(function (root, factory) {
    if (typeof define === 'function' && define.amd) {
        // AMD. Register as an anonymous module.
        define(function () {
            return (root.cv = factory());
        });
    } else if (typeof module === 'object' && module.exports) {
        // Node. Does not work with strict CommonJS, but
        // only CommonJS-like environments that support module.exports,
        // like Node.
        module.exports = factory();
    } else {
        // Browser globals
        root.cv = factory();
    }
}(this, function () {
    var Module = Module || {};
    var cv = function(cv) {
  cv = cv || {};
  var Module = cv;

var Module;if(!Module)Module=(typeof cv!=="undefined"?cv:null)||{};var moduleOverrides={};for(var key in Module){if(Module.hasOwnProperty(key)){moduleOverrides[key]=Module[key]}}var ENVIRONMENT_IS_WEB=false;var ENVIRONMENT_IS_WORKER=false;var ENVIRONMENT_IS_NODE=false;var ENVIRONMENT_IS_SHELL=false;if(Module["ENVIRONMENT"]){if(Module["ENVIRONMENT"]==="WEB"){ENVIRONMENT_IS_WEB=true}else if(Module["ENVIRONMENT"]==="WORKER"){ENVIRONMENT_IS_WORKER=true}else if(Module["ENVIRONMENT"]==="NODE"){ENVIRONMENT_IS_NODE=true}else if(Module["ENVIRONMENT"]==="SHELL"){ENVIRONMENT_IS_SHELL=true}else{throw new Error("The provided Module['ENVIRONMENT'] value is not valid. It must be one of: WEB|WORKER|NODE|SHELL.")}}else{ENVIRONMENT_IS_WEB=typeof window==="object";ENVIRONMENT_IS_WORKER=typeof importScripts==="function";ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof require==="function"&&!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_WORKER;ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER}if(ENVIRONMENT_IS_NODE){if(!Module["print"])Module["print"]=console.log;if(!Module["printErr"])Module["printErr"]=console.warn;var nodeFS;var nodePath;Module["read"]=function read(filename,binary){if(!nodeFS)nodeFS=require("fs");if(!nodePath)nodePath=require("path");filename=nodePath["normalize"](filename);var ret=nodeFS["readFileSync"](filename);return binary?ret:ret.toString()};Module["readBinary"]=function readBinary(filename){var ret=Module["read"](filename,true);if(!ret.buffer){ret=new Uint8Array(ret)}assert(ret.buffer);return ret};Module["load"]=function load(f){globalEval(read(f))};if(!Module["thisProgram"]){if(process["argv"].length>1){Module["thisProgram"]=process["argv"][1].replace(/\\/g,"/")}else{Module["thisProgram"]="unknown-program"}}Module["arguments"]=process["argv"].slice(2);if(typeof module!=="undefined"){module["exports"]=Module}process["on"]("uncaughtException",(function(ex){if(!(ex instanceof ExitStatus)){throw ex}}));Module["inspect"]=(function(){return"[Emscripten Module object]"})}else if(ENVIRONMENT_IS_SHELL){if(!Module["print"])Module["print"]=print;if(typeof printErr!="undefined")Module["printErr"]=printErr;if(typeof read!="undefined"){Module["read"]=read}else{Module["read"]=function read(){throw"no read() available"}}Module["readBinary"]=function readBinary(f){if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}var data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){Module["arguments"]=scriptArgs}else if(typeof arguments!="undefined"){Module["arguments"]=arguments}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){Module["read"]=function read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};Module["readAsync"]=function readAsync(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=function xhr_onload(){if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response)}else{onerror()}};xhr.onerror=onerror;xhr.send(null)};if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof console!=="undefined"){if(!Module["print"])Module["print"]=function print(x){console.log(x)};if(!Module["printErr"])Module["printErr"]=function printErr(x){console.warn(x)}}else{var TRY_USE_DUMP=false;if(!Module["print"])Module["print"]=TRY_USE_DUMP&&typeof dump!=="undefined"?(function(x){dump(x)}):(function(x){})}if(ENVIRONMENT_IS_WORKER){Module["load"]=importScripts}if(typeof Module["setWindowTitle"]==="undefined"){Module["setWindowTitle"]=(function(title){document.title=title})}}else{throw"Unknown runtime environment. Where are we?"}function globalEval(x){eval.call(null,x)}if(!Module["load"]&&Module["read"]){Module["load"]=function load(f){globalEval(Module["read"](f))}}if(!Module["print"]){Module["print"]=(function(){})}if(!Module["printErr"]){Module["printErr"]=Module["print"]}if(!Module["arguments"]){Module["arguments"]=[]}if(!Module["thisProgram"]){Module["thisProgram"]="./this.program"}Module.print=Module["print"];Module.printErr=Module["printErr"];Module["preRun"]=[];Module["postRun"]=[];for(var key in moduleOverrides){if(moduleOverrides.hasOwnProperty(key)){Module[key]=moduleOverrides[key]}}moduleOverrides=undefined;var Runtime={setTempRet0:(function(value){tempRet0=value}),getTempRet0:(function(){return tempRet0}),stackSave:(function(){return STACKTOP}),stackRestore:(function(stackTop){STACKTOP=stackTop}),getNativeTypeSize:(function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:{if(type[type.length-1]==="*"){return Runtime.QUANTUM_SIZE}else if(type[0]==="i"){var bits=parseInt(type.substr(1));assert(bits%8===0);return bits/8}else{return 0}}}}),getNativeFieldSize:(function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)}),STACK_ALIGN:16,prepVararg:(function(ptr,type){if(type==="double"||type==="i64"){if(ptr&7){assert((ptr&7)===4);ptr+=4}}else{assert((ptr&3)===0)}return ptr}),getAlignSize:(function(type,size,vararg){if(!vararg&&(type=="i64"||type=="double"))return 8;if(!type)return Math.min(size,8);return Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE)}),dynCall:(function(sig,ptr,args){if(args&&args.length){return Module["dynCall_"+sig].apply(null,[ptr].concat(args))}else{return Module["dynCall_"+sig].call(null,ptr)}}),functionPointers:[],addFunction:(function(func){for(var i=0;i<Runtime.functionPointers.length;i++){if(!Runtime.functionPointers[i]){Runtime.functionPointers[i]=func;return 2*(1+i)}}throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."}),removeFunction:(function(index){Runtime.functionPointers[(index-2)/2]=null}),warnOnce:(function(text){if(!Runtime.warnOnce.shown)Runtime.warnOnce.shown={};if(!Runtime.warnOnce.shown[text]){Runtime.warnOnce.shown[text]=1;Module.printErr(text)}}),funcWrappers:{},getFuncWrapper:(function(func,sig){assert(sig);if(!Runtime.funcWrappers[sig]){Runtime.funcWrappers[sig]={}}var sigCache=Runtime.funcWrappers[sig];if(!sigCache[func]){if(sig.length===1){sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func)}}else if(sig.length===2){sigCache[func]=function dynCall_wrapper(arg){return Runtime.dynCall(sig,func,[arg])}}else{sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func,Array.prototype.slice.call(arguments))}}}return sigCache[func]}),getCompilerSetting:(function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"}),stackAlloc:(function(size){var ret=STACKTOP;STACKTOP=STACKTOP+size|0;STACKTOP=STACKTOP+15&-16;return ret}),staticAlloc:(function(size){var ret=STATICTOP;STATICTOP=STATICTOP+size|0;STATICTOP=STATICTOP+15&-16;return ret}),dynamicAlloc:(function(size){var ret=HEAP32[DYNAMICTOP_PTR>>2];var end=(ret+size+15|0)&-16;HEAP32[DYNAMICTOP_PTR>>2]=end;if(end>=TOTAL_MEMORY){var success=enlargeMemory();if(!success){HEAP32[DYNAMICTOP_PTR>>2]=ret;return 0}}return ret}),alignMemory:(function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret}),makeBigInt:(function(low,high,unsigned){var ret=unsigned?+(low>>>0)+ +(high>>>0)*+4294967296:+(low>>>0)+ +(high|0)*+4294967296;return ret}),GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module["Runtime"]=Runtime;var ABORT=0;var EXITSTATUS=0;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}function getCFunc(ident){var func=Module["_"+ident];if(!func){try{func=eval("_"+ident)}catch(e){}}assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)");return func}var cwrap,ccall;((function(){var JSfuncs={"stackSave":(function(){Runtime.stackSave()}),"stackRestore":(function(){Runtime.stackRestore()}),"arrayToC":(function(arr){var ret=Runtime.stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}),"stringToC":(function(str){var ret=0;if(str!==null&&str!==undefined&&str!==0){var len=(str.length<<2)+1;ret=Runtime.stackAlloc(len);stringToUTF8(str,ret,len)}return ret})};var toC={"string":JSfuncs["stringToC"],"array":JSfuncs["arrayToC"]};ccall=function ccallFunc(ident,returnType,argTypes,args,opts){var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=Runtime.stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);if(returnType==="string")ret=Pointer_stringify(ret);if(stack!==0){if(opts&&opts.async){EmterpreterAsync.asyncFinalizers.push((function(){Runtime.stackRestore(stack)}));return}Runtime.stackRestore(stack)}return ret};var sourceRegex=/^function\s*[a-zA-Z$_0-9]*\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;function parseJSFunc(jsfunc){var parsed=jsfunc.toString().match(sourceRegex).slice(1);return{arguments:parsed[0],body:parsed[1],returnValue:parsed[2]}}var JSsource=null;function ensureJSsource(){if(!JSsource){JSsource={};for(var fun in JSfuncs){if(JSfuncs.hasOwnProperty(fun)){JSsource[fun]=parseJSFunc(JSfuncs[fun])}}}}cwrap=function cwrap(ident,returnType,argTypes){argTypes=argTypes||[];var cfunc=getCFunc(ident);var numericArgs=argTypes.every((function(type){return type==="number"}));var numericRet=returnType!=="string";if(numericRet&&numericArgs){return cfunc}var argNames=argTypes.map((function(x,i){return"$"+i}));var funcstr="(function("+argNames.join(",")+") {";var nargs=argTypes.length;if(!numericArgs){ensureJSsource();funcstr+="var stack = "+JSsource["stackSave"].body+";";for(var i=0;i<nargs;i++){var arg=argNames[i],type=argTypes[i];if(type==="number")continue;var convertCode=JSsource[type+"ToC"];funcstr+="var "+convertCode.arguments+" = "+arg+";";funcstr+=convertCode.body+";";funcstr+=arg+"=("+convertCode.returnValue+");"}}var cfuncname=parseJSFunc((function(){return cfunc})).returnValue;funcstr+="var ret = "+cfuncname+"("+argNames.join(",")+");";if(!numericRet){var strgfy=parseJSFunc((function(){return Pointer_stringify})).returnValue;funcstr+="ret = "+strgfy+"(ret);"}if(!numericArgs){ensureJSsource();funcstr+=JSsource["stackRestore"].body.replace("()","(stack)")+";"}funcstr+="return ret})";return eval(funcstr)}}))();Module["ccall"]=ccall;Module["cwrap"]=cwrap;function setValue(ptr,value,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=+1?tempDouble>+0?(Math_min(+Math_floor(tempDouble/+4294967296),+4294967295)|0)>>>0:~~+Math_ceil((tempDouble- +(~~tempDouble>>>0))/+4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}Module["setValue"]=setValue;function getValue(ptr,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}Module["getValue"]=getValue;var ALLOC_NORMAL=0;var ALLOC_STACK=1;var ALLOC_STATIC=2;var ALLOC_DYNAMIC=3;var ALLOC_NONE=4;Module["ALLOC_NORMAL"]=ALLOC_NORMAL;Module["ALLOC_STACK"]=ALLOC_STACK;Module["ALLOC_STATIC"]=ALLOC_STATIC;Module["ALLOC_DYNAMIC"]=ALLOC_DYNAMIC;Module["ALLOC_NONE"]=ALLOC_NONE;function allocate(slab,types,allocator,ptr){var zeroinit,size;if(typeof slab==="number"){zeroinit=true;size=slab}else{zeroinit=false;size=slab.length}var singleType=typeof types==="string"?types:null;var ret;if(allocator==ALLOC_NONE){ret=ptr}else{ret=[typeof _malloc==="function"?_malloc:Runtime.staticAlloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][allocator===undefined?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length))}if(zeroinit){var ptr=ret,stop;assert((ret&3)==0);stop=ret+(size&~3);for(;ptr<stop;ptr+=4){HEAP32[ptr>>2]=0}stop=ret+size;while(ptr<stop){HEAP8[ptr++>>0]=0}return ret}if(singleType==="i8"){if(slab.subarray||slab.slice){HEAPU8.set(slab,ret)}else{HEAPU8.set(new Uint8Array(slab),ret)}return ret}var i=0,type,typeSize,previousType;while(i<size){var curr=slab[i];if(typeof curr==="function"){curr=Runtime.getFunctionIndex(curr)}type=singleType||types[i];if(type===0){i++;continue}if(type=="i64")type="i32";setValue(ret+i,curr,type);if(previousType!==type){typeSize=Runtime.getNativeTypeSize(type);previousType=type}i+=typeSize}return ret}Module["allocate"]=allocate;function getMemory(size){if(!staticSealed)return Runtime.staticAlloc(size);if(!runtimeInitialized)return Runtime.dynamicAlloc(size);return _malloc(size)}Module["getMemory"]=getMemory;function Pointer_stringify(ptr,length){if(length===0||!ptr)return"";var hasUtf=0;var t;var i=0;while(1){t=HEAPU8[ptr+i>>0];hasUtf|=t;if(t==0&&!length)break;i++;if(length&&i==length)break}if(!length)length=i;var ret="";if(hasUtf<128){var MAX_CHUNK=1024;var curr;while(length>0){curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK)));ret=ret?ret+curr:curr;ptr+=MAX_CHUNK;length-=MAX_CHUNK}return ret}return Module["UTF8ToString"](ptr)}Module["Pointer_stringify"]=Pointer_stringify;function AsciiToString(ptr){var str="";while(1){var ch=HEAP8[ptr++>>0];if(!ch)return str;str+=String.fromCharCode(ch)}}Module["AsciiToString"]=AsciiToString;function stringToAscii(str,outPtr){return writeAsciiToMemory(str,outPtr,false)}Module["stringToAscii"]=stringToAscii;var UTF8Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf8"):undefined;function UTF8ArrayToString(u8Array,idx){var endPtr=idx;while(u8Array[endPtr])++endPtr;if(endPtr-idx>16&&u8Array.subarray&&UTF8Decoder){return UTF8Decoder.decode(u8Array.subarray(idx,endPtr))}else{var u0,u1,u2,u3,u4,u5;var str="";while(1){u0=u8Array[idx++];if(!u0)return str;if(!(u0&128)){str+=String.fromCharCode(u0);continue}u1=u8Array[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}u2=u8Array[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u3=u8Array[idx++]&63;if((u0&248)==240){u0=(u0&7)<<18|u1<<12|u2<<6|u3}else{u4=u8Array[idx++]&63;if((u0&252)==248){u0=(u0&3)<<24|u1<<18|u2<<12|u3<<6|u4}else{u5=u8Array[idx++]&63;u0=(u0&1)<<30|u1<<24|u2<<18|u3<<12|u4<<6|u5}}}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}}Module["UTF8ArrayToString"]=UTF8ArrayToString;function UTF8ToString(ptr){return UTF8ArrayToString(HEAPU8,ptr)}Module["UTF8ToString"]=UTF8ToString;function stringToUTF8Array(str,outU8Array,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){if(outIdx>=endIdx)break;outU8Array[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;outU8Array[outIdx++]=192|u>>6;outU8Array[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;outU8Array[outIdx++]=224|u>>12;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=2097151){if(outIdx+3>=endIdx)break;outU8Array[outIdx++]=240|u>>18;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=67108863){if(outIdx+4>=endIdx)break;outU8Array[outIdx++]=248|u>>24;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else{if(outIdx+5>=endIdx)break;outU8Array[outIdx++]=252|u>>30;outU8Array[outIdx++]=128|u>>24&63;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}}outU8Array[outIdx]=0;return outIdx-startIdx}Module["stringToUTF8Array"]=stringToUTF8Array;function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}Module["stringToUTF8"]=stringToUTF8;function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){++len}else if(u<=2047){len+=2}else if(u<=65535){len+=3}else if(u<=2097151){len+=4}else if(u<=67108863){len+=5}else{len+=6}}return len}Module["lengthBytesUTF8"]=lengthBytesUTF8;var UTF16Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf-16le"):undefined;function demangle(func){var hasLibcxxabi=!!Module["___cxa_demangle"];if(hasLibcxxabi){try{var s=func.substr(1);var len=lengthBytesUTF8(s)+1;var buf=_malloc(len);stringToUTF8(s,buf,len);var status=_malloc(4);var ret=Module["___cxa_demangle"](buf,0,0,status);if(getValue(status,"i32")===0&&ret){return Pointer_stringify(ret)}}catch(e){}finally{if(buf)_free(buf);if(status)_free(status);if(ret)_free(ret)}return func}Runtime.warnOnce("warning: build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");return func}function demangleAll(text){return text.replace(/__Z[\w\d_]+/g,(function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"}))}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){var js=jsStackTrace();if(Module["extraStackTrace"])js+="\n"+Module["extraStackTrace"]();return demangleAll(js)}Module["stackTrace"]=stackTrace;function alignMemoryPage(x){if(x%4096>0){x+=4096-x%4096}return x}var HEAP;var buffer;var HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function updateGlobalBuffer(buf){Module["buffer"]=buffer=buf}function updateGlobalBufferViews(){Module["HEAP8"]=HEAP8=new Int8Array(buffer);Module["HEAP16"]=HEAP16=new Int16Array(buffer);Module["HEAP32"]=HEAP32=new Int32Array(buffer);Module["HEAPU8"]=HEAPU8=new Uint8Array(buffer);Module["HEAPU16"]=HEAPU16=new Uint16Array(buffer);Module["HEAPU32"]=HEAPU32=new Uint32Array(buffer);Module["HEAPF32"]=HEAPF32=new Float32Array(buffer);Module["HEAPF64"]=HEAPF64=new Float64Array(buffer)}var STATIC_BASE,STATICTOP,staticSealed;var STACK_BASE,STACKTOP,STACK_MAX;var DYNAMIC_BASE,DYNAMICTOP_PTR;STATIC_BASE=STATICTOP=STACK_BASE=STACKTOP=STACK_MAX=DYNAMIC_BASE=DYNAMICTOP_PTR=0;staticSealed=false;function abortOnCannotGrowMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value "+TOTAL_MEMORY+", (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which adjusts the size at runtime but prevents some optimizations, (3) set Module.TOTAL_MEMORY to a higher value before the program runs, or if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ")}if(!Module["reallocBuffer"])Module["reallocBuffer"]=(function(size){var ret;try{if(ArrayBuffer.transfer){ret=ArrayBuffer.transfer(buffer,size)}else{var oldHEAP8=HEAP8;ret=new ArrayBuffer(size);var temp=new Int8Array(ret);temp.set(oldHEAP8)}}catch(e){return false}var success=_emscripten_replace_memory(ret);if(!success)return false;return ret});function enlargeMemory(){var LIMIT=Math.pow(2,31);if(HEAP32[DYNAMICTOP_PTR>>2]>=LIMIT)return false;while(TOTAL_MEMORY<HEAP32[DYNAMICTOP_PTR>>2]){if(TOTAL_MEMORY<LIMIT/2){TOTAL_MEMORY=alignMemoryPage(2*TOTAL_MEMORY)}else{var last=TOTAL_MEMORY;TOTAL_MEMORY=alignMemoryPage((3*TOTAL_MEMORY+LIMIT)/4);if(TOTAL_MEMORY<=last)return false}}TOTAL_MEMORY=Math.max(TOTAL_MEMORY,16*1024*1024);if(TOTAL_MEMORY>=LIMIT)return false;var replacement=Module["reallocBuffer"](TOTAL_MEMORY);if(!replacement)return false;updateGlobalBuffer(replacement);updateGlobalBufferViews();return true}var byteLength;try{byteLength=Function.prototype.call.bind(Object.getOwnPropertyDescriptor(ArrayBuffer.prototype,"byteLength").get);byteLength(new ArrayBuffer(4))}catch(e){byteLength=(function(buffer){return buffer.byteLength})}var TOTAL_STACK=Module["TOTAL_STACK"]||5242880;var TOTAL_MEMORY=Module["TOTAL_MEMORY"]||134217728;var WASM_PAGE_SIZE=64*1024;var totalMemory=WASM_PAGE_SIZE;while(totalMemory<TOTAL_MEMORY||totalMemory<2*TOTAL_STACK){if(totalMemory<16*1024*1024){totalMemory*=2}else{totalMemory+=16*1024*1024}}totalMemory=Math.max(totalMemory,16*1024*1024);if(totalMemory!==TOTAL_MEMORY){TOTAL_MEMORY=totalMemory}if(Module["buffer"]){buffer=Module["buffer"]}else{{buffer=new ArrayBuffer(TOTAL_MEMORY)}}updateGlobalBufferViews();function getTotalMemory(){return TOTAL_MEMORY}HEAP32[0]=1668509029;HEAP16[1]=25459;if(HEAPU8[2]!==115||HEAPU8[3]!==99)throw"Runtime error: expected the system to be little-endian!";Module["HEAP"]=HEAP;Module["buffer"]=buffer;Module["HEAP8"]=HEAP8;Module["HEAP16"]=HEAP16;Module["HEAP32"]=HEAP32;Module["HEAPU8"]=HEAPU8;Module["HEAPU16"]=HEAPU16;Module["HEAPU32"]=HEAPU32;Module["HEAPF32"]=HEAPF32;Module["HEAPF64"]=HEAPF64;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback();continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){Runtime.dynCall("v",func)}else{Runtime.dynCall("vi",func,[callback.arg])}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATEXIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){if(runtimeInitialized)return;runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__);runtimeExited=true}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}Module["addOnPreRun"]=addOnPreRun;function addOnInit(cb){__ATINIT__.unshift(cb)}Module["addOnInit"]=addOnInit;function addOnPreMain(cb){__ATMAIN__.unshift(cb)}Module["addOnPreMain"]=addOnPreMain;function addOnExit(cb){__ATEXIT__.unshift(cb)}Module["addOnExit"]=addOnExit;function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}Module["addOnPostRun"]=addOnPostRun;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;function intArrayToString(array){var ret=[];for(var i=0;i<array.length;i++){var chr=array[i];if(chr>255){chr&=255}ret.push(String.fromCharCode(chr))}return ret.join("")}Module["intArrayToString"]=intArrayToString;function writeStringToMemory(string,buffer,dontAddNull){Runtime.warnOnce("writeStringToMemory is deprecated and should not be called! Use stringToUTF8() instead!");var lastChar,end;if(dontAddNull){end=buffer+lengthBytesUTF8(string);lastChar=HEAP8[end]}stringToUTF8(string,buffer,Infinity);if(dontAddNull)HEAP8[end]=lastChar}Module["writeStringToMemory"]=writeStringToMemory;function writeArrayToMemory(array,buffer){HEAP8.set(array,buffer)}Module["writeArrayToMemory"]=writeArrayToMemory;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}Module["writeAsciiToMemory"]=writeAsciiToMemory;if(!Math["imul"]||Math["imul"](4294967295,5)!==-5)Math["imul"]=function imul(a,b){var ah=a>>>16;var al=a&65535;var bh=b>>>16;var bl=b&65535;return al*bl+(ah*bl+al*bh<<16)|0};Math.imul=Math["imul"];if(!Math["clz32"])Math["clz32"]=(function(x){x=x>>>0;for(var i=0;i<32;i++){if(x&1<<31-i)return i}return 32});Math.clz32=Math["clz32"];if(!Math["trunc"])Math["trunc"]=(function(x){return x<0?Math.ceil(x):Math.floor(x)});Math.trunc=Math["trunc"];var Math_abs=Math.abs;var Math_cos=Math.cos;var Math_sin=Math.sin;var Math_tan=Math.tan;var Math_acos=Math.acos;var Math_asin=Math.asin;var Math_atan=Math.atan;var Math_atan2=Math.atan2;var Math_exp=Math.exp;var Math_log=Math.log;var Math_sqrt=Math.sqrt;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_pow=Math.pow;var Math_imul=Math.imul;var Math_fround=Math.fround;var Math_round=Math.round;var Math_min=Math.min;var Math_clz32=Math.clz32;var Math_trunc=Math.trunc;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function getUniqueRunDependency(id){return id}function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}Module["addRunDependency"]=addRunDependency;function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}Module["removeRunDependency"]=removeRunDependency;Module["preloadedImages"]={};Module["preloadedAudios"]={};var ASM_CONSTS=[];STATIC_BASE=8;STATICTOP=STATIC_BASE+1016768;__ATINIT__.push({func:(function(){__GLOBAL__I_000101()})},{func:(function(){__GLOBAL__sub_I_umatrix_cpp()})},{func:(function(){__GLOBAL__sub_I_iostream_cpp()})},{func:(function(){__GLOBAL__sub_I_bind_cpp()})},{func:(function(){__GLOBAL__sub_I_hog_cpp()})},{func:(function(){__GLOBAL__sub_I_haar_cpp()})},{func:(function(){___cxx_global_var_init_38()})},{func:(function(){___cxx_global_var_init_37()})},{func:(function(){___cxx_global_var_init_36()})},{func:(function(){__GLOBAL__sub_I_knearest_cpp()})},{func:(function(){__GLOBAL__sub_I_loadsave_cpp()})},{func:(function(){__GLOBAL__sub_I_imgwarp_cpp()})},{func:(function(){__GLOBAL__sub_I_histogram_cpp()})},{func:(function(){___cxx_global_var_init_1423()})},{func:(function(){__GLOBAL__sub_I_system_cpp()})},{func:(function(){__GLOBAL__sub_I_persistence_cpp()})},{func:(function(){__GLOBAL__sub_I_bindings_cpp()})},{func:(function(){___cxx_global_var_init_1431()})},{func:(function(){___cxx_global_var_init_1430()})},{func:(function(){___cxx_global_var_init_1429()})},{func:(function(){___cxx_global_var_init_1428()})},{func:(function(){___cxx_global_var_init_1427()})},{func:(function(){___cxx_global_var_init_1426()})},{func:(function(){___cxx_global_var_init_1425()})},{func:(function(){___cxx_global_var_init_1424()})});allocate([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,192,11,177,162,10,240,111,63,32,224,31,224,31,224,239,63,136,103,16,107,42,224,127,63,240,7,252,1,127,192,239,63,118,10,129,95,71,220,135,63,18,250,1,170,28,161,239,63,227,3,252,176,168,192,143,63,32,248,129,31,248,129,239,63,116,165,70,67,164,206,147,63,181,219,160,172,16,99,239,63,26,177,213,7,27,185,151,63,113,66,74,158,101,68,239,63,151,145,175,39,192,159,155,63,181,10,35,68,246,37,239,63,0,51,120,14,155,130,159,63,8,31,124,240,193,7,239,63,127,217,35,137,217,176,161,63,2,142,69,248,199,233,238,63,95,189,254,185,135,158,163,63,192,236,1,179,7,204,238,63,212,228,200,175,91,138,165,63,235,1,186,122,128,174,238,63,252,220,50,246,88,116,167,63,103,183,240,171,49,145,238,63,235,227,200,14,131,92,169,63,228,80,151,165,26,116,238,63,190,113,25,113,221,66,171,63,116,229,1,201,58,87,238,63,82,11,219,138,107,39,173,63,115,26,220,121,145,58,238,63,166,98,17,192,48,10,175,63,30,30,30,30,30,30,238,63,113,228,152,53,152,117,176,63,30,224,1,30,224,1,238,63,224,122,163,238,54,101,177,63,138,134,248,227,214,229,237,63,22,20,10,47,246,83,178,63,202,29,160,220,1,202,237,63,208,209,27,150,215,65,179,63,219,129,185,118,96,174,237,63,240,70,166,190,220,46,180,63,138,127,30,35,242,146,237,63,63,24,6,63,7,27,181,63,52,44,184,84,182,119,237,63,195,80,55,169,88,6,182,63,178,114,117,128,172,92,237,63,75,107,229,138,210,240,182,63,29,212,65,29,212,65,237,63,204,18,123,109,118,218,183,63,26,91,252,163,44,39,237,63,32,155,49,214,69,195,184,63,116,192,110,143,181,12,237,63,172,51,32,70,66,171,185,63,198,191,68,92,110,242,236,63,99,213,74,58,109,146,186,63,11,155,3,137,86,216,236,63,161,237,176,43,200,120,187,63,231,203,1,150,109,190,236,63,67,199,91,143,84,94,188,63,145,225,94,5,179,164,236,63,93,179,108,214,19,67,189,63,66,138,251,90,38,139,236,63,229,242,42,110,7,39,190,63,28,199,113,28,199,113,236,63,166,98,17,192,48,10,191,63,134,73,13,209,148,88,236,63,186,234,219,49,145,236,191,63,240,248,195,1,143,63,236,63,110,89,202,18,21,103,192,63,28,160,46,57,181,38,236,63,89,142,208,124,126,215,192,63,224,192,129,3,7,14,236,63,172,66,103,132,133,71,193,63,139,141,134,238,131,245,235,63,160,103,47,213,42,183,193,63,247,6,148,137,43,221,235,63,203,90,10,25,111,38,194,63,123,62,136,101,253,196,235,63,35,245,31,248,82,149,194,63,208,186,193,20,249,172,235,63,210,127,228,24,215,3,195,63,35,255,24,43,30,149,235,63,116,143,30,32,252,113,195,63,139,51,218,61,108,125,235,63,41,198,236,176,194,223,195,63,5,238,190,227,226,101,235,63,30,125,203,108,43,77,196,63,79,27,232,180,129,78,235,63,229,85,154,243,54,186,196,63,206,6,216,74,72,55,235,63,55,180,161,227,229,38,197,63,217,128,108,64,54,32,235,63,133,32,152,217,56,147,197,63,164,34,217,49,75,9,235,63,211,147,167,112,48,255,197,63,40,175,161,188,134,242,234,63,80,173,114,66,205,106,198,63,94,144,148,127,232,219,234,63,28,210,25,231,15,214,198,63,27,112,197,26,112,197,234,63,164,55,64,245,248,64,199,63,253,235,135,47,29,175,234,63,9,217,16,2,137,171,199,63,190,99,106,96,239,152,234,63,234,87,67,161,192,21,200,63,89,225,48,81,230,130,234,63,16,201,32,101,160,127,200,63,109,26,208,166,1,109,234,63,64,109,136,222,40,233,200,63,74,138,104,7,65,87,234,63,180,86,244,156,90,82,201,63,26,164,65,26,164,65,234,63,131,251,125,46,54,187,201,63,160,28,197,135,42,44,234,63,99,181,226,31,188,35,202,63,2,75,122,249,211,22,234,63,24,47,136,252,236,139,202,63,26,160,1,26,160,1,234,63,242,191,128,78,201,243,202,63,217,51,16,149,142,236,233,63,164,181,143,158,81,91,203,63,45,104,107,23,159,215,233,63,214,140,45,116,134,194,203,63,2,161,228,78,209,194,233,63,192,24,140,85,104,41,204,63,218,16,85,234,36,174,233,63,33,154,154,199,247,143,204,63,154,153,153,153,153,153,233,63,220,197,9,78,53,246,204,63,255,192,142,13,47,133,233,63,145,187,79,107,33,92,205,63,114,184,12,248,228,112,233,63,125,236,171,160,188,193,205,63,174,119,227,11,187,92,233,63,229,242,42,110,7,39,206,63,224,233,214,252,176,72,233,63,95,90,170,82,2,140,206,63,230,44,155,127,198,52,233,63,54,89,220,203,173,240,206,63,41,226,208,73,251,32,233,63,55,123,75,86,10,85,207,63,213,144,1,18,79,13,233,63,42,62,94,109,24,185,207,63,250,24,156,143,193,249,232,63,28,80,173,69,108,14,208,63,63,55,241,122,82,230,232,63,64,208,180,148,37,64,208,63,211,24,48,141,1,211,232,63,13,89,205,95,184,113,208,63,58,255,98,128,206,191,232,63,227,144,115,226,36,163,208,63,170,243,107,15,185,172,232,63,75,183,154,87,107,212,208,63,156,137,1,246,192,153,232,63,213,74,174,249,139,5,209,63,74,176,171,240,229,134,232,63,176,168,147,2,135,54,209,63,185,146,192,188,39,116,232,63,14,166,171,171,92,103,209,63,24,134,97,24,134,97,232,63,111,35,212,45,13,152,209,63,20,6,120,194,0,79,232,63,250,153,105,193,152,200,209,63,221,190,178,122,151,60,232,63,242,162,72,158,255,248,209,63,160,164,130,1,74,42,232,63,101,121,207,251,65,41,210,63,24,24,24,24,24,24,232,63,57,118,223,16,96,89,210,63,6,24,96,128,1,6,232,63,163,134,222,19,90,137,210,63,64,127,1,253,5,244,231,63,36,157,184,58,48,185,210,63,29,79,90,81,37,226,231,63,48,29,225,186,226,232,210,63,244,5,125,65,95,208,231,63,132,65,84,201,113,24,211,63,124,1,46,146,179,190,231,63,84,125,152,154,221,71,211,63,195,236,224,8,34,173,231,63,90,216,191,98,38,119,211,63,139,57,182,107,170,155,231,63,233,69,105,85,76,166,211,63,200,164,120,129,76,138,231,63,15,247,193,165,79,213,211,63,13,198,154,17,8,121,231,63,227,167,134,134,48,4,212,63,177,169,52,228,220,103,231,63,19,232,4,42,239,50,212,63,109,117,1,194,202,86,231,63,194,94,28,194,139,97,212,63,70,23,93,116,209,69,231,63,208,9,64,128,6,144,212,63,141,254,65,197,240,52,231,63,160,120,119,149,95,190,212,63,188,222,70,127,40,36,231,63,105,2,96,50,151,236,212,63,9,124,156,109,120,19,231,63,45,248,45,135,173,26,213,63,112,129,11,92,224,2,231,63,98,210,173,195,162,72,213,63,23,96,242,22,96,242,230,63,108,90,69,23,119,118,213,63,199,55,67,107,247,225,230,63,225,207,244,176,42,164,213,63,97,200,129,38,166,209,230,63,202,9,88,191,189,209,213,63,23,108,193,22,108,193,230,63,211,147,167,112,48,255,213,63,61,26,163,10,73,177,230,63,149,199,185,242,130,44,214,63,144,114,83,209,60,161,230,63,242,225,3,115,181,89,214,63,192,208,136,58,71,145,230,63,174,20,155,30,200,134,214,63,23,104,129,22,104,129,230,63,61,148,53,34,187,179,214,63,26,103,1,54,159,113,230,63,227,161,43,170,142,224,214,63,249,34,81,106,236,97,230,63,53,146,120,226,66,13,215,63,163,74,59,133,79,82,230,63,6,208,187,246,215,57,215,63,100,33,11,89,200,66,230,63,206,219,57,18,78,102,215,63,222,192,138,184,86,51,230,63,162,71,221,95,165,146,215,63,64,98,1,119,250,35,230,63,191,175,55,10,222,190,215,63,148,174,49,104,179,20,230,63,195,175,130,59,248,234,215,63,6,22,88,96,129,5,230,63,149,212,160,29,244,22,216,63,252,45,41,52,100,246,229,63,23,139,30,218,209,66,216,63,231,21,208,184,91,231,229,63,160,11,51,154,145,110,216,63,165,226,236,195,103,216,229,63,90,66,193,134,51,154,216,63,87,16,147,43,136,201,229,63,138,180,88,200,183,197,216,63,145,250,71,198,188,186,229,63,199,98,54,135,30,241,216,63,192,90,1,107,5,172,229,63,61,168,69,235,103,28,217,63,170,204,35,241,97,157,229,63,250,22,33,28,148,71,217,63,237,88,129,48,210,142,229,63,88,81,19,65,163,114,217,63,96,5,88,1,86,128,229,63,138,224,23,129,149,157,217,63,58,107,80,60,237,113,229,63,98,8,220,2,107,200,217,63,226,82,124,186,151,99,229,63,75,152,191,236,35,243,217,63,85,85,85,85,85,85,229,63,149,185,213,100,192,29,218,63,254,130,187,230,37,71,229,63,10,187,229,144,64,72,218,63,235,15,244,72,9,57,229,63,234,217,107,150,164,114,218,63,75,5,168,86,255,42,229,63,73,8,154,154,236,156,218,63,21,248,226,234,7,29,229,63,228,176,88,194,24,199,218,63,197,196,17,225,34,15,229,63,107,120,71,50,41,241,218,63,21,80,1,21,80,1,229,63,91,252,189,14,30,27,219,63,155,76,221,98,143,243,228,63,98,143,204,123,247,68,219,63,57,5,47,167,224,229,228,63,93,243,60,157,181,110,219,63,76,44,220,190,67,216,228,63,251,16,147,150,88,152,219,63,110,175,37,135,184,202,228,63,10,173,13,139,224,193,219,63,225,143,166,221,62,189,228,63,123,27,167,157,77,235,219,63,91,191,82,160,214,175,228,63,38,240,21,241,159,20,220,63,74,1,118,173,127,162,228,63,77,173,205,167,215,61,220,63,103,208,178,227,57,149,228,63,247,111,255,227,244,102,220,63,128,72,1,34,5,136,228,63,33,154,154,199,247,143,220,63,123,20,174,71,225,122,228,63,201,122,77,116,224,184,220,63,102,96,89,52,206,109,228,63,235,243,133,11,175,225,220,63,154,207,245,199,203,96,228,63,100,30,114,174,99,10,221,63,202,118,199,226,217,83,228,63,213,235,0,126,254,50,221,63,251,217,98,101,248,70,228,63,131,198,226,154,127,91,221,63,77,238,171,48,39,58,228,63,62,47,138,37,231,131,221,63,135,31,213,37,102,45,228,63,84,89,44,62,53,172,221,63,81,89,94,38,181,32,228,63,160,196,193,4,106,212,221,63,20,20,20,20,20,20,228,63,181,213,6,153,133,252,221,63,102,101,14,209,130,7,228,63,38,108,124,26,136,36,222,63,251,19,176,63,1,251,227,63,4,119,104,168,113,76,222,63,7,175,165,66,143,238,227,63,135,135,214,97,66,116,222,63,2,169,228,188,44,226,227,63,245,97,152,101,250,155,222,63,198,117,170,145,217,213,227,63,192,140,70,210,153,195,222,63,231,171,123,164,149,201,227,63,244,221,64,198,32,235,222,63,85,41,35,217,96,189,227,63,236,6,175,95,143,18,223,63,20,59,177,19,59,177,227,63,91,30,129,188,229,57,223,63,34,200,122,56,36,165,227,63,172,40,112,250,35,97,223,63,99,127,24,44,28,153,227,63,194,158,254,54,74,136,223,63,142,8,102,211,34,141,227,63,30,243,120,143,88,175,223,63,20,56,129,19,56,129,227,63,113,21,246,32,79,214,223,63,238,69,201,209,91,117,227,63,152,244,87,8,46,253,223,63,72,7,222,243,141,105,227,63,138,255,37,177,250,17,224,63,248,42,159,95,206,93,227,63,254,208,165,165,82,37,224,63,193,120,43,251,28,82,227,63,59,99,206,239,158,56,224,63,70,19,224,172,121,70,227,63,210,38,169,157,223,75,224,63,178,188,87,91,228,58,227,63,156,69,38,189,20,95,224,63,250,29,106,237,92,47,227,63,64,223,28,92,62,114,224,63,191,16,43,74,227,35,227,63,14,69,75,136,92,133,224,63,182,235,233,88,119,24,227,63,32,53,87,79,111,152,224,63,144,209,48,1,25,13,227,63,209,20,206,190,118,171,224,63,96,2,196,42,200,1,227,63,130,42,37,228,114,190,224,63,104,47,161,189,132,246,226,63,183,214,185,204,99,209,224,63,75,209,254,161,78,235,226,63,139,204,209,133,73,228,224,63,151,128,75,192,37,224,226,63,125,73,155,28,36,247,224,63,160,80,45,1,10,213,226,63,150,76,45,158,243,9,225,63,160,44,129,77,251,201,226,63,248,204,135,23,184,28,225,63,17,55,90,142,249,190,226,63,188,239,147,149,113,47,225,63,64,43,1,173,4,180,226,63,68,61,36,37,32,66,225,63,5,193,243,146,28,169,226,63,233,213,244,210,195,84,225,63,158,18,228,41,65,158,226,63,14,166,171,171,92,103,225,63,165,4,184,91,114,147,226,63,160,153,216,187,234,121,225,63,19,176,136,18,176,136,226,63,6,207,245,15,110,140,225,63,77,206,161,56,250,125,226,63,110,201,103,180,230,158,225,63,53,39,129,184,80,115,226,63,158,162,125,181,84,177,225,63,39,1,214,124,179,104,226,63,36,60,113,31,184,195,225,63,241,146,128,112,34,94,226,63,3,112,103,254,16,214,225,63,178,119,145,126,157,83,226,63,208,64,112,94,95,232,225,63,146,36,73,146,36,73,226,63,76,9,135,75,163,250,225,63,91,96,23,151,183,62,226,63,109,171,146,209,220,12,226,63,223,188,154,120,86,52,226,63,235,190,101,252,11,31,226,63,42,18,160,34,1,42,226,63,66,191,190,215,48,49,226,63,120,251,33,129,183,31,226,63,51,57,72,111,75,67,226,63,230,85,72,128,121,21,226,63,203,247,152,206,91,85,226,63,217,192,103,12,71,11,226,63,223,48,52,1,98,103,226,63,18,32,1,18,32,1,226,63,26,177,137,18,94,121,226,63,112,31,193,125,4,247,225,63,130,7,246,13,80,139,226,63,76,184,127,60,244,236,225,63,138,176,194,254,55,157,226,63,116,184,63,59,239,226,225,63,173,64,38,240,21,175,226,63,189,74,46,103,245,216,225,63,139,142,68,237,233,192,226,63,29,129,162,173,6,207,225,63,157,220,46,1,180,210,226,63,89,224,28,252,34,197,225,63,104,2,228,54,116,228,226,63,41,237,70,64,74,187,225,63,70,149,80,153,42,246,226,63,227,186,242,103,124,177,225,63,190,16,79,51,215,7,227,63,150,123,26,97,185,167,225,63,106,254,167,15,122,25,227,63,158,17,224,25,1,158,225,63,113,29,18,57,19,43,227,63,156,162,140,128,83,148,225,63,148,137,50,186,162,60,227,63,219,43,144,131,176,138,225,63,211,225,156,157,40,78,227,63,18,24,129,17,24,129,225,63,160,110,211,237,164,95,227,63,132,214,27,25,138,119,225,63,181,71,71,181,23,113,227,63,121,115,66,137,6,110,225,63,126,121,88,254,128,130,227,63,1,50,252,80,141,100,225,63,25,42,86,211,224,147,227,63,13,39,117,95,30,91,225,63,249,189,126,62,55,165,227,63,201,213,253,163,185,81,225,63,34,252,255,73,132,182,227,63,59,205,10,14,95,72,225,63,5,50,247,255,199,199,227,63,36,71,52,141,14,63,225,63,250,86,113,106,2,217,227,63,17,200,53,17,200,53,225,63,91,47,107,147,51,234,227,63,172,192,237,137,139,44,225,63,66,111,209,132,91,251,227,63,51,48,93,231,88,35,225,63,233,220,128,72,122,12,228,63,38,72,167,25,48,26,225,63,174,114,70,232,143,29,228,63,17,17,17,17,17,17,225,63,191,128,223,109,156,46,228,63,128,16,1,190,251,7,225,63,103,206,249,226,159,63,228,63,17,240,254,16,240,254,224,63,10,187,51,81,154,80,228,63,162,37,179,250,237,245,224,63,194,94,28,194,139,97,228,63,144,156,230,107,245,236,224,63,173,170,51,63,116,114,228,63,17,96,130,85,6,228,224,63,223,136,234,209,83,131,228,63,150,70,143,168,32,219,224,63,7,252,162,131,42,148,228,63,58,158,53,86,68,210,224,63,187,62,176,93,248,164,228,63,59,218,188,79,113,201,224,63,115,226,86,105,189,181,228,63,113,65,139,134,167,192,224,63,57,238,204,175,121,198,228,63,200,157,37,236,230,183,224,63,0,253,57,58,45,215,228,63,181,236,46,114,47,175,224,63,176,91,183,17,216,231,228,63,167,16,104,10,129,166,224,63,232,38,80,63,122,248,228,63,96,131,175,166,219,157,224,63,107,104,1,204,19,9,229,63,84,9,1,57,63,149,224,63,70,52,186,192,164,25,229,63,226,101,117,179,171,140,224,63,170,197,91,38,45,42,229,63,132,16,66,8,33,132,224,63,124,155,185,5,173,58,229,63,226,234,184,41,159,123,224,63,151,148,153,103,36,75,229,63,198,247,71,10,38,115,224,63,205,11,180,84,147,91,229,63,251,18,121,156,181,106,224,63,153,243,179,213,249,107,229,63,252,169,241,210,77,98,224,63,144,241,54,243,87,124,229,63,134,117,114,160,238,89,224,63,137,121,205,181,173,140,229,63,4,52,215,247,151,81,224,63,125,232,250,37,251,156,229,63,197,100,22,204,73,73,224,63,44,159,53,76,64,173,229,63,16,4,65,16,4,65,224,63,115,28,231,48,125,189,229,63,252,71,130,183,198,56,224,63,100,23,108,220,177,205,229,63,26,94,31,181,145,48,224,63,35,153,20,87,222,221,229,63,233,41,119,252,100,40,224,63,117,22,36,169,2,238,229,63,8,4,2,129,64,32,224,63,24,137,209,218,30,254,229,63,55,122,81,54,36,24,224,63,216,136,71,244,50,14,230,63,16,16,16,16,16,16,224,63,239,57,250,254,66,46,230,63,0,0,0,0,0,0,224,63,196,162,2,0,23,242,2,0,196,162,2,0,52,242,2,0,196,162,2,0,76,242,2,0,196,162,2,0,101,242,2,0,196,162,2,0,123,242,2,0,196,162,2,0,142,242,2,0,196,162,2,0,167,242,2,0,196,162,2,0,193,242,2,0,196,162,2,0,231,242,2,0,196,162,2,0,12,243,2,0,196,162,2,0,36,243,2,0,196,162,2,0,57,243,2,0,196,162,2,0,75,243,2,0,196,162,2,0,97,243,2,0,196,162,2,0,118,243,2,0,196,162,2,0,152,243,2,0,196,162,2,0,181,243,2,0,196,162,2,0,219,243,2,0,196,162,2,0,241,243,2,0,196,162,2,0,7,244,2,0,196,162,2,0,29,244,2,0,196,162,2,0,54,244,2,0,196,162,2,0,80,244,2,0,196,162,2,0,96,244,2,0,196,162,2,0,112,244,2,0,196,162,2,0,134,244,2,0,196,162,2,0,153,244,2,0,196,162,2,0,185,244,2,0,196,162,2,0,201,244,2,0,196,162,2,0,219,244,2,0,196,162,2,0,238,244,2,0,196,162,2,0,1,245,2,0,196,162,2,0,17,245,2,0,196,162,2,0,49,245,2,0,196,162,2,0,68,245,2,0,196,162,2,0,94,245,2,0,196,162,2,0,120,245,2,0,196,162,2,0,143,245,2,0,196,162,2,0,163,245,2,0,196,162,2,0,182,245,2,0,196,162,2,0,200,245,2,0,196,162,2,0,223,245,2,0,196,162,2,0,243,245,2,0,196,162,2,0,7,246,2,0,196,162,2,0,29,246,2,0,196,162,2,0,51,246,2,0,196,162,2,0,72,246,2,0,196,162,2,0,102,246,2,0,196,162,2,0,137,246,2,0,196,162,2,0,155,246,2,0,196,162,2,0,188,246,2,0,196,162,2,0,220,246,2,0,196,162,2,0,241,246,2,0,196,162,2,0,13,247,2,0,40,162,2,0,43,247,2,0,80,162,2,0,75,247,2,0,104,75,0,0,0,0,0,0,40,162,2,0,65,247,2,0,40,162,2,0,87,247,2,0,168,162,2,0,107,247,2,0,1,0,0,0,200,17,0,0,80,162,2,0,121,247,2,0,8,18,0,0,0,0,0,0,40,162,2,0,138,247,2,0,224,162,2,0,169,247,2,0,0,0,0,0,1,0,0,0,40,18,0,0,0,0,0,0,224,162,2,0,215,247,2,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,40,162,2,0,13,248,2,0,168,162,2,0,61,248,2,0,0,0,0,0,200,17,0,0,40,162,2,0,74,248,2,0,80,162,2,0,94,248,2,0,240,81,0,0,0,0,0,0,168,162,2,0,104,248,2,0,1,0,0,0,96,18,0,0,168,162,2,0,128,248,2,0,0,0,0,0,96,18,0,0,168,162,2,0,139,248,2,0,1,0,0,0,112,81,0,0,168,162,2,0,159,248,2,0,0,0,0,0,112,81,0,0,40,162,2,0,178,248,2,0,168,162,2,0,222,248,2,0,1,0,0,0,200,18,0,0,80,162,2,0,2,249,2,0,216,18,0,0,0,0,0,0,80,162,2,0,36,249,2,0,176,40,0,0,0,0,0,0,168,162,2,0,66,249,2,0,0,0,0,0,200,18,0,0,40,162,2,0,101,249,2,0,168,162,2,0,131,249,2,0,1,0,0,0,16,19,0,0,80,162,2,0,153,249,2,0,32,19,0,0,0,0,0,0,80,162,2,0,173,249,2,0,176,40,0,0,0,0,0,0,168,162,2,0,187,249,2,0,0,0,0,0,16,19,0,0,40,162,2,0,208,249,2,0,168,162,2,0,248,249,2,0,1,0,0,0,88,19,0,0,80,162,2,0,17,250,2,0,32,19,0,0,0,0,0,0,168,162,2,0,40,250,2,0,0,0,0,0,88,19,0,0,40,162,2,0,200,250,2,0,224,162,2,0,90,250,2,0,0,0,0,0,1,0,0,0,160,19,0,0,0,0,0,0,40,162,2,0,75,250,2,0,224,162,2,0,141,250,2,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,168,162,2,0,225,250,2,0,1,0,0,0,120,19,0,0,224,162,2,0,90,251,2,0,0,0,0,0,1,0,0,0,16,20,0,0,0,0,0,0,224,162,2,0,10,251,2,0,0,0,0,0,1,0,0,0,248,19,0,0,0,0,0,0,224,162,2,0,46,251,2,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,224,162,2,0,126,251,2,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,168,162,2,0,183,251,2,0,0,0,0,0,120,19,0,0,40,162,2,0,170,251,2,0,40,162,2,0,221,251,2,0,224,162,2,0,236,251,2,0,0,0,0,0,1,0,0,0,96,20,0,0,0,0,0,0,40,162,2,0,43,252,2,0,168,162,2,0,81,252,2,0,1,0,0,0,120,20,0,0,80,162,2,0,118,252,2,0,136,20,0,0,0,0,0,0,80,162,2,0,153,252,2,0,176,40,0,0,0,0,0,0,168,162,2,0,183,252,2,0,0,0,0,0,120,20,0,0,40,162,2,0,219,252,2,0,168,162,2,0,242,252,2,0,1,0,0,0,192,20,0,0,80,162,2,0,1,253,2,0,104,75,0,0,0,0,0,0,168,162,2,0,21,253,2,0,0,0,0,0,192,20,0,0,40,162,2,0,35,253,2,0,40,162,2,0,71,253,2,0,168,162,2,0,104,253,2,0,1,0,0,0,0,21,0,0,80,162,2,0,132,253,2,0,240,81,0,0,0,0,0,0,168,162,2,0,158,253,2,0,0,0,0,0,0,21,0,0,168,162,2,0,185,253,2,0,1,0,0,0,48,21,0,0,40,162,2,0,201,253,2,0,168,162,2,0,215,253,2,0,0,0,0,0,48,21,0,0,168,162,2,0,230,253,2,0,0,0,0,0,232,20,0,0,168,162,2,0,8,254,2,0,1,0,0,0,232,20,0,0,40,162,2,0,43,254,2,0,80,162,2,0,65,254,2,0,176,40,0,0,0,0,0,0,168,162,2,0,77,254,2,0,1,0,0,0,112,21,0,0,168,162,2,0,91,254,2,0,0,0,0,0,112,21,0,0,40,162,2,0,109,254,2,0,168,162,2,0,146,254,2,0,1,0,0,0,184,21,0,0,80,162,2,0,175,254,2,0,200,21,0,0,0,0,0,0,80,162,2,0,202,254,2,0,176,40,0,0,0,0,0,0,168,162,2,0,226,254,2,0,0,0,0,0,184,21,0,0,40,162,2,0,254,254,2,0,80,162,2,0,39,255,2,0,0,22,0,0,0,0,0,0,80,162,2,0,70,255,2,0,176,40,0,0,0,0,0,0,168,162,2,0,98,255,2,0,1,0,0,0,240,21,0,0,168,162,2,0,131,255,2,0,0,0,0,0,240,21,0,0,40,162,2,0,163,255,2,0,80,162,2,0,80,0,3,0,240,81,0,0,0,0,0,0,224,162,2,0,184,255,2,0,0,0,0,0,1,0,0,0,96,22,0,0,0,0,0,0,224,162,2,0,253,255,2,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,168,162,2,0,103,0,3,0,1,0,0,0,56,22,0,0,168,162,2,0,116,0,3,0,0,0,0,0,56,22,0,0,40,162,2,0,128,0,3,0,168,162,2,0,157,0,3,0,0,0,0,0,24,75,0,0,168,162,2,0,187,0,3,0,1,0,0,0,24,75,0,0,168,162,2,0,214,0,3,0,1,0,0,0,192,80,0,0,168,162,2,0,245,0,3,0,0,0,0,0,192,80,0,0,168,162,2,0,19,1,3,0,0,0,0,0,40,83,0,0,168,162,2,0,36,1,3,0,1,0,0,0,40,83,0,0,40,162,2,0,54,1,3,0,168,162,2,0,93,1,3,0,1,0,0,0,24,23,0,0,80,162,2,0,116,1,3,0,32,19,0,0,0,0,0,0,168,162,2,0,137,1,3,0,0,0,0,0,24,23,0,0,168,162,2,0,166,1,3,0,0,0,0,0,72,23,0,0,40,162,2,0,180,1,3,0,168,162,2,0,193,1,3,0,1,0,0,0,72,23,0,0,40,162,2,0,208,1,3,0,168,162,2,0,243,1,3,0,1,0,0,0,24,83,0,0,224,162,2,0,14,2,3,0,0,0,0,0,1,0,0,0,144,23,0,0,0,0,0,0,224,162,2,0,63,2,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,224,162,2,0,120,2,3,0,0,0,0,0,1,0,0,0,192,23,0,0,0,0,0,0,224,162,2,0,186,2,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,168,162,2,0,20,3,3,0,0,0,0,0,24,83,0,0,40,162,2,0,46,3,3,0,168,162,2,0,76,3,3,0,1,0,0,0,0,24,0,0,80,162,2,0,98,3,3,0,240,81,0,0,0,0,0,0,168,162,2,0,127,3,3,0,0,0,0,0,0,24,0,0,168,162,2,0,148,3,3,0,1,0,0,0,216,18,0,0,168,162,2,0,180,3,3,0,0,0,0,0,216,18,0,0,40,162,2,0,211,3,3,0,80,162,2,0,237,3,3,0,88,24,0,0,0,0,0,0,80,162,2,0,253,3,3,0,104,75,0,0,0,0,0,0,168,162,2,0,13,4,3,0,1,0,0,0,72,24,0,0,168,162,2,0,31,4,3,0,0,0,0,0,72,24,0,0,40,162,2,0,48,4,3,0,80,162,2,0,75,4,3,0,104,75,0,0,0,0,0,0,168,162,2,0,92,4,3,0,1,0,0,0,144,24,0,0,168,162,2,0,118,4,3,0,0,0,0,0,144,24,0,0,80,162,2,0,136,4,3,0,176,40,0,0,0,0,0,0,80,162,2,0,160,4,3,0,224,24,0,0,0,0,0,0,80,162,2,0,177,4,3,0,240,24,0,0,0,0,0,0,40,162,2,0,194,4,3,0,168,162,2,0,216,4,3,0,1,0,0,0,192,24,0,0,168,162,2,0,242,4,3,0,0,0,0,0,192,24,0,0,168,162,2,0,11,5,3,0,0,0,0,0,176,40,0,0,168,162,2,0,28,5,3,0,1,0,0,0,176,40,0,0,80,162,2,0,46,5,3,0,176,40,0,0,0,0,0,0,168,162,2,0,68,5,3,0,1,0,0,0,56,25,0,0,168,162,2,0,92,5,3,0,0,0,0,0,56,25,0,0,168,162,2,0,115,5,3,0,1,0,0,0,136,81,0,0,168,162,2,0,176,5,3,0,0,0,0,0,136,81,0,0,40,162,2,0,150,5,3,0,224,162,2,0,210,5,3,0,0,0,0,0,1,0,0,0,168,25,0,0,0,0,0,0,224,162,2,0,5,6,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,40,162,2,0,64,6,3,0,168,162,2,0,98,6,3,0,1,0,0,0,216,25,0,0,80,162,2,0,124,6,3,0,232,25,0,0,0,0,0,0,80,162,2,0,148,6,3,0,176,40,0,0,0,0,0,0,168,162,2,0,174,6,3,0,0,0,0,0,216,25,0,0,40,162,2,0,199,6,3,0,80,162,2,0,231,6,3,0,32,26,0,0,0,0,0,0,80,162,2,0,253,6,3,0,176,40,0,0,0,0,0,0,168,162,2,0,19,7,3,0,1,0,0,0,16,26,0,0,168,162,2,0,43,7,3,0,0,0,0,0,16,26,0,0,168,162,2,0,66,7,3,0,1,0,0,0,32,26,0,0,168,162,2,0,90,7,3,0,0,0,0,0,32,26,0,0,40,162,2,0,113,7,3,0,80,162,2,0,163,7,3,0,104,75,0,0,0,0,0,0,168,162,2,0,195,7,3,0,1,0,0,0,120,26,0,0,168,162,2,0,229,7,3,0,0,0,0,0,120,26,0,0,80,162,2,0,6,8,3,0,184,26,0,0,0,0,0,0,40,162,2,0,32,8,3,0,168,162,2,0,57,8,3,0,0,0,0,0,0,77,0,0,196,162,2,0,96,8,3,0,168,162,2,0,76,8,3,0,1,0,0,0,0,77,0,0,196,162,2,0,125,8,3,0,40,162,2,0,165,8,3,0,168,162,2,0,184,8,3,0,1,0,0,0,240,81,0,0,168,162,2,0,202,8,3,0,0,0,0,0,240,81,0,0,40,162,2,0,219,8,3,0,80,162,2,0,241,8,3,0,240,81,0,0,0,0,0,0,168,162,2,0,7,9,3,0,1,0,0,0,32,27,0,0,168,162,2,0,21,9,3,0,0,0,0,0,32,27,0,0,168,162,2,0,34,9,3,0,1,0,0,0,232,25,0,0,168,162,2,0,56,9,3,0,0,0,0,0,232,25,0,0,40,162,2,0,77,9,3,0,80,162,2,0,98,9,3,0,240,81,0,0,0,0,0,0,168,162,2,0,109,9,3,0,1,0,0,0,120,27,0,0,168,162,2,0,131,9,3,0,0,0,0,0,120,27,0,0,40,162,2,0,143,9,3,0,80,162,2,0,190,9,3,0,216,18,0,0,0,0,0,0,40,162,2,0,15,10,3,0,40,162,2,0,237,9,3,0,168,162,2,0,55,10,3,0,1,0,0,0,176,27,0,0,168,162,2,0,94,10,3,0,0,0,0,0,176,27,0,0,40,162,2,0,132,10,3,0,168,162,2,0,181,10,3,0,1,0,0,0,8,28,0,0,80,162,2,0,222,10,3,0,192,24,0,0,0,0,0,0,168,162,2,0,9,11,3,0,0,0,0,0,8,28,0,0,168,162,2,0,49,11,3,0,1,0,0,0,56,28,0,0,80,162,2,0,84,11,3,0,136,20,0,0,0,0,0,0,168,162,2,0,117,11,3,0,0,0,0,0,56,28,0,0,168,162,2,0,151,11,3,0,0,0,0,0,104,28,0,0,40,162,2,0,172,11,3,0,168,162,2,0,192,11,3,0,1,0,0,0,104,28,0,0,40,162,2,0,214,11,3,0,224,162,2,0,244,11,3,0,0,0,0,0,1,0,0,0,160,28,0,0,0,0,0,0,224,162,2,0,24,12,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,168,162,2,0,68,12,3,0,1,0,0,0,200,28,0,0,80,162,2,0,82,12,3,0,240,81,0,0,0,0,0,0,168,162,2,0,94,12,3,0,0,0,0,0,200,28,0,0,40,162,2,0,140,12,3,0,40,162,2,0,124,12,3,0,168,162,2,0,107,12,3,0,0,0,0,0,240,28,0,0,224,162,2,0,11,13,3,0,0,0,0,0,1,0,0,0,80,29,0,0,0,0,0,0,224,162,2,0,155,12,3,0,0,0,0,0,1,0,0,0,56,29,0,0,0,0,0,0,224,162,2,0,207,12,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,224,162,2,0,80,13,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,224,162,2,0,163,13,3,0,0,0,0,0,1,0,0,0,128,29,0,0,0,0,0,0,224,162,2,0,216,13,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,224,162,2,0,21,14,3,0,0,0,0,0,1,0,0,0,176,29,0,0,0,0,0,0,224,162,2,0,74,14,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,168,162,2,0,150,14,3,0,0,0,0,0,232,28,0,0,40,162,2,0,135,14,3,0,168,162,2,0,166,14,3,0,1,0,0,0,232,28,0,0,40,162,2,0,183,14,3,0,80,162,2,0,220,14,3,0,240,81,0,0,0,0,0,0,168,162,2,0,247,14,3,0,1,0,0,0,248,29,0,0,168,162,2,0,20,15,3,0,0,0,0,0,248,29,0,0,40,162,2,0,48,15,3,0,80,162,2,0,85,15,3,0,104,75,0,0,0,0,0,0,168,162,2,0,103,15,3,0,1,0,0,0,48,30,0,0,168,162,2,0,123,15,3,0,0,0,0,0,48,30,0,0,40,162,2,0,142,15,3,0,168,162,2,0,166,15,3,0,1,0,0,0,32,19,0,0,168,162,2,0,186,15,3,0,0,0,0,0,32,19,0,0,168,162,2,0,201,15,3,0,1,0,0,0,104,75,0,0,168,162,2,0,222,15,3,0,0,0,0,0,104,75,0,0,40,162,2,0,242,15,3,0,80,162,2,0,18,16,3,0,32,19,0,0,0,0,0,0,168,162,2,0,40,16,3,0,1,0,0,0,176,30,0,0,168,162,2,0,64,16,3,0,0,0,0,0,176,30,0,0,168,162,2,0,158,16,3,0,0,0,0,0,72,83,0,0,40,162,2,0,123,16,3,0,40,162,2,0,87,16,3,0,168,162,2,0,184,16,3,0,1,0,0,0,72,83,0,0,168,162,2,0,218,16,3,0,0,0,0,0,120,81,0,0,168,162,2,0,248,16,3,0,1,0,0,0,120,81,0,0,40,162,2,0,18,17,3,0,168,162,2,0,44,17,3,0,1,0,0,0,88,24,0,0,168,162,2,0,62,17,3,0,0,0,0,0,88,24,0,0,168,162,2,0,79,17,3,0,1,0,0,0,136,20,0,0,168,162,2,0,111,17,3,0,0,0,0,0,136,20,0,0,40,162,2,0,142,17,3,0,80,162,2,0,172,17,3,0,32,26,0,0,0,0,0,0,168,162,2,0,192,17,3,0,1,0,0,0,128,31,0,0,168,162,2,0,214,17,3,0,0,0,0,0,128,31,0,0,40,162,2,0,235,17,3,0,80,162,2,0,14,18,3,0,192,24,0,0,0,0,0,0,168,162,2,0,39,18,3,0,1,0,0,0,184,31,0,0,168,162,2,0,66,18,3,0,0,0,0,0,184,31,0,0,40,162,2,0,92,18,3,0,40,162,2,0,132,18,3,0,80,162,2,0,117,18,3,0,56,25,0,0,0,0,0,0,168,162,2,0,148,18,3,0,1,0,0,0,248,31,0,0,168,162,2,0,165,18,3,0,0,0,0,0,248,31,0,0,40,162,2,0,187,18,3,0,168,162,2,0,212,18,3,0,0,0,0,0,40,32,0,0,168,162,2,0,238,18,3,0,1,0,0,0,40,32,0,0,168,162,2,0,255,18,3,0,1,0,0,0,96,32,0,0,80,162,2,0,34,19,3,0,136,20,0,0,0,0,0,0,168,162,2,0,67,19,3,0,0,0,0,0,96,32,0,0,168,162,2,0,108,19,3,0,1,0,0,0,0,22,0,0,168,162,2,0,138,19,3,0,0,0,0,0,0,22,0,0,40,162,2,0,167,19,3,0,80,162,2,0,215,19,3,0,176,40,0,0,0,0,0,0,168,162,2,0,250,19,3,0,1,0,0,0,168,32,0,0,168,162,2,0,23,20,3,0,0,0,0,0,168,32,0,0,168,162,2,0,55,20,3,0,0,0,0,0,200,21,0,0,168,162,2,0,87,20,3,0,1,0,0,0,200,21,0,0,40,162,2,0,113,20,3,0,80,162,2,0,138,20,3,0,88,24,0,0,0,0,0,0,168,162,2,0,153,20,3,0,1,0,0,0,0,33,0,0,168,162,2,0,170,20,3,0,0,0,0,0,0,33,0,0,40,162,2,0,186,20,3,0,80,162,2,0,224,20,3,0,240,81,0,0,0,0,0,0,168,162,2,0,252,20,3,0,1,0,0,0,56,33,0,0,168,162,2,0,26,21,3,0,0,0,0,0,56,33,0,0,168,162,2,0,55,21,3,0,1,0,0,0,120,33,0,0,80,162,2,0,91,21,3,0,136,20,0,0,0,0,0,0,168,162,2,0,131,21,3,0,0,0,0,0,120,33,0,0,40,162,2,0,166,21,3,0,168,162,2,0,205,21,3,0,1,0,0,0,176,33,0,0,80,162,2,0,236,21,3,0,104,75,0,0,0,0,0,0,168,162,2,0,16,22,3,0,0,0,0,0,176,33,0,0,168,162,2,0,59,22,3,0,1,0,0,0,8,81,0,0,224,162,2,0,82,22,3,0,0,0,0,0,1,0,0,0,248,33,0,0,0,0,0,0,224,162,2,0,134,22,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,168,162,2,0,203,22,3,0,0,0,0,0,8,81,0,0,40,162,2,0,3,23,3,0,168,162,2,0,39,23,3,0,1,0,0,0,56,34,0,0,80,162,2,0,67,23,3,0,232,25,0,0,0,0,0,0,168,162,2,0,98,23,3,0,0,0,0,0,56,34,0,0,40,162,2,0,125,23,3,0,80,162,2,0,167,23,3,0,0,22,0,0,0,0,0,0,168,162,2,0,204,23,3,0,1,0,0,0,96,34,0,0,168,162,2,0,1,24,3,0,0,0,0,0,96,34,0,0,40,162,2,0,34,24,3,0,80,162,2,0,76,24,3,0,32,26,0,0,0,0,0,0,168,162,2,0,108,24,3,0,1,0,0,0,152,34,0,0,168,162,2,0,141,24,3,0,0,0,0,0,152,34,0,0,40,162,2,0,197,24,3,0,80,162,2,0,14,25,3,0,224,34,0,0,0,0,0,0,80,162,2,0,39,25,3,0,240,26,0,0,0,0,0,0,224,162,2,0,101,25,3,0,0,0,0,0,1,0,0,0,8,35,0,0,0,0,0,0,224,162,2,0,137,25,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,224,162,2,0,71,26,3,0,0,0,0,0,1,0,0,0,56,35,0,0,0,0,0,0,224,162,2,0,124,26,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,224,162,2,0,191,26,3,0,0,0,0,0,1,0,0,0,104,35,0,0,0,0,0,0,224,162,2,0,227,26,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,40,162,2,0,223,31,3,0,168,162,2,0,42,32,3,0,1,0,0,0,208,24,0,0,168,162,2,0,68,32,3,0,0,0,0,0,208,24,0,0,168,162,2,0,97,32,3,0,0,0,0,0,216,29,0,0,168,162,2,0,113,32,3,0,1,0,0,0,216,29,0,0,168,162,2,0,130,32,3,0,1,0,0,0,216,35,0,0,40,162,2,0,142,32,3,0,168,162,2,0,152,32,3,0,0,0,0,0,216,35,0,0,168,162,2,0,163,32,3,0,0,0,0,0,0,36,0,0,80,162,2,0,181,32,3,0,16,36,0,0,0,0,0,0,40,162,2,0,198,32,3,0,168,162,2,0,220,32,3,0,1,0,0,0,0,36,0,0,168,162,2,0,239,32,3,0,1,0,0,0,216,17,0,0,168,162,2,0,251,32,3,0,0,0,0,0,216,17,0,0,40,162,2,0,11,33,3,0,40,162,2,0,42,33,3,0,40,162,2,0,73,33,3,0,40,162,2,0,104,33,3,0,40,162,2,0,135,33,3,0,40,162,2,0,166,33,3,0,40,162,2,0,197,33,3,0,40,162,2,0,228,33,3,0,168,162,2,0,254,33,3,0,0,0,0,0,224,17,0,0,168,162,2,0,19,34,3,0,1,0,0,0,224,17,0,0,168,162,2,0,45,34,3,0,1,0,0,0,32,29,0,0,168,162,2,0,99,34,3,0,0,0,0,0,32,29,0,0,168,162,2,0,152,34,3,0,1,0,0,0,128,19,0,0,168,162,2,0,205,34,3,0,0,0,0,0,128,19,0,0,168,162,2,0,1,35,3,0,1,0,0,0,144,25,0,0,168,162,2,0,54,35,3,0,0,0,0,0,144,25,0,0,168,162,2,0,106,35,3,0,1,0,0,0,16,18,0,0,168,162,2,0,154,35,3,0,0,0,0,0,16,18,0,0,224,162,2,0,201,35,3,0,0,0,0,0,1,0,0,0,64,37,0,0,0,0,0,0,224,162,2,0,254,35,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,168,162,2,0,59,36,3,0,1,0,0,0,40,37,0,0,168,162,2,0,114,36,3,0,0,0,0,0,40,37,0,0,168,162,2,0,168,36,3,0,1,0,0,0,224,33,0,0,168,162,2,0,222,36,3,0,0,0,0,0,224,33,0,0,168,162,2,0,19,37,3,0,1,0,0,0,72,22,0,0,168,162,2,0,90,37,3,0,0,0,0,0,72,22,0,0,224,162,2,0,160,37,3,0,0,0,0,0,1,0,0,0,208,37,0,0,0,0,0,0,224,162,2,0,213,37,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,168,162,2,0,24,38,3,0,1,0,0,0,184,37,0,0,168,162,2,0,79,38,3,0,0,0,0,0,184,37,0,0,168,162,2,0,133,38,3,0,1,0,0,0,136,28,0,0,168,162,2,0,177,38,3,0,0,0,0,0,136,28,0,0,224,162,2,0,214,38,3,0,0,0,0,0,1,0,0,0,64,38,0,0,0,0,0,0,224,162,2,0,13,39,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,168,162,2,0,76,39,3,0,1,0,0,0,40,38,0,0,168,162,2,0,133,39,3,0,0,0,0,0,40,38,0,0,224,162,2,0,189,39,3,0,0,0,0,0,1,0,0,0,144,38,0,0,0,0,0,0,224,162,2,0,19,40,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,168,162,2,0,113,40,3,0,1,0,0,0,120,38,0,0,168,162,2,0,201,40,3,0,0,0,0,0,120,38,0,0,168,162,2,0,32,41,3,0,1,0,0,0,240,34,0,0,168,162,2,0,70,41,3,0,0,0,0,0,240,34,0,0,224,162,2,0,107,41,3,0,0,0,0,0,1,0,0,0,0,39,0,0,0,0,0,0,224,162,2,0,143,41,3,0,0,0,0,0,1,0,0,0,64,18,0,0,0,0,0,0,168,162,2,0,187,41,3,0,1,0,0,0,232,38,0,0,168,162,2,0,225,41,3,0,0,0,0,0,232,38,0,0,168,162,2,0,6,42,3,0,1,0,0,0,80,35,0,0,168,162,2,0,44,42,3,0,0,0,0,0,80,35,0,0,168,162,2,0,81,42,3,0,1,0,0,0,200,19,0,0,168,162,2,0,119,42,3,0,0,0,0,0,200,19,0,0,80,162,2,0,156,42,3,0,136,39,0,0,0,0,0,0,80,162,2,0,205,42,3,0,152,39,0,0,0,0,0,0,40,162,2,0,5,43,3,0,80,162,2,0,41,43,3,0,176,39,0,0,0,0,0,0,80,162,2,0,81,43,3,0,152,39,0,0,0,0,0,0,80,162,2,0,159,43,3,0,216,39,0,0,0,0,0,0,196,162,2,0,126,43,3,0,80,162,2,0,222,43,3,0,152,39,0,0,0,0,0,0,80,162,2,0,36,44,3,0,248,39,0,0,0,0,0,0,80,162,2,0,96,44,3,0,152,39],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE);allocate([80,162,2,0,163,44,3,0,24,40,0,0,0,0,0,0,80,162,2,0,203,44,3,0,152,39,0,0,0,0,0,0,80,162,2,0,248,44,3,0,56,40,0,0,0,0,0,0,80,162,2,0,32,45,3,0,152,39,0,0,0,0,0,0,80,162,2,0,77,45,3,0,88,40,0,0,0,0,0,0,80,162,2,0,117,45,3,0,152,39,0,0,0,0,0,0,80,162,2,0,162,45,3,0,120,40,0,0,0,0,0,0,80,162,2,0,204,45,3,0,152,39,0,0,0,0,0,0,80,162,2,0,36,46,3,0,160,40,0,0,0,0,0,0,40,162,2,0,7,46,3,0,80,162,2,0,88,46,3,0,152,39,0,0,0,0,0,0,40,162,2,0,157,46,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,192,0,0,0,0,0,0,224,193,0,0,0,224,255,255,239,199,255,255,255,255,255,255,239,255,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,192,95,64,0,0,0,0,224,255,239,64,0,0,0,0,192,255,223,64,0,0,192,255,255,255,223,65,0,0,0,224,255,255,239,71,255,255,255,255,255,255,239,127,0,0,0,0,0,0,0,0,80,162,2,0,243,54,3,0,72,41,0,0,0,0,0,0,40,162,2,0,63,55,3,0,80,162,2,0,85,55,3,0,104,49,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,205,59,127,102,158,160,230,63,204,59,127,102,158,160,230,63,70,141,50,207,107,144,237,63,99,169,174,166,226,125,216,63,176,92,247,207,151,98,239,63,10,166,105,60,184,248,200,63,38,37,209,163,141,216,239,63,44,180,41,188,166,23,185,63,126,109,121,227,33,246,239,63,21,216,13,241,101,31,169,63,13,205,132,96,136,253,239,63,127,102,163,247,85,33,153,63,219,146,155,22,98,255,239,63,135,199,222,252,209,33,137,63,146,138,142,133,216,255,239,63,118,0,103,254,240,33,121,63,2,29,98,33,246,255,239,63,195,164,204,190,248,33,105,63,230,110,88,136,253,255,239,63,66,71,230,174,250,33,89,63,52,26,22,98,255,255,239,63,55,179,236,42,251,33,73,63,117,134,133,216,255,255,239,63,248,78,238,73,251,33,57,63,156,97,33,246,255,255,239,63,2,181,174,81,251,33,41,63,103,88,136,253,255,255,239,63,245,207,158,83,251,33,25,63,26,22,98,255,255,255,239,63,106,215,26,84,251,33,9,63,134,133,216,255,255,255,239,63,72,217,57,84,251,33,249,62,98,33,246,255,255,255,239,63,78,152,65,84,251,33,233,62,88,136,253,255,255,255,239,63,136,124,67,84,251,33,217,62,22,98,255,255,255,255,239,63,196,216,67,84,251,33,201,62,134,216,255,255,255,255,239,63,0,53,68,84,251,33,185,62,33,246,255,255,255,255,239,63,136,124,67,84,251,33,169,62,136,253,255,255,255,255,239,63,136,124,67,84,251,33,153,62,98,255,255,255,255,255,239,63,103,94,70,84,251,33,137,62,217,255,255,255,255,255,239,63,169,154,64,84,251,33,121,62,246,255,255,255,255,255,239,63,36,34,76,84,251,33,105,62,254,255,255,255,255,255,239,63,36,34,76,84,251,33,89,62,255,255,255,255,255,255,239,63,58,4,30,84,251,33,73,62,0,0,0,0,0,0,240,63,15,64,122,84,251,33,57,62,0,0,0,0,0,0,240,63,15,64,122,84,251,33,41,62,205,59,127,102,158,160,230,63,0,0,0,0,0,0,224,63,205,59,127,102,158,160,214,63,0,0,0,0,0,0,208,63,205,59,127,102,158,160,198,63,0,0,0,0,0,0,192,63,205,59,127,102,158,160,182,63,0,0,0,0,0,0,176,63,205,59,127,102,158,160,166,63,0,0,0,0,0,0,160,63,205,59,127,102,158,160,150,63,0,0,0,0,0,0,144,63,205,59,127,102,158,160,134,63,0,0,0,0,0,0,128,63,205,59,127,102,158,160,118,63,0,0,0,0,0,0,112,63,206,59,127,102,158,160,102,63,0,0,0,0,0,0,96,63,206,59,127,102,158,160,86,63,0,0,0,0,0,0,80,63,206,59,127,102,158,160,70,63,0,0,0,0,0,0,64,63,206,59,127,102,158,160,54,63,0,0,0,0,0,0,48,63,206,59,127,102,158,160,38,63,0,0,0,0,0,0,32,63,206,59,127,102,158,160,22,63,0,0,0,0,0,0,16,63,132,59,127,102,158,160,6,63,0,0,0,0,0,0,0,63,80,162,2,0,127,66,3,0,104,49,0,0,0,0,0,0,80,162,2,0,157,66,3,0,104,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,44,180,41,188,166,23,185,63,10,166,105,60,184,248,200,63,5,159,213,46,6,148,210,63,99,169,174,166,226,125,216,63,59,246,6,56,93,43,222,63,200,104,174,57,59,199,225,63,214,29,9,37,243,76,228,63,204,59,127,102,158,160,230,63,65,23,21,107,128,188,232,63,163,161,14,41,102,155,234,63,176,189,128,241,178,56,236,63,70,141,50,207,107,144,237,63,219,45,198,86,65,159,238,63,176,92,247,207,151,98,239,63,37,37,209,163,141,216,239,63,0,0,0,0,0,0,240,63,38,37,209,163,141,216,239,63,176,92,247,207,151,98,239,63,219,45,198,86,65,159,238,63,70,141,50,207,107,144,237,63,177,189,128,241,178,56,236,63,165,161,14,41,102,155,234,63,66,23,21,107,128,188,232,63,205,59,127,102,158,160,230,63,214,29,9,37,243,76,228,63,200,104,174,57,59,199,225,63,63,246,6,56,93,43,222,63,101,169,174,166,226,125,216,63,6,159,213,46,6,148,210,63,23,166,105,60,184,248,200,63,60,180,41,188,166,23,185,63,159,113,189,255,249,165,161,60,43,180,41,188,166,23,185,191,14,166,105,60,184,248,200,191,1,159,213,46,6,148,210,191,97,169,174,166,226,125,216,191,59,246,6,56,93,43,222,191,198,104,174,57,59,199,225,191,212,29,9,37,243,76,228,191,204,59,127,102,158,160,230,191,62,23,21,107,128,188,232,191,163,161,14,41,102,155,234,191,176,189,128,241,178,56,236,191,68,141,50,207,107,144,237,191,218,45,198,86,65,159,238,191,175,92,247,207,151,98,239,191,38,37,209,163,141,216,239,191,0,0,0,0,0,0,240,191,38,37,209,163,141,216,239,191,176,92,247,207,151,98,239,191,219,45,198,86,65,159,238,191,69,141,50,207,107,144,237,191,177,189,128,241,178,56,236,191,165,161,14,41,102,155,234,191,64,23,21,107,128,188,232,191,206,59,127,102,158,160,230,191,218,29,9,37,243,76,228,191,200,104,174,57,59,199,225,191,64,246,6,56,93,43,222,191,110,169,174,166,226,125,216,191,8,159,213,46,6,148,210,191,27,166,105,60,184,248,200,191,37,180,41,188,166,23,185,191,49,244,70,62,15,206,131,63,71,85,215,212,68,5,132,63,150,24,1,83,20,61,132,63,240,209,204,101,127,117,132,63,186,20,239,190,135,174,132,63,248,121,213,20,47,232,132,63,157,202,179,34,119,34,133,63,157,78,145,168,97,93,133,63,12,65,86,107,240,152,133,63,195,105,217,52,37,213,133,63,241,220,237,211,1,18,134,63,251,224,112,28,136,79,134,63,26,251,87,231,185,141,134,63,41,35,191,18,153,204,134,63,3,31,247,129,39,12,135,63,238,5,148,29,103,76,135,63,113,236,123,211,89,141,135,63,28,185,245,150,1,207,135,63,164,34,184,96,96,17,136,63,192,215,248,46,120,84,136,63,87,209,123,5,75,152,136,63,90,207,162,237,218,220,136,63,197,0,125,246,41,34,137,63,87,215,214,52,58,104,137,63,85,7,74,195,13,175,137,63,241,179,77,194,166,246,137,63,199,200,70,88,7,63,138,63,236,128,152,177,49,136,138,63,15,28,181,0,40,210,138,63,43,194,46,126,236,28,139,63,87,150,200,104,129,104,139,63,34,249,135,5,233,180,139,63,22,251,197,159,37,2,140,63,215,255,64,137,57,80,140,63,117,146,46,26,39,159,140,63,103,107,77,177,240,238,140,63,204,168,247,179,152,63,141,63,114,57,53,142,33,145,141,63,62,123,206,178,141,227,141,63,105,13,95,155,223,54,142,63,71,215,104,200,25,139,142,63,18,68,103,193,62,224,142,63,77,180,226,20,81,54,143,63,95,37,132,88,83,141,143,63,249,15,41,41,72,229,143,63,242,190,123,21,25,31,144,63,223,43,185,4,10,76,144,63,173,245,198,59,120,121,144,63,177,85,226,23,101,167,144,63,92,20,22,250,209,213,144,63,48,35,69,71,192,4,145,63,65,84,53,104,49,52,145,63,151,47,154,201,38,100,145,63,190,230,31,220,161,148,145,63,229,102,118,20,164,197,145,63,208,137,92,235,46,247,145,63,8,102,171,221,67,41,146,63,142,190,97,108,228,91,146,63,109,146,175,28,18,143,146,63,136,204,1,120,206,194,146,63,5,20,14,12,27,247,146,63,151,189,222,106,249,43,147,63,33,222,222,42,107,97,147,63,249,126,230,230,113,151,147,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,191,40,162,2,0,223,78,3,0,80,162,2,0,118,78,3,0,128,48,0,0,0,0,0,0,80,162,2,0,227,77,3,0,128,48,0,0,0,0,0,0,80,162,2,0,96,78,3,0,128,48,0,0,0,0,0,0,80,162,2,0,138,78,3,0,128,48,0,0,0,0,0,0,80,162,2,0,190,78,3,0,128,48,0,0,0,0,0,0,80,162,2,0,174,78,3,0,128,48,0,0,0,0,0,0,80,162,2,0,209,78,3,0,128,48,0,0,0,0,0,0,80,162,2,0,235,78,3,0,128,48,0,0,0,0,0,0,80,162,2,0,27,79,3,0,128,48,0,0,0,0,0,0,40,162,2,0,202,80,3,0,80,162,2,0,52,79,3,0,48,49,0,0,0,0,0,0,40,162,2,0,85,79,3,0,80,162,2,0,15,80,3,0,24,49,0,0,0,0,0,0,80,162,2,0,141,95,3,0,56,107,0,0,0,0,0,0,80,162,2,0,207,95,3,0,120,107,0,0,0,0,0,0,40,162,2,0,146,96,3,0,40,162,2,0,226,113,3,0,80,162,2,0,113,99,3,0,72,41,0,0,0,0,0,0,80,162,2,0,38,136,3,0,104,49,0,0,0,0,0,0,80,162,2,0,121,136,3,0,80,112,0,0,0,0,0,0,40,162,2,0,167,140,3,0,224,162,2,0,126,141,3,0,0,0,0,0,1,0,0,0,168,49,0,0,0,0,0,0,80,162,2,0,96,156,3,0,72,41,0,0,0,0,0,0,80,162,2,0,142,159,3,0,112,21,0,0,0,0,0,0,80,162,2,0,56,157,3,0,72,41,0,0,0,0,0,0,80,162,2,0,155,157,3,0,104,49,0,0,0,0,0,0,80,162,2,0,201,157,3,0,72,41,0,0,0,0,0,0,80,162,2,0,44,158,3,0,104,49,0,0,0,0,0,0,80,162,2,0,90,158,3,0,72,41,0,0,0,0,0,0,80,162,2,0,194,158,3,0,104,49,0,0,0,0,0,0,80,162,2,0,245,158,3,0,72,41,0,0,0,0,0,0,80,162,2,0,92,159,3,0,104,49,0,0,0,0,0,0,80,162,2,0,119,162,3,0,104,49,0,0,0,0,0,0,80,162,2,0,168,162,3,0,104,49,0,0,0,0,0,0,80,162,2,0,217,162,3,0,104,49,0,0,0,0,0,0,80,162,2,0,6,163,3,0,104,49,0,0,0,0,0,0,80,162,2,0,51,163,3,0,104,49,0,0,0,0,0,0,80,162,2,0,96,163,3,0,104,49,0,0,0,0,0,0,80,162,2,0,141,163,3,0,104,49,0,0,0,0,0,0,80,162,2,0,186,163,3,0,104,49,0,0,0,0,0,0,80,162,2,0,231,163,3,0,104,49,0,0,0,0,0,0,80,162,2,0,20,164,3,0,104,49,0,0,0,0,0,0,80,162,2,0,65,164,3,0,104,49,0,0,0,0,0,0,80,162,2,0,108,164,3,0,104,49,0,0,0,0,0,0,80,162,2,0,151,164,3,0,104,49,0,0,0,0,0,0,80,162,2,0,194,164,3,0,104,49,0,0,0,0,0,0,80,162,2,0,237,164,3,0,104,49,0,0,0,0,0,0,80,162,2,0,24,165,3,0,104,49,0,0,0,0,0,0,80,162,2,0,67,165,3,0,104,49,0,0,0,0,0,0,80,162,2,0,110,165,3,0,104,49,0,0,0,0,0,0,80,162,2,0,153,165,3,0,104,49,0,0,0,0,0,0,80,162,2,0,189,165,3,0,104,49,0,0,0,0,0,0,80,162,2,0,225,165,3,0,104,49,0,0,0,0,0,0,80,162,2,0,6,166,3,0,104,49,0,0,0,0,0,0,80,162,2,0,43,166,3,0,104,49,0,0,0,0,0,0,80,162,2,0,78,166,3,0,104,49,0,0,0,0,0,0,80,162,2,0,113,166,3,0,104,49,0,0,0,0,0,0,80,162,2,0,155,166,3,0,104,49,0,0,0,0,0,0,80,162,2,0,197,166,3,0,104,49,0,0,0,0,0,0,80,162,2,0,239,166,3,0,104,49,0,0,0,0,0,0,80,162,2,0,25,167,3,0,104,49,0,0,0,0,0,0,80,162,2,0,65,167,3,0,104,49,0,0,0,0,0,0,80,162,2,0,105,167,3,0,104,49,0,0,0,0,0,0,80,162,2,0,145,167,3,0,104,49,0,0,0,0,0,0,80,162,2,0,185,167,3,0,104,49,0,0,0,0,0,0,80,162,2,0,229,167,3,0,104,49,0,0,0,0,0,0,80,162,2,0,17,168,3,0,104,49,0,0,0,0,0,0,80,162,2,0,61,168,3,0,104,49,0,0,0,0,0,0,80,162,2,0,105,168,3,0,104,49,0,0,0,0,0,0,80,162,2,0,149,168,3,0,104,49,0,0,0,0,0,0,80,162,2,0,62,169,3,0,104,49,0,0,0,0,0,0,80,162,2,0,243,169,3,0,104,49,0,0,0,0,0,0,80,162,2,0,168,170,3,0,104,49,0,0,0,0,0,0,80,162,2,0,212,170,3,0,104,49,0,0,0,0,0,0,80,162,2,0,0,171,3,0,104,49,0,0,0,0,0,0,80,162,2,0,44,171,3,0,104,49,0,0,0,0,0,0,80,162,2,0,88,171,3,0,104,49,0,0,0,0,0,0,80,162,2,0,132,171,3,0,104,49,0,0,0,0,0,0,80,162,2,0,176,171,3,0,104,49,0,0,0,0,0,0,80,162,2,0,220,171,3,0,104,49,0,0,0,0,0,0,80,162,2,0,8,172,3,0,104,49,0,0,0,0,0,0,80,162,2,0,55,172,3,0,104,49,0,0,0,0,0,0,80,162,2,0,102,172,3,0,104,49,0,0,0,0,0,0,80,162,2,0,149,172,3,0,104,49,0,0,0,0,0,0,80,162,2,0,196,172,3,0,104,49,0,0,0,0,0,0,80,162,2,0,243,172,3,0,104,49,0,0,0,0,0,0,80,162,2,0,34,173,3,0,104,49,0,0,0,0,0,0,80,162,2,0,84,173,3,0,104,49,0,0,0,0,0,0,80,162,2,0,134,173,3,0,104,49,0,0,0,0,0,0,80,162,2,0,184,173,3,0,104,49,0,0,0,0,0,0,80,162,2,0,234,173,3,0,104,49,0,0,0,0,0,0,80,162,2,0,28,174,3,0,104,49,0,0,0,0,0,0,80,162,2,0,78,174,3,0,104,49,0,0,0,0,0,0,80,162,2,0,125,174,3,0,104,49,0,0,0,0,0,0,80,162,2,0,171,174,3,0,104,49,0,0,0,0,0,0,80,162,2,0,217,174,3,0,104,49,0,0,0,0,0,0,80,162,2,0,7,175,3,0,104,49,0,0,0,0,0,0,80,162,2,0,54,175,3,0,104,49,0,0,0,0,0,0,80,162,2,0,100,175,3,0,104,49,0,0,0,0,0,0,80,162,2,0,146,175,3,0,104,49,0,0,0,0,0,0,80,162,2,0,192,175,3,0,104,49,0,0,0,0,0,0,80,162,2,0,238,175,3,0,104,49,0,0,0,0,0,0,80,162,2,0,28,176,3,0,104,49,0,0,0,0,0,0,80,162,2,0,73,176,3,0,104,49,0,0,0,0,0,0,80,162,2,0,118,176,3,0,104,49,0,0,0,0,0,0,80,162,2,0,117,178,3,0,8,55,0,0,0,0,0,0,40,162,2,0,139,178,3,0,80,162,2,0,163,178,3,0,8,55,0,0,0,0,0,0,80,162,2,0,185,178,3,0,8,55,0,0,0,0,0,0,80,162,2,0,207,178,3,0,8,55,0,0,0,0,0,0,80,162,2,0,230,178,3,0,8,55,0,0,0,0,0,0,80,162,2,0,250,178,3,0,8,55,0,0,0,0,0,0,80,162,2,0,16,179,3,0,8,55,0,0,0,0,0,0,80,162,2,0,37,179,3,0,8,55,0,0,0,0,0,0,80,162,2,0,56,179,3,0,8,55,0,0,0,0,0,0,80,162,2,0,75,179,3,0,8,55,0,0,0,0,0,0,80,162,2,0,94,179,3,0,8,55,0,0,0,0,0,0,80,162,2,0,114,179,3,0,8,55,0,0,0,0,0,0,80,162,2,0,134,179,3,0,8,55,0,0,0,0,0,0,80,162,2,0,160,182,3,0,72,41,0,0,0,0,0,0,80,162,2,0,53,188,3,0,104,49,0,0,0,0,0,0,80,162,2,0,128,188,3,0,104,49,0,0,0,0,0,0,80,162,2,0,203,188,3,0,104,49,0,0,0,0,0,0,80,162,2,0,10,189,3,0,104,49,0,0,0,0,0,0,80,162,2,0,73,189,3,0,104,49,0,0,0,0,0,0,80,162,2,0,137,189,3,0,104,49,0,0,0,0,0,0,80,162,2,0,110,192,3,0,104,49,0,0,0,0,0,0,80,162,2,0,130,192,3,0,104,49,0,0,0,0,0,0,40,162,2,0,254,197,3,0,40,162,2,0,19,198,3,0,40,162,2,0,43,198,3,0,40,162,2,0,187,200,3,0,80,162,2,0,3,202,3,0,72,41,0,0,0,0,0,0,80,162,2,0,176,202,3,0,96,56,0,0,0,0,0,0,80,162,2,0,209,202,3,0,72,41,0,0,0,0,0,0,80,162,2,0,38,203,3,0,96,56,0,0,0,0,0,0,80,162,2,0,71,203,3,0,72,41,0,0,0,0,0,0,80,162,2,0,156,203,3,0,96,56,0,0,0,0,0,0,80,162,2,0,189,203,3,0,72,41,0,0,0,0,0,0,80,162,2,0,18,204,3,0,96,56,0,0,0,0,0,0,80,162,2,0,51,204,3,0,72,41,0,0,0,0,0,0,80,162,2,0,136,204,3,0,96,56,0,0,0,0,0,0,80,162,2,0,169,204,3,0,72,41,0,0,0,0,0,0,80,162,2,0,254,204,3,0,96,56,0,0,0,0,0,0,80,162,2,0,31,205,3,0,72,41,0,0,0,0,0,0,80,162,2,0,116,205,3,0,96,56,0,0,0,0,0,0,80,162,2,0,149,205,3,0,72,41,0,0,0,0,0,0,80,162,2,0,234,205,3,0,96,56,0,0,0,0,0,0,80,162,2,0,11,206,3,0,72,41,0,0,0,0,0,0,80,162,2,0,96,206,3,0,96,56,0,0,0,0,0,0,80,162,2,0,129,206,3,0,72,41,0,0,0,0,0,0,80,162,2,0,214,206,3,0,96,56,0,0,0,0,0,0,80,162,2,0,247,206,3,0,72,41,0,0,0,0,0,0,80,162,2,0,200,207,3,0,96,56,0,0,0,0,0,0,80,162,2,0,243,207,3,0,208,57,0,0,0,0,0,0,80,162,2,0,40,208,3,0,72,41,0,0,0,0,0,0,80,162,2,0,145,208,3,0,96,56,0,0,0,0,0,0,80,162,2,0,188,208,3,0,0,58,0,0,0,0,0,0,80,162,2,0,174,209,3,0,72,41,0,0,0,0,0,0,80,162,2,0,108,210,3,0,104,56,0,0,0,0,0,0,80,162,2,0,160,210,3,0,48,58,0,0,0,0,0,0,80,162,2,0,216,210,3,0,72,41,0,0,0,0,0,0,80,162,2,0,68,211,3,0,104,56,0,0,0,0,0,0,80,162,2,0,120,211,3,0,96,58,0,0,0,0,0,0,80,162,2,0,176,211,3,0,72,41,0,0,0,0,0,0,80,162,2,0,28,212,3,0,104,56,0,0,0,0,0,0,80,162,2,0,80,212,3,0,144,58,0,0,0,0,0,0,80,162,2,0,136,212,3,0,72,41,0,0,0,0,0,0,80,162,2,0,244,212,3,0,104,56,0,0,0,0,0,0,80,162,2,0,40,213,3,0,192,58,0,0,0,0,0,0,80,162,2,0,96,213,3,0,72,41,0,0,0,0,0,0,80,162,2,0,204,213,3,0,104,56,0,0,0,0,0,0,80,162,2,0,0,214,3,0,240,58,0,0,0,0,0,0,80,162,2,0,147,214,3,0,72,41,0,0,0,0,0,0,80,162,2,0,255,214,3,0,104,56,0,0,0,0,0,0,80,162,2,0,51,215,3,0,32,59,0,0,0,0,0,0,80,162,2,0,107,215,3,0,72,41,0,0,0,0,0,0,80,162,2,0,215,215,3,0,104,56,0,0,0,0,0,0,80,162,2,0,11,216,3,0,80,59,0,0,0,0,0,0,80,162,2,0,67,216,3,0,72,41,0,0,0,0,0,0,80,162,2,0,175,216,3,0,104,56,0,0,0,0,0,0,80,162,2,0,227,216,3,0,128,59,0,0,0,0,0,0,80,162,2,0,27,217,3,0,72,41,0,0,0,0,0,0,80,162,2,0,135,217,3,0,104,56,0,0,0,0,0,0,80,162,2,0,187,217,3,0,176,59,0,0,0,0,0,0,80,162,2,0,243,217,3,0,72,41,0,0,0,0,0,0,80,162,2,0,105,218,3,0,104,56,0,0,0,0,0,0,80,162,2,0,167,218,3,0,224,59,0,0,0,0,0,0,80,162,2,0,233,218,3,0,72,41,0,0,0,0,0,0,80,162,2,0,138,219,3,0,104,56,0,0,0,0,0,0,80,162,2,0,199,219,3,0,48,60,0,0,0,0,0,0,80,162,2,0,13,220,3,0,16,60,0,0,0,0,0,0,80,162,2,0,78,220,3,0,72,41,0,0,0,0,0,0,80,162,2,0,200,220,3,0,104,56,0,0,0,0,0,0,80,162,2,0,5,221,3,0,112,60,0,0,0,0,0,0,80,162,2,0,75,221,3,0,80,60,0,0,0,0,0,0,80,162,2,0,140,221,3,0,72,41,0,0,0,0,0,0,80,162,2,0,7,222,3,0,240,59,0,0,0,0,0,0,80,162,2,0,78,222,3,0,72,41,0,0,0,0,0,0,80,162,2,0,182,222,3,0,72,41,0,0,0,0,0,0,80,162,2,0,30,223,3,0,72,41,0,0,0,0,0,0,80,162,2,0,134,223,3,0,72,41,0,0,0,0,0,0,80,162,2,0,238,223,3,0,72,41,0,0,0,0,0,0,80,162,2,0,86,224,3,0,72,41,0,0,0,0,0,0,80,162,2,0,190,224,3,0,72,41,0,0,0,0,0,0,80,162,2,0,38,225,3,0,72,41,0,0,0,0,0,0,80,162,2,0,142,225,3,0,72,41,0,0,0,0,0,0,80,162,2,0,54,226,3,0,72,41,0,0,0,0,0,0,80,162,2,0,99,227,3,0,72,41,0,0,0,0,0,0,80,162,2,0,245,227,3,0,112,56,0,0,0,0,0,0,80,162,2,0,37,228,3,0,72,41,0,0,0,0,0,0,80,162,2,0,137,228,3,0,112,56,0,0,0,0,0,0,80,162,2,0,185,228,3,0,72,41,0,0,0,0,0,0,80,162,2,0,29,229,3,0,112,56,0,0,0,0,0,0,80,162,2,0,77,229,3,0,72,41,0,0,0,0,0,0,80,162,2,0,177,229,3,0,112,56,0,0,0,0,0,0,80,162,2,0,225,229,3,0,72,41,0,0,0,0,0,0,80,162,2,0,69,230,3,0,112,56,0,0,0,0,0,0,80,162,2,0,117,230,3,0,72,41,0,0,0,0,0,0,80,162,2,0,217,230,3,0,112,56,0,0,0,0,0,0,80,162,2,0,9,231,3,0,72,41,0,0,0,0,0,0,80,162,2,0,109,231,3,0,112,56,0,0,0,0,0,0,80,162,2,0,157,231,3,0,72,41,0,0,0,0,0,0,80,162,2,0,1,232,3,0,112,56,0,0,0,0,0,0,80,162,2,0,49,232,3,0,72,41,0,0,0,0,0,0,80,162,2,0,149,232,3,0,112,56,0,0,0,0,0,0,80,162,2,0,197,232,3,0,72,41,0,0,0,0,0,0,80,162,2,0,41,233,3,0,112,56,0,0,0,0,0,0,80,162,2,0,89,233,3,0,72,41,0,0,0,0,0,0,80,162,2,0,189,233,3,0,112,56,0,0,0,0,0,0,80,162,2,0,237,233,3,0,72,41,0,0,0,0,0,0,80,162,2,0,81,234,3,0,112,56,0,0,0,0,0,0,80,162,2,0,129,234,3,0,72,41,0,0,0,0,0,0,80,162,2,0,229,234,3,0,112,56,0,0,0,0,0,0,80,162,2,0,232,27,5,0,104,49,0,0,0,0,0,0,80,162,2,0,2,28,5,0,104,49,0,0,0,0,0,0,80,162,2,0,41,30,5,0,72,41,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,205,59,127,102,158,160,230,191,205,59,127,102,158,160,230,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,205,59,127,102,158,160,230,63,205,59,127,102,158,160,230,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,205,59,127,102,158,160,230,63,205,59,127,102,158,160,230,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,205,59,127,102,158,160,230,191,205,59,127,102,158,160,230,63,80,162,2,0,141,31,5,0,104,49,0,0,0,0,0,0,80,162,2,0,58,32,5,0,104,49,0,0,0,0,0,0,80,162,2,0,190,32,5,0,104,49,0,0,0,0,0,0,80,162,2,0,66,33,5,0,104,49,0,0,0,0,0,0,80,162,2,0,198,33,5,0,104,49,0,0,0,0,0,0,80,162,2,0,90,34,5,0,104,49,0,0,0,0,0,0,80,162,2,0,204,34,5,0,104,49,0,0,0,0,0,0,80,162,2,0,62,35,5,0,104,49,0,0,0,0,0,0,80,162,2,0,176,35,5,0,104,49,0,0,0,0,0,0,80,162,2,0,34,36,5,0,104,49,0,0,0,0,0,0,80,162,2,0,161,36,5,0,104,49,0,0,0,0,0,0,80,162,2,0,13,37,5,0,104,49,0,0,0,0,0,0,80,162,2,0,121,37,5,0,104,49,0,0,0,0,0,0,80,162,2,0,229,37,5,0,104,49,0,0,0,0,0,0,80,162,2,0,81,38,5,0,104,49,0,0,0,0,0,0,80,162,2,0,202,38,5,0,104,49,0,0,0,0,0,0,80,162,2,0,232,38,5,0,104,49,0,0,0,0,0,0,80,162,2,0,6,39,5,0,104,49,0,0,0,0,0,0,80,162,2,0,36,39,5,0,104,49,0,0,0,0,0,0,80,162,2,0,66,39,5,0,104,49,0,0,0,0,0,0,80,162,2,0,96,39,5,0,104,49,0,0,0,0,0,0,80,162,2,0,159,39,5,0,104,49,0,0,0,0,0,0,80,162,2,0,230,39,5,0,104,49,0,0,0,0,0,0,80,162,2,0,63,40,5,0,104,49,0,0,0,0,0,0,80,162,2,0,152,40,5,0,104,49,0,0,0,0,0,0,80,162,2,0,241,40,5,0,104,49,0,0,0,0,0,0,80,162,2,0,236,41,5,0,104,49,0,0,0,0,0,0,80,162,2,0,8,44,5,0,104,49,0,0,0,0,0,0,80,162,2,0,143,44,5,0,104,49,0,0,0,0,0,0,80,162,2,0,54,49,5,0,168,32,0,0,0,0,0,0,80,162,2,0,85,49,5,0,72,41,0,0,0,0,0,0,80,162,2,0,25,54,5,0,72,41,0,0,0,0,0,0,80,162,2,0,133,54,5,0,96,56,0,0,0,0,0,0,80,162,2,0,189,54,5,0,72,41,0,0,0,0,0,0,80,162,2,0,41,55,5,0,96,56,0,0,0,0,0,0,80,162,2,0,97,55,5,0,72,41,0,0,0,0,0,0,80,162,2,0,205,55,5,0,96,56,0,0,0,0,0,0,80,162,2,0,5,56,5,0,72,41,0,0,0,0,0,0,80,162,2,0,113,56,5,0,96,56,0,0,0,0,0,0,80,162,2,0,169,56,5,0,72,41,0,0,0,0,0,0,80,162,2,0,21,57,5,0,96,56,0,0,0,0,0,0,80,162,2,0,77,57,5,0,72,41,0,0,0,0,0,0,80,162,2,0,185,57,5,0,96,56,0,0,0,0,0,0,80,162,2,0,241,57,5,0,72,41,0,0,0,0,0,0,80,162,2,0,93,58,5,0,96,56,0,0,0,0,0,0,80,162,2,0,149,58,5,0,72,41,0,0,0,0,0,0,80,162,2,0,1,59,5,0,96,56,0,0,0,0,0,0,80,162,2,0,57,59,5,0,72,41,0,0,0,0,0,0,80,162,2,0,165,59,5,0,96,56,0,0,0,0,0,0,80,162,2,0,221,59,5,0,72,41,0,0,0,0,0,0,80,162,2,0,73,60,5,0,96,56,0,0,0,0,0,0,80,162,2,0,155,60,5,0,72,41,0,0,0,0,0,0,80,162,2,0,13,61,5,0,104,56,0,0,0,0,0,0,80,162,2,0,75,61,5,0,72,41,0,0,0,0,0,0,80,162,2,0,189,61,5,0,104,56,0,0,0,0,0,0,80,162,2,0,251,61,5,0,72,41,0,0,0,0,0,0,80,162,2,0,109,62,5,0,104,56,0,0,0,0,0,0,80,162,2,0,171,62,5,0,72,41,0,0,0,0,0,0,80,162,2,0,29,63,5,0,104,56,0,0,0,0,0,0,80,162,2,0,91,63,5,0,72,41,0,0,0,0,0,0,80,162,2,0,205,63,5,0,104,56,0,0,0,0,0,0,80,162,2,0,11,64,5,0,72,41,0,0,0,0,0,0,80,162,2,0,125,64,5,0,104,56,0,0,0,0,0,0,80,162,2,0,187,64,5,0,72,41,0,0,0,0,0,0,80,162,2,0,45,65,5,0,104,56,0,0,0,0,0,0,80,162,2,0,107,65,5,0,72,41,0,0,0,0,0,0,80,162,2,0,221,65,5,0,104,56,0,0,0,0,0,0,80,162,2,0,27,66,5,0,72,41,0,0,0,0,0,0,80,162,2,0,141,66,5,0,104,56,0,0,0,0,0,0,80,162,2,0,203,66,5,0,72,41,0,0,0,0,0,0,80,162,2,0,61,67,5,0,104,56,0,0,0,0,0,0,80,162,2,0,30,68,5,0,72,41,0,0,0,0,0,0,80,162,2,0,168,68,5,0,112,56,0,0,0,0,0,0,80,162,2,0,218,68,5,0,72,41,0,0,0,0,0,0,80,162,2,0,64,69,5,0,112,56,0,0,0,0,0,0,80,162,2,0,114,69,5,0,72,41,0,0,0,0,0,0,80,162,2,0,216,69,5,0,112,56,0,0,0,0,0,0,80,162,2,0,10,70,5,0,72,41,0,0,0,0,0,0,80,162,2,0,112,70,5,0,112,56,0,0,0,0,0,0,80,162,2,0,162,70,5,0,72,41,0,0,0,0,0,0,80,162,2,0,8,71,5,0,112,56,0,0,0,0,0,0,80,162,2,0,58,71,5,0,72,41,0,0,0,0,0,0,80,162,2,0,160,71,5,0,112,56,0,0,0,0,0,0,80,162,2,0,210,71,5,0,72,41,0,0,0,0,0,0,80,162,2,0,56,72,5,0,112,56,0,0,0,0,0,0,80,162,2,0,106,72,5,0,72,41,0,0,0,0,0,0,80,162,2,0,208,72,5,0,112,56,0,0,0,0,0,0,80,162,2,0,2,73,5,0,72,41,0,0,0,0,0,0,80,162,2,0,104,73,5,0,112,56,0,0,0,0,0,0,80,162,2,0,154,73,5,0,72,41,0,0,0,0,0,0,80,162,2,0,0,74,5,0,112,56,0,0,0,0,0,0,80,162,2,0,0,75,5,0,104,49,0,0,0,0,0,0,80,162,2,0,58,83,5,0,72,41,0,0,0,0,0,0,80,162,2,0,127,83,5,0,96,56,0,0,0,0,0,0,80,162,2,0,144,83,5,0,72,41,0,0,0,0,0,0,80,162,2,0,213,83,5,0,96,56,0,0,0,0,0,0,80,162,2,0,230,83,5,0,72,41,0,0,0,0,0,0,80,162,2,0,43,84,5,0,96,56,0,0,0,0,0,0,80,162,2,0,60,84,5,0,72,41,0,0,0,0,0,0,80,162,2,0,129,84,5,0,96,56,0,0,0,0,0,0,80,162,2,0,146,84,5,0,72,41,0,0,0,0,0,0,80,162,2,0,215,84,5,0,96,56,0,0,0,0,0,0,80,162,2,0,232,84,5,0,72,41,0,0,0,0,0,0,80,162,2,0,45,85,5,0,96,56,0,0,0,0,0,0,80,162,2,0,62,85,5,0,72,41,0,0,0,0,0,0,80,162,2,0,131,85,5,0,96,56,0,0,0,0,0,0,80,162,2,0,148,85,5,0,72,41,0,0,0,0,0,0,80,162,2,0,217,85,5,0,96,56,0,0,0,0,0,0,80,162,2,0,234,85,5,0,72,41,0,0,0,0,0,0,80,162,2,0,47,86,5,0,96,56,0,0,0,0,0,0,80,162,2,0,198,86,5,0,72,41,0,0,0,0,0,0,80,162,2,0,34,87,5,0,104,56,0,0,0,0,0,0,80,162,2,0,54,87,5,0,72,41,0,0,0,0,0,0,80,162,2,0,126,87,5,0,104,56,0,0,0,0,0,0,80,162,2,0,146,87,5,0,72,41,0,0,0,0,0,0,80,162,2,0,218,87,5,0,104,56,0,0,0,0,0,0,80,162,2,0,238,87,5,0,72,41,0,0,0,0,0,0,80,162,2,0,54,88,5,0,104,56,0,0,0,0,0,0,80,162,2,0,74,88,5,0,72,41,0,0,0,0,0,0,80,162,2,0,146,88,5,0,104,56,0,0,0,0,0,0,80,162,2,0,166,88,5,0,72,41,0,0,0,0,0,0,80,162,2,0,238,88,5,0,104,56,0,0,0,0,0,0,80,162,2,0,2,89,5,0,72,41,0,0,0,0,0,0,80,162,2,0,74,89,5,0,104,56,0,0,0,0,0,0,80,162,2,0,94,89,5,0,72,41,0,0,0,0,0,0,80,162,2,0,166,89,5,0,104,56,0,0,0,0,0,0,80,162,2,0,186,89,5,0,72,41,0,0,0,0,0,0,80,162,2,0,2,90,5,0,104,56,0,0,0,0,0,0,80,162,2,0,22,90,5,0,72,41,0,0,0,0,0,0,80,162,2,0,94,90,5,0,104,56,0,0,0,0,0,0,80,162,2,0,114,90,5,0,72,41,0,0,0,0,0,0,80,162,2,0,186,90,5,0,104,56,0,0,0,0,0,0,80,162,2,0,225,90,5,0,72,41,0,0,0,0,0,0,80,162,2,0,41,91,5,0,96,56,0,0,0,0,0,0,80,162,2,0,61,91,5,0,72,41,0,0,0,0,0,0,80,162,2,0,133,91,5,0,96,56,0,0,0,0,0,0,80,162,2,0,153,91,5,0,72,41,0,0,0,0,0,0,80,162,2,0,225,91,5,0,96,56,0,0,0,0,0,0,80,162,2,0,245,91,5,0,72,41,0,0,0,0,0,0,80,162,2,0,61,92,5,0,96,56,0,0,0,0,0,0,80,162,2,0,81,92,5,0,72,41,0,0,0,0,0,0,80,162,2,0,153,92,5,0,96,56,0,0,0,0,0,0,80,162,2,0,202,94,5,0,104,49,0,0,0,0,0,0,80,162,2,0,237,94,5,0,104,49,0,0,0,0,0,0,80,162,2,0,52,103,5,0,104,49,0,0,0,0,0,0,80,162,2,0,20,113,5,0,72,41,0,0,0,0,0,0,80,162,2,0,90,113,5,0,72,41,0,0,0,0,0,0,80,162,2,0,160,113,5,0,72,41,0,0,0,0,0,0,80,162,2,0,231,113,5,0,72,41,0,0,0,0,0,0,80,162,2,0,45,114,5,0,72,41,0,0,0,0,0,0,80,162,2,0,115,114,5,0,72,41,0,0,0,0,0,0,80,162,2,0,191,114,5,0,72,41,0,0,0,0,0,0,80,162,2,0,11,115,5,0,72,41,0,0,0,0,0,0,80,162,2,0,82,115,5,0,72,41,0,0,0,0,0,0,80,162,2,0,153,115,5,0,72,41,0,0,0,0,0,0,80,162,2,0,223,115,5,0,72,41,0,0,0,0,0,0,80,162,2,0,37,116,5,0,72,41,0,0,0,0,0,0,80,162,2,0,107,116,5,0,72,41,0,0,0,0,0,0,80,162,2,0,64,118,5,0,168,74,0,0,0,0,0,0,80,162,2,0,114,118,5,0,176,74,0,0,0,0,0,0,80,162,2,0,150,118,5,0,168,74,0,0,0,0,0,0,80,162,2,0,131,119,5,0,176,74,0,0,0,0,0,0,80,162,2,0,61,121,5,0,168,74,0,0,0,0,0,0,80,162,2,0,112,121,5,0,176,74,0,0,0,0,0,0,80,162,2,0,3,122,5,0,168,74,0,0,0,0,0,0,80,162,2,0,102,122,5,0,176,74,0,0,0,0,0,0,80,162,2,0,130,122,5,0,168,74,0,0,0,0,0,0,196,162,2,0,120,122,5,0,80,162,2,0,226,122,5,0,176,74,0,0,0,0,0,0,80,162,2,0,244,122,5,0,168,74,0,0,0,0,0,0,80,162,2,0,47,123,5,0,176,74,0,0,0,0,0,0,80,162,2,0,106,123,5,0,176,74,0,0,0,0,0,0,40,162,2,0,230,123,5,0,196,162,2,0,125,123,5,0,40,162,2,0,249,123,5,0,80,162,2,0,12,124,5,0,72,74,0,0,0,0,0,0,80,162,2,0,32,124,5,0,96,74,0,0,0,0,0,0,80,162,2,0,52,124,5,0,88,74,0,0,0,0,0,0,80,162,2,0,72,124,5,0,128,74,0,0,0,0,0,0,40,162,2,0,239,125,5,0,40,162,2,0,18,126,5,0,40,162,2,0,154,126,5,0,80,162,2,0,178,126,5,0,72,41,0,0,0,0,0,0,80,162,2,0,241,132,5,0,144,24,0,0,0,0,0,0,80,162,2,0,231,128,5,0,104,49,0,0,0,0,0,0,80,162,2,0,7,133,5,0,72,41,0,0,0,0,0,0,80,162,2,0,78,134,5,0,208,76,0,0,0,0,0,0,80,162,2,0,123,134,5,0,0,33,0,0,0,0,0,0,40,162,2,0,142,134,5,0,80,162,2,0,3,139,5,0,72,41,0,0,0,0,0,0,80,162,2,0,169,140,5,0,24,75,0,0,0,0,0,0,80,162,2,0,193,140,5,0,72,41,0,0,0,0,0,0,80,162,2,0,61,147,5,0,200,17,0,0,0,0,0,0,0,0,0,0,0,0,176,60,80,162,2,0,77,147,5,0,176,40,0,0,0,0,0,0,80,162,2,0,127,147,5,0,72,41,0,0,0,0,0,0,80,162,2,0,202,147,5,0,72,41,0,0,0,0,0,0,40,162,2,0,19,148,5,0,80,162,2,0,171,148,5,0,152,75,0,0,0,0,0,0,80,162,2,0,192,148,5,0,72,41,0,0,0,0,0,0,80,162,2,0,59,149,5,0,152,75,0,0,0,0,0,0,80,162,2,0,13,149,5,0,104,49,0,0,0,0,0,0,80,162,2,0,206,149,5,0,48,30,0,0,0,0,0,0,80,162,2,0,194,153,5,0,176,33,0,0,0,0,0,0,80,162,2,0,227,153,5,0,72,41,0,0,0,0,0,0,80,162,2,0,56,154,5,0,72,41,0,0,0,0,0,0,80,162,2,0,241,156,5,0,120,26,0,0,0,0,0,0,80,162,2,0,122,155,5,0,104,49,0,0,0,0,0,0,80,162,2,0,21,157,5,0,72,41,0,0,0,0,0,0,80,162,2,0,8,158,5,0,208,76,0,0,0,0,0,0,80,162,2,0,55,158,5,0,72,24,0,0,0,0,0,0,80,162,2,0,136,158,5,0,72,41,0,0,0,0,0,0,80,162,2,0,46,160,5,0,72,41,0,0,0,0,0,0,80,162,2,0,142,160,5,0,160,76,0,0,0,0,0,0,80,162,2,0,166,160,5,0,176,40,0,0,0,0,0,0,80,162,2,0,243,167,5,0,192,20,0,0,0,0,0,0,80,162,2,0,126,164,5,0,104,49,0,0,0,0,0,0,80,162,2,0,50,174,5,0,88,24,0,0,0,0,0,0,80,162,2,0,185,173,5,0,72,41,0,0,0,0,0,0,80,162,2,0,71,174,5,0,72,41,0,0,0,0,0,0,40,162,2,0,162,194,5,0,80,162,2,0,178,192,5,0,152,49,0,0,0,0,0,0,40,162,2,0,170,178,5,0,80,162,2,0,175,179,5,0,104,77,0,0,0,0,0,0,80,162,2,0,49,179,5,0,64,77,0,0,0,0,0,0,40,162,2,0,80,179,5,0,80,162,2,0,104,179,5,0,48,77,0,0,0,0,0,0,80,162,2,0,141,179,5,0,48,77,0,0,0,0,0,0,40,162,2,0,207,179,5,0,80,162,2,0,134,180,5,0,104,77,0,0,0,0,0,0,80,162,2,0,117,186,5,0,104,77,0,0,0,0,0,0,80,162,2,0,185,183,5,0,64,77,0,0,0,0,0,0,80,162,2,0,72,185,5,0,104,77,0,0,0,0,0,0,80,162,2,0,21,186,5,0,104,77,0,0,0,0,0,0,80,162,2,0,57,186,5,0,104,49,0,0,0,0,0,0,80,162,2,0,206,186,5,0,104,77,0,0,0,0,0,0,80,162,2,0,49,187,5,0,104,77,0,0,0,0,0,0,80,162,2,0,15,187,5,0,64,77,0,0,0,0,0,0,80,162,2,0,91,187,5,0,104,77,0,0,0,0,0,0,80,162,2,0,242,187,5,0,104,77,0,0,0,0,0,0,80,162,2,0,15,188,5,0,48,78,0,0,0,0,0,0,40,162,2,0,47,188,5,0,80,162,2,0,78,188,5,0,48,78,0,0,0,0,0,0,80,162,2,0,6,189,5,0,48,78,0,0,0,0,0,0,80,162,2,0,130,188,5,0,48,78,0,0,0,0,0,0,80,162,2,0,166,188,5,0,48,78,0,0,0,0,0,0,80,162,2,0,202,188,5,0,104,49,0,0,0,0,0,0,80,162,2,0,45,189,5,0,48,78,0,0,0,0,0,0,80,162,2,0,84,189,5,0,48,78,0,0,0,0,0,0,80,162,2,0,126,189,5,0,48,78,0,0,0,0,0,0,80,162,2,0,162,189,5,0,48,78,0,0,0,0,0,0,80,162,2,0,224,191,5,0,16,79,0,0,0,0,0,0,80,162,2,0,191,190,5,0,232,78,0,0,0,0,0,0,40,162,2,0,222,190,5,0,80,162,2,0,246,190,5,0,216,78,0,0,0,0,0,0,80,162,2,0,27,191,5,0,216,78,0,0,0,0,0,0,40,162,2,0,6,192,5,0,80,162,2,0,43,192,5,0,16,79,0,0,0,0,0,0,80,162,2,0,101,192,5,0,16,79,0,0,0,0,0,0,80,162,2,0,143,192,5,0,16,79,0,0,0,0,0,0,80,162,2,0,50,195,5,0,128,79,0,0,0,0,0,0,168,162,2,0,180,194,5,0,0,0,0,0,104,79,0,0,168,162,2,0,223,194,5,0,0,0,0,0,120,79,0,0,40,162,2,0,9,195,5,0,80,162,2,0,125,195,5,0,152,39,0,0,0,0,0,0,80,162,2,0,75,196,5,0,200,79,0,0,0,0,0,0,168,162,2,0,205,195,5,0,0,0,0,0,176,79,0,0,168,162,2,0,248,195,5,0,0,0,0,0,192,79,0,0,40,162,2,0,34,196,5,0,80,162,2,0,150,196,5,0,152,39,0,0,0,0,0,0,80,162,2,0,230,196,5,0,232,79,0,0,0,0,0,0,80,162,2,0,12,197,5,0,152,39,0,0,0,0,0,0,40,162,2,0,180,197,5,0,80,162,2,0,57,197,5],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+10240);allocate([72,41,0,0,0,0,0,0,80,162,2,0,51,200,5,0,248,79,0,0,0,0,0,0,80,162,2,0,244,198,5,0,72,41,0,0,0,0,0,0,80,162,2,0,67,199,5,0,72,41,0,0,0,0,0,0,80,162,2,0,189,199,5,0,72,41,0,0,0,0,0,0,80,162,2,0,141,201,5,0,248,79,0,0,0,0,0,0,80,162,2,0,82,200,5,0,72,41,0,0,0,0,0,0,80,162,2,0,154,200,5,0,72,41,0,0,0,0,0,0,80,162,2,0,19,201,5,0,72,41,0,0,0,0,0,0,80,162,2,0,29,204,5,0,192,80,0,0,0,0,0,0,80,162,2,0,158,202,5,0,104,49,0,0,0,0,0,0,80,162,2,0,100,203,5,0,72,41,0,0,0,0,0,0,80,162,2,0,58,204,5,0,176,40,0,0,0,0,0,0,80,162,2,0,87,204,5,0,72,41,0,0,0,0,0,0,80,162,2,0,75,217,5,0,104,49,0,0,0,0,0,0,80,162,2,0,121,217,5,0,104,49,0,0,0,0,0,0,40,162,2,0,165,217,5,0,40,162,2,0,240,220,5,0,80,162,2,0,180,217,5,0,104,49,0,0,0,0,0,0,80,162,2,0,197,219,5,0,104,49,0,0,0,0,0,0,80,162,2,0,32,221,5,0,72,41,0,0,0,0,0,0,80,162,2,0,117,221,5,0,56,33,0,0,0,0,0,0,80,162,2,0,243,221,5,0,72,41,0,0,0,0,0,0,80,162,2,0,174,222,5,0,32,27,0,0,0,0,0,0,40,162,2,0,192,222,5,0,80,162,2,0,58,223,5,0,112,81,0,0,0,0,0,0,40,162,2,0,82,223,5,0,80,162,2,0,141,225,5,0,0,21,0,0,0,0,0,0,80,162,2,0,171,225,5,0,72,41,0,0,0,0,0,0,80,162,2,0,37,227,5,0,200,28,0,0,0,0,0,0,80,162,2,0,159,227,5,0,72,41,0,0,0,0,0,0,80,162,2,0,134,229,5,0,72,41,0,0,0,0,0,0,80,162,2,0,218,229,5,0,248,29,0,0,0,0,0,0,224,162,2,0,34,231,5,0,0,0,0,0,1,0,0,0,176,40,0,0,3,216,255,255,80,162,2,0,50,231,5,0,72,41,0,0,0,0,0,0,80,162,2,0,127,231,5,0,0,24,0,0,0,0,0,0,80,162,2,0,152,231,5,0,72,41,0,0,0,0,0,0,80,162,2,0,194,232,5,0,120,27,0,0,0,0,0,0,80,162,2,0,107,233,5,0,104,49,0,0,0,0,0,0,80,162,2,0,168,233,5,0,104,49,0,0,0,0,0,0,80,162,2,0,21,234,5,0,104,49,0,0,0,0,0,0,0,0,0,0,0,0,240,63,85,85,85,85,85,85,229,63,0,0,0,0,0,0,224,63,80,162,2,0,57,234,5,0,104,49,0,0,0,0,0,0,80,162,2,0,103,234,5,0,104,49,0,0,0,0,0,0,80,162,2,0,147,234,5,0,104,49,0,0,0,0,0,0,80,162,2,0,182,234,5,0,104,49,0,0,0,0,0,0,80,162,2,0,102,235,5,0,104,49,0,0,0,0,0,0,80,162,2,0,142,235,5,0,104,49,0,0,0,0,0,0,80,162,2,0,17,236,5,0,104,49,0,0,0,0,0,0,80,162,2,0,48,236,5,0,104,49,0,0,0,0,0,0,40,162,2,0,237,236,5,0,80,162,2,0,212,237,5,0,176,40,0,0,0,0,0,0,80,162,2,0,201,238,5,0,24,83,0,0,0,0,0,0,80,162,2,0,133,238,5,0,72,41,0,0,0,0,0,0,80,162,2,0,244,241,5,0,24,83,0,0,0,0,0,0,80,162,2,0,134,239,5,0,72,41,0,0,0,0,0,0,80,162,2,0,38,240,5,0,72,41,0,0,0,0,0,0,80,162,2,0,89,241,5,0,72,41,0,0,0,0,0,0,80,162,2,0,167,241,5,0,72,41,0,0,0,0,0,0,80,162,2,0,116,243,5,0,72,41,0,0,0,0,0,0,80,162,2,0,90,244,5,0,56,22,0,0,0,0,0,0,80,162,2,0,106,244,5,0,72,41,0,0,0,0,0,0,80,162,2,0,69,246,5,0,96,18,0,0,0,0,0,0,80,162,2,0,84,246,5,0,72,41,0,0,0,0,0,0,80,162,2,0,251,246,5,0,184,31,0,0,0,0,0,0,80,162,2,0,24,247,5,0,72,41,0,0,0,0,0,0,80,162,2,0,14,248,5,0,200,18,0,0,0,0,0,0,80,162,2,0,79,248,5,0,72,41,0,0,0,0,0,0,80,162,2,0,3,249,5,0,120,33,0,0,0,0,0,0,80,162,2,0,41,249,5,0,56,28,0,0,0,0,0,0,80,162,2,0,78,249,5,0,96,32,0,0,0,0,0,0,80,162,2,0,115,249,5,0,120,20,0,0,0,0,0,0,80,162,2,0,181,249,5,0,72,41,0,0,0,0,0,0,80,162,2,0,42,250,5,0,72,41,0,0,0,0,0,0,80,162,2,0,158,250,5,0,72,41,0,0,0,0,0,0,80,162,2,0,247,250,5,0,72,41,0,0,0,0,0,0,80,162,2,0,46,253,5,0,176,27,0,0,0,0,0,0,80,162,2,0,87,253,5,0,72,41,0,0,0,0,0,0,80,162,2,0,253,254,5,0,8,28,0,0,0,0,0,0,80,162,2,0,40,255,5,0,72,41,0,0,0,0,0,0,80,162,2,0,61,0,6,0,72,41,0,0,0,0,0,0,80,162,2,0,35,1,6,0,248,31,0,0,0,0,0,0,80,162,2,0,55,1,6,0,72,41,0,0,0,0,0,0,80,162,2,0,243,1,6,0,216,25,0,0,0,0,0,0,80,162,2,0,15,2,6,0,72,41,0,0,0,0,0,0,80,162,2,0,135,2,6,0,56,34,0,0,0,0,0,0,80,162,2,0,84,5,6,0,104,49,0,0,0,0,0,0,80,162,2,0,88,6,6,0,104,49,0,0,0,0,0,0,80,162,2,0,147,6,6,0,104,49,0,0,0,0,0,0,80,162,2,0,217,6,6,0,104,49,0,0,0,0,0,0,80,162,2,0,20,7,6,0,104,49,0,0,0,0,0,0,80,162,2,0,90,7,6,0,104,49,0,0,0,0,0,0,80,162,2,0,149,7,6,0,104,49,0,0,0,0,0,0,80,162,2,0,193,7,6,0,104,49,0,0,0,0,0,0,80,162,2,0,7,8,6,0,104,49,0,0,0,0,0,0,80,162,2,0,66,8,6,0,104,49,0,0,0,0,0,0,80,162,2,0,136,8,6,0,104,49,0,0,0,0,0,0,80,162,2,0,195,8,6,0,104,49,0,0,0,0,0,0,80,162,2,0,9,9,6,0,104,49,0,0,0,0,0,0,80,162,2,0,68,9,6,0,104,49,0,0,0,0,0,0,80,162,2,0,112,9,6,0,104,49,0,0,0,0,0,0,80,162,2,0,187,9,6,0,104,49,0,0,0,0,0,0,80,162,2,0,251,9,6,0,104,49,0,0,0,0,0,0,80,162,2,0,70,10,6,0,104,49,0,0,0,0,0,0,80,162,2,0,134,10,6,0,104,49,0,0,0,0,0,0,80,162,2,0,209,10,6,0,104,49,0,0,0,0,0,0,80,162,2,0,17,11,6,0,104,49,0,0,0,0,0,0,80,162,2,0,22,12,6,0,104,49,0,0,0,0,0,0,80,162,2,0,37,13,6,0,104,49,0,0,0,0,0,0,80,162,2,0,101,13,6,0,104,49,0,0,0,0,0,0,80,162,2,0,176,13,6,0,104,49,0,0,0,0,0,0,80,162,2,0,240,13,6,0,104,49,0,0,0,0,0,0,80,162,2,0,59,14,6,0,104,49,0,0,0,0,0,0,80,162,2,0,123,14,6,0,104,49,0,0,0,0,0,0,80,162,2,0,172,14,6,0,104,49,0,0,0,0,0,0,80,162,2,0,247,14,6,0,104,49,0,0,0,0,0,0,80,162,2,0,55,15,6,0,104,49,0,0,0,0,0,0,80,162,2,0,130,15,6,0,104,49,0,0,0,0,0,0,80,162,2,0,194,15,6,0,104,49,0,0,0,0,0,0,80,162,2,0,13,16,6,0,104,49,0,0,0,0,0,0,80,162,2,0,77,16,6,0,104,49,0,0,0,0,0,0,80,162,2,0,126,16,6,0,104,49,0,0,0,0,0,0,80,162,2,0,206,16,6,0,104,49,0,0,0,0,0,0,80,162,2,0,19,17,6,0,104,49,0,0,0,0,0,0,80,162,2,0,99,17,6,0,104,49,0,0,0,0,0,0,80,162,2,0,168,17,6,0,104,49,0,0,0,0,0,0,80,162,2,0,248,17,6,0,104,49,0,0,0,0,0,0,80,162,2,0,61,18,6,0,104,49,0,0,0,0,0,0,80,162,2,0,166,21,6,0,72,41,0,0,0,0,0,0,80,162,2,0,242,21,6,0,72,41,0,0,0,0,0,0,80,162,2,0,56,22,6,0,72,41,0,0,0,0,0,0,80,162,2,0,107,23,6,0,128,31,0,0,0,0,0,0,80,162,2,0,144,23,6,0,72,41,0,0,0,0,0,0,80,162,2,0,45,24,6,0,152,34,0,0,0,0,0,0,80,162,2,0,69,24,6,0,72,41,0,0,0,0,0,0,80,162,2,0,245,24,6,0,16,26,0,0,0,0,0,0,80,162,2,0,182,25,6,0,72,41,0,0,0,0,0,0,80,162,2,0,112,26,6,0,32,19,0,0,0,0,0,0,80,162,2,0,144,26,6,0,72,41,0,0,0,0,0,0,80,162,2,0,236,26,6,0,16,19,0,0,0,0,0,0,80,162,2,0,18,27,6,0,72,41,0,0,0,0,0,0,80,162,2,0,128,27,6,0,24,23,0,0,0,0,0,0,80,162,2,0,169,27,6,0,72,41,0,0,0,0,0,0,80,162,2,0,26,28,6,0,88,19,0,0,0,0,0,0,80,162,2,0,68,28,6,0,72,41,0,0,0,0,0,0,80,162,2,0,152,28,6,0,176,30,0,0,0,0,0,0,80,162,2,0,19,29,6,0,240,21,0,0,0,0,0,0,80,162,2,0,54,29,6,0,72,41,0,0,0,0,0,0,80,162,2,0,197,31,6,0,96,34,0,0,0,0,0,0,80,162,2,0,60,30,6,0,104,49,0,0,0,0,0,0,80,162,2,0,233,31,6,0,72,41,0,0,0,0,0,0,80,162,2,0,131,39,6,0,104,49,0,0,0,0,0,0,80,162,2,0,55,45,6,0,72,41,0,0,0,0,0,0,80,162,2,0,142,47,6,0,184,21,0,0,0,0,0,0,80,162,2,0,143,46,6,0,104,49,0,0,0,0,0,0,80,162,2,0,187,46,6,0,104,49,0,0,0,0,0,0,80,162,2,0,225,46,6,0,104,49,0,0,0,0,0,0,80,162,2,0,2,47,6,0,104,49,0,0,0,0,0,0,80,162,2,0,34,47,6,0,104,49,0,0,0,0,0,0,80,162,2,0,68,47,6,0,104,49,0,0,0,0,0,0,80,162,2,0,103,47,6,0,104,49,0,0,0,0,0,0,0,0,0,0,0,0,240,63,239,97,72,177,80,49,246,63,202,111,77,145,174,231,244,63,170,17,108,239,98,208,242,63,0,0,0,0,0,0,240,63,59,191,167,192,105,36,233,63,187,32,199,123,122,81,225,63,93,171,114,222,85,168,209,63,224,162,2,0,201,108,6,0,0,0,0,0,1,0,0,0,96,20,0,0,0,0,0,0,224,162,2,0,138,108,6,0,0,0,0,0,1,0,0,0,96,20,0,0,0,0,0,0,40,162,2,0,107,108,6,0,40,162,2,0,76,108,6,0,40,162,2,0,45,108,6,0,40,162,2,0,14,108,6,0,40,162,2,0,239,107,6,0,93,61,127,102,158,160,230,63,0,0,0,0,0,136,57,61,68,23,117,250,82,176,230,63,0,0,0,0,0,0,216,60,254,217,11,117,18,192,230,63,0,0,0,0,0,120,40,189,191,118,212,221,220,207,230,63,0,0,0,0,0,192,30,61,41,26,101,60,178,223,230,63,0,0,0,0,0,0,216,188,227,58,89,152,146,239,230,63,0,0,0,0,0,0,188,188,134,147,81,249,125,255,230,63,0,0,0,0,0,216,47,189,163,45,244,102,116,15,231,63,0,0,0,0,0,136,44,189,195,95,236,232,117,31,231,63,0,0,0,0,0,192,19,61,5,207,234,134,130,47,231,63,0,0,0,0,0,48,56,189,82,129,165,72,154,63,231,63,0,0,0,0,0,192,0,189,252,204,215,53,189,79,231,63,0,0,0,0,0,136,47,61,241,103,66,86,235,95,231,63,0,0,0,0,0,224,3,61,72,109,171,177,36,112,231,63,0,0,0,0,0,208,39,189,56,93,222,79,105,128,231,63,0,0,0,0,0,0,221,188,0,29,172,56,185,144,231,63,0,0,0,0,0,0,227,60,120,1,235,115,20,161,231,63,0,0,0,0,0,0,237,188,96,208,118,9,123,177,231,63,0,0,0,0,0,64,32,61,51,193,48,1,237,193,231,63,0,0,0,0,0,0,160,60,54,134,255,98,106,210,231,63,0,0,0,0,0,144,38,189,59,78,207,54,243,226,231,63,0,0,0,0,0,224,2,189,232,195,145,132,135,243,231,63,0,0,0,0,0,88,36,189,78,27,62,84,39,4,232,63,0,0,0,0,0,0,51,61,26,7,209,173,210,20,232,63,0,0,0,0,0,0,15,61,126,205,76,153,137,37,232,63,0,0,0,0,0,192,33,189,208,66,185,30,76,54,232,63,0,0,0,0,0,208,41,61,181,202,35,70,26,71,232,63,0,0,0,0,0,16,71,61,188,91,159,23,244,87,232,63,0,0,0,0,0,96,34,61,175,145,68,155,217,104,232,63,0,0,0,0,0,196,50,189,149,163,49,217,202,121,232,63,0,0,0,0,0,0,35,189,184,101,138,217,199,138,232,63,0,0,0,0,0,128,42,189,0,88,120,164,208,155,232,63,0,0,0,0,0,0,237,188,35,162,42,66,229,172,232,63,0,0,0,0,0,40,51,61,250,25,214,186,5,190,232,63,0,0,0,0,0,180,66,61,131,67,181,22,50,207,232,63,0,0,0,0,0,208,46,189,76,102,8,94,106,224,232,63,0,0,0,0,0,80,32,189,7,120,21,153,174,241,232,63,0,0,0,0,0,40,40,61,14,44,40,208,254,2,233,63,0,0,0,0,0,176,28,189,150,255,145,11,91,20,233,63,0,0,0,0,0,224,5,189,249,47,170,83,195,37,233,63,0,0,0,0,0,64,245,60,74,198,205,176,55,55,233,63,0,0,0,0,0,32,23,61,174,152,95,43,184,72,233,63,0,0,0,0,0,0,9,189,203,82,200,203,68,90,233,63,0,0,0,0,0,104,37,61,33,111,118,154,221,107,233,63,0,0,0,0,0,208,54,189,42,78,222,159,130,125,233,63,0,0,0,0,0,0,1,189,163,35,122,228,51,143,233,63,0,0,0,0,0,0,45,61,4,6,202,112,241,160,233,63,0,0,0,0,0,164,56,189,137,255,83,77,187,178,233,63,0,0,0,0,0,92,53,61,91,241,163,130,145,196,233,63,0,0,0,0,0,184,38,61,197,184,75,25,116,214,233,63,0,0,0,0,0,0,236,188,142,35,227,25,99,232,233,63,0,0,0,0,0,208,23,61,2,243,7,141,94,250,233,63,0,0,0,0,0,64,22,61,77,229,93,123,102,12,234,63,0,0,0,0,0,0,245,188,246,184,142,237,122,30,234,63,0,0,0,0,0,224,9,61,39,46,74,236,155,48,234,63,0,0,0,0,0,216,42,61,93,10,70,128,201,66,234,63,0,0,0,0,0,240,26,189,155,37,62,178,3,85,234,63,0,0,0,0,0,96,11,61,19,98,244,138,74,103,234,63,0,0,0,0,0,136,56,61,167,179,48,19,158,121,234,63,0,0,0,0,0,32,17,61,141,46,193,83,254,139,234,63,0,0,0,0,0,192,6,61,210,252,121,85,107,158,234,63,0,0,0,0,0,184,41,189,184,111,53,33,229,176,234,63,0,0,0,0,0,112,43,61,129,243,211,191,107,195,234,63,0,0,0,0,0,0,217,60,128,39,60,58,255,213,234,63,0,0,0,0,0,0,228,60,163,210,90,153,159,232,234,63,0,0,0,0,0,144,44,189,103,243,34,230,76,251,234,63,0,0,0,0,0,80,22,61,144,183,141,41,7,14,235,63,0,0,0,0,0,212,47,61,169,137,154,108,206,32,235,63,0,0,0,0,0,112,18,61,75,26,79,184,162,51,235,63,0,0,0,0,0,71,77,61,231,71,183,21,132,70,235,63,0,0,0,0,0,56,56,189,58,89,229,141,114,89,235,63,0,0,0,0,0,0,152,60,106,197,241,41,110,108,235,63,0,0,0,0,0,208,10,61,80,94,251,242,118,127,235,63,0,0,0,0,0,128,222,60,178,73,39,242,140,146,235,63,0,0,0,0,0,192,4,189,3,6,161,48,176,165,235,63,0,0,0,0,0,112,13,189,102,111,154,183,224,184,235,63,0,0,0,0,0,144,13,61,255,193,75,144,30,204,235,63,0,0,0,0,0,160,2,61,111,161,243,195,105,223,235,63,0,0,0,0,0,120,31,189,184,29,215,91,194,242,235,63,0,0,0,0,0,160,16,189,233,178,65,97,40,6,236,63,0,0,0,0,0,64,17,189,224,82,133,221,155,25,236,63,0,0,0,0,0,224,11,61,238,100,250,217,28,45,236,63,0,0,0,0,0,64,9,189,47,208,255,95,171,64,236,63,0,0,0,0,0,208,14,189,21,253,250,120,71,84,236,63,0,0,0,0,0,102,57,61,203,208,87,46,241,103,236,63,0,0,0,0,0,16,26,189,182,193,136,137,168,123,236,63,0,0,0,0,128,69,88,189,51,231,6,148,109,143,236,63,0,0,0,0,0,72,26,189,223,196,81,87,64,163,236,63,0,0,0,0,0,0,203,60,148,144,239,220,32,183,236,63,0,0,0,0,0,64,1,61,137,22,109,46,15,203,236,63,0,0,0,0,0,32,240,60,18,196,93,85,11,223,236,63,0,0,0,0,0,96,243,60,59,171,91,91,21,243,236,63,0,0,0,0,0,144,6,189,188,137,7,74,45,7,237,63,0,0,0,0,0,160,9,61,250,200,8,43,83,27,237,63,0,0,0,0,0,224,21,189,133,138,13,8,135,47,237,63,0,0,0,0,0,40,29,61,3,162,202,234,200,67,237,63,0,0,0,0,0,160,1,61,145,164,251,220,24,88,237,63,0,0,0,0,0,0,223,60,161,230,98,232,118,108,237,63,0,0,0,0,0,160,3,189,78,131,201,22,227,128,237,63,0,0,0,0,0,216,12,189,144,96,255,113,93,149,237,63,0,0,0,0,0,192,244,60,174,50,219,3,230,169,237,63,0,0,0,0,0,144,255,60,37,131,58,214,124,190,237,63,0,0,0,0,0,128,233,60,69,180,1,243,33,211,237,63,0,0,0,0,0,32,245,188,191,5,28,100,213,231,237,63,0,0,0,0,0,112,29,189,236,154,123,51,151,252,237,63,0,0,0,0,0,20,22,189,94,125,25,107,103,17,238,63,0,0,0,0,0,72,11,61,231,163,245,20,70,38,238,63,0,0,0,0,0,206,64,61,92,238,22,59,51,59,238,63,0,0,0,0,0,104,12,61,180,63,139,231,46,80,238,63,0,0,0,0,0,48,9,189,104,109,103,36,57,101,238,63,0,0,0,0,0,0,229,188,68,76,199,251,81,122,238,63,0,0,0,0,0,248,7,189,38,183,205,119,121,143,238,63,0,0,0,0,0,112,243,188,232,144,164,162,175,164,238,63,0,0,0,0,0,208,229,60,228,202,124,134,244,185,238,63,0,0,0,0,0,26,22,61,13,104,142,45,72,207,238,63,0,0,0,0,0,80,245,60,20,133,24,162,170,228,238,63,0,0,0,0,0,64,198,60,19,90,97,238,27,250,238,63,0,0,0,0,0,128,238,188,6,65,182,28,156,15,239,63,0,0,0,0,0,136,250,188,99,185,107,55,43,37,239,63,0,0,0,0,0,144,44,189,117,114,221,72,201,58,239,63,0,0,0,0,0,0,170,60,36,69,110,91,118,80,239,63,0,0,0,0,0,240,244,188,253,68,136,121,50,102,239,63,0,0,0,0,0,128,202,60,56,190,156,173,253,123,239,63,0,0,0,0,0,188,250,60,130,60,36,2,216,145,239,63,0,0,0,0,0,96,212,188,142,144,158,129,193,167,239,63,0,0,0,0,0,12,11,189,17,213,146,54,186,189,239,63,0,0,0,0,0,224,192,188,148,113,143,43,194,211,239,63,0,0,0,0,128,222,16,189,238,35,42,107,217,233,239,63,0,0,0,0,0,67,238,60,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,190,188,90,250,26,11,240,63,0,0,0,0,0,64,179,188,3,51,251,169,61,22,240,63,0,0,0,0,0,23,18,189,130,2,59,20,104,33,240,63,0,0,0,0,0,64,186,60,108,128,119,62,154,44,240,63,0,0,0,0,0,152,239,60,202,187,17,46,212,55,240,63,0,0,0,0,0,64,199,188,137,127,110,232,21,67,240,63,0,0,0,0,0,48,216,60,103,84,246,114,95,78,240,63,0,0,0,0,0,63,26,189,90,133,21,211,176,89,240,63,0,0,0,0,0,132,2,189,149,31,60,14,10,101,240,63,0,0,0,0,0,96,241,60,26,247,221,41,107,112,240,63,0,0,0,0,0,36,21,61,45,168,114,43,212,123,240,63,0,0,0,0,0,160,233,188,208,155,117,24,69,135,240,63,0,0,0,0,0,64,230,60,200,7,102,246,189,146,240,63,0,0,0,0,0,120,0,189,131,243,198,202,62,158,240,63,0,0,0,0,0,0,152,188,48,57,31,155,199,169,240,63,0,0,0,0,0,160,255,60,252,136,249,108,88,181,240,63,0,0,0,0,0,200,250,188,138,108,228,69,241,192,240,63,0,0,0,0,0,192,217,60,22,72,114,43,146,204,240,63,0,0,0,0,0,32,5,61,216,93,57,35,59,216,240,63,0,0,0,0,0,208,250,188,243,209,211,50,236,227,240,63,0,0,0,0,0,172,27,61,166,169,223,95,165,239,240,63,0,0,0,0,0,232,4,189,240,210,254,175,102,251,240,63,0,0,0,0,0,48,13,189,75,35,215,40,48,7,241,63,0,0,0,0,0,80,241,60,91,91,18,208,1,19,241,63,0,0,0,0,0,0,236,60,249,42,94,171,219,30,241,63,0,0,0,0,0,188,22,61,213,49,108,192,189,42,241,63,0,0,0,0,0,64,232,60,125,4,242,20,168,54,241,63,0,0,0,0,0,208,14,189,233,45,169,174,154,66,241,63,0,0,0,0,0,224,232,60,56,49,79,147,149,78,241,63,0,0,0,0,0,64,235,60,113,142,165,200,152,90,241,63,0,0,0,0,0,48,5,61,223,195,113,84,164,102,241,63,0,0,0,0,0,56,3,61,17,82,125,60,184,114,241,63,0,0,0,0,0,212,40,61,159,187,149,134,212,126,241,63,0,0,0,0,0,208,5,189,147,141,140,56,249,138,241,63,0,0,0,0,0,136,28,189,102,93,55,88,38,151,241,63,0,0,0,0,0,240,17,61,167,203,111,235,91,163,241,63,0,0,0,0,0,72,16,61,227,135,19,248,153,175,241,63,0,0,0,0,0,57,71,189,84,93,4,132,224,187,241,63,0,0,0,0,0,228,36,61,67,28,40,149,47,200,241,63,0,0,0,0,0,32,10,189,178,185,104,49,135,212,241,63,0,0,0,0,0,128,227,60,49,64,180,94,231,224,241,63,0,0,0,0,0,192,234,60,56,217,252,34,80,237,241,63,0,0,0,0,0,144,1,61,247,205,56,132,193,249,241,63,0,0,0,0,0,120,27,189,143,141,98,136,59,6,242,63,0,0,0,0,0,148,45,61,30,168,120,53,190,18,242,63,0,0,0,0,0,0,216,60,65,221,125,145,73,31,242,63,0,0,0,0,0,52,43,61,35,19,121,162,221,43,242,63,0,0,0,0,0,248,25,61,231,97,117,110,122,56,242,63,0,0,0,0,0,200,25,189,39,20,130,251,31,69,242,63,0,0,0,0,0,48,2,61,2,166,178,79,206,81,242,63,0,0,0,0,0,72,19,189,176,206,30,113,133,94,242,63,0,0,0,0,0,112,18,61,22,125,226,101,69,107,242,63,0,0,0,0,0,208,17,61,15,224,29,52,14,120,242,63,0,0,0,0,0,238,49,61,62,99,245,225,223,132,242,63,0,0,0,0,0,192,20,189,48,187,145,117,186,145,242,63,0,0,0,0,0,216,19,189,9,223,31,245,157,158,242,63,0,0,0,0,0,176,8,61,155,14,209,102,138,171,242,63,0,0,0,0,0,124,34,189,58,218,218,208,127,184,242,63,0,0,0,0,0,52,42,61,249,26,119,57,126,197,242,63,0,0,0,0,0,128,16,189,217,2,228,166,133,210,242,63,0,0,0,0,0,208,14,189,121,21,100,31,150,223,242,63,0,0,0,0,0,32,244,188,207,46,62,169,175,236,242,63,0,0,0,0,0,152,36,189,34,136,189,74,210,249,242,63,0,0,0,0,0,48,22,189,37,182,49,10,254,6,243,63,0,0,0,0,0,54,50,189,11,165,238,237,50,20,243,63,0,0,0,0,128,223,112,189,184,215,76,252,112,33,243,63,0,0,0,0,0,72,34,189,162,233,168,59,184,46,243,63,0,0,0,0,0,152,37,189,102,23,100,178,8,60,243,63,0,0,0,0,0,208,30,61,39,250,227,102,98,73,243,63,0,0,0,0,0,0,220,188,15,159,146,95,197,86,243,63,0,0,0,0,0,216,48,189,185,136,222,162,49,100,243,63,0,0,0,0,0,200,34,61,57,170,58,55,167,113,243,63,0,0,0,0,0,96,32,61,254,116,30,35,38,127,243,63,0,0,0,0,0,96,22,189,56,216,5,109,174,140,243,63,0,0,0,0,0,224,10,189,195,62,113,27,64,154,243,63,0,0,0,0,0,114,68,189,32,160,229,52,219,167,243,63,0,0,0,0,0,32,8,61,149,110,236,191,127,181,243,63,0,0,0,0,0,128,62,61,242,168,19,195,45,195,243,63,0,0,0,0,0,128,239,60,34,225,237,68,229,208,243,63,0,0,0,0,0,160,23,189,187,52,18,76,166,222,243,63,0,0,0,0,0,48,38,61,204,78,28,223,112,236,243,63,0,0,0,0,0,166,72,189,140,126,172,4,69,250,243,63,0,0,0,0,0,220,60,189,187,160,103,195,34,8,244,63,0,0,0,0,0,184,37,61,149,46,247,33,10,22,244,63,0,0,0,0,0,192,30,61,70,70,9,39,251,35,244,63,0,0,0,0,0,96,19,189,32,169,80,217,245,49,244,63,0,0,0,0,0,152,35,61,235,185,132,63,250,63,244,63,0,0,0,0,0,0,250,60,25,137,97,96,8,78,244,63,0,0,0,0,0,192,246,188,1,210,167,66,32,92,244,63,0,0,0,0,0,192,11,189,22,0,29,237,65,106,244,63,0,0,0,0,0,128,18,189,38,51,139,102,109,120,244,63,0,0,0,0,0,224,48,61,0,60,193,181,162,134,244,63,0,0,0,0,0,64,45,189,4,175,146,225,225,148,244,63,0,0,0,0,0,32,12,61,114,211,215,240,42,163,244,63,0,0,0,0,0,80,30,189,1,184,109,234,125,177,244,63,0,0,0,0,0,128,7,61,225,41,54,213,218,191,244,63,0,0,0,0,0,128,19,189,50,193,23,184,65,206,244,63,0,0,0,0,0,128,0,61,219,221,253,153,178,220,244,63,0,0,0,0,0,112,44,61,150,171,216,129,45,235,244,63,0,0,0,0,0,224,28,189,2,45,157,118,178,249,244,63,0,0,0,0,0,32,25,61,193,49,69,127,65,8,245,63,0,0,0,0,0,192,8,189,42,102,207,162,218,22,245,63,0,0,0,0,0,0,250,188,234,81,63,232,125,37,245,63,0,0,0,0,0,8,74,61,218,78,157,86,43,52,245,63,0,0,0,0,0,216,38,189,26,172,246,244,226,66,245,63,0,0,0,0,0,68,50,189,219,148,93,202,164,81,245,63,0,0,0,0,0,60,72,61,107,17,233,221,112,96,245,63,0,0,0,0,0,176,36,61,222,41,181,54,71,111,245,63,0,0,0,0,0,90,65,61,14,196,226,219,39,126,245,63,0,0,0,0,0,224,41,189,111,199,151,212,18,141,245,63,0,0,0,0,0,8,35,189,76,11,255,39,8,156,245,63,0,0,0,0,0,236,77,61,39,84,72,221,7,171,245,63,0,0,0,0,0,0,196,188,244,122,168,251,17,186,245,63,0,0,0,0,0,8,48,61,11,70,89,138,38,201,245,63,0,0,0,0,0,200,38,189,63,142,153,144,69,216,245,63,0,0,0,0,0,154,70,61,225,32,173,21,111,231,245,63,0,0,0,0,0,64,27,189,202,235,220,32,163,246,245,63,0,0,0,0,0,112,23,61,184,220,118,185,225,5,246,63,0,0,0,0,0,248,38,61,21,247,205,230,42,21,246,63,0,0,0,0,0,0,1,61,49,85,58,176,126,36,246,63,0,0,0,0,0,208,21,189,181,41,25,29,221,51,246,63,0,0,0,0,0,208,18,189,19,195,204,52,70,67,246,63,0,0,0,0,0,128,234,188,250,142,188,254,185,82,246,63,0,0,0,0,0,96,40,189,151,51,85,130,56,98,246,63,0,0,0,0,0,254,113,61,142,50,8,199,193,113,246,63,0,0,0,0,0,32,55,189,126,169,76,212,85,129,246,63,0,0,0,0,0,128,230,60,113,148,158,177,244,144,246,63,0,0,0,0,0,120,41,189,205,59,127,102,158,160,230,63,135,1,235,115,20,161,231,63,219,160,42,66,229,172,232,63,144,240,163,130,145,196,233,63,173,211,90,153,159,232,234,63,156,82,133,221,155,25,236,63,135,164,251,220,24,88,237,63,218,144,164,162,175,164,238,63,0,0,0,0,0,0,240,63,15,137,249,108,88,181,240,63,123,81,125,60,184,114,241,63,56,98,117,110,122,56,242,63,21,183,49,10,254,6,243,63,34,52,18,76,166,222,243,63,39,42,54,213,218,191,244,63,41,84,72,221,7,171,245,63,80,162,2,0,198,119,6,0,32,107,0,0,0,0,0,0,40,162,2,0,180,119,6,0,80,162,2,0,240,119,6,0,32,107,0,0,0,0,0,0,40,162,2,0,26,120,6,0,40,162,2,0,75,120,6,0,224,162,2,0,124,120,6,0,0,0,0,0,1,0,0,0,16,107,0,0,3,244,255,255,224,162,2,0,171,120,6,0,0,0,0,0,1,0,0,0,40,107,0,0,3,244,255,255,224,162,2,0,218,120,6,0,0,0,0,0,1,0,0,0,16,107,0,0,3,244,255,255,224,162,2,0,9,121,6,0,0,0,0,0,1,0,0,0,40,107,0,0,3,244,255,255,80,162,2,0,56,121,6,0,64,107,0,0,0,0,0,0,80,162,2,0,81,121,6,0,56,107,0,0,0,0,0,0,80,162,2,0,106,121,6,0,64,107,0,0,0,0,0,0,80,162,2,0,130,121,6,0,56,107,0,0,0,0,0,0,80,162,2,0,154,121,6,0,248,107,0,0,0,0,0,0,80,162,2,0,174,121,6,0,72,112,0,0,0,0,0,0,80,162,2,0,196,121,6,0,248,107,0,0,0,0,0,0,224,162,2,0,254,121,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,56,108,0,0,0,0,0,0,224,162,2,0,66,122,6,0,0,0,0,0,1,0,0,0,80,108,0,0,0,0,0,0,40,162,2,0,88,122,6,0,224,162,2,0,113,122,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,120,108,0,0,0,0,0,0,224,162,2,0,181,122,6,0,0,0,0,0,1,0,0,0,80,108,0,0,0,0,0,0,224,162,2,0,222,122,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,176,108,0,0,0,0,0,0,224,162,2,0,34,123,6,0,0,0,0,0,1,0,0,0,200,108,0,0,0,0,0,0,40,162,2,0,56,123,6,0,224,162,2,0,81,123,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,240,108,0,0,0,0,0,0,224,162,2,0,149,123,6,0,0,0,0,0,1,0,0,0,200,108,0,0,0,0,0,0,224,162,2,0,217,124,6,0,0,0,0,0,3,0,0,0,248,107,0,0,2,0,0,0,48,109,0,0,2,0,0,0,56,109,0,0,0,8,0,0,40,162,2,0,64,125,6,0,40,162,2,0,30,125,6,0,224,162,2,0,83,125,6,0,0,0,0,0,3,0,0,0,248,107,0,0,2,0,0,0,48,109,0,0,2,0,0,0,104,109,0,0,0,8,0,0,40,162,2,0,152,125,6,0,224,162,2,0,186,125,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,144,109,0,0,0,8,0,0,40,162,2,0,255,125,6,0,224,162,2,0,20,126,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,144,109,0,0,0,8,0,0,224,162,2,0,89,126,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,216,109,0,0,2,0,0,0,40,162,2,0,117,126,6,0,224,162,2,0,138,126,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,216,109,0,0,2,0,0,0,224,162,2,0,166,126,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,216,109,0,0,2,0,0,0,224,162,2,0,194,126,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,216,109,0,0,2,0,0,0,224,162,2,0,237,126,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,96,110,0,0,0,0,0,0,40,162,2,0,51,127,6,0,224,162,2,0,87,127,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,136,110,0,0,0,0,0,0,40,162,2,0,157,127,6,0,224,162,2,0,188,127,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,176,110,0,0,0,0,0,0,40,162,2,0,2,128,6,0,224,162,2,0,27,128,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,216,110,0,0,0,0,0,0,40,162,2,0,97,128,6,0,224,162,2,0,122,128,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,0,111,0,0,2,0,0,0,40,162,2,0,143,128,6,0,224,162,2,0,38,129,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,0,111,0,0,2,0,0,0,80,162,2,0,167,128,6,0,56,111,0,0,0,0,0,0,224,162,2,0,202,128,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,88,111,0,0,2,0,0,0,40,162,2,0,237,128,6,0,80,162,2,0,4,129,6,0,56,111,0,0,0,0,0,0,224,162,2,0,59,129,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,88,111,0,0,2,0,0,0,224,162,2,0,93,129,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,88,111,0,0,2,0,0,0,224,162,2,0,127,129,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,88,111,0,0,2,0,0,0,80,162,2,0,162,129,6,0,248,107,0,0,0,0,0,0,224,162,2,0,184,129,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,0,112,0,0,2,0,0,0,40,162,2,0,202,129,6,0,224,162,2,0,223,129,6,0,0,0,0,0,2,0,0,0,248,107,0,0,2,0,0,0,0,112,0,0,2,0,0,0,80,162,2,0,252,129,6,0,248,107,0,0,0,0,0,0,80,162,2,0,17,130,6,0,248,107,0,0,0,0,0,0,40,162,2,0,183,130,6,0,40,162,2,0,93,132,6,0,80,162,2,0,189,132,6,0,104,112,0,0,0,0,0,0,80,162,2,0,106,132,6,0,120,112,0,0,0,0,0,0,40,162,2,0,139,132,6,0,80,162,2,0,152,132,6,0,88,112,0,0,0,0,0,0,80,162,2,0,174,133,6,0,80,112,0,0,0,0,0,0,80,162,2,0,223,133,6,0,104,112,0,0,0,0,0,0,80,162,2,0,187,133,6,0,160,112,0,0,0,0,0,0,80,162,2,0,1,134,6,0,104,112,0,0,0,0,0,0,140,162,2,0,41,134,6,0,140,162,2,0,43,134,6,0,140,162,2,0,46,134,6,0,140,162,2,0,239,156,5,0,168,162,2,0,48,134,6,0,1,0,0,0,232,112,0,0,140,162,2,0,52,134,6,0,140,162,2,0,54,134,6,0,140,162,2,0,56,134,6,0,140,162,2,0,236,28,3,0,140,162,2,0,58,134,6,0,168,162,2,0,60,134,6,0,0,0,0,0,32,113,0,0,140,162,2,0,63,134,6,0,140,162,2,0,220,122,6,0,140,162,2,0,65,134,6,0,140,162,2,0,146,24,5,0,168,162,2,0,67,134,6,0,0,0,0,0,80,113,0,0,140,162,2,0,70,134,6,0,80,162,2,0,72,134,6,0,104,112,0,0,0,0,0,0,80,162,2,0,105,134,6,0,88,112,0,0,0,0,0,0,224,112,0,0,200,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,192,17,0,0,208,112,0,0,200,17,0,0,224,17,0,0,32,113,0,0,232,17,0,0,248,17,0,0,200,17,0,0,216,17,0,0,216,17,0,0,224,112,0,0,200,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,200,17,0,0,32,113,0,0,216,17,0,0,232,17,0,0,208,112,0,0,200,17,0,0,16,18,0,0,224,17,0,0,232,17,0,0,224,112,0,0,200,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,96,18,0,0,104,113,0,0,104,113,0,0,112,18,0,0,88,18,0,0,32,113,0,0,80,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,96,18,0,0,32,113,0,0,32,113,0,0,112,18,0,0,32,113,0,0,144,18,0,0,208,112,0,0,160,18,0,0,208,112,0,0,112,81,0,0,216,17,0,0,216,17,0,0,112,81,0,0,216,17,0,0,216,17,0,0,112,81,0,0,16,18,0,0,144,18,0,0,80,113,0,0,184,18,0,0,32,113,0,0,184,18,0,0,176,18,0,0,32,113,0,0,80,113,0,0,208,112,0,0,200,18,0,0,80,113,0,0,208,112,0,0,200,18,0,0,32,113,0,0,248,18,0,0,80,113,0,0,80,113,0,0,80,113,0,0,80,113,0,0,0,19,0,0,208,112,0,0,16,19,0,0,80,113,0,0,64,19,0,0,80,113,0,0,80,113,0,0,80,113,0,0,80,113,0,0,80,113,0,0,72,19,0,0,208,112,0,0,88,19,0,0,80,113,0,0,208,112,0,0,120,19,0,0,216,17,0,0,128,19,0,0,104,113,0,0,32,113,0,0,32,113,0,0,152,19,0,0,152,19,0,0,152,19,0,0,184,19,0,0,208,112,0,0,120,19,0,0,216,17,0,0,128,19,0,0,200,19,0,0,224,19,0,0,104,113,0,0,32,113,0,0,32,113,0,0,152,19,0,0,152,19,0,0,224,112,0,0,40,20,0,0,56,20,0,0,40,20,0,0,224,112,0,0,184,19,0,0,208,112,0,0,120,19,0,0,216,17,0,0,128,19,0,0,200,19,0,0,104,113,0,0,32,113,0,0,32,113,0,0,152,19,0,0,152,19,0,0,224,112,0,0,120,19,0,0,64,20,0,0,224,112,0,0,120,19,0,0,72,20,0,0,72,20,0,0,32,113,0,0,184,19,0,0,224,112,0,0,120,19,0,0,72,20,0,0,216,17,0,0,176,20,0,0,208,112,0,0,192,20,0,0,216,17,0,0,104,113,0,0,192,20,0,0,32,113,0,0,216,17,0,0,216,17,0,0,224,17,0,0,176,20,0,0,208,112,0,0,192,20,0,0,224,17,0,0,32,113,0,0,176,20,0,0,168,20,0,0,208,112,0,0,192,20,0,0,32,113,0,0,208,112,0,0,192,20,0,0,104,113,0,0,104,113,0,0,176,20,0,0,224,20,0,0,232,20,0,0,72,21,0,0,208,112,0,0,112,21,0,0,216,17,0,0,216,17,0,0,104,113,0,0,128,21,0,0,152,19,0,0,128,21,0,0,208,112,0,0,112,21,0,0,104,113,0,0,208,112,0,0,144,21,0,0,104,21,0,0,104,113,0,0,152,19,0,0,208,112,0,0,112,21,0,0,152,19,0,0,160,21,0,0,208,112,0,0,240,21,0,0,32,113,0,0,208,112,0,0,240,21,0,0,104,113,0,0,104,113,0,0,16,22,0,0,208,112,0,0,240,21,0,0,224,112,0,0,232,21,0,0,32,113,0,0,104,113,0,0,224,112,0,0,32,113,0,0,16,22,0,0,224,112,0,0,16,22,0,0,208,112,0,0,56,22,0,0,216,17,0,0,72,22,0,0,128,19,0,0,208,112,0,0,56,22,0,0,224,112,0,0,48,22,0,0,32,113,0,0,32,113,0,0,32,113,0,0,104,113,0,0,104,113,0,0,32,113,0,0,104,113,0,0,104,113,0,0,32,113,0,0,32,113,0,0,120,22,0,0,208,112,0,0,56,22,0,0,32,113,0,0,224,112,0,0,120,22,0,0,216,17,0,0,24,75,0,0,32,113,0,0,224,112,0,0,224,112,0,0,208,112,0,0,160,22,0,0,216,17,0,0,24,75,0,0,216,17,0,0,216,17,0,0,32,113,0,0,24,75,0,0,32,113,0,0,208,112,0,0,24,75,0,0,216,17,0,0,32,113,0,0,88,113,0,0,152,22,0,0,216,17,0,0,32,113,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,176,22,0,0,208,112,0,0,24,75,0,0,32,113,0,0,216,17,0,0,88,113,0,0,208,112,0,0,24,75,0,0,104,113,0,0,224,112,0,0,216,17,0,0,176,22,0,0,208,112,0,0,24,75,0,0,32,113,0,0,224,112,0,0,224,22,0,0,32,113,0,0,224,112,0,0,0,23,0,0,80,113,0,0,80,113,0,0,80,113,0,0,80,113,0,0,80,113,0,0,80,113,0,0,8,23,0,0,208,112,0,0,24,23,0,0,80,113,0,0,56,23,0,0,32,113,0,0,32,113,0,0,32,113,0,0,80,113,0,0,56,23,0,0,32,113,0,0,32,113,0,0,80,113,0,0,56,23,0,0,224,112,0,0,104,23,0,0,16,18,0,0,104,23,0,0,208,112,0,0,24,83,0,0,216,17,0,0,120,23,0,0,16,18,0,0,208,112,0,0,24,83,0,0,216,17,0,0,216,17,0,0,120,23,0,0,216,17,0,0,208,112,0,0,24,83,0,0,16,18,0,0,208,112,0,0,24,83,0,0,216,17,0,0,168,23,0,0,32,113,0,0,16,18,0,0,224,112,0,0,208,112,0,0,24,83,0,0,216,17,0,0,216,17,0,0,168,23,0,0,32,113,0,0,216,17,0,0,224,112,0,0,208,112,0,0,216,23,0,0,96,23,0,0,72,20,0,0,224,112,0,0,240,23,0,0,208,112,0,0,0,24,0,0,104,113,0,0,232,23,0,0,32,113,0,0,104,113,0,0,104,113,0,0,32,113,0,0,224,112,0,0,104,113,0,0,208,112,0,0,0,24,0,0,32,113,0,0,208,112,0,0,0,24,0,0,224,112,0,0,104,113,0,0,240,23,0,0,32,113,0,0,240,23,0,0,80,113,0,0,216,18,0,0,216,17,0,0,216,17,0,0,208,112,0,0,72,24,0,0,32,113,0,0,32,113,0,0,104,24,0,0,208,112,0,0,72,24,0,0,224,17,0,0,216,17,0,0,104,24,0,0,208,112,0,0,72,24,0,0,224,112,0,0,64,24,0,0,224,112,0,0,104,24,0,0,224,17,0,0,104,24,0,0,216,17,0,0,144,24,0,0,32,113,0,0,224,17,0,0,160,24,0,0,216,17,0,0,160,24,0,0,208,112,0,0,144,24,0,0,216,17,0,0,208,112,0,0,144,24,0,0,224,17,0,0,136,24],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+20480);allocate([208,112,0,0,144,24,0,0,32,113,0,0,104,113,0,0,104,113,0,0,208,112,0,0,144,24,0,0,104,113,0,0,104,113,0,0,160,24,0,0,32,113,0,0,160,24,0,0,80,113,0,0,192,24,0,0,216,17,0,0,216,17,0,0,208,112,0,0,192,24,0,0,216,17,0,0,216,17,0,0,120,23,0,0,208,112,0,0,192,24,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,208,24,0,0,208,112,0,0,176,40,0,0,72,20,0,0,208,112,0,0,24,25,0,0,72,20,0,0,176,40,0,0,208,112,0,0,56,25,0,0,16,18,0,0,16,18,0,0,216,17,0,0,216,17,0,0,32,113,0,0,104,25,0,0,216,17,0,0,104,25,0,0,120,25,0,0,136,25,0,0,96,23,0,0,208,112,0,0,136,81,0,0,216,17,0,0,144,25,0,0,216,17,0,0,208,112,0,0,136,81,0,0,216,17,0,0,80,113,0,0,200,25,0,0,208,112,0,0,216,25,0,0,32,113,0,0,208,112,0,0,216,25,0,0,80,113,0,0,32,113,0,0,200,25,0,0,192,25,0,0,32,113,0,0,80,113,0,0,224,112,0,0,224,112,0,0,200,25,0,0,208,112,0,0,216,25,0,0,224,112,0,0,8,26,0,0,208,112,0,0,16,26,0,0,16,18,0,0,216,17,0,0,216,17,0,0,208,112,0,0,16,26,0,0,16,18,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,32,26,0,0,16,18,0,0,216,17,0,0,216,17,0,0,216,17,0,0,112,26,0,0,80,113,0,0,120,26,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,208,112,0,0,0,77,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,168,26,0,0,208,112,0,0,0,77,0,0,72,20,0,0,208,112,0,0,192,26,0,0,208,26,0,0,216,26,0,0,208,112,0,0,0,77,0,0,216,17,0,0,184,26,0,0,208,26,0,0,232,26,0,0,216,26,0,0,32,113,0,0,0,77,0,0,216,17,0,0,216,17,0,0,216,17,0,0,104,113,0,0,32,113,0,0,168,26,0,0,192,26,0,0,240,26,0,0,184,26,0,0,208,26,0,0,192,26,0,0,224,112,0,0,0,77,0,0,216,17,0,0,72,20,0,0,224,112,0,0,248,26,0,0,208,112,0,0,240,81,0,0,216,17,0,0,216,17,0,0,144,25,0,0,216,17,0,0,224,112,0,0,32,113,0,0,248,26,0,0,208,112,0,0,240,81,0,0,216,17,0,0,144,25,0,0,216,17,0,0,208,112,0,0,240,81,0,0,216,17,0,0,144,25,0,0,216,17,0,0,208,112,0,0,32,27,0,0,104,113,0,0,24,27,0,0,32,113,0,0,32,113,0,0,32,113,0,0,80,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,104,113,0,0,48,27,0,0,32,113,0,0,48,27,0,0,208,112,0,0,32,27,0,0,32,113,0,0,208,112,0,0,232,25,0,0,16,18,0,0,216,17,0,0,216,17,0,0,208,112,0,0,120,27,0,0,104,113,0,0,104,113,0,0,136,27,0,0,112,27,0,0,224,112,0,0,224,112,0,0,80,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,224,112,0,0,136,27,0,0,32,113,0,0,136,27,0,0,208,112,0,0,120,27,0,0,32,113,0,0,208,112,0,0,120,27,0,0,224,112,0,0,208,112,0,0,176,27,0,0,216,17,0,0,216,17,0,0,168,27,0,0,32,113,0,0,32,113,0,0,80,113,0,0,80,113,0,0,32,113,0,0,192,27,0,0,200,27,0,0,208,112,0,0,176,27,0,0,216,17,0,0,216,17,0,0,224,112,0,0,208,27,0,0,208,112,0,0,176,27,0,0,192,27,0,0,208,112,0,0,176,27,0,0,224,112,0,0,208,112,0,0,176,27,0,0,80,113,0,0,32,113,0,0,208,27,0,0,208,112,0,0,176,27,0,0,200,27,0,0,200,27,0,0,208,27,0,0,192,27,0,0,208,27,0,0,208,112,0,0,176,27,0,0,32,113,0,0,80,113,0,0,208,27,0,0,104,113,0,0,248,27,0,0,240,27,0,0,104,113,0,0,208,112,0,0,8,28,0,0,104,113,0,0,32,113,0,0,40,28,0,0,208,112,0,0,56,28,0,0,32,113,0,0,88,28,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,88,28,0,0,216,17,0,0,104,28,0,0,216,17,0,0,128,28,0,0,136,28,0,0,200,19,0,0,80,113,0,0,80,113,0,0,200,19,0,0,128,28,0,0,32,113,0,0,32,113,0,0,80,113,0,0,32,113,0,0,232,28,0,0,240,28,0,0,248,28,0,0,208,112,0,0,232,28,0,0,200,19,0,0,8,29,0,0,32,29,0,0,240,28,0,0,232,28,0,0,32,113,0,0,40,113,0,0,208,112,0,0,232,28,0,0,104,29,0,0,32,113,0,0,232,28,0,0,32,113,0,0,208,112,0,0,232,28,0,0,152,29,0,0,200,29,0,0,216,29,0,0,200,29,0,0,208,112,0,0,232,28,0,0,216,29,0,0,32,113,0,0,232,28,0,0,32,113,0,0,32,113,0,0,32,113,0,0,232,28,0,0,32,113,0,0,248,28,0,0,208,112,0,0,232,28,0,0,32,29,0,0,32,113,0,0,232,28,0,0,240,28,0,0,208,112,0,0,248,29,0,0,32,113,0,0,208,112,0,0,248,29,0,0,224,112,0,0,240,29,0,0,32,113,0,0,224,112,0,0,32,113,0,0,32,113,0,0,8,30,0,0,224,112,0,0,8,30,0,0,80,113,0,0,48,30,0,0,216,17,0,0,32,113,0,0,216,17,0,0,216,17,0,0,216,17,0,0,40,30,0,0,32,113,0,0,64,30,0,0,208,112,0,0,48,30,0,0,32,113,0,0,224,112,0,0,64,30,0,0,208,112,0,0,48,30,0,0,224,112,0,0,80,113,0,0,104,30,0,0,96,30,0,0,80,113,0,0,208,112,0,0,32,19,0,0,80,113,0,0,208,112,0,0,32,19,0,0,216,17,0,0,216,17,0,0,224,112,0,0,136,30,0,0,224,112,0,0,104,75,0,0,216,17,0,0,32,113,0,0,216,17,0,0,224,112,0,0,104,75,0,0,152,22,0,0,32,113,0,0,32,113,0,0,136,30,0,0,80,113,0,0,104,75,0,0,152,22,0,0,224,112,0,0,216,17,0,0,80,113,0,0,104,75,0,0,216,17,0,0,216,17,0,0,32,113,0,0,208,112,0,0,176,30,0,0,80,113,0,0,168,30,0,0,80,113,0,0,80,113,0,0,80,113,0,0,80,113,0,0,192,30,0,0,224,30,0,0,240,30,0,0,248,30,0,0,16,31,0,0,32,113,0,0,224,17,0,0,32,113,0,0,32,113,0,0,216,17,0,0,120,81,0,0,216,17,0,0,216,17,0,0,120,81,0,0,80,113,0,0,56,31,0,0,48,31,0,0,208,112,0,0,88,24,0,0,216,17,0,0,208,112,0,0,88,24,0,0,80,113,0,0,216,17,0,0,56,31,0,0,208,112,0,0,88,24,0,0,32,113,0,0,208,112,0,0,88,24,0,0,224,112,0,0,32,113,0,0,56,31,0,0,224,112,0,0,56,31,0,0,208,112,0,0,136,20,0,0,80,113,0,0,208,112,0,0,136,20,0,0,32,113,0,0,208,112,0,0,136,20,0,0,216,17,0,0,216,17,0,0,216,17,0,0,80,113,0,0,88,31,0,0,32,113,0,0,88,31,0,0,120,31,0,0,208,112,0,0,128,31,0,0,16,18,0,0,216,17,0,0,216,17,0,0,208,112,0,0,128,31,0,0,16,18,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,184,31,0,0,224,112,0,0,224,112,0,0,200,31,0,0,176,31,0,0,224,112,0,0,240,31,0,0,248,31,0,0,216,17,0,0,216,17,0,0,224,112,0,0,8,32,0,0,208,112,0,0,248,31,0,0,216,17,0,0,216,17,0,0,240,31,0,0,32,113,0,0,8,32,0,0,208,112,0,0,248,31,0,0,32,113,0,0,232,31,0,0,32,113,0,0,32,113,0,0,224,112,0,0,208,112,0,0,248,31,0,0,16,18,0,0,16,18,0,0,208,112,0,0,248,31,0,0,16,18,0,0,16,18,0,0,216,17,0,0,216,17,0,0,208,112,0,0,248,31,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,248,31,0,0,224,112,0,0,80,113,0,0,40,32,0,0,40,32,0,0,40,32,0,0,48,32,0,0,80,113,0,0,80,113,0,0,80,113,0,0,80,113,0,0,80,113,0,0,32,113,0,0,32,113,0,0,48,32,0,0,208,112,0,0,40,32,0,0,32,29,0,0,144,25,0,0,80,113,0,0,80,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,40,32,0,0,144,25,0,0,32,29,0,0,200,19,0,0,192,27,0,0,32,113,0,0,80,113,0,0,208,112,0,0,0,22,0,0,216,17,0,0,208,112,0,0,0,22,0,0,216,17,0,0,216,17,0,0,104,113,0,0,160,32,0,0,32,113,0,0,104,113,0,0,104,113,0,0,104,113,0,0,104,113,0,0,104,113,0,0,104,113,0,0,32,113,0,0,208,112,0,0,168,32,0,0,216,17,0,0,216,17,0,0,208,112,0,0,168,32,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,168,32,0,0,152,19,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,216,32,0,0,208,112,0,0,200,21,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,0,33,0,0,104,113,0,0,32,113,0,0,16,33,0,0,208,112,0,0,0,33,0,0,32,113,0,0,104,113,0,0,16,33,0,0,248,32,0,0,208,112,0,0,56,33,0,0,32,113,0,0,208,112,0,0,56,33,0,0,224,112,0,0,48,33,0,0,32,113,0,0,224,112,0,0,32,113,0,0,32,113,0,0,72,33,0,0,224,112,0,0,72,33,0,0,32,113,0,0,104,33,0,0,208,112,0,0,120,33,0,0,32,113,0,0,192,27,0,0,32,113,0,0,32,113,0,0,80,113,0,0,216,17,0,0,160,33,0,0,208,112,0,0,176,33,0,0,104,113,0,0,208,112,0,0,176,33,0,0,224,17,0,0,104,113,0,0,160,33,0,0,152,33,0,0,80,113,0,0,176,33,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,160,33,0,0,208,112,0,0,176,33,0,0,32,113,0,0,224,17,0,0,160,33,0,0,208,112,0,0,8,81,0,0,216,17,0,0,128,19,0,0,224,19,0,0,104,113,0,0,152,19,0,0,152,19,0,0,104,113,0,0,104,113,0,0,224,112,0,0,56,113,0,0,208,33,0,0,208,112,0,0,8,81,0,0,216,17,0,0,208,112,0,0,8,81,0,0,72,20,0,0,72,20,0,0,208,112,0,0,8,81,0,0,216,17,0,0,136,28,0,0,152,19,0,0,152,19,0,0,224,33,0,0,104,113,0,0,208,33,0,0,224,112,0,0,208,33,0,0,208,112,0,0,8,81,0,0,216,17,0,0,216,17,0,0,216,17,0,0,152,19,0,0,152,19,0,0,136,28,0,0,16,34,0,0,56,20,0,0,16,34,0,0,152,19,0,0,152,19,0,0,152,19,0,0,152,19,0,0,32,113,0,0,32,113,0,0,104,113,0,0,32,113,0,0,104,113,0,0,224,112,0,0,32,113,0,0,224,112,0,0,16,34,0,0,208,112,0,0,8,81,0,0,216,17,0,0,224,33,0,0,224,19,0,0,104,113,0,0,152,19,0,0,152,19,0,0,224,33,0,0,224,112,0,0,8,81,0,0,72,20,0,0,72,20,0,0,32,113,0,0,40,34,0,0,32,34,0,0,32,113,0,0,80,113,0,0,208,112,0,0,56,34,0,0,32,113,0,0,208,112,0,0,56,34,0,0,80,113,0,0,216,17,0,0,40,34,0,0,80,113,0,0,40,34,0,0,208,112,0,0,96,34,0,0,224,112,0,0,208,112,0,0,96,34,0,0,32,113,0,0,32,113,0,0,112,34,0,0,208,112,0,0,96,34,0,0,104,113,0,0,88,34,0,0,32,113,0,0,104,113,0,0,224,112,0,0,104,113,0,0,112,34,0,0,224,112,0,0,112,34,0,0,144,34,0,0,80,113,0,0,80,113,0,0,80,113,0,0,208,112,0,0,152,34,0,0,16,18,0,0,216,17,0,0,208,112,0,0,152,34,0,0,16,18,0,0,216,17,0,0,216,17,0,0,216,17,0,0,80,113,0,0,168,34,0,0,208,112,0,0,152,34,0,0,80,113,0,0,208,112,0,0,224,112,0,0,224,112,0,0,208,112,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,152,19,0,0,32,113,0,0,32,113,0,0,208,24,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,104,113,0,0,216,17,0,0,216,17,0,0,104,113,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,80,113,0,0,80,113,0,0,32,113,0,0,208,24,0,0,216,17,0,0,208,112,0,0,216,17,0,0,16,18,0,0,32,113,0,0,216,17,0,0,216,17,0,0,224,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,208,112,0,0,216,17,0,0,208,24,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,216,17,0,0,216,17,0,0,240,31,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,240,31,0,0,216,17,0,0,32,113,0,0,208,112,0,0,216,17,0,0,104,113,0,0,216,17,0,0,216,17,0,0,32,113,0,0,200,34,0,0,200,34,0,0,216,17,0,0,208,112,0,0,216,17,0,0,32,113,0,0,32,113,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,208,24,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,104,113,0,0,104,113,0,0,32,113,0,0,224,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,152,19,0,0,32,113,0,0,208,112,0,0,216,17,0,0,72,20,0,0,240,31,0,0,32,113,0,0,104,113,0,0,208,24,0,0,32,113,0,0,32,113,0,0,224,112,0,0,208,112,0,0,216,17,0,0,104,113,0,0,216,17,0,0,208,112,0,0,216,17,0,0,16,18,0,0,224,112,0,0,208,24,0,0,32,113,0,0,32,113,0,0,32,113,0,0,104,113,0,0,216,17,0,0,240,28,0,0,224,112,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,224,112,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,80,113,0,0,80,113,0,0,80,113,0,0,208,112,0,0,216,17,0,0,104,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,104,113,0,0,104,113,0,0,32,113,0,0,32,113,0,0,216,17,0,0,104,113,0,0,216,17,0,0,216,17,0,0,32,113,0,0,216,17,0,0,104,113,0,0,216,17,0,0,32,113,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,224,112,0,0,216,17,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,224,112,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,216,17,0,0,240,31,0,0,32,113,0,0,32,113,0,0,208,24,0,0,48,21,0,0,216,17,0,0,224,112,0,0,208,112,0,0,16,18,0,0,208,34,0,0,200,19,0,0,104,113,0,0,216,17,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,216,17,0,0,216,29,0,0,224,17,0,0,208,24,0,0,216,17,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,216,17,0,0,104,113,0,0,216,17,0,0,216,17,0,0,32,113,0,0,104,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,240,28,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,240,31,0,0,240,31,0,0,208,24,0,0,32,113,0,0,32,113,0,0,32,113,0,0,104,113,0,0,216,17,0,0,32,113,0,0,216,17,0,0,224,17,0,0,32,113,0,0,32,113,0,0,216,17,0,0,224,112,0,0,216,17,0,0,104,113,0,0,216,17,0,0,216,17,0,0,32,113,0,0,80,113,0,0,216,17,0,0,216,17,0,0,216,17,0,0,224,112,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,80,113,0,0,216,17,0,0,216,17,0,0,152,19,0,0,32,113,0,0,32,113,0,0,216,17,0,0,216,17,0,0,32,113,0,0,104,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,152,19,0,0,32,113,0,0,216,17,0,0,216,17,0,0,224,112,0,0,72,20,0,0,216,17,0,0,200,19,0,0,224,112,0,0,72,20,0,0,16,18,0,0,32,113,0,0,216,17,0,0,72,20,0,0,32,113,0,0,224,112,0,0,72,20,0,0,216,17,0,0,240,34,0,0,200,19,0,0,216,17,0,0,216,17,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,80,113,0,0,80,113,0,0,208,112,0,0,16,18,0,0,216,17,0,0,208,112,0,0,128,19,0,0,200,19,0,0,32,113,0,0,104,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,29,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,104,113,0,0,104,113,0,0,216,17,0,0,32,113,0,0,224,112,0,0,104,113,0,0,152,19,0,0,72,20,0,0,32,113,0,0,104,113,0,0,32,113,0,0,40,113,0,0,216,17,0,0,32,113,0,0,152,19,0,0,240,31,0,0,216,17,0,0,240,28,0,0,104,113,0,0,104,113,0,0,208,112,0,0,216,17,0,0,152,19,0,0,240,28,0,0,216,17,0,0,32,113,0,0,32,113,0,0,32,113,0,0,216,17,0,0,32,113,0,0,104,113,0,0,32,113,0,0,216,17,0,0,152,19,0,0,104,113,0,0,104,113,0,0,104,113,0,0,104,113,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,32,113,0,0,224,112,0,0,32,113,0,0,216,17,0,0,216,17,0,0,152,19,0,0,224,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,104,113,0,0,216,17,0,0,104,113,0,0,216,17,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,104,113,0,0,104,113,0,0,104,113,0,0,200,34,0,0,216,17,0,0,104,113,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,224,17,0,0,216,17,0,0,208,112,0,0,216,17,0,0,16,18,0,0,216,17,0,0,32,113,0,0,32,113,0,0,240,31,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,216,17,0,0,240,31,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,16,18,0,0,208,24,0,0,32,113,0,0,32,113,0,0,240,31,0,0,208,112,0,0,216,17,0,0,216,17,0,0,208,24,0,0,32,113,0,0,32,113,0,0,208,112,0,0,16,18,0,0,216,17,0,0,32,113,0,0,32,113,0,0,136,28,0,0,32,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,16,18,0,0,216,17,0,0,32,113,0,0,32,113,0,0,80,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,16,18,0,0,216,17,0,0,32,113,0,0,32,113,0,0,80,113,0,0,80,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,80,113,0,0,80,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,136,28,0,0,32,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,80,113,0,0,32,113,0,0,32,113,0,0,216,17,0,0,216,17,0,0,216,17,0,0,224,112,0,0,208,112,0,0,216,17,0,0,216,17,0,0,208,112,0,0,240,31,0,0,152,19,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,224,33,0,0,208,112,0,0,216,17,0,0,200,34,0,0,208,24,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,240,31,0,0,152,19,0,0,104,113,0,0,104,113,0,0,104,113,0,0,208,24,0,0,32,113,0,0,32,113,0,0,32,113,0,0,224,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,80,113,0,0,80,113,0,0,208,112,0,0,216,17,0,0,144,25,0,0,216,17,0,0,144,25,0,0,168,23,0,0,216,17,0,0,208,24,0,0,208,24,0,0,32,35,0,0,32,113,0,0,208,112,0,0,216,17,0,0,144,25,0,0,216,17,0,0,144,25,0,0,120,23,0,0,216,17,0,0,208,24,0,0,208,24,0,0,80,35,0,0,32,113,0,0,208,112,0,0,216,17,0,0,240,31,0,0,208,24,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,144,25,0,0,216,17,0,0,208,24,0,0,32,113,0,0,208,112,0,0,216,17,0,0,16,18,0,0,32,113,0,0,208,24,0,0,32,113,0,0,32,113,0,0,216,17,0,0,32,113,0,0,240,31,0,0,208,112,0,0,104,113,0,0,216,17,0,0,216,17,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,240,31,0,0,32,113,0,0,32,113,0,0,208,24,0,0,104,113,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,80,113,0,0,80,113,0,0,208,112,0,0,16,18,0,0,216,17,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,152,19,0,0,32,113,0,0,32,113,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,152,19,0,0,152,19,0,0,224,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,208,24,0,0,208,112,0,0,216,17,0,0,216,17,0,0,224,112,0,0,224,112,0,0,208,112,0,0,216,17,0,0,216,17,0,0,104,113,0,0,104,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,224,112,0,0,32,113,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,32,113,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,224,112,0,0,104,113,0,0,216,17,0,0,216,17,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,80,113,0,0,80,113,0,0,80,113,0,0,224,112,0,0,216,29,0,0,240,31,0,0,240,31,0,0,208,112,0,0,216,17,0,0,240,31,0,0,32,113,0,0,208,24,0,0,32,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,224,112,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,152,19,0,0,32,113,0,0,224,17,0,0,32,113,0,0,104,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,104,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,104,113,0,0,32,113,0,0,208,112,0,0,16,18,0,0,200,19,0,0,216,17,0,0,216,17,0,0,200,19,0,0,136,28,0,0,224,112,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,208,112,0,0,16,18,0,0,200,19,0,0,216,17,0,0,216,17,0,0,136,28,0,0,104,113,0,0,32,113,0,0,216,17,0,0,16,18,0,0,152,19,0,0,32,113,0,0,224,112,0,0,32,113,0,0,32,113,0,0,224,112,0,0,208,112,0,0,200,34,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,152,19,0,0,240,31,0,0,224,112,0,0,32,113,0,0,216,29,0,0,216,17,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,152,19,0,0,240,31,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,104,113,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,216,17,0,0,32,113,0,0,32,113,0,0,216,17,0,0,32,113,0,0,224,112,0,0,208,112,0,0,216,17,0,0,240,31,0,0,240,31,0,0,208,24,0,0,32,113,0,0,32,113,0,0,32,113,0,0,104,113,0,0,104,113,0,0,216,17,0,0,224,112,0,0,208,112,0,0,216,17,0,0,216,17,0,0,104,113,0,0,224,112,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,208,112,0,0,216,17,0,0,104,113,0,0,216,17,0,0,104,113,0,0,104,113,0,0,216,17,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,104,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,104,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,104,113,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,104,113,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,32,113,0,0,104,113,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,104,113,0,0,216,17,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,104,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,104,113,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,32,113,0,0,104,113,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,216,17,0,0,208,112,0,0,48,21,0,0,216,17,0,0,208,112,0,0,216,17,0,0,216,17,0,0,104,113,0,0,104,113,0,0,32,113,0,0,104,113,0,0,104,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,104,113,0,0,104,113,0,0,32,113,0,0,104,113,0,0,104,113,0,0,104,113,0,0,104,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,104,113,0,0,104,113,0,0,104,113,0,0,104,113,0,0,32,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,152,19,0,0,104,113,0,0,104,113,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,104,113,0,0,104,113,0,0,32,113,0,0,224,112,0,0,200,34,0,0,216,17,0,0,216,29,0,0,224,17,0,0,128,35,0,0,128,35,0,0,32,113,0,0,224,112,0,0,136,35,0,0,208,24,0,0,104,113,0,0,152,35,0,0,104,113,0,0,104,113,0,0,104,113,0,0,104,113,0,0,152,35,0,0,104,113,0,0,104,113,0,0,104,113,0,0,152,35,0,0,104,113,0,0,104,113,0,0,152,35,0,0,104,113,0,0,152,35,0,0,168,35,0,0,216,29,0,0,168,35,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,168,35,0,0,240,31,0,0,152,19,0,0,168,35,0,0,240,35,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,240,35,0,0,216,17,0,0,40,36,0,0,216,29,0,0,80,113,0,0,56,36,0,0,32,113,0,0,32,113,0,0,32,113,0,0,80,113,0,0,56,36,0,0,32,113,0,0,32,113,0,0,80,113,0,0,56,36,0,0,32,113,0,0,104,113,0,0,56,36,0,0,32,113,0,0,32,113,0,0,104,113,0,0,56,36,0,0,32,113,0,0,104,113,0,0,56,36,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,56,36,0,0,32,113,0,0,32,113,0,0,32,113,0,0,32,113,0,0,56,36,0,0,32,113,0,0,32,113,0,0,32,113,0,0,56,36,0,0,32,113,0,0,24,113,0,0,56,36,0,0,32,113,0,0,32,113,0,0,32,113,0,0,24,113,0,0,56,36,0,0,32,113,0,0,32,113,0,0,24,113,0,0,56,36,0,0,32,113,0,0,0,113,0,0,56,36,0,0,32,113,0,0,32,113,0,0,32,113,0,0,0,113,0,0,56,36,0,0,32,113,0,0,32,113,0,0,0,113,0,0,56,36,0,0,32,113,0,0,200,19,0,0,216,17,0,0,128,35,0,0,216,17,0,0,32,113,0,0,32,113,0,0,128,35,0,0,216,17,0,0,32,113,0,0,128,35,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,216,17,0,0,104,113,0,0,216,17,0,0,40,36,0,0,56,113,0,0,40,36,0,0,32,113,0,0,224,112,0,0,40,36,0,0,208,112,0,0,40,36,0,0,224,34,0,0,240,26,0,0,208,112,0,0,40,36,0,0,224,34,0,0,216,17,0,0,40,36,0,0,128,36,0,0,216,17,0,0,40,36,0,0,32,113,0,0,32,113,0,0,208,112,0,0,56,36,0,0,152,19,0,0,32,113,0,0,208,112,0,0,56,36,0,0,32,113,0,0,32,113,0,0,32,113,0,0,216,17,0,0,152,19,0,0,32,113,0,0,216,17,0,0,32,113,0,0,32,113,0,0,32,113,0,0,216,17,0,0,40,36,0,0,32,113,0,0,208,112,0,0,216,17,0,0,216,17,0,0,32,113,0,0,104,113,0,0,104,113,0,0,32,113,0,0,40,36,0,0,56,113,0,0,40,36,0,0,56,36,0,0,240,34,0,0,56,36,0,0,152,19,0,0,32,113,0,0,32,113,0,0,56,113,0,0,56,36,0,0,32,113,0,0,32,113,0,0,32,113,0,0,56,36,0,0,152,19,0,0,32,113,0,0,56,36,0,0,136,36,0,0,32,113,0,0,32,113,0,0,104,113,0,0,136,36,0,0,224,112,0,0,32,29,0,0,56,113,0,0,240,28,0,0,128,35,0,0,32,29,0,0,56,113,0,0,56,113,0,0,168,36,0,0,208,112,0,0,184,36,0,0,56,113,0,0,240,28,0,0,208,112,0,0,184,36,0,0,240,28,0,0,184,36,0,0,224,112,0,0,128,19,0,0,56,113,0,0,216,29,0,0,128,35,0,0,128,19,0,0,56,113,0,0,56,113,0,0,200,36,0,0,208,112,0,0,216,36,0,0,56,113,0,0,216,29,0,0,208,112,0,0,216,36,0,0,216,29,0,0,216,36,0,0,224,112,0,0,144,25,0,0,56,113,0,0,40,32,0,0,128,35,0,0,144,25,0,0,56,113,0,0,56,113,0,0,232,36,0,0,208,112,0,0,248,36,0,0,56,113,0,0,40,32,0,0,208,112,0,0,248,36,0,0,40,32,0,0,248,36,0,0,224,112,0,0,16,18,0,0,56,113,0,0,216,17,0,0,128,35,0,0,16,18,0,0,56,113,0,0,56,113,0,0,8,37,0,0,208,112,0,0,24,37,0,0,56,113,0,0,216,17,0,0,208,112,0,0,24,37,0,0,216,17,0,0,24,37,0,0,224,112,0,0,40,37,0,0,56,113,0,0,0,36,0,0,128,35,0,0,40,37,0,0,56,113,0,0,56,113,0,0,88,37,0,0,208,112,0,0,104,37,0,0,56,113,0,0,0,36,0,0,208,112,0,0,104,37,0,0,0,36,0,0,104,37,0,0,224,112,0,0,224,33,0,0,56,113,0,0,240,31,0,0,128,35,0,0,224,33,0,0,56,113,0,0,56,113,0,0,120,37,0,0,208,112,0,0,136,37,0,0,56,113,0,0,240,31,0,0,208,112,0,0,136,37,0,0,240,31,0,0,136,37,0,0,224,112,0,0,72,22,0,0,56,113,0,0,224,33,0,0,128,35,0,0,72,22,0,0,56,113,0,0,56,113,0,0,152,37,0,0,208,112,0,0,168,37,0,0,56,113,0,0,224,33,0,0,208,112,0,0,168,37,0,0,224,33,0,0,168,37,0,0,224,112,0,0,184,37,0,0,56,113,0,0,200,19,0,0,128,35,0,0,184,37,0,0,56,113,0,0,56,113,0,0,232,37,0,0,208,112,0,0,248,37,0,0,56,113,0,0,200,19,0,0,208,112,0,0,248,37,0,0,200,19,0,0,248,37,0,0,224,112,0,0,136,28,0,0,56,113,0,0,80,113,0,0,128,35,0,0,136,28,0,0,56,113,0,0,56,113,0,0,8,38,0,0,208,112,0,0,24,38,0,0,56,113,0,0,80,113,0,0,208,112,0,0,24,38,0,0,80,113,0,0,24,38,0,0,224,112,0,0,40,38,0,0,56,113,0,0,128,35,0,0,128,35,0,0,40,38,0,0,56,113,0,0,56,113,0,0,88,38,0,0,208,112,0,0,104,38,0,0,56,113,0,0,128,35,0,0,208,112,0,0,104,38,0,0,128,35,0,0,104,38,0,0,224,112,0,0,120,38,0,0,56,113,0,0,72,20,0,0,128,35,0,0,120,38,0,0,56,113,0,0,56,113,0,0,168,38,0,0,208,112,0,0,184,38,0,0,56,113,0,0,72,20,0,0,208,112,0,0,184,38,0,0,72,20,0,0,184,38,0,0,224,112,0,0,240,34,0,0,56,113,0,0,0,113,0,0,128,35,0,0,240,34,0,0,56,113,0,0,56,113,0,0,200,38,0,0,208,112,0,0,216,38,0,0,56,113,0,0,0,113,0,0,208,112,0,0,216,38,0,0,0,113,0,0,216,38,0,0,224,112,0,0,232,38,0,0,56,113,0,0,56,113,0,0,128,35,0,0,232,38,0,0,56,113,0,0,56,113,0,0,24,39,0,0,208,112,0,0,40,39,0,0,56,113,0,0,56,113,0,0,208,112,0,0,40,39,0,0,56,113,0,0,40,39,0,0,224,112,0,0,80,35,0,0,56,113,0,0,232,112,0,0,128,35,0,0,80,35,0,0,56,113,0,0,56,113,0,0,56,39,0,0,208,112,0,0,72,39,0,0,56,113,0,0,232,112,0,0,208,112,0,0,72,39,0,0,232,112,0,0,72,39,0,0,224,112,0,0,200,19,0,0,56,113,0,0,32,113,0,0,128,35,0,0,200,19,0,0,56,113,0,0,56,113,0,0,88,39,0,0,208,112,0,0,104,39,0,0,56,113,0,0,32,113,0,0,208,112,0,0,104,39,0,0,32,113,0,0,104,39,0,0,0,0,0,0,120,39,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,4,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,160,39,0,0,2,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,3,0,0,0,4,0,0,0,3,0,0,0,4,0,0,0,8,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,192,39,0,0,3,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,5,0,0,0,6,0,0,0,5,0,0,0,6,0,0,0,12,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,232,39,0,0,4,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,7,0,0,0,8,0,0,0,7,0,0,0,8,0,0,0,16,0,0,0,7,0,0,0,8,0,0,0,0,0,0,0,8,40,0,0,5,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,9,0,0,0,10,0,0,0,9,0,0,0,10,0,0,0,20,0,0,0,9,0,0,0,10,0,0,0,0,0,0,0,40,40,0,0,6,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,11,0,0,0,12,0,0,0,11,0,0,0,12,0,0,0,24,0,0,0,11,0,0,0,12,0,0,0,0,0,0,0,72,40,0,0,7,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,13,0,0,0,14,0,0,0,13,0,0,0,14,0,0,0,28,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,104,40,0,0,8,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,15,0,0,0,16,0,0,0,15,0,0,0,16,0,0,0,32,0,0,0,15,0,0,0,16,0,0,0,0,0,0,0,136,40,0,0,9,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,17,0,0,0,18,0,0,0,17,0,0,0,18,0,0,0,36,0,0,0,17,0,0,0,18,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,0,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,0,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,0,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,0,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,5,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,1,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,0,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,0,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,16,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,0,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,31,0,0,0,39,0,0,0,0,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,0,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,0,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,0,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,0,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,0,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,0,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,0,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,41,0,0,19,0,0,0,20,0,0,0,10,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,56,41,0,0,21,0,0,0,22,0,0,0,23,0,0,0,0,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,0,0,0,0,107],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+30720);allocate([108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,12,0,0,0,15,0,0,0,16,0,0,0,18,0,0,0,20,0,0,0,24,0,0,0,25,0,0,0,27,0,0,0,30,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,45,0,0,0,48,0,0,0,50,0,0,0,54,0,0,0,60,0,0,0,64,0,0,0,72,0,0,0,75,0,0,0,80,0,0,0,81,0,0,0,90,0,0,0,96,0,0,0,100,0,0,0,108,0,0,0,120,0,0,0,125,0,0,0,128,0,0,0,135,0,0,0,144,0,0,0,150,0,0,0,160,0,0,0,162,0,0,0,180,0,0,0,192,0,0,0,200,0,0,0,216,0,0,0,225,0,0,0,240,0,0,0,243,0,0,0,250,0,0,0,0,1,0,0,14,1,0,0,32,1,0,0,44,1,0,0,64,1,0,0,68,1,0,0,104,1,0,0,119,1,0,0,128,1,0,0,144,1,0,0,149,1,0,0,176,1,0,0,194,1,0,0,224,1,0,0,230,1,0,0,244,1,0,0,0,2,0,0,28,2,0,0,64,2,0,0,88,2,0,0,113,2,0,0,128,2,0,0,136,2,0,0,163,2,0,0,208,2,0,0,217,2,0,0,238,2,0,0,0,3,0,0,32,3,0,0,42,3,0,0,96,3,0,0,132,3,0,0,192,3,0,0,204,3,0,0,232,3,0,0,0,4,0,0,56,4,0,0,101,4,0,0,128,4,0,0,176,4,0,0,191,4,0,0,226,4,0,0,0,5,0,0,16,5,0,0,70,5,0,0,160,5,0,0,178,5,0,0,220,5,0,0,0,6,0,0,64,6,0,0,84,6,0,0,192,6,0,0,8,7,0,0,83,7,0,0,128,7,0,0,152,7,0,0,208,7,0,0,233,7,0,0,0,8,0,0,112,8,0,0,139,8,0,0,202,8,0,0,0,9,0,0,96,9,0,0,126,9,0,0,196,9,0,0,0,10,0,0,32,10,0,0,140,10,0,0,64,11,0,0,100,11,0,0,184,11,0,0,0,12,0,0,53,12,0,0,128,12,0,0,168,12,0,0,47,13,0,0,128,13,0,0,16,14,0,0,61,14,0,0,166,14,0,0,0,15,0,0,48,15,0,0,160,15,0,0,210,15,0,0,0,16,0,0,224,16,0,0,22,17,0,0,148,17,0,0,0,18,0,0,192,18,0,0,252,18,0,0,136,19,0,0,0,20,0,0,64,20,0,0,24,21,0,0,249,21,0,0,128,22,0,0,200,22,0,0,112,23,0,0,187,23,0,0,0,24,0,0,106,24,0,0,0,25,0,0,80,25,0,0,161,25,0,0,94,26,0,0,0,27,0,0,32,28,0,0,122,28,0,0,76,29,0,0,0,30,0,0,96,30,0,0,64,31,0,0,164,31,0,0,0,32,0,0,192,33,0,0,44,34,0,0,40,35,0,0,0,36,0,0,159,36,0,0,128,37,0,0,248,37,0,0,16,39,0,0,141,39,0,0,0,40,0,0,128,40,0,0,48,42,0,0,183,42,0,0,242,43,0,0,0,45,0,0,144,45,0,0,224,46,0,0,118,47,0,0,0,48,0,0,212,48,0,0,0,50,0,0,160,50,0,0,66,51,0,0,188,52,0,0,0,54,0,0,64,56,0,0,244,56,0,0,152,58,0,0,0,60,0,0,192,60,0,0,9,61,0,0,128,62,0,0,72,63,0,0,0,64,0,0,235,65,0,0,128,67,0,0,88,68,0,0,80,70,0,0,49,71,0,0,0,72,0,0,62,73,0,0,0,75,0,0,240,75,0,0,227,76,0,0,32,78,0,0,26,79,0,0,0,80,0,0,0,81,0,0,96,84,0,0,110,85,0,0,228,87,0,0,0,90,0,0,32,91,0,0,192,93,0,0,236,94,0,0,0,96,0,0,168,97,0,0,0,100,0,0,64,101,0,0,132,102,0,0,120,105,0,0,0,108,0,0,221,109,0,0,128,112,0,0,232,113,0,0,48,117,0,0,167,118,0,0,0,120,0,0,128,121,0,0,18,122,0,0,0,125,0,0,144,126,0,0,0,128,0,0,37,128,0,0,214,131,0,0,0,135,0,0,176,136,0,0,160,140,0,0,98,142,0,0,0,144,0,0,124,146,0,0,0,150,0,0,224,151,0,0,198,153,0,0,64,156,0,0,52,158,0,0,0,160,0,0,0,162,0,0,192,168,0,0,220,170,0,0,200,175,0,0,0,180,0,0,64,182,0,0,27,183,0,0,128,187,0,0,216,189,0,0,0,192,0,0,80,195,0,0,193,197,0,0,0,200,0,0,128,202,0,0,8,205,0,0,240,210,0,0,147,213,0,0,0,216,0,0,186,219,0,0,0,225,0,0,208,227,0,0,169,230,0,0,96,234,0,0,78,237,0,0,0,240,0,0,0,243,0,0,36,244,0,0,0,250,0,0,32,253,0,0,0,0,1,0,74,0,1,0,172,7,1,0,0,14,1,0,96,17,1,0,64,25,1,0,196,28,1,0,0,32,1,0,248,36,1,0,0,44,1,0,192,47,1,0,45,49,1,0,140,51,1,0,128,56,1,0,104,60,1,0,0,64,1,0,0,68,1,0,151,73,1,0,128,81,1,0,184,85,1,0,144,95,1,0,245,99,1,0,0,104,1,0,128,108,1,0,54,110,1,0,0,119,1,0,176,123,1,0,0,128,1,0,111,128,1,0,160,134,1,0,130,139,1,0,0,144,1,0,0,149,1,0,16,154,1,0,224,165,1,0,38,171,1,0,0,176,1,0,116,183,1,0,0,194,1,0,160,199,1,0,82,205,1,0,192,212,1,0,156,218,1,0,0,224,1,0,0,230,1,0,72,232,1,0,0,244,1,0,64,250,1,0,0,0,2,0,148,0,2,0,88,15,2,0,0,28,2,0,192,34,2,0,81,37,2,0,128,50,2,0,136,57,2,0,0,64,2,0,240,73,2,0,67,81,2,0,0,88,2,0,128,95,2,0,90,98,2,0,24,103,2,0,0,113,2,0,208,120,2,0,0,128,2,0,185,128,2,0,0,136,2,0,46,147,2,0,0,163,2,0,112,171,2,0,251,179,2,0,32,191,2,0,234,199,2,0,0,208,2,0,0,217,2,0,108,220,2,0,0,238,2,0,96,247,2,0,0,0,3,0,222,0,3,0,64,13,3,0,4,23,3,0,0,32,3,0,0,42,3,0,32,52,3,0,192,75,3,0,76,86,3,0,0,96,3,0,232,110,3,0,0,132,3,0,64,143,3,0,135,147,3,0,164,154,3,0,128,169,3,0,56,181,3,0,0,192,3,0,0,204,3,0,144,208,3,0,197,220,3,0,0,232,3,0,128,244,3,0,0,0,4,0,40,1,4,0,176,30,4,0,223,43,4,0,0,56,4,0,128,69,4,0,162,74,4,0,0,101,4,0,16,115,4,0,0,128,4,0,77,129,4,0,224,147,4,0,134,162,4,0,0,176,4,0,0,191,4,0,180,196,4,0,48,206,4,0,0,226,4,0,160,241,4,0,0,0,5,0,114,1,5,0,0,16,5,0,92,38,5,0,0,70,5,0,224,86,5,0,246,103,5,0,64,126,5,0,212,143,5,0,0,160,5,0,0,178,5,0,216,184,5,0,0,220,5,0,192,238,5,0,225,245,5,0,0,0,6,0,188,1,6,0,128,26,6,0,8,46,6,0,0,64,6,0,0,84,6,0,64,104,6,0,243,111,6,0,128,151,6,0,152,172,6,0,0,192,6,0,208,221,6,0,201,243,6,0,0,8,7,0,128,30,7,0,14,39,7,0,72,53,7,0,0,83,7,0,112,106,7,0,0,128,7,0,43,130,7,0,0,152,7,0,32,161,7,0,138,185,7,0,0,208,7,0,0,233,7,0,0,0,8,0,80,2,8,0,241,27,8,0,96,61,8,0,190,87,8,0,0,112,8,0,0,139,8,0,68,149,8,0,0,202,8,0,32,230,8,0,0,0,9,0,154,2,9,0,192,39,9,0,12,69,9,0,0,96,9,0,0,126,9,0,104,137,9,0,96,156,9,0,0,196,9,0,64,227,9,0,0,0,10,0,228,2,10,0,0,32,10,0,184,76,10,0,0,140,10,0,192,173,10,0,149,186,10,0,236,207,10,0,128,252,10,0,168,31,11,0,0,64,11,0,0,100,11,0,176,113,11,0,79,150,11,0,0,184,11,0,128,221,11,0,194,235,11,0,0,0,12,0,120,3,12,0,0,53,12,0,16,92,12,0,0,128,12,0,157,131,12,0,0,168,12,0,128,208,12,0,230,223,12,0,0,47,13,0,48,89,13,0,0,128,13,0,231,131,13,0,160,187,13,0,146,231,13,0,0,16,14,0,0,61,14,0,28,78,14,0,144,106,14,0,0,166,14,0,224,212,14,0,0,0,15,0,86,4,15,0,0,48,15,0,64,66,15,0,20,115,15,0,0,160,15,0,0,210,15,0,0,0,16,0,160,4,16,0,226,55,16,0,192,122,16,0,124,175,16,0,0,224,16,0,0,22,17,0,136,42,17,0,0,148,17,0,64,204,17,0,163,225,17,0,0,0,18,0,52,5,18,0,128,79,18,0,24,138,18,0,0,192,18,0,0,252,18,0,208,18,19,0,192,56,19,0,217,79,19,0,0,136,19,0,128,198,19,0,0,0,20,0,200,5,20,0,0,64,20,0,112,153,20,0,91,219,20,0,0,24,21,0,128,91,21,0,42,117,21,0,216,159,21,0,0,249,21,0,80,63,22,0,0,128,22,0,129,134,22,0,0,200,22,0,96,227,22,0,158,44,23,0,0,112,23,0,0,187,23,0,132,215,23,0,0,0,24,0,240,6,24,0,211,83,24,0,0,106,24,0,32,184,24,0,0,0,25,0,58,7,25,0,0,80,25,0,0,161,25,0,204,191,25,0,0,94,26,0,96,178,26,0,0,0,27,0,206,7,27,0,64,119,27,0,36,207,27,0,0,32,28,0,0,122,28,0,56,156,28,0,32,213,28,0,0,76,29,0,192,169,29,0,101,205,29,0,0,0,30,0,172,8,30,0,0,96,30,0,128,132,30,0,40,230,30,0,0,64,31,0,0,164,31,0,0,0,32,0,64,9,32,0,191,47,32,0,196,111,32,0,128,245,32,0,248,94,33,0,0,192,33,0,0,44,34,0,16,85,34,0,237,194,34,0,0,40,35,0,128,152,35,0,70,195,35,0,0,0,36,0,104,10,36,0,0,159,36,0,48,20,37,0,0,128,37,0,215,138,37,0,0,248,37,0,160,37,38,0,128,113,38,0,178,159,38,0,0,16,39,0,0,141,39,0,0,0,40,0,144,11,40,0,0,128,40,0,181,139,40,0,224,50,41,0,182,182,41,0,0,48,42,0,0,183,42,0,84,234,42,0,176,63,43,0,0,242,43,0,160,126,44,0,0,0,45,0,2,13,45,0,0,144,45,0,192,198,45,0,60,89,46,0,0,224,46,0,0,118,47,0,8,175,47,0,0,0,48,0,224,13,48,0,166,167,48,0,0,212,48,0,64,112,49,0,0,0,50,0,116,14,50,0,0,160,50,0,0,66,51,0,152,127,51,0,0,188,52,0,192,100,53,0,233,164,53,0,0,0,54,0,156,15,54,0,128,238,54,0,72,158,55,0,0,64,56,0,0,244,56,0,112,56,57,0,64,170,57,0,139,239,57,0,0,152,58,0,128,83,59,0,202,154,59,0,0,0,60,0,88,17,60,0,0,192,60,0,0,9,61,0,80,204,61,0,0,128,62,0,17,146,62,0,0,72,63,0,0,0,64,0,128,18,64,0,126,95,64,0,136,223,64,0,0,235,65,0,240,189,66,0,0,128,67,0,131,147,67,0,0,88,68,0,32,170,68,0,218,133,69,0,0,80,70,0,0,49,71,0,140,134,71,0,0,0,72,0,208,20,72,0,121,251,72,0,0,62,73,0,96,40,74,0,0,0,75,0,174,21,75,0,0,240,75,0,64,75,76,0,0,227,76,0,100,63,77,0,0,32,78,0,0,26,79,0,0,0,80,0,32,23,80,0,0,0,81,0,106,23,81,0,192,101,82,0,108,109,83,0,0,96,84,0,0,110,85,0,168,212,85,0,96,127,86,0,0,228,87,0,64,253,88,0,47,104,89,0,0,0,90,0,4,26,90,0,0,32,91,0,128,141,91,0,120,178,92,0,0,192,93,0,0,236,94,0,16,94,95,0,0,0,96,0,192,27,96,0,61,143,96,0,76,79,97,0,0,168,97,0,128,224,98,0,0,0,100,0,232,28,100,0,0,64,101,0,0,132,102,0,48,255,102,0,199,72,104,0,0,120,105,0,128,201,106,0,210,73,107,0,0,0,108,0,56,31,108,0,0,221,109,0,144,60,111,0,0,128,112,0,133,160,112,0,0,232,113,0,224,112,114,0,128,84,115,0,22,223,115,0,0,48,117,0,0,167,118,0,148,53,119,0,0,0,120,0,176,34,120,0,0,128,121,0,31,163,121,0,0,18,122,0,160,152,123,0,0,0,125,0,34,36,125,0,0,144,126,0,0,0,128,0,0,37,128,0,252,190,128,0,16,191,129,0,0,214,131,0,224,123,133,0,0,0,135,0,6,39,135,0,0,176,136,0,64,84,137,0,180,11,139,0,0,160,140,0,0,98,142,0,24,13,143,0,0,0,144,0,160,41,144,0,242,246,145,0,0,124,146,0,192,80,148,0,249,2,149,0,0,0,150,0,92,43,150,0,0,224,151,0,128,150,152,0,0,198,153,0,200,126,154,0,0,64,156,0,0,52,158,0,0,0,160,0,64,46,160,0,187,238,160,0,0,0,162,0,212,46,162,0,128,203,164,0,216,218,166,0,0,192,168,0,0,220,170,0,80,169,171,0,192,254,172,0,161,206,173,0,0,200,175,0,128,250,177,0,94,208,178,0,0,0,180,0,8,52,180,0,0,64,182,0,0,27,183,0,240,100,185,0,0,128,187,0,51,182,187,0,0,216,189,0,32,188,190,0,0,0,192,0,128,55,192,0,122,30,193,0,152,158,194,0,0,80,195,0,0,193,197,0,0,0,200,0,208,57,200,0,0,128,202,0,137,186,202,0,0,8,205,0,96,254,205,0,142,145,208,0,0,240,210,0,0,147,213,0,164,147,214,0,0,0,216,0,112,62,216,0,0,186,219,0,32,121,222,0,0,0,225,0,10,65,225,0,0,208,227,0,192,225,228,0,0,169,230,0,44,190,231,0,0,96,234,0,0,78,237,0,40,107,238,0,0,0,240,0,96,69,240,0,0,0,243,0,62,70,243,0,0,36,244,0,64,49,247,0,0,0,250,0,68,72,250,0,0,32,253,0,0,0,0,1,0,74,0,1,248,125,1,1,32,126,3,1,0,172,7,1,192,247,10,1,141,56,12,1,0,0,14,1,12,78,14,1,0,96,17,1,128,168,18,1,104,23,22,1,0,64,25,1,0,196,28,1,48,26,30,1,0,0,32,1,64,83,32,1,183,173,33,1,228,237,35,1,0,248,36,1,128,161,40,1,242,5,42,1,0,0,44,1,184,86,44,1,0,192,47,1,0,45,49,1,0,140,51,1,144,253,52,1,0,128,56,1,85,218,56,1,0,104,60,1,0,0,64,1,128,92,64,1,118,221,65,1,0,0,68,1,168,93,68,1,0,151,73,1,176,181,77,1,0,128,81,1,143,225,81,1,0,184,85,1,160,82,87,1,128,253,89,1,66,157,91,1,0,144,95,1,0,245,99,1,188,160,101,1,0,0,104,1,16,104,104,1,0,128,108,1,93,233,108,1,0,54,110,1,224,201,114,1,0,0,119,1,102,108,119,1,0,176,123,1,64,120,125,1,0,0,128,1,0,111,128,1,244,60,130,1,48,61,133,1,0,160,134,1,0,130,139,1,0,0,144,1,160,115,144,1,0,0,149,1,18,117,149,1,0,16,154,1,192,252,155,1,28,35,161,1,0,224,165,1,0,38,171,1,72,39,173,1,0,0,176,1,224,124,176,1,0,116,183,1,64,242,188,1,235,8,191,1,0,0,194,1,20,130,194,1,0,160,199,1,128,195,201,1,0,82,205,1,88,124,207,1,0,192,212,1,0,156,218,1,80,214,220,1,0,0,224,1,192,138,224,1,49,204,226,1,0,0,230,1,124,140,230,1,0,72,232,1,128,98,238,1,0,0,244,1,136,144,244,1,0,64,250,1,0,0,0,2,0,148,0,2,240,251,2,2,64,252,6,2,227,107,9,2,0,88,15,2,128,239,21,2,26,113,24,2,0,0,28,2,24,156,28,2,0,192,34,2,0,81,37,2,208,46,44,2,0,128,50,2,153,34,51,2,0,136,57,2,96,52,60,2,0,0,64,2,128,166,64,2,110,91,67,2,200,219,71,2,0,240,73,2,0,67,81,2,228,11,84,2,0,0,88,2,112,173,88,2,0,128,95,2,155,47,96,2,0,90,98,2,0,24,103,2,32,251,105,2,0,0,113,2,170,180,113,2,0,208,120,2,0,0,128,2,0,185,128,2,236,186,131,2,0,0,136,2,80,187,136,2,0,46,147,2,96,107,155,2,0,0,163,2,30,195,163,2,0,112,171,2,64,165,174,2,0,251,179,2,132,58,183,2,0,32,191,2,0,234,199,2,120,65,203,2,0,0,208,2,32,208,208,2,0,0,217,2,186,210,217,2,0,108,220,2,192,147,229,2,221,14,233,2,0,0,238,2,204,216,238,2,0,96,247,2,128,240,250,2,0,0,0,3,0,222,0,3,232,121,4,3,96,122,10,3,0,64,13,3,0,4,23,3,0,0,32,3,64,231,32,3,167,169,36,3,0,0,42,3,36,234,42,3,0,32,52,3,128,249,55,3,56,70,66,3,0,192,75,3,0,76,86,3,144,78,90,3,0,0,96,3,192,249,96,3,37,9,101,3,0,232,110,3,128,228,121,3,214,17,126,3,0,0,132,3,40,4,133,3,0,64,143,3,0,135,147,3,0,164,154,3,176,248,158,3,0,128,169,3,255,142,170,3,0,56,181,3,160,172,185,3,0,0,192,3,128,21,193,3,98,152,197,3,0,0,204,3,248,24,205,3,0,144,208,3,0,197,220,3,0,0,232,3,16,33,233,3,0,128,244,3,173,164,245,3,0,0,0,4,0,40,1,4,224,247,5,4,128,248,13,4,198,215,18,4,0,176,30,4,0,223,43,4,52,226,48,4,0,0,56,4,48,56,57,4,0,128,69,4,0,162,74,4,160,93,88,4,0,0,101,4,50,69,102,4,0,16,115,4,192,104,120,4,0,0,128,4,0,77,129,4,220,182,134,4,144,183,143,4,0,224,147,4,0,134,162,4,200,23,168,4,0,0,176,4,224,90,177,4,0,0,191,4,54,95,192,4,0,180,196,4,0,48,206,4,64,246,211,4,0,0,226,4,84,105,227,4,0,160,241,4,0,0,0,5,0,114,1,5,216,117,7,5,0,0,16,5,160,118,17,5,0,92,38,5,192,214,54,5,193,26,61,5,0,0,70,5,60,134,71,5,0,224,86,5,128,74,93,5,0,246,103,5,8,117,110,5,0,64,126,5,0,212,143,5,240,130,150,5,0,0,160,5,64,160,161,5,147,100,168,5,0,0,178,5,116,165,179,5,0,216,184,5,128,39,203,5,186,29,210,5,0,0,220,5,152,177,221,5,0,192,238,5,0,225,245,5,0,0,0,6,0,188,1,6,208,243,8,6,192,244,20,6,0,128,26,6,169,67,28,6,0,8,46,6,0,0,64,6,128,206,65,6,78,83,73,6,0,0,84,6,72,212,85,6,0,64,104,6,0,243,111,6,112,140,132,6,0,128,151,6,203,103,153,6,0,152,172,6,32,157,180,6,0,0,192,6,128,243,193,6,74,18,202,6,0,208,221,6,0,201,243,6,172,35,252,6,0,0,8,7,80,8,10,7,0,128,30,7,209,142,32,7,0,14,39,7,0,72,53,7,96,241,61,7,0,0,83,7,254,29,85,7,0,112,106,7,64,89,115,7,0,0,128,7,0,43,130,7,196,48,139,7,0,0,152,7,240,49,154,7,0,32,161,7,0,138,185,7,0,0,208,7,32,66,210,7,0,0,233,7,90,73,235,7,0,0,0,8,0,80,2,8,192,239,11,8,0,241,27,8,140,175,37,8,0,96,61,8,0,190,87,8,104,196,97,8,0,0,112,8,96,112,114,8,0,0,139,8,0,68,149,8,64,187,176,8,151,44,187,8,0,0,202,8,100,138,204,8,0,32,230,8,128,209,240,8,0,0,0,9,0,154,2,9,184,109,13,9,32,111,31,9,0,192,39,9,0,12,69,9,144,47,80,9,0,0,96,9,192,181,98,9,245,252,109,9,0,0,126,9,108,190,128,9,0,104,137,9,0,96,156,9,128,236,167,9,0,0,196,9,168,210,198,9,0,64,227,9,0,0,0,10,0,228,2,10,176,235,14,10,0,0,32,10,64,237,34,10,111,27,47,10,0,184,76,10,128,173,109,10,130,53,122,10,0,0,140,10,120,12,143,10,0,192,173,10,0,149,186,10,0,236,207,10,16,234,220,10,0,128,252,10,253,172,255,10,0,168,31,11,224,5,45,11,0,0,64,11,128,64,67,11,38,201,80,11,0,0,100,11,232,74,103,11,0,176,113,11,0,79,150,11,116,59,164,11,0,0,184,11,48,99,187,11,0,128,221,11,7,238,224,11,0,194,235,11,0,0,0,12,0,120,3,12,160,231,17,12,128,233,41,12,0,0,53,12,82,135,56,12,0,16,92,12,0,0,128,12,0,157,131,12,156,166,146,12,0,0,168,12,144,168,171,12,0,128,208,12,0,230,223,12,224,24,9,13,0,0,47,13,150,207,50,13,0,48,89,13,64,58,105,13,0,0,128,13,0,231,131,13,148,36,148,13,0,160,187,13,0,146,231,13,88,71,248,13,0,0,16,14,160,16,20,14,0,0,61,14,162,29,65,14,0,28,78,14,0,144,106,14,192,226,123,14,81,74,141,14,0,0,166,14,252,59,170,14,0,224,212,14,128,178,230,14,0,0,0,15,0,86,4,15,136,97,22,15,0,0,48,15,224,99,52,15,0,64,66,15,0,20,115,15,0,0,160,15,64,132,164,15,67,80,183,15,0,0,210,15,180,146,214,15,0,0,0,16,0,160,4,16,128,223,23,16,0,226,55,16,24,95,75,16,0,192,122,16,0,124,175,16,208,136,195,16,0,0,224,16,192,224,228,16,185,45,249,16,0,0,22,17,0,136,42,17,128,118,97,17,46,89,118,17,0,0,148,17,200,20,153,17,0,64,204,17,0,163,225,17,0,0,0,18,0,52,5,18,112,219,26,18,64,222,62,18,0,128,79,18,251,202,84,18,0,24,138,18,32,95,160,18,0,0,192,18,128,107,197,18,234,249,219,18,0,0,252,18,216,124,1,19,0,208,18,19,0,192,56,19,0,217,79,19,0,0,136,19,80,165,141,19,0,128,198,19,97,55,204,19,0,0,0,20,0,200,5,20,96,215,29,20,0,0,64,20,128,218,69,20,222,54,94,20,0,112,153,20,0,91,219,20,4,107,244,20,0,0,24,21,240,24,30,21,0,128,91,21,0,42,117,21,0,216,159,21,32,212,185,21,0,0,249,21,250,89,255,21,0,80,63,22,192,11,90,22,0,0,128,22,0,129,134,22,76,146,161,22,0,0,200,22,208,149,206,22,0,96,227,22,0,158,44,23,232,118,72,23,0,0,112,23,96,198,118,23,0,0,187,23,14,220,193,23,0,132,215,23,0,0,0,24,0,240,6,24,64,207,35,24,0,211,83,24,0,0,106,24,164,14,113,24,0,32,184,24,0,0,0,25,0,58,7,25,56,77,37,25,0,0,80,25,32,81,87,25,0,0,161,25,0,204,191,25,192,49,18,26,197,133,49,26,0,0,94,26,44,159,101,26,0,96,178,26,128,116,210,26,0,0,0,27,0,206,7,27,40,73,40,27,0,64,119,27,0,36,207,27,176,142,240,27,0,0,32,28,64,33,40,28,223,246,73,28,0,0,122,28,68,59,130,28,0,56,156,28,0,32,213,28,128,197,247,28,162,148,26,29,0,0,76,29,248,119,84,29,0,192,169,29,0,101,205,29,0,0,0,30,0,172,8,30,16,195,44,30,0,0,96,30,192,199,104,30,0,128,132,30,77,82,141,30,0,40,230,30,0,0,64,31,128,8,73,31,134,160,110,31,0,0,164,31,104,37,173,31,0,0,0,32,0,64,9,32,0,191,47,32,0,196,111,32,48,190,150,32,0,128,245,32,247,6,255,32,0,248,94,33,160,17,135,33,0,0,192,33,128,193,201,33,114,91,242,33,0,0,44,34,0,16,85,34,0,237,194,34,92,178,236,34,0,0,40,35,144,41,50,35,0,128,152,35,21,202,162,35,0,70,195,35,0,0,0,36,0,104,10,36,224,182,53,36,128,188,125,36,0,0,159,36,246,149,169,36,0,48,20,37,64,190,64,37,0,0,128,37,0,215,138,37,212,243,183,37,0,0,248,37,176,249,2,38,0,160,37,38,0,128,113,38,0,178,159,38,0,0,16,39,160,74,27,39,0,0,141,39,194,110,152,39,0,0,0,40,0,144,11,40,192,174,59,40,0,0,128,40,0,181,139,40,188,109,188,40,0,224,50,41,0,182,182,41,8,214,232,41,0,0,48,42,224,49,60,42,0,0,183,42,0,84,234,42,0,176,63,43,64,168,115,43,243,222,167,43,0,0,242,43,244,179,254,43,0,160,126,44,128,23,180,44,0,0,0,45,0,2,13,45,152,36,67,45,0,0,144,45,160,43,157,45,0,192,198,45,0,60,89,46,208,237,144,46,0,0,224,46,192,140,237,46,201,240,37,47,0,0,118,47,28,184,131,47,0,8,175,47,0,0,0,48,0,224,13,48,128,158,71,48,0,166,167,48,0,0,212,48,72,29,226,48,0,64,112,49,0,0,0,50,0,116,14,50,112,154,74,50,0,0,160,50,64,162,174,50,43,137,235,50,0,0,66,51,0,152,127,51,128,99,36,52,138,11,99,52,0,0,188,52,88,62,203,52,0,192,100,53,0,233,164,53,0,0,0,54,0,156,15,54,80,146,80,54,0,128,238,54,241,96,254,54,0,72,158,55,96,29,225,55,0,0,64,56,128,66,80,56,190,237,147,56,0,0,244,56,136,118,4,57,0,112,56,57,0,64,170,57,0,139,239,57,68,41,53,58,0,0,152,58,240,239,168,58,0,128,83,59,35,166,100,59,0,202,154,59,0,0,0,60,0,88,17,60,32,134,89,60,0,0,192,60,128,143,209,60,0,0,9,61,154,164,26,61,0,80,204,61,0,0,128,62,0,17,146,62,12,65,221,62,0,0,72,63,208,74,90,63,0,0,0,64,0,128,18,64,0,126,95,64,0,136,223,64,96,124,45,65,0,0,235,65,238,13,254,65,0,240,189,66,64,35,14,67,0,0,128,67,0,131,147,67,228,182,228,67,0,0,88,68,0,32,170,68,0,218,133,69,184,100,217,69,0,0,80,70,32,83,100,70,0,0,49,71,42,148,69,71,0,140,134,71,0,0,0,72,0,208,20,72,192,109,107,72,149,115,194,72,0,121,251,72,0,0,62,73,236,43,83,73,0,96,40,74,128,124,129,74,0,0,0,75,0,174,21,75,168,231,111,75,0,0,240,75,96,243,5,76,0,64,75,76,0,0,227,76,0,100,63,77,0,0,32,78,64,149,54,78,79,145,148,78,0,0,26,79,132,221,48,79,0,0,0,80,0,32,23,80,128,93,119,80,0,0,0,81,0,106,23,81,120,219,120,81,0,192,101,82,0,108,109,83,16,172,209,83,0,0,96,84,192,99,120,84,157,228,221,84,0,0,110,85,0,168,212,85,0,96,127,86,128,80,231,86,230,189,79,87,0,0,228,87,232,103,253,87,0,64,253,88,0,47,104,89,0,0,0,90,0,4,26,90,48,73,134,90,0,0,32,91,64,87,58,91,0,128,141,91,231,246,167,91,0,120,178,92,160,219,33,93,0,0,192,93,128,25,219,93,146,225,75,94,0,0,236,94,56,112,7,95,0,16,94,95,0,0,0,96,0,192,27,96,0,61,143,96,0,76,79,97,0,0,168,97,144,58,196,97,0,128,224,98,229,20,253,98,0,0,0,100,0,232,28,100,224,52,149,100,0,0,64,101,128,68,93,101,86,18,215,101,0,0,132,102,0,48,255,102,0,199,72,104,20,23,198,104,0,0,120,105,176,124,150,105,0,128,201,106,0,210,73,107,0,0,0,108,0,56,31,108,160,36,161,108,0,0,221,109,226,193,252,109,0,144,60,111,192,58,194,111,0,0,128,112,0,133,160,112,124,219,39,113,0,0,232,113,16,237,8,114,0,224,112,114,0,128,84,115,0,22,223,115,136,82,106,116,0,0,48,117,224,223,81,117,0,0,167,118,70,76,201,118,0,148,53,119,0,0,0,120,0,176,34,120,64,12,179,120,0,0,128,121,0,31,163,121,0,0,18,122,52,73,53,122,0,160,152,123,0,0,0,125,0,34,36,125,24,130,186,125,0,0,144,126,160,149,180,126,0,0,0,0,96,44,0,0,19,0,0,0,24,0,0,0,11,0,0,0,0,0,0,0,80,44,0,0,19,0,0,0,25,0,0,0,12,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,187,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,48,187,0,0,0,0,0,0,136,48,0,0,26,0,0,0,27,0,0,0,19,0,0,0,16,0,0,0,1,0,0,0,17,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,44,0,0,0,45,0,0,0,22,0,0,0,23,0,0,0,46,0,0,0,20,0,0,0,32,188,0,0,172,187,0,0,0,0,0,0,152,48,0,0,26,0,0,0,28,0,0,0,21,0,0,0,24,0,0,0,1,0,0,0,17,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,44,0,0,0,45,0,0,0,25,0,0,0,23,0,0,0,46,0,0,0,20,0,0,0,0,0,0,0,168,48,0,0,26,0,0,0,29,0,0,0,22,0,0,0,26,0,0,0,1,0,0,0,17,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,44,0,0,0,45,0,0,0,25,0,0,0,23,0,0,0,46,0,0,0,20,0,0,0,0,190,0,0,20,189,0,0,160,188,0,0,0,0,0,0,184,48,0,0,26,0,0,0,30,0,0,0,23,0,0,0,27,0,0,0,1,0,0,0,17,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,28,0,0,0,19,0,0,0,29,0,0,0,21,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,44,0,0,0,47,0,0,0,25,0,0,0,23,0,0,0,46,0,0,0,20,0,0,0,0,0,0,0,200,48,0,0,26,0,0,0,31,0,0,0,24,0,0,0,30,0,0,0,1,0,0,0,17,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,18,0,0,0,31,0,0,0,20,0,0,0,32,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,48,0,0,0,49,0,0,0,25,0,0,0,23,0,0,0,46,0,0,0,20,0,0,0,140,189,0,0,0,0,0,0,216,48,0,0,26,0,0,0,32,0,0,0,25,0,0,0,33,0,0,0,1,0,0,0,17,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,4,0,0,0,2,0,0,0,3,0,0,0,44,0,0,0,45,0,0,0,25,0,0,0,23,0,0,0,46,0,0,0,20,0,0,0,0,0,0,0,232,48,0,0,26,0,0,0,33,0,0,0,26,0,0,0,34,0,0,0,1,0,0,0,17,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,5,0,0,0,2,0,0,0,1,0,0,0,44,0,0,0,50,0,0,0,25,0,0,0,23,0,0,0,46,0,0,0,20,0,0,0,0,0,0,0,248,48,0,0,26,0,0,0,34,0,0,0,27,0,0,0,35,0,0,0,1,0,0,0,17,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,44,0,0,0,45,0,0,0,25,0,0,0,23,0,0,0,46,0,0,0,20,0,0,0,0,0,0,0,8,49,0,0,26,0,0,0,35,0,0,0,28,0,0,0,36,0,0,0,1,0,0,0,17,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,6,0,0,0,2,0,0,0,1,0,0,0,44,0,0,0,45,0,0,0,25,0,0,0,23,0,0,0,46,0,0,0,20,0,0,0,116,190,0,0,0,0,0,0,32,49,0,0,19,0,0,0,20,0,0,0,13,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,56,49,0,0,39,0,0,0,40,0,0,0,1,0,0,0,6,0,0,0,14,0,0,0,51,0,0,0,15,0,0,0,113,0,0,0,114,0,0,0,1,0,0,0,29,0,0,0,0,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,0,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,120,107,0,0,41,0,0,0,42,0,0,0,200,255,255,255,200,255,255,255,120,107,0,0,43,0,0,0,44,0,0,0,56,0,0,0,0,0,0,0,88,49,0,0,45,0,0,0,46,0,0,0,200,255,255,255,200,255,255,255,88,49,0,0,47,0,0,0,48,0,0,0,0,0,0,0,72,49,0,0,49,0,0,0,50,0,0,0,16,0,0,0,1,0,0,0,26,0,0,0,37,0,0,0,21,0,0,0,22,0,0,0,2,0,0,0,23,0,0,0,24,0,0,0,30,0,0,0,3,0,0,0,31,0,0,0,0,0,0,0,112,49,0,0,51,0,0,0,52,0,0,0,7,0,0,0,25,0,0,0,53,0,0,0,17,0,0,0,0,0,0,0,120,49,0,0,21,0,0,0,54,0,0,0,55,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,32,0,0,0,32,0,0,0,33,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,0,0,0,0,136,49,0,0,19,0,0,0,56,0,0,0,18,0,0,0,0,0,0,0,152,49,0,0,57,0,0,0,58,0,0,0,26,0,0,0,0,0,0,0,168,49,0,0,59,0,0,0,60,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,176,49,0,0,61,0,0,0,62,0,0,0,27,0,0,0,19,0,0,0,0,0,0,195,0,0,254,194,0,0,252,194,0,0,250,194,0,0,248,194,0,0,246,194,0,0,244,194,0,0,242,194,0,0,240,194,0,0,238,194,0,0,236,194,0,0,234,194,0,0,232,194,0,0,230,194,0,0,228,194,0,0,226,194,0,0,224,194,0,0,222,194,0,0,220,194,0,0,218,194,0,0,216,194,0,0,214,194,0,0,212,194,0,0,210,194,0,0,208,194,0,0,206,194,0,0,204,194,0,0,202,194,0,0,200,194,0,0,198,194,0,0,196,194,0,0,194,194,0,0,192,194,0,0,190,194,0,0,188,194,0,0,186,194,0,0,184,194,0,0,182,194,0,0,180,194,0,0,178,194,0,0,176,194,0,0,174,194,0,0,172,194,0,0,170,194,0,0,168,194,0,0,166,194,0,0,164,194,0,0,162,194,0,0,160,194,0,0,158,194,0,0,156,194,0,0,154,194,0,0,152,194,0,0,150,194,0,0,148,194,0,0,146,194,0,0,144,194,0,0,142,194,0,0,140,194,0,0,138,194,0,0,136,194,0,0,134,194,0,0,132,194,0,0,130,194,0,0,128,194,0,0,124,194,0,0,120,194,0,0,116,194,0,0,112,194,0,0,108,194,0,0,104,194,0,0,100,194,0,0,96,194,0,0,92,194,0,0,88,194,0,0,84,194,0,0,80,194,0,0,76,194,0,0,72,194,0,0,68,194,0,0,64,194,0,0,60,194,0,0,56,194,0,0,52,194,0,0,48,194,0,0,44,194,0,0,40,194,0,0,36,194,0,0,32,194,0,0,28,194,0,0,24,194,0,0,20,194,0,0,16,194,0,0,12,194,0,0,8,194,0,0,4,194,0,0,0,194,0,0,248,193,0,0,240,193,0,0,232,193,0,0,224,193,0,0,216,193,0,0,208,193,0,0,200,193,0,0,192,193,0,0,184,193,0,0,176,193,0,0,168,193,0,0,160,193,0,0,152,193,0,0,144,193,0,0,136,193,0,0,128,193,0,0,112,193,0,0,96,193,0,0,80,193,0,0,64,193,0,0,48,193,0,0,32,193,0,0,16,193,0,0,0,193,0,0,224,192,0,0,192,192,0,0,160,192,0,0,128,192,0,0,64,192,0,0,0,192,0,0,128,191,0,0,0,0,0,0,128,63,0,0,0,64,0,0,64,64,0,0,128,64,0,0,160,64,0,0,192,64,0,0,224,64,0,0,0,65,0,0,16,65,0,0,32,65,0,0,48,65,0,0,64,65,0,0,80,65,0,0,96,65,0,0,112,65,0,0,128,65,0,0,136,65,0,0,144,65,0,0,152,65,0,0,160,65,0,0,168,65,0,0,176,65,0,0,184,65,0,0,192,65,0,0,200,65,0,0,208,65,0,0,216,65,0,0,224,65,0,0,232,65,0,0,240,65,0,0,248,65,0,0,0,66,0,0,4,66,0,0,8,66,0,0,12,66,0,0,16,66,0,0,20,66,0,0,24,66,0,0,28,66,0,0,32,66,0,0,36,66,0,0,40,66,0,0,44,66,0,0,48,66,0,0,52,66,0,0,56,66,0,0,60,66,0,0,64,66,0,0,68,66,0,0,72,66,0,0,76,66,0,0,80,66,0,0,84,66,0,0,88,66,0,0,92,66,0,0,96,66,0,0,100,66,0,0,104,66,0,0,108,66,0,0,112,66,0,0,116,66,0,0,120,66,0,0,124,66,0,0,128,66,0,0,130,66,0,0,132,66,0,0,134,66,0,0,136,66,0,0,138,66,0,0,140,66,0,0,142,66,0,0,144,66,0,0,146,66,0,0,148,66,0,0,150,66,0,0,152,66,0,0,154,66,0,0,156,66,0,0,158,66,0,0,160,66,0,0,162,66,0,0,164,66,0,0,166,66,0,0,168,66,0,0,170,66,0,0,172,66,0,0,174,66,0,0,176,66,0,0,178,66,0,0,180,66,0,0,182,66,0,0,184,66,0,0,186,66,0,0,188,66,0,0,190,66,0,0,192,66,0,0,194,66,0,0,196,66,0,0,198,66,0,0,200,66,0,0,202,66,0,0,204,66,0,0,206,66,0,0,208,66,0,0,210,66,0,0,212,66,0,0,214,66,0,0,216,66,0,0,218,66,0,0,220,66,0,0,222,66,0,0,224,66,0,0,226,66,0,0,228,66,0,0,230,66,0,0,232,66,0,0,234,66,0,0,236,66,0,0,238,66,0,0,240,66,0,0,242,66,0,0,244,66,0,0,246,66,0,0,248,66,0,0,250,66,0,0,252,66,0,0,254,66,0,0,0,67,0,0,1,67,0,0,2,67,0,0,3,67,0,0,4,67,0,0,5,67,0,0,6,67,0,0,7,67,0,0,8,67,0,0,9,67,0,0,10,67,0,0,11,67,0,0,12,67,0,0,13,67,0,0,14,67,0,0,15,67,0,0,16,67,0,0,17,67],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+40960);allocate([0,0,18,67,0,0,19,67,0,0,20,67,0,0,21,67,0,0,22,67,0,0,23,67,0,0,24,67,0,0,25,67,0,0,26,67,0,0,27,67,0,0,28,67,0,0,29,67,0,0,30,67,0,0,31,67,0,0,32,67,0,0,33,67,0,0,34,67,0,0,35,67,0,0,36,67,0,0,37,67,0,0,38,67,0,0,39,67,0,0,40,67,0,0,41,67,0,0,42,67,0,0,43,67,0,0,44,67,0,0,45,67,0,0,46,67,0,0,47,67,0,0,48,67,0,0,49,67,0,0,50,67,0,0,51,67,0,0,52,67,0,0,53,67,0,0,54,67,0,0,55,67,0,0,56,67,0,0,57,67,0,0,58,67,0,0,59,67,0,0,60,67,0,0,61,67,0,0,62,67,0,0,63,67,0,0,64,67,0,0,65,67,0,0,66,67,0,0,67,67,0,0,68,67,0,0,69,67,0,0,70,67,0,0,71,67,0,0,72,67,0,0,73,67,0,0,74,67,0,0,75,67,0,0,76,67,0,0,77,67,0,0,78,67,0,0,79,67,0,0,80,67,0,0,81,67,0,0,82,67,0,0,83,67,0,0,84,67,0,0,85,67,0,0,86,67,0,0,87,67,0,0,88,67,0,0,89,67,0,0,90,67,0,0,91,67,0,0,92,67,0,0,93,67,0,0,94,67,0,0,95,67,0,0,96,67,0,0,97,67,0,0,98,67,0,0,99,67,0,0,100,67,0,0,101,67,0,0,102,67,0,0,103,67,0,0,104,67,0,0,105,67,0,0,106,67,0,0,107,67,0,0,108,67,0,0,109,67,0,0,110,67,0,0,111,67,0,0,112,67,0,0,113,67,0,0,114,67,0,0,115,67,0,0,116,67,0,0,117,67,0,0,118,67,0,0,119,67,0,0,120,67,0,0,121,67,0,0,122,67,0,0,123,67,0,0,124,67,0,0,125,67,0,0,126,67,0,0,127,67,168,151,3,0,168,151,3,0,183,131,15,0,183,131,15,0,173,151,3,0,177,151,3,0,173,151,3,0,181,151,3,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,216,49,0,0,63,0,0,0,64,0,0,0,65,0,0,0,20,0,0,0,21,0,0,0,28,0,0,0,22,0,0,0,23,0,0,0,76,0,0,0,1,0,0,0,1,0,0,0,24,0,0,0,25,0,0,0,66,0,0,0,0,0,0,0,200,49,0,0,21,0,0,0,67,0,0,0,68,0,0,0,0,0,0,0,88,50,0,0,69,0,0,0,70,0,0,0,26,0,0,0,0,0,0,0,72,50,0,0,21,0,0,0,71,0,0,0,72,0,0,0,0,0,0,0,56,50,0,0,73,0,0,0,74,0,0,0,27,0,0,0,0,0,0,0,40,50,0,0,21,0,0,0,75,0,0,0,76,0,0,0,0,0,0,0,24,50,0,0,77,0,0,0,78,0,0,0,28,0,0,0,0,0,0,0,8,50,0,0,21,0,0,0,79,0,0,0,80,0,0,0,0,0,0,0,248,49,0,0,81,0,0,0,82,0,0,0,29,0,0,0,0,0,0,0,232,49,0,0,21,0,0,0,83,0,0,0,84,0,0,0,0,0,0,0,232,54,0,0,19,0,0,0,85,0,0,0,30,0,0,0,0,0,0,0,216,54,0,0,19,0,0,0,86,0,0,0,31,0,0,0,0,0,0,0,200,54,0,0,19,0,0,0,87,0,0,0,32,0,0,0,0,0,0,0,184,54,0,0,19,0,0,0,88,0,0,0,33,0,0,0,0,0,0,0,168,54,0,0,19,0,0,0,89,0,0,0,34,0,0,0,0,0,0,0,152,54,0,0,19,0,0,0,90,0,0,0,35,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,0,0,0,0,136,54,0,0,19,0,0,0,91,0,0,0,36,0,0,0,135,22,153,62,162,69,22,63,213,120,233,61,0,0,0,0,120,54,0,0,19,0,0,0,92,0,0,0,37,0,0,0,0,0,0,0,104,54,0,0,19,0,0,0,93,0,0,0,38,0,0,0,0,0,0,0,88,54,0,0,19,0,0,0,94,0,0,0,39,0,0,0,0,0,0,0,72,54,0,0,19,0,0,0,95,0,0,0,40,0,0,0,0,0,0,0,56,54,0,0,19,0,0,0,96,0,0,0,41,0,0,0,0,0,0,0,40,54,0,0,19,0,0,0,97,0,0,0,42,0,0,0,76,7,0,0,145,37,0,0,35,19,0,0,125,31,0,0,33,56,0,0,0,0,0,0,24,54,0,0,19,0,0,0,98,0,0,0,43,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,162,45,0,0,25,36,0,0,0,0,0,0,8,54,0,0,19,0,0,0,99,0,0,0,44,0,0,0,135,22,153,62,162,69,22,63,213,120,233,61,43,135,54,63,78,98,16,63,213,120,233,61,162,69,22,63,135,22,153,62,109,231,251,62,18,131,96,63,0,0,0,0,248,53,0,0,19,0,0,0,100,0,0,0,45,0,0,0,12,130,0,0,184,230,255,255,209,218,255,255,246,72,0,0,0,0,0,0,232,53,0,0,19,0,0,0,101,0,0,0,46,0,0,0,203,89,0,0,78,210,255,255,252,233,255,255,121,113,0,0,0,0,0,0,216,53,0,0,19,0,0,0,102,0,0,0,47,0,0,0,129,149,179,63,180,200,54,191,197,32,176,190,170,241,226,63,74,12,2,64,113,61,202,190,106,188,20,191,133,235,145,63,0,0,0,0,200,53,0,0,19,0,0,0,103,0,0,0,48,0,0,0,0,0,0,0,184,53,0,0,19,0,0,0,104,0,0,0,49,0,0,0,0,0,0,0,168,53,0,0,19,0,0,0,105,0,0,0,50,0,0,0,10,45,211,62,186,20,183,62,207,192,56,62,109,198,89,62,186,20,55,63,87,205,147,61,86,98,158,60,118,27,244,61,20,66,115,63,0,0,0,0,152,53,0,0,19,0,0,0,106,0,0,0,51,0,0,0,0,0,0,0,136,53,0,0,19,0,0,0,107,0,0,0,52,0,0,0,0,0,0,0,120,53,0,0,19,0,0,0,108,0,0,0,53,0,0,0,2,100,79,64,85,193,196,191,251,63,255,190,41,33,120,191,121,32,240,63,160,54,42,61,40,239,99,61,166,240,80,190,248,85,135,63,0,0,0,0,104,53,0,0,19,0,0,0,109,0,0,0,54,0,0,0,0,0,0,0,88,53,0,0,19,0,0,0,110,0,0,0,55,0,0,0,0,0,0,0,72,53,0,0,19,0,0,0,111,0,0,0,56,0,0,0,0,0,0,0,56,53,0,0,19,0,0,0,112,0,0,0,57,0,0,0,0,0,0,0,40,53,0,0,19,0,0,0,113,0,0,0,58,0,0,0,0,0,0,0,24,53,0,0,19,0,0,0,114,0,0,0,59,0,0,0,0,0,0,0,8,53,0,0,19,0,0,0,115,0,0,0,60,0,0,0,0,0,0,0,248,52,0,0,19,0,0,0,116,0,0,0,61,0,0,0,0,0,0,0,232,52,0,0,19,0,0,0,117,0,0,0,62,0,0,0,0,0,0,0,216,52,0,0,19,0,0,0,118,0,0,0,63,0,0,0,0,0,0,0,200,52,0,0,19,0,0,0,119,0,0,0,64,0,0,0,0,0,0,0,184,52,0,0,19,0,0,0,120,0,0,0,65,0,0,0,0,0,0,0,168,52,0,0,19,0,0,0,121,0,0,0,66,0,0,0,0,0,0,0,152,52,0,0,19,0,0,0,122,0,0,0,67,0,0,0,0,0,0,0,136,52,0,0,19,0,0,0,123,0,0,0,68,0,0,0,0,0,0,0,120,52,0,0,19,0,0,0,124,0,0,0,69,0,0,0,0,0,0,0,104,52,0,0,19,0,0,0,125,0,0,0,70,0,0,0,0,0,0,0,88,52,0,0,19,0,0,0,126,0,0,0,71,0,0,0,0,0,0,0,72,52,0,0,19,0,0,0,127,0,0,0,72,0,0,0,0,0,0,0,56,52,0,0,19,0,0,0,128,0,0,0,73,0,0,0,0,0,0,0,40,52,0,0,19,0,0,0,129,0,0,0,74,0,0,0,0,0,0,0,24,52,0,0,19,0,0,0,130,0,0,0,75,0,0,0,0,0,0,0,8,52,0,0,19,0,0,0,131,0,0,0,76,0,0,0,0,0,0,0,248,51,0,0,19,0,0,0,132,0,0,0,77,0,0,0,0,0,0,0,232,51,0,0,19,0,0,0,133,0,0,0,78,0,0,0,0,0,0,0,216,51,0,0,19,0,0,0,134,0,0,0,79,0,0,0,0,0,0,0,200,51,0,0,19,0,0,0,135,0,0,0,80,0,0,0,0,0,0,0,184,51,0,0,19,0,0,0,136,0,0,0,81,0,0,0,0,0,0,0,168,51,0,0,19,0,0,0,137,0,0,0,82,0,0,0,0,0,0,0,152,51,0,0,19,0,0,0,138,0,0,0,83,0,0,0,0,0,0,0,136,51,0,0,19,0,0,0,139,0,0,0,84,0,0,0,0,0,0,0,120,51,0,0,19,0,0,0,140,0,0,0,85,0,0,0,0,0,0,0,104,51,0,0,19,0,0,0,141,0,0,0,86,0,0,0,0,0,0,0,88,51,0,0,19,0,0,0,142,0,0,0,87,0,0,0,0,0,0,0,72,51,0,0,19,0,0,0,143,0,0,0,88,0,0,0,0,0,0,0,56,51,0,0,19,0,0,0,144,0,0,0,89,0,0,0,0,0,0,0,40,51,0,0,19,0,0,0,145,0,0,0,90,0,0,0,0,0,0,0,24,51,0,0,19,0,0,0,146,0,0,0,91,0,0,0,0,0,0,0,8,51,0,0,19,0,0,0,147,0,0,0,92,0,0,0,0,0,0,0,248,50,0,0,19,0,0,0,148,0,0,0,93,0,0,0,0,0,0,0,232,50,0,0,19,0,0,0,149,0,0,0,94,0,0,0,0,0,0,0,216,50,0,0,19,0,0,0,150,0,0,0,95,0,0,0,0,0,0,0,200,50,0,0,19,0,0,0,151,0,0,0,96,0,0,0,0,0,0,0,184,50,0,0,19,0,0,0,152,0,0,0,97,0,0,0,0,0,0,0,168,50,0,0,19,0,0,0,153,0,0,0,98,0,0,0,0,0,0,0,152,50,0,0,19,0,0,0,154,0,0,0,99,0,0,0,0,0,0,0,136,50,0,0,19,0,0,0,155,0,0,0,100,0,0,0,0,0,0,0,120,50,0,0,19,0,0,0,156,0,0,0,101,0,0,0,0,0,0,0,104,50,0,0,19,0,0,0,157,0,0,0,102,0,0,0,3,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,192,55,0,0,158,0,0,0,159,0,0,0,103,0,0,0,0,0,0,0,8,55,0,0,158,0,0,0,160,0,0,0,1,0,0,0,0,0,0,0,176,55,0,0,158,0,0,0,161,0,0,0,104,0,0,0,0,0,0,0,160,55,0,0,158,0,0,0,162,0,0,0,105,0,0,0,0,0,0,0,144,55,0,0,158,0,0,0,163,0,0,0,106,0,0,0,0,0,0,0,128,55,0,0,158,0,0,0,164,0,0,0,107,0,0,0,0,0,0,0,112,55,0,0,158,0,0,0,165,0,0,0,108,0,0,0,0,0,0,0,96,55,0,0,158,0,0,0,166,0,0,0,109,0,0,0,0,0,0,0,80,55,0,0,158,0,0,0,167,0,0,0,110,0,0,0,0,0,0,0,64,55,0,0,158,0,0,0,168,0,0,0,111,0,0,0,0,0,0,0,48,55,0,0,158,0,0,0,169,0,0,0,112,0,0,0,0,0,0,0,32,55,0,0,158,0,0,0,170,0,0,0,113,0,0,0,0,0,0,0,16,55,0,0,158,0,0,0,171,0,0,0,114,0,0,0,0,0,0,0,248,54,0,0,158,0,0,0,172,0,0,0,115,0,0,0,0,0,0,0,205,204,204,61,205,204,76,62,154,153,153,62,205,204,204,62,0,0,0,63,154,153,25,63,51,51,51,63,205,204,76,63,102,102,102,63,0,0,128,63,0,0,128,63,51,51,115,63,102,102,102,63,154,153,89,63,205,204,76,63,0,0,64,63,51,51,51,63,102,102,38,63,154,153,25,63,205,204,12,63,0,0,0,63,0,0,0,0,33,8,130,60,33,8,2,61,49,12,67,61,33,8,130,61,41,138,162,61,49,12,195,61,57,142,227,61,33,8,2,62,37,73,18,62,41,138,34,62,45,203,50,62,49,12,67,62,53,77,83,62,57,142,99,62,61,207,115,62,33,8,130,62,163,40,138,62,37,73,146,62,167,105,154,62,41,138,162,62,171,170,170,62,45,203,178,62,175,235,186,62,49,12,195,62,179,44,203,62,53,77,211,62,183,109,219,62,57,142,227,62,187,174,235,62,61,207,243,62,191,239,251,62,33,8,2,63,98,24,6,63,163,40,10,63,228,56,14,63,37,73,18,63,102,89,22,63,167,105,26,63,232,121,30,63,41,138,34,63,106,154,38,63,171,170,42,63,236,186,46,63,45,203,50,63,110,219,54,63,175,235,58,63,240,251,62,63,49,12,67,63,114,28,71,63,179,44,75,63,244,60,79,63,53,77,83,63,118,93,87,63,183,109,91,63,248,125,95,63,57,142,99,63,122,158,103,63,187,174,107,63,252,190,111,63,61,207,115,63,126,223,119,63,191,239,123,63,0,0,128,63,0,0,0,63,33,8,2,63,65,16,4,63,98,24,6,63,130,32,8,63,163,40,10,63,195,48,12,63,228,56,14,63,4,65,16,63,37,73,18,63,69,81,20,63,102,89,22,63,134,97,24,63,167,105,26,63,199,113,28,63,232,121,30,63,8,130,32,63,41,138,34,63,73,146,36,63,106,154,38,63,138,162,40,63,171,170,42,63,203,178,44,63,236,186,46,63,12,195,48,63,45,203,50,63,77,211,52,63,110,219,54,63,142,227,56,63,175,235,58,63,207,243,60,63,240,251,62,63,16,4,65,63,49,12,67,63,81,20,69,63,114,28,71,63,146,36,73,63,179,44,75,63,211,52,77,63,244,60,79,63,20,69,81,63,53,77,83,63,85,85,85,63,118,93,87,63,150,101,89,63,183,109,91,63,215,117,93,63,248,125,95,63,24,134,97,63,57,142,99,63,89,150,101,63,122,158,103,63,154,166,105,63,187,174,107,63,219,182,109,63,252,190,111,63,28,199,113,63,61,207,115,63,93,215,117,63,126,223,119,63,158,231,121,63,191,239,123,63,223,247,125,63,0,0,128,63,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,205,204,204,62,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,191,239,123,63,126,223,119,63,61,207,115,63,252,190,111,63,187,174,107,63,122,158,103,63,57,142,99,63,248,125,95,63,183,109,91,63,118,93,87,63,53,77,83,63,244,60,79,63,179,44,75,63,114,28,71,63,49,12,67,63,240,251,62,63,175,235,58,63,110,219,54,63,45,203,50,63,236,186,46,63,171,170,42,63,106,154,38,63,41,138,34,63,232,121,30,63,167,105,26,63,102,89,22,63,37,73,18,63,228,56,14,63,163,40,10,63,98,24,6,63,33,8,2,63,191,239,251,62,61,207,243,62,187,174,235,62,57,142,227,62,183,109,219,62,53,77,211,62,179,44,203,62,49,12,195,62,175,235,186,62,45,203,178,62,171,170,170,62,41,138,162,62,167,105,154,62,37,73,146,62,163,40,138,62,33,8,130,62,61,207,115,62,57,142,99,62,53,77,83,62,49,12,67,62,45,203,50,62,41,138,34,62,37,73,18,62,33,8,2,62,57,142,227,61,49,12,195,61,41,138,162,61,33,8,130,61,49,12,67,61,33,8,2,61,33,8,130,60,0,0,0,0,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,252,190,111,63,183,109,91,63,114,28,71,63,45,203,50,63,232,121,30,63,163,40,10,63,187,174,235,62,49,12,195,62,167,105,154,62,57,142,99,62,37,73,18,62,33,8,130,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,33,8,2,61,43,96,173,61,35,222,12,62,49,12,67,62,62,58,121,62,38,180,151,62,45,203,178,62,51,226,205,62,58,249,232,62,33,8,2,63,164,147,15,63,39,31,29,63,171,170,42,63,0,0,0,0,41,138,34,61,41,138,162,61,61,207,243,61,41,138,34,62,179,44,75,62,61,207,115,62,228,56,142,62,41,138,162,62,110,219,182,62,179,44,203,62,248,125,223,62,61,207,243,62,65,16,4,63,228,56,14,63,134,97,24,63,41,138,34,63,203,178,44,63,110,219,54,63,16,4,65,63,179,44,75,63,85,85,85,63,248,125,95,63,154,166,105,63,61,207,115,63,223,247,125,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,191,239,123,63,122,158,103,63,53,77,83,63,240,251,62,63,171,170,42,63,102,89,22,63,33,8,2,63,183,109,219,62,45,203,178,62,163,40,138,62,49,12,67,62,57,142,227,61,33,8,2,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,33,8,130,60,49,12,195,61,45,203,50,62,33,8,130,62,171,170,170,62,53,77,211,62,191,239,251,62,37,73,18,63,106,154,38,63,175,235,58,63,244,60,79,63,57,142,99,63,126,223,119,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,0,0,245,231,32,62,57,142,99,62,72,89,139,62,245,231,160,62,2,230,179,62,163,17,197,62,214,219,212,62,57,142,227,62,239,91,241,62,51,106,254,62,145,106,5,63,72,89,11,63,237,9,17,63,140,131,22,63,241,203,27,63,245,231,32,63,178,219,37,63,171,170,42,63,229,87,47,63,2,230,51,63,80,87,56,63,217,173,60,63,107,235,64,63,233,47,68,63,91,242,69,63,214,176,71,63,115,107,73,63,75,34,75,63,120,213,76,63,15,133,78,63,40,49,80,63,215,217,81,63,50,127,83,63,76,33,85,63,55,192,86,63,7,92,88,63,205,244,89,63,154,138,91,63,126,29,93,63,138,173,94,63,203,58,96,63,82,197,97,63,44,77,99,63,102,210,100,63,15,85,102,63,51,213,103,63,223,82,105,63,31,206,106,63,253,70,108,63,134,189,109,63,197,49,111,63,196,163,112,63,142,19,114,63,44,129,115,63,168,236,116,63,12,86,118,63,96,189,119,63,175,34,121,63,0,134,122,63,91,231,123,63,202,70,125,63,84,164,126,63,0,0,128,63,0,0,0,0,238,172,210,61,87,248,20,62,74,115,54,62,238,172,82,62,217,138,107,62,10,3,129,62,72,89,139,62,87,248,148,62,179,1,158,62,186,141,166,62,211,174,174,62,74,115,182,62,124,230,189,62,163,17,197,62,86,252,203,62,238,172,210,62,203,40,217,62,131,116,223,62,12,148,229,62,217,138,235,62,239,91,241,62,247,9,247,62,80,151,252,62,76,89,2,63,46,106,8,63,228,56,14,63,58,205,19,63,147,45,25,63,57,95,30,63,161,102,35,63,148,71,40,63,83,5,45,63,176,162,49,63,33,34,54,63,207,133,58,63,166,207,62,63,90,1,67,63,114,28,71,63,75,34,75,63,36,20,79,63,28,243,82,63,55,192,86,63,101,124,90,63,129,40,94,63,82,197,97,63,146,83,101,63,235,211,104,63,31,206,106,63,253,70,108,63,134,189,109,63,197,49,111,63,196,163,112,63,142,19,114,63,44,129,115,63,168,236,116,63,12,86,118,63,96,189,119,63,175,34,121,63,0,134,122,63,91,231,123,63,202,70,125,63,84,164,126,63,0,0,128,63,0,0,0,0,238,172,210,61,87,248,20,62,74,115,54,62,238,172,82,62,217,138,107,62,10,3,129,62,72,89,139,62,87,248,148,62,179,1,158,62,186,141,166,62,211,174,174,62,74,115,182,62,124,230,189,62,163,17,197,62,86,252,203,62,238,172,210,62,203,40,217,62,131,116,223,62,12,148,229,62,217,138,235,62,239,91,241,62,247,9,247,62,80,151,252,62,10,3,1,63,21,172,3,63,162,71,6,63,119,214,8,63,72,89,11,63,183,208,13,63,90,61,16,63,187,159,18,63,87,248,20,63,163,71,23,63,10,142,25,63,241,203,27,63,179,1,30,63,167,47,32,63,29,86,34,63,97,117,36,63,186,141,38,63,104,159,40,63,171,170,42,63,188,175,44,63,211,174,46,63,35,168,48,63,222,155,50,63,49,138,52,63,121,71,57,63,166,207,62,63,233,47,68,63,115,107,73,63,15,133,78,63,50,127,83,63,7,92,88,63,126,29,93,63,82,197,97,63,15,85,102,63,31,206,106,63,197,49,111,63,44,129,115,63,96,189,119,63,91,231,123,63,0,0,128,63,134,201,84,62,202,84,65,60,46,144,160,61,18,131,192,60,211,222,96,62,92,143,18,63,35,219,89,63,173,250,124,63,231,251,121,63,30,167,40,62,39,194,198,62,148,135,5,63,135,167,39,63,94,186,57,63,119,190,63,63,245,185,58,63,251,203,78,63,22,251,123,63,194,134,7,63,247,228,97,63,161,214,84,63,180,200,70,63,27,158,30,63,121,233,230,62,150,178,172,62,199,186,56,62,211,222,96,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,49,12,67,61,49,12,195,61,37,73,18,62,49,12,67,62,61,207,115,62,37,73,146,62,171,170,170,62,49,12,195,62,183,109,219,62,61,207,243,62,98,24,6,63,37,73,18,63,232,121,30,63,171,170,42,63,110,219,54,63,49,12,67,63,244,60,79,63,183,109,91,63,122,158,103,63,61,207,115,63,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,49,12,195,60,49,12,67,61,37,73,146,61,49,12,195,61,61,207,243,61,37,73,18,62,171,170,42,62,49,12,67,62,183,109,91,62,61,207,115,62,98,24,134,62,37,73,146,62,232,121,158,62,171,170,170,62,110,219,182,62,49,12,195,62,244,60,207,62,183,109,219,62,122,158,231,62,61,207,243,62,0,0,0,63,98,24,6,63,195,48,12,63,37,73,18,63,134,97,24,63,232,121,30,63,73,146,36,63,171,170,42,63,12,195,48,63,110,219,54,63,207,243,60,63,49,12,67,63,146,36,73,63,244,60,79,63,85,85,85,63,183,109,91,63,24,134,97,63,122,158,103,63,219,182,109,63,61,207,115,63,158,231,121,63,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,193,192,192,59,177,176,176,60,153,152,24,61,217,216,88,61,141,140,140,61,173,172,172,61,205,204,204,61,237,236,236,61,135,134,6,62,151,150,22,62,167,166,38,62,183,182,54,62,199,198,70,62,215,214,86,62,231,230,102,62,247,246,118,62,132,131,131,62,140,139,139,62,148,147,147,62,156,155,155,62,164,163,163,62,172,171,171,62,180,179,179,62,188,187,187,62,196,195,195,62,204,203,203,62,212,211,211,62,220,219,219,62,228,227,227,62,236,235,235,62,244,243,243,62,252,251,251,62,2,2,2,63,6,6,6,63,10,10,10,63,14,14,14,63,18,18,18,63,22,22,22,63,26,26,26,63,30,30,30,63,34,34,34,63,38,38,38,63,42,42,42,63,46,46,46,63,50,50,50,63,54,54,54,63,58,58,58,63,62,62,62,63,66,66,66,63,70,70,70,63,74,74,74,63,78,78,78,63,82,82,82,63,86,86,86,63,90,90,90,63,94,94,94,63,98,98,98,63,102,102,102,63,106,106,106,63,110,110,110,63,114,114,114,63,118,118,118,63,122,122,122,63,126,126,126,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,124,124,124,63,120,120,120,63,116,116,116,63,112,112,112,63,108,108,108,63,104,104,104,63,100,100,100,63,96,96,96,63,92,92,92,63,88,88,88,63,84,84,84,63,80,80,80,63,76,76,76,63,72,72,72,63,68,68,68,63,64,64,64,63,60,60,60,63,56,56,56,63,52,52,52,63,48,48,48,63,44,44,44,63,40,40,40,63,36,36,36,63,32,32,32,63,28,28,28,63,24,24,24,63,20,20,20,63,16,16,16,63,12,12,12,63,8,8,8,63,4,4,4,63,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,129,128,0,59,145,144,144,60,137,136,8,61,201,200,72,61,133,132,132,61,165,164,164,61,197,196,196,61,229,228,228,61,131,130,2,62,147,146,18,62,163,162,34,62,179,178,50,62,195,194,66,62,211,210,82,62,227,226,98,62,243,242,114,62,130,129,129,62,138,137,137,62,146,145,145,62,154,153,153,62,162,161,161,62,170,169,169,62,178,177,177,62,186,185,185,62,194,193,193,62,202,201,201,62,210,209,209,62,218,217,217,62,226,225,225,62,234,233,233,62,242,241,241,62,250,249,249,62,1,1,1,63,5,5,5,63,9,9,9,63,13,13,13,63,17,17,17,63,21,21,21,63,25,25,25,63,29,29,29,63,33,33,33,63,37,37,37,63,41,41,41,63,45,45,45,63,49,49,49,63,53,53,53,63,57,57,57,63,61,61,61,63,65,65,65,63,69,69,69,63,73,73,73,63,77,77,77,63,81,81,81,63,85,85,85,63,89,89,89,63,93,93,93,63,97,97,97,63,101,101,101,63,105,105,105,63,109,109,109,63,113,113,113,63,117,117,117,63,121,121,121,63,125,125,125,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,125,125,125,63,121,121,121,63,117,117,117,63,113,113,113,63,109,109,109,63,105,105,105,63,101,101,101,63,97,97,97,63,93,93,93,63,89,89,89,63,85,85,85,63,81,81,81,63,77,77,77,63,73,73,73,63,69,69,69,63,65,65,65,63,61,61,61,63,57,57,57,63,53,53,53,63,49,49,49,63,45,45,45,63,41,41,41,63,37,37,37,63,33,33,33,63,29,29,29,63,25,25,25,63,21,21,21,63,17,17,17,63,13,13,13,63,9,9,9,63,5,5,5,63,1,1,1,63,250,249,249,62,242,241,241,62,234,233,233,62,226,225,225,62,218,217,217,62,210,209,209,62,202,201,201,62,194,193,193,62,186,185,185,62,178,177,177,62,170,169,169,62,162,161,161,62,154,153,153,62,146,145,145,62,138,137,137,62,130,129,129,62,243,242,114,62,227,226,98,62,211,210,82,62,195,194,66,62,179,178,50,62,163,162,34,62,147,146,18,62,131,130,2,62,229,228,228,61,197,196,196,61,165,164,164,61,133,132,132,61,201,200,72,61,137,136,8,61,145,144,144,60,129,128,0,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,63,4,4,4,63,8,8,8,63,12,12,12,63,16,16,16,63,20,20,20,63,24,24,24,63,28,28,28,63,32,32,32,63,36,36,36,63,40,40,40,63,44,44,44,63,48,48,48,63,52,52,52,63,56,56,56,63,60,60,60,63,64,64,64,63,68,68,68,63,72,72,72,63,76,76,76,63,80,80,80,63,84,84,84,63,88,88,88,63,92,92,92,63,96,96,96,63,100,100,100,63,104,104,104,63,108,108,108,63,112,112,112,63,116,116,116,63,120,120,120,63,124,124,124,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,126,126,126,63,122,122,122,63,118,118,118,63,114,114,114,63,110,110,110,63,106,106,106,63,102,102,102,63,98,98,98,63,94,94,94,63,90,90,90,63,86,86,86,63,82,82,82,63,78,78,78,63,74,74,74,63,70,70,70,63,66,66,66,63,62,62,62,63,58,58,58,63,54,54,54,63,50,50,50,63,46,46,46,63,42,42,42,63,38,38,38,63,34,34,34,63,30,30,30,63,26,26,26,63,22,22,22,63,18,18,18,63,14,14,14,63,10,10,10,63,6,6,6,63,2,2,2,63,252,251,251,62,244,243,243,62,236,235,235,62,228,227,227,62,220,219,219,62,212,211,211,62,204,203,203,62,196,195,195,62,188,187,187,62,180,179,179,62,172,171,171,62,164,163,163,62,156,155,155,62,148,147,147,62,140,139,139,62,132,131,131,62,247,246,118,62,231,230,102,62,215,214,86,62,199,198,70,62,183,182,54,62,167,166,38,62,151,150,22,62,135,134,6,62,237,236,236,61,205,204,204,61,173,172,172,61,141,140,140,61,217,216,88,61,153,152,24,61,177,176,176,60,193,192,192,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,61,207,115,63,183,109,91,63,49,12,67,63,171,170,42,63,37,73,18,63,61,207,243,62,49,12,195,62,37,73,146,62,49,12,67,62,49,12,195,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,49,12,195,61,49,12,67,62,37,73,146,62,49,12,195,62,61,207,243,62,37,73,18,63,171,170,42,63,49,12,67,63,183,109,91,63,61,207,115,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,0,0,49,12,195,61,49,12,67,62,37,73,146,62,49,12,195,62,61,207,243,62,37,73,18,63,171,170,42,63,49,12,67,63,183,109,91,63,61,207,115,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,61,207,115,63,183,109,91,63,49,12,67,63,171,170,42,63,37,73,18,63,61,207,243,62,49,12,195,62,37,73,146,62,49,12,67,62,49,12,195,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,49,12,195,61,49,12,67,62,37,73,146,62,49,12,195,62,61,207,243,62,37,73,18,63,171,170,42,63,49,12,67,63,183,109,91,63,61,207,115,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+51200);allocate([0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,61,207,115,63,183,109,91,63,49,12,67,63,171,170,42,63,37,73,18,63,61,207,243,62,49,12,195,62,37,73,146,62,49,12,67,62,49,12,195,61,0,0,0,0,0,0,0,0,41,138,34,61,41,138,162,61,61,207,243,61,41,138,34,62,179,44,75,62,61,207,115,62,228,56,142,62,41,138,162,62,110,219,182,62,179,44,203,62,248,125,223,62,61,207,243,62,65,16,4,63,228,56,14,63,134,97,24,63,41,138,34,63,203,178,44,63,110,219,54,63,16,4,65,63,179,44,75,63,85,85,85,63,248,125,95,63,154,166,105,63,61,207,115,63,223,247,125,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,33,8,2,61,37,73,146,61,57,142,227,61,167,105,26,62,49,12,67,62,187,174,107,62,163,40,138,62,232,121,158,62,45,203,178,62,114,28,199,62,183,109,219,62,252,190,239,62,33,8,2,63,195,48,12,63,102,89,22,63,8,130,32,63,171,170,42,63,77,211,52,63,240,251,62,63,146,36,73,63,53,77,83,63,215,117,93,63,122,158,103,63,28,199,113,63,191,239,123,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,49,12,67,61,33,8,2,62,53,77,83,62,37,73,146,62,175,235,186,62,57,142,227,62,98,24,6,63,167,105,26,63,236,186,46,63,49,12,67,63,118,93,87,63,187,174,107,63,0,0,128,63,0,0,0,0,57,142,99,60,57,142,227,60,171,170,42,61,57,142,99,61,228,56,142,61,171,170,170,61,114,28,199,61,57,142,227,61,0,0,0,62,228,56,14,62,199,113,28,62,171,170,42,62,142,227,56,62,114,28,71,62,85,85,85,62,57,142,99,62,28,199,113,62,0,0,128,62,114,28,135,62,228,56,142,62,85,85,149,62,199,113,156,62,57,142,163,62,171,170,170,62,28,199,177,62,142,227,184,62,0,0,192,62,114,28,199,62,228,56,206,62,85,85,213,62,199,113,220,62,57,142,227,62,171,170,234,62,28,199,241,62,142,227,248,62,0,0,0,63,57,142,3,63,114,28,7,63,171,170,10,63,228,56,14,63,28,199,17,63,85,85,21,63,142,227,24,63,199,113,28,63,0,0,32,63,57,142,35,63,114,28,39,63,195,48,44,63,28,199,49,63,118,93,55,63,207,243,60,63,41,138,66,63,130,32,72,63,219,182,77,63,53,77,83,63,142,227,88,63,232,121,94,63,65,16,100,63,154,166,105,63,244,60,111,63,77,211,116,63,167,105,122,63,0,0,128,63,0,0,0,0,57,142,99,60,57,142,227,60,171,170,42,61,57,142,99,61,228,56,142,61,171,170,170,61,114,28,199,61,57,142,227,61,0,0,0,62,228,56,14,62,199,113,28,62,171,170,42,62,142,227,56,62,114,28,71,62,85,85,85,62,57,142,99,62,28,199,113,62,0,0,128,62,114,28,135,62,228,56,142,62,85,85,149,62,199,113,156,62,57,142,163,62,187,174,171,62,173,128,181,62,160,82,191,62,146,36,201,62,133,246,210,62,119,200,220,62,106,154,230,62,92,108,240,62,79,62,250,62,33,8,2,63,26,241,6,63,19,218,11,63,12,195,16,63,5,172,21,63,255,148,26,63,248,125,31,63,241,102,36,63,234,79,41,63,228,56,46,63,221,33,51,63,214,10,56,63,207,243,60,63,200,220,65,63,194,197,70,63,171,170,74,63,228,56,78,63,28,199,81,63,85,85,85,63,142,227,88,63,199,113,92,63,0,0,96,63,57,142,99,63,114,28,103,63,171,170,106,63,228,56,110,63,28,199,113,63,85,85,117,63,142,227,120,63,199,113,124,63,0,0,128,63,0,0,0,0,39,31,157,60,39,31,29,61,187,174,107,61,39,31,157,61,241,102,196,61,187,174,235,61,66,123,9,62,39,31,29,62,12,195,48,62,241,102,68,62,214,10,88,62,187,174,107,62,160,82,127,62,66,123,137,62,53,77,147,62,39,31,157,62,26,241,166,62,12,195,176,62,255,148,186,62,241,102,196,62,228,56,206,62,214,10,216,62,200,220,225,62,171,170,234,62,28,199,241,62,142,227,248,62,0,0,0,63,57,142,3,63,114,28,7,63,171,170,10,63,228,56,14,63,28,199,17,63,85,85,21,63,142,227,24,63,199,113,28,63,0,0,32,63,57,142,35,63,114,28,39,63,171,170,42,63,228,56,46,63,28,199,49,63,85,85,53,63,142,227,56,63,199,113,60,63,0,0,64,63,57,142,67,63,114,28,71,63,171,170,74,63,228,56,78,63,28,199,81,63,85,85,85,63,142,227,88,63,199,113,92,63,0,0,96,63,57,142,99,63,114,28,103,63,171,170,106,63,228,56,110,63,28,199,113,63,85,85,117,63,142,227,120,63,199,113,124,63,0,0,128,63,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,208,55,0,0,21,0,0,0,173,0,0,0,174,0,0,0,0,0,0,0,0,0,0,63,0,0,128,62,171,170,42,62,0,0,0,62,205,204,204,61,171,170,170,61,40,73,146,61,0,0,128,61,0,0,0,0,224,55,0,0,175,0,0,0,176,0,0,0,116,0,0,0,0,0,0,0,240,55,0,0,177,0,0,0,178,0,0,0,117,0,0,0,0,0,0,0,0,56,0,0,179,0,0,0,180,0,0,0,118,0,0,0,0,0,0,0,16,56,0,0,181,0,0,0,182,0,0,0,119,0,0,0,0,0,0,0,32,56,0,0,183,0,0,0,184,0,0,0,120,0,0,0,0,0,0,0,48,56,0,0,185,0,0,0,186,0,0,0,121,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,128,63,0,0,128,192,0,0,128,63,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,193,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,80,56,0,0,19,0,0,0,187,0,0,0,122,0,0,0,0,0,0,0,64,56,0,0,19,0,0,0,188,0,0,0,123,0,0,0,0,0,0,0,86,248,142,60,199,242,14,61,70,94,86,61,127,220,142,61,176,126,178,61,10,19,214,61,157,150,249,61,101,131,14,62,94,48,32,62,213,208,49,62,111,99,67,62,206,230,84,62,149,89,102,62,96,186,119,62,237,131,132,62,88,32,141,62,190,177,149,62,122,55,158,62,224,176,166,62,66,29,175,62,255,123,183,62,112,204,191,62,232,13,200,62,200,63,208,62,109,97,216,62,45,114,224,62,113,113,232,62,149,94,240,62,247,56,248,62,0,0,0,63,137,217,3,63,203,168,7,63,118,109,11,63,68,39,15,63,231,213,18,63,25,121,22,63,140,16,26,63,254,155,29,63,36,27,33,63,186,141,36,63,124,243,39,63,37,76,43,63,114,151,46,63,34,213,49,63,244,4,53,63,167,38,56,63,255,57,59,63,189,62,62,63,166,52,65,63,124,27,68,63,10,243,70,63,19,187,73,63,96,115,76,63,189,27,79,63,242,179,81,63,207,59,84,63,30,179,86,63,174,25,89,63,81,111,91,63,215,179,93,63,20,231,95,63,219,8,98,63,1,25,100,63,93,23,102,63,202,3,104,63,30,222,105,63,54,166,107,63,237,91,109,63,32,255,110,63,178,143,112,63,130,13,114,63,112,120,115,63,100,208,116,63,63,21,118,63,234,70,119,63,77,101,120,63,82,112,121,63,226,103,122,63,236,75,123,63,93,28,124,63,36,217,124,63,54,130,125,63,130,23,126,63,253,152,126,63,158,6,127,63,92,96,127,63,47,166,127,63,19,216,127,63,5,246,127,63,0,0,128,63,5,246,127,63,19,216,127,63,47,166,127,63,92,96,127,63,158,6,127,63,253,152,126,63,130,23,126,63,54,130,125,63,36,217,124,63,93,28,124,63,236,75,123,63,226,103,122,63,82,112,121,63,77,101,120,63,234,70,119,63,63,21,118,63,100,208,116,63,112,120,115,63,130,13,114,63,178,143,112,63,32,255,110,63,237,91,109,63,54,166,107,63,30,222,105,63,202,3,104,63,93,23,102,63,1,25,100,63,219,8,98,63,20,231,95,63,215,179,93,63,81,111,91,63,174,25,89,63,30,179,86,63,207,59,84,63,242,179,81,63,189,27,79,63,96,115,76,63,19,187,73,63,10,243,70,63,124,27,68,63,166,52,65,63,189,62,62,63,255,57,59,63,167,38,56,63,244,4,53,63,34,213,49,63,114,151,46,63,37,76,43,63,124,243,39,63,186,141,36,63,36,27,33,63,254,155,29,63,140,16,26,63,25,121,22,63,231,213,18,63,68,39,15,63,118,109,11,63,203,168,7,63,137,217,3,63,0,0,0,63,247,56,248,62,149,94,240,62,113,113,232,62,45,114,224,62,109,97,216,62,200,63,208,62,232,13,200,62,112,204,191,62,255,123,183,62,66,29,175,62,224,176,166,62,122,55,158,62,190,177,149,62,88,32,141,62,237,131,132,62,96,186,119,62,149,89,102,62,206,230,84,62,111,99,67,62,213,208,49,62,94,48,32,62,101,131,14,62,157,150,249,61,10,19,214,61,176,126,178,61,127,220,142,61,70,94,86,61,199,242,14,61,86,248,142,60,0,0,0,0,86,248,142,188,199,242,14,189,70,94,86,189,127,220,142,189,176,126,178,189,10,19,214,189,157,150,249,189,101,131,14,190,94,48,32,190,213,208,49,190,111,99,67,190,206,230,84,190,149,89,102,190,96,186,119,190,237,131,132,190,88,32,141,190,190,177,149,190,122,55,158,190,224,176,166,190,66,29,175,190,255,123,183,190,112,204,191,190,232,13,200,190,200,63,208,190,109,97,216,190,45,114,224,190,113,113,232,190,149,94,240,190,247,56,248,190,0,0,0,191,137,217,3,191,203,168,7,191,118,109,11,191,68,39,15,191,231,213,18,191,25,121,22,191,140,16,26,191,254,155,29,191,36,27,33,191,186,141,36,191,124,243,39,191,37,76,43,191,114,151,46,191,34,213,49,191,244,4,53,191,167,38,56,191,255,57,59,191,189,62,62,191,166,52,65,191,124,27,68,191,10,243,70,191,19,187,73,191,96,115,76,191,189,27,79,191,242,179,81,191,207,59,84,191,30,179,86,191,174,25,89,191,81,111,91,191,215,179,93,191,20,231,95,191,219,8,98,191,1,25,100,191,93,23,102,191,202,3,104,191,30,222,105,191,54,166,107,191,237,91,109,191,32,255,110,191,178,143,112,191,130,13,114,191,112,120,115,191,100,208,116,191,63,21,118,191,234,70,119,191,77,101,120,191,82,112,121,191,226,103,122,191,236,75,123,191,93,28,124,191,36,217,124,191,54,130,125,191,130,23,126,191,253,152,126,191,158,6,127,191,92,96,127,191,47,166,127,191,19,216,127,191,5,246,127,191,0,0,128,191,5,246,127,191,19,216,127,191,47,166,127,191,92,96,127,191,158,6,127,191,253,152,126,191,130,23,126,191,54,130,125,191,36,217,124,191,93,28,124,191,236,75,123,191,226,103,122,191,82,112,121,191,77,101,120,191,234,70,119,191,63,21,118,191,100,208,116,191,112,120,115,191,130,13,114,191,178,143,112,191,32,255,110,191,237,91,109,191,54,166,107,191,30,222,105,191,202,3,104,191,93,23,102,191,1,25,100,191,219,8,98,191,20,231,95,191,215,179,93,191,81,111,91,191,174,25,89,191,30,179,86,191,207,59,84,191,242,179,81,191,189,27,79,191,96,115,76,191,19,187,73,191,10,243,70,191,124,27,68,191,166,52,65,191,189,62,62,191,255,57,59,191,167,38,56,191,244,4,53,191,34,213,49,191,114,151,46,191,37,76,43,191,124,243,39,191,186,141,36,191,36,27,33,191,254,155,29,191,140,16,26,191,25,121,22,191,231,213,18,191,68,39,15,191,118,109,11,191,203,168,7,191,137,217,3,191,0,0,0,191,247,56,248,190,149,94,240,190,113,113,232,190,45,114,224,190,109,97,216,190,200,63,208,190,232,13,200,190,112,204,191,190,255,123,183,190,66,29,175,190,224,176,166,190,122,55,158,190,190,177,149,190,88,32,141,190,237,131,132,190,96,186,119,190,149,89,102,190,206,230,84,190,111,99,67,190,213,208,49,190,94,48,32,190,101,131,14,190,157,150,249,189,10,19,214,189,176,126,178,189,127,220,142,189,70,94,86,189,199,242,14,189,86,248,142,188,0,0,0,128,86,248,142,60,199,242,14,61,70,94,86,61,127,220,142,61,176,126,178,61,10,19,214,61,157,150,249,61,101,131,14,62,94,48,32,62,213,208,49,62,111,99,67,62,206,230,84,62,149,89,102,62,96,186,119,62,237,131,132,62,88,32,141,62,190,177,149,62,122,55,158,62,224,176,166,62,66,29,175,62,255,123,183,62,112,204,191,62,232,13,200,62,200,63,208,62,109,97,216,62,45,114,224,62,113,113,232,62,149,94,240,62,247,56,248,62,0,0,0,63,137,217,3,63,203,168,7,63,118,109,11,63,68,39,15,63,231,213,18,63,25,121,22,63,140,16,26,63,254,155,29,63,36,27,33,63,186,141,36,63,124,243,39,63,37,76,43,63,114,151,46,63,34,213,49,63,244,4,53,63,167,38,56,63,255,57,59,63,189,62,62,63,166,52,65,63,124,27,68,63,10,243,70,63,19,187,73,63,96,115,76,63,189,27,79,63,242,179,81,63,207,59,84,63,30,179,86,63,174,25,89,63,81,111,91,63,215,179,93,63,20,231,95,63,219,8,98,63,1,25,100,63,93,23,102,63,202,3,104,63,30,222,105,63,54,166,107,63,237,91,109,63,32,255,110,63,178,143,112,63,130,13,114,63,112,120,115,63,100,208,116,63,63,21,118,63,234,70,119,63,77,101,120,63,82,112,121,63,226,103,122,63,236,75,123,63,93,28,124,63,36,217,124,63,54,130,125,63,130,23,126,63,253,152,126,63,158,6,127,63,92,96,127,63,47,166,127,63,19,216,127,63,5,246,127,63,0,0,128,63,168,0,0,0,177,0,0,0,185,0,0,0,194,0,0,0,202,0,0,0,210,0,0,0,218,0,0,0,224,0,0,0,231,0,0,0,236,0,0,0,241,0,0,0,246,0,0,0,249,0,0,0,252,0,0,0,254,0,0,0,254,0,0,0,254,0,0,0,254,0,0,0,252,0,0,0,249,0,0,0,246,0,0,0,241,0,0,0,236,0,0,0,231,0,0,0,224,0,0,0,218,0,0,0,210,0,0,0,202,0,0,0,194,0,0,0,185,0,0,0,177,0,0,0,168,0,0,0,158,0,0,0,149,0,0,0,140,0,0,0,131,0,0,0,122,0,0,0,114,0,0,0,105,0,0,0,97,0,0,0,89,0,0,0,82,0,0,0,75,0,0,0,68,0,0,0,62,0,0,0,56,0,0,0,50,0,0,0,45,0,0,0,40,0,0,0,36,0,0,0,32,0,0,0,28,0,0,0,25,0,0,0,22,0,0,0,19,0,0,0,16,0,0,0,14,0,0,0,12,0,0,0,11,0,0,0,9,0,0,0,8,0,0,0,7,0,0,0,5,0,0,0,5,0,0,0,69,17,0,0,199,0,0,0,214,0,0,0,217,0,0,0,233,0,0,0,219,0,0,0,197,0,0,0,234,0,0,0,216,0,0,0,221,0,0,0,222,0,0,0,228,0,0,0,225,0,0,0,211,0,0,0,224,0,0,0,210,0,0,0,220,0,0,0,200,0,0,0,201,0,0,0,202,0,0,0,203,0,0,0,204,0,0,0,205,0,0,0,206,0,0,0,207,0,0,0,208,0,0,0,209,0,0,0,212,0,0,0,213,0,0,0,191,0,0,0,226,0,0,0,192,0,0,0,215,0,0,0,190,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,193,0,0,0,84,0,0,0,194,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,151,0,0,0,152,0,0,0,153,0,0,0,154,0,0,0,155,0,0,0,156,0,0,0,157,0,0,0,158,0,0,0,159,0,0,0,160,0,0,0,161,0,0,0,162,0,0,0,163,0,0,0,164,0,0,0,165,0,0,0,166,0,0,0,167,0,0,0,168,0,0,0,169,0,0,0,170,0,0,0,171,0,0,0,172,0,0,0,173,0,0,0,174,0,0,0,175,0,0,0,176,0,0,0,195,0,0,0,223,0,0,0,196,0,0,0,88,0,0,0,69,16,0,0,199,0,0,0,214,0,0,0,217,0,0,0,233,0,0,0,219,0,0,0,197,0,0,0,234,0,0,0,216,0,0,0,221,0,0,0,222,0,0,0,228,0,0,0,225,0,0,0,211,0,0,0,224,0,0,0,210,0,0,0,220,0,0,0,200,0,0,0,201,0,0,0,202,0,0,0,203,0,0,0,204,0,0,0,205,0,0,0,206,0,0,0,207,0,0,0,208,0,0,0,209,0,0,0,212,0,0,0,213,0,0,0,191,0,0,0,226,0,0,0,192,0,0,0,215,0,0,0,190,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,193,0,0,0,84,0,0,0,194,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,195,0,0,0,223,0,0,0,196,0,0,0,88,0,0,0,201,48,0,0,151,8,0,0,166,8,0,0,169,8,0,0,227,8,0,0,226,8,0,0,223,8,0,0,224,8,0,0,168,8,0,0,173,8,0,0,174,8,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,152,8,0,0,153,8,0,0,154,8,0,0,155,8,0,0,156,8,0,0,157,8,0,0,158,8,0,0,159,8,0,0,160,8,0,0,161,8,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,167,8,0,0,225,8,0,0,209,7,0,0,210,7,0,0,211,7,0,0,212,7,0,0,213,7,0,0,214,7,0,0,215,7,0,0,216,7,0,0,217,7,0,0,218,7,0,0,219,7,0,0,220,7,0,0,221,7,0,0,222,7,0,0,223,7,0,0,224,7,0,0,225,7,0,0,226,7,0,0,227,7,0,0,228,7,0,0,229,7,0,0,230,7,0,0,231,7,0,0,232,7,0,0,233,7,0,0,234,7,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,53,8,0,0,54,8,0,0,55,8,0,0,56,8,0,0,57,8,0,0,58,8,0,0,59,8,0,0,60,8,0,0,61,8,0,0,62,8,0,0,63,8,0,0,64,8,0,0,65,8,0,0,66,8,0,0,67,8,0,0,68,8,0,0,69,8,0,0,70,8,0,0,71,8,0,0,72,8,0,0,73,8,0,0,74,8,0,0,75,8,0,0,76,8,0,0,77,8,0,0,78,8,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,241,10,0,0,242,10,0,0,243,10,0,0,244,10,0,0,245,10,0,0,246,10,0,0,247,10,0,0,248,10,0,0,249,10,0,0,250,10,0,0,251,10,0,0,252,10,0,0,253,10,0,0,254,10,0,0,255,10,0,0,0,11,0,0,1,11,0,0,2,11,0,0,3,11,0,0,4,11,0,0,5,11,0,0,6,11,0,0,7,11,0,0,8,11,0,0,9,11,0,0,10,11,0,0,11,11,0,0,12,11,0,0,13,11,0,0,14,11,0,0,15,11,0,0,16,11,0,0,85,11,0,0,86,11,0,0,87,11,0,0,88,11,0,0,89,11,0,0,90,11,0,0,91,11,0,0,92,11,0,0,93,11,0,0,94,11,0,0,95,11,0,0,96,11,0,0,97,11,0,0,98,11,0,0,99,11,0,0,100,11,0,0,101,11,0,0,102,11,0,0,103,11,0,0,104,11,0,0,105,11,0,0,106,11,0,0,107,11,0,0,108,11,0,0,109,11,0,0,110,11,0,0,111,11,0,0,112,11,0,0,113,11,0,0,114,11,0,0,115,11,0,0,116,11,0,0,201,55,0,0,151,8,0,0,204,10,0,0,218,10,0,0,222,10,0,0,209,10,0,0,223,10,0,0,208,10,0,0,217,10,0,0,211,10,0,0,212,10,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,190,10,0,0,191,10,0,0,192,10,0,0,193,10,0,0,194,10,0,0,195,10,0,0,196,10,0,0,197,10,0,0,198,10,0,0,199,10,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,205,10,0,0,225,8,0,0,3,8,0,0,4,8,0,0,5,8,0,0,6,8,0,0,7,8,0,0,8,8,0,0,9,8,0,0,10,8,0,0,11,8,0,0,12,8,0,0,13,8,0,0,14,8,0,0,15,8,0,0,16,8,0,0,17,8,0,0,18,8,0,0,19,8,0,0,20,8,0,0,21,8,0,0,22,8,0,0,23,8,0,0,24,8,0,0,25,8,0,0,26,8,0,0,27,8,0,0,28,8,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,103,8,0,0,104,8,0,0,105,8,0,0,106,8,0,0,107,8,0,0,108,8,0,0,109,8,0,0,110,8,0,0,111,8,0,0,112,8,0,0,113,8,0,0,114,8,0,0,115,8,0,0,116,8,0,0,117,8,0,0,118,8,0,0,119,8,0,0,120,8,0,0,121,8,0,0,122,8,0,0,123,8,0,0,124,8,0,0,125,8,0,0,126,8,0,0,127,8,0,0,128,8,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,23,0,0,151,8,0,0,192,12,0,0,206,12,0,0,210,12,0,0,197,12,0,0,161,12,0,0,196,12,0,0,205,12,0,0,199,12,0,0,200,12,0,0,151,12,0,0,153,12,0,0,189,12,0,0,152,12,0,0,188,12,0,0,198,12,0,0,178,12,0,0,179,12,0,0,180,12,0,0,181,12,0,0,182,12,0,0,183,12,0,0,184,12,0,0,185,12,0,0,186,12,0,0,187,12,0,0,190,12,0,0,191,12,0,0,158,12,0,0,154,12,0,0,159,12,0,0,193,12,0,0,162,12,0,0,235,11,0,0,236,11,0,0,237,11,0,0,238,11,0,0,239,11,0,0,240,11,0,0,241,11,0,0,242,11,0,0,243,11,0,0,244,11,0,0,245,11,0,0,246,11,0,0,247,11,0,0,16,8,0,0,249,11,0,0,250,11,0,0,251,11,0,0,252,11,0,0,253,11,0,0,254,11,0,0,255,11,0,0,0,12,0,0,1,12,0,0,2,12,0,0,3,12,0,0,4,12,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,79,12,0,0,80,12,0,0,81,12,0,0,82,12,0,0,83,12,0,0,84,12,0,0,85,12,0,0,86,12,0,0,87,12,0,0,88,12,0,0,89,12,0,0,90,12,0,0,91,12,0,0,92,12,0,0,93,12,0,0,94,12,0,0,95,12,0,0,96,12,0,0,97,12,0,0,98,12,0,0,99,12,0,0,100,12,0,0,101,12,0,0,102,12,0,0,103,12,0,0,104,12,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,16,0,0,151,8,0,0,142,12,0,0,156,12,0,0,160,12,0,0,147,12,0,0,161,12,0,0,146,12,0,0,155,12,0,0,149,12,0,0,150,12,0,0,151,12,0,0,153,12,0,0,139,12,0,0,152,12,0,0,138,12,0,0,148,12,0,0,128,12,0,0,129,12,0,0,130,12,0,0,131,12,0,0,132,12,0,0,133,12,0,0,134,12,0,0,135,12,0,0,136,12,0,0,137,12,0,0,140,12,0,0,141,12,0,0,158,12,0,0,154,12,0,0,159,12,0,0,143,12,0,0,162,12,0,0,185,11,0,0,186,11,0,0,187,11,0,0,188,11,0,0,189,11,0,0,190,11,0,0,191,11,0,0,192,11,0,0,193,11,0,0,194,11,0,0,195,11,0,0,196,11,0,0,197,11,0,0,222,7,0,0,199,11,0,0,200,11,0,0,201,11,0,0,202,11,0,0,203,11,0,0,204,11,0,0,205,11,0,0,206,11,0,0,207,11,0,0,208,11,0,0,209,11,0,0,210,11,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,29,12,0,0,30,12,0,0,31,12,0,0,32,12,0,0,33,12,0,0,34,12,0,0,35,12,0,0,36,12,0,0,37,12,0,0,38,12,0,0,39,12,0,0,40,12,0,0,41,12,0,0,42,12,0,0,43,12,0,0,44,12,0,0,45,12,0,0,46,12,0,0,47,12,0,0,48,12,0,0,49,12,0,0,50,12,0,0,51,12,0,0,52,12,0,0,53,12,0,0,54,12,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,118,17,0,0,175,4,0,0,190,4,0,0,193,4,0,0,251,4,0,0,250,4,0,0,247,4,0,0,248,4,0,0,192,4,0,0,197,4,0,0,198,4,0,0,195,4,0,0,208,4,0,0,187,4,0,0,207,4,0,0,186,4,0,0,196,4,0,0,176,4,0,0,177,4,0,0,178,4,0,0,179,4,0,0,180,4,0,0,181,4,0,0,182,4,0,0,183,4,0,0,184,4,0,0,185,4,0,0,188,4,0,0,189,4,0,0,217,4,0,0,214,4,0,0,218,4,0,0,191,4,0,0,249,4,0,0,27,4,0,0,28,4,0,0,29,4,0,0,30,4,0,0,31,4,0,0,32,4,0,0,33,4,0,0,34,4,0,0,35,4,0,0,36,4,0,0,37,4,0,0,38,4,0,0,39,4,0,0,40,4,0,0,41,4,0,0,42,4,0,0,43,4,0,0,44,4,0,0,45,4,0,0,46,4,0,0,47,4,0,0,48,4,0,0,49,4,0,0,50,4,0,0,51,4,0,0,52,4,0,0,199,4,0,0,60,4,0,0,200,4,0,0,223,4,0,0,74,2,0,0,225,4,0,0,127,4,0,0,128,4,0,0,129,4,0,0,130,4,0,0,131,4,0,0,132,4,0,0,133,4,0,0,134,4,0,0,135,4,0,0,136,4,0,0,137,4,0,0,138,4,0,0,139,4,0,0,140,4,0,0,141,4,0,0,142,4,0,0,143,4,0,0,144,4,0,0,145,4,0,0,146,4,0,0,147,4,0,0,148,4,0,0,149,4,0,0,150,4,0,0,151,4,0,0,152,4,0,0,201,4,0,0,205,4,0,0,202,4,0,0,222,4,0,0,118,16,0,0,175,4,0,0,190,4,0,0,193,4,0,0,251,4,0,0,250,4,0,0,247,4,0,0,248,4,0,0,192,4,0,0,197,4,0,0,198,4,0,0,195,4,0,0,208,4,0,0,187,4,0,0,207,4,0,0,186,4,0,0,196,4,0,0,176,4,0,0,177,4,0,0,178,4,0,0,179,4,0,0,180,4,0,0,181,4,0,0,182,4,0,0,183,4,0,0,184,4,0,0,185,4,0,0,188,4,0,0,165,8,0,0,217,4,0,0,214,4,0,0,218,4,0,0,191,4,0,0,249,4,0,0,233,3,0,0,234,3,0,0,235,3,0,0,236,3,0,0,237,3,0,0,238,3,0,0,239,3,0,0,240,3,0,0,241,3,0,0,242,3,0,0,243,3,0,0,244,3,0,0,245,3,0,0,246,3,0,0,247,3,0,0,248,3,0,0,249,3,0,0,250,3,0,0,251,3,0,0,252,3,0,0,253,3,0,0,254,3,0,0,255,3,0,0,0,4,0,0,1,4,0,0,2,4,0,0,199,4,0,0,60,4,0,0,200,4,0,0,223,4,0,0,74,2,0,0,225,4,0,0,77,4,0,0,78,4,0,0,79,4,0,0,80,4,0,0,81,4,0,0,82,4,0,0,83,4,0,0,84,4,0,0,85,4,0,0,86,4,0,0,87,4,0,0,88,4,0,0,89,4,0,0,90,4,0,0,91,4,0,0,92,4,0,0,93,4,0,0,94,4,0,0,95,4,0,0,96,4,0,0,97,4,0,0,98,4,0,0,99,4,0,0,100,4,0,0,101,4,0,0,102,4,0,0,201,4,0,0,205,4,0,0,202,4,0,0,222,4,0,0,201,23,0,0,151,8,0,0,204,10,0,0,218,10,0,0,222,10,0,0,209,10,0,0,223,10,0,0,208,10,0,0,217,10,0,0,211,10,0,0,212,10,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,190,10,0,0,191,10,0,0,192,10,0,0,193,10,0,0,194,10,0,0,195,10,0,0,196,10,0,0,197,10,0,0,198,10,0,0,199,10,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,167,8,0,0,225,8,0,0,247,9,0,0,248,9,0,0,249,9,0,0,250,9,0,0,251,9,0,0,252,9,0,0,253,9,0,0,254,9,0,0,255,9,0,0,0,10,0,0,1,10,0,0,2,10,0,0,3,10,0,0,4,10,0,0,5,10,0,0,6,10,0,0,7,10,0,0,8,10,0,0,9,10,0,0,10,10,0,0,11,10,0,0,12,10,0,0,13,10,0,0,14,10,0,0,15,10,0,0,16,10,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,74,2,0,0,201,8,0,0,91,10,0,0,92,10,0,0,93,10,0,0,94,10,0,0,95,10,0,0,96,10,0,0,97,10,0,0,98,10,0,0,99,10,0,0,100,10,0,0,101,10,0,0,102,10,0,0,103,10,0,0,104,10,0,0,105,10,0,0,106,10,0,0,107,10,0,0,108,10,0,0,109,10,0,0,110,10,0,0,111,10,0,0,112,10,0,0,113,10,0,0,114,10,0,0,115,10,0,0,116,10,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,17,0,0,151,8,0,0,202,2,0,0,205,2,0,0,221,2,0,0,207,2,0,0,185,2,0,0,222,2,0,0,204,2,0,0,209,2,0,0,210,2,0,0,216,2,0,0,213,2,0,0,199,2,0,0,212,2,0,0,198,2,0,0,208,2,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,192,2,0,0,193,2,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,200,2,0,0,201,2,0,0,179,2,0,0,214,2,0,0,180,2,0,0,203,2,0,0,178,2,0,0,39,2,0,0,40,2,0,0,41,2,0,0,42,2,0,0,43,2,0,0,44,2,0,0,45,2,0,0,46,2,0,0,47,2,0,0,48,2,0,0,49,2,0,0,50,2,0,0,51,2,0,0,52,2,0,0,53,2,0,0,54,2,0,0,55,2,0,0,56,2,0,0,57,2,0,0,58,2,0,0,59,2,0,0,60,2,0,0,61,2,0,0,62,2,0,0,63,2,0,0,64,2,0,0,181,2,0,0,72,2,0,0,182,2,0,0,199,8,0,0,74,2,0,0,201,8,0,0,139,2,0,0,140,2,0,0,141,2,0,0,142,2,0,0,143,2,0,0,144,2,0,0,145,2,0,0,146,2,0,0,147,2,0,0,148,2,0,0,149,2,0,0,150,2,0,0,151,2,0,0,152,2,0,0,153,2,0,0,154,2,0,0,155,2,0,0,156,2,0,0,157,2,0,0,158,2,0,0,159,2,0,0,160,2,0,0,161,2,0,0,162,2,0,0,163,2,0,0,164,2,0,0,183,2,0,0,211,2,0,0,184,2,0,0,198,8,0,0,201,16,0,0,151,8,0,0,154,10,0,0,168,10,0,0,172,10,0,0,159,10,0,0,173,10,0,0,158,10,0,0,167,10,0,0,161,10,0,0,162,10,0,0,163,10,0,0,165,10,0,0,151,10,0,0,164,10,0,0,150,10,0,0,160,10,0,0,140,10,0,0,141,10,0,0,142,10,0,0,143,10,0,0,144,10,0,0,145,10,0,0,146,10,0,0,147,10,0,0,148,10,0,0,149,10,0,0,152,10,0,0,153,10,0,0,170,10,0,0,166,10,0,0,171,10,0,0,155,10,0,0,174,10,0,0,197,9,0,0,198,9,0,0,199,9,0,0,200,9,0,0,201,9,0,0,202,9,0,0,203,9,0,0,204,9,0,0,205,9,0,0,206,9,0,0,207,9,0,0,208,9,0,0,209,9,0,0,210,9,0,0,211,9,0,0,212,9,0,0,213,9,0,0,214,9,0,0,215,9,0,0,216,9,0,0,217,9,0,0,218,9,0,0,219,9,0,0,220,9,0,0,221,9,0,0,222,9,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,41,10,0,0,42,10,0,0,43,10,0,0,44,10,0,0,45,10,0,0,46,10,0,0,47,10,0,0,48,10,0,0,49,10,0,0,50,10,0,0,51,10,0,0,52,10,0,0,53,10,0,0,54,10,0,0,55,10,0,0,56,10,0,0,57,10,0,0,58,10,0,0,59,10,0,0,60,10,0,0,61,10,0,0,62,10,0,0,63,10,0,0,64,10,0,0,65,10,0,0,66,10,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,16,0,0,151,8,0,0,202,2,0,0,205,2,0,0,221,2,0,0,207,2,0,0,185,2,0,0,222,2,0,0,204,2,0,0,209,2,0,0,210,2,0,0,216,2,0,0,213,2,0,0,199,2,0,0,212,2,0,0,198,2,0,0,208,2,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,192,2,0,0,193,2,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,200,2,0,0,201,2,0,0,179,2,0,0,214,2,0,0,180,2,0,0,203,2,0,0,178,2,0,0,245,1,0,0,246,1,0,0,247,1,0,0,248,1,0,0,249,1,0,0,250,1,0,0,251,1,0,0,252,1,0,0,253,1,0,0,254,1,0,0,255,1,0,0,0,2,0,0,1,2,0,0,2,2,0,0,3,2,0,0,4,2,0,0,5,2,0,0,6,2,0,0,7,2,0,0,8,2,0,0,9,2,0,0,10,2,0,0,11,2,0,0,12,2,0,0,13,2,0,0,14,2,0,0,181,2,0,0,72,2,0,0,182,2,0,0,199,8,0,0,74,2,0,0,201,8,0,0,89,2,0,0,90,2,0,0,91,2,0,0,92,2,0,0,93,2,0,0,94,2,0,0,95,2,0,0,96,2,0,0,97,2,0,0,98,2,0,0,99,2,0,0,100,2,0,0,101,2,0,0,102,2,0,0,103,2,0,0,104,2,0,0,105,2,0,0,106,2,0,0,107,2,0,0,108,2,0,0,109,2,0,0,110,2,0,0,111,2,0,0,112,2,0,0,113,2,0,0,114,2,0,0,183,2,0,0,211,2,0,0,184,2,0,0,198,8,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,120,56,0,0,189,0,0,0,190,0,0,0,8,0,0,0,29,0,0,0,29,0,0,0,34,0,0,0,0,0,0,0,240,57,0,0,21,0,0,0,191,0,0,0,192,0,0,0,0,0,0,0,192,57,0,0,21,0,0,0,193,0,0,0,194,0,0,0,0,0,0,0,160,57,0,0,21,0,0,0,195,0,0,0,196,0,0,0,0,0,0,0,128,57,0,0,21,0,0,0,197,0,0,0,198,0,0,0,0,0,0,0,96,57,0,0,21,0,0,0,199,0,0,0,200,0,0,0,0,0,0,0,64,57,0,0,21,0,0,0,201,0,0,0,202,0,0,0,0,0,0,0,32,57,0,0,21,0,0,0,203,0,0,0,204,0,0,0,0,0,0,0,0,57,0,0,21,0,0,0,205,0,0,0,206,0,0,0,0,0,0,0,224,56,0,0,21,0,0,0,207,0,0,0,208,0,0,0,0,0,0,0,192,56,0,0,21,0,0,0,209,0,0,0,210,0,0,0,0,0,0,0,160,56,0,0,21,0,0,0,211,0,0,0,212,0,0,0,0,0,0,0,128,56,0,0,21,0,0,0,213,0,0,0,214,0,0,0,0,0,0,0,144,56,0,0,215,0,0,0,216,0,0,0,38,0,0,0,0,0,0,0,176,56,0,0,217,0,0,0,218,0,0,0,39,0,0,0,0,0,0,0,208,56,0,0,219,0,0,0,220,0,0,0,40,0,0,0,0,0,0,0,240,56,0,0,221,0,0,0,222,0,0,0,41,0,0,0,0,0,0,0,16,57,0,0,223,0,0,0,224,0,0,0,42,0,0,0,0,0,0,0,48,57,0,0,225,0,0,0,226,0,0,0,43,0,0,0,0,0,0,0,80,57,0,0,227,0,0,0,228,0,0,0,44,0,0,0,0,0,0,0,112,57,0,0,229,0,0,0,230,0,0,0,45,0,0,0,0,0,0,0,144,57,0,0,231,0,0,0,232,0,0,0,46,0,0,0,0,0,0,0,176,57,0,0,233,0,0,0,234,0,0,0,47,0,0,0,0,0,0,0,224,57,0,0,235,0,0,0,236,0,0,0,48,0,0,0,0,0,0,0,208,57,0,0,235,0,0,0,237,0,0,0,49,0,0,0,0,0,0,0,16,58,0,0,238,0,0,0,239,0,0,0,50,0,0,0,0,0,0,0,0,58,0,0,238,0,0,0,240,0,0,0,51,0,0,0,0,0,0,0,32,61,0,0,21,0,0,0,241,0,0,0,242,0,0,0,0,0,0,0,16,61,0,0,21,0,0,0,243,0,0,0,244,0,0,0,0,0,0,0,0,61,0,0,21,0,0,0,245,0,0,0,246,0,0,0,0,0,0,0,240,60,0,0,21,0,0,0,247,0,0,0,248,0,0,0,0,0,0,0,224,60,0,0,21,0,0,0,249,0,0,0,250,0,0,0,0,0,0,0,208,60,0,0,21,0,0,0,251,0,0,0,252,0,0,0,0,0,0,0,192,60,0,0,21,0,0,0,253,0,0,0,254,0,0,0,0,0,0,0,176,60,0,0,21,0,0,0,255,0,0,0,0,1,0,0,0,0,0,0,160,60,0,0,21,0,0,0,1,1,0,0,2,1,0,0,0,0,0,0,128,60,0,0,21,0,0,0,3,1,0,0,4,1,0,0,0,0,0,0,64,60,0,0,21,0,0,0,5,1,0,0,6,1,0,0,0,0,0,0,0,60,0,0,21,0,0,0,7,1,0,0,8,1,0,0,0,0,0,0,208,59,0,0,21,0,0,0,9,1,0,0,10,1,0,0,0,0,0,0,160,59,0,0,21,0,0,0,11,1,0,0,12,1,0,0,0,0,0,0,112,59,0,0,21,0,0,0,13,1,0,0,14,1,0,0,0,0,0,0,64,59,0,0,21,0,0,0,15,1,0,0,16,1,0,0,0,0,0,0,16,59,0,0,21,0,0,0,17,1,0,0,18,1,0,0,0,0,0,0,224,58,0,0,21,0,0,0,19,1,0,0,20,1,0,0,0,0,0,0,176,58,0,0,21,0,0,0,21,1,0,0,22,1,0,0,0,0,0,0,128,58,0,0,21,0,0,0,23,1,0,0,24,1,0,0,0,0,0,0,80,58,0,0,21,0,0,0,25,1,0,0,26,1,0,0,0,0,0,0,32,58,0,0,21,0,0,0,27,1,0,0,28,1,0,0,0,0,0,0,64,58,0,0,29,1,0,0,30,1,0,0,35,0,0,0,31,1,0,0,0,0,0,0,48,58,0,0,29,1,0,0,32,1,0,0,36,0,0,0,31,1,0,0,0,0,0,0,112,58,0,0,33,1,0,0,34,1,0,0,37,0,0,0,31,1,0,0,0,0,0,0,96,58,0,0,33,1,0,0,35,1,0,0,38,0,0,0,31,1,0,0,0,0,0,0,160,58,0,0,36,1,0,0,37,1,0,0,39,0,0,0,31,1,0,0,0,0,0,0,144,58,0,0,36,1,0,0,38,1,0,0,40,0,0,0,31,1,0,0,0,0,0,0,208,58,0,0,39,1,0,0,40,1,0,0,41,0,0,0,31,1,0,0,0,0,0,0,192,58,0,0,39,1,0,0,41,1,0,0,42,0,0,0,31,1,0,0,0,0,0,0,0,59,0,0,42,1,0,0,43,1,0,0,43,0,0,0,31,1,0,0,0,0,0,0,240,58,0,0,42,1,0,0,44,1,0,0,44,0,0,0,31,1,0,0,0,0,0,0,48,59,0,0,45,1,0,0,46,1,0,0,45,0,0,0,31,1,0,0,0,0,0,0,32,59,0,0,45,1,0,0,47,1,0,0,46,0,0,0,31,1,0,0,0,0,0,0,96,59,0,0,48,1,0,0,49,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+61440);allocate([47,0,0,0,31,1,0,0,0,0,0,0,80,59,0,0,48,1,0,0,50,1,0,0,48,0,0,0,31,1,0,0,0,0,0,0,144,59,0,0,51,1,0,0,52,1,0,0,49,0,0,0,31,1,0,0,0,0,0,0,128,59,0,0,51,1,0,0,53,1,0,0,50,0,0,0,31,1,0,0,0,0,0,0,192,59,0,0,54,1,0,0,55,1,0,0,51,0,0,0,31,1,0,0,0,0,0,0,176,59,0,0,54,1,0,0,56,1,0,0,52,0,0,0,31,1,0,0,0,0,0,0,240,59,0,0,57,1,0,0,58,1,0,0,53,0,0,0,31,1,0,0,0,0,0,0,224,59,0,0,57,1,0,0,59,1,0,0,54,0,0,0,31,1,0,0,0,0,0,0,32,60,0,0,60,1,0,0,61,1,0,0,55,0,0,0,31,1,0,0,0,0,0,0,16,60,0,0,60,1,0,0,62,1,0,0,56,0,0,0,31,1,0,0,0,0,0,0,48,60,0,0,60,1,0,0,63,1,0,0,57,0,0,0,31,1,0,0,0,0,0,0,96,60,0,0,64,1,0,0,65,1,0,0,58,0,0,0,31,1,0,0,0,0,0,0,80,60,0,0,64,1,0,0,66,1,0,0,59,0,0,0,31,1,0,0,0,0,0,0,112,60,0,0,64,1,0,0,67,1,0,0,60,0,0,0,31,1,0,0,0,0,0,0,144,60,0,0,57,1,0,0,68,1,0,0,61,0,0,0,31,1,0,0,0,0,0,0,48,61,0,0,21,0,0,0,69,1,0,0,70,1,0,0,0,0,0,0,192,62,0,0,21,0,0,0,71,1,0,0,72,1,0,0,0,0,0,0,160,62,0,0,21,0,0,0,73,1,0,0,74,1,0,0,0,0,0,0,128,62,0,0,21,0,0,0,75,1,0,0,76,1,0,0,0,0,0,0,96,62,0,0,21,0,0,0,77,1,0,0,78,1,0,0,0,0,0,0,64,62,0,0,21,0,0,0,79,1,0,0,80,1,0,0,0,0,0,0,32,62,0,0,21,0,0,0,81,1,0,0,82,1,0,0,0,0,0,0,0,62,0,0,21,0,0,0,83,1,0,0,84,1,0,0,0,0,0,0,224,61,0,0,21,0,0,0,85,1,0,0,86,1,0,0,0,0,0,0,192,61,0,0,21,0,0,0,87,1,0,0,88,1,0,0,0,0,0,0,160,61,0,0,21,0,0,0,89,1,0,0,90,1,0,0,0,0,0,0,128,61,0,0,21,0,0,0,91,1,0,0,92,1,0,0,0,0,0,0,96,61,0,0,21,0,0,0,93,1,0,0,94,1,0,0,0,0,0,0,64,61,0,0,21,0,0,0,95,1,0,0,96,1,0,0,0,0,0,0,80,61,0,0,97,1,0,0,98,1,0,0,8,0,0,0,99,1,0,0,0,0,0,0,112,61,0,0,100,1,0,0,101,1,0,0,9,0,0,0,99,1,0,0,0,0,0,0,144,61,0,0,102,1,0,0,103,1,0,0,10,0,0,0,99,1,0,0,0,0,0,0,176,61,0,0,104,1,0,0,105,1,0,0,11,0,0,0,99,1,0,0,0,0,0,0,208,61,0,0,106,1,0,0,107,1,0,0,12,0,0,0,99,1,0,0,0,0,0,0,240,61,0,0,108,1,0,0,109,1,0,0,13,0,0,0,99,1,0,0,0,0,0,0,16,62,0,0,110,1,0,0,111,1,0,0,14,0,0,0,99,1,0,0,0,0,0,0,48,62,0,0,112,1,0,0,113,1,0,0,15,0,0,0,99,1,0,0,0,0,0,0,80,62,0,0,114,1,0,0,115,1,0,0,16,0,0,0,99,1,0,0,0,0,0,0,112,62,0,0,116,1,0,0,117,1,0,0,17,0,0,0,99,1,0,0,0,0,0,0,144,62,0,0,118,1,0,0,119,1,0,0,18,0,0,0,99,1,0,0,0,0,0,0,176,62,0,0,120,1,0,0,121,1,0,0,19,0,0,0,99,1,0,0,0,0,0,0,208,62,0,0,122,1,0,0,123,1,0,0,20,0,0,0,99,1,0,0,183,131,15,0,147,239,3,0,164,239,3,0,195,239,3,0,218,239,3,0,242,239,3,0,8,240,3,0,25,240,3,0,55,240,3,0,72,240,3,0,79,240,3,0,94,240,3,0,111,240,3,0,123,240,3,0,145,240,3,0,162,240,3,0,191,240,3,0,211,240,3,0,245,240,3,0,14,241,3,0,41,241,3,0,53,241,3,0,72,241,3,0,84,241,3,0,106,241,3,0,118,241,3,0,132,241,3,0,147,239,3,0,164,239,3,0,149,241,3,0,161,241,3,0,242,239,3,0,132,241,3,0,55,240,3,0,178,241,3,0,72,240,3,0,94,240,3,0,217,241,3,0,123,240,3,0,145,240,3,0,229,241,3,0,162,240,3,0,251,241,3,0,191,240,3,0,12,242,3,0,41,241,3,0,31,242,3,0,61,242,3,0,106,241,3,0,87,242,3,0,111,242,3,0,138,242,3,0,155,242,3,0,188,242,3,0,217,242,3,0,241,242,3,0,7,243,3,0,24,243,3,0,55,243,3,0,72,243,3,0,79,243,3,0,96,243,3,0,113,243,3,0,125,243,3,0,147,243,3,0,164,243,3,0,197,243,3,0,219,243,3,0,15,244,3,0,48,244,3,0,75,244,3,0,87,244,3,0,106,244,3,0,118,244,3,0,140,244,3,0,152,244,3,0,166,244,3,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,177,244,3,0,194,244,3,0,201,244,3,0,213,244,3,0,220,244,3,0,227,244,3,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,242,244,3,0,12,245,3,0,38,245,3,0,59,245,3,0,85,245,3,0,106,245,3,0,124,245,3,0,156,245,3,0,176,245,3,0,194,245,3,0,218,245,3,0,72,240,3,0,235,245,3,0,16,246,3,0,36,246,3,0,57,246,3,0,83,246,3,0,109,246,3,0,125,246,3,0,152,246,3,0,170,246,3,0,190,246,3,0,202,246,3,0,224,246,3,0,236,246,3,0,254,246,3,0,9,247,3,0,34,247,3,0,71,247,3,0,97,247,3,0,128,247,3,0,158,247,3,0,190,247,3,0,222,247,3,0,5,248,3,0,20,248,3,0,45,248,3,0,63,248,3,0,96,248,3,0,114,248,3,0,36,246,3,0,157,248,3,0,180,248,3,0,203,248,3,0,226,248,3,0,240,248,3,0,7,249,3,0,38,249,3,0,62,249,3,0,90,249,3,0,120,249,3,0,152,249,3,0,175,249,3,0,194,249,3,0,226,249,3,0,251,249,3,0,19,250,3,0,53,250,3,0,81,250,3,0,111,250,3,0,143,250,3,0,168,250,3,0,181,250,3,0,230,250,3,0,36,246,3,0,8,251,3,0,40,251,3,0,66,251,3,0,90,251,3,0,117,251,3,0,135,251,3,0,169,251,3,0,194,251,3,0,234,251,3,0,14,252,3,0,50,252,3,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,75,252,3,0,104,252,3,0,130,252,3,0,164,252,3,0,194,252,3,0,183,131,15,0,183,131,15,0,219,252,3,0,21,253,3,0,30,253,3,0,39,253,3,0,50,253,3,0,61,253,3,0,86,253,3,0,111,253,3,0,159,253,3,0,162,253,3,0,165,253,3,0,190,253,3,0,199,253,3,0,218,253,3,0,248,253,3,0,6,254,3,0,34,254,3,0,63,254,3,0,75,254,3,0,113,254,3,0,142,254,3,0,155,254,3,0,170,254,3,0,194,254,3,0,220,254,3,0,243,254,3,0,21,255,3,0,28,255,3,0,40,255,3,0,61,255,3,0,93,255,3,0,100,255,3,0,115,255,3,0,130,255,3,0,137,255,3,0,144,255,3,0,156,255,3,0,168,255,3,0,180,255,3,0,197,255,3,0,210,255,3,0,225,255,3,0,240,255,3,0,254,255,3,0,20,0,4,0,63,0,4,0,101,0,4,0,183,131,15,0,138,0,4,0,162,0,4,0,224,0,4,0,183,131,15,0,231,0,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,244,0,4,0,183,131,15,0,74,1,4,0,183,131,15,0,128,1,4,0,183,131,15,0,144,1,4,0,183,131,15,0,157,1,4,0,183,131,15,0,211,1,4,0,218,1,4,0,183,131,15,0,230,1,4,0,64,2,4,0,162,2,4,0,255,2,4,0,119,3,4,0,10,4,4,0,187,4,4,0,95,5,4,0,237,5,4,0,118,6,4,0,164,6,4,0,11,7,4,0,89,7,4,0,201,7,4,0,36,8,4,0,58,8,4,0,183,131,15,0,93,8,4,0,136,8,4,0,179,8,4,0,211,8,4,0,243,8,4,0,183,131,15,0,19,9,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,36,9,4,0,53,9,4,0,100,9,4,0,139,9,4,0,171,9,4,0,193,9,4,0,210,9,4,0,0,10,4,0,17,10,4,0,24,10,4,0,47,10,4,0,64,10,4,0,76,10,4,0,98,10,4,0,115,10,4,0,160,10,4,0,188,10,4,0,238,10,4,0,15,11,4,0,58,11,4,0,70,11,4,0,93,11,4,0,105,11,4,0,127,11,4,0,139,11,4,0,153,11,4,0,36,9,4,0,53,9,4,0,170,11,4,0,182,11,4,0,171,9,4,0,153,11,4,0,0,10,4,0,199,11,4,0,17,10,4,0,47,10,4,0,249,11,4,0,76,10,4,0,98,10,4,0,5,12,4,0,115,10,4,0,22,12,4,0,160,10,4,0,39,12,4,0,58,11,4,0,58,12,4,0,96,12,4,0,138,12,4,0,150,12,4,0,186,12,4,0,221,12,4,0,6,13,4,0,88,13,4,0,137,13,4,0,208,13,4,0,9,14,4,0,64,14,4,0,123,14,4,0,199,14,4,0,250,14,4,0,45,15,4,0,122,15,4,0,181,15,4,0,14,16,4,0,78,16,4,0,137,16,4,0,200,16,4,0,9,17,4,0,86,17,4,0,143,17,4,0,193,17,4,0,3,18,4,0,68,18,4,0,116,18,4,0,188,18,4,0,8,19,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,89,19,4,0,106,19,4,0,113,19,4,0,125,19,4,0,132,19,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,145,19,4,0,181,19,4,0,217,19,4,0,248,19,4,0,28,20,4,0,65,20,4,0,83,20,4,0,129,20,4,0,151,20,4,0,169,20,4,0,193,20,4,0,17,10,4,0,210,20,4,0,247,20,4,0,13,21,4,0,50,21,4,0,86,21,4,0,122,21,4,0,140,21,4,0,177,21,4,0,195,21,4,0,217,21,4,0,229,21,4,0,251,21,4,0,7,22,4,0,27,22,4,0,44,22,4,0,92,22,4,0,153,22,4,0,187,22,4,0,236,22,4,0,18,23,4,0,64,23,4,0,102,23,4,0,157,23,4,0,176,23,4,0,213,23,4,0,231,23,4,0,16,24,4,0,44,24,4,0,101,24,4,0,138,24,4,0,163,24,4,0,202,24,4,0,239,24,4,0,255,24,4,0,32,25,4,0,75,25,4,0,103,25,4,0,143,25,4,0,189,25,4,0,234,25,4,0,25,26,4,0,54,26,4,0,102,26,4,0,137,26,4,0,186,26,4,0,242,26,4,0,44,27,4,0,76,27,4,0,116,27,4,0,181,27,4,0,218,27,4,0,27,28,4,0,73,28,4,0,120,28,4,0,167,28,4,0,221,28,4,0,252,28,4,0,28,29,4,0,59,29,4,0,97,29,4,0,131,29,4,0,180,29,4,0,220,29,4,0,10,30,4,0,57,30,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,102,30,4,0,155,30,4,0,187,30,4,0,233,30,4,0,19,31,4,0,183,131,15,0,183,131,15,0,52,31,4,0,140,31,4,0,149,31,4,0,158,31,4,0,175,31,4,0,192,31,4,0,225,31,4,0,2,32,4,0,162,253,3,0,65,32,4,0,68,32,4,0,105,32,4,0,116,32,4,0,147,32,4,0,180,32,4,0,194,32,4,0,231,32,4,0,24,33,4,0,36,33,4,0,97,33,4,0,146,33,4,0,159,33,4,0,178,33,4,0,202,33,4,0,232,33,4,0,250,33,4,0,36,34,4,0,43,34,4,0,55,34,4,0,84,34,4,0,137,34,4,0,144,34,4,0,167,34,4,0,190,34,4,0,197,34,4,0,204,34,4,0,216,34,4,0,228,34,4,0,240,34,4,0,1,35,4,0,14,35,4,0,31,35,4,0,48,35,4,0,66,35,4,0,88,35,4,0,159,35,4,0,213,35,4,0,10,36,4,0,22,36,4,0,34,36,4,0,43,36,4,0,78,36,4,0,141,36,4,0,193,36,4,0,231,36,4,0,67,37,4,0,171,37,4,0,183,131,15,0,183,131,15,0,183,131,15,0,20,38,4,0,56,38,4,0,88,38,4,0,105,38,4,0,155,38,4,0,203,38,4,0,229,38,4,0,249,38,4,0,16,39,4,0,43,39,4,0,66,39,4,0,81,39,4,0,94,39,4,0,109,39,4,0,124,39,4,0,167,39,4,0,210,39,4,0,17,40,4,0,57,40,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,117,40,4,0,124,40,4,0,131,40,4,0,138,40,4,0,145,40,4,0,152,40,4,0,159,40,4,0,183,131,15,0,166,40,4,0,173,40,4,0,180,40,4,0,187,40,4,0,183,131,15,0,194,40,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,201,40,4,0,220,40,4,0,239,40,4,0,2,41,4,0,21,41,4,0,32,41,4,0,43,41,4,0,54,41,4,0,65,41,4,0,112,41,4,0,159,41,4,0,206,41,4,0,253,41,4,0,40,42,4,0,79,42,4,0,183,131,15,0,130,42,4,0,147,42,4,0,158,42,4,0,170,42,4,0,187,42,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,204,42,4,0,241,42,4,0,254,42,4,0,9,43,4,0,22,43,4,0,47,43,4,0,59,43,4,0,71,43,4,0,183,131,15,0,183,131,15,0,88,43,4,0,152,43,4,0,200,43,4,0,231,43,4,0,6,44,4,0,37,44,4,0,68,44,4,0,183,131,15,0,183,131,15,0,183,131,15,0,108,44,4,0,133,44,4,0,154,44,4,0,180,44,4,0,212,44,4,0,249,44,4,0,14,45,4,0,43,45,4,0,107,45,4,0,127,45,4,0,193,45,4,0,51,46,4,0,223,46,4,0,45,47,4,0,107,47,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,134,47,4,0,147,47,4,0,168,47,4,0,197,47,4,0,204,42,4,0,234,47,4,0,23,48,4,0,92,48,4,0,161,48,4,0,6,49,4,0,74,49,4,0,139,49,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,200,49,4,0,232,49,4,0,42,50,4,0,90,50,4,0,140,50,4,0,180,50,4,0,216,50,4,0,28,51,4,0,75,51,4,0,97,51,4,0,134,51,4,0,181,51,4,0,207,51,4,0,3,52,4,0,40,52,4,0,103,52,4,0,150,52,4,0,241,52,4,0,54,53,4,0,118,53,4,0,148,53,4,0,186,53,4,0,213,53,4,0,255,53,4,0,36,54,4,0,72,54,4,0,200,49,4,0,232,49,4,0,102,54,4,0,128,54,4,0,140,50,4,0,72,54,4,0,28,51,4,0,155,54,4,0,75,51,4,0,134,51,4,0,238,54,4,0,207,51,4,0,3,52,4,0,9,55,4,0,40,52,4,0,71,55,4,0,103,52,4,0,108,55,4,0,118,53,4,0,145,55,4,0,208,55,4,0,255,53,4,0,27,56,4,0,88,56,4,0,155,56,4,0,187,56,4,0,251,56,4,0,45,57,4,0,95,57,4,0,135,57,4,0,171,57,4,0,235,57,4,0,26,58,4,0,48,58,4,0,85,58,4,0,132,58,4,0,158,58,4,0,210,58,4,0,247,58,4,0,54,59,4,0,99,59,4,0,188,59,4,0,253,59,4,0,53,60,4,0,83,60,4,0,121,60,4,0,148,60,4,0,190,60,4,0,227,60,4,0,7,61,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,37,61,4,0,44,61,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,56,61,4,0,118,61,4,0,173,61,4,0,221,61,4,0,25,62,4,0,76,62,4,0,114,62,4,0,194,62,4,0,245,62,4,0,22,63,4,0,66,63,4,0,113,63,4,0,135,63,4,0,215,63,4,0,10,64,4,0,65,64,4,0,125,64,4,0,180,64,4,0,221,64,4,0,17,65,4,0,44,65,4,0,95,65,4,0,122,65,4,0,164,65,4,0,201,65,4,0,244,65,4,0,18,66,4,0,80,66,4,0,156,66,4,0,193,66,4,0,13,67,4,0,65,67,4,0,121,67,4,0,171,67,4,0,240,67,4,0,10,68,4,0,59,68,4,0,87,68,4,0,136,68,4,0,172,68,4,0,241,68,4,0,40,69,4,0,76,69,4,0,132,69,4,0,187,69,4,0,213,69,4,0,5,70,4,0,73,70,4,0,106,70,4,0,160,70,4,0,230,70,4,0,36,71,4,0,97,71,4,0,141,71,4,0,208,71,4,0,254,71,4,0,43,72,4,0,109,72,4,0,164,72,4,0,215,72,4,0,10,73,4,0,70,73,4,0,101,73,4,0,189,73,4,0,241,68,4,0,253,73,4,0,64,74,4,0,117,74,4,0,160,74,4,0,208,74,4,0,239,74,4,0,213,69,4,0,47,75,4,0,119,75,4,0,193,75,4,0,5,76,4,0,56,76,4,0,129,76,4,0,182,76,4,0,231,76,4,0,63,77,4,0,147,77,4,0,183,131,15,0,169,77,4,0,210,77,4,0,22,78,4,0,87,78,4,0,183,131,15,0,183,131,15,0,183,131,15,0,131,78,4,0,218,78,4,0,35,79,4,0,107,79,4,0,226,79,4,0,88,80,4,0,183,131,15,0,128,80,4,0,131,80,4,0,134,80,4,0,189,80,4,0,208,80,4,0,20,81,4,0,96,81,4,0,120,81,4,0,183,81,4,0,254,81,4,0,39,82,4,0,137,82,4,0,208,82,4,0,221,82,4,0,238,82,4,0,6,83,4,0,34,83,4,0,63,83,4,0,120,83,4,0,132,83,4,0,154,83,4,0,175,83,4,0,192,83,4,0,199,83,4,0,231,83,4,0,7,84,4,0,29,84,4,0,51,84,4,0,100,84,4,0,149,84,4,0,158,84,4,0,167,84,4,0,174,84,4,0,186,84,4,0,193,84,4,0,205,84,4,0,222,84,4,0,239,84,4,0,251,84,4,0,8,85,4,0,37,85,4,0,49,85,4,0,66,85,4,0,83,85,4,0,92,85,4,0,101,85,4,0,120,85,4,0,139,85,4,0,182,85,4,0,214,85,4,0,230,85,4,0,244,85,4,0,2,86,4,0,30,86,4,0,47,86,4,0,64,86,4,0,81,86,4,0,183,131,15,0,98,86,4,0,121,86,4,0,144,86,4,0,167,86,4,0,190,86,4,0,218,86,4,0,243,86,4,0,12,87,4,0,37,87,4,0,62,87,4,0,135,87,4,0,162,87,4,0,181,87,4,0,233,87,4,0,56,88,4,0,109,88,4,0,160,88,4,0,241,88,4,0,43,89,4,0,109,89,4,0,131,89,4,0,209,89,4,0,8,90,4,0,90,90,4,0,183,131,15,0,112,90,4,0,160,90,4,0,222,90,4,0,10,91,4,0,57,91,4,0,105,91,4,0,152,91,4,0,203,91,4,0,255,91,4,0,49,92,4,0,100,92,4,0,140,92,4,0,184,92,4,0,206,92,4,0,18,93,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,86,93,4,0,123,93,4,0,160,93,4,0,200,93,4,0,240,93,4,0,6,94,4,0,28,94,4,0,79,94,4,0,130,94,4,0,178,94,4,0,226,94,4,0,250,94,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,58,95,4,0,90,95,4,0,176,95,4,0,240,95,4,0,42,96,4,0,82,96,4,0,118,96,4,0,195,96,4,0,242,96,4,0,8,97,4,0,47,97,4,0,94,97,4,0,120,97,4,0,172,97,4,0,209,97,4,0,40,98,4,0,95,98,4,0,220,98,4,0,49,99,4,0,117,99,4,0,147,99,4,0,191,99,4,0,218,99,4,0,4,100,4,0,41,100,4,0,77,100,4,0,58,95,4,0,90,95,4,0,107,100,4,0,133,100,4,0,42,96,4,0,77,100,4,0,195,96,4,0,160,100,4,0,242,96,4,0,47,97,4,0,11,101,4,0,120,97,4,0,172,97,4,0,38,101,4,0,209,97,4,0,100,101,4,0,40,98,4,0,137,101,4,0,117,99,4,0,174,101,4,0,237,101,4,0,4,100,4,0,72,102,4,0,149,102,4,0,232,102,4,0,8,103,4,0,86,103,4,0,154,103,4,0,212,103,4,0,252,103,4,0,32,104,4,0,114,104,4,0,161,104,4,0,183,104,4,0,224,104,4,0,15,105,4,0,41,105,4,0,93,105,4,0,130,105,4,0,213,105,4,0,8,106,4,0,127,106,4,0,206,106,4,0,20,107,4,0,50,107,4,0,98,107,4,0,125,107,4,0,167,107,4,0,204,107,4,0,240,107,4,0,14,108,4,0,99,108,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,158,108,4,0,165,108,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,177,108,4,0,253,108,4,0,60,109,4,0,116,109,4,0,184,109,4,0,245,109,4,0,31,110,4,0,147,110,4,0,198,110,4,0,231,110,4,0,23,111,4,0,70,111,4,0,92,111,4,0,172,111,4,0,223,111,4,0,38,112,4,0,106,112,4,0,169,112,4,0,212,112,4,0,20,113,4,0,51,113,4,0,102,113,4,0,129,113,4,0,171,113,4,0,208,113,4,0,249,113,4,0,23,114,4,0,101,114,4,0,211,114,4,0,9,115,4,0,96,115,4,0,158,115,4,0,220,115,4,0,26,116,4,0,113,116,4,0,143,116,4,0,198,116,4,0,242,116,4,0,39,117,4,0,84,117,4,0,171,117,4,0,234,117,4,0,18,118,4,0,79,118,4,0,147,118,4,0,177,118,4,0,238,118,4,0,55,119,4,0,100,119,4,0,166,119,4,0,252,119,4,0,72,120,4,0,141,120,4,0,191,120,4,0,16,121,4,0,68,121,4,0,137,121,4,0,221,121,4,0,24,122,4,0,75,122,4,0,138,122,4,0,202,122,4,0,237,122,4,0,81,123,4,0,171,117,4,0,153,123,4,0,234,123,4,0,41,124,4,0,92,124,4,0,148,124,4,0,183,124,4,0,255,124,4,0,51,125,4,0,131,125,4,0,213,125,4,0,37,126,4,0,96,126,4,0,177,126,4,0,238,126,4,0,46,127,4,0,146,127,4,0,249,127,4,0,183,131,15,0,15,128,4,0,64,128,4,0,148,128,4,0,229,128,4,0,183,131,15,0,183,131,15,0,27,129,4,0,116,129,4,0,251,129,4,0,96,130,4,0,200,130,4,0,111,131,4,0,25,132,4,0,183,131,15,0,162,253,3,0,65,32,4,0,65,132,4,0,144,132,4,0,165,132,4,0,253,132,4,0,89,133,4,0,113,133,4,0,188,133,4,0,27,134,4,0,86,134,4,0,208,134,4,0,146,33,4,0,47,135,4,0,178,33,4,0,64,135,4,0,92,135,4,0,121,135,4,0,184,135,4,0,196,135,4,0,55,34,4,0,218,135,4,0,137,34,4,0,160,93,4,0,200,93,4,0,240,93,4,0,6,94,4,0,28,94,4,0,79,94,4,0,235,135,4,0,244,135,4,0,190,34,4,0,253,135,4,0,197,34,4,0,204,34,4,0,9,136,4,0,26,136,4,0,228,34,4,0,43,136,4,0,66,136,4,0,216,34,4,0,95,136,4,0,112,136,4,0,140,31,4,0,149,31,4,0,129,136,4,0,148,136,4,0,167,136,4,0,210,136,4,0,2,137,4,0,18,137,4,0,32,137,4,0,46,137,4,0,31,35,4,0,14,35,4,0,82,137,4,0,99,137,4,0,116,137,4,0,135,137,4,0,162,137,4,0,189,137,4,0,216,137,4,0,243,137,4,0,19,138,4,0,40,138,4,0,61,138,4,0,82,138,4,0,103,138,4,0,190,138,4,0,217,138,4,0,250,94,4,0,236,138,4,0,79,139,4,0,132,139,4,0,195,139,4,0,36,140,4,0,146,140,4,0,66,35,4,0,228,140,4,0,62,141,4,0,118,141,4,0,221,141,4,0,183,131,15,0,243,141,4,0,62,142,4,0,146,142,4,0,198,142,4,0,253,142,4,0,57,143,4,0,110,143,4,0,167,143,4,0,252,143,4,0,65,144,4,0,124,144,4,0,172,144,4,0,224,144,4,0,246,144,4,0,86,145,4,0,182,145,4,0,207,145,4,0,232,145,4,0,1,146,4,0,183,131,15,0,26,146,4,0,104,146,4,0,203,146,4,0,3,147,4,0,95,147,4,0,190,147,4,0,24,148,4,0,103,148,4,0,159,148,4,0,218,148,4,0,27,149,4,0,93,149,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,149,4,0,206,149,4,0,241,149,4,0,20,150,4,0,20,150,4,0,87,150,4,0,150,150,4,0,182,150,4,0,214,150,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+71680);allocate([6,151,4,0,38,151,4,0,70,151,4,0,159,151,4,0,207,151,4,0,121,152,4,0,58,153,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,149,4,0,206,149,4,0,241,149,4,0,110,153,4,0,20,150,4,0,87,150,4,0,150,150,4,0,182,150,4,0,214,150,4,0,6,151,4,0,38,151,4,0,173,153,4,0,241,153,4,0,207,151,4,0,33,154,4,0,198,154,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,103,155,4,0,140,155,4,0,182,155,4,0,238,155,4,0,38,156,4,0,64,156,4,0,90,156,4,0,165,156,4,0,240,156,4,0,48,157,4,0,112,157,4,0,138,157,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,249,157,4,0,29,158,4,0,113,158,4,0,189,158,4,0,251,158,4,0,43,159,4,0,81,159,4,0,169,159,4,0,209,159,4,0,225,159,4,0,9,160,4,0,49,160,4,0,75,160,4,0,121,160,4,0,157,160,4,0,237,160,4,0,33,161,4,0,127,161,4,0,191,161,4,0,21,162,4,0,49,162,4,0,97,162,4,0,123,162,4,0,169,162,4,0,199,162,4,0,231,162,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,11,163,4,0,85,163,4,0,221,163,4,0,47,164,4,0,133,164,4,0,229,164,4,0,63,165,4,0,167,165,4,0,19,166,4,0,85,166,4,0,153,166,4,0,11,167,4,0,91,167,4,0,185,167,4,0,3,168,4,0,71,168,4,0,175,168,4,0,5,169,4,0,131,169,4,0,203,169,4,0,22,170,4,0,98,170,4,0,170,170,4,0,248,170,4,0,95,171,4,0,177,171,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,8,172,4,0,78,172,4,0,148,172,4,0,212,172,4,0,26,173,4,0,98,173,4,0,143,173,4,0,237,173,4,0,29,174,4,0,75,174,4,0,121,174,4,0,209,159,4,0,161,174,4,0,241,174,4,0,33,175,4,0,105,175,4,0,175,175,4,0,245,175,4,0,29,176,4,0,123,176,4,0,153,176,4,0,201,176,4,0,227,176,4,0,17,177,4,0,47,177,4,0,79,177,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,115,177,4,0,179,177,4,0,224,177,4,0,12,178,4,0,76,178,4,0,122,178,4,0,176,178,4,0,250,178,4,0,51,179,4,0,88,179,4,0,135,179,4,0,193,179,4,0,226,179,4,0,56,180,4,0,118,180,4,0,176,180,4,0,233,180,4,0,45,181,4,0,91,181,4,0,134,181,4,0,172,181,4,0,224,181,4,0,13,182,4,0,82,182,4,0,162,182,4,0,224,182,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,162,253,3,0,65,32,4,0,42,183,4,0,123,183,4,0,147,183,4,0,213,183,4,0,47,184,4,0,80,184,4,0,179,184,4,0,42,185,4,0,65,185,4,0,198,185,4,0,61,186,4,0,93,186,4,0,139,186,4,0,201,186,4,0,21,187,4,0,67,187,4,0,177,187,4,0,223,187,4,0,13,188,4,0,152,188,4,0,251,188,4,0,11,189,4,0,59,189,4,0,107,189,4,0,178,189,4,0,194,189,4,0,224,189,4,0,254,189,4,0,19,190,4,0,59,190,4,0,118,190,4,0,138,190,4,0,158,190,4,0,216,190,4,0,84,191,4,0,247,191,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,162,253,3,0,65,32,4,0,93,192,4,0,176,192,4,0,204,192,4,0,30,193,4,0,128,193,4,0,147,193,4,0,222,193,4,0,57,194,4,0,114,194,4,0,236,194,4,0,71,195,4,0,84,195,4,0,101,195,4,0,123,195,4,0,151,195,4,0,183,195,4,0,250,195,4,0,11,196,4,0,28,196,4,0,137,196,4,0,217,196,4,0,224,196,4,0,8,197,4,0,48,197,4,0,197,34,4,0,204,34,4,0,216,34,4,0,65,197,4,0,77,197,4,0,99,197,4,0,140,31,4,0,149,31,4,0,128,197,4,0,150,197,4,0,36,140,4,0,79,139,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,58,95,4,0,213,197,4,0,90,95,4,0,107,100,4,0,16,198,4,0,42,96,4,0,71,198,4,0,206,198,4,0,38,199,4,0,85,199,4,0,151,199,4,0,232,199,4,0,120,97,4,0,195,96,4,0,209,97,4,0,100,101,4,0,40,98,4,0,176,95,4,0,117,99,4,0,23,200,4,0,68,200,4,0,4,100,4,0,159,200,4,0,206,200,4,0,1,201,4,0,53,201,4,0,115,201,4,0,174,201,4,0,249,201,4,0,48,202,4,0,125,202,4,0,237,202,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,177,108,4,0,66,203,4,0,160,203,4,0,230,203,4,0,0,204,4,0,184,109,4,0,41,204,4,0,152,204,4,0,234,204,4,0,25,205,4,0,91,205,4,0,162,205,4,0,203,205,4,0,255,205,4,0,223,111,4,0,46,206,4,0,38,112,4,0,60,109,4,0,83,206,4,0,113,206,4,0,154,206,4,0,171,113,4,0,252,206,4,0,37,207,4,0,88,207,4,0,140,207,4,0,196,207,4,0,247,207,4,0,58,208,4,0,105,208,4,0,172,208,4,0,12,209,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,87,209,4,0,149,209,4,0,34,210,4,0,107,210,4,0,219,210,4,0,105,211,4,0,225,211,4,0,81,212,4,0,218,212,4,0,29,213,4,0,112,213,4,0,229,213,4,0,62,214,4,0,169,214,4,0,236,214,4,0,85,215,4,0,190,215,4,0,82,216,4,0,226,216,4,0,57,217,4,0,154,217,4,0,235,217,4,0,38,218,4,0,133,218,4,0,225,218,4,0,52,219,4,0,87,209,4,0,149,209,4,0,123,219,4,0,212,219,4,0,219,210,4,0,52,219,4,0,81,212,4,0,249,219,4,0,218,212,4,0,112,213,4,0,158,220,4,0,62,214,4,0,169,214,4,0,215,220,4,0,236,214,4,0,131,221,4,0,85,215,4,0,2,222,4,0,57,217,4,0,65,222,4,0,179,222,4,0,133,218,4,0,69,223,4,0,221,223,4,0,74,224,4,0,140,224,4,0,25,225,4,0,106,225,4,0,220,225,4,0,101,226,4,0,221,226,4,0,87,227,4,0,224,227,4,0,35,228,4,0,122,228,4,0,244,228,4,0,72,229,4,0,188,229,4,0,6,230,4,0,115,230,4,0,222,230,4,0,116,231,4,0,0,232,4,0,87,232,4,0,179,232,4,0,10,233,4,0,71,233,4,0,170,233,4,0,6,234,4,0,94,234,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,155,234,4,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,189,234,4,0,37,235,4,0,125,235,4,0,192,235,4,0,32,236,4,0,111,236,4,0,184,236,4,0,98,237,4,0,212,237,4,0,31,238,4,0,107,238,4,0,211,238,4,0,9,239,4,0,183,239,4,0,41,240,4,0,130,240,4,0,239,240,4,0,84,241,4,0,161,241,4,0,244,241,4,0,30,242,4,0,108,242,4,0,162,242,4,0,240,242,4,0,66,243,4,0,138,243,4,0,209,243,4,0,56,244,4,0,186,244,4,0,24,245,4,0,141,245,4,0,237,245,4,0,82,246,4,0,162,246,4,0,29,247,4,0,80,247,4,0,185,247,4,0,239,247,4,0,63,248,4,0,136,248,4,0,41,240,4,0,11,249,4,0,81,249,4,0,170,249,4,0,17,250,4,0,67,250,4,0,145,250,4,0,4,251,4,0,74,251,4,0,177,251,4,0,27,252,4,0,123,252,4,0,222,252,4,0,33,253,4,0,143,253,4,0,208,253,4,0,40,254,4,0,150,254,4,0,226,254,4,0,36,255,4,0,122,255,4,0,213,255,4,0,6,0,5,0,121,0,5,0,201,0,5,0,34,1,5,0,157,1,5,0,6,2,5,0,64,2,5,0,155,2,5,0,199,2,5,0,23,3,5,0,80,3,5,0,172,3,5,0,15,4,5,0,109,4,5,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,182,4,5,0,41,5,5,0,126,5,5,0,233,5,5,0,90,6,5,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,162,253,3,0,65,32,4,0,170,6,5,0,11,7,5,0,60,7,5,0,179,7,5,0,69,8,5,0,118,8,5,0,223,8,5,0,101,9,5,0,182,9,5,0,76,10,5,0,61,186,4,0,93,186,4,0,139,186,4,0,201,186,4,0,210,10,5,0,18,11,5,0,177,187,4,0,223,187,4,0,118,11,5,0,4,12,5,0,251,188,4,0,113,12,5,0,166,12,5,0,107,189,4,0,178,189,4,0,194,189,4,0,224,189,4,0,254,189,4,0,19,190,4,0,59,190,4,0,118,190,4,0,138,190,4,0,158,190,4,0,219,12,5,0,99,13,5,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,162,253,3,0,65,32,4,0,231,13,5,0,88,14,5,0,125,14,5,0,225,14,5,0,93,15,5,0,121,15,5,0,214,15,5,0,77,16,5,0,150,16,5,0,87,17,5,0,206,17,5,0,238,17,5,0,25,18,5,0,87,18,5,0,160,18,5,0,224,18,5,0,82,19,5,0,125,19,5,0,168,19,5,0,52,20,5,0,153,20,5,0,169,20,5,0,231,20,5,0,37,21,5,0,178,189,4,0,194,189,4,0,224,189,4,0,108,21,5,0,129,21,5,0,169,21,5,0,118,190,4,0,138,190,4,0,228,21,5,0,30,22,5,0,166,22,5,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,183,131,15,0,0,0,0,0,0,0,0,0,240,62,0,0,19,0,0,0,124,1,0,0,124,0,0,0,0,0,0,0,224,62,0,0,19,0,0,0,125,1,0,0,125,0,0,0,0,0,0,0,0,63,0,0,21,0,0,0,126,1,0,0,127,1,0,0,62,0,0,0,0,0,0,0,63,0,0,0,64,0,0,0,0,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,0,0,0,0,24,0,0,0,25,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,79,0,0,0,80,0,0,0,0,0,0,0,81,0,0,0,82,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,84,0,0,0,85,0,0,0,0,0,0,0,86,0,0,0,87,0,0,0,0,0,0,0,88,0,0,0,0,0,0,0,89,0,0,0,90,0,0,0,0,0,0,0,91,0,0,0,92,0,0,0,0,0,0,0,0,0,0,0,144,63,0,0,128,1,0,0,129,1,0,0,126,0,0,0,0,0,0,0,160,63,0,0,130,1,0,0,131,1,0,0,127,0,0,0,0,0,0,0,176,63,0,0,132,1,0,0,133,1,0,0,128,0,0,0,0,0,0,0,192,63,0,0,134,1,0,0,135,1,0,0,129,0,0,0,0,0,0,0,208,63,0,0,136,1,0,0,137,1,0,0,130,0,0,0,0,0,0,0,224,63,0,0,138,1,0,0,139,1,0,0,131,0,0,0,0,0,0,0,240,63,0,0,140,1,0,0,141,1,0,0,132,0,0,0,0,0,0,0,0,64,0,0,142,1,0,0,143,1,0,0,133,0,0,0,0,0,0,0,16,64,0,0,144,1,0,0,145,1,0,0,134,0,0,0,0,0,0,0,32,64,0,0,146,1,0,0,147,1,0,0,135,0,0,0,0,0,0,0,48,64,0,0,148,1,0,0,149,1,0,0,136,0,0,0,0,0,0,0,64,64,0,0,150,1,0,0,151,1,0,0,137,0,0,0,0,0,0,0,80,64,0,0,152,1,0,0,153,1,0,0,138,0,0,0,0,0,0,0,96,64,0,0,154,1,0,0,155,1,0,0,139,0,0,0,0,0,0,0,112,64,0,0,156,1,0,0,157,1,0,0,140,0,0,0,0,0,0,0,128,64,0,0,19,0,0,0,158,1,0,0,141,0,0,0,0,0,0,0,144,64,0,0,19,0,0,0,159,1,0,0,142,0,0,0,0,0,0,0,160,64,0,0,19,0,0,0,160,1,0,0,143,0,0,0,0,0,0,0,176,64,0,0,19,0,0,0,161,1,0,0,144,0,0,0,0,0,0,0,192,64,0,0,19,0,0,0,162,1,0,0,145,0,0,0,0,0,0,0,208,64,0,0,163,1,0,0,164,1,0,0,146,0,0,0,0,0,0,0,224,64,0,0,165,1,0,0,166,1,0,0,147,0,0,0,0,0,0,0,240,64,0,0,167,1,0,0,168,1,0,0,148,0,0,0,0,0,0,0,0,65,0,0,169,1,0,0,170,1,0,0,149,0,0,0,0,0,0,0,16,65,0,0,171,1,0,0,172,1,0,0,150,0,0,0,0,0,0,0,32,65,0,0,173,1,0,0,174,1,0,0,151,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,29,0,0,0,30,0,0,0,0,0,0,0,31,0,0,0,0,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,36,0,0,0,0,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,39,0,0,0,40,0,0,0,0,0,0,0,0,0,0,0,48,65,0,0,19,0,0,0,175,1,0,0,152,0,0,0,0,0,0,0,64,65,0,0,176,1,0,0,177,1,0,0,153,0,0,0,0,0,0,0,80,65,0,0,178,1,0,0,179,1,0,0,154,0,0,0,0,0,0,0,96,65,0,0,180,1,0,0,181,1,0,0,65,0,0,0,20,0,0,0,21,0,0,0,28,0,0,0,22,0,0,0,23,0,0,0,67,0,0,0,77,0,0,0,30,0,0,0,0,0,0,0,112,65,0,0,21,0,0,0,182,1,0,0,183,1,0,0,0,0,0,0,176,66,0,0,184,1,0,0,185,1,0,0,59,0,0,0,0,0,0,0,160,66,0,0,21,0,0,0,186,1,0,0,187,1,0,0,0,0,0,0,144,66,0,0,184,1,0,0,188,1,0,0,60,0,0,0,0,0,0,0,128,66,0,0,21,0,0,0,189,1,0,0,190,1,0,0,0,0,0,0,112,66,0,0,184,1,0,0,191,1,0,0,61,0,0,0,0,0,0,0,96,66,0,0,21,0,0,0,192,1,0,0,193,1,0,0,0,0,0,0,80,66,0,0,184,1,0,0,194,1,0,0,62,0,0,0,0,0,0,0,64,66,0,0,21,0,0,0,195,1,0,0,196,1,0,0,0,0,0,0,48,66,0,0,184,1,0,0,197,1,0,0,63,0,0,0,0,0,0,0,32,66,0,0,21,0,0,0,198,1,0,0,199,1,0,0,0,0,0,0,16,66,0,0,184,1,0,0,200,1,0,0,64,0,0,0,0,0,0,0,0,66,0,0,21,0,0,0,201,1,0,0,202,1,0,0,0,0,0,0,240,65,0,0,184,1,0,0,203,1,0,0,65,0,0,0,0,0,0,0,224,65,0,0,21,0,0,0,204,1,0,0,205,1,0,0,0,0,0,0,208,65,0,0,184,1,0,0,206,1,0,0,66,0,0,0,0,0,0,0,192,65,0,0,21,0,0,0,207,1,0,0,208,1,0,0,0,0,0,0,176,65,0,0,184,1,0,0,209,1,0,0,67,0,0,0,0,0,0,0,160,65,0,0,21,0,0,0,210,1,0,0,211,1,0,0,0,0,0,0,144,65,0,0,184,1,0,0,212,1,0,0,68,0,0,0,0,0,0,0,128,65,0,0,21,0,0,0,213,1,0,0,214,1,0,0,0,0,0,0,240,67,0,0,215,1,0,0,216,1,0,0,68,0,0,0,31,1,0,0,0,0,0,0,224,67,0,0,21,0,0,0,217,1,0,0,218,1,0,0,0,0,0,0,208,67,0,0,215,1,0,0,219,1,0,0,69,0,0,0,31,1,0,0,0,0,0,0,192,67,0,0,21,0,0,0,220,1,0,0,221,1,0,0,0,0,0,0,176,67,0,0,215,1,0,0,222,1,0,0,70,0,0,0,31,1,0,0,0,0,0,0,160,67,0,0,21,0,0,0,223,1,0,0,224,1,0,0,0,0,0,0,144,67,0,0,215,1,0,0,225,1,0,0,71,0,0,0,31,1,0,0,0,0,0,0,128,67,0,0,21,0,0,0,226,1,0,0,227,1,0,0,0,0,0,0,112,67,0,0,215,1,0,0,228,1,0,0,72,0,0,0,31,1,0,0,0,0,0,0,96,67,0,0,21,0,0,0,229,1,0,0,230,1,0,0,0,0,0,0,80,67,0,0,215,1,0,0,231,1,0,0,73,0,0,0,31,1,0,0,0,0,0,0,64,67,0,0,21,0,0,0,232,1,0,0,233,1,0,0,0,0,0,0,48,67,0,0,215,1,0,0,234,1,0,0,74,0,0,0,31,1,0,0,0,0,0,0,32,67,0,0,21,0,0,0,235,1,0,0,236,1,0,0,0,0,0,0,16,67,0,0,215,1,0,0,237,1,0,0,75,0,0,0,31,1,0,0,0,0,0,0,0,67,0,0,21,0,0,0,238,1,0,0,239,1,0,0,0,0,0,0,240,66,0,0,215,1,0,0,240,1,0,0,76,0,0,0,31,1,0,0,0,0,0,0,224,66,0,0,21,0,0,0,241,1,0,0,242,1,0,0,0,0,0,0,208,66,0,0,215,1,0,0,243,1,0,0,77,0,0,0,31,1,0,0,0,0,0,0,192,66,0,0,21,0,0,0,244,1,0,0,245,1,0,0,0,0,0,0,32,69,0,0,21,0,0,0,246,1,0,0,247,1,0,0,0,0,0,0,0,69,0,0,21,0,0,0,248,1,0,0,249,1,0,0,0,0,0,0,224,68,0,0,21,0,0,0,250,1,0,0,251,1,0,0,0,0,0,0,192,68,0,0,21,0,0,0,252,1,0,0,253,1,0,0,0,0,0,0,160,68,0,0,21,0,0,0,254,1,0,0,255,1,0,0,0,0,0,0,128,68,0,0,21,0,0,0,0,2,0,0,1,2,0,0,0,0,0,0,96,68,0,0,21,0,0,0,2,2,0,0,3,2,0,0,0,0,0,0,64,68,0,0,21,0,0,0,4,2,0,0,5,2,0,0,0,0,0,0,32,68,0,0,21,0,0,0,6,2,0,0,7,2,0,0,0,0,0,0,0,68,0,0,21,0,0,0,8,2,0,0,9,2,0,0,0,0,0,0,16,68,0,0,10,2,0,0,11,2,0,0,41,0,0,0,99,1,0,0,0,0,0,0,48,68,0,0,12,2,0,0,13,2,0,0,42,0,0,0,99,1,0,0,0,0,0,0,80,68,0,0,14,2,0,0,15,2,0,0,43,0,0,0,99,1,0,0,0,0,0,0,112,68,0,0,16,2,0,0,17,2,0,0,44,0,0,0,99,1,0,0,0,0,0,0,144,68,0,0,18,2,0,0,19,2,0,0,45,0,0,0,99,1,0,0,0,0,0,0,176,68,0,0,20,2,0,0,21,2,0,0,46,0,0,0,99,1,0,0,0,0,0,0,208,68,0,0,22,2,0,0,23,2,0,0,47,0,0,0,99,1,0,0,0,0,0,0,240,68,0,0,24,2,0,0,25,2,0,0,48,0,0,0,99,1,0,0,0,0,0,0,16,69,0,0,26,2,0,0,27,2,0,0,49,0,0,0,99,1,0,0,0,0,0,0,48,69,0,0,28,2,0,0,29,2,0,0,50,0,0,0,99,1,0,0,0,0,0,0,64,69,0,0,30,2,0,0,31,2,0,0,155,0,0,0,0,0,0,0,96,70,0,0,184,1,0,0,32,2,0,0,69,0,0,0,0,0,0,0,80,70,0,0,21,0,0,0,33,2,0,0,34,2,0,0,0,0,0,0,64,70,0,0,184,1,0,0,35,2,0,0,70,0,0,0,0,0,0,0,48,70,0,0,21,0,0,0,36,2,0,0,37,2,0,0,0,0,0,0,32,70,0,0,184,1,0,0,38,2,0,0,71,0,0,0,0,0,0,0,16,70,0,0,21,0,0,0,39,2,0,0,40,2,0,0,0,0,0,0,0,70,0,0,184,1,0,0,41,2,0,0,72,0,0,0,0,0,0,0,240,69,0,0,21,0,0,0,42,2,0,0,43,2,0,0,0,0,0,0,224,69,0,0,184,1,0,0,44,2,0,0,73,0,0,0,0,0,0,0,208,69,0,0,21,0,0,0,45,2,0,0,46,2,0,0,0,0,0,0,192,69,0,0,184,1,0,0,47,2,0,0,74,0,0,0,0,0,0,0,176,69,0,0,21,0,0,0,48,2,0,0,49,2,0,0,0,0,0,0,160,69,0,0,184,1,0,0,50,2,0,0,75,0,0,0,0,0,0,0,144,69,0,0,21,0,0,0,51,2,0,0,52,2,0,0,0,0,0,0,128,69,0,0,184,1,0,0,53,2,0,0,76,0,0,0,0,0,0,0,112,69,0,0,21,0,0,0,54,2,0,0,55,2,0,0,0,0,0,0,96,69,0,0,184,1,0,0,56,2,0,0,77,0,0,0,0,0,0,0,80,69,0,0,21,0,0,0,57,2,0,0,58,2,0,0,0,0,0,0,192,71,0,0,59,2,0,0,60,2,0,0,78,0,0,0,61,2,0,0,0,0,0,0,176,71,0,0,21,0,0,0,62,2,0,0,63,2,0,0,0,0,0,0,160,71,0,0,64,2,0,0,65,2,0,0,79,0,0,0,66,2,0,0,0,0,0,0,144,71,0,0,21,0,0,0,67,2,0,0,68,2,0,0,0,0,0,0,128,71,0,0,69,2,0,0,70,2,0,0,80,0,0,0,71,2,0,0,0,0,0,0,112,71,0,0,21,0,0,0,72,2,0,0,73,2,0,0,0,0,0,0,96,71,0,0,74,2,0,0,75,2,0,0,81,0,0,0,76,2,0,0,0,0,0,0,80,71,0,0,21,0,0,0,77,2,0,0,78,2,0,0,0,0,0,0,64,71,0,0,79,2,0,0,80,2,0,0,82,0,0,0,81,2,0,0,0,0,0,0,48,71,0,0,21,0,0,0,82,2,0,0,83,2,0,0,0,0,0,0,32,71,0,0,84,2,0,0,85,2,0,0,83,0,0,0,86,2,0,0,0,0,0,0,16,71,0,0,21,0,0,0,87,2,0,0,88,2,0,0,0,0,0,0,0,71,0,0,89,2,0,0,90,2,0,0,84,0,0,0,91,2,0,0,0,0,0,0,240,70,0,0,21,0,0,0,92,2,0,0,93,2,0,0,0,0,0,0,224,70,0,0,94,2,0,0,95,2,0,0,85,0,0,0,96,2,0,0,0,0,0,0,208,70,0,0,21,0,0,0,97,2,0,0,98,2,0,0,0,0,0,0,192,70,0,0,99,2,0,0,100,2,0,0,86,0,0,0,101,2,0,0,0,0,0,0,176,70,0,0,21,0,0,0,102,2,0,0,103,2,0,0,0,0,0,0,160,70,0,0,104,2,0,0,105,2,0,0,87,0,0,0,106,2,0,0,0,0,0,0,144,70,0,0,21,0,0,0,107,2,0,0,108,2,0,0,0,0,0,0,128,70,0,0,109,2,0,0,110,2,0,0,88,0,0,0,111,2,0,0,0,0,0,0,112,70,0,0,21,0,0,0,112,2,0,0,113,2,0,0,0,0,0,0,96,72,0,0,184,1,0,0,114,2,0,0,78,0,0,0,0,0,0,0,80,72,0,0,21,0,0,0,115,2,0,0,116,2,0,0,0,0,0,0,64,72,0,0,184,1,0,0,117,2,0,0,79,0,0,0,0,0,0,0,48,72,0,0,21,0,0,0,118,2,0,0,119,2,0,0,0,0,0,0,32,72,0,0,184,1,0,0,120,2,0,0,80,0,0,0,0,0,0,0,16,72,0,0,21,0,0,0,121,2,0,0,122,2,0,0,0,0,0,0,0,72,0,0,184,1,0,0,123,2,0,0,81,0,0,0,0,0,0,0,240,71,0,0,21,0,0,0,124,2,0,0,125,2,0,0,0,0,0,0,224,71,0,0,184,1,0,0,126,2,0,0,82,0,0,0,0,0,0,0,208,71,0,0,21,0,0,0,127,2,0,0,128,2,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,62,0,0,0,63,0,0,128,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,61,0,0,128,62,0,0,192,62,0,0,128,62,0,0,128,61,0,0,0,0,0,0,0,0,0,0,0,61,0,0,224,61,0,0,96,62,0,0,144,62,0,0,96,62,0,0,224,61,0,0,0,61,0,0,0,0,128,72,0,0,19,0,0,0,129,2,0,0,156,0,0,0,0,0,0,0,112,72,0,0,19,0,0,0,130,2,0,0,157,0,0,0,0,0,0,0,144,72,0,0,131,2,0,0,132,2,0,0,158,0,0,0,0,0,0,0,96,73,0,0,21,0,0,0,133,2,0,0,134,2,0,0,0,0,0,0,80,73,0,0,21,0,0,0,135,2,0,0,136,2,0,0,0,0,0,0,64,73,0,0,21,0,0,0,137,2,0,0,138,2,0,0,0,0,0,0,48,73,0,0,21,0,0,0,139,2,0,0,140,2,0,0,0,0,0,0,32,73,0,0,21,0,0,0,141,2,0,0,142,2,0,0,0,0,0,0,16,73,0,0,21,0,0,0,143,2,0,0,144,2,0,0,0,0,0,0,0,73,0,0,21,0,0,0,145,2,0,0,146,2,0,0,0,0,0,0,240,72,0,0,21,0,0,0,147,2,0,0,148,2,0,0,0,0,0,0,224,72,0,0,21,0,0,0,149,2,0,0,150,2,0,0,0,0,0,0,208,72,0,0,21,0,0,0,151,2,0,0,152,2,0,0,0,0,0,0,192,72,0,0,21,0,0,0,153,2,0,0,154,2,0,0,0,0,0,0,176,72,0,0,21,0,0,0,155,2,0,0,156,2,0,0,0,0,0,0,160,72,0,0,21,0,0,0,157,2,0,0,158,2,0,0,0,0,0,0,112,73,0,0,159,2,0,0,160,2,0,0,29,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,30,0,0,0,40,0,0,0,31,0,0,0,32,0,0,0,41,0,0,0,159,0,0,0,0,0,0,0,128,73,0,0,161,2,0,0,162,2,0,0,42,0,0,0,43,0,0,0,44,0,0,0,4,0,0,0,160,0,0,0,161,0,0,0,163,2,0,0,0,0,0,0,144,73,0,0,164,2,0,0,165,2,0,0,29,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,33,0,0,0,45,0,0,0,31,0,0,0,34,0,0,0,46,0,0,0,162,0,0,0,0,0,0,0,160,73,0,0,166,2,0,0,167,2,0,0,47,0,0,0,43,0,0,0,44,0,0,0,5,0,0,0,160,0,0,0,163,0,0,0,163,2,0,0,0,0,0,0,176,73,0,0,168,2,0,0,169,2,0,0,29,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,35,0,0,0,48,0,0,0,31,0,0,0,32,0,0,0,41,0,0,0,164,0,0,0,0,0,0,0,192,73,0,0,170,2,0,0,171,2,0,0,42,0,0,0,43,0,0,0,44,0,0,0,6,0,0,0,160,0,0,0,165,0,0,0,163,2,0,0,0,0,0,0,208,73,0,0,172,2,0,0,173,2,0,0,29,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,36,0,0,0,49,0,0,0,31,0,0,0,32,0,0,0,41,0,0,0,166,0,0,0,0,0,0,0,224,73,0,0,174,2,0,0,175,2,0,0,50,0,0,0,43,0,0,0,44,0,0,0,7,0,0,0,160,0,0,0,167,0,0,0,163,2,0,0,0,0,0,0,240,73,0,0,176,2,0,0,177,2,0,0,29,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,37,0,0,0,51,0,0,0,31,0,0,0,38,0,0,0,52,0,0,0,168,0,0,0,0,0,0,0,8,74,0,0,178,2,0,0,179,2,0,0,53,0,0,0,43,0,0,0,44,0,0,0,8,0,0,0,160,0,0,0,169,0,0,0,163,2,0,0,0,0,0,0,24,74,0,0,180,2,0,0,181,2,0,0,29,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,39,0,0,0,54,0,0,0,31,0,0,0,32,0,0,0,41,0,0,0,170,0,0,0,0,0,0,0,40,74,0,0,182,2,0,0,183,2,0,0,42,0,0,0,43,0,0,0,44,0,0,0,9,0,0,0,160,0,0,0,171,0,0,0,163,2,0,0,0,0,0,0,56,74,0,0,184,2,0,0,185,2,0,0,55,0,0,0,43,0,0,0,44,0,0,0,10,0,0,0,160,0,0,0,172,0,0,0,163,2,0,0,0,0,0,0,72,74,0,0,186,2,0,0,187,2,0,0,56,0,0,0,57,0,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,0,0,0,0,88,74,0,0,192,2,0,0,193,2,0,0,58,0,0,0,59,0,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,0,0,0,0,96,74,0,0,186,2,0,0,198,2,0,0,56,0,0,0,57,0,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,0,0,0,0,112,74,0,0,186,2,0,0,199,2,0,0,56,0,0,0,57,0,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,0,0,0,0,128,74,0,0,192,2,0,0,200,2,0,0,58,0,0,0,59,0,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,0,0,0,0,144,74,0,0,192,2,0,0,201,2,0,0,58,0,0,0,59,0,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,0,0,0,0,168,74,0,0,202,2,0,0,203,2,0,0,29,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,1,0,0,0,1,0,0,0,31,0,0,0,32,0,0,0,41,0,0,0,173,0,0,0,0,0,0,0,176,74,0,0,204,2,0,0,205,2,0,0,42,0,0,0,43,0,0,0,44,0,0,0,1,0,0,0,160,0,0,0,174,0,0,0,163,2,0,0,0,0,0,0,184,74,0,0,21,0,0,0,206,2,0,0,207,2,0,0,0,0,0,0,200,74,0,0,208,2,0,0,209,2,0,0,210,2,0,0,175,0,0,0,176,0,0,0,40,0,0,0,22,0,0,0,177,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,11,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,44,0,0,0,2,0,0,0,178,0,0,0,179,0,0,0,180,0,0,0,181,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,78,0,0,0,0,0,0,0,216,74,0,0,211,2,0,0,212,2,0,0,182,0,0,0,0,0,0,0,8,75,0,0,213,2,0,0,214,2,0,0,65,0,0,0,183,0,0,0,184,0,0,0,40,0,0,0,22,0,0,0,185,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,12,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,48,0,0,0,186,0,0,0,49,0,0,0,187,0,0,0,50,0,0,0,188,0,0,0,51,0,0,0,189,0,0,0,52,0,0,0,190,0,0,0,53,0,0,0,191,0,0,0,54,0,0,0,192,0,0,0,9,0,0,0,9,0,0,0,193,0,0,0,194,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,195,0,0,0,60,0,0,0,196,0,0,0,10,0,0,0,10,0,0,0,0,0,0,0,248,74,0,0,215,2,0,0,216,2,0,0,217,2,0,0,197,0,0,0,198,0,0,0,40,0,0,0,22,0,0,0,199,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,13,0,0,0,9,0,0,0,1,0,0,0,4,0,0,0,64,0,0,0,200,0,0,0,65,0,0,0,201,0,0,0,66,0,0,0,202,0,0,0,67,0,0,0,203,0,0,0,68,0,0,0,204,0,0,0,69,0,0,0,205,0,0,0,70,0,0,0,206,0,0,0,11,0,0,0,11,0,0,0,207,0,0,0,208,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,209,0,0,0,79,0,0,0,218,2,0,0,219,2,0,0,60,0,0,0,14,0,0,0,75,0,0,0,61,0,0,0,80,0,0,0,3,0,0,0,51,0,0,0,1,0,0,0,4,0,0,0,2,0,0,0,31,0,0,0,62,0,0,0,1,0,0,0,1,0,0,0,5,0,0,0,210,0,0,0,211,0,0,0,81,0,0,0,38,0,0,0,82,0,0,0,212,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,0,0,0,0,232,74,0,0,21,0,0,0,220,2,0,0,221,2,0,0,0,0,0,0,32,75,0,0,21,0,0,0,222,2,0,0,223,2,0,0,0,0,0,0,48,75,0,0,224,2,0,0,225,2,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,39,0,0,0,213,0,0,0,214,0,0,0,83,0,0,0,215,0,0,0,216,0,0,0,217,0,0,0,218,0,0,0,219,0,0,0,220,0,0,0,221,0,0,0,222,0,0,0,223,0,0,0,224,0,0,0,225,0,0,0,82,0,0,0,226,0,0,0,227,0,0,0,40,0,0,0,41,0,0,0,228,0,0,0,66,0,0,0,229,0,0,0,230,0,0,0,231,0,0,0,83,0,0,0,1,0,0,0,226,2,0,0,0,0,0,0,80,75,0,0,227,2,0,0,228,2,0,0,229,2,0,0,232,0,0,0,233,0,0,0,40,0,0,0,22,0,0,0,234,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,15,0,0,0,9,0,0,0,1,0,0,0,6,0,0,0,86,0,0,0,235,0,0,0,87,0,0,0,236,0,0,0,237,0,0,0,238,0,0,0,239,0,0,0,240,0,0,0,241,0,0,0,42,0,0,0,32,0,0,0,2,0,0,0,30,0,0,0,0,0,0,0,64,75,0,0,21,0,0,0,230,2,0,0,231,2,0,0,0,0,0,0,224,75,0,0,232,2,0,0,233,2,0,0,65,0,0,0,242,0,0,0,243,0,0,0,40,0,0,0,22,0,0,0,244,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,16,0,0,0,9,0,0,0,1,0,0,0,7,0,0,0,91,0,0,0,245,0,0,0,92,0,0,0,246,0,0,0,93,0,0,0,247,0,0,0,94,0,0,0,248,0,0,0,1,0,0,0,0,0,0,0,120,75,0,0,21,0,0,0,234,2,0,0,235,2,0,0,0,0,0,0,192,75,0,0,236,2,0,0,237,2,0,0,249,0,0,0,95,0,0,0,2,0,0,0,250,0,0,0,0,0,0,0,176,75,0,0,21,0,0,0,238,2,0,0,239,2,0,0,0,0,0,0,160,75,0,0,240,2,0,0,241,2,0,0,251,0,0,0,96,0,0,0,3,0,0,0,252,0,0,0,0,0,0,0,136,75,0,0,21,0,0,0,242,2,0,0,243,2,0,0,0,0,0,0,152,75,0,0,236,2,0,0,244,2,0,0,1,0,0,0,1,0,0,0,1,0,0,0,250,0,0,0,0,0,0,0,208,75,0,0,19,0,0,0,245,2,0,0,253,0,0,0,0,0,0,0,240,75,0,0,246,2,0,0,247,2,0,0,248,2,0,0,254,0,0,0,255,0,0,0,40,0,0,0,22,0,0,0,0,1,0,0,97,0,0,0,98,0,0,0,99,0,0,0,17,0,0,0,9,0,0,0,1,0,0,0,8,0,0,0,12,0,0,0,12,0,0,0,100,0,0,0,1,1,0,0,101,0,0,0,2,1,0,0,102,0,0,0,3,1,0,0,103,0,0,0,4,1,0,0,5,1,0,0,6,1,0,0,7,1,0,0,0,0,0,0,0,76,0,0,21,0,0,0,249,2,0,0,250,2,0,0,0,0,0,0,32,76,0,0,251,2,0,0,252,2,0,0,253,2,0,0,8,1,0,0,9,1,0,0,40,0,0,0,22,0,0,0,10,1,0,0,104,0,0,0,105,0,0,0,106,0,0,0,18,0,0,0,9,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,0,0,0,0,16,76,0,0,21,0,0,0,254,2,0,0,255,2,0,0,0,0,0,0,48,76,0,0,19,0,0,0,0,3,0,0,11,1,0,0,0,0,0,0,96,76,0,0,1,3,0,0,2,3,0,0,65,0,0,0,12,1,0,0,13,1,0,0,40,0,0,0,22,0,0,0,14,1,0,0,107,0,0,0,108,0,0,0,109,0,0,0,19,0,0,0,9,0,0,0,1,0,0,0,10,0,0,0,110],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+81920);allocate([15,1,0,0,111,0,0,0,16,1,0,0,112,0,0,0,17,1,0,0,113,0,0,0,18,1,0,0,114,0,0,0,19,1,0,0,115,0,0,0,20,1,0,0,116,0,0,0,21,1,0,0,13,0,0,0,13,0,0,0,22,1,0,0,23,1,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,24,1,0,0,122,0,0,0,25,1,0,0,26,1,0,0,27,1,0,0,28,1,0,0,0,0,0,0,64,76,0,0,21,0,0,0,3,3,0,0,4,3,0,0,0,0,0,0,80,76,0,0,5,3,0,0,6,3,0,0,7,3,0,0,29,1,0,0,30,1,0,0,40,0,0,0,22,0,0,0,199,0,0,0,61,0,0,0,62,0,0,0,123,0,0,0,20,0,0,0,9,0,0,0,1,0,0,0,4,0,0,0,64,0,0,0,200,0,0,0,65,0,0,0,201,0,0,0,66,0,0,0,202,0,0,0,67,0,0,0,203,0,0,0,68,0,0,0,204,0,0,0,69,0,0,0,205,0,0,0,70,0,0,0,206,0,0,0,11,0,0,0,11,0,0,0,207,0,0,0,208,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,209,0,0,0,84,0,0,0,8,3,0,0,219,2,0,0,60,0,0,0,14,0,0,0,124,0,0,0,61,0,0,0,85,0,0,0,3,0,0,0,51,0,0,0,1,0,0,0,4,0,0,0,2,0,0,0,31,0,0,0,62,0,0,0,1,0,0,0,1,0,0,0,11,0,0,0,31,1,0,0,211,0,0,0,81,0,0,0,38,0,0,0,82,0,0,0,32,1,0,0,63,0,0,0,64,0,0,0,65,0,0,0,0,0,0,0,112,76,0,0,21,0,0,0,9,3,0,0,10,3,0,0,0,0,0,0,176,76,0,0,11,3,0,0,12,3,0,0,13,3,0,0,33,1,0,0,34,1,0,0,40,0,0,0,22,0,0,0,35,1,0,0,125,0,0,0,126,0,0,0,127,0,0,0,21,0,0,0,9,0,0,0,1,0,0,0,12,0,0,0,128,0,0,0,36,1,0,0,14,0,0,0,14,0,0,0,15,0,0,0,15,0,0,0,16,0,0,0,16,0,0,0,17,0,0,0,17,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,19,0,0,0,37,1,0,0,38,1,0,0,39,1,0,0,40,1,0,0,129,0,0,0,41,1,0,0,42,1,0,0,1,0,0,0,43,1,0,0,13,0,0,0,0,0,0,0,128,76,0,0,21,0,0,0,14,3,0,0,15,3,0,0,0,0,0,0,144,76,0,0,16,3,0,0,17,3,0,0,65,0,0,0,20,0,0,0,21,0,0,0,28,0,0,0,22,0,0,0,23,0,0,0,130,0,0,0,89,0,0,0,0,0,0,0,192,76,0,0,19,0,0,0,18,3,0,0,44,1,0,0,0,0,0,0,208,76,0,0,19,3,0,0,20,3,0,0,21,3,0,0,45,1,0,0,46,1,0,0,40,0,0,0,22,0,0,0,199,0,0,0,61,0,0,0,62,0,0,0,123,0,0,0,22,0,0,0,9,0,0,0,1,0,0,0,4,0,0,0,64,0,0,0,200,0,0,0,65,0,0,0,201,0,0,0,66,0,0,0,202,0,0,0,67,0,0,0,203,0,0,0,68,0,0,0,204,0,0,0,69,0,0,0,205,0,0,0,70,0,0,0,206,0,0,0,11,0,0,0,11,0,0,0,207,0,0,0,208,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,209,0,0,0,86,0,0,0,22,3,0,0,219,2,0,0,60,0,0,0,14,0,0,0,75,0,0,0,61,0,0,0,85,0,0,0,3,0,0,0,51,0,0,0,1,0,0,0,4,0,0,0,2,0,0,0,31,0,0,0,62,0,0,0,1,0,0,0,1,0,0,0,11,0,0,0,47,1,0,0,211,0,0,0,81,0,0,0,38,0,0,0,82,0,0,0,48,1,0,0,63,0,0,0,64,0,0,0,65,0,0,0,0,0,0,0,224,76,0,0,21,0,0,0,23,3,0,0,24,3,0,0,0,0,0,0,240,76,0,0,21,0,0,0,25,3,0,0,26,3,0,0,0,0,0,0,0,77,0,0,27,3,0,0,28,3,0,0,43,0,0,0,90,0,0,0,1,0,0,0,49,1,0,0,23,0,0,0,29,3,0,0,0,0,0,0,16,78,0,0,30,3,0,0,31,3,0,0,32,3,0,0,91,0,0,0,1,0,0,0,50,1,0,0,51,1,0,0,131,0,0,0,132,0,0,0,133,0,0,0,134,0,0,0,52,1,0,0,44,0,0,0,0,0,0,0,32,77,0,0,33,3,0,0,34,3,0,0,35,3,0,0,92,0,0,0,2,0,0,0,53,1,0,0,54,1,0,0,135,0,0,0,136,0,0,0,137,0,0,0,138,0,0,0,55,1,0,0,45,0,0,0,0,0,0,0,72,77,0,0,36,3,0,0,37,3,0,0,139,0,0,0,2,0,0,0,20,0,0,0,38,3,0,0,46,0,0,0,47,0,0,0,0,0,0,0,48,77,0,0,36,3,0,0,39,3,0,0,140,0,0,0,1,0,0,0,21,0,0,0,1,0,0,0,46,0,0,0,47,0,0,0,0,0,0,0,88,77,0,0,36,3,0,0,40,3,0,0,140,0,0,0,3,0,0,0,21,0,0,0,41,3,0,0,46,0,0,0,47,0,0,0,0,0,0,0,112,77,0,0,42,3,0,0,43,3,0,0,44,3,0,0,93,0,0,0,2,0,0,0,56,1,0,0,57,1,0,0,141,0,0,0,142,0,0,0,143,0,0,0,144,0,0,0,58,1,0,0,48,0,0,0,0,0,0,0,128,77,0,0,45,3,0,0,46,3,0,0,47,3,0,0,93,0,0,0,2,0,0,0,59,1,0,0,60,1,0,0,145,0,0,0,146,0,0,0,147,0,0,0,148,0,0,0,61,1,0,0,49,0,0,0,0,0,0,0,8,77,0,0,57,0,0,0,48,3,0,0,26,0,0,0,0,0,0,0,144,77,0,0,49,3,0,0,50,3,0,0,149,0,0,0,4,0,0,0,22,0,0,0,1,0,0,0,4,0,0,0,8,0,0,0,16,0,0,0,32,0,0,0,0,0,0,0,160,77,0,0,51,3,0,0,52,3,0,0,53,3,0,0,93,0,0,0,2,0,0,0,62,1,0,0,63,1,0,0,150,0,0,0,151,0,0,0,152,0,0,0,153,0,0,0,64,1,0,0,50,0,0,0,1,0,0,0,5,0,0,0,10,0,0,0,15,0,0,0,16,0,0,0,32,0,0,0,64,0,0,0,128,0,0,0,0,1,0,0,0,0,0,0,176,77,0,0,54,3,0,0,55,3,0,0,56,3,0,0,93,0,0,0,2,0,0,0,65,1,0,0,66,1,0,0,154,0,0,0,155,0,0,0,156,0,0,0,157,0,0,0,67,1,0,0,51,0,0,0,0,0,0,0,192,77,0,0,19,0,0,0,57,3,0,0,68,1,0,0,0,0,0,0,208,77,0,0,58,3,0,0,59,3,0,0,60,3,0,0,93,0,0,0,2,0,0,0,69,1,0,0,70,1,0,0,158,0,0,0,159,0,0,0,160,0,0,0,161,0,0,0,71,1,0,0,52,0,0,0,0,0,0,0,224,77,0,0,61,3,0,0,62,3,0,0,63,3,0,0,94,0,0,0,2,0,0,0,72,1,0,0,73,1,0,0,162,0,0,0,163,0,0,0,164,0,0,0,165,0,0,0,74,1,0,0,53,0,0,0,0,0,0,0,240,77,0,0,49,3,0,0,64,3,0,0,166,0,0,0,5,0,0,0,23,0,0,0,0,0,0,0,0,78,0,0,65,3,0,0,66,3,0,0,67,3,0,0,93,0,0,0,2,0,0,0,75,1,0,0,76,1,0,0,167,0,0,0,168,0,0,0,169,0,0,0,170,0,0,0,77,1,0,0,54,0,0,0,0,0,0,0,184,78,0,0,68,3,0,0,69,3,0,0,70,3,0,0,95,0,0,0,3,0,0,0,78,1,0,0,79,1,0,0,171,0,0,0,172,0,0,0,173,0,0,0,174,0,0,0,80,1,0,0,55,0,0,0,0,0,0,0,32,78,0,0,71,3,0,0,72,3,0,0,73,3,0,0,96,0,0,0,4,0,0,0,81,1,0,0,82,1,0,0,175,0,0,0,176,0,0,0,177,0,0,0,178,0,0,0,83,1,0,0,56,0,0,0,0,0,0,0,56,78,0,0,74,3,0,0,75,3,0,0,76,3,0,0,97,0,0,0,4,0,0,0,84,1,0,0,85,1,0,0,179,0,0,0,180,0,0,0,181,0,0,0,182,0,0,0,86,1,0,0,57,0,0,0,0,0,0,0,72,78,0,0,77,3,0,0,78,3,0,0,79,3,0,0,97,0,0,0,4,0,0,0,87,1,0,0,88,1,0,0,183,0,0,0,184,0,0,0,185,0,0,0,186,0,0,0,89,1,0,0,58,0,0,0,0,0,0,0,88,78,0,0,80,3,0,0,81,3,0,0,82,3,0,0,97,0,0,0,4,0,0,0,90,1,0,0,91,1,0,0,187,0,0,0,188,0,0,0,189,0,0,0,190,0,0,0,92,1,0,0,59,0,0,0,0,0,0,0,104,78,0,0,83,3,0,0,84,3,0,0,85,3,0,0,97,0,0,0,4,0,0,0,93,1,0,0,94,1,0,0,191,0,0,0,192,0,0,0,193,0,0,0,194,0,0,0,95,1,0,0,60,0,0,0,0,0,0,0,120,78,0,0,19,0,0,0,86,3,0,0,96,1,0,0,0,0,0,0,136,78,0,0,87,3,0,0,88,3,0,0,89,3,0,0,97,0,0,0,4,0,0,0,97,1,0,0,98,1,0,0,195,0,0,0,196,0,0,0,197,0,0,0,198,0,0,0,99,1,0,0,61,0,0,0,0,0,0,0,152,78,0,0,90,3,0,0,91,3,0,0,92,3,0,0,98,0,0,0,4,0,0,0,100,1,0,0,101,1,0,0,199,0,0,0,200,0,0,0,201,0,0,0,202,0,0,0,102,1,0,0,62,0,0,0,0,0,0,0,168,78,0,0,93,3,0,0,94,3,0,0,95,3,0,0,97,0,0,0,4,0,0,0,103,1,0,0,104,1,0,0,203,0,0,0,204,0,0,0,205,0,0,0,206,0,0,0,105,1,0,0,63,0,0,0,0,0,0,0,56,79,0,0,96,3,0,0,97,3,0,0,98,3,0,0,99,0,0,0,5,0,0,0,106,1,0,0,107,1,0,0,207,0,0,0,208,0,0,0,209,0,0,0,210,0,0,0,108,1,0,0,64,0,0,0,0,0,0,0,200,78,0,0,99,3,0,0,100,3,0,0,101,3,0,0,100,0,0,0,6,0,0,0,109,1,0,0,110,1,0,0,211,0,0,0,212,0,0,0,213,0,0,0,214,0,0,0,111,1,0,0,65,0,0,0,0,0,0,0,240,78,0,0,102,3,0,0,103,3,0,0,215,0,0,0,87,0,0,0,216,0,0,0,104,3,0,0,66,0,0,0,67,0,0,0,0,0,0,0,216,78,0,0,102,3,0,0,105,3,0,0,217,0,0,0,1,0,0,0,218,0,0,0,1,0,0,0,66,0,0,0,67,0,0,0,0,0,0,0,0,79,0,0,102,3,0,0,106,3,0,0,217,0,0,0,88,0,0,0,218,0,0,0,107,3,0,0,66,0,0,0,67,0,0,0,0,0,0,0,24,79,0,0,108,3,0,0,109,3,0,0,110,3,0,0,101,0,0,0,6,0,0,0,112,1,0,0,113,1,0,0,219,0,0,0,220,0,0,0,221,0,0,0,222,0,0,0,114,1,0,0,68,0,0,0,0,0,0,0,40,79,0,0,111,3,0,0,112,3,0,0,113,3,0,0,101,0,0,0,6,0,0,0,115,1,0,0,116,1,0,0,223,0,0,0,224,0,0,0,225,0,0,0,226,0,0,0,117,1,0,0,69,0,0,0,0,0,0,0,72,79,0,0,118,1,0,0,89,0,0,0,90,0,0,0,91,0,0,0,67,0,0,0,68,0,0,0,227,0,0,0,228,0,0,0,92,0,0,0,114,3,0,0,115,3,0,0,0,0,0,0,144,79,0,0,119,1,0,0,93,0,0,0,94,0,0,0,95,0,0,0,69,0,0,0,70,0,0,0,229,0,0,0,230,0,0,0,96,0,0,0,114,3,0,0,116,3,0,0,0,0,0,0,216,79,0,0,120,1,0,0,97,0,0,0,98,0,0,0,99,0,0,0,71,0,0,0,72,0,0,0,231,0,0,0,232,0,0,0,100,0,0,0,114,3,0,0,117,3,0,0,0,0,0,0,248,79,0,0,118,3,0,0,119,3,0,0,24,0,0,0,121,1,0,0,233,0,0,0,25,0,0,0,26,0,0,0,122,1,0,0,120,3,0,0,1,0,0,0,73,0,0,0,101,0,0,0,121,3,0,0,0,0,0,0,0,80,0,0,21,0,0,0,122,3,0,0,123,3,0,0,0,0,0,0,16,80,0,0,124,3,0,0,125,3,0,0,27,0,0,0,123,1,0,0,234,0,0,0,25,0,0,0,28,0,0,0,122,1,0,0,120,3,0,0,2,0,0,0,73,0,0,0,102,0,0,0,126,3,0,0,0,0,0,0,32,80,0,0,21,0,0,0,127,3,0,0,128,3,0,0,0,0,0,0,64,80,0,0,21,0,0,0,129,3,0,0,130,3,0,0,0,0,0,0,48,80,0,0,21,0,0,0,131,3,0,0,132,3,0,0,0,0,0,0,80,80,0,0,133,3,0,0,134,3,0,0,29,0,0,0,124,1,0,0,235,0,0,0,25,0,0,0,30,0,0,0,122,1,0,0,120,3,0,0,1,0,0,0,74,0,0,0,103,0,0,0,135,3,0,0,0,0,0,0,96,80,0,0,21,0,0,0,136,3,0,0,137,3,0,0,0,0,0,0,128,80,0,0,21,0,0,0,138,3,0,0,139,3,0,0,0,0,0,0,112,80,0,0,21,0,0,0,140,3,0,0,141,3,0,0,0,0,0,0,144,80,0,0,142,3,0,0,143,3,0,0,65,0,0,0,20,0,0,0,125,1,0,0,236,0,0,0,22,0,0,0,23,0,0,0,75,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,237,0,0,0,126,1,0,0,238,0,0,0,239,0,0,0,127,1,0,0,128,1,0,0,0,0,0,0,160,80,0,0,144,3,0,0,145,3,0,0,129,1,0,0,0,0,0,0,176,80,0,0,21,0,0,0,146,3,0,0,147,3,0,0,0,0,0,0,208,80,0,0,21,0,0,0,148,3,0,0,149,3,0,0,0,0,0,0,224,80,0,0,19,0,0,0,150,3,0,0,130,1,0,0,0,0,0,0,240,80,0,0,151,3,0,0,152,3,0,0,131,1,0,0,0,0,0,0,0,81,0,0,153,3,0,0,154,3,0,0,52,0,0,0,132,1,0,0,0,0,0,0,8,81,0,0,155,3,0,0,156,3,0,0,133,1,0,0,76,0,0,0,104,0,0,0,31,0,0,0,105,0,0,0,134,1,0,0,102,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,103,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,16,81,0,0,157,3,0,0,158,3,0,0,135,1,0,0,0,0,0,0,32,81,0,0,159,3,0,0,160,3,0,0,136,1,0,0,60,133,91,61,105,191,22,190,2,153,98,189,108,247,79,61,246,123,236,61,167,217,46,189,62,226,61,61,57,250,95,189,212,151,168,61,35,124,213,61,136,247,187,188,168,158,53,60,147,226,97,60,59,62,229,61,79,209,79,60,24,169,174,61,149,54,129,189,240,173,5,62,38,231,165,61,19,100,85,189,154,195,48,189,193,79,191,61,81,255,225,61,15,146,155,189,76,255,97,189,6,230,54,189,19,114,241,60,66,152,58,61,65,71,105,187,217,33,160,61,168,84,158,61,18,154,161,61,195,227,126,61,40,89,184,61,26,104,18,189,208,217,11,61,93,138,104,61,160,134,67,189,86,118,25,61,50,58,16,189,138,114,142,61,23,168,29,189,94,104,44,60,232,56,142,60,25,146,222,61,48,45,179,61,33,25,88,59,61,96,223,61,226,18,162,61,158,217,212,61,161,93,171,60,17,114,237,61,236,252,6,62,68,84,202,61,23,168,91,61,71,37,138,189,4,202,229,187,53,239,171,59,152,142,4,61,71,172,102,60,194,224,180,60,128,219,207,60,177,72,58,61,179,120,147,61,81,51,0,61,72,128,128,189,73,155,172,60,190,51,119,61,192,222,176,61,41,126,148,59,40,174,179,60,10,56,189,60,116,18,100,61,159,175,216,188,243,55,54,61,22,115,232,60,125,210,183,61,99,190,54,61,182,208,183,61,13,229,153,61,235,252,188,60,210,50,213,61,174,108,130,61,189,113,115,61,27,55,150,59,51,211,85,61,176,184,136,61,249,46,171,61,189,118,137,61,18,84,134,61,23,254,32,189,43,17,22,188,31,148,113,189,77,185,230,60,254,31,78,61,63,222,138,61,58,89,10,61,73,193,31,186,241,14,147,188,138,157,252,188,195,101,85,188,236,125,243,188,194,56,1,60,97,108,16,189,197,25,36,187,177,214,86,61,86,124,241,61,186,143,177,188,134,15,89,61,120,255,135,61,224,151,84,61,44,140,7,188,73,121,248,60,160,75,111,61,138,106,131,187,176,213,204,187,146,37,112,61,119,248,201,188,55,50,99,61,112,131,168,189,36,39,148,189,151,19,62,61,38,88,86,188,162,78,205,188,91,3,254,60,230,26,63,189,56,17,60,189,116,168,241,60,104,54,119,61,163,225,183,60,11,39,139,188,123,102,42,60,181,84,57,60,104,252,93,61,38,131,174,188,138,4,49,189,99,32,22,189,106,144,56,60,4,134,213,188,109,139,182,188,10,201,184,188,45,97,12,189,146,1,254,187,175,193,125,189,2,158,6,60,249,75,195,61,243,245,23,189,179,46,142,189,24,75,21,62,111,40,95,189,111,107,168,188,104,105,107,61,83,226,227,60,227,242,144,189,143,26,84,189,14,150,213,189,104,26,230,189,217,49,154,61,131,208,154,189,209,243,179,189,185,111,244,60,80,135,218,60,161,117,98,60,57,64,147,188,220,169,0,189,94,224,171,188,8,235,184,61,33,245,74,61,218,122,12,62,186,15,233,61,101,244,235,58,184,127,59,189,210,161,145,186,226,244,193,189,219,124,237,189,42,226,55,61,158,41,146,60,0,25,73,59,8,208,220,61,17,135,92,59,89,14,222,189,116,78,152,189,28,194,215,189,189,237,152,188,204,110,36,62,200,60,166,187,61,243,47,189,202,125,193,187,233,129,16,60,28,142,116,188,208,255,77,189,89,217,3,190,106,97,102,58,215,135,84,188,1,128,155,189,113,161,218,188,73,223,53,186,30,40,197,60,193,68,145,188,107,238,29,189,202,193,112,189,97,132,5,61,31,88,3,62,75,223,128,61,220,150,134,187,126,53,225,61,178,101,90,60,243,27,171,60,76,96,37,61,199,110,85,189,253,236,158,61,2,15,131,61,92,153,107,189,249,226,205,189,239,179,153,61,123,74,175,188,138,36,147,60,241,157,25,59,108,95,44,189,172,161,150,61,165,159,80,61,8,127,245,188,80,201,181,188,47,111,9,61,222,253,52,61,239,149,100,189,200,86,78,189,29,75,58,189,3,5,98,60,215,46,176,60,241,191,179,188,98,28,12,190,99,216,95,61,236,187,131,60,30,118,89,61,202,141,64,61,14,59,175,58,76,38,155,61,83,32,197,61,91,64,18,60,75,241,230,188,124,141,222,61,240,223,12,189,115,64,145,189,175,244,117,189,3,49,222,188,170,210,231,187,204,26,134,188,9,5,91,60,0,57,211,189,62,249,72,61,11,205,106,189,225,186,223,188,129,194,42,60,31,209,170,189,196,255,22,61,150,50,122,61,19,184,88,60,108,240,159,189,218,156,26,61,128,206,11,189,179,182,121,189,82,135,44,189,151,121,163,189,154,29,165,186,201,124,249,188,70,150,74,188,33,71,129,189,72,46,68,61,41,128,60,189,237,165,175,61,225,134,206,60,245,200,244,60,31,62,211,61,235,150,144,61,87,41,57,61,213,80,53,189,215,158,6,62,92,193,171,61,190,82,177,60,183,30,11,187,54,254,22,189,187,250,169,188,8,224,28,189,217,197,122,188,68,87,220,60,92,11,243,61,96,138,119,189,42,38,228,188,72,150,67,189,89,213,71,61,77,17,130,61,130,37,15,61,56,107,112,60,98,133,154,58,149,99,51,61,37,124,5,59,6,37,34,189,204,191,47,188,243,237,210,59,41,121,245,60,165,5,12,189,158,150,160,188,6,191,71,188,65,50,143,187,232,217,208,188,80,201,216,60,71,188,133,188,198,217,211,59,117,21,158,188,68,221,156,59,59,66,75,61,108,5,28,61,82,205,148,61,81,218,107,61,10,65,25,189,209,13,135,60,217,125,10,188,194,181,35,61,121,163,167,189,56,45,216,60,30,238,36,189,252,215,224,188,243,196,38,189,122,192,137,58,108,51,66,189,54,229,137,189,176,156,14,60,246,156,179,188,44,104,177,58,100,109,250,188,51,193,243,188,35,145,236,188,252,92,70,188,196,198,69,189,68,173,185,189,146,45,204,189,8,32,22,189,47,208,104,186,104,207,139,189,1,224,152,188,144,150,20,189,225,187,102,188,164,137,153,60,106,13,170,188,14,75,187,61,11,76,17,189,87,13,93,61,130,253,43,61,177,78,85,60,134,159,10,189,127,229,249,189,178,229,139,61,117,49,24,189,46,155,28,60,251,179,165,59,0,206,103,61,179,11,128,59,78,18,230,60,113,5,98,189,43,7,24,189,28,74,232,188,237,15,53,189,255,18,41,188,37,75,154,60,174,47,11,188,255,231,192,189,243,249,79,188,8,196,174,188,56,181,208,189,104,167,160,189,188,172,31,59,151,56,134,187,165,6,69,60,150,36,132,189,30,246,216,189,120,233,201,188,8,51,180,188,110,151,151,189,7,55,149,61,11,168,104,58,251,116,35,60,132,188,10,60,96,203,24,61,232,252,237,188,39,93,18,61,43,247,51,189,111,14,246,189,149,28,2,61,197,227,52,187,231,175,221,61,50,132,80,61,228,98,88,187,43,223,81,189,107,104,165,59,165,0,104,189,167,106,196,187,228,205,90,189,239,28,72,188,205,145,83,60,117,125,34,60,184,12,248,187,157,171,125,189,24,41,19,187,50,210,162,60,37,98,165,188,235,219,142,189,254,50,135,189,252,45,9,189,174,122,182,189,15,24,10,189,115,177,151,189,246,40,184,188,197,79,124,189,250,6,54,59,138,109,106,189,171,76,68,189,216,250,153,61,188,183,53,59,95,133,44,61,61,254,253,60,138,52,88,61,209,251,33,61,34,82,246,188,111,196,29,189,239,192,228,188,27,140,235,188,138,226,122,60,187,39,179,60,189,1,163,188,9,73,36,59,72,25,210,189,39,6,68,189,79,133,236,188,238,90,124,59,143,58,54,60,246,219,7,60,159,140,69,189,163,119,56,189,173,22,24,189,74,29,143,189,182,83,225,189,208,109,48,187,112,252,242,58,179,134,114,189,31,16,122,189,139,56,173,189,89,115,57,189,253,100,105,58,21,164,112,189,22,8,48,187,199,89,130,188,205,194,20,61,5,0,97,61,193,130,149,61,246,80,181,59,145,20,131,61,235,93,151,60,233,213,188,187,124,132,3,189,14,81,139,59,101,31,63,60,93,224,189,186,112,160,184,60,101,234,9,189,14,4,143,61,17,99,138,187,47,184,17,188,66,174,162,189,26,251,84,61,62,110,120,61,206,78,41,61,103,201,188,58,61,78,196,189,56,101,34,189,239,88,45,61,233,101,143,60,16,211,55,189,19,243,248,187,80,193,164,60,123,110,63,61,128,140,184,61,53,41,161,189,98,203,63,189,30,21,80,189,188,222,130,187,88,252,90,189,134,226,49,60,190,109,19,189,123,93,145,189,177,120,17,61,202,147,219,60,159,49,14,61,67,171,146,60,117,26,96,61,59,159,29,60,249,66,2,189,4,53,112,61,133,236,190,60,131,201,133,60,43,15,102,189,142,211,209,189,97,7,170,189,135,83,149,61,54,152,161,188,176,153,214,188,22,153,203,188,210,139,61,189,234,26,195,58,108,220,97,61,187,55,80,188,101,167,159,188,242,135,130,61,213,228,76,61,10,144,246,188,45,143,15,60,136,176,202,188,247,122,97,189,76,28,228,58,8,140,8,189,151,218,121,60,180,223,238,61,156,119,173,186,83,87,135,189,66,242,104,61,66,193,52,186,2,82,52,189,81,138,193,61,13,246,44,189,251,149,91,189,120,199,145,60,51,212,209,60,12,211,226,189,57,209,15,188,138,36,52,188,125,150,212,189,54,60,254,60,151,128,172,188,7,249,150,189,42,207,82,61,46,181,216,61,249,126,176,189,225,235,236,188,37,242,50,60,255,1,21,62,205,2,19,187,127,78,110,189,198,92,151,189,14,134,105,61,159,121,4,62,211,64,76,189,46,137,208,61,56,249,77,61,246,40,0,62,164,231,187,61,143,44,131,61,199,151,121,60,151,192,193,61,171,32,122,61,20,24,18,190,105,193,239,188,237,70,226,60,137,73,177,60,15,67,123,186,12,81,45,189,236,16,202,189,3,10,49,61,189,132,112,61,253,50,70,189,22,107,129,61,41,50,200,60,214,188,19,189,126,205,25,60,209,183,47,61,190,84,40,188,146,13,167,61,92,57,179,61,88,20,7,190,209,179,5,60,12,236,109,188,32,226,241,60,238,27,20,61,2,14,9,187,145,12,184,60,189,21,197,61,162,194,192,61,159,152,239,188,21,14,160,189,234,121,180,188,26,193,4,187,110,92,51,60,202,79,108,188,240,136,232,60,216,89,243,61,9,208,238,59,167,226,211,189,142,218,154,61,130,232,167,188,78,140,145,59,116,214,131,60,123,108,72,189,107,94,179,189,234,119,251,187,98,128,181,61,111,199,121,61,40,120,134,61,250,46,240,59,154,192,17,61,134,177,30,189,61,252,203,188,239,171,138,189,39,142,203,61,131,170,46,188,4,151,98,60,198,71,149,189,93,214,244,59,227,134,217,61,219,209,235,188,36,66,195,60,39,33,6,189,78,16,175,60,231,44,29,61,7,201,200,60,103,255,47,189,141,43,237,188,134,53,90,61,117,153,117,60,129,191,76,61,234,125,4,62,115,88,192,61,249,208,47,61,180,151,9,189,89,117,139,189,79,115,56,60,228,13,49,62,216,133,12,189,112,27,128,189,194,135,148,188,129,42,240,61,136,252,122,189,60,185,177,189,209,124,12,189,35,229,63,61,88,37,167,61,188,242,16,61,86,59,150,60,33,223,231,61,236,154,5,61,106,175,69,189,163,142,143,60,136,41,147,188,96,80,214,189,215,75,88,187,13,124,112,57,66,195,110,60,224,187,174,188,64,59,213,188,132,196,33,188,204,14,47,61,188,77,172,188,236,183,163,189,165,55,214,60,217,252,172,188,52,164,142,189,132,195,9,190,1,136,140,189,64,171,199,187,87,253,168,61,59,223,31,62,27,145,33,59,59,143,17,60,90,27,42,189,100,85,168,60,89,47,88,61,156,243,252,188,234,208,230,60,116,188,14,62,22,125,156,61,109,150,20,189,48,255,246,188,158,138,37,189,122,239,94,188,250,16,127,189,179,80,224,188,228,8,11,62,166,3,28,62,227,228,92,189,48,226,228,189,70,182,176,60,230,214,59,60,222,166,87,189,181,17,135,189,97,54,225,188,59,234,241,61,239,55,50,62,122,95,123,189,234,89,225,189,24,115,93,188,131,6,143,188,126,170,175,189,101,22,55,189,66,27,122,189,139,67,216,61,208,15,85,62,39,231,187,189,236,5,58,58,117,156,18,61,251,195,147,61,79,1,182,60,135,186,149,60,238,143,1,188,108,12,116,60,52,175,20,62,220,153,131,189,54,249,244,60,210,42,236,186,88,160,101,188,131,217,42,189,163,212,114,187,77,44,186,189,245,251,194,61,251,39,181,61,75,59,217,188,106,33,247,188,110,234,209,60,82,249,17,61,98,97,28,189,134,216,106,60,93,228,184,60,185,72,235,60,40,40,36,60,72,175,129,189,124,179,49,61,162,101,143,61,18,191,64,189,39,228,149,189,174,124,215,60,141,121,254,60,118,40,136,61,126,128,223,61,171,152,133,188,149,105,238,60,214,42,237,60,22,170,164,61,66,187,142,61,180,55,139,61,108,112,199,59,1,130,136,59,193,209,182,61,166,227,255,188,42,50,221,60,66,124,63,60,2,169,133,188,207,16,151,59,155,124,11,60,226,43,17,189,18,79,18,61,100,211,140,59,130,99,161,188,52,37,16,188,135,197,196,61,93,1,125,60,13,183,32,189,10,174,149,61,240,68,120,61,106,20,10,57,220,199,2,188,38,140,196,60,113,55,121,189,224,189,224,188,5,71,96,189,240,55,41,189,191,206,17,61,42,75,250,60,47,61,244,60,243,43,24,62,53,188,144,60,132,70,241,60,192,161,72,61,59,64,40,60,190,84,230,60,94,79,169,61,108,209,223,60,155,200,74,188,22,217,240,61,133,187,27,61,73,145,7,189,163,4,172,59,162,144,201,188,210,123,220,60,250,46,93,61,194,136,207,189,20,198,130,61,84,238,148,188,54,25,185,60,9,91,18,61,55,220,42,60,148,31,42,189,59,154,37,189,68,164,134,60,197,135,170,61,200,229,241,57,105,107,89,189,101,210,174,189,139,10,211,186,127,64,177,188,154,23,146,188,58,23,30,61,162,14,174,61,103,84,141,188,135,164,176,61,236,45,225,61,73,245,187,61,208,11,174,61,161,153,156,61,206,147,100,61,32,167,220,60,157,188,204,61,163,194,185,61,84,139,136,61,244,142,112,61,170,36,184,188,89,45,159,61,241,31,254,61,212,82,1,62,134,185,92,186,182,30,114,60,48,184,187,61,128,143,67,187,206,110,132,189,150,136,144,189,199,177,91,57,113,15,181,60,130,217,176,188,232,45,176,189,124,44,187,188,213,175,131,59,62,189,28,60,121,230,169,188,242,218,61,189,11,217,248,187,13,172,97,188,88,192,58,189,38,9,8,190,36,151,177,189,28,175,21,189,102,63,59,60,9,172,6,61,196,239,51,189,152,157,123,61,9,92,53,62,168,176,212,61,12,196,89,60,100,47,206,61,52,254,254,61,178,93,55,189,147,83,185,61,109,250,59,61,255,183,228,61,110,223,175,61,187,71,67,61,8,35,219,58,163,80,193,60,181,2,28,189,86,13,0,61,244,52,157,188,125,109,105,189,254,191,193,188,129,130,133,189,134,89,101,189,86,90,145,189,2,62,7,189,95,75,65,189,38,59,210,188,176,239,88,60,78,11,189,189,219,6,98,189,246,9,65,189,86,123,10,189,108,157,137,189,179,248,65,60,248,2,191,189,96,149,134,60,163,59,27,61,85,200,216,187,132,171,159,61,235,104,148,61,160,197,64,61,79,184,206,188,27,1,139,188,25,64,165,189,114,6,119,61,29,152,215,61,165,104,135,189,121,231,243,60,195,199,214,60,115,200,156,60,76,168,173,189,174,123,129,189,142,246,10,190,37,143,156,189,187,174,24,60,229,201,165,189,98,218,208,189,40,40,85,189,217,135,103,60,158,192,159,189,224,109,154,188,201,202,153,189,138,151,207,189,129,127,85,189,138,167,203,189,240,30,175,186,148,229,129,189,70,39,43,189,242,105,253,189,200,14,232,188,128,29,120,189,183,204,110,61,87,188,155,61,145,90,132,189,22,121,3,60,53,41,237,61,79,144,252,61,91,19,162,60,121,129,50,187,149,165,111,61,124,119,63,189,88,221,82,61,97,15,44,187,253,119,230,61,145,159,202,61,18,102,200,61,218,215,62,189,57,159,52,188,67,104,143,189,51,11,253,60,118,43,210,188,125,28,157,189,62,10,80,59,171,216,220,189,194,149,189,188,53,29,227,189,227,229,39,188,178,67,255,60,247,91,75,189,87,237,186,60,210,57,180,59,61,154,172,189,37,97,22,190,192,25,158,189,1,161,8,190,108,93,57,189,3,11,203,189,79,20,212,60,7,26,14,61,203,9,63,61,199,95,239,61,129,147,197,61,57,94,222,61,249,91,109,188,59,30,48,61,100,130,138,189,212,169,174,58,94,193,18,62,91,31,155,61,80,185,187,61,233,113,104,61,132,242,231,61,185,73,53,188,167,238,168,60,163,53,235,189,96,112,153,189,148,164,234,188,35,0,81,188,54,65,142,189,192,225,206,189,39,125,40,189,94,111,181,188,0,185,80,188,206,50,153,189,14,48,216,189,210,25,156,189,242,143,204,189,190,147,234,189,6,70,247,189,40,198,192,189,180,92,146,189,231,18,38,189,31,247,122,189,172,229,44,61,219,115,157,61,209,231,39,61,56,173,1,62,181,92,22,62,47,215,94,62,101,66,0,62,214,189,60,62,95,27,218,186,103,212,27,59,158,211,108,60,229,190,15,61,8,121,217,60,160,162,140,60,151,30,92,61,206,47,241,60,254,233,231,61,138,96,115,188,10,0,132,188,166,53,243,186,223,246,139,188,0,166,94,189,143,44,89,189,16,119,87,61,231,193,18,189,243,194,179,185,194,91,178,58,153,179,53,189,83,50,45,189,212,102,6,61,187,126,96,189,178,217,208,189,168,149,147,189,21,250,219,189,117,230,193,188,208,128,210,61,2,21,52,187,214,207,4,189,76,38,189,60,124,80,232,60,131,241,211,61,188,128,72,62,38,246,209,61,98,168,164,61,162,83,98,61,89,176,7,190,141,104,19,190,38,131,77,59,3,188,10,189,40,149,18,60,170,111,93,61,155,246,162,187,14,211,66,188,205,84,148,57,202,206,31,189,165,166,72,189,70,81,177,60,72,147,98,188,9,150,151,188,12,35,153,60,123,181,200,188,249,187,187,60,18,221,167,61,252,138,7,61,174,179,217,189,242,169,202,60,8,232,90,61,203,0,197,188,16,220,4,189,75,241,181,187,115,11,164,189,63,82,230,60,249,126,45,61,36,74,152,60,124,202,72,61,169,164,107,188,219,40,122,188,224,117,167,60,155,39,77,189,192,214,45,61,214,227,155,61,113,197,74,61,8,154,118,189,167,153,139,187,183,124,6,62,12,185,107,188,41,119,160,188,2,166,37,189,5,119,254,189,146,90,58,59,87,141,78,189,217,206,186,189,99,161,240,59,153,72,192,61,161,171,241,61,252,194,154,59,39,157,145,59,246,135,163,189,199,4,20,189,168,242,55,61,42,8,184,188,150,188,63,61,132,170,86,61,228,183,176,60,121,142,60,189,201,68,68,188,19,46,225,188,195,122,11,62,18,121,180,61,52,201,159,189,26,103,159,59,5,250,130,188,140,216,39,60,156,221,13,189,101,195,188,188,153,6,178,189,10,76,136,61,139,252,108,61,254,112,1,190,50,7,189,60,30,69,150,61,243,30,154,61,29,127,74,61,228,149,183,188,180,90,204,189,104,91,20,62,116,144,134,189,89,225,160,189,15,218,231,60,23,213,10,186,102,71,63,189,112,33,242,189,174,206,250,189,40,88,29,190,27,59,243,188,10,113,165,61,119,94,10,62,237,162,235,61,143,45,66,61,140,114,97,60,236,188,111,189,98,244,123,188,216,246,98,189,107,17,204,60,191,44,235,188,232,45,226,60,27,21,116,62,114,214,100,62,145,19,211,61,219,179,141,189,17,129,207,189,190,212,78,190,26,118,78,189,48,19,139,62,156,95,189,62,225,216,176,62,108,248,148,62,118,105,103,61,125,253,40,61,114,184,153,61,149,72,224,188,19,48,10,188,144,230,150,61,75,124,135,60,145,146,192,189,55,21,196,189,45,142,113,60,49,254,145,189,117,192,13,189,255,68,234,61,158,211,12,62,41,198,130,189,88,60,129,189,89,70,6,60,55,7,238,61,163,133,165,59,84,180,155,189,139,32,137,61,222,180,131,62,160,24,185,61,42,151,147,62,65,208,6,62,204,154,89,189,74,20,175,188,107,254,12,189,198,29,128,189,249,186,31,61,250,82,60,62,139,52,133,62,204,55,10,61,199,104,152,60,191,90,67,62,198,246,57,62,73,52,97,59,239,197,248,188,231,141,73,62,231,34,181,62,97,173,127,62,237,255,3,189,174,86,148,62,17,161,220,62,207,149,157,62,20,78,191,60,5,74,202,189,137,138,224,187,210,50,183,61,18,237,166,189,211,194,228,60,166,5,126,62,205,139,49,62,43,65,127,61,187,167,213,189,175,135,42,190,128,37,7,190,7,186,174,189,39,87,69,190,197,156,10,190,89,189,99,62,230,205,200,62,41,46,136,62,26,203,73,188,163,125,38,60,138,2,9,62,175,34,246,61,231,198,70,189,208,26,162,189,247,24,144,61,37,25,126,59,53,244,122,189,94,193,25,190,253,154,233,189,222,60,175,189,26,39,152,189,203,5,37,190,223,79,7,62,49,138,131,62,61,97,105,61,46,136,140,61,59,143,197,187,94,46,2,188,38,151,68,61,242,29,137,61,206,216,157,188,219,53,126,61,242,188,9,62,106,177,130,189,53,138,67,187,153,169,14,189,104,17,247,59,113,144,31,61,191,201,234,61,213,205,136,60,59,161,7,60,29,124,245,187,143,223,239,189,238,31,218,189,38,12,212,189,255,142,76,189,207,179,72,186,253,180,247,60,144,240,66,189,27,143,149,189,174,151,110,189,148,184,6,190,235,230,217,189,97,151,70,190,211,66,204,189,226,45,162,189,166,214,242,57,153,96,45,186,247,87,34,62,87,85,175,61,243,224,156,189,19,39,164,189,253,122,124,189,128,56,154,60,83,87,63,186,250,25,140,61,201,112,29,61,129,157,79,62,55,147,97,62,146,100,172,187,138,247,109,60,241,171,129,189,191,180,234,60,122,101,104,61,13,70,249,61,235,43,29,61,198,161,17,61,91,37,218,188,116,137,210,189,135,168,133,189,141,163,226,189,58,21,184,189,95,236,206,189,243,203,4,60,62,12,195,59,151,113,214,60,1,188,139,188,173,48,223,189,53,241,163,189,181,217,230,189,54,93,125,189,15,2,122,189,97,212,130,60,131,161,114,189,79,187,192,61,93,18,106,62,5,171,5,61,249,181,138,61,91,100,184,189,144,196,38,60,111,62,158,60,113,181,176,61,237,74,106,188,118,91,224,61,140,28,42,62,23,112,199,188,148,148,7,189,65,136,45,189,104,163,70,60,213,137,201,187,1,108,142,61,17,3,247,60,45,120,146,60,201,223,227,60,234,200,99,189,53,215,18,188,215,161,75,189,133,207,153,61,93,110,145,60,12,64,113,61,170,117,163,189,79,104,21,61,211,254,116,187,48,41,182,189,194,172,131,189,1,61,165,189,23,34,18,61,226,15,146,189,52,142,236,187,228,236,195,189,80,39,55,62,49,178,24,62,184,147,169,60,81,128,77,189,112,127,76,189,73,160,128,60,180,228,202,189,12,57,132,61,98,249,28,62,131,185,64,62,138,104,239,61,107,22,65,188,13,73,182,188,106,21,156,188,203,90,210,61,158,59,238,187,45,226,238,61,49,133,23,62,26,43,159,61,236,155,196,60,132,158,91,189,118,158,161,188,12,121,97,60,57,9,138,61,221,163,133,189,84,139,106,61,27,4,197,188,213,140,15,190,162,251,169,188,222,80,61,189,209,11,64,189,199,230,150,188,85,41,158,61,43,198,70,189,19,131,122,60,194,27,73,190,158,136,221,61,122,122,27,61,167,59,193,189,35,133,163,189,241,149,10,189,25,242,226,61,247,72,183,60,211,20,2,62,134,83,93,62,118,27,239,60,136,218,152,59,190,106,210,189,65,211,70,189,117,244,98,187,206,50,177,61,88,114,184,60,170,88,197,61,81,238,47,62,5,230,189,189,85,189,240,57,137,22,240,189,38,16,250,189,240,52,31,190,21,212,147,61,241,255,88,189,139,211,26,61,215,250,82,61,28,190,27,189,168,138,30,61,203,42,28,190,179,26,178,189,48,155,165,188,18,182,40,61,38,108,27,190,168,61,129,60,219,231,209,61,19,198,245,59,228,12,141,60,138,219,139,189,60,105,196,188,165,37,135,189,62,217,48,189,185,43,165,189,49,113,218,59,29,138,8,61,0,71,145,61,123,146,168,61,40,183,134,189,60,49,137,189,96,8,143,189,201,72,133,189,129,216,16,190,220,13,196,188,170,209,132,61,193,182,16,60,77,118,189,61,123,199,154,189,173,146,79,189,169,173,200,189,97,72,137,189,187,239,15,190,183,244,4,61,239,141,0,62,223,79,144,60,38,235,4,62,89,50,39,189,127,218,243,189,110,175,23,190,227,142,171,189,181,222,249,189,104,80,76,61,90,45,94,61,124,27,128,187,214,90,5,61,12,59,2,190,182,207,152,189,102,162,105,189,134,58,142,188,160,97,164,189,130,146,94,189,146,217,140,188,147,113,236,60,58,55,145,60,58,171,187,189,34,123,106,59,86,118,207,189,119,101,217,188,8,136,166,189,15,157,29,189,135,203,71,186,184,216,132,61,150,122,73,62,23,125,73,189,43,146,144,189,145,249,70,189,182,200,42,188,33,146,170,189,12,237,21,61,61,108,23,189,117,138,75,61,108,199,168,61,243,38,0,190,233,200,122,189,184,155,25,189,189,248,213,59,232,220,209,189,31,102,210,60,44,10,148,59,59,244,24,189,167,88,57,188,182,173,93,189,247,34,105,58,235,185,253,189,33,23,116,189,70,85,254,189,167,248,123,189,209,182,149,189,138,3,200,60,132,215,143,61,198,150,154,189,87,123,70,186,143,147,185,189,92,39,166,189,85,186,141,189,50,94,28,60,102,222,71,188,138,244,158,58,238,166,17,188,171,44,170,189,28,122,58,189,234,243,219,189,209,26,105,189,127,159,14,190,104,227,184,61,75,220,26,62,134,22,2,61,39,230,53,62,53,248,172,57,118,5,83,61,76,155,201,189,203,13,194,189,5,138,175,189,82,80,38,62,54,0,70,62,64,124,12,60,165,0,235,61,34,196,116,188,62,80,9,61,236,160,183,189,95,62,190,188,18,51,218,60,73,46,95,61,232,222,16,189,152,171,147,189,189,105,139,189,35,185,255,188,206,253,114,189,251,249,48,190,108,139,34,190,100,3,75,189,65,89,131,60,7,170,253,189,226,29,14,62,65,213,91,62,218,87,10,62,106,246,86,62,224,41,181,61,94,248,165,61,99,197,25,61,45,78,249,61,75,100,227,61,157,248,217,61,191,194,14,62,35,101,238,61,213,106,23,62,155,152,71,60,130,45,62,60,217,82,17,61,132,27,180,61,200,226,138,188,154,137,157,189,48,173,168,189,238,142,222,59,115,100,201,188,188,90,5,62,63,82,224,61,31,227,201,61,211,251,65,61,188,81,50,189,30,96,27,190,108,87,55,190,1,6,214,189,235,102,9,190,137,216,135,189,219,219,1,189,14,16,140,189,89,115,232,189,209,7,143,189,93,106,67,62,42,68,52,62,199,82,158,61,142,67,205,61,13,131,186,62,202,218,144,62,120,238,1,62,23,63,35,62,170,5,16,62,249,105,229,189,46,11,15,190,178,31,186,189,199,116,16,190,142,155,81,61,122,150,44,187,216,18,221,189,247,248,198,189,0,121,88,189,112,66,128,60,245,19,78,61,218,202,143,61,51,187,242,188,214,191,144,60,76,172,170,61,200,137,3,189,76,152,160,59,56,114,84,61,99,172,78,189,128,29,197,189,255,237,206,188,68,167,141,61,84,227,70,60,252,121,90,61,104,9,13,189,236,239,205,189,144,215,128,189,180,225,177,59,115,142,206,187,189,250,185,60,58,251,144,188,27,23,6,61,194,163,158,61,209,163,254,59,88,126,78,61,58,3,135,60,25,46,190,188,198,94,203,189,150,233,187,188,213,180,166,60,205,122,170,189,63,73,174,61,159,229,24,189,88,105,132,189,65,82,121,189,159,22,12,62,160,228,234,189,199,152,31,189,229,72,146,189,175,92,47,59,79,20,21,189,113,181,201,189,213,146,225,189,192,22,51,62,241,85,52,62,20,199,36,190,21,117,148,189,84,97,128,60,215,32,115,62,137,171,154,61,176,106,128,189,189,146,149,189,149,67,130,62,129,22,45,62,187,75,167,189,178,59,114,189,180,245,33,189,151,103,223,59,227,0,102,189,242,144,149,189,79,95,249,189,163,165,253,61,25,37,98,62,186,12,99,189,99,152,7,189,28,196,106,61,155,126,71,62,82,131,36,61,214,185,132,189,181,255,252,189,152,212,63,62,77,63,197,189,182,54,229,189,195,11,254,61,140,122,32,62,201,46,69,62,106,36,223,61,55,234,10,61,158,114,5,190,101,122,102,189,45,216,184,189,9,125,112,62,46,102,142,62,163,213,136,62,60,154,148,61,131,160,41,62,8,66,101,62,158,100,152,61,116,18,87,190],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+92160);allocate([9,98,165,189,81,237,25,190,30,217,143,61,206,168,222,61,57,236,57,62,117,46,77,62,25,250,10,62,126,8,244,189,167,251,227,189,147,79,65,190,2,209,120,61,83,186,82,62,113,56,254,61,53,251,32,61,150,97,149,62,212,13,151,62,183,159,142,62,65,192,147,188,128,117,42,62,190,78,69,62,49,180,155,60,51,214,118,61,40,148,26,59,154,75,127,60,186,198,221,60,199,31,233,61,199,227,247,61,137,11,32,61,44,242,61,61,255,191,184,61,177,29,244,61,129,230,109,187,6,224,181,60,196,178,211,61,235,174,49,62,76,20,251,61,185,99,66,62,63,37,33,62,86,44,62,60,8,129,138,188,147,43,126,186,40,189,147,61,149,81,62,60,168,239,54,62,247,188,122,62,199,117,58,62,24,158,78,62,127,162,116,61,86,118,18,188,17,206,189,188,181,212,19,62,79,136,16,62,91,35,98,61,28,31,130,61,213,214,67,190,205,96,208,61,185,154,150,62,23,106,135,62,129,98,191,61,47,130,28,62,250,185,74,62,117,218,232,61,239,71,2,190,75,25,91,190,190,131,164,188,101,124,134,189,208,41,136,188,120,66,33,189,143,184,67,61,238,129,77,61,211,86,188,188,92,239,78,190,237,252,130,189,208,130,12,62,52,219,102,62,239,116,24,62,151,233,177,61,232,176,138,62,218,229,164,62,231,86,200,61,146,173,61,190,33,117,48,190,250,164,42,188,201,49,36,61,17,5,44,61,72,129,165,189,113,210,25,189,203,0,69,189,125,229,85,189,94,77,94,190,72,163,135,189,5,71,241,60,15,111,60,189,246,73,87,189,231,180,172,189,252,80,233,60,55,249,14,61,233,194,7,60,91,84,226,189,209,151,229,189,40,179,163,188,75,238,91,189,164,164,181,189,199,129,64,190,221,174,94,189,203,70,77,189,215,253,93,189,229,250,123,189,226,192,221,189,210,10,50,61,175,127,36,61,208,43,121,60,60,79,249,189,127,229,71,189,81,116,52,188,154,39,5,61,182,38,118,189,197,141,252,188,115,4,188,188,143,109,140,189,148,183,179,189,241,164,115,190,4,229,187,189,132,217,98,189,75,253,48,189,240,49,243,189,62,237,44,189,120,165,120,189,128,180,67,60,147,177,213,60,12,108,31,189,96,155,134,188,156,40,213,188,119,227,85,188,58,145,32,61,125,105,133,189,94,162,56,60,50,176,205,187,133,211,222,188,79,4,228,189,120,46,7,61,155,123,196,60,99,26,39,61,34,92,216,189,182,95,116,61,52,211,67,60,219,58,2,189,47,168,138,188,92,11,125,189,166,220,150,60,202,147,180,187,178,181,139,189,95,189,2,189,201,125,195,189,61,67,248,60,224,139,72,189,24,196,238,188,125,5,8,190,201,237,67,189,14,45,199,59,8,126,109,188,192,201,8,190,214,103,198,189,132,129,230,188,204,209,70,60,54,49,136,61,86,10,167,188,121,196,8,62,28,52,117,61,245,139,21,188,16,79,64,190,231,156,245,189,150,227,129,189,101,114,73,60,26,75,146,61,5,103,219,61,86,9,227,61,122,137,134,61,46,48,242,188,222,202,38,190,64,75,15,190,2,196,83,188,14,0,29,61,130,253,186,61,69,85,80,189,247,21,102,61,132,155,31,189,103,169,128,189,190,80,235,189,130,16,18,190,186,145,57,189,116,236,130,60,169,193,187,61,156,108,177,61,216,25,72,61,11,41,107,189,107,242,154,189,54,122,47,190,67,149,214,188,153,246,202,188,3,131,219,60,128,4,238,61,123,252,179,61,109,238,30,62,51,231,64,61,237,128,56,61,42,47,209,189,173,196,251,189,23,115,69,189,167,168,96,189,121,52,96,61,136,116,150,61,253,113,100,61,220,35,168,189,237,215,13,61,61,167,86,190,192,247,190,189,118,178,120,59,162,45,20,61,56,113,43,62,207,140,144,61,97,255,208,61,47,43,139,189,20,142,83,59,30,234,0,190,59,43,51,190,103,65,170,60,107,148,157,189,155,138,249,61,13,67,184,61,118,87,68,61,177,33,233,189,24,202,164,189,146,171,131,190,132,127,165,189,57,14,223,59,109,12,240,188,40,216,71,187,237,116,227,189,29,153,61,189,248,47,160,189,250,90,252,59,126,223,209,189,50,167,158,58,35,173,82,62,103,192,4,189,210,28,10,60,79,116,159,60,161,70,68,188,136,76,21,190,169,104,45,61,243,176,135,187,230,159,140,189,216,55,199,188,211,137,10,190,58,2,165,58,124,252,233,189,13,71,48,189,217,214,138,188,192,76,106,61,113,64,36,190,216,39,227,60,83,54,97,61,77,181,25,190,187,181,109,60,109,137,192,60,76,43,48,189,104,211,74,189,26,59,94,62,36,102,1,189,115,213,160,188,202,179,58,62,54,176,5,189,100,14,61,187,151,13,130,60,146,173,254,186,98,135,159,189,20,116,63,61,38,253,204,187,191,205,182,61,145,169,90,62,248,144,77,60,9,92,143,189,123,242,114,189,52,93,154,188,137,98,48,189,61,139,241,61,236,101,29,61,46,8,32,189,240,218,102,61,3,2,200,189,20,92,172,188,43,252,14,60,121,52,224,188,20,102,81,189,33,12,46,62,78,35,242,60,168,138,171,60,48,83,172,61,0,162,8,189,201,43,20,189,229,231,109,189,92,179,181,189,109,214,239,60,119,163,138,62,32,214,120,61,160,39,153,61,6,127,28,62,28,23,32,189,16,248,80,189,177,249,27,188,197,9,6,189,213,231,178,189,54,85,156,61,187,39,147,189,26,188,13,62,196,0,160,61,97,28,4,190,7,208,96,189,177,51,103,189,134,201,6,189,87,16,229,189,16,170,25,61,122,221,116,189,3,128,187,189,63,185,103,61,82,72,49,189,202,175,249,188,46,135,103,188,249,129,208,189,182,193,98,188,59,40,78,62,32,205,123,188,187,125,156,189,14,241,113,61,61,108,160,189,217,168,121,188,71,167,153,189,135,199,193,189,74,188,25,190,219,91,36,62,5,194,184,61,41,136,173,61,149,179,10,61,103,86,187,189,115,208,187,189,155,12,174,189,145,174,81,189,177,160,213,189,160,168,42,60,226,19,251,188,156,73,191,61,212,16,132,61,205,247,30,189,22,52,76,189,161,125,23,190,32,255,84,189,82,173,175,188,166,223,35,61,201,96,254,61,240,175,151,188,16,159,40,189,88,197,244,189,94,216,71,189,25,163,178,189,39,39,173,189,2,12,216,189,195,112,230,61,168,126,220,61,217,160,68,62,80,10,123,61,8,5,224,188,113,240,180,189,6,20,46,190,32,87,17,189,175,170,175,187,45,241,169,61,8,255,147,61,211,206,43,61,150,58,63,61,31,46,15,60,8,244,142,61,140,134,103,61,115,210,112,61,13,236,202,60,17,210,200,60,65,164,254,61,163,98,101,61,105,8,141,61,74,59,30,61,239,194,152,61,112,122,185,60,132,4,117,60,252,237,129,61,228,60,142,61,97,46,240,60,65,3,240,61,131,113,57,61,195,11,5,61,40,126,8,59,234,126,167,60,234,138,233,61,148,73,48,61,150,252,131,61,35,31,75,61,203,103,167,61,130,61,189,61,3,124,72,61,131,143,184,60,17,96,135,188,204,97,155,61,66,100,120,61,156,228,14,62,128,38,227,60,244,67,145,61,248,26,174,61,222,94,139,60,16,118,185,61,37,30,171,62,37,122,78,62,123,34,201,61,19,216,162,61,121,19,178,61,160,163,2,190,212,252,13,190,203,95,135,189,177,251,224,189,14,139,11,61,135,230,54,188,112,33,149,189,218,128,10,190,168,135,3,190,139,108,183,61,167,213,187,61,207,176,206,61,88,119,111,62,25,150,176,62,173,201,202,61,82,20,164,60,30,164,252,61,87,198,155,61,179,145,24,190,57,25,32,190,129,2,133,189,89,57,144,188,110,112,11,61,50,66,7,190,250,212,247,189,33,86,59,190,232,148,41,190,110,231,178,60,123,126,225,188,191,146,148,60,234,230,163,60,160,65,88,60,152,117,164,61,243,248,71,60,66,115,67,59,125,38,86,188,26,139,116,61,93,241,90,189,167,134,10,189,150,204,33,188,95,175,140,189,82,17,34,61,45,159,254,188,220,208,106,189,61,246,177,60,76,98,42,61,212,55,44,59,93,38,69,61,6,172,191,61,185,21,6,188,240,70,141,60,103,176,208,188,202,117,75,189,209,209,195,188,94,255,135,61,146,40,129,189,247,94,58,60,224,240,100,61,187,181,168,189,26,29,201,60,187,160,250,188,162,96,183,189,148,81,140,61,182,65,147,61,130,222,155,189,39,251,0,60,34,192,0,188,117,11,118,61,102,154,56,188,187,67,59,187,110,127,67,189,36,106,154,60,244,168,25,62,173,98,128,189,221,241,162,188,234,131,58,60,254,105,179,61,86,226,30,61,218,107,30,188,254,26,164,189,190,94,131,61,68,78,95,188,115,24,187,189,90,200,143,60,249,168,54,61,154,166,197,61,31,207,85,61,16,208,15,187,18,35,144,189,152,254,130,188,143,45,6,62,172,49,204,188,222,43,41,188,195,214,237,188,65,224,55,61,152,221,82,61,182,56,152,60,166,36,239,188,55,248,169,61,103,5,60,189,59,60,33,190,121,183,185,189,220,128,243,188,114,247,4,62,208,143,100,62,39,113,120,62,244,51,21,61,5,139,97,189,119,64,47,59,189,10,29,189,142,21,132,61,124,19,29,61,13,88,28,61,121,51,128,62,96,42,175,62,189,15,166,62,125,195,64,62,237,31,176,189,203,55,52,190,163,216,28,190,123,5,203,189,44,248,233,188,205,71,89,189,157,130,139,186,59,6,136,189,89,202,153,189,207,193,111,60,205,169,154,189,176,190,56,189,239,97,10,188,57,45,145,60,137,162,38,61,238,210,79,62,150,247,32,62,190,247,105,61,0,164,134,62,108,24,22,62,46,131,125,60,50,246,78,189,210,250,30,189,47,149,107,188,167,240,73,189,74,4,240,61,142,196,118,62,236,132,135,62,246,75,162,62,1,236,206,61,77,161,51,188,174,248,95,188,184,37,47,62,4,120,77,62,154,99,47,59,165,249,66,188,145,104,59,62,112,188,193,61,60,52,130,189,93,149,132,189,145,193,97,60,163,120,205,189,102,215,130,189,93,75,121,59,114,51,126,61,50,243,211,61,251,60,137,62,255,1,6,60,117,151,189,188,130,24,25,60,2,98,188,61,128,201,22,61,75,190,15,188,230,226,197,189,134,120,222,188,169,70,10,62,130,142,183,61,39,79,215,187,1,31,3,189,181,249,145,62,127,84,164,62,235,145,61,62,87,185,17,190,111,219,15,190,176,18,147,189,214,159,175,189,38,100,177,189,53,87,50,190,1,190,69,58,215,113,101,61,74,29,11,62,244,45,75,189,45,222,157,189,188,166,218,61,120,136,52,189,85,164,147,189,74,16,22,61,115,56,148,62,36,146,210,62,149,114,140,62,151,81,141,189,77,229,91,190,115,134,31,190,135,63,72,190,28,191,27,190,244,202,230,189,55,225,151,61,162,120,66,62,139,131,137,62,215,237,159,60,190,198,38,60,49,239,176,60,124,65,162,187,144,235,50,189,25,69,2,190,193,174,136,189,200,234,230,189,243,197,52,61,215,124,100,61,155,156,31,61,152,20,18,61,116,130,112,189,223,78,151,189,165,247,55,190,227,132,175,189,220,101,28,190,149,172,118,189,92,91,143,189,64,81,223,187,15,232,128,61,177,173,43,186,46,235,56,188,150,145,187,188,126,160,70,61,122,155,41,61,200,128,114,62,196,242,20,62,151,4,163,60,206,109,246,61,133,237,125,59,142,117,197,187,87,121,114,189,89,68,251,188,97,126,159,189,44,229,221,61,254,110,176,60,221,143,226,60,151,214,34,61,132,129,249,189,105,181,72,189,192,146,203,189,130,43,132,189,183,223,12,190,133,109,24,189,95,158,231,60,39,58,50,189,124,57,156,60,104,158,210,189,108,74,104,189,200,96,220,189,134,25,197,189,70,231,195,189,54,151,85,188,150,91,252,60,199,20,104,60,62,117,111,61,193,235,177,187,231,212,126,61,34,0,8,189,148,24,139,189,159,54,109,189,24,153,3,62,75,128,25,62,44,221,20,61,76,13,18,62,113,95,49,61,80,34,78,61,230,174,102,189,34,147,131,60,94,179,51,61,16,208,100,62,242,255,32,62,66,64,64,189,136,76,246,60,171,186,37,187,154,49,106,61,112,53,154,189,56,91,233,188,18,172,140,189,205,5,148,187,175,108,132,61,243,28,115,189,0,182,64,189,90,208,150,189,35,97,70,61,84,111,9,190,86,124,200,189,38,7,210,189,119,195,15,61,138,159,66,61,246,143,28,189,26,124,199,61,203,22,67,61,109,99,33,61,34,164,169,189,13,165,195,61,2,99,78,61,52,176,89,62,5,146,197,61,95,194,4,61,70,171,83,61,70,3,61,61,73,92,49,61,140,224,218,188,244,51,128,189,77,146,188,188,138,207,64,62,180,129,215,61,19,171,48,61,82,226,136,60,36,123,172,189,179,33,114,61,80,187,216,189,113,225,70,189,88,127,171,189,48,64,159,61,19,132,24,61,199,186,246,189,159,93,159,59,212,119,215,189,16,151,134,61,30,45,154,189,30,241,4,189,84,30,202,189,237,255,238,188,182,82,59,190,1,170,23,62,201,100,23,60,149,96,50,189,6,180,185,60,75,39,243,189,253,132,36,189,52,218,231,60,195,204,102,62,154,151,82,62,194,6,43,62,97,186,184,61,77,25,85,60,168,229,199,61,226,143,22,189,73,141,158,188,203,52,141,189,50,108,165,61,250,11,67,62,165,172,231,61,251,46,40,61,14,29,229,189,12,167,48,61,253,239,61,190,76,41,231,189,199,28,180,189,182,64,170,60,51,160,28,190,119,203,241,61,81,192,52,188,83,139,35,190,247,106,176,60,10,79,86,189,68,232,221,189,49,113,14,190,150,131,114,61,150,79,207,189,150,149,78,62,153,124,186,61,186,30,154,188,190,196,195,61,69,155,24,189,39,100,193,189,38,243,199,189,102,204,111,61,179,184,169,61,156,76,4,62,40,3,176,61,151,182,35,187,239,122,196,60,28,27,186,59,244,242,128,189,20,13,5,190,138,239,29,61,6,113,84,61,86,0,222,61,185,118,10,189,226,149,1,190,44,40,93,189,28,183,152,189,254,254,65,189,216,41,208,189,91,133,153,61,134,103,166,61,107,204,156,61,163,200,76,189,237,78,3,190,78,138,157,189,108,200,231,189,4,192,186,189,107,75,105,189,192,146,214,61,224,244,152,61,150,136,133,60,196,58,3,188,79,205,134,189,68,159,36,189,215,207,63,189,89,74,156,188,186,59,225,189,211,43,73,61,39,28,240,60,113,240,43,61,146,128,108,189,3,14,198,189,203,63,19,189,211,89,11,189,235,106,146,189,82,101,216,189,69,29,217,61,121,219,129,61,11,208,120,188,218,109,195,187,192,56,156,189,133,50,103,187,127,220,219,188,193,60,210,189,196,156,219,188,22,78,39,62,109,61,254,60,20,43,188,60,12,17,133,60,226,212,221,189,252,148,189,188,119,50,68,189,152,137,98,189,229,83,132,189,112,237,214,61,224,43,62,61,244,128,155,189,191,221,125,189,238,46,185,189,140,213,108,188,227,9,48,189,101,165,230,189,206,24,234,189,122,7,2,61,63,161,22,189,128,207,242,188,83,96,135,189,79,28,8,190,215,145,144,189,118,239,172,189,14,80,216,188,129,38,146,189,184,198,58,61,0,52,111,60,190,53,56,62,201,171,53,61,21,71,255,189,165,51,235,188,139,52,220,189,247,1,11,189,203,75,27,189,178,192,208,60,87,61,160,60,82,19,69,62,213,251,14,62,58,219,113,189,108,14,152,189,66,60,213,189,237,20,202,58,209,62,147,60,120,98,5,62,124,69,58,61,89,229,105,189,238,19,219,189,192,33,10,190,82,113,133,189,137,54,131,189,149,225,133,187,41,248,90,188,135,241,50,61,92,153,230,189,250,137,105,189,72,129,132,189,60,240,170,189,192,171,42,189,172,98,109,189,182,232,168,189,210,55,107,189,39,26,173,61,165,57,9,189,252,41,15,62,11,180,7,62,116,111,155,61,65,107,154,61,99,243,248,61,47,116,67,62,164,30,26,62,62,154,89,62,70,122,17,62,147,190,84,60,190,148,152,61,143,84,134,61,68,79,139,60,238,217,56,61,62,147,45,62,56,40,210,61,91,213,39,62,186,124,97,61,35,112,13,189,137,150,176,61,65,135,162,61,28,222,34,61,236,203,166,60,125,173,129,59,169,209,5,61,12,4,28,62,216,148,84,60,136,19,166,189,67,157,102,60,11,104,144,59,67,54,27,190,233,70,233,189,147,88,153,189,10,3,0,188,35,62,225,188,230,131,208,189,201,219,12,62,16,111,15,62,186,15,10,62,100,227,140,62,157,93,175,62,206,117,156,61,111,220,148,61,30,255,74,62,2,59,37,62,63,122,43,189,197,232,2,190,231,166,201,189,206,205,1,61,204,191,224,61,182,33,26,190,83,157,182,189,179,51,146,189,5,31,42,189,231,239,204,59,82,135,79,60,143,184,215,61,30,141,2,62,182,29,27,62,49,132,117,60,85,37,129,61,33,84,76,188,26,200,179,189,123,36,175,189,101,215,244,189,199,242,173,189,98,179,237,188,213,47,196,188,229,126,9,190,154,94,226,189,127,151,19,190,128,174,27,190,104,185,34,61,21,26,195,185,212,17,44,189,168,16,122,61,57,14,156,60,3,61,53,188,147,94,238,187,185,23,121,188,141,122,144,58,253,183,74,189,183,27,164,189,204,116,187,59,55,89,172,61,26,152,133,189,173,20,22,61,193,249,218,188,102,29,247,189,15,163,23,189,142,7,118,61,240,107,133,60,134,110,202,187,115,199,167,61,249,227,95,187,0,39,235,60,73,220,109,61,57,41,75,61,223,41,61,61,78,197,72,189,112,171,216,189,130,82,186,60,154,54,247,61,111,137,18,59,196,90,201,61,205,98,247,188,186,1,229,189,164,52,75,189,82,182,204,60,129,42,24,189,150,174,132,188,235,141,216,60,22,2,250,187,1,30,236,188,88,178,127,189,46,217,172,189,71,226,147,61,7,196,148,61,41,217,127,60,69,75,253,60,74,250,139,60,4,136,27,189,176,197,80,187,48,10,133,60,122,183,231,188,252,26,231,61,11,98,173,186,22,111,159,189,114,164,147,189,133,32,10,61,189,236,248,61,78,159,186,60,160,21,88,189,135,41,157,188,167,2,5,62,248,46,94,61,92,32,191,60,92,7,37,61,149,206,253,61,182,119,194,61,218,55,188,61,234,134,162,61,93,168,15,60,159,153,47,62,57,122,11,188,4,18,164,189,25,48,139,189,80,21,72,61,18,60,54,60,146,119,160,189,84,124,150,186,252,238,12,189,18,21,233,60,206,154,157,61,183,200,144,189,83,181,60,188,129,230,11,188,38,55,136,188,71,141,42,189,102,52,93,61,254,56,234,60,173,91,239,60,172,237,76,61,51,178,224,187,86,190,133,188,190,86,159,61,239,151,37,61,49,77,71,188,108,135,108,59,197,123,129,189,13,231,194,61,93,220,3,62,159,201,30,188,200,242,40,60,159,53,84,61,115,34,25,188,91,184,134,188,23,161,70,189,33,230,49,189,191,87,215,61,139,203,164,61,239,9,61,189,254,213,34,189,111,99,115,188,142,28,6,62,112,179,120,188,172,151,134,189,182,130,36,189,211,136,151,60,151,219,199,60,170,55,165,61,113,37,229,58,243,117,144,61,173,159,180,61,180,147,166,187,99,41,134,189,138,74,169,189,199,88,159,189,29,34,110,60,83,87,179,189,150,166,51,60,198,193,14,188,243,15,207,61,53,79,198,60,63,99,137,189,217,122,164,60,155,91,194,59,208,35,93,61,142,97,154,61,104,223,167,60,128,182,183,60,30,75,36,61,66,228,189,186,238,85,137,187,217,104,130,61,55,94,205,60,236,111,199,60,8,210,112,61,37,213,6,188,193,143,75,188,143,13,45,61,103,195,143,188,217,11,116,61,236,107,28,61,127,241,149,188,69,126,48,189,25,34,53,189,219,73,199,188,175,137,185,60,209,135,5,59,30,31,68,60,107,212,53,61,231,57,249,61,47,145,19,61,63,238,212,188,227,232,1,187,199,162,167,60,15,49,216,188,90,170,250,186,141,44,191,189,233,65,19,189,68,231,33,188,147,65,140,189,188,33,63,189,187,228,203,189,158,75,44,189,69,188,213,60,114,238,20,60,145,50,146,189,236,105,221,185,59,185,144,60,251,205,225,60,19,89,86,60,164,1,38,61,210,149,195,60,160,157,90,61,8,218,204,60,44,155,75,189,81,85,255,189,227,68,52,62,228,2,251,61,217,217,153,189,93,157,14,60,31,95,105,189,86,138,20,189,63,160,15,188,180,100,70,188,50,145,193,189,2,105,153,61,213,126,164,188,122,166,219,188,219,94,132,189,219,160,120,188,16,112,240,59,66,243,198,59,185,207,190,189,203,103,59,189,123,204,7,62,95,243,29,62,30,167,135,188,59,29,227,188,152,199,86,189,119,10,193,188,214,167,192,188,70,34,209,189,228,209,3,190,101,253,20,62,13,52,0,62,21,198,143,59,52,12,229,60,193,198,83,61,53,230,188,61,73,65,113,61,8,179,194,60,43,133,227,188,148,179,194,61,84,201,190,60,107,12,190,188,121,214,3,189,76,82,122,188,61,147,38,188,236,28,219,188,58,107,82,61,148,65,162,60,192,7,134,61,220,11,143,188,127,41,40,60,228,226,127,60,18,238,80,58,97,175,155,61,238,61,156,60,238,143,252,188,91,62,117,189,205,74,189,61,32,11,21,62,188,181,41,60,89,84,253,60,35,216,195,189,146,190,27,189,240,89,207,60,186,68,252,60,50,108,145,189,36,109,8,61,81,94,48,187,138,189,1,61,174,80,107,61,122,134,5,61,137,178,250,58,148,217,2,61,181,87,151,61,169,16,180,60,141,84,156,61,181,226,6,61,86,113,186,189,78,65,65,61,39,247,121,61,131,87,36,188,189,217,191,59,98,117,121,188,223,87,190,60,115,196,216,61,56,212,142,59,177,45,122,61,195,96,112,61,108,57,255,188,84,3,71,60,7,116,175,61,246,20,129,59,112,143,206,188,0,249,246,186,18,245,166,60,132,83,36,186,92,153,72,61,48,85,47,189,26,106,69,189,145,34,69,189,39,195,109,188,200,244,80,61,241,163,19,188,12,142,8,189,188,122,32,61,242,226,43,61,76,206,47,61,24,40,230,60,149,188,245,60,9,44,39,61,206,25,21,60,226,184,198,61,189,147,212,61,85,104,192,60,179,233,154,187,34,81,40,60,227,11,213,61,31,59,247,61,236,14,201,61,77,250,213,188,137,7,21,61,74,132,113,61,124,69,71,61,202,91,68,61,22,5,31,189,25,168,242,188,163,65,72,188,202,197,38,61,142,131,157,60,7,108,187,188,155,84,8,61,252,75,152,60,246,212,184,61,154,212,27,61,72,100,105,188,224,12,160,60,124,150,205,60,79,228,10,189,186,254,103,189,204,130,134,188,236,142,111,61,119,10,62,61,218,98,171,60,124,55,4,62,53,246,75,62,34,131,158,61,6,213,237,187,198,231,38,61,150,106,2,61,253,132,182,58,224,16,106,188,243,209,152,60,92,175,174,61,252,185,10,62,13,42,229,61,132,203,35,61,126,29,196,61,53,138,215,188,105,166,13,189,52,143,66,189,18,168,120,189,128,160,154,59,128,2,132,61,5,181,200,188,143,157,96,189,171,194,62,189,57,91,166,188,122,146,14,189,45,119,192,189,244,16,131,189,228,212,147,188,50,69,184,59,110,216,217,187,104,124,133,189,89,34,228,59,34,98,152,188,193,232,45,189,139,161,111,189,41,156,84,187,214,181,157,61,80,61,231,61,65,57,203,61,250,89,243,188,174,16,101,61,58,46,69,61,235,238,200,189,218,166,191,189,140,48,6,189,61,190,85,61,119,161,41,61,94,197,128,59,170,190,78,189,103,110,35,62,183,240,60,61,94,27,255,188,63,119,62,189,146,28,5,189,97,181,198,188,213,151,48,189,20,113,48,61,242,140,192,189,181,67,66,189,128,137,77,188,104,36,135,189,79,184,95,59,163,54,102,189,197,151,238,187,96,177,117,189,25,31,6,189,9,20,151,189,230,17,81,59,142,95,158,189,193,55,110,61,29,110,202,188,165,184,29,61,139,181,13,62,208,177,29,62,111,212,141,60,115,22,114,188,10,219,212,61,197,88,83,61,63,97,159,188,249,99,12,189,197,93,71,189,0,47,189,61,92,206,219,61,196,175,120,61,204,3,94,188,243,22,151,60,221,146,14,189,251,130,27,189,94,26,98,57,124,212,94,189,34,209,154,60,33,125,108,188,171,163,213,188,89,174,240,188,252,224,222,60,122,29,127,189,11,97,243,188,106,86,12,189,102,141,210,189,93,5,138,189,251,33,86,189,55,163,9,61,131,251,230,189,217,170,142,189,37,184,14,190,69,63,21,60,167,33,132,57,206,123,133,187,52,31,252,61,139,88,191,61,48,142,149,61,24,250,3,61,251,69,154,61,15,86,27,61,103,49,76,189,63,213,147,60,93,181,220,60,240,12,10,62,87,119,60,61,212,56,40,61,115,78,174,61,74,52,252,61,160,103,88,60,113,155,78,61,76,48,181,187,64,43,184,189,67,67,184,188,19,144,167,189,242,134,124,61,245,99,5,189,193,33,47,188,123,214,88,188,125,38,245,189,232,21,61,189,129,147,247,189,136,127,138,189,153,179,177,189,180,199,131,189,161,52,145,60,141,29,14,61,242,198,223,189,127,229,246,60,216,171,15,62,28,44,37,62,36,44,56,62,203,13,231,61,224,170,215,61,209,100,182,61,50,99,158,61,84,30,137,61,215,122,175,60,66,222,131,61,36,151,200,61,114,81,107,61,71,112,228,60,114,174,215,60,161,140,163,61,114,59,139,59,25,235,10,60,122,128,219,188,6,72,173,187,151,40,177,188,235,104,153,189,197,252,168,189,134,121,168,188,178,33,40,188,2,97,151,186,250,235,22,186,67,172,147,189,6,239,149,189,61,5,72,189,116,44,223,189,94,34,153,189,82,153,181,189,33,224,188,189,182,188,223,189,175,156,213,189,62,227,162,61,79,192,226,60,4,86,233,61,114,77,64,62,189,183,7,61,166,156,175,60,214,178,111,61,10,251,10,187,108,15,119,187,128,66,227,60,210,247,255,188,120,12,112,60,15,98,132,60,16,13,100,188,91,100,52,189,220,254,94,189,36,95,22,190,21,197,25,190,51,181,56,61,33,210,169,58,13,27,101,60,90,205,101,61,34,109,71,189,127,167,67,189,43,214,5,188,205,208,22,187,117,75,187,188,133,107,245,61,68,165,64,189,14,133,180,189,141,88,155,189,11,45,221,189,227,98,4,189,4,93,119,60,103,99,70,189,226,133,34,189,40,100,196,61,122,154,93,60,242,229,110,188,246,42,44,60,81,243,248,188,87,194,131,60,195,196,146,58,81,232,76,188,79,146,59,59,11,130,49,61,49,138,21,190,247,117,159,188,189,171,190,188,155,180,161,188,137,179,162,61,18,60,182,188,198,64,137,189,21,102,14,61,115,162,235,61,143,59,222,188,243,103,136,188,139,88,129,61,87,14,168,189,20,53,152,61,171,89,73,61,67,10,55,189,254,47,116,188,207,143,151,61,71,156,238,189,219,254,80,61,209,189,58,61,42,82,114,189,11,15,181,61,184,20,130,188,192,121,24,190,107,237,160,61,152,238,64,61,47,114,92,189,130,40,150,189,108,165,19,189,216,221,31,62,188,171,156,61,75,24,116,189,171,117,227,188,23,77,227,61,169,246,25,61,221,36,54,189,55,16,74,61,212,115,92,60,131,190,141,61,175,212,150,61,115,14,98,61,180,136,237,60,103,4,192,61,227,106,215,61,150,13,53,189,96,230,156,60,201,143,105,187,160,94,21,62,203,168,210,61,122,156,50,189,52,73,2,190,103,226,185,61,255,187,227,61,179,49,119,189,232,35,198,61,35,14,183,61,203,181,144,61,164,64,213,60,227,161,191,59,90,145,114,189,158,35,253,61,248,186,107,59,122,129,68,59,171,119,23,61,83,94,167,60,64,192,42,61,131,24,40,60,178,209,94,188,186,37,131,188,171,112,211,60,234,207,190,60,255,92,67,59,150,130,133,60,62,60,136,61,179,216,111,61,246,190,74,60,201,133,84,188,40,79,144,60,151,133,80,61,106,33,134,61,102,73,53,189,184,98,31,59,12,105,73,59,65,199,136,61,254,72,48,189,218,86,49,60,31,161,132,189,175,6,39,61,206,207,254,61,174,181,168,61,2,12,152,61,242,137,38,61,239,108,141,61,200,182,195,61,127,77,2,62,0,169,174,188,176,94,174,61,125,5,43,189,20,122,218,188,129,120,155,60,69,225,7,61,181,231,26,60,86,254,74,188,214,197,45,189,68,145,104,188,65,54,17,189,215,244,199,188,203,217,177,61,254,143,44,61,224,193,201,60,184,3,53,188,57,102,164,187,17,56,243,60,5,201,212,60,9,135,128,188,19,238,56,61,185,214,142,61,58,145,177,61,243,214,139,61,45,177,209,61,145,109,93,61,216,28,134,61,243,43,26,189,248,209,95,60,19,201,144,61,249,178,91,61,239,135,68,61,94,191,239,61,242,231,95,61,52,33,153,188,213,238,129,61,238,124,254,60,158,178,172,61,81,216,168,188,3,131,28,61,46,209,226,187,69,222,209,59,71,94,80,188,50,127,144,56,48,4,58,61,56,156,155,188,5,161,77,189,127,213,245,60,157,167,50,60,125,66,148,59,250,212,210,60,131,169,195,188,252,12,44,189,168,120,226,58,193,223,116,189,82,222,222,188,51,161,134,61,144,31,61,60,190,91,79,60,116,15,151,61,102,180,22,188,72,72,73,189,240,16,174,60,123,52,132,61,73,29,51,61,81,148,7,189,109,177,19,61,114,47,222,187,44,99,25,60,191,41,143,60,137,51,131,189,103,135,139,189,192,126,165,61,186,148,227,188,143,18,224,60,81,240,130,61,215,60,136,61,150,135,104,61,148,242,176,61,80,197,248,187,118,228,164,188,168,50,66,189,65,191,135,188,30,18,133,188,171,60,99,61,226,230,24,187,151,129,55,60,176,138,123,61,134,183,128,189,158,214,178,189,7,189,190,189,118,207,46,189,202,169,182,59,15,3,69,61,243,75,145,60,28,21,176,59,132,252,23,62,185,251,128,189,126,114,240,188,200,92,234,61,127,51,78,189,25,77,185,59,232,27,170,60,164,131,59,189,216,249,65,189,41,146,242,60,38,156,190,189,66,245,52,189,58,100,76,189,48,98,33,189,72,250,85,60,217,93,128,61,55,245,25,61,97,67,173,61,252,233,13,62,213,41,71,61,0,110,129,189,98,166,103,189,110,124,154,60,22,148,6,189,113,25,10,61,190,50,144,189,60,229,56,189,173,23,100,60,241,157,167,61,174,19,148,189,80,136,195,60,50,246,178,60,213,118,213,60,45,103,41,188,236,89,24,60,21,114,251,59,176,137,27,62,144,127,169,60,184,112,199,189,186,38,182,189,157,26,159,189,52,15,191,60,59,188,145,188,235,123,5,189,17,139,167,189,182,239,173,189,13,156,187,60,243,209,232,189,68,151,17,189,205,180,57,189,175,107,234,188,111,231,138,61,195,95,54,60,165,0,201,60,209,69,2,62,182,147,165,61,121,198,19,189,243,183,53,60,218,192,68,61,143,242,14,189,184,62,11,61,60,188,104,189,119,211,12,60,61,55,140,187,78,86,4,61,66,6,85,188,159,22,42,188,161,104,162,189,164,126,8,60,117,43,188,60,149,14,86,188,143,36,154,188,135,197,52,61,38,178,106,61,190,18,26,189,135,29,159,60,188,170,215,58,148,28,28,189,38,166,43,61,46,96,25,190,212,233,56,189,255,43,70,60,113,16,179,187,47,240,134,188,117,10,250,59,56,125,153,189,88,88,172,61,102,54,205,61,149,73,73,188,236,56,134,61,52,136,58,61,130,152,161,61,73,33,249,60,64,134,143,60,200,149,188,61,181,77,196,185,231,13,216,61,216,249,63,61,135,57,155,60,36,52,217,188,205,111,142,187,30,145,178,59,13,170,108,60,224,238,112,61,51,170,8,189,76,147,60,61,150,168,213,189,178,155,157,60,67,247,150,60,196,66,140,188,200,22,182,188,18,61,64,61,181,18,126,189,172,1,105,188,251,213,178,61,50,210,157,189,62,254,217,60,67,35,48,189,202,84,253,188,89,127,17,189,34,130,154,188,101,250,75,189,149,1,32,61,35,197,60,61,115,105,75,61,125,31,47,61,195,78,61,189,227,89,217,188,168,105,12,60,1,70,29,61,42,86,110,61,24,245,30,61,155,193,144,185,29,7,252,60,60,208,5,189,81,36,92,189,134,63,76,61,44,230,26,188,58,189,18,61,150,98,45,187,26,218,140,186,53,172,242,60,193,8,115,188,19,191,250,60,35,145,200,60,230,49,151,60,101,120,6,61,69,197,16,189,187,156,49,188,247,91,55,188,146,244,242,186,122,226,27,186,175,88,54,189,23,131,67,59,226,117,128,61,78,76,176,188,121,133,72,187,124,179,79,189,193,246,122,60,41,45,82,60,127,165,83,61,80,9,27,60,147,65,91,187,139,86,234,61,187,4,32,189,184,49,47,187,116,109,251,60,84,210,57,188,180,158,241,60,150,235,235,60,138,236,29,61,16,88,13,189,251,62,187,61,80,172,176,188,164,213,120,61,252,205,126,189,229,78,159,60,35,3,219,59,200,84,136,189,84,171,14,60,236,142,13,61,100,107,199,60,81,138,7,190,99,23,43,189,57,139,169,188,221,255,46,60,101,166,118,60,199,244,153,189,164,96,123,187,82,254,128,189,103,8,236,188,155,39,6,190,200,229,147,189,86,9,190,187,198,117,12,188,16,238,26,61,199,70,226,60,104,113,74,61,176,140,240,188,7,141,196,61,233,102,157,60,160,231,121,61,166,24,68,189,178,7,98,188,135,142,242,187,160,223,181,188,236,62,87,188,76,202,254,59,135,215,251,61,58,216,240,60,121,54,19,61,210,130,159,189,129,167,57,188,97,91,209,57,235,117,121,189,220,214,55,188,241,147,153,187,109,83,156,61,202,55,138,189,208,6,103,189,171,174,87,189,61,162,58,188,7,17,133,188,216,39,65,189,66,19,52,188,214,203,43,60,39,73,87,59,4,252,109,189,182,177,157,189,190,108,8,189,109,108,43,61,24,123,14,61,171,97,186,60,114,206,188,60,142,63,218,59,175,160,224,61,154,81,194,187,88,255,70,189,226,41,44,189,202,206,190,189,115,228,200,187,167,116,208,188,160,214,95,60,6,127,22,60,140,69,151,188,38,75,102,189,166,103,35,189,114,244,159,189,105,132,226,59,239,5,116,61,116,204,31,189,69,199,128,60,236,155,67,188,35,231,225,187,97,104,253,188,34,106,41,189,189,7,128,188,133,154,60,189,80,184,234,60,14,188,177,189,13,103,4,189,214,187,91,189,93,192,108,188,102,112,143,189,112,142,177,189,195,43,57,189,107,17,47,61,7,99,255,60,59,112,167,61,255,32,49,60,55,168,130,61,99,235,125,61,32,200,234,60,11,92,193,60,133,188,137,61,237,17,5,189,28,162,25,188,28,73,169,61,168,250,183,188,133,243,81,61,65,145,152,188,79,170,161,60,146,99,163,188,94,150,220,189,166,68,2,61,77,75,84,59,172,122,175,188,99,85,46,189,168,1,67,61,19,109,47,61,64,217,102,61,140,66,153,188,162,241,98,61,85,65,249,188,190,110,110,60,60,201,135,189,194,92,111,189,102,45,25,189,57,117,199,189,151,230,3,189,225,51,102,189,113,156,212,189,107,142,151,61,240,216,137,59,55,120,5,61,20,115,12,59,181,203,81,61,145,201,80,188,16,92,195,60,173,192,129,61,17,232,161,189,102,136,171,61,0,197,161,189,110,75,133,189,43,172,204,188,120,218,133,61,20,162,34,61,180,132,72,61,39,159,63,188,160,11,35,189,41,191,104,61,252,180,114,61,136,1,63,188,41,139,162,189,21,102,44,189,120,143,90,60,86,94,185,61,31,210,206,61,24,201,34,189,210,245,74,60,186,162,153,189,17,186,21,189,202,48,48,189,228,194,188,61,136,12,243,57,55,144,233,60,105,136,175,60,65,121,6,57,106,231,235,60,66,52,175,189,37,51,70,189,195,156,166,61,160,201,107,189,68,167,103,60,150,99,13,61,46,145,135,189,199,28,250,188,217,158,242,60,193,60,151,189,96,18,58,60,208,109,88,61,77,75,159,189,26,165,172,188,136,194,97,189,162,248,9,190,0,59,248,60,191,170,137,61,6,185,126,189,182,170,110,189,102,24,128,61,190,56,237,60,156,80,136,188,99,73,20,189,236,19,132,188,37,126,191,186,81,127,15,62,151,212,18,188,77,33,5,189,184,236,93,59,160,134,45,59,88,157,9,61,30,151,197,188,236,63,45,189,120,113,218,61,42,78,213,192,11,181,150,62,143,85,202,189,106,161,4,190,65,73,161,61,240,105,198,62,33,231,133,62,9,113,21,62,101,252,123,61,60,75,168,62,124,153,104,62,218,31,136,189,212,155,177,189,58,205,66,61,223,140,218,61,226,57,27,61,170,69,228,61,23,239,199,188,175,10,156,62,229,100,130,62,20,203,141,189,93,24,169,61,83,203,22,62,123,104,167,62,25,118,24,62,204,98,98,61,123,49,180,189,42,0,134,62,118,226,18,62,215,164,219,60,217,237,115,62,46,173,70,62,210,197,102,61,197,203,211,188,39,21,13,189,224,99,32,190,34,25,82,62,212,73,182,61,157,42,15,190,223,25,205,189,161,243,26,189,193,115,239,188,209,231,99,189,14,47,8,61,44,68,135,188,72,248,30,62,37,64,125,62,145,95,255,189,194,77,70,189,90,217,126,189,214,84,70,62,126,225,149,59,1,165,97,61,2,159,191,61,178,188,43,62,91,154,43,62,176,201,154,60,152,108,92,62,109,26,251,61,141,98,185,61,29,170,137,189,162,210,72,189,243,2,204,189,120,155,119,62,67,87,194,189,91,122,52,190,129,92,226,58,74,179,9,190,176,229,213,61,143,168,80,61,214,57,166,61,134,198,147,61,138,33,249,61,73,16,46,59,12,144,152,190,8,203,8,190,112,65,118,189,129,120,189,189,246,152,72,189,129,147,173,189,5,111,56,190,140,16,30,189,36,181,176,61,5,222,9,190,93,165,219,189,81,20,8,62,14,244,16,62,68,105,127,62,73,102,5,62,146,3,246,188,44,240,149,61,141,156,5,188,86,70,163,60,40,209,146,61,82,73,157,57,229,242,159,188,161,248,177,188,71,232,39,189,178,217,177,189,44,157,143,61,54,203,117,62,245,219,135,62,223,250,48,61,144,193,42,62,182,75,187,61,14,131,121,61,244,111,23,189,193,116,186,189,117,148,163,61,69,14,97,62,126,229,33,62,42,254,15,190,140,49,48,189,49,152,255,61,2,213,191,61,183,94,211,61,64,76,194,61,174,242,164,61,29,4,13,62,106,107,36,62,228,74,45,190,244,24,101,60,213,119,158,62,195,46,138,187,140,74,106,189,207,18,132,189,20,117,102,60,44,214,184,62,16,174,128,62,106,218,165,189,60,249,52,189,81,164,123,61,210,28,25,189,142,90,161,189,8,229,253,60,162,207,135,61,125,89,26,61,22,251,27,62,76,196,187,189,151,198,143,61,165,21,95,62,222,60,21,61,28,152,156,189,91,238,204,59,10,101,193,189,126,139,30,62,48,186,188,188,37,176,73,190,91,121,201,188,135,191,54,62,141,94,77,189,49,35,60,189,14,248,124,186,29,118,223,61,131,23,61,61,173,50,35,190,249,192,14,188,135,49,41,61,146,235,198,61,21,86,106,189,123,76,132,189,175,8,158,61,31,101,52,62,72,164,13,62,130,169,134,61,7,240,214,189,58,232,146,60,110,134,11,62,138,5,62,188,105,138,64,61,102,247,164,61,30,136,140,61,191,98,173,61,28,97,17,189,214,2,187,189,149,158,41,189,186,188,121,61,61,183,208,189,226,146,163,189,182,20,176,189,254,215,185,188,228,103,163,61,199,213,200,189,101,167,95,189,165,104,37,61,172,1,154,62,129,176,3,62,146,61,194,61,216,45,66,61,160,137,208,61,141,67,125,61,69,13,38,190,87,118,81,190,45,9,16,189,5,197,207,61,181,82,136,188,181,84,222,188,14,158,9,190,205,62,15,188,234,146,209,61,13,56,235,61,222,1,30,60,88,169,128,61,255,8,115,62,9,223,43,62,188,91,89,61,173,78,78,188,113,198,48,61,124,15,23,59,63,31,133,61,4,116,31,189,160,193,166,188,206,255,27,62,141,12,50,61,91,125,245,188,62,234,47,189,204,10,5,61,112,67,140,61,21,0,227,189,124,127,227,189,197,85,229,61,100,202,7,187,112,65,182,187,27,213,169,61,106,106,217,59,82,127,221,189,41,151,198,60,10,20,177,189,244,112,66,190,98,75,143,188,11,13,68,62,173,193,251,187,5,220,3,190,183,183,27,189,159,142,7,190,179,67,188,61,168,55,163,61,54,148,218,189,47,223,250,187,206,227,48,62,67,169,61,60,78,236,33,60,44,131,170,61,21,56,217,188,221,6,21,62,65,158,29,62,190,106,5,190,142,30,223,189,157,244,254,61,54,204,80,187,20,203,205,189,57,39,118,60,110,219,119,189,239,89,215,60,150,150,177,189,123,17,45,190,242,180,156,61,232,244,92,62,210,255,50,61,41,205,6,190,81,49,78,188,182,15,57,189,238,9,242,189,79,87,119,190,219,78,43,190,111,183,164,188,250,40,163,188,173,138,208,189,38,85,219,189,198,20,44,188,233,16,56,61,121,59,66,62,113,84,94,62,172,196,60,189,5,78,54,61,90,130,76,62,238,120,19,189,82,128,24,190,238,206,90,60,190,80,160,189,96,116,249,60,225,155,102,61,208,152,201,188,88,113,170,61,245,215,203,61,115,131,33,189,143,54,14,190,89,162,179,59,78,151,197,188,216,214,15,190,195,242,135,189,31,187,139,188,65,183,23,60,154,149,109,189,121,91,233,188,196,90,124,189,244,51,245,59,193,27,34,190,177,77,26,190,63,169,54,189,174,73,215,189,252,113,59,189,207,219,216,187,91,10,200,188,131,19,241,189,41,118,244,189,225,41,52,190,157,132,146,189,110,196,243,61,195,17,228,61,167,116,48,61,197,231,14,61,91,120,190,61,187,123,0,60,181,250,106,61,92,228,222,189,67,198,163,189,132,128,108,62,245,132,165,60,171,236,59,60,6,128,202,61,158,123,207,61,115,133,247,188,124,154,147,188,204,236,115,189,215,104,217,189,83,32,179,60,158,98,21,189,199,241,163,61,162,156,40,61,146,36,168,189,84,26,241,61,236,161,253,60,43,79,96,189,171,61,172,189,151,60,62,190,244,26,123,189,54,3,28,189,93,197,226,189,82,44,135,190,200,7,157,61,95,236,157,189,140,242,12,190,1,104,20,61,92,85,142,62,40,153,156,60,190,165,220,61,134,117,19,62,108,118,164,61,102,50,92,62,250,99,106,62,142,234,148,61,115,71,159,61,164,26,246,61,120,67,154,61,150,120,128,61,191,213,250,61,157,188,72,189,177,222,40,62,75,89,38,62,145,241,40,61,220,13,34,60,134,89,200,189,228,131,30,189,30,163,188,188,12,205,245,189,167,62,80,62,248,111,126,62,203,103,25,62,37,150,20,189,99,154,169,189,192,5,185,189,255,90,222,188,214,2,155,189,172,255,163,190,111,18,3,186,38,198,18,190,23,71,133,189,39,108,63,190,24,122,4,62,96,115,238,61,77,15,58,62,198,134,46,62,8,116,214,62,5,139,235,62,55,221,170,62,32,12,108,62,0,225,67,61,175,33,56,189,172,112,139,189,21,139,15,62,58,150,55,189,215,52,175,61,186,103,189,61,1,190,219,189,91,206,5,190,141,150,83,190,238,179,234,61,186,191,162,190,126,1,157,189,235,110,30,61,236,219,89,62,42,142,131,188,8,144,1,190,72,135,39,190,156,50,87,62,142,145,204,61,23,102,1,190,125,151,242,61,232,45,158,60,141,9,177,188,69,161,197,189,30,252,228,189,253,76,77,190,82,72,18,62,8,85,106,62,196,233,180,190,92,115,55,190,170,70,239,61,34,57,129,62,56,245,1,189,118,166,64,190,95,208,34,190,88,230,197,62,73,128,250,61,143,251,86,62,98,189,201,62,200,210,183,62,179,124,133,62,76,108,46,62,169,46,96,60,176,4,18,190,92,31,214,188,241,155,66,188,167,33,26,190,204,41,65,61,82,67,219,189,34,226,22,190,140,49,64,190,221,125,62,190,137,10,85,190,36,124,111,61,168,142,149,189,188,59,114,190,228,103,163,189,166,185,21,190,194,223,111,189,91,150,207,189,151,2,146,189,53,153,145,189,59,115,239,61,99,237,111,62,102,18,157,62,159,203,164,62],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+102400);allocate([143,194,117,62,221,9,150,61,67,113,71,188,125,234,216,60,52,130,77,61,50,29,42,62,46,115,106,62,25,144,125,61,13,55,32,62,11,239,82,62,226,34,247,61,80,252,24,61,201,233,43,62,219,135,148,62,52,128,215,62,109,116,78,188,40,101,66,62,148,221,156,62,201,114,242,61,226,200,195,189,123,49,148,189,8,173,7,190,39,164,101,190,166,11,1,190,182,18,186,60,143,109,145,62,77,104,82,61,235,1,115,186,29,148,112,189,128,181,170,189,227,164,16,190,114,20,64,190,118,136,79,190,119,77,72,61,237,131,124,62,222,59,226,62,166,94,175,62,73,44,137,61,239,115,92,62,36,181,64,62,145,242,147,189,45,35,85,190,154,93,247,188,152,106,54,62,204,69,12,62,239,168,49,189,193,113,57,190,129,9,188,61,53,238,237,61,6,187,1,190,182,243,197,190,31,128,188,62,230,205,137,62,93,79,180,189,54,30,236,188,86,98,190,61,68,107,197,60,240,223,60,61,134,255,52,62,0,28,11,62,104,232,255,61,128,40,72,62,231,113,24,189,239,58,43,62,247,120,65,62,45,64,91,61,34,81,136,189,40,238,8,62,98,132,144,189,238,91,237,61,236,23,28,62,7,154,239,189,15,126,226,189,22,77,55,190,217,118,218,60,234,236,164,61,164,197,153,61,102,46,144,189,56,192,76,60,173,252,178,60,75,30,15,190,73,99,180,188,117,57,197,189,154,6,133,189,52,129,2,190,144,50,98,188,65,212,221,189,45,9,32,62,188,118,25,62,145,123,58,188,90,41,132,61,187,241,238,60,73,103,224,60,67,199,142,61,181,108,29,62,47,135,29,61,74,64,108,62,81,247,129,62,87,205,115,61,127,137,56,189,98,188,102,60,115,158,145,61,58,203,140,61,103,96,196,61,93,26,191,59,66,93,20,62,163,234,215,60,132,243,137,189,174,215,52,189,204,123,252,189,101,28,163,188,158,66,174,59,114,168,223,61,222,199,81,187,128,11,178,188,0,111,17,62,138,6,137,189,67,231,245,189,149,42,65,190,92,87,76,60,216,125,71,189,195,154,74,188,141,67,61,190,30,163,44,62,251,201,136,62,131,107,110,61,64,163,52,189,76,55,9,61,233,215,54,62,79,30,214,61,74,182,250,61,215,51,164,61,102,103,49,62,215,217,152,62,34,109,131,61,208,182,90,61,114,134,50,62,18,135,108,62,206,170,239,61,88,59,42,62,108,63,105,62,49,9,247,61,232,50,53,62,181,169,58,188,0,30,177,189,229,126,7,188,97,195,83,61,195,12,29,190,17,255,112,189,223,22,108,189,37,59,118,189,220,217,215,60,86,154,36,190,189,54,27,189,148,246,70,189,36,38,40,61,58,36,181,188,74,65,119,61,99,155,84,61,142,143,38,62,237,215,13,62,201,142,77,189,142,147,194,187,66,6,146,61,30,192,2,62,83,90,127,61,152,221,19,62,79,175,148,61,207,50,75,62,213,32,124,62,117,31,160,189,242,37,20,189,73,131,155,61,1,219,65,61,187,214,94,188,137,152,178,61,83,5,163,60,56,48,185,60,123,189,123,188,201,115,189,189,199,41,154,61,4,86,238,189,23,217,78,61,167,205,56,61,138,144,42,62,2,155,147,61,149,71,119,61,176,232,6,62,145,240,45,190,144,47,33,189,174,128,66,189,46,2,35,189,42,55,81,190,43,217,177,60,181,140,4,62,0,115,173,188,247,147,49,62,114,252,144,189,24,11,131,189,27,185,142,61,86,70,131,189,206,80,252,189,185,79,142,188,187,213,83,190,46,227,134,61,8,227,231,61,86,102,202,60,59,27,146,189,108,36,137,189,250,69,201,189,223,223,128,189,0,82,155,61,97,27,113,60,157,190,158,60,63,226,7,62,115,241,151,189,169,105,183,189,76,168,160,189,75,58,74,190,61,213,49,190,70,97,87,61,225,179,53,61,97,140,232,61,44,182,201,61,226,120,158,61,182,157,54,188,25,55,69,190,166,97,40,190,131,165,58,61,194,162,82,62,79,120,73,61,241,130,168,189,105,28,10,62,115,243,61,62,155,58,15,61,102,220,244,189,75,35,230,189,213,180,235,189,37,91,93,189,67,58,60,190,229,242,159,189,141,69,67,62,178,161,187,61,78,126,139,59,44,125,40,189,36,182,123,189,126,253,16,190,3,124,71,190,14,17,247,189,93,55,165,60,183,155,224,61,246,7,138,61,206,168,121,188,109,226,116,190,245,130,135,190,199,158,61,190,186,187,78,61,21,86,170,60,24,35,18,61,219,24,187,60,160,55,85,189,11,10,3,190,60,134,231,189,226,229,105,190,104,61,132,190,193,224,90,189,48,132,156,61,255,178,123,61,111,45,115,62,248,27,109,59,179,210,100,189,184,92,221,189,74,13,237,188,86,183,58,61,57,99,88,61,146,206,192,186,151,253,186,60,110,250,115,61,101,223,213,189,163,61,158,189,152,247,88,190,250,42,89,190,114,251,229,60,38,85,155,61,45,62,133,60,156,195,37,62,87,180,9,62,27,100,18,60,164,198,68,189,31,248,152,61,15,123,161,59,245,19,206,188,195,128,69,62,69,100,152,61,31,18,158,62,167,232,136,62,32,240,192,61,149,16,172,187,47,51,44,61,159,173,3,189,208,100,127,60,12,120,129,62,94,130,51,62,1,136,187,60,44,68,167,61,50,115,129,61,110,135,38,62,156,23,71,62,220,128,111,62,35,75,134,62,148,106,63,62,156,49,172,61,115,161,146,190,150,37,90,190,195,40,72,189,47,167,84,190,150,33,46,190,28,64,63,60,196,96,190,189,177,105,69,190,233,12,140,190,25,114,108,62,25,145,136,62,17,27,164,62,179,36,152,62,206,84,12,63,189,30,156,62,26,223,7,62,221,68,125,62,116,150,89,62,97,254,138,190,249,131,17,190,191,41,44,187,254,38,244,189,213,118,3,62,56,246,204,61,162,122,107,189,193,167,249,189,170,98,106,190,162,37,79,62,238,177,204,190,113,30,190,190,170,69,196,189,89,78,130,189,125,63,37,190,252,82,159,190,162,239,150,190,212,238,119,62,117,34,65,60,199,187,195,61,188,33,165,62,242,7,3,63,135,80,165,62,124,99,160,62,175,125,49,62,175,151,38,59,83,35,244,188,187,71,166,62,193,255,166,190,45,92,174,190,95,155,13,190,228,46,66,187,74,152,233,189,10,47,193,190,137,152,226,190,114,139,89,62,54,63,254,187,67,169,61,188,184,200,45,62,124,12,158,62,112,123,162,62,119,21,10,63,169,106,170,62,233,211,106,61,245,161,139,189,59,226,208,61,146,179,136,62,133,153,86,62,62,34,182,62,34,171,187,61,223,82,46,62,92,56,0,62,234,93,140,62,20,209,143,61,213,4,209,60,45,148,76,61,224,45,16,186,128,14,51,61,75,63,17,190,9,193,170,60,231,252,4,62,129,95,131,62,27,18,215,61,46,230,23,62,67,199,46,62,51,221,235,60,182,160,151,61,13,226,35,62,30,110,207,62,114,24,124,62,81,78,180,62,126,1,45,62,233,152,99,62,140,100,135,62,44,14,135,61,192,235,179,60,164,197,153,189,214,173,190,61,0,202,223,60,53,121,202,61,83,202,107,61,228,106,164,189,7,121,61,62,135,251,160,62,68,222,170,62,49,209,0,62,160,255,150,62,14,162,197,62,132,215,94,62,225,235,59,190,139,167,142,190,61,124,25,187,222,232,227,188,7,125,9,190,83,231,169,190,242,235,7,188,105,27,255,61,29,1,92,61,170,239,188,190,60,162,194,189,249,103,86,62,18,247,216,62,84,87,190,62,172,230,217,61,12,35,189,62,157,161,248,62,244,191,108,62,113,3,14,190,100,203,178,190,173,135,143,189,137,126,237,60,161,45,167,189,119,191,202,190,97,80,22,190,127,21,224,188,195,213,129,61,6,131,139,190,239,202,110,61,120,41,173,62,207,217,226,61,35,159,87,189,218,117,111,190,161,218,224,188,109,114,248,60,68,78,31,62,217,39,192,189,12,92,158,60,14,17,247,61,31,45,206,59,11,66,217,189,1,246,113,190,190,80,16,190,121,92,180,189,53,238,205,188,128,101,85,190,146,233,208,188,17,167,19,62,204,13,70,189,7,98,217,189,210,56,156,190,231,197,233,189,207,74,186,61,213,203,167,62,153,215,17,61,52,15,192,189,102,188,45,59,220,47,47,190,106,165,64,190,202,196,93,190,147,30,86,190,162,212,94,189,37,235,32,62,0,254,105,189,49,93,136,61,104,66,19,60,229,183,40,61,188,33,13,61,40,68,160,189,195,101,85,61,144,46,182,188,86,45,137,61,83,174,240,189,181,194,148,189,75,6,128,61,0,227,25,61,66,179,107,189,133,237,159,190,237,185,12,61,134,57,1,189,86,42,40,59,29,90,84,190,11,179,144,189,25,229,153,188,239,143,55,189,208,241,81,188,169,77,156,189,105,30,160,61,179,153,195,60,151,198,239,61,182,157,182,60,171,90,82,190,115,133,119,189,87,176,141,188,208,43,158,187,213,94,164,190,195,187,188,189,140,19,31,61,164,228,149,61,65,68,138,189,145,66,217,60,90,18,48,62,200,211,178,61,161,74,13,61,232,160,11,189,168,29,30,62,18,159,123,189,77,161,243,59,64,133,227,189,17,143,196,189,60,132,113,60,241,127,7,190,163,205,241,188,151,197,68,190,237,17,202,61,18,21,170,60,152,76,53,62,210,29,132,189,85,249,94,189,88,88,112,189,34,136,243,186,220,159,43,62,176,230,128,60,134,145,94,61,198,250,134,60,169,218,62,62,164,196,46,188,184,4,96,61,168,200,1,62,40,73,87,60,254,10,185,61,137,208,8,190,99,152,147,188,40,72,28,190,101,25,226,60,95,7,14,190,28,236,77,189,197,229,56,61,61,41,243,189,238,36,194,61,165,160,43,190,162,153,199,61,49,154,21,188,212,183,76,62,93,253,88,189,156,253,33,62,136,218,54,62,100,93,220,189,29,115,30,60,241,45,172,189,147,229,36,189,241,155,82,190,132,184,210,61,17,224,100,62,38,229,46,61,75,201,242,61,208,70,174,188,101,82,227,61,10,216,30,190,185,226,226,60,54,145,25,190,49,40,83,61,252,81,4,190,71,176,49,62,162,126,151,61,3,149,65,190,253,103,13,189,240,109,218,189,36,9,66,188,63,30,74,190,205,173,96,62,255,151,59,62,203,243,96,189,21,111,20,62,218,146,21,61,125,236,174,189,83,145,106,190,183,40,19,190,213,177,74,189,170,100,32,62,51,25,14,188,84,170,132,189,249,163,168,61,78,43,21,62,65,215,62,59,246,41,87,190,27,185,238,189,73,157,160,61,181,53,98,62,185,110,138,189,72,27,71,61,88,230,173,61,234,148,135,189,68,110,230,189,80,254,94,190,41,63,169,189,206,167,142,188,151,202,107,62,131,221,144,189,72,81,135,61,18,108,92,62,195,186,145,61,102,160,178,189,177,22,79,190,183,67,67,188,41,231,203,61,192,232,50,62,43,193,130,189,175,235,247,189,145,99,107,60,222,228,7,62,91,206,165,187,255,121,122,190,113,1,56,190,45,236,9,190,183,95,190,60,51,192,69,190,18,165,157,189,32,96,173,188,125,4,254,186,237,186,39,190,21,57,228,189,35,105,87,190,120,94,42,190,54,90,14,61,9,110,36,60,72,139,179,188,237,74,139,61,245,244,177,189,218,228,128,190,163,202,136,190,235,30,25,61,56,245,129,59,191,129,9,61,100,36,27,190,65,97,208,60,219,247,168,188,175,237,157,190,112,176,175,190,98,244,188,189,79,33,215,188,198,51,232,188,124,154,19,61,95,13,16,61,201,147,4,62,157,70,250,61,127,75,128,60,6,157,144,189,169,49,193,189,216,71,135,189,166,70,40,189,43,247,34,62,126,225,149,61,192,94,225,61,135,168,50,62,164,226,159,61,112,207,115,188,249,248,4,60,144,106,88,60,234,90,155,61,173,76,72,62,51,112,128,61,254,43,139,61,174,154,103,61,15,154,29,190,166,38,17,190,24,149,148,189,106,79,9,61,65,14,202,188,246,182,9,62,153,242,161,61,122,196,8,62,196,148,104,62,251,229,147,60,15,123,161,59,206,56,45,62,105,110,133,61,159,200,147,61,71,202,6,62,130,58,197,61,24,93,94,61,191,156,217,61,47,196,234,61,50,202,243,61,38,228,3,63,7,94,125,62,201,233,75,62,65,11,89,62,144,158,2,62,210,224,150,190,63,145,71,190,56,192,76,189,193,225,229,189,35,18,5,188,11,96,202,187,3,178,23,61,148,21,227,189,30,253,127,190,169,23,28,62,125,64,112,62,41,5,29,62,57,213,178,62,77,220,46,63,57,242,32,62,54,174,255,61,209,7,203,61,209,231,131,61,146,92,126,190,254,12,31,190,85,18,217,188,55,26,192,188,180,233,72,61,224,218,233,189,9,196,235,59,157,17,53,190,114,252,192,190,49,121,187,62,171,65,56,190,123,18,24,190,92,4,198,59,16,33,46,62,248,109,200,61,92,62,210,189,21,87,133,190,65,215,126,62,60,161,23,61,46,228,241,189,189,26,160,61,195,212,70,62,94,102,88,62,182,186,188,62,233,240,184,62,33,34,5,62,220,215,193,61,127,218,104,62,214,84,54,190,211,18,235,189,129,152,4,188,60,160,108,62,36,9,66,188,181,136,200,189,175,205,166,190,187,72,17,62,50,57,245,61,14,245,107,190,95,121,240,189,12,201,233,189,45,64,27,61,54,90,238,61,8,6,96,62,143,168,208,189,159,146,115,61,247,59,244,61,221,40,50,60,171,208,0,189,77,102,60,61,98,158,245,61,69,42,140,62,36,151,159,62,221,9,134,62,3,124,71,62,17,254,173,62,30,50,117,62,213,91,131,61,45,235,158,61,106,190,202,61,148,250,18,62,79,8,61,62,241,160,25,61,230,231,102,62,25,230,196,61,41,232,22,190,45,210,84,190,145,239,50,190,196,237,176,189,166,129,31,189,39,104,35,62,75,59,181,189,85,161,129,186,216,127,221,61,68,23,212,188,142,234,148,189,169,247,212,60,179,235,222,187,158,237,177,189,177,249,56,188,149,212,137,190,152,221,211,189,208,208,255,189,170,67,238,189,161,218,16,62,171,207,85,62,54,33,45,61,137,178,135,62,164,55,4,63,45,208,94,62,163,92,154,188,135,108,160,190,90,103,44,190,87,10,65,61,148,77,185,61,22,250,224,189,171,176,153,188,157,185,87,62,126,2,144,62,122,140,50,189,186,221,11,189,129,122,115,190,73,20,10,190,235,112,148,189,89,165,212,189,34,26,29,61,79,3,158,62,87,147,23,62,9,223,59,189,127,217,253,189,175,235,87,190,144,16,133,189,179,183,20,189,1,105,63,189,246,8,181,188,53,38,196,61,228,159,209,62,104,92,120,61,123,133,133,189,153,73,84,61,105,56,229,60,17,111,29,188,64,252,12,190,33,149,194,189,67,4,156,188,93,136,53,62,54,228,31,60,227,168,188,189,129,235,138,188,153,18,9,190,182,134,242,189,84,59,3,189,207,158,203,187,213,35,173,189,58,3,131,61,158,209,150,189,248,166,41,62,241,47,226,61,181,194,52,61,22,190,62,61,182,72,90,61,81,48,99,189,11,38,126,60,214,111,190,62,38,172,109,62,26,162,138,188,241,242,212,61,158,235,187,189,130,143,193,59,79,30,86,62,30,54,33,62,226,0,250,60,249,47,128,62,90,69,127,61,182,103,22,61,126,229,193,61,80,197,141,60,198,54,41,188,11,209,161,189,79,120,137,60,82,68,230,189,193,28,125,61,146,65,46,61,153,215,1,190,47,110,35,188,44,125,104,189,24,39,62,61,149,98,71,190,157,190,14,190,210,139,26,189,222,199,33,62,202,53,133,188,78,156,252,61,181,24,108,62,49,153,170,61,132,72,134,188,135,252,115,61,213,91,131,188,144,164,132,189,253,130,109,62,90,99,32,62,212,186,13,61,130,31,21,62,235,57,41,61,146,116,13,61,213,145,163,60,51,168,182,189,84,25,70,188,111,159,157,62,141,122,88,62,164,139,205,188,150,206,23,190,61,125,4,190,42,31,130,61,187,127,140,189,167,36,139,189,54,201,15,189,88,228,87,62,209,174,130,61,105,138,128,61,185,23,184,189,98,76,250,188,243,85,114,60,29,146,90,189,12,231,26,189,255,91,73,190,210,109,9,60,128,70,169,189,70,125,18,62,77,134,131,61,174,240,142,61,253,159,67,62,60,80,199,61,57,240,234,188,226,57,155,61,185,85,160,62,153,158,176,61,94,160,84,62,46,228,145,60,178,161,251,61,223,249,101,62,177,107,43,62,97,168,195,188,39,74,66,61,178,44,176,62,58,64,64,62,252,113,11,62,196,35,17,62,13,169,130,61,61,70,57,61,124,101,158,189,176,3,103,187,130,0,41,190,165,216,209,188,158,7,151,189,178,98,40,62,52,128,55,60,195,101,21,190,201,255,228,188,21,230,125,189,235,82,35,189,156,51,18,190,193,170,26,62,115,159,28,189,233,181,89,61,231,0,161,61,192,64,176,61,180,3,206,61,126,30,3,62,152,107,145,189,246,181,238,189,155,114,85,62,142,63,81,61,221,95,157,61,13,251,189,60,169,161,173,189,216,42,65,188,184,90,23,62,143,224,70,189,46,85,233,189,149,15,145,62,52,132,67,62,41,8,190,61,226,61,7,61,165,216,17,190,71,230,17,190,146,204,202,189,150,4,40,189,28,37,47,189,145,44,80,62,154,8,91,189,202,196,45,61,232,47,100,62,29,4,157,188,74,95,8,190,47,108,141,190,86,16,3,189,189,53,240,61,72,24,54,62,64,166,117,189,129,152,132,189,171,178,239,189,172,54,31,190,233,214,203,189,86,15,40,62,54,148,218,188,117,31,192,189,149,186,116,62,73,48,213,187,102,73,0,60,29,204,134,61,202,135,80,190,196,177,206,189,51,194,91,189,146,232,5,190,221,66,215,60,136,245,6,62,122,28,6,61,12,61,2,62,68,253,238,61,42,253,36,190,104,62,143,190,165,73,129,190,76,226,44,187,163,91,47,61,127,50,198,61,58,122,252,189,69,212,132,61,115,75,43,188,196,8,97,190,48,19,117,190,69,188,213,189,122,168,109,189,229,122,91,189,41,206,209,60,44,17,168,59,244,167,205,189,130,60,59,189,131,21,71,190,23,102,1,190,13,26,250,188,137,149,81,61,91,36,93,62,38,138,48,62,27,13,96,189,121,117,62,190,52,133,142,190,117,87,70,190,13,27,37,189,231,198,116,59,124,155,254,187,238,10,253,61,73,190,66,62,84,87,158,189,252,112,240,61,120,13,90,62,189,58,71,60,106,250,236,56,67,229,223,60,218,170,36,61,62,94,8,61,91,180,96,62,28,152,60,62,100,201,132,62,101,86,159,62,103,14,169,61,147,24,68,189,24,153,160,189,254,15,48,60,173,52,169,61,108,181,159,62,103,126,157,62,99,42,125,59,138,89,175,60,166,43,216,188,117,85,160,188,149,155,168,60,34,28,115,189,34,110,206,60,155,203,133,62,113,198,176,61,140,15,19,62,195,187,220,61,36,151,127,59,37,235,64,190,60,244,29,189,31,46,217,189,95,40,0,190,241,45,44,188,32,69,93,61,237,240,119,62,3,237,142,62,23,184,92,62,84,169,177,62,225,183,225,62,158,38,115,62,17,198,111,62,88,113,154,62,185,251,44,62,205,91,85,190,113,228,1,190,143,25,40,60,73,216,247,61,9,249,128,189,37,119,88,189,93,50,78,61,36,71,122,189,84,112,136,190,85,132,219,61,24,150,15,62,174,100,143,62,48,102,147,62,207,19,191,62,251,59,27,62,45,181,94,60,21,200,236,61,242,119,111,60,75,60,144,190,161,76,115,190,155,61,240,189,57,155,14,184,79,5,12,190,80,252,72,190,83,5,195,189,68,81,0,190,95,67,128,190,191,124,114,62,128,14,147,189,195,70,25,189,210,140,69,61,59,168,164,62,126,81,130,61,112,237,196,60,84,168,238,188,207,134,108,62,126,114,36,62,61,15,30,190,170,102,86,188,209,177,163,189,225,237,193,61,138,61,36,62,147,144,56,62,1,193,92,61,188,90,206,61,113,199,147,62,43,110,28,61,120,13,58,62,194,49,107,62,112,93,225,62,98,216,129,61,189,141,205,59,20,237,170,60,110,105,173,62,106,50,131,62,204,236,51,189,155,200,236,61,180,1,88,59,226,35,50,62,22,163,174,60,130,172,39,189,159,146,243,189,211,193,58,62,137,149,113,62,217,10,90,189,220,160,118,188,249,246,206,189,36,66,195,61,197,89,81,61,7,183,37,62,66,150,5,61,235,82,35,62,88,57,148,61,114,135,205,60,42,139,194,60,20,206,238,60,162,39,37,62,156,21,241,189,4,61,20,189,212,16,53,190,231,228,37,190,160,250,103,62,244,106,160,189,155,115,48,61,115,16,244,189,238,178,95,61,116,152,207,189,18,46,132,189,129,36,236,189,1,106,10,62,192,5,153,62,174,211,200,61,7,38,183,61,101,169,245,187,173,20,226,61,79,32,236,188,41,174,170,60,203,191,22,189,190,107,0,62,44,183,68,62,223,107,72,189,125,62,74,59,92,255,46,188,68,251,152,61,252,57,133,188,174,188,196,61,136,218,118,61,231,115,238,187,116,122,14,62,246,35,165,189,62,7,22,61,45,63,176,61,129,37,7,62,39,135,175,61,11,68,207,60,47,133,103,62,231,110,71,62,145,210,44,61,98,162,33,190,89,22,140,189,69,216,16,190,195,185,230,189,204,69,156,189,112,124,141,189,229,38,234,189,255,231,208,189,154,93,7,62,81,77,137,189,165,103,218,61,56,189,75,62,27,188,47,62,45,64,43,62,120,40,10,189,77,45,219,188,125,65,171,61,200,11,25,62,109,111,55,187,61,185,166,185,168,143,64,60,208,240,134,61,61,10,183,189,219,51,75,189,10,248,101,62,194,190,93,62,177,251,14,189,67,60,146,188,215,132,180,189,56,190,246,59,209,8,118,62,149,14,150,61,14,77,89,60,223,135,51,62,149,243,69,60,103,127,192,61,91,97,122,60,251,201,216,61,220,41,221,61,143,84,159,61,174,242,196,189,255,8,163,189,114,22,54,62,53,207,17,62,97,140,8,61,229,242,159,189,74,38,167,189,187,123,64,189,87,206,14,62,119,17,166,60,214,59,252,189,183,121,51,62,3,124,215,61,196,208,106,61,158,179,165,61,144,162,78,188,103,210,198,189,19,15,168,61,10,19,198,189,3,233,130,189,174,186,78,62,243,61,3,62,163,145,15,189,117,0,4,189,118,140,139,189,216,100,237,189,78,185,194,61,112,36,176,189,252,83,138,189,243,29,252,60,5,253,5,61,154,36,182,61,109,143,94,61,114,23,33,189,94,132,233,189,201,202,47,62,141,8,230,189,152,222,94,190,61,128,133,61,100,172,118,61,67,201,68,62,219,167,99,61,234,64,6,190,87,205,19,190,183,93,104,61,237,40,14,189,74,38,167,189,143,139,10,190,216,244,32,186,37,144,178,61,143,111,111,60,4,171,138,61,13,140,220,61,223,50,103,62,118,197,172,61,34,252,11,188,231,141,83,61,147,30,70,189,54,148,26,189,13,171,120,189,187,238,45,59,69,187,138,60,167,59,175,61,165,192,130,188,162,209,157,188,27,241,228,61,250,125,127,61,18,222,78,62,181,110,67,61,223,25,45,61,67,199,142,61,47,190,120,62,62,117,172,60,117,30,149,189,126,169,31,190,79,144,216,188,83,231,17,61,10,104,162,189,183,210,235,188,161,244,69,189,161,128,173,61,1,19,120,189,31,133,171,189,71,3,40,190,21,225,38,189,150,147,176,189,55,51,122,60,81,134,170,187,32,98,131,188,143,169,59,61,213,146,78,189,3,8,159,189,216,214,239,61,117,119,29,60,123,49,20,188,159,117,13,188,205,206,98,189,254,15,176,189,117,177,233,60,219,50,96,189,134,31,44,190,36,15,52,62,237,211,145,61,20,91,193,188,95,68,27,61,113,116,149,187,240,106,185,188,27,155,253,61,247,120,193,61,21,87,149,189,115,217,8,190,121,230,101,188,27,46,18,190,2,45,221,188,223,49,76,190,7,98,89,60,206,111,104,62,57,69,71,61,122,23,47,190,166,96,77,189,30,27,1,60,226,117,125,61,119,73,156,60,216,126,50,189,164,55,28,189,174,12,10,62,209,148,93,61,154,66,167,189,5,21,53,62,195,71,68,61,112,94,28,189,134,118,78,61,182,129,219,189,74,153,20,189,239,172,221,60,193,26,167,61,192,207,56,187,188,91,185,61,109,141,8,189,185,0,116,189,115,156,91,60,102,131,204,189,137,67,150,61,35,132,175,62,34,84,201,61,39,136,26,190,230,146,170,188,228,78,105,189,57,125,61,61,212,209,49,189,160,253,24,190,26,52,4,190,184,145,50,188,192,32,105,188,141,68,56,190,157,131,231,189,245,158,74,189,174,43,134,189,244,222,184,61,233,71,67,188,155,232,179,61,177,48,196,61,81,162,21,62,35,19,208,61,17,225,159,61,165,190,172,189,217,205,204,189,15,240,164,188,2,126,77,189,163,115,126,61,156,220,111,60,200,209,156,60,29,174,21,61,36,68,57,62,152,251,100,188,169,189,136,189,85,222,142,186,214,55,144,189,121,144,158,187,222,33,197,186,12,62,13,61,175,33,56,189,31,45,78,189,215,135,181,189,13,250,50,190,102,188,237,189,109,112,82,190,158,96,127,60,242,119,47,189,127,104,198,189,42,142,19,190,210,229,77,189,228,132,73,190,105,138,224,61,98,246,138,62,205,230,49,62,206,83,221,61,5,49,32,62,104,121,254,61,208,38,199,61,240,107,116,62,66,233,171,61,113,114,223,61,135,80,101,62,222,204,136,62,130,86,224,60,94,130,211,60,90,18,0,62,181,249,191,61,48,73,37,61,56,74,30,61,125,145,80,188,64,133,19,62,45,206,88,61,141,183,21,188,97,109,172,61,88,30,36,62,101,111,41,189,33,206,67,60,174,184,248,189,88,140,218,189,145,212,66,189,223,138,68,61,184,172,130,190,181,226,155,189,92,27,202,61,29,119,26,190,27,161,47,190,33,89,32,190,125,236,110,61,42,254,63,62,24,119,211,62,80,228,13,63,129,150,190,62,84,167,115,62,21,31,255,61,81,250,226,61,155,29,41,60,25,170,50,190,6,128,138,189,28,178,1,187,201,87,18,62,10,73,38,61,1,20,163,60,91,176,212,60,47,134,50,189,87,66,247,189,197,171,204,61,36,125,186,61,12,62,125,62,159,32,81,62,197,29,47,189,172,115,140,189,82,183,243,189,25,232,218,60,5,194,14,61,238,149,121,189,12,62,205,188,106,132,190,189,59,226,16,189,87,206,110,190,112,67,76,189,205,92,32,189,115,130,182,188,243,229,133,189,67,5,17,193,56,1,1,0,211,0,2,32,138,0,3,64,81,0,4,80,39,0,5,112,22,0,6,48,13,0,7,16,10,0,8,96,9,0,173,130,172,2,173,242,172,2,11,208,172,2,12,224,172,2,173,242,172,2,14,128,172,2,15,144,172,2,16,160,17,0,173,98,172,2,18,176,172,2,19,192,172,2,20,208,172,2,21,224,172,2,173,242,172,2,23,160,172,2,24,176,172,2,25,192,35,0,26,128,31,0,27,144,28,0,173,98,172,2,29,208,172,2,30,224,172,2,173,242,172,2,32,16,172,2,33,208,172,2,34,224,172,2,173,242,172,2,36,16,172,2,37,208,172,2,38,224,172,2,173,242,65,16,40,112,56,0,41,224,172,2,42,240,50,0,43,16,46,0,44,48,45,0,173,98,172,2,173,210,172,2,47,160,172,2,48,176,172,2,49,192,172,2,173,210,172,2,51,128,172,2,52,144,172,2,53,160,172,2,54,176,172,2,55,192,172,2,173,210,172,18,57,224,172,18,58,128,172,18,59,144,172,18,60,160,172,18,61,176,172,18,62,192,172,18,63,208,64,16,173,98,172,18,173,242,172,2,66,224,172,2,67,240,75,0,68,16,71,0,69,48,70,0,173,98,172,2,173,210,172,2,72,160,172,2,73,176,172,2,74,192,172,2,173,210,172,2,76,128,172,2,77,144,172,2,78,160,172,2,79,176,172,2,80,192,172,2,173,210,110,16,82,80,100,0,83,192,172,2,84,208,172,2,85,224,94,0,86,240,90,0,87,16,88,0,173,50,172,2,89,160,172,2,173,178,172,2,91,128,172,2,92,144,172,2,93,160,172,2,173,178,172,2,95,96,172,2,96,112,172,2,97,128,172,2,98,144,172,2,99,160,172,2,173,178,172,18,101,192,172,18,102,112,172,18,103,128,172,18,104,144,172,18,105,160,172,18,106,176,172,18,107,208,108,16,173,98,172,18,109,224,172,18,173,242,128,0,111,192,172,2,112,208,172,2,113,224,122,0,114,240,118,0,115,16,116,0,173,50,172,2,117,160,172,2,173,178,172,2,119,128,172,2,120,144,172,2,121,160,172,2,173,178,172,2,123,96,172,2,124,112,172,2,125,128,172,2,126,144,172,2,127,160,172,2,173,178,172,18,129,192,172,18,130,112,172,18,131,128,172,18,132,144,172,18,133,160,172,18,134,176,172,18,135,208,172,18,136,224,137,16,173,98,172,18,173,242,177,16,139,64,161,0,140,176,172,2,141,192,172,2,142,208,157,0,143,160,152,0,144,224,148,0,145,240,146,0,173,18,172,2,147,128,172,2,173,146,172,2,149,96,172,2,150,112,172,2,151,128,172,2,173,146,172,2,153,80,172,2,154,96,172,2,155,112,172,2,156,128,172,2,173,146,172,2,158,16,172,2,159,48,172,2,160,224,172,2,173,242,172,18,162,176,172,18,163,112,172,18,164,128,172,18,165,144,172,18,166,160,173,16,167,96,170,16,168,80,169,16,173,50,172,18,173,194,172,18,171,192,172,18,172,208,172,18,173,226,172,18,174,192,172,18,175,208,172,18,176,224,172,18,173,242,199,0,178,176,172,2,179,192,172,2,180,208,195,0,181,160,190,0,182,224,186,0,183,240,184,0,173,18,172,2,185,128,172,2,173,146,172,2,187,96,172,2,188,112,172,2,189,128,172,2,173,146,172,2,191,80,172,2,192,96,172,2,193,112,172,2,194,128,172,2,173,146,172,2,196,16,172,2,197,48,172,2,198,224,172,2,173,242,172,18,200,176,172,18,201,112,172,18,202,128,172,18,203,144,172,18,204,160,172,18,205,192,172,18,206,208,209,16,207,96,208,16,173,82,172,18,173,226,172,18,210,224,172,18,173,242,10,17,212,32,239,0,213,144,172,2,214,160,172,2,215,176,234,0,216,128,229,0,217,192,225,0,218,208,222,0,219,224,220,0,173,242,172,2,221,96,172,2,173,114,172,2,223,80,172,2,224,96,172,2,173,114,172,2,226,64,172,2,227,80,172,2,228,96,172,2,173,114,172,2,230,48,172,2,231,64,172,2,232,80,172,2,233,96,172,2,173,114,172,2,235,16,172,2,236,192,172,2,237,208,172,2,238,224,172,2,173,242,172,18,240,144,172,18,241,112,172,18,242,128,4,17,243,96,255,16,244,80,251,16,245,64,248,16,246,48,247,16,173,18,172,18,173,162,172,18,249,160,172,18,250,176,172,18,173,194,172,18,252,160,172,18,253,176,172,18,254,192,172,18,173,210,172,18,0,161,172,18,1,177,172,18,2,193,172,18,3,209,172,18,173,226,172,18,5,161,172,18,6,177,172,18,7,193,172,18,8,209,172,18,9,225,172,18,173,242,37,1,11,145,172,2,12,161,172,2,13,177,32,1,14,129,27,1,15,193,23,1,16,209,20,1,17,225,18,1,173,242,172,2,19,97,172,2,173,114,172,2,21,81,172,2,22,97,172,2,173,114,172,2,24,65,172,2,25,81,172,2,26,97,172,2,173,114,172,2,28,49,172,2,29,65,172,2,30,81,172,2,31,97,172,2,173,114,172,2,33,17,172,2,34,193,172,2,35,209,172,2,36,225,172,2,173,242,172,18,38,145,172,18,39,113,172,18,40,129,172,18,41,161,172,18,42,177,52,17,43,97,49,17,44,81,47,17,45,65,46,17,173,50,172,18,173,194,172,18,48,193,172,18,173,210,172,18,50,193,172,18,51,209,172,18,173,226,172,18,53,193,172,18,54,209,172,18,55,225,172,18,173,242,112,18,57,1,112,1,58,33,85,1,59,145,172,2,60,113,172,2,61,129,79,1,62,97,74,1,63,81,70,1,64,65,67,1,65,49,66,1,173,18,172,2,173,162,172,2,68,161,172,2,69,177,172,2,173,194,172,2,71,161,172,2,72,177,172,2,73,193,172,2,173,210,172,2,75,161,172,2,76,177,172,2,77,193,172,2,78,209,172,2,173,226,172,2,80,161,172,2,81,177,172,2,82,193,172,2,83,209,172,2,84,225,172,2,173,242,172,18,86,145,172,18,87,161,172,18,88,177,107,17,89,129,102,17,90,193,98,17,91,209,95,17,92,225,93,17,173,242,172,18,94,97,172,18,173,114,172,18,96,81,172,18,97,97,172,18,173,114,172,18,99,65,172,18,100,81,172,18,101,97,172,18,173,114,172,18,103,49,172,18,104,65,172,18,105,81,172,18,106,97,172,18,173,114,172,18,108,17,172,18,109,193,172,18,110,209,172,18,111,225,172,18,173,242,66,18,113,33,152,1,114,65,130,1,115,177,172,2,116,113,172,2,117,129,172,2,118,145,172,2,119,161,126,1,120,97,123,1,121,81,122,1,173,50,172,2,173,194,172,2,124,193,172,2,125,209,172,2,173,226,172,2,127,193,172,2,128,209,172,2,129,225,172,2,173,242,172,18,131,177,172,18,132,193,172,18,133,209,148,17,134,161,143,17,135,225,139,17,136,241,137,17,173,18,172,18,138,129,172,18,173,146,172,18,140,97,172,18,141,113,172,18,142,129,172,18,173,146,172,18,144,81,172,18,145,97,172,18,146,113,172,18,147,129,172,18,173,146,172,18,149,17,172,18,150,49,172,18,151,225,172,18,173,242,32,18,153,65,182,1,154,81,164,1,155,193,172,2,156,113,172,2,157,129,172,2,158,145,172,2,159,161,172,2,160,177,172,2,161,209,162,1,173,98,172,2,163,225,172,2,173,242,172,18,165,193,172,18,166,209,172,18,167,225,176,17,168,241,172,17,169,17,170,17,173,50,172,18,171,161,172,18,173,178,172,18,173,129,172,18,174,145,172,18,175,161,172,18,173,178,172,18,177,97,172,18,178,113,172,18,179,129,172,18,180,145,172,18,181,161,172,18,173,178,4,18,183,81,209,1,184,113,193,1,185,225,172,2,186,129,172,2,187,145,172,2,188,161,172,2,189,177,172,2,190,193,172,2,191,209,192,1,173,98,172,2,173,242,172,18,194,225,172,18,195,241,203,17,196,17,199,17,197,49,198,17,173,98,172,18,173,210,172,18,200,161,172,18,201,177,172,18,202,193,172,18,173,210,172,18,204,129,172,18,205,145,172,18,206,161,172,18,207,177,172,18,208,193,172,18,173,210,244,17,210,113,227,17,211,49,218,17,212,17,215,17,213,97,214,17,173,130,172,18,173,242,172,18,216,209,172,18,217,225,172,18,173,242,172,18,219,129,172,18,220,145,172,18,221,161,222,17,173,98,172,18,223,177,172,18,224,193,172,18,225,209,172,18,226,225,172,18,173,242,172,18,228,161,172,18,229,177,172,18,230,193,240,17,231,129,236,17,232,145,233,17,173,98,172,18,234,209,172,18,235,225,172,18,173,242,172,18,237,17,172,18,238,209,172,18,239,225,172,18,173,242,172,18,241,17,172,18,242,209,172,18,243,225,172,18,173,242,172,18,245,225,172,18,246,241,254,17,247,17,250,17,248,49,249,17,173,98,172,18,173,210,172,18,251,161,172,18,252,177,172,18,253,193,172,18,173,210,172,18,255,129,172,18,0,146,172,18,1,162,172,18,2,178,172,18,3,194,172,18,173,210,14,2,5,194,172,2,6,114,172,2,7,130,172,2,8,146,172,2,9,162,172,2,10,178,172,2,11,210,172,2,12,226,13,2,173,98,172,2,173,242,172,18,15,194,172,18,16,210,172,18,17,226,26,18,18,242,22,18,19,18,20,18,173,50,172,18,21,162,172,18,173,178,172,18,23,130,172,18,24,146,172,18,25,162,172,18,173,178,172,18,27,98,172,18,28,114,172,18,29,130,172,18,30,146,172,18,31,162,172,18,173,178,44,2,33,178,172,2,34,114,172,2,35,130,172,2,36,146,172,2,37,162,172,2,38,194,172,2,39,210,42,2,40,98,41,2,173,82,172,2,173,226,172,2,43,226,172,2,173,242,172,18,45,178,172,18,46,194,172,18,47,210,62,18,48,162,57,18,49,226,53,18,50,242,51,18,173,18,172,18,52,130,172,18,173,146,172,18,54,98,172,18,55,114,172,18,56,130,172,18,173,146,172,18,58,82,172,18,59,98,172,18,60,114,172,18,61,130,172,18,173,146,172,18,63,18,172,18,64,50,172,18,65,226,172,18,173,242,85,2,67,146,172,2,68,114,172,2,69,130,172,2,70,162,172,2,71,178,81,2,72,98,78,2,73,82,76,2,74,66,75,2,173,50,172,2,173,194,172,2,77,194,172,2,173,210,172,2,79,194,172,2,80,210,172,2,173,226,172,2,82,194,172,2,83,210,172,2,84,226,172,2,173,242,172,18,86,146,172,18,87,162,172,18,88,178,107,18,89,130,102,18,90,194,98,18,91,210,95,18,92,226,93,18,173,242,172,18,94,98,172,18,173,114,172,18,96,82,172,18,97,98,172,18,173,114,172,18,99,66,172,18,100,82,172,18,101,98,172,18,173,114,172,18,103,50,172,18,104,66,172,18,105,82,172,18,106,98,172,18,173,114,172,18,108,18,172,18,109,194,172,18,110,210,172,18,111,226,172,18,173,242,142,2,113,114,172,2,114,130,172,2,115,146,136,2,116,98,131,2,117,82,127,2,118,66,124,2,119,50,122,2,120,34,121,2,173,18,172,2,173,162,172,2,123,162,172,2,173,178,172,2,125,162,172,2,126,178,172,2,173,194,172,2,128,162,172,2,129,178,172,2,130,194,172,2,173,210,172,2,132,162,172,2,133,178,172,2,134,194,172,2,135,210,172,2,173,226,172,2,137,162,172,2,138,178,172,2,139,194,172,2,140,210,172,2,141,226,172,2,173,242,172,18,143,114,172,18,144,130,172,18,145,146,166,18,146,98,161,18,147,82,157,18,148,66,154,18,149,50,152,18,150,34,151,18,173,18,172,18,173,162,172,18,153,162,172,18,173,178,172,18,155,162,172,18,156,178,172,18,173,194,172,18,158,162,172,18,159,178,172,18,160,194,172,18,173,210,172,18,162,162,172,18,163,178,172,18,164,194,172,18,165,210,172,18,173,226,172,18,167,162,172,18,168,178,172,18,169,194,172,18,170,210,172,18,171,226,172,18,173,242,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,146,0,1,0,101,0,2,32,49,0,3,80,38,0,4,144,28,0,5,112,21,0,6,16,15,0,7,96,11,0,8,48,9,0,64,65,63,1,10,160,63,1,64,177,63,1,12,128,63,1,13,160,14,0,64,65,63,1,64,177,63,1,16,176,19,0,17,48,18,0,64,65,63,1,64,161,63,1,20,128,63,1,64,161,63,1,22,96,63,1,23,128,26,0,24,64,25,0,64,49,63,1,64,161,63,1,27,160,63,1,64,177,63,1,29,16,35,0,30,176,33,0,31,48,32,0,64,65,63,1,64,161,63,1,34,128,63,1,64,161,63,1,36,96,63,1,37,48,63,1,64,65,63,1,39,48,63,1,40,64,46,0,41,112,44,0,42,16,43,0,64,97,63,1,64,177,63,1,45,96,63,1,64,129,63,1,47,16,48,0,64,97,63,1,64,177,89,16,50,112,80,16,51,144,75,16,52,80,68,0,53,16,61,0,54,64,57,0,55,160,63,1,56,48,63,1,64,177,63,17,58,96,63,17,59,128,63,17,60,176,63,17,64,161,63,17,62,96,63,17,63,128,66,16,64,160,65,16,64,65,63,17,64,177,63,17,67,48,63,17,64,65,63,17,69,96,63,17,70,128,73,16,71,64,72,16,64,49,63,17,64,161,63,17,74,160,63,17,64,177,63,1,76,16,63,1,77,48,63,1,78,64,63,1,79,160,63,1,64,177,63,1,81,160,63,1,82,176,86,0,83,144,63,1,84,16,85,0,64,49,63,1,64,129,63,1,87,16,63,1,88,48,63,1,64,65,63,1,90,160,63,1,91,176,98,0,92,144,95,0,93,16,94,0,64,49,63,1,64,129,63,1,96,96,63,1,97,128,63,1,64,113,63,1,99,16,63,1,100,48,63,1,64,65,123,0,102,112,63,1,103,144,63,1,104,128,119,0,105,80,113,0,106,16,110,0,107,160,108,0,64,177,63,1,109,96,63,1,64,65,63,1,111,96,63,1,112,48,63,1,64,65,63,1,114,96,117,0,115,64,116,0,64,49,63,1,64,161,63,1,118,160,63,1,64,177,63,1,120,160,63,1,121,176,122,0,64,17,63,1,64,97,63,17,124,112,63,17,125,80,138,16,126,32,63,17,127,96,134,16,128,64,131,16,129,48,130,16,64,17,63,17,64,129,63,17,132,144,63,17,133,128,63,17,64,161,63,17,135,144,63,17,136,128,63,17,137,160,63,17,64,177,63,17,139,144,63,17,140,96,63,17,141,128,144,16,142,64,143,16,64,49,63,17,64,161,63,17,145,160,63,17,64,177,19,17,147,0,230,16,148,32,200,16,149,176,185,16,150,48,169,16,151,80,163,16,152,144,160,16,153,112,156,16,154,16,155,16,64,65,63,17,64,161,63,17,157,96,63,17,158,128,159,16,64,65,63,17,64,161,63,17,161,16,162,16,64,65,63,17,64,161,63,17,164,64,168,16,165,112,166,16,64,17,63,17,167,96,63,17,64,129,63,17,64,17,178,16,170,160,176,16,171,144,175,16,172,112,173,16,64,17,63,17,174,96,63,17,64,129,63,17,64,17,63,17,177,16,63,17,64,65,63,1,179,112,63,1,180,144,63,1,181,80,63,1,182,64,63,1,183,96,63,1,184,128,63,1,64,161,192,16,186,144,63,17,187,128,63,17,188,160,191,16,189,112,190,16,64,17,63,17,64,97,63,17,64,17,63,1,193,80,63,1,194,112,63,1,195,144,63,1,196,64,63,1,197,96,63,1,198,128,199,0,64,49,63,1,64,161,220,16,201,64,213,16,202,80,210,16,203,112,63,17,204,96,207,16,205,48,206,16,64,17,63,17,64,129,63,17,208,144,63,17,209,128,63,17,64,161,63,17,211,16,63,17,212,96,63,17,64,49,63,1,214,112,63,1,215,144,63,1,216,80,63,1,217,96,63,1,218,128,63,1,219,160,63,1,64,177,63,1,221,80,63,1,222,112,63,1,223,144,63,1,224,96,63,1,225,128,228,0,226,160,227,0,64,65,61,1,64,177,63,1,229,48,63,1,64,65,253,0,231,112,63,1,232,80,245,0,233,32,63,1,234,96,241,0,235,64,238,0,236,48,237,0,64,17,63,1,64,129,63,1,239,144,63,1,240,128,63,1,64,161,63,1,242,144,63,1,243,128,63,1,244,160,63,1,64,177,63,1,246,144,63,1,247,96,63,1,248,128,251,0,249,64,250,0,64,49,63,1,64,161,63,1,252,160,63,1,64,177,63,17,254,112,63,17,255,144,63,17,0,129,15,17,1,81,9,17,2,17,6,17,3,161,4,17,64,177,63,17,5,97,63,17,64,65,63,17,7,97,63,17,8,49,63,17,64,65,63,17,10,97,13,17,11,65,12,17,64,49,63,17,64,161,63,17,14,161,63,17,64,177,63,17,16,161,63,17,17,177,18,17,64,17,63,17,64,97,40,1,20,81,63,1,21,113,33,1,22,145,63,1,23,97,30,1,24,65,28,1,25,49,26,1,64,129,63,1,27,17,63,1,64,33,63,1,29,129,63,1,64,161,63,1,31,177,63,1,32,129,63,1,64,161,63,1,34,33,63,1,35,49,63,1,36,65,38,1,37,17,63,1,64,97,63,1,39,97,63,1,64,129,61,17,41,81,63,17,42,113,54,17,43,145,63,17,44,97,51,17,45,65,49,17,46,49,47,17,64,129,63,17,48,17,63,17,64,33,63,17,50,129,63,17,64,161,63,17,52,177,63,17,53,129,63,17,64,161,63,17,55,33,63,17,56,49,63,17,57,65,59,17,58,17,63,17,64,97,63,17,60,97,63,17,64,129,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,181,0,1,0,54,0,2,80,37,0,3,32,29,0,4,144,21,0,5,16,15,0,6,96,10,0,7,48,8,0,137,65,136,1,9,160,136,1,137,177,136,1,11,128,136,1,12,160,13,0,137,177,136,1,14,64,136,1,137,113,136,1,16,176,19,0,17,48,18,0,137,65,136,1,137,161,136,1,20,128,136,1,137,161,136,1,22,96,136,1,23,112],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+112640);allocate([136,1,24,128,27,0,25,64,26,0,137,49,136,1,137,161,136,1,28,160,136,1,137,177,136,1,30,48,136,1,31,64,34,0,32,16,33,0,137,97,136,1,137,177,136,1,35,96,136,1,36,112,136,1,137,129,136,1,38,144,136,1,39,112,136,1,40,128,48,0,41,16,45,0,42,160,43,0,137,177,136,1,44,96,136,1,137,65,136,1,46,96,136,1,47,48,136,1,137,65,136,1,49,96,52,0,50,64,51,0,137,49,136,1,137,161,136,1,53,160,136,1,137,177,161,16,55,80,107,0,56,144,91,16,57,48,83,16,58,64,77,0,59,176,68,0,60,16,64,0,61,128,136,1,62,160,63,0,137,33,136,1,137,113,136,17,65,96,136,17,66,32,136,17,67,112,136,17,137,129,72,0,69,96,136,1,70,112,136,1,71,128,136,1,137,161,136,17,73,96,136,17,74,32,136,17,75,112,76,16,137,17,136,17,137,129,136,17,78,32,136,17,79,112,81,16,80,16,136,17,137,97,136,17,82,96,136,17,137,129,136,1,84,176,136,1,85,128,136,1,86,160,89,0,87,16,88,0,137,33,136,1,137,113,136,1,90,96,136,1,137,113,136,1,92,176,136,1,93,160,101,0,94,48,98,0,95,16,96,0,137,33,136,1,97,112,136,1,137,129,136,1,99,96,136,1,100,112,136,1,137,129,136,1,102,128,105,0,103,16,104,0,137,33,136,1,137,113,136,1,106,96,136,1,137,113,147,16,108,144,135,0,109,32,127,0,110,16,119,0,111,64,114,0,112,160,136,1,113,48,136,1,137,177,136,17,115,96,136,17,116,112,136,17,117,128,136,17,118,176,136,17,137,161,136,17,120,96,136,17,121,112,136,17,122,128,125,16,123,160,124,16,137,65,136,17,137,177,136,17,126,48,136,17,137,65,136,17,128,96,136,17,129,112,136,17,130,128,133,16,131,64,132,16,137,49,136,17,137,161,136,17,134,160,136,17,137,177,136,17,136,96,136,17,137,112,143,16,138,128,141,16,139,64,140,16,137,49,136,17,137,161,136,17,142,160,136,17,137,177,136,17,144,32,136,17,145,16,136,17,146,48,136,17,137,65,153,0,148,32,136,1,149,16,136,1,150,48,136,1,151,64,136,1,152,160,136,1,137,177,134,17,154,32,136,17,155,48,136,17,156,64,136,17,157,112,159,16,158,16,136,17,137,97,136,17,160,96,136,17,137,129,174,0,162,32,136,1,163,160,136,1,164,176,171,0,165,144,168,0,166,16,167,0,137,49,136,1,137,129,136,1,169,96,136,1,170,112,136,1,137,129,136,1,172,16,136,1,173,48,136,1,137,65,136,1,175,144,136,1,176,112,136,1,177,128,136,1,178,160,136,1,179,176,180,0,137,17,136,1,137,97,90,17,182,0,226,0,183,32,204,0,184,80,197,0,185,112,136,1,186,96,193,0,187,64,190,0,188,48,189,0,137,17,136,1,137,129,136,1,191,144,136,1,192,128,136,1,137,161,136,1,194,144,136,1,195,128,136,1,196,160,136,1,137,177,136,17,198,144,136,17,199,128,136,17,200,160,136,17,201,176,136,17,202,112,203,16,137,17,136,17,137,97,136,17,205,144,136,17,206,112,136,17,207,128,222,16,208,80,216,16,209,16,213,16,210,160,211,16,137,177,136,17,212,96,136,17,137,65,136,17,214,96,136,17,215,48,136,17,137,65,136,17,217,96,220,16,218,64,219,16,137,49,136,17,137,161,136,17,221,160,136,17,137,177,136,17,223,160,136,17,224,176,225,16,137,17,136,17,137,97,58,17,227,32,11,1,228,144,255,0,229,80,247,16,230,16,239,16,231,64,234,16,232,160,136,17,233,48,136,17,137,177,136,1,235,96,136,1,236,112,136,1,237,128,136,1,238,176,136,1,137,161,136,1,240,96,136,1,241,112,136,1,242,128,245,0,243,160,244,0,137,65,136,1,137,177,136,1,246,48,136,1,137,65,136,1,248,96,136,1,249,112,136,1,250,128,253,0,251,64,252,0,137,49,136,1,137,161,136,1,254,160,136,1,137,177,136,17,0,49,136,17,1,65,8,17,2,81,5,17,3,17,4,17,137,97,136,17,137,177,136,17,6,97,136,17,7,113,136,17,137,129,136,17,9,17,136,17,10,161,136,17,137,177,46,17,12,145,38,17,13,81,30,17,14,17,24,17,15,97,19,17,16,49,17,17,137,65,136,17,18,161,136,17,137,177,136,17,20,129,136,17,21,161,22,17,137,177,136,17,23,65,136,17,137,113,136,17,25,177,28,17,26,49,27,17,137,65,136,17,137,161,136,17,29,129,136,17,137,161,136,17,31,97,136,17,32,113,136,17,33,129,36,17,34,65,35,17,137,49,136,17,137,161,136,17,37,161,136,17,137,177,136,17,39,161,136,17,40,177,43,17,41,17,42,17,137,49,136,17,137,129,136,17,44,97,136,17,45,113,136,17,137,129,136,17,47,49,136,17,48,65,55,17,49,81,52,17,50,17,51,17,137,97,136,17,137,177,136,17,53,97,136,17,54,113,136,17,137,129,136,17,56,17,136,17,57,161,136,17,137,177,80,17,59,145,136,17,60,113,136,17,61,129,76,17,62,81,70,17,63,17,67,17,64,161,65,17,137,177,136,17,66,97,136,17,137,65,136,17,68,97,136,17,69,49,136,17,137,65,136,17,71,97,74,17,72,65,73,17,137,49,136,17,137,161,136,17,75,161,136,17,137,177,136,17,77,161,136,17,78,177,79,17,137,17,136,17,137,97,136,1,81,81,134,1,82,145,136,1,83,97,136,1,84,113,136,1,85,129,88,1,86,65,87,1,137,49,136,1,137,161,136,1,89,161,136,1,137,177,112,1,91,81,104,1,92,145,136,1,93,97,136,1,94,113,101,1,95,65,99,1,96,49,97,1,137,129,136,1,98,17,136,1,137,33,136,1,100,129,136,1,137,161,136,1,102,177,136,1,103,129,136,1,137,161,136,1,105,33,136,1,106,49,136,1,107,65,136,1,108,113,110,1,109,17,136,1,137,97,136,1,111,97,136,1,137,129,134,17,113,81,126,17,114,145,136,17,115,97,136,17,116,113,123,17,117,65,121,17,118,49,119,17,137,129,136,17,120,17,136,17,137,33,136,17,122,129,136,17,137,161,136,17,124,177,136,17,125,129,136,17,137,161,136,17,127,33,136,17,128,49,136,17,129,65,136,17,130,113,132,17,131,17,136,17,137,97,136,17,133,97,136,17,137,129,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,42,0,1,0,27,0,2,32,16,0,3,48,12,0,4,80,8,0,5,112,6,0,115,16,114,0,7,64,114,0,115,96,10,0,9,16,114,0,115,64,114,0,11,64,114,0,115,96,14,0,13,112,114,0,115,16,114,0,15,16,114,0,115,64,22,0,17,112,114,0,18,96,21,0,19,80,20,0,115,16,114,0,115,64,114,0,115,16,114,16,23,80,112,16,24,48,112,16,25,112,114,16,26,64,114,16,115,96,32,0,28,80,114,0,29,112,114,0,30,96,31,0,115,16,114,0,115,64,112,16,33,80,114,16,34,48,39,16,35,32,37,16,36,16,114,16,115,64,114,16,38,64,114,16,115,96,112,16,40,112,112,16,41,64,112,16,113,96,92,16,43,0,77,16,44,32,57,0,45,112,53,16,46,48,51,16,47,80,49,16,48,16,114,16,115,64,114,16,50,64,114,16,115,96,114,16,52,16,114,16,115,64,114,0,54,80,112,0,55,48,114,0,56,64,114,0,115,96,69,16,58,112,64,16,59,48,63,16,60,80,61,16,115,16,114,16,62,64,114,16,115,96,114,16,115,16,114,16,65,96,68,16,66,80,67,16,115,16,114,16,115,64,114,16,115,16,112,16,70,48,75,16,71,80,73,16,72,16,112,16,113,64,112,16,74,64,112,16,113,96,112,16,76,16,112,16,113,64,87,0,78,80,114,0,79,48,84,0,80,32,82,0,81,16,114,0,115,64,114,0,83,64,114,0,115,96,112,0,85,112,112,0,86,64,112,0,113,96,112,16,88,80,114,16,89,112,114,16,90,96,91,16,115,16,114,16,115,64,102,0,93,48,112,0,94,80,99,0,95,32,97,0,96,16,112,0,113,64,112,0,98,64,112,0,113,96,112,0,100,112,112,0,101,64,112,0,113,96,112,16,103,48,112,16,104,80,109,16,105,32,107,16,106,16,112,16,113,64,112,16,108,64,112,16,113,96,112,16,110,112,112,16,111,64,112,16,113,96,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,145,0,1,0,100,0,2,32,49,0,3,80,38,0,4,144,28,0,5,112,21,0,6,16,15,0,7,96,11,0,8,48,9,0,89,65,86,1,10,160,88,1,89,177,86,1,12,128,86,1,13,160,14,0,89,65,88,1,89,177,86,1,16,176,19,0,17,48,18,0,89,65,86,1,89,161,86,1,20,128,86,1,89,161,86,1,22,96,86,1,23,128,26,0,24,64,25,0,89,49,86,1,89,161,86,1,27,160,86,1,89,177,86,1,29,16,35,0,30,176,33,0,31,48,32,0,87,65,86,1,87,161,86,1,34,128,86,1,87,161,86,1,36,96,86,1,37,48,86,1,87,65,86,1,39,48,86,1,40,64,46,0,41,112,44,0,42,16,43,0,87,97,86,1,87,177,86,1,45,96,86,1,87,129,86,1,47,16,48,0,87,97,86,1,87,177,85,16,50,144,80,16,51,112,75,16,52,80,68,0,53,16,61,0,54,64,57,0,55,160,86,1,56,48,88,1,89,177,86,17,58,96,86,17,59,128,88,17,60,176,88,17,89,161,86,17,62,96,86,17,63,128,66,16,64,160,65,16,89,65,88,17,89,177,86,17,67,48,88,17,89,65,86,17,69,96,86,17,70,128,73,16,71,64,72,16,89,49,86,17,89,161,86,17,74,160,86,17,89,177,86,1,76,16,86,1,77,48,86,1,78,64,86,1,79,160,86,1,89,177,86,1,81,16,86,1,82,48,86,1,83,64,86,1,84,160,86,1,87,177,86,1,86,160,86,1,87,176,97,0,88,144,94,0,89,112,92,0,90,16,91,0,87,49,86,1,87,129,86,1,93,96,86,1,87,129,86,1,95,16,96,0,87,49,86,1,87,129,86,1,98,16,86,1,99,48,86,1,87,65,122,0,101,112,86,1,102,144,86,1,103,128,118,0,104,80,112,0,105,16,109,0,106,160,107,0,87,177,86,1,108,96,86,1,89,65,86,1,110,96,86,1,111,48,86,1,89,65,86,1,113,96,116,0,114,64,115,0,87,49,86,1,87,161,86,1,117,160,86,1,87,177,86,1,119,160,86,1,120,176,121,0,87,17,86,1,87,97,86,17,123,112,86,17,124,80,137,16,125,32,86,17,126,96,133,16,127,64,130,16,128,48,129,16,87,17,86,17,87,129,86,17,131,144,86,17,132,128,86,17,89,161,86,17,134,144,86,17,135,128,86,17,136,160,86,17,89,177,86,17,138,144,86,17,139,96,86,17,140,128,143,16,141,64,142,16,87,49,86,17,87,161,86,17,144,160,86,17,87,177,44,17,146,0,255,16,147,32,194,16,148,144,183,16,149,80,173,16,150,112,166,16,151,16,160,16,152,96,156,16,153,48,154,16,89,65,86,17,155,160,88,17,89,177,86,17,157,128,86,17,158,160,159,16,89,65,88,17,89,177,86,17,161,176,164,16,162,48,163,16,89,65,86,17,89,161,86,17,165,128,86,17,89,161,86,17,167,96,86,17,168,128,171,16,169,64,170,16,89,49,86,17,89,161,86,17,172,160,86,17,89,177,86,17,174,16,180,16,175,176,178,16,176,48,177,16,87,65,86,17,87,161,86,17,179,128,86,17,87,161,86,17,181,96,86,17,182,48,86,17,87,65,86,17,184,160,86,17,185,176,191,16,186,112,189,16,187,16,188,16,87,49,86,17,87,129,86,17,190,96,86,17,87,129,86,17,192,16,193,16,87,49,86,17,87,129,240,0,195,144,225,0,196,80,220,0,197,112,213,16,198,16,206,16,199,64,202,16,200,160,86,17,201,48,88,17,89,177,86,1,203,96,86,1,204,128,88,1,205,176,88,1,89,161,86,1,207,96,86,1,208,128,211,0,209,160,210,0,89,65,88,1,89,177,86,1,212,48,88,1,89,65,86,1,214,96,86,1,215,128,218,0,216,64,217,0,89,49,86,1,89,161,86,1,219,160,86,1,89,177,86,17,221,16,86,17,222,48,86,17,223,64,86,17,224,160,86,17,89,177,86,17,226,48,86,17,227,64,237,16,228,80,234,16,229,112,232,16,230,16,231,16,89,97,86,17,89,177,86,17,233,96,86,17,89,129,86,17,235,16,236,16,87,97,86,17,87,177,86,17,238,16,86,17,239,160,86,17,87,177,86,17,241,48,86,17,242,64,252,16,243,80,249,16,244,112,247,16,245,16,246,16,87,97,86,17,87,177,86,17,248,96,86,17,87,129,86,17,250,16,251,16,87,97,86,17,87,177,86,17,253,16,86,17,254,160,86,17,87,177,22,1,0,113,86,1,1,81,14,1,2,33,86,1,3,97,10,1,4,65,7,1,5,49,6,1,87,17,86,1,87,129,86,1,8,145,86,1,9,129,86,1,89,161,86,1,11,145,86,1,12,129,86,1,13,161,86,1,89,177,86,1,15,145,86,1,16,97,86,1,17,129,20,1,18,65,19,1,87,49,86,1,87,161,86,1,21,161,86,1,87,177,86,17,23,113,86,17,24,145,86,17,25,129,40,17,26,81,34,17,27,17,31,17,28,161,29,17,87,177,86,17,30,97,86,17,89,65,86,17,32,97,86,17,33,49,86,17,89,65,86,17,35,97,38,17,36,65,37,17,87,49,86,17,87,161,86,17,39,161,86,17,87,177,86,17,41,161,86,17,42,177,43,17,87,17,86,17,87,97,65,1,45,81,86,1,46,113,58,1,47,145,86,1,48,97,55,1,49,65,53,1,50,49,51,1,87,129,86,1,52,17,86,1,87,33,86,1,54,129,86,1,87,161,86,1,56,177,86,1,57,129,86,1,87,161,86,1,59,33,86,1,60,49,86,1,61,65,63,1,62,17,86,1,87,97,86,1,64,97,86,1,87,129,86,17,66,81,86,17,67,113,79,17,68,145,86,17,69,97,76,17,70,65,74,17,71,49,72,17,87,129,86,17,73,17,86,17,87,33,86,17,75,129,86,17,87,161,86,17,77,177,86,17,78,129,86,17,87,161,86,17,80,33,86,17,81,49,86,17,82,65,84,17,83,17,86,17,87,97,86,17,85,97,86,17,87,129,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,181,0,1,0,54,0,2,80,37,0,3,32,29,0,4,144,21,0,5,16,15,0,6,96,10,0,7,48,8,0,135,65,134,1,9,160,134,1,137,177,134,1,11,128,134,1,12,160,13,0,137,177,134,1,14,64,136,1,137,113,134,1,16,176,19,0,17,48,18,0,135,65,134,1,135,161,134,1,20,128,134,1,135,161,134,1,22,96,134,1,23,112,134,1,24,128,27,0,25,64,26,0,137,49,134,1,137,161,134,1,28,160,134,1,137,177,134,1,30,48,134,1,31,64,34,0,32,16,33,0,135,97,134,1,135,177,134,1,35,96,134,1,36,112,134,1,135,129,134,1,38,144,134,1,39,112,134,1,40,128,48,0,41,16,45,0,42,160,43,0,135,177,134,1,44,96,134,1,137,65,134,1,46,96,134,1,47,48,134,1,137,65,134,1,49,96,52,0,50,64,51,0,135,49,134,1,135,161,134,1,53,160,134,1,135,177,161,16,55,80,107,0,56,144,91,16,57,48,83,16,58,64,77,0,59,176,68,0,60,16,64,0,61,128,134,1,62,160,63,0,137,33,136,1,137,113,134,17,65,96,134,17,66,32,136,17,67,112,136,17,137,129,72,0,69,96,134,1,70,112,134,1,71,128,136,1,137,161,134,17,73,96,134,17,74,32,134,17,75,112,76,16,137,17,136,17,137,129,134,17,78,32,134,17,79,112,81,16,80,16,134,17,137,97,134,17,82,96,134,17,137,129,134,1,84,176,134,1,85,128,134,1,86,160,89,0,87,16,88,0,137,33,134,1,137,113,134,1,90,96,134,1,137,113,134,1,92,176,134,1,93,160,101,0,94,48,98,0,95,16,96,0,135,33,134,1,97,112,134,1,137,129,134,1,99,96,134,1,100,112,134,1,137,129,134,1,102,128,105,0,103,16,104,0,135,33,134,1,135,113,134,1,106,96,134,1,135,113,147,16,108,144,135,0,109,32,127,0,110,16,119,0,111,64,114,0,112,160,134,1,113,48,134,1,137,177,134,17,115,96,134,17,116,112,134,17,117,128,136,17,118,176,136,17,137,161,134,17,120,96,134,17,121,112,134,17,122,128,125,16,123,160,124,16,137,65,136,17,137,177,134,17,126,48,136,17,137,65,134,17,128,96,134,17,129,112,134,17,130,128,133,16,131,64,132,16,137,49,134,17,137,161,134,17,134,160,134,17,137,177,134,17,136,96,134,17,137,112,143,16,138,128,141,16,139,64,140,16,135,49,134,17,135,161,134,17,142,160,134,17,135,177,134,17,144,32,134,17,145,16,134,17,146,48,134,17,137,65,153,0,148,32,134,1,149,16,134,1,150,48,134,1,151,64,134,1,152,160,134,1,135,177,134,17,154,32,134,17,155,48,134,17,156,64,134,17,157,112,159,16,158,16,134,17,135,97,134,17,160,96,134,17,135,129,174,0,162,32,134,1,163,160,134,1,164,176,171,0,165,144,168,0,166,16,167,0,135,49,134,1,135,129,134,1,169,96,134,1,170,112,134,1,135,129,134,1,172,16,134,1,173,48,134,1,135,65,134,1,175,144,134,1,176,112,134,1,177,128,134,1,178,160,134,1,179,176,180,0,135,17,134,1,135,97,90,17,182,0,226,0,183,32,204,0,184,80,197,0,185,112,134,1,186,96,193,0,187,64,190,0,188,48,189,0,135,17,134,1,135,129,134,1,191,144,134,1,192,128,134,1,137,161,134,1,194,144,134,1,195,128,134,1,196,160,134,1,137,177,134,17,198,144,134,17,199,128,134,17,200,160,134,17,201,176,134,17,202,112,203,16,137,17,134,17,137,97,134,17,205,144,134,17,206,112,134,17,207,128,222,16,208,80,216,16,209,16,213,16,210,160,211,16,137,177,134,17,212,96,136,17,137,65,134,17,214,96,134,17,215,48,136,17,137,65,134,17,217,96,220,16,218,64,219,16,137,49,134,17,137,161,134,17,221,160,134,17,137,177,134,17,223,160,134,17,224,176,225,16,135,17,134,17,135,97,58,17,227,32,11,1,228,144,255,0,229,80,247,16,230,16,239,16,231,64,234,16,232,160,134,17,233,48,134,17,137,177,134,1,235,96,134,1,236,112,134,1,237,128,136,1,238,176,136,1,137,161,134,1,240,96,134,1,241,112,134,1,242,128,245,0,243,160,244,0,137,65,136,1,137,177,134,1,246,48,136,1,137,65,134,1,248,96,134,1,249,112,134,1,250,128,253,0,251,64,252,0,137,49,134,1,137,161,134,1,254,160,134,1,137,177,134,17,0,49,134,17,1,65,8,17,2,81,5,17,3,17,4,17,135,97,134,17,135,177,134,17,6,97,134,17,7,113,134,17,137,129,134,17,9,17,134,17,10,161,134,17,135,177,46,17,12,145,38,17,13,81,30,17,14,17,24,17,15,97,19,17,16,49,17,17,135,65,134,17,18,161,134,17,137,177,134,17,20,129,134,17,21,161,22,17,137,177,134,17,23,65,136,17,137,113,134,17,25,177,28,17,26,49,27,17,135,65,134,17,135,161,134,17,29,129,134,17,135,161,134,17,31,97,134,17,32,113,134,17,33,129,36,17,34,65,35,17,137,49,134,17,137,161,134,17,37,161,134,17,137,177,134,17,39,161,134,17,40,177,43,17,41,17,42,17,135,49,134,17,135,129,134,17,44,97,134,17,45,113,134,17,135,129,134,17,47,49,134,17,48,65,55,17,49,81,52,17,50,17,51,17,135,97,134,17,135,177,134,17,53,97,134,17,54,113,134,17,135,129,134,17,56,17,134,17,57,161,134,17,135,177,80,17,59,145,134,17,60,113,134,17,61,129,76,17,62,81,70,17,63,17,67,17,64,161,65,17,135,177,134,17,66,97,134,17,137,65,134,17,68,97,134,17,69,49,134,17,137,65,134,17,71,97,74,17,72,65,73,17,135,49,134,17,135,161,134,17,75,161,134,17,135,177,134,17,77,161,134,17,78,177,79,17,135,17,134,17,135,97,134,1,81,81,134,1,82,145,134,1,83,97,134,1,84,113,134,1,85,129,88,1,86,65,87,1,135,49,134,1,135,161,134,1,89,161,134,1,135,177,112,1,91,81,104,1,92,145,134,1,93,97,134,1,94,113,101,1,95,65,99,1,96,49,97,1,135,129,134,1,98,17,134,1,135,33,134,1,100,129,134,1,135,161,134,1,102,177,134,1,103,129,134,1,135,161,134,1,105,33,134,1,106,49,134,1,107,65,134,1,108,113,110,1,109,17,134,1,135,97,134,1,111,97,134,1,135,129,134,17,113,81,126,17,114,145,134,17,115,97,134,17,116,113,123,17,117,65,121,17,118,49,119,17,135,129,134,17,120,17,134,17,135,33,134,17,122,129,134,17,135,161,134,17,124,177,134,17,125,129,134,17,135,161,134,17,127,33,134,17,128,49,134,17,129,65,134,17,130,113,132,17,131,17,134,17,135,97,134,17,133,97,134,17,135,129,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,38,0,1,0,23,0,2,32,12,0,3,48,9,0,4,80,7,0,5,16,6,0,111,64,108,0,111,112,108,0,8,64,108,0,111,96,108,0,10,16,11,0,109,64,108,0,109,112,18,0,13,112,108,0,14,96,17,0,15,80,16,0,111,16,108,0,111,64,108,0,109,16,108,16,19,80,108,16,20,48,108,16,21,112,108,16,22,64,110,16,111,96,28,0,24,80,108,0,25,112,108,0,26,96,27,0,109,16,108,0,109,64,108,16,29,80,108,16,30,48,35,16,31,32,33,16,32,16,108,16,111,64,108,16,34,64,108,16,111,96,108,16,36,112,108,16,37,64,108,16,111,96,88,16,39,0,73,16,40,32,53,0,41,112,49,16,42,48,47,16,43,80,45,16,44,16,110,16,111,64,108,16,46,64,110,16,111,96,108,16,48,16,108,16,111,64,108,0,50,80,108,0,51,48,108,0,52,64,110,0,111,96,65,16,54,112,60,16,55,48,59,16,56,80,57,16,111,16,108,16,58,64,110,16,111,96,108,16,109,16,108,16,61,96,64,16,62,80,63,16,111,16,108,16,111,64,108,16,109,16,108,16,66,48,71,16,67,80,69,16,68,16,108,16,111,64,108,16,70,64,108,16,111,96,108,16,72,16,108,16,109,64,83,0,74,80,108,0,75,48,80,0,76,32,78,0,77,16,108,0,111,64,108,0,79,64,108,0,111,96,108,0,81,112,108,0,82,64,108,0,111,96,108,16,84,80,108,16,85,112,108,16,86,96,87,16,109,16,108,16,109,64,98,0,89,48,108,0,90,80,95,0,91,32,93,0,92,16,108,0,109,64,108,0,94,64,108,0,109,96,108,0,96,112,108,0,97,64,108,0,109,96,108,16,99,48,108,16,100,80,105,16,101,32,103,16,102,16,108,16,109,64,108,16,104,64,108,16,109,96,108,16,106,112,108,16,107,64,108,16,109,96,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,81,0,0,161,3,0,0,162,3,0,0,65,0,0,0,20,0,0,0,21,0,0,0,240,0,0,0,22,0,0,0,23,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,104,0,0,0,241,0,0,0,242,0,0,0,243,0,0,0,137,1,0,0,244,0,0,0,138,1,0,0,245,0,0,0,139,1,0,0,246,0,0,0,0,0,0,0,48,81,0,0,21,0,0,0,163,3,0,0,164,3,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,1,0,0,0,253,255,255,255,0,0,0,0,253,255,255,255,255,255,255,255,254,255,255,255,254,255,255,255,255,255,255,255,253,255,255,255,0,0,0,0,253,255,255,255,1,0,0,0,253,255,255,255,2,0,0,0,254,255,255,255,3,0,0,0,255,255,255,255,3,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,3,0,0,0,254,255,255,255,2,0,0,0,253,255,255,255,1,0,0,0,253,255,255,255,0,0,0,0,254,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,0,0,0,0,253,255,255,255,1,0,0,0,254,255,255,255,2,0,0,0,255,255,255,255,3,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,2,0,0,0,254,255,255,255,1,0,0,0,254,255,255,255,0,0,0,0,254,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,0,0,0,0,254,255,255,255,1,0,0,0,254,255,255,255,2,0,0,0,255,255,255,255,2,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,255,255,255,255,2,0,0,0,254,255,255,255,1,0,0,0,38,0,1,0,23,0,2,32,12,0,3,48,9,0,4,80,7,0,5,16,6,0,109,64,108,0,109,112,108,0,8,64,108,0,109,96,108,0,10,16,11,0,109,64,108,0,109,112,18,0,13,112,108,0,14,96,17,0,15,80,16,0,109,16,108,0,109,64,108,0,109,16,108,16,19,80,108,16,20,48,108,16,21,112,108,16,22,64,108,16,109,96,28,0,24,80,108,0,25,112,108,0,26,96,27,0,109,16,108,0,109,64,108,16,29,80,108,16,30,48,35,16,31,32,33,16,32,16,108,16,109,64,108,16,34,64,108,16,109,96,108,16,36,112,108,16,37,64,108,16,109,96,88,16,39,0,73,16,40,32,53,0,41,112,49,16,42,48,47,16,43,80,45,16,44,16,108,16,109,64,108,16,46,64,108,16,109,96,108,16,48,16,108,16,109,64,108,0,50,80,108,0,51,48,108,0,52,64,108,0,109,96,65,16,54,112,60,16,55,48,59,16,56,80,57,16,109,16,108,16,58,64,108,16,109,96,108,16,109,16,108,16,61,96,64,16,62,80,63,16,109,16,108,16,109,64,108,16,109,16,108,16,66,48,71,16,67,80,69,16,68,16,108,16,109,64,108,16,70,64,108,16,109,96,108,16,72,16,108,16,109,64,83,0,74,80,108,0,75,48,80,0,76,32,78,0,77,16,108,0,109,64,108,0,79,64,108,0,109,96,108,0,81,112,108,0,82,64,108,0,109,96,108,16,84,80,108,16,85,112,108,16,86,96,87,16,109,16,108,16,109,64,98,0,89,48,108,0,90,80,95,0,91,32,93,0,92,16,108,0,109,64,108,0,94,64,108,0,109,96,108,0,96,112,108,0,97,64,108,0,109,96,108,16,99,48,108,16,100,80,105,16,101,32,103,16,102,16,108,16,109,64,108,16,104,64,108,16,109,96,108,16,106,112,108,16,107,64,108,16,109,96,254,0,0,0,255,0,0,0,181,0,1,0,54,0,2,80,37,0,3,32,29,0,4,144,21,0,5,16,15,0,6,96,10,0,7,48,8,0,135,65,134,1,9,160,134,1,135,177,134,1,11,128,134,1,12,160,13,0,135,177,134,1,14,64,134,1,135,113,134,1,16,176,19,0,17,48,18,0,135,65,134,1,135,161,134,1,20,128,134,1,135,161,134,1,22,96,134,1,23,112,134,1,24,128,27,0,25,64,26,0,135,49,134,1,135,161,134,1,28,160,134,1,135,177,134,1,30,48,134,1,31,64,34,0,32,16,33,0,135,97,134,1,135,177,134,1,35,96,134,1,36,112,134,1,135,129,134,1,38,144,134,1,39,112,134,1,40,128,48,0,41,16,45,0,42,160,43,0,135,177,134,1,44,96,134,1,135,65,134,1,46,96,134,1,47,48,134,1,135,65,134,1,49,96,52,0,50,64,51,0,135,49,134,1,135,161,134,1,53,160,134,1,135,177,161,16,55,80,107,0,56,144,91,16,57,48,83,16,58,64,77,0,59,176,68,0,60,16,64,0,61,128,134,1,62,160,63,0,135,33,134,1,135,113,134,17,65,96,134,17,66,32,134,17,67,112,134,17,135,129,72,0,69,96,134,1,70,112,134,1,71,128,134,1,135,161,134,17,73,96,134,17,74,32,134,17,75,112,76,16,135,17,134,17,135,129,134,17,78,32,134,17,79,112,81,16,80,16,134,17,135,97,134,17,82,96,134,17,135,129,134,1,84,176,134,1,85,128,134,1,86,160,89,0,87,16,88,0,135,33,134,1,135,113,134,1,90,96,134,1,135,113,134,1,92,176,134,1,93,160,101,0,94,48,98,0,95,16,96,0,135,33,134,1,97,112,134,1,135,129,134,1,99,96,134,1,100,112,134,1,135,129,134,1,102,128,105,0,103,16,104,0,135,33,134,1,135,113,134,1,106,96,134,1,135,113,147,16,108,144,135,0,109,32,127,0,110,16,119,0,111,64,114,0,112,160,134,1,113,48,134,1,135,177,134,17,115,96,134,17,116,112,134,17,117,128,134,17,118,176,134,17,135,161,134,17,120,96,134,17,121,112,134,17,122,128,125,16,123,160,124,16,135,65,134,17,135,177,134,17,126,48,134,17,135,65,134,17,128,96,134,17,129,112,134,17,130,128,133,16,131,64,132,16,135,49,134,17,135,161,134,17,134,160,134,17,135,177,134,17,136,96,134,17,137,112,143,16,138,128,141,16,139,64,140,16,135,49,134,17,135,161,134,17,142,160,134,17,135,177,134,17,144,32,134,17,145,16,134,17,146,48,134,17,135,65,153,0,148,32,134,1,149,16,134,1,150,48,134,1,151,64,134,1,152,160,134,1,135,177,134,17,154,32,134,17,155,48,134,17,156,64,134,17,157,112,159,16,158,16,134,17,135,97,134,17,160,96,134,17,135,129,174,0,162,32,134,1,163,160,134,1,164,176,171,0,165,144,168,0,166,16,167,0,135,49,134,1,135,129,134,1,169,96,134,1,170,112,134,1,135,129,134,1,172,16,134,1,173,48,134,1,135,65,134,1,175,144,134,1,176,112,134,1,177,128,134,1,178,160,134,1,179,176,180,0,135,17,134,1,135,97,90,17,182,0,226,0,183,32,204,0,184,80,197,0,185,112,134,1,186,96,193,0,187,64,190,0,188,48,189,0,135,17,134,1,135,129,134,1,191,144,134,1,192,128,134,1,135,161,134,1,194,144,134,1,195,128,134,1,196,160,134,1,135,177,134,17,198,144,134,17,199,128,134,17,200,160,134,17,201,176,134,17,202,112,203,16,135,17,134,17,135,97,134,17,205,144,134,17,206,112,134,17,207,128,222,16,208,80,216,16,209,16,213,16,210,160,211,16,135,177,134,17,212,96,134,17,135,65,134,17,214,96,134,17,215,48,134,17,135,65,134,17,217,96,220,16,218,64,219,16,135,49,134,17,135,161,134,17,221,160,134,17,135,177,134,17,223,160,134,17,224,176,225,16,135,17,134,17,135,97,58,17,227,32,11,1,228,144,255,0,229,80,247,16,230,16,239,16,231,64,234,16,232,160,134,17,233,48,134,17,135,177,134,1,235,96,134,1,236,112,134,1,237,128,134,1,238,176,134,1,135,161,134,1,240,96,134,1,241,112,134,1,242,128,245,0,243,160,244,0,135,65,134,1,135,177,134,1,246,48,134,1,135,65,134,1,248,96,134,1,249,112,134,1,250,128,253,0,251,64,252,0,135,49,134,1,135,161,134,1,254,160,134,1,135,177,134,17,0,49,134,17,1,65,8,17,2,81,5,17,3,17,4,17,135,97,134,17,135,177,134,17,6,97,134,17,7,113,134,17,135,129,134,17,9,17,134,17,10,161,134,17,135,177,46,17,12,145,38,17,13,81,30,17,14,17,24,17,15,97,19,17,16,49,17,17,135,65,134,17,18,161,134,17,135,177,134,17,20,129,134,17,21,161,22,17,135,177,134,17,23,65,134,17,135,113,134,17,25,177,28,17,26,49,27,17,135,65,134,17,135,161,134,17,29,129,134,17,135,161,134,17,31,97,134,17,32,113,134,17,33,129,36,17,34,65,35,17,135,49,134,17,135,161,134,17,37,161,134,17,135,177,134,17,39,161,134,17,40,177,43,17,41,17,42,17,135,49,134,17,135,129,134,17,44,97,134,17,45,113,134,17,135,129,134,17,47,49,134,17,48,65,55,17,49,81,52,17,50,17,51,17,135,97,134,17,135,177,134,17,53,97,134,17,54,113,134,17,135,129,134,17,56,17,134,17,57,161,134,17,135,177,80,17,59,145,134,17,60,113,134,17,61,129,76,17,62,81,70,17,63,17,67,17,64,161,65,17,135,177,134,17,66,97,134,17,135,65,134,17,68,97,134,17,69,49,134,17,135,65,134,17,71,97,74,17,72,65,73,17,135,49,134,17,135,161,134,17,75,161,134,17,135,177,134,17,77,161,134,17,78,177,79,17,135,17,134,17,135,97,134,1,81,81,134,1,82,145,134,1,83,97,134,1,84,113,134,1,85,129,88,1,86,65,87,1,135,49,134,1,135,161,134,1,89,161,134,1,135,177,112,1,91,81,104,1,92,145,134,1,93,97,134,1,94,113,101,1,95,65,99,1,96,49,97,1,135,129,134,1,98,17,134,1,135,33,134,1,100,129,134,1,135,161,134,1,102,177,134,1,103,129,134,1,135,161,134,1,105,33,134,1,106,49,134,1,107,65,134,1,108,113,110,1,109,17,134,1,135,97,134,1,111,97,134,1,135,129,134,17,113,81,126,17,114,145,134,17,115,97,134,17,116,113,123,17,117,65,121,17,118,49,119,17,135,129,134,17,120,17,134,17,135,33,134,17,122,129,134,17,135,161,134,17,124,177,134,17,125,129,134,17,135,161,134,17,127,33,134,17,128,49,134,17,129,65,134,17,130,113,132,17,131,17,134,17,135,97,134,17,133,97,134,17,135,129,254,0,0,0,255,0,0,0,43,3,1,0,4,1,2,80,38,16,3,32,72,7,4,112,5,16,72,151,72,7,6,144,15,16,7,16,8,16,72,103,72,7,9,96,72,7,10,128,13,0,11,64,12,0,73,55,72,7,73,167,72,7,14,160,72,7,73,183,30,0,16,16,20,16,17,96,72,7,18,128,72,7,19,160,72,7,73,183,27,0,21,96,72,7,22,128,25,0,23,64,24,0,73,55,72,7,73,167,72,7,26,160,72,7,73,183,72,7,28,128,72,7,29,160,72,7,73,183,31,16,72,103,72,7,32,96,72,7,33,128,36,0,34,64,35,0,73,55,72,7,73,167,72,7,37,160,72,7,73,183,225,0,39,32,89,16,40,112,53,16,41,144,42,16,72,23,72,7,43,16,46,0,44,96,72,7,45,48,72,7,73,71,50,16,47,96,72,7,48,48,72,7,49,64,72,7,73,183,72,7,51,48,72,7,52,64,72,7,73,183,77,0,54,144,55,16,72,23,72,7,56,16,63,16,57,96,72,7,58,176,61,0,59,48,60,0,73,71,72,7,73,167,72,7,62,128,72,7,73,167,71,0,64,96,68,0,65,48,66,0,73,71,72,7,67,160,72,7,73,183,72,7,69,128,72,7,70,160,72,7,73,183,72,7,72,176,75,0,73,48,74,0,73,71,72,7,73,167,72,7,76,128,72,7,73,167,78,16,72,23,72,7,79,16,82,0,80,96,72,7,81,48,72,7,73,71,86,16,83,96,72,7,84,48,72,7,85,64,72,7,73,183,72,7,87,48,72,7,88,64,72,7,73,183,125,16,90,144,113,0,91,112,97,16,92,16,93,16,72,103,72,7,94,96,72,7,95,48,72,7,96,64,72,7,73,135,108,0,98,16,101,0,99,96,72,7,100,48,72,7,73,71,105,16,102,96,72,7,103,48,72,7,104,64,72,7,73,183,72,7,106,48,72,7,107,64,72,7,73,183,109,16,72,103,72,7,110,96,72,7,111,48,72,7,112,64,72,7,73,135,114,16,72,23,72,7,115,16,118,0,116,96,72,7,117,48,72,7,73,71,122,16,119,96,72,7,120,48,72,7,121,64,72,7,73,183,72,7,123,48,72,7,124,64,72,7,73,183,189,0,126,112,167,0,127,144,136,16,128,16,129,16,72,103,72,7,130,96,72,7,131,128,134,0,132,64,133,0,73,55,72,7,73,167,72,7,135,160,72,7,73,183,159,0,137,16,144,16,138,96,72,7,139,176,142,0,140,48,141,0,73,71,72,7,73,167,72,7,143,128,72,7,73,167,153,0,145,96,149,0,146,48,147,0,73,71,72,7,148,160,72,7,73,183,72,7,150,128,72,7,151,160,152,0,73,71,72,7,73,183,72,7,154,176,157,0,155,48,156,0,73,71,72,7,73,167,72,7,158,128,72,7,73,167,160,16,72,103,72,7,161,96,72,7,162,128,165,0,163,64,164,0,73,55,72,7,73,167,72,7,166,160,72,7,73,183,173,16,168,16,169,16,72,103,72,7,170,96,72,7,171,48,72,7,172,64,72,7,73,135,184,0,174,16,177,0,175,96,72,7,176,48,72,7,73,71,181,16,178,96,72,7,179,48,72,7,180,64,72,7,73,183,72,7,182,48,72,7,183,64,72,7,73,183,185,16,72,103,72,7,186,96,72,7,187,48,72,7,188,64,72,7,73,135,213,0,190,144,191,16,72,23,72,7,192,16,199,16,193,96,72,7,194,176,197,0,195,48,196,0,73,71,72,7,73,167,72,7,198,128,72,7,73,167,207,0,200,96,204,0,201,48,202,0,73,71,72,7,203,160,72,7,73,183,72,7,205,128,72,7,206,160,72,7,73,183,72,7,208,176,211,0,209,48,210,0,73,71,72,7,73,167,72,7,212,128,72,7,73,167,214,16,72,23,72,7,215,16,218,0,216,96,72,7,217,48,72,7,73,71,222,16,219,96,72,7,220,48,72,7,221,64,72,7,73,183,72,7,223,48,72,7,224,64,72,7,73,183,72,7,226,112,227,16,72,151,72,7,228,144,237,16,229,16,230,16,72,103,72,7,231,96,72,7,232,128,235,0,233,64,234,0,73,55,72,7,73,167,72,7,236,160,72,7,73,183,252,0,238,16,242,16,239,96,72,7,240,128,72,7,241,160,72,7,73,183,249,0,243,96,72,7,244,128,247,0,245,64,246,0,73,55,72,7,73,167,72,7,248,160,72,7,73,183,72,7,250,128,72,7,251,160,72,7,73,183,253,16,72,103,72,7,254,96,72,7,255,128,2,1,0,65,1,1,73,55,72,7,73,167,72,7,3,161,72,7,73,183,83,18,5,81,140,17,6,145,25,1,7,113,8,17,72,39,72,7,9,33,10,17,72,23,72,7,11,17,16,1,12,97,72,7,13,49,72,7,14,65,72,7,15,161,72,7,73,183,21,17,17,97,72,7,18,49,72,7,19,65,72,7,20,161,72,7,73,183,72,7,22,49,72,7,23,65,72,7,24,161,72,7,73,183,122,17,26,113,54,17,27,33,36,1,28,17,29,1,72,103,72,23,30,97,72,23,31,129,34,17,32,65,33,17,73,55,72,23,73,167,72,23,35,161,72,23,73,183,46,17,37,17,38,1,72,103,72,23,39,97,43,17,40,65,41,17,73,55,72,23,42,129,72,23,73,167,72,23,44,129,72,23,45,161,72,23,73,183,47,1,72,103,72,23,48,97,72,23,49,129,52,17,50,65,51,17,73,55,72,23,73,167,72,23,53,161,72,23,73,183,96,1,55,33,64,17,56,17,57,1,72,103,72,23,58,97,72,23,59,129,62,17,60,65,61,17,73,55,72,23,73,167,72,23,63,161,72,23,73,183,88,1,65,17,70,1,66,97,72,7,67,49,72,7,68,65,72,7,69,161,72,7,73,183,84,17,71,97,78,1,72,65,75,1,73,161,72,7,74,49,72,7,73,183,72,23,76,129,72,23,77,177,72,23,73,167,72,23,79,129,82,17,80,161,81,17,73,71,72,23,73,183,72,23,83,49,72,23,73,71,72,7,85,49,72,7,86,65,72,7,87,161,72,7,73,183,89,1,72,103,72,23,90,97,72,23,91,129,94,17,92,65,93,17,73,55,72,23,73,167,72,23,95,161,72,23,73,183,105,1,97,17,98,1,72,103,72,23,99,97,72,23,100,129,103,17,101,65,102,17,73,55,72,23,73,167,72,23,104,161,72,23,73,183,114,17,106,17,107,1,72,103,72,23,108,97,72,23,109,129,112,17,110,65,111,17,73,55,72,23,73,167,72,23,113,161,72,23,73,183,115,1,72,103,72,23,116,97,72,23,117,129,120,17,118,65,119,17,73,55,72,23,73,167,72,23,121,161,72,23,73,183,123,17,72,39,72,7,124,33,125,17,72,23,72,7,126,17,131,1,127,97,72,7,128,49,72,7,129,65,72,7,130,161,72,7,73,183,136,17,132,97,72,7,133,49,72,7,134,65,72,7,135,161,72,7,73,183,72,7,137,49,72,7,138,65,72,7,139,161,72,7,73,183,13,2,141,145,176,17,142,113,159,1,143,33,144,17,72,23,72,7,145,17,150,1,146,97,72,7,147,161,72,7,148,177,149,1,73,55,72,7,73,135,155,17,151,97,72,7,152,161,72,7,153,177,154,1,73,55,72,7,73,135,72,7,156,161,72,7,157,177,158,1,73,55,72,7,73,135,72,23,160,33,165,17,161,17,162,1,72,103,72,23,163,97,72,23,164,49,72,23,73,71,171,1,166,17,167,1,72,103,72,23,168,97,72,23,169,49,72,23,170,65,72,23,73,135,172,1,72,103,72,23,173,97,72,23,174,49,72,23,175,65,72,23,73,135,251,1,177,113,201,17,178,33,184,17,179,17,180,17,72,103,72,7,181,97,72,7,182,129,72,7,183,161,72,7,73,183,196,1,185,17,189,1,186,97,72,7,187,129,72,7,188,161,72,7,73,183,193,17,190,97,72,7,191,129,72,7,192,161,72,7,73,183,72,7,194,129,72,7,195,161,72,7,73,183,197,17,72,103,72,7,198,97,72,7,199,129,72,7,200,161,72,7,73,183,228,1,202,33,208,17,203,17,204,17,72,103,72,7,205,97,72,7,206,129,72,7,207,161,72,7,73,183,223,1,209,17,214,1,210,97,72,7,211,161,72,7,212,177,213,1,73,55,72,7,73,135,219,17,215,97,72,7,216,161,72,7,217,177,218,1,73,55,72,7,73,135,72,7,220,161,72,7,221,177,222,1,73,55,72,7,73,135,224,17,72,103,72,7,225,97,72,7,226,129,72,7,227,161,72,7,73,183,234,17,229,17,230,17,72,103,72,7,231,97,72,7,232,129,72,7,233,161,72,7,73,183,246,1,235,17,239,1,236,97,72,7,237,129,72,7,238,161,72,7,73,183,243,17,240,97,72,7,241,129,72,7,242,161,72,7,73,183,72,7,244,129,72,7,245,161,72,7,73,183,247,17,72,103,72,7,248,97,72,7,249,129,72,7,250,161,72,7,73,183,252,17,72,39,72,7,253,33,254,17,72,23,72,7,255,17,4,2,0,98,72,7,1,162,72,7,2,178,3,2,73,55,72,7,73,135,9,18,5,98,72,7,6,162,72,7,7,178,8,2,73,55,72,7,73,135,72,7,10,162,72,7,11,178,12,2,73,55,72,7,73,135,32,18,14,34,15,2,72,119,72,23,16,114,21,18,17,18,18,2,72,103,72,23,19,98,72,23,20,50,72,23,73,71,27,2,22,18,23,2,72,103,72,23,24,98,72,23,25,50,72,23,26,66,72,23,73,135,28,2,72,103,72,23,29,98,72,23,30,50,72,23,31,66,72,23,73,135,72,7,33,34,50,2,34,114,35,18,72,23,72,7,36,18,41,2,37,98,72,7,38,50,72,7,39,66,72,7,40,162,72,7,73,183,46,18,42,98,72,7,43,50,72,7,44,66,72,7,45,162,72,7,73,183,72,7,47,50,72,7,48,66,72,7,49,162,72,7,73,183,67,18,51,114,52,18,72,23,72,7,53,18,58,2,54,98,72,7,55,50,72,7,56,66,72,7,57,162,72,7,73,183,63,18,59,98,72,7,60,50,72,7,61,66,72,7,62,162,72,7,73,183,72,7,64,50,72,7,65,66,72,7,66,162,72,7,73,183,68,18,72,23,72,7,69,18,74,2,70,98,72,7,71,50,72,7,72,66,72,7,73,162,72,7,73,183],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+122880);allocate([79,18,75,98,72,7,76,50,72,7,77,66,72,7,78,162,72,7,73,183,72,7,80,50,72,7,81,66,72,7,82,162,72,7,73,183,110,18,84,34,72,7,85,114,86,18,72,151,72,7,87,146,93,18,88,18,89,18,72,103,72,7,90,98,72,7,91,130,72,7,92,162,72,7,73,183,105,2,94,18,98,2,95,98,72,7,96,130,72,7,97,162,72,7,73,183,102,18,99,98,72,7,100,130,72,7,101,162,72,7,73,183,72,7,103,130,72,7,104,162,72,7,73,183,106,18,72,103,72,7,107,98,72,7,108,130,72,7,109,162,72,7,73,183,17,3,111,34,162,18,112,114,129,18,113,146,114,18,72,23,72,7,115,18,120,2,116,98,72,7,117,50,72,7,118,66,72,7,119,162,72,7,73,183,125,18,121,98,72,7,122,50,72,7,123,66,72,7,124,162,72,7,73,183,72,7,126,50,72,7,127,66,72,7,128,162,72,7,73,183,146,2,130,146,131,18,72,23,72,7,132,18,137,2,133,98,72,7,134,162,72,7,135,178,136,2,73,55,72,7,73,135,142,18,138,98,72,7,139,162,72,7,140,178,141,2,73,55,72,7,73,135,72,7,143,162,72,7,144,178,145,2,73,55,72,7,73,135,147,18,72,23,72,7,148,18,153,2,149,98,72,7,150,50,72,7,151,66,72,7,152,162,72,7,73,183,158,18,154,98,72,7,155,50,72,7,156,66,72,7,157,162,72,7,73,183,72,7,159,50,72,7,160,66,72,7,161,162,72,7,73,183,196,18,163,146,180,2,164,114,165,18,72,23,72,7,166,18,171,2,167,98,72,7,168,50,72,7,169,66,72,7,170,162,72,7,73,183,176,18,172,98,72,7,173,50,72,7,174,66,72,7,175,162,72,7,73,183,72,7,177,50,72,7,178,66,72,7,179,162,72,7,73,183,181,18,72,23,72,7,182,18,187,2,183,98,72,7,184,50,72,7,185,66,72,7,186,162,72,7,73,183,192,18,188,98,72,7,189,50,72,7,190,66,72,7,191,162,72,7,73,183,72,7,193,50,72,7,194,66,72,7,195,162,72,7,73,183,240,2,197,114,224,2,198,146,204,18,199,18,200,18,72,103,72,7,201,98,72,7,202,130,72,7,203,162,72,7,73,183,219,2,205,18,210,2,206,98,72,7,207,162,72,7,208,178,209,2,73,55,72,7,73,135,215,18,211,98,72,7,212,162,72,7,213,178,214,2,73,55,72,7,73,135,72,7,216,162,72,7,217,178,218,2,73,55,72,7,73,135,220,18,72,103,72,7,221,98,72,7,222,130,72,7,223,162,72,7,73,183,225,18,72,23,72,7,226,18,231,2,227,98,72,7,228,50,72,7,229,66,72,7,230,162,72,7,73,183,236,18,232,98,72,7,233,50,72,7,234,66,72,7,235,162,72,7,73,183,72,7,237,50,72,7,238,66,72,7,239,162,72,7,73,183,1,3,241,146,242,18,72,23,72,7,243,18,248,2,244,98,72,7,245,162,72,7,246,178,247,2,73,55,72,7,73,135,253,18,249,98,72,7,250,162,72,7,251,178,252,2,73,55,72,7,73,135,72,7,254,162,72,7,255,178,0,3,73,55,72,7,73,135,2,19,72,23,72,7,3,19,8,3,4,99,72,7,5,51,72,7,6,67,72,7,7,163,72,7,73,183,13,19,9,99,72,7,10,51,72,7,11,67,72,7,12,163,72,7,73,183,72,7,14,51,72,7,15,67,72,7,16,163,72,7,73,183,72,7,18,115,19,19,72,151,72,7,20,147,26,19,21,19,22,19,72,103,72,7,23,99,72,7,24,131,72,7,25,163,72,7,73,183,38,3,27,19,31,3,28,99,72,7,29,131,72,7,30,163,72,7,73,183,35,19,32,99,72,7,33,131,72,7,34,163,72,7,73,183,72,7,36,131,72,7,37,163,72,7,73,183,39,19,72,103,72,7,40,99,72,7,41,131,72,7,42,163,72,7,73,183,85,22,44,3,49,20,45,83,96,3,46,147,47,3,72,39,72,23,48,35,61,3,49,115,50,3,72,23,72,23,51,19,54,19,52,99,72,23,53,51,72,23,73,71,58,3,55,99,72,23,56,51,72,23,57,67,72,23,73,183,72,23,59,51,72,23,60,67,72,23,73,183,84,19,62,115,68,3,63,19,64,3,72,103,72,23,65,99,72,23,66,51,72,23,67,67,72,23,73,135,79,19,69,19,72,19,70,99,72,23,71,51,72,23,73,71,76,3,73,99,72,23,74,51,72,23,75,67,72,23,73,183,72,23,77,51,72,23,78,67,72,23,73,183,80,3,72,103,72,23,81,99,72,23,82,51,72,23,83,67,72,23,73,135,85,3,72,23,72,23,86,19,89,19,87,99,72,23,88,51,72,23,73,71,93,3,90,99,72,23,91,51,72,23,92,67,72,23,73,183,72,23,94,51,72,23,95,67,72,23,73,183,255,19,97,147,123,3,98,115,99,3,72,39,72,23,100,35,101,3,72,23,72,23,102,19,109,3,103,99,72,23,104,179,107,19,105,51,106,19,73,71,72,23,73,167,72,23,108,131,72,23,73,167,117,19,110,99,114,19,111,51,112,19,73,71,72,23,113,163,72,23,73,183,72,23,115,131,72,23,116,163,72,23,73,183,72,23,118,179,121,19,119,51,120,19,73,71,72,23,73,167,72,23,122,131,72,23,73,167,230,19,124,115,157,3,125,35,134,3,126,19,127,3,72,103,72,23,128,99,72,23,129,131,132,19,130,67,131,19,73,55,72,23,73,167,72,23,133,163,72,23,73,183,149,19,135,19,139,3,136,99,72,23,137,131,72,23,138,163,72,23,73,183,146,19,140,99,72,23,141,131,144,19,142,67,143,19,73,55,72,23,73,167,72,23,145,163,72,23,73,183,72,23,147,131,72,23,148,163,72,23,73,183,150,3,72,103,72,23,151,99,72,23,152,131,155,19,153,67,154,19,73,55,72,23,73,167,72,23,156,163,72,23,73,183,198,19,158,35,167,3,159,19,160,3,72,103,72,23,161,99,72,23,162,131,165,19,163,67,164,19,73,55,72,23,73,167,72,23,166,163,72,23,73,183,190,19,168,19,175,3,169,99,72,23,170,179,173,19,171,51,172,19,73,71,72,23,73,167,72,23,174,131,72,23,73,167,184,19,176,99,180,19,177,51,178,19,73,71,72,23,179,163,72,23,73,183,72,23,181,131,72,23,182,163,183,19,73,71,72,23,73,183,72,23,185,179,188,19,186,51,187,19,73,71,72,23,73,167,72,23,189,131,72,23,73,167,191,3,72,103,72,23,192,99,72,23,193,131,196,19,194,67,195,19,73,55,72,23,73,167,72,23,197,163,72,23,73,183,207,3,199,19,200,3,72,103,72,23,201,99,72,23,202,131,205,19,203,67,204,19,73,55,72,23,73,167,72,23,206,163,72,23,73,183,222,19,208,19,212,3,209,99,72,23,210,131,72,23,211,163,72,23,73,183,219,19,213,99,72,23,214,131,217,19,215,67,216,19,73,55,72,23,73,167,72,23,218,163,72,23,73,183,72,23,220,131,72,23,221,163,72,23,73,183,223,3,72,103,72,23,224,99,72,23,225,131,228,19,226,67,227,19,73,55,72,23,73,167,72,23,229,163,72,23,73,183,231,3,72,39,72,23,232,35,233,3,72,23,72,23,234,19,241,3,235,99,72,23,236,179,239,19,237,51,238,19,73,71,72,23,73,167,72,23,240,131,72,23,73,167,249,19,242,99,246,19,243,51,244,19,73,71,72,23,245,163,72,23,73,183,72,23,247,131,72,23,248,163,72,23,73,183,72,23,250,179,253,19,251,51,252,19,73,71,72,23,73,167,72,23,254,131,72,23,73,167,0,4,72,39,72,23,1,36,14,4,2,116,3,4,72,23,72,23,4,20,7,20,5,100,72,23,6,52,72,23,73,71,11,4,8,100,72,23,9,52,72,23,10,68,72,23,73,183,72,23,12,52,72,23,13,68,72,23,73,183,37,20,15,116,21,4,16,20,17,4,72,103,72,23,18,100,72,23,19,52,72,23,20,68,72,23,73,135,32,20,22,20,25,20,23,100,72,23,24,52,72,23,73,71,29,4,26,100,72,23,27,52,72,23,28,68,72,23,73,183,72,23,30,52,72,23,31,68,72,23,73,183,33,4,72,103,72,23,34,100,72,23,35,52,72,23,36,68,72,23,73,135,38,4,72,23,72,23,39,20,42,20,40,100,72,23,41,52,72,23,73,71,46,4,43,100,72,23,44,52,72,23,45,68,72,23,73,183,72,23,47,52,72,23,48,68,72,23,73,183,125,5,50,84,139,4,51,36,77,20,52,116,53,4,72,151,72,23,54,148,60,4,55,20,56,4,72,103,72,23,57,100,72,23,58,132,72,23,59,164,72,23,73,183,72,20,61,20,65,4,62,100,72,23,63,132,72,23,64,164,72,23,73,183,69,20,66,100,72,23,67,132,72,23,68,164,72,23,73,183,72,23,70,132,72,23,71,164,72,23,73,183,73,4,72,103,72,23,74,100,72,23,75,132,72,23,76,164,72,23,73,183,72,7,78,116,95,20,79,148,84,4,80,20,81,20,72,103,72,7,82,100,72,7,83,52,72,7,73,71,90,20,85,20,86,20,72,103,72,7,87,100,72,7,88,52,72,7,89,68,72,7,73,135,91,20,72,103,72,7,92,100,72,7,93,52,72,7,94,68,72,7,73,135,123,4,96,148,105,20,97,20,98,20,72,103,72,7,99,100,72,7,100,132,103,4,101,68,102,4,73,55,72,7,73,167,72,7,104,164,72,7,73,183,115,4,106,20,107,20,72,103,72,7,108,100,112,4,109,68,110,4,73,55,72,7,111,132,72,7,73,167,72,7,113,132,72,7,114,164,72,7,73,183,116,20,72,103,72,7,117,100,72,7,118,132,121,4,119,68,120,4,73,55,72,7,73,167,72,7,122,164,72,7,73,183,128,4,124,20,125,20,72,103,72,7,126,100,72,7,127,52,72,7,73,71,134,20,129,20,130,20,72,103,72,7,131,100,72,7,132,52,72,7,133,68,72,7,73,135,135,20,72,103,72,7,136,100,72,7,137,52,72,7,138,68,72,7,73,135,71,21,140,36,201,20,141,116,158,4,142,148,143,4,72,23,72,23,144,20,149,4,145,100,72,23,146,52,72,23,147,68,72,23,148,164,72,23,73,183,154,20,150,100,72,23,151,52,72,23,152,68,72,23,153,164,72,23,73,183,72,23,155,52,72,23,156,68,72,23,157,164,72,23,73,183,185,20,159,148,165,4,160,20,161,4,72,103,72,23,162,100,72,23,163,132,72,23,164,164,72,23,73,183,180,20,166,20,171,4,167,100,72,23,168,164,72,23,169,180,170,20,73,55,72,23,73,135,176,20,172,100,72,23,173,164,72,23,174,180,175,20,73,55,72,23,73,135,72,23,177,164,72,23,178,180,179,20,73,55,72,23,73,135,181,4,72,103,72,23,182,100,72,23,183,132,72,23,184,164,72,23,73,183,186,4,72,23,72,23,187,20,192,4,188,100,72,23,189,52,72,23,190,68,72,23,191,164,72,23,73,183,197,20,193,100,72,23,194,52,72,23,195,68,72,23,196,164,72,23,73,183,72,23,198,52,72,23,199,68,72,23,200,164,72,23,73,183,21,5,202,116,219,20,203,148,204,4,72,23,72,23,205,20,210,4,206,100,72,23,207,164,72,23,208,180,209,20,73,55,72,23,73,135,215,20,211,100,72,23,212,164,72,23,213,180,214,20,73,55,72,23,73,135,72,23,216,164,72,23,217,180,218,20,73,55,72,23,73,135,5,5,220,148,229,4,221,20,222,20,72,103,72,7,223,100,72,7,224,132,227,4,225,68,226,4,73,55,72,7,73,167,72,7,228,164,72,7,73,183,253,20,230,20,235,20,231,100,72,23,232,52,72,23,233,68,72,23,234,164,72,23,73,183,249,4,236,100,243,20,237,68,240,4,238,164,72,7,239,132,72,7,73,183,72,23,241,52,72,23,242,180,72,23,73,167,72,7,244,132,247,4,245,164,246,4,73,71,72,7,73,183,72,7,248,52,72,7,73,71,72,23,250,52,72,23,251,68,72,23,252,164,72,23,73,183,254,20,72,103,72,7,255,100,72,7,0,133,3,5,1,69,2,5,73,55,72,7,73,167,72,7,4,165,72,7,73,183,6,5,72,23,72,23,7,21,12,5,8,101,72,23,9,53,72,23,10,69,72,23,11,165,72,23,73,183,17,21,13,101,72,23,14,53,72,23,15,69,72,23,16,165,72,23,73,183,72,23,18,53,72,23,19,69,72,23,20,165,72,23,73,183,38,5,22,149,23,5,72,23,72,23,24,21,29,5,25,101,72,23,26,53,72,23,27,69,72,23,28,165,72,23,73,183,34,21,30,101,72,23,31,53,72,23,32,69,72,23,33,165,72,23,73,183,72,23,35,53,72,23,36,69,72,23,37,165,72,23,73,183,55,21,39,149,40,5,72,23,72,23,41,21,46,5,42,101,72,23,43,165,72,23,44,181,45,21,73,55,72,23,73,135,51,21,47,101,72,23,48,165,72,23,49,181,50,21,73,55,72,23,73,135,72,23,52,165,72,23,53,181,54,21,73,55,72,23,73,135,56,5,72,23,72,23,57,21,62,5,58,101,72,23,59,53,72,23,60,69,72,23,61,165,72,23,73,183,67,21,63,101,72,23,64,53,72,23,65,69,72,23,66,165,72,23,73,183,72,23,68,53,72,23,69,69,72,23,70,165,72,23,73,183,100,5,72,117,73,21,72,151,72,7,74,149,83,5,75,21,76,21,72,103,72,7,77,101,72,7,78,133,81,5,79,69,80,5,73,55,72,7,73,167,72,7,82,165,72,7,73,183,92,21,84,21,85,21,72,103,72,7,86,101,72,7,87,133,90,5,88,69,89,5,73,55,72,7,73,167,72,7,91,165,72,7,73,183,93,21,72,103,72,7,94,101,72,7,95,133,98,5,96,69,97,5,73,55,72,7,73,167,72,7,99,165,72,7,73,183,72,23,101,149,72,23,102,117,108,5,103,21,104,5,72,103,72,23,105,101,72,23,106,133,72,23,107,165,72,23,73,183,120,21,109,21,113,5,110,101,72,23,111,133,72,23,112,165,72,23,73,183,117,21,114,101,72,23,115,133,72,23,116,165,72,23,73,183,72,23,118,133,72,23,119,165,72,23,73,183,121,5,72,103,72,23,122,101,72,23,123,133,72,23,124,165,72,23,73,183,152,5,126,37,72,23,127,117,128,5,72,151,72,23,129,149,135,5,130,21,131,5,72,103,72,23,132,101,72,23,133,133,72,23,134,165,72,23,73,183,147,21,136,21,140,5,137,101,72,23,138,133,72,23,139,165,72,23,73,183,144,21,141,101,72,23,142,133,72,23,143,165,72,23,73,183,72,23,145,133,72,23,146,165,72,23,73,183,148,5,72,103,72,23,149,101,72,23,150,133,72,23,151,165,72,23,73,183,59,22,153,37,204,5,154,117,171,5,155,149,156,5,72,23,72,23,157,21,162,5,158,101,72,23,159,53,72,23,160,69,72,23,161,165,72,23,73,183,167,21,163,101,72,23,164,53,72,23,165,69,72,23,166,165,72,23,73,183,72,23,168,53,72,23,169,69,72,23,170,165,72,23,73,183,188,21,172,149,173,5,72,23,72,23,174,21,179,5,175,101,72,23,176,165,72,23,177,181,178,21,73,55,72,23,73,135,184,21,180,101,72,23,181,165,72,23,182,181,183,21,73,55,72,23,73,135,72,23,185,165,72,23,186,181,187,21,73,55,72,23,73,135,189,5,72,23,72,23,190,21,195,5,191,101,72,23,192,53,72,23,193,69,72,23,194,165,72,23,73,183,200,21,196,101,72,23,197,53,72,23,198,69,72,23,199,165,72,23,73,183,72,23,201,53,72,23,202,69,72,23,203,165,72,23,73,183,238,5,205,149,222,21,206,117,207,5,72,23,72,23,208,21,213,5,209,101,72,23,210,53,72,23,211,69,72,23,212,165,72,23,73,183,218,21,214,101,72,23,215,53,72,23,216,69,72,23,217,165,72,23,73,183,72,23,219,53,72,23,220,69,72,23,221,165,72,23,73,183,223,5,72,23,72,23,224,21,229,5,225,101,72,23,226,53,72,23,227,69,72,23,228,165,72,23,73,183,234,21,230,101,72,23,231,53,72,23,232,69,72,23,233,165,72,23,73,183,72,23,235,53,72,23,236,69,72,23,237,165,72,23,73,183,26,22,239,117,10,22,240,149,246,5,241,21,242,5,72,103,72,23,243,101,72,23,244,133,72,23,245,165,72,23,73,183,5,22,247,21,252,5,248,101,72,23,249,165,72,23,250,181,251,21,73,55,72,23,73,135,1,22,253,101,72,23,254,165,72,23,255,181,0,22,73,55,72,23,73,135,72,23,2,166,72,23,3,182,4,22,73,55,72,23,73,135,6,6,72,103,72,23,7,102,72,23,8,134,72,23,9,166,72,23,73,183,11,6,72,23,72,23,12,22,17,6,13,102,72,23,14,54,72,23,15,70,72,23,16,166,72,23,73,183,22,22,18,102,72,23,19,54,72,23,20,70,72,23,21,166,72,23,73,183,72,23,23,54,72,23,24,70,72,23,25,166,72,23,73,183,43,22,27,150,28,6,72,23,72,23,29,22,34,6,30,102,72,23,31,166,72,23,32,182,33,22,73,55,72,23,73,135,39,22,35,102,72,23,36,166,72,23,37,182,38,22,73,55,72,23,73,135,72,23,40,166,72,23,41,182,42,22,73,55,72,23,73,135,44,6,72,23,72,23,45,22,50,6,46,102,72,23,47,54,72,23,48,70,72,23,49,166,72,23,73,183,55,22,51,102,72,23,52,54,72,23,53,70,72,23,54,166,72,23,73,183,72,23,56,54,72,23,57,70,72,23,58,166,72,23,73,183,72,23,60,118,61,6,72,151,72,23,62,150,68,6,63,22,64,6,72,103,72,23,65,102,72,23,66,134,72,23,67,166,72,23,73,183,80,22,69,22,73,6,70,102,72,23,71,134,72,23,72,166,72,23,73,183,77,22,74,102,72,23,75,134,72,23,76,166,72,23,73,183,72,23,78,134,72,23,79,166,72,23,73,183,81,6,72,103,72,23,82,102,72,23,83,134,72,23,84,166,72,23,73,183,207,22,86,86,87,6,72,119,72,23,88,118,117,6,89,38,90,6,72,151,72,23,91,150,100,6,92,22,93,6,72,103,72,23,94,102,72,23,95,134,98,22,96,70,97,22,73,55,72,23,73,167,72,23,99,166,72,23,73,183,109,22,101,22,102,6,72,103,72,23,103,102,72,23,104,134,107,22,105,70,106,22,73,55,72,23,73,167,72,23,108,166,72,23,73,183,110,6,72,103,72,23,111,102,72,23,112,134,115,22,113,70,114,22,73,55,72,23,73,167,72,23,116,166,72,23,73,183,179,22,118,38,135,6,119,150,124,22,120,22,121,6,72,103,72,23,122,102,72,23,123,54,72,23,73,71,130,6,125,22,126,6,72,103,72,23,127,102,72,23,128,54,72,23,129,70,72,23,73,135,131,6,72,103,72,23,132,102,72,23,133,54,72,23,134,70,72,23,73,135,163,22,136,150,145,6,137,22,138,6,72,103,72,23,139,102,72,23,140,134,143,22,141,70,142,22,73,55,72,23,73,167,72,23,144,166,72,23,73,183,155,22,146,22,147,6,72,103,72,23,148,102,152,22,149,70,150,22,73,55,72,23,151,134,72,23,73,167,72,23,153,134,72,23,154,166,72,23,73,183,156,6,72,103,72,23,157,102,72,23,158,134,161,22,159,70,160,22,73,55,72,23,73,167,72,23,162,166,72,23,73,183,168,22,164,22,165,6,72,103,72,23,166,102,72,23,167,54,72,23,73,71,174,6,169,22,170,6,72,103,72,23,171,102,72,23,172,54,72,23,173,70,72,23,73,135,175,6,72,103,72,23,176,102,72,23,177,54,72,23,178,70,72,23,73,135,180,6,72,151,72,23,181,150,190,6,182,22,183,6,72,103,72,23,184,102,72,23,185,134,188,22,186,70,187,22,73,55,72,23,73,167,72,23,189,166,72,23,73,183,199,22,191,22,192,6,72,103,72,23,193,102,72,23,194,134,197,22,195,70,196,22,73,55,72,23,73,167,72,23,198,166,72,23,73,183,200,6,72,103,72,23,201,102,72,23,202,134,205,22,203,70,204,22,73,55,72,23,73,167,72,23,206,166,72,23,73,183,72,7,208,86,72,7,209,118,238,22,210,38,211,22,72,151,72,7,212,150,221,6,213,22,214,22,72,103,72,7,215,102,72,7,216,134,219,6,217,70,218,6,73,55,72,7,73,167,72,7,220,166,72,7,73,183,230,22,222,22,223,22,72,103,72,7,224,102,72,7,225,134,228,6,226,70,227,6,73,55,72,7,73,167,72,7,229,166,72,7,73,183,231,22,72,103,72,7,232,102,72,7,233,134,236,6,234,70,235,6,73,55,72,7,73,167,72,7,237,166,72,7,73,183,44,7,239,38,0,23,240,150,245,6,241,22,242,22,72,103,72,7,243,102,72,7,244,54,72,7,73,71,251,22,246,22,247,22,72,103,72,7,248,102,72,7,249,54,72,7,250,70,72,7,73,135,252,22,72,103,72,7,253,102,72,7,254,54,72,7,255,70,72,7,73,135,28,7,1,151,10,23,2,23,3,23,72,103,72,7,4,103,72,7,5,135,8,7,6,71,7,7,73,55,72,7,73,167,72,7,9,167,72,7,73,183,20,7,11,23,12,23,72,103,72,7,13,103,17,7,14,71,15,7,73,55,72,7,16,135,72,7,73,167,72,7,18,135,72,7,19,167,72,7,73,183,21,23,72,103,72,7,22,103,72,7,23,135,26,7,24,71,25,7,73,55,72,7,73,167,72,7,27,167,72,7,73,183,33,7,29,23,30,23,72,103,72,7,31,103,72,7,32,55,72,7,73,71,39,23,34,23,35,23,72,103,72,7,36,103,72,7,37,55,72,7,38,71,72,7,73,135,40,23,72,103,72,7,41,103,72,7,42,55,72,7,43,71,72,7,73,135,45,23,72,151,72,7,46,151,55,7,47,23,48,23,72,103,72,7,49,103,72,7,50,135,53,7,51,71,52,7,73,55,72,7,73,167,72,7,54,167,72,7,73,183,64,23,56,23,57,23,72,103,72,7,58,103,72,7,59,135,62,7,60,71,61,7,73,55,72,7,73,167,72,7,63,167,72,7,73,183,65,23,72,103,72,7,66,103,72,7,67,135,70,7,68,71,69,7,73,55,72,7,73,167,72,7,71,167,72,7,73,183,254,0,0,0,255,0,0,0,56,1,1,0,211,0,2,32,138,0,3,64,81,0,4,80,39,0,5,112,22,0,6,48,13,0,7,16,10,0,8,96,9,0,173,130,172,2,173,242,172,2,11,208,172,2,12,224,172,2,173,242,172,2,14,128,172,2,15,144,172,2,16,160,17,0,173,98,172,2,18,176,172,2,19,192,172,2,20,208,172,2,21,224,172,2,173,242,172,2,23,160,172,2,24,176,172,2,25,192,35,0,26,128,31,0,27,144,28,0,173,98,172,2,29,208,172,2,30,224,172,2,173,242,172,2,32,16,172,2,33,208,172,2,34,224,172,2,173,242,172,2,36,16,172,2,37,208,172,2,38,224,172,2,173,242,65,16,40,112,56,0,41,224,172,2,42,240,50,0,43,16,46,0,44,48,45,0,173,98,172,2,173,210,172,2,47,160,172,2,48,176,172,2,49,192,172,2,173,210,172,2,51,128,172,2,52,144,172,2,53,160,172,2,54,176,172,2,55,192,172,2,173,210,172,18,57,224,172,18,58,128,172,18,59,144,172,18,60,160,172,18,61,176,172,18,62,192,172,18,63,208,64,16,173,98,172,18,173,242,172,2,66,224,172,2,67,240,75,0,68,16,71,0,69,48,70,0,173,98,172,2,173,210,172,2,72,160,172,2,73,176,172,2,74,192,172,2,173,210,172,2,76,128,172,2,77,144,172,2,78,160,172,2,79,176,172,2,80,192,172,2,173,210,110,16,82,80,100,0,83,192,172,2,84,208,172,2,85,224,94,0,86,240,90,0,87,16,88,0,173,50,172,2,89,160,172,2,173,178,172,2,91,128,172,2,92,144,172,2,93,160,172,2,173,178,172,2,95,96,172,2,96,112,172,2,97,128,172,2,98,144,172,2,99,160,172,2,173,178,172,18,101,192,172,18,102,112,172,18,103,128,172,18,104,144,172,18,105,160,172,18,106,176,172,18,107,208,108,16,173,98,172,18,109,224,172,18,173,242,128,0,111,192,172,2,112,208,172,2,113,224,122,0,114,240,118,0,115,16,116,0,173,50,172,2,117,160,172,2,173,178,172,2,119,128,172,2,120,144,172,2,121,160,172,2,173,178,172,2,123,96,172,2,124,112,172,2,125,128,172,2,126,144,172,2,127,160,172,2,173,178,172,18,129,192,172,18,130,112,172,18,131,128,172,18,132,144,172,18,133,160,172,18,134,176,172,18,135,208,172,18,136,224,137,16,173,98,172,18,173,242,177,16,139,64,161,0,140,176,172,2,141,192,172,2,142,208,157,0,143,160,152,0,144,224,148,0,145,240,146,0,173,18,172,2,147,128,172,2,173,146,172,2,149,96,172,2,150,112,172,2,151,128,172,2,173,146,172,2,153,80,172,2,154,96,172,2,155,112,172,2,156,128,172,2,173,146,172,2,158,16,172,2,159,48,172,2,160,224,172,2,173,242,172,18,162,176,172,18,163,112,172,18,164,128,172,18,165,144,172,18,166,160,173,16,167,96,170,16,168,80,169,16,173,50,172,18,173,194,172,18,171,192,172,18,172,208,172,18,173,226,172,18,174,192,172,18,175,208,172,18,176,224,172,18,173,242,199,0,178,176,172,2,179,192,172,2,180,208,195,0,181,160,190,0,182,224,186,0,183,240,184,0,173,18,172,2,185,128,172,2,173,146,172,2,187,96,172,2,188,112,172,2,189,128,172,2,173,146,172,2,191,80,172,2,192,96,172,2,193,112,172,2,194,128,172,2,173,146,172,2,196,16,172,2,197,48,172,2,198,224,172,2,173,242,172,18,200,176,172,18,201,112,172,18,202,128,172,18,203,144,172,18,204,160,172,18,205,192,172,18,206,208,209,16,207,96,208,16,173,82,172,18,173,226,172,18,210,224,172,18,173,242,10,17,212,32,239,0,213,144,172,2,214,160,172,2,215,176,234,0,216,128,229,0,217,192,225,0,218,208,222,0,219,224,220,0,173,242,172,2,221,96,172,2,173,114,172,2,223,80,172,2,224,96,172,2,173,114,172,2,226,64,172,2,227,80,172,2,228,96,172,2,173,114,172,2,230,48,172,2,231,64,172,2,232,80,172,2,233,96,172,2,173,114,172,2,235,16,172,2,236,192,172,2,237,208,172,2,238,224,172,2,173,242,172,18,240,144,172,18,241,112,172,18,242,128,4,17,243,96,255,16,244,80,251,16,245,64,248,16,246,48,247,16,173,18,172,18,173,162,172,18,249,160,172,18,250,176,172,18,173,194,172,18,252,160,172,18,253,176,172,18,254,192,172,18,173,210,172,18,0,161,172,18,1,177,172,18,2,193,172,18,3,209,172,18,173,226,172,18,5,161,172,18,6,177,172,18,7,193,172,18,8,209,172,18,9,225,172,18,173,242,37,1,11,145,172,2,12,161,172,2,13,177,32,1,14,129,27,1,15,193,23,1,16,209,20,1,17,225,18,1,173,242,172,2,19,97,172,2,173,114,172,2,21,81,172,2,22,97,172,2,173,114,172,2,24,65,172,2,25,81,172,2,26,97,172,2,173,114,172,2,28,49,172,2,29,65,172,2,30,81,172,2,31,97,172,2,173,114,172,2,33,17,172,2,34,193,172,2,35,209,172,2,36,225,172,2,173,242,172,18,38,145,172,18,39,113,172,18,40,129,172,18,41,161,172,18,42,177,52,17,43,97,49,17,44,81,47,17,45,65,46,17,173,50,172,18,173,194,172,18,48,193,172,18,173,210,172,18,50,193,172,18,51,209,172,18,173,226,172,18,53,193,172,18,54,209,172,18,55,225,172,18,173,242,112,18,57,1,112,1,58,33,85,1,59,145,172,2,60,113,172,2,61,129,79,1,62,97,74,1,63,81,70,1,64,65,67,1,65,49,66,1,173,18,172,2,173,162,172,2,68,161,172,2,69,177,172,2,173,194,172,2,71,161,172,2,72,177,172,2,73,193,172,2,173,210,172,2,75,161,172,2,76,177,172,2,77,193,172,2,78,209,172,2,173,226,172,2,80,161,172,2,81,177,172,2,82,193,172,2,83,209,172,2,84,225,172,2,173,242,172,18,86,145,172,18,87,161,172,18,88,177,107,17,89,129,102,17,90,193,98,17,91,209,95,17,92,225,93,17,173,242,172,18,94,97,172,18,173,114,172,18,96,81,172,18,97,97,172,18,173,114,172,18,99,65,172,18,100,81,172,18,101,97,172,18,173,114,172,18,103,49,172,18,104,65,172,18,105,81,172,18,106,97,172,18,173,114,172,18,108,17,172,18,109,193,172,18,110,209,172,18,111,225,172,18,173,242,66,18,113,33,152,1,114,65,130,1,115,177,172,2,116,113,172,2,117,129,172,2,118,145,172,2,119,161,126,1,120,97,123,1,121,81,122,1,173,50,172,2,173,194,172,2,124,193,172,2,125,209,172,2,173,226,172,2,127,193,172,2,128,209,172,2,129,225,172,2,173,242,172,18,131,177,172,18,132,193,172,18,133,209,148,17,134,161,143,17,135,225,139,17,136,241,137,17,173,18,172,18,138,129,172,18,173,146,172,18,140,97,172,18,141,113,172,18,142,129,172,18,173,146,172,18,144,81,172,18,145,97,172,18,146,113,172,18,147,129,172,18,173,146,172,18,149,17,172,18,150,49,172,18,151,225,172,18,173,242,32,18,153,65,182,1,154,81,164,1,155,193,172,2,156,113,172,2,157,129,172,2,158,145,172,2,159,161,172,2,160,177,172,2,161,209,162,1,173,98,172,2,163,225,172,2,173,242,172,18,165,193,172,18,166,209,172,18,167,225,176,17,168,241,172,17,169,17,170,17,173,50,172,18,171,161,172,18,173,178,172,18,173,129,172,18,174,145,172,18,175,161,172,18,173,178,172,18,177,97,172,18,178,113,172,18,179,129,172,18,180,145,172,18,181,161,172,18,173,178,4,18,183,81,209,1,184,113,193,1,185,225,172,2,186,129,172,2,187,145,172,2,188,161,172,2,189,177,172,2,190,193,172,2,191,209,192,1,173,98,172,2,173,242,172,18,194,225,172,18,195,241,203,17,196,17,199,17,197,49,198,17,173,98,172,18,173,210,172,18,200,161,172,18,201,177,172,18,202,193,172,18,173,210,172,18,204,129,172,18,205,145,172,18,206,161,172,18,207,177,172,18,208,193,172,18,173,210,244,17,210,113,227,17,211,49,218,17,212,17,215,17,213,97,214,17,173,130,172,18,173,242,172,18,216,209,172,18,217,225,172,18,173,242,172,18,219,129,172,18,220,145,172,18,221,161,222,17,173,98,172,18,223,177,172,18,224,193,172,18,225,209,172,18,226,225,172,18,173,242,172,18,228,161,172,18,229,177,172,18,230,193,240,17,231,129,236,17,232,145,233,17,173,98,172,18,234,209,172,18,235,225,172,18,173,242,172,18,237,17,172,18,238,209,172,18,239,225,172,18,173,242,172,18,241,17,172,18,242,209,172,18,243,225,172,18,173,242,172,18,245,225,172,18,246,241,254,17,247,17,250,17,248,49,249,17,173,98,172,18,173,210,172,18,251,161,172,18,252,177,172,18,253,193,172,18,173,210,172,18,255,129,172,18,0,146,172,18,1,162,172,18,2,178,172,18,3,194,172,18,173,210,14,2,5,194,172,2,6,114,172,2,7,130,172,2,8,146,172,2,9,162,172,2,10,178,172,2,11,210,172,2,12,226,13,2,173,98,172,2,173,242,172,18,15,194,172,18,16,210,172,18,17,226,26,18,18,242,22,18,19,18,20,18,173,50,172,18,21,162,172,18,173,178,172,18,23,130,172,18,24,146,172,18,25,162,172,18,173,178,172,18,27,98,172,18,28,114,172,18,29,130,172,18,30,146,172,18,31,162,172,18,173,178,44,2,33,178,172,2,34,114,172,2,35,130,172,2,36,146,172,2,37,162,172,2,38,194,172,2,39,210,42,2,40,98,41,2,173,82,172,2,173,226,172,2,43,226,172,2,173,242,172,18,45,178,172,18,46,194,172,18,47,210,62,18,48,162,57,18,49,226,53,18,50,242,51,18,173,18,172,18,52,130,172,18,173,146,172,18,54,98,172,18,55,114,172,18,56,130,172,18,173,146,172,18,58,82,172,18,59,98,172,18,60,114,172,18,61,130,172,18,173,146,172,18,63,18,172,18,64,50,172,18,65,226,172,18,173,242,85,2,67,146,172,2,68,114,172,2,69,130,172,2,70,162,172,2,71,178,81,2,72,98,78,2,73,82,76,2,74,66,75,2,173,50,172,2,173,194,172,2,77,194,172,2,173,210,172,2,79,194,172,2,80,210,172,2,173,226,172,2,82,194,172,2,83,210,172,2,84,226,172,2,173,242,172,18,86,146,172,18,87,162,172,18,88,178,107,18,89,130,102,18,90,194,98,18,91,210,95,18,92,226,93,18,173,242,172,18,94,98,172,18,173,114,172,18,96,82,172,18,97,98,172,18,173,114,172,18,99,66,172,18,100,82,172,18,101,98,172,18,173,114,172,18,103,50,172,18,104,66,172,18,105,82,172,18,106,98,172,18,173,114,172,18,108,18,172,18,109,194,172,18,110,210,172,18,111,226,172,18,173,242,142,2,113,114,172,2,114,130,172,2,115,146,136,2,116,98,131,2,117,82,127,2,118,66,124,2,119,50,122,2,120,34,121,2,173,18,172,2,173,162,172,2,123,162,172,2,173,178,172,2,125,162,172,2,126,178,172,2,173,194,172,2,128,162,172,2,129,178,172,2,130,194,172,2,173,210,172,2,132,162,172,2,133,178,172,2,134,194,172,2,135,210,172,2,173,226,172,2,137,162,172,2,138,178,172,2,139,194,172,2,140,210,172,2,141,226,172,2,173,242,172,18,143,114,172,18,144,130,172,18,145,146,166,18,146,98,161,18,147,82,157,18,148,66,154,18,149,50,152,18,150,34,151,18,173,18,172,18,173,162,172,18,153,162,172,18,173,178,172,18,155,162,172,18,156,178,172,18,173,194,172,18,158,162,172,18,159,178,172,18,160,194,172,18,173,210,172,18,162,162,172,18,163,178,172,18,164,194,172,18,165,210,172,18,173,226,172,18,167,162,172,18,168,178,172,18,169,194,172,18,170,210,172,18,171,226,172,18,173,242,254,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,81,0,0,165,3,0,0,166,3,0,0,65,0,0,0,140,1,0,0,141,1,0,0,240,0,0,0,22,0,0,0,23,0,0,0,74,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,105,0,0,0,247,0,0,0,248,0,0,0,249,0,0,0,142,1,0,0,250,0,0,0,143,1,0,0,251,0,0,0,144,1,0,0,252,0,0,0,20,0,0,0,24,0,0,0,145,1,0,0,253,0,0,0,146,1,0,0,254,0,0,0,147,1,0,0,255,0,0,0,0,0,0,0,80,81,0,0,21,0,0,0,167,3,0,0,168,3,0,0,0,0,0,0,112,81,0,0,169,3,0,0,170,3,0,0,171,3,0,0,1,0,0,0,1,0,0,0,0,0,0,0,120,81,0,0,169,3,0,0,172,3,0,0,171,3,0,0,148,1,0,0,106,0,0,0,0,0,0,0,136,81,0,0,173,3,0,0,174,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,81,0,0,175,3,0,0,176,3,0,0,65,0,0,0,149,1,0,0,150,1,0,0,240,0,0,0,22,0,0,0,23,0,0,0,75,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,104,0,0,0,241,0,0,0,242,0,0,0,243,0,0,0,76,0,0,0,0,0,0,0,160,81,0,0,21,0,0,0,177,3,0,0,178,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,81,0,0,179,3,0,0,180,3,0,0,65,0,0,0,20,0,0,0,21,0,0,0,240,0,0,0,22,0,0,0,23,0,0,0,74,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,106,0,0,0,0,1,0,0,1,1,0,0,2,1,0,0,0,0,0,0,192,81,0,0,21,0,0,0,181,3,0,0,182,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,81,0,0,183,3,0,0,184,3,0,0,65,0,0,0,20,0,0,0,21,0,0,0,240,0,0,0,22,0,0,0,23,0,0,0,77,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,104,0,0,0,241,0,0,0,242,0,0,0,243,0,0,0,151,1,0,0,3,1,0,0,152,1,0,0,4,1,0,0,153,1,0,0,5,1,0,0,0,0,0,0,208,81,0,0,21,0,0,0,185,3,0,0,186,3,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,2,0,0,0,254,255,255,255,1,0,0,0,253,255,255,255,0,0,0,0,253,255,255,255,255,255,255,255,253,255,255,255,254,255,255,255,254,255,255,255,253,255,255,255,255,255,255,255,253,255,255,255,0,0,0,0,253,255,255,255,1,0,0,0,254,255,255,255,2,0,0,0,255,255,255,255,3,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,255,255,255,255,1,0,0,0,254,255,255,255,0,0,0,0,254,255,255,255,255,255,255,255,254,255,255,255,254,255,255,255,255,255,255,255,254,255,255,255,0,0,0,0,254,255,255,255,1,0,0,0,255,255,255,255,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,82,0,0,187,3,0,0,188,3,0,0,65,0,0,0,20,0,0,0,21,0,0,0,240,0,0,0,22,0,0,0,23,0,0,0,78,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,104,0,0,0,241,0,0,0,242,0,0,0,243,0,0,0,154,1,0,0,6,1,0,0,21,0,0,0,25,0,0,0,22,0,0,0,26,0,0,0,155,1,0,0,7,1,0,0,156,1,0,0,8,1,0,0,23,0,0,0,27,0,0,0,0,0,0,0,8,82,0,0,21,0,0,0,189,3,0,0,190,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,82,0,0,191,3,0,0,192,3,0,0,65,0,0,0,157,1,0,0,158,1,0,0,240,0,0,0,22,0,0,0,23,0,0,0,74,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,107,0,0,0,9,1,0,0,10,1,0,0,11,1,0,0,159,1,0,0,12,1,0,0,160,1,0,0,13,1,0,0,24,0,0,0,28,0,0,0,161,1,0,0,14,1,0,0,162,1,0,0,15,1,0,0,163,1,0,0,16,1,0,0,0,0,0,0,40,82,0,0,21,0,0,0,193,3,0,0,194,3,0,0,0,0,0,0,72,82,0,0,19,0,0,0,195,3,0,0,164,1,0,0,0,0,0,0,192,82,0,0,19,0,0,0,196,3,0,0,165,1,0,0,0,0,0,0,176,82,0,0,19,0,0,0,197,3,0,0,166,1,0,0,0,0,0,0,160,82,0,0,19,0,0,0,198,3,0,0,167,1,0,0,0,0,0,0,104,82,0,0,19,0,0,0,199,3,0,0,168,1,0,0,0,0,0,0,88,82,0,0,200,3,0,0,201,3,0,0,169,1,0,0,6,0,0,0,5,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,148,155,208,60,182,145,192,60,246,122,151,60,156,20,75,60,197,0,232,59,39,219,97,59,184,92,187,58,182,145,192,60,135,195,177,60,124,213,139,60,144,119,59,60,111,42,214,59,177,125,80,59,22,245,172,58,246,122,151,60,124,213,139,60,153,254,91,60,129,119,19,60,4,120,168,59,82,1,36,59,128,13,136,58,156,20,75,60,144,119,59,60,129,119,19,60,40,179,197,59,39,219,97,59,57,223,219,58,173,101,54,58,197,0,232,59,111,42,214,59,4,120,168,59,39,219,97,59,202,2,1,59,183,47,123,58,126,95,208,57,39,219,97,59,177,125,80,59,82,1,36,59,57,223,219,58,183,47,123,58,38,135,244,57,134,219,74,57,184,92,187,58,22,245,172,58,128,13,136,58,173,101,54,58,126,95,208,57,134,219,74,57,134,70,168,56,0,0,0,0,144,82,0,0,202,3,0,0,203,3,0,0,170,1,0,0,0,0,0,0,208,82,0,0,19,0,0,0,204,3,0,0,171,1,0,0,0,0,0,0,224,82,0,0,19,0,0,0,205,3,0,0,172,1,0,0,0,0,0,0,240,82,0,0,19,0,0,0,206,3,0,0,173,1,0,0,0,0,0,0,0,83,0,0,19,0,0,0,207,3,0,0,174,1,0,0,0,0,0,0,16,83,0,0,208,3,0,0,209,3,0,0,210,3,0,0,0,0,0,0,24,83,0,0,211,3,0,0,212,3,0,0,213,3,0,0,175,1,0,0,176,1,0,0,17,1,0,0,22,0,0,0,23,0,0,0,177,1,0,0,1,0,0,0,214,3,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,40,83,0,0,211,3,0,0,215,3,0,0,213,3,0,0,175,1,0,0,176,1,0,0,17,1,0,0,22,0,0,0,23,0,0,0,177,1,0,0,18,1,0,0,214,3,0,0,107,0,0,0,108,0,0,0,1,0,0,0,0,0,0,0,56,83,0,0,21,0,0,0,216,3,0,0,217,3,0,0,0,0,0,0,72,83,0,0,218,3,0,0,219,3,0,0,220,3,0,0,178,1,0,0,179,1,0,0,17,1,0,0,22,0,0,0,23,0,0,0,180,1,0,0,19,1,0,0,221,3,0,0,108,0,0,0,109,0,0,0,2,0,0,0,0,0,0,0,88,83,0,0,21,0,0,0,222,3,0,0,223,3,0,0,0,0,0,0,104,83,0,0,21,0,0,0,224,3,0,0,225,3,0,0,0,0,0,0,136,83,0,0,21,0,0,0,226,3,0,0,227,3,0,0,0,0,0,0,120,83,0,0,21,0,0,0,228,3,0,0,229,3,0,0,0,0,0,0,152,83,0,0,21,0,0,0,230,3,0,0,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,83,0,0,232,3,0,0,233,3,0,0,65,0,0,0,20,0,0,0,21,0,0,0,240,0,0,0,22,0,0,0,23,0,0,0,79,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,104,0,0,0,241,0,0,0,242,0,0,0,243,0,0,0,80,0,0,0,181,1,0,0,20,1,0,0,182,1,0,0,21,1,0,0,183,1,0,0,22,1,0,0,184,1,0,0,23,1,0,0,0,0,0,0,120,218,117,60,45,46,196,60,242,29,1,61,60,13,29,61,238,237,54,61,1,78,79,61,100,132,102,61,98,203,124,61,25,38,137,61,199,146,147,61,94,183,157,61,78,157,167,61,224,75,177,61,82,201,186,61,186,26,196,61,86,68,205,61,212,73,214,61,207,46,223,61,98,245,231,61,44,160,240,61,68,49,249,61,99,213,0,62,33,7,5,62,165,46,9,62,119,76,13,62,162,97,17,62,105,110,21,62,17,115,25,62,164,112,29,62,35,103,33,62,88,87,37,62,255,64,41,62,36,37,45,62,201,3,49,62,47,221,52,62,154,177,56,62,145,129,60,62],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+133120);allocate([18,77,64,62,31,20,68,62,128,215,71,62,53,151,75,62,63,83,79,62,225,11,83,62,93,193,86,62,180,115,90,62,108,35,94,62,66,208,97,62,120,122,101,62,83,34,105,62,210,199,108,62,244,106,112,62,65,12,116,62,117,171,119,62,212,72,123,62,92,228,126,62,41,63,129,62,124,11,131,62,228,214,132,62,165,161,134,62,223,107,136,62,114,53,138,62,93,254,139,62,227,198,141,62,193,142,143,62,92,86,145,62,113,29,147,62,33,228,148,62,143,170,150,62,151,112,152,62,126,54,154,62,1,252,155,62,64,193,157,62,127,134,159,62,90,75,161,62,52,16,163,62,237,212,164,62,133,153,166,62,28,94,168,62,180,34,170,62,75,231,171,62,193,171,173,62,88,112,175,62,17,53,177,62,202,249,178,62,165,190,180,62,161,131,182,62,191,72,184,62,31,14,186,62,162,211,187,62,70,153,189,62,78,95,191,62,120,37,193,62,230,235,194,62,183,178,196,62,204,121,198,62,70,65,200,62,3,9,202,62,36,209,203,62,170,153,205,62,149,98,207,62,6,44,209,62,220,245,210,62,22,192,212,62,215,138,214,62,252,85,216,62,201,33,218,62,28,238,219,62,212,186,221,62,51,136,223,62,59,86,225,62,200,36,227,62,220,243,228,62,185,195,230,62,29,148,232,62,40,101,234,62,219,54,236,62,87,9,238,62,123,220,239,62,104,176,241,62,253,132,243,62,92,90,245,62,131,48,247,62,83,7,249,62,13,223,250,62,145,183,252,62,0,145,254,62,156,53,0,63,28,35,1,63,18,17,2,63,126,255,2,63,95,238,3,63,181,221,4,63,129,205,5,63,211,189,6,63,155,174,7,63,216,159,8,63,155,145,9,63,228,131,10,63,180,118,11,63,249,105,12,63,213,93,13,63,55,82,14,63,48,71,15,63,159,60,16,63,181,50,17,63,82,41,18,63,134,32,19,63,97,24,20,63,195,16,21,63,187,9,22,63,92,3,23,63,147,253,23,63,114,248,24,63,249,243,25,63,40,240,26,63,238,236,27,63,108,234,28,63,146,232,29,63,96,231,30,63,230,230,31,63,20,231,32,63,12,232,33,63,171,233,34,63,3,236,35,63,36,239,36,63,254,242,37,63,144,247,38,63,235,252,39,63,16,3,41,63,255,9,42,63,165,17,43,63,38,26,44,63,129,35,45,63,165,45,46,63,147,56,47,63,91,68,48,63,13,81,49,63,137,94,50,63,240,108,51,63,49,124,52,63,76,140,53,63,98,157,54,63,83,175,55,63,64,194,56,63,6,214,57,63,200,234,58,63,134,0,60,63,64,23,61,63,228,46,62,63,132,71,63,63,49,97,64,63,217,123,65,63,141,151,66,63,78,180,67,63,28,210,68,63,246,240,69,63,220,16,71,63,223,49,72,63,0,84,73,63,62,119,74,63,153,155,75,63,18,193,76,63,201,231,77,63,140,15,79,63,143,56,80,63,191,98,81,63,46,142,82,63,203,186,83,63,184,232,84,63,211,23,86,63,61,72,87,63,230,121,88,63,239,172,89,63,55,225,90,63,223,22,92,63,215,77,93,63,47,134,94,63,232,191,95,63,18,251,96,63,155,55,98,63,151,117,99,63,3,181,100,63,241,245,101,63,97,56,103,63,66,124,104,63,181,193,105,63,171,8,107,63,51,81,108,63,95,155,109,63,29,231,110,63,127,52,112,63,132,131,113,63,44,212,114,63,137,38,116,63,171,122,117,63,129,208,118,63,11,40,120,63,107,129,121,63,160,220,122,63,155,57,124,63,124,152,125,63,51,249,126,63,224,45,128,63,34,224,128,63,96,147,129,63,153,71,130,63,34,253,130,63,83,179,131,63,127,106,132,63,251,34,133,63,114,220,133,63,230,150,134,63,168,82,135,63,19,15,136,63,33,205,136,63,42,140,137,63,48,76,138,63,132,13,139,63,213,207,139,63,201,147,140,63,184,88,141,63,247,30,142,63,50,230,142,63,16,175,143,63,62,121,144,63,103,68,145,63,52,17,146,63,80,223,146,63,188,174,147,63,204,127,148,63,215,81,149,63,217,37,150,63,43,251,150,63,204,209,151,63,17,170,152,63,249,131,153,63,49,95,154,63,96,60,155,63,51,27,156,63,85,251,156,63,110,221,157,63,43,193,158,63,139,166,159,63,227,141,160,63,222,118,161,63,208,97,162,63,186,78,163,63,71,61,164,63,31,46,165,63,155,32,166,63,98,21,167,63,32,12,168,63,213,4,169,63,214,255,169,63,34,253,170,63,101,252,171,63,244,253,172,63,205,1,174,63,70,8,175,63,182,16,176,63,25,28,177,63,116,41,178,63,193,57,179,63,173,76,180,63,229,97,181,63,99,122,182,63,45,149,183,63,234,178,184,63,153,211,185,63,144,247,186,63,38,30,188,63,2,72,189,63,37,117,190,63,60,165,191,63,237,216,192,63,228,15,194,63,119,74,195,63,81,136,196,63,25,202,197,63,208,15,199,63,33,89,200,63,97,166,201,63,144,247,202,63,85,77,204,63,9,167,205,63,83,5,207,63,224,103,208,63,87,207,209,63,100,59,211,63,176,172,212,63,146,34,214,63,6,158,215,63,184,30,217,63,169,164,218,63,127,48,220,63,59,194,221,63,50,90,223,63,14,248,224,63,203,156,226,63,195,71,228,63,240,249,229,63,83,179,231,63,235,115,233,63,12,60,235,63,95,12,237,63,143,228,238,63,151,197,240,63,121,175,242,63,135,162,244,63,107,159,246,63,34,166,248,63,2,183,250,63,7,211,252,63,47,250,254,63,188,150,0,64,112,182,1,64,135,220,2,64,171,9,4,64,176,61,5,64,62,121,6,64,169,188,7,64,112,8,9,64,230,92,10,64,136,186,11,64,255,33,13,64,201,147,14,64,140,16,16,64,242,152,17,64,161,45,19,64,192,207,20,64,246,127,22,64,62,63,24,64,19,15,26,64,111,240,27,64,205,228,29,64,208,237,31,64,69,13,34,64,78,69,36,64,95,152,38,64,238,8,41,64,107,154,43,64,156,80,46,64,194,47,49,64,29,61,52,64,57,127,55,64,160,253,58,64,253,193,62,64,111,216,66,64,177,80,71,64,20,63,76,64,114,191,81,64,161,248,87,64,79,35,95,64,120,151,103,64,146,232,113,64,179,41,127,64,25,226,136,64,133,177,152,64,63,85,5,67,0,0,0,0,184,83,0,0,21,0,0,0,234,3,0,0,235,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,83,0,0,236,3,0,0,237,3,0,0,65,0,0,0,20,0,0,0,21,0,0,0,240,0,0,0,22,0,0,0,23,0,0,0,74,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,110,0,0,0,24,1,0,0,25,1,0,0,26,1,0,0,185,1,0,0,27,1,0,0,25,0,0,0,29,0,0,0,186,1,0,0,28,1,0,0,187,1,0,0,29,1,0,0,188,1,0,0,30,1,0,0,189,1,0,0,31,1,0,0,190,1,0,0,32,1,0,0,191,1,0,0,33,1,0,0,192,1,0,0,34,1,0,0,8,0,0,0,253,255,255,255,9,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,7,0,0,0,244,255,255,255,245,255,255,255,9,0,0,0,248,255,255,255,2,0,0,0,7,0,0,0,244,255,255,255,12,0,0,0,243,255,255,255,2,0,0,0,243,255,255,255,2,0,0,0,12,0,0,0,1,0,0,0,249,255,255,255,1,0,0,0,6,0,0,0,254,255,255,255,246,255,255,255,254,255,255,255,252,255,255,255,243,255,255,255,243,255,255,255,245,255,255,255,248,255,255,255,243,255,255,255,253,255,255,255,244,255,255,255,247,255,255,255,10,0,0,0,4,0,0,0,11,0,0,0,9,0,0,0,243,255,255,255,248,255,255,255,248,255,255,255,247,255,255,255,245,255,255,255,7,0,0,0,247,255,255,255,12,0,0,0,7,0,0,0,7,0,0,0,12,0,0,0,6,0,0,0,252,255,255,255,251,255,255,255,253,255,255,255,0,0,0,0,243,255,255,255,2,0,0,0,244,255,255,255,253,255,255,255,247,255,255,255,0,0,0,0,249,255,255,255,5,0,0,0,12,0,0,0,250,255,255,255,12,0,0,0,255,255,255,255,253,255,255,255,6,0,0,0,254,255,255,255,12,0,0,0,250,255,255,255,243,255,255,255,252,255,255,255,248,255,255,255,11,0,0,0,243,255,255,255,12,0,0,0,248,255,255,255,4,0,0,0,7,0,0,0,5,0,0,0,1,0,0,0,5,0,0,0,253,255,255,255,10,0,0,0,253,255,255,255,3,0,0,0,249,255,255,255,6,0,0,0,12,0,0,0,248,255,255,255,249,255,255,255,250,255,255,255,254,255,255,255,254,255,255,255,11,0,0,0,255,255,255,255,246,255,255,255,243,255,255,255,12,0,0,0,248,255,255,255,10,0,0,0,249,255,255,255,3,0,0,0,251,255,255,255,253,255,255,255,252,255,255,255,2,0,0,0,253,255,255,255,7,0,0,0,246,255,255,255,244,255,255,255,250,255,255,255,11,0,0,0,5,0,0,0,244,255,255,255,6,0,0,0,249,255,255,255,5,0,0,0,250,255,255,255,7,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,4,0,0,0,251,255,255,255,9,0,0,0,11,0,0,0,11,0,0,0,243,255,255,255,4,0,0,0,7,0,0,0,4,0,0,0,12,0,0,0,2,0,0,0,255,255,255,255,4,0,0,0,4,0,0,0,252,255,255,255,244,255,255,255,254,255,255,255,7,0,0,0,248,255,255,255,251,255,255,255,249,255,255,255,246,255,255,255,4,0,0,0,11,0,0,0,9,0,0,0,12,0,0,0,0,0,0,0,248,255,255,255,1,0,0,0,243,255,255,255,243,255,255,255,254,255,255,255,248,255,255,255,2,0,0,0,253,255,255,255,254,255,255,255,254,255,255,255,3,0,0,0,250,255,255,255,9,0,0,0,252,255,255,255,247,255,255,255,8,0,0,0,12,0,0,0,10,0,0,0,7,0,0,0,0,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,7,0,0,0,251,255,255,255,11,0,0,0,246,255,255,255,243,255,255,255,250,255,255,255,245,255,255,255,0,0,0,0,10,0,0,0,7,0,0,0,12,0,0,0,1,0,0,0,250,255,255,255,253,255,255,255,250,255,255,255,12,0,0,0,10,0,0,0,247,255,255,255,12,0,0,0,252,255,255,255,243,255,255,255,8,0,0,0,248,255,255,255,244,255,255,255,243,255,255,255,0,0,0,0,248,255,255,255,252,255,255,255,3,0,0,0,3,0,0,0,7,0,0,0,8,0,0,0,5,0,0,0,7,0,0,0,10,0,0,0,249,255,255,255,255,255,255,255,7,0,0,0,1,0,0,0,244,255,255,255,3,0,0,0,246,255,255,255,5,0,0,0,6,0,0,0,2,0,0,0,252,255,255,255,3,0,0,0,246,255,255,255,243,255,255,255,0,0,0,0,243,255,255,255,5,0,0,0,243,255,255,255,249,255,255,255,244,255,255,255,12,0,0,0,243,255,255,255,3,0,0,0,245,255,255,255,8,0,0,0,249,255,255,255,12,0,0,0,252,255,255,255,7,0,0,0,6,0,0,0,246,255,255,255,12,0,0,0,8,0,0,0,247,255,255,255,255,255,255,255,249,255,255,255,250,255,255,255,254,255,255,255,251,255,255,255,0,0,0,0,12,0,0,0,244,255,255,255,5,0,0,0,249,255,255,255,5,0,0,0,3,0,0,0,246,255,255,255,8,0,0,0,243,255,255,255,249,255,255,255,249,255,255,255,252,255,255,255,5,0,0,0,253,255,255,255,254,255,255,255,255,255,255,255,249,255,255,255,2,0,0,0,9,0,0,0,5,0,0,0,245,255,255,255,245,255,255,255,243,255,255,255,251,255,255,255,243,255,255,255,255,255,255,255,6,0,0,0,0,0,0,0,255,255,255,255,5,0,0,0,253,255,255,255,5,0,0,0,2,0,0,0,252,255,255,255,243,255,255,255,252,255,255,255,12,0,0,0,247,255,255,255,250,255,255,255,247,255,255,255,6,0,0,0,244,255,255,255,246,255,255,255,248,255,255,255,252,255,255,255,10,0,0,0,2,0,0,0,12,0,0,0,253,255,255,255,7,0,0,0,12,0,0,0,12,0,0,0,12,0,0,0,249,255,255,255,243,255,255,255,250,255,255,255,5,0,0,0,252,255,255,255,9,0,0,0,253,255,255,255,4,0,0,0,7,0,0,0,255,255,255,255,12,0,0,0,2,0,0,0,249,255,255,255,6,0,0,0,251,255,255,255,1,0,0,0,243,255,255,255,11,0,0,0,244,255,255,255,5,0,0,0,253,255,255,255,7,0,0,0,254,255,255,255,250,255,255,255,7,0,0,0,248,255,255,255,12,0,0,0,249,255,255,255,243,255,255,255,249,255,255,255,245,255,255,255,244,255,255,255,1,0,0,0,253,255,255,255,12,0,0,0,12,0,0,0,2,0,0,0,250,255,255,255,3,0,0,0,0,0,0,0,252,255,255,255,3,0,0,0,254,255,255,255,243,255,255,255,255,255,255,255,243,255,255,255,1,0,0,0,9,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,250,255,255,255,1,0,0,0,255,255,255,255,3,0,0,0,12,0,0,0,9,0,0,0,1,0,0,0,12,0,0,0,6,0,0,0,255,255,255,255,247,255,255,255,255,255,255,255,3,0,0,0,243,255,255,255,243,255,255,255,246,255,255,255,5,0,0,0,7,0,0,0,7,0,0,0,10,0,0,0,12,0,0,0,12,0,0,0,251,255,255,255,12,0,0,0,9,0,0,0,6,0,0,0,3,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,243,255,255,255,6,0,0,0,10,0,0,0,2,0,0,0,244,255,255,255,2,0,0,0,3,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,250,255,255,255,2,0,0,0,6,0,0,0,12,0,0,0,243,255,255,255,9,0,0,0,244,255,255,255,10,0,0,0,3,0,0,0,248,255,255,255,4,0,0,0,249,255,255,255,9,0,0,0,245,255,255,255,12,0,0,0,252,255,255,255,250,255,255,255,1,0,0,0,12,0,0,0,2,0,0,0,248,255,255,255,6,0,0,0,247,255,255,255,7,0,0,0,252,255,255,255,2,0,0,0,3,0,0,0,3,0,0,0,254,255,255,255,6,0,0,0,3,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,253,255,255,255,8,0,0,0,248,255,255,255,7,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,245,255,255,255,251,255,255,255,250,255,255,255,252,255,255,255,246,255,255,255,11,0,0,0,251,255,255,255,10,0,0,0,251,255,255,255,248,255,255,255,253,255,255,255,12,0,0,0,246,255,255,255,5,0,0,0,247,255,255,255,0,0,0,0,8,0,0,0,255,255,255,255,12,0,0,0,250,255,255,255,4,0,0,0,250,255,255,255,6,0,0,0,245,255,255,255,246,255,255,255,12,0,0,0,248,255,255,255,7,0,0,0,4,0,0,0,254,255,255,255,6,0,0,0,7,0,0,0,254,255,255,255,0,0,0,0,254,255,255,255,12,0,0,0,251,255,255,255,248,255,255,255,251,255,255,255,2,0,0,0,7,0,0,0,250,255,255,255,10,0,0,0,12,0,0,0,247,255,255,255,243,255,255,255,248,255,255,255,248,255,255,255,251,255,255,255,243,255,255,255,251,255,255,255,254,255,255,255,8,0,0,0,248,255,255,255,9,0,0,0,243,255,255,255,247,255,255,255,245,255,255,255,247,255,255,255,0,0,0,0,1,0,0,0,248,255,255,255,1,0,0,0,254,255,255,255,7,0,0,0,252,255,255,255,9,0,0,0,1,0,0,0,254,255,255,255,1,0,0,0,255,255,255,255,252,255,255,255,11,0,0,0,250,255,255,255,12,0,0,0,245,255,255,255,244,255,255,255,247,255,255,255,250,255,255,255,4,0,0,0,3,0,0,0,7,0,0,0,7,0,0,0,12,0,0,0,5,0,0,0,5,0,0,0,10,0,0,0,8,0,0,0,0,0,0,0,252,255,255,255,2,0,0,0,8,0,0,0,247,255,255,255,12,0,0,0,251,255,255,255,243,255,255,255,0,0,0,0,7,0,0,0,2,0,0,0,12,0,0,0,255,255,255,255,2,0,0,0,1,0,0,0,7,0,0,0,5,0,0,0,11,0,0,0,7,0,0,0,247,255,255,255,3,0,0,0,5,0,0,0,6,0,0,0,248,255,255,255,243,255,255,255,252,255,255,255,248,255,255,255,9,0,0,0,251,255,255,255,9,0,0,0,253,255,255,255,253,255,255,255,252,255,255,255,249,255,255,255,253,255,255,255,244,255,255,255,6,0,0,0,5,0,0,0,8,0,0,0,0,0,0,0,249,255,255,255,6,0,0,0,250,255,255,255,12,0,0,0,243,255,255,255,6,0,0,0,251,255,255,255,254,255,255,255,1,0,0,0,246,255,255,255,3,0,0,0,10,0,0,0,4,0,0,0,1,0,0,0,8,0,0,0,252,255,255,255,254,255,255,255,254,255,255,255,2,0,0,0,243,255,255,255,2,0,0,0,244,255,255,255,12,0,0,0,12,0,0,0,254,255,255,255,243,255,255,255,0,0,0,0,250,255,255,255,4,0,0,0,1,0,0,0,9,0,0,0,3,0,0,0,250,255,255,255,246,255,255,255,253,255,255,255,251,255,255,255,253,255,255,255,243,255,255,255,255,255,255,255,1,0,0,0,7,0,0,0,5,0,0,0,12,0,0,0,245,255,255,255,4,0,0,0,254,255,255,255,5,0,0,0,249,255,255,255,243,255,255,255,9,0,0,0,247,255,255,255,251,255,255,255,7,0,0,0,1,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,248,255,255,255,7,0,0,0,6,0,0,0,249,255,255,255,252,255,255,255,249,255,255,255,1,0,0,0,248,255,255,255,11,0,0,0,249,255,255,255,248,255,255,255,243,255,255,255,6,0,0,0,244,255,255,255,248,255,255,255,2,0,0,0,4,0,0,0,3,0,0,0,9,0,0,0,10,0,0,0,251,255,255,255,12,0,0,0,3,0,0,0,250,255,255,255,251,255,255,255,250,255,255,255,7,0,0,0,8,0,0,0,253,255,255,255,9,0,0,0,248,255,255,255,2,0,0,0,244,255,255,255,2,0,0,0,8,0,0,0,245,255,255,255,254,255,255,255,246,255,255,255,3,0,0,0,244,255,255,255,243,255,255,255,249,255,255,255,247,255,255,255,245,255,255,255,0,0,0,0,246,255,255,255,251,255,255,255,5,0,0,0,253,255,255,255,11,0,0,0,8,0,0,0,254,255,255,255,243,255,255,255,255,255,255,255,12,0,0,0,255,255,255,255,248,255,255,255,0,0,0,0,9,0,0,0,243,255,255,255,245,255,255,255,244,255,255,255,251,255,255,255,246,255,255,255,254,255,255,255,246,255,255,255,11,0,0,0,253,255,255,255,9,0,0,0,254,255,255,255,243,255,255,255,2,0,0,0,253,255,255,255,3,0,0,0,2,0,0,0,247,255,255,255,243,255,255,255,252,255,255,255,0,0,0,0,252,255,255,255,6,0,0,0,253,255,255,255,246,255,255,255,252,255,255,255,12,0,0,0,254,255,255,255,249,255,255,255,250,255,255,255,245,255,255,255,252,255,255,255,9,0,0,0,6,0,0,0,253,255,255,255,6,0,0,0,11,0,0,0,243,255,255,255,11,0,0,0,251,255,255,255,5,0,0,0,11,0,0,0,11,0,0,0,12,0,0,0,6,0,0,0,7,0,0,0,251,255,255,255,12,0,0,0,254,255,255,255,255,255,255,255,12,0,0,0,0,0,0,0,7,0,0,0,252,255,255,255,248,255,255,255,253,255,255,255,254,255,255,255,249,255,255,255,1,0,0,0,250,255,255,255,7,0,0,0,243,255,255,255,244,255,255,255,248,255,255,255,243,255,255,255,249,255,255,255,254,255,255,255,250,255,255,255,248,255,255,255,248,255,255,255,5,0,0,0,250,255,255,255,247,255,255,255,251,255,255,255,255,255,255,255,252,255,255,255,5,0,0,0,243,255,255,255,7,0,0,0,248,255,255,255,10,0,0,0,1,0,0,0,5,0,0,0,5,0,0,0,243,255,255,255,1,0,0,0,0,0,0,0,10,0,0,0,243,255,255,255,9,0,0,0,12,0,0,0,10,0,0,0,255,255,255,255,5,0,0,0,248,255,255,255,10,0,0,0,247,255,255,255,255,255,255,255,11,0,0,0,1,0,0,0,243,255,255,255,247,255,255,255,253,255,255,255,250,255,255,255,2,0,0,0,255,255,255,255,246,255,255,255,1,0,0,0,12,0,0,0,243,255,255,255,1,0,0,0,248,255,255,255,246,255,255,255,8,0,0,0,245,255,255,255,10,0,0,0,250,255,255,255,2,0,0,0,243,255,255,255,3,0,0,0,250,255,255,255,7,0,0,0,243,255,255,255,12,0,0,0,247,255,255,255,246,255,255,255,246,255,255,255,251,255,255,255,249,255,255,255,246,255,255,255,248,255,255,255,248,255,255,255,243,255,255,255,4,0,0,0,250,255,255,255,8,0,0,0,5,0,0,0,3,0,0,0,12,0,0,0,8,0,0,0,243,255,255,255,252,255,255,255,2,0,0,0,253,255,255,255,253,255,255,255,5,0,0,0,243,255,255,255,10,0,0,0,244,255,255,255,4,0,0,0,243,255,255,255,5,0,0,0,255,255,255,255,247,255,255,255,9,0,0,0,252,255,255,255,3,0,0,0,0,0,0,0,3,0,0,0,3,0,0,0,247,255,255,255,244,255,255,255,1,0,0,0,250,255,255,255,1,0,0,0,3,0,0,0,2,0,0,0,4,0,0,0,248,255,255,255,246,255,255,255,246,255,255,255,246,255,255,255,9,0,0,0,8,0,0,0,243,255,255,255,12,0,0,0,12,0,0,0,248,255,255,255,244,255,255,255,250,255,255,255,251,255,255,255,2,0,0,0,2,0,0,0,3,0,0,0,7,0,0,0,10,0,0,0,6,0,0,0,11,0,0,0,248,255,255,255,6,0,0,0,8,0,0,0,8,0,0,0,244,255,255,255,249,255,255,255,10,0,0,0,250,255,255,255,5,0,0,0,253,255,255,255,247,255,255,255,253,255,255,255,9,0,0,0,255,255,255,255,243,255,255,255,255,255,255,255,5,0,0,0,253,255,255,255,249,255,255,255,253,255,255,255,4,0,0,0,248,255,255,255,254,255,255,255,248,255,255,255,3,0,0,0,4,0,0,0,2,0,0,0,12,0,0,0,12,0,0,0,2,0,0,0,251,255,255,255,3,0,0,0,11,0,0,0,6,0,0,0,247,255,255,255,11,0,0,0,243,255,255,255,3,0,0,0,255,255,255,255,7,0,0,0,12,0,0,0,11,0,0,0,255,255,255,255,12,0,0,0,4,0,0,0,253,255,255,255,0,0,0,0,253,255,255,255,6,0,0,0,4,0,0,0,245,255,255,255,4,0,0,0,12,0,0,0,2,0,0,0,252,255,255,255,2,0,0,0,1,0,0,0,246,255,255,255,250,255,255,255,248,255,255,255,1,0,0,0,243,255,255,255,7,0,0,0,245,255,255,255,1,0,0,0,243,255,255,255,12,0,0,0,245,255,255,255,243,255,255,255,6,0,0,0,0,0,0,0,11,0,0,0,243,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,4,0,0,0,243,255,255,255,3,0,0,0,247,255,255,255,254,255,255,255,247,255,255,255,8,0,0,0,250,255,255,255,253,255,255,255,243,255,255,255,250,255,255,255,248,255,255,255,254,255,255,255,5,0,0,0,247,255,255,255,8,0,0,0,10,0,0,0,2,0,0,0,7,0,0,0,3,0,0,0,247,255,255,255,255,255,255,255,250,255,255,255,255,255,255,255,255,255,255,255,9,0,0,0,5,0,0,0,11,0,0,0,254,255,255,255,11,0,0,0,253,255,255,255,12,0,0,0,248,255,255,255,3,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,255,255,255,255,4,0,0,0,0,0,0,0,10,0,0,0,3,0,0,0,250,255,255,255,4,0,0,0,5,0,0,0,243,255,255,255,0,0,0,0,246,255,255,255,5,0,0,0,5,0,0,0,8,0,0,0,12,0,0,0,11,0,0,0,8,0,0,0,9,0,0,0,9,0,0,0,250,255,255,255,7,0,0,0,252,255,255,255,8,0,0,0,244,255,255,255,246,255,255,255,4,0,0,0,246,255,255,255,9,0,0,0,7,0,0,0,3,0,0,0,12,0,0,0,4,0,0,0,9,0,0,0,249,255,255,255,10,0,0,0,254,255,255,255,7,0,0,0,0,0,0,0,12,0,0,0,254,255,255,255,255,255,255,255,250,255,255,255,0,0,0,0,245,255,255,255,0,0,0,0,216,83,0,0,21,0,0,0,238,3,0,0,239,3,0,0,0,0,0,0,232,83,0,0,240,3,0,0,241,3,0,0,65,0,0,0,193,1,0,0,194,1,0,0,28,0,0,0,22,0,0,0,23,0,0,0,81,0,0,0,8,0,0,0,111,0,0,0,195,1,0,0,35,1,0,0,0,0,0,0,248,83,0,0,21,0,0,0,242,3,0,0,243,3,0,0,0,0,0,0,8,84,0,0,244,3,0,0,245,3,0,0,65,0,0,0,196,1,0,0,197,1,0,0,28,0,0,0,22,0,0,0,23,0,0,0,9,0,0,0,198,1,0,0,36,1,0,0,26,0,0,0,30,0,0,0,0,0,0,0,24,84,0,0,21,0,0,0,246,3,0,0,247,3,0,0,0,0,0,0,40,84,0,0,248,3,0,0,249,3,0,0,65,0,0,0,199,1,0,0,200,1,0,0,28,0,0,0,22,0,0,0,23,0,0,0,82,0,0,0,201,1,0,0,37,1,0,0,27,0,0,0,31,0,0,0,202,1,0,0,38,1,0,0,0,0,0,0,56,84,0,0,250,3,0,0,251,3,0,0,65,0,0,0,203,1,0,0,204,1,0,0,28,0,0,0,22,0,0,0,23,0,0,0,83,0,0,0,205,1,0,0,39,1,0,0,28,0,0,0,32,0,0,0,206,1,0,0,40,1,0,0,0,0,0,0,72,84,0,0,252,3,0,0,253,3,0,0,65,0,0,0,207,1,0,0,208,1,0,0,28,0,0,0,22,0,0,0,23,0,0,0,84,0,0,0,209,1,0,0,41,1,0,0,29,0,0,0,33,0,0,0,0,0,0,0,88,84,0,0,254,3,0,0,255,3,0,0,65,0,0,0,210,1,0,0,211,1,0,0,28,0,0,0,22,0,0,0,23,0,0,0,85,0,0,0,212,1,0,0,42,1,0,0,30,0,0,0,34,0,0,0,0,0,0,0,104,84,0,0,21,0,0,0,0,4,0,0,1,4,0,0,0,0,0,0,120,84,0,0,21,0,0,0,2,4,0,0,3,4,0,0,0,0,0,0,136,84,0,0,21,0,0,0,4,4,0,0,5,4,0,0,0,0,0,0,152,84,0,0,21,0,0,0,6,4,0,0,7,4,0,0,0,0,0,0,168,84,0,0,8,4,0,0,9,4,0,0,65,0,0,0,213,1,0,0,214,1,0,0,28,0,0,0,22,0,0,0,23,0,0,0,10,0,0,0,215,1,0,0,43,1,0,0,216,1,0,0,44,1,0,0,31,0,0,0,35,0,0,0,32,0,0,0,36,0,0,0,217,1,0,0,45,1,0,0,33,0,0,0,37,0,0,0,34,0,0,0,38,0,0,0,35,0,0,0,39,0,0,0,109,0,0,0,110,0,0,0,218,1,0,0,46,1,0,0,219,1,0,0,220,1,0,0,36,0,0,0,40,0,0,0,221,1,0,0,222,1,0,0,0,0,0,0,184,84,0,0,21,0,0,0,10,4,0,0,11,4,0,0,0,0,0,0,200,84,0,0,12,4,0,0,13,4,0,0,65,0,0,0,223,1,0,0,224,1,0,0,28,0,0,0,22,0,0,0,23,0,0,0,86,0,0,0,11,0,0,0,112,0,0,0,37,0,0,0,41,0,0,0,0,0,0,0,216,84,0,0,21,0,0,0,14,4,0,0,15,4,0,0,0,0,0,0,248,84,0,0,16,4,0,0,17,4,0,0,65,0,0,0,225,1,0,0,226,1,0,0,28,0,0,0,22,0,0,0,23,0,0,0,84,0,0,0,111,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,47,1,0,0,227,1,0,0,48,1,0,0,228,1,0,0,49,1,0,0,229,1,0,0,0,0,0,0,232,84,0,0,21,0,0,0,18,4,0,0,19,4,0,0,0,0,0,0,8,85,0,0,21,0,0,0,20,4,0,0,21,4,0,0,0,0,0,0,24,85,0,0,22,4,0,0,23,4,0,0,65,0,0,0,230,1,0,0,231,1,0,0,28,0,0,0,22,0,0,0,23,0,0,0,90,0,0,0,42,0,0,0,38,0,0,0,50,1,0,0,232,1,0,0,51,1,0,0,233,1,0,0,0,0,0,0,40,85,0,0,21,0,0,0,24,4,0,0,25,4,0,0,0,0,0,0,56,85,0,0,26,4,0,0,27,4,0,0,65,0,0,0,234,1,0,0,235,1,0,0,28,0,0,0,22,0,0,0,23,0,0,0,91,0,0,0,52,1,0,0,236,1,0,0,43,0,0,0,39,0,0,0,237,1,0,0,0,0,0,0,72,85,0,0,28,4,0,0,29,4,0,0,238,1,0,0,0,0,0,0,88,85,0,0,30,4,0,0,31,4,0,0,239,1,0,0,0,0,0,0,104,85,0,0,32,4,0,0,33,4,0,0,240,1,0,0,0,0,0,0,120,85,0,0,34,4,0,0,35,4,0,0,241,1,0,0,0,0,0,0,136,85,0,0,36,4,0,0,37,4,0,0,242,1,0,0,0,0,0,0,152,85,0,0,38,4,0,0,39,4,0,0,243,1,0,0,0,0,0,0,168,85,0,0,40,4,0,0,41,4,0,0,244,1,0,0,0,0,0,0,184,85,0,0,42,4,0,0,43,4,0,0,245,1,0,0,0,0,0,0,200,85,0,0,44,4,0,0,45,4,0,0,246,1,0,0,0,0,0,0,216,85,0,0,46,4,0,0,47,4,0,0,247,1,0,0,0,0,0,0,232,85,0,0,48,4,0,0,49,4,0,0,248,1,0,0,0,0,0,0,248,85,0,0,50,4,0,0,51,4,0,0,249,1,0,0,0,0,0,0,8,86,0,0,52,4,0,0,53,4,0,0,250,1,0,0,0,0,0,0,24,86,0,0,54,4,0,0,55,4,0,0,251,1,0,0,0,0,0,0,40,86,0,0,56,4,0,0,57,4,0,0,252,1,0,0,0,0,0,0,56,86,0,0,58,4,0,0,59,4,0,0,253,1,0,0,0,0,0,0,72,86,0,0,60,4,0,0,61,4,0,0,254,1,0,0,0,0,0,0,88,86,0,0,62,4,0,0,63,4,0,0,255,1,0,0,0,0,0,0,104,86,0,0,64,4,0,0,65,4,0,0,0,2,0,0,0,0,0,0,120,86,0,0,66,4,0,0,67,4,0,0,1,2,0,0,0,0,0,0,136,86,0,0,68,4,0,0,69,4,0,0,2,2,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,152,86,0,0,70,4,0,0,71,4,0,0,3,2,0,0,0,0,0,0,168,86,0,0,72,4,0,0,73,4,0,0,4,2,0,0,0,0,0,0,184,86,0,0,74,4,0,0,75,4,0,0,5,2,0,0,0,0,0,0,200,86,0,0,76,4,0,0,77,4,0,0,6,2,0,0,0,0,0,0,216,86,0,0,78,4,0,0,79,4,0,0,7,2,0,0,0,0,0,0,232,86,0,0,80,4,0,0,81,4,0,0,8,2,0,0,0,0,0,0,248,86,0,0,82,4,0,0,83,4,0,0,9,2,0,0,0,0,0,0,8,87,0,0,84,4,0,0,85,4,0,0,10,2,0,0,0,0,0,0,24,87,0,0,86,4,0,0,87,4,0,0,11,2,0,0,0,0,0,0,40,87,0,0,88,4,0,0,89,4,0,0,12,2,0,0,0,0,0,0,56,87,0,0,90,4,0,0,91,4,0,0,13,2,0,0,0,0,0,0,72,87,0,0,92,4,0,0,93,4,0,0,14,2,0,0,0,0,0,0,88,87,0,0,94,4,0,0,95,4,0,0,15,2,0,0,0,0,0,0,104,87,0,0,96,4,0,0,97,4,0,0,16,2,0,0,0,0,0,0,120,87,0,0,98,4,0,0,99,4,0,0,17,2,0,0,0,0,0,0,136,87,0,0,100,4,0,0,101,4,0,0,18,2,0,0,0,0,0,0,152,87,0,0,102,4,0,0,103,4,0,0,19,2,0,0,0,0,0,0,168,87,0,0,104,4,0,0,105,4,0,0,20,2,0,0,0,0,0,0,184,87,0,0,106,4,0,0,107,4,0,0,21,2,0,0,0,0,0,0,200,87,0,0,108,4,0,0,109,4,0,0,22,2,0,0,0,0,0,0,216,87,0,0,110,4,0,0,111,4,0,0,23,2,0,0,0,0,0,0,248,87,0,0,21,0,0,0,112,4,0,0,113,4,0,0,0,0,0,0,232,87,0,0,21,0,0,0,114,4,0,0,115,4,0,0,0,0,0,0,8,88,0,0,21,0,0,0,116,4,0,0,117,4,0,0,0,0,0,0,24,88,0,0,118,4,0,0,119,4,0,0,65,0,0,0,20,0,0,0,21,0,0,0,28,0,0,0,22,0,0,0,23,0,0,0,85,0,0,0,92,0,0,0,0,0,0,0,56,88,0,0,120,4,0,0,121,4,0,0,65,0,0,0,24,2,0,0,25,2,0,0,28,0,0,0,22,0,0,0,23,0,0,0,86,0,0,0,112,0,0,0,44,0,0,0,40,0,0,0,45,0,0,0,41,0,0,0,46,0,0,0,42,0,0,0,0,0,0,0,40,88,0,0,21,0,0,0,122,4,0,0,123,4,0,0,0,0,0,0,72,88,0,0,21,0,0,0,124,4,0,0,125,4,0,0,0,0,0,0,88,88,0,0,126,4,0,0,127,4,0,0,65,0,0,0,20,0,0,0,21,0,0,0,28,0,0,0,22,0,0,0,23,0,0,0,87,0,0,0,93,0,0,0,0,0,0,0,120,88,0,0,128,4,0,0,129,4,0,0,65,0,0,0,26,2,0,0,27,2,0,0,28,0,0,0,22,0,0,0,23,0,0,0,113,0,0,0,47,0,0,0,43,0,0,0,0,0,0,0,104,88,0,0,21,0,0,0,130,4,0,0,131,4,0,0,0,0,0,0,152,88,0,0,132,4,0,0,133,4,0,0,65,0,0,0,28,2,0,0,29,2,0,0,28,0,0,0,22,0,0,0,23,0,0,0,114,0,0,0,48,0,0,0,44,0,0,0,49,0,0,0,45,0,0,0,50,0,0,0,46,0,0,0,0,0,0,0,136,88,0,0,21,0,0,0,134,4,0,0,135,4,0,0,0,0,0,0,184,88,0,0,136,4,0,0,137,4,0,0,65,0,0,0,30,2,0,0,31,2,0,0,28,0,0,0,22,0,0,0,23,0,0,0,115,0,0,0,51,0,0,0,47,0,0,0,52,0,0,0,48,0,0,0,53,0,0,0,49,0,0,0,54,0,0,0,50,0,0,0,55,0,0,0,51,0,0,0,0,0,0,0,168,88,0,0,21,0,0,0,138,4,0,0,139,4,0,0,0,0,0,0,216,88,0,0,140,4,0,0,141,4,0,0,65,0,0,0,32,2,0,0,33,2,0,0,28,0,0,0,22,0,0,0,23,0,0,0,116,0,0,0,56,0,0,0,52,0,0,0,57,0,0,0,53,0,0,0,58,0,0,0,54,0,0,0,59,0,0,0,55,0,0,0,0,0,0,0,200,88,0,0,21,0,0,0,142,4,0,0,143,4,0,0,0,0,0,0,248,88,0,0,144,4,0,0,145,4,0,0,65,0,0,0,34,2,0,0,35,2,0,0,28,0,0,0,22,0,0,0,23,0,0,0,117,0,0,0,60,0,0,0,56,0,0,0,61,0,0,0,57,0,0,0,62,0,0,0,58,0,0,0,0,0,0,0,232,88,0,0,21,0,0,0,146,4,0,0,147,4,0,0,0,0,0,0,8,89,0,0,148,4,0,0,149,4,0,0,65,0,0,0,36,2,0,0,37,2,0,0,28,0,0,0,22,0,0,0,23,0,0,0,1,0,0,0,38,2,0,0,53,1,0,0,39,2,0,0,54,1,0,0,40,2,0,0,63,0,0,0,59,0,0,0,55,1,0,0,41,2,0,0,56,1,0,0,42,2,0,0,57,1,0,0,43,2,0,0,64,0,0,0,60,0,0,0,0,0,0,0,24,89,0,0,21,0,0,0,150,4,0,0,151,4,0,0,0,0,0,0,40,89,0,0,152,4,0,0,153,4,0,0,65,0,0,0,44,2,0,0,45,2,0,0,28,0,0,0,22,0,0,0,23,0,0,0,2,0,0,0,46,2,0,0,58,1,0,0,47,2,0,0,59,1,0,0,48,2,0,0,65,0,0,0,61,0,0,0,66,0,0,0,62,0,0,0,67,0,0,0,63,0,0,0,68,0,0,0,64,0,0,0,69,0,0,0,65,0,0,0,70,0,0,0,66,0,0,0,71,0,0,0,67,0,0,0,60,1,0,0,49,2,0,0,61,1,0,0,50,2,0,0,72,0,0,0,68,0,0,0,0,0,0,0,56,89,0,0,19,0,0,0,154,4,0,0,51,2,0,0,0,0,0,0,72,89,0,0,21,0,0,0,155,4,0,0,156,4,0,0,0,0,0,0,88,89,0,0,19,0,0,0,157,4,0,0,52,2,0,0,41,92,15,62,41,92,15,62,102,247,228,62,102,247,228,62,102,247,228,62,0,0,0,0,120,89,0,0,158,4,0,0,159,4,0,0,65,0,0,0,20,0,0,0,21,0,0,0,28,0,0,0,22,0,0,0,23,0,0,0,94,0,0,0,160,4,0,0,73,0,0,0,69,0,0,0,74,0,0,0,70,0,0,0,75,0,0,0,71,0,0,0,76,0,0,0,72,0,0,0,62,1,0,0,53,2,0,0,63,1,0,0,54,2,0,0,77,0,0,0,73,0,0,0,64,1,0,0,55,2,0,0,65,1,0,0,56,2,0,0,66,1,0,0,57,2,0,0,78,0,0,0,74,0,0,0,67,1,0,0,58,2,0,0,0,0,0,0,104,89,0,0,21,0,0,0,161,4,0,0,162,4,0,0,0,0,0,0,232,89,0,0,163,4,0,0,164,4,0,0,59,2,0,0,0,0,0,0,216,89,0,0,165,4,0,0,166,4,0,0,60,2,0,0,0,0,0,0,200,89,0,0,167,4,0,0,168,4,0,0,61,2,0,0,0,0,0,0,184,89,0,0,169,4,0,0,170,4,0,0,62,2,0,0,0,0,0,0,136,89,0,0,171,4,0,0,172,4,0,0,63,2,0,0,0,0,0,0,152,89,0,0,173,4,0,0,174,4,0,0,64,2,0,0,0,0,0,0,168,89,0,0,175,4,0,0,176,4,0,0,65,2,0,0,16,0,0,0,11,0,0,0,10,0,0,0,16,0,0,0,24,0,0,0,40,0,0,0,51,0,0,0,61,0,0,0,12,0,0,0,12,0,0,0,14,0,0,0,19,0,0,0,26,0,0,0,58,0,0,0,60,0,0,0,55,0,0,0,14,0,0,0,13,0,0,0,16,0,0,0,24,0,0,0,40,0,0,0,57,0,0,0,69,0,0,0,56,0,0,0,14,0,0,0,17,0,0,0,22,0,0,0,29,0,0,0,51,0,0,0,87,0,0,0,80,0,0,0,62,0,0,0,18,0,0,0,22,0,0,0,37,0,0,0,56,0,0,0,68,0,0,0,109,0,0,0,103,0,0,0,77,0,0,0,24,0,0,0,35,0,0,0,55,0,0,0,64,0,0,0,81,0,0,0,104,0,0,0,113,0,0,0,92,0,0,0,49,0,0,0,64,0,0,0,78,0,0,0,87,0,0,0,103,0,0,0,121,0,0,0,120,0,0,0,101,0,0,0,72,0,0,0,92,0,0,0,95,0,0,0,98,0,0,0,112,0,0,0,100,0,0,0,103,0,0,0,99,0,0,0,17,0,0,0,18,0,0,0,24,0,0,0,47,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,18,0,0,0,21,0,0,0,26,0,0,0,66,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,24,0,0,0,26,0,0,0,56,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,47,0,0,0,66,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,93,49,6,0,115,49,6,0,147,49,6,0,184,49,6,0,210,49,6,0,241,49,6,0,6,50,6,0,35,50,6,0,77,50,6,0,141,50,6,0,172,50,6,0,195,50,6,0,217,50,6,0,237,50,6,0,42,51,6,0,90,51,6,0,118,51,6,0,153,51,6,0,208,51,6,0,7,52,6,0,30,52,6,0,62,52,6,0,104,52,6,0,181,52,6,0,208,52,6,0,251,52,6,0,23,53,6,0,60,53,6,0,98,53,6,0,135,53,6,0,154,53,6,0,175,53,6,0,194,53,6,0,213,53,6,0,250,53,6,0,15,54,6,0,35,54,6,0,68,54,6,0,90,54,6,0,137,54,6,0,177,54,6,0,210,54,6,0,243,54,6,0,34,55,6,0,51,55,6,0,79,55,6,0,141,55,6,0,180,55,6,0,219,55,6,0,239,55,6,0,29,56,6,0,69,56,6,0,97,56,6,0,134,56,6,0,168,56,6,0,210,56,6,0,253,56,6,0,27,57,6,0,73,57,6,0,113,57,6,0,152,57,6,0,195,57,6,0,240,57,6,0,32,58,6,0,74,58,6,0,119,58,6,0,154,58,6,0,184,58,6,0,214,58,6,0,12,59,6,0,54,59,6,0,85,59,6,0,120,59,6,0,159,59,6,0,180,59,6,0,200,59,6,0,253,59,6,0,12,60,6,0,74,60,6,0,140,60,6,0,182,60,6,0,226,60,6,0,9,61,6,0,37,61,6,0,80,61,6,0,107,61,6,0,127,61,6,0,150,61,6,0,163,61,6,0,203,61,6,0,0,62,6,0,60,62,6,0,106,62,6,0,139,62,6,0,178,62,6,0,203,62,6,0,243,62,6,0,22,63,6,0,46,63,6,0,82,63,6,0,119,63,6,0,125,63,6,0,182,63,6,0,240,63,6,0,15,64,6,0,30,64,6,0,59,64,6,0,89,64,6,0,118,64,6,0,143,64,6,0,168,64,6,0,234,64,6,0,36,65,6,0,90,65,6,0,142,65,6,0,162,65,6,0,185,65,6,0,223,65,6,0,6,66,6,0,72,66,6,0,132,66,6,0,181,66,6,0,217,66,6,0,7,67,6,0,34,67,6,0,90,67,6,0,133,67,6,0,0,0,0,0,64,6,0,0,128,62,0,0,0,0,0,0,136,19,0,0,1,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,16,0,0,0,9,0,0,0,2,0,0,0,3,0,0,0,10,0,0,0,17,0,0,0,24,0,0,0,32,0,0,0,25,0,0,0,18,0,0,0,11,0,0,0,4,0,0,0,5,0,0,0,12,0,0,0,19,0,0,0,26,0,0,0,33,0,0,0,40,0,0,0,48,0,0,0,41,0,0,0,34,0,0,0,27,0,0,0,20,0,0,0,13,0,0,0,6,0,0,0,7,0,0,0,14,0,0,0,21,0,0,0,28,0,0,0,35,0,0,0,42,0,0,0,49,0,0,0,56,0,0,0,57,0,0,0,50,0,0,0,43,0,0,0,36,0,0,0,29,0,0,0,22,0,0,0,15,0,0,0,23],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+143360);allocate([30,0,0,0,37,0,0,0,44,0,0,0,51,0,0,0,58,0,0,0,59,0,0,0,52,0,0,0,45,0,0,0,38,0,0,0,31,0,0,0,39,0,0,0,46,0,0,0,53,0,0,0,60,0,0,0,61,0,0,0,54,0,0,0,47,0,0,0,55,0,0,0,62,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,16,0,0,0,9,0,0,0,2,0,0,0,3,0,0,0,10,0,0,0,17,0,0,0,24,0,0,0,32,0,0,0,25,0,0,0,18,0,0,0,11,0,0,0,4,0,0,0,5,0,0,0,12,0,0,0,19,0,0,0,26,0,0,0,33,0,0,0,40,0,0,0,48,0,0,0,41,0,0,0,34,0,0,0,27,0,0,0,20,0,0,0,13,0,0,0,6,0,0,0,14,0,0,0,21,0,0,0,28,0,0,0,35,0,0,0,42,0,0,0,49,0,0,0,50,0,0,0,43,0,0,0,36,0,0,0,29,0,0,0,22,0,0,0,30,0,0,0,37,0,0,0,44,0,0,0,51,0,0,0,52,0,0,0,45,0,0,0,38,0,0,0,46,0,0,0,53,0,0,0,54,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,16,0,0,0,9,0,0,0,2,0,0,0,3,0,0,0,10,0,0,0,17,0,0,0,24,0,0,0,32,0,0,0,25,0,0,0,18,0,0,0,11,0,0,0,4,0,0,0,5,0,0,0,12,0,0,0,19,0,0,0,26,0,0,0,33,0,0,0,40,0,0,0,41,0,0,0,34,0,0,0,27,0,0,0,20,0,0,0,13,0,0,0,21,0,0,0,28,0,0,0,35,0,0,0,42,0,0,0,43,0,0,0,36,0,0,0,29,0,0,0,37,0,0,0,44,0,0,0,45,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,16,0,0,0,9,0,0,0,2,0,0,0,3,0,0,0,10,0,0,0,17,0,0,0,24,0,0,0,32,0,0,0,25,0,0,0,18,0,0,0,11,0,0,0,4,0,0,0,12,0,0,0,19,0,0,0,26,0,0,0,33,0,0,0,34,0,0,0,27,0,0,0,20,0,0,0,28,0,0,0,35,0,0,0,36,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,16,0,0,0,9,0,0,0,2,0,0,0,3,0,0,0,10,0,0,0,17,0,0,0,24,0,0,0,25,0,0,0,18,0,0,0,11,0,0,0,19,0,0,0,26,0,0,0,27,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,16,0,0,0,9,0,0,0,2,0,0,0,10,0,0,0,17,0,0,0,18,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,2,0,0,0,4,0,0,0,6,0,0,0,3,0,0,0,7,0,0,0,8,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,4,0,0,0,7,0,0,0,12,0,0,0,3,0,0,0,8,0,0,0,11,0,0,0,13,0,0,0,9,0,0,0,10,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,14,0,0,0,2,0,0,0,4,0,0,0,7,0,0,0,13,0,0,0,15,0,0,0,3,0,0,0,8,0,0,0,12,0,0,0,16,0,0,0,21,0,0,0,9,0,0,0,11,0,0,0,17,0,0,0,20,0,0,0,22,0,0,0,10,0,0,0,18,0,0,0,19,0,0,0,23,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,14,0,0,0,15,0,0,0,2,0,0,0,4,0,0,0,7,0,0,0,13,0,0,0,16,0,0,0,25,0,0,0,3,0,0,0,8,0,0,0,12,0,0,0,17,0,0,0,24,0,0,0,26,0,0,0,9,0,0,0,11,0,0,0,18,0,0,0,23,0,0,0,27,0,0,0,32,0,0,0,10,0,0,0,19,0,0,0,22,0,0,0,28,0,0,0,31,0,0,0,33,0,0,0,20,0,0,0,21,0,0,0,29,0,0,0,30,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,14,0,0,0,15,0,0,0,27,0,0,0,2,0,0,0,4,0,0,0,7,0,0,0,13,0,0,0,16,0,0,0,26,0,0,0,28,0,0,0,3,0,0,0,8,0,0,0,12,0,0,0,17,0,0,0,25,0,0,0,29,0,0,0,38,0,0,0,9,0,0,0,11,0,0,0,18,0,0,0,24,0,0,0,30,0,0,0,37,0,0,0,39,0,0,0,10,0,0,0,19,0,0,0,23,0,0,0,31,0,0,0,36,0,0,0,40,0,0,0,45,0,0,0,20,0,0,0,22,0,0,0,32,0,0,0,35,0,0,0,41,0,0,0,44,0,0,0,46,0,0,0,21,0,0,0,33,0,0,0,34,0,0,0,42,0,0,0,43,0,0,0,47,0,0,0,48,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,14,0,0,0,15,0,0,0,27,0,0,0,28,0,0,0,2,0,0,0,4,0,0,0,7,0,0,0,13,0,0,0,16,0,0,0,26,0,0,0,29,0,0,0,42,0,0,0,3,0,0,0,8,0,0,0,12,0,0,0,17,0,0,0,25,0,0,0,30,0,0,0,41,0,0,0,43,0,0,0,9,0,0,0,11,0,0,0,18,0,0,0,24,0,0,0,31,0,0,0,40,0,0,0,44,0,0,0,53,0,0,0,10,0,0,0,19,0,0,0,23,0,0,0,32,0,0,0,39,0,0,0,45,0,0,0,52,0,0,0,54,0,0,0,20,0,0,0,22,0,0,0,33,0,0,0,38,0,0,0,46,0,0,0,51,0,0,0,55,0,0,0,60,0,0,0,21,0,0,0,34,0,0,0,37,0,0,0,47,0,0,0,50,0,0,0,56,0,0,0,59,0,0,0,61,0,0,0,35,0,0,0,36,0,0,0,48,0,0,0,49,0,0,0,57,0,0,0,58,0,0,0,62,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,7,0,0,0,15,0,0,0,31,0,0,0,63,0,0,0,127,0,0,0,255,0,0,0,255,1,0,0,255,3,0,0,255,7,0,0,255,15,0,0,255,31,0,0,255,63,0,0,255,127,0,0,129,1,29,90,14,2,134,37,16,3,20,17,18,4,11,8,20,5,216,3,23,6,218,1,25,7,229,0,28,8,111,0,30,9,54,0,33,10,26,0,35,11,13,0,9,12,6,0,10,13,3,0,12,13,1,0,143,15,127,90,36,16,37,63,38,17,242,44,39,18,124,32,40,19,185,23,42,20,130,17,43,21,239,12,45,22,161,9,46,23,47,7,48,24,92,5,49,25,6,4,51,26,3,3,52,27,64,2,54,28,177,1,56,29,68,1,57,30,245,0,59,31,183,0,60,32,138,0,62,33,104,0,63,34,78,0,32,35,59,0,33,9,44,0,165,37,225,90,64,38,76,72,65,39,13,58,67,40,241,46,68,41,31,38,69,42,51,31,70,43,168,25,72,44,24,21,73,45,119,17,74,46,116,14,75,47,251,11,77,48,248,9,78,49,97,8,79,50,6,7,48,51,205,5,50,52,222,4,50,53,15,4,51,54,99,3,52,55,212,2,53,56,92,2,54,57,248,1,55,58,164,1,56,59,96,1,57,60,37,1,58,61,246,0,59,62,203,0,61,63,171,0,61,32,143,0,193,65,18,91,80,66,4,77,81,67,44,65,82,68,216,55,83,69,232,47,84,70,60,41,86,71,121,35,87,72,223,30,87,73,169,26,72,74,78,23,72,75,36,20,74,76,156,17,74,77,107,15,75,78,81,13,77,79,182,11,77,48,64,10,208,81,50,88,88,82,28,77,89,83,142,67,90,84,221,59,91,85,238,52,92,86,174,46,93,87,154,41,86,71,22,37,216,89,112,85,95,90,169,76,96,91,217,68,97,92,34,62,99,93,36,56,99,94,180,50,93,86,23,46,223,96,168,86,101,97,70,79,102,98,229,71,103,99,207,65,104,100,61,60,99,93,94,55,105,102,49,82,106,103,15,76,107,104,57,70,103,99,94,65,233,106,39,86,108,107,231,80,109,103,133,75,110,109,151,85,111,107,79,80,238,111,16,90,112,109,34,85,240,111,235,89,113,113,29,90,0,250,0,0,232,128,0,0,48,117,0,0,96,234,0,0,152,58,0,0,112,23,0,0,38,122,0,0,132,128,0,0,23,161,0,0,16,83,0,0,141,7,0,0,174,139,0,0,93,23,1,0,143,46,0,0,128,70,0,0,51,28,0,0,77,115,1,0,246,217,63,10,185,114,135,59,232,11,0,0,222,61,248,41,174,85,242,175,228,250,66,120,13,57,131,202,1,0,0,0,225,229,9,73,33,187,126,66,236,11,0,0,55,214,91,201,59,138,93,233,153,143,243,13,137,3,50,193,1,0,1,0,161,68,33,253,174,216,111,48,60,238,0,0,120,51,102,252,107,136,226,55,131,233,114,253,184,241,40,130,1,0,0,0,210,53,156,32,18,120,239,187,32,238,0,0,191,42,86,52,6,205,76,153,33,87,44,109,93,140,214,208,1,0,0,0,98,215,84,160,206,41,81,93,208,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,251,243,132,247,82,165,46,24,72,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,252,243,152,3,109,82,158,242,72,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,240,240,240,240,204,204,204,204,170,170,170,170,0,255,0,255,240,240,240,240,204,204,204,204,0,0,255,255,0,255,0,255,240,240,240,240,15,15,15,15,51,51,51,51,85,85,85,85,0,255,0,255,15,15,15,15,51,51,51,51,0,0,255,255,0,255,0,255,15,15,15,15,1,1,1,1,16,16,16,16,17,17,17,17,68,68,68,68,85,85,85,85,170,170,170,170,3,0,3,0,0,3,0,3,3,3,3,3,48,48,48,48,51,51,51,51,204,204,204,204,15,0,0,0,0,0,15,0,15,0,15,0,0,15,0,15,15,15,15,15,240,240,240,240,128,128,128,128,8,8,8,8,136,136,136,136,34,34,34,34,170,170,170,170,85,85,85,85,192,0,192,0,0,192,0,192,192,192,192,192,12,12,12,12,204,204,204,204,51,51,51,51,240,0,0,0,0,0,240,0,240,0,240,0,0,240,0,240,240,240,240,240,15,15,15,15,8,0,0,0,8,0,0,0,4,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,150,48,7,119,44,97,14,238,186,81,9,153,25,196,109,7,143,244,106,112,53,165,99,233,163,149,100,158,50,136,219,14,164,184,220,121,30,233,213,224,136,217,210,151,43,76,182,9,189,124,177,126,7,45,184,231,145,29,191,144,100,16,183,29,242,32,176,106,72,113,185,243,222,65,190,132,125,212,218,26,235,228,221,109,81,181,212,244,199,133,211,131,86,152,108,19,192,168,107,100,122,249,98,253,236,201,101,138,79,92,1,20,217,108,6,99,99,61,15,250,245,13,8,141,200,32,110,59,94,16,105,76,228,65,96,213,114,113,103,162,209,228,3,60,71,212,4,75,253,133,13,210,107,181,10,165,250,168,181,53,108,152,178,66,214,201,187,219,64,249,188,172,227,108,216,50,117,92,223,69,207,13,214,220,89,61,209,171,172,48,217,38,58,0,222,81,128,81,215,200,22,97,208,191,181,244,180,33,35,196,179,86,153,149,186,207,15,165,189,184,158,184,2,40,8,136,5,95,178,217,12,198,36,233,11,177,135,124,111,47,17,76,104,88,171,29,97,193,61,45,102,182,144,65,220,118,6,113,219,1,188,32,210,152,42,16,213,239,137,133,177,113,31,181,182,6,165,228,191,159,51,212,184,232,162,201,7,120,52,249,0,15,142,168,9,150,24,152,14,225,187,13,106,127,45,61,109,8,151,108,100,145,1,92,99,230,244,81,107,107,98,97,108,28,216,48,101,133,78,0,98,242,237,149,6,108,123,165,1,27,193,244,8,130,87,196,15,245,198,217,176,101,80,233,183,18,234,184,190,139,124,136,185,252,223,29,221,98,73,45,218,21,243,124,211,140,101,76,212,251,88,97,178,77,206,81,181,58,116,0,188,163,226,48,187,212,65,165,223,74,215,149,216,61,109,196,209,164,251,244,214,211,106,233,105,67,252,217,110,52,70,136,103,173,208,184,96,218,115,45,4,68,229,29,3,51,95,76,10,170,201,124,13,221,60,113,5,80,170,65,2,39,16,16,11,190,134,32,12,201,37,181,104,87,179,133,111,32,9,212,102,185,159,228,97,206,14,249,222,94,152,201,217,41,34,152,208,176,180,168,215,199,23,61,179,89,129,13,180,46,59,92,189,183,173,108,186,192,32,131,184,237,182,179,191,154,12,226,182,3,154,210,177,116,57,71,213,234,175,119,210,157,21,38,219,4,131,22,220,115,18,11,99,227,132,59,100,148,62,106,109,13,168,90,106,122,11,207,14,228,157,255,9,147,39,174,0,10,177,158,7,125,68,147,15,240,210,163,8,135,104,242,1,30,254,194,6,105,93,87,98,247,203,103,101,128,113,54,108,25,231,6,107,110,118,27,212,254,224,43,211,137,90,122,218,16,204,74,221,103,111,223,185,249,249,239,190,142,67,190,183,23,213,142,176,96,232,163,214,214,126,147,209,161,196,194,216,56,82,242,223,79,241,103,187,209,103,87,188,166,221,6,181,63,75,54,178,72,218,43,13,216,76,27,10,175,246,74,3,54,96,122,4,65,195,239,96,223,85,223,103,168,239,142,110,49,121,190,105,70,140,179,97,203,26,131,102,188,160,210,111,37,54,226,104,82,149,119,12,204,3,71,11,187,185,22,2,34,47,38,5,85,190,59,186,197,40,11,189,178,146,90,180,43,4,106,179,92,167,255,215,194,49,207,208,181,139,158,217,44,29,174,222,91,176,194,100,155,38,242,99,236,156,163,106,117,10,147,109,2,169,6,9,156,63,54,14,235,133,103,7,114,19,87,0,5,130,74,191,149,20,122,184,226,174,43,177,123,56,27,182,12,155,142,210,146,13,190,213,229,183,239,220,124,33,223,219,11,212,210,211,134,66,226,212,241,248,179,221,104,110,131,218,31,205,22,190,129,91,38,185,246,225,119,176,111,119,71,183,24,230,90,8,136,112,106,15,255,202,59,6,102,92,11,1,17,255,158,101,143,105,174,98,248,211,255,107,97,69,207,108,22,120,226,10,160,238,210,13,215,84,131,4,78,194,179,3,57,97,38,103,167,247,22,96,208,77,71,105,73,219,119,110,62,74,106,209,174,220,90,214,217,102,11,223,64,240,59,216,55,83,174,188,169,197,158,187,222,127,207,178,71,233,255,181,48,28,242,189,189,138,194,186,202,48,147,179,83,166,163,180,36,5,54,208,186,147,6,215,205,41,87,222,84,191,103,217,35,46,122,102,179,184,74,97,196,2,27,104,93,148,43,111,42,55,190,11,180,161,142,12,195,27,223,5,90,141,239,2,45,0,0,0,0,65,49,27,25,130,98,54,50,195,83,45,43,4,197,108,100,69,244,119,125,134,167,90,86,199,150,65,79,8,138,217,200,73,187,194,209,138,232,239,250,203,217,244,227,12,79,181,172,77,126,174,181,142,45,131,158,207,28,152,135,81,18,194,74,16,35,217,83,211,112,244,120,146,65,239,97,85,215,174,46,20,230,181,55,215,181,152,28,150,132,131,5,89,152,27,130,24,169,0,155,219,250,45,176,154,203,54,169,93,93,119,230,28,108,108,255,223,63,65,212,158,14,90,205,162,36,132,149,227,21,159,140,32,70,178,167,97,119,169,190,166,225,232,241,231,208,243,232,36,131,222,195,101,178,197,218,170,174,93,93,235,159,70,68,40,204,107,111,105,253,112,118,174,107,49,57,239,90,42,32,44,9,7,11,109,56,28,18,243,54,70,223,178,7,93,198,113,84,112,237,48,101,107,244,247,243,42,187,182,194,49,162,117,145,28,137,52,160,7,144,251,188,159,23,186,141,132,14,121,222,169,37,56,239,178,60,255,121,243,115,190,72,232,106,125,27,197,65,60,42,222,88,5,79,121,240,68,126,98,233,135,45,79,194,198,28,84,219,1,138,21,148,64,187,14,141,131,232,35,166,194,217,56,191,13,197,160,56,76,244,187,33,143,167,150,10,206,150,141,19,9,0,204,92,72,49,215,69,139,98,250,110,202,83,225,119,84,93,187,186,21,108,160,163,214,63,141,136,151,14,150,145,80,152,215,222,17,169,204,199,210,250,225,236,147,203,250,245,92,215,98,114,29,230,121,107,222,181,84,64,159,132,79,89,88,18,14,22,25,35,21,15,218,112,56,36,155,65,35,61,167,107,253,101,230,90,230,124,37,9,203,87,100,56,208,78,163,174,145,1,226,159,138,24,33,204,167,51,96,253,188,42,175,225,36,173,238,208,63,180,45,131,18,159,108,178,9,134,171,36,72,201,234,21,83,208,41,70,126,251,104,119,101,226,246,121,63,47,183,72,36,54,116,27,9,29,53,42,18,4,242,188,83,75,179,141,72,82,112,222,101,121,49,239,126,96,254,243,230,231,191,194,253,254,124,145,208,213,61,160,203,204,250,54,138,131,187,7,145,154,120,84,188,177,57,101,167,168,75,152,131,59,10,169,152,34,201,250,181,9,136,203,174,16,79,93,239,95,14,108,244,70,205,63,217,109,140,14,194,116,67,18,90,243,2,35,65,234,193,112,108,193,128,65,119,216,71,215,54,151,6,230,45,142,197,181,0,165,132,132,27,188,26,138,65,113,91,187,90,104,152,232,119,67,217,217,108,90,30,79,45,21,95,126,54,12,156,45,27,39,221,28,0,62,18,0,152,185,83,49,131,160,144,98,174,139,209,83,181,146,22,197,244,221,87,244,239,196,148,167,194,239,213,150,217,246,233,188,7,174,168,141,28,183,107,222,49,156,42,239,42,133,237,121,107,202,172,72,112,211,111,27,93,248,46,42,70,225,225,54,222,102,160,7,197,127,99,84,232,84,34,101,243,77,229,243,178,2,164,194,169,27,103,145,132,48,38,160,159,41,184,174,197,228,249,159,222,253,58,204,243,214,123,253,232,207,188,107,169,128,253,90,178,153,62,9,159,178,127,56,132,171,176,36,28,44,241,21,7,53,50,70,42,30,115,119,49,7,180,225,112,72,245,208,107,81,54,131,70,122,119,178,93,99,78,215,250,203,15,230,225,210,204,181,204,249,141,132,215,224,74,18,150,175,11,35,141,182,200,112,160,157,137,65,187,132,70,93,35,3,7,108,56,26,196,63,21,49,133,14,14,40,66,152,79,103,3,169,84,126,192,250,121,85,129,203,98,76,31,197,56,129,94,244,35,152,157,167,14,179,220,150,21,170,27,0,84,229,90,49,79,252,153,98,98,215,216,83,121,206,23,79,225,73,86,126,250,80,149,45,215,123,212,28,204,98,19,138,141,45,82,187,150,52,145,232,187,31,208,217,160,6,236,243,126,94,173,194,101,71,110,145,72,108,47,160,83,117,232,54,18,58,169,7,9,35,106,84,36,8,43,101,63,17,228,121,167,150,165,72,188,143,102,27,145,164,39,42,138,189,224,188,203,242,161,141,208,235,98,222,253,192,35,239,230,217,189,225,188,20,252,208,167,13,63,131,138,38,126,178,145,63,185,36,208,112,248,21,203,105,59,70,230,66,122,119,253,91,181,107,101,220,244,90,126,197,55,9,83,238,118,56,72,247,177,174,9,184,240,159,18,161,51,204,63,138,114,253,36,147,0,0,0,0,55,106,194,1,110,212,132,3,89,190,70,2,220,168,9,7,235,194,203,6,178,124,141,4,133,22,79,5,184,81,19,14,143,59,209,15,214,133,151,13,225,239,85,12,100,249,26,9,83,147,216,8,10,45,158,10,61,71,92,11,112,163,38,28,71,201,228,29,30,119,162,31,41,29,96,30,172,11,47,27,155,97,237,26,194,223,171,24,245,181,105,25,200,242,53,18,255,152,247,19,166,38,177,17,145,76,115,16,20,90,60,21,35,48,254,20,122,142,184,22,77,228,122,23,224,70,77,56,215,44,143,57,142,146,201,59,185,248,11,58,60,238,68,63,11,132,134,62,82,58,192,60,101,80,2,61,88,23,94,54,111,125,156,55,54,195,218,53,1,169,24,52,132,191,87,49,179,213,149,48,234,107,211,50,221,1,17,51,144,229,107,36,167,143,169,37,254,49,239,39,201,91,45,38,76,77,98,35,123,39,160,34,34,153,230,32,21,243,36,33,40,180,120,42,31,222,186,43,70,96,252,41,113,10,62,40,244,28,113,45,195,118,179,44,154,200,245,46,173,162,55,47,192,141,154,112,247,231,88,113,174,89,30,115,153,51,220,114,28,37,147,119,43,79,81,118,114,241,23,116,69,155,213,117,120,220,137,126,79,182,75,127,22,8,13,125,33,98,207,124,164,116,128,121,147,30,66,120,202,160,4,122,253,202,198,123,176,46,188,108,135,68,126,109,222,250,56,111,233,144,250,110,108,134,181,107,91,236,119,106,2,82,49,104,53,56,243,105,8,127,175,98,63,21,109,99,102,171,43,97,81,193,233,96,212,215,166,101,227,189,100,100,186,3,34,102,141,105,224,103,32,203,215,72,23,161,21,73,78,31,83,75,121,117,145,74,252,99,222,79,203,9,28,78,146,183,90,76,165,221,152,77,152,154,196,70,175,240,6,71,246,78,64,69,193,36,130,68,68,50,205,65,115,88,15,64,42,230,73,66,29,140,139,67,80,104,241,84,103,2,51,85,62,188,117,87,9,214,183,86,140,192,248,83,187,170,58,82,226,20,124,80,213,126,190,81,232,57,226,90,223,83,32,91,134,237,102,89,177,135,164,88,52,145,235,93,3,251,41,92,90,69,111,94,109,47,173,95,128,27,53,225,183,113,247,224,238,207,177,226,217,165,115,227,92,179,60,230,107,217,254,231,50,103,184,229,5,13,122,228,56,74,38,239,15,32,228,238,86,158,162,236,97,244,96,237,228,226,47,232,211,136,237,233,138,54,171,235,189,92,105,234,240,184,19,253,199,210,209,252,158,108,151,254,169,6,85,255,44,16,26,250,27,122,216,251,66,196,158,249,117,174,92,248,72,233,0,243,127,131,194,242,38,61,132,240,17,87,70,241,148,65,9,244,163,43,203,245,250,149,141,247,205,255,79,246,96,93,120,217,87,55,186,216,14,137,252,218,57,227,62,219,188,245,113,222,139,159,179,223,210,33,245,221,229,75,55,220,216,12,107,215,239,102,169,214,182,216,239,212,129,178,45,213,4,164,98,208,51,206,160,209,106,112,230,211,93,26,36,210,16,254,94,197,39,148,156,196,126,42,218,198,73,64,24,199,204,86,87,194,251,60,149,195,162,130,211,193,149,232,17,192,168,175,77,203,159,197,143,202,198,123,201,200,241,17,11,201,116,7,68,204,67,109,134,205,26,211,192,207,45,185,2,206,64,150,175,145,119,252,109,144,46,66,43,146,25,40,233,147,156,62,166,150,171,84,100,151,242,234,34,149,197,128,224,148,248,199,188,159,207,173,126,158,150,19,56,156,161,121,250,157,36,111,181,152,19,5,119,153,74,187,49,155,125,209,243,154,48,53,137,141,7,95,75,140,94,225,13,142,105,139,207,143,236,157,128,138,219,247,66,139,130,73,4,137,181,35,198,136,136,100,154,131,191,14,88,130,230,176,30,128,209,218,220,129,84,204,147,132,99,166,81,133,58,24,23,135,13,114,213,134,160,208,226,169,151,186,32,168,206,4,102,170,249,110,164,171,124,120,235,174,75,18,41,175,18,172,111,173,37,198,173,172,24,129,241,167,47,235,51,166,118,85,117,164,65,63,183,165,196,41,248,160,243,67,58,161,170,253,124,163,157,151,190,162,208,115,196,181,231,25,6,180,190,167,64,182,137,205,130,183,12,219,205,178,59,177,15,179,98,15,73,177,85,101,139,176,104,34,215,187,95,72,21,186,6,246,83,184,49,156,145,185,180,138,222,188,131,224,28,189,218,94,90,191,237,52,152,190,0,0,0,0,101,103,188,184,139,200,9,170,238,175,181,18,87,151,98,143,50,240,222,55,220,95,107,37,185,56,215,157,239,40,180,197,138,79,8,125,100,224,189,111,1,135,1,215,184,191,214,74,221,216,106,242,51,119,223,224,86,16,99,88,159,87,25,80,250,48,165,232,20,159,16,250,113,248,172,66,200,192,123,223,173,167,199,103,67,8,114,117,38,111,206,205,112,127,173,149,21,24,17,45,251,183,164,63,158,208,24,135,39,232,207,26,66,143,115,162,172,32,198,176,201,71,122,8,62,175,50,160,91,200,142,24,181,103,59,10,208,0,135,178,105,56,80,47,12,95,236,151,226,240,89,133,135,151,229,61,209,135,134,101,180,224,58,221,90,79,143,207,63,40,51,119,134,16,228,234,227,119,88,82,13,216,237,64,104,191,81,248,161,248,43,240,196,159,151,72,42,48,34,90,79,87,158,226,246,111,73,127,147,8,245,199,125,167,64,213,24,192,252,109,78,208,159,53,43,183,35,141,197,24,150,159,160,127,42,39,25,71,253,186,124,32,65,2,146,143,244,16,247,232,72,168,61,88,20,155,88,63,168,35,182,144,29,49,211,247,161,137,106,207,118,20,15,168,202,172,225,7,127,190,132,96,195,6,210,112,160,94,183,23,28,230,89,184,169,244,60,223,21,76,133,231,194,209,224,128,126,105,14,47,203,123,107,72,119,195,162,15,13,203,199,104,177,115,41,199,4,97,76,160,184,217,245,152,111,68,144,255,211,252,126,80,102,238,27,55,218,86,77,39,185,14,40,64,5,182,198,239,176,164,163,136,12,28,26,176,219,129,127,215,103,57,145,120,210,43,244,31,110,147,3,247,38,59,102,144,154,131,136,63,47,145,237,88,147,41,84,96,68,180,49,7,248,12,223,168,77,30,186,207,241,166,236,223,146,254,137,184,46,70,103,23,155,84,2,112,39,236,187,72,240,113,222,47,76,201,48,128,249,219,85,231,69,99,156,160,63,107,249,199,131,211,23,104,54,193,114,15,138,121,203,55,93,228,174,80,225,92,64,255,84,78,37,152,232,246,115,136,139,174,22,239,55,22,248,64,130,4,157,39,62,188,36,31,233,33,65,120,85,153,175,215,224,139,202,176,92,51,59,182,89,237,94,209,229,85,176,126,80,71,213,25,236,255,108,33,59,98,9,70,135,218,231,233,50,200,130,142,142,112,212,158,237,40,177,249,81,144,95,86,228,130,58,49,88,58,131,9,143,167,230,110,51,31,8,193,134,13,109,166,58,181,164,225,64,189,193,134,252,5,47,41,73,23,74,78,245,175,243,118,34,50,150,17,158,138,120,190,43,152,29,217,151,32,75,201,244,120,46,174,72,192,192,1,253,210,165,102,65,106,28,94,150,247,121,57,42,79,151,150,159,93,242,241,35,229,5,25,107,77,96,126,215,245,142,209,98,231,235,182,222,95,82,142,9,194,55,233,181,122,217,70,0,104,188,33,188,208,234,49,223,136,143,86,99,48,97,249,214,34,4,158,106,154,189,166,189,7,216,193,1,191,54,110,180,173,83,9,8,21,154,78,114,29,255,41,206,165,17,134,123,183,116,225,199,15,205,217,16,146,168,190,172,42,70,17,25,56,35,118,165,128,117,102,198,216,16,1,122,96,254,174,207,114,155,201,115,202,34,241,164,87,71,150,24,239,169,57,173,253,204,94,17,69,6,238,77,118,99,137,241,206,141,38,68,220,232,65,248,100,81,121,47,249,52,30,147,65,218,177,38,83,191,214,154,235,233,198,249,179,140,161,69,11,98,14,240,25,7,105,76,161,190,81,155,60,219,54,39,132,53,153,146,150,80,254,46,46,153,185,84,38,252,222,232,158,18,113,93,140,119,22,225,52,206,46,54,169,171,73,138,17,69,230,63,3,32,129,131,187,118,145,224,227,19,246,92,91,253,89,233,73,152,62,85,241,33,6,130,108,68,97,62,212,170,206,139,198,207,169,55,126,56,65,127,214,93,38,195,110,179,137,118,124,214,238,202,196,111,214,29,89,10,177,161,225,228,30,20,243,129,121,168,75,215,105,203,19,178,14,119,171,92,161,194,185,57,198,126,1,128,254,169,156,229,153,21,36,11,54,160,54,110,81,28,142,167,22,102,134,194,113,218,62,44,222,111,44,73,185,211,148,240,129,4,9,149,230,184,177,123,73,13,163,30,46,177,27,72,62,210,67,45,89,110,251,195,246,219,233,166,145,103,81,31,169,176,204,122,206,12,116,148,97,185,102,241,6,5,222,0,0,0,0,119,7,48,150,238,14,97,44,153,9,81,186,7,109,196,25,112,106,244,143,233,99,165,53,158,100,149,163,14,219,136,50,121,220,184,164,224,213,233,30,151,210,217,136,9,182,76,43,126,177,124,189,231,184,45,7,144,191,29,145,29,183,16,100,106,176,32,242,243,185,113,72,132,190,65,222,26,218,212,125,109,221,228,235,244,212,181,81,131,211,133,199,19,108,152,86,100,107,168,192,253,98,249,122,138,101,201,236,20,1,92,79,99,6,108,217,250,15,61,99,141,8,13,245,59,110,32,200,76,105,16,94,213,96,65,228,162,103,113,114,60,3,228,209,75,4,212,71,210,13,133,253,165,10,181,107,53,181,168,250,66,178,152,108,219,187,201,214,172,188,249,64,50,216,108,227,69,223,92,117,220,214,13,207,171,209,61,89,38,217,48,172,81,222,0,58,200,215,81,128,191,208,97,22,33,180,244,181,86,179,196,35,207,186,149,153,184,189,165,15,40,2,184,158,95,5,136,8,198,12,217,178,177,11,233,36,47,111,124,135,88,104,76,17,193,97,29,171,182,102,45,61,118,220,65,144,1,219,113,6,152,210,32,188,239,213,16,42,113,177,133,137,6,182,181,31,159,191,228,165,232,184,212,51,120,7,201,162,15,0,249,52,150,9,168,142,225,14,152,24,127,106,13,187,8,109,61,45,145,100,108,151,230,99,92,1,107,107,81,244,28,108,97,98,133,101,48,216,242,98,0,78,108,6,149,237,27,1,165,123,130,8,244,193,245,15,196,87,101,176,217,198,18,183,233,80,139,190,184,234,252,185,136,124,98,221,29,223,21,218,45,73,140,211,124,243,251,212,76,101,77,178,97,88,58,181,81,206,163,188,0,116,212,187,48,226,74,223,165,65,61,216,149,215,164,209,196,109,211,214,244,251,67,105,233,106,52,110,217,252,173,103,136,70,218,96,184,208,68,4,45,115,51,3,29,229,170,10,76,95,221,13,124,201,80,5,113,60,39,2,65,170,190,11,16,16,201,12,32,134,87,104,181,37,32,111,133,179,185,102,212,9,206,97,228,159,94,222,249,14,41,217,201,152,176,208,152,34,199,215,168,180,89,179,61,23,46,180,13,129,183,189,92,59,192,186,108,173,237,184,131,32,154,191,179,182,3,182,226,12,116,177,210,154,234,213,71,57,157,210,119,175,4,219,38,21,115,220,22,131,227,99,11,18,148,100,59,132,13,109,106,62,122,106,90,168,228,14,207,11,147,9,255,157,10,0,174,39,125,7,158,177,240,15,147,68,135,8,163,210,30,1,242,104,105,6,194,254,247,98,87,93,128,101,103,203,25,108,54,113,110,107,6,231,254,212,27,118,137,211,43,224,16,218,122,90,103,221,74,204,249,185,223,111,142,190,239,249,23,183,190,67,96,176,142,213,214,214,163,232,161,209,147,126,56,216,194,196,79,223,242,82,209,187,103,241,166,188,87,103,63,181,6,221,72,178,54,75,216,13,43,218,175,10,27,76,54,3,74,246,65,4,122,96,223,96,239,195,168,103,223,85,49,110,142,239,70,105,190,121,203,97,179,140,188,102,131,26,37,111,210,160,82,104,226,54,204,12,119,149,187,11,71,3,34,2,22,185,85,5,38,47,197,186,59,190,178,189,11,40,43,180,90,146,92,179,106,4,194,215,255,167,181,208,207,49,44,217,158,139,91,222,174,29,155,100,194,176,236,99,242,38,117,106,163,156,2,109,147,10,156,9,6,169,235,14,54,63,114,7,103,133,5,0,87,19,149,191,74,130,226,184,122,20,123,177,43,174,12,182,27,56,146,210,142,155,229,213,190,13,124,220,239,183,11,219,223,33,134,211,210,212,241,212,226,66,104,221,179,248,31,218,131,110,129,190,22,205,246,185,38,91,111,176,119,225,24,183,71,119,136,8,90,230,255,15,106,112,102,6,59,202,17,1,11,92,143,101,158,255,248,98,174,105,97,107,255,211,22,108,207,69,160,10,226,120,215,13,210,238,78,4,131,84,57,3,179,194,167,103,38,97,208,96,22,247,73,105,71,77,62,110,119,219,174,209,106,74,217,214,90,220,64,223,11,102,55,216,59,240,169,188,174,83,222,187,158,197,71,178,207,127,48,181,255,233,189,189,242,28,202,186,194,138,83,179,147,48,36,180,163,166,186,208,54,5,205,215,6,147,84,222,87,41,35,217,103,191,179,102,122,46,196,97,74,184,93,104,27,2,42,111,43,148,180,11,190,55,195,12,142,161,90,5,223,27,45,2,239,141,0,0,0,0,25,27,49,65,50,54,98,130,43,45,83,195,100,108,197,4,125,119,244,69,86,90,167,134,79,65,150,199,200,217,138,8,209,194,187,73,250,239,232,138,227,244,217,203,172,181,79,12,181,174,126,77,158,131,45,142,135,152,28,207,74,194,18,81,83,217,35,16,120,244,112,211,97,239,65,146,46,174,215,85,55,181,230,20,28,152,181,215,5,131,132,150,130,27,152,89,155,0,169,24,176,45,250,219,169,54,203,154,230,119,93,93,255,108,108,28,212,65,63,223,205,90,14,158,149,132,36,162,140,159,21,227,167,178,70,32,190,169,119,97,241,232,225,166,232,243,208,231,195,222,131,36,218,197,178,101,93,93,174,170,68,70,159,235,111,107,204,40,118,112,253,105,57,49,107,174,32,42,90,239,11,7,9,44,18,28,56,109,223,70,54,243,198,93,7,178,237,112,84,113,244,107,101,48,187,42,243,247,162,49,194,182,137,28,145,117,144,7,160,52,23,159,188,251,14,132,141,186,37,169,222,121,60,178,239,56,115,243,121,255,106,232,72,190,65,197,27,125,88,222,42,60,240,121,79,5,233,98,126,68,194,79,45,135,219,84,28,198,148,21,138,1,141,14,187,64,166,35,232,131,191,56,217,194,56,160,197,13,33,187,244,76,10,150,167,143,19,141,150,206,92,204,0,9,69,215,49,72,110,250,98,139,119,225,83,202,186,187,93,84,163,160,108,21,136,141,63,214,145,150,14,151,222,215,152,80,199,204,169,17,236,225,250,210,245,250,203,147,114,98,215,92,107,121,230,29,64,84,181,222,89,79,132,159,22,14,18,88,15,21,35,25,36,56,112,218,61,35,65,155,101,253,107,167,124,230,90,230,87,203,9,37,78,208,56,100,1,145,174,163,24,138,159,226,51,167,204,33,42,188,253,96,173,36,225,175,180,63,208,238,159,18,131,45,134,9,178,108,201,72,36,171,208,83,21,234,251,126,70,41,226,101,119,104,47,63,121,246,54,36,72,183,29,9,27,116,4,18,42,53,75,83,188,242,82,72,141,179,121,101,222,112,96,126,239,49,231,230,243,254,254,253,194,191,213,208,145,124,204,203,160,61,131,138,54,250,154,145,7,187,177,188,84,120,168,167,101,57,59,131,152,75,34,152,169,10,9,181,250,201,16,174,203,136,95,239,93,79,70,244,108,14,109,217,63,205,116,194,14,140,243,90,18,67,234,65,35,2,193,108,112,193,216,119,65,128,151,54,215,71,142,45,230,6,165,0,181,197,188,27,132,132,113,65,138,26,104,90,187,91,67,119,232,152,90,108,217,217,21,45,79,30,12,54,126,95,39,27,45,156,62,0,28,221,185,152,0,18,160,131,49,83,139,174,98,144,146,181,83,209,221,244,197,22,196,239,244,87,239,194,167,148,246,217,150,213,174,7,188,233,183,28,141,168,156,49,222,107,133,42,239,42,202,107,121,237,211,112,72,172,248,93,27,111,225,70,42,46,102,222,54,225,127,197,7,160,84,232,84,99,77,243,101,34,2,178,243,229,27,169,194,164,48,132,145,103,41,159,160,38,228,197,174,184,253,222,159,249,214,243,204,58,207,232,253,123,128,169,107,188,153,178,90,253,178,159,9,62,171,132,56,127,44,28,36,176,53,7,21,241,30,42,70,50,7,49,119,115,72,112,225,180,81,107,208,245,122,70,131,54,99,93,178,119,203,250,215,78,210,225,230,15,249,204,181,204,224,215,132,141,175,150,18,74,182,141,35,11,157,160,112,200,132,187,65,137,3,35,93,70,26,56,108,7,49,21,63,196,40,14,14,133,103,79,152,66,126,84,169,3,85,121,250,192,76,98,203,129,129,56,197,31,152,35,244,94,179,14,167,157,170,21,150,220,229,84,0,27,252,79,49,90,215,98,98,153,206,121,83,216,73,225,79,23,80,250,126,86,123,215,45,149,98,204,28,212,45,141,138,19,52,150,187,82,31,187,232,145,6,160,217,208,94,126,243,236,71,101,194,173,108,72,145,110,117,83,160,47,58,18,54,232,35,9,7,169,8,36,84,106,17,63,101,43,150,167,121,228,143,188,72,165,164,145,27,102,189,138,42,39,242,203,188,224,235,208,141,161,192,253,222,98,217,230,239,35,20,188,225,189,13,167,208,252,38,138,131,63,63,145,178,126,112,208,36,185,105,203,21,248,66,230,70,59,91,253,119,122,220,101,107,181,197,126,90,244,238,83,9,55,247,72,56,118,184,9,174,177,161,18,159,240,138,63,204,51,147,36,253,114,0,0,0,0,1,194,106,55,3,132,212,110,2,70,190,89,7,9,168,220,6,203,194,235,4,141,124,178,5,79,22,133,14,19,81,184,15,209,59,143,13,151,133,214,12,85,239,225,9,26,249,100,8,216,147,83,10,158,45,10,11,92,71,61,28,38,163,112,29,228,201,71,31,162,119,30,30,96,29,41,27,47,11,172,26,237,97,155,24,171,223,194,25,105,181,245,18,53,242,200,19,247,152,255,17,177,38,166,16,115,76,145,21,60,90,20,20,254,48,35,22,184,142,122,23,122,228,77,56,77,70,224,57,143,44,215,59,201,146,142,58,11,248,185,63,68,238,60,62,134,132,11,60,192,58,82,61,2,80,101,54,94,23,88,55,156,125,111,53,218,195,54,52,24,169,1,49,87,191,132,48,149,213,179,50,211,107,234,51,17,1,221,36,107,229,144,37,169,143,167,39,239,49,254,38,45,91,201,35,98,77,76,34,160,39,123,32,230,153,34,33,36,243,21,42,120,180,40,43,186,222,31,41,252,96,70,40,62,10,113,45,113,28,244,44,179,118,195,46,245,200,154,47,55,162,173,112,154,141,192,113,88,231,247,115,30,89,174,114,220,51,153,119,147,37,28,118,81,79,43,116,23,241,114,117,213,155,69,126,137,220,120,127,75,182,79,125,13,8,22,124,207,98,33,121,128,116,164,120,66,30,147,122,4,160,202,123,198,202,253,108,188,46,176,109,126,68,135,111,56,250,222,110,250,144,233,107,181,134,108,106,119,236,91,104,49,82,2,105,243,56,53,98,175,127,8,99,109,21,63,97,43,171,102,96,233,193,81,101,166,215,212,100,100,189,227,102,34,3,186,103,224,105,141,72,215,203,32,73,21,161,23,75,83,31,78,74,145,117,121,79,222,99,252,78,28,9,203,76,90,183,146,77,152,221,165,70,196,154,152,71,6,240,175,69,64,78,246,68,130,36,193,65,205,50,68,64,15,88,115,66,73,230,42,67,139,140,29,84,241,104,80,85,51,2,103,87,117,188,62,86,183,214,9,83,248,192,140,82,58,170,187,80,124,20,226,81,190,126,213,90,226,57,232,91,32,83,223,89,102,237,134,88,164,135,177,93,235,145,52,92,41,251,3,94,111,69,90,95,173,47,109,225,53,27,128,224,247,113,183,226,177,207,238,227,115,165,217,230,60,179,92,231,254,217,107,229,184,103,50,228,122,13,5,239,38,74,56,238,228,32,15,236,162,158,86,237,96,244,97,232,47,226,228,233,237,136,211,235,171,54,138,234,105,92,189,253,19,184,240,252,209,210,199,254,151,108,158,255,85,6,169,250,26,16,44,251,216,122,27,249,158,196,66,248,92,174,117,243,0,233,72,242,194,131,127,240,132,61,38,241,70,87,17,244,9,65,148,245,203,43,163,247,141,149,250,246,79,255,205,217,120,93,96,216,186,55,87,218,252,137,14,219,62,227,57,222,113,245,188,223,179,159,139,221,245,33,210,220,55,75,229,215,107,12,216,214,169,102,239,212,239,216,182,213,45,178,129,208,98,164,4,209,160,206,51,211,230,112,106,210,36,26,93,197,94,254,16,196,156,148,39,198,218,42,126,199,24,64,73,194,87,86,204,195,149,60,251,193,211,130,162,192,17,232,149,203,77,175,168,202,143,197,159,200,201,123,198,201,11,17,241,204,68,7,116,205,134,109,67,207,192,211,26,206,2,185,45,145,175,150,64,144,109,252,119,146,43,66,46,147,233,40,25,150,166,62,156,151,100,84,171,149,34,234,242,148,224,128,197,159,188,199,248,158,126,173,207,156,56,19,150,157,250,121,161,152,181,111,36,153,119,5,19,155,49,187,74,154,243,209,125,141,137,53,48,140,75,95,7,142,13,225,94,143,207,139,105,138,128,157,236,139,66,247,219,137,4,73,130,136,198,35,181,131,154,100,136,130,88,14,191,128,30,176,230,129,220,218,209,132,147,204,84,133,81,166,99,135,23,24,58,134,213,114,13,169,226,208,160,168,32,186,151,170,102,4,206,171,164,110,249,174,235,120,124,175,41,18,75,173,111,172,18,172,173,198,37,167,241,129,24,166,51,235,47,164,117,85,118,165,183,63,65,160,248,41,196,161,58,67,243,163,124,253,170,162,190,151,157,181,196,115,208,180,6,25,231,182,64,167,190,183,130,205,137,178,205,219,12,179,15,177,59,177,73,15,98,176,139,101,85,187,215,34,104,186,21,72,95,184,83,246,6,185,145,156,49,188,222,138,180,189,28,224,131,191,90,94,218,190,152,52,237,0,0,0,0,184,188,103,101,170,9,200,139,18,181,175,238,143,98,151,87,55,222,240,50,37,107,95,220,157,215,56,185,197,180,40,239,125,8,79,138,111,189,224,100,215,1,135,1,74,214,191,184,242,106,216,221,224,223,119,51,88,99,16,86,80,25,87,159,232,165,48,250,250,16,159,20,66,172,248,113,223,123,192,200,103,199,167,173,117,114,8,67,205,206,111,38,149,173,127,112,45,17,24,21,63,164,183,251,135,24,208,158,26,207,232,39,162,115,143,66],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+153600);allocate([176,198,32,172,8,122,71,201,160,50,175,62,24,142,200,91,10,59,103,181,178,135,0,208,47,80,56,105,151,236,95,12,133,89,240,226,61,229,151,135,101,134,135,209,221,58,224,180,207,143,79,90,119,51,40,63,234,228,16,134,82,88,119,227,64,237,216,13,248,81,191,104,240,43,248,161,72,151,159,196,90,34,48,42,226,158,87,79,127,73,111,246,199,245,8,147,213,64,167,125,109,252,192,24,53,159,208,78,141,35,183,43,159,150,24,197,39,42,127,160,186,253,71,25,2,65,32,124,16,244,143,146,168,72,232,247,155,20,88,61,35,168,63,88,49,29,144,182,137,161,247,211,20,118,207,106,172,202,168,15,190,127,7,225,6,195,96,132,94,160,112,210,230,28,23,183,244,169,184,89,76,21,223,60,209,194,231,133,105,126,128,224,123,203,47,14,195,119,72,107,203,13,15,162,115,177,104,199,97,4,199,41,217,184,160,76,68,111,152,245,252,211,255,144,238,102,80,126,86,218,55,27,14,185,39,77,182,5,64,40,164,176,239,198,28,12,136,163,129,219,176,26,57,103,215,127,43,210,120,145,147,110,31,244,59,38,247,3,131,154,144,102,145,47,63,136,41,147,88,237,180,68,96,84,12,248,7,49,30,77,168,223,166,241,207,186,254,146,223,236,70,46,184,137,84,155,23,103,236,39,112,2,113,240,72,187,201,76,47,222,219,249,128,48,99,69,231,85,107,63,160,156,211,131,199,249,193,54,104,23,121,138,15,114,228,93,55,203,92,225,80,174,78,84,255,64,246,232,152,37,174,139,136,115,22,55,239,22,4,130,64,248,188,62,39,157,33,233,31,36,153,85,120,65,139,224,215,175,51,92,176,202,237,89,182,59,85,229,209,94,71,80,126,176,255,236,25,213,98,59,33,108,218,135,70,9,200,50,233,231,112,142,142,130,40,237,158,212,144,81,249,177,130,228,86,95,58,88,49,58,167,143,9,131,31,51,110,230,13,134,193,8,181,58,166,109,189,64,225,164,5,252,134,193,23,73,41,47,175,245,78,74,50,34,118,243,138,158,17,150,152,43,190,120,32,151,217,29,120,244,201,75,192,72,174,46,210,253,1,192,106,65,102,165,247,150,94,28,79,42,57,121,93,159,150,151,229,35,241,242,77,107,25,5,245,215,126,96,231,98,209,142,95,222,182,235,194,9,142,82,122,181,233,55,104,0,70,217,208,188,33,188,136,223,49,234,48,99,86,143,34,214,249,97,154,106,158,4,7,189,166,189,191,1,193,216,173,180,110,54,21,8,9,83,29,114,78,154,165,206,41,255,183,123,134,17,15,199,225,116,146,16,217,205,42,172,190,168,56,25,17,70,128,165,118,35,216,198,102,117,96,122,1,16,114,207,174,254,202,115,201,155,87,164,241,34,239,24,150,71,253,173,57,169,69,17,94,204,118,77,238,6,206,241,137,99,220,68,38,141,100,248,65,232,249,47,121,81,65,147,30,52,83,38,177,218,235,154,214,191,179,249,198,233,11,69,161,140,25,240,14,98,161,76,105,7,60,155,81,190,132,39,54,219,150,146,153,53,46,46,254,80,38,84,185,153,158,232,222,252,140,93,113,18,52,225,22,119,169,54,46,206,17,138,73,171,3,63,230,69,187,131,129,32,227,224,145,118,91,92,246,19,73,233,89,253,241,85,62,152,108,130,6,33,212,62,97,68,198,139,206,170,126,55,169,207,214,127,65,56,110,195,38,93,124,118,137,179,196,202,238,214,89,29,214,111,225,161,177,10,243,20,30,228,75,168,121,129,19,203,105,215,171,119,14,178,185,194,161,92,1,126,198,57,156,169,254,128,36,21,153,229,54,160,54,11,142,28,81,110,134,102,22,167,62,218,113,194,44,111,222,44,148,211,185,73,9,4,129,240,177,184,230,149,163,13,73,123,27,177,46,30,67,210,62,72,251,110,89,45,233,219,246,195,81,103,145,166,204,176,169,31,116,12,206,122,102,185,97,148,222,5,6,241,0,0,0,0,0,0,0,0,77,0,0,0,4,0,4,0,8,0,4,0,78,0,0,0,4,0,5,0,16,0,8,0,78,0,0,0,4,0,6,0,32,0,32,0,78,0,0,0,4,0,4,0,16,0,16,0,79,0,0,0,8,0,16,0,32,0,32,0,79,0,0,0,8,0,16,0,128,0,128,0,79,0,0,0,8,0,32,0,128,0,0,1,79,0,0,0,32,0,128,0,2,1,0,4,79,0,0,0,32,0,2,1,2,1,0,16,79,0,0,0,154,173,2,0,8,133,2,0,1,1,0,0,30,1,0,0,15,0,0,0,34,173,2,0,144,132,2,0,0,0,0,0,30,0,0,0,15,0,0,0,0,0,0,0,68,132,2,0,0,0,0,0,19,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,11,0,0,0,12,0,0,0,12,0,0,0,13,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,10,0,0,0,12,0,0,0,14,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,40,0,0,0,48,0,0,0,56,0,0,0,64,0,0,0,80,0,0,0,96,0,0,0,112,0,0,0,128,0,0,0,160,0,0,0,192,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,6,0,0,0,8,0,0,0,12,0,0,0,16,0,0,0,24,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,96,0,0,0,128,0,0,0,192,0,0,0,0,1,0,0,128,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,6,0,0,0,8,0,0,0,12,0,0,0,16,0,0,0,24,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,96,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,9,0,0,0,0,0,0,0,0,0,0,0,68,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,33,0,0,0,166,123,15,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,68,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,34,0,0,0,33,0,0,0,174,127,15,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,164,135,2,0,5,0,0,0,0,0,0,0,0,0,0,0,68,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,0,0,33,0,0,0,182,131,15,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+163840);allocate([1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,95,112,137,0,255,9,47,15,0,0,0,0,32,107,0,0,177,4,0,0,178,4,0,0,0,0,0,0,56,107,0,0,179,4,0,0,180,4,0,0,16,0,0,0,1,0,0,0,113,0,0,0,95,0,0,0,21,0,0,0,22,0,0,0,2,0,0,0,69,1,0,0,24,0,0,0,80,0,0,0,3,0,0,0,81,0,0,0,0,0,0,0,64,107,0,0,181,4,0,0,182,4,0,0,66,2,0,0,37,0,0,0,114,0,0,0,96,0,0,0,70,1,0,0,71,1,0,0,38,0,0,0,72,1,0,0,73,1,0,0,82,0,0,0,39,0,0,0,83,0,0,0,8,0,0,0,0,0,0,0,72,107,0,0,183,4,0,0,184,4,0,0,248,255,255,255,248,255,255,255,72,107,0,0,185,4,0,0,186,4,0,0,8,0,0,0,0,0,0,0,96,107,0,0,187,4,0,0,188,4,0,0,248,255,255,255,248,255,255,255,96,107,0,0,189,4,0,0,190,4,0,0,4,0,0,0,0,0,0,0,120,107,0,0,41,0,0,0,42,0,0,0,252,255,255,255,252,255,255,255,120,107,0,0,43,0,0,0,44,0,0,0,4,0,0,0,0,0,0,0,144,107,0,0,191,4,0,0,192,4,0,0,252,255,255,255,252,255,255,255,144,107,0,0,193,4,0,0,194,4,0,0,0,0,0,0,168,107,0,0,181,4,0,0,195,4,0,0,67,2,0,0,37,0,0,0,114,0,0,0,96,0,0,0,74,1,0,0,71,1,0,0,38,0,0,0,72,1,0,0,73,1,0,0,82,0,0,0,40,0,0,0,84,0,0,0,0,0,0,0,184,107,0,0,179,4,0,0,196,4,0,0,68,2,0,0,1,0,0,0,113,0,0,0,95,0,0,0,75,1,0,0,22,0,0,0,2,0,0,0,69,1,0,0,24,0,0,0,80,0,0,0,41,0,0,0,85,0,0,0,0,0,0,0,200,107,0,0,181,4,0,0,197,4,0,0,69,2,0,0,37,0,0,0,114,0,0,0,96,0,0,0,70,1,0,0,71,1,0,0,38,0,0,0,76,1,0,0,77,1,0,0,86,0,0,0,39,0,0,0,83,0,0,0,0,0,0,0,216,107,0,0,179,4,0,0,198,4,0,0,70,2,0,0,1,0,0,0,113,0,0,0,95,0,0,0,21,0,0,0,22,0,0,0,2,0,0,0,78,1,0,0,79,1,0,0,87,0,0,0,3,0,0,0,81,0,0,0,0,0,0,0,232,107,0,0,199,4,0,0,200,4,0,0,201,4,0,0,33,0,0,0,97,0,0,0,42,0,0,0,0,0,0,0,8,108,0,0,202,4,0,0,203,4,0,0,201,4,0,0,34,0,0,0,98,0,0,0,43,0,0,0,0,0,0,0,24,108,0,0,204,4,0,0,205,4,0,0,201,4,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,0,0,0,0,88,108,0,0,206,4,0,0,207,4,0,0,201,4,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,0,0,0,0,144,108,0,0,208,4,0,0,209,4,0,0,201,4,0,0,35,0,0,0,36,0,0,0,53,0,0,0,37,0,0,0,54,0,0,0,1,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,208,108,0,0,210,4,0,0,211,4,0,0,201,4,0,0,39,0,0,0,40,0,0,0,55,0,0,0,41,0,0,0,56,0,0,0,3,0,0,0,4,0,0,0,42,0,0,0,0,0,0,0,8,109,0,0,212,4,0,0,213,4,0,0,201,4,0,0,80,1,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,3,0,0,0,248,255,255,255,8,109,0,0,81,1,0,0,82,1,0,0,83,1,0,0,84,1,0,0,85,1,0,0,86,1,0,0,87,1,0,0,0,0,0,0,64,109,0,0,214,4,0,0,215,4,0,0,201,4,0,0,88,1,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,4,0,0,0,248,255,255,255,64,109,0,0,89,1,0,0,90,1,0,0,91,1,0,0,92,1,0,0,93,1,0,0,94,1,0,0,95,1,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,112,109,0,0,216,4,0,0,217,4,0,0,201,4,0,0,1,0,0,0,0,0,0,0,152,109,0,0,218,4,0,0,219,4,0,0,201,4,0,0,2,0,0,0,0,0,0,0,184,109,0,0,220,4,0,0,221,4,0,0,201,4,0,0,96,1,0,0,97,1,0,0,71,2,0,0,72,2,0,0,73,2,0,0,74,2,0,0,98,1,0,0,75,2,0,0,76,2,0,0,0,0,0,0,224,109,0,0,222,4,0,0,223,4,0,0,201,4,0,0,99,1,0,0,100,1,0,0,77,2,0,0,78,2,0,0,79,2,0,0,80,2,0,0,101,1,0,0,81,2,0,0,82,2,0,0,0,0,0,0,0,110,0,0,224,4,0,0,225,4,0,0,201,4,0,0,102,1,0,0,103,1,0,0,83,2,0,0,84,2,0,0,85,2,0,0,86,2,0,0,104,1,0,0,87,2,0,0,88,2,0,0,0,0,0,0,32,110,0,0,226,4,0,0,227,4,0,0,201,4,0,0,105,1,0,0,106,1,0,0,89,2,0,0,90,2,0,0,91,2,0,0,92,2,0,0,107,1,0,0,93,2,0,0,94,2,0,0,0,0,0,0,64,110,0,0,228,4,0,0,229,4,0,0,201,4,0,0,3,0,0,0,4,0,0,0,0,0,0,0,104,110,0,0,230,4,0,0,231,4,0,0,201,4,0,0,5,0,0,0,6,0,0,0,0,0,0,0,144,110,0,0,232,4,0,0,233,4,0,0,201,4,0,0,1,0,0,0,67,0,0,0,0,0,0,0,184,110,0,0,234,4,0,0,235,4,0,0,201,4,0,0,2,0,0,0,68,0,0,0,0,0,0,0,224,110,0,0,236,4,0,0,237,4,0,0,201,4,0,0,44,0,0,0,115,0,0,0,95,2,0,0,0,0,0,0,8,111,0,0,238,4,0,0,239,4,0,0,201,4,0,0,45,0,0,0,116,0,0,0,96,2,0,0,0,0,0,0,96,111,0,0,240,4,0,0,241,4,0,0,201,4,0,0,5,0,0,0,6,0,0,0,43,0,0,0,108,1,0,0,109,1,0,0,44,0,0,0,110,1,0,0,0,0,0,0,40,111,0,0,240,4,0,0,242,4,0,0,201,4,0,0,5,0,0,0,6,0,0,0,43,0,0,0,108,1,0,0,109,1,0,0,44,0,0,0,110,1,0,0,0,0,0,0,144,111,0,0,243,4,0,0,244,4,0,0,201,4,0,0,7,0,0,0,8,0,0,0,45,0,0,0,111,1,0,0,112,1,0,0,46,0,0,0,113,1,0,0,0,0,0,0,208,111,0,0,245,4,0,0,246,4,0,0,201,4,0,0,0,0,0,0,224,111,0,0,247,4,0,0,248,4,0,0,201,4,0,0,88,0,0,0,46,0,0,0,89,0,0,0,47,0,0,0,90,0,0,0,10,0,0,0,48,0,0,0,47,0,0,0,0,0,0,0,40,112,0,0,249,4,0,0,250,4,0,0,201,4,0,0,114,1,0,0,115,1,0,0,97,2,0,0,98,2,0,0,99,2,0,0,0,0,0,0,56,112,0,0,251,4,0,0,252,4,0,0,201,4,0,0,116,1,0,0,117,1,0,0,100,2,0,0,101,2,0,0,102,2,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,248,107,0,0,240,4,0,0,253,4,0,0,201,4,0,0,0,0,0,0,8,112,0,0,240,4,0,0,254,4,0,0,201,4,0,0,49,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,91,0,0,0,50,0,0,0,92,0,0,0,51,0,0,0,93,0,0,0,14,0,0,0,52,0,0,0,48,0,0,0,0,0,0,0,112,111,0,0,240,4,0,0,255,4,0,0,201,4,0,0,9,0,0,0,10,0,0,0,49,0,0,0,118,1,0,0,119,1,0,0,50,0,0,0,120,1,0,0,0,0,0,0,176,111,0,0,240,4,0,0,0,5,0,0,201,4,0,0,11,0,0,0,12,0,0,0,51,0,0,0,121,1,0,0,122,1,0,0,52,0,0,0,123,1,0,0,0,0,0,0,56,111,0,0,240,4,0,0,1,5,0,0,201,4,0,0,5,0,0,0,6,0,0,0,43,0,0,0,108,1,0,0,109,1,0,0,44,0,0,0,110,1,0,0,2,0,0,0,0,0,0,0,88,112,0,0,2,5,0,0,3,5,0,0,4,5,0,0,5,5,0,0,53,0,0,0,117,0,0,0,88,0,0,0,99,0,0,0,0,0,0,0,128,112,0,0,2,5,0,0,6,5,0,0,4,5,0,0,5,5,0,0,53,0,0,0,118,0,0,0,89,0,0,0,100,0,0,0,0,0,0,0,144,112,0,0,7,5,0,0,8,5,0,0,124,1,0,0,0,0,0,0,192,112,0,0,2,5,0,0,9,5,0,0,4,5,0,0,5,5,0,0,54,0,0,0,0,0,0,0,176,112,0,0,2,5,0,0,10,5,0,0,4,5,0,0,5,5,0,0,55,0,0,0,0,0,0,0,112,113,0,0,2,5,0,0,11,5,0,0,4,5,0,0,5,5,0,0,56,0,0,0,0,0,0,0,128,113,0,0,2,5,0,0,12,5,0,0,4,5,0,0,5,5,0,0,53,0,0,0,119,0,0,0,90,0,0,0,101,0,0,0,0,64,197,88,159,83,66,75,0,64,73,50,163,34,168,17,197,88,33,123,252,115,98,104,197,88,191,69,11,48,126,24,159,83,252,115,65,109,84,98,159,83,179,65,65,45,18,23,66,75,98,104,84,98,126,88,66,75,33,59,186,40,195,20,0,64,197,88,159,83,66,75,0,64,73,50,163,34,168,17,73,50,191,69,179,65,33,59,73,50,130,39,55,27,224,13,163,34,11,48,65,45,186,40,163,34,55,27,191,18,142,9,168,17,126,24,18,23,195,20,168,17,224,13,142,9,223,4,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,192,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,160,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,224,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,144,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,208,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,176,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,240,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,200,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,168,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,232,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,152,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,216,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,184,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,248,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,196,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,164,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,228,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,148,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,212,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,180,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,244,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,204,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,172,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,236,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,156,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,220,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,188,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,252,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,194,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,162,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,226,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,146,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,210,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,178,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,242,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,202,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,170,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,234,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,154,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,218,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,186,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,250,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,198,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,166,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,230,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,150,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,214,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,182,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,246,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,206,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,174,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,238,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,158,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,222,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,190,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,254,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,193,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,161,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,225,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,145,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,209,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,177,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,241,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,201,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,169,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,233,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,153,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,217,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,185,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,249,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,197,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,165,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,229,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,149,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,213,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,181,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,245,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,205,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,173,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,237,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,157,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,221,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,189,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,253,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,195,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,163,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,227,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,147,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,211,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,179,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,243,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,203,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,171,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,235,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,155,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,219,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,187,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,251,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,199,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,167,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,231,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,151,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,215,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,183,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,247,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,207,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,175,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,239,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,159,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,223,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,191,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,255,0,16,5,1,0,23,5,1,1,19,5,17,0,27,5,1,16,17,5,5,0,25,5,1,4,21,5,65,0,29,5,1,64,16,5,3,0,24,5,1,2,20,5,33,0,28,5,1,32,18,5,9,0,26,5,1,8,22,5,129,0,64,5,0,0,16,5,2,0,23,5,129,1,19,5,25,0,27,5,1,24,17,5,7,0,25,5,1,6,21,5,97,0,29,5,1,96,16,5,4,0,24,5,1,3,20,5,49,0,28,5,1,48,18,5,13,0,26,5,1,12,22,5,193,0,64,5,0,0,16,0,17,0,18,0,0,0,8,0,7,0,9,0,6,0,10,0,5,0,11,0,4,0,12,0,3,0,13,0,2,0,14,0,1,0,15,0,1,0,2,0,3,0,4,0,5,0,7,0,9,0,13,0,17,0,25,0,33,0,49,0,65,0,97,0,129,0,193,0,1,1,129,1,1,2,1,3,1,4,1,6,1,8,1,12,1,16,1,24,1,32,1,48,1,64,1,96,0,0,0,0,3,0,4,0,5,0,6,0,7,0,8,0,9,0,10,0,11,0,13,0,15,0,17,0,19,0,23,0,27,0,31,0,35,0,43,0,51,0,59,0,67,0,83,0,99,0,115,0,131,0,163,0,195,0,227,0,2,1,0,0,0,0,16,0,16,0,16,0,16,0,17,0,17,0,18,0,18,0,19,0,19,0,20,0,20,0,21,0,21,0,22,0,22,0,23,0,23,0,24,0,24,0,25,0,25,0,26,0,26,0,27,0,27,0,28,0,28,0,29,0,29,0,64,0,64,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,17,0,17,0,17,0,17,0,18,0,18,0,18,0,18,0,19,0,19,0,19,0,19,0,20,0,20,0,20,0,20,0,21,0,21,0,21,0,21,0,16,0,72,0,78,0,0,0,5,0,16,0,5,0,8,0,5,0,24,0,5,0,4,0,5,0,20,0,5,0,12,0,5,0,28,0,5,0,2,0,5,0,18,0,5,0,10,0,5,0,26,0,5,0,6,0,5,0,22,0,5,0,14,0,5,0,30,0,5,0,1,0,5,0,17,0,5,0,9,0,5,0,25,0,5,0,5,0,5,0,21,0,5,0,13,0,5,0,29,0,5,0,3,0,5,0,19,0,5,0,11,0,5,0,27,0,5,0,7,0,5,0,23,0,5,0,12,0,8,0,140,0,8,0,76,0,8,0,204,0,8,0,44,0,8,0,172,0,8,0,108,0,8,0,236,0,8,0,28,0,8,0,156,0,8,0,92,0,8,0,220,0,8,0,60,0,8,0,188,0,8,0,124,0,8,0,252,0,8,0,2,0,8,0,130,0,8,0,66,0,8,0,194,0,8,0,34,0,8,0,162,0,8,0,98,0,8,0,226,0,8,0,18,0,8,0,146,0,8,0,82,0,8,0,210,0,8,0,50,0,8,0,178,0,8,0,114,0,8,0,242,0,8,0,10,0,8,0,138,0,8,0,74,0,8,0,202,0,8,0,42,0,8,0,170,0,8,0,106,0,8,0,234,0,8,0,26,0,8,0,154,0,8,0,90,0,8,0,218,0,8,0,58,0,8,0,186,0,8,0,122,0,8,0,250,0,8,0,6,0,8,0,134,0,8,0,70,0,8,0,198,0,8,0,38,0,8,0,166,0,8,0,102,0,8,0,230,0,8,0,22,0,8,0,150,0,8,0,86,0,8,0,214,0,8,0,54,0,8,0,182,0,8,0,118,0,8,0,246,0,8,0,14,0,8,0,142,0,8,0,78,0,8,0,206,0,8,0,46,0,8,0,174,0,8,0,110,0,8,0,238,0,8,0,30,0,8,0,158,0,8,0,94,0,8,0,222,0,8,0,62,0,8,0,190,0,8,0,126,0,8,0,254,0,8,0,1,0,8,0,129,0,8,0,65,0,8,0,193,0,8,0,33,0,8,0,161,0,8,0,97,0,8,0,225,0,8,0,17,0,8,0,145,0,8,0,81,0,8,0,209,0,8,0,49,0,8,0,177,0,8,0,113,0,8,0,241,0,8,0,9,0,8,0,137,0,8,0,73,0,8,0,201,0,8,0,41,0,8,0,169,0,8,0,105,0,8,0,233,0,8,0,25,0,8,0,153,0,8,0,89,0,8,0,217,0,8,0,57,0,8,0,185,0,8,0,121,0,8,0,249,0,8,0,5,0,8,0,133,0,8,0,69,0,8,0,197,0,8,0,37,0,8,0,165,0,8,0,101,0,8,0,229,0,8,0,21,0,8,0,149,0,8,0,85,0,8,0,213,0,8,0,53,0,8,0,181,0,8,0,117,0,8,0,245,0,8,0,13,0,8,0,141,0,8,0,77,0,8,0,205,0,8,0,45,0,8,0,173,0,8,0,109,0,8,0,237,0,8,0,29,0,8,0,157,0,8,0,93,0,8,0,221,0,8,0,61,0,8,0,189,0,8,0,125,0,8,0,253,0,8,0,19,0,9,0,19,1,9,0,147,0,9,0,147,1,9,0,83,0,9,0,83,1,9,0,211,0,9,0,211,1,9,0,51,0,9,0,51,1,9,0,179,0,9,0,179,1,9,0,115,0,9,0,115,1,9,0,243,0,9,0,243,1,9,0,11,0,9,0,11,1,9,0,139,0,9,0,139,1,9,0,75,0,9,0,75,1,9,0,203,0,9,0,203,1,9,0,43,0,9,0,43,1,9,0,171,0,9,0,171,1,9,0,107,0,9,0,107,1,9,0,235,0,9,0,235,1,9,0,27,0,9,0,27,1,9,0,155,0,9,0,155,1,9,0,91,0,9,0,91,1,9,0,219,0,9,0,219,1,9,0,59,0,9,0,59,1,9,0,187,0,9,0,187,1,9,0,123,0,9,0,123,1,9,0,251,0,9,0,251,1,9,0,7,0,9,0,7,1,9,0,135,0,9,0,135,1,9,0,71,0,9,0,71,1,9,0,199,0,9,0,199,1,9,0,39,0,9,0,39,1,9,0,167,0,9,0,167,1,9,0,103,0,9,0,103,1,9,0,231,0,9,0,231,1,9,0,23,0,9,0,23,1,9,0,151,0,9,0,151,1,9,0,87,0,9,0,87,1,9,0,215,0,9,0,215,1,9,0,55,0,9,0,55,1,9,0,183,0,9,0,183,1,9,0,119,0,9,0,119,1,9,0,247,0,9,0,247,1,9,0,15,0,9,0,15,1,9,0,143,0,9,0,143,1,9,0,79,0,9,0,79,1,9,0,207,0,9,0,207,1,9,0,47,0,9,0,47,1,9,0,175,0,9,0,175,1,9,0,111,0,9,0,111,1,9,0,239,0,9,0,239,1,9,0,31,0,9,0,31,1,9,0,159,0,9,0,159,1,9,0,95,0,9,0,95,1,9,0,223,0,9,0,223,1,9,0,63,0,9,0,63,1,9,0,191,0,9,0,191,1,9,0,127,0,9,0,127,1,9,0,255,0,9,0,255,1,9,0,0,0,7,0,64,0,7,0,32,0,7,0,96,0,7,0,16,0,7,0,80,0,7,0,48,0,7,0,112,0,7,0,8,0,7,0,72,0,7,0,40,0,7,0,104,0,7,0,24,0,7,0,88,0,7,0,56,0,7,0,120,0,7,0,4,0,7,0,68,0,7,0,36,0,7,0,100,0,7,0,20,0,7,0,84,0,7,0,52,0,7,0,116,0,7,0,3,0,8,0,131,0,8,0,67,0,8,0,195,0,8,0,35,0,8,0,163,0,8,0,99,0,8,0,227,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,3,32,2,32,2,32,2,32,2,32,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,1,96,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,213,8,213,8,213,8,213,8,213,8,213,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,4,192,4,192,4,192,4,192,4,192,4,192,8,214,8,214,8,214,8,214,8,214,8,214,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,4,192,4,192,4,192,4,192,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,97,109,83,104,105,102,116,0,71,97,117,115,115,105,97,110,66,108,117,114,0,72,111,117,103,104,67,105,114,99,108,101,115,0,72,111,117,103,104,76,105,110,101,115,0,72,111,117,103,104,76,105,110,101,115,80,0,76,97,112,108,97,99,105,97,110,0,80,67,65,66,97,99,107,80,114,111,106,101,99,116,0,80,67,65,67,111,109,112,117,116,101,0,80,67,65,67,111,109,112,117,116,101,49,0,80,67,65,80,114,111,106,101,99,116,0,83,86,66,97,99,107,83,117,98,115,116,0,83,86,68,101,99,111,109,112,0,83,99,104,97,114,114,0,83,111,98,101,108,0,97,98,115,100,105,102,102,0,97,100,100,87,101,105,103,104,116,101,100,0,97,114,114,111,119,101,100,76,105,110,101,0,98,105,116,119,105,115,101,95,97,110,100,0,98,105,116,119,105,115,101,95,110,111,116,0,98,105,116,119,105,115,101,95,111,114,0,98,105,116,119,105,115,101,95,120,111,114,0,98,108,117,114,0,98,111,117,110,100,105,110,103,82,101,99,116,0,98,111,120,70,105,108,116,101,114,0,98,111,120,80,111,105,110,116,115,0,99,108,105,112,76,105,110,101,0,99,111,108,111,114,67,104,97,110,103,101,0,99,111,114,110,101,114,69,105,103,101,110,86,97,108,115,65,110,100,86,101,99,115,0,99,111,114,110,101,114,72,97,114,114,105,115,0,99,111,114,110,101,114,77,105,110,69,105,103,101,110,86,97,108,0,100,101,116,97,105,108,69,110,104,97,110,99,101,0,100,105,108,97,116,101,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,87,105,116,104,76,97,98,101,108,115,0,100,105,118,105,100,101,0,100,105,118,105,100,101,49,0,100,114,97,119,77,97,114,107,101,114,0,100,114,97,119,77,97,116,99,104,101,115,75,110,110,0,101,100,103,101,80,114,101,115,101,114,118,105,110,103,70,105,108,116,101,114,0,101,108,108,105,112,115,101,49,0,101,108,108,105,112,115,101,50,80,111,108,121,0,101,114,111,100,101,0,102,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,49,0,102,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,77,117,108,116,105,49,0,102,105,108,116,101,114,50,68,0,103,101,116,68,101,102,97,117,108,116,78,101,119,67,97,109,101,114,97,77,97,116,114,105,120,0,103,101,116,68,101,114,105,118,75,101,114,110,101,108,115,0,103,101,116,79,112,116,105,109,97,108,68,70,84,83,105,122,101,0,103,101,116,82,111,116,97,116,105,111,110,77,97,116,114,105,120,50,68,0,103,101,116,84,101,120,116,83,105,122,101,0,105,100,99,116,0,105,100,102,116,0,105,108,108,117,109,105,110,97,116,105,111,110,67,104,97,110,103,101,0,105,109,100,101,99,111,100,101,0,105,109,114,101,97,100,0,105,109,114,101,97,100,109,117,108,116,105,0,105,109,119,114,105,116,101,0,105,110,112,97,105,110,116,0,105,110,116,101,103,114,97,108,50,0,105,110,116,101,103,114,97,108,51,0,108,105,110,101,97,114,80,111,108,97,114,0,108,111,103,80,111,108,97,114,0,109,97,120,0,109,105,110,0,109,105,110,65,114,101,97,82,101,99,116,0,109,105,110,69,110,99,108,111,115,105,110,103,84,114,105,97,110,103,108,101,0,109,117,108,116,105,112,108,121,0,110,111,114,109,49,0,112,101,110,99,105,108,83,107,101,116,99,104,0,112,117,116,84,101,120,116,0,114,97,110,100,110,0,114,97,110,100,117,0,115,101,112,70,105,108,116,101,114,50,68,0,115,113,114,66,111,120,70,105,108,116,101,114,0,115,113,114,116,0,115,116,121,108,105,122,97,116,105,111,110,0,115,117,98,116,114,97,99,116,0,115,117,109,69,108,101,109,115,0,116,101,120,116,117,114,101,70,108,97,116,116,101,110,105,110,103,0,104,97,118,101,65,109,100,66,108,97,115,0,104,97,118,101,65,109,100,70,102,116,0,104,97,118,101,79,112,101,110,67,76,0,115,101,116,85,115,101,79,112,101,110,67,76,0,117,115,101,79,112,101,110,67,76,0,115,101,116,69,120,112,111,115,117,114,101,87,101,105,103,104,116,0,103,101,116,67,111,110],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+168180);allocate([116,114,97,115,116,87,101,105,103,104,116,0,103,101,116,69,120,112,111,115,117,114,101,87,101,105,103,104,116,0,112,114,111,99,101,115,115,49,0,103,101,116,83,97,116,117,114,97,116,105,111,110,87,101,105,103,104,116,0,115,101,116,83,97,116,117,114,97,116,105,111,110,87,101,105,103,104,116,0,115,101,116,67,111,110,116,114,97,115,116,87,101,105,103,104,116,0,80,116,114,60,77,101,114,103,101,77,101,114,116,101,110,115,62,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,0,103,101,116,68,101,116,101,99,116,83,104,97,100,111,119,115,0,103,101,116,86,97,114,73,110,105,116,0,115,101,116,86,97,114,77,97,120,0,115,101,116,66,97,99,107,103,114,111,117,110,100,82,97,116,105,111,0,103,101,116,83,104,97,100,111,119,84,104,114,101,115,104,111,108,100,0,103,101,116,78,77,105,120,116,117,114,101,115,0,103,101,116,67,111,109,112,108,101,120,105,116,121,82,101,100,117,99,116,105,111,110,84,104,114,101,115,104,111,108,100,0,115,101,116,78,77,105,120,116,117,114,101,115,0,115,101,116,86,97,114,73,110,105,116,0,103,101,116,83,104,97,100,111,119,86,97,108,117,101,0,115,101,116,68,101,116,101,99,116,83,104,97,100,111,119,115,0,103,101,116,86,97,114,77,105,110,0,115,101,116,86,97,114,77,105,110,0,115,101,116,72,105,115,116,111,114,121,0,115,101,116,86,97,114,84,104,114,101,115,104,111,108,100,0,103,101,116,86,97,114,84,104,114,101,115,104,111,108,100,71,101,110,0,115,101,116,83,104,97,100,111,119,84,104,114,101,115,104,111,108,100,0,103,101,116,86,97,114,77,97,120,0,103,101,116,66,97,99,107,103,114,111,117,110,100,82,97,116,105,111,0,115,101,116,86,97,114,84,104,114,101,115,104,111,108,100,71,101,110,0,103,101,116,72,105,115,116,111,114,121,0,115,101,116,83,104,97,100,111,119,86,97,108,117,101,0,115,101,116,67,111,109,112,108,101,120,105,116,121,82,101,100,117,99,116,105,111,110,84,104,114,101,115,104,111,108,100,0,103,101,116,86,97,114,84,104,114,101,115,104,111,108,100,0,80,116,114,60,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,62,0,103,101,116,84,104,114,101,115,104,111,108,100,0,103,101,116,82,97,100,105,97,110,99,101,0,115,101,116,84,104,114,101,115,104,111,108,100,0,115,101,116,77,97,120,73,116,101,114,0,103,101,116,77,97,120,73,116,101,114,0,80,116,114,60,67,97,108,105,98,114,97,116,101,82,111,98,101,114,116,115,111,110,62,0,72,79,71,68,101,115,99,114,105,112,116,111,114,0,108,111,97,100,0,103,101,116,68,101,102,97,117,108,116,80,101,111,112,108,101,68,101,116,101,99,116,111,114,0,103,101,116,68,97,105,109,108,101,114,80,101,111,112,108,101,68,101,116,101,99,116,111,114,0,99,104,101,99,107,68,101,116,101,99,116,111,114,83,105,122,101,0,103,101,116,87,105,110,83,105,103,109,97,0,115,118,109,68,101,116,101,99,116,111,114,0,109,108,95,76,111,103,105,115,116,105,99,82,101,103,114,101,115,115,105,111,110,0,103,101,116,84,101,114,109,67,114,105,116,101,114,105,97,0,115,101,116,84,114,97,105,110,77,101,116,104,111,100,0,103,101,116,73,116,101,114,97,116,105,111,110,115,0,103,101,116,84,114,97,105,110,77,101,116,104,111,100,0,103,101,116,76,101,97,114,110,105,110,103,82,97,116,101,0,115,101,116,84,101,114,109,67,114,105,116,101,114,105,97,0,115,101,116,77,105,110,105,66,97,116,99,104,83,105,122,101,0,115,101,116,76,101,97,114,110,105,110,103,82,97,116,101,0,103,101,116,82,101,103,117,108,97,114,105,122,97,116,105,111,110,0,103,101,116,77,105,110,105,66,97,116,99,104,83,105,122,101,0,115,101,116,82,101,103,117,108,97,114,105,122,97,116,105,111,110,0,103,101,116,95,108,101,97,114,110,116,95,116,104,101,116,97,115,0,80,116,114,60,109,108,95,76,111,103,105,115,116,105,99,82,101,103,114,101,115,115,105,111,110,62,0,78,111,114,109,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,0,115,101,116,78,111,114,109,70,108,97,103,0,103,101,116,78,111,114,109,70,108,97,103,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,0,103,101,116,78,111,110,109,97,120,83,117,112,112,114,101,115,115,105,111,110,0,103,101,116,84,121,112,101,0,115,101,116,78,111,110,109,97,120,83,117,112,112,114,101,115,115,105,111,110,0,115,101,116,84,121,112,101,0,80,116,114,60,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,62,0,109,108,95,66,111,111,115,116,0,103,101,116,87,101,105,103,104,116,84,114,105,109,82,97,116,101,0,115,101,116,87,101,97,107,67,111,117,110,116,0,103,101,116,87,101,97,107,67,111,117,110,116,0,103,101,116,66,111,111,115,116,84,121,112,101,0,115,101,116,87,101,105,103,104,116,84,114,105,109,82,97,116,101,0,115,101,116,66,111,111,115,116,84,121,112,101,0,80,116,114,60,109,108,95,66,111,111,115,116,62,0,68,101,110,115,101,79,112,116,105,99,97,108,70,108,111,119,0,99,111,108,108,101,99,116,71,97,114,98,97,103,101,0,76,105,110,101,83,101,103,109,101,110,116,68,101,116,101,99,116,111,114,0,80,116,114,60,76,105,110,101,83,101,103,109,101,110,116,68,101,116,101,99,116,111,114,62,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,0,67,104,105,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,0,75,101,121,80,111,105,110,116,0,99,111,110,118,101,114,116,49,0,111,118,101,114,108,97,112,0,112,116,0,97,110,103,108,101,0,114,101,115,112,111,110,115,101,0,111,99,116,97,118,101,0,99,108,97,115,115,95,105,100,0,65,108,105,103,110,77,84,66,0,115,101,116,67,117,116,0,99,111,109,112,117,116,101,66,105,116,109,97,112,115,0,115,101,116,69,120,99,108,117,100,101,82,97,110,103,101,0,103,101,116,69,120,99,108,117,100,101,82,97,110,103,101,0,115,101,116,77,97,120,66,105,116,115,0,115,104,105,102,116,77,97,116,0,103,101,116,67,117,116,0,103,101,116,77,97,120,66,105,116,115,0,80,116,114,60,65,108,105,103,110,77,84,66,62,0,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,101,114,0,103,101,116,70,117,108,108,65,102,102,105,110,101,0,115,101,116,70,117,108,108,65,102,102,105,110,101,0,80,116,114,60,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,101,114,62,0,80,116,114,60,77,101,114,103,101,68,101,98,101,118,101,99,62,0,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,0,103,101,116,78,68,117,109,109,105,101,115,0,103,101,116,68,101,102,97,117,108,116,67,111,115,116,0,98,117,105,108,100,67,111,115,116,77,97,116,114,105,120,0,115,101,116,78,68,117,109,109,105,101,115,0,115,101,116,68,101,102,97,117,108,116,67,111,115,116,0,80,116,114,60,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,62,0,109,108,95,68,84,114,101,101,115,0,103,101,116,85,115,101,49,83,69,82,117,108,101,0,103,101,116,77,105,110,83,97,109,112,108,101,67,111,117,110,116,0,115,101,116,84,114,117,110,99,97,116,101,80,114,117,110,101,100,84,114,101,101,0,115,101,116,77,105,110,83,97,109,112,108,101,67,111,117,110,116,0,103,101,116,84,114,117,110,99,97,116,101,80,114,117,110,101,100,84,114,101,101,0,103,101,116,80,114,105,111,114,115,0,103,101,116,67,86,70,111,108,100,115,0,115,101,116,85,115,101,83,117,114,114,111,103,97,116,101,115,0,115,101,116,85,115,101,49,83,69,82,117,108,101,0,103,101,116,77,97,120,67,97,116,101,103,111,114,105,101,115,0,103,101,116,85,115,101,83,117,114,114,111,103,97,116,101,115,0,103,101,116,77,97,120,68,101,112,116,104,0,115,101,116,80,114,105,111,114,115,0,103,101,116,82,101,103,114,101,115,115,105,111,110,65,99,99,117,114,97,99,121,0,80,116,114,60,109,108,95,68,84,114,101,101,115,62,0,66,79,87,75,77,101,97,110,115,84,114,97,105,110,101,114,0,99,108,117,115,116,101,114,49,0,103,101,116,83,97,116,117,114,97,116,105,111,110,0,103,101,116,83,99,97,108,101,0,115,101,116,83,97,116,117,114,97,116,105,111,110,0,115,101,116,83,99,97,108,101,0,80,116,114,60,84,111,110,101,109,97,112,77,97,110,116,105,117,107,62,0,109,108,95,83,116,97,116,77,111,100,101,108,0,105,115,84,114,97,105,110,101,100,0,105,115,67,108,97,115,115,105,102,105,101,114,0,99,97,108,99,69,114,114,111,114,0,103,101,116,86,97,114,67,111,117,110,116,0,116,114,97,105,110,49,0,115,101,116,71,97,109,109,97,0,103,101,116,71,97,109,109,97,0,80,116,114,60,84,111,110,101,109,97,112,62,0,109,108,95,75,78,101,97,114,101,115,116,0,115,101,116,73,115,67,108,97,115,115,105,102,105,101,114,0,103,101,116,73,115,67,108,97,115,115,105,102,105,101,114,0,115,101,116,65,108,103,111,114,105,116,104,109,84,121,112,101,0,115,101,116,69,109,97,120,0,115,101,116,68,101,102,97,117,108,116,75,0,103,101,116,68,101,102,97,117,108,116,75,0,103,101,116,69,109,97,120,0,103,101,116,65,108,103,111,114,105,116,104,109,84,121,112,101,0,80,116,114,60,109,108,95,75,78,101,97,114,101,115,116,62,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,0,80,116,114,60,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,62,0,83,117,98,100,105,118,50,68,0,105,110,115,101,114,116,49,0,101,100,103,101,79,114,103,0,114,111,116,97,116,101,69,100,103,101,0,105,110,105,116,68,101,108,97,117,110,97,121,0,103,101,116,69,100,103,101,0,103,101,116,84,114,105,97,110,103,108,101,76,105,115,116,0,110,101,120,116,69,100,103,101,0,101,100,103,101,68,115,116,0,103,101,116,69,100,103,101,76,105,115,116,0,103,101,116,86,101,114,116,101,120,0,103,101,116,86,111,114,111,110,111,105,70,97,99,101,116,76,105,115,116,0,115,121,109,69,100,103,101,0,66,82,73,83,75,0,80,116,114,60,66,82,73,83,75,62,0,75,97,108,109,97,110,70,105,108,116,101,114,0,99,111,114,114,101,99,116,0,115,116,97,116,101,80,114,101,0,115,116,97,116,101,80,111,115,116,0,116,114,97,110,115,105,116,105,111,110,77,97,116,114,105,120,0,99,111,110,116,114,111,108,77,97,116,114,105,120,0,109,101,97,115,117,114,101,109,101,110,116,77,97,116,114,105,120,0,112,114,111,99,101,115,115,78,111,105,115,101,67,111,118,0,109,101,97,115,117,114,101,109,101,110,116,78,111,105,115,101,67,111,118,0,101,114,114,111,114,67,111,118,80,114,101,0,103,97,105,110,0,101,114,114,111,114,67,111,118,80,111,115,116,0,69,77,68,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,0,84,104,105,110,80,108,97,116,101,83,112,108,105,110,101,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,0,115,101,116,82,101,103,117,108,97,114,105,122,97,116,105,111,110,80,97,114,97,109,101,116,101,114,0,103,101,116,82,101,103,117,108,97,114,105,122,97,116,105,111,110,80,97,114,97,109,101,116,101,114,0,80,116,114,60,84,104,105,110,80,108,97,116,101,83,112,108,105,110,101,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,62,0,83,104,97,112,101,67,111,110,116,101,120,116,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,0,103,101,116,66,101,110,100,105,110,103,69,110,101,114,103,121,87,101,105,103,104,116,0,103,101,116,67,111,115,116,69,120,116,114,97,99,116,111,114,0,103,101,116,84,114,97,110,115,102,111,114,109,65,108,103,111,114,105,116,104,109,0,115,101,116,84,114,97,110,115,102,111,114,109,65,108,103,111,114,105,116,104,109,0,115,101,116,83,104,97,112,101,67,111,110,116,101,120,116,87,101,105,103,104,116,0,103,101,116,73,110,110,101,114,82,97,100,105,117,115,0,115,101,116,73,109,97,103,101,65,112,112,101,97,114,97,110,99,101,87,101,105,103,104,116,0,115,101,116,82,111,116,97,116,105,111,110,73,110,118,97,114,105,97,110,116,0,115,101,116,66,101,110,100,105,110,103,69,110,101,114,103,121,87,101,105,103,104,116,0,115,101,116,83,116,100,68,101,118,0,115,101,116,67,111,115,116,69,120,116,114,97,99,116,111,114,0,103,101,116,83,104,97,112,101,67,111,110,116,101,120,116,87,101,105,103,104,116,0,103,101,116,82,111,116,97,116,105,111,110,73,110,118,97,114,105,97,110,116,0,103,101,116,65,110,103,117,108,97,114,66,105,110,115,0,103,101,116,73,109,97,103,101,65,112,112,101,97,114,97,110,99,101,87,101,105,103,104,116,0,103,101,116,79,117,116,101,114,82,97,100,105,117,115,0,103,101,116,82,97,100,105,97,108,66,105,110,115,0,103,101,116,83,116,100,68,101,118,0,80,116,114,60,83,104,97,112,101,67,111,110,116,101,120,116,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,62,0,75,65,90,69,0,115,101,116,69,120,116,101,110,100,101,100,0,115,101,116,78,79,99,116,97,118,101,76,97,121,101,114,115,0,103,101,116,78,79,99,116,97,118,101,115,0,103,101,116,78,79,99,116,97,118,101,76,97,121,101,114,115,0,115,101,116,78,79,99,116,97,118,101,115,0,103,101,116,85,112,114,105,103,104,116,0,103,101,116,69,120,116,101,110,100,101,100,0,115,101,116,85,112,114,105,103,104,116,0,115,101,116,68,105,102,102,117,115,105,118,105,116,121,0,103,101,116,68,105,102,102,117,115,105,118,105,116,121,0,80,116,114,60,75,65,90,69,62,0,67,97,108,105,98,114,97,116,101,67,82,70,0,65,75,65,90,69,0,115,101,116,68,101,115,99,114,105,112,116,111,114,84,121,112,101,0,103,101,116,68,101,115,99,114,105,112,116,111,114,84,121,112,101,0,115,101,116,68,101,115,99,114,105,112,116,111,114,67,104,97,110,110,101,108,115,0,103,101,116,68,101,115,99,114,105,112,116,111,114,67,104,97,110,110,101,108,115,0,115,101,116,68,101,115,99,114,105,112,116,111,114,83,105,122,101,0,80,116,114,60,65,75,65,90,69,62,0,70,101,97,116,117,114,101,50,68,0,100,101,102,97,117,108,116,78,111,114,109,0,100,101,115,99,114,105,112,116,111,114,83,105,122,101,0,100,101,115,99,114,105,112,116,111,114,84,121,112,101,0,102,108,97,110,110,95,73,110,100,101,120,0,103,101,116,65,108,103,111,114,105,116,104,109,0,103,101,116,68,105,115,116,97,110,99,101,0,109,108,95,78,111,114,109,97,108,66,97,121,101,115,67,108,97,115,115,105,102,105,101,114,0,80,116,114,60,109,108,95,78,111,114,109,97,108,66,97,121,101,115,67,108,97,115,115,105,102,105,101,114,62,0,77,101,114,103,101,69,120,112,111,115,117,114,101,115,0,80,116,114,60,77,101,114,103,101,82,111,98,101,114,116,115,111,110,62,0,115,101,116,82,97,110,100,111,109,0,103,101,116,82,97,110,100,111,109,0,103,101,116,83,97,109,112,108,101,115,0,115,101,116,76,97,109,98,100,97,0,115,101,116,83,97,109,112,108,101,115,0,103,101,116,76,97,109,98,100,97,0,80,116,114,60,67,97,108,105,98,114,97,116,101,68,101,98,101,118,101,99,62,0,66,79,87,73,109,103,68,101,115,99,114,105,112,116,111,114,69,120,116,114,97,99,116,111,114,0,115,101,116,86,111,99,97,98,117,108,97,114,121,0,103,101,116,86,111,99,97,98,117,108,97,114,121,0,65,108,105,103,110,69,120,112,111,115,117,114,101,115,0,65,108,103,111,114,105,116,104,109,0,103,101,116,68,101,102,97,117,108,116,78,97,109,101,0,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,0,109,108,95,65,78,78,95,77,76,80,0,103,101,116,82,112,114,111,112,68,87,77,105,110,117,115,0,103,101,116,82,112,114,111,112,68,87,77,105,110,0,115,101,116,82,112,114,111,112,68,87,77,105,110,117,115,0,103,101,116,82,112,114,111,112,68,87,80,108,117,115,0,115,101,116,66,97,99,107,112,114,111,112,87,101,105,103,104,116,83,99,97,108,101,0,115,101,116,82,112,114,111,112,68,87,77,105,110,0,103,101,116,66,97,99,107,112,114,111,112,77,111,109,101,110,116,117,109,83,99,97,108,101,0,103,101,116,82,112,114,111,112,68,87,77,97,120,0,115,101,116,82,112,114,111,112,68,87,77,97,120,0,115,101,116,82,112,114,111,112,68,87,48,0,115,101,116,66,97,99,107,112,114,111,112,77,111,109,101,110,116,117,109,83,99,97,108,101,0,115,101,116,82,112,114,111,112,68,87,80,108,117,115,0,103,101,116,76,97,121,101,114,83,105,122,101,115,0,103,101,116,66,97,99,107,112,114,111,112,87,101,105,103,104,116,83,99,97,108,101,0,103,101,116,82,112,114,111,112,68,87,48,0,80,116,114,60,109,108,95,65,78,78,95,77,76,80,62,0,109,108,95,82,84,114,101,101,115,0,103,101,116,67,97,108,99,117,108,97,116,101,86,97,114,73,109,112,111,114,116,97,110,99,101,0,115,101,116,67,97,108,99,117,108,97,116,101,86,97,114,73,109,112,111,114,116,97,110,99,101,0,103,101,116,86,97,114,73,109,112,111,114,116,97,110,99,101,0,103,101,116,65,99,116,105,118,101,86,97,114,67,111,117,110,116,0,115,101,116,65,99,116,105,118,101,86,97,114,67,111,117,110,116,0,80,116,114,60,109,108,95,82,84,114,101,101,115,62,0,83,104,97,112,101,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,0,71,70,84,84,68,101,116,101,99,116,111,114,0,103,101,116,66,108,111,99,107,83,105,122,101,0,103,101,116,75,0,115,101,116,72,97,114,114,105,115,68,101,116,101,99,116,111,114,0,115,101,116,66,108,111,99,107,83,105,122,101,0,115,101,116,81,117,97,108,105,116,121,76,101,118,101,108,0,115,101,116,77,97,120,70,101,97,116,117,114,101,115,0,115,101,116,75,0,103,101,116,77,97,120,70,101,97,116,117,114,101,115,0,115,101,116,77,105,110,68,105,115,116,97,110,99,101,0,103,101,116,77,105,110,68,105,115,116,97,110,99,101,0,103,101,116,81,117,97,108,105,116,121,76,101,118,101,108,0,103,101,116,72,97,114,114,105,115,68,101,116,101,99,116,111,114,0,80,116,114,60,71,70,84,84,68,101,116,101,99,116,111,114,62,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,0,107,110,110,77,97,116,99,104,49,0,109,97,116,99,104,0,109,97,116,99,104,49,0,103,101,116,84,114,97,105,110,68,101,115,99,114,105,112,116,111,114,115,0,105,115,77,97,115,107,83,117,112,112,111,114,116,101,100,0,80,116,114,60,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,62,0,68,77,97,116,99,104,0,113,117,101,114,121,73,100,120,0,116,114,97,105,110,73,100,120,0,105,109,103,73,100,120,0,115,101,116,83,105,103,109,97,83,112,97,99,101,0,115,101,116,83,105,103,109,97,67,111,108,111,114,0,103,101,116,67,111,110,116,114,97,115,116,0,103,101,116,83,105,103,109,97,83,112,97,99,101,0,103,101,116,83,105,103,109,97,67,111,108,111,114,0,115,101,116,67,111,110,116,114,97,115,116,0,80,116,114,60,84,111,110,101,109,97,112,68,117,114,97,110,100,62,0,66,70,77,97,116,99,104,101,114,0,66,97,115,101,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,0,109,108,95,84,114,97,105,110,68,97,116,97,0,103,101,116,84,114,97,105,110,82,101,115,112,111,110,115,101,115,0,103,101,116,78,84,101,115,116,83,97,109,112,108,101,115,0,103,101,116,84,101,115,116,82,101,115,112,111,110,115,101,115,0,103,101,116,78,84,114,97,105,110,83,97,109,112,108,101,115,0,103,101,116,86,97,114,73,100,120,0,103,101,116,84,101,115,116,78,111,114,109,67,97,116,82,101,115,112,111,110,115,101,115,0,103,101,116,83,97,109,112,108,101,87,101,105,103,104,116,115,0,103,101,116,67,108,97,115,115,76,97,98,101,108,115,0,103,101,116,78,65,108,108,86,97,114,115,0,103,101,116,82,101,115,112,111,110,115,101,115,0,103,101,116,78,86,97,114,115,0,103,101,116,84,101,115,116,83,97,109,112,108,101,73,100,120,0,103,101,116,84,114,97,105,110,78,111,114,109,67,97,116,82,101,115,112,111,110,115,101,115,0,103,101,116,84,114,97,105,110,83,97,109,112,108,101,87,101,105,103,104,116,115,0,103,101,116,84,101,115,116,83,97,109,112,108,101,87,101,105,103,104,116,115,0,103,101,116,84,114,97,105,110,83,97,109,112,108,101,115,0,103,101,116,86,97,114,84,121,112,101,0,103,101,116,84,114,97,105,110,83,97,109,112,108,101,73,100,120,0,103,101,116,77,105,115,115,105,110,103,0,103,101,116,68,101,102,97,117,108,116,83,117,98,115,116,86,97,108,117,101,115,0,103,101,116,67,97,116,77,97,112,0,103,101,116,67,97,116,79,102,115,0,103,101,116,78,83,97,109,112,108,101,115,0,103,101,116,78,111,114,109,67,97,116,82,101,115,112,111,110,115,101,115,0,103,101,116,82,101,115,112,111,110,115,101,84,121,112,101,0,103,101,116,76,97,121,111,117,116,0,80,116,114,60,109,108,95,84,114,97,105,110,68,97,116,97,62,0,77,83,69,82,0,103,101,116,80,97,115,115,50,79,110,108,121,0,115,101,116,77,105,110,65,114,101,97,0,103,101,116,68,101,108,116,97,0,103,101,116,77,97,120,65,114,101,97,0,115,101,116,77,97,120,65,114,101,97,0,115,101,116,80,97,115,115,50,79,110,108,121,0,103,101,116,77,105,110,65,114,101,97,0,115,101,116,68,101,108,116,97,0,80,116,114,60,77,83,69,82,62,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,75,78,78,0,103,101,116,107,78,78,83,97,109,112,108,101,115,0,103,101,116,68,105,115,116,50,84,104,114,101,115,104,111,108,100,0,115,101,116,68,105,115,116,50,84,104,114,101,115,104,111,108,100,0,115,101,116,107,78,78,83,97,109,112,108,101,115,0,115,101,116,78,83,97,109,112,108,101,115,0,80,116,114,60,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,75,78,78,62,0,68,117,97,108,84,86,76,49,79,112,116,105,99,97,108,70,108,111,119,0,80,116,114,60,68,117,97,108,84,86,76,49,79,112,116,105,99,97,108,70,108,111,119,62,0,67,76,65,72,69,0,115,101,116,84,105,108,101,115,71,114,105,100,83,105,122,101,0,115,101,116,67,108,105,112,76,105,109,105,116,0,103,101,116,84,105,108,101,115,71,114,105,100,83,105,122,101,0,103,101,116,67,108,105,112,76,105,109,105,116,0,80,116,114,60,67,76,65,72,69,62,0,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,95,80,97,114,97,109,115,0,77,111,109,101,110,116,115,0,109,48,48,0,109,49,48,0,109,48,49,0,109,50,48,0,109,49,49,0,109,48,50,0,109,51,48,0,109,50,49,0,109,49,50,0,109,48,51,0,109,117,50,48,0,109,117,49,49,0,109,117,48,50,0,109,117,51,48,0,109,117,50,49,0,109,117,49,50,0,109,117,48,51,0,110,117,50,48,0,110,117,49,49,0,110,117,48,50,0,110,117,51,48,0,110,117,50,49,0,110,117,49,50,0,110,117,48,51,0,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,0,80,116,114,60,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,62,0,109,108,95,83,86,77,0,103,101,116,68,101,103,114,101,101,0,103,101,116,67,0,115,101,116,67,111,101,102,48,0,103,101,116,80,0,115,101,116,78,117,0,103,101,116,83,117,112,112,111,114,116,86,101,99,116,111,114,115,0,115,101,116,68,101,103,114,101,101,0,115,101,116,67,0,115,101,116,80,0,103,101,116,67,111,101,102,48,0,103,101,116,67,108,97,115,115,87,101,105,103,104,116,115,0,115,101,116,75,101,114,110,101,108,0,115,101,116,67,108,97,115,115,87,101,105,103,104,116,115,0,103,101,116,78,117,0,80,116,114,60,109,108,95,83,86,77,62,0,69,77,68,76,49,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,0,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,50,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,51,0,115,101,116,67,111,108,111,114,65,100,97,112,116,97,116,105,111,110,0,115,101,116,76,105,103,104,116,65,100,97,112,116,97,116,105,111,110,0,103,101,116,73,110,116,101,110,115,105,116,121,0,103,101,116,76,105,103,104,116,65,100,97,112,116,97,116,105,111,110,0,115,101,116,73,110,116,101,110,115,105,116,121,0,103,101,116,67,111,108,111,114,65,100,97,112,116,97,116,105,111,110,0,80,116,114,60,84,111,110,101,109,97,112,82,101,105,110,104,97,114,100,62,0,115,101,116,66,105,97,115,0,103,101,116,66,105,97,115,0,80,116,114,60,84,111,110,101,109,97,112,68,114,97,103,111,62,0,72,97,117,115,100,111,114,102,102,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,0,115,101,116,68,105,115,116,97,110,99,101,70,108,97,103,0,103,101,116,68,105,115,116,97,110,99,101,70,108,97,103,0,103,101,116,82,97,110,107,80,114,111,112,111,114,116,105,111,110,0,80,116,114,60,72,97,117,115,100,111,114,102,102,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,62,0,66,79,87,84,114,97,105,110,101,114,0,103,101,116,68,101,115,99,114,105,112,116,111,114,115,0,100,101,115,99,114,105,112,116,111,114,115,67,111,117,110,116,0,79,82,66,0,115,101,116,69,100,103,101,84,104,114,101,115,104,111,108,100,0,115,101,116,70,105,114,115,116,76,101,118,101,108,0,103,101,116,70,97,115,116,84,104,114,101,115,104,111,108,100,0,103,101,116,87,84,65,95,75,0,103,101,116,78,76,101,118,101,108,115,0,115,101,116,78,76,101,118,101,108,115,0,115,101,116,70,97,115,116,84,104,114,101,115,104,111,108,100,0,103,101,116,83,99,97,108,101,70,97,99,116,111,114,0,115,101,116,80,97,116,99,104,83,105,122,101,0,115,101,116,87,84,65,95,75,0,115,101,116,83,99,97,108,101,70,97,99,116,111,114,0,103,101,116,80,97,116,99,104,83,105,122,101,0,103,101,116,69,100,103,101,84,104,114,101,115,104,111,108,100,0,103,101,116,70,105,114,115,116,76,101,118,101,108,0,103,101,116,83,99,111,114,101,84,121,112,101,0,115,101,116,83,99,111,114,101,84,121,112,101,0,80,116,114,60,79,82,66,62,0,109,108,95,69,77,0,116,114,97,105,110,69,0,103,101,116,67,111,118,115,0,116,114,97,105,110,77,0,103,101,116,67,108,117,115,116,101,114,115,78,117,109,98,101,114,0,103,101,116,67,111,118,97,114,105,97,110,99,101,77,97,116,114,105,120,84,121,112,101,0,103,101,116,77,101,97,110,115,0,116,114,97,105,110,69,77,0,80,116,114,60,109,108,95,69,77,62,0,65,100,97,112,116,105,118,101,84,104,114,101,115,104,111,108,100,84,121,112,101,115,0,65,68,65,80,84,73,86,69,95,84,72,82,69,83,72,95,77,69,65,78,95,67,0,65,68,65,80,84,73,86,69,95,84,72,82,69,83,72,95,71,65,85,83,83,73,65,78,95,67,0,67,111,108,111,114,67,111,110,118,101,114,115,105,111,110,67,111,100,101,115,0,67,79,76,79,82,95,66,71,82,50,66,71,82,65,0,67,79,76,79,82,95,82,71,66,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,0,67,79,76,79,82,95,82,71,66,65,50,82,71,66,0,67,79,76,79,82,95,66,71,82,50,82,71,66,65,0,67,79,76,79,82,95,82,71,66,50,66,71,82,65,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,0,67,79,76,79,82,95,66,71,82,65,50,82,71,66,0,67,79,76,79,82,95,66,71,82,50,82,71,66,0,67,79,76,79,82,95,82,71,66,50,66,71,82,0,67,79,76,79,82,95,66,71,82,65,50,82,71,66,65,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,50,71,82,65,89,0,67,79,76,79,82,95,82,71,66,50,71,82,65,89,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,0,67,79,76,79,82,95,71,82,65,89,50,82,71,66,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,65,0,67,79,76,79,82,95,71,82,65,89,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,65,50,71,82,65,89,0,67,79,76,79,82,95,82,71,66,65,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,50,66,71,82,53,54,53,0,67,79,76,79,82,95,82,71,66,50,66,71,82,53,54,53,0,67,79,76,79,82,95,66,71,82,53,54,53,50,66,71,82,0,67,79,76,79,82,95,66,71,82,53,54,53,50,82,71,66,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,53,54,53,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,53,54,53,0,67,79,76,79,82,95,66,71,82,53,54,53,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,53,54,53,50,82,71,66,65,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,53,54,53,0,67,79,76,79,82,95,66,71,82,53,54,53,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,50,66,71,82,53,53,53,0,67,79,76,79,82,95,82,71,66,50,66,71,82,53,53,53,0,67,79,76,79,82,95,66,71,82,53,53,53,50,66,71,82,0,67,79,76,79,82,95,66,71,82,53,53,53,50,82,71,66,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,53,53,53,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,53,53,53,0,67,79,76,79,82,95,66,71,82,53,53,53,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,53,53,53,50,82,71,66,65,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,53,53,53,0,67,79,76,79,82,95,66,71,82,53,53,53,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,50,88,89,90,0,67,79,76,79,82,95,82,71,66,50,88,89,90,0,67,79,76,79,82,95,88,89,90,50,66,71,82,0,67,79,76,79,82,95,88,89,90,50,82,71,66,0,67,79,76,79,82,95,66,71,82,50,89,67,114,67,98,0,67,79,76,79,82,95,82,71,66,50,89,67,114,67,98,0,67,79,76,79,82,95,89,67,114,67,98,50,66,71,82,0,67,79,76,79,82,95,89,67,114,67,98,50,82,71,66,0,67,79,76,79,82,95,66,71,82,50,72,83,86,0,67,79,76,79,82,95,82,71,66,50,72,83,86,0,67,79,76,79,82,95,66,71,82,50,76,97,98,0,67,79,76,79,82,95,82,71,66,50,76,97,98,0,67,79,76,79,82,95,66,71,82,50,76,117,118,0,67,79,76,79,82,95,82,71,66,50,76,117,118,0,67,79,76,79,82,95,66,71,82,50,72,76,83,0,67,79,76,79,82,95,82,71,66,50,72,76,83,0,67,79,76,79,82,95,72,83,86,50,66,71,82,0,67,79,76,79,82,95,72,83,86,50,82,71,66,0,67,79,76,79,82,95,76,97,98,50,66,71,82,0,67,79,76,79,82,95,76,97,98,50,82,71,66,0,67,79,76,79,82,95,76,117,118,50,66,71,82,0,67,79,76,79,82,95,76,117,118,50,82,71,66,0,67,79,76,79,82,95,72,76,83,50,66,71,82,0,67,79,76,79,82,95,72,76,83,50,82,71,66,0,67,79,76,79,82,95,66,71,82,50,72,83,86,95,70,85,76,76,0,67,79,76,79,82,95,82,71,66,50,72,83,86,95,70,85,76,76,0,67,79,76,79,82,95,66,71,82,50,72,76,83,95,70,85,76,76,0,67,79,76,79,82,95,82,71,66,50,72,76,83,95,70,85,76,76,0,67,79,76,79,82,95,72,83,86,50,66,71,82,95,70,85,76,76,0,67,79,76,79,82,95,72,83,86,50,82,71,66,95,70,85,76,76,0,67,79,76,79,82,95,72,76,83,50,66,71,82,95,70,85,76,76,0,67,79,76,79,82,95,72,76,83,50,82,71,66,95,70,85,76,76,0,67,79,76,79,82,95,76,66,71,82,50,76,97,98,0,67,79,76,79,82,95,76,82,71,66,50,76,97,98,0,67,79,76,79,82,95,76,66,71,82,50,76,117,118,0,67,79,76,79,82,95,76,82,71,66,50,76,117,118,0,67,79,76,79,82,95,76,97,98,50,76,66,71,82,0,67,79,76,79,82,95,76,97,98,50,76,82,71,66,0,67,79,76,79,82,95,76,117,118,50,76,66,71,82,0,67,79,76,79,82,95,76,117,118,50,76,82,71,66,0,67,79,76,79,82,95,66,71,82,50,89,85,86,0,67,79,76,79,82,95,82,71,66,50,89,85,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,0,67,79,76,79,82,95,89,85,86,50,82,71,66,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,82,71,66,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,66,71,82,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,82,71,66,65,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,66,71,82,65,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,82,71,66,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,66,71,82,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,82,71,66,65,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,66,71,82,65,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,52,50,48,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,71,82,65,89,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,71,82,65,89,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,78,86,0,67,79,76,79,82,95,82,71,66,65,50,109,82,71,66,65,0,67,79,76,79,82,95,109,82,71,66,65,50,82,71,66,65,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,95,69,65,0,67],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+178420);allocate([79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,95,69,65,0,67,79,76,79,82,95,67,79,76,79,82,67,86,84,95,77,65,88,0,67,111,108,111,114,109,97,112,84,121,112,101,115,0,67,79,76,79,82,77,65,80,95,65,85,84,85,77,78,0,67,79,76,79,82,77,65,80,95,66,79,78,69,0,67,79,76,79,82,77,65,80,95,74,69,84,0,67,79,76,79,82,77,65,80,95,87,73,78,84,69,82,0,67,79,76,79,82,77,65,80,95,82,65,73,78,66,79,87,0,67,79,76,79,82,77,65,80,95,79,67,69,65,78,0,67,79,76,79,82,77,65,80,95,83,85,77,77,69,82,0,67,79,76,79,82,77,65,80,95,83,80,82,73,78,71,0,67,79,76,79,82,77,65,80,95,67,79,79,76,0,67,79,76,79,82,77,65,80,95,72,83,86,0,67,79,76,79,82,77,65,80,95,80,73,78,75,0,67,79,76,79,82,77,65,80,95,72,79,84,0,67,79,76,79,82,77,65,80,95,80,65,82,85,76,65,0,67,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,84,121,112,101,115,0,67,67,95,83,84,65,84,95,76,69,70,84,0,67,67,95,83,84,65,84,95,84,79,80,0,67,67,95,83,84,65,84,95,87,73,68,84,72,0,67,67,95,83,84,65,84,95,72,69,73,71,72,84,0,67,67,95,83,84,65,84,95,65,82,69,65,0,67,67,95,83,84,65,84,95,77,65,88,0,67,111,110,116,111,117,114,65,112,112,114,111,120,105,109,97,116,105,111,110,77,111,100,101,115,0,67,72,65,73,78,95,65,80,80,82,79,88,95,78,79,78,69,0,67,72,65,73,78,95,65,80,80,82,79,88,95,83,73,77,80,76,69,0,67,72,65,73,78,95,65,80,80,82,79,88,95,84,67,56,57,95,76,49,0,67,72,65,73,78,95,65,80,80,82,79,88,95,84,67,56,57,95,75,67,79,83,0,67,111,118,97,114,70,108,97,103,115,0,67,79,86,65,82,95,83,67,82,65,77,66,76,69,68,0,67,79,86,65,82,95,78,79,82,77,65,76,0,67,79,86,65,82,95,85,83,69,95,65,86,71,0,67,79,86,65,82,95,83,67,65,76,69,0,67,79,86,65,82,95,82,79,87,83,0,67,79,86,65,82,95,67,79,76,83,0,68,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,76,97,98,101,108,84,121,112,101,115,0,68,73,83,84,95,76,65,66,69,76,95,67,67,79,77,80,0,68,73,83,84,95,76,65,66,69,76,95,80,73,88,69,76,0,68,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,77,97,115,107,115,0,68,73,83,84,95,77,65,83,75,95,51,0,68,73,83,84,95,77,65,83,75,95,53,0,68,73,83,84,95,77,65,83,75,95,80,82,69,67,73,83,69,0,68,105,115,116,97,110,99,101,84,121,112,101,115,0,68,73,83,84,95,85,83,69,82,0,68,73,83,84,95,76,49,0,68,73,83,84,95,76,50,0,68,73,83,84,95,67,0,68,73,83,84,95,76,49,50,0,68,73,83,84,95,70,65,73,82,0,68,73,83,84,95,87,69,76,83,67,72,0,68,73,83,84,95,72,85,66,69,82,0,70,108,111,111,100,70,105,108,108,70,108,97,103,115,0,70,76,79,79,68,70,73,76,76,95,70,73,88,69,68,95,82,65,78,71,69,0,70,76,79,79,68,70,73,76,76,95,77,65,83,75,95,79,78,76,89,0,71,114,97,98,67,117,116,67,108,97,115,115,101,115,0,71,67,95,66,71,68,0,71,67,95,70,71,68,0,71,67,95,80,82,95,66,71,68,0,71,67,95,80,82,95,70,71,68,0,71,114,97,98,67,117,116,77,111,100,101,115,0,71,67,95,73,78,73,84,95,87,73,84,72,95,82,69,67,84,0,71,67,95,73,78,73,84,95,87,73,84,72,95,77,65,83,75,0,71,67,95,69,86,65,76,0,72,101,114,115,104,101,121,70,111,110,116,115,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,73,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,80,76,65,73,78,0,70,79,78,84,95,72,69,82,83,72,69,89,95,68,85,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,67,79,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,84,82,73,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,67,79,77,80,76,69,88,95,83,77,65,76,76,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,67,82,73,80,84,95,83,73,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,67,82,73,80,84,95,67,79,77,80,76,69,88,0,70,79,78,84,95,73,84,65,76,73,67,0,72,105,115,116,67,111,109,112,77,101,116,104,111,100,115,0,72,73,83,84,67,77,80,95,67,79,82,82,69,76,0,72,73,83,84,67,77,80,95,67,72,73,83,81,82,0,72,73,83,84,67,77,80,95,73,78,84,69,82,83,69,67,84,0,72,73,83,84,67,77,80,95,66,72,65,84,84,65,67,72,65,82,89,89,65,0,72,73,83,84,67,77,80,95,72,69,76,76,73,78,71,69,82,0,72,73,83,84,67,77,80,95,67,72,73,83,81,82,95,65,76,84,0,72,73,83,84,67,77,80,95,75,76,95,68,73,86,0,72,111,117,103,104,77,111,100,101,115,0,72,79,85,71,72,95,83,84,65,78,68,65,82,68,0,72,79,85,71,72,95,80,82,79,66,65,66,73,76,73,83,84,73,67,0,72,79,85,71,72,95,77,85,76,84,73,95,83,67,65,76,69,0,72,79,85,71,72,95,71,82,65,68,73,69,78,84,0,73,109,114,101,97,100,77,111,100,101,115,0,73,77,82,69,65,68,95,85,78,67,72,65,78,71,69,68,0,73,77,82,69,65,68,95,71,82,65,89,83,67,65,76,69,0,73,77,82,69,65,68,95,67,79,76,79,82,0,73,77,82,69,65,68,95,65,78,89,68,69,80,84,72,0,73,77,82,69,65,68,95,65,78,89,67,79,76,79,82,0,73,77,82,69,65,68,95,76,79,65,68,95,71,68,65,76,0,73,77,82,69,65,68,95,82,69,68,85,67,69,68,95,71,82,65,89,83,67,65,76,69,95,50,0,73,77,82,69,65,68,95,82,69,68,85,67,69,68,95,67,79,76,79,82,95,50,0,73,77,82,69,65,68,95,82,69,68,85,67,69,68,95,71,82,65,89,83,67,65,76,69,95,52,0,73,77,82,69,65,68,95,82,69,68,85,67,69,68,95,67,79,76,79,82,95,52,0,73,77,82,69,65,68,95,82,69,68,85,67,69,68,95,71,82,65,89,83,67,65,76,69,95,56,0,73,77,82,69,65,68,95,82,69,68,85,67,69,68,95,67,79,76,79,82,95,56,0,73,109,119,114,105,116,101,70,108,97,103,115,0,73,77,87,82,73,84,69,95,74,80,69,71,95,81,85,65,76,73,84,89,0,73,77,87,82,73,84,69,95,74,80,69,71,95,80,82,79,71,82,69,83,83,73,86,69,0,73,77,87,82,73,84,69,95,74,80,69,71,95,79,80,84,73,77,73,90,69,0,73,77,87,82,73,84,69,95,74,80,69,71,95,82,83,84,95,73,78,84,69,82,86,65,76,0,73,77,87,82,73,84,69,95,74,80,69,71,95,76,85,77,65,95,81,85,65,76,73,84,89,0,73,77,87,82,73,84,69,95,74,80,69,71,95,67,72,82,79,77,65,95,81,85,65,76,73,84,89,0,73,77,87,82,73,84,69,95,80,78,71,95,67,79,77,80,82,69,83,83,73,79,78,0,73,77,87,82,73,84,69,95,80,78,71,95,83,84,82,65,84,69,71,89,0,73,77,87,82,73,84,69,95,80,78,71,95,66,73,76,69,86,69,76,0,73,77,87,82,73,84,69,95,80,88,77,95,66,73,78,65,82,89,0,73,77,87,82,73,84,69,95,87,69,66,80,95,81,85,65,76,73,84,89,0,73,109,119,114,105,116,101,80,78,71,70,108,97,103,115,0,73,77,87,82,73,84,69,95,80,78,71,95,83,84,82,65,84,69,71,89,95,68,69,70,65,85,76,84,0,73,77,87,82,73,84,69,95,80,78,71,95,83,84,82,65,84,69,71,89,95,70,73,76,84,69,82,69,68,0,73,77,87,82,73,84,69,95,80,78,71,95,83,84,82,65,84,69,71,89,95,72,85,70,70,77,65,78,95,79,78,76,89,0,73,77,87,82,73,84,69,95,80,78,71,95,83,84,82,65,84,69,71,89,95,82,76,69,0,73,77,87,82,73,84,69,95,80,78,71,95,83,84,82,65,84,69,71,89,95,70,73,88,69,68,0,73,110,116,101,114,112,111,108,97,116,105,111,110,70,108,97,103,115,0,73,78,84,69,82,95,78,69,65,82,69,83,84,0,73,78,84,69,82,95,76,73,78,69,65,82,0,73,78,84,69,82,95,67,85,66,73,67,0,73,78,84,69,82,95,65,82,69,65,0,73,78,84,69,82,95,76,65,78,67,90,79,83,52,0,73,78,84,69,82,95,77,65,88,0,87,65,82,80,95,70,73,76,76,95,79,85,84,76,73,69,82,83,0,87,65,82,80,95,73,78,86,69,82,83,69,95,77,65,80,0,73,110,116,101,114,112,111,108,97,116,105,111,110,77,97,115,107,115,0,73,78,84,69,82,95,66,73,84,83,0,73,78,84,69,82,95,66,73,84,83,50,0,73,78,84,69,82,95,84,65,66,95,83,73,90,69,0,73,78,84,69,82,95,84,65,66,95,83,73,90,69,50,0,75,109,101,97,110,115,70,108,97,103,115,0,75,77,69,65,78,83,95,82,65,78,68,79,77,95,67,69,78,84,69,82,83,0,75,77,69,65,78,83,95,80,80,95,67,69,78,84,69,82,83,0,75,77,69,65,78,83,95,85,83,69,95,73,78,73,84,73,65,76,95,76,65,66,69,76,83,0,76,105,110,101,83,101,103,109,101,110,116,68,101,116,101,99,116,111,114,77,111,100,101,115,0,76,83,68,95,82,69,70,73,78,69,95,78,79,78,69,0,76,83,68,95,82,69,70,73,78,69,95,83,84,68,0,76,83,68,95,82,69,70,73,78,69,95,65,68,86,0,76,105,110,101,84,121,112,101,115,0,70,73,76,76,69,68,0,76,73,78,69,95,52,0,76,73,78,69,95,56,0,76,73,78,69,95,65,65,0,77,97,114,107,101,114,84,121,112,101,115,0,77,65,82,75,69,82,95,67,82,79,83,83,0,77,65,82,75,69,82,95,84,73,76,84,69,68,95,67,82,79,83,83,0,77,65,82,75,69,82,95,83,84,65,82,0,77,65,82,75,69,82,95,68,73,65,77,79,78,68,0,77,65,82,75,69,82,95,83,81,85,65,82,69,0,77,65,82,75,69,82,95,84,82,73,65,78,71,76,69,95,85,80,0,77,65,82,75,69,82,95,84,82,73,65,78,71,76,69,95,68,79,87,78,0,77,111,114,112,104,83,104,97,112,101,115,0,77,79,82,80,72,95,82,69,67,84,0,77,79,82,80,72,95,67,82,79,83,83,0,77,79,82,80,72,95,69,76,76,73,80,83,69,0,77,111,114,112,104,84,121,112,101,115,0,77,79,82,80,72,95,69,82,79,68,69,0,77,79,82,80,72,95,68,73,76,65,84,69,0,77,79,82,80,72,95,79,80,69,78,0,77,79,82,80,72,95,67,76,79,83,69,0,77,79,82,80,72,95,71,82,65,68,73,69,78,84,0,77,79,82,80,72,95,84,79,80,72,65,84,0,77,79,82,80,72,95,66,76,65,67,75,72,65,84,0,77,79,82,80,72,95,72,73,84,77,73,83,83,0,80,67,65,95,70,108,97,103,115,0,68,65,84,65,95,65,83,95,82,79,87,0,68,65,84,65,95,65,83,95,67,79,76,0,85,83,69,95,65,86,71,0,82,101,99,116,97,110,103,108,101,115,73,110,116,101,114,115,101,99,116,84,121,112,101,115,0,73,78,84,69,82,83,69,67,84,95,78,79,78,69,0,73,78,84,69,82,83,69,67,84,95,80,65,82,84,73,65,76,0,73,78,84,69,82,83,69,67,84,95,70,85,76,76,0,82,101,100,117,99,101,84,121,112,101,115,0,82,69,68,85,67,69,95,83,85,77,0,82,69,68,85,67,69,95,65,86,71,0,82,69,68,85,67,69,95,77,65,88,0,82,69,68,85,67,69,95,77,73,78,0,82,101,116,114,105,101,118,97,108,77,111,100,101,115,0,82,69,84,82,95,69,88,84,69,82,78,65,76,0,82,69,84,82,95,76,73,83,84,0,82,69,84,82,95,67,67,79,77,80,0,82,69,84,82,95,84,82,69,69,0,82,69,84,82,95,70,76,79,79,68,70,73,76,76,0,83,86,68,95,70,108,97,103,115,0,77,79,68,73,70,89,95,65,0,78,79,95,85,86,0,70,85,76,76,95,85,86,0,83,111,114,116,70,108,97,103,115,0,83,79,82,84,95,69,86,69,82,89,95,82,79,87,0,83,79,82,84,95,69,86,69,82,89,95,67,79,76,85,77,78,0,83,79,82,84,95,65,83,67,69,78,68,73,78,71,0,83,79,82,84,95,68,69,83,67,69,78,68,73,78,71,0,84,101,109,112,108,97,116,101,77,97,116,99,104,77,111,100,101,115,0,84,77,95,83,81,68,73,70,70,0,84,77,95,83,81,68,73,70,70,95,78,79,82,77,69,68,0,84,77,95,67,67,79,82,82,0,84,77,95,67,67,79,82,82,95,78,79,82,77,69,68,0,84,77,95,67,67,79,69,70,70,0,84,77,95,67,67,79,69,70,70,95,78,79,82,77,69,68,0,84,101,114,109,67,114,105,116,101,114,105,97,95,84,121,112,101,0,67,79,85,78,84,0,77,65,88,95,73,84,69,82,0,69,80,83,0,84,104,114,101,115,104,111,108,100,84,121,112,101,115,0,84,72,82,69,83,72,95,66,73,78,65,82,89,0,84,72,82,69,83,72,95,66,73,78,65,82,89,95,73,78,86,0,84,72,82,69,83,72,95,84,82,85,78,67,0,84,72,82,69,83,72,95,84,79,90,69,82,79,0,84,72,82,69,83,72,95,84,79,90,69,82,79,95,73,78,86,0,84,72,82,69,83,72,95,77,65,83,75,0,84,72,82,69,83,72,95,79,84,83,85,0,84,72,82,69,83,72,95,84,82,73,65,78,71,76,69,0,85,77,97,116,85,115,97,103,101,70,108,97,103,115,0,85,83,65,71,69,95,68,69,70,65,85,76,84,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,72,79,83,84,95,77,69,77,79,82,89,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,68,69,86,73,67,69,95,77,69,77,79,82,89,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,83,72,65,82,69,68,95,77,69,77,79,82,89,0,95,95,85,77,65,84,95,85,83,65,71,69,95,70,76,65,71,83,95,51,50,66,73,84,0,85,110,100,105,115,116,111,114,116,84,121,112,101,115,0,80,82,79,74,95,83,80,72,69,82,73,67,65,76,95,79,82,84,72,79,0,80,82,79,74,95,83,80,72,69,82,73,67,65,76,95,69,81,82,69,67,84,0,109,108,95,65,78,78,95,77,76,80,95,65,99,116,105,118,97,116,105,111,110,70,117,110,99,116,105,111,110,115,0,109,108,95,65,78,78,95,77,76,80,95,84,114,97,105,110,70,108,97,103,115,0,85,80,68,65,84,69,95,87,69,73,71,72,84,83,0,78,79,95,73,78,80,85,84,95,83,67,65,76,69,0,78,79,95,79,85,84,80,85,84,95,83,67,65,76,69,0,109,108,95,65,78,78,95,77,76,80,95,84,114,97,105,110,105,110,103,77,101,116,104,111,100,115,0,109,108,95,66,111,111,115,116,95,84,121,112,101,115,0,68,73,83,67,82,69,84,69,0,82,69,65,76,0,76,79,71,73,84,0,71,69,78,84,76,69,0,109,108,95,68,84,114,101,101,115,95,70,108,97,103,115,0,80,82,69,68,73,67,84,95,65,85,84,79,0,80,82,69,68,73,67,84,95,83,85,77,0,80,82,69,68,73,67,84,95,77,65,88,95,86,79,84,69,0,80,82,69,68,73,67,84,95,77,65,83,75,0,109,108,95,69,77,95,84,121,112,101,115,0,67,79,86,95,77,65,84,95,83,80,72,69,82,73,67,65,76,0,67,79,86,95,77,65,84,95,68,73,65,71,79,78,65,76,0,67,79,86,95,77,65,84,95,71,69,78,69,82,73,67,0,67,79,86,95,77,65,84,95,68,69,70,65,85,76,84,0,109,108,95,69,114,114,111,114,84,121,112,101,115,0,84,69,83,84,95,69,82,82,79,82,0,84,82,65,73,78,95,69,82,82,79,82,0,109,108,95,75,78,101,97,114,101,115,116,95,84,121,112,101,115,0,66,82,85,84,69,95,70,79,82,67,69,0,75,68,84,82,69,69,0,109,108,95,76,111,103,105,115,116,105,99,82,101,103,114,101,115,115,105,111,110,95,77,101,116,104,111,100,115,0,66,65,84,67,72,0,77,73,78,73,95,66,65,84,67,72,0,109,108,95,76,111,103,105,115,116,105,99,82,101,103,114,101,115,115,105,111,110,95,82,101,103,75,105,110,100,115,0,82,69,71,95,68,73,83,65,66,76,69,0,82,69,71,95,76,49,0,82,69,71,95,76,50,0,109,108,95,83,86,77,95,75,101,114,110,101,108,84,121,112,101,115,0,67,85,83,84,79,77,0,109,108,95,83,86,77,95,80,97,114,97,109,84,121,112,101,115,0,71,65,77,77,65,0,80,0,78,85,0,67,79,69,70,0,68,69,71,82,69,69,0,109,108,95,83,86,77,95,84,121,112,101,115,0,109,108,95,83,97,109,112,108,101,84,121,112,101,115,0,82,79,87,95,83,65,77,80,76,69,0,67,79,76,95,83,65,77,80,76,69,0,109,108,95,83,116,97,116,77,111,100,101,108,95,70,108,97,103,115,0,85,80,68,65,84,69,95,77,79,68,69,76,0,82,65,87,95,79,85,84,80,85,84,0,67,79,77,80,82,69,83,83,69,68,95,73,78,80,85,84,0,80,82,69,80,82,79,67,69,83,83,69,68,95,73,78,80,85,84,0,109,108,95,86,97,114,105,97,98,108,101,84,121,112,101,115,0,86,65,82,95,78,85,77,69,82,73,67,65,76,0,86,65,82,95,79,82,68,69,82,69,68,0,86,65,82,95,67,65,84,69,71,79,82,73,67,65,76,0,111,99,108,95,79,99,108,86,101,99,116,111,114,83,116,114,97,116,101,103,121,0,79,67,76,95,86,69,67,84,79,82,95,79,87,78,0,79,67,76,95,86,69,67,84,79,82,95,77,65,88,0,79,67,76,95,86,69,67,84,79,82,95,68,69,70,65,85,76,84,0,78,50,99,118,51,111,99,108,49,55,79,99,108,86,101,99,116,111,114,83,116,114,97,116,101,103,121,69,0,78,50,99,118,50,109,108,49,51,86,97,114,105,97,98,108,101,84,121,112,101,115,69,0,78,50,99,118,50,109,108,57,83,116,97,116,77,111,100,101,108,53,70,108,97,103,115,69,0,78,50,99,118,50,109,108,49,49,83,97,109,112,108,101,84,121,112,101,115,69,0,78,50,99,118,50,109,108,51,83,86,77,53,84,121,112,101,115,69,0,78,50,99,118,50,109,108,51,83,86,77,49,48,80,97,114,97,109,84,121,112,101,115,69,0,78,50,99,118,50,109,108,51,83,86,77,49,49,75,101,114,110,101,108,84,121,112,101,115,69,0,78,50,99,118,50,109,108,49,56,76,111,103,105,115,116,105,99,82,101,103,114,101,115,115,105,111,110,56,82,101,103,75,105,110,100,115,69,0,78,50,99,118,50,109,108,49,56,76,111,103,105,115,116,105,99,82,101,103,114,101,115,115,105,111,110,55,77,101,116,104,111,100,115,69,0,78,50,99,118,50,109,108,56,75,78,101,97,114,101,115,116,53,84,121,112,101,115,69,0,78,50,99,118,50,109,108,49,48,69,114,114,111,114,84,121,112,101,115,69,0,78,50,99,118,50,109,108,50,69,77,53,84,121,112,101,115,69,0,78,50,99,118,50,109,108,54,68,84,114,101,101,115,53,70,108,97,103,115,69,0,78,50,99,118,50,109,108,53,66,111,111,115,116,53,84,121,112,101,115,69,0,78,50,99,118,50,109,108,55,65,78,78,95,77,76,80,49,53,84,114,97,105,110,105,110,103,77,101,116,104,111,100,115,69,0,78,50,99,118,50,109,108,55,65,78,78,95,77,76,80,49,48,84,114,97,105,110,70,108,97,103,115,69,0,78,50,99,118,50,109,108,55,65,78,78,95,77,76,80,49,57,65,99,116,105,118,97,116,105,111,110,70,117,110,99,116,105,111,110,115,69,0,78,50,99,118,49,52,85,110,100,105,115,116,111,114,116,84,121,112,101,115,69,0,78,50,99,118,49,52,85,77,97,116,85,115,97,103,101,70,108,97,103,115,69,0,78,50,99,118,49,52,84,104,114,101,115,104,111,108,100,84,121,112,101,115,69,0,78,50,99,118,49,50,84,101,114,109,67,114,105,116,101,114,105,97,52,84,121,112,101,69,0,78,50,99,118,49,56,84,101,109,112,108,97,116,101,77,97,116,99,104,77,111,100,101,115,69,0,78,50,99,118,57,83,111,114,116,70,108,97,103,115,69,0,78,50,99,118,51,83,86,68,53,70,108,97,103,115,69,0,78,50,99,118,49,52,82,101,116,114,105,101,118,97,108,77,111,100,101,115,69,0,78,50,99,118,49,49,82,101,100,117,99,101,84,121,112,101,115,69,0,78,50,99,118,50,52,82,101,99,116,97,110,103,108,101,115,73,110,116,101,114,115,101,99,116,84,121,112,101,115,69,0,78,50,99,118,51,80,67,65,53,70,108,97,103,115,69,0,78,50,99,118,49,48,77,111,114,112,104,84,121,112,101,115,69,0,78,50,99,118,49,49,77,111,114,112,104,83,104,97,112,101,115,69,0,78,50,99,118,49,49,77,97,114,107,101,114,84,121,112,101,115,69,0,78,50,99,118,57,76,105,110,101,84,121,112,101,115,69,0,78,50,99,118,50,52,76,105,110,101,83,101,103,109,101,110,116,68,101,116,101,99,116,111,114,77,111,100,101,115,69,0,78,50,99,118,49,49,75,109,101,97,110,115,70,108,97,103,115,69,0,78,50,99,118,49,56,73,110,116,101,114,112,111,108,97,116,105,111,110,77,97,115,107,115,69,0,78,50,99,118,49,56,73,110,116,101,114,112,111,108,97,116,105,111,110,70,108,97,103,115,69,0,78,50,99,118,49,53,73,109,119,114,105,116,101,80,78,71,70,108,97,103,115,69,0,78,50,99,118,49,50,73,109,119,114,105,116,101,70,108,97,103,115,69,0,78,50,99,118,49,49,73,109,114,101,97,100,77,111,100,101,115,69,0,78,50,99,118,49,48,72,111,117,103,104,77,111,100,101,115,69,0,78,50,99,118,49,53,72,105,115,116,67,111,109,112,77,101,116,104,111,100,115,69,0,78,50,99,118,49,50,72,101,114,115,104,101,121,70,111,110,116,115,69,0,78,50,99,118,49,50,71,114,97,98,67,117,116,77,111,100,101,115,69,0,78,50,99,118,49,52,71,114,97,98,67,117,116,67,108,97,115,115,101,115,69,0,78,50,99,118,49,52,70,108,111,111,100,70,105,108,108,70,108,97,103,115,69,0,78,50,99,118,49,51,68,105,115,116,97,110,99,101,84,121,112,101,115,69,0,78,50,99,118,50,50,68,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,77,97,115,107,115,69,0,78,50,99,118,50,55,68,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,76,97,98,101,108,84,121,112,101,115,69,0,78,50,99,118,49,48,67,111,118,97,114,70,108,97,103,115,69,0,78,50,99,118,50,53,67,111,110,116,111,117,114,65,112,112,114,111,120,105,109,97,116,105,111,110,77,111,100,101,115,69,0,78,50,99,118,50,52,67,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,84,121,112,101,115,69,0,78,50,99,118,49,51,67,111,108,111,114,109,97,112,84,121,112,101,115,69,0,78,50,99,118,50,48,67,111,108,111,114,67,111,110,118,101,114,115,105,111,110,67,111,100,101,115,69,0,78,50,99,118,50,50,65,100,97,112,116,105,118,101,84,104,114,101,115,104,111,108,100,84,121,112,101,115,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,109,108,50,69,77,69,69,69,0,78,50,99,118,51,77,97,116,69,0,78,50,99,118,50,109,108,50,69,77,69,0,78,50,99,118,49,50,84,101,114,109,67,114,105,116,101,114,105,97,69,0,80,75,78,50,99,118,50,109,108,50,69,77,69,0,78,50,99,118,51,86,101,99,73,100,76,105,50,69,69,69,0,78,50,99,118,52,77,97,116,120,73,100,76,105,50,69,76,105,49,69,69,69,0,105,105,105,105,105,105,105,105,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,118,101,99,116,111,114,95,98,97,115,101,95,99,111,109,109,111,110,73,76,98,49,69,69,69,0,105,105,105,105,105,105,105,105,105,105,0,80,78,50,99,118,50,109,108,50,69,77,69,0,78,50,99,118,51,80,116,114,73,78,83,95,51,79,82,66,69,69,69,0,78,50,99,118,51,79,82,66,69,0,80,75,78,50,99,118,51,79,82,66,69,0,105,105,105,102,105,105,105,105,105,105,105,0,80,78,50,99,118,51,79,82,66,69,0,80,75,78,50,99,118,49,48,66,79,87,84,114,97,105,110,101,114,69,0,80,78,50,99,118,49,48,66,79,87,84,114,97,105,110,101,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,54,72,97,117,115,100,111,114,102,102,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,69,69,69,0,80,75,78,50,99,118,50,54,72,97,117,115,100,111,114,102,102,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,50,54,72,97,117,115,100,111,114,102,102,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,50,50,83,104,97,112,101,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,69,0,80,78,50,99,118,50,54,72,97,117,115,100,111,114,102,102,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,50,84,111,110,101,109,97,112,68,114,97,103,111,69,69,69,0,80,75,78,50,99,118,49,50,84,111,110,101,109,97,112,68,114,97,103,111,69,0,78,50,99,118,49,50,84,111,110,101,109,97,112,68,114,97,103,111,69,0,78,50,99,118,55,84,111,110,101,109,97,112,69,0,80,78,50,99,118,49,50,84,111,110,101,109,97,112,68,114,97,103,111,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,53,84,111,110,101,109,97,112,82,101,105,110,104,97,114,100,69,69,69,0,105,105,102,102,102,102,0,80,75,78,50,99,118,49,53,84,111,110,101,109,97,112,82,101,105,110,104,97,114,100,69,0,78,50,99,118,49,53,84,111,110,101,109,97,112,82,101,105,110,104,97,114,100,69,0,80,78,50,99,118,49,53,84,111,110,101,109,97,112,82,101,105,110,104,97,114,100,69,0,118,105,105,105,105,100,105,105,105,105,0,78,50,99,118,53,83,105,122,101,95,73,105,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,80,75,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,118,105,105,105,105,105,105,100,105,105,105,105,105,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,78,50,99,118,54,83,116,114,105,110,103,69,0,80,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,118,105,105,105,105,105,100,105,105,105,105,0,78,50,99,118,56,70,105,108,101,78,111,100,101,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,83,116,51,95,95,50,50,49,95,95,98,97,115,105,99,95,115,116,114,105,110,103,95,99,111,109,109,111,110,73,76,98,49,69,69,69,0,80,75,78,50,99,118,50,55,69,77,68,76,49,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,50,55,69,77,68,76,49,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,50,50,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,80,78,50,99,118,50,55,69,77,68,76,49,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,109,108,51,83,86,77,69,69,69,0,80,75,78,50,99,118,50,109,108,51,83,86,77,69,0,78,50,99,118,50,109,108,51,83,86,77,69,0,100,105,105,105,105,105,0,80,78,50,99,118,50,109,108,51,83,86,77,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,56,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,69,69,69,0,78,50,99,118,49,56,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,54,80,97,114,97,109,115,69,0,80,75,78,50,99,118,49,56,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,69,0,78,50,99,118,49,56,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,69,0,80,78,50,99,118,49,56,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,55,77,111,109,101,110,116,115,69,0,78,50,99,118,55,77,111,109,101,110,116,115,69,0,80,78,50,99,118,55,77,111,109,101,110,116,115,69,0,80,78,50,99,118,49,56,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,54,80,97,114,97,109,115,69,0,80,75,78,50,99,118,49,56,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,54,80,97,114,97,109,115,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,67,76,65,72,69,69,69,69,0,78,50,99,118,53,67,76,65,72,69,69,0,80,75,78,50,99,118,53,67,76,65,72,69,69,0,80,78,50,99,118,53,67,76,65,72,69,69,0,105,105,100,105,0,78,50,99,118,51,80,116,114,73,78,83,95,49,57,68,117,97,108,84,86,76,49,79,112,116,105,99,97,108,70,108,111,119,69,69,69,0,80,75,78,50,99,118,49,57,68,117,97,108,84,86,76,49,79,112,116,105,99,97,108,70,108,111,119,69,0,78,50,99,118,49,57,68,117,97,108,84,86,76,49,79,112,116,105,99,97,108,70,108,111,119,69,0,78,50,99,118,49,54,68,101,110,115,101,79,112,116,105,99,97,108,70,108,111,119,69,0,80,78,50,99,118,49,57,68,117,97,108,84,86,76,49,79,112,116,105,99,97,108,70,108,111,119,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,51,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,75,78,78,69,69,69,0,78,50,99,118,50,51,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,75,78,78,69,0,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,80,75,78,50,99,118,50,51,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,75,78,78,69,0,80,78,50,99,118,50,51,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,75,78,78,69,0,78,50,99,118,51,80,116,114,73,78,83,95,52,77,83,69,82,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,78,83,53,95,73,83,55,95,69,69,69,69,0,78,50,99,118,52,77,83,69,82,69,0,105,105,105,105,105,100,100,105,100,100,105,0,80,75,78,50,99,118,52,77,83,69,82,69,0,80,78,50,99,118,52,77,83,69,82,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,109,108,57,84,114,97,105,110,68,97,116,97,69,69,69,0,80,78,50,99,118,50,109,108,57,84,114,97,105,110,68,97,116,97,69,0,105,105,105,105,105,105,105,105,105,0,80,75,78,50,99,118,50,109,108,57,84,114,97,105,110,68,97,116,97,69,0,118,105,105,100,105,0,80,75,78,50,99,118,50,49,66,97,115,101,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,80,78,50,99,118,50,49,66,97,115,101,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,80,78,50,99,118,57,66,70,77,97,116,99,104,101,114,69,0,80,75,78,50,99,118,57,66,70,77,97,116,99,104,101,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,51,84,111,110,101,109,97,112,68,117,114,97,110,100,69,69,69,0,105,105,102,102,102,102,102,0,80,75,78,50,99,118,49,51,84,111,110,101,109,97,112,68,117,114,97,110,100,69,0,78,50,99,118,49,51,84,111,110,101,109,97,112,68,117,114,97,110,100,69,0,80,78,50,99,118,49,51,84,111,110,101,109,97,112,68,117,114,97,110,100,69,0,105,105,105,105,105,102,0,80,78,50,99,118,54,68,77,97,116,99,104,69,0,78,50,99,118,54,68,77,97,116,99,104,69,0,80,75,78,50,99,118,54,68,77,97,116,99,104,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,69,69,0,80,75,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,78,83,51,95,73,83,53,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,118,105,105,105,105,105,105,105,105,0,80,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,69,69,0,80,75,78,50,99,118,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,0,78,50,99,118,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,0,105,105,105,100,100,105,105,100,0,80,78,50,99,118,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,50,50,83,104,97,112,101,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,69,0,80,78,50,99,118,50,50,83,104,97,112,101,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,109,108,54,82,84,114,101,101,115,69,69,69,0,78,50,99,118,50,109,108,54,82,84,114,101,101,115,69,0,78,50,99,118,50,109,108,54,68,84,114,101,101,115,69,0,80,75,78,50,99,118,50,109,108,54,82,84,114,101,101,115,69,0,80,78,50,99,118,50,109,108,54,82,84,114,101,101,115,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,109,108,55,65,78,78,95,77,76,80,69,69,69,0,78,50,99,118,50,109,108,55,65,78,78,95,77,76,80,69,0,80,75,78,50,99,118,50,109,108,55,65,78,78,95,77,76,80,69,0,118,105,105,105,100,100,0,80,78,50,99,118,50,109,108,55,65,78,78,95,77,76,80,69,0,78,50,99,118,49,54,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,69,0,78,50,99,118,55,83,99,97,108,97,114,95,73,100,69,69,0,78,50,99,118,51,86,101,99,73,100,76,105,52,69,69,69,0,78,50,99,118,52,77,97,116,120,73,100,76,105,52,69,76,105,49,69,69,69,0,80,75,78,50,99,118,49,54,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,69,0,80,78,50,99,118,49,54,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,69,0,80,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,80,75,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,78,50,99,118,49,52,65,108,105,103,110,69,120,112,111,115,117,114,101,115,69,0,80,75,78,50,99,118,49,52,65,108,105,103,110,69,120,112,111,115,117,114,101,115,69,0,80,78,50,99,118,49,52,65,108,105,103,110,69,120,112,111,115,117,114,101,115,69,0,80,75,78,50,99,118,50,53,66,79,87,73,109,103,68,101,115,99,114,105,112,116,111,114,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,57,70,101,97,116,117,114,101,50,68,69,69,69,0,80,78,50,99,118,50,53,66,79,87,73,109,103,68,101,115,99,114,105,112,116,111,114,69,120,116,114,97,99,116,111,114,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,54,67,97,108,105,98,114,97,116,101,68,101,98,101,118,101,99,69,69,69,0,80,75,78,50,99,118,49,54,67,97,108,105,98,114,97,116,101,68,101,98,101,118,101,99,69,0,78,50,99,118,49,54,67,97,108,105,98,114,97,116,101,68,101,98,101,118,101,99,69,0,78,50,99,118,49,50,67,97,108,105,98,114,97,116,101,67,82,70,69,0,105,105,105,102,105,0,80,78,50,99,118,49,54,67,97,108,105,98,114,97,116,101,68,101,98,101,118,101,99,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,52,77,101,114,103,101,82,111,98,101,114,116,115,111,110,69,69,69,0,78,50,99,118,49,52,77,101,114,103,101,82,111,98,101,114,116,115,111,110,69,0,78,50,99,118,49,52,77,101,114,103,101,69,120,112,111,115,117,114,101,115,69,0,80,75,78,50,99,118,49,52,77,101,114,103,101,82,111,98,101,114,116,115,111,110,69,0,80,78,50,99,118,49,52,77,101,114,103,101,82,111,98,101,114,116,115,111,110,69,0,80,75,78,50,99,118,49,52,77,101,114,103,101,69,120,112,111,115,117,114,101,115,69,0,80,78,50,99,118,49,52,77,101,114,103,101,69,120,112,111,115,117,114,101,115,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,109,108,50,49,78,111,114,109,97,108,66,97,121,101,115,67,108,97,115,115,105,102,105,101,114,69,69,69,0,102,105,105,105,105,105,105,0,78,50,99,118,50,109,108,50,49,78,111,114,109,97,108,66,97,121,101,115,67,108,97,115,115,105,102,105,101,114,69,0,80,75,78,50,99,118,50,109,108,50,49,78,111,114,109,97,108,66,97,121,101,115,67,108,97,115,115,105,102,105,101,114,69,0,80,78,50,99,118,50,109,108,50,49,78,111,114,109,97,108,66,97,121,101,115,67,108,97,115,115,105,102,105,101,114,69,0,78,50,99,118,53,102,108,97,110,110,49,50,83,101,97,114,99,104,80,97,114,97,109,115,69,0,78,50,99,118,53,102,108,97,110,110,49,49,73,110,100,101,120,80,97,114,97,109,115,69,0,80,78,50,99,118,53,102,108,97,110,110,53,73,110,100,101,120,69,0,80,75,78,50,99,118,53,102,108,97,110,110,53,73,110,100,101,120,69,0,78,55,99,118,102,108,97,110,110,49,54,102,108,97,110,110,95,100,105,115,116,97,110,99,101,95,116,69,0,78,55,99,118,102,108,97,110,110,49,55,102,108,97,110,110,95,97,108,103,111,114,105,116,104,109,95,116,69,0,105,105,105,105,105,105,100,105,105,0,78,50,99,118,49,49,95,73,110,112,117,116,65,114,114,97,121,69,0,80,75,78,50,99,118,57,70,101,97,116,117,114,101,50,68,69,0,80,78,50,99,118,57,70,101,97,116,117,114,101,50,68,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,65,75,65,90,69,69,69,69,0,78,50,99,118,53,65,75,65,90,69,69],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+188660);allocate([0,105,105,105,105,105,102,105,105,105,0,80,75,78,50,99,118,53,65,75,65,90,69,69,0,80,78,50,99,118,53,65,75,65,90,69,69,0,80,75,78,50,99,118,49,50,67,97,108,105,98,114,97,116,101,67,82,70,69,0,80,78,50,99,118,49,50,67,97,108,105,98,114,97,116,101,67,82,70,69,0,78,50,99,118,51,80,116,114,73,78,83,95,52,75,65,90,69,69,69,69,0,78,50,99,118,52,75,65,90,69,69,0,80,75,78,50,99,118,52,75,65,90,69,69,0,105,105,105,105,102,105,105,105,0,80,78,50,99,118,52,75,65,90,69,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,57,83,104,97,112,101,67,111,110,116,101,120,116,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,69,69,69,0,78,50,99,118,50,57,83,104,97,112,101,67,111,110,116,101,120,116,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,69,0,105,105,105,105,102,102,105,105,105,0,78,50,99,118,51,80,116,114,73,78,83,95,49,54,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,69,69,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,50,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,69,69,0,80,75,78,50,99,118,50,57,83,104,97,112,101,67,111,110,116,101,120,116,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,69,0,80,78,50,99,118,50,57,83,104,97,112,101,67,111,110,116,101,120,116,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,51,49,84,104,105,110,80,108,97,116,101,83,112,108,105,110,101,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,69,69,69,0,80,75,78,50,99,118,51,49,84,104,105,110,80,108,97,116,101,83,112,108,105,110,101,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,69,0,78,50,99,118,51,49,84,104,105,110,80,108,97,116,101,83,112,108,105,110,101,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,69,0,105,105,100,0,80,78,50,99,118,51,49,84,104,105,110,80,108,97,116,101,83,112,108,105,110,101,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,69,0,80,75,78,50,99,118,50,53,69,77,68,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,50,53,69,77,68,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,80,78,50,99,118,50,53,69,77,68,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,80,78,50,99,118,49,50,75,97,108,109,97,110,70,105,108,116,101,114,69,0,78,50,99,118,49,50,75,97,108,109,97,110,70,105,108,116,101,114,69,0,80,75,78,50,99,118,49,50,75,97,108,109,97,110,70,105,108,116,101,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,66,82,73,83,75,69,69,69,0,105,105,105,105,102,102,105,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,80,75,78,50,99,118,53,66,82,73,83,75,69,0,78,50,99,118,53,66,82,73,83,75,69,0,80,78,50,99,118,53,66,82,73,83,75,69,0,80,78,50,99,118,54,80,111,105,110,116,95,73,102,69,69,0,78,50,99,118,54,80,111,105,110,116,95,73,102,69,69,0,78,50,99,118,56,83,117,98,100,105,118,50,68,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,102,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,54,80,111,105,110,116,95,73,102,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,54,80,111,105,110,116,95,73,102,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,102,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,78,83,53,95,73,83,55,95,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,86,101,99,73,102,76,105,52,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,51,86,101,99,73,102,76,105,52,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,86,101,99,73,102,76,105,54,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,51,86,101,99,73,102,76,105,54,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,53,82,101,99,116,95,73,105,69,69,0,80,78,50,99,118,56,83,117,98,100,105,118,50,68,69,0,80,75,78,50,99,118,56,83,117,98,100,105,118,50,68,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,69,69,0,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,80,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,109,108,56,75,78,101,97,114,101,115,116,69,69,69,0,102,105,105,105,105,105,105,105,0,78,50,99,118,50,109,108,56,75,78,101,97,114,101,115,116,69,0,80,75,78,50,99,118,50,109,108,56,75,78,101,97,114,101,115,116,69,0,80,78,50,99,118,50,109,108,56,75,78,101,97,114,101,115,116,69,0,78,50,99,118,51,80,116,114,73,78,83,95,55,84,111,110,101,109,97,112,69,69,69,0,80,75,78,50,99,118,55,84,111,110,101,109,97,112,69,0,105,105,102,0,80,78,50,99,118,55,84,111,110,101,109,97,112,69,0,80,75,78,50,99,118,50,109,108,57,83,116,97,116,77,111,100,101,108,69,0,80,78,50,99,118,50,109,108,57,83,116,97,116,77,111,100,101,108,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,52,84,111,110,101,109,97,112,77,97,110,116,105,117,107,69,69,69,0,78,50,99,118,49,52,84,111,110,101,109,97,112,77,97,110,116,105,117,107,69,0,80,75,78,50,99,118,49,52,84,111,110,101,109,97,112,77,97,110,116,105,117,107,69,0,80,78,50,99,118,49,52,84,111,110,101,109,97,112,77,97,110,116,105,117,107,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,102,108,97,110,110,49,50,83,101,97,114,99,104,80,97,114,97,109,115,69,69,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,102,108,97,110,110,49,49,73,110,100,101,120,80,97,114,97,109,115,69,69,69,0,80,78,50,99,118,49,55,70,108,97,110,110,66,97,115,101,100,77,97,116,99,104,101,114,69,0,80,75,78,50,99,118,49,55,70,108,97,110,110,66,97,115,101,100,77,97,116,99,104,101,114,69,0,105,105,105,105,105,105,0,80,78,50,99,118,49,54,66,79,87,75,77,101,97,110,115,84,114,97,105,110,101,114,69,0,105,105,105,105,0,80,75,78,50,99,118,49,54,66,79,87,75,77,101,97,110,115,84,114,97,105,110,101,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,109,108,54,68,84,114,101,101,115,69,69,69,0,80,75,78,50,99,118,50,109,108,54,68,84,114,101,101,115,69,0,80,78,50,99,118,50,109,108,54,68,84,114,101,101,115,69,0,80,75,78,50,99,118,50,50,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,80,78,50,99,118,50,50,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,50,77,101,114,103,101,68,101,98,101,118,101,99,69,69,69,0,78,50,99,118,49,50,77,101,114,103,101,68,101,98,101,118,101,99,69,0,80,75,78,50,99,118,49,50,77,101,114,103,101,68,101,98,101,118,101,99,69,0,80,78,50,99,118,49,50,77,101,114,103,101,68,101,98,101,118,101,99,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,55,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,101,114,69,69,69,0,78,50,99,118,49,55,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,101,114,69,0,80,75,78,50,99,118,49,55,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,101,114,69,0,80,78,50,99,118,49,55,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,101,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,56,65,108,105,103,110,77,84,66,69,69,69,0,78,50,99,118,56,65,108,105,103,110,77,84,66,69,0,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,0,80,75,78,50,99,118,56,65,108,105,103,110,77,84,66,69,0,80,78,50,99,118,56,65,108,105,103,110,77,84,66,69,0,102,105,105,105,105,0,78,50,99,118,56,75,101,121,80,111,105,110,116,69,0,105,105,102,102,102,102,102,105,105,0,80,78,50,99,118,56,75,101,121,80,111,105,110,116,69,0,118,105,105,105,105,102,102,105,105,0,80,75,78,50,99,118,56,75,101,121,80,111,105,110,116,69,0,80,75,78,50,99,118,50,53,67,104,105,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,50,53,67,104,105,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,80,78,50,99,118,50,53,67,104,105,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,118,105,105,105,105,100,0,80,75,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,80,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,57,76,105,110,101,83,101,103,109,101,110,116,68,101,116,101,99,116,111,114,69,69,69,0,105,105,105,100,100,100,100,100,100,105,0,78,50,99,118,49,57,76,105,110,101,83,101,103,109,101,110,116,68,101,116,101,99,116,111,114,69,0,105,105,105,105,105,105,105,0,80,75,78,50,99,118,49,57,76,105,110,101,83,101,103,109,101,110,116,68,101,116,101,99,116,111,114,69,0,80,78,50,99,118,49,57,76,105,110,101,83,101,103,109,101,110,116,68,101,116,101,99,116,111,114,69,0,118,105,105,0,80,78,50,99,118,49,54,68,101,110,115,101,79,112,116,105,99,97,108,70,108,111,119,69,0,118,105,105,105,105,105,0,80,75,78,50,99,118,49,54,68,101,110,115,101,79,112,116,105,99,97,108,70,108,111,119,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,109,108,53,66,111,111,115,116,69,69,69,0,78,50,99,118,50,109,108,53,66,111,111,115,116,69,0,80,75,78,50,99,118,50,109,108,53,66,111,111,115,116,69,0,80,78,50,99,118,50,109,108,53,66,111,111,115,116,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,69,69,0,78,50,99,118,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,80,78,50,99,118,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,50,54,78,111,114,109,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,50,54,78,111,114,109,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,105,105,105,105,102,0,80,78,50,99,118,50,54,78,111,114,109,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,109,108,49,56,76,111,103,105,115,116,105,99,82,101,103,114,101,115,115,105,111,110,69,69,69,0,80,75,78,50,99,118,50,109,108,49,56,76,111,103,105,115,116,105,99,82,101,103,114,101,115,115,105,111,110,69,0,78,50,99,118,50,109,108,49,56,76,111,103,105,115,116,105,99,82,101,103,114,101,115,115,105,111,110,69,0,102,105,105,105,105,105,0,80,78,50,99,118,50,109,108,49,56,76,111,103,105,115,116,105,99,82,101,103,114,101,115,115,105,111,110,69,0,118,105,105,105,105,105,100,105,105,100,100,105,0,80,75,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,118,105,105,105,105,105,105,105,0,80,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,105,105,105,105,105,105,105,105,100,105,100,105,105,105,0,118,105,105,105,105,105,100,105,105,105,0,105,105,105,105,105,0,118,0,78,50,99,118,51,80,116,114,73,78,83,95,49,56,67,97,108,105,98,114,97,116,101,82,111,98,101,114,116,115,111,110,69,69,69,0,80,75,78,50,99,118,49,56,67,97,108,105,98,114,97,116,101,82,111,98,101,114,116,115,111,110,69,0,78,50,99,118,49,56,67,97,108,105,98,114,97,116,101,82,111,98,101,114,116,115,111,110,69,0,105,105,105,102,0,80,78,50,99,118,49,56,67,97,108,105,98,114,97,116,101,82,111,98,101,114,116,115,111,110,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,69,69,0,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,118,105,105,105,0,80,75,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,118,105,105,100,0,105,105,105,100,105,0,100,105,105,0,105,105,105,0,80,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,50,77,101,114,103,101,77,101,114,116,101,110,115,69,69,69,0,105,105,102,102,102,0,118,105,105,105,105,0,78,50,99,118,49,50,77,101,114,103,101,77,101,114,116,101,110,115,69,0,118,105,105,105,105,105,105,0,102,105,105,0,80,75,78,50,99,118,49,50,77,101,114,103,101,77,101,114,116,101,110,115,69,0,118,105,105,102,0,118,105,0,105,105,0,80,78,50,99,118,49,50,77,101,114,103,101,77,101,114,116,101,110,115,69,0,100,105,105,105,100,100,105,0,118,105,105,105,105,102,102,105,0,118,105,105,105,105,105,105,105,100,105,0,118,105,105,100,105,105,0,78,50,99,118,49,49,82,111,116,97,116,101,100,82,101,99,116,69,0,118,105,105,105,100,100,105,105,0,100,105,105,105,105,0,118,105,105,105,105,102,102,102,0,118,105,105,105,100,100,105,105,105,0,118,105,105,105,105,105,100,105,0,118,105,105,105,105,105,105,105,105,105,0,78,50,99,118,49,55,95,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,69,0,78,50,99,118,49,50,95,79,117,116,112,117,116,65,114,114,97,121,69,0,100,105,105,105,0,100,105,105,105,105,100,0,118,105,105,105,105,100,105,0,100,105,105,105,105,105,105,105,105,0,102,105,105,105,105,105,105,105,105,105,100,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,104,78,83,95,57,97,108,108,111,99,97,116,111,114,73,104,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,104,78,83,95,57,97,108,108,111,99,97,116,111,114,73,104,69,69,69,69,0,118,105,105,105,105,102,102,0,118,105,105,105,105,100,100,105,105,105,100,0,105,105,105,105,100,105,105,0,105,105,105,100,100,0,105,105,105,100,100,100,100,100,105,0,118,105,105,105,100,105,100,105,105,0,118,105,105,105,105,100,100,100,0,100,105,105,105,105,105,105,105,0,118,105,105,105,105,105,105,100,105,0,118,105,105,105,105,105,102,105,105,0,118,105,105,105,105,105,102,102,105,105,0,118,105,105,105,102,102,105,105,0,118,105,105,105,102,105,105,0,118,105,105,105,105,100,100,100,105,105,105,105,0,118,105,105,105,105,105,105,105,105,105,105,105,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,99,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,49,95,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,99,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,50,95,73,83,52,95,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,99,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,99,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,118,105,105,105,105,105,105,105,105,105,105,0,118,105,100,105,105,105,0,118,105,105,105,102,102,0,118,105,105,105,100,105,0,118,105,105,105,105,105,105,105,105,105,105,105,100,0,118,105,105,105,105,100,105,105,105,105,100,105,0,118,105,105,105,105,105,105,100,0,118,105,105,105,105,100,100,105,0,118,105,105,105,105,105,105,105,105,100,0,118,105,105,100,105,100,100,105,105,0,118,105,105,105,100,105,105,105,100,0,118,105,105,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,100,100,105,0,118,105,105,105,100,100,105,100,100,0,118,105,105,105,100,100,105,100,100,100,100,0,118,105,105,105,105,100,100,100,100,105,105,0,73,110,116,86,101,99,116,111,114,0,67,104,97,114,86,101,99,116,111,114,0,85,110,115,105,103,110,101,100,86,101,99,116,111,114,0,85,67,104,97,114,86,101,99,116,111,114,0,83,116,114,86,101,99,116,111,114,0,69,109,118,97,108,86,101,99,116,111,114,0,70,108,111,97,116,86,101,99,116,111,114,0,73,110,116,86,101,99,116,111,114,86,101,99,116,111,114,0,80,111,105,110,116,86,101,99,116,111,114,86,101,99,116,111,114,0,80,111,105,110,116,86,101,99,116,111,114,0,86,101,99,52,105,86,101,99,116,111,114,0,77,97,116,86,101,99,116,111,114,0,75,101,121,80,111,105,110,116,86,101,99,116,111,114,0,82,101,99,116,86,101,99,116,111,114,0,80,111,105,110,116,50,102,86,101,99,116,111,114,0,84,101,114,109,67,114,105,116,101,114,105,97,0,109,97,120,67,111,117,110,116,0,101,108,101,109,83,105,122,101,49,0,99,104,97,110,110,101,108,115,0,116,111,116,97,108,0,114,111,119,0,101,121,101,0,114,111,119,82,97,110,103,101,0,101,108,101,109,83,105,122,101,0,99,111,108,82,97,110,103,101,0,115,116,101,112,49,0,111,110,101,115,0,122,101,114,111,115,0,99,111,108,0,109,117,108,0,105,110,118,0,116,0,100,97,116,97,56,83,0,100,97,116,97,49,54,117,0,100,97,116,97,49,54,115,0,100,97,116,97,51,50,115,0,100,97,116,97,51,50,102,0,100,97,116,97,54,52,102,0,112,116,114,0,103,101,116,95,117,99,104,97,114,95,97,116,0,103,101,116,95,117,115,104,111,114,116,95,97,116,0,103,101,116,95,105,110,116,95,97,116,0,103,101,116,95,100,111,117,98,108,101,95,97,116,0,103,101,116,95,102,108,111,97,116,95,97,116,0,103,101,116,82,79,73,95,82,101,99,116,0,86,101,99,52,105,0,82,78,71,0,83,105,122,101,0,80,111,105,110,116,0,80,111,105,110,116,50,102,0,82,101,99,116,0,83,99,97,108,97,114,0,97,108,108,0,105,115,82,101,97,108,0,109,97,116,70,114,111,109,65,114,114,97,121,0,67,86,95,56,85,67,49,0,67,86,95,56,85,67,50,0,67,86,95,56,85,67,51,0,67,86,95,56,85,67,52,0,67,86,95,56,83,67,49,0,67,86,95,56,83,67,50,0,67,86,95,56,83,67,51,0,67,86,95,56,83,67,52,0,67,86,95,49,54,85,67,49,0,67,86,95,49,54,85,67,50,0,67,86,95,49,54,85,67,51,0,67,86,95,49,54,85,67,52,0,67,86,95,49,54,83,67,49,0,67,86,95,49,54,83,67,50,0,67,86,95,49,54,83,67,51,0,67,86,95,49,54,83,67,52,0,67,86,95,51,50,83,67,49,0,67,86,95,51,50,83,67,50,0,67,86,95,51,50,83,67,51,0,67,86,95,51,50,83,67,52,0,67,86,95,51,50,70,67,49,0,67,86,95,51,50,70,67,50,0,67,86,95,51,50,70,67,51,0,67,86,95,51,50,70,67,52,0,67,86,95,54,52,70,67,49,0,67,86,95,54,52,70,67,50,0,67,86,95,54,52,70,67,51,0,67,86,95,54,52,70,67,52,0,67,86,95,56,85,0,67,86,95,56,83,0,67,86,95,49,54,85,0,67,86,95,49,54,83,0,67,86,95,51,50,83,0,67,86,95,51,50,70,0,66,79,82,68,69,82,95,67,79,78,83,84,65,78,84,0,66,79,82,68,69,82,95,82,69,80,76,73,67,65,84,69,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,0,66,79,82,68,69,82,95,87,82,65,80,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,95,49,48,49,0,66,79,82,68,69,82,95,84,82,65,78,83,80,65,82,69,78,84,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,49,48,49,0,66,79,82,68,69,82,95,68,69,70,65,85,76,84,0,66,79,82,68,69,82,95,73,83,79,76,65,84,69,68,0,78,79,82,77,95,73,78,70,0,78,79,82,77,95,76,49,0,78,79,82,77,95,76,50,0,78,79,82,77,95,76,50,83,81,82,0,78,79,82,77,95,72,65,77,77,73,78,71,0,78,79,82,77,95,72,65,77,77,73,78,71,50,0,78,79,82,77,95,84,89,80,69,95,77,65,83,75,0,78,79,82,77,95,82,69,76,65,84,73,86,69,0,78,79,82,77,95,77,73,78,77,65,88,0,73,78,80,65,73,78,84,95,78,83,0,73,78,80,65,73,78,84,95,84,69,76,69,65,0,78,49,48,101,109,115,99,114,105,112,116,101,110,51,118,97,108,69,0,98,117,102,102,101,114,0,46,46,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,109,97,116,46,105,110,108,46,104,112,112,0,80,75,78,50,99,118,55,83,99,97,108,97,114,95,73,100,69,69,0,105,105,100,100,100,100,0,80,78,50,99,118,55,83,99,97,108,97,114,95,73,100,69,69,0,105,105,100,100,100,0,105,105,100,100,0,80,78,50,99,118,53,82,101,99,116,95,73,105,69,69,0,80,75,78,50,99,118,53,82,101,99,116,95,73,105,69,69,0,80,75,78,50,99,118,51,82,78,71,69,0,78,50,99,118,51,82,78,71,69,0,80,78,50,99,118,51,82,78,71,69,0,80,78,50,99,118,51,86,101,99,73,105,76,105,52,69,69,69,0,78,50,99,118,51,86,101,99,73,105,76,105,52,69,69,69,0,78,50,99,118,52,77,97,116,120,73,105,76,105,52,69,76,105,49,69,69,69,0,80,75,78,50,99,118,51,86,101,99,73,105,76,105,52,69,69,69,0,80,75,78,50,99,118,51,77,97,116,69,0,80,78,50,99,118,51,77,97,116,69,0,102,105,105,105,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,104,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,100,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,102,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,105,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,115,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,116,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,99,69,69,0,78,50,99,118,53,82,97,110,103,101,69,0,118,105,105,105,105,100,100,0,105,105,105,105,100,0,80,78,50,99,118,49,50,84,101,114,109,67,114,105,116,101,114,105,97,69,0,80,75,78,50,99,118,49,50,84,101,114,109,67,114,105,116,101,114,105,97,69,0,103,101,116,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,102,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,102,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,86,101,99,73,105,76,105,52,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,51,86,101,99,73,105,76,105,52,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,86,101,99,73,105,76,105,52,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,86,101,99,73,105,76,105,52,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,78,83,49,95,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,78,83,50,95,73,83,52,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,78,83,49,95,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,78,83,49,95,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,118,105,105,105,102,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,49,48,101,109,115,99,114,105,112,116,101,110,51,118,97,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,49,48,101,109,115,99,114,105,112,116,101,110,51,118,97,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,49,48,101,109,115,99,114,105,112,116,101,110,51,118,97,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,49,48,101,109,115,99,114,105,112,116,101,110,51,118,97,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,104,78,83,95,57,97,108,108,111,99,97,116,111,114,73,104,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,104,78,83,95,57,97,108,108,111,99,97,116,111,114,73,104,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,106,78,83,95,57,97,108,108,111,99,97,116,111,114,73,106,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,106,78,83,95,57,97,108,108,111,99,97,116,111,114,73,106,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,106,78,83,95,57,97,108,108,111,99,97,116,111,114,73,106,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,106,78,83,95,57,97,108,108,111,99,97,116,111,114,73,106,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,99,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,99,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,52,98,105,103,95,97,110,121,95,112,111,108,105,99,121,73,78,50,99,118,54,83,116,114,105,110,103,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,78,50,99,118,54,83,116,114,105,110,103,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,53,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,106,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,106,69,69,0,78,55,99,118,102,108,97,110,110,50,48,102,108,97,110,110,95,99,101,110,116,101,114,115,95,105,110,105,116,95,116,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,52,98,105,103,95,97,110,121,95,112,111,108,105,99,121,73,78,83,95,50,48,102,108,97,110,110,95,99,101,110,116,101,114,115,95,105,110,105,116,95,116,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,78,83,95,50,48,102,108,97,110,110,95,99,101,110,116,101,114,115,95,105,110,105,116,95,116,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,52,98,105,103,95,97,110,121,95,112,111,108,105,99,121,73,78,83,95,49,55,102,108,97,110,110,95,97,108,103,111,114,105,116,104,109,95,116,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,78,83,95,49,55,102,108,97,110,110,95,97,108,103,111,114,105,116,104,109,95,116,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,98,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,98,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,102,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,102,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,105,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,105,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,80,75,99,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,80,75,99,69,69,0,91,101,109,112,116,121,95,97,110,121,93,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,57,101,109,112,116,121,95,97,110,121,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,52,98,105,103,95,97,110,121,95,112,111,108,105,99,121,73,78,83,48,95,57,101,109,112,116,121,95,97,110,121,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,78,83,48,95,57,101,109,112,116,121,95,97,110,121,69,69,69,0,109,121,95,111,98,106,101,99,116,0,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,70,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,37,108,117,32,98,121,116,101,115,0,79,117,116,79,102,77,101,109,111,114,121,69,114,114,111,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,108,108,111,99,46,99,112,112,0,99,111,110,118,101,114,116,65,110,100,85,110,114,111,108,108,83,99,97,108,97,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,114,105,116,104,109,46,99,112,112,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,121,112,101,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,98,105,110,97,114,121,95,111,112,0,112,115,114,99,49,45,62,115,97,109,101,83,105,122,101,40,42,112,115,114,99,50,41,32,38,38,32,116,121,112,101,49,32,61,61,32,116,121,112,101,50,0,40,109,116,121,112,101,32,61,61,32,67,86,95,56,85,32,124,124,32,109,116,121,112,101,32,61,61,32,67,86,95,56,83,41,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,42,112,115,114,99,49,41,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,104,101,32,115,97,109,101,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+198900);allocate([114,97,121,39,0,97,114,105,116,104,109,95,111,112,0,116,121,112,101,50,32,61,61,32,67,86,95,54,52,70,32,38,38,32,40,115,122,50,46,104,101,105,103,104,116,32,61,61,32,49,32,124,124,32,115,122,50,46,104,101,105,103,104,116,32,61,61,32,52,41,0,87,104,101,110,32,116,104,101,32,105,110,112,117,116,32,97,114,114,97,121,115,32,105,110,32,97,100,100,47,115,117,98,116,114,97,99,116,47,109,117,108,116,105,112,108,121,47,100,105,118,105,100,101,32,102,117,110,99,116,105,111,110,115,32,104,97,118,101,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,115,44,32,116,104,101,32,111,117,116,112,117,116,32,97,114,114,97,121,32,116,121,112,101,32,109,117,115,116,32,98,101,32,101,120,112,108,105,99,105,116,108,121,32,115,112,101,99,105,102,105,101,100,0,40,109,116,121,112,101,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,109,116,121,112,101,32,61,61,32,67,86,95,56,83,67,49,41,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,42,112,115,114,99,49,41,0,111,112,32,61,61,32,67,77,80,95,76,84,32,124,124,32,111,112,32,61,61,32,67,77,80,95,76,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,69,81,32,124,124,32,111,112,32,61,61,32,67,77,80,95,78,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,71,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,71,84,0,99,111,109,112,97,114,101,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,104,101,32,115,97,109,101,32,116,121,112,101,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,84,104,101,32,108,111,119,101,114,32,98,111,117,110,97,114,121,32,105,115,32,110,101,105,116,104,101,114,32,97,110,32,97,114,114,97,121,32,111,102,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,115,97,109,101,32,116,121,112,101,32,97,115,32,115,114,99,44,32,110,111,114,32,97,32,115,99,97,108,97,114,0,105,110,82,97,110,103,101,0,84,104,101,32,117,112,112,101,114,32,98,111,117,110,97,114,121,32,105,115,32,110,101,105,116,104,101,114,32,97,110,32,97,114,114,97,121,32,111,102,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,115,97,109,101,32,116,121,112,101,32,97,115,32,115,114,99,44,32,110,111,114,32,97,32,115,99,97,108,97,114,0,108,98,83,99,97,108,97,114,32,61,61,32,117,98,83,99,97,108,97,114,0,108,98,46,116,121,112,101,40,41,32,61,61,32,117,98,46,116,121,112,101,40,41,0,115,114,99,49,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,49,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,0,99,118,83,117,98,0,115,112,108,105,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,110,118,101,114,116,46,99,112,112,0,33,95,109,118,46,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,95,109,118,46,101,109,112,116,121,40,41,32,124,124,32,95,109,118,46,116,121,112,101,40,41,32,61,61,32,109,46,100,101,112,116,104,40,41,0,109,118,32,38,38,32,110,32,62,32,48,0,109,101,114,103,101,0,109,118,91,105,93,46,115,105,122,101,32,61,61,32,109,118,91,48,93,46,115,105,122,101,32,38,38,32,109,118,91,105,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,48,32,60,32,99,110,32,38,38,32,99,110,32,60,61,32,67,86,95,67,78,95,77,65,88,0,115,114,99,32,38,38,32,110,115,114,99,115,32,62,32,48,32,38,38,32,100,115,116,32,38,38,32,110,100,115,116,115,32,62,32,48,32,38,38,32,102,114,111,109,84,111,32,38,38,32,110,112,97,105,114,115,32,62,32,48,0,109,105,120,67,104,97,110,110,101,108,115,0,106,32,60,32,110,115,114,99,115,32,38,38,32,115,114,99,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,105,49,32,62,61,32,48,32,38,38,32,106,32,60,32,110,100,115,116,115,32,38,38,32,100,115,116,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,110,115,114,99,32,62,32,48,32,38,38,32,110,100,115,116,32,62,32,48,0,102,114,111,109,84,111,46,115,105,122,101,40,41,37,50,32,61,61,32,48,32,38,38,32,110,115,114,99,32,62,32,48,32,38,38,32,110,100,115,116,32,62,32,48,0,48,32,60,61,32,99,111,105,32,38,38,32,99,111,105,32,60,32,99,110,0,101,120,116,114,97,99,116,67,104,97,110,110,101,108,0,95,115,114,99,46,115,97,109,101,83,105,122,101,40,95,100,115,116,41,32,38,38,32,115,100,101,112,116,104,32,61,61,32,100,100,101,112,116,104,0,105,110,115,101,114,116,67,104,97,110,110,101,108,0,48,32,60,61,32,99,111,105,32,38,38,32,99,111,105,32,60,32,100,99,110,32,38,38,32,115,99,110,32,61,61,32,49,0,99,111,110,118,101,114,116,83,99,97,108,101,65,98,115,0,99,111,110,118,101,114,116,84,111,0,40,108,117,116,99,110,32,61,61,32,99,110,32,124,124,32,108,117,116,99,110,32,61,61,32,49,41,32,38,38,32,95,108,117,116,46,116,111,116,97,108,40,41,32,61,61,32,50,53,54,32,38,38,32,95,108,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,56,83,41,0,76,85,84,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,80,97,114,97,108,108,101,108,76,111,111,112,66,111,100,121,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,56,80,116,114,79,119,110,101,114,69,0,78,50,99,118,49,53,76,85,84,80,97,114,97,108,108,101,108,66,111,100,121,69,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,110,111,114,109,32,116,121,112,101,0,110,111,114,109,97,108,105,122,101,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,0,99,118,67,111,110,118,101,114,116,83,99,97,108,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,112,121,46,99,112,112,0,109,97,115,107,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,40,109,99,110,32,61,61,32,49,32,124,124,32,109,99,110,32,61,61,32,99,110,41,0,115,105,122,101,40,41,32,61,61,32,109,97,115,107,46,115,105,122,101,40,41,0,99,104,101,99,107,83,99,97,108,97,114,40,118,97,108,117,101,44,32,116,121,112,101,40,41,44,32,95,118,97,108,117,101,46,107,105,110,100,40,41,44,32,95,73,110,112,117,116,65,114,114,97,121,58,58,77,65,84,32,41,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,115,105,122,101,32,61,61,32,109,97,115,107,46,115,105,122,101,41,0,102,108,105,112,0,114,101,112,101,97,116,0,110,121,32,62,32,48,32,38,38,32,110,120,32,62,32,48,0,108,101,110,32,62,32,48,0,98,111,114,100,101,114,73,110,116,101,114,112,111,108,97,116,101,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,98,111,114,100,101,114,32,116,121,112,101,0,116,111,112,32,62,61,32,48,32,38,38,32,98,111,116,116,111,109,32,62,61,32,48,32,38,38,32,108,101,102,116,32,62,61,32,48,32,38,38,32,114,105,103,104,116,32,62,61,32,48,0,99,111,112,121,77,97,107,101,66,111,114,100,101,114,0,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,49,93,32,38,38,32,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,50,93,32,38,38,32,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,51,93,0,99,118,67,111,112,121,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,32,38,38,32,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,0,40,99,111,105,49,32,33,61,32,48,32,124,124,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,41,32,38,38,32,40,99,111,105,50,32,33,61,32,48,32,124,124,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,41,0,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,0,105,99,118,73,110,105,116,77,101,109,83,116,111,114,97,103,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,100,97,116,97,115,116,114,117,99,116,115,46,99,112,112,0,99,118,67,114,101,97,116,101,67,104,105,108,100,77,101,109,83,116,111,114,97,103,101,0,99,118,82,101,108,101,97,115,101,77,101,109,83,116,111,114,97,103,101,0,99,118,67,108,101,97,114,77,101,109,83,116,111,114,97,103,101,0,99,118,83,97,118,101,77,101,109,83,116,111,114,97,103,101,80,111,115,0,99,118,82,101,115,116,111,114,101,77,101,109,83,116,111,114,97,103,101,80,111,115,0,99,118,77,101,109,83,116,111,114,97,103,101,65,108,108,111,99,0,84,111,111,32,108,97,114,103,101,32,109,101,109,111,114,121,32,98,108,111,99,107,32,105,115,32,114,101,113,117,101,115,116,101,100,0,114,101,113,117,101,115,116,101,100,32,115,105,122,101,32,105,115,32,110,101,103,97,116,105,118,101,32,111,114,32,116,111,111,32,98,105,103,0,105,99,118,71,111,78,101,120,116,77,101,109,66,108,111,99,107,0,99,118,67,114,101,97,116,101,83,101,113,0,83,112,101,99,105,102,105,101,100,32,101,108,101,109,101,110,116,32,115,105,122,101,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,115,105,122,101,32,111,102,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,101,108,101,109,101,110,116,32,116,121,112,101,32,40,116,114,121,32,116,111,32,117,115,101,32,48,32,102,111,114,32,101,108,101,109,101,110,116,32,116,121,112,101,41,0,99,118,83,101,116,83,101,113,66,108,111,99,107,83,105,122,101,0,83,116,111,114,97,103,101,32,98,108,111,99,107,32,115,105,122,101,32,105,115,32,116,111,111,32,115,109,97,108,108,32,116,111,32,102,105,116,32,116,104,101,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,115,0,0,1,255,2,255,255,255,3,255,255,255,255,255,255,255,4,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,5,99,118,67,118,116,83,101,113,84,111,65,114,114,97,121,0,99,118,83,101,116,83,101,113,82,101,97,100,101,114,80,111,115,0,99,118,83,116,97,114,116,82,101,97,100,83,101,113,0,99,118,77,97,107,101,83,101,113,72,101,97,100,101,114,70,111,114,65,114,114,97,121,0,69,108,101,109,101,110,116,32,115,105,122,101,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,115,105,122,101,32,111,102,32,112,114,101,100,101,102,105,110,101,100,32,101,108,101,109,101,110,116,32,116,121,112,101,32,40,116,114,121,32,116,111,32,117,115,101,32,48,32,102,111,114,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,116,121,112,101,41,0,99,118,83,116,97,114,116,65,112,112,101,110,100,84,111,83,101,113,0,99,118,83,116,97,114,116,87,114,105,116,101,83,101,113,0,99,118,67,114,101,97,116,101,83,101,113,66,108,111,99,107,0,105,99,118,71,114,111,119,83,101,113,0,84,104,101,32,115,101,113,117,101,110,99,101,32,104,97,115,32,78,85,76,76,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,99,118,71,101,116,83,101,113,82,101,97,100,101,114,80,111,115,0,99,118,83,101,113,80,117,115,104,0,99,118,83,101,113,80,111,112,0,78,85,76,76,32,115,101,113,117,101,110,99,101,32,112,111,105,110,116,101,114,0,99,118,83,101,113,80,117,115,104,77,117,108,116,105,0,110,117,109,98,101,114,32,111,102,32,114,101,109,111,118,101,100,32,101,108,101,109,101,110,116,115,32,105,115,32,110,101,103,97,116,105,118,101,0,99,118,83,101,113,80,111,112,77,117,108,116,105,0,99,118,67,108,101,97,114,83,101,113,0,73,110,118,97,108,105,100,32,115,101,113,117,101,110,99,101,32,104,101,97,100,101,114,0,99,118,83,101,113,83,108,105,99,101,0,66,97,100,32,115,101,113,117,101,110,99,101,32,115,108,105,99,101,0,66,97,100,32,105,110,112,117,116,32,115,101,113,117,101,110,99,101,0,99,118,83,101,113,83,111,114,116,0,99,118,67,114,101,97,116,101,83,101,116,0,99,118,83,101,116,65,100,100,0,99,118,67,114,101,97,116,101,71,114,97,112,104,0,99,118,71,114,97,112,104,65,100,100,86,116,120,0,99,118,70,105,110,100,71,114,97,112,104,69,100,103,101,66,121,80,116,114,0,103,114,97,112,104,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,99,118,71,114,97,112,104,65,100,100,69,100,103,101,66,121,80,116,114,0,118,101,114,116,101,120,32,112,111,105,110,116,101,114,115,32,99,111,105,110,115,105,100,101,32,40,111,114,32,115,101,116,32,116,111,32,78,85,76,76,41,0,73,110,118,97,108,105,100,32,103,114,97,112,104,32,112,111,105,110,116,101,114,0,99,118,67,108,111,110,101,71,114,97,112,104,0,99,118,84,114,101,101,84,111,78,111,100,101,83,101,113,0,99,118,73,110,105,116,84,114,101,101,78,111,100,101,73,116,101,114,97,116,111,114,0,99,118,73,110,115,101,114,116,78,111,100,101,73,110,116,111,84,114,101,101,0,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,50,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,67,49,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,67,50,0,100,102,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,100,120,116,46,99,112,112,0,84,104,105,115,32,109,111,100,101,32,40,117,115,105,110,103,32,110,111,110,122,101,114,111,95,114,111,119,115,32,119,105,116,104,32,97,32,115,105,110,103,108,101,45,99,111,108,117,109,110,32,109,97,116,114,105,120,41,32,98,114,101,97,107,115,32,116,104,101,32,102,117,110,99,116,105,111,110,39,115,32,108,111,103,105,99,44,32,115,111,32,105,116,32,105,115,32,112,114,111,104,105,98,105,116,101,100,46,10,70,111,114,32,102,97,115,116,32,99,111,110,118,111,108,117,116,105,111,110,47,99,111,114,114,101,108,97,116,105,111,110,32,117,115,101,32,50,45,99,111,108,117,109,110,32,109,97,116,114,105,120,32,111,114,32,115,105,110,103,108,101,45,114,111,119,32,109,97,116,114,105,120,32,105,110,115,116,101,97,100,0,102,97,99,116,111,114,115,91,48,93,32,61,61,32,102,97,99,116,111,114,115,91,110,102,45,49,93,0,68,70,84,0,116,121,112,101,32,61,61,32,115,114,99,66,46,116,121,112,101,40,41,32,38,38,32,115,114,99,65,46,115,105,122,101,40,41,32,61,61,32,115,114,99,66,46,115,105,122,101,40,41,0,109,117,108,83,112,101,99,116,114,117,109,115,0,100,99,116,0,79,100,100,45,115,105,122,101,32,68,67,84,39,115,32,97,114,101,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,100,97,116,97,48,46,100,105,109,115,32,60,61,32,50,32,38,38,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,38,38,32,75,32,62,32,48,0,107,109,101,97,110,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,107,109,101,97,110,115,46,99,112,112,0,78,32,62,61,32,75,0,40,98,101,115,116,95,108,97,98,101,108,115,46,99,111,108,115,32,61,61,32,49,32,124,124,32,98,101,115,116,95,108,97,98,101,108,115,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,99,111,108,115,42,98,101,115,116,95,108,97,98,101,108,115,46,114,111,119,115,32,61,61,32,78,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,40,117,110,115,105,103,110,101,100,41,108,97,98,101,108,115,91,105,93,32,60,32,40,117,110,115,105,103,110,101,100,41,75,0,99,111,117,110,116,101,114,115,91,107,93,32,33,61,32,48,0,78,50,99,118,50,50,75,77,101,97,110,115,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,69,0,78,50,99,118,50,52,75,77,101,97,110,115,80,80,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,69,0,33,109,97,116,46,101,109,112,116,121,40,41,0,100,101,116,101,114,109,105,110,97,110,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,108,97,112,97,99,107,46,99,112,112,0,109,97,116,46,114,111,119,115,32,61,61,32,109,97,116,46,99,111,108,115,32,38,38,32,40,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,41,0,105,110,118,101,114,116,0,109,32,61,61,32,110,0,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,76,85,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,0,115,114,99,46,114,111,119,115,32,61,61,32,115,114,99,46,99,111,108,115,0,101,105,103,101,110,0,119,46,116,121,112,101,40,41,32,61,61,32,117,46,116,121,112,101,40,41,32,38,38,32,117,46,116,121,112,101,40,41,32,61,61,32,118,116,46,116,121,112,101,40,41,32,38,38,32,117,46,100,97,116,97,32,38,38,32,118,116,46,100,97,116,97,32,38,38,32,119,46,100,97,116,97,0,98,97,99,107,83,117,98,115,116,0,117,46,99,111,108,115,32,62,61,32,110,109,32,38,38,32,118,116,46,114,111,119,115,32,62,61,32,110,109,32,38,38,32,40,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,109,44,32,49,41,32,124,124,32,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,109,41,32,124,124,32,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,118,116,46,114,111,119,115,44,32,117,46,99,111,108,115,41,41,0,114,104,115,46,100,97,116,97,32,61,61,32,48,32,124,124,32,40,114,104,115,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,32,38,38,32,114,104,115,46,114,111,119,115,32,61,61,32,109,41,0,95,83,86,68,99,111,109,112,117,116,101,0,116,121,112,101,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,40,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,41,0,115,111,108,118,101,0,40,109,101,116,104,111,100,32,33,61,32,68,69,67,79,77,80,95,76,85,32,38,38,32,109,101,116,104,111,100,32,33,61,32,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,41,32,124,124,32,105,115,95,110,111,114,109,97,108,32,124,124,32,115,114,99,46,114,111,119,115,32,61,61,32,115,114,99,46,99,111,108,115,0,84,104,101,32,102,117,110,99,116,105,111,110,32,99,97,110,32,110,111,116,32,115,111,108,118,101,32,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,50,46,115,105,122,101,40,41,32,38,38,32,116,121,112,101,32,61,61,32,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,41,0,109,97,103,110,105,116,117,100,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,104,102,117,110,99,115,46,99,112,112,0,112,104,97,115,101,0,88,46,115,105,122,101,32,61,61,32,89,46,115,105,122,101,32,38,38,32,116,121,112,101,32,61,61,32,89,46,116,121,112,101,40,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,41,0,99,97,114,116,84,111,80,111,108,97,114,0,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,41,32,38,38,32,40,115,114,99,49,46,101,109,112,116,121,40,41,32,124,124,32,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,41,0,112,111,108,97,114,84,111,67,97,114,116,0,77,97,103,46,101,109,112,116,121,40,41,32,124,124,32,65,110,103,108,101,46,115,105,122,101,32,61,61,32,77,97,103,46,115,105,122,101,0,101,120,112,0,108,111,103,0,112,111,119,0,95,97,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,70,0,112,97,116,99,104,78,97,78,115,0,77,97,103,46,115,105,122,101,40,41,32,61,61,32,88,46,115,105,122,101,40,41,32,38,38,32,77,97,103,46,116,121,112,101,40,41,32,61,61,32,88,46,116,121,112,101,40,41,0,99,118,67,97,114,116,84,111,80,111,108,97,114,0,65,110,103,108,101,46,115,105,122,101,40,41,32,61,61,32,88,46,115,105,122,101,40,41,32,38,38,32,65,110,103,108,101,46,116,121,112,101,40,41,32,61,61,32,88,46,116,121,112,101,40,41,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,32,38,38,32,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,0,99,118,76,111,103,0,99,118,80,111,119,0,99,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,99,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,115,111,108,118,101,67,117,98,105,99,0,40,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,48,44,32,49,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,48,43,49,44,32,49,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,48,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,48,43,49,41,41,0,67,86,95,77,65,84,95,68,69,80,84,72,40,99,116,121,112,101,41,32,62,61,32,67,86,95,51,50,70,32,38,38,32,67,86,95,77,65,84,95,67,78,40,99,116,121,112,101,41,32,60,61,32,50,0,115,111,108,118,101,80,111,108,121,0,99,111,101,102,102,115,48,46,114,111,119,115,32,61,61,32,49,32,124,124,32,99,111,101,102,102,115,48,46,99,111,108,115,32,61,61,32,49,0,116,121,112,101,32,61,61,32,66,46,116,121,112,101,40,41,32,38,38,32,40,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,67,49,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,50,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,67,50,41,0,103,101,109,109,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,109,117,108,46,99,112,112,0,97,95,115,105,122,101,46,119,105,100,116,104,32,61,61,32,108,101,110,0,97,95,115,105,122,101,46,104,101,105,103,104,116,32,61,61,32,108,101,110,0,67,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,32,38,38,32,40,40,40,102,108,97,103,115,38,71,69,77,77,95,51,95,84,41,32,61,61,32,48,32,38,38,32,67,46,114,111,119,115,32,61,61,32,100,95,115,105,122,101,46,104,101,105,103,104,116,32,38,38,32,67,46,99,111,108,115,32,61,61,32,100,95,115,105,122,101,46,119,105,100,116,104,41,32,124,124,32,40,40,102,108,97,103,115,38,71,69,77,77,95,51,95,84,41,32,33,61,32,48,32,38,38,32,67,46,114,111,119,115,32,61,61,32,100,95,115,105,122,101,46,119,105,100,116,104,32,38,38,32,67,46,99,111,108,115,32,61,61,32,100,95,115,105,122,101,46,104,101,105,103,104,116,41,41,0,116,121,112,101,32,61,61,32,67,86,95,54,52,70,67,50,0,115,99,110,32,61,61,32,109,46,99,111,108,115,32,124,124,32,115,99,110,32,43,32,49,32,61,61,32,109,46,99,111,108,115,0,116,114,97,110,115,102,111,114,109,0,115,99,110,32,43,32,49,32,61,61,32,109,46,99,111,108,115,0,112,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,0,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,0,116,121,112,101,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,0,115,99,97,108,101,65,100,100,0,115,114,99,49,46,115,105,122,101,32,61,61,32,115,114,99,50,46,115,105,122,101,0,99,97,108,99,67,111,118,97,114,77,97,116,114,105,120,0,95,109,101,97,110,46,115,105,122,101,40,41,32,61,61,32,115,105,122,101,0,115,114,99,46,115,105,122,101,40,41,32,62,32,48,0,40,42,101,97,99,104,41,46,115,105,122,101,40,41,32,61,61,32,115,105,122,101,32,38,38,32,40,42,101,97,99,104,41,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,0,40,40,102,108,97,103,115,32,38,32,67,86,95,67,79,86,65,82,95,82,79,87,83,41,32,33,61,32,48,41,32,94,32,40,40,102,108,97,103,115,32,38,32,67,86,95,67,79,86,65,82,95,67,79,76,83,41,32,33,61,32,48,41,0,110,115,97,109,112,108,101,115,32,62,32,48,0,109,101,97,110,46,115,105,122,101,40,41,32,61,61,32,115,105,122,101,0,109,117,108,84,114,97,110,115,112,111,115,101,100,0,100,101,108,116,97,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,40,100,101,108,116,97,46,114,111,119,115,32,61,61,32,115,114,99,46,114,111,119,115,32,124,124,32,100,101,108,116,97,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,40,100,101,108,116,97,46,99,111,108,115,32,61,61,32,115,114,99,46,99,111,108,115,32,124,124,32,100,101,108,116,97,46,99,111,108,115,32,61,61,32,49,41,0,116,121,112,101,32,61,61,32,118,50,46,116,121,112,101,40,41,32,38,38,32,116,121,112,101,32,61,61,32,105,99,111,118,97,114,46,116,121,112,101,40,41,32,38,38,32,115,122,32,61,61,32,118,50,46,115,105,122,101,40,41,32,38,38,32,108,101,110,32,61,61,32,105,99,111,118,97,114,46,114,111,119,115,32,38,38,32,108,101,110,32,61,61,32,105,99,111,118,97,114,46,99,111,108,115,0,77,97,104,97,108,97,110,111,98,105,115,0,109,97,116,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,40,41,32,38,38,32,109,97,116,46,115,105,122,101,32,61,61,32,115,105,122,101,32,38,38,32,102,117,110,99,32,33,61,32,48,0,100,111,116,0,40,68,46,114,111,119,115,32,61,61,32,40,40,102,108,97,103,115,32,38,32,67,86,95,71,69,77,77,95,65,95,84,41,32,61,61,32,48,32,63,32,65,46,114,111,119,115,32,58,32,65,46,99,111,108,115,41,41,32,38,38,32,40,68,46,99,111,108,115,32,61,61,32,40,40,102,108,97,103,115,32,38,32,67,86,95,71,69,77,77,95,66,95,84,41,32,61,61,32,48,32,63,32,66,46,99,111,108,115,32,58,32,66,46,114,111,119,115,41,41,32,38,38,32,68,46,116,121,112,101,40,41,32,61,61,32,65,46,116,121,112,101,40,41,0,99,118,71,69,77,77,0,78,50,99,118,49,49,77,97,116,79,112,95,83,111,108,118,101,69,0,67,86,95,77,65,84,95,67,78,40,95,116,121,112,101,41,32,61,61,32,101,46,97,46,99,104,97,110,110,101,108,115,40,41,0,97,115,115,105,103,110,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,111,112,46,99,112,112,0,78,50,99,118,49,52,77,97,116,79,112,95,73,100,101,110,116,105,116,121,69,0,78,50,99,118,49,50,77,97,116,79,112,95,73,110,118,101,114,116,69,0,78,50,99,118,49,48,77,97,116,79,112,95,71,69,77,77,69,0,85,110,107,110,111,119,110,32,111,112,101,114,97,116,105,111,110,0,78,50,99,118,57,77,97,116,79,112,95,66,105,110,69,0,78,50,99,118,49,49,77,97,116,79,112,95,65,100,100,69,120,69,0,78,50,99,118,55,77,97,116,79,112,95,84,69,0,78,50,99,118,53,77,97,116,79,112,69,0,78,50,99,118,57,77,97,116,79,112,95,67,109,112,69,0,73,110,118,97,108,105,100,32,109,97,116,114,105,120,32,105,110,105,116,105,97,108,105,122,101,114,32,116,121,112,101,0,78,50,99,118,49,55,77,97,116,79,112,95,73,110,105,116,105,97,108,105,122,101,114,69,0,78,50,99,118,50,53,68,117,109,109,121,66,117,102,102,101,114,80,111,111,108,67,111,110,116,114,111,108,108,101,114,69,0,78,50,99,118,50,48,66,117,102,102,101,114,80,111,111,108,67,111,110,116,114,111,108,108,101,114,69,0,115,122,91,105,93,32,60,61,32,40,115,105,122,101,95,116,41,73,78,84,95,77,65,88,0,99,111,112,121,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,46,99,112,112,0,117,45,62,117,114,101,102,99,111,117,110,116,32,61,61,32,48,0,100,101,97,108,108,111,99,97,116,101,0,117,45,62,114,101,102,99,111,117,110,116,32,61,61,32,48,0,116,111,116,97,108,32,60,61,32,115,116,101,112,91,105,93,0,78,50,99,118,49,53,83,116,100,77,97,116,65,108,108,111,99,97,116,111,114,69,0,95,97,114,114,97,121,115,32,38,38,32,40,95,112,116,114,115,32,124,124,32,95,112,108,97,110,101,115,41,0,110,97,114,114,97,121,115,32,60,61,32,49,48,48,48,0,97,114,114,97,121,115,91,105,93,32,33,61,32,48,0,65,46,115,105,122,101,32,61,61,32,97,114,114,97,121,115,91,105,48,93,45,62,115,105,122,101,0,65,46,115,116,101,112,91,100,45,49,93,32,61,61,32,65,46,101,108,101,109,83,105,122,101,40,41,0,83,116,101,112,32,109,117,115,116,32,98,101,32,97,32,109,117,108,116,105,112,108,101,32,111,102,32,101,115,122,49,0,117,112,108,111,97,100,0,100,111,119,110,108,111,97,100,0,78,50,99,118,49,50,77,97,116,65,108,108,111,99,97,116,111,114,69,0,109,46,100,105,109,115,32,62,61,32,50,0,48,32,60,61,32,95,114,111,119,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,95,114,111,119,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,95,114,111,119,82,97,110,103,101,46,101,110,100,32,38,38,32,95,114,111,119,82,97,110,103,101,46,101,110,100,32,60,61,32,109,46,114,111,119,115,0,48,32,60,61,32,95,99,111,108,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,95,99,111,108,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,95,99,111,108,82,97,110,103,101,46,101,110,100,32,38,38,32,95,99,111,108,82,97,110,103,101,46,101,110,100,32,60,61,32,109,46,99,111,108,115,0,114,97,110,103,101,115,0,114,32,61,61,32,82,97,110,103,101,58,58,97,108,108,40,41,32,124,124,32,40,48,32,60,61,32,114,46,115,116,97,114,116,32,38,38,32,114,46,115,116,97,114,116,32,60,32,114,46,101,110,100,32,38,38,32,114,46,101,110,100,32,60,61,32,109,46,115,105,122,101,91,105,93,41,0,100,105,109,115,32,60,61,32,50,0,100,105,97,103,0,40,105,110,116,41,110,101,108,101,109,115,32,62,61,32,48,0,114,101,115,101,114,118,101,0,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,101,32,102,117,110,99,116,105,111,110,0,99,118,97,114,114,84,111,77,97,116,0,105,109,103,45,62,100,97,116,97,79,114,100,101,114,32,61,61,32,73,80,76,95,68,65,84,65,95,79,82,68,69,82,95,80,73,88,69,76,0,105,112,108,73,109,97,103,101,84,111,77,97,116,0,105,109,103,45,62,100,97,116,97,79,114,100,101,114,32,61,61,32,73,80,76,95,68,65,84,65,95,79,82,68,69,82,95,80,73,88,69,76,32,124,124,32,105,109,103,45,62,114,111,105,45,62,99,111,105,32,33,61,32,48,0,116,111,116,97,108,32,62,32,48,32,38,38,32,67,86,95,69,76,69,77,95,83,73,90,69,40,115,101,113,45,62,102,108,97,103,115,41,32,61,61,32,101,115,122,0,100,105,109,115,32,60,61,32,50,32,38,38,32,115,116,101,112,91,48,93,32,62,32,48,0,108,111,99,97,116,101,82,79,73,0,97,100,106,117,115,116,82,79,73,0,105,32,60,32,48,0,103,101,116,77,97,116,95,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,40,105,110,116,41,118,118,46,115,105,122,101,40,41,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,40,105,110,116,41,118,46,115,105,122,101,40,41,0,89,111,117,32,115,104,111,117,108,100,32,101,120,112,108,105,99,105,116,108,121,32,99,97,108,108,32,109,97,112,72,111,115,116,47,117,110,109,97,112,72,111,115,116,32,109,101,116,104,111,100,115,32,102,111,114,32,111,103,108,58,58,66,117,102,102,101,114,32,111,98,106,101,99,116,0,89,111,117,32,115,104,111,117,108,100,32,101,120,112,108,105,99,105,116,108,121,32,99,97,108,108,32,100,111,119,110,108,111,97,100,32,109,101,116,104,111,100,32,102,111,114,32,99,117,100,97,58,58,71,112,117,77,97,116,32,111,98,106,101,99,116,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,40,102,108,97,103,115,32,38,32,70,73,88,69,68,95,84,89,80,69,41,32,33,61,32,48,0,105,32,60,32,40,105,110,116,41,118,118,46,115,105,122,101,40,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,38,38,32,33,102,105,120,101,100,83,105,122,101,40,41,0,67,86,95,77,65,84,95,84,89,80,69,40,109,116,121,112,101,41,32,61,61,32,109,46,116,121,112,101,40,41,0,109,46,100,105,109,115,32,61,61,32,100,0,109,46,115,105,122,101,91,106,93,32,61,61,32,115,105,122,101,115,91,106,93,0,109,116,121,112,101,32,61,61,32,116,121,112,101,48,32,124,124,32,40,67,86,95,77,65,84,95,67,78,40,109,116,121,112,101,41,32,61,61,32,49,32,38,38,32,40,40,49,32,60,60,32,116,121,112,101,48,41,32,38,32,102,105,120,101,100,68,101,112,116,104,77,97,115,107,41,32,33,61,32,48,41,0,100,32,61,61,32,50,32,38,38,32,40,40,115,105,122,101,115,91,48,93,32,61,61,32,115,122,46,104,101,105,103,104,116,32,38,38,32,115,105,122,101,115,91,49,93,32,61,61,32,115,122,46,119,105,100,116,104,41,32,124,124,32,40,97,108,108,111,119,84,114,97,110,115,112,111,115,101,100,32,38,38,32,115,105,122,101,115,91,48,93,32,61,61,32,115,122,46,119,105,100,116,104,32,38,38,32,115,105,122,101,115,91,49,93,32,61,61,32,115,122,46,104,101,105,103,104,116,41,41,0,100,32,61,61,32,50,32,38,38,32,40,115,105,122,101,115,91,48,93,32,61,61,32,49,32,124,124,32,115,105,122,101,115,91,49,93,32,61,61,32,49,32,124,124,32,115,105,122,101,115,91,48,93,42,115,105,122,101,115,91,49,93,32,61,61,32,48,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,118,118,46,115,105,122,101,40,41,0,109,116,121,112,101,32,61,61,32,116,121,112,101,48,32,124,124,32,40,67,86,95,77,65,84,95,67,78,40,109,116,121,112,101,41,32,61,61,32,67,86,95,77,65,84,95,67,78,40,116,121,112,101,48,41,32,38,38,32,40,40,49,32,60,60,32,116,121,112,101,48,41,32,38,32,102,105,120,101,100,68,101,112,116,104,77,97,115,107,41,32,33,61,32,48,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,40,40,115,116,100,58,58,118,101,99,116,111,114,60,117,99,104,97,114,62,42,41,118,41,45,62,115,105,122,101,40,41,32,47,32,101,115,122,0,86,101,99,116,111,114,115,32,119,105,116,104,32,101,108,101,109,101,110,116,32,115,105,122,101,32,37,100,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,46,32,80,108,101,97,115,101,44,32,109,111,100,105,102,121,32,79,117,116,112,117,116,65,114,114,97,121,58,58,99,114,101,97,116,101,40,41,10,0,99,114,101,97,116,101,40,41,32,99,97,108,108,101,100,32,102,111,114,32,116,104,101,32,109,105,115,115,105,110,103,32,111,117,116,112,117,116,32,97,114,114,97,121,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,108,101,110,48,0,118,91,106,93,46,101,109,112,116,121,40,41,0,105,32,60,32,40,105,110,116,41,118,46,115,105,122,101,40,41,0,114,101,115,104,97,112,101,0,100,46,99,111,108,115,32,61,61,32,49,32,124,124,32,100,46,114,111,119,115,32,61,61,32,49,0,95,115,114,99,46,100,105,109,115,40,41,32,60,61,32,50,32,38,38,32,101,115,122,32,60,61,32,51,50,0,116,114,97,110,115,112,111,115,101,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,32,38,38,32,40,115,114,99,46,99,111,108,115,32,61,61,32,49,32,124,124,32,115,114,99,46,114,111,119,115,32,61,61,32,49,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+209140);allocate([40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,100,105,109,115,0,99,110,32,60,61,32,52,0,115,99,97,108,97,114,84,111,82,97,119,68,97,116,97,0,103,101,116,77,97,116,86,101,99,116,111,114,0,103,101,116,85,77,97,116,86,101,99,116,111,114,0,101,109,112,116,121,0,40,115,105,122,101,95,116,41,105,32,60,32,118,118,46,115,105,122,101,40,41,0,105,115,67,111,110,116,105,110,117,111,117,115,0,103,101,116,77,97,116,82,101,102,0,107,32,61,61,32,83,84,68,95,86,69,67,84,79,82,95,77,65,84,0,99,108,101,97,114,0,107,32,61,61,32,85,77,65,84,0,103,101,116,85,77,97,116,82,101,102,0,107,32,61,61,32,83,84,68,95,86,69,67,84,79,82,95,85,77,65,84,0,99,104,101,99,107,83,99,97,108,97,114,40,118,97,108,117,101,44,32,116,121,112,101,40,41,44,32,97,114,114,46,107,105,110,100,40,41,44,32,95,73,110,112,117,116,65,114,114,97,121,58,58,67,85,68,65,95,71,80,85,95,77,65,84,41,0,115,101,116,84,111,0,115,114,99,91,105,93,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,91,105,93,46,114,111,119,115,32,61,61,32,115,114,99,91,48,93,46,114,111,119,115,32,38,38,32,115,114,99,91,105,93,46,116,121,112,101,40,41,32,61,61,32,115,114,99,91,48,93,46,116,121,112,101,40,41,0,104,99,111,110,99,97,116,0,115,114,99,91,105,93,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,91,105,93,46,99,111,108,115,32,61,61,32,115,114,99,91,48,93,46,99,111,108,115,32,38,38,32,115,114,99,91,105,93,46,116,121,112,101,40,41,32,61,61,32,115,114,99,91,48,93,46,116,121,112,101,40,41,0,118,99,111,110,99,97,116,0,95,109,46,100,105,109,115,40,41,32,60,61,32,50,0,115,101,116,73,100,101,110,116,105,116,121,0,116,114,97,99,101,0,109,46,100,105,109,115,32,60,61,32,50,32,38,38,32,109,46,114,111,119,115,32,61,61,32,109,46,99,111,108,115,0,99,111,109,112,108,101,116,101,83,121,109,109,0,95,115,114,99,46,100,105,109,115,40,41,32,60,61,32,50,0,114,101,100,117,99,101,0,111,112,32,61,61,32,67,86,95,82,69,68,85,67,69,95,83,85,77,32,124,124,32,111,112,32,61,61,32,67,86,95,82,69,68,85,67,69,95,77,65,88,32,124,124,32,111,112,32,61,61,32,67,86,95,82,69,68,85,67,69,95,77,73,78,32,124,124,32,111,112,32,61,61,32,67,86,95,82,69,68,85,67,69,95,65,86,71,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,105,110,112,117,116,32,97,110,100,32,111,117,116,112,117,116,32,97,114,114,97,121,32,102,111,114,109,97,116,115,0,115,114,99,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,102,117,110,99,32,33,61,32,48,0,115,111,114,116,0,115,111,114,116,73,100,120,0,115,114,99,46,100,97,116,97,32,33,61,32,100,115,116,46,100,97,116,97,0,115,111,114,116,73,100,120,95,0,95,99,110,32,62,61,32,48,32,38,38,32,95,110,101,119,110,100,105,109,115,32,62,32,48,32,38,38,32,95,110,101,119,110,100,105,109,115,32,60,61,32,67,86,95,77,65,88,95,68,73,77,32,38,38,32,95,110,101,119,115,122,0,82,101,113,117,101,115,116,101,100,32,97,110,100,32,115,111,117,114,99,101,32,109,97,116,114,105,99,101,115,32,104,97,118,101,32,100,105,102,102,101,114,101,110,116,32,99,111,117,110,116,32,111,102,32,101,108,101,109,101,110,116,115,0,82,101,115,104,97,112,105,110,103,32,111,102,32,110,45,100,105,109,101,110,115,105,111,110,97,108,32,110,111,110,45,99,111,110,116,105,110,117,111,117,115,32,109,97,116,114,105,99,101,115,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,121,101,116,0,79,80,69,78,67,86,95,79,80,69,78,67,76,95,82,65,73,83,69,95,69,82,82,79,82,0,99,108,70,105,110,105,115,104,40,112,45,62,104,97,110,100,108,101,41,32,61,61,32,48,0,102,105,110,105,115,104,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,111,99,108,46,99,112,112,0,49,0,84,114,117,101,0,84,82,85,69,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,37,115,32,112,97,114,97,109,101,116,101,114,58,32,37,115,0,103,101,116,66,111,111,108,80,97,114,97,109,101,116,101,114,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,84,104,101,32,108,105,98,114,97,114,121,32,105,115,32,99,111,109,112,105,108,101,100,32,119,105,116,104,111,117,116,32,79,112,101,110,71,76,32,115,117,112,112,111,114,116,0,116,104,114,111,119,95,110,111,95,111,103,108,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,111,112,101,110,103,108,46,99,112,112,0,78,50,99,118,49,54,80,97,114,97,108,108,101,108,76,111,111,112,66,111,100,121,69,0,100,97,116,97,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,99,97,46,99,112,112,0,95,109,101,97,110,46,115,105,122,101,40,41,32,61,61,32,109,101,97,110,95,115,122,0,114,101,116,97,105,110,101,100,86,97,114,105,97,110,99,101,32,62,32,48,32,38,38,32,114,101,116,97,105,110,101,100,86,97,114,105,97,110,99,101,32,60,61,32,49,0,33,109,101,97,110,46,101,109,112,116,121,40,41,32,38,38,32,33,101,105,103,101,110,118,101,99,116,111,114,115,46,101,109,112,116,121,40,41,32,38,38,32,40,40,109,101,97,110,46,114,111,119,115,32,61,61,32,49,32,38,38,32,109,101,97,110,46,99,111,108,115,32,61,61,32,100,97,116,97,46,99,111,108,115,41,32,124,124,32,40,109,101,97,110,46,99,111,108,115,32,61,61,32,49,32,38,38,32,109,101,97,110,46,114,111,119,115,32,61,61,32,100,97,116,97,46,114,111,119,115,41,41,0,112,114,111,106,101,99,116,0,33,109,101,97,110,46,101,109,112,116,121,40,41,32,38,38,32,33,101,105,103,101,110,118,101,99,116,111,114,115,46,101,109,112,116,121,40,41,32,38,38,32,40,40,109,101,97,110,46,114,111,119,115,32,61,61,32,49,32,38,38,32,101,105,103,101,110,118,101,99,116,111,114,115,46,114,111,119,115,32,61,61,32,100,97,116,97,46,99,111,108,115,41,32,124,124,32,40,109,101,97,110,46,99,111,108,115,32,61,61,32,49,32,38,38,32,101,105,103,101,110,118,101,99,116,111,114,115,46,114,111,119,115,32,61,61,32,100,97,116,97,46,114,111,119,115,41,41,0,98,97,99,107,80,114,111,106,101,99,116,0,78,85,76,76,32,100,111,117,98,108,101,32,112,111,105,110,116,101,114,32,116,111,32,102,105,108,101,32,115,116,111,114,97,103,101,0,105,99,118,67,108,111,115,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,46,99,112,112,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,10,0,84,104,101,32,115,116,111,114,97,103,101,32,105,115,32,110,111,116,32,111,112,101,110,101,100,0,105,99,118,80,117,116,115,0,73,110,118,97,108,105,100,32,112,111,105,110,116,101,114,32,116,111,32,102,105,108,101,32,115,116,111,114,97,103,101,0,99,118,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,84,104,101,32,102,105,108,101,32,115,116,111,114,97,103,101,32,105,115,32,111,112,101,110,101,100,32,102,111,114,32,114,101,97,100,105,110,103,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,49,51,67,118,70,105,108,101,83,116,111,114,97,103,101,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,85,76,76,32,111,114,32,101,109,112,116,121,32,102,105,108,101,110,97,109,101,0,78,85,76,76,32,111,114,32,101,109,112,116,121,32,98,117,102,102,101,114,0,99,118,79,112,101,110,70,105,108,101,83,116,111,114,97,103,101,0,67,86,95,83,84,79,82,65,71,69,95,65,80,80,69,78,68,32,97,110,100,32,67,86,95,83,84,79,82,65,71,69,95,77,69,77,79,82,89,32,97,114,101,32,110,111,116,32,99,117,114,114,101,110,116,108,121,32,99,111,109,112,97,116,105,98,108,101,0,65,112,112,101,110,100,105,110,103,32,100,97,116,97,32,116,111,32,99,111,109,112,114,101,115,115,101,100,32,102,105,108,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,97,43,116,0,119,116,0,114,116,0,85,84,70,45,49,54,0,117,116,102,45,49,54,0,85,116,102,45,49,54,0,85,84,70,45,49,54,32,88,77,76,32,101,110,99,111,100,105,110,103,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,33,32,85,115,101,32,56,45,98,105,116,32,101,110,99,111,100,105,110,103,10,0,115,116,114,108,101,110,40,101,110,99,111,100,105,110,103,41,32,60,32,49,48,48,48,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,32,101,110,99,111,100,105,110,103,61,34,37,115,34,63,62,10,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,63,62,10,0,60,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,10,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,105,110,32,116,104,101,32,101,110,100,32,111,102,32,102,105,108,101,46,10,0,114,43,116,0,32,60,33,45,45,32,114,101,115,117,109,101,100,32,45,45,62,0,37,89,65,77,76,58,49,46,48,10,0,46,46,46,10,45,45,45,10,0,37,89,65,77,76,58,0,37,115,40,37,100,41,58,32,37,115,0,86,97,108,105,100,32,88,77,76,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,39,60,63,120,109,108,32,46,46,46,63,62,39,0,105,99,118,88,77,76,80,97,114,115,101,0,111,112,101,110,99,118,95,115,116,111,114,97,103,101,0,60,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,116,97,103,32,105,115,32,109,105,115,115,105,110,103,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,116,97,103,32,105,115,32,109,105,115,115,105,110,103,0,45,45,45,0,37,89,65,77,76,58,49,46,0,85,110,115,117,112,112,111,114,116,101,100,32,89,65,77,76,32,118,101,114,115,105,111,110,32,40,105,116,32,109,117,115,116,32,98,101,32,49,46,120,41,0,105,99,118,89,77,76,80,97,114,115,101,0,73,110,118,97,108,105,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,115,121,110,116,97,120,0,84,104,101,32,89,65,77,76,32,115,116,114,101,97,109,115,32,109,117,115,116,32,115,116,97,114,116,32,119,105,116,104,32,39,45,45,45,39,44,32,101,120,99,101,112,116,32,116,104,101,32,102,105,114,115,116,32,111,110,101,0,79,110,108,121,32,99,111,108,108,101,99,116,105,111,110,115,32,97,115,32,89,65,77,76,32,115,116,114,101,97,109,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,105,115,32,112,97,114,115,101,114,0,69,109,112,116,121,32,116,121,112,101,32,110,97,109,101,0,105,99,118,89,77,76,80,97,114,115,101,86,97,108,117,101,0,115,116,114,0,115,101,113,0,109,97,112,0,73,110,118,97,108,105,100,32,110,117,109,101,114,105,99,32,118,97,108,117,101,32,40,105,110,99,111,110,115,105,115,116,101,110,116,32,101,120,112,108,105,99,105,116,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,63,41,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,0,84,111,111,32,108,111,110,103,32,115,116,114,105,110,103,32,108,105,116,101,114,97,108,0,84,104,101,32,119,114,111,110,103,32,99,108,111,115,105,110,103,32,98,114,97,99,107,101,116,0,77,105,115,115,105,110,103,32,44,32,98,101,116,119,101,101,110,32,116,104,101,32,101,108,101,109,101,110,116,115,0,67,111,109,112,108,101,120,32,107,101,121,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,77,117,108,116,105,45,108,105,110,101,32,116,101,120,116,32,108,105,116,101,114,97,108,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,73,110,99,111,114,114,101,99,116,32,105,110,100,101,110,116,97,116,105,111,110,0,66,108,111,99,107,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,115,32,109,117,115,116,32,98,101,32,112,114,101,99,101,100,101,100,32,119,105,116,104,32,39,45,39,0,75,101,121,32,109,97,121,32,110,111,116,32,115,116,97,114,116,32,119,105,116,104,32,39,45,39,0,105,99,118,89,77,76,80,97,114,115,101,75,101,121,0,77,105,115,115,105,110,103,32,39,58,39,0,65,110,32,101,109,112,116,121,32,107,101,121,0,99,118,71,101,116,70,105,108,101,78,111,100,101,0,78,117,108,108,32,107,101,121,32,101,108,101,109,101,110,116,0,84,104,101,32,110,111,100,101,32,105,115,32,110,101,105,116,104,101,114,32,97,32,109,97,112,32,110,111,114,32,97,110,32,101,109,112,116,121,32,99,111,108,108,101,99,116,105,111,110,0,68,117,112,108,105,99,97,116,101,100,32,107,101,121,0,83,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,115,104,111,117,108,100,32,110,111,116,32,104,97,118,101,32,110,97,109,101,32,40,117,115,101,32,60,95,62,60,47,95,62,41,0,105,99,118,70,83,67,114,101,97,116,101,67,111,108,108,101,99,116,105,111,110,0,66,97,100,32,102,111,114,109,97,116,32,111,102,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,99,111,110,115,116,97,110,116,0,105,99,118,80,114,111,99,101,115,115,83,112,101,99,105,97,108,68,111,117,98,108,101,0,105,99,118,89,77,76,83,107,105,112,83,112,97,99,101,115,0,84,111,111,32,108,111,110,103,32,115,116,114,105,110,103,32,111,114,32,97,32,108,97,115,116,32,115,116,114,105,110,103,32,119,47,111,32,110,101,119,108,105,110,101,0,84,97,98,115,32,97,114,101,32,112,114,111,104,105,98,105,116,101,100,32,105,110,32,89,65,77,76,33,0,68,105,114,101,99,116,105,118,101,32,116,97,103,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,105,99,118,88,77,76,80,97,114,115,101,86,97,108,117,101,0,69,109,112,116,121,32,116,97,103,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,116,121,112,101,95,105,100,0,77,97,112,32,101,108,101,109,101,110,116,32,115,104,111,117,108,100,32,104,97,118,101,32,97,32,110,97,109,101,0,77,105,115,109,97,116,99,104,101,100,32,99,108,111,115,105,110,103,32,116,97,103,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,108,105,116,101,114,97,108,115,0,76,105,116,101,114,97,108,32,34,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,119,105,116,104,105,110,32,97,32,115,116,114,105,110,103,46,32,85,115,101,32,38,113,117,111,116,59,0,67,108,111,115,105,110,103,32,34,32,105,115,32,101,120,112,101,99,116,101,100,0,76,105,116,101,114,97,108,32,39,32,111,114,32,62,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,46,32,85,115,101,32,38,97,112,111,115,59,32,111,114,32,38,103,116,59,0,73,110,118,97,108,105,100,32,110,117,109,101,114,105,99,32,118,97,108,117,101,32,105,110,32,116,104,101,32,115,116,114,105,110,103,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,105,110,32,116,104,101,32,115,121,109,98,111,108,32,101,110,116,105,116,121,32,110,97,109,101,0,97,109,112,0,84,104,101,32,97,99,116,117,97,108,32,116,121,112,101,32,105,115,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,116,121,112,101,0,80,114,101,108,105,109,105,110,97,114,121,32,101,110,100,32,111,102,32,116,104,101,32,115,116,114,101,97,109,0,105,99,118,88,77,76,80,97,114,115,101,84,97,103,0,84,97,103,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,39,60,39,0,85,110,107,110,111,119,110,32,116,97,103,32,116,121,112,101,0,78,97,109,101,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,117,110,100,101,114,115,99,111,114,101,0,67,108,111,115,105,110,103,32,116,97,103,32,115,104,111,117,108,100,32,110,111,116,32,99,111,110,116,97,105,110,32,97,110,121,32,97,116,116,114,105,98,117,116,101,115,0,65,116,116,114,105,98,117,116,101,32,110,97,109,101,32,115,104,111,117,108,100,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,39,61,39,0,65,116,116,114,105,98,117,116,101,32,118,97,108,117,101,32,115,104,111,117,108,100,32,98,101,32,112,117,116,32,105,110,116,111,32,115,105,110,103,108,101,32,111,114,32,100,111,117,98,108,101,32,113,117,111,116,101,115,0,73,110,118,97,108,105,100,32,99,108,111,115,105,110,103,32,116,97,103,32,102,111,114,32,60,63,120,109,108,32,46,46,46,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,97,116,116,114,105,98,117,116,101,115,0,67,111,109,109,101,110,116,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,105,99,118,88,77,76,83,107,105,112,83,112,97,99,101,115,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,105,110,32,116,104,101,32,115,116,114,101,97,109,0,46,46,46,10,0,45,45,45,10,0,78,117,108,108,32,99,111,109,109,101,110,116,0,105,99,118,89,77,76,87,114,105,116,101,67,111,109,109,101,110,116,0,78,117,108,108,32,115,116,114,105,110,103,32,112,111,105,110,116,101,114,0,105,99,118,89,77,76,87,114,105,116,101,83,116,114,105,110,103,0,84,104,101,32,119,114,105,116,116,101,110,32,115,116,114,105,110,103,32,105,115,32,116,111,111,32,108,111,110,103,0,120,37,48,50,120,0,65,110,32,97,116,116,101,109,112,116,32,116,111,32,97,100,100,32,101,108,101,109,101,110,116,32,119,105,116,104,111,117,116,32,97,32,107,101,121,32,116,111,32,97,32,109,97,112,44,32,111,114,32,97,100,100,32,101,108,101,109,101,110,116,32,119,105,116,104,32,107,101,121,32,116,111,32,115,101,113,117,101,110,99,101,0,105,99,118,89,77,76,87,114,105,116,101,0,84,104,101,32,107,101,121,32,105,115,32,97,110,32,101,109,112,116,121,0,84,104,101,32,107,101,121,32,105,115,32,116,111,111,32,108,111,110,103,0,75,101,121,32,109,117,115,116,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,75,101,121,32,110,97,109,101,115,32,109,97,121,32,111,110,108,121,32,99,111,110,116,97,105,110,32,97,108,112,104,97,110,117,109,101,114,105,99,32,99,104,97,114,97,99,116,101,114,115,32,91,97,45,122,65,45,90,48,45,57,93,44,32,39,45,39,44,32,39,95,39,32,97,110,100,32,39,32,39,0,37,100,46,0,37,46,49,54,101,0,46,78,97,110,0,45,46,73,110,102,0,46,73,110,102,0,69,110,100,87,114,105,116,101,83,116,114,117,99,116,32,119,47,111,32,109,97,116,99,104,105,110,103,32,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,105,99,118,89,77,76,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,83,111,109,101,32,99,111,108,108,101,99,116,105,111,110,32,116,121,112,101,32,45,32,67,86,95,78,79,68,69,95,83,69,81,32,111,114,32,67,86,95,78,79,68,69,95,77,65,80,44,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,105,99,118,89,77,76,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,33,33,37,115,32,37,99,0,33,33,37,115,0,10,60,33,45,45,32,110,101,120,116,32,115,116,114,101,97,109,32,45,45,62,10,0,105,99,118,88,77,76,87,114,105,116,101,67,111,109,109,101,110,116,0,45,45,0,68,111,117,98,108,101,32,104,121,112,104,101,110,32,39,45,45,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,116,104,101,32,99,111,109,109,101,110,116,115,0,60,33,45,45,32,37,115,32,45,45,62,0,60,33,45,45,0,105,99,118,88,77,76,87,114,105,116,101,83,116,114,105,110,103,0,35,120,37,48,50,120,0,101,108,101,109,101,110,116,115,32,119,105,116,104,32,107,101,121,115,32,99,97,110,32,110,111,116,32,98,101,32,119,114,105,116,116,101,110,32,116,111,32,115,101,113,117,101,110,99,101,0,105,99,118,88,77,76,87,114,105,116,101,83,99,97,108,97,114,0,105,99,118,88,77,76,87,114,105,116,101,84,97,103,0,65,32,115,105,110,103,108,101,32,95,32,105,115,32,97,32,114,101,115,101,114,118,101,100,32,116,97,103,32,110,97,109,101,0,95,0,67,108,111,115,105,110,103,32,116,97,103,32,115,104,111,117,108,100,32,110,111,116,32,105,110,99,108,117,100,101,32,97,110,121,32,97,116,116,114,105,98,117,116,101,115,0,75,101,121,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,75,101,121,32,110,97,109,101,32,109,97,121,32,111,110,108,121,32,99,111,110,116,97,105,110,32,97,108,112,104,97,110,117,109,101,114,105,99,32,99,104,97,114,97,99,116,101,114,115,32,91,97,45,122,65,45,90,48,45,57,93,44,32,39,45,39,32,97,110,100,32,39,95,39,0,65,110,32,101,120,116,114,97,32,99,108,111,115,105,110,103,32,116,97,103,0,105,99,118,88,77,76,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,83,111,109,101,32,99,111,108,108,101,99,116,105,111,110,32,116,121,112,101,58,32,67,86,95,78,79,68,69,95,83,69,81,32,111,114,32,67,86,95,78,79,68,69,95,77,65,80,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,105,99,118,88,77,76,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,105,99,118,71,101,116,115,0,99,118,82,101,108,101,97,115,101,70,105,108,101,83,116,111,114,97,103,101,0,78,50,99,118,49,49,70,105,108,101,83,116,111,114,97,103,101,69,0,111,112,101,110,99,118,45,115,101,113,117,101,110,99,101,0,111,112,101,110,99,118,45,115,101,113,117,101,110,99,101,45,116,114,101,101,0,111,112,101,110,99,118,45,103,114,97,112,104,0,111,112,101,110,99,118,45,115,112,97,114,115,101,45,109,97,116,114,105,120,0,111,112,101,110,99,118,45,105,109,97,103,101,0,111,112,101,110,99,118,45,109,97,116,114,105,120,0,111,112,101,110,99,118,45,110,100,45,109,97,116,114,105,120,0,115,105,122,101,115,0,105,0,117,99,119,115,105,102,100,114,0,37,100,37,99,0,100,116,0,100,97,116,97,0,99,118,87,114,105,116,101,83,116,114,105,110,103,0,99,118,87,114,105,116,101,82,97,119,68,97,116,97,0,78,101,103,97,116,105,118,101,32,110,117,109,98,101,114,32,111,102,32,101,108,101,109,101,110,116,115,0,78,117,108,108,32,100,97,116,97,32,112,111,105,110,116,101,114,0,37,46,56,101,0,73,110,118,97,108,105,100,32,100,97,116,97,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,0,105,99,118,68,101,99,111,100,101,70,111,114,109,97,116,0,84,111,111,32,108,111,110,103,32,100,97,116,97,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,0,99,118,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,109,97,116,114,105,120,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,77,97,116,78,68,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,116,104,101,32,109,97,116,114,105,120,32,100,105,109,101,110,115,105,111,110,97,108,105,116,121,0,84,104,101,32,109,97,116,114,105,120,32,100,97,116,97,32,105,115,32,110,111,116,32,102,111,117,110,100,32,105,110,32,102,105,108,101,32,115,116,111,114,97,103,101,0,84,104,101,32,109,97,116,114,105,120,32,115,105,122,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,111,114,101,100,32,101,108,101,109,101,110,116,115,0,84,111,111,32,99,111,109,112,108,101,120,32,102,111,114,109,97,116,32,102,111,114,32,116,104,101,32,109,97,116,114,105,120,0,105,99,118,68,101,99,111,100,101,83,105,109,112,108,101,70,111,114,109,97,116,0,78,117,108,108,32,112,111,105,110,116,101,114,115,32,116,111,32,115,111,117,114,99,101,32,102,105,108,101,32,110,111,100,101,32,111,114,32,100,101,115,116,105,110,97,116,105,111,110,32,97,114,114,97,121,0,99,118,82,101,97,100,82,97,119,68,97,116,97,0,99,118,82,101,97,100,82,97,119,68,97,116,97,83,108,105,99,101,0,78,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,114,101,97,100,101,114,32,111,114,32,100,101,115,116,105,110,97,116,105,111,110,32,97,114,114,97,121,0,84,104,101,32,114,101,97,100,101,100,32,115,101,113,117,101,110,99,101,32,105,115,32,97,32,115,99,97,108,97,114,44,32,116,104,117,115,32,108,101,110,32,109,117,115,116,32,98,101,32,49,0,84,104,101,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,105,115,32,110,111,116,32,97,32,110,117,109,101,114,105,99,97,108,32,115,99,97,108,97,114,0,84,104,101,32,115,101,113,117,101,110,99,101,32,115,108,105,99,101,32,100,111,101,115,32,110,111,116,32,102,105,116,32,97,110,32,105,110,116,101,103,101,114,32,110,117,109,98,101,114,32,111,102,32,114,101,99,111,114,100,115,0,99,118,83,116,97,114,116,82,101,97,100,82,97,119,68,97,116,97,0,78,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,115,111,117,114,99,101,32,102,105,108,101,32,110,111,100,101,32,111,114,32,114,101,97,100,101,114,0,84,104,101,32,102,105,108,101,32,110,111,100,101,32,115,104,111,117,108,100,32,98,101,32,97,32,110,117,109,101,114,105,99,97,108,32,115,99,97,108,97,114,32,111,114,32,97,32,115,101,113,117,101,110,99,101,0,99,118,71,101,116,70,105,108,101,78,111,100,101,66,121,78,97,109,101,0,78,117,108,108,32,101,108,101,109,101,110,116,32,110,97,109,101,0,114,111,119,115,0,99,111,108,115,0,99,118,87,114,105,116,101,73,110,116,0,105,99,118,82,101,97,100,77,97,116,0,73,109,97,103,101,115,32,119,105,116,104,32,112,108,97,110,97,114,32,100,97,116,97,32,108,97,121,111,117,116,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,105,99,118,87,114,105,116,101,73,109,97,103,101,0,116,111,112,45,108,101,102,116,0,98,111,116,116,111,109,45,108,101,102,116,0,111,114,105,103,105,110,0,112,108,97,110,97,114,0,105,110,116,101,114,108,101,97,118,101,100,0,108,97,121,111,117,116,0,114,111,105,0,120,0,121,0,99,111,105,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,105,109,97,103,101,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,73,109,97,103,101,0,79,110,108,121,32,105,110,116,101,114,108,101,97,118,101,100,32,105,109,97,103,101,115,32,99,97,110,32,98,101,32,114,101,97,100,0,84,104,101,32,105,109,97,103,101,32,100,97,116,97,32,105,115,32,110,111,116,32,102,111,117,110,100,32,105,110,32,102,105,108,101,32,115,116,111,114,97,103,101,0,105,99,118,82,101,97,100,83,112,97,114,115,101,77,97,116,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,112,97,114,115,101,32,109,97,116,114,105,120,32,100,105,109,101,110,115,105,111,110,97,108,105,116,121,0,83,112,97,114,115,101,32,109,97,116,114,105,120,32,100,97,116,97,32,105,115,32,99,111,114,114,117,112,116,101,100,0,111,114,105,101,110,116,101,100,0,102,108,97,103,115,0,118,101,114,116,101,120,95,99,111,117,110,116,0,118,101,114,116,101,120,95,100,116,0,101,100,103,101,95,99,111,117,110,116,0,101,100,103,101,95,100,116,0,50,105,102,37,115,0,118,101,114,116,105,99,101,115,0,101,100,103,101,115,0,104,101,97,100,101,114,95,100,116,0,84,104,101,32,115,105,122,101,32,111,102,32,104,101,97,100,101,114,32,99,97,108,99,117,108,97,116,101,100,32,102,114,111,109,32,34,104,101,97,100,101,114,95,100,116,34,32,105,115,32,103,114,101,97,116,101,114,32,116,104,97,110,32,104,101,97,100,101,114,95,115,105,122,101,0,105,99,118,87,114,105,116,101,72,101,97,100,101,114,68,97,116,97,0,99,111,108,111,114,0,37,117,105,0,37,117,117,0,104,101,97,100,101,114,95,117,115,101,114,95,100,97,116,97,0,84,104,101,32,115,105,122,101,32,111,102,32,101,108,101,109,101,110,116,32,99,97,108,99,117,108,97,116,101,100,32,102,114,111,109,32,34,100,116,34,32,97,110,100,32,116,104,101,32,101,108,101,109,95,115,105,122,101,32,100,111,32,110,111,116,32,109,97,116,99,104,0,105,99,118,71,101,116,70,111,114,109,97,116,0,83,105,122,101,32,111,102,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,40,101,108,101,109,95,115,105,122,101,41,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,32,119,105,116,104,32,115,101,113,45,62,102,108,97,103,115,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,103,114,97,112,104,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,71,114,97,112,104,0,84,104,101,32,115,101,113,117,101,110,99,101,32,102,108,97,103,115,32,97,114,101,32,105,110,118,97,108,105,100,0,79,110,101,32,111,102,32,34,104,101,97,100,101,114,95,100,116,34,32,97,110,100,32,34,104,101,97,100,101,114,95,117,115,101,114,95,100,97,116,97,34,32,105,115,32,116,104,101,114,101,44,32,119,104,105,108,101,32,116,104,101,32,111,116,104,101,114,32,105,115,32,110,111,116,0,71,114,97,112,104,32,101,100,103,101,115,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,50,32,105,110,116,101,103,101,114,115,32,97,110,100,32,97,32,102,108,111,97,116,0,37,100,102,37,115,0,78,111,32,101,100,103,101,115,32,100,97,116,97,0,78,111,32,118,101,114,116,105,99,101,115,32,100,97,116,97,0,83,111,109,101,32,111,102,32,115,116,111,114,101,100,32,118,101,114,116,101,120,32,105,110,100,105,99,101,115,32,97,114,101,32,111,117,116,32,111,102,32,114,97,110,103,101,0,68,117,112,108,105,99,97,116,101,100,32,101,100,103,101,32,104,97,115,32,111,99,99,117,114,101,100,0,78,85,76,76,32,100,111,117,98,108,101,32,112,111,105,110,116,101,114,0,105,99,118,82,101,108,101,97,115,101,71,114,97,112,104,0,115,101,113,117,101,110,99,101,115,0,111,112,101,110,99,118,45,115,101,113,117,101,110,99,101,45,116,114,101,101,32,105,110,115,116,97,110,99,101,32,115,104,111,117,108,100,32,99,111,110,116,97,105,110,32,97,32,102,105,101,108,100,32,34,115,101,113,117,101,110,99,101,115,34,32,116,104,97,116,32,115,104,111,117,108,100,32,98,101,32,97,32,115,101,113,117,101,110,99,101,0,105,99,118,82,101,97,100,83,101,113,84,114,101,101,0,108,101,118,101,108,0,65,108,108,32,116,104,101,32,115,101,113,117,101,110,99,101,32,116,114,101,101,32,110,111,100,101,115,32,115,104,111,117,108,100,32,99,111,110,116,97,105,110,32,34,108,101,118,101,108,34,32,102,105,101,108,100,0,99,118,82,101,97,100,0,84,104,101,32,110,111,100,101,32,100,111,101,115,32,110,111,116,32,114,101,112,114,101,115,101,110,116,32,97,32,117,115,101,114,32,111,98,106,101,99,116,32,40,117,110,107,110,111,119,110,32,116,121,112,101,63,41,0,73,110,118,97,108,105,100,32,116,121,112,101,32,105,110,102,111,0,99,118,82,101,103,105,115,116,101,114,84,121,112,101,0,83,111,109,101,32,111,102,32,114,101,113,117,105,114,101,100,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,115,32,40,105,115,95,105,110,115,116,97,110,99,101,44,32,114,101,108,101,97,115,101,44,32,114,101,97,100,32,111,114,32,119,114,105,116,101,41,32,97,114,101,32,78,85,76,76,0,84,121,112,101,32,110,97,109,101,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,84,121,112,101,32,110,97,109,101,32,115,104,111,117,108,100,32,99,111,110,116,97,105,110,32,111,110,108,121,32,108,101,116,116,101,114,115,44,32,100,105,103,105,116,115,44,32,45,32,97,110,100,32,95,0,114,101,99,117,114,115,105,118,101,0,48,0,70,97,108,115,101,0,70,65,76,83,69,0,32,104,111,108,101,0,32,99,117,114,118,101,0,32,117,110,116,121,112,101,100,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,115,101,113,117,101,110,99,101,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,83,101,113,0,99,117,114,118,101,0,99,108,111,115,101,100,0,104,111,108,101,0,117,110,116,121,112,101,100,0,79,110,108,121,32,111,110,101,32,111,102,32,34,104,101,97,100,101,114,95,117,115,101,114,95,100,97,116,97,34,44,32,34,114,101,99,116,34,32,97,110,100,32,34,111,114,105,103,105,110,34,32,116,97,103,115,32,109,97,121,32,111,99,99,117,114,0,84,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,111,114,101,100,32,101,108,101,109,101,110,116,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,111,32,34,99,111,117,110,116,34,0,105,99,118,82,101,108,101,97,115,101,83,101,113,0,46,103,122,0,73,110,118,97,108,105,100,32,102,105,108,101,110,97,109,101,0,103,101,116,68,101,102,97,117,108,116,79,98,106,101,99,116,78,97,109,101,0,99,118,71,101,116,82,111,111,116,70,105,108,101,78,111,100,101,0,99,118,87,114,105,116,101,82,101,97,108,0,99,118,87,114,105,116,101,67,111,109,109,101,110,116,0,99,118,82,101,108,101,97,115,101,0,85,110,107,110,111,119,110,32,111,98,106,101,99,116,32,116,121,112,101,0,114,101,108,101,97,115,101,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,99,118,87,114,105,116,101,0,78,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,116,104,101,32,119,114,105,116,116,101,110,32,111,98,106,101,99,116,0,85,110,107,110,111,119,110,32,111,98,106,101,99,116,0,84,104,101,32,111,98,106,101,99,116,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,119,114,105,116,101,32,102,117,110,99,116,105,111,110,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,116,104,101,47,97,110,32,111,98,106,101,99,116,32,105,110,32,102,105,108,101,32,115,116,111,114,97,103,101,0,99,118,76,111,97,100,0,78,85,76,76,32,109,101,109,111,114,121,32,115,116,111,114,97,103,101,32,105,115,32,112,97,115,115,101,100,32,45,32,116,104,101,32,108,111,97,100,101,100,32,100,121,110,97,109,105,99,32,115,116,114,117,99,116,117,114,101,32,99,97,110,32,110,111,116,32,98,101,32,115,116,111,114,101,100,0,69,120,116,114,97,32,99,108,111,115,105,110,103,32,39,37,99,39,0,84,104,101,32,99,108,111,115,105,110,103,32,39,37,99,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,111,112,101,110,105,110,103,32,39,37,99,39,0,73,110,99,111,114,114,101,99,116,32,101,108,101,109,101,110,116,32,110,97,109,101,32,37,115,0,73,110,118,97,108,105,100,32,102,115,46,115,116,97,116,101,0,108,101,110,32,37,32,101,108,101,109,83,105,122,101,32,61,61,32,48,0,119,114,105,116,101,82,97,119,0,101,108,101,109,95,115,105,122,101,32,62,32,48,0,114,101,97,100,82,97,119,0,85,110,107,110,111,119,110,32,97,114,114,97,121,32,116,121,112,101,0,95,112,97,114,97,109,49,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,40,95,112,97,114,97,109,49,46,114,111,119,115,32,61,61,32,49,32,124,124,32,95,112,97,114,97,109,49,46,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,95,112,97,114,97,109,49,46,114,111,119,115,32,43,32,95,112,97,114,97,109,49,46,99,111,108,115,32,45,32,49,32,61,61,32,99,110,32,124,124,32,95,112,97,114,97,109,49,46,114,111,119,115,32,43,32,95,112,97,114,97,109,49,46,99,111,108,115,32,45,32,49,32,61,61,32,49,32,124,124,32,40,95,112,97,114,97,109,49,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,38,38,32,95,112,97,114,97,109,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,32,38,38,32,99,110,32,60,61,32,52,41,41,0,102,105,108,108,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,114,97,110,100,46,99,112,112,0,95,112,97,114,97,109,50,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,40,40,40,95,112,97,114,97,109,50,46,114,111,119,115,32,61,61,32,49,32,124,124,32,95,112,97,114,97,109,50,46,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,95,112,97,114,97,109,50,46,114,111,119,115,32,43,32,95,112,97,114,97],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+219380);allocate([109,50,46,99,111,108,115,32,45,32,49,32,61,61,32,99,110,32,124,124,32,95,112,97,114,97,109,50,46,114,111,119,115,32,43,32,95,112,97,114,97,109,50,46,99,111,108,115,32,45,32,49,32,61,61,32,49,32,124,124,32,40,95,112,97,114,97,109,49,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,38,38,32,95,112,97,114,97,109,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,32,38,38,32,99,110,32,60,61,32,52,41,41,41,32,124,124,32,40,95,112,97,114,97,109,50,46,114,111,119,115,32,61,61,32,99,110,32,38,38,32,95,112,97,114,97,109,50,46,99,111,108,115,32,61,61,32,99,110,32,38,38,32,100,105,115,116,116,121,112,101,32,61,61,32,78,79,82,77,65,76,41,41,0,115,99,97,108,101,70,117,110,99,32,33,61,32,48,0,85,110,107,110,111,119,110,32,100,105,115,116,114,105,98,117,116,105,111,110,32,116,121,112,101,0,99,110,32,60,61,32,52,32,38,38,32,102,117,110,99,32,33,61,32,48,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,116,97,116,46,99,112,112,0,99,111,117,110,116,78,111,110,90,101,114,111,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,0,109,101,97,110,0,109,101,97,110,83,116,100,68,101,118,0,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,32,38,38,32,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,100,115,116,46,99,111,108,115,32,61,61,32,49,32,124,124,32,100,115,116,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,100,99,110,32,62,61,32,99,110,0,40,99,110,32,61,61,32,49,32,38,38,32,40,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,41,41,32,124,124,32,40,99,110,32,62,32,49,32,38,38,32,95,109,97,115,107,46,101,109,112,116,121,40,41,32,38,38,32,33,109,105,110,73,100,120,32,38,38,32,33,109,97,120,73,100,120,41,0,109,105,110,77,97,120,73,100,120,0,95,105,109,103,46,100,105,109,115,40,41,32,60,61,32,50,0,109,105,110,77,97,120,76,111,99,0,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,73,78,70,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,49,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,83,81,82,32,124,124,32,40,40,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,50,41,32,38,38,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,41,0,0,1,1,1,1,2,2,2,1,2,2,2,1,2,2,2,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,95,115,114,99,49,46,115,97,109,101,83,105,122,101,40,95,115,114,99,50,41,32,38,38,32,95,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,0,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,73,78,70,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,49,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,83,81,82,32,124,124,32,40,40,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,50,41,32,38,38,32,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,41,0,116,121,112,101,32,61,61,32,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,115,114,99,49,46,99,111,108,115,32,61,61,32,115,114,99,50,46,99,111,108,115,32,38,38,32,40,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,56,85,41,0,98,97,116,99,104,68,105,115,116,97,110,99,101,0,95,110,105,100,120,46,110,101,101,100,101,100,40,41,32,61,61,32,40,75,32,62,32,48,41,0,40,116,121,112,101,32,61,61,32,67,86,95,56,85,32,38,38,32,100,116,121,112,101,32,61,61,32,67,86,95,51,50,83,41,32,124,124,32,100,116,121,112,101,32,61,61,32,67,86,95,51,50,70,0,75,32,61,61,32,49,32,38,38,32,117,112,100,97,116,101,32,61,61,32,48,32,38,38,32,109,97,115,107,46,101,109,112,116,121,40,41,0,84,104,101,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,116,121,112,101,61,37,100,44,32,100,116,121,112,101,61,37,100,32,97,110,100,32,110,111,114,109,84,121,112,101,61,37,100,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,50,99,118,49,54,66,97,116,99,104,68,105,115,116,73,110,118,111,107,101,114,69,0,102,105,110,100,78,111,110,90,101,114,111,0,105,100,120,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,95,115,114,99,49,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,0,80,83,78,82,0,78,50,99,118,57,69,120,99,101,112,116,105,111,110,69,0,107,101,121,95,32,61,61,32,45,49,0,126,84,76,83,68,97,116,97,67,111,110,116,97,105,110,101,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,121,115,116,101,109,46,99,112,112,0,115,116,97,116,117,115,0,101,114,114,111,114,0,85,110,107,110,111,119,110,32,37,115,32,99,111,100,101,32,37,100,0,79,112,101,110,71,76,32,65,80,73,32,99,97,108,108,0,78,111,32,79,112,101,110,71,76,32,115,117,112,112,111,114,116,0,71,112,117,32,65,80,73,32,99,97,108,108,0,78,111,32,67,85,68,65,32,115,117,112,112,111,114,116,0,65,115,115,101,114,116,105,111,110,32,102,97,105,108,101,100,0,77,101,109,111,114,121,32,98,108,111,99,107,32,104,97,115,32,98,101,101,110,32,99,111,114,114,117,112,116,101,100,0,84,104,101,32,102,117,110,99,116,105,111,110,47,102,101,97,116,117,114,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,80,97,114,115,105,110,103,32,101,114,114,111,114,0,66,97,100,32,116,121,112,101,32,111,102,32,109,97,115,107,32,97,114,103,117,109,101,110,116,0,66,97,100,32,112,97,114,97,109,101,116,101,114,32,111,102,32,116,121,112,101,32,67,118,80,111,105,110,116,0,66,97,100,32,102,108,97,103,32,40,112,97,114,97,109,101,116,101,114,32,111,114,32,115,116,114,117,99,116,117,114,101,32,102,105,101,108,100,41,0,66,97,100,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,0,73,110,112,117,116,32,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,85,110,115,117,112,112,111,114,116,101,100,32,102,111,114,109,97,116,32,111,114,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,102,111,114,109,97,116,115,0,79,110,101,32,111,102,32,97,114,103,117,109,101,110,116,115,39,32,118,97,108,117,101,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,83,105,122,101,115,32,111,102,32,105,110,112,117,116,32,97,114,103,117,109,101,110,116,115,32,100,111,32,110,111,116,32,109,97,116,99,104,0,70,111,114,109,97,116,115,32,111,102,32,105,110,112,117,116,32,97,114,103,117,109,101,110,116,115,32,100,111,32,110,111,116,32,109,97,116,99,104,0,73,110,112,117,116,32,105,109,97,103,101,32,100,101,112,116,104,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,102,117,110,99,116,105,111,110,0,82,101,113,117,101,115,116,101,100,32,111,98,106,101,99,116,32,119,97,115,32,110,111,116,32,102,111,117,110,100,0,73,110,112,108,97,99,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,73,109,97,103,101,32,115,116,101,112,32,105,115,32,119,114,111,110,103,0,68,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,111,99,99,117,114,101,100,0,78,117,108,108,32,112,111,105,110,116,101,114,0,73,110,99,111,114,114,101,99,116,32,115,105,122,101,32,111,102,32,105,110,112,117,116,32,97,114,114,97,121,0,65,117,116,111,116,114,97,99,101,32,99,97,108,108,0,73,116,101,114,97,116,105,111,110,115,32,100,111,32,110,111,116,32,99,111,110,118,101,114,103,101,0,66,97,100,32,97,114,103,117,109,101,110,116,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,0,85,110,115,112,101,99,105,102,105,101,100,32,101,114,114,111,114,0,66,97,99,107,116,114,97,99,101,0,78,111,32,69,114,114,111,114,0,117,110,107,110,111,119,110,32,102,117,110,99,116,105,111,110,0,79,112,101,110,67,86,32,69,114,114,111,114,58,32,37,115,32,40,37,115,41,32,105,110,32,37,115,44,32,102,105,108,101,32,37,115,44,32,108,105,110,101,32,37,100,0,37,115,58,37,100,58,32,101,114,114,111,114,58,32,40,37,100,41,32,37,115,32,105,110,32,102,117,110,99,116,105,111,110,32,37,115,10,0,37,115,58,37,100,58,32,101,114,114,111,114,58,32,40,37,100,41,32,37,115,10,0,78,50,99,118,49,54,84,76,83,68,97,116,97,67,111,110,116,97,105,110,101,114,69,0,116,108,115,83,108,111,116,115,46,115,105,122,101,40,41,32,62,32,115,108,111,116,73,100,120,32,38,38,32,112,68,97,116,97,32,33,61,32,78,85,76,76,0,112,116,104,114,101,97,100,95,115,101,116,115,112,101,99,105,102,105,99,40,116,108,115,75,101,121,44,32,112,68,97,116,97,41,32,61,61,32,48,0,83,101,116,68,97,116,97,0,116,108,115,83,108,111,116,115,46,115,105,122,101,40,41,32,62,32,115,108,111,116,73,100,120,0,103,101,116,68,97,116,97,0,112,116,104,114,101,97,100,95,107,101,121,95,99,114,101,97,116,101,40,38,116,108,115,75,101,121,44,32,78,85,76,76,41,32,61,61,32,48,0,84,108,115,65,98,115,116,114,97,99,116,105,111,110,0,114,101,108,101,97,115,101,83,108,111,116,0,78,50,99,118,55,84,76,83,68,97,116,97,73,78,83,95,49,49,67,111,114,101,84,76,83,68,97,116,97,69,69,69,0,79,80,69,78,67,86,95,84,69,77,80,95,80,65,84,72,0,47,116,109,112,47,95,95,111,112,101,110,99,118,95,116,101,109,112,46,88,88,88,88,88,88,0,95,95,111,112,101,110,99,118,95,116,101,109,112,46,88,88,88,88,88,88,0,107,101,121,112,111,105,110,116,73,110,100,101,120,101,115,32,104,97,115,32,101,108,101,109,101,110,116,32,60,32,48,46,32,84,79,68,79,58,32,112,114,111,99,101,115,115,32,116,104,105,115,32,99,97,115,101,0,99,111,110,118,101,114,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,116,121,112,101,115,46,99,112,112,0,109,97,112,99,111,117,110,116,32,61,61,32,48,0,126,85,77,97,116,68,97,116,97,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,117,109,97,116,114,105,120,46,99,112,112,0,48,32,60,61,32,95,100,105,109,115,32,38,38,32,95,100,105,109,115,32,60,61,32,67,86,95,77,65,88,95,68,73,77,0,115,101,116,83,105,122,101,0,115,32,62,61,32,48,0,84,104,101,32,116,111,116,97,108,32,109,97,116,114,105,120,32,115,105,122,101,32,100,111,101,115,32,110,111,116,32,102,105,116,32,116,111,32,34,115,105,122,101,95,116,34,32,116,121,112,101,0,100,97,116,97,32,61,61,32,100,97,116,97,115,116,97,114,116,0,103,101,116,85,77,97,116,0,97,108,108,111,99,97,116,101,100,0,109,46,100,105,109,115,32,60,61,32,50,0,85,77,97,116,0,48,32,60,61,32,114,111,105,46,120,32,38,38,32,48,32,60,61,32,114,111,105,46,119,105,100,116,104,32,38,38,32,114,111,105,46,120,32,43,32,114,111,105,46,119,105,100,116,104,32,60,61,32,109,46,99,111,108,115,32,38,38,32,48,32,60,61,32,114,111,105,46,121,32,38,38,32,48,32,60,61,32,114,111,105,46,104,101,105,103,104,116,32,38,38,32,114,111,105,46,121,32,43,32,114,111,105,46,104,101,105,103,104,116,32,60,61,32,109,46,114,111,119,115,0,48,32,60,61,32,100,32,38,38,32,100,32,60,61,32,67,86,95,77,65,88,95,68,73,77,32,38,38,32,95,115,105,122,101,115,0,117,32,33,61,32,48,0,115,116,101,112,91,100,105,109,115,45,49,93,32,61,61,32,40,115,105,122,101,95,116,41,67,86,95,69,76,69,77,95,83,73,90,69,40,102,108,97,103,115,41,0,99,104,97,110,110,101,108,115,40,41,32,61,61,32,67,86,95,77,65,84,95,67,78,40,100,116,121,112,101,41,0,99,111,112,121,84,111,0,117,45,62,100,97,116,97,32,33,61,32,48,32,38,38,32,34,69,114,114,111,114,32,109,97,112,112,105,110,103,32,111,102,32,85,77,97,116,32,116,111,32,104,111,115,116,32,109,101,109,111,114,121,46,34,0,103,101,116,77,97,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,114,114,97,121,46,99,112,112,0,68,97,116,97,32,105,115,32,97,108,114,101,97,100,121,32,97,108,108,111,99,97,116,101,100,0,99,118,67,114,101,97,116,101,68,97,116,97,0,84,111,111,32,98,105,103,32,98,117,102,102,101,114,32,105,115,32,97,108,108,111,99,97,116,101,100,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,78,111,110,45,112,111,115,105,116,105,118,101,32,119,105,100,116,104,32,111,114,32,104,101,105,103,104,116,0,99,118,67,114,101,97,116,101,77,97,116,72,101,97,100,101,114,0,73,110,118,97,108,105,100,32,109,97,116,114,105,120,32,116,121,112,101,0,99,118,73,110,105,116,77,97,116,72,101,97,100,101,114,0,78,111,110,45,112,111,115,105,116,105,118,101,32,99,111,108,115,32,111,114,32,114,111,119,115,0,99,118,82,101,108,101,97,115,101,77,97,116,0,66,97,100,32,67,118,77,97,116,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,77,97,116,0,78,85,76,76,32,109,97,116,114,105,120,32,104,101,97,100,101,114,32,112,111,105,110,116,101,114,0,99,118,73,110,105,116,77,97,116,78,68,72,101,97,100,101,114,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,100,97,116,97,32,116,121,112,101,0,78,85,76,76,32,60,115,105,122,101,115,62,32,112,111,105,110,116,101,114,0,110,111,110,45,112,111,115,105,116,105,118,101,32,111,114,32,116,111,111,32,108,97,114,103,101,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,0,111,110,101,32,111,102,32,100,105,109,101,115,105,111,110,32,115,105,122,101,115,32,105,115,32,110,111,110,45,112,111,115,105,116,105,118,101,0,84,104,101,32,97,114,114,97,121,32,105,115,32,116,111,111,32,98,105,103,0,99,118,67,114,101,97,116,101,77,97,116,78,68,72,101,97,100,101,114,0,66,97,100,32,67,118,77,97,116,78,68,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,77,97,116,78,68,0,115,114,99,45,62,100,105,109,115,32,60,61,32,67,86,95,77,65,88,95,68,73,77,0,95,100,115,116,46,100,97,116,97,32,61,61,32,100,97,116,97,48,0,99,118,73,110,105,116,78,65,114,114,97,121,73,116,101,114,97,116,111,114,0,83,111,109,101,32,111,102,32,114,101,113,117,105,114,101,100,32,97,114,114,97,121,32,112,111,105,110,116,101,114,115,32,105,115,32,78,85,76,76,0,67,79,73,32,115,101,116,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,78,85,76,76,32,97,114,114,97,121,32,112,111,105,110,116,101,114,32,105,115,32,112,97,115,115,101,100,0,99,118,71,101,116,77,97,116,78,68,0,84,104,101,32,109,97,116,114,105,120,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,85,110,114,101,99,111,103,110,105,122,101,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,73,110,112,117,116,32,97,114,114,97,121,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,99,118,71,101,116,77,97,116,0,84,104,101,32,105,109,97,103,101,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,73,109,97,103,101,115,32,119,105,116,104,32,112,108,97,110,97,114,32,100,97,116,97,32,108,97,121,111,117,116,32,115,104,111,117,108,100,32,98,101,32,117,115,101,100,32,119,105,116,104,32,67,79,73,32,115,101,108,101,99,116,101,100,0,84,104,101,32,105,109,97,103,101,32,105,115,32,105,110,116,101,114,108,101,97,118,101,100,32,97,110,100,32,104,97,115,32,111,118,101,114,32,67,86,95,67,78,95,77,65,88,32,99,104,97,110,110,101,108,115,0,80,105,120,101,108,32,111,114,100,101,114,32,115,104,111,117,108,100,32,98,101,32,117,115,101,100,32,119,105,116,104,32,99,111,105,32,61,61,32,48,0,79,110,108,121,32,99,111,110,116,105,110,117,111,117,115,32,110,68,32,97,114,114,97,121,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,32,104,101,114,101,0,99,118,67,114,101,97,116,101,83,112,97,114,115,101,77,97,116,0,98,97,100,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,0,99,118,82,101,108,101,97,115,101,83,112,97,114,115,101,77,97,116,0,73,110,118,97,108,105,100,32,115,112,97,114,115,101,32,97,114,114,97,121,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,83,112,97,114,115,101,77,97,116,0,73,110,118,97,108,105,100,32,115,112,97,114,115,101,32,109,97,116,114,105,120,32,104,101,97,100,101,114,0,99,118,73,110,105,116,83,112,97,114,115,101,77,97,116,73,116,101,114,97,116,111,114,0,78,85,76,76,32,105,116,101,114,97,116,111,114,32,112,111,105,110,116,101,114,0,99,118,82,101,108,101,97,115,101,68,97,116,97,0,105,110,100,101,120,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,99,118,80,116,114,50,68,0,67,79,73,32,109,117,115,116,32,98,101,32,110,111,110,45,110,117,108,108,32,105,110,32,99,97,115,101,32,111,102,32,112,108,97,110,97,114,32,105,109,97,103,101,115,0,79,110,101,32,111,102,32,105,110,100,105,99,101,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,105,99,118,71,101,116,78,111,100,101,80,116,114,0,99,118,71,101,116,69,108,101,109,84,121,112,101,0,99,118,71,101,116,68,105,109,115,0,65,114,114,97,121,32,115,104,111,117,108,100,32,98,101,32,67,118,77,97,116,32,111,114,32,73,112,108,73,109,97,103,101,0,99,118,71,101,116,83,105,122,101,0,99,118,71,101,116,67,111,108,115,0,99,118,80,116,114,78,68,0,84,104,101,32,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,32,105,115,32,110,111,116,32,100,105,118,105,115,105,98,108,101,32,98,121,32,116,104,101,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,0,99,118,82,101,115,104,97,112,101,0,84,104,101,32,109,97,116,114,105,120,32,105,115,32,110,111,116,32,99,111,110,116,105,110,117,111,117,115,44,32,116,104,117,115,32,105,116,115,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,32,99,97,110,32,110,111,116,32,98,101,32,99,104,97,110,103,101,100,0,66,97,100,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,0,84,104,101,32,116,111,116,97,108,32,119,105,100,116,104,32,105,115,32,110,111,116,32,100,105,118,105,115,105,98,108,101,32,98,121,32,116,104,101,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,0,110,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,104,101,97,100,101,114,0,99,118,73,110,105,116,73,109,97,103,101,72,101,97,100,101,114,0,66,97,100,32,105,110,112,117,116,32,114,111,105,0,85,110,115,117,112,112,111,114,116,101,100,32,102,111,114,109,97,116,0,71,82,65,89,0,82,71,66,0,66,71,82,0,66,71,82,65,0,99,118,82,101,108,101,97,115,101,73,109,97,103,101,0,99,118,83,101,116,73,109,97,103,101,82,79,73,0,114,101,99,116,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,114,101,99,116,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,114,101,99,116,46,120,32,60,32,105,109,97,103,101,45,62,119,105,100,116,104,32,38,38,32,114,101,99,116,46,121,32,60,32,105,109,97,103,101,45,62,104,101,105,103,104,116,32,38,38,32,114,101,99,116,46,120,32,43,32,114,101,99,116,46,119,105,100,116,104,32,62,61,32,40,105,110,116,41,40,114,101,99,116,46,119,105,100,116,104,32,62,32,48,41,32,38,38,32,114,101,99,116,46,121,32,43,32,114,101,99,116,46,104,101,105,103,104,116,32,62,61,32,40,105,110,116,41,40,114,101,99,116,46,104,101,105,103,104,116,32,62,32,48,41,0,99,118,83,101,116,73,109,97,103,101,67,79,73,0,66,97,100,32,105,109,97,103,101,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,73,109,97,103,101,0,84,104,101,32,108,105,98,114,97,114,121,32,105,115,32,99,111,109,112,105,108,101,100,32,119,105,116,104,111,117,116,32,67,85,68,65,32,115,117,112,112,111,114,116,0,116,104,114,111,119,95,110,111,95,99,117,100,97,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,112,114,105,118,97,116,101,46,99,117,100,97,46,104,112,112,0,95,115,114,99,46,115,97,109,101,83,105,122,101,40,95,100,115,116,41,32,38,38,32,100,99,110,32,61,61,32,115,99,110,0,97,99,99,117,109,117,108,97,116,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,97,99,99,117,109,46,99,112,112,0,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,95,115,114,99,46,115,97,109,101,83,105,122,101,40,95,109,97,115,107,41,32,38,38,32,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,41,0,97,99,99,117,109,117,108,97,116,101,83,113,117,97,114,101,0,95,115,114,99,49,46,115,97,109,101,83,105,122,101,40,95,115,114,99,50,41,32,38,38,32,115,116,121,112,101,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,0,97,99,99,117,109,117,108,97,116,101,80,114,111,100,117,99,116,0,95,115,114,99,49,46,115,97,109,101,83,105,122,101,40,95,100,115,116,41,32,38,38,32,100,99,110,32,61,61,32,115,99,110,0,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,95,115,114,99,49,46,115,97,109,101,83,105,122,101,40,95,109,97,115,107,41,32,38,38,32,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,41,0,97,99,99,117,109,117,108,97,116,101,87,101,105,103,104,116,101,100,0,67,86,95,73,83,95,83,69,81,95,67,72,65,73,78,95,67,79,78,84,79,85,82,40,32,99,104,97,105,110,32,41,0,105,99,118,65,112,112,114,111,120,105,109,97,116,101,67,104,97,105,110,84,67,56,57,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,97,112,112,114,111,120,46,99,112,112,0,104,101,97,100,101,114,95,115,105,122,101,32,62,61,32,40,105,110,116,41,115,105,122,101,111,102,40,67,118,67,111,110,116,111,117,114,41,0,110,112,111,105,110,116,115,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,41,0,97,112,112,114,111,120,80,111,108,121,68,80,0,67,97,110,110,121,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,97,110,110,121,46,99,112,112,0,65,112,101,114,116,117,114,101,32,115,105,122,101,32,115,104,111,117,108,100,32,98,101,32,111,100,100,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,0,99,118,67,97,110,110,121,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,48,67,76,65,72,69,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,85,67,49,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,108,97,104,101,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,116,121,112,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,116,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,116,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,104,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,104,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,116,76,105,52,48,57,54,69,76,105,52,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,116,76,105,52,48,57,54,69,76,105,52,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,104,76,105,50,53,54,69,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,104,76,105,50,53,54,69,76,105,48,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,48,67,76,65,72,69,95,73,109,112,108,69,0,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,49,54,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,0,99,118,116,67,111,108,111,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,46,99,112,112,0,115,99,110,32,61,61,32,51,32,124,124,32,115,99,110,32,61,61,32,52,0,40,115,99,110,32,61,61,32,51,32,124,124,32,115,99,110,32,61,61,32,52,41,32,38,38,32,100,101,112,116,104,32,61,61,32,67,86,95,56,85,0,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,32,38,38,32,115,99,110,32,61,61,32,50,32,38,38,32,100,101,112,116,104,32,61,61,32,67,86,95,56,85,0,115,99,110,32,61,61,32,50,32,38,38,32,100,101,112,116,104,32,61,61,32,67,86,95,56,85,0,115,99,110,32,61,61,32,49,32,38,38,32,100,101,112,116,104,32,61,61,32,67,86,95,56,85,0,115,99,110,32,61,61,32,51,32,38,38,32,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,0,40,115,99,110,32,61,61,32,51,32,124,124,32,115,99,110,32,61,61,32,52,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,41,0,104,114,97,110,103,101,32,61,61,32,49,56,48,32,124,124,32,104,114,97,110,103,101,32,61,61,32,50,53,54,0,82,71,66,50,72,83,86,95,98,0,115,99,110,32,61,61,32,51,32,38,38,32,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,41,0,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,0,115,122,46,119,105,100,116,104,32,37,32,50,32,61,61,32,48,32,38,38,32,115,122,46,104,101,105,103,104,116,32,37,32,51,32,61,61,32,48,32,38,38,32,100,101,112,116,104,32,61,61,32,67,86,95,56,85,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,99,111,110,118,101,114,115,105,111,110,32,99,111,100,101,0,115,122,46,119,105,100,116,104,32,37,32,50,32,61,61,32,48,32,38,38,32,115,122,46,104,101,105,103,104,116,32,37,32,50,32,61,61,32,48,0,115,99,110,32,61,61,32,52,32,38,38,32,100,99,110,32,61,61,32,52,0,85,110,115,117,112,112,111,114,116,101,100,32,105,109,97,103,101,32,100,101,112,116,104,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,109,82,71,66,65,50,82,71,66,65,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,65,50,109,82,71,66,65,73,104,69,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,76,105,49,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,76,105,49,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,76,105,49,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,76,105,49,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,50,82,71,66,56,56,56,116,111,89,85,86,52,50,48,112,73,110,118,111,107,101,114,73,76,105,50,69,69,69,0,78,50,99,118,50,50,82,71,66,56,56,56,116,111,89,85,86,52,50,48,112,73,110,118,111,107,101,114,73,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,48,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,48,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,48,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,48,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,117,118,50,82,71,66,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,117,118,50,82,71,66,95,98,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,97,98,50,82,71,66,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,97,98,50,82,71,66,95,98,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,117,118,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,117,118,95,98,69,69,69,0,99,111,101,102,102,115,91,105,42,51,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,62,61,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+229620);allocate([48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,93,32,43,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,43,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,60,32,49,46,53,102,0,82,71,66,50,76,117,118,95,102,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,97,98,95,102,69,69,69,0,99,111,101,102,102,115,91,106,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,106,32,43,32,49,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,106,32,43,32,50,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,106,93,32,43,32,99,111,101,102,102,115,91,106,32,43,32,49,93,32,43,32,99,111,101,102,102,115,91,106,32,43,32,50,93,32,60,32,49,46,53,102,42,76,97,98,67,98,114,116,84,97,98,83,99,97,108,101,0,82,71,66,50,76,97,98,95,102,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,97,98,95,98,69,69,69,0,99,111,101,102,102,115,91,105,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,93,32,43,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,43,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,60,32,50,42,40,49,32,60,60,32,108,97,98,95,115,104,105,102,116,41,0,82,71,66,50,76,97,98,95,98,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,76,83,50,82,71,66,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,76,83,50,82,71,66,95,98,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,83,86,50,82,71,66,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,83,86,50,82,71,66,95,98,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,76,83,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,76,83,95,98,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,83,86,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,83,86,95,98,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,102,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,105,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,105,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,102,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,105,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,105,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,102,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,105,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,105,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,102,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,105,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,105,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,71,114,97,121,50,82,71,66,53,120,53,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,53,120,53,50,71,114,97,121,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,53,120,53,50,82,71,66,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,50,82,71,66,53,120,53,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,104,69,69,69,69,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,0,99,118,67,118,116,67,111,108,111,114,0,100,115,116,46,100,97,116,97,32,61,61,32,100,115,116,48,46,100,97,116,97,0,99,118,58,58,76,85,84,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,116,97,98,108,101,115,32,111,102,32,115,105,122,101,32,50,53,54,46,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,109,97,112,46,99,112,112,0,40,120,46,116,121,112,101,40,41,32,61,61,32,89,46,116,121,112,101,40,41,41,32,38,38,32,40,89,46,116,121,112,101,40,41,32,61,61,32,120,105,46,116,121,112,101,40,41,41,0,105,110,116,101,114,112,49,0,40,120,46,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,120,46,114,111,119,115,32,61,61,32,89,46,114,111,119,115,41,32,38,38,32,40,120,46,99,111,108,115,32,61,61,32,89,46,99,111,108,115,41,0,99,118,58,58,115,111,114,116,82,111,119,115,66,121,73,110,100,105,99,101,115,32,111,110,108,121,32,119,111,114,107,115,32,111,110,32,105,110,116,101,103,101,114,32,105,110,100,105,99,101,115,33,0,115,111,114,116,77,97,116,114,105,120,82,111,119,115,66,121,73,110,100,105,99,101,115,0,99,118,58,58,97,114,103,115,111,114,116,32,111,110,108,121,32,115,111,114,116,115,32,49,68,32,109,97,116,114,105,99,101,115,46,0,97,114,103,115,111,114,116,0,85,110,107,110,111,119,110,32,99,111,108,111,114,109,97,112,32,105,100,59,32,117,115,101,32,111,110,101,32,111,102,32,67,79,76,79,82,77,65,80,95,42,0,97,112,112,108,121,67,111,108,111,114,77,97,112,0,78,50,99,118,56,99,111,108,111,114,109,97,112,54,87,105,110,116,101,114,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,56,67,111,108,111,114,77,97,112,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,54,83,117,109,109,101,114,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,54,83,112,114,105,110,103,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,55,82,97,105,110,98,111,119,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,52,80,105,110,107,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,54,80,97,114,117,108,97,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,53,79,99,101,97,110,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,51,74,101,116,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,51,72,83,86,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,51,72,111,116,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,52,67,111,111,108,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,52,66,111,110,101,69,0,78,50,99,118,56,99,111,108,111,114,109,97,112,54,65,117,116,117,109,110,69,0,116,104,101,32,116,121,112,101,32,111,102,32,108,97,98,101,108,115,32,109,117,115,116,32,98,101,32,49,54,117,32,111,114,32,51,50,115,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,46,99,112,112,0,76,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,73,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,95,115,117,98,49,0,105,68,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,105,68,101,112,116,104,32,61,61,32,67,86,95,56,83,0,117,110,115,117,112,112,111,114,116,101,100,32,108,97,98,101,108,47,105,109,97,103,101,32,116,121,112,101,0,76,46,114,111,119,115,32,61,61,32,73,46,114,111,119,115,0,76,46,99,111,108,115,32,61,61,32,73,46,99,111,108,115,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,87,105,116,104,83,116,97,116,115,0,99,118,83,116,97,114,116,82,101,97,100,67,104,97,105,110,80,111,105,110,116,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,116,111,117,114,115,46,99,112,112,0,99,118,83,116,97,114,116,70,105,110,100,67,111,110,116,111,117,114,115,0,91,83,116,97,114,116,93,70,105,110,100,67,111,110,116,111,117,114,115,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,67,86,95,56,85,67,49,32,105,109,97,103,101,115,32,119,104,101,110,32,109,111,100,101,32,33,61,32,67,86,95,82,69,84,82,95,70,76,79,79,68,70,73,76,76,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,111,114,116,115,32,67,86,95,51,50,83,67,49,32,105,109,97,103,101,115,32,111,110,108,121,0,99,118,70,105,110,100,78,101,120,116,67,111,110,116,111,117,114,0,99,118,69,110,100,70,105,110,100,67,111,110,116,111,117,114,115,0,78,85,76,76,32,100,111,117,98,108,101,32,67,118,83,101,113,32,112,111,105,110,116,101,114,0,99,118,70,105,110,100,67,111,110,116,111,117,114,115,0,78,111,110,122,101,114,111,32,111,102,102,115,101,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,67,86,95,76,73,78,75,95,82,85,78,83,32,121,101,116,0,78,85,76,76,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,105,99,118,70,105,110,100,67,111,110,116,111,117,114,115,73,110,73,110,116,101,114,118,97,108,0,73,110,112,117,116,32,97,114,114,97,121,32,109,117,115,116,32,98,101,32,56,117,67,49,32,111,114,32,56,115,67,49,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,49,50,67,118,77,101,109,83,116,111,114,97,103,101,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,40,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,86,69,67,84,79,82,32,124,124,32,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,77,65,84,32,124,124,32,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,85,77,65,84,41,0,102,105,110,100,67,111,110,116,111,117,114,115,0,95,99,111,110,116,111,117,114,115,46,101,109,112,116,121,40,41,32,124,124,32,40,95,99,111,110,116,111,117,114,115,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,50,32,38,38,32,95,99,111,110,116,111,117,114,115,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,83,41,0,99,105,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,116,111,116,97,108,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,41,0,99,111,110,118,101,120,72,117,108,108,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,118,104,117,108,108,46,99,112,112,0,112,111,105,110,116,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,110,112,111,105,110,116,115,32,62,61,32,48,0,99,111,110,118,101,120,105,116,121,68,101,102,101,99,116,115,0,104,112,111,105,110,116,115,32,62,32,50,0,48,32,60,61,32,104,99,117,114,114,32,38,38,32,104,99,117,114,114,32,60,32,110,112,111,105,110,116,115,0,48,32,60,61,32,104,110,101,120,116,32,38,38,32,104,110,101,120,116,32,60,32,110,112,111,105,110,116,115,0,105,115,67,111,110,116,111,117,114,67,111,110,118,101,120,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,99,111,114,110,101,114,69,105,103,101,110,86,97,108,115,86,101,99,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,114,110,101,114,46,99,112,112,0,116,121,112,101,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,0,112,114,101,67,111,114,110,101,114,68,101,116,101,99,116,0,99,111,117,110,116,32,62,61,32,48,0,99,111,114,110,101,114,83,117,98,80,105,120,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,114,110,101,114,115,117,98,112,105,120,46,99,112,112,0,119,105,110,46,119,105,100,116,104,32,62,32,48,32,38,38,32,119,105,110,46,104,101,105,103,104,116,32,62,32,48,0,115,114,99,46,99,111,108,115,32,62,61,32,119,105,110,46,119,105,100,116,104,42,50,32,43,32,53,32,38,38,32,115,114,99,46,114,111,119,115,32,62,61,32,119,105,110,46,104,101,105,103,104,116,42,50,32,43,32,53,0,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,49,54,85,0,100,101,109,111,115,97,105,99,105,110,103,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,101,109,111,115,97,105,99,105,110,103,46,99,112,112,0,115,99,110,32,61,61,32,49,32,38,38,32,100,99,110,32,61,61,32,49,0,66,97,121,101,114,45,62,71,114,97,121,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,115,99,110,32,61,61,32,49,32,38,38,32,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,0,66,97,121,101,114,45,62,82,71,66,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,115,99,110,32,61,61,32,49,32,38,38,32,100,99,110,32,61,61,32,51,0,66,97,121,101,114,45,62,82,71,66,32,69,100,103,101,45,65,119,97,114,101,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,99,117,114,114,101,110,116,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,85,110,107,110,111,119,110,32,47,32,117,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,99,111,110,118,101,114,115,105,111,110,32,99,111,100,101,0,78,50,99,118,50,57,66,97,121,101,114,50,82,71,66,95,69,100,103,101,65,119,97,114,101,95,84,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,50,57,66,97,121,101,114,50,82,71,66,95,69,100,103,101,65,119,97,114,101,95,84,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,78,50,99,118,49,55,66,97,121,101,114,50,82,71,66,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,49,55,66,97,121,101,114,50,82,71,66,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,78,50,99,118,49,56,66,97,121,101,114,50,71,114,97,121,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,49,56,66,97,121,101,114,50,71,114,97,121,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,103,101,116,83,111,98,101,108,75,101,114,110,101,108,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,101,114,105,118,46,99,112,112,0,84,104,101,32,107,101,114,110,101,108,32,115,105,122,101,32,109,117,115,116,32,98,101,32,111,100,100,32,97,110,100,32,110,111,116,32,108,97,114,103,101,114,32,116,104,97,110,32,51,49,0,100,120,32,62,61,32,48,32,38,38,32,100,121,32,62,61,32,48,32,38,38,32,100,120,43,100,121,32,62,32,48,0,107,115,105,122,101,32,62,32,111,114,100,101,114,0,103,101,116,83,99,104,97,114,114,75,101,114,110,101,108,115,0,100,120,32,62,61,32,48,32,38,38,32,100,121,32,62,61,32,48,32,38,38,32,100,120,43,100,121,32,61,61,32,49,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,0,99,118,83,111,98,101,108,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,105,115,116,114,97,110,115,102,111,114,109,46,99,112,112,0,108,97,98,101,108,84,121,112,101,32,61,61,32,68,73,83,84,95,76,65,66,69,76,95,80,73,88,69,76,32,124,124,32,108,97,98,101,108,84,121,112,101,32,61,61,32,68,73,83,84,95,76,65,66,69,76,95,67,67,79,77,80,0,77,97,115,107,32,115,105,122,101,32,115,104,111,117,108,100,32,98,101,32,51,32,111,114,32,53,32,111,114,32,48,32,40,112,114,101,99,105,115,101,41,0,116,114,117,101,68,105,115,116,84,114,97,110,115,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,67,32,124,124,32,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,76,49,32,124,124,32,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,76,50,0,85,110,107,110,111,119,110,32,109,101,116,114,105,99,32,116,121,112,101,0,103,101,116,68,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,77,97,115,107,0,78,50,99,118,49,50,68,84,82,111,119,73,110,118,111,107,101,114,69,0,78,50,99,118,49,53,68,84,67,111,108,117,109,110,73,110,118,111,107,101,114,69,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,95,76,49,95,56,85,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,100,105,115,116,97,110,99,101,65,84,83,95,76,49,95,56,117,0,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,56,32,124,124,32,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,52,0,76,105,110,101,73,116,101,114,97,116,111,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,114,97,119,105,110,103,46,99,112,112,0,48,32,60,61,32,116,104,105,99,107,110,101,115,115,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,108,105,110,101,0,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,32,38,38,32,116,104,105,99,107,110,101,115,115,32,62,61,32,48,0,80,111,108,121,76,105,110,101,0,181,181,181,182,182,183,184,185,187,188,190,192,194,196,198,201,203,206,209,211,214,218,221,224,227,231,235,238,242,246,250,254,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,114,101,99,116,97,110,103,108,101,0,114,97,100,105,117,115,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,32,38,38,32,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,99,105,114,99,108,101,0,97,120,101,115,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,97,120,101,115,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,32,38,38,32,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,101,108,108,105,112,115,101,0,98,111,120,46,115,105,122,101,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,98,111,120,46,115,105,122,101,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,102,105,108,108,67,111,110,118,101,120,80,111,108,121,0,112,116,115,32,38,38,32,110,112,116,115,32,38,38,32,110,99,111,110,116,111,117,114,115,32,62,61,32,48,32,38,38,32,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,102,105,108,108,80,111,108,121,0,112,116,115,32,38,38,32,110,112,116,115,32,38,38,32,110,99,111,110,116,111,117,114,115,32,62,61,32,48,32,38,38,32,48,32,60,61,32,116,104,105,99,107,110,101,115,115,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,32,38,38,32,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,112,111,108,121,108,105,110,101,115,0,85,110,107,110,111,119,110,32,102,111,110,116,32,116,121,112,101,0,103,101,116,70,111,110,116,68,97,116,97,0,112,111,105,110,116,115,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,83,41,32,62,61,32,48,0,112,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,83,41,32,62,61,32,48,0,48,32,60,61,32,99,111,110,116,111,117,114,73,100,120,32,38,38,32,99,111,110,116,111,117,114,73,100,120,32,60,32,40,105,110,116,41,108,97,115,116,0,100,114,97,119,67,111,110,116,111,117,114,115,0,110,112,111,105,110,116,115,32,62,32,48,0,104,105,101,114,97,114,99,104,121,46,116,111,116,97,108,40,41,32,61,61,32,110,99,111,110,116,111,117,114,115,32,38,38,32,104,105,101,114,97,114,99,104,121,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,52,0,99,118,68,114,97,119,67,111,110,116,111,117,114,115,0,101,108,101,109,95,116,121,112,101,32,61,61,32,67,86,95,51,50,83,67,50,0,113,117,97,108,105,116,121,76,101,118,101,108,32,62,32,48,32,38,38,32,109,105,110,68,105,115,116,97,110,99,101,32,62,61,32,48,32,38,38,32,109,97,120,67,111,114,110,101,114,115,32,62,61,32,48,0,103,111,111,100,70,101,97,116,117,114,101,115,84,111,84,114,97,99,107,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,101,97,116,117,114,101,115,101,108,101,99,116,46,99,112,112,0,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,95,105,109,97,103,101,41,41,0,78,50,99,118,49,51,66,97,115,101,82,111,119,70,105,108,116,101,114,69,0,78,50,99,118,49,54,66,97,115,101,67,111,108,117,109,110,70,105,108,116,101,114,69,0,78,50,99,118,49,48,66,97,115,101,70,105,108,116,101,114,69,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,115,114,99,84,121,112,101,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,100,115,116,84,121,112,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,105,108,116,101,114,46,99,112,112,0,100,115,116,79,102,115,46,120,32,62,61,32,48,32,38,38,32,100,115,116,79,102,115,46,121,32,62,61,32,48,32,38,38,32,100,115,116,79,102,115,46,120,32,43,32,115,114,99,82,111,105,46,119,105,100,116,104,32,60,61,32,100,115,116,46,99,111,108,115,32,38,38,32,100,115,116,79,102,115,46,121,32,43,32,115,114,99,82,111,105,46,104,101,105,103,104,116,32,60,61,32,100,115,116,46,114,111,119,115,0,119,104,111,108,101,83,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,119,104,111,108,101,83,105,122,101,46,104,101,105,103,104,116,32,62,32,48,0,112,114,111,99,101,101,100,0,115,114,99,32,38,38,32,100,115,116,32,38,38,32,99,111,117,110,116,32,62,32,48,0,115,114,99,89,32,62,61,32,115,116,97,114,116,89,0,100,115,116,89,32,60,61,32,114,111,105,46,104,101,105,103,104,116,0,115,114,99,82,111,105,46,120,32,62,61,32,48,32,38,38,32,115,114,99,82,111,105,46,121,32,62,61,32,48,32,38,38,32,115,114,99,82,111,105,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,115,114,99,82,111,105,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,115,114,99,82,111,105,46,120,32,43,32,115,114,99,82,111,105,46,119,105,100,116,104,32,60,61,32,115,114,99,46,99,111,108,115,32,38,38,32,115,114,99,82,111,105,46,121,32,43,32,115,114,99,82,111,105,46,104,101,105,103,104,116,32,60,61,32,115,114,99,46,114,111,119,115,0,115,116,97,114,116,0,114,111,105,46,120,32,62,61,32,48,32,38,38,32,114,111,105,46,121,32,62,61,32,48,32,38,38,32,114,111,105,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,114,111,105,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,114,111,105,46,120,32,43,32,114,111,105,46,119,105,100,116,104,32,60,61,32,119,104,111,108,101,83,105,122,101,46,119,105,100,116,104,32,38,38,32,114,111,105,46,121,32,43,32,114,111,105,46,104,101,105,103,104,116,32,60,61,32,119,104,111,108,101,83,105,122,101,46,104,101,105,103,104,116,0,78,50,99,118,49,50,70,105,108,116,101,114,69,110,103,105,110,101,69,0,99,111,108,117,109,110,66,111,114,100,101,114,84,121,112,101,32,33,61,32,66,79,82,68,69,82,95,87,82,65,80,0,114,111,119,70,105,108,116,101,114,32,38,38,32,99,111,108,117,109,110,70,105,108,116,101,114,0,98,117,102,84,121,112,101,32,61,61,32,115,114,99,84,121,112,101,0,48,32,60,61,32,97,110,99,104,111,114,46,120,32,38,38,32,97,110,99,104,111,114,46,120,32,60,32,107,115,105,122,101,46,119,105,100,116,104,32,38,38,32,48,32,60,61,32,97,110,99,104,111,114,46,121,32,38,38,32,97,110,99,104,111,114,46,121,32,60,32,107,115,105,122,101,46,104,101,105,103,104,116,0,95,107,101,114,110,101,108,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,103,101,116,75,101,114,110,101,108,84,121,112,101,0,99,110,32,61,61,32,67,86,95,77,65,84,95,67,78,40,98,117,102,84,121,112,101,41,32,38,38,32,100,100,101,112,116,104,32,62,61,32,115,116,100,58,58,109,97,120,40,115,100,101,112,116,104,44,32,67,86,95,51,50,83,41,32,38,38,32,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,100,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,82,111,119,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,100,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,68,84,62,58,58,116,121,112,101,32,38,38,32,40,107,101,114,110,101,108,46,114,111,119,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,46,99,111,108,115,32,61,61,32,49,41,0,82,111,119,70,105,108,116,101,114,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,100,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,102,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,115,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,115,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,115,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,115,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,116,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,116,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,116,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,116,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,104,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,104,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,40,115,121,109,109,101,116,114,121,84,121,112,101,32,38,32,40,75,69,82,78,69,76,95,83,89,77,77,69,84,82,73,67,65,76,32,124,32,75,69,82,78,69,76,95,65,83,89,77,77,69,84,82,73,67,65,76,41,41,32,33,61,32,48,32,38,38,32,116,104,105,115,45,62,107,115,105,122,101,32,60,61,32,53,0,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,99,110,32,61,61,32,67,86,95,77,65],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+239860);allocate([84,95,67,78,40,98,117,102,84,121,112,101,41,32,38,38,32,115,100,101,112,116,104,32,62,61,32,115,116,100,58,58,109,97,120,40,100,100,101,112,116,104,44,32,67,86,95,51,50,83,41,32,38,38,32,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,115,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,67,111,108,117,109,110,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,98,117,102,102,101,114,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,40,115,121,109,109,101,116,114,121,84,121,112,101,32,38,32,40,75,69,82,78,69,76,95,83,89,77,77,69,84,82,73,67,65,76,32,124,32,75,69,82,78,69,76,95,65,83,89,77,77,69,84,82,73,67,65,76,41,41,32,33,61,32,48,0,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,83,84,62,58,58,116,121,112,101,32,38,38,32,40,107,101,114,110,101,108,46,114,111,119,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,46,99,111,108,115,32,61,61,32,49,41,0,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,116,104,105,115,45,62,107,115,105,122,101,32,61,61,32,51,0,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,99,110,32,61,61,32,67,86,95,77,65,84,95,67,78,40,95,100,115,116,84,121,112,101,41,0,99,114,101,97,116,101,83,101,112,97,114,97,98,108,101,76,105,110,101,97,114,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,70,105,108,116,101,114,69,110,103,105,110,101,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,107,116,121,112,101,32,61,61,32,67,86,95,56,85,32,124,124,32,107,116,121,112,101,32,61,61,32,67,86,95,51,50,83,32,124,124,32,107,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,107,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,112,114,101,112,114,111,99,101,115,115,50,68,75,101,114,110,101,108,0,99,110,32,61,61,32,67,86,95,77,65,84,95,67,78,40,100,115,116,84,121,112,101,41,32,38,38,32,100,100,101,112,116,104,32,62,61,32,115,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,111,117,114,99,101,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,100,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,95,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,75,84,62,58,58,116,121,112,101,0,70,105,108,116,101,114,50,68,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,100,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,99,114,101,97,116,101,76,105,110,101,97,114,70,105,108,116,101,114,0,103,101,116,71,97,98,111,114,75,101,114,110,101,108,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,97,98,111,114,46,99,112,112,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,101,111,109,101,116,114,121,46,99,112,112,0,116,111,116,97,108,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,41,0,112,111,105,110,116,80,111,108,121,103,111,110,84,101,115,116,0,112,49,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,83,32,124,124,32,112,49,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,70,0,105,110,116,101,114,115,101,99,116,67,111,110,118,101,120,67,111,110,118,101,120,0,112,50,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,83,32,124,124,32,112,50,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,70,0,110,32,62,61,32,48,32,38,38,32,109,32,62,61,32,48,0,116,101,109,112,46,112,116,114,60,80,111,105,110,116,50,102,62,40,41,32,61,61,32,100,115,116,0,95,109,111,100,101,108,32,109,117,115,116,32,104,97,118,101,32,67,86,95,54,52,70,67,49,32,116,121,112,101,44,32,114,111,119,115,32,61,61,32,49,32,97,110,100,32,99,111,108,115,32,61,61,32,49,51,42,99,111,109,112,111,110,101,110,116,115,67,111,117,110,116,0,71,77,77,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,114,97,98,99,117,116,46,99,112,112,0,100,116,114,109,32,62,32,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,100,111,117,98,108,101,62,58,58,101,112,115,105,108,111,110,40,41,0,99,97,108,99,73,110,118,101,114,115,101,67,111,118,65,110,100,68,101,116,101,114,109,0,99,111,118,68,101,116,101,114,109,115,91,99,105,93,32,62,32,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,100,111,117,98,108,101,62,58,58,101,112,115,105,108,111,110,40,41,0,105,109,97,103,101,32,105,115,32,101,109,112,116,121,0,103,114,97,98,67,117,116,0,105,109,97,103,101,32,109,117,115,116,32,104,97,118,101,32,67,86,95,56,85,67,51,32,116,121,112,101,0,33,98,103,100,83,97,109,112,108,101,115,46,101,109,112,116,121,40,41,32,38,38,32,33,102,103,100,83,97,109,112,108,101,115,46,101,109,112,116,121,40,41,0,105,110,105,116,71,77,77,115,0,105,62,61,48,32,38,38,32,105,60,40,105,110,116,41,118,116,99,115,46,115,105,122,101,40,41,0,105,110,83,111,117,114,99,101,83,101,103,109,101,110,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,99,103,114,97,112,104,46,104,112,112,0,109,105,110,87,101,105,103,104,116,32,62,32,48,0,109,97,120,70,108,111,119,0,97,100,100,69,100,103,101,115,0,106,62,61,48,32,38,38,32,106,60,40,105,110,116,41,118,116,99,115,46,115,105,122,101,40,41,0,119,62,61,48,32,38,38,32,114,101,118,119,62,61,48,0,105,32,33,61,32,106,0,97,100,100,84,101,114,109,87,101,105,103,104,116,115,0,109,97,115,107,32,105,115,32,101,109,112,116,121,0,99,104,101,99,107,77,97,115,107,0,109,97,115,107,32,109,117,115,116,32,104,97,118,101,32,67,86,95,56,85,67,49,32,116,121,112,101,0,109,97,115,107,32,109,117,115,116,32,104,97,118,101,32,97,115,32,109,97,110,121,32,114,111,119,115,32,97,110,100,32,99,111,108,115,32,97,115,32,105,109,103,0,109,97,115,107,32,101,108,101,109,101,110,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,101,113,117,101,108,71,67,95,66,71,68,32,111,114,32,71,67,95,70,71,68,32,111,114,32,71,67,95,80,82,95,66,71,68,32,111,114,32,71,67,95,80,82,95,70,71,68,0,77,87,82,77,78,86,32,82,77,86,86,32,80,83,84,83,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,80,83,81,32,79,81,83,81,85,82,85,85,83,86,79,86,0,77,88,86,78,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,86,86,85,0,77,87,79,77,79,86,32,79,77,82,77,84,78,85,80,85,83,84,85,82,86,79,86,0,77,87,79,77,79,86,32,79,77,85,77,32,79,81,83,81,32,79,86,85,86,0,77,86,79,77,79,86,32,79,77,85,77,32,79,81,83,81,0,77,88,86,78,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,86,86,85,86,82,32,83,82,86,82,0,77,87,79,77,79,86,32,85,77,85,86,32,79,81,85,81,0,80,84,82,77,82,86,0,78,85,83,77,83,84,82,86,80,86,79,84,79,83,0,77,87,79,77,79,86,32,85,77,79,83,32,81,81,85,86,0,77,86,79,77,79,86,32,79,86,85,86,0,76,88,78,77,78,86,32,78,77,82,86,32,86,77,82,86,32,86,77,86,86,0,77,87,79,77,79,86,32,79,77,85,86,32,85,77,85,86,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,81,83,82,79,82,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,32,83,84,86,87,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,81,83,82,79,82,32,82,82,85,86,0,77,87,85,78,83,77,81,77,79,78,79,79,80,80,84,82,85,83,85,85,83,86,81,86,79,85,0,77,87,82,77,82,86,32,78,77,86,77,0,77,88,79,77,79,83,80,85,82,86,83,86,85,85,86,83,86,77,0,77,87,78,77,82,86,32,86,77,82,86,0,76,88,78,77,80,86,32,82,77,80,86,32,82,77,84,86,32,86,77,84,86,0,77,87,79,77,85,86,32,85,77,79,86,0,77,87,78,77,82,81,82,86,32,86,77,82,81,0,77,87,85,77,79,86,32,79,77,85,77,32,79,86,85,86,0,77,86,79,77,79,86,32,79,77,85,77,0,77,87,82,77,78,86,32,82,77,86,86,32,78,86,86,86,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,32,81,81,84,82,32,84,81,81,82,0,77,87,82,77,78,86,32,82,77,86,86,0,77,87,79,77,85,77,32,80,81,84,82,32,84,81,80,82,32,79,86,85,86,0,77,87,79,77,79,86,32,85,77,85,86,32,79,77,85,77,0,77,87,79,77,82,81,79,86,32,79,77,85,77,32,79,86,85,86,0,77,87,78,79,78,78,79,77,80,77,81,78,82,80,82,86,32,86,79,86,78,85,77,84,77,83,78,82,80,0,76,88,82,77,82,86,32,80,79,78,80,78,83,80,84,84,84,86,83,86,80,84,79,80,79,0,76,88,82,77,82,86,32,78,79,79,80,79,83,81,84,83,84,85,83,85,80,86,79,0,77,88,79,86,81,86,79,82,79,80,80,78,82,77,83,77,85,78,86,80,86,82,84,86,86,86,0,77,87,83,77,77,86,32,83,77,85,86,32,79,83,84,83,0,77,87,81,77,78,86,32,81,77,84,77,86,78,86,80,83,81,80,81,32,83,81,85,82,85,84,84,85,82,86,78,86,0,76,88,86,80,85,78,84,77,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,0,77,88,81,77,78,86,32,81,77,85,77,86,79,86,81,85,84,84,85,82,86,78,86,0,77,86,81,77,78,86,32,81,77,86,77,32,80,81,83,81,32,78,86,83,86,0,77,86,81,77,78,86,32,81,77,86,77,32,80,81,83,81,0,76,88,86,80,85,78,84,77,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,83,82,83,0,77,88,81,77,78,86,32,87,77,84,86,32,80,81,85,81,0,80,85,84,77,81,86,0,79,86,85,77,83,83,82,85,81,86,80,86,79,85,79,84,0,77,86,81,77,78,86,32,86,77,79,83,32,82,81,84,86,0,78,86,82,77,79,86,32,79,86,84,86,0,76,89,80,77,77,86,32,80,77,81,86,32,88,77,81,86,32,88,77,85,86,0,77,88,81,77,78,86,32,81,77,84,86,32,87,77,84,86,0,76,88,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,86,82,86,80,85,78,84,77,82,77,0,77,87,81,77,78,86,32,81,77,85,77,86,78,86,80,85,81,83,82,80,82,0,76,88,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,86,82,86,80,85,78,84,77,82,77,32,81,86,80,85,80,84,81,83,82,83,83,84,84,86,85,87,86,87,0,77,87,81,77,78,86,32,81,77,85,77,86,78,86,80,85,81,83,82,80,82,32,81,82,82,85,83,86,84,86,85,85,0,77,87,86,78,84,77,82,77,80,78,80,80,81,81,84,82,85,83,85,85,83,86,80,86,78,85,0,77,86,83,77,80,86,32,80,77,86,77,0,76,88,80,77,78,83,78,85,79,86,82,86,84,85,85,83,87,77,0,77,87,79,77,81,86,32,87,77,81,86,0,75,88,78,77,78,86,32,83,77,78,86,32,83,77,83,86,32,88,77,83,86,0,78,87,81,77,84,86,32,87,77,78,86,0,78,87,81,77,83,81,81,86,32,87,77,83,81,0,77,87,81,77,87,77,78,86,84,86,0,76,88,78,77,82,86,32,86,77,82,86,32,78,77,86,77,0,77,87,78,76,86,88,0,76,88,82,79,78,85,32,82,79,86,85,0,77,87,78,86,86,86,0,80,86,82,77,85,81,0,77,87,77,77,79,75,81,75,84,77,86,77,87,75,0,78,87,81,80,84,80,85,81,85,86,32,85,82,81,83,80,84,80,85,81,86,83,86,85,85,0,77,87,79,77,79,86,32,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,83,86,85,85,0,77,87,85,77,85,86,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,77,87,79,83,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,86,0,78,86,85,78,84,77,83,77,82,78,82,86,32,80,80,84,80,0,77,87,85,80,85,86,84,88,82,89,80,89,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,77,87,79,77,79,86,32,79,83,80,81,82,80,84,81,85,83,85,86,0,80,84,82,76,81,77,82,78,83,77,82,76,32,82,80,82,86,0,80,85,83,76,82,77,83,78,84,77,83,76,32,83,80,83,88,82,89,81,89,80,88,0,78,87,80,77,80,86,32,85,80,80,84,32,82,83,85,86,0,75,89,77,80,77,86,32,77,83,78,81,79,80,80,80,81,81,82,83,82,86,32,82,83,83,81,84,80,85,80,86,81,87,83,87,86,0,77,87,79,80,79,86,32,79,83,80,81,82,80,84,81,85,83,85,86,0,77,87,82,80,80,81,79,83,80,85,82,86,84,85,85,83,84,81,82,80,0,77,87,79,80,79,89,32,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,80,85,89,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,78,86,80,80,80,86,32,80,83,81,81,83,80,84,80,0,78,87,85,81,84,80,81,80,80,81,80,82,81,83,84,83,85,84,85,85,84,86,81,86,80,85,0,78,86,82,77,82,85,83,86,84,86,85,85,32,80,80,84,80,0,77,87,85,80,85,86,32,79,80,79,83,80,85,82,86,84,85,85,83,0,78,86,79,80,82,86,32,85,80,82,86,0,76,88,78,80,80,86,32,82,80,80,86,32,82,80,84,86,32,86,80,84,86,0,77,87,79,80,85,86,32,85,80,79,86,0,77,87,79,80,82,86,32,85,80,82,86,81,88,80,89,79,89,0,77,87,79,80,85,80,79,86,85,86,0,77,88,86,80,85,83,84,85,82,86,80,85,79,83,80,81,82,80,84,81,85,85,86,86,0,77,87,79,84,81,86,83,86,84,85,84,83,83,82,80,81,82,81,84,80,85,79,85,78,84,77,82,77,81,78,80,80,79,84,78,89,0,77,88,78,81,79,80,81,80,82,81,82,83,81,87,32,86,80,85,82,83,84,81,87,80,89,0,77,87,84,78,83,77,82,77,81,78,81,79,82,80,84,81,85,83,84,85,82,86,80,85,79,83,80,81,82,80,0,78,87,85,81,83,80,81,80,80,81,80,82,81,83,32,83,83,81,83,80,84,80,85,81,86,83,86,85,85,0,78,87,84,77,83,78,83,79,84,80,32,85,80,83,80,81,81,80,83,80,85,81,86,83,87,83,88,82,89,81,89,0,76,88,78,81,79,80,80,80,81,81,81,83,80,86,32,81,83,82,81,84,80,85,80,86,81,86,83,85,86,84,89,0,76,88,78,81,79,80,80,80,81,81,81,85,82,86,83,86,84,85,85,83,86,80,86,78,85,77,84,77,83,78,83,80,84,82,85,83,87,84,0,79,86,82,80,81,83,81,85,82,86,83,86,84,85,0,77,87,81,80,79,86,32,85,80,84,80,82,81,80,83,32,80,83,81,85,83,86,84,86,0,77,87,79,77,80,77,81,78,82,80,85,86,32,82,80,79,86,0,76,89,80,80,77,89,32,85,80,84,83,83,85,81,86,80,86,79,85,79,83,32,84,83,84,85,85,86,86,86,87,85,0,77,87,78,80,79,80,79,86,32,85,80,84,83,82,85,79,86,0,78,87,84,77,83,78,83,79,84,80,32,85,80,83,80,81,81,81,82,82,83,84,83,32,83,83,81,84,80,85,80,86,81,87,83,88,83,89,82,90,81,90,0,77,88,79,81,81,80,86,80,32,81,80,81,82,80,86,32,84,80,84,82,85,86,0,77,87,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,78,89,0,77,88,86,80,82,80,80,81,79,83,80,85,82,86,84,85,85,83,84,81,82,80,0,77,88,79,81,81,80,86,80,32,83,80,82,86,0,75,88,77,81,78,80,79,80,80,81,80,85],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+250100);allocate([81,86,83,86,84,85,85,83,86,80,0,77,88,80,80,79,81,79,83,80,85,82,86,83,86,85,85,86,83,86,81,85,80,84,80,83,81,82,83,81,89,0,77,87,79,80,80,80,81,81,83,88,84,89,85,89,32,85,80,84,82,80,87,79,89,0,75,89,84,77,82,89,32,77,81,78,80,79,80,80,81,80,85,81,86,84,86,85,85,86,83,87,80,0,76,88,79,80,78,82,78,84,79,86,81,86,82,84,82,82,32,85,80,86,82,86,84,85,86,83,86,82,84,0,76,87,84,83,83,81,81,80,79,81,78,83,79,85,81,86,83,85,84,83,32,85,80,84,83,84,85,85,86,86,86,0,77,87,81,77,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,84,86,0,76,87,84,83,83,81,81,80,79,81,78,83,79,85,81,86,83,85,84,83,32,86,77,84,83,84,85,85,86,86,86,0,77,87,79,83,84,83,85,82,85,81,83,80,82,80,80,81,79,83,80,85,82,86,84,86,0,79,86,86,77,85,77,84,78,83,80,81,86,80,88,79,89,78,89,32,81,80,85,80,0,77,88,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,32,86,80,84,86,83,88,82,89,80,89,79,88,0,77,86,81,77,78,86,32,79,83,80,81,81,80,83,80,84,81,84,82,83,84,83,85,84,86,85,86,0,80,85,83,77,83,78,84,78,84,77,83,77,32,81,80,82,80,83,81,83,82,82,84,82,85,83,86,84,86,0,79,85,83,77,83,78,84,78,84,77,83,77,32,81,80,82,80,83,81,83,82,82,86,81,88,80,89,79,89,78,88,0,78,86,82,77,79,86,32,85,80,84,80,82,81,80,83,32,80,83,81,85,83,86,84,86,0,79,84,83,77,81,83,81,85,82,86,83,86,0,74,89,75,80,76,80,77,81,77,83,76,86,32,77,83,78,81,79,80,81,80,82,81,82,83,81,86,32,82,83,83,81,84,80,86,80,87,81,87,82,86,84,86,85,87,86,88,86,0,77,87,78,80,79,80,80,81,80,83,79,86,32,80,83,81,81,82,80,84,80,85,81,85,82,84,84,84,85,85,86,86,86,0,77,88,78,80,79,80,80,81,80,83,78,89,32,80,83,81,85,83,86,85,85,86,83,85,81,83,80,81,81,80,83,0,77,88,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,32,86,80,83,89,0,77,86,79,80,80,80,81,81,81,83,80,86,32,85,81,84,80,83,80,82,81,81,83,0,78,86,84,81,83,80,81,80,80,81,80,82,81,83,82,83,83,84,83,85,82,86,80,86,79,85,0,78,85,83,77,81,83,81,85,82,86,83,86,32,80,80,84,80,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,83,85,84,83,32,85,80,84,83,84,85,85,86,86,86,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,84,85,85,82,85,80,0,75,89,76,80,77,80,78,81,78,82,77,84,77,85,78,86,80,86,81,85,82,83,83,80,32,82,83,82,85,83,86,85,86,86,85,87,82,87,80,0,77,87,79,81,80,80,81,80,82,81,82,85,83,86,84,86,85,85,32,86,81,85,80,84,80,83,81,81,85,80,86,79,86,78,85,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,83,85,84,83,32,85,80,83,86,82,88,81,89,79,89,78,88,0,78,86,85,80,79,86,32,80,81,81,80,83,80,84,81,32,80,85,81,86,83,86,84,85,0,77,87,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,85,80,84,78,82,77,81,77,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,83,86,85,85,32,79,83,83,83,0,77,87,82,77,81,78,80,80,79,83,79,86,80,87,82,87,83,86,84,84,85,81,85,78,84,77,82,77,32,80,82,84,82,0,77,87,84,77,81,89,32,82,80,80,81,79,83,80,85,82,86,83,86,85,85,86,83,85,81,83,80,82,80,0,77,87,85,81,83,80,81,80,79,81,79,83,80,84,82,85,83,86,83,87,82,88,81,88,0,75,89,84,80,84,83,85,84,86,84,87,83,87,81,86,79,85,78,83,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,32,84,81,83,80,81,80,80,81,80,83,81,84,83,84,84,83,0,77,87,85,78,79,82,85,86,0,77,87,79,78,85,82,79,86,0,79,85,84,75,81,75,81,89,84,89,0,79,85,80,75,83,75,83,89,80,89,0,79,85,84,75,83,76,82,78,82,79,83,81,81,82,83,83,82,85,82,86,83,88,84,89,0,79,85,80,75,81,76,82,78,82,79,81,81,83,82,81,83,82,85,82,86,81,88,80,89,0,76,89,80,77,81,78,81,79,80,80,79,80,78,79,78,78,79,77,80,77,83,78,85,78,87,77,78,86,32,85,83,84,84,84,85,85,86,86,86,87,85,87,84,86,83,85,83,0,80,84,0,78,86,0,77,87,82,77,80,78,79,80,79,83,80,85,82,86,84,85,85,83,85,80,84,78,82,77,0,77,87,80,79,82,77,82,86,0,77,87,79,78,81,77,83,77,85,78,85,80,84,82,79,86,85,86,0,77,87,79,78,81,77,83,77,85,78,85,80,83,81,32,82,81,83,81,85,82,85,85,83,86,81,86,79,85,0,77,87,83,77,83,86,32,83,77,78,83,86,83,0,77,87,80,77,79,81,81,80,82,80,84,81,85,83,84,85,82,86,81,86,79,85,32,80,77,84,77,0,77,87,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,77,81,86,32,79,77,85,77,0,77,87,81,77,79,78,79,80,81,81,83,81,85,80,85,78,83,77,81,77,32,81,81,79,82,79,85,81,86,83,86,85,85,85,82,83,81,0,77,87,85,80,84,82,82,83,80,82,79,80,80,78,82,77,84,78,85,80,85,83,84,85,82,86,80,86,0,80,85,82,85,82,86,83,86,83,85,82,85,0,80,85,83,86,82,86,82,85,83,85,83,87,82,89,0,80,85,82,80,82,81,83,81,83,80,82,80,32,82,85,82,86,83,86,83,85,82,85,0,80,85,82,80,82,81,83,81,83,80,82,80,32,83,86,82,86,82,85,83,85,83,87,82,89,0,80,85,82,77,82,82,32,83,77,83,82,32,82,85,82,86,83,86,83,85,82,85,0,78,87,80,78,82,77,83,77,85,78,85,80,82,81,82,82,83,82,83,81,85,80,32,82,85,82,86,83,86,83,85,82,85,0,80,84,82,77,82,81,0,78,86,80,77,80,81,32,84,77,84,81,0,78,86,81,77,80,78,80,80,81,81,83,81,84,80,84,78,83,77,81,77,0,77,87,82,75,82,88,32,85,78,83,77,81,77,79,78,79,80,81,81,84,82,85,83,85,85,83,86,81,86,79,85,0,77,87,86,76,78,88,0,79,85,84,75,82,78,81,81,81,83,82,86,84,89,0,79,85,80,75,82,78,83,81,83,83,82,86,80,89,0,80,84,82,75,82,89,0,76,88,78,82,86,82,0,76,88,82,78,82,86,32,78,82,86,82,0,76,88,78,80,86,80,32,78,84,86,84,0,77,87,79,79,85,85,32,85,79,79,85,0,77,87,82,79,82,85,32,79,80,85,84,32,85,80,79,84,0,80,85,82,81,82,82,83,82,83,81,82,81,0,80,85,83,77,82,79,82,81,83,81,83,80,82,80,0,80,85,83,78,82,78,82,77,83,77,83,79,82,81,0,76,88,83,79,86,82,83,85,32,78,82,86,82,0,77,88,81,76,81,89,32,84,76,84,89,32,79,81,86,81,32,79,84,86,84,0,76,88,86,82,85,82,84,83,83,85,82,86,79,86,78,85,78,83,79,82,82,81,83,80,83,78,82,77,80,77,79,78,79,80,81,83,83,85,85,86,86,86,0,76,88,78,78,79,81,79,83,78,86,32,86,78,85,81,85,83,86,86,32,78,78,81,79,83,79,86,78,32,78,86,81,85,83,85,86,86,0,76,89,82,81,81,80,79,80,78,81,78,83,79,84,81,84,82,83,83,81,84,80,86,80,87,81,87,83,86,84,84,84,83,83,82,81,0,72,92,78,82,77,81,76,82,77,83,78,82,32,86,82,87,81,88,82,87,83,86,82,0,72,92,77,80,76,81,76,82,77,83,78,83,79,82,79,81,78,80,77,80,32,77,81,77,82,78,82,78,81,77,81,32,87,80,86,81,86,82,87,83,88,83,89,82,89,81,88,80,87,80,32,87,81,87,82,88,82,88,81,87,81,0,73,91,75,82,89,82,0,72,92,82,85,74,80,82,84,90,80,82,85,0,70,94,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,32,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,89,74,87,76,86,78,86,80,87,84,90,86,91,88,91,90,90,91,87,32,73,89,74,86,76,85,78,85,80,86,84,89,86,90,88,90,90,89,91,87,0,70,94,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,32,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,87,91,87,32,73,91,91,91,0,67,97,71,79,93,79,88,73,32,76,91,71,85,93,85,0,68,96,70,94,94,94,94,70,70,70,70,94,0,75,89,81,86,79,85,78,83,78,81,79,79,81,78,83,78,85,79,86,81,86,83,85,85,83,86,81,86,32,83,86,86,83,32,81,86,86,81,32,79,85,85,79,32,78,83,83,78,32,78,81,81,78,0,72,92,73,82,91,82,0,72,92,73,82,91,82,32,73,81,91,81,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,81,91,79,92,78,94,78,97,32,84,84,85,85,86,87,85,89,84,90,32,78,96,79,95,80,95,83,96,86,96,87,95,32,80,95,83,97,86,97,87,95,87,94,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,32,84,84,85,85,86,87,85,89,84,90,32,82,90,84,90,86,91,87,93,87,94,86,96,84,97,81,97,79,96,78,95,78,94,79,94,79,95,32,84,90,85,91,86,93,86,94,85,96,84,97,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,86,86,86,87,87,87,87,86,86,85,84,84,82,84,80,85,79,86,78,89,78,94,79,96,81,97,84,97,86,96,87,94,87,92,86,90,84,89,81,89,78,91,32,82,84,80,86,79,89,79,94,80,96,81,97,32,84,97,85,96,86,94,86,92,85,90,84,89,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,81,74,79,75,78,77,78,80,32,84,67,85,68,86,70,85,72,84,73,32,78,79,79,78,80,78,83,79,86,79,87,78,32,80,78,83,80,86,80,87,78,87,77,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,32,84,84,85,85,86,87,85,89,84,90,32,82,90,84,90,86,91,87,93,87,94,86,96,84,97,81,97,79,96,78,95,78,94,79,94,79,95,32,84,90,85,91,86,93,86,94,85,96,84,97,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,32,84,67,85,68,86,70,85,72,84,73,32,82,73,84,73,86,74,87,76,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,73,85,74,86,76,86,77,85,79,84,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,67,78,73,32,79,67,86,67,32,79,68,83,68,86,67,32,78,73,79,72,81,71,84,71,86,72,87,74,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,71,85,72,86,74,86,77,85,79,84,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,78,67,78,71,32,86,69,82,76,80,80,32,87,67,84,73,81,80,32,78,69,80,67,82,67,85,69,32,78,69,80,68,82,68,85,69,86,69,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,67,78,73,32,79,67,86,67,32,79,68,83,68,86,67,32,78,73,79,72,81,71,84,71,86,72,87,74,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,71,85,72,86,74,86,77,85,79,84,80,32,77,82,88,82,32,86,86,86,87,87,87,87,86,86,85,84,84,82,84,80,85,79,86,78,89,78,94,79,96,81,97,84,97,86,96,87,94,87,92,86,90,84,89,81,89,78,91,32,82,84,80,86,79,89,79,94,80,96,81,97,32,84,97,85,96,86,94,86,92,85,90,84,89,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,83,86,83,97,32,84,84,84,97,32,84,84,77,93,88,93,32,81,97,86,97,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,32,84,67,85,68,86,70,85,72,84,73,32,82,73,84,73,86,74,87,76,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,73,85,74,86,76,86,77,85,79,84,80,32,77,82,88,82,32,83,86,83,97,32,84,84,84,97,32,84,84,77,93,88,93,32,81,97,86,97,0,70,94,89,88,87,90,85,91,82,91,80,90,77,88,75,87,73,87,72,88,72,90,73,91,75,91,77,90,79,87,80,85,82,81,84,75,87,71,89,70,90,70,91,71,92,72,91,73,90,72,91,71,91,70,90,70,89,70,87,71,86,72,84,76,82,80,80,86,78,90,77,90,32,79,80,85,80,0,69,94,80,91,77,90,74,88,72,85,71,82,71,79,72,76,74,73,77,71,80,70,84,70,87,71,89,73,91,76,92,79,92,82,91,85,89,88,86,90,83,91,80,91,32,78,74,78,87,32,79,74,79,87,32,76,74,83,74,86,75,87,77,87,78,86,80,83,81,79,81,32,83,74,85,75,86,77,86,78,85,80,83,81,32,76,87,81,87,32,83,81,84,82,85,86,86,87,87,87,88,86,32,83,81,85,82,86,86,87,87,0,69,94,80,91,77,90,74,88,72,85,71,82,71,79,72,76,74,73,77,71,80,70,84,70,87,71,89,73,91,76,92,79,92,82,91,85,89,88,86,90,83,91,80,91,32,85,75,86,74,86,78,85,75,83,74,80,74,78,75,77,76,76,79,76,82,77,85,78,86,80,87,83,87,85,86,86,84,32,80,74,78,76,77,79,77,82,78,85,80,87,0,69,95,73,77,91,77,32,73,82,91,82,32,73,87,91,87,32,75,91,89,73,0,67,97,72,81,71,82,72,83,73,82,72,81,32,82,81,81,82,82,83,83,82,82,81,32,92,81,91,82,92,83,93,82,92,81,0,69,95,78,87,76,84,73,82,76,80,78,77,32,76,80,74,82,76,84,32,74,82,90,82,32,86,87,88,84,91,82,88,80,86,77,32,88,80,90,82,88,84,0,74,90,87,78,84,76,82,73,80,76,77,78,32,80,76,82,74,84,76,32,82,74,82,90,32,87,86,84,88,82,91,80,88,77,86,32,80,88,82,90,84,88,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,32,83,70,83,94,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,32,81,70,81,94,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,32,79,82,90,82,0,72,92,76,66,76,91,32,82,66,82,91,32,88,66,88,91,0,73,91,82,70,74,91,32,82,70,90,91,32,77,84,87,84,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,84,80,32,75,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,75,91,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,0,71,92,75,70,75,91,32,75,70,82,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,82,91,75,91,0,72,91,76,70,76,91,32,76,70,89,70,32,76,80,84,80,32,76,91,89,91,0,72,90,76,70,76,91,32,76,70,89,70,32,76,80,84,80,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,90,83,32,85,83,90,83,0,71,93,75,70,75,91,32,89,70,89,91,32,75,80,89,80,0,78,86,82,70,82,91,0,74,90,86,70,86,86,85,89,84,90,82,91,80,91,78,90,77,89,76,86,76,84,0,71,92,75,70,75,91,32,89,70,75,84,32,80,79,89,91,0,72,89,76,70,76,91,32,76,91,88,91,0,70,94,74,70,74,91,32,74,70,82,91,32,90,70,82,91,32,90,70,90,91,0,71,93,75,70,75,91,32,75,70,89,91,32,89,70,89,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,75,81,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,83,87,89,93,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,84,80,75,80,32,82,80,89,91,0,72,92,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,74,90,82,70,82,91,32,75,70,89,70,0,71,93,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,0,73,91,74,70,82,91,32,90,70,82,91,0,70,94,72,70,77,91,32,82,70,77,91,32,82,70,87,91,32,92,70,87,91,0,72,92,75,70,89,91,32,89,70,75,91,0,73,91,74,70,82,80,82,91,32,90,70,82,80,0,72,92,89,70,75,91,32,75,70,89,70,32,75,91,89,91,0,72,89,76,70,76,91,32,76,70,88,70,0,73,91,82,70,74,91,32,82,70,90,91,32,74,91,90,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,79,80,85,80,0,73,91,82,70,74,91,32,82,70,90,91,0,73,91,75,70,89,70,32,79,80,85,80,32,75,91,89,91,0,71,93,75,70,75,91,32,89,70,89,91,32,75,70,89,70,0,73,91,75,70,82,80,75,91,32,75,70,89,70,32,75,91,89,91,0,73,91,75,75,75,73,76,71,77,70,79,70,80,71,81,73,82,77,82,91,32,89,75,89,73,88,71,87,70,85,70,84,71,83,73,82,77,0,72,92,82,70,82,91,32,80,75,77,76,76,77,75,79,75,82,76,84,77,85,80,86,84,86,87,85,88,84,89,82,89,79,88,77,87,76,84,75,80,75,0,72,92,75,70,89,91,32,75,91,89,70,0,71,93,82,70,82,91,32,73,76,74,76,75,77,76,81,77,83,78,84,81,85,83,85,86,84,87,83,88,81,89,77,90,76,91,76,0,72,92,75,91,79,91,76,84,75,80,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,80,88,84,85,91,89,91,0,71,91,71,91,73,90,76,87,79,83,83,76,86,70,86,91,85,88,83,85,81,83,78,81,76,81,75,82,75,84,76,86,78,88,81,90,84,91,89,91,0,70,93,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,88,70,90,71,91,73,91,75,90,77,89,78,87,79,84,80,32,83,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,82,91,80,90,79,88,0,72,92,84,76,84,77,85,78,87,78,89,77,90,75,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,87,86,0,71,94,84,70,82,71,81,73,80,77,79,83,78,86,77,88,75,90,73,91,71,91,70,90,70,88,71,87,73,87,75,88,77,90,80,91,83,91,86,90,88,88,90,84,91,79,91,75,90,72,89,71,87,70,84,70,82,72,82,74,83,77,85,80,87,82,90,84,92,85,0,72,92,86,74,86,75,87,76,89,76,90,75,90,73,89,71,86,70,82,70,79,71,78,73,78,76,79,78,80,79,83,80,80,80,77,81,76,82,75,84,75,87,76,89,77,90,80,91,83,91,86,90,88,88,89,86,0,72,92,82,76,80,76,78,75,77,73,78,71,81,70,84,70,88,71,91,71,93,70,32,88,71,86,78,84,84,82,88,80,90,78,91,76,91,74,90,73,88,73,86,74,85,76,85,78,86,32,81,80,90,80,0,71,94,71,91,73,90,77,86,80,81,81,78,82,74,82,71,81,70,80,70,79,71,78,73,78,76,79,78,81,79,85,79,88,78,89,77,90,75,90,81,89,86,88,88,86,90,83,91,79,91,76,90,74,88,73,86,73,84,0,70,94,77,77,75,76,74,74,74,73,75,71,77,70,78,70,80,71,81,73,81,75,80,79,78,85,76,89,74,91,72,91,71,90,71,88,32,77,82,86,79,88,78,91,76,93,74,94,72,94,71,93,70,92,70,90,72,88,76,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,73,90,87,86,85,84,83,81,82,79,81,76,81,73,82,71,83,70,85,70,86,71,87,73,87,76,86,81,84,86,83,88,81,90,79,91,77,91,75,90,74,88,74,86,75,85,77,85,79,86,0,74,89,84,94,82,91,80,86,79,80,79,74,80,71,82,70,84,70,85,71,86,74,86,77,85,82,82,91,80,97,79,100,78,102,76,103,75,102,75,100,76,97,78,94,80,92,83,90,87,88,0,70,94,77,77,75,76,74,74,74,73,75,71,77,70,78,70,80,71,81,73,81,75,80,79,78,85,76,89,74,91,72,91,71,90,71,88,32,94,73,94,71,93,70,92,70,90,71,88,73,86,76,84,78,82,79,80,79,32,82,79,83,81,83,88,84,90,85,91,86,91,88,90,89,89,91,86,0,73,92,77,82,79,82,83,81,86,79,88,77,89,75,89,72,88,70,86,70,85,71,84,73,83,78,82,83,81,86,80,88,78,90,76,91,74,91,73,90,73,88,74,87,76,87,78,88,81,90,84,91,86,91,89,90,91,88,0,64,97,69,77,67,76,66,74,66,73,67,71,69,70,70,70,72,71,73,73,73,75,72,80,71,84,69,91,32,71,84,74,76,76,72,77,71,79,70,80,70,82,71,83,73,83,75,82,80,81,84,79,91,32,81,84,84,76,86,72,87,71,89,70,90,70,92,71,93,73,93,75,92,80,90,87,90,90,91,91,92,91,94,90,95,89,97,86,0,69,93,74,77,72,76,71,74,71,73,72,71,74,70,75,70,77,71,78,73,78,75,77,80,76,84,74,91,32,76,84,79,76,81,72,82,71,84,70,86,70,88,71,89,73,89,75,88,80,86,87,86,90,87,91,88,91,90,90,91,89,93,86,0,72,93,84,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,83,90,79,90,75,89,72,88,71,86,70,84,70,82,72,82,75,83,78,85,81,87,83,90,85,92,86,0,70,95,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,90,70,92,71,93,72,94,74,94,77,93,79,92,80,90,81,87,81,85,80,84,79,0,72,94,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,83,83,87,80,89,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,83,91,86,91,89,90,91,88,0,70,95,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,89,70,91,71,92,72,93,74,93,77,92,79,91,80,89,81,86,81,83,80,84,81,85,83,85,88,86,90,88,91,90,90,91,89,93,86,0,72,92,72,91,74,90,76,88,79,84,81,81,83,77,84,74,84,71,83,70,82,70,81,71,80,73,80,75,81,77,83,79,86,81,88,83,89,85,89,87,88,89,87,90,84,91,80,91,77,90,75,88,74,86,74,84,0,72,91,82,76,80,76,78,75,77,73,78,71,81,70,84,70,88,71,91,71,93,70,32,88,71,86,78,84,84,82,88,80,90,78,91,76,91,74,90,73,88,73,86,74,85,76,85,78,86,0,69,93,74,77,72,76,71,74,71,73,72,71,74,70,75,70,77,71,78,73,78,75,77,79,76,82,75,86,75,88,76,90,78,91,80,91,82,90,83,89,85,85,88,77,90,70,32,88,77,87,81,86,87,86,90,87,91,88,91,90,90,91,89,93,86,0,70,93,75,77,73,76,72,74,72,73,73,71,75,70,76,70,78,71,79,73,79,75,78,79,77,82,76,86,76,89,77,91,79,91,81,90,84,87,86,84,88,80,89,77,90,73,90,71,89,70,88,70,87,71,86,73,86,75,87,78,89,80,91,81,0,67,95,72,77,70,76,69,74,69,73,70,71,72,70,73,70,75,71,76,73,76,76,75,91,32,85,70,75,91,32,85,70,83,91,32,97,70,95,71,92,74,89,78,86,84,83,91,0,70,94,78,76,76,76,75,75,75,73,76,71,78,70,80,70,82,71,83,73,83,76,81,85,81,88,82,90,84,91,86,91,88,90,89,88,89,86,88,85,86,85,32,93,73,93,71,92,70,90,70,88,71,86,73,84,76,80,85,78,88,76,90,74,91,72,91,71,90,71,88,0,70,93,75,77,73,76,72,74,72,73,73,71,75,70,76,70,78,71,79,73,79,75,78,79,77,82,76,86,76,88,77,90,78,91,80,91,82,90,84,88,86,85,87,83,89,77,32,91,70,89,77,86,87,84,93,82,98,80,102,78,103,77,102,77,100,78,97,80,94,83,91,86,89,91,86,0,72,93,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,84,84,87,80,90,78,91,75,91,74,90,74,88,75,87,78,87,80,88,81,89,82,91,82,94,81,97,80,99,78,102,76,103,75,102,75,100,76,97,78,94,81,91,84,89,90,86,0,73,91,74,70,82,91,32,90,70,82,91,32,74,70,90,70,0,71,93,73,76,91,98,0,69,95,82,74,73,90,32,82,74,91,90,0,73,91,74,91,90,91,0,73,91,74,91,90,91,90,90,74,90,74,91,0,73,92,88,77,88,91,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,72,91,76,70,76,91,32,76,80,78,78,80,77,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,80,91,78,90,76,88,0,73,91,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,92,88,70,88,91,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,91,76,83,88,83,88,81,87,79,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,77,89,87,70,85,70,83,71,82,74,82,91,32,79,77,86,77,0,73,92,88,77,88,93,87,96,86,97,84,98,81,98,79,97,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,92,77,70,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,0,78,86,81,70,82,71,83,70,82,69,81,70,32,82,77,82,91,0,77,87,82,70,83,71,84,70,83,69,82,70,32,83,77,83,94,82,97,80,98,78,98,0,73,90,77,70,77,91,32,87,77,77,87,32,81,83,88,91,0,67,97,71,77,71,91,32,71,81,74,78,76,77,79,77,81,78,82,81,82,91,32,82,81,85,78,87,77,90,77,92,78,93,81,93,91,0,73,92,77,77,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,0,73,92,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,89,85,89,83,88,80,86,78,84,77,81,77,0,72,91,76,77,76,98,32,76,80,78,78,80,77,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,80,91,78,90,76,88,0,73,92,88,77,88,98,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,75,88,79,77,79,91,32,79,83,80,80,82,78,84,77,87,77,0,74,91,88,80,87,78,84,77,81,77,78,78,77,80,78,82,80,83,85,84,87,85,88,87,88,88,87,90,84,91,81,91,78,90,77,88,0,77,89,82,70,82,87,83,90,85,91,87,91,32,79,77,86,77,0,73,92,77,77,77,87,78,90,80,91,83,91,85,90,88,87,32,88,77,88,91,0,74,90,76,77,82,91,32,88,77,82,91,0,71,93,74,77,78,91,32,82,77,78,91,32,82,77,86,91,32,90,77,86,91,0,74,91,77,77,88,91,32,88,77,77,91,0,74,90,76,77,82,91,32,88,77,82,91,80,95,78,97,76,98,75,98,0,74,91,88,77,77,91,32,77,77,88,77,32,77,91,88,91,0,72,93,81,77,79,78,77,80,76,82,75,85,75,88,76,90,78,91,80,91,82,90,85,87,87,84,89,80,90,77,32,81,77,83,77,84,78,85,80,87,88,88,90,89,91,90,91,0,73,92,85,70,83,71,81,73,79,77,78,80,77,84,76,90,75,98,32,85,70,87,70,89,72,89,75,88,77,87,78,85,79,82,79,32,82,79,84,80,86,82,87,84,87,87,86,89,85,90,83,91,81,91,79,90,78,89,77,86,0,73,92,74,80,76,78,78,77,79,77,81,78,82,79,83,82,83,86,82,91,32,90,77,89,80,88,82,82,91,80,95,79,98,0,73,91,84,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,87,82,86,79,84,77,82,75,81,73,81,71,82,70,84,70,86,71,88,73,0,74,90,87,79,86,78,84,77,81,77,79,78,79,80,80,82,83,83,32,83,83,79,84,77,86,77,88,78,90,80,91,83,91,85,90,87,88,0,74,89,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,88,75,84,77,81,79,78,82,77,85,77,87,78,89,80,91,83,93,84,95,84,97,83,98,81,98,80,96,0,72,92,73,81,74,79,76,77,78,77,79,78,79,80,78,84,76,91,32,78,84,80,80,82,78,84,77,86,77,88,79,88,82,87,87,84,98,0,71,92,72,81,73,79,75,77,77,77,78,78,78,80,77,85,77,88,78,90,79,91,81,91,83,90,85,87,86,85,87,82,88,77,88,74,87,71,85,70,83,70,82,72,82,74,83,77,85,80,87,82,90,84,0,76,87,82,77,80,84,79,88,79,90,80,91,82,91,84,89,85,87,0,73,91,79,77,75,91,32,89,78,88,77,87,77,85,78,81,82,79,83,78,83,32,78,83,80,84,81,85,83,90,84,91,85,91,86,90,0,74,90,75,70,77,70,79,71,80,72,88,91,32,82,77,76,91,0,72,93,79,77,73,98,32,78,81,77,86,77,89,79,91,81,91,83,90,85,88,87,84,32,89,77,87,84,86,88,86,90,87,91,89,91,91,89,92,87,0,73,91,76,77,79,77,78,83,77,88,76,91,32,89,77,88,80,87,82,85,85,82,88,79,90,76,91,0,74,90,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,85,75,82,76,80,77,79,79,79,81,81,83,84,84,86,84,32,84,84,80,85,78,86,77,88,77,90,79,92,83,94,84,95,84,97,82,98,80,98,0,74,91,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,83,91,85,90,87,88,88,85,88,82,87,79,86,78,84,77,82,77,0,71,93,80,77,76,91,32,85,77,86,83,87,88,88,91,32,73,80,75,78,78,77,91,77,0,73,91,77,83,77,86,78,89,79,90,81,91,83,91,85,90,87,88,88,85,88,82,87,79,86,78,84,77,82,77,80,78,78,80,77,83,73,98,0,73,93,91,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,87,82,86,79,85,78,83,77,0,72,92,83,77,80,91,32,74,80,76,78,79,77,90,77,0,72,92,73,81,74,79,76,77,78,77,79,78,79,80,77,86,77,89,79,91,81,91,84,90,86,88,88,84,89,80,89,77,0,71,93,79,78,77,79,75,81,74,84,74,87,75,89,76,90,78,91,81,91,84,90,87,88,89,85,90,82,90,79,88,77,86,77,84,79,82,83,80,88,77,98,0,73,91,75,77,77,77,79,79,85,96,87,98,89,98,32,90,77,89,79,87,82,77,93,75,96,74,98,0,70,93,86,70,78,98,32,71,81,72,79,74,77,76,77,77,78,77,80,76,85,76,88,77,90,79,91,81,91,84,90,86,88,88,85,90,80,91,77,0,70,93,78,77,76,78,74,81,73,84,73,87,74,90,75,91,77,91,79,90,81,87,32,82,83,81,87,82,90,83,91,85,91,87,90,89,87,90,84,90,81,89,78,88,77,0,76,92,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,77,91,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,84,78,90,79,91,80,91,82,90,84,88,85,85,85,82,86,86,87,87,89,87,91,86,0,77,88,84,84,84,83,83,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,0,76,92,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,90,70,32,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,78,88,79,89,81,88,82,87,83,85,83,83,82,82,81,82,79,83,78,85,78,88,79,90,81,91,83,91,85,90,86,89,88,86,0,79,87,79,86,83,81,85,78,86,76,87,73,87,71,86,70,84,71,83,73,81,81,78,90,75,97,74,100,74,102,75,103,77,102,78,99,79,90,80,91,82,91,84,90,85,89,87,86,0,76,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,32,86,82,84,89,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,85,91,88,89,91,86,0,77,92,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,83,77,91,32,77,91,78,88,79,86,81,83,83,82,85,82,86,83,86,85,85,88,85,90,86,91,87,91,89,90,90,89,92,86,0,80,87,83,77,83,78,84,78,84,77,83,77,32,80,86,82,82,80,88,80,90,81,91,82,91,84,90,85,89,87,86,0,80,87,83,77,83,78,84,78,84,77,83,77,32,80,86,82,82,76,100,75,102,73,103,72,102,72,100,73,97,76,94,79,92,81,91,84,89,87,86,0,77,91,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,83,77,91,32,77,91,78,88,79,86,81,83,83,82,85,82,86,83,86,85,84,86,81,86,32,81,86,83,87,84,90,85,91,86,91,88,90,89,89,91,86,0,79,87,79,86,81,83,84,78,85,76,86,73,86,71,85,70,83,71,82,73,81,77,80,84,80,90,81,91,82,91,84,90,85,89,87,86,0,69,94,69,86,71,83,73,82,74,83,74,84,73,88,72,91,32,73,88,74,86,76,83,78,82,80,82,81,83,81,84,80,88,79,91,32,80,88,81,86,83,83,85,82,87,82,88,83,88,85,87,88,87,90,88,91,89,91,91,90,92,89,94,86,0,74,92,74,86,76,83,78,82,79,83,79,84,78,88,77,91,32,78,88,79,86,81,83,83,82,85,82,86,83,86,85,85,88,85,90,86,91,87,91,89,90,90,89,92,86,0,76,90,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,85,87,85,85,84,83,82,82,81,83,81,85,82,87,84,88,87,88,89,87,90,86,0,75,90,75,86,77,83,78,81,77,85,71,103,32,77,85,78,83,80,82,82,82,84,83,85,85,85,87,84,89,83,90,81,91,32,77,90,79,91,82,91,85,90,87,89,90,86,0,76,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,32,86,82,85,85,83,90,80,97,79,100,79,102,80,103,82,102,83,99,83,92,85,91,88,89,91,86,0,77,90,77,86,79,83,80,81,80,83,83,83,84,84,84,86,83,89,83,90,84,91,85,91,87,90,88,89,90,86,0,78,89,78,86,80,83,81,81,81,83,83,86,84,88,84,90,82,91,32,78,90,80,91,84,91,86,90,87,89,89,86,0,79,88,79,86,81,83,83,79,32,86,70,80,88,80,90,81,91,83,91,85,90,86,89,88,86,32,80,78,87,78,0,76,91,76,86,78,82,76,88,76,90,77,91,79,91,81,90,83,88,85,85,32,86,82,84,88,84,90,85,91,86,91,88,90,89,89,91,86,0,76,91,76,86,78,82,77,87,77,90,78,91,79,91,82,90,84,88,85,85,85,82,32,85,82,86,86,87,87,89,87,91,86,0,73,94,76,82,74,84,73,87,73,89,74,91,76,91,78,90,80,88,32,82,82,80,88,80,90,81,91,83,91,85,90,87,88,88,85,88,82,32,88,82,89,86,90,87,92,87,94,86,0,74,90,74,86,76,83,78,82,80,82,81,83,81,90,82,91,85,91,88,89,90,86,32,87,83,86,82,84,82,83,83,79,90,78,91,76,91,75,90,0,76,91,76,86,78,82,76,88,76,90,77,91,79,91,81,90,83,88,85,85,32,86,82,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,85,91,88,89,91,86,0,76,90,76,86,78,83,80,82,82,82,84,84,84,86,83,88,81,90,78,91,80,92,81,94,81,97,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,87,89,90,86,0,74,92,75,91,78,90,81,88,83,86,85,83,87,79,88,75,88,73,87,71,85,70,83,71,82,72,81,74,80,79,80,84,81,88,82,90,84,91,86,91,88,90,89,89,0,73,91,87,85,87,82,86,79,85,78,83,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,88,80,88,75,87,72,86,71,84,70,82,70,80,71,78,73,0,74,90,87,78,85,77,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,84,91,86,90,32,77,84,85,84,0,74,91,84,70,82,71,80,74,79,76,78,79,77,84,77,88,78,90,79,91,81,91,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,84,70,32,78,80,87,80,0,72,92,86,70,78,98,32,81,77,78,78,76,80,75,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,82,88,80,86,78,83,77,81,77,0,73,91,88,79,87,78,84,77,81,77,78,78,77,79,76,81,76,83,77,85,79,87,83,90,84,92,84,94,83,95,81,95,0,68,97,87,78,86,76,84,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,84,86,86,85,87,83,32,87,75,87,83,88,85,89,86,91,86,92,85,93,83,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,0,70,94,90,73,74,82,90,91,0,70,94,74,73,90,82,74,91,0,75,89,79,66,79,98,32,79,66,86,66,32,79,98,86,98,0,75,89,85,66,85,98,32,78,66,85,66,32,78,98,85,98,0,75,89,84,66,81,69,80,72,80,74,81,77,83,79,83,80,79,82,83,84,83,85,81,87,80,90,80,92,81,95,84,98,0,75,89,80,66,83,69,84,72,84,74,83,77,81,79,81,80,85,82,81,84,81,85,83,87,84,90,84,92,83,95,80,98,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,73,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,0,74,90,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,0,72,92,78,74,80,73,83,70,83,91,0,72,92,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,85,81,75,91,89,91,0,72,92,77,70,88,70,82,78,85,78,87,79,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,0,72,92,85,70,75,84,90,84,32,85,70,85,91,0,72,92,87,70,77,70,76,79,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,0,72,92,88,73,87,71,84,70,82,70,79,71,77,74,76,79,76,84,77,88,79],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+260340);allocate([90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,76,84,0,72,92,89,70,79,91,32,75,70,89,70,0,72,92,80,70,77,71,76,73,76,75,77,77,79,78,83,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,84,76,82,78,80,81,79,85,78,87,77,88,75,88,73,87,71,84,70,80,70,0,72,92,88,77,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,82,70,85,71,87,73,88,77,88,82,87,87,85,90,82,91,80,91,77,90,76,88,0,77,87,82,89,81,90,82,91,83,90,82,89,0,77,87,83,90,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,77,81,78,82,79,83,78,82,77,32,82,89,81,90,82,91,83,90,82,89,0,77,87,82,77,81,78,82,79,83,78,82,77,32,83,90,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,70,82,84,32,82,89,81,90,82,91,83,90,82,89,0,73,91,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,86,79,82,81,82,84,32,82,89,81,90,82,91,83,90,82,89,0,78,86,82,70,82,77,0,74,90,78,70,78,77,32,86,70,86,77,0,75,89,81,70,79,71,78,73,78,75,79,77,81,78,83,78,85,77,86,75,86,73,85,71,83,70,81,70,0,72,92,80,66,80,95,32,84,66,84,95,32,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,71,93,91,66,73,98,0,75,89,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,0,78,86,82,66,82,98,0,69,95,73,82,91,82,0,69,95,82,73,82,91,32,73,82,91,82,0,69,95,73,79,91,79,32,73,85,91,85,0,71,93,75,75,89,89,32,89,75,75,89,0,74,90,82,76,82,88,32,77,79,87,85,32,87,79,77,85,0,77,87,82,81,81,82,82,83,83,82,82,81,0,77,87,83,70,82,71,81,73,81,75,82,76,83,75,82,74,0,77,87,82,72,81,71,82,70,83,71,83,73,82,75,81,76,0,69,95,85,77,88,80,91,82,88,84,85,87,32,73,82,91,82,0,71,93,79,70,79,98,32,85,70,85,98,32,74,81,90,81,32,74,87,90,87,0,69,95,92,79,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,76,91,74,90,73,89,72,87,72,85,73,83,74,82,81,78,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,75,78,78,80,81,85,88,87,90,89,91,91,91,92,90,92,89,0,71,93,73,73,74,75,75,79,75,85,74,89,73,91,32,91,73,90,75,89,79,89,85,90,89,91,91,32,73,73,75,74,79,75,85,75,89,74,91,73,32,73,91,75,90,79,89,85,89,89,90,91,91,0,70,95,92,81,91,79,89,78,87,78,85,79,84,80,81,84,80,85,78,86,76,86,74,85,73,83,73,81,74,79,76,78,78,78,80,79,81,80,84,84,85,85,87,86,89,86,91,85,92,83,92,81,0,75,89,79,66,79,91,32,85,66,85,91,0,70,94,82,66,82,91,32,73,91,91,91,0,70,94,91,66,73,91,91,91,0,69,95,82,73,81,74,82,75,83,74,82,73,32,73,89,72,90,73,91,74,90,73,89,32,91,89,90,90,91,91,92,90,91,89,0,70,94,82,72,78,76,75,80,74,83,74,85,75,87,77,88,79,88,81,87,82,85,32,82,72,86,76,89,80,90,83,90,85,89,87,87,88,85,88,83,87,82,85,32,82,85,81,89,80,92,32,82,85,83,89,84,92,32,80,92,84,92,0,70,94,82,78,81,75,80,73,78,72,77,72,75,73,74,75,74,79,75,82,76,84,78,87,82,92,32,82,78,83,75,84,73,86,72,87,72,89,73,90,75,90,79,89,82,88,84,86,87,82,92,0,70,94,82,71,80,74,76,79,73,82,32,82,71,84,74,88,79,91,82,32,73,82,76,85,80,90,82,93,32,91,82,88,85,84,90,82,93,0,70,94,82,84,84,87,86,88,88,88,90,87,91,85,91,83,90,81,88,80,86,80,83,81,32,83,81,85,79,86,77,86,75,85,73,83,72,81,72,79,73,78,75,78,77,79,79,81,81,32,81,81,78,80,76,80,74,81,73,83,73,85,74,87,76,88,78,88,80,87,82,84,32,82,84,81,89,80,92,32,82,84,83,89,84,92,32,80,92,84,92,0,70,94,82,82,82,91,81,92,32,82,86,81,92,32,82,73,81,72,79,72,78,73,78,75,79,78,82,82,32,82,73,83,72,85,72,86,73,86,75,85,78,82,82,32,82,82,78,79,76,78,74,78,73,79,73,81,74,82,32,82,82,86,79,88,78,90,78,91,79,91,81,90,82,32,82,82,78,85,76,86,74,86,73,85,73,83,74,82,32,82,82,86,85,88,86,90,86,91,85,91,83,90,82,0,70,94,73,83,74,83,76,84,77,86,77,88,76,90,32,73,83,73,82,74,81,76,81,77,82,78,84,78,87,77,89,76,90,32,82,71,80,73,79,76,79,79,81,85,81,88,80,90,82,92,32,82,71,84,73,85,76,85,79,83,85,83,88,84,90,82,92,32,91,83,91,82,90,81,88,81,87,82,86,84,86,87,87,89,88,90,32,91,83,90,83,88,84,87,86,87,88,88,90,32,75,86,89,86,0,80,83,83,82,82,83,81,83,80,82,80,81,81,80,82,80,83,81,83,83,82,85,81,86,32,81,81,81,82,82,82,82,81,81,81,0,80,84,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,32,82,81,81,82,82,83,83,82,82,81,0,78,86,80,79,84,85,32,84,79,80,85,32,78,82,86,82,0,77,87,82,75,81,77,79,80,77,82,32,82,75,83,77,85,80,87,82,32,82,77,79,81,32,82,77,85,81,32,82,79,80,81,32,82,79,84,81,32,81,81,83,81,32,77,82,87,82,0,77,87,77,82,77,81,78,79,79,78,81,77,83,77,85,78,86,79,87,81,87,82,32,80,78,84,78,32,79,79,85,79,32,78,80,86,80,32,78,81,86,81,32,77,82,87,82,0,76,82,76,70,76,82,82,82,76,70,32,76,73,80,81,32,76,76,79,82,32,76,79,77,81,0,77,87,82,75,81,77,79,80,77,82,32,82,75,83,77,85,80,87,82,0,77,87,87,82,87,81,86,79,85,78,83,77,81,77,79,78,78,79,77,81,77,82,0,71,93,93,82,93,80,92,77,90,74,87,72,84,71,80,71,77,72,74,74,72,77,71,80,71,82,0,77,87,77,82,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,82,0,76,88,76,80,78,82,81,83,83,83,86,82,88,80,0,82,85,82,85,84,84,85,82,84,80,82,79,0,82,86,82,82,85,80,86,78,86,76,85,75,84,75,0,78,82,82,82,79,80,78,78,78,76,79,75,80,75,0,77,87,87,72,86,71,84,70,81,70,79,71,78,72,77,74,77,76,78,78,79,79,85,83,86,84,87,86,87,88,86,90,85,91,83,92,80,92,78,91,77,90,0,71,93,73,87,72,86,71,84,71,81,72,79,73,78,75,77,77,77,79,78,80,79,84,85,85,86,87,87,89,87,91,86,92,85,93,83,93,80,92,78,91,77,0,71,93,82,82,84,85,85,86,87,87,89,87,91,86,92,85,93,83,93,81,92,79,91,78,89,77,87,77,85,78,84,79,80,85,79,86,77,87,75,87,73,86,72,85,71,83,71,81,72,79,73,78,75,77,77,77,79,78,80,79,82,82,0,72,92,75,70,75,91,32,72,70,91,70,81,80,91,90,32,90,86,91,89,92,91,32,90,86,90,89,32,87,89,90,89,32,87,89,90,90,92,91,0,75,89,85,65,82,66,80,67,78,69,76,72,75,76,75,82,76,85,78,87,81,88,83,88,86,87,88,85,89,82,32,75,80,76,77,78,75,81,74,83,74,86,75,88,77,89,80,89,86,88,90,86,93,84,95,82,96,79,97,0,62,102,62,82,102,82,0,68,96,68,96,96,68,0,82,82,82,62,82,102,0,68,96,68,68,96,96,0,68,96,68,82,96,82,0,70,94,70,89,94,75,0,75,89,75,94,89,70,0,75,89,75,70,89,94,0,70,94,70,75,94,89,0,75,89,75,82,89,82,0,77,87,77,87,87,77,0,77,87,77,77,87,87,0,68,96,68,79,71,81,75,83,80,84,84,84,89,83,93,81,96,79,0,80,85,85,68,83,71,81,75,80,80,80,84,81,89,83,93,85,96,0,79,84,79,68,81,71,83,75,84,80,84,84,83,89,81,93,79,96,0,68,96,68,85,71,83,75,81,80,80,84,80,89,81,93,83,96,85,0,75,89,82,74,89,78,75,86,82,90,0,74,90,74,82,78,75,86,89,90,82,0,75,89,75,86,75,78,89,86,89,78,0,74,90,76,88,74,80,90,84,88,76,0,74,90,74,93,76,93,79,92,81,91,84,88,85,86,86,83,86,79,85,76,84,74,83,73,81,73,80,74,79,76,78,79,78,83,79,86,80,88,83,91,85,92,88,93,90,93,0,73,93,93,90,93,88,92,85,91,83,88,80,86,79,83,78,79,78,76,79,74,80,73,81,73,83,74,84,76,85,79,86,83,86,86,85,88,84,91,81,92,79,93,76,93,74,0,74,90,90,71,88,71,85,72,83,73,80,76,79,78,78,81,78,85,79,88,80,90,81,91,83,91,84,90,85,88,86,85,86,81,85,78,84,76,81,73,79,72,76,71,74,71,0,71,91,71,74,71,76,72,79,73,81,76,84,78,85,81,86,85,86,88,85,90,84,91,83,91,81,90,80,88,79,85,78,81,78,78,79,76,80,73,83,72,85,71,88,71,90,0,69,91,69,80,70,82,72,84,74,85,77,86,81,86,85,85,88,83,90,80,91,78,90,76,87,76,83,77,81,78,78,80,76,83,75,86,75,89,76,92,77,94,0,69,89,69,84,72,86,75,87,80,87,83,86,86,84,88,81,89,78,89,76,88,75,86,75,83,76,80,78,78,81,77,84,77,89,78,92,80,95,0,79,85,81,79,79,81,79,83,81,85,83,85,85,83,85,81,83,79,81,79,32,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,32,82,81,81,82,82,83,83,82,82,81,0,68,96,68,82,74,82,32,79,82,85,82,32,90,82,96,82,0,68,96,68,85,68,79,96,79,96,85,0,74,90,82,68,74,82,32,82,68,90,82,0,68,96,68,82,96,82,32,74,89,90,89,32,80,96,84,96,0,68,96,68,82,96,82,32,68,82,82,98,32,96,82,82,98,0,75,89,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,0,76,88,76,76,76,88,88,88,88,76,76,76,0,75,89,82,74,75,86,89,86,82,74,0,76,88,82,72,76,82,82,92,88,82,82,72,0,74,90,82,73,80,79,74,79,79,83,77,89,82,85,87,89,85,83,90,79,84,79,82,73,0,75,89,82,75,82,89,32,75,82,89,82,0,77,87,77,77,87,87,32,87,77,77,87,0,77,87,82,76,82,88,32,77,79,87,85,32,87,79,77,85,0,78,86,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,32,79,81,79,83,32,80,80,80,84,32,81,79,81,85,32,82,79,82,85,32,83,79,83,85,32,84,80,84,84,32,85,81,85,83,0,78,86,78,78,78,86,86,86,86,78,78,78,32,79,79,79,85,32,80,79,80,85,32,81,79,81,85,32,82,79,82,85,32,83,79,83,85,32,84,79,84,85,32,85,79,85,85,0,77,87,82,76,77,85,87,85,82,76,32,82,79,79,84,32,82,79,85,84,32,82,82,81,84,32,82,82,83,84,0,76,85,76,82,85,87,85,77,76,82,32,79,82,84,85,32,79,82,84,79,32,82,82,84,83,32,82,82,84,81,0,77,87,82,88,87,79,77,79,82,88,32,82,85,85,80,32,82,85,79,80,32,82,82,83,80,32,82,82,81,80,0,79,88,88,82,79,77,79,87,88,82,32,85,82,80,79,32,85,82,80,85,32,82,82,80,81,32,82,82,80,83,0,76,88,82,76,78,87,88,80,76,80,86,87,82,76,32,82,82,82,76,32,82,82,76,80,32,82,82,78,87,32,82,82,86,87,32,82,82,88,80,0,77,87,82,76,82,88,32,79,79,85,79,32,77,85,79,87,81,88,83,88,85,87,87,85,0,76,88,82,76,82,88,32,76,81,77,79,87,79,88,81,32,80,87,84,87,0,75,89,77,78,87,88,32,87,78,77,88,32,79,76,76,79,75,81,32,85,76,88,79,89,81,0,73,91,78,73,73,91,32,86,73,91,91,32,77,77,91,91,32,87,77,73,91,32,78,73,86,73,32,77,77,87,77,0,73,91,82,71,82,86,32,77,74,87,80,32,87,74,77,80,32,73,86,76,92,32,91,86,88,92,32,73,86,91,86,32,76,92,88,92,0,71,91,77,74,83,86,32,75,80,83,76,32,71,92,91,92,91,82,71,92,0,76,88,80,76,80,80,76,80,76,84,80,84,80,88,84,88,84,84,88,84,88,80,84,80,84,76,80,76,0,75,89,89,80,88,78,86,76,83,75,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,84,32,89,80,87,78,85,77,83,77,81,78,80,79,79,81,79,83,80,85,81,86,83,87,85,87,87,86,89,84,0,75,89,82,74,75,86,89,86,82,74,32,82,90,89,78,75,78,82,90,0,71,93,80,73,80,71,81,70,83,70,84,71,84,73,32,71,90,72,88,74,86,75,84,76,80,76,75,77,74,79,73,85,73,87,74,88,75,88,80,89,84,90,86,92,88,93,90,32,71,90,93,90,32,81,90,80,91,81,92,83,92,84,91,83,90,0,74,90,82,77,82,83,32,82,83,81,92,32,82,83,83,92,32,81,92,83,92,32,82,77,81,74,80,72,78,71,32,81,74,78,71,32,82,77,83,74,84,72,86,71,32,83,74,86,71,32,82,77,78,75,76,75,74,77,32,80,76,76,76,74,77,32,82,77,86,75,88,75,90,77,32,84,76,88,76,90,77,32,82,77,80,78,79,79,79,82,32,82,77,80,79,79,82,32,82,77,84,78,85,79,85,82,32,82,77,84,79,85,82,0,74,90,82,73,82,75,32,82,78,82,80,32,82,83,82,85,32,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,71,81,73,80,74,32,82,71,83,73,84,74,32,80,74,82,73,84,74,32,82,75,80,78,78,79,77,78,32,82,75,84,78,86,79,87,78,32,78,79,80,79,82,78,84,79,86,79,32,82,80,80,83,78,84,76,84,75,82,75,83,76,84,32,82,80,84,83,86,84,88,84,89,82,89,83,88,84,32,78,84,80,84,82,83,84,84,86,84,32,82,85,80,88,79,89,77,90,76,90,75,89,74,87,74,89,76,90,32,82,85,84,88,85,89,87,90,88,90,89,89,90,87,90,89,88,90,32,77,90,79,90,82,89,85,90,87,90,0,74,90,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,89,85,90,88,90,90,88,90,85,89,84,87,84,89,82,90,79,89,77,87,76,85,77,86,74,85,72,83,71,81,71,79,72,78,74,79,77,77,76,75,77,74,79,75,82,77,84,75,84,74,85,74,88,76,90,79,90,82,89,0,74,90,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,89,86,88,86,86,88,85,88,82,90,81,90,76,89,73,88,72,86,72,84,71,80,71,78,72,76,72,75,73,74,76,74,81,76,82,76,85,78,86,78,88,82,89,0,73,91,73,80,75,82,32,76,75,78,80,32,82,71,82,79,32,88,75,86,80,32,91,80,89,82,0,81,83,82,81,81,82,82,83,83,82,82,81,0,80,84,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,0,78,86,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,0,77,87,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,0,71,93,80,71,77,72,74,74,72,77,71,80,71,84,72,87,74,90,77,92,80,93,84,93,87,92,90,90,92,87,93,84,93,80,92,77,90,74,87,72,84,71,80,71,0,65,99,80,65,76,66,74,67,71,69,69,71,67,74,66,76,65,80,65,84,66,88,67,90,69,93,71,95,74,97,76,98,80,99,84,99,88,98,90,97,93,95,95,93,97,90,98,88,99,84,99,80,98,76,97,74,95,71,93,69,90,67,88,66,84,65,80,65,0,60,104,80,60,75,61,71,63,68,65,65,68,63,71,61,75,60,80,60,84,61,89,63,93,65,96,68,99,71,101,75,103,80,104,84,104,89,103,93,101,96,99,99,96,101,93,103,89,104,84,104,80,103,75,101,71,99,68,96,65,93,63,89,61,84,60,80,60,0,41,123,79,41,73,42,69,43,64,45,59,48,55,51,51,55,48,59,45,64,43,69,42,73,41,79,41,85,42,91,43,95,45,100,48,105,51,109,55,113,59,116,64,119,69,121,73,122,79,123,85,123,91,122,95,121,100,119,105,116,109,113,113,109,116,105,119,100,121,95,122,91,123,85,123,79,122,73,121,69,119,64,116,59,113,55,109,51,105,48,100,45,95,43,91,42,85,41,79,41,0,62,102,82,65,80,67,77,68,74,68,71,67,69,65,62,72,64,74,65,77,65,90,66,93,68,95,71,96,77,96,80,97,82,99,32,82,65,84,67,87,68,90,68,93,67,95,65,102,72,100,74,99,77,99,90,98,93,96,95,93,96,87,96,84,97,82,99,0,65,99,82,65,80,67,77,68,74,68,71,67,69,65,66,71,65,75,65,80,66,84,68,88,71,92,76,96,82,99,32,82,65,84,67,87,68,90,68,93,67,95,65,98,71,99,75,99,80,98,84,96,88,93,92,88,96,82,99,32,66,72,98,72,0,72,91,87,80,86,81,87,82,88,81,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,76,98,88,70,0,75,89,82,75,77,88,32,82,78,86,88,32,82,75,87,88,32,79,84,84,84,32,75,88,80,88,32,84,88,89,88,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,86,80,83,81,32,83,75,85,76,86,78,85,80,83,81,32,79,81,83,81,86,82,87,84,87,85,86,87,83,88,76,88,32,83,81,85,82,86,84,86,85,85,87,83,88,0,75,89,86,76,87,75,87,79,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,85,32,81,75,79,77,78,80,78,83,79,86,81,88,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,77,88,80,88,83,87,86,86,87,83,88,76,88,32,83,75,85,76,86,77,87,80,87,83,86,86,85,87,83,88,0,74,89,78,75,78,88,32,79,75,79,88,32,83,79,83,83,32,76,75,86,75,86,79,85,75,32,79,81,83,81,32,76,88,86,88,86,84,85,88,0,74,88,78,75,78,88,32,79,75,79,88,32,83,79,83,83,32,76,75,86,75,86,79,85,75,32,79,81,83,81,32,76,88,81,88,0,75,91,86,76,87,75,87,79,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,85,87,86,85,32,86,83,86,88,32,87,83,87,88,32,84,83,89,83,0,74,91,78,75,78,88,32,79,75,79,88,32,86,75,86,88,32,87,75,87,88,32,76,75,81,75,32,84,75,89,75,32,79,81,86,81,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,88,32,83,75,83,88,32,80,75,85,75,32,80,88,85,88,0,76,88,83,75,83,85,82,87,81,88,32,84,75,84,85,83,87,81,88,80,88,78,87,77,85,78,84,79,85,78,86,32,81,75,86,75,0,74,90,78,75,78,88,32,79,75,79,88,32,87,75,79,83,32,81,81,86,88,32,82,81,87,88,32,76,75,81,75,32,84,75,89,75,32,76,88,81,88,32,84,88,89,88,0,75,88,79,75,79,88,32,80,75,80,88,32,77,75,82,75,32,77,88,87,88,87,84,86,88,0,73,92,77,75,77,88,32,78,78,82,88,32,78,75,82,85,32,87,75,82,88,32,87,75,87,88,32,88,75,88,88,32,75,75,78,75,32,87,75,90,75,32,75,88,79,88,32,85,88,90,88,0,74,90,78,75,78,88,32,79,77,86,88,32,79,75,86,86,32,86,75,86,88,32,76,75,79,75,32,84,75,88,75,32,76,88,80,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,0,74,89,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,81,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,32,80,87,80,85,81,84,83,84,84,85,85,90,86,91,87,91,88,90,32,84,85,85,88,86,90,87,91,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,81,88,32,83,82,84,83,85,87,86,88,87,88,88,87,32,83,82,85,83,86,87,87,88,0,75,90,86,77,87,75,87,79,86,77,85,76,83,75,81,75,79,76,78,77,78,79,79,80,81,81,84,82,86,83,87,84,32,78,78,79,79,81,80,84,81,86,82,87,83,87,86,86,87,84,88,82,88,80,87,79,86,78,84,78,88,79,86,0,75,90,82,75,82,88,32,83,75,83,88,32,78,75,77,79,77,75,88,75,88,79,87,75,32,80,88,85,88,0,74,91,78,75,78,85,79,87,81,88,84,88,86,87,87,85,87,75,32,79,75,79,85,80,87,81,88,32,76,75,81,75,32,85,75,89,75,0,75,89,77,75,82,88,32,78,75,82,85,32,87,75,82,88,32,75,75,80,75,32,84,75,89,75,0,73,91,76,75,79,88,32,77,75,79,84,32,82,75,79,88,32,82,75,85,88,32,83,75,85,84,32,88,75,85,88,32,74,75,79,75,32,86,75,90,75,0,75,90,78,75,86,88,32,79,75,87,88,32,87,75,78,88,32,76,75,81,75,32,84,75,89,75,32,76,88,81,88,32,84,88,89,88,0,76,89,78,75,82,82,82,88,32,79,75,83,82,32,87,75,83,82,83,88,32,76,75,81,75,32,84,75,89,75,32,80,88,85,88,0,76,89,86,75,78,88,32,87,75,79,88,32,79,75,78,79,78,75,87,75,32,78,88,87,88,87,84,86,88,0,75,88,79,75,79,88,32,80,75,80,88,32,77,75,87,75,87,79,86,75,32,77,88,82,88,0,75,89,82,75,76,88,32,82,77,87,88,32,82,75,88,88,32,77,87,86,87,32,76,88,88,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,32,81,79,81,84,32,84,79,84,84,32,81,81,84,81,32,81,82,84,82,0,75,89,82,75,77,88,32,82,78,86,88,32,82,75,87,88,32,75,88,80,88,32,84,88,89,88,0,74,90,77,74,76,77,32,88,74,87,77,32,80,80,79,83,32,85,80,84,83,32,77,86,76,89,32,88,86,87,89,32,77,75,87,75,32,77,76,87,76,32,80,81,84,81,32,80,82,84,82,32,77,87,87,87,32,77,88,87,88,0,74,91,78,75,78,88,32,79,75,79,88,32,86,75,86,88,32,87,75,87,88,32,76,75,89,75,32,76,88,81,88,32,84,88,89,88,0,75,91,77,75,82,81,32,78,75,83,81,77,88,32,77,75,87,75,88,79,86,75,32,78,87,87,87,32,77,88,87,88,88,84,86,88,0,75,90,77,79,78,76,79,75,80,75,81,76,82,79,82,88,32,88,79,87,76,86,75,85,75,84,76,83,79,83,88,32,77,79,78,77,79,76,80,76,81,77,82,79,32,88,79,87,77,86,76,85,76,84,77,83,79,32,80,88,85,88,0,75,90,82,75,82,88,32,83,75,83,88,32,81,78,78,79,77,81,77,82,78,84,81,85,84,85,87,84,88,82,88,81,87,79,84,78,81,78,32,81,78,79,79,78,81,78,82,79,84,81,85,32,84,85,86,84,87,82,87,81,86,79,84,78,32,80,75,85,75,32,80,88,85,88,0,74,91,82,75,82,88,32,83,75,83,88,32,76,80,77,79,78,79,79,83,81,85,32,84,85,86,83,87,79,88,79,89,80,32,77,79,78,82,79,84,81,85,84,85,86,84,87,82,88,79,32,80,75,85,75,32,80,88,85,88,0,75,90,77,86,78,88,81,88,77,82,77,79,78,77,79,76,81,75,84,75,86,76,87,77,88,79,88,82,84,88,87,88,88,86,32,79,85,78,82,78,79,79,77,81,75,32,84,75,86,77,87,79,87,82,86,85,32,78,87,80,87,32,85,87,87,87,0,75,89,84,75,75,88,32,83,77,84,88,32,84,75,85,88,32,78,84,84,84,32,73,88,78,88,32,82,88,87,88,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,87,78,86,80,83,81,32,85,75,86,76,86,78,85,80,83,81,32,79,81,82,81,84,82,85,83,85,85,84,87,81,88,74,88,32,82,81,84,83,84,85,83,87,81,88,0,75,88,86,76,87,76,88,75,87,78,86,76,84,75,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,85,32,82,75,80,77,79,79,78,82,78,86,80,88,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,84,75,86,76,87,78,87,81,86,84,85,86,84,87,81,88,74,88,32,84,75,85,76,86,78,86,81,85,84,84,86,83,87,81,88,0,74,89,80,75,76,88,32,81,75,77,88,32,83,79,82,83,32,78,75,88,75,87,78,87,75,32,79,81,82,81,32,74,88,84,88,85,85,83,88,0,74,88,80,75,76,88,32,81,75,77,88,32,83,79,82,83,32,78,75,88,75,87,78,87,75,32,79,81,82,81,32,74,88,79,88,0,75,89,86,76,87,76,88,75,87,78,86,76,84,75,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,83,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,83,32,83,83,88,83,0,74,91,80,75,76,88,32,81,75,77,88,32,88,75,84,88,32,89,75,85,88,32,78,75,83,75,32,86,75,91,75,32,79,81,86,81,32,74,88,79,88,32,82,88,87,88,0,78,87,84,75,80,88,32,85,75,81,88,32,82,75,87,75,32,78,88,83,88,0,76,88,85,75,82,85,81,87,80,88,32,86,75,83,85,82,87,80,88,79,88,77,87,76,85,77,84,78,85,77,86,32,83,75,88,75,0,74,90,80,75,76,88,32,81,75,77,88,32,89,75,79,82,32,82,80,84,88,32,83,80,85,88,32,78,75,83,75,32,86,75,91,75,32,74,88,79,88,32,82,88,87,88,0,75,88,81,75,77,88,32,82,75,78,88,32,79,75,84,75,32,75,88,85,88,86,85,84,88,0,73,92,79,75,75,88,32,79,77,80,88,32,80,75,81,86,32,89,75,80,88,32,89,75,85,88,32,90,75,86,88,32,77,75,80,75,32,89,75,92,75,32,73,88,77,88,32,83,88,88,88,0,74,90,80,75,76,88,32,80,75,84,88,32,81,75,84,85,32,88,75,84,88,32,78,75,81,75,32,86,75,90,75,32,74,88,78,88,0,75,89,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,82,75,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,84,86,81,86,77,84,75,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,88,77,88,79,87,81,84,82,79,82,32,85,75,87,77,87,79,86,81,84,82,32,74,88,79,88,0,75,89,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,82,75,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,84,86,81,86,77,84,75,32,79,87,79,86,80,85,81,85,82,86,82,90,83,91,84,91,85,90,32,82,86,83,90,84,91,0,74,90,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,88,77,88,79,87,81,84,82,79,82,32,85,75,87,77,87,79,86,81,84,82,32,83,82,84,87,85,88,86,88,87,87,32,83,82,84,83,85,87,86,88,32,74,88,79,88,0,75,90,87,76,88,76,89,75,88,78,87,76,85,75,82,75,80,76,79,77,79,79,80,80,85,83,86,84,32,79,78,80,79,85,82,86,83,86,86,85,87,83,88,80,88,78,87,77,85,76,88,77,87,78,87,0,75,90,84,75,80,88,32,85,75,81,88,32,80,75,78,78,79,75,90,75,89,78,89,75,32,78,88,83,88,0,74,91,80,75,77,85,77,87,79,88,83,88,85,87,86,85,89,75,32,81,75,78,85,78,87,79,88,32,78,75,83,75,32,87,75,91,75,0,75,89,79,75,80,88,32,80,75,81,86,32,89,75,80,88,32,77,75,82,75,32,86,75,91,75,0,73,91,78,75,77,88,32,79,75,78,86,32,84,75,77,88,32,84,75,83,88,32,85,75,84,86,32,90,75,83,88,32,76,75,81,75,32,88,75,92,75,0,75,90,80,75,84,88,32,81,75,85,88,32,89,75,76,88,32,78,75,83,75,32,86,75,91,75,32,74,88,79,88,32,82,88,87,88,0,76,89,80,75,82,81,80,88,32,81,75,83,81,32,89,75,83,81,81,88,32,78,75,83,75,32,86,75,91,75,32,78,88,83,88,0,76,89,88,75,76,88,32,89,75,77,88,32,81,75,79,78,80,75,89,75,32,76,88,85,88,86,85,84,88,0,75,90,77,72,88,92,0,74,90,82,77,76,87,32,82,77,88,87,0,76,90,81,79,80,80,80,81,79,81,79,80,81,79,84,79,86,81,86,87,87,88,88,88,32,84,79,85,81,85,87,87,88,32,85,82,82,83,80,84,79,85,79,87,80,88,83,88,84,87,85,85,32,82,83,80,85,80,87,81,88,0,74,89,78,75,78,88,32,79,75,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,85,86,87,84,88,82,88,80,87,79,85,32,84,79,85,80,86,82,86,85,85,87,84,88,32,76,75,79,75,0,76,88,86,81,85,81,85,82,86,82,86,81,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,86,32,81,79,80,80,79,82,79,85,80,87,81,88,0,76,91,86,75,86,88,32,87,75,87,88,32,86,82,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,85,32,81,79,80,80,79,82,79,85,80,87,81,88,32,84,75,87,75,32,86,88,89,88,0,76,88,79,83,86,83,86,82,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,86,32,85,83,85,81,83,79,32,81,79,80,80,79,82,79,85,80,87,81,88,0,76,87,84,75,85,76,85,77,86,77,86,76,84,75,82,75,80,77,80,88,32,82,75,81,77,81,88,32,78,79,83,79,32,78,88,83,88,0,76,89,81,79,79,81,79,83,81,85,83,85,85,83,85,81,83,79,81,79,32,81,79,80,81,80,83,81,85,32,83,85,84,83,84,81,83,79,32,84,80,85,79,86,79,32,80,84,79,85,79,88,80,89,84,89,86,90,32,79,87,80,88,84,88,86,89,86,91,84,92,80,92,78,91,78,89,80,88,0,74,91,78,75,78,88,32,79,75,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,88,32,84,79,85,80,86,82,86,88,32,76,75,79,75,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,76,83,76,83,75,82,75,32,82,79,82,88,32,83,79,83,88,32,80,79,83,79,32,80,88,85,88,0,78,87,83,75,83,76,84,76,84,75,83,75,32,83,79,83,90,82,92,32,84,79,84,90,82,92,80,92,79,91,79,90,80,90,80,91,79,91,32,81,79,84,79,0,74,90,78,75,78,88,32,79,75,79,88,32,87,79,79,85,32,82,83,86,88,32,83,83,87,88,32,76,75,79,75,32,84,79,89,79,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,88,32,83,75,83,88,32,80,75,83,75,32,80,88,85,88,0,70,95,74,79,74,88,32,75,79,75,88,32,75,82,76,80,78,79,80,79,82,80,83,82,83,88,32,80,79,81,80,82,82,82,88,32,83,82,84,80,86,79,88,79,90,80,91,82,91,88,32,88,79,89,80,90,82,90,88,32,72,79,75,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,74,91,78,79,78,88,32,79,79,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,88,32,84,79,85,80,86,82,86,88,32,76,79,79,79,32,76,88,81,88,32,84,88,89,88,0,76,89,81,79,79,80,78,82,78,85,79,87,81,88,84,88,86,87,87,85,87,82,86,80,84,79,81,79,32,81,79,80,80,79,82,79,85,80,87,81,88,32,84,88,85,87,86,85,86,82,85,80,84,79,0,74,89,78,79,78,92,32,79,79,79,92,32,79,82,80,80,82,79,84,79,86,80,87,82,87,85,86,87,84,88,82,88,80,87,79,85,32,84,79,85,80,86,82,86,85,85,87,84,88,32,76,79,79,79,32,76,92,81,92,0,75,89,85,79,85,92,32,86,79,86,92,32,85,82,84,80,82,79,80,79,78,80,77,82,77,85,78,87,80,88,82,88,84,87,85,85,32,80,79,79,80,78,82,78,85,79,87,80,88,32,83,92,88,92,0,75,88,79,79,79,88,32,80,79,80,88,32,80,82,81,80,83,79,85,79,86,80,86,81,85,81,85,80,86,80,32,77,79,80,79,32,77,88,82,88,0,76,89,84,79,85,80,85,81,86,81,86,80,84,79,81,79,79,80,79,82,81,83,84,84,86,85,32,79,81,81,82,84,83,86,84,86,87,84,88,81,88,79,87,79,86,80,86,80,87,81,88,0,76,87,80,75,80,86,82,88,84,88,85,87,85,86,32,81,75,81,86,82,88,32,78,79,84,79,0,74,91,78,79,78,85,79,87,81,88,83,88,85,87,86,85,32,79,79,79,85,80,87,81,88,32,86,79,86,88,32,87,79,87,88,32,76,79,79,79,32,84,79,87,79,32,86,88,89,88,0,75,89,78,79,82,88,32,79,79,82,86,32,86,79,82,88,32,76,79,81,79,32,84,79,88,79,0,73,91,76,79,79,88,32,77,79,79,85,32,82,79,79,88,32,82,79,85,88,32,83,79,85,85,32,88,79,85,88,32,74,79,79,79,32,86,79,90,79,0,75,89,78,79,85,88,32,79,79,86,88,32,86,79,78,88,32,76,79,81,79,32,84,79,88,79,32,76,88,80,88,32,83,88,88,88,0,75,89,78,79,82,88,32,79,79,82,86,32,86,79,82,88,80,91,78,92,77,92,76,91,76,90,77,90,77,91,76,91,32,76,79,81,79,32,84,79,88,79,0,76,88,85,79,78,88,32,86,79,79,88,32,79,79,78,81,78,79,86,79,32,78,88,86,88,86,86,85,88,0,75,91,81,79,79,80,78,81,77,83,77,85,78,87,80,88,81,88,83,87,85,85,87,82,88,79,32,81,79,79,81,78,83,78,85,79,87,80,88,32,81,79,83,79,85,80,87,87,88,88,32,83,79,84,80,86,87,88,88,89,88,0,75,88,82,75,80,77,79,79,77,85,75,92,32,81,76,80,78,78,84,76,92,32,82,75,84,75,86,76,86,78,85,80,82,81,32,84,75,85,76,85,78,84,80,82,81,32,82,81,84,82,85,84,85,86,84,87,82,88,81,88,79,87,78,84,32,82,81,83,82,84,84,84,86,82,88,0,75,89,76,81,78,79,80,79,82,80,83,83,83,88,82,92,32,76,81,78,80,80,80,82,81,83,83,32,87,79,86,82,83,88,81,92,0,75,89,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,82,78,81,76,81,75,82,74,84,74,85,75,86,77,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,32,81,76,82,75,84,75,86,77,0,76,88,86,80,84,79,81,79,79,80,79,81,80,82,82,83,32,81,79,80,80,80,81,82,83,32,82,83,79,84,78,85,78,87,80,88,83,88,85,87,32,82,83,80,84,79,85,79,87,80,88,0,76,87,82,75,81,76,81,77,83,78,86,78,86,77,83,78,80,79,79,80,78,82,78,84,79,86,80,87,82,88,83,89,83,91,82,92,80,92,79,91,32,83,78,81,79,80,80,79,82,79,84,80,86,82,88,0,73,89,74,82,75,80,76,79,78,79,79,80,79,81,77,88,32,77,79,78,80,78,81,76,88,32,79,81,80,80,82,79,84,79,86,80,86,82,83,92,32,84,79,85,80,85,82,82,92,0,73,89,74,83,75,81,76,80,78,80,79,81,79,86,80,88,32,77,80,78,81,78,85,79,87,80,88,81,88,83,87,84,86,85,84,86,81,86,78,85,76,84,75,82,75,81,76,81,78,82,80,85,82,87,83,32,81,88,83,86,84,84,85,81,85,78,84,75,0,78,87,82,79,80,86,80,87,81,88,83,88,85,87,86,85,32,83,79,81,86,81,87,82,88,0,75,89,79,79,76,88,32,80,79,77,88,32,85,79,86,80,87,80,86,79,84,79,82,81,79,82,32,79,82,80,83,82,87,84,88,86,87,87,85,32,79,82,81,83,83,87,84,88,0,76,88,76,75,78,75,80,76,87,88,32,78,75,79,76,86,88,32,82,80,77,88,32,82,80,78,88,0,75,90,79,79,75,92,32,80,79,76,92,32,78,85,78,87,79,88,81,88,83,87,84,86,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,0,74,89,78,79,77,88,32,79,79,78,85,77,88,32,86,82,86,79,87,79,86,82,84,85,81,87,78,88,77,88,32,76,79,79,79,0,77,88,82,75,81,76,81,77,83,78,86,78,32,84,78,81,79,80,80,80,82,82,83,85,83,32,84,78,82,79,81,80,81,82,82,83,32,83,83,80,84,79,85,79,87,81,88,83,89,84,90,84,91,83,92,81,92,32,83,83,81,84,80,85,80,87,81,88,0,75,88,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,83,79,81,79,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,0,73,90,80,80,77,88,32,80,80,78,88,32,84,80,83,88,32,84,80,84,88,32,75,81,77,79,88,79,32,75,81,77,80,88,80,0,74,88,83,79,81,79,79,80,78,81,77,83,74,92,32,81,79,79,81,78,83,75,92,32,83,79,85,80,86,82,86,84,85,86,84,87,82,88,80,88,78,87,77,85,32,83,79,85,81,85,84,84,86,82,88,0,75,91,89,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,89,80,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,0,75,90,83,80,81,88,32,83,80,82,88,32,77,81,79,79,88,79,32,77,81,79,80,88,80,0,74,88,75,82,76,80,77,79,79,79,80,80,80,82,79,85,79,87,80,88,32,78,79,79,80,79,82,78,85,78,87,80,88,81,88,83,87,85,85,86,82,86,79,85,79,86,80,0,75,90,79,80,78,81,77,83,77,85,78,87,80,88,82,88,85,87,87,85,88,82,88,80,87,79,85,79,84,80,83,82,82,85,79,92,32,77,85,78,86,80,87,82,87,85,86,87,84,88,82,32,88,81,87,80,85,80,83,82,32,82,85,81,88,80,92,0,75,88,77,79,78,79,80,80,83,91,84,92,32,78,79,79,80,82,91,84,92,85,92,32,86,79,84,82,78,89,76,92,0,73,91,84,75,81,92,32,85,75,80,92,32,74,82,75,80,76,79,78,79,79,80,79,86,80,87,83,87,85,86,87,84,32,77,79,78,80,78,84,79,87,80,88,83,88,85,87,87,84,88,82,89,79,0,74,90,78,80,80,80,80,79,78,80,77,81,76,83,76,85,77,87,78,88,80,88,81,87,82,85,83,82,32,76,85,78,87,80,87,82,85,32,82,82,82,87,83,88,85,88,87,86,88,84,88,82,87,80,86,79,86,80,87,80,32,82,85,83,87,85,87,87,86,0,75,90,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,0,74,88,79,75,77,82,32,80,75,78,82,78,86,80,88,32,78,82,79,80,81,79,83,79,85,80,86,82,86,84,85,86,84,87,82,88,80,88,78,87,77,85,77,82,32,83,79,85,81,85,84,84,86,82,88,32,77,75,80,75,0,75,88,85,80,85,81,86,81,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,32,81,79,79,81,78,83,78,86,80,88,0,75,90,87,75,84,86,84,87,85,88,87,88,88,87,89,85,32,88,75,85,86,85,87,86,88,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,32,85,75,88,75,0,75,87,78,85,82,84,84,83,85,82,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,32,81,79,79,81,78,83,78,86,80,88,0,77,88,87,75,88,76,88,75,86,75,84,76,83,78,80,89,79,91,78,92,32,86,75,85,76,84,78,81,89,80,91,78,92,76,92,76,91,77,92,32,80,79,86,79,0,75,89,86,79,84,86,83,89,82,91,32,87,79,85,86,84,89,82,91,80,92,77,92,76,91,77,91,78,92,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,0,75,90,80,75,76,88,32,81,75,77,88,32,79,81,80,80,82,79,84,79,86,80,86,82,85,85,85,87,86,88,32,84,79,85,80,85,82,84,85,84,87,85,88,87,88,88,87,89,85,32,78,75,81,75,0,77,87,83,75,83,76,84,76,84,75,83,75,32,78,82,79,80,80,79,82,79,83,80,83,82,82,85,82,87,83,88,32,81,79,82,80,82,82,81,85,81,87,82,88,84,88,85,87,86,85,0,77,87,84,75,84,76,85,76,85,75,84,75,32,79,82,80,80,81,79,83,79,84,80,84,82,82,89,81,91,79,92,77,92,77,91,78,92],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+270580);allocate([32,82,79,83,80,83,82,81,89,80,91,79,92,0,75,88,80,75,76,88,32,81,75,77,88,32,86,80,85,81,86,81,86,80,85,79,84,79,82,81,80,82,79,82,32,79,82,80,83,81,87,82,88,84,88,85,87,86,85,32,79,82,81,83,82,87,83,88,32,78,75,81,75,0,78,86,83,75,80,86,80,87,81,88,83,88,84,87,85,85,32,84,75,81,86,81,87,82,88,32,81,75,84,75,0,70,94,71,82,72,80,73,79,75,79,76,80,76,81,74,88,32,74,79,75,80,75,81,73,88,32,76,81,77,80,79,79,81,79,83,80,83,81,81,88,32,81,79,82,80,82,81,80,88,32,83,81,84,80,86,79,88,79,90,80,90,82,89,85,89,87,90,88,32,88,79,89,80,89,82,88,85,88,87,89,88,91,88,92,87,93,85,0,74,91,75,82,76,80,77,79,79,79,80,80,80,81,78,88,32,78,79,79,80,79,81,77,88,32,80,81,81,80,83,79,85,79,87,80,87,82,86,85,86,87,87,88,32,85,79,86,80,86,82,85,85,85,87,86,88,88,88,89,87,90,85,0,74,89,75,82,76,80,77,79,79,79,80,80,80,81,77,92,32,78,79,79,80,79,81,76,92,32,80,81,82,79,84,79,86,80,87,82,87,84,86,86,85,87,83,88,81,88,79,86,79,84,32,84,79,86,81,86,84,85,86,83,88,32,74,92,79,92,0,75,89,86,79,82,92,32,87,79,83,92,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,32,80,92,85,92,0,76,88,77,82,78,80,79,79,81,79,82,80,82,81,80,88,32,80,79,81,80,81,81,79,88,32,82,81,83,80,85,79,86,79,87,80,87,81,86,81,87,80,0,76,89,86,80,86,81,87,81,86,80,84,79,81,79,79,80,79,82,81,83,84,84,86,85,32,79,81,81,82,84,83,86,84,86,87,84,88,81,88,79,87,78,86,79,86,79,87,0,78,87,83,75,80,86,80,87,81,88,83,88,84,87,85,85,32,84,75,81,86,81,87,82,88,32,80,79,85,79,0,73,90,74,82,75,80,76,79,78,79,79,80,79,82,78,85,78,87,79,88,32,77,79,78,80,78,82,77,85,77,87,79,88,81,88,83,87,84,86,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,0,72,92,73,82,74,80,75,79,77,79,78,80,78,82,77,85,77,87,78,88,32,76,79,77,80,77,82,76,85,76,87,78,88,79,88,81,87,82,86,32,84,79,82,86,82,87,84,88,32,85,79,83,86,83,87,84,88,85,88,87,87,89,85,90,82,90,79,89,79,90,80,0,74,90,77,82,78,80,80,79,82,79,83,80,83,82,32,81,79,82,80,82,82,81,85,80,87,78,88,77,88,76,87,76,86,77,86,76,87,32,88,80,87,81,88,81,88,80,87,79,86,79,84,80,83,82,82,85,82,87,83,88,32,81,85,81,87,82,88,84,88,86,87,87,85,0,73,89,74,82,75,80,76,79,78,79,79,80,79,82,78,85,78,87,79,88,32,77,79,78,80,78,82,77,85,77,87,79,88,81,88,83,87,84,86,32,86,79,84,86,83,89,82,91,32,87,79,85,86,84,89,82,91,80,92,77,92,76,91,77,91,78,92,0,75,89,87,79,87,80,86,81,78,86,77,87,77,88,32,78,81,79,79,82,79,85,81,32,79,80,82,80,85,81,86,81,32,78,86,79,86,82,87,85,87,32,79,86,82,88,85,88,86,86,0,72,91,82,75,83,76,83,77,84,77,84,76,82,75,79,75,77,76,76,78,76,88,32,79,75,78,76,77,78,77,88,32,88,75,89,76,89,77,90,77,90,76,88,75,86,75,84,77,84,88,32,86,75,85,77,85,88,32,74,79,87,79,32,74,88,79,88,32,82,88,87,88,0,74,91,85,75,86,76,87,76,87,75,81,75,79,76,78,78,78,88,32,81,75,80,76,79,78,79,88,32,86,79,86,88,32,87,79,87,88,32,76,79,87,79,32,76,88,81,88,32,84,88,89,88,0,74,91,87,75,81,75,79,76,78,78,78,88,32,81,75,80,76,79,78,79,88,32,85,75,86,76,86,88,32,87,75,87,88,32,76,79,86,79,32,76,88,81,88,32,84,88,89,88,0,70,95,80,75,81,76,81,77,82,77,82,76,80,75,77,75,75,76,74,78,74,88,32,77,75,76,76,75,78,75,88,32,89,75,90,76,91,76,91,75,85,75,83,76,82,78,82,88,32,85,75,84,76,83,78,83,88,32,90,79,90,88,32,91,79,91,88,32,72,79,91,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,70,95,80,75,81,76,81,77,82,77,82,76,80,75,77,75,75,76,74,78,74,88,32,77,75,76,76,75,78,75,88,32,91,75,85,75,83,76,82,78,82,88,32,85,75,84,76,83,78,83,88,32,89,75,90,76,90,88,32,91,75,91,88,32,72,79,90,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,78,87,82,79,82,88,32,83,79,83,88,32,80,79,83,79,32,80,88,85,88,0,76,88,86,80,84,79,82,79,80,80,79,81,78,83,78,85,79,87,81,88,83,88,85,87,32,82,79,80,81,79,83,79,86,81,88,32,79,83,83,83,0,76,89,83,75,81,76,80,77,79,79,78,82,78,85,79,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,85,75,83,75,32,83,75,81,77,80,79,79,83,79,86,80,88,32,82,88,84,86,85,84,86,80,86,77,85,75,32,79,81,86,81,0,75,90,84,75,81,92,32,85,75,80,92,32,81,79,78,80,77,82,77,85,78,87,81,88,84,88,87,87,88,85,88,82,87,80,84,79,81,79,32,81,79,79,80,78,82,78,85,79,87,81,88,32,84,88,86,87,87,85,87,82,86,80,84,79,0,76,88,85,80,86,82,86,81,85,80,83,79,81,79,79,80,78,82,78,84,79,86,82,88,32,81,79,79,81,79,84,80,86,82,88,83,89,83,91,82,92,80,92,0,73,91,86,75,87,76,88,76,86,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,90,75,91,76,91,75,89,75,87,76,86,78,83,89,82,91,81,92,32,89,75,88,76,87,78,84,89,83,91,81,92,79,92,79,91,80,92,32,76,79,89,79,0,73,90,86,75,87,76,88,76,88,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,32,76,79,87,79,0,73,90,86,75,87,76,32,88,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,87,75,84,86,84,87,85,88,87,88,88,87,89,85,32,88,75,85,86,85,87,86,88,32,76,79,86,79,0,70,94,83,75,84,76,84,77,32,85,76,83,75,80,75,78,76,77,77,76,79,73,89,72,91,71,92,32,80,75,78,77,77,79,74,89,73,91,71,92,69,92,69,91,70,92,32,90,75,91,76,92,76,92,75,87,75,85,76,32,84,77,83,79,80,89,79,91,78,92,32,87,75,85,77,84,79,81,89,80,91,78,92,76,92,76,91,77,92,32,90,79,88,86,88,87,89,88,91,88,92,87,93,85,32,91,79,89,86,89,87,90,88,32,73,79,91,79,0,70,94,83,75,84,76,84,77,32,85,76,83,75,80,75,78,76,77,77,76,79,73,89,72,91,71,92,32,80,75,78,77,77,79,74,89,73,91,71,92,69,92,69,91,70,92,32,90,75,91,76,32,92,75,87,75,85,76,32,84,77,83,79,80,89,79,91,78,92,32,87,75,85,77,84,79,81,89,80,91,78,92,76,92,76,91,77,92,32,91,75,88,86,88,87,89,88,91,88,92,87,93,85,32,92,75,89,86,89,87,90,88,32,73,79,90,79,0,77,87,78,82,79,80,80,79,82,79,83,80,83,82,82,85,82,87,83,88,32,81,79,82,80,82,82,81,85,81,87,82,88,84,88,85,87,86,85,0,79,85,0,76,88,0,76,89,81,75,79,76,78,79,78,84,79,87,81,88,84,88,86,87,87,84,87,79,86,76,84,75,81,75,32,81,75,80,76,79,79,79,84,80,87,81,88,32,84,88,85,87,86,84,86,79,85,76,84,75,0,76,89,80,78,83,75,83,88,32,82,76,82,88,32,79,88,86,88,0,76,89,79,77,79,78,78,78,78,77,79,76,81,75,84,75,86,76,87,78,86,80,84,81,81,82,79,83,78,85,78,88,32,84,75,85,76,86,78,85,80,84,81,32,78,87,79,86,80,86,83,87,86,87,87,86,32,80,86,83,88,86,88,87,86,87,85,0,76,89,79,77,79,78,78,78,78,77,79,76,81,75,84,75,86,76,87,78,86,80,84,81,32,84,75,85,76,86,78,85,80,84,81,32,82,81,84,81,86,82,87,84,87,85,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,32,84,81,85,82,86,84,86,85,85,87,84,88,0,76,89,83,77,83,88,32,84,75,84,88,32,84,75,77,84,88,84,32,81,88,86,88,0,76,89,79,75,78,81,32,79,75,86,75,32,79,76,83,76,86,75,32,78,81,79,80,81,79,84,79,86,80,87,82,87,85,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,32,84,79,85,80,86,82,86,85,85,87,84,88,0,76,89,86,77,86,78,87,78,87,77,86,76,84,75,82,75,80,76,79,77,78,80,78,85,79,87,81,88,84,88,86,87,87,85,87,83,86,81,84,80,81,80,78,82,32,82,75,80,77,79,80,79,85,80,87,81,88,32,84,88,85,87,86,85,86,83,85,81,84,80,0,76,89,78,75,78,79,32,86,77,82,84,80,88,32,87,75,84,81,81,88,32,78,77,80,75,82,75,85,77,32,78,77,80,76,82,76,85,77,86,77,0,76,89,81,75,79,76,78,78,79,80,81,81,84,81,86,80,87,78,86,76,84,75,81,75,32,81,75,80,76,79,78,80,80,81,81,32,84,81,85,80,86,78,85,76,84,75,32,81,81,79,82,78,84,78,85,79,87,81,88,84,88,86,87,87,85,87,84,86,82,84,81,32,81,81,80,82,79,84,79,85,80,87,81,88,32,84,88,85,87,86,85,86,84,85,82,84,81,0,76,89,79,86,79,85,78,85,78,86,79,87,81,88,83,88,85,87,86,86,87,83,87,78,86,76,84,75,81,75,79,76,78,78,78,80,79,82,81,83,84,83,87,81,32,83,88,85,86,86,83,86,78,85,76,84,75,32,81,75,80,76,79,78,79,80,80,82,81,83,0,78,86,82,86,81,87,82,88,83,87,82,86,0,78,86,83,87,82,88,81,87,82,86,83,87,83,89,81,91,0,78,86,82,79,81,80,82,81,83,80,82,79,32,82,86,81,87,82,88,83,87,82,86,0,78,86,82,79,81,80,82,81,83,80,82,79,32,83,87,82,88,81,87,82,86,83,87,83,89,81,91,0,78,86,82,75,81,76,82,83,83,76,82,75,32,82,76,82,79,32,82,86,81,87,82,88,83,87,82,86,0,76,89,78,78,79,78,79,79,78,79,78,78,79,76,81,75,84,75,86,76,87,78,87,79,86,81,83,82,82,83,82,84,83,84,32,84,75,86,77,86,80,85,81,83,82,32,82,87,82,88,83,88,83,87,82,87,0,79,86,82,75,82,80,32,83,75,82,80,0,76,88,79,75,79,80,32,80,75,79,80,32,85,75,85,80,32,86,75,85,80,0,77,87,81,75,80,76,80,78,81,79,83,79,84,78,84,76,83,75,81,75,0,77,87,82,74,82,80,32,79,75,85,79,32,85,75,79,79,0,75,90,88,72,77,92,0,77,87,85,72,83,74,81,77,80,80,80,84,81,87,83,90,85,92,32,83,74,82,76,81,80,81,84,82,88,83,90,0,77,87,79,72,81,74,83,77,84,80,84,84,83,87,81,90,79,92,32,81,74,82,76,83,80,83,84,82,88,81,90,0,77,87,80,72,80,92,32,81,72,81,92,32,80,72,85,72,32,80,92,85,92,0,77,87,83,72,83,92,32,84,72,84,92,32,79,72,84,72,32,79,92,84,92,0,76,87,83,72,82,73,81,75,81,77,82,79,82,80,80,82,82,84,82,85,81,87,81,89,82,91,83,92,32,82,73,81,77,32,81,75,82,79,32,82,85,81,89,32,81,87,82,91,0,77,88,81,72,82,73,83,75,83,77,82,79,82,80,84,82,82,84,82,85,83,87,83,89,82,91,81,92,32,82,73,83,77,32,83,75,82,79,32,82,85,83,89,32,83,87,82,91,0,77,87,84,72,80,82,84,92,0,77,87,80,72,84,82,80,92,0,79,85,82,72,82,92,0,77,87,80,72,80,92,32,84,72,84,92,0,73,91,76,82,88,82,0,73,91,82,76,82,88,32,76,82,88,82,0,74,90,82,77,82,88,32,77,82,87,82,32,77,88,87,88,0,74,90,82,77,82,88,32,77,77,87,77,32,77,82,87,82,0,74,90,77,77,87,87,32,87,77,77,87,0,78,86,82,81,81,82,82,83,83,82,82,81,0,73,91,82,76,81,77,82,78,83,77,82,76,32,76,82,88,82,32,82,86,81,87,82,88,83,87,82,86,0,73,91,76,80,88,80,32,76,84,88,84,0,73,91,87,76,77,88,32,76,80,88,80,32,76,84,88,84,0,73,91,76,78,88,78,32,76,82,88,82,32,76,86,88,86,0,74,90,87,76,77,82,87,88,0,74,90,77,76,87,82,77,88,0,74,90,87,75,77,79,87,83,32,77,84,87,84,32,77,88,87,88,0,74,90,77,75,87,79,77,83,32,77,84,87,84,32,77,88,87,88,0,72,91,89,85,87,85,85,84,84,83,82,80,81,79,79,78,78,78,76,79,75,81,75,82,76,84,78,85,79,85,81,84,82,83,84,80,85,79,87,78,89,78,0,74,90,76,84,76,82,77,80,79,80,85,83,87,83,88,82,32,76,82,77,81,79,81,85,84,87,84,88,82,88,80,0,74,90,77,83,82,80,87,83,32,77,83,82,81,87,83,0,78,86,83,75,80,79,32,83,75,84,76,80,79,0,78,86,81,75,84,79,32,81,75,80,76,84,79,0,76,88,78,75,79,77,81,78,83,78,85,77,86,75,32,78,75,79,78,81,79,83,79,85,78,86,75,0,78,86,83,76,82,77,81,76,82,75,83,76,83,78,81,80,0,78,86,83,75,81,77,81,79,82,80,83,79,82,78,81,79,0,78,86,81,76,82,77,83,76,82,75,81,76,81,78,83,80,0,78,86,81,75,83,77,83,79,82,80,81,79,82,78,83,79,0,74,90,87,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,87,87,0,74,90,77,77,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,77,0,74,90,77,77,83,77,85,78,86,79,87,81,87,83,86,85,85,86,83,87,77,87,0,74,90,77,87,77,81,78,79,79,78,81,77,83,77,85,78,86,79,87,81,87,87,0,74,90,87,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,87,87,32,77,82,85,82,0,73,91,84,79,85,80,88,82,85,84,84,85,32,85,80,87,82,85,84,32,76,82,87,82,0,77,87,82,77,82,88,32,79,80,80,79,82,76,84,79,85,80,32,80,79,82,77,84,79,0,73,91,80,79,79,80,76,82,79,84,80,85,32,79,80,77,82,79,84,32,77,82,88,82,0,77,87,82,76,82,87,32,79,84,80,85,82,88,84,85,85,84,32,80,85,82,87,84,85,0,75,89,86,83,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,81,75,80,76,81,76,82,75,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,86,81,86,78,85,76,84,75,0,74,90,76,75,82,88,32,77,75,82,86,32,88,75,82,88,32,76,75,88,75,32,78,76,87,76,0,71,91,73,79,76,79,82,87,32,75,79,82,88,32,91,70,82,88,0,73,91,88,73,88,74,89,74,89,73,88,72,86,72,84,74,83,76,82,79,81,85,80,89,79,91,32,85,73,84,75,83,79,82,85,81,88,80,90,78,92,76,92,75,91,75,90,76,90,76,91,0,73,91,88,73,88,74,89,74,89,73,88,72,86,72,84,74,83,76,82,79,81,85,80,89,79,91,32,85,73,84,75,83,79,82,85,81,88,80,90,78,92,76,92,75,91,75,90,76,90,76,91,32,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,0,72,92,90,82,89,84,87,85,86,85,84,84,83,83,81,80,80,79,78,78,77,78,75,79,74,81,74,82,75,84,77,85,78,85,80,84,81,83,83,80,84,79,86,78,87,78,89,79,90,81,90,82,0,74,90,88,75,76,88,32,79,75,80,76,80,78,79,79,77,79,76,78,76,76,77,75,79,75,83,76,86,76,88,75,32,85,84,84,85,84,87,85,88,87,88,88,87,88,85,87,84,85,84,0,74,91,89,80,88,80,88,81,89,81,89,80,88,79,87,79,86,80,85,84,84,86,83,87,81,88,79,88,77,87,76,86,76,84,77,83,79,82,82,80,83,78,83,76,82,75,80,75,79,76,79,78,80,81,85,87,87,88,88,88,89,87,32,79,88,77,86,77,84,79,82,32,79,78,80,80,86,87,87,88,0,74,91,85,80,83,79,81,79,80,81,80,82,81,84,83,84,85,83,32,85,79,85,83,86,84,88,84,89,82,89,81,88,78,86,76,83,75,82,75,79,76,77,78,76,81,76,82,77,85,79,87,82,88,83,88,86,87,0,75,90,81,72,81,92,32,84,72,84,92,32,87,76,86,76,86,77,87,77,87,76,85,75,80,75,78,76,78,78,79,80,86,83,87,84,32,78,78,79,79,86,82,87,84,87,86,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,78,86,0,75,89,80,75,80,91,32,84,75,84,91,32,77,81,87,81,32,77,85,87,85,0,76,88,84,76,83,76,83,77,84,77,84,76,83,75,81,75,80,76,80,78,81,80,84,82,85,83,32,80,78,81,79,84,81,85,83,85,85,83,87,32,81,80,79,82,79,84,80,86,83,88,84,89,32,79,84,80,85,83,87,84,89,84,91,83,92,81,92,80,91,80,90,81,90,81,91,80,91,0,76,88,82,75,81,76,82,77,83,76,82,75,32,82,77,82,81,32,82,81,81,83,82,86,83,83,82,81,32,82,86,82,92,32,80,79,79,78,78,79,79,80,80,79,84,79,85,78,86,79,85,80,84,79,0,76,88,82,77,83,76,82,75,81,76,82,77,82,81,81,82,83,85,82,86,32,82,81,83,82,81,85,82,86,82,90,81,91,82,92,83,91,82,90,32,80,79,79,78,78,79,79,80,80,79,84,79,85,78,86,79,85,80,84,79,32,80,88,79,87,78,88,79,89,80,88,84,88,85,87,86,88,85,89,84,88,0,76,89,86,75,86,88,32,78,75,86,75,32,81,81,86,81,32,78,88,86,88,0,72,92,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,32,82,81,81,82,82,83,83,82,82,81,0,76,89,81,75,80,76,80,77,81,78,32,84,75,85,76,85,77,84,78,32,82,78,80,79,79,81,79,82,80,84,82,85,83,85,85,84,86,82,86,81,85,79,83,78,82,78,32,82,85,82,89,32,83,85,83,89,32,79,87,86,87,0,76,89,82,75,80,76,79,78,79,79,80,81,82,82,83,82,85,81,86,79,86,78,85,76,83,75,82,75,32,82,82,82,88,32,83,82,83,88,32,79,85,86,85,0,72,92,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,32,82,75,82,89,32,75,82,89,82,0,74,89,82,82,80,81,79,81,77,82,76,84,76,85,77,87,79,88,80,88,82,87,83,85,83,84,82,82,32,87,77,82,82,32,82,77,87,77,87,82,32,82,77,86,78,87,82,0,74,90,76,76,77,75,79,75,81,76,82,78,82,80,81,82,80,83,78,84,32,79,75,80,76,81,78,81,81,80,83,32,86,75,85,88,32,87,75,84,88,32,78,84,88,84,0,74,89,78,75,78,85,32,79,75,78,82,32,78,82,79,80,81,79,83,79,85,80,86,81,86,84,84,86,84,88,85,89,86,89,87,88,32,83,79,85,81,85,84,84,86,32,76,75,79,75,0,76,89,79,78,82,75,82,81,32,86,78,83,75,83,81,32,82,81,80,82,79,84,79,85,80,87,82,88,83,88,85,87,86,85,86,84,85,82,83,81,32,82,84,82,85,83,85,83,84,82,84,0,74,90,82,75,82,89,32,77,75,77,80,78,82,80,83,84,83,86,82,87,80,87,75,32,76,77,77,75,78,77,32,81,77,82,75,83,77,32,86,77,87,75,88,77,32,79,86,85,86,0,74,89,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,86,88,86,85,85,88,0,76,89,87,75,84,75,81,76,79,78,78,81,78,83,79,86,81,88,84,89,87,89,32,87,75,84,76,82,78,81,81,81,83,82,86,84,88,87,89,0,74,90,82,82,80,81,79,81,77,82,76,84,76,85,77,87,79,88,80,88,82,87,83,85,83,84,82,82,32,83,76,81,81,32,87,77,82,82,32,88,81,83,83,0,75,89,80,77,84,87,32,84,77,80,87,32,77,80,87,84,32,87,80,77,84,0,74,91,79,85,77,85,76,86,76,88,77,89,79,89,80,88,80,86,78,84,77,82,77,79,78,77,79,76,81,75,84,75,86,76,87,77,88,79,88,82,87,84,85,86,85,88,86,89,88,89,89,88,89,86,88,85,86,85,32,78,77,80,76,85,76,87,77,0,74,91,79,79,77,79,76,78,76,76,77,75,79,75,80,76,80,78,78,80,77,82,77,85,78,87,79,88,81,89,84,89,86,88,87,87,88,85,88,82,87,80,85,78,85,76,86,75,88,75,89,76,89,78,88,79,86,79,32,78,87,80,88,85,88,87,87,0,70,94,75,72,75,92,32,76,72,76,92,32,88,72,88,92,32,89,72,89,92,32,72,72,92,72,32,72,92,79,92,32,85,92,92,92,0,72,93,75,72,82,81,74,92,32,74,72,81,81,32,74,72,89,72,90,77,88,72,32,75,91,88,91,32,74,92,89,92,90,87,88,92,0,75,89,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,32,84,68,82,72,81,75,80,80,80,84,81,89,82,92,84,96,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,32,80,68,82,72,83,75,84,80,84,84,83,89,82,92,80,96,0,75,89,79,66,79,98,32,80,66,80,98,32,79,66,86,66,32,79,98,86,98,0,75,89,84,66,84,98,32,85,66,85,98,32,78,66,85,66,32,78,98,85,98,0,74,89,84,66,81,69,80,72,80,74,81,77,83,79,83,80,79,82,83,84,83,85,81,87,80,90,80,92,81,95,84,98,32,82,68,81,71,81,75,82,78,32,82,86,81,89,81,93,82,96,0,75,90,80,66,83,69,84,72,84,74,83,77,81,79,81,80,85,82,81,84,81,85,83,87,84,90,84,92,83,95,80,98,32,82,68,83,71,83,75,82,78,32,82,86,83,89,83,93,82,96,0,75,89,85,64,82,67,80,70,79,73,79,76,80,79,83,86,84,89,84,92,83,95,82,97,32,82,67,81,69,80,72,80,75,81,78,84,85,85,88,85,91,84,94,82,97,79,100,0,75,89,79,64,82,67,84,70,85,73,85,76,84,79,81,86,80,89,80,92,81,95,82,97,32,82,67,83,69,84,72,84,75,83,78,80,85,79,88,79,91,80,94,82,97,85,100,0,65,88,67,82,71,82,82,96,32,71,83,82,97,32,70,83,82,98,32,88,58,82,98,0,70,94,91,67,90,68,91,69,92,68,92,67,91,66,89,66,87,67,85,69,84,71,83,74,82,78,80,90,79,94,78,96,32,86,68,85,70,84,74,82,86,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,96,73,95,74,96,73,97,0,72,92,82,70,75,91,32,82,70,89,91,32,82,73,88,91,32,77,85,86,85,32,73,91,79,91,32,85,91,91,91,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,32,85,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,32,77,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,71,92,88,73,89,76,89,70,88,73,86,71,83,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,32,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,73,91,32,83,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,83,91,0,71,92,76,70,76,91,32,77,70,77,91,32,83,76,83,84,32,73,70,89,70,89,76,88,70,32,77,80,83,80,32,73,91,89,91,89,85,88,91,0,71,91,76,70,76,91,32,77,70,77,91,32,83,76,83,84,32,73,70,89,70,89,76,88,70,32,77,80,83,80,32,73,91,80,91,0,71,94,88,73,89,76,89,70,88,73,86,71,83,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,32,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,32,88,83,88,91,32,89,83,89,91,32,85,83,92,83,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,76,80,88,80,32,72,91,79,91,32,85,91,92,91,0,77,88,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,79,91,86,91,0,75,90,85,70,85,87,84,90,82,91,80,91,78,90,77,88,77,86,78,85,79,86,78,87,32,84,70,84,87,83,90,82,91,32,81,70,88,70,0,70,92,75,70,75,91,32,76,70,76,91,32,89,70,76,83,32,81,79,89,91,32,80,79,88,91,32,72,70,79,70,32,85,70,91,70,32,72,91,79,91,32,85,91,91,91,0,73,91,78,70,78,91,32,79,70,79,91,32,75,70,82,70,32,75,91,90,91,90,85,89,91,0,70,95,75,70,75,91,32,76,70,82,88,32,75,70,82,91,32,89,70,82,91,32,89,70,89,91,32,90,70,90,91,32,72,70,76,70,32,89,70,93,70,32,72,91,78,91,32,86,91,93,91,0,71,94,76,70,76,91,32,77,70,89,89,32,77,72,89,91,32,89,70,89,91,32,73,70,77,70,32,86,70,92,70,32,73,91,79,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,77,81,32,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,32,73,91,80,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,32,78,89,78,88,79,86,81,85,82,85,84,86,85,88,86,95,87,96,89,96,90,94,90,93,32,85,88,86,92,87,94,88,95,89,95,90,94,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,77,80,32,85,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,32,73,91,80,91,32,82,80,84,81,85,82,88,89,89,90,90,90,91,89,32,84,81,85,83,87,90,88,91,90,91,91,89,91,88,0,72,92,88,73,89,70,89,76,88,73,86,71,83,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,89,84,32,75,75,77,77,79,78,85,80,87,81,88,82,89,84,89,88,87,90,84,91,81,91,78,90,76,88,75,85,75,91,76,88,0,73,92,82,70,82,91,32,83,70,83,91,32,76,70,75,76,75,70,90,70,90,76,89,70,32,79,91,86,91,0,70,94,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,32,76,70,76,85,77,88,79,90,81,91,32,72,70,79,70,32,86,70,92,70,0,72,92,75,70,82,91,32,76,70,82,88,32,89,70,82,91,32,73,70,79,70,32,85,70,91,70,0,70,94,74,70,78,91,32,75,70,78,86,32,82,70,78,91,32,82,70,86,91,32,83,70,86,86,32,90,70,86,91,32,71,70,78,70,32,87,70,93,70,0,72,92,75,70,88,91,32,76,70,89,91,32,89,70,75,91,32,73,70,79,70,32,85,70,91,70,32,73,91,79,91,32,85,91,91,91,0,72,93,75,70,82,81,82,91,32,76,70,83,81,83,91,32,90,70,83,81,32,73,70,79,70,32,86,70,92,70,32,79,91,86,91,0,72,92,88,70,75,91,32,89,70,76,91,32,76,70,75,76,75,70,89,70,32,75,91,89,91,89,85,88,91,0,73,91,78,70,78,91,32,79,70,79,91,32,75,70,90,70,90,76,89,70,32,75,91,82,91,0,72,92,82,70,74,91,32,82,70,90,91,32,82,73,89,91,32,75,90,89,90,32,74,91,90,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,32,79,77,79,84,32,85,77,85,84,32,79,80,85,80,32,79,81,85,81,0,72,92,82,70,75,91,32,82,70,89,91,32,82,73,88,91,32,73,91,79,91,32,85,91,91,91,0,71,93,75,69,74,74,32,90,69,89,74,32,79,78,78,83,32,86,78,85,83,32,75,87,74,92,32,90,87,89,92,32,75,71,89,71,32,75,72,89,72,32,79,80,85,80,32,79,81,85,81,32,75,89,89,89,32,75,90,89,90,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,92,70,32,72,91,79,91,32,85,91,92,91,0,72,93,75,70,82,80,74,91,32,74,70,81,80,32,74,70,89,70,90,76,88,70,32,75,90,88,90,32,74,91,89,91,90,85,88,91,0,73,92,75,75,75,73,76,71,77,70,79,70,80,71,81,73,82,77,82,91,32,75,73,77,71,79,71,81,73,32,90,75,90,73,89,71,88,70,86,70,85,71,84,73,83,77,83,91,32,90,73,88,71,86,71,84,73,32,79,91,86,91,0,72,93,82,70,82,91,32,83,70,83,91,32,80,75,77,76,76,77,75,79,75,82,76,84,77,85,80,86,85,86,88,85,89,84,90,82,90,79,89,77,88,76,85,75,80,75,32,80,75,78,76,77,77,76,79,76,82,77,84,78,85,80,86,32,85,86,87,85,88,84,89,82,89,79,88,77,87,76,85,75,32,79,70,86,70,32,79,91,86,91,0,71,94,82,70,82,91,32,83,70,83,91,32,73,77,74,76,76,77,77,81,78,83,79,84,81,85,32,74,76,75,77,76,81,77,83,78,84,81,85,84,85,87,84,88,83,89,81,90,77,91,76,32,84,85,86,84,87,83,88,81,89,77,91,76,92,77,32,79,70,86,70,32,79,91,86,91,0,71,93,74,88,75,91,79,91,77,87,75,83,74,80,74,76,75,73,77,71,80,70,84,70,87,71,89,73,90,76,90,80,89,83,87,87,85,91,89,91,90,88,32,77,87,76,84,75,80,75,76,76,73,78,71,80,70,32,84,70,86,71,88,73,89,76,89,80,88,84,87,87,32,75,90,78,90,32,86,90,89,90,0,72,92,85,70,72,91,32,85,70,86,91,32,84,72,85,91,32,76,85,85,85,32,70,91,76,91,32,82,91,88,91,0,70,94,79,70,73,91,32,80,70,74,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,32,87,70,89,71,90,73,90,75,89,78,88,79,86,80,32,77,80,86,80,88,81,89,83,89,85,88,88,86,90,82,91,70,91,32,86,80,87,81,88,83,88,85,87,88,85,90,82,91,0,72,93,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,83,91,85,90,87,88,88,86,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,78,90,80,91,0,70,93,79,70,73,91,32,80,70,74,91,32,76,70,85,70,88,71,89,72,90,75,90,79,89,83,87,87,85,89,83,90,79,91,70,91,32,85,70,87,71,88,72,89,75,89,79,88,83,86,87,84,89,82,90,79,91,0,70,93,79,70,73,91,32,80,70,74,91,32,84,76,82,84,32,76,70,91,70,90,76,90,70,32,77,80,83,80,32,70,91,85,91,87,86,84,91,0,70,92,79,70,73,91,32,80,70,74,91,32,84,76,82,84,32,76,70,91,70,90,76,90,70,32,77,80,83,80,32,70,91,77,91,0,72,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,82,91,85,90,87,88,89,84,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,78,90,80,91,32,82,91,84,90,86,88,88,84,32,85,84,92,84,0,69,95,78,70,72,91,32,79,70,73,91,32,91,70,85,91,32,92,70,86,91,32,75,70,82,70,32,88,70,95,70,32,76,80,88,80,32,69,91,76,91,32,82,91,89,91,0,76,89,85,70,79,91,32,86,70,80,91,32,82,70,89,70,32,76,91,83,91,0,73,91,88,70,83,87,82,89,81,90,79,91,77,91,75,90,74,88,74,86,75,85,76,86,75,87,32,87,70,82,87,81,89,79,91,32,84,70,91,70,0,70,93,79,70,73,91,32,80,70,74,91,32,93,70,76,83,32,83,79,87,91,32,82,79,86,91,32,76,70,83,70,32,89,70,95,70,32,70,91,77,91,32,83,91,89,91,0,72,92,81,70,75,91,32,82,70,76,91,32,78,70,85,70,32,72,91,87,91,89,85,86,91,0,69,96,78,70,72,91,32,78,70,79,91,32,79,70,80,89,32,92,70,79,91,32,92,70,86,91,32,93,70,87,91,32,75,70,79,70,32,92,70,96,70,32,69,91,75,91,32,83,91,90,91,0,70,95,79,70,73,91,32,79,70,86,88,32,79,73,86,91,32,92,70,86,91,32,76,70,79,70,32,89,70,95,70,32,70,91,76,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,83,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,78,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,0,70,93,79,70,73,91,32,80,70,74,91,32,76,70,88,70,91,71,92,73,92,75,91,78,89,80,85,81,77,81,32,88,70,90,71,91,73,91,75,90,78,88,80,85,81,32,70,91,77,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,83,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,78,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,32,76,89,76,88,77,86,79,85,80,85,82,86,83,88,83,95,84,96,86,96,87,94,87,93,32,83,88,84,94,85,95,86,95,87,94,0,70,94,79,70,73,91,32,80,70,74,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,77,80,32,87,70,89,71,90,73,90,75,89,78,88,79,86,80,32,82,80,84,81,85,82,86,90,87,91,89,91,90,89,90,88,32,85,82,87,89,88,90,89,90,90,89,32,70,91,77,91,0,71,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,75,78,77,79,78,86,82,88,84,32,77,75,79,77,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,73,91,74,89,75,89,0,72,93,85,70,79,91,32,86,70,80,91,32,79,70,76,76,78,70,93,70,92,76,92,70,32,76,91,83,91,0,70,95,78,70,75,81,74,85,74,88,75,90,78,91,82,91,85,90,87,88,88,85,92,70,32,79,70,76,81,75,85,75,88,76,90,78,91,32,75,70,82,70,32,89,70,95,70,0,72,92,78,70,79,91,32,79,70,80,89,32,92,70,79,91,32,76,70,82,70,32,88,70,94,70,0,69,95,77,70,75,91,32,78,70,76,89,32,85,70,75,91,32,85,70,83,91,32,86,70,84,89,32,93,70,83,91,32,74,70,81,70,32,90,70,96,70,0,71,93,78,70,85,91,32,79,70,86,91,32,92,70,72,91,32,76,70,82,70,32,88,70,94,70,32,70,91,76,91,32,82,91,88,91,0,72,93,78,70,82,80,79,91,32,79,70,83,80,80,91,32,93,70,83,80,32,76,70,82,70,32,89,70,95,70,32,76,91,83,91,0,71,93,91,70,72,91,32,92,70,73,91,32,79,70,76,76,78,70,92,70,32,72,91,86,91,88,85,85,91,0,72,92,75,73,76,75,88,87,89,89,89,91,32,76,76,88,88,32,75,73,75,75,76,77,88,89,89,91,32,80,80,76,84,75,86,75,88,76,90,75,91,32,75,86,77,90,32,76,84,76,86,77,88,77,90,75,91,32,83,83,88,78,32,86,73,86,76,87,78,89,78,89,76,87,75,86,73,32,86,73,87,76,89,78,0,72,92,81,73,75,91,32,83,73,89,91,32,82,73,88,91,32,77,85,86,85,32,73,91,79,91,32,85,91,91,91,32,81,66,79,67,78,69,78,71,79,73,81,74,83,74,85,73,86,71,86,69,85,67,83,66,81,66,0,71,93,73,66,91,98,0,70,94,82,74,73,90,32,82,74,91,90,0,73,93,78,79,78,80,77,80,77,79,78,78,80,77,84,77,86,78,87,79,88,81,88,88,89,90,90,91,32,87,79,87,88,88,90,90,91,91,91,32,87,81,86,82,80,83,77,84,76,86,76,88,77,90,80,91,83,91,85,90,87,88,32,80,83,78,84,77,86,77,88,78,90,80,91,0,71,92,76,70,76,91,32,77,70,77,91,32,77,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,73,70,77,70,0,72,91,87,80,86,81,87,82,88,81,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,0,72,93,87,70,87,91,32,88,70,88,91,32,87,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,87,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,84,70,88,70,32,87,91,91,91,0,72,91,76,83,88,83,88,81,87,79,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,87,83,87,80,86,78,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,0,75,88,85,71,84,72,85,73,86,72,86,71,85,70,83,70,81,71,80,73,80,91,32,83,70,82,71,81,73,81,91,32,77,77,85,77,32,77,91,84,91,0,73,92,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,32,79,78,78,80,78,84,79,86,32,85,86,86,84,86,80,85,78,32,86,79,87,78,89,77,89,78,87,78,32,78,85,77,86,76,88,76,89,77,91,80,92,85,92,88,93,89,94,32,76,89,77,90,80,91,85,91,88,92,89,94,89,95,88,97,85,98,79,98,76,97,75,95,75,94,76,92,79,91,0,71,93,76,70,76,91,32,77,70,77,91,32,77,80,79,78,82,77,84,77,87,78,88,80,88,91,32,84,77,86,78,87,80,87,91,32,73,70,77,70,32,73,91,80,91,32,84,91,91,91,0,77,88,82,70,81,71,82,72,83,71,82,70,32,82,77,82,91,32,83,77,83,91,32,79,77,83,77,32,79,91,86,91,0,77,88,83,70,82,71,83,72,84,71,83,70,32,84,77,84,95,83,97,81,98,79,98,78,97,78,96,79,95,80,96,79,97,32,83,77,83,95,82,97,81,98,32,80,77,84,77,0,71,92,76,70,76,91,32,77,70,77,91,32,87,77,77,87,32,82,83,88,91,32,81,83,87,91,32,73,70,77,70,32,84,77,90,77,32,73,91,80,91,32,84,91,90,91,0,77,88,82,70,82,91,32,83,70,83,91,32,79,70,83,70,32,79,91,86,91,0,66,99,71,77,71,91,32,72,77,72,91,32,72,80,74,78,77,77,79,77,82,78,83,80,83,91,32,79,77,81,78,82,80,82,91,32,83,80,85,78,88,77,90,77,93,78,94,80,94,91,32,90,77,92,78,93,80,93,91,32,68,77,72,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,71,93,76,77,76,91,32,77,77,77,91,32,77,80,79,78,82,77,84,77,87,78,88,80,88,91,32,84,77,86,78,87,80,87,91,32,73,77,77,77,32,73,91,80,91,32,84,91,91,91,0,72,92,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,83,87,80,85,78,83,77,0,71,92,76,77,76,98,32,77,77,77,98,32,77,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,73,77,77,77,32,73,98,80,98,0,72,92,87,77,87,98,32,88,77,88,98,32,87,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,87,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,84,98,91,98,0,73,90,78,77,78,91,32,79,77,79,91,32,79,83,80,80,82,78,84,77,87,77,88,78,88,79,87,80,86,79,87,78,32,75,77,79,77,32,75,91,82,91,0,74,91,87,79,88,77,88,81,87,79,86,78,84,77,80,77,78,78,77,79,77,81,78,82,80,83,85,85,87,86,88,87,32,77,80,78,81,80,82,85],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+280820);allocate([84,87,85,88,86,88,89,87,90,85,91,81,91,79,90,78,89,77,87,77,91,78,89,0,75,90,80,70,80,87,81,90,83,91,85,91,87,90,88,88,32,81,70,81,87,82,90,83,91,32,77,77,85,77,0,71,93,76,77,76,88,77,90,80,91,82,91,85,90,87,88,32,77,77,77,88,78,90,80,91,32,87,77,87,91,32,88,77,88,91,32,73,77,77,77,32,84,77,88,77,32,87,91,91,91,0,73,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,32,74,77,80,77,32,84,77,90,77,0,70,94,74,77,78,91,32,75,77,78,88,32,82,77,78,91,32,82,77,86,91,32,83,77,86,88,32,90,77,86,91,32,71,77,78,77,32,87,77,93,77,0,72,92,76,77,87,91,32,77,77,88,91,32,88,77,76,91,32,74,77,80,77,32,84,77,90,77,32,74,91,80,91,32,84,91,90,91,0,72,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,80,95,78,97,76,98,75,98,74,97,75,96,76,97,32,74,77,80,77,32,84,77,90,77,0,73,91,87,77,76,91,32,88,77,77,91,32,77,77,76,81,76,77,88,77,32,76,91,88,91,88,87,87,91,0,71,94,81,77,78,78,76,80,75,82,74,85,74,88,75,90,78,91,80,91,82,90,85,87,87,84,89,80,90,77,32,81,77,79,78,77,80,76,82,75,85,75,88,76,90,78,91,32,81,77,83,77,85,78,86,80,88,88,89,90,90,91,32,83,77,84,78,85,80,87,88,88,90,90,91,91,91,0,71,92,84,70,81,71,79,73,77,77,76,80,75,84,74,90,73,98,32,84,70,82,71,80,73,78,77,77,80,76,84,75,90,74,98,32,84,70,86,70,88,71,89,72,89,75,88,77,87,78,84,79,80,79,32,86,70,88,72,88,75,87,77,86,78,84,79,32,80,79,84,80,86,82,87,84,87,87,86,89,85,90,82,91,80,91,78,90,77,89,76,86,32,80,79,83,80,85,82,86,84,86,87,85,89,84,90,82,91,0,72,92,73,80,75,78,77,77,79,77,81,78,82,79,83,82,83,86,82,90,79,98,32,74,79,76,78,80,78,82,79,32,90,77,89,80,88,82,83,89,80,94,78,98,32,89,77,88,80,87,82,83,89,0,73,92,86,78,84,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,83,74,82,72,82,70,83,69,85,69,87,70,89,72,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,87,87,84,87,80,86,78,84,75,83,73,83,71,84,70,86,70,89,72,0,73,91,88,80,86,78,84,77,80,77,78,78,78,80,80,82,83,83,32,80,77,79,78,79,80,81,82,83,83,32,83,83,78,84,76,86,76,88,77,90,80,91,83,91,85,90,87,88,32,83,83,79,84,77,86,77,88,78,90,80,91,0,73,91,84,70,82,71,81,72,81,73,82,74,85,75,90,75,90,74,87,75,83,77,80,79,77,82,76,85,76,87,77,89,80,91,83,93,84,95,84,97,83,98,81,98,80,97,32,85,76,81,79,78,82,77,85,77,87,78,89,80,91,0,71,93,72,81,73,79,75,77,78,77,79,78,79,80,78,84,76,91,32,77,77,78,78,78,80,77,84,75,91,32,78,84,80,80,82,78,84,77,86,77,88,78,89,79,89,82,88,87,85,98,32,86,77,88,79,88,82,87,87,84,98,0,70,93,71,81,72,79,74,77,77,77,78,78,78,80,77,85,77,88,78,90,79,91,32,76,77,77,78,77,80,76,85,76,88,77,90,79,91,81,91,83,90,85,88,87,85,88,82,89,77,89,73,88,71,86,70,84,70,82,72,82,74,83,77,85,80,87,82,90,84,32,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,0,76,88,82,77,80,84,79,88,79,90,80,91,83,91,85,89,86,87,32,83,77,81,84,80,88,80,90,81,91,0,72,92,78,77,74,91,32,79,77,75,91,32,88,77,89,78,90,78,89,77,87,77,85,78,81,82,79,83,77,83,32,79,83,81,84,83,90,84,91,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,0,72,92,75,70,77,70,79,71,80,72,81,74,87,88,88,90,89,91,32,77,70,79,72,80,74,86,88,87,90,89,91,90,91,32,82,77,74,91,32,82,77,75,91,0,70,93,77,77,71,98,32,78,77,72,98,32,77,80,76,86,76,89,78,91,80,91,82,90,84,88,86,85,32,88,77,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,86,88,86,90,87,91,0,72,92,78,77,76,91,32,79,77,78,83,77,88,76,91,32,89,77,88,81,86,85,32,90,77,89,80,88,82,86,85,84,87,81,89,79,90,76,91,32,75,77,79,77,0,73,90,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,85,75,81,76,79,77,78,79,78,81,80,83,83,84,86,84,32,85,75,82,76,80,77,79,79,79,81,81,83,83,84,32,83,84,79,85,77,86,76,88,76,90,78,92,83,94,84,95,84,97,82,98,80,98,32,83,84,80,85,78,86,77,88,77,90,79,92,83,94,0,73,91,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,86,78,84,77,82,77,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,87,87,84,87,80,86,78,0,71,93,80,78,76,91,32,80,78,77,91,32,86,78,86,91,32,86,78,87,91,32,73,80,75,78,78,77,91,77,32,73,80,75,79,78,78,91,78,0,72,91,76,86,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,86,78,84,77,82,77,79,78,77,81,76,84,72,98,32,82,91,84,90,86,87,87,84,87,80,86,78,32,82,77,80,78,78,81,77,84,73,98,0,72,93,91,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,84,90,86,87,87,84,87,81,86,79,85,78,83,77,32,81,77,79,78,77,81,76,84,76,88,77,90,32,81,91,83,90,85,87,86,84,86,80,85,78,32,85,78,91,78,0,72,92,83,78,80,91,32,83,78,81,91,32,74,80,76,78,79,77,90,77,32,74,80,76,79,79,78,90,78,0,72,92,73,81,74,79,76,77,79,77,80,78,80,80,78,86,78,89,80,91,32,78,77,79,78,79,80,77,86,77,89,78,90,80,91,81,91,84,90,86,88,88,85,89,82,89,79,88,77,87,78,88,79,89,82,32,88,85,89,79,0,71,93,79,78,77,79,75,81,74,84,74,87,75,89,76,90,78,91,81,91,84,90,87,88,89,85,90,82,90,79,88,77,86,77,84,79,82,83,80,88,77,98,32,74,87,76,89,78,90,81,90,84,89,87,87,89,85,32,90,79,88,78,86,78,84,80,82,83,80,89,78,98,0,73,91,75,77,77,77,79,78,80,80,85,95,86,97,87,98,32,77,77,78,78,79,80,84,95,85,97,87,98,89,98,32,90,77,89,79,87,82,77,93,75,96,74,98,0,70,93,85,70,79,98,32,86,70,78,98,32,71,81,72,79,74,77,77,77,78,78,78,80,77,85,77,88,79,90,82,90,84,89,87,86,89,83,32,76,77,77,78,77,80,76,85,76,88,77,90,79,91,82,91,84,90,86,88,88,85,89,83,91,77,0,70,93,74,81,76,79,79,78,78,77,76,78,74,81,73,84,73,87,74,90,75,91,77,91,79,90,81,87,82,84,32,73,87,74,89,75,90,77,90,79,89,81,87,32,81,84,81,87,82,90,83,91,85,91,87,90,89,87,90,84,90,81,89,78,88,77,87,78,89,79,90,81,32,81,87,82,89,83,90,85,90,87,89,89,87,0,72,93,88,77,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,87,84,86,88,86,90,87,91,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,0,72,91,80,70,76,83,76,86,77,89,78,90,32,81,70,77,83,32,77,83,78,80,80,78,82,77,84,77,86,78,87,79,88,81,88,84,87,87,85,90,82,91,80,91,78,90,77,87,77,83,32,86,78,87,80,87,84,86,87,84,90,82,91,32,77,70,81,70,0,73,91,87,80,87,81,88,81,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,32,82,77,80,78,78,81,77,84,77,88,78,90,0,72,93,90,70,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,91,70,87,84,86,88,86,90,87,91,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,32,87,70,91,70,0,73,91,77,86,81,85,84,84,87,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,88,32,82,77,80,78,78,81,77,84,77,88,78,90,0,75,90,90,71,89,72,90,73,91,72,91,71,90,70,88,70,86,71,85,72,84,74,83,77,80,91,79,95,78,97,32,88,70,86,72,85,74,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,79,77,89,77,0,72,92,89,77,85,91,84,94,82,97,79,98,76,98,74,97,73,96,73,95,74,94,75,95,74,96,32,88,77,84,91,83,94,81,97,79,98,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,0,72,93,80,70,74,91,32,81,70,75,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,79,88,81,86,87,86,90,87,91,32,85,77,87,79,87,81,85,87,85,90,86,91,89,91,91,89,92,87,32,77,70,81,70,0,76,89,85,70,84,71,85,72,86,71,85,70,32,77,81,78,79,80,77,83,77,84,78,84,81,82,87,82,90,83,91,32,82,77,83,78,83,81,81,87,81,90,82,91,85,91,87,89,88,87,0,76,89,86,70,85,71,86,72,87,71,86,70,32,78,81,79,79,81,77,84,77,85,78,85,81,82,91,81,94,80,96,79,97,77,98,75,98,74,97,74,96,75,95,76,96,75,97,32,83,77,84,78,84,81,81,91,80,94,79,96,77,98,0,72,92,80,70,74,91,32,81,70,75,91,32,88,78,87,79,88,80,89,79,89,78,88,77,87,77,85,78,81,82,79,83,77,83,32,79,83,81,84,83,90,84,91,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,32,77,70,81,70,0,77,89,85,70,81,84,80,88,80,90,81,91,84,91,86,89,87,87,32,86,70,82,84,81,88,81,90,82,91,32,82,70,86,70,0,65,98,66,81,67,79,69,77,72,77,73,78,73,80,72,84,70,91,32,71,77,72,78,72,80,71,84,69,91,32,72,84,74,80,76,78,78,77,80,77,82,78,83,79,83,81,80,91,32,80,77,82,79,82,81,79,91,32,82,84,84,80,86,78,88,77,90,77,92,78,93,79,93,81,91,87,91,90,92,91,32,90,77,92,79,92,81,90,87,90,90,91,91,94,91,96,89,97,87,0,70,93,71,81,72,79,74,77,77,77,78,78,78,80,77,84,75,91,32,76,77,77,78,77,80,76,84,74,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,79,88,81,86,87,86,90,87,91,32,85,77,87,79,87,81,85,87,85,90,86,91,89,91,91,89,92,87,0,71,92,72,81,73,79,75,77,78,77,79,78,79,80,78,84,74,98,32,77,77,78,78,78,80,77,84,73,98,32,78,84,79,81,81,78,83,77,85,77,87,78,88,79,89,81,89,84,88,87,86,90,83,91,81,91,79,90,78,87,78,84,32,87,78,88,80,88,84,87,87,85,90,83,91,32,70,98,77,98,0,72,92,88,77,82,98,32,89,77,83,98,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,32,79,98,86,98,0,73,90,74,81,75,79,77,77,80,77,81,78,81,80,80,84,78,91,32,79,77,80,78,80,80,79,84,77,91,32,80,84,82,80,84,78,86,77,88,77,89,78,89,79,88,80,87,79,88,78,0,74,91,88,79,88,80,89,80,89,79,88,78,85,77,82,77,79,78,78,79,78,81,79,82,86,86,87,87,32,78,80,79,81,86,85,87,86,87,89,86,90,83,91,80,91,77,90,76,89,76,88,77,88,77,89,0,75,89,84,70,80,84,79,88,79,90,80,91,83,91,85,89,86,87,32,85,70,81,84,80,88,80,90,81,91,32,78,77,87,77,0,70,93,71,81,72,79,74,77,77,77,78,78,78,81,76,87,76,89,78,91,32,76,77,77,78,77,81,75,87,75,89,76,90,78,91,80,91,82,90,84,88,86,84,32,88,77,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,87,84,86,88,86,90,87,91,0,72,92,73,81,74,79,76,77,79,77,80,78,80,81,78,87,78,89,80,91,32,78,77,79,78,79,81,77,87,77,89,78,90,80,91,81,91,84,90,86,88,88,85,89,81,89,77,88,77,89,79,0,67,96,68,81,69,79,71,77,74,77,75,78,75,81,73,87,73,89,75,91,32,73,77,74,78,74,81,72,87,72,89,73,90,75,91,77,91,79,90,81,88,82,86,32,84,77,82,86,82,89,83,90,85,91,87,91,89,90,91,88,92,86,93,82,93,77,92,77,93,79,32,85,77,83,86,83,89,85,91,0,72,92,75,81,77,78,79,77,82,77,83,79,83,82,32,81,77,82,79,82,82,81,86,80,88,78,90,76,91,75,91,74,90,74,89,75,88,76,89,75,90,32,81,86,81,89,82,91,85,91,87,90,89,87,32,89,78,88,79,89,80,90,79,90,78,89,77,88,77,86,78,84,80,83,82,82,86,82,89,83,91,0,71,92,72,81,73,79,75,77,78,77,79,78,79,81,77,87,77,89,79,91,32,77,77,78,78,78,81,76,87,76,89,77,90,79,91,81,91,83,90,85,88,87,84,32,90,77,86,91,85,94,83,97,80,98,77,98,75,97,74,96,74,95,75,94,76,95,75,96,32,89,77,85,91,84,94,82,97,80,98,0,72,92,89,77,88,79,86,81,78,87,76,89,75,91,32,76,81,77,79,79,77,82,77,86,79,32,77,79,79,78,82,78,86,79,88,79,32,76,89,78,89,82,90,85,90,87,89,32,78,89,82,91,85,91,87,89,88,87,0,71,94,86,71,85,72,86,73,87,72,87,71,85,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,92,71,91,72,92,73,93,72,93,71,92,70,90,70,88,71,87,73,87,91,32,90,70,89,71,88,73,88,91,32,73,77,91,77,32,73,91,80,91,32,84,91,91,91,0,71,93,87,71,86,72,87,73,88,72,87,71,85,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,88,77,32,73,91,80,91,32,84,91,91,91,0,71,93,86,71,85,72,86,73,87,72,87,71,85,70,32,88,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,87,72,87,91,32,88,70,88,91,32,73,77,87,77,32,73,91,80,91,32,84,91,91,91,0,66,99,82,71,81,72,82,73,83,72,82,71,80,70,77,70,74,71,72,73,71,76,71,91,32,77,70,75,71,73,73,72,76,72,91,32,93,71,92,72,93,73,94,72,93,71,91,70,88,70,85,71,83,73,82,76,82,91,32,88,70,86,71,84,73,83,76,83,91,32,93,77,93,91,32,94,77,94,91,32,68,77,94,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,66,99,82,71,81,72,82,73,83,72,82,71,80,70,77,70,74,71,72,73,71,76,71,91,32,77,70,75,71,73,73,72,76,72,91,32,92,71,91,72,92,73,93,72,93,71,91,70,32,94,70,88,70,85,71,83,73,82,76,82,91,32,88,70,86,71,84,73,83,76,83,91,32,93,72,93,91,32,94,70,94,91,32,68,77,93,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,77,88,82,77,82,91,32,83,77,83,91,32,79,77,83,77,32,79,91,86,91,0,73,90,87,78,85,77,82,77,79,78,77,80,76,83,76,86,77,89,78,90,81,91,84,91,86,90,32,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,32,77,84,85,84,0,73,92,84,70,81,71,79,74,78,76,77,79,76,84,76,88,77,90,79,91,81,91,84,90,86,87,87,85,88,82,89,77,89,73,88,71,86,70,84,70,32,84,70,82,71,80,74,79,76,78,79,77,84,77,88,78,90,79,91,32,81,91,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,32,78,80,87,80,0,71,93,85,70,79,98,32,86,70,78,98,32,81,77,77,78,75,80,74,83,74,86,75,88,77,90,80,91,83,91,87,90,89,88,90,85,90,82,89,80,87,78,84,77,81,77,32,81,77,78,78,76,80,75,83,75,86,76,88,78,90,80,91,32,83,91,86,90,88,88,89,85,89,82,88,80,86,78,84,77,0,73,91,84,77,86,78,88,80,88,79,87,78,84,77,81,77,78,78,77,79,76,81,76,83,77,85,79,87,83,90,32,81,77,79,78,78,79,77,81,77,83,78,85,83,90,84,92,84,94,83,95,81,95,0,71,93,76,77,75,78,74,80,74,82,75,85,79,89,80,91,32,74,82,75,84,79,88,80,91,80,93,79,96,77,98,76,98,75,97,74,95,74,92,75,88,77,84,79,81,82,78,84,77,86,77,89,78,90,80,90,84,89,88,87,90,85,91,84,91,83,90,83,88,84,87,85,88,84,89,32,86,77,88,78,89,80,89,84,88,88,87,90,0,69,95,89,71,88,72,89,73,90,72,89,71,87,70,84,70,81,71,79,73,78,75,77,78,76,82,74,91,73,95,72,97,32,84,70,82,71,80,73,79,75,78,78,76,87,75,91,74,94,73,96,72,97,70,98,68,98,67,97,67,96,68,95,69,96,68,97,32,95,71,94,72,95,73,96,72,96,71,95,70,93,70,91,71,90,72,89,74,88,77,85,91,84,95,83,97,32,93,70,91,72,90,74,89,78,87,87,86,91,85,94,84,96,83,97,81,98,79,98,78,97,78,96,79,95,80,96,79,97,32,73,77,94,77,0,70,94,91,71,90,72,91,73,92,72,91,71,88,70,85,70,82,71,80,73,79,75,78,78,77,82,75,91,74,95,73,97,32,85,70,83,71,81,73,80,75,79,78,77,87,76,91,75,94,74,96,73,97,71,98,69,98,68,97,68,96,69,95,70,96,69,97,32,89,77,87,84,86,88,86,90,87,91,90,91,92,89,93,87,32,90,77,88,84,87,88,87,90,88,91,32,74,77,90,77,0,70,94,89,71,88,72,89,73,90,72,90,71,88,70,32,92,70,85,70,82,71,80,73,79,75,78,78,77,82,75,91,74,95,73,97,32,85,70,83,71,81,73,80,75,79,78,77,87,76,91,75,94,74,96,73,97,71,98,69,98,68,97,68,96,69,95,70,96,69,97,32,91,70,87,84,86,88,86,90,87,91,90,91,92,89,93,87,32,92,70,88,84,87,88,87,90,88,91,32,74,77,89,77,0,64,99,84,71,83,72,84,73,85,72,84,71,82,70,79,70,76,71,74,73,73,75,72,78,71,82,69,91,68,95,67,97,32,79,70,77,71,75,73,74,75,73,78,71,87,70,91,69,94,68,96,67,97,65,98,63,98,62,97,62,96,63,95,64,96,63,97,32,96,71,95,72,96,73,97,72,96,71,93,70,90,70,87,71,85,73,84,75,83,78,82,82,80,91,79,95,78,97,32,90,70,88,71,86,73,85,75,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,94,77,92,84,91,88,91,90,92,91,95,91,97,89,98,87,32,95,77,93,84,92,88,92,90,93,91,32,68,77,95,77,0,64,99,84,71,83,72,84,73,85,72,84,71,82,70,79,70,76,71,74,73,73,75,72,78,71,82,69,91,68,95,67,97,32,79,70,77,71,75,73,74,75,73,78,71,87,70,91,69,94,68,96,67,97,65,98,63,98,62,97,62,96,63,95,64,96,63,97,32,94,71,93,72,94,73,95,72,95,71,93,70,32,97,70,90,70,87,71,85,73,84,75,83,78,82,82,80,91,79,95,78,97,32,90,70,88,71,86,73,85,75,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,96,70,92,84,91,88,91,90,92,91,95,91,97,89,98,87,32,97,70,93,84,92,88,92,90,93,91,32,68,77,94,77,0,76,89,77,81,78,79,80,77,83,77,84,78,84,81,82,87,82,90,83,91,32,82,77,83,78,83,81,81,87,81,90,82,91,85,91,87,89,88,87,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,81,70,79,71,78,72,77,74,76,79,76,82,77,87,78,89,79,90,81,91,32,83,91,85,90,86,89,87,87,88,82,88,79,87,74,86,72,85,71,83,70,0,72,92,78,74,80,73,83,70,83,91,32,82,71,82,91,32,78,91,87,91,0,72,92,76,74,77,75,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,85,80,80,82,78,83,76,85,75,88,75,91,32,84,70,86,71,87,72,88,74,88,76,87,78,84,80,80,82,32,75,89,76,88,78,88,83,90,86,90,88,89,89,88,32,78,88,83,91,87,91,88,90,89,88,89,86,0,72,92,76,74,77,75,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,81,79,32,84,70,86,71,87,73,87,76,86,78,84,79,32,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,87,81,88,84,88,87,87,89,86,90,84,91,0,72,92,84,72,84,91,32,85,70,85,91,32,85,70,74,85,90,85,32,81,91,88,91,0,72,92,77,70,75,80,32,75,80,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,77,70,87,70,32,77,71,82,71,87,70,0,72,92,87,73,86,74,87,75,88,74,88,73,87,71,85,70,82,70,79,71,77,73,76,75,75,79,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,76,84,32,82,70,80,71,78,73,77,75,76,79,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,84,87,81,85,79,83,78,0,72,92,75,70,75,76,32,75,74,76,72,78,70,80,70,85,73,87,73,88,72,89,70,32,76,72,78,71,80,71,85,73,32,89,70,89,73,88,76,84,81,83,83,82,86,82,91,32,88,76,83,81,82,83,81,86,81,91,0,72,92,80,70,77,71,76,73,76,76,77,78,80,79,84,79,87,78,88,76,88,73,87,71,84,70,80,70,32,80,70,78,71,77,73,77,76,78,78,80,79,32,84,79,86,78,87,76,87,73,86,71,84,70,32,80,79,77,80,76,81,75,83,75,87,76,89,77,90,80,91,84,91,87,90,88,89,89,87,89,83,88,81,87,80,84,79,32,80,79,78,80,77,81,76,83,76,87,77,89,78,90,80,91,32,84,91,86,90,87,89,88,87,88,83,87,81,86,80,84,79,0,72,92,88,77,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,82,88,86,87,88,85,90,82,91,79,91,77,90,76,88,76,87,77,86,78,87,77,88,32,81,83,79,82,77,80,76,77,76,76,77,73,79,71,81,70,32,83,70,85,71,87,73,88,76,88,82,87,86,86,88,84,90,82,91,0,77,87,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,77,81,78,82,79,83,78,82,77,32,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,70,81,72,82,84,83,72,82,70,32,82,72,82,78,32,82,89,81,90,82,91,83,90,82,89,0,73,91,77,74,78,75,77,76,76,75,76,74,77,72,78,71,80,70,83,70,86,71,87,72,88,74,88,76,87,78,86,79,82,81,82,84,32,83,70,85,71,86,72,87,74,87,76,86,78,84,80,32,82,89,81,90,82,91,83,90,82,89,0,78,86,82,70,81,77,32,83,70,81,77,0,74,90,78,70,77,77,32,79,70,77,77,32,86,70,85,77,32,87,70,85,77,0,74,90,82,70,82,82,32,77,73,87,79,32,87,73,77,79,0,75,89,85,66,78,82,85,98,0,75,89,79,66,86,82,79,98,0,75,89,79,66,79,98,32,85,66,85,98,0,70,94,82,74,82,91,32,74,82,90,82,32,74,91,90,91,0,70,94,82,74,82,91,32,74,74,90,74,32,74,82,90,82,0,77,87,81,81,81,83,83,83,83,81,81,81,32,82,81,82,83,32,81,82,83,82,0,69,95,82,73,81,74,82,75,83,74,82,73,32,73,82,91,82,32,82,89,81,90,82,91,83,90,82,89,0,69,95,89,73,75,91,32,73,79,91,79,32,73,85,91,85,0,69,95,73,77,91,77,32,73,82,91,82,32,73,87,91,87,0,70,94,90,70,74,77,90,84,32,74,86,90,86,32,74,91,90,91,0,70,94,74,70,90,77,74,84,32,74,86,90,86,32,74,91,90,91,0,70,95,91,87,89,87,87,86,85,84,82,80,81,79,79,78,77,78,75,79,74,81,74,83,75,85,77,86,79,86,81,85,82,84,85,80,87,78,89,77,91,77,0,70,94,73,85,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,91,79,0,71,93,74,84,82,79,90,84,32,74,84,82,80,90,84,0,76,88,84,70,79,76,32,84,70,85,71,79,76,0,76,88,80,70,85,76,32,80,70,79,71,85,76,0,72,92,75,70,76,72,78,74,81,75,83,75,86,74,88,72,89,70,32,75,70,76,73,78,75,81,76,83,76,86,75,88,73,89,70,0,77,87,82,72,83,71,82,70,81,71,81,73,82,75,83,76,0,77,87,81,70,82,71,83,73,83,75,82,76,81,75,82,74,0,69,91,72,77,76,77,82,89,32,75,77,82,91,32,91,66,82,91,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,0,70,94,74,74,74,81,75,85,76,87,78,89,81,90,83,90,86,89,88,87,89,85,90,81,90,74,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,0,70,94,74,90,74,83,75,79,76,77,78,75,81,74,83,74,86,75,88,77,89,79,90,83,90,90,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,32,74,82,86,82,0,69,95,88,80,91,82,88,84,32,85,77,90,82,85,87,32,73,82,90,82,0,74,90,80,76,82,73,84,76,32,77,79,82,74,87,79,32,82,74,82,91,0,69,95,76,80,73,82,76,84,32,79,77,74,82,79,87,32,74,82,91,82,0,74,90,80,88,82,91,84,88,32,77,85,82,90,87,85,32,82,73,82,90,0,73,92,88,82,87,79,86,78,84,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,88,88,85,89,80,89,75,88,72,87,71,85,70,82,70,80,71,79,72,79,73,80,73,80,72,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,88,87,85,88,80,88,75,87,72,85,70,0,72,92,74,70,82,91,32,75,70,82,89,32,90,70,82,91,32,74,70,90,70,32,75,71,89,71,0,65,98,68,77,73,77,82,89,32,72,78,82,91,32,98,58,82,91,0,70,94,91,67,90,68,91,69,92,68,92,67,91,66,89,66,87,67,85,69,84,71,83,74,82,78,80,90,79,94,78,96,32,86,68,85,70,84,74,82,86,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,96,73,95,74,96,73,97,32,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,0,70,95,92,83,91,85,89,86,87,86,85,85,84,84,81,80,80,79,78,78,76,78,74,79,73,81,73,83,74,85,76,86,78,86,80,85,81,84,84,80,85,79,87,78,89,78,91,79,92,81,92,83,0,70,94,91,70,73,91,32,78,70,80,72,80,74,79,76,77,77,75,77,73,75,73,73,74,71,76,70,78,70,80,71,83,72,86,72,89,71,91,70,32,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,87,84,0,70,95,91,78,90,79,91,80,92,79,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,77,91,74,90,73,88,73,85,74,83,80,79,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,75,78,78,80,81,85,88,87,90,90,91,91,91,92,90,92,89,32,77,91,75,90,74,88,74,85,75,83,77,81,32,77,75,78,77,86,88,88,90,90,91,0,69,96,87,78,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,85,80,86,83,86,85,85,86,83,32,81,75,79,77,78,80,78,83,79,85,80,86,32,87,75,86,83,86,85,88,86,90,86,92,84,93,81,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,90,88,32,88,75,87,83,87,85,88,86,0,72,92,80,66,80,95,32,84,66,84,95,32,88,73,87,74,88,75,89,74,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,89,84,32,75,75,77,77,79,78,85,80,87,81,88,82,89,84,89,88,87,90,84,91,80,91,77,90,75,88,75,87,76,86,77,87,76,88,0,74,90,85,73,84,74,85,75,86,74,86,73,85,71,83,70,81,70,79,71,78,73,78,75,79,77,81,79,86,82,32,79,77,84,80,86,82,87,84,87,86,86,88,84,90,32,80,78,78,80,77,82,77,84,78,86,80,88,85,91,32,78,86,83,89,85,91,86,93,86,95,85,97,83,98,81,98,79,97,78,95,78,94,79,93,80,94,79,95,0,74,90,82,70,81,72,82,74,83,72,82,70,32,82,70,82,98,32,82,81,81,84,82,98,83,84,82,81,32,76,77,78,78,80,77,78,76,76,77,32,76,77,88,77,32,84,77,86,78,88,77,86,76,84,77,0,74,90,82,70,81,72,82,74,83,72,82,70,32,82,70,82,84,32,82,80,81,82,83,86,82,88,81,86,83,82,82,80,32,82,84,82,98,32,82,94,81,96,82,98,83,96,82,94,32,76,77,78,78,80,77,78,76,76,77,32,76,77,88,77,32,84,77,86,78,88,77,86,76,84,77,32,76,91,78,92,80,91,78,90,76,91,32,76,91,88,91,32,84,91,86,92,88,91,86,90,84,91,0,73,92,88,70,88,91,32,75,70,88,70,32,80,80,88,80,32,75,91,88,91,0,69,96,81,70,78,71,75,73,73,76,72,79,72,82,73,85,75,88,78,90,81,91,84,91,87,90,90,88,92,85,93,82,93,79,92,76,90,73,87,71,84,70,81,70,32,82,79,81,80,81,81,82,82,83,82,84,81,84,80,83,79,82,79,32,82,80,82,81,83,81,83,80,82,80,0,74,91,80,70,78,71,79,73,81,74,32,80,70,79,71,79,73,32,85,70,87,71,86,73,84,74,32,85,70,86,71,86,73,32,81,74,79,75,78,76,77,78,77,81,78,83,79,84,81,85,84,85,86,84,87,83,88,81,88,78,87,76,86,75,84,74,81,74,32,82,85,82,91,32,83,85,83,91,32,78,88,87,88,0,73,92,82,70,79,71,77,73,76,76,76,77,77,80,79,82,82,83,83,83,86,82,88,80,89,77,89,76,88,73,86,71,83,70,82,70,32,82,83,82,91,32,83,83,83,91,32,78,87,87,87,0,68,96,80,70,77,71,74,73,72,76,71,79,71,83,72,86,74,89,77,91,80,92,84,92,87,91,90,89,92,86,93,83,93,79,92,76,90,73,87,71,84,70,80,70,32,82,70,82,92,32,71,81,93,81,0,71,96,80,77,77,78,75,80,74,83,74,84,75,87,77,89,80,90,81,90,84,89,86,87,87,84,87,83,86,80,84,78,81,77,80,77,32,93,71,87,71,91,72,85,78,32,93,71,93,77,92,73,86,79,32,92,72,86,78,0,70,92,73,73,74,71,76,70,79,70,81,71,82,73,82,76,81,79,80,81,78,83,75,85,32,79,70,80,71,81,73,81,77,80,80,78,83,32,86,70,84,91,32,87,70,83,91,32,75,85,89,85,0,73,92,77,70,77,85,32,78,70,77,81,32,77,81,78,79,79,78,81,77,84,77,87,78,88,80,88,82,87,84,85,86,32,84,77,86,78,87,80,87,82,84,88,84,90,85,91,87,91,89,89,32,75,70,78,70,0,73,92,82,78,79,79,77,81,76,84,76,85,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,32,82,72,78,74,82,70,82,78,32,83,72,87,74,83,70,83,78,32,82,83,81,84,81,85,82,86,83,86,84,85,84,84,83,83,82,83,32,82,84,82,85,83,85,83,84,82,84,0,71,94,81,72,82,70,82,91,32,84,72,83,70,83,91,32,74,72,75,70,75,77,76,80,78,82,81,83,82,83,32,77,72,76,70,76,78,77,81,32,91,72,90,70,90,77,89,80,87,82,84,83,83,83,32,88,72,89,70,89,78,88,81,32,78,87,87,87,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,77,81,32,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,32,73,91,89,91,89,86,88,91,0,72,91,89,71,85,71,81,72,78,74,76,77,75,80,75,83,76,86,78,89,81,91,85,92,89,92,32,89,71,86,72,83,74,81,77,80,80,80,83,81,86,83,89,86,91,89,92,0,70,95,79,81,77,81,75,82,74,83,73,85,73,87,74,89,75,90,77,91,79,91,81,90,82,89,83,87,83,85,82,83,81,82,79,81,32,83,72,80,81,32,90,74,82,82,32,92,81,83,84,0,72,92,79,75,85,89,32,85,75,79,89,32,75,79,89,85,32,89,79,75,85,0,70,94,78,86,76,85,75,85,73,86,72,88,72,89,73,91,75,92,76,92,78,91,79,89,79,88,78,86,75,82,74,79,74,77,75,74,77,72,80,71,84,71,87,72,89,74,90,77,90,79,89,82,86,86,85,88,85,89,86,91,88,92,89,92,91,91,92,89,92,88,91,86,89,85,88,85,86,86,32,74,77,75,75,77,73,80,72,84,72,87,73,89,75,90,77,0,70,94,78,77,76,78,75,78,73,77,72,75,72,74,73,72,75,71,76,71,78,72,79,74,79,75,78,77,75,81,74,84,74,86,75,89,77,91,80,92,84,92,87,91,89,89,90,86,90,84,89,81,86,77,85,75,85,74,86,72,88,71,89,71,91,72,92,74,92,75,91,77,89,78,88,78,86,77,32,74,86,75,88,77,90,80,91,84,91,87,90,89,88,90,86,0,73,91,75,89,89,75,32,81,76,85,76,89,75,88,79,88,83,32,85,76,88,76,88,79,0,73,91,89,75,75,89,32,76,81,76,85,75,89,79,88,83,88,32,76,85,76,88,79,88,0,73,91,89,89,75,75,32,83,76,79,76,75,75,76,79,76,83,32,79,76,76,76,76,79,0,73,91,75,75,89,89,32,81,88,85,88,89,89,88,85,88,81,32,85,88,88,88,88,85,0,70,95,74,77,73,76,73,74,74,72,76,71,78,71,80,72,81,73,82,75,83,80,32,73,74,75,72,77,72,79,73,80,74,81,76,82,80,82,91,32,91,77,92,76,92,74,91,72,89,71,87,71,85,72,84,73,83,75,82,80,32,92,74,90,72,88,72,86,73,85,74,84,76,83,80,83,91,0,70,94,73,71,74,75,75,77,77,79,80,80,84,80,87,79,89,77,90,75,91,71,32,73,71,74,74,75,76,77,78,80,79,84,79,87,78,89,76,90,74,91,71,32,80,79,78,80,77,81,76,83,76,86,77,88,79,90,81,91,83,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,32,80,80,78,81,77,83,77,86,78,89,32,86,89,87,86,87,83,86,81,84,80,0,70,94,77,74,77,86,32,78,75,78,85,32,86,75,86,85,32,87,74,87,86,32,73,71,75,73,77,74,80,75,84,75,87,74,89,73,91,71,32,73,89,75,87,77,86,80,85,84,85,87,86,89,87,91,89,0,70,94,91,73,76,73,74,74,73,76,73,78,74,80,76,81,78,81,80,80,81,78,81,76,80,74,91,74,32,73,77,74,79,75,80,77,81,32,81,77,80,75,79,74,77,73,32,73,88,88,88,90,87,91,85,91,83,90,81,88,80,86,80,84,81,83,83,83,85,84,87,73,87,32,91,84,90,82,89,81,87,80,32,83,84,84,86,85,87,87,88,0,70,93,79,85,77,84,76,84,74,85,73,87,73,88,74,90,76,91,77,91,79,90,80,88,80,87,79,85,74,80,73,78,73,75,74,73,76,72,79,71,83,71,87,72,89,74,90,76,90,79,89,82,86,85,85,87,85,89,86,91,88,91,89,90,90,88,32,77,83,75,80,74,78,74,75,75,73,76,72,32,83,71,86,72,88,74,89,76,89,79,88,82,86,85,0,71,95,72,75,75,72,77,75,77,86,32,74,73,76,76,76,86,32,77,75,80,72,82,75,82,85,32,79,73,81,76,81,85,32,82,75,85,72,87,75,87,91,32,84,73,86,76,86,91,32,87,75,90,72,91,74,92,77,92,80,91,83,90,85,88,87,85,89,80,91,32,89,73,90,74,91,77,91,80,90,83,89,85,87,87,84,89,80,91,0,70,94,73,83,77,83,76,82,75,79,75,77,76,74,78,72,81,71,83,71,86,72,88,74,89,77,89,79,88,82,87,83,91,83,32,73,84,79,84,77,82,76,79,76,77,77,74,79,72,81,71,32,83,71,85,72,87,74,88,77,88,79,87,82,85,84,91,84,32,75,88,89,88,32,75,89,89,89,0,70,95,71,76,74,73,77,76,77,88,32,73,74,76,77,76,88,32,77,76,80,73,83,76,83,88,32,79,74,82,77,82,88,32,83,76,86,73,89,76,89,87,91,89,32,85,74,88,77,88,88,90,90,93,87,0,71,93,90,73,74,89,32,90,73,87,74,81,74,32,88,75,85,75,81,74,32,90,73,89,76,89,82,32,88,75,88,78,89,82,32,81,82,74,82,32,80,83,77,83,74,82,32,81,82,81,89,32,80,83,80,86,81,89,0,70,94,72,79,74,75,79,85,32,74,77,79,87,82,80,87,80,90,79,91,77,91,75,90,73,88,72,87,72,85,73,84,75,84,77,85,80,86,82,87,85,87,88,85,90,32,87,72,86,73,85,75,85,77,87,81,88,84,88,87,87,89,85,90,0,70,94,73,79,76,76,80,78,32,75,77,79,79,82,76,85,78,32,81,77,84,79,87,76,89,78,32,86,77,88,79,91,76,32,73,85,76,82,80,84,32,75,83,79,85,82,82,85,84,32,81,83,84,85,87,82,89,84,32,86,83,88,85,91,82,0,70,94,74,72,78,74,80,76,81,79,81,82,80,85,78,87,74,89,32,74,72,77,73,79,74,81,76,82,79,32,82,82,81,85,79,87,77,88,74,89,32,90,72,87,73,85,74,83,76,82,79,32,82,82,83,85,85,87,87,88,90,89,32,90,72,86,74,84,76,83,79,83,82,84,85,86,87,90,89,32,73,80,91,80,32,73,81,91,81,0,78,86,81,81,81,83,83,83,83,81,81,81,32,81,81,83,83,32,83,81,81,83,0,74,90,77,80,81,82,84,84,86,86,87,89,87,91,86,93,85,94,32,77,81,83,84,32,77,82,80,83,84,85,86,87,87,89,0,74,90,87,75,86,77,84,79,80,81,77,82,32,83,80,77,83,32,85,70,86,71,87,73,87,75,86,78,84,80,81,82,77,84,0,72,92,83,77,79,78,76,80,75,82,75,84,76,86,78,87,81,87,85,86,88,84,89,82,89,80,88,78,86,77,83,77,32,88,78,83,77,32,86,77,81,78,76,80,32,79,78,75,82,32,76,86,81,87,32,78,87,83,86,88,84,32,85,86,89,82,0,74,91,83,77,80,78,78,80,77,82,77,84,78,86,80,87,82,87,85,86,87,84,88,82,88,80,87,78,85,77,83,77,32,79,80,85,77,32,78,82,86,78,32,77,84,87,79,32,78,85,88,80,32,79,86,87,82,32,80,87,86,84,0,74,90,79,71,79,94,32,85,70,85,93,32,77,78,87,76,32,77,79,87,77,32,77,87,87,85,32,77,88,87,86,0,74,90,78,70,78,88,32,86,76,86,94,32,78,78,86,76,32,78,79,86,77,32,78,87,86,85,32,78,88,86,86,0,74,90,78,66,78,87,32,78,78,81,76,84,76,86,77,87,79,87,81,86,83,83,85,81,86,78,87,32,78,78,81,77,84,77,86,78,32,85,77,86,79,86,81,85,83,83,85,0,69,95,72,73,72,76,32,92,73,92,76,32,72,73,92,73,32,72,74,92,74,32,72,75,92,75,32,72,76,92,76,0,74,90,77,78,77,81,32,87,78,87,81,32,77,78,87,78,32,77,79,87,79,32,77,80,87,80,32,77,81,87,81,0,74,90,77,76,87,88,32,77,76,79,78,81,79,84,79,86,78,87,77,87,75,85,75,85,77,84,79,32,79,78,84,79,32,81,79,87,77,32,86,75,86,78,32,85,76,87,76,32,87,88,85,86,83,85,80,85,78,86,77,87,77,89,79,89,79,87,80,85,32,85,86,80,85,32,83,85,77,87,32,78,86,78,89,32,77,88,79,88,0,74,90,80,79,79,77,79,75,77,75,77,77,78,78,80,79,83,79,85,78,87,76,32,78,75,78,78,32,77,76,79,76,32,77,77,83,79,32,80,79,85,78,32,87,76,87,89,0,65,94,71,102,72,102,73,101,73,100,72,99,71,99,70,100,70,102,71,104,73,105,75,105,78,104,80,102,81,100,82,96,82,85,81,59,81,52,82,47,83,45,85,44,86,44,88,45,89,47,89,51,88,54,87,56,85,59,80,63,74,67,72,69,70,72,69,74,68,78,68,82,69,86,71,89,74,91,78,92,82,92,86,91,88,90,90,87,91,84,91,80,90,77,89,75,87,73,84,72,80,72,77,73,75,75,74,78,74,82,75,85,77,87,32,71,100,71,101,72,101,72,100,71,100,32,85,59,81,63,76,67,73,70,71,73,70,75,69,78,69,82,70,86,71,88,74,91,32,82,92,85,91,87,90,89,87,90,84,90,80,89,77,88,75,86,73,84,72,0,69,102,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,79,79,78,80,77,83,77,86,78,89,80,91,83,92,86,92,89,91,91,89,92,87,93,84,93,80,92,77,90,74,88,73,85,72,82,72,79,73,77,74,75,76,73,79,72,83,72,88,73,93,75,97,77,99,80,101,84,102,89,102,93,101,96,99,98,97,32,75,76,74,78,73,82,73,88,74,92,76,96,78,98,81,100,85,101,89,101,93,100,95,99,98,97,32,80,79,84,79,32,79,80,85,80,32,78,81,86,81,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+291060);allocate([78,82,86,82,32,78,83,86,83,32,79,84,85,84,32,80,85,84,85,32,97,76,97,78,99,78,99,76,97,76,32,98,76,98,78,32,97,77,99,77,32,97,86,97,88,99,88,99,86,97,86,32,98,86,98,88,32,97,87,99,87,0,68,96,72,64,72,100,32,77,64,77,100,32,87,64,87,100,32,92,64,92,100,32,77,77,87,75,32,77,78,87,76,32,77,79,87,77,32,77,87,87,85,32,77,88,87,86,32,77,89,87,87,0,72,92,80,77,77,78,76,79,75,81,75,83,76,85,77,86,80,87,84,87,87,86,88,85,89,83,89,81,88,79,87,78,84,77,80,77,32,77,78,76,80,76,83,77,85,78,86,80,87,32,87,86,88,84,88,81,87,79,86,78,84,77,0,74,90,81,67,86,77,82,84,82,85,32,85,76,81,83,32,84,73,84,75,80,82,82,85,85,89,32,87,92,85,89,83,88,81,88,79,89,78,91,78,93,79,95,82,97,32,87,92,85,90,83,89,79,89,79,93,80,95,82,97,32,83,88,80,90,78,93,0,74,90,80,79,79,77,79,75,77,75,77,77,78,78,80,79,83,79,85,78,87,76,32,78,75,78,78,32,77,76,79,76,32,77,77,83,79,32,80,79,85,78,32,87,76,83,89,0,73,106,78,81,79,79,81,78,83,78,85,79,86,81,86,83,85,85,83,86,81,86,79,85,78,84,77,81,77,78,78,75,80,73,83,72,87,72,91,73,94,75,96,78,97,82,97,87,96,91,95,93,93,96,90,99,86,102,81,105,77,107,32,87,72,90,73,93,75,95,78,96,82,96,87,95,91,94,93,92,96,89,99,84,103,81,105,32,80,79,84,79,32,79,80,85,80,32,78,81,86,81,32,78,82,86,82,32,78,83,86,83,32,79,84,85,84,32,80,85,84,85,32,101,76,101,78,103,78,103,76,101,76,32,102,76,102,78,32,101,77,103,77,32,101,86,101,88,103,88,103,86,101,86,32,102,86,102,88,32,101,87,103,87,0,68,96,72,62,72,102,32,73,62,73,102,32,77,62,77,102,32,81,66,83,66,83,68,81,68,81,65,82,63,84,62,87,62,89,63,91,65,92,68,92,73,91,76,89,78,87,79,85,79,83,78,82,76,81,78,79,81,78,82,79,83,81,86,82,88,83,86,85,85,87,85,89,86,91,88,92,91,92,96,91,99,89,101,87,102,84,102,82,101,81,99,81,96,83,96,83,98,81,98,32,82,66,82,68,32,81,67,83,67,32,89,63,90,65,91,68,91,73,90,76,89,78,32,82,76,82,78,80,81,78,82,80,83,82,86,82,88,32,89,86,90,88,91,91,91,96,90,99,89,101,32,82,96,82,98,32,81,97,83,97,0,65,99,72,66,72,98,32,73,66,73,98,32,91,66,91,98,32,92,66,92,98,32,68,66,96,66,32,68,98,77,98,32,87,98,96,98,0,66,97,71,66,81,80,70,98,32,70,66,80,80,32,69,66,80,81,32,69,66,92,66,94,73,91,66,32,71,97,92,97,32,70,98,92,98,94,91,91,98,0,73,91,88,43,85,49,82,56,80,61,79,65,78,70,77,78,77,86,78,94,79,99,80,103,82,108,85,115,88,121,32,85,49,83,54,81,60,80,64,79,70,78,78,78,86,79,94,80,100,81,104,83,110,85,115,0,73,91,76,43,79,49,82,56,84,61,85,65,86,70,87,78,87,86,86,94,85,99,84,103,82,108,79,115,76,121,32,79,49,81,54,83,60,84,64,85,70,86,78,86,86,85,94,84,100,83,104,81,110,79,115,0,73,91,77,43,77,82,77,121,32,78,43,78,82,78,121,32,77,43,88,43,32,77,121,88,121,0,73,91,86,43,86,82,86,121,32,87,43,87,82,87,121,32,76,43,87,43,32,76,121,87,121,0,72,91,86,43,82,49,80,53,79,58,79,62,80,66,84,74,84,76,83,78,82,79,77,82,82,85,83,86,84,88,84,90,80,98,79,102,79,106,80,111,82,115,86,121,32,84,46,82,50,81,53,80,58,80,62,81,67,82,70,32,82,94,81,97,80,102,80,106,81,111,82,114,84,118,0,73,92,78,43,82,49,84,53,85,58,85,62,84,66,80,74,80,76,81,78,82,79,87,82,82,85,81,86,80,88,80,90,84,98,85,102,85,106,84,111,82,115,78,121,32,80,46,82,50,83,53,84,58,84,62,83,67,82,70,32,82,94,83,97,84,102,84,106,83,111,82,114,80,118,0,73,91,86,46,83,49,81,52,79,56,78,61,78,67,79,73,80,77,83,88,84,92,85,98,85,103,84,108,83,111,81,115,32,83,49,81,53,80,56,79,61,79,66,80,72,81,76,84,87,85,91,86,97,86,103,85,108,83,112,81,115,78,118,0,73,91,78,46,81,49,83,52,85,56,86,61,86,67,85,73,84,77,81,88,80,92,79,98,79,103,80,108,81,111,83,115,32,81,49,83,53,84,56,85,61,85,66,84,72,83,76,80,87,79,91,78,97,78,103,79,108,81,112,83,115,86,118,0,55,90,58,82,65,82,82,111,32,64,82,81,111,32,63,82,82,114,32,90,34,86,74,82,114,0,67,97,93,46,92,46,91,47,91,48,92,49,93,49,94,48,94,46,93,44,91,43,89,43,87,44,85,46,84,48,83,51,82,58,81,74,81,106,80,115,79,118,32,92,47,92,48,93,48,93,47,92,47,32,82,58,82,106,32,85,46,84,49,83,58,83,90,82,106,81,113,80,116,79,118,77,120,75,121,73,121,71,120,70,118,70,116,71,115,72,115,73,116,73,117,72,118,71,118,32,71,116,71,117,72,117,72,116,71,116,0,72,92,82,70,74,91,32,82,73,75,91,74,91,32,82,73,89,91,90,91,32,82,70,90,91,32,77,85,87,85,32,76,86,88,86,0,72,92,76,70,76,91,32,77,71,77,90,32,76,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,32,77,71,84,71,87,72,88,74,88,77,87,79,84,80,32,77,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,76,91,32,77,81,84,81,87,82,88,84,88,87,87,89,84,90,77,90,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,32,90,75,89,75,88,73,87,72,85,71,81,71,79,72,77,75,76,78,76,83,77,86,79,89,81,90,85,90,87,89,88,88,89,86,90,86,0,72,93,76,70,76,91,32,77,71,77,90,32,76,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,76,91,32,77,71,83,71,86,72,87,73,88,75,89,78,89,83,88,86,87,88,86,89,83,90,77,90,0,73,92,77,70,77,91,32,78,71,78,90,32,77,70,89,70,32,78,71,89,71,89,70,32,78,80,84,80,84,81,32,78,81,84,81,32,78,90,89,90,89,91,32,77,91,89,91,0,73,91,77,70,77,91,32,78,71,78,91,77,91,32,77,70,89,70,32,78,71,89,71,89,70,32,78,80,84,80,84,81,32,78,81,84,81,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,90,82,85,82,32,90,75,89,75,88,73,87,72,85,71,81,71,79,72,78,73,77,75,76,78,76,83,77,86,78,88,79,89,81,90,85,90,87,89,88,88,89,86,89,83,85,83,85,82,0,71,93,75,70,75,91,32,75,70,76,70,76,91,75,91,32,89,70,88,70,88,91,89,91,32,89,70,89,91,32,76,80,88,80,32,76,81,88,81,0,78,87,82,70,82,91,83,91,32,82,70,83,70,83,91,0,74,91,86,70,86,86,85,89,83,90,81,90,79,89,78,86,77,86,32,86,70,87,70,87,86,86,89,85,90,83,91,81,91,79,90,78,89,77,86,0,72,93,76,70,76,91,77,91,32,76,70,77,70,77,91,32,90,70,89,70,77,82,32,90,70,77,83,32,80,79,89,91,90,91,32,81,79,90,91,0,73,90,77,70,77,91,32,77,70,78,70,78,90,32,78,90,89,90,89,91,32,77,91,89,91,0,70,94,74,70,74,91,32,75,75,75,91,74,91,32,75,75,82,91,32,74,70,82,88,32,90,70,82,88,32,89,75,82,91,32,89,75,89,91,90,91,32,90,70,90,91,0,71,93,75,70,75,91,32,76,73,76,91,75,91,32,76,73,89,91,32,75,70,88,88,32,88,70,88,88,32,88,70,89,70,89,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,81,71,78,72,76,75,75,78,75,83,76,86,78,89,81,90,83,90,86,89,88,86,89,83,89,78,88,75,86,72,83,71,81,71,0,72,92,76,70,76,91,32,77,71,77,91,76,91,32,76,70,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,77,81,32,77,71,85,71,87,72,88,74,88,77,87,79,85,80,77,80,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,81,71,78,72,76,75,75,78,75,83,76,86,78,89,81,90,83,90,86,89,88,86,89,83,89,78,88,75,86,72,83,71,81,71,32,83,88,88,93,89,93,32,83,88,84,88,89,93,0,72,92,76,70,76,91,32,77,71,77,91,76,91,32,76,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,77,81,32,77,71,84,71,87,72,88,74,88,77,87,79,84,80,77,80,32,82,81,88,91,89,91,32,83,81,89,91,0,72,92,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,84,81,86,82,87,83,88,85,88,88,87,89,84,90,80,90,78,89,77,88,75,88,32,89,73,87,73,86,72,84,71,80,71,77,72,76,73,76,75,77,77,79,78,84,80,86,81,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,74,91,82,71,82,91,32,83,71,83,91,82,91,32,76,70,89,70,89,71,32,76,70,76,71,89,71,0,71,93,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,32,75,70,76,70,76,85,77,88,78,89,81,90,83,90,86,89,87,88,88,85,88,70,89,70,0,72,92,74,70,82,91,32,74,70,75,70,82,88,32,90,70,89,70,82,88,32,90,70,82,91,0,69,95,71,70,77,91,32,71,70,72,70,77,88,32,82,70,77,88,32,82,73,77,91,32,82,73,87,91,32,82,70,87,88,32,93,70,92,70,87,88,32,93,70,87,91,0,72,92,75,70,88,91,89,91,32,75,70,76,70,89,91,32,89,70,88,70,75,91,32,89,70,76,91,75,91,0,73,92,75,70,82,80,82,91,83,91,32,75,70,76,70,83,80,32,90,70,89,70,82,80,32,90,70,83,80,83,91,0,72,92,88,70,75,91,32,89,70,76,91,32,75,70,89,70,32,75,70,75,71,88,71,32,76,90,89,90,89,91,32,75,91,89,91,0,69,92,88,70,86,72,84,75,81,80,79,83,76,87,73,90,71,91,69,91,68,90,68,88,69,87,70,88,69,89,32,88,70,87,74,85,84,84,91,32,88,70,85,91,32,84,91,84,89,83,86,82,84,80,82,78,81,76,81,75,82,75,84,76,87,79,90,82,91,86,91,88,90,0,70,94,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,88,70,90,71,91,73,91,75,90,77,88,78,84,79,82,79,32,88,70,89,71,90,73,90,75,89,77,88,78,32,84,79,87,80,88,81,89,83,89,86,88,89,87,90,85,91,83,91,82,90,82,88,83,85,32,84,79,86,80,87,81,88,83,88,86,87,89,85,91,0,72,93,75,72,74,74,74,76,75,78,78,79,81,79,85,78,87,77,89,75,90,73,90,71,89,70,87,70,84,71,81,74,79,77,77,81,76,85,76,88,77,90,80,91,82,91,85,90,87,88,88,86,88,84,87,82,85,82,83,83,82,85,32,87,70,85,71,82,74,80,77,78,81,77,85,77,88,78,90,80,91,0,70,93,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,74,87,76,88,78,90,80,91,83,91,85,90,87,88,89,84,90,79,90,76,89,73,87,71,85,70,80,70,77,71,75,73,74,75,74,77,75,78,77,78,78,77,79,75,0,73,92,87,73,86,74,86,76,87,77,89,77,90,75,90,73,89,71,87,70,84,70,82,71,81,72,80,74,80,76,81,78,83,79,32,84,70,82,72,81,74,81,77,83,79,32,83,79,81,79,78,80,76,82,75,84,75,87,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,84,87,82,85,82,83,83,82,85,32,81,79,79,80,77,82,76,84,76,88,77,90,0,71,92,87,72,86,74,84,79,82,85,81,87,79,90,77,91,32,81,76,80,78,78,79,76,79,75,77,75,75,76,73,78,71,81,70,91,70,88,71,87,72,86,75,84,83,83,86,82,88,80,90,77,91,75,91,73,90,72,89,72,88,73,87,74,88,73,89,32,83,70,87,71,88,71,32,79,83,80,82,82,81,86,81,88,80,90,77,88,84,0,71,93,74,73,73,75,73,77,74,79,76,80,79,80,82,79,84,78,87,75,88,72,88,71,87,70,86,70,84,71,82,73,81,75,80,78,80,81,81,83,83,84,85,84,87,83,89,81,90,79,32,87,70,85,71,83,73,82,75,81,78,81,82,83,84,32,90,79,89,83,87,87,85,89,83,90,79,91,76,91,74,90,73,88,73,87,74,86,75,87,74,88,32,89,83,87,86,85,88,82,90,79,91,0,70,94,76,76,75,75,75,73,76,71,79,70,82,70,79,81,77,87,76,89,75,90,73,91,71,91,70,90,70,88,71,87,72,88,71,89,32,82,70,79,79,78,82,76,87,75,89,73,91,32,74,84,75,83,77,82,86,79,88,78,91,76,93,74,94,72,94,71,93,70,92,70,90,71,88,74,87,76,85,82,84,86,84,89,86,91,87,91,89,90,91,88,32,92,70,90,72,88,76,86,82,85,86,85,89,86,91,0,73,89,87,72,85,75,83,80,81,85,80,87,78,90,76,91,32,89,76,87,78,84,79,81,79,79,78,78,76,78,74,79,72,81,71,85,70,89,70,87,72,86,74,84,80,82,86,81,88,79,90,76,91,74,91,73,90,73,88,74,87,75,88,74,89,0,73,90,89,70,87,72,85,75,83,80,80,89,78,93,32,89,77,87,79,84,80,81,80,79,79,78,77,78,75,79,73,81,71,85,70,89,70,87,73,86,75,83,84,81,88,80,90,78,93,77,94,75,95,74,94,74,92,75,90,77,88,79,87,82,86,86,85,0,70,94,76,76,75,75,75,73,77,71,80,70,82,70,79,81,77,87,76,89,75,90,73,91,71,91,70,90,70,88,71,87,72,88,71,89,32,82,70,79,79,78,82,76,87,75,89,73,91,32,90,71,87,75,85,77,83,78,80,79,32,93,71,92,72,93,73,94,72,94,71,93,70,92,70,90,71,87,76,86,77,84,78,80,79,32,80,79,83,80,84,82,85,89,86,91,32,80,79,82,80,83,82,84,89,86,91,87,91,89,90,91,88,0,73,91,77,73,76,75,76,77,77,79,79,80,82,80,85,79,87,78,90,75,91,72,91,71,90,70,89,70,87,71,86,72,84,75,80,85,79,87,77,90,75,91,32,86,72,84,76,82,83,81,86,80,88,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,82,91,85,91,87,90,89,88,0,68,96,82,70,78,79,75,85,73,88,71,90,69,91,67,91,66,90,66,88,67,87,68,88,67,89,32,82,70,80,77,79,81,78,86,78,90,80,91,32,82,70,81,74,80,79,79,86,79,90,80,91,32,91,70,87,79,82,88,80,91,32,91,70,89,77,88,81,87,86,87,90,89,91,90,91,92,90,94,88,32,91,70,90,74,89,79,88,86,88,90,89,91,0,71,94,82,70,81,74,79,80,77,85,76,87,74,90,72,91,70,91,69,90,69,88,70,87,71,88,70,89,32,82,70,82,75,83,86,84,91,32,82,70,83,75,84,86,84,91,32,96,71,95,72,96,73,97,72,97,71,96,70,94,70,92,71,90,74,89,76,87,81,85,87,84,91,0,72,93,83,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,83,90,79,90,75,89,72,88,71,87,71,85,72,83,74,81,78,80,83,80,86,32,81,71,79,74,77,78,76,82,76,86,77,89,79,91,0,70,93,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,86,70,89,71,90,72,91,74,91,77,90,79,89,80,86,81,84,81,82,80,32,86,70,88,71,89,72,90,74,90,77,89,79,88,80,86,81,0,72,93,85,74,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,83,83,87,80,89,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,83,91,86,91,88,90,90,88,32,87,70,88,71,89,73,89,77,88,80,86,83,83,86,79,89,75,91,0,70,94,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,87,70,90,71,91,73,91,75,90,77,89,78,86,79,82,79,32,87,70,89,71,90,73,90,75,89,77,88,78,86,79,32,82,79,85,80,86,82,87,89,88,91,32,82,79,84,80,85,82,86,89,88,91,89,91,91,90,93,88,0,72,92,78,73,77,75,77,77,78,79,80,80,83,80,86,79,88,78,91,75,92,72,92,71,91,70,90,70,88,71,87,72,86,74,85,77,83,84,82,87,80,90,78,91,32,86,74,85,78,84,85,83,88,81,90,78,91,75,91,73,90,72,88,72,87,73,86,74,87,73,88,0,73,91,89,72,88,74,86,79,84,85,83,87,81,90,79,91,32,83,76,82,78,80,79,78,79,77,77,77,75,78,73,80,71,83,70,92,70,90,71,89,72,88,75,86,83,85,86,84,88,82,90,79,91,77,91,75,90,74,89,74,88,75,87,76,88,75,89,32,85,70,89,71,90,71,0,71,93,72,74,74,71,76,70,77,70,79,72,79,75,78,78,75,86,75,89,76,91,32,77,70,78,72,78,75,75,83,74,86,74,89,76,91,78,91,80,90,83,87,85,84,86,82,32,90,70,86,82,85,86,85,89,87,91,88,91,90,90,92,88,32,91,70,87,82,86,86,86,89,87,91,0,71,92,72,74,74,71,76,70,77,70,79,72,79,75,78,79,76,86,76,89,77,91,32,77,70,78,72,78,75,76,82,75,86,75,89,77,91,78,91,81,90,84,87,86,84,88,80,89,77,90,73,90,71,89,70,88,70,87,71,86,73,86,76,87,78,89,80,91,81,93,81,0,70,93,73,76,72,76,71,75,71,73,72,71,74,70,78,70,77,72,76,76,75,85,74,91,32,76,76,76,85,75,91,32,86,70,84,72,82,76,79,85,77,89,75,91,32,86,70,85,72,84,76,83,85,82,91,32,84,76,84,85,83,91,32,96,70,94,71,92,73,90,76,87,85,85,89,83,91,0,72,92,80,75,79,76,77,76,76,75,76,73,77,71,79,70,81,70,83,71,84,73,84,76,83,80,81,85,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,81,70,82,71,83,73,83,76,82,80,80,85,78,88,76,90,74,91,32,93,71,92,72,93,73,94,72,94,71,93,70,91,70,89,71,87,73,85,76,83,80,82,85,82,88,83,90,84,91,85,91,87,90,89,88,0,71,93,74,74,76,71,78,70,79,70,81,71,81,73,79,79,79,82,80,84,32,79,70,80,71,80,73,78,79,78,82,80,84,82,84,85,83,87,81,89,78,90,76,32,92,70,90,76,87,84,85,88,32,93,70,91,76,89,81,87,85,85,88,83,90,80,91,76,91,74,90,73,88,73,87,74,86,75,87,74,88,0,71,92,90,72,89,74,87,79,86,82,85,84,83,87,81,89,79,90,76,91,32,83,76,82,78,80,79,78,79,77,77,77,75,78,73,80,71,83,70,93,70,91,71,90,72,89,75,88,79,86,85,84,88,81,90,76,91,72,91,71,90,71,88,72,87,74,87,76,88,79,90,81,91,84,91,87,90,89,88,32,86,70,90,71,91,71,0,72,92,87,77,87,91,88,91,32,87,77,88,77,88,91,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,72,92,76,70,76,91,77,91,32,76,70,77,70,77,91,32,77,80,79,78,81,77,84,77,86,78,88,80,89,83,89,85,88,88,86,90,84,91,81,91,79,90,77,88,32,77,80,81,78,84,78,86,79,87,80,88,83,88,85,87,88,86,89,84,90,81,90,77,88,0,73,91,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,32,88,80,87,81,86,79,84,78,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,87,88,88,0,72,92,87,70,87,91,88,91,32,87,70,88,70,88,91,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,73,91,77,84,88,84,88,81,87,79,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,32,77,83,87,83,87,81,86,79,84,78,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,87,88,88,0,76,90,87,70,85,70,83,71,82,74,82,91,83,91,32,87,70,87,71,85,71,83,72,32,84,71,83,74,83,91,32,79,77,86,77,86,78,32,79,77,79,78,86,78,0,72,92,88,77,87,77,87,92,86,95,85,96,83,97,81,97,79,96,78,95,76,95,32,88,77,88,92,87,95,85,97,83,98,80,98,78,97,76,95,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,72,92,76,70,76,91,77,91,32,76,70,77,70,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,32,77,81,80,79,82,78,84,78,86,79,87,81,87,91,88,91,0,78,87,82,70,81,71,81,72,82,73,83,73,84,72,84,71,83,70,82,70,32,82,71,82,72,83,72,83,71,82,71,32,82,77,82,91,83,91,32,82,77,83,77,83,91,0,78,87,82,70,81,71,81,72,82,73,83,73,84,72,84,71,83,70,82,70,32,82,71,82,72,83,72,83,71,82,71,32,82,77,82,98,83,98,32,82,77,83,77,83,98,0,72,91,76,70,76,91,77,91,32,76,70,77,70,77,91,32,88,77,87,77,77,87,32,88,77,77,88,32,80,84,86,91,88,91,32,81,83,88,91,0,67,98,71,77,71,91,72,91,32,71,77,72,77,72,91,32,72,81,75,78,77,77,80,77,82,78,83,81,83,91,32,72,81,75,79,77,78,79,78,81,79,82,81,82,91,83,91,32,83,81,86,78,88,77,91,77,93,78,94,81,94,91,32,83,81,86,79,88,78,90,78,92,79,93,81,93,91,94,91,0,72,92,76,77,76,91,77,91,32,76,77,77,77,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,32,77,81,80,79,82,78,84,78,86,79,87,81,87,91,88,91,0,73,92,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,89,85,89,83,88,80,86,78,84,77,81,77,32,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,88,88,85,88,83,87,80,86,79,84,78,81,78,0,72,92,76,77,76,98,77,98,32,76,77,77,77,77,98,32,77,80,79,78,81,77,84,77,86,78,88,80,89,83,89,85,88,88,86,90,84,91,81,91,79,90,77,88,32,77,80,81,78,84,78,86,79,87,80,88,83,88,85,87,88,86,89,84,90,81,90,77,88,0,72,92,87,77,87,98,88,98,32,87,77,88,77,88,98,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,75,89,79,77,79,91,80,91,32,79,77,80,77,80,91,32,80,83,81,80,83,78,85,77,88,77,32,80,83,81,81,83,79,85,78,88,78,88,77,0,74,91,88,80,87,78,84,77,81,77,78,78,77,80,78,82,80,83,85,85,87,86,32,86,85,87,87,87,88,86,90,32,87,89,84,90,81,90,78,89,32,79,90,78,88,77,88,32,88,80,87,80,86,78,32,87,79,84,78,81,78,78,79,32,79,78,78,80,79,82,32,78,81,80,82,85,84,87,85,88,87,88,88,87,90,84,91,81,91,78,90,77,88,0,77,88,82,70,82,91,83,91,32,82,70,83,70,83,91,32,79,77,86,77,86,78,32,79,77,79,78,86,78,0,72,92,76,77,76,87,77,90,79,91,82,91,84,90,87,87,32,76,77,77,77,77,87,78,89,80,90,82,90,84,89,87,87,32,87,77,87,91,88,91,32,87,77,88,77,88,91,0,74,90,76,77,82,91,32,76,77,77,77,82,89,32,88,77,87,77,82,89,32,88,77,82,91,0,70,94,73,77,78,91,32,73,77,74,77,78,88,32,82,77,78,88,32,82,80,78,91,32,82,80,86,91,32,82,77,86,88,32,91,77,90,77,86,88,32,91,77,86,91,0,73,91,76,77,87,91,88,91,32,76,77,77,77,88,91,32,88,77,87,77,76,91,32,88,77,77,91,76,91,0,74,90,76,77,82,91,32,76,77,77,77,82,89,32,88,77,87,77,82,89,78,98,32,88,77,82,91,79,98,78,98,0,73,91,86,78,76,91,32,88,77,78,90,32,76,77,88,77,32,76,77,76,78,86,78,32,78,90,88,90,88,91,32,76,91,88,91,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,86,82,84,88,84,90,86,91,88,90,89,89,91,86,32,87,82,85,88,85,90,86,91,0,76,90,76,86,78,83,80,79,32,83,70,77,88,77,90,79,91,80,91,82,90,84,88,85,85,85,82,86,86,87,87,88,87,90,86,32,84,70,78,88,78,90,79,91,0,76,88,84,83,83,84,84,84,84,83,83,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,32,81,82,79,84,78,86,78,89,80,91,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,90,70,84,88,84,90,86,91,88,90,89,89,91,86,32,91,70,85,88,85,90,86,91,0,76,88,79,89,81,88,82,87,83,85,83,83,82,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,32,81,82,79,84,78,86,78,89,80,91,0,79,88,82,82,85,79,87,76,88,73,88,71,87,70,85,71,84,73,75,100,75,102,76,103,78,102,79,99,80,90,81,91,83,91,85,90,86,89,88,86,32,84,73,83,78,82,82,79,91,77,96,75,100,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,86,82,80,100,32,87,82,84,91,82,96,80,100,79,102,77,103,76,102,76,100,77,97,79,95,82,93,86,91,89,89,91,86,0,76,91,76,86,78,83,80,79,32,83,70,76,91,32,84,70,77,91,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,78,86,83,76,82,77,83,78,84,77,83,76,32,81,82,79,88,79,90,81,91,83,90,84,89,86,86,32,82,82,80,88,80,90,81,91,0,78,86,83,76,82,77,83,78,84,77,83,76,32,81,82,75,100,32,82,82,79,91,77,96,75,100,74,102,72,103,71,102,71,100,72,97,74,95,77,93,81,91,84,89,86,86,0,76,90,76,86,78,83,80,79,32,83,70,76,91,32,84,70,77,91,32,85,82,85,83,86,83,85,82,84,82,82,84,79,85,32,79,85,82,86,83,90,84,91,32,79,85,81,86,82,90,84,91,85,91,88,89,90,86,0,78,86,78,86,80,83,82,79,32,85,70,79,88,79,90,81,91,83,90,84,89,86,86,32,86,70,80,88,80,90,81,91,0,69,94,69,86,71,83,73,82,75,83,75,85,73,91,32,73,82,74,83,74,85,72,91,32,75,85,77,83,79,82,80,82,82,83,82,85,80,91,32,80,82,81,83,81,85,79,91,32,82,85,84,83,86,82,87,82,89,83,89,85,88,88,88,90,89,91,32,87,82,88,83,88,85,87,88,87,90,89,91,91,90,92,89,94,86,0,73,91,73,86,75,83,77,82,79,83,79,85,77,91,32,77,82,78,83,78,85,76,91,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,75,89,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,85,87,85,85,84,83,82,82,81,83,81,85,82,87,84,88,86,88,88,87,89,86,32,80,82,78,84,77,86,77,89,79,91,0,76,91,76,86,78,83,80,79,32,81,76,72,103,32,82,76,73,103,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,32,80,82,78,84,77,86,77,89,79,91,32,86,82,80,100,80,102,81,103,83,102,84,99,84,91,86,91,89,89,91,86,32,87,82,84,91,82,96,80,100,0,76,90,76,86,78,83,80,82,82,83,82,85,80,91,32,80,82,81,83,81,85,79,91,32,82,85,84,83,86,82,87,82,86,85,32,86,82,86,85,87,87,88,87,90,86,0,78,90,78,86,80,83,81,81,81,83,84,85,85,87,85,89,84,90,82,91,32,81,83,83,85,84,87,84,89,82,91,32,78,90,80,91,85,91,88,89,90,86,0,78,86,78,86,80,83,82,79,32,85,70,79,88,79,90,81,91,83,90,84,89,86,86,32,86,70,80,88,80,90,81,91,32,80,78,86,78,0,75,91,78,82,76,88,76,90,78,91,79,91,81,90,83,88,85,85,32,79,82,77,88,77,90,78,91,32,86,82,84,88,84,90,86,91,88,90,89,89,91,86,32,87,82,85,88,85,90,86,91,0,75,90,78,82,77,84,76,87,76,90,78,91,79,91,82,90,84,88,85,85,85,82,32,79,82,78,84,77,87,77,90,78,91,32,85,82,86,86,87,87,88,87,90,86,0,72,93,76,82,74,84,73,87,73,90,75,91,76,91,78,90,80,88,32,77,82,75,84,74,87,74,90,75,91,32,82,82,80,88,80,90,82,91,83,91,85,90,87,88,88,85,88,82,32,83,82,81,88,81,90,82,91,32,88,82,89,86,90,87,91,87,93,86,0,74,90,74,86,76,83,78,82,80,82,81,83,81,85,80,88,79,90,77,91,76,91,75,90,75,89,76,89,75,90,32,87,83,86,84,87,84,87,83,86,82,85,82,83,83,82,85,81,88,81,90,82,91,85,91,88,89,90,86,32,81,83,82,85,32,83,83,81,85,32,80,88,81,90,32,81,88,79,90,0,75,91,78,82,76,88,76,90,78,91,79,91,81,90,83,88,85,85,32,79,82,77,88,77,90,78,91,32,86,82,80,100,32,87,82,84,91,82,96,80,100,79,102,77,103,76,102,76,100,77,97,79,95,82,93,86,91,89,89,91,86,0,76,89,76,86,78,83,80,82,82,82,84,83,84,86,83,88,80,90,78,91,32,82,82,83,83,83,86,82,88,80,90,32,78,91,80,92,81,94,81,97,80,100,78,102,76,103,75,102,75,100,76,97,79,94,82,92,86,89,89,86,32,78,91,79,92,80,94,80,97,79,100,78,102,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,79,71,77,74,76,79,76,82,77,87,79,90,32,78,89,81,90,83,90,86,89,32,85,90,87,87,88,82,88,79,87,74,85,71,32,86,72,83,71,81,71,78,72,0,72,92,78,74,80,73,83,70,83,91,32,78,74,78,75,80,74,82,72,82,91,83,91,0,72,92,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,85,81,76,91,32,76,75,77,75,77,74,78,72,80,71,84,71,86,72,87,74,87,76,86,78,84,81,75,91,32,76,90,89,90,89,91,32,75,91,89,91,0,72,92,77,70,88,70,81,79,32,77,70,77,71,87,71,32,87,70,80,79,32,81,78,83,78,86,79,88,81,89,84,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,76,87,32,80,79,83,79,86,80,88,83,32,84,79,87,81,88,84,88,85,87,88,84,90,32,88,86,86,89,83,90,80,90,77,89,76,87,32,79,90,76,88,0,72,92,85,73,85,91,86,91,32,86,70,86,91,32,86,70,75,86,90,86,32,85,73,76,86,32,76,85,90,85,90,86,0,72,92,77,70,76,79,32,78,71,77,78,32,77,70,87,70,87,71,32,78,71,87,71,32,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,76,87,32,76,79,77,79,79,78,83,78,86,79,88,82,32,84,78,87,80,88,83,88,85,87,88,84,90,32,88,86,86,89,83,90,80,90,77,89,76,87,32,79,90,76,88,0,72,92,86,71,87,73,88,73,87,71,84,70,82,70,79,71,77,74,76,79,76,84,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,32,87,72,84,71,82,71,79,72,32,80,71,78,74,77,79,77,84,78,88,81,90,32,77,86,79,89,82,90,83,90,86,89,88,86,32,84,90,87,88,88,85,88,84,87,81,84,79,32,88,83,86,80,83,79,82,79,79,80,77,83,32,81,79,78,81,77,84,0,72,92,75,70,89,70,79,91,32,75,70,75,71,88,71,32,88,70,78,91,79,91,0,72,92,80,70,77,71,76,73,76,75,77,77,78,78,80,79,84,80,86,81,87,82,88,84,88,87,87,89,84,90,80,90,77,89,76,87,76,84,77,82,78,81,80,80,84,79,86,78,87,77,88,75,88,73,87,71,84,70,80,70,32,78,71,77,73,77,75,78,77,80,78,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,84,76,82,78,80,80,79,84,78,86,77,87,75,87,73,86,71,32,87,72,84,71,80,71,77,72,32,76,88,79,90,32,85,90,88,88,0,72,92,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,82,70,85,71,87,73,88,77,88,82,87,87,85,90,82,91,80,91,77,90,76,88,77,88,78,90,32,87,77,86,80,83,82,32,87,78,85,81,82,82,81,82,78,81,76,78,32,80,82,77,80,76,77,76,76,77,73,80,71,32,76,75,78,72,81,71,82,71,85,72,87,75,32,83,71,86,73,87,77,87,82,86,87,84,90,32,85,89,82,90,80,90,77,89,0,77,88,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,84,90,83,91,82,91,81,90,81,89,82,88,83,88,84,89,84,92,83,94,81,95,32,82,89,82,90,83,90,83,89,82,89,32,83,91,84,92,32,84,90,83,94,0,77,88,82,77,81,78,81,79,82,80,83,80,84,79,84,78,83,77,82,77,32,82,78,82,79,83,79,83,78,82,78,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,82,77,81,78,81,79,82,80,83,80,84,79,84,78,83,77,82,77,32,82,78,82,79,83,79,83,78,82,78,32,84,90,83,91,82,91,81,90,81,89,82,88,83,88,84,89,84,92,83,94,81,95,32,82,89,82,90,83,90,83,89,82,89,32,83,91,84,92,32,84,90,83,94,0,77,88,82,70,82,84,83,84,32,82,70,83,70,83,84,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,73,92,76,75,76,74,77,72,78,71,81,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,82,81,32,76,75,77,75,77,74,78,72,81,71,84,71,87,72,88,74,88,76,87,78,85,79,82,80,32,77,73,80,71,32,85,71,88,73,32,88,77,84,80,32,82,80,82,84,83,84,83,80,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,84,70,82,71,81,73,81,76,82,77,83,77,84,76,84,75,83,74,82,74,81,75,32,82,75,82,76,83,76,83,75,82,75,32,82,71,81,75,32,81,73,82,74,0,77,88,84,72,83,73,82,73,81,72,81,71,82,70,83,70,84,71,84,74,83,76,81,77,32,82,71,82,72,83,72,83,71,82,71,32,83,73,84,74,32,84,72,83,76,0,70,95,92,77,90,77,88,78,87,80,85,86,84,88,83,89,81,90,77,90,75,89,74,87,74,85,75,83,76,82,81,79,83,77,84,75,84,73,83,71,81,70,80,70,78,71,77,73,77,75,78,78,80,81,85,87,88,90,90,91,92,91,32,92,77,92,78,90,78,87,80,32,90,77,88,80,86,86,85,88,83,90,81,91,77,91,75,90,74,89,73,87,73,85,74,83,76,81,81,78,82,77,83,75,83,73,82,71,32,83,72,81,71,80,71,78,72,32,79,71,78,73,78,75,79,78,81,81,86,87,88,89,90,90,92,90,92,91,0,73,92,82,66,82,95,83,95,32,82,66,83,66,83,95,32,87,73,89,73,87,71,84,70,81,70,78,71,76,73,76,75,77,77,78,78,86,82,87,83,88,85,88,87,87,89,84,90,81,90,79,89,78,88,32,87,73,86,72,84,71,81,71,78,72,77,73,77,75,78,77,86,81,88,83,89,85,89,87,88,89,87,90,84,91,81,91,78,90,76,88,78,88,32,88,88,85,90,0,71,94,91,66,73,98,74,98,32,91,66,92,66,74,98,0,75,89,85,66,83,68,81,71,79,75,78,80,78,84,79,89,81,93,83,96,85,98,86,98,32,85,66,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,79,98,32,78,66,79,66,81,68,83,71,85,75,86,80,86,84,85,89,83,93,81,96,79,98,0,74,90,82,70,81,71,83,81,82,82,32,82,70,82,82,32,82,70,83,71,81,81,82,82,32,77,73,78,73,86,79,87,79,32,77,73,87,79,32,77,73,77,74,87,78,87,79,32,87,73,86,73,78,79,77,79,32,87,73,77,79,32,87,73,87,74,77,78,77,79,0,70,95,74,81,91,81,91,82,32,74,81,74,82,91,82,0,70,95,82,73,82,90,83,90,32,82,73,83,73,83,90,32,74,81,91,81,91,82,32,74,81,74,82,91,82,0,70,95,74,77,91,77,91,78,32,74,77,74,78,91,78,32,74,85,91,85,91,86,32,74,85,74,86,91,86,0,78,87,83,70,82,71,82,77,32,83,71,82,77,32,83,70,84,71,82,77,0,73,91,78,70,77,71,77,77,32,78,71,77,77,32,78,70,79,71,77,77,32,87,70,86,71,86,77,32,87,71,86,77,32,87,70,88,71,86,77,0,75,89,81,70,79,71,78,73,78,75,79,77,81,78,83,78,85,77,86,75,86,73,85,71,83,70,81,70,32,81,70,78,73,79,77,83,78,86,75,85,71,81,70,32,83,70,79,71,78,75,81,78,85,77,86,73,83,70,0,70,94,90,73,74,82,90,91,32,90,73,90,74,76,82,90,90,90,91,0,70,94,74,73,90,82,74,91,32,74,73,74,74,88,82,74,90,74,91,0,71,94,79,70,79,98,80,98,32,79,70,80,70,80,98,32,85,70,85,98,86,98,32,85,70,86,70,86,98,32,74,80,91,80,91,81,32,74,80,74,81,91,81,32,74,87,91,87,91,88,32,74,87,74,88,91,88,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,72,91,73,91,32,91,70,92,70,73,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,32,78,70,74,71,73,75,77,77,80,74,78,70,32,76,70,73,73,75,77,79,76,80,72,76,70,32,89,84,85,85,84,89,88,91,91,88,89,84,32,87,84,84,87,86,91,90,90,91,86,87,84,0,69,96,87,77,84,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,84,86,87,84,32,87,77,84,76,81,76,79,77,78,79,78,82,79,84,81,85,84,85,87,84,32,86,75,86,83,87,85,89,86,90,86,92,85,93,83,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,85,91,89,90,32,86,75,87,75,87,83,88,85,90,86,32,89,86,91,85,92,83,92,79,91,76,90,74,89,73,87,72,84,71,81,71,78,72,76,73,75,74,74,76,73,79,73,82,74,85,75,87,76,88,78,89,81,90,85,90,89,89,89,90,0,69,95,74,80,76,79,78,79,80,80,83,84,84,85,86,86,88,86,90,85,91,83,91,81,90,79,88,78,86,78,84,79,83,80,80,84,78,85,76,85,74,84,32,90,80,88,79,86,79,84,80,81,84,80,85,78,86,76,86,74,85,73,83,73,81,74,79,76,78,78,78,80,79,81,80,84,84,86,85,88,85,90,84,32,75,79,74,81,74,83,75,85,32,89,85,90,83,90,81,89,79,0,72,93,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,84,70,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,79,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,0,72,93,84,74,79,91,32,86,70,80,91,32,86,70,83,73,80,75,78,76,32,85,73,81,75,78,76,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,87,79,84,81,80,83,77,85,75,87,73,91,32,86,70,88,71,89,73,89],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+301300);allocate([75,88,77,86,79,80,83,32,74,89,75,88,77,88,82,90,85,90,87,89,88,87,32,77,88,82,91,85,91,87,90,88,87,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,86,79,83,80,32,86,70,88,71,89,73,89,75,88,77,86,79,32,81,80,83,80,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,32,83,80,85,81,86,82,87,84,87,87,86,89,85,90,83,91,0,72,93,88,71,82,91,32,89,70,83,91,32,89,70,74,85,90,85,0,72,93,81,70,76,80,32,81,70,91,70,32,81,71,86,71,91,70,32,76,80,77,79,80,78,83,78,86,79,87,80,88,82,88,85,87,88,85,90,82,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,32,83,78,85,79,86,80,87,82,87,85,86,88,84,90,82,91,0,72,93,89,73,88,74,89,75,90,74,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,87,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,81,79,79,80,77,82,76,84,32,84,70,82,71,80,73,78,76,77,79,76,83,76,88,77,90,32,82,91,84,90,86,88,87,86,87,82,86,80,0,72,93,78,70,76,76,32,91,70,90,73,88,76,83,82,81,85,80,87,79,91,32,88,76,82,82,80,85,79,87,78,91,32,77,73,80,70,82,70,87,73,32,78,72,80,71,82,71,87,73,89,73,90,72,91,70,0,72,93,83,70,80,71,79,72,78,74,78,77,79,79,81,80,84,80,88,79,89,78,90,76,90,73,89,71,86,70,83,70,32,83,70,81,71,80,72,79,74,79,77,80,79,81,80,32,84,80,87,79,88,78,89,76,89,73,88,71,86,70,32,81,80,77,81,75,83,74,85,74,88,75,90,78,91,82,91,86,90,87,89,88,87,88,84,87,82,86,81,84,80,32,81,80,78,81,76,83,75,85,75,88,76,90,78,91,32,82,91,85,90,86,89,87,87,87,83,86,81,0,72,93,89,77,88,79,86,81,84,82,81,82,79,81,78,80,77,78,77,75,78,73,80,71,83,70,86,70,88,71,89,72,90,74,90,78,89,82,88,85,86,88,84,90,81,91,78,91,76,90,75,88,75,87,76,86,77,87,76,88,32,79,81,78,79,78,75,79,73,81,71,83,70,32,88,71,89,73,89,78,88,82,87,85,85,88,83,90,81,91,0,77,88,80,89,79,90,80,91,81,90,80,89,0,77,88,80,91,79,90,80,89,81,90,81,91,80,93,78,95,0,77,88,83,77,82,78,83,79,84,78,83,77,32,80,89,79,90,80,91,81,90,0,77,88,83,77,82,78,83,79,84,78,83,77,32,80,91,79,90,80,89,81,90,81,91,80,93,78,95,0,77,88,85,70,84,71,82,83,32,85,71,82,83,32,85,70,86,71,82,83,32,80,89,79,90,80,91,81,90,80,89,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,87,70,90,71,91,73,91,75,90,77,89,78,83,80,81,81,81,83,82,84,84,84,32,87,70,89,71,90,73,90,75,89,77,88,78,86,79,32,80,89,79,90,80,91,81,90,80,89,0,77,88,86,70,84,72,83,74,83,75,84,76,85,75,84,74,0,77,88,85,72,84,71,85,70,86,71,86,72,85,74,83,76,0,69,95,92,78,91,79,92,80,93,79,93,78,92,77,91,77,89,78,87,80,82,88,80,90,78,91,75,91,72,90,71,88,71,86,72,84,73,83,75,82,80,80,82,79,84,77,85,75,85,73,84,71,82,70,80,71,79,73,79,76,80,82,81,85,83,88,85,90,87,91,89,91,90,89,90,88,32,75,91,73,90,72,88,72,86,73,84,74,83,80,80,32,79,76,80,81,81,84,83,87,85,89,87,90,89,90,90,89,0,72,93,84,66,76,95,32,89,66,81,95,32,90,74,89,75,90,76,91,75,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,75,78,77,79,78,86,82,88,84,32,77,75,79,77,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,0,71,93,95,66,69,98,0,75,90,90,66,86,69,83,72,81,75,79,79,78,84,78,88,79,93,80,96,81,98,32,86,69,83,73,81,77,80,80,79,85,79,90,80,95,81,98,0,74,89,83,66,84,68,85,71,86,76,86,80,85,85,83,89,81,92,78,95,74,98,32,83,66,84,69,85,74,85,79,84,84,83,87,81,91,78,95,0,74,91,84,70,84,82,32,79,73,89,79,32,89,73,79,79,0,78,87,85,70,83,77,32,86,70,83,77,0,73,91,80,70,78,77,32,81,70,78,77,32,89,70,87,77,32,90,70,87,77,0,75,90,83,70,81,71,80,73,80,75,81,77,83,78,85,78,87,77,88,75,88,73,87,71,85,70,83,70,0,72,93,83,70,76,98,32,89,70,82,98,32,76,81,90,81,32,75,87,89,87,0,69,95,94,70,92,71,88,72,85,72,81,71,79,70,77,70,75,71,74,73,74,75,76,77,78,77,80,76,81,74,81,72,79,70,32,94,70,70,91,32,88,84,86,84,84,85,83,87,83,89,85,91,87,91,89,90,90,88,90,86,88,84,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,89,70,89,76,88,70,32,77,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,70,94,78,70,78,76,77,84,76,88,75,90,74,91,32,88,70,88,91,32,89,70,89,91,32,75,70,92,70,32,71,91,92,91,32,71,91,71,98,32,72,91,71,98,32,91,91,92,98,32,92,91,92,98,0,67,98,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,71,71,72,72,71,73,70,72,70,71,71,70,72,70,73,71,74,73,75,77,76,79,78,80,87,80,89,79,90,77,91,73,92,71,93,70,94,70,95,71,95,72,94,73,93,72,94,71,32,78,80,76,81,75,83,74,88,73,90,72,91,32,78,80,77,81,76,83,75,88,74,90,73,91,71,91,70,90,69,88,32,87,80,89,81,90,83,91,88,92,90,93,91,32,87,80,88,81,89,83,90,88,91,90,92,91,94,91,95,90,96,88,32,79,91,86,91,0,72,92,76,73,75,70,75,76,76,73,78,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,81,79,32,84,70,86,71,87,73,87,76,86,78,84,79,32,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,79,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,87,81,88,84,88,87,87,89,86,90,84,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,88,72,76,89,32,72,91,79,91,32,85,91,92,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,88,72,76,89,32,72,91,79,91,32,85,91,92,91,32,78,64,78,63,77,63,77,64,78,66,80,67,84,67,86,66,87,64,0,70,94,75,70,75,91,32,76,70,76,91,32,72,70,79,70,32,76,80,83,80,85,79,86,77,87,73,88,71,89,70,90,70,91,71,91,72,90,73,89,72,90,71,32,83,80,85,81,86,83,87,88,88,90,89,91,32,83,80,84,81,85,83,86,88,87,90,88,91,90,91,91,90,92,88,32,72,91,79,91,0,69,94,77,70,77,76,76,84,75,88,74,90,73,91,72,91,71,90,71,89,72,88,73,89,72,90,32,88,70,88,91,32,89,70,89,91,32,74,70,92,70,32,85,91,92,91,0,72,93,75,70,82,86,32,76,70,83,86,32,90,70,83,86,81,89,80,90,78,91,77,91,76,90,76,89,77,88,78,89,77,90,32,73,70,79,70,32,86,70,92,70,0,70,95,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,80,73,76,74,74,76,73,79,73,82,74,85,76,87,80,88,85,88,89,87,91,85,92,82,92,79,91,76,89,74,85,73,80,73,32,80,73,77,74,75,76,74,79,74,82,75,85,77,87,80,88,32,85,88,88,87,90,85,91,82,91,79,90,76,88,74,85,73,32,79,91,86,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,72,91,92,91,32,91,91,92,98,32,92,91,92,98,0,70,93,75,70,75,81,76,83,79,84,82,84,85,83,87,81,32,76,70,76,81,77,83,79,84,32,87,70,87,91,32,88,70,88,91,32,72,70,79,70,32,84,70,91,70,32,84,91,91,91,0,66,99,71,70,71,91,32,72,70,72,91,32,82,70,82,91,32,83,70,83,91,32,93,70,93,91,32,94,70,94,91,32,68,70,75,70,32,79,70,86,70,32,90,70,97,70,32,68,91,97,91,0,66,99,71,70,71,91,32,72,70,72,91,32,82,70,82,91,32,83,70,83,91,32,93,70,93,91,32,94,70,94,91,32,68,70,75,70,32,79,70,86,70,32,90,70,97,70,32,68,91,97,91,32,96,91,97,98,32,97,91,97,98,0,70,96,80,70,80,91,32,81,70,81,91,32,73,70,72,76,72,70,84,70,32,81,80,88,80,91,81,92,82,93,84,93,87,92,89,91,90,88,91,77,91,32,88,80,90,81,91,82,92,84,92,87,91,89,90,90,88,91,0,67,97,72,70,72,91,32,73,70,73,91,32,69,70,76,70,32,73,80,80,80,83,81,84,82,85,84,85,87,84,89,83,90,80,91,69,91,32,80,80,82,81,83,82,84,84,84,87,83,89,82,90,80,91,32,91,70,91,91,32,92,70,92,91,32,88,70,95,70,32,88,91,95,91,0,72,93,77,70,77,91,32,78,70,78,91,32,74,70,81,70,32,78,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,74,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,72,93,76,73,75,70,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,83,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,83,91,32,80,80,89,80,0,67,98,72,70,72,91,32,73,70,73,91,32,69,70,76,70,32,69,91,76,91,32,86,70,83,71,81,73,80,75,79,79,79,82,80,86,81,88,83,90,86,91,88,91,91,90,93,88,94,86,95,82,95,79,94,75,93,73,91,71,88,70,86,70,32,86,70,84,71,82,73,81,75,80,79,80,82,81,86,82,88,84,90,86,91,32,88,91,90,90,92,88,93,86,94,82,94,79,93,75,92,73,90,71,88,70,32,73,80,79,80,0,71,93,87,70,87,91,32,88,70,88,91,32,91,70,79,70,76,71,75,72,74,74,74,76,75,78,76,79,79,80,87,80,32,79,70,77,71,76,72,75,74,75,76,76,78,77,79,79,80,32,82,80,80,81,79,82,76,89,75,90,74,90,73,89,32,80,81,79,83,77,90,76,91,74,91,73,89,73,88,32,84,91,91,91,0,72,92,88,70,87,71,81,73,78,75,76,78,75,81,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,78,78,76,80,75,83,32,88,70,87,72,85,73,81,74,78,76,76,78,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,83,87,80,85,78,83,77,0,72,92,77,77,77,91,32,78,77,78,91,32,74,77,85,77,88,78,89,80,89,81,88,83,85,84,32,85,77,87,78,88,80,88,81,87,83,85,84,32,78,84,85,84,88,85,89,87,89,88,88,90,85,91,74,91,32,85,84,87,85,88,87,88,88,87,90,85,91,0,72,90,77,77,77,91,32,78,77,78,91,32,74,77,88,77,88,82,87,77,32,74,91,81,91,0,70,93,78,77,78,81,77,87,76,90,75,91,32,87,77,87,91,32,88,77,88,91,32,75,77,91,77,32,73,91,72,96,72,91,91,91,91,96,90,91,0,69,96,82,77,82,91,32,83,77,83,91,32,79,77,86,77,32,74,78,73,79,72,78,73,77,74,77,75,78,77,82,78,83,80,84,85,84,87,83,88,82,90,78,91,77,92,77,93,78,92,79,91,78,32,80,84,78,85,77,86,75,90,74,91,32,80,84,78,86,76,90,75,91,73,91,72,90,71,88,32,85,84,87,85,88,86,90,90,91,91,32,85,84,87,86,89,90,90,91,92,91,93,90,94,88,32,79,91,86,91,0,73,91,77,79,76,77,76,81,77,79,78,78,80,77,84,77,87,78,88,80,88,81,87,83,84,84,32,84,77,86,78,87,80,87,81,86,83,84,84,32,81,84,84,84,87,85,88,87,88,88,87,90,84,91,80,91,77,90,76,88,76,87,77,86,78,87,77,88,32,84,84,86,85,87,87,87,88,86,90,84,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,80,91,32,84,91,91,91,32,87,78,77,90,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,80,91,32,84,91,91,91,32,87,78,77,90,32,79,71,79,70,78,70,78,71,79,73,81,74,83,74,85,73,86,71,0,72,92,77,77,77,91,32,78,77,78,91,32,74,77,81,77,32,78,84,80,84,83,83,84,82,86,78,87,77,88,77,89,78,88,79,87,78,32,80,84,83,85,84,86,86,90,87,91,32,80,84,82,85,83,86,85,90,86,91,88,91,89,90,90,88,32,74,91,81,91,0,71,93,78,77,78,81,77,87,76,90,75,91,74,91,73,90,74,89,75,90,32,87,77,87,91,32,88,77,88,91,32,75,77,91,77,32,84,91,91,91,0,71,94,76,77,76,91,32,76,77,82,91,32,77,77,82,89,32,88,77,82,91,32,88,77,88,91,32,89,77,89,91,32,73,77,77,77,32,88,77,92,77,32,73,91,79,91,32,85,91,92,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,77,84,87,84,32,73,91,80,91,32,84,91,91,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,91,77,32,73,91,80,91,32,84,91,91,91,0,73,92,82,77,82,91,32,83,77,83,91,32,77,77,76,82,76,77,89,77,89,82,88,77,32,79,91,86,91,0,73,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,80,95,78,97,76,98,75,98,74,97,75,96,76,97,32,74,77,80,77,32,84,77,90,77,0,72,93,82,70,82,98,32,83,70,83,98,32,79,70,83,70,32,82,80,81,78,80,77,78,77,76,78,75,81,75,87,76,90,78,91,80,91,81,90,82,88,32,78,77,77,78,76,81,76,87,77,90,78,91,32,87,77,88,78,89,81,89,87,88,90,87,91,32,83,80,84,78,85,77,87,77,89,78,90,81,90,87,89,90,87,91,85,91,84,90,83,88,32,79,98,86,98,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,91,91,91,96,90,91,0,71,93,76,77,76,84,77,86,80,87,82,87,85,86,87,84,32,77,77,77,84,78,86,80,87,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,84,91,91,91,0,67,98,72,77,72,91,32,73,77,73,91,32,82,77,82,91,32,83,77,83,91,32,92,77,92,91,32,93,77,93,91,32,69,77,76,77,32,79,77,86,77,32,89,77,96,77,32,69,91,96,91,0,67,98,72,77,72,91,32,73,77,73,91,32,82,77,82,91,32,83,77,83,91,32,92,77,92,91,32,93,77,93,91,32,69,77,76,77,32,79,77,86,77,32,89,77,96,77,32,69,91,96,91,96,96,95,91,0,72,93,81,77,81,91,32,82,77,82,91,32,76,77,75,82,75,77,85,77,32,82,84,86,84,89,85,90,87,90,88,89,90,86,91,78,91,32,86,84,88,85,89,87,89,88,88,90,86,91,0,69,95,74,77,74,91,32,75,77,75,91,32,71,77,78,77,32,75,84,79,84,82,85,83,87,83,88,82,90,79,91,71,91,32,79,84,81,85,82,87,82,88,81,90,79,91,32,89,77,89,91,32,90,77,90,91,32,86,77,93,77,32,86,91,93,91,0,74,91,79,77,79,91,32,80,77,80,91,32,76,77,83,77,32,80,84,84,84,87,85,88,87,88,88,87,90,84,91,76,91,32,84,84,86,85,87,87,87,88,86,90,84,91,0,73,92,77,79,76,77,76,81,77,79,78,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,78,90,76,88,76,87,77,86,78,87,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,82,84,88,84,0,68,97,73,77,73,91,32,74,77,74,91,32,70,77,77,77,32,70,91,77,91,32,86,77,83,78,81,80,80,83,80,85,81,88,83,90,86,91,88,91,91,90,93,88,94,85,94,83,93,80,91,78,88,77,86,77,32,86,77,84,78,82,80,81,83,81,85,82,88,84,90,86,91,32,88,91,90,90,92,88,93,85,93,83,92,80,90,78,88,77,32,74,84,80,84,0,71,92,86,77,86,91,32,87,77,87,91,32,90,77,79,77,76,78,75,80,75,81,76,83,79,84,86,84,32,79,77,77,78,76,80,76,81,77,83,79,84,32,84,84,81,85,80,86,78,90,77,91,32,84,84,82,85,81,86,79,90,78,91,76,91,75,90,74,88,32,83,91,90,91,0,72,92,82,70,75,90,32,81,73,87,91,32,82,73,88,91,32,82,70,89,91,32,77,85,86,85,32,73,91,79,91,32,84,91,91,91,32,75,90,74,91,32,75,90,77,91,32,87,90,85,91,32,87,89,86,91,32,88,89,90,91,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,32,88,72,89,74,89,76,88,78,32,85,70,87,71,88,73,88,77,87,79,85,80,32,78,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,88,82,89,84,89,87,88,89,32,85,80,87,81,88,83,88,88,87,90,85,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,92,88,73,89,70,89,76,88,73,86,71,84,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,84,91,86,90,88,88,89,86,32,77,73,76,75,75,78,75,83,76,86,77,88,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,73,91,32,87,73,88,75,89,78,89,83,88,86,87,88,32,83,70,85,71,87,74,88,78,88,83,87,87,85,90,83,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,92,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,89,70,89,76,32,78,80,84,80,32,84,76,84,84,32,73,91,89,91,89,85,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,84,70,89,71,32,86,70,89,72,32,87,70,89,73,32,88,70,89,76,32,84,76,83,80,84,84,32,84,78,82,80,84,82,32,84,79,80,80,84,81,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,84,91,89,90,32,86,91,89,89,32,87,91,89,88,32,88,91,89,85,0,71,91,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,89,70,89,76,32,78,80,84,80,32,84,76,84,84,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,84,70,89,71,32,86,70,89,72,32,87,70,89,73,32,88,70,89,76,32,84,76,83,80,84,84,32,84,78,82,80,84,82,32,84,79,80,80,84,81,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,94,88,73,89,70,89,76,88,73,86,71,84,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,84,91,86,90,88,90,89,91,89,83,32,77,73,76,75,75,78,75,83,76,86,77,88,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,88,84,88,89,32,87,83,87,89,86,90,32,84,83,92,83,32,85,83,87,84,32,86,83,87,85,32,90,83,89,85,32,91,83,89,84,0,70,94,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,87,70,87,91,32,88,71,88,90,32,89,70,89,91,32,72,70,80,70,32,84,70,92,70,32,77,80,87,80,32,72,91,80,91,32,84,91,92,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,85,70,87,71,32,86,70,87,72,32,90,70,89,72,32,91,70,89,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,76,88,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,74,90,83,70,83,87,82,90,81,91,32,84,71,84,87,83,90,32,85,70,85,87,84,90,81,91,79,91,77,90,76,88,76,86,77,85,78,85,79,86,79,87,78,88,77,88,32,77,86,77,87,78,87,78,86,77,86,32,80,70,88,70,32,81,70,83,71,32,82,70,83,72,32,86,70,85,72,32,87,70,85,71,0,70,92,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,88,71,77,82,32,80,80,87,91,32,81,80,88,91,32,81,78,89,91,32,72,70,80,70,32,85,70,91,70,32,72,91,80,91,32,84,91,91,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,87,70,88,71,32,90,70,88,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,89,85,91,32,87,89,90,91,0,73,91,78,70,78,91,32,79,71,79,90,32,80,70,80,91,32,75,70,83,70,32,75,91,90,91,90,85,32,76,70,78,71,32,77,70,78,72,32,81,70,80,72,32,82,70,80,71,32,78,90,76,91,32,78,89,77,91,32,80,89,81,91,32,80,90,82,91,32,85,91,90,90,32,87,91,90,89,32,88,91,90,88,32,89,91,90,85,0,69,95,74,70,74,90,32,74,70,81,91,32,75,70,81,88,32,76,70,82,88,32,88,70,81,91,32,88,70,88,91,32,89,71,89,90,32,90,70,90,91,32,71,70,76,70,32,88,70,93,70,32,71,91,77,91,32,85,91,93,91,32,72,70,74,71,32,91,70,90,72,32,92,70,90,71,32,74,90,72,91,32,74,90,76,91,32,88,90,86,91,32,88,89,87,91,32,90,89,91,91,32,90,90,92,91,0,70,94,75,70,75,90,32,75,70,89,91,32,76,70,88,88,32,77,70,89,88,32,89,71,89,91,32,72,70,77,70,32,86,70,92,70,32,72,91,78,91,32,73,70,75,71,32,87,70,89,71,32,91,70,89,71,32,75,90,73,91,32,75,90,77,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,78,81,32,88,72,89,74,89,77,88,79,32,85,70,87,71,88,73,88,78,87,80,85,81,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,32,78,88,79,86,81,85,82,85,84,86,85,88,86,94,87,96,89,96,90,94,90,92,32,86,92,87,94,88,95,89,95,32,85,88,87,93,88,94,89,94,90,93,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,78,80,32,88,72,89,74,89,76,88,78,32,85,70,87,71,88,73,88,77,87,79,85,80,32,82,80,84,81,85,83,87,89,88,91,90,91,91,89,91,87,32,87,87,88,89,89,90,90,90,32,84,81,85,82,88,88,89,89,90,89,91,88,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,72,92,88,73,89,70,89,76,88,73,86,71,83,70,80,70,77,71,75,73,75,76,76,78,79,80,85,82,87,83,88,85,88,88,87,90,32,76,76,77,78,79,79,85,81,87,82,88,84,32,77,71,76,73,76,75,77,77,79,78,85,80,88,82,89,84,89,87,88,89,87,90,84,91,81,91,78,90,76,88,75,85,75,91,76,88,0,72,92,74,70,74,76,32,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,90,70,90,76,32,74,70,90,70,32,78,91,86,91,32,75,70,74,76,32,76,70,74,73,32,77,70,74,72,32,79,70,74,71,32,85,70,90,71,32,87,70,90,72,32,88,70,90,73,32,89,70,90,76,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,70,94,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,71,32,76,71,76,86,77,88,32,77,70,77,86,78,89,79,90,81,91,32,72,70,80,70,32,86,70,92,70,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,87,70,89,71,32,91,70,89,71,0,72,92,75,70,82,91,32,76,70,82,88,82,91,32,77,70,83,88,32,89,71,82,91,32,73,70,80,70,32,85,70,91,70,32,74,70,76,72,32,78,70,77,72,32,79,70,77,71,32,87,70,89,71,32,90,70,89,71,0,70,94,74,70,78,91,32,75,70,78,86,78,91,32,76,70,79,86,32,82,70,79,86,78,91,32,82,70,86,91,32,83,70,86,86,86,91,32,84,70,87,86,32,90,71,87,86,86,91,32,71,70,79,70,32,82,70,84,70,32,87,70,93,70,32,72,70,75,71,32,73,70,75,72,32,77,70,76,72,32,78,70,76,71,32,88,70,90,71,32,92,70,90,71,0,72,92,75,70,87,91,32,76,70,88,91,32,77,70,89,91,32,88,71,76,90,32,73,70,80,70,32,85,70,91,70,32,73,91,79,91,32,84,91,91,91,32,74,70,77,72,32,78,70,77,72,32,79,70,77,71,32,86,70,88,71,32,90,70,88,71,32,76,90,74,91,32,76,90,78,91,32,87,90,85,91,32,87,89,86,91,32,87,89,90,91,0,71,93,74,70,81,81,81,91,32,75,70,82,81,82,90,32,76,70,83,81,83,91,32,89,71,83,81,32,72,70,79,70,32,86,70,92,70,32,78,91,86,91,32,73,70,75,71,32,78,70,76,71,32,87,70,89,71,32,91,70,89,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,72,92,89,70,75,70,75,76,32,87,70,75,91,32,88,70,76,91,32,89,70,77,91,32,75,91,89,91,89,85,32,76,70,75,76,32,77,70,75,73,32,78,70,75,72,32,80,70,75,71,32,84,91,89,90,32,86,91,89,89,32,87,91,89,88,32,88,91,89,85,0,73,91,78,70,78,91,32,79,71,79,90,32,80,70,80,91,32,75,70,90,70,90,76,32,75,91,83,91,32,76,70,78,71,32,77,70,78,72,32,81,70,80,72,32,82,70,80,71,32,85,70,90,71,32,87,70,90,72,32,88,70,90,73,32,89,70,90,76,32,78,89,77,91,32,78,90,76,91,32,80,89,81,91,32,80,90,82,91,0,72,92,82,70,74,91,32,81,73,88,91,32,82,73,89,91,32,82,70,90,91,32,75,89,88,89,32,75,90,88,90,32,74,91,90,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,32,79,77,79,84,32,85,77,85,84,32,79,80,85,80,32,79,81,85,81,32,79,78,80,80,32,79,79,81,80,32,85,78,84,80,32,85,79,83,80,32,80,81,79,83,32,81,81,79,82,32,83,81,85,82,32,84,81,85,83,0,72,92,82,70,75,90,32,81,73,87,91,32,82,73,88,91,32,82,70,89,91,32,73,91,79,91,32,84,91,91,91,32,75,90,74,91,32,75,90,77,91,32,87,90,85,91,32,87,89,86,91,32,88,89,90,91,0,71,93,74,69,74,76,32,90,69,90,76,32,79,77,79,84,32,85,77,85,84,32,74,85,74,92,32,90,85,90,92,32,74,71,90,71,32,74,72,90,72,32,74,73,90,73,32,79,80,85,80,32,79,81,85,81,32,74,88,90,88,32,74,89,90,89,32,74,90,90,90,32,74,70,77,72,32,90,70,87,72,32,75,73,74,75,32,76,73,74,74,32,88,73,90,74,32,89,73,90,75,32,79,78,80,80,32,79,79,81,80,32,85,78,84,80,32,85,79,83,80,32,80,81,79,83,32,81,81,79,82,32,83,81,85,82,32,84,81,85,83,32,74,86,75,88,32,74,87,76,88,32,90,87,88,88,32,90,86,89,88,32,77,89,74,91,32,87,89,90,91,0,70,94,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,87,70,87,91,32,88,71,88,90,32,89,70,89,91,32,72,70,92,70,32,72,91,80,91,32,84,91,92,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,85,70,87,71,32,86,70,87,72,32,90,70,89,72,32,91,70,89,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,71,93,73,70,80,80,81,81,32,74,70,81,80,32,75,70,82,80,73,91,32,73,70,89,70,90,76,89,73,87,70,32,86,70,89,72,32,84,70,89,71,32,75,89,89,89,32,74,90,89,90,32,73,91,89,91,90,85,89,88,87,89,0,72,92,74,77,75,73,76,71,77,70,79,70,80,71,81,73,82,77,32,76,72,77,71,79,71,80,72,32,74,77,75,74,77,72,79,72,80,73,81,77,81,91,32,82,77,82,91,32,90,77,89,74,87,72,85,72,84,73,83,77,83,91,32,88,72,87,71,85,71,84,72,32,90,77,89,73,88,71,87,70,85,70,84,71,83,73,82,77,32,78,91,86,91,32,81,89,80,91,32,81,90,79,91,32,83,90,85,91,32,83,89,84,91,0,71,93,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,79,75,76,76,75,77,74,79,74,82,75,84,76,85,79,86,85,86,88,85,89,84,90,82,90,79,89,77,88,76,85,75,79,75,32,76,77,75,79,75,82,76,84,32,88,84,89,82,89,79,88,77,32,79,75,77,76,76,79,76,82,77,85,79,86,32,85,86,87,85,88,82,88,79,87,76,85,75,0,70,94,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,72,77,73,77,74,78,75,81,76,83,77,84,80,85,84,85,87,84,88,83,89,81,90,78,91,77,92,77,32,76,82,75,78,74,76,73,76,75,78,32,72,77,73,75,74,75,75,76,76,80,77,83,78,84,80,85,32,89,78,91,76,90,76,89,78,88,82,32,84,85,86,84,87,83,88,80,89,76,90,75,91,75,92,77,0,71,93,78,89,75,89,74,87,75,91,79,91,77,86,75,82,74,79,74,76,75,73,77,71,80,70,84,70,87,71,89,73,90,76,90,79,89,82,87,86,85,91,89,91,90,87,89,89,86,89,32,76,83,75,79,75,76,76,73,32,88,73,89,76,89,79,88,83,32,79,91,77,85,76,80,76,75,77,72,78,71,80,70,32,84,70,86,71,87,72,88,75,88,80,87,85,85,91,32,75,90,78,90,32,86,90,89,90,0,72,92,85,70,73,90,32,83,74,84,91,32,84,72,85,90,32,85,70,85,72,86,89,86,91,32,76,85,84,85,32,70,91,76,91,32,81,91,88,91,32,73,90,71,91,32,73,90,75,91,32,84,90,82,91,32,84,89,83,91,32,86,89,87,91,0,70,94,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,32,89,71,90,73,90,75,89,78,88,79,32,87,70,88,71,89,73,89,75,88,78,86,80,32,78,80,86,80,88,81,89,83,89,85,88,88,86,90,82,91,70,91,32,87,81,88,83,88,85,87,88,85,90,32,86,80,87,82,87,85,86,88,84,90,82,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,72,93,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,83,91,85,90,87,88,88,86,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,80,91,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,85,70,88,71,89,72,90,75,90,79,89,83,87,87,85,89,83,90,79,91,70,91,32,87,71,88,72,89,75,89,79,88,83,86,87,84,89,32,85,70,87,72,88,75,88,79,87,83,85,87,82,90,79,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,85,76,83,84,32,76,70,91,70,90,76,32,78,80,84,80,32,70,91,85,91,87,86,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,87,70,90,71,32,88,70,90,72,32,89,70,90,73,32,90,70,90,76,32,85,76,83,80,83,84,32,84,78,82,80,83,82,32,84,79,81,80,83,81,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,32,80,91,85,90,32,82,91,85,89,32,85,89,87,86,0,70,92,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,85,76,83,84,32,76,70,91,70,90,76,32,78,80,84,80,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,87,70,90,71,32,88,70,90,72,32,89,70,90,73,32,90,70,90,76,32,85,76,83,80,83,84,32,84,78,82,80,83,82,32,84,79,81,80,83,81,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,72,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,82,91,85,90,87,88,89,84,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,86,88,87,87,88,84,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,80,91,32,82,91,84,90,86,87,87,84,32,84,84,92,84,32,85,84,87,85,32,86,84,87,87,32,90,84,88,86,32,91,84,88,85,0,69,95,78,70,72,91,32,79,70,73,91,32,80,70,74,91,32,90,70,84,91,32,91,70,85,91,32,92,70,86,91,32,75,70,83,70,32,87,70,95,70,32,76,80,88,80,32,69,91,77,91,32,81,91,89,91,32,76,70,79,71,32,77,70,78,72,32,81,70,79,72,32,82,70,79,71,32,88,70,91,71,32,89,70,90,72,32,93,70,91,72,32,94,70,91,71,32,73,90,70,91,32,73,89,71,91,32,74,89,75,91,32,73,90,76,91,32,85,90,82,91,32,85,89,83,91,32,86,89,87,91,32,85,90,88,91,0,75,89,84,70,78,91,32,85,70,79,91,32,86,70,80,91,32,81,70,89,70,32,75,91,83,91,32,82,70,85,71,32,83,70,84,72,32,87,70,85,72,32,88,70,85,71,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,73,92,87,70,82,87,81,89,79,91,32,88,70,84,83,83,86,82,88,32,89,70,85,83,83,88,81,90,79,91,77,91,75,90,74,88,74,86,75,85,76,85,77,86,77,87,76,88,75,88,32,75,86,75,87,76,87,76,86,75,86,32,84,70,92,70,32,85,70,88,71,32,86,70,87,72,32,90,70,88,72,32,91,70,88,71,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,92,71,77,82,32,81,79,85,91,32,82,79,86,91,32,83,78,87,90,32,76,70,84,70,32,89,70,95,70,32,70,91,78,91,32,82,91,89,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,90,70,92,71,32,94,70,92,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,32,85,90,83,91,32,85,89,84,91,32,86,89,88,91,0,72,92,81,70,75,91,32,82,70,76,91,32,83,70,77,91,32,78,70,86,70,32,72,91,87,91,89,85,32,79,70,82,71,32,80,70,81,72,32,84,70,82,72,32,85,70,82,71,32,76,90,73,91,32,76,89,74,91,32,77,89,78,91,32,76,90,79,91,32,82,91,87,90,32,84,91,88,88,32,86,91,89,85,0,68,96,77,70,71,90,32,77,71,78,89,78,91,32,78,70,79,89,32,79,70,80,88,32,91,70,80,88,78,91,32,91,70,85,91,32,92,70,86,91,32,93,70,87,91,32,74,70,79,70,32,91,70,96,70,32,68,91,74,91,32,82,91,90,91,32,75,70,77,71,32,76,70,77,72,32,94,70,92,72,32,95,70,92,71,32,71,90,69,91,32,71,90,73,91,32,86,90,83,91,32,86,89,84,91,32,87,89,88,91,32,86,90,89,91,0,70,95,79,70,73,90,32,79,70,86,91,32,80,70,86,88,32,81,70,87,88,32,92,71,87,88,86,91,32,76,70,81,70,32,89,70,95,70,32,70,91,76,91,32,77,70,80,71,32,78,70,80,72,32,90,70,92,71,32,94,70,92,71,32,73,90,71,91,32,73,90,75,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,79,73,77,76,76,79,75,83,75,87,76,89,32,85,88,87,85,88,82,89,78,89,74,88,72,32,83,70,81,71,79,74,78,76,77,79,76,83,76,88,77,90,78,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,88,70,91,71,92,73,92,75,91,78,89,80,85,81,77,81,32,90,71,91,73,91,75,90,78,88,80,32,88,70,89,71,90,73,90,75,89,78,87,80,85,81,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,79,73,77,76,76,79,75,83,75,87,76,89,32,85,88,87,85,88,82,89,78,89,74,88,72,32,83,70,81,71,79,74,78,76,77,79,76,83,76,88,77,90,78,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,32,76,88,77,86,79,85,80,85,82,86,83,88,84,93,85,94,86,94,87,93,32,84,94,85,95,86,95,32,83,88,83,95,84,96,86,96,87,93,87,92,0,70,94,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,78,80,32,89,71,90,73,90,75,89,78,88,79,32,87,70,88,71,89,73,89,75,88,78,86,80,32,82,80,84,81,85,82,87,88,88,89,89,89,90,88,32,87,89,88,90,89,90,32,85,82,86,90,87,91,89,91,90,88,90,87,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,71,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,76,78,78,80,80,86,83,87,85,87,88,86,90,32,78,76,79,78,86,82,87,84,32,79,71,78,73,78,75,79,77,85,80,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,73,91,74,89,75,89,0,71,93,84,70,78,91,32,85,70,79,91,32,86,70,80,91,32,77,70,75,76,32,93,70,92,76,32,77,70,93,70,32,75,91,83,91,32,78,70,75,76,32,80,70,76,73,32,82,70,77,71,32,89,70,92,71,32,90,70,92,72,32,91,70,92,73,32,92,70,92,76,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,70,95,78,70,75,81,74,85,74,88,75,90,78,91,82,91,85,90,87,88,88,85,92,71,32,79,70,76,81,75,85,75,89,76,90,32,80,70,77,81,76,85,76,89,78,91,32,75,70,83,70,32,89,70,95,70,32,76,70,79,71,32,77,70,78,72,32,81,70,79,72,32,82],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+311540);allocate([70,79,71,32,90,70,92,71,32,94,70,92,71,0,72,92,78,70,78,72,79,89,79,91,32,79,71,80,88,32,80,70,81,87,32,91,71,79,91,32,76,70,83,70,32,88,70,94,70,32,77,70,78,72,32,81,70,80,72,32,82,70,79,71,32,89,70,91,71,32,93,70,91,71,0,69,95,77,70,77,72,75,89,75,91,32,78,71,76,88,32,79,70,77,87,32,85,70,77,87,75,91,32,85,70,85,72,83,89,83,91,32,86,71,84,88,32,87,70,85,87,32,93,71,85,87,83,91,32,74,70,82,70,32,85,70,87,70,32,90,70,96,70,32,75,70,78,71,32,76,70,77,72,32,80,70,78,73,32,81,70,78,71,32,91,70,93,71,32,95,70,93,71,0,71,93,78,70,84,91,32,79,70,85,91,32,80,70,86,91,32,91,71,73,90,32,76,70,83,70,32,88,70,94,70,32,70,91,76,91,32,81,91,88,91,32,77,70,79,72,32,81,70,80,72,32,82,70,80,71,32,89,70,91,71,32,93,70,91,71,32,73,90,71,91,32,73,90,75,91,32,84,90,82,91,32,84,89,83,91,32,85,89,87,91,0,71,93,77,70,81,80,78,91,32,78,70,82,80,79,91,32,79,70,83,80,80,91,32,92,71,83,80,32,75,70,82,70,32,89,70,95,70,32,75,91,83,91,32,76,70,78,71,32,80,70,79,72,32,81,70,78,71,32,90,70,92,71,32,94,70,92,71,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,71,93,90,70,72,91,32,91,70,73,91,32,92,70,74,91,32,92,70,78,70,76,76,32,72,91,86,91,88,85,32,79,70,76,76,32,80,70,77,73,32,82,70,78,71,32,82,91,86,90,32,84,91,87,88,32,85,91,88,85,0,72,92,74,70,82,91,32,75,70,82,88,32,76,70,83,88,32,74,70,90,70,82,91,32,76,71,89,71,32,76,72,89,72,0,73,93,78,80,78,79,79,79,79,81,77,81,77,79,78,78,80,77,84,77,86,78,87,79,88,81,88,88,89,90,90,91,32,86,79,87,81,87,88,88,90,32,84,77,85,78,86,80,86,88,87,90,90,91,91,91,32,86,82,85,83,80,84,77,85,76,87,76,88,77,90,80,91,83,91,85,90,86,88,32,78,85,77,87,77,88,78,90,32,85,83,81,84,79,85,78,87,78,88,79,90,80,91,0,71,92,76,70,76,91,77,90,79,90,32,77,71,77,89,32,73,70,78,70,78,90,32,78,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,78,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,74,70,76,71,32,75,70,76,72,0,72,91,87,81,87,80,86,80,86,82,88,82,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,0,72,93,86,70,86,91,91,91,32,87,71,87,90,32,83,70,88,70,88,91,32,86,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,86,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,84,70,86,71,32,85,70,86,72,32,88,89,89,91,32,88,90,90,91,0,72,91,77,83,88,83,88,81,87,79,86,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,87,82,87,81,86,79,32,77,80,76,82,76,86,77,88,32,86,83,86,80,85,78,83,77,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,0,75,89,87,72,87,71,86,71,86,73,88,73,88,71,87,70,84,70,82,71,81,72,80,75,80,91,32,82,72,81,75,81,90,32,84,70,83,71,82,73,82,91,32,77,77,86,77,32,77,91,85,91,32,80,90,78,91,32,80,89,79,91,32,82,89,83,91,32,82,90,84,91,0,73,92,88,78,89,79,90,78,89,77,88,77,86,78,85,79,32,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,32,79,79,78,81,78,83,79,85,32,85,85,86,83,86,81,85,79,32,81,77,80,78,79,80,79,84,80,86,81,87,32,83,87,84,86,85,84,85,80,84,78,83,77,32,78,85,77,86,76,88,76,89,77,91,78,92,81,93,85,93,88,94,89,95,32,78,91,81,92,85,92,88,93,32,76,89,77,90,80,91,85,91,88,92,89,94,89,95,88,97,85,98,79,98,76,97,75,95,75,94,76,92,79,91,32,79,98,77,97,76,95,76,94,77,92,79,91,0,71,94,76,70,76,91,32,77,71,77,90,32,73,70,78,70,78,91,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,91,32,87,79,88,82,88,90,32,85,77,86,78,87,81,87,91,32,73,91,81,91,32,84,91,92,91,32,74,70,76,71,32,75,70,76,72,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,76,88,81,70,81,72,83,72,83,70,81,70,32,82,70,82,72,32,81,71,83,71,32,81,77,81,91,32,82,78,82,90,32,78,77,83,77,83,91,32,78,91,86,91,32,79,77,81,78,32,80,77,81,79,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,75,88,82,70,82,72,84,72,84,70,82,70,32,83,70,83,72,32,82,71,84,71,32,82,77,82,94,81,97,80,98,32,83,78,83,93,82,96,32,79,77,84,77,84,93,83,96,82,97,80,98,77,98,76,97,76,95,78,95,78,97,77,97,77,96,32,80,77,82,78,32,81,77,82,79,0,71,93,76,70,76,91,32,77,71,77,90,32,73,70,78,70,78,91,32,87,78,78,87,32,82,83,89,91,32,82,84,88,91,32,81,84,87,91,32,84,77,91,77,32,73,91,81,91,32,84,91,91,91,32,74,70,76,71,32,75,70,76,72,32,85,77,87,78,32,90,77,87,78,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,89,85,91,32,86,89,90,91,0,76,88,81,70,81,91,32,82,71,82,90,32,78,70,83,70,83,91,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,65,99,70,77,70,91,32,71,78,71,90,32,67,77,72,77,72,91,32,72,81,73,79,74,78,76,77,79,77,81,78,82,79,83,82,83,91,32,81,79,82,82,82,90,32,79,77,80,78,81,81,81,91,32,83,81,84,79,85,78,87,77,90,77,92,78,93,79,94,82,94,91,32,92,79,93,82,93,90,32,90,77,91,78,92,81,92,91,32,67,91,75,91,32,78,91,86,91,32,89,91,97,91,32,68,77,70,78,32,69,77,70,79,32,70,90,68,91,32,70,89,69,91,32,72,89,73,91,32,72,90,74,91,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,92,90,90,91,32,92,89,91,91,32,94,89,95,91,32,94,90,96,91,0,71,94,76,77,76,91,32,77,78,77,90,32,73,77,78,77,78,91,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,91,32,87,79,88,82,88,90,32,85,77,86,78,87,81,87,91,32,73,91,81,91,32,84,91,92,91,32,74,77,76,78,32,75,77,76,79,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,72,92,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,77,80,76,82,76,86,77,88,32,87,88,88,86,88,82,87,80,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,83,77,0,71,92,76,77,76,98,32,77,78,77,97,32,73,77,78,77,78,98,32,78,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,78,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,73,98,81,98,32,74,77,76,78,32,75,77,76,79,32,76,97,74,98,32,76,96,75,98,32,78,96,79,98,32,78,97,80,98,0,72,92,86,78,86,98,32,87,79,87,97,32,85,78,87,78,88,77,88,98,32,86,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,86,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,98,91,98,32,86,97,84,98,32,86,96,85,98,32,88,96,89,98,32,88,97,90,98,0,73,90,78,77,78,91,32,79,78,79,90,32,75,77,80,77,80,91,32,87,79,87,78,86,78,86,80,88,80,88,78,87,77,85,77,83,78,81,80,80,83,32,75,91,83,91,32,76,77,78,78,32,77,77,78,79,32,78,90,76,91,32,78,89,77,91,32,80,89,81,91,32,80,90,82,91,0,74,91,87,79,88,77,88,81,87,79,86,78,84,77,80,77,78,78,77,79,77,81,78,83,80,84,85,85,87,86,88,89,32,78,78,77,81,32,78,82,80,83,85,84,87,85,32,88,86,87,90,32,77,79,78,81,80,82,85,83,87,84,88,86,88,89,87,90,85,91,81,91,79,90,78,89,77,87,77,91,78,89,0,75,90,80,72,80,86,81,89,82,90,84,91,86,91,88,90,89,88,32,81,72,81,87,82,89,32,80,72,82,70,82,87,83,90,84,91,32,77,77,86,77,0,71,94,76,77,76,86,77,89,78,90,80,91,83,91,85,90,86,89,87,87,32,77,78,77,87,78,89,32,73,77,78,77,78,87,79,90,80,91,32,87,77,87,91,92,91,32,88,78,88,90,32,84,77,89,77,89,91,32,74,77,76,78,32,75,77,76,79,32,89,89,90,91,32,89,90,91,91,0,73,91,76,77,82,91,32,77,77,82,89,32,78,77,83,89,32,88,78,83,89,82,91,32,74,77,81,77,32,84,77,90,77,32,75,77,78,79,32,80,77,78,78,32,86,77,88,78,32,89,77,88,78,0,70,94,74,77,78,91,32,75,77,78,88,32,76,77,79,88,32,82,77,79,88,78,91,32,82,77,86,91,32,83,77,86,88,32,82,77,84,77,87,88,32,90,78,87,88,86,91,32,71,77,79,77,32,87,77,93,77,32,72,77,75,78,32,78,77,76,78,32,88,77,90,78,32,92,77,90,78,0,72,92,76,77,86,91,32,77,77,87,91,32,78,77,88,91,32,87,78,77,90,32,74,77,81,77,32,84,77,90,77,32,74,91,80,91,32,83,91,90,91,32,75,77,77,78,32,80,77,78,78,32,85,77,87,78,32,89,77,87,78,32,77,90,75,91,32,77,90,79,91,32,86,90,84,91,32,87,90,89,91,0,72,91,76,77,82,91,32,77,77,82,89,32,78,77,83,89,32,88,78,83,89,80,95,78,97,76,98,74,98,73,97,73,95,75,95,75,97,74,97,74,96,32,74,77,81,77,32,84,77,90,77,32,75,77,78,79,32,80,77,78,78,32,86,77,88,78,32,89,77,88,78,0,73,91,86,77,76,91,32,87,77,77,91,32,88,77,78,91,32,88,77,76,77,76,81,32,76,91,88,91,88,87,32,77,77,76,81,32,78,77,76,80,32,79,77,76,79,32,81,77,76,78,32,83,91,88,90,32,85,91,88,89,32,86,91,88,88,32,87,91,88,87,0,71,94,91,77,90,81,89,84,87,88,85,90,82,91,80,91,77,90,75,88,74,85,74,83,75,80,77,78,80,77,82,77,85,78,86,79,87,81,89,88,90,90,91,91,92,91,32,90,77,89,81,88,84,87,86,85,89,84,90,82,91,32,76,88,75,86,75,82,76,80,32,80,91,78,90,77,89,76,86,76,82,77,79,78,78,80,77,32,82,77,84,78,85,79,86,81,88,88,89,90,91,91,0,71,92,81,70,78,71,77,72,76,74,75,78,75,98,32,78,72,77,74,76,78,76,97,32,81,70,79,71,78,73,77,78,77,98,32,81,70,83,70,86,71,87,72,88,74,88,76,87,78,86,79,83,80,32,80,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,81,91,79,90,78,89,77,87,32,86,72,87,74,87,76,86,78,32,87,82,88,84,88,87,87,89,32,83,70,85,71,86,73,86,77,85,79,83,80,32,84,80,86,81,87,83,87,88,86,90,84,91,32,75,98,77,98,0,70,92,72,82,73,78,75,77,77,77,79,78,80,79,81,82,82,89,83,98,32,73,79,75,78,77,78,79,79,80,80,32,72,82,73,80,75,79,77,79,79,80,80,81,81,84,82,89,82,97,32,88,77,87,80,86,82,84,85,83,87,82,91,81,98,32,89,77,87,81,32,90,77,89,79,87,82,84,86,83,88,82,91,32,88,77,90,77,32,81,98,83,98,0,72,92,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,80,76,78,75,77,74,77,72,78,71,80,70,83,70,87,72,32,77,80,76,83,76,85,77,88,32,87,88,88,85,88,83,87,80,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,79,75,78,74,78,73,79,72,81,71,84,71,87,72,0,73,91,83,77,85,78,86,79,87,79,86,78,83,77,81,77,77,78,76,79,76,81,77,82,81,83,32,83,83,81,83,77,84,75,86,75,88,77,90,80,91,83,91,86,90,88,88,87,88,86,90,32,78,78,77,79,77,81,78,82,32,77,85,76,86,76,88,77,89,32,81,77,79,78,78,79,78,81,79,82,81,83,32,81,83,78,84,77,86,77,88,78,90,80,91,0,73,91,81,72,82,71,82,70,81,70,80,71,80,73,81,74,84,75,88,75,89,75,89,74,88,74,85,75,83,76,80,78,78,80,77,82,76,85,76,87,77,89,78,90,80,91,83,92,85,93,86,95,86,97,85,98,83,98,82,97,82,96,83,96,83,97,32,80,79,79,80,78,82,77,85,77,87,78,89,79,90,32,85,75,82,77,81,78,79,81,78,84,78,87,79,89,81,91,83,92,0,71,93,74,77,75,78,76,80,76,91,32,75,77,76,78,77,80,77,90,32,72,80,73,78,74,77,76,77,77,78,78,80,78,91,32,85,77,86,78,87,81,87,98,32,87,79,88,82,88,97,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,98,32,76,91,78,91,32,87,98,89,98,0,70,93,73,77,74,78,75,80,75,84,76,87,77,89,78,90,81,91,83,91,86,90,87,89,88,87,89,82,89,79,88,74,86,71,84,70,82,70,80,71,79,73,79,75,80,77,83,79,86,80,91,81,32,74,77,75,78,76,80,76,84,77,87,78,89,32,86,89,87,87,88,82,88,79,87,74,86,72,84,71,32,71,80,72,78,73,77,75,77,76,78,77,80,77,84,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,74,85,72,83,71,81,71,79,73,0,75,90,78,77,79,78,80,80,80,88,81,90,83,91,85,91,87,90,88,88,32,79,77,80,78,81,80,81,88,82,90,32,76,80,77,78,78,77,80,77,81,78,82,80,82,88,83,90,84,91,0,71,93,74,77,75,78,76,80,76,91,32,75,77,76,78,77,80,77,90,32,72,80,73,78,74,77,76,77,77,78,78,80,78,91,32,83,79,85,78,87,78,88,79,88,80,90,80,90,78,88,77,86,77,84,78,81,81,79,84,78,87,32,88,78,89,79,89,80,32,80,83,81,83,87,89,89,89,90,88,32,84,87,87,90,89,90,32,82,84,85,90,86,91,88,91,89,90,90,88,32,76,91,78,91,0,72,92,74,71,75,70,77,70,79,71,81,73,88,88,89,90,90,91,32,79,72,80,73,87,88,88,89,32,77,70,78,71,79,73,86,88,88,90,90,91,91,91,32,82,77,74,90,74,91,75,91,82,77,0,71,93,75,77,75,98,32,76,78,76,97,32,77,77,77,98,32,86,77,86,88,87,90,88,91,90,91,91,90,92,88,32,87,78,87,88,88,90,89,91,32,88,77,88,88,89,90,90,91,32,77,88,78,90,80,91,82,91,84,90,85,89,86,87,32,75,77,77,77,32,86,77,88,77,32,75,98,77,98,0,71,93,74,77,75,78,76,80,77,84,78,91,32,75,77,76,78,77,80,78,84,79,90,32,72,80,73,78,74,77,76,77,77,78,78,80,79,84,80,90,32,86,86,87,84,88,81,88,77,89,77,90,78,89,81,88,83,86,86,84,88,81,90,78,91,32,88,82,89,79,89,77,0,74,90,80,71,83,70,82,70,80,71,79,72,79,73,80,74,83,75,86,76,87,75,86,74,83,75,80,76,78,77,77,79,77,81,78,82,80,83,83,84,86,85,87,84,86,83,83,84,79,85,77,86,76,88,76,90,77,91,79,92,83,93,85,94,86,95,86,97,84,98,82,98,79,97,80,97,82,98,32,79,77,78,79,78,81,79,82,32,78,86,77,88,77,90,78,91,32,86,75,83,75,81,76,80,77,79,79,79,81,81,83,83,84,32,86,84,83,84,80,85,79,86,78,88,78,90,80,92,83,93,0,71,93,73,81,74,79,75,78,77,77,91,77,32,75,79,77,78,90,78,32,73,81,74,80,76,79,91,79,32,79,79,78,90,77,91,76,90,77,87,79,79,32,85,79,86,90,87,91,88,90,87,87,85,79,32,91,77,91,79,32,79,79,77,90,32,85,79,87,90,0,71,92,81,77,78,78,76,80,75,84,75,98,32,77,80,76,84,76,97,32,81,77,79,78,78,79,77,83,77,98,32,77,87,78,89,79,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,87,88,88,86,88,82,87,80,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,83,77,32,75,98,77,98,0,71,93,80,77,77,78,75,80,74,83,74,85,75,88,77,90,80,91,82,91,85,90,87,88,88,85,88,83,87,80,85,78,82,77,32,76,80,75,82,75,86,76,88,32,86,88,87,86,87,82,86,80,32,80,77,78,78,77,79,76,82,76,86,77,89,78,90,80,91,32,82,91,84,90,85,89,86,86,86,82,85,79,84,78,82,77,32,82,77,90,79,91,78,91,77,80,77,32,82,77,90,78,0,72,92,74,81,75,79,76,78,78,77,90,77,32,76,79,78,78,89,78,32,74,81,75,80,77,79,90,79,32,82,79,81,90,82,91,83,90,82,79,32,90,77,90,79,32,82,79,82,90,0,71,92,74,77,75,78,76,80,76,85,77,88,79,90,81,91,83,91,85,90,87,88,88,86,89,82,89,78,88,77,87,77,88,80,88,83,87,87,85,90,32,75,77,76,78,77,80,77,85,78,88,32,87,77,88,78,88,79,32,72,80,73,78,74,77,76,77,77,78,78,80,78,86,79,89,81,91,0,71,93,82,81,81,78,80,77,78,77,76,78,75,79,74,82,74,85,75,88,77,90,80,91,84,91,87,90,89,88,90,85,90,82,89,79,88,78,86,77,84,77,83,78,82,81,32,76,79,75,82,75,85,76,88,32,88,88,89,85,89,82,88,79,32,78,77,77,78,76,81,76,86,77,89,78,90,80,91,32,84,91,86,90,87,89,88,86,88,81,87,78,86,77,32,82,81,81,98,32,82,81,82,97,32,82,81,83,98,32,81,98,83,98,0,72,92,76,77,77,78,78,80,84,95,86,97,88,98,90,98,91,97,32,78,79,79,80,85,95,86,96,32,73,78,74,77,76,77,78,78,80,80,86,95,87,97,88,98,32,86,83,88,80,89,77,90,77,89,79,86,83,78,92,75,96,74,98,75,98,76,95,78,92,0,70,93,72,78,73,78,74,80,74,85,75,88,77,90,80,91,84,91,86,90,88,88,89,86,90,82,90,78,89,77,88,77,89,80,89,83,88,87,86,90,32,74,78,75,80,75,85,76,88,32,88,77,89,78,89,79,32,71,80,72,78,73,77,74,77,75,78,76,80,76,86,77,89,78,90,80,91,32,81,70,83,98,32,82,71,82,97,32,83,70,81,98,32,81,70,83,70,32,81,98,83,98,0,70,94,78,77,76,78,74,80,73,83,73,87,74,89,75,90,77,91,79,91,81,90,82,89,83,87,83,84,82,83,81,84,81,87,82,89,83,90,85,91,87,91,89,90,90,89,91,87,91,83,90,80,88,78,86,77,32,75,80,74,83,74,87,75,89,32,82,84,82,88,32,89,89,90,87,90,83,89,80,32,78,77,76,79,75,82,75,87,76,90,77,91,32,87,91,88,90,89,87,89,82,88,79,86,77,0,71,93,87,77,85,84,85,88,86,90,87,91,89,91,91,89,92,87,32,88,77,86,84,86,90,32,87,77,89,77,87,84,86,88,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,78,78,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,0,73,92,80,70,78,77,77,83,77,87,78,89,79,90,81,91,83,91,86,90,88,87,89,84,89,82,88,79,87,78,85,77,83,77,81,78,80,79,79,81,78,84,32,81,70,79,77,78,81,78,87,79,90,32,86,89,87,87,88,84,88,81,87,79,32,77,70,82,70,80,77,78,84,32,83,91,85,89,86,87,87,84,87,81,86,78,85,77,32,78,70,81,71,32,79,70,80,72,0,73,91,87,81,87,80,86,80,86,82,88,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,86,77,89,78,90,80,91,82,91,85,90,87,87,32,79,79,78,81,77,84,77,87,78,89,32,82,77,80,79,79,81,78,84,78,87,79,90,80,91,0,71,93,89,70,86,81,85,85,85,88,86,90,87,91,89,91,91,89,92,87,32,90,70,87,81,86,85,86,90,32,86,70,91,70,87,84,86,88,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,77,79,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,32,87,70,90,71,32,88,70,89,72,0,73,91,77,86,81,85,84,84,87,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,86,77,89,78,90,80,91,82,91,85,90,87,88,32,79,79,78,81,77,84,77,87,78,89,32,82,77,80,79,79,81,78,84,78,87,79,90,80,91,0,74,90,90,72,90,71,89,71,89,73,91,73,91,71,90,70,88,70,86,71,84,73,83,75,82,78,81,82,79,91,78,94,77,96,75,98,32,84,74,83,77,82,82,80,91,79,94,32,88,70,86,72,85,74,84,77,83,82,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,95,74,95,74,97,73,97,73,96,32,78,77,89,77,0,72,93,88,77,84,91,83,94,81,97,79,98,32,89,77,85,91,83,95,32,88,77,90,77,86,91,84,95,82,97,79,98,76,98,74,97,73,96,73,94,75,94,75,96,74,96,74,95,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,86,76,89,77,90,79,91,81,91,83,90,84,89,85,87,86,84,32,78,79,77,81,76,84,76,87,77,89,32,81,77,79,79,78,81,77,84,77,87,78,90,79,91,0,71,93,79,70,73,91,75,91,32,80,70,74,91,32,76,70,81,70,75,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,80,88,83,86,88,32,87,78,87,82,86,86,86,90,32,87,80,85,85,85,88,86,90,87,91,89,91,91,89,92,87,32,77,70,80,71,32,78,70,79,72,0,75,88,84,70,84,72,86,72,86,70,84,70,32,85,70,85,72,32,84,71,86,71,32,76,81,77,79,79,77,81,77,82,78,83,80,83,83,81,88,32,82,78,82,82,81,86,81,90,32,82,80,80,85,80,88,81,90,82,91,84,91,86,89,87,87,0,75,88,85,70,85,72,87,72,87,70,85,70,32,86,70,86,72,32,85,71,87,71,32,77,81,78,79,80,77,82,77,83,78,84,80,84,83,82,90,81,93,80,95,78,97,76,98,74,98,73,97,73,95,75,95,75,97,74,97,74,96,32,83,78,83,83,81,90,80,93,79,95,32,83,80,82,84,80,91,79,94,78,96,76,98,0,71,93,79,70,73,91,75,91,32,80,70,74,91,32,76,70,81,70,75,91,32,89,79,89,78,88,78,88,80,90,80,90,78,89,77,87,77,85,78,81,82,79,83,32,77,83,79,83,81,84,82,85,84,89,85,90,87,90,32,81,85,83,89,84,90,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,32,77,70,80,71,32,78,70,79,72,0,76,88,84,70,81,81,80,85,80,88,81,90,82,91,84,91,86,89,87,87,32,85,70,82,81,81,85,81,90,32,81,70,86,70,82,84,81,88,32,82,70,85,71,32,83,70,84,72,0,64,99,65,81,66,79,68,77,70,77,71,78,72,80,72,83,70,91,32,71,78,71,83,69,91,32,71,80,70,84,68,91,70,91,32,72,83,74,80,76,78,78,77,80,77,82,78,83,80,83,83,81,91,32,82,78,82,83,80,91,32,82,80,81,84,79,91,81,91,32,83,83,85,80,87,78,89,77,91,77,93,78,94,80,94,83,92,88,32,93,78,93,82,92,86,92,90,32,93,80,91,85,91,88,92,90,93,91,95,91,97,89,98,87,0,70,94,71,81,72,79,74,77,76,77,77,78,78,80,78,83,76,91,32,77,78,77,83,75,91,32,77,80,76,84,74,91,76,91,32,78,83,80,80,82,78,84,77,86,77,88,78,89,80,89,83,87,88,32,88,78,88,82,87,86,87,90,32,88,80,86,85,86,88,87,90,88,91,90,91,92,89,93,87,0,72,92,81,77,78,78,76,81,75,84,75,86,76,89,77,90,80,91,83,91,86,90,88,87,89,84,89,82,88,79,87,78,84,77,81,77,32,78,79,77,81,76,84,76,87,77,89,32,86,89,87,87,88,84,88,81,87,79,32,81,77,79,79,78,81,77,84,77,87,78,90,80,91,32,83,91,85,89,86,87,87,84,87,81,86,78,84,77,0,71,93,72,81,73,79,75,77,77,77,78,78,79,80,79,83,78,87,75,98,32,78,78,78,83,77,87,74,98,32,78,80,77,84,73,98,32,79,84,80,81,81,79,82,78,84,77,86,77,88,78,89,79,90,82,90,84,89,87,87,90,84,91,82,91,80,90,79,87,79,84,32,88,79,89,81,89,84,88,87,87,89,32,86,77,87,78,88,81,88,84,87,87,86,89,84,91,32,70,98,78,98,32,74,97,71,98,32,74,96,72,98,32,75,96,76,98,32,74,97,77,98,0,71,92,87,77,81,98,32,88,77,82,98,32,87,77,89,77,83,98,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,77,79,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,32,78,98,86,98,32,82,97,79,98,32,82,96,80,98,32,83,96,84,98,32,82,97,85,98,0,73,91,74,81,75,79,77,77,79,77,80,78,81,80,81,84,79,91,32,80,78,80,84,78,91,32,80,80,79,84,77,91,79,91,32,89,79,89,78,88,78,88,80,90,80,90,78,89,77,87,77,85,78,83,80,81,84,0,74,91,88,80,88,79,87,79,87,81,89,81,89,79,88,78,85,77,82,77,79,78,78,79,78,81,79,83,81,84,84,85,86,86,87,88,32,79,78,78,81,32,79,82,81,83,84,84,86,85,32,87,86,86,90,32,78,79,79,81,81,82,84,83,86,84,87,86,87,88,86,90,83,91,80,91,77,90,76,89,76,87,78,87,78,89,77,89,77,88,0,75,89,84,70,81,81,80,85,80,88,81,90,82,91,84,91,86,89,87,87,32,85,70,82,81,81,85,81,90,32,84,70,86,70,82,84,81,88,32,78,77,88,77,0,70,94,71,81,72,79,74,77,76,77,77,78,78,80,78,83,76,88,32,77,78,77,82,76,86,76,90,32,77,80,75,85,75,88,76,90,78,91,80,91,82,90,84,88,86,85,32,88,77,86,85,86,88,87,90,88,91,90,91,92,89,93,87,32,89,77,87,85,87,90,32,88,77,90,77,88,84,87,88,0,72,92,73,81,74,79,76,77,78,77,79,78,80,80,80,83,78,88,32,79,78,79,82,78,86,78,90,32,79,80,77,85,77,88,78,90,80,91,82,91,84,90,86,88,88,85,89,81,89,77,88,77,88,78,89,80,0,67,97,68,81,69,79,71,77,73,77,74,78,75,80,75,83,73,88,32,74,78,74,82,73,86,73,90,32,74,80,72,85,72,88,73,90,75,91,77,91,79,90,81,88,82,85,32,84,77,82,85,82,88,83,90,85,91,87,91,89,90,91,88,93,85,94,81,94,77,93,77,93,78,94,80,32,85,77,83,85,83,90,32,84,77,86,77,84,84,83,88,0,71,93,74,81,76,78,78,77,80,77,82,78,83,80,83,82,32,80,77,81,78,81,82,80,86,79,88,77,90,75,91,73,91,72,90,72,88,74,88,74,90,73,90,73,89,32,82,79,82,82,81,86,81,89,32,90,79,90,78,89,78,89,80,91,80,91,78,90,77,88,77,86,78,84,80,83,82,82,86,82,90,83,91,32,80,86,80,88,81,90,83,91,85,91,87,90,89,87,0,71,93,72,81,73,79,75,77,77,77,78,78,79,80,79,83,77,88,32,78,78,78,82,77,86,77,90,32,78,80,76,85,76,88,77,90,79,91,81,91,83,90,85,88,87,84,32,89,77,85,91,84,94,82,97,80,98,32,90,77,86,91,84,95,32,89,77,91,77,87,91,85,95,83,97,80,98,77,98,75,97,74,96,74,94,76,94,76,96,75,96,75,95,0,72,92,89,77,88,79,86,81,78,87,76,89,75,91,32,88,79,79,79,77,80,76,82,32,86,79,82,78,79,78,78,79,32,86,79,82,77,79,77,77,79,76,82,32,76,89,85,89,87,88,88,86,32,78,89,82,90,85,90,86,89,32,78,89,82,91,85,91,87,89,88,86,0,72,92,87,81,86,79,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,87,89,88,87,89,83,89,78,88,74,87,72,86,71,83,70,81,70,78,71,77,72,78,72,79,71,81,70,32,77,80,76,82,76,86,77,88,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,88,87,84,87,77,86,73,85,71,83,70,0,73,91,85,77,87,78,88,79,89,79,88,78,85,77,82,77,79,78,77,80,76,83,76,85,77,88,79,90,82,91,85,91,88,90,89,89,88,89,87,90,85,91,32,78,80,77,83,77,85,78,88,32,82,77,80,78,79,79,78,82,78,86,79,89,80,90,82,91,32,78,84,84,85,85,84,84,83,78,84,32,78,84,84,84,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,78,72,77,74,76,78,76,83,77,87,78,89,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,70,79,71,78,73,77,78,77,83,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,73,85,71,83,70,32,76,80,88,81,32,76,81,88,80,0,71,93,80,77,77,78,75,80,74,83,74,85,75,88,77,90,80,91,84,91,87,90,89,88,90,85,90,83,89,80,87,78,84,77,80,77,32,76,80,75,83,75,85,76,88,32,88,88,89,85,89,83,88,80,32,80,77,78,78,77,79,76,82,76,86,77,89,78,90,80,91,84,91,86,90,87,89,88,86,88,82,87,79,86,78,84,77,32,81,70,83,98,32,82,71,82,97,32,83,70,81,98,32,81,70,83,70,32,81,98,83,98,0,72,92,84,77,86,78,88,80,89,80,89,79,87,78,84,77,80,77,77,78,76,79,75,81,75,83,76,85,78,87,80,88,82,89,83,90,84,92,84,94,83,95,81,95,79,94,80,94,81,95,32,77,79,76,81,76,83,77,85,79,87,32,80,77,78,78,77,80,77,83,78,85,82,89,32,89,80,88,79,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,78,72,77,74,76,78,76,83,77,87,78,89,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,70,79,71,78,73,77,78,77,83,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,73,85,71,83,70,0,72,92,81,72,81,91,32,82,72,82,90,32,83,70,83,91,32,83,70,80,73,78,74,32,77,91,87,91,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,72,92,76,74,76,75,77,75,77,74,76,74,32,76,73,77,73,78,74,78,75,77,76,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,85,80,80,82,78,83,76,85,75,88,75,91,32,87,72,88,74,88,76,87,78,32,84,70,86,71,87,74,87,76,86,78,84,80,80,82,32,75,89,76,88,78,88,83,89,87,89,89,88,32,78,88,83,90,87,90,88,89,32,78,88,83,91,87,91,88,90,89,88,89,86,0,72,92,76,74,76,75,77,75,77,74,76,74,32,76,73,77,73,78,74,78,75,77,76,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,32,86,71,87,73,87,76,86,78,32,83,70,85,71,86,73,86,76,85,78,83,79,32,81,79,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,86,76,85,77,85,78,86,78,87,77,88,76,88,32,87,82,88,84,88,87,87,89,32,83,79,85,80,86,81,87,84,87,87,86,90,84,91,32,76,86,76,87,77,87,77,86,76,86,0,72,92,83,73,83,91,32,84,72,84,90,32,85,70,85,91,32,85,70,74,85,90,85,32,80,91,88,91,32,83,90,81,91,32,83,89,82,91,32,85,89,86,91,32,85,90,87,91,0,72,92,77,70,75,80,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,85,78,86,78,87,77,88,76,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,76,86,76,87,77,87,77,86,76,86,32,77,70,87,70,32,77,71,85,71,32,77,72,81,72,85,71,87,70,0,72,92,86,73,86,74,87,74,87,73,86,73,32,87,72,86,72,85,73,85,74,86,75,87,75,88,74,88,73,87,71,85,70,82,70,79,71,77,73,76,75,75,79,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,81,78,79,79,78,80,77,82,32,78,73,77,75,76,79,76,85,77,88,78,89,32,87,88,88,86,88,83,87,81,32,82,70,80,71,79,72,78,74,77,78,77,85,78,88,79,90,81,91,32,83,91,85,90,86,89,87,86,87,83,86,80,85,79,83,78,0,72,92,75,70,75,76,32,89,70,89,73,88,76,84,81,83,83,82,87,82,91,32,83,82,82,84,81,87,81,91,32,88,76,83,81,81,84,80,87,80,91,82,91,32,75,74,76,72,78,70,80,70,85,73,87,73,88,72,89,70,32,77,72,78,71,80,71,82,72,32,75,74,76,73,78,72,80,72,85,73,0,72,92,80,70,77,71,76,73,76,76,77,78,80,79,84,79,87,78,88,76,88,73,87,71,84,70,80,70,32,78,71,77,73,77,76,78,78,32,86,78,87,76,87,73,86,71,32,80,70,79,71,78,73,78,76,79,78,80,79,32,84,79,85,78,86,76,86,73,85,71,84,70,32,80,79,77,80,76,81,75,83,75,87,76,89,77,90,80,91,84,91,87,90,88,89,89,87,89,83,88,81,87,80,84,79,32,77,81,76,83,76,87,77,89,32,87,89,88,87,88,83,87,81,32,80,79,78,80,77,83,77,87,78,90,80,91,32,84,91,86,90,87,87,87,83,86,80,84,79,0,72,92,77,87,77,88,78,88,78,87,77,87,32,87,79,86,81,85,82,83,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,82,88,86,87,88,85,90,82,91,79,91,77,90,76,88,76,87,77,86,78,86,79,87,79,88,78,89,77,89,32,77,80,76,78,76,75,77,73,32,86,72,87,73,88,76,88,82,87,86,86,88,32,81,83,79,82,78,81,77,78,77,75,78,72,79,71,81,70,32,83,70,85,71,86,73,87,76,87,83,86,87,85,89,84,90,82,91,0,77,88,82,70,81,71,81,73,82,81,32,82,70,82,84,83,84,32,82,70,83,70,83,84,32,83,70,84,71,84,73,83,81,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,73,92,77,75,77,74,78,74,78,76,76,76,76,74,77,72,78,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,83,81,32,87,72,88,73,88,77,87,78,32,84,70,86,71,87,73,87,77,86,79,85,80,32,82,81,82,84,83,84,83,81,82,81,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,69,95,91,79,91,78,90,78,90,80,92,80,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,76,91,74,90,73,88,73,85,74,83,80,79,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,76,78,79,80,82,84,87,87,90,89,91,91,91,92,89,92,88,32,75,90,74,88,74,85,75,83,76,82,32,82,77,83,73,32,83,75,82,71,32,78,71,77,75,32,78,78,80,81,84,86,87,89,89,90,32,78,91,76,90,75,88,75,85,76,83,80,79,32,77,73,78,77,81,81,85,86,88,89,90,90,91,90,92,89,0,72,92,80,66,80,95,32,84,66,84,95,32,88,75,88,74,87,74,87,76,89,76,89,74,88,72,87,71,84,70,80,70,77,71,75,73,75,76,76,78,79,80,85,82,87,83,88,85,88,88,87,90,32,76,76,77,78,79,79,85,81,87,82,88,84,32,77,71,76,73,76,75,77,77,79,78,85,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,85,77,85,77,87,76,87,76,86,0,75,89,85,66,83,68,81,71,79,75,78,80,78,84,79,89,81,93,83,96,85,98,32,81,72,80,75,79,79,79,85,80,89,81,92,32,83,68,82,70,81,73,80,79,80,85,81,91,82,94,83,96,0,75,89,79,66,81,68,83,71,85,75,86,80,86,84,85,89,83,93,81,96,79,98,32,83,72,84,75,85,79,85,85,84,89,83,92,32,81,68,82,70,83,73,84,79,84,85,83,91,82,94,81,96,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,72,91,32,91,70,73,91,32,91,70,74,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,32,79,71,76,70,73,73,74,76,77,77,80,74,79,71,32,78,70,74,71,73,75,32,75,77,79,76,80,72,32,90,85,87,84,84,87,85,90,88,91,91,88,90,85,32,89,84,85,85,84,89,32,86,91,90,90,91,86,32,72,91,74,91,0,69,96,86,78,85,76,83,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,83,86,85,85,86,83,32,79,77,78,79,78,82,79,84,32,81,75,80,76,79,79,79,82,80,85,81,86,32,86,75,86,83,87,85,89,86,90,86,92,85,93,82,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,88,89,87,90,32,87,76,87,83,88,85,32,86,75,88,75,88,83,89,85,90,86,0,72,93,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,84,70,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,84,89,86,87,87,85,88,82,89,78,89,74,88,72,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,79,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,0,72,93,84,74,79,91,81,91,32,87,70,85,74,80,91,32,87,70,81,91,32,87,70,84,73,81,75,79,76,32,84,74,82,75,79,76,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,87,79,77,85,75,87,73,91,32,88,71,89,73,89,75,88,77,86,79,83,81,32,86,70,87,71,88,73,88,75,87,77,85,79,77,85,32,74,89,75,88,77,88,82,89,87,89,88,88,32,77,88,82,90,87,90,32,77,88,82,91,85,91,87,90,88,88,88,87,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,88,78,86,79,83,80,32,88,71,89,73,89,75,88,77,87,78,32,86,70,87,71,88,73,88,75,87,77,85,79,83,80,32,81,80,83,80,86,81,87,82,88,84,88,87,87,89,85,90,82,91,79,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,32,86,82,87,84,87,87,86,89,32,83,80,85,81,86,83,86,87,85,89,84,90,82,91,0,72,93,87,74,82,91,84,91,32,90,70,88,74,83,91,32,90,70,84,91,32,90,70,74,85,90,85,0,72,93,81,70,76,80,32,81,70,91,70,32,81,71,89,71,32,80,72,85,72,89,71,91,70,32,76,80,77,79,80,78,83,78,86,79,87,80,88,82,88,85,87,88,85,90,81,91,78,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,32,86,80,87,82,87,85,86,88,84,90,32,83,78,85,79,86,81,86,85,85,88,83,90,81,91,0,72,93,89,74,89,73,88,73,88,75,90,75,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,81,79,79,80,78,81,77,83,32,80,73,78,76,77,79,76,83,76,87,77,89,32,86,88,87,86,87,83,86,81,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,79,91,32,82,91,84,90,85,89,86,86,86,82,85,80,84,79,0,72,93,78,70,76,76,32,91,70,90,73,88,76,84,81,82,84,81,87,80,91,32,82,83,80,87,79,91,32,88,76,82,82,80,85,79,87,78,91,80,91,32,77,73,80,70,82,70,87,73,32,79,71,82,71,87,73,32,77,73,79,72,82,72,87,73,89,73,90,72,91,70,0,72,93,83,70,80,71,79,72,78,74,78,77,79,79,81,80,84,80,87,79,89,78,90,76,90,73,89,71,87,70,83,70,32,85,70,80,71,32,80,72,79,74,79,78,80,79,32,79,79,82,80,32,83,80,87,79,32,88,78,89,76,89,73,88,71,32,89,71,85,70,32,83,70,81,72,80,74,80,78,81,80,32,84,80,86,79,87,78,88,76,88,72,87,70,32,81,80,77,81,75,83,74],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+321780);allocate([85,74,88,75,90,78,91,82,91,86,90,87,89,88,87,88,84,87,82,86,81,84,80,32,82,80,77,81,32,78,81,76,83,75,85,75,88,76,90,32,75,90,80,91,86,90,32,86,89,87,87,87,84,86,82,32,86,81,83,80,32,81,80,79,81,77,83,76,85,76,88,77,90,78,91,32,82,91,84,90,85,89,86,87,86,83,85,81,84,80,0,72,93,88,78,87,80,86,81,84,82,81,82,79,81,78,80,77,78,77,75,78,73,80,71,83,70,86,70,88,71,89,72,90,75,90,78,89,82,88,85,86,88,84,90,81,91,78,91,76,90,75,88,75,86,77,86,77,88,76,88,76,87,32,79,80,78,78,78,75,79,73,32,88,72,89,74,89,78,88,82,87,85,85,88,32,81,82,80,81,79,79,79,75,80,72,81,71,83,70,32,86,70,87,71,88,73,88,78,87,82,86,85,85,87,83,90,81,91,0,77,88,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,81,91,80,91,79,90,79,89,80,88,81,88,82,89,82,91,81,93,80,94,78,95,32,80,89,80,90,81,90,81,89,80,89,32,81,91,81,92,80,94,0,77,88,83,77,82,78,82,79,83,80,84,80,85,79,85,78,84,77,83,77,32,83,78,83,79,84,79,84,78,83,78,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,83,77,82,78,82,79,83,80,84,80,85,79,85,78,84,77,83,77,32,83,78,83,79,84,79,84,78,83,78,32,81,91,80,91,79,90,79,89,80,88,81,88,82,89,82,91,81,93,80,94,78,95,32,80,89,80,90,81,90,81,89,80,89,32,81,91,81,92,80,94,0,77,88,86,70,85,70,84,71,82,84,32,86,71,85,71,82,84,32,86,71,86,72,82,84,32,86,70,87,71,87,72,82,84,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,87,70,90,71,91,73,91,75,90,77,89,78,87,79,83,80,81,81,81,83,83,84,84,84,32,85,70,90,71,32,89,71,90,73,90,75,89,77,88,78,86,79,32,87,70,88,71,89,73,89,75,88,77,87,78,83,80,82,81,82,83,83,84,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,87,70,85,71,84,72,83,74,83,76,84,77,85,77,86,76,86,75,85,74,84,74,32,85,71,84,73,84,74,32,84,75,84,76,85,76,85,75,84,75,0,77,88,86,73,85,73,84,72,84,71,85,70,86,70,87,71,87,73,86,75,85,76,83,77,32,85,71,85,72,86,72,86,71,85,71,32,86,73,86,74,85,76,0,69,95,92,79,92,78,91,78,91,80,93,80,93,78,92,77,91,77,89,78,87,80,82,88,80,90,78,91,75,91,72,90,71,88,71,86,72,84,73,83,75,82,80,80,82,79,84,77,85,75,85,73,84,71,82,70,80,71,79,73,79,76,80,82,81,85,82,87,84,90,86,91,88,91,89,89,89,88,32,76,91,72,90,32,73,90,72,88,72,86,73,84,74,83,76,82,32,80,80,81,83,84,89,86,90,32,75,91,74,90,73,88,73,86,74,84,75,83,77,82,82,79,32,79,76,80,79,81,82,83,86,85,89,87,90,88,90,89,89,0,72,93,84,66,76,95,32,89,66,81,95,32,90,75,90,74,89,74,89,76,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,76,78,78,80,80,86,83,87,85,87,88,86,90,32,78,76,79,78,86,82,87,84,32,79,71,78,73,78,75,79,77,85,80,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,0,71,94,95,66,69,98,70,98,32,95,66,96,66,70,98,0,74,90,90,66,88,67,85,69,82,72,80,75,78,79,77,83,77,88,78,92,79,95,81,98,32,83,72,81,75,79,79,78,84,78,92,32,90,66,87,68,84,71,82,74,81,76,80,79,79,83,78,92,32,78,84,79,93,80,96,81,98,0,74,90,83,66,85,69,86,72,87,76,87,81,86,85,84,89,82,92,79,95,76,97,74,98,32,86,72,86,80,85,85,83,89,81,92,32,83,66,84,68,85,71,86,80,32,86,72,85,81,84,85,83,88,82,90,80,93,77,96,74,98,0,74,91,84,70,83,71,85,81,84,82,32,84,70,84,82,32,84,70,85,71,83,81,84,82,32,79,73,80,73,88,79,89,79,32,79,73,89,79,32,79,73,79,74,89,78,89,79,32,89,73,88,73,80,79,79,79,32,89,73,79,79,32,89,73,89,74,79,78,79,79,0,77,87,85,70,84,71,82,77,32,85,71,82,77,32,85,70,86,71,82,77,0,72,92,80,70,79,71,77,77,32,80,71,77,77,32,80,70,81,71,77,77,32,90,70,89,71,87,77,32,90,71,87,77,32,90,70,91,71,87,77,0,75,90,83,70,81,71,80,73,80,75,81,77,83,78,85,78,87,77,88,75,88,73,87,71,85,70,83,70,32,83,70,80,73,81,77,85,78,88,75,87,71,83,70,32,85,70,81,71,80,75,83,78,87,77,88,73,85,70,0,71,94,83,70,75,98,76,98,32,83,70,84,70,76,98,32,89,70,81,98,82,98,32,89,70,90,70,82,98,32,75,80,92,80,92,81,32,75,80,75,81,92,81,32,73,87,90,87,90,88,32,73,87,73,88,90,88,0,69,94,94,70,92,71,88,72,85,72,81,71,79,70,77,70,75,71,74,73,74,75,76,77,78,77,80,76,81,74,81,72,79,70,32,94,70,69,91,32,94,70,70,91,32,94,70,71,91,32,88,84,86,84,84,85,83,87,83,89,85,91,87,91,89,90,90,88,90,86,88,84,32,80,71,77,70,74,73,75,76,78,77,81,74,80,71,32,79,70,75,71,74,75,32,76,77,80,76,81,72,32,89,85,86,84,83,87,84,90,87,91,90,88,89,85,32,88,84,84,85,83,89,32,85,91,89,90,90,86,32,69,91,71,91,0,69,96,85,81,85,78,84,76,82,75,80,75,78,76,77,77,76,80,76,83,77,85,79,86,81,86,83,85,84,84,85,81,32,79,76,78,77,77,80,77,83,78,85,32,82,75,80,76,79,77,78,80,78,83,79,85,80,86,32,86,75,85,81,85,83,86,85,88,86,90,86,92,85,93,82,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,88,89,87,90,32,87,75,86,81,86,83,87,85,32,86,75,88,75,87,81,87,83,88,85,90,86,0,111,112,101,110,99,118,45,104,105,115,116,0,99,118,67,111,112,121,72,105,115,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,104,105,115,116,111,103,114,97,109,46,99,112,112,0,73,110,118,97,108,105,100,32,104,105,115,116,111,103,114,97,109,32,104,101,97,100,101,114,91,115,93,0,78,85,76,76,32,114,97,110,103,101,115,32,112,111,105,110,116,101,114,0,99,118,83,101,116,72,105,115,116,66,105,110,82,97,110,103,101,115,0,73,110,118,97,108,105,100,32,104,105,115,116,111,103,114,97,109,32,104,101,97,100,101,114,0,79,110,101,32,111,102,32,60,114,97,110,103,101,115,62,32,101,108,101,109,101,110,116,115,32,105,115,32,78,85,76,76,0,66,105,110,32,114,97,110,103,101,115,32,115,104,111,117,108,100,32,103,111,32,105,110,32,97,115,99,101,110,116,105,110,103,32,111,114,100,101,114,0,78,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,99,118,67,114,101,97,116,101,72,105,115,116,0,105,115,95,117,110,105,102,111,114,109,0,104,97,118,101,95,114,97,110,103,101,115,0,109,97,116,0,98,105,110,115,0,116,104,114,101,115,104,0,102,0,69,120,112,101,99,116,101,100,32,67,118,77,97,116,78,68,0,105,99,118,82,101,97,100,72,105,115,116,0,85,110,107,110,111,119,110,32,72,105,115,116,111,103,114,97,109,32,116,121,112,101,0,39,116,104,114,101,115,104,39,32,110,111,100,101,32,105,115,32,109,105,115,115,105,110,103,0,99,118,82,101,108,101,97,115,101,72,105,115,116,0,100,105,109,115,32,62,32,48,32,38,38,32,104,105,115,116,83,105,122,101,0,99,97,108,99,72,105,115,116,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,99,104,97,110,110,101,108,115,32,33,61,32,48,32,124,124,32,110,105,109,97,103,101,115,32,61,61,32,100,105,109,115,0,104,105,115,116,80,114,101,112,97,114,101,73,109,97,103,101,115,0,105,109,97,103,101,115,91,106,93,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,99,32,62,61,32,48,0,106,32,60,32,110,105,109,97,103,101,115,0,105,109,97,103,101,115,91,106,93,46,115,105,122,101,40,41,32,61,61,32,105,109,115,105,122,101,32,38,38,32,105,109,97,103,101,115,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,109,97,115,107,46,115,105,122,101,40,41,32,61,61,32,105,109,115,105,122,101,32,38,38,32,109,97,115,107,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,114,97,110,103,101,115,91,105,93,32,38,38,32,114,97,110,103,101,115,91,105,93,91,48,93,32,60,32,114,97,110,103,101,115,91,105,93,91,49,93,0,110,105,109,97,103,101,115,32,62,32,48,32,38,38,32,100,105,109,115,32,62,32,48,0,114,115,122,32,61,61,32,100,105,109,115,42,50,32,124,124,32,40,114,115,122,32,61,61,32,48,32,38,38,32,105,109,97,103,101,115,46,100,101,112,116,104,40,48,41,32,61,61,32,67,86,95,56,85,41,0,99,115,122,32,61,61,32,48,32,124,124,32,99,115,122,32,61,61,32,100,105,109,115,0,100,105,109,115,32,62,32,48,32,38,38,32,33,104,105,115,116,46,101,109,112,116,121,40,41,0,99,97,108,99,66,97,99,107,80,114,111,106,101,99,116,0,72,48,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,110,105,109,97,103,101,115,32,62,32,48,0,114,115,122,32,61,61,32,100,105,109,115,42,50,32,124,124,32,40,114,115,122,32,61,61,32,50,32,38,38,32,95,49,100,41,32,124,124,32,40,114,115,122,32,61,61,32,48,32,38,38,32,105,109,97,103,101,115,46,100,101,112,116,104,40,48,41,32,61,61,32,67,86,95,56,85,41,0,99,115,122,32,61,61,32,48,32,124,124,32,99,115,122,32,61,61,32,100,105,109,115,32,124,124,32,40,99,115,122,32,61,61,32,49,32,38,38,32,95,49,100,41,0,72,49,46,116,121,112,101,40,41,32,61,61,32,72,50,46,116,121,112,101,40,41,32,38,38,32,72,49,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,70,0,99,111,109,112,97,114,101,72,105,115,116,0,105,116,46,112,108,97,110,101,115,91,48,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,105,116,46,112,108,97,110,101,115,91,49,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,101,113,117,97,108,105,122,101,72,105,115,116,0,50,51,69,113,117,97,108,105,122,101,72,105,115,116,76,117,116,95,73,110,118,111,107,101,114,0,50,56,69,113,117,97,108,105,122,101,72,105,115,116,67,97,108,99,72,105,115,116,95,73,110,118,111,107,101,114,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,72,111,117,103,104,76,105,110,101,115,83,68,105,118,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,104,111,117,103,104,46,99,112,112,0,72,111,117,103,104,76,105,110,101,115,83,116,97,110,100,97,114,100,0,109,97,120,95,116,104,101,116,97,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,109,105,110,95,116,104,101,116,97,0,105,109,97,103,101,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,72,111,117,103,104,76,105,110,101,115,80,114,111,98,97,98,105,108,105,115,116,105,99,0,78,85,76,76,32,100,101,115,116,105,110,97,116,105,111,110,0,84,104,101,32,100,101,115,116,105,110,97,116,105,111,110,32,109,97,116,114,105,120,32,115,104,111,117,108,100,32,98,101,32,99,111,110,116,105,110,117,111,117,115,32,97,110,100,32,104,97,118,101,32,97,32,115,105,110,103,108,101,32,114,111,119,32,111,114,32,97,32,115,105,110,103,108,101,32,99,111,108,117,109,110,0,68,101,115,116,105,110,97,116,105,111,110,32,105,115,32,110,111,116,32,67,118,77,101,109,83,116,111,114,97,103,101,42,32,110,111,114,32,67,118,77,97,116,42,0,85,110,114,101,99,111,103,110,105,122,101,100,32,109,101,116,104,111,100,32,105,100,0,84,104,101,32,115,111,117,114,99,101,32,105,109,97,103,101,32,109,117,115,116,32,98,101,32,56,45,98,105,116,44,32,115,105,110,103,108,101,45,99,104,97,110,110,101,108,0,99,118,72,111,117,103,104,67,105,114,99,108,101,115,0,100,112,44,32,109,105,110,95,100,105,115,116,44,32,99,97,110,110,121,95,116,104,114,101,115,104,111,108,100,32,97,110,100,32,97,99,99,95,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,97,108,108,32,112,111,115,105,116,105,118,101,32,110,117,109,98,101,114,115,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,53,67,118,77,97,116,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,116,121,112,101,0,105,110,105,116,73,110,116,101,114,84,97,98,50,68,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,105,109,103,119,97,114,112,46,99,112,112,0,85,110,107,110,111,119,110,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,109,101,116,104,111,100,0,105,110,105,116,73,110,116,101,114,84,97,98,49,68,0,115,115,105,122,101,46,97,114,101,97,40,41,32,62,32,48,0,114,101,115,105,122,101,0,100,115,105,122,101,46,97,114,101,97,40,41,32,62,32,48,32,124,124,32,40,105,110,118,95,115,99,97,108,101,95,120,32,62,32,48,32,38,38,32,105,110,118,95,115,99,97,108,101,95,121,32,62,32,48,41,0,100,115,105,122,101,46,97,114,101,97,40,41,32,62,32,48,0,102,117,110,99,32,33,61,32,48,0,102,117,110,99,32,33,61,32,48,32,38,38,32,99,110,32,60,61,32,52,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,100,100,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,107,115,105,122,101,32,60,61,32,77,65,88,95,69,83,73,90,69,0,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,102,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,115,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,116,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,104,105,115,76,105,50,48,52,56,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,100,100,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,102,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,115,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,116,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,104,105,115,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,100,100,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,102,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,115,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,116,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,104,105,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,100,100,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,102,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,115,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,116,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,104,102,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,100,100,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,100,100,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,102,102,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,102,102,69,69,69,69,0,99,110,32,61,61,32,52,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,115,102,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,115,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,115,115,69,69,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,116,102,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,116,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,116,116,69,69,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,104,105,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,104,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,104,104,69,69,69,69,69,69,0,78,50,99,118,49,53,114,101,115,105,122,101,78,78,73,110,118,111,107,101,114,69,0,95,109,97,112,49,46,115,105,122,101,40,41,46,97,114,101,97,40,41,32,62,32,48,0,114,101,109,97,112,0,95,109,97,112,50,46,101,109,112,116,121,40,41,32,124,124,32,40,95,109,97,112,50,46,115,105,122,101,40,41,32,61,61,32,95,109,97,112,49,46,115,105,122,101,40,41,41,0,110,110,102,117,110,99,32,33,61,32,48,0,105,102,117,110,99,32,33,61,32,48,0,40,40,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,50,32,124,124,32,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,67,50,41,32,38,38,32,109,97,112,50,46,101,109,112,116,121,40,41,41,32,124,124,32,40,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,32,38,38,32,109,97,112,50,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,41,0,78,50,99,118,49,50,82,101,109,97,112,73,110,118,111,107,101,114,69,0,114,101,109,97,112,66,105,108,105,110,101,97,114,0,40,109,49,116,121,112,101,32,61,61,32,67,86,95,49,54,83,67,50,32,38,38,32,40,110,110,105,110,116,101,114,112,111,108,97,116,101,32,124,124,32,109,50,116,121,112,101,32,61,61,32,67,86,95,49,54,85,67,49,32,124,124,32,109,50,116,121,112,101,32,61,61,32,67,86,95,49,54,83,67,49,41,41,32,124,124,32,40,109,50,116,121,112,101,32,61,61,32,67,86,95,49,54,83,67,50,32,38,38,32,40,110,110,105,110,116,101,114,112,111,108,97,116,101,32,124,124,32,109,49,116,121,112,101,32,61,61,32,67,86,95,49,54,85,67,49,32,124,124,32,109,49,116,121,112,101,32,61,61,32,67,86,95,49,54,83,67,49,41,41,32,124,124,32,40,109,49,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,32,38,38,32,109,50,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,41,32,124,124,32,40,109,49,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,50,32,38,38,32,109,50,45,62,101,109,112,116,121,40,41,41,0,99,111,110,118,101,114,116,77,97,112,115,0,100,115,116,109,49,116,121,112,101,32,61,61,32,67,86,95,49,54,83,67,50,32,124,124,32,100,115,116,109,49,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,100,115,116,109,49,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,50,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,105,110,112,117,116,47,111,117,116,112,117,116,32,109,97,116,114,105,99,101,115,0,115,114,99,46,99,111,108,115,32,62,32,48,32,38,38,32,115,114,99,46,114,111,119,115,32,62,32,48,0,119,97,114,112,65,102,102,105,110,101,0,40,77,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,77,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,41,32,38,38,32,77,48,46,114,111,119,115,32,61,61,32,50,32,38,38,32,77,48,46,99,111,108,115,32,61,61,32,51,0,78,50,99,118,49,55,87,97,114,112,65,102,102,105,110,101,73,110,118,111,107,101,114,69,0,95,115,114,99,46,116,111,116,97,108,40,41,32,62,32,48,0,119,97,114,112,80,101,114,115,112,101,99,116,105,118,101,0,40,77,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,77,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,41,32,38,38,32,77,48,46,114,111,119,115,32,61,61,32,51,32,38,38,32,77,48,46,99,111,108,115,32,61,61,32,51,0,78,50,99,118,50,50,87,97,114,112,80,101,114,115,112,101,99,116,105,118,101,73,110,118,111,107,101,114,69,0,109,97,116,77,46,114,111,119,115,32,61,61,32,50,32,38,38,32,109,97,116,77,46,99,111,108,115,32,61,61,32,51,0,105,110,118,101,114,116,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,0,115,114,99,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,41,32,61,61,32,52,32,38,38,32,100,115,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,41,32,61,61,32,52,0,103,101,116,80,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,0,115,114,99,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,41,32,61,61,32,51,32,38,38,32,100,115,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,41,32,61,61,32,51,0,103,101,116,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,0,99,118,82,101,115,105,122,101,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,32,38,38,32,100,115,116,46,115,105,122,101,40,41,32,61,61,32,109,97,112,120,46,115,105,122,101,40,41,0,99,118,82,101,109,97,112,0,100,115,116,48,46,100,97,116,97,32,61,61,32,100,115,116,46,100,97,116,97,0,99,118,76,111,103,80,111,108,97,114,0,77,32,115,104,111,117,108,100,32,98,101,32,62,48,0,99,118,76,105,110,101,97,114,80,111,108,97,114,0,105,110,116,101,114,115,101,99,116,105,111,110,46,115,105,122,101,40,41,32,60,61,32,56,0,114,111,116,97,116,101,100,82,101,99,116,97,110,103,108,101,73,110,116,101,114,115,101,99,116,105,111,110,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,105,110,116,101,114,115,101,99,116,105,111,110,46,99,112,112,0,110,112,111,105,110,116,115,50,32,62,61,32,48,32,124,124,32,110,112,111,105,110,116,115,51,32,62,61,32,48,0,102,105,116,76,105,110,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,108,105,110,101,102,105,116,46,99,112,112,0,85,110,107,110,111,119,110,32,100,105,115,116,97,110,99,101,32,116,121,112,101,0,102,105,116,76,105,110,101,50,68,0,85,110,107,110,111,119,110,32,100,105,115,116,97,110,99,101,0,102,105,116,76,105,110,101,51,68,0,115,122,46,97,114,101,97,40,41,0,99,111,109,112,97,114,101,83,101,103,109,101,110,116,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,108,115,100,46,99,112,112,0,95,105,109,97,103,101,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,51,0,105,109,103,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,73,49,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,73,50,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,33,95,105,109,97,103,101,46,101,109,112,116,121,40,41,32,38,38,32,40,95,105,109,97,103,101,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,124,124,32,95,105,109,97,103,101,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,51,41,0,100,114,97,119,83,101,103,109,101,110,116,115,0,33,105,109,103,46,101,109,112,116,121,40,41,32,38,38,32,105,109,103,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,114,101,103,105,111,110,50,114,101,99,116,0,33,40,100,111,117,98,108,101,95,101,113,117,97,108,40,73,120,120,44,32,48,41,32,38,38,32,100,111,117,98,108,101,95,101,113,117,97,108,40,73,121,121,44,32,48,41,32,38,38,32,100,111,117,98,108,101,95,101,113,117,97,108,40,73,120,121,44,32,48,41,41,0,103,101,116,95,116,104,101,116,97,0,115,99,97,108,101,100,95,105,109,97,103,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,109,111,100,103,114,97,100,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,97,110,103,108,101,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,108,108,95,97,110,103,108,101,0,78,50,99,118,50,51,76,105,110,101,83,101,103,109,101,110,116,68,101,116,101,99,116,111,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,51,76,105,110,101,83,101,103,109,101,110,116,68,101,116,101,99,116,111,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,95,115,99,97,108,101,32,62,32,48,32,38,38,32,95,115,105,103,109,97,95,115,99,97,108,101,32,62,32,48,32,38,38,32,95,113,117,97,110,116,32,62,61,32,48,32,38,38,32,95,97,110,103,95,116,104,32,62,32,48,32,38,38,32,95,97,110,103,95,116,104,32,60,32,49,56,48,32,38,38,32,95,100,101,110,115,105,116,121,95,116,104,32,62,61,32,48,32,38,38,32,95,100,101,110,115,105,116,121,95,116,104,32,60,32,49,32,38,38,32,95,110,95,98,105,110,115,32,62,32,48,0,76,105,110,101,83,101,103,109,101,110,116,68,101,116,101,99,116,111,114,73,109,112,108,0,85,110,107,110,111,119,110,32,99,111,109,112,97,114,105,115,111,110,32,109,101,116,104,111,100,0,109,97,116,99,104,83,104,97,112,101,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,97,116,99,104,99,111,110,116,111,117,114,115,46,99,112,112,0,40,112,111,105,110,116,115,77,97,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,41,32,62,32,48,41,32,38,38,32,40,40,112,111,105,110,116,115,77,97,116,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,70,41,32,124,124,32,40,112,111,105,110,116,115,77,97,116,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,83,41,41,0,99,114,101,97,116,101,67,111,110,118,101,120,72,117,108,108,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,105,110,95,101,110,99,108,111,115,105,110,103,95,116,114,105,97,110,103,108,101,46,99,112,112,0,84,104,101,32,112,111,115,105,116,105,111,110,32,111,102,32,116,104,101,32,118,101,114,116,101,120,32,67,32,111,110,32,115,105,100,101,32,66,32,99,111,117,108,100,32,110,111,116,32,98,101,32,100,101,116,101,114,109,105,110,101,100,44,32,98,101,99,97,117,115,101,32,116,104,101,32,99,111,110,115,105,100,101,114,101,100,32,108,105,110,101,115,32,100,111,32,110,111,116,32,105,110,116,101,114,115,101,99,116,46,0,102,105,110,100,86,101,114,116,101,120,67,79,110,83,105,100,101,66,0,84,104,101,32,112,111,115,105,116,105,111,110,32,111,102,32,115,105,100,101,32,66,32,99,111,117,108,100,32,110,111,116,32,98,101,32,100,101,116,101,114,109,105,110,101,100,44,32,98,101,99,97,117,115,101,32,103,97,109,109,97,40,98,41,32,99,111,117,108,100,32,110,111,116,32,98,101,32,99,111,109,112,117,116,101,100,46,0,117,112,100,97,116,101,83,105,100,101,66,0,97,114,101,69,113,117,97,108,80,111,105,110,116,115,40,112,44,32,113,41,32,61,61,32,102,97,108,115,101,0,108,105,110,101,69,113,117,97,116,105,111,110,68,101,116,101,114,109,105,110,101,100,66,121,80,111,105,110,116,115,0,99,111,110,116,111,117,114,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,83,32,124,124,32,99,111,110,116,111,117,114,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,70,0,99,111,110,116,111,117,114,77,111,109,101,110,116,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,111,109,101,110,116,115,46,99,112,112,0,73,110,118,97,108,105,100,32,105,109,97,103,101,32,116,121,112,101,32,40,109,117,115,116,32,98,101,32,115,105,110,103,108,101,45,99,104,97,110,110,101,108,41,0,109,111,109,101,110,116,115,0,104,117,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,72,117,77,111,109,101,110,116,115,0,111,112,32,61,61,32,77,79,82,80,72,95,69,82,79,68,69,32,124,124,32,111,112,32,61,61,32,77,79,82,80,72,95,68,73,76,65,84,69,0,103,101,116,77,111,114,112,104,111,108,111,103,121,82,111,119,70,105,108,116,101,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,111,114,112,104,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,100,97,116,97,32,116,121,112,101,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+332020);allocate([49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,103,101,116,77,111,114,112,104,111,108,111,103,121,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,97,110,99,104,111,114,46,105,110,115,105,100,101,40,82,101,99,116,40,48,44,32,48,44,32,107,115,105,122,101,46,119,105,100,116,104,44,32,107,115,105,122,101,46,104,101,105,103,104,116,41,41,0,110,111,114,109,97,108,105,122,101,65,110,99,104,111,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,105,108,116,101,114,101,110,103,105,110,101,46,104,112,112,0,103,101,116,77,111,114,112,104,111,108,111,103,121,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,95,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,0,77,111,114,112,104,70,105,108,116,101,114,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,49,54,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,49,54,83,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,0,99,114,101,97,116,101,77,111,114,112,104,111,108,111,103,121,70,105,108,116,101,114,0,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,82,69,67,84,32,124,124,32,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,67,82,79,83,83,32,124,124,32,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,69,76,76,73,80,83,69,0,103,101,116,83,116,114,117,99,116,117,114,105,110,103,69,108,101,109,101,110,116,0,78,50,99,118,49,54,77,111,114,112,104,111,108,111,103,121,82,117,110,110,101,114,69,0,109,111,114,112,104,111,108,111,103,121,69,120,0,117,110,107,110,111,119,110,32,109,111,114,112,104,111,108,111,103,105,99,97,108,32,111,112,101,114,97,116,105,111,110,0,99,111,108,115,32,62,32,48,32,38,38,32,114,111,119,115,32,62,32,48,32,38,38,32,97,110,99,104,111,114,46,105,110,115,105,100,101,40,99,118,58,58,82,101,99,116,40,48,44,48,44,99,111,108,115,44,114,111,119,115,41,41,32,38,38,32,40,115,104,97,112,101,32,33,61,32,67,86,95,83,72,65,80,69,95,67,85,83,84,79,77,32,124,124,32,118,97,108,117,101,115,32,33,61,32,48,41,0,99,118,67,114,101,97,116,101,83,116,114,117,99,116,117,114,105,110,103,69,108,101,109,101,110,116,69,120,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,32,38,38,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,0,99,118,68,105,108,97,116,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,112,104,97,115,101,99,111,114,114,46,99,112,112,0,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,67,49,0,99,114,101,97,116,101,72,97,110,110,105,110,103,87,105,110,100,111,119,0,98,111,114,100,101,114,84,121,112,101,32,33,61,32,66,79,82,68,69,82,95,67,79,78,83,84,65,78,84,0,112,121,114,68,111,119,110,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,112,121,114,97,109,105,100,115,46,99,112,112,0,33,95,115,114,99,46,101,109,112,116,121,40,41,0,112,121,114,68,111,119,110,95,0,115,115,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,115,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,119,105,100,116,104,42,50,32,45,32,115,115,105,122,101,46,119,105,100,116,104,41,32,60,61,32,50,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,104,101,105,103,104,116,42,50,32,45,32,115,115,105,122,101,46,104,101,105,103,104,116,41,32,60,61,32,50,0,98,111,114,100,101,114,84,121,112,101,32,61,61,32,66,79,82,68,69,82,95,68,69,70,65,85,76,84,0,112,121,114,85,112,0,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,119,105,100,116,104,32,45,32,115,115,105,122,101,46,119,105,100,116,104,42,50,41,32,61,61,32,100,115,105,122,101,46,119,105,100,116,104,32,37,32,50,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,104,101,105,103,104,116,32,45,32,115,115,105,122,101,46,104,101,105,103,104,116,42,50,41,32,61,61,32,100,115,105,122,101,46,104,101,105,103,104,116,32,37,32,50,0,112,121,114,85,112,95,0,111,114,105,101,110,116,97,116,105,111,110,32,33,61,32,48,0,114,111,116,97,116,105,110,103,67,97,108,105,112,101,114,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,114,111,116,99,97,108,105,112,101,114,115,46,99,112,112,0,99,110,32,61,61,32,49,32,124,124,32,99,110,32,61,61,32,51,0,103,101,116,82,101,99,116,83,117,98,80,105,120,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,97,109,112,108,101,114,115,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,105,110,112,117,116,32,97,110,100,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,51,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,119,97,116,101,114,115,104,101,100,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,101,103,109,101,110,116,97,116,105,111,110,46,99,112,112,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,0,84,104,101,32,110,117,109,98,101,114,32,111,102,32,112,121,114,97,109,105,100,32,108,101,118,101,108,115,32,105,115,32,116,111,111,32,108,97,114,103,101,32,111,114,32,110,101,103,97,116,105,118,101,0,112,121,114,77,101,97,110,83,104,105,102,116,70,105,108,116,101,114,105,110,103,0,79,110,108,121,32,56,45,98,105,116,44,32,51,45,99,104,97,110,110,101,108,32,105,109,97,103,101,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,0,84,104,101,32,105,110,112,117,116,32,97,110,100,32,111,117,116,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,116,121,112,101,0,84,104,101,32,105,110,112,117,116,32,97,110,100,32,111,117,116,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,0,99,111,117,110,116,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,41,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,104,97,112,101,100,101,115,99,114,46,99,112,112,0,97,114,99,76,101,110,103,116,104,0,110,112,111,105,110,116,115,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,41,0,99,111,110,116,111,117,114,65,114,101,97,0,110,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,41,0,102,105,116,69,108,108,105,112,115,101,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,97,116,32,108,101,97,115,116,32,53,32,112,111,105,110,116,115,32,116,111,32,102,105,116,32,116,104,101,32,101,108,108,105,112,115,101,0,112,111,105,110,116,83,101,116,66,111,117,110,100,105,110,103,82,101,99,116,0,105,109,103,46,100,101,112,116,104,40,41,32,60,61,32,67,86,95,56,83,32,38,38,32,105,109,103,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,109,97,115,107,66,111,117,110,100,105,110,103,82,101,99,116,0,85,110,115,117,112,112,111,114,116,101,100,32,115,101,113,117,101,110,99,101,32,116,121,112,101,0,99,118,66,111,117,110,100,105,110,103,82,101,99,116,0,84,104,101,32,105,109,97,103,101,47,109,97,116,114,105,120,32,102,111,114,109,97,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,101,32,102,117,110,99,116,105,111,110,0,103,101,116,82,111,119,83,117,109,70,105,108,116,101,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,109,111,111,116,104,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,111,117,114,99,101,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,98,117,102,102,101,114,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,100,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,100,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,102,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,102,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,115,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,115,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,105,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,105,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,115,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,115,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,116,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,116,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,116,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,116,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,104,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,104,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,105,69,69,0,67,86,95,77,65,84,95,67,78,40,115,117,109,84,121,112,101,41,32,61,61,32,67,86,95,77,65,84,95,67,78,40,100,115,116,84,121,112,101,41,0,103,101,116,67,111,108,117,109,110,83,117,109,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,117,109,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,115,117,109,67,111,117,110,116,32,61,61,32,107,115,105,122,101,45,49,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,102,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,102,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,102,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,102,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,115,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,115,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,115,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,115,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,116,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,116,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,116,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,116,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,104,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,104,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,104,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,104,69,69,0,103,101,116,83,113,114,82,111,119,83,117,109,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,100,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,100,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,102,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,102,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,115,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,115,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,116,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,116,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,104,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,104,105,69,69,0,107,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,107,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,103,101,116,71,97,117,115,115,105,97,110,75,101,114,110,101,108,0,107,115,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,107,115,105,122,101,46,119,105,100,116,104,32,37,32,50,32,61,61,32,49,32,38,38,32,107,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,107,115,105,122,101,46,104,101,105,103,104,116,32,37,32,50,32,61,61,32,49,0,99,114,101,97,116,101,71,97,117,115,115,105,97,110,75,101,114,110,101,108,115,0,40,107,115,105,122,101,32,37,32,50,32,61,61,32,49,41,32,38,38,32,40,95,115,114,99,48,46,100,105,109,115,40,41,32,60,61,32,50,32,41,0,109,101,100,105,97,110,66,108,117,114,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,40,99,110,32,61,61,32,49,32,124,124,32,99,110,32,61,61,32,51,32,124,124,32,99,110,32,61,61,32,52,41,0,40,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,51,41,32,38,38,32,115,114,99,46,100,97,116,97,32,33,61,32,100,115,116,46,100,97,116,97,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,56,117,0,40,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,51,41,32,38,38,32,115,114,99,46,100,97,116,97,32,33,61,32,100,115,116,46,100,97,116,97,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,51,50,102,0,66,105,108,97,116,101,114,97,108,32,102,105,108,116,101,114,105,110,103,32,105,115,32,111,110,108,121,32,105,109,112,108,101,109,101,110,116,101,100,32,102,111,114,32,56,117,32,97,110,100,32,51,50,102,32,105,109,97,103,101,115,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,0,99,110,32,61,61,32,51,0,78,50,99,118,50,55,66,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,51,50,102,95,73,110,118,111,107,101,114,69,0,78,50,99,118,50,54,66,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,56,117,95,73,110,118,111,107,101,114,69,0,115,112,97,116,105,97,108,71,114,97,100,105,101,110,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,112,97,116,105,97,108,103,114,97,100,105,101,110,116,46,99,112,112,0,98,111,114,100,101,114,84,121,112,101,32,61,61,32,66,79,82,68,69,82,95,68,69,70,65,85,76,84,32,124,124,32,98,111,114,100,101,114,84,121,112,101,32,61,61,32,66,79,82,68,69,82,95,82,69,80,76,73,67,65,84,69,0,107,115,105,122,101,32,61,61,32,51,0,83,117,98,100,105,118,105,115,105,111,110,32,105,115,32,101,109,112,116,121,0,108,111,99,97,116,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,117,98,100,105,118,105,115,105,111,110,50,100,46,99,112,112,0,105,110,115,101,114,116,0,83,117,98,100,105,118,50,68,58,58,108,111,99,97,116,101,32,114,101,116,117,114,110,101,100,32,105,110,118,97,108,105,100,32,108,111,99,97,116,105,111,110,32,61,32,37,100,0,101,100,103,101,68,115,116,40,101,100,103,101,44,32,38,116,41,32,62,32,48,0,101,100,103,101,79,114,103,40,32,101,100,103,101,44,32,38,116,32,41,32,62,32,48,0,105,110,116,101,103,114,97,108,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,117,109,112,105,120,101,108,115,46,99,112,112,0,115,117,109,46,100,97,116,97,32,61,61,32,115,117,109,48,46,100,97,116,97,32,38,38,32,115,113,115,117,109,46,100,97,116,97,32,61,61,32,115,113,115],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+342260);allocate([117,109,48,46,100,97,116,97,32,38,38,32,116,105,108,116,101,100,46,100,97,116,97,32,61,61,32,116,105,108,116,101,100,48,46,100,97,116,97,0,99,118,73,110,116,101,103,114,97,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,105,109,103,46,100,105,109,115,32,60,61,32,50,32,38,38,32,116,101,109,112,108,46,100,105,109,115,32,60,61,32,50,32,38,38,32,99,111,114,114,46,100,105,109,115,32,60,61,32,50,0,99,114,111,115,115,67,111,114,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,116,101,109,112,108,109,97,116,99,104,46,99,112,112,0,100,101,112,116,104,32,61,61,32,116,100,101,112,116,104,32,124,124,32,116,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,0,99,111,114,114,115,105,122,101,46,104,101,105,103,104,116,32,60,61,32,105,109,103,46,114,111,119,115,32,43,32,116,101,109,112,108,46,114,111,119,115,32,45,32,49,32,38,38,32,99,111,114,114,115,105,122,101,46,119,105,100,116,104,32,60,61,32,105,109,103,46,99,111,108,115,32,43,32,116,101,109,112,108,46,99,111,108,115,32,45,32,49,0,99,99,110,32,61,61,32,49,32,124,124,32,100,101,108,116,97,32,61,61,32,48,0,116,104,101,32,105,110,112,117,116,32,97,114,114,97,121,115,32,97,114,101,32,116,111,111,32,98,105,103,0,67,86,95,84,77,95,83,81,68,73,70,70,32,60,61,32,109,101,116,104,111,100,32,38,38,32,109,101,116,104,111,100,32,60,61,32,67,86,95,84,77,95,67,67,79,69,70,70,95,78,79,82,77,69,68,0,109,97,116,99,104,84,101,109,112,108,97,116,101,77,97,115,107,0,40,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,41,32,38,38,32,116,121,112,101,32,61,61,32,95,116,101,109,112,108,46,116,121,112,101,40,41,32,38,38,32,95,105,109,103,46,100,105,109,115,40,41,32,60,61,32,50,0,109,97,116,99,104,84,101,109,112,108,97,116,101,0,95,105,109,103,46,115,105,122,101,40,41,46,104,101,105,103,104,116,32,60,61,32,95,116,101,109,112,108,46,115,105,122,101,40,41,46,104,101,105,103,104,116,32,38,38,32,95,105,109,103,46,115,105,122,101,40,41,46,119,105,100,116,104,32,60,61,32,95,116,101,109,112,108,46,115,105,122,101,40,41,46,119,105,100,116,104,0,97,117,116,111,109,97,116,105,99,95,116,104,114,101,115,104,32,33,61,32,40,67,86,95,84,72,82,69,83,72,95,79,84,83,85,32,124,32,67,86,95,84,72,82,69,83,72,95,84,82,73,65,78,71,76,69,41,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,116,104,114,101,115,104,46,99,112,112,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,85,110,107,110,111,119,110,32,116,104,114,101,115,104,111,108,100,32,116,121,112,101,0,116,104,114,101,115,104,95,56,117,0,116,104,114,101,115,104,95,49,54,115,0,116,104,114,101,115,104,95,51,50,102,0,78,50,99,118,49,53,84,104,114,101,115,104,111,108,100,82,117,110,110,101,114,69,0,97,100,97,112,116,105,118,101,84,104,114,101,115,104,111,108,100,0,98,108,111,99,107,83,105,122,101,32,37,32,50,32,61,61,32,49,32,38,38,32,98,108,111,99,107,83,105,122,101,32,62,32,49,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,97,100,97,112,116,105,118,101,32,116,104,114,101,115,104,111,108,100,32,109,101,116,104,111,100,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,116,104,114,101,115,104,111,108,100,32,116,121,112,101,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,32,38,38,32,40,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,32,124,124,32,100,115,116,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,41,0,99,118,84,104,114,101,115,104,111,108,100,0,109,49,116,121,112,101,32,61,61,32,67,86,95,49,54,83,67,50,32,124,124,32,109,49,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,109,49,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,50,0,105,110,105,116,85,110,100,105,115,116,111,114,116,82,101,99,116,105,102,121,77,97,112,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,117,110,100,105,115,116,111,114,116,46,99,112,112,0,65,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,51,44,51,41,32,38,38,32,65,46,115,105,122,101,40,41,32,61,61,32,82,46,115,105,122,101,40,41,0,65,114,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,51,44,51,41,32,124,124,32,65,114,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,52,44,32,51,41,0,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,52,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,53,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,53,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,56,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,56,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,49,50,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,50,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,49,52,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,52,44,32,49,41,0,100,115,116,46,100,97,116,97,32,33,61,32,115,114,99,46,100,97,116,97,0,117,110,100,105,115,116,111,114,116,0,67,86,95,73,83,95,77,65,84,40,95,115,114,99,41,32,38,38,32,67,86,95,73,83,95,77,65,84,40,95,100,115,116,41,32,38,38,32,40,95,115,114,99,45,62,114,111,119,115,32,61,61,32,49,32,124,124,32,95,115,114,99,45,62,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,95,100,115,116,45,62,114,111,119,115,32,61,61,32,49,32,124,124,32,95,100,115,116,45,62,99,111,108,115,32,61,61,32,49,41,32,38,38,32,95,115,114,99,45,62,99,111,108,115,32,43,32,95,115,114,99,45,62,114,111,119,115,32,45,32,49,32,61,61,32,95,100,115,116,45,62,114,111,119,115,32,43,32,95,100,115,116,45,62,99,111,108,115,32,45,32,49,32,38,38,32,40,67,86,95,77,65,84,95,84,89,80,69,40,95,115,114,99,45,62,116,121,112,101,41,32,61,61,32,67,86,95,51,50,70,67,50,32,124,124,32,67,86,95,77,65,84,95,84,89,80,69,40,95,115,114,99,45,62,116,121,112,101,41,32,61,61,32,67,86,95,54,52,70,67,50,41,32,38,38,32,40,67,86,95,77,65,84,95,84,89,80,69,40,95,100,115,116,45,62,116,121,112,101,41,32,61,61,32,67,86,95,51,50,70,67,50,32,124,124,32,67,86,95,77,65,84,95,84,89,80,69,40,95,100,115,116,45,62,116,121,112,101,41,32,61,61,32,67,86,95,54,52,70,67,50,41,0,99,118,85,110,100,105,115,116,111,114,116,80,111,105,110,116,115,0,67,86,95,73,83,95,77,65,84,40,95,99,97,109,101,114,97,77,97,116,114,105,120,41,32,38,38,32,95,99,97,109,101,114,97,77,97,116,114,105,120,45,62,114,111,119,115,32,61,61,32,51,32,38,38,32,95,99,97,109,101,114,97,77,97,116,114,105,120,45,62,99,111,108,115,32,61,61,32,51,0,67,86,95,73,83,95,77,65,84,40,95,100,105,115,116,67,111,101,102,102,115,41,32,38,38,32,40,95,100,105,115,116,67,111,101,102,102,115,45,62,114,111,119,115,32,61,61,32,49,32,124,124,32,95,100,105,115,116,67,111,101,102,102,115,45,62,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,95,100,105,115,116,67,111,101,102,102,115,45,62,114,111,119,115,42,95,100,105,115,116,67,111,101,102,102,115,45,62,99,111,108,115,32,61,61,32,52,32,124,124,32,95,100,105,115,116,67,111,101,102,102,115,45,62,114,111,119,115,42,95,100,105,115,116,67,111,101,102,102,115,45,62,99,111,108,115,32,61,61,32,53,32,124,124,32,95,100,105,115,116,67,111,101,102,102,115,45,62,114,111,119,115,42,95,100,105,115,116,67,111,101,102,102,115,45,62,99,111,108,115,32,61,61,32,56,32,124,124,32,95,100,105,115,116,67,111,101,102,102,115,45,62,114,111,119,115,42,95,100,105,115,116,67,111,101,102,102,115,45,62,99,111,108,115,32,61,61,32,49,50,32,124,124,32,95,100,105,115,116,67,111,101,102,102,115,45,62,114,111,119,115,42,95,100,105,115,116,67,111,101,102,102,115,45,62,99,111,108,115,32,61,61,32,49,52,41,0,67,86,95,73,83,95,77,65,84,40,109,97,116,82,41,32,38,38,32,109,97,116,82,45,62,114,111,119,115,32,61,61,32,51,32,38,38,32,109,97,116,82,45,62,99,111,108,115,32,61,61,32,51,0,67,86,95,73,83,95,77,65,84,40,109,97,116,80,41,32,38,38,32,109,97,116,80,45,62,114,111,119,115,32,61,61,32,51,32,38,38,32,40,109,97,116,80,45,62,99,111,108,115,32,61,61,32,51,32,124,124,32,109,97,116,80,45,62,99,111,108,115,32,61,61,32,52,41,0,115,114,99,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,54,52,70,41,32,38,38,32,40,40,115,114,99,46,114,111,119,115,32,61,61,32,49,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,50,41,32,124,124,32,115,114,99,46,99,111,108,115,42,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,50,41,0,117,110,100,105,115,116,111,114,116,80,111,105,110,116,115,0,40,100,105,115,116,67,111,101,102,102,115,48,46,99,111,108,115,32,61,61,32,49,32,124,124,32,100,105,115,116,67,111,101,102,102,115,48,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,40,110,100,99,111,101,102,102,115,32,61,61,32,52,32,124,124,32,110,100,99,111,101,102,102,115,32,61,61,32,53,32,124,124,32,110,100,99,111,101,102,102,115,32,61,61,32,56,32,124,124,32,110,100,99,111,101,102,102,115,32,61,61,32,49,50,32,124,124,32,110,100,99,111,101,102,102,115,32,61,61,32,49,52,41,0,105,110,105,116,87,105,100,101,65,110,103,108,101,80,114,111,106,77,97,112,0,99,97,109,101,114,97,77,97,116,114,105,120,48,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,51,44,51,41,0,97,118,103,32,105,116,101,114,115,32,61,32,37,103,10,0,85,110,107,110,111,119,110,32,112,114,111,106,101,99,116,105,111,110,32,116,121,112,101,0,109,97,112,80,111,105,110,116,83,112,104,101,114,105,99,97,108,0,97,114,114,32,33,61,32,48,32,38,38,32,99,111,110,116,111,117,114,95,104,101,97,100,101,114,32,33,61,32,48,32,38,38,32,98,108,111,99,107,32,33,61,32,48,0,99,118,80,111,105,110,116,83,101,113,70,114,111,109,77,97,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,117,116,105,108,115,46,99,112,112,0,73,110,112,117,116,32,97,114,114,97,121,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,116,114,105,120,0,84,104,101,32,109,97,116,114,105,120,32,99,97,110,32,110,111,116,32,98,101,32,99,111,110,118,101,114,116,101,100,32,116,111,32,112,111,105,110,116,32,115,101,113,117,101,110,99,101,32,98,101,99,97,117,115,101,32,111,102,32,105,110,97,112,112,114,111,112,114,105,97,116,101,32,101,108,101,109,101,110,116,32,116,121,112,101,0,84,104,101,32,109,97,116,114,105,120,32,99,111,110,118,101,114,116,101,100,32,116,111,32,112,111,105,110,116,32,115,101,113,117,101,110,99,101,32,109,117,115,116,32,98,101,32,49,45,100,105,109,101,110,115,105,111,110,97,108,32,97,110,100,32,99,111,110,116,105,110,117,111,117,115,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,80,110,103,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,80,110,103,68,101,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,84,105,102,102,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,80,120,77,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,80,120,77,68,101,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,117,110,82,97,115,116,101,114,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,117,110,82,97,115,116,101,114,68,101,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,74,112,101,103,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,74,112,101,103,68,101,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,72,100,114,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,72,100,114,68,101,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,66,109,112,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,66,109,112,68,101,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,105,109,97,103,101,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,124,124,32,105,109,97,103,101,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,51,32,124,124,32,105,109,97,103,101,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,52,0,105,109,119,114,105,116,101,95,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,108,111,97,100,115,97,118,101,46,99,112,112,0,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,97,32,119,114,105,116,101,114,32,102,111,114,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,101,120,116,101,110,115,105,111,110,0,101,110,99,111,100,101,114,45,62,105,115,70,111,114,109,97,116,83,117,112,112,111,114,116,101,100,40,67,86,95,56,85,41,0,33,98,117,102,46,101,109,112,116,121,40,41,32,38,38,32,98,117,102,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,105,109,100,101,99,111,100,101,95,0,99,104,97,110,110,101,108,115,32,61,61,32,49,32,124,124,32,99,104,97,110,110,101,108,115,32,61,61,32,51,32,124,124,32,99,104,97,110,110,101,108,115,32,61,61,32,52,0,105,109,101,110,99,111,100,101,0,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,101,110,99,111,100,101,114,32,102,111,114,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,101,120,116,101,110,115,105,111,110,0,102,32,33,61,32,48,0,78,50,99,118,49,48,66,109,112,68,101,99,111,100,101,114,69,0,87,105,110,100,111,119,115,32,98,105,116,109,97,112,32,40,42,46,98,109,112,59,42,46,100,105,98,41,0,66,77,0,78,50,99,118,49,48,66,109,112,69,110,99,111,100,101,114,69,0,35,63,82,71,66,69,0,35,63,82,65,68,73,65,78,67,69,0,78,50,99,118,49,48,72,100,114,68,101,99,111,100,101,114,69,0,82,97,100,105,97,110,99,101,32,72,68,82,32,40,42,46,104,100,114,59,42,46,112,105,99,41,0,105,110,112,117,116,95,105,109,103,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,51,32,124,124,32,105,110,112,117,116,95,105,109,103,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,103,114,102,109,116,95,104,100,114,46,99,112,112,0,112,97,114,97,109,115,46,101,109,112,116,121,40,41,32,124,124,32,112,97,114,97,109,115,91,48,93,32,61,61,32,72,68,82,95,78,79,78,69,32,124,124,32,112,97,114,97,109,115,91,48,93,32,61,61,32,72,68,82,95,82,76,69,0,78,50,99,118,49,48,72,100,114,69,110,99,111,100,101,114,69,0,255,216,255,0,255,196,1,162,0,0,1,5,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,1,0,3,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,16,0,2,1,3,3,2,4,3,5,5,4,4,0,0,1,125,1,2,3,0,4,17,5,18,33,49,65,6,19,81,97,7,34,113,20,50,129,145,161,8,35,66,177,193,21,82,209,240,36,51,98,114,130,9,10,22,23,24,25,26,37,38,39,40,41,42,52,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,225,226,227,228,229,230,231,232,233,234,241,242,243,244,245,246,247,248,249,250,17,0,2,1,2,4,4,3,4,7,5,4,4,0,1,2,119,0,1,2,3,17,4,5,33,49,6,18,65,81,7,97,113,19,34,50,129,8,20,66,145,161,177,193,9,35,51,82,240,21,98,114,209,10,22,36,52,225,37,241,23,24,25,26,38,39,40,41,42,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,130,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,226,227,228,229,230,231,232,233,234,242,243,244,245,246,247,248,249,250,78,50,99,118,49,49,74,112,101,103,68,101,99,111,100,101,114,69,0,74,80,69,71,32,102,105,108,101,115,32,40,42,46,106,112,101,103,59,42,46,106,112,103,59,42,46,106,112,101,41,0,78,50,99,118,49,49,74,112,101,103,69,110,99,111,100,101,114,69,0,100,101,99,111,100,101,114,0,114,101,97,100,68,97,116,97,70,114,111,109,66,117,102,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,103,114,102,109,116,95,112,110,103,46,99,112,112,0,80,78,71,32,105,110,112,117,116,32,98,117,102,102,101,114,32,105,115,32,105,110,99,111,109,112,108,101,116,101,0,78,50,99,118,49,48,80,110,103,68,101,99,111,100,101,114,69,0,80,111,114,116,97,98,108,101,32,78,101,116,119,111,114,107,32,71,114,97,112,104,105,99,115,32,102,105,108,101,115,32,40,42,46,112,110,103,41,0,101,110,99,111,100,101,114,32,38,38,32,101,110,99,111,100,101,114,45,62,109,95,98,117,102,0,119,114,105,116,101,68,97,116,97,84,111,66,117,102,0,78,50,99,118,49,48,80,110,103,69,110,99,111,100,101,114,69,0,78,50,99,118,51,36,95,48,69,0,78,50,99,118,49,48,80,120,77,68,101,99,111,100,101,114,69,0,80,111,114,116,97,98,108,101,32,105,109,97,103,101,32,102,111,114,109,97,116,32,40,42,46,112,98,109,59,42,46,112,103,109,59,42,46,112,112,109,59,42,46,112,120,109,59,42,46,112,110,109,41,0,80,37,99,10,37,100,32,37,100,10,37,100,10,0,37,32,52,100,0,37,32,54,100,0,78,50,99,118,49,48,80,120,77,69,110,99,111,100,101,114,69,0,78,50,99,118,49,54,83,117,110,82,97,115,116,101,114,68,101,99,111,100,101,114,69,0,83,117,110,32,114,97,115,116,101,114,32,102,105,108,101,115,32,40,42,46,115,114,59,42,46,114,97,115,41,0,89,166,106,149,0,78,50,99,118,49,54,83,117,110,82,97,115,116,101,114,69,110,99,111,100,101,114,69,0,84,73,70,70,32,70,105,108,101,115,32,40,42,46,116,105,102,102,59,42,46,116,105,102,41,0,73,73,42,0,0,114,43,98,0,78,50,99,118,49,49,84,105,102,102,69,110,99,111,100,101,114,69,0,78,50,99,118,51,36,95,48,69,0,98,117,102,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,111,112,101,110,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,98,105,116,115,116,114,109,46,99,112,112,0,78,50,99,118,49,49,82,66,97,115,101,83,116,114,101,97,109,69,0,78,50,99,118,49,49,87,66,97,115,101,83,116,114,101,97,109,69,0,78,50,99,118,49,50,82,76,66,121,116,101,83,116,114,101,97,109,69,0,78,50,99,118,49,50,82,77,66,121,116,101,83,116,114,101,97,109,69,0,78,50,99,118,49,50,87,76,66,121,116,101,83,116,114,101,97,109,69,0,78,50,99,118,49,50,87,77,66,121,116,101,83,116,114,101,97,109,69,0,82,71,66,69,0,35,63,37,115,10,0,70,79,82,77,65,84,61,51,50,45,98,105,116,95,114,108,101,95,114,103,98,101,10,10,0,45,89,32,37,100,32,43,88,32,37,100,10,0,82,71,66,69,32,114,101,97,100,32,101,114,114,111,114,0,114,103,98,101,95,101,114,114,111,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,114,103,98,101,46,99,112,112,0,82,71,66,69,32,119,114,105,116,101,32,101,114,114,111,114,0,82,71,66,69,32,98,97,100,32,102,105,108,101,32,102,111,114,109,97,116,58,32,0,82,71,66,69,32,101,114,114,111,114,58,32,10,0,70,79,82,77,65,84,61,51,50,45,98,105,116,95,114,108,101,95,114,103,98,101,10,0,10,0,109,105,115,115,105,110,103,32,98,108,97,110,107,32,108,105,110,101,32,97,102,116,101,114,32,70,79,82,77,65,84,32,115,112,101,99,105,102,105,101,114,0,109,105,115,115,105,110,103,32,70,79,82,77,65,84,32,115,112,101,99,105,102,105,101,114,0,45,89,32,37,100,32,43,88,32,37,100,0,109,105,115,115,105,110,103,32,105,109,97,103,101,32,115,105,122,101,32,115,112,101,99,105,102,105,101,114,0,119,114,111,110,103,32,115,99,97,110,108,105,110,101,32,119,105,100,116,104,0,117,110,97,98,108,101,32,116,111,32,97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,32,115,112,97,99,101,0,98,97,100,32,115,99,97,110,108,105,110,101,32,100,97,116,97,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,54,69,120,105,102,80,97,114,115,105,110,103,69,114,114,111,114,69,0,78,50,99,118,49,54,66,97,115,101,73,109,97,103,101,68,101,99,111,100,101,114,69,0,82,97,119,32,105,109,97,103,101,32,101,110,99,111,100,101,114,32,101,114,114,111,114,58,32,0,116,104,114,111,119,79,110,69,114,111,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,103,114,102,109,116,95,98,97,115,101,46,99,112,112,0,78,50,99,118,49,54,66,97,115,101,73,109,97,103,101,69,110,99,111,100,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,49,49,65,78,78,95,77,76,80,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,48,32,60,61,32,108,97,121,101,114,73,100,120,32,38,38,32,108,97,121,101,114,73,100,120,32,60,32,40,105,110,116,41,119,101,105,103,104,116,115,46,115,105,122,101,40,41,0,103,101,116,87,101,105,103,104,116,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,109,108,47,115,114,99,47,97,110,110,95,109,108,112,46,99,112,112,0,116,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,97,116,32,108,101,97,115,116,32,111,110,101,32,105,110,112,117,116,32,97,110,100,32,111,110,101,32,111,117,116,112,117,116,32,97,110,100,32,101,118,101,114,121,32,104,105,100,100,101,110,32,108,97,121,101,114,32,109,117,115,116,32,104,97,118,101,32,109,111,114,101,32,116,104,97,110,32,49,32,110,101,117,114,111,110,0,115,101,116,76,97,121,101,114,83,105,122,101,115,0,85,110,107,110,111,119,110,32,97,99,116,105,118,97,116,105,111,110,32,102,117,110,99,116,105,111,110,0,115,101,116,65,99,116,105,118,97,116,105,111,110,70,117,110,99,116,105,111,110,0,84,104,101,32,110,101,116,119,111,114,107,32,104,97,115,32,110,111,116,32,98,101,101,110,32,116,114,97,105,110,101,100,32,111,114,32,108,111,97,100,101,100,0,40,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,41,32,38,38,32,105,110,112,117,116,115,46,99,111,108,115,32,61,61,32,108,97,121,101,114,95,115,105,122,101,115,91,48,93,0,110,32,61,61,32,49,0,115,117,109,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,99,97,108,99,95,97,99,116,105,118,95,102,117,110,99,0,119,101,105,103,104,116,115,91,105,93,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,50,44,32,110,49,43,49,41,0,116,114,97,105,110,95,114,112,114,111,112,0,78,50,99,118,50,109,108,49,49,65,78,78,95,77,76,80,73,109,112,108,57,82,80,114,111,112,76,111,111,112,69,0,84,104,101,32,110,101,116,119,111,114,107,32,104,97,115,32,110,111,116,32,98,101,101,110,32,99,114,101,97,116,101,100,46,32,85,115,101,32,109,101,116,104,111,100,32,99,114,101,97,116,101,32,111,114,32,116,104,101,32,97,112,112,114,111,112,114,105,97,116,101,32,99,111,110,115,116,114,117,99,116,111,114,0,112,114,101,112,97,114,101,95,116,111,95,116,114,97,105,110,0,105,110,112,117,116,32,116,114,97,105,110,105,110,103,32,100,97,116,97,32,115,104,111,117,108,100,32,98,101,32,97,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,109,97,116,114,105,120,32,119,105,116,104,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,32,101,113,117,97,108,32,116,111,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,116,114,97,105,110,105,110,103,32,115,97,109,112,108,101,115,32,97,110,100,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,99,111,108,117,109,110,115,32,101,113,117,97,108,32,116,111,32,116,104,101,32,115,105,122,101,32,111,102,32,48,45,116,104,32,40,105,110,112,117,116,41,32,108,97,121,101,114,0,111,117,116,112,117,116,32,116,114,97,105,110,105,110,103,32,100,97,116,97,32,115,104,111,117,108,100,32,98,101,32,97,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,109,97,116,114,105,120,32,119,105,116,104,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,32,101,113,117,97,108,32,116,111,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,116,114,97,105,110,105,110,103,32,115,97,109,112,108,101,115,32,97,110,100,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,99,111,108,117,109,110,115,32,101,113,117,97,108,32,116,111,32,116,104,101,32,115,105,122,101,32,111,102,32,108,97,115,116,32,40,111,117,116,112,117,116,41,32,108,97,121,101,114,0,84,104,101,32,110,117,109,98,101,114,115,32,111,102,32,105,110,112,117,116,32,97,110,100,32,111,117,116,112,117,116,32,115,97,109,112,108,101,115,32,100,111,32,110,111,116,32,109,97,116,99,104,0,83,111,109,101,32,111,102,32,110,101,119,32,111,117,116,112,117,116,32,116,114,97,105,110,105,110,103,32,118,101,99,116,111,114,32,99,111,109,112,111,110,101,110,116,115,32,114,117,110,32,101,120,99,101,101,100,32,116,104,101,32,111,114,105,103,105,110,97,108,32,114,97,110,103,101,32,116,111,111,32,109,117,99,104,0,99,97,108,99,95,111,117,116,112,117,116,95,115,99,97,108,101,0,111,112,101,110,99,118,95,109,108,95,97,110,110,95,109,108,112,0,108,97,121,101,114,95,115,105,122,101,115,0,105,110,112,117,116,95,115,99,97,108,101,0,111,117,116,112,117,116,95,115,99,97,108,101,0,105,110,118,95,111,117,116,112,117,116,95,115,99,97,108,101,0,97,99,116,105,118,97,116,105,111,110,95,102,117,110,99,116,105,111,110,0,83,73,71,77,79,73,68,95,83,89,77,0,73,68,69,78,84,73,84,89,0,71,65,85,83,83,73,65,78,0,97,99,116,105,118,95,102,117,110,99,32,62,61,32,48,0,97,99,116,105,118,97,116,105,111,110,95,102,117,110,99,116,105,111,110,95,105,100,0,102,95,112,97,114,97,109,49,0,102,95,112,97,114,97,109,50,0,109,105,110,95,118,97,108,0,109,97,120,95,118,97,108,0,109,105,110,95,118,97,108,49,0,109,97,120,95,118,97,108,49,0,66,65,67,75,80,82,79,80,0,100,119,95,115,99,97,108,101,0,109,111,109,101,110,116,95,115,99,97,108,101,0,82,80,82,79,80,0,100,119,48,0,100,119,95,112,108,117,115,0,100,119,95,109,105,110,117,115,0,100,119,95,109,105,110,0,100,119,95,109,97,120,0,85,110,107,110,111,119,110,32,116,114,97,105,110,105,110,103,32,109,101,116,104,111,100,32,40,115,104,111,117,108,100,32,98,101,32,66,65,67,75,80,82,79,80,32,111,114,32,82,80,82,79,80,41,0,85,110,107,110,111,119,110,32,116,114,97,105,110,105,110,103,32,109,101,116,104,111,100,0,119,114,105,116,101,95,112,97,114,97,109,115,0,78,50,99,118,50,109,108,49,49,65,78,78,95,77,76,80,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,57,66,111,111,115,116,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,98,111,111,115,116,105,110,103,95,116,121,112,101,0,68,105,115,99,114,101,116,101,65,100,97,98,111,111,115,116,0,82,101,97,108,65,100,97,98,111,111,115,116,0,76,111,103,105,116,66,111,111,115,116,0,71,101,110,116,108,101,65,100,97,98,111,111,115,116,0,119,101,105,103,104,116,95,116,114,105,109,109,105,110,103,95,114,97,116,101,0,85,110,107,110,111,119,110,0,115,116,100,58,58,97,98,115,40,119,45,62,111,114,100,95,114,101,115,112,111,110,115,101,115,91,115,105,93,41,32,61,61,32,49,0,117,112,100,97,116,101,87,101,105,103,104,116,115,65,110,100,84,114,105,109,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,109,108,47,115,114,99,47,98,111,111,115,116,46,99,112,112,0,85,110,107,110,111,119,110,32,98,111,111,115,116,105,110,103,32,116,121,112,101,0,111,112,101,110,99,118,95,109,108,95,100,116,114,101,101,0,78,50,99,118,50,109,108,49,56,68,84,114,101,101,115,73,109,112,108,70,111,114,66,111,111,115,116,69,0,111,112,101,110,99,118,95,109,108,95,98,111,111,115,116,0,78,50,99,118,50,109,108,57,66,111,111,115,116,73,109,112,108,69,0,78,50,99,118,50,109,108,57,84,114,97,105,110,68,97,116,97,69,0,116,121,112,101,32,61,61,32,67,86,95,51,50,83,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,103,101,116,83,117,98,86,101,99,116,111,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,109,108,47,115,114,99,47,100,97,116,97,46,99,112,112,0,48,32,60,61,32,107,32,38,38,32,107,32,60,32,109,0,95,108,97,121,111,117,116,32,61,61,32,82,79,87,95,83,65,77,80,76,69,32,124,124,32,95,108,97,121,111,117,116,32,61,61,32,67,79,76,95,83,65,77,80,76,69,0,115,101,116,68,97,116,97,0,115,97,109,112,108,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,115,97,109,112,108,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,0,40,115,97,109,112,108,101,73,100,120,46,99,104,101,99,107,86,101,99,116,111,114,40,49,44,32,67,86,95,51,50,83,44,32,116,114,117,101,41,32,62,32,48,32,38,38,32,99,104,101,99,107,82,97,110,103,101,40,115,97,109,112,108,101,73,100,120,44,32,116,114,117,101,44,32,48,44,32,48,44,32,110,115,97,109,112,108,101,115,41,41,32,124,124,32,115,97,109,112,108,101,73,100,120,46,99,104,101,99,107,86,101,99,116,111,114,40,49,44,32,67,86,95,56,85,44,32,116,114,117,101,41,32,61,61,32,110,115,97,109,112,108,101,115,0,115,97,109,112,108,101,87,101,105,103,104,116,115,46,99,104,101,99,107,86,101,99,116,111,114,40,49,44,32,67,86,95,51,50,70,44,32,116,114,117,101,41,32,61,61,32,110,115,97,109,112,108,101,115,0,40,118,97,114,73,100,120,46,99,104,101,99,107,86,101,99,116,111,114,40,49,44,32,67,86,95,51,50,83,44,32,116,114,117,101,41,32,62,32,48,32,38,38,32,99,104,101,99,107,82,97,110,103,101,40,118,97,114,73,100,120,44,32,116,114,117,101,44,32,48,44,32,48,44,32,110,105,110,112,117,116,118,97,114,115,41,41,32,124,124,32,118,97,114,73,100,120,46,99,104,101,99,107,86,101,99,116,111,114,40,49,44,32,67,86,95,56,85,44,32,116,114,117,101,41,32,61,61,32,110,105,110,112,117,116,118,97,114,115,0,114,101,115,112,111,110,115,101,115,46,116,121,112,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+352500);allocate([40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,114,101,115,112,111,110,115,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,0,40,108,97,121,111,117,116,32,61,61,32,82,79,87,95,83,65,77,80,76,69,32,38,38,32,114,101,115,112,111,110,115,101,115,46,114,111,119,115,32,61,61,32,110,115,97,109,112,108,101,115,41,32,124,124,32,40,108,97,121,111,117,116,32,61,61,32,67,79,76,95,83,65,77,80,76,69,32,38,38,32,114,101,115,112,111,110,115,101,115,46,99,111,108,115,32,61,61,32,110,115,97,109,112,108,101,115,41,0,118,97,114,84,121,112,101,46,99,104,101,99,107,86,101,99,116,111,114,40,49,44,32,67,86,95,56,85,44,32,116,114,117,101,41,32,61,61,32,110,118,97,114,115,32,38,38,32,99,104,101,99,107,82,97,110,103,101,40,118,97,114,84,121,112,101,44,32,116,114,117,101,44,32,48,44,32,86,65,82,95,79,82,68,69,82,69,68,44,32,86,65,82,95,67,65,84,69,71,79,82,73,67,65,76,43,49,41,0,118,97,114,84,121,112,101,46,97,116,60,117,99,104,97,114,62,40,110,105,110,112,117,116,118,97,114,115,32,43,32,105,41,32,61,61,32,86,65,82,95,79,82,68,69,82,69,68,0,109,105,115,115,105,110,103,46,115,105,122,101,40,41,32,61,61,32,115,97,109,112,108,101,115,46,115,105,122,101,40,41,32,38,38,32,109,105,115,115,105,110,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,0,109,32,62,32,48,0,40,100,97,116,97,46,99,111,108,115,32,61,61,32,49,32,124,124,32,100,97,116,97,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,40,100,97,116,97,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,32,124,124,32,100,97,116,97,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,41,0,112,114,101,112,114,111,99,101,115,115,67,97,116,101,103,111,114,105,99,97,108,0,40,102,108,111,97,116,41,105,100,97,116,97,91,105,93,32,61,61,32,102,100,97,116,97,91,105,42,105,115,116,101,112,93,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,49,51,84,114,97,105,110,68,97,116,97,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,97,32,60,32,110,116,101,115,116,0,115,104,117,102,102,108,101,84,114,97,105,110,84,101,115,116,0,98,32,60,32,110,116,101,115,116,0,48,46,32,60,61,32,114,97,116,105,111,32,38,38,32,114,97,116,105,111,32,60,61,32,49,46,0,115,101,116,84,114,97,105,110,84,101,115,116,83,112,108,105,116,82,97,116,105,111,0,48,32,60,61,32,99,111,117,110,116,32,38,38,32,99,111,117,110,116,32,60,32,110,115,97,109,112,108,101,115,0,115,101,116,84,114,97,105,110,84,101,115,116,83,112,108,105,116,0,48,32,60,61,32,118,105,32,38,38,32,118,105,32,60,32,110,0,103,101,116,67,97,116,67,111,117,110,116,0,103,101,116,78,111,114,109,67,97,116,86,97,108,117,101,115,0,99,109,97,112,91,105,100,120,93,32,61,61,32,118,97,108,0,48,32,60,61,32,118,105,32,38,38,32,118,105,32,60,32,103,101,116,78,65,108,108,86,97,114,115,40,41,0,103,101,116,86,97,108,117,101,115,0,110,32,62,61,32,48,0,48,32,60,61,32,106,32,38,38,32,106,32,60,32,110,115,97,109,112,108,101,115,0,98,117,102,32,33,61,32,48,32,38,38,32,48,32,60,61,32,115,105,100,120,32,38,38,32,115,105,100,120,32,60,32,103,101,116,78,83,97,109,112,108,101,115,40,41,0,103,101,116,83,97,109,112,108,101,0,48,32,60,61,32,106,32,38,38,32,106,32,60,32,110,118,97,114,115,0,78,50,99,118,50,109,108,49,51,84,114,97,105,110,68,97,116,97,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,54,69,77,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,119,101,105,103,104,116,115,46,101,109,112,116,121,40,41,0,100,111,84,114,97,105,110,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,109,108,47,115,114,99,47,101,109,46,99,112,112,0,105,110,118,67,111,118,115,69,105,103,101,110,86,97,108,117,101,115,46,101,109,112,116,121,40,41,0,33,109,101,97,110,115,46,101,109,112,116,121,40,41,0,99,111,109,112,117,116,101,80,114,111,98,97,98,105,108,105,116,105,101,115,0,40,115,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,115,116,121,112,101,32,61,61,32,67,86,95,54,52,70,41,32,38,38,32,40,112,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,112,116,121,112,101,32,61,61,32,67,86,95,54,52,70,41,0,115,97,109,112,108,101,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,109,101,97,110,115,46,99,111,108,115,44,32,49,41,0,33,99,111,118,115,69,105,103,101,110,86,97,108,117,101,115,46,101,109,112,116,121,40,41,0,99,111,109,112,117,116,101,76,111,103,87,101,105,103,104,116,68,105,118,68,101,116,0,33,99,111,118,115,46,101,109,112,116,121,40,41,0,100,101,99,111,109,112,111,115,101,67,111,118,115,0,33,99,111,118,115,91,99,108,117,115,116,101,114,73,110,100,101,120,93,46,101,109,112,116,121,40,41,0,109,101,97,110,115,70,108,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,99,108,117,115,116,101,114,84,114,97,105,110,83,97,109,112,108,101,115,0,33,99,108,117,115,116,101,114,83,97,109,112,108,101,115,46,101,109,112,116,121,40,41,0,33,115,97,109,112,108,101,115,46,101,109,112,116,121,40,41,0,99,104,101,99,107,84,114,97,105,110,68,97,116,97,0,115,97,109,112,108,101,115,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,110,99,108,117,115,116,101,114,115,32,62,32,48,0,110,99,108,117,115,116,101,114,115,32,60,61,32,110,115,97,109,112,108,101,115,0,115,116,97,114,116,83,116,101,112,32,61,61,32,83,84,65,82,84,95,65,85,84,79,95,83,84,69,80,32,124,124,32,115,116,97,114,116,83,116,101,112,32,61,61,32,83,84,65,82,84,95,69,95,83,84,69,80,32,124,124,32,115,116,97,114,116,83,116,101,112,32,61,61,32,83,84,65,82,84,95,77,95,83,84,69,80,0,99,111,118,77,97,116,84,121,112,101,32,61,61,32,67,79,86,95,77,65,84,95,71,69,78,69,82,73,67,32,124,124,32,99,111,118,77,97,116,84,121,112,101,32,61,61,32,67,79,86,95,77,65,84,95,68,73,65,71,79,78,65,76,32,124,124,32,99,111,118,77,97,116,84,121,112,101,32,61,61,32,67,79,86,95,77,65,84,95,83,80,72,69,82,73,67,65,76,0,33,112,114,111,98,115,32,124,124,32,40,33,112,114,111,98,115,45,62,101,109,112,116,121,40,41,32,38,38,32,112,114,111,98,115,45,62,114,111,119,115,32,61,61,32,110,115,97,109,112,108,101,115,32,38,38,32,112,114,111,98,115,45,62,99,111,108,115,32,61,61,32,110,99,108,117,115,116,101,114,115,32,38,38,32,40,112,114,111,98,115,45,62,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,112,114,111,98,115,45,62,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,67,49,41,41,0,33,119,101,105,103,104,116,115,32,124,124,32,40,33,119,101,105,103,104,116,115,45,62,101,109,112,116,121,40,41,32,38,38,32,40,119,101,105,103,104,116,115,45,62,99,111,108,115,32,61,61,32,49,32,124,124,32,119,101,105,103,104,116,115,45,62,114,111,119,115,32,61,61,32,49,41,32,38,38,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,119,101,105,103,104,116,115,45,62,116,111,116,97,108,40,41,41,32,61,61,32,110,99,108,117,115,116,101,114,115,32,38,38,32,40,119,101,105,103,104,116,115,45,62,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,119,101,105,103,104,116,115,45,62,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,67,49,41,41,0,33,109,101,97,110,115,32,124,124,32,40,33,109,101,97,110,115,45,62,101,109,112,116,121,40,41,32,38,38,32,109,101,97,110,115,45,62,114,111,119,115,32,61,61,32,110,99,108,117,115,116,101,114,115,32,38,38,32,109,101,97,110,115,45,62,99,111,108,115,32,61,61,32,100,105,109,32,38,38,32,109,101,97,110,115,45,62,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,41,0,33,99,111,118,115,32,124,124,32,40,33,99,111,118,115,45,62,101,109,112,116,121,40,41,32,38,38,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,99,111,118,115,45,62,115,105,122,101,40,41,41,32,61,61,32,110,99,108,117,115,116,101,114,115,41,0,33,109,46,101,109,112,116,121,40,41,32,38,38,32,109,46,115,105,122,101,40,41,32,61,61,32,99,111,118,83,105,122,101,32,38,38,32,40,109,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,41,0,109,101,97,110,115,0,112,114,111,98,115,0,105,115,84,114,97,105,110,101,100,40,41,0,112,114,101,100,105,99,116,50,0,33,115,97,109,112,108,101,46,101,109,112,116,121,40,41,0,99,111,118,77,97,116,84,121,112,101,32,61,61,32,67,79,86,95,77,65,84,95,83,80,72,69,82,73,67,65,76,32,124,124,32,99,111,118,77,97,116,84,121,112,101,32,61,61,32,67,79,86,95,77,65,84,95,68,73,65,71,79,78,65,76,32,124,124,32,99,111,118,77,97,116,84,121,112,101,32,61,61,32,67,79,86,95,77,65,84,95,71,69,78,69,82,73,67,0,115,101,116,67,111,118,97,114,105,97,110,99,101,77,97,116,114,105,120,84,121,112,101,0,110,99,108,117,115,116,101,114,115,32,62,61,32,49,0,115,101,116,67,108,117,115,116,101,114,115,78,117,109,98,101,114,0,111,112,101,110,99,118,95,109,108,95,101,109,0,119,101,105,103,104,116,115,0,99,111,118,115,0,110,99,108,117,115,116,101,114,115,0,99,111,118,95,109,97,116,95,116,121,112,101,0,115,112,104,101,114,105,99,97,108,0,100,105,97,103,111,110,97,108,0,103,101,110,101,114,105,99,0,99,111,118,77,97,116,84,121,112,101,32,62,61,32,48,0,117,110,107,110,111,119,110,95,37,100,0,78,50,99,118,50,109,108,54,69,77,73,109,112,108,69,0,78,50,99,118,50,109,108,57,83,116,97,116,77,111,100,101,108,69,0,111,112,101,110,99,118,95,109,108,95,107,110,110,0,111,112,101,110,99,118,95,109,108,95,107,110,110,95,107,100,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,49,50,75,78,101,97,114,101,115,116,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,49,48,75,68,84,114,101,101,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,50,109,108,52,73,109,112,108,69,0,48,32,60,32,107,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,109,108,47,115,114,99,47,107,110,101,97,114,101,115,116,46,99,112,112,0,116,101,115,116,95,115,97,109,112,108,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,116,101,115,116,95,115,97,109,112,108,101,115,46,99,111,108,115,32,61,61,32,115,97,109,112,108,101,115,46,99,111,108,115,0,78,50,99,118,50,109,108,49,48,75,68,84,114,101,101,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,49,52,66,114,117,116,101,70,111,114,99,101,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,50,109,108,49,52,66,114,117,116,101,70,111,114,99,101,73,109,112,108,49,57,102,105,110,100,75,78,101,97,114,101,115,116,73,110,118,111,107,101,114,69,0,78,50,99,118,50,109,108,49,52,66,114,117,116,101,70,111,114,99,101,73,109,112,108,69,0,110,101,119,95,115,97,109,112,108,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,110,101,119,95,115,97,109,112,108,101,115,46,99,111,108,115,32,61,61,32,115,97,109,112,108,101,115,46,99,111,108,115,32,38,38,32,110,101,119,95,114,101,115,112,111,110,115,101,115,46,99,111,108,115,32,61,61,32,114,101,115,112,111,110,115,101,115,46,99,111,108,115,0,100,101,102,97,117,108,116,95,107,0,114,101,115,112,111,110,115,101,115,0,78,50,99,118,50,109,108,49,50,75,78,101,97,114,101,115,116,73,109,112,108,69,0,99,108,97,115,115,105,102,105,101,114,32,115,104,111,117,108,100,32,98,101,32,116,114,97,105,110,101,100,32,102,105,114,115,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,109,108,47,115,114,99,47,108,114,46,99,112,112,0,100,97,116,97,32,109,117,115,116,32,98,101,32,111,102,32,102,108,111,97,116,105,110,103,32,116,121,112,101,0,116,104,101,116,97,115,46,114,111,119,115,32,62,32,48,0,116,101,109,112,95,112,114,101,100,46,99,111,108,115,61,61,49,0,33,108,109,97,112,46,101,109,112,116,121,40,41,0,114,101,109,97,112,95,108,97,98,101,108,115,0,68,97,116,97,84,121,112,101,60,95,84,112,62,58,58,116,121,112,101,32,61,61,32,116,121,112,101,40,41,32,38,38,32,99,111,108,115,32,61,61,32,49,0,112,117,115,104,95,98,97,99,107,0,33,95,108,97,98,101,108,115,95,105,46,101,109,112,116,121,40,41,32,38,38,32,33,95,100,97,116,97,95,105,46,101,109,112,116,121,40,41,0,95,108,97,98,101,108,115,95,105,32,115,104,111,117,108,100,32,98,101,32,97,32,99,111,108,117,109,110,32,109,97,116,114,105,120,0,100,97,116,97,32,97,110,100,32,108,97,98,101,108,115,32,109,117,115,116,32,98,101,32,97,32,102,108,111,97,116,105,110,103,32,112,111,105,110,116,32,109,97,116,114,105,120,0,100,97,116,97,32,115,104,111,117,108,100,32,104,97,118,101,32,97,116,108,101,97,115,116,32,50,32,99,108,97,115,115,101,115,0,110,117,109,98,101,114,32,111,102,32,114,111,119,115,32,105,110,32,100,97,116,97,32,97,110,100,32,108,97,98,101,108,115,32,115,104,111,117,108,100,32,98,101,32,116,104,101,32,101,113,117,97,108,0,99,104,101,99,107,32,116,114,97,105,110,105,110,103,32,112,97,114,97,109,101,116,101,114,115,46,32,73,110,118,97,108,105,100,32,116,114,97,105,110,105,110,103,32,99,108,97,115,115,105,102,105,101,114,0,99,104,101,99,107,32,116,114,97,105,110,105,110,103,32,112,97,114,97,109,101,116,101,114,115,32,102,111,114,32,116,104,101,32,99,108,97,115,115,105,102,105,101,114,0,109,105,110,105,95,98,97,116,99,104,95,103,114,97,100,105,101,110,116,95,100,101,115,99,101,110,116,0,110,117,109,98,101,114,32,111,102,32,105,116,101,114,97,116,105,111,110,115,32,99,97,110,110,111,116,32,98,101,32,122,101,114,111,32,111,114,32,97,32,110,101,103,97,116,105,118,101,32,110,117,109,98,101,114,0,95,103,114,97,100,105,101,110,116,46,114,111,119,115,32,61,61,32,95,116,104,101,116,97,46,114,111,119,115,32,38,38,32,95,103,114,97,100,105,101,110,116,46,99,111,108,115,32,61,61,32,95,116,104,101,116,97,46,99,111,108,115,0,99,111,109,112,117,116,101,95,103,114,97,100,105,101,110,116,0,99,111,109,112,117,116,101,95,99,111,115,116,0,99,104,101,99,107,32,116,114,97,105,110,105,110,103,32,112,97,114,97,109,101,116,101,114,115,32,40,108,101,97,114,110,105,110,103,32,114,97,116,101,41,32,102,111,114,32,116,104,101,32,99,108,97,115,115,105,102,105,101,114,0,98,97,116,99,104,95,103,114,97,100,105,101,110,116,95,100,101,115,99,101,110,116,0,111,112,101,110,99,118,95,109,108,95,108,114,0,101,109,112,116,121,32,70,105,108,101,78,111,100,101,32,111,98,106,101,99,116,0,110,111,114,109,0,116,114,97,105,110,95,109,101,116,104,111,100,0,109,105,110,105,95,98,97,116,99,104,95,115,105,122,101,0,108,101,97,114,110,116,95,116,104,101,116,97,115,0,111,95,108,97,98,101,108,115,0,110,95,108,97,98,101,108,115,0,102,105,108,101,32,99,97,110,39,116,32,111,112,101,110,46,32,67,104,101,99,107,32,102,105,108,101,32,112,97,116,104,0,76,111,103,105,115,105,116,105,99,32,82,101,103,114,101,115,115,105,111,110,32,67,108,97,115,115,105,102,105,101,114,0,99,108,97,115,115,105,102,105,101,114,0,78,50,99,118,50,109,108,50,50,76,111,103,105,115,116,105,99,82,101,103,114,101,115,115,105,111,110,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,50,50,76,111,103,105,115,116,105,99,82,101,103,114,101,115,115,105,111,110,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,50,53,78,111,114,109,97,108,66,97,121,101,115,67,108,97,115,115,105,102,105,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,84,104,101,32,105,110,112,117,116,32,115,97,109,112,108,101,115,32,109,117,115,116,32,98,101,32,51,50,102,32,109,97,116,114,105,120,32,119,105,116,104,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,99,111,108,117,109,110,115,32,61,32,110,97,108,108,118,97,114,115,0,112,114,101,100,105,99,116,80,114,111,98,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,109,108,47,115,114,99,47,110,98,97,121,101,115,46,99,112,112,0,87,104,101,110,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,105,110,112,117,116,32,115,97,109,112,108,101,115,32,105,115,32,62,49,44,32,116,104,101,32,111,117,116,112,117,116,32,118,101,99,116,111,114,32,111,102,32,114,101,115,117,108,116,115,32,109,117,115,116,32,98,101,32,112,97,115,115,101,100,0,78,50,99,118,50,109,108,50,53,78,111,114,109,97,108,66,97,121,101,115,67,108,97,115,115,105,102,105,101,114,73,109,112,108,49,51,78,66,80,114,101,100,105,99,116,66,111,100,121,69,0,84,104,101,32,110,101,119,32,116,114,97,105,110,105,110,103,32,100,97,116,97,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,32,119,105,116,104,32,116,104,101,32,111,114,105,103,105,110,97,108,32,116,114,97,105,110,105,110,103,32,100,97,116,97,59,32,118,97,114,73,100,120,32,97,110,100,32,116,104,101,32,99,108,97,115,115,32,108,97,98,101,108,115,32,115,104,111,117,108,100,32,98,101,32,116,104,101,32,115,97,109,101,0,111,112,101,110,99,118,95,109,108,95,110,98,97,121,101,115,0,84,104,101,32,102,105,101,108,100,32,34,118,97,114,95,99,111,117,110,116,34,32,111,102,32,78,66,97,121,101,115,32,99,108,97,115,115,105,102,105,101,114,32,105,115,32,109,105,115,115,105,110,103,32,111,114,32,110,111,110,45,112,111,115,105,116,105,118,101,0,99,108,115,95,108,97,98,101,108,115,0,78,111,32,111,114,32,105,110,118,97,108,105,100,32,34,99,108,115,95,108,97,98,101,108,115,34,32,105,110,32,78,66,97,121,101,115,32,99,108,97,115,115,105,102,105,101,114,0,99,111,117,110,116,0,115,117,109,0,112,114,111,100,117,99,116,115,117,109,0,97,118,103,0,105,110,118,95,101,105,103,101,110,95,118,97,108,117,101,115,0,99,111,118,95,114,111,116,97,116,101,95,109,97,116,115,0,99,0,78,50,99,118,50,109,108,50,53,78,111,114,109,97,108,66,97,121,101,115,67,108,97,115,115,105,102,105,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,49,48,82,84,114,101,101,115,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,110,97,99,116,105,118,101,95,118,97,114,115,0,111,111,98,95,101,114,114,111,114,0,110,116,114,101,101,115,0,118,97,114,95,105,109,112,111,114,116,97,110,99,101,0,110,116,114,101,101,115,32,61,61,32,40,105,110,116,41,116,114,101,101,115,95,110,111,100,101,46,115,105,122,101,40,41,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,109,108,47,115,114,99,47,114,116,114,101,101,115,46,99,112,112,0,82,84,114,101,101,115,32,104,97,118,101,32,110,111,116,32,98,101,101,110,32,116,114,97,105,110,101,100,0,78,50,99,118,50,109,108,49,57,68,84,114,101,101,115,73,109,112,108,70,111,114,82,84,114,101,101,115,69,0,111,112,101,110,99,118,95,109,108,95,114,116,114,101,101,115,0,78,50,99,118,50,109,108,49,48,82,84,114,101,101,115,73,109,112,108,69,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,109,108,47,115,114,99,47,115,118,109,46,99,112,112,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,55,83,86,77,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,107,101,114,110,101,108,32,116,121,112,101,0,99,104,101,99,107,80,97,114,97,109,115,0,103,97,109,109,97,32,112,97,114,97,109,101,116,101,114,32,111,102,32,116,104,101,32,107,101,114,110,101,108,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,0,84,104,101,32,107,101,114,110,101,108,32,112,97,114,97,109,101,116,101,114,32,60,99,111,101,102,48,62,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,111,114,32,122,101,114,111,0,84,104,101,32,107,101,114,110,101,108,32,112,97,114,97,109,101,116,101,114,32,60,100,101,103,114,101,101,62,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,0,67,117,115,116,111,109,32,107,101,114,110,101,108,32,105,115,32,110,111,116,32,115,101,116,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,83,86,77,32,116,121,112,101,0,84,104,101,32,112,97,114,97,109,101,116,101,114,32,67,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,0,84,104,101,32,112,97,114,97,109,101,116,101,114,32,110,117,32,109,117,115,116,32,98,101,32,98,101,116,119,101,101,110,32,48,32,97,110,100,32,49,0,84,104,101,32,112,97,114,97,109,101,116,101,114,32,112,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,49,51,83,86,77,75,101,114,110,101,108,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,85,110,107,110,111,119,110,32,107,101,114,110,101,108,32,116,121,112,101,0,78,50,99,118,50,109,108,49,51,83,86,77,75,101,114,110,101,108,73,109,112,108,69,0,78,50,99,118,50,109,108,51,83,86,77,54,75,101,114,110,101,108,69,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,40,105,110,116,41,100,101,99,105,115,105,111,110,95,102,117,110,99,46,115,105,122,101,40,41,0,103,101,116,68,101,99,105,115,105,111,110,70,117,110,99,116,105,111,110,0,107,95,102,111,108,100,32,62,61,32,50,0,116,114,97,105,110,65,117,116,111,0,115,97,109,112,108,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,95,115,97,109,112,108,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,100,111,95,116,114,97,105,110,0,115,118,95,99,111,117,110,116,32,33,61,32,48,0,115,118,109,84,121,112,101,32,61,61,32,67,95,83,86,67,32,124,124,32,115,118,109,84,121,112,101,32,61,61,32,78,85,95,83,86,67,0,112,97,114,97,109,115,46,99,108,97,115,115,95,119,101,105,103,104,116,115,32,109,117,115,116,32,98,101,32,49,100,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,118,101,99,116,111,114,32,99,111,110,116,97,105,110,105,110,103,32,97,115,32,109,97,110,121,32,101,108,101,109,101,110,116,115,32,97,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,99,108,97,115,115,101,115,0,95,114,101,115,112,111,110,115,101,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,95,114,101,115,112,111,110,115,101,115,46,99,104,101,99,107,86,101,99,116,111,114,40,49,44,32,67,86,95,51,50,83,41,32,61,61,32,110,115,97,109,112,108,101,115,0,115,111,114,116,83,97,109,112,108,101,115,66,121,67,108,97,115,115,101,115,0,87,104,105,108,101,32,99,114,111,115,115,45,118,97,108,105,100,97,116,105,111,110,32,111,110,101,32,111,114,32,109,111,114,101,32,111,102,32,116,104,101,32,99,108,97,115,115,101,115,32,104,97,118,101,32,98,101,101,110,32,102,101,108,108,32,111,117,116,32,111,102,32,116,104,101,32,115,97,109,112,108,101,46,32,84,114,121,32,116,111,32,101,110,108,97,114,103,101,32,60,80,97,114,97,109,115,58,58,107,95,102,111,108,100,62,0,115,118,95,116,97,98,91,100,102,95,105,110,100,101,120,91,105,93,93,32,62,32,48,0,115,101,108,101,99,116,95,119,111,114,107,105,110,103,95,115,101,116,95,102,117,110,99,32,33,61,32,48,0,83,111,108,118,101,114,0,99,97,108,99,95,114,104,111,95,102,117,110,99,32,33,61,32,48,0,103,101,116,95,114,111,119,95,102,117,110,99,32,33,61,32,48,0,40,105,110,116,41,95,121,102,46,115,105,122,101,40,41,32,61,61,32,115,97,109,112,108,101,95,99,111,117,110,116,0,115,111,108,118,101,95,110,117,95,115,118,114,0,115,111,108,118,101,95,101,112,115,95,115,118,114,0,76,111,119,101,114,32,98,111,117,110,100,32,111,102,32,116,104,101,32,103,114,105,100,32,109,117,115,116,32,98,101,32,108,101,115,115,32,116,104,101,110,32,116,104,101,32,117,112,112,101,114,32,111,110,101,0,99,104,101,99,107,80,97,114,97,109,71,114,105,100,0,76,111,119,101,114,32,98,111,117,110,100,32,111,102,32,116,104,101,32,103,114,105,100,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,0,71,114,105,100,32,115,116,101,112,32,109,117,115,116,32,103,114,101,97,116,101,114,32,116,104,101,110,32,49,0,115,97,109,112,108,101,115,46,99,111,108,115,32,61,61,32,118,97,114,95,99,111,117,110,116,32,38,38,32,115,97,109,112,108,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,110,115,97,109,112,108,101,115,32,61,61,32,49,0,73,78,84,69,82,78,65,76,32,69,82,82,79,82,58,32,85,110,107,110,111,119,110,32,83,86,77,32,116,121,112,101,44,32,116,104,101,32,83,86,77,32,115,116,114,117,99,116,117,114,101,32,105,115,32,112,114,111,98,97,98,108,121,32,99,111,114,114,117,112,116,101,100,0,111,112,101,114,97,116,111,114,40,41,0,78,50,99,118,50,109,108,55,83,86,77,73,109,112,108,49,49,80,114,101,100,105,99,116,66,111,100,121,69,0,105,110,32,116,104,101,32,99,97,115,101,32,111,102,32,99,108,97,115,115,105,102,105,99,97,116,105,111,110,32,112,114,111,98,108,101,109,32,116,104,101,32,114,101,115,112,111,110,115,101,115,32,109,117,115,116,32,98,101,32,99,97,116,101,103,111,114,105,99,97,108,59,32,101,105,116,104,101,114,32,115,112,101,99,105,102,121,32,118,97,114,84,121,112,101,32,119,104,101,110,32,99,114,101,97,116,105,110,103,32,84,114,97,105,110,68,97,116,97,44,32,111,114,32,112,97,115,115,32,105,110,116,101,103,101,114,32,114,101,115,112,111,110,115,101,115,0,111,112,101,110,99,118,95,109,108,95,115,118,109,0,115,118,95,116,111,116,97,108,0,99,108,97,115,115,95,99,111,117,110,116,0,83,86,77,32,109,111,100,101,108,32,100,97,116,97,32,105,115,32,105,110,118,97,108,105,100,44,32,99,104,101,99,107,32,115,118,95,99,111,117,110,116,44,32,118,97,114,95,42,32,97,110,100,32,99,108,97,115,115,95,99,111,117,110,116,32,116,97,103,115,0,99,108,97,115,115,95,119,101,105,103,104,116,115,0,65,114,114,97,121,32,111,102,32,99,108,97,115,115,32,108,97,98,101,108,115,32,105,115,32,109,105,115,115,105,110,103,32,111,114,32,105,110,118,97,108,105,100,0,115,117,112,112,111,114,116,95,118,101,99,116,111,114,115,0,40,105,110,116,41,115,118,95,110,111,100,101,46,115,105,122,101,40,41,32,61,61,32,115,118,95,116,111,116,97,108,0,117,110,99,111,109,112,114,101,115,115,101,100,95,115,118,95,116,111,116,97,108,0,117,110,99,111,109,112,114,101,115,115,101,100,95,115,117,112,112,111,114,116,95,118,101,99,116,111,114,115,0,40,105,110,116,41,117,110,99,111,109,112,114,101,115,115,101,100,95,115,118,95,110,111,100,101,46,115,105,122,101,40,41,32,61,61,32,117,110,99,111,109,112,114,101,115,115,101,100,95,115,118,95,116,111,116,97,108,0,100,101,99,105,115,105,111,110,95,102,117,110,99,116,105,111,110,115,0,40,105,110,116,41,100,102,95,110,111,100,101,46,115,105,122,101,40,41,32,61,61,32,100,102,95,99,111,117,110,116,0,115,118,95,99,111,117,110,116,0,114,104,111,0,97,108,112,104,97,0,105,110,100,101,120,0,111,112,116,105,109,105,122,101,95,108,105,110,101,97,114,0,115,118,109,95,116,121,112,101,0,115,118,109,84,121,112,101,0,67,95,83,86,67,0,78,85,95,83,86,67,0,79,78,69,95,67,76,65,83,83,0,69,80,83,95,83,86,82,0,78,85,95,83,86,82,0,77,105,115,115,105,110,103,32,111,114,32,105,110,118,97,108,105,100,32,83,86,77,32,116,121,112,101,0,114,101,97,100,95,112,97,114,97,109,115,0,107,101,114,110,101,108,0,83,86,77,32,107,101,114,110,101,108,32,116,97,103,32,105,115,32,110,111,116,32,102,111,117,110,100,0,76,73,78,69,65,82,0,80,79,76,89,0,82,66,70,0,83,73,71,77,79,73,68,0,67,72,73,50,0,73,78,84,69,82,0,73,110,118,97,108,105,100,32,83,86,77,32,107,101,114,110,101,108,32,116,121,112,101,32,40,111,114,32,99,117,115,116,111,109,32,107,101,114,110,101,108,41,0,100,101,103,114,101,101,0,99,111,101,102,48,0,110,117,0,112,0,116,101,114,109,95,99,114,105,116,101,114,105,97,0,101,112,115,105,108,111,110,0,119,114,105,116,101,0,115,118,95,99,111,117,110,116,32,61,61,32,115,118,95,116,111,116,97,108,0,85,107,110,111,119,110,95,37,100,0,85,110,107,110,111,119,110,95,37,100,0,78,50,99,118,50,109,108,55,83,86,77,73,109,112,108,69,0,116,104,101,32,99,108,97,115,115,32,105,115,32,110,111,116,32,83,86,77,73,109,112,108,0,103,101,116,85,110,99,111,109,112,114,101,115,115,101,100,83,117,112,112,111,114,116,86,101,99,116,111,114,115,0,110,111,114,109,95,99,108,97,115,115,95,105,100,120,0,115,112,108,105,116,115,0,118,97,114,0,48,32,60,61,32,118,105,32,38,38,32,118,105,32,60,61,32,40,105,110,116,41,118,97,114,84,121,112,101,46,115,105,122,101,40,41,0,114,101,97,100,83,112,108,105,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,109,108,47,115,114,99,47,116,114,101,101,46,99,112,112,0,105,110,0,110,111,116,95,105,110,0,108,101,0,103,116,0,113,117,97,108,105,116,121,0,105,115,95,99,108,97,115,115,105,102,105,101,114,0,116,114,97,105,110,105,110,103,95,112,97,114,97,109,115,0,117,115,101,95,115,117,114,114,111,103,97,116,101,115,0,109,97,120,95,99,97,116,101,103,111,114,105,101,115,0,109,97,120,95,99,97,116,101,103,111,114,105,101,115,32,115,104,111,117,108,100,32,98,101,32,62,61,32,50,0,115,101,116,77,97,120,67,97,116,101,103,111,114,105,101,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,109,108,47,115,114,99,47,112,114,101,99,111,109,112,46,104,112,112,0,114,101,103,114,101,115,115,105,111,110,95,97,99,99,117,114,97,99,121,0,112,97,114,97,109,115,46,114,101,103,114,101,115,115,105,111,110,95,97,99,99,117,114,97,99,121,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,115,101,116,82,101,103,114,101,115,115,105,111,110,65,99,99,117,114,97,99,121,0,109,97,120,95,100,101,112,116,104,0,109,97,120,95,100,101,112,116,104,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,115,101,116,77,97,120,68,101,112,116,104,0,109,105,110,95,115,97,109,112,108,101,95,99,111,117,110,116,0,99,114,111,115,115,95,118,97,108,105,100,97,116,105,111,110,95,102,111,108,100,115,0,112,97,114,97,109,115,46,67,86,70,111,108,100,115,32,115,104,111,117,108,100,32,98,101,32,61,48,32,40,116,104,101,32,116,114,101,101,32,105,115,32,110,111,116,32,112,114,117,110,101,100,41,32,111,114,32,110,62,48,32,40,116,114,101,101,32,105,115,32,112,114,117,110,101,100,32,117,115,105,110,103,32,110,45,102,111,108,100,32,99,114,111,115,115,45,118,97,108,105,100,97,116,105,111,110,41,0,115,101,116,67,86,70,111,108,100,115,0,117,115,101,95,49,115,101,95,114,117,108,101,0,112,114,105,111,114,115,0,118,97,114,95,105,100,120,0,118,97,114,95,116,121,112,101,0,102,111,114,109,97,116,0,118,97,114,95,97,108,108,0,99,97,116,95,109,97,112,0,99,97,116,95,99,111,117,110,116,0,99,97,116,95,111,102,115,0,109,105,115,115,105,110,103,95,115,117,98,115,116,0,99,108,97,115,115,95,108,97,98,101,108,115,0,103,108,111,98,97,108,95,118,97,114,95,105,100,120,0,110,111,100,101,115,0,100,101,112,116,104,0,118,97,114,95,99,111,117,110,116,0,111,114,100,95,118,97,114,95,99,111,117,110,116,0,99,97,116,95,118,97,114,95,99,111,117,110,116,0,115,97,109,112,108,101,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,112,114,101,100,105,99,116,84,114,101,101,115,0,111,110,101,32,111,102,32,105,110,112,117,116,32,99,97,116,101,103,111,114,105,99,97,108,32,118,97,114,105,97,98,108,101,32,105,115,32,110,111,116,32,97,110,32,105,110,116,101,103,101,114,0,99,32,62,61,32,48,32,38,38,32,105,118,97,108,32,61,61,32,99,109,97,112,91,99,93,0,40,105,110,116,41,95,115,108,101,102,116,46,115,105,122,101,40,41,32,60,32,110,32,38,38,32,40,105,110,116,41,95,115,114,105,103,104,116,46,115,105,122,101,40,41,32,60,32,110,0,99,97,108,99,68,105,114,0,115,117,109,32,62,32,48,0,102,105,110,100,83,112,108,105,116,67,97,116,67,108,97,115,115,0,99,111,109,112,86,97,114,73,100,120,91,98,101,115,116,95,115,112,108,105,116,46,118,97,114,73,100,120,93,32,62,61,32,48,32,38,38,32,98,101,115,116,95,118,105,32,62,61,32,48,0,102,105,110,100,66,101,115,116,83,112,108,105,116,0,115,117,114,114,111,103,97,116,101,32,115,112,108,105,116,115,32,97,114,101,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,121,101,116,0,97,100,100,78,111,100,101,65,110,100,84,114,121,83,112,108,105,116,0,119,45,62,119,110,111,100,101,115,91,110,105,100,120,93,46,108,101,102,116,32,62,32,48,32,38,38,32,119,45,62,119,110,111,100,101,115,91,110,105,100,120,93,46,114,105,103,104,116,32,62,32,48,0,119,45,62,119,110,111,100,101,115,91,119,95,112,105,100,120,93,46,114,105,103,104,116,32,61,61,32,119,95,110,105,100,120,0,97,100,100,84,114,101,101,0,119,95,110,105,100,120,32,62,61,32,48,0,48,32,60,61,32,118,105,32,38,38,32,118,105,32,60,32,110,97,108,108,118,97,114,115,32,38,38,32,118,105,32,62,32,112,114,101,118,73,100,120,0,105,110,105,116,67,111,109,112,86,97,114,73,100,120,0,99,108,97,115,115,95,119,101,105,103,104,116,115,46,99,104,101,99,107,86,101,99,116,111,114,40,49,44,32,67,86,95,54,52,70,41,32,61,61,32,110,99,108,97,115,115,101,115,0,115,116,97,114,116,84,114,97,105,110,105,110,103,0,40,105,110,116,41,119,45,62,115,97,109,112,108,101,95,119,101,105,103,104,116,115,46,115,105,122,101,40,41,32,61,61,32,110,115,97,109,112,108,101,115,0,48,32,60,61,32,99,105,32,38,38,32,99,105,32,60,32,110,99,108,97,115,115,101,115,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,49,48,68,84,114,101,101,115,73,109,112,108,56,87,111,114,107,68,97,116,97,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,33,114,111,111,116,115,46,101,109,112,116,121,40,41,0,112,114,101,100,105,99,116,0,33,102,110,111,100,101,115,46,101,109,112,116,121,40,41,0,78,50,99,118,50,109,108,49,48,68,84,114,101,101,115,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,109,108,49,48,68,84,114,101,101,115,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,95,112,111,105,110,116,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,33,95,112,111,105,110,116,115,46,101,109,112,116,121,40,41,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,109,108,47,115,114,99,47,107,100,116,114,101,101,46,99,112,112,0,110,108,97,98,101,108,115,32,61,61,32,110,0,118,97,108,115,91,111,102,115,91,107,93,93,32,60,61,32,112,105,118,111,116,0,109,101,100,105,97,110,80,97,114,116,105,116,105,111,110,0,118,97,108,115,91,111,102,115,91,107,93,93,32,62,61,32,112,105,118,111,116,0,115,116,100,58,58,97,98,115,40,109,111,114,101,32,45,32,108,101,115,115,41,32,60,61,32,49,0,118,101,99,109,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,118,101,99,109,97,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,118,101,99,109,97,116,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,112,111,105,110,116,115,46,99,111,108,115,0,102,105,110,100,78,101,97,114,101,115,116,0,75,32,62,32,48,32,38,38,32,40,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,49,41,0,105,100,120,109,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,105,100,120,109,97,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,32,38,38,32,40,105,100,120,109,97,116,46,99,111,108,115,32,61,61,32,49,32,124,124,32,105,100,120,109,97,116,46,114,111,119,115,32,61,61,32,49,41,0,103,101,116,80,111,105,110,116,115,0,108,97,98,101,108,115,109,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,40,117,110,115,105,103,110,101,100,41,107,32,60,32,40,117,110,115,105,103,110,101,100,41,112,111,105,110,116,115,46,114,111,119,115,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,100,105,115,116,97,110,99,101,32,116,121,112,101,0,114,101,108,101,97,115,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,108,97,110,110,47,115],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+362740);allocate([114,99,47,109,105,110,105,102,108,97,110,110,46,99,112,112,0,114,98,0,82,101,97,100,105,110,103,32,70,76,65,78,78,32,105,110,100,101,120,32,101,114,114,111,114,58,32,116,104,101,32,115,97,118,101,100,32,100,97,116,97,32,115,105,122,101,32,40,37,100,44,32,37,100,41,32,111,114,32,116,121,112,101,32,40,37,100,41,32,105,115,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,116,104,101,32,112,97,115,115,101,100,32,111,110,101,32,40,37,100,44,32,37,100,41,44,32,37,100,10,0,67,97,110,110,111,116,32,114,101,97,100,32,102,114,111,109,32,102,105,108,101,0,82,101,97,100,105,110,103,32,70,76,65,78,78,32,105,110,100,101,120,32,101,114,114,111,114,58,32,117,110,115,117,112,112,111,114,116,101,100,32,102,101,97,116,117,114,101,32,116,121,112,101,32,37,100,32,102,111,114,32,116,104,101,32,105,110,100,101,120,32,116,121,112,101,32,37,100,10,0,82,101,97,100,105,110,103,32,70,76,65,78,78,32,105,110,100,101,120,32,101,114,114,111,114,58,32,117,110,115,117,112,112,111,114,116,101,100,32,100,105,115,116,97,110,99,101,32,116,121,112,101,32,37,100,10,0,68,97,116,97,84,121,112,101,60,69,108,101,109,101,110,116,84,121,112,101,62,58,58,116,121,112,101,32,61,61,32,100,97,116,97,46,116,121,112,101,40,41,32,38,38,32,100,97,116,97,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,108,111,97,100,73,110,100,101,120,95,0,97,108,103,111,114,105,116,104,109,0,85,110,107,110,111,119,110,32,105,110,100,101,120,32,116,121,112,101,0,116,97,98,108,101,95,110,117,109,98,101,114,0,109,117,108,116,105,95,112,114,111,98,101,95,108,101,118,101,108,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,50,98,97,100,95,97,110,121,95,99,97,115,116,69,0,76,83,72,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,102,111,114,32,116,104,97,116,32,116,121,112,101,0,73,32,99,97,110,32,111,110,108,121,32,115,101,97,114,99,104,32,111,110,101,32,102,101,97,116,117,114,101,32,97,116,32,97,32,116,105,109,101,32,102,111,114,32,114,97,110,103,101,32,115,101,97,114,99,104,10,0,115,111,114,116,101,100,0,78,55,99,118,102,108,97,110,110,49,53,85,110,105,113,117,101,82,101,115,117,108,116,83,101,116,73,102,69,69,0,78,55,99,118,102,108,97,110,110,57,82,101,115,117,108,116,83,101,116,73,102,69,69,0,78,55,99,118,102,108,97,110,110,50,49,82,97,100,105,117,115,85,110,105,113,117,101,82,101,115,117,108,116,83,101,116,73,102,69,69,0,78,55,99,118,102,108,97,110,110,49,56,75,78,78,85,110,105,113,117,101,82,101,115,117,108,116,83,101,116,73,102,69,69,0,78,55,99,118,102,108,97,110,110,56,76,115,104,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,55,78,78,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,98,114,97,110,99,104,105,110,103,0,99,101,110,116,101,114,115,95,105,110,105,116,0,108,101,97,102,95,115,105,122,101,0,85,110,107,110,111,119,110,32,97,108,103,111,114,105,116,104,109,32,102,111,114,32,99,104,111,111,115,105,110,103,32,105,110,105,116,105,97,108,32,99,101,110,116,101,114,115,46,0,99,104,101,99,107,115,0,70,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,46,10,0,66,114,97,110,99,104,105,110,103,32,102,97,99,116,111,114,32,109,117,115,116,32,98,101,32,97,116,32,108,101,97,115,116,32,50,0,78,55,99,118,102,108,97,110,110,50,55,72,105,101,114,97,114,99,104,105,99,97,108,67,108,117,115,116,101,114,105,110,103,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,116,97,114,103,101,116,95,112,114,101,99,105,115,105,111,110,0,98,117,105,108,100,95,119,101,105,103,104,116,0,109,101,109,111,114,121,95,119,101,105,103,104,116,0,115,97,109,112,108,101,95,102,114,97,99,116,105,111,110,0,101,112,115,0,77,105,115,115,105,110,103,32,112,97,114,97,109,101,116,101,114,32,39,0,39,32,105,110,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,32,103,105,118,101,110,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,108,97,110,110,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,102,108,97,110,110,47,103,101,110,101,114,97,108,46,104,0,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,10,0,65,117,116,111,116,117,110,101,100,32,112,97,114,97,109,101,116,101,114,115,58,10,0,83,101,97,114,99,104,32,112,97,114,97,109,101,116,101,114,115,58,10,0,67,111,109,112,117,116,105,110,103,32,103,114,111,117,110,100,32,116,114,117,116,104,10,0,69,115,116,105,109,97,116,105,110,103,32,110,117,109,98,101,114,32,111,102,32,99,104,101,99,107,115,10,0,75,77,101,97,110,115,32,97,108,103,111,114,105,116,104,109,44,32,101,115,116,105,109,97,116,105,110,103,32,99,108,117,115,116,101,114,32,98,111,114,100,101,114,32,102,97,99,116,111,114,10,0,79,112,116,105,109,117,109,32,99,98,95,105,110,100,101,120,58,32,37,103,10,0,82,101,113,117,105,114,101,100,32,110,117,109,98,101,114,32,111,102,32,99,104,101,99,107,115,58,32,37,100,32,10,0,32,32,78,111,100,101,115,32,32,80,114,101,99,105,115,105,111,110,40,37,41,32,32,32,84,105,109,101,40,115,41,32,32,32,84,105,109,101,47,118,101,99,40,109,115,41,32,32,77,101,97,110,32,100,105,115,116,10,0,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,10,0,71,111,116,32,97,115,32,99,108,111,115,101,32,97,115,32,73,32,99,97,110,10,0,83,116,97,114,116,32,108,105,110,101,97,114,32,101,115,116,105,109,97,116,105,111,110,10,0,78,111,32,110,101,101,100,32,102,111,114,32,108,105,110,101,97,114,32,101,115,116,105,109,97,116,105,111,110,10,0,109,97,116,99,104,101,115,46,99,111,108,115,61,37,100,44,32,110,110,61,37,100,10,0,71,114,111,117,110,100,32,116,114,117,116,104,32,105,115,32,110,111,116,32,99,111,109,112,117,116,101,100,32,102,111,114,32,97,115,32,109,97,110,121,32,110,101,105,103,104,98,111,114,115,32,97,115,32,114,101,113,117,101,115,116,101,100,0,37,56,100,32,37,49,48,46,52,103,32,37,49,48,46,53,103,32,37,49,48,46,53,103,32,37,49,48,46,53,103,10,0,78,55,99,118,102,108,97,110,110,49,50,75,78,78,82,101,115,117,108,116,83,101,116,73,102,69,69,0,32,58,32,0,69,110,116,101,114,105,110,103,32,97,117,116,111,116,117,110,105,110,103,44,32,100,97,116,97,115,101,116,32,115,105,122,101,58,32,37,100,44,32,115,97,109,112,108,101,83,105,122,101,58,32,37,100,44,32,116,101,115,116,83,97,109,112,108,101,83,105,122,101,58,32,37,100,44,32,116,97,114,103,101,116,32,112,114,101,99,105,115,105,111,110,58,32,37,103,10,0,67,104,111,111,115,105,110,103,32,108,105,110,101,97,114,44,32,100,97,116,97,115,101,116,32,116,111,111,32,115,109,97,108,108,10,0,67,111,109,112,117,116,105,110,103,32,103,114,111,117,110,100,32,116,114,117,116,104,46,46,46,32,10,0,65,117,116,111,116,117,110,105,110,103,32,112,97,114,97,109,101,116,101,114,115,46,46,46,10,0,75,68,45,84,82,69,69,44,32,83,116,101,112,32,49,58,32,69,120,112,108,111,114,105,110,103,32,112,97,114,97,109,101,116,101,114,32,115,112,97,99,101,10,0,75,68,84,114,101,101,32,117,115,105,110,103,32,112,97,114,97,109,115,58,32,116,114,101,101,115,61,37,100,10,0,75,68,84,114,101,101,32,98,117,105,108,100,84,105,109,101,61,37,103,44,32,115,101,97,114,99,104,84,105,109,101,61,37,103,10,0,73,116,32,100,111,101,115,110,39,116,32,109,97,107,101,32,97,110,121,32,115,101,110,115,101,32,116,111,32,117,115,101,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,116,114,101,101,32,102,111,114,32,101,120,97,99,116,32,115,101,97,114,99,104,0,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,75,77,69,65,78,83,44,32,83,116,101,112,32,49,58,32,69,120,112,108,111,114,105,110,103,32,112,97,114,97,109,101,116,101,114,32,115,112,97,99,101,10,0,105,116,101,114,97,116,105,111,110,115,0,75,77,101,97,110,115,84,114,101,101,32,117,115,105,110,103,32,112,97,114,97,109,115,58,32,109,97,120,95,105,116,101,114,97,116,105,111,110,115,61,37,100,44,32,98,114,97,110,99,104,105,110,103,61,37,100,10,0,75,77,101,97,110,115,84,114,101,101,32,98,117,105,108,100,84,105,109,101,61,37,103,44,32,115,101,97,114,99,104,84,105,109,101,61,37,103,44,32,98,117,105,108,100,95,119,101,105,103,104,116,61,37,103,10,0,78,55,99,118,102,108,97,110,110,49,49,75,77,101,97,110,115,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,75,77,101,97,110,115,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,50,50,75,77,101,97,110,115,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,69,0,78,55,99,118,102,108,97,110,110,49,52,65,117,116,111,116,117,110,101,100,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,66,117,105,108,100,105,110,103,32,107,109,101,97,110,115,32,116,114,101,101,46,46,46,10,0,66,117,105,108,100,105,110,103,32,107,100,116,114,101,101,32,116,114,101,101,46,46,46,10,0,78,55,99,118,102,108,97,110,110,49,52,67,111,109,112,111,115,105,116,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,100,105,109,0,108,101,97,102,95,109,97,120,95,115,105,122,101,0,114,101,111,114,100,101,114,0,78,55,99,118,102,108,97,110,110,49,56,75,78,78,83,105,109,112,108,101,82,101,115,117,108,116,83,101,116,73,102,69,69,0,78,55,99,118,102,108,97,110,110,49,55,75,68,84,114,101,101,83,105,110,103,108,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,76,105,110,101,97,114,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,68,97,116,97,116,121,112,101,32,111,102,32,115,97,118,101,100,32,105,110,100,101,120,32,105,115,32,100,105,102,102,101,114,101,110,116,32,116,104,97,110,32,111,102,32,116,104,101,32,111,110,101,32,116,111,32,98,101,32,99,114,101,97,116,101,100,46,0,84,104,101,32,105,110,100,101,120,32,115,97,118,101,100,32,98,101,108,111,110,103,115,32,116,111,32,97,32,100,105,102,102,101,114,101,110,116,32,100,97,116,97,115,101,116,0,78,55,99,118,102,108,97,110,110,53,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,56,76,115,104,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,55,78,78,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,50,55,72,105,101,114,97,114,99,104,105,99,97,108,67,108,117,115,116,101,114,105,110,103,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,75,77,101,97,110,115,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,75,77,101,97,110,115,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,50,50,75,77,101,97,110,115,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,69,0,78,55,99,118,102,108,97,110,110,49,52,65,117,116,111,116,117,110,101,100,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,52,67,111,109,112,111,115,105,116,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,55,75,68,84,114,101,101,83,105,110,103,108,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,76,105,110,101,97,114,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,53,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8,78,55,99,118,102,108,97,110,110,49,53,85,110,105,113,117,101,82,101,115,117,108,116,83,101,116,73,105,69,69,0,78,55,99,118,102,108,97,110,110,57,82,101,115,117,108,116,83,101,116,73,105,69,69,0,78,55,99,118,102,108,97,110,110,50,49,82,97,100,105,117,115,85,110,105,113,117,101,82,101,115,117,108,116,83,101,116,73,105,69,69,0,78,55,99,118,102,108,97,110,110,49,56,75,78,78,85,110,105,113,117,101,82,101,115,117,108,116,83,101,116,73,105,69,69,0,73,110,118,97,108,105,100,32,107,101,121,95,115,105,122,101,32,40,61,37,100,41,46,32,86,97,108,105,100,32,118,97,108,117,101,115,32,102,111,114,32,121,111,117,114,32,115,121,115,116,101,109,32,97,114,101,32,37,100,32,60,61,32,107,101,121,95,115,105,122,101,32,60,32,37,100,46,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,108,97,110,110,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,102,108,97,110,110,47,108,115,104,95,116,97,98,108,101,46,104,0,78,55,99,118,102,108,97,110,110,56,76,115,104,73,110,100,101,120,73,78,83,95,49,48,72,97,109,109,105,110,103,76,85,84,69,69,69,0,78,55,99,118,102,108,97,110,110,55,78,78,73,110,100,101,120,73,78,83,95,49,48,72,97,109,109,105,110,103,76,85,84,69,69,69,0,78,55,99,118,102,108,97,110,110,50,55,72,105,101,114,97,114,99,104,105,99,97,108,67,108,117,115,116,101,114,105,110,103,73,110,100,101,120,73,78,83,95,49,48,72,97,109,109,105,110,103,76,85,84,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,76,105,110,101,97,114,73,110,100,101,120,73,78,83,95,49,48,72,97,109,109,105,110,103,76,85,84,69,69,69,0,78,55,99,118,102,108,97,110,110,53,73,110,100,101,120,73,78,83,95,49,48,72,97,109,109,105,110,103,76,85,84,69,69,69,0,78,55,99,118,102,108,97,110,110,49,52,70,76,65,78,78,69,120,99,101,112,116,105,111,110,69,0,73,110,118,97,108,105,100,32,105,110,100,101,120,32,102,105,108,101,44,32,99,97,110,110,111,116,32,114,101,97,100,0,70,76,65,78,78,95,73,78,68,69,88,0,73,110,118,97,108,105,100,32,105,110,100,101,120,32,102,105,108,101,44,32,119,114,111,110,103,32,115,105,103,110,97,116,117,114,101,0,119,98,0,67,97,110,32,110,111,116,32,111,112,101,110,32,102,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,32,70,76,65,78,78,32,105,110,100,101,120,10,0,115,97,118,101,0,49,46,54,46,49,48,0,109,97,120,82,101,115,117,108,116,115,32,62,32,48,0,114,97,100,105,117,115,83,101,97,114,99,104,0,76,83,72,32,105,110,100,101,120,32,100,111,101,115,32,110,111,116,32,115,117,112,112,111,114,116,32,114,97,100,105,117,115,83,101,97,114,99,104,32,111,112,101,114,97,116,105,111,110,0,113,117,101,114,121,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,32,38,38,32,105,110,100,105,99,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,32,38,38,32,100,105,115,116,115,46,116,121,112,101,40,41,32,61,61,32,100,116,121,112,101,0,114,117,110,82,97,100,105,117,115,83,101,97,114,99,104,95,0,113,117,101,114,121,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,105,110,100,105,99,101,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,100,105,115,116,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,107,110,110,83,101,97,114,99,104,0,114,117,110,75,110,110,83,101,97,114,99,104,95,0,98,117,105,108,100,0,116,121,112,101,61,37,100,10,0,98,117,105,108,100,73,110,100,101,120,95,0,79,110,108,121,32,99,111,110,116,105,110,117,111,117,115,32,97,114,114,97,121,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,0,78,50,99,118,53,102,108,97,110,110,53,73,110,100,101,120,69,0,80,80,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,52,78,111,100,101,69,0,80,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,52,78,111,100,101,69,0,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,52,78,111,100,101,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,80,80,78,83,95,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,52,78,111,100,101,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,80,80,78,83,95,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,52,78,111,100,101,69,69,69,0,80,80,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,52,78,111,100,101,69,0,80,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,52,78,111,100,101,69,0,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,52,78,111,100,101,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,80,80,78,83,95,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,52,78,111,100,101,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,80,80,78,83,95,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,52,78,111,100,101,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,52,98,105,103,95,97,110,121,95,112,111,108,105,99,121,73,100,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,54,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,57,83,99,97,108,101,68,97,116,97,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,49,54,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,69,0,115,113,115,117,109,46,117,32,61,61,32,117,32,38,38,32,115,113,115,117,109,46,115,105,122,101,40,41,32,61,61,32,115,46,115,122,105,32,38,38,32,115,113,115,117,109,46,116,121,112,101,40,41,61,61,67,86,95,51,50,83,0,99,111,109,112,117,116,101,67,104,97,110,110,101,108,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,99,97,115,99,97,100,101,100,101,116,101,99,116,46,99,112,112,0,48,32,60,61,32,115,99,97,108,101,73,100,120,32,38,38,32,115,99,97,108,101,73,100,120,32,60,32,40,105,110,116,41,115,99,97,108,101,68,97,116,97,45,62,115,105,122,101,40,41,0,103,101,116,83,99,97,108,101,68,97,116,97,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,99,97,115,99,97,100,101,100,101,116,101,99,116,46,104,112,112,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,110,32,62,32,48,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,49,48,79,112,116,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,55,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,69,0,115,101,116,87,105,110,100,111,119,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,76,66,80,69,118,97,108,117,97,116,111,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,50,76,66,80,69,118,97,108,117,97,116,111,114,49,48,79,112,116,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,50,76,66,80,69,118,97,108,117,97,116,111,114,55,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,114,101,99,116,0,78,50,99,118,49,50,76,66,80,69,118,97,108,117,97,116,111,114,69,0,115,99,97,108,101,70,97,99,116,111,114,32,62,32,49,32,38,38,32,95,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,0,110,111,100,101,115,91,114,111,111,116,93,91,80,65,82,69,78,84,93,32,60,32,48,0,112,97,114,116,105,116,105,111,110,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,111,112,101,114,97,116,105,111,110,115,46,104,112,112,0,33,99,97,115,99,97,100,101,46,100,97,116,97,46,115,116,117,109,112,115,46,101,109,112,116,121,40,41,0,112,114,101,100,105,99,116,67,97,116,101,103,111,114,105,99,97,108,83,116,117,109,112,0,112,114,101,100,105,99,116,79,114,100,101,114,101,100,83,116,117,109,112,0,78,50,99,118,50,52,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,110,118,111,107,101,114,69,0,33,95,115,101,113,32,124,124,32,95,115,101,113,45,62,101,108,101,109,95,115,105,122,101,32,61,61,32,115,105,122,101,111,102,40,95,84,112,41,0,83,101,113,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,99,111,114,101,95,99,46,104,0,115,99,97,108,101,70,97,99,116,111,114,32,62,32,49,32,38,38,32,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,50,51,67,118,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,102,101,97,116,117,114,101,115,0,72,65,65,82,0,76,66,80,0,72,79,71,0,72,79,71,32,99,97,115,99,97,100,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,51,46,48,0,111,114,105,103,87,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,111,114,105,103,87,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,48,0,78,50,99,118,50,49,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,69,0,78,50,99,118,50,49,66,97,115,101,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,97,45,62,115,105,122,101,40,41,32,61,61,32,110,0,99,108,105,112,79,98,106,101,99,116,115,0,98,45,62,115,105,122,101,40,41,32,61,61,32,110,0,105,115,79,108,100,70,111,114,109,97,116,67,97,115,99,97,100,101,0,103,101,116,79,114,105,103,105,110,97,108,87,105,110,100,111,119,83,105,122,101,0,103,101,116,70,101,97,116,117,114,101,84,121,112,101,0,99,97,115,99,97,100,101,0,123,58,111,112,101,110,99,118,45,99,97,115,99,97,100,101,45,99,108,97,115,115,105,102,105,101,114,0,115,116,97,103,101,84,121,112,101,0,66,79,79,83,84,0,102,101,97,116,117,114,101,84,121,112,101,0,104,101,105,103,104,116,0,119,105,100,116,104,0,115,116,97,103,101,80,97,114,97,109,115,0,109,97,120,87,101,97,107,67,111,117,110,116,0,102,101,97,116,117,114,101,80,97,114,97,109,115,0,109,97,120,67,97,116,67,111,117,110,116,0,115,116,97,103,101,84,104,114,101,115,104,111,108,100,0,119,101,97,107,67,108,97,115,115,105,102,105,101,114,115,0,105,110,116,101,114,110,97,108,78,111,100,101,115,0,108,101,97,102,86,97,108,117,101,115,0,111,112,101,110,99,118,45,104,97,97,114,45,99,108,97,115,115,105,102,105,101,114,0,78,117,109,98,101,114,32,111,102,32,115,116,97,103,101,115,32,115,104,111,117,108,100,32,98,101,32,112,111,115,105,116,105,118,101,0,105,99,118,67,114,101,97,116,101,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,104,97,97,114,46,99,112,112,0,115,105,122,101,0,115,116,97,103,101,115,0,115,116,97,103,101,32,37,100,0,116,114,101,101,115,0,116,114,101,101,32,37,100,0,110,111,100,101,32,37,100,0,114,111,111,116,32,110,111,100,101,0,102,101,97,116,117,114,101,0,114,101,99,116,115,0,116,105,108,116,101,100,0,108,101,102,116,95,110,111,100,101,0,108,101,102,116,95,118,97,108,0,114,105,103,104,116,95,110,111,100,101,0,114,105,103,104,116,95,118,97,108,0,115,116,97,103,101,95,116,104,114,101,115,104,111,108,100,0,112,97,114,101,110,116,0,110,101,120,116,0,73,110,118,97,108,105,100,32,115,116,97,103,101,115,32,110,111,100,101,0,105,99,118,82,101,97,100,72,97,97,114,67,108,97,115,115,105,102,105,101,114,0,115,105,122,101,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,0,73,110,118,97,108,105,100,32,115,105,122,101,32,110,111,100,101,58,32,119,105,100,116,104,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,0,73,110,118,97,108,105,100,32,115,105,122,101,32,110,111,100,101,58,32,104,101,105,103,104,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,0,73,110,118,97,108,105,100,32,115,116,97,103,101,32,37,100,0,84,114,101,101,115,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,41,0,84,114,101,101,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,41,0,84,114,101,101,32,110,111,100,101,32,37,100,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,112,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,41,0,70,101,97,116,117,114,101,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,112,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,82,101,99,116,115,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,82,101,99,116,32,37,100,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,120,32,99,111,111,114,100,105,110,97,116,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,121,32,99,111,111,114,100,105,110,97,116,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,119,105,100,116,104,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,32,97,110,100,32,40,120,32,43,32,119,105,100,116,104,41,32,109,117,115,116,32,110,111,116,32,101,120,99,101,101,100,32,119,105,110,100,111,119,32,119,105,100,116,104,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,104,101,105,103,104,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,32,97,110,100,32,40,121,32,43,32,104,101,105,103,104,116,41,32,109,117,115,116,32,110,111,116,32,101,120,99,101,101,100,32,119,105,110,100,111,119,32,104,101,105,103,104,116,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,119,101,105,103,104,116,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,116,105,108,116,101,100,32,109,117,115,116,32,98,101,32,48,32,111,114,32,49,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,108,101,102,116,32,110,111,100,101,32,109,117,115,116,32,98,101,32,118,97,108,105,100,32,110,111,100,101,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,108,101,102,116,32,110,111,100,101,32,111,114,32,108,101,102,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,108,101,102,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,84,114,101,101,32,115,116,114,117,99,116,117,114,101,32,105,115,32,98,114,111,107,101,110,58,32,116,111,111,32,109,97,110,121,32,118,97,108,117,101,115,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,114,105,103,104,116,32,110,111,100,101,32,109,117,115,116,32,98,101,32,118,97,108,105,100,32,110,111,100,101,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,114,105,103,104,116,32,110,111,100,101,32,111,114,32,114,105,103,104,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,114,105,103,104,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,84,114,101,101,32,115,116,114,117,99,116,117,114,101,32,105,115,32,98,114,111,107,101,110,58,32,116,111,111,32,102,101,119,32,118,97,108,117,101,115,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,41,0,115,116,97,103,101,32,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,41,0,112,97,114,101,110,116,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,41,0,110,101,120,116,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,41,0,73,110,118,97,108,105,100,32,99,108,97,115,115,105,102,105,101,114,32,112,111,105,110,116,101,114,0,99,118,83,101,116,73,109,97,103,101,115,70,111,114,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,83,99,97,108,101,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,0,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,108,108,32,105,110,116,101,103,114,97,108,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,0,79,110,108,121,32,40,51,50,115,44,32,54,52,102,44,32,51,50,115,41,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,40,115,117,109,44,115,113,115,117,109,44,116,105,108,116,101,100,95,115,117,109,41,32,102,111,114,109,97,116,115,32,105,115,32,97,108,108,111,119,101,100,0,83,117,109,32,97,110,100,32,116,105,108,116,101,100,95,115,117,109,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,116,114,105,100,101,32,40,115,116,101,112,44,32,119,105,100,116,104,83,116,101,112,41,0,105,99,118,67,114,101,97,116,101,72,105,100,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,104,105,100,95,99,97,115,99,97,100,101,32,104,97,115,32,98,101,101,110,32,97,108,114,101,97,100,121,32,99,114,101,97,116,101,100,0,78,101,103,97,116,105,118,101,32,110,117,109,98,101,114,32,111,102,32,99,97,115,99,97,100,101,32,115,116,97,103,101,115,0,104,101,97,100,101,114,32,111,102,32,116,104,101,32,115,116,97,103,101,32,99,108,97,115,115,105,102,105,101,114,32,35,37,100,32,105,115,32,105,110,118,97,108,105,100,32,40,104,97,115,32,110,117,108,108,32,112,111,105,110,116,101,114,115,32,111,114,32,110,111,110,45,112,111,115,105,116,105,118,101,32,99,108,97,115,115,102,105,101,114,32,99,111,117,110,116,41,0,114,101,99,116,97,110,103,108,101,32,35,37,100,32,111,102,32,116,104,101,32,99,108,97,115,115,105,102,105,101,114,32,35,37,100,32,111,102,32,116,104,101,32,115,116,97,103,101,32,99,108,97,115,115,105,102,105,101,114,32,35,37,100,32,105,115,32,110,111,116,32,105,110,115,105,100,101,32,116,104,101,32,114,101,102,101,114,101,110,99,101,32,40,111,114,105,103,105,110,97,108,41,32,99,97,115,99,97,100,101,32,119,105,110,100,111,119,0,73,110,118,97,108,105,100,32,99,97,115,99,97,100,101,32,112,111,105,110,116,101,114,0,99,118,82,117,110,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,83,117,109,0,72,105,100,100,101,110,32,99,97,115,99,97,100,101,32,104,97,115,32,110,111,116,32,98,101,101,110,32,99,114,101,97,116,101,100,46,10,85,115,101,32,99,118,83,101,116,73,109,97,103,101,115,70,111,114,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,73,110,118,97,108,105,100,32,99,108,97,115,115,105,102,105,101,114,32,99,97,115,99,97,100,101,0,99,118,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,70,111,114,82,79,67],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+372980);allocate([0,78,117,108,108,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,79,110,108,121,32,56,45,98,105,116,32,105,109,97,103,101,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,0,115,99,97,108,101,32,102,97,99,116,111,114,32,109,117,115,116,32,98,101,32,62,32,49,0,78,50,99,118,51,56,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,95,83,99,97,108,101,67,97,115,99,97,100,101,95,73,110,118,111,107,101,114,69,0,78,50,99,118,51,54,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,95,83,99,97,108,101,73,109,97,103,101,95,73,110,118,111,107,101,114,69,0,78,50,99,118,56,72,79,71,67,97,99,104,101,69,0,78,50,99,118,49,52,72,79,71,67,111,110,102,73,110,118,111,107,101,114,69,0,112,116,46,120,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,112,116,46,121,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,103,101,116,66,108,111,99,107,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,104,111,103,46,99,112,112,0,98,108,111,99,107,83,105,122,101,46,119,105,100,116,104,32,37,32,99,101,108,108,83,105,122,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,98,108,111,99,107,83,105,122,101,46,104,101,105,103,104,116,32,37,32,99,101,108,108,83,105,122,101,46,104,101,105,103,104,116,32,61,61,32,48,0,103,101,116,68,101,115,99,114,105,112,116,111,114,83,105,122,101,0,40,119,105,110,83,105,122,101,46,119,105,100,116,104,32,45,32,98,108,111,99,107,83,105,122,101,46,119,105,100,116,104,41,32,37,32,98,108,111,99,107,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,40,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,45,32,98,108,111,99,107,83,105,122,101,46,104,101,105,103,104,116,41,32,37,32,98,108,111,99,107,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,32,124,124,32,105,109,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,51,0,99,111,109,112,117,116,101,71,114,97,100,105,101,110,116,0,40,117,110,115,105,103,110,101,100,41,104,105,100,120,32,60,32,40,117,110,115,105,103,110,101,100,41,110,98,105,110,115,0,114,101,99,116,76,105,115,116,46,115,105,122,101,40,41,32,61,61,32,119,101,105,103,104,116,115,46,115,105,122,101,40,41,0,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,0,78,50,99,118,49,48,72,79,71,73,110,118,111,107,101,114,69,0,112,116,48,46,120,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,112,116,48,46,121,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,123,111,112,101,110,99,118,45,111,98,106,101,99,116,45,100,101,116,101,99,116,111,114,45,104,111,103,0,119,105,110,83,105,122,101,0,98,108,111,99,107,83,105,122,101,0,98,108,111,99,107,83,116,114,105,100,101,0,110,98,105,110,115,0,100,101,114,105,118,65,112,101,114,116,117,114,101,0,104,105,115,116,111,103,114,97,109,78,111,114,109,84,121,112,101,0,76,50,72,121,115,84,104,114,101,115,104,111,108,100,0,103,97,109,109,97,67,111,114,114,101,99,116,105,111,110,0,110,108,101,118,101,108,115,0,115,105,103,110,101,100,71,114,97,100,105,101,110,116,0,83,86,77,68,101,116,101,99,116,111,114,0,99,101,108,108,83,105,122,101,0,119,105,110,83,105,103,109,97,0,99,104,101,99,107,68,101,116,101,99,116,111,114,83,105,122,101,40,41,0,115,101,116,83,86,77,68,101,116,101,99,116,111,114,0,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,111,112,101,110,99,118,45,111,98,106,101,99,116,45,100,101,116,101,99,116,111,114,45,104,111,103,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,53,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,50,53,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,0,109,97,107,101,65,103,97,115,116,79,102,102,115,101,116,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,97,103,97,115,116,95,115,99,111,114,101,46,99,112,112,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,65,75,65,90,69,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,97,107,97,122,101,46,99,112,112,0,100,101,115,99,114,105,112,116,111,114,0,100,101,115,99,114,105,112,116,111,114,95,99,104,97,110,110,101,108,115,0,100,101,115,99,114,105,112,116,111,114,95,115,105,122,101,0,78,50,99,118,49,48,65,75,65,90,69,95,73,109,112,108,69,0,78,50,99,118,49,48,66,79,87,84,114,97,105,110,101,114,69,0,33,100,101,115,99,114,105,112,116,111,114,115,46,101,109,112,116,121,40,41,0,99,108,117,115,116,101,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,98,97,103,111,102,119,111,114,100,115,46,99,112,112,0,78,50,99,118,49,54,66,79,87,75,77,101,97,110,115,84,114,97,105,110,101,114,69,0,78,50,99,118,50,53,66,79,87,73,109,103,68,101,115,99,114,105,112,116,111,114,69,120,116,114,97,99,116,111,114,69,0,33,95,100,101,115,99,114,105,112,116,111,114,115,46,101,109,112,116,121,40,41,0,100,101,115,99,114,105,112,116,111,114,115,91,48,93,46,99,111,108,115,32,61,61,32,95,100,101,115,99,114,105,112,116,111,114,115,46,99,111,108,115,0,100,101,115,99,114,105,112,116,111,114,115,91,48,93,46,116,121,112,101,40,41,32,61,61,32,95,100,101,115,99,114,105,112,116,111,114,115,46,116,121,112,101,40,41,0,33,118,111,99,97,98,117,108,97,114,121,46,101,109,112,116,121,40,41,0,113,117,101,114,121,73,100,120,32,61,61,32,40,105,110,116,41,105,0,66,108,111,98,32,100,101,116,101,99,116,111,114,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,56,45,98,105,116,32,105,109,97,103,101,115,33,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,98,108,111,98,100,101,116,101,99,116,111,114,46,99,112,112,0,116,104,114,101,115,104,111,108,100,83,116,101,112,0,109,105,110,84,104,114,101,115,104,111,108,100,0,109,97,120,84,104,114,101,115,104,111,108,100,0,109,105,110,82,101,112,101,97,116,97,98,105,108,105,116,121,0,109,105,110,68,105,115,116,66,101,116,119,101,101,110,66,108,111,98,115,0,102,105,108,116,101,114,66,121,67,111,108,111,114,0,98,108,111,98,67,111,108,111,114,0,102,105,108,116,101,114,66,121,65,114,101,97,0,109,105,110,65,114,101,97,0,109,97,120,65,114,101,97,0,102,105,108,116,101,114,66,121,67,105,114,99,117,108,97,114,105,116,121,0,109,105,110,67,105,114,99,117,108,97,114,105,116,121,0,109,97,120,67,105,114,99,117,108,97,114,105,116,121,0,102,105,108,116,101,114,66,121,73,110,101,114,116,105,97,0,109,105,110,73,110,101,114,116,105,97,82,97,116,105,111,0,109,97,120,73,110,101,114,116,105,97,82,97,116,105,111,0,102,105,108,116,101,114,66,121,67,111,110,118,101,120,105,116,121,0,109,105,110,67,111,110,118,101,120,105,116,121,0,109,97,120,67,111,110,118,101,120,105,116,121,0,78,50,99,118,50,50,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,50,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,108,97,121,101,114,32,43,32,49,32,60,32,108,97,121,101,114,115,95,0,103,101,116,83,99,111,114,101,77,97,120,65,98,111,118,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,98,114,105,115,107,46,99,112,112,0,108,97,121,101,114,32,62,32,48,0,103,101,116,83,99,111,114,101,77,97,120,66,101,108,111,119,0,40,115,114,99,105,109,103,46,99,111,108,115,32,47,32,51,41,32,42,32,50,32,61,61,32,100,115,116,105,109,103,46,99,111,108,115,0,116,119,111,116,104,105,114,100,115,97,109,112,108,101,0,40,115,114,99,105,109,103,46,114,111,119,115,32,47,32,51,41,32,42,32,50,32,61,61,32,100,115,116,105,109,103,46,114,111,119,115,0,115,114,99,105,109,103,46,99,111,108,115,32,47,32,50,32,61,61,32,100,115,116,105,109,103,46,99,111,108,115,0,104,97,108,102,115,97,109,112,108,101,0,115,114,99,105,109,103,46,114,111,119,115,32,47,32,50,32,61,61,32,100,115,116,105,109,103,46,114,111,119,115,0,78,50,99,118,49,48,66,82,73,83,75,95,73,109,112,108,69,0,114,97,100,105,117,115,76,105,115,116,46,115,105,122,101,40,41,32,33,61,32,48,32,38,38,32,114,97,100,105,117,115,76,105,115,116,46,115,105,122,101,40,41,32,61,61,32,110,117,109,98,101,114,76,105,115,116,46,115,105,122,101,40,41,0,103,101,110,101,114,97,116,101,75,101,114,110,101,108,0,110,111,83,104,111,114,116,80,97,105,114,115,95,32,60,32,105,110,100,83,105,122,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,66,82,73,83,75,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,73,110,99,111,114,114,101,99,116,32,116,121,112,101,32,111,102,32,105,110,112,117,116,32,105,109,97,103,101,46,10,0,100,114,97,119,75,101,121,112,111,105,110,116,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,100,114,97,119,46,99,112,112,0,33,111,117,116,73,109,97,103,101,46,101,109,112,116,121,40,41,0,33,105,109,103,46,101,109,112,116,121,40,41,0,95,100,114,97,119,75,101,121,112,111,105,110,116,0,109,97,116,99,104,101,115,77,97,115,107,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,115,32,109,97,116,99,104,101,115,49,116,111,50,0,100,114,97,119,77,97,116,99,104,101,115,0,105,49,32,62,61,32,48,32,38,38,32,105,49,32,60,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,107,101,121,112,111,105,110,116,115,49,46,115,105,122,101,40,41,41,0,105,50,32,62,61,32,48,32,38,38,32,105,50,32,60,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,107,101,121,112,111,105,110,116,115,50,46,115,105,122,101,40,41,41,0,111,117,116,73,109,103,32,104,97,115,32,115,105,122,101,32,108,101,115,115,32,116,104,97,110,32,110,101,101,100,32,116,111,32,100,114,97,119,32,105,109,103,49,32,97,110,100,32,105,109,103,50,32,116,111,103,101,116,104,101,114,0,95,112,114,101,112,97,114,101,73,109,103,65,110,100,68,114,97,119,75,101,121,112,111,105,110,116,115,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,52,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,50,52,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,0,112,105,120,101,108,32,38,38,32,111,102,102,115,101,116,115,0,109,97,107,101,79,102,102,115,101,116,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,102,97,115,116,95,115,99,111,114,101,46,99,112,112,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,102,101,97,116,117,114,101,50,100,46,99,112,112,0,107,101,121,112,111,105,110,116,115,46,115,105,122,101,40,41,32,61,61,32,110,105,109,97,103,101,115,0,99,111,109,112,117,116,101,0,95,100,101,115,99,114,105,112,116,111,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,77,65,84,0,109,97,115,107,115,46,115,105,122,101,40,41,32,61,61,32,110,105,109,97,103,101,115,0,100,101,116,101,99,116,0,78,50,99,118,57,70,101,97,116,117,114,101,50,68,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,71,70,84,84,68,101,116,101,99,116,111,114,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,49,55,71,70,84,84,68,101,116,101,99,116,111,114,95,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,75,65,90,69,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,33,32,105,109,103,49,95,51,50,46,101,109,112,116,121,40,41,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,107,97,122,101,46,99,112,112,0,40,33,100,101,115,99,46,114,111,119,115,32,124,124,32,100,101,115,99,46,99,111,108,115,32,61,61,32,100,101,115,99,114,105,112,116,111,114,83,105,122,101,40,41,41,0,40,33,100,101,115,99,46,114,111,119,115,32,124,124,32,40,100,101,115,99,46,116,121,112,101,40,41,32,61,61,32,100,101,115,99,114,105,112,116,111,114,84,121,112,101,40,41,41,41,0,101,120,116,101,110,100,101,100,0,117,112,114,105,103,104,116,0,111,99,116,97,118,101,115,0,115,117,98,108,101,118,101,108,115,0,100,105,102,102,117,115,105,118,105,116,121,0,78,50,99,118,57,75,65,90,69,95,73,109,112,108,69,0,110,98,105,116,115,32,60,61,32,115,115,122,0,103,101,110,101,114,97,116,101,68,101,115,99,114,105,112,116,111,114,83,117,98,115,97,109,112,108,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,107,97,122,101,47,65,75,65,90,69,70,101,97,116,117,114,101,115,46,99,112,112,0,68,105,102,102,117,115,105,118,105,116,121,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,50,99,118,51,51,77,117,108,116,105,115,99,97,108,101,68,101,114,105,118,97,116,105,118,101,115,65,75,65,90,69,73,110,118,111,107,101,114,69,0,67,111,109,112,117,116,101,95,68,101,115,99,114,105,112,116,111,114,115,0,78,50,99,118,51,48,77,76,68,66,95,68,101,115,99,114,105,112,116,111,114,95,83,117,98,115,101,116,95,73,110,118,111,107,101,114,69,0,111,112,116,105,111,110,115,95,45,62,100,101,115,99,114,105,112,116,111,114,95,99,104,97,110,110,101,108,115,32,60,61,32,109,97,120,95,99,104,97,110,110,101,108,115,0,71,101,116,95,77,76,68,66,95,70,117,108,108,95,68,101,115,99,114,105,112,116,111,114,0,78,50,99,118,50,56,77,76,68,66,95,70,117,108,108,95,68,101,115,99,114,105,112,116,111,114,95,73,110,118,111,107,101,114,69,0,78,50,99,118,51,56,85,112,114,105,103,104,116,95,77,76,68,66,95,68,101,115,99,114,105,112,116,111,114,95,83,117,98,115,101,116,95,73,110,118,111,107,101,114,69,0,78,50,99,118,51,54,85,112,114,105,103,104,116,95,77,76,68,66,95,70,117,108,108,95,68,101,115,99,114,105,112,116,111,114,95,73,110,118,111,107,101,114,69,0,78,50,99,118,50,55,77,83,85,82,70,95,68,101,115,99,114,105,112,116,111,114,95,54,52,95,73,110,118,111,107,101,114,69,0,78,50,99,118,51,53,77,83,85,82,70,95,85,112,114,105,103,104,116,95,68,101,115,99,114,105,112,116,111,114,95,54,52,95,73,110,118,111,107,101,114,69,0,101,118,111,108,117,116,105,111,110,95,46,115,105,122,101,40,41,32,62,32,48,0,67,114,101,97,116,101,95,78,111,110,108,105,110,101,97,114,95,83,99,97,108,101,95,83,112,97,99,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,107,97,122,101,47,75,65,90,69,70,101,97,116,117,114,101,115,46,99,112,112,0,78,50,99,118,51,50,77,117,108,116,105,115,99,97,108,101,68,101,114,105,118,97,116,105,118,101,115,75,65,90,69,73,110,118,111,107,101,114,69,0,78,50,99,118,50,51,70,105,110,100,69,120,116,114,101,109,117,109,75,65,90,69,73,110,118,111,107,101,114,69,0,48,32,60,61,32,107,112,116,115,91,105,93,46,99,108,97,115,115,95,105,100,32,38,38,32,107,112,116,115,91,105,93,46,99,108,97,115,115,95,105,100,32,60,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,101,118,111,108,117,116,105,111,110,95,46,115,105,122,101,40,41,41,0,70,101,97,116,117,114,101,95,68,101,115,99,114,105,112,116,105,111,110,0,78,50,99,118,50,51,75,65,90,69,95,68,101,115,99,114,105,112,116,111,114,95,73,110,118,111,107,101,114,69,0,78,50,99,118,50,51,78,108,100,95,83,116,101,112,95,83,99,97,108,97,114,95,73,110,118,111,107,101,114,69,0,115,114,99,46,99,111,108,115,32,47,32,50,32,61,61,32,100,115,116,46,99,111,108,115,0,104,97,108,102,115,97,109,112,108,101,95,105,109,97,103,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,107,97,122,101,47,110,108,100,105,102,102,117,115,105,111,110,95,102,117,110,99,116,105,111,110,115,46,99,112,112,0,115,114,99,46,114,111,119,115,32,47,32,50,32,61,61,32,100,115,116,46,114,111,119,115,0,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,50,48,68,101,115,99,114,105,112,116,111,114,67,111,108,108,101,99,116,105,111,110,69,0,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,85,77,97,116,40,41,32,124,124,32,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,85,77,97,116,86,101,99,116,111,114,40,41,32,124,124,32,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,77,97,116,40,41,32,124,124,32,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,77,97,116,86,101,99,116,111,114,40,41,0,97,100,100,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,109,97,116,99,104,101,114,115,46,99,112,112,0,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,0,95,113,117,101,114,121,68,101,115,99,114,105,112,116,111,114,115,46,116,121,112,101,40,41,32,61,61,32,116,114,97,105,110,68,101,115,99,84,121,112,101,0,114,97,100,105,117,115,77,97,116,99,104,73,109,112,108,0,107,110,110,77,97,116,99,104,73,109,112,108,0,40,105,110,116,54,52,41,105,109,103,67,111,117,110,116,42,73,77,71,73,68,88,95,79,78,69,32,60,32,73,78,84,95,77,65,88,0,116,114,97,105,110,68,101,115,99,67,111,108,108,101,99,116,105,111,110,91,105,73,100,120,93,46,114,111,119,115,32,60,32,73,77,71,73,68,88,95,79,78,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,66,70,77,97,116,99,104,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,57,66,70,77,97,116,99,104,101,114,69,0,40,103,108,111,98,97,108,68,101,115,99,73,100,120,62,61,48,41,32,38,38,32,40,103,108,111,98,97,108,68,101,115,99,73,100,120,32,60,32,115,105,122,101,40,41,41,0,103,101,116,76,111,99,97,108,73,100,120,0,100,101,101,112,32,99,108,111,110,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,44,32,98,101,99,97,117,115,101,32,70,108,97,110,110,58,58,73,110,100,101,120,32,104,97,115,32,110,111,116,32,99,111,112,121,32,99,111,110,115,116,114,117,99,116,111,114,32,111,114,32,99,108,111,110,101,32,109,101,116,104,111,100,32,0,99,108,111,110,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,70,108,97,110,110,66,97,115,101,100,77,97,116,99,104,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,95,105,110,100,101,120,80,97,114,97,109,115,0,70,108,97,110,110,66,97,115,101,100,77,97,116,99,104,101,114,0,95,115,101,97,114,99,104,80,97,114,97,109,115,0,116,114,97,105,110,68,101,115,99,67,111,108,108,101,99,116,105,111,110,46,115,105,122,101,40,41,32,61,61,32,48,0,116,114,97,105,110,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,53,102,108,97,110,110,53,73,110,100,101,120,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,105,109,97,103,101,67,111,117,110,116,32,62,32,48,0,115,101,116,0,100,105,109,32,62,32,48,0,100,101,115,99,114,105,112,116,111,114,115,91,105,93,46,99,111,108,115,32,61,61,32,100,105,109,32,38,38,32,100,101,115,99,114,105,112,116,111,114,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,0,105,110,100,101,120,80,97,114,97,109,115,0,105,112,46,116,121,112,101,40,41,32,61,61,32,70,105,108,101,78,111,100,101,58,58,83,69,81,0,105,112,91,105,93,46,116,121,112,101,40,41,32,61,61,32,70,105,108,101,78,111,100,101,58,58,77,65,80,0,116,121,112,101,0,118,97,108,117,101,0,115,101,97,114,99,104,80,97,114,97,109,115,0,115,112,46,116,121,112,101,40,41,32,61,61,32,70,105,108,101,78,111,100,101,58,58,83,69,81,0,115,112,91,105,93,46,116,121,112,101,40,41,32,61,61,32,70,105,108,101,78,111,100,101,58,58,77,65,80,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,53,102,108,97,110,110,49,50,83,101,97,114,99,104,80,97,114,97,109,115,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,53,102,108,97,110,110,49,49,73,110,100,101,120,80,97,114,97,109,115,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,49,55,70,108,97,110,110,66,97,115,101,100,77,97,116,99,104,101,114,69,0,107,110,110,77,97,116,99,104,101,115,91,105,93,46,115,105,122,101,40,41,32,60,61,32,49,0,99,111,110,118,101,114,116,77,97,116,99,104,101,115,0,109,97,115,107,115,46,115,105,122,101,40,41,32,61,61,32,105,109,97,103,101,67,111,117,110,116,0,99,104,101,99,107,77,97,115,107,115,0,109,97,115,107,115,91,105,93,46,114,111,119,115,32,61,61,32,113,117,101,114,121,68,101,115,99,114,105,112,116,111,114,115,67,111,117,110,116,32,38,38,32,40,109,97,115,107,115,91,105,93,46,99,111,108,115,32,61,61,32,114,111,119,115,32,124,124,32,109,97,115,107,115,91,105,93,46,99,111,108,115,32,61,61,32,114,111,119,115,41,32,38,38,32,109,97,115,107,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,107,110,110,32,62,32,48,0,107,110,110,77,97,116,99,104,0,70,108,97,110,110,66,97,115,101,100,0,66,114,117,116,101,70,111,114,99,101,0,66,114,117,116,101,70,111,114,99,101,45,83,76,50,0,66,114,117,116,101,70,111,114,99,101,45,76,49,0,66,114,117,116,101,70,111,114,99,101,45,72,97,109,109,105,110,103,0,66,114,117,116,101,70,111,114,99,101,45,72,97,109,109,105,110,103,76,85,84,0,66,114,117,116,101,70,111,114,99,101,45,72,97,109,109,105,110,103,40,50,41,0,85,110,107,110,111,119,110,32,109,97,116,99,104,101,114,32,110,97,109,101,0,99,114,101,97,116,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,53,102,108,97,110,110,49,55,75,68,84,114,101,101,73,110,100,101,120,80,97,114,97,109,115,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,51,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,52,0,100,101,116,101,99,116,82,101,103,105,111,110,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,109,115,101,114,46,99,112,112,0,112,116,114,111,102,115,32,33,61,32,48,0,112,97,115,115,0,78,50,99,118,57,77,83,69,82,95,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,77,83,69,82,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,112,97,116,99,104,83,105,122,101,32,62,61,32,50,0,100,101,116,101,99,116,65,110,100,67,111,109,112,117,116,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,111,114,98,46,99,112,112,0,108,101,118,101,108,32,62,61,32,48,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,98,108,111,99,107,83,105,122,101,42,98,108,111,99,107,83,105,122,101,32,60,61,32,50,48,52,56,0,72,97,114,114,105,115,82,101,115,112,111,110,115,101,115,0,48,32,60,61,32,108,101,118,101,108,0,119,116,97,95,107,32,61,61,32,50,32,124,124,32,119,116,97,95,107,32,61,61,32,51,32,124,124,32,119,116,97,95,107,32,61,61,32,52,0,87,114,111,110,103,32,119,116,97,95,107,46,32,73,116,32,99,97,110,32,98,101,32,111,110,108,121,32,50,44,32,51,32,111,114,32,52,46,0,99,111,109,112,117,116,101,79,114,98,68,101,115,99,114,105,112,116,111,114,115,0,116,111,116,97,108,40,41,32,61,61,32,48,32,124,124,32,100,97,116,97,32,33,61,32,78,85,76,76,0,77,97,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,109,97,116,46,105,110,108,46,104,112,112,0,78,50,99,118,56,79,82,66,95,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,79,82,66,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,33,97,102,102,105,110,101,77,97,116,46,101,109,112,116,121,40,41,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,115,104,97,112,101,47,115,114,99,47,97,102,102,95,116,114,97,110,115,46,99,112,112,0,97,102,102,105,110,101,95,116,121,112,101,0,78,50,99,118,50,49,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,46,65,70,70,0,40,95,114,97,110,107,80,114,111,112,111,114,116,105,111,110,62,48,41,32,38,38,32,40,95,114,97,110,107,80,114,111,112,111,114,116,105,111,110,60,61,49,41,0,115,101,116,82,97,110,107,80,114,111,112,111,114,116,105,111,110,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,115,104,97,112,101,47,115,114,99,47,104,97,117,115,95,100,105,115,46,99,112,112,0,100,105,115,116,97,110,99,101,0,114,97,110,107,0,78,50,99,118,51,48,72,97,117,115,100,111,114,102,102,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,73,109,112,108,69,0,83,104,97,112,101,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,46,72,65,85,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,48,72,97,117,115,100,111,114,102,102,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,115,104,97,112,101,47,115,114,99,47,104,105,115,116,95,99,111,115,116,46,99,112,112,0,102,108,97,103,0,100,117,109,109,105,101,115,0,100,101,102,97,117,108,116,0,78,50,99,118,51,48,78,111,114,109,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,73,109,112,108,69,0,78,50,99,118,50,57,69,77,68,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,73,109,112,108,69,0,78,50,99,118,50,57,67,104,105,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,73,109,112,108,69,0,78,50,99,118,51,49,69,77,68,76,49,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,73,109,112,108,69,0,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,46,78,79,82,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,48,78,111,114,109,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,46,69,77,68,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,57,69,77,68,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,46,67,72,73,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,57,67,104,105,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,49,69,77,68,76,49,72,105,115,116,111,103,114,97,109,67,111,115,116,69,120,116,114,97,99,116,111,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,95,105,116,101,114,97,116,105,111,110,115,62,48,0,115,101,116,73,116,101,114,97,116,105,111,110,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,115,104,97,112,101,47,115,114,99,47,115,99,95,100,105,115,46,99,112,112,0,40,33,105,109,97,103,101,49,46,101,109,112,116,121,40,41,41,32,38,38,32,40,33,105,109,97,103,101,50,46,101,109,112,116,121,40,41,41,0,103,101,116,73,109,97,103,101,115,0,40,105,109,97,103,101,49,95,46,100,101,112,116,104,40,41,61,61,48,41,32,38,38,32,40,105,109,97,103,101,50,95,46,100,101,112,116,104,40,41,61,61,48,41,0,115,101,116,73,109,97,103,101,115,0,95,111,117,116,101,114,82,97,100,105,117,115,62,48,0,115,101,116,79,117,116,101,114,82,97,100,105,117,115,0,95,105,110,110,101,114,82,97,100,105,117,115,62,48,0,115,101,116,73,110,110,101,114,82,97,100,105,117,115,0,95,110,82,97,100,105,97,108,66,105,110,115,62,48,0,115,101,116,82,97,100,105,97,108,66,105,110,115,0,95,110,65,110,103,117,108,97,114,66,105,110,115,62,48,0,115,101,116,65,110,103,117,108,97,114,66,105,110,115,0,40,115,101,116,49,46,99,104,97,110,110,101,108,115,40,41,61,61,50,41,32,38,38,32,40,115,101,116,49,46,99,111,108,115,62,48,41,0,99,111,109,112,117,116,101,68,105,115,116,97,110,99,101,0,40,115,101,116,50,46,99,104,97,110,110,101,108,115,40,41,61,61,50,41,32,38,38,32,40,115,101,116,50,46,99,111,108,115,62,48,41,0,110,82,97,100,115,0,110,65,110,103,115,0,105,116,101,114,115,0,98,101,87,101,105,0,115,99,87,101,105,0,105,97,87,101,105,0,99,111,115,116,70,0,115,105,103,109,97,0,105,109,103,95,49,0,105,109,103,95,50,0,114,111,116,73,110,0,78,50,99,118,51,51,83,104,97,112,101,67,111,110,116,101,120,116,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,51,83,104,97,112,101,67,111,110,116,101,120,116,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,83,104,97,112,101,68,105,115,116,97,110,99,101,69,120,116,114,97,99,116,111,114,46,83,67,68,0,116,112,115,67,111,109,112,117,116,101,100,61,61,116,114,117,101,0,119,97,114,112,73,109,97,103,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,115,104,97,112,101,47,115,114,99,47,116,112,115,95,116,114,97,110,115,46,99,112,112,0,116,112,115,67,111,109,112,117,116,101,100,0,97,112,112,108,121,84,114,97,110,115,102,111,114,109,97,116,105,111,110,0,40,112,116,115,49,46,99,104,97,110,110,101,108,115,40,41,61,61,50,41,32,38,38,32,40,112,116,115,49,46,99,111,108,115,62,48,41,0,40,112,116,115,49,46,99,104,97,110,110,101,108,115,40,41,61,61,50,41,32,38,38,32,40,112,116,115,49,46,99,111,108,115,62,48,41,32,38,38,32,40,112,116,115,50,46,99,104,97,110,110,101,108,115,40,41,61,61,50,41,32,38,38,32,40,112,116,115,50,46,99,111,108,115,62,48,41,0,101,115,116,105,109,97,116,101,84,114,97,110,115,102,111,114,109,97,116,105,111,110,0,95,109,97,116,99,104,101,115,46,115,105,122,101,40,41,62,49,0,114,101,103,117,108,97,114,105,122,97,116,105,111,110,0,78,50,99,118,51,53,84,104,105,110,80,108,97,116,101,83,112,108,105,110,101,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,53,84,104,105,110,80,108,97,116,101,83,112,108,105,110,101,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,83,104,97,112,101,84,114,97,110,115,102,111,114,109,101,114,46,84,80,83,0,40,115,105,103,49,46,114,111,119,115,61,61,115,105,103,50,46,114,111,119,115,41,32,38,38,32,40,115,105,103,49,46,99,111,108,115,61,61,115,105,103,50,46,99,111,108,115,41,32,38,38,32,40,33,115,105,103,49,46,101,109,112,116,121,40,41,41,32,38,38,32,40,33,115,105,103,50,46,101,109,112,116,121,40,41,41,0,103,101,116,69,77,68,76,49,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,115,104,97,112,101,47,115,114,99,47,101,109,100,76,49,46,99,112,112,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,65,108,105,103,110,77,84,66,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,105,109,103,48,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,105,109,103,48,46,116,121,112,101,40,41,32,61,61,32,105,109,103,49,46,116,121,112,101,40,41,0,99,97,108,99,117,108,97,116,101,83,104,105,102,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,112,104,111,116,111,47,115,114],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+383220);allocate([99,47,97,108,105,103,110,46,99,112,112,0,109,97,120,95,98,105,116,115,0,101,120,99,108,117,100,101,95,114,97,110,103,101,0,99,117,116,0,78,50,99,118,49,50,65,108,105,103,110,77,84,66,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,48,67,97,108,105,98,114,97,116,101,68,101,98,101,118,101,99,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,67,97,108,105,98,114,97,116,101,68,101,98,101,118,101,99,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,112,104,111,116,111,47,115,114,99,47,99,97,108,105,98,114,97,116,101,46,99,112,112,0,115,97,109,112,108,101,115,0,108,97,109,98,100,97,0,114,97,110,100,111,109,0,78,50,99,118,50,48,67,97,108,105,98,114,97,116,101,68,101,98,101,118,101,99,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,50,67,97,108,105,98,114,97,116,101,82,111,98,101,114,116,115,111,110,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,67,97,108,105,98,114,97,116,101,82,111,98,101,114,116,115,111,110,0,109,97,120,95,105,116,101,114,0,116,104,114,101,115,104,111,108,100,0,78,50,99,118,50,50,67,97,108,105,98,114,97,116,101,82,111,98,101,114,116,115,111,110,73,109,112,108,69,0,33,73,46,101,109,112,116,121,40,41,32,38,38,32,40,73,46,99,104,97,110,110,101,108,115,40,41,61,61,51,41,0,100,101,99,111,108,111,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,112,104,111,116,111,47,115,114,99,47,99,111,110,116,114,97,115,116,95,112,114,101,115,101,114,118,101,46,99,112,112,0,111,98,115,101,114,118,97,116,105,111,110,115,46,115,105,122,101,40,41,62,48,32,38,38,32,110,105,116,101,114,115,62,48,32,38,38,32,108,97,109,98,100,97,62,48,0,100,101,110,111,105,115,101,95,84,86,76,49,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,112,104,111,116,111,47,115,114,99,47,100,101,110,111,105,115,101,95,116,118,108,49,46,99,112,112,0,111,98,115,101,114,118,97,116,105,111,110,115,91,105,93,46,114,111,119,115,61,61,114,111,119,115,32,38,38,32,111,98,115,101,114,118,97,116,105,111,110,115,91,105,93,46,99,111,108,115,61,61,99,111,108,115,0,104,110,32,61,61,32,49,32,124,124,32,104,110,32,61,61,32,99,110,0,102,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,112,104,111,116,111,47,115,114,99,47,100,101,110,111,105,115,105,110,103,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,33,32,79,110,108,121,32,49,44,32,50,44,32,51,44,32,97,110,100,32,52,32,97,114,101,32,115,117,112,112,111,114,116,101,100,0,102,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,95,0,85,110,115,117,112,112,111,114,116,101,100,32,100,101,112,116,104,33,32,79,110,108,121,32,67,86,95,56,85,32,105,115,32,115,117,112,112,111,114,116,101,100,32,102,111,114,32,78,79,82,77,95,76,50,0,85,110,115,117,112,112,111,114,116,101,100,32,100,101,112,116,104,33,32,79,110,108,121,32,67,86,95,56,85,32,97,110,100,32,67,86,95,49,54,85,32,97,114,101,32,115,117,112,112,111,114,116,101,100,32,102,111,114,32,78,79,82,77,95,76,49,0,85,110,115,117,112,112,111,114,116,101,100,32,110,111,114,109,32,116,121,112,101,33,32,79,110,108,121,32,78,79,82,77,95,76,50,32,97,110,100,32,78,79,82,77,95,76,49,32,97,114,101,32,115,117,112,112,111,114,116,101,100,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,116,76,105,52,69,69,69,120,121,55,68,105,115,116,65,98,115,78,83,49,95,73,105,76,105,52,69,69,69,69,0,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,112,105,120,101,108,73,110,102,111,60,84,62,58,58,99,104,97,110,110,101,108,115,0,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,112,104,111,116,111,47,115,114,99,47,102,97,115,116,95,110,108,109,101,97,110,115,95,100,101,110,111,105,115,105,110,103,95,105,110,118,111,107,101,114,46,104,112,112,0,116,101,109,112,108,97,116,101,95,119,105,110,100,111,119,95,115,105,122,101,95,32,60,61,32,52,54,51,52,48,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,116,76,105,52,69,69,69,120,121,55,68,105,115,116,65,98,115,105,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,116,76,105,51,69,69,69,120,121,55,68,105,115,116,65,98,115,78,83,49,95,73,105,76,105,51,69,69,69,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,116,76,105,51,69,69,69,120,121,55,68,105,115,116,65,98,115,105,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,116,76,105,50,69,69,69,120,121,55,68,105,115,116,65,98,115,78,83,49,95,73,105,76,105,50,69,69,69,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,116,76,105,50,69,69,69,120,121,55,68,105,115,116,65,98,115,105,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,116,120,121,55,68,105,115,116,65,98,115,105,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,52,69,69,69,105,106,55,68,105,115,116,65,98,115,78,83,49,95,73,105,76,105,52,69,69,69,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,52,69,69,69,105,106,55,68,105,115,116,65,98,115,105,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,51,69,69,69,105,106,55,68,105,115,116,65,98,115,78,83,49,95,73,105,76,105,51,69,69,69,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,51,69,69,69,105,106,55,68,105,115,116,65,98,115,105,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,50,69,69,69,105,106,55,68,105,115,116,65,98,115,78,83,49,95,73,105,76,105,50,69,69,69,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,50,69,69,69,105,106,55,68,105,115,116,65,98,115,105,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,104,105,106,55,68,105,115,116,65,98,115,105,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,52,69,69,69,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,78,83,49,95,73,105,76,105,52,69,69,69,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,52,69,69,69,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,105,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,51,69,69,69,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,78,83,49,95,73,105,76,105,51,69,69,69,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,51,69,69,69,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,105,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,50,69,69,69,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,78,83,49,95,73,105,76,105,50,69,69,69,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,50,69,69,69,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,105,69,0,50,55,70,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,104,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,105,69,0,84,121,112,101,32,111,102,32,105,110,112,117,116,32,105,109,97,103,101,32,115,104,111,117,108,100,32,98,101,32,67,86,95,56,85,67,51,32,111,114,32,67,86,95,56,85,67,52,33,0,102,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,67,111,108,111,114,101,100,0,102,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,77,117,108,116,105,0,85,110,115,117,112,112,111,114,116,101,100,32,105,109,97,103,101,32,102,111,114,109,97,116,33,32,79,110,108,121,32,67,86,95,56,85,44,32,67,86,95,56,85,67,50,44,32,67,86,95,56,85,67,51,32,97,110,100,32,67,86,95,56,85,67,52,32,97,114,101,32,115,117,112,112,111,114,116,101,100,0,102,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,77,117,108,116,105,95,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,116,76,105,52,69,69,69,120,121,55,68,105,115,116,65,98,115,78,83,49,95,73,105,76,105,52,69,69,69,69,0,115,114,99,73,109,103,115,46,115,105,122,101,40,41,32,62,32,48,0,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,112,104,111,116,111,47,115,114,99,47,102,97,115,116,95,110,108,109,101,97,110,115,95,109,117,108,116,105,95,100,101,110,111,105,115,105,110,103,95,105,110,118,111,107,101,114,46,104,112,112,0,115,114,99,73,109,103,115,91,48,93,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,112,105,120,101,108,73,110,102,111,60,84,62,58,58,99,104,97,110,110,101,108,115,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,116,76,105,52,69,69,69,120,121,55,68,105,115,116,65,98,115,105,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,116,76,105,51,69,69,69,120,121,55,68,105,115,116,65,98,115,78,83,49,95,73,105,76,105,51,69,69,69,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,116,76,105,51,69,69,69,120,121,55,68,105,115,116,65,98,115,105,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,116,76,105,50,69,69,69,120,121,55,68,105,115,116,65,98,115,78,83,49,95,73,105,76,105,50,69,69,69,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,116,76,105,50,69,69,69,120,121,55,68,105,115,116,65,98,115,105,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,104,120,121,55,68,105,115,116,65,98,115,105,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,52,69,69,69,105,106,55,68,105,115,116,65,98,115,78,83,49,95,73,105,76,105,52,69,69,69,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,52,69,69,69,105,106,55,68,105,115,116,65,98,115,105,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,51,69,69,69,105,106,55,68,105,115,116,65,98,115,78,83,49,95,73,105,76,105,51,69,69,69,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,51,69,69,69,105,106,55,68,105,115,116,65,98,115,105,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,50,69,69,69,105,106,55,68,105,115,116,65,98,115,78,83,49,95,73,105,76,105,50,69,69,69,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,50,69,69,69,105,106,55,68,105,115,116,65,98,115,105,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,104,105,106,55,68,105,115,116,65,98,115,105,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,52,69,69,69,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,78,83,49,95,73,105,76,105,52,69,69,69,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,52,69,69,69,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,105,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,51,69,69,69,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,78,83,49,95,73,105,76,105,51,69,69,69,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,51,69,69,69,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,105,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,50,69,69,69,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,78,83,49,95,73,105,76,105,50,69,69,69,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,78,50,99,118,51,86,101,99,73,104,76,105,50,69,69,69,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,105,69,0,51,50,70,97,115,116,78,108,77,101,97,110,115,77,117,108,116,105,68,101,110,111,105,115,105,110,103,73,110,118,111,107,101,114,73,104,105,106,49,49,68,105,115,116,83,113,117,97,114,101,100,105,69,0,73,110,112,117,116,32,105,109,97,103,101,115,32,118,101,99,116,111,114,32,115,104,111,117,108,100,32,110,111,116,32,98,101,32,101,109,112,116,121,33,0,102,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,77,117,108,116,105,67,104,101,99,107,80,114,101,99,111,110,100,105,116,105,111,110,115,0,65,108,108,32,119,105,110,100,111,119,115,32,115,105,122,101,115,32,115,104,111,117,108,100,32,98,101,32,111,100,100,33,0,105,109,103,84,111,68,101,110,111,105,115,101,73,110,100,101,120,32,97,110,100,32,116,101,109,112,111,114,97,108,87,105,110,100,111,119,83,105,122,101,32,115,104,111,117,108,100,32,98,101,32,99,104,111,115,101,110,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,115,114,99,73,109,103,115,32,115,105,122,101,33,0,73,110,112,117,116,32,105,109,97,103,101,115,32,115,104,111,117,108,100,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,121,112,101,33,0,84,121,112,101,32,111,102,32,105,110,112,117,116,32,105,109,97,103,101,115,32,115,104,111,117,108,100,32,98,101,32,67,86,95,56,85,67,51,33,0,102,97,115,116,78,108,77,101,97,110,115,68,101,110,111,105,115,105,110,103,67,111,108,111,114,101,100,77,117,108,116,105,0,33,105,109,97,103,101,115,46,101,109,112,116,121,40,41,0,99,104,101,99,107,73,109,97,103,101,68,105,109,101,110,115,105,111,110,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,112,104,111,116,111,47,115,114,99,47,104,100,114,95,99,111,109,109,111,110,46,99,112,112,0,105,109,97,103,101,115,91,105,93,46,99,111,108,115,32,61,61,32,119,105,100,116,104,32,38,38,32,105,109,97,103,101,115,91,105,93,46,114,111,119,115,32,61,61,32,104,101,105,103,104,116,0,105,109,97,103,101,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,0,65,108,108,32,116,104,101,32,105,110,112,117,116,32,97,110,100,32,111,117,116,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,0,99,118,73,110,112,97,105,110,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,112,104,111,116,111,47,115,114,99,47,105,110,112,97,105,110,116,46,99,112,112,0,79,110,108,121,32,56,45,98,105,116,32,49,45,99,104,97,110,110,101,108,32,97,110,100,32,51,45,99,104,97,110,110,101,108,32,105,110,112,117,116,47,111,117,116,112,117,116,32,105,109,97,103,101,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,0,84,104,101,32,109,97,115,107,32,109,117,115,116,32,98,101,32,56,45,98,105,116,32,49,45,99,104,97,110,110,101,108,32,105,109,97,103,101,0,84,104,101,32,102,108,97,103,115,32,97,114,103,117,109,101,110,116,32,109,117,115,116,32,98,101,32,111,110,101,32,111,102,32,67,86,95,73,78,80,65,73,78,84,95,84,69,76,69,65,32,111,114,32,67,86,95,73,78,80,65,73,78,84,95,78,83,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,50,48,67,118,80,114,105,111,114,105,116,121,81,117,101,117,101,70,108,111,97,116,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,49,52,95,73,112,108,67,111,110,118,75,101,114,110,101,108,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,77,101,114,103,101,68,101,98,101,118,101,99,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,77,101,114,103,101,68,101,98,101,118,101,99,0,105,109,97,103,101,115,46,115,105,122,101,40,41,32,61,61,32,116,105,109,101,115,46,116,111,116,97,108,40,41,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,112,104,111,116,111,47,115,114,99,47,109,101,114,103,101,46,99,112,112,0,105,109,97,103,101,115,91,48,93,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,0,108,111,103,95,114,101,115,112,111,110,115,101,46,114,111,119,115,32,61,61,32,76,68,82,95,83,73,90,69,32,38,38,32,108,111,103,95,114,101,115,112,111,110,115,101,46,99,111,108,115,32,61,61,32,49,32,38,38,32,108,111,103,95,114,101,115,112,111,110,115,101,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,99,104,97,110,110,101,108,115,0,78,50,99,118,49,54,77,101,114,103,101,68,101,98,101,118,101,99,73,109,112,108,69,0,77,101,114,103,101,77,101,114,116,101,110,115,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,77,101,114,103,101,77,101,114,116,101,110,115,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,99,104,97,110,110,101,108,115,32,61,61,32,49,32,124,124,32,99,104,97,110,110,101,108,115,32,61,61,32,51,0,99,111,110,116,114,97,115,116,95,119,101,105,103,104,116,0,115,97,116,117,114,97,116,105,111,110,95,119,101,105,103,104,116,0,101,120,112,111,115,117,114,101,95,119,101,105,103,104,116,0,78,50,99,118,49,54,77,101,114,103,101,77,101,114,116,101,110,115,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,56,77,101,114,103,101,82,111,98,101,114,116,115,111,110,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,77,101,114,103,101,82,111,98,101,114,116,115,111,110,0,114,101,115,112,111,110,115,101,46,114,111,119,115,32,61,61,32,76,68,82,95,83,73,90,69,32,38,38,32,114,101,115,112,111,110,115,101,46,99,111,108,115,32,61,61,32,49,32,38,38,32,114,101,115,112,111,110,115,101,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,99,104,97,110,110,101,108,115,0,78,50,99,118,49,56,77,101,114,103,101,82,111,98,101,114,116,115,111,110,73,109,112,108,69,0,109,105,110,120,100,32,62,61,32,48,32,38,38,32,109,105,110,121,100,32,62,61,32,48,32,38,38,32,109,97,120,120,100,32,60,61,32,100,101,115,116,46,114,111,119,115,32,38,38,32,109,97,120,121,100,32,60,61,32,100,101,115,116,46,99,111,108,115,0,115,101,97,109,108,101,115,115,67,108,111,110,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,112,104,111,116,111,47,115,114,99,47,115,101,97,109,108,101,115,115,95,99,108,111,110,105,110,103,46,99,112,112,0,84,111,110,101,109,97,112,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,84,111,110,101,109,97,112,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,112,114,111,99,101,115,115,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,112,104,111,116,111,47,115,114,99,47,116,111,110,101,109,97,112,46,99,112,112,0,110,46,105,115,83,116,114,105,110,103,40,41,32,38,38,32,83,116,114,105,110,103,40,110,41,32,61,61,32,110,97,109,101,0,103,97,109,109,97,0,78,50,99,118,49,49,84,111,110,101,109,97,112,73,109,112,108,69,0,84,111,110,101,109,97,112,68,114,97,103,111,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,84,111,110,101,109,97,112,68,114,97,103,111,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,98,105,97,115,0,115,97,116,117,114,97,116,105,111,110,0,78,50,99,118,49,54,84,111,110,101,109,97,112,68,114,97,103,111,73,109,112,108,69,0,84,111,110,101,109,97,112,68,117,114,97,110,100,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,84,111,110,101,109,97,112,68,117,114,97,110,100,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,99,111,110,116,114,97,115,116,0,115,105,103,109,97,95,99,111,108,111,114,0,115,105,103,109,97,95,115,112,97,99,101,0,78,50,99,118,49,55,84,111,110,101,109,97,112,68,117,114,97,110,100,73,109,112,108,69,0,84,111,110,101,109,97,112,82,101,105,110,104,97,114,100,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,57,84,111,110,101,109,97,112,82,101,105,110,104,97,114,100,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,105,110,116,101,110,115,105,116,121,0,108,105,103,104,116,95,97,100,97,112,116,0,99,111,108,111,114,95,97,100,97,112,116,0,78,50,99,118,49,57,84,111,110,101,109,97,112,82,101,105,110,104,97,114,100,73,109,112,108,69,0,84,111,110,101,109,97,112,77,97,110,116,105,117,107,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,56,84,111,110,101,109,97,112,77,97,110,116,105,117,107,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,115,99,97,108,101,0,78,50,99,118,49,56,84,111,110,101,109,97,112,77,97,110,116,105,117,107,73,109,112,108,69,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,98,103,102,103,95,75,78,78,46,99,112,112,0,110,115,97,109,112,108,101,115,0,110,75,78,78,0,100,105,115,116,50,84,104,114,101,115,104,111,108,100,0,78,50,99,118,50,55,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,75,78,78,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,55,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,75,78,78,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,46,75,78,78,0,110,99,104,97,110,110,101,108,115,32,61,61,32,49,32,124,124,32,110,99,104,97,110,110,101,108,115,32,61,61,32,51,0,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,98,103,102,103,95,103,97,117,115,115,109,105,120,50,46,99,112,112,0,108,101,97,114,110,105,110,103,82,97,116,101,32,62,61,32,48,0,97,112,112,108,121,0,78,50,99,118,49,49,77,79,71,50,73,110,118,111,107,101,114,69,0,110,99,104,97,110,110,101,108,115,32,60,61,32,67,86,95,67,78,95,77,65,88,0,105,110,105,116,105,97,108,105,122,101,0,110,109,105,120,116,117,114,101,115,32,60,61,32,50,53,53,0,110,97,109,101,0,40,83,116,114,105,110,103,41,102,110,91,34,110,97,109,101,34,93,32,61,61,32,110,97,109,101,95,0,114,101,97,100,0,104,105,115,116,111,114,121,0,110,109,105,120,116,117,114,101,115,0,98,97,99,107,103,114,111,117,110,100,82,97,116,105,111,0,118,97,114,84,104,114,101,115,104,111,108,100,0,118,97,114,84,104,114,101,115,104,111,108,100,71,101,110,0,118,97,114,73,110,105,116,0,118,97,114,77,105,110,0,118,97,114,77,97,120,0,99,111,109,112,108,101,120,105,116,121,82,101,100,117,99,116,105,111,110,84,104,114,101,115,104,111,108,100,0,100,101,116,101,99,116,83,104,97,100,111,119,115,0,115,104,97,100,111,119,86,97,108,117,101,0,115,104,97,100,111,119,84,104,114,101,115,104,111,108,100,0,78,111,32,101,108,101,109,101,110,116,32,110,97,109,101,32,104,97,115,32,98,101,101,110,32,103,105,118,101,110,0,111,112,101,114,97,116,111,114,60,60,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,112,101,114,115,105,115,116,101,110,99,101,46,104,112,112,0,78,50,99,118,50,56,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,56,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,46,77,79,71,50,0,99,110,32,61,61,32,49,0,109,101,97,110,83,104,105,102,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,99,97,109,115,104,105,102,116,46,99,112,112,0,73,110,112,117,116,32,119,105,110,100,111,119,32,104,97,115,32,110,111,110,45,112,111,115,105,116,105,118,101,32,115,105,122,101,115,0,33,115,114,99,46,101,109,112,116,121,40,41,0,102,105,110,100,84,114,97,110,115,102,111,114,109,69,67,67,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,101,99,99,46,99,112,112,0,33,100,115,116,46,101,109,112,116,121,40,41,0,73,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,56,117,67,49,32,111,114,32,51,50,102,67,49,32,116,121,112,101,0,119,97,114,112,77,97,116,114,105,120,32,109,117,115,116,32,98,101,32,115,105,110,103,108,101,45,99,104,97,110,110,101,108,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,109,97,116,114,105,120,0,109,97,112,46,99,111,108,115,32,61,61,32,51,0,109,97,112,46,114,111,119,115,32,61,61,32,50,32,124,124,32,109,97,112,46,114,111,119,115,32,61,61,51,0,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,65,70,70,73,78,69,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,0,109,97,112,46,114,111,119,115,32,61,61,51,0,99,114,105,116,101,114,105,97,46,116,121,112,101,32,38,32,84,101,114,109,67,114,105,116,101,114,105,97,58,58,67,79,85,78,84,32,124,124,32,99,114,105,116,101,114,105,97,46,116,121,112,101,32,38,32,84,101,114,109,67,114,105,116,101,114,105,97,58,58,69,80,83,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,50,46,115,105,122,101,40,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,97,102,102,105,110,101,95,69,67,67,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,51,46,115,105,122,101,40,41,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,52,46,115,105,122,101,40,41,0,115,114,99,49,46,114,111,119,115,32,61,61,32,100,115,116,46,114,111,119,115,0,100,115,116,46,99,111,108,115,32,61,61,32,40,54,42,115,114,99,49,46,99,111,108,115,41,0,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,104,111,109,111,95,69,67,67,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,56,41,0,115,114,99,53,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,50,46,115,105,122,101,40,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,116,114,97,110,115,108,97,116,105,111,110,95,69,67,67,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,50,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,101,117,99,108,105,100,101,97,110,95,69,67,67,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,51,46,115,105,122,101,40,41,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,52,46,115,105,122,101,40,41,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,51,41,0,78,97,78,32,101,110,99,111,117,110,116,101,114,101,100,46,0,84,104,101,32,97,108,103,111,114,105,116,104,109,32,115,116,111,112,112,101,100,32,98,101,102,111,114,101,32,105,116,115,32,99,111,110,118,101,114,103,101,110,99,101,46,32,84,104,101,32,99,111,114,114,101,108,97,116,105,111,110,32,105,115,32,103,111,105,110,103,32,116,111,32,98,101,32,109,105,110,105,109,105,122,101,100,46,32,73,109,97,103,101,115,32,109,97,121,32,98,101,32,117,110,99,111,114,114,101,108,97,116,101,100,32,111,114,32,110,111,110,45,111,118,101,114,108,97,112,112,101,100,0,109,97,112,95,109,97,116,114,105,120,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,117,112,100,97,116,101,95,119,97,114,112,105,110,103,95,109,97,116,114,105,120,95,69,67,67,0,117,112,100,97,116,101,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,65,70,70,73,78,69,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,51,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,56,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,54,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,51,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,50,0,117,112,100,97,116,101,46,99,111,108,115,32,61,61,32,49,0,109,97,112,95,109,97,116,114,105,120,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,117,112,100,97,116,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,49,46,114,111,119,115,32,61,61,32,115,114,99,50,46,114,111,119,115,0,112,114,111,106,101,99,116,95,111,110,116,111,95,106,97,99,111,98,105,97,110,95,69,67,67,0,40,115,114,99,49,46,99,111,108,115,32,37,32,115,114,99,50,46,99,111,108,115,41,32,61,61,32,48,0,100,115,116,46,99,111,108,115,32,61,61,32,100,115,116,46,114,111,119,115,0,68,80,32,62,32,48,32,38,38,32,77,80,32,62,32,48,0,105,110,105,116,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,107,97,108,109,97,110,46,99,112,112,0,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,78,50,99,118,54,100,101,116,97,105,108,49,54,76,75,84,114,97,99,107,101,114,73,110,118,111,107,101,114,69,0,105,109,103,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,50,32,38,38,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,50,0,98,117,105,108,100,79,112,116,105,99,97,108,70,108,111,119,80,121,114,97,109,105,100,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,108,107,112,121,114,97,109,105,100,46,99,112,112,0,100,101,112,116,104,32,61,61,32,67,86,95,56,85,0,99,97,108,99,83,104,97,114,114,68,101,114,105,118,0,109,97,120,76,101,118,101,108,32,62,61,32,48,32,38,38,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,50,32,38,38,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,50,0,99,97,108,99,79,112,116,105,99,97,108,70,108,111,119,80,121,114,76,75,0,40,110,112,111,105,110,116,115,32,61,32,112,114,101,118,80,116,115,77,97,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,44,32,116,114,117,101,41,41,32,62,61,32,48,0,110,101,120,116,80,116,115,77,97,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+393460);allocate([44,32,67,86,95,51,50,70,44,32,116,114,117,101,41,32,61,61,32,110,112,111,105,110,116,115,0,115,116,97,116,117,115,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,101,114,114,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,108,101,118,101,108,115,49,32,62,61,32,48,0,111,102,115,46,120,32,62,61,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,62,61,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,38,38,32,111,102,115,46,120,32,43,32,112,114,101,118,80,121,114,91,108,118,108,83,116,101,112,49,93,46,99,111,108,115,32,43,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,60,61,32,102,117,108,108,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,43,32,112,114,101,118,80,121,114,91,108,118,108,83,116,101,112,49,93,46,114,111,119,115,32,43,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,60,61,32,102,117,108,108,83,105,122,101,46,104,101,105,103,104,116,0,108,101,118,101,108,115,50,32,62,61,32,48,0,111,102,115,46,120,32,62,61,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,62,61,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,38,38,32,111,102,115,46,120,32,43,32,110,101,120,116,80,121,114,91,108,118,108,83,116,101,112,50,93,46,99,111,108,115,32,43,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,60,61,32,102,117,108,108,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,43,32,110,101,120,116,80,121,114,91,108,118,108,83,116,101,112,50,93,46,114,111,119,115,32,43,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,60,61,32,102,117,108,108,83,105,122,101,46,104,101,105,103,104,116,0,112,114,101,118,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,49,93,46,115,105,122,101,40,41,32,61,61,32,110,101,120,116,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,50,93,46,115,105,122,101,40,41,0,112,114,101,118,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,49,93,46,116,121,112,101,40,41,32,61,61,32,110,101,120,116,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,50,93,46,116,121,112,101,40,41,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,0,101,115,116,105,109,97,116,101,82,105,103,105,100,84,114,97,110,115,102,111,114,109,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,100,97,116,97,32,116,121,112,101,0,99,110,32,61,61,32,49,32,124,124,32,99,110,32,61,61,32,51,32,124,124,32,99,110,32,61,61,32,52,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,101,105,116,104,101,114,32,56,117,67,49,32,111,114,32,56,117,67,51,32,116,121,112,101,0,77,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,103,101,116,82,84,77,97,116,114,105,120,0,112,114,101,118,48,46,115,105,122,101,40,41,32,61,61,32,110,101,120,116,48,46,115,105,122,101,40,41,32,38,38,32,112,114,101,118,48,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,110,101,120,116,48,46,99,104,97,110,110,101,108,115,40,41,32,38,38,32,112,114,101,118,48,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,112,121,114,95,115,99,97,108,101,32,60,32,49,0,99,97,108,99,79,112,116,105,99,97,108,70,108,111,119,70,97,114,110,101,98,97,99,107,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,111,112,116,102,108,111,119,103,102,46,99,112,112,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,70,97,114,110,101,98,97,99,107,80,111,108,121,69,120,112,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,48,79,112,116,105,99,97,108,70,108,111,119,68,117,97,108,95,84,86,76,49,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,73,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,73,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,99,97,108,99,0,47,115,114,118,47,103,105,116,47,99,111,115,105,117,109,45,102,111,114,107,47,111,112,101,110,99,118,106,115,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,116,118,108,49,102,108,111,119,46,99,112,112,0,73,48,46,115,105,122,101,40,41,32,61,61,32,73,49,46,115,105,122,101,40,41,0,73,48,46,116,121,112,101,40,41,32,61,61,32,73,49,46,116,121,112,101,40,41,0,33,117,115,101,73,110,105,116,105,97,108,70,108,111,119,32,124,124,32,40,95,102,108,111,119,46,115,105,122,101,40,41,32,61,61,32,73,48,46,115,105,122,101,40,41,32,38,38,32,95,102,108,111,119,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,50,41,0,110,115,99,97,108,101,115,32,62,32,48,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,53,69,115,116,105,109,97,116,101,68,117,97,108,86,97,114,105,97,98,108,101,115,66,111,100,121,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,57,70,111,114,119,97,114,100,71,114,97,100,105,101,110,116,66,111,100,121,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,52,68,105,118,101,114,103,101,110,99,101,66,111,100,121,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,51,69,115,116,105,109,97,116,101,86,66,111,100,121,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,53,67,97,108,99,71,114,97,100,82,104,111,66,111,100,121,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,54,66,117,105,108,100,70,108,111,119,77,97,112,66,111,100,121,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,48,67,101,110,116,101,114,101,100,71,114,97,100,105,101,110,116,66,111,100,121,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,48,79,112,116,105,99,97,108,70,108,111,119,68,117,97,108,95,84,86,76,49,69,0,0,0,1,5,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,0,0,2,1,3,3,2,4,3,5,5,4,4,0,0,1,125,1,2,3,0,4,17,5,18,33,49,65,6,19,81,97,7,34,113,20,50,129,145,161,8,35,66,177,193,21,82,209,240,36,51,98,114,130,9,10,22,23,24,25,26,37,38,39,40,41,42,52,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,225,226,227,228,229,230,231,232,233,234,241,242,243,244,245,246,247,248,249,250,0,0,3,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,0,0,2,1,2,4,4,3,4,7,5,4,4,0,1,2,119,0,1,2,3,17,4,5,33,49,6,18,65,81,7,97,113,19,34,50,129,8,20,66,145,161,177,193,9,35,51,82,240,21,98,114,209,10,22,36,52,225,37,241,23,24,25,26,38,39,40,41,42,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,130,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,226,227,228,229,230,231,232,233,234,242,243,244,245,246,247,248,249,250,83,79,83,0,76,83,69,0,66,111,103,117,115,32,109,101,115,115,97,103,101,32,99,111,100,101,32,37,100,0,65,76,73,71,78,95,84,89,80,69,32,105,115,32,119,114,111,110,103,44,32,112,108,101,97,115,101,32,102,105,120,0,77,65,88,95,65,76,76,79,67,95,67,72,85,78,75,32,105,115,32,119,114,111,110,103,44,32,112,108,101,97,115,101,32,102,105,120,0,66,111,103,117,115,32,98,117,102,102,101,114,32,99,111,110,116,114,111,108,32,109,111,100,101,0,73,110,118,97,108,105,100,32,99,111,109,112,111,110,101,110,116,32,73,68,32,37,100,32,105,110,32,83,79,83,0,73,110,118,97,108,105,100,32,99,114,111,112,32,114,101,113,117,101,115,116,0,68,67,84,32,99,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,114,97,110,103,101,0,68,67,84,32,115,99,97,108,101,100,32,98,108,111,99,107,32,115,105,122,101,32,37,100,120,37,100,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,67,111,109,112,111,110,101,110,116,32,105,110,100,101,120,32,37,100,58,32,109,105,115,109,97,116,99,104,105,110,103,32,115,97,109,112,108,105,110,103,32,114,97,116,105,111,32,37,100,58,37,100,44,32,37,100,58,37,100,44,32,37,99,0,66,111,103,117,115,32,72,117,102,102,109,97,110,32,116,97,98,108,101,32,100,101,102,105,110,105,116,105,111,110,0,66,111,103,117,115,32,105,110,112,117,116,32,99,111,108,111,114,115,112,97,99,101,0,66,111,103,117,115,32,74,80,69,71,32,99,111,108,111,114,115,112,97,99,101,0,66,111,103,117,115,32,109,97,114,107,101,114,32,108,101,110,103,116,104,0,87,114,111,110,103,32,74,80,69,71,32,108,105,98,114,97,114,121,32,118,101,114,115,105,111,110,58,32,108,105,98,114,97,114,121,32,105,115,32,37,100,44,32,99,97,108,108,101,114,32,101,120,112,101,99,116,115,32,37,100,0,83,97,109,112,108,105,110,103,32,102,97,99,116,111,114,115,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,105,110,116,101,114,108,101,97,118,101,100,32,115,99,97,110,0,73,110,118,97,108,105,100,32,109,101,109,111,114,121,32,112,111,111,108,32,99,111,100,101,32,37,100,0,85,110,115,117,112,112,111,114,116,101,100,32,74,80,69,71,32,100,97,116,97,32,112,114,101,99,105,115,105,111,110,32,37,100,0,73,110,118,97,108,105,100,32,112,114,111,103,114,101,115,115,105,118,101,32,112,97,114,97,109,101,116,101,114,115,32,83,115,61,37,100,32,83,101,61,37,100,32,65,104,61,37,100,32,65,108,61,37,100,0,73,110,118,97,108,105,100,32,112,114,111,103,114,101,115,115,105,118,101,32,112,97,114,97,109,101,116,101,114,115,32,97,116,32,115,99,97,110,32,115,99,114,105,112,116,32,101,110,116,114,121,32,37,100,0,66,111,103,117,115,32,115,97,109,112,108,105,110,103,32,102,97,99,116,111,114,115,0,73,110,118,97,108,105,100,32,115,99,97,110,32,115,99,114,105,112,116,32,97,116,32,101,110,116,114,121,32,37,100,0,73,109,112,114,111,112,101,114,32,99,97,108,108,32,116,111,32,74,80,69,71,32,108,105,98,114,97,114,121,32,105,110,32,115,116,97,116,101,32,37,100,0,74,80,69,71,32,112,97,114,97,109,101,116,101,114,32,115,116,114,117,99,116,32,109,105,115,109,97,116,99,104,58,32,108,105,98,114,97,114,121,32,116,104,105,110,107,115,32,115,105,122,101,32,105,115,32,37,117,44,32,99,97,108,108,101,114,32,101,120,112,101,99,116,115,32,37,117,0,66,111,103,117,115,32,118,105,114,116,117,97,108,32,97,114,114,97,121,32,97,99,99,101,115,115,0,66,117,102,102,101,114,32,112,97,115,115,101,100,32,116,111,32,74,80,69,71,32,108,105,98,114,97,114,121,32,105,115,32,116,111,111,32,115,109,97,108,108,0,83,117,115,112,101,110,115,105,111,110,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,67,67,73,82,54,48,49,32,115,97,109,112,108,105,110,103,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,121,101,116,0,84,111,111,32,109,97,110,121,32,99,111,108,111,114,32,99,111,109,112,111,110,101,110,116,115,58,32,37,100,44,32,109,97,120,32,37,100,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,99,111,110,118,101,114,115,105,111,110,32,114,101,113,117,101,115,116,0,66,111,103,117,115,32,68,65,67,32,105,110,100,101,120,32,37,100,0,66,111,103,117,115,32,68,65,67,32,118,97,108,117,101,32,48,120,37,120,0,66,111,103,117,115,32,68,72,84,32,105,110,100,101,120,32,37,100,0,66,111,103,117,115,32,68,81,84,32,105,110,100,101,120,32,37,100,0,69,109,112,116,121,32,74,80,69,71,32,105,109,97,103,101,32,40,68,78,76,32,110,111,116,32,115,117,112,112,111,114,116,101,100,41,0,82,101,97,100,32,102,114,111,109,32,69,77,83,32,102,97,105,108,101,100,0,87,114,105,116,101,32,116,111,32,69,77,83,32,102,97,105,108,101,100,0,68,105,100,110,39,116,32,101,120,112,101,99,116,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,115,99,97,110,0,73,110,112,117,116,32,102,105,108,101,32,114,101,97,100,32,101,114,114,111,114,0,79,117,116,112,117,116,32,102,105,108,101,32,119,114,105,116,101,32,101,114,114,111,114,32,45,45,45,32,111,117,116,32,111,102,32,100,105,115,107,32,115,112,97,99,101,63,0,70,114,97,99,116,105,111,110,97,108,32,115,97,109,112,108,105,110,103,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,121,101,116,0,72,117,102,102,109,97,110,32,99,111,100,101,32,115,105,122,101,32,116,97,98,108,101,32,111,118,101,114,102,108,111,119,0,77,105,115,115,105,110,103,32,72,117,102,102,109,97,110,32,99,111,100,101,32,116,97,98,108,101,32,101,110,116,114,121,0,77,97,120,105,109,117,109,32,115,117,112,112,111,114,116,101,100,32,105,109,97,103,101,32,100,105,109,101,110,115,105,111,110,32,105,115,32,37,117,32,112,105,120,101,108,115,0,69,109,112,116,121,32,105,110,112,117,116,32,102,105,108,101,0,80,114,101,109,97,116,117,114,101,32,101,110,100,32,111,102,32,105,110,112,117,116,32,102,105,108,101,0,67,97,110,110,111,116,32,116,114,97,110,115,99,111,100,101,32,100,117,101,32,116,111,32,109,117,108,116,105,112,108,101,32,117,115,101,32,111,102,32,113,117,97,110,116,105,122,97,116,105,111,110,32,116,97,98,108,101,32,37,100,0,83,99,97,110,32,115,99,114,105,112,116,32,100,111,101,115,32,110,111,116,32,116,114,97,110,115,109,105,116,32,97,108,108,32,100,97,116,97,0,73,110,118,97,108,105,100,32,99,111,108,111,114,32,113,117,97,110,116,105,122,97,116,105,111,110,32,109,111,100,101,32,99,104,97,110,103,101,0,78,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,121,101,116,0,82,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,119,97,115,32,111,109,105,116,116,101,100,32,97,116,32,99,111,109,112,105,108,101,32,116,105,109,101,0,65,114,105,116,104,109,101,116,105,99,32,116,97,98,108,101,32,48,120,37,48,50,120,32,119,97,115,32,110,111,116,32,100,101,102,105,110,101,100,0,66,97,99,107,105,110,103,32,115,116,111,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,72,117,102,102,109,97,110,32,116,97,98,108,101,32,48,120,37,48,50,120,32,119,97,115,32,110,111,116,32,100,101,102,105,110,101,100,0,74,80,69,71,32,100,97,116,97,115,116,114,101,97,109,32,99,111,110,116,97,105,110,115,32,110,111,32,105,109,97,103,101,0,81,117,97,110,116,105,122,97,116,105,111,110,32,116,97,98,108,101,32,48,120,37,48,50,120,32,119,97,115,32,110,111,116,32,100,101,102,105,110,101,100,0,78,111,116,32,97,32,74,80,69,71,32,102,105,108,101,58,32,115,116,97,114,116,115,32,119,105,116,104,32,48,120,37,48,50,120,32,48,120,37,48,50,120,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,32,40,99,97,115,101,32,37,100,41,0,67,97,110,110,111,116,32,113,117,97,110,116,105,122,101,32,109,111,114,101,32,116,104,97,110,32,37,100,32,99,111,108,111,114,32,99,111,109,112,111,110,101,110,116,115,0,67,97,110,110,111,116,32,113,117,97,110,116,105,122,101,32,116,111,32,102,101,119,101,114,32,116,104,97,110,32,37,100,32,99,111,108,111,114,115,0,67,97,110,110,111,116,32,113,117,97,110,116,105,122,101,32,116,111,32,109,111,114,101,32,116,104,97,110,32,37,100,32,99,111,108,111,114,115,0,73,110,118,97,108,105,100,32,74,80,69,71,32,102,105,108,101,32,115,116,114,117,99,116,117,114,101,58,32,37,115,32,98,101,102,111,114,101,32,83,79,70,0,73,110,118,97,108,105,100,32,74,80,69,71,32,102,105,108,101,32,115,116,114,117,99,116,117,114,101,58,32,116,119,111,32,83,79,70,32,109,97,114,107,101,114,115,0,73,110,118,97,108,105,100,32,74,80,69,71,32,102,105,108,101,32,115,116,114,117,99,116,117,114,101,58,32,109,105,115,115,105,110,103,32,83,79,83,32,109,97,114,107,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,74,80,69,71,32,112,114,111,99,101,115,115,58,32,83,79,70,32,116,121,112,101,32,48,120,37,48,50,120,0,73,110,118,97,108,105,100,32,74,80,69,71,32,102,105,108,101,32,115,116,114,117,99,116,117,114,101,58,32,116,119,111,32,83,79,73,32,109,97,114,107,101,114,115,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,32,37,115,0,82,101,97,100,32,102,97,105,108,101,100,32,111,110,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,0,83,101,101,107,32,102,97,105,108,101,100,32,111,110,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,0,87,114,105,116,101,32,102,97,105,108,101,100,32,111,110,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,32,45,45,45,32,111,117,116,32,111,102,32,100,105,115,107,32,115,112,97,99,101,63,0,65,112,112,108,105,99,97,116,105,111,110,32,116,114,97,110,115,102,101,114,114,101,100,32,116,111,111,32,102,101,119,32,115,99,97,110,108,105,110,101,115,0,85,110,115,117,112,112,111,114,116,101,100,32,109,97,114,107,101,114,32,116,121,112,101,32,48,120,37,48,50,120,0,86,105,114,116,117,97,108,32,97,114,114,97,121,32,99,111,110,116,114,111,108,108,101,114,32,109,101,115,115,101,100,32,117,112,0,73,109,97,103,101,32,116,111,111,32,119,105,100,101,32,102,111,114,32,116,104,105,115,32,105,109,112,108,101,109,101,110,116,97,116,105,111,110,0,82,101,97,100,32,102,114,111,109,32,88,77,83,32,102,97,105,108,101,100,0,87,114,105,116,101,32,116,111,32,88,77,83,32,102,97,105,108,101,100,0,67,111,112,121,114,105,103,104,116,32,40,67,41,32,50,48,49,51,44,32,84,104,111,109,97,115,32,71,46,32,76,97,110,101,44,32,71,117,105,100,111,32,86,111,108,108,98,101,100,105,110,103,0,57,32,32,49,51,45,74,97,110,45,50,48,49,51,0,67,97,117,116,105,111,110,58,32,113,117,97,110,116,105,122,97,116,105,111,110,32,116,97,98,108,101,115,32,97,114,101,32,116,111,111,32,99,111,97,114,115,101,32,102,111,114,32,98,97,115,101,108,105,110,101,32,74,80,69,71,0,65,100,111,98,101,32,65,80,80,49,52,32,109,97,114,107,101,114,58,32,118,101,114,115,105,111,110,32,37,100,44,32,102,108,97,103,115,32,48,120,37,48,52,120,32,48,120,37,48,52,120,44,32,116,114,97,110,115,102,111,114,109,32,37,100,0,85,110,107,110,111,119,110,32,65,80,80,48,32,109,97,114,107,101,114,32,40,110,111,116,32,74,70,73,70,41,44,32,108,101,110,103,116,104,32,37,117,0,85,110,107,110,111,119,110,32,65,80,80,49,52,32,109,97,114,107,101,114,32,40,110,111,116,32,65,100,111,98,101,41,44,32,108,101,110,103,116,104,32,37,117,0,68,101,102,105,110,101,32,65,114,105,116,104,109,101,116,105,99,32,84,97,98,108,101,32,48,120,37,48,50,120,58,32,48,120,37,48,50,120,0,68,101,102,105,110,101,32,72,117,102,102,109,97,110,32,84,97,98,108,101,32,48,120,37,48,50,120,0,68,101,102,105,110,101,32,81,117,97,110,116,105,122,97,116,105,111,110,32,84,97,98,108,101,32,37,100,32,32,112,114,101,99,105,115,105,111,110,32,37,100,0,68,101,102,105,110,101,32,82,101,115,116,97,114,116,32,73,110,116,101,114,118,97,108,32,37,117,0,70,114,101,101,100,32,69,77,83,32,104,97,110,100,108,101,32,37,117,0,79,98,116,97,105,110,101,100,32,69,77,83,32,104,97,110,100,108,101,32,37,117,0,69,110,100,32,79,102,32,73,109,97,103,101,0,32,32,32,32,32,32,32,32,37,51,100,32,37,51,100,32,37,51,100,32,37,51,100,32,37,51,100,32,37,51,100,32,37,51,100,32,37,51,100,0,74,70,73,70,32,65,80,80,48,32,109,97,114,107,101,114,58,32,118,101,114,115,105,111,110,32,37,100,46,37,48,50,100,44,32,100,101,110,115,105,116,121,32,37,100,120,37,100,32,32,37,100,0,87,97,114,110,105,110,103,58,32,116,104,117,109,98,110,97,105,108,32,105,109,97,103,101,32,115,105,122,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,100,97,116,97,32,108,101,110,103,116,104,32,37,117,0,74,70,73,70,32,101,120,116,101,110,115,105,111,110,32,109,97,114,107,101,114,58,32,116,121,112,101,32,48,120,37,48,50,120,44,32,108,101,110,103,116,104,32,37,117,0,32,32,32,32,119,105,116,104,32,37,100,32,120,32,37,100,32,116,104,117,109,98,110,97,105,108,32,105,109,97,103,101,0,77,105,115,99,101,108,108,97,110,101,111,117,115,32,109,97,114,107,101,114,32,48,120,37,48,50,120,44,32,108,101,110,103,116,104,32,37,117,0,85,110,101,120,112,101,99,116,101,100,32,109,97,114,107,101,114,32,48,120,37,48,50,120,0,32,32,32,32,32,32,32,32,37,52,117,32,37,52,117,32,37,52,117,32,37,52,117,32,37,52,117,32,37,52,117,32,37,52,117,32,37,52,117,0,81,117,97,110,116,105,122,105,110,103,32,116,111,32,37,100,32,61,32,37,100,42,37,100,42,37,100,32,99,111,108,111,114,115,0,81,117,97,110,116,105,122,105,110,103,32,116,111,32,37,100,32,99,111,108,111,114,115,0,83,101,108,101,99,116,101,100,32,37,100,32,99,111,108,111,114,115,32,102,111,114,32,113,117,97,110,116,105,122,97,116,105,111,110,0,65,116,32,109,97,114,107,101,114,32,48,120,37,48,50,120,44,32,114,101,99,111,118,101,114,121,32,97,99,116,105,111,110,32,37,100,0,82,83,84,37,100,0,83,109,111,111,116,104,105,110,103,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,119,105,116,104,32,110,111,110,115,116,97,110,100,97,114,100,32,115,97,109,112,108,105,110,103,32,114,97,116,105,111,115,0,83,116,97,114,116,32,79,102,32,70,114,97,109,101,32,48,120,37,48,50,120,58,32,119,105,100,116,104,61,37,117,44,32,104,101,105,103,104,116,61,37,117,44,32,99,111,109,112,111,110,101,110,116,115,61,37,100,0,32,32,32,32,67,111,109,112,111,110,101,110,116,32,37,100,58,32,37,100,104,120,37,100,118,32,113,61,37,100,0,83,116,97,114,116,32,111,102,32,73,109,97,103,101,0,83,116,97,114,116,32,79,102,32,83,99,97,110,58,32,37,100,32,99,111,109,112,111,110,101,110,116,115,0,32,32,32,32,67,111,109,112,111,110,101,110,116,32,37,100,58,32,100,99,61,37,100,32,97,99,61,37,100,0,32,32,83,115,61,37,100,44,32,83,101,61,37,100,44,32,65,104,61,37,100,44,32,65,108,61,37,100,0,67,108,111,115,101,100,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,32,37,115,0,79,112,101,110,101,100,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,32,37,115,0,74,70,73,70,32,101,120,116,101,110,115,105,111,110,32,109,97,114,107,101,114,58,32,74,80,69,71,45,99,111,109,112,114,101,115,115,101,100,32,116,104,117,109,98,110,97,105,108,32,105,109,97,103,101,44,32,108,101,110,103,116,104,32,37,117,0,74,70,73,70,32,101,120,116,101,110,115,105,111,110,32,109,97,114,107,101,114,58,32,112,97,108,101,116,116,101,32,116,104,117,109,98,110,97,105,108,32,105,109,97,103,101,44,32,108,101,110,103,116,104,32,37,117,0,74,70,73,70,32,101,120,116,101,110,115,105,111,110,32,109,97,114,107,101,114,58,32,82,71,66,32,116,104,117,109,98,110,97,105,108,32,105,109,97,103,101,44,32,108,101,110,103,116,104,32,37,117,0,85,110,114,101,99,111,103,110,105,122,101,100,32,99,111,109,112,111,110,101,110,116,32,73,68,115,32,37,100,32,37,100,32,37,100,44,32,97,115,115,117,109,105,110,103,32,89,67,98,67,114,0,70,114,101,101,100,32,88,77,83,32,104,97,110,100,108,101,32,37,117,0,79,98,116,97,105,110,101,100,32,88,77,83,32,104,97,110,100,108,101,32,37,117,0,85,110,107,110,111,119,110,32,65,100,111,98,101,32,99,111,108,111,114,32,116,114,97,110,115,102,111,114,109,32,99,111,100,101,32,37,100,0,67,111,114,114,117,112,116,32,74,80,69,71,32,100,97,116,97,58,32,98,97,100,32,97,114,105,116,104,109,101,116,105,99,32,99,111,100,101,0,73,110,99,111,110,115,105,115,116,101,110,116,32,112,114,111,103,114,101,115,115,105,111,110,32,115,101,113,117,101,110,99,101,32,102,111,114,32,99,111,109,112,111,110,101,110,116,32,37,100,32,99,111,101,102,102,105,99,105,101,110,116,32,37,100,0,67,111,114,114,117,112,116,32,74,80,69,71,32,100,97,116,97,58,32,37,117,32,101,120,116,114,97,110,101,111,117,115,32,98,121,116,101,115,32,98,101,102,111,114,101,32,109,97,114,107,101,114,32,48,120,37,48,50,120,0,67,111,114,114,117,112,116,32,74,80,69,71,32,100,97,116,97,58,32,112,114,101,109,97,116,117,114,101,32,101,110,100,32,111,102,32,100,97,116,97,32,115,101,103,109,101,110,116,0,67,111,114,114,117,112,116,32,74,80,69,71,32,100,97,116,97,58,32,98,97,100,32,72,117,102,102,109,97,110,32,99,111,100,101,0,87,97,114,110,105,110,103,58,32,117,110,107,110,111,119,110,32,74,70,73,70,32,114,101,118,105,115,105,111,110,32,110,117,109,98,101,114,32,37,100,46,37,48,50,100,0,80,114,101,109,97,116,117,114,101,32,101,110,100,32,111,102,32,74,80,69,71,32,102,105,108,101,0,67,111,114,114,117,112,116,32,74,80,69,71,32,100,97,116,97,58,32,102,111,117,110,100,32,109,97,114,107,101,114,32,48,120,37,48,50,120,32,105,110,115,116,101,97,100,32,111,102,32,82,83,84,37,100,0,73,110,118,97,108,105,100,32,83,79,83,32,112,97,114,97,109,101,116,101,114,115,32,102,111,114,32,115,101,113,117,101,110,116,105,97,108,32,74,80,69,71,0,65,112,112,108,105,99,97,116,105,111,110,32,116,114,97,110,115,102,101,114,114,101,100,32,116,111,111,32,109,97,110,121,32,115,99,97,110,108,105,110,101,115,0,37,115,10,0,74,80,69,71,77,69,77,0,37,108,100,37,99,0,0,192,48,240,12,204,60,252,3,195,51,243,15,207,63,255,128,64,176,112,140,76,188,124,131,67,179,115,143,79,191,127,32,224,16,208,44,236,28,220,35,227,19,211,47,239,31,223,160,96,144,80,172,108,156,92,163,99,147,83,175,111,159,95,8,200,56,248,4,196,52,244,11,203,59,251,7,199,55,247,136,72,184,120,132,68,180,116,139,75,187,123,135,71,183,119,40,232,24,216,36,228,20,212,43,235,27,219,39,231,23,215,168,104,152,88,164,100,148,84,171,107,155,91,167,103,151,87,2,194,50,242,14,206,62,254,1,193,49,241,13,205,61,253,130,66,178,114,142,78,190,126,129,65,177,113,141,77,189,125,34,226,18,210,46,238,30,222,33,225,17,209,45,237,29,221,162,98,146,82,174,110,158,94,161,97,145,81,173,109,157,93,10,202,58,250,6,198,54,246,9,201,57,249,5,197,53,245,138,74,186,122,134,70,182,118,137,73,185,121,133,69,181,117,42,234,26,218,38,230,22,214,41,233,25,217,37,229,21,213,170,106,154,90,166,102,150,86,169,105,153,89,165,101,149,85,137,80,78,71,13,10,26,10,80,111,116,101,110,116,105,97,108,32,111,118,101,114,102,108,111,119,32,105,110,32,112,110,103,95,122,97,108,108,111,99,40,41,0,49,46,54,46,49,57,0,32,98,117,116,32,114,117,110,110,105,110,103,32,119,105,116,104,32,0,117,110,101,120,112,101,99,116,101,100,32,122,108,105,98,32,114,101,116,117,114,110,32,99,111,100,101,0,117,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,76,90,32,115,116,114,101,97,109,0,109,105,115,115,105,110,103,32,76,90,32,100,105,99,116,105,111,110,97,114,121,0,122,108,105,98,32,73,79,32,101,114,114,111,114,0,98,97,100,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,122,108,105,98,0,100,97,109,97,103,101,100,32,76,90,32,115,116,114,101,97,109,0,117,110,115,117,112,112,111,114,116,101,100,32,122,108,105,98,32,118,101,114,115,105,111,110,0,117,110,101,120,112,101,99,116,101,100,32,122,108,105,98,32,114,101,116,117,114,110,0,103,97,109,109,97,32,118,97,108,117,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,108,105,98,112,110,103,32,101,115,116,105,109,97,116,101,0,103,97,109,109,97,32,118,97,108,117,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,115,82,71,66,0,103,97,109,109,97,32,118,97,108,117,101,32,111,117,116,32,111,102,32,114,97,110,103,101,0,105,110,99,111,110,115,105,115,116,101,110,116,32,99,104,114,111,109,97,116,105,99,105,116,105,101,115,0,105,110,118,97,108,105,100,32,99,104,114,111,109,97,116,105,99,105,116,105,101,115,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,32,99,104,101,99,107,105,110,103,32,99,104,114,111,109,97,116,105,99,105,116,105,101,115,0,115,82,71,66,0,105,110,118,97,108,105,100,32,115,82,71,66,32,114,101,110,100,101,114,105,110,103,32,105,110,116,101,110,116,0,105,110,99,111,110,115,105,115,116,101,110,116,32,114,101,110,100,101,114,105,110,103,32,105,110,116,101,110,116,115,0,100,117,112,108,105,99,97,116,101,32,115,82,71,66,32,105,110,102,111,114,109,97,116,105,111,110,32,105,103,110,111,114,101,100,0,99,72,82,77,32,99,104,117,110,107,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,115,82,71,66,0,39,58,32,0,104,58,32,0,105,110,118,97,108,105,100,32,108,101,110,103,116,104,0,116,97,103,32,99,111,117,110,116,32,116,111,111,32,108,97,114,103,101,0,105,110,118,97,108,105,100,32,114,101,110,100,101,114,105,110,103,32,105,110,116,101,110,116,0,105,110,116,101,110,116,32,111,117,116,115,105,100,101,32,100,101,102,105,110,101,100,32,114,97,110,103,101,0,105,110,118,97,108,105,100,32,115,105,103,110,97,116,117,114,101,0,80,67,83,32,105,108,108,117,109,105,110,97,110,116,32,105,115,32,110,111,116,32,68,53,48,0,82,71,66,32,99,111,108,111,114,32,115,112,97,99,101,32,110,111,116,32,112,101,114,109,105,116,116,101,100,32,111,110,32,103,114,97,121,115,99,97,108,101,32,80,78,71,0,71,114,97,121,32,99,111,108,111,114,32,115,112,97,99,101,32,110,111,116,32,112,101,114,109,105,116,116,101,100,32,111,110,32,82,71,66,32,80,78,71,0,105,110,118,97,108,105,100,32,73,67,67,32,112,114,111,102,105,108,101,32,99,111,108,111,114,32,115,112,97,99,101,0,105,110,118,97,108,105,100,32,101,109,98,101,100,100,101,100,32,65,98,115,116,114,97,99,116,32,73,67,67,32,112,114,111,102,105,108,101,0,117,110,101,120,112,101,99,116,101,100,32,68,101,118,105,99,101,76,105,110,107,32,73,67,67,32,112,114,111,102,105,108,101,32,99,108,97,115,115,0,117,110,101,120,112,101,99,116,101,100,32,78,97,109,101,100,67,111,108,111,114,32,73,67,67,32,112,114,111,102,105,108,101,32,99,108,97,115,115,0,117,110,114,101,99,111,103,110,105,122,101,100,32,73,67,67,32,112,114,111,102,105,108,101,32,99,108,97,115,115,0,117,110,101,120,112,101,99,116,101,100,32,73,67,67,32,80,67,83,32,101,110,99,111,100,105,110,103,0,73,67,67,32,112,114,111,102,105,108,101,32,116,97,103,32,115,116,97,114,116,32,110,111,116,32,97,32,109,117,108,116,105,112,108,101,32,111,102,32,52,0,73,67,67,32,112,114,111,102,105,108,101,32,116,97,103,32,111,117,116,115,105,100,101,32,112,114,111,102,105,108,101,0,107,110,111,119,110,32,105,110,99,111,114,114,101,99,116,32,115,82,71,66,32,112,114,111,102,105,108,101,0,111,117,116,45,111,102,45,100,97,116,101,32,115,82,71,66,32,112,114,111,102,105,108,101,32,119,105,116,104,32,110,111,32,115,105,103,110,97,116,117,114,101,0,78,111,116,32,114,101,99,111,103,110,105,122,105,110,103,32,107,110,111,119,110,32,115,82,71,66,32,112,114,111,102,105,108,101,32,116,104,97,116,32,104,97,115,32,98,101,101,110,32,101,100,105,116,101,100,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,32,104,97,110,100,108,105,110,103,32,99,72,82,77,32,99,111,101,102,102,105,99,105,101,110,116,115,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,32,104,97,110,100,108,105,110,103,32,99,72,82,77,45,62,88,89,90,0,73,109,97,103,101,32,119,105,100,116,104,32,105,115,32,122,101,114,111,32,105,110,32,73,72,68,82,0,73,110,118,97,108,105,100,32,105,109,97,103,101,32,119,105,100,116,104,32,105,110,32,73,72,68,82,0,73,109,97,103,101,32,119,105,100,116,104,32,105,115,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,116,104,105,115,32,97,114,99,104,105,116,101,99,116,117,114,101,0,73,109,97,103,101,32,119,105,100,116,104,32,101,120,99,101,101,100,115,32,117,115,101,114,32,108,105,109,105,116,32,105,110,32,73,72,68,82,0,73,109,97,103,101,32,104,101,105,103,104,116,32,105,115,32,122,101,114,111,32,105,110,32,73,72,68,82,0,73,110,118,97,108,105,100,32,105,109,97,103,101,32,104,101,105,103,104,116,32,105,110,32,73,72,68,82,0,73,109,97,103,101,32,104,101,105,103,104,116,32,101,120,99,101,101,100,115,32,117,115,101,114,32,108,105,109,105,116,32,105,110,32,73,72,68,82,0,73,110,118,97,108,105,100,32,98,105,116,32,100,101,112,116,104,32,105,110,32,73,72,68,82,0,73,110,118,97,108,105,100,32,99,111,108,111,114,32,116,121,112,101,32,105,110,32,73,72,68,82,0,73,110,118,97,108,105,100,32,99,111,108,111,114,32,116,121,112,101,47,98,105,116,32,100,101,112,116,104,32,99,111,109,98,105,110,97,116,105,111,110,32,105,110,32,73,72,68,82,0,85,110,107,110,111,119,110,32,105,110,116,101,114,108,97,99,101,32,109,101,116,104,111,100,32,105,110,32,73,72,68,82,0,85,110,107,110,111,119,110,32,99,111,109,112,114,101,115,115,105,111,110,32,109,101,116,104,111,100,32,105,110,32,73,72,68,82,0,85,110,107,110,111,119,110,32,102,105,108,116,101,114,32,109,101,116,104,111,100,32,105,110,32,73,72,68,82,0,73,110,118,97,108,105,100,32,102,105,108,116,101,114,32,109,101,116,104,111,100,32,105,110,32,73,72,68,82,0,73,110,118,97,108,105,100,32,73,72,68,82,32,100,97,116,97,0,103,97,109,109,97,32,116,97,98,108,101,32,98,101,105,110,103,32,114,101,98,117,105,108,116,0,117,110,100,101,102,105,110,101,100,0,108,105,98,112,110,103,32,101,114,114,111,114,58,32,37,115,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,108,105,98,112,110,103,32,119,97,114,110,105,110,103,58,32,37,115,0,49,50,51,52,53,54,55,56,57,0,76,105,98,112,110,103,32,106,109,112,95,98,117,102,32,115,116,105,108,108,32,97,108,108,111,99,97,116,101,100,0,65,112,112,108,105,99,97,116,105,111,110,32,106,109,112,95,98,117,102,32,115,105,122,101,32,99,104,97,110,103,101,100,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,97,114,114,97,121,32,97,108,108,111,99,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,97,114,114,97,121,32,114,101,97,108,108,111,99,0,77,105,115,115,105,110,103,32,73,72,68,82,32,98,101,102,111,114,101,32,73,68,65,84,0,77,105,115,115,105,110,103,32,80,76,84,69,32,98,101,102,111,114,101,32,73,68,65,84,0,84,111,111,32,109,97,110,121,32,73,68,65,84,115,32,102,111,117,110,100,0,112,110,103,95,114,101,97,100,95,117,112,100,97,116,101,95,105,110,102,111,47,112,110,103,95,115,116,97,114,116,95,114,101,97,100,95,105,109,97,103,101,58,32,100,117,112,108,105,99,97,116,101,32,99,97,108,108,0,73,110,118,97,108,105,100,32,97,116,116,101,109,112,116,32,116,111,32,114,101,97,100,32,114,111,119,32,100,97,116,97,0,98,97,100,32,97,100,97,112,116,105,118,101,32,102,105,108,116,101,114,32,118,97,108,117,101,0,115,101,113,117,101,110,116,105,97,108,32,114,111,119,32,111,118,101,114,102,108,111,119,0,105,110,116,101,114,110,97,108,32,115,101,113,117,101,110,116,105,97,108,32,114,111,119,32,115,105,122,101,32,99,97,108,99,117,108,97,116,105,111,110,32,101,114,114,111,114,0,73,110,116,101,114,108,97,99,101,32,104,97,110,100,108,105,110,103,32,115,104,111,117,108,100,32,98,101,32,116,117,114,110,101,100,32,111,110,32,119,104,101,110,32,117,115,105,110,103,32,112,110,103,95,114,101,97,100,95,105,109,97,103,101,0,82,101,97,100,32,112,97,108,101,116,116,101,32,105,110,100,101,120,32,101,120,99,101,101,100,105,110,103,32,110,117,109,95,112,97,108,101,116,116,101,0,67,97,108,108,32,116,111,32,78,85,76,76,32,114,101,97,100,32,102,117,110,99,116,105,111,110,0,82,101,97,100,32,69,114,114,111,114,0,105,110,118,97,108,105,100,32,97,102,116,101,114,32,112,110,103,95,115,116,97,114,116,95,114,101,97,100,95,105,109,97,103,101,32,111,114,32,112,110,103,95,114,101,97,100,95,117,112,100,97,116,101,95,105,110,102,111,0,105,110,118,97,108,105,100,32,98,101,102,111,114,101,32,116,104,101,32,80,78,71,32,104,101,97,100,101,114,32,104,97,115,32,98,101,101,110,32,114,101,97,100,0,108,105,98,112,110,103,32,100,111,101,115,32,110,111,116,32,115,117,112,112,111,114,116,32,103,97,109,109,97,43,98,97,99,107,103,114,111,117,110,100,43,114,103,98,95,116,111,95,103,114,97,121,0,105,110,118,97,108,105,100,32,98,97,99,107,103,114,111,117,110,100,32,103,97,109,109,97,32,116,121,112,101,0,80,97,108,101,116,116,101,32,105,115,32,78,85,76,76,32,105,110,32,105,110,100,101,120,101,100,32,105,109,97,103,101,0,78,85,76,76,32,114,111,119,32,98,117,102,102,101,114,0,85,110,105,110,105,116,105,97,108,105,122,101,100,32,114,111,119,0,112,110,103,95,100,111,95,114,103,98,95,116,111,95,103,114,97,121,32,102,111,117,110,100,32,110,111,110,103,114,97,121,32,112,105,120,101,108,0,112,110,103,95,100,111,95,101,110,99,111,100,101,95,97,108,112,104,97,58,32,117,110,101,120,112,101,99,116,101,100,32,99,97,108,108,0,112,110,103,95,100,111,95,113,117,97,110,116,105,122,101,32,114,101,116,117,114,110,101,100,32,114,111,119,98,121,116,101,115,61,48,0,80,78,71,32,117,110,115,105,103,110,101,100,32,105,110,116,101,103,101,114,32,111,117,116,32,111,102,32,114,97,110,103,101,0,78,111,116,32,97,32,80,78,71,32,102,105,108,101,0,80,78,71,32,102,105,108,101,32,99,111,114,114,117,112,116,101,100,32,98,121,32,65,83,67,73,73,32,99,111,110,118,101,114,115,105,111,110,0,105,110,118,97,108,105,100,32,99,104,117,110,107,32,116,121,112,101,0,67,82,67,32,101,114,114,111,114,0,111,117,116,32,111,102,32,112,108,97,99,101,0,105,110,118,97,108,105,100,0,109,105,115,115,105,110,103,32,73,72,68,82,0,100,117,112,108,105,99,97,116,101,0,105,103,110,111,114,101,100,32,105,110,32,103,114,97,121,115,99,97,108,101,32,80,78,71,0,116,82,78,83,32,109,117,115,116,32,98,101,32,97,102,116,101,114,0,104,73,83,84,32,109,117,115,116,32,98,101,32,97,102,116,101,114,0,98,75,71,68,32,109,117,115,116,32,98,101,32,97,102,116,101,114,0,105,110,118,97,108,105,100,32,118,97,108,117,101,115,0,116,111,111,32,109,97,110,121,32,112,114,111,102,105,108,101,115,0,116,111,111,32,115,104,111,114,116,0,101,120,116,114,97,32,99,111,109,112,114,101,115,115,101,100,32,100,97,116,97,0,116,114,117,110,99,97,116,101,100,0,98,97,100,32,107,101,121,119,111,114,100,0,98,97,100,32,99,111,109,112,114,101,115,115,105,111,110,32,109,101,116,104],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+403700);allocate([111,100,0,122,115,116,114,101,97,109,32,117,110,99,108,97,105,109,101,100,0,78,111,32,115,112,97,99,101,32,105,110,32,99,104,117,110,107,32,99,97,99,104,101,32,102,111,114,32,115,80,76,84,0,109,97,108,102,111,114,109,101,100,32,115,80,76,84,32,99,104,117,110,107,0,115,80,76,84,32,99,104,117,110,107,32,104,97,115,32,98,97,100,32,108,101,110,103,116,104,0,115,80,76,84,32,99,104,117,110,107,32,116,111,111,32,108,111,110,103,0,115,80,76,84,32,99,104,117,110,107,32,114,101,113,117,105,114,101,115,32,116,111,111,32,109,117,99,104,32,109,101,109,111,114,121,0,105,110,118,97,108,105,100,32,119,105,116,104,32,97,108,112,104,97,32,99,104,97,110,110,101,108,0,105,110,118,97,108,105,100,32,105,110,100,101,120,0,105,110,118,97,108,105,100,32,112,97,114,97,109,101,116,101,114,32,99,111,117,110,116,0,117,110,114,101,99,111,103,110,105,122,101,100,32,101,113,117,97,116,105,111,110,32,116,121,112,101,0,105,110,118,97,108,105,100,32,100,97,116,97,0,105,110,118,97,108,105,100,32,117,110,105,116,0,98,97,100,32,119,105,100,116,104,32,102,111,114,109,97,116,0,110,111,110,45,112,111,115,105,116,105,118,101,32,119,105,100,116,104,0,98,97,100,32,104,101,105,103,104,116,32,102,111,114,109,97,116,0,110,111,110,45,112,111,115,105,116,105,118,101,32,104,101,105,103,104,116,0,110,111,32,115,112,97,99,101,32,105,110,32,99,104,117,110,107,32,99,97,99,104,101,0,105,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,32,116,111,32,114,101,97,100,32,99,104,117,110,107,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,32,116,111,32,112,114,111,99,101,115,115,32,116,101,120,116,32,99,104,117,110,107,0,117,110,107,110,111,119,110,32,99,111,109,112,114,101,115,115,105,111,110,32,116,121,112,101,0,98,97,100,32,99,111,109,112,114,101,115,115,105,111,110,32,105,110,102,111,0,101,114,114,111,114,32,105,110,32,117,115,101,114,32,99,104,117,110,107,0,83,97,118,105,110,103,32,117,110,107,110,111,119,110,32,99,104,117,110,107,58,0,102,111,114,99,105,110,103,32,115,97,118,101,32,111,102,32,97,110,32,117,110,104,97,110,100,108,101,100,32,99,104,117,110,107,59,32,112,108,101,97,115,101,32,99,97,108,108,32,112,110,103,95,115,101,116,95,107,101,101,112,95,117,110,107,110,111,119,110,95,99,104,117,110,107,115,0,117,110,104,97,110,100,108,101,100,32,99,114,105,116,105,99,97,108,32,99,104,117,110,107,0,117,110,107,110,111,119,110,32,99,104,117,110,107,32,101,120,99,101,101,100,115,32,109,101,109,111,114,121,32,108,105,109,105,116,115,0,105,110,116,101,114,110,97,108,32,114,111,119,32,108,111,103,105,99,32,101,114,114,111,114,0,105,110,116,101,114,110,97,108,32,114,111,119,32,115,105,122,101,32,99,97,108,99,117,108,97,116,105,111,110,32,101,114,114,111,114,0,105,110,116,101,114,110,97,108,32,114,111,119,32,119,105,100,116,104,32,101,114,114,111,114,0,105,110,118,97,108,105,100,32,117,115,101,114,32,116,114,97,110,115,102,111,114,109,32,112,105,120,101,108,32,100,101,112,116,104,0,78,111,116,32,101,110,111,117,103,104,32,105,109,97,103,101,32,100,97,116,97,0,69,120,116,114,97,32,99,111,109,112,114,101,115,115,101,100,32,100,97,116,97,0,84,111,111,32,109,117,99,104,32,105,109,97,103,101,32,100,97,116,97,0,82,111,119,32,104,97,115,32,116,111,111,32,109,97,110,121,32,98,121,116,101,115,32,116,111,32,97,108,108,111,99,97,116,101,32,105,110,32,109,101,109,111,114,121,0,73,110,118,97,108,105,100,32,112,97,108,101,116,116,101,32,115,105,122,101,44,32,104,73,83,84,32,97,108,108,111,99,97,116,105,111,110,32,115,107,105,112,112,101,100,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,32,102,111,114,32,104,73,83,84,32,99,104,117,110,107,32,100,97,116,97,0,73,110,118,97,108,105,100,32,112,67,65,76,32,101,113,117,97,116,105,111,110,32,116,121,112,101,0,73,110,118,97,108,105,100,32,102,111,114,109,97,116,32,102,111,114,32,112,67,65,76,32,112,97,114,97,109,101,116,101,114,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,32,102,111,114,32,112,67,65,76,32,112,117,114,112,111,115,101,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,32,102,111,114,32,112,67,65,76,32,117,110,105,116,115,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,32,102,111,114,32,112,67,65,76,32,112,97,114,97,109,115,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,32,102,111,114,32,112,67,65,76,32,112,97,114,97,109,101,116,101,114,0,73,110,118,97,108,105,100,32,115,67,65,76,32,117,110,105,116,0,73,110,118,97,108,105,100,32,115,67,65,76,32,119,105,100,116,104,0,73,110,118,97,108,105,100,32,115,67,65,76,32,104,101,105,103,104,116,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,119,104,105,108,101,32,112,114,111,99,101,115,115,105,110,103,32,115,67,65,76,0,73,110,118,97,108,105,100,32,112,97,108,101,116,116,101,32,108,101,110,103,116,104,0,73,110,118,97,108,105,100,32,112,97,108,101,116,116,101,0,116,111,111,32,109,97,110,121,32,116,101,120,116,32,99,104,117,110,107,115,0,116,101,120,116,32,99,111,109,112,114,101,115,115,105,111,110,32,109,111,100,101,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,116,101,120,116,32,99,104,117,110,107,58,32,111,117,116,32,111,102,32,109,101,109,111,114,121,0,73,103,110,111,114,105,110,103,32,105,110,118,97,108,105,100,32,116,105,109,101,32,118,97,108,117,101,0,116,82,78,83,32,99,104,117,110,107,32,104,97,115,32,111,117,116,45,111,102,45,114,97,110,103,101,32,115,97,109,112,108,101,115,32,102,111,114,32,98,105,116,95,100,101,112,116,104,0,116,111,111,32,109,97,110,121,32,115,80,76,84,32,99,104,117,110,107,115,0,112,110,103,95,115,101,116,95,115,80,76,84,58,32,105,110,118,97,108,105,100,32,115,80,76,84,0,115,80,76,84,32,111,117,116,32,111,102,32,109,101,109,111,114,121,0,116,111,111,32,109,97,110,121,32,117,110,107,110,111,119,110,32,99,104,117,110,107,115,0,112,110,103,95,115,101,116,95,117,110,107,110,111,119,110,95,99,104,117,110,107,115,32,110,111,119,32,101,120,112,101,99,116,115,32,97,32,118,97,108,105,100,32,108,111,99,97,116,105,111,110,0,105,110,118,97,108,105,100,32,108,111,99,97,116,105,111,110,32,105,110,32,112,110,103,95,115,101,116,95,117,110,107,110,111,119,110,95,99,104,117,110,107,115,0,117,110,107,110,111,119,110,32,99,104,117,110,107,58,32,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,64,128,192,16,80,144,208,32,96,160,224,48,112,176,240,4,68,132,196,20,84,148,212,36,100,164,228,52,116,180,244,8,72,136,200,24,88,152,216,40,104,168,232,56,120,184,248,12,76,140,204,28,92,156,220,44,108,172,236,60,124,188,252,1,65,129,193,17,81,145,209,33,97,161,225,49,113,177,241,5,69,133,197,21,85,149,213,37,101,165,229,53,117,181,245,9,73,137,201,25,89,153,217,41,105,169,233,57,121,185,249,13,77,141,205,29,93,157,221,45,109,173,237,61,125,189,253,2,66,130,194,18,82,146,210,34,98,162,226,50,114,178,242,6,70,134,198,22,86,150,214,38,102,166,230,54,118,182,246,10,74,138,202,26,90,154,218,42,106,170,234,58,122,186,250,14,78,142,206,30,94,158,222,46,110,174,238,62,126,190,254,3,67,131,195,19,83,147,211,35,99,163,227,51,115,179,243,7,71,135,199,23,87,151,215,39,103,167,231,55,119,183,247,11,75,139,203,27,91,155,219,43,107,171,235,59,123,187,251,15,79,143,207,31,95,159,223,47,111,175,239,63,127,191,255,0,16,32,48,64,80,96,112,128,144,160,176,192,208,224,240,1,17,33,49,65,81,97,113,129,145,161,177,193,209,225,241,2,18,34,50,66,82,98,114,130,146,162,178,194,210,226,242,3,19,35,51,67,83,99,115,131,147,163,179,195,211,227,243,4,20,36,52,68,84,100,116,132,148,164,180,196,212,228,244,5,21,37,53,69,85,101,117,133,149,165,181,197,213,229,245,6,22,38,54,70,86,102,118,134,150,166,182,198,214,230,246,7,23,39,55,71,87,103,119,135,151,167,183,199,215,231,247,8,24,40,56,72,88,104,120,136,152,168,184,200,216,232,248,9,25,41,57,73,89,105,121,137,153,169,185,201,217,233,249,10,26,42,58,74,90,106,122,138,154,170,186,202,218,234,250,11,27,43,59,75,91,107,123,139,155,171,187,203,219,235,251,12,28,44,60,76,92,108,124,140,156,172,188,204,220,236,252,13,29,45,61,77,93,109,125,141,157,173,189,205,221,237,253,14,30,46,62,78,94,110,126,142,158,174,190,206,222,238,254,15,31,47,63,79,95,111,127,143,159,175,191,207,223,239,255,0,128,64,192,32,160,96,224,16,144,80,208,48,176,112,240,8,136,72,200,40,168,104,232,24,152,88,216,56,184,120,248,4,132,68,196,36,164,100,228,20,148,84,212,52,180,116,244,12,140,76,204,44,172,108,236,28,156,92,220,60,188,124,252,2,130,66,194,34,162,98,226,18,146,82,210,50,178,114,242,10,138,74,202,42,170,106,234,26,154,90,218,58,186,122,250,6,134,70,198,38,166,102,230,22,150,86,214,54,182,118,246,14,142,78,206,46,174,110,238,30,158,94,222,62,190,126,254,1,129,65,193,33,161,97,225,17,145,81,209,49,177,113,241,9,137,73,201,41,169,105,233,25,153,89,217,57,185,121,249,5,133,69,197,37,165,101,229,21,149,85,213,53,181,117,245,13,141,77,205,45,173,109,237,29,157,93,221,61,189,125,253,3,131,67,195,35,163,99,227,19,147,83,211,51,179,115,243,11,139,75,203,43,171,107,235,27,155,91,219,59,187,123,251,7,135,71,199,39,167,103,231,23,151,87,215,55,183,119,247,15,143,79,207,47,175,111,239,31,159,95,223,63,191,127,255,67,97,108,108,32,116,111,32,78,85,76,76,32,119,114,105,116,101,32,102,117,110,99,116,105,111,110,0,87,114,105,116,101,32,69,114,114,111,114,0,67,97,110,39,116,32,115,101,116,32,98,111,116,104,32,114,101,97,100,95,100,97,116,97,95,102,110,32,97,110,100,32,119,114,105,116,101,95,100,97,116,97,95,102,110,32,105,110,32,116,104,101,32,115,97,109,101,32,115,116,114,117,99,116,117,114,101,0,77,78,71,32,102,101,97,116,117,114,101,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,97,32,80,78,71,32,100,97,116,97,115,116,114,101,97,109,0,112,114,111,102,105,108,101,32,109,97,116,99,104,101,115,32,115,82,71,66,32,98,117,116,32,119,114,105,116,105,110,103,32,105,67,67,80,32,105,110,115,116,101,97,100,0,87,114,105,116,105,110,103,32,122,101,114,111,45,108,101,110,103,116,104,32,117,110,107,110,111,119,110,32,99,104,117,110,107,0,86,97,108,105,100,32,112,97,108,101,116,116,101,32,114,101,113,117,105,114,101,100,32,102,111,114,32,112,97,108,101,116,116,101,100,32,105,109,97,103,101,115,0,78,111,32,73,68,65,84,115,32,119,114,105,116,116,101,110,32,105,110,116,111,32,102,105,108,101,0,87,114,111,116,101,32,112,97,108,101,116,116,101,32,105,110,100,101,120,32,101,120,99,101,101,100,105,110,103,32,110,117,109,95,112,97,108,101,116,116,101,0,112,110,103,95,119,114,105,116,101,95,105,110,102,111,32,119,97,115,32,110,101,118,101,114,32,99,97,108,108,101,100,32,98,101,102,111,114,101,32,112,110,103,95,119,114,105,116,101,95,114,111,119,0,105,110,116,101,114,110,97,108,32,119,114,105,116,101,32,116,114,97,110,115,102,111,114,109,32,108,111,103,105,99,32,101,114,114,111,114,0,108,101,110,103,116,104,32,101,120,99,101,101,100,115,32,80,78,71,32,109,97,120,105,109,117,109,0,73,110,118,97,108,105,100,32,98,105,116,32,100,101,112,116,104,32,102,111,114,32,103,114,97,121,115,99,97,108,101,32,105,109,97,103,101,0,73,110,118,97,108,105,100,32,98,105,116,32,100,101,112,116,104,32,102,111,114,32,82,71,66,32,105,109,97,103,101,0,73,110,118,97,108,105,100,32,98,105,116,32,100,101,112,116,104,32,102,111,114,32,112,97,108,101,116,116,101,100,32,105,109,97,103,101,0,73,110,118,97,108,105,100,32,98,105,116,32,100,101,112,116,104,32,102,111,114,32,103,114,97,121,115,99,97,108,101,43,97,108,112,104,97,32,105,109,97,103,101,0,73,110,118,97,108,105,100,32,98,105,116,32,100,101,112,116,104,32,102,111,114,32,82,71,66,65,32,105,109,97,103,101,0,73,110,118,97,108,105,100,32,105,109,97,103,101,32,99,111,108,111,114,32,116,121,112,101,32,115,112,101,99,105,102,105,101,100,0,73,110,118,97,108,105,100,32,99,111,109,112,114,101,115,115,105,111,110,32,116,121,112,101,32,115,112,101,99,105,102,105,101,100,0,73,110,118,97,108,105,100,32,102,105,108,116,101,114,32,116,121,112,101,32,115,112,101,99,105,102,105,101,100,0,73,110,118,97,108,105,100,32,105,110,116,101,114,108,97,99,101,32,116,121,112,101,32,115,112,101,99,105,102,105,101,100,0,73,110,118,97,108,105,100,32,110,117,109,98,101,114,32,111,102,32,99,111,108,111,114,115,32,105,110,32,112,97,108,101,116,116,101,0,73,103,110,111,114,105,110,103,32,114,101,113,117,101,115,116,32,116,111,32,119,114,105,116,101,32,97,32,80,76,84,69,32,99,104,117,110,107,32,105,110,32,103,114,97,121,115,99,97,108,101,32,80,78,71,0,90,95,79,75,32,111,110,32,90,95,70,73,78,73,83,72,32,119,105,116,104,32,111,117,116,112,117,116,32,115,112,97,99,101,0,105,110,32,117,115,101,32,98,121,32,73,68,65,84,0,100,101,102,108,97,116,101,69,110,100,32,102,97,105,108,101,100,32,40,105,103,110,111,114,101,100,41,0,73,110,118,97,108,105,100,32,115,82,71,66,32,114,101,110,100,101,114,105,110,103,32,105,110,116,101,110,116,32,115,112,101,99,105,102,105,101,100,0,78,111,32,112,114,111,102,105,108,101,32,102,111,114,32,105,67,67,80,32,99,104,117,110,107,0,73,67,67,32,112,114,111,102,105,108,101,32,116,111,111,32,115,104,111,114,116,0,73,67,67,32,112,114,111,102,105,108,101,32,108,101,110,103,116,104,32,105,110,118,97,108,105,100,32,40,110,111,116,32,97,32,109,117,108,116,105,112,108,101,32,111,102,32,52,41,0,105,67,67,80,58,32,105,110,118,97,108,105,100,32,107,101,121,119,111,114,100,0,101,114,114,111,114,32,119,114,105,116,105,110,103,32,97,110,99,105,108,108,97,114,121,32,99,104,117,110,107,101,100,32,99,111,109,112,114,101,115,115,101,100,32,100,97,116,97,0,99,111,109,112,114,101,115,115,101,100,32,100,97,116,97,32,116,111,111,32,108,111,110,103,0,107,101,121,119,111,114,100,32,116,114,117,110,99,97,116,101,100,0,107,101,121,119,111,114,100,32,34,64,49,34,58,32,98,97,100,32,99,104,97,114,97,99,116,101,114,32,39,48,120,64,50,39,0,115,80,76,84,58,32,105,110,118,97,108,105,100,32,107,101,121,119,111,114,100,0,73,110,118,97,108,105,100,32,115,66,73,84,32,100,101,112,116,104,32,115,112,101,99,105,102,105,101,100,0,73,110,118,97,108,105,100,32,110,117,109,98,101,114,32,111,102,32,116,114,97,110,115,112,97,114,101,110,116,32,99,111,108,111,114,115,32,115,112,101,99,105,102,105,101,100,0,73,103,110,111,114,105,110,103,32,97,116,116,101,109,112,116,32,116,111,32,119,114,105,116,101,32,116,82,78,83,32,99,104,117,110,107,32,111,117,116,45,111,102,45,114,97,110,103,101,32,102,111,114,32,98,105,116,95,100,101,112,116,104,0,73,103,110,111,114,105,110,103,32,97,116,116,101,109,112,116,32,116,111,32,119,114,105,116,101,32,49,54,45,98,105,116,32,116,82,78,83,32,99,104,117,110,107,32,119,104,101,110,32,98,105,116,95,100,101,112,116,104,32,105,115,32,56,0,67,97,110,39,116,32,119,114,105,116,101,32,116,82,78,83,32,119,105,116,104,32,97,110,32,97,108,112,104,97,32,99,104,97,110,110,101,108,0,73,110,118,97,108,105,100,32,98,97,99,107,103,114,111,117,110,100,32,112,97,108,101,116,116,101,32,105,110,100,101,120,0,73,103,110,111,114,105,110,103,32,97,116,116,101,109,112,116,32,116,111,32,119,114,105,116,101,32,49,54,45,98,105,116,32,98,75,71,68,32,99,104,117,110,107,32,119,104,101,110,32,98,105,116,95,100,101,112,116,104,32,105,115,32,56,0,73,103,110,111,114,105,110,103,32,97,116,116,101,109,112,116,32,116,111,32,119,114,105,116,101,32,98,75,71,68,32,99,104,117,110,107,32,111,117,116,45,111,102,45,114,97,110,103,101,32,102,111,114,32,98,105,116,95,100,101,112,116,104,0,73,110,118,97,108,105,100,32,110,117,109,98,101,114,32,111,102,32,104,105,115,116,111,103,114,97,109,32,101,110,116,114,105,101,115,32,115,112,101,99,105,102,105,101,100,0,116,69,88,116,58,32,105,110,118,97,108,105,100,32,107,101,121,119,111,114,100,0,116,69,88,116,58,32,116,101,120,116,32,116,111,111,32,108,111,110,103,0,122,84,88,116,58,32,105,110,118,97,108,105,100,32,99,111,109,112,114,101,115,115,105,111,110,32,116,121,112,101,0,122,84,88,116,58,32,105,110,118,97,108,105,100,32,107,101,121,119,111,114,100,0,105,84,88,116,58,32,105,110,118,97,108,105,100,32,107,101,121,119,111,114,100,0,105,84,88,116,58,32,105,110,118,97,108,105,100,32,99,111,109,112,114,101,115,115,105,111,110,0,105,84,88,116,58,32,117,110,99,111,109,112,114,101,115,115,101,100,32,116,101,120,116,32,116,111,111,32,108,111,110,103,0,85,110,114,101,99,111,103,110,105,122,101,100,32,117,110,105,116,32,116,121,112,101,32,102,111,114,32,111,70,70,115,32,99,104,117,110,107,0,85,110,114,101,99,111,103,110,105,122,101,100,32,101,113,117,97,116,105,111,110,32,116,121,112,101,32,102,111,114,32,112,67,65,76,32,99,104,117,110,107,0,112,67,65,76,58,32,105,110,118,97,108,105,100,32,107,101,121,119,111,114,100,0,67,97,110,39,116,32,119,114,105,116,101,32,115,67,65,76,32,40,98,117,102,102,101,114,32,116,111,111,32,115,109,97,108,108,41,0,85,110,114,101,99,111,103,110,105,122,101,100,32,117,110,105,116,32,116,121,112,101,32,102,111,114,32,112,72,89,115,32,99,104,117,110,107,0,73,110,118,97,108,105,100,32,116,105,109,101,32,115,112,101,99,105,102,105,101,100,32,102,111,114,32,116,73,77,69,32,99,104,117,110,107,0,8,8,4,4,2,2,1,0,4,0,2,0,1,0,8,8,8,4,4,2,2,0,0,4,0,2,0,1,37,115,0,37,115,37,115,37,115,0,58,32,0,117,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,102,105,108,101,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,105,110,102,108,97,116,101,32,115,116,114,101,97,109,32,99,111,114,114,117,112,116,0,99,111,109,112,114,101,115,115,101,100,32,100,97,116,97,32,101,114,114,111,114,0,114,101,113,117,101,115,116,101,100,32,108,101,110,103,116,104,32,100,111,101,115,32,110,111,116,32,102,105,116,32,105,110,32,105,110,116,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,100,101,102,108,97,116,101,32,115,116,114,101,97,109,32,99,111,114,114,117,112,116,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,49,46,50,46,56,0,105,110,99,111,114,114,101,99,116,32,104,101,97,100,101,114,32,99,104,101,99,107,0,117,110,107,110,111,119,110,32,99,111,109,112,114,101,115,115,105,111,110,32,109,101,116,104,111,100,0,105,110,118,97,108,105,100,32,119,105,110,100,111,119,32,115,105,122,101,0,117,110,107,110,111,119,110,32,104,101,97,100,101,114,32,102,108,97,103,115,32,115,101,116,0,104,101,97,100,101,114,32,99,114,99,32,109,105,115,109,97,116,99,104,0,105,110,118,97,108,105,100,32,98,108,111,99,107,32,116,121,112,101,0,105,110,118,97,108,105,100,32,115,116,111,114,101,100,32,98,108,111,99,107,32,108,101,110,103,116,104,115,0,116,111,111,32,109,97,110,121,32,108,101,110,103,116,104,32,111,114,32,100,105,115,116,97,110,99,101,32,115,121,109,98,111,108,115,0,105,110,118,97,108,105,100,32,99,111,100,101,32,108,101,110,103,116,104,115,32,115,101,116,0,105,110,118,97,108,105,100,32,98,105,116,32,108,101,110,103,116,104,32,114,101,112,101,97,116,0,105,110,118,97,108,105,100,32,99,111,100,101,32,45,45,32,109,105,115,115,105,110,103,32,101,110,100,45,111,102,45,98,108,111,99,107,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,115,32,115,101,116,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,115,32,115,101,116,0,105,110,99,111,114,114,101,99,116,32,100,97,116,97,32,99,104,101,99,107,0,105,110,99,111,114,114,101,99,116,32,108,101,110,103,116,104,32,99,104,101,99,107,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,116,111,111,32,102,97,114,32,98,97,99,107,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,99,111,100,101,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,32,99,111,100,101,0,0,1,2,3,4,4,5,5,6,6,6,6,7,7,7,7,8,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0,0,16,17,18,18,19,19,20,20,20,20,21,21,21,21,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,0,1,2,3,4,5,6,7,8,8,9,9,10,10,11,11,12,12,12,12,13,13,13,13,14,14,14,14,15,15,15,15,16,16,16,16,16,16,16,16,17,17,17,17,17,17,17,17,18,18,18,18,18,18,18,18,19,19,19,19,19,19,19,19,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,28,16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15,115,116,114,101,97,109,32,101,114,114,111,114,0,105,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,0,98,117,102,102,101,114,32,101,114,114,111,114,0,118,111,105,100,0,98,111,111,108,0,99,104,97,114,0,115,105,103,110,101,100,32,99,104,97,114,0,117,110,115,105,103,110,101,100,32,99,104,97,114,0,115,104,111,114,116,0,117,110,115,105,103,110,101,100,32,115,104,111,114,116,0,105,110,116,0,117,110,115,105,103,110,101,100,32,105,110,116,0,108,111,110,103,0,117,110,115,105,103,110,101,100,32,108,111,110,103,0,102,108,111,97,116,0,100,111,117,98,108,101,0,115,116,100,58,58,115,116,114,105,110,103,0,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,0,115,116,100,58,58,119,115,116,114,105,110,103,0,101,109,115,99,114,105,112,116,101,110,58,58,118,97,108,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,115,105,103,110,101,100,32,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,115,104,111,114,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,105,110,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,108,111,110,103,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,108,111,110,103,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,56,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,56,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,49,54,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,49,54,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,51,50,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,51,50,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,102,108,111,97,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,100,111,117,98,108,101,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,108,111,110,103,32,100,111,117,98,108,101,62,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,101,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,109,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,108,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,106,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,97,69,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,104,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,104,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,104,69,69,69,69,0,17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,45,43,32,32,32,48,88,48,120,0,40,110,117,108,108,41,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,105,110,102,0,73,78,70,0,78,65,78,0,46,0,84,33,34,25,13,1,2,3,17,75,28,12,16,4,11,29,18,30,39,104,110,111,112,113,98,32,5,6,15,19,20,21,26,8,22,7,40,36,23,24,9,10,14,27,31,37,35,131,130,125,38,42,43,60,61,62,63,67,71,74,77,88,89,90,91,92,93,94,95,96,97,99,100,101,102,103,105,106,107,108,114,115,116,121,122,123,124,0,73,108,108,101,103,97,108,32,98,121,116,101,32,115,101,113,117,101,110,99,101,0,68,111,109,97,105,110,32,101,114,114,111,114,0,82,101,115,117,108,116,32,110,111,116,32,114,101,112,114,101,115,101,110,116,97,98,108,101,0,78,111,116,32,97,32,116,116,121,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,70,105,108,101,32,101,120,105,115,116,115,0,86,97,108,117,101,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,100,97,116,97,32,116,121,112,101,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,73,110,116,101,114,114,117,112,116,101,100,32,115,121,115,116,101,109,32,99,97,108,108,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,73,110,118,97,108,105,100,32,115,101,101,107,0,67,114,111,115,115,45,100,101,118,105,99,101,32,108,105,110,107,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,112,101,101,114,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,67,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,72,111,115,116,32,105,115,32,100,111,119,110,0,72,111,115,116,32,105,115,32,117,110,114,101,97,99,104,97,98,108,101,0,65,100,100,114,101,115,115,32,105,110,32,117,115,101,0,66,114,111,107,101,110,32,112,105,112,101,0,73,47,79,32,101,114,114,111,114,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,66,108,111,99,107,32,100,101,118,105,99,101,32,114,101,113,117,105,114,101,100,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,84,101,120,116,32,102,105,108,101,32,98,117,115,121,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,65,114,103,117,109,101,110,116,32,108,105,115,116,32,116,111,111,32,108,111,110,103,0,83,121,109,98,111,108,105,99,32,108,105,110,107,32,108,111,111,112,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111,110,103,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,78,111,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,115,32,97,118,97,105,108,97,98,108,101,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,0,66,97,100,32,97,100,100,114,101,115,115,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,119,111,117,108,100,32,111,99,99,117,114,0,83,116,97,116,101,32,110,111,116,32,114,101,99,111,118,101,114,97,98,108,101,0,80,114,101,118,105,111,117,115,32,111,119,110,101,114,32,100,105,101,100,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,78,111,32,109,101,115,115,97,103,101,32,111,102,32,100,101,115,105,114,101,100,32,116,121,112,101,0,73,100,101,110,116,105,102,105,101,114,32,114,101,109,111,118,101,100,0,68,101,118,105,99,101,32,110,111,116,32,97,32,115,116,114,101,97,109,0,78,111,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,0,68,101,118,105,99,101,32,116,105,109,101,111,117,116,0,79,117,116,32,111,102,32,115,116,114,101,97,109,115,32,114,101,115,111,117,114,99,101,115,0,76,105,110,107,32,104,97,115,32,98,101,101,110,32,115,101,118,101,114,101,100,0,80,114,111,116,111,99,111,108,32,101,114,114,111,114,0,66,97,100,32,109,101,115,115,97,103,101,0,70,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,105,110,32,98,97,100,32,115,116,97,116,101,0,78,111,116,32,97,32,115,111,99,107,101,116,0,68,101,115,116,105,110,97,116,105,111,110,32,97,100,100,114,101,115,115,32,114,101,113,117,105,114,101,100,0,77,101,115,115,97,103,101,32,116,111,111,32,108,97,114,103,101,0,80,114,111,116,111,99,111,108,32,119,114,111,110,103,32,116,121,112,101,32,102,111,114,32,115,111,99,107,101,116,0,80,114,111,116,111,99,111,108,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,80,114,111,116,111,99,111,108,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,83,111,99,107,101,116,32,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,80,114,111,116,111,99,111,108,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,100,100,114,101,115,115,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,112,114,111,116,111,99,111,108,0,65,100,100,114,101,115,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,78,101,116,119,111,114,107,32,105,115,32,100,111,119,110,0,78,101,116,119,111,114,107,32,117,110,114,101,97,99,104,97,98,108,101,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,110,101,116,119,111,114,107,0,67,111,110,110,101,99,116,105,111,110,32,97,98,111,114,116,101,100,0,78,111,32,98,117,102,102,101,114,32,115,112,97,99,101,32,97,118,97,105,108,97,98,108,101,0,83,111,99,107,101,116,32,105,115,32,99,111,110,110,101,99,116,101,100,0,83,111,99,107,101,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,67,97,110,110,111,116,32,115,101,110,100,32,97,102,116,101,114,32,115,111,99,107,101,116,32,115,104,117,116,100,111,119,110,0,79,112,101,114,97,116,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,112,114,111,103,114,101,115,115,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,83,116,97,108,101,32,102,105,108,101,32,104,97,110,100,108,101,0,82,101,109,111,116,101,32,73,47,79,32,101,114,114,111,114,0,81,117,111,116,97,32,101,120,99,101,101,100,101,100,0,78,111,32,109,101,100,105,117,109,32,102,111,117,110,100,0,87,114,111,110,103,32,109,101,100,105,117,109,32,116,121,112,101,0,78,111,32,101,114,114,111,114,32,105,110,102,111,114,109,97,116,105,111,110,0,0,88,88,88,88,88,88,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,4,7,3,6,5,0,105,110,102,105,110,105,116,121,0,110,97,110,0,114,119,97,0,119,43,0,47,116,109,112,0,47,116,109,112,47,116,37,120,45,37,120,0,78,83,116,51,95,95,50,56,105,111,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+413940);allocate([116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,99,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,119,69,69,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,37,112,0,67,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,37,112,0,0,0,0,76,0,108,108,0,37,0,0,0,0,0,108,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,37,73,58,37,77,58,37,83,32,37,112,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,65,77,0,80,77,0,74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,77,97,114,99,104,0,65,112,114,105,108,0,77,97,121,0,74,117,110,101,0,74,117,108,121,0,65,117,103,117,115,116,0,83,101,112,116,101,109,98,101,114,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,68,101,99,101,109,98,101,114,0,74,97,110,0,70,101,98,0,77,97,114,0,65,112,114,0,74,117,110,0,74,117,108,0,65,117,103,0,83,101,112,0,79,99,116,0,78,111,118,0,68,101,99,0,83,117,110,100,97,121,0,77,111,110,100,97,121,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,84,104,117,114,115,100,97,121,0,70,114,105,100,97,121,0,83,97,116,117,114,100,97,121,0,83,117,110,0,77,111,110,0,84,117,101,0,87,101,100,0,84,104,117,0,70,114,105,0,83,97,116,0,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,37,72,58,37,77,37,72,58,37,77,58,37,83,37,72,58,37,77,58,37,83,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,78,83,116,51,95,95,50,57,116,105,109,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,95,95,116,105,109,101,95,112,117,116,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,48,49,50,51,52,53,54,55,56,57,0,37,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,48,49,50,51,52,53,54,55,56,57,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,37,46,48,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,99,69,69,0,78,83,116,51,95,95,50,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,119,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,99,69,69,0,78,83,116,51,95,95,50,49,48,99,116,121,112,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,119,69,69,0,102,97,108,115,101,0,116,114,117,101,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,99,69,69,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,119,69,69,0,33,34,118,101,99,116,111,114,32,108,101,110,103,116,104,95,101,114,114,111,114,34,0,47,111,112,116,47,101,109,115,99,114,105,112,116,101,110,47,101,109,115,100,107,45,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,109,97,115,116,101,114,47,115,121,115,116,101,109,47,105,110,99,108,117,100,101,47,108,105,98,99,120,120,47,118,101,99,116,111,114,0,33,34,118,101,99,116,111,114,32,111,117,116,95,111,102,95,114,97,110,103,101,34,0,95,95,116,104,114,111,119,95,111,117,116,95,111,102,95,114,97,110,103,101,0,78,83,116,51,95,95,50,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,33,34,98,97,115,105,99,95,115,116,114,105,110,103,32,108,101,110,103,116,104,95,101,114,114,111,114,34,0,47,111,112,116,47,101,109,115,99,114,105,112,116,101,110,47,101,109,115,100,107,45,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,109,97,115,116,101,114,47,115,121,115,116,101,109,47,105,110,99,108,117,100,101,47,108,105,98,99,120,120,47,115,116,114,105,110,103,0,95,95,116,104,114,111,119,95,108,101,110,103,116,104,95,101,114,114,111,114,0,33,34,97,108,108,111,99,97,116,111,114,60,84,62,58,58,97,108,108,111,99,97,116,101,58,58,98,97,100,95,97,108,108,111,99,34,0,47,111,112,116,47,101,109,115,99,114,105,112,116,101,110,47,101,109,115,100,107,45,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,109,97,115,116,101,114,47,115,121,115,116,101,109,47,105,110,99,108,117,100,101,47,108,105,98,99,120,120,47,109,101,109,111,114,121,0,97,108,108,111,99,97,116,101,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,58,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,102,111,114,101,105,103,110,32,101,120,99,101,112,116,105,111,110,0,116,101,114,109,105,110,97,116,105,110,103,0,117,110,99,97,117,103,104,116,0,83,116,57,101,120,99,101,112,116,105,111,110,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,83,116,57,116,121,112,101,95,105,110,102,111,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,112,116,104,114,101,97,100,95,111,110,99,101,32,102,97,105,108,117,114,101,32,105,110,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,95,102,97,115,116,40,41,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,112,116,104,114,101,97,100,32,107,101,121,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,99,97,110,110,111,116,32,122,101,114,111,32,111,117,116,32,116,104,114,101,97,100,32,118,97,108,117,101,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,116,101,114,109,105,110,97,116,101,95,104,97,110,100,108,101,114,32,117,110,101,120,112,101,99,116,101,100,108,121,32,114,101,116,117,114,110,101,100,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,83,116,57,98,97,100,95,97,108,108,111,99,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,57,95,95,112,111,105,110,116,101,114,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,112,98,97,115,101,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,51,95,95,102,117,110,100,97,109,101,110,116,97,108,95,116,121,112,101,95,105,110,102,111,69,0,118,0,68,110,0,98,0,80,75,99,0,104,0,97,0,115,0,105,0,80,105,0,106,0,109,0,80,102,0,100,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,101,110,117,109,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+424180);var tempDoublePtr=STATICTOP;STATICTOP+=16;function _atexit(func,arg){__ATEXIT__.unshift({func:func,arg:arg})}function ___cxa_atexit(){return _atexit.apply(null,arguments)}var emval_symbols={};function embind_init_charCodes(){var codes=new Array(256);for(var i=0;i<256;++i){codes[i]=String.fromCharCode(i)}embind_charCodes=codes}var embind_charCodes=undefined;function readLatin1String(ptr){var ret="";var c=ptr;while(HEAPU8[c]){ret+=embind_charCodes[HEAPU8[c++]]}return ret}function getStringOrSymbol(address){var symbol=emval_symbols[address];if(symbol===undefined){return readLatin1String(address)}else{return symbol}}var emval_free_list=[];var emval_handle_array=[{},{value:undefined},{value:null},{value:true},{value:false}];function count_emval_handles(){var count=0;for(var i=5;i<emval_handle_array.length;++i){if(emval_handle_array[i]!==undefined){++count}}return count}function get_first_emval(){for(var i=5;i<emval_handle_array.length;++i){if(emval_handle_array[i]!==undefined){return emval_handle_array[i]}}return null}function init_emval(){Module["count_emval_handles"]=count_emval_handles;Module["get_first_emval"]=get_first_emval}function __emval_register(value){switch(value){case undefined:{return 1};case null:{return 2};case true:{return 3};case false:{return 4};default:{var handle=emval_free_list.length?emval_free_list.pop():emval_handle_array.length;emval_handle_array[handle]={refcount:1,value:value};return handle}}}function __emval_new_cstring(v){return __emval_register(getStringOrSymbol(v))}Module["_i64Subtract"]=_i64Subtract;Module["_i64Add"]=_i64Add;function __ZSt18uncaught_exceptionv(){return!!__ZSt18uncaught_exceptionv.uncaught_exception}var EXCEPTIONS={last:0,caught:[],infos:{},deAdjust:(function(adjusted){if(!adjusted||EXCEPTIONS.infos[adjusted])return adjusted;for(var ptr in EXCEPTIONS.infos){var info=EXCEPTIONS.infos[ptr];if(info.adjusted===adjusted){return ptr}}return adjusted}),addRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount++}),decRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];assert(info.refcount>0);info.refcount--;if(info.refcount===0&&!info.rethrown){if(info.destructor){Runtime.dynCall("vi",info.destructor,[ptr])}delete EXCEPTIONS.infos[ptr];___cxa_free_exception(ptr)}}),clearRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount=0})};function ___resumeException(ptr){if(!EXCEPTIONS.last){EXCEPTIONS.last=ptr}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}function ___cxa_find_matching_catch(){var thrown=EXCEPTIONS.last;if(!thrown){return(asm["setTempRet0"](0),0)|0}var info=EXCEPTIONS.infos[thrown];var throwntype=info.type;if(!throwntype){return(asm["setTempRet0"](0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=Module["___cxa_is_pointer_type"](throwntype);if(!___cxa_find_matching_catch.buffer)___cxa_find_matching_catch.buffer=_malloc(4);HEAP32[___cxa_find_matching_catch.buffer>>2]=thrown;thrown=___cxa_find_matching_catch.buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&Module["___cxa_can_catch"](typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted=thrown;return(asm["setTempRet0"](typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(asm["setTempRet0"](throwntype),thrown)|0}function ___cxa_throw(ptr,type,destructor){EXCEPTIONS.infos[ptr]={ptr:ptr,adjusted:ptr,type:type,destructor:destructor,refcount:0,caught:false,rethrown:false};EXCEPTIONS.last=ptr;if(!("uncaught_exception"in __ZSt18uncaught_exceptionv)){__ZSt18uncaught_exceptionv.uncaught_exception=1}else{__ZSt18uncaught_exceptionv.uncaught_exception++}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}Module["_pthread_mutex_unlock"]=_pthread_mutex_unlock;Module["_pthread_mutex_lock"]=_pthread_mutex_lock;function _free(){}Module["_free"]=_free;function _malloc(bytes){var ptr=Runtime.dynamicAlloc(bytes+8);return ptr+8&4294967288}Module["_malloc"]=_malloc;var awaitingDependencies={};var registeredTypes={};var typeDependencies={};var char_0=48;var char_9=57;function makeLegalFunctionName(name){if(undefined===name){return"_unknown"}name=name.replace(/[^a-zA-Z0-9_]/g,"$");var f=name.charCodeAt(0);if(f>=char_0&&f<=char_9){return"_"+name}else{return name}}function createNamedFunction(name,body){name=makeLegalFunctionName(name);return(new Function("body","return function "+name+"() {\n"+'    "use strict";'+"    return body.apply(this, arguments);\n"+"};\n"))(body)}function extendError(baseErrorType,errorName){var errorClass=createNamedFunction(errorName,(function(message){this.name=errorName;this.message=message;var stack=(new Error(message)).stack;if(stack!==undefined){this.stack=this.toString()+"\n"+stack.replace(/^Error(:[^\n]*)?\n/,"")}}));errorClass.prototype=Object.create(baseErrorType.prototype);errorClass.prototype.constructor=errorClass;errorClass.prototype.toString=(function(){if(this.message===undefined){return this.name}else{return this.name+": "+this.message}});return errorClass}var BindingError=undefined;function throwBindingError(message){throw new BindingError(message)}var InternalError=undefined;function throwInternalError(message){throw new InternalError(message)}function whenDependentTypesAreResolved(myTypes,dependentTypes,getTypeConverters){myTypes.forEach((function(type){typeDependencies[type]=dependentTypes}));function onComplete(typeConverters){var myTypeConverters=getTypeConverters(typeConverters);if(myTypeConverters.length!==myTypes.length){throwInternalError("Mismatched type converter count")}for(var i=0;i<myTypes.length;++i){registerType(myTypes[i],myTypeConverters[i])}}var typeConverters=new Array(dependentTypes.length);var unregisteredTypes=[];var registered=0;dependentTypes.forEach((function(dt,i){if(registeredTypes.hasOwnProperty(dt)){typeConverters[i]=registeredTypes[dt]}else{unregisteredTypes.push(dt);if(!awaitingDependencies.hasOwnProperty(dt)){awaitingDependencies[dt]=[]}awaitingDependencies[dt].push((function(){typeConverters[i]=registeredTypes[dt];++registered;if(registered===unregisteredTypes.length){onComplete(typeConverters)}}))}}));if(0===unregisteredTypes.length){onComplete(typeConverters)}}function registerType(rawType,registeredInstance,options){options=options||{};if(!("argPackAdvance"in registeredInstance)){throw new TypeError("registerType registeredInstance requires argPackAdvance")}var name=registeredInstance.name;if(!rawType){throwBindingError('type "'+name+'" must have a positive integer typeid pointer')}if(registeredTypes.hasOwnProperty(rawType)){if(options.ignoreDuplicateRegistrations){return}else{throwBindingError("Cannot register type '"+name+"' twice")}}registeredTypes[rawType]=registeredInstance;delete typeDependencies[rawType];if(awaitingDependencies.hasOwnProperty(rawType)){var callbacks=awaitingDependencies[rawType];delete awaitingDependencies[rawType];callbacks.forEach((function(cb){cb()}))}}function simpleReadValueFromPointer(pointer){return this["fromWireType"](HEAPU32[pointer>>2])}function __embind_register_std_string(rawType,name){name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(value){var length=HEAPU32[value>>2];var a=new Array(length);for(var i=0;i<length;++i){a[i]=String.fromCharCode(HEAPU8[value+4+i])}_free(value);return a.join("")}),"toWireType":(function(destructors,value){if(value instanceof ArrayBuffer){value=new Uint8Array(value)}function getTAElement(ta,index){return ta[index]}function getStringElement(string,index){return string.charCodeAt(index)}var getElement;if(value instanceof Uint8Array){getElement=getTAElement}else if(value instanceof Uint8ClampedArray){getElement=getTAElement}else if(value instanceof Int8Array){getElement=getTAElement}else if(typeof value==="string"){getElement=getStringElement}else{throwBindingError("Cannot pass non-string to std::string")}var length=value.length;var ptr=_malloc(4+length);HEAPU32[ptr>>2]=length;for(var i=0;i<length;++i){var charCode=getElement(value,i);if(charCode>255){_free(ptr);throwBindingError("String has UTF-16 code units that do not fit in 8 bits")}HEAPU8[ptr+4+i]=charCode}if(destructors!==null){destructors.push(_free,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:(function(ptr){_free(ptr)})})}function __embind_register_std_wstring(rawType,charSize,name){name=readLatin1String(name);var getHeap,shift;if(charSize===2){getHeap=(function(){return HEAPU16});shift=1}else if(charSize===4){getHeap=(function(){return HEAPU32});shift=2}registerType(rawType,{name:name,"fromWireType":(function(value){var HEAP=getHeap();var length=HEAPU32[value>>2];var a=new Array(length);var start=value+4>>shift;for(var i=0;i<length;++i){a[i]=String.fromCharCode(HEAP[start+i])}_free(value);return a.join("")}),"toWireType":(function(destructors,value){var HEAP=getHeap();var length=value.length;var ptr=_malloc(4+length*charSize);HEAPU32[ptr>>2]=length;var start=ptr+4>>shift;for(var i=0;i<length;++i){HEAP[start+i]=value.charCodeAt(i)}if(destructors!==null){destructors.push(_free,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:(function(ptr){_free(ptr)})})}function _pthread_mutex_init(){}function __emval_decref(handle){if(handle>4&&0===--emval_handle_array[handle].refcount){emval_handle_array[handle]=undefined;emval_free_list.push(handle)}}function _realloc(){throw"bad"}Module["_realloc"]=_realloc;Module["_saveSetjmp"]=_saveSetjmp;var PTHREAD_SPECIFIC={};var PTHREAD_SPECIFIC_NEXT_KEY=1;var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};function _pthread_key_create(key,destructor){if(key==0){return ERRNO_CODES.EINVAL}HEAP32[key>>2]=PTHREAD_SPECIFIC_NEXT_KEY;PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY]=0;PTHREAD_SPECIFIC_NEXT_KEY++;return 0}function getTypeName(type){var ptr=___getTypeName(type);var rv=readLatin1String(ptr);_free(ptr);return rv}function requireRegisteredType(rawType,humanName){var impl=registeredTypes[rawType];if(undefined===impl){throwBindingError(humanName+" has unknown type "+getTypeName(rawType))}return impl}function __emval_take_value(type,argv){type=requireRegisteredType(type,"_emval_take_value");var v=type["readValueFromPointer"](argv);return __emval_register(v)}var _llvm_pow_f32=Math_pow;function _pthread_mutexattr_destroy(){}var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};function ___setErrNo(value){if(Module["___errno_location"])HEAP32[Module["___errno_location"]()>>2]=value;return value}var PATH={splitPath:(function(filename){var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return splitPathRe.exec(filename).slice(1)}),normalizeArray:(function(parts,allowAboveRoot){var up=0;for(var i=parts.length-1;i>=0;i--){var last=parts[i];if(last==="."){parts.splice(i,1)}else if(last===".."){parts.splice(i,1);up++}else if(up){parts.splice(i,1);up--}}if(allowAboveRoot){for(;up--;up){parts.unshift("..")}}return parts}),normalize:(function(path){var isAbsolute=path.charAt(0)==="/",trailingSlash=path.substr(-1)==="/";path=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),!isAbsolute).join("/");if(!path&&!isAbsolute){path="."}if(path&&trailingSlash){path+="/"}return(isAbsolute?"/":"")+path}),dirname:(function(path){var result=PATH.splitPath(path),root=result[0],dir=result[1];if(!root&&!dir){return"."}if(dir){dir=dir.substr(0,dir.length-1)}return root+dir}),basename:(function(path){if(path==="/")return"/";var lastSlash=path.lastIndexOf("/");if(lastSlash===-1)return path;return path.substr(lastSlash+1)}),extname:(function(path){return PATH.splitPath(path)[3]}),join:(function(){var paths=Array.prototype.slice.call(arguments,0);return PATH.normalize(paths.join("/"))}),join2:(function(l,r){return PATH.normalize(l+"/"+r)}),resolve:(function(){var resolvedPath="",resolvedAbsolute=false;for(var i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:FS.cwd();if(typeof path!=="string"){throw new TypeError("Arguments to path.resolve must be strings")}else if(!path){return""}resolvedPath=path+"/"+resolvedPath;resolvedAbsolute=path.charAt(0)==="/"}resolvedPath=PATH.normalizeArray(resolvedPath.split("/").filter((function(p){return!!p})),!resolvedAbsolute).join("/");return(resolvedAbsolute?"/":"")+resolvedPath||"."}),relative:(function(from,to){from=PATH.resolve(from).substr(1);to=PATH.resolve(to).substr(1);function trim(arr){var start=0;for(;start<arr.length;start++){if(arr[start]!=="")break}var end=arr.length-1;for(;end>=0;end--){if(arr[end]!=="")break}if(start>end)return[];return arr.slice(start,end-start+1)}var fromParts=trim(from.split("/"));var toParts=trim(to.split("/"));var length=Math.min(fromParts.length,toParts.length);var samePartsLength=length;for(var i=0;i<length;i++){if(fromParts[i]!==toParts[i]){samePartsLength=i;break}}var outputParts=[];for(var i=samePartsLength;i<fromParts.length;i++){outputParts.push("..")}outputParts=outputParts.concat(toParts.slice(samePartsLength));return outputParts.join("/")})};var TTY={ttys:[],init:(function(){}),shutdown:(function(){}),register:(function(dev,ops){TTY.ttys[dev]={input:[],output:[],ops:ops};FS.registerDevice(dev,TTY.stream_ops)}),stream_ops:{open:(function(stream){var tty=TTY.ttys[stream.node.rdev];if(!tty){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}stream.tty=tty;stream.seekable=false}),close:(function(stream){stream.tty.ops.flush(stream.tty)}),flush:(function(stream){stream.tty.ops.flush(stream.tty)}),read:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.get_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=stream.tty.ops.get_char(stream.tty)}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.put_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}for(var i=0;i<length;i++){try{stream.tty.ops.put_char(stream.tty,buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})},default_tty_ops:{get_char:(function(tty){if(!tty.input.length){var result=null;if(ENVIRONMENT_IS_NODE){var BUFSIZE=256;var buf=new Buffer(BUFSIZE);var bytesRead=0;var isPosixPlatform=process.platform!="win32";var fd=process.stdin.fd;if(isPosixPlatform){var usingDevice=false;try{fd=fs.openSync("/dev/stdin","r");usingDevice=true}catch(e){}}try{bytesRead=fs.readSync(fd,buf,0,BUFSIZE,null)}catch(e){if(e.toString().indexOf("EOF")!=-1)bytesRead=0;else throw e}if(usingDevice){fs.closeSync(fd)}if(bytesRead>0){result=buf.slice(0,bytesRead).toString("utf-8")}else{result=null}}else if(typeof window!="undefined"&&typeof window.prompt=="function"){result=window.prompt("Input: ");if(result!==null){result+="\n"}}else if(typeof readline=="function"){result=readline();if(result!==null){result+="\n"}}if(!result){return null}tty.input=intArrayFromString(result,true)}return tty.input.shift()}),put_char:(function(tty,val){if(val===null||val===10){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}})},default_tty1_ops:{put_char:(function(tty,val){if(val===null||val===10){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}})}};var MEMFS={ops_table:null,mount:(function(mount){return MEMFS.createNode(null,"/",16384|511,0)}),createNode:(function(parent,name,mode,dev){if(FS.isBlkdev(mode)||FS.isFIFO(mode)){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(!MEMFS.ops_table){MEMFS.ops_table={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap,msync:MEMFS.stream_ops.msync}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}}}var node=FS.createNode(parent,name,mode,dev);if(FS.isDir(node.mode)){node.node_ops=MEMFS.ops_table.dir.node;node.stream_ops=MEMFS.ops_table.dir.stream;node.contents={}}else if(FS.isFile(node.mode)){node.node_ops=MEMFS.ops_table.file.node;node.stream_ops=MEMFS.ops_table.file.stream;node.usedBytes=0;node.contents=null}else if(FS.isLink(node.mode)){node.node_ops=MEMFS.ops_table.link.node;node.stream_ops=MEMFS.ops_table.link.stream}else if(FS.isChrdev(node.mode)){node.node_ops=MEMFS.ops_table.chrdev.node;node.stream_ops=MEMFS.ops_table.chrdev.stream}node.timestamp=Date.now();if(parent){parent.contents[name]=node}return node}),getFileDataAsRegularArray:(function(node){if(node.contents&&node.contents.subarray){var arr=[];for(var i=0;i<node.usedBytes;++i)arr.push(node.contents[i]);return arr}return node.contents}),getFileDataAsTypedArray:(function(node){if(!node.contents)return new Uint8Array;if(node.contents.subarray)return node.contents.subarray(0,node.usedBytes);return new Uint8Array(node.contents)}),expandFileStorage:(function(node,newCapacity){if(node.contents&&node.contents.subarray&&newCapacity>node.contents.length){node.contents=MEMFS.getFileDataAsRegularArray(node);node.usedBytes=node.contents.length}if(!node.contents||node.contents.subarray){var prevCapacity=node.contents?node.contents.length:0;if(prevCapacity>=newCapacity)return;var CAPACITY_DOUBLING_MAX=1024*1024;newCapacity=Math.max(newCapacity,prevCapacity*(prevCapacity<CAPACITY_DOUBLING_MAX?2:1.125)|0);if(prevCapacity!=0)newCapacity=Math.max(newCapacity,256);var oldContents=node.contents;node.contents=new Uint8Array(newCapacity);if(node.usedBytes>0)node.contents.set(oldContents.subarray(0,node.usedBytes),0);return}if(!node.contents&&newCapacity>0)node.contents=[];while(node.contents.length<newCapacity)node.contents.push(0)}),resizeFileStorage:(function(node,newSize){if(node.usedBytes==newSize)return;if(newSize==0){node.contents=null;node.usedBytes=0;return}if(!node.contents||node.contents.subarray){var oldContents=node.contents;node.contents=new Uint8Array(new ArrayBuffer(newSize));if(oldContents){node.contents.set(oldContents.subarray(0,Math.min(newSize,node.usedBytes)))}node.usedBytes=newSize;return}if(!node.contents)node.contents=[];if(node.contents.length>newSize)node.contents.length=newSize;else while(node.contents.length<newSize)node.contents.push(0);node.usedBytes=newSize}),node_ops:{getattr:(function(node){var attr={};attr.dev=FS.isChrdev(node.mode)?node.id:1;attr.ino=node.id;attr.mode=node.mode;attr.nlink=1;attr.uid=0;attr.gid=0;attr.rdev=node.rdev;if(FS.isDir(node.mode)){attr.size=4096}else if(FS.isFile(node.mode)){attr.size=node.usedBytes}else if(FS.isLink(node.mode)){attr.size=node.link.length}else{attr.size=0}attr.atime=new Date(node.timestamp);attr.mtime=new Date(node.timestamp);attr.ctime=new Date(node.timestamp);attr.blksize=4096;attr.blocks=Math.ceil(attr.size/attr.blksize);return attr}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}if(attr.size!==undefined){MEMFS.resizeFileStorage(node,attr.size)}}),lookup:(function(parent,name){throw FS.genericErrors[ERRNO_CODES.ENOENT]}),mknod:(function(parent,name,mode,dev){return MEMFS.createNode(parent,name,mode,dev)}),rename:(function(old_node,new_dir,new_name){if(FS.isDir(old_node.mode)){var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(new_node){for(var i in new_node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}}}delete old_node.parent.contents[old_node.name];old_node.name=new_name;new_dir.contents[new_name]=old_node;old_node.parent=new_dir}),unlink:(function(parent,name){delete parent.contents[name]}),rmdir:(function(parent,name){var node=FS.lookupNode(parent,name);for(var i in node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}delete parent.contents[name]}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newname,oldpath){var node=MEMFS.createNode(parent,newname,511|40960,0);node.link=oldpath;return node}),readlink:(function(node){if(!FS.isLink(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return node.link})},stream_ops:{read:(function(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=stream.node.usedBytes)return 0;var size=Math.min(stream.node.usedBytes-position,length);assert(size>=0);if(size>8&&contents.subarray){buffer.set(contents.subarray(position,position+size),offset)}else{for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i]}return size}),write:(function(stream,buffer,offset,length,position,canOwn){if(!length)return 0;var node=stream.node;node.timestamp=Date.now();if(buffer.subarray&&(!node.contents||node.contents.subarray)){if(canOwn){node.contents=buffer.subarray(offset,offset+length);node.usedBytes=length;return length}else if(node.usedBytes===0&&position===0){node.contents=new Uint8Array(buffer.subarray(offset,offset+length));node.usedBytes=length;return length}else if(position+length<=node.usedBytes){node.contents.set(buffer.subarray(offset,offset+length),position);return length}}MEMFS.expandFileStorage(node,position+length);if(node.contents.subarray&&buffer.subarray)node.contents.set(buffer.subarray(offset,offset+length),position);else{for(var i=0;i<length;i++){node.contents[position+i]=buffer[offset+i]}}node.usedBytes=Math.max(node.usedBytes,position+length);return length}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.usedBytes}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position}),allocate:(function(stream,offset,length){MEMFS.expandFileStorage(stream.node,offset+length);stream.node.usedBytes=Math.max(stream.node.usedBytes,offset+length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}var ptr;var allocated;var contents=stream.node.contents;if(!(flags&2)&&(contents.buffer===buffer||contents.buffer===buffer.buffer)){allocated=false;ptr=contents.byteOffset}else{if(position>0||position+length<stream.node.usedBytes){if(contents.subarray){contents=contents.subarray(position,position+length)}else{contents=Array.prototype.slice.call(contents,position,position+length)}}allocated=true;ptr=_malloc(length);if(!ptr){throw new FS.ErrnoError(ERRNO_CODES.ENOMEM)}buffer.set(contents,ptr)}return{ptr:ptr,allocated:allocated}}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(mmapFlags&2){return 0}var bytesWritten=MEMFS.stream_ops.write(stream,buffer,0,length,offset,false);return 0})}};var IDBFS={dbs:{},indexedDB:(function(){if(typeof indexedDB!=="undefined")return indexedDB;var ret=null;if(typeof window==="object")ret=window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB;assert(ret,"IDBFS used, but indexedDB not supported");return ret}),DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:(function(mount){return MEMFS.mount.apply(null,arguments)}),syncfs:(function(mount,populate,callback){IDBFS.getLocalSet(mount,(function(err,local){if(err)return callback(err);IDBFS.getRemoteSet(mount,(function(err,remote){if(err)return callback(err);var src=populate?remote:local;var dst=populate?local:remote;IDBFS.reconcile(src,dst,callback)}))}))}),getDB:(function(name,callback){var db=IDBFS.dbs[name];if(db){return callback(null,db)}var req;try{req=IDBFS.indexedDB().open(name,IDBFS.DB_VERSION)}catch(e){return callback(e)}if(!req){return callback("Unable to connect to IndexedDB")}req.onupgradeneeded=(function(e){var db=e.target.result;var transaction=e.target.transaction;var fileStore;if(db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)){fileStore=transaction.objectStore(IDBFS.DB_STORE_NAME)}else{fileStore=db.createObjectStore(IDBFS.DB_STORE_NAME)}if(!fileStore.indexNames.contains("timestamp")){fileStore.createIndex("timestamp","timestamp",{unique:false})}});req.onsuccess=(function(){db=req.result;IDBFS.dbs[name]=db;callback(null,db)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),getLocalSet:(function(mount,callback){var entries={};function isRealDir(p){return p!=="."&&p!==".."}function toAbsolute(root){return(function(p){return PATH.join2(root,p)})}var check=FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));while(check.length){var path=check.pop();var stat;try{stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){check.push.apply(check,FS.readdir(path).filter(isRealDir).map(toAbsolute(path)))}entries[path]={timestamp:stat.mtime}}return callback(null,{type:"local",entries:entries})}),getRemoteSet:(function(mount,callback){var entries={};IDBFS.getDB(mount.mountpoint,(function(err,db){if(err)return callback(err);var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readonly");transaction.onerror=(function(e){callback(this.error);e.preventDefault()});var store=transaction.objectStore(IDBFS.DB_STORE_NAME);var index=store.index("timestamp");index.openKeyCursor().onsuccess=(function(event){var cursor=event.target.result;if(!cursor){return callback(null,{type:"remote",db:db,entries:entries})}entries[cursor.primaryKey]={timestamp:cursor.key};cursor.continue()})}))}),loadLocalEntry:(function(path,callback){var stat,node;try{var lookup=FS.lookupPath(path);node=lookup.node;stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){return callback(null,{timestamp:stat.mtime,mode:stat.mode})}else if(FS.isFile(stat.mode)){node.contents=MEMFS.getFileDataAsTypedArray(node);return callback(null,{timestamp:stat.mtime,mode:stat.mode,contents:node.contents})}else{return callback(new Error("node type not supported"))}}),storeLocalEntry:(function(path,entry,callback){try{if(FS.isDir(entry.mode)){FS.mkdir(path,entry.mode)}else if(FS.isFile(entry.mode)){FS.writeFile(path,entry.contents,{encoding:"binary",canOwn:true})}else{return callback(new Error("node type not supported"))}FS.chmod(path,entry.mode);FS.utime(path,entry.timestamp,entry.timestamp)}catch(e){return callback(e)}callback(null)}),removeLocalEntry:(function(path,callback){try{var lookup=FS.lookupPath(path);var stat=FS.stat(path);if(FS.isDir(stat.mode)){FS.rmdir(path)}else if(FS.isFile(stat.mode)){FS.unlink(path)}}catch(e){return callback(e)}callback(null)}),loadRemoteEntry:(function(store,path,callback){var req=store.get(path);req.onsuccess=(function(event){callback(null,event.target.result)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),storeRemoteEntry:(function(store,path,entry,callback){var req=store.put(entry,path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),removeRemoteEntry:(function(store,path,callback){var req=store.delete(path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),reconcile:(function(src,dst,callback){var total=0;var create=[];Object.keys(src.entries).forEach((function(key){var e=src.entries[key];var e2=dst.entries[key];if(!e2||e.timestamp>e2.timestamp){create.push(key);total++}}));var remove=[];Object.keys(dst.entries).forEach((function(key){var e=dst.entries[key];var e2=src.entries[key];if(!e2){remove.push(key);total++}}));if(!total){return callback(null)}var completed=0;var db=src.type==="remote"?src.db:dst.db;var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readwrite");var store=transaction.objectStore(IDBFS.DB_STORE_NAME);function done(err){if(err){if(!done.errored){done.errored=true;return callback(err)}return}if(++completed>=total){return callback(null)}}transaction.onerror=(function(e){done(this.error);e.preventDefault()});create.sort().forEach((function(path){if(dst.type==="local"){IDBFS.loadRemoteEntry(store,path,(function(err,entry){if(err)return done(err);IDBFS.storeLocalEntry(path,entry,done)}))}else{IDBFS.loadLocalEntry(path,(function(err,entry){if(err)return done(err);IDBFS.storeRemoteEntry(store,path,entry,done)}))}}));remove.sort().reverse().forEach((function(path){if(dst.type==="local"){IDBFS.removeLocalEntry(path,done)}else{IDBFS.removeRemoteEntry(store,path,done)}}))})};var NODEFS={isWindows:false,staticInit:(function(){NODEFS.isWindows=!!process.platform.match(/^win/)}),mount:(function(mount){assert(ENVIRONMENT_IS_NODE);return NODEFS.createNode(null,"/",NODEFS.getMode(mount.opts.root),0)}),createNode:(function(parent,name,mode,dev){if(!FS.isDir(mode)&&!FS.isFile(mode)&&!FS.isLink(mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=FS.createNode(parent,name,mode);node.node_ops=NODEFS.node_ops;node.stream_ops=NODEFS.stream_ops;return node}),getMode:(function(path){var stat;try{stat=fs.lstatSync(path);if(NODEFS.isWindows){stat.mode=stat.mode|(stat.mode&146)>>1}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return stat.mode}),realPath:(function(node){var parts=[];while(node.parent!==node){parts.push(node.name);node=node.parent}parts.push(node.mount.opts.root);parts.reverse();return PATH.join.apply(null,parts)}),flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:(function(flags){flags&=~2097152;flags&=~2048;flags&=~32768;flags&=~524288;if(flags in NODEFS.flagsToPermissionStringMap){return NODEFS.flagsToPermissionStringMap[flags]}else{throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}}),node_ops:{getattr:(function(node){var path=NODEFS.realPath(node);var stat;try{stat=fs.lstatSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(NODEFS.isWindows&&!stat.blksize){stat.blksize=4096}if(NODEFS.isWindows&&!stat.blocks){stat.blocks=(stat.size+stat.blksize-1)/stat.blksize|0}return{dev:stat.dev,ino:stat.ino,mode:stat.mode,nlink:stat.nlink,uid:stat.uid,gid:stat.gid,rdev:stat.rdev,size:stat.size,atime:stat.atime,mtime:stat.mtime,ctime:stat.ctime,blksize:stat.blksize,blocks:stat.blocks}}),setattr:(function(node,attr){var path=NODEFS.realPath(node);try{if(attr.mode!==undefined){fs.chmodSync(path,attr.mode);node.mode=attr.mode}if(attr.timestamp!==undefined){var date=new Date(attr.timestamp);fs.utimesSync(path,date,date)}if(attr.size!==undefined){fs.truncateSync(path,attr.size)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),lookup:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);var mode=NODEFS.getMode(path);return NODEFS.createNode(parent,name,mode)}),mknod:(function(parent,name,mode,dev){var node=NODEFS.createNode(parent,name,mode,dev);var path=NODEFS.realPath(node);try{if(FS.isDir(node.mode)){fs.mkdirSync(path,node.mode)}else{fs.writeFileSync(path,"",{mode:node.mode})}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return node}),rename:(function(oldNode,newDir,newName){var oldPath=NODEFS.realPath(oldNode);var newPath=PATH.join2(NODEFS.realPath(newDir),newName);try{fs.renameSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),unlink:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.unlinkSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),rmdir:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.rmdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readdir:(function(node){var path=NODEFS.realPath(node);try{return fs.readdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),symlink:(function(parent,newName,oldPath){var newPath=PATH.join2(NODEFS.realPath(parent),newName);try{fs.symlinkSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readlink:(function(node){var path=NODEFS.realPath(node);try{path=fs.readlinkSync(path);path=NODEJS_PATH.relative(NODEJS_PATH.resolve(node.mount.opts.root),path);return path}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}})},stream_ops:{open:(function(stream){var path=NODEFS.realPath(stream.node);try{if(FS.isFile(stream.node.mode)){stream.nfd=fs.openSync(path,NODEFS.flagsToPermissionString(stream.flags))}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),close:(function(stream){try{if(FS.isFile(stream.node.mode)&&stream.nfd){fs.closeSync(stream.nfd)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),read:(function(stream,buffer,offset,length,position){if(length===0)return 0;var nbuffer=new Buffer(length);var res;try{res=fs.readSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(res>0){for(var i=0;i<res;i++){buffer[offset+i]=nbuffer[i]}}return res}),write:(function(stream,buffer,offset,length,position){var nbuffer=new Buffer(buffer.subarray(offset,offset+length));var res;try{res=fs.writeSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}return res}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){try{var stat=fs.fstatSync(stream.nfd);position+=stat.size}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};var WORKERFS={DIR_MODE:16895,FILE_MODE:33279,reader:null,mount:(function(mount){assert(ENVIRONMENT_IS_WORKER);if(!WORKERFS.reader)WORKERFS.reader=new FileReaderSync;var root=WORKERFS.createNode(null,"/",WORKERFS.DIR_MODE,0);var createdParents={};function ensureParent(path){var parts=path.split("/");var parent=root;for(var i=0;i<parts.length-1;i++){var curr=parts.slice(0,i+1).join("/");if(!createdParents[curr]){createdParents[curr]=WORKERFS.createNode(parent,parts[i],WORKERFS.DIR_MODE,0)}parent=createdParents[curr]}return parent}function base(path){var parts=path.split("/");return parts[parts.length-1]}Array.prototype.forEach.call(mount.opts["files"]||[],(function(file){WORKERFS.createNode(ensureParent(file.name),base(file.name),WORKERFS.FILE_MODE,0,file,file.lastModifiedDate)}));(mount.opts["blobs"]||[]).forEach((function(obj){WORKERFS.createNode(ensureParent(obj["name"]),base(obj["name"]),WORKERFS.FILE_MODE,0,obj["data"])}));(mount.opts["packages"]||[]).forEach((function(pack){pack["metadata"].files.forEach((function(file){var name=file.filename.substr(1);WORKERFS.createNode(ensureParent(name),base(name),WORKERFS.FILE_MODE,0,pack["blob"].slice(file.start,file.end))}))}));return root}),createNode:(function(parent,name,mode,dev,contents,mtime){var node=FS.createNode(parent,name,mode);node.mode=mode;node.node_ops=WORKERFS.node_ops;node.stream_ops=WORKERFS.stream_ops;node.timestamp=(mtime||new Date).getTime();assert(WORKERFS.FILE_MODE!==WORKERFS.DIR_MODE);if(mode===WORKERFS.FILE_MODE){node.size=contents.size;node.contents=contents}else{node.size=4096;node.contents={}}if(parent){parent.contents[name]=node}return node}),node_ops:{getattr:(function(node){return{dev:1,ino:undefined,mode:node.mode,nlink:1,uid:0,gid:0,rdev:undefined,size:node.size,atime:new Date(node.timestamp),mtime:new Date(node.timestamp),ctime:new Date(node.timestamp),blksize:4096,blocks:Math.ceil(node.size/4096)}}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}}),lookup:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}),mknod:(function(parent,name,mode,dev){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rename:(function(oldNode,newDir,newName){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),unlink:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rmdir:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readdir:(function(node){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),symlink:(function(parent,newName,oldPath){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readlink:(function(node){throw new FS.ErrnoError(ERRNO_CODES.EPERM)})},stream_ops:{read:(function(stream,buffer,offset,length,position){if(position>=stream.node.size)return 0;var chunk=stream.node.contents.slice(position,position+length);var ab=WORKERFS.reader.readAsArrayBuffer(chunk);buffer.set(new Uint8Array(ab),offset);return chunk.size}),write:(function(stream,buffer,offset,length,position){throw new FS.ErrnoError(ERRNO_CODES.EIO)}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.size}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};STATICTOP+=16;STATICTOP+=16;STATICTOP+=16;var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},filesystems:null,syncFSRequests:0,handleFSError:(function(e){if(!(e instanceof FS.ErrnoError))throw e+" : "+stackTrace();return ___setErrNo(e.errno)}),lookupPath:(function(path,opts){path=PATH.resolve(FS.cwd(),path);opts=opts||{};if(!path)return{path:"",node:null};var defaults={follow_mount:true,recurse_count:0};for(var key in defaults){if(opts[key]===undefined){opts[key]=defaults[key]}}if(opts.recurse_count>8){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}var parts=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),false);var current=FS.root;var current_path="/";for(var i=0;i<parts.length;i++){var islast=i===parts.length-1;if(islast&&opts.parent){break}current=FS.lookupNode(current,parts[i]);current_path=PATH.join2(current_path,parts[i]);if(FS.isMountpoint(current)){if(!islast||islast&&opts.follow_mount){current=current.mounted.root}}if(!islast||opts.follow){var count=0;while(FS.isLink(current.mode)){var link=FS.readlink(current_path);current_path=PATH.resolve(PATH.dirname(current_path),link);var lookup=FS.lookupPath(current_path,{recurse_count:opts.recurse_count});current=lookup.node;if(count++>40){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}}}}return{path:current_path,node:current}}),getPath:(function(node){var path;while(true){if(FS.isRoot(node)){var mount=node.mount.mountpoint;if(!path)return mount;return mount[mount.length-1]!=="/"?mount+"/"+path:mount+path}path=path?node.name+"/"+path:node.name;node=node.parent}}),hashName:(function(parentid,name){var hash=0;for(var i=0;i<name.length;i++){hash=(hash<<5)-hash+name.charCodeAt(i)|0}return(parentid+hash>>>0)%FS.nameTable.length}),hashAddNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);node.name_next=FS.nameTable[hash];FS.nameTable[hash]=node}),hashRemoveNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);if(FS.nameTable[hash]===node){FS.nameTable[hash]=node.name_next}else{var current=FS.nameTable[hash];while(current){if(current.name_next===node){current.name_next=node.name_next;break}current=current.name_next}}}),lookupNode:(function(parent,name){var err=FS.mayLookup(parent);if(err){throw new FS.ErrnoError(err,parent)}var hash=FS.hashName(parent.id,name);for(var node=FS.nameTable[hash];node;node=node.name_next){var nodeName=node.name;if(node.parent.id===parent.id&&nodeName===name){return node}}return FS.lookup(parent,name)}),createNode:(function(parent,name,mode,rdev){if(!FS.FSNode){FS.FSNode=(function(parent,name,mode,rdev){if(!parent){parent=this}this.parent=parent;this.mount=parent.mount;this.mounted=null;this.id=FS.nextInode++;this.name=name;this.mode=mode;this.node_ops={};this.stream_ops={};this.rdev=rdev});FS.FSNode.prototype={};var readMode=292|73;var writeMode=146;Object.defineProperties(FS.FSNode.prototype,{read:{get:(function(){return(this.mode&readMode)===readMode}),set:(function(val){val?this.mode|=readMode:this.mode&=~readMode})},write:{get:(function(){return(this.mode&writeMode)===writeMode}),set:(function(val){val?this.mode|=writeMode:this.mode&=~writeMode})},isFolder:{get:(function(){return FS.isDir(this.mode)})},isDevice:{get:(function(){return FS.isChrdev(this.mode)})}})}var node=new FS.FSNode(parent,name,mode,rdev);FS.hashAddNode(node);return node}),destroyNode:(function(node){FS.hashRemoveNode(node)}),isRoot:(function(node){return node===node.parent}),isMountpoint:(function(node){return!!node.mounted}),isFile:(function(mode){return(mode&61440)===32768}),isDir:(function(mode){return(mode&61440)===16384}),isLink:(function(mode){return(mode&61440)===40960}),isChrdev:(function(mode){return(mode&61440)===8192}),isBlkdev:(function(mode){return(mode&61440)===24576}),isFIFO:(function(mode){return(mode&61440)===4096}),isSocket:(function(mode){return(mode&49152)===49152}),flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:(function(str){var flags=FS.flagModes[str];if(typeof flags==="undefined"){throw new Error("Unknown file open mode: "+str)}return flags}),flagsToPermissionString:(function(flag){var perms=["r","w","rw"][flag&3];if(flag&512){perms+="w"}return perms}),nodePermissions:(function(node,perms){if(FS.ignorePermissions){return 0}if(perms.indexOf("r")!==-1&&!(node.mode&292)){return ERRNO_CODES.EACCES}else if(perms.indexOf("w")!==-1&&!(node.mode&146)){return ERRNO_CODES.EACCES}else if(perms.indexOf("x")!==-1&&!(node.mode&73)){return ERRNO_CODES.EACCES}return 0}),mayLookup:(function(dir){var err=FS.nodePermissions(dir,"x");if(err)return err;if(!dir.node_ops.lookup)return ERRNO_CODES.EACCES;return 0}),mayCreate:(function(dir,name){try{var node=FS.lookupNode(dir,name);return ERRNO_CODES.EEXIST}catch(e){}return FS.nodePermissions(dir,"wx")}),mayDelete:(function(dir,name,isdir){var node;try{node=FS.lookupNode(dir,name)}catch(e){return e.errno}var err=FS.nodePermissions(dir,"wx");if(err){return err}if(isdir){if(!FS.isDir(node.mode)){return ERRNO_CODES.ENOTDIR}if(FS.isRoot(node)||FS.getPath(node)===FS.cwd()){return ERRNO_CODES.EBUSY}}else{if(FS.isDir(node.mode)){return ERRNO_CODES.EISDIR}}return 0}),mayOpen:(function(node,flags){if(!node){return ERRNO_CODES.ENOENT}if(FS.isLink(node.mode)){return ERRNO_CODES.ELOOP}else if(FS.isDir(node.mode)){if(FS.flagsToPermissionString(flags)!=="r"||flags&512){return ERRNO_CODES.EISDIR}}return FS.nodePermissions(node,FS.flagsToPermissionString(flags))}),MAX_OPEN_FDS:4096,nextfd:(function(fd_start,fd_end){fd_start=fd_start||0;fd_end=fd_end||FS.MAX_OPEN_FDS;for(var fd=fd_start;fd<=fd_end;fd++){if(!FS.streams[fd]){return fd}}throw new FS.ErrnoError(ERRNO_CODES.EMFILE)}),getStream:(function(fd){return FS.streams[fd]}),createStream:(function(stream,fd_start,fd_end){if(!FS.FSStream){FS.FSStream=(function(){});FS.FSStream.prototype={};Object.defineProperties(FS.FSStream.prototype,{object:{get:(function(){return this.node}),set:(function(val){this.node=val})},isRead:{get:(function(){return(this.flags&2097155)!==1})},isWrite:{get:(function(){return(this.flags&2097155)!==0})},isAppend:{get:(function(){return this.flags&1024})}})}var newStream=new FS.FSStream;for(var p in stream){newStream[p]=stream[p]}stream=newStream;var fd=FS.nextfd(fd_start,fd_end);stream.fd=fd;FS.streams[fd]=stream;return stream}),closeStream:(function(fd){FS.streams[fd]=null}),chrdev_stream_ops:{open:(function(stream){var device=FS.getDevice(stream.node.rdev);stream.stream_ops=device.stream_ops;if(stream.stream_ops.open){stream.stream_ops.open(stream)}}),llseek:(function(){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)})},major:(function(dev){return dev>>8}),minor:(function(dev){return dev&255}),makedev:(function(ma,mi){return ma<<8|mi}),registerDevice:(function(dev,ops){FS.devices[dev]={stream_ops:ops}}),getDevice:(function(dev){return FS.devices[dev]}),getMounts:(function(mount){var mounts=[];var check=[mount];while(check.length){var m=check.pop();mounts.push(m);check.push.apply(check,m.mounts)}return mounts}),syncfs:(function(populate,callback){if(typeof populate==="function"){callback=populate;populate=false}FS.syncFSRequests++;if(FS.syncFSRequests>1){console.log("warning: "+FS.syncFSRequests+" FS.syncfs operations in flight at once, probably just doing extra work")}var mounts=FS.getMounts(FS.root.mount);var completed=0;function doCallback(err){assert(FS.syncFSRequests>0);FS.syncFSRequests--;return callback(err)}function done(err){if(err){if(!done.errored){done.errored=true;return doCallback(err)}return}if(++completed>=mounts.length){doCallback(null)}}mounts.forEach((function(mount){if(!mount.type.syncfs){return done(null)}mount.type.syncfs(mount,populate,done)}))}),mount:(function(type,opts,mountpoint){var root=mountpoint==="/";var pseudo=!mountpoint;var node;if(root&&FS.root){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}else if(!root&&!pseudo){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});mountpoint=lookup.path;node=lookup.node;if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}}var mount={type:type,opts:opts,mountpoint:mountpoint,mounts:[]};var mountRoot=type.mount(mount);mountRoot.mount=mount;mount.root=mountRoot;if(root){FS.root=mountRoot}else if(node){node.mounted=mount;if(node.mount){node.mount.mounts.push(mount)}}return mountRoot}),unmount:(function(mountpoint){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});if(!FS.isMountpoint(lookup.node)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=lookup.node;var mount=node.mounted;var mounts=FS.getMounts(mount);Object.keys(FS.nameTable).forEach((function(hash){var current=FS.nameTable[hash];while(current){var next=current.name_next;if(mounts.indexOf(current.mount)!==-1){FS.destroyNode(current)}current=next}}));node.mounted=null;var idx=node.mount.mounts.indexOf(mount);assert(idx!==-1);node.mount.mounts.splice(idx,1)}),lookup:(function(parent,name){return parent.node_ops.lookup(parent,name)}),mknod:(function(path,mode,dev){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);if(!name||name==="."||name===".."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.mayCreate(parent,name);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.mknod){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.mknod(parent,name,mode,dev)}),create:(function(path,mode){mode=mode!==undefined?mode:438;mode&=4095;mode|=32768;return FS.mknod(path,mode,0)}),mkdir:(function(path,mode){mode=mode!==undefined?mode:511;mode&=511|512;mode|=16384;return FS.mknod(path,mode,0)}),mkdirTree:(function(path,mode){var dirs=path.split("/");var d="";for(var i=0;i<dirs.length;++i){if(!dirs[i])continue;d+="/"+dirs[i];try{FS.mkdir(d,mode)}catch(e){if(e.errno!=ERRNO_CODES.EEXIST)throw e}}}),mkdev:(function(path,mode,dev){if(typeof dev==="undefined"){dev=mode;mode=438}mode|=8192;return FS.mknod(path,mode,dev)}),symlink:(function(oldpath,newpath){if(!PATH.resolve(oldpath)){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var lookup=FS.lookupPath(newpath,{parent:true});var parent=lookup.node;if(!parent){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var newname=PATH.basename(newpath);var err=FS.mayCreate(parent,newname);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.symlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.symlink(parent,newname,oldpath)}),rename:(function(old_path,new_path){var old_dirname=PATH.dirname(old_path);var new_dirname=PATH.dirname(new_path);var old_name=PATH.basename(old_path);var new_name=PATH.basename(new_path);var lookup,old_dir,new_dir;try{lookup=FS.lookupPath(old_path,{parent:true});old_dir=lookup.node;lookup=FS.lookupPath(new_path,{parent:true});new_dir=lookup.node}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!old_dir||!new_dir)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(old_dir.mount!==new_dir.mount){throw new FS.ErrnoError(ERRNO_CODES.EXDEV)}var old_node=FS.lookupNode(old_dir,old_name);var relative=PATH.relative(old_path,new_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}relative=PATH.relative(new_path,old_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(old_node===new_node){return}var isdir=FS.isDir(old_node.mode);var err=FS.mayDelete(old_dir,old_name,isdir);if(err){throw new FS.ErrnoError(err)}err=new_node?FS.mayDelete(new_dir,new_name,isdir):FS.mayCreate(new_dir,new_name);if(err){throw new FS.ErrnoError(err)}if(!old_dir.node_ops.rename){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(old_node)||new_node&&FS.isMountpoint(new_node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(new_dir!==old_dir){err=FS.nodePermissions(old_dir,"w");if(err){throw new FS.ErrnoError(err)}}try{if(FS.trackingDelegate["willMovePath"]){FS.trackingDelegate["willMovePath"](old_path,new_path)}}catch(e){console.log("FS.trackingDelegate['willMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}FS.hashRemoveNode(old_node);try{old_dir.node_ops.rename(old_node,new_dir,new_name)}catch(e){throw e}finally{FS.hashAddNode(old_node)}try{if(FS.trackingDelegate["onMovePath"])FS.trackingDelegate["onMovePath"](old_path,new_path)}catch(e){console.log("FS.trackingDelegate['onMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}}),rmdir:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,true);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.rmdir){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.rmdir(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;if(!node.node_ops.readdir){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}return node.node_ops.readdir(node)}),unlink:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,false);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.unlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.unlink(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readlink:(function(path){var lookup=FS.lookupPath(path);var link=lookup.node;if(!link){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!link.node_ops.readlink){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return PATH.resolve(FS.getPath(link.parent),link.node_ops.readlink(link))}),stat:(function(path,dontFollow){var lookup=FS.lookupPath(path,{follow:!dontFollow});var node=lookup.node;if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!node.node_ops.getattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return node.node_ops.getattr(node)}),lstat:(function(path){return FS.stat(path,true)}),chmod:(function(path,mode,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{mode:mode&4095|node.mode&~4095,timestamp:Date.now()})}),lchmod:(function(path,mode){FS.chmod(path,mode,true)}),fchmod:(function(fd,mode){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chmod(stream.node,mode)}),chown:(function(path,uid,gid,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{timestamp:Date.now()})}),lchown:(function(path,uid,gid){FS.chown(path,uid,gid,true)}),fchown:(function(fd,uid,gid){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chown(stream.node,uid,gid)}),truncate:(function(path,len){if(len<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:true});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!FS.isFile(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.nodePermissions(node,"w");if(err){throw new FS.ErrnoError(err)}node.node_ops.setattr(node,{size:len,timestamp:Date.now()})}),ftruncate:(function(fd,len){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}FS.truncate(stream.node,len)}),utime:(function(path,atime,mtime){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;node.node_ops.setattr(node,{timestamp:Math.max(atime,mtime)})}),open:(function(path,flags,mode,fd_start,fd_end){if(path===""){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}flags=typeof flags==="string"?FS.modeStringToFlags(flags):flags;mode=typeof mode==="undefined"?438:mode;if(flags&64){mode=mode&4095|32768}else{mode=0}var node;if(typeof path==="object"){node=path}else{path=PATH.normalize(path);try{var lookup=FS.lookupPath(path,{follow:!(flags&131072)});node=lookup.node}catch(e){}}var created=false;if(flags&64){if(node){if(flags&128){throw new FS.ErrnoError(ERRNO_CODES.EEXIST)}}else{node=FS.mknod(path,mode,0);created=true}}if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(FS.isChrdev(node.mode)){flags&=~512}if(flags&65536&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}if(!created){var err=FS.mayOpen(node,flags);if(err){throw new FS.ErrnoError(err)}}if(flags&512){FS.truncate(node,0)}flags&=~(128|512);var stream=FS.createStream({node:node,path:FS.getPath(node),flags:flags,seekable:true,position:0,stream_ops:node.stream_ops,ungotten:[],error:false},fd_start,fd_end);if(stream.stream_ops.open){stream.stream_ops.open(stream)}if(Module["logReadFiles"]&&!(flags&1)){if(!FS.readFiles)FS.readFiles={};if(!(path in FS.readFiles)){FS.readFiles[path]=1;Module["printErr"]("read file: "+path)}}try{if(FS.trackingDelegate["onOpenFile"]){var trackingFlags=0;if((flags&2097155)!==1){trackingFlags|=FS.tracking.openFlags.READ}if((flags&2097155)!==0){trackingFlags|=FS.tracking.openFlags.WRITE}FS.trackingDelegate["onOpenFile"](path,trackingFlags)}}catch(e){console.log("FS.trackingDelegate['onOpenFile']('"+path+"', flags) threw an exception: "+e.message)}return stream}),close:(function(stream){if(stream.getdents)stream.getdents=null;try{if(stream.stream_ops.close){stream.stream_ops.close(stream)}}catch(e){throw e}finally{FS.closeStream(stream.fd)}}),llseek:(function(stream,offset,whence){if(!stream.seekable||!stream.stream_ops.llseek){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}stream.position=stream.stream_ops.llseek(stream,offset,whence);stream.ungotten=[];return stream.position}),read:(function(stream,buffer,offset,length,position){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.read){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesRead=stream.stream_ops.read(stream,buffer,offset,length,position);if(!seeking)stream.position+=bytesRead;return bytesRead}),write:(function(stream,buffer,offset,length,position,canOwn){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.write){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if(stream.flags&1024){FS.llseek(stream,0,2)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesWritten=stream.stream_ops.write(stream,buffer,offset,length,position,canOwn);if(!seeking)stream.position+=bytesWritten;try{if(stream.path&&FS.trackingDelegate["onWriteToFile"])FS.trackingDelegate["onWriteToFile"](stream.path)}catch(e){console.log("FS.trackingDelegate['onWriteToFile']('"+path+"') threw an exception: "+e.message)}return bytesWritten}),allocate:(function(stream,offset,length){if(offset<0||length<=0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(!FS.isFile(stream.node.mode)&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(!stream.stream_ops.allocate){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)}stream.stream_ops.allocate(stream,offset,length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EACCES)}if(!stream.stream_ops.mmap){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}return stream.stream_ops.mmap(stream,buffer,offset,length,position,prot,flags)}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!stream||!stream.stream_ops.msync){return 0}return stream.stream_ops.msync(stream,buffer,offset,length,mmapFlags)}),munmap:(function(stream){return 0}),ioctl:(function(stream,cmd,arg){if(!stream.stream_ops.ioctl){throw new FS.ErrnoError(ERRNO_CODES.ENOTTY)}return stream.stream_ops.ioctl(stream,cmd,arg)}),readFile:(function(path,opts){opts=opts||{};opts.flags=opts.flags||"r";opts.encoding=opts.encoding||"binary";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var ret;var stream=FS.open(path,opts.flags);var stat=FS.stat(path);var length=stat.size;var buf=new Uint8Array(length);FS.read(stream,buf,0,length,0);if(opts.encoding==="utf8"){ret=UTF8ArrayToString(buf,0)}else if(opts.encoding==="binary"){ret=buf}FS.close(stream);return ret}),writeFile:(function(path,data,opts){opts=opts||{};opts.flags=opts.flags||"w";opts.encoding=opts.encoding||"utf8";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var stream=FS.open(path,opts.flags,opts.mode);if(opts.encoding==="utf8"){var buf=new Uint8Array(lengthBytesUTF8(data)+1);var actualNumBytes=stringToUTF8Array(data,buf,0,buf.length);FS.write(stream,buf,0,actualNumBytes,0,opts.canOwn)}else if(opts.encoding==="binary"){FS.write(stream,data,0,data.length,0,opts.canOwn)}FS.close(stream)}),cwd:(function(){return FS.currentPath}),chdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});if(lookup.node===null){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!FS.isDir(lookup.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}var err=FS.nodePermissions(lookup.node,"x");if(err){throw new FS.ErrnoError(err)}FS.currentPath=lookup.path}),createDefaultDirectories:(function(){FS.mkdir("/tmp");FS.mkdir("/home");FS.mkdir("/home/web_user")}),createDefaultDevices:(function(){FS.mkdir("/dev");FS.registerDevice(FS.makedev(1,3),{read:(function(){return 0}),write:(function(stream,buffer,offset,length,pos){return length})});FS.mkdev("/dev/null",FS.makedev(1,3));TTY.register(FS.makedev(5,0),TTY.default_tty_ops);TTY.register(FS.makedev(6,0),TTY.default_tty1_ops);FS.mkdev("/dev/tty",FS.makedev(5,0));FS.mkdev("/dev/tty1",FS.makedev(6,0));var random_device;if(typeof crypto!=="undefined"){var randomBuffer=new Uint8Array(1);random_device=(function(){crypto.getRandomValues(randomBuffer);return randomBuffer[0]})}else if(ENVIRONMENT_IS_NODE){random_device=(function(){return require("crypto").randomBytes(1)[0]})}else{random_device=(function(){return Math.random()*256|0})}FS.createDevice("/dev","random",random_device);FS.createDevice("/dev","urandom",random_device);FS.mkdir("/dev/shm");FS.mkdir("/dev/shm/tmp")}),createSpecialDirectories:(function(){FS.mkdir("/proc");FS.mkdir("/proc/self");FS.mkdir("/proc/self/fd");FS.mount({mount:(function(){var node=FS.createNode("/proc/self","fd",16384|511,73);node.node_ops={lookup:(function(parent,name){var fd=+name;var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);var ret={parent:null,mount:{mountpoint:"fake"},node_ops:{readlink:(function(){return stream.path})}};ret.parent=ret;return ret})};return node})},{},"/proc/self/fd")}),createStandardStreams:(function(){if(Module["stdin"]){FS.createDevice("/dev","stdin",Module["stdin"])}else{FS.symlink("/dev/tty","/dev/stdin")}if(Module["stdout"]){FS.createDevice("/dev","stdout",null,Module["stdout"])}else{FS.symlink("/dev/tty","/dev/stdout")}if(Module["stderr"]){FS.createDevice("/dev","stderr",null,Module["stderr"])}else{FS.symlink("/dev/tty1","/dev/stderr")}var stdin=FS.open("/dev/stdin","r");assert(stdin.fd===0,"invalid handle for stdin ("+stdin.fd+")");var stdout=FS.open("/dev/stdout","w");assert(stdout.fd===1,"invalid handle for stdout ("+stdout.fd+")");var stderr=FS.open("/dev/stderr","w");assert(stderr.fd===2,"invalid handle for stderr ("+stderr.fd+")")}),ensureErrnoError:(function(){if(FS.ErrnoError)return;FS.ErrnoError=function ErrnoError(errno,node){this.node=node;this.setErrno=(function(errno){this.errno=errno;for(var key in ERRNO_CODES){if(ERRNO_CODES[key]===errno){this.code=key;break}}});this.setErrno(errno);this.message=ERRNO_MESSAGES[errno]};FS.ErrnoError.prototype=new Error;FS.ErrnoError.prototype.constructor=FS.ErrnoError;[ERRNO_CODES.ENOENT].forEach((function(code){FS.genericErrors[code]=new FS.ErrnoError(code);FS.genericErrors[code].stack="<generic error, no stack>"}))}),staticInit:(function(){FS.ensureErrnoError();FS.nameTable=new Array(4096);FS.mount(MEMFS,{},"/");FS.createDefaultDirectories();FS.createDefaultDevices();FS.createSpecialDirectories();FS.filesystems={"MEMFS":MEMFS,"IDBFS":IDBFS,"NODEFS":NODEFS,"WORKERFS":WORKERFS}}),init:(function(input,output,error){assert(!FS.init.initialized,"FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");FS.init.initialized=true;FS.ensureErrnoError();Module["stdin"]=input||Module["stdin"];Module["stdout"]=output||Module["stdout"];Module["stderr"]=error||Module["stderr"];FS.createStandardStreams()}),quit:(function(){FS.init.initialized=false;var fflush=Module["_fflush"];if(fflush)fflush(0);for(var i=0;i<FS.streams.length;i++){var stream=FS.streams[i];if(!stream){continue}FS.close(stream)}}),getMode:(function(canRead,canWrite){var mode=0;if(canRead)mode|=292|73;if(canWrite)mode|=146;return mode}),joinPath:(function(parts,forceRelative){var path=PATH.join.apply(null,parts);if(forceRelative&&path[0]=="/")path=path.substr(1);return path}),absolutePath:(function(relative,base){return PATH.resolve(base,relative)}),standardizePath:(function(path){return PATH.normalize(path)}),findObject:(function(path,dontResolveLastLink){var ret=FS.analyzePath(path,dontResolveLastLink);if(ret.exists){return ret.object}else{___setErrNo(ret.error);return null}}),analyzePath:(function(path,dontResolveLastLink){try{var lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});path=lookup.path}catch(e){}var ret={isRoot:false,exists:false,error:0,name:null,path:null,object:null,parentExists:false,parentPath:null,parentObject:null};try{var lookup=FS.lookupPath(path,{parent:true});ret.parentExists=true;ret.parentPath=lookup.path;ret.parentObject=lookup.node;ret.name=PATH.basename(path);lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});ret.exists=true;ret.path=lookup.path;ret.object=lookup.node;ret.name=lookup.node.name;ret.isRoot=lookup.path==="/"}catch(e){ret.error=e.errno}return ret}),createFolder:(function(parent,name,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.mkdir(path,mode)}),createPath:(function(parent,path,canRead,canWrite){parent=typeof parent==="string"?parent:FS.getPath(parent);var parts=path.split("/").reverse();while(parts.length){var part=parts.pop();if(!part)continue;var current=PATH.join2(parent,part);try{FS.mkdir(current)}catch(e){}parent=current}return current}),createFile:(function(parent,name,properties,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.create(path,mode)}),createDataFile:(function(parent,name,data,canRead,canWrite,canOwn){var path=name?PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name):parent;var mode=FS.getMode(canRead,canWrite);var node=FS.create(path,mode);if(data){if(typeof data==="string"){var arr=new Array(data.length);for(var i=0,len=data.length;i<len;++i)arr[i]=data.charCodeAt(i);data=arr}FS.chmod(node,mode|146);var stream=FS.open(node,"w");FS.write(stream,data,0,data.length,0,canOwn);FS.close(stream);FS.chmod(node,mode)}return node}),createDevice:(function(parent,name,input,output){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(!!input,!!output);if(!FS.createDevice.major)FS.createDevice.major=64;var dev=FS.makedev(FS.createDevice.major++,0);FS.registerDevice(dev,{open:(function(stream){stream.seekable=false}),close:(function(stream){if(output&&output.buffer&&output.buffer.length){output(10)}}),read:(function(stream,buffer,offset,length,pos){var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=input()}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){for(var i=0;i<length;i++){try{output(buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})});return FS.mkdev(path,mode,dev)}),createLink:(function(parent,name,target,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);return FS.symlink(target,path)}),forceLoadFile:(function(obj){if(obj.isDevice||obj.isFolder||obj.link||obj.contents)return true;var success=true;if(typeof XMLHttpRequest!=="undefined"){throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.")}else if(Module["read"]){try{obj.contents=intArrayFromString(Module["read"](obj.url),true);obj.usedBytes=obj.contents.length}catch(e){success=false}}else{throw new Error("Cannot load without read() or XMLHttpRequest.")}if(!success)___setErrNo(ERRNO_CODES.EIO);return success}),createLazyFile:(function(parent,name,url,canRead,canWrite){function LazyUint8Array(){this.lengthKnown=false;this.chunks=[]}LazyUint8Array.prototype.get=function LazyUint8Array_get(idx){if(idx>this.length-1||idx<0){return undefined}var chunkOffset=idx%this.chunkSize;var chunkNum=idx/this.chunkSize|0;return this.getter(chunkNum)[chunkOffset]};LazyUint8Array.prototype.setDataGetter=function LazyUint8Array_setDataGetter(getter){this.getter=getter};LazyUint8Array.prototype.cacheLength=function LazyUint8Array_cacheLength(){var xhr=new XMLHttpRequest;xhr.open("HEAD",url,false);xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);var datalength=Number(xhr.getResponseHeader("Content-length"));var header;var hasByteServing=(header=xhr.getResponseHeader("Accept-Ranges"))&&header==="bytes";var usesGzip=(header=xhr.getResponseHeader("Content-Encoding"))&&header==="gzip";var chunkSize=1024*1024;if(!hasByteServing)chunkSize=datalength;var doXHR=(function(from,to){if(from>to)throw new Error("invalid range ("+from+", "+to+") or no bytes requested!");if(to>datalength-1)throw new Error("only "+datalength+" bytes available! programmer error!");var xhr=new XMLHttpRequest;xhr.open("GET",url,false);if(datalength!==chunkSize)xhr.setRequestHeader("Range","bytes="+from+"-"+to);if(typeof Uint8Array!="undefined")xhr.responseType="arraybuffer";if(xhr.overrideMimeType){xhr.overrideMimeType("text/plain; charset=x-user-defined")}xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);if(xhr.response!==undefined){return new Uint8Array(xhr.response||[])}else{return intArrayFromString(xhr.responseText||"",true)}});var lazyArray=this;lazyArray.setDataGetter((function(chunkNum){var start=chunkNum*chunkSize;var end=(chunkNum+1)*chunkSize-1;end=Math.min(end,datalength-1);if(typeof lazyArray.chunks[chunkNum]==="undefined"){lazyArray.chunks[chunkNum]=doXHR(start,end)}if(typeof lazyArray.chunks[chunkNum]==="undefined")throw new Error("doXHR failed!");return lazyArray.chunks[chunkNum]}));if(usesGzip||!datalength){chunkSize=datalength=1;datalength=this.getter(0).length;chunkSize=datalength;console.log("LazyFiles on gzip forces download of the whole file when length is accessed")}this._length=datalength;this._chunkSize=chunkSize;this.lengthKnown=true};if(typeof XMLHttpRequest!=="undefined"){if(!ENVIRONMENT_IS_WORKER)throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var lazyArray=new LazyUint8Array;Object.defineProperties(lazyArray,{length:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._length})},chunkSize:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._chunkSize})}});var properties={isDevice:false,contents:lazyArray}}else{var properties={isDevice:false,url:url}}var node=FS.createFile(parent,name,properties,canRead,canWrite);if(properties.contents){node.contents=properties.contents}else if(properties.url){node.contents=null;node.url=properties.url}Object.defineProperties(node,{usedBytes:{get:(function(){return this.contents.length})}});var stream_ops={};var keys=Object.keys(node.stream_ops);keys.forEach((function(key){var fn=node.stream_ops[key];stream_ops[key]=function forceLoadLazyFile(){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return fn.apply(null,arguments)}}));stream_ops.read=function stream_ops_read(stream,buffer,offset,length,position){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}var contents=stream.node.contents;if(position>=contents.length)return 0;var size=Math.min(contents.length-position,length);assert(size>=0);if(contents.slice){for(var i=0;i<size;i++){buffer[offset+i]=contents[position+i]}}else{for(var i=0;i<size;i++){buffer[offset+i]=contents.get(position+i)}}return size};node.stream_ops=stream_ops;return node}),createPreloadedFile:(function(parent,name,url,canRead,canWrite,onload,onerror,dontCreateFile,canOwn,preFinish){Browser.init();var fullname=name?PATH.resolve(PATH.join2(parent,name)):parent;var dep=getUniqueRunDependency("cp "+fullname);function processData(byteArray){function finish(byteArray){if(preFinish)preFinish();if(!dontCreateFile){FS.createDataFile(parent,name,byteArray,canRead,canWrite,canOwn)}if(onload)onload();removeRunDependency(dep)}var handled=false;Module["preloadPlugins"].forEach((function(plugin){if(handled)return;if(plugin["canHandle"](fullname)){plugin["handle"](byteArray,fullname,finish,(function(){if(onerror)onerror();removeRunDependency(dep)}));handled=true}}));if(!handled)finish(byteArray)}addRunDependency(dep);if(typeof url=="string"){Browser.asyncLoad(url,(function(byteArray){processData(byteArray)}),onerror)}else{processData(url)}}),indexedDB:(function(){return window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB}),DB_NAME:(function(){return"EM_FS_"+window.location.pathname}),DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=function openRequest_onupgradeneeded(){console.log("creating db");var db=openRequest.result;db.createObjectStore(FS.DB_STORE_NAME)};openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;var transaction=db.transaction([FS.DB_STORE_NAME],"readwrite");var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var putRequest=files.put(FS.analyzePath(path).object.contents,path);putRequest.onsuccess=function putRequest_onsuccess(){ok++;if(ok+fail==total)finish()};putRequest.onerror=function putRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror}),loadFilesFromDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=onerror;openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;try{var transaction=db.transaction([FS.DB_STORE_NAME],"readonly")}catch(e){onerror(e);return}var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var getRequest=files.get(path);getRequest.onsuccess=function getRequest_onsuccess(){if(FS.analyzePath(path).exists){FS.unlink(path)}FS.createDataFile(PATH.dirname(path),PATH.basename(path),getRequest.result,true,true,true);ok++;if(ok+fail==total)finish()};getRequest.onerror=function getRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror})};var SYSCALLS={DEFAULT_POLLMASK:5,mappings:{},umask:511,calculateAt:(function(dirfd,path){if(path[0]!=="/"){var dir;if(dirfd===-100){dir=FS.cwd()}else{var dirstream=FS.getStream(dirfd);if(!dirstream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);dir=dirstream.path}path=PATH.join2(dir,path)}return path}),doStat:(function(func,path,buf){try{var stat=func(path)}catch(e){if(e&&e.node&&PATH.normalize(path)!==PATH.normalize(FS.getPath(e.node))){return-ERRNO_CODES.ENOTDIR}throw e}HEAP32[buf>>2]=stat.dev;HEAP32[buf+4>>2]=0;HEAP32[buf+8>>2]=stat.ino;HEAP32[buf+12>>2]=stat.mode;HEAP32[buf+16>>2]=stat.nlink;HEAP32[buf+20>>2]=stat.uid;HEAP32[buf+24>>2]=stat.gid;HEAP32[buf+28>>2]=stat.rdev;HEAP32[buf+32>>2]=0;HEAP32[buf+36>>2]=stat.size;HEAP32[buf+40>>2]=4096;HEAP32[buf+44>>2]=stat.blocks;HEAP32[buf+48>>2]=stat.atime.getTime()/1e3|0;HEAP32[buf+52>>2]=0;HEAP32[buf+56>>2]=stat.mtime.getTime()/1e3|0;HEAP32[buf+60>>2]=0;HEAP32[buf+64>>2]=stat.ctime.getTime()/1e3|0;HEAP32[buf+68>>2]=0;HEAP32[buf+72>>2]=stat.ino;return 0}),doMsync:(function(addr,stream,len,flags){var buffer=new Uint8Array(HEAPU8.subarray(addr,addr+len));FS.msync(stream,buffer,0,len,flags)}),doMkdir:(function(path,mode){path=PATH.normalize(path);if(path[path.length-1]==="/")path=path.substr(0,path.length-1);FS.mkdir(path,mode,0);return 0}),doMknod:(function(path,mode,dev){switch(mode&61440){case 32768:case 8192:case 24576:case 4096:case 49152:break;default:return-ERRNO_CODES.EINVAL}FS.mknod(path,mode,dev);return 0}),doReadlink:(function(path,buf,bufsize){if(bufsize<=0)return-ERRNO_CODES.EINVAL;var ret=FS.readlink(path);var len=Math.min(bufsize,lengthBytesUTF8(ret));var endChar=HEAP8[buf+len];stringToUTF8(ret,buf,bufsize+1);HEAP8[buf+len]=endChar;return len}),doAccess:(function(path,amode){if(amode&~7){return-ERRNO_CODES.EINVAL}var node;var lookup=FS.lookupPath(path,{follow:true});node=lookup.node;var perms="";if(amode&4)perms+="r";if(amode&2)perms+="w";if(amode&1)perms+="x";if(perms&&FS.nodePermissions(node,perms)){return-ERRNO_CODES.EACCES}return 0}),doDup:(function(path,flags,suggestFD){var suggest=FS.getStream(suggestFD);if(suggest)FS.close(suggest);return FS.open(path,flags,0,suggestFD,suggestFD).fd}),doReadv:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.read(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr;if(curr<len)break}return ret}),doWritev:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.write(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr}return ret}),varargs:0,get:(function(varargs){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret}),getStr:(function(){var ret=Pointer_stringify(SYSCALLS.get());return ret}),getStreamFromFD:(function(){var stream=FS.getStream(SYSCALLS.get());if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return stream}),getSocketFromFD:(function(){var socket=SOCKFS.getSocket(SYSCALLS.get());if(!socket)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return socket}),getSocketAddress:(function(allowNull){var addrp=SYSCALLS.get(),addrlen=SYSCALLS.get();if(allowNull&&addrp===0)return null;var info=__read_sockaddr(addrp,addrlen);if(info.errno)throw new FS.ErrnoError(info.errno);info.addr=DNS.lookup_addr(info.addr)||info.addr;return info}),get64:(function(){var low=SYSCALLS.get(),high=SYSCALLS.get();if(low>=0)assert(high===0);else assert(high===-1);return low}),getZero:(function(){assert(SYSCALLS.get()===0)})};function ___syscall54(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),op=SYSCALLS.get();switch(op){case 21505:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21506:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21519:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;var argp=SYSCALLS.get();HEAP32[argp>>2]=0;return 0};case 21520:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return-ERRNO_CODES.EINVAL};case 21531:{var argp=SYSCALLS.get();return FS.ioctl(stream,op,argp)};default:abort("bad ioctl syscall "+op)}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __ZN2cv3EMDERKNS_11_InputArrayES2_iS2_PfRKNS_12_OutputArrayE(){Module["printErr"]("missing function: _ZN2cv3EMDERKNS_11_InputArrayES2_iS2_PfRKNS_12_OutputArrayE");abort(-1)}Module["_bitshift64Ashr"]=_bitshift64Ashr;Module["_bitshift64Lshr"]=_bitshift64Lshr;function upcastPointer(ptr,ptrClass,desiredClass){while(ptrClass!==desiredClass){if(!ptrClass.upcast){throwBindingError("Expected null or instance of "+desiredClass.name+", got an instance of "+ptrClass.name)}ptr=ptrClass.upcast(ptr);ptrClass=ptrClass.baseClass}return ptr}function constNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}return 0}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}function genericPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}if(this.isSmartPointer){var ptr=this.rawConstructor();if(destructors!==null){destructors.push(this.rawDestructor,ptr)}return ptr}else{return 0}}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}if(!this.isConst&&handle.$$.ptrType.isConst){throwBindingError("Cannot convert argument of type "+(handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name)+" to parameter type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);if(this.isSmartPointer){if(undefined===handle.$$.smartPtr){throwBindingError("Passing raw pointer to smart pointer is illegal")}switch(this.sharingPolicy){case 0:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{throwBindingError("Cannot convert argument of type "+(handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name)+" to parameter type "+this.name)}break;case 1:ptr=handle.$$.smartPtr;break;case 2:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{var clonedHandle=handle["clone"]();ptr=this.rawShare(ptr,__emval_register((function(){clonedHandle["delete"]()})));if(destructors!==null){destructors.push(this.rawDestructor,ptr)}}break;default:throwBindingError("Unsupporting sharing policy")}}return ptr}function nonConstNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}return 0}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}if(handle.$$.ptrType.isConst){throwBindingError("Cannot convert argument of type "+handle.$$.ptrType.name+" to parameter type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}function RegisteredPointer_getPointee(ptr){if(this.rawGetPointee){ptr=this.rawGetPointee(ptr)}return ptr}function RegisteredPointer_destructor(ptr){if(this.rawDestructor){this.rawDestructor(ptr)}}function RegisteredPointer_deleteObject(handle){if(handle!==null){handle["delete"]()}}function downcastPointer(ptr,ptrClass,desiredClass){if(ptrClass===desiredClass){return ptr}if(undefined===desiredClass.baseClass){return null}var rv=downcastPointer(ptr,ptrClass,desiredClass.baseClass);if(rv===null){return null}return desiredClass.downcast(rv)}var registeredPointers={};function getInheritedInstanceCount(){return Object.keys(registeredInstances).length}function getLiveInheritedInstances(){var rv=[];for(var k in registeredInstances){if(registeredInstances.hasOwnProperty(k)){rv.push(registeredInstances[k])}}return rv}var deletionQueue=[];function flushPendingDeletes(){while(deletionQueue.length){var obj=deletionQueue.pop();obj.$$.deleteScheduled=false;obj["delete"]()}}var delayFunction=undefined;function setDelayFunction(fn){delayFunction=fn;if(deletionQueue.length&&delayFunction){delayFunction(flushPendingDeletes)}}function init_embind(){Module["getInheritedInstanceCount"]=getInheritedInstanceCount;Module["getLiveInheritedInstances"]=getLiveInheritedInstances;Module["flushPendingDeletes"]=flushPendingDeletes;Module["setDelayFunction"]=setDelayFunction}var registeredInstances={};function getBasestPointer(class_,ptr){if(ptr===undefined){throwBindingError("ptr should not be undefined")}while(class_.baseClass){ptr=class_.upcast(ptr);class_=class_.baseClass}return ptr}function getInheritedInstance(class_,ptr){ptr=getBasestPointer(class_,ptr);return registeredInstances[ptr]}function makeClassHandle(prototype,record){if(!record.ptrType||!record.ptr){throwInternalError("makeClassHandle requires ptr and ptrType")}var hasSmartPtrType=!!record.smartPtrType;var hasSmartPtr=!!record.smartPtr;if(hasSmartPtrType!==hasSmartPtr){throwInternalError("Both smartPtrType and smartPtr must be specified")}record.count={value:1};return Object.create(prototype,{$$:{value:record}})}function RegisteredPointer_fromWireType(ptr){var rawPointer=this.getPointee(ptr);if(!rawPointer){this.destructor(ptr);return null}var registeredInstance=getInheritedInstance(this.registeredClass,rawPointer);if(undefined!==registeredInstance){if(0===registeredInstance.$$.count.value){registeredInstance.$$.ptr=rawPointer;registeredInstance.$$.smartPtr=ptr;return registeredInstance["clone"]()}else{var rv=registeredInstance["clone"]();this.destructor(ptr);return rv}}function makeDefaultHandle(){if(this.isSmartPointer){return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this.pointeeType,ptr:rawPointer,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this,ptr:ptr})}}var actualType=this.registeredClass.getActualType(rawPointer);var registeredPointerRecord=registeredPointers[actualType];if(!registeredPointerRecord){return makeDefaultHandle.call(this)}var toType;if(this.isConst){toType=registeredPointerRecord.constPointerType}else{toType=registeredPointerRecord.pointerType}var dp=downcastPointer(rawPointer,this.registeredClass,toType.registeredClass);if(dp===null){return makeDefaultHandle.call(this)}if(this.isSmartPointer){return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp})}}function init_RegisteredPointer(){RegisteredPointer.prototype.getPointee=RegisteredPointer_getPointee;RegisteredPointer.prototype.destructor=RegisteredPointer_destructor;RegisteredPointer.prototype["argPackAdvance"]=8;RegisteredPointer.prototype["readValueFromPointer"]=simpleReadValueFromPointer;RegisteredPointer.prototype["deleteObject"]=RegisteredPointer_deleteObject;RegisteredPointer.prototype["fromWireType"]=RegisteredPointer_fromWireType}function RegisteredPointer(name,registeredClass,isReference,isConst,isSmartPointer,pointeeType,sharingPolicy,rawGetPointee,rawConstructor,rawShare,rawDestructor){this.name=name;this.registeredClass=registeredClass;this.isReference=isReference;this.isConst=isConst;this.isSmartPointer=isSmartPointer;this.pointeeType=pointeeType;this.sharingPolicy=sharingPolicy;this.rawGetPointee=rawGetPointee;this.rawConstructor=rawConstructor;this.rawShare=rawShare;this.rawDestructor=rawDestructor;if(!isSmartPointer&&registeredClass.baseClass===undefined){if(isConst){this["toWireType"]=constNoSmartPtrRawPointerToWireType;this.destructorFunction=null}else{this["toWireType"]=nonConstNoSmartPtrRawPointerToWireType;this.destructorFunction=null}}else{this["toWireType"]=genericPointerToWireType}}function requireFunction(signature,rawFunction){signature=readLatin1String(signature);function makeDynCaller(dynCall){var args=[];for(var i=1;i<signature.length;++i){args.push("a"+i)}var name="dynCall_"+signature+"_"+rawFunction;var body="return function "+name+"("+args.join(", ")+") {\n";body+="    return dynCall(rawFunction"+(args.length?", ":"")+args.join(", ")+");\n";body+="};\n";return(new Function("dynCall","rawFunction",body))(dynCall,rawFunction)}var fp;if(Module["FUNCTION_TABLE_"+signature]!==undefined){fp=Module["FUNCTION_TABLE_"+signature][rawFunction]}else if(typeof FUNCTION_TABLE!=="undefined"){fp=FUNCTION_TABLE[rawFunction]}else{var dc=asm["dynCall_"+signature];if(dc===undefined){dc=asm["dynCall_"+signature.replace(/f/g,"d")];if(dc===undefined){throwBindingError("No dynCall invoker for signature: "+signature)}}fp=makeDynCaller(dc)}if(typeof fp!=="function"){throwBindingError("unknown function pointer with signature "+signature+": "+rawFunction)}return fp}function __embind_register_smart_ptr(rawType,rawPointeeType,name,sharingPolicy,getPointeeSignature,rawGetPointee,constructorSignature,rawConstructor,shareSignature,rawShare,destructorSignature,rawDestructor){name=readLatin1String(name);rawGetPointee=requireFunction(getPointeeSignature,rawGetPointee);rawConstructor=requireFunction(constructorSignature,rawConstructor);rawShare=requireFunction(shareSignature,rawShare);rawDestructor=requireFunction(destructorSignature,rawDestructor);whenDependentTypesAreResolved([rawType],[rawPointeeType],(function(pointeeType){pointeeType=pointeeType[0];var registeredPointer=new RegisteredPointer(name,pointeeType.registeredClass,false,false,true,pointeeType,sharingPolicy,rawGetPointee,rawConstructor,rawShare,rawDestructor);return[registeredPointer]}))}var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_STATIC);Module["_llvm_cttz_i32"]=_llvm_cttz_i32;Module["___udivmoddi4"]=___udivmoddi4;Module["___udivdi3"]=___udivdi3;function ___syscall33(which,varargs){SYSCALLS.varargs=varargs;try{var path=SYSCALLS.getStr(),amode=SYSCALLS.get();return SYSCALLS.doAccess(path,amode)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _pthread_cleanup_push(routine,arg){__ATEXIT__.push((function(){Runtime.dynCall("vi",routine,[arg])}));_pthread_cleanup_push.level=__ATEXIT__.length}Module["_pthread_cond_broadcast"]=_pthread_cond_broadcast;function new_(constructor,argumentList){if(!(constructor instanceof Function)){throw new TypeError("new_ called with constructor type "+typeof constructor+" which is not a function")}var dummy=createNamedFunction(constructor.name||"unknownFunctionName",(function(){}));dummy.prototype=constructor.prototype;var obj=new dummy;var r=constructor.apply(obj,argumentList);return r instanceof Object?r:obj}function runDestructors(destructors){while(destructors.length){var ptr=destructors.pop();var del=destructors.pop();del(ptr)}}function craftInvokerFunction(humanName,argTypes,classType,cppInvokerFunc,cppTargetFunc){var argCount=argTypes.length;if(argCount<2){throwBindingError("argTypes array size mismatch! Must at least get return value and 'this' types!")}var isClassMethodFunc=argTypes[1]!==null&&classType!==null;var argsList="";var argsListWired="";for(var i=0;i<argCount-2;++i){argsList+=(i!==0?", ":"")+"arg"+i;argsListWired+=(i!==0?", ":"")+"arg"+i+"Wired"}var invokerFnBody="return function "+makeLegalFunctionName(humanName)+"("+argsList+") {\n"+"if (arguments.length !== "+(argCount-2)+") {\n"+"throwBindingError('function "+humanName+" called with ' + arguments.length + ' arguments, expected "+(argCount-2)+" args!');\n"+"}\n";var needsDestructorStack=false;for(var i=1;i<argTypes.length;++i){if(argTypes[i]!==null&&argTypes[i].destructorFunction===undefined){needsDestructorStack=true;break}}if(needsDestructorStack){invokerFnBody+="var destructors = [];\n"}var dtorStack=needsDestructorStack?"destructors":"null";var args1=["throwBindingError","invoker","fn","runDestructors","retType","classParam"];var args2=[throwBindingError,cppInvokerFunc,cppTargetFunc,runDestructors,argTypes[0],argTypes[1]];if(isClassMethodFunc){invokerFnBody+="var thisWired = classParam.toWireType("+dtorStack+", this);\n"}for(var i=0;i<argCount-2;++i){invokerFnBody+="var arg"+i+"Wired = argType"+i+".toWireType("+dtorStack+", arg"+i+"); // "+argTypes[i+2].name+"\n";args1.push("argType"+i);args2.push(argTypes[i+2])}if(isClassMethodFunc){argsListWired="thisWired"+(argsListWired.length>0?", ":"")+argsListWired}var returns=argTypes[0].name!=="void";invokerFnBody+=(returns?"var rv = ":"")+"invoker(fn"+(argsListWired.length>0?", ":"")+argsListWired+");\n";if(needsDestructorStack){invokerFnBody+="runDestructors(destructors);\n"}else{for(var i=isClassMethodFunc?1:2;i<argTypes.length;++i){var paramName=i===1?"thisWired":"arg"+(i-2)+"Wired";if(argTypes[i].destructorFunction!==null){invokerFnBody+=paramName+"_dtor("+paramName+"); // "+argTypes[i].name+"\n";args1.push(paramName+"_dtor");args2.push(argTypes[i].destructorFunction)}}}if(returns){invokerFnBody+="var ret = retType.fromWireType(rv);\n"+"return ret;\n"}else{}invokerFnBody+="}\n";args1.push(invokerFnBody);var invokerFunction=new_(Function,args1).apply(null,args2);return invokerFunction}function ensureOverloadTable(proto,methodName,humanName){if(undefined===proto[methodName].overloadTable){var prevFunc=proto[methodName];proto[methodName]=(function(){if(!proto[methodName].overloadTable.hasOwnProperty(arguments.length)){throwBindingError("Function '"+humanName+"' called with an invalid number of arguments ("+arguments.length+") - expects one of ("+proto[methodName].overloadTable+")!")}return proto[methodName].overloadTable[arguments.length].apply(this,arguments)});proto[methodName].overloadTable=[];proto[methodName].overloadTable[prevFunc.argCount]=prevFunc}}function heap32VectorToArray(count,firstElement){var array=[];for(var i=0;i<count;i++){array.push(HEAP32[(firstElement>>2)+i])}return array}var UnboundTypeError=undefined;function throwUnboundTypeError(message,types){var unboundTypes=[];var seen={};function visit(type){if(seen[type]){return}if(registeredTypes[type]){return}if(typeDependencies[type]){typeDependencies[type].forEach(visit);return}unboundTypes.push(type);seen[type]=true}types.forEach(visit);throw new UnboundTypeError(message+": "+unboundTypes.map(getTypeName).join([", "]))}function __embind_register_class_class_function(rawClassType,methodName,argCount,rawArgTypesAddr,invokerSignature,rawInvoker,fn){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);methodName=readLatin1String(methodName);rawInvoker=requireFunction(invokerSignature,rawInvoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName=classType.name+"."+methodName;function unboundTypesHandler(){throwUnboundTypeError("Cannot call "+humanName+" due to unbound types",rawArgTypes)}var proto=classType.registeredClass.constructor;if(undefined===proto[methodName]){unboundTypesHandler.argCount=argCount-1;proto[methodName]=unboundTypesHandler}else{ensureOverloadTable(proto,methodName,humanName);proto[methodName].overloadTable[argCount-1]=unboundTypesHandler}whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){var invokerArgsArray=[argTypes[0],null].concat(argTypes.slice(1));var func=craftInvokerFunction(humanName,invokerArgsArray,null,rawInvoker,fn);if(undefined===proto[methodName].overloadTable){func.argCount=argCount-1;proto[methodName]=func}else{proto[methodName].overloadTable[argCount-1]=func}return[]}));return[]}))}var _environ=STATICTOP;STATICTOP+=16;function ___buildEnvironment(env){var MAX_ENV_VALUES=64;var TOTAL_ENV_SIZE=1024;var poolPtr;var envPtr;if(!___buildEnvironment.called){___buildEnvironment.called=true;ENV["USER"]=ENV["LOGNAME"]="web_user";ENV["PATH"]="/";ENV["PWD"]="/";ENV["HOME"]="/home/web_user";ENV["LANG"]="C";ENV["_"]=Module["thisProgram"];poolPtr=allocate(TOTAL_ENV_SIZE,"i8",ALLOC_STATIC);envPtr=allocate(MAX_ENV_VALUES*4,"i8*",ALLOC_STATIC);HEAP32[envPtr>>2]=poolPtr;HEAP32[_environ>>2]=envPtr}else{envPtr=HEAP32[_environ>>2];poolPtr=HEAP32[envPtr>>2]}var strings=[];var totalSize=0;for(var key in env){if(typeof env[key]==="string"){var line=key+"="+env[key];strings.push(line);totalSize+=line.length}}if(totalSize>TOTAL_ENV_SIZE){throw new Error("Environment size exceeded TOTAL_ENV_SIZE!")}var ptrSize=4;for(var i=0;i<strings.length;i++){var line=strings[i];writeAsciiToMemory(line,poolPtr);HEAP32[envPtr+i*ptrSize>>2]=poolPtr;poolPtr+=line.length+1}HEAP32[envPtr+strings.length*ptrSize>>2]=0}var ENV={};function _getenv(name){if(name===0)return 0;name=Pointer_stringify(name);if(!ENV.hasOwnProperty(name))return 0;if(_getenv.ret)_free(_getenv.ret);_getenv.ret=allocate(intArrayFromString(ENV[name]),"i8",ALLOC_NORMAL);return _getenv.ret}function __isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0)}function __arraySum(array,index){var sum=0;for(var i=0;i<=index;sum+=array[i++]);return sum}var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date,days){var newDate=new Date(date.getTime());while(days>0){var leap=__isLeapYear(newDate.getFullYear());var currentMonth=newDate.getMonth();var daysInCurrentMonth=(leap?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR)[currentMonth];if(days>daysInCurrentMonth-newDate.getDate()){days-=daysInCurrentMonth-newDate.getDate()+1;newDate.setDate(1);if(currentMonth<11){newDate.setMonth(currentMonth+1)}else{newDate.setMonth(0);newDate.setFullYear(newDate.getFullYear()+1)}}else{newDate.setDate(newDate.getDate()+days);return newDate}}return newDate}function _strftime(s,maxsize,format,tm){var tm_zone=HEAP32[tm+40>>2];var date={tm_sec:HEAP32[tm>>2],tm_min:HEAP32[tm+4>>2],tm_hour:HEAP32[tm+8>>2],tm_mday:HEAP32[tm+12>>2],tm_mon:HEAP32[tm+16>>2],tm_year:HEAP32[tm+20>>2],tm_wday:HEAP32[tm+24>>2],tm_yday:HEAP32[tm+28>>2],tm_isdst:HEAP32[tm+32>>2],tm_gmtoff:HEAP32[tm+36>>2],tm_zone:tm_zone?Pointer_stringify(tm_zone):""};var pattern=Pointer_stringify(format);var EXPANSION_RULES_1={"%c":"%a %b %d %H:%M:%S %Y","%D":"%m/%d/%y","%F":"%Y-%m-%d","%h":"%b","%r":"%I:%M:%S %p","%R":"%H:%M","%T":"%H:%M:%S","%x":"%m/%d/%y","%X":"%H:%M:%S"};for(var rule in EXPANSION_RULES_1){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_1[rule])}var WEEKDAYS=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];var MONTHS=["January","February","March","April","May","June","July","August","September","October","November","December"];function leadingSomething(value,digits,character){var str=typeof value==="number"?value.toString():value||"";while(str.length<digits){str=character[0]+str}return str}function leadingNulls(value,digits){return leadingSomething(value,digits,"0")}function compareByDay(date1,date2){function sgn(value){return value<0?-1:value>0?1:0}var compare;if((compare=sgn(date1.getFullYear()-date2.getFullYear()))===0){if((compare=sgn(date1.getMonth()-date2.getMonth()))===0){compare=sgn(date1.getDate()-date2.getDate())}}return compare}function getFirstWeekStartDate(janFourth){switch(janFourth.getDay()){case 0:return new Date(janFourth.getFullYear()-1,11,29);case 1:return janFourth;case 2:return new Date(janFourth.getFullYear(),0,3);case 3:return new Date(janFourth.getFullYear(),0,2);case 4:return new Date(janFourth.getFullYear(),0,1);case 5:return new Date(janFourth.getFullYear()-1,11,31);case 6:return new Date(janFourth.getFullYear()-1,11,30)}}function getWeekBasedYear(date){var thisDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);var janFourthThisYear=new Date(thisDate.getFullYear(),0,4);var janFourthNextYear=new Date(thisDate.getFullYear()+1,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);if(compareByDay(firstWeekStartThisYear,thisDate)<=0){if(compareByDay(firstWeekStartNextYear,thisDate)<=0){return thisDate.getFullYear()+1}else{return thisDate.getFullYear()}}else{return thisDate.getFullYear()-1}}var EXPANSION_RULES_2={"%a":(function(date){return WEEKDAYS[date.tm_wday].substring(0,3)}),"%A":(function(date){return WEEKDAYS[date.tm_wday]}),"%b":(function(date){return MONTHS[date.tm_mon].substring(0,3)}),"%B":(function(date){return MONTHS[date.tm_mon]}),"%C":(function(date){var year=date.tm_year+1900;return leadingNulls(year/100|0,2)}),"%d":(function(date){return leadingNulls(date.tm_mday,2)}),"%e":(function(date){return leadingSomething(date.tm_mday,2," ")}),"%g":(function(date){return getWeekBasedYear(date).toString().substring(2)}),"%G":(function(date){return getWeekBasedYear(date)}),"%H":(function(date){return leadingNulls(date.tm_hour,2)}),"%I":(function(date){var twelveHour=date.tm_hour;if(twelveHour==0)twelveHour=12;else if(twelveHour>12)twelveHour-=12;return leadingNulls(twelveHour,2)}),"%j":(function(date){return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900)?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,date.tm_mon-1),3)}),"%m":(function(date){return leadingNulls(date.tm_mon+1,2)}),"%M":(function(date){return leadingNulls(date.tm_min,2)}),"%n":(function(){return"\n"}),"%p":(function(date){if(date.tm_hour>=0&&date.tm_hour<12){return"AM"}else{return"PM"}}),"%S":(function(date){return leadingNulls(date.tm_sec,2)}),"%t":(function(){return"\t"}),"%u":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()||7}),"%U":(function(date){var janFirst=new Date(date.tm_year+1900,0,1);var firstSunday=janFirst.getDay()===0?janFirst:__addDays(janFirst,7-janFirst.getDay());var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstSunday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstSundayUntilEndJanuary=31-firstSunday.getDate();var days=firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstSunday,janFirst)===0?"01":"00"}),"%V":(function(date){var janFourthThisYear=new Date(date.tm_year+1900,0,4);var janFourthNextYear=new Date(date.tm_year+1901,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);var endDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);if(compareByDay(endDate,firstWeekStartThisYear)<0){return"53"}if(compareByDay(firstWeekStartNextYear,endDate)<=0){return"01"}var daysDifference;if(firstWeekStartThisYear.getFullYear()<date.tm_year+1900){daysDifference=date.tm_yday+32-firstWeekStartThisYear.getDate()}else{daysDifference=date.tm_yday+1-firstWeekStartThisYear.getDate()}return leadingNulls(Math.ceil(daysDifference/7),2)}),"%w":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()}),"%W":(function(date){var janFirst=new Date(date.tm_year,0,1);var firstMonday=janFirst.getDay()===1?janFirst:__addDays(janFirst,janFirst.getDay()===0?1:7-janFirst.getDay()+1);var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstMonday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstMondayUntilEndJanuary=31-firstMonday.getDate();var days=firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstMonday,janFirst)===0?"01":"00"}),"%y":(function(date){return(date.tm_year+1900).toString().substring(2)}),"%Y":(function(date){return date.tm_year+1900}),"%z":(function(date){var off=date.tm_gmtoff;var ahead=off>=0;off=Math.abs(off)/60;off=off/60*100+off%60;return(ahead?"+":"-")+String("0000"+off).slice(-4)}),"%Z":(function(date){return date.tm_zone}),"%%":(function(){return"%"})};for(var rule in EXPANSION_RULES_2){if(pattern.indexOf(rule)>=0){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_2[rule](date))}}var bytes=intArrayFromString(pattern,false);if(bytes.length>maxsize){return 0}writeArrayToMemory(bytes,s);return bytes.length-1}function _strftime_l(s,maxsize,format,tm){return _strftime(s,maxsize,format,tm)}function _pthread_cleanup_pop(){assert(_pthread_cleanup_push.level==__ATEXIT__.length,"cannot pop if something else added meanwhile!");__ATEXIT__.pop();_pthread_cleanup_push.level=__ATEXIT__.length}function _llvm_trap(){abort("trap!")}function __emval_run_destructors(handle){var destructors=emval_handle_array[handle].value;runDestructors(destructors);__emval_decref(handle)}function _emscripten_memcpy_big(dest,src,num){HEAPU8.set(HEAPU8.subarray(src,src+num),dest);return dest}Module["_memcpy"]=_memcpy;function __embind_register_enum_value(rawEnumType,name,enumValue){var enumType=requireRegisteredType(rawEnumType,"enum");name=readLatin1String(name);var Enum=enumType.constructor;var Value=Object.create(enumType.constructor.prototype,{value:{value:enumValue},constructor:{value:createNamedFunction(enumType.name+"_"+name,(function(){}))}});Enum.values[enumValue]=Value;Enum[name]=Value}var tupleRegistrations={};function __embind_finalize_value_array(rawTupleType){var reg=tupleRegistrations[rawTupleType];delete tupleRegistrations[rawTupleType];var elements=reg.elements;var elementsLength=elements.length;var elementTypes=elements.map((function(elt){return elt.getterReturnType})).concat(elements.map((function(elt){return elt.setterArgumentType})));var rawConstructor=reg.rawConstructor;var rawDestructor=reg.rawDestructor;whenDependentTypesAreResolved([rawTupleType],elementTypes,(function(elementTypes){elements.forEach((function(elt,i){var getterReturnType=elementTypes[i];var getter=elt.getter;var getterContext=elt.getterContext;var setterArgumentType=elementTypes[i+elementsLength];var setter=elt.setter;var setterContext=elt.setterContext;elt.read=(function(ptr){return getterReturnType["fromWireType"](getter(getterContext,ptr))});elt.write=(function(ptr,o){var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,o));runDestructors(destructors)})}));return[{name:reg.name,"fromWireType":(function(ptr){var rv=new Array(elementsLength);for(var i=0;i<elementsLength;++i){rv[i]=elements[i].read(ptr)}rawDestructor(ptr);return rv}),"toWireType":(function(destructors,o){if(elementsLength!==o.length){throw new TypeError("Incorrect number of tuple elements for "+reg.name+": expected="+elementsLength+", actual="+o.length)}var ptr=rawConstructor();for(var i=0;i<elementsLength;++i){elements[i].write(ptr,o[i])}if(destructors!==null){destructors.push(rawDestructor,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:rawDestructor}]}))}Module["_sbrk"]=_sbrk;Module["_memmove"]=_memmove;function ___gxx_personality_v0(){}Module["___uremdi3"]=___uremdi3;function _pthread_cond_wait(){return 0}Module["_llvm_bswap_i32"]=_llvm_bswap_i32;function __embind_register_memory_view(rawType,dataTypeIndex,name){var typeMapping=[Int8Array,Uint8Array,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array];var TA=typeMapping[dataTypeIndex];function decodeMemoryView(handle){handle=handle>>2;var heap=HEAPU32;var size=heap[handle];var data=heap[handle+1];return new TA(heap["buffer"],data,size)}name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":decodeMemoryView,"argPackAdvance":8,"readValueFromPointer":decodeMemoryView},{ignoreDuplicateRegistrations:true})}var _llvm_pow_f64=Math_pow;function validateThis(this_,classType,humanName){if(!(this_ instanceof Object)){throwBindingError(humanName+' with invalid "this": '+this_)}if(!(this_ instanceof classType.registeredClass.constructor)){throwBindingError(humanName+' incompatible with "this" of type '+this_.constructor.name)}if(!this_.$$.ptr){throwBindingError("cannot call emscripten binding method "+humanName+" on deleted object")}return upcastPointer(this_.$$.ptr,this_.$$.ptrType.registeredClass,classType.registeredClass)}function __embind_register_class_property(classType,fieldName,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){fieldName=readLatin1String(fieldName);getter=requireFunction(getterSignature,getter);whenDependentTypesAreResolved([],[classType],(function(classType){classType=classType[0];var humanName=classType.name+"."+fieldName;var desc={get:(function(){throwUnboundTypeError("Cannot access "+humanName+" due to unbound types",[getterReturnType,setterArgumentType])}),enumerable:true,configurable:true};if(setter){desc.set=(function(){throwUnboundTypeError("Cannot access "+humanName+" due to unbound types",[getterReturnType,setterArgumentType])})}else{desc.set=(function(v){throwBindingError(humanName+" is a read-only property")})}Object.defineProperty(classType.registeredClass.instancePrototype,fieldName,desc);whenDependentTypesAreResolved([],setter?[getterReturnType,setterArgumentType]:[getterReturnType],(function(types){var getterReturnType=types[0];var desc={get:(function(){var ptr=validateThis(this,classType,humanName+" getter");return getterReturnType["fromWireType"](getter(getterContext,ptr))}),enumerable:true};if(setter){setter=requireFunction(setterSignature,setter);var setterArgumentType=types[1];desc.set=(function(v){var ptr=validateThis(this,classType,humanName+" setter");var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,v));runDestructors(destructors)})}Object.defineProperty(classType.registeredClass.instancePrototype,fieldName,desc);return[]}));return[]}))}function exposePublicSymbol(name,value,numArguments){if(Module.hasOwnProperty(name)){if(undefined===numArguments||undefined!==Module[name].overloadTable&&undefined!==Module[name].overloadTable[numArguments]){throwBindingError("Cannot register public name '"+name+"' twice")}ensureOverloadTable(Module,name,name);if(Module.hasOwnProperty(numArguments)){throwBindingError("Cannot register multiple overloads of a function with the same number of arguments ("+numArguments+")!")}Module[name].overloadTable[numArguments]=value}else{Module[name]=value;if(undefined!==numArguments){Module[name].numArguments=numArguments}}}function getShiftFromSize(size){switch(size){case 1:return 0;case 2:return 1;case 4:return 2;case 8:return 3;default:throw new TypeError("Unknown type size: "+size)}}function enumReadValueFromPointer(name,shift,signed){switch(shift){case 0:return(function(pointer){var heap=signed?HEAP8:HEAPU8;return this["fromWireType"](heap[pointer])});case 1:return(function(pointer){var heap=signed?HEAP16:HEAPU16;return this["fromWireType"](heap[pointer>>1])});case 2:return(function(pointer){var heap=signed?HEAP32:HEAPU32;return this["fromWireType"](heap[pointer>>2])});default:throw new TypeError("Unknown integer type: "+name)}}function __embind_register_enum(rawType,name,size,isSigned){var shift=getShiftFromSize(size);name=readLatin1String(name);function ctor(){}ctor.values={};registerType(rawType,{name:name,constructor:ctor,"fromWireType":(function(c){return this.constructor.values[c]}),"toWireType":(function(destructors,c){return c.value}),"argPackAdvance":8,"readValueFromPointer":enumReadValueFromPointer(name,shift,isSigned),destructorFunction:null});exposePublicSymbol(name,ctor)}function ___syscall40(which,varargs){SYSCALLS.varargs=varargs;try{var path=SYSCALLS.getStr();FS.rmdir(path);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __emval_incref(handle){if(handle>4){emval_handle_array[handle].refcount+=1}}function _pthread_mutexattr_settype(){}function __embind_register_value_array(rawType,name,constructorSignature,rawConstructor,destructorSignature,rawDestructor){tupleRegistrations[rawType]={name:readLatin1String(name),rawConstructor:requireFunction(constructorSignature,rawConstructor),rawDestructor:requireFunction(destructorSignature,rawDestructor),elements:[]}}function __embind_register_bool(rawType,name,size,trueValue,falseValue){var shift=getShiftFromSize(size);name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(wt){return!!wt}),"toWireType":(function(destructors,o){return o?trueValue:falseValue}),"argPackAdvance":8,"readValueFromPointer":(function(pointer){var heap;if(size===1){heap=HEAP8}else if(size===2){heap=HEAP16}else if(size===4){heap=HEAP32}else{throw new TypeError("Unknown boolean type size: "+name)}return this["fromWireType"](heap[pointer>>shift])}),destructorFunction:null})}function ___assert_fail(condition,filename,line,func){ABORT=true;throw"Assertion failed: "+Pointer_stringify(condition)+", at: "+[filename?Pointer_stringify(filename):"unknown filename",line,func?Pointer_stringify(func):"unknown function"]+" at "+stackTrace()}function __embind_register_void(rawType,name){name=readLatin1String(name);registerType(rawType,{isVoid:true,name:name,"argPackAdvance":0,"fromWireType":(function(){return undefined}),"toWireType":(function(destructors,o){return undefined})})}Module["_memset"]=_memset;Module["_bitshift64Shl"]=_bitshift64Shl;function _abort(){Module["abort"]()}function requireHandle(handle){if(!handle){throwBindingError("Cannot use deleted val. handle = "+handle)}return emval_handle_array[handle].value}function __emval_as(handle,returnType,destructorsRef){handle=requireHandle(handle);returnType=requireRegisteredType(returnType,"emval::as");var destructors=[];var rd=__emval_register(destructors);HEAP32[destructorsRef>>2]=rd;return returnType["toWireType"](destructors,handle)}function _pthread_mutex_destroy(){}function _pthread_once(ptr,func){if(!_pthread_once.seen)_pthread_once.seen={};if(ptr in _pthread_once.seen)return;Runtime.dynCall("v",func);_pthread_once.seen[ptr]=1}Module["___divdi3"]=___divdi3;function ClassHandle_isAliasOf(other){if(!(this instanceof ClassHandle)){return false}if(!(other instanceof ClassHandle)){return false}var leftClass=this.$$.ptrType.registeredClass;var left=this.$$.ptr;var rightClass=other.$$.ptrType.registeredClass;var right=other.$$.ptr;while(leftClass.baseClass){left=leftClass.upcast(left);leftClass=leftClass.baseClass}while(rightClass.baseClass){right=rightClass.upcast(right);rightClass=rightClass.baseClass}return leftClass===rightClass&&left===right}function shallowCopyInternalPointer(o){return{count:o.count,deleteScheduled:o.deleteScheduled,preservePointerOnDelete:o.preservePointerOnDelete,ptr:o.ptr,ptrType:o.ptrType,smartPtr:o.smartPtr,smartPtrType:o.smartPtrType}}function throwInstanceAlreadyDeleted(obj){function getInstanceTypeName(handle){return handle.$$.ptrType.registeredClass.name}throwBindingError(getInstanceTypeName(obj)+" instance already deleted")}function ClassHandle_clone(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.preservePointerOnDelete){this.$$.count.value+=1;return this}else{var clone=Object.create(Object.getPrototypeOf(this),{$$:{value:shallowCopyInternalPointer(this.$$)}});clone.$$.count.value+=1;clone.$$.deleteScheduled=false;return clone}}function runDestructor(handle){var $$=handle.$$;if($$.smartPtr){$$.smartPtrType.rawDestructor($$.smartPtr)}else{$$.ptrType.registeredClass.rawDestructor($$.ptr)}}function ClassHandle_delete(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}this.$$.count.value-=1;var toDelete=0===this.$$.count.value;if(toDelete){runDestructor(this)}if(!this.$$.preservePointerOnDelete){this.$$.smartPtr=undefined;this.$$.ptr=undefined}}function ClassHandle_isDeleted(){return!this.$$.ptr}function ClassHandle_deleteLater(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}deletionQueue.push(this);if(deletionQueue.length===1&&delayFunction){delayFunction(flushPendingDeletes)}this.$$.deleteScheduled=true;return this}function init_ClassHandle(){ClassHandle.prototype["isAliasOf"]=ClassHandle_isAliasOf;ClassHandle.prototype["clone"]=ClassHandle_clone;ClassHandle.prototype["delete"]=ClassHandle_delete;ClassHandle.prototype["isDeleted"]=ClassHandle_isDeleted;ClassHandle.prototype["deleteLater"]=ClassHandle_deleteLater}function ClassHandle(){}function RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast){this.name=name;this.constructor=constructor;this.instancePrototype=instancePrototype;this.rawDestructor=rawDestructor;this.baseClass=baseClass;this.getActualType=getActualType;this.upcast=upcast;this.downcast=downcast;this.pureVirtualFunctions=[]}function replacePublicSymbol(name,value,numArguments){if(!Module.hasOwnProperty(name)){throwInternalError("Replacing nonexistant public symbol")}if(undefined!==Module[name].overloadTable&&undefined!==numArguments){Module[name].overloadTable[numArguments]=value}else{Module[name]=value;Module[name].argCount=numArguments}}function __embind_register_class(rawType,rawPointerType,rawConstPointerType,baseClassRawType,getActualTypeSignature,getActualType,upcastSignature,upcast,downcastSignature,downcast,name,destructorSignature,rawDestructor){name=readLatin1String(name);getActualType=requireFunction(getActualTypeSignature,getActualType);if(upcast){upcast=requireFunction(upcastSignature,upcast)}if(downcast){downcast=requireFunction(downcastSignature,downcast)}rawDestructor=requireFunction(destructorSignature,rawDestructor);var legalFunctionName=makeLegalFunctionName(name);exposePublicSymbol(legalFunctionName,(function(){throwUnboundTypeError("Cannot construct "+name+" due to unbound types",[baseClassRawType])}));whenDependentTypesAreResolved([rawType,rawPointerType,rawConstPointerType],baseClassRawType?[baseClassRawType]:[],(function(base){base=base[0];var baseClass;var basePrototype;if(baseClassRawType){baseClass=base.registeredClass;basePrototype=baseClass.instancePrototype}else{basePrototype=ClassHandle.prototype}var constructor=createNamedFunction(legalFunctionName,(function(){if(Object.getPrototypeOf(this)!==instancePrototype){throw new BindingError("Use 'new' to construct "+name)}if(undefined===registeredClass.constructor_body){throw new BindingError(name+" has no accessible constructor")}var body=registeredClass.constructor_body[arguments.length];if(undefined===body){throw new BindingError("Tried to invoke ctor of "+name+" with invalid number of parameters ("+arguments.length+") - expected ("+Object.keys(registeredClass.constructor_body).toString()+") parameters instead!")}return body.apply(this,arguments)}));var instancePrototype=Object.create(basePrototype,{constructor:{value:constructor}});constructor.prototype=instancePrototype;var registeredClass=new RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast);var referenceConverter=new RegisteredPointer(name,registeredClass,true,false,false);var pointerConverter=new RegisteredPointer(name+"*",registeredClass,false,false,false);var constPointerConverter=new RegisteredPointer(name+" const*",registeredClass,false,true,false);registeredPointers[rawType]={pointerType:pointerConverter,constPointerType:constPointerConverter};replacePublicSymbol(legalFunctionName,constructor);return[referenceConverter,pointerConverter,constPointerConverter]}))}function ___lock(){}function ___unlock(){}function _pthread_mutexattr_init(){}function _pthread_getspecific(key){return PTHREAD_SPECIFIC[key]||0}function _embind_repr(v){if(v===null){return"null"}var t=typeof v;if(t==="object"||t==="array"||t==="function"){return v.toString()}else{return""+v}}function integerReadValueFromPointer(name,shift,signed){switch(shift){case 0:return signed?function readS8FromPointer(pointer){return HEAP8[pointer]}:function readU8FromPointer(pointer){return HEAPU8[pointer]};case 1:return signed?function readS16FromPointer(pointer){return HEAP16[pointer>>1]}:function readU16FromPointer(pointer){return HEAPU16[pointer>>1]};case 2:return signed?function readS32FromPointer(pointer){return HEAP32[pointer>>2]}:function readU32FromPointer(pointer){return HEAPU32[pointer>>2]};default:throw new TypeError("Unknown integer type: "+name)}}function __embind_register_integer(primitiveType,name,size,minRange,maxRange){name=readLatin1String(name);if(maxRange===-1){maxRange=4294967295}var shift=getShiftFromSize(size);var fromWireType=(function(value){return value});if(minRange===0){var bitshift=32-8*size;fromWireType=(function(value){return value<<bitshift>>>bitshift})}registerType(primitiveType,{name:name,"fromWireType":fromWireType,"toWireType":(function(destructors,value){if(typeof value!=="number"&&typeof value!=="boolean"){throw new TypeError('Cannot convert "'+_embind_repr(value)+'" to '+this.name)}if(value<minRange||value>maxRange){throw new TypeError('Passing a number "'+_embind_repr(value)+'" from JS side to C/C++ side to an argument of type "'+name+'", which is outside the valid range ['+minRange+", "+maxRange+"]!")}return value|0}),"argPackAdvance":8,"readValueFromPointer":integerReadValueFromPointer(name,shift,minRange!==0),destructorFunction:null})}function __emval_get_property(handle,key){handle=requireHandle(handle);key=requireHandle(key);return __emval_register(handle[key])}function __embind_register_emval(rawType,name){name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(handle){var rv=emval_handle_array[handle].value;__emval_decref(handle);return rv}),"toWireType":(function(destructors,value){return __emval_register(value)}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:null})}function _pthread_setspecific(key,value){if(!(key in PTHREAD_SPECIFIC)){return ERRNO_CODES.EINVAL}PTHREAD_SPECIFIC[key]=value;return 0}function __embind_register_value_array_element(rawTupleType,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){tupleRegistrations[rawTupleType].elements.push({getterReturnType:getterReturnType,getter:requireFunction(getterSignature,getter),getterContext:getterContext,setterArgumentType:setterArgumentType,setter:requireFunction(setterSignature,setter),setterContext:setterContext})}function ___cxa_allocate_exception(size){return _malloc(size)}function ___cxa_pure_virtual(){ABORT=true;throw"Pure virtual function called!"}Module["_testSetjmp"]=_testSetjmp;function _longjmp(env,value){asm["setThrew"](env,value||1);throw"longjmp"}function __embind_register_class_constructor(rawClassType,argCount,rawArgTypesAddr,invokerSignature,invoker,rawConstructor){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);invoker=requireFunction(invokerSignature,invoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName="constructor "+classType.name;if(undefined===classType.registeredClass.constructor_body){classType.registeredClass.constructor_body=[]}if(undefined!==classType.registeredClass.constructor_body[argCount-1]){throw new BindingError("Cannot register multiple constructors with identical number of parameters ("+(argCount-1)+") for class '"+classType.name+"'! Overload resolution is currently only performed using the parameter count, not actual type info!")}classType.registeredClass.constructor_body[argCount-1]=function unboundTypeHandler(){throwUnboundTypeError("Cannot construct "+classType.name+" due to unbound types",rawArgTypes)};whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){classType.registeredClass.constructor_body[argCount-1]=function constructor_body(){if(arguments.length!==argCount-1){throwBindingError(humanName+" called with "+arguments.length+" arguments, expected "+(argCount-1))}var destructors=[];var args=new Array(argCount);args[0]=rawConstructor;for(var i=1;i<argCount;++i){args[i]=argTypes[i]["toWireType"](destructors,arguments[i-1])}var ptr=invoker.apply(null,args);runDestructors(destructors);return argTypes[0]["fromWireType"](ptr)};return[]}));return[]}))}function floatReadValueFromPointer(name,shift){switch(shift){case 2:return(function(pointer){return this["fromWireType"](HEAPF32[pointer>>2])});case 3:return(function(pointer){return this["fromWireType"](HEAPF64[pointer>>3])});default:throw new TypeError("Unknown float type: "+name)}}function __embind_register_float(rawType,name,size){var shift=getShiftFromSize(size);name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(value){return value}),"toWireType":(function(destructors,value){if(typeof value!=="number"&&typeof value!=="boolean"){throw new TypeError('Cannot convert "'+_embind_repr(value)+'" to '+this.name)}return value}),"argPackAdvance":8,"readValueFromPointer":floatReadValueFromPointer(name,shift),destructorFunction:null})}function ___syscall10(which,varargs){SYSCALLS.varargs=varargs;try{var path=SYSCALLS.getStr();FS.unlink(path);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _emscripten_get_now(){abort()}function _emscripten_get_now_is_monotonic(){return ENVIRONMENT_IS_NODE||typeof dateNow!=="undefined"||(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER)&&self["performance"]&&self["performance"]["now"]}function _clock_gettime(clk_id,tp){var now;if(clk_id===0){now=Date.now()}else if(clk_id===1&&_emscripten_get_now_is_monotonic()){now=_emscripten_get_now()}else{___setErrNo(ERRNO_CODES.EINVAL);return-1}HEAP32[tp>>2]=now/1e3|0;HEAP32[tp+4>>2]=now%1e3*1e3*1e3|0;return 0}function ___clock_gettime(){return _clock_gettime.apply(null,arguments)}function __embind_register_function(name,argCount,rawArgTypesAddr,signature,rawInvoker,fn){var argTypes=heap32VectorToArray(argCount,rawArgTypesAddr);name=readLatin1String(name);rawInvoker=requireFunction(signature,rawInvoker);exposePublicSymbol(name,(function(){throwUnboundTypeError("Cannot call "+name+" due to unbound types",argTypes)}),argCount-1);whenDependentTypesAreResolved([],argTypes,(function(argTypes){var invokerArgsArray=[argTypes[0],null].concat(argTypes.slice(1));replacePublicSymbol(name,craftInvokerFunction(name,invokerArgsArray,null,rawInvoker,fn),argCount-1);return[]}))}function _emscripten_longjmp(env,value){_longjmp(env,value)}function __embind_register_constant(name,type,value){name=readLatin1String(name);whenDependentTypesAreResolved([],[type],(function(type){type=type[0];Module[name]=type["fromWireType"](value);return[]}))}function ___cxa_begin_catch(ptr){var info=EXCEPTIONS.infos[ptr];if(info&&!info.caught){info.caught=true;__ZSt18uncaught_exceptionv.uncaught_exception--}if(info)info.rethrown=false;EXCEPTIONS.caught.push(ptr);EXCEPTIONS.addRef(EXCEPTIONS.deAdjust(ptr));return ptr}function ___syscall3(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),buf=SYSCALLS.get(),count=SYSCALLS.get();return FS.read(stream,HEAP8,buf,count)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall5(which,varargs){SYSCALLS.varargs=varargs;try{var pathname=SYSCALLS.getStr(),flags=SYSCALLS.get(),mode=SYSCALLS.get();var stream=FS.open(pathname,flags,mode);return stream.fd}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall4(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),buf=SYSCALLS.get(),count=SYSCALLS.get();return FS.write(stream,HEAP8,buf,count)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall6(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD();FS.close(stream);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}Module["___muldsi3"]=___muldsi3;Module["___muldi3"]=___muldi3;function _gettimeofday(ptr){var now=Date.now();HEAP32[ptr>>2]=now/1e3|0;HEAP32[ptr+4>>2]=now%1e3*1e3|0;return 0}function ___syscall265(which,varargs){SYSCALLS.varargs=varargs;try{return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}Module["_pthread_self"]=_pthread_self;function ___syscall140(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),offset_high=SYSCALLS.get(),offset_low=SYSCALLS.get(),result=SYSCALLS.get(),whence=SYSCALLS.get();var offset=offset_low;assert(offset_high===0);FS.llseek(stream,offset,whence);HEAP32[result>>2]=stream.position;if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __embind_register_class_function(rawClassType,methodName,argCount,rawArgTypesAddr,invokerSignature,rawInvoker,context,isPureVirtual){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);methodName=readLatin1String(methodName);rawInvoker=requireFunction(invokerSignature,rawInvoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName=classType.name+"."+methodName;if(isPureVirtual){classType.registeredClass.pureVirtualFunctions.push(methodName)}function unboundTypesHandler(){throwUnboundTypeError("Cannot call "+humanName+" due to unbound types",rawArgTypes)}var proto=classType.registeredClass.instancePrototype;var method=proto[methodName];if(undefined===method||undefined===method.overloadTable&&method.className!==classType.name&&method.argCount===argCount-2){unboundTypesHandler.argCount=argCount-2;unboundTypesHandler.className=classType.name;proto[methodName]=unboundTypesHandler}else{ensureOverloadTable(proto,methodName,humanName);proto[methodName].overloadTable[argCount-2]=unboundTypesHandler}whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){var memberFunction=craftInvokerFunction(humanName,argTypes,classType,rawInvoker,context);if(undefined===proto[methodName].overloadTable){memberFunction.argCount=argCount-2;proto[methodName]=memberFunction}else{proto[methodName].overloadTable[argCount-2]=memberFunction}return[]}));return[]}))}function ___syscall146(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doWritev(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall221(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),cmd=SYSCALLS.get();switch(cmd){case 0:{var arg=SYSCALLS.get();if(arg<0){return-ERRNO_CODES.EINVAL}var newStream;newStream=FS.open(stream.path,stream.flags,0,arg);return newStream.fd};case 1:case 2:return 0;case 3:return stream.flags;case 4:{var arg=SYSCALLS.get();stream.flags|=arg;return 0};case 12:case 12:{var arg=SYSCALLS.get();var offset=0;HEAP16[arg+offset>>1]=2;return 0};case 13:case 14:case 13:case 14:return 0;case 16:case 8:return-ERRNO_CODES.EINVAL;case 9:___setErrNo(ERRNO_CODES.EINVAL);return-1;default:{return-ERRNO_CODES.EINVAL}}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall145(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doReadv(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var ___dso_handle=STATICTOP;STATICTOP+=16;embind_init_charCodes();init_emval();BindingError=Module["BindingError"]=extendError(Error,"BindingError");InternalError=Module["InternalError"]=extendError(Error,"InternalError");FS.staticInit();__ATINIT__.unshift((function(){if(!Module["noFSInit"]&&!FS.init.initialized)FS.init()}));__ATMAIN__.push((function(){FS.ignorePermissions=false}));__ATEXIT__.push((function(){FS.quit()}));Module["FS_createFolder"]=FS.createFolder;Module["FS_createPath"]=FS.createPath;Module["FS_createDataFile"]=FS.createDataFile;Module["FS_createPreloadedFile"]=FS.createPreloadedFile;Module["FS_createLazyFile"]=FS.createLazyFile;Module["FS_createLink"]=FS.createLink;Module["FS_createDevice"]=FS.createDevice;Module["FS_unlink"]=FS.unlink;__ATINIT__.unshift((function(){TTY.init()}));__ATEXIT__.push((function(){TTY.shutdown()}));if(ENVIRONMENT_IS_NODE){var fs=require("fs");var NODEJS_PATH=require("path");NODEFS.staticInit()}init_RegisteredPointer();init_embind();UnboundTypeError=Module["UnboundTypeError"]=extendError(Error,"UnboundTypeError");___buildEnvironment(ENV);init_ClassHandle();if(ENVIRONMENT_IS_NODE){_emscripten_get_now=function _emscripten_get_now_actual(){var t=process["hrtime"]();return t[0]*1e3+t[1]/1e6}}else if(typeof dateNow!=="undefined"){_emscripten_get_now=dateNow}else if(typeof self==="object"&&self["performance"]&&typeof self["performance"]["now"]==="function"){_emscripten_get_now=(function(){return self["performance"]["now"]()})}else if(typeof performance==="object"&&typeof performance["now"]==="function"){_emscripten_get_now=(function(){return performance["now"]()})}else{_emscripten_get_now=Date.now}DYNAMICTOP_PTR=allocate(1,"i32",ALLOC_STATIC);STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP);STACK_MAX=STACK_BASE+TOTAL_STACK;DYNAMIC_BASE=Runtime.alignMemory(STACK_MAX);HEAP32[DYNAMICTOP_PTR>>2]=DYNAMIC_BASE;staticSealed=true;function invoke_iiiiiid(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiddd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiddd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiidiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiidiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiidddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiddi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiddi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iidd(index,a1,a2,a3){try{return Module["dynCall_iidd"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iidi(index,a1,a2,a3){try{return Module["dynCall_iidi"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiddidd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiddidd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vidi(index,a1,a2,a3){try{Module["dynCall_vidi"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiddii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiddii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiddiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiidi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiidi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiddidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiddidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiidii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiidii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_di(index,a1){try{return Module["dynCall_di"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiddi(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiddddd(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiddddd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_diiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiiddiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{return Module["dynCall_iiiiiddiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viidddddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viidddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_dii(index,a1,a2){try{return Module["dynCall_dii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiidddddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiidddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diidi(index,a1,a2,a3,a4){try{return Module["dynCall_diidi"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){try{Module["dynCall_viiiiiiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiid(index,a1,a2,a3,a4){try{return Module["dynCall_iiiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiddiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiddiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiddiid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiddiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiiiiididiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){try{return Module["dynCall_iiiiiiiididiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iidddd(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iidddd"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viidiiid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viidiiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diiiddi(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_diiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){try{return Module["dynCall_iiiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiididii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiididii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_diiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiidiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiidiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiidiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{return Module["dynCall_iiidiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiidd(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiidd"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiidi(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiidi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vidddd(index,a1,a2,a3,a4,a5){try{Module["dynCall_vidddd"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiiidii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiddd(index,a1,a2,a3,a4){try{return Module["dynCall_iiddd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diiddi(index,a1,a2,a3,a4,a5){try{return Module["dynCall_diiddi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diii(index,a1,a2,a3){try{return Module["dynCall_diii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiddd(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiddd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiddidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiddidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{Module["dynCall_viiiiiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiddidd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiidiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiidiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiddi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiid(index,a1,a2,a3,a4){try{Module["dynCall_viiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viidii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viidii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiii(index,a1,a2,a3,a4){try{Module["dynCall_viiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viidiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viidiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vid(index,a1,a2){try{Module["dynCall_vid"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiidi(index,a1,a2,a3,a4){try{return Module["dynCall_iiidi"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiidd(index,a1,a2,a3,a4){try{return Module["dynCall_iiidd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vii(index,a1,a2){try{Module["dynCall_vii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiid(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viidd(index,a1,a2,a3,a4){try{Module["dynCall_viidd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viidi(index,a1,a2,a3,a4){try{Module["dynCall_viidi"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viddd(index,a1,a2,a3,a4){try{Module["dynCall_viddd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiidii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiidii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diiid(index,a1,a2,a3,a4){try{return Module["dynCall_diiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiidddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diiii(index,a1,a2,a3,a4){try{return Module["dynCall_diiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viddddd(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viddddd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiddddddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiddddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiidii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iid(index,a1,a2){try{return Module["dynCall_iid"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iii(index,a1,a2){try{return Module["dynCall_iii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiddii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiddii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vdiii(index,a1,a2,a3,a4){try{Module["dynCall_vdiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{return Module["dynCall_diiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiddddddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{return Module["dynCall_iiiddddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_i(index){try{return Module["dynCall_i"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viii(index,a1,a2,a3){try{Module["dynCall_viii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_v(index){try{Module["dynCall_v"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viid(index,a1,a2,a3){try{Module["dynCall_viid"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iidddddii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iidddddii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiddiid(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiddiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vi(index,a1){try{Module["dynCall_vi"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiidiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiidiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_ii(index,a1){try{return Module["dynCall_ii"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vidii(index,a1,a2,a3,a4){try{Module["dynCall_vidii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiidiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiidiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiidi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiidi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{Module["dynCall_viiiiiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiii(index,a1,a2,a3){try{return Module["dynCall_iiii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viididii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viididii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiddii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiid(index,a1,a2,a3){try{return Module["dynCall_iiid"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiidii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiidii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_diiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diiiid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_diiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){try{Module["dynCall_viiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{return Module["dynCall_iiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiidid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiidid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{return Module["dynCall_diiiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiidii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiidii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_diiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_diiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vididdii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_vididdii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viididdii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viididdii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiidd(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiidd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vidiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_vidiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}Module.asmGlobalArg={"Math":Math,"Int8Array":Int8Array,"Int16Array":Int16Array,"Int32Array":Int32Array,"Uint8Array":Uint8Array,"Uint16Array":Uint16Array,"Uint32Array":Uint32Array,"Float32Array":Float32Array,"Float64Array":Float64Array,"NaN":NaN,"Infinity":Infinity,"byteLength":byteLength};Module.asmLibraryArg={"abort":abort,"assert":assert,"enlargeMemory":enlargeMemory,"getTotalMemory":getTotalMemory,"abortOnCannotGrowMemory":abortOnCannotGrowMemory,"invoke_iiiiiid":invoke_iiiiiid,"invoke_viiiiddd":invoke_viiiiddd,"invoke_viiiidiii":invoke_viiiidiii,"invoke_viiiiiddi":invoke_viiiiiddi,"invoke_viiidiii":invoke_viiidiii,"invoke_iiiiddiii":invoke_iiiiddiii,"invoke_iiiiiii":invoke_iiiiiii,"invoke_viiiidddiiii":invoke_viiiidddiiii,"invoke_viiiiddi":invoke_viiiiddi,"invoke_viiiiiiiiiii":invoke_viiiiiiiiiii,"invoke_iidd":invoke_iidd,"invoke_viiiiiiiiiid":invoke_viiiiiiiiiid,"invoke_viiiidiiii":invoke_viiiidiiii,"invoke_iidi":invoke_iidi,"invoke_viiddidd":invoke_viiddidd,"invoke_vidi":invoke_vidi,"invoke_viiddii":invoke_viiddii,"invoke_viiiiddiddi":invoke_viiiiddiddi,"invoke_viiiiidi":invoke_viiiiidi,"invoke_viiddidddd":invoke_viiddidddd,"invoke_viiiiddiiid":invoke_viiiiddiiid,"invoke_viiiiiiidi":invoke_viiiiiiidi,"invoke_viiidii":invoke_viiidii,"invoke_di":invoke_di,"invoke_iiiiddi":invoke_iiiiddi,"invoke_viiiidiiddi":invoke_viiiidiiddi,"invoke_iiddddd":invoke_iiddddd,"invoke_diiiiiii":invoke_diiiiiii,"invoke_iiiiiddiddi":invoke_iiiiiddiddi,"invoke_viidddddi":invoke_viidddddi,"invoke_dii":invoke_dii,"invoke_viiiddiiid":invoke_viiiddiiid,"invoke_iiidddddi":invoke_iiidddddi,"invoke_diidi":invoke_diidi,"invoke_viiiiiiiiiiddi":invoke_viiiiiiiiiiddi,"invoke_iiiiiiiiii":invoke_iiiiiiiiii,"invoke_iiiid":invoke_iiiid,"invoke_iiiiiiii":invoke_iiiiiiii,"invoke_viiddiii":invoke_viiddiii,"invoke_viiddiid":invoke_viiddiid,"invoke_iiiiiiiididiii":invoke_iiiiiiiididiii,"invoke_iidddd":invoke_iidddd,"invoke_viidiiid":invoke_viidiiid,"invoke_viiiiidiiii":invoke_viiiiidiiii,"invoke_diiiddi":invoke_diiiddi,"invoke_iiiii":invoke_iiiii,"invoke_viiididii":invoke_viiididii,"invoke_diiiiiiii":invoke_diiiiiiii,"invoke_viiidiiid":invoke_viiidiiid,"invoke_viiiddddii":invoke_viiiddddii,"invoke_iiidiiiiiii":invoke_iiidiiiiiii,"invoke_viiiiid":invoke_viiiiid,"invoke_viiiiddddii":invoke_viiiiddddii,"invoke_viiiiii":invoke_viiiiii,"invoke_viiidiiii":invoke_viiidiiii,"invoke_viiidd":invoke_viiidd,"invoke_viiidi":invoke_viiidi,"invoke_vidddd":invoke_vidddd,"invoke_iiiiiidii":invoke_iiiiiidii,"invoke_iiddd":invoke_iiddd,"invoke_viiiiiiiiii":invoke_viiiiiiiiii,"invoke_diiddi":invoke_diiddi,"invoke_diii":invoke_diii,"invoke_viiiddd":invoke_viiiddd,"invoke_viiiddidddd":invoke_viiiddidddd,"invoke_viiiiiiiiiiid":invoke_viiiiiiiiiiid,"invoke_viiiddidd":invoke_viiiddidd,"invoke_viiidiiiidi":invoke_viiidiiiidi,"invoke_viiiddi":invoke_viiiddi,"invoke_iiiiii":invoke_iiiiii,"invoke_viiid":invoke_viiid,"invoke_viidii":invoke_viidii,"invoke_iiiiid":invoke_iiiiid,"invoke_viiii":invoke_viiii,"invoke_viiiii":invoke_viiiii,"invoke_viidiiiiiii":invoke_viidiiiiiii,"invoke_vid":invoke_vid,"invoke_iiidi":invoke_iiidi,"invoke_iiidd":invoke_iiidd,"invoke_vii":invoke_vii,"invoke_viiiid":invoke_viiiid,"invoke_iiiiidiii":invoke_iiiiidiii,"invoke_viidd":invoke_viidd,"invoke_viidi":invoke_viidi,"invoke_viddd":invoke_viddd,"invoke_viiidiiddi":invoke_viiidiiddi,"invoke_iiiidii":invoke_iiiidii,"invoke_diiid":invoke_diiid,"invoke_viiiiiiii":invoke_viiiiiiii,"invoke_viiidddiiii":invoke_viiidddiiii,"invoke_viiiiiiid":invoke_viiiiiiid,"invoke_viiiiiiddi":invoke_viiiiiiddi,"invoke_diiii":invoke_diiii,"invoke_viiiiidiiddi":invoke_viiiiidiiddi,"invoke_viddddd":invoke_viddddd,"invoke_viiddddddi":invoke_viiddddddi,"invoke_viiiiiddii":invoke_viiiiiddii,"invoke_viiiiidii":invoke_viiiiidii,"invoke_iid":invoke_iid,"invoke_viiiiiiiid":invoke_viiiiiiiid,"invoke_viiiiiii":invoke_viiiiiii,"invoke_viiiiiid":invoke_viiiiiid,"invoke_viiiiiiiii":invoke_viiiiiiiii,"invoke_iii":invoke_iii,"invoke_viiiddii":invoke_viiiddii,"invoke_viiiiiidi":invoke_viiiiiidi,"invoke_vdiii":invoke_vdiii,"invoke_diiiiiiiid":invoke_diiiiiiiid,"invoke_iiiddddddi":invoke_iiiddddddi,"invoke_i":invoke_i,"invoke_viiiiidiiiii":invoke_viiiiidiiiii,"invoke_viii":invoke_viii,"invoke_v":invoke_v,"invoke_viid":invoke_viid,"invoke_iidddddii":invoke_iidddddii,"invoke_iiiddiid":invoke_iiiddiid,"invoke_vi":invoke_vi,"invoke_iiiiiiiiiii":invoke_iiiiiiiiiii,"invoke_viiiidiiiidi":invoke_viiiidiiiidi,"invoke_ii":invoke_ii,"invoke_viiiiiiiddi":invoke_viiiiiiiddi,"invoke_vidii":invoke_vidii,"invoke_iiiidiii":invoke_iiiidiii,"invoke_viiiidi":invoke_viiiidi,"invoke_viiiddiii":invoke_viiiddiii,"invoke_viiiiiidiiiii":invoke_viiiiiidiiiii,"invoke_iiii":invoke_iiii,"invoke_viididii":invoke_viididii,"invoke_viiiiddii":invoke_viiiiddii,"invoke_iiid":invoke_iiid,"invoke_viiiidii":invoke_viiiidii,"invoke_diiiii":invoke_diiiii,"invoke_diiiid":invoke_diiiid,"invoke_viiiiiiiiiiiiii":invoke_viiiiiiiiiiiiii,"invoke_iiiiiiiiiiiii":invoke_iiiiiiiiiiiii,"invoke_iiiiidi":invoke_iiiiidi,"invoke_iiidid":invoke_iiidid,"invoke_diiiiiiiiid":invoke_diiiiiiiiid,"invoke_iiiiidii":invoke_iiiiidii,"invoke_diiiiii":invoke_diiiiii,"invoke_vididdii":invoke_vididdii,"invoke_viiiiidiii":invoke_viiiiidiii,"invoke_iiiiiiiii":invoke_iiiiiiiii,"invoke_viididdii":invoke_viididdii,"invoke_viiiidd":invoke_viiiidd,"invoke_vidiii":invoke_vidiii,"___syscall221":___syscall221,"floatReadValueFromPointer":floatReadValueFromPointer,"simpleReadValueFromPointer":simpleReadValueFromPointer,"throwInternalError":throwInternalError,"get_first_emval":get_first_emval,"whenDependentTypesAreResolved":whenDependentTypesAreResolved,"getLiveInheritedInstances":getLiveInheritedInstances,"___assert_fail":___assert_fail,"__ZSt18uncaught_exceptionv":__ZSt18uncaught_exceptionv,"ClassHandle":ClassHandle,"_longjmp":_longjmp,"getShiftFromSize":getShiftFromSize,"__emval_get_property":__emval_get_property,"_clock_gettime":_clock_gettime,"___cxa_begin_catch":___cxa_begin_catch,"_emscripten_memcpy_big":_emscripten_memcpy_big,"runDestructor":runDestructor,"throwInstanceAlreadyDeleted":throwInstanceAlreadyDeleted,"__embind_register_std_string":__embind_register_std_string,"init_RegisteredPointer":init_RegisteredPointer,"___lock":___lock,"getStringOrSymbol":getStringOrSymbol,"flushPendingDeletes":flushPendingDeletes,"__embind_register_enum_value":__embind_register_enum_value,"makeClassHandle":makeClassHandle,"__isLeapYear":__isLeapYear,"__embind_register_class_constructor":__embind_register_class_constructor,"___cxa_atexit":___cxa_atexit,"__embind_finalize_value_array":__embind_finalize_value_array,"init_ClassHandle":init_ClassHandle,"_pthread_cleanup_push":_pthread_cleanup_push,"__embind_register_constant":__embind_register_constant,"___syscall140":___syscall140,"ClassHandle_clone":ClassHandle_clone,"___syscall145":___syscall145,"___syscall146":___syscall146,"_pthread_cleanup_pop":_pthread_cleanup_pop,"_emscripten_get_now_is_monotonic":_emscripten_get_now_is_monotonic,"throwBindingError":throwBindingError,"RegisteredClass":RegisteredClass,"___cxa_find_matching_catch":___cxa_find_matching_catch,"embind_init_charCodes":embind_init_charCodes,"__emval_as":__emval_as,"___setErrNo":___setErrNo,"readLatin1String":readLatin1String,"_llvm_pow_f32":_llvm_pow_f32,"__embind_register_bool":__embind_register_bool,"___resumeException":___resumeException,"createNamedFunction":createNamedFunction,"__embind_register_class_property":__embind_register_class_property,"__embind_register_emval":__embind_register_emval,"___buildEnvironment":___buildEnvironment,"__emval_decref":__emval_decref,"_pthread_once":_pthread_once,"_llvm_trap":_llvm_trap,"__embind_register_class":__embind_register_class,"constNoSmartPtrRawPointerToWireType":constNoSmartPtrRawPointerToWireType,"heap32VectorToArray":heap32VectorToArray,"_emscripten_get_now":_emscripten_get_now,"___syscall10":___syscall10,"__emval_run_destructors":__emval_run_destructors,"ClassHandle_delete":ClassHandle_delete,"__ZN2cv3EMDERKNS_11_InputArrayES2_iS2_PfRKNS_12_OutputArrayE":__ZN2cv3EMDERKNS_11_InputArrayES2_iS2_PfRKNS_12_OutputArrayE,"___syscall3":___syscall3,"__addDays":__addDays,"___syscall6":___syscall6,"___syscall5":___syscall5,"ensureOverloadTable":ensureOverloadTable,"_gettimeofday":_gettimeofday,"new_":new_,"downcastPointer":downcastPointer,"replacePublicSymbol":replacePublicSymbol,"init_embind":init_embind,"_llvm_pow_f64":_llvm_pow_f64,"___syscall265":___syscall265,"ClassHandle_deleteLater":ClassHandle_deleteLater,"___syscall54":___syscall54,"RegisteredPointer_deleteObject":RegisteredPointer_deleteObject,"ClassHandle_isDeleted":ClassHandle_isDeleted,"__embind_register_integer":__embind_register_integer,"___cxa_allocate_exception":___cxa_allocate_exception,"__emval_take_value":__emval_take_value,"enumReadValueFromPointer":enumReadValueFromPointer,"getTypeName":getTypeName,"___clock_gettime":___clock_gettime,"_strftime":_strftime,"__embind_register_class_function":__embind_register_class_function,"throwUnboundTypeError":throwUnboundTypeError,"craftInvokerFunction":craftInvokerFunction,"_getenv":_getenv,"runDestructors":runDestructors,"requireRegisteredType":requireRegisteredType,"makeLegalFunctionName":makeLegalFunctionName,"___syscall33":___syscall33,"_pthread_key_create":_pthread_key_create,"upcastPointer":upcastPointer,"init_emval":init_emval,"shallowCopyInternalPointer":shallowCopyInternalPointer,"nonConstNoSmartPtrRawPointerToWireType":nonConstNoSmartPtrRawPointerToWireType,"__embind_register_value_array":__embind_register_value_array,"_abort":_abort,"requireHandle":requireHandle,"_embind_repr":_embind_repr,"validateThis":validateThis,"exposePublicSymbol":exposePublicSymbol,"RegisteredPointer_fromWireType":RegisteredPointer_fromWireType,"___cxa_pure_virtual":___cxa_pure_virtual,"_pthread_getspecific":_pthread_getspecific,"_pthread_cond_wait":_pthread_cond_wait,"RegisteredPointer_destructor":RegisteredPointer_destructor,"__embind_register_value_array_element":__embind_register_value_array_element,"__embind_register_memory_view":__embind_register_memory_view,"getInheritedInstance":getInheritedInstance,"___syscall40":___syscall40,"setDelayFunction":setDelayFunction,"___gxx_personality_v0":___gxx_personality_v0,"extendError":extendError,"___syscall4":___syscall4,"__embind_register_void":__embind_register_void,"__embind_register_smart_ptr":__embind_register_smart_ptr,"__embind_register_function":__embind_register_function,"_pthread_mutexattr_destroy":_pthread_mutexattr_destroy,"_strftime_l":_strftime_l,"RegisteredPointer_getPointee":RegisteredPointer_getPointee,"__emval_register":__emval_register,"__embind_register_std_wstring":__embind_register_std_wstring,"ClassHandle_isAliasOf":ClassHandle_isAliasOf,"__emval_incref":__emval_incref,"RegisteredPointer":RegisteredPointer,"__arraySum":__arraySum,"__embind_register_class_class_function":__embind_register_class_class_function,"_pthread_mutex_destroy":_pthread_mutex_destroy,"getBasestPointer":getBasestPointer,"getInheritedInstanceCount":getInheritedInstanceCount,"__embind_register_float":__embind_register_float,"integerReadValueFromPointer":integerReadValueFromPointer,"___unlock":___unlock,"_pthread_mutexattr_settype":_pthread_mutexattr_settype,"_pthread_mutexattr_init":_pthread_mutexattr_init,"_pthread_setspecific":_pthread_setspecific,"genericPointerToWireType":genericPointerToWireType,"registerType":registerType,"___cxa_throw":___cxa_throw,"__embind_register_enum":__embind_register_enum,"__emval_new_cstring":__emval_new_cstring,"count_emval_handles":count_emval_handles,"requireFunction":requireFunction,"_emscripten_longjmp":_emscripten_longjmp,"_atexit":_atexit,"_pthread_mutex_init":_pthread_mutex_init,"STACKTOP":STACKTOP,"STACK_MAX":STACK_MAX,"DYNAMICTOP_PTR":DYNAMICTOP_PTR,"tempDoublePtr":tempDoublePtr,"ABORT":ABORT,"cttz_i8":cttz_i8,"___dso_handle":___dso_handle};// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer) {
"almost asm";var a=global.Int8Array;var b=global.Int16Array;var c=global.Int32Array;var d=global.Uint8Array;var e=global.Uint16Array;var f=global.Uint32Array;var g=global.Float32Array;var h=global.Float64Array;var i=new a(buffer);var j=new b(buffer);var k=new c(buffer);var l=new d(buffer);var m=new e(buffer);var n=new f(buffer);var o=new g(buffer);var p=new h(buffer);var q=global.byteLength;var r=env.STACKTOP|0;var s=env.STACK_MAX|0;var t=env.DYNAMICTOP_PTR|0;var u=env.tempDoublePtr|0;var v=env.ABORT|0;var w=env.cttz_i8|0;var x=env.___dso_handle|0;var y=0;var z=0;var A=0;var B=0;var C=global.NaN,D=global.Infinity;var E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0.0;var N=0;var O=global.Math.floor;var P=global.Math.abs;var Q=global.Math.sqrt;var R=global.Math.pow;var S=global.Math.cos;var T=global.Math.sin;var U=global.Math.tan;var V=global.Math.acos;var W=global.Math.asin;var X=global.Math.atan;var Y=global.Math.atan2;var Z=global.Math.exp;var _=global.Math.log;var $=global.Math.ceil;var aa=global.Math.imul;var ba=global.Math.min;var ca=global.Math.max;var da=global.Math.clz32;var ea=env.abort;var fa=env.assert;var ga=env.enlargeMemory;var ha=env.getTotalMemory;var ia=env.abortOnCannotGrowMemory;var ja=env.invoke_iiiiiid;var ka=env.invoke_viiiiddd;var la=env.invoke_viiiidiii;var ma=env.invoke_viiiiiddi;var na=env.invoke_viiidiii;var oa=env.invoke_iiiiddiii;var pa=env.invoke_iiiiiii;var qa=env.invoke_viiiidddiiii;var ra=env.invoke_viiiiddi;var sa=env.invoke_viiiiiiiiiii;var ta=env.invoke_iidd;var ua=env.invoke_viiiiiiiiiid;var va=env.invoke_viiiidiiii;var wa=env.invoke_iidi;var xa=env.invoke_viiddidd;var ya=env.invoke_vidi;var za=env.invoke_viiddii;var Aa=env.invoke_viiiiddiddi;var Ba=env.invoke_viiiiidi;var Ca=env.invoke_viiddidddd;var Da=env.invoke_viiiiddiiid;var Ea=env.invoke_viiiiiiidi;var Fa=env.invoke_viiidii;var Ga=env.invoke_di;var Ha=env.invoke_iiiiddi;var Ia=env.invoke_viiiidiiddi;var Ja=env.invoke_iiddddd;var Ka=env.invoke_diiiiiii;var La=env.invoke_iiiiiddiddi;var Ma=env.invoke_viidddddi;var Na=env.invoke_dii;var Oa=env.invoke_viiiddiiid;var Pa=env.invoke_iiidddddi;var Qa=env.invoke_diidi;var Ra=env.invoke_viiiiiiiiiiddi;var Sa=env.invoke_iiiiiiiiii;var Ta=env.invoke_iiiid;var Ua=env.invoke_iiiiiiii;var Va=env.invoke_viiddiii;var Wa=env.invoke_viiddiid;var Xa=env.invoke_iiiiiiiididiii;var Ya=env.invoke_iidddd;var Za=env.invoke_viidiiid;var _a=env.invoke_viiiiidiiii;var $a=env.invoke_diiiddi;var ab=env.invoke_iiiii;var bb=env.invoke_viiididii;var cb=env.invoke_diiiiiiii;var db=env.invoke_viiidiiid;var eb=env.invoke_viiiddddii;var fb=env.invoke_iiidiiiiiii;var gb=env.invoke_viiiiid;var hb=env.invoke_viiiiddddii;var ib=env.invoke_viiiiii;var jb=env.invoke_viiidiiii;var kb=env.invoke_viiidd;var lb=env.invoke_viiidi;var mb=env.invoke_vidddd;var nb=env.invoke_iiiiiidii;var ob=env.invoke_iiddd;var pb=env.invoke_viiiiiiiiii;var qb=env.invoke_diiddi;var rb=env.invoke_diii;var sb=env.invoke_viiiddd;var tb=env.invoke_viiiddidddd;var ub=env.invoke_viiiiiiiiiiid;var vb=env.invoke_viiiddidd;var wb=env.invoke_viiidiiiidi;var xb=env.invoke_viiiddi;var yb=env.invoke_iiiiii;var zb=env.invoke_viiid;var Ab=env.invoke_viidii;var Bb=env.invoke_iiiiid;var Cb=env.invoke_viiii;var Db=env.invoke_viiiii;var Eb=env.invoke_viidiiiiiii;var Fb=env.invoke_vid;var Gb=env.invoke_iiidi;var Hb=env.invoke_iiidd;var Ib=env.invoke_vii;var Jb=env.invoke_viiiid;var Kb=env.invoke_iiiiidiii;var Lb=env.invoke_viidd;var Mb=env.invoke_viidi;var Nb=env.invoke_viddd;var Ob=env.invoke_viiidiiddi;var Pb=env.invoke_iiiidii;var Qb=env.invoke_diiid;var Rb=env.invoke_viiiiiiii;var Sb=env.invoke_viiidddiiii;var Tb=env.invoke_viiiiiiid;var Ub=env.invoke_viiiiiiddi;var Vb=env.invoke_diiii;var Wb=env.invoke_viiiiidiiddi;var Xb=env.invoke_viddddd;var Yb=env.invoke_viiddddddi;var Zb=env.invoke_viiiiiddii;var _b=env.invoke_viiiiidii;var $b=env.invoke_iid;var ac=env.invoke_viiiiiiiid;var bc=env.invoke_viiiiiii;var cc=env.invoke_viiiiiid;var dc=env.invoke_viiiiiiiii;var ec=env.invoke_iii;var fc=env.invoke_viiiddii;var gc=env.invoke_viiiiiidi;var hc=env.invoke_vdiii;var ic=env.invoke_diiiiiiiid;var jc=env.invoke_iiiddddddi;var kc=env.invoke_i;var lc=env.invoke_viiiiidiiiii;var mc=env.invoke_viii;var nc=env.invoke_v;var oc=env.invoke_viid;var pc=env.invoke_iidddddii;var qc=env.invoke_iiiddiid;var rc=env.invoke_vi;var sc=env.invoke_iiiiiiiiiii;var tc=env.invoke_viiiidiiiidi;var uc=env.invoke_ii;var vc=env.invoke_viiiiiiiddi;var wc=env.invoke_vidii;var xc=env.invoke_iiiidiii;var yc=env.invoke_viiiidi;var zc=env.invoke_viiiddiii;var Ac=env.invoke_viiiiiidiiiii;var Bc=env.invoke_iiii;var Cc=env.invoke_viididii;var Dc=env.invoke_viiiiddii;var Ec=env.invoke_iiid;var Fc=env.invoke_viiiidii;var Gc=env.invoke_diiiii;var Hc=env.invoke_diiiid;var Ic=env.invoke_viiiiiiiiiiiiii;var Jc=env.invoke_iiiiiiiiiiiii;var Kc=env.invoke_iiiiidi;var Lc=env.invoke_iiidid;var Mc=env.invoke_diiiiiiiiid;var Nc=env.invoke_iiiiidii;var Oc=env.invoke_diiiiii;var Pc=env.invoke_vididdii;var Qc=env.invoke_viiiiidiii;var Rc=env.invoke_iiiiiiiii;var Sc=env.invoke_viididdii;var Tc=env.invoke_viiiidd;var Uc=env.invoke_vidiii;var Vc=env.___syscall221;var Wc=env.floatReadValueFromPointer;var Xc=env.simpleReadValueFromPointer;var Yc=env.throwInternalError;var Zc=env.get_first_emval;var _c=env.whenDependentTypesAreResolved;var $c=env.getLiveInheritedInstances;var ad=env.___assert_fail;var bd=env.__ZSt18uncaught_exceptionv;var cd=env.ClassHandle;var dd=env._longjmp;var ed=env.getShiftFromSize;var fd=env.__emval_get_property;var gd=env._clock_gettime;var hd=env.___cxa_begin_catch;var id=env._emscripten_memcpy_big;var jd=env.runDestructor;var kd=env.throwInstanceAlreadyDeleted;var ld=env.__embind_register_std_string;var md=env.init_RegisteredPointer;var nd=env.___lock;var od=env.getStringOrSymbol;var pd=env.flushPendingDeletes;var qd=env.__embind_register_enum_value;var rd=env.makeClassHandle;var sd=env.__isLeapYear;var td=env.__embind_register_class_constructor;var ud=env.___cxa_atexit;var vd=env.__embind_finalize_value_array;var wd=env.init_ClassHandle;var xd=env._pthread_cleanup_push;var yd=env.__embind_register_constant;var zd=env.___syscall140;var Ad=env.ClassHandle_clone;var Bd=env.___syscall145;var Cd=env.___syscall146;var Dd=env._pthread_cleanup_pop;var Ed=env._emscripten_get_now_is_monotonic;var Fd=env.throwBindingError;var Gd=env.RegisteredClass;var Hd=env.___cxa_find_matching_catch;var Id=env.embind_init_charCodes;var Jd=env.__emval_as;var Kd=env.___setErrNo;var Ld=env.readLatin1String;var Md=env._llvm_pow_f32;var Nd=env.__embind_register_bool;var Od=env.___resumeException;var Pd=env.createNamedFunction;var Qd=env.__embind_register_class_property;var Rd=env.__embind_register_emval;var Sd=env.___buildEnvironment;var Td=env.__emval_decref;var Ud=env._pthread_once;var Vd=env._llvm_trap;var Wd=env.__embind_register_class;var Xd=env.constNoSmartPtrRawPointerToWireType;var Yd=env.heap32VectorToArray;var Zd=env._emscripten_get_now;var _d=env.___syscall10;var $d=env.__emval_run_destructors;var ae=env.ClassHandle_delete;var be=env.__ZN2cv3EMDERKNS_11_InputArrayES2_iS2_PfRKNS_12_OutputArrayE;var ce=env.___syscall3;var de=env.__addDays;var ee=env.___syscall6;var fe=env.___syscall5;var ge=env.ensureOverloadTable;var he=env._gettimeofday;var ie=env.new_;var je=env.downcastPointer;var ke=env.replacePublicSymbol;var le=env.init_embind;var me=env._llvm_pow_f64;var ne=env.___syscall265;var oe=env.ClassHandle_deleteLater;var pe=env.___syscall54;var qe=env.RegisteredPointer_deleteObject;var re=env.ClassHandle_isDeleted;var se=env.__embind_register_integer;var te=env.___cxa_allocate_exception;var ue=env.__emval_take_value;var ve=env.enumReadValueFromPointer;var we=env.getTypeName;var xe=env.___clock_gettime;var ye=env._strftime;var ze=env.__embind_register_class_function;var Ae=env.throwUnboundTypeError;var Be=env.craftInvokerFunction;var Ce=env._getenv;var De=env.runDestructors;var Ee=env.requireRegisteredType;var Fe=env.makeLegalFunctionName;var Ge=env.___syscall33;var He=env._pthread_key_create;var Ie=env.upcastPointer;var Je=env.init_emval;var Ke=env.shallowCopyInternalPointer;var Le=env.nonConstNoSmartPtrRawPointerToWireType;var Me=env.__embind_register_value_array;var Ne=env._abort;var Oe=env.requireHandle;var Pe=env._embind_repr;var Qe=env.validateThis;var Re=env.exposePublicSymbol;var Se=env.RegisteredPointer_fromWireType;var Te=env.___cxa_pure_virtual;var Ue=env._pthread_getspecific;var Ve=env._pthread_cond_wait;var We=env.RegisteredPointer_destructor;var Xe=env.__embind_register_value_array_element;var Ye=env.__embind_register_memory_view;var Ze=env.getInheritedInstance;var _e=env.___syscall40;var $e=env.setDelayFunction;var af=env.___gxx_personality_v0;var bf=env.extendError;var cf=env.___syscall4;var df=env.__embind_register_void;var ef=env.__embind_register_smart_ptr;var ff=env.__embind_register_function;var gf=env._pthread_mutexattr_destroy;var hf=env._strftime_l;var jf=env.RegisteredPointer_getPointee;var kf=env.__emval_register;var lf=env.__embind_register_std_wstring;var mf=env.ClassHandle_isAliasOf;var nf=env.__emval_incref;var of=env.RegisteredPointer;var pf=env.__arraySum;var qf=env.__embind_register_class_class_function;var rf=env._pthread_mutex_destroy;var sf=env.getBasestPointer;var tf=env.getInheritedInstanceCount;var uf=env.__embind_register_float;var vf=env.integerReadValueFromPointer;var wf=env.___unlock;var xf=env._pthread_mutexattr_settype;var yf=env._pthread_mutexattr_init;var zf=env._pthread_setspecific;var Af=env.genericPointerToWireType;var Bf=env.registerType;var Cf=env.___cxa_throw;var Df=env.__embind_register_enum;var Ef=env.__emval_new_cstring;var Ff=env.count_emval_handles;var Gf=env.requireFunction;var Hf=env._emscripten_longjmp;var If=env._atexit;var Jf=env._pthread_mutex_init;var Kf=0.0;function Lf(newBuffer){if(q(newBuffer)&16777215||q(newBuffer)<=16777215||q(newBuffer)>2147483648)return false;i=new a(newBuffer);j=new b(newBuffer);k=new c(newBuffer);l=new d(newBuffer);m=new e(newBuffer);n=new f(newBuffer);o=new g(newBuffer);p=new h(newBuffer);buffer=newBuffer;return true}
// EMSCRIPTEN_START_FUNCS
function Vza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0;_Ga(a,b,c);c=k[(k[a+236>>2]|0)+8>>2]|0;switch(k[a+240>>2]|0){case 0:{p[c+(b*104|0)+16>>3]=(k[c+(b*104|0)>>2]|0)==0?-1.0:1.0;return}case 1:{b=c+(b*104|0)+16|0;d=(+p[b>>3]+1.0)*.5;d=d<1.0e-05?1.0e-05:d;d=d>.99999?.99999:d;d=+_(+(d/(1.0-d)))*.5;p[b>>3]=d;return}default:return}}function Wza(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0;f=d&-769|256;e=+iHa(a,b,c,f);if((f|0)==(d|0))return +e;b=e>0.0&1;if(!(d&1))b=k[(k[a+192>>2]|0)+(b<<2)>>2]|0;e=+(b|0);return +e}function Xza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o;d=n+4|0;j=ZT(20)|0;k[j>>2]=1;h=j+4|0;k[n>>2]=h;k[d>>2]=13;i[j+17>>0]=0;j=361806;l=h+13|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));h=z6(b,n)|0;c=k[n>>2]|0;k[d>>2]=0;k[n>>2]=0;if(c|0?(j=c+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[c+-8>>2]|0);c=k[a+240>>2]|0;if(c)if((c|0)!=1)if((c|0)==2)e=361850;else e=(c|0)==3?361861:361897;else e=361837;else e=361820;k[n>>2]=0;g=n+4|0;k[g>>2]=0;f=e;a:do if(!(f&3)){c=e;m=11}else{c=e;d=f;while(1){if(!(i[c>>0]|0)){c=d;break a}c=c+1|0;d=c;if(!(d&3)){m=11;break}}}while(0);if((m|0)==11){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}c=c-f|0;m=ZT(c+8&-4)|0;k[m>>2]=1;m=m+4|0;k[n>>2]=m;k[g>>2]=c;i[m+c>>0]=0;upb(k[n>>2]|0,e|0,c|0)|0;z6(h,n)|0;c=k[n>>2]|0;k[g>>2]=0;k[n>>2]=0;if(c|0?(l=c+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);jHa(a,b);d=n+4|0;j=ZT(28)|0;k[j>>2]=1;h=j+4|0;k[n>>2]=h;k[d>>2]=20;i[j+24>>0]=0;j=361876;l=h+20|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));g=z6(b,n)|0;c=k[n>>2]|0;k[d>>2]=0;k[n>>2]=0;if(c|0?(m=c+-4|0,b=k[m>>2]|0,k[m>>2]=b+-1,(b|0)==1):0)ggb(k[c+-8>>2]|0);e=a+248|0;if(!(Xh[k[(k[g>>2]|0)+12>>2]&1023](g)|0)){r=o;return}f=g+32|0;if((k[f>>2]|0)==6){c=n+4|0;d=ZT(36)|0;k[d>>2]=1;h=d+4|0;k[n>>2]=h;k[c>>2]=30;i[d+34>>0]=0;j=401220;l=h+30|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-2,n,401251,401262,1064);k[c>>2]=0;k[n>>2]=0;n=k[d>>2]|0;k[d>>2]=n+-1;if((n|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[g+16>>2]|0))c=0;else{c=k[g+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[g+8>>2]|0,c,+p[e>>3]);if(!(k[f>>2]&4)){r=o;return}k[f>>2]=6;r=o;return}function Yza(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0;t=r;r=r+16|0;s=t;oHa(a,b);m=k[b>>2]|0;n=b+4|0;o=k6(m,k[n>>2]|0,370919)|0;if(!(k6(k[b>>2]|0,k[n>>2]|0,361806)|0))c=k6(m,o,361806)|0;else c=k6(k[b>>2]|0,k[n>>2]|0,361806)|0;k[s>>2]=0;q=s+4|0;k[q>>2]=0;J6(c,s,s);j=k[s>>2]|0;do if((j|0)!=361820){c=(j|0)==0?1016759:j;l=i[c>>0]|0;if(l<<24>>24==68){e=361820;f=c;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){c=0;break}}if((j|0)!=361837){if(l<<24>>24==82){e=361837;f=c;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){c=1;break}}if((j|0)==361850)c=2;else{if(l<<24>>24==76){e=361850;f=c;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){c=2;break}}if((j|0)!=361861){if(l<<24>>24==71)g=361861;else{c=-1;break}do{c=c+1|0;g=g+1|0;e=i[c>>0]|0;f=i[g>>0]|0}while(!(e<<24>>24==0?1:e<<24>>24!=f<<24>>24));if(e<<24>>24!=f<<24>>24){c=-1;break}}c=3}}else c=1}else c=0;while(0);k[a+240>>2]=c;i[a+228>>0]=(c|0)==0&1;if(!(k6(k[b>>2]|0,k[n>>2]|0,361876)|0))c=k6(m,o,361876)|0;else c=k6(k[b>>2]|0,k[n>>2]|0,361876)|0;a:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break a}case 2:{d=+p[c+8>>3];break a}default:{d=1.e+300;break a}}while(0);p[a+248>>3]=d;c=k[s>>2]|0;k[q>>2]=0;k[s>>2]=0;if(!c){r=t;return}q=c+-4|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1){r=t;return}ggb(k[c+-8>>2]|0);r=t;return}function Zza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+8|0;d=k[i>>2]|0;g=k[a>>2]|0;j=g;if(d-g>>3>>>0>=b>>>0){a=a+4|0;h=k[a>>2]|0;f=h-g>>3;g=f>>>0<b>>>0;d=g?f:b;if(d|0){e=j;while(1){p[e>>3]=+p[c>>3];d=d+-1|0;if(!d)break;else e=e+8|0}}if(g){e=b-f|0;d=e;f=h;while(1){p[f>>3]=+p[c>>3];d=d+-1|0;if(!d)break;else f=f+8|0}k[a>>2]=h+(e<<3);return}else{d=j+(b<<3)|0;if((h|0)==(d|0))return;k[a>>2]=h+(~((h+-8-d|0)>>>3)<<3);return}}f=g;if(g){d=a+4|0;e=k[d>>2]|0;if((e|0)!=(j|0))k[d>>2]=e+(~((e+-8-g|0)>>>3)<<3);ggb(f);k[i>>2]=0;k[d>>2]=0;k[a>>2]=0;d=0}if(b>>>0>536870911)ad(426534,426557,304,426811);h=d>>2;h=d>>3>>>0<268435455?(h>>>0<b>>>0?b:h):536870911;if(h>>>0>536870911)bob();e=h<<3;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0){f=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){f=0;break}Qh[d&7]()}g=a+4|0;k[g>>2]=f;k[a>>2]=f;k[i>>2]=f+(h<<3);d=b;e=f;while(1){p[e>>3]=+p[c>>3];d=d+-1|0;if(!d)break;else e=e+8|0}k[g>>2]=f+(b<<3);return}function _za(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90792;c=a+8|0;k[c>>2]=90972;d=k[a+264>>2]|0;if(!d){LGa(c);return}a=a+268|0;b=k[a>>2]|0;if((b|0)!=(d|0))k[a>>2]=b+(~((b+-8-d|0)>>>3)<<3);ggb(d);LGa(c);return}function $za(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=90792;b=a+8|0;k[b>>2]=90972;c=k[a+264>>2]|0;if(!c){LGa(b);ggb(a);return}d=a+268|0;e=k[d>>2]|0;if((e|0)!=(c|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(c);LGa(b);ggb(a);return}function aAa(a,b){a=a|0;b=b|0;qza(a+8|0,b);return}function bAa(a,b){a=a|0;b=b|0;rza(a+8|0,b);return}function cAa(a,b){a=a|0;b=b|0;var c=0;c=ZT(20)|0;k[c>>2]=1;b=c+4|0;k[a>>2]=b;k[a+4>>2]=15;i[c+19>>0]=0;a=b;b=362091;c=a+15|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));return}function dAa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+32>>2]&1023](a)|0}function eAa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0}function fAa(a){a=a|0;return 1}function gAa(a,b,c){a=a|0;b=b|0;c=c|0;return wza(a+8|0,b,c)|0}function hAa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=a+8|0;return +(+wh[k[(k[a>>2]|0)+56>>2]&31](a,b,c,d))}function iAa(a){a=a|0;return k[a+72>>2]|0}function jAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if((b|0)>=2){h=(b|0)>15;h=h?15:b;j=a+72|0;k[j>>2]=h;r=g;return}d=c+4|0;e=ZT(36)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=29;i[e+33>>0]=0;h=370965;j=f+29|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,c,370995,371012,135);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);h=(b|0)>15;h=h?15:b;j=a+72|0;k[j>>2]=h;r=g;return}function kAa(a){a=a|0;return k[a+76>>2]|0}function lAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if((b|0)>=0){h=(b|0)>25;h=h?25:b;j=a+76|0;k[j>>2]=h;r=g;return}d=c+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=24;i[e+28>>0]=0;h=371170;j=f+24|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,c,371195,371012,141);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);h=(b|0)>25;h=h?25:b;j=a+76|0;k[j>>2]=h;r=g;return}function mAa(a){a=a|0;return k[a+80>>2]|0}function nAa(a,b){a=a|0;b=b|0;k[a+80>>2]=(b|0)<1?1:b;return}function oAa(a){a=a|0;return k[a+84>>2]|0}function pAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if((b|0)>=0){h=(b|0)==1;h=h?0:b;j=a+84|0;k[j>>2]=h;r=g;return}d=c+4|0;e=ZT(112)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=106;i[e+110>>0]=0;h=371247;j=f+106|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,c,371354,371012,153);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);h=(b|0)==1;h=h?0:b;j=a+84|0;k[j>>2]=h;r=g;return}function qAa(a){a=a|0;return (i[a+12>>0]|0)!=0|0}function rAa(a,b){a=a|0;b=b|0;i[a+12>>0]=b&1;return}function sAa(a){a=a|0;return (i[a+13>>0]|0)!=0|0}function tAa(a,b){a=a|0;b=b|0;i[a+13>>0]=b&1;return}function uAa(a){a=a|0;return (i[a+14>>0]|0)!=0|0}function vAa(a,b){a=a|0;b=b|0;i[a+14>>0]=b&1;return}function wAa(a){a=a|0;return +(+o[a+88>>2])}function xAa(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if(!(b<0.0)){j=a+88|0;o[j>>2]=b;r=g;return}d=c+4|0;e=ZT(48)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=41;i[e+45>>0]=0;h=371096;j=f+41|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,c,371138,371012,161);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);j=a+88|0;o[j>>2]=b;r=g;return}function yAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+16>>2];i=a+4|0;e=b+20|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+24>>2];k[a+12>>2]=k[b+28>>2];k[a+16>>2]=k[b+32>>2];k[a+20>>2]=k[b+36>>2];k[a+24>>2]=k[b+40>>2];k[a+28>>2]=k[b+44>>2];k[a+32>>2]=k[b+48>>2];d=k[b+52>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+60>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+56>>2]|0;a=k[g>>2]|0;e=k[b+60>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function zAa(a,b){a=a|0;b=b|0;KG(a+16|0,b)|0;return}function AAa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+132>>2]&1023](a)|0}function BAa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+136>>2]&1023](a)|0}function CAa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+140>>2]&1023](a)|0}function DAa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+144>>2]&1023](a)|0}function EAa(a){a=a|0;return k[a+248>>2]|0}function FAa(a,b){a=a|0;b=b|0;k[a+248>>2]=b;return}function GAa(a){a=a|0;return k[a+252>>2]|0}function HAa(a,b){a=a|0;b=b|0;k[a+252>>2]=b;return}function IAa(a){a=a|0;return +(+p[a+256>>3])}function JAa(a,b){a=a|0;b=+b;p[a+256>>3]=b;return}function KAa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;W=r;r=r+64|0;O=W+56|0;R=W;P=c+16|0;if(k[P>>2]|0){g=k[c+4>>2]|0;if((g|0)<3)d=aa(k[c+12>>2]|0,k[c+8>>2]|0)|0;else{f=k[c+40>>2]|0;e=0;d=1;do{d=aa(k[f+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(g|0))}if(d|0){N=y2(c,1,4,1)|0;f=k[b>>2]|0;g=f&4095;if((g+-4|0)>>>0>=3){d=O+4|0;e=ZT(56)|0;k[e>>2]=1;I=e+4|0;k[O>>2]=I;k[d>>2]=50;i[e+54>>0]=0;H=362145;J=I+50|0;do{i[I>>0]=i[H>>0]|0;I=I+1|0;H=H+1|0}while((I|0)<(J|0));Y8(-215,O,362196,362209,59);k[d>>2]=0;k[O>>2]=0;V=k[e>>2]|0;k[e>>2]=V+-1;if((V|0)==1)ggb(k[e+-4>>2]|0)}M=b+12|0;e=k[M>>2]|0;d=k[b+8>>2]|0;if((e|0)!=1)if((d|0)==1){d=1;Q=20}else K=e;else Q=20;if((Q|0)==20){d=e+-1+d|0;K=1}k[R>>2]=1124007936;T=R+4|0;L=R+8|0;S=R+40|0;I=T;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[S>>2]=L;V=R+48|0;U=R+44|0;k[U>>2]=V;k[R+52>>2]=0;k[V>>2]=0;if((e|0)==(d|0)){k[O>>2]=K;k[O+4>>2]=N;G1(R,2,O,g)}else{k[O>>2]=N;k[O+4>>2]=K;G1(R,2,O,g)}switch(f&4095){case 4:{if((N|0)>0){n=c+40|0;o=c+44|0;s=c+12|0;t=(K|0)==1;u=b+40|0;v=b+16|0;w=b+44|0;x=R+16|0;y=R+12|0;z=(K|0)>0;A=O+4|0;m=0;do{do if((k[c>>2]&16384|0)==0?(E=k[n>>2]|0,(k[E>>2]|0)!=1):0){e=k[P>>2]|0;f=k[o>>2]|0;if((k[E+4>>2]|0)==1){e=e+(aa(k[f>>2]|0,m)|0)|0;break}else{J=k[s>>2]|0;I=(m|0)/(J|0)|0;J=m-(aa(I,J)|0)|0;e=e+(aa(k[f>>2]|0,I)|0)+(J<<2)|0;break}}else Q=33;while(0);if((Q|0)==33){Q=0;e=(k[P>>2]|0)+(m<<2)|0}l=k[e>>2]|0;if(!((l|0)>-1&(l|0)<(d|0))){k[O>>2]=0;k[A>>2]=0;e=ZT(20)|0;k[e>>2]=1;I=e+4|0;k[O>>2]=I;k[A>>2]=15;i[e+19>>0]=0;H=362270;J=I+15|0;do{i[I>>0]=i[H>>0]|0;I=I+1|0;H=H+1|0}while((I|0)<(J|0));Y8(-215,O,362196,362209,83);k[A>>2]=0;k[O>>2]=0;J=k[e>>2]|0;k[e>>2]=J+-1;if((J|0)==1)ggb(k[e+-4>>2]|0)}if(!t){if(z){f=k[v>>2]|0;g=k[w>>2]|0;h=k[x>>2]|0;j=k[U>>2]|0;e=0;do{I=f+(aa(k[g>>2]|0,l)|0)+(e<<2)|0;J=h+(aa(k[j>>2]|0,m)|0)+(e<<2)|0;k[J>>2]=k[I>>2];e=e+1|0}while((e|0)!=(K|0))}}else{do if((k[b>>2]&16384|0)==0?(F=k[u>>2]|0,(k[F>>2]|0)!=1):0){e=k[v>>2]|0;f=k[w>>2]|0;if((k[F+4>>2]|0)==1){e=e+(aa(k[f>>2]|0,l)|0)|0;break}else{J=k[M>>2]|0;I=(l|0)/(J|0)|0;J=l-(aa(I,J)|0)|0;e=e+(aa(k[f>>2]|0,I)|0)+(J<<2)|0;break}}else Q=46;while(0);if((Q|0)==46){Q=0;e=(k[v>>2]|0)+(l<<2)|0}g=k[e>>2]|0;do if((k[R>>2]&16384|0)==0?(G=k[S>>2]|0,(k[G>>2]|0)!=1):0){e=k[x>>2]|0;f=k[U>>2]|0;if((k[G+4>>2]|0)==1){e=e+(aa(k[f>>2]|0,m)|0)|0;break}else{J=k[y>>2]|0;I=(m|0)/(J|0)|0;J=m-(aa(I,J)|0)|0;e=e+(aa(k[f>>2]|0,I)|0)+(J<<2)|0;break}}else Q=52;while(0);if((Q|0)==52){Q=0;e=(k[x>>2]|0)+(m<<2)|0}k[e>>2]=g}m=m+1|0}while((m|0)<(N|0))}break}case 5:{if((N|0)>0){j=c+40|0;l=c+44|0;m=c+12|0;n=(K|0)==1;o=b+40|0;s=b+16|0;t=b+44|0;u=R+16|0;v=R+12|0;w=(K|0)>0;x=O+4|0;h=0;do{do if((k[c>>2]&16384|0)==0?(y=k[j>>2]|0,(k[y>>2]|0)!=1):0){e=k[P>>2]|0;f=k[l>>2]|0;if((k[y+4>>2]|0)==1){e=e+(aa(k[f>>2]|0,h)|0)|0;break}else{J=k[m>>2]|0;I=(h|0)/(J|0)|0;J=h-(aa(I,J)|0)|0;e=e+(aa(k[f>>2]|0,I)|0)+(J<<2)|0;break}}else Q=61;while(0);if((Q|0)==61){Q=0;e=(k[P>>2]|0)+(h<<2)|0}g=k[e>>2]|0;if(!((g|0)>-1&(g|0)<(d|0))){k[O>>2]=0;k[x>>2]=0;e=ZT(20)|0;k[e>>2]=1;I=e+4|0;k[O>>2]=I;k[x>>2]=15;i[e+19>>0]=0;H=362270;J=I+15|0;do{i[I>>0]=i[H>>0]|0;I=I+1|0;H=H+1|0}while((I|0)<(J|0));Y8(-215,O,362196,362209,94);k[x>>2]=0;k[O>>2]=0;J=k[e>>2]|0;k[e>>2]=J+-1;if((J|0)==1)ggb(k[e+-4>>2]|0)}if(!n){if(w){f=(k[s>>2]|0)+(aa(k[k[t>>2]>>2]|0,g)|0)|0;g=(k[u>>2]|0)+(aa(k[k[U>>2]>>2]|0,h)|0)|0;e=0;do{k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)!=(K|0))}}else{do if((k[b>>2]&16384|0)==0?(z=k[o>>2]|0,(k[z>>2]|0)!=1):0){e=k[s>>2]|0;f=k[t>>2]|0;if((k[z+4>>2]|0)==1){e=e+(aa(k[f>>2]|0,g)|0)|0;break}else{J=k[M>>2]|0;I=(g|0)/(J|0)|0;J=g-(aa(I,J)|0)|0;e=e+(aa(k[f>>2]|0,I)|0)+(J<<2)|0;break}}else Q=74;while(0);if((Q|0)==74){Q=0;e=(k[s>>2]|0)+(g<<2)|0}g=k[e>>2]|0;do if((k[R>>2]&16384|0)==0?(A=k[S>>2]|0,(k[A>>2]|0)!=1):0){e=k[u>>2]|0;f=k[U>>2]|0;if((k[A+4>>2]|0)==1){e=e+(aa(k[f>>2]|0,h)|0)|0;break}else{J=k[v>>2]|0;I=(h|0)/(J|0)|0;J=h-(aa(I,J)|0)|0;e=e+(aa(k[f>>2]|0,I)|0)+(J<<2)|0;break}}else Q=80;while(0);if((Q|0)==80){Q=0;e=(k[u>>2]|0)+(h<<2)|0}k[e>>2]=g}h=h+1|0}while((h|0)<(N|0))}break}default:if((N|0)>0){j=c+40|0;l=c+44|0;m=c+12|0;n=(K|0)==1;o=b+40|0;s=b+16|0;t=b+44|0;u=R+16|0;v=R+12|0;w=(K|0)>0;x=O+4|0;h=0;do{do if((k[c>>2]&16384|0)==0?(B=k[j>>2]|0,(k[B>>2]|0)!=1):0){e=k[P>>2]|0;f=k[l>>2]|0;if((k[B+4>>2]|0)==1){e=e+(aa(k[f>>2]|0,h)|0)|0;break}else{J=k[m>>2]|0;I=(h|0)/(J|0)|0;J=h-(aa(I,J)|0)|0;e=e+(aa(k[f>>2]|0,I)|0)+(J<<2)|0;break}}else Q=89;while(0);if((Q|0)==89){Q=0;e=(k[P>>2]|0)+(h<<2)|0}g=k[e>>2]|0;if(!((g|0)>-1&(g|0)<(d|0))){k[O>>2]=0;k[x>>2]=0;e=ZT(20)|0;k[e>>2]=1;I=e+4|0;k[O>>2]=I;k[x>>2]=15;i[e+19>>0]=0;H=362270;J=I+15|0;do{i[I>>0]=i[H>>0]|0;I=I+1|0;H=H+1|0}while((I|0)<(J|0));Y8(-215,O,362196,362209,105);k[x>>2]=0;k[O>>2]=0;J=k[e>>2]|0;k[e>>2]=J+-1;if((J|0)==1)ggb(k[e+-4>>2]|0)}if(!n){if(w){f=(k[s>>2]|0)+(aa(k[k[t>>2]>>2]|0,g)|0)|0;g=(k[u>>2]|0)+(aa(k[k[U>>2]>>2]|0,h)|0)|0;e=0;do{p[g+(e<<3)>>3]=+p[f+(e<<3)>>3];e=e+1|0}while((e|0)!=(K|0))}}else{do if((k[b>>2]&16384|0)==0?(C=k[o>>2]|0,(k[C>>2]|0)!=1):0){e=k[s>>2]|0;f=k[t>>2]|0;if((k[C+4>>2]|0)==1){e=e+(aa(k[f>>2]|0,g)|0)|0;break}else{J=k[M>>2]|0;I=(g|0)/(J|0)|0;J=g-(aa(I,J)|0)|0;e=e+(aa(k[f>>2]|0,I)|0)+(J<<3)|0;break}}else Q=102;while(0);if((Q|0)==102){Q=0;e=(k[s>>2]|0)+(g<<3)|0}q=+p[e>>3];do if((k[R>>2]&16384|0)==0?(D=k[S>>2]|0,(k[D>>2]|0)!=1):0){e=k[u>>2]|0;f=k[U>>2]|0;if((k[D+4>>2]|0)==1){e=e+(aa(k[f>>2]|0,h)|0)|0;break}else{J=k[v>>2]|0;I=(h|0)/(J|0)|0;J=h-(aa(I,J)|0)|0;e=e+(aa(k[f>>2]|0,I)|0)+(J<<3)|0;break}}else Q=108;while(0);if((Q|0)==108){Q=0;e=(k[u>>2]|0)+(h<<3)|0}p[e>>3]=q}h=h+1|0}while((h|0)<(N|0))}}k[a>>2]=k[R>>2];l=a+4|0;d=k[T>>2]|0;k[l>>2]=d;b=a+8|0;k[b>>2]=k[L>>2];k[a+12>>2]=k[R+12>>2];o=R+16|0;k[a+16>>2]=k[o>>2];k[a+20>>2]=k[R+20>>2];k[a+24>>2]=k[R+24>>2];k[a+28>>2]=k[R+28>>2];m=R+32|0;k[a+32>>2]=k[m>>2];n=R+36|0;e=k[n>>2]|0;k[a+36>>2]=e;f=a+40|0;k[f>>2]=b;b=a+48|0;j=a+44|0;k[j>>2]=b;k[a+52>>2]=0;k[b>>2]=0;if(e){d=e+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[T>>2]|0}if((d|0)>=3){k[l>>2]=0;x1(a,d,0,0,0);if((k[l>>2]|0)>0){h=k[S>>2]|0;f=k[f>>2]|0;g=k[U>>2]|0;e=k[j>>2]|0;d=0;do{k[f+(d<<2)>>2]=k[h+(d<<2)>>2];k[e+(d<<2)>>2]=k[g+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else{b=k[U>>2]|0;a=k[j>>2]|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2]}d=k[n>>2]|0;if(d|0?(b=d+12|0,a=k[b>>2]|0,k[b>>2]=a+-1,(a|0)==1):0){e=k[n>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[m>>2]|0;if(!d){d=B1()|0;e=k[n>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[n>>2]=0}k[n>>2]=0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[T>>2]|0)>0){e=k[S>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[T>>2]|0))}d=k[U>>2]|0;if(!((d|0)==(V|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=W;return}}k[a>>2]=k[b>>2];l=a+4|0;e=b+4|0;d=k[e>>2]|0;k[l>>2]=d;V=a+8|0;k[V>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];k[a+20>>2]=k[b+20>>2];k[a+24>>2]=k[b+24>>2];k[a+28>>2]=k[b+28>>2];k[a+32>>2]=k[b+32>>2];f=k[b+36>>2]|0;k[a+36>>2]=f;g=a+40|0;k[g>>2]=V;V=a+48|0;j=a+44|0;k[j>>2]=V;k[a+52>>2]=0;k[V>>2]=0;if(f){d=f+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[e>>2]|0}if((d|0)<3){V=k[b+44>>2]|0;a=k[j>>2]|0;k[a>>2]=k[V>>2];k[a+4>>2]=k[V+4>>2];r=W;return}k[l>>2]=0;x1(a,d,0,0,0);if((k[l>>2]|0)<=0){r=W;return}h=k[b+40>>2]|0;g=k[g>>2]|0;f=k[b+44>>2]|0;e=k[j>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[h+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0));r=W;return}function LAa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+16|0;z=B+12|0;e=B;b=a+4|0;c=k[b>>2]|0;if(c|0)Qfb(c)|0;k[b>>2]=0;d=a+48|0;b=k[d>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;y=a+28|0;c=a+16|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+104|0;b=k[d>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+100>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;y=a+84|0;c=a+72|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+108>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+160|0;b=k[d>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+156>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;y=a+140|0;c=a+128|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+164>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+272|0;b=k[d>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+268>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;y=a+252|0;c=a+240|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+276>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+384|0;b=k[d>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+380>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;y=a+364|0;c=a+352|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+388>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+440|0;b=k[d>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+436>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;y=a+420|0;c=a+408|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+444>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+496|0;b=k[d>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+492>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;y=a+476|0;c=a+464|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+500>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+720|0;b=k[d>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+716>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;y=a+700|0;c=a+688|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+724>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+776|0;b=k[d>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+772>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;y=a+756|0;c=a+744|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+780>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+832|0;b=k[d>>2]|0;do if(b|0){x=b+12|0;y=k[x>>2]|0;k[x>>2]=y+-1;if((y|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+828>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;y=a+812|0;c=a+800|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+836>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+608|0;b=k[d>>2]|0;do if(b|0){x=b+12|0;y=k[x>>2]|0;k[x>>2]=y+-1;if((y|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+604>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;y=a+588|0;c=a+576|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+612>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+664|0;b=k[d>>2]|0;do if(b|0){x=b+12|0;y=k[x>>2]|0;k[x>>2]=y+-1;if((y|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+660>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;y=a+644|0;c=a+632|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+668>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}v=a+852|0;k[e+4>>2]=0;k[e+8>>2]=0;w=e+4|0;k[e>>2]=w;if((v|0)==(e|0)){A=k[w>>2]|0;OAa(A);A=a+8|0;k[A>>2]=0;r=B;return}x=a+856|0;OAa(k[x>>2]|0);y=a+860|0;k[y>>2]=0;k[v>>2]=x;k[x>>2]=0;b=k[e>>2]|0;t=x;if((b|0)==(w|0)){A=k[w>>2]|0;OAa(A);A=a+8|0;k[A>>2]=0;r=B;return}u=a+856|0;c=b;d=x;q=b;while(1){s=c+16|0;b=k[x>>2]|0;a:do if((x|0)==(d|0)){d=t;A=146}else{if(!b){e=x;while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))e=d;else break}}else{d=b;while(1){e=k[d+4>>2]|0;if(!e)break;else d=e}}e=k[d+16>>2]|0;p=k[s>>2]|0;if((e|0)!=(p|0)){g=(e|0)==0?1016759:e;f=(p|0)==0?1016759:p;e=i[g>>0]|0;h=i[f>>0]|0;if(e<<24>>24==0?1:e<<24>>24!=h<<24>>24)f=h;else{do{g=g+1|0;f=f+1|0;e=i[g>>0]|0;h=i[f>>0]|0}while(!(e<<24>>24==0?1:e<<24>>24!=h<<24>>24));f=h}if((e&255)<(f&255)){A=146;break}}if(!b){k[z>>2]=t;e=x;break}m=(p|0)==0?1016759:p;d=k[b+16>>2]|0;b:do if((p|0)!=(d|0)){n=i[m>>0]|0;o=n<<24>>24==0;while(1){e=(d|0)==0?1016759:d;d=i[e>>0]|0;l=n<<24>>24!=d<<24>>24;if(o|l){g=d;f=n}else{h=e;j=m;do{j=j+1|0;h=h+1|0;f=i[j>>0]|0;g=i[h>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=g<<24>>24))}if((f&255)<(g&255)){d=k[b>>2]|0;if(!d){A=156;break}else b=d}else{if(d<<24>>24==0|l)e=n;else{g=m;do{e=e+1|0;g=g+1|0;d=i[e>>0]|0;f=i[g>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24));e=f}if((d&255)>=(e&255))break b;e=b+4|0;d=k[e>>2]|0;if(!d){A=162;break}else b=d}d=k[b+16>>2]|0;if((p|0)==(d|0))break b}if((A|0)==156){A=0;k[z>>2]=b;e=b;break a}else if((A|0)==162){A=0;k[z>>2]=b;break a}}while(0);k[z>>2]=b;e=z}while(0);do if((A|0)==146){A=0;if(!b){k[z>>2]=t;e=x;break}else{k[z>>2]=d;e=d+4|0;break}}while(0);if(!(k[e>>2]|0)){while(1){b=fgb(28)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=k[s>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){s=d+-4|0;k[s>>2]=(k[s>>2]|0)+1}k[b+24>>2]=k[c+24>>2];d=k[z>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[v>>2]>>2]|0;if(d){k[v>>2]=d;b=k[e>>2]|0}B4(k[u>>2]|0,b);k[y>>2]=(k[y>>2]|0)+1}else c=q;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(w|0))break;c=b;d=k[v>>2]|0;q=b}A=k[w>>2]|0;OAa(A);A=a+8|0;k[A>>2]=0;r=B;return}function MAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>2;c=g+1|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>1;f=e>>2>>>0<536870911?(f>>>0<c>>>0?c:f):1073741823;if(!f)c=0;else{if(f>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<2)|0;k[e>>2]=k[b>>2];d=e+(0-g<<2)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+4;k[l>>2]=c+(f<<2);if(!i)return;ggb(i);return}function NAa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;Ba=r;r=r+1744|0;ta=Ba+224|0;ma=Ba;Aa=Ba+1496|0;za=Ba+1480|0;ya=Ba+1468|0;xa=Ba+1456|0;va=Ba+1444|0;ka=Ba+1432|0;wa=Ba+392|0;ua=Ba+336|0;la=Ba+280|0;na=Ba+1680|0;qa=Ba+1624|0;ra=Ba+1568|0;sa=Ba+1512|0;LAa(a);if((c|1|0)!=1){j=ta+4|0;l=ZT(52)|0;k[l>>2]=1;t=l+4|0;k[ta>>2]=t;k[j>>2]=46;i[l+50>>0]=0;m=362286;u=t+46|0;do{i[t>>0]=i[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(u|0));Y8(-215,ta,362333,362209,237);k[j>>2]=0;k[ta>>2]=0;pa=k[l>>2]|0;k[l>>2]=pa+-1;if((pa|0)==1)ggb(k[l+-4>>2]|0)}ja=a+12|0;do if((k[b>>2]&2031616|0)==65536){m=k[b+4>>2]|0;k[ta>>2]=k[m>>2];s=ta+4|0;j=m+4|0;k[s>>2]=k[j>>2];pa=ta+8|0;k[pa>>2]=k[m+8>>2];k[ta+12>>2]=k[m+12>>2];k[ta+16>>2]=k[m+16>>2];k[ta+20>>2]=k[m+20>>2];k[ta+24>>2]=k[m+24>>2];k[ta+28>>2]=k[m+28>>2];k[ta+32>>2]=k[m+32>>2];l=k[m+36>>2]|0;k[ta+36>>2]=l;b=ta+40|0;k[b>>2]=pa;pa=ta+48|0;p=ta+44|0;k[p>>2]=pa;k[ta+52>>2]=0;k[pa>>2]=0;if(l|0){pa=l+12|0;k[pa>>2]=(k[pa>>2]|0)+1}if((k[j>>2]|0)<3){ia=k[m+44>>2]|0;pa=k[p>>2]|0;k[pa>>2]=k[ia>>2];k[pa+4>>2]=k[ia+4>>2];break}k[s>>2]=0;x1(ta,k[j>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[m+40>>2]|0;n=k[b>>2]|0;b=k[m+44>>2]|0;l=k[p>>2]|0;j=0;do{k[n+(j<<2)>>2]=k[q+(j<<2)>>2];k[l+(j<<2)>>2]=k[b+(j<<2)>>2];j=j+1|0}while((j|0)<(k[s>>2]|0))}}else Q1(ta,b,-1);while(0);KG(ja,ta)|0;b=ta+36|0;j=k[b>>2]|0;if(j|0?(ia=j+12|0,pa=k[ia>>2]|0,k[ia>>2]=pa+-1,(pa|0)==1):0){l=k[b>>2]|0;if(l|0){j=k[l+4>>2]|0;if(!j){j=k[ta+32>>2]|0;if(!j){j=B1()|0;l=k[b>>2]|0}}jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[b>>2]=0}k[b>>2]=0;pa=ta+16|0;l=ta+4|0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[l>>2]|0)>0){b=k[ta+40>>2]|0;j=0;do{k[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[ta+44>>2]|0;if(!((j|0)==(ta+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);ia=a+8|0;k[ia>>2]=c;pa=a+236|0;do if((k[d>>2]&2031616|0)==65536){m=k[d+4>>2]|0;k[ta>>2]=k[m>>2];s=ta+4|0;j=m+4|0;k[s>>2]=k[j>>2];ha=ta+8|0;k[ha>>2]=k[m+8>>2];k[ta+12>>2]=k[m+12>>2];k[ta+16>>2]=k[m+16>>2];k[ta+20>>2]=k[m+20>>2];k[ta+24>>2]=k[m+24>>2];k[ta+28>>2]=k[m+28>>2];k[ta+32>>2]=k[m+32>>2];l=k[m+36>>2]|0;k[ta+36>>2]=l;b=ta+40|0;k[b>>2]=ha;ha=ta+48|0;p=ta+44|0;k[p>>2]=ha;k[ta+52>>2]=0;k[ha>>2]=0;if(l|0){ha=l+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[j>>2]|0)<3){ga=k[m+44>>2]|0;ha=k[p>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2];break}k[s>>2]=0;x1(ta,k[j>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[m+40>>2]|0;n=k[b>>2]|0;b=k[m+44>>2]|0;l=k[p>>2]|0;j=0;do{k[n+(j<<2)>>2]=k[q+(j<<2)>>2];k[l+(j<<2)>>2]=k[b+(j<<2)>>2];j=j+1|0}while((j|0)<(k[s>>2]|0))}}else Q1(ta,d,-1);while(0);KG(pa,ta)|0;b=ta+36|0;j=k[b>>2]|0;if(j|0?(ga=j+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){l=k[b>>2]|0;if(l|0){j=k[l+4>>2]|0;if(!j){j=k[ta+32>>2]|0;if(!j){j=B1()|0;l=k[b>>2]|0}}jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[b>>2]=0}k[b>>2]=0;ha=ta+16|0;l=ta+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[l>>2]|0)>0){b=k[ta+40>>2]|0;j=0;do{k[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[ta+44>>2]|0;if(!((j|0)==(ta+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);v=a+180|0;do if((k[e>>2]&2031616|0)==65536){m=k[e+4>>2]|0;k[ta>>2]=k[m>>2];s=ta+4|0;j=m+4|0;k[s>>2]=k[j>>2];ha=ta+8|0;k[ha>>2]=k[m+8>>2];k[ta+12>>2]=k[m+12>>2];k[ta+16>>2]=k[m+16>>2];k[ta+20>>2]=k[m+20>>2];k[ta+24>>2]=k[m+24>>2];k[ta+28>>2]=k[m+28>>2];k[ta+32>>2]=k[m+32>>2];l=k[m+36>>2]|0;k[ta+36>>2]=l;b=ta+40|0;k[b>>2]=ha;ha=ta+48|0;p=ta+44|0;k[p>>2]=ha;k[ta+52>>2]=0;k[ha>>2]=0;if(l|0){ha=l+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[j>>2]|0)<3){ga=k[m+44>>2]|0;ha=k[p>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2];break}k[s>>2]=0;x1(ta,k[j>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[m+40>>2]|0;n=k[b>>2]|0;b=k[m+44>>2]|0;l=k[p>>2]|0;j=0;do{k[n+(j<<2)>>2]=k[q+(j<<2)>>2];k[l+(j<<2)>>2]=k[b+(j<<2)>>2];j=j+1|0}while((j|0)<(k[s>>2]|0))}}else Q1(ta,e,-1);while(0);KG(v,ta)|0;b=ta+36|0;j=k[b>>2]|0;if(j|0?(ga=j+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){l=k[b>>2]|0;if(l|0){j=k[l+4>>2]|0;if(!j){j=k[ta+32>>2]|0;if(!j){j=B1()|0;l=k[b>>2]|0}}jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[b>>2]=0}k[b>>2]=0;ha=ta+16|0;l=ta+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[l>>2]|0)>0){b=k[ta+40>>2]|0;j=0;do{k[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[ta+44>>2]|0;if(!((j|0)==(ta+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);c=a+348|0;do if((k[f>>2]&2031616|0)==65536){m=k[f+4>>2]|0;k[ta>>2]=k[m>>2];s=ta+4|0;j=m+4|0;k[s>>2]=k[j>>2];ha=ta+8|0;k[ha>>2]=k[m+8>>2];k[ta+12>>2]=k[m+12>>2];k[ta+16>>2]=k[m+16>>2];k[ta+20>>2]=k[m+20>>2];k[ta+24>>2]=k[m+24>>2];k[ta+28>>2]=k[m+28>>2];k[ta+32>>2]=k[m+32>>2];l=k[m+36>>2]|0;k[ta+36>>2]=l;b=ta+40|0;k[b>>2]=ha;ha=ta+48|0;p=ta+44|0;k[p>>2]=ha;k[ta+52>>2]=0;k[ha>>2]=0;if(l|0){ha=l+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[j>>2]|0)<3){ga=k[m+44>>2]|0;ha=k[p>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2];break}k[s>>2]=0;x1(ta,k[j>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[m+40>>2]|0;n=k[b>>2]|0;b=k[m+44>>2]|0;l=k[p>>2]|0;j=0;do{k[n+(j<<2)>>2]=k[q+(j<<2)>>2];k[l+(j<<2)>>2]=k[b+(j<<2)>>2];j=j+1|0}while((j|0)<(k[s>>2]|0))}}else Q1(ta,f,-1);while(0);KG(c,ta)|0;b=ta+36|0;j=k[b>>2]|0;if(j|0?(ga=j+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){l=k[b>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[ta+32>>2]|0;if(j|0)break;j=B1()|0;l=k[b>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[b>>2]=0}k[b>>2]=0;ha=ta+16|0;l=ta+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[l>>2]|0)>0){b=k[ta+40>>2]|0;j=0;do{k[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[ta+44>>2]|0;if(!((j|0)==(ta+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);d=a+516|0;do if((k[g>>2]&2031616|0)==65536){m=k[g+4>>2]|0;k[ta>>2]=k[m>>2];s=ta+4|0;j=m+4|0;k[s>>2]=k[j>>2];ha=ta+8|0;k[ha>>2]=k[m+8>>2];k[ta+12>>2]=k[m+12>>2];k[ta+16>>2]=k[m+16>>2];k[ta+20>>2]=k[m+20>>2];k[ta+24>>2]=k[m+24>>2];k[ta+28>>2]=k[m+28>>2];k[ta+32>>2]=k[m+32>>2];l=k[m+36>>2]|0;k[ta+36>>2]=l;b=ta+40|0;k[b>>2]=ha;ha=ta+48|0;p=ta+44|0;k[p>>2]=ha;k[ta+52>>2]=0;k[ha>>2]=0;if(l|0){ha=l+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[j>>2]|0)<3){ga=k[m+44>>2]|0;ha=k[p>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2];break}k[s>>2]=0;x1(ta,k[j>>2]|0,0,0,0);if((k[s>>2]|0)<=0)break;q=k[m+40>>2]|0;n=k[b>>2]|0;b=k[m+44>>2]|0;l=k[p>>2]|0;j=0;do{k[n+(j<<2)>>2]=k[q+(j<<2)>>2];k[l+(j<<2)>>2]=k[b+(j<<2)>>2];j=j+1|0}while((j|0)<(k[s>>2]|0))}else Q1(ta,g,-1);while(0);KG(d,ta)|0;b=ta+36|0;j=k[b>>2]|0;do if(j|0){ga=j+12|0;ha=k[ga>>2]|0;k[ga>>2]=ha+-1;if((ha|0)!=1)break;l=k[b>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[ta+32>>2]|0;if(j|0)break;j=B1()|0;l=k[b>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[b>>2]=0}while(0);k[b>>2]=0;ha=ta+16|0;l=ta+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[l>>2]|0)>0){b=k[ta+40>>2]|0;j=0;do{k[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[ta+44>>2]|0;if(!((j|0)==(ta+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);ha=a+124|0;do if((k[h>>2]&2031616|0)==65536){m=k[h+4>>2]|0;k[ta>>2]=k[m>>2];s=ta+4|0;j=m+4|0;k[s>>2]=k[j>>2];ga=ta+8|0;k[ga>>2]=k[m+8>>2];k[ta+12>>2]=k[m+12>>2];k[ta+16>>2]=k[m+16>>2];k[ta+20>>2]=k[m+20>>2];k[ta+24>>2]=k[m+24>>2];k[ta+28>>2]=k[m+28>>2];k[ta+32>>2]=k[m+32>>2];l=k[m+36>>2]|0;k[ta+36>>2]=l;b=ta+40|0;k[b>>2]=ga;ga=ta+48|0;p=ta+44|0;k[p>>2]=ga;k[ta+52>>2]=0;k[ga>>2]=0;if(l|0){ga=l+12|0;k[ga>>2]=(k[ga>>2]|0)+1}if((k[j>>2]|0)<3){fa=k[m+44>>2]|0;ga=k[p>>2]|0;k[ga>>2]=k[fa>>2];k[ga+4>>2]=k[fa+4>>2];break}k[s>>2]=0;x1(ta,k[j>>2]|0,0,0,0);if((k[s>>2]|0)<=0)break;q=k[m+40>>2]|0;n=k[b>>2]|0;b=k[m+44>>2]|0;l=k[p>>2]|0;j=0;do{k[n+(j<<2)>>2]=k[q+(j<<2)>>2];k[l+(j<<2)>>2]=k[b+(j<<2)>>2];j=j+1|0}while((j|0)<(k[s>>2]|0))}else Q1(ta,h,-1);while(0);KG(ha,ta)|0;b=ta+36|0;j=k[b>>2]|0;do if(j|0){fa=j+12|0;ga=k[fa>>2]|0;k[fa>>2]=ga+-1;if((ga|0)!=1)break;l=k[b>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[ta+32>>2]|0;if(j|0)break;j=B1()|0;l=k[b>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[b>>2]=0}while(0);k[b>>2]=0;ga=ta+16|0;l=ta+4|0;k[ga>>2]=0;k[ga+4>>2]=0;k[ga+8>>2]=0;k[ga+12>>2]=0;if((k[l>>2]|0)>0){b=k[ta+40>>2]|0;j=0;do{k[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[ta+44>>2]|0;if(!((j|0)==(ta+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);g=a+68|0;do if((k[12333]&2031616|0)==65536){m=k[12334]|0;k[ta>>2]=k[m>>2];s=ta+4|0;j=m+4|0;k[s>>2]=k[j>>2];ga=ta+8|0;k[ga>>2]=k[m+8>>2];k[ta+12>>2]=k[m+12>>2];k[ta+16>>2]=k[m+16>>2];k[ta+20>>2]=k[m+20>>2];k[ta+24>>2]=k[m+24>>2];k[ta+28>>2]=k[m+28>>2];k[ta+32>>2]=k[m+32>>2];l=k[m+36>>2]|0;k[ta+36>>2]=l;b=ta+40|0;k[b>>2]=ga;ga=ta+48|0;p=ta+44|0;k[p>>2]=ga;k[ta+52>>2]=0;k[ga>>2]=0;if(l|0){ga=l+12|0;k[ga>>2]=(k[ga>>2]|0)+1}if((k[j>>2]|0)<3){fa=k[m+44>>2]|0;ga=k[p>>2]|0;k[ga>>2]=k[fa>>2];k[ga+4>>2]=k[fa+4>>2];break}k[s>>2]=0;x1(ta,k[j>>2]|0,0,0,0);if((k[s>>2]|0)<=0)break;q=k[m+40>>2]|0;n=k[b>>2]|0;b=k[m+44>>2]|0;l=k[p>>2]|0;j=0;do{k[n+(j<<2)>>2]=k[q+(j<<2)>>2];k[l+(j<<2)>>2]=k[b+(j<<2)>>2];j=j+1|0}while((j|0)<(k[s>>2]|0))}else Q1(ta,49332,-1);while(0);KG(g,ta)|0;b=ta+36|0;j=k[b>>2]|0;do if(j|0){fa=j+12|0;ga=k[fa>>2]|0;k[fa>>2]=ga+-1;if((ga|0)!=1)break;l=k[b>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[ta+32>>2]|0;if(j|0)break;j=B1()|0;l=k[b>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[b>>2]=0}while(0);k[b>>2]=0;ga=ta+16|0;l=ta+4|0;k[ga>>2]=0;k[ga+4>>2]=0;k[ga+8>>2]=0;k[ga+12>>2]=0;if((k[l>>2]|0)>0){b=k[ta+40>>2]|0;j=0;do{k[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[ta+44>>2]|0;if(!((j|0)==(ta+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);ea=(k[ia>>2]|0)==0;ga=a+20|0;fa=a+24|0;f=k[(ea?ga:fa)>>2]|0;ga=k[(ea?fa:ga)>>2]|0;if((k[ja>>2]&4094|0)!=4){j=ta+4|0;l=ZT(60)|0;k[l>>2]=1;t=l+4|0;k[ta>>2]=t;k[j>>2]=52;i[l+56>>0]=0;m=362341;u=t+52|0;do{i[t>>0]=i[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(u|0));Y8(-215,ta,362333,362209,251);k[j>>2]=0;k[ta>>2]=0;fa=k[l>>2]|0;k[l>>2]=fa+-1;if((fa|0)==1)ggb(k[l+-4>>2]|0)}do if(k[a+364>>2]|0){b=k[a+352>>2]|0;if((b|0)<3)j=aa(k[a+360>>2]|0,k[a+356>>2]|0)|0;else{m=k[a+388>>2]|0;l=0;j=1;do{j=aa(k[m+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(b|0))}if(!j)break;do if((y2(c,1,4,1)|0)>0){k[ta+8>>2]=0;k[ta+12>>2]=0;k[ta>>2]=16842752;k[ta+4>>2]=c;if(!(j_(ta,+(f|0))|0)?(y2(c,1,0,1)|0)!=(f|0):0){oa=174;break}else break}else if((y2(c,1,0,1)|0)!=(f|0))oa=174;while(0);if((oa|0)==174?(fa=ta+4|0,w=ZT(152)|0,k[w>>2]=1,ea=w+4|0,k[ta>>2]=ea,k[fa>>2]=144,i[w+148>>0]=0,upb(ea|0,362394,144)|0,Y8(-215,ta,362333,362209,257),k[fa>>2]=0,k[ta>>2]=0,fa=k[w>>2]|0,k[w>>2]=fa+-1,(fa|0)==1):0)ggb(k[w+-4>>2]|0);if(k[c>>2]&4095|0)break;PAa(ta,c);KG(c,ta)|0;b=ta+36|0;j=k[b>>2]|0;do if(j|0){ea=j+12|0;fa=k[ea>>2]|0;k[ea>>2]=fa+-1;if((fa|0)!=1)break;l=k[b>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[ta+32>>2]|0;if(j|0)break;j=B1()|0;l=k[b>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[b>>2]=0}while(0);k[b>>2]=0;fa=ta+16|0;l=ta+4|0;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=0;k[fa+12>>2]=0;if((k[l>>2]|0)>0){b=k[ta+40>>2]|0;j=0;do{k[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[ta+44>>2]|0;if(!((j|0)==(ta+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0)}while(0);do if(k[a+532>>2]|0){b=k[a+520>>2]|0;if((b|0)<3)j=aa(k[a+528>>2]|0,k[a+524>>2]|0)|0;else{m=k[a+556>>2]|0;l=0;j=1;do{j=aa(k[m+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(b|0))}if(!j){oa=202;break}if((y2(d,1,5,1)|0)==(f|0))break;j=ta+4|0;l=ZT(60)|0;k[l>>2]=1;t=l+4|0;k[ta>>2]=t;k[j>>2]=54;i[l+58>>0]=0;m=362539;u=t+54|0;do{i[t>>0]=i[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(u|0));Y8(-215,ta,362333,362209,264);k[j>>2]=0;k[ta>>2]=0;fa=k[l>>2]|0;k[l>>2]=fa+-1;if((fa|0)==1)ggb(k[l+-4>>2]|0)}else oa=202;while(0);if((oa|0)==202){k[ma>>2]=0;k[ma+4>>2]=0;k[ma+8>>2]=1124007936;j=ma+16|0;l=ma+48|0;t=ma+12|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[l>>2]=j;j=ma+56|0;k[ma+52>>2]=j;k[ma+60>>2]=0;k[j>>2]=0;k[ma+64>>2]=1124007936;j=ma+72|0;l=ma+104|0;t=ma+68|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[l>>2]=j;j=ma+112|0;k[ma+108>>2]=j;k[ma+116>>2]=0;k[j>>2]=0;k[ma+120>>2]=1124007936;j=ma+128|0;l=ma+160|0;t=ma+124|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[l>>2]=j;t=ma+168|0;k[ma+164>>2]=t;u=t+56|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[ta>>2]=1;k[ta+4>>2]=f;j1(ma,49,ta,5);fa=k[ma>>2]|0;dh[k[(k[fa>>2]|0)+12>>2]&255](fa,ma,d,-1);XN(ma)}s=a+196|0;do if(k[s>>2]|0){c=a+184|0;b=k[c>>2]|0;if((b|0)<3)j=aa(k[a+192>>2]|0,k[a+188>>2]|0)|0;else{m=k[a+220>>2]|0;l=0;j=1;do{j=aa(k[m+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(b|0))}if(!j)break;do if((y2(v,1,4,1)|0)>0){k[ta+8>>2]=0;k[ta+12>>2]=0;k[ta>>2]=16842752;k[ta+4>>2]=v;if(!(j_(ta,+(ga|0))|0)?(y2(v,1,0,1)|0)!=(ga|0):0){oa=214;break}else break}else if((y2(v,1,0,1)|0)!=(ga|0))oa=214;while(0);if((oa|0)==214?(fa=ta+4|0,x=ZT(144)|0,k[x>>2]=1,ea=x+4|0,k[ta>>2]=ea,k[fa>>2]=139,i[x+143>>0]=0,upb(ea|0,362594,139)|0,Y8(-215,ta,362333,362209,275),k[fa>>2]=0,k[ta>>2]=0,fa=k[x>>2]|0,k[x>>2]=fa+-1,(fa|0)==1):0)ggb(k[x+-4>>2]|0);if(!(k[v>>2]&4095)){PAa(ta,v);KG(v,ta)|0;b=ta+36|0;j=k[b>>2]|0;do if(j|0){ea=j+12|0;fa=k[ea>>2]|0;k[ea>>2]=fa+-1;if((fa|0)!=1)break;l=k[b>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[ta+32>>2]|0;if(j|0)break;j=B1()|0;l=k[b>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[b>>2]=0}while(0);k[b>>2]=0;fa=ta+16|0;l=ta+4|0;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=0;k[fa+12>>2]=0;if((k[l>>2]|0)>0){b=k[ta+40>>2]|0;j=0;do{k[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[ta+44>>2]|0;if(!((j|0)==(ta+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0)}k[ma>>2]=1124007936;q=ma+4|0;j=ma+8|0;n=ma+40|0;t=q;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[n>>2]=j;p=ma+48|0;m=ma+44|0;k[m>>2]=p;k[ma+52>>2]=0;k[p>>2]=0;b=ta+4|0;j=b+4|0;k[j>>2]=0;k[j+4>>2]=0;k[ta>>2]=33619968;k[b>>2]=ma;mY(v,ta);KG(v,ma)|0;b=ma+36|0;j=k[b>>2]|0;do if(j|0){ea=j+12|0;fa=k[ea>>2]|0;k[ea>>2]=fa+-1;if((fa|0)!=1)break;l=k[b>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[ma+32>>2]|0;if(j|0)break;j=B1()|0;l=k[b>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[b>>2]=0}while(0);k[b>>2]=0;fa=ma+16|0;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=0;k[fa+12>>2]=0;if((k[q>>2]|0)>0){l=k[n>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[q>>2]|0))}j=k[m>>2]|0;if(!((j|0)==(p|0)|(j|0)==0))ggb(k[j+-4>>2]|0);n=k[s>>2]|0;b=k[c>>2]|0;if((b|0)<3)j=aa(k[a+192>>2]|0,k[a+188>>2]|0)|0;else{m=k[a+220>>2]|0;l=0;j=1;do{j=aa(k[m+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(b|0))}Dgb(n,n+(j<<2)|0)}while(0);do if(!(k[a+252>>2]|0))d=0;else{p=a+240|0;b=k[p>>2]|0;if((b|0)<3)j=aa(k[a+248>>2]|0,k[a+244>>2]|0)|0;else{m=k[a+276>>2]|0;l=0;j=1;do{j=aa(k[m+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(b|0))}if(!j){d=0;break}if((k[pa>>2]&4094|0)!=4){j=ta+4|0;l=ZT(64)|0;k[l>>2]=1;t=l+4|0;k[ta>>2]=t;k[j>>2]=56;i[l+60>>0]=0;m=362734;u=t+56|0;do{i[t>>0]=i[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(u|0));Y8(-215,ta,362333,362209,284);k[j>>2]=0;k[ta>>2]=0;fa=k[l>>2]|0;k[l>>2]=fa+-1;if((fa|0)==1)ggb(k[l+-4>>2]|0)}q=a+248|0;n=k[q>>2]|0;if((n|0)!=1?(k[a+244>>2]|0)!=1:0)oa=267;else{b=k[p>>2]|0;if((b|0)<3)j=aa(n,k[a+244>>2]|0)|0;else{m=k[a+276>>2]|0;l=0;j=1;do{j=aa(k[m+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(b|0))}if((j|0)==(f|0))s=1;else oa=267}if((oa|0)==267){switch(k[ia>>2]|0){case 0:{if((k[a+244>>2]|0)==(f|0))j=0;else oa=270;break}case 1:{if((n|0)==(f|0))j=1;else oa=270;break}default:oa=270}if((oa|0)==270){j=ta+4|0;l=ZT(116)|0;k[l>>2]=1;t=l+4|0;k[ta>>2]=t;k[j>>2]=108;i[l+112>>0]=0;m=362791;u=t+108|0;do{i[t>>0]=i[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(u|0));Y8(-215,ta,362333,362209,290);k[j>>2]=0;k[ta>>2]=0;oa=k[l>>2]|0;k[l>>2]=oa+-1;if((oa|0)==1)ggb(k[l+-4>>2]|0);j=k[ia>>2]|0}s=k[((j|0)==0?q:a+244|0)>>2]|0}if(k[pa>>2]&16384|0?!((s|0)>1&(k[ia>>2]|0)==1):0){d=s;break}k[ta>>2]=1124007936;q=ta+4|0;j=ta+8|0;n=ta+40|0;t=q;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[n>>2]=j;p=ta+48|0;m=ta+44|0;k[m>>2]=p;k[ta+52>>2]=0;k[p>>2]=0;k[ma+8>>2]=0;k[ma+12>>2]=0;k[ma>>2]=16842752;k[ma+4>>2]=pa;b=Aa+4|0;j=b+4|0;k[j>>2]=0;k[j+4>>2]=0;k[Aa>>2]=33619968;k[b>>2]=ta;$1(ma,Aa);KG(pa,ta)|0;b=ta+36|0;j=k[b>>2]|0;do if(j|0){fa=j+12|0;oa=k[fa>>2]|0;k[fa>>2]=oa+-1;if((oa|0)!=1)break;l=k[b>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[ta+32>>2]|0;if(j|0)break;j=B1()|0;l=k[b>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[b>>2]=0}while(0);k[b>>2]=0;oa=ta+16|0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[q>>2]|0)>0){l=k[n>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[q>>2]|0))}j=k[m>>2]|0;if(!((j|0)==(p|0)|(j|0)==0))ggb(k[j+-4>>2]|0);d=s}while(0);e=d+ga|0;T=a+140|0;n=(k[T>>2]|0)==0;m=k[a+128>>2]|0;do if(n)oa=301;else{if((m|0)<3)j=aa(k[a+136>>2]|0,k[a+132>>2]|0)|0;else{b=k[a+164>>2]|0;l=0;j=1;do{j=aa(k[b+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(m|0))}if(!j){oa=301;break}if((y2(ha,1,0,1)|0)==(e|0)?(k[ta+8>>2]=0,k[ta+12>>2]=0,k[ta>>2]=16842752,k[ta+4>>2]=ha,j_(ta,2.0)|0):0){oa=314;break}j=ta+4|0;l=ZT(116)|0;k[l>>2]=1;t=l+4|0;k[ta>>2]=t;k[j>>2]=108;i[l+112>>0]=0;m=362900;u=t+108|0;do{i[t>>0]=i[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(u|0));Y8(-215,ta,362333,362209,306);k[j>>2]=0;k[ta>>2]=0;oa=k[l>>2]|0;k[l>>2]=oa+-1;if((oa|0)==1)ggb(k[l+-4>>2]|0);oa=314}while(0);do if((oa|0)==301){do if((m|0)<3){if((k[a+132>>2]|0)!=1){oa=305;break}if((k[a+136>>2]|0)!=(e|0)){oa=305;break}if((k[ha>>2]&4095|0)!=0|n)oa=305}else oa=305;while(0);if((oa|0)==305){k[ta>>2]=1;k[ta+4>>2]=e;G1(ha,2,ta,0)};k[ta>>2]=0;k[ta+4>>2]=0;k[ta+8>>2]=0;k[ta+12>>2]=0;k[ta+16>>2]=0;k[ta+20>>2]=0;k[ta+24>>2]=0;k[ta+28>>2]=0;oY(ha,ta);if((d|0)!=1){oa=314;break}m=(k[pa>>2]&4095)>>>0<5&1;do if(!(k[ha>>2]&16384)){j=k[a+164>>2]|0;if((k[j>>2]|0)==1){oa=309;break}l=k[T>>2]|0;b=k[a+168>>2]|0;if((k[j+4>>2]|0)==1){j=l+(aa(k[b>>2]|0,ga)|0)|0;break}else{j=k[a+136>>2]|0;fa=(ga|0)/(j|0)|0;j=ga-(aa(fa,j)|0)|0;j=l+(aa(k[b>>2]|0,fa)|0)+j|0;break}}else oa=309;while(0);if((oa|0)==309)j=(k[T>>2]|0)+ga|0;i[j>>0]=m}while(0);do if((oa|0)==314){if((d|0)<=1)break;p=a+164|0;q=a+168|0;s=a+136|0;c=ta+4|0;n=0;do{j=n+ga|0;do if(!(k[ha>>2]&16384)){l=k[p>>2]|0;if((k[l>>2]|0)==1){oa=318;break}b=k[T>>2]|0;m=k[q>>2]|0;if((k[l+4>>2]|0)==1){j=b+(aa(k[m>>2]|0,j)|0)|0;break}else{ea=k[s>>2]|0;fa=(j|0)/(ea|0)|0;j=j-(aa(fa,ea)|0)|0;j=b+(aa(k[m>>2]|0,fa)|0)+j|0;break}}else oa=318;while(0);if((oa|0)==318){oa=0;j=(k[T>>2]|0)+j|0}if(i[j>>0]|0){j=ZT(56)|0;k[j>>2]=1;t=j+4|0;k[ta>>2]=t;k[c>>2]=48;i[j+52>>0]=0;m=363009;u=t+48|0;do{i[t>>0]=i[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(u|0));Y8(-215,ta,362333,362209,319);k[c>>2]=0;k[ta>>2]=0;fa=k[j>>2]|0;k[j>>2]=fa+-1;if((fa|0)==1)ggb(k[j+-4>>2]|0)}n=n+1|0}while((n|0)<(d|0))}while(0);S=a+628|0;k[ma>>2]=0;k[ma+4>>2]=0;k[ma+8>>2]=1124007936;j=ma+16|0;l=ma+48|0;t=ma+12|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[l>>2]=j;j=ma+56|0;k[ma+52>>2]=j;k[ma+60>>2]=0;k[j>>2]=0;k[ma+64>>2]=1124007936;j=ma+72|0;l=ma+104|0;t=ma+68|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[l>>2]=j;j=ma+112|0;k[ma+108>>2]=j;k[ma+116>>2]=0;k[j>>2]=0;k[ma+120>>2]=1124007936;j=ma+128|0;l=ma+160|0;t=ma+124|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[l>>2]=j;t=ma+168|0;k[ma+164>>2]=t;u=t+56|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[ta>>2]=e;k[ta+4>>2]=1;j1(ma,48,ta,12);R=k[ma>>2]|0;dh[k[(k[R>>2]|0)+12>>2]&255](R,ma,S,-1);XN(ma);R=a+292|0;k[ma>>2]=0;k[ma+4>>2]=0;k[ma+8>>2]=1124007936;j=ma+16|0;l=ma+48|0;t=ma+12|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[l>>2]=j;j=ma+56|0;k[ma+52>>2]=j;k[ma+60>>2]=0;k[j>>2]=0;k[ma+64>>2]=1124007936;j=ma+72|0;l=ma+104|0;t=ma+68|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[l>>2]=j;j=ma+112|0;k[ma+108>>2]=j;k[ma+116>>2]=0;k[j>>2]=0;k[ma+120>>2]=1124007936;j=ma+128|0;l=ma+160|0;t=ma+124|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[l>>2]=j;t=ma+168|0;k[ma+164>>2]=t;u=t+56|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[ta>>2]=e;k[ta+4>>2]=1;j1(ma,48,ta,5);fa=k[ma>>2]|0;dh[k[(k[fa>>2]|0)+12>>2]&255](fa,ma,R,-1);XN(ma);k[Aa>>2]=0;fa=Aa+4|0;k[fa>>2]=0;k[Aa+8>>2]=0;k[za>>2]=0;ea=za+4|0;k[ea>>2]=0;k[za+8>>2]=0;k[ya>>2]=0;da=ya+4|0;k[da>>2]=0;k[ya+8>>2]=0;k[xa>>2]=0;ca=xa+4|0;k[ca>>2]=0;k[xa+8>>2]=0;k[va>>2]=0;ba=va+4|0;k[ba>>2]=0;k[va+8>>2]=0;P=ka+4|0;k[P>>2]=0;Q=ka+8|0;k[Q>>2]=0;Z=ka+4|0;k[ka>>2]=Z;_=wa+8|0;k[wa>>2]=_;$=wa+4|0;k[$>>2]=1032;if(f>>>0>1032){while(1){j=fgb(f)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}k[wa>>2]=j}else j=_;k[$>>2]=f;U=(k[ia>>2]|0)==0;M=U?1:f;W=ua+4|0;k[W>>2]=2;Y=ua+8|0;k[Y>>2]=U?f:1;k[ua+12>>2]=M;U=ua+16|0;k[U>>2]=j;k[ua+20>>2]=j;N=ua+24|0;V=ua+40|0;X=N+8|0;k[X>>2]=0;k[X+4>>2]=0;k[V>>2]=Y;Y=ua+48|0;X=ua+44|0;k[X>>2]=Y;O=k[a+84>>2]|0;k[ua>>2]=1124024320;k[Y>>2]=M;k[ua+52>>2]=1;L=j+f|0;k[ua+28>>2]=L;k[N>>2]=L+(0-M)+M;do if(O|0){b=k[a+72>>2]|0;if((b|0)<3)j=aa(k[a+80>>2]|0,k[a+76>>2]|0)|0;else{m=k[a+108>>2]|0;l=0;j=1;do{j=aa(k[m+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(b|0))}if(!j)break;N=k[a+108>>2]|0;O=k[a+52>>2]|0;if(((k[N>>2]|0)==(k[O>>2]|0)?(k[N+4>>2]|0)==(k[O+4>>2]|0):0)?(k[g>>2]&4095|0)==0:0)break;k[ta>>2]=0;j=ta+4|0;k[j>>2]=0;l=ZT(64)|0;k[l>>2]=1;t=l+4|0;k[ta>>2]=t;k[j>>2]=59;i[l+63>>0]=0;m=363058;u=t+59|0;do{i[t>>0]=i[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(u|0));Y8(-215,ta,362333,362209,334);k[j>>2]=0;k[ta>>2]=0;O=k[l>>2]|0;k[l>>2]=O+-1;if((O|0)==1)ggb(k[l+-4>>2]|0)}while(0);if((ga|0)>0){f=ta+4|0;t=ma+4|0;u=a+164|0;g=a+168|0;h=a+136|0;v=a+332|0;w=a+308|0;x=a+336|0;y=a+304|0;z=Z;A=ta+4|0;B=va+8|0;C=xa+8|0;D=ta+4|0;E=ta+4|0;F=la+36|0;G=la+16|0;H=la+4|0;I=la+40|0;J=la+44|0;K=la+48|0;L=ta+4|0;M=ta+4|0;N=ma+4|0;O=la+32|0;e=0;do{if(!(k[ia>>2]|0)){k[ta>>2]=-2147483648;k[f>>2]=2147483647;k[ma>>2]=e;k[t>>2]=e+1;H1(la,ja,ta,ma)}else{k[ta>>2]=e;k[M>>2]=e+1;k[ma>>2]=-2147483648;k[N>>2]=2147483647;H1(la,ja,ta,ma)}do if(!(k[ha>>2]&16384)){j=k[u>>2]|0;if((k[j>>2]|0)==1){oa=350;break}l=k[T>>2]|0;b=k[g>>2]|0;if((k[j+4>>2]|0)==1){j=l+(aa(k[b>>2]|0,e)|0)|0;break}else{j=k[h>>2]|0;d=(e|0)/(j|0)|0;j=e-(aa(d,j)|0)|0;j=l+(aa(k[b>>2]|0,d)|0)+j|0;break}}else oa=350;while(0);if((oa|0)==350){oa=0;j=(k[T>>2]|0)+e|0}a:do if((i[j>>0]|0)==1){QAa(la,0,Aa,0,ya);do if(!(k[R>>2]&16384)){j=k[v>>2]|0;if((k[j>>2]|0)==1){oa=357;break}l=k[w>>2]|0;b=k[x>>2]|0;if((k[j+4>>2]|0)==1){j=l+(aa(k[b>>2]|0,e)|0)|0;break}else{j=k[y>>2]|0;d=(e|0)/(j|0)|0;j=e-(aa(d,j)|0)|0;j=l+(aa(k[b>>2]|0,d)|0)+(j<<2)|0;break}}else oa=357;while(0);if((oa|0)==357){oa=0;j=(k[w>>2]|0)+(e<<2)|0}o[j>>2]=-1.0;l=k[fa>>2]|0;j=k[Aa>>2]|0;s=l-j|0;d=s>>2;s=(s|0)>0;if(s)c=j;else{k[ta>>2]=0;k[E>>2]=0;j=ZT(12)|0;k[j>>2]=1;c=j+4|0;k[ta>>2]=c;k[E>>2]=5;i[j+9>>0]=0;i[c>>0]=i[363118]|0;i[c+1>>0]=i[363119]|0;i[c+2>>0]=i[363120]|0;i[c+3>>0]=i[363121]|0;i[c+4>>0]=i[363122]|0;Y8(-215,ta,362333,362209,350);k[E>>2]=0;k[ta>>2]=0;c=k[j>>2]|0;k[j>>2]=c+-1;if((c|0)==1)ggb(k[j+-4>>2]|0);c=k[Aa>>2]|0;l=k[fa>>2]|0}q=k[c>>2]|0;p=k[l+-4>>2]|0;n=((p+(q*127|0)|0)*127|0)+d|0;j=k[Z>>2]|0;b:do if(j){l=Z;m=j;c:while(1){b=m;while(1){if((k[b+16>>2]|0)>=(n|0))break;b=k[b+4>>2]|0;if(!b)break c}m=k[b>>2]|0;if(!m){l=b;break}else l=b}do if((l|0)!=(Z|0)){if((n|0)<(k[l+16>>2]|0))break;n=k[l+20>>2]|0;j=k[va>>2]|0;m=k[j+(n<<3)>>2]|0;k[ta>>2]=m;n=k[j+(n<<3)+4>>2]|0;k[D>>2]=n;j=k[xa>>2]|0;b=j+(m<<2)|0;do if((n-m|0)==(d|0)?(k[b>>2]|0)==(q|0):0){if((k[b+(d+-1<<2)>>2]|0)!=(p|0))break;d:do if(s){if((q|0)==(k[c>>2]|0))l=0;else{l=0;break}do{l=l+1|0;if((l|0)>=(d|0))break d}while((k[b+(l<<2)>>2]|0)==(k[c+(l<<2)>>2]|0))}else l=0;while(0);if((l|0)!=(d|0))break;j=k[ba>>2]|0;if((j|0)==(k[B>>2]|0))RAa(va,ta);else{k[j>>2]=m;k[j+4>>2]=n;k[ba>>2]=j+8}break a}while(0);break b}while(0);while(1){l=k[j+16>>2]|0;if((n|0)<(l|0)){l=k[j>>2]|0;if(!l){oa=388;break}else j=l}else{if((l|0)>=(n|0)){oa=393;break}b=j+4|0;l=k[b>>2]|0;if(!l){oa=392;break}else j=l}}if((oa|0)==388){k[ta>>2]=j;l=j;b=j;oa=394;break}else if((oa|0)==392){k[ta>>2]=j;l=j;oa=394;break}else if((oa|0)==393){k[ta>>2]=j;if(!j){l=j;b=ta;oa=394;break}else{oa=401;break}}}else{k[ta>>2]=Z;l=z;b=Z;oa=394}while(0);if((oa|0)==394){while(1){j=fgb(24)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}k[j+16>>2]=n;k[j+20>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=l;k[b>>2]=j;l=k[k[ka>>2]>>2]|0;if(!l)l=j;else{k[ka>>2]=l;l=k[b>>2]|0}B4(k[P>>2]|0,l);k[Q>>2]=(k[Q>>2]|0)+1;oa=401}if((oa|0)==401){oa=0;k[j+20>>2]=e;j=k[xa>>2]|0}l=k[ca>>2]|0;m=l-j>>2;k[ta>>2]=m;j=m+d|0;k[A>>2]=j;b=k[ba>>2]|0;if((b|0)==(k[B>>2]|0))RAa(va,ta);else{k[b>>2]=m;k[b+4>>2]=j;k[ba>>2]=b+8}j=k[Aa>>2]|0;b=k[fa>>2]|0;e:do if((j|0)!=(b|0))while(1){if((l|0)==(k[C>>2]|0))Q4(xa,j);else{k[l>>2]=k[j>>2];k[ca>>2]=l+4}j=j+4|0;if((j|0)==(b|0))break e;l=k[ca>>2]|0}while(0)}else{k[ta>>2]=0;k[L>>2]=0;j=k[ba>>2]|0;if((j|0)==(k[B>>2]|0))RAa(va,ta);else{k[j>>2]=0;k[j+4>>2]=0;k[ba>>2]=j+8}do if(!(k[R>>2]&16384)){j=k[v>>2]|0;if((k[j>>2]|0)==1){oa=417;break}l=k[w>>2]|0;b=k[x>>2]|0;if((k[j+4>>2]|0)==1){j=l+(aa(k[b>>2]|0,e)|0)|0;break}else{j=k[y>>2]|0;d=(e|0)/(j|0)|0;j=e-(aa(d,j)|0)|0;j=l+(aa(k[b>>2]|0,d)|0)+(j<<2)|0;break}}else oa=417;while(0);if((oa|0)==417){oa=0;j=(k[w>>2]|0)+(e<<2)|0}o[j>>2]=0.0}while(0);j=k[F>>2]|0;do if(j|0){c=j+12|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1)break;l=k[F>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[O>>2]|0;if(j|0)break;j=B1()|0;l=k[F>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[F>>2]=0}while(0);k[F>>2]=0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[H>>2]|0)>0){l=k[I>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[H>>2]|0))}j=k[J>>2]|0;if(!((j|0)==(K|0)|(j|0)==0))ggb(k[j+-4>>2]|0);e=e+1|0}while((e|0)<(ga|0))}l=k[va>>2]|0;j=k[ba>>2]|0;do if((l|0)!=(j|0)){k[na>>2]=1124024332;s=na+4|0;k[s>>2]=2;c=na+8|0;j=j-l|0;k[c>>2]=j>>3;k[na+12>>2]=1;m=na+16|0;b=na+32|0;k[b>>2]=0;n=na+36|0;k[n>>2]=0;p=na+40|0;k[p>>2]=c;c=na+48|0;q=na+44|0;k[q>>2]=c;k[na+52>>2]=8;k[c>>2]=8;k[m>>2]=l;k[na+20>>2]=l;j=l+j|0;k[na+24>>2]=j;k[na+28>>2]=j;j=ta+4|0;ma=j+4|0;k[ma>>2]=0;k[ma+4>>2]=0;k[ta>>2]=33619968;k[j>>2]=S;mY(na,ta);j=k[n>>2]|0;do if(j|0){ma=j+12|0;na=k[ma>>2]|0;k[ma>>2]=na+-1;if((na|0)!=1)break;l=k[n>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[b>>2]|0;if(j|0)break;j=B1()|0;l=k[n>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[n>>2]=0}while(0);k[n>>2]=0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[s>>2]|0)>0){l=k[p>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[s>>2]|0))}j=k[q>>2]|0;if(!((j|0)==(c|0)|(j|0)==0))ggb(k[j+-4>>2]|0);k[qa>>2]=1124024324;e=qa+4|0;k[e>>2]=2;t=qa+8|0;na=k[ca>>2]|0;j=k[xa>>2]|0;l=na-j|0;k[t>>2]=l>>2;k[qa+12>>2]=1;s=qa+16|0;k[s>>2]=0;b=qa+20|0;k[b>>2]=0;m=qa+24|0;k[m>>2]=0;q=qa+32|0;k[q>>2]=0;c=qa+36|0;k[c>>2]=0;d=qa+40|0;k[d>>2]=t;t=qa+48|0;f=qa+44|0;k[f>>2]=t;n=qa+52|0;k[n>>2]=0;k[t>>2]=0;p=j;if((p|0)!=(na|0)){k[n>>2]=4;k[t>>2]=4;k[s>>2]=p;k[b>>2]=p;na=j+l|0;k[m>>2]=na;k[qa+28>>2]=na}j=ta+4|0;na=j+4|0;k[na>>2]=0;k[na+4>>2]=0;k[ta>>2]=33619968;k[j>>2]=a+572;mY(qa,ta);j=k[c>>2]|0;do if(j|0){na=j+12|0;qa=k[na>>2]|0;k[na>>2]=qa+-1;if((qa|0)!=1)break;l=k[c>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[q>>2]|0;if(j|0)break;j=B1()|0;l=k[c>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[c>>2]=0}while(0);k[c>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[e>>2]|0)>0){l=k[d>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[e>>2]|0))}j=k[f>>2]|0;if((j|0)==(t|0)|(j|0)==0)break;ggb(k[j+-4>>2]|0)}while(0);do if(!(k[ha>>2]&16384)){b=k[a+164>>2]|0;if((k[b>>2]|0)==1){oa=467;break}j=k[T>>2]|0;l=k[a+168>>2]|0;if((k[b+4>>2]|0)==1){j=j+(aa(k[l>>2]|0,ga)|0)|0;break}else{qa=k[a+136>>2]|0;na=(ga|0)/(qa|0)|0;qa=ga-(aa(na,qa)|0)|0;j=j+(aa(k[l>>2]|0,na)|0)+qa|0;break}}else oa=467;while(0);if((oa|0)==467)j=(k[T>>2]|0)+ga|0;do if((i[j>>0]|0)==1){QAa(pa,a+684|0,Aa,za,ya);k[ra>>2]=1124024324;e=ra+4|0;k[e>>2]=2;t=ra+8|0;qa=k[fa>>2]|0;j=k[Aa>>2]|0;l=qa-j|0;k[t>>2]=l>>2;k[ra+12>>2]=1;s=ra+16|0;k[s>>2]=0;b=ra+20|0;k[b>>2]=0;m=ra+24|0;k[m>>2]=0;q=ra+32|0;k[q>>2]=0;c=ra+36|0;k[c>>2]=0;d=ra+40|0;k[d>>2]=t;t=ra+48|0;f=ra+44|0;k[f>>2]=t;n=ra+52|0;k[n>>2]=0;k[t>>2]=0;p=j;if((p|0)!=(qa|0)){k[n>>2]=4;k[t>>2]=4;k[s>>2]=p;k[b>>2]=p;qa=j+l|0;k[m>>2]=qa;k[ra+28>>2]=qa}j=ta+4|0;qa=j+4|0;k[qa>>2]=0;k[qa+4>>2]=0;k[ta>>2]=33619968;k[j>>2]=a+740;mY(ra,ta);j=k[c>>2]|0;do if(j|0){qa=j+12|0;ra=k[qa>>2]|0;k[qa>>2]=ra+-1;if((ra|0)!=1)break;l=k[c>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[q>>2]|0;if(j|0)break;j=B1()|0;l=k[c>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[c>>2]=0}while(0);k[c>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[e>>2]|0)>0){l=k[d>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[e>>2]|0))}j=k[f>>2]|0;if(!((j|0)==(t|0)|(j|0)==0))ggb(k[j+-4>>2]|0);k[sa>>2]=1124024324;e=sa+4|0;k[e>>2]=2;t=sa+8|0;ra=k[ea>>2]|0;j=k[za>>2]|0;l=ra-j|0;k[t>>2]=l>>2;k[sa+12>>2]=1;s=sa+16|0;k[s>>2]=0;b=sa+20|0;k[b>>2]=0;m=sa+24|0;k[m>>2]=0;q=sa+32|0;k[q>>2]=0;c=sa+36|0;k[c>>2]=0;d=sa+40|0;k[d>>2]=t;t=sa+48|0;f=sa+44|0;k[f>>2]=t;n=sa+52|0;k[n>>2]=0;k[t>>2]=0;p=j;if((p|0)!=(ra|0)){k[n>>2]=4;k[t>>2]=4;k[s>>2]=p;k[b>>2]=p;ra=j+l|0;k[m>>2]=ra;k[sa+28>>2]=ra}j=ta+4|0;ra=j+4|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ta>>2]=33619968;k[j>>2]=a+796;mY(sa,ta);j=k[c>>2]|0;do if(j|0){sa=j+12|0;ta=k[sa>>2]|0;k[sa>>2]=ta+-1;if((ta|0)!=1)break;l=k[c>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[q>>2]|0;if(j|0)break;j=B1()|0;l=k[c>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[c>>2]=0}while(0);k[c>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[e>>2]|0)>0){l=k[d>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[e>>2]|0))}j=k[f>>2]|0;if((j|0)==(t|0)|(j|0)==0)break;ggb(k[j+-4>>2]|0)}while(0);b=ua+36|0;j=k[b>>2]|0;do if(j|0){sa=j+12|0;ta=k[sa>>2]|0;k[sa>>2]=ta+-1;if((ta|0)!=1)break;l=k[b>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[ua+32>>2]|0;if(j|0)break;j=B1()|0;l=k[b>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[b>>2]=0}while(0);k[b>>2]=0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[W>>2]|0)>0){l=k[V>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[W>>2]|0))}j=k[X>>2]|0;if(!((j|0)==(Y|0)|(j|0)==0))ggb(k[j+-4>>2]|0);j=k[wa>>2]|0;if((j|0)!=(_|0)){if(j|0)ggb(j);k[wa>>2]=_;k[$>>2]=1032}SAa(k[Z>>2]|0);j=k[va>>2]|0;l=j;if(j|0){b=k[ba>>2]|0;if((b|0)!=(j|0))k[ba>>2]=b+(~((b+-8-l|0)>>>3)<<3);ggb(j)}j=k[xa>>2]|0;l=j;if(j|0){b=k[ca>>2]|0;if((b|0)!=(j|0))k[ca>>2]=b+(~((b+-4-l|0)>>>2)<<2);ggb(j)}j=k[ya>>2]|0;l=j;if(j|0){b=k[da>>2]|0;if((b|0)!=(j|0))k[da>>2]=b+(~((b+-4-l|0)>>>2)<<2);ggb(j)}j=k[za>>2]|0;l=j;if(j|0){b=k[ea>>2]|0;if((b|0)!=(j|0))k[ea>>2]=b+(~((b+-4-l|0)>>>2)<<2);ggb(j)}j=k[Aa>>2]|0;if(!j){r=Ba;return}l=k[fa>>2]|0;if((l|0)!=(j|0))k[fa>>2]=l+(~((l+-4-j|0)>>>2)<<2);ggb(j);r=Ba;return}function OAa(a){a=a|0;var b=0,c=0,d=0;if(!a)return;OAa(k[a>>2]|0);OAa(k[a+4>>2]|0);c=a+16|0;b=k[c>>2]|0;k[a+20>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);ggb(a);return}function PAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;w=r;r=r+16|0;f=w;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;g=o7(f)|0;u=b+12|0;p=(k[u>>2]|0)+-1+(k[b+8>>2]|0)|0;k[a>>2]=1124007936;c=a+8|0;q=a+40|0;d=a+4|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[q>>2]=c;n=a+48|0;o=a+44|0;k[o>>2]=n;k[a+52>>2]=0;k[n>>2]=0;k[f>>2]=1;k[f+4>>2]=g;G1(a,2,f,4);if((p|0)<=0){r=w;return}h=b+40|0;j=b+16|0;l=b+44|0;m=a+16|0;n=a+12|0;c=0;g=0;do{do if((k[b>>2]&16384|0)==0?(s=k[h>>2]|0,(k[s>>2]|0)!=1):0){d=k[j>>2]|0;e=k[l>>2]|0;if((k[s+4>>2]|0)==1){d=d+(aa(k[e>>2]|0,g)|0)|0;break}else{f=k[u>>2]|0;x=(g|0)/(f|0)|0;f=g-(aa(x,f)|0)|0;d=d+(aa(k[e>>2]|0,x)|0)+f|0;break}}else v=5;while(0);if((v|0)==5){v=0;d=(k[j>>2]|0)+g|0}if(i[d>>0]|0){f=c+1|0;do if((k[a>>2]&16384|0)==0?(t=k[q>>2]|0,(k[t>>2]|0)!=1):0){d=k[m>>2]|0;e=k[o>>2]|0;if((k[t+4>>2]|0)==1){c=d+(aa(k[e>>2]|0,c)|0)|0;break}else{y=k[n>>2]|0;x=(c|0)/(y|0)|0;c=c-(aa(x,y)|0)|0;c=d+(aa(k[e>>2]|0,x)|0)+(c<<2)|0;break}}else v=12;while(0);if((v|0)==12){v=0;c=(k[m>>2]|0)+(c<<2)|0}k[c>>2]=g;c=f}g=g+1|0}while((g|0)!=(p|0));r=w;return}function QAa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0.0,p=0.0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=r;r=r+16|0;y=H;q=a+12|0;if((k[q>>2]|0)!=1?(k[a+8>>2]|0)!=1:0)x=4;else x=3;if((x|0)==3?(k[a>>2]&4094|0)!=4:0)x=4;if((x|0)==4){l=y+4|0;m=ZT(92)|0;k[m>>2]=1;s=m+4|0;k[y>>2]=s;k[l>>2]=86;i[m+90>>0]=0;t=363124;v=s+86|0;do{i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));Y8(-215,y,363211,362209,427);k[l>>2]=0;k[y>>2]=0;G=k[m>>2]|0;k[m>>2]=G+-1;if((G|0)==1)ggb(k[m+-4>>2]|0)}if(b){m=k[a+40>>2]|0;l=k[m+4>>2]|0;m=k[m>>2]|0;if(!(((((k[b+4>>2]|0)<3?(k[b+8>>2]|0)==(m|0):0)?(k[b+12>>2]|0)==(l|0):0)?(g=k[b>>2]|0,(g&4095|0)==4):0)?(f=k[b+16>>2]|0,(f|0)!=0):0)){k[y>>2]=m;k[y+4>>2]=l;G1(b,2,y,4);f=k[b+16>>2]|0;g=k[b>>2]|0}if(!(g&16384)){F=f;D=((k[k[b+44>>2]>>2]|0)>>>0)/((1212424721>>>(g<<2&28)&15)>>>0)|0}else{F=f;D=1}}else{F=0;D=0}G=(k[q>>2]|0)+-1+(k[a+8>>2]|0)|0;f=G<<1;g=e+4|0;b=k[g>>2]|0;m=k[e>>2]|0;l=b-m>>2;if(f>>>0<=l>>>0)if(f>>>0<l>>>0?(w=m+(f<<2)|0,(b|0)!=(w|0)):0){k[g>>2]=b+(~((b+-4-w|0)>>>2)<<2);E=m}else E=m;else{U1(e,f-l|0);E=k[e>>2]|0}g=k[a+16>>2]|0;f=k[a>>2]|0;if(!(f&16384))l=((k[k[a+44>>2]>>2]|0)>>>0)/((1212424721>>>(f<<2&28)&15)>>>0)|0;else l=1;if((f&4095|0)==5){q=E+(G<<2)|0;if((G|0)>0){b=y+4|0;m=0;do{A=g+((aa(m,l)|0)<<2)|0;p=+o[A>>2];if(!(p==3402823466385288598117041.0e14)){f=(o[u>>2]=p,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;n=f?p+-8388608.0+8388608.0:p+8388608.0+-8388608.0;if(n==0.0)n=f?-0.0:0.0}else n=p;A=~~n;k[q+(m<<2)>>2]=A;if(!(+(A|0)==p)){f=ZT(40)|0;k[f>>2]=1;s=f+4|0;k[y>>2]=s;k[b>>2]=33;i[f+37>>0]=0;t=363233;v=s+33|0;do{i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));Y8(-215,y,363211,362209,455);k[b>>2]=0;k[y>>2]=0;A=k[f>>2]|0;k[f>>2]=A+-1;if((A|0)==1)ggb(k[f+-4>>2]|0)}}else k[q+(m<<2)>>2]=-1;m=m+1|0}while((m|0)<(G|0));l=1;g=q;x=37}else{A=1;a=q;s=0}}else x=37;if((x|0)==37)if((G|0)>0){f=0;do{k[E+(f<<2)>>2]=f;f=f+1|0}while((f|0)!=(G|0));A=l;a=g;s=1}else{A=l;a=g;s=0}k[y>>2]=a;k[y+4>>2]=A;TAa(E,E+(G<<2)|0,y);m=k[E>>2]|0;if((G|0)>1){f=1;g=1;l=m;do{y=l;l=k[E+(g<<2)>>2]|0;x=a+((aa(l,A)|0)<<2)|0;y=a+((aa(y,A)|0)<<2)|0;f=((k[x>>2]|0)!=(k[y>>2]|0)&1)+f|0;g=g+1|0}while((g|0)!=(G|0));q=f}else q=1;f=a+((aa(m,A)|0)<<2)|0;f=~k[f>>2];g=c+4|0;b=k[g>>2]|0;m=k[c>>2]|0;l=b-m>>2;if(q>>>0<=l>>>0){if(q>>>0<l>>>0?(z=m+(q<<2)|0,(b|0)!=(z|0)):0)k[g>>2]=b+(~((b+-4-z|0)>>>2)<<2)}else U1(c,q-l|0);w=(d|0)!=0;do if(w){g=d+4|0;b=k[g>>2]|0;l=k[d>>2]|0;m=b-l>>2;if(q>>>0>m>>>0){U1(d,q-m|0);break}if(q>>>0<m>>>0?(B=l+(q<<2)|0,(b|0)!=(B|0)):0)k[g>>2]=b+(~((b+-4-B|0)>>>2)<<2)}while(0);a:do if(s){t=(F|0)==0;v=d+4|0;e=k[c>>2]|0;if(!w)if(t){j=0;h=-1;l=0;while(1){g=a+((aa(k[E+(l<<2)>>2]|0,A)|0)<<2)|0;g=k[g>>2]|0;if((g|0)!=(f|0)){h=h+1|0;k[e+(h<<2)>>2]=g;j=l;f=g}l=l+1|0;if((l|0)==(G|0)){C=G;break a}}}else{j=0;h=-1;b=0;while(1){m=E+(b<<2)|0;g=k[m>>2]|0;l=a+((aa(g,A)|0)<<2)|0;l=k[l>>2]|0;if((l|0)!=(f|0)){h=h+1|0;k[e+(h<<2)>>2]=l;j=b;f=l;g=k[m>>2]|0}C=F+((aa(g,D)|0)<<2)|0;k[C>>2]=h;b=b+1|0;if((b|0)==(G|0)){C=G;break a}}}else{l=0;g=-1;q=0}while(1){s=E+(q<<2)|0;m=a+((aa(k[s>>2]|0,A)|0)<<2)|0;m=k[m>>2]|0;if((m|0)!=(f|0)){b=g+1|0;k[e+(b<<2)>>2]=m;if((g|0)>-1){f=k[d>>2]|0;if((k[v>>2]|0)-f>>2>>>0<=g>>>0)break;k[f+(g<<2)>>2]=q-l;l=q;f=m;g=b}else{l=q;f=m;g=b}}if(!t){c=F+((aa(k[s>>2]|0,D)|0)<<2)|0;k[c>>2]=g}q=q+1|0;if((q|0)==(G|0)){j=l;h=g;C=G;break a}}ad(426635,426557,315,426658)}else{j=0;h=-1;C=0}while(0);if(!w){r=H;return}f=k[d>>2]|0;if((k[d+4>>2]|0)-f>>2>>>0<=h>>>0)ad(426635,426557,315,426658);k[f+(h<<2)>>2]=C-j;r=H;return}function RAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+4|0;c=k[l>>2]|0;m=k[a>>2]|0;f=c-m>>3;d=f+1|0;if(d>>>0>536870911)ad(426534,426557,304,426811);j=m;h=c;i=a+8|0;g=(k[i>>2]|0)-m|0;e=g>>2;e=g>>3>>>0<268435455?(e>>>0<d>>>0?d:e):536870911;if(!e)d=0;else{if(e>>>0>536870911){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c}c=d+(f<<3)|0;g=d+(e<<3)|0;k[c>>2]=k[b>>2];k[d+(f<<3)+4>>2]=k[b+4>>2];f=c+8|0;if((h|0)!=(j|0)){b=h+-8|0;d=h;e=c;while(1){h=d;d=d+-8|0;k[e+-8>>2]=k[d>>2];k[e+-4>>2]=k[h+-4>>2];if((d|0)==(j|0))break;else e=e+-8|0}c=c+(~((b-m|0)>>>3)<<3)|0}k[a>>2]=c;k[l>>2]=f;k[i>>2]=g;if(!m)return;ggb(m);return}function SAa(a){a=a|0;if(!a)return;else{SAa(k[a>>2]|0);SAa(k[a+4>>2]|0);ggb(a);return}}function TAa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=c+4|0;a:while(1){o=b;s=b+-4|0;while(1){t=a;b:while(1){n=t;a=o-n|0;d=a>>2;switch(d|0){case 2:{r=5;break a}case 3:{r=7;break a}case 4:{r=15;break a}case 5:{r=16;break a}case 1:case 0:{r=78;break a}default:{}}if((a|0)<124){r=18;break a}l=t+(((d|0)/2|0)<<2)|0;do if((a|0)<=3996){a=k[l>>2]|0;f=k[t>>2]|0;e=k[u>>2]|0;j=aa(e,a)|0;g=k[c>>2]|0;j=k[g+(j<<2)>>2]|0;m=g+((aa(e,f)|0)<<2)|0;d=k[s>>2]|0;e=g+((aa(d,e)|0)<<2)|0;e=(k[e>>2]|0)<(j|0);if((j|0)>=(k[m>>2]|0)){if(!e){a=0;d=g;break}k[l>>2]=d;k[s>>2]=a;a=k[l>>2]|0;d=k[t>>2]|0;m=k[u>>2]|0;j=g+((aa(m,a)|0)<<2)|0;m=g+((aa(m,d)|0)<<2)|0;if((k[j>>2]|0)>=(k[m>>2]|0)){a=1;d=g;break}k[t>>2]=a;k[l>>2]=d;a=2;d=g;break}if(e){k[t>>2]=d;k[s>>2]=f;a=1;d=g;break}k[t>>2]=a;k[l>>2]=f;a=k[s>>2]|0;m=k[u>>2]|0;j=g+((aa(m,a)|0)<<2)|0;m=g+((aa(m,f)|0)<<2)|0;if((k[j>>2]|0)<(k[m>>2]|0)){k[l>>2]=a;k[s>>2]=f;a=2;d=g}else{a=1;d=g}}else{a=(d|0)/4|0;a=VAa(t,t+(a<<2)|0,l,l+(a<<2)|0,s,c)|0;d=k[c>>2]|0}while(0);g=k[t>>2]|0;j=k[u>>2]|0;h=aa(j,g)|0;e=aa(j,k[l>>2]|0)|0;if((k[d+(h<<2)>>2]|0)<(k[d+(e<<2)>>2]|0)){e=s;break}i=k[c>>2]|0;d=i+(e<<2)|0;e=s;while(1){e=e+-4|0;if((t|0)==(e|0))break;f=k[e>>2]|0;m=i+((aa(j,f)|0)<<2)|0;if((k[m>>2]|0)<(k[d>>2]|0)){r=60;break b}}a=t+4|0;f=k[s>>2]|0;e=k[i+(h<<2)>>2]|0;n=i+((aa(j,f)|0)<<2)|0;if((e|0)>=(k[n>>2]|0)){if((a|0)==(s|0)){r=78;break a}while(1){d=k[a>>2]|0;n=i+((aa(j,d)|0)<<2)|0;if((e|0)<(k[n>>2]|0))break;a=a+4|0;if((a|0)==(s|0)){r=78;break a}}k[a>>2]=f;k[s>>2]=d;a=a+4|0}if((a|0)==(s|0)){r=78;break a}j=k[c>>2]|0;d=s;while(1){h=k[u>>2]|0;i=j+((aa(h,k[t>>2]|0)|0)<<2)|0;i=k[i>>2]|0;while(1){f=k[a>>2]|0;n=j+((aa(h,f)|0)<<2)|0;g=a+4|0;if((i|0)<(k[n>>2]|0))break;else a=g}do{d=d+-4|0;e=k[d>>2]|0;n=j+((aa(h,e)|0)<<2)|0}while((i|0)<(k[n>>2]|0));if(a>>>0>=d>>>0){t=a;continue b}k[a>>2]=e;k[d>>2]=f;a=g}}if((r|0)==60){r=0;k[t>>2]=f;k[e>>2]=g;a=a+1|0}f=t+4|0;c:do if(f>>>0<e>>>0){m=k[c>>2]|0;d=l;while(1){j=k[u>>2]|0;l=m+((aa(j,k[d>>2]|0)|0)<<2)|0;l=k[l>>2]|0;while(1){h=k[f>>2]|0;g=m+((aa(j,h)|0)<<2)|0;i=f+4|0;if((k[g>>2]|0)<(l|0))f=i;else break}do{e=e+-4|0;g=k[e>>2]|0;v=m+((aa(j,g)|0)<<2)|0}while((k[v>>2]|0)>=(l|0));if(f>>>0>e>>>0){e=f;break c}k[f>>2]=g;k[e>>2]=h;d=(d|0)==(f|0)?e:d;f=i;a=a+1|0}}else{d=l;e=f}while(0);if((e|0)!=(d|0)?(p=k[d>>2]|0,q=k[e>>2]|0,v=k[u>>2]|0,m=aa(v,p)|0,l=k[c>>2]|0,v=l+((aa(v,q)|0)<<2)|0,(k[l+(m<<2)>>2]|0)<(k[v>>2]|0)):0){k[e>>2]=p;k[d>>2]=q;a=a+1|0}if(!a){d=WAa(t,e,c)|0;a=e+4|0;if(WAa(a,b,c)|0){r=77;break}if(d)continue}v=e;if((v-n|0)>=(o-v|0)){r=76;break}TAa(t,e,c);a=e+4|0}if((r|0)==76){r=0;TAa(e+4|0,b,c);a=t;b=e;continue}else if((r|0)==77){r=0;if(d){r=78;break}else{a=t;b=e;continue}}}if((r|0)==5){b=k[s>>2]|0;a=k[t>>2]|0;v=k[u>>2]|0;u=aa(v,b)|0;c=k[c>>2]|0;v=c+((aa(v,a)|0)<<2)|0;if((k[c+(u<<2)>>2]|0)>=(k[v>>2]|0))return;k[t>>2]=b;k[s>>2]=a;return}else if((r|0)==7){g=t+4|0;d=k[g>>2]|0;e=k[t>>2]|0;b=k[u>>2]|0;v=aa(b,d)|0;f=k[c>>2]|0;c=k[f+(v<<2)>>2]|0;v=f+((aa(b,e)|0)<<2)|0;a=k[s>>2]|0;b=f+((aa(a,b)|0)<<2)|0;b=(k[b>>2]|0)<(c|0);if((c|0)>=(k[v>>2]|0)){if(!b)return;k[g>>2]=a;k[s>>2]=d;a=k[g>>2]|0;b=k[t>>2]|0;v=k[u>>2]|0;u=f+((aa(v,a)|0)<<2)|0;v=f+((aa(v,b)|0)<<2)|0;if((k[u>>2]|0)>=(k[v>>2]|0))return;k[t>>2]=a;k[g>>2]=b;return}if(b){k[t>>2]=a;k[s>>2]=e;return}k[t>>2]=d;k[g>>2]=e;a=k[s>>2]|0;v=k[u>>2]|0;u=f+((aa(v,a)|0)<<2)|0;v=f+((aa(v,e)|0)<<2)|0;if((k[u>>2]|0)>=(k[v>>2]|0))return;k[g>>2]=a;k[s>>2]=e;return}else if((r|0)==15){UAa(t,t+4|0,t+8|0,s,c)|0;return}else if((r|0)==16){VAa(t,t+4|0,t+8|0,t+12|0,s,c)|0;return}else if((r|0)==18){a=t+8|0;d=t+4|0;f=k[d>>2]|0;e=k[t>>2]|0;i=k[u>>2]|0;s=aa(i,f)|0;g=k[c>>2]|0;s=k[g+(s<<2)>>2]|0;v=g+((aa(i,e)|0)<<2)|0;h=k[a>>2]|0;i=g+((aa(h,i)|0)<<2)|0;i=(k[i>>2]|0)<(s|0);do if((s|0)<(k[v>>2]|0)){if(i){k[t>>2]=h;k[a>>2]=e;f=e;break}k[t>>2]=f;k[d>>2]=e;v=k[u>>2]|0;s=g+((aa(v,h)|0)<<2)|0;v=g+((aa(v,e)|0)<<2)|0;if((k[s>>2]|0)<(k[v>>2]|0)){k[d>>2]=h;k[a>>2]=e;f=e}else f=h}else if(i){k[d>>2]=h;k[a>>2]=f;v=k[u>>2]|0;s=g+((aa(v,h)|0)<<2)|0;v=g+((aa(v,e)|0)<<2)|0;if((k[s>>2]|0)<(k[v>>2]|0)){k[t>>2]=h;k[d>>2]=e}}else f=h;while(0);d=t+12|0;if((d|0)==(b|0))return;h=k[c>>2]|0;while(1){g=k[d>>2]|0;v=k[u>>2]|0;c=h+((aa(v,g)|0)<<2)|0;v=h+((aa(v,f)|0)<<2)|0;if((k[c>>2]|0)<(k[v>>2]|0)){e=d;while(1){k[e>>2]=f;if((a|0)==(t|0)){a=t;break}e=a+-4|0;f=k[e>>2]|0;v=k[u>>2]|0;c=h+((aa(v,g)|0)<<2)|0;v=h+((aa(v,f)|0)<<2)|0;if((k[c>>2]|0)>=(k[v>>2]|0))break;else{v=a;a=e;e=v}}k[a>>2]=g}a=d+4|0;if((a|0)==(b|0))break;f=k[d>>2]|0;v=d;d=a;a=v}return}else if((r|0)==78)return}function UAa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0;h=k[b>>2]|0;g=k[a>>2]|0;l=e+4|0;f=k[l>>2]|0;m=aa(f,h)|0;j=k[e>>2]|0;m=k[j+(m<<2)>>2]|0;i=j+((aa(f,g)|0)<<2)|0;e=k[c>>2]|0;f=j+((aa(e,f)|0)<<2)|0;f=(k[f>>2]|0)<(m|0);do if((m|0)<(k[i>>2]|0)){if(f){k[a>>2]=e;k[c>>2]=g;i=1;e=g;break}k[a>>2]=h;k[b>>2]=g;e=k[c>>2]|0;m=k[l>>2]|0;i=j+((aa(m,e)|0)<<2)|0;m=j+((aa(m,g)|0)<<2)|0;if((k[i>>2]|0)<(k[m>>2]|0)){k[b>>2]=e;k[c>>2]=g;i=2;e=g}else i=1}else if(f){k[b>>2]=e;k[c>>2]=h;e=k[b>>2]|0;f=k[a>>2]|0;m=k[l>>2]|0;i=j+((aa(m,e)|0)<<2)|0;m=j+((aa(m,f)|0)<<2)|0;if((k[i>>2]|0)<(k[m>>2]|0)){k[a>>2]=e;k[b>>2]=f;i=2;e=k[c>>2]|0}else{i=1;e=h}}else i=0;while(0);f=k[d>>2]|0;m=k[l>>2]|0;h=j+((aa(m,f)|0)<<2)|0;m=j+((aa(m,e)|0)<<2)|0;if((k[h>>2]|0)>=(k[m>>2]|0)){m=i;return m|0}k[c>>2]=f;k[d>>2]=e;e=k[c>>2]|0;f=k[b>>2]|0;m=k[l>>2]|0;d=j+((aa(m,e)|0)<<2)|0;m=j+((aa(m,f)|0)<<2)|0;if((k[d>>2]|0)>=(k[m>>2]|0)){m=i+1|0;return m|0}k[b>>2]=e;k[c>>2]=f;e=k[b>>2]|0;f=k[a>>2]|0;m=k[l>>2]|0;l=j+((aa(m,e)|0)<<2)|0;m=j+((aa(m,f)|0)<<2)|0;if((k[l>>2]|0)>=(k[m>>2]|0)){m=i+2|0;return m|0}k[a>>2]=e;k[b>>2]=f;m=i+3|0;return m|0}function VAa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0;j=UAa(a,b,c,d,f)|0;g=k[e>>2]|0;h=k[d>>2]|0;l=f+4|0;n=k[l>>2]|0;m=aa(n,g)|0;i=k[f>>2]|0;f=i+((aa(n,h)|0)<<2)|0;if((k[i+(m<<2)>>2]|0)>=(k[f>>2]|0)){n=j;return n|0}k[d>>2]=g;k[e>>2]=h;f=k[d>>2]|0;e=k[c>>2]|0;n=k[l>>2]|0;m=i+((aa(n,f)|0)<<2)|0;n=i+((aa(n,e)|0)<<2)|0;if((k[m>>2]|0)>=(k[n>>2]|0)){n=j+1|0;return n|0}k[c>>2]=f;k[d>>2]=e;f=k[c>>2]|0;e=k[b>>2]|0;n=k[l>>2]|0;m=i+((aa(n,f)|0)<<2)|0;n=i+((aa(n,e)|0)<<2)|0;if((k[m>>2]|0)>=(k[n>>2]|0)){n=j+2|0;return n|0}k[b>>2]=f;k[c>>2]=e;f=k[b>>2]|0;e=k[a>>2]|0;n=k[l>>2]|0;m=i+((aa(n,f)|0)<<2)|0;n=i+((aa(n,e)|0)<<2)|0;if((k[m>>2]|0)>=(k[n>>2]|0)){n=j+3|0;return n|0}k[a>>2]=f;k[b>>2]=e;n=j+4|0;return n|0}function WAa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=k[d>>2]|0;f=k[a>>2]|0;b=k[c+4>>2]|0;l=aa(b,e)|0;c=k[c>>2]|0;b=c+((aa(b,f)|0)<<2)|0;if((k[c+(l<<2)>>2]|0)>=(k[b>>2]|0)){a=1;return a|0}k[a>>2]=e;k[d>>2]=f;a=1;return a|0}case 3:{l=a+4|0;g=b+-4|0;f=k[l>>2]|0;h=k[a>>2]|0;j=c+4|0;e=k[j>>2]|0;b=aa(e,f)|0;i=k[c>>2]|0;c=k[i+(b<<2)>>2]|0;b=i+((aa(e,h)|0)<<2)|0;d=k[g>>2]|0;e=i+((aa(d,e)|0)<<2)|0;e=(k[e>>2]|0)<(c|0);if((c|0)>=(k[b>>2]|0)){if(!e){a=1;return a|0}k[l>>2]=d;k[g>>2]=f;d=k[l>>2]|0;e=k[a>>2]|0;b=k[j>>2]|0;c=i+((aa(b,d)|0)<<2)|0;b=i+((aa(b,e)|0)<<2)|0;if((k[c>>2]|0)>=(k[b>>2]|0)){a=1;return a|0}k[a>>2]=d;k[l>>2]=e;a=1;return a|0}if(e){k[a>>2]=d;k[g>>2]=h;a=1;return a|0}k[a>>2]=f;k[l>>2]=h;d=k[g>>2]|0;a=k[j>>2]|0;b=i+((aa(a,d)|0)<<2)|0;a=i+((aa(a,h)|0)<<2)|0;if((k[b>>2]|0)>=(k[a>>2]|0)){a=1;return a|0}k[l>>2]=d;k[g>>2]=h;a=1;return a|0}case 4:{UAa(a,a+4|0,a+8|0,b+-4|0,c)|0;a=1;return a|0}case 5:{VAa(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{d=a+8|0;e=a+4|0;g=k[e>>2]|0;f=k[a>>2]|0;l=c+4|0;j=k[l>>2]|0;n=aa(j,g)|0;h=k[c>>2]|0;n=k[h+(n<<2)>>2]|0;m=h+((aa(j,f)|0)<<2)|0;i=k[d>>2]|0;j=h+((aa(i,j)|0)<<2)|0;j=(k[j>>2]|0)<(n|0);do if((n|0)<(k[m>>2]|0)){if(j){k[a>>2]=i;k[d>>2]=f;g=f;break}k[a>>2]=g;k[e>>2]=f;n=k[l>>2]|0;m=h+((aa(n,i)|0)<<2)|0;n=h+((aa(n,f)|0)<<2)|0;if((k[m>>2]|0)<(k[n>>2]|0)){k[e>>2]=i;k[d>>2]=f;g=f}else g=i}else if(j){k[e>>2]=i;k[d>>2]=g;n=k[l>>2]|0;m=h+((aa(n,i)|0)<<2)|0;n=h+((aa(n,f)|0)<<2)|0;if((k[m>>2]|0)<(k[n>>2]|0)){k[a>>2]=i;k[e>>2]=f}}else g=i;while(0);e=a+12|0;a:do if((e|0)==(b|0)){e=1;d=0}else{j=k[c>>2]|0;i=e;e=0;while(1){h=k[i>>2]|0;n=k[l>>2]|0;m=j+((aa(n,h)|0)<<2)|0;n=j+((aa(n,g)|0)<<2)|0;if((k[m>>2]|0)<(k[n>>2]|0)){f=i;while(1){k[f>>2]=g;if((d|0)==(a|0)){d=a;break}f=d+-4|0;g=k[f>>2]|0;n=k[l>>2]|0;m=j+((aa(n,h)|0)<<2)|0;n=j+((aa(n,g)|0)<<2)|0;if((k[m>>2]|0)>=(k[n>>2]|0))break;else{n=d;d=f;f=n}}k[d>>2]=h;e=e+1|0;d=i+4|0;if((e|0)==8){e=0;d=(d|0)==(b|0);break a}}else d=i+4|0;if((d|0)==(b|0)){e=1;d=0;break a}g=k[i>>2]|0;n=i;i=d;d=n}}while(0);n=d|e;return n|0}}return 0}function XAa(a){a=a|0;ggb(a);return}function YAa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function ZAa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=91280;b=a+4|0;c=k[b>>2]|0;if(c|0)Qfb(c)|0;k[b>>2]=0;OAa(k[a+856>>2]|0);d=a+832|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+828>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+812|0;c=a+800|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+836>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+840>>2]|0;if(!((b|0)==(a+844|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+776|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+772>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+756|0;c=a+744|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+780>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+784>>2]|0;if(!((b|0)==(a+788|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+720|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+716>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+700|0;c=a+688|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+724>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+728>>2]|0;if(!((b|0)==(a+732|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+664|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+660>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+644|0;c=a+632|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+668>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+672>>2]|0;if(!((b|0)==(a+676|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+608|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+604>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+588|0;c=a+576|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+612>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+616>>2]|0;if(!((b|0)==(a+620|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+552|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+548>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+532|0;c=a+520|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+556>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+560>>2]|0;if(!((b|0)==(a+564|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+496|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+492>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+476|0;c=a+464|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+500>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+504>>2]|0;if(!((b|0)==(a+508|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+440|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+436>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+420|0;c=a+408|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+444>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+448>>2]|0;if(!((b|0)==(a+452|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+384|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+380>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+364|0;c=a+352|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+388>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+392>>2]|0;if(!((b|0)==(a+396|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+328|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+324>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+308|0;c=a+296|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+332>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+336>>2]|0;if(!((b|0)==(a+340|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+272|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+268>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+252|0;c=a+240|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+276>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+280>>2]|0;if(!((b|0)==(a+284|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+216|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+212>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+196|0;c=a+184|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+220>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+224>>2]|0;if(!((b|0)==(a+228|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+160|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+156>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+140|0;c=a+128|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+164>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+168>>2]|0;if(!((b|0)==(a+172|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+104|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+100>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+84|0;c=a+72|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+108>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+112>>2]|0;if(!((b|0)==(a+116|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+48|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+44>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function _Aa(a){a=a|0;ZAa(a);ggb(a);return}function $Aa(a){a=a|0;return k[a+8>>2]|0}function aBa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;if(k[a+420>>2]|0){f=k[a+408>>2]|0;e=(f|0)<3;if(e)b=aa(k[a+416>>2]|0,k[a+412>>2]|0)|0;else{d=k[a+444>>2]|0;c=0;b=1;do{b=aa(k[d+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(f|0))}if(b|0){if(e){f=aa(k[a+416>>2]|0,k[a+412>>2]|0)|0;return f|0}d=k[a+444>>2]|0;c=0;b=1;do{b=aa(k[d+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(f|0));return b|0}}f=Xh[k[(k[a>>2]|0)+20>>2]&1023](a)|0;return f|0}function bBa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;if(!(k[a+476>>2]|0)){f=0;return f|0}f=k[a+464>>2]|0;e=(f|0)<3;if(e)b=aa(k[a+472>>2]|0,k[a+468>>2]|0)|0;else{d=k[a+500>>2]|0;c=0;b=1;do{b=aa(k[d+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(f|0))}if(!b){f=0;return f|0}if(e){f=aa(k[a+472>>2]|0,k[a+468>>2]|0)|0;return f|0}d=k[a+500>>2]|0;c=0;b=1;do{b=aa(k[d+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(f|0));return b|0}function cBa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;if(k[a+364>>2]|0){f=k[a+352>>2]|0;e=(f|0)<3;if(e)b=aa(k[a+360>>2]|0,k[a+356>>2]|0)|0;else{d=k[a+388>>2]|0;c=0;b=1;do{b=aa(k[d+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(f|0))}if(b|0){if(e){f=aa(k[a+360>>2]|0,k[a+356>>2]|0)|0;return f|0}d=k[a+388>>2]|0;c=0;b=1;do{b=aa(k[d+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(f|0));return b|0}}if(!(k[a+8>>2]|0)){f=k[a+20>>2]|0;return f|0}else{f=k[a+24>>2]|0;return f|0}return 0}function dBa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;if(k[a+196>>2]|0){f=k[a+184>>2]|0;e=(f|0)<3;if(e)b=aa(k[a+192>>2]|0,k[a+188>>2]|0)|0;else{d=k[a+220>>2]|0;c=0;b=1;do{b=aa(k[d+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(f|0))}if(b|0){if(e){f=aa(k[a+192>>2]|0,k[a+188>>2]|0)|0;return f|0}d=k[a+220>>2]|0;c=0;b=1;do{b=aa(k[d+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(f|0));return b|0}}f=Xh[k[(k[a>>2]|0)+28>>2]&1023](a)|0;return f|0}function eBa(a){a=a|0;return k[((k[a+8>>2]|0)==0?a+24|0:a+20|0)>>2]|0}function fBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+64|0;t=u+8|0;s=u;if(!((c|0)>-1&(d|0)!=0?(Xh[k[(k[a>>2]|0)+20>>2]&1023](a)|0)>(c|0):0)){e=t+4|0;f=ZT(52)|0;k[f>>2]=1;n=f+4|0;k[t>>2]=n;k[e>>2]=45;i[f+49>>0]=0;o=363613;p=n+45|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,t,363659,362209,948);k[e>>2]=0;k[t>>2]=0;q=k[f>>2]|0;k[f>>2]=q+-1;if((q|0)==1)ggb(k[f+-4>>2]|0)}do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[t>>2]=k[g>>2];m=t+4|0;b=g+4|0;k[m>>2]=k[b>>2];q=t+8|0;k[q>>2]=k[g+8>>2];k[t+12>>2]=k[g+12>>2];k[t+16>>2]=k[g+16>>2];k[t+20>>2]=k[g+20>>2];k[t+24>>2]=k[g+24>>2];k[t+28>>2]=k[g+28>>2];k[t+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[t+36>>2]=e;f=t+40|0;k[f>>2]=q;q=t+48|0;j=t+44|0;k[j>>2]=q;k[t+52>>2]=0;k[q>>2]=0;if(e|0){q=e+12|0;k[q>>2]=(k[q>>2]|0)+1}if((k[b>>2]|0)<3){p=k[g+44>>2]|0;q=k[j>>2]|0;k[q>>2]=k[p>>2];k[q+4>>2]=k[p+4>>2];break}k[m>>2]=0;x1(t,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(t,b,-1);while(0);e=y2(t,1,4,1)|0;q=Xh[k[(k[a>>2]|0)+28>>2]&1023](a)|0;if((e|0)>-1)if(!e)m=0;else m=k[t+16>>2]|0;else{k[s>>2]=0;p=s+4|0;k[p>>2]=0;b=ZT(12)|0;k[b>>2]=1;o=b+4|0;k[s>>2]=o;k[p>>2]=6;i[b+10>>0]=0;i[o>>0]=i[363583]|0;i[o+1>>0]=i[363584]|0;i[o+2>>0]=i[363585]|0;i[o+3>>0]=i[363586]|0;i[o+4>>0]=i[363587]|0;i[o+5>>0]=i[363588]|0;Y8(-215,s,363659,362209,951);k[p>>2]=0;k[s>>2]=0;p=k[b>>2]|0;k[b>>2]=p+-1;if((p|0)==1)ggb(k[b+-4>>2]|0);m=0}l=(e|0)==0?q:e;b=k[a+16>>2]|0;if((b|0)>0)b=k[(k[a+56>>2]|0)+(b+-1<<2)>>2]|0;else b=0;h=((k[a+60>>2]|0)>>>0)/(b>>>0)|0;p=(k[a+8>>2]|0)==0;j=p?1:h;h=(k[a+28>>2]|0)+((aa(p?h:1,c)|0)<<2)|0;a:do if((l|0)>0){e=s+4|0;if(!m){b=0;while(1){s=h+((aa(b,j)|0)<<2)|0;k[d+(b<<2)>>2]=k[s>>2];b=b+1|0;if((b|0)==(l|0))break a}}else b=0;do{f=k[m+(b<<2)>>2]|0;if(!((f|0)>-1&(f|0)<(q|0))){k[s>>2]=0;k[e>>2]=0;g=ZT(24)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[e>>2]=19;i[g+23>>0]=0;o=363669;p=n+19|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,s,363659,362209,967);k[e>>2]=0;k[s>>2]=0;c=k[g>>2]|0;k[g>>2]=c+-1;if((c|0)==1)ggb(k[g+-4>>2]|0)}c=h+((aa(f,j)|0)<<2)|0;k[d+(b<<2)>>2]=k[c>>2];b=b+1|0}while((b|0)<(l|0))}while(0);f=t+36|0;b=k[f>>2]|0;if(b|0?(s=b+12|0,d=k[s>>2]|0,k[s>>2]=d+-1,(d|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[t+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;d=t+16|0;e=t+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[e>>2]|0)>0){f=k[t+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[t+44>>2]|0;if((b|0)==(t+48|0)|(b|0)==0){r=u;return}ggb(k[b+-4>>2]|0);r=u;return}function gBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+12>>2];i=a+4|0;e=b+16|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+20>>2];k[a+12>>2]=k[b+24>>2];k[a+16>>2]=k[b+28>>2];k[a+20>>2]=k[b+32>>2];k[a+24>>2]=k[b+36>>2];k[a+28>>2]=k[b+40>>2];k[a+32>>2]=k[b+44>>2];d=k[b+48>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+56>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+52>>2]|0;a=k[g>>2]|0;e=k[b+56>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function hBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+68>>2];i=a+4|0;e=b+72|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+76>>2];k[a+12>>2]=k[b+80>>2];k[a+16>>2]=k[b+84>>2];k[a+20>>2]=k[b+88>>2];k[a+24>>2]=k[b+92>>2];k[a+28>>2]=k[b+96>>2];k[a+32>>2]=k[b+100>>2];d=k[b+104>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+112>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+108>>2]|0;a=k[g>>2]|0;e=k[b+112>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function iBa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=r;r=r+176|0;z=F+168|0;E=F+112|0;D=F+56|0;B=F;l=b+12|0;n=b+28|0;C=k[n>>2]|0;m=C;o=b+16|0;f=k[o>>2]|0;if(C|0){if((f|0)<3)g=aa(k[b+24>>2]|0,k[b+20>>2]|0)|0;else{i=k[b+52>>2]|0;h=0;g=1;do{g=aa(k[i+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(f|0))}if(g|0){do if(d){if(k[b+420>>2]|0){i=k[b+408>>2]|0;if((i|0)<3)g=aa(k[b+416>>2]|0,k[b+412>>2]|0)|0;else{d=k[b+444>>2]|0;h=0;g=1;do{g=aa(k[d+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(i|0))}if(g|0)break}if(k[b+364>>2]|0){i=k[b+352>>2]|0;if((i|0)<3)g=aa(k[b+360>>2]|0,k[b+356>>2]|0)|0;else{d=k[b+388>>2]|0;h=0;g=1;do{g=aa(k[d+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(i|0))}if(!g)j=27}else j=27}else j=27;while(0);do if((j|0)==27){if(e?k[b+196>>2]|0:0){i=k[b+184>>2]|0;if((i|0)<3)g=aa(k[b+192>>2]|0,k[b+188>>2]|0)|0;else{d=k[b+220>>2]|0;h=0;g=1;do{g=aa(k[d+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(i|0))}if(g|0)break}if((k[b+8>>2]|0)==(c|0)){k[a>>2]=k[l>>2];j=a+4|0;k[j>>2]=f;E=a+8|0;k[E>>2]=k[b+20>>2];k[a+12>>2]=k[b+24>>2];k[a+16>>2]=m;k[a+20>>2]=k[b+32>>2];k[a+24>>2]=k[b+36>>2];k[a+28>>2]=k[b+40>>2];k[a+32>>2]=k[b+44>>2];g=k[b+48>>2]|0;k[a+36>>2]=g;h=a+40|0;k[h>>2]=E;E=a+48|0;e=a+44|0;k[e>>2]=E;k[a+52>>2]=0;k[E>>2]=0;if(g){f=g+12|0;k[f>>2]=(k[f>>2]|0)+1;f=k[o>>2]|0}if((f|0)<3){D=k[b+56>>2]|0;E=k[e>>2]|0;k[E>>2]=k[D>>2];k[E+4>>2]=k[D+4>>2];r=F;return}k[j>>2]=0;x1(a,f,0,0,0);if((k[j>>2]|0)<=0){r=F;return}d=k[b+52>>2]|0;i=k[h>>2]|0;h=k[b+56>>2]|0;g=k[e>>2]|0;f=0;do{k[i+(f<<2)>>2]=k[d+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[j>>2]|0));r=F;return}}while(0);l=Xh[k[(k[b>>2]|0)+12>>2]&1023](b)|0;m=Xh[k[(k[b>>2]|0)+24>>2]&1023](b)|0;jh[k[(k[b>>2]|0)+96>>2]&1023](E,b);jh[k[(k[b>>2]|0)+84>>2]&1023](D,b);y=k[n>>2]|0;j=b+56|0;C=E+16|0;d=k[C>>2]|0;if(!d)f=0;else{h=k[E+4>>2]|0;if((h|0)<3)f=aa(k[E+12>>2]|0,k[E+8>>2]|0)|0;else{i=k[E+40>>2]|0;g=0;f=1;do{f=aa(k[i+(g<<2)>>2]|0,f)|0;g=g+1|0}while((g|0)!=(h|0))}f=(f|0)==0?0:d}A=D+16|0;e=k[A>>2]|0;if(!e)g=0;else{i=k[D+4>>2]|0;if((i|0)<3)g=aa(k[D+12>>2]|0,k[D+8>>2]|0)|0;else{d=k[D+40>>2]|0;h=0;g=1;do{g=aa(k[d+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(i|0))}g=(g|0)==0?0:e}h=g;g=k[o>>2]|0;if((g|0)>0)g=k[(k[j>>2]|0)+(g+-1<<2)>>2]|0;else g=0;p=((k[b+60>>2]|0)>>>0)/(g>>>0)|0;t=(k[b+8>>2]|0)==0;x=t?p:1;p=t?1:p;t=(c|0)==1;s=t?m:l;q=t?l:m;i=t?h:f;h=t?f:h;b=t?p:x;p=t?x:p;k[B>>2]=1124007936;x=B+4|0;t=B+8|0;u=B+40|0;f=x;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[u>>2]=t;w=B+48|0;v=B+44|0;k[v>>2]=w;k[B+52>>2]=0;k[w>>2]=0;k[z>>2]=s;k[z+4>>2]=q;G1(B,2,z,5);do if((s|0)>0){n=B+16|0;m=k[n>>2]|0;c=k[k[v>>2]>>2]|0;l=(q|0)>0;o=(h|0)==0;j=i;f=m;if(!i){i=0;do{d=y+((aa(i,b)|0)<<2)|0;e=m+(aa(c,i)|0)|0;if(l)if(o){g=0;do{z=d+((aa(g,p)|0)<<2)|0;k[e+(g<<2)>>2]=k[z>>2];g=g+1|0}while((g|0)!=(q|0))}else{g=0;do{z=d+((aa(k[h+(g<<2)>>2]|0,p)|0)<<2)|0;k[e+(g<<2)>>2]=k[z>>2];g=g+1|0}while((g|0)!=(q|0))}i=i+1|0}while((i|0)!=(s|0))}else{if(l)i=0;else break;do{d=y+((aa(k[j+(i<<2)>>2]|0,b)|0)<<2)|0;e=m+(aa(c,i)|0)|0;if(o){g=0;do{z=d+((aa(g,p)|0)<<2)|0;k[e+(g<<2)>>2]=k[z>>2];g=g+1|0}while((g|0)!=(q|0))}else{g=0;do{z=d+((aa(k[h+(g<<2)>>2]|0,p)|0)<<2)|0;k[e+(g<<2)>>2]=k[z>>2];g=g+1|0}while((g|0)!=(q|0))}i=i+1|0}while((i|0)!=(s|0))}}else{f=B+16|0;n=f;f=k[f>>2]|0}while(0);k[a>>2]=k[B>>2];j=a+4|0;h=k[x>>2]|0;k[j>>2]=h;e=a+8|0;k[e>>2]=k[t>>2];k[a+12>>2]=k[B+12>>2];k[a+16>>2]=f;k[a+20>>2]=k[B+20>>2];k[a+24>>2]=k[B+24>>2];k[a+28>>2]=k[B+28>>2];l=B+32|0;k[a+32>>2]=k[l>>2];m=B+36|0;f=k[m>>2]|0;k[a+36>>2]=f;g=a+40|0;k[g>>2]=e;B=a+48|0;e=a+44|0;k[e>>2]=B;k[a+52>>2]=0;k[B>>2]=0;if(!f)f=h;else{f=f+12|0;k[f>>2]=(k[f>>2]|0)+1;f=k[x>>2]|0}if((f|0)>=3){k[j>>2]=0;x1(a,f,0,0,0);if((k[j>>2]|0)>0){d=k[u>>2]|0;h=k[g>>2]|0;i=k[v>>2]|0;g=k[e>>2]|0;f=0;do{k[h+(f<<2)>>2]=k[d+(f<<2)>>2];k[g+(f<<2)>>2]=k[i+(f<<2)>>2];f=f+1|0}while((f|0)<(k[j>>2]|0))}}else{B=k[v>>2]|0;a=k[e>>2]|0;k[a>>2]=k[B>>2];k[a+4>>2]=k[B+4>>2]}f=k[m>>2]|0;if(f|0?(B=f+12|0,a=k[B>>2]|0,k[B>>2]=a+-1,(a|0)==1):0){g=k[m>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[l>>2]|0;if(!f){f=B1()|0;g=k[m>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[m>>2]=0}k[m>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[x>>2]|0)>0){g=k[u>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[x>>2]|0))}f=k[v>>2]|0;if(!((f|0)==(w|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=D+36|0;f=k[h>>2]|0;if(f|0?(B=f+12|0,a=k[B>>2]|0,k[B>>2]=a+-1,(a|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[D+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;h=D+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[h>>2]|0)>0){g=k[D+40>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[h>>2]|0))}f=k[D+44>>2]|0;if(!((f|0)==(D+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=E+36|0;f=k[h>>2]|0;if(f|0?(a=f+12|0,D=k[a>>2]|0,k[a>>2]=D+-1,(D|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[E+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;h=E+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[h>>2]|0)>0){g=k[E+40>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[h>>2]|0))}f=k[E+44>>2]|0;if(!((f|0)==(E+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);r=F;return}}k[a>>2]=k[l>>2];j=a+4|0;k[j>>2]=f;E=a+8|0;k[E>>2]=k[b+20>>2];k[a+12>>2]=k[b+24>>2];k[a+16>>2]=m;k[a+20>>2]=k[b+32>>2];k[a+24>>2]=k[b+36>>2];k[a+28>>2]=k[b+40>>2];k[a+32>>2]=k[b+44>>2];g=k[b+48>>2]|0;k[a+36>>2]=g;h=a+40|0;k[h>>2]=E;E=a+48|0;e=a+44|0;k[e>>2]=E;k[a+52>>2]=0;k[E>>2]=0;if(g){f=g+12|0;k[f>>2]=(k[f>>2]|0)+1;f=k[o>>2]|0}if((f|0)<3){D=k[b+56>>2]|0;E=k[e>>2]|0;k[E>>2]=k[D>>2];k[E+4>>2]=k[D+4>>2];r=F;return}k[j>>2]=0;x1(a,f,0,0,0);if((k[j>>2]|0)<=0){r=F;return}d=k[b+52>>2]|0;i=k[h>>2]|0;h=k[b+56>>2]|0;g=k[e>>2]|0;f=0;do{k[i+(f<<2)>>2]=k[d+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[j>>2]|0));r=F;return}function jBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=r;r=r+64|0;d=e;jh[k[(k[b>>2]|0)+96>>2]&1023](d,b);KAa(a,b+236|0,d);c=d+36|0;a=k[c>>2]|0;if(a|0?(a=a+12|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[d+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;c=d+16|0;b=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[b>>2]|0)>0){c=k[d+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[d+44>>2]|0;if((a|0)==(d+48|0)|(a|0)==0){r=e;return}ggb(k[a+-4>>2]|0);r=e;return}function kBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=r;r=r+64|0;d=e;jh[k[(k[b>>2]|0)+96>>2]&1023](d,b);KAa(a,b+684|0,d);c=d+36|0;a=k[c>>2]|0;if(a|0?(a=a+12|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[d+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;c=d+16|0;b=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[b>>2]|0)>0){c=k[d+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[d+44>>2]|0;if((a|0)==(d+48|0)|(a|0)==0){r=e;return}ggb(k[a+-4>>2]|0);r=e;return}function lBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=r;r=r+64|0;i=j;jh[k[(k[b>>2]|0)+100>>2]&1023](i,b);h=i+16|0;if(k[h>>2]|0){e=k[i+4>>2]|0;if((e|0)<3)c=aa(k[i+12>>2]|0,k[i+8>>2]|0)|0;else{f=k[i+40>>2]|0;d=0;c=1;do{c=aa(k[f+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(e|0))}if(c)KAa(a,b+236|0,i);else g=7}else g=7;if((g|0)==7){k[a>>2]=1124007936;c=a+8|0;d=a+40|0;e=a+4|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;g=a+48|0;k[a+44>>2]=g;k[a+52>>2]=0;k[g>>2]=0}e=i+36|0;c=k[e>>2]|0;if(c|0?(g=c+12|0,a=k[g>>2]|0,k[g>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[i+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=i+4|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[e>>2]|0)>0){d=k[i+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[i+44>>2]|0;if((c|0)==(i+48|0)|(c|0)==0){r=j;return}ggb(k[c+-4>>2]|0);r=j;return}function mBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=r;r=r+64|0;i=j;jh[k[(k[b>>2]|0)+100>>2]&1023](i,b);h=i+16|0;if(k[h>>2]|0){e=k[i+4>>2]|0;if((e|0)<3)c=aa(k[i+12>>2]|0,k[i+8>>2]|0)|0;else{f=k[i+40>>2]|0;d=0;c=1;do{c=aa(k[f+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(e|0))}if(c)KAa(a,b+684|0,i);else g=7}else g=7;if((g|0)==7){k[a>>2]=1124007936;c=a+8|0;d=a+40|0;e=a+4|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;g=a+48|0;k[a+44>>2]=g;k[a+52>>2]=0;k[g>>2]=0}e=i+36|0;c=k[e>>2]|0;if(c|0?(g=c+12|0,a=k[g>>2]|0,k[g>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[i+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=i+4|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[e>>2]|0)>0){d=k[i+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[i+44>>2]|0;if((c|0)==(i+48|0)|(c|0)==0){r=j;return}ggb(k[c+-4>>2]|0);r=j;return}function nBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+236>>2];i=a+4|0;e=b+240|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+244>>2];k[a+12>>2]=k[b+248>>2];k[a+16>>2]=k[b+252>>2];k[a+20>>2]=k[b+256>>2];k[a+24>>2]=k[b+260>>2];k[a+28>>2]=k[b+264>>2];k[a+32>>2]=k[b+268>>2];d=k[b+272>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+280>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+276>>2]|0;a=k[g>>2]|0;e=k[b+280>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function oBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+684>>2];i=a+4|0;e=b+688|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+692>>2];k[a+12>>2]=k[b+696>>2];k[a+16>>2]=k[b+700>>2];k[a+20>>2]=k[b+704>>2];k[a+24>>2]=k[b+708>>2];k[a+28>>2]=k[b+712>>2];k[a+32>>2]=k[b+716>>2];d=k[b+720>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+728>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+724>>2]|0;a=k[g>>2]|0;e=k[b+728>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function pBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+516>>2];i=a+4|0;e=b+520|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+524>>2];k[a+12>>2]=k[b+528>>2];k[a+16>>2]=k[b+532>>2];k[a+20>>2]=k[b+536>>2];k[a+24>>2]=k[b+540>>2];k[a+28>>2]=k[b+544>>2];k[a+32>>2]=k[b+548>>2];d=k[b+552>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+560>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+556>>2]|0;a=k[g>>2]|0;e=k[b+560>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function qBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=r;r=r+64|0;d=e;jh[k[(k[b>>2]|0)+96>>2]&1023](d,b);KAa(a,b+516|0,d);c=d+36|0;a=k[c>>2]|0;if(a|0?(a=a+12|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[d+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;c=d+16|0;b=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[b>>2]|0)>0){c=k[d+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[d+44>>2]|0;if((a|0)==(d+48|0)|(a|0)==0){r=e;return}ggb(k[a+-4>>2]|0);r=e;return}function rBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=r;r=r+64|0;i=j;jh[k[(k[b>>2]|0)+100>>2]&1023](i,b);h=i+16|0;if(k[h>>2]|0){e=k[i+4>>2]|0;if((e|0)<3)c=aa(k[i+12>>2]|0,k[i+8>>2]|0)|0;else{f=k[i+40>>2]|0;d=0;c=1;do{c=aa(k[f+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(e|0))}if(c)KAa(a,b+516|0,i);else g=7}else g=7;if((g|0)==7){k[a>>2]=1124007936;c=a+8|0;d=a+40|0;e=a+4|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;g=a+48|0;k[a+44>>2]=g;k[a+52>>2]=0;k[g>>2]=0}e=i+36|0;c=k[e>>2]|0;if(c|0?(g=c+12|0,a=k[g>>2]|0,k[g>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[i+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=i+4|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[e>>2]|0)>0){d=k[i+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[i+44>>2]|0;if((c|0)==(i+48|0)|(c|0)==0){r=j;return}ggb(k[c+-4>>2]|0);r=j;return}function sBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+180>>2];i=a+4|0;e=b+184|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+188>>2];k[a+12>>2]=k[b+192>>2];k[a+16>>2]=k[b+196>>2];k[a+20>>2]=k[b+200>>2];k[a+24>>2]=k[b+204>>2];k[a+28>>2]=k[b+208>>2];k[a+32>>2]=k[b+212>>2];d=k[b+216>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+224>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+220>>2]|0;a=k[g>>2]|0;e=k[b+224>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function tBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+124>>2];i=a+4|0;e=b+128|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+132>>2];k[a+12>>2]=k[b+136>>2];k[a+16>>2]=k[b+140>>2];k[a+20>>2]=k[b+144>>2];k[a+24>>2]=k[b+148>>2];k[a+28>>2]=k[b+152>>2];k[a+32>>2]=k[b+156>>2];d=k[b+160>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+168>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+164>>2]|0;a=k[g>>2]|0;e=k[b+168>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function uBa(a){a=a|0;var b=0,c=0,d=0;if(!(k[a+756>>2]|0)){d=1;d=d&1;d=d^1;return d|0}d=k[a+744>>2]|0;if((d|0)<3)a=aa(k[a+752>>2]|0,k[a+748>>2]|0)|0;else{c=k[a+780>>2]|0;b=0;a=1;do{a=aa(k[c+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(d|0))}d=(a|0)==0;d=d&1;d=d^1;return d|0}function vBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;g=b+404|0;if(k[b+420>>2]|0){f=k[b+408>>2]|0;if((f|0)<3)c=aa(k[b+416>>2]|0,k[b+412>>2]|0)|0;else{e=k[b+444>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0))}if(!c)h=7}else h=7;if((h|0)==7)g=b+348|0;k[a>>2]=k[g>>2];i=a+4|0;d=g+4|0;c=k[d>>2]|0;k[i>>2]=c;b=a+8|0;k[b>>2]=k[g+8>>2];k[a+12>>2]=k[g+12>>2];k[a+16>>2]=k[g+16>>2];k[a+20>>2]=k[g+20>>2];k[a+24>>2]=k[g+24>>2];k[a+28>>2]=k[g+28>>2];k[a+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[a+36>>2]=e;f=a+40|0;k[f>>2]=b;b=a+48|0;h=a+44|0;k[h>>2]=b;k[a+52>>2]=0;k[b>>2]=0;if(e){c=e+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[d>>2]|0}if((c|0)<3){i=k[g+44>>2]|0;a=k[h>>2]|0;k[a>>2]=k[i>>2];k[a+4>>2]=k[i+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;b=k[g+40>>2]|0;f=k[f>>2]|0;e=k[g+44>>2]|0;d=k[h>>2]|0;c=0;do{k[f+(c<<2)>>2]=k[b+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function wBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+460>>2];i=a+4|0;e=b+464|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+468>>2];k[a+12>>2]=k[b+472>>2];k[a+16>>2]=k[b+476>>2];k[a+20>>2]=k[b+480>>2];k[a+24>>2]=k[b+484>>2];k[a+28>>2]=k[b+488>>2];k[a+32>>2]=k[b+492>>2];d=k[b+496>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+504>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+500>>2]|0;a=k[g>>2]|0;e=k[b+504>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function xBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0;y=r;r=r+64|0;x=y+8|0;w=y;do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[x>>2]=k[g>>2];m=x+4|0;c=g+4|0;k[m>>2]=k[c>>2];t=x+8|0;k[t>>2]=k[g+8>>2];k[x+12>>2]=k[g+12>>2];k[x+16>>2]=k[g+16>>2];k[x+20>>2]=k[g+20>>2];k[x+24>>2]=k[g+24>>2];k[x+28>>2]=k[g+28>>2];k[x+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[x+36>>2]=e;f=x+40|0;k[f>>2]=t;t=x+48|0;j=x+44|0;k[j>>2]=t;k[x+52>>2]=0;k[t>>2]=0;if(e|0){t=e+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[c>>2]|0)<3){s=k[g+44>>2]|0;t=k[j>>2]|0;k[t>>2]=k[s>>2];k[t+4>>2]=k[s+4>>2];break}k[m>>2]=0;x1(x,k[c>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;c=0;do{k[h+(c<<2)>>2]=k[l+(c<<2)>>2];k[e+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[m>>2]|0))}}else Q1(x,c,-1);while(0);f=y2(x,1,4,1)|0;t=Xh[k[(k[a>>2]|0)+20>>2]&1023](a)|0;if(!((b|0)>-1?(Xh[k[(k[a>>2]|0)+28>>2]&1023](a)|0)>(b|0):0)){k[w>>2]=0;c=w+4|0;k[c>>2]=0;e=ZT(36)|0;k[e>>2]=1;j=e+4|0;k[w>>2]=j;k[c>>2]=29;i[e+33>>0]=0;l=363543;m=j+29|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,w,363573,362209,874);k[c>>2]=0;k[w>>2]=0;s=k[e>>2]|0;k[e>>2]=s+-1;if((s|0)==1)ggb(k[e+-4>>2]|0)}if((f|0)>-1)if(!f)q=0;else q=k[x+16>>2]|0;else{k[w>>2]=0;s=w+4|0;k[s>>2]=0;c=ZT(12)|0;k[c>>2]=1;q=c+4|0;k[w>>2]=q;k[s>>2]=6;i[c+10>>0]=0;i[q>>0]=i[363583]|0;i[q+1>>0]=i[363584]|0;i[q+2>>0]=i[363585]|0;i[q+3>>0]=i[363586]|0;i[q+4>>0]=i[363587]|0;i[q+5>>0]=i[363588]|0;Y8(-215,w,363573,362209,875);k[s>>2]=0;k[w>>2]=0;s=k[c>>2]|0;k[c>>2]=s+-1;if((s|0)==1)ggb(k[c+-4>>2]|0);q=0}s=(f|0)==0?t:f;c=k[a+16>>2]|0;if((c|0)>0)c=k[(k[a+56>>2]|0)+(c+-1<<2)>>2]|0;else c=0;p=((k[a+60>>2]|0)>>>0)/(c>>>0)|0;m=(k[a+8>>2]|0)==0;n=m?p:1;p=(k[a+28>>2]|0)+((aa(m?1:p,b)|0)<<2)|0;do if((k[a+292>>2]&16384|0)==0?(u=k[a+332>>2]|0,(k[u>>2]|0)!=1):0){c=k[a+308>>2]|0;e=k[a+336>>2]|0;if((k[u+4>>2]|0)==1){c=c+(aa(k[e>>2]|0,b)|0)|0;break}else{u=k[a+304>>2]|0;a=(b|0)/(u|0)|0;u=b-(aa(a,u)|0)|0;c=c+(aa(k[e>>2]|0,a)|0)+(u<<2)|0;break}}else v=25;while(0);if((v|0)==25)c=(k[a+308>>2]|0)+(b<<2)|0;h=k[c>>2]|0;a:do if((s|0)>0){g=w+4|0;if(!q){c=0;while(1){e=p+((aa(c,n)|0)<<2)|0;z=+o[e>>2];e=d+(c<<2)|0;o[e>>2]=z;if(z==3402823466385288598117041.0e14)k[e>>2]=h;c=c+1|0;if((c|0)==(s|0))break a}}else f=0;do{c=k[q+(f<<2)>>2]|0;if(!((c|0)>-1&(c|0)<(t|0))){k[w>>2]=0;k[g>>2]=0;e=ZT(28)|0;k[e>>2]=1;j=e+4|0;k[w>>2]=j;k[g>>2]=22;i[e+26>>0]=0;l=363590;m=j+22|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,w,363573,362209,892);k[g>>2]=0;k[w>>2]=0;v=k[e>>2]|0;k[e>>2]=v+-1;if((v|0)==1)ggb(k[e+-4>>2]|0)}c=p+((aa(c,n)|0)<<2)|0;z=+o[c>>2];c=d+(f<<2)|0;o[c>>2]=z;if(z==3402823466385288598117041.0e14)k[c>>2]=h;f=f+1|0}while((f|0)<(s|0))}while(0);f=x+36|0;c=k[f>>2]|0;if(c|0?(w=c+12|0,d=k[w>>2]|0,k[w>>2]=d+-1,(d|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[x+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;d=x+16|0;e=x+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[e>>2]|0)>0){f=k[x+40>>2]|0;c=0;do{k[f+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[x+44>>2]|0;if((c|0)==(x+48|0)|(c|0)==0){r=y;return}ggb(k[c+-4>>2]|0);r=y;return}function yBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0;s=r;r=r+16|0;n=s;dh[k[(k[a>>2]|0)+104>>2]&255](a,b,c,d);q=F2(c)|0;do if((k[a+628>>2]&16384|0)==0?(g=k[a+668>>2]|0,(k[g>>2]|0)!=1):0){c=k[a+644>>2]|0;f=k[a+672>>2]|0;if((k[g+4>>2]|0)==1){c=c+(aa(k[f>>2]|0,b)|0)|0;break}else{p=k[a+640>>2]|0;m=(b|0)/(p|0)|0;p=b-(aa(m,p)|0)|0;c=c+(aa(k[f>>2]|0,m)|0)+(p<<3)|0;break}}else l=3;while(0);if((l|0)==3)c=(k[a+644>>2]|0)+(b<<3)|0;b=k[c>>2]|0;m=(k[c+4>>2]|0)-b|0;if((m|0)<=0?(p=n+4|0,h=ZT(12)|0,k[h>>2]=1,g=h+4|0,k[n>>2]=g,k[p>>2]=5,i[h+9>>0]=0,i[g>>0]=i[363118]|0,i[g+1>>0]=i[363119]|0,i[g+2>>0]=i[363120]|0,i[g+3>>0]=i[363121]|0,i[g+4>>0]=i[363122]|0,Y8(-215,n,363509,362209,908),k[p>>2]=0,k[n>>2]=0,p=k[h>>2]|0,k[h>>2]=p+-1,(p|0)==1):0)ggb(k[h+-4>>2]|0);do if((k[a+572>>2]&16384|0)==0?(j=k[a+612>>2]|0,(k[j>>2]|0)!=1):0){c=k[a+588>>2]|0;f=k[a+616>>2]|0;if((k[j+4>>2]|0)==1){p=c+(aa(k[f>>2]|0,b)|0)|0;break}else{p=k[a+584>>2]|0;j=(b|0)/(p|0)|0;p=b-(aa(j,p)|0)|0;p=c+(aa(k[f>>2]|0,j)|0)+(p<<2)|0;break}}else l=13;while(0);if((l|0)==13)p=(k[a+588>>2]|0)+(b<<2)|0;f=k[p>>2]|0;c=(q|0)>0;if((m|0)==((k[p+(m+-1<<2)>>2]|0)+1-f|0)){if(!c){r=s;return}l=n+4|0;c=0;while(1){j=d+(c<<2)|0;e=+o[j>>2];b=(o[u>>2]=e,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;e=b?e+-8388608.0+8388608.0:e+8388608.0+-8388608.0;if(e==0.0)e=b?-0.0:0.0}m=~~e;f=m-f|0;if((k[p+(f<<2)>>2]|0)!=(m|0)){b=ZT(24)|0;k[b>>2]=1;g=b+4|0;k[n>>2]=g;k[l>>2]=16;i[b+20>>0]=0;h=363526;a=g+16|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(a|0));Y8(-215,n,363509,362209,918);k[l>>2]=0;k[n>>2]=0;m=k[b>>2]|0;k[b>>2]=m+-1;if((m|0)==1)ggb(k[b+-4>>2]|0)}k[j>>2]=f;c=c+1|0;if((c|0)>=(q|0))break;f=k[p>>2]|0}r=s;return}else{if(c)a=0;else{r=s;return}do{j=d+(a<<2)|0;e=+o[j>>2];c=(o[u>>2]=e,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;e=c?e+-8388608.0+8388608.0:e+8388608.0+-8388608.0;if(e==0.0)e=c?-0.0:0.0}g=~~e;c=-1;f=m;b=0;a:while(1){while(1){if((b|0)>=(f|0))break a;h=f+b>>1;c=k[p+(h<<2)>>2]|0;if((g|0)<(c|0)){c=h;f=h}else break}if((g|0)<=(c|0)){c=h;break}c=h;b=h+1|0}k[j>>2]=c;a=a+1|0}while((a|0)!=(q|0));r=s;return}}function zBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+292>>2];i=a+4|0;e=b+296|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+300>>2];k[a+12>>2]=k[b+304>>2];k[a+16>>2]=k[b+308>>2];k[a+20>>2]=k[b+312>>2];k[a+24>>2]=k[b+316>>2];k[a+28>>2]=k[b+320>>2];k[a+32>>2]=k[b+324>>2];d=k[b+328>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+336>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+332>>2]|0;a=k[g>>2]|0;e=k[b+336>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function ABa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;h=l;e=k[a+632>>2]|0;if((e|0)<3)c=aa(k[a+640>>2]|0,k[a+636>>2]|0)|0;else{f=k[a+668>>2]|0;d=0;c=1;do{c=aa(k[f+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(e|0))}if(!((b|0)>-1&(c|0)>(b|0))){c=h+4|0;d=ZT(24)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=17;i[d+21>>0]=0;f=363479;g=e+17|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,h,363497,362209,199);k[c>>2]=0;k[h>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if((k[a+628>>2]&16384|0)==0?(j=k[a+668>>2]|0,(k[j>>2]|0)!=1):0){c=k[a+644>>2]|0;d=k[a+672>>2]|0;if((k[j+4>>2]|0)==1){b=c+(aa(k[d>>2]|0,b)|0)|0;j=k[b>>2]|0;b=b+4|0;b=k[b>>2]|0;j=b-j|0;r=l;return j|0}else{a=k[a+640>>2]|0;j=(b|0)/(a|0)|0;b=b-(aa(j,a)|0)|0;b=c+(aa(k[d>>2]|0,j)|0)+(b<<3)|0;j=k[b>>2]|0;b=b+4|0;b=k[b>>2]|0;j=b-j|0;r=l;return j|0}}b=(k[a+644>>2]|0)+(b<<3)|0;j=k[b>>2]|0;b=b+4|0;b=k[b>>2]|0;j=b-j|0;r=l;return j|0}function BBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+740>>2];i=a+4|0;e=b+744|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+748>>2];k[a+12>>2]=k[b+752>>2];k[a+16>>2]=k[b+756>>2];k[a+20>>2]=k[b+760>>2];k[a+24>>2]=k[b+764>>2];k[a+28>>2]=k[b+768>>2];k[a+32>>2]=k[b+772>>2];d=k[b+776>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+784>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+780>>2]|0;a=k[g>>2]|0;e=k[b+784>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function CBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+628>>2];i=a+4|0;e=b+632|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+636>>2];k[a+12>>2]=k[b+640>>2];k[a+16>>2]=k[b+644>>2];k[a+20>>2]=k[b+648>>2];k[a+24>>2]=k[b+652>>2];k[a+28>>2]=k[b+656>>2];k[a+32>>2]=k[b+660>>2];d=k[b+664>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+672>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+668>>2]|0;a=k[g>>2]|0;e=k[b+672>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function DBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+572>>2];i=a+4|0;e=b+576|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+580>>2];k[a+12>>2]=k[b+584>>2];k[a+16>>2]=k[b+588>>2];k[a+20>>2]=k[b+592>>2];k[a+24>>2]=k[b+596>>2];k[a+28>>2]=k[b+600>>2];k[a+32>>2]=k[b+604>>2];d=k[b+608>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+616>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+612>>2]|0;a=k[g>>2]|0;e=k[b+616>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function EBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+64|0;s=A+56|0;z=A;y=Xh[k[(k[a>>2]|0)+20>>2]&1023](a)|0;if(!((b|0)>-1&(y|0)>(b|0))){d=s+4|0;e=ZT(36)|0;k[e>>2]=1;g=e+4|0;k[s>>2]=g;k[d>>2]=30;i[e+34>>0]=0;f=363430;h=g+30|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,s,363461,362209,762);k[d>>2]=0;k[s>>2]=0;x=k[e>>2]|0;k[e>>2]=x+-1;if((x|0)==1)ggb(k[e+-4>>2]|0)}o=a+404|0;f=a+440|0;d=k[f>>2]|0;if(d|0?(w=d+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[a+436>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;q=a+420|0;l=a+408|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[l>>2]|0)>0){e=k[a+444>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[l>>2]|0))}j=a+460|0;f=a+496|0;d=k[f>>2]|0;if(d|0?(w=d+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[a+492>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;n=a+476|0;f=a+464|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[f>>2]|0)>0){e=k[a+500>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[f>>2]|0))}if(!b){KG(o,a+348|0)|0;r=A;return}if((y|0)==(b|0)){KG(j,a+348|0)|0;r=A;return}k[z>>2]=1124007936;x=z+4|0;d=z+8|0;v=z+40|0;g=x;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[v>>2]=d;w=z+48|0;u=z+44|0;k[u>>2]=w;k[z+52>>2]=0;k[w>>2]=0;k[s>>2]=1;e=s+4|0;k[e>>2]=y;G1(z,2,s,0);t=z+16|0;p=k[t>>2]|0;m=(y|0)>0;if(m){d=0;do{i[p+d>>0]=(d|0)<(b|0)&1;d=d+1|0}while((d|0)!=(y|0))}if(!(((((k[l>>2]|0)<3?(k[a+412>>2]|0)==1:0)?(k[a+416>>2]|0)==(b|0):0)?(k[o>>2]&4095|0)==4:0)?(k[q>>2]|0)!=0:0)){k[s>>2]=1;k[e>>2]=b;G1(o,2,s,4)}d=y-b|0;if(!(((((k[f>>2]|0)<3?(k[a+468>>2]|0)==1:0)?(k[a+472>>2]|0)==(d|0):0)?(k[j>>2]&4095|0)==4:0)?(k[n>>2]|0)!=0:0)){k[s>>2]=1;k[e>>2]=d;G1(j,2,s,4)}h=k[a+364>>2]|0;if(!h)h=0;else{f=k[a+352>>2]|0;if((f|0)<3)d=aa(k[a+360>>2]|0,k[a+356>>2]|0)|0;else{g=k[a+388>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}h=(d|0)==0?0:h}l=k[q>>2]|0;j=k[n>>2]|0;if(m)if(!h){d=0;e=0;f=0;do{if(!(i[p+f>>0]|0)){k[j+(e<<2)>>2]=f;e=e+1|0}else{k[l+(d<<2)>>2]=f;d=d+1|0}f=f+1|0}while((f|0)!=(y|0))}else{d=0;e=0;g=0;do{f=k[h+(g<<2)>>2]|0;if(!(i[p+g>>0]|0)){k[j+(e<<2)>>2]=f;e=e+1|0}else{k[l+(d<<2)>>2]=f;d=d+1|0}g=g+1|0}while((g|0)!=(y|0))}if(c)Uh[k[(k[a>>2]|0)+140>>2]&2047](a);f=z+36|0;d=k[f>>2]|0;if(d|0?(c=d+12|0,y=k[c>>2]|0,k[c>>2]=y+-1,(y|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[z+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[x>>2]|0)>0){e=k[v>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[x>>2]|0))}d=k[u>>2]|0;if(!((d|0)==(w|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=A;return}function FBa(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;d=l;if(!(b>=0.0&b<=1.0)){e=d+4|0;f=ZT(32)|0;k[f>>2]=1;g=f+4|0;k[d>>2]=g;k[e>>2]=26;i[f+30>>0]=0;h=363380;j=g+26|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,d,363407,362209,755);k[e>>2]=0;k[d>>2]=0;j=k[f>>2]|0;k[f>>2]=j+-1;if((j|0)==1)ggb(k[f+-4>>2]|0)}d=k[a>>2]|0;e=k[d+132>>2]|0;b=+(Xh[k[d+20>>2]&1023](a)|0)*b;p[u>>3]=b;d=k[u+4>>2]|0;j=d&2146435072;if(j>>>0>1126170624|(j|0)==1126170624&0>0){j=~~b;Ph[e&511](a,j,c);r=l;return}d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(!(b==0.0)){j=~~b;Ph[e&511](a,j,c);r=l;return}b=d?-0.0:0.0;j=~~b;Ph[e&511](a,j,c);r=l;return}function GBa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+16|0;t=u;g=a+420|0;if(!(k[g>>2]|0)){r=u;return}d=k[a+408>>2]|0;if((d|0)<3)b=aa(k[a+416>>2]|0,k[a+412>>2]|0)|0;else{e=k[a+444>>2]|0;c=0;b=1;do{b=aa(k[e+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(d|0))}if(!b){r=u;return}f=a+476|0;if(!(k[f>>2]|0)){r=u;return}d=k[a+464>>2]|0;if((d|0)<3)b=aa(k[a+472>>2]|0,k[a+468>>2]|0)|0;else{e=k[a+500>>2]|0;c=0;b=1;do{b=aa(k[e+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(d|0))}if(!b){r=u;return}q=Xh[k[(k[a>>2]|0)+20>>2]&1023](a)|0;s=Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0;p=Xh[k[(k[a>>2]|0)+16>>2]&1023](a)|0;o=k[g>>2]|0;j=k[f>>2]|0;l=n9(c9()|0)|0;if((q|0)<=0){r=u;return}m=t+4|0;n=t+4|0;h=0;do{c=l;g=k[c+4>>2]|0;c=Epb(k[c>>2]|0,0,-130063606,0)|0;g=kpb(c|0,N|0,g|0,0)|0;c=N;b=(g>>>0)%(q>>>0)|0;g=Epb(g|0,0,-130063606,0)|0;c=kpb(g|0,N|0,c|0,0)|0;g=l;k[g>>2]=c;k[g+4>>2]=N;c=(c>>>0)%(q>>>0)|0;if((b|0)>=(s|0)){b=b-s|0;if((b|0)<(p|0))g=j;else{d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[t>>2]=e;k[n>>2]=9;i[d+13>>0]=0;f=363343;a=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(a|0));Y8(-215,t,363353,362209,815);k[n>>2]=0;k[t>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0);g=j}}else g=o;if((c|0)>=(s|0)){c=c-s|0;if((c|0)<(p|0))d=j;else{d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[t>>2]=e;k[m>>2]=9;i[d+13>>0]=0;f=363370;a=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(a|0));Y8(-215,t,363353,362209,821);k[m>>2]=0;k[t>>2]=0;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)==1)ggb(k[d+-4>>2]|0);d=j}}else d=o;f=g+(b<<2)|0;g=d+(c<<2)|0;a=k[f>>2]|0;k[f>>2]=k[g>>2];k[g>>2]=a;h=h+1|0}while((h|0)<(q|0));r=u;return}function HBa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0;while(1){i=fgb(864)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}k[i>>2]=91280;k[i+12>>2]=1124007936;j=i+20|0;l=i+52|0;m=i+16|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=i+60|0;k[i+56>>2]=j;k[i+64>>2]=0;k[j>>2]=0;k[i+68>>2]=1124007936;j=i+76|0;l=i+108|0;m=i+72|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=i+116|0;k[i+112>>2]=j;k[i+120>>2]=0;k[j>>2]=0;k[i+124>>2]=1124007936;j=i+132|0;l=i+164|0;m=i+128|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=i+172|0;k[i+168>>2]=j;k[i+176>>2]=0;k[j>>2]=0;k[i+180>>2]=1124007936;j=i+188|0;l=i+220|0;m=i+184|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=i+228|0;k[i+224>>2]=j;k[i+232>>2]=0;k[j>>2]=0;k[i+236>>2]=1124007936;j=i+244|0;l=i+276|0;m=i+240|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=i+284|0;k[i+280>>2]=j;k[i+288>>2]=0;k[j>>2]=0;k[i+292>>2]=1124007936;j=i+300|0;l=i+332|0;m=i+296|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=i+340|0;k[i+336>>2]=j;k[i+344>>2]=0;k[j>>2]=0;k[i+348>>2]=1124007936;j=i+356|0;l=i+388|0;m=i+352|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=i+396|0;k[i+392>>2]=j;k[i+400>>2]=0;k[j>>2]=0;k[i+404>>2]=1124007936;j=i+412|0;l=i+444|0;m=i+408|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=i+452|0;k[i+448>>2]=j;k[i+456>>2]=0;k[j>>2]=0;k[i+460>>2]=1124007936;j=i+468|0;l=i+500|0;m=i+464|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=i+508|0;k[i+504>>2]=j;k[i+512>>2]=0;k[j>>2]=0;k[i+516>>2]=1124007936;j=i+524|0;l=i+556|0;m=i+520|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=i+564|0;k[i+560>>2]=j;k[i+568>>2]=0;k[j>>2]=0;k[i+572>>2]=1124007936;j=i+580|0;l=i+612|0;m=i+576|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=i+620|0;k[i+616>>2]=j;k[i+624>>2]=0;k[j>>2]=0;k[i+628>>2]=1124007936;j=i+636|0;l=i+668|0;m=i+632|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;l=i+676|0;k[i+672>>2]=l;k[i+680>>2]=0;k[l>>2]=0;k[i+684>>2]=1124007936;l=i+692|0;j=i+724|0;m=i+688|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[j>>2]=l;j=i+732|0;k[i+728>>2]=j;k[i+736>>2]=0;k[j>>2]=0;k[i+740>>2]=1124007936;j=i+748|0;l=i+780|0;m=i+744|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=i+788|0;k[i+784>>2]=j;k[i+792>>2]=0;k[j>>2]=0;k[i+796>>2]=1124007936;j=i+804|0;l=i+836|0;m=i+800|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;n=i+844|0;k[i+840>>2]=n;k[i+848>>2]=0;k[n>>2]=0;n=i+856|0;k[n>>2]=0;k[i+860>>2]=0;k[i+852>>2]=n;k[i+4>>2]=0;LAa(i);while(1){j=fgb(16)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}n=j+4|0;k[n>>2]=1;k[j>>2]=91260;k[j+8>>2]=i;NAa(i,b,c,d,e,f,g,h);k[a>>2]=j;k[a+4>>2]=i;k[n>>2]=(k[n>>2]|0)+1;h=k[n>>2]|0;k[n>>2]=h+-1;if((h|0)!=1)return;Uh[k[(k[j>>2]|0)+8>>2]&2047](j);return}function IBa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;while(1){g=fgb(472)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;Qh[g&7]()}k[g>>2]=91432;d=g+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[g+32>>2]=1124007936;b=g+40|0;c=g+72|0;e=g+36|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;b=g+80|0;k[g+76>>2]=b;k[g+84>>2]=0;k[b>>2]=0;k[g+88>>2]=1124007936;b=g+96|0;c=g+128|0;e=g+92|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;b=g+136|0;k[g+132>>2]=b;k[g+140>>2]=0;k[b>>2]=0;k[g+144>>2]=1124007936;b=g+152|0;c=g+184|0;e=g+148|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;b=g+192|0;k[g+188>>2]=b;k[g+196>>2]=0;k[b>>2]=0;k[g+200>>2]=1124007936;b=g+208|0;c=g+240|0;e=g+204|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;b=g+248|0;k[g+244>>2]=b;k[g+252>>2]=0;k[b>>2]=0;k[g+256>>2]=1124007936;b=g+264|0;c=g+296|0;e=g+260|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;b=g+304|0;k[g+300>>2]=b;k[g+308>>2]=0;k[b>>2]=0;k[g+312>>2]=1124007936;b=g+320|0;c=g+352|0;e=g+316|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;e=g+360|0;k[g+356>>2]=e;b=g+416|0;f=e+56|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[b>>2]=1124007936;b=g+424|0;c=g+456|0;e=g+420|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=g+464|0;k[g+460>>2]=f;k[g+468>>2]=0;k[f>>2]=0;k[g+4>>2]=5;k[g+8>>2]=1;k[d>>2]=3;k[g+20>>2]=100;p[g+24>>3]=1.0e-06;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=b+4|0;k[f>>2]=1;k[b>>2]=91552;k[b+8>>2]=g;k[a>>2]=b;k[a+4>>2]=g;k[f>>2]=(k[f>>2]|0)+1;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)return;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);return}function JBa(a){a=a|0;ggb(a);return}function KBa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function LBa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=91432;d=a+452|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+448>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+432|0;c=a+420|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+456>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+460>>2]|0;if(!((b|0)==(a+464|0)|(b|0)==0))ggb(k[b+-4>>2]|0);zF(a+404|0);zF(a+392|0);zF(a+380|0);zF(a+368|0);d=a+348|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+344>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+328|0;c=a+316|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+352>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+356>>2]|0;if(!((b|0)==(a+360|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+292|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+288>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+272|0;c=a+260|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+296>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+300>>2]|0;if(!((b|0)==(a+304|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+236|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+232>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+216|0;c=a+204|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+240>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+244>>2]|0;if(!((b|0)==(a+248|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+180|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+176>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+160|0;c=a+148|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+184>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+188>>2]|0;if(!((b|0)==(a+192|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+124|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+120>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+104|0;c=a+92|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+128>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+132>>2]|0;if(!((b|0)==(a+136|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+68|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+64>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+48|0;c=a+36|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+72>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+76>>2]|0;if((b|0)==(a+80|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function MBa(a){a=a|0;LBa(a);ggb(a);return}function NBa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;d=a+68|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+64>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+48|0;c=a+36|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+72>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+124|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+120>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+104|0;c=a+92|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+128>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+180|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+176>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+160|0;c=a+148|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+184>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+236|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+232>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+216|0;c=a+204|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+240>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+292|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+288>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+272|0;c=a+260|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+296>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+348|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+344>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+328|0;c=a+316|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+352>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}f=k[a+368>>2]|0;g=a+372|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[b+-24>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));f=k[a+380>>2]|0;g=a+384|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[b+-24>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));f=k[a+404>>2]|0;g=a+408|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[b+-24>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));f=k[a+392>>2]|0;g=a+396|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;do if(c|0){c=c+12|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[b+-24>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));d=a+452|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+448>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+432|0;d=a+420|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[d>>2]|0)<=0)return;c=k[a+456>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0));return}function OBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;f=o;n=o+8|0;e=n+4|0;l=ZT(20)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[e>>2]=15;i[l+19>>0]=0;l=370919;m=j+15|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[e>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);k[n>>2]=0;m=n+4|0;k[m>>2]=0;j=ZT(8)|0;k[j>>2]=1;l=j+4|0;k[n>>2]=l;k[m>>2]=1;i[j+5>>0]=0;i[l>>0]=123;z6(c,n)|0;c=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(c|0?(l=c+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);k[n>>2]=0;e=n+4|0;k[e>>2]=0;l=ZT(16)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[e>>2]=9;i[l+13>>0]=0;l=365296;m=j+9|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[e>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);rCa(c,a+4|0);k[n>>2]=0;d=n+4|0;k[d>>2]=0;l=ZT(20)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[d>>2]=12;i[l+16>>0]=0;l=365306;m=j+12|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));e=z6(b,n)|0;c=k[n>>2]|0;k[d>>2]=0;k[n>>2]=0;if(c|0?(l=c+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);c=k[a+8>>2]|0;switch(c|0){case 0:{k[n>>2]=0;m=n+4|0;k[m>>2]=0;l=ZT(16)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[m>>2]=9;i[l+13>>0]=0;l=365319;m=j+9|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));break}case 1:{k[n>>2]=0;j=n+4|0;k[j>>2]=0;l=ZT(16)|0;k[l>>2]=1;m=l+4|0;k[n>>2]=m;k[j>>2]=8;i[l+12>>0]=0;l=m;i[l>>0]=100;i[l+1>>0]=105;i[l+2>>0]=97;i[l+3>>0]=103;m=m+4|0;i[m>>0]=111;i[m+1>>0]=110;i[m+2>>0]=97;i[m+3>>0]=108;break}case 2:{k[n>>2]=0;j=n+4|0;k[j>>2]=0;l=ZT(12)|0;k[l>>2]=1;m=l+4|0;k[n>>2]=m;k[j>>2]=7;i[l+11>>0]=0;i[m>>0]=i[365338]|0;i[m+1>>0]=i[365339]|0;i[m+2>>0]=i[365340]|0;i[m+3>>0]=i[365341]|0;i[m+4>>0]=i[365342]|0;i[m+5>>0]=i[365343]|0;i[m+6>>0]=i[365344]|0;break}default:{k[f>>2]=c;$8(n,365362,f)}}z6(e,n)|0;c=k[n>>2]|0;k[n+4>>2]=0;k[n>>2]=0;if(c|0?(l=c+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);g=a+16|0;if(k[g>>2]&2|0){k[n>>2]=0;m=n+4|0;k[m>>2]=0;c=ZT(12)|0;k[c>>2]=1;h=c+4|0;k[n>>2]=h;k[m>>2]=7;i[c+11>>0]=0;i[h>>0]=i[370619]|0;i[h+1>>0]=i[370620]|0;i[h+2>>0]=i[370621]|0;i[h+3>>0]=i[370622]|0;i[h+4>>0]=i[370623]|0;i[h+5>>0]=i[370624]|0;i[h+6>>0]=i[370625]|0;h=z6(b,n)|0;c=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(c|0?(l=c+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);e=a+24|0;if(Xh[k[(k[h>>2]|0)+12>>2]&1023](h)|0){f=h+32|0;if((k[f>>2]|0)==6){c=n+4|0;d=ZT(36)|0;k[d>>2]=1;j=d+4|0;k[n>>2]=j;k[c>>2]=30;i[d+34>>0]=0;l=401220;m=j+30|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-2,n,401251,401262,1064);k[c>>2]=0;k[n>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[h+16>>2]|0))c=0;else{c=k[h+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[h+8>>2]|0,c,+p[e>>3]);if(k[f>>2]&4|0)k[f>>2]=6}}if(k[g>>2]&1|0){k[n>>2]=0;e=n+4|0;k[e>>2]=0;l=ZT(16)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[e>>2]=10;i[l+14>>0]=0;l=375191;m=j+10|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[e>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);rCa(c,a+20|0)}k[n>>2]=0;m=n+4|0;k[m>>2]=0;l=ZT(8)|0;k[l>>2]=1;c=l+4|0;k[n>>2]=c;k[m>>2]=1;i[l+5>>0]=0;i[c>>0]=125;z6(b,n)|0;c=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(c|0?(l=c+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);k[n>>2]=0;m=n+4|0;k[m>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[n>>2]=c;k[m>>2]=7;i[d+11>>0]=0;i[c>>0]=i[365283]|0;i[c+1>>0]=i[365284]|0;i[c+2>>0]=i[365285]|0;i[c+3>>0]=i[365286]|0;i[c+4>>0]=i[365287]|0;i[c+5>>0]=i[365288]|0;i[c+6>>0]=i[365289]|0;c=z6(b,n)|0;d=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);qCa(c,a+256|0);k[n>>2]=0;m=n+4|0;k[m>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[n>>2]=c;k[m>>2]=5;i[d+9>>0]=0;i[c>>0]=i[365065]|0;i[c+1>>0]=i[365066]|0;i[c+2>>0]=i[365067]|0;i[c+3>>0]=i[365068]|0;i[c+4>>0]=i[365069]|0;c=z6(b,n)|0;d=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);qCa(c,a+312|0);g=a+368|0;e=(k[a+372>>2]|0)-(k[g>>2]|0)|0;f=(e|0)/56|0;a=n+4|0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[n>>2]=c;k[a>>2]=4;i[d+8>>0]=0;i[c>>0]=99;i[c+1>>0]=111;i[c+2>>0]=118;i[c+3>>0]=115;c=z6(b,n)|0;d=k[n>>2]|0;k[a>>2]=0;k[n>>2]=0;if(d|0?(m=d+-4|0,a=k[m>>2]|0,k[m>>2]=a+-1,(a|0)==1):0)ggb(k[d+-8>>2]|0);a=n+4|0;l=ZT(8)|0;k[l>>2]=1;m=l+4|0;k[n>>2]=m;k[a>>2]=1;i[l+5>>0]=0;i[m>>0]=91;z6(c,n)|0;c=k[n>>2]|0;k[a>>2]=0;k[n>>2]=0;if(c|0?(m=c+-4|0,a=k[m>>2]|0,k[m>>2]=a+-1,(a|0)==1):0)ggb(k[c+-8>>2]|0);if(e|0){c=0;do{qCa(b,(k[g>>2]|0)+(c*56|0)|0);c=c+1|0}while(c>>>0<f>>>0)}a=n+4|0;m=ZT(8)|0;k[m>>2]=1;c=m+4|0;k[n>>2]=c;k[a>>2]=1;i[m+5>>0]=0;i[c>>0]=93;z6(b,n)|0;c=k[n>>2]|0;k[a>>2]=0;k[n>>2]=0;if(!c){r=o;return}b=c+-4|0;n=k[b>>2]|0;k[b>>2]=n+-1;if((n|0)!=1){r=o;return}ggb(k[c+-8>>2]|0);r=o;return}function PBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0,j=0.0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=r;r=r+112|0;F=H+48|0;G=H;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);q=k[b>>2]|0;t=b+4|0;o=k6(q,k[t>>2]|0,370919)|0;c=k6(q,o,365296)|0;a:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break a}case 2:break;default:{c=2147483647;break a}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;E=c&2146435072;if(!(E>>>0>1126170624|(E|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}c=~~e}while(0);k[a+4>>2]=c;l=k6(q,o,365306)|0;k[F>>2]=0;s=F+4|0;k[s>>2]=0;J6(l,F,F);l=k[F>>2]|0;do if((l|0)!=365319){c=(l|0)==0?1016759:l;m=i[c>>0]|0;if(m<<24>>24==115){d=365319;f=c;do{f=f+1|0;d=d+1|0;g=i[f>>0]|0;h=i[d>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){c=0;n=20;break}}if((l|0)!=365329){if(m<<24>>24==100){d=365329;f=c;do{f=f+1|0;d=d+1|0;g=i[f>>0]|0;h=i[d>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){c=1;n=20;break}}if((l|0)!=365338){if(m<<24>>24==103){g=365338;do{c=c+1|0;g=g+1|0;d=i[c>>0]|0;f=i[g>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24));if(d<<24>>24==f<<24>>24){c=2;n=20;break}}k[a+8>>2]=-1;k[G>>2]=0;c=G+4|0;k[c>>2]=0;d=ZT(20)|0;k[d>>2]=1;D=d+4|0;k[G>>2]=D;k[c>>2]=15;i[d+19>>0]=0;f=365346;E=D+15|0;do{i[D>>0]=i[f>>0]|0;D=D+1|0;f=f+1|0}while((D|0)<(E|0));Y8(-215,G,370462,363805,793);k[c>>2]=0;k[G>>2]=0;E=k[d>>2]|0;k[d>>2]=E+-1;if((E|0)==1)ggb(k[d+-4>>2]|0)}else{c=2;n=20}}else{c=1;n=20}}else{c=0;n=20}while(0);if((n|0)==20)k[a+8>>2]=c;c=k6(q,o,370619)|0;b:do if(!c)e=0.0;else switch(k[c>>2]&7){case 1:{e=+(k[c+8>>2]|0);break b}case 2:{e=+p[c+8>>3];break b}default:{e=1.e+300;break b}}while(0);f=e>0.0;j=f?e:0.0;d=f?2:0;f=f?3:1;c=k6(q,o,375191)|0;c:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break c}case 2:break;default:{c=2147483647;break c}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;E=c&2146435072;if(!(E>>>0>1126170624|(E|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}c=~~e}while(0);E=(c|0)>0;k[a+16>>2]=E?f:d;k[a+20>>2]=E?c:0;p[a+24>>3]=j;c=k[F>>2]|0;k[s>>2]=0;k[F>>2]=0;if(c|0?(D=c+-4|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0)ggb(k[c+-8>>2]|0);d=k[b>>2]|0;f=k6(d,k[t>>2]|0,365283)|0;g=a+256|0;k[F>>2]=1124007936;n=F+4|0;c=F+8|0;l=F+40|0;D=n;E=D+36|0;do{k[D>>2]=0;D=D+4|0}while((D|0)<(E|0));k[l>>2]=c;m=F+48|0;h=F+44|0;k[h>>2]=m;k[F+52>>2]=0;k[m>>2]=0;G6(d,f,g,F);f=F+36|0;c=k[f>>2]|0;if(c|0?(D=c+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[F+32>>2]|0;if(!c){c=B1()|0;d=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;E=F+16|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[n>>2]|0)>0){d=k[l>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[n>>2]|0))}c=k[h>>2]|0;if(!((c|0)==(m|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=k[b>>2]|0;f=k6(d,k[t>>2]|0,365065)|0;g=a+312|0;k[F>>2]=1124007936;n=F+4|0;c=F+8|0;l=F+40|0;D=n;E=D+36|0;do{k[D>>2]=0;D=D+4|0}while((D|0)<(E|0));k[l>>2]=c;m=F+48|0;h=F+44|0;k[h>>2]=m;k[F+52>>2]=0;k[m>>2]=0;G6(d,f,g,F);f=F+36|0;c=k[f>>2]|0;if(c|0?(D=c+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[F+32>>2]|0;if(!c){c=B1()|0;d=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;E=F+16|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[n>>2]|0)>0){d=k[l>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[n>>2]|0))}c=k[h>>2]|0;if(!((c|0)==(m|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[b>>2]|0;f=k6(c,k[t>>2]|0,365291)|0;do if((c|0)!=0&(f|0)!=0?(v=k[f>>2]|0,w=v&7,(w|0)!=0):0){k[G>>2]=c;k[G+4>>2]=f;if(!((w+-5|0)>>>0<2&(v&16|0)==0)){k[G+20>>2]=f;k[G+12>>2]=0;k[G+40>>2]=1;n=74;break}c=f+8|0;KY(k[c>>2]|0,G+8|0);d=k[f>>2]|0;switch(d&7){case 6:{c=k[(k[c>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[c>>2]|0)+24>>2]|0;break}default:c=(d&7|0)!=0&1}k[G+40>>2]=c;n=74}else n=73;while(0);if((n|0)==73){k[G>>2]=0;k[G+4>>2]=0;k[G+20>>2]=0;k[G+40>>2]=0;if(!f){c=1;n=78}else n=74}d:do if((n|0)==74){c=k[f>>2]|0;switch(c&7){case 6:{C=k[(k[f+8>>2]|0)+60>>2]|0;break d}case 5:{C=k[(k[f+8>>2]|0)+24>>2]|0;break d}default:{c=(c&7|0)==0;n=78;break d}}}while(0);if((n|0)==78)C=c&1^1;h=a+368|0;Y1(h,C);if((C|0)<=0){jCa(a);lCa(a);r=H;return}l=G+20|0;m=F+4|0;n=F+8|0;o=F+40|0;q=F+48|0;s=F+44|0;b=F+52|0;t=F+36|0;v=F+16|0;w=G+40|0;x=G+12|0;y=G+28|0;z=G+16|0;A=G+24|0;B=F+32|0;g=0;do{c=k[G>>2]|0;d=k[l>>2]|0;f=(k[h>>2]|0)+(g*56|0)|0;k[F>>2]=1124007936;D=m;E=D+36|0;do{k[D>>2]=0;D=D+4|0}while((D|0)<(E|0));k[o>>2]=n;k[s>>2]=q;k[b>>2]=0;k[q>>2]=0;G6(c,d,f,F);c=k[t>>2]|0;if(c|0?(D=c+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){d=k[t>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[B>>2]|0;if(c|0)break;c=B1()|0;d=k[t>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[t>>2]=0}k[t>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[m>>2]|0)>0){d=k[o>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[m>>2]|0))}c=k[s>>2]|0;if(!((c|0)==(q|0)|(c|0)==0))ggb(k[c+-4>>2]|0);g=g+1|0;c=k[w>>2]|0;if(c|0){d=k[x>>2]|0;do if(d|0){E=(k[l>>2]|0)+(k[d+28>>2]|0)|0;k[l>>2]=E;if(E>>>0<(k[y>>2]|0)>>>0)break;E=k[(k[z>>2]|0)+4>>2]|0;k[z>>2]=E;f=k[E+16>>2]|0;k[l>>2]=f;D=k[d+28>>2]|0;E=k[E+12>>2]|0;k[A>>2]=f;E=f+(aa(D,E)|0)|0;k[y>>2]=E}while(0);k[w>>2]=c+-1}}while((g|0)<(C|0));jCa(a);lCa(a);r=H;return}function QBa(a,b){a=a|0;b=b|0;var c=0;c=ZT(20)|0;k[c>>2]=1;b=c+4|0;k[a>>2]=b;k[a+4>>2]=12;i[c+16>>0]=0;a=b;b=365270;c=a+12|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));return}function RBa(a){a=a|0;return k[a+324>>2]|0}function SBa(a){a=a|0;var b=0,c=0,d=0;if(!(k[a+328>>2]|0)){d=0;return d|0}d=k[a+316>>2]|0;if((d|0)<3)a=aa(k[a+324>>2]|0,k[a+320>>2]|0)|0;else{c=k[a+352>>2]|0;b=0;a=1;do{a=aa(k[c+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(d|0))}d=(a|0)!=0;return d|0}function TBa(a){a=a|0;return 1}function UBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=r;r=r+144|0;m=n+88|0;j=n+32|0;e=n+16|0;f=n;l=k[b+4>>2]|0;eh[k[(k[l>>2]|0)+44>>2]&255](m,l,0,1,1);k[j>>2]=1124007936;l=j+4|0;c=j+8|0;h=j+40|0;b=l;d=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(d|0));k[h>>2]=c;i=j+48|0;g=j+44|0;k[g>>2]=i;k[j+52>>2]=0;k[i>>2]=0;d=k[(k[a>>2]|0)+100>>2]|0;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=m;c=f+4|0;b=c+4|0;k[b>>2]=0;k[b+4>>2]=0;k[f>>2]=33619968;k[c>>2]=j;e=$g[d&127](a,e,f,49332,49332)|0;d=j+36|0;c=k[d>>2]|0;if(c|0?(f=c+12|0,a=k[f>>2]|0,k[f>>2]=a+-1,(a|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[j+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;j=j+16|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[l>>2]|0)>0){b=k[h>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[l>>2]|0))}c=k[g>>2]|0;if(!((c|0)==(i|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=m+36|0;c=k[d>>2]|0;if(c|0?(j=c+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[m+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;l=m+16|0;b=m+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[b>>2]|0)>0){d=k[m+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[m+44>>2]|0;if((c|0)==(m+48|0)|(c|0)==0){r=n;return e|0}ggb(k[c+-4>>2]|0);r=n;return e|0}function VBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0.0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;V=r;r=r+304|0;L=V+288|0;M=V+280|0;U=V+224|0;T=V+168|0;S=V+112|0;N=V;K=V+56|0;u=(k[c>>2]&2031616|0)!=0;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[U>>2]=k[f>>2];j=U+4|0;d=f+4|0;k[j>>2]=k[d>>2];l=U+8|0;k[l>>2]=k[f+8>>2];k[U+12>>2]=k[f+12>>2];k[U+16>>2]=k[f+16>>2];k[U+20>>2]=k[f+20>>2];k[U+24>>2]=k[f+24>>2];k[U+28>>2]=k[f+28>>2];k[U+32>>2]=k[f+32>>2];b=k[f+36>>2]|0;k[U+36>>2]=b;e=U+40|0;k[e>>2]=l;R=U+48|0;h=U+44|0;k[h>>2]=R;k[U+52>>2]=0;k[R>>2]=0;if(b|0){R=b+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[d>>2]|0)<3){Q=k[f+44>>2]|0;R=k[h>>2]|0;k[R>>2]=k[Q>>2];k[R+4>>2]=k[Q+4>>2];break}k[j>>2]=0;x1(U,k[d>>2]|0,0,0,0);if((k[j>>2]|0)>0){i=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;b=k[h>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[i+(d<<2)>>2];k[b+(d<<2)>>2]=k[e+(d<<2)>>2];d=d+1|0}while((d|0)<(k[j>>2]|0))}}else{Q1(U,b,-1);l=U+8|0}while(0);k[T>>2]=1124007936;Q=T+4|0;d=T+8|0;O=T+40|0;b=Q;e=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(e|0));k[O>>2]=d;R=T+48|0;P=T+44|0;k[P>>2]=R;k[T+52>>2]=0;k[R>>2]=0;k[S>>2]=1124007936;J=S+4|0;d=S+8|0;H=S+40|0;b=J;e=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(e|0));k[H>>2]=d;I=S+48|0;G=S+44|0;k[G>>2]=I;k[S+52>>2]=0;k[I>>2]=0;e=k[l>>2]|0;if(!u)if((e|0)>1){e=1;d=6;b=16}else{d=6;b=15}else{if((k[c>>2]|0)<0){d=S1(c,-1)|0;b=k[l>>2]|0}else{d=6;b=e}c2(c,b,k[a+4>>2]|0,d,-1,0,0);b=15}if((b|0)==15)if((e|0)>0)b=16;else m=0.0;a:do if((b|0)==16){j=L+4|0;l=M+4|0;c=N+36|0;n=N+16|0;o=N+4|0;q=N+40|0;s=N+44|0;t=N+48|0;w=L+4|0;x=M+4|0;v=u?S:0;y=K+36|0;z=K+16|0;A=K+4|0;B=K+40|0;C=K+44|0;D=K+48|0;E=N+8|0;F=K+32|0;if(!u){h=0;m=0.0;while(1){g=h;h=h+1|0;k[L>>2]=g;k[w>>2]=h;k[M>>2]=-2147483648;k[x>>2]=2147483647;H1(K,U,L,M);mCa(N,a,K,v,d);b=k[y>>2]|0;if(b|0?(t=b+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){f=k[y>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[F>>2]|0;if(!b){b=B1()|0;f=k[y>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[y>>2]=0}k[y>>2]=0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[A>>2]|0)>0){f=k[B>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[A>>2]|0))}b=k[C>>2]|0;if(!((b|0)==(D|0)|(b|0)==0))ggb(k[b+-4>>2]|0);m=(g|0)==0?+p[E>>3]:m;if((h|0)>=(e|0))break a}}i=N+32|0;h=0;m=0.0;do{g=h;h=h+1|0;k[L>>2]=g;k[j>>2]=h;k[M>>2]=-2147483648;k[l>>2]=2147483647;H1(N,T,L,M);KG(S,N)|0;b=k[c>>2]|0;if(b|0?(f=b+12|0,u=k[f>>2]|0,k[f>>2]=u+-1,(u|0)==1):0){f=k[c>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[i>>2]|0;if(!b){b=B1()|0;f=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[c>>2]=0}k[c>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[o>>2]|0)>0){f=k[q>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[o>>2]|0))}b=k[s>>2]|0;if(!((b|0)==(t|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[L>>2]=g;k[w>>2]=h;k[M>>2]=-2147483648;k[x>>2]=2147483647;H1(K,U,L,M);mCa(N,a,K,v,d);b=k[y>>2]|0;if(b|0?(f=b+12|0,u=k[f>>2]|0,k[f>>2]=u+-1,(u|0)==1):0){f=k[y>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[F>>2]|0;if(!b){b=B1()|0;f=k[y>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[y>>2]=0}k[y>>2]=0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[A>>2]|0)>0){f=k[B>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[A>>2]|0))}b=k[C>>2]|0;if(!((b|0)==(D|0)|(b|0)==0))ggb(k[b+-4>>2]|0);m=(g|0)==0?+p[E>>3]:m}while((h|0)<(e|0))}while(0);e=S+36|0;d=k[e>>2]|0;if(d|0?(N=d+12|0,a=k[N>>2]|0,k[N>>2]=a+-1,(a|0)==1):0){b=k[e>>2]|0;if(b|0){d=k[b+4>>2]|0;if(!d){d=k[S+32>>2]|0;if(!d){d=B1()|0;b=k[e>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,b)}k[e>>2]=0}k[e>>2]=0;S=S+16|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[J>>2]|0)>0){b=k[H>>2]|0;d=0;do{k[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[J>>2]|0))}d=k[G>>2]|0;if(!((d|0)==(I|0)|(d|0)==0))ggb(k[d+-4>>2]|0);e=T+36|0;d=k[e>>2]|0;if(d|0?(a=d+12|0,S=k[a>>2]|0,k[a>>2]=S+-1,(S|0)==1):0){b=k[e>>2]|0;if(b|0){d=k[b+4>>2]|0;if(!d){d=k[T+32>>2]|0;if(!d){d=B1()|0;b=k[e>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,b)}k[e>>2]=0}k[e>>2]=0;T=T+16|0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[Q>>2]|0)>0){b=k[O>>2]|0;d=0;do{k[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Q>>2]|0))}d=k[P>>2]|0;if(!((d|0)==(R|0)|(d|0)==0))ggb(k[d+-4>>2]|0);e=U+36|0;d=k[e>>2]|0;if(d|0?(S=d+12|0,T=k[S>>2]|0,k[S>>2]=T+-1,(T|0)==1):0){b=k[e>>2]|0;if(b|0){d=k[b+4>>2]|0;if(!d){d=k[U+32>>2]|0;if(!d){d=B1()|0;b=k[e>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,b)}k[e>>2]=0}k[e>>2]=0;T=U+16|0;b=U+4|0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[b>>2]|0)>0){e=k[U+40>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[b>>2]|0))}d=k[U+44>>2]|0;if((d|0)==(U+48|0)|(d|0)==0){r=V;return +m}ggb(k[d+-4>>2]|0);r=V;return +m}function WBa(a){a=a|0;return k[a+4>>2]|0}function XBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;g=r;r=r+16|0;f=g;k[a+4>>2]=b;if((b|0)>0){r=g;return}a=f+4|0;b=ZT(20)|0;k[b>>2]=1;c=b+4|0;k[f>>2]=c;k[a>>2]=14;i[b+18>>0]=0;d=365237;e=c+14|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,f,365252,363805,64);k[a>>2]=0;k[f>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0);r=g;return}function YBa(a){a=a|0;return k[a+8>>2]|0}function ZBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;g=r;r=r+16|0;f=g;k[a+8>>2]=b;if(b>>>0<3){r=g;return}a=f+4|0;b=ZT(104)|0;k[b>>2]=1;c=b+4|0;k[f>>2]=c;k[a>>2]=98;i[b+102>>0]=0;d=365114;e=c+98|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,f,365213,363805,77);k[a>>2]=0;k[f>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0);r=g;return}function _Ba(a,b){a=a|0;b=b|0;b=b+16|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];return}function $Ba(a,b){a=a|0;b=b|0;a=a+16|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];return}function aCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+256>>2];i=a+4|0;e=b+260|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+264>>2];k[a+12>>2]=k[b+268>>2];k[a+16>>2]=k[b+272>>2];k[a+20>>2]=k[b+276>>2];k[a+24>>2]=k[b+280>>2];k[a+28>>2]=k[b+284>>2];k[a+32>>2]=k[b+288>>2];d=k[b+292>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+300>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+296>>2]|0;a=k[g>>2]|0;e=k[b+300>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function bCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+312>>2];i=a+4|0;e=b+316|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+320>>2];k[a+12>>2]=k[b+324>>2];k[a+16>>2]=k[b+328>>2];k[a+20>>2]=k[b+332>>2];k[a+24>>2]=k[b+336>>2];k[a+28>>2]=k[b+340>>2];k[a+32>>2]=k[b+344>>2];d=k[b+348>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+356>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+352>>2]|0;a=k[g>>2]|0;e=k[b+356>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function cCa(a,b){a=a|0;b=b|0;var c=0,d=0;d=a+368|0;c=a+372|0;Y1(b,((k[c>>2]|0)-(k[d>>2]|0)|0)/56|0);a=k[d>>2]|0;c=k[c>>2]|0;if((a|0)==(c|0))return;b=k[b>>2]|0;while(1){KG(b,a)|0;a=a+56|0;if((a|0)==(c|0))break;else b=b+56|0}return}function dCa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+224|0;y=z+168|0;w=z+112|0;u=z;n=z+56|0;do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[y>>2]=k[g>>2];m=y+4|0;c=g+4|0;k[m>>2]=k[c>>2];x=y+8|0;k[x>>2]=k[g+8>>2];k[y+12>>2]=k[g+12>>2];k[y+16>>2]=k[g+16>>2];k[y+20>>2]=k[g+20>>2];k[y+24>>2]=k[g+24>>2];k[y+28>>2]=k[g+28>>2];k[y+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[y+36>>2]=e;f=y+40|0;k[f>>2]=x;x=y+48|0;j=y+44|0;k[j>>2]=x;k[y+52>>2]=0;k[x>>2]=0;if(e|0){x=e+12|0;k[x>>2]=(k[x>>2]|0)+1}if((k[c>>2]|0)<3){t=k[g+44>>2]|0;x=k[j>>2]|0;k[x>>2]=k[t>>2];k[x+4>>2]=k[t+4>>2];break}k[m>>2]=0;x1(y,k[c>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;c=0;do{k[h+(c<<2)>>2]=k[l+(c<<2)>>2];k[e+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[m>>2]|0))}}else Q1(y,c,-1);while(0);if(!(Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0)){k[w>>2]=0;c=w+4|0;k[c>>2]=0;e=ZT(16)|0;k[e>>2]=1;g=e+4|0;k[w>>2]=g;k[c>>2]=11;i[e+15>>0]=0;f=365077;h=g+11|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,w,365089,363805,192);k[c>>2]=0;k[w>>2]=0;x=k[e>>2]|0;k[e>>2]=x+-1;if((x|0)==1)ggb(k[e+-4>>2]|0)}x=y+16|0;if(k[x>>2]|0){f=k[y+4>>2]|0;if((f|0)<3)c=aa(k[y+12>>2]|0,k[y+8>>2]|0)|0;else{g=k[y+40>>2]|0;e=0;c=1;do{c=aa(k[g+(e<<2)>>2]|0,c)|0;e=e+1|0}while((e|0)!=(f|0))}if(!c)v=20}else v=20;if((v|0)==20){k[w>>2]=0;c=w+4|0;k[c>>2]=0;e=ZT(20)|0;k[e>>2]=1;g=e+4|0;k[w>>2]=g;k[c>>2]=15;i[e+19>>0]=0;f=365098;h=g+15|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,w,365089,363805,194);k[c>>2]=0;k[w>>2]=0;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)ggb(k[e+-4>>2]|0)}if((k[y>>2]&4095|0)!=6){k[w>>2]=1124007936;l=w+4|0;c=w+8|0;j=w+40|0;g=l;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[j>>2]=c;h=w+48|0;g=w+44|0;k[g>>2]=h;k[w+52>>2]=0;k[h>>2]=0;f=u+4|0;c=f+4|0;k[c>>2]=0;k[c+4>>2]=0;k[u>>2]=33619968;k[f>>2]=w;SW(y,u,6,1.0,0.0);KG(y,w)|0;f=w+36|0;c=k[f>>2]|0;if(c|0?(s=c+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[w+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;t=w+16|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[l>>2]|0)>0){e=k[j>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[l>>2]|0))}c=k[g>>2]|0;if(!((c|0)==(h|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}_1(n,y,1,1);f=n+36|0;c=k[f>>2]|0;if(c|0?(s=c+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[n+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;t=n+16|0;e=n+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[e>>2]|0)>0){f=k[n+40>>2]|0;c=0;do{k[f+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[n+44>>2]|0;if(!((c|0)==(n+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);k[w>>2]=1124007936;t=w+4|0;n=w+8|0;p=w+40|0;g=t;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[p>>2]=n;s=w+48|0;q=w+44|0;k[q>>2]=s;k[w+52>>2]=0;k[s>>2]=0;c=k[d>>2]|0;if(c&2031616){if((c|0)<0)o=S1(d,-1)|0;else o=6;c2(d,1,k[b+4>>2]|0,o,-1,0,0);do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[u>>2]=k[g>>2];m=u+4|0;c=g+4|0;k[m>>2]=k[c>>2];d=u+8|0;k[d>>2]=k[g+8>>2];k[u+12>>2]=k[g+12>>2];k[u+16>>2]=k[g+16>>2];k[u+20>>2]=k[g+20>>2];k[u+24>>2]=k[g+24>>2];k[u+28>>2]=k[g+28>>2];k[u+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[u+36>>2]=e;f=u+40|0;k[f>>2]=d;d=u+48|0;j=u+44|0;k[j>>2]=d;k[u+52>>2]=0;k[d>>2]=0;if(e|0){d=e+12|0;k[d>>2]=(k[d>>2]|0)+1}if((k[c>>2]|0)<3){m=k[g+44>>2]|0;d=k[j>>2]|0;k[d>>2]=k[m>>2];k[d+4>>2]=k[m+4>>2];break}k[m>>2]=0;x1(u,k[c>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;c=0;do{k[h+(c<<2)>>2]=k[l+(c<<2)>>2];k[e+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[m>>2]|0))}}else Q1(u,d,-1);while(0);KG(w,u)|0;f=u+36|0;c=k[f>>2]|0;if(c|0?(m=c+12|0,d=k[m>>2]|0,k[m>>2]=d+-1,(d|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[u+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;d=u+16|0;e=u+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[e>>2]|0)>0){f=k[u+40>>2]|0;c=0;do{k[f+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[u+44>>2]|0;if(!((c|0)==(u+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=w+16|0;if(k[e>>2]|0){h=k[t>>2]|0;if((h|0)<3)c=aa(k[w+12>>2]|0,k[n>>2]|0)|0;else{g=k[p>>2]|0;f=0;c=1;do{c=aa(k[g+(f<<2)>>2]|0,c)|0;f=f+1|0}while((f|0)!=(h|0))}if(c){c=o;g=e;e=w}else{c=o;v=83}}else{c=o;v=83}}else{c=6;e=w+16|0;v=83}if((v|0)==83){g=e;e=0}mCa(a,b,y,e,c);f=w+36|0;c=k[f>>2]|0;if(c|0?(b=c+12|0,v=k[b>>2]|0,k[b>>2]=v+-1,(v|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[w+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[t>>2]|0)>0){e=k[p>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[t>>2]|0))}c=k[q>>2]|0;if(!((c|0)==(s|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=y+36|0;c=k[f>>2]|0;if(c|0?(v=c+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;f=y+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[f>>2]|0)>0){e=k[y+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[f>>2]|0))}c=k[y+44>>2]|0;if((c|0)==(y+48|0)|(c|0)==0){r=z;return}ggb(k[c+-4>>2]|0);r=z;return}function eCa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+80|0;n=p+56|0;o=p;do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[o>>2]=k[h>>2];m=o+4|0;b=h+4|0;k[m>>2]=k[b>>2];l=o+8|0;k[l>>2]=k[h+8>>2];k[o+12>>2]=k[h+12>>2];k[o+16>>2]=k[h+16>>2];k[o+20>>2]=k[h+20>>2];k[o+24>>2]=k[h+24>>2];k[o+28>>2]=k[h+28>>2];k[o+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[o+36>>2]=f;g=o+40|0;k[g>>2]=l;l=o+48|0;j=o+44|0;k[j>>2]=l;k[o+52>>2]=0;k[l>>2]=0;if(f|0){l=f+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[b>>2]|0)<3){l=k[h+44>>2]|0;m=k[j>>2]|0;k[m>>2]=k[l>>2];k[m+4>>2]=k[l+4>>2];break}k[m>>2]=0;x1(o,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[h+40>>2]|0;i=k[g>>2]|0;g=k[h+44>>2]|0;f=k[j>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[l+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(o,b,-1);while(0);Uh[k[(k[a>>2]|0)+8>>2]&2047](a);oCa(0,o,k[a+4>>2]|0,k[a+8>>2]|0,0,0,0,0);b=a+32|0;if((k[o>>2]&4095|0)==5)KG(b,o)|0;else{m=n+4|0;l=m+4|0;k[l>>2]=0;k[l+4>>2]=0;k[n>>2]=33619968;k[m>>2]=b;SW(o,n,5,1.0,0.0)}h=iCa(a,0,c,d,e)|0;g=o+36|0;b=k[g>>2]|0;if(b|0?(e=b+12|0,n=k[e>>2]|0,k[e>>2]=n+-1,(n|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[o+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;n=o+16|0;f=o+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[f>>2]|0)>0){g=k[o+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[o+44>>2]|0;if((b|0)==(o+48|0)|(b|0)==0){r=p;return h|0}ggb(k[b+-4>>2]|0);r=p;return h|0}function fCa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+192|0;u=v+128|0;t=v+112|0;s=v+56|0;q=v;do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[u>>2]=k[l>>2];p=u+4|0;b=l+4|0;k[p>>2]=k[b>>2];o=u+8|0;k[o>>2]=k[l+8>>2];k[u+12>>2]=k[l+12>>2];k[u+16>>2]=k[l+16>>2];k[u+20>>2]=k[l+20>>2];k[u+24>>2]=k[l+24>>2];k[u+28>>2]=k[l+28>>2];k[u+32>>2]=k[l+32>>2];i=k[l+36>>2]|0;k[u+36>>2]=i;j=u+40|0;k[j>>2]=o;o=u+48|0;n=u+44|0;k[n>>2]=o;k[u+52>>2]=0;k[o>>2]=0;if(i|0){o=i+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[b>>2]|0)<3){o=k[l+44>>2]|0;p=k[n>>2]|0;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];break}k[p>>2]=0;x1(u,k[b>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;i=k[n>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[o+(b<<2)>>2];k[i+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0))}}else Q1(u,b,-1);while(0);k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;B2(d,t);do if((k[c>>2]&2031616|0)==65536){m=k[c+4>>2]|0;k[s>>2]=k[m>>2];p=s+4|0;i=m+4|0;k[p>>2]=k[i>>2];o=s+8|0;k[o>>2]=k[m+8>>2];k[s+12>>2]=k[m+12>>2];k[s+16>>2]=k[m+16>>2];k[s+20>>2]=k[m+20>>2];k[s+24>>2]=k[m+24>>2];k[s+28>>2]=k[m+28>>2];k[s+32>>2]=k[m+32>>2];b=k[m+36>>2]|0;k[s+36>>2]=b;j=s+40|0;k[j>>2]=o;o=s+48|0;n=s+44|0;k[n>>2]=o;k[s+52>>2]=0;k[o>>2]=0;if(b|0){o=b+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[i>>2]|0)<3){o=k[m+44>>2]|0;p=k[n>>2]|0;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];break}k[p>>2]=0;x1(s,k[i>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[m+40>>2]|0;l=k[j>>2]|0;j=k[m+44>>2]|0;i=k[n>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[o+(b<<2)>>2];k[i+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0))}}else Q1(s,c,-1);while(0);do if((k[e>>2]&2031616|0)==65536){l=k[e+4>>2]|0;k[q>>2]=k[l>>2];p=q+4|0;b=l+4|0;k[p>>2]=k[b>>2];o=q+8|0;k[o>>2]=k[l+8>>2];k[q+12>>2]=k[l+12>>2];k[q+16>>2]=k[l+16>>2];k[q+20>>2]=k[l+20>>2];k[q+24>>2]=k[l+24>>2];k[q+28>>2]=k[l+28>>2];k[q+32>>2]=k[l+32>>2];i=k[l+36>>2]|0;k[q+36>>2]=i;j=q+40|0;k[j>>2]=o;o=q+48|0;n=q+44|0;k[n>>2]=o;k[q+52>>2]=0;k[o>>2]=0;if(i|0){o=i+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[b>>2]|0)<3){o=k[l+44>>2]|0;p=k[n>>2]|0;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];break}k[p>>2]=0;x1(q,k[b>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;i=k[n>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[o+(b<<2)>>2];k[i+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0))}}else Q1(q,e,-1);while(0);b=G2(c)|0;j=G2(d)|0;l=G2(e)|0;hCa(a,1,u,0,b?0:s,j?0:t,l?0:q);l=iCa(a,1,f,g,h)|0;j=q+36|0;b=k[j>>2]|0;if(b|0?(g=b+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){i=k[j>>2]|0;if(i|0){b=k[i+4>>2]|0;if(!b){b=k[q+32>>2]|0;if(!b){b=B1()|0;i=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,i)}k[j>>2]=0}k[j>>2]=0;h=q+16|0;i=q+4|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[i>>2]|0)>0){j=k[q+40>>2]|0;b=0;do{k[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[i>>2]|0))}b=k[q+44>>2]|0;if(!((b|0)==(q+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);j=s+36|0;b=k[j>>2]|0;if(b|0?(h=b+12|0,q=k[h>>2]|0,k[h>>2]=q+-1,(q|0)==1):0){i=k[j>>2]|0;if(i|0){b=k[i+4>>2]|0;if(!b){b=k[s+32>>2]|0;if(!b){b=B1()|0;i=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,i)}k[j>>2]=0}k[j>>2]=0;q=s+16|0;i=s+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[i>>2]|0)>0){j=k[s+40>>2]|0;b=0;do{k[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[i>>2]|0))}b=k[s+44>>2]|0;if(!((b|0)==(s+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);zF(t);j=u+36|0;b=k[j>>2]|0;if(b|0?(s=b+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){i=k[j>>2]|0;if(i|0){b=k[i+4>>2]|0;if(!b){b=k[u+32>>2]|0;if(!b){b=B1()|0;i=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,i)}k[j>>2]=0}k[j>>2]=0;t=u+16|0;i=u+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[i>>2]|0)>0){j=k[u+40>>2]|0;b=0;do{k[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[i>>2]|0))}b=k[u+44>>2]|0;if((b|0)==(u+48|0)|(b|0)==0){r=v;return l|0}ggb(k[b+-4>>2]|0);r=v;return l|0}function gCa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+112|0;p=q+56|0;o=q;do if((k[b>>2]&2031616|0)==65536){i=k[b+4>>2]|0;k[p>>2]=k[i>>2];n=p+4|0;b=i+4|0;k[n>>2]=k[b>>2];m=p+8|0;k[m>>2]=k[i+8>>2];k[p+12>>2]=k[i+12>>2];k[p+16>>2]=k[i+16>>2];k[p+20>>2]=k[i+20>>2];k[p+24>>2]=k[i+24>>2];k[p+28>>2]=k[i+28>>2];k[p+32>>2]=k[i+32>>2];g=k[i+36>>2]|0;k[p+36>>2]=g;h=p+40|0;k[h>>2]=m;m=p+48|0;l=p+44|0;k[l>>2]=m;k[p+52>>2]=0;k[m>>2]=0;if(g|0){m=g+12|0;k[m>>2]=(k[m>>2]|0)+1}if((k[b>>2]|0)<3){m=k[i+44>>2]|0;n=k[l>>2]|0;k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];break}k[n>>2]=0;x1(p,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[i+40>>2]|0;j=k[h>>2]|0;h=k[i+44>>2]|0;g=k[l>>2]|0;b=0;do{k[j+(b<<2)>>2]=k[m+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else Q1(p,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){j=k[c+4>>2]|0;k[o>>2]=k[j>>2];n=o+4|0;g=j+4|0;k[n>>2]=k[g>>2];m=o+8|0;k[m>>2]=k[j+8>>2];k[o+12>>2]=k[j+12>>2];k[o+16>>2]=k[j+16>>2];k[o+20>>2]=k[j+20>>2];k[o+24>>2]=k[j+24>>2];k[o+28>>2]=k[j+28>>2];k[o+32>>2]=k[j+32>>2];b=k[j+36>>2]|0;k[o+36>>2]=b;h=o+40|0;k[h>>2]=m;m=o+48|0;l=o+44|0;k[l>>2]=m;k[o+52>>2]=0;k[m>>2]=0;if(b|0){m=b+12|0;k[m>>2]=(k[m>>2]|0)+1}if((k[g>>2]|0)<3){m=k[j+44>>2]|0;n=k[l>>2]|0;k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];break}k[n>>2]=0;x1(o,k[g>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[j+40>>2]|0;i=k[h>>2]|0;h=k[j+44>>2]|0;g=k[l>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[m+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else Q1(o,c,-1);while(0);i=G2(c)|0;hCa(a,2,p,i?0:o,0,0,0);i=iCa(a,2,d,e,f)|0;h=o+36|0;b=k[h>>2]|0;if(b|0?(e=b+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[o+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;f=o+16|0;g=o+4|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[g>>2]|0)>0){h=k[o+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[o+44>>2]|0;if(!((b|0)==(o+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);h=p+36|0;b=k[h>>2]|0;if(b|0?(f=b+12|0,o=k[f>>2]|0,k[f>>2]=o+-1,(o|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[p+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;o=p+16|0;g=p+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[g>>2]|0)>0){h=k[p+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[p+44>>2]|0;if((b|0)==(p+48|0)|(b|0)==0){r=q;return i|0}ggb(k[b+-4>>2]|0);r=q;return i|0}function hCa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+80|0;p=q+56|0;n=q;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);o=a+4|0;oCa(b,c,k[o>>2]|0,k[a+8>>2]|0,d,e,f,g);if(b)if((b|0)==1)m=(f|0)==0|(g|0)==0?5:6;else m=6;else m=5;h=a+32|0;if((k[c>>2]&4095|0)==(m|0))KG(h,c)|0;else{l=p+4|0;j=l+4|0;k[j>>2]=0;k[j+4>>2]=0;k[p>>2]=33619968;k[l>>2]=h;SW(c,p,m,1.0,0.0)}if((b|0)==2&(d|0)!=0){l=a+88|0;j=p+4|0;i=j+4|0;k[i>>2]=0;k[i+4>>2]=0;k[p>>2]=33619968;k[j>>2]=l;SW(d,p,6,1.0,0.0);pCa(l)}l=(g|0)!=0;b=(b|0)==1;i=(f|0)!=0;if(i&(b&l)){j=a+256|0;d=p+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[p>>2]=33619968;k[d>>2]=j;SW(g,p,6,1.0,0.0);_1(n,j,1,1);d=n+36|0;c=k[d>>2]|0;if(c|0?(h=c+12|0,g=k[h>>2]|0,k[h>>2]=g+-1,(g|0)==1):0){h=k[d>>2]|0;if(h|0){c=k[h+4>>2]|0;if(!c){c=k[n+32>>2]|0;if(!c){c=B1()|0;h=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,h)}k[d>>2]=0}k[d>>2]=0;g=n+16|0;h=n+4|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[h>>2]|0)>0){d=k[n+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[n+44>>2]|0;if(!((c|0)==(n+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);pCa(j)}if(b&(e|0)!=0){n=p+4|0;j=n+4|0;k[j>>2]=0;k[j+4>>2]=0;k[p>>2]=33619968;k[n>>2]=a+312;SW(e,p,m,1.0,0.0)}if(!(b&i&l)){r=q;return}i=a+368|0;Y1(i,k[o>>2]|0);g=f+4|0;c=k[f>>2]|0;if((k[g>>2]|0)==(c|0)){r=q;return}d=p+4|0;b=d+4|0;h=0;do{o=(k[i>>2]|0)+(h*56|0)|0;n=b;k[n>>2]=0;k[n+4>>2]=0;k[p>>2]=33619968;k[d>>2]=o;SW(c+(h*56|0)|0,p,6,1.0,0.0);h=h+1|0;c=k[f>>2]|0}while(h>>>0<(((k[g>>2]|0)-c|0)/56|0)>>>0);r=q;return}function iCa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0.0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0.0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0;Va=r;r=r+496|0;Ra=Va+176|0;Sa=Va+144|0;Ta=Va+432|0;Ua=Va+56|0;Oa=Va+376|0;xa=Va;ya=Va+320|0;za=Va+304|0;Aa=Va+288|0;Ba=Va+232|0;La=Va+112|0;Qa=k[a+44>>2]|0;Ka=(b|0)==2;if(!Ka){b=a+372|0;if((k[a+368>>2]|0)==(k[b>>2]|0)){wa=a+272|0;if(k[wa>>2]|0){h=k[a+260>>2]|0;if((h|0)<3)f=aa(k[a+268>>2]|0,k[a+264>>2]|0)|0;else{j=k[a+296>>2]|0;g=0;f=1;do{f=aa(k[j+(g<<2)>>2]|0,f)|0;g=g+1|0}while((g|0)!=(h|0))}if(f|0){f=Ra+4|0;g=ZT(20)|0;k[g>>2]=1;ma=g+4|0;k[Ra>>2]=ma;k[f>>2]=15;i[g+19>>0]=0;ka=363781;na=ma+15|0;do{i[ma>>0]=i[ka>>0]|0;ma=ma+1|0;ka=ka+1|0}while((ma|0)<(na|0));Y8(-215,Ra,363797,363805,483);k[f>>2]=0;k[Ra>>2]=0;Ja=k[g>>2]|0;k[g>>2]=Ja+-1;if((Ja|0)==1)ggb(k[g+-4>>2]|0)}}sa=a+32|0;ta=k[a+40>>2]|0;k[Ta>>2]=1124007936;Ia=Ta+4|0;f=Ta+8|0;Ga=Ta+40|0;ma=Ia;na=ma+36|0;do{k[ma>>2]=0;ma=ma+4|0}while((ma|0)<(na|0));k[Ga>>2]=f;Ja=Ta+48|0;Ha=Ta+44|0;k[Ha>>2]=Ja;k[Ta+52>>2]=0;k[Ja>>2]=0;k[Ua>>2]=1124007936;Ea=Ua+4|0;f=Ua+8|0;Ca=Ua+40|0;ma=Ea;na=ma+36|0;do{k[ma>>2]=0;ma=ma+4|0}while((ma|0)<(na|0));k[Ca>>2]=f;Fa=Ua+48|0;Da=Ua+44|0;k[Da>>2]=Fa;k[Ua+52>>2]=0;k[Fa>>2]=0;if((k[sa>>2]&4095|0)==5)KG(Ta,sa)|0;else{va=Ra+4|0;ua=va+4|0;k[ua>>2]=0;k[ua+4>>2]=0;k[Ra>>2]=33619968;k[va>>2]=Ta;SW(sa,Ra,5,1.0,0.0)}pa=a+312|0;m=a+328|0;do if(k[m>>2]|0){h=k[a+316>>2]|0;if((h|0)<3)f=aa(k[a+324>>2]|0,k[a+320>>2]|0)|0;else{j=k[a+352>>2]|0;g=0;f=1;do{f=aa(k[j+(g<<2)>>2]|0,f)|0;g=g+1|0}while((g|0)!=(h|0))}if(f|0)if((k[pa>>2]&4095|0)==5){KG(Ua,pa)|0;break}else{va=Ra+4|0;ua=va+4|0;k[ua>>2]=0;k[ua+4>>2]=0;k[Ra>>2]=33619968;k[va>>2]=Ua;SW(pa,Ra,5,1.0,0.0);break}}while(0);k[Oa>>2]=1124007936;ua=Oa+4|0;f=Oa+8|0;qa=Oa+40|0;ma=ua;na=ma+36|0;do{k[ma>>2]=0;ma=ma+4|0}while((ma|0)<(na|0));k[qa>>2]=f;va=Oa+48|0;ra=Oa+44|0;k[ra>>2]=va;k[Oa+52>>2]=0;k[va>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;k[Ra>>2]=16842752;k[Ra+4>>2]=Ta;oa=a+4|0;l=k[oa>>2]|0;na=Sa+4|0;ma=na+4|0;k[ma>>2]=0;k[ma+4>>2]=0;k[Sa>>2]=50397184;k[na>>2]=Oa;if(k[m>>2]|0){h=k[a+316>>2]|0;if((h|0)<3)f=aa(k[a+324>>2]|0,k[a+320>>2]|0)|0;else{j=k[a+352>>2]|0;g=0;f=1;do{f=aa(k[j+(g<<2)>>2]|0,f)|0;g=g+1|0}while((g|0)!=(h|0))}if(f)f=1;else Pa=31}else Pa=31;if((Pa|0)==31)f=10;na=xa+4|0;ma=na+4|0;k[ma>>2]=0;k[ma+4>>2]=0;k[xa>>2]=33619968;k[na>>2]=Ua;+xZ(Ra,l,Sa,1,f,.5,10,2,xa);if((k[Ua>>2]&4095|0)!=5){k[Ra>>2]=0;f=Ra+4|0;k[f>>2]=0;g=ZT(32)|0;k[g>>2]=1;ma=g+4|0;k[Ra>>2]=ma;k[f>>2]=27;i[g+31>>0]=0;ka=364145;na=ma+27|0;do{i[ma>>0]=i[ka>>0]|0;ma=ma+1|0;ka=ka+1|0}while((ma|0)<(na|0));Y8(-215,Ra,364173,363805,420);k[f>>2]=0;k[Ra>>2]=0;na=k[g>>2]|0;k[g>>2]=na+-1;if((na|0)==1)ggb(k[g+-4>>2]|0)}if((k[sa>>2]&4095|0)!=6){k[Ra>>2]=1124007936;n=Ra+4|0;f=Ra+8|0;l=Ra+40|0;ma=n;na=ma+36|0;do{k[ma>>2]=0;ma=ma+4|0}while((ma|0)<(na|0));k[l>>2]=f;m=Ra+48|0;j=Ra+44|0;k[j>>2]=m;k[Ra+52>>2]=0;k[m>>2]=0;h=Sa+4|0;f=h+4|0;k[f>>2]=0;k[f+4>>2]=0;k[Sa>>2]=33619968;k[h>>2]=Ra;SW(Ta,Sa,6,1.0,0.0);KG(sa,Ra)|0;h=Ra+36|0;f=k[h>>2]|0;if(f|0?(ma=f+12|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[Ra+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;na=Ra+16|0;k[na>>2]=0;k[na+4>>2]=0;k[na+8>>2]=0;k[na+12>>2]=0;if((k[n>>2]|0)>0){g=k[l>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[n>>2]|0))}f=k[j>>2]|0;if(!((f|0)==(m|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}la=Ra+4|0;g=la+4|0;k[g>>2]=0;k[g+4>>2]=0;k[Ra>>2]=33619968;k[la>>2]=pa;SW(Ua,Ra,6,1.0,0.0);la=a+256|0;g=k[oa>>2]|0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;k[xa+16>>2]=0;k[xa+20>>2]=0;k[xa+24>>2]=0;k[xa+28>>2]=0;k[Ra>>2]=1124007936;n=Ra+4|0;f=Ra+8|0;l=Ra+40|0;ma=n;na=ma+36|0;do{k[ma>>2]=0;ma=ma+4|0}while((ma|0)<(na|0));k[l>>2]=f;m=Ra+48|0;j=Ra+44|0;k[j>>2]=m;k[Ra+52>>2]=0;k[m>>2]=0;k[Sa>>2]=1;k[Sa+4>>2]=g;G1(Ra,2,Sa,6);oY(Ra,xa);KG(la,Ra)|0;h=Ra+36|0;f=k[h>>2]|0;if(f|0?(ma=f+12|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[Ra+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;na=Ra+16|0;k[na>>2]=0;k[na+4>>2]=0;k[na+8>>2]=0;k[na+12>>2]=0;if((k[n>>2]|0)>0){g=k[l>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[n>>2]|0))}f=k[j>>2]|0;if(!((f|0)==(m|0)|(f|0)==0))ggb(k[f+-4>>2]|0);n=a+368|0;Y1(n,k[oa>>2]|0);if((k[oa>>2]|0)>0){s=xa+4|0;t=xa+8|0;u=xa+40|0;v=xa+48|0;w=xa+44|0;x=xa+52|0;y=(ta|0)>0;z=xa+16|0;A=Ra+4|0;B=ya+8|0;C=ya+12|0;D=ya+4|0;E=za+4|0;F=E+4|0;G=Ra+4|0;H=Sa+4|0;I=Aa+4|0;J=I+4|0;K=Ba+36|0;L=Ba+16|0;M=Ba+4|0;N=Ba+40|0;O=Ba+44|0;Q=Ba+48|0;R=a+296|0;S=a+300|0;T=a+268|0;o=+(ta|0);U=xa+36|0;W=xa+12|0;X=Oa+16|0;Y=Oa+12|0;_=Ra+4|0;$=Sa+4|0;ba=ya+36|0;ca=ya+16|0;da=ya+4|0;ea=ya+40|0;fa=ya+44|0;ga=ya+48|0;ha=xa+32|0;ia=Ba+32|0;ja=ya+32|0;m=0;do{k[xa>>2]=1124007936;ma=s;na=ma+36|0;do{k[ma>>2]=0;ma=ma+4|0}while((ma|0)<(na|0));k[u>>2]=t;k[w>>2]=v;k[x>>2]=0;k[v>>2]=0;if(y){f=0;do{do if(!(k[Oa>>2]&16384)){g=k[qa>>2]|0;if((k[g>>2]|0)==1){Pa=75;break}h=k[X>>2]|0;j=k[ra>>2]|0;if((k[g+4>>2]|0)==1){g=h+(aa(k[j>>2]|0,f)|0)|0;break}else{g=k[Y>>2]|0;na=(f|0)/(g|0)|0;g=f-(aa(na,g)|0)|0;g=h+(aa(k[j>>2]|0,na)|0)+(g<<2)|0;break}}else Pa=75;while(0);if((Pa|0)==75){Pa=0;g=(k[X>>2]|0)+(f<<2)|0}if((k[g>>2]|0)==(m|0)){h=f+1|0;k[Ra>>2]=f;k[_>>2]=h;k[Sa>>2]=-2147483648;k[$>>2]=2147483647;H1(ya,sa,Ra,Sa);L1(xa,ya);f=k[ba>>2]|0;do if(f|0){ma=f+12|0;na=k[ma>>2]|0;k[ma>>2]=na+-1;if((na|0)!=1)break;g=k[ba>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[ja>>2]|0;if(f|0)break;f=B1()|0;g=k[ba>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[ba>>2]=0}while(0);k[ba>>2]=0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;if((k[da>>2]|0)>0){g=k[ea>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[da>>2]|0))}f=k[fa>>2]|0;if(!((f|0)==(ga|0)|(f|0)==0))ggb(k[f+-4>>2]|0);f=h}else f=f+1|0}while((f|0)<(ta|0));if(k[z>>2]|0){h=k[s>>2]|0;if((h|0)<3)f=aa(k[W>>2]|0,k[t>>2]|0)|0;else{j=k[u>>2]|0;g=0;f=1;do{f=aa(k[j+(g<<2)>>2]|0,f)|0;g=g+1|0}while((g|0)!=(h|0))}if(!f)Pa=97}else Pa=97}else Pa=97;if((Pa|0)==97){Pa=0;k[Ra>>2]=0;k[A>>2]=0;f=ZT(28)|0;k[f>>2]=1;ma=f+4|0;k[Ra>>2]=ma;k[A>>2]=23;i[f+27>>0]=0;ka=364193;na=ma+23|0;do{i[ma>>0]=i[ka>>0]|0;ma=ma+1|0;ka=ka+1|0}while((ma|0)<(na|0));Y8(-215,Ra,364173,363805,443);k[A>>2]=0;k[Ra>>2]=0;na=k[f>>2]|0;k[f>>2]=na+-1;if((na|0)==1)ggb(k[f+-4>>2]|0)}k[B>>2]=0;k[C>>2]=0;k[ya>>2]=16842752;k[D>>2]=xa;l=(k[n>>2]|0)+(m*56|0)|0;f=F;k[f>>2]=0;k[f+4>>2]=0;k[za>>2]=33619968;k[E>>2]=l;l=m;m=m+1|0;k[Ra>>2]=l;k[G>>2]=m;k[Sa>>2]=-2147483648;k[H>>2]=2147483647;H1(Ba,pa,Ra,Sa);f=J;k[f>>2]=0;k[f+4>>2]=0;k[Aa>>2]=-1023344640;k[I>>2]=Ba;Z_(ya,za,Aa,15,6);f=k[K>>2]|0;if(f|0?(ma=f+12|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){g=k[K>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[ia>>2]|0;if(f|0)break;f=B1()|0;g=k[K>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[K>>2]=0}k[K>>2]=0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[M>>2]|0)>0){g=k[N>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[M>>2]|0))}f=k[O>>2]|0;if(!((f|0)==(Q|0)|(f|0)==0))ggb(k[f+-4>>2]|0);j=k[t>>2]|0;do if(!(k[la>>2]&16384)){f=k[R>>2]|0;if((k[f>>2]|0)==1){Pa=115;break}g=k[wa>>2]|0;h=k[S>>2]|0;if((k[f+4>>2]|0)==1){f=g+(aa(k[h>>2]|0,l)|0)|0;break}else{f=k[T>>2]|0;na=(l|0)/(f|0)|0;f=l-(aa(na,f)|0)|0;f=g+(aa(k[h>>2]|0,na)|0)+(f<<3)|0;break}}else Pa=115;while(0);if((Pa|0)==115){Pa=0;f=(k[wa>>2]|0)+(l<<3)|0}p[f>>3]=+(j|0)/o;f=k[U>>2]|0;do if(f|0){ma=f+12|0;na=k[ma>>2]|0;k[ma>>2]=na+-1;if((na|0)!=1)break;g=k[U>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[ha>>2]|0;if(f|0)break;f=B1()|0;g=k[U>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[U>>2]=0}while(0);k[U>>2]=0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[s>>2]|0)>0){g=k[u>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[s>>2]|0))}f=k[w>>2]|0;if(!((f|0)==(v|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}while((m|0)<(k[oa>>2]|0))}jCa(a);h=Oa+36|0;f=k[h>>2]|0;if(f|0?(Aa=f+12|0,Ba=k[Aa>>2]|0,k[Aa>>2]=Ba+-1,(Ba|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[Oa+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Ba=Oa+16|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;if((k[ua>>2]|0)>0){g=k[qa>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[ua>>2]|0))}f=k[ra>>2]|0;if(!((f|0)==(va|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=Ua+36|0;f=k[h>>2]|0;if(f|0?(Aa=f+12|0,Ba=k[Aa>>2]|0,k[Aa>>2]=Ba+-1,(Ba|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[Ua+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Ba=Ua+16|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;if((k[Ea>>2]|0)>0){g=k[Ca>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[Ea>>2]|0))}f=k[Da>>2]|0;if(!((f|0)==(Fa|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=Ta+36|0;f=k[h>>2]|0;do if(f|0){Ea=f+12|0;Fa=k[Ea>>2]|0;k[Ea>>2]=Fa+-1;if((Fa|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[Ta+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;Fa=Ta+16|0;k[Fa>>2]=0;k[Fa+4>>2]=0;k[Fa+8>>2]=0;k[Fa+12>>2]=0;if((k[Ia>>2]|0)>0){g=k[Ga>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[Ia>>2]|0))}f=k[Ha>>2]|0;if(!((f|0)==(Ja|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}}else b=a+372|0;ea=a+368|0;if((k[ea>>2]|0)!=(k[b>>2]|0)?(k[a+380>>2]|0)==(k[a+384>>2]|0):0){if((k[a+404>>2]|0)!=(k[a+408>>2]|0)){b=Ra+4|0;f=ZT(32)|0;k[f>>2]=1;ma=f+4|0;k[Ra>>2]=ma;k[b>>2]=26;i[f+30>>0]=0;ka=363864;na=ma+26|0;do{i[ma>>0]=i[ka>>0]|0;ma=ma+1|0;ka=ka+1|0}while((ma|0)<(na|0));Y8(-215,Ra,363797,363805,490);k[b>>2]=0;k[Ra>>2]=0;Ja=k[f>>2]|0;k[f>>2]=Ja+-1;if((Ja|0)==1)ggb(k[f+-4>>2]|0)}jCa(a)}if(Ka)kCa(a);b=k[a+16>>2]|0;if(!(b&1))f=100;else f=k[a+20>>2]|0;if(!(b&2))Z=0.0;else Z=+p[a+24>>3];da=a+144|0;W=Ra+8|0;X=Ra+12|0;Y=Ra+4|0;m=f+-1|0;_=a+88|0;n=a+32|0;s=a+40|0;$=a+4|0;ga=a+92|0;t=a+96|0;u=a+100|0;fa=a+104|0;ba=Sa+4|0;ca=a+200|0;ja=a+204|0;v=a+208|0;w=a+212|0;ha=a+216|0;pa=a+148|0;x=a+152|0;y=a+156|0;la=a+160|0;z=Ra+4|0;A=Sa+4|0;B=Ra+4|0;C=Sa+4|0;D=Oa+36|0;E=Oa+16|0;F=Oa+4|0;G=Oa+40|0;H=Oa+44|0;I=Oa+48|0;oa=a+184|0;J=a+188|0;K=Ua+8|0;ia=a+240|0;L=a+244|0;M=Ta+36|0;N=Ta+16|0;O=Ta+4|0;Q=Ta+40|0;R=Ta+44|0;S=Ta+48|0;T=Ta+32|0;U=Oa+32|0;l=0;V=0.0;while(1){b=k[s>>2]|0;f=k[$>>2]|0;if(!(((((k[ga>>2]|0)<3?(k[t>>2]|0)==(b|0):0)?(k[u>>2]|0)==(f|0):0)?(k[_>>2]&4095|0)==6:0)?(k[fa>>2]|0)!=0:0)){k[Sa>>2]=b;k[ba>>2]=f;G1(_,2,Sa,6);b=k[s>>2]|0}if(!(((((k[ja>>2]|0)<3?(k[v>>2]|0)==(b|0):0)?(k[w>>2]|0)==1:0)?(k[ca>>2]&4095|0)==4:0)?(k[ha>>2]|0)!=0:0)){k[Sa>>2]=b;k[ba>>2]=1;G1(ca,2,Sa,4);b=k[s>>2]|0}if(!(((((k[pa>>2]|0)<3?(k[x>>2]|0)==(b|0):0)?(k[y>>2]|0)==1:0)?(k[da>>2]&4095|0)==6:0)?(k[la>>2]|0)!=0:0)){k[Sa>>2]=b;k[ba>>2]=1;G1(da,2,Sa,6)}lCa(a);if((k[s>>2]|0)>0){j=0;do{h=j;j=j+1|0;k[Ra>>2]=h;k[z>>2]=j;k[Sa>>2]=-2147483648;k[A>>2]=2147483647;H1(Ta,_,Ra,Sa);k[Ra>>2]=h;k[B>>2]=j;k[Sa>>2]=-2147483648;k[C>>2]=2147483647;H1(Oa,n,Ra,Sa);mCa(Ua,a,Oa,Ta,6);b=k[D>>2]|0;if(b|0?(Ja=b+12|0,Ka=k[Ja>>2]|0,k[Ja>>2]=Ka+-1,(Ka|0)==1):0){f=k[D>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[U>>2]|0;if(!b){b=B1()|0;f=k[D>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[D>>2]=0}k[D>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[F>>2]|0)>0){f=k[G>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[F>>2]|0))}b=k[H>>2]|0;if(!((b|0)==(I|0)|(b|0)==0))ggb(k[b+-4>>2]|0);o=+p[Ua>>3];do if((k[da>>2]&16384|0)==0?(Ma=k[oa>>2]|0,(k[Ma>>2]|0)!=1):0){b=k[la>>2]|0;f=k[J>>2]|0;if((k[Ma+4>>2]|0)==1){b=b+(aa(k[f>>2]|0,h)|0)|0;break}else{Ka=k[y>>2]|0;Ja=(h|0)/(Ka|0)|0;Ka=h-(aa(Ja,Ka)|0)|0;b=b+(aa(k[f>>2]|0,Ja)|0)+(Ka<<3)|0;break}}else Pa=220;while(0);if((Pa|0)==220){Pa=0;b=(k[la>>2]|0)+(h<<3)|0}p[b>>3]=o;g=~~+p[K>>3];do if((k[ca>>2]&16384|0)==0?(Na=k[ia>>2]|0,(k[Na>>2]|0)!=1):0){b=k[ha>>2]|0;f=k[L>>2]|0;if((k[Na+4>>2]|0)==1){b=b+(aa(k[f>>2]|0,h)|0)|0;break}else{Ka=k[w>>2]|0;Ja=(h|0)/(Ka|0)|0;Ka=h-(aa(Ja,Ka)|0)|0;b=b+(aa(k[f>>2]|0,Ja)|0)+(Ka<<2)|0;break}}else Pa=226;while(0);if((Pa|0)==226){Pa=0;b=(k[ha>>2]|0)+(h<<2)|0}k[b>>2]=g;b=k[M>>2]|0;if(b|0?(Ja=b+12|0,Ka=k[Ja>>2]|0,k[Ja>>2]=Ka+-1,(Ka|0)==1):0){f=k[M>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[T>>2]|0;if(b|0)break;b=B1()|0;f=k[M>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[M>>2]=0}k[M>>2]=0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[O>>2]|0)>0){f=k[Q>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[O>>2]|0))}b=k[R>>2]|0;if(!((b|0)==(S|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((j|0)<(k[s>>2]|0))}k[W>>2]=0;k[X>>2]=0;k[Ra>>2]=16842752;k[Y>>2]=da;g7(La,Ra);q=+p[La>>3];if((l|0)>=(m|0))break;o=q-V;if(l|0){if(o<-2.220446049250313e-16)break;if(o<Z*+P(+q))break}kCa(a);l=l+1|0;V=q}if(q<=-179769313486231575024503.0e281){Uh[k[(k[a>>2]|0)+8>>2]&2047](a);a=0;r=Va;return a|0}Y1(ea,k[$>>2]|0);a:do if((k[$>>2]|0)>0){m=a+8|0;n=Ra+4|0;s=Ra+4|0;t=s+4|0;u=a+380|0;v=Sa+8|0;w=Ua+36|0;x=Ua+16|0;y=Ua+4|0;z=Ua+40|0;A=Ua+44|0;B=Ua+48|0;C=Ua+8|0;D=Ua+52|0;E=Sa+4|0;F=E+4|0;G=Ra+36|0;H=Ra+16|0;I=Ra+4|0;J=Ra+40|0;K=Ra+44|0;L=Ra+48|0;M=Ua+32|0;N=Ra+32|0;O=Sa+8|0;Q=Sa+12|0;R=Sa+4|0;S=Ta+4|0;T=S+4|0;U=Ra+4|0;l=0;while(1){switch(k[m>>2]|0){case 0:{b=k[ea>>2]|0;f=b+(l*56|0)|0;if(!(((((k[b+(l*56|0)+4>>2]|0)<3?(k[b+(l*56|0)+8>>2]|0)==(Qa|0):0)?(k[b+(l*56|0)+12>>2]|0)==(Qa|0):0)?(k[f>>2]&4095|0)==6:0)?(k[b+(l*56|0)+16>>2]|0)!=0:0)){k[Ra>>2]=Qa;k[n>>2]=Qa;G1(f,2,Ra,6);b=k[ea>>2]|0}Pa=t;k[Pa>>2]=0;k[Pa+4>>2]=0;k[Ra>>2]=50397184;k[s>>2]=b+(l*56|0);p[Sa>>3]=+p[k[(k[u>>2]|0)+(l*56|0)+16>>2]>>3];k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;k[v+16>>2]=0;k[v+20>>2]=0;R2(Ra,Sa);break}case 1:{j=(k[ea>>2]|0)+(l*56|0)|0;f=k[u>>2]|0;g=f+(l*56|0)|0;h=f+(l*56|0)+12|0;b=k[h>>2]|0;f=f+(l*56|0)+8|0;if((b|0)!=1){if((k[f>>2]|0)!=1){b=ZT(32)|0;k[b>>2]=1;ma=b+4|0;k[Ra>>2]=ma;k[U>>2]=26;i[b+30>>0]=0;ka=218921;na=ma+26|0;do{i[ma>>0]=i[ka>>0]|0;ma=ma+1|0;ka=ka+1|0}while((ma|0)<(na|0));Y8(-215,Ra,217584,216975,1026);k[U>>2]=0;k[Ra>>2]=0;Pa=k[b>>2]|0;k[b>>2]=Pa+-1;if((Pa|0)==1)ggb(k[b+-4>>2]|0);b=k[h>>2]|0}}else b=1;b=(k[f>>2]|0)+-1+b|0;f=k[g>>2]&4095;k[Ra>>2]=0;k[Ra+4>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;k[Ra+16>>2]=0;k[Ra+20>>2]=0;k[Ra+24>>2]=0;k[Ra+28>>2]=0;k[Ua>>2]=1124007936;ma=y;na=ma+36|0;do{k[ma>>2]=0;ma=ma+4|0}while((ma|0)<(na|0));k[z>>2]=C;k[A>>2]=B;k[D>>2]=0;k[B>>2]=0;k[Sa>>2]=b;k[ba>>2]=b;G1(Ua,2,Sa,f);oY(Ua,Ra);J1(Ra,Ua,0);if((k[h>>2]|0)==1){Pa=F;k[Pa>>2]=0;k[Pa+4>>2]=0;k[Sa>>2]=33619968;k[E>>2]=Ra;mY(g,Sa)}else{k[O>>2]=0;k[Q>>2]=0;k[Sa>>2]=16842752;k[R>>2]=g;Pa=T;k[Pa>>2]=0;k[Pa+4>>2]=0;k[Ta>>2]=33619968;k[S>>2]=Ra;$1(Sa,Ta)}b=k[G>>2]|0;if(b|0?(Oa=b+12|0,Pa=k[Oa>>2]|0,k[Oa>>2]=Pa+-1,(Pa|0)==1):0){f=k[G>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[N>>2]|0;if(!b){b=B1()|0;f=k[G>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[G>>2]=0}k[G>>2]=0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[I>>2]|0)>0){f=k[J>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[I>>2]|0))}b=k[K>>2]|0;if(!((b|0)==(L|0)|(b|0)==0))ggb(k[b+-4>>2]|0);KG(j,Ua)|0;b=k[w>>2]|0;if(b|0?(Oa=b+12|0,Pa=k[Oa>>2]|0,k[Oa>>2]=Pa+-1,(Pa|0)==1):0){f=k[w>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[M>>2]|0;if(b|0)break;b=B1()|0;f=k[w>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[w>>2]=0}k[w>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[y>>2]|0)>0){f=k[z>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[y>>2]|0))}b=k[A>>2]|0;if(!((b|0)==(B|0)|(b|0)==0))ggb(k[b+-4>>2]|0);break}default:{}}l=l+1|0;if((l|0)>=(k[$>>2]|0))break a}}while(0);if(k[d>>2]&2031616|0)mY(ca,d);if(k[e>>2]&2031616|0)mY(_,e);if(k[c>>2]&2031616|0)mY(da,c);g=a+68|0;b=k[g>>2]|0;if(b|0?(Ta=b+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[a+64>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;Ua=a+48|0;f=a+36|0;k[Ua>>2]=0;k[Ua+4>>2]=0;k[Ua+8>>2]=0;k[Ua+12>>2]=0;if((k[f>>2]|0)>0){g=k[a+72>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}g=a+124|0;b=k[g>>2]|0;if(b|0?(Ta=b+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[a+120>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=0;k[fa+12>>2]=0;if((k[ga>>2]|0)>0){f=k[a+128>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ga>>2]|0))}g=a+236|0;b=k[g>>2]|0;if(b|0?(Ta=b+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[a+232>>2]|0;if(b|0)break;b=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[ja>>2]|0)>0){f=k[ia>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ja>>2]|0))}g=a+180|0;b=k[g>>2]|0;if(b|0?(Ta=b+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[a+176>>2]|0;if(b|0)break;b=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[pa>>2]|0)<=0){a=1;r=Va;return a|0}f=k[oa>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[pa>>2]|0));b=1;r=Va;return b|0}function jCa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;na=r;r=r+544|0;ga=na+32|0;ha=na+312|0;ia=na+256|0;ja=na;ka=na+480|0;la=a+368|0;if((k[la>>2]|0)==(k[a+372>>2]|0)){b=ga+4|0;c=ZT(20)|0;k[c>>2]=1;e=c+4|0;k[ga>>2]=e;k[b>>2]=13;i[c+17>>0]=0;d=364089;f=e+13|0;do{i[e>>0]=i[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(f|0));Y8(-215,ga,364103,363805,364);k[b>>2]=0;k[ga>>2]=0;fa=k[c>>2]|0;k[c>>2]=fa+-1;if((fa|0)==1)ggb(k[c+-4>>2]|0)}n=a+380|0;o=a+4|0;Y1(n,k[o>>2]|0);q=a+8|0;if((k[q>>2]|0)==2)Y1(a+392|0,k[o>>2]|0);s=a+404|0;Y1(s,k[o>>2]|0);if((k[o>>2]|0)<=0){r=na;return}t=ga+4|0;u=ga+8|0;v=ga+12|0;w=ga+4|0;x=ha+72|0;y=ja+8|0;z=ia+4|0;A=ia+8|0;B=ia+40|0;C=ia+48|0;D=ia+44|0;E=ia+52|0;F=ga+4|0;G=ia+36|0;H=ia+16|0;I=ga+8|0;J=ga+12|0;K=ga+4|0;L=ia+8|0;M=ia+12|0;N=ia+4|0;O=ja+4|0;P=O+4|0;Q=ia+4|0;R=ia+8|0;S=ia+40|0;T=ia+48|0;U=ia+44|0;V=ia+52|0;W=ga+4|0;X=W+4|0;Y=ia+36|0;Z=ia+16|0;_=ka+36|0;$=ka+16|0;ba=ka+4|0;ca=ka+40|0;da=ka+44|0;ea=ka+48|0;fa=ha+56|0;h=a+392|0;j=ia+32|0;l=ka+32|0;m=ia+32|0;g=0;do{b=k[la>>2]|0;if(k[b+(g*56|0)+16>>2]|0){d=k[b+(g*56|0)+4>>2]|0;if((d|0)<3)c=aa(k[b+(g*56|0)+12>>2]|0,k[b+(g*56|0)+8>>2]|0)|0;else{e=k[b+(g*56|0)+40>>2]|0;a=0;c=1;do{c=aa(k[e+(a<<2)>>2]|0,c)|0;a=a+1|0}while((a|0)!=(d|0))}if(!c)ma=16}else ma=16;if((ma|0)==16){ma=0;b=ZT(32)|0;k[b>>2]=1;e=b+4|0;k[ga>>2]=e;k[t>>2]=27;i[b+31>>0]=0;d=364117;f=e+27|0;do{i[e>>0]=i[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(f|0));Y8(-215,ga,364103,363805,371);k[t>>2]=0;k[ga>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0);b=k[la>>2]|0}k[u>>2]=0;k[v>>2]=0;k[ga>>2]=16842752;k[w>>2]=b+(g*56|0);nCa(ha,ga,5);b=k[q>>2]|0;do if(!b){b=(k[n>>2]|0)+(g*56|0)|0;p[ja>>3]=+p[k[x>>2]>>3];k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;k[y+16>>2]=0;k[y+20>>2]=0;k[ia>>2]=1124007936;e=z;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[B>>2]=A;k[D>>2]=C;k[E>>2]=0;k[C>>2]=0;k[ga>>2]=1;k[F>>2]=1;G1(ia,2,ga,6);oY(ia,ja);KG(b,ia)|0;b=k[G>>2]|0;if(b|0?(e=b+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){c=k[G>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[j>>2]|0;if(!b){b=B1()|0;c=k[G>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[G>>2]=0}k[G>>2]=0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[z>>2]|0)>0){c=k[B>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[D>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{c=(k[n>>2]|0)+(g*56|0)|0;if((b|0)!=1){KG(c,fa)|0;KG((k[h>>2]|0)+(g*56|0)|0,ha)|0;break}J1(ka,(k[la>>2]|0)+(g*56|0)|0,0);k[ia>>2]=1124007936;e=Q;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[S>>2]=R;k[U>>2]=T;k[V>>2]=0;k[T>>2]=0;b=X;k[b>>2]=0;k[b+4>>2]=0;k[ga>>2]=33619968;k[W>>2]=ia;mY(ka,ga);KG(c,ia)|0;b=k[Y>>2]|0;if(b|0?(e=b+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){c=k[Y>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[m>>2]|0;if(!b){b=B1()|0;c=k[Y>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[Y>>2]=0}k[Y>>2]=0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[Q>>2]|0)>0){c=k[S>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Q>>2]|0))}b=k[U>>2]|0;if(!((b|0)==(T|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[_>>2]|0;if(b|0?(e=b+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){c=k[_>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[l>>2]|0;if(!b){b=B1()|0;c=k[_>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[_>>2]=0}k[_>>2]=0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[ba>>2]|0)>0){c=k[ca>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ba>>2]|0))}b=k[da>>2]|0;if(!((b|0)==(ea|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while(0);f=(k[n>>2]|0)+(g*56|0)|0;k[I>>2]=0;k[J>>2]=0;k[ga>>2]=16842752;k[K>>2]=f;k[ia>>2]=-1056833530;k[N>>2]=19296;k[L>>2]=1;k[M>>2]=1;e=P;k[e>>2]=0;k[e+4>>2]=0;k[ja>>2]=33619968;k[O>>2]=f;aU(ga,ia,ja,49332,39872,0,14);f=k[s>>2]|0;g1(ga,(k[n>>2]|0)+(g*56|0)|0);e=k[ga>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,ga,f+(g*56|0)|0,-1);XN(ga);OZ(ha);g=g+1|0}while((g|0)<(k[o>>2]|0));r=na;return}function kCa(a){a=a|0;var b=0,c=0,d=0,e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0.0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0.0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;lc=r;r=r+1120|0;cc=lc+672|0;ec=lc+448|0;hc=lc+1008|0;Vb=lc+224|0;Xb=lc;Yb=lc+952|0;Zb=lc+896|0;ic=lc+1064|0;$b=a+32|0;Ub=k[a+44>>2]|0;k[cc+8>>2]=0;k[cc+12>>2]=0;k[cc>>2]=16842752;k[cc+4>>2]=a+88;dc=a+256|0;fc=ec+4|0;gc=fc+4|0;k[gc>>2]=0;k[gc+4>>2]=0;k[ec>>2]=33619968;k[fc>>2]=dc;T2(cc,ec,0,0,-1);fc=a+312|0;gc=a+4|0;b=k[gc>>2]|0;if(!(((((k[a+316>>2]|0)<3?(k[a+320>>2]|0)==(b|0):0)?(k[a+324>>2]|0)==(Ub|0):0)?(k[fc>>2]&4095|0)==6:0)?(k[a+328>>2]|0)!=0:0))kc=6;if((kc|0)==6){k[cc>>2]=b;k[cc+4>>2]=Ub;G1(fc,2,cc,6)};k[cc>>2]=0;k[cc+4>>2]=0;k[cc+8>>2]=0;k[cc+12>>2]=0;k[cc+16>>2]=0;k[cc+20>>2]=0;k[cc+24>>2]=0;k[cc+28>>2]=0;oY(fc,cc);ac=a+40|0;bc=+(k[ac>>2]|0)*2.220446049250313e-16;b=k[gc>>2]|0;if((b|0)>0){j=a+296|0;l=a+272|0;m=a+300|0;n=a+268|0;o=cc+4|0;q=ec+4|0;s=cc+4|0;t=s+4|0;u=hc+36|0;v=hc+16|0;w=hc+4|0;x=hc+40|0;y=hc+44|0;z=hc+48|0;A=a+104|0;B=a+132|0;C=cc+4|0;D=ec+4|0;E=Xb+36|0;F=Xb+16|0;G=Xb+4|0;H=Xb+40|0;I=Xb+44|0;J=Xb+48|0;K=hc+32|0;L=Xb+32|0;c=0;i=-1;e=1797693134862315708145274.0e284;while(1){h=(k[dc>>2]&16384|0)==0;do if(h?(P=k[j>>2]|0,(k[P>>2]|0)!=1):0){f=k[l>>2]|0;d=k[m>>2]|0;if((k[P+4>>2]|0)==1){d=f+(aa(k[d>>2]|0,c)|0)|0;g=f;break}else{g=k[n>>2]|0;Tb=(c|0)/(g|0)|0;g=c-(aa(Tb,g)|0)|0;d=f+(aa(k[d>>2]|0,Tb)|0)+(g<<3)|0;g=f;break}}else kc=12;while(0);if((kc|0)==12){kc=0;f=k[l>>2]|0;d=f+(c<<3)|0;g=f}if(!(+p[d>>3]<=bc)){do if(h?(M=k[j>>2]|0,(k[M>>2]|0)!=1):0){b=k[m>>2]|0;if((k[M+4>>2]|0)==1){b=f+(aa(k[b>>2]|0,c)|0)|0;break}else{Tb=k[n>>2]|0;Sb=(c|0)/(Tb|0)|0;Tb=c-(aa(Sb,Tb)|0)|0;b=f+(aa(k[b>>2]|0,Sb)|0)+(Tb<<3)|0;break}}else kc=20;while(0);if((kc|0)==20){kc=0;b=g+(c<<3)|0}if(+p[b>>3]<e){do if(h?(N=k[j>>2]|0,(k[N>>2]|0)!=1):0){b=k[m>>2]|0;if((k[N+4>>2]|0)==1){b=f+(aa(k[b>>2]|0,c)|0)|0;break}else{Tb=k[n>>2]|0;Sb=(c|0)/(Tb|0)|0;Tb=c-(aa(Sb,Tb)|0)|0;b=f+(aa(k[b>>2]|0,Sb)|0)+(Tb<<3)|0;break}}else kc=27;while(0);if((kc|0)==27){kc=0;b=g+(c<<3)|0}i=c;e=+p[b>>3]}g=c+1|0;k[cc>>2]=c;k[o>>2]=g;k[ec>>2]=-2147483648;k[q>>2]=2147483647;H1(hc,fc,cc,ec);if((k[ac>>2]|0)>0){f=0;do{b=(k[A>>2]|0)+(aa(k[k[B>>2]>>2]|0,f)|0)+(c<<3)|0;cb=+p[b>>3];k[cc>>2]=f;f=f+1|0;k[C>>2]=f;k[ec>>2]=-2147483648;k[D>>2]=2147483647;H1(Xb,$b,cc,ec);c1(Vb,cb,Xb);b=k[Vb>>2]|0;Ph[k[(k[b>>2]|0)+24>>2]&511](b,Vb,hc);XN(Vb);b=k[E>>2]|0;if(b|0?(Sb=b+12|0,Tb=k[Sb>>2]|0,k[Sb>>2]=Tb+-1,(Tb|0)==1):0){d=k[E>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[L>>2]|0;if(!b){b=B1()|0;d=k[E>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[E>>2]=0}k[E>>2]=0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[G>>2]|0)>0){d=k[H>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[G>>2]|0))}b=k[I>>2]|0;if(!((b|0)==(J|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((f|0)<(k[ac>>2]|0))}do if((k[dc>>2]&16384|0)==0?(O=k[j>>2]|0,(k[O>>2]|0)!=1):0){b=k[l>>2]|0;d=k[m>>2]|0;if((k[O+4>>2]|0)==1){b=b+(aa(k[d>>2]|0,c)|0)|0;break}else{Tb=k[n>>2]|0;Sb=(c|0)/(Tb|0)|0;Tb=c-(aa(Sb,Tb)|0)|0;b=b+(aa(k[d>>2]|0,Sb)|0)+(Tb<<3)|0;break}}else kc=35;while(0);if((kc|0)==35){kc=0;b=(k[l>>2]|0)+(c<<3)|0}cb=+p[b>>3];b=t;k[b>>2]=0;k[b+4>>2]=0;k[cc>>2]=33619968;k[s>>2]=hc;SW(hc,cc,-1,1.0/cb,0.0);b=k[u>>2]|0;if(b|0?(Sb=b+12|0,Tb=k[Sb>>2]|0,k[Sb>>2]=Tb+-1,(Tb|0)==1):0){c=k[u>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[K>>2]|0;if(!b){b=B1()|0;c=k[u>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[u>>2]=0}k[u>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[w>>2]|0)>0){c=k[x>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[w>>2]|0))}b=k[y>>2]|0;if(!((b|0)==(z|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=i;c=g;b=k[gc>>2]|0}else{d=i;c=c+1|0}if((c|0)<(b|0))i=d;else{Tb=d;break}}}else Tb=-1;Sb=a+368|0;Y1(Sb,b);Qb=a+380|0;Y1(Qb,k[gc>>2]|0);Rb=a+8|0;if((k[Rb>>2]|0)==2)Y1(a+392|0,k[gc>>2]|0);Kb=a+404|0;Y1(Kb,k[gc>>2]|0);if((k[gc>>2]|0)<=0){kc=k[ac>>2]|0;bc=+(kc|0);kc=cc+4|0;jc=kc+4|0;ic=jc;k[ic>>2]=0;jc=jc+4|0;k[jc>>2]=0;k[cc>>2]=33619968;k[kc>>2]=dc;bc=1.0/bc;SW(dc,cc,-1,bc,0.0);r=lc;return}Lb=a+296|0;Mb=a+272|0;Nb=a+300|0;Ob=a+268|0;Ia=cc+4|0;Ja=hc+4|0;Ka=hc+8|0;La=hc+12|0;Ma=hc+16|0;Na=hc+20|0;Oa=hc+24|0;Pa=hc+28|0;Qa=hc+32|0;Ra=hc+36|0;Sa=hc+40|0;Ta=hc+48|0;Ua=hc+44|0;Va=hc+52|0;Wa=Vb+4|0;Xa=Vb+8|0;Ya=Vb+40|0;Za=Vb+48|0;_a=Vb+44|0;$a=Vb+52|0;ab=cc+4|0;bb=ab+4|0;cb=1.0/+(Ub|0);db=cc+4|0;eb=db+4|0;fb=ec+8|0;gb=ec+12|0;hb=ec+4|0;ib=cc+56|0;Pb=a+392|0;jb=cc+8|0;kb=cc+12|0;lb=cc+4|0;mb=ec+8|0;nb=ec+12|0;ob=ec+4|0;pb=Xb+4|0;qb=pb+4|0;rb=Vb+36|0;sb=Vb+16|0;tb=cc+4|0;ub=ec+4|0;vb=cc+4|0;wb=ec+4|0;xb=Zb+36|0;yb=Zb+16|0;zb=Zb+4|0;Ab=Zb+40|0;Bb=Zb+44|0;Cb=Zb+48|0;Db=Yb+36|0;Eb=Yb+16|0;Fb=Yb+4|0;Gb=Yb+40|0;Hb=Yb+44|0;Ib=Yb+48|0;Jb=a+104|0;s=a+132|0;t=(Ub|0)>0;u=Vb+12|0;v=Xb+4|0;w=Xb+8|0;x=Xb+12|0;y=Xb+16|0;z=Xb+48|0;A=Xb+56|0;B=Xb+52|0;C=Xb+60|0;D=Xb+64|0;E=Xb+68|0;F=Xb+72|0;G=Xb+104|0;H=Xb+112|0;I=Xb+108|0;J=Xb+116|0;K=Xb+120|0;L=Xb+124|0;M=Xb+128|0;N=Xb+160|0;O=Xb+168|0;P=Xb+164|0;a=Xb+4|0;R=Xb+8|0;S=Xb+12|0;T=Xb+16|0;U=Xb+48|0;V=Xb+56|0;W=Xb+52|0;X=Xb+60|0;Y=Xb+64|0;Z=Xb+68|0;_=Xb+72|0;$=Xb+104|0;ba=Xb+112|0;ca=Xb+108|0;da=Xb+116|0;ea=Xb+120|0;fa=Xb+124|0;ga=Xb+128|0;ha=Xb+160|0;ia=Xb+168|0;ja=Xb+164|0;ka=ec+4|0;la=ec+8|0;ma=ec+12|0;na=ec+16|0;oa=ec+48|0;pa=ec+56|0;qa=ec+52|0;ra=ec+60|0;sa=ec+64|0;ta=ec+68|0;ua=ec+72|0;va=ec+104|0;wa=ec+112|0;xa=ec+108|0;ya=ec+116|0;za=ec+120|0;Aa=ec+124|0;Ba=ec+128|0;Ca=ec+160|0;Da=ec+168|0;Ea=ec+164|0;Fa=Yb+32|0;Ga=Zb+32|0;Ha=Vb+32|0;q=0;do{do if((k[dc>>2]&16384|0)==0?(Wb=k[Lb>>2]|0,(k[Wb>>2]|0)!=1):0){b=k[Mb>>2]|0;c=k[Nb>>2]|0;if((k[Wb+4>>2]|0)==1){b=b+(aa(k[c>>2]|0,q)|0)|0;break}else{o=k[Ob>>2]|0;n=(q|0)/(o|0)|0;o=q-(aa(n,o)|0)|0;b=b+(aa(k[c>>2]|0,n)|0)+(o<<3)|0;break}}else kc=75;while(0);if((kc|0)==75){kc=0;b=(k[Mb>>2]|0)+(q<<3)|0}if(!(+p[b>>3]<=bc)){b=k[Qb>>2]|0;c=b+(q*56|0)|0;d=(k[b+(q*56|0)+4>>2]|0)<3;do if(!(k[Rb>>2]|0)){if((((d?(k[b+(q*56|0)+8>>2]|0)==1:0)?(k[b+(q*56|0)+12>>2]|0)==1:0)?(k[c>>2]&4095|0)==6:0)?k[b+(q*56|0)+16>>2]|0:0)break;k[cc>>2]=1;k[Ia>>2]=1;G1(c,2,cc,6)}else{if((((d?(k[b+(q*56|0)+8>>2]|0)==1:0)?(k[b+(q*56|0)+12>>2]|0)==(Ub|0):0)?(k[c>>2]&4095|0)==6:0)?k[b+(q*56|0)+16>>2]|0:0)break;k[cc>>2]=1;k[Ia>>2]=Ub;G1(c,2,cc,6)}while(0);b=k[Rb>>2]|0;do if((b|0)==2){o=k[Sb>>2]|0;b=o+(q*56|0)|0;if(((((k[o+(q*56|0)+4>>2]|0)<3?(k[o+(q*56|0)+8>>2]|0)==(Ub|0):0)?(k[o+(q*56|0)+12>>2]|0)==(Ub|0):0)?(k[b>>2]&4095|0)==6:0)?k[o+(q*56|0)+16>>2]|0:0){b=2;break}k[cc>>2]=Ub;k[Ia>>2]=Ub;G1(b,2,cc,6);b=k[Rb>>2]|0}while(0);d=k[((b|0)==2?Sb:Qb)>>2]|0;k[hc>>2]=k[d+(q*56|0)>>2];b=d+(q*56|0)+4|0;k[Ja>>2]=k[b>>2];k[Ka>>2]=k[d+(q*56|0)+8>>2];k[La>>2]=k[d+(q*56|0)+12>>2];k[Ma>>2]=k[d+(q*56|0)+16>>2];k[Na>>2]=k[d+(q*56|0)+20>>2];k[Oa>>2]=k[d+(q*56|0)+24>>2];k[Pa>>2]=k[d+(q*56|0)+28>>2];k[Qa>>2]=k[d+(q*56|0)+32>>2];c=k[d+(q*56|0)+36>>2]|0;k[Ra>>2]=c;k[Sa>>2]=Ka;k[Ua>>2]=Ta;k[Va>>2]=0;k[Ta>>2]=0;if(c|0){o=c+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[b>>2]|0)>=3){k[Ja>>2]=0;x1(hc,k[b>>2]|0,0,0,0);if((k[Ja>>2]|0)>0){f=k[d+(q*56|0)+40>>2]|0;g=k[Sa>>2]|0;c=k[d+(q*56|0)+44>>2]|0;d=k[Ua>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[f+(b<<2)>>2];k[d+(b<<2)>>2]=k[c+(b<<2)>>2];b=b+1|0}while((b|0)<(k[Ja>>2]|0))}}else{n=k[d+(q*56|0)+44>>2]|0;o=k[Ua>>2]|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2]};k[cc>>2]=0;k[cc+4>>2]=0;k[cc+8>>2]=0;k[cc+12>>2]=0;k[cc+16>>2]=0;k[cc+20>>2]=0;k[cc+24>>2]=0;k[cc+28>>2]=0;oY(hc,cc);k[Vb>>2]=1124007936;b=Wa;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[Ya>>2]=Xa;k[_a>>2]=Za;k[$a>>2]=0;k[Za>>2]=0;if((k[ac>>2]|0)>0){o=q+1|0;n=0;do{d=n;n=n+1|0;k[cc>>2]=d;k[tb>>2]=n;k[ec>>2]=-2147483648;k[ub>>2]=2147483647;H1(Yb,$b,cc,ec);k[cc>>2]=q;k[vb>>2]=o;k[ec>>2]=-2147483648;k[wb>>2]=2147483647;H1(Zb,fc,cc,ec);k[Xb>>2]=0;k[v>>2]=0;k[w>>2]=1124007936;b=x;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[z>>2]=y;k[B>>2]=A;k[C>>2]=0;k[A>>2]=0;k[D>>2]=1124007936;b=E;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[G>>2]=F;k[I>>2]=H;k[J>>2]=0;k[H>>2]=0;k[K>>2]=1124007936;b=L;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[N>>2]=M;k[P>>2]=O;b=O;c=b+56|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[cc>>2]=0;k[cc+4>>2]=0;k[cc+8>>2]=0;k[cc+12>>2]=0;k[cc+16>>2]=0;k[cc+20>>2]=0;k[cc+24>>2]=0;k[cc+28>>2]=0;G0(Xb,Yb,Zb,1.0,-1.0,cc);b=k[Xb>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,Xb,Vb,-1);XN(Xb);b=k[xb>>2]|0;if(b|0?(l=b+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){c=k[xb>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Ga>>2]|0;if(b|0)break;b=B1()|0;c=k[xb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[xb>>2]=0}k[xb>>2]=0;k[yb>>2]=0;k[yb+4>>2]=0;k[yb+8>>2]=0;k[yb+12>>2]=0;if((k[zb>>2]|0)>0){c=k[Ab>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[zb>>2]|0))}b=k[Bb>>2]|0;if(!((b|0)==(Cb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Db>>2]|0;do if(b|0){l=b+12|0;m=k[l>>2]|0;k[l>>2]=m+-1;if((m|0)!=1)break;c=k[Db>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Fa>>2]|0;if(b|0)break;b=B1()|0;c=k[Db>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[Db>>2]=0}while(0);k[Db>>2]=0;k[Eb>>2]=0;k[Eb+4>>2]=0;k[Eb+8>>2]=0;k[Eb+12>>2]=0;if((k[Fb>>2]|0)>0){c=k[Gb>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Fb>>2]|0))}b=k[Hb>>2]|0;if(!((b|0)==(Ib|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Rb>>2]|0;do if((b|0)==2){b=(k[Jb>>2]|0)+(aa(k[k[s>>2]>>2]|0,d)|0)+(q<<3)|0;e=+p[b>>3];k[Xb>>2]=0;k[a>>2]=0;k[R>>2]=1124007936;b=S;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[U>>2]=T;k[W>>2]=V;k[X>>2]=0;k[V>>2]=0;k[Y>>2]=1124007936;b=Z;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[$>>2]=_;k[ca>>2]=ba;k[da>>2]=0;k[ba>>2]=0;k[ea>>2]=1124007936;b=fa;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[ha>>2]=ga;k[ja>>2]=ia;b=ia;c=b+56|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));y0(Xb,Vb,1.0);k[ec>>2]=0;k[ka>>2]=0;k[la>>2]=1124007936;b=ma;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[oa>>2]=na;k[qa>>2]=pa;k[ra>>2]=0;k[pa>>2]=0;k[sa>>2]=1124007936;b=ta;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[va>>2]=ua;k[xa>>2]=wa;k[ya>>2]=0;k[wa>>2]=0;k[za>>2]=1124007936;b=Aa;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[Ca>>2]=Ba;k[Ea>>2]=Da;b=Da;c=b+56|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));m=k[Xb>>2]|0;nh[k[(k[m>>2]|0)+72>>2]&15](m,Xb,e,ec);d1(cc,ec,Vb);m=k[cc>>2]|0;Ph[k[(k[m>>2]|0)+24>>2]&511](m,cc,hc);XN(cc);XN(ec);XN(Xb)}else{m=(k[Jb>>2]|0)+(aa(k[k[s>>2]>>2]|0,d)|0)+(q<<3)|0;Q=+p[m>>3];if(!t)break;h=k[Ya>>2]|0;i=h+4|0;j=k[Sa>>2]|0;l=j+4|0;m=(k[Vb>>2]&16384|0)==0;g=(b|0)!=0;f=0;do{do if(m){if((k[h>>2]|0)==1){kc=143;break}b=k[sb>>2]|0;c=k[_a>>2]|0;if((k[i>>2]|0)==1){b=b+(aa(k[c>>2]|0,f)|0)|0;break}else{d=k[u>>2]|0;mc=(f|0)/(d|0)|0;d=f-(aa(mc,d)|0)|0;b=b+(aa(k[c>>2]|0,mc)|0)+(d<<3)|0;break}}else kc=143;while(0);if((kc|0)==143){kc=0;b=(k[sb>>2]|0)+(f<<3)|0}e=+p[b>>3];b=g?f:0;do if(!(k[hc>>2]&16384)){if((k[j>>2]|0)==1){kc=149;break}c=k[Ma>>2]|0;d=k[Ua>>2]|0;if((k[l>>2]|0)==1){b=c+(aa(k[d>>2]|0,b)|0)|0;break}else{nc=k[La>>2]|0;mc=(b|0)/(nc|0)|0;b=b-(aa(mc,nc)|0)|0;b=c+(aa(k[d>>2]|0,mc)|0)+(b<<3)|0;break}}else kc=149;while(0);if((kc|0)==149){kc=0;b=(k[Ma>>2]|0)+(b<<3)|0}p[b>>3]=e*(Q*e)+ +p[b>>3];f=f+1|0}while((f|0)!=(Ub|0))}while(0)}while((n|0)<(k[ac>>2]|0))}if(!(k[Rb>>2]|0)){nc=bb;k[nc>>2]=0;k[nc+4>>2]=0;k[cc>>2]=33619968;k[ab>>2]=hc;SW(hc,cc,-1,cb,0.0)}do if((k[dc>>2]&16384|0)==0?(_b=k[Lb>>2]|0,(k[_b>>2]|0)!=1):0){b=k[Mb>>2]|0;c=k[Nb>>2]|0;if((k[_b+4>>2]|0)==1){b=b+(aa(k[c>>2]|0,q)|0)|0;break}else{nc=k[Ob>>2]|0;mc=(q|0)/(nc|0)|0;nc=q-(aa(mc,nc)|0)|0;b=b+(aa(k[c>>2]|0,mc)|0)+(nc<<3)|0;break}}else kc=157;while(0);if((kc|0)==157){kc=0;b=(k[Mb>>2]|0)+(q<<3)|0}Q=+p[b>>3];nc=eb;k[nc>>2]=0;k[nc+4>>2]=0;k[cc>>2]=33619968;k[db>>2]=hc;SW(hc,cc,-1,1.0/Q,0.0);if((k[Rb>>2]|0)==2){nc=(k[Sb>>2]|0)+(q*56|0)|0;k[fb>>2]=0;k[gb>>2]=0;k[ec>>2]=16842752;k[hb>>2]=nc;nCa(cc,ec,5);KG((k[Qb>>2]|0)+(q*56|0)|0,ib)|0;KG((k[Pb>>2]|0)+(q*56|0)|0,cc)|0;OZ(cc)}b=(k[Qb>>2]|0)+(q*56|0)|0;k[jb>>2]=0;k[kb>>2]=0;k[cc>>2]=16842752;k[lb>>2]=b;k[ec>>2]=-1056833530;k[ob>>2]=19296;k[mb>>2]=1;k[nb>>2]=1;nc=qb;k[nc>>2]=0;k[nc+4>>2]=0;k[Xb>>2]=33619968;k[pb>>2]=b;aU(cc,ec,Xb,49332,39872,0,14);b=k[Kb>>2]|0;g1(cc,(k[Qb>>2]|0)+(q*56|0)|0);nc=k[cc>>2]|0;dh[k[(k[nc>>2]|0)+12>>2]&255](nc,cc,b+(q*56|0)|0,-1);XN(cc);b=k[rb>>2]|0;if(b|0?(mc=b+12|0,nc=k[mc>>2]|0,k[mc>>2]=nc+-1,(nc|0)==1):0){c=k[rb>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Ha>>2]|0;if(b|0)break;b=B1()|0;c=k[rb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[rb>>2]=0}k[rb>>2]=0;k[sb>>2]=0;k[sb+4>>2]=0;k[sb+8>>2]=0;k[sb+12>>2]=0;if((k[Wa>>2]|0)>0){c=k[Ya>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Wa>>2]|0))}b=k[_a>>2]|0;if(!((b|0)==(Za|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Ra>>2]|0;do if(b|0){mc=b+12|0;nc=k[mc>>2]|0;k[mc>>2]=nc+-1;if((nc|0)!=1)break;c=k[Ra>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Qa>>2]|0;if(b|0)break;b=B1()|0;c=k[Ra>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[Ra>>2]=0}while(0);k[Ra>>2]=0;k[Ma>>2]=0;k[Ma+4>>2]=0;k[Ma+8>>2]=0;k[Ma+12>>2]=0;if((k[Ja>>2]|0)>0){c=k[Sa>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ja>>2]|0))}b=k[Ua>>2]|0;if(!((b|0)==(Ta|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}q=q+1|0;c=k[gc>>2]|0}while((q|0)<(c|0));if((c|0)<=0){nc=k[ac>>2]|0;bc=+(nc|0);nc=cc+4|0;mc=nc+4|0;kc=mc;k[kc>>2]=0;mc=mc+4|0;k[mc>>2]=0;k[cc>>2]=33619968;k[nc>>2]=dc;bc=1.0/bc;SW(dc,cc,-1,bc,0.0);r=lc;return}g=cc+4|0;h=ec+4|0;i=Tb+1|0;j=cc+4|0;l=ec+4|0;m=cc+4|0;n=m+4|0;o=ic+36|0;q=ic+16|0;s=ic+4|0;t=ic+40|0;u=ic+44|0;v=ic+48|0;w=cc+4|0;x=w+4|0;y=cc+4|0;z=y+4|0;A=cc+4|0;B=A+4|0;C=cc+4|0;D=C+4|0;E=hc+36|0;F=hc+16|0;G=hc+4|0;H=hc+40|0;I=hc+44|0;J=hc+48|0;K=hc+32|0;L=ic+32|0;f=0;while(1){do if((k[dc>>2]&16384|0)==0?(jc=k[Lb>>2]|0,(k[jc>>2]|0)!=1):0){b=k[Mb>>2]|0;d=k[Nb>>2]|0;if((k[jc+4>>2]|0)==1){b=b+(aa(k[d>>2]|0,f)|0)|0;break}else{nc=k[Ob>>2]|0;mc=(f|0)/(nc|0)|0;nc=f-(aa(mc,nc)|0)|0;b=b+(aa(k[d>>2]|0,mc)|0)+(nc<<3)|0;break}}else kc=194;while(0);if((kc|0)==194){kc=0;b=(k[Mb>>2]|0)+(f<<3)|0}if(!(+p[b>>3]<=bc))b=f+1|0;else{d=f+1|0;k[cc>>2]=f;k[g>>2]=d;k[ec>>2]=-2147483648;k[h>>2]=2147483647;H1(hc,fc,cc,ec);k[cc>>2]=Tb;k[j>>2]=i;k[ec>>2]=-2147483648;k[l>>2]=2147483647;H1(ic,fc,cc,ec);b=n;k[b>>2]=0;k[b+4>>2]=0;k[cc>>2]=33619968;k[m>>2]=hc;mY(ic,cc);b=k[o>>2]|0;if(b|0?(mc=b+12|0,nc=k[mc>>2]|0,k[mc>>2]=nc+-1,(nc|0)==1):0){c=k[o>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[L>>2]|0;if(!b){b=B1()|0;c=k[o>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[o>>2]=0}k[o>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[s>>2]|0)>0){c=k[t>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[s>>2]|0))}b=k[u>>2]|0;if(!((b|0)==(v|0)|(b|0)==0))ggb(k[b+-4>>2]|0);nc=k[Sb>>2]|0;mc=x;k[mc>>2]=0;k[mc+4>>2]=0;k[cc>>2]=33619968;k[w>>2]=nc+(f*56|0);mY(nc+(Tb*56|0)|0,cc);nc=k[Qb>>2]|0;mc=z;k[mc>>2]=0;k[mc+4>>2]=0;k[cc>>2]=33619968;k[y>>2]=nc+(f*56|0);mY(nc+(Tb*56|0)|0,cc);if((k[Rb>>2]|0)==2){nc=k[Pb>>2]|0;mc=B;k[mc>>2]=0;k[mc+4>>2]=0;k[cc>>2]=33619968;k[A>>2]=nc+(f*56|0);mY(nc+(Tb*56|0)|0,cc)}b=k[Kb>>2]|0;nc=D;k[nc>>2]=0;k[nc+4>>2]=0;k[cc>>2]=33619968;k[C>>2]=b+(f*56|0);mY(b+(Tb*56|0)|0,cc);b=k[E>>2]|0;if(b|0?(mc=b+12|0,nc=k[mc>>2]|0,k[mc>>2]=nc+-1,(nc|0)==1):0){c=k[E>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[K>>2]|0;if(b|0)break;b=B1()|0;c=k[E>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[E>>2]=0}k[E>>2]=0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[G>>2]|0)>0){c=k[H>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[G>>2]|0))}b=k[I>>2]|0;if(!((b|0)==(J|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=d;c=k[gc>>2]|0}if((b|0)<(c|0))f=b;else break}nc=k[ac>>2]|0;bc=+(nc|0);nc=cc+4|0;mc=nc+4|0;kc=mc;k[kc>>2]=0;mc=mc+4|0;k[mc>>2]=0;k[cc>>2]=33619968;k[nc>>2]=dc;bc=1.0/bc;SW(dc,cc,-1,bc,0.0);r=lc;return}function lCa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0.0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;K=r;r=r+112|0;m=K+96|0;J=K+40|0;g=K+24|0;h=K;j=K+8|0;o=a+380|0;if((k[o>>2]|0)==(k[a+384>>2]|0)){b=m+4|0;c=ZT(32)|0;k[c>>2]=1;e=c+4|0;k[m>>2]=e;k[b>>2]=24;i[c+28>>0]=0;d=364041;f=e+24|0;do{i[e>>0]=i[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(f|0));Y8(-215,m,364066,363805,455);k[b>>2]=0;k[m>>2]=0;I=k[c>>2]|0;k[c>>2]=I+-1;if((I|0)==1)ggb(k[c+-4>>2]|0)}k[J>>2]=1124007936;I=J+4|0;b=J+8|0;G=J+40|0;e=I;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[G>>2]=b;H=J+48|0;F=J+44|0;k[F>>2]=H;k[J+52>>2]=0;k[H>>2]=0;B=a+256|0;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=B;p[h>>3]=2.2250738585072014e-308;k[g>>2]=-1056833530;k[g+4>>2]=h;k[g+8>>2]=1;k[g+12>>2]=1;b=j+4|0;c=b+4|0;k[c>>2]=0;k[c+4>>2]=0;k[j>>2]=33619968;k[b>>2]=B;aU(m,g,j,49332,39872,0,14);k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=B;B=g+4|0;b=B+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=33619968;k[B>>2]=J;YZ(m,g);B=a+416|0;b=a+4|0;c=k[b>>2]|0;if(!(((((k[a+420>>2]|0)<3?(k[a+424>>2]|0)==1:0)?(k[a+428>>2]|0)==(c|0):0)?(k[B>>2]&4095|0)==6:0)?(k[a+432>>2]|0)!=0:0)){k[m>>2]=1;k[m+4>>2]=c;G1(B,2,m,6);c=k[b>>2]|0}if((c|0)>0){v=a+8|0;w=J+16|0;x=J+12|0;y=a+456|0;z=a+432|0;A=a+460|0;u=a+428|0;t=k[o>>2]|0;s=0;do{e=k[t+(s*56|0)+4>>2]|0;if((e|0)<3)b=aa(k[t+(s*56|0)+12>>2]|0,k[t+(s*56|0)+8>>2]|0)|0;else{f=k[t+(s*56|0)+40>>2]|0;d=0;b=1;do{b=aa(k[f+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}a:do if((b|0)>0){q=(k[v>>2]|0)!=0;h=t+(s*56|0)+16|0;j=t+(s*56|0)+44|0;m=t+(s*56|0)+12|0;if(k[t+(s*56|0)>>2]&16384|0){e=k[h>>2]|0;if(q){l=0.0;d=0;while(1){l=l+ +_(+(+p[e+(d<<3)>>3]));d=d+1|0;if((d|0)==(b|0))break a}}n=+_(+(+p[e>>3]));l=0.0;d=0;while(1){l=l+n;d=d+1|0;if((d|0)==(b|0))break a}}o=k[t+(s*56|0)+40>>2]|0;a=(k[o>>2]|0)==1;o=o+4|0;l=0.0;g=0;do{d=q?g:0;do if(!a){e=k[h>>2]|0;f=k[j>>2]|0;if((k[o>>2]|0)==1){d=e+(aa(k[f>>2]|0,d)|0)|0;break}else{M=k[m>>2]|0;L=(d|0)/(M|0)|0;d=d-(aa(L,M)|0)|0;d=e+(aa(k[f>>2]|0,L)|0)+(d<<3)|0;break}}else d=(k[h>>2]|0)+(d<<3)|0;while(0);l=l+ +_(+(+p[d>>3]));g=g+1|0}while((g|0)!=(b|0))}else l=0.0;while(0);do if((k[J>>2]&16384|0)==0?(C=k[G>>2]|0,(k[C>>2]|0)!=1):0){b=k[w>>2]|0;d=k[F>>2]|0;if((k[C+4>>2]|0)==1){b=b+(aa(k[d>>2]|0,s)|0)|0;break}else{M=k[x>>2]|0;L=(s|0)/(M|0)|0;M=s-(aa(L,M)|0)|0;b=b+(aa(k[d>>2]|0,L)|0)+(M<<3)|0;break}}else E=45;while(0);if((E|0)==45){E=0;b=(k[w>>2]|0)+(s<<3)|0}n=+p[b>>3];do if((k[B>>2]&16384|0)==0?(D=k[y>>2]|0,(k[D>>2]|0)!=1):0){b=k[z>>2]|0;d=k[A>>2]|0;if((k[D+4>>2]|0)==1){b=b+(aa(k[d>>2]|0,s)|0)|0;break}else{M=k[u>>2]|0;L=(s|0)/(M|0)|0;M=s-(aa(L,M)|0)|0;b=b+(aa(k[d>>2]|0,L)|0)+(M<<3)|0;break}}else E=52;while(0);if((E|0)==52){E=0;b=(k[z>>2]|0)+(s<<3)|0}p[b>>3]=n-l*.5;s=s+1|0}while((s|0)!=(c|0))}d=J+36|0;b=k[d>>2]|0;if(b|0?(L=b+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[J+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;M=J+16|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[I>>2]|0)>0){c=k[G>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[I>>2]|0))}b=k[F>>2]|0;if((b|0)==(H|0)|(b|0)==0){r=K;return}ggb(k[b+-4>>2]|0);r=K;return}function mCa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,l=0,m=0,n=0.0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;Fa=r;r=r+400|0;ya=Fa+336|0;Ea=Fa+280|0;Da=Fa+224|0;qa=Fa;m=k[c>>2]&4095;oa=b+328|0;if(k[oa>>2]|0){h=k[b+316>>2]|0;if((h|0)<3)f=aa(k[b+324>>2]|0,k[b+320>>2]|0)|0;else{l=k[b+352>>2]|0;g=0;f=1;do{f=aa(k[l+(g<<2)>>2]|0,f)|0;g=g+1|0}while((g|0)!=(h|0))}if(!f)wa=7}else wa=7;if((wa|0)==7){f=ya+4|0;g=ZT(20)|0;k[g>>2]=1;l=g+4|0;k[ya>>2]=l;k[f>>2]=14;i[g+18>>0]=0;h=363891;s=l+14|0;do{i[l>>0]=i[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(s|0));Y8(-215,ya,363906,363805,566);k[f>>2]=0;k[ya>>2]=0;Ca=k[g>>2]|0;k[g>>2]=Ca+-1;if((Ca|0)==1)ggb(k[g+-4>>2]|0)}na=(m|0)==5;if((m+-5|e+-5)>>>0>=2){f=ya+4|0;g=ZT(84)|0;k[g>>2]=1;l=g+4|0;k[ya>>2]=l;k[f>>2]=76;i[g+80>>0]=0;h=363927;s=l+76|0;do{i[l>>0]=i[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(s|0));Y8(-215,ya,363906,363805,567);k[f>>2]=0;k[ya>>2]=0;Ca=k[g>>2]|0;k[g>>2]=Ca+-1;if((Ca|0)==1)ggb(k[g+-4>>2]|0)}Ca=k[c+40>>2]|0;if(!((k[Ca>>2]|0)==1?(k[Ca+4>>2]|0)==(k[b+324>>2]|0):0)){f=ya+4|0;g=ZT(44)|0;k[g>>2]=1;l=g+4|0;k[ya>>2]=l;k[f>>2]=36;i[g+40>>0]=0;h=364004;s=l+36|0;do{i[l>>0]=i[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(s|0));Y8(-215,ya,363906,363805,568);k[f>>2]=0;k[ya>>2]=0;Ca=k[g>>2]|0;k[g>>2]=Ca+-1;if((Ca|0)==1)ggb(k[g+-4>>2]|0)}sa=k[c+12>>2]|0;ma=b+4|0;g=k[ma>>2]|0;k[Ea>>2]=1124007936;Ba=Ea+4|0;f=Ea+8|0;za=Ea+40|0;l=Ba;s=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(s|0));k[za>>2]=f;Ca=Ea+48|0;Aa=Ea+44|0;k[Aa>>2]=Ca;k[Ea+52>>2]=0;k[Ca>>2]=0;k[ya>>2]=1;f=ya+4|0;k[f>>2]=g;G1(Ea,2,ya,6);k[Da>>2]=1124007936;ua=Da+4|0;la=Da+8|0;ta=Da+40|0;l=ua;s=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(s|0));k[ta>>2]=la;xa=Da+48|0;va=Da+44|0;k[va>>2]=xa;k[Da+52>>2]=0;k[xa>>2]=0;k[ya>>2]=1;k[f>>2]=sa;G1(Da,2,ya,6);if((k[ma>>2]|0)>0){ja=b+356|0;ka=Da+16|0;U=c+16|0;V=(sa|0)>0;W=b+8|0;X=b+392|0;Y=ya+4|0;$=ya+8|0;ba=ya+40|0;ca=ya+48|0;da=ya+44|0;ea=ya+52|0;fa=b+404|0;ga=ya+16|0;ha=ya+12|0;ia=b+416|0;R=b+456|0;S=b+432|0;T=b+460|0;D=b+428|0;E=Ea+16|0;F=Ea+12|0;G=ya+36|0;H=Da+12|0;I=ya+20|0;J=Da+20|0;K=ya+24|0;L=Da+24|0;M=ya+28|0;N=Da+28|0;O=ya+32|0;P=Da+32|0;Q=Da+36|0;t=0;C=0;do{g=(k[oa>>2]|0)+(aa(k[k[ja>>2]>>2]|0,C)|0)|0;h=k[ka>>2]|0;l=k[U>>2]|0;m=h;if(na){if(V){f=0;do{p[h+(f<<3)>>3]=+o[l+(f<<2)>>2]-+p[g+(f<<3)>>3];f=f+1|0}while((f|0)!=(sa|0))}}else if(V){f=0;do{p[h+(f<<3)>>3]=+p[l+(f<<3)>>3]-+p[g+(f<<3)>>3];f=f+1|0}while((f|0)!=(sa|0))}do if((k[W>>2]|0)!=2){k[ya>>2]=k[Da>>2];f=k[ua>>2]|0;k[Y>>2]=f;k[$>>2]=k[la>>2];k[ha>>2]=k[H>>2];k[ga>>2]=m;k[I>>2]=k[J>>2];k[K>>2]=k[L>>2];k[M>>2]=k[N>>2];k[O>>2]=k[P>>2];g=k[Q>>2]|0;k[G>>2]=g;k[ba>>2]=$;k[da>>2]=ca;k[ea>>2]=0;k[ca>>2]=0;if(g){f=g+12|0;k[f>>2]=(k[f>>2]|0)+1;f=k[ua>>2]|0}if((f|0)<3){A=k[va>>2]|0;B=k[da>>2]|0;k[B>>2]=k[A>>2];k[B+4>>2]=k[A+4>>2];break}k[Y>>2]=0;x1(ya,f,0,0,0);if((k[Y>>2]|0)>0){g=k[ta>>2]|0;h=k[ba>>2]|0;l=k[va>>2]|0;m=k[da>>2]|0;f=0;do{k[h+(f<<2)>>2]=k[g+(f<<2)>>2];k[m+(f<<2)>>2]=k[l+(f<<2)>>2];f=f+1|0}while((f|0)<(k[Y>>2]|0))}}else{a1(qa,Da,(k[X>>2]|0)+(C*56|0)|0);k[ya>>2]=1124007936;l=Y;s=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(s|0));k[ba>>2]=$;k[da>>2]=ca;k[ea>>2]=0;k[ca>>2]=0;B=k[qa>>2]|0;dh[k[(k[B>>2]|0)+12>>2]&255](B,qa,ya,-1);XN(qa)}while(0);a:do if(V){f=k[fa>>2]|0;v=(k[W>>2]|0)!=0;b=f+(C*56|0)+16|0;s=f+(C*56|0)+44|0;u=f+(C*56|0)+12|0;w=(k[ya>>2]&16384|0)==0;x=k[ba>>2]|0;y=x+4|0;z=k[ga>>2]|0;A=k[da>>2]|0;B=k[ha>>2]|0;if(k[f+(C*56|0)>>2]&16384|0){h=k[b>>2]|0;g=0;n=0.0;while(1){j=+p[h+((v?g:0)<<3)>>3];do if(w?(k[x>>2]|0)!=1:0)if((k[y>>2]|0)==1){f=z+(aa(k[A>>2]|0,g)|0)|0;break}else{u=(g|0)/(B|0)|0;f=g-(aa(u,B)|0)|0;f=z+(aa(k[A>>2]|0,u)|0)+(f<<3)|0;break}else wa=69;while(0);if((wa|0)==69){wa=0;f=z+(g<<3)|0}q=+p[f>>3];n=n+q*(j*q);g=g+1|0;if((g|0)==(sa|0))break a}}c=k[f+(C*56|0)+40>>2]|0;m=(k[c>>2]|0)==1;c=c+4|0;l=0;n=0.0;do{f=v?l:0;do if(!m){g=k[b>>2]|0;h=k[s>>2]|0;if((k[c>>2]|0)==1){f=g+(aa(k[h>>2]|0,f)|0)|0;break}else{Ha=k[u>>2]|0;Ga=(f|0)/(Ha|0)|0;f=f-(aa(Ga,Ha)|0)|0;f=g+(aa(k[h>>2]|0,Ga)|0)+(f<<3)|0;break}}else f=(k[b>>2]|0)+(f<<3)|0;while(0);j=+p[f>>3];do if(w?(k[x>>2]|0)!=1:0)if((k[y>>2]|0)==1){f=z+(aa(k[A>>2]|0,l)|0)|0;break}else{Ha=(l|0)/(B|0)|0;f=l-(aa(Ha,B)|0)|0;f=z+(aa(k[A>>2]|0,Ha)|0)+(f<<3)|0;break}else wa=54;while(0);if((wa|0)==54){wa=0;f=z+(l<<3)|0}q=+p[f>>3];n=n+q*(j*q);l=l+1|0}while((l|0)!=(sa|0))}else n=0.0;while(0);do if((k[ia>>2]&16384|0)==0?(pa=k[R>>2]|0,(k[pa>>2]|0)!=1):0){f=k[S>>2]|0;g=k[T>>2]|0;if((k[pa+4>>2]|0)==1){f=f+(aa(k[g>>2]|0,C)|0)|0;break}else{Ha=k[D>>2]|0;Ga=(C|0)/(Ha|0)|0;Ha=C-(aa(Ga,Ha)|0)|0;f=f+(aa(k[g>>2]|0,Ga)|0)+(Ha<<3)|0;break}}else wa=58;while(0);if((wa|0)==58){wa=0;f=(k[S>>2]|0)+(C<<3)|0}j=+p[f>>3];do if(!(k[Ea>>2]&16384)){h=k[za>>2]|0;if((k[h>>2]|0)==1){wa=k[E>>2]|0;p[wa+(C<<3)>>3]=j-n*.5;f=wa;j=+p[wa+(C<<3)>>3];wa=79;break}f=k[E>>2]|0;g=k[Aa>>2]|0;if((k[h+4>>2]|0)==1)f=f+(aa(k[g>>2]|0,C)|0)|0;else{Ha=k[F>>2]|0;Ga=(C|0)/(Ha|0)|0;Ha=C-(aa(Ga,Ha)|0)|0;f=f+(aa(k[g>>2]|0,Ga)|0)+(Ha<<3)|0}p[f>>3]=j-n*.5;f=k[E>>2]|0;g=k[Aa>>2]|0;if((k[h+4>>2]|0)==1)f=f+(aa(k[g>>2]|0,C)|0)|0;else{Ha=k[F>>2]|0;Ga=(C|0)/(Ha|0)|0;Ha=C-(aa(Ga,Ha)|0)|0;f=f+(aa(k[g>>2]|0,Ga)|0)+(Ha<<3)|0}j=+p[f>>3];f=k[E>>2]|0;g=k[Aa>>2]|0;if((k[h+4>>2]|0)==1){f=f+(aa(k[g>>2]|0,t)|0)|0;break}else{Ha=k[F>>2]|0;Ga=(t|0)/(Ha|0)|0;Ha=t-(aa(Ga,Ha)|0)|0;f=f+(aa(k[g>>2]|0,Ga)|0)+(Ha<<3)|0;break}}else{f=k[E>>2]|0;j=j-n*.5;p[f+(C<<3)>>3]=j;wa=79}while(0);if((wa|0)==79){wa=0;f=f+(t<<3)|0}t=j>+p[f>>3]?C:t;f=k[G>>2]|0;if(f|0?(Ga=f+12|0,Ha=k[Ga>>2]|0,k[Ga>>2]=Ha+-1,(Ha|0)==1):0){g=k[G>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[O>>2]|0;if(!f){f=B1()|0;g=k[G>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[G>>2]=0}k[G>>2]=0;k[ga>>2]=0;k[ga+4>>2]=0;k[ga+8>>2]=0;k[ga+12>>2]=0;if((k[Y>>2]|0)>0){g=k[ba>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[Y>>2]|0))}f=k[da>>2]|0;if(!((f|0)==(ca|0)|(f|0)==0))ggb(k[f+-4>>2]|0);C=C+1|0}while((C|0)<(k[ma>>2]|0))}else t=0;s=(k[Ea>>2]&16384|0)==0;do if(s?(ra=k[za>>2]|0,(k[ra>>2]|0)!=1):0){g=k[Ea+16>>2]|0;f=k[Aa>>2]|0;if((k[ra+4>>2]|0)==1){f=g+(aa(k[f>>2]|0,t)|0)|0;break}else{Ha=k[Ea+12>>2]|0;Ga=(t|0)/(Ha|0)|0;Ha=t-(aa(Ga,Ha)|0)|0;f=g+(aa(k[f>>2]|0,Ga)|0)+(Ha<<3)|0;break}}else wa=22;while(0);if((wa|0)==22){g=k[Ea+16>>2]|0;f=g+(t<<3)|0}q=+p[f>>3];l=k[Ea+12>>2]|0;if((l|0)>0){m=k[za>>2]|0;c=m+4|0;b=Ea+16|0;j=0.0;h=0;do{if(s?(k[m>>2]|0)!=1:0){f=k[b>>2]|0;g=k[Aa>>2]|0;if((k[c>>2]|0)==1)f=f+(aa(k[g>>2]|0,h)|0)|0;else{Ga=(h|0)/(l|0)|0;Ha=h-(aa(Ga,l)|0)|0;f=f+(aa(k[g>>2]|0,Ga)|0)+(Ha<<3)|0}n=+Z(+(+p[f>>3]-q));wa=108}else wa=105;do if((wa|0)==105){wa=0;n=+Z(+(+p[g+(h<<3)>>3]-q));if(s?(k[m>>2]|0)!=1:0){wa=108;break}f=g+(h<<3)|0}while(0);do if((wa|0)==108){g=k[b>>2]|0;f=k[Aa>>2]|0;if((k[c>>2]|0)==1){f=g+(aa(k[f>>2]|0,h)|0)|0;break}else{Ga=(h|0)/(l|0)|0;Ha=h-(aa(Ga,l)|0)|0;f=g+(aa(k[f>>2]|0,Ga)|0)+(Ha<<3)|0;break}}while(0);p[f>>3]=n;j=j+n;h=h+1|0}while((h|0)!=(l|0))}else j=0.0;if(d|0){Ha=ya+4|0;Ga=Ha+4|0;k[Ga>>2]=0;k[Ga+4>>2]=0;k[ya>>2]=33619968;k[Ha>>2]=d;SW(Ea,ya,e,1.0/j,0.0)}q=q+ +_(+j)-+(sa|0)*.5*1.8378770664093456;p[a>>3]=q;p[a+8>>3]=+(t|0);h=Da+36|0;f=k[h>>2]|0;if(f|0?(Ga=f+12|0,Ha=k[Ga>>2]|0,k[Ga>>2]=Ha+-1,(Ha|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[Da+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Ha=Da+16|0;k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ha+8>>2]=0;k[Ha+12>>2]=0;if((k[ua>>2]|0)>0){g=k[ta>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[ua>>2]|0))}f=k[va>>2]|0;if(!((f|0)==(xa|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=Ea+36|0;f=k[h>>2]|0;if(f|0?(Ga=f+12|0,Ha=k[Ga>>2]|0,k[Ga>>2]=Ha+-1,(Ha|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[Ea+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Ha=Ea+16|0;k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ha+8>>2]=0;k[Ha+12>>2]=0;if((k[Ba>>2]|0)>0){g=k[za>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[Ba>>2]|0))}f=k[Aa>>2]|0;if((f|0)==(Ca|0)|(f|0)==0){r=Fa;return}ggb(k[f+-4>>2]|0);r=Fa;return}function nCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+48|0;f=j+32|0;g=j+16|0;h=j;k[a>>2]=1124007936;d=a+8|0;e=a+40|0;i=a+4|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[e>>2]=d;d=a+48|0;k[a+44>>2]=d;k[a+52>>2]=0;k[d>>2]=0;k[a+56>>2]=1124007936;d=a+64|0;e=a+96|0;i=a+60|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[e>>2]=d;d=a+104|0;k[a+100>>2]=d;k[a+108>>2]=0;k[d>>2]=0;k[a+112>>2]=1124007936;d=a+120|0;e=a+152|0;i=a+116|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[e>>2]=d;l=a+160|0;k[a+156>>2]=l;k[a+164>>2]=0;k[l>>2]=0;l=f+4|0;i=l+4|0;k[i>>2]=0;k[i+4>>2]=0;k[f>>2]=33619968;k[l>>2]=a+56;l=g+4|0;i=l+4|0;k[i>>2]=0;k[i+4>>2]=0;k[g>>2]=33619968;k[l>>2]=a;l=h+4|0;i=l+4|0;k[i>>2]=0;k[i+4>>2]=0;k[h>>2]=33619968;k[l>>2]=a+112;DZ(b,f,g,h,c);r=j;return}function oCa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+16|0;x=y;if(k[b+16>>2]|0){m=k[b+4>>2]|0;if((m|0)<3)j=aa(k[b+12>>2]|0,k[b+8>>2]|0)|0;else{n=k[b+40>>2]|0;l=0;j=1;do{j=aa(k[n+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(m|0))}if(!j)w=7}else w=7;if((w|0)==7){j=x+4|0;l=ZT(24)|0;k[l>>2]=1;m=l+4|0;k[x>>2]=m;k[j>>2]=16;i[l+20>>0]=0;p=364217;q=m+16|0;do{i[m>>0]=i[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));Y8(-215,x,364234,363805,240);k[j>>2]=0;k[x>>2]=0;v=k[l>>2]|0;k[l>>2]=v+-1;if((v|0)==1)ggb(k[l+-4>>2]|0)}if(k[b>>2]&4088|0){j=x+4|0;l=ZT(28)|0;k[l>>2]=1;m=l+4|0;k[x>>2]=m;k[j>>2]=23;i[l+27>>0]=0;p=364249;q=m+23|0;do{i[m>>0]=i[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));Y8(-215,x,364234,363805,241);k[j>>2]=0;k[x>>2]=0;v=k[l>>2]|0;k[l>>2]=v+-1;if((v|0)==1)ggb(k[l+-4>>2]|0)}o=k[b+8>>2]|0;v=k[b+12>>2]|0;if((c|0)<=0){j=x+4|0;l=ZT(20)|0;k[l>>2]=1;m=l+4|0;k[x>>2]=m;k[j>>2]=13;i[l+17>>0]=0;p=364273;q=m+13|0;do{i[m>>0]=i[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));Y8(-215,x,364234,363805,247);k[j>>2]=0;k[x>>2]=0;u=k[l>>2]|0;k[l>>2]=u+-1;if((u|0)==1)ggb(k[l+-4>>2]|0)}if((o|0)<(c|0)){j=x+4|0;l=ZT(28)|0;k[l>>2]=1;m=l+4|0;k[x>>2]=m;k[j>>2]=21;i[l+25>>0]=0;p=364287;q=m+21|0;do{i[m>>0]=i[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));Y8(-215,x,364234,363805,248);k[j>>2]=0;k[x>>2]=0;u=k[l>>2]|0;k[l>>2]=u+-1;if((u|0)==1)ggb(k[l+-4>>2]|0)}u=(a|0)==1;if(a>>>0>=3){j=x+4|0;l=ZT(92)|0;k[l>>2]=1;m=l+4|0;k[x>>2]=m;k[j>>2]=86;i[l+90>>0]=0;p=364309;q=m+86|0;do{i[m>>0]=i[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));Y8(-215,x,364234,363805,251);k[j>>2]=0;k[x>>2]=0;t=k[l>>2]|0;k[l>>2]=t+-1;if((t|0)==1)ggb(k[l+-4>>2]|0)}if(d>>>0>=3){j=x+4|0;l=ZT(104)|0;k[l>>2]=1;m=l+4|0;k[x>>2]=m;k[j>>2]=98;i[l+102>>0]=0;p=364396;q=m+98|0;do{i[m>>0]=i[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));Y8(-215,x,364234,363805,254);k[j>>2]=0;k[x>>2]=0;t=k[l>>2]|0;k[l>>2]=t+-1;if((t|0)==1)ggb(k[l+-4>>2]|0)}t=(e|0)!=0;do if(t){if(k[e+16>>2]|0){m=k[e+4>>2]|0;if((m|0)<3)j=aa(k[e+12>>2]|0,k[e+8>>2]|0)|0;else{n=k[e+40>>2]|0;l=0;j=1;do{j=aa(k[n+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(m|0))}if(((j|0?(k[e+8>>2]|0)==(o|0):0)?(k[e+12>>2]|0)==(c|0):0)?((k[e>>2]&4095)+-5|0)>>>0<2:0)break}s=x+4|0;j=ZT(148)|0;k[j>>2]=1;q=j+4|0;k[x>>2]=q;k[s>>2]=142;i[j+146>>0]=0;upb(q|0,364495,142)|0;Y8(-215,x,364234,363805,259);k[s>>2]=0;k[x>>2]=0;s=k[j>>2]|0;k[j>>2]=s+-1;if((s|0)==1)ggb(k[j+-4>>2]|0)}while(0);a:do if(h|0){do if(k[h+16>>2]|0){b=k[h+4>>2]|0;n=(b|0)<3;if(n)j=aa(k[h+12>>2]|0,k[h+8>>2]|0)|0;else{m=k[h+40>>2]|0;l=0;j=1;do{j=aa(k[m+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(b|0))}if(j|0){j=k[h+12>>2]|0;if((j|0)!=1?(k[h+8>>2]|0)!=1:0)break;if(n)j=aa(j,k[h+8>>2]|0)|0;else{m=k[h+40>>2]|0;l=0;j=1;do{j=aa(k[m+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(b|0))}if((j|0)==(c|0)?((k[h>>2]&4095)+-5|0)>>>0<2:0)break a}}while(0);s=x+4|0;j=ZT(200)|0;k[j>>2]=1;q=j+4|0;k[x>>2]=q;k[s>>2]=192;i[j+196>>0]=0;upb(q|0,364638,192)|0;Y8(-215,x,364234,363805,264);k[s>>2]=0;k[x>>2]=0;s=k[j>>2]|0;k[j>>2]=s+-1;if((s|0)==1)ggb(k[j+-4>>2]|0)}while(0);s=(f|0)!=0;do if(s){if(k[f+16>>2]|0){m=k[f+4>>2]|0;if((m|0)<3)j=aa(k[f+12>>2]|0,k[f+8>>2]|0)|0;else{n=k[f+40>>2]|0;l=0;j=1;do{j=aa(k[n+(l<<2)>>2]|0,j)|0;l=l+1|0}while((l|0)!=(m|0))}if(((j|0?(k[f+8>>2]|0)==(c|0):0)?(k[f+12>>2]|0)==(v|0):0)?(k[f>>2]&4088|0)==0:0)break}j=x+4|0;l=ZT(108)|0;k[l>>2]=1;m=l+4|0;k[x>>2]=m;k[j>>2]=103;i[l+107>>0]=0;p=364831;q=m+103|0;do{i[m>>0]=i[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));Y8(-215,x,364234,363805,269);k[j>>2]=0;k[x>>2]=0;q=k[l>>2]|0;k[l>>2]=q+-1;if((q|0)==1)ggb(k[l+-4>>2]|0)}while(0);if(g|0){j=k[g>>2]|0;n=g+4|0;q=k[n>>2]|0;l=q;m=j;if((j|0)!=(q|0)?((l-m|0)/56|0|0)==(c|0):0)f=n;else{j=x+4|0;l=ZT(80)|0;k[l>>2]=1;m=l+4|0;k[x>>2]=m;k[j>>2]=72;i[l+76>>0]=0;p=364935;q=m+72|0;do{i[m>>0]=i[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));Y8(-215,x,364234,363805,273);k[j>>2]=0;k[x>>2]=0;c=k[l>>2]|0;k[l>>2]=c+-1;if((c|0)==1)ggb(k[l+-4>>2]|0);j=k[g>>2]|0;f=n;l=k[n>>2]|0;m=j}if((l|0)!=(m|0)){h=x+4|0;e=0;d=m;m=l;while(1){if(k[j+(e*56|0)+16>>2]|0){b=k[j+(e*56|0)+4>>2]|0;if((b|0)<3)l=aa(k[j+(e*56|0)+12>>2]|0,k[j+(e*56|0)+8>>2]|0)|0;else{o=k[j+(e*56|0)+40>>2]|0;n=0;l=1;do{l=aa(k[o+(n<<2)>>2]|0,l)|0;n=n+1|0}while((n|0)!=(b|0))}if(((l|0)!=0?(c=k[j+(e*56|0)+40>>2]|0,(k[c>>2]|0)==(v|0)?(k[c+4>>2]|0)==(v|0):0):0)?(k[j+(e*56|0)>>2]&4088|0)==0:0)l=d;else w=90}else w=90;if((w|0)==90){w=0;j=ZT(64)|0;k[j>>2]=1;m=j+4|0;k[x>>2]=m;k[h>>2]=56;i[j+60>>0]=0;p=365008;q=m+56|0;do{i[m>>0]=i[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));Y8(-215,x,364234,363805,280);k[h>>2]=0;k[x>>2]=0;c=k[j>>2]|0;k[j>>2]=c+-1;if((c|0)==1)ggb(k[j+-4>>2]|0);l=k[g>>2]|0;m=k[f>>2]|0}e=e+1|0;if(e>>>0>=((m-l|0)/56|0)>>>0)break;else{j=l;d=l}}}}if(u){if(s){r=y;return}w=x+4|0;j=ZT(12)|0;k[j>>2]=1;a=j+4|0;k[x>>2]=a;k[w>>2]=5;i[j+9>>0]=0;i[a>>0]=i[365065]|0;i[a+1>>0]=i[365066]|0;i[a+2>>0]=i[365067]|0;i[a+3>>0]=i[365068]|0;i[a+4>>0]=i[365069]|0;Y8(-215,x,364234,363805,286);k[w>>2]=0;k[x>>2]=0;x=k[j>>2]|0;k[j>>2]=x+-1;if((x|0)==1)ggb(k[j+-4>>2]|0);r=y;return}else{if((a|0)!=2|t){r=y;return}w=x+4|0;j=ZT(12)|0;k[j>>2]=1;a=j+4|0;k[x>>2]=a;k[w>>2]=5;i[j+9>>0]=0;i[a>>0]=i[365071]|0;i[a+1>>0]=i[365072]|0;i[a+2>>0]=i[365073]|0;i[a+3>>0]=i[365074]|0;i[a+4>>0]=i[365075]|0;Y8(-215,x,364234,363805,290);k[w>>2]=0;k[x>>2]=0;x=k[j>>2]|0;k[j>>2]=x+-1;if((x|0)==1)ggb(k[j+-4>>2]|0);r=y;return}}function pCa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=r;r=r+112|0;e=H+8|0;f=H+96|0;n=H;A=H+40|0;G=H+24|0;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=a;p[n>>3]=0.0;k[f>>2]=-1056833530;k[f+4>>2]=n;k[f+8>>2]=1;k[f+12>>2]=1;g=A+4|0;F=g+4|0;k[F>>2]=0;k[F+4>>2]=0;k[A>>2]=33619968;k[g>>2]=a;aU(e,f,A,49332,39872,0,14);p[n>>3]=1.0/+(k[a+12>>2]|0);g=a+8|0;if((k[g>>2]|0)<=0){r=H;return}h=e+4|0;i=f+4|0;j=f+8|0;l=f+12|0;m=f+4|0;o=f+8|0;q=f+12|0;s=f+4|0;t=A+36|0;u=A+16|0;v=A+4|0;w=A+40|0;x=A+44|0;y=A+48|0;z=f+8|0;B=f+12|0;C=f+4|0;D=G+4|0;E=D+4|0;F=A+32|0;d=0;do{k[e>>2]=d;d=d+1|0;k[h>>2]=d;k[f>>2]=-2147483648;k[i>>2]=2147483647;H1(A,a,e,f);p[e>>3]=0.0;k[j>>2]=0;k[l>>2]=0;k[f>>2]=16842752;k[m>>2]=A;L7(f,0,e,0,0,49332);if(+p[e>>3]<1.1920928955078125e-07){k[f>>2]=-1056833530;k[s>>2]=n;k[o>>2]=1;k[q>>2]=1;pY(A,f,49332)}else{k[z>>2]=0;k[B>>2]=0;k[f>>2]=16842752;k[C>>2]=A;c=E;k[c>>2]=0;k[c+4>>2]=0;k[G>>2]=50397184;k[D>>2]=A;$X(f,G,1.0,0.0,2,-1,49332)}b=k[t>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[t>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[F>>2]|0;if(!b){b=B1()|0;c=k[t>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[t>>2]=0}k[t>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[v>>2]|0)>0){c=k[w>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[v>>2]|0))}b=k[x>>2]|0;if(!((b|0)==(y|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((d|0)<(k[g>>2]|0));r=H;return}function qCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;e=h;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=h;return}f=a+32|0;if((k[f>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[e>>2]=g;k[c>>2]=30;i[d+34>>0]=0;j=401220;l=g+30|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}D6(a,a+12|0,b);if(!(k[f>>2]&4)){r=h;return}k[f>>2]=6;r=h;return}function rCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function sCa(a){a=a|0;return (Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)^1|0}function tCa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+16|0;f=e;g=k[(k[a>>2]|0)+44>>2]|0;HBa(f,b,c,d,49332,49332,49332,49332);a=ci[g&255](a,f,0)|0;b=k[f>>2]|0;if(!b){r=e;return a|0}f=b+4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){r=e;return a|0}Uh[k[(k[b>>2]|0)+8>>2]&2047](b);r=e;return a|0}function uCa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0,i=0,j=0.0,l=0.0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0;fa=r;r=r+304|0;V=fa+288|0;W=fa+280|0;ea=fa+224|0;da=fa+168|0;_=fa+112|0;Z=fa+56|0;S=fa;h=b+4|0;i=k[h>>2]|0;jh[k[(k[i>>2]|0)+36>>2]&1023](ea,i);i=k[h>>2]|0;i=Xh[k[(k[i>>2]|0)+8>>2]&1023](i)|0;b=k[h>>2]|0;e=k[b>>2]|0;if(c)jh[k[e+100>>2]&1023](da,b);else jh[k[e+96>>2]&1023](da,b);$=da+16|0;L=k[$>>2]|0;ba=da+44|0;ca=da+4|0;c=k[ca>>2]|0;if((c|0)<3)b=aa(k[da+12>>2]|0,k[da+8>>2]|0)|0;else{f=k[da+40>>2]|0;e=0;b=1;do{b=aa(k[f+(e<<2)>>2]|0,b)|0;e=e+1|0}while((e|0)!=(c|0))}Y=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;R=k[h>>2]|0;jh[k[(k[R>>2]|0)+64>>2]&1023](_,R);if(!b){b=k[h>>2]|0;b=Xh[k[(k[b>>2]|0)+20>>2]&1023](b)|0;if(!b)g=-3402823466385288598117041.0e14;else{R=b;X=10}}else{R=b;X=10}if((X|0)==10){k[Z>>2]=1124007936;Q=Z+4|0;K=Z+8|0;M=Z+40|0;b=Q;e=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(e|0));k[M>>2]=K;O=Z+48|0;N=Z+44|0;k[N>>2]=O;k[Z+52>>2]=0;k[O>>2]=0;if(k[d>>2]&2031616|0){k[V>>2]=R;k[V+4>>2]=1;G1(Z,2,V,5)}if((R|0)>0){J=(L|0)==0;m=(i|0)==0;n=V+4|0;p=W+4|0;q=V+8|0;s=V+12|0;t=V+4|0;u=_+40|0;v=_+16|0;w=_+44|0;x=_+12|0;y=Z+16|0;z=S+36|0;A=S+16|0;B=S+4|0;C=S+40|0;D=S+44|0;E=S+48|0;F=Z+12|0;G=V+4|0;H=W+4|0;I=S+32|0;g=0.0;i=0;do{if(J)c=i;else c=k[L+(i<<2)>>2]|0;if(m){k[V>>2]=c;k[n>>2]=c+1;k[W>>2]=-2147483648;k[p>>2]=2147483647;H1(S,ea,V,W)}else{k[V>>2]=-2147483648;k[G>>2]=2147483647;k[W>>2]=c;k[H>>2]=c+1;H1(S,ea,V,W)}h=k[(k[a>>2]|0)+56>>2]|0;k[q>>2]=0;k[s>>2]=0;k[V>>2]=16842752;k[t>>2]=S;l=+wh[h&31](a,V,49332,0);do if((k[_>>2]&16384|0)==0?(T=k[u>>2]|0,(k[T>>2]|0)!=1):0){b=k[v>>2]|0;e=k[w>>2]|0;if((k[T+4>>2]|0)==1){b=b+(aa(k[e>>2]|0,c)|0)|0;break}else{h=k[x>>2]|0;f=(c|0)/(h|0)|0;h=c-(aa(f,h)|0)|0;b=b+(aa(k[e>>2]|0,f)|0)+(h<<2)|0;break}}else X=21;while(0);if((X|0)==21){X=0;b=(k[v>>2]|0)+(c<<2)|0}j=l-+o[b>>2];if(Y)j=+(+P(+j)>1.1920928955078125e-07&1);else j=j*j;g=g+j;h=k[y>>2]|0;if(h|0){c=k[Q>>2]|0;if((c|0)<3)b=aa(k[F>>2]|0,k[K>>2]|0)|0;else{f=k[M>>2]|0;e=0;b=1;do{b=aa(k[f+(e<<2)>>2]|0,b)|0;e=e+1|0}while((e|0)!=(c|0))}if(b|0){do if((k[Z>>2]&16384|0)==0?(U=k[M>>2]|0,(k[U>>2]|0)!=1):0){b=k[N>>2]|0;if((k[U+4>>2]|0)==1){b=h+(aa(k[b>>2]|0,i)|0)|0;break}else{f=k[F>>2]|0;c=(i|0)/(f|0)|0;f=i-(aa(c,f)|0)|0;b=h+(aa(k[b>>2]|0,c)|0)+(f<<2)|0;break}}else X=36;while(0);if((X|0)==36){X=0;b=h+(i<<2)|0}o[b>>2]=l}}b=k[z>>2]|0;if(b|0?(f=b+12|0,h=k[f>>2]|0,k[f>>2]=h+-1,(h|0)==1):0){e=k[z>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[I>>2]|0;if(b|0)break;b=B1()|0;e=k[z>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[z>>2]=0}k[z>>2]=0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[B>>2]|0)>0){e=k[C>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[B>>2]|0))}b=k[D>>2]|0;if(!((b|0)==(E|0)|(b|0)==0))ggb(k[b+-4>>2]|0);i=i+1|0}while((i|0)<(R|0))}else g=0.0;if(k[d>>2]&2031616|0)mY(Z,d);c=Z+36|0;b=k[c>>2]|0;if(b|0?(d=b+12|0,X=k[d>>2]|0,k[d>>2]=X+-1,(X|0)==1):0){e=k[c>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Z+32>>2]|0;if(!b){b=B1()|0;e=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[c>>2]=0}k[c>>2]=0;Z=Z+16|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[Q>>2]|0)>0){e=k[M>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Q>>2]|0))}b=k[N>>2]|0;if(!((b|0)==(O|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=(Y?100.0:1.0)*(g/+(R|0))}c=_+36|0;b=k[c>>2]|0;if(b|0?(Y=b+12|0,Z=k[Y>>2]|0,k[Y>>2]=Z+-1,(Z|0)==1):0){e=k[c>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[_+32>>2]|0;if(!b){b=B1()|0;e=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[c>>2]=0}k[c>>2]=0;Z=_+16|0;e=_+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[e>>2]|0)>0){c=k[_+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[_+44>>2]|0;if(!((b|0)==(_+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);c=da+36|0;b=k[c>>2]|0;if(b|0?(Z=b+12|0,_=k[Z>>2]|0,k[Z>>2]=_+-1,(_|0)==1):0){e=k[c>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[da+32>>2]|0;if(!b){b=B1()|0;e=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[c>>2]=0}k[c>>2]=0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[ca>>2]|0)>0){e=k[da+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ca>>2]|0))}b=k[ba>>2]|0;if(!((b|0)==(da+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);c=ea+36|0;b=k[c>>2]|0;if(b|0?(ca=b+12|0,da=k[ca>>2]|0,k[ca>>2]=da+-1,(da|0)==1):0){e=k[c>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[ea+32>>2]|0;if(!b){b=B1()|0;e=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[c>>2]=0}k[c>>2]=0;da=ea+16|0;e=ea+4|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[e>>2]|0)>0){c=k[ea+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[ea+44>>2]|0;if((b|0)==(ea+48|0)|(b|0)==0){r=fa;return +g}ggb(k[b+-4>>2]|0);r=fa;return +g}function vCa(){var a=0,b=0,c=0;k[206769]=0;k[206770]=0;b=ZT(20)|0;k[b>>2]=1;a=b+4|0;k[206769]=a;k[206770]=13;i[b+17>>0]=0;b=365408;c=a+13|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));ud(1488,827076,x|0)|0;k[206771]=0;k[206772]=0;b=ZT(24)|0;k[b>>2]=1;a=b+4|0;k[206771]=a;k[206772]=16;i[b+20>>0]=0;b=365422;c=a+16|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));ud(1488,827084,x|0)|0;return}function wCa(a){a=a|0;var b=0,c=0,d=0;while(1){c=fgb(12)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;Qh[c&7]()}k[c>>2]=91572;k[c+4>>2]=0;k[c+8>>2]=0;xCa(c,1);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=91676;k[b+8>>2]=c;k[a>>2]=b;k[a+4>>2]=c;k[d>>2]=(k[d>>2]|0)+1;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1)return;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);return}function xCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=a+4|0;if((b|0)==2){while(1){b=fgb(216)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}e=b+4|0;zpb(b+8|0,0,204)|0;k[b+16>>2]=1124007936;c=b+24|0;d=b+56|0;g=b+20|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=b+64|0;k[b+60>>2]=c;k[b+68>>2]=0;k[c>>2]=0;k[b+72>>2]=1124007936;c=b+80|0;d=b+112|0;g=b+76|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=b+120|0;k[b+116>>2]=c;k[b+124>>2]=0;k[c>>2]=0;k[e>>2]=10;i[b+8>>0]=1;k[b+12>>2]=2147483647;k[b>>2]=91748;k[b+128>>2]=0;k[b+132>>2]=0;k[b+136>>2]=0;k[b+140>>2]=1124007936;c=b+148|0;d=b+180|0;g=b+144|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;h=b+188|0;k[b+184>>2]=h;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[b+208>>2]=-1;k[b+212>>2]=4;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=91780;k[c+8>>2]=b;k[d>>2]=(k[d>>2]|0)+1;e=k[j>>2]|0;k[j>>2]=c;k[a+8>>2]=b;if(e|0?(a=e+4|0,j=k[a>>2]|0,k[a>>2]=j+-1,(j|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}else{while(1){b=fgb(128)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=b+4|0;e=b+8|0;g=e;h=g+104|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[b+16>>2]=1124007936;c=b+24|0;d=b+56|0;g=b+20|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=b+64|0;k[b+60>>2]=c;k[b+68>>2]=0;k[c>>2]=0;k[b+72>>2]=1124007936;c=b+80|0;d=b+112|0;g=b+76|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;h=b+120|0;k[b+116>>2]=h;k[b+124>>2]=0;k[h>>2]=0;k[f>>2]=10;i[e>>0]=1;k[b+12>>2]=2147483647;k[b>>2]=91696;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=91728;k[c+8>>2]=b;k[d>>2]=(k[d>>2]|0)+1;e=k[j>>2]|0;k[j>>2]=c;k[a+8>>2]=b;if(e|0?(a=e+4|0,j=k[a>>2]|0,k[a>>2]=j+-1,(j|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}}function yCa(a){a=a|0;ggb(a);return}function zCa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function ACa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=91800;d=a+108|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+104>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+88|0;c=a+76|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+112>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+116>>2]|0;if(!((b|0)==(a+120|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+52|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+48>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+32|0;c=a+20|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+56>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+60>>2]|0;if((b|0)==(a+64|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function BCa(a){a=a|0;ggb(a);return}function CCa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function DCa(a){a=a|0;ACa(a);ggb(a);return}function ECa(a,b){a=a|0;b=b|0;return}function FCa(a){a=a|0;k[a>>2]=91748;LCa(a+128|0);ACa(a);return}function GCa(a){a=a|0;k[a>>2]=91748;LCa(a+128|0);ACa(a);ggb(a);return}function HCa(a,b){a=a|0;b=b|0;b=k[206771]|0;k[a>>2]=b;k[a+4>>2]=k[206772];if(!b)return;a=b+-4|0;k[a>>2]=(k[a>>2]|0)+1;return}function ICa(a){a=a|0;return 2}function JCa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0.0,se=0,te=0;oe=r;r=r+2976|0;_d=oe+2912|0;$d=oe+2856|0;ae=oe+2800|0;be=oe+2744|0;Od=oe+2688|0;Pd=oe+1648|0;Qd=oe+608|0;Rd=oe+552|0;Sd=oe+496|0;ne=oe+440|0;me=oe+384|0;le=oe+328|0;ge=oe+272|0;Td=oe+216|0;Ud=oe+160|0;Vd=oe+104|0;Wd=oe+48|0;Xd=oe+32|0;Yd=oe+16|0;Zd=oe;if((c|0)<=0?(ke=_d+4|0,g=ZT(12)|0,k[g>>2]=1,je=g+4|0,k[_d>>2]=je,k[ke>>2]=5,i[g+9>>0]=0,i[je>>0]=i[365601]|0,i[je+1>>0]=i[365602]|0,i[je+2>>0]=i[365603]|0,i[je+3>>0]=i[365604]|0,i[je+4>>0]=i[365605]|0,Y8(-215,_d,372666,365607,378),k[ke>>2]=0,k[_d>>2]=0,ke=k[g>>2]|0,k[g>>2]=ke+-1,(ke|0)==1):0)ggb(k[g+-4>>2]|0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[ne>>2]=k[j>>2];p=ne+4|0;b=j+4|0;k[p>>2]=k[b>>2];ke=ne+8|0;k[ke>>2]=k[j+8>>2];k[ne+12>>2]=k[j+12>>2];k[ne+16>>2]=k[j+16>>2];k[ne+20>>2]=k[j+20>>2];k[ne+24>>2]=k[j+24>>2];k[ne+28>>2]=k[j+28>>2];k[ne+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[ne+36>>2]=g;h=ne+40|0;k[h>>2]=ke;ke=ne+48|0;m=ne+44|0;k[m>>2]=ke;k[ne+52>>2]=0;k[ke>>2]=0;if(g|0){ke=g+12|0;k[ke>>2]=(k[ke>>2]|0)+1}if((k[b>>2]|0)<3){ke=k[j+44>>2]|0;b=k[m>>2]|0;k[b>>2]=k[ke>>2];k[b+4>>2]=k[ke+4>>2];b=ne;break}k[p>>2]=0;x1(ne,k[b>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[n+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0));b=ne}else b=ne}else{Q1(ne,b,-1);b=ne}while(0);if(!((k[b>>2]&4095|0)==5?(k[ne+12>>2]|0)==(k[a+28>>2]|0):0)){k[_d>>2]=0;b=_d+4|0;k[b>>2]=0;g=ZT(72)|0;k[g>>2]=1;l=g+4|0;k[_d>>2]=l;k[b>>2]=66;i[g+70>>0]=0;j=365672;n=l+66|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(n|0));Y8(-215,_d,372666,365607,381);k[b>>2]=0;k[_d>>2]=0;ke=k[g>>2]|0;k[g>>2]=ke+-1;if((ke|0)==1)ggb(k[g+-4>>2]|0)}Fd=ne+8|0;q=k[Fd>>2]|0;if(q){k[me>>2]=1124007936;ie=me+4|0;Gd=me+8|0;he=me+40|0;l=ie;n=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(n|0));k[he>>2]=Gd;ke=me+48|0;je=me+44|0;k[je>>2]=ke;k[me+52>>2]=0;k[ke>>2]=0;k[le>>2]=1124007936;de=le+4|0;Hd=le+8|0;ce=le+40|0;l=de;n=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(n|0));k[ce>>2]=Hd;fe=le+48|0;ee=le+44|0;k[ee>>2]=fe;k[le+52>>2]=0;k[fe>>2]=0;k[ge>>2]=1124007936;Kd=ge+4|0;Id=ge+8|0;Jd=ge+40|0;l=Kd;n=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(n|0));k[Jd>>2]=Id;Md=ge+48|0;Ld=ge+44|0;k[Ld>>2]=Md;k[ge+52>>2]=0;k[Md>>2]=0;if(k[d>>2]&2031616|0){c2(d,q,1,5,-1,0,0);do if((k[d>>2]&2031616|0)==65536){j=k[d+4>>2]|0;k[_d>>2]=k[j>>2];p=_d+4|0;b=j+4|0;k[p>>2]=k[b>>2];Ed=_d+8|0;k[Ed>>2]=k[j+8>>2];k[_d+12>>2]=k[j+12>>2];k[_d+16>>2]=k[j+16>>2];k[_d+20>>2]=k[j+20>>2];k[_d+24>>2]=k[j+24>>2];k[_d+28>>2]=k[j+28>>2];k[_d+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[_d+36>>2]=g;h=_d+40|0;k[h>>2]=Ed;Ed=_d+48|0;m=_d+44|0;k[m>>2]=Ed;k[_d+52>>2]=0;k[Ed>>2]=0;if(g|0){Ed=g+12|0;k[Ed>>2]=(k[Ed>>2]|0)+1}if((k[b>>2]|0)<3){Dd=k[j+44>>2]|0;Ed=k[m>>2]|0;k[Ed>>2]=k[Dd>>2];k[Ed+4>>2]=k[Dd+4>>2];break}k[p>>2]=0;x1(_d,k[b>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[n+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0))}}else Q1(_d,d,-1);while(0);KG(me,_d)|0;h=_d+36|0;b=k[h>>2]|0;if(b|0?(Dd=b+12|0,Ed=k[Dd>>2]|0,k[Dd>>2]=Ed+-1,(Ed|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[_d+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;Ed=_d+16|0;g=_d+4|0;k[Ed>>2]=0;k[Ed+4>>2]=0;k[Ed+8>>2]=0;k[Ed+12>>2]=0;if((k[g>>2]|0)>0){h=k[_d+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[_d+44>>2]|0;if(!((b|0)==(_d+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if(k[e>>2]&2031616|0){c2(e,q,c,5,-1,0,0);do if((k[e>>2]&2031616|0)==65536){j=k[e+4>>2]|0;k[_d>>2]=k[j>>2];p=_d+4|0;b=j+4|0;k[p>>2]=k[b>>2];Ed=_d+8|0;k[Ed>>2]=k[j+8>>2];k[_d+12>>2]=k[j+12>>2];k[_d+16>>2]=k[j+16>>2];k[_d+20>>2]=k[j+20>>2];k[_d+24>>2]=k[j+24>>2];k[_d+28>>2]=k[j+28>>2];k[_d+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[_d+36>>2]=g;h=_d+40|0;k[h>>2]=Ed;Ed=_d+48|0;m=_d+44|0;k[m>>2]=Ed;k[_d+52>>2]=0;k[Ed>>2]=0;if(g|0){Ed=g+12|0;k[Ed>>2]=(k[Ed>>2]|0)+1}if((k[b>>2]|0)<3){Dd=k[j+44>>2]|0;Ed=k[m>>2]|0;k[Ed>>2]=k[Dd>>2];k[Ed+4>>2]=k[Dd+4>>2];break}k[p>>2]=0;x1(_d,k[b>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[n+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0))}}else Q1(_d,e,-1);while(0);KG(le,_d)|0;h=_d+36|0;b=k[h>>2]|0;if(b|0?(Dd=b+12|0,Ed=k[Dd>>2]|0,k[Dd>>2]=Ed+-1,(Ed|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[_d+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;Ed=_d+16|0;g=_d+4|0;k[Ed>>2]=0;k[Ed+4>>2]=0;k[Ed+8>>2]=0;k[Ed+12>>2]=0;if((k[g>>2]|0)>0){h=k[_d+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[_d+44>>2]|0;if(!((b|0)==(_d+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if(k[f>>2]&2031616|0){c2(f,q,c,5,-1,0,0);do if((k[f>>2]&2031616|0)==65536){j=k[f+4>>2]|0;k[_d>>2]=k[j>>2];p=_d+4|0;b=j+4|0;k[p>>2]=k[b>>2];Ed=_d+8|0;k[Ed>>2]=k[j+8>>2];k[_d+12>>2]=k[j+12>>2];k[_d+16>>2]=k[j+16>>2];k[_d+20>>2]=k[j+20>>2];k[_d+24>>2]=k[j+24>>2];k[_d+28>>2]=k[j+28>>2];k[_d+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[_d+36>>2]=g;h=_d+40|0;k[h>>2]=Ed;Ed=_d+48|0;m=_d+44|0;k[m>>2]=Ed;k[_d+52>>2]=0;k[Ed>>2]=0;if(g|0){Ed=g+12|0;k[Ed>>2]=(k[Ed>>2]|0)+1}if((k[b>>2]|0)<3){Dd=k[j+44>>2]|0;Ed=k[m>>2]|0;k[Ed>>2]=k[Dd>>2];k[Ed+4>>2]=k[Dd+4>>2];break}k[p>>2]=0;x1(_d,k[b>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[n+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0))}}else Q1(_d,f,-1);while(0);KG(ge,_d)|0;h=_d+36|0;b=k[h>>2]|0;if(b|0?(Dd=b+12|0,Ed=k[Dd>>2]|0,k[Dd>>2]=Ed+-1,(Ed|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[_d+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;Ed=_d+16|0;g=_d+4|0;k[Ed>>2]=0;k[Ed+4>>2]=0;k[Ed+8>>2]=0;k[Ed+12>>2]=0;if((k[g>>2]|0)>0){h=k[_d+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[_d+44>>2]|0;if(!((b|0)==(_d+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if((k[Fd>>2]|0)>0){Ka=Td+4|0;La=Td+8|0;Ma=Td+40|0;Na=Td+48|0;Oa=Td+44|0;Pa=Td+52|0;Qa=Ud+4|0;Ra=Ud+8|0;Sa=Ud+40|0;Ta=Ud+48|0;Ua=Ud+44|0;Va=Ud+52|0;Wa=Vd+4|0;Xa=Vd+8|0;Ya=Vd+40|0;Za=Vd+48|0;_a=Vd+44|0;$a=Vd+52|0;ab=_d+4|0;bb=$d+4|0;cb=ae+36|0;db=ae+16|0;eb=ae+4|0;fb=ae+40|0;gb=ae+44|0;hb=ae+48|0;ib=_d+4|0;jb=$d+4|0;kb=ae+36|0;lb=ae+16|0;mb=ae+4|0;nb=ae+40|0;ob=ae+44|0;pb=ae+48|0;qb=_d+4|0;rb=$d+4|0;sb=ae+36|0;tb=ae+16|0;ub=ae+4|0;vb=ae+40|0;wb=ae+44|0;xb=ae+48|0;yb=_d+4|0;zb=$d+4|0;Ab=a+12|0;Bb=Xd+4|0;Cb=Bb+4|0;Db=Yd+4|0;Eb=Db+4|0;Fb=Zd+4|0;Gb=Fb+4|0;Hb=Wd+36|0;Ib=Wd+16|0;Jb=Wd+4|0;Kb=Wd+40|0;Lb=Wd+44|0;Mb=Wd+48|0;Nb=Vd+36|0;Ob=Vd+16|0;Pb=Ud+36|0;Qb=Ud+16|0;Rb=Td+36|0;Sb=Td+16|0;Tb=ae+32|0;Ub=ae+32|0;Vb=ae+32|0;Wb=Od+4|0;Xb=Od+8|0;Yb=Od+12|0;Zb=Od+16|0;_b=Od+20|0;$b=Od+24|0;ac=Od+28|0;bc=Od+32|0;cc=Od+36|0;dc=Od+40|0;ec=Od+48|0;fc=Od+44|0;gc=Od+52|0;hc=a+152|0;ic=a+148|0;jc=a+212|0;kc=_d+4|0;lc=Pd+8|0;mc=Pd+4|0;nc=Qd+8|0;oc=Qd+4|0;pc=a+128|0;qc=a+156|0;rc=a+184|0;sc=Td+32|0;tc=Ud+32|0;uc=Vd+32|0;vc=Wd+32|0;wc=Sd+4|0;xc=Sd+8|0;yc=Sd+12|0;zc=Sd+16|0;Ac=Sd+20|0;Bc=Sd+24|0;Cc=Sd+28|0;Dc=Sd+40|0;Ec=Sd+48|0;Fc=Sd+44|0;Gc=Sd+52|0;Hc=_d+4|0;Ic=_d+8|0;Jc=_d+12|0;Kc=_d+16|0;Lc=_d+20|0;Mc=_d+24|0;Nc=_d+28|0;Oc=_d+32|0;Pc=_d+36|0;Qc=_d+40|0;Rc=_d+48|0;Sc=_d+44|0;Tc=_d+52|0;Uc=$d+4|0;Vc=$d+8|0;Wc=$d+40|0;Xc=$d+48|0;Yc=$d+44|0;Zc=$d+52|0;_c=ae+4|0;$c=ae+8|0;ad=ae+40|0;bd=ae+48|0;cd=ae+44|0;dd=ae+52|0;ed=ae+36|0;fd=ae+16|0;gd=$d+36|0;hd=$d+16|0;id=Sd+36|0;jd=Sd+32|0;kd=$d+32|0;ld=ae+32|0;md=a+196|0;nd=a+200|0;od=$d+12|0;pd=be+4|0;qd=be+4|0;rd=be+4|0;sd=be+8|0;td=be+12|0;ud=be+16|0;vd=be+20|0;wd=be+24|0;xd=be+28|0;yd=be+32|0;zd=be+36|0;Ad=be+40|0;Bd=be+48|0;Cd=be+44|0;Dd=be+52|0;Ed=be+4|0;C=a+140|0;D=be+4|0;E=be+8|0;F=be+12|0;G=be+16|0;H=be+20|0;I=be+24|0;J=be+28|0;K=be+32|0;L=be+36|0;M=be+40|0;N=be+48|0;O=be+44|0;Q=be+52|0;R=be+4|0;S=$d+4|0;T=$d+8|0;U=$d+12|0;V=$d+16|0;W=$d+20|0;X=$d+24|0;Y=$d+28|0;Z=$d+40|0;_=$d+48|0;$=$d+44|0;ba=$d+52|0;ca=_d+8|0;da=_d+12|0;ea=_d+4|0;fa=$d+36|0;ga=$d+32|0;ha=_d+4|0;ia=_d+8|0;ja=_d+12|0;ka=_d+16|0;la=_d+20|0;ma=_d+24|0;na=_d+28|0;oa=_d+32|0;pa=_d+36|0;qa=_d+40|0;ra=_d+48|0;sa=_d+44|0;ta=_d+52|0;ua=Rd+4|0;va=Rd+8|0;wa=Rd+12|0;xa=Rd+16|0;ya=Rd+20|0;za=Rd+24|0;Aa=Rd+28|0;Ba=Rd+40|0;Ca=Rd+48|0;Da=Rd+44|0;Ea=Rd+52|0;Fa=$d+4|0;Ga=Fa+4|0;Ha=Rd+36|0;Ia=Rd+32|0;Ja=_d+4|0;j=0;while(1){k[Td>>2]=1124007936;l=Ka;n=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(n|0));k[Ma>>2]=La;k[Oa>>2]=Na;k[Pa>>2]=0;k[Na>>2]=0;k[Ud>>2]=1124007936;l=Qa;n=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(n|0));k[Sa>>2]=Ra;k[Ua>>2]=Ta;k[Va>>2]=0;k[Ta>>2]=0;k[Vd>>2]=1124007936;l=Wa;n=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(n|0));k[Ya>>2]=Xa;k[_a>>2]=Za;k[$a>>2]=0;k[Za>>2]=0;if((k[Gd>>2]|0)>(j|0)){k[_d>>2]=j;k[ab>>2]=j+1;k[$d>>2]=-2147483648;k[bb>>2]=2147483647;H1(ae,me,_d,$d);KG(Td,ae)|0;b=k[cb>>2]|0;if(b|0?(A=b+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){g=k[cb>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[Tb>>2]|0;if(b|0)break;b=B1()|0;g=k[cb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[cb>>2]=0}k[cb>>2]=0;k[db>>2]=0;k[db+4>>2]=0;k[db+8>>2]=0;k[db+12>>2]=0;if((k[eb>>2]|0)>0){g=k[fb>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[eb>>2]|0))}b=k[gb>>2]|0;if(!((b|0)==(hb|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if((k[Hd>>2]|0)>(j|0)){k[_d>>2]=j;k[ib>>2]=j+1;k[$d>>2]=-2147483648;k[jb>>2]=2147483647;H1(ae,le,_d,$d);KG(Ud,ae)|0;b=k[kb>>2]|0;if(b|0?(A=b+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){g=k[kb>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[Ub>>2]|0;if(b|0)break;b=B1()|0;g=k[kb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[kb>>2]=0}k[kb>>2]=0;k[lb>>2]=0;k[lb+4>>2]=0;k[lb+8>>2]=0;k[lb+12>>2]=0;if((k[mb>>2]|0)>0){g=k[nb>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[mb>>2]|0))}b=k[ob>>2]|0;if(!((b|0)==(pb|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if((k[Id>>2]|0)>(j|0)){h=j+1|0;k[_d>>2]=j;k[qb>>2]=h;k[$d>>2]=-2147483648;k[rb>>2]=2147483647;H1(ae,ge,_d,$d);KG(Vd,ae)|0;b=k[sb>>2]|0;if(b|0?(A=b+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){g=k[sb>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[Vb>>2]|0;if(b|0)break;b=B1()|0;g=k[sb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[sb>>2]=0}k[sb>>2]=0;k[tb>>2]=0;k[tb+4>>2]=0;k[tb+8>>2]=0;k[tb+12>>2]=0;if((k[ub>>2]|0)>0){g=k[vb>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ub>>2]|0))}b=k[wb>>2]|0;if(!((b|0)==(xb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);B=h}else B=j+1|0;k[_d>>2]=j;k[yb>>2]=B;k[$d>>2]=-2147483648;k[zb>>2]=2147483647;H1(Wd,ne,_d,$d);m=k[Ab>>2]|0;b=Cb;k[b>>2]=0;k[b+4>>2]=0;k[Xd>>2]=33619968;k[Bb>>2]=Td;b=Eb;k[b>>2]=0;k[b+4>>2]=0;k[Yd>>2]=33619968;k[Db>>2]=Ud;b=Gb;k[b>>2]=0;k[b+4>>2]=0;k[Zd>>2]=33619968;k[Fb>>2]=Vd;k[Od>>2]=k[Wd>>2];b=k[Jb>>2]|0;k[Wb>>2]=b;k[Xb>>2]=k[Wd+8>>2];k[Yb>>2]=k[Wd+12>>2];k[Zb>>2]=k[Ib>>2];k[_b>>2]=k[Wd+20>>2];k[$b>>2]=k[Wd+24>>2];k[ac>>2]=k[Wd+28>>2];k[bc>>2]=k[vc>>2];g=k[Hb>>2]|0;k[cc>>2]=g;k[dc>>2]=Xb;k[fc>>2]=ec;k[gc>>2]=0;k[ec>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[Jb>>2]|0}if((b|0)>=3){k[Wb>>2]=0;x1(Od,b,0,0,0);if((k[Wb>>2]|0)>0){g=k[Kb>>2]|0;h=k[dc>>2]|0;j=k[Lb>>2]|0;l=k[fc>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[g+(b<<2)>>2];k[l+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[Wb>>2]|0))}}else{z=k[Lb>>2]|0;A=k[fc>>2]|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2]}if((k[Od>>2]&20479|0)==16389){h=k[Wb>>2]|0;if((h|0)<3)b=aa(k[Yb>>2]|0,k[Xb>>2]|0)|0;else{j=k[dc>>2]|0;g=0;b=1;do{b=aa(k[j+(g<<2)>>2]|0,b)|0;g=g+1|0}while((g|0)!=(h|0))}if((b|0)!=(k[hc>>2]|0))Nd=167}else Nd=167;if((Nd|0)==167){Nd=0;k[_d>>2]=0;k[Ja>>2]=0;b=ZT(96)|0;k[b>>2]=1;l=b+4|0;k[_d>>2]=l;k[Ja>>2]=89;i[b+93>>0]=0;j=372576;n=l+89|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(n|0));Y8(-215,_d,372666,372413,280);k[Ja>>2]=0;k[_d>>2]=0;A=k[b>>2]|0;k[b>>2]=A+-1;if((A|0)==1)ggb(k[b+-4>>2]|0);b=k[hc>>2]|0}x=k[Zb>>2]|0;y=k[ic>>2]|0;y=(y|0)<(c|0)?y:c;if((y|0)>0)switch(k[jc>>2]|0){case 2:case 4:break;default:Nd=172}else Nd=172;if((Nd|0)==172){Nd=0;k[_d>>2]=0;k[kc>>2]=0;g=ZT(60)|0;k[g>>2]=1;l=g+4|0;k[_d>>2]=l;k[kc>>2]=53;i[g+57>>0]=0;j=372678;n=l+53|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(n|0));Y8(-215,_d,372666,372413,285);k[kc>>2]=0;k[_d>>2]=0;A=k[g>>2]|0;k[g>>2]=A+-1;if((A|0)==1)ggb(k[g+-4>>2]|0)}h=(y<<3)+8|0;k[Pd>>2]=lc;k[mc>>2]=1032;if(h>>>0>1032){while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[Pd>>2]=g;A=g}else A=lc;k[mc>>2]=h;z=A+(y<<2)+4|0;k[Qd>>2]=nc;k[oc>>2]=1032;while(1){g=fgb(8192)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[Qd>>2]=g;k[oc>>2]=8192;u=(m|0)<1?1:m;a:do if((u|0)>0){v=g+4|0;w=(b|0)>0;j=0;l=0;a=0;while(1){q=(a|0)==(y|0);f=z+(a+-1<<2)|0;h=l;b:while(1){do if(!j){m=k[pc>>2]|0;if(q){t=0.0;j=0;l=0;Nd=205}else{t=0.0;j=0;l=0;Nd=204}}else{if(!h){b=a;break a}while(1){l=k[v>>2]|0;s=+o[g>>2];e=h;h=h+-1|0;c:do if((e|0)>1){e=g+(h<<3)|0;d=g;p=k[d>>2]|0;d=k[d+4>>2]|0;pe=e;m=k[pe+4>>2]|0;n=g;k[n>>2]=k[pe>>2];k[n+4>>2]=m;k[e>>2]=p;k[e+4>>2]=d;t=+o[g>>2];if((h|0)>1){d=0;m=2;p=1}else break;while(1){do if((m|0)<(h|0)){if(!(+o[g+(m<<3)>>2]<+o[g+(p<<3)>>2])){m=p;break}}else m=p;while(0);n=g+(m<<3)|0;if(+o[n>>2]>=t)break c;e=g+(d<<3)|0;p=e;pe=k[p>>2]|0;p=k[p+4>>2]|0;qe=n;d=k[qe+4>>2]|0;k[e>>2]=k[qe>>2];k[e+4>>2]=d;k[n>>2]=pe;k[n+4>>2]=p;n=m<<1;p=n|1;if((p|0)>=(h|0))break;else{d=m;m=n+2|0}}}while(0);if(q){if(!((l|0)<0?1:s>+o[f>>2])){Nd=200;break}}else if((l|0)>=0){Nd=202;break}if(!h){b=a;break a}}if((Nd|0)==200){t=s;m=k[pc>>2]|0;Nd=205;break}else if((Nd|0)==202){t=s;m=k[pc>>2]|0;Nd=204;break}}while(0);if((Nd|0)==204){Nd=0;e=l;l=h;while(1){h=k[m+(e<<4)>>2]|0;if((h|0)<0)break b;re=+o[x+(h<<2)>>2];s=+o[m+(e<<4)+12>>2];d=!(re<=s);qe=m+(e<<4)+4|0;pe=m+(e<<4)+8|0;h=k[(d?qe:pe)>>2]|0;e=k[(d?pe:qe)>>2]|0;s=re-s;if((k[jc>>2]|0)==4)s=s*s;else s=+P(+s);s=t+s;o[g+(l<<3)>>2]=s;k[g+(l<<3)+4>>2]=h;d:do if((l|0)>0){h=l;do{p=h+-1|0;n=h;h=(p|0)/2|0;if((n|0)<0)break d;d=g+(h<<3)|0;if(+o[d>>2]<=s)break d;qe=g+(n<<3)|0;pe=qe;n=k[pe>>2]|0;pe=k[pe+4>>2]|0;te=d;se=k[te+4>>2]|0;k[qe>>2]=k[te>>2];k[qe+4>>2]=se;qe=d;k[qe>>2]=n;k[qe+4>>2]=pe}while((p|0)>1)}while(0);h=((l+1|0)<1024&1)+l|0;if((e|0)<0)break;else l=h}}else if((Nd|0)==205){Nd=0;e=l;l=h;while(1){h=k[m+(e<<4)>>2]|0;if((h|0)<0)break b;re=+o[x+(h<<2)>>2];s=+o[m+(e<<4)+12>>2];qe=!(re<=s);te=m+(e<<4)+4|0;se=m+(e<<4)+8|0;h=k[(qe?te:se)>>2]|0;e=k[(qe?se:te)>>2]|0;s=re-s;if((k[jc>>2]|0)==4)s=s*s;else s=+P(+s);s=t+s;if(s>+o[f>>2])h=l;else{o[g+(l<<3)>>2]=s;k[g+(l<<3)+4>>2]=h;e:do if((l|0)>0){h=l;do{p=h+-1|0;n=h;h=(p|0)/2|0;if((n|0)<0)break e;d=g+(h<<3)|0;if(+o[d>>2]<=s)break e;te=g+(n<<3)|0;se=te;qe=k[se>>2]|0;se=k[se+4>>2]|0;n=d;pe=k[n+4>>2]|0;k[te>>2]=k[n>>2];k[te+4>>2]=pe;te=d;k[te>>2]=qe;k[te+4>>2]=se}while((p|0)>1)}while(0);h=((l+1|0)<1024&1)+l|0}if((e|0)<0)break;else l=h}}if((j|0)>=(u|0)){b=a;break a}}n=~h;m=(k[qc>>2]|0)+(aa(k[k[rc>>2]>>2]|0,n)|0)|0;do if((k[jc>>2]|0)==4){if(w){h=0;s=0.0}else{s=0.0;break}do{re=+o[x+(h<<2)>>2]-+o[m+(h<<2)>>2];s=s+re*re;h=h+1|0}while((h|0)!=(b|0))}else{if(w){h=0;s=0.0}else{s=0.0;break}do{s=s+ +P(+(+o[x+(h<<2)>>2]-+o[m+(h<<2)>>2]));h=h+1|0}while((h|0)!=(b|0))}while(0);o[z+(a<<2)>>2]=s;k[A+(a<<2)>>2]=n;f:do if((a|0)>0){h=a;do{m=h;h=h+-1|0;n=z+(h<<2)|0;t=+o[n>>2];if(t<=s)break f;qe=z+(m<<2)|0;k[n>>2]=k[qe>>2];o[qe>>2]=t;qe=A+(h<<2)|0;te=A+(m<<2)|0;se=k[qe>>2]|0;k[qe>>2]=k[te>>2];k[te>>2]=se}while((m|0)>1)}while(0);h=((a|0)<(y|0)&1)+a|0;j=j+1|0;if((j|0)>=(u|0)){b=h;break}else a=h}}else b=0;while(0);m=(b|0)<(y|0)?b:y;if(k[Xd>>2]&2031616|0){k[be>>2]=m;k[qd>>2]=1;P1(Xd,2,be,4,-1,1,0);do if((k[Xd>>2]&2031616|0)==65536){h=k[Bb>>2]|0;k[_d>>2]=k[h>>2];b=h+4|0;k[ha>>2]=k[b>>2];k[ia>>2]=k[h+8>>2];k[ja>>2]=k[h+12>>2];k[ka>>2]=k[h+16>>2];k[la>>2]=k[h+20>>2];k[ma>>2]=k[h+24>>2];k[na>>2]=k[h+28>>2];k[oa>>2]=k[h+32>>2];g=k[h+36>>2]|0;k[pa>>2]=g;k[qa>>2]=ia;k[sa>>2]=ra;k[ta>>2]=0;k[ra>>2]=0;if(g|0){te=g+12|0;k[te>>2]=(k[te>>2]|0)+1}if((k[b>>2]|0)<3){se=k[h+44>>2]|0;te=k[sa>>2]|0;k[te>>2]=k[se>>2];k[te+4>>2]=k[se+4>>2];break}k[ha>>2]=0;x1(_d,k[b>>2]|0,0,0,0);if((k[ha>>2]|0)<=0)break;j=k[h+40>>2]|0;l=k[qa>>2]|0;g=k[h+44>>2]|0;h=k[sa>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[j+(b<<2)>>2];k[h+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[ha>>2]|0))}else Q1(_d,Xd,-1);while(0);te=k[qa>>2]|0;b=k[te+4>>2]|0;te=k[te>>2]|0;k[ua>>2]=2;k[va>>2]=te;k[wa>>2]=b;k[xa>>2]=A;k[ya>>2]=A;se=za+8|0;k[se>>2]=0;k[se+4>>2]=0;k[Ba>>2]=va;k[Da>>2]=Ca;b=b<<2;k[Rd>>2]=1124024324;k[Ca>>2]=b;k[Ea>>2]=4;te=A+(aa(te,b)|0)|0;k[Aa>>2]=te;k[za>>2]=te+(0-b)+b;b=Ga;k[b>>2]=0;k[b+4>>2]=0;k[$d>>2]=33619968;k[Fa>>2]=_d;mY(Rd,$d);b=k[Ha>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[Ha>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[Ia>>2]|0;if(b|0)break;b=B1()|0;g=k[Ha>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[Ha>>2]=0}while(0);k[Ha>>2]=0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[ua>>2]|0)>0){g=k[Ba>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ua>>2]|0))}b=k[Da>>2]|0;if(!((b|0)==(Ca|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[pa>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[pa>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[oa>>2]|0;if(b|0)break;b=B1()|0;g=k[pa>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[pa>>2]=0}while(0);k[pa>>2]=0;k[ka>>2]=0;k[ka+4>>2]=0;k[ka+8>>2]=0;k[ka+12>>2]=0;if((k[ha>>2]|0)>0){g=k[qa>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ha>>2]|0))}b=k[sa>>2]|0;if(!((b|0)==(ra|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if(k[Zd>>2]&2031616|0){k[S>>2]=2;k[T>>2]=m;k[U>>2]=1;k[V>>2]=z;k[W>>2]=z;b=X+8|0;k[b>>2]=0;k[b+4>>2]=0;k[Z>>2]=T;k[$>>2]=_;k[$d>>2]=1124024325;k[_>>2]=4;k[ba>>2]=4;b=z+(m<<2)|0;k[Y>>2]=b;k[X>>2]=b+-4+4;k[ca>>2]=0;k[da>>2]=0;k[_d>>2]=16842752;k[ea>>2]=$d;ZZ(_d,.5,Zd);b=k[fa>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[fa>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[ga>>2]|0;if(b|0)break;b=B1()|0;g=k[fa>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[fa>>2]=0}while(0);k[fa>>2]=0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[S>>2]|0)>0){g=k[Z>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[S>>2]|0))}b=k[$>>2]|0;if(!((b|0)==(_|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if(!((k[Yd>>2]&2031616|0)==0?!(k[12333]&2031616|0):0)){k[wc>>2]=2;k[xc>>2]=m;k[yc>>2]=1;k[zc>>2]=A;k[Ac>>2]=A;l=Bc+8|0;k[l>>2]=0;k[l+4>>2]=0;k[Dc>>2]=xc;k[Fc>>2]=Ec;k[Sd>>2]=1124024324;k[Ec>>2]=4;k[Gc>>2]=4;l=A+(m<<2)|0;k[Cc>>2]=l;n=l+-4+4|0;k[Bc>>2]=n;te=A;k[_d>>2]=1124024324;k[Hc>>2]=2;k[Ic>>2]=m;k[Jc>>2]=1;k[Kc>>2]=te;k[Lc>>2]=te;k[Mc>>2]=n;k[Nc>>2]=l;k[Oc>>2]=0;k[Pc>>2]=0;k[Qc>>2]=Ic;k[Sc>>2]=Rc;k[Tc>>2]=0;k[Rc>>2]=4;k[_d+52>>2]=4;k[$d>>2]=1124007936;l=Uc;n=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(n|0));k[Wc>>2]=Vc;k[Yc>>2]=Xc;k[Zc>>2]=0;k[Xc>>2]=0;k[ae>>2]=1124007936;l=_c;n=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(n|0));k[ad>>2]=$c;k[cd>>2]=bd;k[dd>>2]=0;k[bd>>2]=0;do if((k[Jc>>2]|0)==1|(k[Ic>>2]|0)==1){g=k[hc>>2]|0;b=A;Nd=295}else{k[be>>2]=0;k[R>>2]=0;b=ZT(96)|0;k[b>>2]=1;l=b+4|0;k[be>>2]=l;k[R>>2]=90;i[b+94>>0]=0;j=372732;n=l+90|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(n|0));Y8(-215,be,372823,372413,478);k[R>>2]=0;k[be>>2]=0;te=k[b>>2]|0;k[b>>2]=te+-1;if((te|0)==1)ggb(k[b+-4>>2]|0);l=k[Hc>>2]|0;b=k[Kc>>2]|0;g=k[hc>>2]|0;if((l|0)<3){Nd=295;break}m=k[Qc>>2]|0;j=0;h=1;do{h=aa(k[m+(j<<2)>>2]|0,h)|0;j=j+1|0}while((j|0)!=(l|0));u=g;a=b}while(0);if((Nd|0)==295){Nd=0;h=aa(k[Jc>>2]|0,k[Ic>>2]|0)|0;u=g;a=b}g:do if(!h){b2(Yd);b2(49332)}else{if(k[Yd>>2]&2031616|0){c2(Yd,h,u,k[C>>2]&4095,-1,0,0);do if((k[Yd>>2]&2031616|0)==65536){j=k[Db>>2]|0;k[be>>2]=k[j>>2];b=j+4|0;k[D>>2]=k[b>>2];k[E>>2]=k[j+8>>2];k[F>>2]=k[j+12>>2];k[G>>2]=k[j+16>>2];k[H>>2]=k[j+20>>2];k[I>>2]=k[j+24>>2];k[J>>2]=k[j+28>>2];k[K>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[L>>2]=g;k[M>>2]=E;k[O>>2]=N;k[Q>>2]=0;k[N>>2]=0;if(g|0){te=g+12|0;k[te>>2]=(k[te>>2]|0)+1}if((k[b>>2]|0)<3){se=k[j+44>>2]|0;te=k[O>>2]|0;k[te>>2]=k[se>>2];k[te+4>>2]=k[se+4>>2];break}k[D>>2]=0;x1(be,k[b>>2]|0,0,0,0);if((k[D>>2]|0)<=0)break;l=k[j+40>>2]|0;m=k[M>>2]|0;g=k[j+44>>2]|0;j=k[O>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[l+(b<<2)>>2];k[j+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[D>>2]|0))}else Q1(be,Yd,-1);while(0);KG($d,be)|0;b=k[L>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[L>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[K>>2]|0;if(b|0)break;b=B1()|0;g=k[L>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[L>>2]=0}while(0);k[L>>2]=0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[D>>2]|0)>0){g=k[M>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[D>>2]|0))}b=k[O>>2]|0;if(!((b|0)==(N|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if(!(k[12333]&2031616))e=0;else{k[be>>2]=h;k[qd>>2]=1;P1(49332,2,be,4,-1,1,0);do if((k[12333]&2031616|0)==65536){j=k[12334]|0;k[be>>2]=k[j>>2];b=j+4|0;k[rd>>2]=k[b>>2];k[sd>>2]=k[j+8>>2];k[td>>2]=k[j+12>>2];k[ud>>2]=k[j+16>>2];k[vd>>2]=k[j+20>>2];k[wd>>2]=k[j+24>>2];k[xd>>2]=k[j+28>>2];k[yd>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[zd>>2]=g;k[Ad>>2]=sd;k[Cd>>2]=Bd;k[Dd>>2]=0;k[Bd>>2]=0;if(g|0){te=g+12|0;k[te>>2]=(k[te>>2]|0)+1}if((k[b>>2]|0)<3){se=k[j+44>>2]|0;te=k[Cd>>2]|0;k[te>>2]=k[se>>2];k[te+4>>2]=k[se+4>>2];break}k[rd>>2]=0;x1(be,k[b>>2]|0,0,0,0);if((k[rd>>2]|0)<=0)break;l=k[j+40>>2]|0;m=k[Ad>>2]|0;g=k[j+44>>2]|0;j=k[Cd>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[l+(b<<2)>>2];k[j+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[rd>>2]|0))}else Q1(be,49332,-1);while(0);KG(ae,be)|0;b=k[zd>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[zd>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[yd>>2]|0;if(b|0)break;b=B1()|0;g=k[zd>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[zd>>2]=0}while(0);k[zd>>2]=0;k[ud>>2]=0;k[ud+4>>2]=0;k[ud+8>>2]=0;k[ud+12>>2]=0;if((k[rd>>2]|0)>0){g=k[Ad>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[rd>>2]|0))}b=k[Cd>>2]|0;if(!((b|0)==(Bd|0)|(b|0)==0))ggb(k[b+-4>>2]|0);if(!(k[ae>>2]&16384)){k[be>>2]=0;k[Ed>>2]=0;b=ZT(32)|0;k[b>>2]=1;l=b+4|0;k[be>>2]=l;k[Ed>>2]=24;i[b+28>>0]=0;j=372833;n=l+24|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(n|0));Y8(-215,be,372823,372413,501);k[Ed>>2]=0;k[be>>2]=0;te=k[b>>2]|0;k[b>>2]=te+-1;if((te|0)==1)ggb(k[b+-4>>2]|0)}e=k[fd>>2]|0}d=k[md>>2]|0;d=(d|0)==(k[nd>>2]|0)?0:d;if((h|0)<=0)break;f=(d|0)==0;if(!e){p=0;while(1){b=k[a+(p<<2)>>2]|0;if(b>>>0>=(k[ic>>2]|0)>>>0){k[be>>2]=0;k[pd>>2]=0;g=ZT(40)|0;k[g>>2]=1;l=g+4|0;k[be>>2]=l;k[pd>>2]=35;i[g+39>>0]=0;j=372858;n=l+35|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(n|0));Y8(-215,be,372823,372413,509);k[pd>>2]=0;k[be>>2]=0;te=k[g>>2]|0;k[g>>2]=te+-1;if((te|0)==1)ggb(k[g+-4>>2]|0)}m=(k[qc>>2]|0)+(aa(k[k[rc>>2]>>2]|0,b)|0)|0;n=k[hd>>2]|0;do if(n|0){j=k[Uc>>2]|0;if((j|0)<3)b=aa(k[od>>2]|0,k[Vc>>2]|0)|0;else{l=k[Wc>>2]|0;g=0;b=1;do{b=aa(k[l+(g<<2)>>2]|0,b)|0;g=g+1|0}while((g|0)!=(j|0))}if(!b)break;b=m+(u<<2)-m|0;if(!b)break;wpb(n+(aa(k[k[Yc>>2]>>2]|0,p)|0)|0,m|0,b|0)|0}while(0);p=p+1|0;if((p|0)>=(h|0))break g}}else q=0;do{b=k[a+(q<<2)>>2]|0;if(b>>>0>=(k[ic>>2]|0)>>>0){k[be>>2]=0;k[pd>>2]=0;g=ZT(40)|0;k[g>>2]=1;l=g+4|0;k[be>>2]=l;k[pd>>2]=35;i[g+39>>0]=0;j=372858;n=l+35|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(n|0));Y8(-215,be,372823,372413,509);k[pd>>2]=0;k[be>>2]=0;te=k[g>>2]|0;k[g>>2]=te+-1;if((te|0)==1)ggb(k[g+-4>>2]|0)}n=(k[qc>>2]|0)+(aa(k[k[rc>>2]>>2]|0,b)|0)|0;p=k[hd>>2]|0;do if(p|0){l=k[Uc>>2]|0;if((l|0)<3)g=aa(k[od>>2]|0,k[Vc>>2]|0)|0;else{m=k[Wc>>2]|0;j=0;g=1;do{g=aa(k[m+(j<<2)>>2]|0,g)|0;j=j+1|0}while((j|0)!=(l|0))}if(!g)break;g=n+(u<<2)-n|0;if(!g)break;wpb(p+(aa(k[k[Yc>>2]>>2]|0,q)|0)|0,n|0,g|0)|0}while(0);if(!f)b=k[d+(b<<2)>>2]|0;k[e+(q<<2)>>2]=b;q=q+1|0}while((q|0)<(h|0))}while(0);b=k[ed>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[ed>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[ld>>2]|0;if(b|0)break;b=B1()|0;g=k[ed>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[ed>>2]=0}while(0);k[ed>>2]=0;k[fd>>2]=0;k[fd+4>>2]=0;k[fd+8>>2]=0;k[fd+12>>2]=0;if((k[_c>>2]|0)>0){g=k[ad>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[_c>>2]|0))}b=k[cd>>2]|0;if(!((b|0)==(bd|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[gd>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[gd>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[kd>>2]|0;if(b|0)break;b=B1()|0;g=k[gd>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[gd>>2]=0}while(0);k[gd>>2]=0;k[hd>>2]=0;k[hd+4>>2]=0;k[hd+8>>2]=0;k[hd+12>>2]=0;if((k[Uc>>2]|0)>0){g=k[Wc>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Uc>>2]|0))}b=k[Yc>>2]|0;if(!((b|0)==(Xc|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Pc>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[Pc>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[Oc>>2]|0;if(b|0)break;b=B1()|0;g=k[Pc>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[Pc>>2]=0}while(0);k[Pc>>2]=0;k[Kc>>2]=0;k[Kc+4>>2]=0;k[Kc+8>>2]=0;k[Kc+12>>2]=0;if((k[Hc>>2]|0)>0){g=k[Qc>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Hc>>2]|0))}b=k[Sc>>2]|0;if(!((b|0)==(Rc|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[id>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[id>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[jd>>2]|0;if(b|0)break;b=B1()|0;g=k[id>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[id>>2]=0}while(0);k[id>>2]=0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[wc>>2]|0)>0){g=k[Dc>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[wc>>2]|0))}b=k[Fc>>2]|0;if(!((b|0)==(Ec|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}b=k[Qd>>2]|0;if((b|0)!=(nc|0)){if(b|0)ggb(b);k[Qd>>2]=nc;k[oc>>2]=1032}b=k[Pd>>2]|0;if((b|0)!=(lc|0)){if(b|0)ggb(b);k[Pd>>2]=lc;k[mc>>2]=1032}b=k[cc>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[cc>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[bc>>2]|0;if(b|0)break;b=B1()|0;g=k[cc>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[cc>>2]=0}while(0);k[cc>>2]=0;k[Zb>>2]=0;k[Zb+4>>2]=0;k[Zb+8>>2]=0;k[Zb+12>>2]=0;if((k[Wb>>2]|0)>0){g=k[dc>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Wb>>2]|0))}b=k[fc>>2]|0;if(!((b|0)==(ec|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Hb>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[Hb>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[vc>>2]|0;if(b|0)break;b=B1()|0;g=k[Hb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[Hb>>2]=0}while(0);k[Hb>>2]=0;k[Ib>>2]=0;k[Ib+4>>2]=0;k[Ib+8>>2]=0;k[Ib+12>>2]=0;if((k[Jb>>2]|0)>0){g=k[Kb>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Jb>>2]|0))}b=k[Lb>>2]|0;if(!((b|0)==(Mb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Nb>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[Nb>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[uc>>2]|0;if(b|0)break;b=B1()|0;g=k[Nb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[Nb>>2]=0}while(0);k[Nb>>2]=0;k[Ob>>2]=0;k[Ob+4>>2]=0;k[Ob+8>>2]=0;k[Ob+12>>2]=0;if((k[Wa>>2]|0)>0){g=k[Ya>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Wa>>2]|0))}b=k[_a>>2]|0;if(!((b|0)==(Za|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Pb>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[Pb>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[tc>>2]|0;if(b|0)break;b=B1()|0;g=k[Pb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[Pb>>2]=0}while(0);k[Pb>>2]=0;k[Qb>>2]=0;k[Qb+4>>2]=0;k[Qb+8>>2]=0;k[Qb+12>>2]=0;if((k[Qa>>2]|0)>0){g=k[Sa>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Qa>>2]|0))}b=k[Ua>>2]|0;if(!((b|0)==(Ta|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Rb>>2]|0;do if(b|0){se=b+12|0;te=k[se>>2]|0;k[se>>2]=te+-1;if((te|0)!=1)break;g=k[Rb>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[sc>>2]|0;if(b|0)break;b=B1()|0;g=k[Rb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[Rb>>2]=0}while(0);k[Rb>>2]=0;k[Sb>>2]=0;k[Sb+4>>2]=0;k[Sb+8>>2]=0;k[Sb+12>>2]=0;if((k[Ka>>2]|0)>0){g=k[Ma>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ka>>2]|0))}b=k[Oa>>2]|0;if(!((b|0)==(Na|0)|(b|0)==0))ggb(k[b+-4>>2]|0);if((B|0)<(k[Fd>>2]|0))j=B;else break}}h=ge+36|0;b=k[h>>2]|0;if(b|0?(se=b+12|0,te=k[se>>2]|0,k[se>>2]=te+-1,(te|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[ge+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;te=ge+16|0;k[te>>2]=0;k[te+4>>2]=0;k[te+8>>2]=0;k[te+12>>2]=0;if((k[Kd>>2]|0)>0){g=k[Jd>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Kd>>2]|0))}b=k[Ld>>2]|0;if(!((b|0)==(Md|0)|(b|0)==0))ggb(k[b+-4>>2]|0);h=le+36|0;b=k[h>>2]|0;if(b|0?(se=b+12|0,te=k[se>>2]|0,k[se>>2]=te+-1,(te|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[le+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;te=le+16|0;k[te>>2]=0;k[te+4>>2]=0;k[te+8>>2]=0;k[te+12>>2]=0;if((k[de>>2]|0)>0){g=k[ce>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[de>>2]|0))}b=k[ee>>2]|0;if(!((b|0)==(fe|0)|(b|0)==0))ggb(k[b+-4>>2]|0);h=me+36|0;b=k[h>>2]|0;if(b|0?(se=b+12|0,te=k[se>>2]|0,k[se>>2]=te+-1,(te|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[me+32>>2]|0;if(b|0)break;b=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;te=me+16|0;k[te>>2]=0;k[te+4>>2]=0;k[te+8>>2]=0;k[te+12>>2]=0;if((k[ie>>2]|0)>0){g=k[he>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ie>>2]|0))}b=k[je>>2]|0;if(!((b|0)==(ke|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{b2(d);b2(e);b2(f)}h=ne+36|0;b=k[h>>2]|0;if(b|0?(se=b+12|0,te=k[se>>2]|0,k[se>>2]=te+-1,(te|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[ne+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;te=ne+16|0;g=ne+4|0;k[te>>2]=0;k[te+4>>2]=0;k[te+8>>2]=0;k[te+12>>2]=0;if((k[g>>2]|0)>0){h=k[ne+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[ne+44>>2]|0;if((b|0)==(ne+48|0)|(b|0)==0){r=oe;return 0.0}ggb(k[b+-4>>2]|0);r=oe;return 0.0}function KCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0.0,q=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;sa=r;r=r+1216|0;ma=sa+1192|0;ra=sa+1136|0;qa=sa+1080|0;pa=sa+1024|0;na=sa;oa=a+128|0;do if((k[b>>2]&2031616|0)==65536){e=k[b+4>>2]|0;k[ra>>2]=k[e>>2];j=ra+4|0;b=e+4|0;k[j>>2]=k[b>>2];la=ra+8|0;k[la>>2]=k[e+8>>2];k[ra+12>>2]=k[e+12>>2];k[ra+16>>2]=k[e+16>>2];k[ra+20>>2]=k[e+20>>2];k[ra+24>>2]=k[e+24>>2];k[ra+28>>2]=k[e+28>>2];k[ra+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[ra+36>>2]=c;d=ra+40|0;k[d>>2]=la;la=ra+48|0;g=ra+44|0;k[g>>2]=la;k[ra+52>>2]=0;k[la>>2]=0;if(c|0){la=c+12|0;k[la>>2]=(k[la>>2]|0)+1}if((k[b>>2]|0)<3){ka=k[e+44>>2]|0;la=k[g>>2]|0;k[la>>2]=k[ka>>2];k[la+4>>2]=k[ka+4>>2];break}k[j>>2]=0;x1(ra,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else Q1(ra,b,-1);while(0);do if((k[12333]&2031616|0)==65536){f=k[12334]|0;k[qa>>2]=k[f>>2];j=qa+4|0;c=f+4|0;k[j>>2]=k[c>>2];la=qa+8|0;k[la>>2]=k[f+8>>2];k[qa+12>>2]=k[f+12>>2];k[qa+16>>2]=k[f+16>>2];k[qa+20>>2]=k[f+20>>2];k[qa+24>>2]=k[f+24>>2];k[qa+28>>2]=k[f+28>>2];k[qa+32>>2]=k[f+32>>2];b=k[f+36>>2]|0;k[qa+36>>2]=b;d=qa+40|0;k[d>>2]=la;la=qa+48|0;g=qa+44|0;k[g>>2]=la;k[qa+52>>2]=0;k[la>>2]=0;if(b|0){la=b+12|0;k[la>>2]=(k[la>>2]|0)+1}if((k[c>>2]|0)<3){ka=k[f+44>>2]|0;la=k[g>>2]|0;k[la>>2]=k[ka>>2];k[la+4>>2]=k[ka+4>>2];break}k[j>>2]=0;x1(qa,k[c>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[f+40>>2]|0;e=k[d>>2]|0;d=k[f+44>>2]|0;c=k[g>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else Q1(qa,49332,-1);while(0);if((k[ra>>2]&4095|0)==5?(k[ra+16>>2]|0)!=0:0){d=k[ra+4>>2]|0;if((d|0)<3)b=aa(k[ra+12>>2]|0,k[ra+8>>2]|0)|0;else{e=k[ra+40>>2]|0;c=0;b=1;do{b=aa(k[e+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(d|0))}if(!b)l=26}else l=26;if((l|0)==26){k[ma>>2]=0;b=ma+4|0;k[b>>2]=0;c=ZT(52)|0;k[c>>2]=1;z=c+4|0;k[ma>>2]=z;k[b>>2]=44;i[c+48>>0]=0;w=372368;A=z+44|0;do{i[z>>0]=i[w>>0]|0;z=z+1|0;w=w+1|0}while((z|0)<(A|0));Y8(-215,ma,377442,372413,167);k[b>>2]=0;k[ma>>2]=0;la=k[c>>2]|0;k[c>>2]=la+-1;if((la|0)==1)ggb(k[c+-4>>2]|0)}b=k[oa>>2]|0;k[oa>>2]=0;ha=a+132|0;k[ha>>2]=0;ia=a+136|0;k[ia>>2]=0;if(b|0)ggb(b);KG(a+140|0,ra)|0;ca=a+156|0;s=k[ra+8>>2]|0;da=k[ra+12>>2]|0;ka=ra+16|0;ea=k[ka>>2]|0;la=ra+44|0;fa=((k[k[la>>2]>>2]|0)>>>0)/((1212424721>>>(k[ra>>2]<<2&28)&15)>>>0)|0;ga=a+196|0;b=a+200|0;e=k[b>>2]|0;d=k[ga>>2]|0;c=e-d>>2;if(s>>>0<=c>>>0){if(s>>>0<c>>>0?(m=d+(s<<2)|0,(e|0)!=(m|0)):0)k[b>>2]=e+(~((e+-4-m|0)>>>2)<<2)}else U1(ga,s-c|0);ja=qa+16|0;f=k[ja>>2]|0;if(f){d=k[qa+4>>2]|0;if((d|0)<3)b=aa(k[qa+12>>2]|0,k[qa+8>>2]|0)|0;else{e=k[qa+40>>2]|0;c=0;b=1;do{b=aa(k[e+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(d|0))}if(b){if((y2(qa,1,4,1)|0)!=(s|0)){k[ma>>2]=0;b=ma+4|0;k[b>>2]=0;c=ZT(20)|0;k[c>>2]=1;z=c+4|0;k[ma>>2]=z;k[b>>2]=12;i[c+16>>0]=0;w=372476;A=z+12|0;do{i[z>>0]=i[w>>0]|0;z=z+1|0;w=w+1|0}while((z|0)<(A|0));Y8(-215,ma,377442,372413,190);k[b>>2]=0;k[ma>>2]=0;ba=k[c>>2]|0;k[c>>2]=ba+-1;if((ba|0)==1)ggb(k[c+-4>>2]|0);f=k[ja>>2]|0}}else f=0}else f=0;X=da<<1;k[pa>>2]=1124007936;$=pa+4|0;b=pa+8|0;Z=pa+40|0;z=$;A=z+36|0;do{k[z>>2]=0;z=z+4|0}while((z|0)<(A|0));k[Z>>2]=b;ba=pa+48|0;_=pa+44|0;k[_>>2]=ba;k[pa+52>>2]=0;k[ba>>2]=0;k[ma>>2]=64;k[ma+4>>2]=X;G1(pa,2,ma,6);zpb(na|0,0,1024)|0;if(!s)c=0;else{if(s>>>0>1073741823)ad(426534,426557,304,426811);e=s<<2;d=(e|0)==0?1:e;while(1){c=fgb(d)|0;if(c|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){c=0;break}Qh[b&7]()}zpb(c|0,0,e|0)|0;b=0;do{Y=aa(b,fa)|0;k[c+(b<<2)>>2]=Y;b=b+1|0}while((b|0)!=(s|0))}k[ma>>2]=-1;k[ma+4>>2]=-1;k[ma+8>>2]=-1;o[ma+12>>2]=0.0;b=k[ha>>2]|0;if((b|0)==(k[ia>>2]|0))LHa(oa,ma);else{k[b>>2]=k[ma>>2];k[b+4>>2]=k[ma+4>>2];k[b+8>>2]=k[ma+8>>2];k[b+12>>2]=k[ma+12>>2];k[ha>>2]=(k[ha>>2]|0)+16}l=s+-1|0;Y=pa+16|0;h=k[Y>>2]|0;W=a+152|0;e=k[W>>2]|0;g=k[ca>>2]|0;if((e|0)>0?(zpb(h|0,0,e<<4|0)|0,(s|0)>=1):0){b=0;do{j=g+(k[c+(b<<2)>>2]<<2)|0;d=0;do{q=+o[j+(d<<2)>>2];V=d<<1;U=h+(V<<3)|0;V=h+((V|1)<<3)|0;t=+p[V>>3]+q*q;p[U>>3]=+p[U>>3]+q;p[V>>3]=t;d=d+1|0}while((d|0)!=(e|0));b=b+1|0}while((b|0)!=(s|0))}k[na>>2]=0;k[na+4>>2]=l;k[na+8>>2]=0;k[na+12>>2]=0;L=(da|0)>0;M=ma+4|0;N=ma+8|0;O=ma+12|0;P=ma+4|0;Q=ma+8|0;R=ma+12|0;S=ma+4|0;T=ma+4|0;U=ma+4|0;V=(f|0)==0;e=1;b=0;g=0;j=0;h=0;d=0;a:while(1){K=(e|0)>-1;m=d;while(1){G=na+(m<<4)|0;H=na+(m<<4)+4|0;I=na+(m<<4)+12|0;J=na+(m<<4)+8|0;E=l-g|0;F=(k[Y>>2]|0)+(aa(k[k[_>>2]>>2]|0,m)|0)|0;t=1.0/+(E+1|0);if(!E)break;if(L){m=-1;n=-1.0;d=0;while(1){s=d<<1;q=t*+p[F+(s<<3)>>3];q=t*+p[F+((s|1)<<3)>>3]-q*q;s=n<q;m=s?d:m;d=d+1|0;if((d|0)==(da|0))break;else n=s?q:n}}else m=-1;d=k[ha>>2]|0;D=d-(k[oa>>2]|0)>>4;E=D+1|0;k[ma>>2]=-1;k[M>>2]=-1;k[N>>2]=-1;o[O>>2]=0.0;if((d|0)==(k[ia>>2]|0)){LHa(oa,ma);d=k[ha>>2]|0}else{k[d>>2]=k[ma>>2];k[d+4>>2]=k[ma+4>>2];k[d+8>>2]=k[ma+8>>2];k[d+12>>2]=k[ma+12>>2];d=(k[ha>>2]|0)+16|0;k[ha>>2]=d}k[ma>>2]=-1;k[P>>2]=-1;k[Q>>2]=-1;o[R>>2]=0.0;if((d|0)==(k[ia>>2]|0))LHa(oa,ma);else{k[d>>2]=k[ma>>2];k[d+4>>2]=k[ma+4>>2];k[d+8>>2]=k[ma+8>>2];k[d+12>>2]=k[ma+12>>2];k[ha>>2]=(k[ha>>2]|0)+16}B=k[oa>>2]|0;k[B+(h<<4)>>2]=m;k[B+(h<<4)+4>>2]=D;k[B+(h<<4)+8>>2]=E;B=ea+(m<<2)|0;C=(l+g|0)/2|0;b:do if((l|0)>(g|0)){x=g;y=l;do{d=(y+x|0)/2|0;n=+o[B+(k[c+(x<<2)>>2]<<2)>>2];q=+o[B+(k[c+(d<<2)>>2]<<2)>>2];m=c+(y<<2)|0;s=k[m>>2]|0;t=+o[B+(s<<2)>>2];do if(n<q){if(q<t)break;d=n<t?y:x}else{if(n<t){d=x;break}d=q<t?y:d}while(0);A=c+(d<<2)|0;d=k[A>>2]|0;n=+o[B+(d<<2)>>2];k[A>>2]=s;k[m>>2]=d;d=x+-1|0;if((x|0)<=(y|0)){w=x;while(1){m=c+(w<<2)|0;s=k[m>>2]|0;u=d+1|0;v=c+(u<<2)|0;if(+o[B+(s<<2)>>2]<=n){d=k[v>>2]|0;k[v>>2]=s;k[m>>2]=d;d=u}if((w|0)<(y|0))w=w+1|0;else break}}if((d|0)==(C|0))break b;A=(d|0)>(C|0);y=A?d-((y|0)==(d|0)&1)|0:y;x=A?x:d}while((y|0)>(x|0))}while(0);y=c+(C<<2)|0;q=+o[B+(k[y>>2]<<2)>>2];if((C|0)>(g|0)){d=0;u=g;do{s=c+(u<<2)|0;n=+o[B+(k[s>>2]<<2)>>2];if(!(n<=q)){k[ma>>2]=0;k[S>>2]=0;m=ZT(28)|0;k[m>>2]=1;z=m+4|0;k[ma>>2]=z;k[S>>2]=21;i[m+25>>0]=0;w=372489;A=z+21|0;do{i[z>>0]=i[w>>0]|0;z=z+1|0;w=w+1|0}while((z|0)<(A|0));Y8(-215,ma,372511,372413,126);k[S>>2]=0;k[ma>>2]=0;A=k[m>>2]|0;k[m>>2]=A+-1;if((A|0)==1)ggb(k[m+-4>>2]|0);n=+o[B+(k[s>>2]<<2)>>2]}d=(n<q&1)+d|0;u=u+1|0}while((u|0)<(C|0));v=d}else v=0;x=(C|0)<(l|0);if(x){d=0;u=l;do{s=c+(u<<2)|0;n=+o[B+(k[s>>2]<<2)>>2];if(!(n>=q)){k[ma>>2]=0;k[T>>2]=0;m=ZT(28)|0;k[m>>2]=1;z=m+4|0;k[ma>>2]=z;k[T>>2]=21;i[m+25>>0]=0;w=372527;A=z+21|0;do{i[z>>0]=i[w>>0]|0;z=z+1|0;w=w+1|0}while((z|0)<(A|0));Y8(-215,ma,372511,372413,131);k[T>>2]=0;k[ma>>2]=0;A=k[m>>2]|0;k[m>>2]=A+-1;if((A|0)==1)ggb(k[m+-4>>2]|0);n=+o[B+(k[s>>2]<<2)>>2]}d=(n>q&1)+d|0;u=u+-1|0}while((u|0)>(C|0))}else d=0;A=d-v|0;if((((A|0)>-1?A:0-A|0)|0)>=2){k[ma>>2]=0;k[U>>2]=0;d=ZT(32)|0;k[d>>2]=1;z=d+4|0;k[ma>>2]=z;k[U>>2]=26;i[d+30>>0]=0;w=372549;A=z+26|0;do{i[z>>0]=i[w>>0]|0;z=z+1|0;w=w+1|0}while((z|0)<(A|0));Y8(-215,ma,372511,372413,134);k[U>>2]=0;k[ma>>2]=0;A=k[d>>2]|0;k[d>>2]=A+-1;if((A|0)==1)ggb(k[d+-4>>2]|0)}k[(k[oa>>2]|0)+(h<<4)+12>>2]=k[B+(k[y>>2]<<2)>>2];v=F+(X<<3)|0;w=C+1|0;s=k[W>>2]|0;u=k[ca>>2]|0;do if((s|0)>0){zpb(v|0,0,s<<4|0)|0;if(x)d=w;else break;while(1){m=u+(k[c+(d<<2)>>2]<<2)|0;h=0;do{q=+o[m+(h<<2)>>2];B=h<<1;A=v+(B<<3)|0;B=v+((B|1)<<3)|0;t=+p[B>>3]+q*q;p[A>>3]=+p[A>>3]+q;p[B>>3]=t;h=h+1|0}while((h|0)!=(s|0));if((d|0)<(l|0))d=d+1|0;else break}}while(0);if(L){d=0;do{B=F+(d<<3)|0;p[B>>3]=+p[B>>3]-+p[v+(d<<3)>>3];d=d+1|0}while((d|0)<(X|0))}j=j+1|0;k[G>>2]=g;k[H>>2]=C;k[J>>2]=D;k[I>>2]=j;k[na+(e<<4)>>2]=w;k[na+(e<<4)+4>>2]=l;k[na+(e<<4)+8>>2]=E;k[na+(e<<4)+12>>2]=j;if(K){m=e;e=e+1|0;g=w;h=E}else{l=115;break a}}e=((k[c+(g<<2)>>2]|0)>>>0)/(fa>>>0)|0;k[(k[oa>>2]|0)+(h<<4)>>2]=~e;if(V)d=e;else d=k[f+(e<<2)>>2]|0;k[(k[ga>>2]|0)+(e<<2)>>2]=d;b=(b|0)<(j|0)?j:b;d=m+-1|0;if((m|0)<=0){l=70;break}e=m;g=k[na+(d<<4)>>2]|0;l=k[na+(d<<4)+4>>2]|0;j=k[na+(d<<4)+12>>2]|0;h=k[na+(d<<4)+8>>2]|0}if((l|0)==70){k[a+208>>2]=b;l=116}else if((l|0)==115?(k[a+208>>2]=b,c|0):0)l=116;if((l|0)==116)ggb(c);d=pa+36|0;b=k[d>>2]|0;if(b|0?(oa=b+12|0,a=k[oa>>2]|0,k[oa>>2]=a+-1,(a|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[pa+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[$>>2]|0)>0){c=k[Z>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[$>>2]|0))}b=k[_>>2]|0;if(!((b|0)==(ba|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=qa+36|0;b=k[d>>2]|0;if(b|0?(a=b+12|0,pa=k[a>>2]|0,k[a>>2]=pa+-1,(pa|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[qa+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=qa+4|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[d>>2]|0)>0){c=k[qa+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[qa+44>>2]|0;if(!((b|0)==(qa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=ra+36|0;b=k[d>>2]|0;if(b|0?(pa=b+12|0,qa=k[pa>>2]|0,k[pa>>2]=qa+-1,(qa|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ra+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=ra+4|0;k[ka>>2]=0;k[ka+4>>2]=0;k[ka+8>>2]=0;k[ka+12>>2]=0;if((k[d>>2]|0)>0){c=k[ra+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[la>>2]|0;if((b|0)==(ra+48|0)|(b|0)==0){r=sa;return}ggb(k[b+-4>>2]|0);r=sa;return}function LCa(a){a=a|0;var b=0,c=0,d=0,e=0;b=k[a+68>>2]|0;c=b;if(b|0){d=a+72|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if(!((b|0)==(a+60|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=k[a>>2]|0;if(!d)return;b=a+4|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-16-d|0)>>>4)<<4);ggb(d);return}function MCa(a){a=a|0;ggb(a);return}function NCa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function OCa(a){a=a|0;ACa(a);ggb(a);return}function PCa(a,b){a=a|0;b=b|0;b=k[206769]|0;k[a>>2]=b;k[a+4>>2]=k[206770];if(!b)return;a=b+-4|0;k[a>>2]=(k[a>>2]|0)+1;return}function QCa(a){a=a|0;return 1}function RCa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;N=r;r=r+304|0;B=N+288|0;M=N+232|0;L=N+176|0;K=N+120|0;F=N+64|0;y=N+8|0;A=N;o[B>>2]=0.0;if((c|0)<=0?(J=M+4|0,g=ZT(12)|0,k[g>>2]=1,I=g+4|0,k[M>>2]=I,k[J>>2]=5,i[g+9>>0]=0,i[I>>0]=i[365601]|0,i[I+1>>0]=i[365602]|0,i[I+2>>0]=i[365603]|0,i[I+3>>0]=i[365604]|0,i[I+4>>0]=i[365605]|0,Y8(-215,M,372666,365607,322),k[J>>2]=0,k[M>>2]=0,J=k[g>>2]|0,k[g>>2]=J+-1,(J|0)==1):0)ggb(k[g+-4>>2]|0);do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[M>>2]=k[l>>2];q=M+4|0;b=l+4|0;k[q>>2]=k[b>>2];J=M+8|0;k[J>>2]=k[l+8>>2];k[M+12>>2]=k[l+12>>2];k[M+16>>2]=k[l+16>>2];k[M+20>>2]=k[l+20>>2];k[M+24>>2]=k[l+24>>2];k[M+28>>2]=k[l+28>>2];k[M+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[M+36>>2]=g;h=M+40|0;k[h>>2]=J;J=M+48|0;n=M+44|0;k[n>>2]=J;k[M+52>>2]=0;k[J>>2]=0;if(g|0){J=g+12|0;k[J>>2]=(k[J>>2]|0)+1}if((k[b>>2]|0)<3){J=k[l+44>>2]|0;b=k[n>>2]|0;k[b>>2]=k[J>>2];k[b+4>>2]=k[J+4>>2];b=M;break}k[q>>2]=0;x1(M,k[b>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[p+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0));b=M}else b=M}else{Q1(M,b,-1);b=M}while(0);if(!((k[b>>2]&4095|0)==5?(k[M+12>>2]|0)==(k[a+28>>2]|0):0)){k[L>>2]=0;b=L+4|0;k[b>>2]=0;g=ZT(72)|0;k[g>>2]=1;l=g+4|0;k[L>>2]=l;k[b>>2]=66;i[g+70>>0]=0;h=365672;m=l+66|0;do{i[l>>0]=i[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(m|0));Y8(-215,L,372666,365607,325);k[b>>2]=0;k[L>>2]=0;J=k[g>>2]|0;k[g>>2]=J+-1;if((J|0)==1)ggb(k[g+-4>>2]|0)}t=k[M+8>>2]|0;if(!t){b2(d);b2(e);b2(f);j=0.0}else{k[L>>2]=1124007936;I=L+4|0;b=L+8|0;G=L+40|0;l=I;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[G>>2]=b;J=L+48|0;H=L+44|0;k[H>>2]=J;k[L+52>>2]=0;k[J>>2]=0;k[K>>2]=1124007936;D=K+4|0;b=K+8|0;z=K+40|0;l=D;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[z>>2]=b;E=K+48|0;C=K+44|0;k[C>>2]=E;k[K+52>>2]=0;k[E>>2]=0;k[F>>2]=1124007936;x=F+4|0;b=F+8|0;v=F+40|0;l=x;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[v>>2]=b;w=F+48|0;u=F+44|0;k[u>>2]=w;k[F+52>>2]=0;k[w>>2]=0;if(!(k[d>>2]&2031616))s=0;else{c2(d,t,1,5,-1,0,0);do if((k[d>>2]&2031616|0)==65536){l=k[d+4>>2]|0;k[y>>2]=k[l>>2];q=y+4|0;b=l+4|0;k[q>>2]=k[b>>2];s=y+8|0;k[s>>2]=k[l+8>>2];k[y+12>>2]=k[l+12>>2];k[y+16>>2]=k[l+16>>2];k[y+20>>2]=k[l+20>>2];k[y+24>>2]=k[l+24>>2];k[y+28>>2]=k[l+28>>2];k[y+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[y+36>>2]=g;h=y+40|0;k[h>>2]=s;s=y+48|0;n=y+44|0;k[n>>2]=s;k[y+52>>2]=0;k[s>>2]=0;if(g|0){s=g+12|0;k[s>>2]=(k[s>>2]|0)+1}if((k[b>>2]|0)<3){d=k[l+44>>2]|0;s=k[n>>2]|0;k[s>>2]=k[d>>2];k[s+4>>2]=k[d+4>>2];break}k[q>>2]=0;x1(y,k[b>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[p+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else Q1(y,d,-1);while(0);l=KG(L,y)|0;h=y+36|0;b=k[h>>2]|0;if(b|0?(d=b+12|0,s=k[d>>2]|0,k[d>>2]=s+-1,(s|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[y+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;s=y+16|0;g=y+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[g>>2]|0)>0){h=k[y+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[y+44>>2]|0;if(!((b|0)==(y+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);s=l}if(!(k[e>>2]&2031616))d=0;else{c2(e,t,c,5,-1,0,0);do if((k[e>>2]&2031616|0)==65536){l=k[e+4>>2]|0;k[y>>2]=k[l>>2];q=y+4|0;b=l+4|0;k[q>>2]=k[b>>2];e=y+8|0;k[e>>2]=k[l+8>>2];k[y+12>>2]=k[l+12>>2];k[y+16>>2]=k[l+16>>2];k[y+20>>2]=k[l+20>>2];k[y+24>>2]=k[l+24>>2];k[y+28>>2]=k[l+28>>2];k[y+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[y+36>>2]=g;h=y+40|0;k[h>>2]=e;e=y+48|0;n=y+44|0;k[n>>2]=e;k[y+52>>2]=0;k[e>>2]=0;if(g|0){e=g+12|0;k[e>>2]=(k[e>>2]|0)+1}if((k[b>>2]|0)<3){d=k[l+44>>2]|0;e=k[n>>2]|0;k[e>>2]=k[d>>2];k[e+4>>2]=k[d+4>>2];break}k[q>>2]=0;x1(y,k[b>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[p+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else Q1(y,e,-1);while(0);l=KG(K,y)|0;h=y+36|0;b=k[h>>2]|0;if(b|0?(d=b+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[y+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;e=y+16|0;g=y+4|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[g>>2]|0)>0){h=k[y+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[y+44>>2]|0;if(!((b|0)==(y+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=l}if(!(k[f>>2]&2031616))b=0;else{c2(f,t,c,5,-1,0,0);do if((k[f>>2]&2031616|0)==65536){l=k[f+4>>2]|0;k[y>>2]=k[l>>2];q=y+4|0;b=l+4|0;k[q>>2]=k[b>>2];f=y+8|0;k[f>>2]=k[l+8>>2];k[y+12>>2]=k[l+12>>2];k[y+16>>2]=k[l+16>>2];k[y+20>>2]=k[l+20>>2];k[y+24>>2]=k[l+24>>2];k[y+28>>2]=k[l+28>>2];k[y+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[y+36>>2]=g;h=y+40|0;k[h>>2]=f;f=y+48|0;n=y+44|0;k[n>>2]=f;k[y+52>>2]=0;k[f>>2]=0;if(g|0){f=g+12|0;k[f>>2]=(k[f>>2]|0)+1}if((k[b>>2]|0)<3){e=k[l+44>>2]|0;f=k[n>>2]|0;k[f>>2]=k[e>>2];k[f+4>>2]=k[e+4>>2];break}k[q>>2]=0;x1(y,k[b>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[p+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else Q1(y,f,-1);while(0);b=KG(F,y)|0;l=y+36|0;g=k[l>>2]|0;if(g|0?(e=g+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[y+32>>2]|0;if(!g){g=B1()|0;h=k[l>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}k[l>>2]=0;f=y+16|0;h=y+4|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[h>>2]|0)>0){l=k[y+40>>2]|0;g=0;do{k[l+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[y+44>>2]|0;if(!((g|0)==(y+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0)}k[y>>2]=91832;k[y+4>>2]=a;k[y+8>>2]=c;k[y+12>>2]=M;k[y+16>>2]=s;k[y+20>>2]=d;k[y+24>>2]=b;k[y+28>>2]=B;k[A>>2]=0;k[A+4>>2]=t;TCa(y,A);j=+o[B>>2];h=F+36|0;b=k[h>>2]|0;if(b|0?(c=b+12|0,B=k[c>>2]|0,k[c>>2]=B+-1,(B|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[F+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;F=F+16|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[x>>2]|0)>0){g=k[v>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[x>>2]|0))}b=k[u>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0);h=K+36|0;b=k[h>>2]|0;if(b|0?(B=b+12|0,F=k[B>>2]|0,k[B>>2]=F+-1,(F|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[K+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;K=K+16|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[D>>2]|0)>0){g=k[z>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[D>>2]|0))}b=k[C>>2]|0;if(!((b|0)==(E|0)|(b|0)==0))ggb(k[b+-4>>2]|0);h=L+36|0;b=k[h>>2]|0;if(b|0?(F=b+12|0,K=k[F>>2]|0,k[F>>2]=K+-1,(K|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[L+32>>2]|0;if(b|0)break;b=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;L=L+16|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[I>>2]|0)>0){g=k[G>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[I>>2]|0))}b=k[H>>2]|0;if(!((b|0)==(J|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}h=M+36|0;b=k[h>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[M+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;L=M+16|0;g=M+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[g>>2]|0)>0){h=k[M+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[M+44>>2]|0;if((b|0)==(M+48|0)|(b|0)==0){r=N;return +j}ggb(k[b+-4>>2]|0);r=N;return +j}function SCa(a){a=a|0;ggb(a);return}function TCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0.0;ha=r;r=r+1072|0;da=ha;fa=b+4|0;c=k[fa>>2]|0;b=k[b>>2]|0;X=c-b|0;X=(X|0)>256?256:X;if((c|0)<=(b|0)){r=ha;return}ca=a+4|0;Y=a+12|0;Z=a+8|0;_=a+16|0;$=a+20|0;ba=a+24|0;U=a+28|0;V=da+8|0;W=da+4|0;T=b;do{H=k[ca>>2]|0;f=k[Y>>2]|0;Q=k[Z>>2]|0;P=T;T=T+X|0;R=k[_>>2]|0;K=k[$>>2]|0;J=k[ba>>2]|0;S=k[U>>2]|0;E=k[H+28>>2]|0;F=k[H+24>>2]|0;O=((c|0)<(T|0)?c:T)-P|0;N=(F|0)<(Q|0)?F:Q;c=aa(O,N)|0;d=c<<1;k[da>>2]=V;k[W>>2]=264;if(d>>>0>264){a=d>>>0>1073741823?-1:d<<2;a=(a|0)==0?1:a;while(1){b=fgb(a)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[da>>2]=b}else b=V;k[W>>2]=d;L=b+(c<<2)|0;C=k[H+88>>2]|0;D=(O|0)>0;M=(N|0)>0;if(D&M){c=0;do{d=aa(c,N)|0;a=0;do{G=a+d|0;o[b+(G<<2)>>2]=3402823466385288598117041.0e14;o[L+(G<<2)>>2]=0.0;a=a+1|0}while((a|0)<(N|0));c=c+1|0}while((c|0)!=(O|0))}if((F|0)>0){z=H+32|0;A=H+60|0;B=k[f+16>>2]|0;m=k[f+44>>2]|0;n=E+-4|0;p=(E|0)<4;q=N+-2|0;s=E&-4;t=(E|0)>0;v=(s|0)<(E|0);l=0;do{a:do if(D){w=k[z>>2]|0;x=k[A>>2]|0;y=C+(l<<2)|0;if(p){j=0;while(1){c=w+(aa(k[x>>2]|0,l)|0)|0;d=B+(aa(k[m>>2]|0,P+j|0)|0)|0;if(t){e=0.0;a=0;do{I=+o[d+(a<<2)>>2]-+o[c+(a<<2)>>2];e=e+I*I;a=a+1|0}while((a|0)!=(E|0))}else e=0.0;a=(o[u>>2]=e,k[u>>2]|0);g=aa(j,N)|0;f=b+(g<<2)|0;g=L+(g<<2)|0;d=N;while(1){if((d|0)<=0)break;c=d+-1|0;if((a|0)<(k[f+(c<<2)>>2]|0))d=c;else break}if((d|0)<(N|0)){if((q|0)>=(d|0)){a=q;while(1){G=a+1|0;k[f+(G<<2)>>2]=k[f+(a<<2)>>2];k[g+(G<<2)>>2]=k[g+(a<<2)>>2];if((a|0)>(d|0))a=a+-1|0;else break}}o[f+(d<<2)>>2]=e;k[g+(d<<2)>>2]=k[y>>2]}j=j+1|0;if((j|0)==(O|0))break a}}else j=0;do{c=w+(aa(k[x>>2]|0,l)|0)|0;d=B+(aa(k[m>>2]|0,P+j|0)|0)|0;e=0.0;a=0;do{ja=+o[d+(a<<2)>>2]-+o[c+(a<<2)>>2];G=a|1;ia=+o[d+(G<<2)>>2]-+o[c+(G<<2)>>2];G=a|2;h=+o[d+(G<<2)>>2]-+o[c+(G<<2)>>2];G=a|3;I=+o[d+(G<<2)>>2]-+o[c+(G<<2)>>2];e=e+(ja*ja+ia*ia+h*h+I*I);a=a+4|0}while((a|0)<=(n|0));if(v){a=s;do{ja=+o[d+(a<<2)>>2]-+o[c+(a<<2)>>2];e=e+ja*ja;a=a+1|0}while((a|0)!=(E|0))}a=(o[u>>2]=e,k[u>>2]|0);g=aa(j,N)|0;f=b+(g<<2)|0;g=L+(g<<2)|0;d=N;while(1){if((d|0)<=0)break;c=d+-1|0;if((a|0)<(k[f+(c<<2)>>2]|0))d=c;else break}if((d|0)<(N|0)){if((q|0)>=(d|0)){a=q;while(1){G=a+1|0;k[f+(G<<2)>>2]=k[f+(a<<2)>>2];k[g+(G<<2)>>2]=k[g+(a<<2)>>2];if((a|0)>(d|0))a=a+-1|0;else break}}o[f+(d<<2)>>2]=e;k[g+(d<<2)>>2]=k[y>>2]}j=j+1|0}while((j|0)!=(O|0))}while(0);l=l+1|0}while((l|0)!=(F|0))}I=1.0/+(N|0);if(D){E=(K|0)==0;F=(J|0)==0;G=(R|0)!=0;v=H+8|0;w=(N|0)==1;x=R+40|0;y=R+16|0;z=R+44|0;A=R+12|0;B=(S|0)!=0;C=(N|0)<1;D=J+16|0;s=J+44|0;t=K+16|0;m=K+44|0;n=M?N<<2:0;p=(Q<<2)-n|0;q=0-P|0;l=0;do{if(!E){f=k[t>>2]|0;g=aa(k[k[m>>2]>>2]|0,P+l|0)|0;c=f+g|0;if(M){d=aa(l,N)|0;a=0;do{k[c+(a<<2)>>2]=k[L+(a+d<<2)>>2];a=a+1|0}while((a|0)<(N|0));a=N}else a=0;if((a|0)<(Q|0))zpb(f+n+g|0,0,p|0)|0}if(!F){f=k[D>>2]|0;g=aa(k[k[s>>2]>>2]|0,P+l|0)|0;c=f+g|0;if(M){d=aa(l,N)|0;a=0;do{k[c+(a<<2)>>2]=k[b+(a+d<<2)>>2];a=a+1|0}while((a|0)<(N|0));a=N}else a=0;if((a|0)<(Q|0))zpb(f+n+g|0,0,p|0)|0}if(G|(l|0)==(q|0)){if(!(w|(i[v>>0]|0)==0)){j=L+((aa(l,N)|0)<<2)|0;g=N;do{if((g|0)>1){f=0;a=0}else break;g=g+-1|0;b:while(1){do{if((a|0)>=(g|0))break b;c=j+(a<<2)|0;e=+o[c>>2];a=a+1|0;d=j+(a<<2)|0;h=+o[d>>2]}while(!(e>h));o[c>>2]=h;o[d>>2]=e;f=1}}while(f);e=+o[j>>2];if(!C){a=0;c=0;f=1;while(1){if((f|0)!=(N|0)?!(+o[j+(f<<2)>>2]!=+o[j+(f+-1<<2)>>2]):0)d=c;else{c=f-c|0;if((a|0)<(c|0)){d=f;a=c;e=+o[j+(f+-1<<2)>>2]}else d=f}if((f|0)<(N|0)){c=d;f=f+1|0}else break}}}else{if(M){c=aa(l,N)|0;e=0.0;a=0;do{e=e+ +o[L+(a+c<<2)>>2];a=a+1|0}while((a|0)<(N|0))}else e=0.0;e=I*e}if(G){a=P+l|0;do if((k[R>>2]&16384|0)==0?(ea=k[x>>2]|0,(k[ea>>2]|0)!=1):0){c=k[y>>2]|0;d=k[z>>2]|0;if((k[ea+4>>2]|0)==1){a=c+(aa(k[d>>2]|0,a)|0)|0;break}else{J=k[A>>2]|0;K=(a|0)/(J|0)|0;a=a-(aa(K,J)|0)|0;a=c+(aa(k[d>>2]|0,K)|0)+(a<<2)|0;break}}else ga=77;while(0);if((ga|0)==77){ga=0;a=(k[y>>2]|0)+(a<<2)|0}o[a>>2]=e}if(B&(l|0)==(q|0))o[S>>2]=e}l=l+1|0}while((l|0)!=(O|0));b=k[da>>2]|0}if((b|0)!=(V|0)){if(b|0)ggb(b);k[da>>2]=V;k[W>>2]=264}c=k[fa>>2]|0}while((T|0)<(c|0));r=ha;return}function UCa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=91572;b=a+4|0;c=k[b>>2]|0;if(c|0?(e=c+4|0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+8>>2]=0;return}function VCa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=91572;b=k[a+4>>2]|0;if(!b){ggb(a);return}d=b+4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function WCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;f=k[a+8>>2]|0;d=g+4|0;c=ZT(20)|0;k[c>>2]=1;a=c+4|0;k[g>>2]=a;k[d>>2]=13;i[c+17>>0]=0;c=370905;e=a+13|0;do{i[a>>0]=i[c>>0]|0;a=a+1|0;c=c+1|0}while((a|0)<(e|0));c=z6(b,g)|0;a=k[g>>2]|0;k[d>>2]=0;k[g>>2]=0;if(a|0?(d=a+-4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)ggb(k[a+-8>>2]|0);k[g>>2]=l[f+8>>0];lDa(c,g);d=g+4|0;c=ZT(16)|0;k[c>>2]=1;a=c+4|0;k[g>>2]=a;k[d>>2]=9;i[c+13>>0]=0;c=366010;e=a+9|0;do{i[a>>0]=i[c>>0]|0;a=a+1|0;c=c+1|0}while((a|0)<(e|0));a=z6(b,g)|0;c=k[g>>2]|0;k[d>>2]=0;k[g>>2]=0;if(c|0?(d=c+-4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)ggb(k[c+-8>>2]|0);lDa(a,f+4|0);e=g+4|0;c=ZT(12)|0;k[c>>2]=1;a=c+4|0;k[g>>2]=a;k[e>>2]=7;i[c+11>>0]=0;i[a>>0]=i[393693]|0;i[a+1>>0]=i[393694]|0;i[a+2>>0]=i[393695]|0;i[a+3>>0]=i[393696]|0;i[a+4>>0]=i[393697]|0;i[a+5>>0]=i[393698]|0;i[a+6>>0]=i[393699]|0;a=z6(b,g)|0;c=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(c|0?(d=c+-4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)ggb(k[c+-8>>2]|0);mDa(a,f+16|0);d=g+4|0;c=ZT(16)|0;k[c>>2]=1;a=c+4|0;k[g>>2]=a;k[d>>2]=9;i[c+13>>0]=0;c=366020;e=a+9|0;do{i[a>>0]=i[c>>0]|0;a=a+1|0;c=c+1|0}while((a|0)<(e|0));a=z6(b,g)|0;c=k[g>>2]|0;k[d>>2]=0;k[g>>2]=0;if(!c){g=f+72|0;mDa(a,g);r=h;return}b=c+-4|0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)!=1){g=f+72|0;mDa(a,g);r=h;return}ggb(k[c+-8>>2]|0);g=f+72|0;mDa(a,g);r=h;return}function XCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0;q=r;r=r+64|0;o=q;n=b+4|0;c=k[n>>2]|0;if(((c|0)!=0?(k[c>>2]&64|0)!=0:0)?(g=k[(k[c+16>>2]|0)+8>>2]|0,(g|0)!=0):0){f=g;a:do if(!(f&3)){c=g;j=7}else{d=g;c=f;while(1){if(!(i[d>>0]|0))break a;d=d+1|0;c=d;if(!(c&3)){c=d;j=7;break}}}while(0);if((j|0)==7){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}m=c-f|0;h=ZT(m+8&-4)|0;k[h>>2]=1;h=h+4|0;i[h+m>>0]=0;upb(h|0,g|0,m|0)|0}else h=0;d=k[206771]|0;c=(h|0)==0;if((d|0)==(h|0))if(!c?(l=h+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){ggb(k[h+-8>>2]|0);j=23}else j=23;else{f=c?1016759:h;d=(d|0)==0?1016759:d;c=i[f>>0]|0;g=i[d>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)d=g;else{do{f=f+1|0;d=d+1|0;c=i[f>>0]|0;g=i[d>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));d=g}c=c<<24>>24==d<<24>>24;if(h|0?(l=h+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[h+-8>>2]|0);if(c)j=23;else c=1}if((j|0)==23)c=2;xCa(a,c);g=k[a+8>>2]|0;l=g+16|0;f=g+52|0;c=k[f>>2]|0;if(c|0?(j=c+12|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[g+48>>2]|0;if(!c){c=B1()|0;d=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;m=g+32|0;d=g+20|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[d>>2]|0)>0){f=k[g+56>>2]|0;c=0;do{k[f+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}m=g+72|0;f=g+108|0;c=k[f>>2]|0;if(c|0?(a=c+12|0,j=k[a>>2]|0,k[a>>2]=j+-1,(j|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[g+104>>2]|0;if(!c){c=B1()|0;d=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;j=g+88|0;d=g+76|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[d>>2]|0)>0){f=k[g+112>>2]|0;c=0;do{k[f+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k6(k[b>>2]|0,k[n>>2]|0,370905)|0;b:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break b}case 2:break;default:{c=2147483647;break b}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;j=c&2146435072;if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}c=~~e}while(0);i[g+8>>0]=(c|0)!=0&1;c=k6(k[b>>2]|0,k[n>>2]|0,366010)|0;c:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break c}case 2:break;default:{c=2147483647;break c}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;j=c&2146435072;if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}c=~~e}while(0);k[g+4>>2]=c;d=k[b>>2]|0;f=k6(d,k[n>>2]|0,393693)|0;k[o>>2]=1124007936;j=o+4|0;c=o+8|0;a=o+40|0;g=j;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[a>>2]=c;h=o+48|0;g=o+44|0;k[g>>2]=h;k[o+52>>2]=0;k[h>>2]=0;G6(d,f,l,o);f=o+36|0;c=k[f>>2]|0;if(c|0?(d=c+12|0,l=k[d>>2]|0,k[d>>2]=l+-1,(l|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[o+32>>2]|0;if(!c){c=B1()|0;d=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;l=o+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[j>>2]|0)>0){d=k[a>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[j>>2]|0))}c=k[g>>2]|0;if(!((c|0)==(h|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=k[b>>2]|0;d=k6(f,k[n>>2]|0,366020)|0;k[o>>2]=1124007936;j=o+4|0;c=o+8|0;a=o+40|0;g=j;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[a>>2]=c;h=o+48|0;g=o+44|0;k[g>>2]=h;k[o+52>>2]=0;k[h>>2]=0;G6(f,d,m,o);f=o+36|0;c=k[f>>2]|0;if(c|0?(b=c+12|0,n=k[b>>2]|0,k[b>>2]=n+-1,(n|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[o+32>>2]|0;if(!c){c=B1()|0;d=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;o=o+16|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[j>>2]|0)>0){d=k[a>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[j>>2]|0))}c=k[g>>2]|0;if((c|0)==(h|0)|(c|0)==0){r=q;return}ggb(k[c+-4>>2]|0);r=q;return}function YCa(a,b){a=a|0;b=b|0;b=k[b+8>>2]|0;jh[k[(k[b>>2]|0)+8>>2]&1023](a,b);return}function ZCa(a){a=a|0;return k[(k[a+8>>2]|0)+28>>2]|0}function _Ca(a){a=a|0;var b=0,c=0,d=0;a=k[a+8>>2]|0;if(!(k[a+32>>2]|0)){d=0;return d|0}d=k[a+20>>2]|0;if((d|0)<3)a=aa(k[a+28>>2]|0,k[a+24>>2]|0)|0;else{c=k[a+56>>2]|0;b=0;a=1;do{a=aa(k[c+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(d|0))}d=(a|0)!=0;return d|0}function $Ca(a){a=a|0;return (i[(k[a+8>>2]|0)+8>>0]|0)!=0|0}function aDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+192|0;q=s+128|0;p=s+72|0;g=s+16|0;j=s;h=k[a+8>>2]|0;b=b+4|0;n=k[b>>2]|0;eh[k[(k[n>>2]|0)+44>>2]&255](q,n,0,1,1);k[p>>2]=1124007936;n=p+4|0;a=p+8|0;l=p+40|0;e=n;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[l>>2]=a;o=p+48|0;m=p+44|0;k[m>>2]=o;k[p+52>>2]=0;k[o>>2]=0;d=k[b>>2]|0;jh[k[(k[d>>2]|0)+48>>2]&1023](g,d);d=j+4|0;a=d+4|0;k[a>>2]=0;k[a+4>>2]=0;k[j>>2]=33619968;k[d>>2]=p;SW(g,j,5,1.0,0.0);d=g+36|0;a=k[d>>2]|0;if(a|0?(e=a+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[g+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;f=g+16|0;b=g+4|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[b>>2]|0)>0){d=k[g+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[g+44>>2]|0;if(!((a|0)==(g+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);if(!(c&1))a=0;else{if(!(k[h+32>>2]|0))a=1;else{d=k[h+20>>2]|0;if((d|0)<3)a=aa(k[h+28>>2]|0,k[h+24>>2]|0)|0;else{c=k[h+56>>2]|0;b=0;a=1;do{a=aa(k[c+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(d|0))}a=(a|0)==0}a=a^1}if((k[q>>2]&4095|0)!=5){k[j>>2]=0;b=j+4|0;k[b>>2]=0;d=ZT(36)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[b>>2]=28;i[d+32>>0]=0;c=365908;f=e+28|0;do{i[e>>0]=i[c>>0]|0;e=e+1|0;c=c+1|0}while((e|0)<(f|0));Y8(-215,j,389152,365607,81);k[b>>2]=0;k[j>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0)}do if(a){if((k[q+12>>2]|0)==(k[h+28>>2]|0)?(k[p+12>>2]|0)==(k[h+84>>2]|0):0)break;k[j>>2]=0;a=j+4|0;k[a>>2]=0;b=ZT(80)|0;k[b>>2]=1;e=b+4|0;k[j>>2]=e;k[a>>2]=72;i[b+76>>0]=0;c=365937;f=e+72|0;do{i[e>>0]=i[c>>0]|0;e=e+1|0;c=c+1|0}while((e|0)<(f|0));Y8(-215,j,389152,365607,90);k[a>>2]=0;k[j>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0)}else{d=h+52|0;a=k[d>>2]|0;if(a|0?(f=a+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[h+48>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;g=h+32|0;b=h+20|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[b>>2]|0)>0){d=k[h+56>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}d=h+108|0;a=k[d>>2]|0;if(a|0?(f=a+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[h+104>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;g=h+88|0;b=h+76|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[b>>2]|0)>0){d=k[h+112>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}}while(0);a=h+16|0;L1(a,q);L1(h+72|0,p);d=k[(k[h>>2]|0)+20>>2]|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;jh[d&1023](h,j);d=p+36|0;a=k[d>>2]|0;if(a|0?(h=a+12|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[p+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;p=p+16|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[n>>2]|0)>0){b=k[l>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[m>>2]|0;if(!((a|0)==(o|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=q+36|0;a=k[d>>2]|0;if(a|0?(o=a+12|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;p=q+16|0;b=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[b>>2]|0)>0){d=k[q+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[q+44>>2]|0;if((a|0)==(q+48|0)|(a|0)==0){r=s;return 1}ggb(k[a+-4>>2]|0);r=s;return 1}function bDa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=k[a+8>>2]|0;return +(+pi[k[(k[d>>2]|0)+16>>2]&7](d,b,k[d+4>>2]|0,c,49332,49332))}function cDa(a){a=a|0;return k[(k[a+8>>2]|0)+4>>2]|0}function dDa(a,b){a=a|0;b=b|0;k[(k[a+8>>2]|0)+4>>2]=b;return}function eDa(a){a=a|0;return (i[(k[a+8>>2]|0)+8>>0]|0)!=0|0}function fDa(a,b){a=a|0;b=b|0;i[(k[a+8>>2]|0)+8>>0]=b&1;return}function gDa(a){a=a|0;return k[(k[a+8>>2]|0)+12>>2]|0}function hDa(a,b){a=a|0;b=b|0;k[(k[a+8>>2]|0)+12>>2]=b;return}function iDa(a){a=a|0;a=k[a+8>>2]|0;return Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0}function jDa(a,b){a=a|0;b=b|0;xCa(a,(b+-1|0)>>>0>1?1:b);return}function kDa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=k[a+8>>2]|0;return +(+pi[k[(k[a>>2]|0)+16>>2]&7](a,b,c,d,e,f))}function lDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function mDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;e=h;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=h;return}f=a+32|0;if((k[f>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[e>>2]=g;k[c>>2]=30;i[d+34>>0]=0;j=401220;l=g+30|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}D6(a,a+12|0,b);if(!(k[f>>2]&4)){r=h;return}k[f>>2]=6;r=h;return}function nDa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=91852;d=a+220|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+216>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+200|0;c=a+188|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+224>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+228>>2]|0;if(!((b|0)==(a+232|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+164|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+160>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+144|0;c=a+132|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+168>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+172>>2]|0;if(!((b|0)==(a+176|0)|(b|0)==0))ggb(k[b+-4>>2]|0);SAa(k[a+120>>2]|0);SAa(k[a+108>>2]|0);d=a+84|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+80>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+64|0;c=a+52|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+88>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+92>>2]|0;if((b|0)==(a+96|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function oDa(a){a=a|0;nDa(a);ggb(a);return}function pDa(a){a=a|0;var b=0,c=0,d=0;d=a+84|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+80>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+64|0;c=a+52|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+88>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+164|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+160>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+144|0;c=a+132|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+168>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+220|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+216>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+200|0;d=a+188|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)<=0)return;c=k[a+224>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0));return}function qDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0;s=r;r=r+32|0;o=s+16|0;q=s;if(!(Xh[k[(k[b>>2]|0)+12>>2]&1023](b)|0)){c=o+4|0;d=ZT(40)|0;k[d>>2]=1;h=d+4|0;k[o>>2]=h;k[c>>2]=32;i[d+36>>0]=0;j=366966;l=h+32|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,o,370627,366088,552);k[c>>2]=0;k[o>>2]=0;n=k[d>>2]|0;k[d>>2]=n+-1;if((n|0)==1)ggb(k[d+-4>>2]|0)};k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;while(1){c=fgb(32)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[q>>2]=c;k[q+8>>2]=-2147483616;k[q+4>>2]=31;h=c;j=366999;l=h+31|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));i[c+31>>0]=0;k[o>>2]=0;d=o+4|0;k[d>>2]=0;j=ZT(16)|0;k[j>>2]=1;h=j+4|0;k[o>>2]=h;k[d>>2]=10;i[j+14>>0]=0;j=367031;l=h+10|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));h=z6(b,o)|0;c=k[o>>2]|0;k[d>>2]=0;k[o>>2]=0;if(c|0?(l=c+-4|0,n=k[l>>2]|0,k[l>>2]=n+-1,(n|0)==1):0)ggb(k[c+-8>>2]|0);n=q+11|0;e=(i[n>>0]|0)<0?k[q>>2]|0:q;k[o>>2]=0;g=o+4|0;k[g>>2]=0;if(e|0){f=e;a:do if(!(f&3)){c=e;m=16}else{c=e;d=f;while(1){if(!(i[c>>0]|0)){c=d;break a}c=c+1|0;d=c;if(!(d&3)){m=16;break}}}while(0);if((m|0)==16){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}m=c-f|0;l=ZT(m+8&-4)|0;k[l>>2]=1;l=l+4|0;k[o>>2]=l;k[g>>2]=m;i[l+m>>0]=0;upb(k[o>>2]|0,e|0,m|0)|0}z6(h,o)|0;c=k[o>>2]|0;k[g>>2]=0;k[o>>2]=0;if(c|0?(l=c+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);k[o>>2]=0;m=o+4|0;k[m>>2]=0;c=ZT(12)|0;k[c>>2]=1;g=c+4|0;k[o>>2]=g;k[m>>2]=5;i[c+9>>0]=0;i[g>>0]=i[370351]|0;i[g+1>>0]=i[370352]|0;i[g+2>>0]=i[370353]|0;i[g+3>>0]=i[370354]|0;i[g+4>>0]=i[370355]|0;g=z6(b,o)|0;c=k[o>>2]|0;k[m>>2]=0;k[o>>2]=0;if(c|0?(l=c+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);e=a+8|0;if(Xh[k[(k[g>>2]|0)+12>>2]&1023](g)|0){f=g+32|0;if((k[f>>2]|0)==6){k[o>>2]=0;c=o+4|0;k[c>>2]=0;d=ZT(36)|0;k[d>>2]=1;h=d+4|0;k[o>>2]=h;k[c>>2]=30;i[d+34>>0]=0;j=401220;l=h+30|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-2,o,401251,401262,1064);k[c>>2]=0;k[o>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[g+16>>2]|0))c=0;else{c=k[g+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[g+8>>2]|0,c,+p[e>>3]);if(k[f>>2]&4|0)k[f>>2]=6}k[o>>2]=0;e=o+4|0;k[e>>2]=0;j=ZT(16)|0;k[j>>2]=1;h=j+4|0;k[o>>2]=h;k[e>>2]=10;i[j+14>>0]=0;j=375191;l=h+10|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));c=z6(b,o)|0;d=k[o>>2]|0;k[e>>2]=0;k[o>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);SDa(c,a+16|0);k[o>>2]=0;m=o+4|0;k[m>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[o>>2]=c;k[m>>2]=4;i[d+8>>0]=0;i[c>>0]=110;i[c+1>>0]=111;i[c+2>>0]=114;i[c+3>>0]=109;c=z6(b,o)|0;d=k[o>>2]|0;k[m>>2]=0;k[o>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);SDa(c,a+20|0);k[o>>2]=0;e=o+4|0;k[e>>2]=0;j=ZT(20)|0;k[j>>2]=1;h=j+4|0;k[o>>2]=h;k[e>>2]=12;i[j+16>>0]=0;j=366905;l=h+12|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));c=z6(b,o)|0;d=k[o>>2]|0;k[e>>2]=0;k[o>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);m=a+24|0;SDa(c,m);if((k[m>>2]|0)==1){k[o>>2]=0;e=o+4|0;k[e>>2]=0;j=ZT(20)|0;k[j>>2]=1;h=j+4|0;k[o>>2]=h;k[e>>2]=15;i[j+19>>0]=0;j=366918;l=h+15|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));c=z6(b,o)|0;d=k[o>>2]|0;k[e>>2]=0;k[o>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);SDa(c,a+28|0)}k[o>>2]=0;e=o+4|0;k[e>>2]=0;j=ZT(20)|0;k[j>>2]=1;h=j+4|0;k[o>>2]=h;k[e>>2]=13;i[j+17>>0]=0;j=366934;l=h+13|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));c=z6(b,o)|0;d=k[o>>2]|0;k[e>>2]=0;k[o>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);TDa(c,a+48|0);k[o>>2]=0;m=o+4|0;k[m>>2]=0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[o>>2]=c;k[m>>2]=8;i[d+12>>0]=0;d=c;i[d>>0]=110;i[d+1>>0]=95;i[d+2>>0]=108;i[d+3>>0]=97;c=c+4|0;i[c>>0]=98;i[c+1>>0]=101;i[c+2>>0]=108;i[c+3>>0]=115;c=z6(b,o)|0;d=k[o>>2]|0;k[m>>2]=0;k[o>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);TDa(c,a+184|0);k[o>>2]=0;m=o+4|0;k[m>>2]=0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[o>>2]=c;k[m>>2]=8;i[d+12>>0]=0;d=c;i[d>>0]=111;i[d+1>>0]=95;i[d+2>>0]=108;i[d+3>>0]=97;c=c+4|0;i[c>>0]=98;i[c+1>>0]=101;i[c+2>>0]=108;i[c+3>>0]=115;c=z6(b,o)|0;d=k[o>>2]|0;k[m>>2]=0;k[o>>2]=0;if(d|0?(b=d+-4|0,o=k[b>>2]|0,k[b>>2]=o+-1,(o|0)==1):0)ggb(k[d+-8>>2]|0);TDa(c,a+128|0);if((i[n>>0]|0)>=0){r=s;return}ggb(k[q>>2]|0);r=s;return}function rDa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+64|0;H=I;n=b+4|0;c=k[n>>2]|0;if(!c){c=H+4|0;e=ZT(28)|0;k[e>>2]=1;h=e+4|0;k[H>>2]=h;k[c>>2]=21;i[e+25>>0]=0;f=366878;l=h+21|0;do{i[h>>0]=i[f>>0]|0;h=h+1|0;f=f+1|0}while((h|0)<(l|0));Y8(-5,H,401059,366088,574);k[c>>2]=0;k[H>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0);c=k[n>>2]|0}c=k6(k[b>>2]|0,c,370351)|0;a:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break a}case 2:{d=+p[c+8>>3];break a}default:{d=1.e+300;break a}}while(0);p[a+8>>3]=d;c=k6(k[b>>2]|0,k[n>>2]|0,375191)|0;b:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break b}case 2:break;default:{c=2147483647;break b}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;F=c&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+16>>2]=c;c=k6(k[b>>2]|0,k[n>>2]|0,366900)|0;c:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break c}case 2:break;default:{c=2147483647;break c}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;F=c&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+20>>2]=c;c=k6(k[b>>2]|0,k[n>>2]|0,366905)|0;d:do if(c){switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break}case 2:{d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;F=c&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d;break}default:{c=2147483647;G=30;break d}}k[a+24>>2]=c;if((c|0)==1){c=k6(k[b>>2]|0,k[n>>2]|0,366918)|0;e:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break e}case 2:break;default:{c=2147483647;break e}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;F=c&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+28>>2]=c}}else{c=0;G=30}while(0);if((G|0)==30)k[a+24>>2]=c;e=k[b>>2]|0;f=k6(e,k[n>>2]|0,366934)|0;g=a+48|0;k[H>>2]=1124007936;m=H+4|0;c=H+8|0;j=H+40|0;h=m;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[j>>2]=c;l=H+48|0;h=H+44|0;k[h>>2]=l;k[H+52>>2]=0;k[l>>2]=0;G6(e,f,g,H);f=H+36|0;c=k[f>>2]|0;if(c|0?(F=c+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[H+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;G=H+16|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[m>>2]|0)>0){e=k[j>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[m>>2]|0))}c=k[h>>2]|0;if(!((c|0)==(l|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=k[b>>2]|0;f=k6(e,k[n>>2]|0,366948)|0;g=a+128|0;k[H>>2]=1124007936;m=H+4|0;c=H+8|0;j=H+40|0;h=m;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[j>>2]=c;l=H+48|0;h=H+44|0;k[h>>2]=l;k[H+52>>2]=0;k[l>>2]=0;G6(e,f,g,H);f=H+36|0;c=k[f>>2]|0;if(c|0?(F=c+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[H+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;G=H+16|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[m>>2]|0)>0){e=k[j>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[m>>2]|0))}c=k[h>>2]|0;if(!((c|0)==(l|0)|(c|0)==0))ggb(k[c+-4>>2]|0);g=k[b>>2]|0;e=k6(g,k[n>>2]|0,366957)|0;f=a+184|0;k[H>>2]=1124007936;m=H+4|0;c=H+8|0;j=H+40|0;h=m;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[j>>2]=c;l=H+48|0;h=H+44|0;k[h>>2]=l;k[H+52>>2]=0;k[l>>2]=0;G6(g,e,f,H);f=H+36|0;c=k[f>>2]|0;if(c|0?(F=c+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[H+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;G=H+16|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[m>>2]|0)>0){e=k[j>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[m>>2]|0))}c=k[h>>2]|0;if(!((c|0)==(l|0)|(c|0)==0))ggb(k[c+-4>>2]|0);q=a+136|0;if((k[q>>2]|0)<=0){r=I;return}s=a+200|0;t=a+228|0;v=a+104|0;w=a+144|0;x=a+172|0;y=a+108|0;z=y;A=a+108|0;B=a+112|0;C=a+116|0;D=a+120|0;E=D;F=a+120|0;o=a+124|0;a=0;do{c=k[s>>2]|0;g=k[t>>2]|0;n=c+(aa(k[g>>2]|0,a)|0)|0;n=k[n>>2]|0;m=k[w>>2]|0;l=k[x>>2]|0;b=m+(aa(k[l>>2]|0,a)|0)|0;f=k[y>>2]|0;do if(f){j=k[b>>2]|0;while(1){e=k[f+16>>2]|0;if((j|0)<(e|0)){e=k[f>>2]|0;if(!e){G=86;break}else f=e}else{if((e|0)>=(j|0)){G=92;break}e=f+4|0;h=k[e>>2]|0;if(!h){G=90;break}else f=h}}if((G|0)==86){k[H>>2]=f;c=f;e=f;G=93;break}else if((G|0)==90){k[H>>2]=f;c=f;G=93;break}else if((G|0)==92){G=0;k[H>>2]=f;if(!f){c=f;e=H;G=93;break}else{h=l;e=m;break}}}else{k[H>>2]=y;c=z;e=y;G=93}while(0);if((G|0)==93){while(1){f=fgb(24)|0;if(f|0)break;G=k[207666]|0;k[207666]=G+0;Qh[G&7]()}k[f+16>>2]=k[b>>2];k[f+20>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=c;k[e>>2]=f;c=k[k[v>>2]>>2]|0;if(!c)c=f;else{k[v>>2]=c;c=k[e>>2]|0}B4(k[A>>2]|0,c);k[B>>2]=(k[B>>2]|0)+1;h=k[x>>2]|0;e=k[w>>2]|0;g=k[t>>2]|0;c=k[s>>2]|0}k[f+20>>2]=n;j=e+(aa(k[h>>2]|0,a)|0)|0;j=k[j>>2]|0;h=c+(aa(k[g>>2]|0,a)|0)|0;c=k[D>>2]|0;do if(c){g=k[h>>2]|0;while(1){e=k[c+16>>2]|0;if((g|0)<(e|0)){e=k[c>>2]|0;if(!e){G=103;break}else c=e}else{if((e|0)>=(g|0)){G=109;break}f=c+4|0;e=k[f>>2]|0;if(!e){G=107;break}else c=e}}if((G|0)==103){k[H>>2]=c;e=c;f=c;G=110;break}else if((G|0)==107){k[H>>2]=c;e=c;G=110;break}else if((G|0)==109){G=0;k[H>>2]=c;if(!c){e=c;f=H;G=110;break}else break}}else{k[H>>2]=D;e=E;f=D;G=110}while(0);if((G|0)==110){while(1){c=fgb(24)|0;if(c|0)break;G=k[207666]|0;k[207666]=G+0;Qh[G&7]()}k[c+16>>2]=k[h>>2];k[c+20>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=e;k[f>>2]=c;e=k[k[C>>2]>>2]|0;if(!e)e=c;else{k[C>>2]=e;e=k[f>>2]|0}B4(k[F>>2]|0,e);k[o>>2]=(k[o>>2]|0)+1}k[c+20>>2]=j;a=a+1|0}while((a|0)<(k[q>>2]|0));r=I;return}function sDa(a,b){a=a|0;b=b|0;var c=0;c=ZT(20)|0;k[c>>2]=1;b=c+4|0;k[a>>2]=b;k[a+4>>2]=12;i[c+16>>0]=0;a=b;b=366865;c=a+12|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));return}function tDa(a){a=a|0;return k[a+60>>2]|0}function uDa(a){a=a|0;var b=0,c=0,d=0;if(!(k[a+64>>2]|0)){d=0;return d|0}d=k[a+52>>2]|0;if((d|0)<3)a=aa(k[a+60>>2]|0,k[a+56>>2]|0)|0;else{c=k[a+88>>2]|0;b=0;a=1;do{a=aa(k[c+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(d|0))}d=(a|0)!=0;return d|0}function vDa(a){a=a|0;return 1}function wDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0;Qb=r;r=r+1920|0;Bb=Qb+1152|0;zb=Qb+704|0;Lb=Qb+1856|0;Gb=Qb+256|0;Pb=Qb+1800|0;Ob=Qb+1744|0;Mb=Qb+1688|0;Fb=Qb+1632|0;C=Qb+928|0;D=Qb+480|0;Eb=Qb+1576|0;Db=Qb+1520|0;Cb=Qb+1464|0;vb=Qb+1448|0;wb=Qb;xb=Qb+1432|0;yb=Qb+1376|0;Ab=Qb+224|0;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);Nb=b+4|0;Kb=k[Nb>>2]|0;jh[k[(k[Kb>>2]|0)+36>>2]&1023](Pb,Kb);Nb=k[Nb>>2]|0;jh[k[(k[Nb>>2]|0)+64>>2]&1023](Ob,Nb);Nb=Ob+16|0;if(k[Nb>>2]|0){d=k[Ob+4>>2]|0;if((d|0)<3)c=aa(k[Ob+12>>2]|0,k[Ob+8>>2]|0)|0;else{e=k[Ob+40>>2]|0;b=0;c=1;do{c=aa(k[e+(b<<2)>>2]|0,c)|0;b=b+1|0}while((b|0)!=(d|0))}if((c|0)!=0?(k[Pb+16>>2]|0)!=0:0){d=k[Pb+4>>2]|0;if((d|0)<3)c=aa(k[Pb+12>>2]|0,k[Pb+8>>2]|0)|0;else{e=k[Pb+40>>2]|0;b=0;c=1;do{c=aa(k[e+(b<<2)>>2]|0,c)|0;b=b+1|0}while((b|0)!=(d|0))}if(!c)v=13}else v=13}else v=13;if((v|0)==13){k[Bb>>2]=0;c=Bb+4|0;k[c>>2]=0;b=ZT(44)|0;k[b>>2]=1;$a=b+4|0;k[Bb>>2]=$a;k[c>>2]=38;i[b+42>>0]=0;d=366291;ab=$a+38|0;do{i[$a>>0]=i[d>>0]|0;$a=$a+1|0;d=d+1|0}while(($a|0)<(ab|0));Y8(-215,Bb,389152,366088,136);k[c>>2]=0;k[Bb>>2]=0;Kb=k[b>>2]|0;k[b>>2]=Kb+-1;if((Kb|0)==1)ggb(k[b+-4>>2]|0)}if((k[Ob+12>>2]|0)!=1){k[Bb>>2]=0;c=Bb+4|0;k[c>>2]=0;b=ZT(40)|0;k[b>>2]=1;$a=b+4|0;k[Bb>>2]=$a;k[c>>2]=35;i[b+39>>0]=0;d=366330;ab=$a+35|0;do{i[$a>>0]=i[d>>0]|0;$a=$a+1|0;d=d+1|0}while(($a|0)<(ab|0));Y8(-5,Bb,389152,366088,141);k[c>>2]=0;k[Bb>>2]=0;Kb=k[b>>2]|0;k[b>>2]=Kb+-1;if((Kb|0)==1)ggb(k[b+-4>>2]|0)}if(!((k[Pb>>2]&4095|0)==5?(k[Ob>>2]&4095|0)==5:0)){k[Bb>>2]=0;c=Bb+4|0;k[c>>2]=0;b=ZT(52)|0;k[b>>2]=1;$a=b+4|0;k[Bb>>2]=$a;k[c>>2]=47;i[b+51>>0]=0;d=366366;ab=$a+47|0;do{i[$a>>0]=i[d>>0]|0;$a=$a+1|0;d=d+1|0}while(($a|0)<(ab|0));Y8(-5,Bb,389152,366088,149);k[c>>2]=0;k[Bb>>2]=0;Kb=k[b>>2]|0;k[b>>2]=Kb+-1;if((Kb|0)==1)ggb(k[b+-4>>2]|0)}k[Mb>>2]=1124007936;Jb=Mb+4|0;c=Mb+8|0;Hb=Mb+40|0;$a=Jb;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[Hb>>2]=c;Kb=Mb+48|0;Ib=Mb+44|0;k[Ib>>2]=Kb;k[Mb+52>>2]=0;k[Kb>>2]=0;k[zb>>2]=0;k[Lb>>2]=1124007936;y=Lb+4|0;q=Lb+8|0;x=Lb+40|0;$a=y;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[x>>2]=q;A=Lb+48|0;z=Lb+44|0;k[z>>2]=A;k[Lb+52>>2]=0;k[A>>2]=0;u=a+128|0;k[Gb>>2]=1124007936;h=Gb+4|0;c=Gb+8|0;f=Gb+40|0;$a=h;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[f>>2]=c;g=Gb+48|0;e=Gb+44|0;k[e>>2]=g;k[Gb+52>>2]=0;k[g>>2]=0;k[Bb>>2]=0;j=Bb+4|0;k[j>>2]=1;G1(Gb,2,Bb,0);KG(u,Gb)|0;d=Gb+36|0;c=k[d>>2]|0;if(c|0?(tb=c+12|0,ub=k[tb>>2]|0,k[tb>>2]=ub+-1,(ub|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[Gb+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;ub=Gb+16|0;k[ub>>2]=0;k[ub+4>>2]=0;k[ub+8>>2]=0;k[ub+12>>2]=0;if((k[h>>2]|0)>0){b=k[f>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[e>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);s=a+184|0;k[Gb>>2]=1124007936;h=Gb+4|0;c=Gb+8|0;f=Gb+40|0;$a=h;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[f>>2]=c;g=Gb+48|0;e=Gb+44|0;k[e>>2]=g;k[Gb+52>>2]=0;k[g>>2]=0;k[Bb>>2]=0;k[j>>2]=1;G1(Gb,2,Bb,0);KG(s,Gb)|0;d=Gb+36|0;c=k[d>>2]|0;if(c|0?(tb=c+12|0,ub=k[tb>>2]|0,k[tb>>2]=ub+-1,(ub|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[Gb+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;ub=Gb+16|0;k[ub>>2]=0;k[ub+4>>2]=0;k[ub+8>>2]=0;k[ub+12>>2]=0;if((k[h>>2]|0)>0){b=k[f>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[e>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=Bb+4|0;B=c+4|0;k[B>>2]=0;k[B+4>>2]=0;k[Bb>>2]=33619968;k[c>>2]=Lb;SW(Ob,Bb,4,1.0,0.0);c=k[q>>2]|0;B=a+104|0;if((c|0)>0){j=Lb+16|0;l=Lb+12|0;m=a+108|0;n=m;o=a+108|0;p=a+112|0;h=0;do{do if((k[Lb>>2]&16384|0)==0?(t=k[x>>2]|0,(k[t>>2]|0)!=1):0){b=k[j>>2]|0;d=k[z>>2]|0;if((k[t+4>>2]|0)==1){g=b+(aa(k[d>>2]|0,h)|0)|0;break}else{g=k[l>>2]|0;ub=(h|0)/(g|0)|0;g=h-(aa(ub,g)|0)|0;g=b+(aa(k[d>>2]|0,ub)|0)+(g<<2)|0;break}}else v=58;while(0);if((v|0)==58)g=(k[j>>2]|0)+(h<<2)|0;b=k[m>>2]|0;do if(b){f=k[g>>2]|0;while(1){d=k[b+16>>2]|0;if((f|0)<(d|0)){d=k[b>>2]|0;if(!d){v=66;break}else b=d}else{if((d|0)>=(f|0)){v=72;break}e=b+4|0;d=k[e>>2]|0;if(!d){v=70;break}else b=d}}if((v|0)==66){k[Bb>>2]=b;f=b;d=b;v=73;break}else if((v|0)==70){k[Bb>>2]=b;f=b;d=e;v=73;break}else if((v|0)==72){v=0;k[Bb>>2]=b;if(!b){f=b;d=Bb;v=73;break}else break}}else{k[Bb>>2]=m;f=n;d=m;v=73}while(0);if((v|0)==73){v=0;while(1){b=fgb(24)|0;if(b|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){b=0;break}Qh[c&7]()}k[b+16>>2]=k[g>>2];k[b+20>>2]=0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=f;k[d>>2]=b;c=k[k[B>>2]>>2]|0;if(!c)c=b;else{k[B>>2]=c;c=k[d>>2]|0}B4(k[o>>2]|0,c);k[p>>2]=(k[p>>2]|0)+1;c=k[q>>2]|0}ub=b+20|0;k[ub>>2]=(k[ub>>2]|0)+1;h=h+1|0}while((h|0)<(c|0));p=m}else p=a+108|0;c=k[B>>2]|0;if((c|0)!=(p|0)){j=a+108|0;l=p;m=a+112|0;h=k[zb>>2]|0;do{g=c+16|0;b=k[p>>2]|0;do if(b){f=k[g>>2]|0;while(1){d=k[b+16>>2]|0;if((f|0)<(d|0)){d=k[b>>2]|0;if(!d){v=88;break}else b=d}else{if((d|0)>=(f|0)){v=94;break}e=b+4|0;d=k[e>>2]|0;if(!d){v=92;break}else b=d}}if((v|0)==88){k[Bb>>2]=b;d=b;e=b;v=95;break}else if((v|0)==92){k[Bb>>2]=b;d=b;v=95;break}else if((v|0)==94){v=0;k[Bb>>2]=b;if(!b){d=b;e=Bb;v=95;break}else break}}else{k[Bb>>2]=p;d=l;e=j;v=95}while(0);if((v|0)==95){while(1){b=fgb(24)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b+16>>2]=k[g>>2];k[b+20>>2]=0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[B>>2]>>2]|0;if(!d)d=b;else{k[B>>2]=d;d=k[e>>2]|0}B4(k[j>>2]|0,d);k[m>>2]=(k[m>>2]|0)+1}k[b+20>>2]=h;MDa(u,g);MDa(s,zb);h=(k[zb>>2]|0)+1|0;k[zb>>2]=h;b=k[c+4>>2]|0;if(!b){b=c;while(1){c=k[b+8>>2]|0;if((k[c>>2]|0)==(b|0))break;else b=c}}else{c=b;while(1){b=k[c>>2]|0;if(!b)break;else c=b}}}while((c|0)!=(p|0));c=k[B>>2]|0}if((c|0)!=(p|0)){j=a+116|0;l=a+120|0;m=l;n=a+120|0;o=a+124|0;b=c;while(1){h=k[b+16>>2]|0;g=b+20|0;c=k[l>>2]|0;do if(c){f=k[g>>2]|0;while(1){d=k[c+16>>2]|0;if((f|0)<(d|0)){d=k[c>>2]|0;if(!d){v=124;break}else c=d}else{if((d|0)>=(f|0)){v=130;break}e=c+4|0;d=k[e>>2]|0;if(!d){v=128;break}else c=d}}if((v|0)==124){k[Bb>>2]=c;d=c;e=c;v=131;break}else if((v|0)==128){k[Bb>>2]=c;d=c;v=131;break}else if((v|0)==130){v=0;k[Bb>>2]=c;if(!c){d=c;e=Bb;v=131;break}else break}}else{k[Bb>>2]=l;d=m;e=l;v=131}while(0);if((v|0)==131){while(1){c=fgb(24)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c+16>>2]=k[g>>2];k[c+20>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=d;k[e>>2]=c;d=k[k[j>>2]>>2]|0;if(!d)d=c;else{k[j>>2]=d;d=k[e>>2]|0}B4(k[n>>2]|0,d);k[o>>2]=(k[o>>2]|0)+1}k[c+20>>2]=h;c=k[b+4>>2]|0;if(!c)while(1){c=k[b+8>>2]|0;if((k[c>>2]|0)==(b|0))break;else b=c}else while(1){b=k[c>>2]|0;if(!b)break;else c=b}if((c|0)==(p|0))break;else b=c}}d=Lb+36|0;c=k[d>>2]|0;if(c|0?(tb=c+12|0,ub=k[tb>>2]|0,k[tb>>2]=ub+-1,(ub|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[Lb+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;ub=Lb+16|0;k[ub>>2]=0;k[ub+4>>2]=0;k[ub+8>>2]=0;k[ub+12>>2]=0;if((k[y>>2]|0)>0){b=k[x>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[y>>2]|0))}c=k[z>>2]|0;if(!((c|0)==(A|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=k[a+112>>2]|0;k[Lb>>2]=1124007936;tb=Lb+4|0;c=Lb+8|0;rb=Lb+40|0;$a=tb;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[rb>>2]=c;ub=Lb+48|0;sb=Lb+44|0;k[sb>>2]=ub;k[Lb+52>>2]=0;k[ub>>2]=0;e=Pb+8|0;d=k[e>>2]|0;k[Gb>>2]=0;k[Gb+4>>2]=0;k[Gb+8>>2]=1124007936;c=Gb+16|0;b=Gb+48|0;$a=Gb+12|0;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[b>>2]=c;c=Gb+56|0;k[Gb+52>>2]=c;k[Gb+60>>2]=0;k[c>>2]=0;k[Gb+64>>2]=1124007936;c=Gb+72|0;b=Gb+104|0;$a=Gb+68|0;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[b>>2]=c;c=Gb+112|0;k[Gb+108>>2]=c;k[Gb+116>>2]=0;k[c>>2]=0;k[Gb+120>>2]=1124007936;c=Gb+128|0;b=Gb+160|0;$a=Gb+124|0;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[b>>2]=c;$a=Gb+168|0;k[Gb+164>>2]=$a;ab=$a+56|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[Bb>>2]=1;k[Bb+4>>2]=d;j1(Gb,49,Bb,5);k[zb+8>>2]=0;k[zb+12>>2]=0;k[zb>>2]=-1056571392;k[zb+4>>2]=Gb;k[Bb+8>>2]=0;k[Bb+12>>2]=0;k[Bb>>2]=16842752;k[Bb+4>>2]=Pb;qb=Fb+4|0;pb=qb+4|0;k[pb>>2]=0;k[pb+4>>2]=0;k[Fb>>2]=33619968;k[qb>>2]=Lb;P2(zb,Bb,Fb);XN(Gb);if((f|0)<2){k[Bb>>2]=0;c=Bb+4|0;k[c>>2]=0;b=ZT(40)|0;k[b>>2]=1;$a=b+4|0;k[Bb>>2]=$a;k[c>>2]=34;i[b+38>>0]=0;d=366414;ab=$a+34|0;do{i[$a>>0]=i[d>>0]|0;$a=$a+1|0;d=d+1|0}while(($a|0)<(ab|0));Y8(-5,Bb,389152,366088,165);k[c>>2]=0;k[Bb>>2]=0;qb=k[b>>2]|0;k[b>>2]=qb+-1;if((qb|0)==1)ggb(k[b+-4>>2]|0)}if((k[Ob+8>>2]|0)!=(k[e>>2]|0)){k[Bb>>2]=0;c=Bb+4|0;k[c>>2]=0;b=ZT(60)|0;k[b>>2]=1;$a=b+4|0;k[Bb>>2]=$a;k[c>>2]=53;i[b+57>>0]=0;d=366449;ab=$a+53|0;do{i[$a>>0]=i[d>>0]|0;$a=$a+1|0;d=d+1|0}while(($a|0)<(ab|0));Y8(-5,Bb,389152,366088,170);k[c>>2]=0;k[Bb>>2]=0;qb=k[b>>2]|0;k[b>>2]=qb+-1;if((qb|0)==1)ggb(k[b+-4>>2]|0)}e=Lb+12|0;d=k[e>>2]|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=1124007936;c=C+16|0;b=C+48|0;$a=C+12|0;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[b>>2]=c;c=C+56|0;k[C+52>>2]=c;k[C+60>>2]=0;k[c>>2]=0;k[C+64>>2]=1124007936;c=C+72|0;b=C+104|0;$a=C+68|0;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[b>>2]=c;c=C+112|0;k[C+108>>2]=c;k[C+116>>2]=0;k[c>>2]=0;k[C+120>>2]=1124007936;c=C+128|0;b=C+160|0;$a=C+124|0;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[b>>2]=c;$a=C+168|0;k[C+164>>2]=$a;ab=$a+56|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[Bb>>2]=d;k[Bb+4>>2]=f;j1(C,48,Bb,5);k[Gb>>2]=1124007936;pb=Gb+4|0;c=Gb+8|0;nb=Gb+40|0;$a=pb;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[nb>>2]=c;qb=Gb+48|0;ob=Gb+44|0;k[ob>>2]=qb;k[Gb+52>>2]=0;k[qb>>2]=0;d=k[C>>2]|0;dh[k[(k[d>>2]|0)+12>>2]&255](d,C,Gb,-1);XN(C);d=k[e>>2]|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=1124007936;c=D+16|0;b=D+48|0;$a=D+12|0;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[b>>2]=c;c=D+56|0;k[D+52>>2]=c;k[D+60>>2]=0;k[c>>2]=0;k[D+64>>2]=1124007936;c=D+72|0;b=D+104|0;$a=D+68|0;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[b>>2]=c;c=D+112|0;k[D+108>>2]=c;k[D+116>>2]=0;k[c>>2]=0;k[D+120>>2]=1124007936;c=D+128|0;b=D+160|0;$a=D+124|0;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[b>>2]=c;$a=D+168|0;k[D+164>>2]=$a;ab=$a+56|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[Bb>>2]=1;k[Bb+4>>2]=d;j1(D,48,Bb,5);k[Fb>>2]=1124007936;lb=Fb+4|0;c=Fb+8|0;jb=Fb+40|0;$a=lb;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[jb>>2]=c;mb=Fb+48|0;kb=Fb+44|0;k[kb>>2]=mb;k[Fb+52>>2]=0;k[mb>>2]=0;hb=k[D>>2]|0;dh[k[(k[hb>>2]|0)+12>>2]&255](hb,D,Fb,-1);XN(D);NDa(Eb,Ob,B);k[Db>>2]=1124007936;hb=Db+4|0;c=Db+8|0;fb=Db+40|0;$a=hb;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[fb>>2]=c;ib=Db+48|0;gb=Db+44|0;k[gb>>2]=ib;k[Db+52>>2]=0;k[ib>>2]=0;k[Cb>>2]=1124007936;db=Cb+4|0;c=Cb+8|0;bb=Cb+40|0;$a=db;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[bb>>2]=c;eb=Cb+48|0;cb=Cb+44|0;k[cb>>2]=eb;k[Cb+52>>2]=0;k[eb>>2]=0;if((f|0)!=2){c=k[B>>2]|0;f=a+108|0;if((c|0)!=(f|0)){g=Bb+4|0;h=g+4|0;j=a+24|0;l=Bb+36|0;m=Bb+16|0;n=Bb+4|0;o=Bb+40|0;p=Bb+44|0;q=Bb+48|0;s=vb+8|0;t=vb+12|0;u=vb+4|0;v=Bb+4|0;x=zb+4|0;y=xb+4|0;z=y+4|0;A=yb+36|0;B=yb+16|0;C=yb+4|0;D=yb+40|0;E=yb+44|0;F=yb+48|0;G=Bb+36|0;H=Bb+16|0;I=Bb+4|0;J=Bb+40|0;K=Bb+44|0;L=Bb+48|0;M=zb+4|0;N=zb+8|0;O=zb+12|0;P=zb+16|0;Q=zb+48|0;R=zb+56|0;S=zb+52|0;T=zb+60|0;U=zb+64|0;V=zb+68|0;W=zb+72|0;X=zb+104|0;Y=zb+112|0;Z=zb+108|0;_=zb+116|0;$=zb+120|0;ba=zb+124|0;ca=zb+128|0;da=zb+160|0;ea=zb+168|0;fa=zb+164|0;ga=Bb+4|0;ha=Bb+8|0;ia=Bb+12|0;ja=Bb+16|0;ka=Bb+48|0;la=Bb+56|0;ma=Bb+52|0;na=Bb+60|0;oa=Bb+64|0;pa=Bb+68|0;qa=Bb+72|0;ra=Bb+104|0;sa=Bb+112|0;ta=Bb+108|0;ua=Bb+116|0;va=Bb+120|0;wa=Bb+124|0;xa=Bb+128|0;ya=Bb+160|0;za=Bb+168|0;Aa=Bb+164|0;Ba=Bb+32|0;Ca=wb+4|0;Da=wb+8|0;Ea=wb+12|0;Fa=wb+16|0;Ga=wb+48|0;Ha=wb+56|0;Ia=wb+52|0;Ja=wb+60|0;Ka=wb+64|0;La=wb+68|0;Ma=wb+72|0;Na=wb+104|0;Oa=wb+112|0;Pa=wb+108|0;Qa=wb+116|0;Ra=wb+120|0;Sa=wb+124|0;Ta=wb+128|0;Ua=wb+160|0;Va=wb+168|0;Wa=wb+164|0;Xa=Bb+4|0;Ya=Bb+8|0;Za=yb+32|0;_a=Bb+32|0;e=0;b=c;while(1){w=+(k[b+20>>2]|0);k[zb>>2]=0;k[M>>2]=0;k[N>>2]=1124007936;$a=O;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[Q>>2]=P;k[S>>2]=R;k[T>>2]=0;k[R>>2]=0;k[U>>2]=1124007936;$a=V;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[X>>2]=W;k[Z>>2]=Y;k[_>>2]=0;k[Y>>2]=0;k[$>>2]=1124007936;$a=ba;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[da>>2]=ca;k[fa>>2]=ea;$a=ea;ab=$a+56|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));h1(zb,0,Eb,w);k[Bb>>2]=0;k[ga>>2]=0;k[ha>>2]=1124007936;$a=ia;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[ka>>2]=ja;k[ma>>2]=la;k[na>>2]=0;k[la>>2]=0;k[oa>>2]=1124007936;$a=pa;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[ra>>2]=qa;k[ta>>2]=sa;k[ua>>2]=0;k[sa>>2]=0;k[va>>2]=1124007936;$a=wa;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[ya>>2]=xa;k[Aa>>2]=za;$a=za;ab=$a+56|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));ab=k[zb>>2]|0;nh[k[(k[ab>>2]|0)+72>>2]&15](ab,zb,.00392156862745098,Bb);ab=k[Bb>>2]|0;dh[k[(k[ab>>2]|0)+12>>2]&255](ab,Bb,Db,-1);XN(Bb);XN(zb);ab=h;k[ab>>2]=0;k[ab+4>>2]=0;k[Bb>>2]=33619968;k[g>>2]=Mb;SW(Db,Bb,5,1.0,0.0);if(!(k[j>>2]|0)){ODa(Bb,a,Lb,Mb,Fb);KG(Cb,Bb)|0;c=k[l>>2]|0;do if(c|0){$a=c+12|0;ab=k[$a>>2]|0;k[$a>>2]=ab+-1;if((ab|0)!=1)break;d=k[l>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[Ba>>2]|0;if(c|0)break;c=B1()|0;d=k[l>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[l>>2]=0}while(0);k[l>>2]=0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[n>>2]|0)>0){d=k[o>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[n>>2]|0))}c=k[p>>2]|0;if(!((c|0)==(q|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}else{PDa(Bb,a,Lb,Mb,Fb);KG(Cb,Bb)|0;c=k[G>>2]|0;do if(c|0){$a=c+12|0;ab=k[$a>>2]|0;k[$a>>2]=ab+-1;if((ab|0)!=1)break;d=k[G>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[_a>>2]|0;if(c|0)break;c=B1()|0;d=k[G>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[G>>2]=0}while(0);k[G>>2]=0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[I>>2]|0)>0){d=k[J>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[I>>2]|0))}c=k[K>>2]|0;if(!((c|0)==(L|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}k[wb>>2]=0;k[Ca>>2]=0;k[Da>>2]=1124007936;$a=Ea;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[Ga>>2]=Fa;k[Ia>>2]=Ha;k[Ja>>2]=0;k[Ha>>2]=0;k[Ka>>2]=1124007936;$a=La;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[Na>>2]=Ma;k[Pa>>2]=Oa;k[Qa>>2]=0;k[Oa>>2]=0;k[Ra>>2]=1124007936;$a=Sa;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[Ua>>2]=Ta;k[Wa>>2]=Va;$a=Va;ab=$a+56|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));y0(wb,Cb,1.0);k[s>>2]=0;k[t>>2]=0;k[vb>>2]=-1056571392;k[u>>2]=wb;k[Bb>>2]=e;e=e+1|0;k[v>>2]=e;k[zb>>2]=-2147483648;k[x>>2]=2147483647;H1(yb,Gb,Bb,zb);c=z;k[c>>2]=0;k[c+4>>2]=0;k[xb>>2]=-1040121856;k[y>>2]=yb;k[Bb>>2]=0;k[Xa>>2]=0;k[Ya>>2]=0;B2(vb,Bb);c=k[Bb>>2]|0;ab=k[Xa>>2]|0;O2((c|0)==(ab|0)?0:c,(ab-c|0)/56|0,xb);zF(Bb);c=k[A>>2]|0;do if(c|0){$a=c+12|0;ab=k[$a>>2]|0;k[$a>>2]=ab+-1;if((ab|0)!=1)break;d=k[A>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[Za>>2]|0;if(c|0)break;c=B1()|0;d=k[A>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[A>>2]=0}while(0);k[A>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[C>>2]|0)>0){d=k[D>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[C>>2]|0))}c=k[E>>2]|0;if(!((c|0)==(F|0)|(c|0)==0))ggb(k[c+-4>>2]|0);XN(wb);c=k[b+4>>2]|0;if(!c)while(1){c=k[b+8>>2]|0;if((k[c>>2]|0)==(b|0))break;else b=c}else while(1){b=k[c>>2]|0;if(!b)break;else c=b}if((c|0)==(f|0))break;else b=c}}}else{yb=Bb+4|0;xb=yb+4|0;k[xb>>2]=0;k[xb+4>>2]=0;k[Bb>>2]=33619968;k[yb>>2]=Mb;SW(Eb,Bb,5,1.0,0.0);if(!(k[a+24>>2]|0)){ODa(Bb,a,Lb,Mb,Fb);KG(Cb,Bb)|0;d=Bb+36|0;c=k[d>>2]|0;do if(c|0){xb=c+12|0;yb=k[xb>>2]|0;k[xb>>2]=yb+-1;if((yb|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[Bb+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;yb=Bb+16|0;b=Bb+4|0;k[yb>>2]=0;k[yb+4>>2]=0;k[yb+8>>2]=0;k[yb+12>>2]=0;if((k[b>>2]|0)>0){d=k[Bb+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[Bb+44>>2]|0;if(!((c|0)==(Bb+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}else{PDa(Bb,a,Lb,Mb,Fb);KG(Cb,Bb)|0;d=Bb+36|0;c=k[d>>2]|0;do if(c|0){xb=c+12|0;yb=k[xb>>2]|0;k[xb>>2]=yb+-1;if((yb|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[Bb+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;yb=Bb+16|0;b=Bb+4|0;k[yb>>2]=0;k[yb+4>>2]=0;k[yb+8>>2]=0;k[yb+12>>2]=0;if((k[b>>2]|0)>0){d=k[Bb+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[Bb+44>>2]|0;if(!((c|0)==(Bb+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}k[Bb>>2]=0;k[Bb+4>>2]=0;k[Bb+8>>2]=1124007936;c=Bb+16|0;b=Bb+48|0;$a=Bb+12|0;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[b>>2]=c;c=Bb+56|0;k[Bb+52>>2]=c;k[Bb+60>>2]=0;k[c>>2]=0;k[Bb+64>>2]=1124007936;c=Bb+72|0;b=Bb+104|0;$a=Bb+68|0;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[b>>2]=c;c=Bb+112|0;k[Bb+108>>2]=c;k[Bb+116>>2]=0;k[c>>2]=0;k[Bb+120>>2]=1124007936;c=Bb+128|0;b=Bb+160|0;$a=Bb+124|0;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[b>>2]=c;$a=Bb+168|0;k[Bb+164>>2]=$a;ab=$a+56|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));y0(Bb,Cb,1.0);yb=k[Bb>>2]|0;dh[k[(k[yb>>2]|0)+12>>2]&255](yb,Bb,Gb,-1);XN(Bb)}j=a+48|0;k[zb>>2]=1124007936;h=zb+4|0;c=zb+8|0;f=zb+40|0;$a=h;ab=$a+36|0;do{k[$a>>2]=0;$a=$a+4|0}while(($a|0)<(ab|0));k[f>>2]=c;g=zb+48|0;e=zb+44|0;k[e>>2]=g;k[zb+52>>2]=0;k[g>>2]=0;d=Bb+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[Bb>>2]=33619968;k[d>>2]=zb;mY(Gb,Bb);KG(j,zb)|0;d=zb+36|0;c=k[d>>2]|0;do if(c|0){yb=c+12|0;a=k[yb>>2]|0;k[yb>>2]=a+-1;if((a|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[zb+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;zb=zb+16|0;k[zb>>2]=0;k[zb+4>>2]=0;k[zb+8>>2]=0;k[zb+12>>2]=0;if((k[h>>2]|0)>0){b=k[f>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[e>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);k[Bb+8>>2]=0;k[Bb+12>>2]=0;k[Bb>>2]=16842752;k[Bb+4>>2]=j;g7(Ab,Bb);if(((k[Ab+4>>2]&2147483647)+((k[Ab>>2]|0)!=0&1)|0)>>>0>2146435072){k[Bb>>2]=0;c=Bb+4|0;k[c>>2]=0;b=ZT(60)|0;k[b>>2]=1;$a=b+4|0;k[Bb>>2]=$a;k[c>>2]=54;i[b+58>>0]=0;d=366503;ab=$a+54|0;do{i[$a>>0]=i[d>>0]|0;$a=$a+1|0;d=d+1|0}while(($a|0)<(ab|0));Y8(-5,Bb,389152,366088,214);k[c>>2]=0;k[Bb>>2]=0;Bb=k[b>>2]|0;k[b>>2]=Bb+-1;if((Bb|0)==1)ggb(k[b+-4>>2]|0)}d=Cb+36|0;c=k[d>>2]|0;do if(c|0){Ab=c+12|0;Bb=k[Ab>>2]|0;k[Ab>>2]=Bb+-1;if((Bb|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[Cb+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;Cb=Cb+16|0;k[Cb>>2]=0;k[Cb+4>>2]=0;k[Cb+8>>2]=0;k[Cb+12>>2]=0;if((k[db>>2]|0)>0){b=k[bb>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[db>>2]|0))}c=k[cb>>2]|0;if(!((c|0)==(eb|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=Db+36|0;c=k[d>>2]|0;do if(c|0){Bb=c+12|0;Cb=k[Bb>>2]|0;k[Bb>>2]=Cb+-1;if((Cb|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[Db+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;Db=Db+16|0;k[Db>>2]=0;k[Db+4>>2]=0;k[Db+8>>2]=0;k[Db+12>>2]=0;if((k[hb>>2]|0)>0){b=k[fb>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[hb>>2]|0))}c=k[gb>>2]|0;if(!((c|0)==(ib|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=Eb+36|0;c=k[d>>2]|0;do if(c|0){Cb=c+12|0;Db=k[Cb>>2]|0;k[Cb>>2]=Db+-1;if((Db|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[Eb+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;Db=Eb+16|0;b=Eb+4|0;k[Db>>2]=0;k[Db+4>>2]=0;k[Db+8>>2]=0;k[Db+12>>2]=0;if((k[b>>2]|0)>0){d=k[Eb+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[Eb+44>>2]|0;if(!((c|0)==(Eb+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=Fb+36|0;c=k[d>>2]|0;do if(c|0){Db=c+12|0;Eb=k[Db>>2]|0;k[Db>>2]=Eb+-1;if((Eb|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[Fb+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;Fb=Fb+16|0;k[Fb>>2]=0;k[Fb+4>>2]=0;k[Fb+8>>2]=0;k[Fb+12>>2]=0;if((k[lb>>2]|0)>0){b=k[jb>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[lb>>2]|0))}c=k[kb>>2]|0;if(!((c|0)==(mb|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=Gb+36|0;c=k[d>>2]|0;do if(c|0){Eb=c+12|0;Fb=k[Eb>>2]|0;k[Eb>>2]=Fb+-1;if((Fb|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[Gb+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;Gb=Gb+16|0;k[Gb>>2]=0;k[Gb+4>>2]=0;k[Gb+8>>2]=0;k[Gb+12>>2]=0;if((k[pb>>2]|0)>0){b=k[nb>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[pb>>2]|0))}c=k[ob>>2]|0;if(!((c|0)==(qb|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=Lb+36|0;c=k[d>>2]|0;do if(c|0){Fb=c+12|0;Gb=k[Fb>>2]|0;k[Fb>>2]=Gb+-1;if((Gb|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[Lb+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;Lb=Lb+16|0;k[Lb>>2]=0;k[Lb+4>>2]=0;k[Lb+8>>2]=0;k[Lb+12>>2]=0;if((k[tb>>2]|0)>0){b=k[rb>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[tb>>2]|0))}c=k[sb>>2]|0;if(!((c|0)==(ub|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=Mb+36|0;c=k[d>>2]|0;do if(c|0){Gb=c+12|0;Lb=k[Gb>>2]|0;k[Gb>>2]=Lb+-1;if((Lb|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[Mb+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;Mb=Mb+16|0;k[Mb>>2]=0;k[Mb+4>>2]=0;k[Mb+8>>2]=0;k[Mb+12>>2]=0;if((k[Jb>>2]|0)>0){b=k[Hb>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Jb>>2]|0))}c=k[Ib>>2]|0;if(!((c|0)==(Kb|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=Ob+36|0;c=k[d>>2]|0;do if(c|0){Lb=c+12|0;Mb=k[Lb>>2]|0;k[Lb>>2]=Mb+-1;if((Mb|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[Ob+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;d=Ob+4|0;k[Nb>>2]=0;k[Nb+4>>2]=0;k[Nb+8>>2]=0;k[Nb+12>>2]=0;if((k[d>>2]|0)>0){b=k[Ob+40>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[Ob+44>>2]|0;if(!((c|0)==(Ob+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=Pb+36|0;c=k[d>>2]|0;do if(c|0){Nb=c+12|0;Ob=k[Nb>>2]|0;k[Nb>>2]=Ob+-1;if((Ob|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[Pb+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;Ob=Pb+16|0;b=Pb+4|0;k[Ob>>2]=0;k[Ob+4>>2]=0;k[Ob+8>>2]=0;k[Ob+12>>2]=0;if((k[b>>2]|0)>0){d=k[Pb+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[Pb+44>>2]|0;if((c|0)==(Pb+48|0)|(c|0)==0){r=Qb;return 1}ggb(k[c+-4>>2]|0);r=Qb;return 1}function xDa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0;ub=r;r=r+2384|0;Ta=ub+1584|0;Oa=ub+1360|0;qb=ub+2328|0;lb=ub+2272|0;fb=ub+2216|0;eb=ub+2160|0;za=ub+688|0;Aa=ub+448|0;Ba=ub+2096|0;Ca=ub+2088|0;db=ub+2032|0;cb=ub+1976|0;bb=ub+1920|0;Ya=ub+1864|0;o=ub+1136|0;p=ub+912|0;Ha=ub+224|0;ua=ub+1808|0;va=ub+464|0;wa=ub;xa=ub+2104|0;k[qb>>2]=1124007936;rb=qb+4|0;ya=qb+8|0;pb=qb+40|0;ra=rb;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[pb>>2]=ya;tb=qb+48|0;sb=qb+44|0;k[sb>>2]=tb;k[qb+52>>2]=0;k[tb>>2]=0;k[lb>>2]=1124007936;mb=lb+4|0;n=lb+8|0;kb=lb+40|0;ra=mb;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[kb>>2]=n;ob=lb+48|0;nb=lb+44|0;k[nb>>2]=ob;k[lb+52>>2]=0;k[ob>>2]=0;k[fb>>2]=1124007936;hb=fb+4|0;Xa=fb+8|0;gb=fb+40|0;ra=hb;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[gb>>2]=Xa;jb=fb+48|0;ib=fb+44|0;k[ib>>2]=jb;k[fb+52>>2]=0;k[jb>>2]=0;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[Ta>>2]=k[g>>2];m=Ta+4|0;b=g+4|0;k[m>>2]=k[b>>2];ab=Ta+8|0;k[ab>>2]=k[g+8>>2];k[Ta+12>>2]=k[g+12>>2];k[Ta+16>>2]=k[g+16>>2];k[Ta+20>>2]=k[g+20>>2];k[Ta+24>>2]=k[g+24>>2];k[Ta+28>>2]=k[g+28>>2];k[Ta+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Ta+36>>2]=e;f=Ta+40|0;k[f>>2]=ab;ab=Ta+48|0;j=Ta+44|0;k[j>>2]=ab;k[Ta+52>>2]=0;k[ab>>2]=0;if(e|0){ab=e+12|0;k[ab>>2]=(k[ab>>2]|0)+1}if((k[b>>2]|0)<3){$a=k[g+44>>2]|0;ab=k[j>>2]|0;k[ab>>2]=k[$a>>2];k[ab+4>>2]=k[$a+4>>2];break}k[m>>2]=0;x1(Ta,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(Ta,b,-1);while(0);KG(lb,Ta)|0;f=Ta+36|0;b=k[f>>2]|0;if(b|0?($a=b+12|0,ab=k[$a>>2]|0,k[$a>>2]=ab+-1,(ab|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Ta+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;ab=Ta+16|0;e=Ta+4|0;k[ab>>2]=0;k[ab+4>>2]=0;k[ab+8>>2]=0;k[ab+12>>2]=0;if((k[e>>2]|0)>0){f=k[Ta+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Ta+44>>2]|0;if(!((b|0)==(Ta+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);Ia=(d&1|0)==0;h=a+48|0;f=k[a+52>>2]|0;if((f|0)<3)b=aa(k[a+60>>2]|0,k[a+56>>2]|0)|0;else{g=k[a+88>>2]|0;e=0;b=1;do{b=aa(k[g+(e<<2)>>2]|0,b)|0;e=e+1|0}while((e|0)!=(f|0))}if(!b){k[Ta>>2]=0;b=Ta+4|0;k[b>>2]=0;e=ZT(40)|0;k[e>>2]=1;ra=e+4|0;k[Ta>>2]=ra;k[b>>2]=34;i[e+38>>0]=0;f=366053;sa=ra+34|0;do{i[ra>>0]=i[f>>0]|0;ra=ra+1|0;f=f+1|0}while((ra|0)<(sa|0));Y8(-5,Ta,372250,366088,232);k[b>>2]=0;k[Ta>>2]=0;ab=k[e>>2]|0;k[e>>2]=ab+-1;if((ab|0)==1)ggb(k[e+-4>>2]|0)}if((k[lb>>2]&4095|0)!=5){k[Ta>>2]=0;b=Ta+4|0;k[b>>2]=0;e=ZT(36)|0;k[e>>2]=1;ra=e+4|0;k[Ta>>2]=ra;k[b>>2]=29;i[e+33>>0]=0;f=366147;sa=ra+29|0;do{i[ra>>0]=i[f>>0]|0;ra=ra+1|0;f=f+1|0}while((ra|0)<(sa|0));Y8(-5,Ta,372250,366088,236);k[b>>2]=0;k[Ta>>2]=0;ab=k[e>>2]|0;k[e>>2]=ab+-1;if((ab|0)==1)ggb(k[e+-4>>2]|0)}k[eb>>2]=1124007936;_a=eb+4|0;g=eb+8|0;Za=eb+40|0;ra=_a;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[Za>>2]=g;ab=eb+48|0;$a=eb+44|0;k[$a>>2]=ab;k[eb+52>>2]=0;k[ab>>2]=0;f=k[n>>2]|0;k[za>>2]=0;k[za+4>>2]=0;k[za+8>>2]=1124007936;b=za+16|0;e=za+48|0;ra=za+12|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[e>>2]=b;b=za+56|0;k[za+52>>2]=b;k[za+60>>2]=0;k[b>>2]=0;k[za+64>>2]=1124007936;b=za+72|0;e=za+104|0;ra=za+68|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[e>>2]=b;b=za+112|0;k[za+108>>2]=b;k[za+116>>2]=0;k[b>>2]=0;k[za+120>>2]=1124007936;b=za+128|0;e=za+160|0;ra=za+124|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[e>>2]=b;ra=za+168|0;k[za+164>>2]=ra;sa=ra+56|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[Ta>>2]=1;k[Ta+4>>2]=f;j1(za,49,Ta,5);k[Oa+8>>2]=0;k[Oa+12>>2]=0;k[Oa>>2]=-1056571392;k[Oa+4>>2]=za;k[Ta+8>>2]=0;k[Ta+12>>2]=0;k[Ta>>2]=16842752;k[Ta+4>>2]=lb;Wa=Aa+4|0;Va=Wa+4|0;k[Va>>2]=0;k[Va+4>>2]=0;k[Aa>>2]=33619968;k[Wa>>2]=eb;P2(Oa,Ta,Aa);XN(za);if((k[h>>2]&4095|0)==5)KG(qb,h)|0;else{Wa=Ta+4|0;Va=Wa+4|0;k[Va>>2]=0;k[Va+4>>2]=0;k[Ta>>2]=33619968;k[Wa>>2]=qb;SW(h,Ta,5,1.0,0.0)}b=k[ya>>2]|0;if((b|0)<=0){k[Ta>>2]=0;b=Ta+4|0;k[b>>2]=0;e=ZT(20)|0;k[e>>2]=1;ra=e+4|0;k[Ta>>2]=ra;k[b>>2]=15;i[e+19>>0]=0;f=366177;sa=ra+15|0;do{i[ra>>0]=i[f>>0]|0;ra=ra+1|0;f=f+1|0}while((ra|0)<(sa|0));Y8(-215,Ta,372250,366088,252);k[b>>2]=0;k[Ta>>2]=0;Wa=k[e>>2]|0;k[e>>2]=Wa+-1;if((Wa|0)==1)ggb(k[e+-4>>2]|0);b=k[ya>>2]|0}k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[db>>2]=1124007936;Va=db+4|0;e=db+8|0;Sa=db+40|0;ra=Va;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[Sa>>2]=e;Wa=db+48|0;Ua=db+44|0;k[Ua>>2]=Wa;k[db+52>>2]=0;k[Wa>>2]=0;k[cb>>2]=1124007936;Qa=cb+4|0;e=cb+8|0;Na=cb+40|0;ra=Qa;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[Na>>2]=e;Ra=cb+48|0;Pa=cb+44|0;k[Pa>>2]=Ra;k[cb+52>>2]=0;k[Ra>>2]=0;k[bb>>2]=1124007936;La=bb+4|0;e=bb+8|0;Ja=bb+40|0;ra=La;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[Ja>>2]=e;Ma=bb+48|0;Ka=bb+44|0;k[Ka>>2]=Ma;k[bb+52>>2]=0;k[Ma>>2]=0;g=k[g>>2]|0;h=k[lb>>2]&4095;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=1124007936;e=o+16|0;f=o+48|0;ra=o+12|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[f>>2]=e;e=o+56|0;k[o+52>>2]=e;k[o+60>>2]=0;k[e>>2]=0;k[o+64>>2]=1124007936;e=o+72|0;f=o+104|0;ra=o+68|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[f>>2]=e;e=o+112|0;k[o+108>>2]=e;k[o+116>>2]=0;k[e>>2]=0;k[o+120>>2]=1124007936;e=o+128|0;f=o+160|0;ra=o+124|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[f>>2]=e;ra=o+168|0;k[o+164>>2]=ra;sa=ra+56|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[Ta>>2]=b;k[Ta+4>>2]=g;j1(o,48,Ta,h);k[Ya>>2]=1124007936;Ea=Ya+4|0;ta=Ya+8|0;Da=Ya+40|0;ra=Ea;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[Da>>2]=ta;Ga=Ya+48|0;Fa=Ya+44|0;k[Fa>>2]=Ga;k[Ya+52>>2]=0;k[Ga>>2]=0;b=k[o>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,o,Ya,-1);XN(o);b=k[ya>>2]|0;if((b|0)==1){k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ha+8>>2]=1124007936;b=Ha+16|0;e=Ha+48|0;ra=Ha+12|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[e>>2]=b;b=Ha+56|0;k[Ha+52>>2]=b;k[Ha+60>>2]=0;k[b>>2]=0;k[Ha+64>>2]=1124007936;b=Ha+72|0;e=Ha+104|0;ra=Ha+68|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[e>>2]=b;b=Ha+112|0;k[Ha+108>>2]=b;k[Ha+116>>2]=0;k[b>>2]=0;k[Ha+120>>2]=1124007936;b=Ha+128|0;e=Ha+160|0;ra=Ha+124|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[e>>2]=b;ra=Ha+168|0;k[Ha+164>>2]=ra;sa=ra+56|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));y0(Ha,qb,1.0);e1(p,eb,Ha);k[Oa>>2]=1124007936;l=Oa+4|0;b=Oa+8|0;h=Oa+40|0;ra=l;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[h>>2]=b;j=Oa+48|0;g=Oa+44|0;k[g>>2]=j;k[Oa+52>>2]=0;k[j>>2]=0;f=k[p>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,p,Oa,-1);LDa(Ta,Oa);KG(bb,Ta)|0;f=Ta+36|0;b=k[f>>2]|0;if(b|0?(Ba=b+12|0,Ca=k[Ba>>2]|0,k[Ba>>2]=Ca+-1,(Ca|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Ta+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Ca=Ta+16|0;e=Ta+4|0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[e>>2]|0)>0){f=k[Ta+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Ta+44>>2]|0;if(!((b|0)==(Ta+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Oa+36|0;b=k[f>>2]|0;if(b|0?(Ba=b+12|0,Ca=k[Ba>>2]|0,k[Ba>>2]=Ca+-1,(Ca|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Oa+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Ca=Oa+16|0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[l>>2]|0)>0){e=k[h>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[g>>2]|0;if(!((b|0)==(j|0)|(b|0)==0))ggb(k[b+-4>>2]|0);XN(p);XN(Ha);if((k[bb+12>>2]|0)!=1){k[Ta>>2]=0;b=Ta+4|0;k[b>>2]=0;e=ZT(24)|0;k[e>>2]=1;ra=e+4|0;k[Ta>>2]=ra;k[b>>2]=17;i[e+21>>0]=0;f=366193;sa=ra+17|0;do{i[ra>>0]=i[f>>0]|0;ra=ra+1|0;f=f+1|0}while((ra|0)<(sa|0));Y8(-215,Ta,372250,366088,268);k[b>>2]=0;k[Ta>>2]=0;Ha=k[e>>2]|0;k[e>>2]=Ha+-1;if((Ha|0)==1)ggb(k[e+-4>>2]|0)}k[Oa>>2]=0;k[Oa+4>>2]=0;k[Oa+8>>2]=1124007936;b=Oa+16|0;e=Oa+48|0;ra=Oa+12|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[e>>2]=b;b=Oa+56|0;k[Oa+52>>2]=b;k[Oa+60>>2]=0;k[b>>2]=0;k[Oa+64>>2]=1124007936;b=Oa+72|0;e=Oa+104|0;ra=Oa+68|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[e>>2]=b;b=Oa+112|0;k[Oa+108>>2]=b;k[Oa+116>>2]=0;k[b>>2]=0;k[Oa+120>>2]=1124007936;b=Oa+128|0;e=Oa+160|0;ra=Oa+124|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[e>>2]=b;ra=Oa+168|0;k[Oa+164>>2]=ra;sa=ra+56|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));h1(Oa,1,bb,.5);k[Ta>>2]=0;k[Ta+4>>2]=0;k[Ta+8>>2]=1124007936;b=Ta+16|0;e=Ta+48|0;ra=Ta+12|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[e>>2]=b;b=Ta+56|0;k[Ta+52>>2]=b;k[Ta+60>>2]=0;k[b>>2]=0;k[Ta+64>>2]=1124007936;b=Ta+72|0;e=Ta+104|0;ra=Ta+68|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[e>>2]=b;b=Ta+112|0;k[Ta+108>>2]=b;k[Ta+116>>2]=0;k[b>>2]=0;k[Ta+120>>2]=1124007936;b=Ta+128|0;e=Ta+160|0;ra=Ta+124|0;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[e>>2]=b;ra=Ta+168|0;k[Ta+164>>2]=ra;sa=ra+56|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));Ha=k[Oa>>2]|0;nh[k[(k[Ha>>2]|0)+72>>2]&15](Ha,Oa,.00392156862745098,Ta);Ha=k[Ta>>2]|0;dh[k[(k[Ha>>2]|0)+12>>2]&255](Ha,Ta,bb,-1);XN(Ta);XN(Oa);Oa=Ta+4|0;Ha=Oa+4|0;k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ta>>2]=33619968;k[Oa>>2]=cb;SW(bb,Ta,4,1.0,0.0)}else{if((b|0)>0){h=Ta+4|0;j=Oa+4|0;l=ua+4|0;m=ua+8|0;d=ua+40|0;n=ua+48|0;o=ua+44|0;p=ua+52|0;q=Ha+36|0;s=Ha+16|0;t=Ha+4|0;u=Ha+40|0;v=Ha+44|0;w=Ha+48|0;x=ua+36|0;y=ua+16|0;z=xa+36|0;A=xa+16|0;B=xa+4|0;C=xa+40|0;D=xa+44|0;E=xa+48|0;F=Ha+8|0;H=Ha+12|0;I=Ha+4|0;J=Ta+4|0;K=Oa+4|0;L=ua+4|0;M=L+4|0;N=wa+36|0;O=wa+16|0;P=wa+4|0;Q=wa+40|0;R=wa+44|0;S=wa+48|0;T=wa+4|0;U=wa+8|0;V=wa+12|0;W=wa+16|0;X=wa+48|0;Y=wa+56|0;Z=wa+52|0;_=wa+60|0;$=wa+64|0;ba=wa+68|0;ca=wa+72|0;da=wa+104|0;ea=wa+112|0;fa=wa+108|0;ga=wa+116|0;ha=wa+120|0;ia=wa+124|0;ja=wa+128|0;ka=wa+160|0;la=wa+168|0;ma=wa+164|0;na=wa+32|0;oa=xa+32|0;pa=ua+32|0;qa=Ha+32|0;g=0;do{f=g;g=g+1|0;k[Ta>>2]=f;k[h>>2]=g;k[Oa>>2]=-2147483648;k[j>>2]=2147483647;H1(xa,qb,Ta,Oa);k[wa>>2]=0;k[T>>2]=0;k[U>>2]=1124007936;ra=V;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[X>>2]=W;k[Z>>2]=Y;k[_>>2]=0;k[Y>>2]=0;k[$>>2]=1124007936;ra=ba;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[da>>2]=ca;k[fa>>2]=ea;k[ga>>2]=0;k[ea>>2]=0;k[ha>>2]=1124007936;ra=ia;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[ka>>2]=ja;k[ma>>2]=la;ra=la;sa=ra+56|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));y0(wa,xa,1.0);e1(va,eb,wa);k[ua>>2]=1124007936;ra=l;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[d>>2]=m;k[o>>2]=n;k[p>>2]=0;k[n>>2]=0;b=k[va>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,va,ua,-1);LDa(Ha,ua);KG(bb,Ha)|0;b=k[q>>2]|0;if(b|0?(ra=b+12|0,sa=k[ra>>2]|0,k[ra>>2]=sa+-1,(sa|0)==1):0){e=k[q>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[qa>>2]|0;if(b|0)break;b=B1()|0;e=k[q>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[q>>2]=0}k[q>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[t>>2]|0)>0){e=k[u>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[v>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[x>>2]|0;if(b|0?(ra=b+12|0,sa=k[ra>>2]|0,k[ra>>2]=sa+-1,(sa|0)==1):0){e=k[x>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[pa>>2]|0;if(b|0)break;b=B1()|0;e=k[x>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[x>>2]=0}k[x>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[l>>2]|0)>0){e=k[d>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[o>>2]|0;if(!((b|0)==(n|0)|(b|0)==0))ggb(k[b+-4>>2]|0);XN(va);XN(wa);b=k[z>>2]|0;do if(b|0){ra=b+12|0;sa=k[ra>>2]|0;k[ra>>2]=sa+-1;if((sa|0)!=1)break;e=k[z>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[oa>>2]|0;if(b|0)break;b=B1()|0;e=k[z>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[z>>2]=0}while(0);k[z>>2]=0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[B>>2]|0)>0){e=k[C>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[B>>2]|0))}b=k[D>>2]|0;if(!((b|0)==(E|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[F>>2]=0;k[H>>2]=0;k[Ha>>2]=16842752;k[I>>2]=bb;k[Ta>>2]=-2147483648;k[J>>2]=2147483647;k[Oa>>2]=f;k[K>>2]=g;H1(wa,Ya,Ta,Oa);b=M;k[b>>2]=0;k[b+4>>2]=0;k[ua>>2]=-1040121856;k[L>>2]=wa;Q2(Ha,ua);b=k[N>>2]|0;do if(b|0){ra=b+12|0;sa=k[ra>>2]|0;k[ra>>2]=sa+-1;if((sa|0)!=1)break;e=k[N>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[na>>2]|0;if(b|0)break;b=B1()|0;e=k[N>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[N>>2]=0}while(0);k[N>>2]=0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[P>>2]|0)>0){e=k[Q>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[P>>2]|0))}b=k[R>>2]|0;if(!((b|0)==(S|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((g|0)<(k[ya>>2]|0))}f=Ta+4|0;g=Oa+4|0;h=Ha+36|0;j=Ha+16|0;l=Ha+4|0;m=Ha+40|0;d=Ha+44|0;n=Ha+48|0;o=Ta+8|0;p=Ta+12|0;q=Ta+4|0;s=Ha+4|0;t=Ha+8|0;u=Ha+40|0;v=Ha+48|0;w=Ha+44|0;x=Ha+52|0;y=Oa+8|0;z=Oa+12|0;A=Oa+4|0;B=Ha+36|0;C=Ha+16|0;D=Ha+32|0;E=Ha+32|0;b=0;while(1){if((b|0)>=(k[ta>>2]|0))break;F=b+1|0;k[Ta>>2]=b;k[f>>2]=F;k[Oa>>2]=-2147483648;k[g>>2]=2147483647;H1(Ha,Ya,Ta,Oa);KG(bb,Ha)|0;b=k[h>>2]|0;if(b|0?(xa=b+12|0,ya=k[xa>>2]|0,k[xa>>2]=ya+-1,(ya|0)==1):0){e=k[h>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[E>>2]|0;if(b|0)break;b=B1()|0;e=k[h>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[h>>2]=0}k[h>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[l>>2]|0)>0){e=k[m>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[d>>2]|0;if(!((b|0)==(n|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[o>>2]=0;k[p>>2]=0;k[Ta>>2]=16842752;k[q>>2]=bb;k[Ha>>2]=1124007936;ra=s;sa=ra+36|0;do{k[ra>>2]=0;ra=ra+4|0}while((ra|0)<(sa|0));k[u>>2]=t;k[w>>2]=v;k[x>>2]=0;k[v>>2]=0;k[y>>2]=0;k[z>>2]=0;k[Oa>>2]=16842752;k[A>>2]=Ha;L7(Ta,za,Aa,Ba,Ca,Oa);b=k[B>>2]|0;if(b|0?(xa=b+12|0,ya=k[xa>>2]|0,k[xa>>2]=ya+-1,(ya|0)==1):0){e=k[B>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[D>>2]|0;if(b|0)break;b=B1()|0;e=k[B>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[B>>2]=0}k[B>>2]=0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[s>>2]|0)>0){e=k[u>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[s>>2]|0))}b=k[w>>2]|0;if(!((b|0)==(v|0)|(b|0)==0))ggb(k[b+-4>>2]|0);MDa(db,Ca);b=F}Oa=Ta+4|0;Ha=Oa+4|0;k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ta>>2]=33619968;k[Oa>>2]=cb;SW(db,Ta,4,1.0,0.0)}NDa(Ta,cb,a+116|0);KG(fb,Ta)|0;f=Ta+36|0;b=k[f>>2]|0;if(b|0?(a=b+12|0,Oa=k[a>>2]|0,k[a>>2]=Oa+-1,(Oa|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Ta+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Oa=Ta+16|0;e=Ta+4|0;k[Oa>>2]=0;k[Oa+4>>2]=0;k[Oa+8>>2]=0;k[Oa+12>>2]=0;if((k[e>>2]|0)>0){f=k[Ta+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Ta+44>>2]|0;if(!((b|0)==(Ta+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);Oa=Ta+4|0;a=Oa+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Ta>>2]=33619968;k[Oa>>2]=fb;SW(fb,Ta,4,1.0,0.0);do if(k[c>>2]&2031616|0)if(Ia){mY(fb,c);break}else{mY(Ya,c);break}while(0);j=fb+16|0;h=k[j>>2]|0;if(h){g=k[hb>>2]|0;if((g|0)<3)b=aa(k[fb+12>>2]|0,k[Xa>>2]|0)|0;else{f=k[gb>>2]|0;e=0;b=1;do{b=aa(k[f+(e<<2)>>2]|0,b)|0;e=e+1|0}while((e|0)!=(g|0))}if(b)G=+(k[h>>2]|0);else G=0.0}else G=0.0;f=Ya+36|0;b=k[f>>2]|0;if(b|0?(Ta=b+12|0,Xa=k[Ta>>2]|0,k[Ta>>2]=Xa+-1,(Xa|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Ya+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Ya=Ya+16|0;k[Ya>>2]=0;k[Ya+4>>2]=0;k[Ya+8>>2]=0;k[Ya+12>>2]=0;if((k[Ea>>2]|0)>0){e=k[Da>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ea>>2]|0))}b=k[Fa>>2]|0;if(!((b|0)==(Ga|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=bb+36|0;b=k[f>>2]|0;do if(b|0){Xa=b+12|0;Ya=k[Xa>>2]|0;k[Xa>>2]=Ya+-1;if((Ya|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[bb+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;bb=bb+16|0;k[bb>>2]=0;k[bb+4>>2]=0;k[bb+8>>2]=0;k[bb+12>>2]=0;if((k[La>>2]|0)>0){e=k[Ja>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[La>>2]|0))}b=k[Ka>>2]|0;if(!((b|0)==(Ma|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=cb+36|0;b=k[f>>2]|0;do if(b|0){Ya=b+12|0;bb=k[Ya>>2]|0;k[Ya>>2]=bb+-1;if((bb|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[cb+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;cb=cb+16|0;k[cb>>2]=0;k[cb+4>>2]=0;k[cb+8>>2]=0;k[cb+12>>2]=0;if((k[Qa>>2]|0)>0){e=k[Na>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Qa>>2]|0))}b=k[Pa>>2]|0;if(!((b|0)==(Ra|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=db+36|0;b=k[f>>2]|0;do if(b|0){bb=b+12|0;cb=k[bb>>2]|0;k[bb>>2]=cb+-1;if((cb|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[db+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;db=db+16|0;k[db>>2]=0;k[db+4>>2]=0;k[db+8>>2]=0;k[db+12>>2]=0;if((k[Va>>2]|0)>0){e=k[Sa>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Va>>2]|0))}b=k[Ua>>2]|0;if(!((b|0)==(Wa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=eb+36|0;b=k[f>>2]|0;do if(b|0){cb=b+12|0;db=k[cb>>2]|0;k[cb>>2]=db+-1;if((db|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[eb+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;eb=eb+16|0;k[eb>>2]=0;k[eb+4>>2]=0;k[eb+8>>2]=0;k[eb+12>>2]=0;if((k[_a>>2]|0)>0){e=k[Za>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[_a>>2]|0))}b=k[$a>>2]|0;if(!((b|0)==(ab|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=fb+36|0;b=k[f>>2]|0;do if(b|0){db=b+12|0;eb=k[db>>2]|0;k[db>>2]=eb+-1;if((eb|0)!=1)break;b=k[f>>2]|0;if(b|0){e=k[b+4>>2]|0;do if(!e){e=k[fb+32>>2]|0;if(e|0)break;e=B1()|0;b=k[f>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,b)}k[f>>2]=0}while(0);k[f>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[hb>>2]|0)>0){e=k[gb>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[hb>>2]|0))}b=k[ib>>2]|0;if(!((b|0)==(jb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=lb+36|0;b=k[f>>2]|0;do if(b|0){ib=b+12|0;jb=k[ib>>2]|0;k[ib>>2]=jb+-1;if((jb|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[lb+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;lb=lb+16|0;k[lb>>2]=0;k[lb+4>>2]=0;k[lb+8>>2]=0;k[lb+12>>2]=0;if((k[mb>>2]|0)>0){e=k[kb>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[mb>>2]|0))}b=k[nb>>2]|0;if(!((b|0)==(ob|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=qb+36|0;b=k[f>>2]|0;do if(b|0){nb=b+12|0;ob=k[nb>>2]|0;k[nb>>2]=ob+-1;if((ob|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[qb+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;qb=qb+16|0;k[qb>>2]=0;k[qb+4>>2]=0;k[qb+8>>2]=0;k[qb+12>>2]=0;if((k[rb>>2]|0)>0){e=k[pb>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[rb>>2]|0))}b=k[sb>>2]|0;if((b|0)==(tb|0)|(b|0)==0){r=ub;return +G}ggb(k[b+-4>>2]|0);r=ub;return +G}function yDa(a){a=a|0;return +(+p[a+8>>3])}function zDa(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function ADa(a){a=a|0;return k[a+16>>2]|0}function BDa(a,b){a=a|0;b=b|0;k[a+16>>2]=b;return}function CDa(a){a=a|0;return k[a+20>>2]|0}function DDa(a,b){a=a|0;b=b|0;k[a+20>>2]=b;return}function EDa(a){a=a|0;return k[a+24>>2]|0}function FDa(a,b){a=a|0;b=b|0;k[a+24>>2]=b;return}function GDa(a){a=a|0;return k[a+28>>2]|0}function HDa(a,b){a=a|0;b=b|0;k[a+28>>2]=b;return}function IDa(a,b){a=a|0;b=b|0;b=b+32|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];return}function JDa(a,b){a=a|0;b=b|0;a=a+32|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];return}function KDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+48>>2];i=a+4|0;e=b+52|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+56>>2];k[a+12>>2]=k[b+60>>2];k[a+16>>2]=k[b+64>>2];k[a+20>>2]=k[b+68>>2];k[a+24>>2]=k[b+72>>2];k[a+28>>2]=k[b+76>>2];k[a+32>>2]=k[b+80>>2];d=k[b+84>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+92>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+88>>2]|0;a=k[g>>2]|0;e=k[b+92>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function LDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0;q=r;r=r+752|0;j=q+688|0;f=q+448|0;d=q+224|0;e=q+672|0;g=q;k[j>>2]=1124007936;o=j+4|0;c=j+8|0;l=j+40|0;h=o;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[l>>2]=c;n=j+48|0;m=j+44|0;k[m>>2]=n;k[j+52>>2]=0;k[n>>2]=0;$0(d,b);k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=-1056571392;k[f+4>>2]=d;c=e+4|0;b=c+4|0;k[b>>2]=0;k[b+4>>2]=0;k[e>>2]=33619968;k[c>>2]=j;XZ(f,e);XN(d);p[d>>3]=1.0;c=d+8|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;k[c+16>>2]=0;k[c+20>>2]=0;V0(f,d,j);k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=1124007936;c=g+16|0;b=g+48|0;h=g+12|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[b>>2]=c;c=g+56|0;k[g+52>>2]=c;k[g+60>>2]=0;k[c>>2]=0;k[g+64>>2]=1124007936;c=g+72|0;b=g+104|0;h=g+68|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[b>>2]=c;c=g+112|0;k[g+108>>2]=c;k[g+116>>2]=0;k[c>>2]=0;k[g+120>>2]=1124007936;c=g+128|0;b=g+160|0;h=g+124|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[b>>2]=c;h=g+168|0;k[g+164>>2]=h;i=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));c=k[f>>2]|0;Zh[k[(k[c>>2]|0)+80>>2]&7](c,1.0,f,g);k[a>>2]=1124007936;c=a+8|0;b=a+40|0;h=a+4|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[b>>2]=c;d=a+48|0;k[a+44>>2]=d;k[a+52>>2]=0;k[d>>2]=0;d=k[g>>2]|0;dh[k[(k[d>>2]|0)+12>>2]&255](d,g,a,-1);XN(g);XN(f);d=j+36|0;c=k[d>>2]|0;if(c|0?(h=c+12|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[j+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;j=j+16|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[o>>2]|0)>0){b=k[l>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[o>>2]|0))}c=k[m>>2]|0;if((c|0)==(n|0)|(c|0)==0){r=q;return}ggb(k[c+-4>>2]|0);r=q;return}function MDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+128|0;h=u+112|0;m=u+56|0;n=u;l=a+16|0;if(k[l>>2]|0){c=k[a>>2]|0;if(!((c&4095|0)==4?(k[a+12>>2]|0)==1:0)){c=h+4|0;d=ZT(48)|0;k[d>>2]=1;f=d+4|0;k[h>>2]=f;k[c>>2]=42;i[d+46>>0]=0;e=366238;g=f+42|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,h,366281,390642,1115);k[c>>2]=0;k[h>>2]=0;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0);c=k[a>>2]|0}h=a+24|0;j=a+44|0;d=k[j>>2]|0;e=(k[h>>2]|0)+(k[d>>2]|0)|0;if((c&49152|0)==16384?e>>>0<=(k[a+28>>2]|0)>>>0:0){s=k[b>>2]|0;q=k[l>>2]|0;p=k[a+40>>2]|0;t=k[p>>2]|0;k[p>>2]=t+1;t=q+(aa(k[d>>2]|0,t)|0)|0;k[t>>2]=s;k[h>>2]=e;r=u;return}f=a+40|0;g=k[k[f>>2]>>2]|0;if(!((c&32768|0)==0?e>>>0<=(k[a+28>>2]|0)>>>0:0)){t=g+1|0;s=((g*3|0)+1|0)/2|0;K1(a,(t|0)<(s|0)?s:t)}c=k[a+4>>2]|0;if((c|0)>0){t=k[j>>2]|0;d=t;c=k[t+(c+-1<<2)>>2]|0}else{d=k[j>>2]|0;c=0}upb((k[l>>2]|0)+(aa(k[d>>2]|0,g)|0)|0,b|0,c|0)|0;k[k[f>>2]>>2]=g+1;t=k[k[j>>2]>>2]|0;k[h>>2]=(k[h>>2]|0)+t;if(c>>>0>=t>>>0){r=u;return}k[a>>2]=k[a>>2]&-16385;r=u;return}s=n+4|0;k[s>>2]=2;t=n+8|0;k[t>>2]=1;k[n+12>>2]=1;o=n+16|0;k[o>>2]=b;k[n+20>>2]=b;l=n+24|0;p=n+40|0;q=l+8|0;k[q>>2]=0;k[q+4>>2]=0;k[p>>2]=t;t=n+48|0;q=n+44|0;k[q>>2]=t;k[n>>2]=1124024324;k[t>>2]=4;k[n+52>>2]=4;c=b+4|0;k[n+28>>2]=c;k[l>>2]=c;k[m>>2]=1124007936;l=m+4|0;c=m+8|0;j=m+40|0;f=l;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[j>>2]=c;g=m+48|0;f=m+44|0;k[f>>2]=g;k[m+52>>2]=0;k[g>>2]=0;e=h+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[h>>2]=33619968;k[e>>2]=m;mY(n,h);KG(a,m)|0;e=m+36|0;c=k[e>>2]|0;if(c|0?(b=c+12|0,a=k[b>>2]|0,k[b>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[m+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;a=m+16|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[l>>2]|0)>0){d=k[j>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[l>>2]|0))}c=k[f>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=n+36|0;c=k[e>>2]|0;if(c|0?(b=c+12|0,a=k[b>>2]|0,k[b>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[n+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[s>>2]|0)>0){d=k[p>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[s>>2]|0))}c=k[q>>2]|0;if(!((c|0)==(t|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=u;return}function NDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+304|0;j=u+280|0;o=u+224|0;h=u;k[o>>2]=1124007936;s=o+4|0;n=o+8|0;p=o+40|0;l=s;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[p>>2]=n;t=o+48|0;q=o+44|0;k[q>>2]=t;k[o+52>>2]=0;k[t>>2]=0;e=j+4|0;f=e+4|0;k[f>>2]=0;k[f+4>>2]=0;k[j>>2]=33619968;k[e>>2]=o;SW(b,j,4,1.0,0.0);e=k[n>>2]|0;f=k[o+12>>2]|0;g=k[o>>2]&4095;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=1124007936;b=h+16|0;d=h+48|0;l=h+12|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[d>>2]=b;b=h+56|0;k[h+52>>2]=b;k[h+60>>2]=0;k[b>>2]=0;k[h+64>>2]=1124007936;b=h+72|0;d=h+104|0;l=h+68|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[d>>2]=b;b=h+112|0;k[h+108>>2]=b;k[h+116>>2]=0;k[b>>2]=0;k[h+120>>2]=1124007936;b=h+128|0;d=h+160|0;l=h+124|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[d>>2]=b;l=h+168|0;k[h+164>>2]=l;m=l+56|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[j>>2]=f;k[j+4>>2]=e;j1(h,48,j,g);k[a>>2]=1124007936;b=a+8|0;d=a+40|0;l=a+4|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[d>>2]=b;m=a+48|0;f=a+44|0;k[f>>2]=m;k[a+52>>2]=0;k[m>>2]=0;m=k[h>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,h,a,-1);XN(h);if(!(k[c+8>>2]|0)){k[j>>2]=0;b=j+4|0;k[b>>2]=0;d=ZT(20)|0;k[d>>2]=1;l=d+4|0;k[j>>2]=l;k[b>>2]=13;i[d+17>>0]=0;e=366211;m=l+13|0;do{i[l>>0]=i[e>>0]|0;l=l+1|0;e=e+1|0}while((l|0)<(m|0));Y8(-215,j,366225,366088,531);k[b>>2]=0;k[j>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0)}a:do if((k[n>>2]|0)>0){j=c+4|0;l=k[j>>2]|0;a=k[a+16>>2]|0;m=k[f>>2]|0;h=k[o+16>>2]|0;c=k[q>>2]|0;if(!l){d=j+20|0;b=0;while(1){l=a+(aa(k[m>>2]|0,b)|0)|0;k[l>>2]=k[d>>2];b=b+1|0;if((b|0)>=(k[n>>2]|0))break a}}else g=0;do{f=h+(aa(k[c>>2]|0,g)|0)|0;f=k[f>>2]|0;b=j;e=l;b:while(1){d=e;while(1){if((k[d+16>>2]|0)>=(f|0))break;d=k[d+4>>2]|0;if(!d)break b}e=k[d>>2]|0;if(!e){b=d;break}else b=d}if(!((b|0)!=(j|0)?(f|0)>=(k[b+16>>2]|0):0))b=j;f=a+(aa(k[m>>2]|0,g)|0)|0;k[f>>2]=k[b+20>>2];g=g+1|0}while((g|0)<(k[n>>2]|0))}while(0);e=o+36|0;b=k[e>>2]|0;if(b|0?(a=b+12|0,n=k[a>>2]|0,k[a>>2]=n+-1,(n|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[o+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;o=o+16|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[s>>2]|0)>0){d=k[p>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[s>>2]|0))}b=k[q>>2]|0;if((b|0)==(t|0)|(b|0)==0){r=u;return}ggb(k[b+-4>>2]|0);r=u;return}function ODa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,l=0.0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+512|0;s=x+224|0;w=x+448|0;t=x;u=b+8|0;if(+p[u>>3]<=0.0){f=s+4|0;g=ZT(68)|0;k[g>>2]=1;m=g+4|0;k[s>>2]=m;k[f>>2]=60;i[g+64>>0]=0;h=366781;n=m+60|0;do{i[m>>0]=i[h>>0]|0;m=m+1|0;h=h+1|0}while((m|0)<(n|0));Y8(-5,s,366842,366088,401);k[f>>2]=0;k[s>>2]=0;v=k[g>>2]|0;k[g>>2]=v+-1;if((v|0)==1)ggb(k[g+-4>>2]|0)}o=b+16|0;if((k[o>>2]|0)<1){f=s+4|0;g=ZT(64)|0;k[g>>2]=1;m=g+4|0;k[s>>2]=m;k[f>>2]=56;i[g+60>>0]=0;h=366631;n=m+56|0;do{i[m>>0]=i[h>>0]|0;m=m+1|0;h=h+1|0}while((m|0)<(n|0));Y8(-5,s,366842,366088,406);k[f>>2]=0;k[s>>2]=0;v=k[g>>2]|0;k[g>>2]=v+-1;if((v|0)==1)ggb(k[g+-4>>2]|0)}k[a>>2]=1124007936;f=a+8|0;g=a+40|0;m=a+4|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[g>>2]=f;g=a+48|0;k[a+44>>2]=g;k[a+52>>2]=0;k[g>>2]=0;g=s+4|0;h=g+4|0;k[h>>2]=0;k[h+4>>2]=0;k[s>>2]=33619968;k[g>>2]=a;mY(e,s);g=k[f>>2]|0;h=k[a+12>>2]|0;e=k[a>>2]&4095;k[w>>2]=1124007936;v=w+4|0;f=w+8|0;q=w+40|0;m=v;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[q>>2]=f;n=w+48|0;m=w+44|0;k[m>>2]=n;k[w+52>>2]=0;k[n>>2]=0;k[s>>2]=g;k[s+4>>2]=h;G1(w,2,s,e);j=(k[b+20>>2]|0)==-1?0.0:1.0;if((k[o>>2]|0)>0){l=+(k[c+8>>2]|0);f=0;do{QDa(b,c,d,a);RDa(c,d,a,j,w);c1(t,+p[u>>3]/l,w);_0(s,a,t);e=k[s>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,s,a,-1);XN(s);XN(t);f=f+1|0}while((f|0)<(k[o>>2]|0))}h=w+36|0;f=k[h>>2]|0;if(f|0?(t=f+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[w+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;w=w+16|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[v>>2]|0)>0){g=k[q>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[v>>2]|0))}f=k[m>>2]|0;if((f|0)==(n|0)|(f|0)==0){r=x;return}ggb(k[f+-4>>2]|0);r=x;return}function PDa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0.0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;va=r;r=r+672|0;ia=va+224|0;ja=va;ua=va+616|0;pa=va+560|0;na=va+504|0;ea=va+448|0;fa=b+8|0;ga=b+28|0;ha=k[ga>>2]|0;if(!((ha|0)>=1?!(+p[fa>>3]==0.0):0)){f=ia+4|0;g=ZT(52)|0;k[g>>2]=1;j=g+4|0;k[ia>>2]=j;k[f>>2]=44;i[g+48>>0]=0;h=366558;l=j+44|0;do{i[j>>0]=i[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(l|0));Y8(-5,ia,366603,366088,442);k[f>>2]=0;k[ia>>2]=0;ta=k[g>>2]|0;k[g>>2]=ta+-1;if((ta|0)==1)ggb(k[g+-4>>2]|0)}if((k[b+16>>2]|0)<1){f=ia+4|0;g=ZT(64)|0;k[g>>2]=1;j=g+4|0;k[ia>>2]=j;k[f>>2]=56;i[g+60>>0]=0;h=366631;l=j+56|0;do{i[j>>0]=i[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(l|0));Y8(-5,ia,366603,366088,447);k[f>>2]=0;k[ia>>2]=0;ta=k[g>>2]|0;k[g>>2]=ta+-1;if((ta|0)==1)ggb(k[g+-4>>2]|0)}k[a>>2]=1124007936;f=a+8|0;g=a+40|0;j=a+4|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[g>>2]=f;g=a+48|0;k[a+44>>2]=g;k[a+52>>2]=0;k[g>>2]=0;g=ia+4|0;h=g+4|0;k[h>>2]=0;k[h+4>>2]=0;k[ia>>2]=33619968;k[g>>2]=a;mY(e,ia);g=k[f>>2]|0;h=k[a+12>>2]|0;e=k[a>>2]&4095;k[ua>>2]=1124007936;sa=ua+4|0;f=ua+8|0;qa=ua+40|0;j=sa;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[qa>>2]=f;ta=ua+48|0;ra=ua+44|0;k[ra>>2]=ta;k[ua+52>>2]=0;k[ta>>2]=0;k[ia>>2]=g;k[ia+4>>2]=h;G1(ua,2,ia,e);k[pa>>2]=1124007936;la=pa+4|0;$=pa+8|0;ka=pa+40|0;j=la;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[ka>>2]=$;oa=pa+48|0;ma=pa+44|0;k[ma>>2]=oa;k[pa+52>>2]=0;k[oa>>2]=0;k[na>>2]=1124007936;da=na+4|0;f=na+8|0;ba=na+40|0;j=da;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[ba>>2]=f;ca=na+48|0;aa=na+44|0;k[aa>>2]=ca;k[na+52>>2]=0;k[ca>>2]=0;m=(k[b+20>>2]|0)==-1?0.0:1.0;E=b+36|0;if((k[E>>2]|0)>0){F=c+8|0;o=ia+4|0;q=ja+4|0;G=ea+36|0;H=ea+16|0;I=ea+4|0;J=ea+40|0;K=ea+44|0;L=ea+48|0;M=d+8|0;l=ia+4|0;n=ja+4|0;N=ea+36|0;O=ea+16|0;P=ea+4|0;Q=ea+40|0;R=ea+44|0;S=ea+48|0;u=ia+4|0;v=ja+4|0;T=ea+36|0;U=ea+16|0;V=ea+4|0;W=ea+40|0;X=ea+44|0;Y=ea+48|0;s=ia+4|0;t=ja+4|0;Z=ea+36|0;_=ea+16|0;w=ea+4|0;x=ea+40|0;y=ea+44|0;z=ea+48|0;A=ea+32|0;B=ea+32|0;C=ea+32|0;D=ea+32|0;j=0;e=0;f=k[F>>2]|0;while(1){h=e+ha|0;if((h|0)>(f|0)){k[ia>>2]=-2147483648;k[o>>2]=2147483647;k[ja>>2]=e;k[q>>2]=f;H1(ea,c,ja,ia);KG(pa,ea)|0;f=k[G>>2]|0;if(f|0?(g=f+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){g=k[G>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[B>>2]|0;if(!f){f=B1()|0;g=k[G>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[G>>2]=0}k[G>>2]=0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[I>>2]|0)>0){g=k[J>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[I>>2]|0))}f=k[K>>2]|0;if(!((f|0)==(L|0)|(f|0)==0))ggb(k[f+-4>>2]|0);f=k[M>>2]|0;k[ia>>2]=-2147483648;k[l>>2]=2147483647;k[ja>>2]=e;k[n>>2]=f;H1(ea,d,ja,ia);KG(na,ea)|0;f=k[N>>2]|0;if(f|0?(g=f+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){g=k[N>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[A>>2]|0;if(!f){f=B1()|0;g=k[N>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[N>>2]=0}k[N>>2]=0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[P>>2]|0)>0){g=k[Q>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[P>>2]|0))}f=k[R>>2]|0;if(!((f|0)==(S|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}else{k[ia>>2]=-2147483648;k[u>>2]=2147483647;k[ja>>2]=e;k[v>>2]=h;H1(ea,c,ja,ia);KG(pa,ea)|0;f=k[T>>2]|0;if(f|0?(f=f+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){g=k[T>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[D>>2]|0;if(!f){f=B1()|0;g=k[T>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[T>>2]=0}k[T>>2]=0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[V>>2]|0)>0){g=k[W>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[V>>2]|0))}f=k[X>>2]|0;if(!((f|0)==(Y|0)|(f|0)==0))ggb(k[f+-4>>2]|0);k[ia>>2]=-2147483648;k[s>>2]=2147483647;k[ja>>2]=e;k[t>>2]=h;H1(ea,d,ja,ia);KG(na,ea)|0;f=k[Z>>2]|0;if(f|0?(g=f+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){g=k[Z>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[C>>2]|0;if(!f){f=B1()|0;g=k[Z>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[Z>>2]=0}k[Z>>2]=0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[w>>2]|0)>0){g=k[x>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[w>>2]|0))}f=k[y>>2]|0;if(!((f|0)==(z|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}f=k[$>>2]|0;QDa(b,pa,na,a);RDa(pa,na,a,m,ua);c1(ja,+p[fa>>3]/+(f|0),ua);_0(ia,a,ja);f=k[ia>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,ia,a,-1);XN(ia);XN(ja);f=(k[ga>>2]|0)+e|0;g=k[F>>2]|0;j=j+1|0;if((j|0)>=(k[E>>2]|0))break;else{e=(f|0)>=(g|0)?0:f;f=g}}f=na+36|0;g=k[f>>2]|0;if((g|0)!=0?(ia=g+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){h=k[f>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[na+32>>2]|0;if(!g){g=B1()|0;h=k[f>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[f>>2]=0}}else f=na+36|0;k[f>>2]=0;na=na+16|0;k[na>>2]=0;k[na+4>>2]=0;k[na+8>>2]=0;k[na+12>>2]=0;if((k[da>>2]|0)>0){g=k[ba>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[da>>2]|0))}f=k[aa>>2]|0;if(!((f|0)==(ca|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=pa+36|0;f=k[h>>2]|0;if(f|0?(ja=f+12|0,na=k[ja>>2]|0,k[ja>>2]=na+-1,(na|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[pa+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;pa=pa+16|0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[la>>2]|0)>0){g=k[ka>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[la>>2]|0))}f=k[ma>>2]|0;if(!((f|0)==(oa|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=ua+36|0;f=k[h>>2]|0;if(f|0?(oa=f+12|0,pa=k[oa>>2]|0,k[oa>>2]=pa+-1,(pa|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[ua+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;ua=ua+16|0;k[ua>>2]=0;k[ua+4>>2]=0;k[ua+8>>2]=0;k[ua+12>>2]=0;if((k[sa>>2]|0)>0){g=k[qa>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[sa>>2]|0))}f=k[ra>>2]|0;if((f|0)==(ta|0)|(f|0)==0){r=va;return}ggb(k[f+-4>>2]|0);r=va;return}function QDa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0.0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0;W=r;r=r+1408|0;B=W+1112|0;A=W+1056|0;S=W+1352|0;O=W+1296|0;L=W+1240|0;G=W+1184|0;s=W+768|0;l=W+1024|0;t=W+96|0;m=W+992|0;n=W+544|0;v=W+320|0;w=W;x=W+1168|0;y=W+64|0;z=W+32|0;k[S>>2]=1124007936;U=S+4|0;e=S+8|0;R=S+40|0;h=U;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[R>>2]=e;V=S+48|0;T=S+44|0;k[T>>2]=V;k[S+52>>2]=0;k[V>>2]=0;k[O>>2]=1124007936;P=O+4|0;e=O+8|0;M=O+40|0;h=P;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[M>>2]=e;Q=O+48|0;N=O+44|0;k[N>>2]=Q;k[O+52>>2]=0;k[Q>>2]=0;k[L>>2]=1124007936;J=L+4|0;e=L+8|0;H=L+40|0;h=J;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[H>>2]=e;K=L+48|0;I=L+44|0;k[I>>2]=K;k[L+52>>2]=0;k[K>>2]=0;k[G>>2]=1124007936;E=G+4|0;e=G+8|0;C=G+40|0;h=E;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[C>>2]=e;F=G+48|0;D=G+44|0;k[D>>2]=F;k[G+52>>2]=0;k[F>>2]=0;q=k[b+8>>2]|0;g=k[b+12>>2]|0;k[B>>2]=-2147483648;k[B+4>>2]=2147483647;k[A>>2]=1;k[A+4>>2]=g;H1(s,d,A,B);KG(S,s)|0;g=s+36|0;e=k[g>>2]|0;if(e|0?(h=e+12|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[s+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;j=s+16|0;f=s+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[f>>2]|0)>0){g=k[s+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[s+44>>2]|0;if(!((e|0)==(s+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);a=k[a+20>>2]|0;e=(a|0)!=-1&1;if(!a){k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=S;g7(l,B);o=+((e|0)/(q<<1|0)|0|0)*+p[l>>3]}else{k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=16842752;k[A+4>>2]=S;k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=S;l=t+4|0;a=l+4|0;k[a>>2]=0;k[a+4>>2]=0;k[t>>2]=33619968;k[l>>2]=O;p[B>>3]=1.0;sU(A,s,t,49332,-1,40032,1,B);k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=O;g7(m,B);o=+((e|0)/(q<<1|0)|0|0)*+p[m>>3]}a1(n,b,d);k[A>>2]=1124007936;l=A+4|0;e=A+8|0;a=A+40|0;h=l;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[a>>2]=e;j=A+48|0;h=A+44|0;k[h>>2]=j;k[A+52>>2]=0;k[j>>2]=0;g=k[n>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,n,A,-1);LDa(B,A);KG(L,B)|0;g=B+36|0;e=k[g>>2]|0;if(e|0?(f=e+12|0,m=k[f>>2]|0,k[f>>2]=m+-1,(m|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[B+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;m=B+16|0;f=B+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[f>>2]|0)>0){g=k[B+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[B+44>>2]|0;if(!((e|0)==(B+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=A+36|0;e=k[g>>2]|0;if(e|0?(f=e+12|0,m=k[f>>2]|0,k[f>>2]=m+-1,(m|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[A+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;m=A+16|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[l>>2]|0)>0){f=k[a>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[l>>2]|0))}e=k[h>>2]|0;if(!((e|0)==(j|0)|(e|0)==0))ggb(k[e+-4>>2]|0);XN(n);k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=L;l=A+4|0;e=l+4|0;k[e>>2]=0;k[e+4>>2]=0;k[A>>2]=33619968;k[l>>2]=L;YZ(B,A);k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=16842752;k[A+4>>2]=L;k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=c;l=t+4|0;e=l+4|0;k[e>>2]=0;k[e+4>>2]=0;k[t>>2]=33619968;k[l>>2]=L;p[B>>3]=1.0;sU(A,s,t,49332,-1,40032,1,B);$0(s,b);d1(v,s,d);k[A>>2]=1124007936;l=A+4|0;e=A+8|0;a=A+40|0;h=l;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[a>>2]=e;j=A+48|0;h=A+44|0;k[h>>2]=j;k[A+52>>2]=0;k[j>>2]=0;g=k[v>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,v,A,-1);LDa(B,A);KG(G,B)|0;g=B+36|0;e=k[g>>2]|0;if(e|0?(n=e+12|0,d=k[n>>2]|0,k[n>>2]=d+-1,(d|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[B+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;d=B+16|0;f=B+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[f>>2]|0)>0){g=k[B+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[B+44>>2]|0;if(!((e|0)==(B+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=A+36|0;e=k[g>>2]|0;if(e|0?(n=e+12|0,d=k[n>>2]|0,k[n>>2]=d+-1,(d|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[A+32>>2]|0;if(e|0)break;e=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;d=A+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[l>>2]|0)>0){f=k[a>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[l>>2]|0))}e=k[h>>2]|0;if(!((e|0)==(j|0)|(e|0)==0))ggb(k[e+-4>>2]|0);XN(v);XN(s);k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=G;v=A+4|0;d=v+4|0;k[d>>2]=0;k[d+4>>2]=0;k[A>>2]=33619968;k[v>>2]=G;YZ(B,A);k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=16842752;k[A+4>>2]=G;p[w>>3]=1.0;v=w+8|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;k[v+16>>2]=0;k[v+20>>2]=0;Z0(t,w,c);k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=-1056571392;k[s+4>>2]=t;c=x+4|0;w=c+4|0;k[w>>2]=0;k[w+4>>2]=0;k[x>>2]=33619968;k[c>>2]=G;p[B>>3]=1.0;sU(A,s,x,49332,-1,40032,1,B);XN(t);k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=L;g7(y,B);X=+p[y>>3];k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=16842752;k[A+4>>2]=G;g7(z,A);p[u>>3]=o+-1.0/+(q|0)*(X+ +p[z>>3]);if(((k[u+4>>2]&2147483647)+((k[u>>2]|0)!=0&1)|0)>>>0>2146435072){k[B>>2]=0;e=B+4|0;k[e>>2]=0;f=ZT(60)|0;k[f>>2]=1;h=f+4|0;k[B>>2]=h;k[e>>2]=54;i[f+58>>0]=0;g=366503;j=h+54|0;do{i[h>>0]=i[g>>0]|0;h=h+1|0;g=g+1|0}while((h|0)<(j|0));Y8(-5,B,366768,366088,363);k[e>>2]=0;k[B>>2]=0;B=k[f>>2]|0;k[f>>2]=B+-1;if((B|0)==1)ggb(k[f+-4>>2]|0)}g=G+36|0;e=k[g>>2]|0;if(e|0?(A=e+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[G+32>>2]|0;if(e|0)break;e=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;G=G+16|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[E>>2]|0)>0){f=k[C>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[E>>2]|0))}e=k[D>>2]|0;if(!((e|0)==(F|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=L+36|0;e=k[g>>2]|0;do if(e|0){F=e+12|0;G=k[F>>2]|0;k[F>>2]=G+-1;if((G|0)!=1)break;f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[L+32>>2]|0;if(e|0)break;e=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}while(0);k[g>>2]=0;L=L+16|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[J>>2]|0)>0){f=k[H>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[J>>2]|0))}e=k[I>>2]|0;if(!((e|0)==(K|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=O+36|0;e=k[g>>2]|0;do if(e|0){K=e+12|0;L=k[K>>2]|0;k[K>>2]=L+-1;if((L|0)!=1)break;f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[O+32>>2]|0;if(e|0)break;e=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}while(0);k[g>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[P>>2]|0)>0){f=k[M>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[P>>2]|0))}e=k[N>>2]|0;if(!((e|0)==(Q|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=S+36|0;e=k[g>>2]|0;do if(e|0){P=e+12|0;Q=k[P>>2]|0;k[P>>2]=Q+-1;if((Q|0)!=1)break;f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[S+32>>2]|0;if(e|0)break;e=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}while(0);k[g>>2]=0;S=S+16|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[U>>2]|0)>0){f=k[R>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[U>>2]|0))}e=k[T>>2]|0;if((e|0)==(V|0)|(e|0)==0){r=W;return}ggb(k[e+-4>>2]|0);r=W;return}function RDa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0.0;Za=r;r=r+1440|0;Da=Za+992|0;Ea=Za+768|0;Va=Za+1264|0;Ra=Za+1208|0;Oa=Za+1152|0;Ja=Za+1096|0;g=Za+544|0;wa=Za+256|0;xa=Za+224|0;l=Za+1376|0;j=Za+512|0;ya=Za+1320|0;za=Za+1080|0;Aa=Za+480|0;Ba=Za;Ca=Za+1024|0;m=k[a+8>>2]|0;k[Va>>2]=1124007936;Xa=Va+4|0;f=Va+8|0;Ua=Va+40|0;n=Xa;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[Ua>>2]=f;Ya=Va+48|0;Wa=Va+44|0;k[Wa>>2]=Ya;k[Va+52>>2]=0;k[Ya>>2]=0;k[Ra>>2]=1124007936;Sa=Ra+4|0;f=Ra+8|0;Pa=Ra+40|0;n=Sa;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[Pa>>2]=f;Ta=Ra+48|0;Qa=Ra+44|0;k[Qa>>2]=Ta;k[Ra+52>>2]=0;k[Ta>>2]=0;k[Oa>>2]=1124007936;Ma=Oa+4|0;f=Oa+8|0;Ka=Oa+40|0;n=Ma;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[Ka>>2]=f;Na=Oa+48|0;La=Oa+44|0;k[La>>2]=Na;k[Oa+52>>2]=0;k[Na>>2]=0;a1(g,a,c);k[Ja>>2]=1124007936;Ha=Ja+4|0;f=Ja+8|0;Fa=Ja+40|0;n=Ha;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[Fa>>2]=f;Ia=Ja+48|0;Ga=Ja+44|0;k[Ga>>2]=Ia;k[Ja+52>>2]=0;k[Ia>>2]=0;va=k[g>>2]|0;dh[k[(k[va>>2]|0)+12>>2]&255](va,g,Ja,-1);XN(g);va=e+8|0;if(!((k[va>>2]|0)==(k[c+8>>2]|0)?(k[e+12>>2]|0)==(k[c+12>>2]|0):0)){k[Da>>2]=0;f=Da+4|0;k[f>>2]=0;g=ZT(68)|0;k[g>>2]=1;n=g+4|0;k[Da>>2]=n;k[f>>2]=62;i[g+66>>0]=0;h=366688;o=n+62|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,Da,366751,366088,377);k[f>>2]=0;k[Da>>2]=0;ua=k[g>>2]|0;k[g>>2]=ua+-1;if((ua|0)==1)ggb(k[g+-4>>2]|0)}LDa(wa,Ja);k[Ea>>2]=0;k[Ea+4>>2]=0;k[Ea+8>>2]=1124007936;f=Ea+16|0;g=Ea+48|0;n=Ea+12|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[g>>2]=f;f=Ea+56|0;k[Ea+52>>2]=f;k[Ea+60>>2]=0;k[f>>2]=0;k[Ea+64>>2]=1124007936;f=Ea+72|0;g=Ea+104|0;n=Ea+68|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[g>>2]=f;f=Ea+112|0;k[Ea+108>>2]=f;k[Ea+116>>2]=0;k[f>>2]=0;k[Ea+120>>2]=1124007936;f=Ea+128|0;g=Ea+160|0;n=Ea+124|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[g>>2]=f;n=Ea+168|0;k[Ea+164>>2]=n;o=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[Da>>2]=0;k[Da+4>>2]=0;k[Da+8>>2]=0;k[Da+12>>2]=0;k[Da+16>>2]=0;k[Da+20>>2]=0;k[Da+24>>2]=0;k[Da+28>>2]=0;G0(Ea,wa,b,1.0,-1.0,Da);h=k[Ea>>2]|0;dh[k[(k[h>>2]|0)+12>>2]&255](h,Ea,Va,-1);XN(Ea);h=wa+36|0;f=k[h>>2]|0;if(f|0?(ta=f+12|0,ua=k[ta>>2]|0,k[ta>>2]=ua+-1,(ua|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[wa+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;ua=wa+16|0;g=wa+4|0;k[ua>>2]=0;k[ua+4>>2]=0;k[ua+8>>2]=0;k[ua+12>>2]=0;if((k[g>>2]|0)>0){h=k[wa+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[wa+44>>2]|0;if(!((f|0)==(wa+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);k[Da>>2]=0;k[Da+4>>2]=1;k[Ea>>2]=-2147483648;k[Ea+4>>2]=2147483647;H1(wa,a,Ea,Da);KG(Ra,wa)|0;h=wa+36|0;f=k[h>>2]|0;if(f|0?(ta=f+12|0,ua=k[ta>>2]|0,k[ta>>2]=ua+-1,(ua|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[wa+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;ua=wa+16|0;g=wa+4|0;k[ua>>2]=0;k[ua+4>>2]=0;k[ua+8>>2]=0;k[ua+12>>2]=0;if((k[g>>2]|0)>0){h=k[wa+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[wa+44>>2]|0;if(!((f|0)==(wa+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);k[Ea+8>>2]=0;k[Ea+12>>2]=0;k[Ea>>2]=16842752;k[Ea+4>>2]=Va;k[wa+8>>2]=0;k[wa+12>>2]=0;k[wa>>2]=16842752;k[wa+4>>2]=Ra;h=xa+4|0;f=h+4|0;k[f>>2]=0;k[f+4>>2]=0;k[xa>>2]=33619968;k[h>>2]=Oa;p[Da>>3]=1.0;sU(Ea,wa,xa,49332,-1,40032,1,Da);k[Da>>2]=0;k[Da+4>>2]=1;k[Ea>>2]=-2147483648;k[Ea+4>>2]=2147483647;H1(l,e,Da,Ea);k[Ea+8>>2]=0;k[Ea+12>>2]=0;k[Ea>>2]=16842752;k[Ea+4>>2]=Oa;g7(j,Ea);p[Da>>3]=1.0/+(m|0)*+p[j>>3];h=Da+8|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;oY(l,Da);h=l+36|0;f=k[h>>2]|0;if(f|0?(ta=f+12|0,ua=k[ta>>2]|0,k[ta>>2]=ua+-1,(ua|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[l+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;ua=l+16|0;g=l+4|0;k[ua>>2]=0;k[ua+4>>2]=0;k[ua+8>>2]=0;k[ua+12>>2]=0;if((k[g>>2]|0)>0){h=k[l+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[l+44>>2]|0;if(!((f|0)==(l+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);if((k[va>>2]|0)>1){da=Da+4|0;ea=Ea+4|0;fa=wa+36|0;ga=wa+16|0;ha=wa+4|0;ia=wa+40|0;ja=wa+44|0;ka=wa+48|0;la=Ea+8|0;ma=Ea+12|0;na=Ea+4|0;oa=wa+8|0;pa=wa+12|0;qa=wa+4|0;ra=xa+4|0;sa=ra+4|0;ta=Da+4|0;ua=Ea+4|0;_a=+(m|0);Y=za+8|0;Z=za+12|0;_=za+4|0;$=1.0/_a;aa=xa+8|0;ba=Da+4|0;ca=Ea+4|0;d=d/_a;j=Ca+36|0;l=Ca+16|0;m=Ca+4|0;q=Ca+40|0;s=Ca+44|0;t=Ca+48|0;u=ya+36|0;v=ya+16|0;w=ya+4|0;x=ya+40|0;y=ya+44|0;z=ya+48|0;A=wa+4|0;B=wa+8|0;C=wa+12|0;D=wa+16|0;E=wa+48|0;F=wa+56|0;G=wa+52|0;H=wa+60|0;I=wa+64|0;J=wa+68|0;K=wa+72|0;L=wa+104|0;M=wa+112|0;N=wa+108|0;O=wa+116|0;P=wa+120|0;Q=wa+124|0;R=wa+128|0;S=wa+160|0;T=wa+168|0;U=wa+164|0;V=ya+32|0;W=Ca+32|0;X=wa+32|0;b=1;do{h=b;b=b+1|0;k[Da>>2]=h;k[da>>2]=b;k[Ea>>2]=-2147483648;k[ea>>2]=2147483647;H1(wa,a,Ea,Da);KG(Ra,wa)|0;f=k[fa>>2]|0;if(f|0?(n=f+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){g=k[fa>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[X>>2]|0;if(f|0)break;f=B1()|0;g=k[fa>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[fa>>2]=0}k[fa>>2]=0;k[ga>>2]=0;k[ga+4>>2]=0;k[ga+8>>2]=0;k[ga+12>>2]=0;if((k[ha>>2]|0)>0){g=k[ia>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[ha>>2]|0))}f=k[ja>>2]|0;if(!((f|0)==(ka|0)|(f|0)==0))ggb(k[f+-4>>2]|0);k[la>>2]=0;k[ma>>2]=0;k[Ea>>2]=16842752;k[na>>2]=Va;k[oa>>2]=0;k[pa>>2]=0;k[wa>>2]=16842752;k[qa>>2]=Ra;n=sa;k[n>>2]=0;k[n+4>>2]=0;k[xa>>2]=33619968;k[ra>>2]=Oa;p[Da>>3]=1.0;sU(Ea,wa,xa,49332,-1,40032,1,Da);k[Da>>2]=h;k[ta>>2]=b;k[Ea>>2]=-2147483648;k[ua>>2]=2147483647;H1(ya,e,Da,Ea);k[Y>>2]=0;k[Z>>2]=0;k[za>>2]=16842752;k[_>>2]=Oa;g7(Aa,za);p[xa>>3]=$*+p[Aa>>3];k[aa>>2]=0;k[aa+4>>2]=0;k[aa+8>>2]=0;k[aa+12>>2]=0;k[aa+16>>2]=0;k[aa+20>>2]=0;k[Da>>2]=h;k[ba>>2]=b;k[Ea>>2]=-2147483648;k[ca>>2]=2147483647;H1(Ca,c,Da,Ea);c1(Ba,d,Ca);k[wa>>2]=0;k[A>>2]=0;k[B>>2]=1124007936;n=C;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[E>>2]=D;k[G>>2]=F;k[H>>2]=0;k[F>>2]=0;k[I>>2]=1124007936;n=J;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[L>>2]=K;k[N>>2]=M;k[O>>2]=0;k[M>>2]=0;k[P>>2]=1124007936;n=Q;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[S>>2]=R;k[U>>2]=T;n=T;o=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f=k[Ba>>2]|0;dh[k[(k[f>>2]|0)+56>>2]&255](f,Ba,xa,wa);f=k[wa>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,wa,ya,-1);XN(wa);XN(Ba);f=k[j>>2]|0;if(f|0?(n=f+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){g=k[j>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[W>>2]|0;if(f|0)break;f=B1()|0;g=k[j>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[j>>2]=0}k[j>>2]=0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[m>>2]|0)>0){g=k[q>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[m>>2]|0))}f=k[s>>2]|0;if(!((f|0)==(t|0)|(f|0)==0))ggb(k[f+-4>>2]|0);f=k[u>>2]|0;do if(f|0){n=f+12|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;g=k[u>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[V>>2]|0;if(f|0)break;f=B1()|0;g=k[u>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[u>>2]=0}while(0);k[u>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[w>>2]|0)>0){g=k[x>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[w>>2]|0))}f=k[y>>2]|0;if(!((f|0)==(z|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}while((b|0)<(k[va>>2]|0))}h=Ja+36|0;f=k[h>>2]|0;if(f|0?(Da=f+12|0,Ea=k[Da>>2]|0,k[Da>>2]=Ea+-1,(Ea|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[Ja+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Ja=Ja+16|0;k[Ja>>2]=0;k[Ja+4>>2]=0;k[Ja+8>>2]=0;k[Ja+12>>2]=0;if((k[Ha>>2]|0)>0){g=k[Fa>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[Ha>>2]|0))}f=k[Ga>>2]|0;if(!((f|0)==(Ia|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=Oa+36|0;f=k[h>>2]|0;if(f|0?(Ia=f+12|0,Ja=k[Ia>>2]|0,k[Ia>>2]=Ja+-1,(Ja|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[Oa+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Oa=Oa+16|0;k[Oa>>2]=0;k[Oa+4>>2]=0;k[Oa+8>>2]=0;k[Oa+12>>2]=0;if((k[Ma>>2]|0)>0){g=k[Ka>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[Ma>>2]|0))}f=k[La>>2]|0;if(!((f|0)==(Na|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=Ra+36|0;f=k[h>>2]|0;if(f|0?(Na=f+12|0,Oa=k[Na>>2]|0,k[Na>>2]=Oa+-1,(Oa|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[Ra+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Ra=Ra+16|0;k[Ra>>2]=0;k[Ra+4>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;if((k[Sa>>2]|0)>0){g=k[Pa>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[Sa>>2]|0))}f=k[Qa>>2]|0;if(!((f|0)==(Ta|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=Va+36|0;f=k[h>>2]|0;do if(f|0){Sa=f+12|0;Ta=k[Sa>>2]|0;k[Sa>>2]=Ta+-1;if((Ta|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[Va+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;Va=Va+16|0;k[Va>>2]=0;k[Va+4>>2]=0;k[Va+8>>2]=0;k[Va+12>>2]=0;if((k[Xa>>2]|0)>0){g=k[Ua>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[Xa>>2]|0))}f=k[Wa>>2]|0;if((f|0)==(Ya|0)|(f|0)==0){r=Za;return}ggb(k[f+-4>>2]|0);r=Za;return}function SDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function TDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;e=h;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=h;return}f=a+32|0;if((k[f>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[e>>2]=g;k[c>>2]=30;i[d+34>>0]=0;j=401220;l=g+30|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}D6(a,a+12|0,b);if(!(k[f>>2]&4)){r=h;return}k[f>>2]=6;r=h;return}function UDa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;while(1){f=fgb(240)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;Qh[f&7]()}k[f>>2]=91852;p[f+8>>3]=.001;k[f+16>>2]=1e3;k[f+20>>2]=1;k[f+24>>2]=0;k[f+28>>2]=1;k[f+32>>2]=3;k[f+36>>2]=1e3;p[f+40>>3]=.001;k[f+48>>2]=1124007936;b=f+56|0;c=f+88|0;d=f+52|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=f+96|0;k[f+92>>2]=b;k[f+100>>2]=0;k[b>>2]=0;b=f+108|0;k[b>>2]=0;k[f+112>>2]=0;k[f+104>>2]=b;b=f+120|0;k[b>>2]=0;k[f+124>>2]=0;k[f+116>>2]=b;k[f+128>>2]=1124007936;b=f+136|0;c=f+168|0;d=f+132|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=f+176|0;k[f+172>>2]=b;k[f+180>>2]=0;k[b>>2]=0;k[f+184>>2]=1124007936;b=f+192|0;c=f+224|0;d=f+188|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;e=f+232|0;k[f+228>>2]=e;k[f+236>>2]=0;k[e>>2]=0;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}e=b+4|0;k[e>>2]=1;k[b>>2]=91972;k[b+8>>2]=f;k[a>>2]=b;k[a+4>>2]=f;k[e>>2]=(k[e>>2]|0)+1;f=k[e>>2]|0;k[e>>2]=f+-1;if((f|0)!=1)return;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);return}function VDa(a){a=a|0;ggb(a);return}function WDa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function XDa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;while(1){f=fgb(248)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;Qh[f&7]()}k[f>>2]=91992;k[f+8>>2]=1124007936;b=f+16|0;c=f+48|0;d=f+12|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=f+56|0;k[f+52>>2]=b;k[f+60>>2]=0;k[b>>2]=0;k[f+64>>2]=1124007936;b=f+72|0;c=f+104|0;d=f+68|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=f+112|0;k[f+108>>2]=b;k[f+116>>2]=0;k[b>>2]=0;k[f+120>>2]=1124007936;b=f+128|0;c=f+160|0;d=f+124|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;d=f+168|0;k[f+164>>2]=d;k[f+4>>2]=0;e=d+80|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}e=b+4|0;k[e>>2]=1;k[b>>2]=92064;k[b+8>>2]=f;k[a>>2]=b;k[a+4>>2]=f;k[e>>2]=(k[e>>2]|0)+1;f=k[e>>2]|0;k[e>>2]=f+-1;if((f|0)!=1)return;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);return}function YDa(a){a=a|0;ggb(a);return}function ZDa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function _Da(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=91992;zF(a+236|0);zF(a+224|0);zF(a+212|0);zF(a+200|0);zF(a+188|0);zF(a+176|0);d=a+156|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+152>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+136|0;c=a+124|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+160>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+164>>2]|0;if(!((b|0)==(a+168|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+100|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+96>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+80|0;c=a+68|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+104>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+108>>2]|0;if(!((b|0)==(a+112|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+44|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+40>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+24|0;c=a+12|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+48>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+52>>2]|0;if((b|0)==(a+56|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function $Da(a){a=a|0;_Da(a);ggb(a);return}function aEa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;f=k[a+176>>2]|0;g=a+180|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));f=k[a+188>>2]|0;g=a+192|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));f=k[a+200>>2]|0;g=a+204|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));f=k[a+212>>2]|0;g=a+216|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));f=k[a+224>>2]|0;g=a+228|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));f=k[a+236>>2]|0;g=a+240|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));d=a+44|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+40>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+24|0;c=a+12|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+48>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+100|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+96>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+80|0;c=a+68|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+104>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+156|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+152>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+136|0;c=a+124|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)<=0){a=a+4|0;k[a>>2]=0;return}d=k[a+160>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0));a=a+4|0;k[a>>2]=0;return}function bEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+16|0;p=q;n=a+64|0;e=k[a+68>>2]|0;if((e|0)<3)o=aa(k[a+76>>2]|0,k[a+72>>2]|0)|0;else{f=k[a+104>>2]|0;d=0;c=1;do{c=aa(k[f+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(e|0));o=c}k[p>>2]=0;d=p+4|0;k[d>>2]=0;f=ZT(16)|0;k[f>>2]=1;c=f+4|0;k[p>>2]=c;k[d>>2]=9;i[f+13>>0]=0;f=371497;g=c+9|0;do{i[c>>0]=i[f>>0]|0;c=c+1|0;f=f+1|0}while((c|0)<(g|0));h=z6(b,p)|0;c=k[p>>2]|0;k[d>>2]=0;k[p>>2]=0;if(c|0?(j=c+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[c+-8>>2]|0);l=a+8|0;j=a+24|0;do if(k[j>>2]|0){g=k[a+12>>2]|0;f=(g|0)<3;if(f)c=aa(k[a+20>>2]|0,k[a+16>>2]|0)|0;else{e=k[a+48>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(g|0))}if(c){if(f){c=aa(k[a+20>>2]|0,k[a+16>>2]|0)|0;break}e=k[a+48>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(g|0))}else m=14}else m=14;while(0);if((m|0)==14)c=k[a+4>>2]|0;k[p>>2]=c;mEa(h,p);k[p>>2]=0;m=p+4|0;k[m>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[p>>2]=c;k[m>>2]=7;i[d+11>>0]=0;i[c>>0]=i[371409]|0;i[c+1>>0]=i[371410]|0;i[c+2>>0]=i[371411]|0;i[c+3>>0]=i[371412]|0;i[c+4>>0]=i[371413]|0;i[c+5>>0]=i[371414]|0;i[c+6>>0]=i[371415]|0;c=z6(b,p)|0;d=k[p>>2]|0;k[m>>2]=0;k[p>>2]=0;if(d|0?(h=d+-4|0,m=k[h>>2]|0,k[h>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);mEa(c,a+4|0);if(k[j>>2]|0){e=k[a+12>>2]|0;if((e|0)<3)c=aa(k[a+20>>2]|0,k[a+16>>2]|0)|0;else{f=k[a+48>>2]|0;d=0;c=1;do{c=aa(k[f+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(e|0))}if(c|0){k[p>>2]=0;m=p+4|0;k[m>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[p>>2]=c;k[m>>2]=7;i[d+11>>0]=0;i[c>>0]=i[371385]|0;i[c+1>>0]=i[371386]|0;i[c+2>>0]=i[371387]|0;i[c+3>>0]=i[371388]|0;i[c+4>>0]=i[371389]|0;i[c+5>>0]=i[371390]|0;i[c+6>>0]=i[371391]|0;c=z6(b,p)|0;d=k[p>>2]|0;k[m>>2]=0;k[p>>2]=0;if(d|0?(j=d+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);nEa(c,l)}}k[p>>2]=0;e=p+4|0;k[e>>2]=0;f=ZT(16)|0;k[f>>2]=1;c=f+4|0;k[p>>2]=c;k[e>>2]=10;i[f+14>>0]=0;f=367738;g=c+10|0;do{i[c>>0]=i[f>>0]|0;c=c+1|0;f=f+1|0}while((c|0)<(g|0));c=z6(b,p)|0;d=k[p>>2]|0;k[e>>2]=0;k[p>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);nEa(c,n);k[p>>2]=0;n=p+4|0;k[n>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[p>>2]=c;k[n>>2]=5;i[d+9>>0]=0;i[c>>0]=i[367797]|0;i[c+1>>0]=i[367798]|0;i[c+2>>0]=i[367799]|0;i[c+3>>0]=i[367800]|0;i[c+4>>0]=i[367801]|0;c=z6(b,p)|0;d=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;if(d|0?(m=d+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[d+-8>>2]|0);k[p>>2]=0;n=p+4|0;k[n>>2]=0;l=ZT(8)|0;k[l>>2]=1;m=l+4|0;k[p>>2]=m;k[n>>2]=1;i[l+5>>0]=0;i[m>>0]=91;z6(c,p)|0;c=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;if(c|0?(m=c+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[c+-8>>2]|0);h=(o|0)>0;if(h){d=a+176|0;c=0;do{nEa(b,(k[d>>2]|0)+(c*56|0)|0);c=c+1|0}while((c|0)!=(o|0))}k[p>>2]=0;n=p+4|0;k[n>>2]=0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[p>>2]=c;k[n>>2]=1;i[d+5>>0]=0;i[c>>0]=93;c=z6(b,p)|0;d=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;if(d|0?(m=d+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[d+-8>>2]|0);k[p>>2]=0;n=p+4|0;k[n>>2]=0;m=ZT(8)|0;k[m>>2]=1;d=m+4|0;k[p>>2]=d;k[n>>2]=3;i[m+7>>0]=0;i[d>>0]=i[367803]|0;i[d+1>>0]=i[367804]|0;i[d+2>>0]=i[367805]|0;c=z6(c,p)|0;d=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;if(d|0?(m=d+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[d+-8>>2]|0);k[p>>2]=0;n=p+4|0;k[n>>2]=0;l=ZT(8)|0;k[l>>2]=1;m=l+4|0;k[p>>2]=m;k[n>>2]=1;i[l+5>>0]=0;i[m>>0]=91;z6(c,p)|0;c=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;if(c|0?(m=c+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[c+-8>>2]|0);if(h){d=a+188|0;c=0;do{nEa(b,(k[d>>2]|0)+(c*56|0)|0);c=c+1|0}while((c|0)!=(o|0))}k[p>>2]=0;n=p+4|0;k[n>>2]=0;c=ZT(8)|0;k[c>>2]=1;d=c+4|0;k[p>>2]=d;k[n>>2]=1;i[c+5>>0]=0;i[d>>0]=93;d=z6(b,p)|0;c=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;if(c|0?(m=c+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[c+-8>>2]|0);k[p>>2]=0;e=p+4|0;k[e>>2]=0;f=ZT(16)|0;k[f>>2]=1;c=f+4|0;k[p>>2]=c;k[e>>2]=10;i[f+14>>0]=0;f=367807;g=c+10|0;do{i[c>>0]=i[f>>0]|0;c=c+1|0;f=f+1|0}while((c|0)<(g|0));c=z6(d,p)|0;d=k[p>>2]|0;k[e>>2]=0;k[p>>2]=0;if(d|0?(m=d+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[d+-8>>2]|0);k[p>>2]=0;n=p+4|0;k[n>>2]=0;l=ZT(8)|0;k[l>>2]=1;m=l+4|0;k[p>>2]=m;k[n>>2]=1;i[l+5>>0]=0;i[m>>0]=91;z6(c,p)|0;c=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;if(c|0?(m=c+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[c+-8>>2]|0);if(h){d=a+200|0;c=0;do{nEa(b,(k[d>>2]|0)+(c*56|0)|0);c=c+1|0}while((c|0)!=(o|0))}k[p>>2]=0;n=p+4|0;k[n>>2]=0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[p>>2]=c;k[n>>2]=1;i[d+5>>0]=0;i[c>>0]=93;c=z6(b,p)|0;d=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;if(d|0?(m=d+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[d+-8>>2]|0);k[p>>2]=0;n=p+4|0;k[n>>2]=0;m=ZT(8)|0;k[m>>2]=1;d=m+4|0;k[p>>2]=d;k[n>>2]=3;i[m+7>>0]=0;i[d>>0]=i[367818]|0;i[d+1>>0]=i[367819]|0;i[d+2>>0]=i[367820]|0;c=z6(c,p)|0;d=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;do if(d|0){m=d+-4|0;n=k[m>>2]|0;k[m>>2]=n+-1;if((n|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[p>>2]=0;n=p+4|0;k[n>>2]=0;l=ZT(8)|0;k[l>>2]=1;m=l+4|0;k[p>>2]=m;k[n>>2]=1;i[l+5>>0]=0;i[m>>0]=91;z6(c,p)|0;c=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;do if(c|0){m=c+-4|0;n=k[m>>2]|0;k[m>>2]=n+-1;if((n|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);if(h){d=a+212|0;c=0;do{nEa(b,(k[d>>2]|0)+(c*56|0)|0);c=c+1|0}while((c|0)!=(o|0))}k[p>>2]=0;n=p+4|0;k[n>>2]=0;c=ZT(8)|0;k[c>>2]=1;d=c+4|0;k[p>>2]=d;k[n>>2]=1;i[c+5>>0]=0;i[d>>0]=93;d=z6(b,p)|0;c=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;do if(c|0){m=c+-4|0;n=k[m>>2]|0;k[m>>2]=n+-1;if((n|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[p>>2]=0;e=p+4|0;k[e>>2]=0;f=ZT(24)|0;k[f>>2]=1;c=f+4|0;k[p>>2]=c;k[e>>2]=16;i[f+20>>0]=0;f=367822;g=c+16|0;do{i[c>>0]=i[f>>0]|0;c=c+1|0;f=f+1|0}while((c|0)<(g|0));c=z6(d,p)|0;d=k[p>>2]|0;k[e>>2]=0;k[p>>2]=0;do if(d|0){m=d+-4|0;n=k[m>>2]|0;k[m>>2]=n+-1;if((n|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[p>>2]=0;n=p+4|0;k[n>>2]=0;l=ZT(8)|0;k[l>>2]=1;m=l+4|0;k[p>>2]=m;k[n>>2]=1;i[l+5>>0]=0;i[m>>0]=91;z6(c,p)|0;c=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;do if(c|0){m=c+-4|0;n=k[m>>2]|0;k[m>>2]=n+-1;if((n|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);if(h){d=a+224|0;c=0;do{nEa(b,(k[d>>2]|0)+(c*56|0)|0);c=c+1|0}while((c|0)!=(o|0))}k[p>>2]=0;n=p+4|0;k[n>>2]=0;c=ZT(8)|0;k[c>>2]=1;d=c+4|0;k[p>>2]=d;k[n>>2]=1;i[c+5>>0]=0;i[d>>0]=93;d=z6(b,p)|0;c=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;do if(c|0){m=c+-4|0;n=k[m>>2]|0;k[m>>2]=n+-1;if((n|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[p>>2]=0;e=p+4|0;k[e>>2]=0;f=ZT(20)|0;k[f>>2]=1;c=f+4|0;k[p>>2]=c;k[e>>2]=15;i[f+19>>0]=0;f=367839;g=c+15|0;do{i[c>>0]=i[f>>0]|0;c=c+1|0;f=f+1|0}while((c|0)<(g|0));c=z6(d,p)|0;d=k[p>>2]|0;k[e>>2]=0;k[p>>2]=0;do if(d|0){m=d+-4|0;n=k[m>>2]|0;k[m>>2]=n+-1;if((n|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);n=p+4|0;l=ZT(8)|0;k[l>>2]=1;m=l+4|0;k[p>>2]=m;k[n>>2]=1;i[l+5>>0]=0;i[m>>0]=91;z6(c,p)|0;c=k[p>>2]|0;k[n>>2]=0;k[p>>2]=0;do if(c|0){m=c+-4|0;n=k[m>>2]|0;k[m>>2]=n+-1;if((n|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);if(h){d=a+236|0;c=0;do{nEa(b,(k[d>>2]|0)+(c*56|0)|0);c=c+1|0}while((c|0)!=(o|0))}o=p+4|0;n=ZT(8)|0;k[n>>2]=1;c=n+4|0;k[p>>2]=c;k[o>>2]=1;i[n+5>>0]=0;i[c>>0]=93;z6(b,p)|0;c=k[p>>2]|0;k[o>>2]=0;k[p>>2]=0;do if(c|0){n=c+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);o=p+4|0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[p>>2]=c;k[o>>2]=1;i[d+5>>0]=0;i[c>>0]=99;c=z6(b,p)|0;d=k[p>>2]|0;k[o>>2]=0;k[p>>2]=0;if(!d){p=a+120|0;nEa(c,p);r=q;return}b=d+-4|0;p=k[b>>2]|0;k[b>>2]=p+-1;if((p|0)!=1){p=a+120|0;nEa(c,p);r=q;return}ggb(k[d+-8>>2]|0);p=a+120|0;nEa(c,p);r=q;return}function cEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0.0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0;mb=r;r=r+320|0;lb=mb+264|0;eb=mb+220|0;fb=mb+176|0;gb=mb+132|0;hb=mb+88|0;ib=mb+44|0;jb=mb;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);kb=b+4|0;c=k6(k[b>>2]|0,k[kb>>2]|0,371409)|0;d=a+4|0;a:do if(c){switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break}case 2:{m=+p[c+8>>3];p[u>>3]=m;c=k[u+4>>2]|0;db=c&2146435072;if(!(db>>>0>1126170624|(db|0)==1126170624&0>0)){c=(c|0)<0;m=c?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=c?-0.0:0.0}c=~~m;break}default:{k[d>>2]=2147483647;break a}}k[d>>2]=c;if((c|0)<1)C=11}else{k[d>>2]=0;C=11}while(0);if((C|0)==11){c=lb+4|0;d=ZT(76)|0;k[d>>2]=1;g=d+4|0;k[lb>>2]=g;k[c>>2]=69;i[d+73>>0]=0;e=367668;j=g+69|0;do{i[g>>0]=i[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(j|0));Y8(-212,lb,401059,367335,389);k[c>>2]=0;k[lb>>2]=0;db=k[d>>2]|0;k[d>>2]=db+-1;if((db|0)==1)ggb(k[d+-4>>2]|0)}d=k[b>>2]|0;e=k6(d,k[kb>>2]|0,371385)|0;f=a+8|0;k[lb>>2]=1124007936;l=lb+4|0;c=lb+8|0;h=lb+40|0;g=l;j=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[h>>2]=c;j=lb+48|0;g=lb+44|0;k[g>>2]=j;k[lb+52>>2]=0;k[j>>2]=0;G6(d,e,f,lb);e=lb+36|0;c=k[e>>2]|0;if(c|0?(cb=c+12|0,db=k[cb>>2]|0,k[cb>>2]=db+-1,(db|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[lb+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;db=lb+16|0;k[db>>2]=0;k[db+4>>2]=0;k[db+8>>2]=0;k[db+12>>2]=0;if((k[l>>2]|0)>0){d=k[h>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[l>>2]|0))}c=k[g>>2]|0;if(!((c|0)==(j|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=k[b>>2]|0;e=k6(d,k[kb>>2]|0,367738)|0;f=a+64|0;k[lb>>2]=1124007936;l=lb+4|0;c=lb+8|0;h=lb+40|0;g=l;j=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[h>>2]=c;j=lb+48|0;g=lb+44|0;k[g>>2]=j;k[lb+52>>2]=0;k[j>>2]=0;G6(d,e,f,lb);e=lb+36|0;c=k[e>>2]|0;if(c|0?(cb=c+12|0,db=k[cb>>2]|0,k[cb>>2]=db+-1,(db|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[lb+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;db=lb+16|0;k[db>>2]=0;k[db+4>>2]=0;k[db+8>>2]=0;k[db+12>>2]=0;if((k[l>>2]|0)>0){d=k[h>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[l>>2]|0))}c=k[g>>2]|0;if(!((c|0)==(j|0)|(c|0)==0))ggb(k[c+-4>>2]|0);g=k[a+68>>2]|0;f=(g|0)<3;if(f)db=aa(k[a+76>>2]|0,k[a+72>>2]|0)|0;else{e=k[a+104>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(g|0));db=c}if(k[a+80>>2]|0){if(f)c=aa(k[a+76>>2]|0,k[a+72>>2]|0)|0;else{e=k[a+104>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(g|0))}if((db|0)<1|(c|0)==0)C=50}else C=50;if((C|0)==50){c=lb+4|0;d=ZT(52)|0;k[d>>2]=1;g=d+4|0;k[lb>>2]=g;k[c>>2]=47;i[d+51>>0]=0;e=367749;j=g+47|0;do{i[g>>0]=i[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(j|0));Y8(-212,lb,401059,367335,397);k[c>>2]=0;k[lb>>2]=0;cb=k[d>>2]|0;k[d>>2]=cb+-1;if((cb|0)==1)ggb(k[d+-4>>2]|0)}c=k[b>>2]|0;e=k6(c,k[kb>>2]|0,367797)|0;do if((c|0)!=0&(e|0)!=0?(n=k[e>>2]|0,o=n&7,(o|0)!=0):0){k[eb>>2]=c;k[eb+4>>2]=e;if(!((o+-5|0)>>>0<2&(n&16|0)==0)){k[eb+20>>2]=e;k[eb+12>>2]=0;k[eb+40>>2]=1;break}d=e+8|0;KY(k[d>>2]|0,eb+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[eb+40>>2]=c}else C=62;while(0);if((C|0)==62){k[eb>>2]=0;k[eb+4>>2]=0;k[eb+20>>2]=0;k[eb+40>>2]=0}c=k[b>>2]|0;e=k6(c,k[kb>>2]|0,367803)|0;do if((c|0)!=0&(e|0)!=0?(q=k[e>>2]|0,s=q&7,(s|0)!=0):0){k[fb>>2]=c;k[fb+4>>2]=e;if(!((s+-5|0)>>>0<2&(q&16|0)==0)){k[fb+20>>2]=e;k[fb+12>>2]=0;k[fb+40>>2]=1;break}d=e+8|0;KY(k[d>>2]|0,fb+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[fb+40>>2]=c}else C=72;while(0);if((C|0)==72){k[fb>>2]=0;k[fb+4>>2]=0;k[fb+20>>2]=0;k[fb+40>>2]=0}c=k[b>>2]|0;e=k6(c,k[kb>>2]|0,367807)|0;do if((c|0)!=0&(e|0)!=0?(t=k[e>>2]|0,v=t&7,(v|0)!=0):0){k[gb>>2]=c;k[gb+4>>2]=e;if(!((v+-5|0)>>>0<2&(t&16|0)==0)){k[gb+20>>2]=e;k[gb+12>>2]=0;k[gb+40>>2]=1;break}d=e+8|0;KY(k[d>>2]|0,gb+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[gb+40>>2]=c}else C=82;while(0);if((C|0)==82){k[gb>>2]=0;k[gb+4>>2]=0;k[gb+20>>2]=0;k[gb+40>>2]=0}c=k[b>>2]|0;e=k6(c,k[kb>>2]|0,367818)|0;do if((c|0)!=0&(e|0)!=0?(w=k[e>>2]|0,x=w&7,(x|0)!=0):0){k[hb>>2]=c;k[hb+4>>2]=e;if(!((x+-5|0)>>>0<2&(w&16|0)==0)){k[hb+20>>2]=e;k[hb+12>>2]=0;k[hb+40>>2]=1;break}d=e+8|0;KY(k[d>>2]|0,hb+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[hb+40>>2]=c}else C=92;while(0);if((C|0)==92){k[hb>>2]=0;k[hb+4>>2]=0;k[hb+20>>2]=0;k[hb+40>>2]=0}c=k[b>>2]|0;e=k6(c,k[kb>>2]|0,367822)|0;do if((c|0)!=0&(e|0)!=0?(y=k[e>>2]|0,z=y&7,(z|0)!=0):0){k[ib>>2]=c;k[ib+4>>2]=e;if(!((z+-5|0)>>>0<2&(y&16|0)==0)){k[ib+20>>2]=e;k[ib+12>>2]=0;k[ib+40>>2]=1;break}d=e+8|0;KY(k[d>>2]|0,ib+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[ib+40>>2]=c}else C=102;while(0);if((C|0)==102){k[ib>>2]=0;k[ib+4>>2]=0;k[ib+20>>2]=0;k[ib+40>>2]=0}c=k[b>>2]|0;e=k6(c,k[kb>>2]|0,367839)|0;do if((c|0)!=0&(e|0)!=0?(A=k[e>>2]|0,B=A&7,(B|0)!=0):0){k[jb>>2]=c;k[jb+4>>2]=e;if(!((B+-5|0)>>>0<2&(A&16|0)==0)){k[jb+20>>2]=e;k[jb+12>>2]=0;k[jb+40>>2]=1;break}d=e+8|0;KY(k[d>>2]|0,jb+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[jb+40>>2]=c}else C=112;while(0);if((C|0)==112){k[jb>>2]=0;k[jb+4>>2]=0;k[jb+20>>2]=0;k[jb+40>>2]=0}h=a+176|0;Y1(h,db);l=a+188|0;Y1(l,db);n=a+200|0;Y1(n,db);o=a+212|0;Y1(o,db);q=a+224|0;Y1(q,db);s=a+236|0;Y1(s,db);if((db|0)>0){t=eb+20|0;v=lb+4|0;w=lb+8|0;x=lb+40|0;y=lb+48|0;z=lb+44|0;A=lb+52|0;B=lb+36|0;C=lb+16|0;D=fb+20|0;E=lb+4|0;F=lb+8|0;G=lb+40|0;H=lb+48|0;I=lb+44|0;J=lb+52|0;K=lb+36|0;L=lb+16|0;M=gb+20|0;N=lb+4|0;O=lb+8|0;P=lb+40|0;Q=lb+48|0;R=lb+44|0;S=lb+52|0;T=lb+36|0;U=lb+16|0;V=hb+20|0;W=lb+4|0;X=lb+8|0;Y=lb+40|0;Z=lb+48|0;_=lb+44|0;$=lb+52|0;ba=lb+36|0;ca=lb+16|0;da=ib+20|0;ea=lb+4|0;fa=lb+8|0;ga=lb+40|0;ha=lb+48|0;ia=lb+44|0;ja=lb+52|0;ka=lb+36|0;la=lb+16|0;ma=jb+20|0;na=lb+4|0;oa=lb+8|0;pa=lb+40|0;qa=lb+48|0;ra=lb+44|0;sa=lb+52|0;ta=lb+36|0;ua=lb+16|0;va=eb+40|0;wa=fb+40|0;xa=gb+40|0;ya=hb+40|0;za=ib+40|0;Aa=jb+40|0;Ba=jb+12|0;Ca=jb+28|0;Da=jb+16|0;Ea=jb+24|0;Fa=ib+12|0;Ga=ib+28|0;Ha=ib+16|0;Ia=ib+24|0;Ja=hb+12|0;Ka=hb+28|0;La=hb+16|0;Ma=hb+24|0;Na=gb+12|0;Oa=gb+28|0;Pa=gb+16|0;Qa=gb+24|0;Ra=fb+12|0;Sa=fb+28|0;Ta=fb+16|0;Ua=fb+24|0;Va=eb+12|0;Wa=eb+28|0;Xa=eb+16|0;Ya=eb+24|0;Za=lb+32|0;_a=lb+32|0;$a=lb+32|0;ab=lb+32|0;bb=lb+32|0;cb=lb+32|0;f=0;do{c=k[eb>>2]|0;d=k[t>>2]|0;e=(k[h>>2]|0)+(f*56|0)|0;k[lb>>2]=1124007936;g=v;j=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[x>>2]=w;k[z>>2]=y;k[A>>2]=0;k[y>>2]=0;G6(c,d,e,lb);c=k[B>>2]|0;do if(c|0){g=c+12|0;j=k[g>>2]|0;k[g>>2]=j+-1;if((j|0)!=1)break;d=k[B>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[cb>>2]|0;if(c|0)break;c=B1()|0;d=k[B>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[B>>2]=0}while(0);k[B>>2]=0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[v>>2]|0)>0){d=k[x>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[z>>2]|0;if(!((c|0)==(y|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[fb>>2]|0;d=k[D>>2]|0;e=(k[l>>2]|0)+(f*56|0)|0;k[lb>>2]=1124007936;g=E;j=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[G>>2]=F;k[I>>2]=H;k[J>>2]=0;k[H>>2]=0;G6(c,d,e,lb);c=k[K>>2]|0;do if(c|0){g=c+12|0;j=k[g>>2]|0;k[g>>2]=j+-1;if((j|0)!=1)break;d=k[K>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[bb>>2]|0;if(c|0)break;c=B1()|0;d=k[K>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[K>>2]=0}while(0);k[K>>2]=0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[E>>2]|0)>0){d=k[G>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[E>>2]|0))}c=k[I>>2]|0;if(!((c|0)==(H|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[gb>>2]|0;d=k[M>>2]|0;e=(k[n>>2]|0)+(f*56|0)|0;k[lb>>2]=1124007936;g=N;j=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[P>>2]=O;k[R>>2]=Q;k[S>>2]=0;k[Q>>2]=0;G6(c,d,e,lb);c=k[T>>2]|0;do if(c|0){g=c+12|0;j=k[g>>2]|0;k[g>>2]=j+-1;if((j|0)!=1)break;d=k[T>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[ab>>2]|0;if(c|0)break;c=B1()|0;d=k[T>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[T>>2]=0}while(0);k[T>>2]=0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[N>>2]|0)>0){d=k[P>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[N>>2]|0))}c=k[R>>2]|0;if(!((c|0)==(Q|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[hb>>2]|0;d=k[V>>2]|0;e=(k[o>>2]|0)+(f*56|0)|0;k[lb>>2]=1124007936;g=W;j=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[Y>>2]=X;k[_>>2]=Z;k[$>>2]=0;k[Z>>2]=0;G6(c,d,e,lb);c=k[ba>>2]|0;do if(c|0){g=c+12|0;j=k[g>>2]|0;k[g>>2]=j+-1;if((j|0)!=1)break;d=k[ba>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[$a>>2]|0;if(c|0)break;c=B1()|0;d=k[ba>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[ba>>2]=0}while(0);k[ba>>2]=0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;if((k[W>>2]|0)>0){d=k[Y>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[W>>2]|0))}c=k[_>>2]|0;if(!((c|0)==(Z|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[ib>>2]|0;d=k[da>>2]|0;e=(k[q>>2]|0)+(f*56|0)|0;k[lb>>2]=1124007936;g=ea;j=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[ga>>2]=fa;k[ia>>2]=ha;k[ja>>2]=0;k[ha>>2]=0;G6(c,d,e,lb);c=k[ka>>2]|0;do if(c|0){g=c+12|0;j=k[g>>2]|0;k[g>>2]=j+-1;if((j|0)!=1)break;d=k[ka>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[_a>>2]|0;if(c|0)break;c=B1()|0;d=k[ka>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[ka>>2]=0}while(0);k[ka>>2]=0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[ea>>2]|0)>0){d=k[ga>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[ea>>2]|0))}c=k[ia>>2]|0;if(!((c|0)==(ha|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[jb>>2]|0;d=k[ma>>2]|0;e=(k[s>>2]|0)+(f*56|0)|0;k[lb>>2]=1124007936;g=na;j=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[pa>>2]=oa;k[ra>>2]=qa;k[sa>>2]=0;k[qa>>2]=0;G6(c,d,e,lb);c=k[ta>>2]|0;do if(c|0){g=c+12|0;j=k[g>>2]|0;k[g>>2]=j+-1;if((j|0)!=1)break;d=k[ta>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[Za>>2]|0;if(c|0)break;c=B1()|0;d=k[ta>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[ta>>2]=0}while(0);k[ta>>2]=0;k[ua>>2]=0;k[ua+4>>2]=0;k[ua+8>>2]=0;k[ua+12>>2]=0;if((k[na>>2]|0)>0){d=k[pa>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[na>>2]|0))}c=k[ra>>2]|0;if(!((c|0)==(qa|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=f+1|0;c=k[va>>2]|0;if(c|0){d=k[Va>>2]|0;do if(d|0){j=(k[t>>2]|0)+(k[d+28>>2]|0)|0;k[t>>2]=j;if(j>>>0<(k[Wa>>2]|0)>>>0)break;j=k[(k[Xa>>2]|0)+4>>2]|0;k[Xa>>2]=j;e=k[j+16>>2]|0;k[t>>2]=e;g=k[d+28>>2]|0;j=k[j+12>>2]|0;k[Ya>>2]=e;j=e+(aa(g,j)|0)|0;k[Wa>>2]=j}while(0);k[va>>2]=c+-1}c=k[wa>>2]|0;if(c|0){d=k[Ra>>2]|0;do if(d|0){j=(k[D>>2]|0)+(k[d+28>>2]|0)|0;k[D>>2]=j;if(j>>>0<(k[Sa>>2]|0)>>>0)break;j=k[(k[Ta>>2]|0)+4>>2]|0;k[Ta>>2]=j;e=k[j+16>>2]|0;k[D>>2]=e;g=k[d+28>>2]|0;j=k[j+12>>2]|0;k[Ua>>2]=e;j=e+(aa(g,j)|0)|0;k[Sa>>2]=j}while(0);k[wa>>2]=c+-1}c=k[xa>>2]|0;if(c|0){d=k[Na>>2]|0;do if(d|0){j=(k[M>>2]|0)+(k[d+28>>2]|0)|0;k[M>>2]=j;if(j>>>0<(k[Oa>>2]|0)>>>0)break;j=k[(k[Pa>>2]|0)+4>>2]|0;k[Pa>>2]=j;e=k[j+16>>2]|0;k[M>>2]=e;g=k[d+28>>2]|0;j=k[j+12>>2]|0;k[Qa>>2]=e;j=e+(aa(g,j)|0)|0;k[Oa>>2]=j}while(0);k[xa>>2]=c+-1}c=k[ya>>2]|0;if(c|0){d=k[Ja>>2]|0;do if(d|0){j=(k[V>>2]|0)+(k[d+28>>2]|0)|0;k[V>>2]=j;if(j>>>0<(k[Ka>>2]|0)>>>0)break;j=k[(k[La>>2]|0)+4>>2]|0;k[La>>2]=j;e=k[j+16>>2]|0;k[V>>2]=e;g=k[d+28>>2]|0;j=k[j+12>>2]|0;k[Ma>>2]=e;j=e+(aa(g,j)|0)|0;k[Ka>>2]=j}while(0);k[ya>>2]=c+-1}c=k[za>>2]|0;if(c|0){d=k[Fa>>2]|0;do if(d|0){j=(k[da>>2]|0)+(k[d+28>>2]|0)|0;k[da>>2]=j;if(j>>>0<(k[Ga>>2]|0)>>>0)break;j=k[(k[Ha>>2]|0)+4>>2]|0;k[Ha>>2]=j;e=k[j+16>>2]|0;k[da>>2]=e;g=k[d+28>>2]|0;j=k[j+12>>2]|0;k[Ia>>2]=e;j=e+(aa(g,j)|0)|0;k[Ga>>2]=j}while(0);k[za>>2]=c+-1}c=k[Aa>>2]|0;if(c|0){d=k[Ba>>2]|0;do if(d|0){j=(k[ma>>2]|0)+(k[d+28>>2]|0)|0;k[ma>>2]=j;if(j>>>0<(k[Ca>>2]|0)>>>0)break;j=k[(k[Da>>2]|0)+4>>2]|0;k[Da>>2]=j;e=k[j+16>>2]|0;k[ma>>2]=e;g=k[d+28>>2]|0;j=k[j+12>>2]|0;k[Ea>>2]=e;j=e+(aa(g,j)|0)|0;k[Ca>>2]=j}while(0);k[Aa>>2]=c+-1}}while((f|0)<(db|0))}f=k[b>>2]|0;e=k6(f,k[kb>>2]|0,367855)|0;d=a+120|0;k[lb>>2]=1124007936;l=lb+4|0;c=lb+8|0;h=lb+40|0;g=l;j=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[h>>2]=c;j=lb+48|0;g=lb+44|0;k[g>>2]=j;k[lb+52>>2]=0;k[j>>2]=0;G6(f,e,d,lb);e=lb+36|0;c=k[e>>2]|0;if(c|0?(kb=c+12|0,a=k[kb>>2]|0,k[kb>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[lb+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;lb=lb+16|0;k[lb>>2]=0;k[lb+4>>2]=0;k[lb+8>>2]=0;k[lb+12>>2]=0;if((k[l>>2]|0)>0){d=k[h>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[l>>2]|0))}c=k[g>>2]|0;if((c|0)==(j|0)|(c|0)==0){r=mb;return}ggb(k[c+-4>>2]|0);r=mb;return}function dEa(a,b){a=a|0;b=b|0;var c=0;c=ZT(24)|0;k[c>>2]=1;b=c+4|0;k[a>>2]=b;k[a+4>>2]=16;i[c+20>>0]=0;a=b;b=367651;c=a+16|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));return}function eEa(a){a=a|0;return k[a+4>>2]|0}function fEa(a){a=a|0;return (k[a+212>>2]|0)!=(k[a+216>>2]|0)|0}function gEa(a){a=a|0;return 1}function hEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,q=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0;rc=r;r=r+576|0;hc=rc+240|0;qc=rc+512|0;pc=rc+456|0;nc=rc+400|0;mc=rc+344|0;lc=rc+16|0;kc=rc+288|0;ec=rc+272|0;fc=rc;gc=rc+256|0;g=b+4|0;oc=k[g>>2]|0;jh[k[(k[oc>>2]|0)+68>>2]&1023](qc,oc);oc=k[g>>2]|0;jh[k[(k[oc>>2]|0)+120>>2]&1023](pc,oc);oc=k[g>>2]|0;jh[k[(k[oc>>2]|0)+84>>2]&1023](nc,oc);oc=k[g>>2]|0;eh[k[(k[oc>>2]|0)+44>>2]&255](mc,oc,0,1,1);oc=pc+4|0;e=k[oc>>2]|0;if((e|0)<3)cc=aa(k[pc+12>>2]|0,k[pc+8>>2]|0)|0;else{f=k[pc+40>>2]|0;d=0;b=1;do{b=aa(k[f+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0));cc=b}dc=k[g>>2]|0;dc=Xh[k[(k[dc>>2]|0)+24>>2]&1023](dc)|0;b=k[g>>2]|0;b=Xh[k[(k[b>>2]|0)+28>>2]&1023](b)|0;d=a+4|0;a:do if(c&1){do if((k[d>>2]|0)==(b|0)?(Sb=k[a+48>>2]|0,Tb=k[nc+40>>2]|0,!((k[Sb>>2]|0)!=(k[Tb>>2]|0)?1:(k[Sb+4>>2]|0)!=(k[Tb+4>>2]|0))):0){k[hc+8>>2]=0;k[hc+12>>2]=0;k[hc>>2]=16842752;k[hc+4>>2]=a+8;k[lc+8>>2]=0;k[lc+12>>2]=0;k[lc>>2]=16842752;k[lc+4>>2]=nc;if(+h8(hc,lc,1,49332)!=0.0)break;Sb=k[a+104>>2]|0;Tb=k[pc+40>>2]|0;if(!((k[Sb>>2]|0)!=(k[Tb>>2]|0)?1:(k[Sb+4>>2]|0)!=(k[Tb+4>>2]|0))?(k[kc+8>>2]=0,k[kc+12>>2]=0,k[kc>>2]=16842752,k[kc+4>>2]=a+64,k[ec+8>>2]=0,k[ec+12>>2]=0,k[ec>>2]=16842752,k[ec+4>>2]=pc,!(+h8(kc,ec,1,49332)!=0.0)):0)break a;else break}while(0);k[hc>>2]=0;b=hc+4|0;k[b>>2]=0;d=ZT(124)|0;k[d>>2]=1;Sb=d+4|0;k[hc>>2]=Sb;k[b>>2]=117;i[d+121>>0]=0;e=367533;Tb=Sb+117|0;do{i[Sb>>0]=i[e>>0]|0;Sb=Sb+1|0;e=e+1|0}while((Sb|0)<(Tb|0));Y8(-5,hc,389152,367335,104);k[b>>2]=0;k[hc>>2]=0;Tb=k[d>>2]|0;k[d>>2]=Tb+-1;if((Tb|0)==1)ggb(k[d+-4>>2]|0)}else{k[d>>2]=b;cb=a+176|0;Y1(cb,cc);db=a+188|0;Y1(db,cc);eb=a+200|0;Y1(eb,cc);fb=a+212|0;Y1(fb,cc);gb=a+224|0;Y1(gb,cc);hb=a+236|0;Y1(hb,cc);if((cc|0)>0){ib=lc+4|0;jb=lc+8|0;kb=lc+12|0;lb=lc+16|0;mb=lc+48|0;nb=lc+56|0;ob=lc+52|0;pb=lc+60|0;qb=lc+64|0;rb=lc+68|0;sb=lc+72|0;tb=lc+104|0;ub=lc+112|0;vb=lc+108|0;wb=lc+116|0;xb=lc+120|0;yb=lc+124|0;zb=lc+128|0;Ab=lc+160|0;Bb=lc+168|0;Cb=lc+164|0;Db=hc+4|0;Eb=lc+4|0;Fb=lc+8|0;Gb=lc+12|0;Hb=lc+16|0;Ib=lc+48|0;Jb=lc+56|0;Kb=lc+52|0;Lb=lc+60|0;Mb=lc+64|0;Nb=lc+68|0;Ob=lc+72|0;Pb=lc+104|0;Qb=lc+112|0;Rb=lc+108|0;e=lc+116|0;f=lc+120|0;g=lc+124|0;c=lc+128|0;j=lc+160|0;l=lc+168|0;m=lc+164|0;n=hc+4|0;q=lc+4|0;v=lc+8|0;w=lc+12|0;x=lc+16|0;y=lc+48|0;z=lc+56|0;A=lc+52|0;B=lc+60|0;C=lc+64|0;D=lc+68|0;E=lc+72|0;F=lc+104|0;G=lc+112|0;H=lc+108|0;I=lc+116|0;J=lc+120|0;K=lc+124|0;L=lc+128|0;M=lc+160|0;N=lc+168|0;O=lc+164|0;P=hc+4|0;Q=lc+4|0;R=lc+8|0;S=lc+12|0;T=lc+16|0;U=lc+48|0;V=lc+56|0;W=lc+52|0;X=lc+60|0;Y=lc+64|0;Z=lc+68|0;$=lc+72|0;ba=lc+104|0;ca=lc+112|0;da=lc+108|0;ea=lc+116|0;fa=lc+120|0;ga=lc+124|0;ha=lc+128|0;ia=lc+160|0;ja=lc+168|0;ka=lc+164|0;la=hc+4|0;ma=lc+4|0;na=lc+8|0;oa=lc+12|0;pa=lc+16|0;qa=lc+48|0;ra=lc+56|0;sa=lc+52|0;ta=lc+60|0;ua=lc+64|0;va=lc+68|0;wa=lc+72|0;xa=lc+104|0;ya=lc+112|0;za=lc+108|0;Aa=lc+116|0;Ba=lc+120|0;Ca=lc+124|0;Da=lc+128|0;Ea=lc+160|0;Fa=lc+168|0;Ga=lc+164|0;Ha=hc+4|0;Ia=lc+4|0;Ja=lc+8|0;Ka=lc+12|0;La=lc+16|0;Ma=lc+48|0;Na=lc+56|0;Oa=lc+52|0;Pa=lc+60|0;Qa=lc+64|0;Ra=lc+68|0;Sa=lc+72|0;Ta=lc+104|0;Ua=lc+112|0;Va=lc+108|0;Wa=lc+116|0;Xa=lc+120|0;Ya=lc+124|0;Za=lc+128|0;_a=lc+160|0;$a=lc+168|0;ab=lc+164|0;bb=hc+4|0;d=0;do{b=k[cb>>2]|0;k[lc>>2]=0;k[ib>>2]=0;k[jb>>2]=1124007936;Sb=kb;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[mb>>2]=lb;k[ob>>2]=nb;k[pb>>2]=0;k[nb>>2]=0;k[qb>>2]=1124007936;Sb=rb;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[tb>>2]=sb;k[vb>>2]=ub;k[wb>>2]=0;k[ub>>2]=0;k[xb>>2]=1124007936;Sb=yb;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[Ab>>2]=zb;k[Cb>>2]=Bb;Sb=Bb;Tb=Sb+56|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[hc>>2]=dc;k[Db>>2]=1;j1(lc,48,hc,4);Sb=k[lc>>2]|0;dh[k[(k[Sb>>2]|0)+12>>2]&255](Sb,lc,b+(d*56|0)|0,-1);XN(lc);b=k[db>>2]|0;k[lc>>2]=0;k[Eb>>2]=0;k[Fb>>2]=1124007936;Sb=Gb;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[Ib>>2]=Hb;k[Kb>>2]=Jb;k[Lb>>2]=0;k[Jb>>2]=0;k[Mb>>2]=1124007936;Sb=Nb;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[Pb>>2]=Ob;k[Rb>>2]=Qb;k[e>>2]=0;k[Qb>>2]=0;k[f>>2]=1124007936;Sb=g;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[j>>2]=c;k[m>>2]=l;Sb=l;Tb=Sb+56|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[hc>>2]=dc;k[n>>2]=1;j1(lc,48,hc,6);Sb=k[lc>>2]|0;dh[k[(k[Sb>>2]|0)+12>>2]&255](Sb,lc,b+(d*56|0)|0,-1);XN(lc);b=k[eb>>2]|0;k[lc>>2]=0;k[q>>2]=0;k[v>>2]=1124007936;Sb=w;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[y>>2]=x;k[A>>2]=z;k[B>>2]=0;k[z>>2]=0;k[C>>2]=1124007936;Sb=D;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[F>>2]=E;k[H>>2]=G;k[I>>2]=0;k[G>>2]=0;k[J>>2]=1124007936;Sb=K;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[M>>2]=L;k[O>>2]=N;Sb=N;Tb=Sb+56|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[hc>>2]=dc;k[P>>2]=dc;j1(lc,48,hc,6);Sb=k[lc>>2]|0;dh[k[(k[Sb>>2]|0)+12>>2]&255](Sb,lc,b+(d*56|0)|0,-1);XN(lc);b=k[fb>>2]|0;k[lc>>2]=0;k[Q>>2]=0;k[R>>2]=1124007936;Sb=S;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[U>>2]=T;k[W>>2]=V;k[X>>2]=0;k[V>>2]=0;k[Y>>2]=1124007936;Sb=Z;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[ba>>2]=$;k[da>>2]=ca;k[ea>>2]=0;k[ca>>2]=0;k[fa>>2]=1124007936;Sb=ga;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[ia>>2]=ha;k[ka>>2]=ja;Sb=ja;Tb=Sb+56|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[hc>>2]=dc;k[la>>2]=1;j1(lc,48,hc,6);Sb=k[lc>>2]|0;dh[k[(k[Sb>>2]|0)+12>>2]&255](Sb,lc,b+(d*56|0)|0,-1);XN(lc);b=k[gb>>2]|0;k[lc>>2]=0;k[ma>>2]=0;k[na>>2]=1124007936;Sb=oa;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[qa>>2]=pa;k[sa>>2]=ra;k[ta>>2]=0;k[ra>>2]=0;k[ua>>2]=1124007936;Sb=va;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[xa>>2]=wa;k[za>>2]=ya;k[Aa>>2]=0;k[ya>>2]=0;k[Ba>>2]=1124007936;Sb=Ca;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[Ea>>2]=Da;k[Ga>>2]=Fa;Sb=Fa;Tb=Sb+56|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[hc>>2]=dc;k[Ha>>2]=1;j1(lc,48,hc,6);Sb=k[lc>>2]|0;dh[k[(k[Sb>>2]|0)+12>>2]&255](Sb,lc,b+(d*56|0)|0,-1);XN(lc);b=k[hb>>2]|0;k[lc>>2]=0;k[Ia>>2]=0;k[Ja>>2]=1124007936;Sb=Ka;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[Ma>>2]=La;k[Oa>>2]=Na;k[Pa>>2]=0;k[Na>>2]=0;k[Qa>>2]=1124007936;Sb=Ra;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[Ta>>2]=Sa;k[Va>>2]=Ua;k[Wa>>2]=0;k[Ua>>2]=0;k[Xa>>2]=1124007936;Sb=Ya;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[_a>>2]=Za;k[ab>>2]=$a;Sb=$a;Tb=Sb+56|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[hc>>2]=dc;k[bb>>2]=dc;j1(lc,48,hc,6);Tb=k[lc>>2]|0;dh[k[(k[Tb>>2]|0)+12>>2]&255](Tb,lc,b+(d*56|0)|0,-1);XN(lc);d=d+1|0}while((d|0)<(cc|0))}KG(a+8|0,nc)|0;KG(a+64|0,pc)|0;b=a+120|0;if(((((k[a+124>>2]|0)<3?(k[a+128>>2]|0)==1:0)?(k[a+132>>2]|0)==(cc|0):0)?(k[b>>2]&4095|0)==6:0)?k[a+136>>2]|0:0)break;k[hc>>2]=1;k[hc+4>>2]=cc;G1(b,2,hc,6)}while(0);k[lc>>2]=1124007936;va=lc+4|0;b=lc+8|0;ta=lc+40|0;Sb=va;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[ta>>2]=b;wa=lc+48|0;ua=lc+44|0;k[ua>>2]=wa;k[lc+52>>2]=0;k[wa>>2]=0;k[hc>>2]=dc;k[hc+4>>2]=dc;G1(lc,2,hc,6);m=k[mc+8>>2]|0;if((m|0)>0?(Ub=k[qc+40>>2]|0,Vb=Ub+4|0,Wb=qc+16|0,Xb=qc+44|0,Yb=qc+12|0,Zb=k[a+176>>2]|0,_b=k[a+188>>2]|0,$b=k[a+200>>2]|0,ac=mc+16|0,bc=k[mc+44>>2]|0,(dc|0)>0):0){l=0;do{do if((k[qc>>2]&16384|0)==0?(k[Ub>>2]|0)!=1:0){b=k[Wb>>2]|0;d=k[Xb>>2]|0;if((k[Vb>>2]|0)==1){b=b+(aa(k[d>>2]|0,l)|0)|0;break}else{Tb=k[Yb>>2]|0;Sb=(l|0)/(Tb|0)|0;Tb=l-(aa(Sb,Tb)|0)|0;b=b+(aa(k[d>>2]|0,Sb)|0)+(Tb<<2)|0;break}}else jc=32;while(0);if((jc|0)==32){jc=0;b=(k[Wb>>2]|0)+(l<<2)|0}d=k[b>>2]|0;e=k[Zb+(d*56|0)+16>>2]|0;f=k[_b+(d*56|0)+16>>2]|0;g=(k[ac>>2]|0)+(aa(k[bc>>2]|0,l)|0)|0;b=0;d=k[$b+(d*56|0)+16>>2]|0;while(1){h=+o[g+(b<<2)>>2];j=f+(b<<3)|0;p[j>>3]=+p[j>>3]+h;j=e+(b<<2)|0;k[j>>2]=(k[j>>2]|0)+1;j=d+(b<<3)|0;p[j>>3]=+p[j>>3]+h*h;b=b+1|0;j=(b|0)==(dc|0);if(j)break;else c=b;do{Tb=d+(c<<3)|0;p[Tb>>3]=+p[Tb>>3]+h*+o[g+(c<<2)>>2];c=c+1|0}while((c|0)!=(dc|0));if(j)break;else d=d+(dc<<3)|0}l=l+1|0}while((l|0)!=(m|0))}k[kc>>2]=1124007936;sa=kc+4|0;b=kc+8|0;qa=kc+40|0;Sb=sa;Tb=Sb+36|0;do{k[Sb>>2]=0;Sb=Sb+4|0}while((Sb|0)<(Tb|0));k[qa>>2]=b;ra=kc+48|0;pa=kc+44|0;k[pa>>2]=ra;k[kc+52>>2]=0;k[ra>>2]=0;if((cc|0)>0){A=a+224|0;B=a+176|0;C=a+212|0;D=a+188|0;E=a+200|0;F=hc+4|0;G=F+4|0;H=(dc|0)>0;I=lc+16|0;J=hc+4|0;K=J+4|0;L=hc+8|0;M=hc+12|0;N=hc+4|0;O=ec+4|0;P=O+4|0;Q=a+236|0;R=fc+4|0;S=R+4|0;T=hc+8|0;U=hc+12|0;V=hc+4|0;W=ec+4|0;X=W+4|0;Y=hc+8|0;Z=hc+12|0;$=hc+4|0;ba=ec+8|0;ca=ec+12|0;da=ec+4|0;ea=gc+4|0;fa=ea+4|0;ga=ec+8|0;ha=ec+12|0;ia=ec+4|0;ja=fc+4|0;ka=ja+4|0;la=a+120|0;ma=a+160|0;na=a+136|0;oa=a+164|0;z=a+132|0;y=0;do{w=k[A>>2]|0;x=w+(y*56|0)|0;e=k[(k[B>>2]|0)+(y*56|0)+16>>2]|0;f=k[(k[C>>2]|0)+(y*56|0)+16>>2]|0;g=k[(k[D>>2]|0)+(y*56|0)+16>>2]|0;a=(k[E>>2]|0)+(y*56|0)|0;bc=G;k[bc>>2]=0;k[bc+4>>2]=0;k[hc>>2]=50397184;k[F>>2]=a;S2(hc,0);if(H){d=0;do{b=k[e+(d<<2)>>2]|0;if(!b)h=0.0;else h=+p[g+(d<<3)>>3]/+(b|0);p[f+(d<<3)>>3]=h;d=d+1|0}while((d|0)!=(dc|0))}e=k[(k[B>>2]|0)+(y*56|0)+16>>2]|0;f=k[(k[C>>2]|0)+(y*56|0)+16>>2]|0;g=k[(k[D>>2]|0)+(y*56|0)+16>>2]|0;if(H){j=k[E>>2]|0;c=k[j+(y*56|0)+16>>2]|0;j=k[k[j+(y*56|0)+44>>2]>>2]|0;l=k[I>>2]|0;m=k[k[ua>>2]>>2]|0;d=0;v=1;while(1){n=c+(aa(j,d)|0)|0;q=l+(aa(m,d)|0)|0;s=+p[g+(d<<3)>>3];t=+p[f+(d<<3)>>3];a=k[e+(d<<2)>>2]|0;u=+(a|0);h=+(a+-1|0);if((a|0)>1){b=0;do{sc=+p[f+(b<<3)>>3];p[q+(b<<3)>>3]=(u*(t*sc)+(+p[n+(b<<3)>>3]-t*+p[g+(b<<3)>>3]-s*sc))/h;b=b+1|0}while((b|0)!=(v|0))}else{b=0;do{sc=+p[f+(b<<3)>>3];p[q+(b<<3)>>3]=u*(t*sc)+(+p[n+(b<<3)>>3]-t*+p[g+(b<<3)>>3]-s*sc);b=b+1|0}while((b|0)!=(v|0))}d=d+1|0;if((d|0)==(dc|0))break;else v=v+1|0}}a=K;k[a>>2]=0;k[a+4>>2]=0;k[hc>>2]=50397184;k[J>>2]=lc;S2(hc,1);k[L>>2]=0;k[M>>2]=0;k[hc>>2]=16842752;k[N>>2]=lc;a=P;k[a>>2]=0;k[a+4>>2]=0;k[ec>>2]=33619968;k[O>>2]=x;a=(k[Q>>2]|0)+(y*56|0)|0;bc=S;k[bc>>2]=0;k[bc+4>>2]=0;k[fc>>2]=33619968;k[R>>2]=a;DZ(hc,ec,fc,49332,0);a=(k[Q>>2]|0)+(y*56|0)|0;k[T>>2]=0;k[U>>2]=0;k[hc>>2]=16842752;k[V>>2]=a;bc=X;k[bc>>2]=0;k[bc+4>>2]=0;k[ec>>2]=33619968;k[W>>2]=a;$1(hc,ec);k[Y>>2]=0;k[Z>>2]=0;k[hc>>2]=16842752;k[$>>2]=x;p[fc>>3]=1.1920928955078125e-07;k[ec>>2]=-1056833530;k[da>>2]=fc;k[ba>>2]=1;k[ca>>2]=1;a=fa;k[a>>2]=0;k[a+4>>2]=0;k[gc>>2]=33619968;k[ea>>2]=x;aU(hc,ec,gc,49332,39872,0,14);b:do if(H){c=w+(y*56|0)+16|0;j=w+(y*56|0)+44|0;l=w+(y*56|0)+12|0;if(k[x>>2]&16384|0){d=k[c>>2]|0;h=1.0;b=0;while(1){h=h*+p[d+(b<<3)>>3];b=b+1|0;if((b|0)==(dc|0))break b}}g=k[w+(y*56|0)+40>>2]|0;f=(k[g>>2]|0)==1;g=g+4|0;h=1.0;e=0;do{do if(!f){b=k[c>>2]|0;d=k[j>>2]|0;if((k[g>>2]|0)==1){b=b+(aa(k[d>>2]|0,e)|0)|0;break}else{a=k[l>>2]|0;bc=(e|0)/(a|0)|0;a=e-(aa(bc,a)|0)|0;b=b+(aa(k[d>>2]|0,bc)|0)+(a<<3)|0;break}}else b=(k[c>>2]|0)+(e<<3)|0;while(0);h=h*+p[b>>3];e=e+1|0}while((e|0)!=(dc|0))}else h=1.0;while(0);k[ga>>2]=0;k[ha>>2]=0;k[ec>>2]=16842752;k[ia>>2]=x;a=ka;k[a>>2]=0;k[a+4>>2]=0;k[fc>>2]=33619968;k[ja>>2]=x;p[hc>>3]=1.0;sU(ec,ec,fc,49332,-1,40096,1,hc);if(h>0.0)h=+_(+h);else h=-700.0;do if((k[la>>2]&16384|0)==0?(ic=k[ma>>2]|0,(k[ic>>2]|0)!=1):0){b=k[na>>2]|0;d=k[oa>>2]|0;if((k[ic+4>>2]|0)==1){b=b+(aa(k[d>>2]|0,y)|0)|0;break}else{a=k[z>>2]|0;bc=(y|0)/(a|0)|0;a=y-(aa(bc,a)|0)|0;b=b+(aa(k[d>>2]|0,bc)|0)+(a<<3)|0;break}}else jc=66;while(0);if((jc|0)==66){jc=0;b=(k[na>>2]|0)+(y<<3)|0}p[b>>3]=h;y=y+1|0}while((y|0)<(cc|0));b=kc+36|0;d=k[b>>2]|0;if((d|0)!=0?(ic=d+12|0,jc=k[ic>>2]|0,k[ic>>2]=jc+-1,(jc|0)==1):0){e=k[b>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[kc+32>>2]|0;if(!d){d=B1()|0;e=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[b>>2]=0}}else b=kc+36|0;k[b>>2]=0;kc=kc+16|0;k[kc>>2]=0;k[kc+4>>2]=0;k[kc+8>>2]=0;k[kc+12>>2]=0;if((k[sa>>2]|0)>0){d=k[qa>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[sa>>2]|0))}b=k[pa>>2]|0;if(!((b|0)==(ra|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=lc+36|0;b=k[e>>2]|0;if(b|0?(jc=b+12|0,kc=k[jc>>2]|0,k[jc>>2]=kc+-1,(kc|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[lc+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;lc=lc+16|0;k[lc>>2]=0;k[lc+4>>2]=0;k[lc+8>>2]=0;k[lc+12>>2]=0;if((k[va>>2]|0)>0){d=k[ta>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[va>>2]|0))}b=k[ua>>2]|0;if(!((b|0)==(wa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=mc+36|0;b=k[e>>2]|0;if(b|0?(kc=b+12|0,lc=k[kc>>2]|0,k[kc>>2]=lc+-1,(lc|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[mc+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;lc=mc+16|0;d=mc+4|0;k[lc>>2]=0;k[lc+4>>2]=0;k[lc+8>>2]=0;k[lc+12>>2]=0;if((k[d>>2]|0)>0){e=k[mc+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[mc+44>>2]|0;if(!((b|0)==(mc+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=nc+36|0;b=k[e>>2]|0;if(b|0?(lc=b+12|0,mc=k[lc>>2]|0,k[lc>>2]=mc+-1,(mc|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[nc+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;mc=nc+16|0;d=nc+4|0;k[mc>>2]=0;k[mc+4>>2]=0;k[mc+8>>2]=0;k[mc+12>>2]=0;if((k[d>>2]|0)>0){e=k[nc+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[nc+44>>2]|0;if(!((b|0)==(nc+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=pc+36|0;b=k[e>>2]|0;if(b|0?(mc=b+12|0,nc=k[mc>>2]|0,k[mc>>2]=nc+-1,(nc|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[pc+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;nc=pc+16|0;k[nc>>2]=0;k[nc+4>>2]=0;k[nc+8>>2]=0;k[nc+12>>2]=0;if((k[oc>>2]|0)>0){d=k[pc+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[oc>>2]|0))}b=k[pc+44>>2]|0;if(!((b|0)==(pc+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=qc+36|0;b=k[e>>2]|0;do if(b|0){oc=b+12|0;pc=k[oc>>2]|0;k[oc>>2]=pc+-1;if((pc|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[qc+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;pc=qc+16|0;d=qc+4|0;k[pc>>2]=0;k[pc+4>>2]=0;k[pc+8>>2]=0;k[pc+12>>2]=0;if((k[d>>2]|0)>0){e=k[qc+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[qc+44>>2]|0;if((b|0)==(qc+48|0)|(b|0)==0){r=rc;return 1}ggb(k[b+-4>>2]|0);r=rc;return 1}function iEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+hi[k[(k[a>>2]|0)+60>>2]&15](a,b,c,49332,d))}function jEa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;K=r;r=r+288|0;A=K+272|0;J=K+216|0;I=K+160|0;D=K+104|0;B=K+48|0;z=K;k[A>>2]=0;do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[J>>2]=k[h>>2];n=J+4|0;b=h+4|0;k[n>>2]=k[b>>2];o=J+8|0;k[o>>2]=k[h+8>>2];k[J+12>>2]=k[h+12>>2];k[J+16>>2]=k[h+16>>2];k[J+20>>2]=k[h+20>>2];k[J+24>>2]=k[h+24>>2];k[J+28>>2]=k[h+28>>2];k[J+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[J+36>>2]=f;g=J+40|0;k[g>>2]=o;H=J+48|0;l=J+44|0;k[l>>2]=H;k[J+52>>2]=0;k[H>>2]=0;if(f|0){H=f+12|0;k[H>>2]=(k[H>>2]|0)+1}if((k[b>>2]|0)<3){G=k[h+44>>2]|0;H=k[l>>2]|0;k[H>>2]=k[G>>2];k[H+4>>2]=k[G+4>>2];break}k[n>>2]=0;x1(J,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;b=0;do{k[j+(b<<2)>>2]=k[m+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else{Q1(J,b,-1);o=J+8|0}while(0);k[I>>2]=1124007936;G=I+4|0;b=I+8|0;E=I+40|0;h=G;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[E>>2]=b;H=I+48|0;F=I+44|0;k[F>>2]=H;k[I+52>>2]=0;k[H>>2]=0;k[D>>2]=1124007936;w=D+4|0;u=D+8|0;v=D+40|0;h=w;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[v>>2]=u;y=D+48|0;x=D+44|0;k[x>>2]=y;k[D+52>>2]=0;k[y>>2]=0;s=k[o>>2]|0;t=a+64|0;g=k[a+68>>2]|0;if((g|0)<3)q=aa(k[a+76>>2]|0,k[a+72>>2]|0)|0;else{h=k[a+104>>2]|0;f=0;b=1;do{b=aa(k[h+(f<<2)>>2]|0,b)|0;f=f+1|0}while((f|0)!=(g|0));q=b}e=e&1;if((k[J>>2]&4095|0)==5?(k[J+12>>2]|0)==(k[a+4>>2]|0):0)b=s;else{k[B>>2]=0;b=B+4|0;k[b>>2]=0;f=ZT(80)|0;k[f>>2]=1;h=f+4|0;k[B>>2]=h;k[b>>2]=74;i[f+78>>0]=0;g=367248;j=h+74|0;do{i[h>>0]=i[g>>0]|0;h=h+1|0;g=g+1|0}while((h|0)<(j|0));Y8(-5,B,367323,367335,314);k[b>>2]=0;k[B>>2]=0;n=k[f>>2]|0;k[f>>2]=n+-1;if((n|0)==1)ggb(k[f+-4>>2]|0);b=k[o>>2]|0}if((b|0)>1?(k[c>>2]&2031616|0)==0:0){k[B>>2]=0;b=B+4|0;k[b>>2]=0;f=ZT(88)|0;k[f>>2]=1;h=f+4|0;k[B>>2]=h;k[b>>2]=83;i[f+87>>0]=0;g=367398;j=h+83|0;do{i[h>>0]=i[g>>0]|0;h=h+1|0;g=g+1|0}while((h|0)<(j|0));Y8(-27,B,367323,367335,318);k[b>>2]=0;k[B>>2]=0;o=k[f>>2]|0;k[f>>2]=o+-1;if((o|0)==1)ggb(k[f+-4>>2]|0)}if(!(k[c>>2]&2031616)){l=B+4|0;k[l>>2]=2;n=B+8|0;k[n>>2]=1;k[B+12>>2]=1;g=B+16|0;k[g>>2]=A;k[B+20>>2]=A;j=B+24|0;h=B+40|0;m=j+8|0;k[m>>2]=0;k[m+4>>2]=0;k[h>>2]=n;n=B+48|0;m=B+44|0;k[m>>2]=n;k[B>>2]=1124024324;k[n>>2]=4;k[B+52>>2]=4;b=A+4|0;k[B+28>>2]=b;k[j>>2]=b;KG(I,B)|0;j=B+36|0;b=k[j>>2]|0;if(b|0?(o=b+12|0,c=k[o>>2]|0,k[o>>2]=c+-1,(c|0)==1):0){f=k[j>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[B+32>>2]|0;if(!b){b=B1()|0;f=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[j>>2]=0}k[j>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[l>>2]|0)>0){f=k[h>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[m>>2]|0;if(!((b|0)==(n|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{c2(c,s,1,4,-1,0,0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[B>>2]=k[h>>2];n=B+4|0;b=h+4|0;k[n>>2]=k[b>>2];c=B+8|0;k[c>>2]=k[h+8>>2];k[B+12>>2]=k[h+12>>2];k[B+16>>2]=k[h+16>>2];k[B+20>>2]=k[h+20>>2];k[B+24>>2]=k[h+24>>2];k[B+28>>2]=k[h+28>>2];k[B+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[B+36>>2]=f;g=B+40|0;k[g>>2]=c;c=B+48|0;l=B+44|0;k[l>>2]=c;k[B+52>>2]=0;k[c>>2]=0;if(f|0){c=f+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[b>>2]|0)<3){o=k[h+44>>2]|0;c=k[l>>2]|0;k[c>>2]=k[o>>2];k[c+4>>2]=k[o+4>>2];break}k[n>>2]=0;x1(B,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;b=0;do{k[j+(b<<2)>>2]=k[m+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else Q1(B,c,-1);while(0);KG(I,B)|0;g=B+36|0;b=k[g>>2]|0;if(b|0?(o=b+12|0,c=k[o>>2]|0,k[o>>2]=c+-1,(c|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[B+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;c=B+16|0;f=B+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[f>>2]|0)>0){g=k[B+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[B+44>>2]|0;if(!((b|0)==(B+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if(k[d>>2]&2031616|0){c2(d,s,q,5,-1,0,0);do if((k[d>>2]&2031616|0)==65536){h=k[d+4>>2]|0;k[B>>2]=k[h>>2];n=B+4|0;b=h+4|0;k[n>>2]=k[b>>2];d=B+8|0;k[d>>2]=k[h+8>>2];k[B+12>>2]=k[h+12>>2];k[B+16>>2]=k[h+16>>2];k[B+20>>2]=k[h+20>>2];k[B+24>>2]=k[h+24>>2];k[B+28>>2]=k[h+28>>2];k[B+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[B+36>>2]=f;g=B+40|0;k[g>>2]=d;d=B+48|0;l=B+44|0;k[l>>2]=d;k[B+52>>2]=0;k[d>>2]=0;if(f|0){d=f+12|0;k[d>>2]=(k[d>>2]|0)+1}if((k[b>>2]|0)<3){q=k[h+44>>2]|0;d=k[l>>2]|0;k[d>>2]=k[q>>2];k[d+4>>2]=k[q+4>>2];break}k[n>>2]=0;x1(B,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;b=0;do{k[j+(b<<2)>>2]=k[m+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else Q1(B,d,-1);while(0);KG(D,B)|0;g=B+36|0;b=k[g>>2]|0;if(b|0?(q=b+12|0,d=k[q>>2]|0,k[q>>2]=d+-1,(d|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[B+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;d=B+16|0;f=B+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[f>>2]|0)>0){g=k[B+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[B+44>>2]|0;if(!((b|0)==(B+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}k[B>>2]=0;k[B+4>>2]=s;k[z>>2]=92084;k[z+4>>2]=a+120;k[z+8>>2]=a+236;k[z+12>>2]=a+224;k[z+16>>2]=a+212;k[z+20>>2]=J;k[z+24>>2]=a+8;k[z+28>>2]=t;k[z+36>>2]=I;j=D+16|0;if(k[j>>2]|0){h=k[w>>2]|0;if((h|0)<3)b=aa(k[D+12>>2]|0,k[u>>2]|0)|0;else{g=k[v>>2]|0;f=0;b=1;do{b=aa(k[g+(f<<2)>>2]|0,b)|0;f=f+1|0}while((f|0)!=(h|0))}if(b)b=D;else C=92}else C=92;if((C|0)==92)b=0;k[z+32>>2]=b;i[z+44>>0]=e;lEa(z,B);p=+(k[A>>2]|0);g=D+36|0;b=k[g>>2]|0;if(b|0?(B=b+12|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[D+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[w>>2]|0)>0){f=k[v>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[w>>2]|0))}b=k[x>>2]|0;if(!((b|0)==(y|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=I+36|0;b=k[g>>2]|0;if(b|0?(C=b+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[I+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;I=I+16|0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[G>>2]|0)>0){f=k[E>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[G>>2]|0))}b=k[F>>2]|0;if(!((b|0)==(H|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=J+36|0;b=k[g>>2]|0;if(b|0?(H=b+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[J+32>>2]|0;if(b|0)break;b=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;I=J+16|0;f=J+4|0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[f>>2]|0)>0){g=k[J+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[J+44>>2]|0;if((b|0)==(J+48|0)|(b|0)==0){r=K;return +p}ggb(k[b+-4>>2]|0);r=K;return +p}function kEa(a){a=a|0;ggb(a);return}function lEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0;pa=r;r=r+1264|0;fa=pa+1240|0;oa=pa;na=pa+1184|0;ma=pa+1128|0;ia=pa+1112|0;ja=pa+1096|0;ka=a+28|0;c=k[ka>>2]|0;f=k[c+4>>2]|0;if((f|0)<3)ba=aa(k[c+12>>2]|0,k[c+8>>2]|0)|0;else{e=k[c+40>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0));ba=c}ca=a+16|0;ea=k[ca>>2]|0;c=k[ea>>2]|0;if((k[ea+4>>2]|0)==(c|0))ad(426635,426557,315,426658);$=k[c+12>>2]|0;c=k[a+24>>2]|0;if((c|0)!=0?(g=k[c+16>>2]|0,(g|0)!=0):0){f=k[c+4>>2]|0;if((f|0)<3)c=aa(k[c+12>>2]|0,k[c+8>>2]|0)|0;else{e=k[c+40>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0))}T=(c|0)==0?0:g}else T=0;U=a+36|0;e=k[U>>2]|0;if(e){ea=k[e>>2]|0;d=ea&4095;if(!(ea&16384)){c=k[e+4>>2]|0;if((c|0)>0)c=k[(k[e+44>>2]|0)+(c+-1<<2)>>2]|0;else c=0;O=((k[e+48>>2]|0)>>>0)/(c>>>0)|0}else O=1}else{d=0;O=0}R=a+32|0;f=k[R>>2]|0;if(f){ea=k[f>>2]|0;e=ea&4095;if(!(ea&16384)){c=k[f+4>>2]|0;if((c|0)>0)c=k[(k[f+44>>2]|0)+(c+-1<<2)>>2]|0;else c=0;L=((k[f+48>>2]|0)>>>0)/(c>>>0)|0}else L=1}else{e=0;L=0}g=$<<1;da=oa+8|0;k[oa>>2]=da;ea=oa+4|0;k[ea>>2]=136;if(g>>>0>136){f=g>>>0>536870911?-1:g<<3;f=(f|0)==0?1:f;while(1){c=fgb(f)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[oa>>2]=c}else c=da;k[ea>>2]=g;K=c+($<<3)|0;X=na+4|0;k[X>>2]=2;_=na+8|0;k[_>>2]=1;k[na+12>>2]=$;V=na+16|0;k[V>>2]=c;k[na+20>>2]=c;P=na+24|0;W=na+40|0;Y=P+8|0;k[Y>>2]=0;k[Y+4>>2]=0;k[W>>2]=_;_=na+48|0;Y=na+44|0;k[Y>>2]=_;q=$<<3;k[na>>2]=1124024326;k[_>>2]=q;k[na+52>>2]=8;f=c+($<<3)|0;k[na+28>>2]=f;k[P>>2]=f+(0-q)+q;k[ma>>2]=1124007942;P=ma+4|0;k[P>>2]=2;q=ma+8|0;k[q>>2]=1;f=ma+12|0;k[f>>2]=$;M=ma+16|0;k[M>>2]=K;n=ma+20|0;k[n>>2]=K;s=ma+24|0;t=ma+28|0;N=ma+40|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[N>>2]=q;S=ma+48|0;Q=ma+44|0;k[Q>>2]=S;k[ma+52>>2]=0;k[S>>2]=0;if(($|0)!=0&(K|0)==0){k[fa>>2]=0;g=fa+4|0;k[g>>2]=0;h=ZT(36)|0;k[h>>2]=1;j=h+4|0;k[fa>>2]=j;k[g>>2]=28;i[h+32>>0]=0;l=390609;m=j+28|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,fa,390638,390642,410);k[g>>2]=0;k[fa>>2]=0;J=k[h>>2]|0;k[h>>2]=J+-1;if((J|0)==1)ggb(k[h+-4>>2]|0);g=k[f>>2]|0;h=k[ma>>2]|0;j=k[Q>>2]|0;f=k[n>>2]|0}else{g=$;h=1124007942;j=S;f=K}H=g<<3;k[ma>>2]=h|16384;k[j>>2]=H;k[j+4>>2]=8;f=f+(aa(k[q>>2]|0,H)|0)|0;k[t>>2]=f;k[s>>2]=f+(0-H)+H;f=k[b>>2]|0;H=b+4|0;a:do if((f|0)<(k[H>>2]|0)){I=(ba|0)>0;J=a+44|0;D=(d|0)==4;E=a+4|0;F=a+8|0;G=a+12|0;s=a+20|0;t=($|0)>0;b=(T|0)==0;a=fa+8|0;w=fa+12|0;x=fa+4|0;y=ia+8|0;z=ia+12|0;A=ia+4|0;B=ja+4|0;C=B+4|0;q=(e|0)==5;d=-1;b:while(1){if(I){n=aa(f,L)|0;m=0;v=3402823466385288598117041.0e14;while(1){e=k[E>>2]|0;do if((k[e>>2]&16384|0)==0?(ga=k[e+40>>2]|0,(k[ga>>2]|0)!=1):0){g=k[e+16>>2]|0;h=k[e+44>>2]|0;if((k[ga+4>>2]|0)==1){e=g+(aa(k[h>>2]|0,m)|0)|0;break}else{e=k[e+12>>2]|0;l=(m|0)/(e|0)|0;e=m-(aa(l,e)|0)|0;e=g+(aa(k[h>>2]|0,l)|0)+(e<<3)|0;break}}else la=54;while(0);if((la|0)==54){la=0;e=(k[e+16>>2]|0)+(m<<3)|0}u=+p[e>>3];l=k[F>>2]|0;e=k[l>>2]|0;if((((k[l+4>>2]|0)-e|0)/56|0)>>>0<=m>>>0){la=59;break b}l=e+(m*56|0)|0;j=k[G>>2]|0;e=k[j>>2]|0;if((((k[j+4>>2]|0)-e|0)/56|0)>>>0<=m>>>0){la=61;break b}j=k[ca>>2]|0;g=k[j>>2]|0;if((((k[j+4>>2]|0)-g|0)/56|0)>>>0<=m>>>0){la=63;break b}h=k[g+(m*56|0)+16>>2]|0;j=k[s>>2]|0;j=(k[j+16>>2]|0)+(aa(k[k[j+44>>2]>>2]|0,f)|0)|0;if(t)if(b){g=0;do{p[c+(g<<3)>>3]=+p[h+(g<<3)>>3]-+o[j+(g<<2)>>2];g=g+1|0}while((g|0)!=($|0))}else{g=0;do{p[c+(g<<3)>>3]=+p[h+(g<<3)>>3]-+o[j+(k[T+(g<<2)>>2]<<2)>>2];g=g+1|0}while((g|0)!=($|0))}k[a>>2]=0;k[w>>2]=0;k[fa>>2]=16842752;k[x>>2]=na;k[y>>2]=0;k[z>>2]=0;k[ia>>2]=16842752;k[A>>2]=l;l=C;k[l>>2]=0;k[l+4>>2]=0;k[ja>>2]=33619968;k[B>>2]=ma;s_(fa,ia,1.0,49332,0.0,ja,2);if(t){g=k[e+(m*56|0)+16>>2]|0;e=0;do{qa=+p[K+(e<<3)>>3];u=u+qa*qa*+p[g+(e<<3)>>3];e=e+1|0}while((e|0)!=($|0))}e=u<v;v=e?u:v;d=e?m:d;u=+Z(+(u*-.5));e=k[R>>2]|0;do if(e|0)if(q){o[(k[e+16>>2]|0)+(m+n<<2)>>2]=u;break}else{p[(k[e+16>>2]|0)+(m+n<<3)>>3]=u;break}while(0);m=m+1|0;if((m|0)>=(ba|0)){h=d;break}}}else h=d;if(!(i[J>>0]|0)){d=k[ka>>2]|0;do if((k[d>>2]&16384|0)==0?(ha=k[d+40>>2]|0,(k[ha>>2]|0)!=1):0){e=k[d+16>>2]|0;g=k[d+44>>2]|0;if((k[ha+4>>2]|0)==1){d=e+(aa(k[g>>2]|0,h)|0)|0;break}else{d=k[d+12>>2]|0;n=(h|0)/(d|0)|0;d=h-(aa(n,d)|0)|0;d=e+(aa(k[g>>2]|0,n)|0)+(d<<2)|0;break}}else la=78;while(0);if((la|0)==78){la=0;d=(k[d+16>>2]|0)+(h<<2)|0}e=k[d>>2]|0}else e=h;d=k[U>>2]|0;do if(d|0)if(D){n=aa(f,O)|0;k[(k[d+16>>2]|0)+(n<<2)>>2]=e;break}else{n=aa(f,O)|0;o[(k[d+16>>2]|0)+(n<<2)>>2]=+(e|0);break}while(0);f=f+1|0;if((f|0)>=(k[H>>2]|0))break a;else d=h}if((la|0)==59)ad(426635,426557,315,426658);else if((la|0)==61)ad(426635,426557,315,426658);else if((la|0)==63)ad(426635,426557,315,426658)}while(0);e=ma+36|0;c=k[e>>2]|0;if(c|0?(ka=c+12|0,la=k[ka>>2]|0,k[ka>>2]=la+-1,(la|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[ma+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[P>>2]|0)>0){d=k[N>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[P>>2]|0))}c=k[Q>>2]|0;if(!((c|0)==(S|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=na+36|0;c=k[e>>2]|0;if(c|0?(la=c+12|0,ma=k[la>>2]|0,k[la>>2]=ma+-1,(ma|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[na+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[X>>2]|0)>0){d=k[W>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[X>>2]|0))}c=k[Y>>2]|0;if(!((c|0)==(_|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[oa>>2]|0;if((c|0)==(da|0)){r=pa;return}if(c|0)ggb(c);k[oa>>2]=da;k[ea>>2]=136;r=pa;return}function mEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function nEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;e=h;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=h;return}f=a+32|0;if((k[f>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[e>>2]=g;k[c>>2]=30;i[d+34>>0]=0;j=401220;l=g+30|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}D6(a,a+12|0,b);if(!(k[f>>2]&4)){r=h;return}k[f>>2]=6;r=h;return}function oEa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+64|0;l=m;while(1){b=fgb(328)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=92104;c=b+8|0;k[c>>2]=92848;d=b+12|0;uHa(d);k[b+240>>2]=0;k[b+244>>2]=0;zpb(b+92|0,0,144)|0;k[c>>2]=92308;i[b+248>>0]=0;c=b+252|0;k[c>>2]=0;k[c+4>>2]=0;k[b+256>>2]=3;k[b+260>>2]=50;p[b+264>>3]=.1;c=b+320|0;e=b+280|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));j=c;k[j>>2]=-1;k[j+4>>2]=0;k[b+76>>2]=5;k[b+80>>2]=10;o[b+88>>2]=0.0;i[d>>0]=0;k[b+72>>2]=10;k[b+84>>2]=0;i[b+13>>0]=0;i[b+14>>0]=0;k[l>>2]=1124007936;j=l+4|0;c=l+8|0;g=l+40|0;e=j;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[g>>2]=c;h=l+48|0;f=l+44|0;k[f>>2]=h;k[l+52>>2]=0;k[h>>2]=0;KG(b+16|0,l)|0;e=l+36|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[l+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[j>>2]|0)>0){d=k[g>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[j>>2]|0))}c=k[f>>2]|0;if(!((c|0)==(h|0)|(c|0)==0))ggb(k[c+-4>>2]|0);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=92288;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;if(!c){r=m;return}k[d>>2]=(k[d>>2]|0)+1;if(!c){r=m;return}l=c+4|0;a=k[l>>2]|0;k[l>>2]=a+-1;if((a|0)!=1){r=m;return}Uh[k[(k[c>>2]|0)+8>>2]&2047](c);r=m;return}function pEa(a){a=a|0;ggb(a);return}function qEa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function rEa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=92308;b=k[a+296>>2]|0;c=b;if(b|0){d=a+300|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+284>>2]|0;c=b;if(b|0){d=a+288|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+272>>2]|0;if(!b){LGa(a);return}c=a+276|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);ggb(b);LGa(a);return}function sEa(a){a=a|0;rEa(a);ggb(a);return}function tEa(a){a=a|0;NGa(a);p[a+264>>3]=0.0;a=a+312|0;k[a>>2]=-1;k[a+4>>2]=-1;return}function uEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0;s=r;r=r+16|0;q=s+8|0;n=s;o=a+144|0;m=a+148|0;if((k[o>>2]|0)==(k[m>>2]|0)){d=q+4|0;c=ZT(36)|0;k[c>>2]=1;h=c+4|0;k[q>>2]=h;k[d>>2]=28;i[c+32>>0]=0;j=368107;l=h+28|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,q,370627,368044,297);k[d>>2]=0;k[q>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)==1)ggb(k[c+-4>>2]|0)}jh[k[(k[a>>2]|0)+228>>2]&1023](a,b);k[q>>2]=0;d=q+4|0;k[d>>2]=0;j=ZT(16)|0;k[j>>2]=1;h=j+4|0;k[q>>2]=h;k[d>>2]=9;i[j+13>>0]=0;j=367979;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));g=z6(b,q)|0;c=k[q>>2]|0;k[d>>2]=0;k[q>>2]=0;if(c|0?(j=c+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[c+-8>>2]|0);e=a+264|0;if(Xh[k[(k[g>>2]|0)+12>>2]&1023](g)|0){f=g+32|0;if((k[f>>2]|0)==6){c=q+4|0;d=ZT(36)|0;k[d>>2]=1;h=d+4|0;k[q>>2]=h;k[c>>2]=30;i[d+34>>0]=0;j=401220;l=h+30|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-2,q,401251,401262,1064);k[c>>2]=0;k[q>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[g+16>>2]|0))c=0;else{c=k[g+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[g+8>>2]|0,c,+p[e>>3]);if(k[f>>2]&4|0)k[f>>2]=6}f=a+272|0;if((k[f>>2]|0)!=(k[a+276>>2]|0)){k[q>>2]=0;d=q+4|0;k[d>>2]=0;j=ZT(20)|0;k[j>>2]=1;h=j+4|0;k[q>>2]=h;k[d>>2]=14;i[j+18>>0]=0;j=367996;l=h+14|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));g=z6(b,q)|0;c=k[q>>2]|0;k[d>>2]=0;k[q>>2]=0;if(c|0?(j=c+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[c+-8>>2]|0);if(Xh[k[(k[g>>2]|0)+12>>2]&1023](g)|0){c=g+32|0;if((k[c>>2]|0)==6){d=q+4|0;e=ZT(36)|0;k[e>>2]=1;h=e+4|0;k[q>>2]=h;k[d>>2]=30;i[e+34>>0]=0;j=401220;l=h+30|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-2,q,401251,401262,1064);k[d>>2]=0;k[q>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}E6(q,g,k[g+12>>2]|0,k[g+16>>2]|0,13,0,0);GEa(g,f);F6(q);if(k[c>>2]&4|0)k[c>>2]=6}}e=(k[m>>2]|0)-(k[o>>2]|0)|0;g=e>>2;k[n>>2]=g;k[q>>2]=0;m=q+4|0;k[m>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[q>>2]=c;k[m>>2]=6;i[d+10>>0]=0;i[c>>0]=i[367989]|0;i[c+1>>0]=i[367990]|0;i[c+2>>0]=i[367991]|0;i[c+3>>0]=i[367992]|0;i[c+4>>0]=i[367993]|0;i[c+5>>0]=i[367994]|0;c=z6(b,q)|0;d=k[q>>2]|0;k[m>>2]=0;k[q>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);c=DEa(c,n)|0;k[q>>2]=0;n=q+4|0;k[n>>2]=0;m=ZT(12)|0;k[m>>2]=1;d=m+4|0;k[q>>2]=d;k[n>>2]=5;i[m+9>>0]=0;i[d>>0]=i[380533]|0;i[d+1>>0]=i[380534]|0;i[d+2>>0]=i[380535]|0;i[d+3>>0]=i[380536]|0;i[d+4>>0]=i[380537]|0;c=z6(c,q)|0;d=k[q>>2]|0;k[n>>2]=0;k[q>>2]=0;if(d|0?(m=d+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[d+-8>>2]|0);k[q>>2]=0;n=q+4|0;k[n>>2]=0;l=ZT(8)|0;k[l>>2]=1;m=l+4|0;k[q>>2]=m;k[n>>2]=1;i[l+5>>0]=0;i[m>>0]=91;z6(c,q)|0;c=k[q>>2]|0;k[n>>2]=0;k[q>>2]=0;if(c|0?(m=c+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[c+-8>>2]|0);if((e|0)>0){e=q+4|0;f=q+4|0;d=0;do{k[q>>2]=0;k[e>>2]=0;n=ZT(8)|0;k[n>>2]=1;c=n+4|0;k[q>>2]=c;k[e>>2]=1;i[n+5>>0]=0;i[c>>0]=123;z6(b,q)|0;c=k[q>>2]|0;k[e>>2]=0;k[q>>2]=0;if(c|0?(m=c+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[c+-8>>2]|0);Ph[k[(k[a>>2]|0)+240>>2]&511](a,b,k[(k[o>>2]|0)+(d<<2)>>2]|0);k[q>>2]=0;k[f>>2]=0;n=ZT(8)|0;k[n>>2]=1;c=n+4|0;k[q>>2]=c;k[f>>2]=1;i[n+5>>0]=0;i[c>>0]=125;z6(b,q)|0;c=k[q>>2]|0;k[f>>2]=0;k[q>>2]=0;if(c|0?(m=c+-4|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[c+-8>>2]|0);d=d+1|0}while((d|0)<(g|0))}o=q+4|0;a=ZT(8)|0;k[a>>2]=1;c=a+4|0;k[q>>2]=c;k[o>>2]=1;i[a+5>>0]=0;i[c>>0]=93;z6(b,q)|0;c=k[q>>2]|0;k[o>>2]=0;k[q>>2]=0;if(!c){r=s;return}o=c+-4|0;q=k[o>>2]|0;k[o>>2]=q+-1;if((q|0)!=1){r=s;return}ggb(k[c+-8>>2]|0);r=s;return}function vEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+112|0;y=A+56|0;z=A;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);t=b+4|0;c=k6(k[b>>2]|0,k[t>>2]|0,367979)|0;a:do if(!c)e=0.0;else switch(k[c>>2]&7){case 1:{e=+(k[c+8>>2]|0);break a}case 2:{e=+p[c+8>>3];break a}default:{e=1.e+300;break a}}while(0);p[a+264>>3]=e;c=k6(k[b>>2]|0,k[t>>2]|0,367989)|0;b:do if(!c)x=0;else{switch(k[c>>2]&7){case 1:{x=k[c+8>>2]|0;break b}case 2:break;default:{x=2147483647;break b}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;x=c&2146435072;if(!(x>>>0>1126170624|(x|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}x=~~e}while(0);d=k[b>>2]|0;f=k6(d,k[t>>2]|0,367996)|0;m=a+272|0;do if(f|0){if((k[f>>2]&7|0)!=6){c=k[f>>2]|0;if((c&7|0)!=5)break;do if(!d){k[z>>2]=0;k[z+4>>2]=0;k[z+20>>2]=0;k[z+40>>2]=0}else{k[z>>2]=d;k[z+4>>2]=f;if(c&16|0){k[z+20>>2]=f;k[z+12>>2]=0;k[z+40>>2]=1;break}d=f+8|0;KY(k[d>>2]|0,z+8|0);c=k[f>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[z+40>>2]=c}while(0);k[y>>2]=z;EEa(y,m);break}k[z>>2]=1124007936;q=z+4|0;c=z+8|0;n=z+40|0;g=q;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[n>>2]=c;s=z+48|0;o=z+44|0;k[o>>2]=s;k[z+52>>2]=0;k[s>>2]=0;k[y>>2]=1124007936;l=y+4|0;c=y+8|0;j=y+40|0;g=l;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[j>>2]=c;h=y+48|0;g=y+44|0;k[g>>2]=h;k[y+52>>2]=0;k[h>>2]=0;G6(d,f,z,y);f=y+36|0;c=k[f>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;f=y+16|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[l>>2]|0)>0){d=k[j>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[l>>2]|0))}c=k[g>>2]|0;if(!((c|0)==(h|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=y+4|0;c=f+4|0;k[c>>2]=0;k[c+4>>2]=0;k[y>>2]=-2113732603;k[f>>2]=m;mY(z,y);f=z+36|0;c=k[f>>2]|0;if(c|0?(l=c+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[z+32>>2]|0;if(!c){c=B1()|0;d=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;m=z+16|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[q>>2]|0)>0){d=k[n>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[q>>2]|0))}c=k[o>>2]|0;if(!((c|0)==(s|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}while(0);jh[k[(k[a>>2]|0)+244>>2]&1023](a,b);c=k[b>>2]|0;f=k6(c,k[t>>2]|0,380533)|0;do if((c|0)!=0&(f|0)!=0?(v=k[f>>2]|0,w=v&7,(w|0)!=0):0){k[y>>2]=c;k[y+4>>2]=f;if(!((w+-5|0)>>>0<2&(v&16|0)==0)){k[y+20>>2]=f;k[y+12>>2]=0;k[y+40>>2]=1;d=62;break}c=f+8|0;KY(k[c>>2]|0,y+8|0);d=k[f>>2]|0;switch(d&7){case 6:{c=k[(k[c>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[c>>2]|0)+24>>2]|0;break}default:c=(d&7|0)!=0&1}k[y+40>>2]=c;d=62}else d=61;while(0);if((d|0)==61){k[y>>2]=0;k[y+4>>2]=0;k[y+20>>2]=0;k[y+40>>2]=0;if(!f){c=1;d=66}else d=62}c:do if((d|0)==62){c=k[f>>2]|0;switch(c&7){case 6:{c=k[(k[f+8>>2]|0)+60>>2]|0;break c}case 5:{c=k[(k[f+8>>2]|0)+24>>2]|0;break c}default:{c=(c&7|0)==0;d=66;break c}}}while(0);if((d|0)==66)c=c&1^1;if((x|0)!=(c|0)){c=z+4|0;d=ZT(40)|0;k[d>>2]=1;g=d+4|0;k[z>>2]=g;k[c>>2]=32;i[d+36>>0]=0;f=368011;h=g+32|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,z,401059,368044,343);k[c>>2]=0;k[z>>2]=0;w=k[d>>2]|0;k[d>>2]=w+-1;if((w|0)==1)ggb(k[d+-4>>2]|0)}if((x|0)<=0){r=A;return}d=y+20|0;f=z+4|0;g=y+40|0;h=y+12|0;j=y+28|0;l=y+16|0;m=y+24|0;c=0;do{w=k[y>>2]|0;n=k6(w,k[d>>2]|0,371485)|0;k[z>>2]=w;k[f>>2]=n;Hh[k[(k[a>>2]|0)+256>>2]&511](a,z)|0;c=c+1|0;n=k[g>>2]|0;if(n|0){o=k[h>>2]|0;if(o|0?(w=(k[d>>2]|0)+(k[o+28>>2]|0)|0,k[d>>2]=w,w>>>0>=(k[j>>2]|0)>>>0):0){w=k[(k[l>>2]|0)+4>>2]|0;k[l>>2]=w;t=k[w+16>>2]|0;k[d>>2]=t;v=k[o+28>>2]|0;w=k[w+12>>2]|0;k[m>>2]=t;w=t+(aa(v,w)|0)|0;k[j>>2]=w}k[g>>2]=n+-1}}while((c|0)!=(x|0));r=A;return}function wEa(a){a=a|0;return (i[a+228>>0]|0)!=0|0}function xEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,q=0,s=0.0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0.0;cb=r;r=r+320|0;Ra=cb+264|0;Oa=cb+260|0;bb=cb+248|0;$a=cb+236|0;Za=cb+224|0;_a=cb+168|0;Va=cb+112|0;Ta=cb+56|0;Qa=cb;Ph[k[(k[a>>2]|0)+152>>2]&511](a,b,c);Ia=a+240|0;b=k[a+248>>2]|0;if(!(b&1))Ka=1e4;else Ka=k[a+252>>2]|0;Ja=a+236|0;y=k[Ja>>2]|0;y=(k[y+132>>2]|0)-(k[y+128>>2]|0)|0;La=y>>2;A=(k[a+196>>2]|0)-(k[a+192>>2]|0)|0;Ma=A>>2;if(!((b&2|0)!=0?(e=+p[a+256>>3],e>0.0):0))e=0.0;k[bb>>2]=0;ab=bb+4|0;k[ab>>2]=0;k[bb+8>>2]=0;g=(La|0)==0;if(!g){if(La>>>0>1073741823)ad(426534,426557,304,426811);c=(y|0)==0?1:y;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[bb>>2]=b;Ya=b+(La<<2)|0;k[bb+8>>2]=Ya;zpb(b|0,0,y|0)|0;k[ab>>2]=Ya;if(!g){while(1){b=fgb(La)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}zpb(b|0,0,La|0)|0;Xa=b}else Xa=0}else Xa=0;k[$a>>2]=0;Ya=$a+4|0;k[Ya>>2]=0;k[$a+8>>2]=0;k[Za>>2]=0;Wa=Za+4|0;k[Wa>>2]=0;k[Za+8>>2]=0;if(!g){if(La>>>0>536870911)ad(426534,426557,304,426811);d=y<<1;c=(d|0)==0?1:d;while(1){b=fgb(c)|0;if(b|0){f=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){f=0;break}Qh[b&7]()}zpb(f|0,0,d|0)|0;if(g)Ua=0;else{if(La>>>0>1073741823)ad(426534,426557,304,426811);c=(y|0)==0?1:y;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}c=La;d=b;while(1){k[d>>2]=0;c=c+-1|0;if(!c){Ua=b;break}else d=d+4|0}}}else{Ua=0;f=0}b=aa(Ma,La)|0;if(!b)Sa=0;else{if(b>>>0>1073741823)ad(426534,426557,304,426811);d=b<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c;while(1){k[d>>2]=0;b=b+-1|0;if(!b){Sa=c;break}else d=d+4|0}}va=k[(k[Ja>>2]|0)+4>>2]|0;va=Xh[k[(k[va>>2]|0)+24>>2]&1023](va)|0;wa=k[(k[Ja>>2]|0)+4>>2]|0;wa=Xh[k[(k[wa>>2]|0)+28>>2]&1023](wa)|0;ua=k[a+84>>2]|0;ua=(ua|0)==(k[a+88>>2]|0)?0:ua;if(!wa)Na=0;else{if(wa>>>0>1073741823)ad(426534,426557,304,426811);d=wa<<2;c=(d|0)==0?1:d;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}zpb(b|0,0,d|0)|0;Na=b}Ga=k[(k[Ja>>2]|0)+4>>2]|0;jh[k[(k[Ga>>2]|0)+36>>2]&1023](_a,Ga);Ga=_a+16|0;ta=k[Ga>>2]|0;Ha=_a+44|0;q=((k[k[Ha>>2]>>2]|0)>>>0)/((1212424721>>>(k[_a>>2]<<2&28)&15)>>>0)|0;k[Va>>2]=1124007936;Ea=Va+4|0;b=Va+8|0;Ca=Va+40|0;w=Ea;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[Ca>>2]=b;Fa=Va+48|0;Da=Va+44|0;k[Da>>2]=Fa;k[Va+52>>2]=0;k[Fa>>2]=0;k[Ta>>2]=1124007941;za=Ta+4|0;k[za>>2]=2;l=Ta+8|0;k[l>>2]=wa;b=Ta+12|0;k[b>>2]=1;xa=Ta+16|0;k[xa>>2]=Na;j=Ta+20|0;k[j>>2]=Na;m=Ta+24|0;n=Ta+28|0;ya=Ta+40|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[ya>>2]=l;Ba=Ta+48|0;Aa=Ta+44|0;k[Aa>>2]=Ba;k[Ta+52>>2]=0;k[Ba>>2]=0;if((wa|0)!=0&(Na|0)==0){k[Ra>>2]=0;c=Ra+4|0;k[c>>2]=0;d=ZT(36)|0;k[d>>2]=1;w=d+4|0;k[Ra>>2]=w;k[c>>2]=28;i[d+32>>0]=0;g=390609;x=w+28|0;do{i[w>>0]=i[g>>0]|0;w=w+1|0;g=g+1|0}while((w|0)<(x|0));Y8(-215,Ra,390638,390642,410);k[c>>2]=0;k[Ra>>2]=0;sa=k[d>>2]|0;k[d>>2]=sa+-1;if((sa|0)==1)ggb(k[d+-4>>2]|0);c=k[b>>2]|0;d=k[Ta>>2]|0;g=k[Aa>>2]|0;b=k[j>>2]|0}else{c=1;d=1124007941;g=Ba;b=Na}qa=c<<2;k[Ta>>2]=d|16384;k[g>>2]=qa;k[g+4>>2]=4;ra=b+(aa(k[l>>2]|0,qa)|0)|0;k[n>>2]=ra;k[m>>2]=ra+(0-qa)+qa;qa=a+228|0;ra=i[qa>>0]|0?513:256;if(e>0.0)sa=1;else sa=(i[Ia>>0]|0)!=0;oa=k[(k[Ja>>2]|0)+4>>2]|0;oa=(Xh[k[(k[oa>>2]|0)+8>>2]&1023](oa)|0)==1;pa=oa?q:1;oa=oa?1:q;if((i[qa>>0]|0)==0?(k[Oa>>2]=0,(y|0)>0):0){c=k[Ja>>2]|0;b=k[c+128>>2]|0;c=k[c+116>>2]|0;h=0.0;d=0;do{v=+P(+(+p[c+(k[b+(d<<2)>>2]<<3)>>3]));h=h<v?v:h;d=d+1|0;k[Oa>>2]=d}while((d|0)<(La|0))}else h=0.0;if(i[Ia>>0]|0){b=a+272|0;o[Ra>>2]=0.0;c=a+276|0;j=k[c>>2]|0;g=k[b>>2]|0;d=j-g>>2;if(wa>>>0<=d>>>0){if(wa>>>0<d>>>0?(z=g+(wa<<2)|0,(j|0)!=(z|0)):0)k[c>>2]=j+(~((j+-4-z|0)>>>2)<<2)}else tQ(b,wa-d|0,Ra)}a:do if((Ka|0)>0){G=(y|0)>0;H=a+312|0;I=a+264|0;J=Ra+4|0;K=Ra+8|0;L=Ra+40|0;M=Ra+48|0;O=Ra+44|0;Q=Ra+52|0;R=(va|0)>0;S=Ra+36|0;T=Ra+16|0;U=(ua|0)==0;V=a+272|0;W=pa<<2;X=Qa+36|0;Y=Qa+16|0;_=Qa+4|0;$=Qa+40|0;ba=Qa+44|0;ca=Qa+48|0;da=Qa+4|0;ea=da+4|0;fa=Ra+12|0;ga=Qa+4|0;ha=Ra+36|0;ia=Ra+16|0;ja=Ra+4|0;ka=Ra+40|0;la=Ra+44|0;ma=Ra+48|0;na=Ra+4|0;B=(A|0)>4;C=$a+8|0;D=Ra+32|0;E=Qa+32|0;F=Ra+32|0;A=0;while(1){k[Oa>>2]=0;if(G){b=0;do{i[Xa+b>>0]=1;b=(k[Oa>>2]|0)+1|0;k[Oa>>2]=b}while((b|0)<(La|0));k[Oa>>2]=0;b=0;do{y=H;z=k[y+4>>2]|0;y=Epb(k[y>>2]|0,0,-130063606,0)|0;z=kpb(y|0,N|0,z|0,0)|0;y=H;k[y>>2]=z;k[y+4>>2]=N;z=(z>>>0)%(La>>>0)|0;k[(k[bb>>2]|0)+(b<<2)>>2]=k[(k[(k[Ja>>2]|0)+128>>2]|0)+(z<<2)>>2];i[Xa+z>>0]=0;b=(k[Oa>>2]|0)+1|0;k[Oa>>2]=b}while((b|0)<(La|0))}else k[Oa>>2]=0;if((Hh[k[(k[a>>2]|0)+164>>2]&511](a,bb)|0)<0){g=0;break a}if(sa){d=k[$a>>2]|0;b=k[Ya>>2]|0;c=d;if((b|0)==(d|0))b=d;else{b=b+(~((b+-4-c|0)>>>2)<<2)|0;k[Ya>>2]=b}k[Oa>>2]=0;if(G){c=0;do{do if(i[Xa+c>>0]|0){b=k[Ya>>2]|0;if((b|0)==(k[C>>2]|0)){Q4($a,Oa);break}else{k[b>>2]=c;k[Ya>>2]=b+4;break}}while(0);c=(k[Oa>>2]|0)+1|0;k[Oa>>2]=c}while((c|0)<(La|0));d=k[$a>>2]|0;c=d;b=k[Ya>>2]|0}l=b-c|0;y=l>>2;if(y|0){p[I>>3]=0.0;k[Oa>>2]=0;z=(l|0)>0;b:do if(z){j=A+1|0;t=0.0;c=k[Ja>>2]|0;b=0;while(1){g=k[d+(b<<2)>>2]|0;JN(Ra,wa,1,5,ta+((aa(k[(k[c+128>>2]|0)+(g<<2)>>2]|0,oa)|0)<<2)|0,W);KG(Ta,Ra)|0;b=k[ha>>2]|0;do if(b|0){w=b+12|0;x=k[w>>2]|0;k[w>>2]=x+-1;if((x|0)!=1)break;c=k[ha>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[D>>2]|0;if(b|0)break;b=B1()|0;c=k[ha>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[ha>>2]=0}while(0);k[ha>>2]=0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[ja>>2]|0)>0){c=k[ka>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ja>>2]|0))}b=k[la>>2]|0;if(!((b|0)==(ma|0)|(b|0)==0))ggb(k[b+-4>>2]|0);x=k[(k[a>>2]|0)+220>>2]|0;k[Ra>>2]=A;k[na>>2]=j;s=+wh[x&31](a,Ra,Ta,ra);if(!(i[qa>>0]|0)){c=f+(g<<3)|0;db=s+ +p[c>>3];p[c>>3]=db;c=Ua+(g<<2)|0;x=(k[c>>2]|0)+1|0;k[c>>2]=x;c=k[Ja>>2]|0;v=+p[(k[c+116>>2]|0)+(k[(k[c+128>>2]|0)+(g<<2)>>2]<<3)>>3];db=db/+(x|0)-v;db=+p[I>>3]+db*db;p[I>>3]=db;v=(s-v)/h;v=+Z(+-(v*v));s=db}else{p[u>>3]=s;b=k[u+4>>2]|0;x=b&2146435072;do if(!(x>>>0>1126170624|(x|0)==1126170624&0>0)){b=(b|0)<0;s=b?s+-4503599627370496.0+4503599627370496.0:s+4503599627370496.0+-4503599627370496.0;if(!(s==0.0))break;s=b?-0.0:0.0}while(0);d=Sa+((aa(g,Ma)|0)<<2)|0;x=d+(~~s<<2)|0;k[x>>2]=(k[x>>2]|0)+1;if(B){b=0;c=1;do{b=(k[d+(b<<2)>>2]|0)<(k[d+(c<<2)>>2]|0)?c:b;c=c+1|0}while((c|0)<(Ma|0))}else b=0;c=k[Ja>>2]|0;x=(b|0)!=(k[(k[c+104>>2]|0)+(k[(k[c+128>>2]|0)+(g<<2)>>2]<<2)>>2]|0);s=+p[I>>3]+ +(x&1);p[I>>3]=s;v=+(x&1^1|0)}t=t+v;b=(k[Oa>>2]|0)+1|0;k[Oa>>2]=b;if((b|0)>=(y|0))break b;d=k[$a>>2]|0}}else{t=0.0;s=0.0}while(0);s=s/+(y|0);p[I>>3]=s;if((l|0)>4&(i[Ia>>0]|0)!=0){k[Ra>>2]=1124007936;w=J;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[L>>2]=K;k[O>>2]=M;k[Q>>2]=0;k[M>>2]=0;d=k[Wa>>2]|0;c=k[Za>>2]|0;b=d-c>>2;do if(y>>>0>b>>>0)U1(Za,y-b|0);else{if(y>>>0>=b>>>0)break;b=c+(y<<2)|0;if((d|0)==(b|0))break;k[Wa>>2]=d+(~((d+-4-b|0)>>>2)<<2)}while(0);k[Oa>>2]=0;if(z){b=k[$a>>2]|0;c=k[Za>>2]|0;d=0;do{k[c+(d<<2)>>2]=k[b+(d<<2)>>2];d=(k[Oa>>2]|0)+1|0;k[Oa>>2]=d}while((d|0)<(y|0))}else c=k[Za>>2]|0;g=y+-1|0;k[Oa>>2]=g;d=H;b=k[d>>2]|0;d=k[d+4>>2]|0;do{q=Epb(b|0,0,-130063606,0)|0;b=kpb(q|0,N|0,d|0,0)|0;d=N;q=c+(g<<2)|0;x=c+(((b>>>0)%(y>>>0)|0)<<2)|0;w=k[q>>2]|0;k[q>>2]=k[x>>2];k[x>>2]=w;x=k[Oa>>2]|0;g=x+-1|0;k[Oa>>2]=g}while((x|0)>1);x=H;k[x>>2]=b;k[x+4>>2]=d;if(R){n=A+1|0;m=0;do{if(U)q=m;else q=k[ua+(m<<2)>>2]|0;k[Oa>>2]=0;if(z){l=aa(q,pa)|0;s=0.0;b=k[Ja>>2]|0;c=0;do{j=k[(k[$a>>2]|0)+(c<<2)>>2]|0;d=k[(k[Za>>2]|0)+(c<<2)>>2]|0;JN(Qa,wa,1,5,ta+((aa(k[(k[b+128>>2]|0)+(j<<2)>>2]|0,oa)|0)<<2)|0,W);KG(Va,Qa)|0;b=k[X>>2]|0;do if(b|0){w=b+12|0;x=k[w>>2]|0;k[w>>2]=x+-1;if((x|0)!=1)break;c=k[X>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[E>>2]|0;if(b|0)break;b=B1()|0;c=k[X>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[X>>2]=0}while(0);k[X>>2]=0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[_>>2]|0)>0){c=k[$>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[_>>2]|0))}b=k[ba>>2]|0;if(!((b|0)==(ca|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=ea;k[g>>2]=0;k[g+4>>2]=0;k[Qa>>2]=33619968;k[da>>2]=Ra;mY(Va,Qa);g=ta+((aa(k[(k[(k[Ja>>2]|0)+128>>2]|0)+(d<<2)>>2]|0,oa)|0)+l<<2)|0;g=k[g>>2]|0;do if(!(k[Ra>>2]&16384)){b=k[L>>2]|0;if((k[b>>2]|0)==1){Pa=145;break}c=k[T>>2]|0;d=k[O>>2]|0;if((k[b+4>>2]|0)==1){b=c+(aa(k[d>>2]|0,q)|0)|0;break}else{b=k[fa>>2]|0;x=(q|0)/(b|0)|0;b=q-(aa(x,b)|0)|0;b=c+(aa(k[d>>2]|0,x)|0)+(b<<2)|0;break}}else Pa=145;while(0);if((Pa|0)==145){Pa=0;b=(k[T>>2]|0)+(q<<2)|0}k[b>>2]=g;x=k[(k[a>>2]|0)+220>>2]|0;k[Qa>>2]=A;k[ga>>2]=n;v=+wh[x&31](a,Qa,Ra,ra);if(!(i[qa>>0]|0)){b=k[Ja>>2]|0;v=(v-+p[(k[b+116>>2]|0)+(k[(k[b+128>>2]|0)+(j<<2)>>2]<<3)>>3])/h;v=+Z(+-(v*v))}else{p[u>>3]=v;b=k[u+4>>2]|0;x=b&2146435072;do if(!(x>>>0>1126170624|(x|0)==1126170624&0>0)){b=(b|0)<0;v=b?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=b?-0.0:0.0}while(0);b=k[Ja>>2]|0;v=+((~~v|0)==(k[(k[b+104>>2]|0)+(k[(k[b+128>>2]|0)+(j<<2)>>2]<<2)>>2]|0)&1)}s=s+v;c=(k[Oa>>2]|0)+1|0;k[Oa>>2]=c}while((c|0)<(y|0))}else s=0.0;x=(k[V>>2]|0)+(q<<2)|0;o[x>>2]=t-s+ +o[x>>2];m=m+1|0}while((m|0)<(va|0))}b=k[S>>2]|0;do if(b|0){y=b+12|0;z=k[y>>2]|0;k[y>>2]=z+-1;if((z|0)!=1)break;c=k[S>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[F>>2]|0;if(b|0)break;b=B1()|0;c=k[S>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[S>>2]=0}while(0);k[S>>2]=0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[J>>2]|0)>0){c=k[L>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[J>>2]|0))}b=k[O>>2]|0;if(!((b|0)==(M|0)|(b|0)==0))ggb(k[b+-4>>2]|0);s=+p[I>>3]}if(s<e){Pa=173;break a}}}A=A+1|0;if((A|0)>=(Ka|0)){Pa=173;break}}}else Pa=173;while(0);if((Pa|0)==173){if(i[Ia>>0]|0){if((wa|0)>0){c=k[a+272>>2]|0;b=0;do{Pa=c+(b<<2)|0;o[Ra>>2]=0.0;k[Pa>>2]=k[(+o[Pa>>2]<0.0?Ra:Pa)>>2];b=b+1|0}while((b|0)!=(wa|0))}Oa=a+272|0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;k[Ra>>2]=-2130509819;k[Ra+4>>2]=Oa;Pa=Qa+4|0;Ma=Pa+4|0;k[Ma>>2]=0;k[Ma+4>>2]=0;k[Qa>>2]=-2096955387;k[Pa>>2]=Oa;$X(Ra,Qa,1.0,0.0,2,-1,49332)}Uh[k[(k[a>>2]|0)+156>>2]&2047](a);g=1}d=Ta+36|0;b=k[d>>2]|0;if(b|0?(Qa=b+12|0,Ra=k[Qa>>2]|0,k[Qa>>2]=Ra+-1,(Ra|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Ta+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[za>>2]|0)>0){c=k[ya>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[za>>2]|0))}b=k[Aa>>2]|0;if(!((b|0)==(Ba|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=Va+36|0;b=k[d>>2]|0;if(b|0?(Ra=b+12|0,Ta=k[Ra>>2]|0,k[Ra>>2]=Ta+-1,(Ta|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Va+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;Va=Va+16|0;k[Va>>2]=0;k[Va+4>>2]=0;k[Va+8>>2]=0;k[Va+12>>2]=0;if((k[Ea>>2]|0)>0){c=k[Ca>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ea>>2]|0))}b=k[Da>>2]|0;if(!((b|0)==(Fa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=_a+36|0;b=k[d>>2]|0;if(b|0?(Ta=b+12|0,Va=k[Ta>>2]|0,k[Ta>>2]=Va+-1,(Va|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[_a+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=_a+4|0;k[Ga>>2]=0;k[Ga+4>>2]=0;k[Ga+8>>2]=0;k[Ga+12>>2]=0;if((k[d>>2]|0)>0){c=k[_a+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[Ha>>2]|0;if(!((b|0)==(_a+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);if(Na|0)ggb(Na);if(Sa|0)ggb(Sa);if(Ua|0)ggb(Ua);if(f|0)ggb(f);b=k[Za>>2]|0;c=b;if(b|0){d=k[Wa>>2]|0;if((d|0)!=(b|0))k[Wa>>2]=d+(~((d+-4-c|0)>>>2)<<2);ggb(b)}b=k[$a>>2]|0;c=b;if(b|0){d=k[Ya>>2]|0;if((d|0)!=(b|0))k[Ya>>2]=d+(~((d+-4-c|0)>>>2)<<2);ggb(b)}if(Xa|0)ggb(Xa);b=k[bb>>2]|0;if(!b){r=cb;return g|0}c=k[ab>>2]|0;if((c|0)!=(b|0))k[ab>>2]=c+(~((c+-4-b|0)>>>2)<<2);ggb(b);r=cb;return g|0}function yEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;TGa(a,b,c);l=k[(k[a+236>>2]|0)+4>>2]|0;l=Xh[k[(k[l>>2]|0)+24>>2]&1023](l)|0;b=k[a+244>>2]|0;if((b|0)<=0){d=+Q(+(+(l|0)));p[u>>3]=d;b=k[u+4>>2]|0;i=b&2146435072;if(!(i>>>0>1126170624|(i|0)==1126170624&0>0)){b=(b|0)<0;d=b?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=b?-0.0:0.0}b=~~d}h=(b|0)<1?1:b;h=(l|0)<(h|0)?l:h;i=a+284|0;b=a+288|0;f=k[b>>2]|0;e=k[i>>2]|0;c=f-e>>2;if(l>>>0<=c>>>0){if(l>>>0<c>>>0?(g=e+(l<<2)|0,(f|0)!=(g|0)):0)k[b>>2]=f+(~((f+-4-g|0)>>>2)<<2)}else U1(i,l-c|0);b=a+296|0;c=a+300|0;g=k[c>>2]|0;f=k[b>>2]|0;e=g-f>>2;if(h>>>0<=e>>>0){if(h>>>0<e>>>0?(j=f+(h<<2)|0,(g|0)!=(j|0)):0)k[c>>2]=g+(~((g+-4-j|0)>>>2)<<2)}else U1(b,h-e|0);if((l|0)<=0)return;e=k[a+84>>2]|0;c=k[i>>2]|0;b=0;do{k[c+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)!=(l|0));return}function zEa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+232|0;c=k[b>>2]|0;if(c|0?(e=c+4|0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+236>>2]=0;e=a+284|0;b=k[e>>2]|0;k[e>>2]=0;k[a+288>>2]=0;k[a+292>>2]=0;e=a+296|0;c=k[e>>2]|0;k[e>>2]=0;k[a+300>>2]=0;k[a+304>>2]=0;if(c|0)ggb(c);if(!b)return;ggb(b);return}function AEa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;h=k[a+284>>2]|0;d=(k[a+288>>2]|0)-h|0;f=d>>2;j=a+296|0;i=k[j>>2]|0;e=(k[a+300>>2]|0)-i|0;g=e>>2;if((d|0)>0){b=a+312|0;d=b;a=0;c=k[d>>2]|0;d=k[d+4>>2]|0;do{n=Epb(c|0,0,-130063606,0)|0;n=kpb(n|0,N|0,d|0,0)|0;l=N;m=Epb(n|0,0,-130063606,0)|0;c=kpb(m|0,N|0,l|0,0)|0;d=N;n=h+(((n>>>0)%(f>>>0)|0)<<2)|0;l=h+(((c>>>0)%(f>>>0)|0)<<2)|0;m=k[n>>2]|0;k[n>>2]=k[l>>2];k[l>>2]=m;a=a+1|0}while((a|0)<(f|0));n=b;k[n>>2]=c;k[n+4>>2]=d}if((e|0)>0)a=0;else return j|0;do{k[i+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(g|0));return j|0}function BEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;f=h;jHa(a,b);g=f+4|0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[f>>2]=c;k[g>>2]=12;i[d+16>>0]=0;d=367966;e=c+12|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));b=z6(b,f)|0;c=k[f>>2]|0;k[g>>2]=0;k[f>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);DEa(b,a+244|0)|0;r=h;return}function CEa(a,b){a=a|0;b=b|0;var c=0.0,d=0;oHa(a,b);d=k[b>>2]|0;b=k6(d,k6(d,k[b+4>>2]|0,370919)|0,367966)|0;if(!b){b=0;d=a+244|0;k[d>>2]=b;return}switch(k[b>>2]&7){case 1:{b=k[b+8>>2]|0;d=a+244|0;k[d>>2]=b;return}case 2:{c=+p[b+8>>3];p[u>>3]=c;b=k[u+4>>2]|0;d=b&2146435072;if(!(d>>>0>1126170624|(d|0)==1126170624&0>0)){b=(b|0)<0;c=b?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=b?-0.0:0.0}b=~~c;d=a+244|0;k[d>>2]=b;return}default:{b=2147483647;d=a+244|0;k[d>>2]=b;return}}}function DEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function EEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+16|0;n=p+8|0;o=p;g=k[a>>2]|0;l=k[g+40>>2]|0;i[n>>0]=49;i[n+1>>0]=102;i[n+2>>0]=0;l=(l|0)<0?2147483647:l;m=b+4|0;e=k[m>>2]|0;d=k[b>>2]|0;c=e-d>>2;if(l>>>0<=c>>>0){if(l>>>0<c>>>0?(f=d+(l<<2)|0,(e|0)!=(f|0)):0)k[m>>2]=e+(~((e+-4-f|0)>>>2)<<2)}else{FEa(b,l-c|0);g=k[a>>2]|0}k[o>>2]=0;h=o+4|0;k[h>>2]=0;f=n;a:do if(!(f&3)){a=n;j=10}else{e=n;c=49;a=f;while(1){if(!(c<<24>>24))break a;a=e+1|0;d=a;if(!(d&3)){j=10;break a}e=a;c=i[a>>0]|0;a=d}}while(0);if((j|0)==10){while(1){c=k[a>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))a=a+4|0;else break}if((c&255)<<24>>24)do a=a+1|0;while((i[a>>0]|0)!=0)}j=a-f|0;a=ZT(j+8&-4)|0;k[a>>2]=1;f=a+4|0;k[o>>2]=f;k[h>>2]=j;i[f+j>>0]=0;upb(f|0,n|0,j|0)|0;n=k[b>>2]|0;C6(g,o,(n|0)==(k[m>>2]|0)?0:n,l<<2)|0;k[h>>2]=0;k[o>>2]=0;o=k[a>>2]|0;k[a>>2]=o+-1;if((o|0)!=1){r=p;return}ggb(k[a+-4>>2]|0);r=p;return}function FEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+8|0;d=k[j>>2]|0;l=a+4|0;c=k[l>>2]|0;if(d-c>>2>>>0>=b>>>0){zpb(c|0,0,b<<2|0)|0;k[l>>2]=c+(b<<2);return}i=k[a>>2]|0;h=c-i|0;g=h>>2;c=g+b|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);e=d-i|0;f=e>>1;f=e>>2>>>0<536870911?(f>>>0<c>>>0?c:f):1073741823;if(!f)c=0;else{if(f>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<2)|0;zpb(e|0,0,b<<2|0)|0;d=e+(0-g<<2)|0;if((h|0)>0)upb(d|0,i|0,h|0)|0;k[a>>2]=d;k[l>>2]=e+(b<<2);k[j>>2]=c+(f<<2);if(!i)return;ggb(i);return}function GEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;h=m+8|0;j=m;i[h>>0]=49;i[h+1>>0]=102;i[h+2>>0]=0;k[j>>2]=0;l=j+4|0;k[l>>2]=0;g=h;a:do if(!(g&3)){c=h;f=5}else{e=h;d=g;c=49;while(1){if(!(c<<24>>24)){c=d;break a}c=e+1|0;d=c;if(!(d&3)){f=5;break a}e=c;c=i[c>>0]|0}}while(0);if((f|0)==5){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}g=c-g|0;c=ZT(g+8&-4)|0;k[c>>2]=1;f=c+4|0;k[j>>2]=f;k[l>>2]=g;i[f+g>>0]=0;upb(f|0,h|0,g|0)|0;h=k[b>>2]|0;b=k[b+4>>2]|0;A6(a,j,(h|0)==(b|0)?0:h,b-h|0);k[l>>2]=0;k[j>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)!=1){r=m;return}ggb(k[c+-4>>2]|0);r=m;return}function HEa(a){a=a|0;k[a>>2]=92104;rEa(a+8|0);return}function IEa(a){a=a|0;k[a>>2]=92104;rEa(a+8|0);ggb(a);return}function JEa(a,b){a=a|0;b=b|0;uEa(a+8|0,b);return}function KEa(a,b){a=a|0;b=b|0;vEa(a+8|0,b);return}function LEa(a,b){a=a|0;b=b|0;var c=0;c=ZT(24)|0;k[c>>2]=1;b=c+4|0;k[a>>2]=b;k[a+4>>2]=16;i[c+20>>0]=0;a=b;b=368166;c=a+16|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));return}function MEa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+32>>2]&1023](a)|0}function NEa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0}function OEa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0}function PEa(a,b,c){a=a|0;b=b|0;c=c|0;return xEa(a+8|0,b,c)|0}function QEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=a+8|0;return +(+wh[k[(k[a>>2]|0)+56>>2]&31](a,b,c,d))}function REa(a){a=a|0;return k[a+72>>2]|0}function SEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if((b|0)>=2){h=(b|0)>15;h=h?15:b;j=a+72|0;k[j>>2]=h;r=g;return}d=c+4|0;e=ZT(36)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=29;i[e+33>>0]=0;h=370965;j=f+29|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,c,370995,371012,135);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);h=(b|0)>15;h=h?15:b;j=a+72|0;k[j>>2]=h;r=g;return}function TEa(a){a=a|0;return k[a+76>>2]|0}function UEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if((b|0)>=0){h=(b|0)>25;h=h?25:b;j=a+76|0;k[j>>2]=h;r=g;return}d=c+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=24;i[e+28>>0]=0;h=371170;j=f+24|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,c,371195,371012,141);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);h=(b|0)>25;h=h?25:b;j=a+76|0;k[j>>2]=h;r=g;return}function VEa(a){a=a|0;return k[a+80>>2]|0}function WEa(a,b){a=a|0;b=b|0;k[a+80>>2]=(b|0)<1?1:b;return}function XEa(a){a=a|0;return k[a+84>>2]|0}function YEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if((b|0)>=0){h=(b|0)==1;h=h?0:b;j=a+84|0;k[j>>2]=h;r=g;return}d=c+4|0;e=ZT(112)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=106;i[e+110>>0]=0;h=371247;j=f+106|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,c,371354,371012,153);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);h=(b|0)==1;h=h?0:b;j=a+84|0;k[j>>2]=h;r=g;return}function ZEa(a){a=a|0;return (i[a+12>>0]|0)!=0|0}function _Ea(a,b){a=a|0;b=b|0;i[a+12>>0]=b&1;return}function $Ea(a){a=a|0;return (i[a+13>>0]|0)!=0|0}function aFa(a,b){a=a|0;b=b|0;i[a+13>>0]=b&1;return}function bFa(a){a=a|0;return (i[a+14>>0]|0)!=0|0}function cFa(a,b){a=a|0;b=b|0;i[a+14>>0]=b&1;return}function dFa(a){a=a|0;return +(+o[a+88>>2])}function eFa(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if(!(b<0.0)){j=a+88|0;o[j>>2]=b;r=g;return}d=c+4|0;e=ZT(48)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=41;i[e+45>>0]=0;h=371096;j=f+41|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,c,371138,371012,161);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);j=a+88|0;o[j>>2]=b;r=g;return}function fFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+16>>2];i=a+4|0;e=b+20|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+24>>2];k[a+12>>2]=k[b+28>>2];k[a+16>>2]=k[b+32>>2];k[a+20>>2]=k[b+36>>2];k[a+24>>2]=k[b+40>>2];k[a+28>>2]=k[b+44>>2];k[a+32>>2]=k[b+48>>2];d=k[b+52>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+60>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+56>>2]|0;a=k[g>>2]|0;e=k[b+60>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function gFa(a,b){a=a|0;b=b|0;KG(a+16|0,b)|0;return}function hFa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+132>>2]&1023](a)|0}function iFa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+136>>2]&1023](a)|0}function jFa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+140>>2]&1023](a)|0}function kFa(a){a=a|0;a=a+8|0;return Xh[k[(k[a>>2]|0)+144>>2]&1023](a)|0}function lFa(a){a=a|0;return (i[a+248>>0]|0)!=0|0}function mFa(a,b){a=a|0;b=b|0;i[a+248>>0]=b&1;return}function nFa(a){a=a|0;return k[a+252>>2]|0}function oFa(a,b){a=a|0;b=b|0;k[a+252>>2]=b;return}function pFa(a,b){a=a|0;b=b|0;b=b+256|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];return}function qFa(a,b){a=a|0;b=b|0;a=a+256|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];return}function rFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+128|0;g=A+72|0;f=A+56|0;q=A;k[q>>2]=1124024325;z=q+4|0;k[z>>2]=2;s=q+8|0;m=k[b+284>>2]|0;d=k[b+280>>2]|0;e=m-d|0;b=e>>2;k[s>>2]=b;n=q+12|0;k[n>>2]=1;u=q+16|0;k[u>>2]=0;o=q+20|0;k[o>>2]=0;p=q+24|0;k[p>>2]=0;t=q+32|0;k[t>>2]=0;v=q+36|0;k[v>>2]=0;w=q+40|0;k[w>>2]=s;y=q+48|0;x=q+44|0;k[x>>2]=y;k[q+52>>2]=0;k[y>>2]=0;c=d;if((c|0)!=(m|0)){m=g+4|0;k[m>>2]=2;l=g+8|0;k[l>>2]=b;k[g+12>>2]=1;i=g+16|0;k[i>>2]=c;k[g+20>>2]=c;b=g+24|0;h=g+40|0;j=b+8|0;k[j>>2]=0;k[j+4>>2]=0;k[h>>2]=l;l=g+48|0;j=g+44|0;k[j>>2]=l;k[g>>2]=1124024325;k[l>>2]=4;k[g+52>>2]=4;d=d+e|0;k[g+28>>2]=d;k[b>>2]=d+-4+4;d=f+4|0;b=d+4|0;k[b>>2]=0;k[b+4>>2]=0;k[f>>2]=33619968;k[d>>2]=q;mY(g,f);d=g+36|0;b=k[d>>2]|0;if(b|0?(e=b+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[g+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;if((k[m>>2]|0)>0){c=k[h>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[j>>2]|0;if(!((b|0)==(l|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}k[a>>2]=k[q>>2];h=a+4|0;b=k[z>>2]|0;k[h>>2]=b;g=a+8|0;k[g>>2]=k[s>>2];k[a+12>>2]=k[n>>2];k[a+16>>2]=k[u>>2];k[a+20>>2]=k[o>>2];k[a+24>>2]=k[p>>2];k[a+28>>2]=k[q+28>>2];k[a+32>>2]=k[t>>2];c=k[v>>2]|0;k[a+36>>2]=c;d=a+40|0;k[d>>2]=g;s=a+48|0;g=a+44|0;k[g>>2]=s;k[a+52>>2]=0;k[s>>2]=0;if(c){b=c+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[z>>2]|0}if((b|0)>=3){k[h>>2]=0;x1(a,b,0,0,0);if((k[h>>2]|0)>0){f=k[w>>2]|0;d=k[d>>2]|0;e=k[x>>2]|0;c=k[g>>2]|0;b=0;do{k[d+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else{s=k[x>>2]|0;a=k[g>>2]|0;k[a>>2]=k[s>>2];k[a+4>>2]=k[s+4>>2]}b=k[v>>2]|0;if(b|0?(s=b+12|0,a=k[s>>2]|0,k[s>>2]=a+-1,(a|0)==1):0){c=k[v>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[t>>2]|0;if(!b){b=B1()|0;c=k[v>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[v>>2]=0}k[v>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[z>>2]|0)>0){c=k[w>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[x>>2]|0;if((b|0)==(y|0)|(b|0)==0){r=A;return}ggb(k[b+-4>>2]|0);r=A;return}function sFa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;while(1){b=fgb(352)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=92596;k[b+64>>2]=1124007936;c=b+72|0;d=b+104|0;e=b+68|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;c=b+112|0;k[b+108>>2]=c;k[c>>2]=0;k[c+4>>2]=0;k[b+8>>2]=100;k[b+12>>2]=2;p[b+32>>3]=0.0;p[b+16>>3]=1.0;p[b+24>>3]=0.0;p[b+40>>3]=1.0;c=b+48|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;k[b+120>>2]=3;k[b+124>>2]=1e3;p[b+128>>3]=1.1920928955078125e-07;k[b+136>>2]=1124007936;c=b+144|0;d=b+176|0;e=b+140|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;c=b+184|0;k[b+180>>2]=c;k[b+188>>2]=0;k[c>>2]=0;k[b+196>>2]=1124007936;c=b+204|0;d=b+236|0;e=b+200|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;c=b+244|0;k[b+240>>2]=c;k[b+248>>2]=0;k[c>>2]=0;k[b+252>>2]=1124007936;c=b+260|0;d=b+292|0;e=b+256|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;e=b+300|0;k[b+296>>2]=e;f=e+52|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Uh[k[(k[b>>2]|0)+8>>2]&2047](b);vFa(b);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}f=c+4|0;k[f>>2]=1;k[c>>2]=92576;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[f>>2]=(k[f>>2]|0)+1;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function tFa(a){a=a|0;ggb(a);return}function uFa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function vFa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0.0;n=r;r=r+16|0;m=n;l=a+8|0;d=k[a+12>>2]|0;if((d|0)==-1){if(!(k[a+348>>2]|0)){b=m+4|0;c=ZT(32)|0;k[c>>2]=1;g=c+4|0;k[m>>2]=g;k[b>>2]=24;i[c+28>>0]=0;h=368525;j=g+24|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,m,368365,368204,1315);k[b>>2]=0;k[m>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0)}}else{f=(d|0)==1;if(d>>>0<=5){b=a+16|0;if(!d){p[b>>3]=1.0;b=a+24|0;e=13}else e=8}else{b=m+4|0;c=ZT(36)|0;k[c>>2]=1;g=c+4|0;k[m>>2]=g;k[b>>2]=31;i[c+35>>0]=0;h=368333;j=g+31|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,m,368365,368204,1293);k[b>>2]=0;k[m>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0);b=a+16|0;e=8}a:do if((e|0)==8){if(+p[b>>3]<=0.0){b=m+4|0;c=ZT(52)|0;k[c>>2]=1;g=c+4|0;k[m>>2]=g;k[b>>2]=46;i[c+50>>0]=0;h=368377;j=g+46|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-211,m,368365,368204,1298);k[b>>2]=0;k[m>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0)}b=a+24|0;switch(d|0){case 1:case 3:break;default:{e=13;break a}}if(+p[b>>3]<0.0){b=m+4|0;c=ZT(60)|0;k[c>>2]=1;g=c+4|0;k[m>>2]=g;k[b>>2]=53;i[c+57>>0]=0;h=368424;j=g+53|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-211,m,368365,368204,1303);k[b>>2]=0;k[m>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0)}}while(0);if((e|0)==13)p[b>>3]=0.0;b=a+32|0;if(f){if(+p[b>>3]<=0.0){b=m+4|0;c=ZT(52)|0;k[c>>2]=1;g=c+4|0;k[m>>2]=g;k[b>>2]=46;i[c+50>>0]=0;h=368478;j=g+46|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-211,m,368365,368204,1308);k[b>>2]=0;k[m>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0)}}else p[b>>3]=0.0;f=a+344|0;while(1){b=fgb(136)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}wFa(b,l);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=92760;k[c+8>>2]=b;k[d>>2]=(k[d>>2]|0)+1;e=k[f>>2]|0;k[f>>2]=c;k[a+348>>2]=b;if(e|0?(h=e+4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)Uh[k[(k[c>>2]|0)+8>>2]&2047](c)}d=k[l>>2]|0;f=(d|0)==100;e=(d|0)==103;if((d+-100|0)>>>0>=5){b=m+4|0;c=ZT(36)|0;k[c>>2]=1;g=c+4|0;k[m>>2]=g;k[b>>2]=28;i[c+32>>0]=0;h=368550;j=g+28|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,m,368365,368204,1323);k[b>>2]=0;k[m>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)==1)ggb(k[c+-4>>2]|0)}b=a+40|0;if((d+-101|0)>>>0>=2){if(+p[b>>3]<=0.0){b=m+4|0;c=ZT(40)|0;k[c>>2]=1;g=c+4|0;k[m>>2]=g;k[b>>2]=32;i[c+36>>0]=0;h=368579;j=g+32|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-211,m,368365,368204,1328);k[b>>2]=0;k[m>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)==1)ggb(k[c+-4>>2]|0)}}else p[b>>3]=0.0;b=a+48|0;switch(d|0){case 100:case 103:{p[b>>3]=0.0;break}default:{o=+p[b>>3];if(!(!(o<=0.0)&!(o>=1.0))){b=m+4|0;c=ZT(48)|0;k[c>>2]=1;g=c+4|0;k[m>>2]=g;k[b>>2]=40;i[c+44>>0]=0;h=368612;j=g+40|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-211,m,368365,368204,1333);k[b>>2]=0;k[m>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)==1)ggb(k[c+-4>>2]|0)}}}b=a+56|0;if(e){if(+p[b>>3]<=0.0){b=m+4|0;c=ZT(40)|0;k[c>>2]=1;g=c+4|0;k[m>>2]=g;k[b>>2]=32;i[c+36>>0]=0;h=368653;j=g+32|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-211,m,368365,368204,1338);k[b>>2]=0;k[m>>2]=0;m=k[c>>2]|0;k[c>>2]=m+-1;if((m|0)==1)ggb(k[c+-4>>2]|0)}}else p[b>>3]=0.0;if(!f){d=a+100|0;b=k[d>>2]|0;if(b|0?(l=b+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+96>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;m=a+80|0;c=a+68|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+104>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}}c=k[a+120>>2]|0;b=a+128|0;if(!(c&2))p[b>>3]=2.220446049250313e-16;o=+p[b>>3];p[b>>3]=o<2.220446049250313e-16?2.220446049250313e-16:o;b=a+124|0;if(!(c&1)){k[b>>2]=2147483647;a=2147483647;m=(a|0)<1;a=m?1:a;k[b>>2]=a;r=n;return}else{a=k[b>>2]|0;m=(a|0)<1;a=m?1:a;k[b>>2]=a;r=n;return}}function wFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;k[a>>2]=92780;c=a+8|0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;f=a+68|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;f=a+112|0;k[a+108>>2]=f;k[f>>2]=0;k[f+4>>2]=0;k[c>>2]=100;k[a+12>>2]=2;p[a+32>>3]=0.0;p[a+16>>3]=1.0;p[a+24>>3]=0.0;p[a+40>>3]=1.0;f=a+48|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[a+120>>2]=3;k[a+124>>2]=1e3;p[a+128>>3]=1.1920928955078125e-07;f=c;c=b;g=f+56|0;do{k[f>>2]=k[c>>2];f=f+4|0;c=c+4|0}while((f|0)<(g|0));KG(a+64|0,b+56|0)|0;g=a+120|0;f=b+112|0;k[g>>2]=k[f>>2];k[g+4>>2]=k[f+4>>2];k[g+8>>2]=k[f+8>>2];k[g+12>>2]=k[f+12>>2];return}function xFa(a){a=a|0;ggb(a);return}function yFa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function zFa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=92780;d=a+100|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+96>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+80|0;c=a+68|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+104>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+108>>2]|0;if((b|0)==(a+112|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function AFa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=92780;d=a+100|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+96>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+80|0;c=a+68|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+104>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+108>>2]|0;if((b|0)==(a+112|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function BFa(a){a=a|0;return k[a+12>>2]|0}function CFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0.0,l=0,m=0,n=0,q=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0;H=r;r=r+128|0;F=H+72|0;G=H+16|0;E=H;a:do switch(k[a+12>>2]|0){case 0:{DFa(b,c,d,e,f,1.0,0.0);break}case 2:{u=+p[a+16>>3];if((b|0)<=0){r=H;return}m=c+-4|0;if((c|0)<4){m=(c|0)>0;l=0;do{h=d+((aa(l,c)|0)<<2)|0;if(m){g=0;j=0.0;do{w=+o[h+(g<<2)>>2]-+o[e+(g<<2)>>2];j=j+w*w;g=g+1|0}while((g|0)!=(c|0))}else j=0.0;o[f+(l<<2)>>2]=-(u*j);l=l+1|0}while((l|0)!=(b|0))}else{n=c&-4;q=(n|0)<(c|0);l=0;do{h=d+((aa(l,c)|0)<<2)|0;g=0;j=0.0;do{J=+o[h+(g<<2)>>2]-+o[e+(g<<2)>>2];a=g|1;I=+o[h+(a<<2)>>2]-+o[e+(a<<2)>>2];a=g|2;v=+o[h+(a<<2)>>2]-+o[e+(a<<2)>>2];a=g|3;w=+o[h+(a<<2)>>2]-+o[e+(a<<2)>>2];j=j+(J*J+I*I)+(v*v+w*w);g=g+4|0}while((g|0)<=(m|0));if(q){g=n;do{J=+o[h+(g<<2)>>2]-+o[e+(g<<2)>>2];j=j+J*J;g=g+1|0}while((g|0)!=(c|0))}o[f+(l<<2)>>2]=-(u*j);l=l+1|0}while((l|0)!=(b|0))}s=F+4|0;k[s>>2]=2;t=F+8|0;k[t>>2]=1;k[F+12>>2]=b;m=F+16|0;k[m>>2]=f;k[F+20>>2]=f;l=F+24|0;n=F+40|0;q=l+8|0;k[q>>2]=0;k[q+4>>2]=0;k[n>>2]=t;t=F+48|0;q=F+44|0;k[q>>2]=t;g=b<<2;k[F>>2]=1124024325;k[t>>2]=g;k[F+52>>2]=4;e=f+(b<<2)|0;k[F+28>>2]=e;k[l>>2]=e+(0-g)+g;k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=F;l=E+4|0;g=l+4|0;k[g>>2]=0;k[g+4>>2]=0;k[E>>2]=33619968;k[l>>2]=F;XZ(G,E);l=F+36|0;g=k[l>>2]|0;if(g|0?(d=g+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[F+32>>2]|0;if(!g){g=B1()|0;h=k[l>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}k[l>>2]=0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[s>>2]|0)>0){h=k[n>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[s>>2]|0))}g=k[q>>2]|0;if(!((g|0)==(t|0)|(g|0)==0))ggb(k[g+-4>>2]|0);break}case 1:{k[G>>2]=1124007941;z=G+4|0;k[z>>2]=2;q=G+8|0;k[q>>2]=1;g=G+12|0;k[g>>2]=b;x=G+16|0;k[x>>2]=f;n=G+20|0;k[n>>2]=f;s=G+24|0;t=G+28|0;y=G+40|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[y>>2]=q;B=G+48|0;A=G+44|0;k[A>>2]=B;k[G+52>>2]=0;k[B>>2]=0;if((b|0)!=0&(f|0)==0){h=F+4|0;l=ZT(36)|0;k[l>>2]=1;m=l+4|0;k[F>>2]=m;k[h>>2]=28;i[l+32>>0]=0;C=390609;D=m+28|0;do{i[m>>0]=i[C>>0]|0;m=m+1|0;C=C+1|0}while((m|0)<(D|0));Y8(-215,F,390638,390642,410);k[h>>2]=0;k[F>>2]=0;D=k[l>>2]|0;k[l>>2]=D+-1;if((D|0)==1)ggb(k[l+-4>>2]|0);h=k[g>>2]|0;l=k[G>>2]|16384;m=k[A>>2]|0;g=k[n>>2]|0}else{h=b;l=1124024325;m=B;g=f}D=h<<2;k[G>>2]=l;k[m>>2]=D;k[m+4>>2]=4;C=g+(aa(k[q>>2]|0,D)|0)|0;k[t>>2]=C;k[s>>2]=C+(0-D)+D;DFa(b,c,d,e,f,+p[a+16>>3],+p[a+24>>3]);if((b|0)>0){k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=G;J=+p[a+32>>3];e=E+4|0;d=e+4|0;k[d>>2]=0;k[d+4>>2]=0;k[E>>2]=33619968;k[e>>2]=G;ZZ(F,J,E)}l=G+36|0;g=k[l>>2]|0;if(g|0?(d=g+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[G+32>>2]|0;if(!g){g=B1()|0;h=k[l>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}k[l>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[z>>2]|0)>0){h=k[y>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[z>>2]|0))}g=k[A>>2]|0;if(!((g|0)==(B|0)|(g|0)==0))ggb(k[g+-4>>2]|0);break}case 3:{DFa(b,c,d,e,f,+p[a+16>>3]*-2.0,+p[a+24>>3]*-2.0);if((b|0)>0)g=0;else{r=H;return}do{h=f+(g<<2)|0;J=+o[h>>2];j=+Z(+-+P(+J));if(J>0.0)j=(1.0-j)/(j+1.0);else j=(j+-1.0)/(j+1.0);o[h>>2]=j;g=g+1|0}while((g|0)!=(b|0));break}case 4:{k[G>>2]=1124007941;z=G+4|0;k[z>>2]=2;q=G+8|0;k[q>>2]=1;g=G+12|0;k[g>>2]=b;x=G+16|0;k[x>>2]=f;n=G+20|0;k[n>>2]=f;s=G+24|0;t=G+28|0;y=G+40|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[y>>2]=q;B=G+48|0;A=G+44|0;k[A>>2]=B;k[G+52>>2]=0;k[B>>2]=0;if((b|0)!=0&(f|0)==0){h=F+4|0;l=ZT(36)|0;k[l>>2]=1;m=l+4|0;k[F>>2]=m;k[h>>2]=28;i[l+32>>0]=0;C=390609;D=m+28|0;do{i[m>>0]=i[C>>0]|0;m=m+1|0;C=C+1|0}while((m|0)<(D|0));Y8(-215,F,390638,390642,410);k[h>>2]=0;k[F>>2]=0;D=k[l>>2]|0;k[l>>2]=D+-1;if((D|0)==1)ggb(k[l+-4>>2]|0);h=k[g>>2]|0;l=k[G>>2]|16384;m=k[A>>2]|0;g=k[n>>2]|0}else{h=b;l=1124024325;m=B;g=f}D=h<<2;k[G>>2]=l;k[m>>2]=D;k[m+4>>2]=4;C=g+(aa(k[q>>2]|0,D)|0)|0;k[t>>2]=C;k[s>>2]=C+(0-D)+D;w=+p[a+16>>3];if((b|0)>0){if((c|0)>0){g=0;do{l=d+((aa(g,c)|0)<<2)|0;h=0;j=0.0;do{J=+o[l+(h<<2)>>2];v=+o[e+(h<<2)>>2];u=J-v;v=J+v;if(v!=0.0)j=j+u*u/v;h=h+1|0}while((h|0)!=(c|0));o[f+(g<<2)>>2]=-(w*j);g=g+1|0}while((g|0)!=(b|0))}else{j=-(w*0.0);g=0;do{o[f+(g<<2)>>2]=j;g=g+1|0}while((g|0)!=(b|0))}k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=G;e=E+4|0;d=e+4|0;k[d>>2]=0;k[d+4>>2]=0;k[E>>2]=33619968;k[e>>2]=G;XZ(F,E)}l=G+36|0;g=k[l>>2]|0;if(g|0?(d=g+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[G+32>>2]|0;if(!g){g=B1()|0;h=k[l>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}k[l>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[z>>2]|0)>0){h=k[y>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[z>>2]|0))}g=k[A>>2]|0;if(!((g|0)==(B|0)|(g|0)==0))ggb(k[g+-4>>2]|0);break}case 5:{if((b|0)<=0){r=H;return}m=c+-4|0;if((c|0)<4){m=(c|0)>0;l=0;while(1){h=d+((aa(l,c)|0)<<2)|0;if(m){g=0;j=0.0;do{I=+o[e+(g<<2)>>2];J=+o[h+(g<<2)>>2];j=j+(I<J?I:J);g=g+1|0}while((g|0)!=(c|0))}else j=0.0;o[f+(l<<2)>>2]=j;l=l+1|0;if((l|0)==(b|0))break a}}n=c&-4;q=(n|0)<(c|0);l=0;do{h=d+((aa(l,c)|0)<<2)|0;g=0;j=0.0;do{M=+o[e+(g<<2)>>2];L=+o[h+(g<<2)>>2];G=g|1;K=+o[e+(G<<2)>>2];u=+o[h+(G<<2)>>2];G=g|2;v=+o[e+(G<<2)>>2];w=+o[h+(G<<2)>>2];G=g|3;I=+o[e+(G<<2)>>2];J=+o[h+(G<<2)>>2];j=j+((M<L?M:L)+(K<u?K:u)+(v<w?v:w)+(I<J?I:J));g=g+4|0}while((g|0)<=(m|0));if(q){g=n;do{L=+o[e+(g<<2)>>2];M=+o[h+(g<<2)>>2];j=j+(L<M?L:M);g=g+1|0}while((g|0)!=(c|0))}o[f+(l<<2)>>2]=j;l=l+1|0}while((l|0)!=(b|0));break}default:{g=F+4|0;h=ZT(24)|0;k[h>>2]=1;m=h+4|0;k[F>>2]=m;k[g>>2]=19;i[h+23>>0]=0;C=368762;D=m+19|0;do{i[m>>0]=i[C>>0]|0;m=m+1|0;C=C+1|0}while((m|0)<(D|0));Y8(-5,F,404929,368204,326);k[g>>2]=0;k[F>>2]=0;e=k[h>>2]|0;k[h>>2]=e+-1;if((e|0)==1)ggb(k[h+-4>>2]|0)}}while(0);if((b|0)>0)g=0;else{r=H;return}do{h=f+(g<<2)|0;if(+o[h>>2]>3402823434694023592411306.0e11)o[h>>2]=3402823434694023592411306.0e11;g=g+1|0}while((g|0)!=(b|0));r=H;return}function DFa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;var h=0.0,i=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0;if((a|0)<=0)return;n=b+-4|0;if((b|0)<4){l=(b|0)>0;k=0;do{j=c+((aa(k,b)|0)<<2)|0;if(l){i=0;h=0.0;do{h=h+ +o[j+(i<<2)>>2]*+o[d+(i<<2)>>2];i=i+1|0}while((i|0)!=(b|0))}else h=0.0;o[e+(k<<2)>>2]=h*f+g;k=k+1|0}while((k|0)!=(a|0));return}l=b&-4;m=(l|0)<(b|0);k=0;do{j=c+((aa(k,b)|0)<<2)|0;i=0;h=0.0;do{r=i|1;q=i|2;p=i|3;h=h+(+o[j+(i<<2)>>2]*+o[d+(i<<2)>>2]+ +o[j+(r<<2)>>2]*+o[d+(r<<2)>>2]+ +o[j+(q<<2)>>2]*+o[d+(q<<2)>>2]+ +o[j+(p<<2)>>2]*+o[d+(p<<2)>>2]);i=i+4|0}while((i|0)<=(n|0));if(m){i=l;do{h=h+ +o[j+(i<<2)>>2]*+o[d+(i<<2)>>2];i=i+1|0}while((i|0)!=(b|0))}o[e+(k<<2)>>2]=h*f+g;k=k+1|0}while((k|0)!=(a|0));return}function EFa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=92596;GFa(a);b=a+344|0;c=k[b>>2]|0;if(c|0?(d=c+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+348>>2]=0;b=k[a+332>>2]|0;c=b;if(b|0){d=a+336|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+320>>2]|0;c=b;if(b|0){d=a+324|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}b=k[a+308>>2]|0;c=b;if(b|0){d=a+312|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);ggb(b)}d=a+288|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+284>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+268|0;c=a+256|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+292>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+296>>2]|0;if(!((b|0)==(a+300|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+232|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+228>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+212|0;c=a+200|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+236>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+240>>2]|0;if(!((b|0)==(a+244|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+172|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+168>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+152|0;c=a+140|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+176>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+180>>2]|0;if(!((b|0)==(a+184|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+100|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+96>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+80|0;c=a+68|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+104>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+108>>2]|0;if((b|0)==(a+112|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function FFa(a){a=a|0;EFa(a);ggb(a);return}
function u5a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;l=n;m=b+4|0;h=k6(k[b>>2]|0,k[m>>2]|0,401026)|0;k[l>>2]=0;j=l+4|0;k[j>>2]=0;J6(h,l,l);h=k[l>>2]|0;c=k[a+448>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[l>>2]=0;if(h|0?(j=h+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[h+-8>>2]|0)}else{f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[l>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c){c=l+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[l>>2]=f;k[c>>2]=27;i[e+31>>0]=0;g=401031;h=f+27|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,l,401059,400562,198);k[c>>2]=0;k[l>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}}c=k6(k[b>>2]|0,k[m>>2]|0,401064)|0;a:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break a}case 2:break;default:{c=2147483647;break a}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+20>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,400630)|0;b:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break b}case 2:break;default:{c=2147483647;break b}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+28>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,400639)|0;c:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break c}case 2:break;default:{c=2147483647;break c}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+32>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,400644)|0;d:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break d}case 2:{d=+p[c+8>>3];break d}default:{d=1000000015047466219876688.0e6;break d}}while(0);o[a+24>>2]=d;c=k6(k[b>>2]|0,k[m>>2]|0,401178)|0;e:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break e}case 2:break;default:{c=2147483647;break e}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);i[a+36>>0]=(c|0)!=0&1;c=k6(k[b>>2]|0,k[m>>2]|0,401192)|0;f:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break f}case 2:break;default:{c=2147483647;break f}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);i[a+37>>0]=c>>>0<256?c:(c|0)>0?255:0;c=k6(k[b>>2]|0,k[m>>2]|0,401204)|0;if(!c){d=0.0;a=a+40|0;o[a>>2]=d;r=n;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+40|0;o[a>>2]=d;r=n;return}case 2:{d=+p[c+8>>3];a=a+40|0;o[a>>2]=d;r=n;return}default:{d=1000000015047466219876688.0e6;a=a+40|0;o[a>>2]=d;r=n;return}}}function v5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,m=0,n=0,p=0,q=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,ba=0,ca=0,da=0.0,ea=0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0;la=r;r=r+128|0;ja=la;ka=la+64|0;q=la+120|0;v=la+56|0;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[ka>>2]=k[f>>2];n=ka+4|0;b=f+4|0;k[n>>2]=k[b>>2];ia=ka+8|0;k[ia>>2]=k[f+8>>2];k[ka+12>>2]=k[f+12>>2];k[ka+16>>2]=k[f+16>>2];k[ka+20>>2]=k[f+20>>2];k[ka+24>>2]=k[f+24>>2];k[ka+28>>2]=k[f+28>>2];k[ka+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[ka+36>>2]=e;p=ka+40|0;k[p>>2]=ia;ia=ka+48|0;g=ka+44|0;k[g>>2]=ia;k[ka+52>>2]=0;k[ia>>2]=0;if(e|0){ia=e+12|0;k[ia>>2]=(k[ia>>2]|0)+1}if((k[b>>2]|0)<3){ga=k[f+44>>2]|0;ia=k[g>>2]|0;k[ia>>2]=k[ga>>2];k[ia+4>>2]=k[ga+4>>2];ia=p;break}k[n>>2]=0;x1(ka,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){h=k[f+40>>2]|0;m=k[p>>2]|0;f=k[f+44>>2]|0;e=k[g>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[h+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0));ia=p}else ia=p}else{Q1(ka,b,-1);ia=ka+40|0}while(0);s=a+16|0;b=k[ia>>2]|0;e=k[b+4>>2]|0;b=k[b>>2]|0;n=a+4|0;if(!(d>=1.0|(k[s>>2]|0)==0)){f=a+8|0;if(!(!((e|0)!=(k[n>>2]|0)?1:(b|0)!=(k[f>>2]|0))?(k[ka>>2]&4095|0)==(k[a+12>>2]|0):0))ha=14}else{f=a+8|0;ha=14}if((ha|0)==14){p=k[ka>>2]|0;k[n>>2]=e;k[f>>2]=b;k[a+12>>2]=p&4095;k[s>>2]=0;p=p>>>3&511;if((p+1|0)>>>0>=513){k[ja>>2]=0;b=ja+4|0;k[b>>2]=0;e=ZT(28)|0;k[e>>2]=1;g=e+4|0;k[ja>>2]=g;k[b>>2]=22;i[e+26>>0]=0;h=400975;m=g+22|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(m|0));Y8(-215,ja,400998,400562,133);k[b>>2]=0;k[ja>>2]=0;ga=k[e>>2]|0;k[e>>2]=ga+-1;if((ga|0)==1)ggb(k[e+-4>>2]|0);b=k[f>>2]|0;e=k[n>>2]|0}n=aa(e,b)|0;e=a+56|0;b=aa(aa((p*3|0)+6|0,k[a+28>>2]|0)|0,n)|0;if(!(((((k[a+60>>2]|0)<3?(k[a+64>>2]|0)==1:0)?(k[a+68>>2]|0)==(b|0):0)?(k[e>>2]&4095|0)==0:0)?(k[a+72>>2]|0)!=0:0)){k[ja>>2]=1;k[ja+4>>2]=b;G1(e,2,ja,0)}b=a+112|0;if(!(((((k[a+116>>2]|0)<3?(k[a+120>>2]|0)==1:0)?(k[a+124>>2]|0)==(n|0):0)?(k[b>>2]&4095|0)==0:0)?(k[a+128>>2]|0)!=0:0)){k[ja>>2]=1;k[ja+4>>2]=n;G1(b,2,ja,0)}e=a+168|0;if(!(((((k[a+172>>2]|0)<3?(k[a+176>>2]|0)==1:0)?(k[a+180>>2]|0)==(n|0):0)?(k[e>>2]&4095|0)==0:0)?(k[a+184>>2]|0)!=0:0)){k[ja>>2]=1;k[ja+4>>2]=n;G1(e,2,ja,0)}f=a+224|0;if(!(((((k[a+228>>2]|0)<3?(k[a+232>>2]|0)==1:0)?(k[a+236>>2]|0)==(n|0):0)?(k[f>>2]&4095|0)==0:0)?(k[a+240>>2]|0)!=0:0)){k[ja>>2]=1;k[ja+4>>2]=n;G1(f,2,ja,0)}g=a+280|0;if(!(((((k[a+284>>2]|0)<3?(k[a+288>>2]|0)==1:0)?(k[a+292>>2]|0)==(n|0):0)?(k[g>>2]&4095|0)==0:0)?(k[a+296>>2]|0)!=0:0)){k[ja>>2]=1;k[ja+4>>2]=n;G1(g,2,ja,0)}h=a+336|0;if(!(((((k[a+340>>2]|0)<3?(k[a+344>>2]|0)==1:0)?(k[a+348>>2]|0)==(n|0):0)?(k[h>>2]&4095|0)==0:0)?(k[a+352>>2]|0)!=0:0)){k[ja>>2]=1;k[ja+4>>2]=n;G1(h,2,ja,0)}m=a+392|0;if(!(((((k[a+396>>2]|0)<3?(k[a+400>>2]|0)==1:0)?(k[a+404>>2]|0)==(n|0):0)?(k[m>>2]&4095|0)==0:0)?(k[a+408>>2]|0)!=0:0)){k[ja>>2]=1;k[ja+4>>2]=n;G1(m,2,ja,0)}k[a+52>>2]=0;k[a+48>>2]=0;k[a+44>>2]=0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;k[ja+16>>2]=0;k[ja+20>>2]=0;k[ja+24>>2]=0;k[ja+28>>2]=0;oY(b,ja);k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;k[ja+16>>2]=0;k[ja+20>>2]=0;k[ja+24>>2]=0;k[ja+28>>2]=0;oY(e,ja);k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;k[ja+16>>2]=0;k[ja+20>>2]=0;k[ja+24>>2]=0;k[ja+28>>2]=0;oY(f,ja);k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;k[ja+16>>2]=0;k[ja+20>>2]=0;k[ja+24>>2]=0;k[ja+28>>2]=0;oY(g,ja);k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;k[ja+16>>2]=0;k[ja+20>>2]=0;k[ja+24>>2]=0;k[ja+28>>2]=0;oY(h,ja);k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;k[ja+16>>2]=0;k[ja+20>>2]=0;k[ja+24>>2]=0;k[ja+28>>2]=0;oY(m,ja);b=k[ia>>2]|0;e=k[b+4>>2]|0;b=k[b>>2]|0}k[q>>2]=e;k[q+4>>2]=b;x2(c,q,0,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[ja>>2]=k[g>>2];p=ja+4|0;b=g+4|0;k[p>>2]=k[b>>2];ga=ja+8|0;k[ga>>2]=k[g+8>>2];k[ja+12>>2]=k[g+12>>2];k[ja+16>>2]=k[g+16>>2];k[ja+20>>2]=k[g+20>>2];k[ja+24>>2]=k[g+24>>2];k[ja+28>>2]=k[g+28>>2];k[ja+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[ja+36>>2]=e;f=ja+40|0;k[f>>2]=ga;ga=ja+48|0;m=ja+44|0;k[m>>2]=ga;k[ja+52>>2]=0;k[ga>>2]=0;if(e|0){ga=e+12|0;k[ga>>2]=(k[ga>>2]|0)+1}if((k[b>>2]|0)<3){ea=k[g+44>>2]|0;ga=k[m>>2]|0;k[ga>>2]=k[ea>>2];k[ga+4>>2]=k[ea+4>>2];break}k[p>>2]=0;x1(ja,k[b>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[m>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[n+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0))}}else Q1(ja,c,-1);while(0);ga=k[s>>2]|0;b=ga+1|0;k[s>>2]=b;if(!(d>=0.0&(ga|0)>0)){ga=b<<1;ea=k[a+20>>2]|0;d=1.0/+(((ea|0)<(ga|0)?ea:ga)|0)}if(!(d>=0.0)){k[v>>2]=0;b=v+4|0;k[b>>2]=0;e=ZT(24)|0;k[e>>2]=1;g=e+4|0;k[v>>2]=g;k[b>>2]=17;i[e+21>>0]=0;h=400932;m=g+17|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(m|0));Y8(-215,v,400950,400562,573);k[b>>2]=0;k[v>>2]=0;ga=k[e>>2]|0;k[e>>2]=ga+-1;if((ga|0)==1)ggb(k[e+-4>>2]|0)}b=a+44|0;e=a+48|0;f=a+52|0;ca=k[a+28>>2]|0;da=+o[a+24>>2];ea=k[a+32>>2]|0;fa=+o[a+40>>2];h=j[a+36>>1]|0;ga=(h&65535)>>>8&255;W=k[a+72>>2]|0;X=k[a+408>>2]|0;Y=k[a+352>>2]|0;Z=k[a+296>>2]|0;$=k[a+240>>2]|0;ba=k[a+184>>2]|0;U=k[a+128>>2]|0;g=(k[ka>>2]|0)>>>3&511;V=g+1|0;u=+_(+(1.0-d));Q=~~(-.35667494393873245/u);p=Q+1|0;m=~~(-.916290731874155/u)-p|0;p=(p|0)/(ca|0)|0;O=p+1|0;n=(m+1|0)/(ca|0)|0;P=n+1|0;m=(~~(-2.3025850929940455/u)+1+~Q+~m|0)/(ca|0)|0;Q=m+1|0;R=k[b>>2]|0;S=k[e>>2]|0;T=k[f>>2]|0;k[f>>2]=T+1;k[e>>2]=S+1;k[b>>2]=R+1;if((T|0)>=(p|0))k[f>>2]=0;if((S|0)>=(n|0))k[e>>2]=0;if((R|0)>=(m|0))k[b>>2]=0;J=ka+8|0;b=k[J>>2]|0;if((b|0)>0){K=ka+12|0;L=ka+16|0;M=ka+44|0;E=g+2|0;F=aa(E,ca)|0;G=ca*3|0;H=(ca|0)>0;I=(V|0)==3;D=H&(h&255)<<24>>24!=0;B=ca<<1;C=ca+-1|0;A=(m|0)==(R|0);z=(n|0)==(S|0);w=(p|0)==(T|0);x=ja+16|0;y=ja+44|0;a=0;f=0;e=k[K>>2]|0;do{if((e|0)>0){v=0;do{s=k[M>>2]|0;p=(k[L>>2]|0)+(aa(k[s>>2]|0,a)|0)|0;s=p+(aa(k[s+4>>2]|0,v)|0)|0;p=f*3|0;n=aa(F,p)|0;a:do if(H){if(I){d=+(l[s>>0]|0);t=+(l[s+1>>0]|0);u=+(l[s+2>>0]|0);b=0;e=0;h=0;while(1){g=W+((aa(h,E)|0)+n)|0;na=+(l[g>>0]|0)-d;ma=+(l[g+1>>0]|0)-t;oa=+(l[g+2>>0]|0)-u;do if(oa*oa+(na*na+ma*ma)<da){b=b+1|0;if(!(i[g+3>>0]|0))break;e=e+1|0;if((e|0)>=(ea|0)){q=1;c=1;break a}}while(0);h=h+1|0;if((h|0)>=(G|0)){ha=100;break a}}}else{b=0;e=0;m=0}while(1){h=W+((aa(m,E)|0)+n)|0;g=0;d=0.0;do{oa=+(l[h+g>>0]|0)-+(l[s+g>>0]|0);d=d+oa*oa;g=g+1|0}while((g|0)!=(V|0));do if(d<da){b=b+1|0;if(!(i[h+V>>0]|0))break;e=e+1|0;if((e|0)>=(ea|0)){q=1;c=1;break a}}while(0);m=m+1|0;if((m|0)>=(G|0)){ha=100;break}}}else{b=0;ha=100}while(0);b:do if((ha|0)==100){ha=0;c=(b|0)>=(ea|0)&1;if(D){h=0;b=0;while(1){g=W+((aa(h,E)|0)+n)|0;do if(i[g+V>>0]|0){e=0;d=0.0;t=0.0;do{oa=+(l[g+e>>0]|0);t=t+ +(l[s+e>>0]|0)*oa;d=d+oa*oa;e=e+1|0}while((e|0)!=(V|0));if(d==0.0){q=0;break b}if(!(t<=d)|!(t>=fa*d))break;t=t/d;e=0;d=0.0;do{oa=t*+(l[g+e>>0]|0)-+(l[s+e>>0]|0);d=d+oa*oa;e=e+1|0}while((e|0)!=(V|0));if(!(d<t*(da*t)))break;b=b+1|0;if((b|0)>=(ea|0)){q=2;break b}}while(0);h=h+1|0;if((h|0)>=(G|0)){q=0;break}}}else q=0}while(0);b=aa(p,ca)|0;e=$+f|0;h=ba+f|0;m=aa(b+ca+(l[h>>0]|0)|0,E)|0;n=U+f|0;p=aa((l[n>>0]|0)+b|0,E)|0;g=X+f|0;if((l[g>>0]|0)==(R|0)){upb(W+(aa(b+B+(l[e>>0]|0)|0,E)|0)|0,W+m|0,E|0)|0;b=l[e>>0]|0;i[e>>0]=(b|0)<(C|0)?b+1&255:0}if(A){b=428e3;b=Epb(k[b>>2]|0,k[b+4>>2]|0,1284865837,1481765933)|0;b=kpb(b|0,N|0,1,0)|0;e=N;pa=428e3;k[pa>>2]=b;k[pa+4>>2]=e;e=ppb(b|0,e|0,33)|0;i[g>>0]=(e|0)%(Q|0)|0}b=Y+f|0;if((l[b>>0]|0)==(S|0)){upb(W+m|0,W+p|0,E|0)|0;pa=l[h>>0]|0;i[h>>0]=(pa|0)<(C|0)?pa+1&255:0}if(z){m=428e3;m=Epb(k[m>>2]|0,k[m+4>>2]|0,1284865837,1481765933)|0;m=kpb(m|0,N|0,1,0)|0;pa=N;h=428e3;k[h>>2]=m;k[h+4>>2]=pa;pa=ppb(m|0,pa|0,33)|0;i[b>>0]=(pa|0)%(P|0)|0}b=Z+f|0;if((l[b>>0]|0)==(T|0)){upb(W+p|0,s|0,E|0)|0;i[W+(p+V)>>0]=c;pa=l[n>>0]|0;i[n>>0]=(pa|0)<(C|0)?pa+1&255:0}if(w){s=428e3;s=Epb(k[s>>2]|0,k[s+4>>2]|0,1284865837,1481765933)|0;s=kpb(s|0,N|0,1,0)|0;pa=N;c=428e3;k[c>>2]=s;k[c+4>>2]=pa;pa=ppb(s|0,pa|0,33)|0;i[b>>0]=(pa|0)%(O|0)|0}switch(q&3){case 0:{pa=k[y>>2]|0;pa=(k[x>>2]|0)+(aa(k[pa>>2]|0,a)|0)+(aa(k[pa+4>>2]|0,v)|0)|0;i[pa>>0]=-1;break}case 1:{pa=k[y>>2]|0;pa=(k[x>>2]|0)+(aa(k[pa>>2]|0,a)|0)+(aa(k[pa+4>>2]|0,v)|0)|0;i[pa>>0]=0;break}case 2:{pa=k[y>>2]|0;pa=(k[x>>2]|0)+(aa(k[pa>>2]|0,a)|0)+(aa(k[pa+4>>2]|0,v)|0)|0;i[pa>>0]=ga;break}default:{}}f=f+1|0;v=v+1|0;e=k[K>>2]|0}while((v|0)<(e|0));b=k[J>>2]|0}a=a+1|0}while((a|0)<(b|0))}f=ja+36|0;b=k[f>>2]|0;if(b|0?(ha=b+12|0,pa=k[ha>>2]|0,k[ha>>2]=pa+-1,(pa|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[ja+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;pa=ja+16|0;e=ja+4|0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[e>>2]|0)>0){f=k[ja+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[ja+44>>2]|0;if(!((b|0)==(ja+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ka+36|0;b=k[f>>2]|0;if(b|0?(ja=b+12|0,pa=k[ja>>2]|0,k[ja>>2]=pa+-1,(pa|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[ka+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;pa=ka+16|0;f=ka+4|0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[f>>2]|0)>0){e=k[ia>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[ka+44>>2]|0;if((b|0)==(ka+48|0)|(b|0)==0){r=la;return}ggb(k[b+-4>>2]|0);r=la;return}function w5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+128|0;v=B+104|0;y=B+48|0;s=B;t=B+32|0;u=a+12|0;g=(k[u>>2]|0)>>>3&511;p=g+1|0;e=k[a+4>>2]|0;f=k[a+8>>2]|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[s+16>>2]=0;k[s+20>>2]=0;k[s+24>>2]=0;k[s+28>>2]=0;k[y>>2]=1124007936;A=y+4|0;q=y+8|0;w=y+40|0;c=A;d=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));k[w>>2]=q;z=y+48|0;x=y+44|0;k[x>>2]=z;k[y+52>>2]=0;k[z>>2]=0;k[v>>2]=f;k[v+4>>2]=e;G1(y,2,v,16);oY(y,s);j=g+2|0;l=a+28|0;m=aa(j*3|0,k[l>>2]|0)|0;if((k[q>>2]|0)>0){n=y+12|0;o=y+16|0;h=0;d=k[a+72>>2]|0;c=k[n>>2]|0;do{if((c|0)>0){a=0;do{e=k[l>>2]|0;a:do if((e|0)>0){f=e*3|0;e=0;while(1){g=d+(aa(e,j)|0)|0;e=e+1|0;if(i[g+p>>0]|0)break;if((e|0)>=(f|0))break a}c=(k[o>>2]|0)+(aa(k[k[x>>2]>>2]|0,h)|0)|0;e=i[g+1>>0]|0;f=i[g+2>>0]|0;i[c+(a*3|0)>>0]=i[g>>0]|0;i[c+(a*3|0)+1>>0]=e;i[c+(a*3|0)+2>>0]=f;c=k[n>>2]|0}while(0);d=d+m|0;a=a+1|0}while((a|0)<(c|0))}h=h+1|0}while((h|0)<(k[q>>2]|0))}switch((k[u>>2]|0)>>>3&511){case 0:{k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=y;u=t+4|0;q=u+4|0;k[q>>2]=0;k[q+4>>2]=0;k[t>>2]=33882112;k[u>>2]=v;FV(s,t);mY(k[v>>2]|0,b);zF(v);break}case 2:{mY(y,b);break}default:{k[v>>2]=0;u=v+4|0;k[u>>2]=0;c=ZT(8)|0;k[c>>2]=1;t=c+4|0;k[v>>2]=t;k[u>>2]=0;i[t>>0]=0;Y8(-210,v,400839,400562,640);k[u>>2]=0;k[v>>2]=0;v=k[c>>2]|0;k[c>>2]=v+-1;if((v|0)==1)ggb(k[c+-4>>2]|0)}}e=y+36|0;c=k[e>>2]|0;if(c|0?(u=c+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;y=y+16|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[A>>2]|0)>0){d=k[w>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[A>>2]|0))}c=k[x>>2]|0;if((c|0)==(z|0)|(c|0)==0){r=B;return}ggb(k[c+-4>>2]|0);r=B;return}function x5a(a){a=a|0;return k[a+20>>2]|0}function y5a(a,b){a=a|0;b=b|0;k[a+20>>2]=b;return}function z5a(a){a=a|0;return k[a+28>>2]|0}function A5a(a,b){a=a|0;b=b|0;k[a+28>>2]=b;return}function B5a(a){a=a|0;return +(+o[a+24>>2])}function C5a(a,b){a=a|0;b=+b;o[a+24>>2]=b;return}function D5a(a){a=a|0;return k[a+32>>2]|0}function E5a(a,b){a=a|0;b=b|0;k[a+32>>2]=b;return}function F5a(a){a=a|0;return (i[a+36>>0]|0)!=0|0}function G5a(a,b){a=a|0;b=b|0;i[a+36>>0]=b&1;return}function H5a(a){a=a|0;return l[a+37>>0]|0|0}function I5a(a,b){a=a|0;b=b|0;i[a+37>>0]=b;return}function J5a(a){a=a|0;return +(+o[a+40>>2])}function K5a(a,b){a=a|0;b=+b;o[a+40>>2]=b;return}function L5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function M5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+o[b>>2]);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function N5a(a){a=a|0;ggb(a);return}function O5a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function P5a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=151860;d=a+184|0;b=k[d>>2]|0;k[a+188>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+108|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+104>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+88|0;c=a+76|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+112>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+116>>2]|0;if(!((b|0)==(a+120|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+52|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+48>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+32|0;c=a+20|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+56>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+60>>2]|0;if((b|0)==(a+64|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Q5a(a){a=a|0;P5a(a);ggb(a);return}function R5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,q=0;q=r;r=r+16|0;o=q+8|0;m=q+4|0;n=q;j=o+4|0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[o>>2]=c;k[j>>2]=4;i[h+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;c=z6(b,o)|0;b=k[o>>2]|0;k[j>>2]=0;k[o>>2]=0;if(b|0?(h=b+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[b+-8>>2]|0);b=z6(c,a+184|0)|0;k[o>>2]=0;j=o+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[o>>2]=c;k[j>>2]=7;i[h+11>>0]=0;i[c>>0]=i[401064]|0;i[c+1>>0]=i[401065]|0;i[c+2>>0]=i[401066]|0;i[c+3>>0]=i[401067]|0;i[c+4>>0]=i[401068]|0;i[c+5>>0]=i[401069]|0;i[c+6>>0]=i[401070]|0;b=z6(b,o)|0;c=k[o>>2]|0;k[j>>2]=0;k[o>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=t6a(b,a+132|0)|0;k[o>>2]=0;d=o+4|0;k[d>>2]=0;h=ZT(16)|0;k[h>>2]=1;g=h+4|0;k[o>>2]=g;k[d>>2]=9;i[h+13>>0]=0;h=401072;j=g+9|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));b=z6(b,o)|0;c=k[o>>2]|0;k[d>>2]=0;k[o>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=t6a(b,a+136|0)|0;k[o>>2]=0;d=o+4|0;k[d>>2]=0;h=ZT(20)|0;k[h>>2]=1;g=h+4|0;k[o>>2]=g;k[d>>2]=15;i[h+19>>0]=0;h=401082;j=g+15|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));b=z6(b,o)|0;c=k[o>>2]|0;k[d>>2]=0;k[o>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=u6a(b,a+152|0)|0;k[o>>2]=0;c=o+4|0;k[c>>2]=0;h=ZT(20)|0;k[h>>2]=1;g=h+4|0;k[o>>2]=g;k[c>>2]=12;i[h+16>>0]=0;h=401098;j=g+12|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));f=z6(b,o)|0;b=k[o>>2]|0;k[c>>2]=0;k[o>>2]=0;if(b|0?(h=b+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[b+-8>>2]|0);d=a+144|0;if(Xh[k[(k[f>>2]|0)+12>>2]&1023](f)|0){e=f+32|0;if((k[e>>2]|0)==6){b=o+4|0;c=ZT(36)|0;k[c>>2]=1;g=c+4|0;k[o>>2]=g;k[b>>2]=30;i[c+34>>0]=0;h=401220;j=g+30|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-2,o,401251,401262,1064);k[b>>2]=0;k[o>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0)}if(!(k[f+16>>2]|0))b=0;else{b=k[f+12>>2]|0;b=(b|0)==0?1016759:b}u6(k[f+8>>2]|0,b,+p[d>>3]);if(k[e>>2]&4|0)k[e>>2]=6}k[o>>2]=0;d=o+4|0;k[d>>2]=0;h=ZT(20)|0;k[h>>2]=1;g=h+4|0;k[o>>2]=g;k[d>>2]=15;i[h+19>>0]=0;h=401111;j=g+15|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));b=z6(f,o)|0;c=k[o>>2]|0;k[d>>2]=0;k[o>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=u6a(b,a+156|0)|0;k[o>>2]=0;j=o+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[o>>2]=c;k[j>>2]=7;i[h+11>>0]=0;i[c>>0]=i[401127]|0;i[c+1>>0]=i[401128]|0;i[c+2>>0]=i[401129]|0;i[c+3>>0]=i[401130]|0;i[c+4>>0]=i[401131]|0;i[c+5>>0]=i[401132]|0;i[c+6>>0]=i[401133]|0;b=z6(b,o)|0;c=k[o>>2]|0;k[j>>2]=0;k[o>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=u6a(b,a+160|0)|0;k[o>>2]=0;j=o+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[o>>2]=c;k[j>>2]=6;i[h+10>>0]=0;i[c>>0]=i[401135]|0;i[c+1>>0]=i[401136]|0;i[c+2>>0]=i[401137]|0;i[c+3>>0]=i[401138]|0;i[c+4>>0]=i[401139]|0;i[c+5>>0]=i[401140]|0;b=z6(b,o)|0;c=k[o>>2]|0;k[j>>2]=0;k[o>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=u6a(b,a+164|0)|0;k[o>>2]=0;j=o+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[o>>2]=c;k[j>>2]=6;i[h+10>>0]=0;i[c>>0]=i[401142]|0;i[c+1>>0]=i[401143]|0;i[c+2>>0]=i[401144]|0;i[c+3>>0]=i[401145]|0;i[c+4>>0]=i[401146]|0;i[c+5>>0]=i[401147]|0;b=z6(b,o)|0;c=k[o>>2]|0;k[j>>2]=0;k[o>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=u6a(b,a+168|0)|0;k[o>>2]=0;d=o+4|0;k[d>>2]=0;h=ZT(36)|0;k[h>>2]=1;g=h+4|0;k[o>>2]=g;k[d>>2]=28;i[h+32>>0]=0;h=401149;j=g+28|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));b=z6(b,o)|0;c=k[o>>2]|0;k[d>>2]=0;k[o>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=u6a(b,a+172|0)|0;d=o+4|0;h=ZT(20)|0;k[h>>2]=1;g=h+4|0;k[o>>2]=g;k[d>>2]=13;i[h+17>>0]=0;h=401178;j=g+13|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));b=z6(b,o)|0;c=k[o>>2]|0;k[d>>2]=0;k[o>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);k[m>>2]=l[a+176>>0];b=t6a(b,m)|0;d=o+4|0;h=ZT(16)|0;k[h>>2]=1;g=h+4|0;k[o>>2]=g;k[d>>2]=11;i[h+15>>0]=0;h=401192;j=g+11|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));b=z6(b,o)|0;c=k[o>>2]|0;k[d>>2]=0;k[o>>2]=0;if(c|0?(j=c+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);k[n>>2]=l[a+177>>0];b=t6a(b,n)|0;d=o+4|0;h=ZT(20)|0;k[h>>2]=1;g=h+4|0;k[o>>2]=g;k[d>>2]=15;i[h+19>>0]=0;h=401204;j=g+15|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));b=z6(b,o)|0;c=k[o>>2]|0;k[d>>2]=0;k[o>>2]=0;if(!c){o=a+180|0;u6a(b,o)|0;r=q;return}n=c+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1){o=a+180|0;u6a(b,o)|0;r=q;return}ggb(k[c+-8>>2]|0);o=a+180|0;u6a(b,o)|0;r=q;return}function S5a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;l=n;m=b+4|0;h=k6(k[b>>2]|0,k[m>>2]|0,401026)|0;k[l>>2]=0;j=l+4|0;k[j>>2]=0;J6(h,l,l);h=k[l>>2]|0;c=k[a+184>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[l>>2]=0;if(h|0?(j=h+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[h+-8>>2]|0)}else{f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[l>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c){c=l+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[l>>2]=f;k[c>>2]=27;i[e+31>>0]=0;g=401031;h=f+27|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,l,401059,400858,304);k[c>>2]=0;k[l>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}}c=k6(k[b>>2]|0,k[m>>2]|0,401064)|0;a:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break a}case 2:break;default:{c=2147483647;break a}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+132>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,401072)|0;b:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break b}case 2:break;default:{c=2147483647;break b}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+136>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,401082)|0;c:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break c}case 2:{d=+p[c+8>>3];break c}default:{d=1000000015047466219876688.0e6;break c}}while(0);o[a+152>>2]=d;c=k6(k[b>>2]|0,k[m>>2]|0,401098)|0;d:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break d}case 2:{d=+p[c+8>>3];break d}default:{d=1.e+300;break d}}while(0);p[a+144>>3]=d;c=k6(k[b>>2]|0,k[m>>2]|0,401111)|0;e:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break e}case 2:{d=+p[c+8>>3];break e}default:{d=1000000015047466219876688.0e6;break e}}while(0);o[a+156>>2]=d;c=k6(k[b>>2]|0,k[m>>2]|0,401127)|0;f:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break f}case 2:{d=+p[c+8>>3];break f}default:{d=1000000015047466219876688.0e6;break f}}while(0);o[a+160>>2]=d;c=k6(k[b>>2]|0,k[m>>2]|0,401135)|0;g:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break g}case 2:{d=+p[c+8>>3];break g}default:{d=1000000015047466219876688.0e6;break g}}while(0);o[a+164>>2]=d;c=k6(k[b>>2]|0,k[m>>2]|0,401142)|0;h:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break h}case 2:{d=+p[c+8>>3];break h}default:{d=1000000015047466219876688.0e6;break h}}while(0);o[a+168>>2]=d;c=k6(k[b>>2]|0,k[m>>2]|0,401149)|0;i:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break i}case 2:{d=+p[c+8>>3];break i}default:{d=1000000015047466219876688.0e6;break i}}while(0);o[a+172>>2]=d;c=k6(k[b>>2]|0,k[m>>2]|0,401178)|0;j:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break j}case 2:break;default:{c=2147483647;break j}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);i[a+176>>0]=(c|0)!=0&1;c=k6(k[b>>2]|0,k[m>>2]|0,401192)|0;k:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break k}case 2:break;default:{c=2147483647;break k}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);i[a+177>>0]=c>>>0<256?c:(c|0)>0?255:0;c=k6(k[b>>2]|0,k[m>>2]|0,401204)|0;if(!c){d=0.0;a=a+180|0;o[a>>2]=d;r=n;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+180|0;o[a>>2]=d;r=n;return}case 2:{d=+p[c+8>>3];a=a+180|0;o[a>>2]=d;r=n;return}default:{d=1000000015047466219876688.0e6;a=a+180|0;o[a>>2]=d;r=n;return}}}function T5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0;A=r;r=r+208|0;z=A;g=A+200|0;u=A+192|0;y=A+136|0;w=A+128|0;x=A+56|0;v=a+128|0;do if(!(d>=1.0|(k[v>>2]|0)==0)){R1(z,b,-1);e=a+4|0;f=a+8|0;if(!((k[z>>2]|0)!=(k[e>>2]|0)?1:(k[z+4>>2]|0)!=(k[f>>2]|0))?(s=S1(b,-1)|0,(s|0)==(k[a+12>>2]|0)):0)break;else{s=f;t=6;break}}else{e=a+4|0;s=a+8|0;t=6}while(0);if((t|0)==6){R1(g,b,-1);q=S1(b,-1)|0;k[e>>2]=k[g>>2];k[s>>2]=k[g+4>>2];k[a+12>>2]=q;k[v>>2]=0;q=q>>>3&511;if((q+1|0)>>>0>=513){f=z+4|0;g=ZT(28)|0;k[g>>2]=1;l=g+4|0;k[z>>2]=l;k[f>>2]=22;i[g+26>>0]=0;m=400975;n=l+22|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,z,400998,400858,192);k[f>>2]=0;k[z>>2]=0;n=k[g>>2]|0;k[g>>2]=n+-1;if((n|0)==1)ggb(k[g+-4>>2]|0)}h=a+136|0;f=k[h>>2]|0;if((f|0)<256)h=f;else{f=z+4|0;g=ZT(24)|0;k[g>>2]=1;l=g+4|0;k[z>>2]=l;k[f>>2]=16;i[g+20>>0]=0;m=401009;n=l+16|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,z,400998,400858,193);k[f>>2]=0;k[z>>2]=0;n=k[g>>2]|0;k[g>>2]=n+-1;if((n|0)==1)ggb(k[g+-4>>2]|0);h=k[h>>2]|0}l=a+16|0;g=k[s>>2]|0;f=k[e>>2]|0;h=aa(aa(aa(g,q+3|0)|0,f)|0,h)|0;if(!(((((k[a+20>>2]|0)<3?(k[a+24>>2]|0)==1:0)?(k[a+28>>2]|0)==(h|0):0)?(k[l>>2]&4095|0)==5:0)?(k[a+32>>2]|0)!=0:0)){k[z>>2]=1;k[z+4>>2]=h;G1(l,2,z,5);g=k[s>>2]|0;f=k[e>>2]|0}e=a+72|0;if(!(((((k[a+76>>2]|0)<3?(k[a+80>>2]|0)==(g|0):0)?(k[a+84>>2]|0)==(f|0):0)?(k[e>>2]&4095|0)==0:0)?(k[a+88>>2]|0)!=0:0))t=25;if((t|0)==25){k[z>>2]=g;k[z+4>>2]=f;G1(e,2,z,0)};k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;k[z+16>>2]=0;k[z+20>>2]=0;k[z+24>>2]=0;k[z+28>>2]=0;oY(e,z)}do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[z>>2]=k[g>>2];q=z+4|0;f=g+4|0;k[q>>2]=k[f>>2];t=z+8|0;k[t>>2]=k[g+8>>2];k[z+12>>2]=k[g+12>>2];k[z+16>>2]=k[g+16>>2];k[z+20>>2]=k[g+20>>2];k[z+24>>2]=k[g+24>>2];k[z+28>>2]=k[g+28>>2];k[z+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[z+36>>2]=e;n=z+40|0;k[n>>2]=t;t=z+48|0;h=z+44|0;k[h>>2]=t;k[z+52>>2]=0;k[t>>2]=0;if(e|0){t=e+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[f>>2]|0)<3){t=k[g+44>>2]|0;s=k[h>>2]|0;k[s>>2]=k[t>>2];k[s+4>>2]=k[t+4>>2];s=n;break}k[q>>2]=0;x1(z,k[f>>2]|0,0,0,0);if((k[q>>2]|0)>0){l=k[g+40>>2]|0;m=k[n>>2]|0;g=k[g+44>>2]|0;f=k[h>>2]|0;e=0;do{k[m+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[q>>2]|0));s=n}else s=n}else{Q1(z,b,-1);s=z+40|0}while(0);b=k[s>>2]|0;t=k[b>>2]|0;k[u>>2]=k[b+4>>2];k[u+4>>2]=t;x2(c,u,0,0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[y>>2]=k[h>>2];q=y+4|0;e=h+4|0;k[q>>2]=k[e>>2];u=y+8|0;k[u>>2]=k[h+8>>2];k[y+12>>2]=k[h+12>>2];k[y+16>>2]=k[h+16>>2];k[y+20>>2]=k[h+20>>2];k[y+24>>2]=k[h+24>>2];k[y+28>>2]=k[h+28>>2];k[y+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[y+36>>2]=f;g=y+40|0;k[g>>2]=u;u=y+48|0;m=y+44|0;k[m>>2]=u;k[y+52>>2]=0;k[u>>2]=0;if(f|0){u=f+12|0;k[u>>2]=(k[u>>2]|0)+1}if((k[e>>2]|0)<3){c=k[h+44>>2]|0;u=k[m>>2]|0;k[u>>2]=k[c>>2];k[u+4>>2]=k[c+4>>2];break}k[q>>2]=0;x1(y,k[e>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[h+40>>2]|0;l=k[g>>2]|0;g=k[h+44>>2]|0;f=k[m>>2]|0;e=0;do{k[l+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[q>>2]|0))}}else Q1(y,c,-1);while(0);u=k[v>>2]|0;e=u+1|0;k[v>>2]=e;if(!(d>=0.0&(u|0)>0)){v=e<<1;u=k[a+132>>2]|0;d=1.0/+(((u|0)<(v|0)?u:v)|0)}if(!(d>=0.0)){k[w>>2]=0;e=w+4|0;k[e>>2]=0;f=ZT(24)|0;k[f>>2]=1;l=f+4|0;k[w>>2]=l;k[e>>2]=17;i[f+21>>0]=0;m=400932;n=l+17|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,w,400950,400858,855);k[e>>2]=0;k[w>>2]=0;v=k[f>>2]|0;k[f>>2]=v+-1;if((v|0)==1)ggb(k[f+-4>>2]|0)}b=k[z+8>>2]|0;k[w>>2]=0;k[w+4>>2]=b;q=k[a+32>>2]|0;c=k[a+136>>2]|0;b=aa(c<<3,b)|0;b=q+(aa(b,k[z+12>>2]|0)|0)|0;t=k[a+88>>2]|0;E=+p[a+144>>3];u=k[a+152>>2]|0;v=k[a+156>>2]|0;e=k[a+160>>2]|0;C=+o[a+164>>2];D=+o[a+168>>2];B=-(d*+o[a+172>>2]);g=k[a+180>>2]|0;h=j[a+176>>1]|0;k[x>>2]=152004;k[x+4>>2]=z;k[x+8>>2]=y;k[x+12>>2]=q;k[x+16>>2]=b;k[x+20>>2]=t;k[x+24>>2]=c;o[x+28>>2]=d;o[x+32>>2]=E;k[x+36>>2]=u;k[x+40>>2]=v;k[x+44>>2]=e;o[x+48>>2]=C>D?D:C;o[x+52>>2]=C<D?D:C;o[x+56>>2]=B;k[x+60>>2]=g;i[x+64>>0]=h;i[x+65>>0]=(h&65535)>>>8;h=z+4|0;s6a(x,w);g=y+36|0;e=k[g>>2]|0;if(e|0?(w=e+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[y+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;x=y+16|0;f=y+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[f>>2]|0)>0){g=k[y+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[y+44>>2]|0;if(!((e|0)==(y+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=z+36|0;e=k[g>>2]|0;if(e|0?(x=e+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[z+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;y=z+16|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[h>>2]|0)>0){f=k[s>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[h>>2]|0))}e=k[z+44>>2]|0;if((e|0)==(z+48|0)|(e|0)==0){r=A;return}ggb(k[e+-4>>2]|0);r=A;return}function U5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0.0,p=0.0,q=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;L=r;r=r+96|0;l=L+88|0;K=L+32|0;m=L;s=(k[a+12>>2]|0)>>>3;q=s&511;F=q+1|0;if(!((q|0)==0|(F|0)==3)){c=l+4|0;d=ZT(40)|0;k[d>>2]=1;h=d+4|0;k[l>>2]=h;k[c>>2]=32;i[d+36>>0]=0;e=400806;j=h+32|0;do{i[h>>0]=i[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(j|0));Y8(-215,l,400839,400858,882);k[c>>2]=0;k[l>>2]=0;J=k[d>>2]|0;k[d>>2]=J+-1;if((J|0)==1)ggb(k[d+-4>>2]|0)}f=a+4|0;c=k[f>>2]|0;g=a+8|0;d=k[g>>2]|0;e=q<<3;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[m+16>>2]=0;k[m+20>>2]=0;k[m+24>>2]=0;k[m+28>>2]=0;k[K>>2]=1124007936;J=K+4|0;E=K+8|0;G=K+40|0;h=J;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[G>>2]=E;I=K+48|0;H=K+44|0;k[H>>2]=I;k[K+52>>2]=0;k[I>>2]=0;k[l>>2]=d;k[l+4>>2]=c;G1(K,2,l,e);oY(K,m);D=k[a+32>>2]|0;C=aa(k[g>>2]|0,k[f>>2]|0)|0;B=a+136|0;C=D+((aa(C,k[B>>2]|0)|0)<<3)|0;d=F<<2;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}zpb(c|0,0,(q<<2)+4|0)|0;if((k[E>>2]|0)>0){y=K+12|0;z=a+88|0;A=a+116|0;d=s&65535;v=K+16|0;w=c+4|0;x=c+8|0;q=a+152|0;s=(d&511)==0;a=(d&511)==2;d=0;m=0;e=k[y>>2]|0;do{a:do if((e|0)>0){if(s){j=0;while(1){l=(k[z>>2]|0)+(aa(k[k[A>>2]>>2]|0,m)|0)+j|0;l=i[l>>0]|0;h=(l&255)+d|0;if(!(l<<24>>24))n=0.0;else{g=d;n=0.0;do{p=+o[D+(g<<3)>>2];f=aa(g,F)|0;e=0;do{l=c+(e<<2)|0;o[l>>2]=p*+o[C+(e+f<<2)>>2]+ +o[l>>2];e=e+1|0}while((e|0)!=(F|0));n=n+p;g=g+1|0}while((g|0)<(h|0)?!(n>+o[q>>2]):0)}e=(k[v>>2]|0)+(aa(k[k[H>>2]>>2]|0,m)|0)+j|0;i[e>>0]=~~(1.0/n*+o[c>>2]);o[c>>2]=0.0;d=(k[B>>2]|0)+d|0;j=j+1|0;e=k[y>>2]|0;if((j|0)>=(e|0))break a}}else l=0;do{h=(k[z>>2]|0)+(aa(k[k[A>>2]>>2]|0,m)|0)+l|0;h=i[h>>0]|0;j=(h&255)+d|0;if(!(h<<24>>24))n=0.0;else{h=d;n=0.0;do{p=+o[D+(h<<3)>>2];g=aa(h,F)|0;f=0;do{M=c+(f<<2)|0;o[M>>2]=p*+o[C+(f+g<<2)>>2]+ +o[M>>2];f=f+1|0}while((f|0)!=(F|0));n=n+p;h=h+1|0}while((h|0)<(j|0)?!(n>+o[q>>2]):0)}p=1.0/n;if(a){h=(k[v>>2]|0)+(aa(k[k[H>>2]>>2]|0,m)|0)|0;n=p*+o[c>>2];t=p*+o[w>>2];p=p*+o[x>>2];e=(o[u>>2]=n,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;n=e?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=e?-0.0:0.0}g=~~n;g=(g>>>0<256?g:(g|0)>0?255:0)&255;e=(o[u>>2]=t,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;n=e?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(n==0.0)n=e?-0.0:0.0}else n=t;f=~~n;f=(f>>>0<256?f:(f|0)>0?255:0)&255;e=(o[u>>2]=p,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;n=e?p+-8388608.0+8388608.0:p+8388608.0+-8388608.0;if(n==0.0)n=e?-0.0:0.0}else n=p;e=~~n;i[h+(l*3|0)>>0]=g;i[h+(l*3|0)+1>>0]=f;i[h+(l*3|0)+2>>0]=e>>>0<256?e:(e|0)>0?255:0;o[c>>2]=0.0;e=w;k[e>>2]=0;k[e+4>>2]=0;e=k[y>>2]|0}d=(k[B>>2]|0)+d|0;l=l+1|0}while((l|0)<(e|0))}while(0);m=m+1|0}while((m|0)<(k[E>>2]|0))}mY(K,b);if(c|0)ggb(c);e=K+36|0;c=k[e>>2]|0;if(c|0?(F=c+12|0,M=k[F>>2]|0,k[F>>2]=M+-1,(M|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[K+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;M=K+16|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[J>>2]|0)>0){d=k[G>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[J>>2]|0))}c=k[H>>2]|0;if((c|0)==(I|0)|(c|0)==0){r=L;return}ggb(k[c+-4>>2]|0);r=L;return}function V5a(a){a=a|0;return k[a+132>>2]|0}function W5a(a,b){a=a|0;b=b|0;k[a+132>>2]=b;return}function X5a(a){a=a|0;return k[a+136>>2]|0}function Y5a(a,b){a=a|0;b=b|0;k[a+136>>2]=b;return}function Z5a(a){a=a|0;return +(+o[a+152>>2])}function _5a(a,b){a=a|0;b=+b;o[a+152>>2]=b;return}function $5a(a){a=a|0;return +(+p[a+144>>3])}function a6a(a,b){a=a|0;b=+b;p[a+144>>3]=b;return}function b6a(a){a=a|0;return +(+o[a+156>>2])}function c6a(a,b){a=a|0;b=+b;o[a+156>>2]=b;return}function d6a(a){a=a|0;return +(+o[a+160>>2])}function e6a(a,b){a=a|0;b=+b;o[a+160>>2]=b;return}function f6a(a){a=a|0;return +(+o[a+164>>2])}function g6a(a,b){a=a|0;b=+b;o[a+164>>2]=b;return}function h6a(a){a=a|0;return +(+o[a+168>>2])}function i6a(a,b){a=a|0;b=+b;o[a+168>>2]=b;return}function j6a(a){a=a|0;return +(+o[a+172>>2])}function k6a(a,b){a=a|0;b=+b;o[a+172>>2]=b;return}function l6a(a){a=a|0;return (i[a+176>>0]|0)!=0|0}function m6a(a,b){a=a|0;b=b|0;var c=0;a=a+176|0;c=(i[a>>0]|0)==0;if(!((c|b^1)&(b|c^1)))return;i[a>>0]=b&1;return}function n6a(a){a=a|0;return l[a+177>>0]|0|0}function o6a(a,b){a=a|0;b=b|0;i[a+177>>0]=b;return}function p6a(a){a=a|0;return +(+o[a+180>>2])}function q6a(a,b){a=a|0;b=+b;o[a+180>>2]=b;return}function r6a(a){a=a|0;ggb(a);return}function s6a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0.0,l=0.0,m=0.0,n=0.0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0,Ja=0,Ka=0;Ga=r;r=r+3248|0;wa=Ga+3224|0;za=Ga+3168|0;Fa=Ga+2104|0;Da=Ga+56|0;Ea=Ga;f=k[b>>2]|0;ua=k[b+4>>2]|0;ra=a+4|0;e=k[ra>>2]|0;sa=k[e+12>>2]|0;ta=((k[e>>2]|0)>>>3&511)+1|0;d=aa(sa,ta)|0;va=Fa+8|0;k[Fa>>2]=va;xa=Fa+4|0;k[xa>>2]=264;if(d>>>0>264){c=d>>>0>1073741823?-1:d<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[Fa>>2]=b}else b=va;k[xa>>2]=d;Z=a+28|0;_=1.0-+o[Z>>2];a:do if((f|0)<(ua|0)){$=a+16|0;ba=a+24|0;ca=a+12|0;da=a+20|0;ea=a+8|0;fa=(sa|0)>0;ga=a+64|0;ha=a+32|0;ia=a+36|0;ja=a+60|0;ka=a+44|0;la=a+56|0;ma=(ta|0)==3;na=Da+4|0;oa=Da+8|0;pa=a+40|0;qa=a+48|0;F=a+52|0;G=wa+4|0;H=za+4|0;I=(ta<<3)+-3|0;J=wa+4|0;K=J+4|0;L=za+36|0;M=za+16|0;N=za+4|0;O=za+40|0;P=za+44|0;Q=za+48|0;R=Ea+36|0;S=Ea+16|0;T=Ea+4|0;U=Ea+40|0;V=Ea+44|0;W=Ea+48|0;X=Ea+32|0;Y=za+32|0;c=f;d=e;while(1){if((k[d>>2]&7|0)!=5){k[wa>>2]=c;k[G>>2]=c+1;k[za>>2]=-2147483648;k[H>>2]=2147483647;H1(Ea,d,wa,za);JN(za,1,sa,I,b,0);d=K;k[d>>2]=0;k[d+4>>2]=0;k[wa>>2]=-1040121856;k[J>>2]=za;SW(Ea,wa,5,1.0,0.0);d=k[L>>2]|0;if(d|0?(D=d+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){a=k[L>>2]|0;if(a|0){d=k[a+4>>2]|0;if(!d){d=k[Y>>2]|0;if(!d){d=B1()|0;a=k[L>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,a)}k[L>>2]=0}k[L>>2]=0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[N>>2]|0)>0){a=k[O>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[N>>2]|0))}d=k[P>>2]|0;if(!((d|0)==(Q|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[R>>2]|0;if(d|0?(D=d+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){a=k[R>>2]|0;if(a|0){d=k[a+4>>2]|0;if(!d){d=k[X>>2]|0;if(!d){d=B1()|0;a=k[R>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,a)}k[R>>2]=0}k[R>>2]=0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[T>>2]|0)>0){a=k[U>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[T>>2]|0))}d=k[V>>2]|0;if(!((d|0)==(W|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}else b=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;d=aa(k[ba>>2]|0,sa)|0;D=(k[da>>2]|0)+(aa(c,sa)|0)|0;E=k[ea>>2]|0;E=(k[E+16>>2]|0)+(aa(k[k[E+44>>2]>>2]|0,c)|0)|0;if(fa){B=(k[ca>>2]|0)+((aa(d,c)|0)<<3)|0;C=0;A=(k[$>>2]|0)+((aa(aa(c,ta)|0,d)|0)<<2)|0;while(1){z=D+C|0;x=i[z>>0]|0;y=x&255;if(!(x<<24>>24)){g=0.0;e=y;a=0;q=0}else{w=b+4|0;x=b+8|0;u=0;v=A;g=0.0;e=y;a=0;f=0;h=+o[la>>2];while(1){l=_*+o[B+(u<<3)>>2]+h;b:do if(!a){a=B+(u<<3)+4|0;m=+o[a>>2];if(ma){n=+o[v>>2]-+o[b>>2];o[Da>>2]=n;h=+o[v+4>>2]-+o[w>>2];o[na>>2]=h;Ha=+o[v+8>>2]-+o[x>>2];o[oa>>2]=Ha;h=Ha*Ha+(n*n+h*h)}else{d=0;h=0.0;do{Ha=+o[v+(d<<2)>>2]-+o[b+(d<<2)>>2];o[Da+(d<<2)>>2]=Ha;h=h+Ha*Ha;d=d+1|0}while((d|0)!=(ta|0))}if(g<+o[ia>>2]?h<m*+o[ha>>2]:0)t=1;else t=f;if(h<m*+o[pa>>2]){Ha=+o[Z>>2];n=l+Ha;l=Ha/n;d=0;do{s=v+(d<<2)|0;o[s>>2]=+o[s>>2]-l*+o[Da+(d<<2)>>2];d=d+1|0}while((d|0)!=(ta|0));Ha=m+(h-m)*l;m=+o[qa>>2];Ha=Ha<m?m:Ha;m=+o[F>>2];o[a>>2]=Ha>m?m:Ha;if((u|0)>0){q=u;d=0;while(1){s=q;q=q+-1|0;a=B+(q<<3)|0;if(n<+o[a>>2]){l=n;a=1;f=t;break b}f=B+(s<<3)|0;p=f;Ia=k[p>>2]|0;p=k[p+4>>2]|0;Ka=a;Ja=k[Ka+4>>2]|0;k[f>>2]=k[Ka>>2];k[f+4>>2]=Ja;f=a;k[f>>2]=Ia;k[f+4>>2]=p;f=aa(s,ta)|0;p=aa(q,ta)|0;a=0;do{Ia=A+(a+f<<2)|0;Ka=A+(a+p<<2)|0;Ja=k[Ia>>2]|0;k[Ia>>2]=k[Ka>>2];k[Ka>>2]=Ja;a=a+1|0}while((a|0)!=(ta|0));d=d+1|0;if((s|0)<=1){l=n;a=1;f=t;break}}}else{l=n;d=0;a=1;f=t}}else{d=0;a=0;f=t}}else{d=0;a=1}while(0);h=+o[la>>2];Ka=l<-h;e=(Ka<<31>>31)+e|0;Ha=Ka?0.0:l;o[B+(u-d<<3)>>2]=Ha;g=g+Ha;u=u+1|0;if((u|0)>=(e|0)){q=f;break}else v=v+(ta<<2)|0}}g=1.0/g;if((e|0)>0){d=0;do{Ka=B+(d<<3)|0;o[Ka>>2]=g*+o[Ka>>2];d=d+1|0}while((d|0)!=(e|0))}c:do if(!a?(ya=+o[Z>>2],ya>0.0):0){e=k[ba>>2]|0;d=(y|0)==(e|0);p=(d&1^1)+y|0;e=d?e+-1|0:y;d=B+(e<<3)|0;if((p|0)!=1){o[d>>2]=ya;a=p+-1|0;if(p|0){d=0;do{Ka=B+(d<<3)|0;o[Ka>>2]=_*+o[Ka>>2];d=d+1|0}while((d|0)<(a|0))}}else o[d>>2]=1.0;a=aa(e,ta)|0;d=0;do{k[A+(d+a<<2)>>2]=k[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(ta|0));k[B+(e<<3)+4>>2]=k[ka>>2];if(p>>>0>1){f=p;do{a=f+-2|0;f=f+-1|0;d=B+(a<<3)|0;if(+o[Z>>2]<+o[d>>2])break c;e=B+(f<<3)|0;Ka=e;Ja=k[Ka>>2]|0;Ka=k[Ka+4>>2]|0;y=d;Ia=k[y+4>>2]|0;k[e>>2]=k[y>>2];k[e+4>>2]=Ia;e=d;k[e>>2]=Ja;k[e+4>>2]=Ka;e=aa(f,ta)|0;a=aa(a,ta)|0;d=0;do{Ia=A+(d+e<<2)|0;Ka=A+(d+a<<2)|0;Ja=k[Ia>>2]|0;k[Ia>>2]=k[Ka>>2];k[Ka>>2]=Ja;d=d+1|0}while((d|0)!=(ta|0))}while((f|0)>1)}}else p=y;while(0);i[z>>0]=p;d:do if(!q){Ka=j[ga>>1]|0;d=(Ka&65535)>>>8&65535;if((Ka&255)<<24>>24!=0?(Aa=+o[ha>>2],Ba=+o[ia>>2],Ca=+o[ja>>2],(p|0)>0):0){e=A;l=0.0;f=0;while(1){m=+o[B+(f<<3)>>2];n=+o[B+(f<<3)+4>>2];a=0;g=0.0;h=0.0;do{Ha=+o[e+(a<<2)>>2];h=h+ +o[b+(a<<2)>>2]*Ha;g=g+Ha*Ha;a=a+1|0}while((a|0)!=(ta|0));if(g==0.0){d=255;break d}if(!(!(h<=g)|!(h>=Ca*g))){h=h/g;a=0;g=0.0;do{Ha=h*+o[e+(a<<2)>>2]-+o[b+(a<<2)>>2];g=g+Ha*Ha;a=a+1|0}while((a|0)!=(ta|0));if(g<h*(Aa*n*h))break d}l=l+m;if(l>Ba){d=255;break d}f=f+1|0;if((f|0)>=(p|0)){d=255;break}else e=e+(ta<<2)|0}}else d=255}else d=0;while(0);i[E+C>>0]=d;C=C+1|0;d=k[ba>>2]|0;A=A+((aa(d,ta)|0)<<2)|0;if((C|0)==(sa|0))break;else{B=B+(d<<3)|0;b=b+(ta<<2)|0}}}c=c+1|0;b=k[Fa>>2]|0;if((c|0)>=(ua|0))break a;d=k[ra>>2]|0}}while(0);if((b|0)==(va|0)){r=Ga;return}if(b|0)ggb(b);k[Fa>>2]=va;k[xa>>2]=264;r=Ga;return}function t6a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function u6a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+o[b>>2]);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function v6a(a){a=a|0;ggb(a);return}function w6a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function x6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0.0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;ka=r;r=r+432|0;ga=ka+368|0;_=ka+320|0;W=ka+264|0;X=ka;Y=ka+248|0;Z=ka+192|0;k[ga>>2]=1124007936;ja=ga+4|0;f=ga+8|0;fa=ga+40|0;h=ja;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[fa>>2]=f;ia=ga+48|0;ha=ga+44|0;k[ha>>2]=ia;k[ga+52>>2]=0;k[ia>>2]=0;k[_>>2]=1124007936;ca=_+4|0;ba=_+32|0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;k[ca+16>>2]=0;k[ca+20>>2]=0;k[ca+24>>2]=0;k[ba>>2]=_+8;ea=_+40|0;da=_+36|0;k[da>>2]=ea;k[_+44>>2]=0;k[ea>>2]=0;f=k[a>>2]&2031616;V=(f|0)==655360;if(V){A2(W,a);D2(_,W);j=k[_>>2]|0;m=k[ba>>2]|0;l=k[m+4>>2]|0;m=k[m>>2]|0;h=W+24|0;f=k[h>>2]|0;if(f|0?(T=f+8|0,U=k[T>>2]|0,k[T>>2]=U+-1,(U|0)==1):0){U=k[h>>2]|0;T=k[U+4>>2]|0;jh[k[(k[T>>2]|0)+16>>2]&1023](T,U);k[h>>2]=0}a=W+4|0;if((k[a>>2]|0)>0){g=k[W+32>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[a>>2]|0))}k[h>>2]=0;f=k[W+36>>2]|0;if(!((f|0)==(W+40|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}else{do if((f|0)==65536){j=k[a+4>>2]|0;k[W>>2]=k[j>>2];n=W+4|0;f=j+4|0;k[n>>2]=k[f>>2];U=W+8|0;k[U>>2]=k[j+8>>2];k[W+12>>2]=k[j+12>>2];k[W+16>>2]=k[j+16>>2];k[W+20>>2]=k[j+20>>2];k[W+24>>2]=k[j+24>>2];k[W+28>>2]=k[j+28>>2];k[W+32>>2]=k[j+32>>2];a=k[j+36>>2]|0;k[W+36>>2]=a;g=W+40|0;k[g>>2]=U;U=W+48|0;m=W+44|0;k[m>>2]=U;k[W+52>>2]=0;k[U>>2]=0;if(a|0){U=a+12|0;k[U>>2]=(k[U>>2]|0)+1}if((k[f>>2]|0)<3){T=k[j+44>>2]|0;U=k[m>>2]|0;k[U>>2]=k[T>>2];k[U+4>>2]=k[T+4>>2];break}k[n>>2]=0;x1(W,k[f>>2]|0,0,0,0);if((k[n>>2]|0)>0){l=k[j+40>>2]|0;h=k[g>>2]|0;g=k[j+44>>2]|0;a=k[m>>2]|0;f=0;do{k[h+(f<<2)>>2]=k[l+(f<<2)>>2];k[a+(f<<2)>>2]=k[g+(f<<2)>>2];f=f+1|0}while((f|0)<(k[n>>2]|0))}}else Q1(W,a,-1);while(0);KG(ga,W)|0;j=k[ga>>2]|0;m=k[fa>>2]|0;l=k[m+4>>2]|0;m=k[m>>2]|0;g=W+36|0;f=k[g>>2]|0;if(f|0?(T=f+12|0,U=k[T>>2]|0,k[T>>2]=U+-1,(U|0)==1):0){a=k[g>>2]|0;if(a|0){f=k[a+4>>2]|0;if(!f){f=k[W+32>>2]|0;if(!f){f=B1()|0;a=k[g>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,a)}k[g>>2]=0}k[g>>2]=0;U=W+16|0;a=W+4|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[a>>2]|0)>0){g=k[W+40>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[a>>2]|0))}f=k[W+44>>2]|0;if(!((f|0)==(W+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}k[W>>2]=k[b>>2];O=W+4|0;S=b+4|0;k[O>>2]=k[S>>2];Q=W+8|0;T=b+8|0;f=k[T>>2]|0;k[Q>>2]=f;R=W+12|0;U=b+12|0;a=k[U>>2]|0;k[R>>2]=a;if(j&4088){k[X>>2]=0;N=X+4|0;k[N>>2]=0;f=ZT(12)|0;k[f>>2]=1;M=f+4|0;k[X>>2]=M;k[N>>2]=7;i[f+11>>0]=0;i[M>>0]=i[401499]|0;i[M+1>>0]=i[401500]|0;i[M+2>>0]=i[401501]|0;i[M+3>>0]=i[401502]|0;i[M+4>>0]=i[401503]|0;i[M+5>>0]=i[401504]|0;i[M+6>>0]=i[401505]|0;Y8(-215,X,401507,401517,59);k[N>>2]=0;k[X>>2]=0;N=k[f>>2]|0;k[f>>2]=N+-1;if((N|0)==1)ggb(k[f+-4>>2]|0);a=k[U>>2]|0;f=k[T>>2]|0}if((a|0)<1|(f|0)<1){k[X>>2]=0;f=X+4|0;k[f>>2]=0;a=ZT(40)|0;k[a>>2]=1;h=a+4|0;k[X>>2]=h;k[f>>2]=35;i[a+39>>0]=0;g=401585;j=h+35|0;do{i[h>>0]=i[g>>0]|0;h=h+1|0;g=g+1|0}while((h|0)<(j|0));Y8(-5,X,401507,401517,62);k[f>>2]=0;k[X>>2]=0;N=k[a>>2]|0;k[a>>2]=N+-1;if((N|0)==1)ggb(k[a+-4>>2]|0);f=k[T>>2]|0;a=k[U>>2]|0}M=k[b>>2]|0;N=k[S>>2]|0;K=(M|0)<0?0:M;L=(N|0)<0?0:N;M=f+M|0;M=((l|0)<(M|0)?l:M)-K|0;f=a+N|0;f=((m|0)<(f|0)?m:f)-L|0;N=(M|0)<1|(f|0)<1;k[b>>2]=N?0:K;k[S>>2]=N?0:L;k[T>>2]=N?0:M;k[U>>2]=N?0:f;e=(c&2|0)==0?1.0:e<0.0?0.0:e;e=e*e;p[u>>3]=e;f=k[u+4>>2]|0;N=f&2146435072;if(!(N>>>0>1126170624|(N|0)==1126170624&0>0)){f=(f|0)<0;e=f?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=f?-0.0:0.0}M=~~e;N=((M|0)<0)<<31>>31;n=(c&1|0)==0?100:(d|0)<1?1:d;c=(l|0)/2|0;d=(m|0)/2|0;q=Y+8|0;s=Y+12|0;t=Y+4|0;v=X+8|0;w=X+16|0;x=Y+8|0;y=Y+12|0;z=Y+4|0;A=Z+36|0;B=Z+16|0;C=Z+4|0;D=Z+40|0;E=Z+44|0;F=Z+48|0;G=Z+24|0;H=Z+4|0;I=Z+32|0;J=Z+36|0;K=Z+40|0;L=Z+32|0;j=0;h=k[W>>2]|0;g=k[O>>2]|0;a=k[Q>>2]|0;f=k[R>>2]|0;do{ma=(h|0)<0?0:h;na=(g|0)<0?0:g;la=a+h|0;la=((l|0)<(la|0)?l:la)-ma|0;h=f+g|0;h=((m|0)<(h|0)?m:h)-na|0;g=(la|0)<1|(h|0)<1;f=g?0:h;a=g?0:la;k[W>>2]=g?0:ma;k[O>>2]=g?0:na;k[Q>>2]=a;k[R>>2]=f;if(g|(na|ma|la|h|0)==0){k[W>>2]=c;k[O>>2]=d}k[Q>>2]=(a|0)<1?1:a;k[R>>2]=(f|0)<1?1:f;if(V){u9(Z,_,W);k[q>>2]=0;k[s>>2]=0;k[Y>>2]=17432576;k[t>>2]=Z;$oa(X,Y,0);f=k[G>>2]|0;if(f|0?(ma=f+8|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){na=k[G>>2]|0;ma=k[na+4>>2]|0;jh[k[(k[ma>>2]|0)+16>>2]&1023](ma,na);k[G>>2]=0}if((k[H>>2]|0)>0){a=k[I>>2]|0;f=0;do{k[a+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[H>>2]|0))}k[G>>2]=0;f=k[J>>2]|0;if(!((f|0)==(K|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}else{I1(Z,ga,W);k[x>>2]=0;k[y>>2]=0;k[Y>>2]=16842752;k[z>>2]=Z;$oa(X,Y,0);f=k[A>>2]|0;if(f|0?(ma=f+12|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){a=k[A>>2]|0;if(a|0){f=k[a+4>>2]|0;if(!f){f=k[L>>2]|0;if(!f){f=B1()|0;a=k[A>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,a)}k[A>>2]=0}k[A>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[C>>2]|0)>0){a=k[D>>2]|0;f=0;do{k[a+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[C>>2]|0))}f=k[E>>2]|0;if(!((f|0)==(F|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}o=+p[X>>3];if(+P(+o)<2.220446049250313e-16){$=73;break}e=+p[v>>3]/o-+(k[T>>2]|0)*.5;p[u>>3]=e;f=k[u+4>>2]|0;na=f&2146435072;if(!(na>>>0>1126170624|(na|0)==1126170624&0>0)){f=(f|0)<0;e=f?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=f?-0.0:0.0}a=~~e;e=+p[w>>3]/o-+(k[U>>2]|0)*.5;p[u>>3]=e;f=k[u+4>>2]|0;na=f&2146435072;if(!(na>>>0>1126170624|(na|0)==1126170624&0>0)){f=(f|0)<0;e=f?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=f?-0.0:0.0}na=k[W>>2]|0;h=na+a|0;a=k[Q>>2]|0;ma=l-a|0;h=(h|0)<0?0:h;h=(ma|0)<(h|0)?ma:h;ma=k[O>>2]|0;g=ma+~~e|0;f=k[R>>2]|0;la=m-f|0;g=(g|0)<0?0:g;g=(la|0)<(g|0)?la:g;na=h-na|0;ma=g-ma|0;k[W>>2]=h;k[O>>2]=g;if(0<(N|0)|(0==(N|0)?((aa(ma,ma)|0)+(aa(na,na)|0)|0)>>>0<M>>>0:0)){$=81;break}j=j+1|0}while((j|0)<(n|0));if(($|0)==73){h=k[W>>2]|0;g=k[O>>2]|0;a=k[Q>>2]|0;f=k[R>>2]|0;$=81}k[b>>2]=h;k[S>>2]=g;k[T>>2]=a;k[U>>2]=f;g=_+24|0;f=k[g>>2]|0;if(f|0?(ma=f+8|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){na=k[g>>2]|0;ma=k[na+4>>2]|0;jh[k[(k[ma>>2]|0)+16>>2]&1023](ma,na);k[g>>2]=0}if((k[ca>>2]|0)>0){a=k[ba>>2]|0;f=0;do{k[a+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[ca>>2]|0))}k[g>>2]=0;f=k[da>>2]|0;if(!((f|0)==(ea|0)|(f|0)==0))ggb(k[f+-4>>2]|0);g=ga+36|0;f=k[g>>2]|0;if(f|0?(ma=f+12|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){a=k[g>>2]|0;if(a|0){f=k[a+4>>2]|0;if(!f){f=k[ga+32>>2]|0;if(!f){f=B1()|0;a=k[g>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,a)}k[g>>2]=0}k[g>>2]=0;na=ga+16|0;k[na>>2]=0;k[na+4>>2]=0;k[na+8>>2]=0;k[na+12>>2]=0;if((k[ja>>2]|0)>0){a=k[fa>>2]|0;f=0;do{k[a+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[ja>>2]|0))}f=k[ha>>2]|0;if((f|0)==(ia|0)|(f|0)==0){r=ka;return j|0}ggb(k[f+-4>>2]|0);r=ka;return j|0}function y6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;var j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,R=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,eh=0,fh=0,gh=0,hh=0,ih=0,kh=0,lh=0,mh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,ei=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,Zj=0,_j=0,$j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0,$k=0,al=0,bl=0,cl=0,dl=0,el=0,fl=0,gl=0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0,nl=0,ol=0,pl=0,ql=0,rl=0,sl=0,tl=0,ul=0,vl=0,wl=0,xl=0,yl=0,zl=0,Al=0,Bl=0,Cl=0,Dl=0,El=0,Fl=0,Gl=0,Hl=0,Il=0,Jl=0,Kl=0,Ll=0,Ml=0,Nl=0,Ol=0,Pl=0,Ql=0,Rl=0,Sl=0,Tl=0,Ul=0,Vl=0,Wl=0,Xl=0,Yl=0,Zl=0,_l=0,$l=0,am=0,bm=0,cm=0,dm=0,em=0,fm=0,gm=0,hm=0,im=0,jm=0,km=0,lm=0,mm=0,nm=0,om=0,pm=0,qm=0,rm=0,sm=0,tm=0,um=0,vm=0,wm=0,xm=0,ym=0,zm=0,Am=0,Bm=0,Cm=0,Dm=0,Em=0,Fm=0,Gm=0,Hm=0,Im=0,Jm=0,Km=0,Lm=0,Mm=0,Nm=0,Om=0,Pm=0,Qm=0,Rm=0,Sm=0,Tm=0,Um=0,Vm=0,Wm=0,Xm=0,Ym=0,Zm=0,_m=0,$m=0,an=0,bn=0,cn=0,dn=0,en=0,fn=0,gn=0,hn=0,jn=0,kn=0,ln=0,mn=0,nn=0,on=0,pn=0,qn=0,rn=0,sn=0,tn=0,un=0,vn=0,wn=0,xn=0,yn=0,zn=0,An=0,Bn=0,Cn=0,Dn=0,En=0,Fn=0,Gn=0,Hn=0,In=0,Jn=0,Kn=0,Ln=0,Mn=0,Nn=0,On=0,Pn=0,Qn=0,Rn=0,Sn=0,Tn=0,Un=0,Vn=0,Wn=0,Xn=0,Yn=0,Zn=0,_n=0,$n=0,ao=0,bo=0,co=0,eo=0,fo=0,go=0,ho=0,io=0,jo=0,ko=0,lo=0,mo=0,no=0,oo=0,po=0,qo=0,ro=0,so=0,to=0,uo=0,vo=0,wo=0,xo=0,yo=0,zo=0,Ao=0,Bo=0,Co=0,Do=0,Eo=0,Fo=0,Go=0,Ho=0,Io=0,Jo=0,Ko=0,Lo=0,Mo=0,No=0,Oo=0,Po=0,Qo=0,Ro=0,So=0,To=0,Uo=0,Vo=0,Wo=0,Xo=0,Yo=0,Zo=0,_o=0,$o=0,ap=0,bp=0,cp=0,dp=0,ep=0,fp=0,gp=0,hp=0,ip=0,jp=0,kp=0,lp=0,mp=0,np=0,op=0,pp=0,qp=0,rp=0,sp=0,tp=0,up=0,vp=0,wp=0,xp=0,yp=0,zp=0,Ap=0,Bp=0,Cp=0,Dp=0,Ep=0,Fp=0,Gp=0,Hp=0,Ip=0,Jp=0,Kp=0,Lp=0,Mp=0,Np=0,Op=0,Pp=0,Qp=0,Rp=0,Sp=0,Tp=0,Up=0,Vp=0,Wp=0,Xp=0,Yp=0,Zp=0,_p=0,$p=0,aq=0,bq=0,cq=0,dq=0,eq=0,fq=0,gq=0,hq=0.0,iq=0,jq=0,kq=0,lq=0,mq=0,nq=0,oq=0,pq=0,qq=0,rq=0,sq=0,tq=0,uq=0,vq=0,wq=0,xq=0,yq=0,zq=0,Aq=0,Bq=0,Cq=0,Dq=0,Eq=0,Fq=0,Gq=0,Hq=0,Iq=0,Jq=0,Kq=0,Lq=0,Mq=0,Nq=0,Oq=0,Pq=0,Qq=0,Rq=0,Sq=0,Tq=0,Uq=0,Vq=0,Wq=0,Xq=0,Yq=0,Zq=0,_q=0,$q=0,ar=0,br=0,cr=0,dr=0,er=0,fr=0,gr=0,hr=0,ir=0,jr=0,kr=0,lr=0,mr=0,nr=0,or=0,pr=0,qr=0,rr=0,sr=0,tr=0,ur=0,vr=0,wr=0,xr=0,yr=0,zr=0,Ar=0,Br=0,Cr=0,Dr=0,Er=0,Fr=0,Gr=0,Hr=0,Ir=0,Jr=0,Kr=0,Lr=0,Mr=0,Nr=0,Or=0,Pr=0,Qr=0,Rr=0,Sr=0,Tr=0,Ur=0,Vr=0,Wr=0,Xr=0,Yr=0,Zr=0,_r=0,$r=0,as=0,bs=0,cs=0,ds=0,es=0,fs=0,gs=0,hs=0,is=0,js=0,ks=0,ls=0,ms=0,ns=0,os=0,ps=0,qs=0,rs=0,ss=0,ts=0,us=0,vs=0,ws=0,xs=0,ys=0,zs=0,As=0,Bs=0,Cs=0,Ds=0,Es=0,Fs=0,Gs=0,Hs=0,Is=0,Js=0,Ks=0,Ls=0,Ms=0.0;Ls=r;r=r+5568|0;Wq=Ls+3264|0;Xq=Ls+3040|0;fr=Ls+2816|0;lr=Ls+2592|0;mr=Ls+1920|0;Gq=Ls+1696|0;Hq=Ls+1472|0;Iq=Ls+1248|0;Jq=Ls+1024|0;Kq=Ls+800|0;Lq=Ls+576|0;Mq=Ls+352|0;Nq=Ls+5408|0;Oq=Ls+5352|0;Pq=Ls+128|0;Qq=Ls+5296|0;Rq=Ls+5240|0;Sq=Ls+5184|0;Tq=Ls+5128|0;Uq=Ls+5072|0;Ks=Ls+5016|0;Js=Ls+4960|0;Is=Ls+4904|0;Hs=Ls+4848|0;Fs=Ls+4792|0;Es=Ls+4736|0;Cs=Ls+4680|0;Bs=Ls+4624|0;As=Ls+4568|0;zs=Ls+4512|0;ys=Ls+4456|0;ss=Ls+4400|0;ms=Ls+4344|0;fs=Ls+4288|0;w=Ls+5560|0;as=Ls+4232|0;x=Ls+5552|0;y=Ls+5544|0;$r=Ls+4176|0;A=Ls+2368|0;_r=Ls+4120|0;B=Ls+2144|0;Vr=Ls+4064|0;Qr=Ls+4008|0;C=Ls+3992|0;D=Ls+5536|0;E=Ls+5528|0;Lr=Ls+3936|0;Gr=Ls+3880|0;Br=Ls+3824|0;Ar=Ls+3768|0;zr=Ls+3712|0;wr=Ls+3656|0;tr=Ls+3600|0;pr=Ls+3544|0;nr=Ls+3488|0;Yq=Ls+5520|0;Zq=Ls+5512|0;_q=Ls+5504|0;$q=Ls+5496|0;ar=Ls+5488|0;br=Ls+5480|0;cr=Ls+5472|0;dr=Ls+5464|0;er=Ls+96|0;gr=Ls+64|0;hr=Ls+32|0;ir=Ls;do if((k[a>>2]&2031616|0)==65536){n=k[a+4>>2]|0;k[Ks>>2]=k[n>>2];t=Ks+4|0;j=n+4|0;k[t>>2]=k[j>>2];Gs=Ks+8|0;k[Gs>>2]=k[n+8>>2];k[Ks+12>>2]=k[n+12>>2];k[Ks+16>>2]=k[n+16>>2];k[Ks+20>>2]=k[n+20>>2];k[Ks+24>>2]=k[n+24>>2];k[Ks+28>>2]=k[n+28>>2];k[Ks+32>>2]=k[n+32>>2];a=k[n+36>>2]|0;k[Ks+36>>2]=a;l=Ks+40|0;k[l>>2]=Gs;Gs=Ks+48|0;q=Ks+44|0;k[q>>2]=Gs;k[Ks+52>>2]=0;k[Gs>>2]=0;if(a|0){Gs=a+12|0;k[Gs>>2]=(k[Gs>>2]|0)+1}if((k[j>>2]|0)<3){Ds=k[n+44>>2]|0;Gs=k[q>>2]|0;k[Gs>>2]=k[Ds>>2];k[Gs+4>>2]=k[Ds+4>>2];break}k[t>>2]=0;x1(Ks,k[j>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[n+40>>2]|0;m=k[l>>2]|0;l=k[n+44>>2]|0;j=k[q>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[s+(a<<2)>>2];k[j+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[t>>2]|0))}}else Q1(Ks,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){m=k[b+4>>2]|0;k[Js>>2]=k[m>>2];t=Js+4|0;a=m+4|0;k[t>>2]=k[a>>2];Gs=Js+8|0;k[Gs>>2]=k[m+8>>2];k[Js+12>>2]=k[m+12>>2];k[Js+16>>2]=k[m+16>>2];k[Js+20>>2]=k[m+20>>2];k[Js+24>>2]=k[m+24>>2];k[Js+28>>2]=k[m+28>>2];k[Js+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[Js+36>>2]=j;l=Js+40|0;k[l>>2]=Gs;Gs=Js+48|0;q=Js+44|0;k[q>>2]=Gs;k[Js+52>>2]=0;k[Gs>>2]=0;if(j|0){Gs=j+12|0;k[Gs>>2]=(k[Gs>>2]|0)+1}if((k[a>>2]|0)<3){Ds=k[m+44>>2]|0;Gs=k[q>>2]|0;k[Gs>>2]=k[Ds>>2];k[Gs+4>>2]=k[Ds+4>>2];break}k[t>>2]=0;x1(Js,k[a>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[q>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[s+(a<<2)>>2];k[j+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[t>>2]|0))}}else Q1(Js,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){m=k[c+4>>2]|0;k[Is>>2]=k[m>>2];t=Is+4|0;a=m+4|0;k[t>>2]=k[a>>2];Gs=Is+8|0;k[Gs>>2]=k[m+8>>2];k[Is+12>>2]=k[m+12>>2];k[Is+16>>2]=k[m+16>>2];k[Is+20>>2]=k[m+20>>2];k[Is+24>>2]=k[m+24>>2];k[Is+28>>2]=k[m+28>>2];k[Is+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[Is+36>>2]=j;l=Is+40|0;k[l>>2]=Gs;Gs=Is+48|0;q=Is+44|0;k[q>>2]=Gs;k[Is+52>>2]=0;k[Gs>>2]=0;if(j|0){Gs=j+12|0;k[Gs>>2]=(k[Gs>>2]|0)+1}if((k[a>>2]|0)<3){Ds=k[m+44>>2]|0;Gs=k[q>>2]|0;k[Gs>>2]=k[Ds>>2];k[Gs+4>>2]=k[Ds+4>>2];break}k[t>>2]=0;x1(Is,k[a>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[q>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[s+(a<<2)>>2];k[j+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[t>>2]|0))}}else Q1(Is,c,-1);while(0);Gs=Ks+16|0;if(k[Gs>>2]|0){l=k[Ks+4>>2]|0;if((l|0)<3)a=aa(k[Ks+12>>2]|0,k[Ks+8>>2]|0)|0;else{m=k[Ks+40>>2]|0;j=0;a=1;do{a=aa(k[m+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(l|0))}if(!a)v=34}else v=34;if((v|0)==34){k[Wq>>2]=0;a=Wq+4|0;k[a>>2]=0;j=ZT(20)|0;k[j>>2]=1;n=j+4|0;k[Wq>>2]=n;k[a>>2]=12;i[j+16>>0]=0;l=401621;s=n+12|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,401634,401651,325);k[a>>2]=0;k[Wq>>2]=0;Ds=k[j>>2]|0;k[j>>2]=Ds+-1;if((Ds|0)==1)ggb(k[j+-4>>2]|0)}Ds=Js+16|0;if(k[Ds>>2]|0){l=k[Js+4>>2]|0;if((l|0)<3)a=aa(k[Js+12>>2]|0,k[Js+8>>2]|0)|0;else{m=k[Js+40>>2]|0;j=0;a=1;do{a=aa(k[m+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(l|0))}if(!a)v=43}else v=43;if((v|0)==43){k[Wq>>2]=0;a=Wq+4|0;k[a>>2]=0;j=ZT(20)|0;k[j>>2]=1;n=j+4|0;k[Wq>>2]=n;k[a>>2]=12;i[j+16>>0]=0;l=401714;s=n+12|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,401634,401651,326);k[a>>2]=0;k[Wq>>2]=0;xs=k[j>>2]|0;k[j>>2]=xs+-1;if((xs|0)==1)ggb(k[j+-4>>2]|0)}a=k[Ks>>2]|0;if((k[Js>>2]^a)&4095){k[Wq>>2]=0;a=Wq+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;n=j+4|0;k[Wq>>2]=n;k[a>>2]=46;i[j+50>>0]=0;l=404387;s=n+46|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-205,Wq,401634,401651,330);k[a>>2]=0;k[Wq>>2]=0;xs=k[j>>2]|0;k[j>>2]=xs+-1;if((xs|0)==1)ggb(k[j+-4>>2]|0);a=k[Ks>>2]|0}switch(a&4095){case 5:case 0:break;default:{k[Wq>>2]=0;a=Wq+4|0;k[a>>2]=0;j=ZT(40)|0;k[j>>2]=1;n=j+4|0;k[Wq>>2]=n;k[a>>2]=35;i[j+39>>0]=0;l=401727;s=n+35|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-210,Wq,401634,401651,334);k[a>>2]=0;k[Wq>>2]=0;xs=k[j>>2]|0;k[j>>2]=xs+-1;if((xs|0)==1)ggb(k[j+-4>>2]|0)}}if((k[Is>>2]&4095|0)!=5){k[Wq>>2]=0;a=Wq+4|0;k[a>>2]=0;j=ZT(60)|0;k[j>>2]=1;n=j+4|0;k[Wq>>2]=n;k[a>>2]=55;i[j+59>>0]=0;l=401763;s=n+55|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-210,Wq,401634,401651,337);k[a>>2]=0;k[Wq>>2]=0;xs=k[j>>2]|0;k[j>>2]=xs+-1;if((xs|0)==1)ggb(k[j+-4>>2]|0)}if((k[Is+12>>2]|0)!=3){k[Wq>>2]=0;a=Wq+4|0;k[a>>2]=0;j=ZT(20)|0;k[j>>2]=1;n=j+4|0;k[Wq>>2]=n;k[a>>2]=13;i[j+17>>0]=0;l=401819;s=n+13|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,401634,401651,339);k[a>>2]=0;k[Wq>>2]=0;xs=k[j>>2]|0;k[j>>2]=xs+-1;if((xs|0)==1)ggb(k[j+-4>>2]|0)}nq=Is+8|0;if((k[nq>>2]&-2|0)!=2){k[Wq>>2]=0;a=Wq+4|0;k[a>>2]=0;j=ZT(36)|0;k[j>>2]=1;n=j+4|0;k[Wq>>2]=n;k[a>>2]=29;i[j+33>>0]=0;l=401833;s=n+29|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,401634,401651,340);k[a>>2]=0;k[Wq>>2]=0;xs=k[j>>2]|0;k[j>>2]=xs+-1;if((xs|0)==1)ggb(k[j+-4>>2]|0)}switch(d|0){case 3:{if((k[nq>>2]|0)!=3)v=71;break}case 2:case 1:case 0:break;default:{k[Wq>>2]=0;xs=Wq+4|0;k[xs>>2]=0;a=ZT(140)|0;k[a>>2]=1;ws=a+4|0;k[Wq>>2]=ws;k[xs>>2]=132;i[a+136>>0]=0;upb(ws|0,401863,132)|0;Y8(-215,Wq,401634,401651,343);k[xs>>2]=0;k[Wq>>2]=0;xs=k[a>>2]|0;k[a>>2]=xs+-1;if((xs|0)==1)ggb(k[a+-4>>2]|0);if(!((d|0)!=3|(k[nq>>2]|0)==3))v=71}}if((v|0)==71){k[Wq>>2]=0;a=Wq+4|0;k[a>>2]=0;j=ZT(20)|0;k[j>>2]=1;n=j+4|0;k[Wq>>2]=n;k[a>>2]=12;i[j+16>>0]=0;l=401996;s=n+12|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,401634,401651,346);k[a>>2]=0;k[Wq>>2]=0;xs=k[j>>2]|0;k[j>>2]=xs+-1;if((xs|0)==1)ggb(k[j+-4>>2]|0)}if(!(e&3)){k[Wq>>2]=0;a=Wq+4|0;k[a>>2]=0;j=ZT(80)|0;k[j>>2]=1;n=j+4|0;k[Wq>>2]=n;k[a>>2]=72;i[j+76>>0]=0;l=402009;s=n+72|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,401634,401651,349);k[a>>2]=0;k[Wq>>2]=0;xs=k[j>>2]|0;k[j>>2]=xs+-1;if((xs|0)==1)ggb(k[j+-4>>2]|0)}iq=(e&1|0)==0?200:f;hq=(e&2|0)==0?-1.0:g;switch(d|0){case 0:{v=2;break}case 1:{v=3;break}case 3:{v=8;break}default:v=6}e=k[Ks+12>>2]|0;z=k[Ks+8>>2]|0;b=k[Js+12>>2]|0;c=k[Js+8>>2]|0;k[Hs>>2]=1124007936;ws=Hs+4|0;a=Hs+8|0;us=Hs+40|0;n=ws;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[us>>2]=a;xs=Hs+48|0;vs=Hs+44|0;k[vs>>2]=xs;k[Hs+52>>2]=0;k[xs>>2]=0;k[Wq>>2]=1;f=Wq+4|0;k[f>>2]=e;G1(Hs,2,Wq,5);k[Fs>>2]=1124007936;ps=Fs+4|0;a=Fs+8|0;ns=Fs+40|0;n=ps;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[ns>>2]=a;qs=Fs+48|0;os=Fs+44|0;k[os>>2]=qs;k[Fs+52>>2]=0;k[qs>>2]=0;k[Wq>>2]=z;k[f>>2]=1;G1(Fs,2,Wq,5);k[Es>>2]=1124007936;js=Es+4|0;a=Es+8|0;hs=Es+40|0;n=js;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[hs>>2]=a;ks=Es+48|0;is=Es+44|0;k[is>>2]=ks;k[Es+52>>2]=0;k[ks>>2]=0;k[Wq>>2]=z;k[f>>2]=e;G1(Es,2,Wq,5);k[Cs>>2]=1124007936;ds=Cs+4|0;a=Cs+8|0;bs=Cs+40|0;n=ds;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[bs>>2]=a;es=Cs+48|0;cs=Cs+44|0;k[cs>>2]=es;k[Cs+52>>2]=0;k[es>>2]=0;k[Wq>>2]=z;k[f>>2]=e;G1(Cs,2,Wq,5);ts=Hs+16|0;j=k[ts>>2]|0;ls=Fs+16|0;l=k[ls>>2]|0;if((e|0)>0){a=0;do{o[j+(a<<2)>>2]=+(a|0);a=a+1|0}while((a|0)!=(e|0))}if((z|0)>0){a=0;do{o[l+(a<<2)>>2]=+(a|0);a=a+1|0}while((a|0)!=(z|0))}k[Wq+8>>2]=0;k[Wq+12>>2]=0;k[Wq>>2]=16842752;k[Wq+4>>2]=Hs;rs=Xq+4|0;a=rs+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Xq>>2]=33619968;k[rs>>2]=Es;sY(Wq,z,1,Xq);k[Wq+8>>2]=0;k[Wq+12>>2]=0;k[Wq>>2]=16842752;k[Wq+4>>2]=Fs;rs=Xq+4|0;a=rs+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Xq>>2]=33619968;k[rs>>2]=Cs;sY(Wq,1,e,Xq);rs=Hs+36|0;a=k[rs>>2]|0;if(a|0?(Zr=a+12|0,gs=k[Zr>>2]|0,k[Zr>>2]=gs+-1,(gs|0)==1):0){j=k[rs>>2]|0;if(j|0){a=k[j+4>>2]|0;if(!a){a=k[Hs+32>>2]|0;if(!a){a=B1()|0;j=k[rs>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[rs>>2]=0}k[rs>>2]=0;k[ts>>2]=0;k[ts+4>>2]=0;k[ts+8>>2]=0;k[ts+12>>2]=0;if((k[ws>>2]|0)>0){j=k[us>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ws>>2]|0))}gs=Fs+36|0;a=k[gs>>2]|0;if(a|0?(Yr=a+12|0,Zr=k[Yr>>2]|0,k[Yr>>2]=Zr+-1,(Zr|0)==1):0){j=k[gs>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Fs+32>>2]|0;if(a|0)break;a=B1()|0;j=k[gs>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[gs>>2]=0}k[gs>>2]=0;k[ls>>2]=0;k[ls+4>>2]=0;k[ls+8>>2]=0;k[ls+12>>2]=0;if((k[ps>>2]|0)>0){j=k[ns>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ps>>2]|0))}k[Bs>>2]=1124007936;Xr=Bs+4|0;_p=Bs+8|0;Wr=Bs+40|0;n=Xr;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Wr>>2]=_p;Zr=Bs+48|0;Yr=Bs+44|0;k[Yr>>2]=Zr;k[Bs+52>>2]=0;k[Zr>>2]=0;k[Wq>>2]=z;k[f>>2]=e;G1(Bs,2,Wq,5);k[As>>2]=1124007936;Tr=As+4|0;a=As+8|0;Rr=As+40|0;n=Tr;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Rr>>2]=a;Ur=As+48|0;Sr=As+44|0;k[Sr>>2]=Ur;k[As+52>>2]=0;k[Ur>>2]=0;k[Wq>>2]=z;k[f>>2]=e;G1(As,2,Wq,5);k[zs>>2]=1124007936;Or=zs+4|0;a=zs+8|0;Mr=zs+40|0;n=Or;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Mr>>2]=a;Pr=zs+48|0;Nr=zs+44|0;k[Nr>>2]=Pr;k[zs+52>>2]=0;k[Pr>>2]=0;k[Wq>>2]=c;k[f>>2]=b;G1(zs,2,Wq,5);k[ys>>2]=1124007936;Jr=ys+4|0;a=ys+8|0;Hr=ys+40|0;n=Jr;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Hr>>2]=a;Kr=ys+48|0;Ir=ys+44|0;k[Ir>>2]=Kr;k[ys+52>>2]=0;k[Kr>>2]=0;k[Wq>>2]=z;k[f>>2]=e;G1(ys,2,Wq,5);k[ss>>2]=1124007936;Er=ss+4|0;a=ss+8|0;Cr=ss+40|0;n=Er;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Cr>>2]=a;Fr=ss+48|0;Dr=ss+44|0;k[Dr>>2]=Fr;k[ss+52>>2]=0;k[Fr>>2]=0;k[Wq>>2]=z;k[f>>2]=e;G1(ss,2,Wq,0);do if((k[h>>2]&2031616|0)==65536){m=k[h+4>>2]|0;k[ms>>2]=k[m>>2];t=ms+4|0;a=m+4|0;k[t>>2]=k[a>>2];yr=ms+8|0;k[yr>>2]=k[m+8>>2];k[ms+12>>2]=k[m+12>>2];k[ms+16>>2]=k[m+16>>2];k[ms+20>>2]=k[m+20>>2];k[ms+24>>2]=k[m+24>>2];k[ms+28>>2]=k[m+28>>2];k[ms+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[ms+36>>2]=j;l=ms+40|0;k[l>>2]=yr;yr=ms+48|0;q=ms+44|0;k[q>>2]=yr;k[ms+52>>2]=0;k[yr>>2]=0;if(j|0){yr=j+12|0;k[yr>>2]=(k[yr>>2]|0)+1}if((k[a>>2]|0)<3){xr=k[m+44>>2]|0;yr=k[q>>2]|0;k[yr>>2]=k[xr>>2];k[yr+4>>2]=k[xr+4>>2];break}k[t>>2]=0;x1(ms,k[a>>2]|0,0,0,0);if((k[t>>2]|0)<=0)break;s=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[q>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[s+(a<<2)>>2];k[j+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[t>>2]|0))}else Q1(ms,h,-1);while(0);k[fs>>2]=1124007936;xr=fs+4|0;a=fs+8|0;ur=fs+40|0;n=xr;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[ur>>2]=a;yr=fs+48|0;vr=fs+44|0;k[vr>>2]=yr;k[fs+52>>2]=0;k[yr>>2]=0;if(G2(h)|0){k[Xq>>2]=0;k[Xq+4>>2]=0;k[Xq+8>>2]=1124007936;a=Xq+16|0;j=Xq+48|0;n=Xq+12|0;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[j>>2]=a;a=Xq+56|0;k[Xq+52>>2]=a;k[Xq+60>>2]=0;k[a>>2]=0;k[Xq+64>>2]=1124007936;a=Xq+72|0;j=Xq+104|0;n=Xq+68|0;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[j>>2]=a;a=Xq+112|0;k[Xq+108>>2]=a;k[Xq+116>>2]=0;k[a>>2]=0;k[Xq+120>>2]=1124007936;a=Xq+128|0;j=Xq+160|0;n=Xq+124|0;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[j>>2]=a;n=Xq+168|0;k[Xq+164>>2]=n;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Wq>>2]=b;k[Wq+4>>2]=c;j1(Xq,49,Wq,0);sr=k[Xq>>2]|0;dh[k[(k[sr>>2]|0)+12>>2]&255](sr,Xq,fs,-1);XN(Xq)}else{sr=Wq+4|0;rr=sr+4|0;k[rr>>2]=0;k[rr+4>>2]=0;k[Wq>>2]=33619968;k[sr>>2]=fs;+Yua(h,Wq,0.0,1.0,0)}rr=Wq+4|0;a=rr+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Wq>>2]=33619968;k[rr>>2]=As;SW(Ks,Wq,k[As>>2]&4095,1.0,0.0);k[Wq+8>>2]=0;k[Wq+12>>2]=0;k[Wq>>2]=16842752;k[Wq+4>>2]=As;rr=Xq+4|0;a=rr+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Xq>>2]=33619968;k[rr>>2]=As;k[w>>2]=5;k[w+4>>2]=5;uua(Wq,Xq,w,0.0,0.0,4);k[as>>2]=1124007936;rr=as+4|0;a=as+8|0;or=as+40|0;n=rr;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[or>>2]=a;sr=as+48|0;qr=as+44|0;k[qr>>2]=sr;k[as+52>>2]=0;k[sr>>2]=0;a=Wq+4|0;j=a+4|0;k[j>>2]=0;k[j+4>>2]=0;k[Wq>>2]=33619968;k[a>>2]=as;SW(fs,Wq,5,1.0,0.0);k[Wq+8>>2]=0;k[Wq+12>>2]=0;k[Wq>>2]=16842752;k[Wq+4>>2]=as;a=Xq+4|0;j=a+4|0;k[j>>2]=0;k[j+4>>2]=0;k[Xq>>2]=33619968;k[a>>2]=as;k[x>>2]=5;k[x+4>>2]=5;uua(Wq,Xq,x,0.0,0.0,4);a=Wq+4|0;j=a+4|0;k[j>>2]=0;k[j+4>>2]=0;k[Wq>>2]=33619968;k[a>>2]=as;SW(as,Wq,-1,.5263157894736842,0.0);a=Wq+4|0;j=a+4|0;k[j>>2]=0;k[j+4>>2]=0;k[Wq>>2]=33619968;k[a>>2]=fs;SW(as,Wq,k[fs>>2]&4095,1.0,0.0);a=Wq+4|0;j=a+4|0;k[j>>2]=0;k[j+4>>2]=0;k[Wq>>2]=33619968;k[a>>2]=as;SW(fs,Wq,k[as>>2]&4095,1.0,0.0);a=Wq+4|0;j=a+4|0;k[j>>2]=0;k[j+4>>2]=0;k[Wq>>2]=33619968;k[a>>2]=zs;SW(Js,Wq,k[zs>>2]&4095,1.0,0.0);k[Wq+8>>2]=0;k[Wq+12>>2]=0;k[Wq>>2]=16842752;k[Wq+4>>2]=zs;a=Xq+4|0;j=a+4|0;k[j>>2]=0;k[j+4>>2]=0;k[Xq>>2]=33619968;k[a>>2]=zs;k[y>>2]=5;k[y+4>>2]=5;uua(Wq,Xq,y,0.0,0.0,4);k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=1124007936;a=A+16|0;j=A+48|0;n=A+12|0;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[j>>2]=a;a=A+56|0;k[A+52>>2]=a;k[A+60>>2]=0;k[a>>2]=0;k[A+64>>2]=1124007936;a=A+72|0;j=A+104|0;n=A+68|0;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[j>>2]=a;a=A+112|0;k[A+108>>2]=a;k[A+116>>2]=0;k[a>>2]=0;k[A+120>>2]=1124007936;a=A+128|0;j=A+160|0;n=A+124|0;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[j>>2]=a;n=A+168|0;k[A+164>>2]=n;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Wq>>2]=b;k[Wq+4>>2]=c;j1(A,48,Wq,5);k[$r>>2]=1124007936;jr=$r+4|0;a=$r+8|0;Eq=$r+40|0;n=jr;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Eq>>2]=a;kr=$r+48|0;Fq=$r+44|0;k[Fq>>2]=kr;k[$r+52>>2]=0;k[kr>>2]=0;a=k[A>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,A,$r,-1);XN(A);k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=1124007936;a=B+16|0;j=B+48|0;n=B+12|0;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[j>>2]=a;a=B+56|0;k[B+52>>2]=a;k[B+60>>2]=0;k[a>>2]=0;k[B+64>>2]=1124007936;a=B+72|0;j=B+104|0;n=B+68|0;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[j>>2]=a;a=B+112|0;k[B+108>>2]=a;k[B+116>>2]=0;k[a>>2]=0;k[B+120>>2]=1124007936;a=B+128|0;j=B+160|0;n=B+124|0;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[j>>2]=a;n=B+168|0;k[B+164>>2]=n;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Wq>>2]=b;k[Wq+4>>2]=c;j1(B,48,Wq,5);k[_r>>2]=1124007936;Cq=_r+4|0;a=_r+8|0;Aq=_r+40|0;n=Cq;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Aq>>2]=a;Dq=_r+48|0;Bq=_r+44|0;k[Bq>>2]=Dq;k[_r+52>>2]=0;k[Dq>>2]=0;xq=k[B>>2]|0;dh[k[(k[xq>>2]|0)+12>>2]&255](xq,B,_r,-1);XN(B);k[Vr>>2]=1124007936;xq=Vr+4|0;Jp=Vr+8|0;wq=Vr+40|0;n=xq;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[wq>>2]=Jp;zq=Vr+48|0;yq=Vr+44|0;k[yq>>2]=zq;k[Vr+52>>2]=0;k[zq>>2]=0;k[Wq>>2]=z;k[f>>2]=e;G1(Vr,2,Wq,5);k[Qr>>2]=1124007936;uq=Qr+4|0;a=Qr+8|0;sq=Qr+40|0;n=uq;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[sq>>2]=a;vq=Qr+48|0;tq=Qr+44|0;k[tq>>2]=vq;k[Qr+52>>2]=0;k[vq>>2]=0;k[Wq>>2]=z;k[f>>2]=e;G1(Qr,2,Wq,5);o[C>>2]=-.5;pq=C+4|0;o[pq>>2]=0.0;a=C+8|0;o[a>>2]=.5;k[Wq+8>>2]=0;k[Wq+12>>2]=0;k[Wq>>2]=16842752;k[Wq+4>>2]=zs;Ep=Xq+4|0;oq=Ep+4|0;k[oq>>2]=0;k[oq+4>>2]=0;k[Xq>>2]=33619968;k[Ep>>2]=$r;k[fr>>2]=-1056833531;k[fr+4>>2]=C;k[fr+8>>2]=3;k[fr+12>>2]=1;k[D>>2]=-1;k[D+4>>2]=-1;fla(Wq,Xq,-1,fr,D,0.0,4);k[Wq+8>>2]=0;k[Wq+12>>2]=0;k[Wq>>2]=16842752;k[Wq+4>>2]=zs;Ep=Xq+4|0;oq=Ep+4|0;k[oq>>2]=0;k[oq+4>>2]=0;k[Xq>>2]=33619968;k[Ep>>2]=_r;k[lr>>2]=k[C>>2];k[lr+4>>2]=k[pq>>2];k[lr+8>>2]=k[a>>2];k[fr>>2]=-1056833531;k[fr+4>>2]=lr;k[fr+8>>2]=1;k[fr+12>>2]=3;k[E>>2]=-1;k[E+4>>2]=-1;fla(Wq,Xq,-1,fr,E,0.0,4);k[Xq+8>>2]=0;k[Xq+12>>2]=0;k[Xq>>2]=16842752;k[Xq+4>>2]=as;i1(Wq,$r,Xq,1.0);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,$r,-1);XN(Wq);k[Xq+8>>2]=0;k[Xq+12>>2]=0;k[Xq>>2]=16842752;k[Xq+4>>2]=as;i1(Wq,_r,Xq,1.0);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,_r,-1);XN(Wq);a=aa(e,v)|0;k[Lr>>2]=1124007936;pq=Lr+4|0;Ep=Lr+8|0;oq=Lr+40|0;n=pq;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[oq>>2]=Ep;rq=Lr+48|0;qq=Lr+44|0;k[qq>>2]=rq;k[Lr+52>>2]=0;k[rq>>2]=0;k[Wq>>2]=z;k[f>>2]=a;G1(Lr,2,Wq,5);k[Gr>>2]=1124007936;lq=Gr+4|0;a=Gr+8|0;jq=Gr+40|0;n=lq;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[jq>>2]=a;mq=Gr+48|0;kq=Gr+44|0;k[kq>>2]=mq;k[Gr+52>>2]=0;k[mq>>2]=0;k[Wq>>2]=v;k[f>>2]=v;G1(Gr,2,Wq,5);k[Br>>2]=1124007936;fq=Br+4|0;a=Br+8|0;dq=Br+40|0;n=fq;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[dq>>2]=a;gq=Br+48|0;eq=Br+44|0;k[eq>>2]=gq;k[Br+52>>2]=0;k[gq>>2]=0;k[Wq>>2]=v;k[f>>2]=v;G1(Br,2,Wq,5);k[Ar>>2]=1124007936;bq=Ar+4|0;a=Ar+8|0;$p=Ar+40|0;n=bq;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[$p>>2]=a;cq=Ar+48|0;aq=Ar+44|0;k[aq>>2]=cq;k[Ar+52>>2]=0;k[cq>>2]=0;k[Wq>>2]=v;k[f>>2]=1;G1(Ar,2,Wq,5);k[zr>>2]=1124007936;Yp=zr+4|0;a=zr+8|0;Wp=zr+40|0;n=Yp;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Wp>>2]=a;Zp=zr+48|0;Xp=zr+44|0;k[Xp>>2]=Zp;k[zr+52>>2]=0;k[Zp>>2]=0;k[Wq>>2]=v;k[f>>2]=1;G1(zr,2,Wq,5);k[wr>>2]=1124007936;Up=wr+4|0;a=wr+8|0;Sp=wr+40|0;n=Up;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Sp>>2]=a;Vp=wr+48|0;Tp=wr+44|0;k[Tp>>2]=Vp;k[wr+52>>2]=0;k[Vp>>2]=0;k[Wq>>2]=v;k[f>>2]=1;G1(wr,2,Wq,5);k[tr>>2]=1124007936;Qp=tr+4|0;a=tr+8|0;Op=tr+40|0;n=Qp;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Op>>2]=a;Rp=tr+48|0;Pp=tr+44|0;k[Pp>>2]=Rp;k[tr+52>>2]=0;k[Rp>>2]=0;k[Wq>>2]=v;k[f>>2]=1;G1(tr,2,Wq,5);k[pr>>2]=1124007936;Lp=pr+4|0;Dp=pr+8|0;Kp=pr+40|0;n=Lp;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Kp>>2]=Dp;Np=pr+48|0;Mp=pr+44|0;k[Mp>>2]=Np;k[pr+52>>2]=0;k[Np>>2]=0;k[Wq>>2]=v;k[f>>2]=1;G1(pr,2,Wq,5);k[nr>>2]=1124007936;Hp=nr+4|0;a=nr+8|0;Fp=nr+40|0;n=Hp;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Fp>>2]=a;Ip=nr+48|0;Gp=nr+44|0;k[Gp>>2]=Ip;k[nr+52>>2]=0;k[Ip>>2]=0;k[Wq>>2]=z;k[f>>2]=e;G1(nr,2,Wq,5);a:do if((iq|0)<1)g=-1.0;else{oo=(d|0)==3;po=Wq+8|0;qo=Wq+12|0;ro=Wq+4|0;so=Xq+4|0;to=so+4|0;uo=fr+8|0;vo=fr+12|0;wo=fr+4|0;xo=ar+4|0;yo=Wq+8|0;zo=Wq+12|0;Ao=Wq+4|0;Bo=Xq+4|0;Co=Bo+4|0;Do=fr+8|0;Eo=fr+12|0;Fo=fr+4|0;Go=br+4|0;Ho=Wq+8|0;Io=Wq+12|0;Jo=Wq+4|0;Ko=Xq+4|0;Lo=Ko+4|0;Mo=fr+8|0;No=fr+12|0;Oo=fr+4|0;Po=cr+4|0;Qo=Wq+8|0;Ro=Wq+12|0;So=Wq+4|0;To=Xq+4|0;Uo=To+4|0;Vo=fr+8|0;Wo=fr+12|0;Xo=fr+4|0;Yo=dr+4|0;Zo=Wq+8|0;_o=Wq+12|0;$o=Wq+4|0;ap=Xq+4|0;bp=Xq+8|0;cp=Xq+12|0;dp=fr+4|0;ep=fr+8|0;fp=fr+12|0;gp=lr+8|0;hp=lr+12|0;ip=lr+4|0;jp=Wq+8|0;kp=Wq+12|0;lp=Wq+4|0;mp=Xq+4|0;np=Xq+8|0;op=Xq+12|0;pp=fr+4|0;qp=fr+8|0;rp=fr+12|0;sp=lr+8|0;tp=lr+12|0;up=lr+4|0;vp=Wq+8|0;wp=Wq+12|0;xp=Wq+4|0;yp=Xq+8|0;zp=Xq+12|0;Ap=Xq+4|0;Bp=fr+4|0;b=Bp+4|0;c=lr+8|0;v=lr+12|0;f=lr+4|0;e=Bs+12|0;h=Wq+8|0;w=Wq+12|0;x=Wq+4|0;y=Xq+8|0;z=Xq+12|0;A=Xq+4|0;B=fr+4|0;C=B+4|0;D=lr+8|0;E=lr+12|0;N=lr+4|0;O=Wq+8|0;R=Wq+12|0;U=Wq+4|0;V=Wq+8|0;X=Wq+12|0;Y=Wq+4|0;Z=Wq+8|0;_=Wq+12|0;$=Wq+4|0;ba=Wq+4|0;ca=Wq+8|0;da=Wq+12|0;ea=Wq+4|0;fa=Wq+8|0;ga=Wq+12|0;ha=Wq+4|0;ia=(d|0)==0;ja=(d|0)==1;ka=(d|0)==2;Cp=d>>>0<4;la=Wq+4|0;ma=pr+12|0;na=Wq+4|0;oa=Wq+4|0;pa=Is+16|0;qa=pr+16|0;ra=Wq+4|0;sa=Wq+4|0;ta=Wq+4|0;ua=Wq+4|0;va=Wq+4|0;wa=Wq+4|0;xa=Wq+4|0;ya=Wq+4|0;za=Lr+12|0;Aa=Vr+12|0;Ba=Wq+4|0;Ca=Xq+4|0;Da=Xq+8|0;Ea=Xq+12|0;Fa=Xq+4|0;Ga=fr+36|0;Ha=fr+16|0;Ia=fr+4|0;Ja=fr+40|0;Ka=fr+44|0;La=fr+48|0;Ma=Wq+4|0;Na=Xq+4|0;Oa=Xq+8|0;Pa=Xq+12|0;Qa=Xq+4|0;Ra=lr+36|0;Sa=lr+16|0;Ta=lr+4|0;Ua=lr+40|0;Va=lr+44|0;Wa=lr+48|0;Xa=Wq+4|0;Ya=Xq+4|0;Za=Xq+8|0;_a=Xq+12|0;$a=Xq+4|0;ab=mr+36|0;bb=mr+16|0;cb=mr+4|0;db=mr+40|0;eb=mr+44|0;fb=mr+48|0;gb=Wq+4|0;hb=Xq+4|0;ib=Xq+8|0;jb=Xq+12|0;kb=Xq+4|0;lb=Gq+36|0;mb=Gq+16|0;nb=Gq+4|0;ob=Gq+40|0;pb=Gq+44|0;qb=Gq+48|0;rb=Wq+4|0;sb=Xq+4|0;tb=Hq+4|0;ub=tb+4|0;vb=Iq+36|0;wb=Iq+16|0;xb=Iq+4|0;yb=Iq+40|0;zb=Iq+44|0;Ab=Iq+48|0;Bb=Wq+4|0;Cb=Xq+4|0;Db=Hq+4|0;Eb=Db+4|0;Fb=Iq+36|0;Gb=Iq+16|0;Hb=Iq+4|0;Ib=Iq+40|0;Jb=Iq+44|0;Kb=Iq+48|0;Lb=Wq+4|0;Mb=Wq+4|0;Nb=Wq+4|0;Ob=Wq+4|0;Pb=Wq+4|0;Qb=Wq+4|0;Rb=Wq+4|0;Sb=Gq+8|0;Tb=fr+4|0;Ub=fr+8|0;Vb=fr+40|0;Wb=fr+48|0;Xb=fr+44|0;Yb=fr+52|0;Zb=mr+4|0;_b=mr+8|0;$b=mr+40|0;ac=mr+48|0;bc=mr+44|0;cc=mr+52|0;dc=Xq+8|0;ec=Xq+12|0;fc=Xq+4|0;gc=Gq+8|0;hc=Gq+12|0;ic=Gq+4|0;jc=Iq+4|0;kc=jc+4|0;lc=Gq+4|0;mc=Gq+8|0;nc=Gq+40|0;oc=Gq+48|0;pc=Gq+44|0;qc=Gq+52|0;rc=Xq+8|0;sc=Xq+12|0;tc=Xq+4|0;uc=Iq+8|0;vc=Iq+12|0;wc=Iq+4|0;xc=Jq+4|0;yc=xc+4|0;zc=Iq+4|0;Ac=Iq+8|0;Bc=Iq+40|0;Cc=Iq+48|0;Dc=Iq+44|0;Ec=Iq+52|0;Fc=Jq+4|0;Gc=Jq+8|0;Hc=Jq+40|0;Ic=Jq+48|0;Jc=Jq+44|0;Kc=Jq+52|0;Lc=Xq+8|0;Mc=Xq+12|0;Nc=Xq+4|0;Oc=Lq+8|0;Pc=Lq+12|0;Qc=Lq+4|0;Rc=Mq+4|0;Sc=Rc+4|0;Tc=Xq+8|0;Uc=Xq+12|0;Vc=Xq+4|0;Wc=Lq+8|0;Xc=Lq+12|0;Yc=Lq+4|0;Zc=Mq+4|0;_c=Zc+4|0;$c=Wq+4|0;ad=Xq+4|0;bd=Xq+8|0;cd=Xq+12|0;dd=Xq+4|0;ed=Nq+36|0;fd=Nq+16|0;gd=Nq+4|0;hd=Nq+40|0;id=Nq+44|0;jd=Nq+48|0;kd=Wq+4|0;ld=Xq+4|0;md=Xq+8|0;nd=Xq+12|0;od=Xq+4|0;pd=Oq+36|0;qd=Oq+16|0;rd=Oq+4|0;sd=Oq+40|0;td=Oq+44|0;ud=Oq+48|0;vd=Xq+8|0;wd=Xq+12|0;xd=Xq+4|0;yd=Qq+8|0;zd=Qq+12|0;Ad=Qq+4|0;Bd=Lq+4|0;Cd=Lq+8|0;Dd=Lq+40|0;Ed=Lq+48|0;Fd=Lq+44|0;Gd=Lq+52|0;Hd=Wq+4|0;Id=Xq+4|0;Jd=Xq+8|0;Kd=Xq+12|0;Ld=Xq+4|0;Md=Rq+36|0;Nd=Rq+16|0;Od=Rq+4|0;Pd=Rq+40|0;Qd=Rq+44|0;Rd=Rq+48|0;Sd=mr+36|0;Td=mr+16|0;Ud=Gq+36|0;Vd=Gq+16|0;Wd=Wq+4|0;Xd=Xq+4|0;Yd=Xq+8|0;Zd=Xq+12|0;_d=Xq+4|0;$d=Sq+36|0;ae=Sq+16|0;be=Sq+4|0;ce=Sq+40|0;de=Sq+44|0;ee=Sq+48|0;fe=Wq+4|0;ge=Xq+4|0;he=Xq+8|0;ie=Xq+12|0;je=Xq+4|0;ke=Tq+36|0;le=Tq+16|0;me=Tq+4|0;ne=Tq+40|0;oe=Tq+44|0;pe=Tq+48|0;qe=Wq+4|0;re=Xq+4|0;se=Xq+8|0;te=Xq+12|0;ue=Xq+4|0;ve=Uq+36|0;we=Uq+16|0;xe=Uq+4|0;ye=Uq+40|0;ze=Uq+44|0;Ae=Uq+48|0;Be=Wq+4|0;Ce=Xq+4|0;De=Mq+4|0;Ee=De+4|0;Fe=Qq+36|0;Ge=Qq+16|0;He=Qq+4|0;Ie=Qq+40|0;Je=Qq+44|0;Ke=Qq+48|0;Le=Wq+4|0;Me=Xq+4|0;Ne=Mq+4|0;Oe=Ne+4|0;Pe=Qq+36|0;Qe=Qq+16|0;Re=Qq+4|0;Se=Qq+40|0;Te=Qq+44|0;Ue=Qq+48|0;Ve=Lq+36|0;We=Lq+16|0;Xe=Jq+36|0;Ye=Jq+16|0;Ze=Iq+36|0;_e=Iq+16|0;$e=fr+36|0;af=fr+16|0;bf=Wq+4|0;cf=Wq+4|0;df=Wq+4|0;ef=Wq+4|0;ff=Wq+4|0;gf=Wq+4|0;hf=Wq+4|0;jf=Xq+4|0;kf=fr+4|0;lf=kf+4|0;mf=lr+36|0;nf=lr+16|0;of=lr+4|0;pf=lr+40|0;qf=lr+44|0;rf=lr+48|0;sf=Wq+4|0;tf=Xq+4|0;uf=fr+4|0;vf=uf+4|0;wf=lr+36|0;xf=lr+16|0;yf=lr+4|0;zf=lr+40|0;Af=lr+44|0;Bf=lr+48|0;Cf=Wq+4|0;Df=Wq+4|0;Ef=Wq+4|0;Ff=Wq+4|0;Gf=Wq+4|0;Hf=fr+4|0;If=fr+8|0;Jf=fr+40|0;Kf=fr+48|0;Lf=fr+44|0;Mf=fr+52|0;Nf=mr+4|0;Of=mr+8|0;Pf=mr+40|0;Qf=mr+48|0;Rf=mr+44|0;Sf=mr+52|0;Tf=Wq+4|0;Uf=Xq+4|0;Vf=Iq+8|0;Wf=Iq+12|0;Xf=Iq+4|0;Yf=Kq+8|0;Zf=Kq+12|0;_f=Kq+4|0;$f=Hq+36|0;ag=Hq+16|0;bg=Hq+4|0;cg=Hq+40|0;dg=Hq+44|0;eg=Hq+48|0;fg=Wq+4|0;gg=Xq+4|0;hg=Iq+4|0;ig=hg+4|0;jg=Jq+36|0;kg=Jq+16|0;lg=Jq+4|0;mg=Jq+40|0;ng=Jq+44|0;og=Jq+48|0;pg=Wq+4|0;qg=Xq+4|0;rg=Iq+4|0;sg=rg+4|0;tg=Jq+36|0;ug=Jq+16|0;vg=Jq+4|0;wg=Jq+40|0;xg=Jq+44|0;yg=Jq+48|0;zg=mr+36|0;Ag=mr+16|0;Bg=fr+36|0;Cg=fr+16|0;Dg=Wq+4|0;Eg=Wq+4|0;Fg=Wq+4|0;Gg=Wq+4|0;Hg=Wq+4|0;Ig=Wq+4|0;Jg=Wq+8|0;Kg=Wq+12|0;Lg=Wq+4|0;Mg=Xq+4|0;Ng=Mg+4|0;Og=fr+8|0;Pg=fr+12|0;Qg=fr+4|0;Rg=Yq+4|0;Sg=Wq+8|0;Tg=Wq+12|0;Ug=Wq+4|0;Vg=Xq+4|0;Wg=Vg+4|0;Xg=fr+8|0;Yg=fr+12|0;Zg=fr+4|0;_g=Zq+4|0;$g=Wq+8|0;ah=Wq+12|0;bh=Wq+4|0;ch=Xq+4|0;eh=ch+4|0;fh=fr+8|0;gh=fr+12|0;hh=fr+4|0;ih=_q+4|0;kh=Wq+8|0;lh=Wq+12|0;mh=Wq+4|0;oh=Xq+4|0;ph=oh+4|0;qh=fr+8|0;rh=fr+12|0;sh=fr+4|0;th=$q+4|0;uh=Xq+4|0;vh=Xq+8|0;wh=Xq+12|0;xh=Xq+16|0;yh=Xq+48|0;zh=Xq+56|0;Ah=Xq+52|0;Bh=Xq+60|0;Ch=Xq+64|0;Dh=Xq+68|0;Eh=Xq+72|0;Fh=Xq+104|0;Gh=Xq+112|0;Hh=Xq+108|0;Ih=Xq+116|0;Jh=Xq+120|0;Kh=Xq+124|0;Lh=Xq+128|0;Mh=Xq+160|0;Nh=Xq+168|0;Oh=Xq+164|0;Ph=Wq+4|0;Qh=Wq+4|0;Rh=Wq+8|0;Sh=Wq+12|0;Th=Wq+16|0;Uh=Wq+48|0;Vh=Wq+56|0;Wh=Wq+52|0;Xh=Wq+60|0;Yh=Wq+64|0;Zh=Wq+68|0;_h=Wq+72|0;$h=Wq+104|0;ai=Wq+112|0;bi=Wq+108|0;ci=Wq+116|0;di=Wq+120|0;ei=Wq+124|0;fi=Wq+128|0;gi=Wq+160|0;hi=Wq+168|0;ii=Wq+164|0;ji=Xq+4|0;ki=Xq+8|0;li=Xq+12|0;mi=Xq+16|0;ni=Xq+48|0;oi=Xq+56|0;pi=Xq+52|0;qi=Xq+60|0;ri=Xq+64|0;si=Xq+68|0;ti=Xq+72|0;ui=Xq+104|0;vi=Xq+112|0;wi=Xq+108|0;xi=Xq+116|0;yi=Xq+120|0;zi=Xq+124|0;Ai=Xq+128|0;Bi=Xq+160|0;Ci=Xq+168|0;Di=Xq+164|0;Ei=Iq+32|0;Fi=Iq+32|0;Gi=Gq+32|0;Hi=mr+32|0;Ii=lr+32|0;Ji=fr+32|0;Ki=Wq+4|0;Li=Wq+8|0;Mi=Wq+12|0;Ni=Wq+16|0;Oi=Wq+48|0;Pi=Wq+56|0;Qi=Wq+52|0;Ri=Wq+60|0;Si=Wq+64|0;Ti=Wq+68|0;Ui=Wq+72|0;Vi=Wq+104|0;Wi=Wq+112|0;Xi=Wq+108|0;Yi=Wq+116|0;Zi=Wq+120|0;_i=Wq+124|0;$i=Wq+128|0;aj=Wq+160|0;bj=Wq+168|0;cj=Wq+164|0;dj=lr+4|0;ej=lr+8|0;fj=lr+12|0;gj=lr+16|0;hj=lr+48|0;ij=lr+56|0;jj=lr+52|0;kj=lr+60|0;lj=lr+64|0;mj=lr+68|0;nj=lr+72|0;oj=lr+104|0;pj=lr+112|0;qj=lr+108|0;rj=lr+116|0;sj=lr+120|0;tj=lr+124|0;uj=lr+128|0;vj=lr+160|0;wj=lr+168|0;xj=lr+164|0;yj=Gq+4|0;zj=Gq+8|0;Aj=Gq+12|0;Bj=Gq+16|0;Cj=Gq+48|0;Dj=Gq+56|0;Ej=Gq+52|0;Fj=Gq+60|0;Gj=Gq+64|0;Hj=Gq+68|0;Ij=Gq+72|0;Jj=Gq+104|0;Kj=Gq+112|0;Lj=Gq+108|0;Mj=Gq+116|0;Nj=Gq+120|0;Oj=Gq+124|0;Pj=Gq+128|0;Qj=Gq+160|0;Rj=Gq+168|0;Sj=Gq+164|0;Tj=Xq+4|0;Uj=Xq+8|0;Vj=Xq+12|0;Wj=Xq+16|0;Xj=Xq+48|0;Yj=Xq+56|0;Zj=Xq+52|0;_j=Xq+60|0;$j=Xq+64|0;ak=Xq+68|0;bk=Xq+72|0;ck=Xq+104|0;dk=Xq+112|0;ek=Xq+108|0;fk=Xq+116|0;gk=Xq+120|0;hk=Xq+124|0;ik=Xq+128|0;jk=Xq+160|0;kk=Xq+168|0;lk=Xq+164|0;mk=Hq+4|0;nk=Hq+8|0;ok=Hq+12|0;pk=Hq+16|0;qk=Hq+48|0;rk=Hq+56|0;sk=Hq+52|0;tk=Hq+60|0;uk=Hq+64|0;vk=Hq+68|0;wk=Hq+72|0;xk=Hq+104|0;yk=Hq+112|0;zk=Hq+108|0;Ak=Hq+116|0;Bk=Hq+120|0;Ck=Hq+124|0;Dk=Hq+128|0;Ek=Hq+160|0;Fk=Hq+168|0;Gk=Hq+164|0;Hk=Wq+8|0;Ik=Wq+16|0;Jk=Wq+24|0;Kk=Iq+4|0;Lk=Iq+8|0;Mk=Iq+12|0;Nk=Iq+16|0;Ok=Iq+48|0;Pk=Iq+56|0;Qk=Iq+52|0;Rk=Iq+60|0;Sk=Iq+64|0;Tk=Iq+68|0;Uk=Iq+72|0;Vk=Iq+104|0;Wk=Iq+112|0;Xk=Iq+108|0;Yk=Iq+116|0;Zk=Iq+120|0;_k=Iq+124|0;$k=Iq+128|0;al=Iq+160|0;bl=Iq+168|0;cl=Iq+164|0;dl=Xq+4|0;el=Xq+8|0;fl=Xq+12|0;gl=Xq+16|0;hl=Xq+48|0;il=Xq+56|0;jl=Xq+52|0;kl=Xq+60|0;ll=Xq+64|0;ml=Xq+68|0;nl=Xq+72|0;ol=Xq+104|0;pl=Xq+112|0;ql=Xq+108|0;rl=Xq+116|0;sl=Xq+120|0;tl=Xq+124|0;ul=Xq+128|0;vl=Xq+160|0;wl=Xq+168|0;xl=Xq+164|0;yl=Kq+4|0;zl=Kq+8|0;Al=Kq+12|0;Bl=Kq+16|0;Cl=Kq+48|0;Dl=Kq+56|0;El=Kq+52|0;Fl=Kq+60|0;Gl=Kq+64|0;Hl=Kq+68|0;Il=Kq+72|0;Jl=Kq+104|0;Kl=Kq+112|0;Ll=Kq+108|0;Ml=Kq+116|0;Nl=Kq+120|0;Ol=Kq+124|0;Pl=Kq+128|0;Ql=Kq+160|0;Rl=Kq+168|0;Sl=Kq+164|0;Tl=Wq+8|0;Ul=Wq+16|0;Vl=Wq+24|0;Wl=Pq+4|0;Xl=Pq+8|0;Yl=Pq+12|0;Zl=Pq+16|0;_l=Pq+48|0;$l=Pq+56|0;am=Pq+52|0;bm=Pq+60|0;cm=Pq+64|0;dm=Pq+68|0;em=Pq+72|0;fm=Pq+104|0;gm=Pq+112|0;hm=Pq+108|0;im=Pq+116|0;jm=Pq+120|0;km=Pq+124|0;lm=Pq+128|0;mm=Pq+160|0;nm=Pq+168|0;om=Pq+164|0;pm=fr+32|0;qm=mr+32|0;rm=Gq+32|0;sm=Iq+32|0;tm=Jq+32|0;um=Lq+32|0;vm=Qq+32|0;wm=Qq+32|0;xm=Uq+32|0;ym=Tq+32|0;zm=Sq+32|0;Am=Rq+32|0;Bm=Oq+32|0;Cm=Nq+32|0;Dm=lr+32|0;Em=lr+32|0;Fm=Xq+4|0;Gm=Xq+8|0;Hm=Xq+12|0;Im=Xq+16|0;Jm=Xq+48|0;Km=Xq+56|0;Lm=Xq+52|0;Mm=Xq+60|0;Nm=Xq+64|0;Om=Xq+68|0;Pm=Xq+72|0;Qm=Xq+104|0;Rm=Xq+112|0;Sm=Xq+108|0;Tm=Xq+116|0;Um=Xq+120|0;Vm=Xq+124|0;Wm=Xq+128|0;Xm=Xq+160|0;Ym=Xq+168|0;Zm=Xq+164|0;_m=lr+4|0;$m=lr+8|0;an=lr+12|0;bn=lr+16|0;cn=lr+48|0;dn=lr+56|0;en=lr+52|0;fn=lr+60|0;gn=lr+64|0;hn=lr+68|0;jn=lr+72|0;kn=lr+104|0;ln=lr+112|0;mn=lr+108|0;nn=lr+116|0;on=lr+120|0;pn=lr+124|0;qn=lr+128|0;rn=lr+160|0;sn=lr+168|0;tn=lr+164|0;un=Gq+4|0;vn=Gq+8|0;wn=Gq+12|0;xn=Gq+16|0;yn=Gq+48|0;zn=Gq+56|0;An=Gq+52|0;Bn=Gq+60|0;Cn=Gq+64|0;Dn=Gq+68|0;En=Gq+72|0;Fn=Gq+104|0;Gn=Gq+112|0;Hn=Gq+108|0;In=Gq+116|0;Jn=Gq+120|0;Kn=Gq+124|0;Ln=Gq+128|0;Mn=Gq+160|0;Nn=Gq+168|0;On=Gq+164|0;Pn=Wq+4|0;Qn=Wq+8|0;Rn=Wq+12|0;Sn=Wq+16|0;Tn=Wq+48|0;Un=Wq+56|0;Vn=Wq+52|0;Wn=Wq+60|0;Xn=Wq+64|0;Yn=Wq+68|0;Zn=Wq+72|0;_n=Wq+104|0;$n=Wq+112|0;ao=Wq+108|0;bo=Wq+116|0;co=Wq+120|0;eo=Wq+124|0;fo=Wq+128|0;go=Wq+160|0;ho=Wq+168|0;io=Wq+164|0;jo=fr+32|0;ko=mr+32|0;lo=Jq+32|0;mo=Jq+32|0;no=Hq+32|0;g=-1.0;F=-hq;t=1;while(1){if(!(+P(+(g-F))>=hq))break a;if(oo){k[po>>2]=0;k[qo>>2]=0;k[Wq>>2]=16842752;k[ro>>2]=zs;s=to;k[s>>2]=0;k[s+4>>2]=0;k[Xq>>2]=33619968;k[so>>2]=ys;k[uo>>2]=0;k[vo>>2]=0;k[fr>>2]=16842752;k[wo>>2]=Is;s=k[Hr>>2]|0;q=k[s>>2]|0;k[ar>>2]=k[s+4>>2];k[xo>>2]=q;k[lr>>2]=0;k[lr+4>>2]=0;k[lr+8>>2]=0;k[lr+12>>2]=0;k[lr+16>>2]=0;k[lr+20>>2]=0;k[lr+24>>2]=0;k[lr+28>>2]=0;loa(Wq,Xq,fr,ar,17,0,lr);k[yo>>2]=0;k[zo>>2]=0;k[Wq>>2]=16842752;k[Ao>>2]=$r;q=Co;k[q>>2]=0;k[q+4>>2]=0;k[Xq>>2]=33619968;k[Bo>>2]=Vr;k[Do>>2]=0;k[Eo>>2]=0;k[fr>>2]=16842752;k[Fo>>2]=Is;q=k[wq>>2]|0;s=k[q>>2]|0;k[br>>2]=k[q+4>>2];k[Go>>2]=s;k[lr>>2]=0;k[lr+4>>2]=0;k[lr+8>>2]=0;k[lr+12>>2]=0;k[lr+16>>2]=0;k[lr+20>>2]=0;k[lr+24>>2]=0;k[lr+28>>2]=0;loa(Wq,Xq,fr,br,17,0,lr);k[Ho>>2]=0;k[Io>>2]=0;k[Wq>>2]=16842752;k[Jo>>2]=_r;s=Lo;k[s>>2]=0;k[s+4>>2]=0;k[Xq>>2]=33619968;k[Ko>>2]=Qr;k[Mo>>2]=0;k[No>>2]=0;k[fr>>2]=16842752;k[Oo>>2]=Is;s=k[sq>>2]|0;q=k[s>>2]|0;k[cr>>2]=k[s+4>>2];k[Po>>2]=q;k[lr>>2]=0;k[lr+4>>2]=0;k[lr+8>>2]=0;k[lr+12>>2]=0;k[lr+16>>2]=0;k[lr+20>>2]=0;k[lr+24>>2]=0;k[lr+28>>2]=0;loa(Wq,Xq,fr,cr,17,0,lr);k[Qo>>2]=0;k[Ro>>2]=0;k[Wq>>2]=16842752;k[So>>2]=fs;q=Uo;k[q>>2]=0;k[q+4>>2]=0;k[Xq>>2]=33619968;k[To>>2]=ss;k[Vo>>2]=0;k[Wo>>2]=0;k[fr>>2]=16842752;k[Xo>>2]=Is;q=k[Cr>>2]|0;s=k[q>>2]|0;k[dr>>2]=k[q+4>>2];k[Yo>>2]=s;k[lr>>2]=0;k[lr+4>>2]=0;k[lr+8>>2]=0;k[lr+12>>2]=0;k[lr+16>>2]=0;k[lr+20>>2]=0;k[lr+24>>2]=0;k[lr+28>>2]=0;loa(Wq,Xq,fr,dr,16,0,lr)}else{k[Jg>>2]=0;k[Kg>>2]=0;k[Wq>>2]=16842752;k[Lg>>2]=zs;s=Ng;k[s>>2]=0;k[s+4>>2]=0;k[Xq>>2]=33619968;k[Mg>>2]=ys;k[Og>>2]=0;k[Pg>>2]=0;k[fr>>2]=16842752;k[Qg>>2]=Is;s=k[Hr>>2]|0;q=k[s>>2]|0;k[Yq>>2]=k[s+4>>2];k[Rg>>2]=q;k[lr>>2]=0;k[lr+4>>2]=0;k[lr+8>>2]=0;k[lr+12>>2]=0;k[lr+16>>2]=0;k[lr+20>>2]=0;k[lr+24>>2]=0;k[lr+28>>2]=0;hoa(Wq,Xq,fr,Yq,17,0,lr);k[Sg>>2]=0;k[Tg>>2]=0;k[Wq>>2]=16842752;k[Ug>>2]=$r;q=Wg;k[q>>2]=0;k[q+4>>2]=0;k[Xq>>2]=33619968;k[Vg>>2]=Vr;k[Xg>>2]=0;k[Yg>>2]=0;k[fr>>2]=16842752;k[Zg>>2]=Is;q=k[wq>>2]|0;s=k[q>>2]|0;k[Zq>>2]=k[q+4>>2];k[_g>>2]=s;k[lr>>2]=0;k[lr+4>>2]=0;k[lr+8>>2]=0;k[lr+12>>2]=0;k[lr+16>>2]=0;k[lr+20>>2]=0;k[lr+24>>2]=0;k[lr+28>>2]=0;hoa(Wq,Xq,fr,Zq,17,0,lr);k[$g>>2]=0;k[ah>>2]=0;k[Wq>>2]=16842752;k[bh>>2]=_r;s=eh;k[s>>2]=0;k[s+4>>2]=0;k[Xq>>2]=33619968;k[ch>>2]=Qr;k[fh>>2]=0;k[gh>>2]=0;k[fr>>2]=16842752;k[hh>>2]=Is;s=k[sq>>2]|0;q=k[s>>2]|0;k[_q>>2]=k[s+4>>2];k[ih>>2]=q;k[lr>>2]=0;k[lr+4>>2]=0;k[lr+8>>2]=0;k[lr+12>>2]=0;k[lr+16>>2]=0;k[lr+20>>2]=0;k[lr+24>>2]=0;k[lr+28>>2]=0;hoa(Wq,Xq,fr,_q,17,0,lr);k[kh>>2]=0;k[lh>>2]=0;k[Wq>>2]=16842752;k[mh>>2]=fs;q=ph;k[q>>2]=0;k[q+4>>2]=0;k[Xq>>2]=33619968;k[oh>>2]=ss;k[qh>>2]=0;k[rh>>2]=0;k[fr>>2]=16842752;k[sh>>2]=Is;q=k[Cr>>2]|0;s=k[q>>2]|0;k[$q>>2]=k[q+4>>2];k[th>>2]=s;k[lr>>2]=0;k[lr+4>>2]=0;k[lr+8>>2]=0;k[lr+12>>2]=0;k[lr+16>>2]=0;k[lr+20>>2]=0;k[lr+24>>2]=0;k[lr+28>>2]=0;hoa(Wq,Xq,fr,$q,16,0,lr)};k[er>>2]=0;k[er+4>>2]=0;k[er+8>>2]=0;k[er+12>>2]=0;k[er+16>>2]=0;k[er+20>>2]=0;k[er+24>>2]=0;k[er+28>>2]=0;k[gr>>2]=0;k[gr+4>>2]=0;k[gr+8>>2]=0;k[gr+12>>2]=0;k[gr+16>>2]=0;k[gr+20>>2]=0;k[gr+24>>2]=0;k[gr+28>>2]=0;k[hr>>2]=0;k[hr+4>>2]=0;k[hr+8>>2]=0;k[hr+12>>2]=0;k[hr+16>>2]=0;k[hr+20>>2]=0;k[hr+24>>2]=0;k[hr+28>>2]=0;k[ir>>2]=0;k[ir+4>>2]=0;k[ir+8>>2]=0;k[ir+12>>2]=0;k[ir+16>>2]=0;k[ir+20>>2]=0;k[ir+24>>2]=0;k[ir+28>>2]=0;k[Zo>>2]=0;k[_o>>2]=0;k[Wq>>2]=16842752;k[$o>>2]=ys;k[Xq>>2]=-1040056314;k[ap>>2]=er;k[bp>>2]=1;k[cp>>2]=4;k[fr>>2]=-1040056314;k[dp>>2]=gr;k[ep>>2]=1;k[fp>>2]=4;k[gp>>2]=0;k[hp>>2]=0;k[lr>>2]=16842752;k[ip>>2]=ss;v7(Wq,Xq,fr,lr);k[jp>>2]=0;k[kp>>2]=0;k[Wq>>2]=16842752;k[lp>>2]=As;k[Xq>>2]=-1040056314;k[mp>>2]=hr;k[np>>2]=1;k[op>>2]=4;k[fr>>2]=-1040056314;k[pp>>2]=ir;k[qp>>2]=1;k[rp>>2]=4;k[sp>>2]=0;k[tp>>2]=0;k[lr>>2]=16842752;k[up>>2]=ss;v7(Wq,Xq,fr,lr);k[vp>>2]=0;k[wp>>2]=0;k[Wq>>2]=16842752;k[xp>>2]=ys;k[Xq>>2]=-1056833530;k[Ap>>2]=er;k[yp>>2]=1;k[zp>>2]=4;a=b;k[a>>2]=0;k[a+4>>2]=0;k[fr>>2]=33619968;k[Bp>>2]=ys;k[c>>2]=0;k[v>>2]=0;k[lr>>2]=16842752;k[f>>2]=ss;sU(Wq,Xq,fr,lr,-1,39968,0,0);a=k[_p>>2]|0;j=k[e>>2]|0;l=k[Bs>>2]&4095;k[Xq>>2]=0;k[uh>>2]=0;k[vh>>2]=1124007936;n=wh;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[yh>>2]=xh;k[Ah>>2]=zh;k[Bh>>2]=0;k[zh>>2]=0;k[Ch>>2]=1124007936;n=Dh;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Fh>>2]=Eh;k[Hh>>2]=Gh;k[Ih>>2]=0;k[Gh>>2]=0;k[Jh>>2]=1124007936;n=Kh;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Mh>>2]=Lh;k[Oh>>2]=Nh;n=Nh;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Wq>>2]=j;k[Ph>>2]=a;j1(Xq,48,Wq,l);s=k[Xq>>2]|0;dh[k[(k[s>>2]|0)+12>>2]&255](s,Xq,Bs,-1);XN(Xq);k[h>>2]=0;k[w>>2]=0;k[Wq>>2]=16842752;k[x>>2]=As;k[Xq>>2]=-1056833530;k[A>>2]=hr;k[y>>2]=1;k[z>>2]=4;s=C;k[s>>2]=0;k[s+4>>2]=0;k[fr>>2]=33619968;k[B>>2]=Bs;k[D>>2]=0;k[E>>2]=0;k[lr>>2]=16842752;k[N>>2]=ss;sU(Wq,Xq,fr,lr,-1,39968,0,0);k[O>>2]=0;k[R>>2]=0;k[Wq>>2]=16842752;k[U>>2]=ss;K=+(o7(Wq)|0);L=+p[ir>>3];L=+Q(+(L*(K*L)));k[V>>2]=0;k[X>>2]=0;k[Wq>>2]=16842752;k[Y>>2]=ss;K=+(o7(Wq)|0);M=+p[gr>>3];M=+Q(+(M*(K*M)));switch(d|0){case 2:{j=k[wq>>2]|0;a=k[j+4>>2]|0;j=k[j>>2]|0;s=k[sq>>2]|0;if(!((j|0)==(k[s>>2]|0)?(a|0)==(k[s+4>>2]|0):0)){k[Wq>>2]=0;k[Qb>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Qb>>2]=26;i[a+30>>0]=0;l=402082;s=n+26|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402109,401651,167);k[Qb>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0);j=k[wq>>2]|0;a=k[j+4>>2]|0;j=k[j>>2]|0}s=k[hs>>2]|0;if(!((j|0)==(k[s>>2]|0)?(a|0)==(k[s+4>>2]|0):0)){k[Wq>>2]=0;k[Pb>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Pb>>2]=26;i[a+30>>0]=0;l=402135;s=n+26|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402109,401651,168);k[Pb>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0);j=k[wq>>2]|0;a=k[j+4>>2]|0;j=k[j>>2]|0}s=k[bs>>2]|0;if(!((j|0)==(k[s>>2]|0)?(a|0)==(k[s+4>>2]|0):0)){k[Wq>>2]=0;k[Ob>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Ob>>2]=26;i[a+30>>0]=0;l=402162;s=n+26|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402109,401651,169);k[Ob>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[Jp>>2]|0)!=(k[Ep>>2]|0)){k[Wq>>2]=0;k[Nb>>2]=0;a=ZT(28)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Nb>>2]=21;i[a+25>>0]=0;l=402189;s=n+21|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402109,401651,171);k[Nb>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[za>>2]|0)!=((k[Aa>>2]|0)*6|0)){k[Wq>>2]=0;k[Mb>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Mb>>2]=25;i[a+29>>0]=0;l=402211;s=n+25|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402109,401651,172);k[Mb>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[Lr>>2]&4095|0)!=5){k[Wq>>2]=0;k[Lb>>2]=0;a=ZT(28)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Lb>>2]=22;i[a+26>>0]=0;l=402237;s=n+22|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402109,401651,174);k[Lb>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}q=k[Aa>>2]|0;k[Wq>>2]=-2147483648;k[Ba>>2]=2147483647;k[Xq>>2]=0;k[Ca>>2]=q;H1(fr,Lr,Wq,Xq);k[Da>>2]=0;k[Ea>>2]=0;k[Xq>>2]=16842752;k[Fa>>2]=Es;i1(Wq,Vr,Xq,1.0);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,fr,-1);XN(Wq);a=k[Ga>>2]|0;do if(a|0){n=a+12|0;s=k[n>>2]|0;k[n>>2]=s+-1;if((s|0)!=1)break;j=k[Ga>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Ji>>2]|0;if(a|0)break;a=B1()|0;j=k[Ga>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Ga>>2]=0}while(0);k[Ga>>2]=0;k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ha+8>>2]=0;k[Ha+12>>2]=0;if((k[Ia>>2]|0)>0){j=k[Ja>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Ia>>2]|0))}a=k[Ka>>2]|0;if(!((a|0)==(La|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=q<<1;k[Wq>>2]=-2147483648;k[Ma>>2]=2147483647;k[Xq>>2]=q;k[Na>>2]=l;H1(lr,Lr,Wq,Xq);k[Oa>>2]=0;k[Pa>>2]=0;k[Xq>>2]=16842752;k[Qa>>2]=Es;i1(Wq,Qr,Xq,1.0);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,lr,-1);XN(Wq);a=k[Ra>>2]|0;do if(a|0){n=a+12|0;s=k[n>>2]|0;k[n>>2]=s+-1;if((s|0)!=1)break;j=k[Ra>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Ii>>2]|0;if(a|0)break;a=B1()|0;j=k[Ra>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Ra>>2]=0}while(0);k[Ra>>2]=0;k[Sa>>2]=0;k[Sa+4>>2]=0;k[Sa+8>>2]=0;k[Sa+12>>2]=0;if((k[Ta>>2]|0)>0){j=k[Ua>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Ta>>2]|0))}a=k[Va>>2]|0;if(!((a|0)==(Wa|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=q*3|0;k[Wq>>2]=-2147483648;k[Xa>>2]=2147483647;k[Xq>>2]=l;k[Ya>>2]=m;H1(mr,Lr,Wq,Xq);k[Za>>2]=0;k[_a>>2]=0;k[Xq>>2]=16842752;k[$a>>2]=Cs;i1(Wq,Vr,Xq,1.0);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,mr,-1);XN(Wq);a=k[ab>>2]|0;do if(a|0){n=a+12|0;s=k[n>>2]|0;k[n>>2]=s+-1;if((s|0)!=1)break;j=k[ab>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Hi>>2]|0;if(a|0)break;a=B1()|0;j=k[ab>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[ab>>2]=0}while(0);k[ab>>2]=0;k[bb>>2]=0;k[bb+4>>2]=0;k[bb+8>>2]=0;k[bb+12>>2]=0;if((k[cb>>2]|0)>0){j=k[db>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[cb>>2]|0))}a=k[eb>>2]|0;if(!((a|0)==(fb|0)|(a|0)==0))ggb(k[a+-4>>2]|0);n=q<<2;k[Wq>>2]=-2147483648;k[gb>>2]=2147483647;k[Xq>>2]=m;k[hb>>2]=n;H1(Gq,Lr,Wq,Xq);k[ib>>2]=0;k[jb>>2]=0;k[Xq>>2]=16842752;k[kb>>2]=Cs;i1(Wq,Qr,Xq,1.0);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,Gq,-1);XN(Wq);a=k[lb>>2]|0;do if(a|0){m=a+12|0;s=k[m>>2]|0;k[m>>2]=s+-1;if((s|0)!=1)break;j=k[lb>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Gi>>2]|0;if(a|0)break;a=B1()|0;j=k[lb>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[lb>>2]=0}while(0);k[lb>>2]=0;k[mb>>2]=0;k[mb+4>>2]=0;k[mb+8>>2]=0;k[mb+12>>2]=0;if((k[nb>>2]|0)>0){j=k[ob>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[nb>>2]|0))}a=k[pb>>2]|0;if(!((a|0)==(qb|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=q*5|0;k[Wq>>2]=-2147483648;k[rb>>2]=2147483647;k[Xq>>2]=n;k[sb>>2]=l;H1(Iq,Lr,Wq,Xq);a=ub;k[a>>2]=0;k[a+4>>2]=0;k[Hq>>2]=-1040121856;k[tb>>2]=Iq;mY(Vr,Hq);a=k[vb>>2]|0;do if(a|0){n=a+12|0;s=k[n>>2]|0;k[n>>2]=s+-1;if((s|0)!=1)break;j=k[vb>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Fi>>2]|0;if(a|0)break;a=B1()|0;j=k[vb>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[vb>>2]=0}while(0);k[vb>>2]=0;k[wb>>2]=0;k[wb+4>>2]=0;k[wb+8>>2]=0;k[wb+12>>2]=0;if((k[xb>>2]|0)>0){j=k[yb>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[xb>>2]|0))}a=k[zb>>2]|0;if(!((a|0)==(Ab|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[Wq>>2]=-2147483648;k[Bb>>2]=2147483647;k[Xq>>2]=l;k[Cb>>2]=q*6;H1(Iq,Lr,Wq,Xq);a=Eb;k[a>>2]=0;k[a+4>>2]=0;k[Hq>>2]=-1040121856;k[Db>>2]=Iq;mY(Qr,Hq);a=k[Fb>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[Fb>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Ei>>2]|0;if(a|0)break;a=B1()|0;j=k[Fb>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Fb>>2]=0}while(0);k[Fb>>2]=0;k[Gb>>2]=0;k[Gb+4>>2]=0;k[Gb+8>>2]=0;k[Gb+12>>2]=0;if((k[Hb>>2]|0)>0){j=k[Ib>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Hb>>2]|0))}a=k[Jb>>2]|0;if(!((a|0)==(Kb|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break}case 3:{j=k[wq>>2]|0;a=k[j+4>>2]|0;j=k[j>>2]|0;s=k[sq>>2]|0;if(!((j|0)==(k[s>>2]|0)?(a|0)==(k[s+4>>2]|0):0)){k[Wq>>2]=0;k[gf>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[gf>>2]=26;i[a+30>>0]=0;l=402082;s=n+26|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402260,401651,57);k[gf>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0);j=k[wq>>2]|0;a=k[j+4>>2]|0;j=k[j>>2]|0}s=k[hs>>2]|0;if(!((j|0)==(k[s>>2]|0)?(a|0)==(k[s+4>>2]|0):0)){k[Wq>>2]=0;k[ff>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[ff>>2]=26;i[a+30>>0]=0;l=402135;s=n+26|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402260,401651,58);k[ff>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0);j=k[wq>>2]|0;a=k[j+4>>2]|0;j=k[j>>2]|0}s=k[bs>>2]|0;if(!((j|0)==(k[s>>2]|0)?(a|0)==(k[s+4>>2]|0):0)){k[Wq>>2]=0;k[ef>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[ef>>2]=26;i[a+30>>0]=0;l=402162;s=n+26|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402260,401651,59);k[ef>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[Jp>>2]|0)!=(k[Ep>>2]|0)){k[Wq>>2]=0;k[df>>2]=0;a=ZT(28)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[df>>2]=21;i[a+25>>0]=0;l=402189;s=n+21|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402260,401651,61);k[df>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[za>>2]|0)!=(k[Aa>>2]<<3|0)){k[Wq>>2]=0;k[cf>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[cf>>2]=25;i[a+29>>0]=0;l=402284;s=n+25|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402260,401651,62);k[cf>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[Lr>>2]&4095|0)!=5){k[Wq>>2]=0;k[bf>>2]=0;a=ZT(28)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[bf>>2]=22;i[a+26>>0]=0;l=402237;s=n+22|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402260,401651,63);k[bf>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if(!(k[Is>>2]&16384)){k[Wq>>2]=0;k[Rb>>2]=0;a=ZT(24)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Rb>>2]=19;i[a+23>>0]=0;l=402310;s=n+19|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402260,401651,65);k[Rb>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}n=k[pa>>2]|0;I=+o[n>>2];G=+o[n+12>>2];J=+o[n+4>>2];K=+o[n+16>>2];Ms=+o[n+28>>2];H=+o[n+8>>2];F=+o[n+20>>2];q=k[Aa>>2]|0;b1(Xq,Es,+o[n+24>>2]);b1(mr,Cs,Ms);k[Wq>>2]=0;k[Ki>>2]=0;k[Li>>2]=1124007936;n=Mi;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Oi>>2]=Ni;k[Qi>>2]=Pi;k[Ri>>2]=0;k[Pi>>2]=0;k[Si>>2]=1124007936;n=Ti;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Vi>>2]=Ui;k[Xi>>2]=Wi;k[Yi>>2]=0;k[Wi>>2]=0;k[Zi>>2]=1124007936;n=_i;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[aj>>2]=$i;k[cj>>2]=bj;n=bj;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));n=k[Xq>>2]|0;dh[k[(k[n>>2]|0)+52>>2]&255](n,Xq,mr,Wq);p[Gq>>3]=1.0;k[Sb>>2]=0;k[Sb+4>>2]=0;k[Sb+8>>2]=0;k[Sb+12>>2]=0;k[Sb+16>>2]=0;k[Sb+20>>2]=0;k[lr>>2]=0;k[dj>>2]=0;k[ej>>2]=1124007936;n=fj;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[hj>>2]=gj;k[jj>>2]=ij;k[kj>>2]=0;k[ij>>2]=0;k[lj>>2]=1124007936;n=mj;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[oj>>2]=nj;k[qj>>2]=pj;k[rj>>2]=0;k[pj>>2]=0;k[sj>>2]=1124007936;n=tj;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[vj>>2]=uj;k[xj>>2]=wj;n=wj;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));n=k[Wq>>2]|0;dh[k[(k[n>>2]|0)+56>>2]&255](n,Wq,Gq,lr);k[fr>>2]=1124007936;n=Tb;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Vb>>2]=Ub;k[Xb>>2]=Wb;k[Yb>>2]=0;k[Wb>>2]=0;n=k[lr>>2]|0;dh[k[(k[n>>2]|0)+12>>2]&255](n,lr,fr,-1);XN(lr);XN(Wq);XN(mr);XN(Xq);$0(Iq,Es);k[Gq>>2]=0;k[yj>>2]=0;k[zj>>2]=1124007936;n=Aj;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Cj>>2]=Bj;k[Ej>>2]=Dj;k[Fj>>2]=0;k[Dj>>2]=0;k[Gj>>2]=1124007936;n=Hj;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Jj>>2]=Ij;k[Lj>>2]=Kj;k[Mj>>2]=0;k[Kj>>2]=0;k[Nj>>2]=1124007936;n=Oj;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Qj>>2]=Pj;k[Sj>>2]=Rj;n=Rj;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));n=k[Iq>>2]|0;nh[k[(k[n>>2]|0)+72>>2]&15](n,Iq,I,Gq);b1(Jq,Cs,J);k[Xq>>2]=0;k[Tj>>2]=0;k[Uj>>2]=1124007936;n=Vj;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Xj>>2]=Wj;k[Zj>>2]=Yj;k[_j>>2]=0;k[Yj>>2]=0;k[$j>>2]=1124007936;n=ak;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[ck>>2]=bk;k[ek>>2]=dk;k[fk>>2]=0;k[dk>>2]=0;k[gk>>2]=1124007936;n=hk;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[jk>>2]=ik;k[lk>>2]=kk;n=kk;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));n=k[Gq>>2]|0;dh[k[(k[n>>2]|0)+60>>2]&255](n,Gq,Jq,Xq);k[Hq>>2]=0;k[mk>>2]=0;k[nk>>2]=1124007936;n=ok;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[qk>>2]=pk;k[sk>>2]=rk;k[tk>>2]=0;k[rk>>2]=0;k[uk>>2]=1124007936;n=vk;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[xk>>2]=wk;k[zk>>2]=yk;k[Ak>>2]=0;k[yk>>2]=0;k[Bk>>2]=1124007936;n=Ck;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Ek>>2]=Dk;k[Gk>>2]=Fk;n=Fk;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));n=k[Xq>>2]|0;s=k[(k[n>>2]|0)+56>>2]|0;p[Wq>>3]=-H;p[Hk>>3]=-0.0;p[Ik>>3]=-0.0;p[Jk>>3]=-0.0;dh[s&255](n,Xq,Wq,Hq);k[mr>>2]=1124007936;n=Zb;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[$b>>2]=_b;k[bc>>2]=ac;k[cc>>2]=0;k[ac>>2]=0;n=k[Hq>>2]|0;dh[k[(k[n>>2]|0)+12>>2]&255](n,Hq,mr,-1);XN(Hq);XN(Xq);XN(Jq);XN(Gq);XN(Iq);k[dc>>2]=0;k[ec>>2]=0;k[Xq>>2]=16842752;k[fc>>2]=mr;k[gc>>2]=0;k[hc>>2]=0;k[Gq>>2]=16842752;k[ic>>2]=fr;n=kc;k[n>>2]=0;k[n+4>>2]=0;k[Iq>>2]=33619968;k[jc>>2]=mr;p[Wq>>3]=1.0;sU(Xq,Gq,Iq,49332,-1,40064,1,Wq);$0(Jq,Es);k[Iq>>2]=0;k[Kk>>2]=0;k[Lk>>2]=1124007936;n=Mk;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Ok>>2]=Nk;k[Qk>>2]=Pk;k[Rk>>2]=0;k[Pk>>2]=0;k[Sk>>2]=1124007936;n=Tk;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Vk>>2]=Uk;k[Xk>>2]=Wk;k[Yk>>2]=0;k[Wk>>2]=0;k[Zk>>2]=1124007936;n=_k;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[al>>2]=$k;k[cl>>2]=bl;n=bl;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));n=k[Jq>>2]|0;nh[k[(k[n>>2]|0)+72>>2]&15](n,Jq,G,Iq);b1(Lq,Cs,K);k[Xq>>2]=0;k[dl>>2]=0;k[el>>2]=1124007936;n=fl;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[hl>>2]=gl;k[jl>>2]=il;k[kl>>2]=0;k[il>>2]=0;k[ll>>2]=1124007936;n=ml;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[ol>>2]=nl;k[ql>>2]=pl;k[rl>>2]=0;k[pl>>2]=0;k[sl>>2]=1124007936;n=tl;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[vl>>2]=ul;k[xl>>2]=wl;n=wl;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));n=k[Iq>>2]|0;dh[k[(k[n>>2]|0)+60>>2]&255](n,Iq,Lq,Xq);k[Kq>>2]=0;k[yl>>2]=0;k[zl>>2]=1124007936;n=Al;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Cl>>2]=Bl;k[El>>2]=Dl;k[Fl>>2]=0;k[Dl>>2]=0;k[Gl>>2]=1124007936;n=Hl;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Jl>>2]=Il;k[Ll>>2]=Kl;k[Ml>>2]=0;k[Kl>>2]=0;k[Nl>>2]=1124007936;n=Ol;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Ql>>2]=Pl;k[Sl>>2]=Rl;n=Rl;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));n=k[Xq>>2]|0;s=k[(k[n>>2]|0)+56>>2]|0;p[Wq>>3]=-F;p[Tl>>3]=-0.0;p[Ul>>3]=-0.0;p[Vl>>3]=-0.0;dh[s&255](n,Xq,Wq,Kq);k[Gq>>2]=1124007936;n=lc;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[nc>>2]=mc;k[pc>>2]=oc;k[qc>>2]=0;k[oc>>2]=0;n=k[Kq>>2]|0;dh[k[(k[n>>2]|0)+12>>2]&255](n,Kq,Gq,-1);XN(Kq);XN(Xq);XN(Lq);XN(Iq);XN(Jq);k[rc>>2]=0;k[sc>>2]=0;k[Xq>>2]=16842752;k[tc>>2]=Gq;k[uc>>2]=0;k[vc>>2]=0;k[Iq>>2]=16842752;k[wc>>2]=fr;n=yc;k[n>>2]=0;k[n+4>>2]=0;k[Jq>>2]=33619968;k[xc>>2]=Gq;p[Wq>>3]=1.0;sU(Xq,Iq,Jq,49332,-1,40064,1,Wq);k[Iq>>2]=1124007936;n=zc;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Bc>>2]=Ac;k[Dc>>2]=Cc;k[Ec>>2]=0;k[Cc>>2]=0;k[Jq>>2]=1124007936;n=Fc;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Hc>>2]=Gc;k[Jc>>2]=Ic;k[Kc>>2]=0;k[Ic>>2]=0;k[Lc>>2]=0;k[Mc>>2]=0;k[Xq>>2]=16842752;k[Nc>>2]=Vr;k[Oc>>2]=0;k[Pc>>2]=0;k[Lq>>2]=16842752;k[Qc>>2]=fr;a=Sc;k[a>>2]=0;k[a+4>>2]=0;k[Mq>>2]=33619968;k[Rc>>2]=Iq;p[Wq>>3]=1.0;sU(Xq,Lq,Mq,49332,-1,40064,1,Wq);k[Tc>>2]=0;k[Uc>>2]=0;k[Xq>>2]=16842752;k[Vc>>2]=Qr;k[Wc>>2]=0;k[Xc>>2]=0;k[Lq>>2]=16842752;k[Yc>>2]=fr;a=_c;k[a>>2]=0;k[a+4>>2]=0;k[Mq>>2]=33619968;k[Zc>>2]=Jq;p[Wq>>3]=1.0;sU(Xq,Lq,Mq,49332,-1,40064,1,Wq);k[Wq>>2]=-2147483648;k[$c>>2]=2147483647;k[Xq>>2]=0;k[ad>>2]=q;H1(Nq,Lr,Wq,Xq);k[bd>>2]=0;k[cd>>2]=0;k[Xq>>2]=16842752;k[dd>>2]=Es;i1(Wq,Iq,Xq,1.0);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,Nq,-1);XN(Wq);a=k[ed>>2]|0;do if(a|0){n=a+12|0;s=k[n>>2]|0;k[n>>2]=s+-1;if((s|0)!=1)break;j=k[ed>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Cm>>2]|0;if(a|0)break;a=B1()|0;j=k[ed>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[ed>>2]=0}while(0);k[ed>>2]=0;k[fd>>2]=0;k[fd+4>>2]=0;k[fd+8>>2]=0;k[fd+12>>2]=0;if((k[gd>>2]|0)>0){j=k[hd>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[gd>>2]|0))}a=k[id>>2]|0;if(!((a|0)==(jd|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=q<<1;k[Wq>>2]=-2147483648;k[kd>>2]=2147483647;k[Xq>>2]=q;k[ld>>2]=l;H1(Oq,Lr,Wq,Xq);k[md>>2]=0;k[nd>>2]=0;k[Xq>>2]=16842752;k[od>>2]=Es;i1(Wq,Jq,Xq,1.0);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,Oq,-1);XN(Wq);a=k[pd>>2]|0;do if(a|0){n=a+12|0;s=k[n>>2]|0;k[n>>2]=s+-1;if((s|0)!=1)break;j=k[pd>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Bm>>2]|0;if(a|0)break;a=B1()|0;j=k[pd>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[pd>>2]=0}while(0);k[pd>>2]=0;k[qd>>2]=0;k[qd+4>>2]=0;k[qd+8>>2]=0;k[qd+12>>2]=0;if((k[rd>>2]|0)>0){j=k[sd>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[rd>>2]|0))}a=k[td>>2]|0;if(!((a|0)==(ud|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[vd>>2]=0;k[wd>>2]=0;k[Xq>>2]=16842752;k[xd>>2]=Iq;i1(Wq,mr,Xq,1.0);k[yd>>2]=0;k[zd>>2]=0;k[Qq>>2]=16842752;k[Ad>>2]=Jq;i1(Mq,Gq,Qq,1.0);k[Pq>>2]=0;k[Wl>>2]=0;k[Xl>>2]=1124007936;n=Yl;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[_l>>2]=Zl;k[am>>2]=$l;k[bm>>2]=0;k[$l>>2]=0;k[cm>>2]=1124007936;n=dm;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[fm>>2]=em;k[hm>>2]=gm;k[im>>2]=0;k[gm>>2]=0;k[jm>>2]=1124007936;n=km;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[mm>>2]=lm;k[om>>2]=nm;n=nm;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));n=k[Wq>>2]|0;dh[k[(k[n>>2]|0)+52>>2]&255](n,Wq,Mq,Pq);k[Lq>>2]=1124007936;n=Bd;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Dd>>2]=Cd;k[Fd>>2]=Ed;k[Gd>>2]=0;k[Ed>>2]=0;m=k[Pq>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,Pq,Lq,-1);XN(Pq);XN(Mq);XN(Wq);m=q*3|0;k[Wq>>2]=-2147483648;k[Hd>>2]=2147483647;k[Xq>>2]=l;k[Id>>2]=m;H1(Rq,Lr,Wq,Xq);k[Jd>>2]=0;k[Kd>>2]=0;k[Xq>>2]=16842752;k[Ld>>2]=Es;i1(Wq,Lq,Xq,1.0);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,Rq,-1);XN(Wq);a=k[Md>>2]|0;do if(a|0){n=a+12|0;s=k[n>>2]|0;k[n>>2]=s+-1;if((s|0)!=1)break;j=k[Md>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Am>>2]|0;if(a|0)break;a=B1()|0;j=k[Md>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Md>>2]=0}while(0);k[Md>>2]=0;k[Nd>>2]=0;k[Nd+4>>2]=0;k[Nd+8>>2]=0;k[Nd+12>>2]=0;if((k[Od>>2]|0)>0){j=k[Pd>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Od>>2]|0))}a=k[Qd>>2]|0;if(!((a|0)==(Rd|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[Sd>>2]|0;do if(a|0){n=a+12|0;s=k[n>>2]|0;k[n>>2]=s+-1;if((s|0)!=1)break;j=k[Sd>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[qm>>2]|0;if(a|0)break;a=B1()|0;j=k[Sd>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Sd>>2]=0}while(0);k[Sd>>2]=0;k[Td>>2]=0;k[Td+4>>2]=0;k[Td+8>>2]=0;k[Td+12>>2]=0;if((k[Zb>>2]|0)>0){j=k[$b>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Zb>>2]|0))}a=k[Ud>>2]|0;do if(a|0){n=a+12|0;s=k[n>>2]|0;k[n>>2]=s+-1;if((s|0)!=1)break;j=k[Ud>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[rm>>2]|0;if(a|0)break;a=B1()|0;j=k[Ud>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Ud>>2]=0}while(0);k[Ud>>2]=0;k[Vd>>2]=0;k[Vd+4>>2]=0;k[Vd+8>>2]=0;k[Vd+12>>2]=0;if((k[lc>>2]|0)>0){j=k[nc>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[lc>>2]|0))}l=q<<2;k[Wq>>2]=-2147483648;k[Wd>>2]=2147483647;k[Xq>>2]=m;k[Xd>>2]=l;H1(Sq,Lr,Wq,Xq);k[Yd>>2]=0;k[Zd>>2]=0;k[Xq>>2]=16842752;k[_d>>2]=Cs;i1(Wq,Iq,Xq,1.0);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,Sq,-1);XN(Wq);a=k[$d>>2]|0;do if(a|0){n=a+12|0;s=k[n>>2]|0;k[n>>2]=s+-1;if((s|0)!=1)break;j=k[$d>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[zm>>2]|0;if(a|0)break;a=B1()|0;j=k[$d>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[$d>>2]=0}while(0);k[$d>>2]=0;k[ae>>2]=0;k[ae+4>>2]=0;k[ae+8>>2]=0;k[ae+12>>2]=0;if((k[be>>2]|0)>0){j=k[ce>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[be>>2]|0))}a=k[de>>2]|0;if(!((a|0)==(ee|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=q*5|0;k[Wq>>2]=-2147483648;k[fe>>2]=2147483647;k[Xq>>2]=l;k[ge>>2]=m;H1(Tq,Lr,Wq,Xq);k[he>>2]=0;k[ie>>2]=0;k[Xq>>2]=16842752;k[je>>2]=Cs;i1(Wq,Jq,Xq,1.0);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,Tq,-1);XN(Wq);a=k[ke>>2]|0;do if(a|0){n=a+12|0;s=k[n>>2]|0;k[n>>2]=s+-1;if((s|0)!=1)break;j=k[ke>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[ym>>2]|0;if(a|0)break;a=B1()|0;j=k[ke>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[ke>>2]=0}while(0);k[ke>>2]=0;k[le>>2]=0;k[le+4>>2]=0;k[le+8>>2]=0;k[le+12>>2]=0;if((k[me>>2]|0)>0){j=k[ne>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[me>>2]|0))}a=k[oe>>2]|0;if(!((a|0)==(pe|0)|(a|0)==0))ggb(k[a+-4>>2]|0);n=q*6|0;k[Wq>>2]=-2147483648;k[qe>>2]=2147483647;k[Xq>>2]=m;k[re>>2]=n;H1(Uq,Lr,Wq,Xq);k[se>>2]=0;k[te>>2]=0;k[Xq>>2]=16842752;k[ue>>2]=Cs;i1(Wq,Lq,Xq,1.0);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,Uq,-1);XN(Wq);a=k[ve>>2]|0;do if(a|0){m=a+12|0;s=k[m>>2]|0;k[m>>2]=s+-1;if((s|0)!=1)break;j=k[ve>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[xm>>2]|0;if(a|0)break;a=B1()|0;j=k[ve>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[ve>>2]=0}while(0);k[ve>>2]=0;k[we>>2]=0;k[we+4>>2]=0;k[we+8>>2]=0;k[we+12>>2]=0;if((k[xe>>2]|0)>0){j=k[ye>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[xe>>2]|0))}a=k[ze>>2]|0;if(!((a|0)==(Ae|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=q*7|0;k[Wq>>2]=-2147483648;k[Be>>2]=2147483647;k[Xq>>2]=n;k[Ce>>2]=l;H1(Qq,Lr,Wq,Xq);a=Ee;k[a>>2]=0;k[a+4>>2]=0;k[Mq>>2]=-1040121856;k[De>>2]=Qq;mY(Iq,Mq);a=k[Fe>>2]|0;do if(a|0){n=a+12|0;s=k[n>>2]|0;k[n>>2]=s+-1;if((s|0)!=1)break;j=k[Fe>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[wm>>2]|0;if(a|0)break;a=B1()|0;j=k[Fe>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Fe>>2]=0}while(0);k[Fe>>2]=0;k[Ge>>2]=0;k[Ge+4>>2]=0;k[Ge+8>>2]=0;k[Ge+12>>2]=0;if((k[He>>2]|0)>0){j=k[Ie>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[He>>2]|0))}a=k[Je>>2]|0;if(!((a|0)==(Ke|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[Wq>>2]=-2147483648;k[Le>>2]=2147483647;k[Xq>>2]=l;k[Me>>2]=q<<3;H1(Qq,Lr,Wq,Xq);a=Oe;k[a>>2]=0;k[a+4>>2]=0;k[Mq>>2]=-1040121856;k[Ne>>2]=Qq;mY(Jq,Mq);a=k[Pe>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[Pe>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[vm>>2]|0;if(a|0)break;a=B1()|0;j=k[Pe>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Pe>>2]=0}while(0);k[Pe>>2]=0;k[Qe>>2]=0;k[Qe+4>>2]=0;k[Qe+8>>2]=0;k[Qe+12>>2]=0;if((k[Re>>2]|0)>0){j=k[Se>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Re>>2]|0))}a=k[Te>>2]|0;if(!((a|0)==(Ue|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[Ve>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[Ve>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[um>>2]|0;if(a|0)break;a=B1()|0;j=k[Ve>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Ve>>2]=0}while(0);k[Ve>>2]=0;k[We>>2]=0;k[We+4>>2]=0;k[We+8>>2]=0;k[We+12>>2]=0;if((k[Bd>>2]|0)>0){j=k[Dd>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Bd>>2]|0))}a=k[Fd>>2]|0;if(!((a|0)==(Ed|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[Xe>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[Xe>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[tm>>2]|0;if(a|0)break;a=B1()|0;j=k[Xe>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Xe>>2]=0}while(0);k[Xe>>2]=0;k[Ye>>2]=0;k[Ye+4>>2]=0;k[Ye+8>>2]=0;k[Ye+12>>2]=0;if((k[Fc>>2]|0)>0){j=k[Hc>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Fc>>2]|0))}a=k[Jc>>2]|0;if(!((a|0)==(Ic|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[Ze>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[Ze>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[sm>>2]|0;if(a|0)break;a=B1()|0;j=k[Ze>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Ze>>2]=0}while(0);k[Ze>>2]=0;k[_e>>2]=0;k[_e+4>>2]=0;k[_e+8>>2]=0;k[_e+12>>2]=0;if((k[zc>>2]|0)>0){j=k[Bc>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[zc>>2]|0))}a=k[Dc>>2]|0;if(!((a|0)==(Cc|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[Ud>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[Ud>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[rm>>2]|0;if(a|0)break;a=B1()|0;j=k[Ud>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Ud>>2]=0}while(0);k[Ud>>2]=0;k[Vd>>2]=0;k[Vd+4>>2]=0;k[Vd+8>>2]=0;k[Vd+12>>2]=0;if((k[lc>>2]|0)>0){j=k[nc>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[lc>>2]|0))}a=k[pc>>2]|0;if(!((a|0)==(oc|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[Sd>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[Sd>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[qm>>2]|0;if(a|0)break;a=B1()|0;j=k[Sd>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Sd>>2]=0}while(0);k[Sd>>2]=0;k[Td>>2]=0;k[Td+4>>2]=0;k[Td+8>>2]=0;k[Td+12>>2]=0;if((k[Zb>>2]|0)>0){j=k[$b>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Zb>>2]|0))}a=k[bc>>2]|0;if(!((a|0)==(ac|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[$e>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[$e>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[pm>>2]|0;if(a|0)break;a=B1()|0;j=k[$e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[$e>>2]=0}while(0);k[$e>>2]=0;k[af>>2]=0;k[af+4>>2]=0;k[af+8>>2]=0;k[af+12>>2]=0;if((k[Tb>>2]|0)>0){j=k[Vb>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Tb>>2]|0))}a=k[Xb>>2]|0;if(!((a|0)==(Wb|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break}case 0:{q=k[wq>>2]|0;s=k[sq>>2]|0;if(!((k[q>>2]|0)==(k[s>>2]|0)?(k[q+4>>2]|0)==(k[s+4>>2]|0):0)){k[Wq>>2]=0;k[Ff>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Ff>>2]=24;i[a+28>>0]=0;l=402330;s=n+24|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402355,401651,193);k[Ff>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[Jp>>2]|0)!=(k[Ep>>2]|0)){k[Wq>>2]=0;k[Ef>>2]=0;a=ZT(28)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Ef>>2]=21;i[a+25>>0]=0;l=402189;s=n+21|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402355,401651,195);k[Ef>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[za>>2]|0)!=(k[Aa>>2]<<1|0)){k[Wq>>2]=0;k[Df>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Df>>2]=25;i[a+29>>0]=0;l=402386;s=n+25|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402355,401651,196);k[Df>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[Lr>>2]&4095|0)!=5){k[Wq>>2]=0;k[Cf>>2]=0;a=ZT(28)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Cf>>2]=22;i[a+26>>0]=0;l=402237;s=n+22|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402355,401651,197);k[Cf>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}l=k[Aa>>2]|0;k[Wq>>2]=-2147483648;k[hf>>2]=2147483647;k[Xq>>2]=0;k[jf>>2]=l;H1(lr,Lr,Wq,Xq);a=lf;k[a>>2]=0;k[a+4>>2]=0;k[fr>>2]=-1040121856;k[kf>>2]=lr;mY(Vr,fr);a=k[mf>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[mf>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Em>>2]|0;if(a|0)break;a=B1()|0;j=k[mf>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[mf>>2]=0}while(0);k[mf>>2]=0;k[nf>>2]=0;k[nf+4>>2]=0;k[nf+8>>2]=0;k[nf+12>>2]=0;if((k[of>>2]|0)>0){j=k[pf>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[of>>2]|0))}a=k[qf>>2]|0;if(!((a|0)==(rf|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[Wq>>2]=-2147483648;k[sf>>2]=2147483647;k[Xq>>2]=l;k[tf>>2]=l<<1;H1(lr,Lr,Wq,Xq);a=vf;k[a>>2]=0;k[a+4>>2]=0;k[fr>>2]=-1040121856;k[uf>>2]=lr;mY(Qr,fr);a=k[wf>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[wf>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Dm>>2]|0;if(a|0)break;a=B1()|0;j=k[wf>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[wf>>2]=0}while(0);k[wf>>2]=0;k[xf>>2]=0;k[xf+4>>2]=0;k[xf+8>>2]=0;k[xf+12>>2]=0;if((k[yf>>2]|0)>0){j=k[zf>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[yf>>2]|0))}a=k[Af>>2]|0;if(!((a|0)==(Bf|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break}case 1:{j=k[wq>>2]|0;a=k[j+4>>2]|0;j=k[j>>2]|0;s=k[sq>>2]|0;if(!((j|0)==(k[s>>2]|0)?(a|0)==(k[s+4>>2]|0):0)){k[Wq>>2]=0;k[Ig>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Ig>>2]=24;i[a+28>>0]=0;l=402330;s=n+24|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402412,401651,130);k[Ig>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0);j=k[wq>>2]|0;a=k[j+4>>2]|0;j=k[j>>2]|0}s=k[hs>>2]|0;if(!((j|0)==(k[s>>2]|0)?(a|0)==(k[s+4>>2]|0):0)){k[Wq>>2]=0;k[Hg>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Hg>>2]=24;i[a+28>>0]=0;l=402441;s=n+24|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402412,401651,131);k[Hg>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0);j=k[wq>>2]|0;a=k[j+4>>2]|0;j=k[j>>2]|0}s=k[bs>>2]|0;if(!((j|0)==(k[s>>2]|0)?(a|0)==(k[s+4>>2]|0):0)){k[Wq>>2]=0;k[Gg>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Gg>>2]=24;i[a+28>>0]=0;l=402466;s=n+24|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402412,401651,132);k[Gg>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[Jp>>2]|0)!=(k[Ep>>2]|0)){k[Wq>>2]=0;k[Fg>>2]=0;a=ZT(28)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Fg>>2]=21;i[a+25>>0]=0;l=402189;s=n+21|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402412,401651,134);k[Fg>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[za>>2]|0)!=((k[Aa>>2]|0)*3|0)){k[Wq>>2]=0;k[Eg>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Eg>>2]=25;i[a+29>>0]=0;l=402491;s=n+25|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402412,401651,135);k[Eg>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[Lr>>2]&4095|0)!=5){k[Wq>>2]=0;k[Dg>>2]=0;a=ZT(28)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Dg>>2]=22;i[a+26>>0]=0;l=402237;s=n+22|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402412,401651,136);k[Dg>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if(!(k[Is>>2]&16384)){k[Wq>>2]=0;k[Gf>>2]=0;a=ZT(24)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[Gf>>2]=19;i[a+23>>0]=0;l=402310;s=n+19|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402412,401651,138);k[Gf>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}n=k[pa>>2]|0;F=+o[n>>2];m=k[Aa>>2]|0;G=+o[n+12>>2];b1(mr,Es,G);k[Xq>>2]=0;k[Fm>>2]=0;k[Gm>>2]=1124007936;n=Hm;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Jm>>2]=Im;k[Lm>>2]=Km;k[Mm>>2]=0;k[Km>>2]=0;k[Nm>>2]=1124007936;n=Om;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Qm>>2]=Pm;k[Sm>>2]=Rm;k[Tm>>2]=0;k[Rm>>2]=0;k[Um>>2]=1124007936;n=Vm;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Xm>>2]=Wm;k[Zm>>2]=Ym;n=Ym;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));n=k[mr>>2]|0;s=k[(k[n>>2]|0)+64>>2]|0;k[Wq>>2]=0;k[Wq+4>>2]=0;k[Wq+8>>2]=0;k[Wq+12>>2]=0;k[Wq+16>>2]=0;k[Wq+20>>2]=0;k[Wq+24>>2]=0;k[Wq+28>>2]=0;dh[s&255](n,Wq,mr,Xq);b1(Wq,Cs,F);k[lr>>2]=0;k[_m>>2]=0;k[$m>>2]=1124007936;n=an;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[cn>>2]=bn;k[en>>2]=dn;k[fn>>2]=0;k[dn>>2]=0;k[gn>>2]=1124007936;n=hn;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[kn>>2]=jn;k[mn>>2]=ln;k[nn>>2]=0;k[ln>>2]=0;k[on>>2]=1124007936;n=pn;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[rn>>2]=qn;k[tn>>2]=sn;n=sn;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));n=k[Xq>>2]|0;dh[k[(k[n>>2]|0)+60>>2]&255](n,Xq,Wq,lr);k[fr>>2]=1124007936;n=Hf;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Jf>>2]=If;k[Lf>>2]=Kf;k[Mf>>2]=0;k[Kf>>2]=0;n=k[lr>>2]|0;dh[k[(k[n>>2]|0)+12>>2]&255](n,lr,fr,-1);XN(lr);XN(Wq);XN(Xq);XN(mr);b1(Wq,Es,F);b1(Xq,Cs,G);k[Gq>>2]=0;k[un>>2]=0;k[vn>>2]=1124007936;n=wn;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[yn>>2]=xn;k[An>>2]=zn;k[Bn>>2]=0;k[zn>>2]=0;k[Cn>>2]=1124007936;n=Dn;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Fn>>2]=En;k[Hn>>2]=Gn;k[In>>2]=0;k[Gn>>2]=0;k[Jn>>2]=1124007936;n=Kn;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Mn>>2]=Ln;k[On>>2]=Nn;n=Nn;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));n=k[Wq>>2]|0;dh[k[(k[n>>2]|0)+60>>2]&255](n,Wq,Xq,Gq);k[mr>>2]=1124007936;n=Nf;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Pf>>2]=Of;k[Rf>>2]=Qf;k[Sf>>2]=0;k[Qf>>2]=0;n=k[Gq>>2]|0;dh[k[(k[n>>2]|0)+12>>2]&255](n,Gq,mr,-1);XN(Gq);XN(Xq);XN(Wq);k[Wq>>2]=-2147483648;k[Tf>>2]=2147483647;k[Xq>>2]=0;k[Uf>>2]=m;H1(Hq,Lr,Wq,Xq);k[Vf>>2]=0;k[Wf>>2]=0;k[Iq>>2]=16842752;k[Xf>>2]=fr;i1(Xq,Vr,Iq,1.0);k[Yf>>2]=0;k[Zf>>2]=0;k[Kq>>2]=16842752;k[_f>>2]=mr;i1(Jq,Qr,Kq,1.0);k[Wq>>2]=0;k[Pn>>2]=0;k[Qn>>2]=1124007936;n=Rn;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Tn>>2]=Sn;k[Vn>>2]=Un;k[Wn>>2]=0;k[Un>>2]=0;k[Xn>>2]=1124007936;n=Yn;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[_n>>2]=Zn;k[ao>>2]=$n;k[bo>>2]=0;k[$n>>2]=0;k[co>>2]=1124007936;n=eo;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[go>>2]=fo;k[io>>2]=ho;n=ho;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));a=k[Xq>>2]|0;dh[k[(k[a>>2]|0)+52>>2]&255](a,Xq,Jq,Wq);a=k[Wq>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,Wq,Hq,-1);XN(Wq);XN(Jq);XN(Xq);a=k[$f>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[$f>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[no>>2]|0;if(a|0)break;a=B1()|0;j=k[$f>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[$f>>2]=0}while(0);k[$f>>2]=0;k[ag>>2]=0;k[ag+4>>2]=0;k[ag+8>>2]=0;k[ag+12>>2]=0;if((k[bg>>2]|0)>0){j=k[cg>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[bg>>2]|0))}a=k[dg>>2]|0;if(!((a|0)==(eg|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=m<<1;k[Wq>>2]=-2147483648;k[fg>>2]=2147483647;k[Xq>>2]=m;k[gg>>2]=l;H1(Jq,Lr,Wq,Xq);a=ig;k[a>>2]=0;k[a+4>>2]=0;k[Iq>>2]=-1040121856;k[hg>>2]=Jq;mY(Vr,Iq);a=k[jg>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[jg>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[mo>>2]|0;if(a|0)break;a=B1()|0;j=k[jg>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[jg>>2]=0}while(0);k[jg>>2]=0;k[kg>>2]=0;k[kg+4>>2]=0;k[kg+8>>2]=0;k[kg+12>>2]=0;if((k[lg>>2]|0)>0){j=k[mg>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[lg>>2]|0))}a=k[ng>>2]|0;if(!((a|0)==(og|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[Wq>>2]=-2147483648;k[pg>>2]=2147483647;k[Xq>>2]=l;k[qg>>2]=m*3;H1(Jq,Lr,Wq,Xq);a=sg;k[a>>2]=0;k[a+4>>2]=0;k[Iq>>2]=-1040121856;k[rg>>2]=Jq;mY(Qr,Iq);a=k[tg>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[tg>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[lo>>2]|0;if(a|0)break;a=B1()|0;j=k[tg>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[tg>>2]=0}while(0);k[tg>>2]=0;k[ug>>2]=0;k[ug+4>>2]=0;k[ug+8>>2]=0;k[ug+12>>2]=0;if((k[vg>>2]|0)>0){j=k[wg>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[vg>>2]|0))}a=k[xg>>2]|0;if(!((a|0)==(yg|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[zg>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[zg>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[ko>>2]|0;if(a|0)break;a=B1()|0;j=k[zg>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[zg>>2]=0}while(0);k[zg>>2]=0;k[Ag>>2]=0;k[Ag+4>>2]=0;k[Ag+8>>2]=0;k[Ag+12>>2]=0;if((k[Nf>>2]|0)>0){j=k[Pf>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Nf>>2]|0))}a=k[Rf>>2]|0;if(!((a|0)==(Qf|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[Bg>>2]|0;do if(a|0){q=a+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;j=k[Bg>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[jo>>2]|0;if(a|0)break;a=B1()|0;j=k[Bg>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[Bg>>2]=0}while(0);k[Bg>>2]=0;k[Cg>>2]=0;k[Cg+4>>2]=0;k[Cg+8>>2]=0;k[Cg+12>>2]=0;if((k[Hf>>2]|0)>0){j=k[Jf>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Hf>>2]|0))}a=k[Lf>>2]|0;if(!((a|0)==(Kf|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break}default:{}}z6a(Lr,Lr,Gr);k[Wq>>2]=0;k[Qh>>2]=0;k[Rh>>2]=1124007936;n=Sh;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Uh>>2]=Th;k[Wh>>2]=Vh;k[Xh>>2]=0;k[Vh>>2]=0;k[Yh>>2]=1124007936;n=Zh;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[$h>>2]=_h;k[bi>>2]=ai;k[ci>>2]=0;k[ai>>2]=0;k[di>>2]=1124007936;n=ei;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[gi>>2]=fi;k[ii>>2]=hi;n=hi;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));Y$(Wq,0,Gr);s=k[Wq>>2]|0;dh[k[(k[s>>2]|0)+12>>2]&255](s,Wq,Br,-1);XN(Wq);k[Z>>2]=0;k[_>>2]=0;k[Wq>>2]=16842752;k[$>>2]=ys;F=+r$(Bs,Wq);H=F/(L*M);p[u>>3]=H;if(((k[u+4>>2]&2147483647)+((k[u>>2]|0)!=0&1)|0)>>>0>2146435072){k[Wq>>2]=0;k[ba>>2]=0;a=ZT(24)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[ba>>2]=16;i[a+20>>0]=0;l=402517;s=n+16|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-7,Wq,401634,401651,515);k[ba>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}z6a(Lr,ys,Ar);z6a(Lr,Bs,zr);a1(Wq,Br,Ar);s=k[Wq>>2]|0;dh[k[(k[s>>2]|0)+12>>2]&255](s,Wq,wr,-1);XN(Wq);k[ca>>2]=0;k[da>>2]=0;k[Wq>>2]=16842752;k[ea>>2]=wr;G=M*M-+r$(Ar,Wq);k[fa>>2]=0;k[ga>>2]=0;k[Wq>>2]=16842752;k[ha>>2]=wr;F=F-+r$(zr,Wq);if(F<=0.0){k[Wq>>2]=0;k[ya>>2]=0;a=ZT(140)|0;k[a>>2]=1;s=a+4|0;k[Wq>>2]=s;k[ya>>2]=132;i[a+136>>0]=0;upb(s|0,402534,132)|0;Y8(-7,Wq,401634,401651,530);k[ya>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0);H=-1.0}c1(fr,G/F,Bs);k[Xq>>2]=0;k[ji>>2]=0;k[ki>>2]=1124007936;n=li;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[ni>>2]=mi;k[pi>>2]=oi;k[qi>>2]=0;k[oi>>2]=0;k[ri>>2]=1124007936;n=si;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[ui>>2]=ti;k[wi>>2]=vi;k[xi>>2]=0;k[vi>>2]=0;k[yi>>2]=1124007936;n=zi;s=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));k[Bi>>2]=Ai;k[Di>>2]=Ci;n=Ci;s=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(s|0));s=k[fr>>2]|0;q=k[(k[s>>2]|0)+60>>2]|0;T0(Wq,ys);dh[q&255](s,fr,Wq,Xq);XN(Wq);s=k[Xq>>2]|0;dh[k[(k[s>>2]|0)+12>>2]&255](s,Xq,nr,-1);XN(Xq);XN(fr);z6a(Lr,nr,tr);a1(Wq,Br,tr);s=k[Wq>>2]|0;dh[k[(k[s>>2]|0)+12>>2]&255](s,Wq,pr,-1);XN(Wq);if((k[Is>>2]&4095|0)!=5){k[Wq>>2]=0;k[xa>>2]=0;a=ZT(36)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[xa>>2]=29;i[a+33>>0]=0;l=402667;s=n+29|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402697,401651,252);k[xa>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if((k[pr>>2]&4095|0)!=5){k[Wq>>2]=0;k[wa>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[wa>>2]=25;i[a+29>>0]=0;l=402723;s=n+25|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402697,401651,253);k[wa>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if(!Cp?(k[Wq>>2]=0,k[va>>2]=0,Vq=ZT(140)|0,k[Vq>>2]=1,s=Vq+4|0,k[Wq>>2]=s,k[va>>2]=132,i[Vq+136>>0]=0,upb(s|0,402749,132)|0,Y8(-215,Wq,402697,401651,256),k[va>>2]=0,k[Wq>>2]=0,s=k[Vq>>2]|0,k[Vq>>2]=s+-1,(s|0)==1):0)ggb(k[Vq+-4>>2]|0);a=k[nq>>2]|0;do if(oo){if((a|0)==3&(k[Dp>>2]|0)==8)break;k[Wq>>2]=0;k[la>>2]=0;a=ZT(48)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[la>>2]=40;i[a+44>>0]=0;l=402882;s=n+40|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402697,401651,259);k[la>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}else{a=(a|0)==2;j=k[Dp>>2]|0;if(ka){if(a&(j|0)==6)break;k[Wq>>2]=0;k[sa>>2]=0;a=ZT(48)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[sa>>2]=40;i[a+44>>0]=0;l=402923;s=n+40|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402697,401651,261);k[sa>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0);break}if(ja){if(a&(j|0)==3)break;k[Wq>>2]=0;k[ta>>2]=0;a=ZT(48)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[ta>>2]=40;i[a+44>>0]=0;l=402964;s=n+40|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402697,401651,263);k[ta>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0);break}else{if(a&(j|0)==2)break;k[Wq>>2]=0;k[ua>>2]=0;a=ZT(48)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[ua>>2]=40;i[a+44>>0]=0;l=403005;s=n+40|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402697,401651,265);k[ua>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0);break}}while(0);if((k[ma>>2]|0)!=1){k[Wq>>2]=0;k[ra>>2]=0;a=ZT(24)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[ra>>2]=16;i[a+20>>0]=0;l=403046;s=n+16|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402697,401651,267);k[ra>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if(!(k[Is>>2]&16384)){k[Wq>>2]=0;k[na>>2]=0;a=ZT(32)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[na>>2]=25;i[a+29>>0]=0;l=403063;s=n+25|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402697,401651,269);k[na>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}if(!(k[pr>>2]&16384)){k[Wq>>2]=0;k[oa>>2]=0;a=ZT(28)|0;k[a>>2]=1;n=a+4|0;k[Wq>>2]=n;k[oa>>2]=21;i[a+25>>0]=0;l=403089;s=n+21|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(s|0));Y8(-215,Wq,402697,401651,270);k[oa>>2]=0;k[Wq>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}a=k[pa>>2]|0;j=k[qa>>2]|0;if(ia){s=a+8|0;o[s>>2]=+o[j>>2]+ +o[s>>2];s=a+20|0;o[s>>2]=+o[j+4>>2]+ +o[s>>2]}if(ka){o[a>>2]=+o[j>>2]+ +o[a>>2];s=a+12|0;o[s>>2]=+o[j+4>>2]+ +o[s>>2];s=a+4|0;o[s>>2]=+o[j+8>>2]+ +o[s>>2];s=a+16|0;o[s>>2]=+o[j+12>>2]+ +o[s>>2];s=a+8|0;o[s>>2]=+o[j+16>>2]+ +o[s>>2];s=a+20|0;o[s>>2]=+o[j+20>>2]+ +o[s>>2]}if(oo){o[a>>2]=+o[j>>2]+ +o[a>>2];s=a+12|0;o[s>>2]=+o[j+4>>2]+ +o[s>>2];s=a+24|0;o[s>>2]=+o[j+8>>2]+ +o[s>>2];s=a+4|0;o[s>>2]=+o[j+12>>2]+ +o[s>>2];s=a+16|0;o[s>>2]=+o[j+16>>2]+ +o[s>>2];s=a+28|0;o[s>>2]=+o[j+20>>2]+ +o[s>>2];s=a+8|0;o[s>>2]=+o[j+24>>2]+ +o[s>>2];s=a+20|0;o[s>>2]=+o[j+28>>2]+ +o[s>>2]}if(ja){s=a+12|0;Ms=+o[j>>2]+ +W(+(+o[s>>2]));q=a+8|0;o[q>>2]=+o[j+4>>2]+ +o[q>>2];q=a+20|0;o[q>>2]=+o[j+8>>2]+ +o[q>>2];M=+S(+Ms);o[a+16>>2]=M;o[a>>2]=M;Ms=+T(+Ms);o[s>>2]=Ms;o[a+4>>2]=-Ms}if((t|0)<(iq|0)){F=g;g=H;t=t+1|0}else{g=H;break a}}}while(0);l=nr+36|0;a=k[l>>2]|0;do if(a|0){lr=a+12|0;mr=k[lr>>2]|0;k[lr>>2]=mr+-1;if((mr|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[nr+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;nr=nr+16|0;k[nr>>2]=0;k[nr+4>>2]=0;k[nr+8>>2]=0;k[nr+12>>2]=0;if((k[Hp>>2]|0)>0){j=k[Fp>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Hp>>2]|0))}a=k[Gp>>2]|0;if(!((a|0)==(Ip|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=pr+36|0;a=k[l>>2]|0;do if(a|0){mr=a+12|0;nr=k[mr>>2]|0;k[mr>>2]=nr+-1;if((nr|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[pr+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;pr=pr+16|0;k[pr>>2]=0;k[pr+4>>2]=0;k[pr+8>>2]=0;k[pr+12>>2]=0;if((k[Lp>>2]|0)>0){j=k[Kp>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Lp>>2]|0))}a=k[Mp>>2]|0;if(!((a|0)==(Np|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=tr+36|0;a=k[l>>2]|0;do if(a|0){nr=a+12|0;pr=k[nr>>2]|0;k[nr>>2]=pr+-1;if((pr|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[tr+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;tr=tr+16|0;k[tr>>2]=0;k[tr+4>>2]=0;k[tr+8>>2]=0;k[tr+12>>2]=0;if((k[Qp>>2]|0)>0){j=k[Op>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Qp>>2]|0))}a=k[Pp>>2]|0;if(!((a|0)==(Rp|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=wr+36|0;a=k[l>>2]|0;do if(a|0){pr=a+12|0;tr=k[pr>>2]|0;k[pr>>2]=tr+-1;if((tr|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[wr+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;wr=wr+16|0;k[wr>>2]=0;k[wr+4>>2]=0;k[wr+8>>2]=0;k[wr+12>>2]=0;if((k[Up>>2]|0)>0){j=k[Sp>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Up>>2]|0))}a=k[Tp>>2]|0;if(!((a|0)==(Vp|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=zr+36|0;a=k[l>>2]|0;do if(a|0){tr=a+12|0;wr=k[tr>>2]|0;k[tr>>2]=wr+-1;if((wr|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[zr+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;zr=zr+16|0;k[zr>>2]=0;k[zr+4>>2]=0;k[zr+8>>2]=0;k[zr+12>>2]=0;if((k[Yp>>2]|0)>0){j=k[Wp>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Yp>>2]|0))}a=k[Xp>>2]|0;if(!((a|0)==(Zp|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Ar+36|0;a=k[l>>2]|0;do if(a|0){wr=a+12|0;zr=k[wr>>2]|0;k[wr>>2]=zr+-1;if((zr|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Ar+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;Ar=Ar+16|0;k[Ar>>2]=0;k[Ar+4>>2]=0;k[Ar+8>>2]=0;k[Ar+12>>2]=0;if((k[bq>>2]|0)>0){j=k[$p>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[bq>>2]|0))}a=k[aq>>2]|0;if(!((a|0)==(cq|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Br+36|0;a=k[l>>2]|0;do if(a|0){zr=a+12|0;Ar=k[zr>>2]|0;k[zr>>2]=Ar+-1;if((Ar|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Br+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;Br=Br+16|0;k[Br>>2]=0;k[Br+4>>2]=0;k[Br+8>>2]=0;k[Br+12>>2]=0;if((k[fq>>2]|0)>0){j=k[dq>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[fq>>2]|0))}a=k[eq>>2]|0;if(!((a|0)==(gq|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Gr+36|0;a=k[l>>2]|0;do if(a|0){Ar=a+12|0;Br=k[Ar>>2]|0;k[Ar>>2]=Br+-1;if((Br|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Gr+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;Gr=Gr+16|0;k[Gr>>2]=0;k[Gr+4>>2]=0;k[Gr+8>>2]=0;k[Gr+12>>2]=0;if((k[lq>>2]|0)>0){j=k[jq>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[lq>>2]|0))}a=k[kq>>2]|0;if(!((a|0)==(mq|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Lr+36|0;a=k[l>>2]|0;do if(a|0){Br=a+12|0;Gr=k[Br>>2]|0;k[Br>>2]=Gr+-1;if((Gr|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Lr+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;Lr=Lr+16|0;k[Lr>>2]=0;k[Lr+4>>2]=0;k[Lr+8>>2]=0;k[Lr+12>>2]=0;if((k[pq>>2]|0)>0){j=k[oq>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[pq>>2]|0))}a=k[qq>>2]|0;if(!((a|0)==(rq|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Qr+36|0;a=k[l>>2]|0;do if(a|0){Gr=a+12|0;Lr=k[Gr>>2]|0;k[Gr>>2]=Lr+-1;if((Lr|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Qr+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;Qr=Qr+16|0;k[Qr>>2]=0;k[Qr+4>>2]=0;k[Qr+8>>2]=0;k[Qr+12>>2]=0;if((k[uq>>2]|0)>0){j=k[sq>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[uq>>2]|0))}a=k[tq>>2]|0;if(!((a|0)==(vq|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Vr+36|0;a=k[l>>2]|0;do if(a|0){Lr=a+12|0;Qr=k[Lr>>2]|0;k[Lr>>2]=Qr+-1;if((Qr|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Vr+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;Vr=Vr+16|0;k[Vr>>2]=0;k[Vr+4>>2]=0;k[Vr+8>>2]=0;k[Vr+12>>2]=0;if((k[xq>>2]|0)>0){j=k[wq>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[xq>>2]|0))}a=k[yq>>2]|0;if(!((a|0)==(zq|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=_r+36|0;a=k[l>>2]|0;do if(a|0){Qr=a+12|0;Vr=k[Qr>>2]|0;k[Qr>>2]=Vr+-1;if((Vr|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[_r+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;_r=_r+16|0;k[_r>>2]=0;k[_r+4>>2]=0;k[_r+8>>2]=0;k[_r+12>>2]=0;if((k[Cq>>2]|0)>0){j=k[Aq>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Cq>>2]|0))}a=k[Bq>>2]|0;if(!((a|0)==(Dq|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=$r+36|0;a=k[l>>2]|0;do if(a|0){Vr=a+12|0;_r=k[Vr>>2]|0;k[Vr>>2]=_r+-1;if((_r|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[$r+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;$r=$r+16|0;k[$r>>2]=0;k[$r+4>>2]=0;k[$r+8>>2]=0;k[$r+12>>2]=0;if((k[jr>>2]|0)>0){j=k[Eq>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[jr>>2]|0))}a=k[Fq>>2]|0;if(!((a|0)==(kr|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=as+36|0;a=k[l>>2]|0;do if(a|0){_r=a+12|0;$r=k[_r>>2]|0;k[_r>>2]=$r+-1;if(($r|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[as+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;as=as+16|0;k[as>>2]=0;k[as+4>>2]=0;k[as+8>>2]=0;k[as+12>>2]=0;if((k[rr>>2]|0)>0){j=k[or>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[rr>>2]|0))}a=k[qr>>2]|0;if(!((a|0)==(sr|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=fs+36|0;a=k[l>>2]|0;do if(a|0){$r=a+12|0;as=k[$r>>2]|0;k[$r>>2]=as+-1;if((as|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[fs+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;fs=fs+16|0;k[fs>>2]=0;k[fs+4>>2]=0;k[fs+8>>2]=0;k[fs+12>>2]=0;if((k[xr>>2]|0)>0){j=k[ur>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[xr>>2]|0))}a=k[vr>>2]|0;if(!((a|0)==(yr|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=ms+36|0;a=k[l>>2]|0;do if(a|0){as=a+12|0;fs=k[as>>2]|0;k[as>>2]=fs+-1;if((fs|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[ms+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;fs=ms+16|0;j=ms+4|0;k[fs>>2]=0;k[fs+4>>2]=0;k[fs+8>>2]=0;k[fs+12>>2]=0;if((k[j>>2]|0)>0){l=k[ms+40>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[ms+44>>2]|0;if(!((a|0)==(ms+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=ss+36|0;a=k[l>>2]|0;do if(a|0){fs=a+12|0;ms=k[fs>>2]|0;k[fs>>2]=ms+-1;if((ms|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[ss+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;ss=ss+16|0;k[ss>>2]=0;k[ss+4>>2]=0;k[ss+8>>2]=0;k[ss+12>>2]=0;if((k[Er>>2]|0)>0){j=k[Cr>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Er>>2]|0))}a=k[Dr>>2]|0;if(!((a|0)==(Fr|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=ys+36|0;a=k[l>>2]|0;do if(a|0){ms=a+12|0;ss=k[ms>>2]|0;k[ms>>2]=ss+-1;if((ss|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[ys+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;ys=ys+16|0;k[ys>>2]=0;k[ys+4>>2]=0;k[ys+8>>2]=0;k[ys+12>>2]=0;if((k[Jr>>2]|0)>0){j=k[Hr>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Jr>>2]|0))}a=k[Ir>>2]|0;if(!((a|0)==(Kr|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=zs+36|0;a=k[l>>2]|0;do if(a|0){ss=a+12|0;ys=k[ss>>2]|0;k[ss>>2]=ys+-1;if((ys|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[zs+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;zs=zs+16|0;k[zs>>2]=0;k[zs+4>>2]=0;k[zs+8>>2]=0;k[zs+12>>2]=0;if((k[Or>>2]|0)>0){j=k[Mr>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Or>>2]|0))}a=k[Nr>>2]|0;if(!((a|0)==(Pr|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=As+36|0;a=k[l>>2]|0;do if(a|0){ys=a+12|0;zs=k[ys>>2]|0;k[ys>>2]=zs+-1;if((zs|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[As+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;As=As+16|0;k[As>>2]=0;k[As+4>>2]=0;k[As+8>>2]=0;k[As+12>>2]=0;if((k[Tr>>2]|0)>0){j=k[Rr>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Tr>>2]|0))}a=k[Sr>>2]|0;if(!((a|0)==(Ur|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Bs+36|0;a=k[l>>2]|0;do if(a|0){zs=a+12|0;As=k[zs>>2]|0;k[zs>>2]=As+-1;if((As|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Bs+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;Bs=Bs+16|0;k[Bs>>2]=0;k[Bs+4>>2]=0;k[Bs+8>>2]=0;k[Bs+12>>2]=0;if((k[Xr>>2]|0)>0){j=k[Wr>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Xr>>2]|0))}a=k[Yr>>2]|0;if(!((a|0)==(Zr|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Cs+36|0;a=k[l>>2]|0;do if(a|0){As=a+12|0;Bs=k[As>>2]|0;k[As>>2]=Bs+-1;if((Bs|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Cs+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;Cs=Cs+16|0;k[Cs>>2]=0;k[Cs+4>>2]=0;k[Cs+8>>2]=0;k[Cs+12>>2]=0;if((k[ds>>2]|0)>0){j=k[bs>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ds>>2]|0))}a=k[cs>>2]|0;if(!((a|0)==(es|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Es+36|0;a=k[l>>2]|0;do if(a|0){Bs=a+12|0;Cs=k[Bs>>2]|0;k[Bs>>2]=Cs+-1;if((Cs|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Es+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;Es=Es+16|0;k[Es>>2]=0;k[Es+4>>2]=0;k[Es+8>>2]=0;k[Es+12>>2]=0;if((k[js>>2]|0)>0){j=k[hs>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[js>>2]|0))}a=k[is>>2]|0;if(!((a|0)==(ks|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[gs>>2]|0;do if(a|0){Cs=a+12|0;Es=k[Cs>>2]|0;k[Cs>>2]=Es+-1;if((Es|0)!=1)break;j=k[gs>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Fs+32>>2]|0;if(a|0)break;a=B1()|0;j=k[gs>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[gs>>2]=0}while(0);k[gs>>2]=0;k[ls>>2]=0;k[ls+4>>2]=0;k[ls+8>>2]=0;k[ls+12>>2]=0;if((k[ps>>2]|0)>0){j=k[ns>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ps>>2]|0))}a=k[os>>2]|0;if(!((a|0)==(qs|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[rs>>2]|0;do if(a|0){Es=a+12|0;Fs=k[Es>>2]|0;k[Es>>2]=Fs+-1;if((Fs|0)!=1)break;j=k[rs>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Hs+32>>2]|0;if(a|0)break;a=B1()|0;j=k[rs>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[rs>>2]=0}while(0);k[rs>>2]=0;k[ts>>2]=0;k[ts+4>>2]=0;k[ts+8>>2]=0;k[ts+12>>2]=0;if((k[ws>>2]|0)>0){j=k[us>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ws>>2]|0))}a=k[vs>>2]|0;if(!((a|0)==(xs|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Is+36|0;a=k[l>>2]|0;do if(a|0){Fs=a+12|0;Hs=k[Fs>>2]|0;k[Fs>>2]=Hs+-1;if((Hs|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Is+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;Hs=Is+16|0;j=Is+4|0;k[Hs>>2]=0;k[Hs+4>>2]=0;k[Hs+8>>2]=0;k[Hs+12>>2]=0;if((k[j>>2]|0)>0){l=k[Is+40>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[Is+44>>2]|0;if(!((a|0)==(Is+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Js+36|0;a=k[l>>2]|0;do if(a|0){Hs=a+12|0;Is=k[Hs>>2]|0;k[Hs>>2]=Is+-1;if((Is|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Js+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;l=Js+4|0;k[Ds>>2]=0;k[Ds+4>>2]=0;k[Ds+8>>2]=0;k[Ds+12>>2]=0;if((k[l>>2]|0)>0){j=k[Js+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[Js+44>>2]|0;if(!((a|0)==(Js+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Ks+36|0;a=k[l>>2]|0;do if(a|0){Is=a+12|0;Js=k[Is>>2]|0;k[Is>>2]=Js+-1;if((Js|0)!=1)break;j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Ks+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}while(0);k[l>>2]=0;l=Ks+4|0;k[Gs>>2]=0;k[Gs+4>>2]=0;k[Gs+8>>2]=0;k[Gs+12>>2]=0;if((k[l>>2]|0)>0){j=k[Ks+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[Ks+44>>2]|0;if((a|0)==(Ks+48|0)|(a|0)==0){r=Ls;return +g}ggb(k[a+-4>>2]|0);r=Ls;return +g}function z6a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0.0;X=r;r=r+192|0;T=X+176|0;U=X+168|0;W=X+112|0;V=X+56|0;R=X;if((k[a+8>>2]|0)!=(k[b+8>>2]|0)){d=T+4|0;e=ZT(28)|0;k[e>>2]=1;j=e+4|0;k[T>>2]=j;k[d>>2]=22;i[e+26>>0]=0;g=403111;l=j+22|0;do{i[j>>0]=i[g>>0]|0;j=j+1|0;g=g+1|0}while((j|0)<(l|0));Y8(-215,T,403134,401651,219);k[d>>2]=0;k[T>>2]=0;S=k[e>>2]|0;k[e>>2]=S+-1;if((S|0)==1)ggb(k[e+-4>>2]|0)}f=a+12|0;d=k[f>>2]|0;h=b+12|0;e=k[h>>2]|0;if((d|0)%(e|0)|0){d=T+4|0;e=ZT(36)|0;k[e>>2]=1;j=e+4|0;k[T>>2]=j;k[d>>2]=28;i[e+32>>0]=0;g=403160;l=j+28|0;do{i[j>>0]=i[g>>0]|0;j=j+1|0;g=g+1|0}while((j|0)<(l|0));Y8(-215,T,403134,401651,220);k[d>>2]=0;k[T>>2]=0;S=k[e>>2]|0;k[e>>2]=S+-1;if((S|0)==1)ggb(k[e+-4>>2]|0);d=k[f>>2]|0;e=k[h>>2]|0}S=k[c+16>>2]|0;if((d|0)!=(e|0)){c=c+8|0;if((k[c>>2]|0)<=0){r=X;return}h=T+4|0;j=U+4|0;l=W+8|0;m=W+12|0;n=W+4|0;p=V+36|0;q=V+16|0;s=V+4|0;t=V+40|0;u=V+44|0;v=V+48|0;w=V+32|0;g=0;do{Q=aa(g,e)|0;d=g;g=g+1|0;R=aa(g,e)|0;k[T>>2]=-2147483648;k[h>>2]=2147483647;k[U>>2]=Q;k[j>>2]=R;H1(V,a,T,U);k[l>>2]=0;k[m>>2]=0;k[W>>2]=16842752;k[n>>2]=V;Y=+r$(b,W);o[S+(d<<2)>>2]=Y;d=k[p>>2]|0;if(d|0?(Q=d+12|0,R=k[Q>>2]|0,k[Q>>2]=R+-1,(R|0)==1):0){f=k[p>>2]|0;if(f|0){d=k[f+4>>2]|0;if(!d){d=k[w>>2]|0;if(!d){d=B1()|0;f=k[p>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,f)}k[p>>2]=0}k[p>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[s>>2]|0)>0){f=k[t>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[s>>2]|0))}d=k[u>>2]|0;if(!((d|0)==(v|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}while((g|0)<(k[c>>2]|0));r=X;return}P=c+12|0;f=k[P>>2]|0;O=c+8|0;if((f|0)==(k[O>>2]|0))d=f;else{d=T+4|0;e=ZT(28)|0;k[e>>2]=1;j=e+4|0;k[T>>2]=j;k[d>>2]=20;i[e+24>>0]=0;g=403189;l=j+20|0;do{i[j>>0]=i[g>>0]|0;j=j+1|0;g=g+1|0}while((j|0)<(l|0));Y8(-215,T,403134,401651,233);k[d>>2]=0;k[T>>2]=0;Q=k[e>>2]|0;k[e>>2]=Q+-1;if((Q|0)==1)ggb(k[e+-4>>2]|0);d=k[P>>2]|0;e=k[h>>2]|0;f=k[O>>2]|0}K=(e|0)/(d|0)|0;k[W>>2]=1124007936;Q=W+4|0;d=W+8|0;M=W+40|0;j=Q;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[M>>2]=d;N=W+48|0;L=W+44|0;k[L>>2]=N;k[W+52>>2]=0;k[N>>2]=0;if((f|0)>0){j=T+4|0;l=U+4|0;m=V+36|0;n=V+16|0;p=V+4|0;q=V+40|0;s=V+44|0;t=V+48|0;u=T+8|0;v=T+12|0;w=T+4|0;x=T+4|0;y=U+4|0;z=V+8|0;A=V+12|0;B=V+4|0;C=R+36|0;D=R+16|0;E=R+4|0;F=R+40|0;G=R+44|0;H=R+48|0;I=R+32|0;J=V+32|0;h=0;do{g=aa(h,K)|0;c=h;h=h+1|0;d=aa(h,K)|0;k[T>>2]=-2147483648;k[j>>2]=2147483647;k[U>>2]=g;k[l>>2]=d;H1(V,a,T,U);KG(W,V)|0;d=k[m>>2]|0;if(d|0?(f=d+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){e=k[m>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[J>>2]|0;if(!d){d=B1()|0;e=k[m>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[m>>2]=0}k[m>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[p>>2]|0)>0){e=k[q>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[p>>2]|0))}d=k[s>>2]|0;if(!((d|0)==(t|0)|(d|0)==0))ggb(k[d+-4>>2]|0);k[u>>2]=0;k[v>>2]=0;k[T>>2]=16842752;k[w>>2]=W;Y=+N7(T,4,49332);d=k[O>>2]|0;g=S+((aa(d+1|0,c)|0)<<2)|0;o[g>>2]=Y*Y;if((h|0)<(k[P>>2]|0)){f=h;do{e=aa(f,K)|0;g=f;f=f+1|0;d=aa(f,K)|0;k[T>>2]=-2147483648;k[x>>2]=2147483647;k[U>>2]=e;k[y>>2]=d;H1(R,b,T,U);k[z>>2]=0;k[A>>2]=0;k[V>>2]=16842752;k[B>>2]=R;Y=+r$(W,V);d=S+((aa(k[P>>2]|0,c)|0)+g<<2)|0;o[d>>2]=Y;d=k[C>>2]|0;if(d|0?(d=d+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){e=k[C>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[I>>2]|0;if(d|0)break;d=B1()|0;e=k[C>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[C>>2]=0}k[C>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[E>>2]|0)>0){e=k[F>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[E>>2]|0))}d=k[G>>2]|0;if(!((d|0)==(H|0)|(d|0)==0))ggb(k[d+-4>>2]|0);e=k[P>>2]|0;d=S+((aa(e,c)|0)+g<<2)|0;g=S+((aa(e,g)|0)+c<<2)|0;k[g>>2]=k[d>>2]}while((f|0)<(e|0));d=k[O>>2]|0}}while((h|0)<(d|0));d=W+36|0;e=k[d>>2]|0;if((e|0)!=0?(U=e+12|0,V=k[U>>2]|0,k[U>>2]=V+-1,(V|0)==1):0){f=k[d>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[W+32>>2]|0;if(!e){e=B1()|0;f=k[d>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[d>>2]=0}}else d=W+36|0;k[d>>2]=0;W=W+16|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Q>>2]|0)>0){e=k[M>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Q>>2]|0))}d=k[L>>2]|0;if(!((d|0)==(N|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=X;return}function A6a(a){a=a|0;ggb(a);return}function B6a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,m=0,n=0.0,q=0.0,s=0.0,t=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0;Sa=r;r=r+1184|0;Pa=Sa+128|0;Oa=Sa+72|0;g=Sa+8|0;Na=Sa+16|0;h=Sa;La=a+32|0;m=k[La>>2]|0;Ba=+(m+-1|0)*.5;Ca=a+36|0;e=k[Ca>>2]|0;Ea=+(e+-1|0)*.5;Fa=k[a+4>>2]|0;Ga=k[a+8>>2]|0;Ha=k[a+12>>2]|0;Ia=((k[Fa>>2]|0)>>>3&511)+1|0;Ja=Ia<<1;f=aa(aa(m*3|0,e)|0,Ia)|0;Qa=Pa+8|0;k[Pa>>2]=Qa;Ra=Pa+4|0;k[Ra>>2]=520;if(f>>>0>520){d=f>>>0>2147483647?-1:f<<1;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[Pa>>2]=c}else c=Qa;k[Ra>>2]=f;k[g>>2]=m;k[g+4>>2]=e;YN(Oa,g,(Ia<<3)+-5|0,c,0);c=k[La>>2]|0;k[h>>2]=c;ca=k[Ca>>2]|0;k[h+4>>2]=ca;YN(Na,h,(Ia<<4)+-5|0,(k[Pa>>2]|0)+((aa(aa(ca,Ia)|0,c)|0)<<1)|0,0);c=k[b>>2]|0;ca=b+4|0;if((c|0)<(k[ca>>2]|0)){da=a+16|0;ea=a+56|0;fa=a+60|0;ga=a+64|0;ha=a+20|0;ia=a+24|0;ja=a+28|0;ka=Ha+12|0;la=Ha+8|0;ma=Ha+48|0;na=Fa+48|0;oa=Ga+48|0;pa=Fa+16|0;qa=Ha+16|0;ra=Oa+16|0;sa=Oa+44|0;ta=Na+16|0;ua=Na+44|0;va=Ja|1;wa=a+68|0;xa=a+44|0;ya=Ga+12|0;za=Ga+8|0;Aa=Ga+16|0;$=a+48|0;ba=Ia<<5;_=c;do{Y=k[da>>2]|0;Z=k[ea>>2]|0;n=1.0/+(1<<Z|0);q=+o[Y+(_<<3)>>2]*n;s=+o[Y+(_<<3)+4>>2]*n;if((Z|0)==(k[fa>>2]|0)){c=k[ha>>2]|0;if(!(k[ga>>2]&4)){N=q;V=s}else{N=n*+o[c+(_<<3)>>2];V=n*+o[c+(_<<3)+4>>2]}}else{c=k[ha>>2]|0;N=+o[c+(_<<3)>>2]*2.0;V=+o[c+(_<<3)+4>>2]*2.0}X=c+(_<<3)|0;o[X>>2]=N;W=c+(_<<3)+4|0;o[W>>2]=V;n=q-Ba;q=s-Ea;e=~~n;e=e-(+(e|0)>n&1)|0;M=~~q;M=M-(+(M|0)>q&1)|0;d=k[La>>2]|0;a:do if((((e|0)>=(0-d|0)?(e|0)<(k[ka>>2]|0):0)?(Da=k[Ca>>2]|0,(M|0)>=(0-Da|0)):0)?(M|0)<(k[la>>2]|0):0){s=n-+(e|0);w=q-+(M|0);x=1.0-s;q=1.0-w;n=x*q*16384.0;c=(o[u>>2]=n,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;n=c?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=c?-0.0:0.0}L=~~n;n=s*q*16384.0;c=(o[u>>2]=n,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;n=c?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=c?-0.0:0.0}K=~~n;n=w*x*16384.0;c=(o[u>>2]=n,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;n=c?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=c?-0.0:0.0}F=~~n;G=16384-L-K-F|0;H=((k[ma>>2]|0)>>>0)/((1212424721>>>(k[Ha>>2]<<2&28)&15)>>>0)|0;I=((k[na>>2]|0)>>>0)/((1212424721>>>(k[Fa>>2]<<2&28)&15)>>>0)|0;Y=((k[oa>>2]|0)>>>0)/((1212424721>>>(k[Ga>>2]<<2&28)&15)>>>0)|0;if((Da|0)>0){J=aa(e,Ia)|0;B=aa(e,Ja)|0;C=H+Ja|0;D=H+1|0;E=C+1|0;a=k[pa>>2]|0;t=k[qa>>2]|0;v=k[ra>>2]|0;y=k[k[sa>>2]>>2]|0;z=k[ta>>2]|0;A=k[k[ua>>2]>>2]|0;m=aa(d,Ia)|0;b=(m|0)>0;n=0.0;q=0.0;s=0.0;h=0;d=Da;while(1){c=h+M|0;f=a+(aa(c,I)|0)+J|0;g=v+(aa(y,h)|0)|0;if(b){d=z+(aa(A,h)|0)|0;e=0;c=t+((aa(c,H)|0)<<1)+(B<<1)|0;while(1){Ua=aa(l[f+e>>0]|0,L)|0;Xa=aa(l[f+(e+Ia)>>0]|0,K)|0;Va=e+I|0;Wa=aa(l[f+Va>>0]|0,F)|0;Va=(Ua+256+Xa+Wa+(aa(l[f+(Va+Ia)>>0]|0,G)|0)|0)>>>9;Wa=aa(j[c>>1]|0,L)|0;Xa=aa(j[c+(Ja<<1)>>1]|0,K)|0;Ua=aa(j[c+(H<<1)>>1]|0,F)|0;Ua=Wa+8192+Xa+Ua+(aa(j[c+(C<<1)>>1]|0,G)|0)>>14;Xa=aa(j[c+2>>1]|0,L)|0;Wa=aa(j[c+(va<<1)>>1]|0,K)|0;Ta=aa(j[c+(D<<1)>>1]|0,F)|0;Ta=Xa+8192+Wa+Ta+(aa(j[c+(E<<1)>>1]|0,G)|0)>>14;j[g+(e<<1)>>1]=Va;j[d>>1]=Ua;j[d+2>>1]=Ta;n=n+ +(aa(Ua,Ua)|0);q=q+ +(aa(Ta,Ua)|0);s=s+ +(aa(Ta,Ta)|0);e=e+1|0;if((e|0)==(m|0))break;else{d=d+4|0;c=c+4|0}}c=k[Ca>>2]|0}else c=d;h=h+1|0;if((h|0)>=(c|0))break;else d=c}M=c;d=k[La>>2]|0}else{n=0.0;q=0.0;s=0.0;M=Da}U=n*9.5367431640625e-07;T=q*9.5367431640625e-07;S=s*9.5367431640625e-07;n=S*U-T*T;q=U-S;q=(S+U-+Q(+(T*(T*4.0)+q*q)))/+(aa(M<<1,d)|0);c=k[ja>>2]|0;if(c|0?k[ga>>2]&8|0:0)o[c+(_<<2)>>2]=q;if(n<1.1920928955078125e-07?1:q<+o[wa>>2]){if(Z|0)break;c=k[ia>>2]|0;if(!c)break;i[c+_>>0]=0;break}R=1.0/n;I=k[xa>>2]|0;b:do if((I|0)>0){J=0-d|0;K=0-M|0;L=(M|0)>0;G=aa(d,Ia)|0;H=(G|0)>0;E=0;F=0;O=N-Ba;N=V-Ea;D=0;c:while(1){d=~~O;d=d-(+(d|0)>O&1)|0;C=~~N;C=C-(+(C|0)>N&1)|0;if((d|0)<(J|0))break;if((C|0)<(K|0)?1:(d|0)>=(k[ya>>2]|0))break;if((C|0)>=(k[za>>2]|0))break;q=O-+(d|0);w=N-+(C|0);x=1.0-q;s=1.0-w;n=x*s*16384.0;c=(o[u>>2]=n,k[u>>2]|0);do if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;n=c?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(!(n==0.0))break;n=c?-0.0:0.0}while(0);B=~~n;n=q*s*16384.0;c=(o[u>>2]=n,k[u>>2]|0);do if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;n=c?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(!(n==0.0))break;n=c?-0.0:0.0}while(0);A=~~n;n=x*w*16384.0;c=(o[u>>2]=n,k[u>>2]|0);do if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;n=c?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(!(n==0.0))break;n=c?-0.0:0.0}while(0);v=~~n;y=16384-B-A-v|0;do if(L){z=k[Aa>>2]|0;f=aa(d,Ia)|0;g=k[ra>>2]|0;h=k[k[sa>>2]>>2]|0;m=k[ta>>2]|0;b=k[k[ua>>2]>>2]|0;if(H){q=0.0;n=0.0;e=0}else{q=0.0;n=0.0;break}do{a=z+(aa(e+C|0,Y)|0)+f|0;t=g+(aa(h,e)|0)|0;d=m+(aa(b,e)|0)|0;c=0;while(1){Ua=aa(l[a+c>>0]|0,B)|0;Va=aa(l[a+(c+Ia)>>0]|0,A)|0;Xa=c+Y|0;Wa=aa(l[a+Xa>>0]|0,v)|0;Xa=Ua+256+Va+Wa+(aa(l[a+(Xa+Ia)>>0]|0,y)|0)>>9;Xa=Xa-(j[t+(c<<1)>>1]|0)|0;n=n+ +(aa(Xa,j[d>>1]|0)|0);q=q+ +(aa(Xa,j[d+2>>1]|0)|0);c=c+1|0;if((c|0)==(G|0))break;else d=d+4|0}e=e+1|0}while((e|0)!=(M|0))}else{q=0.0;n=0.0}while(0);s=n*9.5367431640625e-07;q=q*9.5367431640625e-07;n=R*(T*q-S*s);q=R*(T*s-U*q);c=F;F=(o[u>>2]=n,k[u>>2]|0);d=D;D=(o[u>>2]=q,k[u>>2]|0);O=O+n;N=N+q;s=Ba+O;w=Ea+N;o[X>>2]=s;o[W>>2]=w;x=n;V=q;if(x*x+V*V<=+p[$>>3]){Ma=88;break b}do if((E|0)>0){if(!(+P(+((k[u>>2]=c,+o[u>>2])+n))<.01))break;if(+P(+((k[u>>2]=d,+o[u>>2])+q))<.01){Ma=86;break c}}while(0);E=E+1|0;if((E|0)>=(I|0)){Ma=88;break b}}if((Ma|0)==86){o[X>>2]=s-n*.5;o[W>>2]=w-q*.5;Ma=88;break}if(!Z){c=k[ia>>2]|0;if(!c)d=0;else{i[c+_>>0]=0;Ma=88}}else Ma=88}else Ma=88;while(0);if((Ma|0)==88){Ma=0;d=k[ia>>2]|0}c=d+_|0;if((i[c>>0]|0?(Ka=k[ja>>2]|0,Ka|0):0)?(k[ea>>2]|0)==0:0){if(k[ga>>2]&8|0)break;e=k[ha>>2]|0;n=+o[e+(_<<3)>>2]-Ba;q=+o[e+(_<<3)+4>>2]-Ea;e=~~n;e=e-(+(e|0)>n&1)|0;A=~~q;A=A-(+(A|0)>q&1)|0;B=k[La>>2]|0;do if((e|0)>=(0-B|0)){if((e|0)>=(k[ya>>2]|0))break;C=k[Ca>>2]|0;if((A|0)<(0-C|0))break;if((A|0)>=(k[za>>2]|0))break;s=n-+(e|0);w=q-+(A|0);x=1.0-s;q=1.0-w;n=x*q*16384.0;c=(o[u>>2]=n,k[u>>2]|0);do if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;n=c?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(!(n==0.0))break;n=c?-0.0:0.0}while(0);z=~~n;n=s*q*16384.0;c=(o[u>>2]=n,k[u>>2]|0);do if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;n=c?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(!(n==0.0))break;n=c?-0.0:0.0}while(0);y=~~n;n=x*w*16384.0;c=(o[u>>2]=n,k[u>>2]|0);do if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;n=c?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(!(n==0.0))break;n=c?-0.0:0.0}while(0);a=~~n;t=16384-z-y-a|0;do if((C|0)>0){v=k[Aa>>2]|0;e=aa(e,Ia)|0;f=k[ra>>2]|0;g=k[k[sa>>2]>>2]|0;h=aa(B,Ia)|0;if((h|0)>0){n=0.0;d=0}else{n=0.0;break}do{m=v+(aa(d+A|0,Y)|0)+e|0;b=f+(aa(g,d)|0)|0;c=0;do{Ua=aa(l[m+c>>0]|0,z)|0;Va=aa(l[m+(c+Ia)>>0]|0,y)|0;Xa=c+Y|0;Wa=aa(l[m+Xa>>0]|0,a)|0;Xa=Ua+256+Va+Wa+(aa(l[m+(Xa+Ia)>>0]|0,t)|0)>>9;n=n+ +P(+(+(Xa-(j[b+(c<<1)>>1]|0)|0)));c=c+1|0}while((c|0)!=(h|0));d=d+1|0}while((d|0)!=(C|0))}else n=0.0;while(0);V=n/+(aa(aa(ba,C)|0,B)|0);o[Ka+(_<<2)>>2]=V;break a}while(0);if(!d)break;i[c>>0]=0}}else Ma=31;while(0);if((Ma|0)==31?(Ma=0,(Z|0)==0):0){c=k[ia>>2]|0;if(c|0)i[c+_>>0]=0;c=k[ja>>2]|0;if(c|0)o[c+(_<<2)>>2]=0.0}_=_+1|0}while((_|0)<(k[ca>>2]|0))}e=Na+36|0;c=k[e>>2]|0;if(c|0?(Wa=c+12|0,Xa=k[Wa>>2]|0,k[Wa>>2]=Xa+-1,(Xa|0)==1):0){c=k[e>>2]|0;if(c|0){d=k[c+4>>2]|0;if(!d){d=k[Na+32>>2]|0;if(!d){d=B1()|0;c=k[e>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,c)}k[e>>2]=0}k[e>>2]=0;Xa=Na+16|0;d=Na+4|0;k[Xa>>2]=0;k[Xa+4>>2]=0;k[Xa+8>>2]=0;k[Xa+12>>2]=0;if((k[d>>2]|0)>0){e=k[Na+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[Na+44>>2]|0;if(!((c|0)==(Na+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=Oa+36|0;c=k[e>>2]|0;if(c|0?(Wa=c+12|0,Xa=k[Wa>>2]|0,k[Wa>>2]=Xa+-1,(Xa|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[Oa+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;Xa=Oa+16|0;d=Oa+4|0;k[Xa>>2]=0;k[Xa+4>>2]=0;k[Xa+8>>2]=0;k[Xa+12>>2]=0;if((k[d>>2]|0)>0){e=k[Oa+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[Oa+44>>2]|0;if(!((c|0)==(Oa+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[Pa>>2]|0;if((c|0)==(Qa|0)){r=Sa;return}if(c|0)ggb(c);k[Pa>>2]=Qa;k[Ra>>2]=520;r=Sa;return}function C6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0;Oa=r;r=r+368|0;La=Oa+304|0;Na=Oa+248|0;Ba=Oa+192|0;Ca=Oa+64|0;Da=Oa+136|0;Ea=Oa+120|0;Fa=Oa+32|0;Ga=Oa;do if((k[a>>2]&2031616|0)==65536){m=k[a+4>>2]|0;k[Na>>2]=k[m>>2];q=Na+4|0;a=m+4|0;k[q>>2]=k[a>>2];Aa=Na+8|0;k[Aa>>2]=k[m+8>>2];k[Na+12>>2]=k[m+12>>2];k[Na+16>>2]=k[m+16>>2];k[Na+20>>2]=k[m+20>>2];k[Na+24>>2]=k[m+24>>2];k[Na+28>>2]=k[m+28>>2];k[Na+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[Na+36>>2]=j;l=Na+40|0;k[l>>2]=Aa;Aa=Na+48|0;o=Na+44|0;k[o>>2]=Aa;k[Na+52>>2]=0;k[Aa>>2]=0;if(j|0){Aa=j+12|0;k[Aa>>2]=(k[Aa>>2]|0)+1}if((k[a>>2]|0)<3){za=k[m+44>>2]|0;Aa=k[o>>2]|0;k[Aa>>2]=k[za>>2];k[Aa+4>>2]=k[za+4>>2];Aa=Na;break}k[q>>2]=0;x1(Na,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[p+(a<<2)>>2];k[j+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0));Aa=Na}else Aa=Na}else{Q1(Na,a,-1);Aa=Na}while(0);if(!(((k[Aa>>2]&7|0)==0?(k[c>>2]|0)>2:0)?(k[c+4>>2]|0)>2:0)){k[La>>2]=0;a=La+4|0;k[a>>2]=0;j=ZT(68)|0;k[j>>2]=1;l=j+4|0;k[La>>2]=l;k[a>>2]=63;i[j+67>>0]=0;m=403362;n=l+63|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,La,403426,403450,748);k[a>>2]=0;k[La>>2]=0;za=k[j>>2]|0;k[j>>2]=za+-1;if((za|0)==1)ggb(k[j+-4>>2]|0)}xa=e?2:1;wa=aa(xa,d+1|0)|0;k[La>>2]=1;ya=La+4|0;k[ya>>2]=wa;P1(b,2,La,0,-1,1,0);wa=k[Aa>>2]|0;za=wa<<1&8176|11;do if(h?(f&16|0)==0&(wa&32768|0)!=0:0){k[La>>2]=0;l=La+4|0;k[l>>2]=0;k[Ba>>2]=0;a=Ba+4|0;k[a>>2]=0;N1(Na,La,Ba);m=k[Ba>>2]|0;n=k[c>>2]|0;if((m|0)<(n|0)){Ma=27;break}a=k[a>>2]|0;j=k[c+4>>2]|0;if((a|0)<(j|0)){Ma=27;break}if((n+m+(k[Na+12>>2]|0)|0)>(k[La>>2]|0)){Ma=27;break}if((j+a+(k[Na+8>>2]|0)|0)>(k[l>>2]|0)){Ma=27;break}else{KG(J2(b,0)|0,Na)|0;break}}else Ma=27;while(0);if((Ma|0)==27){p=J2(b,0)|0;o=p+16|0;if(k[o>>2]|0){l=k[p+4>>2]|0;if((l|0)<3)a=aa(k[p+12>>2]|0,k[p+8>>2]|0)|0;else{m=k[p+40>>2]|0;j=0;a=1;do{a=aa(k[m+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(l|0))}if(a|0){va=k[c+4>>2]|0;wa=k[c>>2]|0;O1(p,va,va,wa,wa)}}n=k[p>>2]|0;m=k[Aa>>2]|0;if(!((m^n)&4095)){a=k[c>>2]|0;j=k[Na+12>>2]|0;if(!((k[p+12>>2]|0)==((a<<1)+j|0)?(k[p+8>>2]|0)==((k[c+4>>2]<<1)+(k[Na+8>>2]|0)|0):0))Ma=38}else{a=k[c>>2]|0;j=k[Na+12>>2]|0;Ma=38}do if((Ma|0)==38){l=(k[c+4>>2]<<1)+(k[Na+8>>2]|0)|0;j=(a<<1)+j|0;a=m&4095;if((((k[p+4>>2]|0)<3?(k[p+8>>2]|0)==(l|0):0)?(k[p+12>>2]|0)==(j|0):0)?!((n&4095|0)!=(a|0)|(k[o>>2]|0)==0):0)break;k[La>>2]=l;k[La+4>>2]=j;G1(p,2,La,a)}while(0);if((f|0)==5){a=c+4|0;wa=k[a>>2]|0;j=k[Na+12>>2]|0;m=k[Na+8>>2]|0;k[Ca>>2]=k[c>>2];k[Ca+4>>2]=wa;k[Ca+8>>2]=j;k[Ca+12>>2]=m;I1(Ba,p,Ca);m=La+4|0;j=m+4|0;k[j>>2]=0;k[j+4>>2]=0;k[La>>2]=-1040121856;k[m>>2]=Ba;mY(Na,La);m=Ba+36|0;j=k[m>>2]|0;if(j|0?(va=j+12|0,wa=k[va>>2]|0,k[va>>2]=wa+-1,(wa|0)==1):0){l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;if(!j){j=k[Ba+32>>2]|0;if(!j){j=B1()|0;l=k[m>>2]|0}}jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}k[m>>2]=0;wa=Ba+16|0;l=Ba+4|0;k[wa>>2]=0;k[wa+4>>2]=0;k[wa+8>>2]=0;k[wa+12>>2]=0;if((k[l>>2]|0)>0){m=k[Ba+40>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[Ba+44>>2]|0;if(!((j|0)==(Ba+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);j=c}else{k[La+8>>2]=0;k[La+12>>2]=0;k[La>>2]=16842752;k[La+4>>2]=Na;a=Ba+4|0;wa=a+4|0;k[wa>>2]=0;k[wa+4>>2]=0;k[Ba>>2]=33619968;k[a>>2]=p;a=c+4|0;wa=k[a>>2]|0;j=k[c>>2]|0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;k[Ca+16>>2]=0;k[Ca+20>>2]=0;k[Ca+24>>2]=0;k[Ca+28>>2]=0;vY(La,Ba,wa,wa,j,j,f,Ca);j=c}va=0-(k[a>>2]|0)|0;wa=0-(k[j>>2]|0)|0;O1(p,va,va,wa,wa)}wa=Na+40|0;oa=k[wa>>2]|0;l=k[oa>>2]|0;k[Ba>>2]=k[oa+4>>2];oa=Ba+4|0;k[oa>>2]=l;l=J2(b,0)|0;k[Ca>>2]=k[l>>2];ta=Ca+4|0;a=l+4|0;k[ta>>2]=k[a>>2];p=Ca+8|0;k[p>>2]=k[l+8>>2];q=Ca+12|0;k[q>>2]=k[l+12>>2];qa=Ca+16|0;k[qa>>2]=k[l+16>>2];h=Ca+20|0;k[h>>2]=k[l+20>>2];s=Ca+24|0;k[s>>2]=k[l+24>>2];t=Ca+28|0;k[t>>2]=k[l+28>>2];pa=Ca+32|0;k[pa>>2]=k[l+32>>2];ra=Ca+36|0;j=k[l+36>>2]|0;k[ra>>2]=j;sa=Ca+40|0;k[sa>>2]=p;va=Ca+48|0;ua=Ca+44|0;k[ua>>2]=va;k[Ca+52>>2]=0;k[va>>2]=0;if(j|0){na=j+12|0;k[na>>2]=(k[na>>2]|0)+1}if((k[a>>2]|0)>=3){k[ta>>2]=0;x1(Ca,k[a>>2]|0,0,0,0);a=k[ta>>2]|0;if((a|0)>0){n=k[l+40>>2]|0;o=k[sa>>2]|0;l=k[l+44>>2]|0;m=k[ua>>2]|0;j=0;do{k[o+(j<<2)>>2]=k[n+(j<<2)>>2];k[m+(j<<2)>>2]=k[l+(j<<2)>>2];j=j+1|0;a=k[ta>>2]|0}while((j|0)<(a|0))}}else{na=k[l+44>>2]|0;a=k[ua>>2]|0;k[a>>2]=k[na>>2];k[a+4>>2]=k[na+4>>2];a=k[ta>>2]|0}k[Da>>2]=k[Ca>>2];na=Da+4|0;k[na>>2]=a;ma=Da+8|0;k[ma>>2]=k[p>>2];k[Da+12>>2]=k[q>>2];la=Da+16|0;k[la>>2]=k[qa>>2];k[Da+20>>2]=k[h>>2];k[Da+24>>2]=k[s>>2];k[Da+28>>2]=k[t>>2];ha=Da+32|0;k[ha>>2]=k[pa>>2];ia=Da+36|0;j=k[ra>>2]|0;k[ia>>2]=j;ja=Da+40|0;k[ja>>2]=ma;ma=Da+48|0;ka=Da+44|0;k[ka>>2]=ma;k[Da+52>>2]=0;k[ma>>2]=0;if(j){a=j+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[ta>>2]|0}if((a|0)>=3){k[na>>2]=0;x1(Da,a,0,0,0);if((k[na>>2]|0)>0){j=k[sa>>2]|0;l=k[ja>>2]|0;m=k[ua>>2]|0;n=k[ka>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[j+(a<<2)>>2];k[n+(a<<2)>>2]=k[m+(a<<2)>>2];a=a+1|0}while((a|0)<(k[na>>2]|0))}}else{fa=k[ua>>2]|0;ga=k[ka>>2]|0;k[ga>>2]=k[fa>>2];k[ga+4>>2]=k[fa+4>>2]}a:do if((d|0)<0)m=d;else{S=c+4|0;T=Ea+4|0;U=Ea+8|0;V=Ea+12|0;W=(g|0)==5;X=La+36|0;Y=La+16|0;Z=La+4|0;_=La+40|0;$=La+44|0;ba=La+48|0;ca=Ea+8|0;da=Ea+12|0;ea=Ea+4|0;fa=Fa+4|0;ga=fa+4|0;v=g|16;w=za&4091;x=La+4|0;y=Ea+4|0;z=Ea+8|0;A=Ea+12|0;B=La+36|0;C=La+16|0;D=La+4|0;E=La+40|0;F=La+44|0;G=La+48|0;H=La+8|0;I=La+12|0;J=La+4|0;K=Ea+4|0;L=K+4|0;M=(f|0)==5;N=La+8|0;O=La+12|0;P=La+4|0;Q=Ea+4|0;R=Q+4|0;g=f|16;f=La+32|0;u=La+32|0;m=0;while(1){if(m|0){t=J2(b,aa(m,xa)|0)|0;s=t+16|0;if(k[s>>2]|0){l=k[t+4>>2]|0;if((l|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{n=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[n+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(l|0))}if(a|0){q=k[S>>2]|0;h=k[c>>2]|0;O1(t,q,q,h,h)}}h=k[t>>2]|0;o=k[Aa>>2]|0;if(!((o^h)&4095)){a=k[c>>2]|0;j=k[Ba>>2]|0;if((k[t+12>>2]|0)==((a<<1)+j|0)?(Ha=k[S>>2]|0,Ia=k[oa>>2]|0,(k[t+8>>2]|0)==((Ha<<1)+Ia|0)):0){n=a;l=Ha;a=Ia}else{n=a;Ma=88}}else{j=k[Ba>>2]|0;n=k[c>>2]|0;Ma=88}do if((Ma|0)==88){Ma=0;a=k[oa>>2]|0;l=k[S>>2]|0;p=(l<<1)+a|0;q=(n<<1)+j|0;o=o&4095;if((((k[t+4>>2]|0)<3?(k[t+8>>2]|0)==(p|0):0)?(k[t+12>>2]|0)==(q|0):0)?!((h&4095|0)!=(o|0)|(k[s>>2]|0)==0):0)break;k[La>>2]=p;k[x>>2]=q;G1(t,2,La,o);n=k[c>>2]|0;l=k[S>>2]|0}while(0);k[Ea>>2]=n;k[y>>2]=l;k[z>>2]=j;k[A>>2]=a;I1(La,t,Ea);KG(Da,La)|0;a=k[B>>2]|0;if(a|0?(h=a+12|0,s=k[h>>2]|0,k[h>>2]=s+-1,(s|0)==1):0){j=k[B>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[u>>2]|0;if(a|0)break;a=B1()|0;j=k[B>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[B>>2]=0}k[B>>2]=0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[D>>2]|0)>0){j=k[E>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[D>>2]|0))}a=k[F>>2]|0;if(!((a|0)==(G|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[H>>2]=0;k[I>>2]=0;k[La>>2]=16842752;k[J>>2]=Ca;s=L;k[s>>2]=0;k[s+4>>2]=0;k[Ea>>2]=33619968;k[K>>2]=Da;Jra(La,Ea,Ba,4);if(!M){k[N>>2]=0;k[O>>2]=0;k[La>>2]=16842752;k[P>>2]=Da;h=R;k[h>>2]=0;k[h+4>>2]=0;k[Ea>>2]=33619968;k[Q>>2]=t;h=k[S>>2]|0;s=k[c>>2]|0;k[Fa>>2]=0;k[Fa+4>>2]=0;k[Fa+8>>2]=0;k[Fa+12>>2]=0;k[Fa+16>>2]=0;k[Fa+20>>2]=0;k[Fa+24>>2]=0;k[Fa+28>>2]=0;vY(La,Ea,h,h,s,s,g,Fa)}h=0-(k[S>>2]|0)|0;s=0-(k[c>>2]|0)|0;O1(t,h,h,s,s)}if(e){s=J2(b,(aa(m,xa)|0)+1|0)|0;h=s+16|0;if(k[h>>2]|0){l=k[s+4>>2]|0;if((l|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{n=k[s+40>>2]|0;j=0;a=1;do{a=aa(k[n+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(l|0))}if(a|0){q=k[S>>2]|0;t=k[c>>2]|0;O1(s,q,q,t,t)}}q=k[s>>2]&4095;if((q|0)==(za|0)){a=k[c>>2]|0;j=k[Ba>>2]|0;if((k[s+12>>2]|0)==((a<<1)+j|0)?(Ja=k[S>>2]|0,Ka=k[oa>>2]|0,(k[s+8>>2]|0)==((Ja<<1)+Ka|0)):0){o=a;l=Ja;a=Ka}else{o=a;Ma=121}}else{j=k[Ba>>2]|0;o=k[c>>2]|0;Ma=121}do if((Ma|0)==121){Ma=0;a=k[oa>>2]|0;l=k[S>>2]|0;n=(l<<1)+a|0;p=(o<<1)+j|0;if((((k[s+4>>2]|0)<3?(k[s+8>>2]|0)==(n|0):0)?(k[s+12>>2]|0)==(p|0):0)?!((q|0)!=(w|0)|(k[h>>2]|0)==0):0)break;k[La>>2]=n;k[x>>2]=p;G1(s,2,La,w);o=k[c>>2]|0;l=k[S>>2]|0}while(0);k[Ea>>2]=o;k[T>>2]=l;k[U>>2]=j;k[V>>2]=a;I1(La,s,Ea);D6a(Da,La);if(!W){k[ca>>2]=0;k[da>>2]=0;k[Ea>>2]=16842752;k[ea>>2]=La;h=ga;k[h>>2]=0;k[h+4>>2]=0;k[Fa>>2]=33619968;k[fa>>2]=s;h=k[S>>2]|0;t=k[c>>2]|0;k[Ga>>2]=0;k[Ga+4>>2]=0;k[Ga+8>>2]=0;k[Ga+12>>2]=0;k[Ga+16>>2]=0;k[Ga+20>>2]=0;k[Ga+24>>2]=0;k[Ga+28>>2]=0;vY(Ea,Fa,h,h,t,t,v,Ga)}t=0-(k[S>>2]|0)|0;a=0-(k[c>>2]|0)|0;O1(s,t,t,a,a);a=k[X>>2]|0;if(a|0?(s=a+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){j=k[X>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[f>>2]|0;if(a|0)break;a=B1()|0;j=k[X>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[X>>2]=0}k[X>>2]=0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[Z>>2]|0)>0){j=k[_>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Z>>2]|0))}a=k[$>>2]|0;if(!((a|0)==(ba|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}t=((k[Ba>>2]|0)+1|0)/2|0;a=((k[oa>>2]|0)+1|0)/2|0;k[Ba>>2]=t;k[oa>>2]=a;if((t|0)<=(k[c>>2]|0))break;if((a|0)<=(k[S>>2]|0))break;KG(Ca,Da)|0;if((m|0)<(d|0))m=m+1|0;else{m=d;break a}}Ma=aa(m+1|0,xa)|0;k[La>>2]=1;k[ya>>2]=Ma;P1(b,2,La,0,-1,1,0)}while(0);a=k[ia>>2]|0;if(a|0?(La=a+12|0,Ma=k[La>>2]|0,k[La>>2]=Ma+-1,(Ma|0)==1):0){j=k[ia>>2]|0;if(j|0){a=k[j+4>>2]|0;if(!a){a=k[ha>>2]|0;if(!a){a=B1()|0;j=k[ia>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[ia>>2]=0}k[ia>>2]=0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[na>>2]|0)>0){j=k[ja>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[na>>2]|0))}a=k[ka>>2]|0;if(!((a|0)==(ma|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[ra>>2]|0;if(a|0?(La=a+12|0,Ma=k[La>>2]|0,k[La>>2]=Ma+-1,(Ma|0)==1):0){j=k[ra>>2]|0;if(j|0){a=k[j+4>>2]|0;if(!a){a=k[pa>>2]|0;if(!a){a=B1()|0;j=k[ra>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[ra>>2]=0}k[ra>>2]=0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[qa+12>>2]=0;if((k[ta>>2]|0)>0){j=k[sa>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ta>>2]|0))}a=k[ua>>2]|0;if(!((a|0)==(va|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=Na+36|0;a=k[l>>2]|0;if(a|0?(La=a+12|0,Ma=k[La>>2]|0,k[La>>2]=Ma+-1,(Ma|0)==1):0){j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;do if(!a){a=k[Na+32>>2]|0;if(a|0)break;a=B1()|0;j=k[l>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}k[l>>2]=0;Ma=Na+16|0;l=Na+4|0;k[Ma>>2]=0;k[Ma+4>>2]=0;k[Ma+8>>2]=0;k[Ma+12>>2]=0;if((k[l>>2]|0)>0){j=k[wa>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[Na+44>>2]|0;if((a|0)==(Na+48|0)|(a|0)==0){r=Oa;return m|0}ggb(k[a+-4>>2]|0);r=Oa;return m|0}function D6a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;F=r;r=r+1056|0;D=F;E=k[a+8>>2]|0;h=k[a+12>>2]|0;A=k[a>>2]|0;B=(A>>>3&511)+1|0;C=aa(B,h)|0;if(A&7|0){c=D+4|0;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;k[D>>2]=e;k[c>>2]=14;i[d+18>>0]=0;f=403519;g=e+14|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,D,403534,403450,57);k[c>>2]=0;k[D>>2]=0;A=k[d>>2]|0;k[d>>2]=A+-1;if((A|0)==1)ggb(k[d+-4>>2]|0)}c=(B<<4)+4091&4091;if(!(((((k[b+4>>2]|0)<3?(k[b+8>>2]|0)==(E|0):0)?(k[b+12>>2]|0)==(h|0):0)?(k[b>>2]&4095|0)==(c|0):0)?(k[b+16>>2]|0)!=0:0)){k[D>>2]=E;k[D+4>>2]=h;G1(b,2,D,c)}f=(aa(B,h+2|0)|0)+15&-16;e=(f<<1)+64|0;z=D+8|0;k[D>>2]=z;A=D+4|0;k[A>>2]=520;if(e>>>0>520){d=e>>>0>2147483647?-1:e<<1;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[D>>2]=c}else c=z;k[A>>2]=e;y=c+(B<<1)+15&-16;s=y+(f<<1)|0;if((E|0)>0){v=(E|0)!=1;t=v&1;u=E+-1|0;v=v?E+-2|0:0;w=(C|0)>0;q=(h|0)>1;x=q?B:0;q=aa(B,q?h+-2|0:0)|0;p=k[a+16>>2]|0;n=k[k[a+44>>2]>>2]|0;o=k[b+16>>2]|0;a=k[k[b+44>>2]>>2]|0;h=0;do{e=p+(aa(n,(h|0)>0?h+-1|0:t)|0)|0;f=p+(aa(n,h)|0)|0;b=h;h=h+1|0;g=p+(aa(n,(b|0)<(u|0)?h:v)|0)|0;b=o+(aa(a,b)|0)|0;if(w){d=0;do{G=l[e+d>>0]|0;H=l[g+d>>0]|0;j[y+(d<<1)>>1]=((H+G|0)*3|0)+((l[f+d>>0]|0)*10|0);j[s+(d<<1)>>1]=H-G;d=d+1|0}while((d|0)!=(C|0));d=0}else d=0;do{f=d+x|0;g=d-B|0;j[y+(g<<1)>>1]=j[y+(f<<1)>>1]|0;G=d+q|0;H=d+C|0;j[y+(H<<1)>>1]=j[y+(G<<1)>>1]|0;j[s+(g<<1)>>1]=j[s+(f<<1)>>1]|0;j[s+(H<<1)>>1]=j[s+(G<<1)>>1]|0;d=d+1|0}while((d|0)!=(B|0));if(w){d=0;do{f=d+B|0;g=d-B|0;G=(((j[s+(g<<1)>>1]|0)+(j[s+(f<<1)>>1]|0)|0)*3|0)+((j[s+(d<<1)>>1]|0)*10|0)&65535;H=d<<1;j[b+(H<<1)>>1]=(m[y+(f<<1)>>1]|0)-(m[y+(g<<1)>>1]|0);j[b+((H|1)<<1)>>1]=G;d=d+1|0}while((d|0)!=(C|0))}}while((h|0)!=(E|0))}if((c|0)==(z|0)){r=F;return}ggb(c);k[D>>2]=z;k[A>>2]=520;r=F;return}function E6a(a,b,c,d,e,f,g,h,j,l,m,n,q){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;m=+m;n=n|0;q=+q;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;_a=r;r=r+560|0;Ma=_a+496|0;Za=_a+440|0;Ya=_a+384|0;Xa=_a+328|0;Wa=_a+272|0;Ta=_a+244|0;Ua=_a+232|0;Ra=_a+176|0;Na=_a+120|0;E=_a+264|0;F=_a+256|0;Oa=_a+32|0;Pa=_a+104|0;Qa=_a;do if((k[c>>2]&2031616|0)==65536){u=k[c+4>>2]|0;k[Za>>2]=k[u>>2];y=Za+4|0;c=u+4|0;k[y>>2]=k[c>>2];Va=Za+8|0;k[Va>>2]=k[u+8>>2];k[Za+12>>2]=k[u+12>>2];k[Za+16>>2]=k[u+16>>2];k[Za+20>>2]=k[u+20>>2];k[Za+24>>2]=k[u+24>>2];k[Za+28>>2]=k[u+28>>2];k[Za+32>>2]=k[u+32>>2];s=k[u+36>>2]|0;k[Za+36>>2]=s;t=Za+40|0;k[t>>2]=Va;Va=Za+48|0;w=Za+44|0;k[w>>2]=Va;k[Za+52>>2]=0;k[Va>>2]=0;if(s|0){Va=s+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[c>>2]|0)<3){Sa=k[u+44>>2]|0;Va=k[w>>2]|0;k[Va>>2]=k[Sa>>2];k[Va+4>>2]=k[Sa+4>>2];break}k[y>>2]=0;x1(Za,k[c>>2]|0,0,0,0);if((k[y>>2]|0)>0){x=k[u+40>>2]|0;v=k[t>>2]|0;t=k[u+44>>2]|0;s=k[w>>2]|0;c=0;do{k[v+(c<<2)>>2]=k[x+(c<<2)>>2];k[s+(c<<2)>>2]=k[t+(c<<2)>>2];c=c+1|0}while((c|0)<(k[y>>2]|0))}}else Q1(Za,c,-1);while(0);if(!(((h|0)>-1?(k[g>>2]|0)>2:0)?(k[g+4>>2]|0)>2:0)){k[Ma>>2]=0;c=Ma+4|0;k[c>>2]=0;s=ZT(64)|0;k[s>>2]=1;ua=s+4|0;k[Ma>>2]=ua;k[c>>2]=56;i[s+60>>0]=0;sa=403549;va=ua+56|0;do{i[ua>>0]=i[sa>>0]|0;ua=ua+1|0;sa=sa+1|0}while((ua|0)<(va|0));Y8(-215,Ma,403606,403450,1111);k[c>>2]=0;k[Ma>>2]=0;Va=k[s>>2]|0;k[s>>2]=Va+-1;if((Va|0)==1)ggb(k[s+-4>>2]|0)}La=y2(Za,2,5,1)|0;if((La|0)>-1)if(!La){b2(d);b2(e);b2(f)}else C=22;else{k[Ma>>2]=0;c=Ma+4|0;k[c>>2]=0;s=ZT(64)|0;k[s>>2]=1;ua=s+4|0;k[Ma>>2]=ua;k[c>>2]=56;i[s+60>>0]=0;sa=403627;va=ua+56|0;do{i[ua>>0]=i[sa>>0]|0;ua=ua+1|0;sa=sa+1|0}while((ua|0)<(va|0));Y8(-215,Ma,403606,403450,1114);k[c>>2]=0;k[Ma>>2]=0;Va=k[s>>2]|0;k[s>>2]=Va+-1;if((Va|0)==1)ggb(k[s+-4>>2]|0);C=22}if((C|0)==22){if(!(n&4)){Ka=k[Za+40>>2]|0;Sa=k[Ka+4>>2]|0;Va=k[Za>>2]&4095;k[Ma>>2]=k[Ka>>2];k[Ma+4>>2]=Sa;P1(d,2,Ma,Va,-1,1,0)}do if((k[d>>2]&2031616|0)==65536){u=k[d+4>>2]|0;k[Ya>>2]=k[u>>2];y=Ya+4|0;c=u+4|0;k[y>>2]=k[c>>2];Va=Ya+8|0;k[Va>>2]=k[u+8>>2];k[Ya+12>>2]=k[u+12>>2];k[Ya+16>>2]=k[u+16>>2];k[Ya+20>>2]=k[u+20>>2];k[Ya+24>>2]=k[u+24>>2];k[Ya+28>>2]=k[u+28>>2];k[Ya+32>>2]=k[u+32>>2];s=k[u+36>>2]|0;k[Ya+36>>2]=s;t=Ya+40|0;k[t>>2]=Va;Va=Ya+48|0;w=Ya+44|0;k[w>>2]=Va;k[Ya+52>>2]=0;k[Va>>2]=0;if(s|0){Va=s+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[c>>2]|0)<3){Sa=k[u+44>>2]|0;Va=k[w>>2]|0;k[Va>>2]=k[Sa>>2];k[Va+4>>2]=k[Sa+4>>2];break}k[y>>2]=0;x1(Ya,k[c>>2]|0,0,0,0);if((k[y>>2]|0)>0){x=k[u+40>>2]|0;v=k[t>>2]|0;t=k[u+44>>2]|0;s=k[w>>2]|0;c=0;do{k[v+(c<<2)>>2]=k[x+(c<<2)>>2];k[s+(c<<2)>>2]=k[t+(c<<2)>>2];c=c+1|0}while((c|0)<(k[y>>2]|0))}}else Q1(Ya,d,-1);while(0);if((y2(Ya,2,5,1)|0)!=(La|0)){k[Ma>>2]=0;c=Ma+4|0;k[c>>2]=0;s=ZT(56)|0;k[s>>2]=1;ua=s+4|0;k[Ma>>2]=ua;k[c>>2]=50;i[s+54>>0]=0;sa=403684;va=ua+50|0;do{i[ua>>0]=i[sa>>0]|0;ua=ua+1|0;sa=sa+1|0}while((ua|0)<(va|0));Y8(-215,Ma,403606,403450,1128);k[c>>2]=0;k[Ma>>2]=0;Va=k[s>>2]|0;k[s>>2]=Va+-1;if((Va|0)==1)ggb(k[s+-4>>2]|0)}Da=k[Za+16>>2]|0;Sa=Ya+16|0;Ea=k[Sa>>2]|0;Va=Ya+44|0;k[Ma>>2]=La;d=Ma+4|0;k[d>>2]=1;P1(e,2,Ma,0,-1,1,0);do if((k[e>>2]&2031616|0)==65536){u=k[e+4>>2]|0;k[Xa>>2]=k[u>>2];y=Xa+4|0;c=u+4|0;k[y>>2]=k[c>>2];Ka=Xa+8|0;k[Ka>>2]=k[u+8>>2];k[Xa+12>>2]=k[u+12>>2];k[Xa+16>>2]=k[u+16>>2];k[Xa+20>>2]=k[u+20>>2];k[Xa+24>>2]=k[u+24>>2];k[Xa+28>>2]=k[u+28>>2];k[Xa+32>>2]=k[u+32>>2];s=k[u+36>>2]|0;k[Xa+36>>2]=s;t=Xa+40|0;k[t>>2]=Ka;Ka=Xa+48|0;w=Xa+44|0;k[w>>2]=Ka;k[Xa+52>>2]=0;k[Ka>>2]=0;if(s|0){Ka=s+12|0;k[Ka>>2]=(k[Ka>>2]|0)+1}if((k[c>>2]|0)<3){Ka=k[u+44>>2]|0;s=k[w>>2]|0;k[s>>2]=k[Ka>>2];k[s+4>>2]=k[Ka+4>>2];s=Xa;break}k[y>>2]=0;x1(Xa,k[c>>2]|0,0,0,0);if((k[y>>2]|0)>0){x=k[u+40>>2]|0;v=k[t>>2]|0;t=k[u+44>>2]|0;s=k[w>>2]|0;c=0;do{k[v+(c<<2)>>2]=k[x+(c<<2)>>2];k[s+(c<<2)>>2]=k[t+(c<<2)>>2];c=c+1|0}while((c|0)<(k[y>>2]|0));s=Xa}else s=Xa}else{Q1(Xa,e,-1);s=Xa}while(0);k[Wa>>2]=1124007936;Ha=Wa+4|0;c=Wa+8|0;Fa=Wa+40|0;ua=Ha;va=ua+36|0;do{k[ua>>2]=0;ua=ua+4|0}while((ua|0)<(va|0));k[Fa>>2]=c;Ia=Wa+48|0;Ga=Wa+44|0;k[Ga>>2]=Ia;k[Wa+52>>2]=0;k[Ia>>2]=0;if(!(k[s>>2]&16384)){k[Ma>>2]=0;c=Ma+4|0;k[c>>2]=0;s=ZT(32)|0;k[s>>2]=1;ua=s+4|0;k[Ma>>2]=ua;k[c>>2]=24;i[s+28>>0]=0;sa=403735;va=ua+24|0;do{i[ua>>0]=i[sa>>0]|0;ua=ua+1|0;sa=sa+1|0}while((ua|0)<(va|0));Y8(-215,Ma,403606,403450,1135);k[c>>2]=0;k[Ma>>2]=0;Ka=k[s>>2]|0;k[s>>2]=Ka+-1;if((Ka|0)==1)ggb(k[s+-4>>2]|0)}Ja=Xa+16|0;Ca=k[Ja>>2]|0;Ka=Xa+44|0;if((La|0)>0)zpb(Ca|0,1,La|0)|0;if(!(k[f>>2]&2031616))Ba=0;else{k[Ma>>2]=La;k[d>>2]=1;P1(f,2,Ma,5,-1,1,0);do if((k[f>>2]&2031616|0)==65536){u=k[f+4>>2]|0;k[Ma>>2]=k[u>>2];y=Ma+4|0;c=u+4|0;k[y>>2]=k[c>>2];Ba=Ma+8|0;k[Ba>>2]=k[u+8>>2];k[Ma+12>>2]=k[u+12>>2];k[Ma+16>>2]=k[u+16>>2];k[Ma+20>>2]=k[u+20>>2];k[Ma+24>>2]=k[u+24>>2];k[Ma+28>>2]=k[u+28>>2];k[Ma+32>>2]=k[u+32>>2];s=k[u+36>>2]|0;k[Ma+36>>2]=s;t=Ma+40|0;k[t>>2]=Ba;Ba=Ma+48|0;w=Ma+44|0;k[w>>2]=Ba;k[Ma+52>>2]=0;k[Ba>>2]=0;if(s|0){Ba=s+12|0;k[Ba>>2]=(k[Ba>>2]|0)+1}if((k[c>>2]|0)<3){Aa=k[u+44>>2]|0;Ba=k[w>>2]|0;k[Ba>>2]=k[Aa>>2];k[Ba+4>>2]=k[Aa+4>>2];break}k[y>>2]=0;x1(Ma,k[c>>2]|0,0,0,0);if((k[y>>2]|0)>0){x=k[u+40>>2]|0;v=k[t>>2]|0;t=k[u+44>>2]|0;s=k[w>>2]|0;c=0;do{k[v+(c<<2)>>2]=k[x+(c<<2)>>2];k[s+(c<<2)>>2]=k[t+(c<<2)>>2];c=c+1|0}while((c|0)<(k[y>>2]|0))}}else Q1(Ma,f,-1);while(0);KG(Wa,Ma)|0;t=Ma+36|0;c=k[t>>2]|0;if(c|0?(Aa=c+12|0,Ba=k[Aa>>2]|0,k[Aa>>2]=Ba+-1,(Ba|0)==1):0){s=k[t>>2]|0;if(s|0){c=k[s+4>>2]|0;do if(!c){c=k[Ma+32>>2]|0;if(c|0)break;c=B1()|0;s=k[t>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,s)}k[t>>2]=0}k[t>>2]=0;Ba=Ma+16|0;s=Ma+4|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;if((k[s>>2]|0)>0){t=k[Ma+40>>2]|0;c=0;do{k[t+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[s>>2]|0))}c=k[Ma+44>>2]|0;if(!((c|0)==(Ma+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);if(!(k[Wa>>2]&16384)){k[Ma>>2]=0;c=Ma+4|0;k[c>>2]=0;s=ZT(28)|0;k[s>>2]=1;ua=s+4|0;k[Ma>>2]=ua;k[c>>2]=21;i[s+25>>0]=0;sa=403760;va=ua+21|0;do{i[ua>>0]=i[sa>>0]|0;ua=ua+1|0;sa=sa+1|0}while((ua|0)<(va|0));Y8(-215,Ma,403606,403450,1146);k[c>>2]=0;k[Ma>>2]=0;Ba=k[s>>2]|0;k[s>>2]=Ba+-1;if((Ba|0)==1)ggb(k[s+-4>>2]|0)}Ba=k[Wa+16>>2]|0}k[Ta>>2]=0;c=Ta+4|0;k[c>>2]=0;k[Ta+8>>2]=0;k[Ua>>2]=0;x=Ua+4|0;k[x>>2]=0;k[Ua+8>>2]=0;if((k[a>>2]&2031616|0)==327680){B2(a,Ta);Aa=(k[c>>2]|0)-(k[Ta>>2]|0)|0;t=((Aa|0)/56|0)+-1|0;if((Aa|0)<=0){k[Ma>>2]=0;c=Ma+4|0;k[c>>2]=0;s=ZT(20)|0;k[s>>2]=1;ua=s+4|0;k[Ma>>2]=ua;k[c>>2]=12;i[s+16>>0]=0;sa=403782;va=ua+12|0;do{i[ua>>0]=i[sa>>0]|0;ua=ua+1|0;sa=sa+1|0}while((ua|0)<(va|0));Y8(-215,Ma,403606,403450,1161);k[c>>2]=0;k[Ma>>2]=0;Aa=k[s>>2]|0;k[s>>2]=Aa+-1;if((Aa|0)==1)ggb(k[s+-4>>2]|0)}if(((t|0)%2|0|0)==1?(za=k[Ta>>2]|0,Aa=k[za+56>>2]|0,(Aa&7|0)==3?((k[za>>2]|0)>>>2&1022|1|0)==(Aa>>>3&511|0):0):0){w=2;t=(t|0)/2|0}else w=1;if((t|0)>0){k[Ma>>2]=0;s=Ma+4|0;k[s>>2]=0;k[Ra>>2]=0;c=Ra+4|0;k[c>>2]=0;N1((k[Ta>>2]|0)+(w*56|0)|0,Ma,Ra);u=k[Ra>>2]|0;v=k[g>>2]|0;do if((u|0)>=(v|0)?(z=k[c>>2]|0,A=k[g+4>>2]|0,(z|0)>=(A|0)):0){c=k[Ta>>2]|0;if((v+u+(k[c+(w*56|0)+12>>2]|0)|0)>(k[Ma>>2]|0)){C=93;break}if((A+z+(k[c+(w*56|0)+8>>2]|0)|0)>(k[s>>2]|0))C=93}else C=93;while(0);if((C|0)==93?(k[Na>>2]=0,Aa=Na+4|0,k[Aa>>2]=0,B=ZT(192)|0,k[B>>2]=1,za=B+4|0,k[Na>>2]=za,k[Aa>>2]=187,i[B+191>>0]=0,upb(za|0,403795,187)|0,Y8(-215,Na,403606,403450,1177),k[Aa>>2]=0,k[Na>>2]=0,Aa=k[B>>2]|0,k[B>>2]=Aa+-1,(Aa|0)==1):0)ggb(k[B+-4>>2]|0)}c=(t|0)<(h|0)?t:h;Aa=w;e=t}else{c=h;Aa=1;e=-1}if((k[b>>2]&2031616|0)==327680){B2(b,Ua);za=(k[x>>2]|0)-(k[Ua>>2]|0)|0;u=((za|0)/56|0)+-1|0;if((za|0)<=0){k[Ma>>2]=0;s=Ma+4|0;k[s>>2]=0;t=ZT(20)|0;k[t>>2]=1;ua=t+4|0;k[Ma>>2]=ua;k[s>>2]=12;i[t+16>>0]=0;sa=403983;va=ua+12|0;do{i[ua>>0]=i[sa>>0]|0;ua=ua+1|0;sa=sa+1|0}while((ua|0)<(va|0));Y8(-215,Ma,403606,403450,1189);k[s>>2]=0;k[Ma>>2]=0;za=k[t>>2]|0;k[t>>2]=za+-1;if((za|0)==1)ggb(k[t+-4>>2]|0)}if(((u|0)%2|0|0)==1?(ya=k[Ua>>2]|0,za=k[ya+56>>2]|0,(za&7|0)==3?((k[ya>>2]|0)>>>2&1022|1|0)==(za>>>3&511|0):0):0){d=2;u=(u|0)/2|0}else d=1;if((u|0)>0){k[Ma>>2]=0;w=Ma+4|0;k[w>>2]=0;k[Ra>>2]=0;s=Ra+4|0;k[s>>2]=0;N1((k[Ua>>2]|0)+(d*56|0)|0,Ma,Ra);x=k[Ra>>2]|0;y=k[g>>2]|0;do if((x|0)>=(y|0)){s=k[s>>2]|0;t=k[g+4>>2]|0;if((s|0)<(t|0)){C=111;break}v=k[Ua>>2]|0;if((y+x+(k[v+(d*56|0)+12>>2]|0)|0)>(k[Ma>>2]|0)){C=111;break}if((t+s+(k[v+(d*56|0)+8>>2]|0)|0)>(k[w>>2]|0))C=111}else C=111;while(0);if((C|0)==111?(k[Na>>2]=0,za=Na+4|0,k[za>>2]=0,D=ZT(192)|0,k[D>>2]=1,ya=D+4|0,k[Na>>2]=ya,k[za>>2]=187,i[D+191>>0]=0,upb(ya|0,403996,187)|0,Y8(-215,Na,403606,403450,1205),k[za>>2]=0,k[Na>>2]=0,za=k[D>>2]|0,k[D>>2]=za+-1,(za|0)==1):0)ggb(k[D+-4>>2]|0)}s=u;c=(u|0)<(c|0)?u:c}else{d=1;s=-1}if((e|0)<0){za=Ma+4|0;ya=za+4|0;k[ya>>2]=0;k[ya+4>>2]=0;k[Ma>>2]=33882112;k[za>>2]=Ta;k[E>>2]=k[g>>2];k[E+4>>2]=k[g+4>>2];c=C6a(a,Ma,E,c,0,4,0,1)|0}if((s|0)<0){za=Ma+4|0;ya=za+4|0;k[ya>>2]=0;k[ya+4>>2]=0;k[Ma>>2]=33882112;k[za>>2]=Ua;k[F>>2]=k[g>>2];k[F+4>>2]=k[g+4>>2];c=C6a(b,Ma,F,c,0,4,0,1)|0}if(!(j&1))ta=30;else{ta=(l|0)<0?0:l;ta=(ta|0)>100?100:ta}if(!(j&2))m=.01;else{m=m<0.0?0.0:m;m=m>10.0?10.0:m}ra=m*m;k[Ra>>2]=1124007936;ya=Ra+4|0;s=Ra+8|0;wa=Ra+40|0;ua=ya;va=ua+36|0;do{k[ua>>2]=0;ua=ua+4|0}while((ua|0)<(va|0));k[wa>>2]=s;za=Ra+48|0;xa=Ra+44|0;k[xa>>2]=za;k[Ra+52>>2]=0;k[za>>2]=0;O=(Aa|0)==1;if(O){sa=k[Ta>>2]|0;ua=(k[g>>2]<<1)+(k[sa+12>>2]|0)|0;va=k[sa>>2]<<1&4080|11;k[Ma>>2]=(k[g+4>>2]<<1)+(k[sa+8>>2]|0);k[Ma+4>>2]=ua;G1(Ra,2,Ma,va)}if((c|0)>-1){P=Ma+4|0;Q=Ma+8|0;R=Ma+40|0;S=Ma+48|0;T=Ma+44|0;U=Ma+52|0;V=g+4|0;W=Ra+16|0;X=Pa+4|0;Y=Pa+8|0;Z=Pa+12|0;_=Oa+36|0;$=Oa+16|0;ba=Oa+4|0;ca=Oa+40|0;da=Oa+44|0;ea=Oa+48|0;fa=Oa+8|0;ga=Oa+12|0;ha=Oa+4|0;ia=Pa+4|0;ja=ia+4|0;ka=Na+36|0;la=Na+16|0;ma=Na+4|0;na=Na+40|0;oa=Na+44|0;pa=Na+48|0;qa=Na+4|0;m=q;f=Oa+32|0;z=Oa+36|0;A=Oa+4|0;B=Oa+12|0;h=Oa+8|0;C=Oa+16|0;D=Oa+20|0;a=Oa+24|0;E=Oa+28|0;b=Oa+56|0;F=Oa+60|0;l=Oa+64|0;G=Oa+68|0;H=Ma+36|0;I=Ma+16|0;J=Na+4|0;K=Na+4|0;L=Na+32|0;M=Oa+32|0;x=Oa+40|0;y=Oa+44|0;e=Oa+48|0;N=Ma+32|0;w=c;while(1){k[Ma>>2]=1124007936;ua=P;va=ua+36|0;do{k[ua>>2]=0;ua=ua+4|0}while((ua|0)<(va|0));k[R>>2]=Q;k[T>>2]=S;k[U>>2]=0;k[S>>2]=0;v=aa(w,Aa)|0;if(O){s=k[(k[Ta>>2]|0)+(v*56|0)+40>>2]|0;va=k[s+4>>2]|0;s=k[s>>2]|0;JN(Na,(k[V>>2]<<1)+s|0,(k[g>>2]<<1)+va|0,k[Ra>>2]&4095,k[W>>2]|0,0);ua=k[V>>2]|0;k[Pa>>2]=k[g>>2];k[X>>2]=ua;k[Y>>2]=va;k[Z>>2]=s;I1(Oa,Na,Pa);KG(Ma,Oa)|0;s=k[_>>2]|0;do if(s|0){ua=s+12|0;va=k[ua>>2]|0;k[ua>>2]=va+-1;if((va|0)!=1)break;t=k[_>>2]|0;if(t|0){s=k[t+4>>2]|0;do if(!s){s=k[M>>2]|0;if(s|0)break;s=B1()|0;t=k[_>>2]|0}while(0);jh[k[(k[s>>2]|0)+24>>2]&1023](s,t)}k[_>>2]=0}while(0);k[_>>2]=0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[ba>>2]|0)>0){t=k[ca>>2]|0;s=0;do{k[t+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(k[ba>>2]|0))}s=k[da>>2]|0;if(!((s|0)==(ea|0)|(s|0)==0))ggb(k[s+-4>>2]|0);D6a((k[Ta>>2]|0)+(v*56|0)|0,Ma);k[fa>>2]=0;k[ga>>2]=0;k[Oa>>2]=16842752;k[ha>>2]=Ma;va=ja;k[va>>2]=0;k[va+4>>2]=0;k[Pa>>2]=33619968;k[ia>>2]=Na;va=k[V>>2]|0;s=k[g>>2]|0;k[Qa>>2]=0;k[Qa+4>>2]=0;k[Qa+8>>2]=0;k[Qa+12>>2]=0;k[Qa+16>>2]=0;k[Qa+20>>2]=0;k[Qa+24>>2]=0;k[Qa+28>>2]=0;vY(Oa,Pa,va,va,s,s,16,Qa);s=k[ka>>2]|0;do if(s|0){ua=s+12|0;va=k[ua>>2]|0;k[ua>>2]=va+-1;if((va|0)!=1)break;t=k[ka>>2]|0;if(t|0){s=k[t+4>>2]|0;do if(!s){s=k[L>>2]|0;if(s|0)break;s=B1()|0;t=k[ka>>2]|0}while(0);jh[k[(k[s>>2]|0)+24>>2]&1023](s,t)}k[ka>>2]=0}while(0);k[ka>>2]=0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[ma>>2]|0)>0){t=k[na>>2]|0;s=0;do{k[t+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(k[ma>>2]|0))}s=k[oa>>2]|0;if(!((s|0)==(pa|0)|(s|0)==0))ggb(k[s+-4>>2]|0)}else KG(Ma,(k[Ta>>2]|0)+((v+1|0)*56|0)|0)|0;s=k[Ta>>2]|0;ua=k[s+(v*56|0)+40>>2]|0;u=aa(w,d)|0;t=k[Ua>>2]|0;va=k[t+(u*56|0)+40>>2]|0;if(!((k[ua>>2]|0)==(k[va>>2]|0)?(k[ua+4>>2]|0)==(k[va+4>>2]|0):0)){k[Na>>2]=0;k[K>>2]=0;s=ZT(76)|0;k[s>>2]=1;ua=s+4|0;k[Na>>2]=ua;k[K>>2]=68;i[s+72>>0]=0;sa=404184;va=ua+68|0;do{i[ua>>0]=i[sa>>0]|0;ua=ua+1|0;sa=sa+1|0}while((ua|0)<(va|0));Y8(-215,Na,403606,403450,1248);k[K>>2]=0;k[Na>>2]=0;va=k[s>>2]|0;k[s>>2]=va+-1;if((va|0)==1)ggb(k[s+-4>>2]|0);s=k[Ta>>2]|0;t=k[Ua>>2]|0}if((k[t+(u*56|0)>>2]^k[s+(v*56|0)>>2])&4095){k[Na>>2]=0;k[J>>2]=0;s=ZT(76)|0;k[s>>2]=1;ua=s+4|0;k[Na>>2]=ua;k[J>>2]=68;i[s+72>>0]=0;sa=404253;va=ua+68|0;do{i[ua>>0]=i[sa>>0]|0;ua=ua+1|0;sa=sa+1|0}while((ua|0)<(va|0));Y8(-215,Na,403606,403450,1249);k[J>>2]=0;k[Na>>2]=0;va=k[s>>2]|0;k[s>>2]=va+-1;if((va|0)==1)ggb(k[s+-4>>2]|0);s=k[Ta>>2]|0;t=k[Ua>>2]|0}k[Na>>2]=0;k[qa>>2]=La;ua=k[g>>2]|0;va=k[V>>2]|0;k[Oa>>2]=152044;k[A>>2]=s+(v*56|0);k[B>>2]=Ma;k[h>>2]=t+(u*56|0);k[C>>2]=Da;k[D>>2]=Ea;k[a>>2]=Ca;k[E>>2]=Ba;k[f>>2]=ua;k[z>>2]=va;k[x>>2]=j;k[y>>2]=ta;p[e>>3]=ra;k[b>>2]=w;k[F>>2]=c;k[l>>2]=n;o[G>>2]=m;B6a(Oa,Na);s=k[H>>2]|0;do if(s|0){ua=s+12|0;va=k[ua>>2]|0;k[ua>>2]=va+-1;if((va|0)!=1)break;t=k[H>>2]|0;if(t|0){s=k[t+4>>2]|0;do if(!s){s=k[N>>2]|0;if(s|0)break;s=B1()|0;t=k[H>>2]|0}while(0);jh[k[(k[s>>2]|0)+24>>2]&1023](s,t)}k[H>>2]=0}while(0);k[H>>2]=0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[P>>2]|0)>0){t=k[R>>2]|0;s=0;do{k[t+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(k[P>>2]|0))}s=k[T>>2]|0;if(!((s|0)==(S|0)|(s|0)==0))ggb(k[s+-4>>2]|0);if((w|0)>0)w=w+-1|0;else break}}t=Ra+36|0;c=k[t>>2]|0;do if(c|0){g=c+12|0;n=k[g>>2]|0;k[g>>2]=n+-1;if((n|0)!=1)break;s=k[t>>2]|0;if(s|0){c=k[s+4>>2]|0;do if(!c){c=k[Ra+32>>2]|0;if(c|0)break;c=B1()|0;s=k[t>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,s)}k[t>>2]=0}while(0);k[t>>2]=0;Ra=Ra+16|0;k[Ra>>2]=0;k[Ra+4>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;if((k[ya>>2]|0)>0){s=k[wa>>2]|0;c=0;do{k[s+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[ya>>2]|0))}c=k[xa>>2]|0;if(!((c|0)==(za|0)|(c|0)==0))ggb(k[c+-4>>2]|0);zF(Ua);zF(Ta);t=Wa+36|0;c=k[t>>2]|0;do if(c|0){Ta=c+12|0;Ua=k[Ta>>2]|0;k[Ta>>2]=Ua+-1;if((Ua|0)!=1)break;s=k[t>>2]|0;if(s|0){c=k[s+4>>2]|0;do if(!c){c=k[Wa+32>>2]|0;if(c|0)break;c=B1()|0;s=k[t>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,s)}k[t>>2]=0}while(0);k[t>>2]=0;Wa=Wa+16|0;k[Wa>>2]=0;k[Wa+4>>2]=0;k[Wa+8>>2]=0;k[Wa+12>>2]=0;if((k[Ha>>2]|0)>0){s=k[Fa>>2]|0;c=0;do{k[s+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Ha>>2]|0))}c=k[Ga>>2]|0;if(!((c|0)==(Ia|0)|(c|0)==0))ggb(k[c+-4>>2]|0);t=Xa+36|0;c=k[t>>2]|0;do if(c|0){Ua=c+12|0;Wa=k[Ua>>2]|0;k[Ua>>2]=Wa+-1;if((Wa|0)!=1)break;s=k[t>>2]|0;if(s|0){c=k[s+4>>2]|0;do if(!c){c=k[Xa+32>>2]|0;if(c|0)break;c=B1()|0;s=k[t>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,s)}k[t>>2]=0}while(0);k[t>>2]=0;t=Xa+4|0;k[Ja>>2]=0;k[Ja+4>>2]=0;k[Ja+8>>2]=0;k[Ja+12>>2]=0;if((k[t>>2]|0)>0){s=k[Xa+40>>2]|0;c=0;do{k[s+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[t>>2]|0))}c=k[Ka>>2]|0;if(!((c|0)==(Xa+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);t=Ya+36|0;c=k[t>>2]|0;do if(c|0){Wa=c+12|0;Xa=k[Wa>>2]|0;k[Wa>>2]=Xa+-1;if((Xa|0)!=1)break;s=k[t>>2]|0;if(s|0){c=k[s+4>>2]|0;do if(!c){c=k[Ya+32>>2]|0;if(c|0)break;c=B1()|0;s=k[t>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,s)}k[t>>2]=0}while(0);k[t>>2]=0;t=Ya+4|0;k[Sa>>2]=0;k[Sa+4>>2]=0;k[Sa+8>>2]=0;k[Sa+12>>2]=0;if((k[t>>2]|0)>0){s=k[Ya+40>>2]|0;c=0;do{k[s+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[t>>2]|0))}c=k[Va>>2]|0;if(!((c|0)==(Ya+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}t=Za+36|0;c=k[t>>2]|0;if(c|0?(Xa=c+12|0,Ya=k[Xa>>2]|0,k[Xa>>2]=Ya+-1,(Ya|0)==1):0){s=k[t>>2]|0;if(s|0){c=k[s+4>>2]|0;if(!c){c=k[Za+32>>2]|0;if(!c){c=B1()|0;s=k[t>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,s)}k[t>>2]=0}k[t>>2]=0;Ya=Za+16|0;s=Za+4|0;k[Ya>>2]=0;k[Ya+4>>2]=0;k[Ya+8>>2]=0;k[Ya+12>>2]=0;if((k[s>>2]|0)>0){t=k[Za+40>>2]|0;c=0;do{k[t+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[s>>2]|0))}c=k[Za+44>>2]|0;if((c|0)==(Za+48|0)|(c|0)==0){r=_a;return}ggb(k[c+-4>>2]|0);r=_a;return}function F6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0.0,n=0.0,q=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,O=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0.0,xa=0.0,ya=0,za=0,Aa=0,Ba=0,Ca=0.0;va=r;r=r+576|0;pa=va+520|0;ra=va+464|0;oa=va+408|0;na=va+396|0;la=va+384|0;ka=va+372|0;ja=va+360|0;$=va+248|0;x=va+304|0;z=va+192|0;ca=va+128|0;da=va+64|0;ea=va+32|0;S=va+8|0;I=va+184|0;J=va+120|0;F=va+56|0;G=va+24|0;T=va;k[ra>>2]=1124007936;sa=ra+4|0;ha=ra+8|0;qa=ra+40|0;j=sa;y=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(y|0));k[qa>>2]=ha;ua=ra+48|0;ta=ra+44|0;k[ta>>2]=ua;k[ra+52>>2]=0;k[ua>>2]=0;k[pa>>2]=2;k[pa+4>>2]=3;G1(ra,2,pa,6);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[pa>>2]=k[g>>2];q=pa+4|0;b=g+4|0;k[q>>2]=k[b>>2];ma=pa+8|0;k[ma>>2]=k[g+8>>2];k[pa+12>>2]=k[g+12>>2];k[pa+16>>2]=k[g+16>>2];k[pa+20>>2]=k[g+20>>2];k[pa+24>>2]=k[g+24>>2];k[pa+28>>2]=k[g+28>>2];k[pa+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[pa+36>>2]=e;f=pa+40|0;k[f>>2]=ma;ma=pa+48|0;j=pa+44|0;k[j>>2]=ma;k[pa+52>>2]=0;k[ma>>2]=0;if(e|0){ma=e+12|0;k[ma>>2]=(k[ma>>2]|0)+1}if((k[b>>2]|0)<3){ga=k[g+44>>2]|0;ma=k[j>>2]|0;k[ma>>2]=k[ga>>2];k[ma+4>>2]=k[ga+4>>2];break}k[q>>2]=0;x1(pa,k[b>>2]|0,0,0,0);if((k[q>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else Q1(pa,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[oa>>2]=k[f>>2];l=oa+4|0;b=f+4|0;k[l>>2]=k[b>>2];ma=oa+8|0;k[ma>>2]=k[f+8>>2];k[oa+12>>2]=k[f+12>>2];k[oa+16>>2]=k[f+16>>2];k[oa+20>>2]=k[f+20>>2];k[oa+24>>2]=k[f+24>>2];k[oa+28>>2]=k[f+28>>2];k[oa+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[oa+36>>2]=e;q=oa+40|0;k[q>>2]=ma;ma=oa+48|0;g=oa+44|0;k[g>>2]=ma;k[oa+52>>2]=0;k[ma>>2]=0;if(e|0){ma=e+12|0;k[ma>>2]=(k[ma>>2]|0)+1}if((k[b>>2]|0)<3){ga=k[f+44>>2]|0;ma=k[g>>2]|0;k[ma>>2]=k[ga>>2];k[ma+4>>2]=k[ga+4>>2];break}k[l>>2]=0;x1(oa,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){h=k[f+40>>2]|0;j=k[q>>2]|0;f=k[f+44>>2]|0;e=k[g>>2]|0;b=0;do{k[j+(b<<2)>>2]=k[h+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{Q1(oa,c,-1);q=oa+40|0}while(0);k[na>>2]=0;ga=na+4|0;k[ga>>2]=0;k[na+8>>2]=0;k[la>>2]=0;fa=la+4|0;k[fa>>2]=0;k[la+8>>2]=0;k[ka>>2]=0;ba=ka+4|0;k[ba>>2]=0;k[ka+8>>2]=0;k[ja>>2]=0;aa=ja+4|0;k[aa>>2]=0;k[ja+8>>2]=0;ma=pa+40|0;Y=k[ma>>2]|0;Z=k[q>>2]|0;if((k[Y>>2]|0)!=(k[Z>>2]|0)?1:(k[Y+4>>2]|0)!=(k[Z+4>>2]|0)){k[$>>2]=0;b=$+4|0;k[b>>2]=0;e=ZT(48)|0;k[e>>2]=1;j=e+4|0;k[$>>2]=j;k[b>>2]=41;i[e+45>>0]=0;f=404322;y=j+41|0;do{i[j>>0]=i[f>>0]|0;j=j+1|0;f=f+1|0}while((j|0)<(y|0));Y8(-209,$,404364,403450,1375);k[b>>2]=0;k[$>>2]=0;Z=k[e>>2]|0;k[e>>2]=Z+-1;if((Z|0)==1)ggb(k[e+-4>>2]|0)}if((k[oa>>2]^k[pa>>2])&4095|0){k[$>>2]=0;b=$+4|0;k[b>>2]=0;e=ZT(52)|0;k[e>>2]=1;j=e+4|0;k[$>>2]=j;k[b>>2]=46;i[e+50>>0]=0;f=404387;y=j+46|0;do{i[j>>0]=i[f>>0]|0;j=j+1|0;f=f+1|0}while((j|0)<(y|0));Y8(-205,$,404364,403450,1378);k[b>>2]=0;k[$>>2]=0;Z=k[e>>2]|0;k[e>>2]=Z+-1;if((Z|0)==1)ggb(k[e+-4>>2]|0)}g=y2(pa,2,-1,1)|0;do if((g|0)>0){_1(x,pa,2,g);f=$+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[$>>2]=-2113732595;k[f>>2]=na;SW(x,$,5,1.0,0.0);f=x+36|0;b=k[f>>2]|0;if(b|0?(Y=b+12|0,Z=k[Y>>2]|0,k[Y>>2]=Z+-1,(Z|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[x+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Z=x+16|0;e=x+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[e>>2]|0)>0){f=k[x+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[x+44>>2]|0;if(!((b|0)==(x+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);_1(z,oa,2,g);f=$+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[$>>2]=-2113732595;k[f>>2]=la;SW(z,$,5,1.0,0.0);f=z+36|0;b=k[f>>2]|0;if(b|0?(Y=b+12|0,Z=k[Y>>2]|0,k[Y>>2]=Z+-1,(Z|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[z+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Z=z+16|0;e=z+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[e>>2]|0)>0){f=k[z+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[z+44>>2]|0;if((b|0)==(z+48|0)|(b|0)==0)_=1.0;else{ggb(k[b+-4>>2]|0);_=1.0}}else{b=k[pa>>2]|0;if(b&7|0){k[$>>2]=0;b=$+4|0;k[b>>2]=0;e=ZT(60)|0;k[e>>2]=1;j=e+4|0;k[$>>2]=j;k[b>>2]=52;i[e+56>>0]=0;f=404464;y=j+52|0;do{i[j>>0]=i[f>>0]|0;j=j+1|0;f=f+1|0}while((j|0)<(y|0));Y8(-210,$,404364,403450,1458);k[b>>2]=0;k[$>>2]=0;Z=k[e>>2]|0;k[e>>2]=Z+-1;if((Z|0)==1)ggb(k[e+-4>>2]|0);_=1.0;break}Z=b>>>3;g=Z&511;switch(Z&511){case 0:case 2:case 3:break;default:{k[$>>2]=0;b=$+4|0;k[b>>2]=0;e=ZT(36)|0;k[e>>2]=1;j=e+4|0;k[$>>2]=j;k[b>>2]=29;i[e+33>>0]=0;f=404434;y=j+29|0;do{i[j>>0]=i[f>>0]|0;j=j+1|0;f=f+1|0}while((j|0)<(y|0));Y8(-215,$,404364,403450,1390);k[b>>2]=0;k[$>>2]=0;Z=k[e>>2]|0;k[e>>2]=Z+-1;if((Z|0)==1)ggb(k[e+-4>>2]|0)}}f=k[ma>>2]|0;e=k[f+4>>2]|0;f=k[f>>2]|0;m=+(e|0);_=160.0/m;n=+(f|0);X=120.0/n;_=_<X?X:_;_=_>1.0?_:1.0;m=m*_;p[u>>3]=m;b=k[u+4>>2]|0;Z=b&2146435072;if(!(Z>>>0>1126170624|(Z|0)==1126170624&0>0)){b=(b|0)<0;m=b?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=b?-0.0:0.0}L=~~m;m=n*_;p[u>>3]=m;b=k[u+4>>2]|0;Z=b&2146435072;if(!(Z>>>0>1126170624|(Z|0)==1126170624&0>0)){b=(b|0)<0;m=b?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=b?-0.0:0.0}K=~~m;g=(g|0)!=0;if(g|((L|0)!=(e|0)|(K|0)!=(f|0))){k[$>>2]=1124007936;D=$+4|0;b=$+8|0;B=$+40|0;j=D;y=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(y|0));k[B>>2]=b;E=$+48|0;C=$+44|0;k[C>>2]=E;k[$+52>>2]=0;k[E>>2]=0;k[ca>>2]=1124007936;z=ca+4|0;b=ca+8|0;c=ca+40|0;j=z;y=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(y|0));k[c>>2]=b;A=ca+48|0;x=ca+44|0;k[x>>2]=A;k[ca+52>>2]=0;k[A>>2]=0;if(g){k[da>>2]=1124007936;l=da+4|0;b=da+8|0;h=da+40|0;j=l;y=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(y|0));k[h>>2]=b;j=da+48|0;g=da+44|0;k[g>>2]=j;k[da+52>>2]=0;k[j>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea>>2]=16842752;k[ea+4>>2]=pa;f=S+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[S>>2]=33619968;k[f>>2]=da;$aa(ea,S,6,0);k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea>>2]=16842752;k[ea+4>>2]=da;f=S+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[S>>2]=33619968;k[f>>2]=$;k[I>>2]=L;k[I+4>>2]=K;Rla(ea,S,I,0.0,0.0,3);k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea>>2]=16842752;k[ea+4>>2]=oa;f=S+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[S>>2]=33619968;k[f>>2]=da;$aa(ea,S,6,0);k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea>>2]=16842752;k[ea+4>>2]=da;f=S+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[S>>2]=33619968;k[f>>2]=ca;k[J>>2]=L;k[J+4>>2]=K;Rla(ea,S,J,0.0,0.0,3);f=da+36|0;b=k[f>>2]|0;if(b|0?(Y=b+12|0,Z=k[Y>>2]|0,k[Y>>2]=Z+-1,(Z|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[da+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Z=da+16|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[l>>2]|0)>0){e=k[h>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[g>>2]|0;if(!((b|0)==(j|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{k[da+8>>2]=0;k[da+12>>2]=0;k[da>>2]=16842752;k[da+4>>2]=pa;Z=ea+4|0;Y=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[ea>>2]=33619968;k[Z>>2]=$;k[F>>2]=L;k[F+4>>2]=K;Rla(da,ea,F,0.0,0.0,3);k[da+8>>2]=0;k[da+12>>2]=0;k[da>>2]=16842752;k[da+4>>2]=oa;Z=ea+4|0;Y=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[ea>>2]=33619968;k[Z>>2]=ca;k[G>>2]=L;k[G+4>>2]=K;Rla(da,ea,G,0.0,0.0,3)}KG(pa,$)|0;KG(oa,ca)|0;f=ca+36|0;b=k[f>>2]|0;if(b|0?(Y=b+12|0,Z=k[Y>>2]|0,k[Y>>2]=Z+-1,(Z|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[ca+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Z=ca+16|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[z>>2]|0)>0){e=k[c>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[x>>2]|0;if(!((b|0)==(A|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=$+36|0;b=k[f>>2]|0;if(b|0?(Y=b+12|0,Z=k[Y>>2]|0,k[Y>>2]=Z+-1,(Z|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[$+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Z=$+16|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[D>>2]|0)>0){e=k[B>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[D>>2]|0))}b=k[C>>2]|0;if(!((b|0)==(E|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}m=+(L|0)*15.0/+(K|0);p[u>>3]=m;b=k[u+4>>2]|0;Z=b&2146435072;if(!(Z>>>0>1126170624|(Z|0)==1126170624&0>0)){b=(b|0)<0;m=b?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=b?-0.0:0.0}l=~~m;c=l*15|0;f=k[ga>>2]|0;e=k[na>>2]|0;b=f-e>>3;if(c>>>0<=b>>>0){if(c>>>0<b>>>0?(M=e+(c<<3)|0,(f|0)!=(M|0)):0)k[ga>>2]=f+(~((f+-8-M|0)>>>3)<<3)}else o9(na,c-b|0);f=k[fa>>2]|0;e=k[la>>2]|0;b=f-e>>3;if(c>>>0<=b>>>0){if(c>>>0<b>>>0?(O=e+(c<<3)|0,(f|0)!=(O|0)):0)k[fa>>2]=f+(~((f+-8-O|0)>>>3)<<3)}else o9(la,c-b|0);f=k[aa>>2]|0;e=k[ja>>2]|0;b=f-e|0;if(c>>>0<=b>>>0){if(c>>>0<b>>>0?(R=e+c|0,(f|0)!=(R|0)):0)k[aa>>2]=R}else T1(ja,c-b|0);j=(l|0)>0;s=+(L|0);t=+(l|0);h=k[na>>2]|0;m=+(K|0);if(j){b=0;f=0;while(1){n=m*(+(b|0)+.5)/15.0;e=0;g=f;while(1){o[h+(g<<3)>>2]=s*(+(e|0)+.5)/t;o[h+(g<<3)+4>>2]=n;e=e+1|0;if((e|0)==(l|0))break;else g=g+1|0}b=b+1|0;if((b|0)==15)break;else f=l+f|0}}k[$+8>>2]=0;k[$+12>>2]=0;k[$>>2]=16842752;k[$+4>>2]=pa;k[ca+8>>2]=0;k[ca+12>>2]=0;k[ca>>2]=16842752;k[ca+4>>2]=oa;k[da+8>>2]=0;k[da+12>>2]=0;k[da>>2]=-2130509811;k[da+4>>2]=na;Z=ea+4|0;Y=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[ea>>2]=-2096955379;k[Z>>2]=la;Z=S+4|0;Y=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[S>>2]=-2113732608;k[Z>>2]=ja;k[T>>2]=21;k[T+4>>2]=21;E6a($,ca,da,ea,S,49332,T,3,1,40,.1,0,.0001);if(j){f=k[ja>>2]|0;e=0;b=0;do{if(i[f+e>>0]|0){if((e|0)>(b|0)){Z=k[na>>2]|0;k[Z+(b<<3)>>2]=k[Z+(e<<3)>>2];k[Z+(b<<3)+4>>2]=k[Z+(e<<3)+4>>2];Z=k[la>>2]|0;k[Z+(b<<3)>>2]=k[Z+(e<<3)>>2];k[Z+(b<<3)+4>>2]=k[Z+(e<<3)+4>>2]}b=b+1|0}e=e+1|0}while((e|0)<(c|0));g=b}else g=0;f=k[ga>>2]|0;e=k[na>>2]|0;b=f-e>>3;if(g>>>0<=b>>>0){if(g>>>0<b>>>0?(U=e+(g<<3)|0,(f|0)!=(U|0)):0)k[ga>>2]=f+(~((f+-8-U|0)>>>3)<<3)}else o9(na,g-b|0);f=k[fa>>2]|0;b=k[la>>2]|0;e=f-b>>3;if(g>>>0>e>>>0){o9(la,g-e|0);break}if(g>>>0<e>>>0?(V=b+(g<<3)|0,(f|0)!=(V|0)):0)k[fa>>2]=f+(~((f+-8-V|0)>>>3)<<3)}while(0);f=k[ba>>2]|0;e=k[ka>>2]|0;b=f-e>>2;if(g>>>0<=b>>>0){if(g>>>0<b>>>0?(W=e+(g<<2)|0,(f|0)!=(W|0)):0)k[ba>>2]=f+(~((f+-4-W|0)>>>2)<<2)}else U1(ka,g-b|0);if((g|0)>=3){k[ca+8>>2]=0;k[ca+12>>2]=0;k[ca>>2]=-2130509811;k[ca+4>>2]=la;$ra($,ca);I=da+4|0;J=da+8|0;K=ca+4|0;L=da+12|0;M=da+16|0;O=ca+8|0;R=da+20|0;S=ea+4|0;T=ea+8|0;U=ea+12|0;V=ea+16|0;W=ea+20|0;Y=ra+16|0;X=+(g|0)*.5;Z=k[ka>>2]|0;b=k[$+8>>2]|0;e=k[$+12>>2]|0;H=+(((b|0)<(e|0)?e:b)|0)*.05;b=0;e=-1;f=-1;while(1){k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;k[da+16>>2]=0;k[da+20>>2]=0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;F=k[na>>2]|0;G=k[la>>2]|0;E=0;a:while(1){B=ca+(E<<2)|0;C=(E|0)>0;D=(E|0)==2;h=0;while(1){l=Epb(e|0,0,-130063606,0)|0;e=kpb(l|0,N|0,f|0,0)|0;f=N;l=(e>>>0)%(g>>>0)|0;k[B>>2]=l;b:do if(C){c=F+(l<<3)|0;x=F+(l<<3)+4|0;y=G+(l<<3)|0;z=G+(l<<3)+4|0;j=0;while(1){A=k[ca+(j<<2)>>2]|0;if((A|0)==(l|0))break b;w=+P(+(+o[c>>2]-+o[F+(A<<3)>>2]));if(w+ +P(+(+o[x>>2]-+o[F+(A<<3)+4>>2]))<1.1920928955078125e-07)break b;w=+P(+(+o[y>>2]-+o[G+(A<<3)>>2]));j=j+1|0;if(w+ +P(+(+o[z>>2]-+o[G+(A<<3)+4>>2]))<1.1920928955078125e-07)break b;if((j|0)>=(E|0)){ia=168;break}}}else ia=168;while(0);if((ia|0)==168){ia=0;if(!D)break;z=k[ca>>2]|0;Aa=k[F+(z<<3)>>2]|0;k[da>>2]=Aa;ya=k[F+(z<<3)+4>>2]|0;k[I>>2]=ya;y=k[K>>2]|0;Ba=k[F+(y<<3)>>2]|0;k[J>>2]=Ba;za=k[F+(y<<3)+4>>2]|0;k[L>>2]=za;$=k[O>>2]|0;j=k[F+($<<3)>>2]|0;k[M>>2]=j;l=k[F+($<<3)+4>>2]|0;k[R>>2]=l;x=k[G+(z<<3)>>2]|0;k[ea>>2]=x;z=k[G+(z<<3)+4>>2]|0;k[S>>2]=z;c=k[G+(y<<3)>>2]|0;k[T>>2]=c;y=k[G+(y<<3)+4>>2]|0;k[U>>2]=y;A=k[G+($<<3)>>2]|0;k[V>>2]=A;$=k[G+($<<3)+4>>2]|0;k[W>>2]=$;xa=(k[u>>2]=Ba,+o[u>>2]);m=(k[u>>2]=Aa,+o[u>>2]);xa=xa-m;wa=(k[u>>2]=za,+o[u>>2]);n=(k[u>>2]=ya,+o[u>>2]);wa=wa-n;m=(k[u>>2]=j,+o[u>>2])-m;n=(k[u>>2]=l,+o[u>>2])-n;s=(k[u>>2]=c,+o[u>>2]);v=(k[u>>2]=x,+o[u>>2]);s=s-v;t=(k[u>>2]=y,+o[u>>2]);w=(k[u>>2]=z,+o[u>>2]);t=t-w;v=(k[u>>2]=A,+o[u>>2])-v;w=(k[u>>2]=$,+o[u>>2])-w;if(!(+P(+(xa*n-wa*m))<+Q(+(xa*xa+wa*wa))*.01*+Q(+(m*m+n*n)))?!(+P(+(s*w-t*v))<+Q(+(s*s+t*t))*.01*+Q(+(v*v+w*w))):0)break}h=h+1|0;if((h|0)>=500)break a}E=E+1|0;if((h|0)>499)break;if((E|0)>=3){ia=173;break}}if((ia|0)==173){ia=0;G6a(da,ea,3,ra,d);h=k[Y>>2]|0;l=k[na>>2]|0;s=+p[h+16>>3];c=k[la>>2]|0;t=+p[h+24>>3];v=+p[h+32>>3];w=+p[h+40>>3];m=+p[h>>3];n=+p[h+8>>3];h=0;j=0;do{wa=+o[l+(j<<3)>>2];xa=+o[l+(j<<3)+4>>2];Ca=+P(+(s+(m*wa+n*xa)-+o[c+(j<<3)>>2]));if(Ca+ +P(+(w+(wa*t+xa*v)-+o[c+(j<<3)+4>>2]))<H){k[Z+(h<<2)>>2]=j;h=h+1|0}j=j+1|0}while((j|0)!=(g|0));if(+(h|0)>=X){ia=179;break}}b=b+1|0;if((b|0)>=500){ia=180;break}}do if((ia|0)==179)if((b|0)<=499){if((h|0)<(g|0)&(h|0)>0){e=k[na>>2]|0;f=k[la>>2]|0;b=0;do{Ba=k[Z+(b<<2)>>2]|0;k[e+(b<<3)>>2]=k[e+(Ba<<3)>>2];k[e+(b<<3)+4>>2]=k[e+(Ba<<3)+4>>2];k[f+(b<<3)>>2]=k[f+(Ba<<3)>>2];k[f+(b<<3)+4>>2]=k[f+(Ba<<3)+4>>2];b=b+1|0}while((b|0)!=(h|0))}G6a(k[na>>2]|0,k[la>>2]|0,h,ra,d);e=k[Y>>2]|0;l=e+16|0;p[l>>3]=+p[l>>3]/_;l=e+(k[k[ta>>2]>>2]|0)+16|0;p[l>>3]=+p[l>>3]/_;k[a>>2]=k[ra>>2];l=a+4|0;b=k[sa>>2]|0;k[l>>2]=b;Ba=a+8|0;k[Ba>>2]=k[ha>>2];k[a+12>>2]=k[ra+12>>2];k[a+16>>2]=e;k[a+20>>2]=k[ra+20>>2];k[a+24>>2]=k[ra+24>>2];k[a+28>>2]=k[ra+28>>2];k[a+32>>2]=k[ra+32>>2];e=k[ra+36>>2]|0;k[a+36>>2]=e;f=a+40|0;k[f>>2]=Ba;Ba=a+48|0;j=a+44|0;k[j>>2]=Ba;k[a+52>>2]=0;k[Ba>>2]=0;if(e){b=e+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[sa>>2]|0}if((b|0)<3){Aa=k[ta>>2]|0;Ba=k[j>>2]|0;k[Ba>>2]=k[Aa>>2];k[Ba+4>>2]=k[Aa+4>>2];break}k[l>>2]=0;x1(a,b,0,0,0);if((k[l>>2]|0)>0){h=k[qa>>2]|0;f=k[f>>2]|0;g=k[ta>>2]|0;e=k[j>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[h+(b<<2)>>2];k[e+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else ia=180;while(0);if((ia|0)==180){k[a>>2]=1124007936;b=a+8|0;e=a+40|0;j=a+4|0;y=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(y|0));k[e>>2]=b;Ba=a+48|0;k[a+44>>2]=Ba;k[a+52>>2]=0;k[Ba>>2]=0}}else{k[a>>2]=1124007936;b=a+8|0;e=a+40|0;j=a+4|0;y=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(y|0));k[e>>2]=b;Ba=a+48|0;k[a+44>>2]=Ba;k[a+52>>2]=0;k[Ba>>2]=0}b=k[ja>>2]|0;if(b|0){if((k[aa>>2]|0)!=(b|0))k[aa>>2]=b;ggb(b)}b=k[ka>>2]|0;e=b;if(b|0){f=k[ba>>2]|0;if((f|0)!=(b|0))k[ba>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(b)}b=k[la>>2]|0;e=b;if(b|0){f=k[fa>>2]|0;if((f|0)!=(b|0))k[fa>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(b)}b=k[na>>2]|0;e=b;if(b|0){f=k[ga>>2]|0;if((f|0)!=(b|0))k[ga>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(b)}f=oa+36|0;b=k[f>>2]|0;if(b|0?(Aa=b+12|0,Ba=k[Aa>>2]|0,k[Aa>>2]=Ba+-1,(Ba|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[oa+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Ba=oa+16|0;f=oa+4|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;if((k[f>>2]|0)>0){e=k[q>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[oa+44>>2]|0;if(!((b|0)==(oa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=pa+36|0;b=k[f>>2]|0;if(b|0?(Aa=b+12|0,Ba=k[Aa>>2]|0,k[Aa>>2]=Ba+-1,(Ba|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[pa+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Ba=pa+16|0;f=pa+4|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;if((k[f>>2]|0)>0){e=k[ma>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[pa+44>>2]|0;if(!((b|0)==(pa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ra+36|0;b=k[f>>2]|0;if(b|0?(Aa=b+12|0,Ba=k[Aa>>2]|0,k[Aa>>2]=Ba+-1,(Ba|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ra+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Ba=ra+16|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;if((k[sa>>2]|0)>0){e=k[qa>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[sa>>2]|0))}b=k[ta>>2]|0;if((b|0)==(ua|0)|(b|0)==0){r=va;return}ggb(k[b+-4>>2]|0);r=va;return}function G6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0.0,n=0.0,q=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0;ca=r;r=r+608|0;Z=ca+104|0;W=ca+56|0;$=ca;ba=ca+552|0;aa=ca+496|0;_=ca+440|0;X=ca+424|0;Y=ca+408|0;G=ca+392|0;if(!(k[d>>2]&16384)){f=Z+4|0;g=ZT(24)|0;k[g>>2]=1;h=g+4|0;k[Z>>2]=h;k[f>>2]=16;i[g+20>>0]=0;j=404517;l=h+16|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,Z,404534,403450,1272);k[f>>2]=0;k[Z>>2]=0;V=k[g>>2]|0;k[g>>2]=V+-1;if((V|0)==1)ggb(k[g+-4>>2]|0)}if(e){zpb(Z|0,0,288)|0;h=W;l=h+48|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));N=$+4|0;k[N>>2]=2;P=$+8|0;k[P>>2]=6;k[$+12>>2]=6;L=$+16|0;k[L>>2]=Z;k[$+20>>2]=Z;I=$+24|0;M=$+40|0;O=I+8|0;k[O>>2]=0;k[O+4>>2]=0;k[M>>2]=P;P=$+48|0;O=$+44|0;k[O>>2]=P;k[$>>2]=1124024326;k[P>>2]=48;k[$+52>>2]=8;k[$+28>>2]=Z+288;k[I>>2]=Z+288;I=ba+4|0;k[I>>2]=2;K=ba+8|0;k[K>>2]=6;k[ba+12>>2]=1;G=ba+16|0;k[G>>2]=W;k[ba+20>>2]=W;g=ba+24|0;H=ba+40|0;J=g+8|0;k[J>>2]=0;k[J+4>>2]=0;k[H>>2]=K;K=ba+48|0;J=ba+44|0;k[J>>2]=K;k[ba>>2]=1124024326;k[K>>2]=8;k[ba+52>>2]=8;k[ba+28>>2]=W+48;k[g>>2]=W+48;_1(aa,d,1,6);g=Z+8|0;if((c|0)>0){e=Z+16|0;h=Z+56|0;j=Z+64|0;l=Z+112|0;B=W+8|0;C=W+16|0;D=W+24|0;E=W+32|0;F=W+40|0;f=0;v=+p[W>>3];w=+p[B>>3];x=+p[C>>3];y=+p[D>>3];z=+p[E>>3];A=+p[F>>3];q=+p[Z>>3];u=+p[g>>3];t=+p[e>>3];n=+p[h>>3];s=+p[j>>3];m=+p[l>>3];do{fa=+o[a+(f<<3)>>2];q=q+fa*fa;ea=+o[a+(f<<3)+4>>2];u=u+ea*fa;t=t+fa;n=n+ea*ea;s=s+ea;m=m+1.0;da=+o[b+(f<<3)>>2];v=v+fa*da;w=w+ea*da;x=x+da;da=+o[b+(f<<3)+4>>2];y=y+fa*da;z=z+ea*da;A=A+da;f=f+1|0}while((f|0)!=(c|0));p[Z>>3]=q;p[g>>3]=u;p[e>>3]=t;p[h>>3]=n;p[j>>3]=s;p[l>>3]=m;p[W>>3]=v;p[B>>3]=w;p[C>>3]=x;p[D>>3]=y;p[E>>3]=z;p[F>>3]=A}else{u=+p[g>>3];t=+p[Z+16>>3];s=+p[Z+64>>3];q=+p[Z>>3];n=+p[Z+56>>3];m=+p[Z+112>>3]}p[Z+48>>3]=u;p[Z+216>>3]=u;p[Z+176>>3]=u;p[Z+96>>3]=t;p[Z+264>>3]=t;p[Z+184>>3]=t;p[Z+104>>3]=s;p[Z+272>>3]=s;p[Z+232>>3]=s;p[Z+168>>3]=q;p[Z+224>>3]=n;p[Z+280>>3]=m;k[_+8>>2]=0;k[_+12>>2]=0;k[_>>2]=16842752;k[_+4>>2]=$;k[X+8>>2]=0;k[X+12>>2]=0;k[X>>2]=16842752;k[X+4>>2]=ba;e=Y+4|0;f=e+4|0;k[f>>2]=0;k[f+4>>2]=0;k[Y>>2]=33619968;k[e>>2]=aa;NZ(_,X,Y,2)|0;e=aa+36|0;f=k[e>>2]|0;if(f|0?(Z=f+12|0,_=k[Z>>2]|0,k[Z>>2]=_+-1,(_|0)==1):0){g=k[e>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[aa+32>>2]|0;if(!f){f=B1()|0;g=k[e>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[e>>2]=0}k[e>>2]=0;_=aa+16|0;g=aa+4|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[g>>2]|0)>0){e=k[aa+40>>2]|0;f=0;do{k[e+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[aa+44>>2]|0;if(!((f|0)==(aa+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);e=ba+36|0;f=k[e>>2]|0;if(f|0?(_=f+12|0,aa=k[_>>2]|0,k[_>>2]=aa+-1,(aa|0)==1):0){g=k[e>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[ba+32>>2]|0;if(!f){f=B1()|0;g=k[e>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[e>>2]=0}k[e>>2]=0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[I>>2]|0)>0){g=k[H>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[I>>2]|0))}f=k[J>>2]|0;if(!((f|0)==(K|0)|(f|0)==0))ggb(k[f+-4>>2]|0);e=$+36|0;f=k[e>>2]|0;if(f|0?(aa=f+12|0,ba=k[aa>>2]|0,k[aa>>2]=ba+-1,(ba|0)==1):0){g=k[e>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[$+32>>2]|0;if(!f){f=B1()|0;g=k[e>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[e>>2]=0}k[e>>2]=0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[N>>2]|0)>0){g=k[M>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[N>>2]|0))}f=k[O>>2]|0;if(!((f|0)==(P|0)|(f|0)==0))ggb(k[f+-4>>2]|0);r=ca;return}else{h=Z;l=h+128|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;k[W+16>>2]=0;k[W+20>>2]=0;k[W+24>>2]=0;k[W+28>>2]=0;T=ba+4|0;k[T>>2]=2;V=ba+8|0;k[V>>2]=4;k[ba+12>>2]=4;R=ba+16|0;k[R>>2]=Z;k[ba+20>>2]=Z;O=ba+24|0;S=ba+40|0;U=O+8|0;k[U>>2]=0;k[U+4>>2]=0;k[S>>2]=V;V=ba+48|0;U=ba+44|0;k[U>>2]=V;k[ba>>2]=1124024326;k[V>>2]=32;k[ba+52>>2]=8;k[ba+28>>2]=Z+128;k[O>>2]=Z+128;O=aa+4|0;k[O>>2]=2;Q=aa+8|0;k[Q>>2]=4;k[aa+12>>2]=1;M=aa+16|0;k[M>>2]=W;k[aa+20>>2]=W;J=aa+24|0;N=aa+40|0;P=J+8|0;k[P>>2]=0;k[P+4>>2]=0;k[N>>2]=Q;Q=aa+48|0;P=aa+44|0;k[P>>2]=Q;k[aa>>2]=1124024326;k[Q>>2]=8;k[aa+52>>2]=8;k[aa+28>>2]=W+32;k[J>>2]=W+32;J=_+4|0;k[J>>2]=2;L=_+8|0;k[L>>2]=4;k[_+12>>2]=1;H=_+16|0;k[H>>2]=$;k[_+20>>2]=$;F=_+24|0;I=_+40|0;K=F+8|0;k[K>>2]=0;k[K+4>>2]=0;k[I>>2]=L;L=_+48|0;K=_+44|0;k[K>>2]=L;k[_>>2]=1124024326;k[L>>2]=8;k[_+52>>2]=8;k[_+28>>2]=$+32;k[F>>2]=$+32;if((c|0)>0){B=Z+16|0;C=Z+24|0;j=Z+72|0;g=Z+80|0;f=Z+96|0;h=Z+104|0;e=Z+120|0;D=W+8|0;E=W+16|0;F=W+24|0;l=0;q=+p[Z>>3];m=+p[B>>3];n=+p[C>>3];s=+p[j>>3];t=+p[g>>3];u=+p[f>>3];v=+p[h>>3];w=+p[e>>3];x=+p[W>>3];y=+p[D>>3];z=+p[E>>3];A=+p[F>>3];do{ga=+o[a+(l<<3)>>2];da=+o[a+(l<<3)+4>>2];q=q+(ga*ga+da*da);ea=ga;m=m+ea;fa=da;n=n+fa;s=-da+s;t=t+1.0;u=u+fa;v=v+ea;w=w+1.0;ea=+o[b+(l<<3)>>2];fa=+o[b+(l<<3)+4>>2];x=x+(ga*ea+da*fa);y=y+(ga*fa-da*ea);z=z+ea;A=A+fa;l=l+1|0}while((l|0)!=(c|0));p[Z>>3]=q;p[B>>3]=m;p[C>>3]=n;p[j>>3]=s;p[g>>3]=t;p[f>>3]=u;p[h>>3]=v;p[e>>3]=w;p[W>>3]=x;p[D>>3]=y;p[E>>3]=z;p[F>>3]=A}else{j=Z+72|0;h=Z+104|0;e=Z+120|0;g=Z+80|0;f=Z+96|0;q=+p[Z>>3];n=+p[Z+24>>3];m=+p[Z+16>>3]}p[Z+40>>3]=q;ga=-n;p[Z+48>>3]=ga;p[j>>3]=ga;p[Z+64>>3]=m;p[Z+56>>3]=m;p[h>>3]=m;ga=+(c|0);p[e>>3]=ga;p[g>>3]=ga;p[f>>3]=n;k[X+8>>2]=0;k[X+12>>2]=0;k[X>>2]=16842752;k[X+4>>2]=ba;k[Y+8>>2]=0;k[Y+12>>2]=0;k[Y>>2]=16842752;k[Y+4>>2]=aa;e=G+4|0;f=e+4|0;k[f>>2]=0;k[f+4>>2]=0;k[G>>2]=33619968;k[e>>2]=_;NZ(X,Y,G,2)|0;e=k[d+16>>2]|0;ga=+p[$>>3];p[e+32>>3]=ga;p[e>>3]=ga;f=$+8|0;p[e+8>>3]=-+p[f>>3];p[e+24>>3]=+p[f>>3];p[e+16>>3]=+p[$+16>>3];p[e+40>>3]=+p[$+24>>3];e=_+36|0;f=k[e>>2]|0;if(f|0?(Z=f+12|0,$=k[Z>>2]|0,k[Z>>2]=$+-1,($|0)==1):0){g=k[e>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[_+32>>2]|0;if(!f){f=B1()|0;g=k[e>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[e>>2]=0}k[e>>2]=0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[J>>2]|0)>0){g=k[I>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[J>>2]|0))}f=k[K>>2]|0;if(!((f|0)==(L|0)|(f|0)==0))ggb(k[f+-4>>2]|0);e=aa+36|0;f=k[e>>2]|0;if(f|0?(_=f+12|0,$=k[_>>2]|0,k[_>>2]=$+-1,($|0)==1):0){g=k[e>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[aa+32>>2]|0;if(!f){f=B1()|0;g=k[e>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[e>>2]=0}k[e>>2]=0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[O>>2]|0)>0){g=k[N>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[O>>2]|0))}f=k[P>>2]|0;if(!((f|0)==(Q|0)|(f|0)==0))ggb(k[f+-4>>2]|0);e=ba+36|0;f=k[e>>2]|0;if(f|0?($=f+12|0,aa=k[$>>2]|0,k[$>>2]=aa+-1,(aa|0)==1):0){g=k[e>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[ba+32>>2]|0;if(!f){f=B1()|0;g=k[e>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[e>>2]=0}k[e>>2]=0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[T>>2]|0)>0){g=k[S>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[T>>2]|0))}f=k[U>>2]|0;if(!((f|0)==(V|0)|(f|0)==0))ggb(k[f+-4>>2]|0);r=ca;return}}function H6a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0.0,j=0.0,l=0.0,m=0.0,n=0.0,p=0.0,q=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0;Z=r;r=r+16|0;g=Z;Y=k[c+12>>2]|0;h=k[c+8>>2]|0;X=k[b+16>>2]|0;W=(k[b+48>>2]|0)>>>2;if(!(((((k[d+4>>2]|0)<3?(k[d+8>>2]|0)==(h|0):0)?(k[d+12>>2]|0)==(Y|0):0)?(k[d>>2]&4095|0)==37:0)?(k[d+16>>2]|0)!=0:0)){k[g>>2]=h;k[g+4>>2]=Y;G1(d,2,g,37)}if((e|0)>=(f|0)){r=Z;return}V=k[c+16>>2]|0;T=k[k[c+44>>2]>>2]|0;U=k[a+16>>2]|0;R=k[k[a+44>>2]>>2]|0;S=k[d+16>>2]|0;B=k[k[d+44>>2]>>2]|0;C=(Y|0)>0;D=Y+-1|0;E=h+-1|0;F=W+5|0;G=W+1|0;H=W+6|0;I=W+2|0;J=W+7|0;K=W+3|0;L=W+8|0;M=W+4|0;N=W+9|0;O=Y+-10|0;P=h+-10|0;Q=Y+-5|0;A=h+-5|0;do{d=V+(aa(T,e)|0)|0;h=U+(aa(R,e)|0)|0;u=S+(aa(B,e)|0)|0;if(C){v=+(e|0);w=(e|0)<5;x=152056+(e<<2)|0;y=(e|0)<(A|0);z=152056+(E-e<<2)|0;a=(e+-5|0)>>>0>=P>>>0;c=0;do{_=c<<1;p=+o[d+(_<<2)>>2];q=+o[d+((_|1)<<2)>>2];i=+(c|0)+p;j=v+q;_=~~i;_=_-(+(_|0)>i&1)|0;g=~~j;g=g-(+(g|0)>j&1)|0;b=X+((aa(g,W)|0)<<2)+(_*5<<2)|0;i=i-+(_|0);j=j-+(g|0);if(_>>>0<D>>>0&g>>>0<E>>>0){s=1.0-i;n=1.0-j;$=s*n;n=i*n;s=s*j;m=i*j;_=c*5|0;i=$*+o[b>>2]+n*+o[b+20>>2]+s*+o[b+(W<<2)>>2]+m*+o[b+(F<<2)>>2];t=($*+o[b+16>>2]+n*+o[b+36>>2]+s*+o[b+(M<<2)>>2]+m*+o[b+(N<<2)>>2]+ +o[h+(_+4<<2)>>2])*.25;l=($*+o[b+12>>2]+n*+o[b+32>>2]+s*+o[b+(K<<2)>>2]+m*+o[b+(L<<2)>>2]+ +o[h+(_+3<<2)>>2])*.5;j=($*+o[b+8>>2]+n*+o[b+28>>2]+s*+o[b+(I<<2)>>2]+m*+o[b+(J<<2)>>2]+ +o[h+(_+2<<2)>>2])*.5;m=$*+o[b+4>>2]+n*+o[b+24>>2]+s*+o[b+(G<<2)>>2]+m*+o[b+(H<<2)>>2];b=_}else{b=c*5|0;i=0.0;t=+o[h+(b+4<<2)>>2]*.5;l=+o[h+(b+3<<2)>>2];j=+o[h+(b+2<<2)>>2];m=0.0}g=b+1|0;n=q*j+p*t+(+o[h+(b<<2)>>2]-i)*.5;i=p*l+q*t+(+o[h+(g<<2)>>2]-m)*.5;if((c+-5|0)>>>0>=O>>>0|a){if((c|0)<5)p=+o[152056+(c<<2)>>2];else p=1.0;if((c|0)<(Q|0))m=1.0;else m=+o[152056+(D-c<<2)>>2];if(w)q=+o[x>>2];else q=1.0;if(y)s=1.0;else s=+o[z>>2];$=p*m*q*s;n=n*$;m=t*$;l=l*$;j=j*$;i=i*$}else m=t;$=m*m;o[u+(b<<2)>>2]=j*j+$;o[u+(g<<2)>>2]=(j+l)*m;o[u+(b+2<<2)>>2]=l*l+$;o[u+(b+3<<2)>>2]=i*m+j*n;o[u+(b+4<<2)>>2]=i*l+m*n;c=c+1|0}while((c|0)!=(Y|0))}e=e+1|0}while((e|0)!=(f|0));r=Z;return}function I6a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;while(1){h=fgb(1656)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;Qh[h&7]()}k[h>>2]=152084;b=h+84|0;c=h+144|0;d=h+152|0;e=h+184|0;f=h+148|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=b;g=f+60|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;b=h+192|0;k[h+188>>2]=b;k[h+196>>2]=0;k[b>>2]=0;k[c>>2]=1124007941;b=h+200|0;c=h+208|0;d=h+240|0;f=h+204|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+248|0;k[h+244>>2]=c;k[h+252>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+256|0;c=h+264|0;d=h+296|0;f=h+260|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+304|0;k[h+300>>2]=c;k[h+308>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+312|0;c=h+320|0;d=h+352|0;f=h+316|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+360|0;k[h+356>>2]=c;k[h+364>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+368|0;c=h+376|0;d=h+408|0;f=h+372|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+416|0;k[h+412>>2]=c;k[h+420>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+424|0;c=h+432|0;d=h+464|0;f=h+428|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+472|0;k[h+468>>2]=c;k[h+476>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+480|0;c=h+488|0;d=h+520|0;f=h+484|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+528|0;k[h+524>>2]=c;k[h+532>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+536|0;c=h+544|0;d=h+576|0;f=h+540|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+584|0;k[h+580>>2]=c;k[h+588>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+592|0;c=h+600|0;d=h+632|0;f=h+596|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+640|0;k[h+636>>2]=c;k[h+644>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+648|0;c=h+656|0;d=h+688|0;f=h+652|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+696|0;k[h+692>>2]=c;k[h+700>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+704|0;c=h+712|0;d=h+744|0;f=h+708|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+752|0;k[h+748>>2]=c;k[h+756>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+760|0;c=h+768|0;d=h+800|0;f=h+764|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+808|0;k[h+804>>2]=c;k[h+812>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+816|0;c=h+824|0;d=h+856|0;f=h+820|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+864|0;k[h+860>>2]=c;k[h+868>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;c=h+872|0;d=h+880|0;b=h+912|0;f=h+876|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[b>>2]=d;b=h+920|0;k[h+916>>2]=b;k[h+924>>2]=0;k[b>>2]=0;k[c>>2]=1124007941;b=h+928|0;c=h+936|0;d=h+968|0;f=h+932|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+976|0;k[h+972>>2]=c;k[h+980>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+984|0;c=h+992|0;d=h+1024|0;f=h+988|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+1032|0;k[h+1028>>2]=c;k[h+1036>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+1040|0;c=h+1048|0;d=h+1080|0;f=h+1044|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+1088|0;k[h+1084>>2]=c;k[h+1092>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+1096|0;c=h+1104|0;d=h+1136|0;f=h+1100|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+1144|0;k[h+1140>>2]=c;k[h+1148>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+1152|0;c=h+1160|0;d=h+1192|0;f=h+1156|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+1200|0;k[h+1196>>2]=c;k[h+1204>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+1208|0;c=h+1216|0;d=h+1248|0;f=h+1212|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+1256|0;k[h+1252>>2]=c;k[h+1260>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+1264|0;c=h+1272|0;d=h+1304|0;f=h+1268|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+1312|0;k[h+1308>>2]=c;k[h+1316>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+1320|0;c=h+1328|0;d=h+1360|0;f=h+1324|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+1368|0;k[h+1364>>2]=c;k[h+1372>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+1376|0;c=h+1384|0;d=h+1416|0;f=h+1380|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+1424|0;k[h+1420>>2]=c;k[h+1428>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+1432|0;c=h+1440|0;d=h+1472|0;f=h+1436|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+1480|0;k[h+1476>>2]=c;k[h+1484>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+1488|0;c=h+1496|0;d=h+1528|0;f=h+1492|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+1536|0;k[h+1532>>2]=c;k[h+1540>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+1544|0;c=h+1552|0;d=h+1584|0;f=h+1548|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;c=h+1592|0;k[h+1588>>2]=c;k[h+1596>>2]=0;k[c>>2]=0;k[b>>2]=1124007941;b=h+1600|0;c=h+1608|0;d=h+1640|0;f=h+1604|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;g=h+1648|0;k[h+1644>>2]=g;k[h+1652>>2]=0;k[g>>2]=0;k[b>>2]=1124007941;p[h+8>>3]=.25;p[h+16>>3]=.15;p[h+24>>3]=.3;k[h+40>>2]=5;k[h+44>>2]=5;p[h+48>>3]=.01;p[h+32>>3]=0.0;k[h+56>>2]=30;k[h+60>>2]=10;i[h+64>>0]=0;k[h+80>>2]=5;p[h+72>>3]=.8;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}g=b+4|0;k[g>>2]=1;k[b>>2]=152228;k[b+8>>2]=h;k[a>>2]=b;k[a+4>>2]=h;k[g>>2]=(k[g>>2]|0)+1;h=k[g>>2]|0;k[g>>2]=h+-1;if((h|0)!=1)return;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);return}function J6a(a){a=a|0;ggb(a);return}function K6a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function L6a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=152084;e=a+84|0;d=a+1636|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+1632>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+1616|0;c=a+1604|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1640>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+1644>>2]|0;if(!((b|0)==(a+1648|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+1580|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+1576>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+1560|0;c=a+1548|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1584>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+1588>>2]|0;if(!((b|0)==(a+1592|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+1524|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+1520>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+1504|0;d=a+1492|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+1528>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+1532>>2]|0;if(!((b|0)==(a+1536|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+1468|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+1464>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+1448|0;c=a+1436|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1472>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+1476>>2]|0;if(!((b|0)==(a+1480|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+1412|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+1408>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+1392|0;c=a+1380|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1416>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+1420>>2]|0;if(!((b|0)==(a+1424|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+1356|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1352>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+1336|0;c=a+1324|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1360>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+1364>>2]|0;if(!((b|0)==(a+1368|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+1300|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1296>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+1280|0;c=a+1268|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1304>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+1308>>2]|0;if(!((b|0)==(a+1312|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+1244|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1240>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+1224|0;c=a+1212|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1248>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+1252>>2]|0;if(!((b|0)==(a+1256|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+1188|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1184>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+1168|0;c=a+1156|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1192>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+1196>>2]|0;if(!((b|0)==(a+1200|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+1132|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1128>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+1112|0;c=a+1100|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1136>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+1140>>2]|0;if(!((b|0)==(a+1144|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+1076|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1072>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+1056|0;c=a+1044|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1080>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+1084>>2]|0;if(!((b|0)==(a+1088|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+1020|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1016>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+1e3|0;c=a+988|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1024>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+1028>>2]|0;if(!((b|0)==(a+1032|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+964|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+960>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+944|0;c=a+932|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+968>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+972>>2]|0;if(!((b|0)==(a+976|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+908|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+904>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+888|0;c=a+876|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+912>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+916>>2]|0;if(!((b|0)==(a+920|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+852|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+848>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+832|0;c=a+820|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+856>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+860>>2]|0;if(!((b|0)==(a+864|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+796|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+792>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+776|0;c=a+764|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+800>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+804>>2]|0;if(!((b|0)==(a+808|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+740|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+736>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+720|0;c=a+708|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+744>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+748>>2]|0;if(!((b|0)==(a+752|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+684|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+680>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+664|0;c=a+652|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+688>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+692>>2]|0;if(!((b|0)==(a+696|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+628|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+624>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+608|0;c=a+596|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+632>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+636>>2]|0;if(!((b|0)==(a+640|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+572|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+568>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+552|0;c=a+540|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+576>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+580>>2]|0;if(!((b|0)==(a+584|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+516|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+512>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+496|0;c=a+484|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+520>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+524>>2]|0;if(!((b|0)==(a+528|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+460|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+456>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+440|0;c=a+428|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+464>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+468>>2]|0;if(!((b|0)==(a+472|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+404|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+400>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+384|0;c=a+372|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+408>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+412>>2]|0;if(!((b|0)==(a+416|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+348|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+344>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+328|0;c=a+316|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+352>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+356>>2]|0;if(!((b|0)==(a+360|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+292|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+288>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+272|0;c=a+260|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+296>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+300>>2]|0;if(!((b|0)==(a+304|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+236|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+232>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+216|0;c=a+204|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+240>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+244>>2]|0;if(!((b|0)==(a+248|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+180|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+176>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+160|0;c=a+148|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+184>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+188>>2]|0;if((b|0)==(a+192|0)|(b|0)==0){d=a+132|0;L7a(d);d=a+120|0;L7a(d);d=a+108|0;L7a(d);a=a+96|0;L7a(a);L7a(e);return}ggb(k[b+-4>>2]|0);d=a+132|0;L7a(d);d=a+120|0;L7a(d);d=a+108|0;L7a(d);a=a+96|0;L7a(a);L7a(e);return}function M6a(a){a=a|0;L6a(a);ggb(a);return}function N6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0;Fa=r;r=r+400|0;Ba=Fa+88|0;Ea=Fa+328|0;Da=Fa+264|0;za=Fa+32|0;ka=Fa+392|0;la=Fa+384|0;ia=Fa+320|0;ja=Fa+256|0;ta=Fa+216|0;ua=Fa;va=Fa+200|0;wa=Fa+248|0;xa=Fa+240|0;ya=Fa+232|0;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[Ea>>2]=k[g>>2];m=Ea+4|0;b=g+4|0;k[m>>2]=k[b>>2];Ca=Ea+8|0;k[Ca>>2]=k[g+8>>2];k[Ea+12>>2]=k[g+12>>2];k[Ea+16>>2]=k[g+16>>2];k[Ea+20>>2]=k[g+20>>2];k[Ea+24>>2]=k[g+24>>2];k[Ea+28>>2]=k[g+28>>2];k[Ea+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Ea+36>>2]=e;f=Ea+40|0;k[f>>2]=Ca;Ca=Ea+48|0;j=Ea+44|0;k[j>>2]=Ca;k[Ea+52>>2]=0;k[Ca>>2]=0;if(e|0){Ca=e+12|0;k[Ca>>2]=(k[Ca>>2]|0)+1}if((k[b>>2]|0)<3){Aa=k[g+44>>2]|0;Ca=k[j>>2]|0;k[Ca>>2]=k[Aa>>2];k[Ca+4>>2]=k[Aa+4>>2];break}k[m>>2]=0;x1(Ea,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(Ea,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[Da>>2]=k[h>>2];m=Da+4|0;e=h+4|0;k[m>>2]=k[e>>2];Ca=Da+8|0;k[Ca>>2]=k[h+8>>2];k[Da+12>>2]=k[h+12>>2];k[Da+16>>2]=k[h+16>>2];k[Da+20>>2]=k[h+20>>2];k[Da+24>>2]=k[h+24>>2];k[Da+28>>2]=k[h+28>>2];k[Da+32>>2]=k[h+32>>2];b=k[h+36>>2]|0;k[Da+36>>2]=b;f=Da+40|0;k[f>>2]=Ca;Ca=Da+48|0;j=Da+44|0;k[j>>2]=Ca;k[Da+52>>2]=0;k[Ca>>2]=0;if(b|0){Ca=b+12|0;k[Ca>>2]=(k[Ca>>2]|0)+1}if((k[e>>2]|0)<3){Aa=k[h+44>>2]|0;Ca=k[j>>2]|0;k[Ca>>2]=k[Aa>>2];k[Ca+4>>2]=k[Aa+4>>2];break}k[m>>2]=0;x1(Da,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;e=k[j>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(Da,c,-1);while(0);switch(k[Ea>>2]&4095){case 5:case 0:break;default:{k[Ba>>2]=0;b=Ba+4|0;k[b>>2]=0;e=ZT(52)|0;k[e>>2]=1;f=e+4|0;k[Ba>>2]=f;k[b>>2]=45;i[e+49>>0]=0;g=404883;h=f+45|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,Ba,404929,404934,389);k[b>>2]=0;k[Ba>>2]=0;Ca=k[e>>2]|0;k[e>>2]=Ca+-1;if((Ca|0)==1)ggb(k[e+-4>>2]|0)}}Ca=Ea+40|0;ra=k[Ca>>2]|0;Aa=Da+40|0;sa=k[Aa>>2]|0;if(!((k[ra>>2]|0)==(k[sa>>2]|0)?(k[ra+4>>2]|0)==(k[sa+4>>2]|0):0)){k[Ba>>2]=0;b=Ba+4|0;k[b>>2]=0;e=ZT(28)|0;k[e>>2]=1;f=e+4|0;k[Ba>>2]=f;k[b>>2]=22;i[e+26>>0]=0;g=405002;h=f+22|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,Ba,404929,404934,390);k[b>>2]=0;k[Ba>>2]=0;sa=k[e>>2]|0;k[e>>2]=sa+-1;if((sa|0)==1)ggb(k[e+-4>>2]|0)}if((k[Da>>2]^k[Ea>>2])&4095|0){k[Ba>>2]=0;b=Ba+4|0;k[b>>2]=0;e=ZT(28)|0;k[e>>2]=1;f=e+4|0;k[Ba>>2]=f;k[b>>2]=22;i[e+26>>0]=0;g=405025;h=f+22|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,Ba,404929,404934,391);k[b>>2]=0;k[Ba>>2]=0;sa=k[e>>2]|0;k[e>>2]=sa+-1;if((sa|0)==1)ggb(k[e+-4>>2]|0)}ha=a+64|0;do if(i[ha>>0]|0){R1(Ba,d,-1);sa=k[Ca>>2]|0;if((k[Ba>>2]|0)==(k[sa+4>>2]|0)?(k[Ba+4>>2]|0)==(k[sa>>2]|0):0)if((S1(d,-1)|0)==13)break;k[Ba>>2]=0;b=Ba+4|0;k[b>>2]=0;e=ZT(80)|0;k[e>>2]=1;f=e+4|0;k[Ba>>2]=f;k[b>>2]=74;i[e+78>>0]=0;g=405048;h=f+74|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,Ba,404929,404934,392);k[b>>2]=0;k[Ba>>2]=0;sa=k[e>>2]|0;k[e>>2]=sa+-1;if((sa|0)==1)ggb(k[e+-4>>2]|0)}while(0);ga=a+40|0;b=k[ga>>2]|0;if((b|0)<=0){k[Ba>>2]=0;b=Ba+4|0;k[b>>2]=0;e=ZT(16)|0;k[e>>2]=1;f=e+4|0;k[Ba>>2]=f;k[b>>2]=11;i[e+15>>0]=0;g=405123;h=f+11|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,Ba,404929,404934,393);k[b>>2]=0;k[Ba>>2]=0;sa=k[e>>2]|0;k[e>>2]=sa+-1;if((sa|0)==1)ggb(k[e+-4>>2]|0);b=k[ga>>2]|0}qa=+p[a+32>>3]!=0.0;ra=a+84|0;l7a(ra,b);na=a+96|0;l7a(na,k[ga>>2]|0);oa=a+108|0;l7a(oa,k[ga>>2]|0);sa=a+120|0;l7a(sa,k[ga>>2]|0);pa=a+132|0;l7a(pa,k[ga>>2]|0);b=k[ra>>2]|0;e=Ba+4|0;f=e+4|0;k[f>>2]=0;k[f+4>>2]=0;k[Ba>>2]=-2113863675;k[e>>2]=b;SW(Ea,Ba,5,(k[Ea>>2]&7|0)==0?1.0:255.0,0.0);e=k[na>>2]|0;b=Ba+4|0;f=b+4|0;k[f>>2]=0;k[f+4>>2]=0;k[Ba>>2]=-2113863675;k[b>>2]=e;SW(Da,Ba,5,(k[Da>>2]&7|0)==0?1.0:255.0,0.0);b=k[oa>>2]|0;e=k[Ca>>2]|0;f=k[e+4>>2]|0;e=k[e>>2]|0;if(!(((((k[b+4>>2]|0)<3?(k[b+8>>2]|0)==(e|0):0)?(k[b+12>>2]|0)==(f|0):0)?(k[b>>2]&4095|0)==5:0)?(k[b+16>>2]|0)!=0:0)){k[Ba>>2]=e;k[Ba+4>>2]=f;G1(b,2,Ba,5);f=k[Ca>>2]|0;e=k[f>>2]|0;f=k[f+4>>2]|0}b=k[sa>>2]|0;if(!(((((k[b+4>>2]|0)<3?(k[b+8>>2]|0)==(e|0):0)?(k[b+12>>2]|0)==(f|0):0)?(k[b>>2]&4095|0)==5:0)?(k[b+16>>2]|0)!=0:0)){k[Ba>>2]=e;k[Ba+4>>2]=f;G1(b,2,Ba,5)}do if(qa){b=k[pa>>2]|0;f=k[Ca>>2]|0;e=k[f+4>>2]|0;f=k[f>>2]|0;if(((((k[b+4>>2]|0)<3?(k[b+8>>2]|0)==(f|0):0)?(k[b+12>>2]|0)==(e|0):0)?(k[b>>2]&4095|0)==5:0)?k[b+16>>2]|0:0)break;k[Ba>>2]=f;k[Ba+4>>2]=e;G1(b,2,Ba,5)}while(0);if(i[ha>>0]|0){f=k[oa>>2]|0;k[Ba>>2]=k[f>>2];z=Ba+4|0;b=f+4|0;k[z>>2]=k[b>>2];B=Ba+8|0;k[B>>2]=k[f+8>>2];k[Ba+12>>2]=k[f+12>>2];w=Ba+16|0;k[w>>2]=k[f+16>>2];k[Ba+20>>2]=k[f+20>>2];k[Ba+24>>2]=k[f+24>>2];k[Ba+28>>2]=k[f+28>>2];v=Ba+32|0;k[v>>2]=k[f+32>>2];x=Ba+36|0;e=k[f+36>>2]|0;k[x>>2]=e;y=Ba+40|0;k[y>>2]=B;B=Ba+48|0;A=Ba+44|0;k[A>>2]=B;k[Ba+52>>2]=0;k[B>>2]=0;if(e|0){fa=e+12|0;k[fa>>2]=(k[fa>>2]|0)+1}if((k[b>>2]|0)>=3){k[z>>2]=0;x1(Ba,k[b>>2]|0,0,0,0);if((k[z>>2]|0)>0){g=k[f+40>>2]|0;h=k[y>>2]|0;e=k[f+44>>2]|0;f=k[A>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[g+(b<<2)>>2];k[f+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[z>>2]|0))}}else{ea=k[f+44>>2]|0;fa=k[A>>2]|0;k[fa>>2]=k[ea>>2];k[fa+4>>2]=k[ea+4>>2]}b=Ba+56|0;g=k[sa>>2]|0;k[b>>2]=k[g>>2];s=Ba+60|0;e=g+4|0;k[s>>2]=k[e>>2];u=Ba+64|0;k[u>>2]=k[g+8>>2];k[Ba+68>>2]=k[g+12>>2];n=Ba+72|0;k[n>>2]=k[g+16>>2];k[Ba+76>>2]=k[g+20>>2];k[Ba+80>>2]=k[g+24>>2];k[Ba+84>>2]=k[g+28>>2];c=Ba+88|0;k[c>>2]=k[g+32>>2];o=Ba+92|0;f=k[g+36>>2]|0;k[o>>2]=f;q=Ba+96|0;k[q>>2]=u;u=Ba+104|0;t=Ba+100|0;k[t>>2]=u;k[Ba+108>>2]=0;k[u>>2]=0;if(f|0){fa=f+12|0;k[fa>>2]=(k[fa>>2]|0)+1}if((k[e>>2]|0)>=3){k[s>>2]=0;x1(b,k[e>>2]|0,0,0,0);if((k[s>>2]|0)>0){h=k[g+40>>2]|0;j=k[q>>2]|0;e=k[g+44>>2]|0;f=k[t>>2]|0;b=0;do{k[j+(b<<2)>>2]=k[h+(b<<2)>>2];k[f+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[s>>2]|0))}}else{ea=k[g+44>>2]|0;fa=k[t>>2]|0;k[fa>>2]=k[ea>>2];k[fa+4>>2]=k[ea+4>>2]}do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[za>>2]=k[g>>2];m=za+4|0;b=g+4|0;k[m>>2]=k[b>>2];fa=za+8|0;k[fa>>2]=k[g+8>>2];k[za+12>>2]=k[g+12>>2];k[za+16>>2]=k[g+16>>2];k[za+20>>2]=k[g+20>>2];k[za+24>>2]=k[g+24>>2];k[za+28>>2]=k[g+28>>2];k[za+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[za+36>>2]=e;f=za+40|0;k[f>>2]=fa;fa=za+48|0;j=za+44|0;k[j>>2]=fa;k[za+52>>2]=0;k[fa>>2]=0;if(e|0){fa=e+12|0;k[fa>>2]=(k[fa>>2]|0)+1}if((k[b>>2]|0)<3){ea=k[g+44>>2]|0;fa=k[j>>2]|0;k[fa>>2]=k[ea>>2];k[fa+4>>2]=k[ea+4>>2];break}k[m>>2]=0;x1(za,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(za,d,-1);while(0);EV(za,Ba);f=za+36|0;b=k[f>>2]|0;if(b|0?(ea=b+12|0,fa=k[ea>>2]|0,k[ea>>2]=fa+-1,(fa|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[za+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;fa=za+16|0;e=za+4|0;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=0;k[fa+12>>2]=0;if((k[e>>2]|0)>0){f=k[za+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[za+44>>2]|0;if(!((b|0)==(za+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[o>>2]|0;do if(b|0){ea=b+12|0;fa=k[ea>>2]|0;k[ea>>2]=fa+-1;if((fa|0)!=1)break;e=k[o>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[c>>2]|0;if(b|0)break;b=B1()|0;e=k[o>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[o>>2]=0}while(0);k[o>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[s>>2]|0)>0){e=k[q>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[s>>2]|0))}b=k[t>>2]|0;if(!((b|0)==(u|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[x>>2]|0;do if(b|0){ea=b+12|0;fa=k[ea>>2]|0;k[ea>>2]=fa+-1;if((fa|0)!=1)break;e=k[x>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[v>>2]|0;if(b|0)break;b=B1()|0;e=k[x>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[x>>2]=0}while(0);k[x>>2]=0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[z>>2]|0)>0){e=k[y>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[A>>2]|0;if(!((b|0)==(B|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}b=k[Ca>>2]|0;e=k[b+4>>2]|0;b=k[b>>2]|0;f=a+144|0;if(!(((((k[a+148>>2]|0)<3?(k[a+152>>2]|0)==(b|0):0)?(k[a+156>>2]|0)==(e|0):0)?(k[f>>2]&4095|0)==5:0)?(k[a+160>>2]|0)!=0:0)){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+200|0;if(!(((((k[a+204>>2]|0)<3?(k[a+208>>2]|0)==(b|0):0)?(k[a+212>>2]|0)==(e|0):0)?(k[f>>2]&4095|0)==5:0)?(k[a+216>>2]|0)!=0:0)){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+256|0;if(!(((((k[a+260>>2]|0)<3?(k[a+264>>2]|0)==(b|0):0)?(k[a+268>>2]|0)==(e|0):0)?(k[f>>2]&4095|0)==5:0)?(k[a+272>>2]|0)!=0:0)){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+312|0;if(!(((((k[a+316>>2]|0)<3?(k[a+320>>2]|0)==(b|0):0)?(k[a+324>>2]|0)==(e|0):0)?(k[f>>2]&4095|0)==5:0)?(k[a+328>>2]|0)!=0:0)){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+368|0;if(!(((((k[a+372>>2]|0)<3?(k[a+376>>2]|0)==(b|0):0)?(k[a+380>>2]|0)==(e|0):0)?(k[f>>2]&4095|0)==5:0)?(k[a+384>>2]|0)!=0:0)){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+424|0;if(!(((((k[a+428>>2]|0)<3?(k[a+432>>2]|0)==(b|0):0)?(k[a+436>>2]|0)==(e|0):0)?(k[f>>2]&4095|0)==5:0)?(k[a+440>>2]|0)!=0:0)){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+480|0;do if(((k[a+484>>2]|0)<3?(k[a+488>>2]|0)==(b|0):0)?(k[a+492>>2]|0)==(e|0):0){if((k[f>>2]&4095|0)!=5){ma=153;break}if(!(k[a+496>>2]|0))ma=153}else ma=153;while(0);if((ma|0)==153){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+536|0;do if((k[a+540>>2]|0)<3?(k[a+544>>2]|0)==(b|0):0){if((k[a+548>>2]|0)!=(e|0)){ma=159;break}if((k[f>>2]&4095|0)!=5){ma=159;break}if(!(k[a+552>>2]|0))ma=159}else ma=159;while(0);if((ma|0)==159){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+592|0;do if((k[a+596>>2]|0)<3){if((k[a+600>>2]|0)!=(b|0)){ma=165;break}if((k[a+604>>2]|0)!=(e|0)){ma=165;break}if((k[f>>2]&4095|0)!=5){ma=165;break}if(!(k[a+608>>2]|0))ma=165}else ma=165;while(0);if((ma|0)==165){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+648|0;do if((k[a+652>>2]|0)<3){if((k[a+656>>2]|0)!=(b|0)){ma=171;break}if((k[a+660>>2]|0)!=(e|0)){ma=171;break}if((k[f>>2]&4095|0)!=5){ma=171;break}if(!(k[a+664>>2]|0))ma=171}else ma=171;while(0);if((ma|0)==171){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+704|0;do if((k[a+708>>2]|0)<3){if((k[a+712>>2]|0)!=(b|0)){ma=177;break}if((k[a+716>>2]|0)!=(e|0)){ma=177;break}if((k[f>>2]&4095|0)!=5){ma=177;break}if(!(k[a+720>>2]|0))ma=177}else ma=177;while(0);if((ma|0)==177){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+760|0;do if((k[a+764>>2]|0)<3){if((k[a+768>>2]|0)!=(b|0)){ma=183;break}if((k[a+772>>2]|0)!=(e|0)){ma=183;break}if((k[f>>2]&4095|0)!=5){ma=183;break}if(!(k[a+776>>2]|0))ma=183}else ma=183;while(0);if((ma|0)==183){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+816|0;do if((k[a+820>>2]|0)<3){if((k[a+824>>2]|0)!=(b|0)){ma=189;break}if((k[a+828>>2]|0)!=(e|0)){ma=189;break}if((k[f>>2]&4095|0)!=5){ma=189;break}if(!(k[a+832>>2]|0))ma=189}else ma=189;while(0);if((ma|0)==189){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+872|0;do if((k[a+876>>2]|0)<3){if((k[a+880>>2]|0)!=(b|0)){ma=195;break}if((k[a+884>>2]|0)!=(e|0)){ma=195;break}if((k[f>>2]&4095|0)!=5){ma=195;break}if(!(k[a+888>>2]|0))ma=195}else ma=195;while(0);if((ma|0)==195){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+928|0;do if((k[a+932>>2]|0)<3){if((k[a+936>>2]|0)!=(b|0)){ma=201;break}if((k[a+940>>2]|0)!=(e|0)){ma=201;break}if((k[f>>2]&4095|0)!=5){ma=201;break}if(!(k[a+944>>2]|0))ma=201}else ma=201;while(0);if((ma|0)==201){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+984|0;do if((k[a+988>>2]|0)<3){if((k[a+992>>2]|0)!=(b|0)){ma=207;break}if((k[a+996>>2]|0)!=(e|0)){ma=207;break}if((k[f>>2]&4095|0)!=5){ma=207;break}if(!(k[a+1e3>>2]|0))ma=207}else ma=207;while(0);if((ma|0)==207){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+1040|0;do if((k[a+1044>>2]|0)<3){if((k[a+1048>>2]|0)!=(b|0)){ma=213;break}if((k[a+1052>>2]|0)!=(e|0)){ma=213;break}if((k[f>>2]&4095|0)!=5){ma=213;break}if(!(k[a+1056>>2]|0))ma=213}else ma=213;while(0);if((ma|0)==213){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+1096|0;do if((k[a+1100>>2]|0)<3){if((k[a+1104>>2]|0)!=(b|0)){ma=219;break}if((k[a+1108>>2]|0)!=(e|0)){ma=219;break}if((k[f>>2]&4095|0)!=5){ma=219;break}if(!(k[a+1112>>2]|0))ma=219}else ma=219;while(0);if((ma|0)==219){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+1152|0;do if((k[a+1156>>2]|0)<3){if((k[a+1160>>2]|0)!=(b|0)){ma=225;break}if((k[a+1164>>2]|0)!=(e|0)){ma=225;break}if((k[f>>2]&4095|0)!=5){ma=225;break}if(!(k[a+1168>>2]|0))ma=225}else ma=225;while(0);if((ma|0)==225){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+1208|0;do if((k[a+1212>>2]|0)<3){if((k[a+1216>>2]|0)!=(b|0)){ma=231;break}if((k[a+1220>>2]|0)!=(e|0)){ma=231;break}if((k[f>>2]&4095|0)!=5){ma=231;break}if(!(k[a+1224>>2]|0))ma=231}else ma=231;while(0);if((ma|0)==231){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;b=k[e>>2]|0;e=k[e+4>>2]|0}f=a+1264|0;do if((k[a+1268>>2]|0)<3){if((k[a+1272>>2]|0)!=(b|0)){ma=237;break}if((k[a+1276>>2]|0)!=(e|0)){ma=237;break}if((k[f>>2]&4095|0)!=5){ma=237;break}if(!(k[a+1280>>2]|0))ma=237}else ma=237;while(0);if((ma|0)==237){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);b=k[Ca>>2]|0;e=k[b+4>>2]|0;b=k[b>>2]|0}f=a+1320|0;do if((k[a+1324>>2]|0)<3){if((k[a+1328>>2]|0)!=(b|0)){ma=243;break}if((k[a+1332>>2]|0)!=(e|0)){ma=243;break}if((k[f>>2]&4095|0)!=5){ma=243;break}if(k[a+1336>>2]|0)f=b;else ma=243}else ma=243;while(0);if((ma|0)==243){k[Ba>>2]=b;k[Ba+4>>2]=e;G1(f,2,Ba,5);e=k[Ca>>2]|0;f=k[e>>2]|0;e=k[e+4>>2]|0}b=a+1376|0;do if((k[a+1380>>2]|0)<3){if((k[a+1384>>2]|0)!=(f|0)){ma=249;break}if((k[a+1388>>2]|0)!=(e|0)){ma=249;break}if((k[b>>2]&4095|0)!=5){ma=249;break}if(!(k[a+1392>>2]|0))ma=249}else ma=249;while(0);if((ma|0)==249){k[Ba>>2]=f;k[Ba+4>>2]=e;G1(b,2,Ba,5);e=k[Ca>>2]|0;f=k[e>>2]|0;e=k[e+4>>2]|0}b=a+1432|0;do if((k[a+1436>>2]|0)<3){if((k[a+1440>>2]|0)!=(f|0)){ma=255;break}if((k[a+1444>>2]|0)!=(e|0)){ma=255;break}if((k[b>>2]&4095|0)!=5){ma=255;break}if(!(k[a+1448>>2]|0))ma=255}else ma=255;while(0);if((ma|0)==255){k[Ba>>2]=f;k[Ba+4>>2]=e;G1(b,2,Ba,5);e=k[Ca>>2]|0;f=k[e>>2]|0;e=k[e+4>>2]|0}b=a+1488|0;do if((k[a+1492>>2]|0)<3){if((k[a+1496>>2]|0)!=(f|0)){ma=261;break}if((k[a+1500>>2]|0)!=(e|0)){ma=261;break}if((k[b>>2]&4095|0)!=5){ma=261;break}if(!(k[a+1504>>2]|0))ma=261}else ma=261;while(0);if((ma|0)==261){k[Ba>>2]=f;k[Ba+4>>2]=e;G1(b,2,Ba,5);e=k[Ca>>2]|0;f=k[e>>2]|0;e=k[e+4>>2]|0}b=a+1544|0;do if((k[a+1548>>2]|0)<3){if((k[a+1552>>2]|0)!=(f|0)){ma=267;break}if((k[a+1556>>2]|0)!=(e|0)){ma=267;break}if((k[b>>2]&4095|0)!=5){ma=267;break}if(!(k[a+1560>>2]|0))ma=267}else ma=267;while(0);if((ma|0)==267){k[Ba>>2]=f;k[Ba+4>>2]=e;G1(b,2,Ba,5);e=k[Ca>>2]|0;f=k[e>>2]|0;e=k[e+4>>2]|0}b=a+1600|0;do if((k[a+1604>>2]|0)<3){if((k[a+1608>>2]|0)!=(f|0)){ma=273;break}if((k[a+1612>>2]|0)!=(e|0)){ma=273;break}if((k[b>>2]&4095|0)!=5){ma=273;break}if(!(k[a+1616>>2]|0))ma=273}else ma=273;while(0);if((ma|0)==273){k[Ba>>2]=f;k[Ba+4>>2]=e;G1(b,2,Ba,5)}b=k[ga>>2]|0;a:do if((b|0)>1){l=Ba+8|0;m=Ba+12|0;c=Ba+4|0;n=za+4|0;o=n+4|0;q=ka+4|0;s=a+72|0;t=Ba+8|0;u=Ba+12|0;v=Ba+4|0;w=za+4|0;x=w+4|0;y=la+4|0;z=Ba+4|0;A=Ba+8|0;B=Ba+12|0;C=Ba+4|0;D=za+4|0;E=D+4|0;F=ia+4|0;G=Ba+8|0;H=Ba+12|0;I=Ba+4|0;J=za+4|0;K=J+4|0;L=ja+4|0;M=za+8|0;N=za+12|0;O=za+4|0;P=ua+8|0;Q=ua+16|0;R=ua+24|0;S=ta+8|0;T=ta+12|0;U=ta+4|0;V=va+4|0;W=V+4|0;X=za+8|0;Y=za+12|0;Z=za+4|0;_=ua+8|0;$=ua+16|0;aa=ua+24|0;ba=ta+8|0;ca=ta+12|0;da=ta+4|0;ea=va+4|0;fa=ea+4|0;b=1;while(1){e=b+-1|0;f=k[ra>>2]|0;k[l>>2]=0;k[m>>2]=0;k[Ba>>2]=-2130640891;k[c>>2]=f+(e*56|0);j=o;k[j>>2]=0;k[j+4>>2]=0;k[za>>2]=-2113863675;k[n>>2]=f+(b*56|0);k[ka>>2]=0;k[q>>2]=0;Ga=+p[s>>3];Rla(Ba,za,ka,Ga,Ga,1);f=k[na>>2]|0;k[t>>2]=0;k[u>>2]=0;k[Ba>>2]=-2130640891;k[v>>2]=f+(e*56|0);j=x;k[j>>2]=0;k[j+4>>2]=0;k[za>>2]=-2113863675;k[w>>2]=f+(b*56|0);k[la>>2]=0;k[y>>2]=0;Ga=+p[s>>3];Rla(Ba,za,la,Ga,Ga,1);f=k[ra>>2]|0;if((k[f+(b*56|0)+12>>2]|0)<16)break;if((k[f+(b*56|0)+8>>2]|0)<16)break;b:do if(!(i[ha>>0]|0)){g=k[oa>>2]|0;j=g+(b*56|0)|0;e=k[f+(b*56|0)+40>>2]|0;h=k[e+4>>2]|0;e=k[e>>2]|0;do if((k[g+(b*56|0)+4>>2]|0)<3){if((k[g+(b*56|0)+8>>2]|0)!=(e|0)){ma=286;break}if((k[g+(b*56|0)+12>>2]|0)!=(h|0)){ma=286;break}if((k[j>>2]&4095|0)!=5){ma=286;break}if(!(k[g+(b*56|0)+16>>2]|0))ma=286}else ma=286;while(0);if((ma|0)==286){ma=0;k[Ba>>2]=e;k[z>>2]=h;G1(j,2,Ba,5);h=k[(k[ra>>2]|0)+(b*56|0)+40>>2]|0;e=k[h>>2]|0;h=k[h+4>>2]|0}f=k[sa>>2]|0;g=f+(b*56|0)|0;do if((k[f+(b*56|0)+4>>2]|0)<3){if((k[f+(b*56|0)+8>>2]|0)!=(e|0))break;if((k[f+(b*56|0)+12>>2]|0)!=(h|0))break;if((k[g>>2]&4095|0)!=5)break;if(k[f+(b*56|0)+16>>2]|0)break b}while(0);k[Ba>>2]=e;k[z>>2]=h;G1(g,2,Ba,5)}else{j=k[oa>>2]|0;k[A>>2]=0;k[B>>2]=0;k[Ba>>2]=-2130640891;k[C>>2]=j+(e*56|0);h=E;k[h>>2]=0;k[h+4>>2]=0;k[za>>2]=-2113863675;k[D>>2]=j+(b*56|0);k[ia>>2]=0;k[F>>2]=0;Ga=+p[s>>3];Rla(Ba,za,ia,Ga,Ga,1);j=k[sa>>2]|0;k[G>>2]=0;k[H>>2]=0;k[Ba>>2]=-2130640891;k[I>>2]=j+(e*56|0);h=K;k[h>>2]=0;k[h+4>>2]=0;k[za>>2]=-2113863675;k[J>>2]=j+(b*56|0);k[ja>>2]=0;k[L>>2]=0;Ga=+p[s>>3];Rla(Ba,za,ja,Ga,Ga,1);j=(k[oa>>2]|0)+(b*56|0)|0;k[M>>2]=0;k[N>>2]=0;k[za>>2]=-2130640891;k[O>>2]=j;Ga=+p[s>>3];p[ua>>3]=Ga;p[P>>3]=Ga;p[Q>>3]=Ga;p[R>>3]=Ga;k[ta>>2]=-1056833530;k[U>>2]=ua;k[S>>2]=1;k[T>>2]=4;h=W;k[h>>2]=0;k[h+4>>2]=0;k[va>>2]=-2113863675;k[V>>2]=j;p[Ba>>3]=1.0;sU(za,ta,va,49332,-1,40032,1,Ba);j=(k[sa>>2]|0)+(b*56|0)|0;k[X>>2]=0;k[Y>>2]=0;k[za>>2]=-2130640891;k[Z>>2]=j;Ga=+p[s>>3];p[ua>>3]=Ga;p[_>>3]=Ga;p[$>>3]=Ga;p[aa>>3]=Ga;k[ta>>2]=-1056833530;k[da>>2]=ua;k[ba>>2]=1;k[ca>>2]=4;h=fa;k[h>>2]=0;k[h+4>>2]=0;k[va>>2]=-2113863675;k[ea>>2]=j;p[Ba>>3]=1.0;sU(za,ta,va,49332,-1,40032,1,Ba)}while(0);c:do if(qa){e=k[pa>>2]|0;f=e+(b*56|0)|0;h=k[(k[ra>>2]|0)+(b*56|0)+40>>2]|0;g=k[h+4>>2]|0;h=k[h>>2]|0;do if((k[e+(b*56|0)+4>>2]|0)<3){if((k[e+(b*56|0)+8>>2]|0)!=(h|0))break;if((k[e+(b*56|0)+12>>2]|0)!=(g|0))break;if((k[f>>2]&4095|0)!=5)break;if(k[e+(b*56|0)+16>>2]|0)break c}while(0);k[Ba>>2]=h;k[z>>2]=g;G1(f,2,Ba,5)}while(0);b=b+1|0;e=k[ga>>2]|0;if((b|0)>=(e|0)){b=e;break a}}k[ga>>2]=b}while(0);if(!(i[ha>>0]|0)){ma=k[oa>>2]|0;k[za>>2]=0;k[za+4>>2]=0;k[za+8>>2]=0;k[za+12>>2]=0;k[za+16>>2]=0;k[za+20>>2]=0;k[za+24>>2]=0;k[za+28>>2]=0;k[Ba>>2]=-1056833530;k[Ba+4>>2]=za;k[Ba+8>>2]=1;k[Ba+12>>2]=4;pY(ma+((b+-1|0)*56|0)|0,Ba,49332);ma=k[ga>>2]|0;la=k[sa>>2]|0;k[za>>2]=0;k[za+4>>2]=0;k[za+8>>2]=0;k[za+12>>2]=0;k[za+16>>2]=0;k[za+20>>2]=0;k[za+24>>2]=0;k[za+28>>2]=0;k[Ba>>2]=-1056833530;k[Ba+4>>2]=za;k[Ba+8>>2]=1;k[Ba+12>>2]=4;pY(la+((ma+-1|0)*56|0)|0,Ba,49332)}if(qa){ma=k[ga>>2]|0;la=k[pa>>2]|0;k[za>>2]=0;k[za+4>>2]=0;k[za+8>>2]=0;k[za+12>>2]=0;k[za+16>>2]=0;k[za+20>>2]=0;k[za+24>>2]=0;k[za+28>>2]=0;k[Ba>>2]=-1056833530;k[Ba+4>>2]=za;k[Ba+8>>2]=1;k[Ba+12>>2]=4;pY(la+((ma+-1|0)*56|0)|0,Ba,49332)}b=k[ga>>2]|0;d:do if((b|0)>0){g=Ba+8|0;h=Ba+12|0;j=Ba+4|0;l=za+4|0;m=l+4|0;c=wa+4|0;n=Ba+8|0;o=Ba+12|0;q=Ba+4|0;s=za+4|0;t=s+4|0;u=xa+4|0;v=Ba+8|0;w=Ba+12|0;x=Ba+4|0;y=za+4|0;z=y+4|0;A=ya+4|0;B=za+8|0;C=za+12|0;D=za+4|0;E=a+72|0;F=ua+8|0;G=ua+16|0;H=ua+24|0;I=ta+8|0;J=ta+12|0;K=ta+4|0;L=va+4|0;M=L+4|0;N=za+8|0;O=za+12|0;P=za+4|0;Q=ua+8|0;R=ua+16|0;S=ua+24|0;T=ta+8|0;U=ta+12|0;V=ta+4|0;W=va+4|0;X=W+4|0;do{e=b;b=b+-1|0;m7a(a,(k[ra>>2]|0)+(b*56|0)|0,(k[na>>2]|0)+(b*56|0)|0,(k[oa>>2]|0)+(b*56|0)|0,(k[sa>>2]|0)+(b*56|0)|0,(k[pa>>2]|0)+(b*56|0)|0);if(!b)break d;ma=k[oa>>2]|0;k[g>>2]=0;k[h>>2]=0;k[Ba>>2]=-2130640891;k[j>>2]=ma+(b*56|0);f=e+-2|0;la=m;k[la>>2]=0;k[la+4>>2]=0;k[za>>2]=-2113863675;k[l>>2]=ma+(f*56|0);ma=k[(k[ra>>2]|0)+(f*56|0)+40>>2]|0;la=k[ma>>2]|0;k[wa>>2]=k[ma+4>>2];k[c>>2]=la;Rla(Ba,za,wa,0.0,0.0,1);la=k[sa>>2]|0;k[n>>2]=0;k[o>>2]=0;k[Ba>>2]=-2130640891;k[q>>2]=la+(b*56|0);ma=t;k[ma>>2]=0;k[ma+4>>2]=0;k[za>>2]=-2113863675;k[s>>2]=la+(f*56|0);la=k[(k[ra>>2]|0)+(f*56|0)+40>>2]|0;ma=k[la>>2]|0;k[xa>>2]=k[la+4>>2];k[u>>2]=ma;Rla(Ba,za,xa,0.0,0.0,1);if(qa){la=k[pa>>2]|0;k[v>>2]=0;k[w>>2]=0;k[Ba>>2]=-2130640891;k[x>>2]=la+(b*56|0);ma=z;k[ma>>2]=0;k[ma+4>>2]=0;k[za>>2]=-2113863675;k[y>>2]=la+(f*56|0);la=k[(k[ra>>2]|0)+(f*56|0)+40>>2]|0;ma=k[la>>2]|0;k[ya>>2]=k[la+4>>2];k[A>>2]=ma;Rla(Ba,za,ya,0.0,0.0,1)}ma=(k[oa>>2]|0)+(f*56|0)|0;k[B>>2]=0;k[C>>2]=0;k[za>>2]=-2130640891;k[D>>2]=ma;Ga=1.0/+p[E>>3];p[ua>>3]=Ga;p[F>>3]=Ga;p[G>>3]=Ga;p[H>>3]=Ga;k[ta>>2]=-1056833530;k[K>>2]=ua;k[I>>2]=1;k[J>>2]=4;la=M;k[la>>2]=0;k[la+4>>2]=0;k[va>>2]=-2113863675;k[L>>2]=ma;p[Ba>>3]=1.0;sU(za,ta,va,49332,-1,40032,1,Ba);ma=(k[sa>>2]|0)+(f*56|0)|0;k[N>>2]=0;k[O>>2]=0;k[za>>2]=-2130640891;k[P>>2]=ma;Ga=1.0/+p[E>>3];p[ua>>3]=Ga;p[Q>>3]=Ga;p[R>>3]=Ga;p[S>>3]=Ga;k[ta>>2]=-1056833530;k[V>>2]=ua;k[T>>2]=1;k[U>>2]=4;la=X;k[la>>2]=0;k[la+4>>2]=0;k[va>>2]=-2113863675;k[W>>2]=ma;p[Ba>>3]=1.0;sU(za,ta,va,49332,-1,40032,1,Ba)}while((e|0)>1)}while(0);f=k[oa>>2]|0;k[Ba>>2]=k[f>>2];x=Ba+4|0;b=f+4|0;k[x>>2]=k[b>>2];z=Ba+8|0;k[z>>2]=k[f+8>>2];k[Ba+12>>2]=k[f+12>>2];u=Ba+16|0;k[u>>2]=k[f+16>>2];k[Ba+20>>2]=k[f+20>>2];k[Ba+24>>2]=k[f+24>>2];k[Ba+28>>2]=k[f+28>>2];t=Ba+32|0;k[t>>2]=k[f+32>>2];v=Ba+36|0;e=k[f+36>>2]|0;k[v>>2]=e;w=Ba+40|0;k[w>>2]=z;z=Ba+48|0;y=Ba+44|0;k[y>>2]=z;k[Ba+52>>2]=0;k[z>>2]=0;if(e|0){za=e+12|0;k[za>>2]=(k[za>>2]|0)+1}do if((k[b>>2]|0)<3){ya=k[f+44>>2]|0;za=k[y>>2]|0;k[za>>2]=k[ya>>2];k[za+4>>2]=k[ya+4>>2]}else{k[x>>2]=0;x1(Ba,k[b>>2]|0,0,0,0);if((k[x>>2]|0)<=0)break;g=k[f+40>>2]|0;h=k[w>>2]|0;e=k[f+44>>2]|0;f=k[y>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[g+(b<<2)>>2];k[f+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[x>>2]|0))}while(0);f=Ba+56|0;g=k[sa>>2]|0;k[f>>2]=k[g>>2];o=Ba+60|0;b=g+4|0;k[o>>2]=k[b>>2];s=Ba+64|0;k[s>>2]=k[g+8>>2];k[Ba+68>>2]=k[g+12>>2];m=Ba+72|0;k[m>>2]=k[g+16>>2];k[Ba+76>>2]=k[g+20>>2];k[Ba+80>>2]=k[g+24>>2];k[Ba+84>>2]=k[g+28>>2];l=Ba+88|0;k[l>>2]=k[g+32>>2];c=Ba+92|0;e=k[g+36>>2]|0;k[c>>2]=e;n=Ba+96|0;k[n>>2]=s;s=Ba+104|0;q=Ba+100|0;k[q>>2]=s;k[Ba+108>>2]=0;k[s>>2]=0;if(e|0){za=e+12|0;k[za>>2]=(k[za>>2]|0)+1}do if((k[b>>2]|0)<3){ya=k[g+44>>2]|0;za=k[q>>2]|0;k[za>>2]=k[ya>>2];k[za+4>>2]=k[ya+4>>2]}else{k[o>>2]=0;x1(f,k[b>>2]|0,0,0,0);if((k[o>>2]|0)<=0)break;h=k[g+40>>2]|0;j=k[n>>2]|0;e=k[g+44>>2]|0;f=k[q>>2]|0;b=0;do{k[j+(b<<2)>>2]=k[h+(b<<2)>>2];k[f+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[o>>2]|0))}while(0);GV(Ba,2,d);b=k[c>>2]|0;do if(b|0){d=b+12|0;Ba=k[d>>2]|0;k[d>>2]=Ba+-1;if((Ba|0)!=1)break;e=k[c>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[l>>2]|0;if(b|0)break;b=B1()|0;e=k[c>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[c>>2]=0}while(0);k[c>>2]=0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[o>>2]|0)>0){e=k[n>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[o>>2]|0))}b=k[q>>2]|0;if(!((b|0)==(s|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[v>>2]|0;do if(b|0){d=b+12|0;Ba=k[d>>2]|0;k[d>>2]=Ba+-1;if((Ba|0)!=1)break;e=k[v>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[t>>2]|0;if(b|0)break;b=B1()|0;e=k[v>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[v>>2]=0}while(0);k[v>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[x>>2]|0)>0){e=k[w>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[x>>2]|0))}b=k[y>>2]|0;if(!((b|0)==(z|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Da+36|0;b=k[f>>2]|0;do if(b|0){d=b+12|0;Ba=k[d>>2]|0;k[d>>2]=Ba+-1;if((Ba|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Da+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;Ba=Da+16|0;f=Da+4|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;if((k[f>>2]|0)>0){e=k[Aa>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[Da+44>>2]|0;if(!((b|0)==(Da+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Ea+36|0;b=k[f>>2]|0;do if(b|0){Ba=b+12|0;Da=k[Ba>>2]|0;k[Ba>>2]=Da+-1;if((Da|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Ea+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;Da=Ea+16|0;f=Ea+4|0;k[Da>>2]=0;k[Da+4>>2]=0;k[Da+8>>2]=0;k[Da+12>>2]=0;if((k[f>>2]|0)>0){e=k[Ca>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[Ea+44>>2]|0;if((b|0)==(Ea+48|0)|(b|0)==0){r=Fa;return}ggb(k[b+-4>>2]|0);r=Fa;return}function O6a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;f=k[a+84>>2]|0;g=a+88|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));f=k[a+96>>2]|0;g=a+100|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));f=k[a+108>>2]|0;g=a+112|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));f=k[a+120>>2]|0;g=a+124|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));d=a+180|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+176>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+160|0;c=a+148|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+184>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+236|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+232>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+216|0;c=a+204|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+240>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+292|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+288>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+272|0;c=a+260|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+296>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+348|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+344>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+328|0;c=a+316|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+352>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+404|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+400>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+384|0;c=a+372|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+408>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+460|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+456>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+440|0;c=a+428|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+464>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+516|0;b=k[d>>2]|0;if(b|0?(f=b+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+512>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;g=a+496|0;c=a+484|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+520>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+572|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+568>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+552|0;c=a+540|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+576>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+628|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+624>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+608|0;c=a+596|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+632>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+684|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+680>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+664|0;c=a+652|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+688>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+740|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+736>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+720|0;c=a+708|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+744>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+852|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+848>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+832|0;c=a+820|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+856>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+908|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+904>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+888|0;c=a+876|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+912>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+964|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+960>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+944|0;c=a+932|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+968>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+1020|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1016>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+1e3|0;c=a+988|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1024>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+1188|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1184>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+1168|0;c=a+1156|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1192>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+1244|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1240>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+1224|0;c=a+1212|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1248>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+1356|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1352>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+1336|0;c=a+1324|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1360>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+1412|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1408>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+1392|0;c=a+1380|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1416>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+1468|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1464>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+1448|0;c=a+1436|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+1472>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+1524|0;b=k[d>>2]|0;do if(b|0){f=b+12|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+1520>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;g=a+1504|0;d=a+1492|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[d>>2]|0)<=0)return;c=k[a+1528>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0));return}function P6a(a){a=a|0;return +(+p[a+8>>3])}function Q6a(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function R6a(a){a=a|0;return +(+p[a+16>>3])}function S6a(a,b){a=a|0;b=+b;p[a+16>>3]=b;return}function T6a(a){a=a|0;return +(+p[a+24>>3])}function U6a(a,b){a=a|0;b=+b;p[a+24>>3]=b;return}function V6a(a){a=a|0;return +(+p[a+32>>3])}function W6a(a,b){a=a|0;b=+b;p[a+32>>3]=b;return}function X6a(a){a=a|0;return k[a+40>>2]|0}function Y6a(a,b){a=a|0;b=b|0;k[a+40>>2]=b;return}function Z6a(a){a=a|0;return k[a+44>>2]|0}function _6a(a,b){a=a|0;b=b|0;k[a+44>>2]=b;return}function $6a(a){a=a|0;return +(+p[a+48>>3])}function a7a(a,b){a=a|0;b=+b;p[a+48>>3]=b;return}function b7a(a){a=a|0;return k[a+56>>2]|0}function c7a(a,b){a=a|0;b=b|0;k[a+56>>2]=b;return}function d7a(a){a=a|0;return k[a+60>>2]|0}function e7a(a,b){a=a|0;b=b|0;k[a+60>>2]=b;return}function f7a(a){a=a|0;return (i[a+64>>0]|0)!=0|0}function g7a(a,b){a=a|0;b=b|0;i[a+64>>0]=b&1;return}function h7a(a){a=a|0;return +(+p[a+72>>3])}function i7a(a,b){a=a|0;b=+b;p[a+72>>3]=b;return}function j7a(a){a=a|0;return k[a+80>>2]|0}function k7a(a,b){a=a|0;b=b|0;k[a+80>>2]=b;return}function l7a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+32|0;s=u;t=a+4|0;e=k[t>>2]|0;g=k[a>>2]|0;h=(e-g|0)/56|0;d=g;c=e;if(h>>>0>=b>>>0){if(h>>>0<=b>>>0){r=u;return}g=d+(b*56|0)|0;if((c|0)==(g|0)){r=u;return}else f=c;do{k[t>>2]=f+-56;e=f+-20|0;c=k[e>>2]|0;if(c|0?(a=c+12|0,s=k[a>>2]|0,k[a>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[f+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=f+-40|0;d=f+-52|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[d>>2]|0)>0){e=k[f+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[f+-12>>2]|0;if(!((c|0)==(f+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=k[t>>2]|0}while((f|0)!=(g|0));r=u;return}f=b-h|0;q=a+8|0;d=k[q>>2]|0;if(((d-e|0)/56|0)>>>0>=f>>>0){do{d=c+8|0;e=c+40|0;i=c+4|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[e>>2]=d;s=c+48|0;k[c+44>>2]=s;k[c+52>>2]=0;k[s>>2]=0;k[c>>2]=1124007941;c=(k[t>>2]|0)+56|0;k[t>>2]=c;f=f+-1|0}while((f|0)!=0);r=u;return}if(b>>>0>76695844)ad(426534,426557,304,426811);p=(d-g|0)/56|0;g=p<<1;g=p>>>0<38347922?(g>>>0<b>>>0?b:g):76695844;k[s+12>>2]=0;k[s+16>>2]=a+8;if(!g)c=0;else{if(g>>>0>76695844){u=te(4)|0;k[u>>2]=172664;Cf(u|0,28816,1287)}d=g*56|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}k[s>>2]=c;e=c+(h*56|0)|0;n=s+8|0;k[n>>2]=e;o=s+4|0;k[o>>2]=e;p=s+12|0;k[p>>2]=c+(g*56|0);d=e;while(1){g=d+8|0;h=d+40|0;i=d+4|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[h>>2]=g;m=d+48|0;k[d+44>>2]=m;k[d+52>>2]=0;k[m>>2]=0;k[d>>2]=1124007941;f=f+-1|0;if(!f)break;else d=d+56|0}k[n>>2]=c+(b*56|0);d=k[a>>2]|0;c=k[t>>2]|0;if((c|0)!=(d|0)){do{f=e+-56|0;b=c;c=c+-56|0;k[f>>2]=k[c>>2];m=e+-52|0;g=b+-52|0;k[m>>2]=k[g>>2];i=e+-48|0;k[i>>2]=k[b+-48>>2];k[e+-44>>2]=k[b+-44>>2];k[e+-40>>2]=k[b+-40>>2];k[e+-36>>2]=k[b+-36>>2];k[e+-32>>2]=k[b+-32>>2];k[e+-28>>2]=k[b+-28>>2];k[e+-24>>2]=k[b+-24>>2];h=k[b+-20>>2]|0;k[e+-20>>2]=h;j=e+-16|0;k[j>>2]=i;i=e+-8|0;l=e+-12|0;k[l>>2]=i;k[e+-4>>2]=0;k[i>>2]=0;if(h|0){i=h+12|0;k[i>>2]=(k[i>>2]|0)+1}if((k[g>>2]|0)>=3){k[m>>2]=0;x1(f,k[g>>2]|0,0,0,0);if((k[m>>2]|0)>0){i=k[b+-16>>2]|0;h=k[j>>2]|0;g=k[b+-12>>2]|0;f=k[l>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[i+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else{b=k[b+-12>>2]|0;m=k[l>>2]|0;k[m>>2]=k[b>>2];k[m+4>>2]=k[b+4>>2]}e=(k[o>>2]|0)+-56|0;k[o>>2]=e}while((c|0)!=(d|0));d=k[a>>2]|0;c=k[t>>2]|0}k[a>>2]=e;k[o>>2]=d;k[t>>2]=k[n>>2];k[n>>2]=c;t=k[q>>2]|0;k[q>>2]=k[p>>2];k[p>>2]=t;k[s>>2]=k[o>>2];K7a(s);r=u;return}function m7a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0.0,Od=0.0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0.0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,kh=0.0,lh=0.0,mh=0.0,nh=0.0,oh=0,ph=0,qh=0;ih=r;r=r+2304|0;Hg=ih+1608|0;Ig=ih+32|0;hh=ih+1552|0;gh=ih+1496|0;fh=ih+1440|0;eh=ih+1384|0;dh=ih+1328|0;ch=ih+1272|0;bh=ih+1216|0;ah=ih+1160|0;$g=ih+1104|0;_g=ih+1048|0;Zg=ih+992|0;Yg=ih+936|0;Xg=ih+880|0;Wg=ih+824|0;Vg=ih+768|0;Ug=ih+712|0;Tg=ih+656|0;Sg=ih+600|0;Rg=ih+544|0;Qg=ih+488|0;Pg=ih+432|0;Og=ih+376|0;Ng=ih+320|0;Mg=ih+264|0;Lg=ih+208|0;Kg=ih+152|0;Jg=ih+96|0;Cg=ih+80|0;Dg=ih+64|0;Eg=ih;Fg=+p[a+48>>3];A=k[b+40>>2]|0;Fg=Fg*Fg*+(aa(k[A>>2]|0,k[A+4>>2]|0)|0);A=b+12|0;x=k[A>>2]|0;Gg=b+8|0;y=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=x;k[Hg+12>>2]=y;I1(hh,a+144|0,Hg);y=k[A>>2]|0;x=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=y;k[Hg+12>>2]=x;I1(gh,a+200|0,Hg);x=k[c+8>>2]|0;y=x+-1|0;w=k[c+12>>2]|0;z=w+-1|0;k[Hg>>2]=152248;g=Hg+4|0;h=Hg+12|0;j=Hg+44|0;l=Hg+8|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[j>>2]=h;h=Hg+52|0;k[Hg+48>>2]=h;k[Hg+56>>2]=0;k[h>>2]=0;k[g>>2]=1124007941;g=Hg+60|0;h=Hg+68|0;j=Hg+100|0;l=Hg+64|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[j>>2]=h;h=Hg+108|0;k[Hg+104>>2]=h;k[Hg+112>>2]=0;k[h>>2]=0;k[g>>2]=1124007941;g=Hg+116|0;h=Hg+124|0;j=Hg+156|0;l=Hg+120|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[j>>2]=h;Bg=Hg+164|0;k[Hg+160>>2]=Bg;k[Hg+168>>2]=0;k[Bg>>2]=0;k[g>>2]=1124007941;KG(Hg+4|0,c)|0;KG(Hg+60|0,hh)|0;KG(Hg+116|0,gh)|0;k[Ig>>2]=1;k[Ig+4>>2]=y;jh[k[(k[Hg>>2]|0)+8>>2]&1023](Hg,Ig);n7a(Hg);g=c+16|0;if((z|0)>1){u=k[g>>2]|0;g=c+44|0;j=k[hh+16>>2]|0;s=k[k[g>>2]>>2]|0;l=u+s|0;m=k[gh+16>>2]|0;n=u+(aa(s,y)|0)|0;q=j+(aa(k[k[hh+44>>2]>>2]|0,y)|0)|0;s=u+(aa(s,x+-2|0)|0)|0;t=m+(aa(k[k[gh+44>>2]>>2]|0,y)|0)|0;h=1;do{Bg=h;h=h+1|0;Ag=Bg+-1|0;o[j+(Bg<<2)>>2]=(+o[u+(h<<2)>>2]-+o[u+(Ag<<2)>>2])*.5;o[m+(Bg<<2)>>2]=(+o[l+(Bg<<2)>>2]-+o[u+(Bg<<2)>>2])*.5;o[q+(Bg<<2)>>2]=(+o[n+(h<<2)>>2]-+o[n+(Ag<<2)>>2])*.5;o[t+(Bg<<2)>>2]=(+o[n+(Bg<<2)>>2]-+o[s+(Bg<<2)>>2])*.5}while((h|0)!=(z|0));v=u}else{u=k[g>>2]|0;g=c+44|0;v=u}if((y|0)>1){l=k[k[g>>2]>>2]|0;m=k[hh+16>>2]|0;n=k[k[hh+44>>2]>>2]|0;t=k[gh+16>>2]|0;j=k[k[gh+44>>2]>>2]|0;h=w+-2|0;g=1;do{xg=v+(aa(g,l)|0)|0;yg=m+(aa(g,n)|0)|0;o[yg>>2]=(+o[xg+4>>2]-+o[xg>>2])*.5;Bg=g;g=g+1|0;zg=v+(aa(g,l)|0)|0;Ag=v+(aa(Bg+-1|0,l)|0)|0;Bg=t+(aa(Bg,j)|0)|0;o[Bg>>2]=(+o[zg>>2]-+o[Ag>>2])*.5;o[yg+(z<<2)>>2]=(+o[xg+(z<<2)>>2]-+o[xg+(h<<2)>>2])*.5;o[Bg+(z<<2)>>2]=(+o[zg+(z<<2)>>2]-+o[Ag+(z<<2)>>2])*.5}while((g|0)!=(y|0));s=m;q=t;g=t}else{m=k[hh+16>>2]|0;Bg=k[gh+16>>2]|0;h=w+-2|0;s=m;l=k[k[g>>2]>>2]|0;q=Bg;n=k[k[hh+44>>2]>>2]|0;j=k[k[gh+44>>2]>>2]|0;g=Bg}o[s>>2]=(+o[v+4>>2]-+o[v>>2])*.5;xg=v+l|0;o[q>>2]=(+o[xg>>2]-+o[v>>2])*.5;o[s+(z<<2)>>2]=(+o[u+(z<<2)>>2]-+o[u+(h<<2)>>2])*.5;o[q+(z<<2)>>2]=(+o[xg+(z<<2)>>2]-+o[v+(z<<2)>>2])*.5;xg=v+(aa(l,y)|0)|0;yg=m+(aa(n,y)|0)|0;o[yg>>2]=(+o[xg+4>>2]-+o[xg>>2])*.5;Bg=v+(aa(l,x+-2|0)|0)|0;Ag=aa(j,y)|0;o[g+Ag>>2]=(+o[xg>>2]-+o[Bg>>2])*.5;zg=xg+(z<<2)|0;o[yg+(z<<2)>>2]=(+o[zg>>2]-+o[xg+(h<<2)>>2])*.5;o[g+Ag+(z<<2)>>2]=(+o[zg>>2]-+o[Bg+(z<<2)>>2])*.5;Ag=k[A>>2]|0;Bg=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Ag;k[Hg+12>>2]=Bg;I1(fh,a+256|0,Hg);Bg=k[A>>2]|0;Ag=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Bg;k[Hg+12>>2]=Ag;I1(eh,a+312|0,Hg);Ag=k[A>>2]|0;Bg=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Ag;k[Hg+12>>2]=Bg;I1(dh,a+368|0,Hg);Bg=k[A>>2]|0;Ag=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Bg;k[Hg+12>>2]=Ag;I1(ch,a+424|0,Hg);Ag=k[A>>2]|0;Bg=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Ag;k[Hg+12>>2]=Bg;I1(bh,a+480|0,Hg);Bg=k[A>>2]|0;Ag=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Bg;k[Hg+12>>2]=Ag;I1(ah,a+536|0,Hg);Ag=k[A>>2]|0;Bg=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Ag;k[Hg+12>>2]=Bg;I1($g,a+592|0,Hg);Bg=k[A>>2]|0;Ag=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Bg;k[Hg+12>>2]=Ag;I1(_g,a+648|0,Hg);Ag=k[A>>2]|0;Bg=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Ag;k[Hg+12>>2]=Bg;I1(Zg,a+704|0,Hg);Bg=k[A>>2]|0;Ag=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Bg;k[Hg+12>>2]=Ag;I1(Yg,a+760|0,Hg);Ag=k[A>>2]|0;Bg=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Ag;k[Hg+12>>2]=Bg;I1(Xg,a+816|0,Hg);Bg=k[A>>2]|0;Ag=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Bg;k[Hg+12>>2]=Ag;I1(Wg,a+872|0,Hg);Ag=k[A>>2]|0;Bg=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Ag;k[Hg+12>>2]=Bg;I1(Vg,a+928|0,Hg);Bg=k[A>>2]|0;Ag=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Bg;k[Hg+12>>2]=Ag;I1(Ug,a+984|0,Hg);Ag=k[A>>2]|0;Bg=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Ag;k[Hg+12>>2]=Bg;I1(Tg,a+1040|0,Hg);Bg=k[A>>2]|0;Ag=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Bg;k[Hg+12>>2]=Ag;I1(Sg,a+1096|0,Hg);k[Ig>>2]=0;k[Ig+4>>2]=0;k[Ig+8>>2]=0;k[Ig+12>>2]=0;k[Ig+16>>2]=0;k[Ig+20>>2]=0;k[Ig+24>>2]=0;k[Ig+28>>2]=0;k[Hg>>2]=-1056833530;k[Hg+4>>2]=Ig;k[Hg+8>>2]=1;k[Hg+12>>2]=4;pY(Xg,Hg,49332);k[Ig>>2]=0;k[Ig+4>>2]=0;k[Ig+8>>2]=0;k[Ig+12>>2]=0;k[Ig+16>>2]=0;k[Ig+20>>2]=0;k[Ig+24>>2]=0;k[Ig+28>>2]=0;k[Hg>>2]=-1056833530;k[Hg+4>>2]=Ig;k[Hg+8>>2]=1;k[Hg+12>>2]=4;pY(Wg,Hg,49332);k[Ig>>2]=0;k[Ig+4>>2]=0;k[Ig+8>>2]=0;k[Ig+12>>2]=0;k[Ig+16>>2]=0;k[Ig+20>>2]=0;k[Ig+24>>2]=0;k[Ig+28>>2]=0;k[Hg>>2]=-1056833530;k[Hg+4>>2]=Ig;k[Hg+8>>2]=1;k[Hg+12>>2]=4;pY(Vg,Hg,49332);k[Ig>>2]=0;k[Ig+4>>2]=0;k[Ig+8>>2]=0;k[Ig+12>>2]=0;k[Ig+16>>2]=0;k[Ig+20>>2]=0;k[Ig+24>>2]=0;k[Ig+28>>2]=0;k[Hg>>2]=-1056833530;k[Hg+4>>2]=Ig;k[Hg+8>>2]=1;k[Hg+12>>2]=4;pY(Ug,Hg,49332);Ag=a+32|0;Bg=+p[Ag>>3]!=0.0;if(Bg){k[Ig>>2]=0;k[Ig+4>>2]=0;k[Ig+8>>2]=0;k[Ig+12>>2]=0;k[Ig+16>>2]=0;k[Ig+20>>2]=0;k[Ig+24>>2]=0;k[Ig+28>>2]=0;k[Hg>>2]=-1056833530;k[Hg+4>>2]=Ig;k[Hg+8>>2]=1;k[Hg+12>>2]=4;pY(Tg,Hg,49332);k[Ig>>2]=0;k[Ig+4>>2]=0;k[Ig+8>>2]=0;k[Ig+12>>2]=0;k[Ig+16>>2]=0;k[Ig+20>>2]=0;k[Ig+24>>2]=0;k[Ig+28>>2]=0;k[Hg>>2]=-1056833530;k[Hg+4>>2]=Ig;k[Hg+8>>2]=1;k[Hg+12>>2]=4;pY(Sg,Hg,49332)}Pd=k[A>>2]|0;Md=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Pd;k[Hg+12>>2]=Md;I1(Rg,a+1152|0,Hg);Md=k[A>>2]|0;Pd=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Md;k[Hg+12>>2]=Pd;I1(Qg,a+1208|0,Hg);Pd=k[A>>2]|0;Md=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Pd;k[Hg+12>>2]=Md;I1(Pg,a+1264|0,Hg);Md=k[A>>2]|0;Pd=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Md;k[Hg+12>>2]=Pd;I1(Og,a+1320|0,Hg);Pd=k[A>>2]|0;Md=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Pd;k[Hg+12>>2]=Md;I1(Ng,a+1376|0,Hg);Md=k[A>>2]|0;Pd=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Md;k[Hg+12>>2]=Pd;I1(Mg,a+1432|0,Hg);Pd=k[A>>2]|0;Md=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Pd;k[Hg+12>>2]=Md;I1(Lg,a+1488|0,Hg);Md=k[A>>2]|0;Pd=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Md;k[Hg+12>>2]=Pd;I1(Kg,a+1544|0,Hg);Pd=k[A>>2]|0;Md=k[Gg>>2]|0;k[Hg>>2]=0;k[Hg+4>>2]=0;k[Hg+8>>2]=Pd;k[Hg+12>>2]=Md;I1(Jg,a+1600|0,Hg);Md=a+24|0;Od=+p[Md>>3];Nd=+p[a+16>>3]*Od;Od=+p[a+8>>3]/Od;Pd=a+44|0;if((k[Pd>>2]|0)>0){Qd=Hg+4|0;Rd=Hg+8|0;Sd=Hg+12|0;Td=Hg+44|0;Ud=Hg+52|0;Vd=Hg+48|0;Wd=Hg+56|0;Xd=Hg+60|0;Yd=Hg+64|0;Zd=Hg+68|0;_d=Hg+100|0;$d=Hg+108|0;ae=Hg+104|0;be=Hg+112|0;ce=Hg+116|0;de=Hg+120|0;ee=Hg+124|0;fe=Hg+156|0;ge=Hg+164|0;he=Hg+160|0;ie=Hg+168|0;je=Hg+172|0;ke=Hg+176|0;le=Hg+180|0;me=Hg+212|0;ne=Hg+220|0;oe=Hg+216|0;pe=Hg+224|0;qe=Hg+4|0;re=Hg+60|0;se=Hg+116|0;te=Hg+172|0;ue=d+8|0;ve=Ig+4|0;we=Hg+8|0;xe=Hg+12|0;ye=Hg+4|0;ze=Ig+4|0;Ae=ze+4|0;Be=Cg+8|0;Ce=Cg+12|0;De=Cg+4|0;Ee=Dg+8|0;Fe=Dg+12|0;Ge=Dg+4|0;He=Hg+8|0;Ie=Hg+12|0;Je=Hg+4|0;Ke=Ig+4|0;Le=Ke+4|0;Me=Cg+8|0;Ne=Cg+12|0;Oe=Cg+4|0;Pe=Dg+8|0;Qe=Dg+12|0;Re=Dg+4|0;Se=Hg+8|0;Te=Hg+12|0;Ue=Hg+4|0;Ve=Ig+4|0;We=Ve+4|0;Xe=Cg+8|0;Ye=Cg+12|0;Ze=Cg+4|0;_e=Dg+8|0;$e=Dg+12|0;af=Dg+4|0;bf=Hg+4|0;cf=Hg+8|0;df=Hg+12|0;ef=Hg+44|0;ff=Hg+52|0;gf=Hg+48|0;hf=Hg+56|0;jf=Hg+60|0;kf=Hg+64|0;lf=Hg+68|0;mf=Hg+100|0;nf=Hg+108|0;of=Hg+104|0;pf=Hg+112|0;qf=Hg+116|0;rf=Hg+120|0;sf=Hg+124|0;tf=Hg+156|0;uf=Hg+164|0;vf=Hg+160|0;wf=Hg+168|0;xf=Hg+172|0;yf=Hg+176|0;zf=Hg+180|0;Af=Hg+212|0;Bf=Hg+220|0;Cf=Hg+216|0;Df=Hg+224|0;Ef=Hg+228|0;Ff=Hg+232|0;Gf=Hg+236|0;Hf=Hg+268|0;If=Hg+276|0;Jf=Hg+272|0;Kf=Hg+280|0;Lf=Hg+284|0;Mf=Hg+288|0;Nf=Hg+292|0;Of=Hg+324|0;Pf=Hg+332|0;Qf=Hg+328|0;Rf=Hg+336|0;Sf=Hg+340|0;Tf=Hg+344|0;Uf=Hg+348|0;Vf=Hg+380|0;Wf=Hg+388|0;Xf=Hg+384|0;Yf=Hg+392|0;Zf=Hg+396|0;_f=Hg+400|0;$f=Hg+404|0;ag=Hg+436|0;bg=Hg+444|0;cg=Hg+440|0;dg=Hg+448|0;eg=Hg+4|0;fg=Hg+60|0;gg=Hg+116|0;hg=Hg+172|0;ig=Hg+228|0;jg=Hg+284|0;kg=Hg+340|0;lg=Hg+396|0;mg=Ig+4|0;ng=Fg<3402823466385288598117041.0e14;og=a+60|0;pg=a+80|0;qg=Hg+8|0;rg=Hg+12|0;sg=Hg+4|0;tg=Ig+4|0;ug=tg+4|0;vg=Hg+8|0;wg=Hg+12|0;xg=Hg+4|0;yg=Ig+4|0;zg=yg+4|0;ka=a+56|0;la=Hg+4|0;ma=Hg+8|0;na=Hg+12|0;oa=Hg+44|0;pa=Hg+52|0;qa=Hg+48|0;ra=Hg+56|0;sa=Hg+60|0;ta=Hg+64|0;ua=Hg+68|0;va=Hg+100|0;wa=Hg+108|0;xa=Hg+104|0;ya=Hg+112|0;za=Hg+116|0;Aa=Hg+120|0;Ba=Hg+124|0;Ca=Hg+156|0;Da=Hg+164|0;Ea=Hg+160|0;Fa=Hg+168|0;Ga=Hg+172|0;Ha=Hg+176|0;Ia=Hg+180|0;Ja=Hg+212|0;Ka=Hg+220|0;La=Hg+216|0;Ma=Hg+224|0;Na=Hg+228|0;Oa=Hg+232|0;Pa=Hg+236|0;Qa=Hg+268|0;Ra=Hg+276|0;Sa=Hg+272|0;Ta=Hg+280|0;Ua=Hg+284|0;Va=Hg+288|0;Wa=Hg+292|0;Xa=Hg+324|0;Ya=Hg+332|0;Za=Hg+328|0;_a=Hg+336|0;$a=Hg+340|0;ab=Hg+344|0;bb=Hg+348|0;cb=Hg+380|0;db=Hg+388|0;eb=Hg+384|0;fb=Hg+392|0;gb=Hg+396|0;hb=Hg+400|0;ib=Hg+404|0;jb=Hg+436|0;kb=Hg+444|0;lb=Hg+440|0;mb=Hg+448|0;nb=Hg+452|0;ob=Hg+456|0;pb=Hg+460|0;qb=Hg+492|0;rb=Hg+500|0;sb=Hg+496|0;tb=Hg+504|0;ub=Hg+508|0;vb=Hg+512|0;wb=Hg+516|0;xb=Hg+548|0;yb=Hg+556|0;zb=Hg+552|0;Ab=Hg+560|0;Bb=Hg+4|0;Cb=Hg+60|0;Db=Hg+116|0;Eb=Hg+172|0;Fb=Hg+228|0;Gb=Hg+284|0;Hb=Hg+340|0;Ib=Hg+396|0;Jb=Hg+452|0;Kb=Hg+508|0;Lb=Hg+564|0;Mb=Hg+568|0;Nb=ch+8|0;Ob=Ig+4|0;V=Zg+16|0;X=Yg+16|0;Y=Yg+44|0;Z=Rg+16|0;$=Qg+16|0;ca=Pg+16|0;da=Pg+44|0;ea=d+16|0;ga=e+16|0;ia=f+16|0;ja=f+44|0;Pb=_g+8|0;ha=e+44|0;fa=d+44|0;ba=Qg+44|0;_=Rg+44|0;W=Zg+44|0;Qb=_g+16|0;Rb=_g+44|0;Sb=_g+12|0;Tb=Hg+4|0;Ub=Hg+8|0;Vb=Hg+12|0;Wb=Hg+44|0;Xb=Hg+52|0;Yb=Hg+48|0;Zb=Hg+56|0;_b=Hg+60|0;$b=Hg+64|0;ac=Hg+68|0;bc=Hg+100|0;cc=Hg+108|0;dc=Hg+104|0;ec=Hg+112|0;fc=Hg+116|0;gc=Hg+120|0;hc=Hg+124|0;ic=Hg+156|0;jc=Hg+164|0;kc=Hg+160|0;lc=Hg+168|0;mc=Hg+172|0;nc=Hg+176|0;oc=Hg+180|0;pc=Hg+212|0;qc=Hg+220|0;rc=Hg+216|0;sc=Hg+224|0;tc=Hg+228|0;uc=Hg+232|0;vc=Hg+236|0;wc=Hg+268|0;xc=Hg+276|0;yc=Hg+272|0;zc=Hg+280|0;Ac=Hg+284|0;Bc=Hg+288|0;Cc=Hg+292|0;Dc=Hg+324|0;Ec=Hg+332|0;Fc=Hg+328|0;Gc=Hg+336|0;Hc=Hg+340|0;Ic=Hg+344|0;Jc=Hg+348|0;Kc=Hg+380|0;Lc=Hg+388|0;Mc=Hg+384|0;Nc=Hg+392|0;Oc=Hg+396|0;Pc=Hg+400|0;Qc=Hg+404|0;Rc=Hg+436|0;Sc=Hg+444|0;Tc=Hg+440|0;Uc=Hg+448|0;Vc=Hg+452|0;Wc=Hg+456|0;Xc=Hg+460|0;Yc=Hg+492|0;Zc=Hg+500|0;_c=Hg+496|0;$c=Hg+504|0;ad=Hg+508|0;bd=Hg+512|0;cd=Hg+516|0;dd=Hg+548|0;ed=Hg+556|0;fd=Hg+552|0;gd=Hg+560|0;hd=Hg+564|0;id=Hg+568|0;jd=Hg+572|0;kd=Hg+604|0;ld=Hg+612|0;md=Hg+608|0;nd=Hg+616|0;od=Hg+620|0;pd=Hg+624|0;qd=Hg+628|0;rd=Hg+660|0;sd=Hg+668|0;td=Hg+664|0;ud=Hg+672|0;vd=Hg+4|0;wd=Hg+60|0;xd=Hg+116|0;yd=Hg+172|0;zd=Hg+228|0;Ad=Hg+284|0;Bd=Hg+340|0;Cd=Hg+396|0;Dd=Hg+452|0;Ed=Hg+508|0;Fd=Hg+564|0;Gd=Hg+620|0;Hd=Hg+676|0;Id=Hg+680|0;Jd=Bg&1;Kd=Og+8|0;Ld=Ig+4|0;U=0;do{k[Hg>>2]=152268;l=Rd;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Td>>2]=Sd;k[Vd>>2]=Ud;k[Wd>>2]=0;k[Ud>>2]=0;k[Qd>>2]=1124007941;l=Yd;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[_d>>2]=Zd;k[ae>>2]=$d;k[be>>2]=0;k[$d>>2]=0;k[Xd>>2]=1124007941;l=de;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[fe>>2]=ee;k[he>>2]=ge;k[ie>>2]=0;k[ge>>2]=0;k[ce>>2]=1124007941;l=ke;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[me>>2]=le;k[oe>>2]=ne;k[pe>>2]=0;k[ne>>2]=0;k[je>>2]=1124007941;KG(qe,d)|0;KG(re,e)|0;KG(se,fh)|0;KG(te,eh)|0;l=k[ue>>2]|0;k[Ig>>2]=0;k[ve>>2]=l;jh[k[(k[Hg>>2]|0)+8>>2]&1023](Hg,Ig);o7a(Hg);k[we>>2]=0;k[xe>>2]=0;k[Hg>>2]=-2130640891;k[ye>>2]=c;l=Ae;k[l>>2]=0;k[l+4>>2]=0;k[Ig>>2]=-2113863675;k[ze>>2]=dh;k[Be>>2]=0;k[Ce>>2]=0;k[Cg>>2]=-2130640891;k[De>>2]=fh;k[Ee>>2]=0;k[Fe>>2]=0;k[Dg>>2]=-2130640891;k[Ge>>2]=eh;k[Eg>>2]=0;k[Eg+4>>2]=0;k[Eg+8>>2]=0;k[Eg+12>>2]=0;k[Eg+16>>2]=0;k[Eg+20>>2]=0;k[Eg+24>>2]=0;k[Eg+28>>2]=0;Jna(Hg,Ig,Cg,Dg,2,0,Eg);k[He>>2]=0;k[Ie>>2]=0;k[Hg>>2]=-2130640891;k[Je>>2]=hh;l=Le;k[l>>2]=0;k[l+4>>2]=0;k[Ig>>2]=-2113863675;k[Ke>>2]=ch;k[Me>>2]=0;k[Ne>>2]=0;k[Cg>>2]=-2130640891;k[Oe>>2]=fh;k[Pe>>2]=0;k[Qe>>2]=0;k[Dg>>2]=-2130640891;k[Re>>2]=eh;k[Eg>>2]=0;k[Eg+4>>2]=0;k[Eg+8>>2]=0;k[Eg+12>>2]=0;k[Eg+16>>2]=0;k[Eg+20>>2]=0;k[Eg+24>>2]=0;k[Eg+28>>2]=0;Jna(Hg,Ig,Cg,Dg,2,0,Eg);k[Se>>2]=0;k[Te>>2]=0;k[Hg>>2]=-2130640891;k[Ue>>2]=gh;l=We;k[l>>2]=0;k[l+4>>2]=0;k[Ig>>2]=-2113863675;k[Ve>>2]=bh;k[Xe>>2]=0;k[Ye>>2]=0;k[Cg>>2]=-2130640891;k[Ze>>2]=fh;k[_e>>2]=0;k[$e>>2]=0;k[Dg>>2]=-2130640891;k[af>>2]=eh;k[Eg>>2]=0;k[Eg+4>>2]=0;k[Eg+8>>2]=0;k[Eg+12>>2]=0;k[Eg+16>>2]=0;k[Eg+20>>2]=0;k[Eg+24>>2]=0;k[Eg+28>>2]=0;Jna(Hg,Ig,Cg,Dg,2,0,Eg);k[Hg>>2]=152288;l=cf;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[ef>>2]=df;k[gf>>2]=ff;k[hf>>2]=0;k[ff>>2]=0;k[bf>>2]=1124007941;l=kf;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[mf>>2]=lf;k[of>>2]=nf;k[pf>>2]=0;k[nf>>2]=0;k[jf>>2]=1124007941;l=rf;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[tf>>2]=sf;k[vf>>2]=uf;k[wf>>2]=0;k[uf>>2]=0;k[qf>>2]=1124007941;l=yf;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Af>>2]=zf;k[Cf>>2]=Bf;k[Df>>2]=0;k[Bf>>2]=0;k[xf>>2]=1124007941;l=Ff;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Hf>>2]=Gf;k[Jf>>2]=If;k[Kf>>2]=0;k[If>>2]=0;k[Ef>>2]=1124007941;l=Mf;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Of>>2]=Nf;k[Qf>>2]=Pf;k[Rf>>2]=0;k[Pf>>2]=0;k[Lf>>2]=1124007941;l=Tf;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Vf>>2]=Uf;k[Xf>>2]=Wf;k[Yf>>2]=0;k[Wf>>2]=0;k[Sf>>2]=1124007941;l=_f;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[ag>>2]=$f;k[cg>>2]=bg;k[dg>>2]=0;k[bg>>2]=0;k[Zf>>2]=1124007941;KG(eg,b)|0;KG(fg,dh)|0;KG(gg,ch)|0;KG(hg,bh)|0;KG(ig,d)|0;KG(jg,e)|0;KG(kg,ah)|0;KG(lg,$g)|0;T=k[Gg>>2]|0;k[Ig>>2]=0;k[mg>>2]=T;jh[k[(k[Hg>>2]|0)+8>>2]&1023](Hg,Ig);p7a(Hg);a:do if(ng){T=0;B=3402823466385288598117041.0e14;while(1){if((T|0)>=(k[og>>2]|0))break a;g=k[pg>>2]|0;if((g|0)>1){k[qg>>2]=0;k[rg>>2]=0;k[Hg>>2]=-2130640891;k[sg>>2]=d;S=ug;k[S>>2]=0;k[S+4>>2]=0;k[Ig>>2]=-2113863675;k[tg>>2]=d;vua(Hg,Ig,g);k[vg>>2]=0;k[wg>>2]=0;k[Hg>>2]=-2130640891;k[xg>>2]=e;S=zg;k[S>>2]=0;k[S+4>>2]=0;k[Ig>>2]=-2113863675;k[yg>>2]=e;vua(Hg,Ig,k[pg>>2]|0)}b:do if(B>Fg){S=0;while(1){if((S|0)>=(k[ka>>2]|0))break b;B=+p[Ag>>3];k[Hg>>2]=152308;l=ma;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[oa>>2]=na;k[qa>>2]=pa;k[ra>>2]=0;k[pa>>2]=0;k[la>>2]=1124007941;l=ta;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[va>>2]=ua;k[xa>>2]=wa;k[ya>>2]=0;k[wa>>2]=0;k[sa>>2]=1124007941;l=Aa;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Ca>>2]=Ba;k[Ea>>2]=Da;k[Fa>>2]=0;k[Da>>2]=0;k[za>>2]=1124007941;l=Ha;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Ja>>2]=Ia;k[La>>2]=Ka;k[Ma>>2]=0;k[Ka>>2]=0;k[Ga>>2]=1124007941;l=Oa;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Qa>>2]=Pa;k[Sa>>2]=Ra;k[Ta>>2]=0;k[Ra>>2]=0;k[Na>>2]=1124007941;l=Va;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Xa>>2]=Wa;k[Za>>2]=Ya;k[_a>>2]=0;k[Ya>>2]=0;k[Ua>>2]=1124007941;l=ab;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[cb>>2]=bb;k[eb>>2]=db;k[fb>>2]=0;k[db>>2]=0;k[$a>>2]=1124007941;l=hb;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[jb>>2]=ib;k[lb>>2]=kb;k[mb>>2]=0;k[kb>>2]=0;k[gb>>2]=1124007941;l=ob;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[qb>>2]=pb;k[sb>>2]=rb;k[tb>>2]=0;k[rb>>2]=0;k[nb>>2]=1124007941;l=vb;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[xb>>2]=wb;k[zb>>2]=yb;k[Ab>>2]=0;k[yb>>2]=0;k[ub>>2]=1124007941;KG(Bb,ch)|0;KG(Cb,bh)|0;KG(Db,d)|0;KG(Eb,e)|0;if(B!=0.0){KG(Fb,f)|0;KG(Gb,ah)|0;KG(Hb,$g)|0;KG(Ib,_g)|0;KG(Jb,Zg)|0;KG(Kb,Yg)|0}else{KG(Gb,ah)|0;KG(Hb,$g)|0;KG(Ib,_g)|0;KG(Jb,Zg)|0}o[Lb>>2]=Nd;o[Mb>>2]=B;R=k[Nb>>2]|0;k[Ig>>2]=0;k[Ob>>2]=R;jh[k[(k[Hg>>2]|0)+8>>2]&1023](Hg,Ig);q7a(Hg);r7a(Xg,Wg,Rg);r7a(Vg,Ug,Qg);if(Bg)r7a(Tg,Sg,Pg);L=+p[Md>>3];C=k[V>>2]|0;z=k[X>>2]|0;g=k[Y>>2]|0;D=k[Z>>2]|0;E=k[$>>2]|0;A=k[ca>>2]|0;h=k[da>>2]|0;F=k[ea>>2]|0;G=k[ga>>2]|0;a=k[ia>>2]|0;j=k[ja>>2]|0;M=k[Pb>>2]|0;c:do if((M|0)>0){N=k[Qb>>2]|0;O=k[k[Rb>>2]>>2]|0;P=k[k[W>>2]>>2]|0;K=k[k[ba>>2]>>2]|0;J=k[k[_>>2]>>2]|0;I=k[k[fa>>2]>>2]|0;H=k[k[ha>>2]>>2]|0;Q=k[Sb>>2]|0;R=(Q|0)>0;if(!(+p[Ag>>3]!=0.0)){s=0;B=0.0;while(1){n=N+(aa(s,O)|0)|0;q=C+(aa(s,P)|0)|0;m=E+(aa(s,K)|0)|0;l=D+(aa(s,J)|0)|0;j=F+(aa(s,I)|0)|0;h=G+(aa(s,H)|0)|0;if(R){g=0;do{a=j+(g<<2)|0;lh=+o[a>>2];A=h+(g<<2)|0;kh=+o[A>>2];o[a>>2]=+o[n+(g<<2)>>2]+L*+o[l+(g<<2)>>2];mh=+o[q+(g<<2)>>2]+L*+o[m+(g<<2)>>2];o[A>>2]=mh;lh=+o[a>>2]-lh;kh=mh-kh;B=B+(lh*lh+kh*kh);g=g+1|0}while((g|0)!=(Q|0))}s=s+1|0;if((s|0)==(M|0))break c}}y=k[g>>2]|0;x=k[h>>2]|0;w=k[j>>2]|0;v=0;B=0.0;do{n=N+(aa(v,O)|0)|0;q=C+(aa(v,P)|0)|0;s=z+(aa(y,v)|0)|0;t=A+(aa(x,v)|0)|0;u=a+(aa(w,v)|0)|0;m=E+(aa(v,K)|0)|0;l=D+(aa(v,J)|0)|0;j=F+(aa(v,I)|0)|0;h=G+(aa(v,H)|0)|0;if(R){g=0;do{ph=j+(g<<2)|0;lh=+o[ph>>2];oh=h+(g<<2)|0;mh=+o[oh>>2];qh=u+(g<<2)|0;kh=+o[qh>>2];o[ph>>2]=+o[n+(g<<2)>>2]+L*+o[l+(g<<2)>>2];o[oh>>2]=+o[q+(g<<2)>>2]+L*+o[m+(g<<2)>>2];nh=+o[s+(g<<2)>>2]+L*+o[t+(g<<2)>>2];o[qh>>2]=nh;lh=+o[ph>>2]-lh;mh=+o[oh>>2]-mh;kh=nh-kh;B=B+(kh*kh+(lh*lh+mh*mh));g=g+1|0}while((g|0)!=(Q|0))}v=v+1|0}while((v|0)!=(M|0))}else B=0.0;while(0);s7a(d,Og,Ng);s7a(e,Mg,Lg);if(Bg)s7a(f,Kg,Jg);k[Hg>>2]=152328;l=Ub;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Wb>>2]=Vb;k[Yb>>2]=Xb;k[Zb>>2]=0;k[Xb>>2]=0;k[Tb>>2]=1124007941;l=$b;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[bc>>2]=ac;k[dc>>2]=cc;k[ec>>2]=0;k[cc>>2]=0;k[_b>>2]=1124007941;l=gc;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[ic>>2]=hc;k[kc>>2]=jc;k[lc>>2]=0;k[jc>>2]=0;k[fc>>2]=1124007941;l=nc;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[pc>>2]=oc;k[rc>>2]=qc;k[sc>>2]=0;k[qc>>2]=0;k[mc>>2]=1124007941;l=uc;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[wc>>2]=vc;k[yc>>2]=xc;k[zc>>2]=0;k[xc>>2]=0;k[tc>>2]=1124007941;l=Bc;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Dc>>2]=Cc;k[Fc>>2]=Ec;k[Gc>>2]=0;k[Ec>>2]=0;k[Ac>>2]=1124007941;l=Ic;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Kc>>2]=Jc;k[Mc>>2]=Lc;k[Nc>>2]=0;k[Lc>>2]=0;k[Hc>>2]=1124007941;l=Pc;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Rc>>2]=Qc;k[Tc>>2]=Sc;k[Uc>>2]=0;k[Sc>>2]=0;k[Oc>>2]=1124007941;l=Wc;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[Yc>>2]=Xc;k[_c>>2]=Zc;k[$c>>2]=0;k[Zc>>2]=0;k[Vc>>2]=1124007941;l=bd;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[dd>>2]=cd;k[fd>>2]=ed;k[gd>>2]=0;k[ed>>2]=0;k[ad>>2]=1124007941;l=id;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[kd>>2]=jd;k[md>>2]=ld;k[nd>>2]=0;k[ld>>2]=0;k[hd>>2]=1124007941;l=pd;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[rd>>2]=qd;k[td>>2]=sd;k[ud>>2]=0;k[sd>>2]=0;k[od>>2]=1124007941;KG(vd,Og)|0;KG(wd,Ng)|0;KG(xd,Mg)|0;KG(yd,Lg)|0;KG(zd,Kg)|0;KG(Ad,Jg)|0;KG(Bd,Xg)|0;KG(Cd,Wg)|0;KG(Dd,Vg)|0;KG(Ed,Ug)|0;KG(Fd,Tg)|0;KG(Gd,Sg)|0;o[Hd>>2]=Od;i[Id>>0]=Jd;qh=k[Kd>>2]|0;k[Ig>>2]=0;k[Ld>>2]=qh;jh[k[(k[Hg>>2]|0)+8>>2]&1023](Hg,Ig);t7a(Hg);if(B>Fg)S=S+1|0;else break}}while(0);if(B>Fg)T=T+1|0;else break}}while(0);U=U+1|0}while((U|0)<(k[Pd>>2]|0))}j=Jg+36|0;g=k[j>>2]|0;if(g|0?(ph=g+12|0,qh=k[ph>>2]|0,k[ph>>2]=qh+-1,(qh|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[Jg+32>>2]|0;if(!g){g=B1()|0;h=k[j>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;qh=Jg+16|0;h=Jg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Jg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Jg+44>>2]|0;if(!((g|0)==(Jg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Kg+36|0;g=k[j>>2]|0;if(g|0?(ph=g+12|0,qh=k[ph>>2]|0,k[ph>>2]=qh+-1,(qh|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[Kg+32>>2]|0;if(!g){g=B1()|0;h=k[j>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;qh=Kg+16|0;h=Kg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Kg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Kg+44>>2]|0;if(!((g|0)==(Kg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Lg+36|0;g=k[j>>2]|0;if(g|0?(ph=g+12|0,qh=k[ph>>2]|0,k[ph>>2]=qh+-1,(qh|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[Lg+32>>2]|0;if(!g){g=B1()|0;h=k[j>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;qh=Lg+16|0;h=Lg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Lg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Lg+44>>2]|0;if(!((g|0)==(Lg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Mg+36|0;g=k[j>>2]|0;if(g|0?(ph=g+12|0,qh=k[ph>>2]|0,k[ph>>2]=qh+-1,(qh|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Mg+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;qh=Mg+16|0;h=Mg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Mg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Mg+44>>2]|0;if(!((g|0)==(Mg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Ng+36|0;g=k[j>>2]|0;if(g|0?(ph=g+12|0,qh=k[ph>>2]|0,k[ph>>2]=qh+-1,(qh|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Ng+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;qh=Ng+16|0;h=Ng+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Ng+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Ng+44>>2]|0;if(!((g|0)==(Ng+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Og+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Og+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=Og+16|0;h=Og+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Og+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Og+44>>2]|0;if(!((g|0)==(Og+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Pg+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Pg+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=Pg+16|0;h=Pg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Pg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Pg+44>>2]|0;if(!((g|0)==(Pg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Qg+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Qg+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=Qg+16|0;h=Qg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Qg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Qg+44>>2]|0;if(!((g|0)==(Qg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Rg+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Rg+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=Rg+16|0;h=Rg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Rg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Rg+44>>2]|0;if(!((g|0)==(Rg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Sg+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Sg+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=Sg+16|0;h=Sg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Sg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Sg+44>>2]|0;if(!((g|0)==(Sg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Tg+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Tg+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=Tg+16|0;h=Tg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Tg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Tg+44>>2]|0;if(!((g|0)==(Tg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Ug+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Ug+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=Ug+16|0;h=Ug+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Ug+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Ug+44>>2]|0;if(!((g|0)==(Ug+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Vg+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Vg+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=Vg+16|0;h=Vg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Vg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Vg+44>>2]|0;if(!((g|0)==(Vg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Wg+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Wg+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=Wg+16|0;h=Wg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Wg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Wg+44>>2]|0;if(!((g|0)==(Wg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Xg+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Xg+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=Xg+16|0;h=Xg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Xg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Xg+44>>2]|0;if(!((g|0)==(Xg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Yg+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Yg+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=Yg+16|0;h=Yg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Yg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Yg+44>>2]|0;if(!((g|0)==(Yg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Zg+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Zg+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=Zg+16|0;h=Zg+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[Zg+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Zg+44>>2]|0;if(!((g|0)==(Zg+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=_g+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[_g+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=_g+16|0;h=_g+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[_g+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[_g+44>>2]|0;if(!((g|0)==(_g+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=$g+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[$g+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=$g+16|0;h=$g+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[$g+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[$g+44>>2]|0;if(!((g|0)==($g+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=ah+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[ah+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=ah+16|0;h=ah+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[ah+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[ah+44>>2]|0;if(!((g|0)==(ah+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=bh+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[bh+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=bh+16|0;h=bh+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[bh+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[bh+44>>2]|0;if(!((g|0)==(bh+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=ch+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[ch+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=ch+16|0;h=ch+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[ch+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[ch+44>>2]|0;if(!((g|0)==(ch+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=dh+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[dh+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=dh+16|0;h=dh+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[dh+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[dh+44>>2]|0;if(!((g|0)==(dh+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=eh+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[eh+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=eh+16|0;h=eh+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[eh+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[eh+44>>2]|0;if(!((g|0)==(eh+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=fh+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[fh+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=fh+16|0;h=fh+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[fh+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[fh+44>>2]|0;if(!((g|0)==(fh+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=gh+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[gh+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=gh+16|0;h=gh+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[gh+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[gh+44>>2]|0;if(!((g|0)==(gh+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=hh+36|0;g=k[j>>2]|0;do if(g|0){ph=g+12|0;qh=k[ph>>2]|0;k[ph>>2]=qh+-1;if((qh|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[hh+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;qh=hh+16|0;h=hh+4|0;k[qh>>2]=0;k[qh+4>>2]=0;k[qh+8>>2]=0;k[qh+12>>2]=0;if((k[h>>2]|0)>0){j=k[hh+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[hh+44>>2]|0;if((g|0)==(hh+48|0)|(g|0)==0){r=ih;return}ggb(k[g+-4>>2]|0);r=ih;return}function n7a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=152248;d=a+152|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+148>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+132|0;c=a+120|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+156>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+160>>2]|0;if(!((b|0)==(a+164|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+20|0;d=a+8|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+44>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function o7a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=152268;d=a+208|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+204>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+188|0;c=a+176|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+212>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+216>>2]|0;if(!((b|0)==(a+220|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+152|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+148>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+132|0;c=a+120|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+156>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+160>>2]|0;if(!((b|0)==(a+164|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+76|0;d=a+64|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+100>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function p7a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=152288;d=a+432|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+428>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+412|0;c=a+400|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+436>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+440>>2]|0;if(!((b|0)==(a+444|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+376|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+372>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+356|0;c=a+344|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+380>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+384>>2]|0;if(!((b|0)==(a+388|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+320|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+316>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+300|0;d=a+288|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+324>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+328>>2]|0;if(!((b|0)==(a+332|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+264|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+260>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+244|0;c=a+232|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+268>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+272>>2]|0;if(!((b|0)==(a+276|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+208|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+204>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+188|0;c=a+176|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+212>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+216>>2]|0;if(!((b|0)==(a+220|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+152|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+148>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+132|0;c=a+120|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+156>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+160>>2]|0;if(!((b|0)==(a+164|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+96|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+92>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+36>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function q7a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=152308;d=a+544|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+540>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+524|0;c=a+512|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+548>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+552>>2]|0;if(!((b|0)==(a+556|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+488|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+484>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+468|0;c=a+456|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+492>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+496>>2]|0;if(!((b|0)==(a+500|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+432|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+428>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+412|0;d=a+400|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+436>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+440>>2]|0;if(!((b|0)==(a+444|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+376|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+372>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+356|0;c=a+344|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+380>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+384>>2]|0;if(!((b|0)==(a+388|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+320|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+316>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+300|0;c=a+288|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+324>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+328>>2]|0;if(!((b|0)==(a+332|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+264|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+260>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+244|0;c=a+232|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+268>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+272>>2]|0;if(!((b|0)==(a+276|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+208|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+204>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+188|0;c=a+176|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+212>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+216>>2]|0;if(!((b|0)==(a+220|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+152|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+148>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+132|0;c=a+120|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+156>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+160>>2]|0;if(!((b|0)==(a+164|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+96|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+92>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+36>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function r7a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0.0,p=0.0,q=0;m=r;r=r+192|0;j=m+8|0;l=m;k[j>>2]=152368;d=j+4|0;e=j+12|0;f=j+44|0;g=j+8|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[f>>2]=e;e=j+52|0;k[j+48>>2]=e;k[j+56>>2]=0;k[e>>2]=0;k[d>>2]=1124007941;d=j+60|0;e=j+68|0;f=j+100|0;g=j+64|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[f>>2]=e;e=j+108|0;k[j+104>>2]=e;k[j+112>>2]=0;k[e>>2]=0;k[d>>2]=1124007941;d=j+116|0;e=j+124|0;f=j+156|0;g=j+120|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[f>>2]=e;i=j+164|0;k[j+160>>2]=i;k[j+168>>2]=0;k[i>>2]=0;k[d>>2]=1124007941;KG(j+4|0,a)|0;KG(j+60|0,b)|0;KG(j+116|0,c)|0;i=a+8|0;h=k[i>>2]|0;k[l>>2]=1;k[l+4>>2]=h;jh[k[(k[j>>2]|0)+8>>2]&1023](j,l);z7a(j);h=k[a+12>>2]|0;d=a+16|0;if((h|0)>1){e=k[d>>2]|0;f=k[b+16>>2]|0;g=k[c+16>>2]|0;d=1;do{o[g+(d<<2)>>2]=+o[e+(d<<2)>>2]-+o[e+(d+-1<<2)>>2]+ +o[f+(d<<2)>>2];d=d+1|0}while((d|0)!=(h|0));l=e}else l=k[d>>2]|0;j=k[i>>2]|0;if((j|0)<=1){b=k[b+16>>2]|0;c=k[c+16>>2]|0;p=+o[l>>2];n=+o[b>>2];n=p+n;o[c>>2]=n;r=m;return}h=k[k[a+44>>2]>>2]|0;i=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=k[c+16>>2]|0;e=k[k[c+44>>2]>>2]|0;d=1;do{q=l+(aa(h,d)|0)|0;a=i+(aa(f,d)|0)|0;b=i+(aa(f,d+-1|0)|0)|0;c=g+(aa(e,d)|0)|0;o[c>>2]=+o[q>>2]+ +o[a>>2]-+o[b>>2];d=d+1|0}while((d|0)!=(j|0));c=i;q=g;n=+o[l>>2];p=+o[c>>2];p=n+p;o[q>>2]=p;r=m;return}function s7a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0;q=r;r=r+192|0;g=q+8|0;h=q;m=k[a+8>>2]|0;p=m+-1|0;i=k[a+12>>2]|0;n=i+-1|0;k[g>>2]=152348;d=g+4|0;e=g+12|0;f=g+44|0;j=g+8|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[f>>2]=e;e=g+52|0;k[g+48>>2]=e;k[g+56>>2]=0;k[e>>2]=0;k[d>>2]=1124007941;d=g+60|0;e=g+68|0;f=g+100|0;j=g+64|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[f>>2]=e;e=g+108|0;k[g+104>>2]=e;k[g+112>>2]=0;k[e>>2]=0;k[d>>2]=1124007941;d=g+116|0;e=g+124|0;f=g+156|0;j=g+120|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[f>>2]=e;l=g+164|0;k[g+160>>2]=l;k[g+168>>2]=0;k[l>>2]=0;k[d>>2]=1124007941;KG(g+4|0,a)|0;KG(g+60|0,b)|0;KG(g+116|0,c)|0;k[h>>2]=0;k[h+4>>2]=p;jh[k[(k[g>>2]|0)+8>>2]&1023](g,h);w7a(g);if((i|0)>1){h=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,p)|0)|0;i=k[b+16>>2]|0;e=k[k[b+44>>2]>>2]|0;f=i+(aa(e,p)|0)|0;g=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,p)|0)|0;d=0;do{b=d;d=d+1|0;o[f+(b<<2)>>2]=+o[h+(d<<2)>>2]-+o[h+(b<<2)>>2];o[g+(b<<2)>>2]=0.0}while((d|0)!=(n|0));j=e}else{j=k[k[b+44>>2]>>2]|0;i=k[b+16>>2]|0}if((m|0)<=1){a=k[k[c+44>>2]>>2]|0;c=k[c+16>>2]|0;m=aa(j,p)|0;m=i+m|0;m=m+(n<<2)|0;o[m>>2]=0.0;p=aa(a,p)|0;p=c+p|0;p=p+(n<<2)|0;o[p>>2]=0.0;r=q;return}h=k[a+16>>2]|0;g=k[k[a+44>>2]>>2]|0;d=k[c+16>>2]|0;e=k[k[c+44>>2]>>2]|0;f=0;do{c=i+(aa(j,f)|0)+(n<<2)|0;o[c>>2]=0.0;c=f;f=f+1|0;m=h+(aa(g,f)|0)+(n<<2)|0;a=h+(aa(g,c)|0)+(n<<2)|0;c=d+(aa(e,c)|0)+(n<<2)|0;o[c>>2]=+o[m>>2]-+o[a>>2]}while((f|0)!=(p|0));c=aa(j,p)|0;c=i+c|0;c=c+(n<<2)|0;o[c>>2]=0.0;p=aa(e,p)|0;p=d+p|0;p=p+(n<<2)|0;o[p>>2]=0.0;r=q;return}function t7a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=152328;d=a+656|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+652>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+636|0;c=a+624|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+660>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+664>>2]|0;if(!((b|0)==(a+668|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+600|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+596>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+580|0;c=a+568|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+604>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+608>>2]|0;if(!((b|0)==(a+612|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+544|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+540>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+524|0;d=a+512|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+548>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+552>>2]|0;if(!((b|0)==(a+556|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+488|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+484>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+468|0;c=a+456|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+492>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+496>>2]|0;if(!((b|0)==(a+500|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+432|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+428>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+412|0;c=a+400|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+436>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+440>>2]|0;if(!((b|0)==(a+444|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+376|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+372>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+356|0;c=a+344|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+380>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+384>>2]|0;if(!((b|0)==(a+388|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+320|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+316>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+300|0;c=a+288|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+324>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+328>>2]|0;if(!((b|0)==(a+332|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+264|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+260>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+244|0;c=a+232|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+268>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+272>>2]|0;if(!((b|0)==(a+276|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+208|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+204>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+188|0;c=a+176|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+212>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+216>>2]|0;if(!((b|0)==(a+220|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+152|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+148>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+132|0;c=a+120|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+156>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+160>>2]|0;if(!((b|0)==(a+164|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+96|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+92>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+36>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function u7a(a){a=a|0;t7a(a);ggb(a);return}function v7a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0,g=0.0,h=0,j=0,l=0,m=0.0,n=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0,ha=0;c=k[b>>2]|0;P=k[b+4>>2]|0;if((c|0)>=(P|0))return;ea=k[a+20>>2]|0;D=k[k[a+48>>2]>>2]|0;E=k[a+76>>2]|0;F=k[k[a+104>>2]>>2]|0;G=k[a+132>>2]|0;H=k[k[a+160>>2]>>2]|0;I=k[a+188>>2]|0;J=k[k[a+216>>2]>>2]|0;K=k[a+244>>2]|0;L=k[k[a+272>>2]>>2]|0;M=k[a+300>>2]|0;N=k[k[a+328>>2]>>2]|0;O=k[a+356>>2]|0;R=k[k[a+384>>2]>>2]|0;S=k[a+412>>2]|0;T=k[k[a+440>>2]>>2]|0;U=k[a+468>>2]|0;V=k[k[a+496>>2]>>2]|0;W=k[a+524>>2]|0;X=k[k[a+552>>2]>>2]|0;Y=k[a+580>>2]|0;Z=k[k[a+608>>2]>>2]|0;_=k[a+636>>2]|0;$=k[k[a+664>>2]>>2]|0;ba=k[a+16>>2]|0;ca=(ba|0)>0;da=a+676|0;C=a+680|0;do{t=ea+(aa(D,c)|0)|0;v=E+(aa(F,c)|0)|0;w=G+(aa(H,c)|0)|0;x=I+(aa(J,c)|0)|0;p=K+(aa(L,c)|0)|0;q=M+(aa(N,c)|0)|0;y=O+(aa(R,c)|0)|0;z=S+(aa(T,c)|0)|0;A=U+(aa(V,c)|0)|0;B=W+(aa(X,c)|0)|0;r=Y+(aa(Z,c)|0)|0;s=_+(aa($,c)|0)|0;a:do if(ca){if(!(i[C>>0]|0)){l=0;while(1){m=+o[t+(l<<2)>>2];n=v+(l<<2)|0;s=(o[u>>2]=m,k[u>>2]|0)&2147483647;a=k[n>>2]&2147483647;r=s>>>0<a>>>0;b=r?a:s;a=r?s:a;d=(k[u>>2]=b,+o[u>>2]);e=(k[u>>2]=a,+o[u>>2]);do if((a|0)!=2139095040){if(b>>>0>2139095039|(a|0)==0|(b-a|0)>>>0>209715199){e=d+e;break}if(b>>>0<=1568669695)if(a>>>0<562036736){f=8.077935669463161e-28;e=e*1237940039285380274899124.0e3;d=d*1237940039285380274899124.0e3}else f=1.0;else{f=1237940039285380274899124.0e3;e=e*8.077935669463161e-28;d=d*8.077935669463161e-28}g=d;e=f*+Q(+(g*g+e*e))}while(0);h=w+(l<<2)|0;j=x+(l<<2)|0;s=k[h>>2]&2147483647;a=k[j>>2]&2147483647;r=s>>>0<a>>>0;b=r?a:s;a=r?s:a;f=(k[u>>2]=b,+o[u>>2]);d=(k[u>>2]=a,+o[u>>2]);do if((a|0)!=2139095040){if(b>>>0>2139095039|(a|0)==0|(b-a|0)>>>0>209715199){d=f+d;break}if(b>>>0<=1568669695)if(a>>>0<562036736){g=8.077935669463161e-28;d=d*1237940039285380274899124.0e3;f=f*1237940039285380274899124.0e3}else g=1.0;else{g=1237940039285380274899124.0e3;d=d*8.077935669463161e-28;f=f*8.077935669463161e-28}d=g*+Q(+(f*f+d*d))}while(0);fa=+o[da>>2];f=e*fa+1.0;g=d*fa+1.0;s=y+(l<<2)|0;o[s>>2]=(+o[s>>2]+m*fa)/f;s=z+(l<<2)|0;o[s>>2]=(+o[s>>2]+ +o[da>>2]*+o[n>>2])/f;s=A+(l<<2)|0;o[s>>2]=(+o[s>>2]+ +o[da>>2]*+o[h>>2])/g;s=B+(l<<2)|0;o[s>>2]=(+o[s>>2]+ +o[da>>2]*+o[j>>2])/g;l=l+1|0;if((l|0)==(ba|0))break a}}else n=0;do{m=+o[t+(n<<2)>>2];l=v+(n<<2)|0;j=(o[u>>2]=m,k[u>>2]|0)&2147483647;a=k[l>>2]&2147483647;h=j>>>0<a>>>0;b=h?a:j;a=h?j:a;d=(k[u>>2]=b,+o[u>>2]);e=(k[u>>2]=a,+o[u>>2]);do if((a|0)!=2139095040){if(b>>>0>2139095039|(a|0)==0|(b-a|0)>>>0>209715199){e=d+e;break}if(b>>>0<=1568669695)if(a>>>0<562036736){f=8.077935669463161e-28;e=e*1237940039285380274899124.0e3;d=d*1237940039285380274899124.0e3}else f=1.0;else{f=1237940039285380274899124.0e3;e=e*8.077935669463161e-28;d=d*8.077935669463161e-28}fa=d;e=f*+Q(+(fa*fa+e*e))}while(0);h=w+(n<<2)|0;j=x+(n<<2)|0;ga=k[h>>2]&2147483647;a=k[j>>2]&2147483647;ha=ga>>>0<a>>>0;b=ha?a:ga;a=ha?ga:a;f=(k[u>>2]=b,+o[u>>2]);d=(k[u>>2]=a,+o[u>>2]);do if((a|0)!=2139095040){if(b>>>0>2139095039|(a|0)==0|(b-a|0)>>>0>209715199){d=f+d;break}if(b>>>0<=1568669695)if(a>>>0<562036736){g=8.077935669463161e-28;d=d*1237940039285380274899124.0e3;f=f*1237940039285380274899124.0e3}else g=1.0;else{g=1237940039285380274899124.0e3;d=d*8.077935669463161e-28;f=f*8.077935669463161e-28}fa=f;d=g*+Q(+(fa*fa+d*d))}while(0);fa=+o[da>>2];e=e*fa+1.0;g=d*fa+1.0;ha=y+(n<<2)|0;o[ha>>2]=(+o[ha>>2]+m*fa)/e;ha=z+(n<<2)|0;o[ha>>2]=(+o[ha>>2]+ +o[da>>2]*+o[l>>2])/e;ha=A+(n<<2)|0;o[ha>>2]=(+o[ha>>2]+ +o[da>>2]*+o[h>>2])/g;h=B+(n<<2)|0;o[h>>2]=(+o[h>>2]+ +o[da>>2]*+o[j>>2])/g;g=+o[p+(n<<2)>>2];h=q+(n<<2)|0;ha=(o[u>>2]=g,k[u>>2]|0)&2147483647;a=k[h>>2]&2147483647;ga=ha>>>0<a>>>0;b=ga?a:ha;a=ga?ha:a;e=(k[u>>2]=b,+o[u>>2]);d=(k[u>>2]=a,+o[u>>2]);do if((a|0)!=2139095040){if(b>>>0>2139095039|(a|0)==0|(b-a|0)>>>0>209715199){d=e+d;break}if(b>>>0<=1568669695)if(a>>>0<562036736){f=8.077935669463161e-28;d=d*1237940039285380274899124.0e3;e=e*1237940039285380274899124.0e3}else f=1.0;else{f=1237940039285380274899124.0e3;d=d*8.077935669463161e-28;e=e*8.077935669463161e-28}fa=e;d=f*+Q(+(fa*fa+d*d))}while(0);m=+o[da>>2];fa=d*m+1.0;ha=r+(n<<2)|0;o[ha>>2]=(+o[ha>>2]+g*m)/fa;ha=s+(n<<2)|0;o[ha>>2]=(+o[ha>>2]+ +o[da>>2]*+o[h>>2])/fa;n=n+1|0}while((n|0)!=(ba|0))}while(0);c=c+1|0}while((c|0)!=(P|0));return}function w7a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=152348;d=a+152|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+148>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+132|0;c=a+120|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+156>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+160>>2]|0;if(!((b|0)==(a+164|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+20|0;d=a+8|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+44>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function x7a(a){a=a|0;w7a(a);ggb(a);return}function y7a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0;c=k[a+16>>2]|0;p=c+-1|0;d=k[b>>2]|0;n=k[b+4>>2]|0;if((d|0)>=(n|0))return;h=k[a+20>>2]|0;i=k[k[a+48>>2]>>2]|0;j=k[a+76>>2]|0;l=k[k[a+104>>2]>>2]|0;m=k[a+132>>2]|0;g=k[k[a+160>>2]>>2]|0;if((c|0)<=1)return;do{a=h+(aa(i,d)|0)|0;f=d;d=d+1|0;c=h+(aa(i,d)|0)|0;e=j+(aa(l,f)|0)|0;f=m+(aa(g,f)|0)|0;b=0;do{q=b;b=b+1|0;r=a+(q<<2)|0;o[e+(q<<2)>>2]=+o[a+(b<<2)>>2]-+o[r>>2];o[f+(q<<2)>>2]=+o[c+(q<<2)>>2]-+o[r>>2]}while((b|0)!=(p|0))}while((d|0)!=(n|0));return}function z7a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=152368;d=a+152|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+148>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+132|0;c=a+120|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+156>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+160>>2]|0;if(!((b|0)==(a+164|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+20|0;d=a+8|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+44>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function A7a(a){a=a|0;z7a(a);ggb(a);return}function B7a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0;c=k[b>>2]|0;n=k[b+4>>2]|0;if((c|0)>=(n|0))return;p=k[a+20>>2]|0;h=k[k[a+48>>2]>>2]|0;i=k[a+76>>2]|0;j=k[k[a+104>>2]>>2]|0;l=k[a+132>>2]|0;m=k[k[a+160>>2]>>2]|0;g=k[a+16>>2]|0;if((g|0)<=1)return;do{a=p+(aa(h,c)|0)|0;d=i+(aa(j,c+-1|0)|0)|0;e=i+(aa(j,c)|0)|0;f=l+(aa(m,c)|0)|0;b=1;do{o[f+(b<<2)>>2]=+o[a+(b<<2)>>2]-+o[a+(b+-1<<2)>>2]+(+o[e+(b<<2)>>2]-+o[d+(b<<2)>>2]);b=b+1|0}while((b|0)!=(g|0));c=c+1|0}while((c|0)!=(n|0));return}function C7a(a){a=a|0;q7a(a);ggb(a);return}function D7a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,l=0.0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;W=a+568|0;X=+o[W>>2]!=0.0;c=k[b>>2]|0;V=k[b+4>>2]|0;if((c|0)>=(V|0))return;z=k[a+20>>2]|0;A=k[k[a+48>>2]>>2]|0;B=k[a+76>>2]|0;C=k[k[a+104>>2]>>2]|0;D=k[a+132>>2]|0;E=k[k[a+160>>2]>>2]|0;F=k[a+188>>2]|0;G=k[k[a+216>>2]>>2]|0;H=a+244|0;I=a+272|0;J=k[a+300>>2]|0;K=k[k[a+328>>2]>>2]|0;L=k[a+356>>2]|0;M=k[k[a+384>>2]>>2]|0;N=k[a+412>>2]|0;O=k[k[a+440>>2]>>2]|0;P=k[a+468>>2]|0;Q=k[k[a+496>>2]>>2]|0;R=a+524|0;S=a+552|0;T=k[a+16>>2]|0;U=(T|0)>0;y=a+564|0;do{q=z+(aa(A,c)|0)|0;r=B+(aa(C,c)|0)|0;s=D+(aa(E,c)|0)|0;t=F+(aa(G,c)|0)|0;if(X)p=(k[H>>2]|0)+(aa(k[k[I>>2]>>2]|0,c)|0)|0;else p=0;u=J+(aa(K,c)|0)|0;v=L+(aa(M,c)|0)|0;w=N+(aa(O,c)|0)|0;x=P+(aa(Q,c)|0)|0;if(X)a=(k[R>>2]|0)+(aa(k[k[S>>2]>>2]|0,c)|0)|0;else a=0;if(U)if(X){b=0;do{g=+o[q+(b<<2)>>2];l=+o[s+(b<<2)>>2];f=+o[r+(b<<2)>>2];m=t+(b<<2)|0;n=p+(b<<2)|0;j=+o[W>>2];d=+o[v+(b<<2)>>2]+(g*l+f*+o[m>>2])+j*+o[n>>2];h=+o[y>>2];i=-h;e=+o[u+(b<<2)>>2];do if(!(d<e*i)){if(d>h*e){f=f*i;e=g*i;d=j*i;break}if(e>1.1920928955078125e-07){d=-d/e;f=d*f;e=d*g;d=d*j}else{f=0.0;e=0.0;d=0.0}}else{f=h*f;e=h*g;d=h*j}while(0);o[w+(b<<2)>>2]=e+l;o[x+(b<<2)>>2]=f+ +o[m>>2];o[a+(b<<2)>>2]=d+ +o[n>>2];b=b+1|0}while((b|0)!=(T|0))}else{b=0;do{g=+o[q+(b<<2)>>2];j=+o[s+(b<<2)>>2];d=+o[r+(b<<2)>>2];a=t+(b<<2)|0;e=+o[v+(b<<2)>>2]+(g*j+d*+o[a>>2]);h=+o[y>>2];i=-h;f=+o[u+(b<<2)>>2];do if(!(e<f*i)){if(e>h*f){e=d*i;d=g*i;break}if(f>1.1920928955078125e-07){l=-e/f;e=l*d;d=l*g}else{e=0.0;d=0.0}}else{e=h*d;d=h*g}while(0);o[w+(b<<2)>>2]=d+j;o[x+(b<<2)>>2]=e+ +o[a>>2];b=b+1|0}while((b|0)!=(T|0))}c=c+1|0}while((c|0)!=(V|0));return}function E7a(a){a=a|0;p7a(a);ggb(a);return}function F7a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0;c=k[b>>2]|0;z=k[b+4>>2]|0;if((c|0)>=(z|0))return;D=k[a+20>>2]|0;m=k[k[a+48>>2]>>2]|0;n=k[a+76>>2]|0;p=k[k[a+104>>2]>>2]|0;q=k[a+132>>2]|0;r=k[k[a+160>>2]>>2]|0;s=k[a+188>>2]|0;t=k[k[a+216>>2]>>2]|0;u=k[a+244>>2]|0;v=k[k[a+272>>2]>>2]|0;w=k[a+300>>2]|0;x=k[k[a+328>>2]>>2]|0;y=k[a+356>>2]|0;A=k[k[a+384>>2]>>2]|0;B=k[a+412>>2]|0;C=k[k[a+440>>2]>>2]|0;l=k[a+16>>2]|0;if((l|0)<=0)return;do{a=D+(aa(m,c)|0)|0;d=n+(aa(p,c)|0)|0;e=q+(aa(r,c)|0)|0;f=s+(aa(t,c)|0)|0;g=u+(aa(v,c)|0)|0;h=w+(aa(x,c)|0)|0;i=y+(aa(A,c)|0)|0;j=B+(aa(C,c)|0)|0;b=0;do{F=e+(b<<2)|0;H=+o[F>>2];E=f+(b<<2)|0;G=+o[E>>2];o[i+(b<<2)>>2]=H*H+G*G;o[j+(b<<2)>>2]=+o[d+(b<<2)>>2]-+o[F>>2]*+o[g+(b<<2)>>2]-+o[E>>2]*+o[h+(b<<2)>>2]-+o[a+(b<<2)>>2];b=b+1|0}while((b|0)!=(l|0));c=c+1|0}while((c|0)!=(z|0));return}function G7a(a){a=a|0;o7a(a);ggb(a);return}function H7a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0;c=k[b>>2]|0;r=k[b+4>>2]|0;if((c|0)>=(r|0))return;s=k[a+20>>2]|0;i=k[k[a+48>>2]>>2]|0;j=k[a+76>>2]|0;l=k[k[a+104>>2]>>2]|0;m=k[a+132>>2]|0;n=k[k[a+160>>2]>>2]|0;p=k[a+188>>2]|0;q=k[k[a+216>>2]>>2]|0;h=k[a+16>>2]|0;if((h|0)<=0)return;do{a=s+(aa(i,c)|0)|0;d=j+(aa(l,c)|0)|0;e=m+(aa(n,c)|0)|0;f=p+(aa(q,c)|0)|0;g=+(c|0);b=0;do{o[e+(b<<2)>>2]=+(b|0)+ +o[a+(b<<2)>>2];o[f+(b<<2)>>2]=g+ +o[d+(b<<2)>>2];b=b+1|0}while((b|0)!=(h|0));c=c+1|0}while((c|0)!=(r|0));return}function I7a(a){a=a|0;n7a(a);ggb(a);return}function J7a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0;q=(k[a+16>>2]|0)+-1|0;c=k[b>>2]|0;p=k[b+4>>2]|0;if((c|0)>=(p|0))return;i=k[a+20>>2]|0;j=k[k[a+48>>2]>>2]|0;l=k[a+76>>2]|0;m=k[k[a+104>>2]>>2]|0;n=k[a+132>>2]|0;h=k[k[a+160>>2]>>2]|0;if((q|0)<=1)return;do{a=i+(aa(j,c+-1|0)|0)|0;d=i+(aa(j,c)|0)|0;g=c;c=c+1|0;e=i+(aa(j,c)|0)|0;f=l+(aa(m,g)|0)|0;g=n+(aa(h,g)|0)|0;b=1;do{r=b;b=b+1|0;o[f+(r<<2)>>2]=(+o[d+(b<<2)>>2]-+o[d+(r+-1<<2)>>2])*.5;o[g+(r<<2)>>2]=(+o[e+(r<<2)>>2]-+o[a+(r<<2)>>2])*.5}while((b|0)!=(q|0))}while((c|0)!=(p|0));return}function K7a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;f=k[a+4>>2]|0;g=a+8|0;b=k[g>>2]|0;if((b|0)!=(f|0))do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));b=k[a>>2]|0;if(!b)return;ggb(b);return}function L7a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=k[a>>2]|0;if(!b)return;g=a+4|0;c=k[g>>2]|0;if((c|0)!=(b|0)){do{k[g>>2]=c+-56;f=c+-20|0;d=k[f>>2]|0;if(d|0?(d=d+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[c+-24>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;f=c+-40|0;e=c+-52|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[e>>2]|0)>0){f=k[c+-16>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[c+-12>>2]|0;if(!((d|0)==(c+-8|0)|(d|0)==0))ggb(k[d+-4>>2]|0);c=k[g>>2]|0}while((c|0)!=(b|0));b=k[a>>2]|0}ggb(b);return}function M7a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;d=k[a+20>>2]|0;if((d|0)!=101){f=k[a>>2]|0;k[f+20>>2]=21;k[f+24>>2]=d;Uh[k[f>>2]&2047](a)}e=a+264|0;f=a+32|0;if((k[e>>2]|0)>>>0>=(k[f>>2]|0)>>>0){d=k[a>>2]|0;k[d+20>>2]=126;jh[k[d+4>>2]&1023](a,-1)}d=k[a+8>>2]|0;if(d|0){k[d+4>>2]=k[e>>2];k[d+8>>2]=k[f>>2];Uh[k[d>>2]&2047](a)}d=k[a+392>>2]|0;if(k[d+12>>2]|0)Uh[k[d+4>>2]&2047](a);f=(k[f>>2]|0)-(k[e>>2]|0)|0;k[g>>2]=0;dh[k[(k[a+396>>2]|0)+4>>2]&255](a,b,g,f>>>0<c>>>0?f:c);g=k[g>>2]|0;k[e>>2]=(k[e>>2]|0)+g;r=h;return g|0}function N7a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+2608|0;y=J+2560|0;z=J;I=a+4|0;C=ci[k[k[I>>2]>>2]&255](a,1,36)|0;k[a+392>>2]=C;k[C>>2]=1492;k[C+4>>2]=1493;k[C+8>>2]=1494;k[C+16>>2]=0;c=a+28|0;if(!((k[c>>2]|0)>>>0<=16777215?(k[a+32>>2]|0)>>>0<=16777215:0)){H=k[a>>2]|0;k[H+20>>2]=42;k[H+24>>2]=65500;Uh[k[H>>2]&2047](a)}e=k[a+56>>2]|0;B=a+380|0;b=k[B>>2]|0;f=aa(b,k[a+60>>2]|0)|0;do if(e>>>0<f>>>0){if(e<<1>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+1|0)/2|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+1|0)/2|0;k[a+68>>2]=H;k[a+280>>2]=2;k[a+284>>2]=2;break}if((e*3|0)>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+2|0)/3|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+2|0)/3|0;k[a+68>>2]=H;k[a+280>>2]=3;k[a+284>>2]=3;break}if(e<<2>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+3|0)/4|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+3|0)/4|0;k[a+68>>2]=H;k[a+280>>2]=4;k[a+284>>2]=4;break}if((e*5|0)>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+4|0)/5|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+4|0)/5|0;k[a+68>>2]=H;k[a+280>>2]=5;k[a+284>>2]=5;break}if((e*6|0)>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+5|0)/6|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+5|0)/6|0;k[a+68>>2]=H;k[a+280>>2]=6;k[a+284>>2]=6;break}if((e*7|0)>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+6|0)/7|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+6|0)/7|0;k[a+68>>2]=H;k[a+280>>2]=7;k[a+284>>2]=7;break}if(e<<3>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+7|0)/8|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+7|0)/8|0;k[a+68>>2]=H;k[a+280>>2]=8;k[a+284>>2]=8;break}if((e*9|0)>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+8|0)/9|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+8|0)/9|0;k[a+68>>2]=H;k[a+280>>2]=9;k[a+284>>2]=9;break}if((e*10|0)>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+9|0)/10|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+9|0)/10|0;k[a+68>>2]=H;k[a+280>>2]=10;k[a+284>>2]=10;break}if((e*11|0)>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+10|0)/11|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+10|0)/11|0;k[a+68>>2]=H;k[a+280>>2]=11;k[a+284>>2]=11;break}if((e*12|0)>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+11|0)/12|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+11|0)/12|0;k[a+68>>2]=H;k[a+280>>2]=12;k[a+284>>2]=12;break}if((e*13|0)>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+12|0)/13|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+12|0)/13|0;k[a+68>>2]=H;k[a+280>>2]=13;k[a+284>>2]=13;break}if((e*14|0)>>>0>=f>>>0){H=((aa(k[c>>2]|0,b)|0)+13|0)/14|0;k[a+64>>2]=H;H=((aa(b,k[a+32>>2]|0)|0)+13|0)/14|0;k[a+68>>2]=H;k[a+280>>2]=14;k[a+284>>2]=14;break}c=aa(k[c>>2]|0,b)|0;d=k[a+32>>2]|0;if((e*15|0)>>>0<f>>>0){k[a+64>>2]=(c+15|0)/16|0;H=((aa(b,d)|0)+15|0)/16|0;k[a+68>>2]=H;k[a+280>>2]=16;k[a+284>>2]=16;break}else{k[a+64>>2]=(c+14|0)/15|0;H=((aa(b,d)|0)+14|0)/15|0;k[a+68>>2]=H;k[a+280>>2]=15;k[a+284>>2]=15;break}}else{H=aa(k[c>>2]|0,b)|0;k[a+64>>2]=H;H=aa(b,k[a+32>>2]|0)|0;k[a+68>>2]=H;k[a+280>>2]=1;k[a+284>>2]=1}while(0);if((b+-1|0)>>>0>15){H=k[a>>2]|0;k[H+20>>2]=7;k[H+24>>2]=b;k[H+28>>2]=k[B>>2];Uh[k[H>>2]&2047](a);b=k[B>>2]|0}switch(b|0){case 2:{k[a+384>>2]=154612;break}case 3:{k[a+384>>2]=154512;break}case 4:{k[a+384>>2]=154384;break}case 5:{k[a+384>>2]=154220;break}case 6:{k[a+384>>2]=154012;break}case 7:{k[a+384>>2]=153752;break}default:k[a+384>>2]=153432}x=(aa(b,b)|0)+-1|0;A=a+388|0;k[A>>2]=(b|0)<8?x:63;x=a+68|0;b=k[x>>2]|0;if(!((((b|0)!=0?(k[a+64>>2]|0)!=0:0)?(k[a+76>>2]|0)>=1:0)?(k[a+36>>2]|0)>=1:0)){b=k[a>>2]|0;k[b+20>>2]=33;Uh[k[b>>2]&2047](a);b=k[x>>2]|0}if(!((b|0)<=65500?(k[a+64>>2]|0)<=65500:0)){H=k[a>>2]|0;k[H+20>>2]=42;k[H+24>>2]=65500;Uh[k[H>>2]&2047](a)}b=k[a+72>>2]|0;if((b|0)!=8){H=k[a>>2]|0;k[H+20>>2]=16;k[H+24>>2]=b;Uh[k[H>>2]&2047](a)}H=a+76|0;b=k[H>>2]|0;if((b|0)>10){G=k[a>>2]|0;k[G+20>>2]=27;k[G+24>>2]=b;k[G+28>>2]=10;Uh[k[G>>2]&2047](a);b=k[H>>2]|0}E=a+272|0;k[E>>2]=1;F=a+276|0;k[F>>2]=1;G=a+84|0;if((b|0)>0){h=k[G>>2]|0;j=0;e=1;g=1;while(1){c=h+8|0;d=k[c>>2]|0;f=h+12|0;if((d+-1|0)>>>0<=3?(l=k[f>>2]|0,(l+-1|0)>>>0<=3):0)c=l;else{g=k[a>>2]|0;k[g+20>>2]=19;Uh[k[g>>2]&2047](a);g=k[E>>2]|0;d=k[c>>2]|0;e=k[F>>2]|0;c=k[f>>2]|0;b=k[H>>2]|0}g=(g|0)>(d|0)?g:d;k[E>>2]=g;e=(e|0)>(c|0)?e:c;k[F>>2]=e;j=j+1|0;if((j|0)>=(b|0))break;else h=h+88|0}if((b|0)>0){n=k[a+280>>2]|0;o=k[a+224>>2]|0?8:4;p=(n|0)>(o|0);q=k[a+284>>2]|0;s=(q|0)>(o|0);t=k[a+64>>2]|0;w=k[B>>2]|0;u=aa(w,g)|0;v=k[x>>2]|0;w=aa(w,e)|0;l=k[G>>2]|0;m=0;while(1){k[l+4>>2]=m;a:do if(p)c=1;else{d=k[l+8>>2]|0;c=1;while(1){f=c<<1;if((g|0)%(aa(f,d)|0)|0|0)break a;if((aa(f,n)|0)>(o|0)){c=f;break}else c=f}}while(0);d=aa(c,n)|0;j=l+36|0;k[j>>2]=d;b:do if(s)c=1;else{f=k[l+12>>2]|0;c=1;while(1){h=c<<1;if((e|0)%(aa(h,f)|0)|0|0)break b;if((aa(h,q)|0)>(o|0)){c=h;break}else c=h}}while(0);c=aa(c,q)|0;h=l+40|0;k[h>>2]=c;f=c<<1;if((d|0)<=(f|0)){f=d<<1;if((c|0)>(f|0)){k[h>>2]=f;c=f}}else{k[j>>2]=f;d=f}h=aa(k[l+8>>2]|0,t)|0;k[l+28>>2]=(h+-1+u|0)/(u|0)|0;j=aa(k[l+12>>2]|0,v)|0;k[l+32>>2]=(j+-1+w|0)/(w|0)|0;h=((aa(h,d)|0)+-1+u|0)/(u|0)|0;k[l+44>>2]=h;j=((aa(j,c)|0)+-1+w|0)/(w|0)|0;k[l+48>>2]=j;k[l+52>>2]=1;m=m+1|0;if((m|0)==(b|0)){b=e;break}else l=l+88|0}}else b=e}else b=1;u=aa(k[B>>2]|0,b)|0;k[a+288>>2]=((k[x>>2]|0)+-1+u|0)/(u|0)|0;u=a+204|0;b=k[u>>2]|0;if(b){v=a+200|0;if((k[v>>2]|0)<1){b=k[a>>2]|0;k[b+20>>2]=20;k[b+24>>2]=0;Uh[k[b>>2]&2047](a);b=k[u>>2]|0}if((k[b+20>>2]|0)==0?(k[b+24>>2]|0)==63:0){k[a+268>>2]=0;c=k[H>>2]|0;if((c|0)>0){zpb(y|0,0,c<<2|0)|0;d=0}else d=0}else{k[a+268>>2]=1;c=k[H>>2]|0;if((c|0)>0){zpb(z|0,-1,c<<8|0)|0;d=1}else d=1}if((k[v>>2]|0)<1)b=c;else{t=a+268|0;q=1;while(1){s=k[b>>2]|0;if((s+-1|0)>>>0>3){x=k[a>>2]|0;k[x+20>>2]=27;k[x+24>>2]=s;k[x+28>>2]=4;Uh[k[x>>2]&2047](a)}e=(s|0)>0;if(e){c=0;do{d=k[b+4+(c<<2)>>2]|0;if(!((d|0)>=0?(d|0)<(k[H>>2]|0):0)){x=k[a>>2]|0;k[x+20>>2]=20;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}do if((c|0)>0){if((d|0)>(k[b+4+(c+-1<<2)>>2]|0))break;x=k[a>>2]|0;k[x+20>>2]=20;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}while(0);c=c+1|0}while((c|0)!=(s|0))}j=k[b+20>>2]|0;l=k[b+24>>2]|0;o=k[b+28>>2]|0;p=k[b+32>>2]|0;c:do if(!(k[t>>2]|0)){if((l|0)!=63|(o|j|p|0)!=0){x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}if(e)c=0;else break;do{d=y+(k[b+4+(c<<2)>>2]<<2)|0;if(k[d>>2]|0){x=k[a>>2]|0;k[x+20>>2]=20;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}k[d>>2]=1;c=c+1|0}while((c|0)!=(s|0))}else{if(!(j>>>0<=63?!(p>>>0>10|(o>>>0>10|((l|0)<(j|0)|(l|0)>63))):0)){x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}c=(j|0)==0;do if(c){if(!l)break;x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}else{if((s|0)==1)break;x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}while(0);if(!e)break;m=(o|0)==0;n=(p|0)==(o+-1|0);if(c){j=l+1|0;g=(l|0)<0;f=0;while(1){h=k[b+4+(f<<2)>>2]|0;d:do if(!g){if(!n){if(m)c=0;else{c=0;while(1){x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a);k[z+(h<<8)+(c<<2)>>2]=p;c=c+1|0;if((c|0)==(j|0))break d}}while(1){d=z+(h<<8)+(c<<2)|0;if((k[d>>2]|0)>=0){x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}k[d>>2]=p;c=c+1|0;if((c|0)==(j|0))break d}}if(m){c=0;while(1){d=z+(h<<8)+(c<<2)|0;if((k[d>>2]|0)>=1){x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}k[d>>2]=p;c=c+1|0;if((c|0)==(j|0))break d}}else c=0;do{d=z+(h<<8)+(c<<2)|0;e=k[d>>2]|0;do if((e|0)<0){x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}else{if((o|0)==(e|0))break;x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}while(0);k[d>>2]=p;c=c+1|0}while((c|0)!=(j|0))}while(0);f=f+1|0;if((f|0)==(s|0))break c}}g=(j|0)>(l|0);f=0;do{h=k[b+4+(f<<2)>>2]|0;if((k[z+(h<<8)>>2]|0)<0){x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}e:do if(!g){if(!n){if(m)c=j;else{c=j;while(1){x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a);k[z+(h<<8)+(c<<2)>>2]=p;if((c|0)<(l|0))c=c+1|0;else break e}}while(1){d=z+(h<<8)+(c<<2)|0;if((k[d>>2]|0)>=0){x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}k[d>>2]=p;if((c|0)<(l|0))c=c+1|0;else break e}}if(m){c=j;while(1){d=z+(h<<8)+(c<<2)|0;if((k[d>>2]|0)>=1){x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}k[d>>2]=p;if((c|0)<(l|0))c=c+1|0;else break e}}else c=j;while(1){d=z+(h<<8)+(c<<2)|0;e=k[d>>2]|0;do if((e|0)<0){x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}else{if((o|0)==(e|0))break;x=k[a>>2]|0;k[x+20>>2]=18;k[x+24>>2]=q;Uh[k[x>>2]&2047](a)}while(0);k[d>>2]=p;if((c|0)<(l|0))c=c+1|0;else break}}while(0);f=f+1|0}while((f|0)!=(s|0))}while(0);if((q|0)<(k[v>>2]|0)){b=b+36|0;q=q+1|0}else break}d=k[t>>2]|0;b=k[H>>2]|0}c=(b|0)>0;if(!d){if(c){c=0;do{if(!(k[y+(c<<2)>>2]|0)){b=k[a>>2]|0;k[b+20>>2]=46;Uh[k[b>>2]&2047](a);b=k[H>>2]|0}c=c+1|0}while((c|0)<(b|0))}}else if(c){c=0;do{if((k[z+(c<<8)>>2]|0)<0){b=k[a>>2]|0;k[b+20>>2]=46;Uh[k[b>>2]&2047](a);b=k[H>>2]|0}c=c+1|0}while((c|0)<(b|0))}if((k[B>>2]|0)<8){f=k[u>>2]|0;if((k[v>>2]|0)>0){b=0;e=0;do{if((e|0)!=(b|0)){d=f+(b*36|0)|0;c=f+(e*36|0)|0;g=d+36|0;do{k[d>>2]=k[c>>2];d=d+4|0;c=c+4|0}while((d|0)<(g|0))}c=k[A>>2]|0;if((k[f+(b*36|0)+20>>2]|0)<=(c|0)){d=f+(b*36|0)+24|0;if((k[d>>2]|0)>(c|0))k[d>>2]=c;b=b+1|0}e=e+1|0}while((e|0)<(k[v>>2]|0))}else b=0;k[v>>2]=b}}else{k[a+268>>2]=0;k[a+200>>2]=1}w=a+268|0;if(!((k[w>>2]|0)==0?(k[B>>2]|0)>=8:0))D=180;if((D|0)==180?(k[a+212>>2]|0)==0:0)k[a+216>>2]=1;k[C+20>>2]=0;v=a+216|0;D=k[v>>2]|0;k[C+32>>2]=0;k[C+24>>2]=0;x=a+200|0;b=k[x>>2]|0;if(!D)k[C+28>>2]=b;else k[C+28>>2]=b<<1;y=a+208|0;if(!(k[y>>2]|0)){c=ci[k[k[I>>2]>>2]&255](a,1,12)|0;k[a+412>>2]=c;k[c>>2]=1495;d=a+40|0;switch(k[d>>2]|0){case 1:{if((k[a+36>>2]|0)!=1){D=k[a>>2]|0;k[D+20>>2]=10;Uh[k[D>>2]&2047](a)}break}case 2:{if((k[a+36>>2]|0)!=3){D=k[a>>2]|0;k[D+20>>2]=10;Uh[k[D>>2]&2047](a)}break}case 3:{if((k[a+36>>2]|0)!=3){D=k[a>>2]|0;k[D+20>>2]=10;Uh[k[D>>2]&2047](a)}break}case 5:case 4:{if((k[a+36>>2]|0)!=4){D=k[a>>2]|0;k[D+20>>2]=10;Uh[k[D>>2]&2047](a)}break}default:if((k[a+36>>2]|0)<1){D=k[a>>2]|0;k[D+20>>2]=10;Uh[k[D>>2]&2047](a)}}e=a+260|0;b=a+80|0;if(k[e>>2]|0)if((k[b>>2]|0)==2)D=207;else{D=k[a>>2]|0;k[D+20>>2]=28;Uh[k[D>>2]&2047](a);D=200}else D=200;f:do if((D|0)==200){b=k[b>>2]|0;switch(b|0){case 2:{D=207;break f}case 1:{if((k[H>>2]|0)!=1){C=k[a>>2]|0;k[C+20>>2]=11;Uh[k[C>>2]&2047](a)}switch(k[d>>2]|0){case 3:case 1:{k[c+4>>2]=153;break f}case 2:{k[c>>2]=1496;k[c+4>>2]=154;break f}default:{C=k[a>>2]|0;k[C+20>>2]=28;Uh[k[C>>2]&2047](a);break f}}}case 3:{if((k[H>>2]|0)!=3){C=k[a>>2]|0;k[C+20>>2]=11;Uh[k[C>>2]&2047](a)}switch(k[d>>2]|0){case 2:{k[c>>2]=1496;k[c+4>>2]=157;break f}case 3:{k[c+4>>2]=158;break f}default:{C=k[a>>2]|0;k[C+20>>2]=28;Uh[k[C>>2]&2047](a);break f}}}case 4:{if((k[H>>2]|0)!=4){C=k[a>>2]|0;k[C+20>>2]=11;Uh[k[C>>2]&2047](a)}if((k[d>>2]|0)==4){k[c+4>>2]=158;break f}else{C=k[a>>2]|0;k[C+20>>2]=28;Uh[k[C>>2]&2047](a);break f}}case 5:{if((k[H>>2]|0)!=4){C=k[a>>2]|0;k[C+20>>2]=11;Uh[k[C>>2]&2047](a)}switch(k[d>>2]|0){case 4:{k[c>>2]=1496;k[c+4>>2]=159;break f}case 5:{k[c+4>>2]=158;break f}default:{C=k[a>>2]|0;k[C+20>>2]=28;Uh[k[C>>2]&2047](a);break f}}}default:{if(!((b|0)==(k[d>>2]|0)?(k[H>>2]|0)==(k[a+36>>2]|0):0)){C=k[a>>2]|0;k[C+20>>2]=28;Uh[k[C>>2]&2047](a)}k[c+4>>2]=158;break f}}}while(0);g:do if((D|0)==207){if((k[H>>2]|0)!=3){D=k[a>>2]|0;k[D+20>>2]=11;Uh[k[D>>2]&2047](a)}if((k[d>>2]|0)!=2){D=k[a>>2]|0;k[D+20>>2]=28;Uh[k[D>>2]&2047](a);break}switch(k[e>>2]|0){case 0:{k[c+4>>2]=155;break g}case 1:{k[c+4>>2]=156;break g}default:{D=k[a>>2]|0;k[D+20>>2]=28;Uh[k[D>>2]&2047](a);break g}}}while(0);b=ci[k[k[I>>2]>>2]&255](a,1,112)|0;k[a+416>>2]=b;k[b>>2]=1497;k[b+4>>2]=160;n=b+8|0;k[n>>2]=0;if(k[a+220>>2]|0){D=k[a>>2]|0;k[D+20>>2]=26;Uh[k[D>>2]&2047](a)}if((k[H>>2]|0)>0){o=a+280|0;p=a+284|0;q=b+52|0;s=a+228|0;t=b+12|0;u=b+92|0;m=b+102|0;j=k[G>>2]|0;b=1;l=0;while(1){c=aa(k[j+36>>2]|0,k[j+8>>2]|0)|0;c=(c|0)/(k[o>>2]|0)|0;d=aa(k[j+40>>2]|0,k[j+12>>2]|0)|0;d=(d|0)/(k[p>>2]|0)|0;e=k[E>>2]|0;f=k[F>>2]|0;k[q+(l<<2)>>2]=d;g=(f|0)==(d|0);h:do if((e|0)==(c|0)&g){c=t+(l<<2)|0;if(!(k[s>>2]|0)){k[c>>2]=211;break}else{k[c>>2]=210;k[n>>2]=1;break}}else{h=(e|0)==(c<<1|0);if(h&g){k[t+(l<<2)>>2]=212;b=0;break}if(h&(f|0)==(d<<1|0)){c=t+(l<<2)|0;if(!(k[s>>2]|0)){k[c>>2]=214;break}else{k[c>>2]=213;k[n>>2]=1;break}}do if(!((e|0)%(c|0)|0)){if((f|0)%(d|0)|0|0)break;k[t+(l<<2)>>2]=215;i[u+l>>0]=(e|0)/(c|0)|0;i[m+l>>0]=(f|0)/(d|0)|0;b=0;break h}while(0);D=k[a>>2]|0;k[D+20>>2]=39;Uh[k[D>>2]&2047](a)}while(0);l=l+1|0;if((l|0)>=(k[H>>2]|0))break;else j=j+88|0}if(!((b|0)!=0|(k[s>>2]|0)==0)){F=k[a>>2]|0;k[F+20>>2]=101;jh[k[F+4>>2]&1023](a,0)}}i8a(a,0)}F=ci[k[k[I>>2]>>2]&255](a,1,156)|0;k[a+420>>2]=F;k[F>>2]=1498;b=F+140|0;F=F+84|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=k[k[I>>2]>>2]|0;if(!(k[a+212>>2]|0)){b=ci[b&255](a,1,140)|0;k[a+424>>2]=b;k[b>>2]=839;d=b+44|0;g=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(g|0));if(k[w>>2]|0)k[b+136>>2]=0}else{d=ci[b&255](a,1,208)|0;k[a+424>>2]=d;k[d>>2]=838;k[d+8>>2]=1499;b=d+204|0;d=d+76|0;g=d+128|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(g|0));i[b>>0]=113}if((k[x>>2]|0)>1)b=1;else b=(k[v>>2]|0)!=0;Z9a(a,b&1);b=ci[k[k[I>>2]>>2]&255](a,1,64)|0;k[a+396>>2]=b;k[b>>2]=840;if(k[y>>2]|0){G=k[I>>2]|0;G=k[G>>2]|0;G=ci[G&255](a,1,32)|0;H=a+408|0;k[H>>2]=G;k[G>>2]=1500;F=G+4|0;k[F>>2]=1501;F=G+8|0;k[F>>2]=1502;F=G+12|0;k[F>>2]=1503;F=G+16|0;k[F>>2]=1504;F=G+20|0;k[F>>2]=350;F=G+24|0;k[F>>2]=841;G=G+28|0;k[G>>2]=0;I=k[I>>2]|0;I=I+24|0;I=k[I>>2]|0;Uh[I&2047](a);I=k[H>>2]|0;I=k[I>>2]|0;Uh[I&2047](a);r=J;return}if((k[H>>2]|0)<=0){G=k[I>>2]|0;G=k[G>>2]|0;G=ci[G&255](a,1,32)|0;H=a+408|0;k[H>>2]=G;k[G>>2]=1500;F=G+4|0;k[F>>2]=1501;F=G+8|0;k[F>>2]=1502;F=G+12|0;k[F>>2]=1503;F=G+16|0;k[F>>2]=1504;F=G+20|0;k[F>>2]=350;F=G+24|0;k[F>>2]=841;G=G+28|0;k[G>>2]=0;I=k[I>>2]|0;I=I+24|0;I=k[I>>2]|0;Uh[I&2047](a);I=k[H>>2]|0;I=k[I>>2]|0;Uh[I&2047](a);r=J;return}d=b+24|0;c=0;b=k[G>>2]|0;while(1){F=aa(k[b+36>>2]|0,k[b+28>>2]|0)|0;G=aa(k[b+40>>2]|0,k[b+12>>2]|0)|0;G=Dg[k[(k[I>>2]|0)+8>>2]&127](a,1,F,G)|0;k[d+(c<<2)>>2]=G;c=c+1|0;if((c|0)>=(k[H>>2]|0))break;else b=b+88|0}G=k[I>>2]|0;G=k[G>>2]|0;G=ci[G&255](a,1,32)|0;H=a+408|0;k[H>>2]=G;k[G>>2]=1500;F=G+4|0;k[F>>2]=1501;F=G+8|0;k[F>>2]=1502;F=G+12|0;k[F>>2]=1503;F=G+16|0;k[F>>2]=1504;F=G+20|0;k[F>>2]=350;F=G+24|0;k[F>>2]=841;G=G+28|0;k[G>>2]=0;I=k[I>>2]|0;I=I+24|0;I=k[I>>2]|0;Uh[I&2047](a);I=k[H>>2]|0;I=k[I>>2]|0;Uh[I&2047](a);r=J;return}function O7a(a,b){a=a|0;b=b|0;var c=0;c=k[a+396>>2]|0;if(k[a+208>>2]|0)return;k[c+8>>2]=0;k[c+12>>2]=0;k[c+16>>2]=0;k[c+20>>2]=b;if(!b){k[c+4>>2]=216;return}else{c=k[a>>2]|0;k[c+20>>2]=3;Uh[k[c>>2]&2047](a);return}}function P7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;e=k[a+396>>2]|0;n=e+8|0;o=a+288|0;if((k[n>>2]|0)>>>0>=(k[o>>2]|0)>>>0)return;g=e+12|0;h=a+284|0;i=a+400|0;j=e+24|0;l=a+404|0;m=e+16|0;e=k[g>>2]|0;while(1){f=k[h>>2]|0;if(e>>>0<f>>>0){Eh[k[(k[i>>2]|0)+4>>2]&127](a,b,c,d,j,g,f);e=k[g>>2]|0;f=k[h>>2]|0}if((e|0)!=(f|0)){e=12;break}e=(Hh[k[(k[l>>2]|0)+4>>2]&511](a,j)|0)==0;f=(k[m>>2]|0)!=0;if(e){e=7;break}if(f){k[c>>2]=(k[c>>2]|0)+1;k[m>>2]=0}k[g>>2]=0;f=(k[n>>2]|0)+1|0;k[n>>2]=f;if(f>>>0<(k[o>>2]|0)>>>0)e=0;else{e=12;break}}if((e|0)==7){if(f)return;k[c>>2]=(k[c>>2]|0)+-1;k[m>>2]=1;return}else if((e|0)==12)return}function Q7a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;c=k[a+408>>2]|0;d=a+24|0;b=k[d>>2]|0;f=k[b>>2]|0;k[b>>2]=f+1;i[f>>0]=-1;f=b+4|0;e=(k[f>>2]|0)+-1|0;k[f>>2]=e;if((e|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=-40;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}k[c+28>>2]=0;do if(k[a+244>>2]|0){b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=-1;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=-32;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=0;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=16;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=74;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=70;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=73;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=70;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=0;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}f=i[a+248>>0]|0;b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=f;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}f=i[a+249>>0]|0;b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=f;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}f=i[a+250>>0]|0;b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=f;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}c=j[a+252>>1]|0;b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=(c&65535)>>>8;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=c;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}c=j[a+254>>1]|0;b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=(c&65535)>>>8;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;do if(!f){if(Xh[k[b+12>>2]&1023](a)|0)break;f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}while(0);b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=c;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;do if(!f){if(Xh[k[b+12>>2]&1023](a)|0)break;f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}while(0);b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=0;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;do if(!f){if(Xh[k[b+12>>2]&1023](a)|0)break;f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}while(0);b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=0;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if(f|0)break;if(Xh[k[b+12>>2]&1023](a)|0)break;f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}while(0);if(!(k[a+256>>2]|0))return;b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=-1;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=-18;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=0;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=14;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=65;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=100;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=111;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=98;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=101;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=0;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=100;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=0;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=0;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=0;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=0;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;do if(!f){if(Xh[k[b+12>>2]&1023](a)|0)break;f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}while(0);switch(k[a+80>>2]|0){case 3:{b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=1;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if(f|0)return;if(Xh[k[b+12>>2]&1023](a)|0)return;f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a);return}case 5:{b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=2;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if(f|0)return;if(Xh[k[b+12>>2]&1023](a)|0)return;f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a);return}default:{b=k[d>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=0;e=b+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if(f|0)return;if(Xh[k[b+12>>2]&1023](a)|0)return;f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a);return}}}function R7a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;l=a+84|0;h=a+76|0;b=k[h>>2]|0;if((b|0)>0){b=0;d=0;e=k[l>>2]|0;while(1){c=(X7a(a,k[e+16>>2]|0)|0)+b|0;d=d+1|0;b=k[h>>2]|0;if((d|0)>=(b|0))break;else{b=c;e=e+88|0}}}else c=0;g=a+212|0;m=a+268|0;d=(k[m>>2]|0)==0;a:do if(k[g>>2]|0)if(d)j=19;else j=18;else{b:do if(d){do if((k[a+72>>2]|0)==8?(k[a+380>>2]|0)==8:0){if((b|0)>0){d=1;e=0;f=k[l>>2]|0;while(1){if(!((k[f+20>>2]|0)<=1?(k[f+24>>2]|0)<=1:0))d=0;e=e+1|0;if((e|0)==(b|0)){b=d;break}else f=f+88|0}}else b=1;if(!((c|0)!=0&(b|0)!=0)){if(!b)break;Z7a(a,192);break a}b=k[a>>2]|0;k[b+20>>2]=77;jh[k[b+4>>2]&1023](a,0);b=(k[m>>2]|0)!=0;if(!(k[g>>2]|0))if(b)break b;else break;else if(b){j=18;break a}else{j=19;break a}}while(0);Z7a(a,193);break a}while(0);Z7a(a,194)}while(0);if((j|0)==18)Z7a(a,202);else if((j|0)==19)Z7a(a,201);switch(k[a+260>>2]|0){case 0:break;case 1:{if((k[h>>2]|0)<3)j=27;else j=28;break}default:j=27}if((j|0)==27){h=k[a>>2]|0;k[h+20>>2]=28;Uh[k[h>>2]&2047](a);j=28}do if((j|0)==28){c=a+24|0;b=k[c>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=-1;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[c>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=-8;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[c>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=0;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[c>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=24;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[c>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=13;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[c>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=0;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[c>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=-1;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[c>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=3;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[c>>2]|0;j=k[(k[l>>2]|0)+88>>2]&255;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=j;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[c>>2]|0;j=k[k[l>>2]>>2]&255;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=j;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[c>>2]|0;l=k[(k[l>>2]|0)+176>>2]&255;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=l;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;if((l|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=-128;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;if((l|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=0;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;if((l|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=0;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;if((l|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=0;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;if((l|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=0;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;do if(!l){if(Xh[k[b+12>>2]&1023](a)|0)break;l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}while(0);b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=0;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;do if(!l){if(Xh[k[b+12>>2]&1023](a)|0)break;l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}while(0);b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=0;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;do if(!l){if(Xh[k[b+12>>2]&1023](a)|0)break;l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}while(0);b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=1;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;do if(!l){if(Xh[k[b+12>>2]&1023](a)|0)break;l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}while(0);b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=0;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;do if(!l){if(Xh[k[b+12>>2]&1023](a)|0)break;l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}while(0);b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=0;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;do if(!l){if(Xh[k[b+12>>2]&1023](a)|0)break;l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}while(0);b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=0;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;do if(!l){if(Xh[k[b+12>>2]&1023](a)|0)break;l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}while(0);b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=0;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;do if(!l){if(Xh[k[b+12>>2]&1023](a)|0)break;l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}while(0);b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=1;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;do if(!l){if(Xh[k[b+12>>2]&1023](a)|0)break;l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}while(0);b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=0;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;do if(!l){if(Xh[k[b+12>>2]&1023](a)|0)break;l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}while(0);b=k[c>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=0;j=b+4|0;l=(k[j>>2]|0)+-1|0;k[j>>2]=l;if(l|0)break;if(Xh[k[b+12>>2]&1023](a)|0)break;l=k[a>>2]|0;k[l+20>>2]=25;Uh[k[l>>2]&2047](a)}while(0);if(!(k[m>>2]|0))return;c=a+380|0;if((k[c>>2]|0)==8)return;d=a+24|0;b=k[d>>2]|0;l=k[b>>2]|0;k[b>>2]=l+1;i[l>>0]=-1;l=b+4|0;m=(k[l>>2]|0)+-1|0;k[l>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}b=k[d>>2]|0;l=k[b>>2]|0;k[b>>2]=l+1;i[l>>0]=-38;l=b+4|0;m=(k[l>>2]|0)+-1|0;k[l>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}b=k[d>>2]|0;l=k[b>>2]|0;k[b>>2]=l+1;i[l>>0]=0;l=b+4|0;m=(k[l>>2]|0)+-1|0;k[l>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}b=k[d>>2]|0;l=k[b>>2]|0;k[b>>2]=l+1;i[l>>0]=6;l=b+4|0;m=(k[l>>2]|0)+-1|0;k[l>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}b=k[d>>2]|0;l=k[b>>2]|0;k[b>>2]=l+1;i[l>>0]=0;l=b+4|0;m=(k[l>>2]|0)+-1|0;k[l>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}b=k[d>>2]|0;l=k[b>>2]|0;k[b>>2]=l+1;i[l>>0]=0;l=b+4|0;m=(k[l>>2]|0)+-1|0;k[l>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}m=k[c>>2]|0;m=(aa(m,m)|0)+255|0;b=k[d>>2]|0;l=k[b>>2]|0;k[b>>2]=l+1;i[l>>0]=m;l=b+4|0;m=(k[l>>2]|0)+-1|0;k[l>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}b=k[d>>2]|0;l=k[b>>2]|0;k[b>>2]=l+1;i[l>>0]=0;l=b+4|0;m=(k[l>>2]|0)+-1|0;k[l>>2]=m;if(m|0)return;if(Xh[k[b+12>>2]&1023](a)|0)return;m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a);return}function S7a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0;n=r;r=r+32|0;e=n+16|0;f=n;h=k[a+408>>2]|0;if(!(k[a+212>>2]|0)){g=a+292|0;if((k[g>>2]|0)>0){c=a+364|0;d=a+372|0;e=a+368|0;b=0;do{f=k[a+296+(b<<2)>>2]|0;if((k[c>>2]|0)==0?(k[d>>2]|0)==0:0)Y7a(a,k[f+20>>2]|0,0);if(k[e>>2]|0)Y7a(a,k[f+24>>2]|0,1);b=b+1|0}while((b|0)<(k[g>>2]|0))}}else{b=f;c=b+16|0;do{i[b>>0]=0;b=b+1|0}while((b|0)<(c|0));b=e;c=b+16|0;do{i[b>>0]=0;b=b+1|0}while((b|0)<(c|0));d=k[a+292>>2]|0;a:do if((d|0)>0){b=(k[a+368>>2]|0)==0;if(k[a+364>>2]|0){if(b)break;else b=0;while(1){i[f+(k[(k[a+296+(b<<2)>>2]|0)+24>>2]|0)>>0]=1;b=b+1|0;if((b|0)==(d|0))break a}}c=(k[a+372>>2]|0)==0;if(b){if(c)b=0;else break;while(1){i[e+(k[(k[a+296+(b<<2)>>2]|0)+20>>2]|0)>>0]=1;b=b+1|0;if((b|0)==(d|0))break a}}if(c){b=0;do{m=k[a+296+(b<<2)>>2]|0;i[e+(k[m+20>>2]|0)>>0]=1;i[f+(k[m+24>>2]|0)>>0]=1;b=b+1|0}while((b|0)!=(d|0))}else{b=0;do{i[f+(k[(k[a+296+(b<<2)>>2]|0)+24>>2]|0)>>0]=1;b=b+1|0}while((b|0)!=(d|0))}}while(0);c=(i[f>>0]|0)+(i[e>>0]|0)+(i[e+1>>0]|0)+(i[f+1>>0]|0)+(i[e+2>>0]|0)+(i[f+2>>0]|0)+(i[e+3>>0]|0)+(i[f+3>>0]|0)+(i[e+4>>0]|0)+(i[f+4>>0]|0)+(i[e+5>>0]|0)+(i[f+5>>0]|0)+(i[e+6>>0]|0)+(i[f+6>>0]|0)+(i[e+7>>0]|0)+(i[f+7>>0]|0)+(i[e+8>>0]|0)+(i[f+8>>0]|0)+(i[e+9>>0]|0)+(i[f+9>>0]|0)+(i[e+10>>0]|0)+(i[f+10>>0]|0)+(i[e+11>>0]|0)+(i[f+11>>0]|0)+(i[e+12>>0]|0)+(i[f+12>>0]|0)+(i[e+13>>0]|0)+(i[f+13>>0]|0)+(i[e+14>>0]|0)+(i[f+14>>0]|0)+(i[e+15>>0]|0)+(i[f+15>>0]|0)|0;if(c|0){d=a+24|0;b=k[d>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=-1;j=b+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}b=k[d>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=-52;j=b+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}c=(c<<1)+2|0;b=k[d>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=c>>>8;j=b+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}b=k[d>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=c;j=b+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}c=0;do{if(i[e+c>>0]|0){b=k[d>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=c;j=b+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}b=k[d>>2]|0;m=(l[a+168+c>>0]<<4)+(l[a+152+c>>0]|0)&255;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=m;j=b+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}}if(i[f+c>>0]|0){b=k[d>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=c+16;j=b+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}m=i[a+184+c>>0]|0;b=k[d>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=m;j=b+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}}c=c+1|0}while((c|0)!=16)}}e=a+236|0;d=h+28|0;m=a+24|0;if((k[e>>2]|0)!=(k[d>>2]|0)){b=k[m>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=-1;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[m>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=-35;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[m>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=0;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[m>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=4;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}c=k[e>>2]|0;b=k[m>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=c>>>8;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[m>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=c;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}k[d>>2]=k[e>>2]}b=k[m>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=-1;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}b=k[m>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=-38;h=b+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}j=a+292|0;c=(k[j>>2]<<1)+6|0;b=k[m>>2]|0;g=k[b>>2]|0;k[b>>2]=g+1;i[g>>0]=c>>>8;g=b+4|0;h=(k[g>>2]|0)+-1|0;k[g>>2]=h;if((h|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){h=k[a>>2]|0;k[h+20>>2]=25;Uh[k[h>>2]&2047](a)}b=k[m>>2]|0;g=k[b>>2]|0;k[b>>2]=g+1;i[g>>0]=c;g=b+4|0;h=(k[g>>2]|0)+-1|0;k[g>>2]=h;if((h|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){h=k[a>>2]|0;k[h+20>>2]=25;Uh[k[h>>2]&2047](a)}b=k[m>>2]|0;h=k[j>>2]&255;g=k[b>>2]|0;k[b>>2]=g+1;i[g>>0]=h;g=b+4|0;h=(k[g>>2]|0)+-1|0;k[g>>2]=h;if((h|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){h=k[a>>2]|0;k[h+20>>2]=25;Uh[k[h>>2]&2047](a)}if((k[j>>2]|0)>0){b=a+364|0;g=a+372|0;h=a+368|0;f=0;do{d=k[a+296+(f<<2)>>2]|0;c=k[m>>2]|0;e=k[d>>2]&255;o=k[c>>2]|0;k[c>>2]=o+1;i[o>>0]=e;o=c+4|0;e=(k[o>>2]|0)+-1|0;k[o>>2]=e;if((e|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){o=k[a>>2]|0;k[o+20>>2]=25;Uh[k[o>>2]&2047](a)}if((k[b>>2]|0)==0?(k[g>>2]|0)==0:0)e=k[d+20>>2]|0;else e=0;if(!(k[h>>2]|0))c=0;else c=k[d+24>>2]|0;d=k[m>>2]|0;o=k[d>>2]|0;k[d>>2]=o+1;i[o>>0]=c+(e<<4);e=d+4|0;o=(k[e>>2]|0)+-1|0;k[e>>2]=o;if((o|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){o=k[a>>2]|0;k[o+20>>2]=25;Uh[k[o>>2]&2047](a)}f=f+1|0}while((f|0)<(k[j>>2]|0))}else b=a+364|0;c=k[m>>2]|0;o=k[b>>2]&255;j=k[c>>2]|0;k[c>>2]=j+1;i[j>>0]=o;j=c+4|0;o=(k[j>>2]|0)+-1|0;k[j>>2]=o;if((o|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){o=k[a>>2]|0;k[o+20>>2]=25;Uh[k[o>>2]&2047](a)}b=k[m>>2]|0;o=k[a+368>>2]&255;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=o;j=b+4|0;o=(k[j>>2]|0)+-1|0;k[j>>2]=o;if((o|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){o=k[a>>2]|0;k[o+20>>2]=25;Uh[k[o>>2]&2047](a)}b=k[m>>2]|0;o=(k[a+372>>2]<<4)+(k[a+376>>2]|0)&255;m=k[b>>2]|0;k[b>>2]=m+1;i[m>>0]=o;m=b+4|0;o=(k[m>>2]|0)+-1|0;k[m>>2]=o;if(o|0){r=n;return}if(Xh[k[b+12>>2]&1023](a)|0){r=n;return}o=k[a>>2]|0;k[o+20>>2]=25;Uh[k[o>>2]&2047](a);r=n;return}function T7a(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+24|0;c=k[b>>2]|0;e=k[c>>2]|0;k[c>>2]=e+1;i[e>>0]=-1;e=c+4|0;d=(k[e>>2]|0)+-1|0;k[e>>2]=d;if((d|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){e=k[a>>2]|0;k[e+20>>2]=25;Uh[k[e>>2]&2047](a)}b=k[b>>2]|0;d=k[b>>2]|0;k[b>>2]=d+1;i[d>>0]=-39;d=b+4|0;e=(k[d>>2]|0)+-1|0;k[d>>2]=e;if(e|0)return;if(Xh[k[b+12>>2]&1023](a)|0)return;e=k[a>>2]|0;k[e+20>>2]=25;Uh[k[e>>2]&2047](a);return}function U7a(a){a=a|0;var b=0,c=0,d=0,e=0;c=a+24|0;b=k[c>>2]|0;e=k[b>>2]|0;k[b>>2]=e+1;i[e>>0]=-1;e=b+4|0;d=(k[e>>2]|0)+-1|0;k[e>>2]=d;if((d|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){e=k[a>>2]|0;k[e+20>>2]=25;Uh[k[e>>2]&2047](a)}b=k[c>>2]|0;d=k[b>>2]|0;k[b>>2]=d+1;i[d>>0]=-40;d=b+4|0;e=(k[d>>2]|0)+-1|0;k[d>>2]=e;if((e|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){e=k[a>>2]|0;k[e+20>>2]=25;Uh[k[e>>2]&2047](a)}if(k[a+88>>2]|0)X7a(a,0)|0;if(k[a+92>>2]|0)X7a(a,1)|0;if(k[a+96>>2]|0)X7a(a,2)|0;if(k[a+100>>2]|0)X7a(a,3)|0;if(!(k[a+212>>2]|0)){if(k[a+120>>2]|0)Y7a(a,0,0);if(k[a+136>>2]|0)Y7a(a,0,1);if(k[a+124>>2]|0)Y7a(a,1,0);if(k[a+140>>2]|0)Y7a(a,1,1);if(k[a+128>>2]|0)Y7a(a,2,0);if(k[a+144>>2]|0)Y7a(a,2,1);if(k[a+132>>2]|0)Y7a(a,3,0);if(k[a+148>>2]|0)Y7a(a,3,1)}b=k[c>>2]|0;d=k[b>>2]|0;k[b>>2]=d+1;i[d>>0]=-1;d=b+4|0;e=(k[d>>2]|0)+-1|0;k[d>>2]=e;if((e|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){e=k[a>>2]|0;k[e+20>>2]=25;Uh[k[e>>2]&2047](a)}b=k[c>>2]|0;d=k[b>>2]|0;k[b>>2]=d+1;i[d>>0]=-39;d=b+4|0;e=(k[d>>2]|0)+-1|0;k[d>>2]=e;if(e|0)return;if(Xh[k[b+12>>2]&1023](a)|0)return;e=k[a>>2]|0;k[e+20>>2]=25;Uh[k[e>>2]&2047](a);return}function V7a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;if(c>>>0>65533){e=k[a>>2]|0;k[e+20>>2]=12;Uh[k[e>>2]&2047](a)}e=a+24|0;d=k[e>>2]|0;g=k[d>>2]|0;k[d>>2]=g+1;i[g>>0]=-1;g=d+4|0;f=(k[g>>2]|0)+-1|0;k[g>>2]=f;if((f|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}d=k[e>>2]|0;f=k[d>>2]|0;k[d>>2]=f+1;i[f>>0]=b;f=d+4|0;g=(k[f>>2]|0)+-1|0;k[f>>2]=g;if((g|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}b=c+2|0;d=k[e>>2]|0;f=k[d>>2]|0;k[d>>2]=f+1;i[f>>0]=b>>>8;f=d+4|0;g=(k[f>>2]|0)+-1|0;k[f>>2]=g;if((g|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}d=k[e>>2]|0;f=k[d>>2]|0;k[d>>2]=f+1;i[f>>0]=b;f=d+4|0;g=(k[f>>2]|0)+-1|0;k[f>>2]=g;if(g|0)return;if(Xh[k[d+12>>2]&1023](a)|0)return;g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a);return}function W7a(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a+24>>2]|0;d=k[c>>2]|0;k[c>>2]=d+1;i[d>>0]=b;d=c+4|0;b=(k[d>>2]|0)+-1|0;k[d>>2]=b;if(b|0)return;if(Xh[k[c+12>>2]&1023](a)|0)return;d=k[a>>2]|0;k[d+20>>2]=25;Uh[k[d>>2]&2047](a);return}function X7a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,n=0,o=0,p=0;l=k[a+88+(b<<2)>>2]|0;if(!l){n=k[a>>2]|0;k[n+20>>2]=54;k[n+24>>2]=b;Uh[k[n>>2]&2047](a)}n=a+388|0;e=k[n>>2]|0;if((e|0)<0)c=0;else{f=k[a+384>>2]|0;d=0;c=0;while(1){c=(m[l+(k[f+(d<<2)>>2]<<1)>>1]|0)>255?1:c;if((d|0)==(e|0))break;else d=d+1|0}}g=l+128|0;if(k[g>>2]|0)return c|0;h=a+24|0;d=k[h>>2]|0;e=k[d>>2]|0;k[d>>2]=e+1;i[e>>0]=-1;e=d+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}d=k[h>>2]|0;e=k[d>>2]|0;k[d>>2]=e+1;i[e>>0]=-37;e=d+4|0;f=(k[e>>2]|0)+-1|0;k[e>>2]=f;if((f|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}f=(c|0)!=0;e=k[n>>2]|0;e=(f?(e<<1)+2|0:e+1|0)+3|0;d=k[h>>2]|0;p=k[d>>2]|0;k[d>>2]=p+1;i[p>>0]=e>>>8;p=d+4|0;o=(k[p>>2]|0)+-1|0;k[p>>2]=o;if((o|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){p=k[a>>2]|0;k[p+20>>2]=25;Uh[k[p>>2]&2047](a)}d=k[h>>2]|0;o=k[d>>2]|0;k[d>>2]=o+1;i[o>>0]=e;o=d+4|0;p=(k[o>>2]|0)+-1|0;k[o>>2]=p;if((p|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){p=k[a>>2]|0;k[p+20>>2]=25;Uh[k[p>>2]&2047](a)}d=k[h>>2]|0;o=k[d>>2]|0;k[d>>2]=o+1;i[o>>0]=(c<<4)+b;o=d+4|0;p=(k[o>>2]|0)+-1|0;k[o>>2]=p;if((p|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){p=k[a>>2]|0;k[p+20>>2]=25;Uh[k[p>>2]&2047](a)}a:do if((k[n>>2]|0)>=0){b=a+384|0;if(f)e=0;else{d=0;while(1){e=k[h>>2]|0;p=j[l+(k[(k[b>>2]|0)+(d<<2)>>2]<<1)>>1]&255;o=k[e>>2]|0;k[e>>2]=o+1;i[o>>0]=p;o=e+4|0;p=(k[o>>2]|0)+-1|0;k[o>>2]=p;if((p|0)==0?(Xh[k[e+12>>2]&1023](a)|0)==0:0){p=k[a>>2]|0;k[p+20>>2]=25;Uh[k[p>>2]&2047](a)}if((d|0)<(k[n>>2]|0))d=d+1|0;else break a}}while(1){f=j[l+(k[(k[b>>2]|0)+(e<<2)>>2]<<1)>>1]|0;d=k[h>>2]|0;o=k[d>>2]|0;k[d>>2]=o+1;i[o>>0]=(f&65535)>>>8;o=d+4|0;p=(k[o>>2]|0)+-1|0;k[o>>2]=p;if((p|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){p=k[a>>2]|0;k[p+20>>2]=25;Uh[k[p>>2]&2047](a)}d=k[h>>2]|0;o=k[d>>2]|0;k[d>>2]=o+1;i[o>>0]=f;o=d+4|0;p=(k[o>>2]|0)+-1|0;k[o>>2]=p;if((p|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){p=k[a>>2]|0;k[p+20>>2]=25;Uh[k[p>>2]&2047](a)}if((e|0)<(k[n>>2]|0))e=e+1|0;else break}}while(0);k[g>>2]=1;return c|0}function Y7a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0;f=(c|0)==0;d=f?b:b+16|0;f=k[(f?a+120+(b<<2)|0:a+136+(b<<2)|0)>>2]|0;if(!f){h=k[a>>2]|0;k[h+20>>2]=52;k[h+24>>2]=d;Uh[k[h>>2]&2047](a)}g=f+276|0;if(k[g>>2]|0)return;h=a+24|0;c=k[h>>2]|0;b=k[c>>2]|0;k[c>>2]=b+1;i[b>>0]=-1;b=c+4|0;e=(k[b>>2]|0)+-1|0;k[b>>2]=e;if((e|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){e=k[a>>2]|0;k[e+20>>2]=25;Uh[k[e>>2]&2047](a)}c=k[h>>2]|0;b=k[c>>2]|0;k[c>>2]=b+1;i[b>>0]=-60;b=c+4|0;e=(k[b>>2]|0)+-1|0;k[b>>2]=e;if((e|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){e=k[a>>2]|0;k[e+20>>2]=25;Uh[k[e>>2]&2047](a)}e=(l[f+16>>0]|0)+((l[f+15>>0]|0)+((l[f+14>>0]|0)+((l[f+13>>0]|0)+((l[f+12>>0]|0)+((l[f+11>>0]|0)+((l[f+10>>0]|0)+((l[f+9>>0]|0)+((l[f+8>>0]|0)+((l[f+7>>0]|0)+((l[f+6>>0]|0)+((l[f+5>>0]|0)+((l[f+4>>0]|0)+((l[f+3>>0]|0)+((l[f+2>>0]|0)+(l[f+1>>0]|0)))))))))))))))|0;b=e+19|0;c=k[h>>2]|0;m=k[c>>2]|0;k[c>>2]=m+1;i[m>>0]=b>>>8;m=c+4|0;j=(k[m>>2]|0)+-1|0;k[m>>2]=j;if((j|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}c=k[h>>2]|0;j=k[c>>2]|0;k[c>>2]=j+1;i[j>>0]=b;j=c+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}c=k[h>>2]|0;j=k[c>>2]|0;k[c>>2]=j+1;i[j>>0]=d;j=c+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}c=1;do{m=i[f+c>>0]|0;b=k[h>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=m;j=b+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}c=c+1|0}while((c|0)!=17);if((e|0)>0){c=0;do{m=i[f+17+c>>0]|0;b=k[h>>2]|0;j=k[b>>2]|0;k[b>>2]=j+1;i[j>>0]=m;j=b+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}c=c+1|0}while((c|0)!=(e|0))}k[g>>2]=1;return}function Z7a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=a+24|0;c=k[f>>2]|0;d=k[c>>2]|0;k[c>>2]=d+1;i[d>>0]=-1;d=c+4|0;e=(k[d>>2]|0)+-1|0;k[d>>2]=e;if((e|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){e=k[a>>2]|0;k[e+20>>2]=25;Uh[k[e>>2]&2047](a)}c=k[f>>2]|0;d=k[c>>2]|0;k[c>>2]=d+1;i[d>>0]=b;d=c+4|0;e=(k[d>>2]|0)+-1|0;k[d>>2]=e;if((e|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){e=k[a>>2]|0;k[e+20>>2]=25;Uh[k[e>>2]&2047](a)}e=a+76|0;b=((k[e>>2]|0)*3|0)+8|0;c=k[f>>2]|0;g=k[c>>2]|0;k[c>>2]=g+1;i[g>>0]=b>>>8;g=c+4|0;d=(k[g>>2]|0)+-1|0;k[g>>2]=d;if((d|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}c=k[f>>2]|0;d=k[c>>2]|0;k[c>>2]=d+1;i[d>>0]=b;d=c+4|0;g=(k[d>>2]|0)+-1|0;k[d>>2]=g;if((g|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}c=a+68|0;if(!((k[c>>2]|0)<=65535?(k[a+64>>2]|0)<=65535:0)){g=k[a>>2]|0;k[g+20>>2]=42;k[g+24>>2]=65535;Uh[k[g>>2]&2047](a)}b=k[f>>2]|0;g=k[a+72>>2]&255;d=k[b>>2]|0;k[b>>2]=d+1;i[d>>0]=g;d=b+4|0;g=(k[d>>2]|0)+-1|0;k[d>>2]=g;if((g|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}b=k[c>>2]|0;c=k[f>>2]|0;d=k[c>>2]|0;k[c>>2]=d+1;i[d>>0]=b>>>8;d=c+4|0;g=(k[d>>2]|0)+-1|0;k[d>>2]=g;if((g|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}c=k[f>>2]|0;d=k[c>>2]|0;k[c>>2]=d+1;i[d>>0]=b;d=c+4|0;g=(k[d>>2]|0)+-1|0;k[d>>2]=g;if((g|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}b=k[a+64>>2]|0;c=k[f>>2]|0;d=k[c>>2]|0;k[c>>2]=d+1;i[d>>0]=b>>>8;d=c+4|0;g=(k[d>>2]|0)+-1|0;k[d>>2]=g;if((g|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}c=k[f>>2]|0;d=k[c>>2]|0;k[c>>2]=d+1;i[d>>0]=b;d=c+4|0;g=(k[d>>2]|0)+-1|0;k[d>>2]=g;if((g|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}c=k[f>>2]|0;g=k[e>>2]&255;d=k[c>>2]|0;k[c>>2]=d+1;i[d>>0]=g;d=c+4|0;g=(k[d>>2]|0)+-1|0;k[d>>2]=g;if((g|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}if((k[e>>2]|0)<=0)return;b=0;d=k[a+84>>2]|0;while(1){c=k[f>>2]|0;g=k[d>>2]&255;h=k[c>>2]|0;k[c>>2]=h+1;i[h>>0]=g;h=c+4|0;g=(k[h>>2]|0)+-1|0;k[h>>2]=g;if((g|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){h=k[a>>2]|0;k[h+20>>2]=25;Uh[k[h>>2]&2047](a)}c=k[f>>2]|0;h=(k[d+8>>2]<<4)+(k[d+12>>2]|0)&255;g=k[c>>2]|0;k[c>>2]=g+1;i[g>>0]=h;g=c+4|0;h=(k[g>>2]|0)+-1|0;k[g>>2]=h;if((h|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){h=k[a>>2]|0;k[h+20>>2]=25;Uh[k[h>>2]&2047](a)}c=k[f>>2]|0;h=k[d+16>>2]&255;g=k[c>>2]|0;k[c>>2]=g+1;i[g>>0]=h;g=c+4|0;h=(k[g>>2]|0)+-1|0;k[g>>2]=h;if((h|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){h=k[a>>2]|0;k[h+20>>2]=25;Uh[k[h>>2]&2047](a)}b=b+1|0;if((b|0)>=(k[e>>2]|0))break;else d=d+88|0}return}function _7a(a){a=a|0;var b=0,c=0,d=0,e=0;e=k[a+392>>2]|0;b=e+20|0;a:do switch(k[b>>2]|0){case 0:{b8a(a);c8a(a);if(!(k[a+208>>2]|0)){Uh[k[k[a+412>>2]>>2]&2047](a);Uh[k[k[a+416>>2]>>2]&2047](a);jh[k[k[a+400>>2]>>2]&1023](a,0)}Uh[k[k[a+420>>2]>>2]&2047](a);d=a+216|0;jh[k[k[a+424>>2]>>2]&1023](a,k[d>>2]|0);jh[k[k[a+404>>2]>>2]&1023](a,(k[e+28>>2]|0)>1?3:0);jh[k[k[a+396>>2]>>2]&1023](a,0);b=e+12|0;if(!(k[d>>2]|0)){k[b>>2]=1;break a}else{k[b>>2]=0;break a}}case 1:{b8a(a);c8a(a);if((k[a+364>>2]|0)==0?k[a+372>>2]|0:0){k[b>>2]=2;c=e+24|0;k[c>>2]=(k[c>>2]|0)+1;c=11;break a}jh[k[k[a+424>>2]>>2]&1023](a,1);jh[k[k[a+404>>2]>>2]&1023](a,2);k[e+12>>2]=0;break}case 2:{c=11;break}default:{d=k[a>>2]|0;k[d+20>>2]=49;Uh[k[d>>2]&2047](a)}}while(0);if((c|0)==11){if(!(k[a+216>>2]|0)){b8a(a);c8a(a)}jh[k[k[a+424>>2]>>2]&1023](a,0);jh[k[k[a+404>>2]>>2]&1023](a,2);b=a+408|0;if(!(k[e+32>>2]|0))Uh[k[(k[b>>2]|0)+4>>2]&2047](a);Uh[k[(k[b>>2]|0)+8>>2]&2047](a);k[e+12>>2]=0}c=k[e+24>>2]|0;d=k[e+28>>2]|0;k[e+16>>2]=(c|0)==(d+-1|0)&1;b=k[a+8>>2]|0;if(!b)return;k[b+12>>2]=c;k[b+16>>2]=d;return}function $7a(a){a=a|0;var b=0;k[(k[a+392>>2]|0)+12>>2]=0;b=a+408|0;Uh[k[(k[b>>2]|0)+4>>2]&2047](a);Uh[k[(k[b>>2]|0)+8>>2]&2047](a);return}function a8a(a){a=a|0;var b=0,c=0;b=k[a+392>>2]|0;Uh[k[(k[a+424>>2]|0)+8>>2]&2047](a);c=b+20|0;switch(k[c>>2]|0){case 0:{k[c>>2]=2;if(!(k[a+216>>2]|0)){c=b+32|0;k[c>>2]=(k[c>>2]|0)+1}break}case 1:{k[c>>2]=2;break}case 2:{if(k[a+216>>2]|0)k[c>>2]=1;c=b+32|0;k[c>>2]=(k[c>>2]|0)+1;break}default:{}}c=b+24|0;k[c>>2]=(k[c>>2]|0)+1;return}function b8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;d=k[a+204>>2]|0;if(!d){d=a+76|0;b=k[d>>2]|0;if((b|0)>4){f=k[a>>2]|0;k[f+20>>2]=27;k[f+24>>2]=b;k[f+28>>2]=4;Uh[k[f>>2]&2047](a);b=k[d>>2]|0}k[a+292>>2]=b;if((b|0)>0){c=a+84|0;b=0;do{k[a+296+(b<<2)>>2]=(k[c>>2]|0)+(b*88|0);b=b+1|0}while((b|0)<(k[d>>2]|0))}}else{e=k[(k[a+392>>2]|0)+32>>2]|0;f=k[d+(e*36|0)>>2]|0;k[a+292>>2]=f;if((f|0)>0){c=a+84|0;b=0;do{k[a+296+(b<<2)>>2]=(k[c>>2]|0)+((k[d+(e*36|0)+4+(b<<2)>>2]|0)*88|0);b=b+1|0}while((b|0)!=(f|0))}if(k[a+268>>2]|0){k[a+364>>2]=k[d+(e*36|0)+20>>2];k[a+368>>2]=k[d+(e*36|0)+24>>2];k[a+372>>2]=k[d+(e*36|0)+28>>2];k[a+376>>2]=k[d+(e*36|0)+32>>2];return}}k[a+364>>2]=0;f=k[a+380>>2]|0;f=(aa(f,f)|0)+-1|0;k[a+368>>2]=f;k[a+372>>2]=0;k[a+376>>2]=0;return}function c8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=a+292|0;b=k[f>>2]|0;a:do if((b|0)!=1){if((b+-1|0)>>>0>3){e=k[a>>2]|0;k[e+20>>2]=27;k[e+24>>2]=b;k[e+28>>2]=4;Uh[k[e>>2]&2047](a);b=k[f>>2]|0}e=k[a+380>>2]|0;d=aa(e,k[a+272>>2]|0)|0;k[a+312>>2]=((k[a+64>>2]|0)+-1+d|0)/(d|0)|0;e=aa(e,k[a+276>>2]|0)|0;k[a+316>>2]=((k[a+68>>2]|0)+-1+e|0)/(e|0)|0;e=a+320|0;k[e>>2]=0;if((b|0)>0){b=0;d=0;while(1){g=k[a+296+(b<<2)>>2]|0;j=k[g+8>>2]|0;k[g+56>>2]=j;i=k[g+12>>2]|0;k[g+60>>2]=i;c=aa(i,j)|0;k[g+64>>2]=c;h=aa(k[g+36>>2]|0,j)|0;k[g+68>>2]=h;h=((k[g+28>>2]|0)>>>0)%(j>>>0)|0;k[g+72>>2]=(h|0)==0?j:h;h=((k[g+32>>2]|0)>>>0)%(i>>>0)|0;k[g+76>>2]=(h|0)==0?i:h;if((d+c|0)>10){j=k[a>>2]|0;k[j+20>>2]=14;Uh[k[j>>2]&2047](a)}if((c|0)>0)while(1){j=k[e>>2]|0;k[e>>2]=j+1;k[a+324+(j<<2)>>2]=b;if((c|0)>1)c=c+-1|0;else break}b=b+1|0;if((b|0)>=(k[f>>2]|0))break a;d=k[e>>2]|0}}}else{j=k[a+296>>2]|0;k[a+312>>2]=k[j+28>>2];i=k[j+32>>2]|0;k[a+316>>2]=i;k[j+56>>2]=1;k[j+60>>2]=1;k[j+64>>2]=1;k[j+68>>2]=k[j+36>>2];k[j+72>>2]=1;h=k[j+12>>2]|0;i=(i>>>0)%(h>>>0)|0;k[j+76>>2]=(i|0)==0?h:i;k[a+320>>2]=1;k[a+324>>2]=0}while(0);b=k[a+240>>2]|0;if((b|0)<=0)return;j=aa(k[a+312>>2]|0,b)|0;k[a+236>>2]=(j|0)<65535?j:65535;return}function d8a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=k[a+104>>2]|0;g=a+20|0;c=k[g>>2]|0;if((c|0)!=100){f=k[a>>2]|0;k[f+20>>2]=21;k[f+24>>2]=c;Uh[k[f>>2]&2047](a)}c=a+88|0;d=k[c>>2]|0;if(!d){d=ci[k[k[a+4>>2]>>2]&255](a,0,132)|0;k[d+128>>2]=0;k[c>>2]=d}f=(b|0)==0;if(f){c=0;do{b=((aa(k[152380+(c<<2)>>2]|0,e)|0)+50|0)/100|0;b=(b|0)<1?1:b;j[d+(c<<1)>>1]=(b|0)>32767?32767:b;c=c+1|0}while((c|0)!=64)}else{c=0;do{b=((aa(k[152380+(c<<2)>>2]|0,e)|0)+50|0)/100|0;b=(b|0)<1?1:b;j[d+(c<<1)>>1]=(b|0)<255?b:255;c=c+1|0}while((c|0)!=64)}k[d+128>>2]=0;b=k[a+108>>2]|0;c=k[g>>2]|0;if((c|0)!=100){g=k[a>>2]|0;k[g+20>>2]=21;k[g+24>>2]=c;Uh[k[g>>2]&2047](a)}c=a+92|0;d=k[c>>2]|0;if(!d){d=ci[k[k[a+4>>2]>>2]&255](a,0,132)|0;k[d+128>>2]=0;k[c>>2]=d}if(f){c=0;do{a=((aa(k[152636+(c<<2)>>2]|0,b)|0)+50|0)/100|0;a=(a|0)<1?1:a;j[d+(c<<1)>>1]=(a|0)>32767?32767:a;c=c+1|0}while((c|0)!=64);a=d+128|0;k[a>>2]=0;return}else{c=0;do{a=((aa(k[152636+(c<<2)>>2]|0,b)|0)+50|0)/100|0;a=(a|0)<1?1:a;j[d+(c<<1)>>1]=(a|0)<255?a:255;c=c+1|0}while((c|0)!=64);a=d+128|0;k[a>>2]=0;return}}function e8a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=a+20|0;d=k[f>>2]|0;if((d|0)!=100){e=k[a>>2]|0;k[e+20>>2]=21;k[e+24>>2]=d;Uh[k[e>>2]&2047](a)}d=a+88|0;e=k[d>>2]|0;if(!e){e=ci[k[k[a+4>>2]>>2]&255](a,0,132)|0;k[e+128>>2]=0;k[d>>2]=e}c=(c|0)==0;if(c){d=0;do{g=((aa(k[152380+(d<<2)>>2]|0,b)|0)+50|0)/100|0;g=(g|0)<1?1:g;j[e+(d<<1)>>1]=(g|0)>32767?32767:g;d=d+1|0}while((d|0)!=64)}else{d=0;do{g=((aa(k[152380+(d<<2)>>2]|0,b)|0)+50|0)/100|0;g=(g|0)<1?1:g;j[e+(d<<1)>>1]=(g|0)<255?g:255;d=d+1|0}while((d|0)!=64)}k[e+128>>2]=0;d=k[f>>2]|0;if((d|0)!=100){g=k[a>>2]|0;k[g+20>>2]=21;k[g+24>>2]=d;Uh[k[g>>2]&2047](a)}d=a+92|0;e=k[d>>2]|0;if(!e){e=ci[k[k[a+4>>2]>>2]&255](a,0,132)|0;k[e+128>>2]=0;k[d>>2]=e}if(c){d=0;do{g=((aa(k[152636+(d<<2)>>2]|0,b)|0)+50|0)/100|0;g=(g|0)<1?1:g;j[e+(d<<1)>>1]=(g|0)>32767?32767:g;d=d+1|0}while((d|0)!=64);g=e+128|0;k[g>>2]=0;return}else{d=0;do{g=((aa(k[152636+(d<<2)>>2]|0,b)|0)+50|0)/100|0;g=(g|0)<1?1:g;j[e+(d<<1)>>1]=(g|0)<255?g:255;d=d+1|0}while((d|0)!=64);g=e+128|0;k[g>>2]=0;return}}function f8a(a){a=a|0;var b=0,c=0,d=0,e=0;c=a+20|0;b=k[c>>2]|0;if((b|0)!=100){d=k[a>>2]|0;k[d+20>>2]=21;k[d+24>>2]=b;Uh[k[d>>2]&2047](a)}d=a+84|0;if(!(k[d>>2]|0)){b=ci[k[k[a+4>>2]>>2]&255](a,0,880)|0;k[d>>2]=b}k[a+56>>2]=1;k[a+60>>2]=1;b=a+72|0;k[b>>2]=8;e8a(a,50,1);g8a(a,a+120|0,405429,405446);g8a(a,a+136|0,405458,405475);g8a(a,a+124|0,405637,405654);g8a(a,a+140|0,405666,405683);i[a+152>>0]=0;i[a+168>>0]=1;i[a+184>>0]=5;i[a+153>>0]=0;i[a+169>>0]=1;i[a+185>>0]=5;i[a+154>>0]=0;i[a+170>>0]=1;i[a+186>>0]=5;i[a+155>>0]=0;i[a+171>>0]=1;i[a+187>>0]=5;i[a+156>>0]=0;i[a+172>>0]=1;i[a+188>>0]=5;i[a+157>>0]=0;i[a+173>>0]=1;i[a+189>>0]=5;i[a+158>>0]=0;i[a+174>>0]=1;i[a+190>>0]=5;i[a+159>>0]=0;i[a+175>>0]=1;i[a+191>>0]=5;i[a+160>>0]=0;i[a+176>>0]=1;i[a+192>>0]=5;i[a+161>>0]=0;i[a+177>>0]=1;i[a+193>>0]=5;i[a+162>>0]=0;i[a+178>>0]=1;i[a+194>>0]=5;i[a+163>>0]=0;i[a+179>>0]=1;i[a+195>>0]=5;i[a+164>>0]=0;i[a+180>>0]=1;i[a+196>>0]=5;i[a+165>>0]=0;i[a+181>>0]=1;i[a+197>>0]=5;i[a+166>>0]=0;i[a+182>>0]=1;i[a+198>>0]=5;i[a+167>>0]=0;i[a+183>>0]=1;i[a+199>>0]=5;e=a+200|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;k[a+216>>2]=(k[b>>2]|0)>8&1;k[a+220>>2]=0;k[a+224>>2]=1;b=a+228|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;i[a+248>>0]=1;i[a+249>>0]=1;i[a+250>>0]=0;j[a+252>>1]=1;j[a+254>>1]=1;k[a+260>>2]=0;switch(k[a+40>>2]|0){case 1:{b=k[c>>2]|0;if((b|0)!=100){e=k[a>>2]|0;k[e+20>>2]=21;k[e+24>>2]=b;Uh[k[e>>2]&2047](a)}k[a+80>>2]=1;k[a+256>>2]=0;k[a+244>>2]=1;k[a+76>>2]=1;e=k[d>>2]|0;k[e>>2]=1;k[e+8>>2]=1;k[e+12>>2]=1;k[e+16>>2]=0;k[e+20>>2]=0;k[e+24>>2]=0;return}case 2:{b=k[c>>2]|0;if((b|0)!=100){e=k[a>>2]|0;k[e+20>>2]=21;k[e+24>>2]=b;Uh[k[e>>2]&2047](a)}k[a+80>>2]=3;k[a+256>>2]=0;k[a+244>>2]=1;k[a+76>>2]=3;e=k[d>>2]|0;k[e>>2]=1;k[e+8>>2]=2;k[e+12>>2]=2;k[e+16>>2]=0;k[e+20>>2]=0;k[e+24>>2]=0;k[e+88>>2]=2;k[e+96>>2]=1;k[e+100>>2]=1;k[e+104>>2]=1;k[e+108>>2]=1;k[e+112>>2]=1;k[e+176>>2]=3;k[e+184>>2]=1;k[e+188>>2]=1;k[e+192>>2]=1;k[e+196>>2]=1;k[e+200>>2]=1;return}case 3:{b=k[c>>2]|0;if((b|0)!=100){e=k[a>>2]|0;k[e+20>>2]=21;k[e+24>>2]=b;Uh[k[e>>2]&2047](a)}k[a+80>>2]=3;k[a+256>>2]=0;k[a+244>>2]=1;k[a+76>>2]=3;e=k[d>>2]|0;k[e>>2]=1;k[e+8>>2]=2;k[e+12>>2]=2;k[e+16>>2]=0;k[e+20>>2]=0;k[e+24>>2]=0;k[e+88>>2]=2;k[e+96>>2]=1;k[e+100>>2]=1;k[e+104>>2]=1;k[e+108>>2]=1;k[e+112>>2]=1;k[e+176>>2]=3;k[e+184>>2]=1;k[e+188>>2]=1;k[e+192>>2]=1;k[e+196>>2]=1;k[e+200>>2]=1;return}case 4:{b=k[c>>2]|0;if((b|0)!=100){e=k[a>>2]|0;k[e+20>>2]=21;k[e+24>>2]=b;Uh[k[e>>2]&2047](a)}k[a+80>>2]=4;k[a+244>>2]=0;k[a+256>>2]=1;k[a+76>>2]=4;e=k[d>>2]|0;k[e>>2]=67;k[e+8>>2]=1;k[e+12>>2]=1;k[e+16>>2]=0;k[e+20>>2]=0;k[e+24>>2]=0;k[e+88>>2]=77;k[e+96>>2]=1;k[e+100>>2]=1;k[e+104>>2]=0;k[e+108>>2]=0;k[e+112>>2]=0;k[e+176>>2]=89;k[e+184>>2]=1;k[e+188>>2]=1;k[e+192>>2]=0;k[e+196>>2]=0;k[e+200>>2]=0;k[e+264>>2]=75;k[e+272>>2]=1;k[e+276>>2]=1;k[e+280>>2]=0;k[e+284>>2]=0;k[e+288>>2]=0;return}case 5:{b=k[c>>2]|0;if((b|0)!=100){e=k[a>>2]|0;k[e+20>>2]=21;k[e+24>>2]=b;Uh[k[e>>2]&2047](a)}k[a+80>>2]=5;k[a+244>>2]=0;k[a+256>>2]=1;k[a+76>>2]=4;e=k[d>>2]|0;k[e>>2]=1;k[e+8>>2]=2;k[e+12>>2]=2;k[e+16>>2]=0;k[e+20>>2]=0;k[e+24>>2]=0;k[e+88>>2]=2;k[e+96>>2]=1;k[e+100>>2]=1;k[e+104>>2]=1;k[e+108>>2]=1;k[e+112>>2]=1;k[e+176>>2]=3;k[e+184>>2]=1;k[e+188>>2]=1;k[e+192>>2]=1;k[e+196>>2]=1;k[e+200>>2]=1;k[e+264>>2]=4;k[e+272>>2]=2;k[e+276>>2]=2;k[e+280>>2]=0;k[e+284>>2]=0;k[e+288>>2]=0;return}case 0:{b=k[c>>2]|0;if((b|0)!=100){e=k[a>>2]|0;k[e+20>>2]=21;k[e+24>>2]=b;Uh[k[e>>2]&2047](a)}k[a+80>>2]=0;k[a+244>>2]=0;k[a+256>>2]=0;b=k[a+36>>2]|0;c=a+76|0;k[c>>2]=b;if((b+-1|0)>>>0>9){e=k[a>>2]|0;k[e+20>>2]=27;k[e+24>>2]=b;k[e+28>>2]=10;Uh[k[e>>2]&2047](a);a=k[c>>2]|0}else a=b;if((a|0)<=0)return;c=k[d>>2]|0;b=0;do{k[c+(b*88|0)>>2]=b;k[c+(b*88|0)+8>>2]=1;k[c+(b*88|0)+12>>2]=1;k[c+(b*88|0)+16>>2]=0;k[c+(b*88|0)+20>>2]=0;k[c+(b*88|0)+24>>2]=0;b=b+1|0}while((b|0)!=(a|0));return}default:{e=k[a>>2]|0;k[e+20>>2]=10;Uh[k[e>>2]&2047](a);return}}}function g8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=k[b>>2]|0;if(!e){e=ci[k[k[a+4>>2]>>2]&255](a,0,280)|0;k[e+276>>2]=0;k[b>>2]=e}f=c;g=e+17|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));e=(l[c+16>>0]|0)+((l[c+15>>0]|0)+((l[c+14>>0]|0)+((l[c+13>>0]|0)+((l[c+12>>0]|0)+((l[c+11>>0]|0)+((l[c+10>>0]|0)+((l[c+9>>0]|0)+((l[c+8>>0]|0)+((l[c+7>>0]|0)+((l[c+6>>0]|0)+((l[c+5>>0]|0)+((l[c+4>>0]|0)+((l[c+3>>0]|0)+((l[c+2>>0]|0)+(l[c+1>>0]|0)))))))))))))))|0;if((e+-1|0)>>>0<=255){a=k[b>>2]|0;a=a+17|0;upb(a|0,d|0,e|0)|0;d=k[b>>2]|0;d=d+276|0;k[d>>2]=0;return}c=k[a>>2]|0;k[c+20>>2]=9;Uh[k[c>>2]&2047](a);a=k[b>>2]|0;a=a+17|0;upb(a|0,d|0,e|0)|0;d=k[b>>2]|0;d=d+276|0;k[d>>2]=0;return}function h8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;h=k[a+76>>2]|0;b=k[a+20>>2]|0;if((b|0)!=100){f=k[a>>2]|0;k[f+20>>2]=21;k[f+24>>2]=b;Uh[k[f>>2]&2047](a)}f=(h|0)==3;if(f)if((k[a+80>>2]|0)==3)e=10;else g=7;else if((h|0)>4)e=h*6|0;else g=7;if((g|0)==7)e=h<<2|2;c=a+428|0;d=k[c>>2]|0;b=a+432|0;if(!((d|0)!=0?(k[b>>2]|0)>=(e|0):0)){d=(e|0)>10?e:10;k[b>>2]=d;d=ci[k[k[a+4>>2]>>2]&255](a,0,d*36|0)|0;k[c>>2]=d}k[a+204>>2]=d;k[a+200>>2]=e;do if(f){g=(k[a+80>>2]|0)==3;k[d>>2]=3;if(g){k[d+4>>2]=0;k[d+8>>2]=1;k[d+12>>2]=2;k[d+24>>2]=0;k[d+20>>2]=0;k[d+28>>2]=0;k[d+32>>2]=1;k[d+36>>2]=1;k[d+40>>2]=0;k[d+56>>2]=1;k[d+60>>2]=5;k[d+64>>2]=0;k[d+68>>2]=2;k[d+72>>2]=1;k[d+76>>2]=2;k[d+92>>2]=1;k[d+96>>2]=63;k[d+100>>2]=0;k[d+104>>2]=1;k[d+108>>2]=1;k[d+112>>2]=1;k[d+128>>2]=1;k[d+132>>2]=63;k[d+136>>2]=0;k[d+140>>2]=1;k[d+144>>2]=1;k[d+148>>2]=0;k[d+164>>2]=6;k[d+168>>2]=63;k[d+172>>2]=0;k[d+176>>2]=2;k[d+180>>2]=1;k[d+184>>2]=0;k[d+200>>2]=1;k[d+204>>2]=63;k[d+208>>2]=2;k[d+212>>2]=1;k[d+216>>2]=3;k[d+220>>2]=0;k[d+224>>2]=1;k[d+228>>2]=2;k[d+240>>2]=0;k[d+236>>2]=0;k[d+244>>2]=1;k[d+248>>2]=0;k[d+252>>2]=1;k[d+256>>2]=2;k[d+272>>2]=1;k[d+276>>2]=63;k[d+280>>2]=1;k[d+284>>2]=0;k[d+288>>2]=1;k[d+292>>2]=1;k[d+308>>2]=1;k[d+312>>2]=63;k[d+316>>2]=1;k[d+320>>2]=0;k[d+324>>2]=1;k[d+328>>2]=0;k[d+344>>2]=1;k[d+348>>2]=63;k[d+352>>2]=1;k[d+356>>2]=0;return}else{b=0;g=16}}else{if((h|0)<5){k[d>>2]=h;if((h|0)>0){b=0;g=16;break}else{g=17;break}}else{b=d;c=0}while(1){k[b>>2]=1;k[b+4>>2]=c;k[b+20>>2]=0;k[b+24>>2]=0;k[b+28>>2]=0;k[b+32>>2]=1;c=c+1|0;if((c|0)==(h|0))break;else b=b+36|0}d=d+(h*36|0)|0;e=0}while(0);if((g|0)==16)while(1){k[d+4+(b<<2)>>2]=b;b=b+1|0;if((b|0)==(h|0)){g=17;break}else g=16}if((g|0)==17){k[d+24>>2]=0;k[d+20>>2]=0;k[d+28>>2]=0;k[d+32>>2]=1;d=d+36|0;e=1}f=(h|0)>0;if(f){b=d;c=0;while(1){k[b>>2]=1;k[b+4>>2]=c;k[b+20>>2]=1;k[b+24>>2]=5;k[b+28>>2]=0;k[b+32>>2]=2;c=c+1|0;if((c|0)==(h|0))break;else b=b+36|0}d=d+(h*36|0)|0;b=d;c=0;while(1){k[b>>2]=1;k[b+4>>2]=c;k[b+20>>2]=6;k[b+24>>2]=63;k[b+28>>2]=0;k[b+32>>2]=2;c=c+1|0;if((c|0)==(h|0))break;else b=b+36|0}d=d+(h*36|0)|0;b=d;c=0;while(1){k[b>>2]=1;k[b+4>>2]=c;k[b+20>>2]=1;k[b+24>>2]=63;k[b+28>>2]=2;k[b+32>>2]=1;c=c+1|0;if((c|0)==(h|0))break;else b=b+36|0}d=d+(h*36|0)|0}if(e){k[d>>2]=h;if(f){b=0;do{k[d+4+(b<<2)>>2]=b;b=b+1|0}while((b|0)!=(h|0))}k[d+24>>2]=0;k[d+20>>2]=0;k[d+28>>2]=1;k[d+32>>2]=0;b=d+36|0}else{b=d;c=0;while(1){k[b>>2]=1;k[b+4>>2]=c;k[b+20>>2]=0;k[b+24>>2]=0;k[b+28>>2]=1;k[b+32>>2]=0;c=c+1|0;if((c|0)==(h|0))break;else b=b+36|0}b=d+(h*36|0)|0}if(f)c=0;else return;while(1){k[b>>2]=1;k[b+4>>2]=c;k[b+20>>2]=1;k[b+24>>2]=63;k[b+28>>2]=1;k[b+32>>2]=0;c=c+1|0;if((c|0)==(h|0))break;else b=b+36|0}return}function i8a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!b)r=a;else{r=k[a>>2]|0;k[r+20>>2]=3;Uh[k[r>>2]&2047](a);r=a}s=a+4|0;q=ci[k[k[s>>2]>>2]&255](r,1,64)|0;k[a+400>>2]=q;k[q>>2]=842;b=q+4|0;if(!(k[(k[a+416>>2]|0)+8>>2]|0)){k[b>>2]=96;e=a+76|0;if((k[e>>2]|0)<=0)return;f=a+280|0;g=a+272|0;h=a+276|0;d=q+8|0;c=0;b=k[a+84>>2]|0;while(1){q=aa(k[f>>2]|0,k[b+28>>2]|0)|0;q=aa(q,k[g>>2]|0)|0;q=Dg[k[(k[s>>2]|0)+8>>2]&127](r,1,(q|0)/(k[b+8>>2]|0)|0,k[h>>2]|0)|0;k[d+(c<<2)>>2]=q;c=c+1|0;if((c|0)>=(k[e>>2]|0))break;else b=b+88|0}return}k[b>>2]=95;n=k[a+276>>2]|0;o=a+76|0;b=aa(n*20|0,k[o>>2]|0)|0;b=ci[k[k[s>>2]>>2]&255](r,1,b)|0;c=k[a+84>>2]|0;if((k[o>>2]|0)<=0)return;p=a+280|0;i=a+272|0;j=n*3|0;l=n*12|0;m=n*5|0;h=n<<1;a=n<<2;if((n|0)>0)g=0;else{d=0;while(1){h=aa(k[p>>2]|0,k[c+28>>2]|0)|0;h=aa(h,k[i>>2]|0)|0;a=b+(n<<2)|0;upb(a|0,Dg[k[(k[s>>2]|0)+8>>2]&127](r,1,(h|0)/(k[c+8>>2]|0)|0,j)|0,l|0)|0;k[q+8+(d<<2)>>2]=a;d=d+1|0;if((d|0)>=(k[o>>2]|0))break;else{c=c+88|0;b=b+(m<<2)|0}}return}while(1){e=aa(k[p>>2]|0,k[c+28>>2]|0)|0;e=aa(e,k[i>>2]|0)|0;e=Dg[k[(k[s>>2]|0)+8>>2]&127](r,1,(e|0)/(k[c+8>>2]|0)|0,j)|0;f=b+(n<<2)|0;upb(f|0,e|0,l|0)|0;d=0;do{k[b+(d<<2)>>2]=k[e+(d+h<<2)>>2];k[b+(d+a<<2)>>2]=k[e+(d<<2)>>2];d=d+1|0}while((d|0)!=(n|0));k[q+8+(g<<2)>>2]=f;g=g+1|0;if((g|0)>=(k[o>>2]|0))break;else{c=c+88|0;b=b+(m<<2)|0}}return}function j8a(a,b){a=a|0;b=b|0;var c=0;c=k[a+400>>2]|0;if(b|0){b=k[a>>2]|0;k[b+20>>2]=3;Uh[k[b>>2]&2047](a)}k[c+48>>2]=k[a+32>>2];k[c+52>>2]=0;k[c+56>>2]=0;k[c+60>>2]=k[a+276>>2]<<1;return}function k8a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=k[a+400>>2]|0;B=a+276|0;o=(k[B>>2]|0)*3|0;p=A+48|0;if((k[f>>2]|0)>>>0>=g>>>0)return;q=A+60|0;r=A+52|0;s=a+412|0;t=A+8|0;u=a+32|0;v=a+76|0;w=a+28|0;x=a+416|0;y=A+56|0;while(1){h=k[c>>2]|0;if(h>>>0>=d>>>0){if(k[p>>2]|0){i=29;break}j=k[r>>2]|0;h=k[q>>2]|0;if((j|0)<(h|0)){i=k[v>>2]|0;if((i|0)>0){n=0;while(1){l=k[A+8+(n<<2)>>2]|0;m=k[w>>2]|0;if((j|0)<(h|0)){i=l+(j+-1<<2)|0;do{upb(k[l+(j<<2)>>2]|0,k[i>>2]|0,m|0)|0;j=j+1|0}while((j|0)!=(h|0));i=k[v>>2]|0}h=n+1|0;if((h|0)>=(i|0))break;n=h;j=k[r>>2]|0;h=k[q>>2]|0}h=k[q>>2]|0}k[r>>2]=h;i=25}else i=24}else{m=d-h|0;n=k[r>>2]|0;l=(k[q>>2]|0)-n|0;m=l>>>0<m>>>0?l:m;eh[k[(k[s>>2]|0)+4>>2]&255](a,b+(h<<2)|0,t,n,m);if((k[p>>2]|0)==(k[u>>2]|0)?(z=k[v>>2]|0,(z|0)>0):0){l=0;i=z;h=k[B>>2]|0;do{if((h|0)>=1){j=A+8+(l<<2)|0;i=1;while(1){h=k[j>>2]|0;upb(k[h+(0-i<<2)>>2]|0,k[h>>2]|0,k[w>>2]|0)|0;h=k[B>>2]|0;if((i|0)<(h|0))i=i+1|0;else break}i=k[v>>2]|0}l=l+1|0}while((l|0)<(i|0))}k[c>>2]=(k[c>>2]|0)+m;j=(k[r>>2]|0)+m|0;k[r>>2]=j;k[p>>2]=(k[p>>2]|0)-m;h=k[q>>2]|0;i=24}if((i|0)==24?(i=0,(j|0)==(h|0)):0)i=25;if((i|0)==25){eh[k[(k[x>>2]|0)+4>>2]&255](a,t,k[y>>2]|0,e,k[f>>2]|0);k[f>>2]=(k[f>>2]|0)+1;i=k[B>>2]|0;h=(k[y>>2]|0)+i|0;k[y>>2]=(h|0)<(o|0)?h:0;h=k[r>>2]|0;if((h|0)>=(o|0)){k[r>>2]=0;h=0}k[q>>2]=i+h}if((k[f>>2]|0)>>>0>=g>>>0){i=29;break}}if((i|0)==29)return}function l8a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;x=k[a+400>>2]|0;h=k[c>>2]|0;if(h>>>0>=d>>>0)return;q=a+276|0;r=x+52|0;s=a+412|0;t=x+8|0;u=x+48|0;y=a+76|0;v=a+28|0;w=a+416|0;while(1){if((k[f>>2]|0)>>>0>=g>>>0){m=28;break}i=d-h|0;l=k[r>>2]|0;p=(k[q>>2]|0)-l|0;i=p>>>0<i>>>0?p:i;eh[k[(k[s>>2]|0)+4>>2]&255](a,b+(h<<2)|0,t,l,i);k[c>>2]=(k[c>>2]|0)+i;l=(k[r>>2]|0)+i|0;k[r>>2]=l;i=(k[u>>2]|0)-i|0;k[u>>2]=i;h=k[q>>2]|0;if(!((i|0)==0&(l|0)<(h|0)))if((l|0)==(h|0))m=15;else h=i;else{i=k[y>>2]|0;if((i|0)>0){p=0;while(1){n=k[x+8+(p<<2)>>2]|0;o=k[v>>2]|0;if((l|0)<(h|0)){m=n+(l+-1<<2)|0;i=l;do{upb(k[n+(i<<2)>>2]|0,k[m>>2]|0,o|0)|0;i=i+1|0}while((i|0)!=(h|0));i=k[y>>2]|0}h=p+1|0;if((h|0)>=(i|0))break;p=h;l=k[r>>2]|0;h=k[q>>2]|0}h=k[q>>2]|0}k[r>>2]=h;m=15}if((m|0)==15){m=0;eh[k[(k[w>>2]|0)+4>>2]&255](a,t,0,e,k[f>>2]|0);k[r>>2]=0;k[f>>2]=(k[f>>2]|0)+1;h=k[u>>2]|0}if((h|0)==0?(j=k[f>>2]|0,j>>>0<g>>>0):0){m=19;break}h=k[c>>2]|0;if(h>>>0>=d>>>0){m=28;break}}if((m|0)==19){i=k[y>>2]|0;a:do if((i|0)>0){b=a+284|0;p=k[a+84>>2]|0;h=0;while(1){m=aa(k[p+40>>2]|0,k[p+12>>2]|0)|0;m=(m|0)/(k[b>>2]|0)|0;n=k[e+(h<<2)>>2]|0;o=aa(k[p+36>>2]|0,k[p+28>>2]|0)|0;j=aa(j,m)|0;m=aa(m,g)|0;if((j|0)<(m|0)){l=n+(j+-1<<2)|0;i=j;do{upb(k[n+(i<<2)>>2]|0,k[l>>2]|0,o|0)|0;i=i+1|0}while((i|0)!=(m|0));i=k[y>>2]|0}h=h+1|0;if((h|0)>=(i|0))break a;p=p+88|0;j=k[f>>2]|0}}while(0);k[f>>2]=g;return}else if((m|0)==28)return}function m8a(a){a=a|0;return}function n8a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;h=k[a+416>>2]|0;i=a+76|0;if((k[i>>2]|0)<=0)return;f=k[a+84>>2]|0;g=0;while(1){j=(k[d+(g<<2)>>2]|0)+((aa(k[h+52+(g<<2)>>2]|0,e)|0)<<2)|0;dh[k[h+12+(g<<2)>>2]&255](a,f,(k[b+(g<<2)>>2]|0)+(c<<2)|0,j);g=g+1|0;if((g|0)>=(k[i>>2]|0))break;else f=f+88|0}return}function o8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=aa(k[b+36>>2]|0,k[b+28>>2]|0)|0;h=c+-4|0;u=a+276|0;b=k[u>>2]|0;f=k[a+28>>2]|0;if((b|0)>-2&(j-f|0)>0){g=f+~j|0;g=j+2-f+((g|0)>-2?g:-2)|0;e=b+1|0;b=0;while(1){t=(k[h+(b<<2)>>2]|0)+f|0;zpb(t|0,i[t+-1>>0]|0,g|0)|0;if((b|0)==(e|0))break;else b=b+1|0}b=k[u>>2]|0}t=k[a+228>>2]|0;s=65536-(t<<9)|0;t=t<<6;if((b|0)<=0)return;r=j+-2|0;if(!r){b=0;do{r=k[d+(b<<2)>>2]|0;p=k[c+(b<<2)>>2]|0;q=k[c+(b+-1<<2)>>2]|0;b=b+1|0;j=k[c+(b<<2)>>2]|0;n=(l[j>>0]|0)+(l[q>>0]|0)|0;m=l[p>>0]|0;o=n+m|0;p=p+1|0;q=(l[j+1>>0]|0)+(l[q+1>>0]|0)+(l[p>>0]|0)|0;n=((aa(m,s)|0)+32768+(aa(o+n+q|0,t)|0)|0)>>>16&255;i[r>>0]=n;p=l[p>>0]|0;q=((aa(p,s)|0)+32768+(aa(o-p+(q<<1)|0,t)|0)|0)>>>16&255;i[r+1>>0]=q}while((b|0)<(k[u>>2]|0));return}o=j+-1|0;h=0;do{p=k[d+(h<<2)>>2]|0;q=k[c+(h<<2)>>2]|0;a=k[c+(h+-1<<2)>>2]|0;h=h+1|0;m=k[c+(h<<2)>>2]|0;b=a+1|0;j=m+1|0;a=(l[m>>0]|0)+(l[a>>0]|0)|0;m=l[q>>0]|0;f=a+m|0;e=q+1|0;g=(l[j>>0]|0)+(l[b>>0]|0)+(l[e>>0]|0)|0;a=((aa(m,s)|0)+32768+(aa(f+a+g|0,t)|0)|0)>>>16&255;i[p>>0]=a;a=r;m=p;while(1){m=m+1|0;v=l[e>>0]|0;e=e+1|0;b=b+1|0;j=j+1|0;n=(l[j>>0]|0)+(l[b>>0]|0)+(l[e>>0]|0)|0;f=((aa(v,s)|0)+32768+(aa(f+g-v+n|0,t)|0)|0)>>>16&255;i[m>>0]=f;a=a+-1|0;if(!a)break;else{f=g;g=n}}v=l[q+o>>0]|0;v=((aa(v,s)|0)+32768+(aa(g-v+(n<<1)|0,t)|0)|0)>>>16&255;i[p+o>>0]=v}while((h|0)<(k[u>>2]|0));return}function p8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;h=a+276|0;e=k[h>>2]|0;g=a+28|0;f=k[g>>2]|0;if((e|0)>0){a=d;while(1){upb(k[a>>2]|0,k[c>>2]|0,f|0)|0;if((e|0)>1){c=c+4|0;a=a+4|0;e=e+-1|0}else break}f=k[g>>2]|0;e=k[h>>2]|0}a=aa(k[b+36>>2]|0,k[b+28>>2]|0)|0;if(!((e|0)>0&(a-f|0)>0))return;c=f+-1-a|0;c=2-f+a+((c|0)>-2?c:-2)|0;a=0;do{b=(k[d+(a<<2)>>2]|0)+f|0;zpb(b|0,i[b+-1>>0]|0,c|0)|0;a=a+1|0}while((a|0)!=(e|0));return}function q8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;h=aa(k[b+36>>2]|0,k[b+28>>2]|0)|0;j=a+276|0;b=k[j>>2]|0;f=k[a+28>>2]|0;a=h<<1;if((b|0)>0&(a-f|0)>0){e=f+-1-a|0;e=a+2-f+((e|0)>-2?e:-2)|0;a=0;do{g=(k[c+(a<<2)>>2]|0)+f|0;zpb(g|0,i[g+-1>>0]|0,e|0)|0;a=a+1|0}while((a|0)!=(b|0));b=k[j>>2]|0}if((b|0)<1|(h|0)==0)return;else e=0;do{b=k[d+(e<<2)>>2]|0;a=k[c+(e<<2)>>2]|0;f=0;g=0;while(1){i[b>>0]=((l[a>>0]|0)+g+(l[a+1>>0]|0)|0)>>>1;f=f+1|0;if((f|0)==(h|0))break;else{b=b+1|0;a=a+2|0;g=g^1}}e=e+1|0}while((e|0)<(k[j>>2]|0));return}function r8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;m=aa(k[b+36>>2]|0,k[b+28>>2]|0)|0;h=c+-4|0;C=a+276|0;b=k[C>>2]|0;f=k[a+28>>2]|0;j=m<<1;if((b|0)>-2&(j-f|0)>0){g=f+-1-j|0;g=j+2-f+((g|0)>-2?g:-2)|0;e=b+1|0;b=0;while(1){B=(k[h+(b<<2)>>2]|0)+f|0;zpb(B|0,i[B+-1>>0]|0,g|0)|0;if((b|0)==(e|0))break;else b=b+1|0}b=k[C>>2]|0}B=k[a+228>>2]|0;A=(aa(B,-80)|0)+16384|0;B=B<<4;if((b|0)<=0)return;z=m+-2|0;y=j+-2|0;t=m+-1|0;m=0;s=0;while(1){u=k[d+(m<<2)>>2]|0;h=k[c+(s<<2)>>2]|0;x=k[c+((s|1)<<2)>>2]|0;v=k[c+(s+-1<<2)>>2]|0;s=s+2|0;w=k[c+(s<<2)>>2]|0;j=l[h>>0]|0;a=l[x>>0]|0;b=l[v>>0]|0;r=l[w>>0]|0;q=h+2|0;p=x+2|0;o=v+2|0;n=w+2|0;r=((aa((l[h+1>>0]|0)+j+a+(l[x+1>>0]|0)|0,A)|0)+32768+(aa(r+b+(l[o>>0]|0)+(l[n>>0]|0)+(a+j+b+(l[v+1>>0]|0)+r+(l[w+1>>0]|0)+(l[q>>0]|0)+(l[p>>0]|0)<<1)|0,B)|0)|0)>>>16&255;i[u>>0]=r;x=x+y|0;r=z;b=u;while(1){b=b+1|0;e=l[q+1>>0]|0;f=l[p+1>>0]|0;g=e+(l[q>>0]|0)+(l[p>>0]|0)+f|0;h=l[o+1>>0]|0;a=l[n+1>>0]|0;j=h+(l[o>>0]|0)+(l[n>>0]|0)+a+(l[q+-1>>0]|0)|0;if(!r)break;a=q+2|0;h=p+2|0;f=o+2|0;e=n+2|0;j=((aa(g,A)|0)+32768+(aa((l[f>>0]|0)+(l[o+-1>>0]|0)+((l[a>>0]|0)+j+(l[p+-1>>0]|0)+(l[h>>0]|0)<<1)+(l[n+-1>>0]|0)+(l[e>>0]|0)|0,B)|0)|0)>>>16&255;i[b>>0]=j;n=e;o=f;p=h;q=a;r=r+-1|0}x=((aa(g,A)|0)+32768+(aa(a+h+(l[v+y+-1>>0]|0)+(l[w+y+-1>>0]|0)+(f+e+j+(l[x+-1>>0]|0)<<1)|0,B)|0)|0)>>>16&255;i[u+t>>0]=x;if((s|0)>=(k[C>>2]|0))break;else m=m+1|0}return}function s8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0;m=aa(k[b+36>>2]|0,k[b+28>>2]|0)|0;n=a+276|0;b=k[n>>2]|0;f=k[a+28>>2]|0;a=m<<1;if((b|0)>0&(a-f|0)>0){e=f+-1-a|0;e=a+2-f+((e|0)>-2?e:-2)|0;a=0;do{j=(k[c+(a<<2)>>2]|0)+f|0;zpb(j|0,i[j+-1>>0]|0,e|0)|0;a=a+1|0}while((a|0)!=(b|0));b=k[n>>2]|0}if((b|0)<1|(m|0)==0)return;else{f=0;h=0}while(1){b=k[d+(h<<2)>>2]|0;a=k[c+((f|1)<<2)>>2]|0;e=k[c+(f<<2)>>2]|0;g=0;j=1;while(1){i[b>>0]=((l[e>>0]|0)+j+(l[e+1>>0]|0)+(l[a>>0]|0)+(l[a+1>>0]|0)|0)>>>2;g=g+1|0;if((g|0)==(m|0))break;else{b=b+1|0;a=a+2|0;e=e+2|0;j=j^3}}f=f+2|0;if((f|0)>=(k[n>>2]|0))break;else h=h+1|0}return}function t8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;s=k[a+416>>2]|0;w=aa(k[b+36>>2]|0,k[b+28>>2]|0)|0;g=k[b+4>>2]|0;h=i[s+92+g>>0]|0;r=h&255;g=i[s+102+g>>0]|0;s=g&255;t=aa(s,r)|0;u=t>>>1;v=a+276|0;b=k[v>>2]|0;f=k[a+28>>2]|0;a=aa(r,w)|0;if((b|0)>0&(a-f|0)>0){e=f+~a|0;e=a+2-f+((e|0)>-2?e:-2)|0;a=0;do{q=(k[c+(a<<2)>>2]|0)+f|0;zpb(q|0,i[q+-1>>0]|0,e|0)|0;a=a+1|0}while((a|0)!=(b|0));b=k[v>>2]|0}if((b|0)<=0)return;q=(w|0)==0;p=g<<24>>24==0;o=h<<24>>24!=0;m=0;n=0;while(1){b=k[d+(n<<2)>>2]|0;a:do if(!q){if(p){e=((u>>>0)/(t>>>0)|0)&255;if(o){a=0;while(1){i[b>>0]=e;a=a+1|0;if((a|0)==(w|0))break a;else b=b+1|0}}else{a=0;while(1){i[b>>0]=e;a=a+1|0;if((a|0)==(w|0))break a;else b=b+1|0}}}else{h=0;j=0}while(1){if(o){f=0;a=0;do{e=(k[c+(f+m<<2)>>2]|0)+h|0;g=0;while(1){a=(l[e>>0]|0)+a|0;g=g+1|0;if((g|0)==(r|0))break;else e=e+1|0}f=f+1|0}while((f|0)!=(s|0))}else a=0;i[b>>0]=(a+u|0)/(t|0)|0;j=j+1|0;if((j|0)==(w|0))break;else{b=b+1|0;h=h+r|0}}}while(0);m=m+s|0;if((m|0)>=(k[v>>2]|0))break;else n=n+1|0}return}function u8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=a+20|0;b=k[j>>2]|0;a:do switch(b|0){case 202:{Q8a(a);if(!(k[a+64>>2]|0)){k[j>>2]=203;c=6;break a}k[j>>2]=207;j=1;return j|0}case 203:{c=6;break}case 204:{b=a+444|0;break}default:{c=k[a>>2]|0;k[c+20>>2]=21;k[c+24>>2]=b;Uh[k[c>>2]&2047](a);c=16}}while(0);if((c|0)==6){g=a+460|0;b:do if(k[(k[g>>2]|0)+16>>2]|0){e=a+8|0;f=a+332|0;b=k[e>>2]|0;c:while(1){if(b|0)Uh[k[b>>2]&2047](a);c=Xh[k[k[g>>2]>>2]&1023](a)|0;switch(c|0){case 2:break b;case 0:{b=0;break c}default:{}}b=k[e>>2]|0;if(!((c|2|0)==3&(b|0)!=0))continue;c=b+4|0;i=(k[c>>2]|0)+1|0;k[c>>2]=i;c=b+8|0;d=k[c>>2]|0;if((i|0)<(d|0))continue;k[c>>2]=(k[f>>2]|0)+d}return b|0}while(0);k[a+152>>2]=k[a+144>>2];c=16}if((c|0)==16){b=a+444|0;if((k[j>>2]|0)!=204){Uh[k[k[b>>2]>>2]&2047](a);k[a+140>>2]=0;k[j>>2]=204}}d:do if(k[(k[b>>2]|0)+8>>2]|0){f=a+140|0;g=a+116|0;h=a+8|0;i=a+448|0;c=k[f>>2]|0;e:while(1){while(1){d=k[g>>2]|0;if(c>>>0>=d>>>0)break;e=k[h>>2]|0;if(!e)d=c;else{k[e+4>>2]=c;k[e+8>>2]=d;Uh[k[e>>2]&2047](a);d=k[f>>2]|0}dh[k[(k[i>>2]|0)+4>>2]&255](a,0,f,0);c=k[f>>2]|0;if((c|0)==(d|0)){b=0;break e}}Uh[k[(k[b>>2]|0)+4>>2]&2047](a);Uh[k[k[b>>2]>>2]&2047](a);k[f>>2]=0;if(!(k[(k[b>>2]|0)+8>>2]|0))break d;else c=0}return b|0}while(0);k[j>>2]=k[a+68>>2]|0?206:205;j=1;return j|0}function v8a(a){a=a|0;var b=0;b=k[a+24>>2]|0;a=ci[k[k[a+4>>2]>>2]&255](a,1,4096)|0;k[b+24>>2]=a;k[b>>2]=a;k[b+4>>2]=4096;return}function w8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;j=k[a+24>>2]|0;l=j+24|0;h=k[l>>2]|0;g=k[j+20>>2]|0;e=g+16|0;b=k[e>>2]|0;d=(b|0)==0;a:do if((k[g+76>>2]|0)>-1){do if(d){b=g+74|0;d=i[b>>0]|0;i[b>>0]=d+255|d;b=k[g>>2]|0;if(!(b&8)){k[g+8>>2]=0;k[g+4>>2]=0;d=k[g+44>>2]|0;k[g+28>>2]=d;f=g+20|0;k[f>>2]=d;c=d+(k[g+48>>2]|0)|0;k[e>>2]=c;break}else{k[g>>2]=b|32;break a}}else{d=g+20|0;c=b;f=d;d=k[d>>2]|0}while(0);b=d;if((c-d|0)>>>0<4096){c=ci[k[g+36>>2]&255](g,h,4096)|0;f=28;break}b:do if((i[g+75>>0]|0)>-1){c=4096;while(1){if(!c){e=4096;d=h;c=0;break b}d=c+-1|0;if((i[h+d>>0]|0)==10)break;else c=d}if((ci[k[g+36>>2]&255](g,h,c)|0)>>>0<c>>>0){f=28;break a}e=4096-c|0;d=h+c|0;b=k[f>>2]|0}else{e=4096;d=h;c=0}while(0);upb(b|0,d|0,e|0)|0;k[f>>2]=(k[f>>2]|0)+e;c=c+e|0;f=28}else{do if(d){b=g+74|0;d=i[b>>0]|0;i[b>>0]=d+255|d;b=k[g>>2]|0;if(!(b&8)){k[g+8>>2]=0;k[g+4>>2]=0;d=k[g+44>>2]|0;k[g+28>>2]=d;f=g+20|0;k[f>>2]=d;c=d+(k[g+48>>2]|0)|0;k[e>>2]=c;break}else{k[g>>2]=b|32;break a}}else{d=g+20|0;c=b;f=d;d=k[d>>2]|0}while(0);b=d;if((c-d|0)>>>0<4096){c=ci[k[g+36>>2]&255](g,h,4096)|0;f=28;break}c:do if((i[g+75>>0]|0)>-1){c=4096;while(1){if(!c){e=4096;d=h;c=0;break c}d=c+-1|0;if((i[h+d>>0]|0)==10)break;else c=d}if((ci[k[g+36>>2]&255](g,h,c)|0)>>>0<c>>>0){f=28;break a}e=4096-c|0;d=h+c|0;b=k[f>>2]|0}else{e=4096;d=h;c=0}while(0);upb(b|0,d|0,e|0)|0;k[f>>2]=(k[f>>2]|0)+e;c=c+e|0;f=28}while(0);if((f|0)==28?(c|0)==4096:0){l=k[l>>2]|0;k[j>>2]=l;l=j+4|0;k[l>>2]=4096;return 1}h=k[a>>2]|0;k[h+20>>2]=38;Uh[k[h>>2]&2047](a);l=k[l>>2]|0;k[j>>2]=l;l=j+4|0;k[l>>2]=4096;return 1}function x8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;b=k[a+24>>2]|0;j=4096-(k[b+4>>2]|0)|0;if(j){h=k[b+24>>2]|0;b=b+20|0;f=k[b>>2]|0;e=f+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[f+76>>2]|0)>-1){do if(d){c=f+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[f>>2]|0;if(!(c&8)){k[f+8>>2]=0;k[f+4>>2]=0;d=k[f+44>>2]|0;k[f+28>>2]=d;g=f+20|0;k[g>>2]=d;c=d+(k[f+48>>2]|0)|0;k[e>>2]=c;e=d;break}else{k[f>>2]=c|32;c=0;break a}}else{e=f+20|0;g=e;e=k[e>>2]|0}while(0);d=e;if((c-e|0)>>>0<j>>>0){c=ci[k[f+36>>2]&255](f,h,j)|0;break}b:do if((i[f+75>>0]|0)>-1){c=j;while(1){if(!c){f=j;e=h;c=0;break b}e=c+-1|0;if((i[h+e>>0]|0)==10)break;else c=e}if((ci[k[f+36>>2]&255](f,h,c)|0)>>>0<c>>>0)break a;f=j-c|0;e=h+c|0;d=k[g>>2]|0}else{f=j;e=h;c=0}while(0);upb(d|0,e|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f;c=c+f|0}else{do if(d){c=f+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[f>>2]|0;if(!(c&8)){k[f+8>>2]=0;k[f+4>>2]=0;d=k[f+44>>2]|0;k[f+28>>2]=d;g=f+20|0;k[g>>2]=d;c=d+(k[f+48>>2]|0)|0;k[e>>2]=c;e=d;break}else{k[f>>2]=c|32;c=0;break a}}else{e=f+20|0;g=e;e=k[e>>2]|0}while(0);d=e;if((c-e|0)>>>0<j>>>0){c=ci[k[f+36>>2]&255](f,h,j)|0;break}c:do if((i[f+75>>0]|0)>-1){c=j;while(1){if(!c){f=j;e=h;c=0;break c}e=c+-1|0;if((i[h+e>>0]|0)==10)break;else c=e}if((ci[k[f+36>>2]&255](f,h,c)|0)>>>0<c>>>0)break a;f=j-c|0;e=h+c|0;d=k[g>>2]|0}else{f=j;e=h;c=0}while(0);upb(d|0,e|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f;c=c+f|0}while(0);if((c|0)!=(j|0)){j=k[a>>2]|0;k[j+20>>2]=38;Uh[k[j>>2]&2047](a)}}else b=b+20|0;Rfb(k[b>>2]|0)|0;if(!(k[k[b>>2]>>2]&32))return;j=k[a>>2]|0;k[j+20>>2]=38;Uh[k[j>>2]&2047](a);return}function y8a(a){a=a|0;k[(k[a+24>>2]|0)+36>>2]=1;return}function z8a(a){a=a|0;var b=0,c=0,d=0,e=0;c=k[a+24>>2]|0;d=c+32|0;b=_fb(k[d>>2]|0,1,4096,k[c+28>>2]|0)|0;e=c+36|0;if(b|0){a=b;d=k[d>>2]|0;k[c>>2]=d;d=c+4|0;k[d>>2]=a;k[e>>2]=0;return 1}if(!(k[e>>2]|0))b=a;else{b=k[a>>2]|0;k[b+20>>2]=43;Uh[k[b>>2]&2047](a);b=a}a=k[a>>2]|0;k[a+20>>2]=123;jh[k[a+4>>2]&1023](b,-1);i[k[d>>2]>>0]=-1;i[(k[d>>2]|0)+1>>0]=-39;a=2;d=k[d>>2]|0;k[c>>2]=d;d=c+4|0;k[d>>2]=a;k[e>>2]=0;return 1}function A8a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=k[a+24>>2]|0;if((b|0)<=0)return;f=e+4|0;c=k[f>>2]|0;if((c|0)<(b|0)){d=e+12|0;do{b=b-c|0;Xh[k[d>>2]&1023](a)|0;c=k[f>>2]|0}while((b|0)>(c|0))}k[e>>2]=(k[e>>2]|0)+b;k[f>>2]=c-b;return}function B8a(a){a=a|0;return}function C8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;G=a+460|0;b=k[G>>2]|0;H=b+20|0;if(k[H>>2]|0){M=2;return M|0}I=a+464|0;K=b+24|0;L=a+340|0;F=b+16|0;n=a+32|0;o=a+212|0;p=a+36|0;q=a+316|0;r=a+320|0;s=a+216|0;t=a+220|0;u=a+224|0;v=a+416|0;w=a+412|0;x=a+420|0;y=a+424|0;m=a+428|0;z=a+432|0;A=a+436|0;B=a+324|0;C=a+328|0;D=a+28|0;E=a+332|0;a:while(1){b=Xh[k[(k[I>>2]|0)+4>>2]&1023](a)|0;switch(b|0){case 2:{M=57;break a}case 1:break;default:{M=62;break a}}b:do switch(k[K>>2]|0){case 0:{if(!(k[F>>2]|0)){l=k[a>>2]|0;k[l+20>>2]=36;Uh[k[l>>2]&2047](a)}if(!(k[L>>2]|0))continue a;else{M=56;break a}}case 1:{if(!((k[n>>2]|0)<=65500?(k[D>>2]|0)<=65500:0)){l=k[a>>2]|0;k[l+20>>2]=42;k[l+24>>2]=65500;Uh[k[l>>2]&2047](a)}b=k[o>>2]|0;if((b|0)!=8){l=k[a>>2]|0;k[l+20>>2]=16;k[l+24>>2]=b;Uh[k[l>>2]&2047](a)}b=k[p>>2]|0;if((b|0)>10){l=k[a>>2]|0;k[l+20>>2]=27;k[l+24>>2]=b;k[l+28>>2]=10;Uh[k[l>>2]&2047](a);b=k[p>>2]|0}k[q>>2]=1;k[r>>2]=1;if((b|0)>0){h=0;i=k[s>>2]|0;e=1;g=1;while(1){c=i+8|0;d=k[c>>2]|0;f=i+12|0;if((d+-1|0)>>>0<=3?(J=k[f>>2]|0,(J+-1|0)>>>0<=3):0)c=J;else{g=k[a>>2]|0;k[g+20>>2]=19;Uh[k[g>>2]&2047](a);g=k[q>>2]|0;d=k[c>>2]|0;e=k[r>>2]|0;c=k[f>>2]|0;b=k[p>>2]|0}g=(g|0)>(d|0)?g:d;k[q>>2]=g;e=(e|0)>(c|0)?e:c;k[r>>2]=e;h=h+1|0;if((h|0)>=(b|0))break;else i=i+88|0}}c:do if(!(k[t>>2]|0)){if(k[u>>2]|0?k[L>>2]|0:0){M=22;break}do switch(k[v>>2]|0){case 0:{k[m>>2]=1;k[z>>2]=153432;k[A>>2]=0;j=1;l=b;break c}case 3:{k[m>>2]=2;k[z>>2]=154612;k[A>>2]=3;j=2;l=b;break c}case 8:{k[m>>2]=3;k[z>>2]=154512;k[A>>2]=8;j=3;l=b;break c}case 15:{k[m>>2]=4;k[z>>2]=154384;k[A>>2]=15;j=4;l=b;break c}case 24:{k[m>>2]=5;k[z>>2]=154220;k[A>>2]=24;j=5;l=b;break c}case 35:{k[m>>2]=6;k[z>>2]=154012;k[A>>2]=35;j=6;l=b;break c}case 48:{k[m>>2]=7;k[z>>2]=153752;k[A>>2]=48;j=7;l=b;break c}case 63:{k[m>>2]=8;k[z>>2]=153432;k[A>>2]=63;j=8;l=b;break c}case 80:{k[m>>2]=9;k[z>>2]=153432;k[A>>2]=63;j=9;l=b;break c}case 99:{k[m>>2]=10;k[z>>2]=153432;k[A>>2]=63;j=10;l=b;break c}case 120:{k[m>>2]=11;k[z>>2]=153432;k[A>>2]=63;j=11;l=b;break c}case 143:{k[m>>2]=12;k[z>>2]=153432;k[A>>2]=63;j=12;l=b;break c}case 168:{k[m>>2]=13;k[z>>2]=153432;k[A>>2]=63;j=13;l=b;break c}case 195:{k[m>>2]=14;k[z>>2]=153432;k[A>>2]=63;j=14;l=b;break c}case 224:{k[m>>2]=15;k[z>>2]=153432;k[A>>2]=63;j=15;l=b;break c}case 255:{k[m>>2]=16;k[z>>2]=153432;k[A>>2]=63;j=16;l=b;break c}default:{j=k[a>>2]|0;k[j+20>>2]=17;k[j+24>>2]=k[w>>2];k[j+28>>2]=k[v>>2];k[j+32>>2]=k[x>>2];k[j+36>>2]=k[y>>2];Uh[k[j>>2]&2047](a);j=k[m>>2]|0;l=k[p>>2]|0;break c}}while(0)}else M=22;while(0);if((M|0)==22){M=0;k[m>>2]=8;k[z>>2]=153432;k[A>>2]=63;j=8;l=b}k[B>>2]=j;k[C>>2]=j;d:do if((l|0)>0){h=k[D>>2]|0;i=k[q>>2]|0;b=k[n>>2]|0;c=k[r>>2]|0;f=aa(j,c)|0;g=l+-1|0;d=0;e=k[s>>2]|0;while(1){k[e+36>>2]=j;k[e+40>>2]=j;N=aa(i,j)|0;O=(aa(k[e+8>>2]|0,h)|0)+-1|0;k[e+28>>2]=(O+N|0)/(N|0)|0;N=(aa(k[e+12>>2]|0,b)|0)+-1|0;k[e+32>>2]=(N+f|0)/(f|0)|0;k[e+44>>2]=(O+i|0)/(i|0)|0;k[e+48>>2]=(N+c|0)/(c|0)|0;k[e+52>>2]=1;k[e+80>>2]=0;if((d|0)==(g|0))break d;d=d+1|0;e=e+88|0}}else{c=k[r>>2]|0;b=k[n>>2]|0}while(0);O=aa(j,c)|0;k[E>>2]=(b+-1+O|0)/(O|0)|0;b=k[L>>2]|0;if((b|0)>=(l|0)?(k[u>>2]|0)==0:0){k[(k[G>>2]|0)+16>>2]=0;break b}k[(k[G>>2]|0)+16>>2]=1;break}default:b=k[L>>2]|0}while(0);if(b|0){M=52;break}k[K>>2]=2}if((M|0)==52){k[K>>2]=0;O=1;return O|0}else if((M|0)==56){E8a(a);O=1;return O|0}else if((M|0)==57){k[H>>2]=1;if(!(k[K>>2]|0)){c=a+152|0;b=k[a+144>>2]|0;if((k[c>>2]|0)<=(b|0)){O=2;return O|0}k[c>>2]=b;O=2;return O|0}else{if(!(k[(k[I>>2]|0)+16>>2]|0)){O=2;return O|0}O=k[a>>2]|0;k[O+20>>2]=62;Uh[k[O>>2]&2047](a);O=2;return O|0}}else if((M|0)==62)return b|0;return 0}function D8a(a){a=a|0;var b=0;b=k[a+460>>2]|0;k[b>>2]=782;k[b+16>>2]=0;k[b+20>>2]=0;k[b+24>>2]=1;Uh[k[(k[a>>2]|0)+16>>2]&2047](a);Uh[k[k[a+464>>2]>>2]&2047](a);k[a+160>>2]=0;return}function E8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+340|0;b=k[i>>2]|0;if((b|0)!=1){if((b+-1|0)>>>0>3){h=k[a>>2]|0;k[h+20>>2]=27;k[h+24>>2]=b;k[h+28>>2]=4;Uh[k[h>>2]&2047](a);b=k[i>>2]|0}e=k[a+428>>2]|0;h=aa(e,k[a+316>>2]|0)|0;k[a+360>>2]=((k[a+28>>2]|0)+-1+h|0)/(h|0)|0;e=aa(e,k[a+320>>2]|0)|0;k[a+364>>2]=((k[a+32>>2]|0)+-1+e|0)/(e|0)|0;e=a+368|0;k[e>>2]=0;if((b|0)<=0){h=a+468|0;h=k[h>>2]|0;h=k[h>>2]|0;Uh[h&2047](a);h=a+452|0;i=k[h>>2]|0;i=k[i>>2]|0;Uh[i&2047](a);h=k[h>>2]|0;h=h+4|0;h=k[h>>2]|0;i=a+460|0;i=k[i>>2]|0;k[i>>2]=h;return}d=0;c=0;while(1){h=k[a+344+(d<<2)>>2]|0;j=k[h+8>>2]|0;k[h+56>>2]=j;f=k[h+12>>2]|0;k[h+60>>2]=f;b=aa(f,j)|0;k[h+64>>2]=b;g=aa(k[h+36>>2]|0,j)|0;k[h+68>>2]=g;g=((k[h+28>>2]|0)>>>0)%(j>>>0)|0;k[h+72>>2]=(g|0)==0?j:g;g=((k[h+32>>2]|0)>>>0)%(f>>>0)|0;k[h+76>>2]=(g|0)==0?f:g;if((b+c|0)>10){j=k[a>>2]|0;k[j+20>>2]=14;Uh[k[j>>2]&2047](a)}if((b|0)>0)while(1){j=k[e>>2]|0;k[e>>2]=j+1;k[a+372+(j<<2)>>2]=d;if((b|0)>1)b=b+-1|0;else break}b=d+1|0;c=k[i>>2]|0;if((b|0)>=(c|0))break;d=b;c=k[e>>2]|0}if((c|0)>0){g=a;h=a;b=c}else{i=a+468|0;i=k[i>>2]|0;i=k[i>>2]|0;Uh[i&2047](a);i=a+452|0;j=k[i>>2]|0;j=k[j>>2]|0;Uh[j&2047](a);i=k[i>>2]|0;i=i+4|0;i=k[i>>2]|0;j=a+460|0;j=k[j>>2]|0;k[j>>2]=i;return}}else{g=k[a+344>>2]|0;k[a+360>>2]=k[g+28>>2];h=k[g+32>>2]|0;k[a+364>>2]=h;k[g+56>>2]=1;k[g+60>>2]=1;k[g+64>>2]=1;k[g+68>>2]=k[g+36>>2];k[g+72>>2]=1;b=k[g+12>>2]|0;h=(h>>>0)%(b>>>0)|0;k[g+76>>2]=(h|0)==0?b:h;k[a+368>>2]=1;k[a+372>>2]=0;g=a;h=a;b=1}f=a+4|0;e=0;do{c=k[a+344+(e<<2)>>2]|0;d=c+80|0;if(!(k[d>>2]|0)){c=k[c+16>>2]|0;b=a+164+(c<<2)|0;if(!(c>>>0<=3?(k[b>>2]|0)!=0:0)){j=k[h>>2]|0;k[j+20>>2]=54;k[j+24>>2]=c;Uh[k[j>>2]&2047](g)}j=ci[k[k[f>>2]>>2]&255](g,1,132)|0;upb(j|0,k[b>>2]|0,132)|0;k[d>>2]=j;b=k[i>>2]|0}e=e+1|0}while((e|0)<(b|0));i=a+468|0;i=k[i>>2]|0;i=k[i>>2]|0;Uh[i&2047](a);i=a+452|0;j=k[i>>2]|0;j=k[j>>2]|0;Uh[j&2047](a);i=k[i>>2]|0;i=i+4|0;i=k[i>>2]|0;j=a+460|0;j=k[j>>2]|0;k[j>>2]=i;return}function F8a(a){a=a|0;k[k[a+460>>2]>>2]=782;return}function G8a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;i=a+440|0;l=k[i>>2]|0;m=k[a>>2]|0;k[m+20>>2]=124;k[m+24>>2]=l;k[m+28>>2]=b;jh[k[m+4>>2]&1023](a,-1);m=b+1&7|208;g=b+2&7|208;h=b+7&7|208;f=b+6&7|208;a:while(1){e=(l&-8|0)==208;j=(l|0)==(m|0);b=(l|0)==(g|0);c=(l|0)==(h|0);d=(l|0)==(f|0);b:do if((l|0)<192){c=k[a>>2]|0;k[c+20>>2]=99;d=c+24|0;if(e){k[d>>2]=l;k[c+28>>2]=2;jh[k[c+4>>2]&1023](a,4);break}b=k[c+4>>2]|0;if(j){k[d>>2]=m;k[c+28>>2]=2;jh[b&1023](a,4);break}else{k[d>>2]=l;k[c+28>>2]=2;jh[b&1023](a,4);break}}else{if(!e){c=11;break a}b=j|b?3:c|d?2:1;c=b&255;while(1){j=k[a>>2]|0;k[j+20>>2]=99;k[j+24>>2]=l;k[j+28>>2]=b;jh[k[j+4>>2]&1023](a,4);switch(c&3){case 1:{c=14;break a}case 3:{b=1;c=17;break a}case 2:break b;default:{}}}}while(0);if(!(H8a(a)|0)){b=0;c=17;break}l=k[i>>2]|0}if((c|0)==11){b=k[a>>2]|0;k[b+20>>2]=99;c=b+24|0;d=k[b+4>>2]|0;if(j){k[c>>2]=m;k[b+28>>2]=3;jh[d&1023](a,4);m=1;return m|0}else{k[c>>2]=l;k[b+28>>2]=3;jh[d&1023](a,4);m=1;return m|0}}else if((c|0)==14){k[i>>2]=0;m=1;return m|0}else if((c|0)==17)return b|0;return 0}function H8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=k[a+24>>2]|0;j=h+4|0;g=h+12|0;l=a+464|0;b=k[j>>2]|0;c=k[h>>2]|0;a:while(1){if(!b){if(!(Xh[k[g>>2]&1023](a)|0)){b=0;d=19;break}b=k[j>>2]|0;d=k[h>>2]|0}else d=c;b=b+-1|0;c=d+1|0;if((i[d>>0]|0)!=-1)do{f=(k[l>>2]|0)+24|0;k[f>>2]=(k[f>>2]|0)+1;k[h>>2]=c;k[j>>2]=b;if(!b){if(!(Xh[k[g>>2]&1023](a)|0)){b=0;d=19;break a}b=k[j>>2]|0;d=k[h>>2]|0}else d=c;b=b+-1|0;c=d+1|0}while((i[d>>0]|0)!=-1);do{if(!b){if(!(Xh[k[g>>2]&1023](a)|0)){b=0;d=19;break a}b=k[j>>2]|0;d=k[h>>2]|0}else d=c;b=b+-1|0;c=d+1|0;e=i[d>>0]|0}while(e<<24>>24==-1);d=(k[l>>2]|0)+24|0;f=k[d>>2]|0;if(e<<24>>24){d=16;break}k[d>>2]=f+2;k[h>>2]=c;k[j>>2]=b}if((d|0)==16){d=e&255;if(f|0){g=k[a>>2]|0;k[g+20>>2]=119;k[g+24>>2]=f;k[g+28>>2]=d;jh[k[g+4>>2]&1023](a,-1);k[(k[l>>2]|0)+24>>2]=0}k[a+440>>2]=d;k[h>>2]=c;k[j>>2]=b;l=1;return l|0}else if((d|0)==19)return b|0;return 0}function I8a(a){a=a|0;var b=0;b=k[a+464>>2]|0;k[a+216>>2]=0;k[a+144>>2]=0;k[a+440>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+24>>2]=0;k[b+164>>2]=0;return}function J8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0;Fb=r;r=r+288|0;L=Fb+256|0;W=Fb;Db=a+440|0;Eb=a+464|0;za=a+24|0;Ka=a+232|0;Va=a+248|0;eb=a+264|0;ib=a+233|0;M=a+249|0;N=a+265|0;O=a+234|0;P=a+250|0;Q=a+266|0;R=a+235|0;S=a+251|0;T=a+267|0;U=a+236|0;V=a+252|0;X=a+268|0;Y=a+237|0;Z=a+253|0;_=a+269|0;$=a+238|0;aa=a+254|0;ba=a+270|0;ca=a+239|0;da=a+255|0;ea=a+271|0;fa=a+240|0;ga=a+256|0;ha=a+272|0;ia=a+241|0;ja=a+257|0;ka=a+273|0;la=a+242|0;ma=a+258|0;na=a+274|0;oa=a+243|0;pa=a+259|0;qa=a+275|0;ra=a+244|0;sa=a+260|0;ta=a+276|0;ua=a+245|0;va=a+261|0;wa=a+277|0;xa=a+246|0;ya=a+262|0;Aa=a+278|0;Ba=a+247|0;Ca=a+263|0;Da=a+279|0;Ea=a+280|0;Fa=a+40|0;Ga=a+304|0;Ha=a+308|0;Ia=a+284|0;Ja=a+288|0;La=a+289|0;Ma=a+290|0;Na=a+292|0;Oa=a+294|0;Pa=a+296|0;Qa=a+300|0;Ra=L+1|0;Sa=L+2|0;Ta=L+3|0;Ua=L+4|0;Wa=L+5|0;Xa=L+6|0;Ya=L+7|0;Za=L+8|0;_a=L+9|0;$a=L+10|0;ab=L+11|0;bb=L+12|0;cb=L+13|0;db=L+14|0;fb=L+15|0;gb=L+16|0;zb=a+36|0;Ab=a+216|0;hb=a+4|0;b=k[Db>>2]|0;a:while(1){do if(!b){if(k[(k[Eb>>2]|0)+12>>2]|0){if(!(H8a(a)|0)){jb=0;qb=325;break a}b=k[Db>>2]|0;break}o=k[za>>2]|0;p=o+4|0;b=k[p>>2]|0;if(!b){if(!(Xh[k[o+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[p>>2]|0}h=k[o>>2]|0;b=b+-1|0;c=h+1|0;h=i[h>>0]|0;n=h&255;if(!b){if(!(Xh[k[o+12>>2]&1023](a)|0)){jb=0;qb=325;break a}g=k[p>>2]|0;c=k[o>>2]|0}else g=b;u=i[c>>0]|0;b=u&255;if(h<<24>>24!=-1|u<<24>>24!=-40){u=k[a>>2]|0;k[u+20>>2]=55;k[u+24>>2]=n;k[u+28>>2]=b;Uh[k[u>>2]&2047](a)}k[Db>>2]=b;k[o>>2]=c+1;k[p>>2]=g+-1}while(0);do switch(b|0){case 218:{qb=25;break a}case 217:{qb=84;break a}case 216:{b=k[a>>2]|0;k[b+20>>2]=104;jh[k[b+4>>2]&1023](a,1);b=k[Eb>>2]|0;if(k[b+12>>2]|0){b=k[a>>2]|0;k[b+20>>2]=64;Uh[k[b>>2]&2047](a);b=k[Eb>>2]|0}i[Ka>>0]=0;i[Va>>0]=1;i[eb>>0]=5;i[ib>>0]=0;i[M>>0]=1;i[N>>0]=5;i[O>>0]=0;i[P>>0]=1;i[Q>>0]=5;i[R>>0]=0;i[S>>0]=1;i[T>>0]=5;i[U>>0]=0;i[V>>0]=1;i[X>>0]=5;i[Y>>0]=0;i[Z>>0]=1;i[_>>0]=5;i[$>>0]=0;i[aa>>0]=1;i[ba>>0]=5;i[ca>>0]=0;i[da>>0]=1;i[ea>>0]=5;i[fa>>0]=0;i[ga>>0]=1;i[ha>>0]=5;i[ia>>0]=0;i[ja>>0]=1;i[ka>>0]=5;i[la>>0]=0;i[ma>>0]=1;i[na>>0]=5;i[oa>>0]=0;i[pa>>0]=1;i[qa>>0]=5;i[ra>>0]=0;i[sa>>0]=1;i[ta>>0]=5;i[ua>>0]=0;i[va>>0]=1;i[wa>>0]=5;i[xa>>0]=0;i[ya>>0]=1;i[Aa>>0]=5;i[Ba>>0]=0;i[Ca>>0]=1;i[Da>>0]=5;k[Ea>>2]=0;k[Fa>>2]=0;k[Ga>>2]=0;k[Ha>>2]=0;k[Ia>>2]=0;i[Ja>>0]=1;i[La>>0]=1;i[Ma>>0]=0;j[Na>>1]=1;j[Oa>>1]=1;k[Pa>>2]=0;i[Qa>>0]=0;k[b+12>>2]=1;break}case 192:{if(!(N8a(a,1,0,0)|0)){jb=0;qb=325;break a}break}case 193:{if(!(N8a(a,0,0,0)|0)){jb=0;qb=325;break a}break}case 194:{if(!(N8a(a,0,1,0)|0)){jb=0;qb=325;break a}break}case 201:{if(!(N8a(a,0,0,1)|0)){jb=0;qb=325;break a}break}case 202:{if(!(N8a(a,0,1,1)|0)){jb=0;qb=325;break a}break}case 207:case 206:case 205:case 203:case 200:case 199:case 198:case 197:case 195:{u=k[a>>2]|0;k[u+20>>2]=63;k[u+24>>2]=b;Uh[k[u>>2]&2047](a);break}case 204:{t=k[za>>2]|0;u=t+4|0;b=k[u>>2]|0;if(!b){if(!(Xh[k[t+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[u>>2]|0}h=k[t>>2]|0;b=b+-1|0;c=h+1|0;h=l[h>>0]<<8;if(!b){if(!(Xh[k[t+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[u>>2]|0;g=k[t>>2]|0}else g=c;c=b+-1|0;b=g+1|0;s=l[g>>0]|h;g=s+-2|0;if(s>>>0>2){s=t+12|0;q=g;while(1){if(!c){if(!(Xh[k[s>>2]&1023](a)|0)){jb=0;qb=325;break a}c=k[u>>2]|0;b=k[t>>2]|0}c=c+-1|0;g=b+1|0;o=i[b>>0]|0;p=o&255;if(!c){if(!(Xh[k[s>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[u>>2]|0;g=k[t>>2]|0}else b=c;c=b+-1|0;b=g+1|0;h=i[g>>0]|0;n=h&255;g=q+-2|0;Gb=k[a>>2]|0;k[Gb+20>>2]=81;k[Gb+24>>2]=p;k[Gb+28>>2]=n;jh[k[Gb+4>>2]&1023](a,1);if((o&255)<=31)if((o&255)<=15){o=n&15;i[a+232+p>>0]=o;Gb=(h&255)>>>4;i[a+248+p>>0]=Gb;if(o>>>0>(Gb&255)>>>0){Gb=k[a>>2]|0;k[Gb+20>>2]=30;k[Gb+24>>2]=n;Uh[k[Gb>>2]&2047](a)}}else qb=102;else{qb=k[a>>2]|0;k[qb+20>>2]=29;k[qb+24>>2]=p;Uh[k[qb>>2]&2047](a);qb=102}if((qb|0)==102){qb=0;i[p+-16+(a+264)>>0]=h}if((q|0)>2)q=g;else break}}if(g|0){Gb=k[a>>2]|0;k[Gb+20>>2]=12;Uh[k[Gb>>2]&2047](a)}k[t>>2]=b;k[u>>2]=c;break}case 196:{s=k[za>>2]|0;t=s+4|0;b=k[t>>2]|0;if(!b){if(!(Xh[k[s+12>>2]&1023](a)|0)){qb=139;break a}b=k[t>>2]|0}h=k[s>>2]|0;b=b+-1|0;c=h+1|0;h=l[h>>0]<<8;if(!b){if(!(Xh[k[s+12>>2]&1023](a)|0)){qb=139;break a}b=k[t>>2]|0;g=k[s>>2]|0}else g=c;c=b+-1|0;b=g+1|0;g=(l[g>>0]|h)+-2|0;if((g|0)>16){q=s+12|0;do{if(!c){if(!(Xh[k[q>>2]&1023](a)|0)){qb=139;break a}c=k[t>>2]|0;b=k[s>>2]|0}p=l[b>>0]|0;h=k[a>>2]|0;k[h+20>>2]=82;k[h+24>>2]=p;jh[k[h+4>>2]&1023](a,1);i[L>>0]=0;h=1;o=0;b=b+1|0;c=c+-1|0;do{if(!c){if(!(Xh[k[q>>2]&1023](a)|0)){qb=139;break a}c=k[t>>2]|0;b=k[s>>2]|0}Gb=i[b>>0]|0;i[L+h>>0]=Gb;o=(Gb&255)+o|0;h=h+1|0;c=c+-1|0;b=b+1|0}while((h|0)<17);n=g+-17|0;Gb=k[a>>2]|0;k[Gb+24>>2]=l[Ra>>0];k[Gb+28>>2]=l[Sa>>0];k[Gb+32>>2]=l[Ta>>0];k[Gb+36>>2]=l[Ua>>0];k[Gb+40>>2]=l[Wa>>0];k[Gb+44>>2]=l[Xa>>0];k[Gb+48>>2]=l[Ya>>0];k[Gb+52>>2]=l[Za>>0];k[Gb+20>>2]=88;jh[k[Gb+4>>2]&1023](a,2);Gb=k[a>>2]|0;k[Gb+24>>2]=l[_a>>0];k[Gb+28>>2]=l[$a>>0];k[Gb+32>>2]=l[ab>>0];k[Gb+36>>2]=l[bb>>0];k[Gb+40>>2]=l[cb>>0];k[Gb+44>>2]=l[db>>0];k[Gb+48>>2]=l[fb>>0];k[Gb+52>>2]=l[gb>>0];k[Gb+20>>2]=88;jh[k[Gb+4>>2]&1023](a,2);if((o|0)>256|(n|0)<(o|0)){Gb=k[a>>2]|0;k[Gb+20>>2]=9;Uh[k[Gb>>2]&2047](a)}if((o|0)>0){h=0;while(1){if(!c){if(!(Xh[k[q>>2]&1023](a)|0)){qb=139;break a}c=k[t>>2]|0;b=k[s>>2]|0}c=c+-1|0;g=b+1|0;i[W+h>>0]=i[b>>0]|0;h=h+1|0;if((h|0)>=(o|0)){b=g;break}else b=g}}g=n-o|0;u=(p&16|0)==0;Gb=p+-16|0;h=u?p:Gb;p=u?a+180+(p<<2)|0:a+196+(Gb<<2)|0;if(h>>>0>3){Gb=k[a>>2]|0;k[Gb+20>>2]=31;k[Gb+24>>2]=h;Uh[k[Gb>>2]&2047](a)}h=k[p>>2]|0;if(!h){h=ci[k[k[hb>>2]>>2]&255](a,0,280)|0;k[h+276>>2]=0;k[p>>2]=h}n=L;o=h+17|0;do{i[h>>0]=i[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(o|0));upb((k[p>>2]|0)+17|0,W|0,256)|0}while((g|0)>16)}if(g|0){Gb=k[a>>2]|0;k[Gb+20>>2]=12;Uh[k[Gb>>2]&2047](a)}k[s>>2]=b;k[t>>2]=c;break}case 219:{t=k[za>>2]|0;u=t+4|0;b=k[u>>2]|0;if(!b){if(!(Xh[k[t+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[u>>2]|0}n=k[t>>2]|0;b=b+-1|0;c=n+1|0;n=l[n>>0]<<8;if(!b){if(!(Xh[k[t+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[u>>2]|0;h=k[t>>2]|0}else h=c;g=b+-1|0;c=h+1|0;Gb=l[h>>0]|n;b=Gb+-2|0;if(Gb>>>0>2){s=t+12|0;while(1){q=b+-1|0;if(!g){if(!(Xh[k[s>>2]&1023](a)|0)){jb=0;qb=325;break a}g=k[u>>2]|0;c=k[t>>2]|0}h=l[c>>0]|0;o=h>>>4;h=h&15;Gb=k[a>>2]|0;k[Gb+20>>2]=83;k[Gb+24>>2]=h;k[Gb+28>>2]=o;jh[k[Gb+4>>2]&1023](a,1);if(h>>>0>3){Gb=k[a>>2]|0;k[Gb+20>>2]=32;k[Gb+24>>2]=h;Uh[k[Gb>>2]&2047](a)}h=a+164+(h<<2)|0;n=k[h>>2]|0;if(!n){n=ci[k[k[hb>>2]>>2]&255](a,0,132)|0;k[n+128>>2]=0;k[h>>2]=n}p=(o|0)!=0;if(p)if((b|0)<129){b=0;do{j[n+(b<<1)>>1]=1;b=b+1|0}while((b|0)!=64);y=q>>1;qb=162}else qb=169;else if((b|0)<65){b=0;do{j[n+(b<<1)>>1]=1;b=b+1|0}while((b|0)!=64);y=q;qb=162}else qb=169;b:do if((qb|0)==162){qb=0;switch(y|0){case 4:{b=154612;f=4;break}case 9:{b=154512;f=y;break}case 16:{b=154384;f=y;break}case 25:{b=154220;f=y;break}case 36:{b=154012;f=y;break}case 49:{b=153752;f=y;break}default:{g=g+-1|0;b=c+1|0;if((y|0)>0){B=153432;f=y;z=b;A=g;qb=171;break b}else{x=y;w=g;v=b;break b}}}B=b;z=c+1|0;A=g+-1|0;qb=171}else if((qb|0)==169){B=153432;f=64;z=c+1|0;A=g+-1|0;qb=171}while(0);c:do if((qb|0)==171){qb=0;if(p){o=0;c=z;b=A}else{g=0;c=z;b=A;while(1){if(!b){if(!(Xh[k[s>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[u>>2]|0;c=k[t>>2]|0}j[n+(k[B+(g<<2)>>2]<<1)>>1]=l[c>>0]|0;g=g+1|0;b=b+-1|0;c=c+1|0;if((g|0)>=(f|0)){x=f;w=b;v=c;break c}}}while(1){if(!b){if(!(Xh[k[s>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[u>>2]|0;c=k[t>>2]|0}b=b+-1|0;g=c+1|0;h=l[c>>0]<<8;if(!b){if(!(Xh[k[s>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[u>>2]|0;c=k[t>>2]|0}else c=g;j[n+(k[B+(o<<2)>>2]<<1)>>1]=l[c>>0]|h;o=o+1|0;b=b+-1|0;c=c+1|0;if((o|0)>=(f|0)){x=f;w=b;v=c;break}}}while(0);c=k[a>>2]|0;d:do if((k[c+104>>2]|0)>1){b=0;while(1){k[c+24>>2]=m[n+(b<<1)>>1];k[c+28>>2]=m[n+((b|1)<<1)>>1];k[c+32>>2]=m[n+((b|2)<<1)>>1];k[c+36>>2]=m[n+((b|3)<<1)>>1];k[c+40>>2]=m[n+((b|4)<<1)>>1];k[c+44>>2]=m[n+((b|5)<<1)>>1];k[c+48>>2]=m[n+((b|6)<<1)>>1];k[c+52>>2]=m[n+((b|7)<<1)>>1];k[c+20>>2]=95;jh[k[c+4>>2]&1023](a,2);b=b+8|0;if((b|0)>=64)break d;c=k[a>>2]|0}}while(0);b=q-x+(p?0-x|0:0)|0;if((b|0)>0){c=v;g=w}else{g=w;c=v;break}}}if(b|0){Gb=k[a>>2]|0;k[Gb+20>>2]=12;Uh[k[Gb>>2]&2047](a)}k[t>>2]=c;k[u>>2]=g;break}case 221:{n=k[za>>2]|0;o=n+4|0;b=k[o>>2]|0;if(!b){if(!(Xh[k[n+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[o>>2]|0}h=k[n>>2]|0;b=b+-1|0;c=h+1|0;h=l[h>>0]<<8;if(!b){if(!(Xh[k[n+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[o>>2]|0;g=k[n>>2]|0}else g=c;b=b+-1|0;c=g+1|0;if((l[g>>0]|h|0)!=4){Gb=k[a>>2]|0;k[Gb+20>>2]=12;Uh[k[Gb>>2]&2047](a)}if(!b){if(!(Xh[k[n+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[o>>2]|0;c=k[n>>2]|0}g=b+-1|0;b=c+1|0;h=l[c>>0]<<8;if(!g){if(!(Xh[k[n+12>>2]&1023](a)|0)){jb=0;qb=325;break a}c=k[o>>2]|0;b=k[n>>2]|0}else c=g;Gb=l[b>>0]|h;u=k[a>>2]|0;k[u+20>>2]=84;k[u+24>>2]=Gb;jh[k[u+4>>2]&1023](a,1);k[Ea>>2]=Gb;k[n>>2]=b+1;k[o>>2]=c+-1;break}case 248:{p=k[za>>2]|0;c=k[p>>2]|0;q=p+4|0;o=k[q>>2]|0;if(!(k[(k[Eb>>2]|0)+16>>2]|0)){g=k[a>>2]|0;k[g+20>>2]=60;g=g+24|0;e:do if(!((g^405849)&3)){f:do if(1){b=80;h=405849;do{Gb=i[h>>0]|0;i[g>>0]=Gb;if(!(Gb<<24>>24))break f;b=b+-1|0;h=h+1|0;g=g+1|0}while((h&3|0)!=0)}else{b=80;h=405849}while(0);if(i[h>>0]|0){g:do if(b>>>0>3){n=h;while(1){h=k[n>>2]|0;if((h&-2139062144^-2139062144)&h+-16843009|0)break;k[g>>2]=h;b=b+-4|0;h=n+4|0;g=g+4|0;if(b>>>0>3)n=h;else break g}E=n;F=g;I=b;qb=216;break e}while(0);if(!b){C=g;D=0}else{E=h;F=g;I=b;qb=216}}else{C=g;D=b}}else{E=405849;F=g;I=80;qb=216}while(0);h:do if((qb|0)==216)while(1){qb=0;Gb=i[E>>0]|0;i[F>>0]=Gb;if(!(Gb<<24>>24)){C=F;D=I;break h}I=I+-1|0;b=F+1|0;if(!I){C=b;D=0;break}else{E=E+1|0;F=b}}while(0);zpb(C|0,0,D|0)|0;Uh[k[k[a>>2]>>2]&2047](a)}do if((k[zb>>2]|0)>=3){if(!o){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0}else b=o;b=b+-1|0;g=c+1|0;h=l[c>>0]<<8;if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;g=k[p>>2]|0}b=b+-1|0;c=g+1|0;if((l[g>>0]|h|0)!=24){Gb=k[a>>2]|0;k[Gb+20>>2]=12;Uh[k[Gb>>2]&2047](a)}if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0}b=b+-1|0;g=c+1|0;if((i[c>>0]|0)!=13){Gb=k[a>>2]|0;k[Gb+20>>2]=70;k[Gb+24>>2]=k[Db>>2];Uh[k[Gb>>2]&2047](a)}if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0}else c=g;b=b+-1|0;g=c+1|0;h=l[c>>0]<<8;if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;g=k[p>>2]|0}b=b+-1|0;c=g+1|0;if((l[g>>0]|h|0)==255){if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0}b=b+-1|0;g=c+1|0;if((i[c>>0]|0)==3){if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;g=k[p>>2]|0}b=b+-1|0;c=g+1|0;h=k[Ab>>2]|0;if((l[g>>0]|0)==(k[h+88>>2]|0)){if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0;n=k[Ab>>2]|0}else n=h;b=b+-1|0;g=c+1|0;if((l[c>>0]|0)==(k[n>>2]|0)){if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;h=k[p>>2]|0;c=k[Ab>>2]|0}else{h=g;c=n}b=b+-1|0;g=h+1|0;if((l[h>>0]|0)!=(k[c+176>>2]|0)){G=b;H=g;qb=310;break}if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;g=k[p>>2]|0}b=b+-1|0;c=g+1|0;if((i[g>>0]|0)!=-128){G=b;H=c;qb=310;break}if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0}b=b+-1|0;g=c+1|0;h=l[c>>0]<<8;if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;g=k[p>>2]|0}b=b+-1|0;c=g+1|0;if(l[g>>0]|h|0){G=b;H=c;qb=310;break}if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0}b=b+-1|0;g=c+1|0;h=l[c>>0]<<8;if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;g=k[p>>2]|0}b=b+-1|0;c=g+1|0;if(l[g>>0]|h|0){G=b;H=c;qb=310;break}if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0}b=b+-1|0;g=c+1|0;if(i[c>>0]|0){G=b;H=g;qb=310;break}if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0}else c=g;b=b+-1|0;g=c+1|0;h=l[c>>0]<<8;if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;g=k[p>>2]|0}b=b+-1|0;c=g+1|0;if((l[g>>0]|h|0)!=1){G=b;H=c;qb=310;break}if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0}b=b+-1|0;g=c+1|0;h=l[c>>0]<<8;if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;g=k[p>>2]|0}b=b+-1|0;c=g+1|0;if(l[g>>0]|h|0){G=b;H=c;qb=310;break}if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0}b=b+-1|0;g=c+1|0;if(i[c>>0]|0){G=b;H=g;qb=310;break}if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0}else c=g;b=b+-1|0;g=c+1|0;h=l[c>>0]<<8;if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;g=k[p>>2]|0}b=b+-1|0;c=g+1|0;if((l[g>>0]|h|0)!=1){G=b;H=c;qb=310;break}if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;c=k[p>>2]|0}b=b+-1|0;g=c+1|0;h=l[c>>0]<<8;if(!b){if(!(Xh[k[p+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[q>>2]|0;g=k[p>>2]|0}b=b+-1|0;c=g+1|0;if(!(l[g>>0]|h)){J=b;K=c}else{G=b;H=c;qb=310}}else{G=b;H=g;qb=310}}else{G=b;H=c;qb=310}}else{G=b;H=g;qb=310}}else{G=b;H=c;qb=310}}else{G=o;H=c;qb=310}while(0);if((qb|0)==310){qb=0;J=k[a>>2]|0;k[J+20>>2]=28;Uh[k[J>>2]&2047](a);J=G;K=H}k[Ga>>2]=1;k[p>>2]=K;k[q>>2]=J;break}case 239:case 238:case 237:case 236:case 235:case 234:case 233:case 232:case 231:case 230:case 229:case 228:case 227:case 226:case 225:case 224:{if(!(Xh[k[(k[Eb>>2]|0)+32+(b+-224<<2)>>2]&1023](a)|0)){jb=0;qb=325;break a}break}case 254:{if(!(Xh[k[(k[Eb>>2]|0)+28>>2]&1023](a)|0)){jb=0;qb=325;break a}break}case 1:case 215:case 214:case 213:case 212:case 211:case 210:case 209:case 208:{Gb=k[a>>2]|0;k[Gb+20>>2]=94;k[Gb+24>>2]=b;jh[k[Gb+4>>2]&1023](a,1);break}case 220:{h=k[za>>2]|0;n=h+4|0;b=k[n>>2]|0;if(!b){if(!(Xh[k[h+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[n>>2]|0}c=k[h>>2]|0;b=b+-1|0;g=c+1|0;c=l[c>>0]<<8;if(!b){if(!(Xh[k[h+12>>2]&1023](a)|0)){jb=0;qb=325;break a}b=k[n>>2]|0;g=k[h>>2]|0}Gb=l[g>>0]|c;c=Gb+-2|0;u=k[a>>2]|0;k[u+20>>2]=93;k[u+24>>2]=k[Db>>2];k[u+28>>2]=c;jh[k[u+4>>2]&1023](a,1);k[h>>2]=g+1;k[n>>2]=b+-1;if(Gb>>>0>2)jh[k[(k[za>>2]|0)+16>>2]&1023](a,c);break}default:{Gb=k[a>>2]|0;k[Gb+20>>2]=70;k[Gb+24>>2]=b;Uh[k[Gb>>2]&2047](a)}}while(0);k[Db>>2]=0;b=0}if((qb|0)==25){q=k[za>>2]|0;c=k[q>>2]|0;s=q+4|0;b=k[s>>2]|0;if(!(k[(k[Eb>>2]|0)+16>>2]|0)){g=k[a>>2]|0;k[g+20>>2]=60;g=g+24|0;i:do if(!((g^405845)&3)){j:do if(1){f=80;h=405845;do{Gb=i[h>>0]|0;i[g>>0]=Gb;if(!(Gb<<24>>24))break j;f=f+-1|0;h=h+1|0;g=g+1|0}while((h&3|0)!=0)}else{f=80;h=405845}while(0);if(i[h>>0]|0){k:do if(f>>>0>3){n=h;while(1){h=k[n>>2]|0;if((h&-2139062144^-2139062144)&h+-16843009|0)break;k[g>>2]=h;f=f+-4|0;h=n+4|0;g=g+4|0;if(f>>>0>3)n=h;else break k}mb=n;e=g;nb=f;qb=36;break i}while(0);if(!f){kb=g;lb=0}else{mb=h;e=g;nb=f;qb=36}}else{kb=g;lb=f}}else{mb=405845;e=g;nb=80;qb=36}while(0);l:do if((qb|0)==36)while(1){qb=0;Gb=i[mb>>0]|0;i[e>>0]=Gb;if(!(Gb<<24>>24)){kb=e;lb=nb;break l}nb=nb+-1|0;e=e+1|0;if(!nb){kb=e;lb=0;break}else mb=mb+1|0}while(0);zpb(kb|0,0,lb|0)|0;Uh[k[k[a>>2]>>2]&2047](a)}do if(!b)if(!(Xh[k[q+12>>2]&1023](a)|0)){Gb=0;r=Fb;return Gb|0}else{b=k[s>>2]|0;c=k[q>>2]|0;break}while(0);b=b+-1|0;e=c+1|0;f=l[c>>0]<<8;do if(!b)if(!(Xh[k[q+12>>2]&1023](a)|0)){Gb=0;r=Fb;return Gb|0}else{b=k[s>>2]|0;c=k[q>>2]|0;break}else c=e;while(0);b=b+-1|0;e=c+1|0;g=l[c>>0]|f;do if(!b)if(!(Xh[k[q+12>>2]&1023](a)|0)){Gb=0;r=Fb;return Gb|0}else{c=k[s>>2]|0;f=k[q>>2]|0;break}else{c=b;f=e}while(0);h=i[f>>0]|0;p=h&255;Gb=k[a>>2]|0;k[Gb+20>>2]=105;k[Gb+24>>2]=p;jh[k[Gb+4>>2]&1023](a,1);do if(!((h&255)>4|(g|0)!=((p<<1)+6|0))){if(h<<24>>24){k[a+340>>2]=p;d=c+-1|0;ob=f+1|0;pb=d;d=(d|0)==0;qb=54;break}if(k[a+224>>2]|0){k[a+340>>2]=p;b=c+-1|0;if(!b){xb=1;qb=73}else{vb=b;Bb=f+1|0;Cb=1}}else qb=53}else qb=53;while(0);if((qb|0)==53){e=k[a>>2]|0;k[e+20>>2]=12;Uh[k[e>>2]&2047](a);k[a+340>>2]=p;e=c+-1|0;b=f+1|0;c=(e|0)==0;if(!(h<<24>>24)){tb=e;ub=b;wb=c;yb=1;qb=72}else{ob=b;pb=e;d=c;qb=54}}m:do if((qb|0)==54){n=q+12|0;o=a+344|0;b=ob;c=pb;h=0;while(1){if(d){if(!(Xh[k[n>>2]&1023](a)|0)){jb=0;qb=325;break}c=k[s>>2]|0;b=k[q>>2]|0}g=c+-1|0;d=b+1|0;c=l[b>>0]|0;n:do if((h|0)>0){b=0;while(1){if((c|0)==(k[k[a+344+(b<<2)>>2]>>2]|0))break;b=b+1|0;if((b|0)>=(h|0))break n}b=k[k[o>>2]>>2]|0;if((h|0)>1){c=1;do{Gb=k[k[a+344+(c<<2)>>2]>>2]|0;b=(Gb|0)>(b|0)?Gb:b;c=c+1|0}while((c|0)!=(h|0))}c=b+1|0}while(0);b=k[Ab>>2]|0;f=k[zb>>2]|0;o:do if((f|0)>0){e=0;while(1){if((c|0)==(k[b>>2]|0)){sb=b;break o}e=e+1|0;b=b+88|0;if((e|0)>=(f|0)){rb=b;qb=67;break}}}else{rb=b;qb=67}while(0);if((qb|0)==67){qb=0;sb=k[a>>2]|0;k[sb+20>>2]=4;k[sb+24>>2]=c;Uh[k[sb>>2]&2047](a);sb=rb}k[a+344+(h<<2)>>2]=sb;if(!g){if(!(Xh[k[n>>2]&1023](a)|0)){jb=0;qb=325;break}b=k[s>>2]|0;d=k[q>>2]|0}else b=g;c=l[d>>0]|0;pb=sb+20|0;k[pb>>2]=c>>>4;Gb=sb+24|0;k[Gb>>2]=c&15;c=k[a>>2]|0;k[c+24>>2]=k[sb>>2];k[c+28>>2]=k[pb>>2];k[c+32>>2]=k[Gb>>2];k[c+20>>2]=106;jh[k[c+4>>2]&1023](a,1);h=h+1|0;c=b+-1|0;b=d+1|0;d=(c|0)==0;if((h|0)>=(p|0)){tb=c;ub=b;wb=d;yb=0;qb=72;break m}}if((qb|0)==325){r=Fb;return jb|0}}while(0);if((qb|0)==72)if(wb){xb=yb;qb=73}else{vb=tb;Bb=ub;Cb=yb}do if((qb|0)==73)if(!(Xh[k[q+12>>2]&1023](a)|0)){Gb=0;r=Fb;return Gb|0}else{vb=k[s>>2]|0;Bb=k[q>>2]|0;Cb=xb;break}while(0);b=vb+-1|0;c=Bb+1|0;f=a+412|0;k[f>>2]=l[Bb>>0];do if(!b)if(!(Xh[k[q+12>>2]&1023](a)|0)){Gb=0;r=Fb;return Gb|0}else{b=k[s>>2]|0;d=k[q>>2]|0;break}else d=c;while(0);c=b+-1|0;b=d+1|0;e=a+416|0;k[e>>2]=l[d>>0];do if(!c)if(!(Xh[k[q+12>>2]&1023](a)|0)){Gb=0;r=Fb;return Gb|0}else{c=k[s>>2]|0;b=k[q>>2]|0;break}while(0);Gb=l[b>>0]|0;Ab=a+420|0;k[Ab>>2]=Gb>>>4;Bb=a+424|0;k[Bb>>2]=Gb&15;Gb=k[a>>2]|0;k[Gb+24>>2]=k[f>>2];k[Gb+28>>2]=k[e>>2];k[Gb+32>>2]=k[Ab>>2];k[Gb+36>>2]=k[Bb>>2];k[Gb+20>>2]=107;jh[k[Gb+4>>2]&1023](a,1);k[(k[Eb>>2]|0)+20>>2]=0;if(!Cb){Gb=a+144|0;k[Gb>>2]=(k[Gb>>2]|0)+1}k[q>>2]=b+1;k[s>>2]=c+-1;k[Db>>2]=0;Gb=1;r=Fb;return Gb|0}else if((qb|0)==84){Gb=k[a>>2]|0;k[Gb+20>>2]=87;jh[k[Gb+4>>2]&1023](a,1);k[Db>>2]=0;Gb=2;r=Fb;return Gb|0}else if((qb|0)==139){Gb=0;r=Fb;return Gb|0}else if((qb|0)==325){r=Fb;return jb|0}return 0}function K8a(a){a=a|0;var b=0,c=0,d=0,e=0;e=a+440|0;b=k[e>>2]|0;do if(!b)if(!(H8a(a)|0)){e=0;return e|0}else{b=k[e>>2]|0;break}while(0);c=a+464|0;d=k[(k[c>>2]|0)+20>>2]|0;if((b|0)!=(d+208|0)){if(!(Hh[k[(k[a+24>>2]|0)+20>>2]&511](a,d)|0)){e=0;return e|0}}else{b=k[a>>2]|0;k[b+20>>2]=100;k[b+24>>2]=d;jh[k[b+4>>2]&1023](a,3);k[e>>2]=0}e=(k[c>>2]|0)+20|0;k[e>>2]=(k[e>>2]|0)+1&7;e=1;return e|0}function L8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=a+24|0;f=k[e>>2]|0;g=f+4|0;b=k[g>>2]|0;do if(!b)if(!(Xh[k[f+12>>2]&1023](a)|0)){g=0;return g|0}else{b=k[g>>2]|0;break}while(0);c=k[f>>2]|0;b=b+-1|0;d=c+1|0;c=(l[c>>0]|0)<<8;do if(!b)if(!(Xh[k[f+12>>2]&1023](a)|0)){g=0;return g|0}else{b=k[g>>2]|0;d=k[f>>2]|0;break}while(0);h=l[d>>0]|0|c;c=h+-2|0;i=k[a>>2]|0;k[i+20>>2]=93;k[i+24>>2]=k[a+440>>2];k[i+28>>2]=c;jh[k[i+4>>2]&1023](a,1);k[f>>2]=d+1;k[g>>2]=b+-1;if(h>>>0<=2){i=1;return i|0}jh[k[(k[e>>2]|0)+16>>2]&1023](a,c);i=1;return i|0}function M8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+16|0;s=w;t=a+24|0;u=k[t>>2]|0;v=u+4|0;b=k[v>>2]|0;do if(!b)if(!(Xh[k[u+12>>2]&1023](a)|0)){v=0;r=w;return v|0}else{b=k[v>>2]|0;break}while(0);d=k[u>>2]|0;b=b+-1|0;c=d+1|0;d=l[d>>0]<<8;do if(!b)if(!(Xh[k[u+12>>2]&1023](a)|0)){v=0;r=w;return v|0}else{b=k[v>>2]|0;c=k[u>>2]|0;break}while(0);q=l[c>>0]|d;g=q+-2|0;f=(g|0)>13?14:q>>>0>2?g:0;b=b+-1|0;c=c+1|0;a:do if(!f){p=b;n=c}else{e=u+12|0;d=0;while(1){if(!b){if(!(Xh[k[e>>2]&1023](a)|0)){b=0;break}b=k[v>>2]|0;c=k[u>>2]|0}i[s+d>>0]=i[c>>0]|0;d=d+1|0;b=b+-1|0;c=c+1|0;if(d>>>0>=f>>>0){p=b;n=c;break a}}r=w;return b|0}while(0);o=g-f|0;b=k[a+440>>2]|0;b:do switch(b|0){case 224:{if(f>>>0>13){if((i[s>>0]|0)==74?(i[s+1>>0]|0)==70:0)if(((i[s+2>>0]|0)==73?(i[s+3>>0]|0)==70:0)?(i[s+4>>0]|0)==0:0){k[a+284>>2]=1;d=i[s+5>>0]|0;e=a+288|0;i[e>>0]=d;g=i[s+6>>0]|0;i[a+289>>0]=g;b=i[s+7>>0]|0;i[a+290>>0]=b;h=l[s+8>>0]<<8|l[s+9>>0];f=a+292|0;j[f>>1]=h;c=l[s+10>>0]<<8|l[s+11>>0];j[a+294>>1]=c;if(d<<24>>24==1){m=a;f=1;e=g;d=h}else{b=k[a>>2]|0;k[b+20>>2]=122;k[b+24>>2]=d&255;k[b+28>>2]=g&255;jh[k[b+4>>2]&1023](a,-1);b=k[e>>2]|0;c=k[f>>2]|0;m=a;f=b&255;e=(b&65535)>>>8&255;d=c;c=c>>>16;b=b>>>16&255}h=k[a>>2]|0;k[h+24>>2]=f;k[h+28>>2]=e&255;k[h+32>>2]=d&65535;k[h+36>>2]=c&65535;k[h+40>>2]=b&255;k[h+20>>2]=89;jh[k[h+4>>2]&1023](m,1);b=s+12|0;d=i[b>>0]|0;e=s+13|0;c=i[e>>0]|0;if((c|d)<<24>>24){s=k[a>>2]|0;k[s+20>>2]=92;k[s+24>>2]=d&255;k[s+28>>2]=c&255;jh[k[s+4>>2]&1023](m,1);d=i[b>>0]|0;c=i[e>>0]|0}b=q+-16|0;if((b|0)==(aa((d&255)*3|0,c&255)|0))break b;s=k[a>>2]|0;k[s+20>>2]=90;k[s+24>>2]=b;jh[k[s+4>>2]&1023](m,1);break b}else h=29}else if(f>>>0>5&(i[s>>0]|0)==74?(i[s+1>>0]|0)==70:0)h=29;if((((h|0)==29?(i[s+2>>0]|0)==88:0)?(i[s+3>>0]|0)==88:0)?(i[s+4>>0]|0)==0:0){b=i[s+5>>0]|0;switch(b<<24>>24){case 16:{s=k[a>>2]|0;k[s+20>>2]=110;k[s+24>>2]=g;jh[k[s+4>>2]&1023](a,1);break b}case 17:{s=k[a>>2]|0;k[s+20>>2]=111;k[s+24>>2]=g;jh[k[s+4>>2]&1023](a,1);break b}case 19:{s=k[a>>2]|0;k[s+20>>2]=112;k[s+24>>2]=g;jh[k[s+4>>2]&1023](a,1);break b}default:{s=k[a>>2]|0;k[s+20>>2]=91;k[s+24>>2]=b&255;k[s+28>>2]=g;jh[k[s+4>>2]&1023](a,1);break b}}}s=k[a>>2]|0;k[s+20>>2]=79;k[s+24>>2]=g;jh[k[s+4>>2]&1023](a,1);break}case 238:{if((((f>>>0>11&(i[s>>0]|0)==65?(i[s+1>>0]|0)==100:0)?(i[s+2>>0]|0)==111:0)?(i[s+3>>0]|0)==98:0)?(i[s+4>>0]|0)==101:0){g=l[s+7>>0]<<8|l[s+8>>0];h=l[s+9>>0]<<8|l[s+10>>0];q=i[s+11>>0]|0;m=k[a>>2]|0;k[m+24>>2]=l[s+5>>0]<<8|l[s+6>>0];k[m+28>>2]=g;k[m+32>>2]=h;k[m+36>>2]=q&255;k[m+20>>2]=78;jh[k[m+4>>2]&1023](a,1);k[a+296>>2]=1;i[a+300>>0]=q;break b}s=k[a>>2]|0;k[s+20>>2]=80;k[s+24>>2]=g;jh[k[s+4>>2]&1023](a,1);break}default:{s=k[a>>2]|0;k[s+20>>2]=70;k[s+24>>2]=b;Uh[k[s>>2]&2047](a)}}while(0);k[u>>2]=n;k[v>>2]=p;if((o|0)<=0){v=1;r=w;return v|0}jh[k[(k[t>>2]|0)+16>>2]&1023](a,o);v=1;r=w;return v|0}function N8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0;o=k[a+24>>2]|0;f=k[o>>2]|0;p=o+4|0;e=k[p>>2]|0;k[a+220>>2]=b;k[a+224>>2]=c;k[a+228>>2]=d;do if(!e)if(!(Xh[k[o+12>>2]&1023](a)|0)){p=0;return p|0}else{e=k[p>>2]|0;f=k[o>>2]|0;break}while(0);e=e+-1|0;b=f+1|0;c=(l[f>>0]|0)<<8;do if(!e)if(!(Xh[k[o+12>>2]&1023](a)|0)){p=0;return p|0}else{e=k[p>>2]|0;f=k[o>>2]|0;break}else f=b;while(0);e=e+-1|0;b=f+1|0;h=l[f>>0]|0|c;do if(!e)if(!(Xh[k[o+12>>2]&1023](a)|0)){p=0;return p|0}else{e=k[p>>2]|0;f=k[o>>2]|0;break}else f=b;while(0);e=e+-1|0;b=f+1|0;k[a+212>>2]=l[f>>0];do if(!e)if(!(Xh[k[o+12>>2]&1023](a)|0)){p=0;return p|0}else{e=k[p>>2]|0;f=k[o>>2]|0;break}else f=b;while(0);e=e+-1|0;b=f+1|0;f=(l[f>>0]|0)<<8;g=a+32|0;k[g>>2]=f;do if(!e)if(!(Xh[k[o+12>>2]&1023](a)|0)){p=0;return p|0}else{e=k[p>>2]|0;b=k[o>>2]|0;c=k[g>>2]|0;break}else c=f;while(0);e=e+-1|0;f=b+1|0;k[g>>2]=c+(l[b>>0]|0);do if(!e)if(!(Xh[k[o+12>>2]&1023](a)|0)){p=0;return p|0}else{e=k[p>>2]|0;f=k[o>>2]|0;break}while(0);e=e+-1|0;b=f+1|0;f=(l[f>>0]|0)<<8;d=a+28|0;k[d>>2]=f;do if(!e)if(!(Xh[k[o+12>>2]&1023](a)|0)){p=0;return p|0}else{e=k[p>>2]|0;b=k[o>>2]|0;f=k[d>>2]|0;break}while(0);e=e+-1|0;c=b+1|0;k[d>>2]=f+(l[b>>0]|0);do if(!e)if(!(Xh[k[o+12>>2]&1023](a)|0)){p=0;return p|0}else{b=k[p>>2]|0;c=k[o>>2]|0;break}else b=e;while(0);m=a+36|0;k[m>>2]=l[c>>0];f=h+-8|0;n=k[a>>2]|0;k[n+24>>2]=k[a+440>>2];k[n+28>>2]=k[d>>2];k[n+32>>2]=k[g>>2];k[n+36>>2]=k[m>>2];k[n+20>>2]=102;jh[k[n+4>>2]&1023](a,1);n=a+464|0;if(k[(k[n>>2]|0)+16>>2]|0){j=k[a>>2]|0;k[j+20>>2]=61;Uh[k[j>>2]&2047](a)}if(((k[g>>2]|0)!=0?(k[d>>2]|0)!=0:0)?(i=k[m>>2]|0,(i|0)>=1):0)e=i;else{e=k[a>>2]|0;k[e+20>>2]=33;Uh[k[e>>2]&2047](a);e=k[m>>2]|0}if((f|0)!=(e*3|0)){j=k[a>>2]|0;k[j+20>>2]=12;Uh[k[j>>2]&2047](a)}j=a+216|0;if(!(k[j>>2]|0)){i=ci[k[k[a+4>>2]>>2]&255](a,1,(k[m>>2]|0)*88|0)|0;k[j>>2]=i}b=b+-1|0;e=c+1|0;a:do if((k[m>>2]|0)>0){i=o+12|0;h=0;while(1){if(!b){if(!(Xh[k[i>>2]&1023](a)|0)){e=0;f=55;break}b=k[p>>2]|0;e=k[o>>2]|0}d=b+-1|0;f=e+1|0;c=l[e>>0]|0;g=k[j>>2]|0;b:do if((h|0)>0){e=g;b=0;while(1){if((c|0)==(k[e>>2]|0))break;b=b+1|0;e=e+88|0;if((b|0)>=(h|0)){b=c;g=e;break b}}b=k[g>>2]|0;e=g+88|0;if((h|0)>1){c=1;while(1){q=k[e>>2]|0;b=(q|0)>(b|0)?q:b;c=c+1|0;if((c|0)==(h|0))break;else e=e+88|0}e=g+(h*88|0)|0}b=b+1|0;g=e}else b=c;while(0);k[g>>2]=b;k[g+4>>2]=h;if(!d){if(!(Xh[k[i>>2]&1023](a)|0)){e=0;f=55;break}e=k[p>>2]|0;f=k[o>>2]|0}else e=d;e=e+-1|0;b=f+1|0;q=l[f>>0]|0;c=g+8|0;k[c>>2]=q>>>4;d=g+12|0;k[d>>2]=q&15;if(!e){if(!(Xh[k[i>>2]&1023](a)|0)){e=0;f=55;break}e=k[p>>2]|0;f=k[o>>2]|0}else f=b;q=g+16|0;k[q>>2]=l[f>>0];b=k[a>>2]|0;k[b+24>>2]=k[g>>2];k[b+28>>2]=k[c>>2];k[b+32>>2]=k[d>>2];k[b+36>>2]=k[q>>2];k[b+20>>2]=103;jh[k[b+4>>2]&1023](a,1);h=h+1|0;b=e+-1|0;e=f+1|0;if((h|0)>=(k[m>>2]|0))break a}if((f|0)==55)return e|0}while(0);k[(k[n>>2]|0)+16>>2]=1;k[o>>2]=e;k[p>>2]=b;q=1;return q|0}function O8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=k[a+20>>2]|0;if((b|0)!=202){s=k[a>>2]|0;k[s+20>>2]=21;k[s+24>>2]=b;Uh[k[s>>2]&2047](a)}s=k[a+428>>2]|0;b=aa(s,k[a+48>>2]|0)|0;c=k[a+52>>2]|0;do if(b>>>0>c>>>0){if(b>>>0<=c<<1>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d<<1)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r<<1)+-1+s|0)/(s|0)|0;k[a+324>>2]=2;k[a+328>>2]=2;q=2;break}if(b>>>0<=(c*3|0)>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d*3|0)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r*3|0)+-1+s|0)/(s|0)|0;k[a+324>>2]=3;k[a+328>>2]=3;q=3;break}if(b>>>0<=c<<2>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d<<2)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r<<2)+-1+s|0)/(s|0)|0;k[a+324>>2]=4;k[a+328>>2]=4;q=4;break}if(b>>>0<=(c*5|0)>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d*5|0)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r*5|0)+-1+s|0)/(s|0)|0;k[a+324>>2]=5;k[a+328>>2]=5;q=5;break}if(b>>>0<=(c*6|0)>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d*6|0)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r*6|0)+-1+s|0)/(s|0)|0;k[a+324>>2]=6;k[a+328>>2]=6;q=6;break}if(b>>>0<=(c*7|0)>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d*7|0)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r*7|0)+-1+s|0)/(s|0)|0;k[a+324>>2]=7;k[a+328>>2]=7;q=7;break}if(b>>>0<=c<<3>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d<<3)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r<<3)+-1+s|0)/(s|0)|0;k[a+324>>2]=8;k[a+328>>2]=8;q=8;break}if(b>>>0<=(c*9|0)>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d*9|0)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r*9|0)+-1+s|0)/(s|0)|0;k[a+324>>2]=9;k[a+328>>2]=9;q=9;break}if(b>>>0<=(c*10|0)>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d*10|0)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r*10|0)+-1+s|0)/(s|0)|0;k[a+324>>2]=10;k[a+328>>2]=10;q=10;break}if(b>>>0<=(c*11|0)>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d*11|0)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r*11|0)+-1+s|0)/(s|0)|0;k[a+324>>2]=11;k[a+328>>2]=11;q=11;break}if(b>>>0<=(c*12|0)>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d*12|0)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r*12|0)+-1+s|0)/(s|0)|0;k[a+324>>2]=12;k[a+328>>2]=12;q=12;break}if(b>>>0<=(c*13|0)>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d*13|0)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r*13|0)+-1+s|0)/(s|0)|0;k[a+324>>2]=13;k[a+328>>2]=13;q=13;break}if(b>>>0<=(c*14|0)>>>0){d=k[a+28>>2]|0;k[a+112>>2]=((d*14|0)+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=((r*14|0)+-1+s|0)/(s|0)|0;k[a+324>>2]=14;k[a+328>>2]=14;q=14;break}d=k[a+28>>2]|0;e=k[a+32>>2]|0;if(b>>>0>(c*15|0)>>>0){k[a+112>>2]=((d<<4)+-1+s|0)/(s|0)|0;k[a+116>>2]=((e<<4)+-1+s|0)/(s|0)|0;k[a+324>>2]=16;k[a+328>>2]=16;q=16;r=e;break}else{k[a+112>>2]=((d*15|0)+-1+s|0)/(s|0)|0;k[a+116>>2]=((e*15|0)+-1+s|0)/(s|0)|0;k[a+324>>2]=15;k[a+328>>2]=15;q=15;r=e;break}}else{d=k[a+28>>2]|0;k[a+112>>2]=(d+-1+s|0)/(s|0)|0;r=k[a+32>>2]|0;k[a+116>>2]=(r+-1+s|0)/(s|0)|0;k[a+324>>2]=1;k[a+328>>2]=1;q=1}while(0);b=k[a+36>>2]|0;g=(b|0)>0;c=k[a+216>>2]|0;if(g){e=0;f=c;while(1){k[f+36>>2]=q;k[f+40>>2]=q;e=e+1|0;if((e|0)==(b|0))break;else f=f+88|0}if(g){o=k[a+76>>2]|0?8:4;p=a+320|0;if(q>>>0>o>>>0){g=q<<1;e=c;f=0;while(1){h=e+36|0;k[h>>2]=q;k[e+40>>2]=q;if(q>>>0>g>>>0)k[h>>2]=g;f=f+1|0;if((f|0)==(b|0))break;else e=e+88|0}}else{n=k[a+316>>2]|0;l=c;m=0;while(1){f=k[l+8>>2]|0;e=1;while(1){g=e<<1;if((n|0)%(aa(g,f)|0)|0|0)break;if((aa(q,g)|0)>(o|0)){e=g;break}else e=g}i=aa(q,e)|0;j=l+36|0;k[j>>2]=i;f=k[p>>2]|0;g=k[l+12>>2]|0;e=1;while(1){h=e<<1;if((f|0)%(aa(h,g)|0)|0|0)break;if((aa(q,h)|0)>(o|0)){e=h;break}else e=h}f=aa(q,e)|0;g=l+40|0;k[g>>2]=f;e=f<<1;if((i|0)<=(e|0)){e=i<<1;if((f|0)>(e|0))k[g>>2]=e}else k[j>>2]=e;m=m+1|0;if((m|0)==(b|0))break;else l=l+88|0}}g=aa(s,k[a+316>>2]|0)|0;f=aa(s,k[p>>2]|0)|0;e=0;while(1){s=((aa(aa(k[c+8>>2]|0,d)|0,k[c+36>>2]|0)|0)+-1+g|0)/(g|0)|0;k[c+44>>2]=s;s=((aa(aa(k[c+12>>2]|0,r)|0,k[c+40>>2]|0)|0)+-1+f|0)/(f|0)|0;k[c+48>>2]=s;e=e+1|0;if((e|0)>=(b|0))break;else c=c+88|0}}}switch(k[a+44>>2]|0){case 1:{k[a+120>>2]=1;b=1;break}case 2:{k[a+120>>2]=3;b=3;break}case 3:{k[a+120>>2]=3;b=3;break}case 5:case 4:{k[a+120>>2]=4;b=4;break}default:k[a+120>>2]=b}k[a+124>>2]=(k[a+84>>2]|0)==0?b:1;if(!(P8a(a)|0)){s=1;a=a+128|0;k[a>>2]=s;return}s=k[a+320>>2]|0;a=a+128|0;k[a>>2]=s;return}function P8a(a){a=a|0;var b=0,c=0;if(k[a+76>>2]|0)return 0;if(k[a+308>>2]|0)return 0;if((k[a+40>>2]|0)!=3)return 0;if((k[a+36>>2]|0)!=3)return 0;if((k[a+44>>2]|0)!=2)return 0;if((k[a+120>>2]|0)!=3)return 0;c=k[a+216>>2]|0;if((k[c+8>>2]|0)!=2)return 0;if((k[c+96>>2]|0)!=1)return 0;if((k[c+184>>2]|0)!=1)return 0;if((k[c+12>>2]|0)>2)return 0;if((k[c+100>>2]|0)!=1)return 0;if((k[c+188>>2]|0)!=1)return 0;b=k[c+36>>2]|0;if((b|0)!=(k[a+324>>2]|0))return 0;if((k[c+124>>2]|0)!=(b|0))return 0;if((k[c+212>>2]|0)!=(b|0))return 0;b=k[c+40>>2]|0;if((b|0)!=(k[a+328>>2]|0))return 0;if((k[c+128>>2]|0)==(b|0))return (k[c+216>>2]|0)==(b|0)|0;else return 0;return 0}function Q8a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=a+4|0;f=ci[k[k[C>>2]>>2]&255](a,1,28)|0;k[a+444>>2]=f;k[f>>2]=1505;k[f+4>>2]=1506;k[f+8>>2]=0;O8a(a);c=ci[k[k[C>>2]>>2]&255](a,1,1408)|0;d=c+256|0;e=a+336|0;k[e>>2]=d;zpb(c|0,0,256)|0;b=0;do{i[d+b>>0]=b;b=b+1|0}while((b|0)!=256);zpb(c+512|0,-1,384)|0;zpb(c+896|0,0,384)|0;d=c+1280|0;b=k[e>>2]|0;c=d+128|0;do{i[d>>0]=i[b>>0]|0;d=d+1|0;b=b+1|0}while((d|0)<(c|0));z=a+120|0;B=f+12|0;k[B>>2]=0;s=P8a(a)|0;x=f+16|0;k[x>>2]=s;s=f+20|0;k[s>>2]=0;v=f+24|0;k[v>>2]=0;y=a+84|0;do if(!(k[y>>2]|0)){k[a+100>>2]=0;k[a+104>>2]=0;k[a+108>>2]=0;w=a+68|0}else{if(!(k[a+64>>2]|0)){k[a+100>>2]=0;k[a+104>>2]=0;k[a+108>>2]=0}w=a+68|0;if(k[w>>2]|0){r=k[a>>2]|0;k[r+20>>2]=48;Uh[k[r>>2]&2047](a)}do if((k[z>>2]|0)==3){if(k[a+136>>2]|0){k[a+104>>2]=1;break}if(!(k[a+92>>2]|0)){k[a+100>>2]=1;break}else{k[a+108>>2]=1;break}}else{k[a+100>>2]=1;k[a+104>>2]=0;k[a+108>>2]=0;k[a+136>>2]=0}while(0);if(k[a+100>>2]|0){q=ci[k[k[C>>2]>>2]&255](a,1,88)|0;r=a+484|0;k[r>>2]=q;k[q>>2]=843;k[q+8>>2]=1507;k[q+12>>2]=1508;k[q+68>>2]=0;k[q+52>>2]=0;if((k[z>>2]|0)>4){q=k[a>>2]|0;k[q+20>>2]=57;k[q+24>>2]=4;Uh[k[q>>2]&2047](a)}b=a+96|0;c=k[b>>2]|0;if((c|0)>256){c=k[a>>2]|0;k[c+20>>2]=59;k[c+24>>2]=256;Uh[k[c>>2]&2047](a);c=k[b>>2]|0}q=k[r>>2]|0;l=q+32|0;j=k[z>>2]|0;if((j|0)>1){e=1;while(1){f=e+1|0;d=1;b=f;do{b=aa(b,f)|0;d=d+1|0}while((d|0)!=(j|0));if((b|0)>(c|0))break;else e=f}}else{e=(c|0)>1?c:1;b=e+1|0}if((e|0)<2){p=k[a>>2]|0;k[p+20>>2]=58;k[p+24>>2]=b;Uh[k[p>>2]&2047](a)}if((j|0)>0){b=1;d=0;do{k[q+32+(d<<2)>>2]=e;b=aa(b,e)|0;d=d+1|0}while((d|0)!=(j|0));if((k[a+44>>2]|0)==2)a:while(1){h=0;f=0;while(1){d=q+32+(k[153420+(f<<2)>>2]<<2)|0;g=k[d>>2]|0;e=g+1|0;g=aa((b|0)/(g|0)|0,e)|0;if((g|0)>(c|0))break;k[d>>2]=e;b=f+1|0;if((b|0)<(j|0)){h=1;f=b;b=g}else{b=g;continue a}}if(!h){p=b;break}}else b:while(1){h=0;f=0;while(1){d=q+32+(f<<2)|0;g=k[d>>2]|0;e=g+1|0;g=aa((b|0)/(g|0)|0,e)|0;if((g|0)>(c|0))break;k[d>>2]=e;b=f+1|0;if((b|0)<(j|0)){h=1;f=b;b=g}else{b=g;continue b}}if(!h){p=b;break}}}else p=1;b=k[a>>2]|0;c=k[b+4>>2]|0;if((k[z>>2]|0)==3){k[b+24>>2]=p;k[b+28>>2]=k[l>>2];k[b+32>>2]=k[q+36>>2];k[b+36>>2]=k[q+40>>2];k[b+20>>2]=96;jh[c&1023](a,1)}else{k[b+20>>2]=97;k[b+24>>2]=p;jh[c&1023](a,1)}o=Dg[k[(k[C>>2]|0)+8>>2]&127](a,1,p,k[z>>2]|0)|0;b=k[z>>2]|0;if((b|0)>0){m=0;n=p;do{l=k[q+32+(m<<2)>>2]|0;j=n;n=(n|0)/(l|0)|0;c:do if((l|0)>0){f=l+-1|0;g=(f|0)/2|0;h=o+(m<<2)|0;if((n|0)>0)d=0;else{d=0;while(1){c=aa(d,n)|0;if((c|0)<(p|0))do c=c+j|0;while((c|0)<(p|0));d=d+1|0;if((d|0)==(l|0))break c}}do{b=aa(d,n)|0;if((b|0)<(p|0)){e=(((d*255|0)+g|0)/(f|0)|0)&255;do{c=0;do{i[(k[h>>2]|0)+(c+b)>>0]=e;c=c+1|0}while((c|0)!=(n|0));b=b+j|0}while((b|0)<(p|0))}d=d+1|0}while((d|0)!=(l|0));b=k[z>>2]|0}while(0);m=m+1|0}while((m|0)<(b|0))}k[q+16>>2]=o;k[q+20>>2]=p;A9a(a);if((k[a+88>>2]|0)==2?(t=k[r>>2]|0,u=(k[a+112>>2]<<1)+4|0,(k[z>>2]|0)>0):0){b=0;do{q=ci[k[(k[C>>2]|0)+4>>2]&255](a,1,u)|0;k[t+68+(b<<2)>>2]=q;b=b+1|0}while((b|0)<(k[z>>2]|0))}k[s>>2]=k[r>>2]}c=a+108|0;if((k[c>>2]|0)==0?(k[a+104>>2]|0)==0:0)break;e=ci[k[k[C>>2]>>2]&255](a,1,44)|0;f=a+484|0;k[f>>2]=e;k[e>>2]=844;k[e+12>>2]=1509;g=e+32|0;k[g>>2]=0;k[e+40>>2]=0;if((k[z>>2]|0)!=3){u=k[a>>2]|0;k[u+20>>2]=48;Uh[k[u>>2]&2047](a)}b=ci[k[k[C>>2]>>2]&255](a,1,128)|0;d=e+24|0;k[d>>2]=b;b=0;do{u=ci[k[(k[C>>2]|0)+4>>2]&255](a,1,4096)|0;k[(k[d>>2]|0)+(b<<2)>>2]=u;b=b+1|0}while((b|0)!=32);k[e+28>>2]=1;if(!(k[c>>2]|0))k[e+16>>2]=0;else{b=k[a+96>>2]|0;if((b|0)>=8){if((b|0)>256){u=k[a>>2]|0;k[u+20>>2]=59;k[u+24>>2]=256;Uh[k[u>>2]&2047](a)}}else{u=k[a>>2]|0;k[u+20>>2]=58;k[u+24>>2]=8;Uh[k[u>>2]&2047](a)}u=Dg[k[(k[C>>2]|0)+8>>2]&127](a,1,b,3)|0;k[e+16>>2]=u;k[e+20>>2]=b}b=a+88|0;if(k[b>>2]|0){k[b>>2]=2;u=ci[k[(k[C>>2]|0)+4>>2]&255](a,1,((k[a+112>>2]|0)*6|0)+12|0)|0;k[g>>2]=u;I9a(a)}k[v>>2]=k[f>>2]}while(0);do if(!(k[w>>2]|0)){b=k[k[C>>2]>>2]|0;if(!(k[x>>2]|0)){b=ci[b&255](a,1,28)|0;c=a+480|0;k[c>>2]=b;k[b>>2]=1511;d=a+40|0;switch(k[d>>2]|0){case 1:{if((k[a+36>>2]|0)!=1){x=k[a>>2]|0;k[x+20>>2]=11;Uh[k[x>>2]&2047](a)}break}case 3:case 2:{if((k[a+36>>2]|0)!=3){x=k[a>>2]|0;k[x+20>>2]=11;Uh[k[x>>2]&2047](a)}break}case 5:case 4:{if((k[a+36>>2]|0)!=4){x=k[a>>2]|0;k[x+20>>2]=11;Uh[k[x>>2]&2047](a)}break}default:if((k[a+36>>2]|0)<1){x=k[a>>2]|0;k[x+20>>2]=11;Uh[k[x>>2]&2047](a)}}e=a+304|0;if(k[e>>2]|0?(k[d>>2]|0)!=2:0){x=k[a>>2]|0;k[x+20>>2]=28;Uh[k[x>>2]&2047](a)}f=k[a+44>>2]|0;d:do switch(f|0){case 1:{k[z>>2]=1;switch(k[d>>2]|0){case 3:case 1:{k[b+4>>2]=161;c=k[a+36>>2]|0;if((c|0)<=1)break d;d=k[a+216>>2]|0;b=1;do{k[d+(b*88|0)+52>>2]=0;b=b+1|0}while((b|0)!=(c|0));break}case 2:{switch(k[e>>2]|0){case 0:{k[b+4>>2]=162;break}case 1:{k[b+4>>2]=163;break}default:{x=k[a>>2]|0;k[x+20>>2]=28;Uh[k[x>>2]&2047](a)}}b=k[c>>2]|0;c=ci[k[k[C>>2]>>2]&255](a,1,3072)|0;k[b+24>>2]=c;b=0;do{k[c+(b<<2)>>2]=b*19595;k[c+(b+256<<2)>>2]=b*38470;k[c+(b+512<<2)>>2]=(b*7471|0)+32768;b=b+1|0}while((b|0)!=256);break}default:{x=k[a>>2]|0;k[x+20>>2]=28;Uh[k[x>>2]&2047](a);break d}}break}case 2:{k[z>>2]=3;switch(k[d>>2]|0){case 3:{k[b+4>>2]=164;b=k[c>>2]|0;d=ci[k[k[C>>2]>>2]&255](a,1,1024)|0;e=b+8|0;k[e>>2]=d;d=ci[k[k[C>>2]>>2]&255](a,1,1024)|0;f=b+12|0;k[f>>2]=d;d=ci[k[k[C>>2]>>2]&255](a,1,1024)|0;g=b+16|0;k[g>>2]=d;d=ci[k[k[C>>2]>>2]&255](a,1,1024)|0;k[b+20>>2]=d;e=k[e>>2]|0;f=k[f>>2]|0;g=k[g>>2]|0;b=0;c=-128;while(1){k[e+(b<<2)>>2]=(c*91881|0)+32768>>16;k[f+(b<<2)>>2]=(c*116130|0)+32768>>16;x=aa(c,-46802)|0;k[g+(b<<2)>>2]=x;x=(aa(c,-22554)|0)+32768|0;k[d+(b<<2)>>2]=x;b=b+1|0;if((b|0)==256)break;else c=c+1|0}break}case 1:{k[b+4>>2]=165;break d}case 2:switch(k[e>>2]|0){case 0:{k[b+4>>2]=166;break d}case 1:{k[b+4>>2]=167;break d}default:{x=k[a>>2]|0;k[x+20>>2]=28;Uh[k[x>>2]&2047](a);break d}}default:{x=k[a>>2]|0;k[x+20>>2]=28;Uh[k[x>>2]&2047](a);break d}}break}case 4:{k[z>>2]=4;switch(k[d>>2]|0){case 5:{k[b+4>>2]=168;b=k[c>>2]|0;d=ci[k[k[C>>2]>>2]&255](a,1,1024)|0;e=b+8|0;k[e>>2]=d;d=ci[k[k[C>>2]>>2]&255](a,1,1024)|0;f=b+12|0;k[f>>2]=d;d=ci[k[k[C>>2]>>2]&255](a,1,1024)|0;g=b+16|0;k[g>>2]=d;d=ci[k[k[C>>2]>>2]&255](a,1,1024)|0;k[b+20>>2]=d;e=k[e>>2]|0;f=k[f>>2]|0;g=k[g>>2]|0;b=0;c=-128;while(1){k[e+(b<<2)>>2]=(c*91881|0)+32768>>16;k[f+(b<<2)>>2]=(c*116130|0)+32768>>16;x=aa(c,-46802)|0;k[g+(b<<2)>>2]=x;x=(aa(c,-22554)|0)+32768|0;k[d+(b<<2)>>2]=x;b=b+1|0;if((b|0)==256)break;else c=c+1|0}break}case 4:{k[b+4>>2]=169;break d}default:{x=k[a>>2]|0;k[x+20>>2]=28;Uh[k[x>>2]&2047](a);break d}}break}default:if((f|0)==(k[d>>2]|0)){k[z>>2]=k[a+36>>2];k[b+4>>2]=169;break d}else{x=k[a>>2]|0;k[x+20>>2]=28;Uh[k[x>>2]&2047](a);break d}}while(0);if(!(k[y>>2]|0))b=k[z>>2]|0;else b=1;k[a+124>>2]=b;b=ci[k[k[C>>2]>>2]&255](a,1,160)|0;k[a+476>>2]=b;k[b>>2]=1512;k[b+4>>2]=99;k[b+8>>2]=0;if(k[a+308>>2]|0){x=k[a>>2]|0;k[x+20>>2]=26;Uh[k[x>>2]&2047](a)}m=a+36|0;if((k[m>>2]|0)>0){n=a+324|0;o=a+328|0;p=a+316|0;q=a+320|0;r=b+100|0;s=b+52|0;t=a+112|0;u=b+12|0;v=b+140|0;d=b+150|0;b=k[a+216>>2]|0;c=0;while(1){e=aa(k[b+36>>2]|0,k[b+8>>2]|0)|0;e=(e|0)/(k[n>>2]|0)|0;f=aa(k[b+40>>2]|0,k[b+12>>2]|0)|0;f=(f|0)/(k[o>>2]|0)|0;g=k[p>>2]|0;h=k[q>>2]|0;k[r+(c<<2)>>2]=f;do if(!(k[b+52>>2]|0))k[s+(c<<2)>>2]=219;else{j=(f|0)==(h|0);if((e|0)==(g|0)&j){k[s+(c<<2)>>2]=220;break}l=(e<<1|0)==(g|0);do if(l&j)k[s+(c<<2)>>2]=221;else{if(l&(f<<1|0)==(h|0)){k[s+(c<<2)>>2]=222;break}if(((g|0)%(e|0)|0|0)==0?((h|0)%(f|0)|0|0)==0:0){k[s+(c<<2)>>2]=223;i[v+c>>0]=(g|0)/(e|0)|0;i[d+c>>0]=(h|0)/(f|0)|0;break}x=k[a>>2]|0;k[x+20>>2]=39;Uh[k[x>>2]&2047](a)}while(0);x=k[p>>2]|0;l=(k[t>>2]|0)+-1+x|0;x=Dg[k[(k[C>>2]|0)+8>>2]&127](a,1,l-((l|0)%(x|0)|0)|0,k[q>>2]|0)|0;k[u+(c<<2)>>2]=x}while(0);c=c+1|0;if((c|0)>=(k[m>>2]|0))break;else b=b+88|0}}}else{b=ci[b&255](a,1,48)|0;c=a+476|0;k[c>>2]=b;k[b>>2]=1510;k[b+8>>2]=0;d=aa(k[z>>2]|0,k[a+112>>2]|0)|0;k[b+40>>2]=d;e=b+4|0;if((k[a+320>>2]|0)==2){k[e>>2]=97;k[b+12>>2]=217;x=ci[k[(k[C>>2]|0)+4>>2]&255](a,1,d)|0;k[b+32>>2]=x;b=k[c>>2]|0}else{k[e>>2]=98;k[b+12>>2]=218;k[b+32>>2]=0}g=ci[k[k[C>>2]>>2]&255](a,1,1024)|0;d=b+16|0;k[d>>2]=g;g=ci[k[k[C>>2]>>2]&255](a,1,1024)|0;e=b+20|0;k[e>>2]=g;g=ci[k[k[C>>2]>>2]&255](a,1,1024)|0;f=b+24|0;k[f>>2]=g;g=ci[k[k[C>>2]>>2]&255](a,1,1024)|0;k[b+28>>2]=g;d=k[d>>2]|0;e=k[e>>2]|0;f=k[f>>2]|0;b=0;c=-128;while(1){k[d+(b<<2)>>2]=(c*91881|0)+32768>>16;k[e+(b<<2)>>2]=(c*116130|0)+32768>>16;x=aa(c,-46802)|0;k[f+(b<<2)>>2]=x;x=(aa(c,-22554)|0)+32768|0;k[g+(b<<2)>>2]=x;b=b+1|0;if((b|0)==256)break;else c=c+1|0}}f=k[a+108>>2]|0;b=ci[k[k[C>>2]>>2]&255](a,1,28)|0;k[a+456>>2]=b;k[b>>2]=845;g=b+8|0;k[g>>2]=0;h=b+12|0;k[h>>2]=0;if(k[y>>2]|0){e=k[a+320>>2]|0;k[b+16>>2]=e;c=k[C>>2]|0;d=k[a+112>>2]|0;b=k[z>>2]|0;if(!f){z=aa(b,d)|0;z=Dg[k[c+8>>2]&127](a,1,z,e)|0;k[h>>2]=z;break}else{y=aa(b,d)|0;z=(k[a+116>>2]|0)+-1+e|0;z=Sf[k[c+16>>2]&127](a,1,0,y,z-((z|0)%(e|0)|0)|0,e)|0;k[g>>2]=z;break}}}while(0);b=ci[k[k[C>>2]>>2]&255](a,1,84)|0;k[a+472>>2]=b;k[b>>2]=1513;e=a+36|0;if((k[e>>2]|0)>0){d=b+44|0;b=0;c=k[a+216>>2]|0;while(1){z=ci[k[k[C>>2]>>2]&255](a,1,256)|0;k[c+84>>2]=z;zpb(z|0,0,256)|0;k[d+(b<<2)>>2]=-1;b=b+1|0;if((b|0)>=(k[e>>2]|0))break;else c=c+88|0}}b=k[k[C>>2]>>2]|0;do if(k[a+228>>2]|0){d=ci[b&255](a,1,188)|0;k[a+468>>2]=d;k[d>>2]=1514;b=d+184|0;d=d+56|0;c=d+128|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(c|0));i[b>>0]=113;if(k[a+224>>2]|0?(A=ci[k[k[C>>2]>>2]&255](a,1,k[e>>2]<<8)|0,k[a+160>>2]=A,(k[e>>2]|0)>0):0){b=0;do{zpb(A+(b<<8)|0,-1,256)|0;b=b+1|0}while((b|0)<(k[e>>2]|0))}}else{c=ci[b&255](a,1,216)|0;k[a+468>>2]=c;k[c>>2]=1515;if(!(k[a+224>>2]|0)){A=c+64|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;k[A+16>>2]=0;k[A+20>>2]=0;k[A+24>>2]=0;k[A+28>>2]=0;break}d=ci[k[k[C>>2]>>2]&255](a,1,k[e>>2]<<8)|0;k[a+160>>2]=d;if((k[e>>2]|0)>0){b=0;do{zpb(d+(b<<8)|0,-1,256)|0;b=b+1|0}while((b|0)<(k[e>>2]|0))}A=c+44|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0}while(0);c=a+460|0;if(!(k[(k[c>>2]|0)+16>>2]|0))b=(k[a+64>>2]|0)!=0;else b=1;Jab(a,b&1);if(!(k[w>>2]|0))kbb(a,0);Uh[k[(k[C>>2]|0)+24>>2]&2047](a);Uh[k[(k[c>>2]|0)+8>>2]&2047](a);b=k[a+8>>2]|0;if(!b)return;if(k[a+64>>2]|0)return;if(!(k[(k[c>>2]|0)+16>>2]|0))return;C=k[e>>2]|0;C=(k[a+224>>2]|0)==0?C:(C*3|0)+2|0;k[b+4>>2]=0;C=aa(C,k[a+332>>2]|0)|0;k[b+8>>2]=C;k[b+12>>2]=0;k[b+16>>2]=k[a+108>>2]|0?3:2;k[B>>2]=(k[B>>2]|0)+1;return}function R8a(a){a=a|0;var b=0,c=0,d=0,e=0;c=k[a+444>>2]|0;d=c+8|0;if(!(k[d>>2]|0)){b=a+84|0;do if(k[b>>2]|0?(k[a+136>>2]|0)==0:0){if(k[a+92>>2]|0?k[a+108>>2]|0:0){k[a+484>>2]=k[c+24>>2];k[d>>2]=1;break}if(!(k[a+100>>2]|0)){e=k[a>>2]|0;k[e+20>>2]=47;Uh[k[e>>2]&2047](a);break}else{k[a+484>>2]=k[c+20>>2];break}}while(0);Uh[k[k[a+472>>2]>>2]&2047](a);Uh[k[(k[a+452>>2]|0)+8>>2]&2047](a);if(!(k[a+68>>2]|0)){if(!(k[c+16>>2]|0))Uh[k[k[a+480>>2]>>2]&2047](a);Uh[k[k[a+476>>2]>>2]&2047](a);if(k[b>>2]|0)jh[k[k[a+484>>2]>>2]&1023](a,k[d>>2]|0);jh[k[k[a+456>>2]>>2]&1023](a,k[d>>2]|0?3:0);jh[k[k[a+448>>2]>>2]&1023](a,0)}}else{k[d>>2]=0;jh[k[k[a+484>>2]>>2]&1023](a,0);jh[k[k[a+456>>2]>>2]&1023](a,2);jh[k[k[a+448>>2]>>2]&1023](a,2)}b=k[a+8>>2]|0;if(!b)return;c=k[c+12>>2]|0;k[b+12>>2]=c;c=(k[d>>2]|0?2:1)+c|0;b=b+16|0;k[b>>2]=c;if(!(k[a+64>>2]|0))return;if(k[(k[a+460>>2]|0)+20>>2]|0)return;k[b>>2]=c+(k[a+108>>2]|0?2:1);return}function S8a(a){a=a|0;var b=0;b=k[a+444>>2]|0;if(k[a+84>>2]|0)Uh[k[(k[a+484>>2]|0)+8>>2]&2047](a);b=b+12|0;k[b>>2]=(k[b>>2]|0)+1;return}function T8a(a){a=a|0;var b=0;b=k[a+476>>2]|0;k[b+36>>2]=0;k[b+44>>2]=k[a+116>>2];return}function U8a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;l=n;m=k[a+476>>2]|0;h=m+36|0;if(!(k[h>>2]|0)){i=m+44|0;d=k[i>>2]|0;d=d>>>0<2?d:2;j=k[f>>2]|0;g=g-j|0;d=d>>>0>g>>>0?g:d;k[l>>2]=k[e+(j<<2)>>2];if(d>>>0>1)k[l+4>>2]=k[e+(j+1<<2)>>2];else{k[l+4>>2]=k[m+32>>2];k[h>>2]=1}dh[k[m+12>>2]&255](a,b,k[c>>2]|0,l);e=(k[h>>2]|0)==0;k[f>>2]=(k[f>>2]|0)+d;k[i>>2]=(k[i>>2]|0)-d;if(!e){r=n;return}}else{upb(k[e+(k[f>>2]<<2)>>2]|0,k[m+32>>2]|0,k[m+40>>2]|0)|0;k[h>>2]=0;e=m+44|0;k[f>>2]=(k[f>>2]|0)+1;k[e>>2]=(k[e>>2]|0)+-1}k[c>>2]=(k[c>>2]|0)+1;r=n;return}function V8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;v=k[a+476>>2]|0;w=k[a+336>>2]|0;x=k[v+16>>2]|0;t=k[v+20>>2]|0;u=k[v+24>>2]|0;v=k[v+28>>2]|0;e=c<<1;f=k[b>>2]|0;s=k[f+(e<<2)>>2]|0;e=k[f+((e|1)<<2)>>2]|0;f=k[(k[b+4>>2]|0)+(c<<2)>>2]|0;g=k[(k[b+8>>2]|0)+(c<<2)>>2]|0;c=k[d>>2]|0;d=k[d+4>>2]|0;r=a+112|0;b=k[r>>2]|0;o=b>>>1;if(!o)a=s;else{p=f+o|0;q=o*6|0;n=g;b=e;a=s;h=d;j=c;m=o;while(1){y=l[f>>0]|0;A=l[n>>0]|0;B=k[x+(A<<2)>>2]|0;A=(k[u+(A<<2)>>2]|0)+(k[v+(y<<2)>>2]|0)>>16;y=k[t+(y<<2)>>2]|0;z=l[a>>0]|0;i[j>>0]=i[w+(z+B)>>0]|0;i[j+1>>0]=i[w+(z+A)>>0]|0;i[j+2>>0]=i[w+(z+y)>>0]|0;z=l[a+1>>0]|0;i[j+3>>0]=i[w+(z+B)>>0]|0;i[j+4>>0]=i[w+(z+A)>>0]|0;i[j+5>>0]=i[w+(z+y)>>0]|0;z=l[b>>0]|0;i[h>>0]=i[w+(z+B)>>0]|0;i[h+1>>0]=i[w+(z+A)>>0]|0;i[h+2>>0]=i[w+(z+y)>>0]|0;z=l[b+1>>0]|0;i[h+3>>0]=i[w+(z+B)>>0]|0;i[h+4>>0]=i[w+(z+A)>>0]|0;i[h+5>>0]=i[w+(z+y)>>0]|0;m=m+-1|0;if(!m)break;else{n=n+1|0;f=f+1|0;b=b+2|0;a=a+2|0;h=h+6|0;j=j+6|0}}a=o<<1;g=g+o|0;f=p;e=e+a|0;a=s+a|0;d=d+q|0;c=c+q|0;b=k[r>>2]|0}if(!(b&1))return;B=l[f>>0]|0;z=l[g>>0]|0;y=k[x+(z<<2)>>2]|0;z=(k[u+(z<<2)>>2]|0)+(k[v+(B<<2)>>2]|0)>>16;B=k[t+(B<<2)>>2]|0;A=l[a>>0]|0;i[c>>0]=i[w+(A+y)>>0]|0;i[c+1>>0]=i[w+(A+z)>>0]|0;i[c+2>>0]=i[w+(A+B)>>0]|0;A=l[e>>0]|0;i[d>>0]=i[w+(A+y)>>0]|0;i[d+1>>0]=i[w+(A+z)>>0]|0;i[d+2>>0]=i[w+(A+B)>>0]|0;return}function W8a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;dh[k[(k[a+476>>2]|0)+12>>2]&255](a,b,k[c>>2]|0,e+(k[f>>2]<<2)|0);k[f>>2]=(k[f>>2]|0)+1;k[c>>2]=(k[c>>2]|0)+1;return}function X8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;r=k[a+476>>2]|0;s=k[a+336>>2]|0;t=k[r+16>>2]|0;p=k[r+20>>2]|0;q=k[r+24>>2]|0;r=k[r+28>>2]|0;o=k[(k[b>>2]|0)+(c<<2)>>2]|0;n=k[(k[b+4>>2]|0)+(c<<2)>>2]|0;e=k[(k[b+8>>2]|0)+(c<<2)>>2]|0;c=k[d>>2]|0;m=a+112|0;b=k[m>>2]|0;j=b>>>1;if(!j){a=n;d=o}else{h=j<<1;b=e;d=n;a=o;f=c;g=j;while(1){u=l[d>>0]|0;w=l[b>>0]|0;x=k[t+(w<<2)>>2]|0;w=(k[q+(w<<2)>>2]|0)+(k[r+(u<<2)>>2]|0)>>16;u=k[p+(u<<2)>>2]|0;v=l[a>>0]|0;i[f>>0]=i[s+(v+x)>>0]|0;i[f+1>>0]=i[s+(v+w)>>0]|0;i[f+2>>0]=i[s+(v+u)>>0]|0;v=l[a+1>>0]|0;i[f+3>>0]=i[s+(v+x)>>0]|0;i[f+4>>0]=i[s+(v+w)>>0]|0;i[f+5>>0]=i[s+(v+u)>>0]|0;g=g+-1|0;if(!g)break;else{b=b+1|0;d=d+1|0;a=a+2|0;f=f+6|0}}e=e+j|0;a=n+j|0;d=o+h|0;c=c+(j*6|0)|0;b=k[m>>2]|0}if(!(b&1))return;x=l[a>>0]|0;u=l[e>>0]|0;v=(k[q+(u<<2)>>2]|0)+(k[r+(x<<2)>>2]|0)>>16;x=k[p+(x<<2)>>2]|0;w=l[d>>0]|0;i[c>>0]=i[s+(w+(k[t+(u<<2)>>2]|0))>>0]|0;i[c+1>>0]=i[s+(w+v)>>0]|0;i[c+2>>0]=i[s+(w+x)>>0]|0;return}function Y8a(a,b){a=a|0;b=b|0;var c=0;c=k[a+456>>2]|0;a:do switch(b|0){case 0:{if(!(k[a+84>>2]|0)){k[c+4>>2]=k[(k[a+476>>2]|0)+4>>2];break a}k[c+4>>2]=100;b=c+12|0;if(!(k[b>>2]|0)){a=$g[k[(k[a+4>>2]|0)+28>>2]&127](a,k[c+8>>2]|0,0,k[c+16>>2]|0,1)|0;k[b>>2]=a}break}case 3:{if(!(k[c+8>>2]|0)){b=k[a>>2]|0;k[b+20>>2]=3;Uh[k[b>>2]&2047](a)}k[c+4>>2]=101;break}case 2:{if(!(k[c+8>>2]|0)){b=k[a>>2]|0;k[b+20>>2]=3;Uh[k[b>>2]&2047](a)}k[c+4>>2]=102;break}default:{b=k[a>>2]|0;k[b+20>>2]=3;Uh[k[b>>2]&2047](a)}}while(0);k[c+24>>2]=0;k[c+20>>2]=0;return}function Z8a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+16|0;i=h;m=k[a+456>>2]|0;j=g-(k[f>>2]|0)|0;l=k[m+16>>2]|0;k[i>>2]=0;g=m+12|0;Eh[k[(k[a+476>>2]|0)+4>>2]&127](a,b,c,d,k[g>>2]|0,i,j>>>0>l>>>0?l:j);dh[k[(k[a+484>>2]|0)+4>>2]&255](a,k[g>>2]|0,e+(k[f>>2]<<2)|0,k[i>>2]|0);k[f>>2]=(k[f>>2]|0)+(k[i>>2]|0);r=h;return}function _8a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0;j=k[a+456>>2]|0;l=j+24|0;e=k[l>>2]|0;if(!e){i=j+16|0;g=$g[k[(k[a+4>>2]|0)+28>>2]&127](a,k[j+8>>2]|0,k[j+20>>2]|0,k[i>>2]|0,1)|0;h=j+12|0;k[h>>2]=g;e=k[l>>2]|0}else{g=j+12|0;i=j+16|0;h=g;g=k[g>>2]|0}Eh[k[(k[a+476>>2]|0)+4>>2]&127](a,b,c,d,g,l,k[i>>2]|0);g=k[l>>2]|0;if(g>>>0>e>>>0){g=g-e|0;dh[k[(k[a+484>>2]|0)+4>>2]&255](a,(k[h>>2]|0)+(e<<2)|0,0,g);k[f>>2]=(k[f>>2]|0)+g;g=k[l>>2]|0}e=k[i>>2]|0;if(g>>>0<e>>>0)return;j=j+20|0;k[j>>2]=(k[j>>2]|0)+e;k[l>>2]=0;return}function $8a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0;c=k[a+456>>2]|0;i=c+24|0;b=k[i>>2]|0;if(!b){h=c+20|0;d=c+16|0;j=$g[k[(k[a+4>>2]|0)+28>>2]&127](a,k[c+8>>2]|0,k[h>>2]|0,k[d>>2]|0,0)|0;k[c+12>>2]=j;b=k[i>>2]|0;c=j}else{h=c+20|0;d=c+16|0;c=k[c+12>>2]|0}j=(k[d>>2]|0)-b|0;l=k[f>>2]|0;g=g-l|0;j=j>>>0>g>>>0?g:j;g=(k[a+116>>2]|0)-(k[h>>2]|0)|0;j=j>>>0>g>>>0?g:j;dh[k[(k[a+484>>2]|0)+4>>2]&255](a,c+(b<<2)|0,e+(l<<2)|0,j);k[f>>2]=(k[f>>2]|0)+j;j=(k[i>>2]|0)+j|0;k[i>>2]=j;b=k[d>>2]|0;if(j>>>0<b>>>0)return;k[h>>2]=(k[h>>2]|0)+b;k[i>>2]=0;return}function a9a(a){a=a|0;var b=0;b=k[a+476>>2]|0;k[b+92>>2]=k[a+320>>2];k[b+96>>2]=k[a+116>>2];return}function b9a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0,n=0;l=k[a+476>>2]|0;m=l+92|0;h=k[m>>2]|0;j=a+320|0;d=k[j>>2]|0;if((h|0)>=(d|0)){i=a+36|0;if((k[i>>2]|0)>0){d=k[a+216>>2]|0;h=0;while(1){n=(k[b+(h<<2)>>2]|0)+((aa(k[l+100+(h<<2)>>2]|0,k[c>>2]|0)|0)<<2)|0;dh[k[l+52+(h<<2)>>2]&255](a,d,n,l+12+(h<<2)|0);h=h+1|0;if((h|0)>=(k[i>>2]|0))break;else d=d+88|0}d=k[j>>2]|0}k[m>>2]=0;h=0}n=d-h|0;b=l+96|0;i=k[b>>2]|0;n=n>>>0>i>>>0?i:n;i=k[f>>2]|0;g=g-i|0;n=n>>>0>g>>>0?g:n;eh[k[(k[a+480>>2]|0)+4>>2]&255](a,l+12|0,h,e+(i<<2)|0,n);k[f>>2]=(k[f>>2]|0)+n;k[b>>2]=(k[b>>2]|0)-n;n=(k[m>>2]|0)+n|0;k[m>>2]=n;if((n|0)<(k[j>>2]|0))return;k[c>>2]=(k[c>>2]|0)+1;return}function c9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;k[d>>2]=0;return}function d9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;k[d>>2]=c;return}function e9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;h=k[d>>2]|0;j=a+320|0;b=k[j>>2]|0;if((b|0)<=0)return;g=a+112|0;f=0;do{a=k[h+(f<<2)>>2]|0;d=k[g>>2]|0;e=a+d|0;if((d|0)>0){d=k[c+(f<<2)>>2]|0;b=a;while(1){a=i[d>>0]|0;i[b>>0]=a;i[b+1>>0]=a;b=b+2|0;if(b>>>0>=e>>>0)break;else d=d+1|0}b=k[j>>2]|0}f=f+1|0}while((f|0)<(b|0));return}function f9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;l=k[d>>2]|0;m=a+320|0;if((k[m>>2]|0)<=0)return;h=a+112|0;f=0;g=0;while(1){j=l+(g<<2)|0;a=k[j>>2]|0;b=k[h>>2]|0;e=a+b|0;if((b|0)>0){d=k[c+(f<<2)>>2]|0;b=a;while(1){a=i[d>>0]|0;i[b>>0]=a;i[b+1>>0]=a;b=b+2|0;if(b>>>0>=e>>>0)break;else d=d+1|0}b=k[h>>2]|0}upb(k[l+((g|1)<<2)>>2]|0,k[j>>2]|0,b|0)|0;g=g+2|0;if((g|0)>=(k[m>>2]|0))break;else f=f+1|0}return}function g9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=k[a+476>>2]|0;o=k[d>>2]|0;d=k[b+4>>2]|0;b=i[p+140+d>>0]|0;g=b&255;d=i[p+150+d>>0]|0;p=d&255;n=a+320|0;e=k[n>>2]|0;if((e|0)<=0)return;m=a+112|0;l=b<<24>>24!=0;if((d&255)>1){j=(b<<24>>24==0?~g:-2)+g+2|0;h=(b<<24>>24==0?~g:-2)+g+2|0;f=0;g=0;while(1){d=o+(g<<2)|0;b=k[d>>2]|0;a=k[m>>2]|0;e=b+a|0;if((a|0)>0){if(!l){d=9;break}a=k[c+(f<<2)>>2]|0;while(1){zpb(b|0,i[a>>0]|0,j|0)|0;b=b+h|0;if(b>>>0>=e>>>0)break;else a=a+1|0}e=k[m>>2]|0}else e=a;b=o+(g+1<<2)|0;a=p;while(1){a=a+-1|0;upb(k[b>>2]|0,k[d>>2]|0,e|0)|0;if((a|0)<=1)break;else{d=d+4|0;b=b+4|0}}g=g+p|0;if((g|0)>=(k[n>>2]|0)){d=22;break}else f=f+1|0}if((d|0)==9)while(1){}else if((d|0)==22)return}else if(!l){b=(k[m>>2]|0)>0;d=0;while(1){if(b){d=20;break}d=d+p|0;if((d|0)>=(e|0)){d=22;break}}if((d|0)==20)while(1){}else if((d|0)==22)return}else{b=0;e=0;while(1){d=k[o+(e<<2)>>2]|0;l=k[m>>2]|0;f=d+l|0;if((l|0)>0){a=k[c+(b<<2)>>2]|0;while(1){zpb(d|0,i[a>>0]|0,g|0)|0;d=d+g|0;if(d>>>0>=f>>>0)break;else a=a+1|0}}e=e+p|0;if((e|0)>=(k[n>>2]|0))break;else b=b+1|0}return}}function h9a(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;if((b|0)>=0){if((k[c+104>>2]|0)<(b|0))return;Uh[k[c+8>>2]&2047](a);return}d=c+108|0;b=k[d>>2]|0;if(!((b|0)!=0?(k[c+104>>2]|0)<=2:0)){Uh[k[c+8>>2]&2047](a);b=k[d>>2]|0}k[d>>2]=b+1;return}function i9a(a){a=a|0;var b=0,c=0,d=0;b=r;r=r+208|0;c=b;d=b+8|0;jh[k[(k[a>>2]|0)+12>>2]&1023](a,d);k[c>>2]=d;Zfb(165912,410544,c)|0;r=b;return}function j9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;j=r;r=r+48|0;h=j+8|0;g=j;f=k[a>>2]|0;d=k[f+20>>2]|0;if((d|0)>0?(d|0)<=(k[f+116>>2]|0):0){a=(k[f+112>>2]|0)+(d<<2)|0;e=8}else{a=k[f+120>>2]|0;if(((a|0)!=0?(c=k[f+124>>2]|0,(d|0)>=(c|0)):0)?(d|0)<=(k[f+128>>2]|0):0){a=a+(d-c<<2)|0;e=8}else e=9}if((e|0)==8){a=k[a>>2]|0;if(!a)e=9}if((e|0)==9){k[f+24>>2]=d;a=k[k[f+112>>2]>>2]|0}c=a;a:while(1){d=c+1|0;switch(i[c>>0]|0){case 0:break a;case 37:{e=12;break a}default:c=d}}if((e|0)==12?(i[d>>0]|0)==115:0){k[g>>2]=f+24;Cfb(b,a,g);r=j;return}n=k[f+28>>2]|0;m=k[f+32>>2]|0;l=k[f+36>>2]|0;c=k[f+40>>2]|0;d=k[f+44>>2]|0;e=k[f+48>>2]|0;g=k[f+52>>2]|0;k[h>>2]=k[f+24>>2];k[h+4>>2]=n;k[h+8>>2]=m;k[h+12>>2]=l;k[h+16>>2]=c;k[h+20>>2]=d;k[h+24>>2]=e;k[h+28>>2]=g;Cfb(b,a,h);r=j;return}function k9a(a){a=a|0;a=k[a>>2]|0;k[a+108>>2]=0;k[a+20>>2]=0;return}function l9a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;d=h+8|0;e=h+12|0;b=a+4|0;k[b>>2]=0;k[d>>2]=1073741824;c=fgb(84)|0;if(!c){f=k[a>>2]|0;k[f+20>>2]=56;k[f+24>>2]=0;Uh[k[f>>2]&2047](a)}k[c>>2]=148;k[c+4>>2]=149;k[c+8>>2]=78;k[c+12>>2]=79;k[c+16>>2]=73;k[c+20>>2]=74;k[c+24>>2]=1516;k[c+28>>2]=71;k[c+32>>2]=72;k[c+36>>2]=846;k[c+40>>2]=1517;k[c+48>>2]=1e9;f=c+44|0;k[f>>2]=1073741824;a=c+52|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;k[c+76>>2]=84;k[b>>2]=c;a=Ce(410548)|0;if(!a){r=h;return}i[e>>0]=120;k[g>>2]=d;k[g+4>>2]=e;if((Wfb(a,410556,g)|0)>0){switch(i[e>>0]|0){case 77:case 109:{a=(k[d>>2]|0)*1e3|0;k[d>>2]=a;break}default:a=k[d>>2]|0}k[f>>2]=a*1e3}r=h;return}function m9a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=k[a+4>>2]|0;if(c>>>0>999999984){i=k[a>>2]|0;k[i+20>>2]=56;k[i+24>>2]=1;Uh[k[i>>2]&2047](a)}i=c&7;i=((i|0)==0?0:8-i|0)+c|0;if(b>>>0>1){h=k[a>>2]|0;k[h+20>>2]=15;k[h+24>>2]=b;Uh[k[h>>2]&2047](a)}h=j+52+(b<<2)|0;c=k[h>>2]|0;a:do if(!c){c=0;e=8}else while(1){if((k[c+8>>2]|0)>>>0>=i>>>0)break a;d=k[c>>2]|0;if(!d){e=8;break}else c=d}while(0);do if((e|0)==8){f=i+16|0;g=(c|0)==0;e=k[(g?153404:153412)+(b<<2)>>2]|0;d=999999984-i|0;e=e>>>0>d>>>0?d:e;d=f+e|0;b=fgb(d)|0;if(!b){d=e;while(1){e=d>>>1;if(d>>>0<100){b=k[a>>2]|0;k[b+20>>2]=56;k[b+24>>2]=2;Uh[k[b>>2]&2047](a)}d=f+e|0;b=fgb(d)|0;if(!b)d=e;else break}}j=j+76|0;k[j>>2]=(k[j>>2]|0)+d;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=e+i;if(g){k[h>>2]=b;c=b;break}else{k[c>>2]=b;c=b;break}}while(0);h=c+4|0;j=k[h>>2]|0;k[h>>2]=j+i;h=c+8|0;k[h>>2]=(k[h>>2]|0)-i;return c+16+j|0}function n9a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=k[a+4>>2]|0;if(c>>>0>999999984){e=k[a>>2]|0;k[e+20>>2]=56;k[e+24>>2]=3;Uh[k[e>>2]&2047](a)}e=c&7;c=((e|0)==0?0:8-e|0)+c|0;if(b>>>0>1){e=k[a>>2]|0;k[e+20>>2]=15;k[e+24>>2]=b;Uh[k[e>>2]&2047](a)}d=c+16|0;e=fgb(d)|0;if(!e){g=k[a>>2]|0;k[g+20>>2]=56;k[g+24>>2]=4;Uh[k[g>>2]&2047](a)}g=f+76|0;k[g>>2]=(k[g>>2]|0)+d;g=f+60+(b<<2)|0;k[e>>2]=k[g>>2];k[e+4>>2]=c;k[e+8>>2]=0;k[g>>2]=e;return e+16|0}function o9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;n=a+4|0;f=k[n>>2]|0;e=999999984/(c>>>0)|0;if(c>>>0>999999984){m=k[a>>2]|0;k[m+20>>2]=72;Uh[k[m>>2]&2047](a)}g=(e|0)<(d|0)?e:d;k[f+80>>2]=g;l=m9a(a,b,d<<2)|0;if(!d)return l|0;m=b>>>0>1;e=0;do{f=d-e|0;g=g>>>0<f>>>0?g:f;f=aa(g,c)|0;i=k[n>>2]|0;if(f>>>0>999999984){j=k[a>>2]|0;k[j+20>>2]=56;k[j+24>>2]=3;Uh[k[j>>2]&2047](a)}j=f&7;f=((j|0)==0?0:8-j|0)+f|0;if(m){j=k[a>>2]|0;k[j+20>>2]=15;k[j+24>>2]=b;Uh[k[j>>2]&2047](a)}h=f+16|0;j=fgb(h)|0;if(!j){o=k[a>>2]|0;k[o+20>>2]=56;k[o+24>>2]=4;Uh[k[o>>2]&2047](a)}o=i+76|0;k[o>>2]=(k[o>>2]|0)+h;o=i+60+(b<<2)|0;k[j>>2]=k[o>>2];k[j+4>>2]=f;k[j+8>>2]=0;k[o>>2]=j;if(g){i=g;h=j+16|0;while(1){f=e+1|0;k[l+(e<<2)>>2]=h;i=i+-1|0;if(!i){e=f;break}else{h=h+c|0;e=f}}}}while(e>>>0<d>>>0);return l|0}function p9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;n=a+4|0;f=k[n>>2]|0;o=c<<7;e=999999984/(o>>>0)|0;if(o>>>0>999999984){m=k[a>>2]|0;k[m+20>>2]=72;Uh[k[m>>2]&2047](a)}g=(e|0)<(d|0)?e:d;k[f+80>>2]=g;l=m9a(a,b,d<<2)|0;if(!d)return l|0;m=b>>>0>1;e=0;do{f=d-e|0;g=g>>>0<f>>>0?g:f;f=aa(o,g)|0;h=k[n>>2]|0;if(f>>>0>999999984){j=k[a>>2]|0;k[j+20>>2]=56;k[j+24>>2]=3;Uh[k[j>>2]&2047](a)}if(m){j=k[a>>2]|0;k[j+20>>2]=15;k[j+24>>2]=b;Uh[k[j>>2]&2047](a)}i=f|16;j=fgb(i)|0;if(!j){p=k[a>>2]|0;k[p+20>>2]=56;k[p+24>>2]=4;Uh[k[p>>2]&2047](a)}p=h+76|0;k[p>>2]=(k[p>>2]|0)+i;p=h+60+(b<<2)|0;k[j>>2]=k[p>>2];k[j+4>>2]=f;k[j+8>>2]=0;k[p>>2]=j;if(g){i=g;h=j+16|0;while(1){f=e+1|0;k[l+(e<<2)>>2]=h;i=i+-1|0;if(!i){e=f;break}else{h=h+(c<<7)|0;e=f}}}}while(e>>>0<d>>>0);return l|0}function q9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=k[a+4>>2]|0;if((b|0)!=1){h=k[a>>2]|0;k[h+20>>2]=15;k[h+24>>2]=b;Uh[k[h>>2]&2047](a)}h=m9a(a,b,128)|0;k[h>>2]=0;k[h+4>>2]=e;k[h+8>>2]=d;k[h+12>>2]=f;k[h+32>>2]=c;k[h+40>>2]=0;g=g+68|0;k[h+44>>2]=k[g>>2];k[g>>2]=h;return h|0}function r9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=k[a+4>>2]|0;if((b|0)!=1){h=k[a>>2]|0;k[h+20>>2]=15;k[h+24>>2]=b;Uh[k[h>>2]&2047](a)}h=m9a(a,b,128)|0;k[h>>2]=0;k[h+4>>2]=e;k[h+8>>2]=d;k[h+12>>2]=f;k[h+32>>2]=c;k[h+40>>2]=0;g=g+72|0;k[h+44>>2]=k[g>>2];k[g>>2]=h;return h|0}function s9a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;q=a+4|0;o=k[q>>2]|0;g=k[o+68>>2]|0;f=(g|0)==0;if(f){d=0;c=0}else{b=0;c=0;d=g;do{if(!(k[d>>2]|0)){p=k[d+8>>2]|0;b=(aa(p,k[d+12>>2]|0)|0)+b|0;c=(aa(k[d+4>>2]|0,p)|0)+c|0}d=k[d+44>>2]|0}while((d|0)!=0);d=b}n=o+72|0;b=k[n>>2]|0;if(b){e=b;do{if(!(k[e>>2]|0)){p=k[e+8>>2]|0;d=(aa(k[e+12>>2]<<7,p)|0)+d|0;c=(aa(p<<7,k[e+4>>2]|0)|0)+c|0}e=k[e+44>>2]|0}while((e|0)!=0)}if((d|0)<1)return;e=(k[o+44>>2]|0)-(k[o+76>>2]|0)|0;if((e|0)<(c|0)){p=(e|0)/(d|0)|0;p=(p|0)<1?1:p}else p=1e9;if(!f){m=o+80|0;l=g;do{if(!(k[l>>2]|0)){c=k[l+4>>2]|0;b=k[l+12>>2]|0;if(((((c+-1|0)>>>0)/(b>>>0)|0)+1|0)>(p|0)){b=aa(b,p)|0;j=l+16|0;k[j>>2]=b;b=l+8|0;Dcb(a,l+48|0,aa(k[b>>2]|0,c)|0);k[l+40>>2]=1;c=k[j>>2]|0}else{k[l+16>>2]=c;b=l+8|0}j=k[b>>2]|0;d=k[q>>2]|0;b=999999984/(j>>>0)|0;if(j>>>0>999999984){i=k[a>>2]|0;k[i+20>>2]=72;Uh[k[i>>2]&2047](a)}e=(b|0)<(c|0)?b:c;k[d+80>>2]=e;i=m9a(a,1,c<<2)|0;if(c|0){b=0;do{d=c-b|0;e=e>>>0<d>>>0?e:d;d=aa(e,j)|0;g=k[q>>2]|0;if(d>>>0>999999984){h=k[a>>2]|0;k[h+20>>2]=56;k[h+24>>2]=3;Uh[k[h>>2]&2047](a)}f=d&7;d=((f|0)==0?0:8-f|0)+d|0;f=d+16|0;h=fgb(f)|0;if(!h){r=k[a>>2]|0;k[r+20>>2]=56;k[r+24>>2]=4;Uh[k[r>>2]&2047](a)}r=g+76|0;k[r>>2]=(k[r>>2]|0)+f;r=g+64|0;k[h>>2]=k[r>>2];k[h+4>>2]=d;k[h+8>>2]=0;k[r>>2]=h;if(e){g=e;f=h+16|0;while(1){d=b+1|0;k[i+(b<<2)>>2]=f;g=g+-1|0;if(!g){b=d;break}else{f=f+j|0;b=d}}}}while(b>>>0<c>>>0)}k[l>>2]=i;k[l+20>>2]=k[m>>2];k[l+24>>2]=0;k[l+28>>2]=0;k[l+36>>2]=0}l=k[l+44>>2]|0}while((l|0)!=0);b=k[n>>2]|0}if(!b)return;n=o+80|0;do{if(!(k[b>>2]|0)){d=k[b+4>>2]|0;c=k[b+12>>2]|0;if(((((d+-1|0)>>>0)/(c>>>0)|0)+1|0)>(p|0)){c=aa(c,p)|0;r=b+16|0;k[r>>2]=c;c=b+8|0;Dcb(a,b+48|0,aa(d<<7,k[c>>2]|0)|0);k[b+40>>2]=1;d=k[r>>2]|0}else{k[b+16>>2]=d;c=b+8|0}l=k[c>>2]|0;e=k[q>>2]|0;m=l<<7;c=999999984/(m>>>0)|0;if(m>>>0>999999984){r=k[a>>2]|0;k[r+20>>2]=72;Uh[k[r>>2]&2047](a)}f=(c|0)<(d|0)?c:d;k[e+80>>2]=f;j=m9a(a,1,d<<2)|0;if(d|0){c=0;do{e=d-c|0;f=f>>>0<e>>>0?f:e;e=aa(f,m)|0;g=k[q>>2]|0;if(e>>>0>999999984){r=k[a>>2]|0;k[r+20>>2]=56;k[r+24>>2]=3;Uh[k[r>>2]&2047](a)}h=e|16;i=fgb(h)|0;if(!i){r=k[a>>2]|0;k[r+20>>2]=56;k[r+24>>2]=4;Uh[k[r>>2]&2047](a)}r=g+76|0;k[r>>2]=(k[r>>2]|0)+h;r=g+64|0;k[i>>2]=k[r>>2];k[i+4>>2]=e;k[i+8>>2]=0;k[r>>2]=i;if(f){h=f;g=i+16|0;while(1){e=c+1|0;k[j+(c<<2)>>2]=g;h=h+-1|0;if(!h){c=e;break}else{g=g+(l<<7)|0;c=e}}}}while(c>>>0<d>>>0)}k[b>>2]=j;k[b+20>>2]=k[n>>2];k[b+24>>2]=0;k[b+28>>2]=0;k[b+36>>2]=0}b=k[b+44>>2]|0}while((b|0)!=0);return}function t9a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;w=d+c|0;s=b+4|0;if(!((w>>>0<=(k[s>>2]|0)>>>0?(k[b+12>>2]|0)>>>0>=d>>>0:0)?(k[b>>2]|0)!=0:0)){x=k[a>>2]|0;k[x+20>>2]=23;Uh[k[x>>2]&2047](a)}x=b+24|0;n=k[x>>2]|0;if(!(n>>>0<=c>>>0?w>>>0<=((k[b+16>>2]|0)+n|0)>>>0:0))v=7;a:do if((v|0)==7){if(!(k[b+40>>2]|0)){n=k[a>>2]|0;k[n+20>>2]=71;Uh[k[n>>2]&2047](a)}n=b+36|0;if(!(k[n>>2]|0)){d=b+16|0;m=d;d=k[d>>2]|0}else{j=k[b+8>>2]|0;f=k[x>>2]|0;l=b+20|0;m=b+16|0;d=k[m>>2]|0;b:do if((d|0)>0?(o=b+28|0,p=b+48|0,q=b+52|0,g=k[l>>2]|0,g=(g|0)<(d|0)?g:d,i=(k[o>>2]|0)-f|0,i=(g|0)<(i|0)?g:i,g=(k[s>>2]|0)-f|0,g=(i|0)<(g|0)?i:g,(g|0)>=1):0){h=aa(f,j)|0;i=0;f=g;while(1){g=aa(f,j)|0;eh[k[q>>2]&255](a,p,k[(k[b>>2]|0)+(i<<2)>>2]|0,h,g);f=k[l>>2]|0;i=f+i|0;d=k[m>>2]|0;if((d|0)<=(i|0))break b;z=d-i|0;z=(f|0)<(z|0)?f:z;f=i+(k[x>>2]|0)|0;y=(k[o>>2]|0)-f|0;y=(z|0)<(y|0)?z:y;f=(k[s>>2]|0)-f|0;f=(y|0)<(f|0)?y:f;if((f|0)<1)break;else h=g+h|0}}while(0);k[n>>2]=0}if((k[x>>2]|0)>>>0<c>>>0)f=c;else{f=w-d|0;f=(f|0)<0?0:f}k[x>>2]=f;j=k[b+8>>2]|0;l=b+20|0;if((d|0)>0?(t=b+28|0,u=b+48|0,r=k[l>>2]|0,r=(r|0)<(d|0)?r:d,z=(k[t>>2]|0)-f|0,z=(r|0)<(z|0)?r:z,r=(k[s>>2]|0)-f|0,r=(z|0)<(r|0)?z:r,(r|0)>=1):0){h=aa(j,f)|0;i=0;d=r;while(1){g=aa(d,j)|0;eh[k[u>>2]&255](a,u,k[(k[b>>2]|0)+(i<<2)>>2]|0,h,g);f=k[l>>2]|0;i=f+i|0;d=k[m>>2]|0;if((d|0)<=(i|0))break a;y=d-i|0;y=(f|0)<(y|0)?f:y;d=i+(k[x>>2]|0)|0;z=(k[t>>2]|0)-d|0;z=(y|0)<(z|0)?y:z;d=(k[s>>2]|0)-d|0;d=(z|0)<(d|0)?z:d;if((d|0)<1)break;else h=g+h|0}}}while(0);g=b+28|0;d=k[g>>2]|0;do if(d>>>0<w>>>0){f=(e|0)==0;if(d>>>0<c>>>0)if(f){d=c;f=0}else{d=k[a>>2]|0;k[d+20>>2]=23;Uh[k[d>>2]&2047](a);d=c;v=29}else if(f)f=0;else v=29;if((v|0)==29){k[g>>2]=w;f=1}if(!(k[b+32>>2]|0)){if(f)break;z=k[a>>2]|0;k[z+20>>2]=23;Uh[k[z>>2]&2047](a);break}g=k[b+8>>2]|0;f=k[x>>2]|0;d=d-f|0;f=w-f|0;if(d>>>0<f>>>0)do{zpb(k[(k[b>>2]|0)+(d<<2)>>2]|0,0,g|0)|0;d=d+1|0}while((d|0)!=(f|0))}while(0);if(!e){y=k[b>>2]|0;z=k[x>>2]|0;z=c-z|0;z=y+(z<<2)|0;return z|0}k[b+36>>2]=1;y=k[b>>2]|0;z=k[x>>2]|0;z=c-z|0;z=y+(z<<2)|0;return z|0}function u9a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;w=d+c|0;s=b+4|0;if(!((w>>>0<=(k[s>>2]|0)>>>0?(k[b+12>>2]|0)>>>0>=d>>>0:0)?(k[b>>2]|0)!=0:0)){x=k[a>>2]|0;k[x+20>>2]=23;Uh[k[x>>2]&2047](a)}x=b+24|0;n=k[x>>2]|0;if(!(n>>>0<=c>>>0?w>>>0<=((k[b+16>>2]|0)+n|0)>>>0:0))v=7;a:do if((v|0)==7){if(!(k[b+40>>2]|0)){n=k[a>>2]|0;k[n+20>>2]=71;Uh[k[n>>2]&2047](a)}n=b+36|0;if(!(k[n>>2]|0)){d=b+16|0;m=d;d=k[d>>2]|0}else{j=k[b+8>>2]<<7;f=k[x>>2]|0;l=b+20|0;m=b+16|0;d=k[m>>2]|0;b:do if((d|0)>0?(o=b+28|0,p=b+48|0,q=b+52|0,g=k[l>>2]|0,g=(g|0)<(d|0)?g:d,i=(k[o>>2]|0)-f|0,i=(g|0)<(i|0)?g:i,g=(k[s>>2]|0)-f|0,g=(i|0)<(g|0)?i:g,(g|0)>=1):0){h=aa(f,j)|0;i=0;f=g;while(1){g=aa(f,j)|0;eh[k[q>>2]&255](a,p,k[(k[b>>2]|0)+(i<<2)>>2]|0,h,g);f=k[l>>2]|0;i=f+i|0;d=k[m>>2]|0;if((d|0)<=(i|0))break b;z=d-i|0;z=(f|0)<(z|0)?f:z;f=i+(k[x>>2]|0)|0;y=(k[o>>2]|0)-f|0;y=(z|0)<(y|0)?z:y;f=(k[s>>2]|0)-f|0;f=(y|0)<(f|0)?y:f;if((f|0)<1)break;else h=g+h|0}}while(0);k[n>>2]=0}if((k[x>>2]|0)>>>0<c>>>0)f=c;else{f=w-d|0;f=(f|0)<0?0:f}k[x>>2]=f;j=k[b+8>>2]<<7;l=b+20|0;if((d|0)>0?(t=b+28|0,u=b+48|0,r=k[l>>2]|0,r=(r|0)<(d|0)?r:d,z=(k[t>>2]|0)-f|0,z=(r|0)<(z|0)?r:z,r=(k[s>>2]|0)-f|0,r=(z|0)<(r|0)?z:r,(r|0)>=1):0){h=aa(j,f)|0;i=0;d=r;while(1){g=aa(d,j)|0;eh[k[u>>2]&255](a,u,k[(k[b>>2]|0)+(i<<2)>>2]|0,h,g);d=k[l>>2]|0;i=d+i|0;f=k[m>>2]|0;if((f|0)<=(i|0))break a;y=f-i|0;y=(d|0)<(y|0)?d:y;d=i+(k[x>>2]|0)|0;z=(k[t>>2]|0)-d|0;z=(y|0)<(z|0)?y:z;d=(k[s>>2]|0)-d|0;d=(z|0)<(d|0)?z:d;if((d|0)<1)break;else h=g+h|0}}}while(0);g=b+28|0;d=k[g>>2]|0;do if(d>>>0<w>>>0){f=(e|0)==0;if(d>>>0<c>>>0)if(f){d=c;f=0}else{d=k[a>>2]|0;k[d+20>>2]=23;Uh[k[d>>2]&2047](a);d=c;v=29}else if(f)f=0;else v=29;if((v|0)==29){k[g>>2]=w;f=1}if(!(k[b+32>>2]|0)){if(f)break;z=k[a>>2]|0;k[z+20>>2]=23;Uh[k[z>>2]&2047](a);break}g=k[b+8>>2]<<7;f=k[x>>2]|0;d=d-f|0;f=w-f|0;if(d>>>0<f>>>0)do{zpb(k[(k[b>>2]|0)+(d<<2)>>2]|0,0,g|0)|0;d=d+1|0}while((d|0)!=(f|0))}while(0);if(!e){y=k[b>>2]|0;z=k[x>>2]|0;z=c-z|0;z=y+(z<<2)|0;return z|0}k[b+36>>2]=1;y=k[b>>2]|0;z=k[x>>2]|0;z=c-z|0;z=y+(z<<2)|0;return z|0}function v9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=k[a+4>>2]|0;if(b>>>0<=1){if((b|0)==1){e=f+68|0;c=k[e>>2]|0;if(c|0)do{d=c+40|0;if(k[d>>2]|0){k[d>>2]=0;jh[k[c+56>>2]&1023](a,c+48|0)}c=k[c+44>>2]|0}while((c|0)!=0);k[e>>2]=0;e=f+72|0;c=k[e>>2]|0;if(c|0)do{d=c+40|0;if(k[d>>2]|0){k[d>>2]=0;jh[k[c+56>>2]&1023](a,c+48|0)}c=k[c+44>>2]|0}while((c|0)!=0);k[e>>2]=0}}else{e=k[a>>2]|0;k[e+20>>2]=15;k[e+24>>2]=b;Uh[k[e>>2]&2047](a)}a=f+60+(b<<2)|0;c=k[a>>2]|0;k[a>>2]=0;if(c|0){d=f+76|0;do{e=c;c=k[c>>2]|0;a=(k[e+4>>2]|0)+16+(k[e+8>>2]|0)|0;ggb(e);k[d>>2]=(k[d>>2]|0)-a}while((c|0)!=0)}b=f+52+(b<<2)|0;c=k[b>>2]|0;k[b>>2]=0;if(!c)return;d=f+76|0;do{b=c;c=k[c>>2]|0;f=(k[b+4>>2]|0)+16+(k[b+8>>2]|0)|0;ggb(b);k[d>>2]=(k[d>>2]|0)-f}while((c|0)!=0);return}function w9a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;v9a(a,1);d=a+4|0;c=k[d>>2]|0;b=c+60|0;a=k[b>>2]|0;k[b>>2]=0;if(a|0){b=c+76|0;do{f=a;a=k[a>>2]|0;e=(k[f+4>>2]|0)+16+(k[f+8>>2]|0)|0;ggb(f);k[b>>2]=(k[b>>2]|0)-e}while((a|0)!=0)}f=c+52|0;a=k[f>>2]|0;k[f>>2]=0;if(!a){f=k[d>>2]|0;ggb(f);k[d>>2]=0;return}b=c+76|0;do{e=a;a=k[a>>2]|0;f=(k[e+4>>2]|0)+16+(k[e+8>>2]|0)|0;ggb(e);k[b>>2]=(k[b>>2]|0)-f}while((a|0)!=0);f=k[d>>2]|0;ggb(f);k[d>>2]=0;return}function x9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0;b=a+484|0;h=k[b>>2]|0;k[a+136>>2]=k[h+16>>2];k[a+132>>2]=k[h+20>>2];switch(k[a+88>>2]|0){case 0:{b=h+4|0;if((k[a+120>>2]|0)==3){k[b>>2]=224;return}else{k[b>>2]=225;return}}case 1:{j=a+120|0;k[h+4>>2]=(k[j>>2]|0)==3?227:226;k[h+48>>2]=0;if(!(k[h+28>>2]|0))A9a(a);if(k[h+52>>2]|0)return;h=k[b>>2]|0;b=k[j>>2]|0;if((b|0)<=0)return;i=a+4|0;g=0;do{d=k[h+32+(g<<2)>>2]|0;a:do if((g|0)>0){c=0;while(1){if((d|0)==(k[h+32+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(g|0)){m=14;break a}}c=k[h+52+(c<<2)>>2]|0;if(!c)m=14}else m=14;while(0);if((m|0)==14){m=0;c=ci[k[k[i>>2]>>2]&255](a,1,1024)|0;f=(d<<9)+-512|0;e=0;do{d=0;do{n=255-((l[410562+(e<<4)+d>>0]|0)<<1)|0;b=n*255|0;if((n|0)<0)b=0-((0-b|0)/(f|0)|0)|0;else b=(b|0)/(f|0)|0;k[c+(e<<6)+(d<<2)>>2]=b;d=d+1|0}while((d|0)!=16);e=e+1|0}while((e|0)!=16);b=k[j>>2]|0}k[h+52+(g<<2)>>2]=c;g=g+1|0}while((g|0)<(b|0));return}case 2:{k[h+4>>2]=228;k[h+84>>2]=0;if(!(k[h+68>>2]|0)){b=a+112|0;e=(k[b>>2]<<1)+4|0;f=a+120|0;if((k[f>>2]|0)<=0)return;g=a+4|0;c=0;do{d=ci[k[(k[g>>2]|0)+4>>2]&255](a,1,e)|0;k[h+68+(c<<2)>>2]=d;c=c+1|0;d=k[f>>2]|0}while((c|0)<(d|0))}else{d=a+120|0;f=d;b=a+112|0;d=k[d>>2]|0}c=(k[b>>2]<<1)+4|0;if((d|0)>0)b=0;else return;do{zpb(k[h+68+(b<<2)>>2]|0,0,c|0)|0;b=b+1|0}while((b|0)<(k[f>>2]|0));return}default:{n=k[a>>2]|0;k[n+20>>2]=49;Uh[k[n>>2]&2047](a);return}}}function y9a(a){a=a|0;return}function z9a(a){a=a|0;var b=0;b=k[a>>2]|0;k[b+20>>2]=47;Uh[k[b>>2]&2047](a);return}function A9a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;m=k[a+484>>2]|0;b=(k[a+88>>2]|0)==1;k[m+28>>2]=b&1;l=a+120|0;c=Dg[k[(k[a+4>>2]|0)+8>>2]&127](a,1,b?766:256,k[l>>2]|0)|0;j=m+24|0;k[j>>2]=c;a=k[m+20>>2]|0;if((k[l>>2]|0)<=0)return;if(b)b=0;else{b=0;while(1){d=k[m+32+(b<<2)>>2]|0;a=(a|0)/(d|0)|0;f=k[c+(b<<2)>>2]|0;g=d+-1|0;h=g<<1;c=0;d=(d+254|0)/(h|0)|0;e=0;do{if((e|0)>(d|0))do{c=c+1|0;d=(((c<<1|1)*255|0)+g|0)/(h|0)|0}while((e|0)>(d|0));n=(aa(c,a)|0)&255;i[f+e>>0]=n;e=e+1|0}while((e|0)!=256);b=b+1|0;if((b|0)>=(k[l>>2]|0))break;c=k[j>>2]|0}return}while(1){d=k[m+32+(b<<2)>>2]|0;a=(a|0)/(d|0)|0;h=c+(b<<2)|0;k[h>>2]=(k[h>>2]|0)+255;h=k[(k[j>>2]|0)+(b<<2)>>2]|0;f=d+-1|0;g=f<<1;c=0;d=(d+254|0)/(g|0)|0;e=0;do{if((e|0)>(d|0))do{c=c+1|0;d=(((c<<1|1)*255|0)+f|0)/(g|0)|0}while((e|0)>(d|0));n=(aa(c,a)|0)&255;i[h+e>>0]=n;e=e+1|0}while((e|0)!=256);d=h+255|0;c=1;do{i[h+(0-c)>>0]=i[h>>0]|0;i[h+(c+255)>>0]=i[d>>0]|0;c=c+1|0}while((c|0)!=256);b=b+1|0;if((b|0)>=(k[l>>2]|0))break;c=k[j>>2]|0}return}
function L1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+176|0;s=t+112|0;q=t+56|0;p=t;h=a+40|0;e=k[h>>2]|0;n=k[e>>2]|0;o=b+40|0;f=k[o>>2]|0;l=k[f>>2]|0;if(!l){r=t;return}if((a|0)==(b|0)){AF(s,a);L1(a,s);e=s+36|0;c=k[e>>2]|0;if(c|0?(q=c+12|0,b=k[q>>2]|0,k[q>>2]=b+-1,(b|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;b=s+16|0;d=s+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[d>>2]|0)>0){e=k[s+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[s+44>>2]|0;if(!((c|0)==(s+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=t;return}m=a+16|0;if(!(k[m>>2]|0)){k[q>>2]=1124007936;j=q+4|0;c=q+8|0;g=q+40|0;d=j;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[g>>2]=c;h=q+48|0;f=q+44|0;k[f>>2]=h;k[q+52>>2]=0;k[h>>2]=0;e=s+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[s>>2]=33619968;k[e>>2]=q;mY(b,s);KG(a,q)|0;e=q+36|0;c=k[e>>2]|0;if(c|0?(b=c+12|0,s=k[b>>2]|0,k[b>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=q+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[j>>2]|0)>0){d=k[g>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[j>>2]|0))}c=k[f>>2]|0;if(!((c|0)==(h|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=t;return}k[e>>2]=l;g=k[e+-4>>2]|0;a:do if((g|0)==(k[f+-4>>2]|0)){if((g|0)==2){if((l|0)!=(k[f>>2]|0)){j=39;break}g=(k[e+4>>2]|0)==(k[f+4>>2]|0);k[e>>2]=n;if(g)break;else{j=42;break}}b:do if((g|0)>0){if((l|0)==(k[f>>2]|0))c=1;else{j=39;break a}while(1){if((c|0)>=(g|0))break b;if((k[e+(c<<2)>>2]|0)==(k[f+(c<<2)>>2]|0))c=c+1|0;else{j=39;break a}}}while(0);k[e>>2]=n}else j=39;while(0);if((j|0)==39){k[e>>2]=n;j=42}if((j|0)==42?(g=s+4|0,d=ZT(8)|0,k[d>>2]=1,f=d+4|0,k[s>>2]=f,k[g>>2]=0,i[f>>0]=0,Y8(-209,s,366281,216975,834),k[g>>2]=0,k[s>>2]=0,g=k[d>>2]|0,k[d>>2]=g+-1,(g|0)==1):0)ggb(k[d+-4>>2]|0);c=k[a>>2]|0;if((k[b>>2]^c)&4095){g=s+4|0;c=ZT(8)|0;k[c>>2]=1;f=c+4|0;k[s>>2]=f;k[g>>2]=0;i[f>>0]=0;Y8(-205,s,366281,216975,836);k[g>>2]=0;k[s>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)==1)ggb(k[c+-4>>2]|0);c=k[a>>2]|0}if(!(c&32768)){d=a+24|0;f=k[d>>2]|0;c=a+44|0;e=k[c>>2]|0;g=f+(aa(k[e>>2]|0,l)|0)|0;if(g>>>0>(k[a+28>>2]|0)>>>0)j=52;else{g=d;d=f}}else{c=a+44|0;d=a+24|0;j=52}if((j|0)==52){g=l+n|0;e=((n*3|0)+1|0)/2|0;K1(a,(g|0)<(e|0)?e:g);g=d;e=k[c>>2]|0;d=k[d>>2]|0}c=k[h>>2]|0;k[c>>2]=(k[c>>2]|0)+l;c=k[e>>2]|0;j=d+(aa(c,l)|0)|0;k[g>>2]=j;if(k[a>>2]&16384|0?k[b>>2]&16384|0:0){g=(k[m>>2]|0)+(aa(c,n)|0)|0;h=k[b+16>>2]|0;f=k[b+4>>2]|0;if((f|0)<3)d=aa(k[b+12>>2]|0,k[b+8>>2]|0)|0;else{e=k[o>>2]|0;c=0;d=1;do{d=aa(k[e+(c<<2)>>2]|0,d)|0;c=c+1|0}while((c|0)!=(f|0))}if((f|0)>0)c=k[(k[b+44>>2]|0)+(f+-1<<2)>>2]|0;else c=0;upb(g|0,h|0,aa(c,d)|0)|0;r=t;return}k[s>>2]=n;k[s+4>>2]=l+n;k[q>>2]=-2147483648;k[q+4>>2]=2147483647;H1(p,a,s,q);e=s+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[s>>2]=33619968;k[e>>2]=p;mY(b,s);e=p+36|0;c=k[e>>2]|0;if(c|0?(b=c+12|0,s=k[b>>2]|0,k[b>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[p+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=p+16|0;d=p+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[d>>2]|0)>0){e=k[p+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[p+44>>2]|0;if(!((c|0)==(p+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=t;return}function M1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+336|0;z=B+200|0;A=B+72|0;y=B+16|0;o=B;if(!b){k[a>>2]=1124007936;d=a+8|0;g=a+40|0;u=a+4|0;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[g>>2]=d;A=a+48|0;k[a+44>>2]=A;k[a+52>>2]=0;k[A>>2]=0;r=B;return}n=k[b>>2]|0;d=n&-65536;if((d|0)==1111621632){j=k[b+24>>2]|0;if((j|0)>-1?(m=k[b+20>>2]|0,(m|0)>-1):0){k[a>>2]=1124007936;e=a+4|0;h=a+8|0;d=a+40|0;u=e;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[d>>2]=h;d=a+48|0;k[a+44>>2]=d;g=a+52|0;k[g>>2]=0;k[d>>2]=0;if(c){k[a+16>>2]=0;k[a+24>>2]=0;k[a+20>>2]=0;JN(z,m,j,n,k[b+16>>2]|0,k[b+4>>2]|0);e=A+4|0;d=e+4|0;k[d>>2]=0;k[d+4>>2]=0;k[A>>2]=33619968;k[e>>2]=a;mY(z,A);e=z+36|0;d=k[e>>2]|0;if(d|0?(A=d+12|0,a=k[A>>2]|0,k[A>>2]=a+-1,(a|0)==1):0){g=k[e>>2]|0;if(g|0){d=k[g+4>>2]|0;if(!d){d=k[z+32>>2]|0;if(!d){d=B1()|0;g=k[e>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[e>>2]=0}k[e>>2]=0;a=z+16|0;g=z+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[g>>2]|0)>0){e=k[z+40>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[g>>2]|0))}d=k[z+44>>2]|0;if(!((d|0)==(z+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}else{k[a>>2]=n&20479|1124007936;k[e>>2]=2;k[h>>2]=m;k[a+12>>2]=j;c=k[b+16>>2]|0;k[a+16>>2]=c;k[a+20>>2]=c;A=(n>>>3&511)+1<<(47696>>>(n<<1&14)&3);y=aa(A,j)|0;z=k[b+4>>2]|0;z=(z|0)==0?y:z;b=c+(aa(z,m)|0)|0;k[a+28>>2]=b;k[a+24>>2]=b+(0-z)+y;k[d>>2]=z;k[g>>2]=A}r=B;return}}else if((d|0)==1111687168?(w=k[b+16>>2]|0,l=w,w|0):0){m=a+4|0;d=a+8|0;j=a+40|0;u=m;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[j>>2]=d;h=a+48|0;k[a+44>>2]=h;k[a+52>>2]=0;k[h>>2]=0;h=a+16|0;k[h>>2]=l;k[a+20>>2]=l;k[a>>2]=n&4095|1124007936;g=k[b+4>>2]|0;if((g|0)>0){d=0;do{k[z+(d<<2)>>2]=k[b+20+(d<<3)>>2];k[A+(d<<2)>>2]=k[b+20+(d<<3)+4>>2];d=d+1|0}while((d|0)!=(g|0))}x1(a,g,z,A,0);y1(a);if(c){AF(y,a);e=a+36|0;d=k[e>>2]|0;if(d|0?(z=d+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){g=k[e>>2]|0;if(g|0){d=k[g+4>>2]|0;if(!d){d=k[a+32>>2]|0;if(!d){d=B1()|0;g=k[e>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[e>>2]=0}k[e>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[m>>2]|0)>0){g=k[j>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[m>>2]|0))}e=o+4|0;d=e+4|0;k[d>>2]=0;k[d+4>>2]=0;k[o>>2]=33619968;k[e>>2]=a;mY(y,o);e=y+36|0;d=k[e>>2]|0;if(d|0?(A=d+12|0,a=k[A>>2]|0,k[A>>2]=a+-1,(a|0)==1):0){g=k[e>>2]|0;if(g|0){d=k[g+4>>2]|0;if(!d){d=k[y+32>>2]|0;if(!d){d=B1()|0;g=k[e>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[e>>2]=0}k[e>>2]=0;a=y+16|0;g=y+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[g>>2]|0)>0){e=k[y+40>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[g>>2]|0))}d=k[y+44>>2]|0;if(!((d|0)==(y+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}r=B;return}if((n|0)==112?(q=b+68|0,k[q>>2]|0):0){w=b+48|0;if(((e|0)==0?(g=k[w>>2]|0,g|0):0)?(k[g>>2]|0)>0:0){d=z+4|0;g=ZT(44)|0;k[g>>2]=1;u=g+4|0;k[z>>2]=u;k[d>>2]=36;i[g+40>>0]=0;j=217614;v=u+36|0;do{i[u>>0]=i[j>>0]|0;u=u+1|0;j=j+1|0}while((u|0)<(v|0));Y8(-24,z,217651,216975,869);k[d>>2]=0;k[z>>2]=0;v=k[g>>2]|0;k[g>>2]=v+-1;if((v|0)==1)ggb(k[g+-4>>2]|0)}k[a>>2]=1124007936;s=a+4|0;m=a+8|0;f=a+40|0;d=s+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[d+24>>2]=0;k[d+28>>2]=0;k[f>>2]=m;d=a+48|0;o=a+44|0;k[o>>2]=d;k[a+52>>2]=0;k[s>>2]=2;h=k[b+16>>2]|0;h=1125516576>>>((h>>>2&60)+(h>>31&20)|0);k[d>>2]=k[b+72>>2];g=k[w>>2]|0;t=b+28|0;e=(k[t>>2]|0)==0;if(!g){if(!e){k[z>>2]=0;d=z+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;u=g+4|0;k[z>>2]=u;k[d>>2]=38;i[g+42>>0]=0;j=217662;v=u+38|0;do{i[u>>0]=i[j>>0]|0;u=u+1|0;j=j+1|0}while((u|0)<(v|0));Y8(-215,z,217701,216975,640);k[d>>2]=0;k[z>>2]=0;v=k[g>>2]|0;k[g>>2]=v+-1;if((v|0)==1)ggb(k[g+-4>>2]|0);d=k[o>>2]|0}g=((k[b+8>>2]<<3)+-8|h&7)+1124007936|0;k[a>>2]=g;h=k[b+44>>2]|0;k[m>>2]=h;e=k[b+40>>2]|0;k[a+12>>2]=e;l=k[q>>2]|0;k[a+16>>2]=l;k[a+20>>2]=l;m=(g>>>3&511)+1<<(47696>>>(g<<1&14)&3);j=k[d>>2]|0}else{if(!e?(k[g>>2]|0)==0:0){k[z>>2]=0;g=z+4|0;k[g>>2]=0;e=ZT(68)|0;k[e>>2]=1;u=e+4|0;k[z>>2]=u;k[g>>2]=60;i[e+64>>0]=0;j=217715;v=u+60|0;do{i[u>>0]=i[j>>0]|0;u=u+1|0;j=j+1|0}while((u|0)<(v|0));Y8(-215,z,217701,216975,649);k[g>>2]=0;k[z>>2]=0;v=k[e>>2]|0;k[e>>2]=v+-1;if((v|0)==1)ggb(k[e+-4>>2]|0);n=k[w>>2]|0}else n=g;l=k[n>>2]|0;if(l){g=h&7;if((k[t>>2]|0)==1){e=1;j=1}else p=75}else{g=h&7;p=75}if((p|0)==75){e=k[b+8>>2]|0;j=0}g=((e<<3)+-8|g)+1124007936|0;k[a>>2]=g;h=k[n+16>>2]|0;k[m>>2]=h;e=k[n+12>>2]|0;k[a+12>>2]=e;m=(g>>>3&511)+1<<(47696>>>(g<<1&14)&3);if(j){d=aa(k[d>>2]|0,l+-1|0)|0;d=aa(d,k[b+44>>2]|0)|0}else d=0;b=k[o>>2]|0;j=k[b>>2]|0;l=(k[q>>2]|0)+d+(aa(j,k[n+8>>2]|0)|0)|0;l=l+(aa(k[n+4>>2]|0,m)|0)|0;k[a+16>>2]=l;k[a+20>>2]=l;d=b}b=l+(aa(j,h)|0)|0;k[a+28>>2]=b;b=aa(m,e)|0;v=l+(aa(h+-1|0,j)|0)+b|0;k[a+24>>2]=v;k[a>>2]=((h|0)==1|(b|0)==(j|0)?16384:0)|g;k[d+4>>2]=m;if(!c){r=B;return}AF(A,a);e=a+36|0;d=k[e>>2]|0;if(d|0?(c=d+12|0,b=k[c>>2]|0,k[c>>2]=b+-1,(b|0)==1):0){g=k[e>>2]|0;if(g|0){d=k[g+4>>2]|0;if(!d){d=k[a+32>>2]|0;if(!d){d=B1()|0;g=k[e>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[e>>2]=0}k[e>>2]=0;b=a+16|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[s>>2]|0)>0){g=k[f>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[s>>2]|0))}d=k[w>>2]|0;if(((d|0)!=0?(x=k[d>>2]|0,(x|0)!=0):0)?(k[t>>2]|0)!=1:0){k[y>>2]=x+-1;k[y+4>>2]=0;c=k[A+12>>2]|0;b=k[A>>2]&4095;k[z>>2]=k[A+8>>2];k[z+4>>2]=c;G1(a,2,z,b);HV(A,1,a,1,y,1)}else{y=z+4|0;b=y+4|0;k[b>>2]=0;k[b+4>>2]=0;k[z>>2]=33619968;k[y>>2]=a;mY(A,z)}e=A+36|0;d=k[e>>2]|0;if(d|0?(z=d+12|0,a=k[z>>2]|0,k[z>>2]=a+-1,(a|0)==1):0){g=k[e>>2]|0;if(g|0){d=k[g+4>>2]|0;if(!d){d=k[A+32>>2]|0;if(!d){d=B1()|0;g=k[e>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[e>>2]=0}k[e>>2]=0;a=A+16|0;g=A+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[g>>2]|0)>0){e=k[A+40>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[g>>2]|0))}d=k[A+44>>2]|0;if(!((d|0)==(A+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=B;return}if((d|0)!=1117323264){d=z+4|0;g=ZT(24)|0;k[g>>2]=1;u=g+4|0;k[z>>2]=u;k[d>>2]=18;i[g+22>>0]=0;j=229223;v=u+18|0;do{i[u>>0]=i[j>>0]|0;u=u+1|0;j=j+1|0}while((u|0)<(v|0));Y8(-5,z,217651,216975,893);k[d>>2]=0;k[z>>2]=0;A=k[g>>2]|0;k[g>>2]=A+-1;if((A|0)==1)ggb(k[g+-4>>2]|0);k[a>>2]=1124007936;d=a+8|0;g=a+40|0;u=a+4|0;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[g>>2]=d;A=a+48|0;k[a+44>>2]=A;k[a+52>>2]=0;k[A>>2]=0;r=B;return}l=k[b+24>>2]|0;m=n&4095;e=k[b+28>>2]|0;if(!l){k[a>>2]=1124007936;d=a+8|0;g=a+40|0;u=a+4|0;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[g>>2]=d;A=a+48|0;k[a+44>>2]=A;k[a+52>>2]=0;k[A>>2]=0;r=B;return}if(!((l|0)>0?((n>>>3&511)+1<<(47696>>>(n<<1&14)&3)|0)==(e|0):0)){d=z+4|0;g=ZT(52)|0;k[g>>2]=1;u=g+4|0;k[z>>2]=u;k[d>>2]=44;i[g+48>>0]=0;j=217776;v=u+44|0;do{i[u>>0]=i[j>>0]|0;u=u+1|0;j=j+1|0}while((u|0)<(v|0));Y8(-215,z,217651,216975,878);k[d>>2]=0;k[z>>2]=0;y=k[g>>2]|0;k[g>>2]=y+-1;if((y|0)==1)ggb(k[g+-4>>2]|0)}if(!c?(h=k[b+52>>2]|0,(k[h+4>>2]|0)==(h|0)):0){JN(a,l,1,m,k[h+16>>2]|0,0);r=B;return}if(f|0){e=(aa(e,l)|0)+7|0;h=e>>>3;j=f+4|0;do if((k[j>>2]|0)>>>0<h>>>0){d=k[f>>2]|0;g=f+8|0;if((d|0)!=(g|0)){if(d|0)ggb(d);k[f>>2]=g;k[j>>2]=136;d=g}if(e>>>0<=1095)break;g=(h|0)==0?1:h<<3;while(1){d=fgb(g)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[f>>2]=d;k[j>>2]=h}else{k[j>>2]=h;d=k[f>>2]|0}while(0);JY(b,d,0,1073741823);JN(a,l,1,m,d,0);r=B;return}k[A>>2]=1124007936;t=A+4|0;g=A+8|0;p=A+40|0;u=t;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[p>>2]=g;s=A+48|0;q=A+44|0;k[q>>2]=s;k[A+52>>2]=0;k[s>>2]=0;k[z>>2]=l;k[z+4>>2]=1;G1(A,2,z,m);f=A+16|0;JY(b,k[f>>2]|0,0,1073741823);k[a>>2]=k[A>>2];m=a+4|0;d=k[t>>2]|0;k[m>>2]=d;l=a+8|0;k[l>>2]=k[g>>2];k[a+12>>2]=k[A+12>>2];k[a+16>>2]=k[f>>2];k[a+20>>2]=k[A+20>>2];k[a+24>>2]=k[A+24>>2];k[a+28>>2]=k[A+28>>2];n=A+32|0;k[a+32>>2]=k[n>>2];o=A+36|0;g=k[o>>2]|0;k[a+36>>2]=g;e=a+40|0;k[e>>2]=l;A=a+48|0;l=a+44|0;k[l>>2]=A;k[a+52>>2]=0;k[A>>2]=0;if(g){d=g+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[t>>2]|0}if((d|0)>=3){k[m>>2]=0;x1(a,d,0,0,0);if((k[m>>2]|0)>0){j=k[p>>2]|0;e=k[e>>2]|0;h=k[q>>2]|0;g=k[l>>2]|0;d=0;do{k[e+(d<<2)>>2]=k[j+(d<<2)>>2];k[g+(d<<2)>>2]=k[h+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else{A=k[q>>2]|0;a=k[l>>2]|0;k[a>>2]=k[A>>2];k[a+4>>2]=k[A+4>>2]}d=k[o>>2]|0;if(d|0?(A=d+12|0,a=k[A>>2]|0,k[A>>2]=a+-1,(a|0)==1):0){g=k[o>>2]|0;if(g|0){d=k[g+4>>2]|0;if(!d){d=k[n>>2]|0;if(!d){d=B1()|0;g=k[o>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[o>>2]=0}k[o>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[t>>2]|0)>0){g=k[p>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[t>>2]|0))}d=k[q>>2]|0;if(!((d|0)==(s|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=B;return}function N1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;j=m;l=a+4|0;d=k[l>>2]|0;if(!((d|0)<3?(k[k[a+44>>2]>>2]|0)!=0:0)){d=j+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[j>>2]=f;k[d>>2]=24;i[e+28>>0]=0;g=217821;h=f+24|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,j,217846,216975,899);k[d>>2]=0;k[j>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);d=k[l>>2]|0}if((d|0)>0)h=k[(k[a+44>>2]|0)+(d+-1<<2)>>2]|0;else h=0;g=k[a+20>>2]|0;d=(k[a+16>>2]|0)-g|0;g=(k[a+24>>2]|0)-g|0;if(!d){k[c+4>>2]=0;f=a+44|0;d=0;e=0}else{f=a+44|0;l=k[f>>2]|0;e=(d>>>0)/((k[l>>2]|0)>>>0)|0;k[c+4>>2]=e;d=((d-(aa(k[l>>2]|0,e)|0)|0)>>>0)/(h>>>0)|0}k[c>>2]=d;l=(k[a+12>>2]|0)+d|0;c=g-(aa(l,h)|0)|0;c=((c>>>0)/((k[k[f>>2]>>2]|0)>>>0)|0)+1|0;j=(k[a+8>>2]|0)+e|0;c=(c|0)<(j|0)?j:c;k[b+4>>2]=c;c=((g-(aa(c+-1|0,k[a+48>>2]|0)|0)|0)>>>0)/(h>>>0)|0;k[b>>2]=(c|0)<(l|0)?l:c;r=m;return}function O1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;p=r;r=r+16|0;n=p+8|0;o=p;m=a+4|0;f=k[m>>2]|0;if(!((f|0)<3?(k[k[a+44>>2]>>2]|0)!=0:0)){f=n+4|0;g=ZT(32)|0;k[g>>2]=1;h=g+4|0;k[n>>2]=h;k[f>>2]=24;i[g+28>>0]=0;j=217821;l=h+24|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,n,217856,216975,920);k[f>>2]=0;k[n>>2]=0;l=k[g>>2]|0;k[g>>2]=l+-1;if((l|0)==1)ggb(k[g+-4>>2]|0);f=k[m>>2]|0}k[n>>2]=0;h=n+4|0;k[h>>2]=0;k[o>>2]=0;j=o+4|0;k[j>>2]=0;if((f|0)>0){m=a+44|0;g=m;f=k[(k[m>>2]|0)+(f+-1<<2)>>2]|0}else{g=a+44|0;f=0}N1(a,n,o);q=k[j>>2]|0;m=q-b|0;m=(m|0)<0?0:m;b=a+8|0;l=q+c+(k[b>>2]|0)|0;j=k[h>>2]|0;h=k[o>>2]|0;d=h-d|0;d=(d|0)<0?0:d;o=a+12|0;c=h+e+(k[o>>2]|0)|0;n=k[n>>2]|0;h=(aa(d-h|0,f)|0)+(aa(k[a+48>>2]|0,m-q|0)|0)|0;e=a+16|0;k[e>>2]=(k[e>>2]|0)+h;e=((j|0)<(l|0)?j:l)-m|0;k[b>>2]=e;k[o>>2]=((n|0)<(c|0)?n:c)-d;n=k[a+40>>2]|0;k[n>>2]=e;k[n+4>>2]=k[o>>2];o=aa(k[o>>2]|0,f)|0;if((o|0)!=(k[k[g>>2]>>2]|0)?(k[b>>2]|0)!=1:0){k[a>>2]=k[a>>2]&-16385;r=p;return}k[a>>2]=k[a>>2]|16384;r=p;return}function P1(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+16|0;u=D;C=D+8|0;l=k[a>>2]|0;o=l&2031616;p=d&4095;n=o&2097151;a:do if((n|0)<131072){switch(n|0){case 65536:break;default:break a}if((e|0)>=0?(B=C+4|0,h=ZT(12)|0,k[h>>2]=1,A=h+4|0,k[C>>2]=A,k[B>>2]=5,i[h+9>>0]=0,i[A>>0]=i[217866]|0,i[A+1>>0]=i[217867]|0,i[A+2>>0]=i[217868]|0,i[A+3>>0]=i[217869]|0,i[A+4>>0]=i[217870]|0,Y8(-215,C,389997,216975,2277),k[B>>2]=0,k[C>>2]=0,B=k[h>>2]|0,k[h>>2]=B+-1,(B|0)==1):0)ggb(k[h+-4>>2]|0);q=k[a+4>>2]|0;if(f){if(!(k[q>>2]&16384)){if((k[a>>2]|0)>>>0>1073741823){l=C+4|0;m=ZT(36)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=28;i[m+32>>0]=0;A=218156;B=h+28|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2283);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0)}m=q+36|0;h=k[m>>2]|0;if(h|0?(A=h+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){l=k[m>>2]|0;if(l|0){h=k[l+4>>2]|0;if(!h){h=k[q+32>>2]|0;if(!h){h=B1()|0;l=k[m>>2]|0}}jh[k[(k[h>>2]|0)+24>>2]&1023](h,l)}k[m>>2]=0}k[m>>2]=0;B=q+16|0;l=q+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[l>>2]|0)>0){m=k[q+40>>2]|0;h=0;do{k[m+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[l>>2]|0))}}if((((((b|0)==2?(k[q+4>>2]|0)==2:0)?k[q+16>>2]|0:0)?(k[q>>2]&4095|0)==(p|0):0)?(k[q+8>>2]|0)==(k[c+4>>2]|0):0)?(k[q+12>>2]|0)==(k[c>>2]|0):0){r=D;return}}h=k[a>>2]|0;do if((h|0)<0){l=k[q>>2]|0;if(((l^d)&4088|0)==0?1<<(h&4095)&g|0:0){p=l&4095;break}if((p|0)!=(l&4095|0)){l=C+4|0;m=ZT(36)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=30;i[m+34>>0]=0;A=218185;B=h+30|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2297);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0);h=k[a>>2]|0}}while(0);if(h&1073741824|0){if((k[q+4>>2]|0)!=(b|0)){l=C+4|0;m=ZT(16)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=11;i[m+15>>0]=0;A=218216;B=h+11|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2301);k[l>>2]=0;k[C>>2]=0;a=k[m>>2]|0;k[m>>2]=a+-1;if((a|0)==1)ggb(k[m+-4>>2]|0)}if((b|0)>0){m=q+40|0;n=C+4|0;l=0;do{if((k[(k[m>>2]|0)+(l<<2)>>2]|0)!=(k[c+(l<<2)>>2]|0)){o=ZT(28)|0;k[o>>2]=1;h=o+4|0;k[C>>2]=h;k[n>>2]=21;i[o+25>>0]=0;A=218228;B=h+21|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2303);k[n>>2]=0;k[C>>2]=0;a=k[o>>2]|0;k[o>>2]=a+-1;if((a|0)==1)ggb(k[o+-4>>2]|0)}l=l+1|0}while((l|0)<(b|0))}}G1(q,b,c,p);r=D;return}else{if((n|0)<655360){switch(n|0){case 131072:break;default:break a}if((e|0)>=0){B=C+4|0;h=ZT(12)|0;k[h>>2]=1;A=h+4|0;k[C>>2]=A;k[B>>2]=5;i[h+9>>0]=0;i[A>>0]=i[217866]|0;i[A+1>>0]=i[217867]|0;i[A+2>>0]=i[217868]|0;i[A+3>>0]=i[217869]|0;i[A+4>>0]=i[217870]|0;Y8(-215,C,389997,216975,2345);k[B>>2]=0;k[C>>2]=0;B=k[h>>2]|0;k[h>>2]=B+-1;if((B|0)==1)ggb(k[h+-4>>2]|0);l=k[a>>2]|0}h=l&4095;do if((p|0)!=(h|0)){if((d&4088|0)==0?1<<h&g|0:0)break;l=C+4|0;m=ZT(88)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=81;i[m+85>>0]=0;A=218250;B=h+81|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2347);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0)}while(0);if((b|0)==2){l=k[c>>2]|0;m=a+8|0;h=k[a+12>>2]|0;if((l|0)==(h|0)?(k[c+4>>2]|0)==(k[m>>2]|0):0){r=D;return}if((f?(l|0)==(k[m>>2]|0):0)?(k[c+4>>2]|0)==(h|0):0){r=D;return}}a=C+4|0;h=ZT(136)|0;k[h>>2]=1;B=h+4|0;k[C>>2]=B;k[a>>2]=129;i[h+133>>0]=0;upb(B|0,218332,129)|0;Y8(-215,C,389997,216975,2349);k[a>>2]=0;k[C>>2]=0;C=k[h>>2]|0;k[h>>2]=C+-1;if((C|0)==1)ggb(k[h+-4>>2]|0);r=D;return}switch(n|0){case 655360:break;default:break a}if((e|0)>=0?(B=C+4|0,m=ZT(12)|0,k[m>>2]=1,A=m+4|0,k[C>>2]=A,k[B>>2]=5,i[m+9>>0]=0,i[A>>0]=i[217866]|0,i[A+1>>0]=i[217867]|0,i[A+2>>0]=i[217868]|0,i[A+3>>0]=i[217869]|0,i[A+4>>0]=i[217870]|0,Y8(-215,C,389997,216975,2311),k[B>>2]=0,k[C>>2]=0,B=k[m>>2]|0,k[m>>2]=B+-1,(B|0)==1):0)ggb(k[m+-4>>2]|0);q=k[a+4>>2]|0;if(f){if(!(k[q>>2]&16384)){if((k[a>>2]|0)>>>0>1073741823){l=C+4|0;m=ZT(36)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=28;i[m+32>>0]=0;A=218156;B=h+28|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2317);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0)}n=q+24|0;h=k[n>>2]|0;if(h|0?(A=h+8|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){B=k[n>>2]|0;A=k[B+4>>2]|0;jh[k[(k[A>>2]|0)+16>>2]&1023](A,B);k[n>>2]=0}l=q+4|0;if((k[l>>2]|0)>0){m=k[q+32>>2]|0;h=0;do{k[m+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[l>>2]|0))}k[n>>2]=0}if(((((((b|0)==2?(k[q+4>>2]|0)==2:0)?k[q+24>>2]|0:0)?(s=k[q+8>>2]|0,t=k[q+12>>2]|0,aa(t,s)|0):0)?(k[q>>2]&4095|0)==(p|0):0)?(s|0)==(k[c+4>>2]|0):0)?(t|0)==(k[c>>2]|0):0){r=D;return}}h=k[a>>2]|0;do if((h|0)<0){l=k[q>>2]|0;if(((l^d)&4088|0)==0?1<<(h&4095)&g|0:0){p=l&4095;break}if((p|0)!=(l&4095|0)){l=C+4|0;m=ZT(36)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=30;i[m+34>>0]=0;A=218185;B=h+30|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2331);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0);h=k[a>>2]|0}}while(0);if(h&1073741824|0){if((k[q+4>>2]|0)!=(b|0)){l=C+4|0;m=ZT(16)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=11;i[m+15>>0]=0;A=218216;B=h+11|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2335);k[l>>2]=0;k[C>>2]=0;a=k[m>>2]|0;k[m>>2]=a+-1;if((a|0)==1)ggb(k[m+-4>>2]|0)}if((b|0)>0){m=q+32|0;n=C+4|0;l=0;do{if((k[(k[m>>2]|0)+(l<<2)>>2]|0)!=(k[c+(l<<2)>>2]|0)){o=ZT(28)|0;k[o>>2]=1;h=o+4|0;k[C>>2]=h;k[n>>2]=21;i[o+25>>0]=0;A=218228;B=h+21|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2337);k[n>>2]=0;k[C>>2]=0;a=k[o>>2]|0;k[o>>2]=a+-1;if((a|0)==1)ggb(k[o+-4>>2]|0)}l=l+1|0}while((l|0)<(b|0))}}v9(q,b,c,p);r=D;return}while(0);n=(o|0)==262144;h=o&2097151;b:do if((h|0)<262144){if((h|0)>=196608)switch(h|0){case 196608:break b;default:{q=658;break b}}switch(h|0){case 0:break;default:{q=658;break b}}l=C+4|0;m=ZT(52)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=44;i[m+48>>0]=0;A=218809;B=h+44|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-27,C,389997,216975,2437);k[l>>2]=0;k[C>>2]=0;C=k[m>>2]|0;k[m>>2]=C+-1;if((C|0)==1)ggb(k[m+-4>>2]|0);r=D;return}else{if((h|0)<327680)switch(h|0){case 262144:break b;default:{q=658;break b}}if((h|0)<720896){switch(h|0){case 327680:break;default:{q=658;break b}}v=k[a+4>>2]|0;if((e|0)<0){if((b|0)==2){h=k[c>>2]|0;if((h|0)!=1){B=k[c+4>>2]|0;if(!((B|0)==1|(aa(B,h)|0)==0))q=503}else h=1}else q=503;if((q|0)==503){l=C+4|0;m=ZT(76)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=68;i[m+72>>0]=0;A=218462;B=h+68|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2447);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0);h=k[c>>2]|0;l=k[a>>2]|0}u=k[c+4>>2]|0;n=(aa(u,h)|0)>0;u=n?h+-1+u|0:0;n=((k[v+4>>2]|0)-(k[v>>2]|0)|0)/56|0;if(!((l&1073741824|0)==0|(u|0)==(n|0))){l=C+4|0;m=ZT(32)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=27;i[m+31>>0]=0;A=218854;B=h+27|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2450);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0)}Y1(v,u);h=k[a>>2]|0;if((h|0)>=0){r=D;return}s=h&4095;if(n>>>0>=u>>>0){r=D;return}t=C+4|0;q=n;h=k[v>>2]|0;do{l=k[h+(q*56|0)>>2]|0;if((l&4095|0)!=(s|0)){if(k[h+(q*56|0)+16>>2]|0){o=k[h+(q*56|0)+4>>2]|0;if((o|0)<3)m=aa(k[h+(q*56|0)+12>>2]|0,k[h+(q*56|0)+8>>2]|0)|0;else{p=k[h+(q*56|0)+40>>2]|0;n=0;m=1;do{m=aa(k[p+(n<<2)>>2]|0,m)|0;n=n+1|0}while((n|0)!=(o|0))}if(m){l=ZT(20)|0;k[l>>2]=1;h=l+4|0;k[C>>2]=h;k[t>>2]=12;i[l+16>>0]=0;A=218882;B=h+12|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2459);k[t>>2]=0;k[C>>2]=0;a=k[l>>2]|0;k[l>>2]=a+-1;if((a|0)==1)ggb(k[l+-4>>2]|0);l=k[v>>2]|0;h=l;l=k[l+(q*56|0)>>2]|0}}k[h+(q*56|0)>>2]=l&-4096|s}q=q+1|0}while(q>>>0<u>>>0);r=D;return}h=k[v>>2]|0;if((((k[v+4>>2]|0)-h|0)/56|0|0)>(e|0))n=h;else{l=C+4|0;m=ZT(24)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=17;i[m+21>>0]=0;A=218895;B=h+17|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2466);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0);n=k[v>>2]|0}q=n+(e*56|0)|0;if(f){if(!(k[q>>2]&16384)){if((k[a>>2]|0)>>>0>1073741823){l=C+4|0;m=ZT(36)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=28;i[m+32>>0]=0;A=218156;B=h+28|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2473);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0)}m=n+(e*56|0)+36|0;h=k[m>>2]|0;if(h|0?(A=h+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){l=k[m>>2]|0;if(l|0){h=k[l+4>>2]|0;do if(!h){h=k[n+(e*56|0)+32>>2]|0;if(h|0)break;h=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,l)}k[m>>2]=0}k[m>>2]=0;B=n+(e*56|0)+16|0;l=n+(e*56|0)+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[l>>2]|0)>0){m=k[n+(e*56|0)+40>>2]|0;h=0;do{k[m+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[l>>2]|0))}}if((((((b|0)==2?(k[n+(e*56|0)+4>>2]|0)==2:0)?k[n+(e*56|0)+16>>2]|0:0)?(k[q>>2]&4095|0)==(p|0):0)?(k[n+(e*56|0)+8>>2]|0)==(k[c+4>>2]|0):0)?(k[n+(e*56|0)+12>>2]|0)==(k[c>>2]|0):0){r=D;return}}h=k[a>>2]|0;do if((h|0)<0){l=k[q>>2]|0;if(((l^d)&4088|0)==0?1<<(h&4095)&g|0:0){p=l&4095;break}if((p|0)!=(l&4095|0)){l=C+4|0;m=ZT(36)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=30;i[m+34>>0]=0;A=218185;B=h+30|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2487);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0);h=k[a>>2]|0}}while(0);if(h&1073741824|0){if((k[n+(e*56|0)+4>>2]|0)!=(b|0)){l=C+4|0;m=ZT(16)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=11;i[m+15>>0]=0;A=218216;B=h+11|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2491);k[l>>2]=0;k[C>>2]=0;a=k[m>>2]|0;k[m>>2]=a+-1;if((a|0)==1)ggb(k[m+-4>>2]|0)}if((b|0)>0){m=n+(e*56|0)+40|0;n=C+4|0;l=0;do{if((k[(k[m>>2]|0)+(l<<2)>>2]|0)!=(k[c+(l<<2)>>2]|0)){o=ZT(28)|0;k[o>>2]=1;h=o+4|0;k[C>>2]=h;k[n>>2]=21;i[o+25>>0]=0;A=218228;B=h+21|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2493);k[n>>2]=0;k[C>>2]=0;a=k[o>>2]|0;k[o>>2]=a+-1;if((a|0)==1)ggb(k[o+-4>>2]|0)}l=l+1|0}while((l|0)<(b|0))}}G1(q,b,c,p);r=D;return}switch(h|0){case 720896:break;default:{q=658;break b}}w=k[a+4>>2]|0;if((e|0)<0){if((b|0)==2){h=k[c>>2]|0;if((h|0)!=1){B=k[c+4>>2]|0;if(!((B|0)==1|(aa(B,h)|0)==0))q=578}else h=1}else q=578;if((q|0)==578){l=C+4|0;m=ZT(76)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=68;i[m+72>>0]=0;A=218462;B=h+68|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2506);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0);h=k[c>>2]|0;l=k[a>>2]|0}u=k[c+4>>2]|0;p=(aa(u,h)|0)>0;u=p?h+-1+u|0:0;p=w+4|0;m=k[p>>2]|0;h=k[w>>2]|0;q=(m-h|0)/48|0;if((l&1073741824|0)==0|(u|0)==(q|0))l=m;else{l=C+4|0;m=ZT(32)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=27;i[m+31>>0]=0;A=218854;B=h+27|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2509);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0);h=k[w>>2]|0;l=k[p>>2]|0}m=(l-h|0)/48|0;if(u>>>0<=m>>>0){if(u>>>0<m>>>0?(v=h+(u*48|0)|0,(l|0)!=(v|0)):0)do{k[p>>2]=l+-48;o=l+-24|0;h=k[o>>2]|0;if(h|0?(c=h+8|0,B=k[c>>2]|0,k[c>>2]=B+-1,(B|0)==1):0){B=k[o>>2]|0;c=k[B+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,B);k[o>>2]=0}m=l+-44|0;if((k[m>>2]|0)>0){n=k[l+-16>>2]|0;h=0;do{k[n+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[m>>2]|0))}k[o>>2]=0;h=k[l+-12>>2]|0;if(!((h|0)==(l+-8|0)|(h|0)==0))ggb(k[h+-4>>2]|0);l=k[p>>2]|0}while((l|0)!=(v|0))}else Z1(w,u-m|0);h=k[a>>2]|0;if((h|0)>=0){r=D;return}s=h&4095;if(q>>>0>=u>>>0){r=D;return}t=C+4|0;h=k[w>>2]|0;do{l=k[h+(q*48|0)>>2]|0;if((l&4095|0)!=(s|0)){if(k[h+(q*48|0)+24>>2]|0){o=k[h+(q*48|0)+4>>2]|0;if((o|0)<3)m=aa(k[h+(q*48|0)+12>>2]|0,k[h+(q*48|0)+8>>2]|0)|0;else{p=k[h+(q*48|0)+32>>2]|0;n=0;m=1;do{m=aa(k[p+(n<<2)>>2]|0,m)|0;n=n+1|0}while((n|0)!=(o|0))}if(m){l=ZT(20)|0;k[l>>2]=1;h=l+4|0;k[C>>2]=h;k[t>>2]=12;i[l+16>>0]=0;A=218882;B=h+12|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2518);k[t>>2]=0;k[C>>2]=0;a=k[l>>2]|0;k[l>>2]=a+-1;if((a|0)==1)ggb(k[l+-4>>2]|0);l=k[w>>2]|0;h=l;l=k[l+(q*48|0)>>2]|0}}k[h+(q*48|0)>>2]=l&-4096|s}q=q+1|0}while(q>>>0<u>>>0);r=D;return}h=k[w>>2]|0;if((((k[w+4>>2]|0)-h|0)/48|0|0)>(e|0))o=h;else{l=C+4|0;m=ZT(24)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=17;i[m+21>>0]=0;A=218895;B=h+17|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2525);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0);o=k[w>>2]|0}q=o+(e*48|0)|0;if(f){if(!(k[q>>2]&16384)){if((k[a>>2]|0)>>>0>1073741823){l=C+4|0;m=ZT(36)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=28;i[m+32>>0]=0;A=218156;B=h+28|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2532);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0)}n=o+(e*48|0)+24|0;h=k[n>>2]|0;if(h|0?(A=h+8|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){B=k[n>>2]|0;A=k[B+4>>2]|0;jh[k[(k[A>>2]|0)+16>>2]&1023](A,B);k[n>>2]=0}l=o+(e*48|0)+4|0;if((k[l>>2]|0)>0){m=k[o+(e*48|0)+32>>2]|0;h=0;do{k[m+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[l>>2]|0))}k[n>>2]=0}if((((((b|0)==2?(k[o+(e*48|0)+4>>2]|0)==2:0)?k[o+(e*48|0)+24>>2]|0:0)?(k[q>>2]&4095|0)==(p|0):0)?(k[o+(e*48|0)+8>>2]|0)==(k[c+4>>2]|0):0)?(k[o+(e*48|0)+12>>2]|0)==(k[c>>2]|0):0){r=D;return}}h=k[a>>2]|0;do if((h|0)<0){l=k[q>>2]|0;if(((l^d)&4088|0)==0?1<<(h&4095)&g|0:0){p=l&4095;break}if((p|0)!=(l&4095|0)){l=C+4|0;m=ZT(36)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=30;i[m+34>>0]=0;A=218185;B=h+30|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2546);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0);h=k[a>>2]|0}}while(0);if(h&1073741824|0){if((k[o+(e*48|0)+4>>2]|0)!=(b|0)){l=C+4|0;m=ZT(16)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=11;i[m+15>>0]=0;A=218216;B=h+11|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2550);k[l>>2]=0;k[C>>2]=0;a=k[m>>2]|0;k[m>>2]=a+-1;if((a|0)==1)ggb(k[m+-4>>2]|0)}if((b|0)>0){m=o+(e*48|0)+32|0;n=C+4|0;l=0;do{if((k[(k[m>>2]|0)+(l<<2)>>2]|0)!=(k[c+(l<<2)>>2]|0)){o=ZT(28)|0;k[o>>2]=1;h=o+4|0;k[C>>2]=h;k[n>>2]=21;i[o+25>>0]=0;A=218228;B=h+21|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2552);k[n>>2]=0;k[C>>2]=0;a=k[o>>2]|0;k[o>>2]=a+-1;if((a|0)==1)ggb(k[o+-4>>2]|0)}l=l+1|0}while((l|0)<(b|0))}}v9(q,b,c,p);r=D;return}while(0);if((q|0)==658){l=C+4|0;m=ZT(36)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=30;i[m+34>>0]=0;A=218080;B=h+30|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-213,C,389997,216975,2559);k[l>>2]=0;k[C>>2]=0;C=k[m>>2]|0;k[m>>2]=C+-1;if((C|0)==1)ggb(k[m+-4>>2]|0);r=D;return}if((b|0)==2){h=k[c>>2]|0;if((h|0)!=1){B=k[c+4>>2]|0;if(!((B|0)==1|(aa(B,h)|0)==0))q=118}else h=1}else q=118;if((q|0)==118){l=C+4|0;m=ZT(76)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=68;i[m+72>>0]=0;A=218462;B=h+68|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2355);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0);h=k[c>>2]|0}q=k[c+4>>2]|0;b=(aa(q,h)|0)>0;q=b?h+-1+q|0:0;b=k[a+4>>2]|0;h=(e|0)<0;do if(!n){if(!h){B=C+4|0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[C>>2]=c;k[B>>2]=5;i[h+9>>0]=0;i[c>>0]=i[217866]|0;i[c+1>>0]=i[217867]|0;i[c+2>>0]=i[217868]|0;i[c+3>>0]=i[217869]|0;i[c+4>>0]=i[217870]|0;Y8(-215,C,389997,216975,2372);k[B>>2]=0;k[C>>2]=0;B=k[h>>2]|0;k[h>>2]=B+-1;if((B|0)==1)ggb(k[h+-4>>2]|0)}}else{if(!h){h=k[b>>2]|0;if((((k[b+4>>2]|0)-h|0)/12|0|0)<=(e|0)){l=C+4|0;m=ZT(24)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=18;i[m+22>>0]=0;A=218137;B=h+18|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2368);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0);h=k[b>>2]|0}b=h+(e*12|0)|0;break}e=b+4|0;if((k[a>>2]&1073741824|0)!=0?(q|0)!=(((k[e>>2]|0)-(k[b>>2]|0)|0)/12|0|0):0){l=C+4|0;m=ZT(40)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=32;i[m+36>>0]=0;A=218531;B=h+32|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2364);k[l>>2]=0;k[C>>2]=0;C=k[m>>2]|0;k[m>>2]=C+-1;if((C|0)==1)ggb(k[m+-4>>2]|0);h=b}else h=b;n=k[e>>2]|0;m=k[h>>2]|0;h=(n-m|0)/12|0;l=n;if(q>>>0<=h>>>0){if(q>>>0>=h>>>0){r=D;return}n=m+(q*12|0)|0;if((l|0)==(n|0)){r=D;return}while(1){h=l+-12|0;k[e>>2]=h;m=k[h>>2]|0;if(m){h=l+-8|0;if((k[h>>2]|0)!=(m|0))k[h>>2]=m;ggb(m);h=k[e>>2]|0}if((h|0)==(n|0))break;else l=h}r=D;return}o=q-h|0;w=b+8|0;m=k[w>>2]|0;if(((m-n|0)/12|0)>>>0>=o>>>0){zpb(n|0,0,o*12|0)|0;k[e>>2]=l+(o*12|0);r=D;return}l=k[b>>2]|0;n=(n-l|0)/12|0;h=n+o|0;if(h>>>0>357913941)ad(426534,426557,304,426811);C=(m-l|0)/12|0;m=C<<1;m=C>>>0<178956970?(m>>>0<h>>>0?h:m):357913941;if(!m)h=0;else{if(m>>>0>357913941){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}l=m*12|0;l=(l|0)==0?1:l;while(1){h=fgb(l)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}}n=h+(n*12|0)|0;l=n;f=h+(m*12|0)|0;zpb(n|0,0,o*12|0)|0;v=n+(o*12|0)|0;u=k[b>>2]|0;h=k[e>>2]|0;do if((h|0)!=(u|0)){t=l;while(1){m=n+-12|0;k[m>>2]=0;s=n+-8|0;k[s>>2]=0;k[n+-4>>2]=0;q=h+-8|0;h=h+-12|0;p=(k[q>>2]|0)-(k[h>>2]|0)|0;if(p|0){if((p|0)<0){q=146;break}while(1){l=fgb(p)|0;if(l|0){o=l;break}l=k[207666]|0;k[207666]=l+0;if(!l){o=0;break}Qh[l&7]()}k[s>>2]=o;k[m>>2]=o;k[n+-4>>2]=o+p;m=k[h>>2]|0;l=(k[q>>2]|0)-m|0;if((l|0)>0){upb(o|0,m|0,l|0)|0;k[s>>2]=o+l}}n=t+-12|0;t=n;if((h|0)==(u|0)){q=153;break}}if((q|0)==146)ad(426534,426557,304,426811);else if((q|0)==153){x=t;z=k[b>>2]|0;y=k[e>>2]|0;break}}else{x=l;z=u;y=h}while(0);k[b>>2]=x;k[e>>2]=v;k[w>>2]=f;n=z;h=y;if((h|0)!=(n|0))do{l=h;h=h+-12|0;m=k[h>>2]|0;if(m|0){l=l+-8|0;if((k[l>>2]|0)!=(m|0))k[l>>2]=m;ggb(m)}}while((h|0)!=(n|0));if(!z){r=D;return}ggb(z);r=D;return}while(0);n=k[a>>2]|0;h=n&4095;do if((p|0)==(h|0))h=n;else{if(((n^d)&4088|0)==0?1<<h&g|0:0){h=n;break}l=C+4|0;m=ZT(104)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=96;i[m+100>>0]=0;A=218564;B=h+96|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2375);k[l>>2]=0;k[C>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0);h=k[a>>2]|0}while(0);n=(n>>>3&511)+1<<(47696>>>(n<<1&14)&3);if(h&1073741824|0?(q|0)!=((((k[b+4>>2]|0)-(k[b>>2]|0)|0)>>>0)/(n>>>0)|0|0):0){l=C+4|0;m=ZT(68)|0;k[m>>2]=1;h=m+4|0;k[C>>2]=h;k[l>>2]=61;i[m+65>>0]=0;A=218661;B=h+61|0;do{i[h>>0]=i[A>>0]|0;h=h+1|0;A=A+1|0}while((h|0)<(B|0));Y8(-215,C,389997,216975,2378);k[l>>2]=0;k[C>>2]=0;a=k[m>>2]|0;k[m>>2]=a+-1;if((a|0)==1)ggb(k[m+-4>>2]|0)}do switch(n&8191){case 1:{m=b+4|0;n=k[m>>2]|0;h=k[b>>2]|0;l=n-h|0;if(q>>>0>l>>>0){T1(b,q-l|0);r=D;return}if(q>>>0>=l>>>0){r=D;return}h=h+q|0;if((n|0)==(h|0)){r=D;return}k[m>>2]=h;r=D;return}case 2:{t=b+4|0;h=k[t>>2]|0;n=k[b>>2]|0;p=h-n>>1;l=n;m=h;if(q>>>0<=p>>>0){if(q>>>0>=p>>>0){r=D;return}h=l+(q<<1)|0;if((m|0)==(h|0)){r=D;return}k[t>>2]=m+(~((0-h+(m+-2)|0)>>>1)<<1);r=D;return}l=q-p|0;s=b+8|0;m=k[s>>2]|0;if(m-h>>1>>>0>=l>>>0){do{i[h>>0]=0;i[h+1>>0]=0;h=(k[t>>2]|0)+2|0;k[t>>2]=h;l=l+-1|0}while((l|0)!=0);r=D;return}if((q|0)<0)ad(426534,426557,304,426811);o=m-n|0;o=o>>1>>>0<1073741823?(o>>>0<q>>>0?q:o):2147483647;if(!o)h=0;else{if((o|0)<0){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}m=o<<1;m=(m|0)==0?1:m;while(1){h=fgb(m)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}}m=h+(p<<1)|0;p=m;n=m;q=p;do{i[n>>0]=0;i[n+1>>0]=0;n=q+2|0;q=n;l=l+-1|0}while((l|0)!=0);o=h+(o<<1)|0;h=k[b>>2]|0;l=k[t>>2]|0;if((l|0)==(h|0))l=p;else{n=l;l=p;do{C=n;n=n+-2|0;i[m+-2>>0]=i[n>>0]|0;i[m+-1>>0]=i[C+-1>>0]|0;m=l+-2|0;l=m}while((n|0)!=(h|0));h=k[b>>2]|0}k[b>>2]=l;k[t>>2]=q;k[s>>2]=o;if(!h){r=D;return}ggb(h);r=D;return}case 3:{t=b+4|0;n=k[t>>2]|0;o=k[b>>2]|0;p=(n-o|0)/3|0;l=o;h=n;if(q>>>0<=p>>>0){if(q>>>0>=p>>>0){r=D;return}l=l+(q*3|0)|0;if((h|0)==(l|0)){r=D;return}k[t>>2]=h+(~(((0-l+(h+-3)|0)>>>0)/3|0)*3|0);r=D;return}l=q-p|0;s=b+8|0;m=k[s>>2]|0;if(((m-n|0)/3|0)>>>0>=l>>>0){do{i[h>>0]=0;i[h+1>>0]=0;i[h+2>>0]=0;h=(k[t>>2]|0)+3|0;k[t>>2]=h;l=l+-1|0}while((l|0)!=0);r=D;return}if(q>>>0>1431655765)ad(426534,426557,304,426811);C=(m-o|0)/3|0;o=C<<1;o=C>>>0<715827882?(o>>>0<q>>>0?q:o):1431655765;if(!o)h=0;else{if(o>>>0>1431655765){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}m=o*3|0;m=(m|0)==0?1:m;while(1){h=fgb(m)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}}m=h+(p*3|0)|0;p=m;q=p;n=m;do{i[n>>0]=0;i[n+1>>0]=0;i[n+2>>0]=0;n=q+3|0;q=n;l=l+-1|0}while((l|0)!=0);o=h+(o*3|0)|0;h=k[b>>2]|0;l=k[t>>2]|0;if((l|0)==(h|0))l=p;else{n=l;l=p;do{C=n;n=n+-3|0;i[m+-3>>0]=i[n>>0]|0;i[m+-2>>0]=i[C+-2>>0]|0;i[m+-1>>0]=i[C+-1>>0]|0;m=l+-3|0;l=m}while((n|0)!=(h|0));h=k[b>>2]|0}k[b>>2]=l;k[t>>2]=q;k[s>>2]=o;if(!h){r=D;return}ggb(h);r=D;return}case 4:{m=b+4|0;n=k[m>>2]|0;h=k[b>>2]|0;l=n-h>>2;if(q>>>0>l>>>0){U1(b,q-l|0);r=D;return}if(q>>>0>=l>>>0){r=D;return}h=h+(q<<2)|0;if((n|0)==(h|0)){r=D;return}k[m>>2]=n+(~((n+-4-h|0)>>>2)<<2);r=D;return}case 6:{t=b+4|0;h=k[t>>2]|0;n=k[b>>2]|0;o=(h-n|0)/6|0;l=n;m=h;if(q>>>0<=o>>>0){if(q>>>0>=o>>>0){r=D;return}h=l+(q*6|0)|0;if((m|0)==(h|0)){r=D;return}k[t>>2]=m+(~(((m+-6-h|0)>>>0)/6|0)*6|0);r=D;return}l=q-o|0;s=b+8|0;m=k[s>>2]|0;if(((m-h|0)/6|0)>>>0>=l>>>0){do{j[h>>1]=0;j[h+2>>1]=0;j[h+4>>1]=0;h=(k[t>>2]|0)+6|0;k[t>>2]=h;l=l+-1|0}while((l|0)!=0);r=D;return}if(q>>>0>715827882)ad(426534,426557,304,426811);C=(m-n|0)/6|0;n=C<<1;n=C>>>0<357913941?(n>>>0<q>>>0?q:n):715827882;if(!n)h=0;else{if(n>>>0>715827882){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}m=n*6|0;m=(m|0)==0?1:m;while(1){h=fgb(m)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}}p=h+(o*6|0)|0;o=p;m=p;q=o;do{j[m>>1]=0;j[m+2>>1]=0;j[m+4>>1]=0;m=q+6|0;q=m;l=l+-1|0}while((l|0)!=0);m=h+(n*6|0)|0;n=k[b>>2]|0;l=k[t>>2]|0;if((l|0)==(n|0))h=o;else{h=p;do{C=l;l=l+-6|0;j[h+-6>>1]=j[l>>1]|0;j[h+-4>>1]=j[C+-4>>1]|0;j[h+-2>>1]=j[C+-2>>1]|0;h=h+-6|0}while((l|0)!=(n|0))}k[b>>2]=h;k[t>>2]=q;k[s>>2]=m;if(!n){r=D;return}ggb(n);r=D;return}case 8:{m=b+4|0;n=k[m>>2]|0;h=k[b>>2]|0;l=n-h>>3;if(q>>>0>l>>>0){V1(b,q-l|0);r=D;return}if(q>>>0>=l>>>0){r=D;return}h=h+(q<<3)|0;if((n|0)==(h|0)){r=D;return}k[m>>2]=n+(~((n+-8-h|0)>>>3)<<3);r=D;return}case 12:{m=b+4|0;n=k[m>>2]|0;h=k[b>>2]|0;l=(n-h|0)/12|0;if(q>>>0>l>>>0){W1(b,q-l|0);r=D;return}if(q>>>0>=l>>>0){r=D;return}h=h+(q*12|0)|0;if((n|0)==(h|0)){r=D;return}k[m>>2]=n+(~(((n+-12-h|0)>>>0)/12|0)*12|0);r=D;return}case 16:{m=b+4|0;n=k[m>>2]|0;h=k[b>>2]|0;l=n-h>>4;if(q>>>0>l>>>0){X1(b,q-l|0);r=D;return}if(q>>>0>=l>>>0){r=D;return}h=h+(q<<4)|0;if((n|0)==(h|0)){r=D;return}k[m>>2]=n+(~((n+-16-h|0)>>>4)<<4);r=D;return}case 24:{t=b+4|0;h=k[t>>2]|0;n=k[b>>2]|0;o=(h-n|0)/24|0;l=n;m=h;if(q>>>0<=o>>>0){if(q>>>0>=o>>>0){r=D;return}h=l+(q*24|0)|0;if((m|0)==(h|0)){r=D;return}k[t>>2]=m+(~(((m+-24-h|0)>>>0)/24|0)*24|0);r=D;return}l=q-o|0;s=b+8|0;m=k[s>>2]|0;if(((m-h|0)/24|0)>>>0>=l>>>0){do{k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;h=(k[t>>2]|0)+24|0;k[t>>2]=h;l=l+-1|0}while((l|0)!=0);r=D;return}if(q>>>0>178956970)ad(426534,426557,304,426811);C=(m-n|0)/24|0;n=C<<1;n=C>>>0<89478485?(n>>>0<q>>>0?q:n):178956970;if(!n)h=0;else{if(n>>>0>178956970){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}m=n*24|0;m=(m|0)==0?1:m;while(1){h=fgb(m)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}}p=h+(o*24|0)|0;o=p;m=p;q=o;do{k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[m+16>>2]=0;k[m+20>>2]=0;m=q+24|0;q=m;l=l+-1|0}while((l|0)!=0);m=h+(n*24|0)|0;n=k[b>>2]|0;l=k[t>>2]|0;if((l|0)==(n|0))h=o;else{h=p;do{C=l;l=l+-24|0;k[h+-24>>2]=k[l>>2];k[h+-20>>2]=k[C+-20>>2];k[h+-16>>2]=k[C+-16>>2];k[h+-12>>2]=k[C+-12>>2];k[h+-8>>2]=k[C+-8>>2];k[h+-4>>2]=k[C+-4>>2];h=h+-24|0}while((l|0)!=(n|0))}k[b>>2]=h;k[t>>2]=q;k[s>>2]=m;if(!n){r=D;return}ggb(n);r=D;return}case 32:{u=b+4|0;h=k[u>>2]|0;n=k[b>>2]|0;o=h-n>>5;l=n;m=h;if(q>>>0<=o>>>0){if(q>>>0>=o>>>0){r=D;return}h=l+(q<<5)|0;if((m|0)==(h|0)){r=D;return}k[u>>2]=m+(~((m+-32-h|0)>>>5)<<5);r=D;return}l=q-o|0;t=b+8|0;m=k[t>>2]|0;if(m-h>>5>>>0>=l>>>0){do{k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[h+28>>2]=0;h=(k[u>>2]|0)+32|0;k[u>>2]=h;l=l+-1|0}while((l|0)!=0);r=D;return}if(q>>>0>134217727)ad(426534,426557,304,426811);C=m-n|0;n=C>>4;n=C>>5>>>0<67108863?(n>>>0<q>>>0?q:n):134217727;if(!n)h=0;else{if(n>>>0>134217727){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}m=n<<5;m=(m|0)==0?1:m;while(1){h=fgb(m)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}}s=h+(o<<5)|0;p=s;m=s;q=p;do{k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[m+16>>2]=0;k[m+20>>2]=0;k[m+24>>2]=0;k[m+28>>2]=0;m=q+32|0;q=m;l=l+-1|0}while((l|0)!=0);n=h+(n<<5)|0;o=k[b>>2]|0;h=k[u>>2]|0;if((h|0)==(o|0))h=p;else{m=h+-32|0;l=s;while(1){C=h;h=h+-32|0;k[l+-32>>2]=k[h>>2];k[l+-28>>2]=k[C+-28>>2];k[l+-24>>2]=k[C+-24>>2];k[l+-20>>2]=k[C+-20>>2];k[l+-16>>2]=k[C+-16>>2];k[l+-12>>2]=k[C+-12>>2];k[l+-8>>2]=k[C+-8>>2];k[l+-4>>2]=k[C+-4>>2];if((h|0)==(o|0))break;else l=l+-32|0}h=s+(~((m-o|0)>>>5)<<5)|0}k[b>>2]=h;k[u>>2]=q;k[t>>2]=n;if(!o){r=D;return}ggb(o);r=D;return}case 36:{t=b+4|0;h=k[t>>2]|0;n=k[b>>2]|0;o=(h-n|0)/36|0;l=n;m=h;if(q>>>0<=o>>>0){if(q>>>0>=o>>>0){r=D;return}h=l+(q*36|0)|0;if((m|0)==(h|0)){r=D;return}k[t>>2]=m+(~(((m+-36-h|0)>>>0)/36|0)*36|0);r=D;return}l=q-o|0;s=b+8|0;m=k[s>>2]|0;if(((m-h|0)/36|0)>>>0>=l>>>0){do{B=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(B|0));h=(k[t>>2]|0)+36|0;k[t>>2]=h;l=l+-1|0}while((l|0)!=0);r=D;return}if(q>>>0>119304647)ad(426534,426557,304,426811);C=(m-n|0)/36|0;n=C<<1;n=C>>>0<59652323?(n>>>0<q>>>0?q:n):119304647;if(!n)m=0;else{if(n>>>0>119304647){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}m=n*36|0;m=(m|0)==0?1:m;while(1){h=fgb(m)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}m=h}p=m+(o*36|0)|0;o=p;h=p;q=o;do{B=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(B|0));h=q+36|0;q=h;l=l+-1|0}while((l|0)!=0);m=m+(n*36|0)|0;n=k[b>>2]|0;l=k[t>>2]|0;if((l|0)==(n|0))h=o;else{h=p;do{C=l;l=l+-36|0;k[h+-36>>2]=k[l>>2];k[h+-32>>2]=k[C+-32>>2];k[h+-28>>2]=k[C+-28>>2];k[h+-24>>2]=k[C+-24>>2];k[h+-20>>2]=k[C+-20>>2];k[h+-16>>2]=k[C+-16>>2];k[h+-12>>2]=k[C+-12>>2];k[h+-8>>2]=k[C+-8>>2];k[h+-4>>2]=k[C+-4>>2];h=h+-36|0}while((l|0)!=(n|0))}k[b>>2]=h;k[t>>2]=q;k[s>>2]=m;if(!n){r=D;return}ggb(n);r=D;return}case 48:{t=b+4|0;h=k[t>>2]|0;n=k[b>>2]|0;o=(h-n|0)/48|0;l=n;m=h;if(q>>>0<=o>>>0){if(q>>>0>=o>>>0){r=D;return}h=l+(q*48|0)|0;if((m|0)==(h|0)){r=D;return}k[t>>2]=m+(~(((m+-48-h|0)>>>0)/48|0)*48|0);r=D;return}l=q-o|0;s=b+8|0;m=k[s>>2]|0;if(((m-h|0)/48|0)>>>0>=l>>>0){do{B=h+48|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(B|0));h=(k[t>>2]|0)+48|0;k[t>>2]=h;l=l+-1|0}while((l|0)!=0);r=D;return}if(q>>>0>89478485)ad(426534,426557,304,426811);C=(m-n|0)/48|0;n=C<<1;n=C>>>0<44739242?(n>>>0<q>>>0?q:n):89478485;if(!n)m=0;else{if(n>>>0>89478485){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}m=n*48|0;m=(m|0)==0?1:m;while(1){h=fgb(m)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}m=h}p=m+(o*48|0)|0;o=p;h=p;q=o;do{B=h+48|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(B|0));h=q+48|0;q=h;l=l+-1|0}while((l|0)!=0);m=m+(n*48|0)|0;n=k[b>>2]|0;l=k[t>>2]|0;if((l|0)==(n|0))h=o;else{h=p;do{C=l;l=l+-48|0;k[h+-48>>2]=k[l>>2];k[h+-44>>2]=k[C+-44>>2];k[h+-40>>2]=k[C+-40>>2];k[h+-36>>2]=k[C+-36>>2];k[h+-32>>2]=k[C+-32>>2];k[h+-28>>2]=k[C+-28>>2];k[h+-24>>2]=k[C+-24>>2];k[h+-20>>2]=k[C+-20>>2];k[h+-16>>2]=k[C+-16>>2];k[h+-12>>2]=k[C+-12>>2];k[h+-8>>2]=k[C+-8>>2];k[h+-4>>2]=k[C+-4>>2];h=h+-48|0}while((l|0)!=(n|0))}k[b>>2]=h;k[t>>2]=q;k[s>>2]=m;if(!n){r=D;return}ggb(n);r=D;return}case 64:{u=b+4|0;h=k[u>>2]|0;n=k[b>>2]|0;o=h-n>>6;l=n;m=h;if(q>>>0<=o>>>0){if(q>>>0>=o>>>0){r=D;return}h=l+(q<<6)|0;if((m|0)==(h|0)){r=D;return}k[u>>2]=m+(~((m+-64-h|0)>>>6)<<6);r=D;return}l=q-o|0;t=b+8|0;m=k[t>>2]|0;if(m-h>>6>>>0>=l>>>0){do{B=h+64|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(B|0));h=(k[u>>2]|0)+64|0;k[u>>2]=h;l=l+-1|0}while((l|0)!=0);r=D;return}if(q>>>0>67108863)ad(426534,426557,304,426811);C=m-n|0;n=C>>5;n=C>>6>>>0<33554431?(n>>>0<q>>>0?q:n):67108863;if(!n)m=0;else{if(n>>>0>67108863){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}m=n<<6;m=(m|0)==0?1:m;while(1){h=fgb(m)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}m=h}s=m+(o<<6)|0;p=s;h=s;q=p;do{B=h+64|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(B|0));h=q+64|0;q=h;l=l+-1|0}while((l|0)!=0);n=m+(n<<6)|0;o=k[b>>2]|0;h=k[u>>2]|0;if((h|0)==(o|0))h=p;else{m=h+-64|0;l=s;while(1){C=h;h=h+-64|0;k[l+-64>>2]=k[h>>2];k[l+-60>>2]=k[C+-60>>2];k[l+-56>>2]=k[C+-56>>2];k[l+-52>>2]=k[C+-52>>2];k[l+-48>>2]=k[C+-48>>2];k[l+-44>>2]=k[C+-44>>2];k[l+-40>>2]=k[C+-40>>2];k[l+-36>>2]=k[C+-36>>2];k[l+-32>>2]=k[C+-32>>2];k[l+-28>>2]=k[C+-28>>2];k[l+-24>>2]=k[C+-24>>2];k[l+-20>>2]=k[C+-20>>2];k[l+-16>>2]=k[C+-16>>2];k[l+-12>>2]=k[C+-12>>2];k[l+-8>>2]=k[C+-8>>2];k[l+-4>>2]=k[C+-4>>2];if((h|0)==(o|0))break;else l=l+-64|0}h=s+(~((m-o|0)>>>6)<<6)|0}k[b>>2]=h;k[u>>2]=q;k[t>>2]=n;if(!o){r=D;return}ggb(o);r=D;return}case 128:{u=b+4|0;h=k[u>>2]|0;n=k[b>>2]|0;o=h-n>>7;l=n;m=h;if(q>>>0<=o>>>0){if(q>>>0>=o>>>0){r=D;return}h=l+(q<<7)|0;if((m|0)==(h|0)){r=D;return}k[u>>2]=m+(~((m+-128-h|0)>>>7)<<7);r=D;return}l=q-o|0;t=b+8|0;m=k[t>>2]|0;if(m-h>>7>>>0>=l>>>0){do{B=h+128|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(B|0));h=(k[u>>2]|0)+128|0;k[u>>2]=h;l=l+-1|0}while((l|0)!=0);r=D;return}if(q>>>0>33554431)ad(426534,426557,304,426811);C=m-n|0;p=C>>6;p=C>>7>>>0<16777215?(p>>>0<q>>>0?q:p):33554431;if(!p)m=0;else{if(p>>>0>33554431){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}m=p<<7;m=(m|0)==0?1:m;while(1){h=fgb(m)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}m=h}s=m+(o<<7)|0;n=s;h=s;q=n;do{B=h+128|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(B|0));h=q+128|0;q=h;l=l+-1|0}while((l|0)!=0);o=m+(p<<7)|0;p=k[b>>2]|0;h=k[u>>2]|0;if((h|0)==(p|0))h=n;else{n=h+-128|0;m=s;while(1){l=0;do{k[m+-128+(l<<2)>>2]=k[h+-128+(l<<2)>>2];l=l+1|0}while((l|0)!=32);h=h+-128|0;if((h|0)==(p|0))break;else m=m+-128|0}h=s+(~((n-p|0)>>>7)<<7)|0}k[b>>2]=h;k[u>>2]=q;k[t>>2]=o;if(!p){r=D;return}ggb(p);r=D;return}case 256:{u=b+4|0;h=k[u>>2]|0;n=k[b>>2]|0;p=h-n>>8;l=n;m=h;if(q>>>0<=p>>>0){if(q>>>0>=p>>>0){r=D;return}h=l+(q<<8)|0;if((m|0)==(h|0)){r=D;return}k[u>>2]=m+(~((m+-256-h|0)>>>8)<<8);r=D;return}l=q-p|0;t=b+8|0;m=k[t>>2]|0;if(m-h>>8>>>0>=l>>>0){do{zpb(h|0,0,256)|0;h=(k[u>>2]|0)+256|0;k[u>>2]=h;l=l+-1|0}while((l|0)!=0);r=D;return}if(q>>>0>16777215)ad(426534,426557,304,426811);C=m-n|0;o=C>>7;o=C>>8>>>0<8388607?(o>>>0<q>>>0?q:o):16777215;if(!o)h=0;else{if(o>>>0>16777215){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}m=o<<8;m=(m|0)==0?1:m;while(1){h=fgb(m)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}}s=h+(p<<8)|0;n=s;m=s;q=n;do{zpb(m|0,0,256)|0;m=q+256|0;q=m;l=l+-1|0}while((l|0)!=0);o=h+(o<<8)|0;p=k[b>>2]|0;h=k[u>>2]|0;if((h|0)==(p|0))h=n;else{n=h+-256|0;m=s;while(1){l=0;do{k[m+-256+(l<<2)>>2]=k[h+-256+(l<<2)>>2];l=l+1|0}while((l|0)!=64);h=h+-256|0;if((h|0)==(p|0))break;else m=m+-256|0}h=s+(~((n-p|0)>>>8)<<8)|0}k[b>>2]=h;k[u>>2]=q;k[t>>2]=o;if(!p){r=D;return}ggb(p);r=D;return}case 512:{u=b+4|0;h=k[u>>2]|0;n=k[b>>2]|0;p=h-n>>9;l=n;m=h;if(q>>>0<=p>>>0){if(q>>>0>=p>>>0){r=D;return}h=l+(q<<9)|0;if((m|0)==(h|0)){r=D;return}k[u>>2]=m+(~((m+-512-h|0)>>>9)<<9);r=D;return}l=q-p|0;t=b+8|0;m=k[t>>2]|0;if(m-h>>9>>>0>=l>>>0){do{zpb(h|0,0,512)|0;h=(k[u>>2]|0)+512|0;k[u>>2]=h;l=l+-1|0}while((l|0)!=0);r=D;return}if(q>>>0>8388607)ad(426534,426557,304,426811);C=m-n|0;o=C>>8;o=C>>9>>>0<4194303?(o>>>0<q>>>0?q:o):8388607;if(!o)h=0;else{if(o>>>0>8388607){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}m=o<<9;m=(m|0)==0?1:m;while(1){h=fgb(m)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}}s=h+(p<<9)|0;n=s;m=s;q=n;do{zpb(m|0,0,512)|0;m=q+512|0;q=m;l=l+-1|0}while((l|0)!=0);o=h+(o<<9)|0;p=k[b>>2]|0;h=k[u>>2]|0;if((h|0)==(p|0))h=n;else{n=h+-512|0;m=s;while(1){l=0;do{k[m+-512+(l<<2)>>2]=k[h+-512+(l<<2)>>2];l=l+1|0}while((l|0)!=128);h=h+-512|0;if((h|0)==(p|0))break;else m=m+-512|0}h=s+(~((n-p|0)>>>9)<<9)|0}k[b>>2]=h;k[u>>2]=q;k[t>>2]=o;if(!p){r=D;return}ggb(p);r=D;return}default:{k[u>>2]=n;$8(C,218723,u);Y8(-5,C,389997,216975,2430);h=k[C>>2]|0;k[C+4>>2]=0;k[C>>2]=0;if(h|0?(a=h+-4|0,C=k[a>>2]|0,k[a>>2]=C+-1,(C|0)==1):0)ggb(k[h+-8>>2]|0);r=D;return}}while(0)}function Q1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+144|0;x=y+136|0;w=y;u=y+80|0;q=y+72|0;s=y+64|0;v=y+56|0;n=k[b>>2]|0;t=n&50331648;o=n&2031616;a:do if((o|0)<393216){if((o|0)<196608){if((o|0)<65536){switch(o|0){case 0:break;default:break a}k[a>>2]=1124007936;d=a+8|0;e=a+40|0;q=a+4|0;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[e>>2]=d;x=a+48|0;k[a+44>>2]=x;k[a+52>>2]=0;k[x>>2]=0;r=y;return}if((o|0)<131072){switch(o|0){case 65536:break;default:break a}d=k[b+4>>2]|0;if((c|0)<0){AF(a,d);r=y;return}else{k[x>>2]=c;k[x+4>>2]=c+1;k[w>>2]=-2147483648;k[w+4>>2]=2147483647;H1(a,d,x,w);r=y;return}}switch(o|0){case 131072:break;default:break a}if((c|0)<0)d=n;else{c=x+4|0;d=ZT(12)|0;k[d>>2]=1;w=d+4|0;k[x>>2]=w;k[c>>2]=5;i[d+9>>0]=0;i[w>>0]=i[217866]|0;i[w+1>>0]=i[217867]|0;i[w+2>>0]=i[217868]|0;i[w+3>>0]=i[217869]|0;i[w+4>>0]=i[217870]|0;Y8(-215,x,217872,216975,1157);k[c>>2]=0;k[x>>2]=0;x=k[d>>2]|0;k[d>>2]=x+-1;if((x|0)==1)ggb(k[d+-4>>2]|0);d=k[b>>2]|0}k[q>>2]=k[b+8>>2];k[q+4>>2]=k[b+12>>2];YN(a,q,d,k[b+4>>2]|0,0);r=y;return}if((o|0)<262144){switch(o|0){case 196608:break;default:break a}if((c|0)>=0?(c=x+4|0,f=ZT(12)|0,k[f>>2]=1,w=f+4|0,k[x>>2]=w,k[c>>2]=5,i[f+9>>0]=0,i[w>>0]=i[217866]|0,i[w+1>>0]=i[217867]|0,i[w+2>>0]=i[217868]|0,i[w+3>>0]=i[217869]|0,i[w+4>>0]=i[217870]|0,Y8(-215,x,217872,216975,1163),k[c>>2]=0,k[x>>2]=0,c=k[f>>2]|0,k[f>>2]=c+-1,(c|0)==1):0)ggb(k[f+-4>>2]|0);d=k[b+4>>2]|0;if((k[d>>2]|0)==(k[d+4>>2]|0)){k[a>>2]=1124007936;d=a+8|0;e=a+40|0;q=a+4|0;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[e>>2]=d;x=a+48|0;k[a+44>>2]=x;k[a+52>>2]=0;k[x>>2]=0;r=y;return}p=k[b>>2]|0;R1(s,b,-1);d=k[d>>2]|0;g=p&4095|1124007936;k[a>>2]=g;k[a+4>>2]=2;o=a+8|0;c=k[s+4>>2]|0;k[o>>2]=c;h=a+12|0;f=k[s>>2]|0;k[h>>2]=f;k[a+16>>2]=d;l=a+20|0;k[l>>2]=d;m=a+24|0;n=a+28|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[a+40>>2]=o;e=a+48|0;j=a+44|0;k[j>>2]=e;k[a+52>>2]=0;k[e>>2]=0;if((d|0)==0&(aa(f,c)|0)!=0){d=x+4|0;e=ZT(36)|0;k[e>>2]=1;q=e+4|0;k[x>>2]=q;k[d>>2]=28;i[e+32>>0]=0;g=390609;s=q+28|0;do{i[q>>0]=i[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(s|0));Y8(-215,x,390638,390642,443);k[d>>2]=0;k[x>>2]=0;x=k[e>>2]|0;k[e>>2]=x+-1;if((x|0)==1)ggb(k[e+-4>>2]|0);f=k[h>>2]|0;g=k[a>>2]|0;e=k[j>>2]|0;d=k[l>>2]|0}c=(p>>>3&511)+1<<(47696>>>(p<<1&14)&3);x=aa(f,c)|0;k[a>>2]=g|16384;k[e>>2]=x;k[e+4>>2]=c;a=d+(aa(k[o>>2]|0,x)|0)|0;k[n>>2]=a;k[m>>2]=a+(0-x)+x;r=y;return}if((o|0)>=327680){switch(o|0){case 327680:break;default:break a}f=k[b+4>>2]|0;if(!((c|0)>-1?(d=k[f>>2]|0,(((k[f+4>>2]|0)-d|0)/56|0|0)>(c|0)):0)){d=x+4|0;e=ZT(32)|0;k[e>>2]=1;q=e+4|0;k[x>>2]=q;k[d>>2]=27;i[e+31>>0]=0;g=217909;s=q+27|0;do{i[q>>0]=i[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(s|0));Y8(-215,x,217872,216975,1201);k[d>>2]=0;k[x>>2]=0;x=k[e>>2]|0;k[e>>2]=x+-1;if((x|0)==1)ggb(k[e+-4>>2]|0);d=k[f>>2]|0}AF(a,d+(c*56|0)|0);r=y;return}switch(o|0){case 262144:break;default:break a}p=S1(b,c)|0;f=k[b+4>>2]|0;if(!((c|0)>-1?(e=k[f>>2]|0,(((k[f+4>>2]|0)-e|0)/12|0|0)>(c|0)):0)){d=x+4|0;e=ZT(36)|0;k[e>>2]=1;q=e+4|0;k[x>>2]=q;k[d>>2]=28;i[e+32>>0]=0;g=217880;s=q+28|0;do{i[q>>0]=i[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(s|0));Y8(-215,x,217872,216975,1192);k[d>>2]=0;k[x>>2]=0;w=k[e>>2]|0;k[e>>2]=w+-1;if((w|0)==1)ggb(k[e+-4>>2]|0);e=k[f>>2]|0}d=e+(c*12|0)|0;if((k[d>>2]|0)==(k[e+(c*12|0)+4>>2]|0)){k[a>>2]=1124007936;d=a+8|0;e=a+40|0;q=a+4|0;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[e>>2]=d;x=a+48|0;k[a+44>>2]=x;k[a+52>>2]=0;k[x>>2]=0;r=y;return}R1(v,b,c);d=k[d>>2]|0;g=p&4095|1124007936;k[a>>2]=g;k[a+4>>2]=2;o=a+8|0;c=k[v+4>>2]|0;k[o>>2]=c;h=a+12|0;f=k[v>>2]|0;k[h>>2]=f;k[a+16>>2]=d;l=a+20|0;k[l>>2]=d;m=a+24|0;n=a+28|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[a+40>>2]=o;e=a+48|0;j=a+44|0;k[j>>2]=e;k[a+52>>2]=0;k[e>>2]=0;if((d|0)==0&(aa(f,c)|0)!=0){d=x+4|0;e=ZT(36)|0;k[e>>2]=1;q=e+4|0;k[x>>2]=q;k[d>>2]=28;i[e+32>>0]=0;g=390609;s=q+28|0;do{i[q>>0]=i[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(s|0));Y8(-215,x,390638,390642,443);k[d>>2]=0;k[x>>2]=0;x=k[e>>2]|0;k[e>>2]=x+-1;if((x|0)==1)ggb(k[e+-4>>2]|0);f=k[h>>2]|0;g=k[a>>2]|0;e=k[j>>2]|0;d=k[l>>2]|0}c=(p>>>3&511)+1<<(47696>>>(p<<1&14)&3);x=aa(f,c)|0;k[a>>2]=g|16384;k[e>>2]=x;k[e+4>>2]=c;a=d+(aa(k[o>>2]|0,x)|0)|0;k[n>>2]=a;k[m>>2]=a+(0-x)+x;r=y;return}else{if((o|0)<589824){if((o|0)<458752){switch(o|0){case 393216:break;default:break a}if((c|0)>=0?(c=x+4|0,m=ZT(12)|0,k[m>>2]=1,w=m+4|0,k[x>>2]=w,k[c>>2]=5,i[m+9>>0]=0,i[w>>0]=i[217866]|0,i[w+1>>0]=i[217867]|0,i[w+2>>0]=i[217868]|0,i[w+3>>0]=i[217869]|0,i[w+4>>0]=i[217870]|0,Y8(-215,x,217872,216975,1151),k[c>>2]=0,k[x>>2]=0,x=k[m>>2]|0,k[m>>2]=x+-1,(x|0)==1):0)ggb(k[m+-4>>2]|0);d=k[b+4>>2]|0;k[a>>2]=1124007936;e=a+8|0;f=a+40|0;q=a+4|0;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[f>>2]=e;x=a+48|0;k[a+44>>2]=x;k[a+52>>2]=0;k[x>>2]=0;x=k[d>>2]|0;dh[k[(k[x>>2]|0)+12>>2]&255](x,d,a,-1);r=y;return}if((o|0)>=524288){switch(o|0){case 524288:break;default:break a}if((c|0)>=0?(c=x+4|0,l=ZT(12)|0,k[l>>2]=1,w=l+4|0,k[x>>2]=w,k[c>>2]=5,i[l+9>>0]=0,i[w>>0]=i[217866]|0,i[w+1>>0]=i[217867]|0,i[w+2>>0]=i[217868]|0,i[w+3>>0]=i[217869]|0,i[w+4>>0]=i[217870]|0,Y8(-215,x,217872,216975,1230),k[c>>2]=0,k[x>>2]=0,c=k[l>>2]|0,k[l>>2]=c+-1,(c|0)==1):0)ggb(k[l+-4>>2]|0);c=k[b+4>>2]|0;w=k[c+4>>2]|0;k[x>>2]=k[c+8>>2];k[x+4>>2]=w;YN(a,x,k[c>>2]&4095,k[c+16>>2]|0,k[c+12>>2]|0);r=y;return}switch(o|0){case 458752:break;default:break a}if((c|0)>=0?(c=x+4|0,h=ZT(12)|0,k[h>>2]=1,w=h+4|0,k[x>>2]=w,k[c>>2]=5,i[h+9>>0]=0,i[w>>0]=i[217866]|0,i[w+1>>0]=i[217867]|0,i[w+2>>0]=i[217868]|0,i[w+3>>0]=i[217869]|0,i[w+4>>0]=i[217870]|0,Y8(-215,x,217872,216975,1216),k[c>>2]=0,k[x>>2]=0,c=k[h>>2]|0,k[h>>2]=c+-1,(c|0)==1):0)ggb(k[h+-4>>2]|0);d=x+4|0;e=ZT(80)|0;k[e>>2]=1;q=e+4|0;k[x>>2]=q;k[d>>2]=75;i[e+79>>0]=0;g=217937;s=q+75|0;do{i[q>>0]=i[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(s|0));Y8(-213,x,217872,216975,1217);k[d>>2]=0;k[x>>2]=0;x=k[e>>2]|0;k[e>>2]=x+-1;if((x|0)==1)ggb(k[e+-4>>2]|0);k[a>>2]=1124007936;d=a+8|0;e=a+40|0;q=a+4|0;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[e>>2]=d;x=a+48|0;k[a+44>>2]=x;k[a+52>>2]=0;k[x>>2]=0;r=y;return}if((o|0)<720896){if((o|0)<655360){switch(o|0){case 589824:break;default:break a}if((c|0)>=0?(c=x+4|0,j=ZT(12)|0,k[j>>2]=1,w=j+4|0,k[x>>2]=w,k[c>>2]=5,i[j+9>>0]=0,i[w>>0]=i[217866]|0,i[w+1>>0]=i[217867]|0,i[w+2>>0]=i[217868]|0,i[w+3>>0]=i[217869]|0,i[w+4>>0]=i[217870]|0,Y8(-215,x,217872,216975,1223),k[c>>2]=0,k[x>>2]=0,c=k[j>>2]|0,k[j>>2]=c+-1,(c|0)==1):0)ggb(k[j+-4>>2]|0);d=x+4|0;e=ZT(72)|0;k[e>>2]=1;q=e+4|0;k[x>>2]=q;k[d>>2]=66;i[e+70>>0]=0;g=218013;s=q+66|0;do{i[q>>0]=i[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(s|0));Y8(-213,x,217872,216975,1224);k[d>>2]=0;k[x>>2]=0;x=k[e>>2]|0;k[e>>2]=x+-1;if((x|0)==1)ggb(k[e+-4>>2]|0);k[a>>2]=1124007936;d=a+8|0;e=a+40|0;q=a+4|0;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[e>>2]=d;x=a+48|0;k[a+44>>2]=x;k[a+52>>2]=0;k[x>>2]=0;r=y;return}switch(o|0){case 655360:break;default:break a}d=k[b+4>>2]|0;if((c|0)<0){x9(a,d,t);r=y;return}x9(u,d,t);k[x>>2]=c;k[x+4>>2]=c+1;k[w>>2]=-2147483648;k[w+4>>2]=2147483647;H1(a,u,x,w);f=u+36|0;d=k[f>>2]|0;if(d|0?(x=d+12|0,a=k[x>>2]|0,k[x>>2]=a+-1,(a|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[u+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;a=u+16|0;e=u+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[e>>2]|0)>0){f=k[u+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[u+44>>2]|0;if((d|0)==(u+48|0)|(d|0)==0){r=y;return}ggb(k[d+-4>>2]|0);r=y;return}if((o|0)<786432){switch(o|0){case 720896:break;default:break a}f=k[b+4>>2]|0;if((c|0)>-1?(p=k[f>>2]|0,(((k[f+4>>2]|0)-p|0)/48|0|0)>(c|0)):0)d=p;else{d=x+4|0;e=ZT(32)|0;k[e>>2]=1;q=e+4|0;k[x>>2]=q;k[d>>2]=27;i[e+31>>0]=0;g=217909;s=q+27|0;do{i[q>>0]=i[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(s|0));Y8(-215,x,217872,216975,1209);k[d>>2]=0;k[x>>2]=0;x=k[e>>2]|0;k[e>>2]=x+-1;if((x|0)==1)ggb(k[e+-4>>2]|0);d=k[f>>2]|0}x9(a,d+(c*48|0)|0,t);r=y;return}switch(o|0){case 786432:break;default:break a}if((c|0)>=0?(c=x+4|0,g=ZT(12)|0,k[g>>2]=1,v=g+4|0,k[x>>2]=v,k[c>>2]=5,i[g+9>>0]=0,i[v>>0]=i[217866]|0,i[v+1>>0]=i[217867]|0,i[v+2>>0]=i[217868]|0,i[v+3>>0]=i[217869]|0,i[v+4>>0]=i[217870]|0,Y8(-215,x,217872,216975,1172),k[c>>2]=0,k[x>>2]=0,c=k[g>>2]|0,k[g>>2]=c+-1,(c|0)==1):0)ggb(k[g+-4>>2]|0);f=k[b+4>>2]|0;g=k[f+4>>2]|0;if(!g){k[a>>2]=1124007936;d=a+8|0;e=a+40|0;q=a+4|0;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[e>>2]=d;x=a+48|0;k[a+44>>2]=x;k[a+52>>2]=0;k[x>>2]=0;r=y;return}k[w>>2]=1124007936;t=w+4|0;h=w+8|0;p=w+40|0;q=t;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[p>>2]=h;s=w+48|0;q=w+44|0;k[q>>2]=s;k[w+52>>2]=0;k[s>>2]=0;k[x>>2]=1;k[x+4>>2]=g;G1(w,2,x,0);o=w+16|0;d=k[o>>2]|0;if((g|0)>0){e=0;do{i[d+e>>0]=(k[(k[f>>2]|0)+(e>>>5<<2)>>2]&1<<(e&31)|0)!=0&1;e=e+1|0}while((e|0)!=(g|0));d=k[o>>2]|0}k[a>>2]=k[w>>2];l=a+4|0;f=k[t>>2]|0;k[l>>2]=f;x=a+8|0;k[x>>2]=k[h>>2];k[a+12>>2]=k[w+12>>2];k[a+16>>2]=d;k[a+20>>2]=k[w+20>>2];k[a+24>>2]=k[w+24>>2];k[a+28>>2]=k[w+28>>2];m=w+32|0;k[a+32>>2]=k[m>>2];n=w+36|0;d=k[n>>2]|0;k[a+36>>2]=d;e=a+40|0;k[e>>2]=x;x=a+48|0;j=a+44|0;k[j>>2]=x;k[a+52>>2]=0;k[x>>2]=0;if(!d)d=f;else{d=d+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[t>>2]|0}if((d|0)>=3){k[l>>2]=0;x1(a,d,0,0,0);if((k[l>>2]|0)>0){h=k[p>>2]|0;f=k[e>>2]|0;g=k[q>>2]|0;e=k[j>>2]|0;d=0;do{k[f+(d<<2)>>2]=k[h+(d<<2)>>2];k[e+(d<<2)>>2]=k[g+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else{x=k[q>>2]|0;a=k[j>>2]|0;k[a>>2]=k[x>>2];k[a+4>>2]=k[x+4>>2]}d=k[n>>2]|0;if(d|0?(x=d+12|0,a=k[x>>2]|0,k[x>>2]=a+-1,(a|0)==1):0){e=k[n>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[m>>2]|0;if(!d){d=B1()|0;e=k[n>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[n>>2]=0}k[n>>2]=0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[t>>2]|0)>0){e=k[p>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[t>>2]|0))}d=k[q>>2]|0;if(!((d|0)==(s|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=y;return}while(0);d=x+4|0;e=ZT(36)|0;k[e>>2]=1;q=e+4|0;k[x>>2]=q;k[d>>2]=30;i[e+34>>0]=0;g=218080;s=q+30|0;do{i[q>>0]=i[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(s|0));Y8(-213,x,217872,216975,1237);k[d>>2]=0;k[x>>2]=0;x=k[e>>2]|0;k[e>>2]=x+-1;if((x|0)==1)ggb(k[e+-4>>2]|0);k[a>>2]=1124007936;d=a+8|0;e=a+40|0;q=a+4|0;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[e>>2]=d;x=a+48|0;k[a+44>>2]=x;k[a+52>>2]=0;k[x>>2]=0;r=y;return}function R1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+16|0;p=q;o=k[b>>2]&2031616;a:do if((o|0)<458752){if((o|0)<196608){if((o|0)<65536){switch(o|0){case 0:break;default:break a}k[a>>2]=0;k[a+4>>2]=0;r=q;return}if((o|0)<131072){switch(o|0){case 65536:break;default:break a}if((c|0)>=0?(c=p+4|0,l=ZT(12)|0,k[l>>2]=1,o=l+4|0,k[p>>2]=o,k[c>>2]=5,i[l+9>>0]=0,i[o>>0]=i[217866]|0,i[o+1>>0]=i[217867]|0,i[o+2>>0]=i[217868]|0,i[o+3>>0]=i[217869]|0,i[o+4>>0]=i[217870]|0,Y8(-215,p,380512,216975,1488),k[c>>2]=0,k[p>>2]=0,c=k[l>>2]|0,k[l>>2]=c+-1,(c|0)==1):0)ggb(k[l+-4>>2]|0);p=k[(k[b+4>>2]|0)+40>>2]|0;c=k[p>>2]|0;k[a>>2]=k[p+4>>2];k[a+4>>2]=c;r=q;return}else{switch(o|0){case 131072:break;default:break a}if((c|0)>=0?(c=p+4|0,n=ZT(12)|0,k[n>>2]=1,o=n+4|0,k[p>>2]=o,k[c>>2]=5,i[n+9>>0]=0,i[o>>0]=i[217866]|0,i[o+1>>0]=i[217867]|0,i[o+2>>0]=i[217868]|0,i[o+3>>0]=i[217869]|0,i[o+4>>0]=i[217870]|0,Y8(-215,p,380512,216975,1506),k[c>>2]=0,k[p>>2]=0,c=k[n>>2]|0,k[n>>2]=c+-1,(c|0)==1):0)ggb(k[n+-4>>2]|0);k[a>>2]=k[b+8>>2];k[a+4>>2]=k[b+12>>2];r=q;return}}if((o|0)<327680){if((o|0)<262144){switch(o|0){case 196608:break;default:break a}if((c|0)>=0?(c=p+4|0,d=ZT(12)|0,k[d>>2]=1,o=d+4|0,k[p>>2]=o,k[c>>2]=5,i[d+9>>0]=0,i[o>>0]=i[217866]|0,i[o+1>>0]=i[217867]|0,i[o+2>>0]=i[217868]|0,i[o+3>>0]=i[217869]|0,i[o+4>>0]=i[217870]|0,Y8(-215,p,380512,216975,1512),k[c>>2]=0,k[p>>2]=0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[d+-4>>2]|0);d=k[b+4>>2]|0;d=(k[d+4>>2]|0)-(k[d>>2]|0)|0;if((d|0)==(d>>2|0)){k[a>>2]=d;k[a+4>>2]=1;r=q;return}else{c=k[b>>2]|0;k[a>>2]=(d>>>0)/((c>>>3&511)+1<<(47696>>>(c<<1&14)&3)>>>0)|0;k[a+4>>2]=1;r=q;return}}switch(o|0){case 262144:break;default:break a}f=b+4|0;g=k[f>>2]|0;if((c|0)<0){e=k[g>>2]|0;d=k[g+4>>2]|0;if((e|0)==(d|0)){k[a>>2]=0;k[a+4>>2]=0;r=q;return}else{k[a>>2]=(d-e|0)/12|0;k[a+4>>2]=1;r=q;return}}d=k[g>>2]|0;if((((k[g+4>>2]|0)-d|0)/12|0|0)>(c|0))e=g;else{d=p+4|0;e=ZT(24)|0;k[e>>2]=1;h=e+4|0;k[p>>2]=h;k[d>>2]=18;i[e+22>>0]=0;j=218137;l=h+18|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,p,380512,216975,1534);k[d>>2]=0;k[p>>2]=0;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0);d=k[g>>2]|0;e=k[f>>2]|0}d=(k[d+(c*12|0)+4>>2]|0)-(k[d+(c*12|0)>>2]|0)|0;p=k[e>>2]|0;if((d|0)==((k[p+(c*12|0)+4>>2]|0)-(k[p+(c*12|0)>>2]|0)>>2|0)){k[a>>2]=d;k[a+4>>2]=1;r=q;return}else{c=k[b>>2]|0;k[a>>2]=(d>>>0)/((c>>>3&511)+1<<(47696>>>(c<<1&14)&3)>>>0)|0;k[a+4>>2]=1;r=q;return}}if((o|0)<393216){switch(o|0){case 327680:break;default:break a}f=k[b+4>>2]|0;if((c|0)<0){e=k[f>>2]|0;d=k[f+4>>2]|0;if((e|0)==(d|0)){k[a>>2]=0;k[a+4>>2]=0;r=q;return}else{k[a>>2]=(d-e|0)/56|0;k[a+4>>2]=1;r=q;return}}d=k[f>>2]|0;if((((k[f+4>>2]|0)-d|0)/56|0|0)<=(c|0)){d=p+4|0;e=ZT(24)|0;k[e>>2]=1;h=e+4|0;k[p>>2]=h;k[d>>2]=18;i[e+22>>0]=0;j=218137;l=h+18|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,p,380512,216975,1546);k[d>>2]=0;k[p>>2]=0;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0);d=k[f>>2]|0}p=k[d+(c*56|0)+40>>2]|0;c=k[p>>2]|0;k[a>>2]=k[p+4>>2];k[a+4>>2]=c;r=q;return}switch(o|0){case 393216:break;default:break a}if((c|0)>=0?(c=p+4|0,f=ZT(12)|0,k[f>>2]=1,o=f+4|0,k[p>>2]=o,k[c>>2]=5,i[f+9>>0]=0,i[o>>0]=i[217866]|0,i[o+1>>0]=i[217867]|0,i[o+2>>0]=i[217868]|0,i[o+3>>0]=i[217869]|0,i[o+4>>0]=i[217870]|0,Y8(-215,p,380512,216975,1494),k[c>>2]=0,k[p>>2]=0,c=k[f>>2]|0,k[f>>2]=c+-1,(c|0)==1):0)ggb(k[f+-4>>2]|0);g=k[b+4>>2]|0;d=k[g>>2]|0;if((d|0)==48268|(d|0)==47908){c=k[g+20>>2]|0;k[a>>2]=k[g+16>>2];k[a+4>>2]=c;r=q;return}if((d|0)==48276){c=k[g+16>>2]|0;k[a>>2]=k[g+76>>2];k[a+4>>2]=c;r=q;return}if((d|0)==48032){c=k[g+20>>2]|0;k[a>>2]=k[g+76>>2];k[a+4>>2]=c;r=q;return}if(!(k[107189]|0)){e=b9()|0;mpb(k[e>>2]|0)|0;if(!(k[107189]|0)){while(1){f=fgb(4)|0;if(f|0)break;c=k[207666]|0;k[207666]=c+0;Qh[c&7]()}k[f>>2]=48872;k[107189]=f}lpb(k[e>>2]|0)|0}if((k[107189]|0)==(d|0)){p=k[g+48>>2]|0;c=k[p>>2]|0;k[a>>2]=k[p+4>>2];k[a+4>>2]=c;r=q;return}d=k[g>>2]|0;if(!d){k[a>>2]=0;k[a+4>>2]=0;r=q;return}else{Ph[k[(k[d>>2]|0)+100>>2]&511](a,d,g);r=q;return}}else{if((o|0)<655360){if((o|0)<524288){switch(o|0){case 458752:break;default:break a}if((c|0)>=0?(c=p+4|0,g=ZT(12)|0,k[g>>2]=1,o=g+4|0,k[p>>2]=o,k[c>>2]=5,i[g+9>>0]=0,i[o>>0]=i[217866]|0,i[o+1>>0]=i[217867]|0,i[o+2>>0]=i[217868]|0,i[o+3>>0]=i[217869]|0,i[o+4>>0]=i[217870]|0,Y8(-215,p,380512,216975,1572),k[c>>2]=0,k[p>>2]=0,c=k[g>>2]|0,k[g>>2]=c+-1,(c|0)==1):0)ggb(k[g+-4>>2]|0);p=k[b+4>>2]|0;c=k[p+8>>2]|0;k[a>>2]=k[p+12>>2];k[a+4>>2]=c;r=q;return}if((o|0)<589824){switch(o|0){case 524288:break;default:break a}if((c|0)>=0?(c=p+4|0,j=ZT(12)|0,k[j>>2]=1,o=j+4|0,k[p>>2]=o,k[c>>2]=5,i[j+9>>0]=0,i[o>>0]=i[217866]|0,i[o+1>>0]=i[217867]|0,i[o+2>>0]=i[217868]|0,i[o+3>>0]=i[217869]|0,i[o+4>>0]=i[217870]|0,Y8(-215,p,380512,216975,1586),k[c>>2]=0,k[p>>2]=0,c=k[j>>2]|0,k[j>>2]=c+-1,(c|0)==1):0)ggb(k[j+-4>>2]|0);p=k[b+4>>2]|0;c=k[p+4>>2]|0;k[a>>2]=k[p+8>>2];k[a+4>>2]=c;r=q;return}else{switch(o|0){case 589824:break;default:break a}if((c|0)>=0?(c=p+4|0,h=ZT(12)|0,k[h>>2]=1,o=h+4|0,k[p>>2]=o,k[c>>2]=5,i[h+9>>0]=0,i[o>>0]=i[217866]|0,i[o+1>>0]=i[217867]|0,i[o+2>>0]=i[217868]|0,i[o+3>>0]=i[217869]|0,i[o+4>>0]=i[217870]|0,Y8(-215,p,380512,216975,1579),k[c>>2]=0,k[p>>2]=0,c=k[h>>2]|0,k[h>>2]=c+-1,(c|0)==1):0)ggb(k[h+-4>>2]|0);p=k[b+4>>2]|0;c=k[p+4>>2]|0;k[a>>2]=k[p+8>>2];k[a+4>>2]=c;r=q;return}}if((o|0)<786432){if((o|0)<720896){switch(o|0){case 655360:break;default:break a}if((c|0)>=0?(c=p+4|0,m=ZT(12)|0,k[m>>2]=1,o=m+4|0,k[p>>2]=o,k[c>>2]=5,i[m+9>>0]=0,i[o>>0]=i[217866]|0,i[o+1>>0]=i[217867]|0,i[o+2>>0]=i[217868]|0,i[o+3>>0]=i[217869]|0,i[o+4>>0]=i[217870]|0,Y8(-215,p,380512,216975,1500),k[c>>2]=0,k[p>>2]=0,c=k[m>>2]|0,k[m>>2]=c+-1,(c|0)==1):0)ggb(k[m+-4>>2]|0);p=k[(k[b+4>>2]|0)+32>>2]|0;c=k[p>>2]|0;k[a>>2]=k[p+4>>2];k[a+4>>2]=c;r=q;return}switch(o|0){case 720896:break;default:break a}f=k[b+4>>2]|0;if((c|0)<0){e=k[f>>2]|0;d=k[f+4>>2]|0;if((e|0)==(d|0)){k[a>>2]=0;k[a+4>>2]=0;r=q;return}else{k[a>>2]=(d-e|0)/48|0;k[a+4>>2]=1;r=q;return}}d=k[f>>2]|0;if((((k[f+4>>2]|0)-d|0)/48|0|0)<=(c|0)){d=p+4|0;e=ZT(24)|0;k[e>>2]=1;h=e+4|0;k[p>>2]=h;k[d>>2]=18;i[e+22>>0]=0;j=218137;l=h+18|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,p,380512,216975,1565);k[d>>2]=0;k[p>>2]=0;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0);d=k[f>>2]|0}p=k[d+(c*48|0)+32>>2]|0;c=k[p>>2]|0;k[a>>2]=k[p+4>>2];k[a+4>>2]=c;r=q;return}else{if((o|0)<851968){switch(o|0){case 786432:break;default:break a}if((c|0)>=0?(c=p+4|0,e=ZT(12)|0,k[e>>2]=1,o=e+4|0,k[p>>2]=o,k[c>>2]=5,i[e+9>>0]=0,i[o>>0]=i[217866]|0,i[o+1>>0]=i[217867]|0,i[o+2>>0]=i[217868]|0,i[o+3>>0]=i[217869]|0,i[o+4>>0]=i[217870]|0,Y8(-215,p,380512,216975,1521),k[c>>2]=0,k[p>>2]=0,c=k[e>>2]|0,k[e>>2]=c+-1,(c|0)==1):0)ggb(k[e+-4>>2]|0);k[a>>2]=k[(k[b+4>>2]|0)+4>>2];k[a+4>>2]=1;r=q;return}switch(o|0){case 851968:break;default:break a}f=k[b+4>>2]|0;if((c|0)<0){e=k[f>>2]|0;d=k[f+4>>2]|0;if((e|0)==(d|0)){k[a>>2]=0;k[a+4>>2]=0;r=q;return}else{k[a>>2]=(d-e|0)/36|0;k[a+4>>2]=1;r=q;return}}d=k[f>>2]|0;if((((k[f+4>>2]|0)-d|0)/36|0|0)<=(c|0)){d=p+4|0;e=ZT(24)|0;k[e>>2]=1;h=e+4|0;k[p>>2]=h;k[d>>2]=18;i[e+22>>0]=0;j=218137;l=h+18|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,p,380512,216975,1556);k[d>>2]=0;k[p>>2]=0;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0);d=k[f>>2]|0}p=k[d+(c*36|0)+4>>2]|0;k[a>>2]=k[d+(c*36|0)+8>>2];k[a+4>>2]=p;r=q;return}}while(0);d=p+4|0;e=ZT(36)|0;k[e>>2]=1;h=e+4|0;k[p>>2]=h;k[d>>2]=30;i[e+34>>0]=0;j=218080;l=h+30|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-213,p,380512,216975,1591);k[d>>2]=0;k[p>>2]=0;c=k[e>>2]|0;k[e>>2]=c+-1;if((c|0)==1)ggb(k[e+-4>>2]|0);k[a>>2]=0;k[a+4>>2]=0;r=q;return}function S1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;c=k[a>>2]|0;d=c&2031616;a:do if((d|0)>=458752){if((d|0)<655360){if((d|0)<524288){switch(d|0){case 458752:break;default:break a}j=k[(k[a+4>>2]|0)+16>>2]|0;r=l;return j|0}if((d|0)<589824){switch(d|0){case 524288:break;default:break a}j=k[k[a+4>>2]>>2]&4095;r=l;return j|0}else{switch(d|0){case 589824:break;default:break a}j=k[k[a+4>>2]>>2]&4095;r=l;return j|0}}if((d|0)>=786432){if((d|0)<851968)switch(d|0){case 786432:{e=15;break a}default:break a}switch(d|0){case 851968:break;default:break a}f=k[a+4>>2]|0;d=k[f>>2]|0;e=k[f+4>>2]|0;if((d|0)==(e|0)){if((c|0)>=0){c=j+4|0;d=ZT(32)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=25;i[d+29>>0]=0;g=218111;h=e+25|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-215,j,389384,216975,1863);k[c>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);c=k[a>>2]|0}j=c&4095;r=l;return j|0}else{if(((e-d|0)/36|0|0)>(b|0))c=d;else{c=j+4|0;d=ZT(24)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=18;i[d+22>>0]=0;g=218137;h=e+18|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-215,j,389384,216975,1866);k[c>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);c=k[f>>2]|0}j=k[c+(((b|0)<0?0:b)*36|0)>>2]&4095;r=l;return j|0}}if((d|0)<720896){switch(d|0){case 655360:break;default:break a}j=k[k[a+4>>2]>>2]&4095;r=l;return j|0}switch(d|0){case 720896:break;default:break a}f=k[a+4>>2]|0;d=k[f>>2]|0;e=k[f+4>>2]|0;if((d|0)==(e|0)){if((c|0)>=0){c=j+4|0;d=ZT(32)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=25;i[d+29>>0]=0;g=218111;h=e+25|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-215,j,389384,216975,1839);k[c>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);c=k[a>>2]|0}j=c&4095;r=l;return j|0}else{if(((e-d|0)/48|0|0)>(b|0))c=d;else{c=j+4|0;d=ZT(24)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=18;i[d+22>>0]=0;g=218137;h=e+18|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-215,j,389384,216975,1842);k[c>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);c=k[f>>2]|0}j=k[c+(((b|0)<0?0:b)*48|0)>>2]&4095;r=l;return j|0}}else{if((d|0)<196608){if((d|0)<65536){switch(d|0){case 0:{c=-1;break}default:break a}r=l;return c|0}if((d|0)>=131072)switch(d|0){case 131072:{e=15;break a}default:break a}switch(d|0){case 65536:break;default:break a}j=k[k[a+4>>2]>>2]&4095;r=l;return j|0}if((d|0)<327680)if((d|0)<262144)switch(d|0){case 196608:{e=15;break a}default:break a}else switch(d|0){case 262144:{e=15;break a}default:break a}if((d|0)<393216){switch(d|0){case 327680:break;default:break a}f=k[a+4>>2]|0;d=k[f>>2]|0;e=k[f+4>>2]|0;if((d|0)==(e|0)){if((c|0)>=0){c=j+4|0;d=ZT(32)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=25;i[d+29>>0]=0;g=218111;h=e+25|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-215,j,389384,216975,1851);k[c>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);c=k[a>>2]|0}j=c&4095;r=l;return j|0}else{if(((e-d|0)/56|0|0)>(b|0))c=d;else{c=j+4|0;d=ZT(24)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=18;i[d+22>>0]=0;g=218137;h=e+18|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-215,j,389384,216975,1854);k[c>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);c=k[f>>2]|0}j=k[c+(((b|0)<0?0:b)*56|0)>>2]&4095;r=l;return j|0}}switch(d|0){case 393216:break;default:break a}f=k[a+4>>2]|0;c=k[f>>2]|0;if(!(k[107189]|0)){d=b9()|0;mpb(k[d>>2]|0)|0;if(!(k[107189]|0)){while(1){e=fgb(4)|0;if(e|0)break;j=k[207666]|0;k[207666]=j+0;Qh[j&7]()}k[e>>2]=48872;k[107189]=e}lpb(k[d>>2]|0)|0}if((k[107189]|0)==(c|0)){j=k[f+8>>2]&4095;r=l;return j|0}c=k[f>>2]|0;if((c|0)==48980){j=0;r=l;return j|0}if(!c){j=-1;r=l;return j|0}j=Hh[k[(k[c>>2]|0)+104>>2]&511](c,f)|0;r=l;return j|0}while(0);if((e|0)==15){j=c&4095;r=l;return j|0}c=j+4|0;d=ZT(36)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=30;i[d+34>>0]=0;g=218080;h=e+30|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-213,j,389384,216975,1879);k[c>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);j=0;r=l;return j|0}function T1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;j=a+8|0;e=k[j>>2]|0;l=a+4|0;c=k[l>>2]|0;if((e-c|0)>>>0>=b>>>0){do{i[c>>0]=0;c=(k[l>>2]|0)+1|0;k[l>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=c-d|0;c=f+b|0;if((c|0)<0)ad(426534,426557,304,426811);g=e-d|0;h=g<<1;h=g>>>0<1073741823?(h>>>0<c>>>0?c:h):2147483647;a:do if(!h)c=0;else while(1){c=fgb(h)|0;if(c|0)break a;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break a}Qh[c&7]()}while(0);g=c+f|0;f=g;d=g;do{i[d>>0]=0;d=f+1|0;f=d;b=b+-1|0}while((b|0)!=0);d=k[a>>2]|0;e=(k[l>>2]|0)-d|0;b=g+(0-e)|0;if((e|0)>0)upb(b|0,d|0,e|0)|0;k[a>>2]=b;k[l>>2]=f;k[j>>2]=c+h;if(!d)return;ggb(d);return}function U1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+8|0;d=k[j>>2]|0;l=a+4|0;c=k[l>>2]|0;if(d-c>>2>>>0>=b>>>0){zpb(c|0,0,b<<2|0)|0;k[l>>2]=c+(b<<2);return}i=k[a>>2]|0;h=c-i|0;g=h>>2;c=g+b|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);e=d-i|0;f=e>>1;f=e>>2>>>0<536870911?(f>>>0<c>>>0?c:f):1073741823;if(!f)c=0;else{if(f>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<2)|0;zpb(e|0,0,b<<2|0)|0;d=e+(0-g<<2)|0;if((h|0)>0)upb(d|0,i|0,h|0)|0;k[a>>2]=d;k[l>>2]=e+(b<<2);k[j>>2]=c+(f<<2);if(!i)return;ggb(i);return}function V1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+8|0;e=k[j>>2]|0;l=a+4|0;c=k[l>>2]|0;if(e-c>>3>>>0>=b>>>0){do{j=c;k[j>>2]=0;k[j+4>>2]=0;c=(k[l>>2]|0)+8|0;k[l>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=c-d>>3;c=f+b|0;if(c>>>0>536870911)ad(426534,426557,304,426811);i=e-d|0;e=i>>2;e=i>>3>>>0<268435455?(e>>>0<c>>>0?c:e):536870911;if(!e)c=0;else{if(e>>>0>536870911){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}i=c+(f<<3)|0;g=i;d=i;h=g;do{f=d;k[f>>2]=0;k[f+4>>2]=0;d=h+8|0;h=d;b=b+-1|0}while((b|0)!=0);e=c+(e<<3)|0;f=k[a>>2]|0;c=k[l>>2]|0;if((c|0)==(f|0))c=g;else{d=c+-8|0;b=i;while(1){g=c;c=c+-8|0;k[b+-8>>2]=k[c>>2];k[b+-4>>2]=k[g+-4>>2];if((c|0)==(f|0))break;else b=b+-8|0}c=i+(~((d-f|0)>>>3)<<3)|0}k[a>>2]=c;k[l>>2]=h;k[j>>2]=e;if(!f)return;ggb(f);return}function W1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+8|0;e=k[i>>2]|0;j=a+4|0;c=k[j>>2]|0;if(((e-c|0)/12|0)>>>0>=b>>>0){do{k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;c=(k[j>>2]|0)+12|0;k[j>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=(c-d|0)/12|0;c=f+b|0;if(c>>>0>357913941)ad(426534,426557,304,426811);h=(e-d|0)/12|0;e=h<<1;e=h>>>0<178956970?(e>>>0<c>>>0?c:e):357913941;if(!e)c=0;else{if(e>>>0>357913941){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=e*12|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}g=c+(f*12|0)|0;f=g;d=g;h=f;do{k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;d=h+12|0;h=d;b=b+-1|0}while((b|0)!=0);d=c+(e*12|0)|0;e=k[a>>2]|0;b=k[j>>2]|0;if((b|0)==(e|0))c=f;else{c=g;do{g=b;b=b+-12|0;k[c+-12>>2]=k[b>>2];k[c+-8>>2]=k[g+-8>>2];k[c+-4>>2]=k[g+-4>>2];c=c+-12|0}while((b|0)!=(e|0))}k[a>>2]=c;k[j>>2]=h;k[i>>2]=d;if(!e)return;ggb(e);return}function X1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+8|0;e=k[j>>2]|0;l=a+4|0;c=k[l>>2]|0;if(e-c>>4>>>0>=b>>>0){do{k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;c=(k[l>>2]|0)+16|0;k[l>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=c-d>>4;c=f+b|0;if(c>>>0>268435455)ad(426534,426557,304,426811);i=e-d|0;e=i>>3;e=i>>4>>>0<134217727?(e>>>0<c>>>0?c:e):268435455;if(!e)c=0;else{if(e>>>0>268435455){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=e<<4;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}i=c+(f<<4)|0;g=i;d=i;h=g;do{k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;d=h+16|0;h=d;b=b+-1|0}while((b|0)!=0);e=c+(e<<4)|0;f=k[a>>2]|0;c=k[l>>2]|0;if((c|0)==(f|0))c=g;else{d=c+-16|0;b=i;while(1){g=c;c=c+-16|0;k[b+-16>>2]=k[c>>2];k[b+-12>>2]=k[g+-12>>2];k[b+-8>>2]=k[g+-8>>2];k[b+-4>>2]=k[g+-4>>2];if((c|0)==(f|0))break;else b=b+-16|0}c=i+(~((d-f|0)>>>4)<<4)|0}k[a>>2]=c;k[l>>2]=h;k[j>>2]=e;if(!f)return;ggb(f);return}function Y1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=a+4|0;e=k[n>>2]|0;g=k[a>>2]|0;h=(e-g|0)/56|0;d=g;c=e;if(h>>>0>=b>>>0){if(h>>>0<=b>>>0)return;g=d+(b*56|0)|0;if((c|0)==(g|0))return;else f=c;do{k[n>>2]=f+-56;e=f+-20|0;c=k[e>>2]|0;if(c|0?(m=c+12|0,a=k[m>>2]|0,k[m>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[f+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;a=f+-40|0;d=f+-52|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[d>>2]|0)>0){e=k[f+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[f+-12>>2]|0;if(!((c|0)==(f+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=k[n>>2]|0}while((f|0)!=(g|0));return}f=b-h|0;m=a+8|0;d=k[m>>2]|0;if(((d-e|0)/56|0)>>>0>=f>>>0){do{k[c>>2]=1124007936;d=c+8|0;e=c+40|0;j=c+4|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;a=c+48|0;k[c+44>>2]=a;k[c+52>>2]=0;k[a>>2]=0;c=(k[n>>2]|0)+56|0;k[n>>2]=c;f=f+-1|0}while((f|0)!=0);return}if(b>>>0>76695844)ad(426534,426557,304,426811);l=(d-g|0)/56|0;e=l<<1;e=l>>>0<38347922?(e>>>0<b>>>0?b:e):76695844;if(!e)c=0;else{if(e>>>0>76695844){n=te(4)|0;k[n>>2]=172664;Cf(n|0,28816,1287)}d=e*56|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}d=c+(h*56|0)|0;i=c+(e*56|0)|0;e=d;while(1){k[e>>2]=1124007936;g=e+8|0;h=e+40|0;j=e+4|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[h>>2]=g;l=e+48|0;k[e+44>>2]=l;k[e+52>>2]=0;k[l>>2]=0;f=f+-1|0;if(!f)break;else e=e+56|0}f=c+(b*56|0)|0;c=k[a>>2]|0;e=k[n>>2]|0;if((e|0)==(c|0)){j=c;c=j}else{do{e=e+-56|0;AF(d+-56|0,e);d=d+-56|0}while((e|0)!=(c|0));c=k[n>>2]|0;j=k[a>>2]|0}k[a>>2]=d;k[n>>2]=f;k[m>>2]=i;h=j;while(1){if((h|0)==(c|0))break;g=c+-56|0;f=c+-20|0;d=k[f>>2]|0;if(d|0?(a=d+12|0,n=k[a>>2]|0,k[a>>2]=n+-1,(n|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[c+-24>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;d=c+-40|0;e=c+-52|0;f=c+-16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;d=0;while(1){if((d|0)>=(k[e>>2]|0))break;k[(k[f>>2]|0)+(d<<2)>>2]=0;d=d+1|0}d=k[c+-12>>2]|0;if((d|0)==(c+-8|0)|(d|0)==0){c=g;continue}ggb(k[d+-4>>2]|0);c=g}if(!j)return;ggb(j);return}function Z1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;q=a+8|0;e=k[q>>2]|0;r=a+4|0;c=k[r>>2]|0;if(((e-c|0)/48|0)>>>0>=b>>>0){do{k[c>>2]=1124007936;q=c+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;k[q+16>>2]=0;k[q+20>>2]=0;k[q+24>>2]=0;k[c+32>>2]=c+8;q=c+40|0;k[c+36>>2]=q;k[c+44>>2]=0;k[q>>2]=0;c=(k[r>>2]|0)+48|0;k[r>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=(c-d|0)/48|0;c=f+b|0;if(c>>>0>89478485)ad(426534,426557,304,426811);p=(e-d|0)/48|0;g=p<<1;g=p>>>0<44739242?(g>>>0<c>>>0?c:g):89478485;if(!g)c=0;else{if(g>>>0>89478485){r=te(4)|0;k[r>>2]=172664;Cf(r|0,28816,1287)}d=g*48|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}f=c+(f*48|0)|0;e=f;p=e;d=f;do{k[d>>2]=1124007936;o=d+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;k[o+16>>2]=0;k[o+20>>2]=0;k[o+24>>2]=0;k[d+32>>2]=d+8;o=d+40|0;k[d+36>>2]=o;k[d+44>>2]=0;k[o>>2]=0;d=p+48|0;p=d;b=b+-1|0}while((b|0)!=0);o=c+(g*48|0)|0;n=k[a>>2]|0;c=k[r>>2]|0;if((c|0)==(n|0)){c=n;b=e;i=c}else{b=e;do{d=f+-48|0;j=c;c=c+-48|0;k[d>>2]=k[c>>2];m=f+-44|0;e=j+-44|0;k[m>>2]=k[e>>2];h=f+-40|0;k[h>>2]=k[j+-40>>2];k[f+-36>>2]=k[j+-36>>2];k[f+-32>>2]=k[j+-32>>2];k[f+-28>>2]=k[j+-28>>2];g=k[j+-24>>2]|0;k[f+-24>>2]=g;k[f+-20>>2]=k[j+-20>>2];i=f+-16|0;k[i>>2]=h;h=f+-8|0;l=f+-12|0;k[l>>2]=h;k[f+-4>>2]=0;k[h>>2]=0;if(g|0){h=g+8|0;k[h>>2]=(k[h>>2]|0)+1}if((k[e>>2]|0)>=3){k[m>>2]=0;s9(d,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){h=k[j+-16>>2]|0;g=k[i>>2]|0;f=k[j+-12>>2]|0;e=k[l>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[h+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else{j=k[j+-12>>2]|0;m=k[l>>2]|0;k[m>>2]=k[j>>2];k[m+4>>2]=k[j+4>>2]}f=b+-48|0;b=f}while((c|0)!=(n|0));i=k[a>>2]|0;c=k[r>>2]|0}k[a>>2]=b;k[r>>2]=p;k[q>>2]=o;h=i;while(1){if((c|0)==(h|0))break;g=c+-48|0;f=c+-24|0;b=k[f>>2]|0;if(b|0?(q=b+8|0,r=k[q>>2]|0,k[q>>2]=r+-1,(r|0)==1):0){r=k[f>>2]|0;q=k[r+4>>2]|0;jh[k[(k[q>>2]|0)+16>>2]&1023](q,r);k[f>>2]=0}d=c+-44|0;if((k[d>>2]|0)>0){e=k[c+-16>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}k[f>>2]=0;b=k[c+-12>>2]|0;if((b|0)==(c+-8|0)|(b|0)==0){c=g;continue}ggb(k[b+-4>>2]|0);c=g}if(!i)return;ggb(i);return}function _1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+16|0;o=p;h=((k[b>>2]|0)>>>3&511)+1|0;AF(a,b);g=b+4|0;e=k[g>>2]|0;j=(d|0)==0;if((c|0)!=0&(j&(e|0)>2)?(f=e+-1|0,((aa(k[(k[b+40>>2]|0)+(f<<2)>>2]|0,h)|0)%(c|0)|0|0)==0):0){o=k[a>>2]|0;b=(c<<3)+-8|0;k[a>>2]=o&-4089|b;k[(k[a+44>>2]|0)+(f<<2)>>2]=(b>>>3&511)+1<<(47696>>>(o<<1&14)&3);o=(k[a+40>>2]|0)+((k[g>>2]|0)+-1<<2)|0;a=(aa(k[o>>2]|0,h)|0)/(c|0)|0;k[o>>2]=a;r=p;return}if((e|0)>=3){k[o>>2]=0;e=o+4|0;k[e>>2]=0;f=ZT(16)|0;k[f>>2]=1;l=f+4|0;k[o>>2]=l;k[e>>2]=9;i[f+13>>0]=0;m=217574;n=l+9|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,o,218913,216975,982);k[e>>2]=0;k[o>>2]=0;n=k[f>>2]|0;k[f>>2]=n+-1;if((n|0)==1)ggb(k[f+-4>>2]|0)}c=(c|0)==0?h:c;e=aa(k[b+12>>2]|0,h)|0;if((c|0)>(e|0))if(j)f=11;else f=13;else if(j&((e|0)%(c|0)|0|0)!=0)f=11;else f=12;if((f|0)==11){d=(aa(k[b+8>>2]|0,e)|0)/(c|0)|0;f=12}if((f|0)==12)if(d)f=13;if((f|0)==13){f=k[b+8>>2]|0;if((d|0)!=(f|0)){g=aa(f,e)|0;if(!(k[b>>2]&16384)){k[o>>2]=0;e=o+4|0;k[e>>2]=0;f=ZT(80)|0;k[f>>2]=1;l=f+4|0;k[o>>2]=l;k[e>>2]=72;i[f+76>>0]=0;m=235199;n=l+72|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-13,o,218913,216975,997);k[e>>2]=0;k[o>>2]=0;n=k[f>>2]|0;k[f>>2]=n+-1;if((n|0)==1)ggb(k[f+-4>>2]|0)}if(d>>>0>g>>>0){k[o>>2]=0;e=o+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;l=f+4|0;k[o>>2]=l;k[e>>2]=22;i[f+26>>0]=0;m=235272;n=l+22|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-211,o,218913,216975,1e3);k[e>>2]=0;k[o>>2]=0;n=k[f>>2]|0;k[f>>2]=n+-1;if((n|0)==1)ggb(k[f+-4>>2]|0)}e=(g|0)/(d|0)|0;if((aa(e,d)|0)!=(g|0)){k[o>>2]=0;f=o+4|0;k[f>>2]=0;g=ZT(84)|0;k[g>>2]=1;l=g+4|0;k[o>>2]=l;k[f>>2]=78;i[g+82>>0]=0;m=235110;n=l+78|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-5,o,218913,216975,1006);k[f>>2]=0;k[o>>2]=0;n=k[g>>2]|0;k[g>>2]=n+-1;if((n|0)==1)ggb(k[g+-4>>2]|0)}k[a+8>>2]=d;b=aa(1212424721>>>(k[b>>2]<<2&28)&15,e)|0;k[k[a+44>>2]>>2]=b}}f=(e|0)/(c|0)|0;if((aa(f,c)|0)!=(e|0)){k[o>>2]=0;e=o+4|0;k[e>>2]=0;d=ZT(68)|0;k[d>>2]=1;l=d+4|0;k[o>>2]=l;k[e>>2]=62;i[d+66>>0]=0;m=235295;n=l+62|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-15,o,218913,216975,1016);k[e>>2]=0;k[o>>2]=0;o=k[d>>2]|0;k[d>>2]=o+-1;if((o|0)==1)ggb(k[d+-4>>2]|0)}k[a+12>>2]=f;o=k[a>>2]|0;b=(c<<3)+-8|0;k[a>>2]=o&-4089|b;k[(k[a+44>>2]|0)+4>>2]=(b>>>3&511)+1<<(47696>>>(o<<1&14)&3);r=p;return}function $1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+144|0;t=u+80|0;p=u+24|0;o=u;m=u+16|0;l=S1(a,-1)|0;l=(l>>>3&511)+1<<(47696>>>(l<<1&14)&3);if(!((a2(a)|0)<3&(l|0)<33)){d=t+4|0;e=ZT(36)|0;k[e>>2]=1;g=e+4|0;k[t>>2]=g;k[d>>2]=29;i[e+33>>0]=0;h=218948;j=g+29|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,t,218978,216975,3233);k[d>>2]=0;k[t>>2]=0;s=k[e>>2]|0;k[e>>2]=s+-1;if((s|0)==1)ggb(k[e+-4>>2]|0)}if((k[a>>2]&2031616|0)==65536)AF(t,k[a+4>>2]|0);else Q1(t,a,-1);s=t+16|0;if(k[s>>2]|0){e=k[t+4>>2]|0;if((e|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{f=k[t+40>>2]|0;d=0;a=1;do{a=aa(k[f+(d<<2)>>2]|0,a)|0;d=d+1|0}while((d|0)!=(e|0))}if(a){d=t+12|0;a=t+8|0;c2(b,k[d>>2]|0,k[a>>2]|0,k[t>>2]&4095,-1,0,0);if((k[b>>2]&2031616|0)==65536)AF(p,k[b+4>>2]|0);else Q1(p,b,-1);e=k[a>>2]|0;f=p+12|0;do if((e|0)==(k[f>>2]|0)?(c=k[d>>2]|0,n=p+8|0,(c|0)==(k[n>>2]|0)):0){b=p+16|0;d=k[b>>2]|0;a=k[s>>2]|0;if((d|0)!=(a|0)){e=k[49200+(l<<2)>>2]|0;if(!e){k[o>>2]=0;c=o+4|0;k[c>>2]=0;a=ZT(16)|0;k[a>>2]=1;g=a+4|0;k[o>>2]=g;k[c>>2]=9;i[a+13>>0]=0;h=335726;j=g+9|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,o,218978,216975,3268);k[c>>2]=0;k[o>>2]=0;o=k[a>>2]|0;k[a>>2]=o+-1;if((o|0)==1)ggb(k[a+-4>>2]|0);a=k[s>>2]|0;c=k[b>>2]|0}else c=d;n=k[t+48>>2]|0;o=k[p+48>>2]|0;j=k[t+40>>2]|0;l=k[j>>2]|0;k[m>>2]=k[j+4>>2];k[m+4>>2]=l;eh[e&255](a,n,c,o,m);break}d=k[49068+(l<<2)>>2]|0;if(!d){k[o>>2]=0;c=o+4|0;k[c>>2]=0;a=ZT(16)|0;k[a>>2]=1;g=a+4|0;k[o>>2]=g;k[c>>2]=9;i[a+13>>0]=0;h=335726;j=g+9|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,o,218978,216975,3261);k[c>>2]=0;k[o>>2]=0;m=k[a>>2]|0;k[a>>2]=m+-1;if((m|0)==1)ggb(k[a+-4>>2]|0);a=k[f>>2]|0;c=k[n>>2]|0}else a=e;if((a|0)!=(c|0)){k[o>>2]=0;c=o+4|0;k[c>>2]=0;a=ZT(28)|0;k[a>>2]=1;g=a+4|0;k[o>>2]=g;k[c>>2]=20;i[a+24>>0]=0;h=403189;j=g+20|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,o,218978,216975,3262);k[c>>2]=0;k[o>>2]=0;o=k[a>>2]|0;k[a>>2]=o+-1;if((o|0)==1)ggb(k[a+-4>>2]|0);c=k[n>>2]|0}Ph[d&511](k[b>>2]|0,k[p+48>>2]|0,c)}else q=20;while(0);if((q|0)==20){n=k[t+40>>2]|0;m=k[p+40>>2]|0;if(!(((k[m>>2]|0)==(k[n>>2]|0)?(k[m+4>>2]|0)==(k[n+4>>2]|0):0)?(k[d>>2]|0)==1|(e|0)==1:0)){k[o>>2]=0;c=o+4|0;k[c>>2]=0;a=ZT(68)|0;k[a>>2]=1;g=a+4|0;k[o>>2]=g;k[c>>2]=60;i[a+64>>0]=0;h=218988;j=g+60|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,o,218978,216975,3251);k[c>>2]=0;k[o>>2]=0;n=k[a>>2]|0;k[a>>2]=n+-1;if((n|0)==1)ggb(k[a+-4>>2]|0)}n=o+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[o>>2]=33619968;k[n>>2]=p;mY(t,o)}d=p+36|0;c=k[d>>2]|0;if(c|0?(n=c+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[p+32>>2]|0;if(!c){c=B1()|0;a=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;o=p+16|0;a=p+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[a>>2]|0)>0){d=k[p+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[a>>2]|0))}c=k[p+44>>2]|0;if(!((c|0)==(p+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}else q=14}else q=14;if((q|0)==14)b2(b);d=t+36|0;c=k[d>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[t+32>>2]|0;if(!c){c=B1()|0;a=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;d=t+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[d>>2]|0)>0){a=k[t+40>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[t+44>>2]|0;if((c|0)==(t+48|0)|(c|0)==0){r=u;return}ggb(k[c+-4>>2]|0);r=u;return}function a2(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;g=r;r=r+16|0;f=g;b=k[a>>2]&2031616;a:do if((b|0)<393216)if((b|0)<196608){if((b|0)<65536)switch(b|0){case 0:{a=0;break a}default:{c=13;break a}}if((b|0)<131072){switch(b|0){case 65536:break;default:{c=13;break a}}a=k[(k[a+4>>2]|0)+4>>2]|0;break}else{switch(b|0){case 131072:break;default:{c=13;break a}}a=2;break}}else{if((b|0)<262144)switch(b|0){case 196608:{c=6;break a}default:{c=13;break a}}if((b|0)<327680){switch(b|0){case 262144:break;default:{c=13;break a}}a=1;break}else{switch(b|0){case 327680:break;default:{c=13;break a}}a=1;break}}else{if((b|0)<589824){if((b|0)<458752){switch(b|0){case 393216:break;default:{c=13;break a}}a=k[(k[a+4>>2]|0)+12>>2]|0;break}if((b|0)<524288){switch(b|0){case 458752:break;default:{c=13;break a}}a=2;break}else{switch(b|0){case 524288:break;default:{c=13;break a}}a=2;break}}if((b|0)>=720896){if((b|0)>=786432)switch(b|0){case 786432:{c=6;break a}default:{c=13;break a}}switch(b|0){case 720896:break;default:{c=13;break a}}a=1;break}if((b|0)<655360){switch(b|0){case 589824:break;default:{c=13;break a}}a=2;break}else{switch(b|0){case 655360:break;default:{c=13;break a}}a=k[(k[a+4>>2]|0)+4>>2]|0;break}}while(0);if((c|0)==6)a=2;else if((c|0)==13){a=f+4|0;b=ZT(36)|0;k[b>>2]=1;c=b+4|0;k[f>>2]=c;k[a>>2]=30;i[b+34>>0]=0;d=218080;e=c+30|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-213,f,219920,216975,1771);k[a>>2]=0;k[f>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0);a=0}r=g;return a|0}function b2(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;h=j+8|0;g=j;b=k[a>>2]|0;if(b&1073741824){b=h+4|0;c=ZT(20)|0;k[c>>2]=1;d=c+4|0;k[h>>2]=d;k[b>>2]=12;i[c+16>>0]=0;e=219642;f=d+12|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,h,372928,216975,2570);k[b>>2]=0;k[h>>2]=0;f=k[c>>2]|0;k[c>>2]=f+-1;if((f|0)==1)ggb(k[c+-4>>2]|0);b=k[a>>2]|0}c=b&2031616;a:do if((c|0)<458752){if((c|0)<196608){if((c|0)<65536){switch(c|0){case 0:break;default:break a}r=j;return}switch(c|0){case 65536:break;default:break a}e=k[a+4>>2]|0;d=e+36|0;b=k[d>>2]|0;if(b|0?(g=b+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[e+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;h=e+16|0;d=e+4|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[d>>2]|0)<=0){r=j;return}c=k[e+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0));r=j;return}if((c|0)<262144){switch(c|0){case 196608:break;default:break a}k[g>>2]=0;k[g+4>>2]=0;x2(a,g,b&4095,0);r=j;return}if((c|0)<327680){switch(c|0){case 262144:break;default:break a}f=k[a+4>>2]|0;e=k[f>>2]|0;f=f+4|0;b=k[f>>2]|0;if((b|0)==(e|0)){r=j;return}do{c=b+-12|0;k[f>>2]=c;d=k[c>>2]|0;if(!d)b=c;else{b=b+-8|0;if((k[b>>2]|0)!=(d|0))k[b>>2]=d;ggb(d);b=k[f>>2]|0}}while((b|0)!=(e|0));r=j;return}switch(c|0){case 327680:break;default:break a}a=k[a+4>>2]|0;f=k[a>>2]|0;a=a+4|0;b=k[a>>2]|0;if((b|0)==(f|0)){r=j;return}do{k[a>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(g=c+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;h=b+-40|0;d=b+-52|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[a>>2]|0}while((b|0)!=(f|0));r=j;return}else{if((c|0)<655360){if((c|0)<524288){switch(c|0){case 458752:break;default:break a}r=j;return}if((c|0)<589824){switch(c|0){case 524288:break;default:break a}r=j;return}else{switch(c|0){case 589824:break;default:break a}r=j;return}}if((c|0)<720896){switch(c|0){case 655360:break;default:break a}c=k[a+4>>2]|0;e=c+24|0;b=k[e>>2]|0;if(b|0?(g=b+8|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){h=k[e>>2]|0;g=k[h+4>>2]|0;jh[k[(k[g>>2]|0)+16>>2]&1023](g,h);k[e>>2]=0}d=c+4|0;if((k[d>>2]|0)>0){c=k[c+32>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}k[e>>2]=0;r=j;return}if((c|0)>=851968){switch(c|0){case 851968:break;default:break a}c=k[a+4>>2]|0;b=k[c>>2]|0;c=c+4|0;d=k[c>>2]|0;while(1){if((d|0)==(b|0))break;h=d+-36|0;k[c>>2]=h;d=h}r=j;return}switch(c|0){case 720896:break;default:break a}a=k[a+4>>2]|0;f=k[a>>2]|0;a=a+4|0;while(1){g=k[a>>2]|0;if((g|0)==(f|0))break;k[a>>2]=g+-48;e=g+-24|0;b=k[e>>2]|0;if(b|0?(d=b+8|0,h=k[d>>2]|0,k[d>>2]=h+-1,(h|0)==1):0){h=k[e>>2]|0;d=k[h+4>>2]|0;jh[k[(k[d>>2]|0)+16>>2]&1023](d,h);k[e>>2]=0}c=g+-44|0;if((k[c>>2]|0)>0){d=k[g+-16>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[g+-12>>2]|0;if((b|0)==(g+-8|0)|(b|0)==0)continue;ggb(k[b+-4>>2]|0)}r=j;return}while(0);b=h+4|0;c=ZT(36)|0;k[c>>2]=1;d=c+4|0;k[h>>2]=d;k[b>>2]=30;i[c+34>>0]=0;e=218080;f=d+30|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-213,h,372928,216975,2635);k[b>>2]=0;k[h>>2]=0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0);r=j;return}function c2(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;m=n;h=k[a>>2]|0;l=h&2031616;j=(e|0)<0;if(j&(l|0)==65536?(g|0)==0&(f^1):0){e=a+4|0;if((h&1073741824|0)!=0?(l=k[(k[e>>2]|0)+40>>2]|0,!((k[l>>2]|0)==(b|0)?(k[l+4>>2]|0)==(c|0):0)):0){h=m+4|0;j=ZT(76)|0;k[j>>2]=1;f=j+4|0;k[m>>2]=f;k[h>>2]=68;i[j+72>>0]=0;g=219049;l=f+68|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(l|0));Y8(-215,m,389997,216975,2232);k[h>>2]=0;k[m>>2]=0;l=k[j>>2]|0;k[j>>2]=l+-1;if((l|0)==1)ggb(k[j+-4>>2]|0);h=k[a>>2]|0}if((h|0)<0?(k[k[e>>2]>>2]&4095|0)!=(d|0):0){h=m+4|0;j=ZT(52)|0;k[j>>2]=1;f=j+4|0;k[m>>2]=f;k[h>>2]=44;i[j+48>>0]=0;g=219118;l=f+44|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(l|0));Y8(-215,m,389997,216975,2233);k[h>>2]=0;k[m>>2]=0;a=k[j>>2]|0;k[j>>2]=a+-1;if((a|0)==1)ggb(k[j+-4>>2]|0)}j=k[e>>2]|0;h=d&4095;if(((((k[j+4>>2]|0)<3?(k[j+8>>2]|0)==(b|0):0)?(k[j+12>>2]|0)==(c|0):0)?(k[j>>2]&4095|0)==(h|0):0)?k[j+16>>2]|0:0){r=n;return}k[m>>2]=b;k[m+4>>2]=c;G1(j,2,m,h);r=n;return}if(j&(l|0)==655360?(g|0)==0&(f^1):0){e=a+4|0;if((h&1073741824|0)!=0?(l=k[(k[e>>2]|0)+32>>2]|0,!((k[l>>2]|0)==(b|0)?(k[l+4>>2]|0)==(c|0):0)):0){h=m+4|0;j=ZT(76)|0;k[j>>2]=1;f=j+4|0;k[m>>2]=f;k[h>>2]=69;i[j+73>>0]=0;g=219163;l=f+69|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(l|0));Y8(-215,m,389997,216975,2239);k[h>>2]=0;k[m>>2]=0;l=k[j>>2]|0;k[j>>2]=l+-1;if((l|0)==1)ggb(k[j+-4>>2]|0);h=k[a>>2]|0}if((h|0)<0?(k[k[e>>2]>>2]&4095|0)!=(d|0):0){h=m+4|0;j=ZT(52)|0;k[j>>2]=1;f=j+4|0;k[m>>2]=f;k[h>>2]=45;i[j+49>>0]=0;g=219233;l=f+45|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(l|0));Y8(-215,m,389997,216975,2240);k[h>>2]=0;k[m>>2]=0;a=k[j>>2]|0;k[j>>2]=a+-1;if((a|0)==1)ggb(k[j+-4>>2]|0)}j=k[e>>2]|0;h=d&4095;if(((((k[j+4>>2]|0)<3?(k[j+8>>2]|0)==(b|0):0)?(k[j+12>>2]|0)==(c|0):0)?(k[j>>2]&4095|0)==(h|0):0)?k[j+24>>2]|0:0){r=n;return}k[m>>2]=b;k[m+4>>2]=c;v9(j,2,m,h);r=n;return}if(j&(l|0)==589824?(g|0)==0&(f^1):0){if((h&1073741824|0)!=0?(l=k[a+4>>2]|0,!((k[l+8>>2]|0)==(c|0)?(k[l+4>>2]|0)==(b|0):0)):0){h=m+4|0;j=ZT(72)|0;k[j>>2]=1;f=j+4|0;k[m>>2]=f;k[h>>2]=66;i[j+70>>0]=0;g=219279;l=f+66|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(l|0));Y8(-215,m,389997,216975,2246);k[h>>2]=0;k[m>>2]=0;c=k[j>>2]|0;k[j>>2]=c+-1;if((c|0)==1)ggb(k[j+-4>>2]|0);h=k[a>>2]|0}if((h|0)<0?(k[k[a+4>>2]>>2]&4095|0)!=(d|0):0){h=m+4|0;j=ZT(60)|0;k[j>>2]=1;f=j+4|0;k[m>>2]=f;k[h>>2]=53;i[j+57>>0]=0;g=219346;l=f+53|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(l|0));Y8(-215,m,389997,216975,2247);k[h>>2]=0;k[m>>2]=0;m=k[j>>2]|0;k[j>>2]=m+-1;if((m|0)==1)ggb(k[j+-4>>2]|0)}Q9();r=n;return}if(j&(l|0)==458752?(g|0)==0&(f^1):0){if((h&1073741824|0)!=0?(l=k[a+4>>2]|0,!((k[l+12>>2]|0)==(c|0)?(k[l+8>>2]|0)==(b|0):0)):0){h=m+4|0;j=ZT(72)|0;k[j>>2]=1;f=j+4|0;k[m>>2]=f;k[h>>2]=65;i[j+69>>0]=0;g=219400;l=f+65|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(l|0));Y8(-215,m,389997,216975,2253);k[h>>2]=0;k[m>>2]=0;l=k[j>>2]|0;k[j>>2]=l+-1;if((l|0)==1)ggb(k[j+-4>>2]|0);h=k[a>>2]|0}if((h|0)<0?(k[(k[a+4>>2]|0)+16>>2]|0)!=(d|0):0){h=m+4|0;j=ZT(60)|0;k[j>>2]=1;f=j+4|0;k[m>>2]=f;k[h>>2]=52;i[j+56>>0]=0;g=219466;l=f+52|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(l|0));Y8(-215,m,389997,216975,2254);k[h>>2]=0;k[m>>2]=0;m=k[j>>2]|0;k[j>>2]=m+-1;if((m|0)==1)ggb(k[j+-4>>2]|0)}R4(b,c,d,34962,0);r=n;return}if(j&(l|0)==524288?(g|0)==0&(f^1):0){if((h&1073741824|0)!=0?(l=k[a+4>>2]|0,!((k[l+8>>2]|0)==(c|0)?(k[l+4>>2]|0)==(b|0):0)):0){h=m+4|0;j=ZT(72)|0;k[j>>2]=1;f=j+4|0;k[m>>2]=f;k[h>>2]=67;i[j+71>>0]=0;g=219519;l=f+67|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(l|0));Y8(-215,m,389997,216975,2260);k[h>>2]=0;k[m>>2]=0;c=k[j>>2]|0;k[j>>2]=c+-1;if((c|0)==1)ggb(k[j+-4>>2]|0);h=k[a>>2]|0}if((h|0)<0?(k[k[a+4>>2]>>2]&4095|0)!=(d|0):0){h=m+4|0;j=ZT(60)|0;k[j>>2]=1;f=j+4|0;k[m>>2]=f;k[h>>2]=54;i[j+58>>0]=0;g=219587;l=f+54|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(l|0));Y8(-215,m,389997,216975,2261);k[h>>2]=0;k[m>>2]=0;m=k[j>>2]|0;k[j>>2]=m+-1;if((m|0)==1)ggb(k[j+-4>>2]|0)}R9();r=n;return}k[m>>2]=b;k[m+4>>2]=c;P1(a,2,m,d,e,f,g);r=n;return}function d2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;s=k[e>>2]|0;r=k[e+4>>2]|0;q=s+-4|0;do if((s|0)<4)e=0;else{g=r+-4|0;if((r|0)<4){if((r|0)>0){e=0;do{g=c+(aa(e,d)|0)|0;h=c+(aa(e|1,d)|0)|0;j=c+(aa(e|2,d)|0)|0;l=c+(aa(e|3,d)|0)|0;m=a+e|0;f=0;do{p=m+(aa(f,b)|0)|0;i[g+f>>0]=i[p>>0]|0;i[h+f>>0]=i[p+1>>0]|0;i[j+f>>0]=i[p+2>>0]|0;i[l+f>>0]=i[p+3>>0]|0;f=f+1|0}while((f|0)!=(r|0));e=e+4|0}while((e|0)<=(q|0))}e=s&-4;break}l=r&-4;m=(l|0)<(r|0);f=0;do{n=c+(aa(f,d)|0)|0;o=c+(aa(f|1,d)|0)|0;p=c+(aa(f|2,d)|0)|0;h=c+(aa(f|3,d)|0)|0;j=a+f|0;e=0;do{z=j+(aa(e,b)|0)|0;x=e|1;y=j+(aa(x,b)|0)|0;v=e|2;w=j+(aa(v,b)|0)|0;t=e|3;u=j+(aa(t,b)|0)|0;i[n+e>>0]=i[z>>0]|0;i[n+x>>0]=i[y>>0]|0;i[n+v>>0]=i[w>>0]|0;i[n+t>>0]=i[u>>0]|0;i[o+e>>0]=i[z+1>>0]|0;i[o+x>>0]=i[y+1>>0]|0;i[o+v>>0]=i[w+1>>0]|0;i[o+t>>0]=i[u+1>>0]|0;i[p+e>>0]=i[z+2>>0]|0;i[p+x>>0]=i[y+2>>0]|0;i[p+v>>0]=i[w+2>>0]|0;i[p+t>>0]=i[u+2>>0]|0;i[h+e>>0]=i[z+3>>0]|0;i[h+x>>0]=i[y+3>>0]|0;i[h+v>>0]=i[w+3>>0]|0;i[h+t>>0]=i[u+3>>0]|0;e=e+4|0}while((e|0)<=(g|0));if(m){e=l;do{z=j+(aa(e,b)|0)|0;i[n+e>>0]=i[z>>0]|0;i[o+e>>0]=i[z+1>>0]|0;i[p+e>>0]=i[z+2>>0]|0;i[h+e>>0]=i[z+3>>0]|0;e=e+1|0}while((e|0)!=(r|0))}f=f+4|0}while((f|0)<=(q|0));e=s&-4}while(0);if((e|0)>=(s|0))return;l=r+-4|0;if((r|0)<4){if((r|0)<=0)return;do{g=c+(aa(e,d)|0)|0;h=a+e|0;f=0;do{z=h+(aa(f,b)|0)|0;i[g+f>>0]=i[z>>0]|0;f=f+1|0}while((f|0)!=(r|0));e=e+1|0}while((e|0)!=(s|0));return}j=r&-4;if((j|0)>=(r|0)){do{g=c+(aa(e,d)|0)|0;h=a+e|0;f=0;do{t=h+(aa(f,b)|0)|0;v=f|1;u=h+(aa(v,b)|0)|0;x=f|2;w=h+(aa(x,b)|0)|0;z=f|3;y=h+(aa(z,b)|0)|0;i[g+f>>0]=i[t>>0]|0;i[g+v>>0]=i[u>>0]|0;i[g+x>>0]=i[w>>0]|0;i[g+z>>0]=i[y>>0]|0;f=f+4|0}while((f|0)<=(l|0));e=e+1|0}while((e|0)!=(s|0));return}do{g=c+(aa(e,d)|0)|0;h=a+e|0;f=0;do{t=h+(aa(f,b)|0)|0;v=f|1;u=h+(aa(v,b)|0)|0;x=f|2;w=h+(aa(x,b)|0)|0;z=f|3;y=h+(aa(z,b)|0)|0;i[g+f>>0]=i[t>>0]|0;i[g+v>>0]=i[u>>0]|0;i[g+x>>0]=i[w>>0]|0;i[g+z>>0]=i[y>>0]|0;f=f+4|0}while((f|0)<=(l|0));f=j;do{z=h+(aa(f,b)|0)|0;i[g+f>>0]=i[z>>0]|0;f=f+1|0}while((f|0)!=(r|0));e=e+1|0}while((e|0)!=(s|0));return}function e2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;s=k[e>>2]|0;r=k[e+4>>2]|0;q=s+-4|0;do if((s|0)<4)e=0;else{g=r+-4|0;if((r|0)<4){if((r|0)>0){e=0;do{g=c+(aa(e,d)|0)|0;h=c+(aa(e|1,d)|0)|0;i=c+(aa(e|2,d)|0)|0;l=c+(aa(e|3,d)|0)|0;m=a+(e<<1)|0;f=0;do{p=m+(aa(f,b)|0)|0;j[g+(f<<1)>>1]=j[p>>1]|0;j[h+(f<<1)>>1]=j[p+2>>1]|0;j[i+(f<<1)>>1]=j[p+4>>1]|0;j[l+(f<<1)>>1]=j[p+6>>1]|0;f=f+1|0}while((f|0)!=(r|0));e=e+4|0}while((e|0)<=(q|0))}e=s&-4;break}m=r&-4;n=(m|0)<(r|0);f=0;do{o=c+(aa(f,d)|0)|0;p=c+(aa(f|1,d)|0)|0;h=c+(aa(f|2,d)|0)|0;i=c+(aa(f|3,d)|0)|0;l=a+(f<<1)|0;e=0;do{z=l+(aa(e,b)|0)|0;x=e|1;y=l+(aa(x,b)|0)|0;v=e|2;w=l+(aa(v,b)|0)|0;t=e|3;u=l+(aa(t,b)|0)|0;j[o+(e<<1)>>1]=j[z>>1]|0;j[o+(x<<1)>>1]=j[y>>1]|0;j[o+(v<<1)>>1]=j[w>>1]|0;j[o+(t<<1)>>1]=j[u>>1]|0;j[p+(e<<1)>>1]=j[z+2>>1]|0;j[p+(x<<1)>>1]=j[y+2>>1]|0;j[p+(v<<1)>>1]=j[w+2>>1]|0;j[p+(t<<1)>>1]=j[u+2>>1]|0;j[h+(e<<1)>>1]=j[z+4>>1]|0;j[h+(x<<1)>>1]=j[y+4>>1]|0;j[h+(v<<1)>>1]=j[w+4>>1]|0;j[h+(t<<1)>>1]=j[u+4>>1]|0;j[i+(e<<1)>>1]=j[z+6>>1]|0;j[i+(x<<1)>>1]=j[y+6>>1]|0;j[i+(v<<1)>>1]=j[w+6>>1]|0;j[i+(t<<1)>>1]=j[u+6>>1]|0;e=e+4|0}while((e|0)<=(g|0));if(n){e=m;do{z=l+(aa(e,b)|0)|0;j[o+(e<<1)>>1]=j[z>>1]|0;j[p+(e<<1)>>1]=j[z+2>>1]|0;j[h+(e<<1)>>1]=j[z+4>>1]|0;j[i+(e<<1)>>1]=j[z+6>>1]|0;e=e+1|0}while((e|0)!=(r|0))}f=f+4|0}while((f|0)<=(q|0));e=s&-4}while(0);if((e|0)>=(s|0))return;l=r+-4|0;if((r|0)<4){if((r|0)<=0)return;do{g=c+(aa(e,d)|0)|0;h=a+(e<<1)|0;f=0;do{z=h+(aa(f,b)|0)|0;j[g+(f<<1)>>1]=j[z>>1]|0;f=f+1|0}while((f|0)!=(r|0));e=e+1|0}while((e|0)!=(s|0));return}i=r&-4;if((i|0)>=(r|0)){do{g=c+(aa(e,d)|0)|0;h=a+(e<<1)|0;f=0;do{t=h+(aa(f,b)|0)|0;v=f|1;u=h+(aa(v,b)|0)|0;x=f|2;w=h+(aa(x,b)|0)|0;z=f|3;y=h+(aa(z,b)|0)|0;j[g+(f<<1)>>1]=j[t>>1]|0;j[g+(v<<1)>>1]=j[u>>1]|0;j[g+(x<<1)>>1]=j[w>>1]|0;j[g+(z<<1)>>1]=j[y>>1]|0;f=f+4|0}while((f|0)<=(l|0));e=e+1|0}while((e|0)!=(s|0));return}do{g=c+(aa(e,d)|0)|0;h=a+(e<<1)|0;f=0;do{t=h+(aa(f,b)|0)|0;v=f|1;u=h+(aa(v,b)|0)|0;x=f|2;w=h+(aa(x,b)|0)|0;z=f|3;y=h+(aa(z,b)|0)|0;j[g+(f<<1)>>1]=j[t>>1]|0;j[g+(v<<1)>>1]=j[u>>1]|0;j[g+(x<<1)>>1]=j[w>>1]|0;j[g+(z<<1)>>1]=j[y>>1]|0;f=f+4|0}while((f|0)<=(l|0));f=i;do{z=h+(aa(f,b)|0)|0;j[g+(f<<1)>>1]=j[z>>1]|0;f=f+1|0}while((f|0)!=(r|0));e=e+1|0}while((e|0)!=(s|0));return}function f2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;s=k[e>>2]|0;r=k[e+4>>2]|0;q=s+-4|0;do if((s|0)<4)e=0;else{g=r+-4|0;if((r|0)<4){if((r|0)>0){e=0;do{g=c+(aa(e,d)|0)|0;h=c+(aa(e|1,d)|0)|0;j=c+(aa(e|2,d)|0)|0;l=c+(aa(e|3,d)|0)|0;m=a+(e*3|0)|0;f=0;do{o=m+(aa(f,b)|0)|0;p=g+(f*3|0)|0;i[p>>0]=i[o>>0]|0;i[p+1>>0]=i[o+1>>0]|0;i[p+2>>0]=i[o+2>>0]|0;p=o+3|0;n=h+(f*3|0)|0;i[n>>0]=i[p>>0]|0;i[n+1>>0]=i[p+1>>0]|0;i[n+2>>0]=i[p+2>>0]|0;n=o+6|0;p=j+(f*3|0)|0;i[p>>0]=i[n>>0]|0;i[p+1>>0]=i[n+1>>0]|0;i[p+2>>0]=i[n+2>>0]|0;o=o+9|0;p=l+(f*3|0)|0;i[p>>0]=i[o>>0]|0;i[p+1>>0]=i[o+1>>0]|0;i[p+2>>0]=i[o+2>>0]|0;f=f+1|0}while((f|0)!=(r|0));e=e+4|0}while((e|0)<=(q|0))}e=s&-4;break}h=r&-4;j=(h|0)<(r|0);f=0;do{l=c+(aa(f,d)|0)|0;m=c+(aa(f|1,d)|0)|0;n=c+(aa(f|2,d)|0)|0;o=c+(aa(f|3,d)|0)|0;p=a+(f*3|0)|0;e=0;do{A=p+(aa(e,b)|0)|0;x=e|1;y=p+(aa(x,b)|0)|0;v=e|2;w=p+(aa(v,b)|0)|0;t=e|3;u=p+(aa(t,b)|0)|0;z=l+(e*3|0)|0;i[z>>0]=i[A>>0]|0;i[z+1>>0]=i[A+1>>0]|0;i[z+2>>0]=i[A+2>>0]|0;z=l+(x*3|0)|0;i[z>>0]=i[y>>0]|0;i[z+1>>0]=i[y+1>>0]|0;i[z+2>>0]=i[y+2>>0]|0;z=l+(v*3|0)|0;i[z>>0]=i[w>>0]|0;i[z+1>>0]=i[w+1>>0]|0;i[z+2>>0]=i[w+2>>0]|0;z=l+(t*3|0)|0;i[z>>0]=i[u>>0]|0;i[z+1>>0]=i[u+1>>0]|0;i[z+2>>0]=i[u+2>>0]|0;z=A+3|0;B=m+(e*3|0)|0;i[B>>0]=i[z>>0]|0;i[B+1>>0]=i[z+1>>0]|0;i[B+2>>0]=i[z+2>>0]|0;B=y+3|0;z=m+(x*3|0)|0;i[z>>0]=i[B>>0]|0;i[z+1>>0]=i[B+1>>0]|0;i[z+2>>0]=i[B+2>>0]|0;z=w+3|0;B=m+(v*3|0)|0;i[B>>0]=i[z>>0]|0;i[B+1>>0]=i[z+1>>0]|0;i[B+2>>0]=i[z+2>>0]|0;B=u+3|0;z=m+(t*3|0)|0;i[z>>0]=i[B>>0]|0;i[z+1>>0]=i[B+1>>0]|0;i[z+2>>0]=i[B+2>>0]|0;z=A+6|0;B=n+(e*3|0)|0;i[B>>0]=i[z>>0]|0;i[B+1>>0]=i[z+1>>0]|0;i[B+2>>0]=i[z+2>>0]|0;B=y+6|0;z=n+(x*3|0)|0;i[z>>0]=i[B>>0]|0;i[z+1>>0]=i[B+1>>0]|0;i[z+2>>0]=i[B+2>>0]|0;z=w+6|0;B=n+(v*3|0)|0;i[B>>0]=i[z>>0]|0;i[B+1>>0]=i[z+1>>0]|0;i[B+2>>0]=i[z+2>>0]|0;B=u+6|0;z=n+(t*3|0)|0;i[z>>0]=i[B>>0]|0;i[z+1>>0]=i[B+1>>0]|0;i[z+2>>0]=i[B+2>>0]|0;A=A+9|0;z=o+(e*3|0)|0;i[z>>0]=i[A>>0]|0;i[z+1>>0]=i[A+1>>0]|0;i[z+2>>0]=i[A+2>>0]|0;y=y+9|0;x=o+(x*3|0)|0;i[x>>0]=i[y>>0]|0;i[x+1>>0]=i[y+1>>0]|0;i[x+2>>0]=i[y+2>>0]|0;w=w+9|0;v=o+(v*3|0)|0;i[v>>0]=i[w>>0]|0;i[v+1>>0]=i[w+1>>0]|0;i[v+2>>0]=i[w+2>>0]|0;u=u+9|0;t=o+(t*3|0)|0;i[t>>0]=i[u>>0]|0;i[t+1>>0]=i[u+1>>0]|0;i[t+2>>0]=i[u+2>>0]|0;e=e+4|0}while((e|0)<=(g|0));if(j){e=h;do{A=p+(aa(e,b)|0)|0;B=l+(e*3|0)|0;i[B>>0]=i[A>>0]|0;i[B+1>>0]=i[A+1>>0]|0;i[B+2>>0]=i[A+2>>0]|0;B=A+3|0;z=m+(e*3|0)|0;i[z>>0]=i[B>>0]|0;i[z+1>>0]=i[B+1>>0]|0;i[z+2>>0]=i[B+2>>0]|0;z=A+6|0;B=n+(e*3|0)|0;i[B>>0]=i[z>>0]|0;i[B+1>>0]=i[z+1>>0]|0;i[B+2>>0]=i[z+2>>0]|0;A=A+9|0;B=o+(e*3|0)|0;i[B>>0]=i[A>>0]|0;i[B+1>>0]=i[A+1>>0]|0;i[B+2>>0]=i[A+2>>0]|0;e=e+1|0}while((e|0)!=(r|0))}f=f+4|0}while((f|0)<=(q|0));e=s&-4}while(0);if((e|0)>=(s|0))return;l=r+-4|0;if((r|0)<4){if((r|0)<=0)return;do{g=c+(aa(e,d)|0)|0;h=a+(e*3|0)|0;f=0;do{A=h+(aa(f,b)|0)|0;B=g+(f*3|0)|0;i[B>>0]=i[A>>0]|0;i[B+1>>0]=i[A+1>>0]|0;i[B+2>>0]=i[A+2>>0]|0;f=f+1|0}while((f|0)!=(r|0));e=e+1|0}while((e|0)!=(s|0));return}j=r&-4;if((j|0)>=(r|0)){do{g=c+(aa(e,d)|0)|0;h=a+(e*3|0)|0;f=0;do{u=h+(aa(f,b)|0)|0;x=f|1;w=h+(aa(x,b)|0)|0;z=f|2;y=h+(aa(z,b)|0)|0;B=f|3;A=h+(aa(B,b)|0)|0;v=g+(f*3|0)|0;i[v>>0]=i[u>>0]|0;i[v+1>>0]=i[u+1>>0]|0;i[v+2>>0]=i[u+2>>0]|0;x=g+(x*3|0)|0;i[x>>0]=i[w>>0]|0;i[x+1>>0]=i[w+1>>0]|0;i[x+2>>0]=i[w+2>>0]|0;z=g+(z*3|0)|0;i[z>>0]=i[y>>0]|0;i[z+1>>0]=i[y+1>>0]|0;i[z+2>>0]=i[y+2>>0]|0;B=g+(B*3|0)|0;i[B>>0]=i[A>>0]|0;i[B+1>>0]=i[A+1>>0]|0;i[B+2>>0]=i[A+2>>0]|0;f=f+4|0}while((f|0)<=(l|0));e=e+1|0}while((e|0)!=(s|0));return}do{g=c+(aa(e,d)|0)|0;h=a+(e*3|0)|0;f=0;do{u=h+(aa(f,b)|0)|0;x=f|1;w=h+(aa(x,b)|0)|0;z=f|2;y=h+(aa(z,b)|0)|0;B=f|3;A=h+(aa(B,b)|0)|0;v=g+(f*3|0)|0;i[v>>0]=i[u>>0]|0;i[v+1>>0]=i[u+1>>0]|0;i[v+2>>0]=i[u+2>>0]|0;x=g+(x*3|0)|0;i[x>>0]=i[w>>0]|0;i[x+1>>0]=i[w+1>>0]|0;i[x+2>>0]=i[w+2>>0]|0;z=g+(z*3|0)|0;i[z>>0]=i[y>>0]|0;i[z+1>>0]=i[y+1>>0]|0;i[z+2>>0]=i[y+2>>0]|0;B=g+(B*3|0)|0;i[B>>0]=i[A>>0]|0;i[B+1>>0]=i[A+1>>0]|0;i[B+2>>0]=i[A+2>>0]|0;f=f+4|0}while((f|0)<=(l|0));f=j;do{A=h+(aa(f,b)|0)|0;B=g+(f*3|0)|0;i[B>>0]=i[A>>0]|0;i[B+1>>0]=i[A+1>>0]|0;i[B+2>>0]=i[A+2>>0]|0;f=f+1|0}while((f|0)!=(r|0));e=e+1|0}while((e|0)!=(s|0));return}function g2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;r=k[e>>2]|0;q=k[e+4>>2]|0;p=r+-4|0;do if((r|0)<4)e=0;else{g=q+-4|0;if((q|0)<4){if((q|0)>0){e=0;do{g=c+(aa(e,d)|0)|0;h=c+(aa(e|1,d)|0)|0;i=c+(aa(e|2,d)|0)|0;j=c+(aa(e|3,d)|0)|0;l=a+(e<<2)|0;f=0;do{o=l+(aa(f,b)|0)|0;k[g+(f<<2)>>2]=k[o>>2];k[h+(f<<2)>>2]=k[o+4>>2];k[i+(f<<2)>>2]=k[o+8>>2];k[j+(f<<2)>>2]=k[o+12>>2];f=f+1|0}while((f|0)!=(q|0));e=e+4|0}while((e|0)<=(p|0))}e=r&-4;break}l=q&-4;m=(l|0)<(q|0);f=0;do{n=c+(aa(f,d)|0)|0;o=c+(aa(f|1,d)|0)|0;h=c+(aa(f|2,d)|0)|0;i=c+(aa(f|3,d)|0)|0;j=a+(f<<2)|0;e=0;do{y=j+(aa(e,b)|0)|0;w=e|1;x=j+(aa(w,b)|0)|0;u=e|2;v=j+(aa(u,b)|0)|0;s=e|3;t=j+(aa(s,b)|0)|0;k[n+(e<<2)>>2]=k[y>>2];k[n+(w<<2)>>2]=k[x>>2];k[n+(u<<2)>>2]=k[v>>2];k[n+(s<<2)>>2]=k[t>>2];k[o+(e<<2)>>2]=k[y+4>>2];k[o+(w<<2)>>2]=k[x+4>>2];k[o+(u<<2)>>2]=k[v+4>>2];k[o+(s<<2)>>2]=k[t+4>>2];k[h+(e<<2)>>2]=k[y+8>>2];k[h+(w<<2)>>2]=k[x+8>>2];k[h+(u<<2)>>2]=k[v+8>>2];k[h+(s<<2)>>2]=k[t+8>>2];k[i+(e<<2)>>2]=k[y+12>>2];k[i+(w<<2)>>2]=k[x+12>>2];k[i+(u<<2)>>2]=k[v+12>>2];k[i+(s<<2)>>2]=k[t+12>>2];e=e+4|0}while((e|0)<=(g|0));if(m){e=l;do{y=j+(aa(e,b)|0)|0;k[n+(e<<2)>>2]=k[y>>2];k[o+(e<<2)>>2]=k[y+4>>2];k[h+(e<<2)>>2]=k[y+8>>2];k[i+(e<<2)>>2]=k[y+12>>2];e=e+1|0}while((e|0)!=(q|0))}f=f+4|0}while((f|0)<=(p|0));e=r&-4}while(0);if((e|0)>=(r|0))return;j=q+-4|0;if((q|0)<4){if((q|0)<=0)return;do{g=c+(aa(e,d)|0)|0;h=a+(e<<2)|0;f=0;do{y=h+(aa(f,b)|0)|0;k[g+(f<<2)>>2]=k[y>>2];f=f+1|0}while((f|0)!=(q|0));e=e+1|0}while((e|0)!=(r|0));return}i=q&-4;if((i|0)>=(q|0)){do{g=c+(aa(e,d)|0)|0;h=a+(e<<2)|0;f=0;do{s=h+(aa(f,b)|0)|0;u=f|1;t=h+(aa(u,b)|0)|0;w=f|2;v=h+(aa(w,b)|0)|0;y=f|3;x=h+(aa(y,b)|0)|0;k[g+(f<<2)>>2]=k[s>>2];k[g+(u<<2)>>2]=k[t>>2];k[g+(w<<2)>>2]=k[v>>2];k[g+(y<<2)>>2]=k[x>>2];f=f+4|0}while((f|0)<=(j|0));e=e+1|0}while((e|0)!=(r|0));return}do{g=c+(aa(e,d)|0)|0;h=a+(e<<2)|0;f=0;do{s=h+(aa(f,b)|0)|0;u=f|1;t=h+(aa(u,b)|0)|0;w=f|2;v=h+(aa(w,b)|0)|0;y=f|3;x=h+(aa(y,b)|0)|0;k[g+(f<<2)>>2]=k[s>>2];k[g+(u<<2)>>2]=k[t>>2];k[g+(w<<2)>>2]=k[v>>2];k[g+(y<<2)>>2]=k[x>>2];f=f+4|0}while((f|0)<=(j|0));f=i;do{y=h+(aa(f,b)|0)|0;k[g+(f<<2)>>2]=k[y>>2];f=f+1|0}while((f|0)!=(q|0));e=e+1|0}while((e|0)!=(r|0));return}function h2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;s=k[e>>2]|0;r=k[e+4>>2]|0;q=s+-4|0;do if((s|0)<4)e=0;else{g=r+-4|0;if((r|0)<4){if((r|0)>0){e=0;do{g=c+(aa(e,d)|0)|0;h=c+(aa(e|1,d)|0)|0;i=c+(aa(e|2,d)|0)|0;l=c+(aa(e|3,d)|0)|0;m=a+(e*6|0)|0;f=0;do{o=m+(aa(f,b)|0)|0;p=g+(f*6|0)|0;j[p>>1]=j[o>>1]|0;j[p+2>>1]=j[o+2>>1]|0;j[p+4>>1]=j[o+4>>1]|0;p=h+(f*6|0)|0;n=o+6|0;j[p>>1]=j[n>>1]|0;j[p+2>>1]=j[n+2>>1]|0;j[p+4>>1]=j[n+4>>1]|0;p=i+(f*6|0)|0;n=o+12|0;j[p>>1]=j[n>>1]|0;j[p+2>>1]=j[n+2>>1]|0;j[p+4>>1]=j[n+4>>1]|0;p=l+(f*6|0)|0;o=o+18|0;j[p>>1]=j[o>>1]|0;j[p+2>>1]=j[o+2>>1]|0;j[p+4>>1]=j[o+4>>1]|0;f=f+1|0}while((f|0)!=(r|0));e=e+4|0}while((e|0)<=(q|0))}e=s&-4;break}h=r&-4;i=(h|0)<(r|0);f=0;do{l=c+(aa(f,d)|0)|0;m=c+(aa(f|1,d)|0)|0;n=c+(aa(f|2,d)|0)|0;o=c+(aa(f|3,d)|0)|0;p=a+(f*6|0)|0;e=0;do{A=p+(aa(e,b)|0)|0;x=e|1;y=p+(aa(x,b)|0)|0;v=e|2;w=p+(aa(v,b)|0)|0;t=e|3;u=p+(aa(t,b)|0)|0;z=l+(e*6|0)|0;j[z>>1]=j[A>>1]|0;j[z+2>>1]=j[A+2>>1]|0;j[z+4>>1]=j[A+4>>1]|0;z=l+(x*6|0)|0;j[z>>1]=j[y>>1]|0;j[z+2>>1]=j[y+2>>1]|0;j[z+4>>1]=j[y+4>>1]|0;z=l+(v*6|0)|0;j[z>>1]=j[w>>1]|0;j[z+2>>1]=j[w+2>>1]|0;j[z+4>>1]=j[w+4>>1]|0;z=l+(t*6|0)|0;j[z>>1]=j[u>>1]|0;j[z+2>>1]=j[u+2>>1]|0;j[z+4>>1]=j[u+4>>1]|0;z=m+(e*6|0)|0;B=A+6|0;j[z>>1]=j[B>>1]|0;j[z+2>>1]=j[B+2>>1]|0;j[z+4>>1]=j[B+4>>1]|0;z=m+(x*6|0)|0;B=y+6|0;j[z>>1]=j[B>>1]|0;j[z+2>>1]=j[B+2>>1]|0;j[z+4>>1]=j[B+4>>1]|0;z=m+(v*6|0)|0;B=w+6|0;j[z>>1]=j[B>>1]|0;j[z+2>>1]=j[B+2>>1]|0;j[z+4>>1]=j[B+4>>1]|0;z=m+(t*6|0)|0;B=u+6|0;j[z>>1]=j[B>>1]|0;j[z+2>>1]=j[B+2>>1]|0;j[z+4>>1]=j[B+4>>1]|0;z=n+(e*6|0)|0;B=A+12|0;j[z>>1]=j[B>>1]|0;j[z+2>>1]=j[B+2>>1]|0;j[z+4>>1]=j[B+4>>1]|0;z=n+(x*6|0)|0;B=y+12|0;j[z>>1]=j[B>>1]|0;j[z+2>>1]=j[B+2>>1]|0;j[z+4>>1]=j[B+4>>1]|0;z=n+(v*6|0)|0;B=w+12|0;j[z>>1]=j[B>>1]|0;j[z+2>>1]=j[B+2>>1]|0;j[z+4>>1]=j[B+4>>1]|0;z=n+(t*6|0)|0;B=u+12|0;j[z>>1]=j[B>>1]|0;j[z+2>>1]=j[B+2>>1]|0;j[z+4>>1]=j[B+4>>1]|0;z=o+(e*6|0)|0;A=A+18|0;j[z>>1]=j[A>>1]|0;j[z+2>>1]=j[A+2>>1]|0;j[z+4>>1]=j[A+4>>1]|0;x=o+(x*6|0)|0;y=y+18|0;j[x>>1]=j[y>>1]|0;j[x+2>>1]=j[y+2>>1]|0;j[x+4>>1]=j[y+4>>1]|0;v=o+(v*6|0)|0;w=w+18|0;j[v>>1]=j[w>>1]|0;j[v+2>>1]=j[w+2>>1]|0;j[v+4>>1]=j[w+4>>1]|0;t=o+(t*6|0)|0;u=u+18|0;j[t>>1]=j[u>>1]|0;j[t+2>>1]=j[u+2>>1]|0;j[t+4>>1]=j[u+4>>1]|0;e=e+4|0}while((e|0)<=(g|0));if(i){e=h;do{A=p+(aa(e,b)|0)|0;B=l+(e*6|0)|0;j[B>>1]=j[A>>1]|0;j[B+2>>1]=j[A+2>>1]|0;j[B+4>>1]=j[A+4>>1]|0;B=m+(e*6|0)|0;z=A+6|0;j[B>>1]=j[z>>1]|0;j[B+2>>1]=j[z+2>>1]|0;j[B+4>>1]=j[z+4>>1]|0;B=n+(e*6|0)|0;z=A+12|0;j[B>>1]=j[z>>1]|0;j[B+2>>1]=j[z+2>>1]|0;j[B+4>>1]=j[z+4>>1]|0;B=o+(e*6|0)|0;A=A+18|0;j[B>>1]=j[A>>1]|0;j[B+2>>1]=j[A+2>>1]|0;j[B+4>>1]=j[A+4>>1]|0;e=e+1|0}while((e|0)!=(r|0))}f=f+4|0}while((f|0)<=(q|0));e=s&-4}while(0);if((e|0)>=(s|0))return;l=r+-4|0;if((r|0)<4){if((r|0)<=0)return;do{g=c+(aa(e,d)|0)|0;h=a+(e*6|0)|0;f=0;do{A=h+(aa(f,b)|0)|0;B=g+(f*6|0)|0;j[B>>1]=j[A>>1]|0;j[B+2>>1]=j[A+2>>1]|0;j[B+4>>1]=j[A+4>>1]|0;f=f+1|0}while((f|0)!=(r|0));e=e+1|0}while((e|0)!=(s|0));return}i=r&-4;if((i|0)>=(r|0)){do{g=c+(aa(e,d)|0)|0;h=a+(e*6|0)|0;f=0;do{u=h+(aa(f,b)|0)|0;x=f|1;w=h+(aa(x,b)|0)|0;z=f|2;y=h+(aa(z,b)|0)|0;B=f|3;A=h+(aa(B,b)|0)|0;v=g+(f*6|0)|0;j[v>>1]=j[u>>1]|0;j[v+2>>1]=j[u+2>>1]|0;j[v+4>>1]=j[u+4>>1]|0;x=g+(x*6|0)|0;j[x>>1]=j[w>>1]|0;j[x+2>>1]=j[w+2>>1]|0;j[x+4>>1]=j[w+4>>1]|0;z=g+(z*6|0)|0;j[z>>1]=j[y>>1]|0;j[z+2>>1]=j[y+2>>1]|0;j[z+4>>1]=j[y+4>>1]|0;B=g+(B*6|0)|0;j[B>>1]=j[A>>1]|0;j[B+2>>1]=j[A+2>>1]|0;j[B+4>>1]=j[A+4>>1]|0;f=f+4|0}while((f|0)<=(l|0));e=e+1|0}while((e|0)!=(s|0));return}do{g=c+(aa(e,d)|0)|0;h=a+(e*6|0)|0;f=0;do{u=h+(aa(f,b)|0)|0;x=f|1;w=h+(aa(x,b)|0)|0;z=f|2;y=h+(aa(z,b)|0)|0;B=f|3;A=h+(aa(B,b)|0)|0;v=g+(f*6|0)|0;j[v>>1]=j[u>>1]|0;j[v+2>>1]=j[u+2>>1]|0;j[v+4>>1]=j[u+4>>1]|0;x=g+(x*6|0)|0;j[x>>1]=j[w>>1]|0;j[x+2>>1]=j[w+2>>1]|0;j[x+4>>1]=j[w+4>>1]|0;z=g+(z*6|0)|0;j[z>>1]=j[y>>1]|0;j[z+2>>1]=j[y+2>>1]|0;j[z+4>>1]=j[y+4>>1]|0;B=g+(B*6|0)|0;j[B>>1]=j[A>>1]|0;j[B+2>>1]=j[A+2>>1]|0;j[B+4>>1]=j[A+4>>1]|0;f=f+4|0}while((f|0)<=(l|0));f=i;do{A=h+(aa(f,b)|0)|0;B=g+(f*6|0)|0;j[B>>1]=j[A>>1]|0;j[B+2>>1]=j[A+2>>1]|0;j[B+4>>1]=j[A+4>>1]|0;f=f+1|0}while((f|0)!=(r|0));e=e+1|0}while((e|0)!=(s|0));return}function i2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;r=k[e>>2]|0;q=k[e+4>>2]|0;p=r+-4|0;do if((r|0)<4)e=0;else{g=q+-4|0;if((q|0)<4){if((q|0)>0){e=0;do{g=c+(aa(e,d)|0)|0;h=c+(aa(e|1,d)|0)|0;i=c+(aa(e|2,d)|0)|0;j=c+(aa(e|3,d)|0)|0;l=a+(e<<3)|0;f=0;do{m=l+(aa(f,b)|0)|0;s=m;o=k[s+4>>2]|0;n=g+(f<<3)|0;k[n>>2]=k[s>>2];k[n+4>>2]=o;n=m+8|0;o=k[n+4>>2]|0;s=h+(f<<3)|0;k[s>>2]=k[n>>2];k[s+4>>2]=o;s=m+16|0;o=k[s+4>>2]|0;n=i+(f<<3)|0;k[n>>2]=k[s>>2];k[n+4>>2]=o;m=m+24|0;n=k[m+4>>2]|0;o=j+(f<<3)|0;k[o>>2]=k[m>>2];k[o+4>>2]=n;f=f+1|0}while((f|0)!=(q|0));e=e+4|0}while((e|0)<=(p|0))}e=r&-4;break}n=q&-4;o=(n|0)<(q|0);f=0;do{h=c+(aa(f,d)|0)|0;i=c+(aa(f|1,d)|0)|0;j=c+(aa(f|2,d)|0)|0;l=c+(aa(f|3,d)|0)|0;m=a+(f<<3)|0;e=0;do{A=m+(aa(e,b)|0)|0;v=e|1;y=m+(aa(v,b)|0)|0;t=e|2;w=m+(aa(t,b)|0)|0;s=e|3;u=m+(aa(s,b)|0)|0;z=A;x=k[z+4>>2]|0;B=h+(e<<3)|0;k[B>>2]=k[z>>2];k[B+4>>2]=x;B=y;x=k[B+4>>2]|0;z=h+(v<<3)|0;k[z>>2]=k[B>>2];k[z+4>>2]=x;z=w;x=k[z+4>>2]|0;B=h+(t<<3)|0;k[B>>2]=k[z>>2];k[B+4>>2]=x;B=u;x=k[B+4>>2]|0;z=h+(s<<3)|0;k[z>>2]=k[B>>2];k[z+4>>2]=x;z=A+8|0;x=k[z+4>>2]|0;B=i+(e<<3)|0;k[B>>2]=k[z>>2];k[B+4>>2]=x;B=y+8|0;x=k[B+4>>2]|0;z=i+(v<<3)|0;k[z>>2]=k[B>>2];k[z+4>>2]=x;z=w+8|0;x=k[z+4>>2]|0;B=i+(t<<3)|0;k[B>>2]=k[z>>2];k[B+4>>2]=x;B=u+8|0;x=k[B+4>>2]|0;z=i+(s<<3)|0;k[z>>2]=k[B>>2];k[z+4>>2]=x;z=A+16|0;x=k[z+4>>2]|0;B=j+(e<<3)|0;k[B>>2]=k[z>>2];k[B+4>>2]=x;B=y+16|0;x=k[B+4>>2]|0;z=j+(v<<3)|0;k[z>>2]=k[B>>2];k[z+4>>2]=x;z=w+16|0;x=k[z+4>>2]|0;B=j+(t<<3)|0;k[B>>2]=k[z>>2];k[B+4>>2]=x;B=u+16|0;x=k[B+4>>2]|0;z=j+(s<<3)|0;k[z>>2]=k[B>>2];k[z+4>>2]=x;A=A+24|0;z=k[A+4>>2]|0;x=l+(e<<3)|0;k[x>>2]=k[A>>2];k[x+4>>2]=z;y=y+24|0;x=k[y+4>>2]|0;v=l+(v<<3)|0;k[v>>2]=k[y>>2];k[v+4>>2]=x;w=w+24|0;v=k[w+4>>2]|0;t=l+(t<<3)|0;k[t>>2]=k[w>>2];k[t+4>>2]=v;u=u+24|0;t=k[u+4>>2]|0;s=l+(s<<3)|0;k[s>>2]=k[u>>2];k[s+4>>2]=t;e=e+4|0}while((e|0)<=(g|0));if(o){e=n;do{z=m+(aa(e,b)|0)|0;y=z;B=k[y+4>>2]|0;A=h+(e<<3)|0;k[A>>2]=k[y>>2];k[A+4>>2]=B;A=z+8|0;B=k[A+4>>2]|0;y=i+(e<<3)|0;k[y>>2]=k[A>>2];k[y+4>>2]=B;y=z+16|0;B=k[y+4>>2]|0;A=j+(e<<3)|0;k[A>>2]=k[y>>2];k[A+4>>2]=B;z=z+24|0;A=k[z+4>>2]|0;B=l+(e<<3)|0;k[B>>2]=k[z>>2];k[B+4>>2]=A;e=e+1|0}while((e|0)!=(q|0))}f=f+4|0}while((f|0)<=(p|0));e=r&-4}while(0);if((e|0)>=(r|0))return;j=q+-4|0;if((q|0)<4){if((q|0)<=0)return;do{g=c+(aa(e,d)|0)|0;h=a+(e<<3)|0;f=0;do{z=h+(aa(f,b)|0)|0;A=k[z+4>>2]|0;B=g+(f<<3)|0;k[B>>2]=k[z>>2];k[B+4>>2]=A;f=f+1|0}while((f|0)!=(q|0));e=e+1|0}while((e|0)!=(r|0));return}i=q&-4;if((i|0)>=(q|0)){do{g=c+(aa(e,d)|0)|0;h=a+(e<<3)|0;f=0;do{y=f|1;v=h+(aa(y,b)|0)|0;A=f|2;x=h+(aa(A,b)|0)|0;B=f|3;z=h+(aa(B,b)|0)|0;t=h+(aa(f,b)|0)|0;u=k[t+4>>2]|0;w=g+(f<<3)|0;k[w>>2]=k[t>>2];k[w+4>>2]=u;w=k[v+4>>2]|0;y=g+(y<<3)|0;k[y>>2]=k[v>>2];k[y+4>>2]=w;y=k[x+4>>2]|0;A=g+(A<<3)|0;k[A>>2]=k[x>>2];k[A+4>>2]=y;A=k[z+4>>2]|0;B=g+(B<<3)|0;k[B>>2]=k[z>>2];k[B+4>>2]=A;f=f+4|0}while((f|0)<=(j|0));e=e+1|0}while((e|0)!=(r|0));return}do{g=c+(aa(e,d)|0)|0;h=a+(e<<3)|0;f=0;do{y=f|1;v=h+(aa(y,b)|0)|0;A=f|2;x=h+(aa(A,b)|0)|0;B=f|3;z=h+(aa(B,b)|0)|0;t=h+(aa(f,b)|0)|0;u=k[t+4>>2]|0;w=g+(f<<3)|0;k[w>>2]=k[t>>2];k[w+4>>2]=u;w=k[v+4>>2]|0;y=g+(y<<3)|0;k[y>>2]=k[v>>2];k[y+4>>2]=w;y=k[x+4>>2]|0;A=g+(A<<3)|0;k[A>>2]=k[x>>2];k[A+4>>2]=y;A=k[z+4>>2]|0;B=g+(B<<3)|0;k[B>>2]=k[z>>2];k[B+4>>2]=A;f=f+4|0}while((f|0)<=(j|0));f=i;do{z=h+(aa(f,b)|0)|0;A=k[z+4>>2]|0;B=g+(f<<3)|0;k[B>>2]=k[z>>2];k[B+4>>2]=A;f=f+1|0}while((f|0)!=(q|0));e=e+1|0}while((e|0)!=(r|0));return}function j2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;r=k[e>>2]|0;q=k[e+4>>2]|0;p=r+-4|0;do if((r|0)<4)e=0;else{g=q+-4|0;if((q|0)<4){if((q|0)>0){e=0;do{g=c+(aa(e,d)|0)|0;h=c+(aa(e|1,d)|0)|0;i=c+(aa(e|2,d)|0)|0;j=c+(aa(e|3,d)|0)|0;l=a+(e*12|0)|0;f=0;do{n=l+(aa(f,b)|0)|0;o=g+(f*12|0)|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];k[o+8>>2]=k[n+8>>2];o=h+(f*12|0)|0;m=n+12|0;k[o>>2]=k[m>>2];k[o+4>>2]=k[m+4>>2];k[o+8>>2]=k[m+8>>2];o=i+(f*12|0)|0;m=n+24|0;k[o>>2]=k[m>>2];k[o+4>>2]=k[m+4>>2];k[o+8>>2]=k[m+8>>2];o=j+(f*12|0)|0;n=n+36|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];k[o+8>>2]=k[n+8>>2];f=f+1|0}while((f|0)!=(q|0));e=e+4|0}while((e|0)<=(p|0))}e=r&-4;break}h=q&-4;i=(h|0)<(q|0);f=0;do{j=c+(aa(f,d)|0)|0;l=c+(aa(f|1,d)|0)|0;m=c+(aa(f|2,d)|0)|0;n=c+(aa(f|3,d)|0)|0;o=a+(f*12|0)|0;e=0;do{z=o+(aa(e,b)|0)|0;w=e|1;x=o+(aa(w,b)|0)|0;u=e|2;v=o+(aa(u,b)|0)|0;s=e|3;t=o+(aa(s,b)|0)|0;y=j+(e*12|0)|0;k[y>>2]=k[z>>2];k[y+4>>2]=k[z+4>>2];k[y+8>>2]=k[z+8>>2];y=j+(w*12|0)|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];k[y+8>>2]=k[x+8>>2];y=j+(u*12|0)|0;k[y>>2]=k[v>>2];k[y+4>>2]=k[v+4>>2];k[y+8>>2]=k[v+8>>2];y=j+(s*12|0)|0;k[y>>2]=k[t>>2];k[y+4>>2]=k[t+4>>2];k[y+8>>2]=k[t+8>>2];y=l+(e*12|0)|0;A=z+12|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];y=l+(w*12|0)|0;A=x+12|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];y=l+(u*12|0)|0;A=v+12|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];y=l+(s*12|0)|0;A=t+12|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];y=m+(e*12|0)|0;A=z+24|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];y=m+(w*12|0)|0;A=x+24|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];y=m+(u*12|0)|0;A=v+24|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];y=m+(s*12|0)|0;A=t+24|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];y=n+(e*12|0)|0;z=z+36|0;k[y>>2]=k[z>>2];k[y+4>>2]=k[z+4>>2];k[y+8>>2]=k[z+8>>2];w=n+(w*12|0)|0;x=x+36|0;k[w>>2]=k[x>>2];k[w+4>>2]=k[x+4>>2];k[w+8>>2]=k[x+8>>2];u=n+(u*12|0)|0;v=v+36|0;k[u>>2]=k[v>>2];k[u+4>>2]=k[v+4>>2];k[u+8>>2]=k[v+8>>2];s=n+(s*12|0)|0;t=t+36|0;k[s>>2]=k[t>>2];k[s+4>>2]=k[t+4>>2];k[s+8>>2]=k[t+8>>2];e=e+4|0}while((e|0)<=(g|0));if(i){e=h;do{z=o+(aa(e,b)|0)|0;A=j+(e*12|0)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];A=l+(e*12|0)|0;y=z+12|0;k[A>>2]=k[y>>2];k[A+4>>2]=k[y+4>>2];k[A+8>>2]=k[y+8>>2];A=m+(e*12|0)|0;y=z+24|0;k[A>>2]=k[y>>2];k[A+4>>2]=k[y+4>>2];k[A+8>>2]=k[y+8>>2];A=n+(e*12|0)|0;z=z+36|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];e=e+1|0}while((e|0)!=(q|0))}f=f+4|0}while((f|0)<=(p|0));e=r&-4}while(0);if((e|0)>=(r|0))return;j=q+-4|0;if((q|0)<4){if((q|0)<=0)return;do{g=c+(aa(e,d)|0)|0;h=a+(e*12|0)|0;f=0;do{z=h+(aa(f,b)|0)|0;A=g+(f*12|0)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];f=f+1|0}while((f|0)!=(q|0));e=e+1|0}while((e|0)!=(r|0));return}i=q&-4;if((i|0)>=(q|0)){do{g=c+(aa(e,d)|0)|0;h=a+(e*12|0)|0;f=0;do{t=h+(aa(f,b)|0)|0;w=f|1;v=h+(aa(w,b)|0)|0;y=f|2;x=h+(aa(y,b)|0)|0;A=f|3;z=h+(aa(A,b)|0)|0;u=g+(f*12|0)|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];k[u+8>>2]=k[t+8>>2];w=g+(w*12|0)|0;k[w>>2]=k[v>>2];k[w+4>>2]=k[v+4>>2];k[w+8>>2]=k[v+8>>2];y=g+(y*12|0)|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];k[y+8>>2]=k[x+8>>2];A=g+(A*12|0)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];f=f+4|0}while((f|0)<=(j|0));e=e+1|0}while((e|0)!=(r|0));return}do{g=c+(aa(e,d)|0)|0;h=a+(e*12|0)|0;f=0;do{t=h+(aa(f,b)|0)|0;w=f|1;v=h+(aa(w,b)|0)|0;y=f|2;x=h+(aa(y,b)|0)|0;A=f|3;z=h+(aa(A,b)|0)|0;u=g+(f*12|0)|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];k[u+8>>2]=k[t+8>>2];w=g+(w*12|0)|0;k[w>>2]=k[v>>2];k[w+4>>2]=k[v+4>>2];k[w+8>>2]=k[v+8>>2];y=g+(y*12|0)|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];k[y+8>>2]=k[x+8>>2];A=g+(A*12|0)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];f=f+4|0}while((f|0)<=(j|0));f=i;do{z=h+(aa(f,b)|0)|0;A=g+(f*12|0)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];f=f+1|0}while((f|0)!=(q|0));e=e+1|0}while((e|0)!=(r|0));return}function k2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;r=k[e>>2]|0;q=k[e+4>>2]|0;p=r+-4|0;do if((r|0)<4)e=0;else{g=q+-4|0;if((q|0)<4){if((q|0)>0){e=0;do{g=c+(aa(e,d)|0)|0;h=c+(aa(e|1,d)|0)|0;i=c+(aa(e|2,d)|0)|0;j=c+(aa(e|3,d)|0)|0;l=a+(e<<4)|0;f=0;do{n=l+(aa(f,b)|0)|0;o=g+(f<<4)|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];k[o+8>>2]=k[n+8>>2];k[o+12>>2]=k[n+12>>2];o=h+(f<<4)|0;m=n+16|0;k[o>>2]=k[m>>2];k[o+4>>2]=k[m+4>>2];k[o+8>>2]=k[m+8>>2];k[o+12>>2]=k[m+12>>2];o=i+(f<<4)|0;m=n+32|0;k[o>>2]=k[m>>2];k[o+4>>2]=k[m+4>>2];k[o+8>>2]=k[m+8>>2];k[o+12>>2]=k[m+12>>2];o=j+(f<<4)|0;n=n+48|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];k[o+8>>2]=k[n+8>>2];k[o+12>>2]=k[n+12>>2];f=f+1|0}while((f|0)!=(q|0));e=e+4|0}while((e|0)<=(p|0))}e=r&-4;break}h=q&-4;i=(h|0)<(q|0);f=0;do{j=c+(aa(f,d)|0)|0;l=c+(aa(f|1,d)|0)|0;m=c+(aa(f|2,d)|0)|0;n=c+(aa(f|3,d)|0)|0;o=a+(f<<4)|0;e=0;do{z=o+(aa(e,b)|0)|0;w=e|1;x=o+(aa(w,b)|0)|0;u=e|2;v=o+(aa(u,b)|0)|0;s=e|3;t=o+(aa(s,b)|0)|0;y=j+(e<<4)|0;k[y>>2]=k[z>>2];k[y+4>>2]=k[z+4>>2];k[y+8>>2]=k[z+8>>2];k[y+12>>2]=k[z+12>>2];y=j+(w<<4)|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];k[y+8>>2]=k[x+8>>2];k[y+12>>2]=k[x+12>>2];y=j+(u<<4)|0;k[y>>2]=k[v>>2];k[y+4>>2]=k[v+4>>2];k[y+8>>2]=k[v+8>>2];k[y+12>>2]=k[v+12>>2];y=j+(s<<4)|0;k[y>>2]=k[t>>2];k[y+4>>2]=k[t+4>>2];k[y+8>>2]=k[t+8>>2];k[y+12>>2]=k[t+12>>2];y=l+(e<<4)|0;A=z+16|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];y=l+(w<<4)|0;A=x+16|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];y=l+(u<<4)|0;A=v+16|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];y=l+(s<<4)|0;A=t+16|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];y=m+(e<<4)|0;A=z+32|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];y=m+(w<<4)|0;A=x+32|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];y=m+(u<<4)|0;A=v+32|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];y=m+(s<<4)|0;A=t+32|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];y=n+(e<<4)|0;z=z+48|0;k[y>>2]=k[z>>2];k[y+4>>2]=k[z+4>>2];k[y+8>>2]=k[z+8>>2];k[y+12>>2]=k[z+12>>2];w=n+(w<<4)|0;x=x+48|0;k[w>>2]=k[x>>2];k[w+4>>2]=k[x+4>>2];k[w+8>>2]=k[x+8>>2];k[w+12>>2]=k[x+12>>2];u=n+(u<<4)|0;v=v+48|0;k[u>>2]=k[v>>2];k[u+4>>2]=k[v+4>>2];k[u+8>>2]=k[v+8>>2];k[u+12>>2]=k[v+12>>2];s=n+(s<<4)|0;t=t+48|0;k[s>>2]=k[t>>2];k[s+4>>2]=k[t+4>>2];k[s+8>>2]=k[t+8>>2];k[s+12>>2]=k[t+12>>2];e=e+4|0}while((e|0)<=(g|0));if(i){e=h;do{z=o+(aa(e,b)|0)|0;A=j+(e<<4)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];A=l+(e<<4)|0;y=z+16|0;k[A>>2]=k[y>>2];k[A+4>>2]=k[y+4>>2];k[A+8>>2]=k[y+8>>2];k[A+12>>2]=k[y+12>>2];A=m+(e<<4)|0;y=z+32|0;k[A>>2]=k[y>>2];k[A+4>>2]=k[y+4>>2];k[A+8>>2]=k[y+8>>2];k[A+12>>2]=k[y+12>>2];A=n+(e<<4)|0;z=z+48|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];e=e+1|0}while((e|0)!=(q|0))}f=f+4|0}while((f|0)<=(p|0));e=r&-4}while(0);if((e|0)>=(r|0))return;j=q+-4|0;if((q|0)<4){if((q|0)<=0)return;do{g=c+(aa(e,d)|0)|0;h=a+(e<<4)|0;f=0;do{z=h+(aa(f,b)|0)|0;A=g+(f<<4)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];f=f+1|0}while((f|0)!=(q|0));e=e+1|0}while((e|0)!=(r|0));return}i=q&-4;if((i|0)>=(q|0)){do{g=c+(aa(e,d)|0)|0;h=a+(e<<4)|0;f=0;do{t=h+(aa(f,b)|0)|0;w=f|1;v=h+(aa(w,b)|0)|0;y=f|2;x=h+(aa(y,b)|0)|0;A=f|3;z=h+(aa(A,b)|0)|0;u=g+(f<<4)|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];k[u+8>>2]=k[t+8>>2];k[u+12>>2]=k[t+12>>2];w=g+(w<<4)|0;k[w>>2]=k[v>>2];k[w+4>>2]=k[v+4>>2];k[w+8>>2]=k[v+8>>2];k[w+12>>2]=k[v+12>>2];y=g+(y<<4)|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];k[y+8>>2]=k[x+8>>2];k[y+12>>2]=k[x+12>>2];A=g+(A<<4)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];f=f+4|0}while((f|0)<=(j|0));e=e+1|0}while((e|0)!=(r|0));return}do{g=c+(aa(e,d)|0)|0;h=a+(e<<4)|0;f=0;do{t=h+(aa(f,b)|0)|0;w=f|1;v=h+(aa(w,b)|0)|0;y=f|2;x=h+(aa(y,b)|0)|0;A=f|3;z=h+(aa(A,b)|0)|0;u=g+(f<<4)|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];k[u+8>>2]=k[t+8>>2];k[u+12>>2]=k[t+12>>2];w=g+(w<<4)|0;k[w>>2]=k[v>>2];k[w+4>>2]=k[v+4>>2];k[w+8>>2]=k[v+8>>2];k[w+12>>2]=k[v+12>>2];y=g+(y<<4)|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];k[y+8>>2]=k[x+8>>2];k[y+12>>2]=k[x+12>>2];A=g+(A<<4)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];f=f+4|0}while((f|0)<=(j|0));f=i;do{z=h+(aa(f,b)|0)|0;A=g+(f<<4)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];f=f+1|0}while((f|0)!=(q|0));e=e+1|0}while((e|0)!=(r|0));return}function l2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;r=k[e>>2]|0;q=k[e+4>>2]|0;p=r+-4|0;do if((r|0)<4)e=0;else{g=q+-4|0;if((q|0)<4){if((q|0)>0){e=0;do{g=c+(aa(e,d)|0)|0;h=c+(aa(e|1,d)|0)|0;i=c+(aa(e|2,d)|0)|0;j=c+(aa(e|3,d)|0)|0;l=a+(e*24|0)|0;f=0;do{n=l+(aa(f,b)|0)|0;o=g+(f*24|0)|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];k[o+8>>2]=k[n+8>>2];k[o+12>>2]=k[n+12>>2];k[o+16>>2]=k[n+16>>2];k[o+20>>2]=k[n+20>>2];o=h+(f*24|0)|0;m=n+24|0;k[o>>2]=k[m>>2];k[o+4>>2]=k[m+4>>2];k[o+8>>2]=k[m+8>>2];k[o+12>>2]=k[m+12>>2];k[o+16>>2]=k[m+16>>2];k[o+20>>2]=k[m+20>>2];o=i+(f*24|0)|0;m=n+48|0;k[o>>2]=k[m>>2];k[o+4>>2]=k[m+4>>2];k[o+8>>2]=k[m+8>>2];k[o+12>>2]=k[m+12>>2];k[o+16>>2]=k[m+16>>2];k[o+20>>2]=k[m+20>>2];o=j+(f*24|0)|0;n=n+72|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];k[o+8>>2]=k[n+8>>2];k[o+12>>2]=k[n+12>>2];k[o+16>>2]=k[n+16>>2];k[o+20>>2]=k[n+20>>2];f=f+1|0}while((f|0)!=(q|0));e=e+4|0}while((e|0)<=(p|0))}e=r&-4;break}h=q&-4;i=(h|0)<(q|0);f=0;do{j=c+(aa(f,d)|0)|0;l=c+(aa(f|1,d)|0)|0;m=c+(aa(f|2,d)|0)|0;n=c+(aa(f|3,d)|0)|0;o=a+(f*24|0)|0;e=0;do{z=o+(aa(e,b)|0)|0;w=e|1;x=o+(aa(w,b)|0)|0;u=e|2;v=o+(aa(u,b)|0)|0;s=e|3;t=o+(aa(s,b)|0)|0;y=j+(e*24|0)|0;k[y>>2]=k[z>>2];k[y+4>>2]=k[z+4>>2];k[y+8>>2]=k[z+8>>2];k[y+12>>2]=k[z+12>>2];k[y+16>>2]=k[z+16>>2];k[y+20>>2]=k[z+20>>2];y=j+(w*24|0)|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];k[y+8>>2]=k[x+8>>2];k[y+12>>2]=k[x+12>>2];k[y+16>>2]=k[x+16>>2];k[y+20>>2]=k[x+20>>2];y=j+(u*24|0)|0;k[y>>2]=k[v>>2];k[y+4>>2]=k[v+4>>2];k[y+8>>2]=k[v+8>>2];k[y+12>>2]=k[v+12>>2];k[y+16>>2]=k[v+16>>2];k[y+20>>2]=k[v+20>>2];y=j+(s*24|0)|0;k[y>>2]=k[t>>2];k[y+4>>2]=k[t+4>>2];k[y+8>>2]=k[t+8>>2];k[y+12>>2]=k[t+12>>2];k[y+16>>2]=k[t+16>>2];k[y+20>>2]=k[t+20>>2];y=l+(e*24|0)|0;A=z+24|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];y=l+(w*24|0)|0;A=x+24|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];y=l+(u*24|0)|0;A=v+24|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];y=l+(s*24|0)|0;A=t+24|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];y=m+(e*24|0)|0;A=z+48|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];y=m+(w*24|0)|0;A=x+48|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];y=m+(u*24|0)|0;A=v+48|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];y=m+(s*24|0)|0;A=t+48|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];y=n+(e*24|0)|0;z=z+72|0;k[y>>2]=k[z>>2];k[y+4>>2]=k[z+4>>2];k[y+8>>2]=k[z+8>>2];k[y+12>>2]=k[z+12>>2];k[y+16>>2]=k[z+16>>2];k[y+20>>2]=k[z+20>>2];w=n+(w*24|0)|0;x=x+72|0;k[w>>2]=k[x>>2];k[w+4>>2]=k[x+4>>2];k[w+8>>2]=k[x+8>>2];k[w+12>>2]=k[x+12>>2];k[w+16>>2]=k[x+16>>2];k[w+20>>2]=k[x+20>>2];u=n+(u*24|0)|0;v=v+72|0;k[u>>2]=k[v>>2];k[u+4>>2]=k[v+4>>2];k[u+8>>2]=k[v+8>>2];k[u+12>>2]=k[v+12>>2];k[u+16>>2]=k[v+16>>2];k[u+20>>2]=k[v+20>>2];s=n+(s*24|0)|0;t=t+72|0;k[s>>2]=k[t>>2];k[s+4>>2]=k[t+4>>2];k[s+8>>2]=k[t+8>>2];k[s+12>>2]=k[t+12>>2];k[s+16>>2]=k[t+16>>2];k[s+20>>2]=k[t+20>>2];e=e+4|0}while((e|0)<=(g|0));if(i){e=h;do{z=o+(aa(e,b)|0)|0;A=j+(e*24|0)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];k[A+16>>2]=k[z+16>>2];k[A+20>>2]=k[z+20>>2];A=l+(e*24|0)|0;y=z+24|0;k[A>>2]=k[y>>2];k[A+4>>2]=k[y+4>>2];k[A+8>>2]=k[y+8>>2];k[A+12>>2]=k[y+12>>2];k[A+16>>2]=k[y+16>>2];k[A+20>>2]=k[y+20>>2];A=m+(e*24|0)|0;y=z+48|0;k[A>>2]=k[y>>2];k[A+4>>2]=k[y+4>>2];k[A+8>>2]=k[y+8>>2];k[A+12>>2]=k[y+12>>2];k[A+16>>2]=k[y+16>>2];k[A+20>>2]=k[y+20>>2];A=n+(e*24|0)|0;z=z+72|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];k[A+16>>2]=k[z+16>>2];k[A+20>>2]=k[z+20>>2];e=e+1|0}while((e|0)!=(q|0))}f=f+4|0}while((f|0)<=(p|0));e=r&-4}while(0);if((e|0)>=(r|0))return;j=q+-4|0;if((q|0)<4){if((q|0)<=0)return;do{g=c+(aa(e,d)|0)|0;h=a+(e*24|0)|0;f=0;do{z=h+(aa(f,b)|0)|0;A=g+(f*24|0)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];k[A+16>>2]=k[z+16>>2];k[A+20>>2]=k[z+20>>2];f=f+1|0}while((f|0)!=(q|0));e=e+1|0}while((e|0)!=(r|0));return}i=q&-4;if((i|0)>=(q|0)){do{g=c+(aa(e,d)|0)|0;h=a+(e*24|0)|0;f=0;do{t=h+(aa(f,b)|0)|0;w=f|1;v=h+(aa(w,b)|0)|0;y=f|2;x=h+(aa(y,b)|0)|0;A=f|3;z=h+(aa(A,b)|0)|0;u=g+(f*24|0)|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];k[u+8>>2]=k[t+8>>2];k[u+12>>2]=k[t+12>>2];k[u+16>>2]=k[t+16>>2];k[u+20>>2]=k[t+20>>2];w=g+(w*24|0)|0;k[w>>2]=k[v>>2];k[w+4>>2]=k[v+4>>2];k[w+8>>2]=k[v+8>>2];k[w+12>>2]=k[v+12>>2];k[w+16>>2]=k[v+16>>2];k[w+20>>2]=k[v+20>>2];y=g+(y*24|0)|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];k[y+8>>2]=k[x+8>>2];k[y+12>>2]=k[x+12>>2];k[y+16>>2]=k[x+16>>2];k[y+20>>2]=k[x+20>>2];A=g+(A*24|0)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];k[A+16>>2]=k[z+16>>2];k[A+20>>2]=k[z+20>>2];f=f+4|0}while((f|0)<=(j|0));e=e+1|0}while((e|0)!=(r|0));return}do{g=c+(aa(e,d)|0)|0;h=a+(e*24|0)|0;f=0;do{t=h+(aa(f,b)|0)|0;w=f|1;v=h+(aa(w,b)|0)|0;y=f|2;x=h+(aa(y,b)|0)|0;A=f|3;z=h+(aa(A,b)|0)|0;u=g+(f*24|0)|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];k[u+8>>2]=k[t+8>>2];k[u+12>>2]=k[t+12>>2];k[u+16>>2]=k[t+16>>2];k[u+20>>2]=k[t+20>>2];w=g+(w*24|0)|0;k[w>>2]=k[v>>2];k[w+4>>2]=k[v+4>>2];k[w+8>>2]=k[v+8>>2];k[w+12>>2]=k[v+12>>2];k[w+16>>2]=k[v+16>>2];k[w+20>>2]=k[v+20>>2];y=g+(y*24|0)|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];k[y+8>>2]=k[x+8>>2];k[y+12>>2]=k[x+12>>2];k[y+16>>2]=k[x+16>>2];k[y+20>>2]=k[x+20>>2];A=g+(A*24|0)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];k[A+16>>2]=k[z+16>>2];k[A+20>>2]=k[z+20>>2];f=f+4|0}while((f|0)<=(j|0));f=i;do{z=h+(aa(f,b)|0)|0;A=g+(f*24|0)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];k[A+16>>2]=k[z+16>>2];k[A+20>>2]=k[z+20>>2];f=f+1|0}while((f|0)!=(q|0));e=e+1|0}while((e|0)!=(r|0));return}function m2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;r=k[e>>2]|0;q=k[e+4>>2]|0;p=r+-4|0;do if((r|0)<4)e=0;else{g=q+-4|0;if((q|0)<4){if((q|0)>0){e=0;do{g=c+(aa(e,d)|0)|0;h=c+(aa(e|1,d)|0)|0;i=c+(aa(e|2,d)|0)|0;j=c+(aa(e|3,d)|0)|0;l=a+(e<<5)|0;f=0;do{n=l+(aa(f,b)|0)|0;o=g+(f<<5)|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];k[o+8>>2]=k[n+8>>2];k[o+12>>2]=k[n+12>>2];k[o+16>>2]=k[n+16>>2];k[o+20>>2]=k[n+20>>2];k[o+24>>2]=k[n+24>>2];k[o+28>>2]=k[n+28>>2];o=h+(f<<5)|0;m=n+32|0;k[o>>2]=k[m>>2];k[o+4>>2]=k[m+4>>2];k[o+8>>2]=k[m+8>>2];k[o+12>>2]=k[m+12>>2];k[o+16>>2]=k[m+16>>2];k[o+20>>2]=k[m+20>>2];k[o+24>>2]=k[m+24>>2];k[o+28>>2]=k[m+28>>2];o=i+(f<<5)|0;m=n+64|0;k[o>>2]=k[m>>2];k[o+4>>2]=k[m+4>>2];k[o+8>>2]=k[m+8>>2];k[o+12>>2]=k[m+12>>2];k[o+16>>2]=k[m+16>>2];k[o+20>>2]=k[m+20>>2];k[o+24>>2]=k[m+24>>2];k[o+28>>2]=k[m+28>>2];o=j+(f<<5)|0;n=n+96|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];k[o+8>>2]=k[n+8>>2];k[o+12>>2]=k[n+12>>2];k[o+16>>2]=k[n+16>>2];k[o+20>>2]=k[n+20>>2];k[o+24>>2]=k[n+24>>2];k[o+28>>2]=k[n+28>>2];f=f+1|0}while((f|0)!=(q|0));e=e+4|0}while((e|0)<=(p|0))}e=r&-4;break}h=q&-4;i=(h|0)<(q|0);f=0;do{j=c+(aa(f,d)|0)|0;l=c+(aa(f|1,d)|0)|0;m=c+(aa(f|2,d)|0)|0;n=c+(aa(f|3,d)|0)|0;o=a+(f<<5)|0;e=0;do{z=o+(aa(e,b)|0)|0;w=e|1;x=o+(aa(w,b)|0)|0;u=e|2;v=o+(aa(u,b)|0)|0;s=e|3;t=o+(aa(s,b)|0)|0;y=j+(e<<5)|0;k[y>>2]=k[z>>2];k[y+4>>2]=k[z+4>>2];k[y+8>>2]=k[z+8>>2];k[y+12>>2]=k[z+12>>2];k[y+16>>2]=k[z+16>>2];k[y+20>>2]=k[z+20>>2];k[y+24>>2]=k[z+24>>2];k[y+28>>2]=k[z+28>>2];y=j+(w<<5)|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];k[y+8>>2]=k[x+8>>2];k[y+12>>2]=k[x+12>>2];k[y+16>>2]=k[x+16>>2];k[y+20>>2]=k[x+20>>2];k[y+24>>2]=k[x+24>>2];k[y+28>>2]=k[x+28>>2];y=j+(u<<5)|0;k[y>>2]=k[v>>2];k[y+4>>2]=k[v+4>>2];k[y+8>>2]=k[v+8>>2];k[y+12>>2]=k[v+12>>2];k[y+16>>2]=k[v+16>>2];k[y+20>>2]=k[v+20>>2];k[y+24>>2]=k[v+24>>2];k[y+28>>2]=k[v+28>>2];y=j+(s<<5)|0;k[y>>2]=k[t>>2];k[y+4>>2]=k[t+4>>2];k[y+8>>2]=k[t+8>>2];k[y+12>>2]=k[t+12>>2];k[y+16>>2]=k[t+16>>2];k[y+20>>2]=k[t+20>>2];k[y+24>>2]=k[t+24>>2];k[y+28>>2]=k[t+28>>2];y=l+(e<<5)|0;A=z+32|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];k[y+24>>2]=k[A+24>>2];k[y+28>>2]=k[A+28>>2];y=l+(w<<5)|0;A=x+32|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];k[y+24>>2]=k[A+24>>2];k[y+28>>2]=k[A+28>>2];y=l+(u<<5)|0;A=v+32|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];k[y+24>>2]=k[A+24>>2];k[y+28>>2]=k[A+28>>2];y=l+(s<<5)|0;A=t+32|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];k[y+24>>2]=k[A+24>>2];k[y+28>>2]=k[A+28>>2];y=m+(e<<5)|0;A=z+64|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];k[y+24>>2]=k[A+24>>2];k[y+28>>2]=k[A+28>>2];y=m+(w<<5)|0;A=x+64|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];k[y+24>>2]=k[A+24>>2];k[y+28>>2]=k[A+28>>2];y=m+(u<<5)|0;A=v+64|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];k[y+24>>2]=k[A+24>>2];k[y+28>>2]=k[A+28>>2];y=m+(s<<5)|0;A=t+64|0;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2];k[y+20>>2]=k[A+20>>2];k[y+24>>2]=k[A+24>>2];k[y+28>>2]=k[A+28>>2];y=n+(e<<5)|0;z=z+96|0;k[y>>2]=k[z>>2];k[y+4>>2]=k[z+4>>2];k[y+8>>2]=k[z+8>>2];k[y+12>>2]=k[z+12>>2];k[y+16>>2]=k[z+16>>2];k[y+20>>2]=k[z+20>>2];k[y+24>>2]=k[z+24>>2];k[y+28>>2]=k[z+28>>2];w=n+(w<<5)|0;x=x+96|0;k[w>>2]=k[x>>2];k[w+4>>2]=k[x+4>>2];k[w+8>>2]=k[x+8>>2];k[w+12>>2]=k[x+12>>2];k[w+16>>2]=k[x+16>>2];k[w+20>>2]=k[x+20>>2];k[w+24>>2]=k[x+24>>2];k[w+28>>2]=k[x+28>>2];u=n+(u<<5)|0;v=v+96|0;k[u>>2]=k[v>>2];k[u+4>>2]=k[v+4>>2];k[u+8>>2]=k[v+8>>2];k[u+12>>2]=k[v+12>>2];k[u+16>>2]=k[v+16>>2];k[u+20>>2]=k[v+20>>2];k[u+24>>2]=k[v+24>>2];k[u+28>>2]=k[v+28>>2];s=n+(s<<5)|0;t=t+96|0;k[s>>2]=k[t>>2];k[s+4>>2]=k[t+4>>2];k[s+8>>2]=k[t+8>>2];k[s+12>>2]=k[t+12>>2];k[s+16>>2]=k[t+16>>2];k[s+20>>2]=k[t+20>>2];k[s+24>>2]=k[t+24>>2];k[s+28>>2]=k[t+28>>2];e=e+4|0}while((e|0)<=(g|0));if(i){e=h;do{z=o+(aa(e,b)|0)|0;A=j+(e<<5)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];k[A+16>>2]=k[z+16>>2];k[A+20>>2]=k[z+20>>2];k[A+24>>2]=k[z+24>>2];k[A+28>>2]=k[z+28>>2];A=l+(e<<5)|0;y=z+32|0;k[A>>2]=k[y>>2];k[A+4>>2]=k[y+4>>2];k[A+8>>2]=k[y+8>>2];k[A+12>>2]=k[y+12>>2];k[A+16>>2]=k[y+16>>2];k[A+20>>2]=k[y+20>>2];k[A+24>>2]=k[y+24>>2];k[A+28>>2]=k[y+28>>2];A=m+(e<<5)|0;y=z+64|0;k[A>>2]=k[y>>2];k[A+4>>2]=k[y+4>>2];k[A+8>>2]=k[y+8>>2];k[A+12>>2]=k[y+12>>2];k[A+16>>2]=k[y+16>>2];k[A+20>>2]=k[y+20>>2];k[A+24>>2]=k[y+24>>2];k[A+28>>2]=k[y+28>>2];A=n+(e<<5)|0;z=z+96|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];k[A+16>>2]=k[z+16>>2];k[A+20>>2]=k[z+20>>2];k[A+24>>2]=k[z+24>>2];k[A+28>>2]=k[z+28>>2];e=e+1|0}while((e|0)!=(q|0))}f=f+4|0}while((f|0)<=(p|0));e=r&-4}while(0);if((e|0)>=(r|0))return;j=q+-4|0;if((q|0)<4){if((q|0)<=0)return;do{g=c+(aa(e,d)|0)|0;h=a+(e<<5)|0;f=0;do{z=h+(aa(f,b)|0)|0;A=g+(f<<5)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];k[A+16>>2]=k[z+16>>2];k[A+20>>2]=k[z+20>>2];k[A+24>>2]=k[z+24>>2];k[A+28>>2]=k[z+28>>2];f=f+1|0}while((f|0)!=(q|0));e=e+1|0}while((e|0)!=(r|0));return}i=q&-4;if((i|0)>=(q|0)){do{g=c+(aa(e,d)|0)|0;h=a+(e<<5)|0;f=0;do{t=h+(aa(f,b)|0)|0;w=f|1;v=h+(aa(w,b)|0)|0;y=f|2;x=h+(aa(y,b)|0)|0;A=f|3;z=h+(aa(A,b)|0)|0;u=g+(f<<5)|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];k[u+8>>2]=k[t+8>>2];k[u+12>>2]=k[t+12>>2];k[u+16>>2]=k[t+16>>2];k[u+20>>2]=k[t+20>>2];k[u+24>>2]=k[t+24>>2];k[u+28>>2]=k[t+28>>2];w=g+(w<<5)|0;k[w>>2]=k[v>>2];k[w+4>>2]=k[v+4>>2];k[w+8>>2]=k[v+8>>2];k[w+12>>2]=k[v+12>>2];k[w+16>>2]=k[v+16>>2];k[w+20>>2]=k[v+20>>2];k[w+24>>2]=k[v+24>>2];k[w+28>>2]=k[v+28>>2];y=g+(y<<5)|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];k[y+8>>2]=k[x+8>>2];k[y+12>>2]=k[x+12>>2];k[y+16>>2]=k[x+16>>2];k[y+20>>2]=k[x+20>>2];k[y+24>>2]=k[x+24>>2];k[y+28>>2]=k[x+28>>2];A=g+(A<<5)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];k[A+16>>2]=k[z+16>>2];k[A+20>>2]=k[z+20>>2];k[A+24>>2]=k[z+24>>2];k[A+28>>2]=k[z+28>>2];f=f+4|0}while((f|0)<=(j|0));e=e+1|0}while((e|0)!=(r|0));return}do{g=c+(aa(e,d)|0)|0;h=a+(e<<5)|0;f=0;do{t=h+(aa(f,b)|0)|0;w=f|1;v=h+(aa(w,b)|0)|0;y=f|2;x=h+(aa(y,b)|0)|0;A=f|3;z=h+(aa(A,b)|0)|0;u=g+(f<<5)|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];k[u+8>>2]=k[t+8>>2];k[u+12>>2]=k[t+12>>2];k[u+16>>2]=k[t+16>>2];k[u+20>>2]=k[t+20>>2];k[u+24>>2]=k[t+24>>2];k[u+28>>2]=k[t+28>>2];w=g+(w<<5)|0;k[w>>2]=k[v>>2];k[w+4>>2]=k[v+4>>2];k[w+8>>2]=k[v+8>>2];k[w+12>>2]=k[v+12>>2];k[w+16>>2]=k[v+16>>2];k[w+20>>2]=k[v+20>>2];k[w+24>>2]=k[v+24>>2];k[w+28>>2]=k[v+28>>2];y=g+(y<<5)|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];k[y+8>>2]=k[x+8>>2];k[y+12>>2]=k[x+12>>2];k[y+16>>2]=k[x+16>>2];k[y+20>>2]=k[x+20>>2];k[y+24>>2]=k[x+24>>2];k[y+28>>2]=k[x+28>>2];A=g+(A<<5)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];k[A+16>>2]=k[z+16>>2];k[A+20>>2]=k[z+20>>2];k[A+24>>2]=k[z+24>>2];k[A+28>>2]=k[z+28>>2];f=f+4|0}while((f|0)<=(j|0));f=i;do{z=h+(aa(f,b)|0)|0;A=g+(f<<5)|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];k[A+8>>2]=k[z+8>>2];k[A+12>>2]=k[z+12>>2];k[A+16>>2]=k[z+16>>2];k[A+20>>2]=k[z+20>>2];k[A+24>>2]=k[z+24>>2];k[A+28>>2]=k[z+28>>2];f=f+1|0}while((f|0)!=(q|0));e=e+1|0}while((e|0)!=(r|0));return}function n2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;if((c|0)>0)e=0;else return;do{f=a+(aa(e,b)|0)|0;g=a+e|0;e=e+1|0;if((e|0)<(c|0)){d=e;do{k=f+d|0;h=g+(aa(d,b)|0)|0;j=i[k>>0]|0;i[k>>0]=i[h>>0]|0;i[h>>0]=j;d=d+1|0}while((d|0)!=(c|0))}}while((e|0)!=(c|0));return}function o2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,k=0;if((c|0)>0)e=0;else return;do{f=a+(aa(e,b)|0)|0;g=a+(e<<1)|0;e=e+1|0;if((e|0)<(c|0)){d=e;do{k=f+(d<<1)|0;h=g+(aa(d,b)|0)|0;i=j[k>>1]|0;j[k>>1]=j[h>>1]|0;j[h>>1]=i;d=d+1|0}while((d|0)!=(c|0))}}while((e|0)!=(c|0));return}function p2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;if((c|0)>0)e=0;else return;do{f=a+(aa(e,b)|0)|0;g=a+(e*3|0)|0;e=e+1|0;if((e|0)<(c|0)){d=e;do{h=g+(aa(d,b)|0)|0;m=f+(d*3|0)|0;l=i[m>>0]|0;k=i[f+(d*3|0)+1>>0]|0;j=i[f+(d*3|0)+2>>0]|0;i[m>>0]=i[h>>0]|0;i[m+1>>0]=i[h+1>>0]|0;i[m+2>>0]=i[h+2>>0]|0;i[h>>0]=l;i[h+1>>0]=k;i[h+2>>0]=j;d=d+1|0}while((d|0)!=(c|0))}}while((e|0)!=(c|0));return}function q2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;if((c|0)>0)e=0;else return;do{f=a+(aa(e,b)|0)|0;g=a+(e<<2)|0;e=e+1|0;if((e|0)<(c|0)){d=e;do{j=f+(d<<2)|0;h=g+(aa(d,b)|0)|0;i=k[j>>2]|0;k[j>>2]=k[h>>2];k[h>>2]=i;d=d+1|0}while((d|0)!=(c|0))}}while((e|0)!=(c|0));return}function r2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0;if((c|0)>0)e=0;else return;do{f=a+(aa(e,b)|0)|0;g=a+(e*6|0)|0;e=e+1|0;if((e|0)<(c|0)){d=e;do{m=f+(d*6|0)|0;h=g+(aa(d,b)|0)|0;l=j[m>>1]|0;k=j[f+(d*6|0)+2>>1]|0;i=j[f+(d*6|0)+4>>1]|0;j[m>>1]=j[h>>1]|0;j[m+2>>1]=j[h+2>>1]|0;j[m+4>>1]=j[h+4>>1]|0;j[h>>1]=l;j[h+2>>1]=k;j[h+4>>1]=i;d=d+1|0}while((d|0)!=(c|0))}}while((e|0)!=(c|0));return}function s2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;if((c|0)>0)e=0;else return;do{f=a+(aa(e,b)|0)|0;g=a+(e<<3)|0;e=e+1|0;if((e|0)<(c|0)){d=e;do{l=f+(d<<3)|0;h=g+(aa(d,b)|0)|0;j=k[l>>2]|0;i=k[f+(d<<3)+4>>2]|0;n=h;m=k[n+4>>2]|0;k[l>>2]=k[n>>2];k[l+4>>2]=m;k[h>>2]=j;k[h+4>>2]=i;d=d+1|0}while((d|0)!=(c|0))}}while((e|0)!=(c|0));return}function t2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;if((c|0)>0)e=0;else return;do{f=a+(aa(e,b)|0)|0;g=a+(e*12|0)|0;e=e+1|0;if((e|0)<(c|0)){d=e;do{m=f+(d*12|0)|0;h=g+(aa(d,b)|0)|0;l=k[m>>2]|0;j=k[f+(d*12|0)+4>>2]|0;i=k[f+(d*12|0)+8>>2]|0;k[m>>2]=k[h>>2];k[m+4>>2]=k[h+4>>2];k[m+8>>2]=k[h+8>>2];k[h>>2]=l;k[h+4>>2]=j;k[h+8>>2]=i;d=d+1|0}while((d|0)!=(c|0))}}while((e|0)!=(c|0));return}function u2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;if((c|0)>0)e=0;else return;do{f=a+(aa(e,b)|0)|0;g=a+(e<<4)|0;e=e+1|0;if((e|0)<(c|0)){d=e;do{n=f+(d<<4)|0;h=g+(aa(d,b)|0)|0;m=k[n>>2]|0;l=k[f+(d<<4)+4>>2]|0;j=k[f+(d<<4)+8>>2]|0;i=k[f+(d<<4)+12>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=k[h+4>>2];k[n+8>>2]=k[h+8>>2];k[n+12>>2]=k[h+12>>2];k[h>>2]=m;k[h+4>>2]=l;k[h+8>>2]=j;k[h+12>>2]=i;d=d+1|0}while((d|0)!=(c|0))}}while((e|0)!=(c|0));return}function v2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;if((c|0)>0)e=0;else return;do{f=a+(aa(e,b)|0)|0;g=a+(e*24|0)|0;e=e+1|0;if((e|0)<(c|0)){d=e;do{p=f+(d*24|0)|0;h=g+(aa(d,b)|0)|0;o=k[p>>2]|0;n=k[f+(d*24|0)+4>>2]|0;m=k[f+(d*24|0)+8>>2]|0;l=k[f+(d*24|0)+12>>2]|0;j=k[f+(d*24|0)+16>>2]|0;i=k[f+(d*24|0)+20>>2]|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2];k[p+12>>2]=k[h+12>>2];k[p+16>>2]=k[h+16>>2];k[p+20>>2]=k[h+20>>2];k[h>>2]=o;k[h+4>>2]=n;k[h+8>>2]=m;k[h+12>>2]=l;k[h+16>>2]=j;k[h+20>>2]=i;d=d+1|0}while((d|0)!=(c|0))}}while((e|0)!=(c|0));return}function w2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((c|0)>0)e=0;else return;do{f=a+(aa(e,b)|0)|0;g=a+(e<<5)|0;e=e+1|0;if((e|0)<(c|0)){d=e;do{r=f+(d<<5)|0;h=g+(aa(d,b)|0)|0;q=k[r>>2]|0;p=k[f+(d<<5)+4>>2]|0;o=k[f+(d<<5)+8>>2]|0;n=k[f+(d<<5)+12>>2]|0;m=k[f+(d<<5)+16>>2]|0;l=k[f+(d<<5)+20>>2]|0;j=k[f+(d<<5)+24>>2]|0;i=k[f+(d<<5)+28>>2]|0;k[r>>2]=k[h>>2];k[r+4>>2]=k[h+4>>2];k[r+8>>2]=k[h+8>>2];k[r+12>>2]=k[h+12>>2];k[r+16>>2]=k[h+16>>2];k[r+20>>2]=k[h+20>>2];k[r+24>>2]=k[h+24>>2];k[r+28>>2]=k[h+28>>2];k[h>>2]=q;k[h+4>>2]=p;k[h+8>>2]=o;k[h+12>>2]=n;k[h+16>>2]=m;k[h+20>>2]=l;k[h+24>>2]=j;k[h+28>>2]=i;d=d+1|0}while((d|0)!=(c|0))}}while((e|0)!=(c|0));return}function x2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;l=m;e=k[a>>2]|0;f=e&2031616;a:do if((f|0)<524288){if((f|0)>=458752){switch(f|0){case 458752:break;default:break a}if(d)break;if((e&1073741824|0)!=0?(j=k[a+4>>2]|0,!((k[b>>2]|0)==(k[j+12>>2]|0)?(k[b+4>>2]|0)==(k[j+8>>2]|0):0)):0){e=l+4|0;d=ZT(56)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[e>>2]=50;i[d+54>>0]=0;h=219816;j=g+50|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,l,389997,216975,2211);k[e>>2]=0;k[l>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);e=k[a>>2]|0}if((e|0)<0?(k[(k[a+4>>2]|0)+16>>2]|0)!=(c|0):0){e=l+4|0;d=ZT(60)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[e>>2]=52;i[d+56>>0]=0;h=219466;j=g+52|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,l,389997,216975,2212);k[e>>2]=0;k[l>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}R4(k[b+4>>2]|0,k[b>>2]|0,c,34962,0);r=m;return}switch(f|0){case 65536:break;default:break a}if(!d){f=a+4|0;if((e&1073741824|0)!=0?(j=k[(k[f>>2]|0)+40>>2]|0,!((k[b>>2]|0)==(k[j+4>>2]|0)?(k[b+4>>2]|0)==(k[j>>2]|0):0)):0){e=l+4|0;d=ZT(60)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[e>>2]=53;i[d+57>>0]=0;h=219655;j=g+53|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,l,389997,216975,2190);k[e>>2]=0;k[l>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);e=k[a>>2]|0}if((e|0)<0?(k[k[f>>2]>>2]&4095|0)!=(c|0):0){e=l+4|0;d=ZT(52)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[e>>2]=44;i[d+48>>0]=0;h=219118;j=g+44|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,l,389997,216975,2191);k[e>>2]=0;k[l>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}f=k[f>>2]|0;a=k[b>>2]|0;d=k[b+4>>2]|0;e=c&4095;if(((((k[f+4>>2]|0)<3?(k[f+8>>2]|0)==(d|0):0)?(k[f+12>>2]|0)==(a|0):0)?(k[f>>2]&4095|0)==(e|0):0)?k[f+16>>2]|0:0){r=m;return}k[l>>2]=d;k[l+4>>2]=a;G1(f,2,l,e);r=m;return}}else{if((f|0)<589824){switch(f|0){case 524288:break;default:break a}if(d)break;if((e&1073741824|0)!=0?(j=k[a+4>>2]|0,!((k[b>>2]|0)==(k[j+8>>2]|0)?(k[b+4>>2]|0)==(k[j+4>>2]|0):0)):0){e=l+4|0;d=ZT(60)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[e>>2]=52;i[d+56>>0]=0;h=219867;j=g+52|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,l,389997,216975,2218);k[e>>2]=0;k[l>>2]=0;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);e=k[a>>2]|0}if((e|0)<0?(k[k[a+4>>2]>>2]&4095|0)!=(c|0):0){e=l+4|0;d=ZT(60)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[e>>2]=54;i[d+58>>0]=0;h=219587;j=g+54|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,l,389997,216975,2219);k[e>>2]=0;k[l>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}R9();r=m;return}if((f|0)<655360){switch(f|0){case 589824:break;default:break a}if(d)break;if((e&1073741824|0)!=0?(j=k[a+4>>2]|0,!((k[b>>2]|0)==(k[j+8>>2]|0)?(k[b+4>>2]|0)==(k[j+4>>2]|0):0)):0){e=l+4|0;d=ZT(56)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[e>>2]=51;i[d+55>>0]=0;h=219764;j=g+51|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,l,389997,216975,2204);k[e>>2]=0;k[l>>2]=0;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);e=k[a>>2]|0}if((e|0)<0?(k[k[a+4>>2]>>2]&4095|0)!=(c|0):0){e=l+4|0;d=ZT(60)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[e>>2]=53;i[d+57>>0]=0;h=219346;j=g+53|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,l,389997,216975,2205);k[e>>2]=0;k[l>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}Q9();r=m;return}switch(f|0){case 655360:break;default:break a}if(!d){f=a+4|0;if((e&1073741824|0)!=0?(j=k[(k[f>>2]|0)+32>>2]|0,!((k[b>>2]|0)==(k[j+4>>2]|0)?(k[b+4>>2]|0)==(k[j>>2]|0):0)):0){e=l+4|0;d=ZT(60)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[e>>2]=54;i[d+58>>0]=0;h=219709;j=g+54|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,l,389997,216975,2197);k[e>>2]=0;k[l>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);e=k[a>>2]|0}if((e|0)<0?(k[k[f>>2]>>2]&4095|0)!=(c|0):0){e=l+4|0;d=ZT(52)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[e>>2]=45;i[d+49>>0]=0;h=219233;j=g+45|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,l,389997,216975,2198);k[e>>2]=0;k[l>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}a=k[f>>2]|0;f=k[b>>2]|0;d=k[b+4>>2]|0;e=c&4095;if(((((k[a+4>>2]|0)<3?(k[a+8>>2]|0)==(d|0):0)?(k[a+12>>2]|0)==(f|0):0)?(k[a>>2]&4095|0)==(e|0):0)?k[a+24>>2]|0:0){r=m;return}k[l>>2]=d;k[l+4>>2]=f;v9(a,2,l,e);r=m;return}}while(0);k[l>>2]=k[b+4>>2];k[l+4>>2]=k[b>>2];P1(a,2,l,c,-1,d,0);r=m;return}function y2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;h=k[a>>2]|0;if(!((c|0)<1|(h&7|0)==(c|0))){h=-1;return h|0}f=h&16384;if(!((f|0)!=0|d^1)){h=-1;return h|0}a:do switch(k[a+4>>2]|0){case 2:{c=k[a+8>>2]|0;if((c|0)!=1?(e=k[a+12>>2]|0,(e|0)!=1):0)g=7;else{e=k[a+12>>2]|0;if(((h>>>3&511)+1|0)!=(b|0))g=7}if((g|0)==7)if((e|0)==(b|0)&(h&4088|0)==0)e=b;else{h=-1;return h|0}e=aa(e,c)|0;break}case 3:{if(h&4088|0){h=-1;return h|0}g=k[a+40>>2]|0;if((k[g+8>>2]|0)!=(b|0)){h=-1;return h|0}c=k[g>>2]|0;if((c|0)!=1?(k[g+4>>2]|0)!=1:0){h=-1;return h|0}if((f|0)==0?(a=k[a+44>>2]|0,(k[a+4>>2]|0)!=(aa(k[a+8>>2]|0,b)|0)):0){h=-1;return h|0}else{d=0;e=1}while(1){e=aa(c,e)|0;c=d+1|0;if((c|0)==3)break a;d=c;c=k[g+(c<<2)>>2]|0}}default:{h=-1;return h|0}}while(0);h=((aa((h>>>3&511)+1|0,e)|0)>>>0)/(b>>>0)|0;return h|0}function z2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=(c>>>3&511)+1|0;if(h>>>0>=5?(m=g+4|0,e=ZT(12)|0,k[e>>2]=1,n=e+4|0,k[g>>2]=n,k[m>>2]=7,i[e+11>>0]=0,i[n>>0]=i[219925]|0,i[n+1>>0]=i[219926]|0,i[n+2>>0]=i[219927]|0,i[n+3>>0]=i[219928]|0,i[n+4>>0]=i[219929]|0,i[n+5>>0]=i[219930]|0,i[n+6>>0]=i[219931]|0,Y8(-215,g,219933,216975,1052),k[m>>2]=0,k[g>>2]=0,m=k[e>>2]|0,k[e>>2]=m+-1,(m|0)==1):0)ggb(k[e+-4>>2]|0);switch(c&7){case 0:{c=0;do{f=+p[a+(c<<3)>>3];p[u>>3]=f;e=k[u+4>>2]|0;n=e&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){e=(e|0)<0;f=e?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=e?-0.0:0.0}n=~~f;i[b+c>>0]=n>>>0<256?n:(n|0)>0?255:0;c=c+1|0}while((c|0)!=(h|0));if((h|0)<(d|0))e=h;else{r=l;return}do{i[b+e>>0]=i[b+(e-h)>>0]|0;e=e+1|0}while((e|0)!=(d|0));r=l;return}case 1:{c=0;do{f=+p[a+(c<<3)>>3];p[u>>3]=f;e=k[u+4>>2]|0;n=e&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){e=(e|0)<0;f=e?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=e?-0.0:0.0}n=~~f;i[b+c>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;c=c+1|0}while((c|0)!=(h|0));if((h|0)<(d|0))e=h;else{r=l;return}do{i[b+e>>0]=i[b+(e-h)>>0]|0;e=e+1|0}while((e|0)!=(d|0));r=l;return}case 2:{c=0;do{f=+p[a+(c<<3)>>3];p[u>>3]=f;e=k[u+4>>2]|0;n=e&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){e=(e|0)<0;f=e?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=e?-0.0:0.0}n=~~f;j[b+(c<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;c=c+1|0}while((c|0)!=(h|0));if((h|0)<(d|0))e=h;else{r=l;return}do{j[b+(e<<1)>>1]=j[b+(e-h<<1)>>1]|0;e=e+1|0}while((e|0)!=(d|0));r=l;return}case 3:{c=0;do{f=+p[a+(c<<3)>>3];p[u>>3]=f;e=k[u+4>>2]|0;n=e&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){e=(e|0)<0;f=e?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=e?-0.0:0.0}n=~~f;j[b+(c<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;c=c+1|0}while((c|0)!=(h|0));if((h|0)<(d|0))e=h;else{r=l;return}do{j[b+(e<<1)>>1]=j[b+(e-h<<1)>>1]|0;e=e+1|0}while((e|0)!=(d|0));r=l;return}case 4:{c=0;do{f=+p[a+(c<<3)>>3];p[u>>3]=f;e=k[u+4>>2]|0;n=e&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){e=(e|0)<0;f=e?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=e?-0.0:0.0}k[b+(c<<2)>>2]=~~f;c=c+1|0}while((c|0)!=(h|0));if((h|0)<(d|0))e=h;else{r=l;return}do{k[b+(e<<2)>>2]=k[b+(e-h<<2)>>2];e=e+1|0}while((e|0)!=(d|0));r=l;return}case 5:{e=0;do{o[b+(e<<2)>>2]=+p[a+(e<<3)>>3];e=e+1|0}while((e|0)!=(h|0));if((h|0)<(d|0))e=h;else{r=l;return}do{k[b+(e<<2)>>2]=k[b+(e-h<<2)>>2];e=e+1|0}while((e|0)!=(d|0));r=l;return}case 6:{e=0;do{p[b+(e<<3)>>3]=+p[a+(e<<3)>>3];e=e+1|0}while((e|0)!=(h|0));if((h|0)<(d|0))e=h;else{r=l;return}do{p[b+(e<<3)>>3]=+p[b+(e-h<<3)>>3];e=e+1|0}while((e|0)!=(d|0));r=l;return}default:{n=g+4|0;e=ZT(8)|0;k[e>>2]=1;m=e+4|0;k[g>>2]=m;k[n>>2]=0;i[m>>0]=0;Y8(-210,g,219933,216975,1119);k[n>>2]=0;k[g>>2]=0;n=k[e>>2]|0;k[e>>2]=n+-1;if((n|0)==1)ggb(k[e+-4>>2]|0);r=l;return}}}function A2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+64|0;h=l+56|0;f=l;c=k[b>>2]|0;d=c&2031616;c=c&50331648;e=d&2097151;a:do if((e|0)<655360){switch(e|0){case 65536:break;default:break a}t9(a,k[b+4>>2]|0,c);r=l;return}else{if((e|0)<720896){switch(e|0){case 655360:break;default:break a}g=k[b+4>>2]|0;k[a>>2]=k[g>>2];j=a+4|0;b=g+4|0;k[j>>2]=k[b>>2];f=a+8|0;k[f>>2]=k[g+8>>2];k[a+12>>2]=k[g+12>>2];k[a+16>>2]=k[g+16>>2];k[a+20>>2]=k[g+20>>2];c=k[g+24>>2]|0;k[a+24>>2]=c;k[a+28>>2]=k[g+28>>2];d=a+32|0;k[d>>2]=f;f=a+40|0;h=a+36|0;k[h>>2]=f;k[a+44>>2]=0;k[f>>2]=0;if(c|0){f=c+8|0;k[f>>2]=(k[f>>2]|0)+1}if((k[b>>2]|0)<3){j=k[g+36>>2]|0;a=k[h>>2]|0;k[a>>2]=k[j>>2];k[a+4>>2]=k[j+4>>2];r=l;return}k[j>>2]=0;s9(a,k[b>>2]|0,0,0,0);if((k[j>>2]|0)<=0){r=l;return}f=k[g+32>>2]|0;e=k[d>>2]|0;d=k[g+36>>2]|0;c=k[h>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0));r=l;return}switch(e|0){case 720896:break;default:break a}b=k[b+4>>2]|0;c=h+4|0;d=ZT(32)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=27;i[d+31>>0]=0;f=217909;g=e+27|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,h,233265,216975,1257);k[c>>2]=0;k[h>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);f=k[b>>2]|0;k[a>>2]=k[f+-48>>2];j=a+4|0;b=f+-44|0;k[j>>2]=k[b>>2];g=a+8|0;k[g>>2]=k[f+-40>>2];k[a+12>>2]=k[f+-36>>2];k[a+16>>2]=k[f+-32>>2];k[a+20>>2]=k[f+-28>>2];c=k[f+-24>>2]|0;k[a+24>>2]=c;k[a+28>>2]=k[f+-20>>2];d=a+32|0;k[d>>2]=g;g=a+40|0;h=a+36|0;k[h>>2]=g;k[a+44>>2]=0;k[g>>2]=0;if(c|0){g=c+8|0;k[g>>2]=(k[g>>2]|0)+1}if((k[b>>2]|0)<3){j=k[f+-12>>2]|0;a=k[h>>2]|0;k[a>>2]=k[j>>2];k[a+4>>2]=k[j+4>>2];r=l;return}k[j>>2]=0;s9(a,k[b>>2]|0,0,0,0);if((k[j>>2]|0)<=0){r=l;return}g=k[f+-16>>2]|0;e=k[d>>2]|0;d=k[f+-12>>2]|0;c=k[h>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[g+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0));r=l;return}while(0);if((d|0)==65536)AF(f,k[b+4>>2]|0);else Q1(f,b,-1);t9(a,f,c);d=f+36|0;b=k[d>>2]|0;if(b|0?(j=b+12|0,a=k[j>>2]|0,k[j>>2]=a+-1,(a|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[f+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;a=f+16|0;c=f+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[c>>2]|0)>0){d=k[f+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[f+44>>2]|0;if((b|0)==(f+48|0)|(b|0)==0){r=l;return}ggb(k[b+-4>>2]|0);r=l;return}function B2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+240|0;I=J+176|0;H=J+120|0;t=J+56|0;u=J;E=J+112|0;d=k[a>>2]|0;q=d&50331648;c=d&2031616;a:do if((c|0)<262144){if((c|0)>=131072)if((c|0)<196608){switch(c|0){case 131072:break;default:break a}s=k[a+12>>2]|0;f=(d>>>3&511)+1<<(47696>>>(d<<1&14)&3);Y1(b,s);if(!s){r=J;return}g=a+8|0;h=a+4|0;j=I+36|0;l=I+16|0;m=I+4|0;n=I+40|0;o=I+44|0;p=I+48|0;q=I+32|0;e=0;do{c=(k[b>>2]|0)+(e*56|0)|0;H=k[g>>2]|0;JN(I,1,H,k[a>>2]&4095,(k[h>>2]|0)+(aa(aa(e,f)|0,H)|0)|0,0);KG(c,I)|0;c=k[j>>2]|0;if(c|0?(G=c+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){d=k[j>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q>>2]|0;if(!c){c=B1()|0;d=k[j>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[j>>2]=0}k[j>>2]=0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[m>>2]|0)>0){d=k[n>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[m>>2]|0))}c=k[o>>2]|0;if(!((c|0)==(p|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=e+1|0}while(e>>>0<s>>>0);r=J;return}else{switch(c|0){case 196608:break;default:break a}q=k[a+4>>2]|0;s=(k[q+4>>2]|0)-(k[q>>2]|0)|0;t=(d>>>3&511)+1|0;f=d&7;g=t<<(47696>>>(f<<1)&3);Y1(b,s);if(!s){r=J;return}h=I+36|0;j=I+16|0;l=I+4|0;m=I+40|0;n=I+44|0;o=I+48|0;p=I+32|0;e=0;do{c=(k[b>>2]|0)+(e*56|0)|0;JN(I,1,t,f,(k[q>>2]|0)+(aa(e,g)|0)|0,0);KG(c,I)|0;c=k[h>>2]|0;if(c|0?(a=c+12|0,H=k[a>>2]|0,k[a>>2]=H+-1,(H|0)==1):0){d=k[h>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[p>>2]|0;if(!c){c=B1()|0;d=k[h>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[h>>2]=0}k[h>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[l>>2]|0)>0){d=k[m>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[l>>2]|0))}c=k[n>>2]|0;if(!((c|0)==(o|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=e+1|0}while(e>>>0<s>>>0);r=J;return}if((c|0)<65536){switch(c|0){case 0:break;default:break a}h=k[b>>2]|0;g=b+4|0;c=k[g>>2]|0;if((c|0)==(h|0)){r=J;return}do{k[g>>2]=c+-56;f=c+-20|0;d=k[f>>2]|0;if(d|0?(I=d+12|0,b=k[I>>2]|0,k[I>>2]=b+-1,(b|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[c+-24>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;b=c+-40|0;e=c+-52|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[e>>2]|0)>0){f=k[c+-16>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[c+-12>>2]|0;if(!((d|0)==(c+-8|0)|(d|0)==0))ggb(k[d+-4>>2]|0);c=k[g>>2]|0}while((c|0)!=(h|0));r=J;return}switch(c|0){case 65536:break;default:break a}l=k[a+4>>2]|0;m=l+40|0;n=k[k[m>>2]>>2]|0;Y1(b,n);if((n|0)<=0){r=J;return}o=l+4|0;p=l+12|0;q=l+16|0;s=l+44|0;t=I+36|0;u=I+16|0;v=I+4|0;w=I+40|0;x=I+44|0;y=I+48|0;z=I+32|0;A=I+8|0;B=I+20|0;C=I+52|0;j=0;do{h=(k[b>>2]|0)+(j*56|0)|0;c=k[o>>2]|0;if((c|0)==2)JN(I,1,k[p>>2]|0,k[l>>2]&4095,(k[q>>2]|0)+(aa(k[k[s>>2]>>2]|0,j)|0)|0,0);else{c=c+-1|0;d=(k[m>>2]|0)+4|0;e=k[l>>2]&4095;g=k[s>>2]|0;f=(k[q>>2]|0)+(aa(k[g>>2]|0,j)|0)|0;g=g+4|0;F=v;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[w>>2]=A;k[x>>2]=y;k[C>>2]=0;k[y>>2]=0;k[I>>2]=e|1124007936;k[u>>2]=f;k[B>>2]=f;x1(I,c,d,g,1);y1(I)}KG(h,I)|0;c=k[t>>2]|0;if(c|0?(a=c+12|0,H=k[a>>2]|0,k[a>>2]=H+-1,(H|0)==1):0){d=k[t>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[z>>2]|0;if(!c){c=B1()|0;d=k[t>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[t>>2]=0}k[t>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[v>>2]|0)>0){d=k[w>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[x>>2]|0;if(!((c|0)==(y|0)|(c|0)==0))ggb(k[c+-4>>2]|0);j=j+1|0}while((j|0)<(n|0));r=J;return}else{if((c|0)<393216){if((c|0)>=327680){switch(c|0){case 327680:break;default:break a}d=k[a+4>>2]|0;I=(k[d+4>>2]|0)-(k[d>>2]|0)|0;e=(I|0)/56|0;Y1(b,e);if(!I){r=J;return}c=0;do{KG((k[b>>2]|0)+(c*56|0)|0,(k[d>>2]|0)+(c*56|0)|0)|0;c=c+1|0}while(c>>>0<e>>>0);r=J;return}switch(c|0){case 262144:break;default:break a}n=k[a+4>>2]|0;G=(k[n+4>>2]|0)-(k[n>>2]|0)|0;o=(G|0)/12|0;Y1(b,o);if((G|0)<=0){r=J;return}p=d&4095|1124007936;q=H+4|0;s=H+8|0;t=E+4|0;u=H+12|0;v=H+16|0;w=H+20|0;x=H+24|0;y=H+28|0;z=H+40|0;A=H+48|0;B=H+44|0;C=H+52|0;D=I+4|0;j=(d>>>3&511)+1<<(47696>>>(d<<1&14)&3);l=H+36|0;m=H+32|0;h=0;do{d=k[n>>2]|0;g=(k[b>>2]|0)+(h*56|0)|0;R1(E,a,h);d=k[d+(h*12|0)>>2]|0;k[H>>2]=p;k[q>>2]=2;G=k[t>>2]|0;k[s>>2]=G;c=k[E>>2]|0;k[u>>2]=c;k[v>>2]=d;k[w>>2]=d;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;k[z>>2]=s;k[B>>2]=A;k[C>>2]=0;k[A>>2]=0;if((d|0)==0&(aa(c,G)|0)!=0){c=ZT(36)|0;k[c>>2]=1;F=c+4|0;k[I>>2]=F;k[D>>2]=28;i[c+32>>0]=0;e=390609;G=F+28|0;do{i[F>>0]=i[e>>0]|0;F=F+1|0;e=e+1|0}while((F|0)<(G|0));Y8(-215,I,390638,390642,443);k[D>>2]=0;k[I>>2]=0;G=k[c>>2]|0;k[c>>2]=G+-1;if((G|0)==1)ggb(k[c+-4>>2]|0);c=k[u>>2]|0;e=k[H>>2]|0;f=k[B>>2]|0;d=k[w>>2]|0}else{e=p;f=A}c=aa(c,j)|0;k[H>>2]=e|16384;k[f>>2]=c;k[f+4>>2]=j;G=d+(aa(k[s>>2]|0,c)|0)|0;k[y>>2]=G;k[x>>2]=G+(0-c)+c;KG(g,H)|0;c=k[l>>2]|0;if(c|0?(F=c+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){d=k[l>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[m>>2]|0;if(!c){c=B1()|0;d=k[l>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[l>>2]=0}k[l>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[q>>2]|0)>0){d=k[z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[q>>2]|0))}c=k[B>>2]|0;if(!((c|0)==(A|0)|(c|0)==0))ggb(k[c+-4>>2]|0);h=h+1|0}while((h|0)<(o|0));r=J;return}if((c|0)>=720896){switch(c|0){case 720896:break;default:break a}f=k[a+4>>2]|0;H=(k[f+4>>2]|0)-(k[f>>2]|0)|0;g=(H|0)/48|0;Y1(b,g);if(!H){r=J;return}h=I+36|0;j=I+16|0;l=I+4|0;m=I+40|0;n=I+44|0;o=I+48|0;p=I+32|0;e=0;do{c=(k[b>>2]|0)+(e*56|0)|0;x9(I,(k[f>>2]|0)+(e*48|0)|0,q);KG(c,I)|0;c=k[h>>2]|0;if(c|0?(a=c+12|0,H=k[a>>2]|0,k[a>>2]=H+-1,(H|0)==1):0){d=k[h>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[p>>2]|0;if(!c){c=B1()|0;d=k[h>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[h>>2]=0}k[h>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[l>>2]|0)>0){d=k[m>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[l>>2]|0))}c=k[n>>2]|0;if(!((c|0)==(o|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=e+1|0}while(e>>>0<g>>>0);r=J;return}switch(c|0){case 393216:break;default:break a}d=k[a+4>>2]|0;k[t>>2]=1124007936;A=t+4|0;c=t+8|0;w=t+16|0;s=t+32|0;x=t+36|0;y=t+40|0;F=A;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[y>>2]=c;z=t+48|0;v=t+44|0;k[v>>2]=z;k[t+52>>2]=0;k[z>>2]=0;f=k[d>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,d,t,-1);f=k[k[y>>2]>>2]|0;Y1(b,f);if((f|0)>0){g=I+4|0;h=H+4|0;j=u+36|0;l=u+16|0;m=u+4|0;n=u+40|0;o=u+44|0;p=u+48|0;q=u+32|0;e=0;do{a=k[b>>2]|0;c=e;e=e+1|0;k[I>>2]=c;k[g>>2]=e;k[H>>2]=-2147483648;k[h>>2]=2147483647;H1(u,t,I,H);KG(a+(c*56|0)|0,u)|0;c=k[j>>2]|0;if(c|0?(G=c+12|0,a=k[G>>2]|0,k[G>>2]=a+-1,(a|0)==1):0){d=k[j>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q>>2]|0;if(!c){c=B1()|0;d=k[j>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[j>>2]=0}k[j>>2]=0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[m>>2]|0)>0){d=k[n>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[m>>2]|0))}c=k[o>>2]|0;if(!((c|0)==(p|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}while((e|0)<(f|0))}c=k[x>>2]|0;if(c|0?(I=c+12|0,b=k[I>>2]|0,k[I>>2]=b+-1,(b|0)==1):0){d=k[x>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s>>2]|0;if(!c){c=B1()|0;d=k[x>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[x>>2]=0}k[x>>2]=0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[A>>2]|0)>0){d=k[y>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[A>>2]|0))}c=k[v>>2]|0;if(!((c|0)==(z|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=J;return}while(0);c=I+4|0;d=ZT(36)|0;k[d>>2]=1;F=d+4|0;k[I>>2]=F;k[c>>2]=30;i[d+34>>0]=0;e=218080;G=F+30|0;do{i[F>>0]=i[e>>0]|0;F=F+1|0;e=e+1|0}while((F|0)<(G|0));Y8(-213,I,219949,216975,1367);k[c>>2]=0;k[I>>2]=0;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);r=J;return}function C2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+48|0;p=q;c=k[a>>2]|0;o=c&50331648;c=c&2031616;a:do if((c|0)<327680){if((c|0)<65536){switch(c|0){case 0:break;default:break a}h=k[b>>2]|0;f=b+4|0;while(1){g=k[f>>2]|0;if((g|0)==(h|0))break;k[f>>2]=g+-48;e=g+-24|0;a=k[e>>2]|0;if(a|0?(p=a+8|0,b=k[p>>2]|0,k[p>>2]=b+-1,(b|0)==1):0){b=k[e>>2]|0;p=k[b+4>>2]|0;jh[k[(k[p>>2]|0)+16>>2]&1023](p,b);k[e>>2]=0}c=g+-44|0;if((k[c>>2]|0)>0){d=k[g+-16>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}k[e>>2]=0;a=k[g+-12>>2]|0;if((a|0)==(g+-8|0)|(a|0)==0)continue;ggb(k[a+-4>>2]|0)}r=q;return}switch(c|0){case 65536:break;default:break a}g=k[a+4>>2]|0;h=b+4|0;d=k[h>>2]|0;c=k[b>>2]|0;n=d-c|0;a=(n|0)/48|0;if(n){if(a>>>0>1?(l=c+48|0,(d|0)!=(l|0)):0)do{k[h>>2]=d+-48;f=d+-24|0;a=k[f>>2]|0;if(a|0?(m=a+8|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){n=k[f>>2]|0;m=k[n+4>>2]|0;jh[k[(k[m>>2]|0)+16>>2]&1023](m,n);k[f>>2]=0}c=d+-44|0;if((k[c>>2]|0)>0){e=k[d+-16>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}k[f>>2]=0;a=k[d+-12>>2]|0;if(!((a|0)==(d+-8|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=k[h>>2]|0}while((d|0)!=(l|0))}else Z1(b,1-a|0);e=k[b>>2]|0;t9(p,g,o);D2(e,p);e=p+24|0;a=k[e>>2]|0;if(a|0?(o=a+8|0,b=k[o>>2]|0,k[o>>2]=b+-1,(b|0)==1):0){b=k[e>>2]|0;o=k[b+4>>2]|0;jh[k[(k[o>>2]|0)+16>>2]&1023](o,b);k[e>>2]=0}c=p+4|0;if((k[c>>2]|0)>0){d=k[p+32>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}k[e>>2]=0;a=k[p+36>>2]|0;if(!((a|0)==(p+40|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=q;return}else{if((c|0)<655360){switch(c|0){case 327680:break;default:break a}l=k[a+4>>2]|0;g=(k[l+4>>2]|0)-(k[l>>2]|0)|0;m=(g|0)/56|0;h=b+4|0;d=k[h>>2]|0;c=k[b>>2]|0;a=(d-c|0)/48|0;if(m>>>0<=a>>>0){if(m>>>0<a>>>0?(n=c+(m*48|0)|0,(d|0)!=(n|0)):0)do{k[h>>2]=d+-48;f=d+-24|0;a=k[f>>2]|0;if(a|0?(e=a+8|0,j=k[e>>2]|0,k[e>>2]=j+-1,(j|0)==1):0){j=k[f>>2]|0;e=k[j+4>>2]|0;jh[k[(k[e>>2]|0)+16>>2]&1023](e,j);k[f>>2]=0}c=d+-44|0;if((k[c>>2]|0)>0){e=k[d+-16>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}k[f>>2]=0;a=k[d+-12>>2]|0;if(!((a|0)==(d+-8|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=k[h>>2]|0}while((d|0)!=(n|0))}else Z1(b,m-a|0);if(!g){r=q;return}e=p+24|0;f=p+4|0;g=p+32|0;h=p+36|0;j=p+40|0;d=0;do{a=(k[b>>2]|0)+(d*48|0)|0;t9(p,(k[l>>2]|0)+(d*56|0)|0,o);D2(a,p);a=k[e>>2]|0;if(a|0?(c=a+8|0,n=k[c>>2]|0,k[c>>2]=n+-1,(n|0)==1):0){n=k[e>>2]|0;c=k[n+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,n);k[e>>2]=0}if((k[f>>2]|0)>0){c=k[g>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}k[e>>2]=0;a=k[h>>2]|0;if(!((a|0)==(j|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=d+1|0}while(d>>>0<m>>>0);r=q;return}if((c|0)<720896){switch(c|0){case 655360:break;default:break a}g=k[a+4>>2]|0;h=b+4|0;d=k[h>>2]|0;c=k[b>>2]|0;p=d-c|0;a=(p|0)/48|0;if(p){if(a>>>0>1?(j=c+48|0,(d|0)!=(j|0)):0)do{k[h>>2]=d+-48;f=d+-24|0;a=k[f>>2]|0;if(a|0?(o=a+8|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0){p=k[f>>2]|0;o=k[p+4>>2]|0;jh[k[(k[o>>2]|0)+16>>2]&1023](o,p);k[f>>2]=0}c=d+-44|0;if((k[c>>2]|0)>0){e=k[d+-16>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}k[f>>2]=0;a=k[d+-12>>2]|0;if(!((a|0)==(d+-8|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=k[h>>2]|0}while((d|0)!=(j|0))}else Z1(b,1-a|0);D2(k[b>>2]|0,g);r=q;return}switch(c|0){case 720896:break;default:break a}j=k[a+4>>2]|0;g=(k[j+4>>2]|0)-(k[j>>2]|0)|0;l=(g|0)/48|0;h=b+4|0;d=k[h>>2]|0;c=k[b>>2]|0;a=(d-c|0)/48|0;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(m=c+(l*48|0)|0,(d|0)!=(m|0)):0)do{k[h>>2]=d+-48;f=d+-24|0;a=k[f>>2]|0;if(a|0?(o=a+8|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0){p=k[f>>2]|0;o=k[p+4>>2]|0;jh[k[(k[o>>2]|0)+16>>2]&1023](o,p);k[f>>2]=0}c=d+-44|0;if((k[c>>2]|0)>0){e=k[d+-16>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}k[f>>2]=0;a=k[d+-12>>2]|0;if(!((a|0)==(d+-8|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=k[h>>2]|0}while((d|0)!=(m|0))}else Z1(b,l-a|0);if(!g){r=q;return}a=0;do{D2((k[b>>2]|0)+(a*48|0)|0,(k[j>>2]|0)+(a*48|0)|0);a=a+1|0}while(a>>>0<l>>>0);r=q;return}while(0);a=p+4|0;c=ZT(36)|0;k[c>>2]=1;d=c+4|0;k[p>>2]=d;k[a>>2]=30;i[c+34>>0]=0;e=218080;f=d+30|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-213,p,219962,216975,1418);k[a>>2]=0;k[p>>2]=0;b=k[c>>2]|0;k[c>>2]=b+-1;if((b|0)==1)ggb(k[c+-4>>2]|0);r=q;return}function D2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;if((a|0)==(b|0))return;j=b+24|0;c=k[j>>2]|0;if(c|0){i=c+8|0;k[i>>2]=(k[i>>2]|0)+1}i=a+24|0;c=k[i>>2]|0;if(c|0?(g=c+8|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){h=k[i>>2]|0;g=k[h+4>>2]|0;jh[k[(k[g>>2]|0)+16>>2]&1023](g,h);k[i>>2]=0}h=a+4|0;if((k[h>>2]|0)>0){d=k[a+32>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0;e=k[h>>2]|0}while((c|0)<(e|0));k[i>>2]=0;k[a>>2]=k[b>>2];if((e|0)<3)d=13;else{f=k[b+4>>2]|0;d=15}}else{k[i>>2]=0;k[a>>2]=k[b>>2];d=13}if((d|0)==13){c=k[b+4>>2]|0;if((c|0)<3){k[h>>2]=c;k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];e=k[b+36>>2]|0;g=k[a+36>>2]|0;k[g>>2]=k[e>>2];k[g+4>>2]=k[e+4>>2]}else{f=c;d=15}}if((d|0)==15?(s9(a,f,0,0,0),(k[h>>2]|0)>0):0){d=k[b+32>>2]|0;e=k[a+32>>2]|0;f=k[b+36>>2]|0;g=k[a+36>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[d+(c<<2)>>2];k[g+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[h>>2]|0))}k[a+16>>2]=k[b+16>>2];c=a+20|0;if(!(k[c>>2]|0))k[c>>2]=k[b+20>>2];k[i>>2]=k[j>>2];k[a+28>>2]=k[b+28>>2];return}function E2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;g=r;r=r+16|0;e=g;d=k[b>>2]&2031616;c=k[a>>2]&2031616;a:do if((c|0)<655360){switch(c|0){case 65536:break;default:{f=36;break a}}c=k[a+4>>2]|0;a=d&2097151;b:do if((a|0)<655360){switch(a|0){case 65536:break;default:break b}d=k[c+40>>2]|0;e=k[d+-4>>2]|0;c=k[(k[b+4>>2]|0)+40>>2]|0;if((e|0)!=(k[c+-4>>2]|0)){a=0;break a}if((e|0)==2){if((k[d>>2]|0)!=(k[c>>2]|0)){a=0;break a}a=(k[d+4>>2]|0)==(k[c+4>>2]|0);break a}if((e|0)>0)a=0;else{a=1;break a}while(1){if((k[d+(a<<2)>>2]|0)!=(k[c+(a<<2)>>2]|0)){a=0;break a}a=a+1|0;if((a|0)>=(e|0)){a=1;break a}}}else{switch(a|0){case 655360:break;default:break b}d=k[c+40>>2]|0;e=k[d+-4>>2]|0;c=k[(k[b+4>>2]|0)+32>>2]|0;if((e|0)!=(k[c+-4>>2]|0)){a=0;break a}if((e|0)==2){if((k[d>>2]|0)!=(k[c>>2]|0)){a=0;break a}a=(k[d+4>>2]|0)==(k[c+4>>2]|0);break a}if((e|0)>0)a=0;else{a=1;break a}while(1){if((k[d+(a<<2)>>2]|0)!=(k[c+(a<<2)>>2]|0)){a=0;break a}a=a+1|0;if((a|0)>=(e|0)){a=1;break a}}}while(0);if((k[c+4>>2]|0)>2)a=0;else{c=k[c+40>>2]|0;a=k[c+4>>2]|0;c=k[c>>2]|0;f=37}}else{switch(c|0){case 655360:break;default:{f=36;break a}}c=k[a+4>>2]|0;a=d&2097151;c:do if((a|0)<655360){switch(a|0){case 65536:break;default:break c}d=k[c+32>>2]|0;e=k[d+-4>>2]|0;c=k[(k[b+4>>2]|0)+40>>2]|0;if((e|0)!=(k[c+-4>>2]|0)){a=0;break a}if((e|0)==2){if((k[d>>2]|0)!=(k[c>>2]|0)){a=0;break a}a=(k[d+4>>2]|0)==(k[c+4>>2]|0);break a}if((e|0)>0)a=0;else{a=1;break a}while(1){if((k[d+(a<<2)>>2]|0)!=(k[c+(a<<2)>>2]|0)){a=0;break a}a=a+1|0;if((a|0)>=(e|0)){a=1;break a}}}else{switch(a|0){case 655360:break;default:break c}d=k[c+32>>2]|0;e=k[d+-4>>2]|0;c=k[(k[b+4>>2]|0)+32>>2]|0;if((e|0)!=(k[c+-4>>2]|0)){a=0;break a}if((e|0)==2){if((k[d>>2]|0)!=(k[c>>2]|0)){a=0;break a}a=(k[d+4>>2]|0)==(k[c+4>>2]|0);break a}if((e|0)>0)a=0;else{a=1;break a}while(1){if((k[d+(a<<2)>>2]|0)!=(k[c+(a<<2)>>2]|0)){a=0;break a}a=a+1|0;if((a|0)>=(e|0)){a=1;break a}}}while(0);if((k[c+4>>2]|0)>2)a=0;else{c=k[c+32>>2]|0;a=k[c+4>>2]|0;c=k[c>>2]|0;f=37}}while(0);if((f|0)==36){R1(e,a,-1);a=k[e>>2]|0;c=k[e+4>>2]|0;f=37}if((f|0)==37)if((a2(b)|0)>2)a=0;else{R1(e,b,-1);a=(k[e>>2]|0)==(a|0)?(k[e+4>>2]|0)==(c|0):0}r=g;return a|0}function F2(a){a=a|0;var b=0,c=0,d=0,e=0;e=r;r=r+16|0;b=e;c=k[a>>2]&2031616;a:do if((c|0)<655360){if((c|0)>=327680){switch(c|0){case 327680:break;default:break a}d=k[a+4>>2]|0;d=((k[d+4>>2]|0)-(k[d>>2]|0)|0)/56|0;r=e;return d|0}switch(c|0){case 65536:break;default:break a}a=k[a+4>>2]|0;d=k[a+4>>2]|0;if((d|0)<3){d=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;r=e;return d|0}c=k[a+40>>2]|0;b=0;a=1;do{a=aa(k[c+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(d|0));r=e;return a|0}else{if((c|0)>=720896){switch(c|0){case 720896:break;default:break a}d=k[a+4>>2]|0;d=((k[d+4>>2]|0)-(k[d>>2]|0)|0)/48|0;r=e;return d|0}switch(c|0){case 655360:break;default:break a}a=k[a+4>>2]|0;d=k[a+4>>2]|0;if((d|0)<3){d=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;r=e;return d|0}c=k[a+32>>2]|0;b=0;a=1;do{a=aa(k[c+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(d|0));r=e;return a|0}while(0);R1(b,a,-1);d=aa(k[b+4>>2]|0,k[b>>2]|0)|0;r=e;return d|0}function G2(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;g=r;r=r+16|0;f=g;b=k[a>>2]&2031616;a:do if((b|0)<458752){if((b|0)>=196608){if((b|0)>=327680){if((b|0)>=393216){switch(b|0){case 393216:{a=0;break}default:break a}r=g;return a|0}switch(b|0){case 327680:break;default:break a}f=k[a+4>>2]|0;f=(k[f>>2]|0)==(k[f+4>>2]|0);r=g;return f|0}if((b|0)<262144){switch(b|0){case 196608:break;default:break a}f=k[a+4>>2]|0;f=(k[f>>2]|0)==(k[f+4>>2]|0);r=g;return f|0}else{switch(b|0){case 262144:break;default:break a}f=k[a+4>>2]|0;f=(k[f>>2]|0)==(k[f+4>>2]|0);r=g;return f|0}}if((b|0)<65536){switch(b|0){case 0:break;default:break a}f=1;r=g;return f|0}if((b|0)>=131072){switch(b|0){case 131072:{a=0;break}default:break a}r=g;return a|0}switch(b|0){case 65536:break;default:break a}a=k[a+4>>2]|0;if(!(k[a+16>>2]|0)){f=1;r=g;return f|0}d=k[a+4>>2]|0;if((d|0)<3)a=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{c=k[a+40>>2]|0;b=0;a=1;do{a=aa(k[c+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(d|0))}f=(a|0)==0;r=g;return f|0}else{if((b|0)<655360){if((b|0)<524288){switch(b|0){case 458752:break;default:break a}a=k[a+4>>2]|0;if(!(k[a+8>>2]|0)){f=1;r=g;return f|0}f=(k[a+12>>2]|0)==0;r=g;return f|0}if((b|0)<589824){switch(b|0){case 524288:break;default:break a}f=(k[(k[a+4>>2]|0)+16>>2]|0)==0;r=g;return f|0}else{switch(b|0){case 589824:break;default:break a}f=(k[(k[a+4>>2]|0)+16>>2]|0)==0;r=g;return f|0}}if((b|0)>=786432)if((b|0)<851968){switch(b|0){case 786432:break;default:break a}f=(k[(k[a+4>>2]|0)+4>>2]|0)==0;r=g;return f|0}else{switch(b|0){case 851968:break;default:break a}f=k[a+4>>2]|0;f=(k[f>>2]|0)==(k[f+4>>2]|0);r=g;return f|0}if((b|0)>=720896){switch(b|0){case 720896:break;default:break a}f=k[a+4>>2]|0;f=(k[f>>2]|0)==(k[f+4>>2]|0);r=g;return f|0}switch(b|0){case 655360:break;default:break a}a=k[a+4>>2]|0;if(!(k[a+24>>2]|0)){f=1;r=g;return f|0}d=k[a+4>>2]|0;if((d|0)<3)a=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{c=k[a+32>>2]|0;b=0;a=1;do{a=aa(k[c+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(d|0))}f=(a|0)==0;r=g;return f|0}while(0);a=f+4|0;b=ZT(36)|0;k[b>>2]=1;c=b+4|0;k[f>>2]=c;k[a>>2]=30;i[b+34>>0]=0;d=218080;e=c+30|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-213,f,219976,216975,1957);k[a>>2]=0;k[f>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0);f=1;r=g;return f|0}function H2(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;b=k[a>>2]&2031616;a:do if((b|0)<327680){if((b|0)<131072){if((b|0)<65536){switch(b|0){case 0:{a=1;break}default:break a}r=h;return a|0}switch(b|0){case 65536:break;default:break a}g=(k[k[a+4>>2]>>2]&16384|0)!=0;r=h;return g|0}if((b|0)<196608){switch(b|0){case 131072:{a=1;break}default:break a}r=h;return a|0}if((b|0)<262144){switch(b|0){case 196608:{a=1;break}default:break a}r=h;return a|0}else{switch(b|0){case 262144:{a=1;break}default:break a}r=h;return a|0}}else{if((b|0)<655360){if((b|0)>=393216){switch(b|0){case 393216:{a=1;break}default:break a}r=h;return a|0}switch(b|0){case 327680:break;default:break a}a=k[a+4>>2]|0;b=g+4|0;c=ZT(28)|0;k[c>>2]=1;d=c+4|0;k[g>>2]=d;k[b>>2]=21;i[c+25>>0]=0;e=219982;f=d+21|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,g,220004,216975,1978);k[b>>2]=0;k[g>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)==1)ggb(k[c+-4>>2]|0);g=(k[(k[a>>2]|0)+-56>>2]&16384|0)!=0;r=h;return g|0}if((b|0)<720896){switch(b|0){case 655360:break;default:break a}g=(k[k[a+4>>2]>>2]&16384|0)!=0;r=h;return g|0}if((b|0)>=786432){switch(b|0){case 786432:{a=1;break}default:break a}r=h;return a|0}switch(b|0){case 720896:break;default:break a}a=k[a+4>>2]|0;b=g+4|0;c=ZT(28)|0;k[c>>2]=1;d=c+4|0;k[g>>2]=d;k[b>>2]=21;i[c+25>>0]=0;e=219982;f=d+21|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,g,220004,216975,1985);k[b>>2]=0;k[g>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)==1)ggb(k[c+-4>>2]|0);g=(k[(k[a>>2]|0)+-48>>2]&16384|0)!=0;r=h;return g|0}while(0);a=g+4|0;b=ZT(36)|0;k[b>>2]=1;d=b+4|0;k[g>>2]=d;k[a>>2]=30;i[b+34>>0]=0;e=218080;f=d+30|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-213,g,220004,216975,1989);k[a>>2]=0;k[g>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0);g=0;r=h;return g|0}function I2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+112|0;f=o+56|0;g=o;c=k[a>>2]&2031616;d=c&2097151;a:do if((d|0)<196608)if((d|0)>=65536)if((d|0)<131072)switch(d|0){case 65536:break a;default:{e=36;break a}}else switch(d|0){case 131072:break a;default:{e=36;break a}}else{switch(d|0){case 0:break;default:{e=36;break a}}b2(b);r=o;return}else{if((d|0)>=655360){if((d|0)>=786432)switch(d|0){case 786432:break a;default:{e=36;break a}}switch(d|0){case 655360:break;default:{e=36;break a}}w9(k[a+4>>2]|0,b);r=o;return}if((d|0)<393216)switch(d|0){case 196608:break a;default:{e=36;break a}}switch(d|0){case 393216:break;default:{e=36;break a}}e=k[a+4>>2]|0;if((k[b>>2]&2031616|0)==65536){n=J2(b,-1)|0;m=k[e>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,e,n,-1);r=o;return}k[g>>2]=1124007936;n=g+4|0;a=g+8|0;h=g+16|0;f=g+32|0;j=g+36|0;l=g+40|0;c=n;d=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));k[l>>2]=a;m=g+48|0;d=g+44|0;k[d>>2]=m;k[g+52>>2]=0;k[m>>2]=0;a=k[e>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,e,g,-1);mY(g,b);a=k[j>>2]|0;if(a|0?(b=a+12|0,g=k[b>>2]|0,k[b>>2]=g+-1,(g|0)==1):0){c=k[j>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[f>>2]|0;if(!a){a=B1()|0;c=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[j>>2]=0}k[j>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[n>>2]|0)>0){c=k[l>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[d>>2]|0;if((a|0)==(m|0)|(a|0)==0){r=o;return}ggb(k[a+-4>>2]|0);r=o;return}while(0);if((e|0)==36){n=f+4|0;a=ZT(8)|0;k[a>>2]=1;m=a+4|0;k[f>>2]=m;k[n>>2]=0;i[m>>0]=0;Y8(-213,f,233543,216975,2155);k[n>>2]=0;k[f>>2]=0;n=k[a>>2]|0;k[a>>2]=n+-1;if((n|0)==1)ggb(k[a+-4>>2]|0);r=o;return}if((c|0)==65536)AF(f,k[a+4>>2]|0);else Q1(f,a,-1);mY(f,b);d=f+36|0;a=k[d>>2]|0;if(a|0?(m=a+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[f+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;n=f+16|0;c=f+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[c>>2]|0)>0){d=k[f+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[f+44>>2]|0;if(!((a|0)==(f+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=o;return}function J2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;h=j;c=k[a>>2]&2031616;if((b|0)<0){if((c|0)!=65536?(b=h+4|0,d=ZT(16)|0,k[d>>2]=1,g=d+4|0,k[h>>2]=g,k[b>>2]=8,i[d+12>>0]=0,g,f=g,i[f>>0]=107,i[f+1>>0]=32,i[f+2>>0]=61,i[f+3>>0]=61,g=g+4|0,i[g>>0]=32,i[g+1>>0]=77,i[g+2>>0]=65,i[g+3>>0]=84,Y8(-215,h,220017,216975,2662),k[b>>2]=0,k[h>>2]=0,b=k[d>>2]|0,k[d>>2]=b+-1,(b|0)==1):0)ggb(k[d+-4>>2]|0);b=k[a+4>>2]|0;r=j;return b|0}if((c|0)!=327680){c=h+4|0;d=ZT(24)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=19;i[d+23>>0]=0;f=220027;g=e+19|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,h,220017,216975,2667);k[c>>2]=0;k[h>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0)}a=k[a+4>>2]|0;c=k[a>>2]|0;if((((k[a+4>>2]|0)-c|0)/56|0|0)<=(b|0)){c=h+4|0;d=ZT(24)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=17;i[d+21>>0]=0;f=218895;g=e+17|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,h,220017,216975,2669);k[c>>2]=0;k[h>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);c=k[a>>2]|0}b=c+(b*56|0)|0;r=j;return b|0}function K2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;h=r;r=r+144|0;d=h+128|0;f=h;e=k[b>>2]&2031616;a:do if((e|0)>=65536)if((e|0)<655360){switch(e|0){case 65536:break;default:{g=8;break a}}d=k[b+4>>2]|0;b=k[d+4>>2]|0;if((b|0)<=0)break;e=k[d+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=k[e+(d<<2)>>2];d=d+1|0}while((d|0)!=(b|0))}else{switch(e|0){case 655360:break;default:{g=8;break a}}d=k[b+4>>2]|0;b=k[d+4>>2]|0;if((b|0)<=0)break;e=k[d+32>>2]|0;d=0;do{k[f+(d<<2)>>2]=k[e+(d<<2)>>2];d=d+1|0}while((d|0)!=(b|0))}else switch(e|0){case 0:{b=0;break}default:g=8}while(0);if((g|0)==8){R1(d,b,-1);k[f>>2]=k[d+4>>2];k[f+4>>2]=k[d>>2];b=2}P1(a,b,f,c,-1,0,0);r=h;return}function L2(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;g=j;b=k[a>>2]|0;if((b&2031616|0)!=65536){b2(a);r=j;return}if(b&1073741824|0){b=g+4|0;c=ZT(20)|0;k[c>>2]=1;d=c+4|0;k[g>>2]=d;k[b>>2]=12;i[c+16>>0]=0;e=219642;f=d+12|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,g,220047,216975,2644);k[b>>2]=0;k[g>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)==1)ggb(k[c+-4>>2]|0)}e=k[a+4>>2]|0;d=e+40|0;c=k[d>>2]|0;f=k[c>>2]|0;if(!f){r=j;return}if(!(k[e>>2]&32768)){b=e+44|0;if((k[e+16>>2]|0)>>>0>(k[e+28>>2]|0)>>>0)h=10}else{b=e+44|0;h=10}if((h|0)==10){K1(e,0);c=k[d>>2]|0}g=k[b>>2]|0;k[c>>2]=0;g=aa(k[g>>2]|0,0-f|0)|0;h=e+24|0;k[h>>2]=(k[h>>2]|0)+g;r=j;return}function M2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;h=j;c=k[a>>2]&2031616;if((b|0)<0){if((c|0)!=655360){c=h+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=220053;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,h,220063,216975,2679);k[c>>2]=0;k[h>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}h=k[a+4>>2]|0;r=j;return h|0}if((c|0)!=720896){c=h+4|0;d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=20;i[d+24>>0]=0;f=220074;g=e+20|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,h,220063,216975,2684);k[c>>2]=0;k[h>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0)}a=k[a+4>>2]|0;c=k[a>>2]|0;if((((k[a+4>>2]|0)-c|0)/48|0|0)<=(b|0)){c=h+4|0;d=ZT(24)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=17;i[d+21>>0]=0;f=218895;g=e+17|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,h,220063,216975,2686);k[c>>2]=0;k[h>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);c=k[a>>2]|0}h=c+(b*48|0)|0;r=j;return h|0}function N2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+112|0;p=q+56|0;o=q;d=k[a>>2]&2031616;e=d&2097151;a:do if((e|0)<196608){if((e|0)<65536){switch(e|0){case 0:break;default:{m=61;break a}}r=q;return}if((e|0)<131072)switch(e|0){case 65536:break a;default:{m=61;break a}}else switch(e|0){case 131072:break a;default:{m=61;break a}}}else{if((e|0)<589824)switch(e|0){case 196608:break a;default:{m=61;break a}}if((e|0)>=655360){switch(e|0){case 655360:break;default:{m=61;break a}}o=k[a+4>>2]|0;a=G2(c)|0;x9(p,o,a?33554432:50331648);pY(p,b,c);c=p+36|0;a=k[c>>2]|0;if(a|0?(n=a+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[p+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;o=p+16|0;b=p+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[b>>2]|0)>0){c=k[p+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[p+44>>2]|0;if(!((a|0)==(p+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=q;return}switch(e|0){case 589824:break;default:{m=61;break a}}if((k[b>>2]&2031616|0)==65536)AF(o,k[b+4>>2]|0);else Q1(o,b,-1);a=S1(a,-1)|0;n=o+4|0;if(((k[n>>2]|0)<=2?(l=k[o>>2]|0,(l&16384|0)!=0):0)?(g=k[o+40>>2]|0,f=k[g+4>>2]|0,g=k[g>>2]|0,h=(f|0)==1,j=(g|0)==1,h|j):0){a=(a>>>3&511)+1|0;if(!((a|0)==(f|0)&j|h&(j|(a|0)==(g|0))))if(!(h&(g|0)==4?a>>>0<5&(l&4095|0)==6:0))m=42}else m=42;if((m|0)==42){k[p>>2]=0;a=p+4|0;k[a>>2]=0;b=ZT(72)|0;k[b>>2]=1;c=b+4|0;k[p>>2]=c;k[a>>2]=65;i[b+69>>0]=0;d=220095;e=c+65|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,p,220161,216975,2734);k[a>>2]=0;k[p>>2]=0;m=k[b>>2]|0;k[b>>2]=m+-1;if((m|0)==1)ggb(k[b+-4>>2]|0)}f=o+16|0;g=o+44|0;S9()|0;k[p>>2]=0;a=p+4|0;k[a>>2]=0;b=ZT(52)|0;k[b>>2]=1;c=b+4|0;k[p>>2]=c;k[a>>2]=44;i[b+48>>0]=0;d=235708;e=c+44|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-216,p,235753,235767,97);k[a>>2]=0;k[p>>2]=0;p=k[b>>2]|0;k[b>>2]=p+-1;if((p|0)==1)ggb(k[b+-4>>2]|0);c=o+36|0;a=k[c>>2]|0;if(a|0?(m=a+12|0,p=k[m>>2]|0,k[m>>2]=p+-1,(p|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[o+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[n>>2]|0)>0){b=k[o+40>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[g>>2]|0;if(!((a|0)==(o+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=q;return}while(0);if((m|0)==61){o=p+4|0;a=ZT(8)|0;k[a>>2]=1;n=a+4|0;k[p>>2]=n;k[o>>2]=0;i[n>>0]=0;Y8(-213,p,220161,216975,2738);k[o>>2]=0;k[p>>2]=0;p=k[a>>2]|0;k[a>>2]=p+-1;if((p|0)==1)ggb(k[a+-4>>2]|0);r=q;return}if((d|0)==65536)AF(p,k[a+4>>2]|0);else Q1(p,a,-1);pY(p,b,c);c=p+36|0;a=k[c>>2]|0;if(a|0?(n=a+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[p+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;o=p+16|0;b=p+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[b>>2]|0)>0){c=k[p+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[p+44>>2]|0;if(!((a|0)==(p+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=q;return}function O2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+128|0;y=z+72|0;w=z+16|0;x=z;if(!((a|0)!=0&(b|0)!=0)){b2(c);r=z;return}g=a+8|0;h=y+4|0;d=0;e=0;do{if(!(((k[a+(d*56|0)+4>>2]|0)<3?(k[a+(d*56|0)+8>>2]|0)==(k[g>>2]|0):0)?!((k[a>>2]^k[a+(d*56|0)>>2])&4095|0):0)){f=ZT(88)|0;k[f>>2]=1;j=f+4|0;k[y>>2]=j;k[h>>2]=80;i[f+84>>0]=0;l=220167;m=j+80|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,y,220248,216975,2809);k[h>>2]=0;k[y>>2]=0;v=k[f>>2]|0;k[f>>2]=v+-1;if((v|0)==1)ggb(k[f+-4>>2]|0)}e=(k[a+(d*56|0)+12>>2]|0)+e|0;d=d+1|0}while(d>>>0<b>>>0);c2(c,k[g>>2]|0,e,k[a>>2]&4095,-1,0,0);if((k[c>>2]&2031616|0)==65536)AF(y,k[c+4>>2]|0);else Q1(y,c,-1);g=x+4|0;h=x+8|0;j=x+12|0;l=x+4|0;m=l+4|0;n=w+36|0;o=w+16|0;p=w+4|0;q=w+40|0;s=w+44|0;t=w+48|0;u=w+32|0;c=0;f=0;while(1){v=a+(f*56|0)+12|0;e=k[v>>2]|0;d=k[a+(f*56|0)+8>>2]|0;k[x>>2]=c;k[g>>2]=0;k[h>>2]=e;k[j>>2]=d;I1(w,y,x);d=m;k[d>>2]=0;k[d+4>>2]=0;k[x>>2]=33619968;k[l>>2]=w;mY(a+(f*56|0)|0,x);v=k[v>>2]|0;d=k[n>>2]|0;if(d|0?(d=d+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){e=k[n>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[u>>2]|0;if(!d){d=B1()|0;e=k[n>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[n>>2]=0}k[n>>2]=0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[p>>2]|0)>0){e=k[q>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[p>>2]|0))}d=k[s>>2]|0;if(!((d|0)==(t|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=f+1|0;if(f>>>0>=b>>>0)break;else c=v+c|0}c=y+36|0;d=k[c>>2]|0;if(d|0?(w=d+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){e=k[c>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[y+32>>2]|0;if(!d){d=B1()|0;e=k[c>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[c>>2]=0}k[c>>2]=0;x=y+16|0;e=y+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[e>>2]|0)>0){c=k[y+40>>2]|0;d=0;do{k[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[y+44>>2]|0;if(!((d|0)==(y+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=z;return}function P2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=r;r=r+112|0;d=e;if((k[a>>2]&2031616|0)==65536)AF(d,k[a+4>>2]|0);else Q1(d,a,-1);a=d+56|0;if((k[b>>2]&2031616|0)==65536)AF(a,k[b+4>>2]|0);else Q1(a,b,-1);O2(d,2,c);c=d+92|0;a=k[c>>2]|0;if(a|0?(a=a+12|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[d+88>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;c=d+72|0;b=d+60|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[b>>2]|0)>0){c=k[d+96>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[d+100>>2]|0;if(!((a|0)==(d+104|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=d+36|0;a=k[c>>2]|0;if(a|0?(a=a+12|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[d+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;c=d+16|0;b=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[b>>2]|0)>0){c=k[d+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[d+44>>2]|0;if((a|0)==(d+48|0)|(a|0)==0){r=e;return}ggb(k[a+-4>>2]|0);r=e;return}function Q2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+144|0;y=A+88|0;w=A+32|0;x=A+16|0;z=A;k[z>>2]=0;v=z+4|0;k[v>>2]=0;k[z+8>>2]=0;B2(a,z);t=k[z>>2]|0;v=k[v>>2]|0;u=(t|0)==(v|0)?0:t;t=v-t|0;v=(t|0)/56|0;if(!((u|0)!=0&(t|0)!=0)){b2(b);zF(z);r=A;return}d=u+12|0;e=y+4|0;a=0;c=0;do{if(!(((k[u+(a*56|0)+4>>2]|0)<3?(k[u+(a*56|0)+12>>2]|0)==(k[d>>2]|0):0)?!((k[u>>2]^k[u+(a*56|0)>>2])&4095|0):0)){k[y>>2]=0;k[e>>2]=0;f=ZT(88)|0;k[f>>2]=1;g=f+4|0;k[y>>2]=g;k[e>>2]=80;i[f+84>>0]=0;h=220256;j=g+80|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,y,220337,216975,2849);k[e>>2]=0;k[y>>2]=0;t=k[f>>2]|0;k[f>>2]=t+-1;if((t|0)==1)ggb(k[f+-4>>2]|0)}c=(k[u+(a*56|0)+8>>2]|0)+c|0;a=a+1|0}while(a>>>0<v>>>0);c2(b,c,k[d>>2]|0,k[u>>2]&4095,-1,0,0);if((k[b>>2]&2031616|0)==65536)AF(y,k[b+4>>2]|0);else Q1(y,b,-1);f=x+4|0;g=x+8|0;h=x+12|0;j=x+4|0;b=j+4|0;l=w+36|0;m=w+16|0;n=w+4|0;o=w+40|0;p=w+44|0;q=w+48|0;s=w+32|0;d=0;e=0;while(1){c=k[u+(e*56|0)+12>>2]|0;t=u+(e*56|0)+8|0;a=k[t>>2]|0;k[x>>2]=0;k[f>>2]=d;k[g>>2]=c;k[h>>2]=a;I1(w,y,x);a=b;k[a>>2]=0;k[a+4>>2]=0;k[x>>2]=33619968;k[j>>2]=w;mY(u+(e*56|0)|0,x);t=k[t>>2]|0;a=k[l>>2]|0;if(a|0?(a=a+12|0,c=k[a>>2]|0,k[a>>2]=c+-1,(c|0)==1):0){c=k[l>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[s>>2]|0;if(!a){a=B1()|0;c=k[l>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[l>>2]=0}k[l>>2]=0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[n>>2]|0)>0){c=k[o>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[p>>2]|0;if(!((a|0)==(q|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=e+1|0;if(e>>>0>=v>>>0)break;else d=t+d|0}d=y+36|0;a=k[d>>2]|0;if(a|0?(w=a+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;x=y+16|0;c=y+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[c>>2]|0)>0){d=k[y+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[y+44>>2]|0;if(!((a|0)==(y+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);zF(z);r=A;return}function R2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0;q=r;r=r+144|0;n=q+88|0;j=q;m=q+32|0;if((a2(a)|0)>=3){c=n+4|0;d=ZT(20)|0;k[d>>2]=1;f=d+4|0;k[n>>2]=f;k[c>>2]=14;i[d+18>>0]=0;g=220345;h=f+14|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,n,220360,216975,2919);k[c>>2]=0;k[n>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}if((k[a>>2]&2031616|0)==65536)AF(n,k[a+4>>2]|0);else Q1(n,a,-1);h=k[n+8>>2]|0;l=k[n+12>>2]|0;a:do switch(k[n>>2]&4095){case 5:{a=k[n+16>>2]|0;e=+p[b>>3];g=(k[n+48>>2]|0)>>>2;if((h|0)>0){if((l|0)<=0){c=0;while(1){if((c|0)<(l|0))o[a+(c<<2)>>2]=e;c=c+1|0;if((c|0)==(h|0))break a;else a=a+(g<<2)|0}}f=l<<2;c=0;d=a;while(1){zpb(a+((aa(g,c)|0)<<2)|0,0,f|0)|0;if((c|0)<(l|0))o[d+(c<<2)>>2]=e;c=c+1|0;if((c|0)==(h|0))break;else d=d+(g<<2)|0}}break}case 6:{e=+p[b>>3];f=(k[n+48>>2]|0)>>>3;if((h|0)>0&(l|0)>0){a=k[n+16>>2]|0;c=0;while(1){d=0;do{p[a+(d<<3)>>3]=(d|0)==(c|0)?e:0.0;d=d+1|0}while((d|0)!=(l|0));c=c+1|0;if((c|0)==(h|0))break;else a=a+(f<<3)|0}}break}default:{k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;k[j+20>>2]=0;k[j+24>>2]=0;k[j+28>>2]=0;oY(n,j);J1(m,n,0);oY(m,b);d=m+36|0;a=k[d>>2]|0;if(a|0?(b=a+12|0,l=k[b>>2]|0,k[b>>2]=l+-1,(l|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[m+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;l=m+16|0;c=m+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[c>>2]|0)>0){d=k[m+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[m+44>>2]|0;if(!((a|0)==(m+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}}while(0);d=n+36|0;a=k[d>>2]|0;if(a|0?(l=a+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;m=n+16|0;c=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[c>>2]|0)>0){d=k[n+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[n+44>>2]|0;if((a|0)==(n+48|0)|(a|0)==0){r=q;return}ggb(k[a+-4>>2]|0);r=q;return}function S2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+64|0;n=q+8|0;h=q;if((k[a>>2]&2031616|0)==65536)AF(n,k[a+4>>2]|0);else Q1(n,a,-1);p=n+48|0;m=k[p>>2]|0;o=n+4|0;a=k[o>>2]|0;if((a|0)>0){c=k[(k[n+44>>2]|0)+(a+-1<<2)>>2]|0;if((a|0)<3)d=6;else d=7}else{c=0;d=6}if((d|0)==6){a=k[n+8>>2]|0;if((a|0)!=(k[n+12>>2]|0))d=7}if((d|0)==7){k[h>>2]=0;a=h+4|0;k[a>>2]=0;d=ZT(36)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[a>>2]=31;i[d+35>>0]=0;f=220378;g=e+31|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,h,220410,216975,3280);k[a>>2]=0;k[h>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0);a=k[n+8>>2]|0}j=n+16|0;h=k[j>>2]|0;l=n+44|0;if((a|0)>0)if(b){f=0;do{d=f;f=f+1|0;if((f|0)<(a|0)){g=aa(d,m)|0;e=aa(d,c)|0;d=f;do{upb(h+((aa(d,c)|0)+g)|0,h+((aa(d,m)|0)+e)|0,c|0)|0;d=d+1|0}while((d|0)!=(a|0))}}while((f|0)!=(a|0))}else{g=0;do{if((g|0)>0){e=aa(g,m)|0;f=aa(g,c)|0;d=0;do{upb(h+((aa(d,c)|0)+e)|0,h+((aa(d,m)|0)+f)|0,c|0)|0;d=d+1|0}while((d|0)!=(g|0))}g=g+1|0}while((g|0)!=(a|0))}d=n+36|0;a=k[d>>2]|0;if(a|0?(b=a+12|0,m=k[b>>2]|0,k[b>>2]=m+-1,(m|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[o>>2]|0)>0){c=k[n+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[l>>2]|0;if((a|0)==(p|0)|(a|0)==0){r=q;return}ggb(k[a+-4>>2]|0);r=q;return}function T2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;N=r;r=r+192|0;E=N+168|0;M=N+112|0;L=N+56|0;F=N;if((a2(a)|0)>=3){f=E+4|0;g=ZT(24)|0;k[g>>2]=1;h=g+4|0;k[E>>2]=h;k[f>>2]=16;i[g+20>>0]=0;j=220423;l=h+16|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,E,220440,216975,3699);k[f>>2]=0;k[E>>2]=0;K=k[g>>2]|0;k[g>>2]=K+-1;if((K|0)==1)ggb(k[g+-4>>2]|0)}o=S1(a,-1)|0;z=o&7;p=o&4088;if((e|0)<0)if((k[b>>2]|0)<0)e=S1(b,-1)|0;else e=o;m=(e|0)>-1?e:o;n=m&7;g=n|p;v=(d|0)==1;if(d>>>0>=4){e=E+4|0;f=ZT(96)|0;k[f>>2]=1;h=f+4|0;k[E>>2]=h;k[e>>2]=88;i[f+92>>0]=0;j=220447;l=h+88|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,E,220440,216975,3709);k[e>>2]=0;k[E>>2]=0;K=k[f>>2]|0;k[f>>2]=K+-1;if((K|0)==1)ggb(k[f+-4>>2]|0)}if((k[a>>2]&2031616|0)==65536)AF(M,k[a+4>>2]|0);else Q1(M,a,-1);q=(c|0)==0;s=M+8|0;t=M+12|0;c2(b,q?1:k[s>>2]|0,q?k[t>>2]|0:1,g,-1,0,0);if((k[b>>2]&2031616|0)==65536)AF(L,k[b+4>>2]|0);else Q1(L,b,-1);k[F>>2]=k[L>>2];A=F+4|0;K=L+4|0;e=k[K>>2]|0;k[A>>2]=e;j=F+8|0;b=L+8|0;k[j>>2]=k[b>>2];l=F+12|0;h=L+12|0;k[l>>2]=k[h>>2];w=F+16|0;I=L+16|0;k[w>>2]=k[I>>2];k[F+20>>2]=k[L+20>>2];k[F+24>>2]=k[L+24>>2];k[F+28>>2]=k[L+28>>2];u=F+32|0;H=L+32|0;k[u>>2]=k[H>>2];x=F+36|0;J=L+36|0;f=k[J>>2]|0;k[x>>2]=f;y=F+40|0;k[y>>2]=j;C=F+48|0;B=F+44|0;k[B>>2]=C;k[F+52>>2]=0;k[C>>2]=0;if(f){e=f+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[K>>2]|0}if((e|0)>=3){k[A>>2]=0;x1(F,e,0,0,0);if((k[A>>2]|0)>0){f=k[L+40>>2]|0;g=k[y>>2]|0;a=k[L+44>>2]|0;c=k[B>>2]|0;e=0;do{k[g+(e<<2)>>2]=k[f+(e<<2)>>2];k[c+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[A>>2]|0))}}else{a=k[L+44>>2]|0;c=k[B>>2]|0;k[c>>2]=k[a>>2];k[c+4>>2]=k[a+4>>2]}do if(v)if(!((m|o)&4)){g=k[b>>2]|0;f=k[h>>2]|0;e=p|4;if(((k[A>>2]|0)<3?(k[j>>2]|0)==(g|0):0)&(k[l>>2]|0)==(f|0)?!((k[w>>2]|0)==0?1:(k[F>>2]&4095|0)!=(e|0)):0){a=4;e=0;break}k[E>>2]=g;k[E+4>>2]=f;G1(F,2,E,e);a=4;e=0}else{a=n;e=0}else{a=n;e=d}while(0);f=(e|0)==0;a:do if(q){if(f){e=(z|0)==0;if(e&(a|0)==4){D=773;break}g=(a|0)==5;if(e&g){D=774;break}f=(a|0)==6;if(e&f){D=775;break}e=(z|0)==2;if(e&g){D=776;break}if(e&f){D=777;break}e=(z|0)==3;if(e&g){D=778;break}if(e&f){D=779;break}e=(z|0)==5;if(e&g){D=780;break}if(e&f){D=781;break}if((z|0)==6&f){D=782;break}else{G=75;break}}switch(e|0){case 2:{if(!(a|z)){D=783;break a}if((z|0)==2&(a|0)==2){D=784;break a}if((z|0)==3&(a|0)==3){D=785;break a}if((z|0)==5&(a|0)==5){D=786;break a}if((z|0)==6&(a|0)==6){D=787;break a}else{G=75;break a}}case 3:{if(!(a|z)){D=788;break a}if((z|0)==2&(a|0)==2){D=789;break a}if((z|0)==3&(a|0)==3){D=790;break a}if((z|0)==5&(a|0)==5){D=791;break a}if((z|0)==6&(a|0)==6){D=792;break a}else{G=75;break a}}default:{G=75;break a}}}else{if(f){e=(z|0)==0;if(e&(a|0)==4){D=793;break}g=(a|0)==5;if(e&g){D=794;break}f=(a|0)==6;if(e&f){D=795;break}e=(z|0)==2;if(e&g){D=796;break}if(e&f){D=797;break}e=(z|0)==3;if(e&g){D=798;break}if(e&f){D=799;break}e=(z|0)==5;if(e&g){D=800;break}if(e&f){D=801;break}if((z|0)==6&f){D=802;break}else{G=75;break}}switch(e|0){case 2:{if(!(a|z)){D=803;break a}if((z|0)==2&(a|0)==2){D=804;break a}if((z|0)==3&(a|0)==3){D=805;break a}if((z|0)==5&(a|0)==5){D=806;break a}if((z|0)==6&(a|0)==6){D=807;break a}else{G=75;break a}}case 3:{if(!(a|z)){D=808;break a}if((z|0)==2&(a|0)==2){D=809;break a}if((z|0)==3&(a|0)==3){D=810;break a}if((z|0)==5&(a|0)==5){D=811;break a}if((z|0)==6&(a|0)==6){D=812;break a}else{G=75;break a}}default:{G=75;break a}}}while(0);if((G|0)==75){k[E>>2]=0;l=E+4|0;k[l>>2]=0;j=ZT(64)|0;k[j>>2]=1;h=j+4|0;k[E>>2]=h;k[l>>2]=57;i[j+61>>0]=0;j=220536;l=h+57|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-210,E,220440,216975,3836);S8(E)}jh[D&1023](M,F);if(v){G=E+4|0;D=G+4|0;k[D>>2]=0;k[D+4>>2]=0;k[E>>2]=33619968;k[G>>2]=L;SW(F,E,k[L>>2]&4095,1.0/+((q?k[s>>2]|0:k[t>>2]|0)|0),0.0)}e=k[x>>2]|0;if(e|0?(F=e+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){f=k[x>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[u>>2]|0;if(!e){e=B1()|0;f=k[x>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[x>>2]=0}k[x>>2]=0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[A>>2]|0)>0){f=k[y>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[A>>2]|0))}e=k[B>>2]|0;if(!((e|0)==(C|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[J>>2]|0;if(e|0?(F=e+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){f=k[J>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[H>>2]|0;if(e|0)break;e=B1()|0;f=k[J>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[J>>2]=0}k[J>>2]=0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[K>>2]|0)>0){f=k[L+40>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[K>>2]|0))}e=k[L+44>>2]|0;if(!((e|0)==(L+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=M+36|0;e=k[g>>2]|0;if(e|0?(K=e+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[M+32>>2]|0;if(e|0)break;e=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;L=M+16|0;f=M+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[f>>2]|0)>0){g=k[M+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[M+44>>2]|0;if((e|0)==(M+48|0)|(e|0)==0){r=N;return}ggb(k[e+-4>>2]|0);r=N;return}function U2(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0;u=k[a+40>>2]|0;w=k[u>>2]|0;t=((k[a>>2]|0)>>>3&511)+1|0;u=aa(t,k[u+4>>2]|0)|0;if((w|0)<=0)return;v=k[a+16>>2]|0;r=k[k[a+44>>2]>>2]|0;s=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(u|0)==(t|0);h=t<<1;i=t<<2;j=u-i|0;l=(h|0)>(j|0);m=t*3|0;n=(h|0)<(u|0);e=0;do{p=v+(aa(r,e)|0)|0;q=s+(aa(f,e)|0)|0;a:do if(g){a=0;do{k[q+(a<<2)>>2]=k[p+(a<<2)>>2];a=a+1|0}while((a|0)!=(t|0))}else{if(l){b=0;while(1){c=+o[p+(b<<2)>>2];d=+o[p+(b+t<<2)>>2];if(n){a=h;do{x=+o[p+(a+b<<2)>>2];c=x<c?x:c;a=a+t|0}while((a|0)<(u|0))}o[q+(b<<2)>>2]=d<c?d:c;b=b+1|0;if((b|0)==(t|0))break a}}else b=0;do{c=+o[p+(b<<2)>>2];a=h;d=+o[p+(b+t<<2)>>2];do{z=a+b|0;y=+o[p+(z<<2)>>2];y=y<c?y:c;x=+o[p+(z+t<<2)>>2];x=x<d?x:d;A=+o[p+(z+h<<2)>>2];c=A<y?A:y;y=+o[p+(z+m<<2)>>2];d=y<x?y:x;a=a+i|0}while((a|0)<=(j|0));if((a|0)<(u|0))do{A=+o[p+(a+b<<2)>>2];c=A<c?A:c;a=a+t|0}while((a|0)<(u|0));o[q+(b<<2)>>2]=d<c?d:c;b=b+1|0}while((b|0)!=(t|0))}while(0);e=e+1|0}while((e|0)!=(w|0));return}function V2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;u=k[a+40>>2]|0;w=k[u>>2]|0;t=((k[a>>2]|0)>>>3&511)+1|0;u=aa(t,k[u+4>>2]|0)|0;if((w|0)<=0)return;v=k[a+16>>2]|0;r=k[k[a+44>>2]>>2]|0;s=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(u|0)==(t|0);h=t<<1;i=t<<2;l=u-i|0;m=(h|0)>(l|0);n=t*3|0;o=(h|0)<(u|0);e=0;do{p=v+(aa(r,e)|0)|0;q=s+(aa(f,e)|0)|0;a:do if(g){a=0;do{j[q+(a<<1)>>1]=j[p+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(t|0))}else{if(m){c=0;while(1){a=j[p+(c<<1)>>1]|0;d=j[p+(c+t<<1)>>1]|0;if(o){b=h;do{x=j[p+(b+c<<1)>>1]|0;a=x<<16>>16<a<<16>>16?x:a;b=b+t|0}while((b|0)<(u|0))}j[q+(c<<1)>>1]=d<<16>>16<a<<16>>16?d:a;c=c+1|0;if((c|0)==(t|0))break a}}else d=0;do{a=j[p+(d<<1)>>1]|0;b=h;c=j[p+(d+t<<1)>>1]|0;do{y=b+d|0;z=j[p+(y<<1)>>1]|0;z=z<<16>>16<a<<16>>16?z:a;x=j[p+(y+t<<1)>>1]|0;x=x<<16>>16<c<<16>>16?x:c;A=j[p+(y+h<<1)>>1]|0;a=A<<16>>16<z<<16>>16?A:z;y=j[p+(y+n<<1)>>1]|0;c=y<<16>>16<x<<16>>16?y:x;b=b+i|0}while((b|0)<=(l|0));if((b|0)<(u|0))do{A=j[p+(b+d<<1)>>1]|0;a=A<<16>>16<a<<16>>16?A:a;b=b+t|0}while((b|0)<(u|0));j[q+(d<<1)>>1]=c<<16>>16<a<<16>>16?c:a;d=d+1|0}while((d|0)!=(t|0))}while(0);e=e+1|0}while((e|0)!=(w|0));return}function W2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;u=k[a+40>>2]|0;w=k[u>>2]|0;t=((k[a>>2]|0)>>>3&511)+1|0;u=aa(t,k[u+4>>2]|0)|0;if((w|0)<=0)return;v=k[a+16>>2]|0;r=k[k[a+44>>2]>>2]|0;s=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(u|0)==(t|0);h=t<<1;i=t<<2;l=u-i|0;m=(h|0)>(l|0);n=t*3|0;o=(h|0)<(u|0);e=0;do{p=v+(aa(r,e)|0)|0;q=s+(aa(f,e)|0)|0;a:do if(g){a=0;do{j[q+(a<<1)>>1]=j[p+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(t|0))}else{if(m){c=0;while(1){a=j[p+(c<<1)>>1]|0;d=j[p+(c+t<<1)>>1]|0;if(o){b=h;do{x=j[p+(b+c<<1)>>1]|0;a=(x&65535)<(a&65535)?x:a;b=b+t|0}while((b|0)<(u|0))}j[q+(c<<1)>>1]=(d&65535)<(a&65535)?d:a;c=c+1|0;if((c|0)==(t|0))break a}}else d=0;do{a=j[p+(d<<1)>>1]|0;b=h;c=j[p+(d+t<<1)>>1]|0;do{y=b+d|0;z=j[p+(y<<1)>>1]|0;z=(z&65535)<(a&65535)?z:a;x=j[p+(y+t<<1)>>1]|0;x=(x&65535)<(c&65535)?x:c;A=j[p+(y+h<<1)>>1]|0;a=(A&65535)<(z&65535)?A:z;y=j[p+(y+n<<1)>>1]|0;c=(y&65535)<(x&65535)?y:x;b=b+i|0}while((b|0)<=(l|0));if((b|0)<(u|0))do{A=j[p+(b+d<<1)>>1]|0;a=(A&65535)<(a&65535)?A:a;b=b+t|0}while((b|0)<(u|0));j[q+(d<<1)>>1]=(c&65535)<(a&65535)?c:a;d=d+1|0}while((d|0)!=(t|0))}while(0);e=e+1|0}while((e|0)!=(w|0));return}function X2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;w=k[a+40>>2]|0;y=k[w>>2]|0;v=((k[a>>2]|0)>>>3&511)+1|0;w=aa(v,k[w+4>>2]|0)|0;if((y|0)<=0)return;x=a+16|0;t=a+44|0;u=b+16|0;g=b+44|0;h=(w|0)==(v|0);j=v<<1;m=v<<2;n=w-m|0;o=(j|0)>(n|0);p=v*3|0;q=(j|0)<(w|0);f=0;do{r=(k[x>>2]|0)+(aa(k[k[t>>2]>>2]|0,f)|0)|0;s=(k[u>>2]|0)+(aa(k[k[g>>2]>>2]|0,f)|0)|0;a:do if(h){a=0;do{i[s+a>>0]=i[r+a>>0]|0;a=a+1|0}while((a|0)!=(v|0))}else{if(o){c=0;while(1){a=i[r+c>>0]|0;d=i[r+(c+v)>>0]|0;if(q){b=j;do{a=a&255;a=a-(l[352559+((a|256)-(l[r+(b+c)>>0]|0))>>0]|0)&255;b=b+v|0}while((b|0)<(w|0))}e=a&255;i[s+c>>0]=e-(l[352559+((e|256)-(d&255))>>0]|0);c=c+1|0;if((c|0)==(v|0))break a}}else e=0;do{b=i[r+e>>0]|0;c=j;a=i[r+(e+v)>>0]|0;while(1){d=c+e|0;z=b&255;z=z-(l[352559+((z|256)-(l[r+d>>0]|0))>>0]|0)|0;b=a&255;b=b-(l[352559+((b|256)-(l[r+(d+v)>>0]|0))>>0]|0)|0;a=z-(l[352559+((z&255|256)-(l[r+(d+j)>>0]|0))>>0]|0)|0;d=b-(l[352559+((b&255|256)-(l[r+(d+p)>>0]|0))>>0]|0)|0;c=c+m|0;if((c|0)>(n|0))break;else{b=a&255;a=d&255}}if((c|0)<(w|0))do{a=a&255;a=a-(l[352559+((a|256)-(l[r+(c+e)>>0]|0))>>0]|0)|0;c=c+v|0}while((c|0)<(w|0));i[s+e>>0]=a-(l[352559+((a&255|256)-(d&255))>>0]|0);e=e+1|0}while((e|0)!=(v|0))}while(0);f=f+1|0}while((f|0)!=(y|0));return}function Y2(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0;u=k[a+40>>2]|0;w=k[u>>2]|0;t=((k[a>>2]|0)>>>3&511)+1|0;u=aa(t,k[u+4>>2]|0)|0;if((w|0)<=0)return;v=k[a+16>>2]|0;r=k[k[a+44>>2]>>2]|0;s=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(u|0)==(t|0);h=t<<1;i=t<<2;j=u-i|0;l=(h|0)>(j|0);m=t*3|0;n=(h|0)<(u|0);e=0;do{p=v+(aa(r,e)|0)|0;q=s+(aa(f,e)|0)|0;a:do if(g){a=0;do{k[q+(a<<2)>>2]=k[p+(a<<2)>>2];a=a+1|0}while((a|0)!=(t|0))}else{if(l){b=0;while(1){c=+o[p+(b<<2)>>2];d=+o[p+(b+t<<2)>>2];if(n){a=h;do{x=+o[p+(a+b<<2)>>2];c=c<x?x:c;a=a+t|0}while((a|0)<(u|0))}o[q+(b<<2)>>2]=c<d?d:c;b=b+1|0;if((b|0)==(t|0))break a}}else b=0;do{c=+o[p+(b<<2)>>2];a=h;d=+o[p+(b+t<<2)>>2];do{z=a+b|0;y=+o[p+(z<<2)>>2];y=c<y?y:c;x=+o[p+(z+t<<2)>>2];x=d<x?x:d;A=+o[p+(z+h<<2)>>2];c=y<A?A:y;y=+o[p+(z+m<<2)>>2];d=x<y?y:x;a=a+i|0}while((a|0)<=(j|0));if((a|0)<(u|0))do{A=+o[p+(a+b<<2)>>2];c=c<A?A:c;a=a+t|0}while((a|0)<(u|0));o[q+(b<<2)>>2]=c<d?d:c;b=b+1|0}while((b|0)!=(t|0))}while(0);e=e+1|0}while((e|0)!=(w|0));return}function Z2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;u=k[a+40>>2]|0;w=k[u>>2]|0;t=((k[a>>2]|0)>>>3&511)+1|0;u=aa(t,k[u+4>>2]|0)|0;if((w|0)<=0)return;v=k[a+16>>2]|0;r=k[k[a+44>>2]>>2]|0;s=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(u|0)==(t|0);h=t<<1;i=t<<2;l=u-i|0;m=(h|0)>(l|0);n=t*3|0;o=(h|0)<(u|0);e=0;do{p=v+(aa(r,e)|0)|0;q=s+(aa(f,e)|0)|0;a:do if(g){a=0;do{j[q+(a<<1)>>1]=j[p+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(t|0))}else{if(m){c=0;while(1){a=j[p+(c<<1)>>1]|0;d=j[p+(c+t<<1)>>1]|0;if(o){b=h;do{x=j[p+(b+c<<1)>>1]|0;a=a<<16>>16<x<<16>>16?x:a;b=b+t|0}while((b|0)<(u|0))}j[q+(c<<1)>>1]=a<<16>>16<d<<16>>16?d:a;c=c+1|0;if((c|0)==(t|0))break a}}else d=0;do{a=j[p+(d<<1)>>1]|0;b=h;c=j[p+(d+t<<1)>>1]|0;do{y=b+d|0;z=j[p+(y<<1)>>1]|0;z=a<<16>>16<z<<16>>16?z:a;x=j[p+(y+t<<1)>>1]|0;x=c<<16>>16<x<<16>>16?x:c;A=j[p+(y+h<<1)>>1]|0;a=z<<16>>16<A<<16>>16?A:z;y=j[p+(y+n<<1)>>1]|0;c=x<<16>>16<y<<16>>16?y:x;b=b+i|0}while((b|0)<=(l|0));if((b|0)<(u|0))do{A=j[p+(b+d<<1)>>1]|0;a=a<<16>>16<A<<16>>16?A:a;b=b+t|0}while((b|0)<(u|0));j[q+(d<<1)>>1]=a<<16>>16<c<<16>>16?c:a;d=d+1|0}while((d|0)!=(t|0))}while(0);e=e+1|0}while((e|0)!=(w|0));return}function _2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;u=k[a+40>>2]|0;w=k[u>>2]|0;t=((k[a>>2]|0)>>>3&511)+1|0;u=aa(t,k[u+4>>2]|0)|0;if((w|0)<=0)return;v=k[a+16>>2]|0;r=k[k[a+44>>2]>>2]|0;s=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(u|0)==(t|0);h=t<<1;i=t<<2;l=u-i|0;m=(h|0)>(l|0);n=t*3|0;o=(h|0)<(u|0);e=0;do{p=v+(aa(r,e)|0)|0;q=s+(aa(f,e)|0)|0;a:do if(g){a=0;do{j[q+(a<<1)>>1]=j[p+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(t|0))}else{if(m){c=0;while(1){a=j[p+(c<<1)>>1]|0;d=j[p+(c+t<<1)>>1]|0;if(o){b=h;do{x=j[p+(b+c<<1)>>1]|0;a=(a&65535)<(x&65535)?x:a;b=b+t|0}while((b|0)<(u|0))}j[q+(c<<1)>>1]=(a&65535)<(d&65535)?d:a;c=c+1|0;if((c|0)==(t|0))break a}}else d=0;do{a=j[p+(d<<1)>>1]|0;b=h;c=j[p+(d+t<<1)>>1]|0;do{y=b+d|0;z=j[p+(y<<1)>>1]|0;z=(a&65535)<(z&65535)?z:a;x=j[p+(y+t<<1)>>1]|0;x=(c&65535)<(x&65535)?x:c;A=j[p+(y+h<<1)>>1]|0;a=(z&65535)<(A&65535)?A:z;y=j[p+(y+n<<1)>>1]|0;c=(x&65535)<(y&65535)?y:x;b=b+i|0}while((b|0)<=(l|0));if((b|0)<(u|0))do{A=j[p+(b+d<<1)>>1]|0;a=(a&65535)<(A&65535)?A:a;b=b+t|0}while((b|0)<(u|0));j[q+(d<<1)>>1]=(a&65535)<(c&65535)?c:a;d=d+1|0}while((d|0)!=(t|0))}while(0);e=e+1|0}while((e|0)!=(w|0));return}function $2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;w=k[a+40>>2]|0;y=k[w>>2]|0;v=((k[a>>2]|0)>>>3&511)+1|0;w=aa(v,k[w+4>>2]|0)|0;if((y|0)<=0)return;x=a+16|0;t=a+44|0;u=b+16|0;g=b+44|0;h=(w|0)==(v|0);j=v<<1;m=v<<2;n=w-m|0;o=(j|0)>(n|0);p=v*3|0;q=(j|0)<(w|0);f=0;do{r=(k[x>>2]|0)+(aa(k[k[t>>2]>>2]|0,f)|0)|0;s=(k[u>>2]|0)+(aa(k[k[g>>2]>>2]|0,f)|0)|0;a:do if(h){a=0;do{i[s+a>>0]=i[r+a>>0]|0;a=a+1|0}while((a|0)!=(v|0))}else{if(o){c=0;while(1){a=i[r+c>>0]|0;d=i[r+(c+v)>>0]|0;if(q){b=j;do{a=a&255;a=(l[352559+(256-a+(l[r+(b+c)>>0]|0))>>0]|0)+a&255;b=b+v|0}while((b|0)<(w|0))}e=a&255;i[s+c>>0]=(l[352559+((d&255|256)-e)>>0]|0)+e;c=c+1|0;if((c|0)==(v|0))break a}}else e=0;do{b=i[r+e>>0]|0;c=j;a=i[r+(e+v)>>0]|0;while(1){z=c+e|0;b=b&255;b=(l[352559+(256-b+(l[r+z>>0]|0))>>0]|0)+b|0;d=a&255;d=(l[352559+(256-d+(l[r+(z+v)>>0]|0))>>0]|0)+d|0;a=(l[352559+(256-(b&255)+(l[r+(z+j)>>0]|0))>>0]|0)+b|0;d=(l[352559+(256-(d&255)+(l[r+(z+p)>>0]|0))>>0]|0)+d|0;c=c+m|0;if((c|0)>(n|0))break;else{b=a&255;a=d&255}}if((c|0)<(w|0))do{a=a&255;a=(l[352559+(256-a+(l[r+(c+e)>>0]|0))>>0]|0)+a|0;c=c+v|0}while((c|0)<(w|0));i[s+e>>0]=(l[352559+((d&255|256)-(a&255))>>0]|0)+a;e=e+1|0}while((e|0)!=(v|0))}while(0);f=f+1|0}while((f|0)!=(y|0));return}function a3(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;v=k[a+40>>2]|0;x=k[v>>2]|0;u=((k[a>>2]|0)>>>3&511)+1|0;v=aa(u,k[v+4>>2]|0)|0;if((x|0)<=0)return;w=k[a+16>>2]|0;s=k[k[a+44>>2]>>2]|0;t=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(v|0)==(u|0);h=u<<1;i=u<<2;j=v-i|0;l=(h|0)>(j|0);m=u*3|0;n=(h|0)<(v|0);e=0;do{q=w+(aa(s,e)|0)|0;r=t+(aa(f,e)|0)|0;a:do if(g){a=0;do{p[r+(a<<3)>>3]=+o[q+(a<<2)>>2];a=a+1|0}while((a|0)!=(u|0))}else{if(l){b=0;while(1){c=+o[q+(b<<2)>>2];d=+o[q+(b+u<<2)>>2];if(n){a=h;do{c=c+ +o[q+(a+b<<2)>>2];a=a+u|0}while((a|0)<(v|0))}p[r+(b<<3)>>3]=d+c;b=b+1|0;if((b|0)==(u|0))break a}}else b=0;do{c=+o[q+(b<<2)>>2];a=h;d=+o[q+(b+u<<2)>>2];do{y=a+b|0;c=c+ +o[q+(y<<2)>>2]+ +o[q+(y+h<<2)>>2];d=d+ +o[q+(y+u<<2)>>2]+ +o[q+(y+m<<2)>>2];a=a+i|0}while((a|0)<=(j|0));if((a|0)<(v|0))do{c=c+ +o[q+(a+b<<2)>>2];a=a+u|0}while((a|0)<(v|0));p[r+(b<<3)>>3]=d+c;b=b+1|0}while((b|0)!=(u|0))}while(0);e=e+1|0}while((e|0)!=(x|0));return}function b3(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;u=k[a+40>>2]|0;w=k[u>>2]|0;t=((k[a>>2]|0)>>>3&511)+1|0;u=aa(t,k[u+4>>2]|0)|0;if((w|0)<=0)return;v=k[a+16>>2]|0;r=k[k[a+44>>2]>>2]|0;s=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(u|0)==(t|0);h=t<<1;i=t<<2;j=u-i|0;l=(h|0)>(j|0);m=t*3|0;n=(h|0)<(u|0);e=0;do{p=v+(aa(r,e)|0)|0;q=s+(aa(f,e)|0)|0;a:do if(g){a=0;do{k[q+(a<<2)>>2]=k[p+(a<<2)>>2];a=a+1|0}while((a|0)!=(t|0))}else{if(l){b=0;while(1){c=+o[p+(b<<2)>>2];d=+o[p+(b+t<<2)>>2];if(n){a=h;do{c=c+ +o[p+(a+b<<2)>>2];a=a+t|0}while((a|0)<(u|0))}o[q+(b<<2)>>2]=d+c;b=b+1|0;if((b|0)==(t|0))break a}}else b=0;do{c=+o[p+(b<<2)>>2];a=h;d=+o[p+(b+t<<2)>>2];do{x=a+b|0;c=c+ +o[p+(x<<2)>>2]+ +o[p+(x+h<<2)>>2];d=d+ +o[p+(x+t<<2)>>2]+ +o[p+(x+m<<2)>>2];a=a+i|0}while((a|0)<=(j|0));if((a|0)<(u|0))do{c=c+ +o[p+(a+b<<2)>>2];a=a+t|0}while((a|0)<(u|0));o[q+(b<<2)>>2]=d+c;b=b+1|0}while((b|0)!=(t|0))}while(0);e=e+1|0}while((e|0)!=(w|0));return}function c3(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;v=k[a+40>>2]|0;x=k[v>>2]|0;u=((k[a>>2]|0)>>>3&511)+1|0;v=aa(u,k[v+4>>2]|0)|0;if((x|0)<=0)return;w=k[a+16>>2]|0;s=k[k[a+44>>2]>>2]|0;t=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(v|0)==(u|0);h=u<<1;i=u<<2;l=v-i|0;m=(h|0)>(l|0);n=u*3|0;o=(h|0)<(v|0);e=0;do{q=w+(aa(s,e)|0)|0;r=t+(aa(f,e)|0)|0;a:do if(g){a=0;do{p[r+(a<<3)>>3]=+(j[q+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(u|0))}else{if(m){b=0;while(1){c=+(j[q+(b<<1)>>1]|0);d=+(j[q+(b+u<<1)>>1]|0);if(o){a=h;do{c=c+ +(j[q+(a+b<<1)>>1]|0);a=a+u|0}while((a|0)<(v|0))}p[r+(b<<3)>>3]=d+c;b=b+1|0;if((b|0)==(u|0))break a}}else b=0;do{c=+(j[q+(b<<1)>>1]|0);a=h;d=+(j[q+(b+u<<1)>>1]|0);do{y=a+b|0;c=c+ +(j[q+(y<<1)>>1]|0)+ +(j[q+(y+h<<1)>>1]|0);d=d+ +(j[q+(y+u<<1)>>1]|0)+ +(j[q+(y+n<<1)>>1]|0);a=a+i|0}while((a|0)<=(l|0));if((a|0)<(v|0))do{c=c+ +(j[q+(a+b<<1)>>1]|0);a=a+u|0}while((a|0)<(v|0));p[r+(b<<3)>>3]=d+c;b=b+1|0}while((b|0)!=(u|0))}while(0);e=e+1|0}while((e|0)!=(x|0));return}function d3(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;v=k[a+40>>2]|0;x=k[v>>2]|0;u=((k[a>>2]|0)>>>3&511)+1|0;v=aa(u,k[v+4>>2]|0)|0;if((x|0)<=0)return;w=k[a+16>>2]|0;s=k[k[a+44>>2]>>2]|0;t=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(v|0)==(u|0);h=u<<1;i=u<<2;l=v-i|0;m=(h|0)>(l|0);n=u*3|0;p=(h|0)<(v|0);e=0;do{q=w+(aa(s,e)|0)|0;r=t+(aa(f,e)|0)|0;a:do if(g){a=0;do{o[r+(a<<2)>>2]=+(j[q+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(u|0))}else{if(m){b=0;while(1){c=+(j[q+(b<<1)>>1]|0);d=+(j[q+(b+u<<1)>>1]|0);if(p){a=h;do{c=c+ +(j[q+(a+b<<1)>>1]|0);a=a+u|0}while((a|0)<(v|0))}o[r+(b<<2)>>2]=d+c;b=b+1|0;if((b|0)==(u|0))break a}}else b=0;do{c=+(j[q+(b<<1)>>1]|0);a=h;d=+(j[q+(b+u<<1)>>1]|0);do{y=a+b|0;c=c+ +(j[q+(y<<1)>>1]|0)+ +(j[q+(y+h<<1)>>1]|0);d=d+ +(j[q+(y+u<<1)>>1]|0)+ +(j[q+(y+n<<1)>>1]|0);a=a+i|0}while((a|0)<=(l|0));if((a|0)<(v|0))do{c=c+ +(j[q+(a+b<<1)>>1]|0);a=a+u|0}while((a|0)<(v|0));o[r+(b<<2)>>2]=d+c;b=b+1|0}while((b|0)!=(u|0))}while(0);e=e+1|0}while((e|0)!=(x|0));return}function e3(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;v=k[a+40>>2]|0;x=k[v>>2]|0;u=((k[a>>2]|0)>>>3&511)+1|0;v=aa(u,k[v+4>>2]|0)|0;if((x|0)<=0)return;w=k[a+16>>2]|0;s=k[k[a+44>>2]>>2]|0;t=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(v|0)==(u|0);h=u<<1;i=u<<2;j=v-i|0;l=(h|0)>(j|0);n=u*3|0;o=(h|0)<(v|0);e=0;do{q=w+(aa(s,e)|0)|0;r=t+(aa(f,e)|0)|0;a:do if(g){a=0;do{p[r+(a<<3)>>3]=+(m[q+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(u|0))}else{if(l){b=0;while(1){c=+(m[q+(b<<1)>>1]|0);d=+(m[q+(b+u<<1)>>1]|0);if(o){a=h;do{c=c+ +(m[q+(a+b<<1)>>1]|0);a=a+u|0}while((a|0)<(v|0))}p[r+(b<<3)>>3]=d+c;b=b+1|0;if((b|0)==(u|0))break a}}else b=0;do{c=+(m[q+(b<<1)>>1]|0);a=h;d=+(m[q+(b+u<<1)>>1]|0);do{y=a+b|0;c=c+ +(m[q+(y<<1)>>1]|0)+ +(m[q+(y+h<<1)>>1]|0);d=d+ +(m[q+(y+u<<1)>>1]|0)+ +(m[q+(y+n<<1)>>1]|0);a=a+i|0}while((a|0)<=(j|0));if((a|0)<(v|0))do{c=c+ +(m[q+(a+b<<1)>>1]|0);a=a+u|0}while((a|0)<(v|0));p[r+(b<<3)>>3]=d+c;b=b+1|0}while((b|0)!=(u|0))}while(0);e=e+1|0}while((e|0)!=(x|0));return}function f3(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;v=k[a+40>>2]|0;x=k[v>>2]|0;u=((k[a>>2]|0)>>>3&511)+1|0;v=aa(u,k[v+4>>2]|0)|0;if((x|0)<=0)return;w=k[a+16>>2]|0;s=k[k[a+44>>2]>>2]|0;t=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(v|0)==(u|0);h=u<<1;i=u<<2;j=v-i|0;l=(h|0)>(j|0);n=u*3|0;p=(h|0)<(v|0);e=0;do{q=w+(aa(s,e)|0)|0;r=t+(aa(f,e)|0)|0;a:do if(g){a=0;do{o[r+(a<<2)>>2]=+(m[q+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(u|0))}else{if(l){b=0;while(1){c=+(m[q+(b<<1)>>1]|0);d=+(m[q+(b+u<<1)>>1]|0);if(p){a=h;do{c=c+ +(m[q+(a+b<<1)>>1]|0);a=a+u|0}while((a|0)<(v|0))}o[r+(b<<2)>>2]=d+c;b=b+1|0;if((b|0)==(u|0))break a}}else b=0;do{c=+(m[q+(b<<1)>>1]|0);a=h;d=+(m[q+(b+u<<1)>>1]|0);do{y=a+b|0;c=c+ +(m[q+(y<<1)>>1]|0)+ +(m[q+(y+h<<1)>>1]|0);d=d+ +(m[q+(y+u<<1)>>1]|0)+ +(m[q+(y+n<<1)>>1]|0);a=a+i|0}while((a|0)<=(j|0));if((a|0)<(v|0))do{c=c+ +(m[q+(a+b<<1)>>1]|0);a=a+u|0}while((a|0)<(v|0));o[r+(b<<2)>>2]=d+c;b=b+1|0}while((b|0)!=(u|0))}while(0);e=e+1|0}while((e|0)!=(x|0));return}function g3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;q=k[a+40>>2]|0;x=k[q>>2]|0;o=((k[a>>2]|0)>>>3&511)+1|0;q=aa(o,k[q+4>>2]|0)|0;if((x|0)<=0)return;r=(q|0)==(o|0);s=o<<1;t=o<<2;u=q-t|0;v=(s|0)>(u|0);w=o*3|0;n=k[a+16>>2]|0;j=k[k[a+44>>2]>>2]|0;m=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(s|0)<(q|0);e=0;do{h=n+(aa(j,e)|0)|0;i=m+(aa(f,e)|0)|0;a:do if(r){a=0;do{p[i+(a<<3)>>3]=+(l[h+a>>0]|0);a=a+1|0}while((a|0)!=(o|0))}else{if(v){c=0;while(1){a=l[h+c>>0]|0;d=l[h+(c+o)>>0]|0;if(g){b=s;do{a=(l[h+(b+c)>>0]|0)+a|0;b=b+o|0}while((b|0)<(q|0))}p[i+(c<<3)>>3]=+(a+d|0);c=c+1|0;if((c|0)==(o|0))break a}}else d=0;do{a=l[h+d>>0]|0;b=s;c=l[h+(d+o)>>0]|0;do{y=b+d|0;a=(l[h+y>>0]|0)+a+(l[h+(y+s)>>0]|0)|0;c=(l[h+(y+o)>>0]|0)+c+(l[h+(y+w)>>0]|0)|0;b=b+t|0}while((b|0)<=(u|0));if((b|0)<(q|0))do{a=(l[h+(b+d)>>0]|0)+a|0;b=b+o|0}while((b|0)<(q|0));p[i+(d<<3)>>3]=+(a+c|0);d=d+1|0}while((d|0)!=(o|0))}while(0);e=e+1|0}while((e|0)!=(x|0));return}function h3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;q=k[a+40>>2]|0;x=k[q>>2]|0;p=((k[a>>2]|0)>>>3&511)+1|0;q=aa(p,k[q+4>>2]|0)|0;if((x|0)<=0)return;r=(q|0)==(p|0);s=p<<1;t=p<<2;u=q-t|0;v=(s|0)>(u|0);w=p*3|0;n=k[a+16>>2]|0;j=k[k[a+44>>2]>>2]|0;m=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(s|0)<(q|0);e=0;do{h=n+(aa(j,e)|0)|0;i=m+(aa(f,e)|0)|0;a:do if(r){a=0;do{o[i+(a<<2)>>2]=+(l[h+a>>0]|0);a=a+1|0}while((a|0)!=(p|0))}else{if(v){c=0;while(1){a=l[h+c>>0]|0;d=l[h+(c+p)>>0]|0;if(g){b=s;do{a=(l[h+(b+c)>>0]|0)+a|0;b=b+p|0}while((b|0)<(q|0))}o[i+(c<<2)>>2]=+(a+d|0);c=c+1|0;if((c|0)==(p|0))break a}}else d=0;do{a=l[h+d>>0]|0;b=s;c=l[h+(d+p)>>0]|0;do{y=b+d|0;a=(l[h+y>>0]|0)+a+(l[h+(y+s)>>0]|0)|0;c=(l[h+(y+p)>>0]|0)+c+(l[h+(y+w)>>0]|0)|0;b=b+t|0}while((b|0)<=(u|0));if((b|0)<(q|0))do{a=(l[h+(b+d)>>0]|0)+a|0;b=b+p|0}while((b|0)<(q|0));o[i+(d<<2)>>2]=+(a+c|0);d=d+1|0}while((d|0)!=(p|0))}while(0);e=e+1|0}while((e|0)!=(x|0));return}function i3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;p=k[a+40>>2]|0;w=k[p>>2]|0;o=((k[a>>2]|0)>>>3&511)+1|0;p=aa(o,k[p+4>>2]|0)|0;if((w|0)<=0)return;q=(p|0)==(o|0);r=o<<1;s=o<<2;t=p-s|0;u=(r|0)>(t|0);v=o*3|0;n=k[a+16>>2]|0;j=k[a+44>>2]|0;m=k[b+16>>2]|0;f=k[b+44>>2]|0;g=(r|0)<(p|0);e=0;do{h=n+(aa(k[j>>2]|0,e)|0)|0;i=m+(aa(k[f>>2]|0,e)|0)|0;a:do if(q){a=0;do{k[i+(a<<2)>>2]=l[h+a>>0];a=a+1|0}while((a|0)!=(o|0))}else{if(u){c=0;while(1){a=l[h+c>>0]|0;d=l[h+(c+o)>>0]|0;if(g){b=r;do{a=(l[h+(b+c)>>0]|0)+a|0;b=b+o|0}while((b|0)<(p|0))}k[i+(c<<2)>>2]=a+d;c=c+1|0;if((c|0)==(o|0))break a}}else d=0;do{a=l[h+d>>0]|0;b=r;c=l[h+(d+o)>>0]|0;do{x=b+d|0;a=(l[h+x>>0]|0)+a+(l[h+(x+r)>>0]|0)|0;c=(l[h+(x+o)>>0]|0)+c+(l[h+(x+v)>>0]|0)|0;b=b+s|0}while((b|0)<=(t|0));if((b|0)<(p|0))do{a=(l[h+(b+d)>>0]|0)+a|0;b=b+o|0}while((b|0)<(p|0));k[i+(d<<2)>>2]=a+c;d=d+1|0}while((d|0)!=(o|0))}while(0);e=e+1|0}while((e|0)!=(w|0));return}function j3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0;q=r;r=r+1072|0;p=q;l=k[a+40>>2]|0;e=k[l>>2]|0;l=aa(((k[a>>2]|0)>>>3&511)+1|0,k[l+4>>2]|0)|0;m=p+8|0;k[p>>2]=m;n=p+4|0;k[n>>2]=264;if(l>>>0>264){d=l>>>0>1073741823?-1:l<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[p>>2]=c;j=c}else j=m;k[n>>2]=l;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>2;h=(l|0)>0;if(h){c=0;do{k[j+(c<<2)>>2]=k[b+(c<<2)>>2];c=c+1|0}while((c|0)!=(l|0))}d=e+-1|0;a:do if(d|0){a=l+-4|0;if((l|0)<4)while(1){b=b+(g<<2)|0;if(h){c=0;do{f=j+(c<<2)|0;s=+o[f>>2];t=+o[b+(c<<2)>>2];o[f>>2]=t<s?t:s;c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0;if(!d)break a}e=l&-4;f=(e|0)<(l|0);do{b=b+(g<<2)|0;c=0;do{v=j+(c<<2)|0;t=+o[v>>2];s=+o[b+(c<<2)>>2];u=c|1;y=j+(u<<2)|0;w=+o[y>>2];x=+o[b+(u<<2)>>2];o[v>>2]=s<t?s:t;o[y>>2]=x<w?x:w;y=c|2;v=j+(y<<2)|0;w=+o[v>>2];x=+o[b+(y<<2)>>2];y=c|3;u=j+(y<<2)|0;t=+o[u>>2];s=+o[b+(y<<2)>>2];o[v>>2]=x<w?x:w;o[u>>2]=s<t?s:t;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{y=j+(c<<2)|0;x=+o[y>>2];w=+o[b+(c<<2)>>2];o[y>>2]=w<x?w:x;c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{k[i+(c<<2)>>2]=k[j+(c<<2)>>2];c=c+1|0}while((c|0)!=(l|0))}if((j|0)==(m|0)){r=q;return}ggb(j);k[p>>2]=m;k[n>>2]=264;r=q;return}function k3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;q=r;r=r+1056|0;p=q;m=k[a+40>>2]|0;e=k[m>>2]|0;m=aa(((k[a>>2]|0)>>>3&511)+1|0,k[m+4>>2]|0)|0;n=p+8|0;k[p>>2]=n;o=p+4|0;k[o>>2]=520;if(m>>>0>520){d=m>>>0>2147483647?-1:m<<1;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[p>>2]=c;l=c}else l=n;k[o>>2]=m;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>1;h=(m|0)>0;if(h){c=0;do{j[l+(c<<1)>>1]=j[b+(c<<1)>>1]|0;c=c+1|0}while((c|0)!=(m|0))}d=e+-1|0;a:do if(d|0){a=m+-4|0;if((m|0)<4)while(1){b=b+(g<<1)|0;if(h){c=0;do{f=l+(c<<1)|0;e=j[f>>1]|0;a=j[b+(c<<1)>>1]|0;j[f>>1]=a<<16>>16<e<<16>>16?a:e;c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0;if(!d)break a}e=m&-4;f=(e|0)<(m|0);do{b=b+(g<<1)|0;c=0;do{u=l+(c<<1)|0;s=j[u>>1]|0;t=j[b+(c<<1)>>1]|0;w=c|1;x=l+(w<<1)|0;v=j[x>>1]|0;w=j[b+(w<<1)>>1]|0;j[u>>1]=t<<16>>16<s<<16>>16?t:s;j[x>>1]=w<<16>>16<v<<16>>16?w:v;x=c|2;v=l+(x<<1)|0;w=j[v>>1]|0;x=j[b+(x<<1)>>1]|0;u=c|3;s=l+(u<<1)|0;t=j[s>>1]|0;u=j[b+(u<<1)>>1]|0;j[v>>1]=x<<16>>16<w<<16>>16?x:w;j[s>>1]=u<<16>>16<t<<16>>16?u:t;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{x=l+(c<<1)|0;w=j[x>>1]|0;v=j[b+(c<<1)>>1]|0;j[x>>1]=v<<16>>16<w<<16>>16?v:w;c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{j[i+(c<<1)>>1]=j[l+(c<<1)>>1]|0;c=c+1|0}while((c|0)!=(m|0))}if((l|0)==(n|0)){r=q;return}ggb(l);k[p>>2]=n;k[o>>2]=520;r=q;return}function l3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;q=r;r=r+1056|0;p=q;m=k[a+40>>2]|0;e=k[m>>2]|0;m=aa(((k[a>>2]|0)>>>3&511)+1|0,k[m+4>>2]|0)|0;n=p+8|0;k[p>>2]=n;o=p+4|0;k[o>>2]=520;if(m>>>0>520){d=m>>>0>2147483647?-1:m<<1;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[p>>2]=c;l=c}else l=n;k[o>>2]=m;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>1;h=(m|0)>0;if(h){c=0;do{j[l+(c<<1)>>1]=j[b+(c<<1)>>1]|0;c=c+1|0}while((c|0)!=(m|0))}d=e+-1|0;a:do if(d|0){a=m+-4|0;if((m|0)<4)while(1){b=b+(g<<1)|0;if(h){c=0;do{f=l+(c<<1)|0;e=j[f>>1]|0;a=j[b+(c<<1)>>1]|0;j[f>>1]=(a&65535)<(e&65535)?a:e;c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0;if(!d)break a}e=m&-4;f=(e|0)<(m|0);do{b=b+(g<<1)|0;c=0;do{u=l+(c<<1)|0;s=j[u>>1]|0;t=j[b+(c<<1)>>1]|0;w=c|1;x=l+(w<<1)|0;v=j[x>>1]|0;w=j[b+(w<<1)>>1]|0;j[u>>1]=(t&65535)<(s&65535)?t:s;j[x>>1]=(w&65535)<(v&65535)?w:v;x=c|2;v=l+(x<<1)|0;w=j[v>>1]|0;x=j[b+(x<<1)>>1]|0;u=c|3;s=l+(u<<1)|0;t=j[s>>1]|0;u=j[b+(u<<1)>>1]|0;j[v>>1]=(x&65535)<(w&65535)?x:w;j[s>>1]=(u&65535)<(t&65535)?u:t;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{x=l+(c<<1)|0;w=j[x>>1]|0;v=j[b+(c<<1)>>1]|0;j[x>>1]=(v&65535)<(w&65535)?v:w;c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{j[i+(c<<1)>>1]=j[l+(c<<1)>>1]|0;c=c+1|0}while((c|0)!=(m|0))}if((l|0)==(n|0)){r=q;return}ggb(l);k[p>>2]=n;k[o>>2]=520;r=q;return}function m3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;s=r;r=r+1040|0;q=s;n=k[a+40>>2]|0;e=k[n>>2]|0;n=aa(((k[a>>2]|0)>>>3&511)+1|0,k[n+4>>2]|0)|0;o=q+8|0;k[q>>2]=o;p=q+4|0;k[p>>2]=1032;if(n>>>0>1032){while(1){c=fgb(n)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[q>>2]=c}else c=o;k[p>>2]=n;m=k[b+16>>2]|0;d=k[a+16>>2]|0;h=k[a+48>>2]|0;j=(n|0)>0;if(j){b=0;do{i[c+b>>0]=i[d+b>>0]|0;b=b+1|0}while((b|0)!=(n|0))}a=e+-1|0;a:do if(a|0){e=n+-4|0;if((n|0)<4)while(1){d=d+h|0;if(j){b=0;do{g=c+b|0;f=l[g>>0]|0;i[g>>0]=f-(l[352559+((f|256)-(l[d+b>>0]|0))>>0]|0);b=b+1|0}while((b|0)!=(n|0))}a=a+-1|0;if(!a)break a}f=n&-4;g=(f|0)<(n|0);do{d=d+h|0;b=0;do{x=c+b|0;u=l[x>>0]|0;v=b|1;w=c+v|0;t=l[w>>0]|0;v=t-(l[352559+((t|256)-(l[d+v>>0]|0))>>0]|0)&255;i[x>>0]=u-(l[352559+((u|256)-(l[d+b>>0]|0))>>0]|0);i[w>>0]=v;w=b|2;v=c+w|0;x=l[v>>0]|0;u=b|3;t=c+u|0;y=l[t>>0]|0;u=y-(l[352559+((y|256)-(l[d+u>>0]|0))>>0]|0)&255;i[v>>0]=x-(l[352559+((x|256)-(l[d+w>>0]|0))>>0]|0);i[t>>0]=u;b=b+4|0}while((b|0)<=(e|0));if(g){b=f;do{y=c+b|0;x=l[y>>0]|0;i[y>>0]=x-(l[352559+((x|256)-(l[d+b>>0]|0))>>0]|0);b=b+1|0}while((b|0)!=(n|0))}a=a+-1|0}while((a|0)!=0)}while(0);if(j){b=0;do{i[m+b>>0]=i[c+b>>0]|0;b=b+1|0}while((b|0)!=(n|0));c=k[q>>2]|0}if((c|0)==(o|0)){r=s;return}if(c|0)ggb(c);k[q>>2]=o;k[p>>2]=1032;r=s;return}function n3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0;q=r;r=r+1072|0;p=q;l=k[a+40>>2]|0;e=k[l>>2]|0;l=aa(((k[a>>2]|0)>>>3&511)+1|0,k[l+4>>2]|0)|0;m=p+8|0;k[p>>2]=m;n=p+4|0;k[n>>2]=264;if(l>>>0>264){d=l>>>0>1073741823?-1:l<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[p>>2]=c;j=c}else j=m;k[n>>2]=l;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>2;h=(l|0)>0;if(h){c=0;do{k[j+(c<<2)>>2]=k[b+(c<<2)>>2];c=c+1|0}while((c|0)!=(l|0))}d=e+-1|0;a:do if(d|0){a=l+-4|0;if((l|0)<4)while(1){b=b+(g<<2)|0;if(h){c=0;do{f=j+(c<<2)|0;s=+o[f>>2];t=+o[b+(c<<2)>>2];o[f>>2]=s<t?t:s;c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0;if(!d)break a}e=l&-4;f=(e|0)<(l|0);do{b=b+(g<<2)|0;c=0;do{v=j+(c<<2)|0;t=+o[v>>2];s=+o[b+(c<<2)>>2];u=c|1;y=j+(u<<2)|0;w=+o[y>>2];x=+o[b+(u<<2)>>2];o[v>>2]=t<s?s:t;o[y>>2]=w<x?x:w;y=c|2;v=j+(y<<2)|0;w=+o[v>>2];x=+o[b+(y<<2)>>2];y=c|3;u=j+(y<<2)|0;t=+o[u>>2];s=+o[b+(y<<2)>>2];o[v>>2]=w<x?x:w;o[u>>2]=t<s?s:t;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{y=j+(c<<2)|0;x=+o[y>>2];w=+o[b+(c<<2)>>2];o[y>>2]=x<w?w:x;c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{k[i+(c<<2)>>2]=k[j+(c<<2)>>2];c=c+1|0}while((c|0)!=(l|0))}if((j|0)==(m|0)){r=q;return}ggb(j);k[p>>2]=m;k[n>>2]=264;r=q;return}function o3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;q=r;r=r+1056|0;p=q;m=k[a+40>>2]|0;e=k[m>>2]|0;m=aa(((k[a>>2]|0)>>>3&511)+1|0,k[m+4>>2]|0)|0;n=p+8|0;k[p>>2]=n;o=p+4|0;k[o>>2]=520;if(m>>>0>520){d=m>>>0>2147483647?-1:m<<1;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[p>>2]=c;l=c}else l=n;k[o>>2]=m;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>1;h=(m|0)>0;if(h){c=0;do{j[l+(c<<1)>>1]=j[b+(c<<1)>>1]|0;c=c+1|0}while((c|0)!=(m|0))}d=e+-1|0;a:do if(d|0){a=m+-4|0;if((m|0)<4)while(1){b=b+(g<<1)|0;if(h){c=0;do{f=l+(c<<1)|0;e=j[f>>1]|0;a=j[b+(c<<1)>>1]|0;j[f>>1]=e<<16>>16<a<<16>>16?a:e;c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0;if(!d)break a}e=m&-4;f=(e|0)<(m|0);do{b=b+(g<<1)|0;c=0;do{u=l+(c<<1)|0;s=j[u>>1]|0;t=j[b+(c<<1)>>1]|0;w=c|1;x=l+(w<<1)|0;v=j[x>>1]|0;w=j[b+(w<<1)>>1]|0;j[u>>1]=s<<16>>16<t<<16>>16?t:s;j[x>>1]=v<<16>>16<w<<16>>16?w:v;x=c|2;v=l+(x<<1)|0;w=j[v>>1]|0;x=j[b+(x<<1)>>1]|0;u=c|3;s=l+(u<<1)|0;t=j[s>>1]|0;u=j[b+(u<<1)>>1]|0;j[v>>1]=w<<16>>16<x<<16>>16?x:w;j[s>>1]=t<<16>>16<u<<16>>16?u:t;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{x=l+(c<<1)|0;w=j[x>>1]|0;v=j[b+(c<<1)>>1]|0;j[x>>1]=w<<16>>16<v<<16>>16?v:w;c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{j[i+(c<<1)>>1]=j[l+(c<<1)>>1]|0;c=c+1|0}while((c|0)!=(m|0))}if((l|0)==(n|0)){r=q;return}ggb(l);k[p>>2]=n;k[o>>2]=520;r=q;return}function p3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;q=r;r=r+1056|0;p=q;m=k[a+40>>2]|0;e=k[m>>2]|0;m=aa(((k[a>>2]|0)>>>3&511)+1|0,k[m+4>>2]|0)|0;n=p+8|0;k[p>>2]=n;o=p+4|0;k[o>>2]=520;if(m>>>0>520){d=m>>>0>2147483647?-1:m<<1;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[p>>2]=c;l=c}else l=n;k[o>>2]=m;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>1;h=(m|0)>0;if(h){c=0;do{j[l+(c<<1)>>1]=j[b+(c<<1)>>1]|0;c=c+1|0}while((c|0)!=(m|0))}d=e+-1|0;a:do if(d|0){a=m+-4|0;if((m|0)<4)while(1){b=b+(g<<1)|0;if(h){c=0;do{f=l+(c<<1)|0;e=j[f>>1]|0;a=j[b+(c<<1)>>1]|0;j[f>>1]=(e&65535)<(a&65535)?a:e;c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0;if(!d)break a}e=m&-4;f=(e|0)<(m|0);do{b=b+(g<<1)|0;c=0;do{u=l+(c<<1)|0;s=j[u>>1]|0;t=j[b+(c<<1)>>1]|0;w=c|1;x=l+(w<<1)|0;v=j[x>>1]|0;w=j[b+(w<<1)>>1]|0;j[u>>1]=(s&65535)<(t&65535)?t:s;j[x>>1]=(v&65535)<(w&65535)?w:v;x=c|2;v=l+(x<<1)|0;w=j[v>>1]|0;x=j[b+(x<<1)>>1]|0;u=c|3;s=l+(u<<1)|0;t=j[s>>1]|0;u=j[b+(u<<1)>>1]|0;j[v>>1]=(w&65535)<(x&65535)?x:w;j[s>>1]=(t&65535)<(u&65535)?u:t;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{x=l+(c<<1)|0;w=j[x>>1]|0;v=j[b+(c<<1)>>1]|0;j[x>>1]=(w&65535)<(v&65535)?v:w;c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{j[i+(c<<1)>>1]=j[l+(c<<1)>>1]|0;c=c+1|0}while((c|0)!=(m|0))}if((l|0)==(n|0)){r=q;return}ggb(l);k[p>>2]=n;k[o>>2]=520;r=q;return}function q3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;s=r;r=r+1040|0;q=s;n=k[a+40>>2]|0;e=k[n>>2]|0;n=aa(((k[a>>2]|0)>>>3&511)+1|0,k[n+4>>2]|0)|0;o=q+8|0;k[q>>2]=o;p=q+4|0;k[p>>2]=1032;if(n>>>0>1032){while(1){c=fgb(n)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[q>>2]=c}else c=o;k[p>>2]=n;m=k[b+16>>2]|0;d=k[a+16>>2]|0;h=k[a+48>>2]|0;j=(n|0)>0;if(j){b=0;do{i[c+b>>0]=i[d+b>>0]|0;b=b+1|0}while((b|0)!=(n|0))}a=e+-1|0;a:do if(a|0){e=n+-4|0;if((n|0)<4)while(1){d=d+h|0;if(j){b=0;do{g=c+b|0;f=l[g>>0]|0;i[g>>0]=(l[352559+(256-f+(l[d+b>>0]|0))>>0]|0)+f;b=b+1|0}while((b|0)!=(n|0))}a=a+-1|0;if(!a)break a}f=n&-4;g=(f|0)<(n|0);do{d=d+h|0;b=0;do{w=c+b|0;y=l[w>>0]|0;t=b|1;x=c+t|0;v=l[x>>0]|0;v=(l[352559+(256-v+(l[d+t>>0]|0))>>0]|0)+v&255;i[w>>0]=(l[352559+(256-y+(l[d+b>>0]|0))>>0]|0)+y;i[x>>0]=v;x=b|2;v=c+x|0;w=l[v>>0]|0;y=b|3;t=c+y|0;u=l[t>>0]|0;u=(l[352559+(256-u+(l[d+y>>0]|0))>>0]|0)+u&255;i[v>>0]=(l[352559+(256-w+(l[d+x>>0]|0))>>0]|0)+w;i[t>>0]=u;b=b+4|0}while((b|0)<=(e|0));if(g){b=f;do{y=c+b|0;x=l[y>>0]|0;i[y>>0]=(l[352559+(256-x+(l[d+b>>0]|0))>>0]|0)+x;b=b+1|0}while((b|0)!=(n|0))}a=a+-1|0}while((a|0)!=0)}while(0);if(j){b=0;do{i[m+b>>0]=i[c+b>>0]|0;b=b+1|0}while((b|0)!=(n|0));c=k[q>>2]|0}if((c|0)==(o|0)){r=s;return}if(c|0)ggb(c);k[q>>2]=o;k[p>>2]=1032;r=s;return}function r3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0.0,v=0,w=0,x=0;s=r;r=r+1104|0;q=s;l=k[a+40>>2]|0;e=k[l>>2]|0;l=aa(((k[a>>2]|0)>>>3&511)+1|0,k[l+4>>2]|0)|0;m=q+8|0;k[q>>2]=m;n=q+4|0;k[n>>2]=136;if(l>>>0>136){d=l>>>0>536870911?-1:l<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[q>>2]=c;j=c}else j=m;k[n>>2]=l;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>2;h=(l|0)>0;if(h){c=0;do{p[j+(c<<3)>>3]=+o[b+(c<<2)>>2];c=c+1|0}while((c|0)!=(l|0))}d=e+-1|0;a:do if(d|0){a=l+-4|0;if((l|0)<4)while(1){b=b+(g<<2)|0;if(h){c=0;do{f=j+(c<<3)|0;p[f>>3]=+p[f>>3]+ +o[b+(c<<2)>>2];c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0;if(!d)break a}e=l&-4;f=(e|0)<(l|0);do{b=b+(g<<2)|0;c=0;do{v=j+(c<<3)|0;x=c|1;w=j+(x<<3)|0;u=+p[w>>3]+ +o[b+(x<<2)>>2];p[v>>3]=+p[v>>3]+ +o[b+(c<<2)>>2];p[w>>3]=u;w=c|2;v=j+(w<<3)|0;x=c|3;t=j+(x<<3)|0;u=+p[t>>3]+ +o[b+(x<<2)>>2];p[v>>3]=+p[v>>3]+ +o[b+(w<<2)>>2];p[t>>3]=u;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{x=j+(c<<3)|0;p[x>>3]=+p[x>>3]+ +o[b+(c<<2)>>2];c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{p[i+(c<<3)>>3]=+p[j+(c<<3)>>3];c=c+1|0}while((c|0)!=(l|0))}if((j|0)==(m|0)){r=s;return}ggb(j);k[q>>2]=m;k[n>>2]=136;r=s;return}function s3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0.0,u=0,v=0,w=0;q=r;r=r+1072|0;p=q;l=k[a+40>>2]|0;e=k[l>>2]|0;l=aa(((k[a>>2]|0)>>>3&511)+1|0,k[l+4>>2]|0)|0;m=p+8|0;k[p>>2]=m;n=p+4|0;k[n>>2]=264;if(l>>>0>264){d=l>>>0>1073741823?-1:l<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[p>>2]=c;j=c}else j=m;k[n>>2]=l;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>2;h=(l|0)>0;if(h){c=0;do{k[j+(c<<2)>>2]=k[b+(c<<2)>>2];c=c+1|0}while((c|0)!=(l|0))}d=e+-1|0;a:do if(d|0){a=l+-4|0;if((l|0)<4)while(1){b=b+(g<<2)|0;if(h){c=0;do{f=j+(c<<2)|0;o[f>>2]=+o[f>>2]+ +o[b+(c<<2)>>2];c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0;if(!d)break a}e=l&-4;f=(e|0)<(l|0);do{b=b+(g<<2)|0;c=0;do{u=j+(c<<2)|0;w=c|1;v=j+(w<<2)|0;t=+o[v>>2]+ +o[b+(w<<2)>>2];o[u>>2]=+o[u>>2]+ +o[b+(c<<2)>>2];o[v>>2]=t;v=c|2;u=j+(v<<2)|0;w=c|3;s=j+(w<<2)|0;t=+o[s>>2]+ +o[b+(w<<2)>>2];o[u>>2]=+o[u>>2]+ +o[b+(v<<2)>>2];o[s>>2]=t;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{w=j+(c<<2)|0;o[w>>2]=+o[w>>2]+ +o[b+(c<<2)>>2];c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{k[i+(c<<2)>>2]=k[j+(c<<2)>>2];c=c+1|0}while((c|0)!=(l|0))}if((j|0)==(m|0)){r=q;return}ggb(j);k[p>>2]=m;k[n>>2]=264;r=q;return}function t3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0.0,v=0,w=0,x=0;s=r;r=r+1104|0;q=s;m=k[a+40>>2]|0;e=k[m>>2]|0;m=aa(((k[a>>2]|0)>>>3&511)+1|0,k[m+4>>2]|0)|0;n=q+8|0;k[q>>2]=n;o=q+4|0;k[o>>2]=136;if(m>>>0>136){d=m>>>0>536870911?-1:m<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[q>>2]=c;l=c}else l=n;k[o>>2]=m;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>1;h=(m|0)>0;if(h){c=0;do{p[l+(c<<3)>>3]=+(j[b+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(m|0))}d=e+-1|0;a:do if(d|0){a=m+-4|0;if((m|0)<4)while(1){b=b+(g<<1)|0;if(h){c=0;do{f=l+(c<<3)|0;p[f>>3]=+p[f>>3]+ +(j[b+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0;if(!d)break a}e=m&-4;f=(e|0)<(m|0);do{b=b+(g<<1)|0;c=0;do{v=l+(c<<3)|0;x=c|1;w=l+(x<<3)|0;u=+p[w>>3]+ +(j[b+(x<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(j[b+(c<<1)>>1]|0);p[w>>3]=u;w=c|2;v=l+(w<<3)|0;x=c|3;t=l+(x<<3)|0;u=+p[t>>3]+ +(j[b+(x<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(j[b+(w<<1)>>1]|0);p[t>>3]=u;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{x=l+(c<<3)|0;p[x>>3]=+p[x>>3]+ +(j[b+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{p[i+(c<<3)>>3]=+p[l+(c<<3)>>3];c=c+1|0}while((c|0)!=(m|0))}if((l|0)==(n|0)){r=s;return}ggb(l);k[q>>2]=n;k[o>>2]=136;r=s;return}function u3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0.0,v=0,w=0,x=0;s=r;r=r+1072|0;q=s;m=k[a+40>>2]|0;e=k[m>>2]|0;m=aa(((k[a>>2]|0)>>>3&511)+1|0,k[m+4>>2]|0)|0;n=q+8|0;k[q>>2]=n;p=q+4|0;k[p>>2]=264;if(m>>>0>264){d=m>>>0>1073741823?-1:m<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[q>>2]=c;l=c}else l=n;k[p>>2]=m;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>1;h=(m|0)>0;if(h){c=0;do{o[l+(c<<2)>>2]=+(j[b+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(m|0))}d=e+-1|0;a:do if(d|0){a=m+-4|0;if((m|0)<4)while(1){b=b+(g<<1)|0;if(h){c=0;do{f=l+(c<<2)|0;o[f>>2]=+o[f>>2]+ +(j[b+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0;if(!d)break a}e=m&-4;f=(e|0)<(m|0);do{b=b+(g<<1)|0;c=0;do{v=l+(c<<2)|0;x=c|1;w=l+(x<<2)|0;u=+o[w>>2]+ +(j[b+(x<<1)>>1]|0);o[v>>2]=+o[v>>2]+ +(j[b+(c<<1)>>1]|0);o[w>>2]=u;w=c|2;v=l+(w<<2)|0;x=c|3;t=l+(x<<2)|0;u=+o[t>>2]+ +(j[b+(x<<1)>>1]|0);o[v>>2]=+o[v>>2]+ +(j[b+(w<<1)>>1]|0);o[t>>2]=u;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{x=l+(c<<2)|0;o[x>>2]=+o[x>>2]+ +(j[b+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{k[i+(c<<2)>>2]=k[l+(c<<2)>>2];c=c+1|0}while((c|0)!=(m|0))}if((l|0)==(n|0)){r=s;return}ggb(l);k[q>>2]=n;k[p>>2]=264;r=s;return}function v3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,n=0,o=0,q=0,s=0,t=0,u=0.0,v=0,w=0,x=0;s=r;r=r+1104|0;q=s;l=k[a+40>>2]|0;e=k[l>>2]|0;l=aa(((k[a>>2]|0)>>>3&511)+1|0,k[l+4>>2]|0)|0;n=q+8|0;k[q>>2]=n;o=q+4|0;k[o>>2]=136;if(l>>>0>136){d=l>>>0>536870911?-1:l<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[q>>2]=c;j=c}else j=n;k[o>>2]=l;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>1;h=(l|0)>0;if(h){c=0;do{p[j+(c<<3)>>3]=+(m[b+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(l|0))}d=e+-1|0;a:do if(d|0){a=l+-4|0;if((l|0)<4)while(1){b=b+(g<<1)|0;if(h){c=0;do{f=j+(c<<3)|0;p[f>>3]=+p[f>>3]+ +(m[b+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0;if(!d)break a}e=l&-4;f=(e|0)<(l|0);do{b=b+(g<<1)|0;c=0;do{v=j+(c<<3)|0;x=c|1;w=j+(x<<3)|0;u=+p[w>>3]+ +(m[b+(x<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(m[b+(c<<1)>>1]|0);p[w>>3]=u;w=c|2;v=j+(w<<3)|0;x=c|3;t=j+(x<<3)|0;u=+p[t>>3]+ +(m[b+(x<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(m[b+(w<<1)>>1]|0);p[t>>3]=u;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{x=j+(c<<3)|0;p[x>>3]=+p[x>>3]+ +(m[b+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{p[i+(c<<3)>>3]=+p[j+(c<<3)>>3];c=c+1|0}while((c|0)!=(l|0))}if((j|0)==(n|0)){r=s;return}ggb(j);k[q>>2]=n;k[o>>2]=136;r=s;return}function w3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,n=0,p=0,q=0,s=0,t=0,u=0.0,v=0,w=0,x=0;s=r;r=r+1072|0;q=s;l=k[a+40>>2]|0;e=k[l>>2]|0;l=aa(((k[a>>2]|0)>>>3&511)+1|0,k[l+4>>2]|0)|0;n=q+8|0;k[q>>2]=n;p=q+4|0;k[p>>2]=264;if(l>>>0>264){d=l>>>0>1073741823?-1:l<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[q>>2]=c;j=c}else j=n;k[p>>2]=l;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>1;h=(l|0)>0;if(h){c=0;do{o[j+(c<<2)>>2]=+(m[b+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(l|0))}d=e+-1|0;a:do if(d|0){a=l+-4|0;if((l|0)<4)while(1){b=b+(g<<1)|0;if(h){c=0;do{f=j+(c<<2)|0;o[f>>2]=+o[f>>2]+ +(m[b+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0;if(!d)break a}e=l&-4;f=(e|0)<(l|0);do{b=b+(g<<1)|0;c=0;do{v=j+(c<<2)|0;x=c|1;w=j+(x<<2)|0;u=+o[w>>2]+ +(m[b+(x<<1)>>1]|0);o[v>>2]=+o[v>>2]+ +(m[b+(c<<1)>>1]|0);o[w>>2]=u;w=c|2;v=j+(w<<2)|0;x=c|3;t=j+(x<<2)|0;u=+o[t>>2]+ +(m[b+(x<<1)>>1]|0);o[v>>2]=+o[v>>2]+ +(m[b+(w<<1)>>1]|0);o[t>>2]=u;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{x=j+(c<<2)|0;o[x>>2]=+o[x>>2]+ +(m[b+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{k[i+(c<<2)>>2]=k[j+(c<<2)>>2];c=c+1|0}while((c|0)!=(l|0))}if((j|0)==(n|0)){r=s;return}ggb(j);k[q>>2]=n;k[p>>2]=264;r=s;return}function x3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0;s=r;r=r+1072|0;q=s;m=k[a+40>>2]|0;e=k[m>>2]|0;m=aa(((k[a>>2]|0)>>>3&511)+1|0,k[m+4>>2]|0)|0;n=q+8|0;k[q>>2]=n;o=q+4|0;k[o>>2]=264;if(m>>>0>264){d=m>>>0>1073741823?-1:m<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[q>>2]=c;j=c}else j=n;k[o>>2]=m;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=k[a+48>>2]|0;h=(m|0)>0;if(h){c=0;do{k[j+(c<<2)>>2]=l[b+c>>0];c=c+1|0}while((c|0)!=(m|0))}d=e+-1|0;a:do if(d|0){a=m+-4|0;if((m|0)<4)while(1){b=b+g|0;if(h){c=0;do{f=j+(c<<2)|0;k[f>>2]=(l[b+c>>0]|0)+(k[f>>2]|0);c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0;if(!d)break a}e=m&-4;f=(e|0)<(m|0);do{b=b+g|0;c=0;do{u=j+(c<<2)|0;v=c|1;w=j+(v<<2)|0;v=(l[b+v>>0]|0)+(k[w>>2]|0)|0;k[u>>2]=(l[b+c>>0]|0)+(k[u>>2]|0);k[w>>2]=v;w=c|2;v=j+(w<<2)|0;u=c|3;t=j+(u<<2)|0;u=(l[b+u>>0]|0)+(k[t>>2]|0)|0;k[v>>2]=(l[b+w>>0]|0)+(k[v>>2]|0);k[t>>2]=u;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{w=j+(c<<2)|0;k[w>>2]=(l[b+c>>0]|0)+(k[w>>2]|0);c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{p[i+(c<<3)>>3]=+(k[j+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(m|0))}if((j|0)==(n|0)){r=s;return}ggb(j);k[q>>2]=n;k[o>>2]=264;r=s;return}function y3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;s=r;r=r+1072|0;q=s;m=k[a+40>>2]|0;e=k[m>>2]|0;m=aa(((k[a>>2]|0)>>>3&511)+1|0,k[m+4>>2]|0)|0;n=q+8|0;k[q>>2]=n;p=q+4|0;k[p>>2]=264;if(m>>>0>264){d=m>>>0>1073741823?-1:m<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[q>>2]=c;j=c}else j=n;k[p>>2]=m;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=k[a+48>>2]|0;h=(m|0)>0;if(h){c=0;do{k[j+(c<<2)>>2]=l[b+c>>0];c=c+1|0}while((c|0)!=(m|0))}d=e+-1|0;a:do if(d|0){a=m+-4|0;if((m|0)<4)while(1){b=b+g|0;if(h){c=0;do{f=j+(c<<2)|0;k[f>>2]=(l[b+c>>0]|0)+(k[f>>2]|0);c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0;if(!d)break a}e=m&-4;f=(e|0)<(m|0);do{b=b+g|0;c=0;do{u=j+(c<<2)|0;v=c|1;w=j+(v<<2)|0;v=(l[b+v>>0]|0)+(k[w>>2]|0)|0;k[u>>2]=(l[b+c>>0]|0)+(k[u>>2]|0);k[w>>2]=v;w=c|2;v=j+(w<<2)|0;u=c|3;t=j+(u<<2)|0;u=(l[b+u>>0]|0)+(k[t>>2]|0)|0;k[v>>2]=(l[b+w>>0]|0)+(k[v>>2]|0);k[t>>2]=u;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{w=j+(c<<2)|0;k[w>>2]=(l[b+c>>0]|0)+(k[w>>2]|0);c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{o[i+(c<<2)>>2]=+(k[j+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(m|0))}if((j|0)==(n|0)){r=s;return}ggb(j);k[q>>2]=n;k[p>>2]=264;r=s;return}function z3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;q=r;r=r+1072|0;p=q;m=k[a+40>>2]|0;e=k[m>>2]|0;m=aa(((k[a>>2]|0)>>>3&511)+1|0,k[m+4>>2]|0)|0;n=p+8|0;k[p>>2]=n;o=p+4|0;k[o>>2]=264;if(m>>>0>264){d=m>>>0>1073741823?-1:m<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[p>>2]=c;j=c}else j=n;k[o>>2]=m;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=k[a+48>>2]|0;h=(m|0)>0;if(h){c=0;do{k[j+(c<<2)>>2]=l[b+c>>0];c=c+1|0}while((c|0)!=(m|0))}d=e+-1|0;a:do if(d|0){a=m+-4|0;if((m|0)<4)while(1){b=b+g|0;if(h){c=0;do{f=j+(c<<2)|0;k[f>>2]=(l[b+c>>0]|0)+(k[f>>2]|0);c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0;if(!d)break a}e=m&-4;f=(e|0)<(m|0);do{b=b+g|0;c=0;do{t=j+(c<<2)|0;u=c|1;v=j+(u<<2)|0;u=(l[b+u>>0]|0)+(k[v>>2]|0)|0;k[t>>2]=(l[b+c>>0]|0)+(k[t>>2]|0);k[v>>2]=u;v=c|2;u=j+(v<<2)|0;t=c|3;s=j+(t<<2)|0;t=(l[b+t>>0]|0)+(k[s>>2]|0)|0;k[u>>2]=(l[b+v>>0]|0)+(k[u>>2]|0);k[s>>2]=t;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{v=j+(c<<2)|0;k[v>>2]=(l[b+c>>0]|0)+(k[v>>2]|0);c=c+1|0}while((c|0)!=(m|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{k[i+(c<<2)>>2]=k[j+(c<<2)>>2];c=c+1|0}while((c|0)!=(m|0))}if((j|0)==(n|0)){r=q;return}ggb(j);k[p>>2]=n;k[o>>2]=264;r=q;return}function A3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0.0,u=0,v=0,w=0;q=r;r=r+1104|0;o=q;l=k[a+40>>2]|0;e=k[l>>2]|0;l=aa(((k[a>>2]|0)>>>3&511)+1|0,k[l+4>>2]|0)|0;m=o+8|0;k[o>>2]=m;n=o+4|0;k[n>>2]=136;if(l>>>0>136){d=l>>>0>536870911?-1:l<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[o>>2]=c;j=c}else j=m;k[n>>2]=l;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>3;h=(l|0)>0;if(h){c=0;do{p[j+(c<<3)>>3]=+p[b+(c<<3)>>3];c=c+1|0}while((c|0)!=(l|0))}d=e+-1|0;a:do if(d|0){a=l+-4|0;if((l|0)<4)while(1){b=b+(g<<3)|0;if(h){c=0;do{f=j+(c<<3)|0;p[f>>3]=+p[f>>3]+ +p[b+(c<<3)>>3];c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0;if(!d)break a}e=l&-4;f=(e|0)<(l|0);do{b=b+(g<<3)|0;c=0;do{u=j+(c<<3)|0;w=c|1;v=j+(w<<3)|0;t=+p[v>>3]+ +p[b+(w<<3)>>3];p[u>>3]=+p[u>>3]+ +p[b+(c<<3)>>3];p[v>>3]=t;v=c|2;u=j+(v<<3)|0;w=c|3;s=j+(w<<3)|0;t=+p[s>>3]+ +p[b+(w<<3)>>3];p[u>>3]=+p[u>>3]+ +p[b+(v<<3)>>3];p[s>>3]=t;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{w=j+(c<<3)|0;p[w>>3]=+p[w>>3]+ +p[b+(c<<3)>>3];c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{p[i+(c<<3)>>3]=+p[j+(c<<3)>>3];c=c+1|0}while((c|0)!=(l|0))}if((j|0)==(m|0)){r=q;return}ggb(j);k[o>>2]=m;k[n>>2]=136;r=q;return}function B3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0;q=r;r=r+1104|0;o=q;l=k[a+40>>2]|0;e=k[l>>2]|0;l=aa(((k[a>>2]|0)>>>3&511)+1|0,k[l+4>>2]|0)|0;m=o+8|0;k[o>>2]=m;n=o+4|0;k[n>>2]=136;if(l>>>0>136){d=l>>>0>536870911?-1:l<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[o>>2]=c;j=c}else j=m;k[n>>2]=l;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>3;h=(l|0)>0;if(h){c=0;do{p[j+(c<<3)>>3]=+p[b+(c<<3)>>3];c=c+1|0}while((c|0)!=(l|0))}d=e+-1|0;a:do if(d|0){a=l+-4|0;if((l|0)<4)while(1){b=b+(g<<3)|0;if(h){c=0;do{f=j+(c<<3)|0;s=+p[f>>3];t=+p[b+(c<<3)>>3];p[f>>3]=s<t?t:s;c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0;if(!d)break a}e=l&-4;f=(e|0)<(l|0);do{b=b+(g<<3)|0;c=0;do{v=j+(c<<3)|0;t=+p[v>>3];s=+p[b+(c<<3)>>3];u=c|1;y=j+(u<<3)|0;w=+p[y>>3];x=+p[b+(u<<3)>>3];p[v>>3]=t<s?s:t;p[y>>3]=w<x?x:w;y=c|2;v=j+(y<<3)|0;w=+p[v>>3];x=+p[b+(y<<3)>>3];y=c|3;u=j+(y<<3)|0;t=+p[u>>3];s=+p[b+(y<<3)>>3];p[v>>3]=w<x?x:w;p[u>>3]=t<s?s:t;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{y=j+(c<<3)|0;x=+p[y>>3];w=+p[b+(c<<3)>>3];p[y>>3]=x<w?w:x;c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{p[i+(c<<3)>>3]=+p[j+(c<<3)>>3];c=c+1|0}while((c|0)!=(l|0))}if((j|0)==(m|0)){r=q;return}ggb(j);k[o>>2]=m;k[n>>2]=136;r=q;return}function C3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0;q=r;r=r+1104|0;o=q;l=k[a+40>>2]|0;e=k[l>>2]|0;l=aa(((k[a>>2]|0)>>>3&511)+1|0,k[l+4>>2]|0)|0;m=o+8|0;k[o>>2]=m;n=o+4|0;k[n>>2]=136;if(l>>>0>136){d=l>>>0>536870911?-1:l<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[o>>2]=c;j=c}else j=m;k[n>>2]=l;i=k[b+16>>2]|0;b=k[a+16>>2]|0;g=(k[a+48>>2]|0)>>>3;h=(l|0)>0;if(h){c=0;do{p[j+(c<<3)>>3]=+p[b+(c<<3)>>3];c=c+1|0}while((c|0)!=(l|0))}d=e+-1|0;a:do if(d|0){a=l+-4|0;if((l|0)<4)while(1){b=b+(g<<3)|0;if(h){c=0;do{f=j+(c<<3)|0;s=+p[f>>3];t=+p[b+(c<<3)>>3];p[f>>3]=t<s?t:s;c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0;if(!d)break a}e=l&-4;f=(e|0)<(l|0);do{b=b+(g<<3)|0;c=0;do{v=j+(c<<3)|0;t=+p[v>>3];s=+p[b+(c<<3)>>3];u=c|1;y=j+(u<<3)|0;w=+p[y>>3];x=+p[b+(u<<3)>>3];p[v>>3]=s<t?s:t;p[y>>3]=x<w?x:w;y=c|2;v=j+(y<<3)|0;w=+p[v>>3];x=+p[b+(y<<3)>>3];y=c|3;u=j+(y<<3)|0;t=+p[u>>3];s=+p[b+(y<<3)>>3];p[v>>3]=x<w?x:w;p[u>>3]=s<t?s:t;c=c+4|0}while((c|0)<=(a|0));if(f){c=e;do{y=j+(c<<3)|0;x=+p[y>>3];w=+p[b+(c<<3)>>3];p[y>>3]=w<x?w:x;c=c+1|0}while((c|0)!=(l|0))}d=d+-1|0}while((d|0)!=0)}while(0);if(h){c=0;do{p[i+(c<<3)>>3]=+p[j+(c<<3)>>3];c=c+1|0}while((c|0)!=(l|0))}if((j|0)==(m|0)){r=q;return}ggb(j);k[o>>2]=m;k[n>>2]=136;r=q;return}function D3(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;u=k[a+40>>2]|0;w=k[u>>2]|0;t=((k[a>>2]|0)>>>3&511)+1|0;u=aa(t,k[u+4>>2]|0)|0;if((w|0)<=0)return;v=k[a+16>>2]|0;r=k[k[a+44>>2]>>2]|0;s=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(u|0)==(t|0);h=t<<1;i=t<<2;j=u-i|0;l=(h|0)>(j|0);m=t*3|0;n=(h|0)<(u|0);e=0;do{o=v+(aa(r,e)|0)|0;q=s+(aa(f,e)|0)|0;a:do if(g){a=0;do{p[q+(a<<3)>>3]=+p[o+(a<<3)>>3];a=a+1|0}while((a|0)!=(t|0))}else{if(l){b=0;while(1){c=+p[o+(b<<3)>>3];d=+p[o+(b+t<<3)>>3];if(n){a=h;do{c=c+ +p[o+(a+b<<3)>>3];a=a+t|0}while((a|0)<(u|0))}p[q+(b<<3)>>3]=d+c;b=b+1|0;if((b|0)==(t|0))break a}}else b=0;do{c=+p[o+(b<<3)>>3];a=h;d=+p[o+(b+t<<3)>>3];do{x=a+b|0;c=c+ +p[o+(x<<3)>>3]+ +p[o+(x+h<<3)>>3];d=d+ +p[o+(x+t<<3)>>3]+ +p[o+(x+m<<3)>>3];a=a+i|0}while((a|0)<=(j|0));if((a|0)<(u|0))do{c=c+ +p[o+(a+b<<3)>>3];a=a+t|0}while((a|0)<(u|0));p[q+(b<<3)>>3]=d+c;b=b+1|0}while((b|0)!=(t|0))}while(0);e=e+1|0}while((e|0)!=(w|0));return}function E3(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0;u=k[a+40>>2]|0;w=k[u>>2]|0;t=((k[a>>2]|0)>>>3&511)+1|0;u=aa(t,k[u+4>>2]|0)|0;if((w|0)<=0)return;v=k[a+16>>2]|0;r=k[k[a+44>>2]>>2]|0;s=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(u|0)==(t|0);h=t<<1;i=t<<2;j=u-i|0;l=(h|0)>(j|0);m=t*3|0;n=(h|0)<(u|0);e=0;do{o=v+(aa(r,e)|0)|0;q=s+(aa(f,e)|0)|0;a:do if(g){a=0;do{p[q+(a<<3)>>3]=+p[o+(a<<3)>>3];a=a+1|0}while((a|0)!=(t|0))}else{if(l){b=0;while(1){c=+p[o+(b<<3)>>3];d=+p[o+(b+t<<3)>>3];if(n){a=h;do{x=+p[o+(a+b<<3)>>3];c=c<x?x:c;a=a+t|0}while((a|0)<(u|0))}p[q+(b<<3)>>3]=c<d?d:c;b=b+1|0;if((b|0)==(t|0))break a}}else b=0;do{c=+p[o+(b<<3)>>3];a=h;d=+p[o+(b+t<<3)>>3];do{z=a+b|0;y=+p[o+(z<<3)>>3];y=c<y?y:c;x=+p[o+(z+t<<3)>>3];x=d<x?x:d;A=+p[o+(z+h<<3)>>3];c=y<A?A:y;y=+p[o+(z+m<<3)>>3];d=x<y?y:x;a=a+i|0}while((a|0)<=(j|0));if((a|0)<(u|0))do{A=+p[o+(a+b<<3)>>3];c=c<A?A:c;a=a+t|0}while((a|0)<(u|0));p[q+(b<<3)>>3]=c<d?d:c;b=b+1|0}while((b|0)!=(t|0))}while(0);e=e+1|0}while((e|0)!=(w|0));return}function F3(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0;u=k[a+40>>2]|0;w=k[u>>2]|0;t=((k[a>>2]|0)>>>3&511)+1|0;u=aa(t,k[u+4>>2]|0)|0;if((w|0)<=0)return;v=k[a+16>>2]|0;r=k[k[a+44>>2]>>2]|0;s=k[b+16>>2]|0;f=k[k[b+44>>2]>>2]|0;g=(u|0)==(t|0);h=t<<1;i=t<<2;j=u-i|0;l=(h|0)>(j|0);m=t*3|0;n=(h|0)<(u|0);e=0;do{o=v+(aa(r,e)|0)|0;q=s+(aa(f,e)|0)|0;a:do if(g){a=0;do{p[q+(a<<3)>>3]=+p[o+(a<<3)>>3];a=a+1|0}while((a|0)!=(t|0))}else{if(l){b=0;while(1){c=+p[o+(b<<3)>>3];d=+p[o+(b+t<<3)>>3];if(n){a=h;do{x=+p[o+(a+b<<3)>>3];c=x<c?x:c;a=a+t|0}while((a|0)<(u|0))}p[q+(b<<3)>>3]=d<c?d:c;b=b+1|0;if((b|0)==(t|0))break a}}else b=0;do{c=+p[o+(b<<3)>>3];a=h;d=+p[o+(b+t<<3)>>3];do{z=a+b|0;y=+p[o+(z<<3)>>3];y=y<c?y:c;x=+p[o+(z+t<<3)>>3];x=x<d?x:d;A=+p[o+(z+h<<3)>>3];c=A<y?A:y;y=+p[o+(z+m<<3)>>3];d=y<x?y:x;a=a+i|0}while((a|0)<=(j|0));if((a|0)<(u|0))do{A=+p[o+(a+b<<3)>>3];c=A<c?A:c;a=a+t|0}while((a|0)<(u|0));p[q+(b<<3)>>3]=d<c?d:c;b=b+1|0}while((b|0)!=(t|0))}while(0);e=e+1|0}while((e|0)!=(w|0));return}function G3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+128|0;n=o+64|0;l=o+8|0;j=o;if((k[a>>2]&2031616|0)==65536)AF(n,k[a+4>>2]|0);else Q1(n,a,-1);a=k[n>>2]|0;g=a&7;h=k[49348+(g<<2)>>2]|0;m=n+4|0;if(!((k[m>>2]|0)<3?(a&4088|0)==0&(g|0)!=7:0)){k[l>>2]=0;a=l+4|0;k[a>>2]=0;d=ZT(56)|0;k[d>>2]=1;e=d+4|0;k[l>>2]=e;k[a>>2]=49;i[d+53>>0]=0;f=220594;g=e+49|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,l,220644,216975,4122);k[a>>2]=0;k[l>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0);a=k[n>>2]|0}f=n+40|0;e=k[f>>2]|0;g=k[e>>2]|0;k[j>>2]=k[e+4>>2];k[j+4>>2]=g;x2(b,j,a&4095,0);if((k[b>>2]&2031616|0)==65536)AF(l,k[b+4>>2]|0);else Q1(l,b,-1);Ph[h&511](n,l,c);e=l+36|0;a=k[e>>2]|0;if(a|0?(c=a+12|0,j=k[c>>2]|0,k[c>>2]=j+-1,(j|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;j=l+16|0;d=l+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[d>>2]|0)>0){e=k[l+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[l+44>>2]|0;if(!((a|0)==(l+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=n+36|0;a=k[e>>2]|0;if(a|0?(j=a+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;l=n+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[m>>2]|0)>0){d=k[f>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[n+44>>2]|0;if((a|0)==(n+48|0)|(a|0)==0){r=o;return}ggb(k[a+-4>>2]|0);r=o;return}function H3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+1040|0;u=x;v=u+8|0;k[u>>2]=v;w=u+4|0;k[w>>2]=1032;h=(c&1|0)==0;t=a+16|0;s=b+16|0;d=k[s>>2]|0;l=(k[t>>2]|0)==(d|0);g=(c&16|0)==0;do if(h){e=k[a+8>>2]|0;q=k[a+12>>2]|0;c=v}else{e=k[a+12>>2]|0;f=k[a+8>>2]|0;if(f>>>0<=1032){k[w>>2]=f;q=f;c=v;break}while(1){c=fgb(f)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[u>>2]=c;k[w>>2]=f;q=f}while(0);a:do if((e|0)>0){p=b+44|0;m=a+44|0;j=(q|0)>0;n=(q|0)/2|0;f=(q|0)>1;o=q+-1|0;if(h){b=g|f^1;c=0;while(1){f=d+(aa(k[k[p>>2]>>2]|0,c)|0)|0;if(!l)upb(f|0,(k[t>>2]|0)+(aa(k[k[m>>2]>>2]|0,c)|0)|0,q|0)|0;ogb(f,f+q|0);if(!b){d=0;do{g=f+d|0;j=f+(o-d)|0;h=i[g>>0]|0;i[g>>0]=i[j>>0]|0;i[j>>0]=h;d=d+1|0}while((d|0)<(n|0))}c=c+1|0;if((c|0)>=(e|0))break a;d=k[s>>2]|0}}h=c+q|0;g=g|f^1;a=0;do{if(j){f=k[t>>2]|0;b=k[m>>2]|0;d=0;do{l=f+(aa(k[b>>2]|0,d)|0)+a|0;i[c+d>>0]=i[l>>0]|0;d=d+1|0}while((d|0)!=(q|0))}ogb(c,h);if(!g){d=0;do{f=c+d|0;l=c+(o-d)|0;b=i[f>>0]|0;i[f>>0]=i[l>>0]|0;i[l>>0]=b;d=d+1|0}while((d|0)<(n|0))}if(j){d=0;do{l=(k[s>>2]|0)+(aa(k[k[p>>2]>>2]|0,d)|0)+a|0;i[l>>0]=i[c+d>>0]|0;d=d+1|0}while((d|0)!=(q|0))}a=a+1|0}while((a|0)!=(e|0))}while(0);c=k[u>>2]|0;if((c|0)==(v|0)){r=x;return}if(c|0)ggb(c);k[u>>2]=v;k[w>>2]=1032;r=x;return}function I3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+1040|0;u=x;v=u+8|0;k[u>>2]=v;w=u+4|0;k[w>>2]=1032;h=(c&1|0)==0;t=a+16|0;s=b+16|0;d=k[s>>2]|0;l=(k[t>>2]|0)==(d|0);g=(c&16|0)==0;do if(h){e=k[a+8>>2]|0;q=k[a+12>>2]|0;c=v}else{e=k[a+12>>2]|0;f=k[a+8>>2]|0;if(f>>>0<=1032){k[w>>2]=f;q=f;c=v;break}while(1){c=fgb(f)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[u>>2]=c;k[w>>2]=f;q=f}while(0);a:do if((e|0)>0){p=b+44|0;m=a+44|0;j=(q|0)>0;n=(q|0)/2|0;f=(q|0)>1;o=q+-1|0;if(h){b=g|f^1;c=0;while(1){f=d+(aa(k[k[p>>2]>>2]|0,c)|0)|0;if(!l)upb(f|0,(k[t>>2]|0)+(aa(k[k[m>>2]>>2]|0,c)|0)|0,q|0)|0;jgb(f,f+q|0);if(!b){d=0;do{g=f+d|0;j=f+(o-d)|0;h=i[g>>0]|0;i[g>>0]=i[j>>0]|0;i[j>>0]=h;d=d+1|0}while((d|0)<(n|0))}c=c+1|0;if((c|0)>=(e|0))break a;d=k[s>>2]|0}}h=c+q|0;g=g|f^1;a=0;do{if(j){f=k[t>>2]|0;b=k[m>>2]|0;d=0;do{l=f+(aa(k[b>>2]|0,d)|0)+a|0;i[c+d>>0]=i[l>>0]|0;d=d+1|0}while((d|0)!=(q|0))}jgb(c,h);if(!g){d=0;do{f=c+d|0;l=c+(o-d)|0;b=i[f>>0]|0;i[f>>0]=i[l>>0]|0;i[l>>0]=b;d=d+1|0}while((d|0)<(n|0))}if(j){d=0;do{l=(k[s>>2]|0)+(aa(k[k[p>>2]>>2]|0,d)|0)+a|0;i[l>>0]=i[c+d>>0]|0;d=d+1|0}while((d|0)!=(q|0))}a=a+1|0}while((a|0)!=(e|0))}while(0);c=k[u>>2]|0;if((c|0)==(v|0)){r=x;return}if(c|0)ggb(c);k[u>>2]=v;k[w>>2]=1032;r=x;return}function J3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+1056|0;v=y;w=v+8|0;k[v>>2]=w;x=v+4|0;k[x>>2]=520;h=(c&1|0)==0;u=a+16|0;t=b+16|0;l=k[t>>2]|0;m=(k[u>>2]|0)==(l|0);g=(c&16|0)==0;do if(h){e=k[a+8>>2]|0;s=k[a+12>>2]|0;c=w}else{e=k[a+12>>2]|0;f=k[a+8>>2]|0;if(f>>>0<=520){k[x>>2]=f;s=f;c=w;break}d=f>>>0>2147483647?-1:f<<1;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[v>>2]=c;k[x>>2]=f;s=f}while(0);a:do if((e|0)>0){q=b+44|0;n=a+44|0;a=s<<1;i=(s|0)>0;o=(s|0)/2|0;d=(s|0)>1;p=s+-1|0;if(h){b=g|d^1;c=0;d=l;while(1){f=d+(aa(k[k[q>>2]>>2]|0,c)|0)|0;if(!m)upb(f|0,(k[u>>2]|0)+(aa(k[k[n>>2]>>2]|0,c)|0)|0,a|0)|0;ygb(f,f+(s<<1)|0);if(!b){d=0;do{h=f+(d<<1)|0;l=f+(p-d<<1)|0;i=j[h>>1]|0;j[h>>1]=j[l>>1]|0;j[l>>1]=i;d=d+1|0}while((d|0)<(o|0))}c=c+1|0;if((c|0)>=(e|0))break a;d=k[t>>2]|0}}h=c+(s<<1)|0;g=g|d^1;a=0;do{if(i){f=k[u>>2]|0;b=k[k[n>>2]>>2]|0;d=0;do{m=f+(aa(b,d)|0)+(a<<1)|0;j[c+(d<<1)>>1]=j[m>>1]|0;d=d+1|0}while((d|0)!=(s|0))}ygb(c,h);if(!g){d=0;do{b=c+(d<<1)|0;m=c+(p-d<<1)|0;l=j[b>>1]|0;j[b>>1]=j[m>>1]|0;j[m>>1]=l;d=d+1|0}while((d|0)<(o|0))}if(i){f=k[t>>2]|0;b=k[k[q>>2]>>2]|0;d=0;do{m=f+(aa(b,d)|0)+(a<<1)|0;j[m>>1]=j[c+(d<<1)>>1]|0;d=d+1|0}while((d|0)!=(s|0))}a=a+1|0}while((a|0)!=(e|0))}while(0);c=k[v>>2]|0;if((c|0)==(w|0)){r=y;return}if(c|0)ggb(c);k[v>>2]=w;k[x>>2]=520;r=y;return}function K3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+1056|0;v=y;w=v+8|0;k[v>>2]=w;x=v+4|0;k[x>>2]=520;h=(c&1|0)==0;u=a+16|0;t=b+16|0;l=k[t>>2]|0;m=(k[u>>2]|0)==(l|0);g=(c&16|0)==0;do if(h){e=k[a+8>>2]|0;s=k[a+12>>2]|0;c=w}else{e=k[a+12>>2]|0;f=k[a+8>>2]|0;if(f>>>0<=520){k[x>>2]=f;s=f;c=w;break}d=f>>>0>2147483647?-1:f<<1;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[v>>2]=c;k[x>>2]=f;s=f}while(0);a:do if((e|0)>0){q=b+44|0;n=a+44|0;a=s<<1;i=(s|0)>0;o=(s|0)/2|0;d=(s|0)>1;p=s+-1|0;if(h){b=g|d^1;c=0;d=l;while(1){f=d+(aa(k[k[q>>2]>>2]|0,c)|0)|0;if(!m)upb(f|0,(k[u>>2]|0)+(aa(k[k[n>>2]>>2]|0,c)|0)|0,a|0)|0;tgb(f,f+(s<<1)|0);if(!b){d=0;do{h=f+(d<<1)|0;l=f+(p-d<<1)|0;i=j[h>>1]|0;j[h>>1]=j[l>>1]|0;j[l>>1]=i;d=d+1|0}while((d|0)<(o|0))}c=c+1|0;if((c|0)>=(e|0))break a;d=k[t>>2]|0}}h=c+(s<<1)|0;g=g|d^1;a=0;do{if(i){f=k[u>>2]|0;b=k[k[n>>2]>>2]|0;d=0;do{m=f+(aa(b,d)|0)+(a<<1)|0;j[c+(d<<1)>>1]=j[m>>1]|0;d=d+1|0}while((d|0)!=(s|0))}tgb(c,h);if(!g){d=0;do{b=c+(d<<1)|0;m=c+(p-d<<1)|0;l=j[b>>1]|0;j[b>>1]=j[m>>1]|0;j[m>>1]=l;d=d+1|0}while((d|0)<(o|0))}if(i){f=k[t>>2]|0;b=k[k[q>>2]>>2]|0;d=0;do{m=f+(aa(b,d)|0)+(a<<1)|0;j[m>>1]=j[c+(d<<1)>>1]|0;d=d+1|0}while((d|0)!=(s|0))}a=a+1|0}while((a|0)!=(e|0))}while(0);c=k[v>>2]|0;if((c|0)==(w|0)){r=y;return}if(c|0)ggb(c);k[v>>2]=w;k[x>>2]=520;r=y;return}function L3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+1072|0;u=x;v=u+8|0;k[u>>2]=v;w=u+4|0;k[w>>2]=264;h=(c&1|0)==0;t=a+16|0;s=b+16|0;j=k[s>>2]|0;l=(k[t>>2]|0)==(j|0);g=(c&16|0)==0;do if(h){e=k[a+8>>2]|0;q=k[a+12>>2]|0;c=v}else{e=k[a+12>>2]|0;f=k[a+8>>2]|0;if(f>>>0<=264){k[w>>2]=f;q=f;c=v;break}d=f>>>0>1073741823?-1:f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[u>>2]=c;k[w>>2]=f;q=f}while(0);a:do if((e|0)>0){p=b+44|0;m=a+44|0;a=q<<2;i=(q|0)>0;n=(q|0)/2|0;d=(q|0)>1;o=q+-1|0;if(h){b=g|d^1;c=0;d=j;while(1){f=d+(aa(k[k[p>>2]>>2]|0,c)|0)|0;if(!l)upb(f|0,(k[t>>2]|0)+(aa(k[k[m>>2]>>2]|0,c)|0)|0,a|0)|0;Dgb(f,f+(q<<2)|0);if(!b){d=0;do{h=f+(d<<2)|0;j=f+(o-d<<2)|0;i=k[h>>2]|0;k[h>>2]=k[j>>2];k[j>>2]=i;d=d+1|0}while((d|0)<(n|0))}c=c+1|0;if((c|0)>=(e|0))break a;d=k[s>>2]|0}}h=c+(q<<2)|0;g=g|d^1;a=0;do{if(i){f=k[t>>2]|0;b=k[m>>2]|0;d=0;do{l=f+(aa(k[b>>2]|0,d)|0)+(a<<2)|0;k[c+(d<<2)>>2]=k[l>>2];d=d+1|0}while((d|0)!=(q|0))}Dgb(c,h);if(!g){d=0;do{b=c+(d<<2)|0;l=c+(o-d<<2)|0;j=k[b>>2]|0;k[b>>2]=k[l>>2];k[l>>2]=j;d=d+1|0}while((d|0)<(n|0))}if(i){f=k[s>>2]|0;b=k[p>>2]|0;d=0;do{l=f+(aa(k[b>>2]|0,d)|0)+(a<<2)|0;k[l>>2]=k[c+(d<<2)>>2];d=d+1|0}while((d|0)!=(q|0))}a=a+1|0}while((a|0)!=(e|0))}while(0);c=k[u>>2]|0;if((c|0)==(v|0)){r=x;return}if(c|0)ggb(c);k[u>>2]=v;k[w>>2]=264;r=x;return}function M3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+1072|0;u=x;v=u+8|0;k[u>>2]=v;w=u+4|0;k[w>>2]=264;h=(c&1|0)==0;t=a+16|0;s=b+16|0;j=k[s>>2]|0;l=(k[t>>2]|0)==(j|0);g=(c&16|0)==0;do if(h){e=k[a+8>>2]|0;q=k[a+12>>2]|0;c=v}else{e=k[a+12>>2]|0;f=k[a+8>>2]|0;if(f>>>0<=264){k[w>>2]=f;q=f;c=v;break}d=f>>>0>1073741823?-1:f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[u>>2]=c;k[w>>2]=f;q=f}while(0);a:do if((e|0)>0){p=b+44|0;m=a+44|0;a=q<<2;i=(q|0)>0;n=(q|0)/2|0;d=(q|0)>1;o=q+-1|0;if(h){b=g|d^1;c=0;d=j;while(1){f=d+(aa(k[k[p>>2]>>2]|0,c)|0)|0;if(!l)upb(f|0,(k[t>>2]|0)+(aa(k[k[m>>2]>>2]|0,c)|0)|0,a|0)|0;Igb(f,f+(q<<2)|0);if(!b){d=0;do{h=f+(d<<2)|0;j=f+(o-d<<2)|0;i=k[h>>2]|0;k[h>>2]=k[j>>2];k[j>>2]=i;d=d+1|0}while((d|0)<(n|0))}c=c+1|0;if((c|0)>=(e|0))break a;d=k[s>>2]|0}}h=c+(q<<2)|0;g=g|d^1;a=0;do{if(i){f=k[t>>2]|0;b=k[k[m>>2]>>2]|0;d=0;do{l=f+(aa(b,d)|0)+(a<<2)|0;k[c+(d<<2)>>2]=k[l>>2];d=d+1|0}while((d|0)!=(q|0))}Igb(c,h);if(!g){d=0;do{b=c+(d<<2)|0;l=c+(o-d<<2)|0;j=k[b>>2]|0;k[b>>2]=k[l>>2];k[l>>2]=j;d=d+1|0}while((d|0)<(n|0))}if(i){f=k[s>>2]|0;b=k[k[p>>2]>>2]|0;d=0;do{l=f+(aa(b,d)|0)+(a<<2)|0;k[l>>2]=k[c+(d<<2)>>2];d=d+1|0}while((d|0)!=(q|0))}a=a+1|0}while((a|0)!=(e|0))}while(0);c=k[u>>2]|0;if((c|0)==(v|0)){r=x;return}if(c|0)ggb(c);k[u>>2]=v;k[w>>2]=264;r=x;return}function N3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0;y=r;r=r+1104|0;v=y;w=v+8|0;k[v>>2]=w;x=v+4|0;k[x>>2]=136;h=(c&1|0)==0;u=a+16|0;t=b+16|0;j=k[t>>2]|0;l=(k[u>>2]|0)==(j|0);g=(c&16|0)==0;do if(h){e=k[a+8>>2]|0;s=k[a+12>>2]|0;c=w}else{e=k[a+12>>2]|0;f=k[a+8>>2]|0;if(f>>>0<=136){k[x>>2]=f;s=f;c=w;break}d=f>>>0>536870911?-1:f<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[v>>2]=c;k[x>>2]=f;s=f}while(0);a:do if((e|0)>0){q=b+44|0;m=a+44|0;a=s<<3;i=(s|0)>0;n=(s|0)/2|0;d=(s|0)>1;o=s+-1|0;if(h){b=g|d^1;c=0;d=j;while(1){f=d+(aa(k[k[q>>2]>>2]|0,c)|0)|0;if(!l)upb(f|0,(k[u>>2]|0)+(aa(k[k[m>>2]>>2]|0,c)|0)|0,a|0)|0;Ngb(f,f+(s<<3)|0);if(!b){d=0;do{i=f+(d<<3)|0;j=f+(o-d<<3)|0;z=+p[i>>3];p[i>>3]=+p[j>>3];p[j>>3]=z;d=d+1|0}while((d|0)<(n|0))}c=c+1|0;if((c|0)>=(e|0))break a;d=k[t>>2]|0}}h=c+(s<<3)|0;g=g|d^1;a=0;do{if(i){f=k[u>>2]|0;b=k[k[m>>2]>>2]|0;d=0;do{l=f+(aa(b,d)|0)+(a<<3)|0;p[c+(d<<3)>>3]=+p[l>>3];d=d+1|0}while((d|0)!=(s|0))}Ngb(c,h);if(!g){d=0;do{j=c+(d<<3)|0;l=c+(o-d<<3)|0;z=+p[j>>3];p[j>>3]=+p[l>>3];p[l>>3]=z;d=d+1|0}while((d|0)<(n|0))}if(i){f=k[t>>2]|0;b=k[k[q>>2]>>2]|0;d=0;do{l=f+(aa(b,d)|0)+(a<<3)|0;p[l>>3]=+p[c+(d<<3)>>3];d=d+1|0}while((d|0)!=(s|0))}a=a+1|0}while((a|0)!=(e|0))}while(0);c=k[v>>2]|0;if((c|0)==(w|0)){r=y;return}if(c|0)ggb(c);k[v>>2]=w;k[x>>2]=136;r=y;return}function O3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+176|0;p=q+120|0;m=q+64|0;h=q+56|0;l=q;if((k[a>>2]&2031616|0)==65536)AF(p,k[a+4>>2]|0);else Q1(p,a,-1);g=k[p>>2]|0;n=g&7;j=k[49380+(n<<2)>>2]|0;o=p+4|0;if(!((k[o>>2]|0)<3?(g&4088|0)==0&(n|0)!=7:0)){k[m>>2]=0;a=m+4|0;k[a>>2]=0;d=ZT(56)|0;k[d>>2]=1;e=d+4|0;k[m>>2]=e;k[a>>2]=49;i[d+53>>0]=0;f=220594;g=e+49|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,m,220649,216975,4137);k[a>>2]=0;k[m>>2]=0;n=k[d>>2]|0;k[d>>2]=n+-1;if((n|0)==1)ggb(k[d+-4>>2]|0)}if((k[b>>2]&2031616|0)==65536)AF(m,k[b+4>>2]|0);else Q1(m,b,-1);f=m+16|0;g=p+16|0;if((k[f>>2]|0)==(k[g>>2]|0))b2(b);n=p+40|0;d=k[n>>2]|0;e=k[d>>2]|0;k[h>>2]=k[d+4>>2];k[h+4>>2]=e;x2(b,h,4,0);if((k[b>>2]&2031616|0)==65536)AF(l,k[b+4>>2]|0);else Q1(l,b,-1);KG(m,l)|0;e=l+36|0;a=k[e>>2]|0;if(a|0?(b=a+12|0,h=k[b>>2]|0,k[b>>2]=h+-1,(h|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;h=l+16|0;d=l+4|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[d>>2]|0)>0){e=k[l+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[l+44>>2]|0;if(!((a|0)==(l+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);Ph[j&511](p,m,c);e=m+36|0;a=k[e>>2]|0;if(a|0?(c=a+12|0,l=k[c>>2]|0,k[c>>2]=l+-1,(l|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[m+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;e=m+4|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[e>>2]|0)>0){d=k[m+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[m+44>>2]|0;if(!((a|0)==(m+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=p+36|0;a=k[e>>2]|0;if(a|0?(l=a+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[p+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[o>>2]|0)>0){d=k[n>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[p+44>>2]|0;if((a|0)==(p+48|0)|(a|0)==0){r=q;return}ggb(k[a+-4>>2]|0);r=q;return}function P3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+2112|0;w=D;A=D+1072|0;x=D+8|0;B=A+8|0;k[A>>2]=B;C=A+4|0;k[C>>2]=1032;y=x+8|0;k[x>>2]=y;z=x+4|0;k[z>>2]=264;s=(c&1|0)==0;t=(c&16|0)==0;u=a+16|0;v=b+16|0;if((k[u>>2]|0)==(k[v>>2]|0)){k[w>>2]=0;c=w+4|0;k[c>>2]=0;d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[w>>2]=e;k[c>>2]=20;i[d+24>>0]=0;f=220657;g=e+20|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,w,220678,216975,4026);k[c>>2]=0;k[w>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}do if(!s){f=k[a+12>>2]|0;e=k[a+8>>2]|0;if((k[C>>2]|0)>>>0<e>>>0){c=k[A>>2]|0;if((c|0)!=(B|0)){if(c|0)ggb(c);k[A>>2]=B;k[C>>2]=1032}if(e>>>0>1032){while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[A>>2]=c;k[C>>2]=e}}else k[C>>2]=e;if((k[z>>2]|0)>>>0>=e>>>0){k[z>>2]=e;q=e;p=f;break}c=k[x>>2]|0;if((c|0)!=(y|0)){if(c|0)ggb(c);k[x>>2]=y;k[z>>2]=264}if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[x>>2]=c;k[z>>2]=e;q=e;p=f}else{q=e;p=f}}else{q=k[a+12>>2]|0;p=k[a+8>>2]|0}while(0);j=k[A>>2]|0;c=k[x>>2]|0;if((p|0)>0){h=a+48|0;l=b+44|0;m=(q|0)>0;n=(q|0)/2|0;d=(q|0)>1;o=q+-1|0;a=a+44|0;if(s){g=t|d^1;e=0;do{d=(k[u>>2]|0)+(aa(k[h>>2]|0,e)|0)|0;f=(k[v>>2]|0)+(aa(k[k[l>>2]>>2]|0,e)|0)|0;if(m){c=0;do{k[f+(c<<2)>>2]=c;c=c+1|0}while((c|0)!=(q|0))}k[w>>2]=d;m4(f,f+(q<<2)|0,w);if(!g){c=0;do{j=f+(c<<2)|0;t=f+(o-c<<2)|0;s=k[j>>2]|0;k[j>>2]=k[t>>2];k[t>>2]=s;c=c+1|0}while((c|0)<(n|0))}e=e+1|0}while((e|0)!=(p|0))}else{b=c+(q<<2)|0;h=t|d^1;g=0;do{if(m){d=0;do{t=(k[u>>2]|0)+(aa(k[k[a>>2]>>2]|0,d)|0)+g|0;i[j+d>>0]=i[t>>0]|0;d=d+1|0}while((d|0)!=(q|0));d=0;do{k[c+(d<<2)>>2]=d;d=d+1|0}while((d|0)!=(q|0))}k[w>>2]=j;m4(c,b,w);if(!h){d=0;do{f=c+(d<<2)|0;t=c+(o-d<<2)|0;s=k[f>>2]|0;k[f>>2]=k[t>>2];k[t>>2]=s;d=d+1|0}while((d|0)<(n|0))}if(m){e=k[v>>2]|0;f=k[l>>2]|0;d=0;do{t=e+(aa(k[f>>2]|0,d)|0)+(g<<2)|0;k[t>>2]=k[c+(d<<2)>>2];d=d+1|0}while((d|0)!=(q|0))}g=g+1|0}while((g|0)!=(p|0))}c=k[x>>2]|0}if((c|0)!=(y|0)){if(c|0)ggb(c);k[x>>2]=y;k[z>>2]=264}c=k[A>>2]|0;if((c|0)==(B|0)){r=D;return}if(c|0)ggb(c);k[A>>2]=B;k[C>>2]=1032;r=D;return}function Q3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+2112|0;w=D;A=D+1072|0;x=D+8|0;B=A+8|0;k[A>>2]=B;C=A+4|0;k[C>>2]=1032;y=x+8|0;k[x>>2]=y;z=x+4|0;k[z>>2]=264;s=(c&1|0)==0;t=(c&16|0)==0;u=a+16|0;v=b+16|0;if((k[u>>2]|0)==(k[v>>2]|0)){k[w>>2]=0;c=w+4|0;k[c>>2]=0;d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[w>>2]=e;k[c>>2]=20;i[d+24>>0]=0;f=220657;g=e+20|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,w,220678,216975,4026);k[c>>2]=0;k[w>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}do if(!s){f=k[a+12>>2]|0;e=k[a+8>>2]|0;if((k[C>>2]|0)>>>0<e>>>0){c=k[A>>2]|0;if((c|0)!=(B|0)){if(c|0)ggb(c);k[A>>2]=B;k[C>>2]=1032}if(e>>>0>1032){while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[A>>2]=c;k[C>>2]=e}}else k[C>>2]=e;if((k[z>>2]|0)>>>0>=e>>>0){k[z>>2]=e;q=e;p=f;break}c=k[x>>2]|0;if((c|0)!=(y|0)){if(c|0)ggb(c);k[x>>2]=y;k[z>>2]=264}if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[x>>2]=c;k[z>>2]=e;q=e;p=f}else{q=e;p=f}}else{q=k[a+12>>2]|0;p=k[a+8>>2]|0}while(0);j=k[A>>2]|0;c=k[x>>2]|0;if((p|0)>0){h=a+48|0;l=b+44|0;m=(q|0)>0;n=(q|0)/2|0;d=(q|0)>1;o=q+-1|0;a=a+44|0;if(s){g=t|d^1;e=0;do{d=(k[u>>2]|0)+(aa(k[h>>2]|0,e)|0)|0;f=(k[v>>2]|0)+(aa(k[k[l>>2]>>2]|0,e)|0)|0;if(m){c=0;do{k[f+(c<<2)>>2]=c;c=c+1|0}while((c|0)!=(q|0))}k[w>>2]=d;j4(f,f+(q<<2)|0,w);if(!g){c=0;do{j=f+(c<<2)|0;t=f+(o-c<<2)|0;s=k[j>>2]|0;k[j>>2]=k[t>>2];k[t>>2]=s;c=c+1|0}while((c|0)<(n|0))}e=e+1|0}while((e|0)!=(p|0))}else{b=c+(q<<2)|0;h=t|d^1;g=0;do{if(m){d=0;do{t=(k[u>>2]|0)+(aa(k[k[a>>2]>>2]|0,d)|0)+g|0;i[j+d>>0]=i[t>>0]|0;d=d+1|0}while((d|0)!=(q|0));d=0;do{k[c+(d<<2)>>2]=d;d=d+1|0}while((d|0)!=(q|0))}k[w>>2]=j;j4(c,b,w);if(!h){d=0;do{f=c+(d<<2)|0;t=c+(o-d<<2)|0;s=k[f>>2]|0;k[f>>2]=k[t>>2];k[t>>2]=s;d=d+1|0}while((d|0)<(n|0))}if(m){e=k[v>>2]|0;f=k[l>>2]|0;d=0;do{t=e+(aa(k[f>>2]|0,d)|0)+(g<<2)|0;k[t>>2]=k[c+(d<<2)>>2];d=d+1|0}while((d|0)!=(q|0))}g=g+1|0}while((g|0)!=(p|0))}c=k[x>>2]|0}if((c|0)!=(y|0)){if(c|0)ggb(c);k[x>>2]=y;k[z>>2]=264}c=k[A>>2]|0;if((c|0)==(B|0)){r=D;return}if(c|0)ggb(c);k[A>>2]=B;k[C>>2]=1032;r=D;return}function R3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=r;r=r+2128|0;x=E;B=E+1072|0;y=E+8|0;C=B+8|0;k[B>>2]=C;D=B+4|0;k[D>>2]=520;z=y+8|0;k[y>>2]=z;A=y+4|0;k[A>>2]=264;t=(c&1|0)==0;u=(c&16|0)==0;v=a+16|0;w=b+16|0;if((k[v>>2]|0)==(k[w>>2]|0)){k[x>>2]=0;c=x+4|0;k[c>>2]=0;d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[x>>2]=e;k[c>>2]=20;i[d+24>>0]=0;f=220657;g=e+20|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,x,220678,216975,4026);k[c>>2]=0;k[x>>2]=0;s=k[d>>2]|0;k[d>>2]=s+-1;if((s|0)==1)ggb(k[d+-4>>2]|0)}do if(!t){f=k[a+12>>2]|0;e=k[a+8>>2]|0;if((k[D>>2]|0)>>>0<e>>>0){c=k[B>>2]|0;if((c|0)!=(C|0)){if(c|0)ggb(c);k[B>>2]=C;k[D>>2]=520}if(e>>>0>520){d=e>>>0>2147483647?-1:e<<1;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[B>>2]=c;k[D>>2]=e}}else k[D>>2]=e;if((k[A>>2]|0)>>>0>=e>>>0){k[A>>2]=e;s=e;q=f;break}c=k[y>>2]|0;if((c|0)!=(z|0)){if(c|0)ggb(c);k[y>>2]=z;k[A>>2]=264}if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[y>>2]=c;k[A>>2]=e;s=e;q=f}else{s=e;q=f}}else{s=k[a+12>>2]|0;q=k[a+8>>2]|0}while(0);l=k[B>>2]|0;c=k[y>>2]|0;if((q|0)>0){h=a+48|0;m=b+44|0;n=(s|0)>0;o=(s|0)/2|0;d=(s|0)>1;p=s+-1|0;a=a+44|0;if(t){g=u|d^1;e=0;do{d=(k[v>>2]|0)+(aa(k[h>>2]|0,e)|0)|0;f=(k[w>>2]|0)+(aa(k[k[m>>2]>>2]|0,e)|0)|0;if(n){c=0;do{k[f+(c<<2)>>2]=c;c=c+1|0}while((c|0)!=(s|0))}k[x>>2]=d;g4(f,f+(s<<2)|0,x);if(!g){c=0;do{l=f+(c<<2)|0;u=f+(p-c<<2)|0;t=k[l>>2]|0;k[l>>2]=k[u>>2];k[u>>2]=t;c=c+1|0}while((c|0)<(o|0))}e=e+1|0}while((e|0)!=(q|0))}else{b=c+(s<<2)|0;h=u|d^1;g=0;do{if(n){e=k[v>>2]|0;f=k[k[a>>2]>>2]|0;d=0;do{u=e+(aa(f,d)|0)+(g<<1)|0;j[l+(d<<1)>>1]=j[u>>1]|0;d=d+1|0}while((d|0)!=(s|0));d=0;do{k[c+(d<<2)>>2]=d;d=d+1|0}while((d|0)!=(s|0))}k[x>>2]=l;g4(c,b,x);if(!h){d=0;do{f=c+(d<<2)|0;u=c+(p-d<<2)|0;t=k[f>>2]|0;k[f>>2]=k[u>>2];k[u>>2]=t;d=d+1|0}while((d|0)<(o|0))}if(n){e=k[w>>2]|0;f=k[m>>2]|0;d=0;do{u=e+(aa(k[f>>2]|0,d)|0)+(g<<2)|0;k[u>>2]=k[c+(d<<2)>>2];d=d+1|0}while((d|0)!=(s|0))}g=g+1|0}while((g|0)!=(q|0))}c=k[y>>2]|0}if((c|0)!=(z|0)){if(c|0)ggb(c);k[y>>2]=z;k[A>>2]=264}c=k[B>>2]|0;if((c|0)==(C|0)){r=E;return}if(c|0)ggb(c);k[B>>2]=C;k[D>>2]=520;r=E;return}function S3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=r;r=r+2128|0;x=E;B=E+1072|0;y=E+8|0;C=B+8|0;k[B>>2]=C;D=B+4|0;k[D>>2]=520;z=y+8|0;k[y>>2]=z;A=y+4|0;k[A>>2]=264;t=(c&1|0)==0;u=(c&16|0)==0;v=a+16|0;w=b+16|0;if((k[v>>2]|0)==(k[w>>2]|0)){k[x>>2]=0;c=x+4|0;k[c>>2]=0;d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[x>>2]=e;k[c>>2]=20;i[d+24>>0]=0;f=220657;g=e+20|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,x,220678,216975,4026);k[c>>2]=0;k[x>>2]=0;s=k[d>>2]|0;k[d>>2]=s+-1;if((s|0)==1)ggb(k[d+-4>>2]|0)}do if(!t){f=k[a+12>>2]|0;e=k[a+8>>2]|0;if((k[D>>2]|0)>>>0<e>>>0){c=k[B>>2]|0;if((c|0)!=(C|0)){if(c|0)ggb(c);k[B>>2]=C;k[D>>2]=520}if(e>>>0>520){d=e>>>0>2147483647?-1:e<<1;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[B>>2]=c;k[D>>2]=e}}else k[D>>2]=e;if((k[A>>2]|0)>>>0>=e>>>0){k[A>>2]=e;s=e;q=f;break}c=k[y>>2]|0;if((c|0)!=(z|0)){if(c|0)ggb(c);k[y>>2]=z;k[A>>2]=264}if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[y>>2]=c;k[A>>2]=e;s=e;q=f}else{s=e;q=f}}else{s=k[a+12>>2]|0;q=k[a+8>>2]|0}while(0);l=k[B>>2]|0;c=k[y>>2]|0;if((q|0)>0){h=a+48|0;m=b+44|0;n=(s|0)>0;o=(s|0)/2|0;d=(s|0)>1;p=s+-1|0;a=a+44|0;if(t){g=u|d^1;e=0;do{d=(k[v>>2]|0)+(aa(k[h>>2]|0,e)|0)|0;f=(k[w>>2]|0)+(aa(k[k[m>>2]>>2]|0,e)|0)|0;if(n){c=0;do{k[f+(c<<2)>>2]=c;c=c+1|0}while((c|0)!=(s|0))}k[x>>2]=d;d4(f,f+(s<<2)|0,x);if(!g){c=0;do{l=f+(c<<2)|0;u=f+(p-c<<2)|0;t=k[l>>2]|0;k[l>>2]=k[u>>2];k[u>>2]=t;c=c+1|0}while((c|0)<(o|0))}e=e+1|0}while((e|0)!=(q|0))}else{b=c+(s<<2)|0;h=u|d^1;g=0;do{if(n){e=k[v>>2]|0;f=k[k[a>>2]>>2]|0;d=0;do{u=e+(aa(f,d)|0)+(g<<1)|0;j[l+(d<<1)>>1]=j[u>>1]|0;d=d+1|0}while((d|0)!=(s|0));d=0;do{k[c+(d<<2)>>2]=d;d=d+1|0}while((d|0)!=(s|0))}k[x>>2]=l;d4(c,b,x);if(!h){d=0;do{f=c+(d<<2)|0;u=c+(p-d<<2)|0;t=k[f>>2]|0;k[f>>2]=k[u>>2];k[u>>2]=t;d=d+1|0}while((d|0)<(o|0))}if(n){e=k[w>>2]|0;f=k[m>>2]|0;d=0;do{u=e+(aa(k[f>>2]|0,d)|0)+(g<<2)|0;k[u>>2]=k[c+(d<<2)>>2];d=d+1|0}while((d|0)!=(s|0))}g=g+1|0}while((g|0)!=(q|0))}c=k[y>>2]|0}if((c|0)!=(z|0)){if(c|0)ggb(c);k[y>>2]=z;k[A>>2]=264}c=k[B>>2]|0;if((c|0)==(C|0)){r=E;return}if(c|0)ggb(c);k[B>>2]=C;k[D>>2]=520;r=E;return}function T3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+2144|0;w=D;A=D+1072|0;x=D+8|0;B=A+8|0;k[A>>2]=B;C=A+4|0;k[C>>2]=264;y=x+8|0;k[x>>2]=y;z=x+4|0;k[z>>2]=264;s=(c&1|0)==0;t=(c&16|0)==0;u=a+16|0;v=b+16|0;if((k[u>>2]|0)==(k[v>>2]|0)){k[w>>2]=0;c=w+4|0;k[c>>2]=0;d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[w>>2]=e;k[c>>2]=20;i[d+24>>0]=0;f=220657;g=e+20|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,w,220678,216975,4026);k[c>>2]=0;k[w>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}do if(!s){f=k[a+12>>2]|0;e=k[a+8>>2]|0;if((k[C>>2]|0)>>>0<e>>>0){c=k[A>>2]|0;if((c|0)!=(B|0)){if(c|0)ggb(c);k[A>>2]=B;k[C>>2]=264}if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[A>>2]=c;k[C>>2]=e}}else k[C>>2]=e;if((k[z>>2]|0)>>>0>=e>>>0){k[z>>2]=e;q=e;p=f;break}c=k[x>>2]|0;if((c|0)!=(y|0)){if(c|0)ggb(c);k[x>>2]=y;k[z>>2]=264}if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[x>>2]=c;k[z>>2]=e;q=e;p=f}else{q=e;p=f}}else{q=k[a+12>>2]|0;p=k[a+8>>2]|0}while(0);j=k[A>>2]|0;c=k[x>>2]|0;if((p|0)>0){h=a+48|0;l=b+44|0;m=(q|0)>0;n=(q|0)/2|0;d=(q|0)>1;o=q+-1|0;a=a+44|0;if(s){g=t|d^1;e=0;do{d=(k[u>>2]|0)+(aa(k[h>>2]|0,e)|0)|0;f=(k[v>>2]|0)+(aa(k[k[l>>2]>>2]|0,e)|0)|0;if(m){c=0;do{k[f+(c<<2)>>2]=c;c=c+1|0}while((c|0)!=(q|0))}k[w>>2]=d;a4(f,f+(q<<2)|0,w);if(!g){c=0;do{j=f+(c<<2)|0;t=f+(o-c<<2)|0;s=k[j>>2]|0;k[j>>2]=k[t>>2];k[t>>2]=s;c=c+1|0}while((c|0)<(n|0))}e=e+1|0}while((e|0)!=(p|0))}else{b=c+(q<<2)|0;h=t|d^1;g=0;do{if(m){e=k[u>>2]|0;f=k[a>>2]|0;d=0;do{t=e+(aa(k[f>>2]|0,d)|0)+(g<<2)|0;k[j+(d<<2)>>2]=k[t>>2];d=d+1|0}while((d|0)!=(q|0));d=0;do{k[c+(d<<2)>>2]=d;d=d+1|0}while((d|0)!=(q|0))}k[w>>2]=j;a4(c,b,w);if(!h){d=0;do{f=c+(d<<2)|0;t=c+(o-d<<2)|0;s=k[f>>2]|0;k[f>>2]=k[t>>2];k[t>>2]=s;d=d+1|0}while((d|0)<(n|0))}if(m){e=k[v>>2]|0;f=k[l>>2]|0;d=0;do{t=e+(aa(k[f>>2]|0,d)|0)+(g<<2)|0;k[t>>2]=k[c+(d<<2)>>2];d=d+1|0}while((d|0)!=(q|0))}g=g+1|0}while((g|0)!=(p|0))}c=k[x>>2]|0}if((c|0)!=(y|0)){if(c|0)ggb(c);k[x>>2]=y;k[z>>2]=264}c=k[A>>2]|0;if((c|0)==(B|0)){r=D;return}if(c|0)ggb(c);k[A>>2]=B;k[C>>2]=264;r=D;return}function U3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+2144|0;w=D;A=D+1072|0;x=D+8|0;B=A+8|0;k[A>>2]=B;C=A+4|0;k[C>>2]=264;y=x+8|0;k[x>>2]=y;z=x+4|0;k[z>>2]=264;s=(c&1|0)==0;t=(c&16|0)==0;u=a+16|0;v=b+16|0;if((k[u>>2]|0)==(k[v>>2]|0)){k[w>>2]=0;c=w+4|0;k[c>>2]=0;d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[w>>2]=e;k[c>>2]=20;i[d+24>>0]=0;f=220657;g=e+20|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,w,220678,216975,4026);k[c>>2]=0;k[w>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}do if(!s){f=k[a+12>>2]|0;e=k[a+8>>2]|0;if((k[C>>2]|0)>>>0<e>>>0){c=k[A>>2]|0;if((c|0)!=(B|0)){if(c|0)ggb(c);k[A>>2]=B;k[C>>2]=264}if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[A>>2]=c;k[C>>2]=e}}else k[C>>2]=e;if((k[z>>2]|0)>>>0>=e>>>0){k[z>>2]=e;q=e;p=f;break}c=k[x>>2]|0;if((c|0)!=(y|0)){if(c|0)ggb(c);k[x>>2]=y;k[z>>2]=264}if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[x>>2]=c;k[z>>2]=e;q=e;p=f}else{q=e;p=f}}else{q=k[a+12>>2]|0;p=k[a+8>>2]|0}while(0);j=k[A>>2]|0;c=k[x>>2]|0;if((p|0)>0){h=a+48|0;l=b+44|0;m=(q|0)>0;n=(q|0)/2|0;d=(q|0)>1;o=q+-1|0;a=a+44|0;if(s){g=t|d^1;e=0;do{d=(k[u>>2]|0)+(aa(k[h>>2]|0,e)|0)|0;f=(k[v>>2]|0)+(aa(k[k[l>>2]>>2]|0,e)|0)|0;if(m){c=0;do{k[f+(c<<2)>>2]=c;c=c+1|0}while((c|0)!=(q|0))}k[w>>2]=d;Z3(f,f+(q<<2)|0,w);if(!g){c=0;do{j=f+(c<<2)|0;t=f+(o-c<<2)|0;s=k[j>>2]|0;k[j>>2]=k[t>>2];k[t>>2]=s;c=c+1|0}while((c|0)<(n|0))}e=e+1|0}while((e|0)!=(p|0))}else{b=c+(q<<2)|0;h=t|d^1;g=0;do{if(m){e=k[u>>2]|0;f=k[k[a>>2]>>2]|0;d=0;do{t=e+(aa(f,d)|0)+(g<<2)|0;k[j+(d<<2)>>2]=k[t>>2];d=d+1|0}while((d|0)!=(q|0));d=0;do{k[c+(d<<2)>>2]=d;d=d+1|0}while((d|0)!=(q|0))}k[w>>2]=j;Z3(c,b,w);if(!h){d=0;do{f=c+(d<<2)|0;t=c+(o-d<<2)|0;s=k[f>>2]|0;k[f>>2]=k[t>>2];k[t>>2]=s;d=d+1|0}while((d|0)<(n|0))}if(m){e=k[v>>2]|0;f=k[l>>2]|0;d=0;do{t=e+(aa(k[f>>2]|0,d)|0)+(g<<2)|0;k[t>>2]=k[c+(d<<2)>>2];d=d+1|0}while((d|0)!=(q|0))}g=g+1|0}while((g|0)!=(p|0))}c=k[x>>2]|0}if((c|0)!=(y|0)){if(c|0)ggb(c);k[x>>2]=y;k[z>>2]=264}c=k[A>>2]|0;if((c|0)==(B|0)){r=D;return}if(c|0)ggb(c);k[A>>2]=B;k[C>>2]=264;r=D;return}function V3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=r;r=r+2176|0;x=E+1096|0;B=E;y=E+1104|0;C=B+8|0;k[B>>2]=C;D=B+4|0;k[D>>2]=136;z=y+8|0;k[y>>2]=z;A=y+4|0;k[A>>2]=264;t=(c&1|0)==0;u=(c&16|0)==0;v=a+16|0;w=b+16|0;if((k[v>>2]|0)==(k[w>>2]|0)){k[x>>2]=0;c=x+4|0;k[c>>2]=0;d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[x>>2]=e;k[c>>2]=20;i[d+24>>0]=0;f=220657;g=e+20|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,x,220678,216975,4026);k[c>>2]=0;k[x>>2]=0;s=k[d>>2]|0;k[d>>2]=s+-1;if((s|0)==1)ggb(k[d+-4>>2]|0)}do if(!t){f=k[a+12>>2]|0;e=k[a+8>>2]|0;if((k[D>>2]|0)>>>0<e>>>0){c=k[B>>2]|0;if((c|0)!=(C|0)){if(c|0)ggb(c);k[B>>2]=C;k[D>>2]=136}if(e>>>0>136){d=e>>>0>536870911?-1:e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[B>>2]=c;k[D>>2]=e}}else k[D>>2]=e;if((k[A>>2]|0)>>>0>=e>>>0){k[A>>2]=e;s=e;q=f;break}c=k[y>>2]|0;if((c|0)!=(z|0)){if(c|0)ggb(c);k[y>>2]=z;k[A>>2]=264}if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[y>>2]=c;k[A>>2]=e;s=e;q=f}else{s=e;q=f}}else{s=k[a+12>>2]|0;q=k[a+8>>2]|0}while(0);j=k[B>>2]|0;c=k[y>>2]|0;if((q|0)>0){h=a+48|0;l=b+44|0;m=(s|0)>0;n=(s|0)/2|0;d=(s|0)>1;o=s+-1|0;a=a+44|0;if(t){g=u|d^1;e=0;do{d=(k[v>>2]|0)+(aa(k[h>>2]|0,e)|0)|0;f=(k[w>>2]|0)+(aa(k[k[l>>2]>>2]|0,e)|0)|0;if(m){c=0;do{k[f+(c<<2)>>2]=c;c=c+1|0}while((c|0)!=(s|0))}k[x>>2]=d;W3(f,f+(s<<2)|0,x);if(!g){c=0;do{j=f+(c<<2)|0;u=f+(o-c<<2)|0;t=k[j>>2]|0;k[j>>2]=k[u>>2];k[u>>2]=t;c=c+1|0}while((c|0)<(n|0))}e=e+1|0}while((e|0)!=(q|0))}else{b=c+(s<<2)|0;h=u|d^1;g=0;do{if(m){e=k[v>>2]|0;f=k[k[a>>2]>>2]|0;d=0;do{u=e+(aa(f,d)|0)+(g<<3)|0;p[j+(d<<3)>>3]=+p[u>>3];d=d+1|0}while((d|0)!=(s|0));d=0;do{k[c+(d<<2)>>2]=d;d=d+1|0}while((d|0)!=(s|0))}k[x>>2]=j;W3(c,b,x);if(!h){d=0;do{f=c+(d<<2)|0;u=c+(o-d<<2)|0;t=k[f>>2]|0;k[f>>2]=k[u>>2];k[u>>2]=t;d=d+1|0}while((d|0)<(n|0))}if(m){e=k[w>>2]|0;f=k[l>>2]|0;d=0;do{u=e+(aa(k[f>>2]|0,d)|0)+(g<<2)|0;k[u>>2]=k[c+(d<<2)>>2];d=d+1|0}while((d|0)!=(s|0))}g=g+1|0}while((g|0)!=(q|0))}c=k[y>>2]|0}if((c|0)!=(z|0)){if(c|0)ggb(c);k[y>>2]=z;k[A>>2]=264}c=k[B>>2]|0;if((c|0)==(C|0)){r=E;return}if(c|0)ggb(c);k[B>>2]=C;k[D>>2]=136;r=E;return}function W3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0.0,h=0,i=0.0,j=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0;a:while(1){o=b;t=b+-4|0;while(1){u=a;b:while(1){n=u;a=o-n|0;d=a>>2;switch(d|0){case 2:{s=5;break a}case 3:{s=7;break a}case 4:{s=15;break a}case 5:{s=16;break a}case 1:case 0:{s=86;break a}default:{}}if((a|0)<124){s=22;break a}l=u+(((d|0)/2|0)<<2)|0;do if((a|0)>3996){j=(d|0)/4|0;m=u+(j<<2)|0;j=l+(j<<2)|0;a=X3(u,m,l,j,k[c>>2]|0)|0;e=k[t>>2]|0;f=k[j>>2]|0;d=k[c>>2]|0;if(+p[d+(e<<3)>>3]<+p[d+(f<<3)>>3]){k[j>>2]=e;k[t>>2]=f;e=a+1|0;f=k[j>>2]|0;h=k[l>>2]|0;if(+p[d+(f<<3)>>3]<+p[d+(h<<3)>>3]){k[l>>2]=f;k[j>>2]=h;e=a+2|0;f=k[l>>2]|0;h=k[m>>2]|0;if(+p[d+(f<<3)>>3]<+p[d+(h<<3)>>3]){k[m>>2]=f;k[l>>2]=h;e=k[m>>2]|0;f=k[u>>2]|0;if(+p[d+(e<<3)>>3]<+p[d+(f<<3)>>3]){k[u>>2]=e;k[m>>2]=f;a=a+4|0}else a=a+3|0}else a=e}else a=e}}else{a=k[l>>2]|0;f=k[u>>2]|0;h=k[c>>2]|0;i=+p[h+(a<<3)>>3];g=+p[h+(f<<3)>>3];d=k[t>>2]|0;e=+p[h+(d<<3)>>3]<i;if(!(i<g)){if(!e){a=0;d=h;break}k[l>>2]=d;k[t>>2]=a;a=k[l>>2]|0;d=k[u>>2]|0;if(!(+p[h+(a<<3)>>3]<+p[h+(d<<3)>>3])){a=1;d=h;break}k[u>>2]=a;k[l>>2]=d;a=2;d=h;break}if(e){k[u>>2]=d;k[t>>2]=f;a=1;d=h;break}k[u>>2]=a;k[l>>2]=f;a=k[t>>2]|0;if(+p[h+(a<<3)>>3]<g){k[l>>2]=a;k[t>>2]=f;a=2;d=h}else{a=1;d=h}}while(0);h=k[u>>2]|0;e=k[l>>2]|0;if(+p[d+(h<<3)>>3]<+p[d+(e<<3)>>3]){d=t;break}j=k[c>>2]|0;e=j+(e<<3)|0;d=t;while(1){d=d+-4|0;if((u|0)==(d|0))break;f=k[d>>2]|0;if(+p[j+(f<<3)>>3]<+p[e>>3]){s=68;break b}}a=u+4|0;e=k[t>>2]|0;g=+p[j+(h<<3)>>3];if(!(g<+p[j+(e<<3)>>3])){if((a|0)==(t|0)){s=86;break a}while(1){d=k[a>>2]|0;if(g<+p[j+(d<<3)>>3])break;a=a+4|0;if((a|0)==(t|0)){s=86;break a}}k[a>>2]=e;k[t>>2]=d;a=a+4|0}if((a|0)==(t|0)){s=86;break a}j=k[c>>2]|0;d=t;while(1){g=+p[j+(k[u>>2]<<3)>>3];while(1){f=k[a>>2]|0;h=a+4|0;if(g<+p[j+(f<<3)>>3])break;else a=h}do{d=d+-4|0;e=k[d>>2]|0}while(g<+p[j+(e<<3)>>3]);if(a>>>0>=d>>>0){u=a;continue b}k[a>>2]=e;k[d>>2]=f;a=h}}if((s|0)==68){s=0;k[u>>2]=f;k[d>>2]=h;a=a+1|0}e=u+4|0;c:do if(e>>>0<d>>>0){m=k[c>>2]|0;while(1){g=+p[m+(k[l>>2]<<3)>>3];while(1){h=k[e>>2]|0;j=e+4|0;if(+p[m+(h<<3)>>3]<g)e=j;else break}do{d=d+-4|0;f=k[d>>2]|0}while(!(+p[m+(f<<3)>>3]<g));if(e>>>0>d>>>0){d=l;break c}k[e>>2]=f;k[d>>2]=h;l=(l|0)==(e|0)?d:l;e=j;a=a+1|0}}else d=l;while(0);if((e|0)!=(d|0)?(q=k[d>>2]|0,r=k[e>>2]|0,m=k[c>>2]|0,+p[m+(q<<3)>>3]<+p[m+(r<<3)>>3]):0){k[e>>2]=q;k[d>>2]=r;a=a+1|0}if(!a){d=Y3(u,e,c)|0;a=e+4|0;if(Y3(a,b,c)|0){s=85;break}if(d)continue}m=e;if((m-n|0)>=(o-m|0)){s=84;break}W3(u,e,c);a=e+4|0}if((s|0)==84){s=0;W3(e+4|0,b,c);a=u;b=e;continue}else if((s|0)==85){s=0;if(d){s=86;break}else{a=u;b=e;continue}}}if((s|0)==5){a=k[t>>2]|0;b=k[u>>2]|0;c=k[c>>2]|0;if(!(+p[c+(a<<3)>>3]<+p[c+(b<<3)>>3]))return;k[u>>2]=a;k[t>>2]=b;return}else if((s|0)==7){h=u+4|0;d=k[h>>2]|0;e=k[u>>2]|0;f=k[c>>2]|0;i=+p[f+(d<<3)>>3];g=+p[f+(e<<3)>>3];a=k[t>>2]|0;b=+p[f+(a<<3)>>3]<i;if(!(i<g)){if(!b)return;k[h>>2]=a;k[t>>2]=d;a=k[h>>2]|0;b=k[u>>2]|0;if(!(+p[f+(a<<3)>>3]<+p[f+(b<<3)>>3]))return;k[u>>2]=a;k[h>>2]=b;return}if(b){k[u>>2]=a;k[t>>2]=e;return}k[u>>2]=d;k[h>>2]=e;a=k[t>>2]|0;if(!(+p[f+(a<<3)>>3]<g))return;k[h>>2]=a;k[t>>2]=e;return}else if((s|0)==15){X3(u,u+4|0,u+8|0,t,k[c>>2]|0)|0;return}else if((s|0)==16){h=u+4|0;e=u+8|0;d=u+12|0;X3(u,h,e,d,k[c>>2]|0)|0;a=k[t>>2]|0;b=k[d>>2]|0;f=k[c>>2]|0;if(!(+p[f+(a<<3)>>3]<+p[f+(b<<3)>>3]))return;k[d>>2]=a;k[t>>2]=b;b=k[d>>2]|0;a=k[e>>2]|0;g=+p[f+(b<<3)>>3];if(!(g<+p[f+(a<<3)>>3]))return;k[e>>2]=b;k[d>>2]=a;a=k[h>>2]|0;if(!(g<+p[f+(a<<3)>>3]))return;k[h>>2]=b;k[e>>2]=a;a=k[u>>2]|0;if(!(g<+p[f+(a<<3)>>3]))return;k[u>>2]=b;k[h>>2]=a;return}else if((s|0)==22){a=u+8|0;d=u+4|0;e=k[d>>2]|0;f=k[u>>2]|0;j=k[c>>2]|0;v=+p[j+(e<<3)>>3];g=+p[j+(f<<3)>>3];h=k[a>>2]|0;i=+p[j+(h<<3)>>3];j=i<v;do if(v<g){if(j){k[u>>2]=h;k[a>>2]=f;e=f;break}k[u>>2]=e;k[d>>2]=f;if(i<g){k[d>>2]=h;k[a>>2]=f;e=f}else e=h}else if(j){k[d>>2]=h;k[a>>2]=e;if(i<g){k[u>>2]=h;k[d>>2]=f}}else e=h;while(0);d=u+12|0;if((d|0)==(b|0))return;j=k[c>>2]|0;while(1){h=k[d>>2]|0;g=+p[j+(h<<3)>>3];if(g<+p[j+(e<<3)>>3]){f=d;while(1){k[f>>2]=e;if((a|0)==(u|0)){a=u;break}f=a+-4|0;e=k[f>>2]|0;if(!(g<+p[j+(e<<3)>>3]))break;else{c=a;a=f;f=c}}k[a>>2]=h}a=d+4|0;if((a|0)==(b|0))break;e=k[d>>2]|0;c=d;d=a;a=c}return}else if((s|0)==86)return}function X3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,i=0,j=0,l=0,m=0.0;j=k[b>>2]|0;i=k[a>>2]|0;m=+p[e+(j<<3)>>3];h=+p[e+(i<<3)>>3];g=k[c>>2]|0;f=+p[e+(g<<3)>>3]<m;do if(m<h){if(f){k[a>>2]=g;k[c>>2]=i;l=1;g=i;break}k[a>>2]=j;k[b>>2]=i;g=k[c>>2]|0;if(+p[e+(g<<3)>>3]<h){k[b>>2]=g;k[c>>2]=i;l=2;g=i}else l=1}else if(f){k[b>>2]=g;k[c>>2]=j;f=k[b>>2]|0;g=k[a>>2]|0;if(+p[e+(f<<3)>>3]<+p[e+(g<<3)>>3]){k[a>>2]=f;k[b>>2]=g;l=2;g=k[c>>2]|0}else{l=1;g=j}}else l=0;while(0);f=k[d>>2]|0;if(!(+p[e+(f<<3)>>3]<+p[e+(g<<3)>>3])){b=l;return b|0}k[c>>2]=f;k[d>>2]=g;f=k[c>>2]|0;g=k[b>>2]|0;if(!(+p[e+(f<<3)>>3]<+p[e+(g<<3)>>3])){b=l+1|0;return b|0}k[b>>2]=f;k[c>>2]=g;f=k[b>>2]|0;g=k[a>>2]|0;if(!(+p[e+(f<<3)>>3]<+p[e+(g<<3)>>3])){b=l+2|0;return b|0}k[a>>2]=f;k[b>>2]=g;b=l+3|0;return b|0}function Y3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0.0,h=0,i=0,j=0.0,l=0,m=0,n=0.0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=k[d>>2]|0;f=k[a>>2]|0;b=k[c>>2]|0;if(!(+p[b+(e<<3)>>3]<+p[b+(f<<3)>>3])){a=1;return a|0}k[a>>2]=e;k[d>>2]=f;a=1;return a|0}case 3:{m=a+4|0;h=b+-4|0;f=k[m>>2]|0;i=k[a>>2]|0;l=k[c>>2]|0;j=+p[l+(f<<3)>>3];g=+p[l+(i<<3)>>3];d=k[h>>2]|0;e=+p[l+(d<<3)>>3]<j;if(!(j<g)){if(!e){a=1;return a|0}k[m>>2]=d;k[h>>2]=f;d=k[m>>2]|0;e=k[a>>2]|0;if(!(+p[l+(d<<3)>>3]<+p[l+(e<<3)>>3])){a=1;return a|0}k[a>>2]=d;k[m>>2]=e;a=1;return a|0}if(e){k[a>>2]=d;k[h>>2]=i;a=1;return a|0}k[a>>2]=f;k[m>>2]=i;d=k[h>>2]|0;if(!(+p[l+(d<<3)>>3]<g)){a=1;return a|0}k[m>>2]=d;k[h>>2]=i;a=1;return a|0}case 4:{X3(a,a+4|0,a+8|0,b+-4|0,k[c>>2]|0)|0;a=1;return a|0}case 5:{m=a+4|0;l=a+8|0;h=a+12|0;d=b+-4|0;X3(a,m,l,h,k[c>>2]|0)|0;e=k[d>>2]|0;f=k[h>>2]|0;i=k[c>>2]|0;if(!(+p[i+(e<<3)>>3]<+p[i+(f<<3)>>3])){a=1;return a|0}k[h>>2]=e;k[d>>2]=f;e=k[h>>2]|0;d=k[l>>2]|0;g=+p[i+(e<<3)>>3];if(!(g<+p[i+(d<<3)>>3])){a=1;return a|0}k[l>>2]=e;k[h>>2]=d;d=k[m>>2]|0;if(!(g<+p[i+(d<<3)>>3])){a=1;return a|0}k[m>>2]=e;k[l>>2]=d;d=k[a>>2]|0;if(!(g<+p[i+(d<<3)>>3])){a=1;return a|0}k[a>>2]=e;k[m>>2]=d;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{d=a+8|0;e=a+4|0;f=k[e>>2]|0;h=k[a>>2]|0;l=k[c>>2]|0;n=+p[l+(f<<3)>>3];g=+p[l+(h<<3)>>3];i=k[d>>2]|0;j=+p[l+(i<<3)>>3];l=j<n;do if(n<g){if(l){k[a>>2]=i;k[d>>2]=h;f=h;break}k[a>>2]=f;k[e>>2]=h;if(j<g){k[e>>2]=i;k[d>>2]=h;f=h}else f=i}else if(l){k[e>>2]=i;k[d>>2]=f;if(j<g){k[a>>2]=i;k[e>>2]=h}}else f=i;while(0);e=a+12|0;a:do if((e|0)==(b|0)){e=1;d=0}else{m=k[c>>2]|0;l=e;e=0;while(1){i=k[l>>2]|0;g=+p[m+(i<<3)>>3];if(g<+p[m+(f<<3)>>3]){h=l;while(1){k[h>>2]=f;if((d|0)==(a|0)){d=a;break}h=d+-4|0;f=k[h>>2]|0;if(!(g<+p[m+(f<<3)>>3]))break;else{c=d;d=h;h=c}}k[d>>2]=i;e=e+1|0;d=l+4|0;if((e|0)==8){e=0;d=(d|0)==(b|0);break a}}else d=l+4|0;if((d|0)==(b|0)){e=1;d=0;break a}f=k[l>>2]|0;c=l;l=d;d=c}}while(0);a=d|e;return a|0}}return 0}function Z3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0.0,h=0,i=0.0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0;a:while(1){p=b;t=b+-4|0;while(1){u=a;b:while(1){n=u;a=p-n|0;d=a>>2;switch(d|0){case 2:{s=5;break a}case 3:{s=7;break a}case 4:{s=15;break a}case 5:{s=16;break a}case 1:case 0:{s=86;break a}default:{}}if((a|0)<124){s=22;break a}l=u+(((d|0)/2|0)<<2)|0;do if((a|0)>3996){j=(d|0)/4|0;m=u+(j<<2)|0;j=l+(j<<2)|0;a=_3(u,m,l,j,k[c>>2]|0)|0;e=k[t>>2]|0;f=k[j>>2]|0;d=k[c>>2]|0;if(+o[d+(e<<2)>>2]<+o[d+(f<<2)>>2]){k[j>>2]=e;k[t>>2]=f;e=a+1|0;f=k[j>>2]|0;h=k[l>>2]|0;if(+o[d+(f<<2)>>2]<+o[d+(h<<2)>>2]){k[l>>2]=f;k[j>>2]=h;e=a+2|0;f=k[l>>2]|0;h=k[m>>2]|0;if(+o[d+(f<<2)>>2]<+o[d+(h<<2)>>2]){k[m>>2]=f;k[l>>2]=h;e=k[m>>2]|0;f=k[u>>2]|0;if(+o[d+(e<<2)>>2]<+o[d+(f<<2)>>2]){k[u>>2]=e;k[m>>2]=f;a=a+4|0}else a=a+3|0}else a=e}else a=e}}else{a=k[l>>2]|0;f=k[u>>2]|0;h=k[c>>2]|0;i=+o[h+(a<<2)>>2];g=+o[h+(f<<2)>>2];d=k[t>>2]|0;e=+o[h+(d<<2)>>2]<i;if(!(i<g)){if(!e){a=0;d=h;break}k[l>>2]=d;k[t>>2]=a;a=k[l>>2]|0;d=k[u>>2]|0;if(!(+o[h+(a<<2)>>2]<+o[h+(d<<2)>>2])){a=1;d=h;break}k[u>>2]=a;k[l>>2]=d;a=2;d=h;break}if(e){k[u>>2]=d;k[t>>2]=f;a=1;d=h;break}k[u>>2]=a;k[l>>2]=f;a=k[t>>2]|0;if(+o[h+(a<<2)>>2]<g){k[l>>2]=a;k[t>>2]=f;a=2;d=h}else{a=1;d=h}}while(0);h=k[u>>2]|0;e=k[l>>2]|0;if(+o[d+(h<<2)>>2]<+o[d+(e<<2)>>2]){d=t;break}j=k[c>>2]|0;e=j+(e<<2)|0;d=t;while(1){d=d+-4|0;if((u|0)==(d|0))break;f=k[d>>2]|0;if(+o[j+(f<<2)>>2]<+o[e>>2]){s=68;break b}}a=u+4|0;e=k[t>>2]|0;g=+o[j+(h<<2)>>2];if(!(g<+o[j+(e<<2)>>2])){if((a|0)==(t|0)){s=86;break a}while(1){d=k[a>>2]|0;if(g<+o[j+(d<<2)>>2])break;a=a+4|0;if((a|0)==(t|0)){s=86;break a}}k[a>>2]=e;k[t>>2]=d;a=a+4|0}if((a|0)==(t|0)){s=86;break a}j=k[c>>2]|0;d=t;while(1){g=+o[j+(k[u>>2]<<2)>>2];while(1){f=k[a>>2]|0;h=a+4|0;if(g<+o[j+(f<<2)>>2])break;else a=h}do{d=d+-4|0;e=k[d>>2]|0}while(g<+o[j+(e<<2)>>2]);if(a>>>0>=d>>>0){u=a;continue b}k[a>>2]=e;k[d>>2]=f;a=h}}if((s|0)==68){s=0;k[u>>2]=f;k[d>>2]=h;a=a+1|0}e=u+4|0;c:do if(e>>>0<d>>>0){m=k[c>>2]|0;while(1){g=+o[m+(k[l>>2]<<2)>>2];while(1){h=k[e>>2]|0;j=e+4|0;if(+o[m+(h<<2)>>2]<g)e=j;else break}do{d=d+-4|0;f=k[d>>2]|0}while(!(+o[m+(f<<2)>>2]<g));if(e>>>0>d>>>0){d=l;break c}k[e>>2]=f;k[d>>2]=h;l=(l|0)==(e|0)?d:l;e=j;a=a+1|0}}else d=l;while(0);if((e|0)!=(d|0)?(q=k[d>>2]|0,r=k[e>>2]|0,m=k[c>>2]|0,+o[m+(q<<2)>>2]<+o[m+(r<<2)>>2]):0){k[e>>2]=q;k[d>>2]=r;a=a+1|0}if(!a){d=$3(u,e,c)|0;a=e+4|0;if($3(a,b,c)|0){s=85;break}if(d)continue}m=e;if((m-n|0)>=(p-m|0)){s=84;break}Z3(u,e,c);a=e+4|0}if((s|0)==84){s=0;Z3(e+4|0,b,c);a=u;b=e;continue}else if((s|0)==85){s=0;if(d){s=86;break}else{a=u;b=e;continue}}}if((s|0)==5){a=k[t>>2]|0;b=k[u>>2]|0;c=k[c>>2]|0;if(!(+o[c+(a<<2)>>2]<+o[c+(b<<2)>>2]))return;k[u>>2]=a;k[t>>2]=b;return}else if((s|0)==7){h=u+4|0;d=k[h>>2]|0;e=k[u>>2]|0;f=k[c>>2]|0;i=+o[f+(d<<2)>>2];g=+o[f+(e<<2)>>2];a=k[t>>2]|0;b=+o[f+(a<<2)>>2]<i;if(!(i<g)){if(!b)return;k[h>>2]=a;k[t>>2]=d;a=k[h>>2]|0;b=k[u>>2]|0;if(!(+o[f+(a<<2)>>2]<+o[f+(b<<2)>>2]))return;k[u>>2]=a;k[h>>2]=b;return}if(b){k[u>>2]=a;k[t>>2]=e;return}k[u>>2]=d;k[h>>2]=e;a=k[t>>2]|0;if(!(+o[f+(a<<2)>>2]<g))return;k[h>>2]=a;k[t>>2]=e;return}else if((s|0)==15){_3(u,u+4|0,u+8|0,t,k[c>>2]|0)|0;return}else if((s|0)==16){h=u+4|0;e=u+8|0;d=u+12|0;_3(u,h,e,d,k[c>>2]|0)|0;a=k[t>>2]|0;b=k[d>>2]|0;f=k[c>>2]|0;if(!(+o[f+(a<<2)>>2]<+o[f+(b<<2)>>2]))return;k[d>>2]=a;k[t>>2]=b;b=k[d>>2]|0;a=k[e>>2]|0;g=+o[f+(b<<2)>>2];if(!(g<+o[f+(a<<2)>>2]))return;k[e>>2]=b;k[d>>2]=a;a=k[h>>2]|0;if(!(g<+o[f+(a<<2)>>2]))return;k[h>>2]=b;k[e>>2]=a;a=k[u>>2]|0;if(!(g<+o[f+(a<<2)>>2]))return;k[u>>2]=b;k[h>>2]=a;return}else if((s|0)==22){a=u+8|0;d=u+4|0;e=k[d>>2]|0;f=k[u>>2]|0;j=k[c>>2]|0;v=+o[j+(e<<2)>>2];g=+o[j+(f<<2)>>2];h=k[a>>2]|0;i=+o[j+(h<<2)>>2];j=i<v;do if(v<g){if(j){k[u>>2]=h;k[a>>2]=f;e=f;break}k[u>>2]=e;k[d>>2]=f;if(i<g){k[d>>2]=h;k[a>>2]=f;e=f}else e=h}else if(j){k[d>>2]=h;k[a>>2]=e;if(i<g){k[u>>2]=h;k[d>>2]=f}}else e=h;while(0);d=u+12|0;if((d|0)==(b|0))return;j=k[c>>2]|0;while(1){h=k[d>>2]|0;g=+o[j+(h<<2)>>2];if(g<+o[j+(e<<2)>>2]){f=d;while(1){k[f>>2]=e;if((a|0)==(u|0)){a=u;break}f=a+-4|0;e=k[f>>2]|0;if(!(g<+o[j+(e<<2)>>2]))break;else{c=a;a=f;f=c}}k[a>>2]=h}a=d+4|0;if((a|0)==(b|0))break;e=k[d>>2]|0;c=d;d=a;a=c}return}else if((s|0)==86)return}function _3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,i=0,j=0,l=0,m=0.0;j=k[b>>2]|0;i=k[a>>2]|0;m=+o[e+(j<<2)>>2];h=+o[e+(i<<2)>>2];g=k[c>>2]|0;f=+o[e+(g<<2)>>2]<m;do if(m<h){if(f){k[a>>2]=g;k[c>>2]=i;l=1;g=i;break}k[a>>2]=j;k[b>>2]=i;g=k[c>>2]|0;if(+o[e+(g<<2)>>2]<h){k[b>>2]=g;k[c>>2]=i;l=2;g=i}else l=1}else if(f){k[b>>2]=g;k[c>>2]=j;f=k[b>>2]|0;g=k[a>>2]|0;if(+o[e+(f<<2)>>2]<+o[e+(g<<2)>>2]){k[a>>2]=f;k[b>>2]=g;l=2;g=k[c>>2]|0}else{l=1;g=j}}else l=0;while(0);f=k[d>>2]|0;if(!(+o[e+(f<<2)>>2]<+o[e+(g<<2)>>2])){b=l;return b|0}k[c>>2]=f;k[d>>2]=g;f=k[c>>2]|0;g=k[b>>2]|0;if(!(+o[e+(f<<2)>>2]<+o[e+(g<<2)>>2])){b=l+1|0;return b|0}k[b>>2]=f;k[c>>2]=g;f=k[b>>2]|0;g=k[a>>2]|0;if(!(+o[e+(f<<2)>>2]<+o[e+(g<<2)>>2])){b=l+2|0;return b|0}k[a>>2]=f;k[b>>2]=g;b=l+3|0;return b|0}function $3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0.0,h=0,i=0,j=0.0,l=0,m=0,n=0.0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=k[d>>2]|0;f=k[a>>2]|0;b=k[c>>2]|0;if(!(+o[b+(e<<2)>>2]<+o[b+(f<<2)>>2])){a=1;return a|0}k[a>>2]=e;k[d>>2]=f;a=1;return a|0}case 3:{m=a+4|0;h=b+-4|0;f=k[m>>2]|0;i=k[a>>2]|0;l=k[c>>2]|0;j=+o[l+(f<<2)>>2];g=+o[l+(i<<2)>>2];d=k[h>>2]|0;e=+o[l+(d<<2)>>2]<j;if(!(j<g)){if(!e){a=1;return a|0}k[m>>2]=d;k[h>>2]=f;d=k[m>>2]|0;e=k[a>>2]|0;if(!(+o[l+(d<<2)>>2]<+o[l+(e<<2)>>2])){a=1;return a|0}k[a>>2]=d;k[m>>2]=e;a=1;return a|0}if(e){k[a>>2]=d;k[h>>2]=i;a=1;return a|0}k[a>>2]=f;k[m>>2]=i;d=k[h>>2]|0;if(!(+o[l+(d<<2)>>2]<g)){a=1;return a|0}k[m>>2]=d;k[h>>2]=i;a=1;return a|0}case 4:{_3(a,a+4|0,a+8|0,b+-4|0,k[c>>2]|0)|0;a=1;return a|0}case 5:{m=a+4|0;l=a+8|0;h=a+12|0;d=b+-4|0;_3(a,m,l,h,k[c>>2]|0)|0;e=k[d>>2]|0;f=k[h>>2]|0;i=k[c>>2]|0;if(!(+o[i+(e<<2)>>2]<+o[i+(f<<2)>>2])){a=1;return a|0}k[h>>2]=e;k[d>>2]=f;e=k[h>>2]|0;d=k[l>>2]|0;g=+o[i+(e<<2)>>2];if(!(g<+o[i+(d<<2)>>2])){a=1;return a|0}k[l>>2]=e;k[h>>2]=d;d=k[m>>2]|0;if(!(g<+o[i+(d<<2)>>2])){a=1;return a|0}k[m>>2]=e;k[l>>2]=d;d=k[a>>2]|0;if(!(g<+o[i+(d<<2)>>2])){a=1;return a|0}k[a>>2]=e;k[m>>2]=d;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{d=a+8|0;e=a+4|0;f=k[e>>2]|0;h=k[a>>2]|0;l=k[c>>2]|0;n=+o[l+(f<<2)>>2];g=+o[l+(h<<2)>>2];i=k[d>>2]|0;j=+o[l+(i<<2)>>2];l=j<n;do if(n<g){if(l){k[a>>2]=i;k[d>>2]=h;f=h;break}k[a>>2]=f;k[e>>2]=h;if(j<g){k[e>>2]=i;k[d>>2]=h;f=h}else f=i}else if(l){k[e>>2]=i;k[d>>2]=f;if(j<g){k[a>>2]=i;k[e>>2]=h}}else f=i;while(0);e=a+12|0;a:do if((e|0)==(b|0)){e=1;d=0}else{m=k[c>>2]|0;l=e;e=0;while(1){i=k[l>>2]|0;g=+o[m+(i<<2)>>2];if(g<+o[m+(f<<2)>>2]){h=l;while(1){k[h>>2]=f;if((d|0)==(a|0)){d=a;break}h=d+-4|0;f=k[h>>2]|0;if(!(g<+o[m+(f<<2)>>2]))break;else{c=d;d=h;h=c}}k[d>>2]=i;e=e+1|0;d=l+4|0;if((e|0)==8){e=0;d=(d|0)==(b|0);break a}}else d=l+4|0;if((d|0)==(b|0)){e=1;d=0;break a}f=k[l>>2]|0;c=l;l=d;d=c}}while(0);a=d|e;return a|0}}return 0}function a4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a:while(1){n=b;r=b+-4|0;while(1){s=a;b:while(1){m=s;a=n-m|0;d=a>>2;switch(d|0){case 2:{q=5;break a}case 3:{q=7;break a}case 4:{q=15;break a}case 5:{q=16;break a}case 1:case 0:{q=86;break a}default:{}}if((a|0)<124){q=22;break a}j=s+(((d|0)/2|0)<<2)|0;do if((a|0)>3996){h=(d|0)/4|0;i=s+(h<<2)|0;h=j+(h<<2)|0;a=b4(s,i,j,h,k[c>>2]|0)|0;e=k[r>>2]|0;f=k[h>>2]|0;d=k[c>>2]|0;if((k[d+(e<<2)>>2]|0)<(k[d+(f<<2)>>2]|0)){k[h>>2]=e;k[r>>2]=f;e=a+1|0;f=k[h>>2]|0;g=k[j>>2]|0;if((k[d+(f<<2)>>2]|0)<(k[d+(g<<2)>>2]|0)){k[j>>2]=f;k[h>>2]=g;e=a+2|0;f=k[j>>2]|0;g=k[i>>2]|0;if((k[d+(f<<2)>>2]|0)<(k[d+(g<<2)>>2]|0)){k[i>>2]=f;k[j>>2]=g;e=k[i>>2]|0;f=k[s>>2]|0;if((k[d+(e<<2)>>2]|0)<(k[d+(f<<2)>>2]|0)){k[s>>2]=e;k[i>>2]=f;a=a+4|0}else a=a+3|0}else a=e}else a=e}}else{a=k[j>>2]|0;f=k[s>>2]|0;h=k[c>>2]|0;l=k[h+(a<<2)>>2]|0;g=h+(f<<2)|0;d=k[r>>2]|0;e=(k[h+(d<<2)>>2]|0)<(l|0);if((l|0)>=(k[g>>2]|0)){if(!e){a=0;d=h;break}k[j>>2]=d;k[r>>2]=a;a=k[j>>2]|0;d=k[s>>2]|0;if((k[h+(a<<2)>>2]|0)>=(k[h+(d<<2)>>2]|0)){a=1;d=h;break}k[s>>2]=a;k[j>>2]=d;a=2;d=h;break}if(e){k[s>>2]=d;k[r>>2]=f;a=1;d=h;break}k[s>>2]=a;k[j>>2]=f;a=k[r>>2]|0;if((k[h+(a<<2)>>2]|0)<(k[g>>2]|0)){k[j>>2]=a;k[r>>2]=f;a=2;d=h}else{a=1;d=h}}while(0);g=k[s>>2]|0;e=k[j>>2]|0;if((k[d+(g<<2)>>2]|0)<(k[d+(e<<2)>>2]|0)){d=r;break}h=k[c>>2]|0;e=h+(e<<2)|0;d=r;while(1){d=d+-4|0;if((s|0)==(d|0))break;f=k[d>>2]|0;if((k[h+(f<<2)>>2]|0)<(k[e>>2]|0)){q=68;break b}}a=s+4|0;f=k[r>>2]|0;e=k[h+(g<<2)>>2]|0;if((e|0)>=(k[h+(f<<2)>>2]|0)){if((a|0)==(r|0)){q=86;break a}while(1){d=k[a>>2]|0;if((e|0)<(k[h+(d<<2)>>2]|0))break;a=a+4|0;if((a|0)==(r|0)){q=86;break a}}k[a>>2]=f;k[r>>2]=d;a=a+4|0}if((a|0)==(r|0)){q=86;break a}i=k[c>>2]|0;d=r;while(1){h=k[i+(k[s>>2]<<2)>>2]|0;while(1){f=k[a>>2]|0;g=a+4|0;if((h|0)<(k[i+(f<<2)>>2]|0))break;else a=g}do{d=d+-4|0;e=k[d>>2]|0}while((h|0)<(k[i+(e<<2)>>2]|0));if(a>>>0>=d>>>0){s=a;continue b}k[a>>2]=e;k[d>>2]=f;a=g}}if((q|0)==68){q=0;k[s>>2]=f;k[d>>2]=g;a=a+1|0}e=s+4|0;c:do if(e>>>0<d>>>0){l=k[c>>2]|0;while(1){i=k[l+(k[j>>2]<<2)>>2]|0;while(1){g=k[e>>2]|0;h=e+4|0;if((k[l+(g<<2)>>2]|0)<(i|0))e=h;else break}do{d=d+-4|0;f=k[d>>2]|0}while((k[l+(f<<2)>>2]|0)>=(i|0));if(e>>>0>d>>>0){d=j;break c}k[e>>2]=f;k[d>>2]=g;j=(j|0)==(e|0)?d:j;e=h;a=a+1|0}}else d=j;while(0);if((e|0)!=(d|0)?(o=k[d>>2]|0,p=k[e>>2]|0,l=k[c>>2]|0,(k[l+(o<<2)>>2]|0)<(k[l+(p<<2)>>2]|0)):0){k[e>>2]=o;k[d>>2]=p;a=a+1|0}if(!a){d=c4(s,e,c)|0;a=e+4|0;if(c4(a,b,c)|0){q=85;break}if(d)continue}l=e;if((l-m|0)>=(n-l|0)){q=84;break}a4(s,e,c);a=e+4|0}if((q|0)==84){q=0;a4(e+4|0,b,c);a=s;b=e;continue}else if((q|0)==85){q=0;if(d){q=86;break}else{a=s;b=e;continue}}}if((q|0)==5){a=k[r>>2]|0;b=k[s>>2]|0;c=k[c>>2]|0;if((k[c+(a<<2)>>2]|0)>=(k[c+(b<<2)>>2]|0))return;k[s>>2]=a;k[r>>2]=b;return}else if((q|0)==7){h=s+4|0;d=k[h>>2]|0;f=k[s>>2]|0;g=k[c>>2]|0;c=k[g+(d<<2)>>2]|0;e=g+(f<<2)|0;a=k[r>>2]|0;b=(k[g+(a<<2)>>2]|0)<(c|0);if((c|0)>=(k[e>>2]|0)){if(!b)return;k[h>>2]=a;k[r>>2]=d;a=k[h>>2]|0;b=k[s>>2]|0;if((k[g+(a<<2)>>2]|0)>=(k[g+(b<<2)>>2]|0))return;k[s>>2]=a;k[h>>2]=b;return}if(b){k[s>>2]=a;k[r>>2]=f;return}k[s>>2]=d;k[h>>2]=f;a=k[r>>2]|0;if((k[g+(a<<2)>>2]|0)>=(k[e>>2]|0))return;k[h>>2]=a;k[r>>2]=f;return}else if((q|0)==15){b4(s,s+4|0,s+8|0,r,k[c>>2]|0)|0;return}else if((q|0)==16){h=s+4|0;f=s+8|0;e=s+12|0;b4(s,h,f,e,k[c>>2]|0)|0;a=k[r>>2]|0;b=k[e>>2]|0;g=k[c>>2]|0;if((k[g+(a<<2)>>2]|0)>=(k[g+(b<<2)>>2]|0))return;k[e>>2]=a;k[r>>2]=b;b=k[e>>2]|0;a=k[f>>2]|0;d=g+(b<<2)|0;if((k[d>>2]|0)>=(k[g+(a<<2)>>2]|0))return;k[f>>2]=b;k[e>>2]=a;a=k[h>>2]|0;if((k[d>>2]|0)>=(k[g+(a<<2)>>2]|0))return;k[h>>2]=b;k[f>>2]=a;a=k[s>>2]|0;if((k[d>>2]|0)>=(k[g+(a<<2)>>2]|0))return;k[s>>2]=b;k[h>>2]=a;return}else if((q|0)==22){a=s+8|0;d=s+4|0;e=k[d>>2]|0;f=k[s>>2]|0;i=k[c>>2]|0;r=k[i+(e<<2)>>2]|0;g=i+(f<<2)|0;h=k[a>>2]|0;i=i+(h<<2)|0;j=(k[i>>2]|0)<(r|0);do if((r|0)<(k[g>>2]|0)){if(j){k[s>>2]=h;k[a>>2]=f;e=f;break}k[s>>2]=e;k[d>>2]=f;if((k[i>>2]|0)<(k[g>>2]|0)){k[d>>2]=h;k[a>>2]=f;e=f}else e=h}else if(j){k[d>>2]=h;k[a>>2]=e;if((k[i>>2]|0)<(k[g>>2]|0)){k[s>>2]=h;k[d>>2]=f}}else e=h;while(0);d=s+12|0;if((d|0)==(b|0))return;j=k[c>>2]|0;while(1){i=k[d>>2]|0;h=j+(i<<2)|0;if((k[h>>2]|0)<(k[j+(e<<2)>>2]|0)){f=d;g=e;while(1){k[f>>2]=g;if((a|0)==(s|0)){a=s;break}e=a+-4|0;g=k[e>>2]|0;if((k[h>>2]|0)>=(k[j+(g<<2)>>2]|0))break;else{f=a;a=e}}k[a>>2]=i}a=d+4|0;if((a|0)==(b|0))break;e=k[d>>2]|0;c=d;d=a;a=c}return}else if((q|0)==86)return}function b4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0;j=k[b>>2]|0;i=k[a>>2]|0;l=k[e+(j<<2)>>2]|0;h=e+(i<<2)|0;g=k[c>>2]|0;f=(k[e+(g<<2)>>2]|0)<(l|0);do if((l|0)<(k[h>>2]|0)){if(f){k[a>>2]=g;k[c>>2]=i;h=1;g=i;break}k[a>>2]=j;k[b>>2]=i;g=k[c>>2]|0;if((k[e+(g<<2)>>2]|0)<(k[h>>2]|0)){k[b>>2]=g;k[c>>2]=i;h=2;g=i}else h=1}else if(f){k[b>>2]=g;k[c>>2]=j;f=k[b>>2]|0;g=k[a>>2]|0;if((k[e+(f<<2)>>2]|0)<(k[e+(g<<2)>>2]|0)){k[a>>2]=f;k[b>>2]=g;h=2;g=k[c>>2]|0}else{h=1;g=j}}else h=0;while(0);f=k[d>>2]|0;if((k[e+(f<<2)>>2]|0)>=(k[e+(g<<2)>>2]|0)){l=h;return l|0}k[c>>2]=f;k[d>>2]=g;f=k[c>>2]|0;g=k[b>>2]|0;if((k[e+(f<<2)>>2]|0)>=(k[e+(g<<2)>>2]|0)){l=h+1|0;return l|0}k[b>>2]=f;k[c>>2]=g;f=k[b>>2]|0;g=k[a>>2]|0;if((k[e+(f<<2)>>2]|0)>=(k[e+(g<<2)>>2]|0)){l=h+2|0;return l|0}k[a>>2]=f;k[b>>2]=g;l=h+3|0;return l|0}function c4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=k[d>>2]|0;f=k[a>>2]|0;b=k[c>>2]|0;if((k[b+(e<<2)>>2]|0)>=(k[b+(f<<2)>>2]|0)){a=1;return a|0}k[a>>2]=e;k[d>>2]=f;a=1;return a|0}case 3:{l=a+4|0;h=b+-4|0;f=k[l>>2]|0;i=k[a>>2]|0;j=k[c>>2]|0;b=k[j+(f<<2)>>2]|0;g=j+(i<<2)|0;d=k[h>>2]|0;e=(k[j+(d<<2)>>2]|0)<(b|0);if((b|0)>=(k[g>>2]|0)){if(!e){a=1;return a|0}k[l>>2]=d;k[h>>2]=f;d=k[l>>2]|0;e=k[a>>2]|0;if((k[j+(d<<2)>>2]|0)>=(k[j+(e<<2)>>2]|0)){a=1;return a|0}k[a>>2]=d;k[l>>2]=e;a=1;return a|0}if(e){k[a>>2]=d;k[h>>2]=i;a=1;return a|0}k[a>>2]=f;k[l>>2]=i;d=k[h>>2]|0;if((k[j+(d<<2)>>2]|0)>=(k[g>>2]|0)){a=1;return a|0}k[l>>2]=d;k[h>>2]=i;a=1;return a|0}case 4:{b4(a,a+4|0,a+8|0,b+-4|0,k[c>>2]|0)|0;a=1;return a|0}case 5:{j=a+4|0;i=a+8|0;g=a+12|0;d=b+-4|0;b4(a,j,i,g,k[c>>2]|0)|0;e=k[d>>2]|0;f=k[g>>2]|0;h=k[c>>2]|0;if((k[h+(e<<2)>>2]|0)>=(k[h+(f<<2)>>2]|0)){a=1;return a|0}k[g>>2]=e;k[d>>2]=f;e=k[g>>2]|0;d=k[i>>2]|0;f=h+(e<<2)|0;if((k[f>>2]|0)>=(k[h+(d<<2)>>2]|0)){a=1;return a|0}k[i>>2]=e;k[g>>2]=d;d=k[j>>2]|0;if((k[f>>2]|0)>=(k[h+(d<<2)>>2]|0)){a=1;return a|0}k[j>>2]=e;k[i>>2]=d;d=k[a>>2]|0;if((k[f>>2]|0)>=(k[h+(d<<2)>>2]|0)){a=1;return a|0}k[a>>2]=e;k[j>>2]=d;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{d=a+8|0;e=a+4|0;f=k[e>>2]|0;g=k[a>>2]|0;j=k[c>>2]|0;m=k[j+(f<<2)>>2]|0;h=j+(g<<2)|0;i=k[d>>2]|0;j=j+(i<<2)|0;l=(k[j>>2]|0)<(m|0);do if((m|0)<(k[h>>2]|0)){if(l){k[a>>2]=i;k[d>>2]=g;f=g;break}k[a>>2]=f;k[e>>2]=g;if((k[j>>2]|0)<(k[h>>2]|0)){k[e>>2]=i;k[d>>2]=g;f=g}else f=i}else if(l){k[e>>2]=i;k[d>>2]=f;if((k[j>>2]|0)<(k[h>>2]|0)){k[a>>2]=i;k[e>>2]=g}}else f=i;while(0);e=a+12|0;a:do if((e|0)==(b|0)){e=1;d=0}else{c=k[c>>2]|0;l=e;e=0;while(1){j=k[l>>2]|0;i=c+(j<<2)|0;if((k[i>>2]|0)<(k[c+(f<<2)>>2]|0)){g=l;h=f;while(1){k[g>>2]=h;if((d|0)==(a|0)){d=a;break}f=d+-4|0;h=k[f>>2]|0;if((k[i>>2]|0)>=(k[c+(h<<2)>>2]|0))break;else{g=d;d=f}}k[d>>2]=j;e=e+1|0;d=l+4|0;if((e|0)==8){e=0;d=(d|0)==(b|0);break a}}else d=l+4|0;if((d|0)==(b|0)){e=1;d=0;break a}f=k[l>>2]|0;m=l;l=d;d=m}}while(0);m=d|e;return m|0}}return 0}function d4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a:while(1){o=b;s=b+-4|0;while(1){t=a;b:while(1){n=t;a=o-n|0;d=a>>2;switch(d|0){case 2:{r=5;break a}case 3:{r=7;break a}case 4:{r=15;break a}case 5:{r=16;break a}case 1:case 0:{r=86;break a}default:{}}if((a|0)<124){r=22;break a}l=t+(((d|0)/2|0)<<2)|0;do if((a|0)>3996){h=(d|0)/4|0;i=t+(h<<2)|0;h=l+(h<<2)|0;a=e4(t,i,l,h,k[c>>2]|0)|0;e=k[s>>2]|0;f=k[h>>2]|0;d=k[c>>2]|0;if((j[d+(e<<1)>>1]|0)<(j[d+(f<<1)>>1]|0)){k[h>>2]=e;k[s>>2]=f;e=a+1|0;f=k[h>>2]|0;g=k[l>>2]|0;if((j[d+(f<<1)>>1]|0)<(j[d+(g<<1)>>1]|0)){k[l>>2]=f;k[h>>2]=g;e=a+2|0;f=k[l>>2]|0;g=k[i>>2]|0;if((j[d+(f<<1)>>1]|0)<(j[d+(g<<1)>>1]|0)){k[i>>2]=f;k[l>>2]=g;e=k[i>>2]|0;f=k[t>>2]|0;if((j[d+(e<<1)>>1]|0)<(j[d+(f<<1)>>1]|0)){k[t>>2]=e;k[i>>2]=f;a=a+4|0}else a=a+3|0}else a=e}else a=e}}else{a=k[l>>2]|0;f=k[t>>2]|0;h=k[c>>2]|0;m=j[h+(a<<1)>>1]|0;g=j[h+(f<<1)>>1]|0;d=k[s>>2]|0;e=(j[h+(d<<1)>>1]|0)<m<<16>>16;if(m<<16>>16>=g<<16>>16){if(!e){a=0;d=h;break}k[l>>2]=d;k[s>>2]=a;a=k[l>>2]|0;d=k[t>>2]|0;if((j[h+(a<<1)>>1]|0)>=(j[h+(d<<1)>>1]|0)){a=1;d=h;break}k[t>>2]=a;k[l>>2]=d;a=2;d=h;break}if(e){k[t>>2]=d;k[s>>2]=f;a=1;d=h;break}k[t>>2]=a;k[l>>2]=f;a=k[s>>2]|0;if((j[h+(a<<1)>>1]|0)<g<<16>>16){k[l>>2]=a;k[s>>2]=f;a=2;d=h}else{a=1;d=h}}while(0);g=k[t>>2]|0;e=k[l>>2]|0;if((j[d+(g<<1)>>1]|0)<(j[d+(e<<1)>>1]|0)){d=s;break}h=k[c>>2]|0;e=h+(e<<1)|0;d=s;while(1){d=d+-4|0;if((t|0)==(d|0))break;f=k[d>>2]|0;if((j[h+(f<<1)>>1]|0)<(j[e>>1]|0)){r=68;break b}}a=t+4|0;f=k[s>>2]|0;e=j[h+(g<<1)>>1]|0;if(e<<16>>16>=(j[h+(f<<1)>>1]|0)){if((a|0)==(s|0)){r=86;break a}while(1){d=k[a>>2]|0;if(e<<16>>16<(j[h+(d<<1)>>1]|0))break;a=a+4|0;if((a|0)==(s|0)){r=86;break a}}k[a>>2]=f;k[s>>2]=d;a=a+4|0}if((a|0)==(s|0)){r=86;break a}i=k[c>>2]|0;d=s;while(1){h=j[i+(k[t>>2]<<1)>>1]|0;while(1){f=k[a>>2]|0;g=a+4|0;if(h<<16>>16<(j[i+(f<<1)>>1]|0))break;else a=g}do{d=d+-4|0;e=k[d>>2]|0}while(h<<16>>16<(j[i+(e<<1)>>1]|0));if(a>>>0>=d>>>0){t=a;continue b}k[a>>2]=e;k[d>>2]=f;a=g}}if((r|0)==68){r=0;k[t>>2]=f;k[d>>2]=g;a=a+1|0}e=t+4|0;c:do if(e>>>0<d>>>0){m=k[c>>2]|0;while(1){i=j[m+(k[l>>2]<<1)>>1]|0;while(1){g=k[e>>2]|0;h=e+4|0;if((j[m+(g<<1)>>1]|0)<i<<16>>16)e=h;else break}do{d=d+-4|0;f=k[d>>2]|0}while((j[m+(f<<1)>>1]|0)>=i<<16>>16);if(e>>>0>d>>>0){d=l;break c}k[e>>2]=f;k[d>>2]=g;l=(l|0)==(e|0)?d:l;e=h;a=a+1|0}}else d=l;while(0);if((e|0)!=(d|0)?(p=k[d>>2]|0,q=k[e>>2]|0,m=k[c>>2]|0,(j[m+(p<<1)>>1]|0)<(j[m+(q<<1)>>1]|0)):0){k[e>>2]=p;k[d>>2]=q;a=a+1|0}if(!a){d=f4(t,e,c)|0;a=e+4|0;if(f4(a,b,c)|0){r=85;break}if(d)continue}m=e;if((m-n|0)>=(o-m|0)){r=84;break}d4(t,e,c);a=e+4|0}if((r|0)==84){r=0;d4(e+4|0,b,c);a=t;b=e;continue}else if((r|0)==85){r=0;if(d){r=86;break}else{a=t;b=e;continue}}}if((r|0)==5){a=k[s>>2]|0;b=k[t>>2]|0;c=k[c>>2]|0;if((j[c+(a<<1)>>1]|0)>=(j[c+(b<<1)>>1]|0))return;k[t>>2]=a;k[s>>2]=b;return}else if((r|0)==7){h=t+4|0;d=k[h>>2]|0;f=k[t>>2]|0;g=k[c>>2]|0;c=j[g+(d<<1)>>1]|0;e=j[g+(f<<1)>>1]|0;a=k[s>>2]|0;b=(j[g+(a<<1)>>1]|0)<c<<16>>16;if(c<<16>>16>=e<<16>>16){if(!b)return;k[h>>2]=a;k[s>>2]=d;a=k[h>>2]|0;b=k[t>>2]|0;if((j[g+(a<<1)>>1]|0)>=(j[g+(b<<1)>>1]|0))return;k[t>>2]=a;k[h>>2]=b;return}if(b){k[t>>2]=a;k[s>>2]=f;return}k[t>>2]=d;k[h>>2]=f;a=k[s>>2]|0;if((j[g+(a<<1)>>1]|0)>=e<<16>>16)return;k[h>>2]=a;k[s>>2]=f;return}else if((r|0)==15){e4(t,t+4|0,t+8|0,s,k[c>>2]|0)|0;return}else if((r|0)==16){h=t+4|0;f=t+8|0;e=t+12|0;e4(t,h,f,e,k[c>>2]|0)|0;a=k[s>>2]|0;b=k[e>>2]|0;g=k[c>>2]|0;if((j[g+(a<<1)>>1]|0)>=(j[g+(b<<1)>>1]|0))return;k[e>>2]=a;k[s>>2]=b;b=k[e>>2]|0;a=k[f>>2]|0;d=j[g+(b<<1)>>1]|0;if(d<<16>>16>=(j[g+(a<<1)>>1]|0))return;k[f>>2]=b;k[e>>2]=a;a=k[h>>2]|0;if(d<<16>>16>=(j[g+(a<<1)>>1]|0))return;k[h>>2]=b;k[f>>2]=a;a=k[t>>2]|0;if(d<<16>>16>=(j[g+(a<<1)>>1]|0))return;k[t>>2]=b;k[h>>2]=a;return}else if((r|0)==22){a=t+8|0;d=t+4|0;e=k[d>>2]|0;f=k[t>>2]|0;i=k[c>>2]|0;s=j[i+(e<<1)>>1]|0;g=j[i+(f<<1)>>1]|0;h=k[a>>2]|0;i=j[i+(h<<1)>>1]|0;l=i<<16>>16<s<<16>>16;do if(s<<16>>16<g<<16>>16){if(l){k[t>>2]=h;k[a>>2]=f;e=f;break}k[t>>2]=e;k[d>>2]=f;if(i<<16>>16<g<<16>>16){k[d>>2]=h;k[a>>2]=f;e=f}else e=h}else if(l){k[d>>2]=h;k[a>>2]=e;if(i<<16>>16<g<<16>>16){k[t>>2]=h;k[d>>2]=f}}else e=h;while(0);d=t+12|0;if((d|0)==(b|0))return;i=k[c>>2]|0;while(1){h=k[d>>2]|0;g=j[i+(h<<1)>>1]|0;if(g<<16>>16<(j[i+(e<<1)>>1]|0)){f=d;while(1){k[f>>2]=e;if((a|0)==(t|0)){a=t;break}f=a+-4|0;e=k[f>>2]|0;if(g<<16>>16>=(j[i+(e<<1)>>1]|0))break;else{c=a;a=f;f=c}}k[a>>2]=h}a=d+4|0;if((a|0)==(b|0))break;e=k[d>>2]|0;c=d;d=a;a=c}return}else if((r|0)==86)return}function e4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,m=0;l=k[b>>2]|0;i=k[a>>2]|0;m=j[e+(l<<1)>>1]|0;h=j[e+(i<<1)>>1]|0;g=k[c>>2]|0;f=(j[e+(g<<1)>>1]|0)<m<<16>>16;do if(m<<16>>16<h<<16>>16){if(f){k[a>>2]=g;k[c>>2]=i;h=1;g=i;break}k[a>>2]=l;k[b>>2]=i;g=k[c>>2]|0;if((j[e+(g<<1)>>1]|0)<h<<16>>16){k[b>>2]=g;k[c>>2]=i;h=2;g=i}else h=1}else if(f){k[b>>2]=g;k[c>>2]=l;f=k[b>>2]|0;g=k[a>>2]|0;if((j[e+(f<<1)>>1]|0)<(j[e+(g<<1)>>1]|0)){k[a>>2]=f;k[b>>2]=g;h=2;g=k[c>>2]|0}else{h=1;g=l}}else h=0;while(0);f=k[d>>2]|0;if((j[e+(f<<1)>>1]|0)>=(j[e+(g<<1)>>1]|0)){m=h;return m|0}k[c>>2]=f;k[d>>2]=g;f=k[c>>2]|0;g=k[b>>2]|0;if((j[e+(f<<1)>>1]|0)>=(j[e+(g<<1)>>1]|0)){m=h+1|0;return m|0}k[b>>2]=f;k[c>>2]=g;f=k[b>>2]|0;g=k[a>>2]|0;if((j[e+(f<<1)>>1]|0)>=(j[e+(g<<1)>>1]|0)){m=h+2|0;return m|0}k[a>>2]=f;k[b>>2]=g;m=h+3|0;return m|0}function f4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=k[d>>2]|0;f=k[a>>2]|0;b=k[c>>2]|0;if((j[b+(e<<1)>>1]|0)>=(j[b+(f<<1)>>1]|0)){a=1;return a|0}k[a>>2]=e;k[d>>2]=f;a=1;return a|0}case 3:{m=a+4|0;h=b+-4|0;f=k[m>>2]|0;i=k[a>>2]|0;l=k[c>>2]|0;b=j[l+(f<<1)>>1]|0;g=j[l+(i<<1)>>1]|0;d=k[h>>2]|0;e=(j[l+(d<<1)>>1]|0)<b<<16>>16;if(b<<16>>16>=g<<16>>16){if(!e){a=1;return a|0}k[m>>2]=d;k[h>>2]=f;d=k[m>>2]|0;e=k[a>>2]|0;if((j[l+(d<<1)>>1]|0)>=(j[l+(e<<1)>>1]|0)){a=1;return a|0}k[a>>2]=d;k[m>>2]=e;a=1;return a|0}if(e){k[a>>2]=d;k[h>>2]=i;a=1;return a|0}k[a>>2]=f;k[m>>2]=i;d=k[h>>2]|0;if((j[l+(d<<1)>>1]|0)>=g<<16>>16){a=1;return a|0}k[m>>2]=d;k[h>>2]=i;a=1;return a|0}case 4:{e4(a,a+4|0,a+8|0,b+-4|0,k[c>>2]|0)|0;a=1;return a|0}case 5:{l=a+4|0;i=a+8|0;g=a+12|0;d=b+-4|0;e4(a,l,i,g,k[c>>2]|0)|0;e=k[d>>2]|0;f=k[g>>2]|0;h=k[c>>2]|0;if((j[h+(e<<1)>>1]|0)>=(j[h+(f<<1)>>1]|0)){a=1;return a|0}k[g>>2]=e;k[d>>2]=f;e=k[g>>2]|0;d=k[i>>2]|0;f=j[h+(e<<1)>>1]|0;if(f<<16>>16>=(j[h+(d<<1)>>1]|0)){a=1;return a|0}k[i>>2]=e;k[g>>2]=d;d=k[l>>2]|0;if(f<<16>>16>=(j[h+(d<<1)>>1]|0)){a=1;return a|0}k[l>>2]=e;k[i>>2]=d;d=k[a>>2]|0;if(f<<16>>16>=(j[h+(d<<1)>>1]|0)){a=1;return a|0}k[a>>2]=e;k[l>>2]=d;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{d=a+8|0;e=a+4|0;f=k[e>>2]|0;g=k[a>>2]|0;l=k[c>>2]|0;n=j[l+(f<<1)>>1]|0;h=j[l+(g<<1)>>1]|0;i=k[d>>2]|0;l=j[l+(i<<1)>>1]|0;m=l<<16>>16<n<<16>>16;do if(n<<16>>16<h<<16>>16){if(m){k[a>>2]=i;k[d>>2]=g;f=g;break}k[a>>2]=f;k[e>>2]=g;if(l<<16>>16<h<<16>>16){k[e>>2]=i;k[d>>2]=g;f=g}else f=i}else if(m){k[e>>2]=i;k[d>>2]=f;if(l<<16>>16<h<<16>>16){k[a>>2]=i;k[e>>2]=g}}else f=i;while(0);e=a+12|0;a:do if((e|0)==(b|0)){e=1;d=0}else{m=k[c>>2]|0;l=e;e=0;while(1){i=k[l>>2]|0;h=j[m+(i<<1)>>1]|0;if(h<<16>>16<(j[m+(f<<1)>>1]|0)){g=l;while(1){k[g>>2]=f;if((d|0)==(a|0)){d=a;break}g=d+-4|0;f=k[g>>2]|0;if(h<<16>>16>=(j[m+(f<<1)>>1]|0))break;else{n=d;d=g;g=n}}k[d>>2]=i;e=e+1|0;d=l+4|0;if((e|0)==8){e=0;d=(d|0)==(b|0);break a}}else d=l+4|0;if((d|0)==(b|0)){e=1;d=0;break a}f=k[l>>2]|0;n=l;l=d;d=n}}while(0);n=d|e;return n|0}}return 0}function g4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;a:while(1){p=b;t=b+-4|0;while(1){u=a;b:while(1){o=u;a=p-o|0;d=a>>2;switch(d|0){case 2:{s=5;break a}case 3:{s=7;break a}case 4:{s=15;break a}case 5:{s=16;break a}case 1:case 0:{s=86;break a}default:{}}if((a|0)<124){s=22;break a}l=u+(((d|0)/2|0)<<2)|0;do if((a|0)>3996){h=(d|0)/4|0;i=u+(h<<2)|0;h=l+(h<<2)|0;a=h4(u,i,l,h,k[c>>2]|0)|0;e=k[t>>2]|0;f=k[h>>2]|0;d=k[c>>2]|0;if((m[d+(e<<1)>>1]|0)<(m[d+(f<<1)>>1]|0)){k[h>>2]=e;k[t>>2]=f;e=a+1|0;f=k[h>>2]|0;g=k[l>>2]|0;if((m[d+(f<<1)>>1]|0)<(m[d+(g<<1)>>1]|0)){k[l>>2]=f;k[h>>2]=g;e=a+2|0;f=k[l>>2]|0;g=k[i>>2]|0;if((m[d+(f<<1)>>1]|0)<(m[d+(g<<1)>>1]|0)){k[i>>2]=f;k[l>>2]=g;e=k[i>>2]|0;f=k[u>>2]|0;if((m[d+(e<<1)>>1]|0)<(m[d+(f<<1)>>1]|0)){k[u>>2]=e;k[i>>2]=f;a=a+4|0}else a=a+3|0}else a=e}else a=e}}else{a=k[l>>2]|0;f=k[u>>2]|0;h=k[c>>2]|0;n=j[h+(a<<1)>>1]|0;g=j[h+(f<<1)>>1]|0;d=k[t>>2]|0;e=(m[h+(d<<1)>>1]|0)<(n&65535);if((n&65535)>=(g&65535)){if(!e){a=0;d=h;break}k[l>>2]=d;k[t>>2]=a;a=k[l>>2]|0;d=k[u>>2]|0;if((m[h+(a<<1)>>1]|0)>=(m[h+(d<<1)>>1]|0)){a=1;d=h;break}k[u>>2]=a;k[l>>2]=d;a=2;d=h;break}if(e){k[u>>2]=d;k[t>>2]=f;a=1;d=h;break}k[u>>2]=a;k[l>>2]=f;a=k[t>>2]|0;if((m[h+(a<<1)>>1]|0)<(g&65535)){k[l>>2]=a;k[t>>2]=f;a=2;d=h}else{a=1;d=h}}while(0);g=k[u>>2]|0;e=k[l>>2]|0;if((m[d+(g<<1)>>1]|0)<(m[d+(e<<1)>>1]|0)){d=t;break}h=k[c>>2]|0;e=h+(e<<1)|0;d=t;while(1){d=d+-4|0;if((u|0)==(d|0))break;f=k[d>>2]|0;if((m[h+(f<<1)>>1]|0)<(m[e>>1]|0)){s=68;break b}}a=u+4|0;f=k[t>>2]|0;e=j[h+(g<<1)>>1]|0;if((e&65535)>=(m[h+(f<<1)>>1]|0)){if((a|0)==(t|0)){s=86;break a}while(1){d=k[a>>2]|0;if((e&65535)<(m[h+(d<<1)>>1]|0))break;a=a+4|0;if((a|0)==(t|0)){s=86;break a}}k[a>>2]=f;k[t>>2]=d;a=a+4|0}if((a|0)==(t|0)){s=86;break a}i=k[c>>2]|0;d=t;while(1){h=j[i+(k[u>>2]<<1)>>1]|0;while(1){f=k[a>>2]|0;g=a+4|0;if((h&65535)<(m[i+(f<<1)>>1]|0))break;else a=g}do{d=d+-4|0;e=k[d>>2]|0}while((h&65535)<(m[i+(e<<1)>>1]|0));if(a>>>0>=d>>>0){u=a;continue b}k[a>>2]=e;k[d>>2]=f;a=g}}if((s|0)==68){s=0;k[u>>2]=f;k[d>>2]=g;a=a+1|0}e=u+4|0;c:do if(e>>>0<d>>>0){n=k[c>>2]|0;while(1){i=j[n+(k[l>>2]<<1)>>1]|0;while(1){g=k[e>>2]|0;h=e+4|0;if((m[n+(g<<1)>>1]|0)<(i&65535))e=h;else break}do{d=d+-4|0;f=k[d>>2]|0}while((m[n+(f<<1)>>1]|0)>=(i&65535));if(e>>>0>d>>>0){d=l;break c}k[e>>2]=f;k[d>>2]=g;l=(l|0)==(e|0)?d:l;e=h;a=a+1|0}}else d=l;while(0);if((e|0)!=(d|0)?(q=k[d>>2]|0,r=k[e>>2]|0,n=k[c>>2]|0,(m[n+(q<<1)>>1]|0)<(m[n+(r<<1)>>1]|0)):0){k[e>>2]=q;k[d>>2]=r;a=a+1|0}if(!a){d=i4(u,e,c)|0;a=e+4|0;if(i4(a,b,c)|0){s=85;break}if(d)continue}n=e;if((n-o|0)>=(p-n|0)){s=84;break}g4(u,e,c);a=e+4|0}if((s|0)==84){s=0;g4(e+4|0,b,c);a=u;b=e;continue}else if((s|0)==85){s=0;if(d){s=86;break}else{a=u;b=e;continue}}}if((s|0)==5){a=k[t>>2]|0;b=k[u>>2]|0;c=k[c>>2]|0;if((m[c+(a<<1)>>1]|0)>=(m[c+(b<<1)>>1]|0))return;k[u>>2]=a;k[t>>2]=b;return}else if((s|0)==7){h=u+4|0;d=k[h>>2]|0;f=k[u>>2]|0;g=k[c>>2]|0;c=j[g+(d<<1)>>1]|0;e=j[g+(f<<1)>>1]|0;a=k[t>>2]|0;b=(m[g+(a<<1)>>1]|0)<(c&65535);if((c&65535)>=(e&65535)){if(!b)return;k[h>>2]=a;k[t>>2]=d;a=k[h>>2]|0;b=k[u>>2]|0;if((m[g+(a<<1)>>1]|0)>=(m[g+(b<<1)>>1]|0))return;k[u>>2]=a;k[h>>2]=b;return}if(b){k[u>>2]=a;k[t>>2]=f;return}k[u>>2]=d;k[h>>2]=f;a=k[t>>2]|0;if((m[g+(a<<1)>>1]|0)>=(e&65535))return;k[h>>2]=a;k[t>>2]=f;return}else if((s|0)==15){h4(u,u+4|0,u+8|0,t,k[c>>2]|0)|0;return}else if((s|0)==16){h=u+4|0;f=u+8|0;e=u+12|0;h4(u,h,f,e,k[c>>2]|0)|0;a=k[t>>2]|0;b=k[e>>2]|0;g=k[c>>2]|0;if((m[g+(a<<1)>>1]|0)>=(m[g+(b<<1)>>1]|0))return;k[e>>2]=a;k[t>>2]=b;b=k[e>>2]|0;a=k[f>>2]|0;d=j[g+(b<<1)>>1]|0;if((d&65535)>=(m[g+(a<<1)>>1]|0))return;k[f>>2]=b;k[e>>2]=a;a=k[h>>2]|0;if((d&65535)>=(m[g+(a<<1)>>1]|0))return;k[h>>2]=b;k[f>>2]=a;a=k[u>>2]|0;if((d&65535)>=(m[g+(a<<1)>>1]|0))return;k[u>>2]=b;k[h>>2]=a;return}else if((s|0)==22){a=u+8|0;d=u+4|0;e=k[d>>2]|0;f=k[u>>2]|0;i=k[c>>2]|0;t=j[i+(e<<1)>>1]|0;g=j[i+(f<<1)>>1]|0;h=k[a>>2]|0;i=j[i+(h<<1)>>1]|0;l=(i&65535)<(t&65535);do if((t&65535)<(g&65535)){if(l){k[u>>2]=h;k[a>>2]=f;e=f;break}k[u>>2]=e;k[d>>2]=f;if((i&65535)<(g&65535)){k[d>>2]=h;k[a>>2]=f;e=f}else e=h}else if(l){k[d>>2]=h;k[a>>2]=e;if((i&65535)<(g&65535)){k[u>>2]=h;k[d>>2]=f}}else e=h;while(0);d=u+12|0;if((d|0)==(b|0))return;i=k[c>>2]|0;while(1){h=k[d>>2]|0;g=j[i+(h<<1)>>1]|0;if((g&65535)<(m[i+(e<<1)>>1]|0)){f=d;while(1){k[f>>2]=e;if((a|0)==(u|0)){a=u;break}f=a+-4|0;e=k[f>>2]|0;if((g&65535)>=(m[i+(e<<1)>>1]|0))break;else{c=a;a=f;f=c}}k[a>>2]=h}a=d+4|0;if((a|0)==(b|0))break;e=k[d>>2]|0;c=d;d=a;a=c}return}else if((s|0)==86)return}function h4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,n=0;l=k[b>>2]|0;i=k[a>>2]|0;n=j[e+(l<<1)>>1]|0;h=j[e+(i<<1)>>1]|0;g=k[c>>2]|0;f=(m[e+(g<<1)>>1]|0)<(n&65535);do if((n&65535)<(h&65535)){if(f){k[a>>2]=g;k[c>>2]=i;h=1;g=i;break}k[a>>2]=l;k[b>>2]=i;g=k[c>>2]|0;if((m[e+(g<<1)>>1]|0)<(h&65535)){k[b>>2]=g;k[c>>2]=i;h=2;g=i}else h=1}else if(f){k[b>>2]=g;k[c>>2]=l;f=k[b>>2]|0;g=k[a>>2]|0;if((m[e+(f<<1)>>1]|0)<(m[e+(g<<1)>>1]|0)){k[a>>2]=f;k[b>>2]=g;h=2;g=k[c>>2]|0}else{h=1;g=l}}else h=0;while(0);f=k[d>>2]|0;if((m[e+(f<<1)>>1]|0)>=(m[e+(g<<1)>>1]|0)){n=h;return n|0}k[c>>2]=f;k[d>>2]=g;f=k[c>>2]|0;g=k[b>>2]|0;if((m[e+(f<<1)>>1]|0)>=(m[e+(g<<1)>>1]|0)){n=h+1|0;return n|0}k[b>>2]=f;k[c>>2]=g;f=k[b>>2]|0;g=k[a>>2]|0;if((m[e+(f<<1)>>1]|0)>=(m[e+(g<<1)>>1]|0)){n=h+2|0;return n|0}k[a>>2]=f;k[b>>2]=g;n=h+3|0;return n|0}function i4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=k[d>>2]|0;f=k[a>>2]|0;b=k[c>>2]|0;if((m[b+(e<<1)>>1]|0)>=(m[b+(f<<1)>>1]|0)){a=1;return a|0}k[a>>2]=e;k[d>>2]=f;a=1;return a|0}case 3:{n=a+4|0;h=b+-4|0;f=k[n>>2]|0;i=k[a>>2]|0;l=k[c>>2]|0;b=j[l+(f<<1)>>1]|0;g=j[l+(i<<1)>>1]|0;d=k[h>>2]|0;e=(m[l+(d<<1)>>1]|0)<(b&65535);if((b&65535)>=(g&65535)){if(!e){a=1;return a|0}k[n>>2]=d;k[h>>2]=f;d=k[n>>2]|0;e=k[a>>2]|0;if((m[l+(d<<1)>>1]|0)>=(m[l+(e<<1)>>1]|0)){a=1;return a|0}k[a>>2]=d;k[n>>2]=e;a=1;return a|0}if(e){k[a>>2]=d;k[h>>2]=i;a=1;return a|0}k[a>>2]=f;k[n>>2]=i;d=k[h>>2]|0;if((m[l+(d<<1)>>1]|0)>=(g&65535)){a=1;return a|0}k[n>>2]=d;k[h>>2]=i;a=1;return a|0}case 4:{h4(a,a+4|0,a+8|0,b+-4|0,k[c>>2]|0)|0;a=1;return a|0}case 5:{l=a+4|0;i=a+8|0;g=a+12|0;d=b+-4|0;h4(a,l,i,g,k[c>>2]|0)|0;e=k[d>>2]|0;f=k[g>>2]|0;h=k[c>>2]|0;if((m[h+(e<<1)>>1]|0)>=(m[h+(f<<1)>>1]|0)){a=1;return a|0}k[g>>2]=e;k[d>>2]=f;e=k[g>>2]|0;d=k[i>>2]|0;f=j[h+(e<<1)>>1]|0;if((f&65535)>=(m[h+(d<<1)>>1]|0)){a=1;return a|0}k[i>>2]=e;k[g>>2]=d;d=k[l>>2]|0;if((f&65535)>=(m[h+(d<<1)>>1]|0)){a=1;return a|0}k[l>>2]=e;k[i>>2]=d;d=k[a>>2]|0;if((f&65535)>=(m[h+(d<<1)>>1]|0)){a=1;return a|0}k[a>>2]=e;k[l>>2]=d;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{d=a+8|0;e=a+4|0;f=k[e>>2]|0;g=k[a>>2]|0;l=k[c>>2]|0;o=j[l+(f<<1)>>1]|0;h=j[l+(g<<1)>>1]|0;i=k[d>>2]|0;l=j[l+(i<<1)>>1]|0;n=(l&65535)<(o&65535);do if((o&65535)<(h&65535)){if(n){k[a>>2]=i;k[d>>2]=g;f=g;break}k[a>>2]=f;k[e>>2]=g;if((l&65535)<(h&65535)){k[e>>2]=i;k[d>>2]=g;f=g}else f=i}else if(n){k[e>>2]=i;k[d>>2]=f;if((l&65535)<(h&65535)){k[a>>2]=i;k[e>>2]=g}}else f=i;while(0);e=a+12|0;a:do if((e|0)==(b|0)){e=1;d=0}else{n=k[c>>2]|0;l=e;e=0;while(1){i=k[l>>2]|0;h=j[n+(i<<1)>>1]|0;if((h&65535)<(m[n+(f<<1)>>1]|0)){g=l;while(1){k[g>>2]=f;if((d|0)==(a|0)){d=a;break}g=d+-4|0;f=k[g>>2]|0;if((h&65535)>=(m[n+(f<<1)>>1]|0))break;else{o=d;d=g;g=o}}k[d>>2]=i;e=e+1|0;d=l+4|0;if((e|0)==8){e=0;d=(d|0)==(b|0);break a}}else d=l+4|0;if((d|0)==(b|0)){e=1;d=0;break a}f=k[l>>2]|0;o=l;l=d;d=o}}while(0);o=d|e;return o|0}}return 0}function j4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=b;a:while(1){n=s;r=s+-4|0;while(1){t=a;b:while(1){m=t;a=n-m|0;b=a>>2;switch(b|0){case 2:{q=5;break a}case 3:{q=7;break a}case 4:{q=15;break a}case 5:{q=16;break a}case 1:case 0:{q=83;break a}default:{}}if((a|0)<124){q=22;break a}l=t+(((b|0)/2|0)<<2)|0;do if((a|0)>3996){g=(b|0)/4|0;h=t+(g<<2)|0;g=l+(g<<2)|0;a=k4(t,h,l,g,k[c>>2]|0)|0;d=k[r>>2]|0;e=k[g>>2]|0;b=k[c>>2]|0;if((i[b+d>>0]|0)<(i[b+e>>0]|0)){k[g>>2]=d;k[r>>2]=e;d=a+1|0;e=k[g>>2]|0;f=k[l>>2]|0;if((i[b+e>>0]|0)<(i[b+f>>0]|0)){k[l>>2]=e;k[g>>2]=f;d=a+2|0;e=k[l>>2]|0;f=k[h>>2]|0;if((i[b+e>>0]|0)<(i[b+f>>0]|0)){k[h>>2]=e;k[l>>2]=f;d=k[h>>2]|0;e=k[t>>2]|0;if((i[b+d>>0]|0)<(i[b+e>>0]|0)){k[t>>2]=d;k[h>>2]=e;a=a+4|0}else a=a+3|0}else a=d}else a=d}}else{a=k[l>>2]|0;e=k[t>>2]|0;g=k[c>>2]|0;j=i[g+a>>0]|0;f=g+e|0;b=k[r>>2]|0;d=(i[g+b>>0]|0)<j<<24>>24;if(j<<24>>24>=(i[f>>0]|0)){if(!d){a=0;b=g;break}k[l>>2]=b;k[r>>2]=a;a=k[l>>2]|0;b=k[t>>2]|0;if((i[g+a>>0]|0)>=(i[g+b>>0]|0)){a=1;b=g;break}k[t>>2]=a;k[l>>2]=b;a=2;b=g;break}if(d){k[t>>2]=b;k[r>>2]=e;a=1;b=g;break}k[t>>2]=a;k[l>>2]=e;a=k[r>>2]|0;if((i[g+a>>0]|0)<(i[f>>0]|0)){k[l>>2]=a;k[r>>2]=e;a=2;b=g}else{a=1;b=g}}while(0);f=k[t>>2]|0;d=k[l>>2]|0;if((i[b+f>>0]|0)<(i[b+d>>0]|0)){b=r;break}g=k[c>>2]|0;d=g+d|0;b=r;while(1){b=b+-4|0;if((t|0)==(b|0))break;e=k[b>>2]|0;if((i[g+e>>0]|0)<(i[d>>0]|0)){q=66;break b}}a=t+4|0;e=k[r>>2]|0;d=i[g+f>>0]|0;if(d<<24>>24>=(i[g+e>>0]|0)){if((a|0)==(r|0)){q=83;break a}while(1){b=k[a>>2]|0;if(d<<24>>24<(i[g+b>>0]|0))break;a=a+4|0;if((a|0)==(r|0)){q=83;break a}}k[a>>2]=e;k[r>>2]=b;a=a+4|0}if((a|0)==(r|0)){q=83;break a}else b=r;while(1){g=k[c>>2]|0;h=i[g+(k[t>>2]|0)>>0]|0;while(1){e=k[a>>2]|0;f=a+4|0;if(h<<24>>24<(i[g+e>>0]|0))break;else a=f}do{b=b+-4|0;d=k[b>>2]|0}while(h<<24>>24<(i[g+d>>0]|0));if(a>>>0>=b>>>0){t=a;continue b}k[a>>2]=d;k[b>>2]=e;a=f}}if((q|0)==66){q=0;k[t>>2]=e;k[b>>2]=f;a=a+1|0}d=t+4|0;c:do if(d>>>0<b>>>0)while(1){h=k[c>>2]|0;j=i[h+(k[l>>2]|0)>>0]|0;while(1){f=k[d>>2]|0;g=d+4|0;if((i[h+f>>0]|0)<j<<24>>24)d=g;else break}do{b=b+-4|0;e=k[b>>2]|0}while((i[h+e>>0]|0)>=j<<24>>24);if(d>>>0>b>>>0){b=l;break c}k[d>>2]=e;k[b>>2]=f;l=(l|0)==(d|0)?b:l;d=g;a=a+1|0}else b=l;while(0);if((d|0)!=(b|0)?(o=k[b>>2]|0,p=k[d>>2]|0,l=k[c>>2]|0,(i[l+o>>0]|0)<(i[l+p>>0]|0)):0){k[d>>2]=o;k[b>>2]=p;a=a+1|0}if(!a){b=l4(t,d,c)|0;a=d+4|0;if(l4(a,s,c)|0){q=82;break}if(b)continue}l=d;if((l-m|0)>=(n-l|0)){q=81;break}j4(t,d,c);a=d+4|0}if((q|0)==81){q=0;j4(d+4|0,s,c);a=t;s=d;continue}else if((q|0)==82){q=0;if(b){q=83;break}else{a=t;s=d;continue}}}if((q|0)==5){a=k[r>>2]|0;b=k[t>>2]|0;s=k[c>>2]|0;if((i[s+a>>0]|0)>=(i[s+b>>0]|0))return;k[t>>2]=a;k[r>>2]=b;return}else if((q|0)==7){h=t+4|0;d=k[h>>2]|0;f=k[t>>2]|0;g=k[c>>2]|0;s=i[g+d>>0]|0;e=g+f|0;a=k[r>>2]|0;b=(i[g+a>>0]|0)<s<<24>>24;if(s<<24>>24>=(i[e>>0]|0)){if(!b)return;k[h>>2]=a;k[r>>2]=d;a=k[h>>2]|0;b=k[t>>2]|0;if((i[g+a>>0]|0)>=(i[g+b>>0]|0))return;k[t>>2]=a;k[h>>2]=b;return}if(b){k[t>>2]=a;k[r>>2]=f;return}k[t>>2]=d;k[h>>2]=f;a=k[r>>2]|0;if((i[g+a>>0]|0)>=(i[e>>0]|0))return;k[h>>2]=a;k[r>>2]=f;return}else if((q|0)==15){k4(t,t+4|0,t+8|0,r,k[c>>2]|0)|0;return}else if((q|0)==16){h=t+4|0;f=t+8|0;e=t+12|0;k4(t,h,f,e,k[c>>2]|0)|0;a=k[r>>2]|0;b=k[e>>2]|0;g=k[c>>2]|0;if((i[g+a>>0]|0)>=(i[g+b>>0]|0))return;k[e>>2]=a;k[r>>2]=b;b=k[e>>2]|0;a=k[f>>2]|0;d=g+b|0;if((i[d>>0]|0)>=(i[g+a>>0]|0))return;k[f>>2]=b;k[e>>2]=a;a=k[h>>2]|0;if((i[d>>0]|0)>=(i[g+a>>0]|0))return;k[h>>2]=b;k[f>>2]=a;a=k[t>>2]|0;if((i[d>>0]|0)>=(i[g+a>>0]|0))return;k[t>>2]=b;k[h>>2]=a;return}else if((q|0)==22){a=t+8|0;h=t+4|0;d=k[h>>2]|0;j=k[t>>2]|0;l=k[c>>2]|0;r=i[l+d>>0]|0;b=l+j|0;e=k[a>>2]|0;f=l+e|0;g=(i[f>>0]|0)<r<<24>>24;do if(r<<24>>24<(i[b>>0]|0)){if(g){k[t>>2]=e;k[a>>2]=j;d=j;break}k[t>>2]=d;k[h>>2]=j;if((i[f>>0]|0)<(i[b>>0]|0)){k[h>>2]=e;k[a>>2]=j;d=j}else d=e}else if(g){k[h>>2]=e;k[a>>2]=d;if((i[f>>0]|0)<(i[b>>0]|0)){k[t>>2]=e;k[h>>2]=j}}else d=e;while(0);b=t+12|0;if((b|0)==(s|0))return;while(1){g=k[b>>2]|0;f=l+g|0;if((i[f>>0]|0)<(i[l+d>>0]|0)){e=b;while(1){k[e>>2]=d;if((a|0)==(t|0)){a=t;break}e=a+-4|0;d=k[e>>2]|0;if((i[f>>0]|0)>=(i[l+d>>0]|0))break;else{r=a;a=e;e=r}}k[a>>2]=g}a=b+4|0;if((a|0)==(s|0))break;d=k[b>>2]|0;r=b;b=a;a=r}return}else if((q|0)==83)return}function k4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0;l=k[b>>2]|0;j=k[a>>2]|0;m=i[e+l>>0]|0;h=e+j|0;g=k[c>>2]|0;f=(i[e+g>>0]|0)<m<<24>>24;do if(m<<24>>24<(i[h>>0]|0)){if(f){k[a>>2]=g;k[c>>2]=j;h=1;g=j;break}k[a>>2]=l;k[b>>2]=j;g=k[c>>2]|0;if((i[e+g>>0]|0)<(i[h>>0]|0)){k[b>>2]=g;k[c>>2]=j;h=2;g=j}else h=1}else if(f){k[b>>2]=g;k[c>>2]=l;f=k[b>>2]|0;g=k[a>>2]|0;if((i[e+f>>0]|0)<(i[e+g>>0]|0)){k[a>>2]=f;k[b>>2]=g;h=2;g=k[c>>2]|0}else{h=1;g=l}}else h=0;while(0);f=k[d>>2]|0;if((i[e+f>>0]|0)>=(i[e+g>>0]|0)){m=h;return m|0}k[c>>2]=f;k[d>>2]=g;f=k[c>>2]|0;g=k[b>>2]|0;if((i[e+f>>0]|0)>=(i[e+g>>0]|0)){m=h+1|0;return m|0}k[b>>2]=f;k[c>>2]=g;f=k[b>>2]|0;g=k[a>>2]|0;if((i[e+f>>0]|0)>=(i[e+g>>0]|0)){m=h+2|0;return m|0}k[a>>2]=f;k[b>>2]=g;m=h+3|0;return m|0}function l4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=k[d>>2]|0;f=k[a>>2]|0;b=k[c>>2]|0;if((i[b+e>>0]|0)>=(i[b+f>>0]|0)){a=1;return a|0}k[a>>2]=e;k[d>>2]=f;a=1;return a|0}case 3:{m=a+4|0;h=b+-4|0;f=k[m>>2]|0;j=k[a>>2]|0;l=k[c>>2]|0;b=i[l+f>>0]|0;g=l+j|0;d=k[h>>2]|0;e=(i[l+d>>0]|0)<b<<24>>24;if(b<<24>>24>=(i[g>>0]|0)){if(!e){a=1;return a|0}k[m>>2]=d;k[h>>2]=f;d=k[m>>2]|0;e=k[a>>2]|0;if((i[l+d>>0]|0)>=(i[l+e>>0]|0)){a=1;return a|0}k[a>>2]=d;k[m>>2]=e;a=1;return a|0}if(e){k[a>>2]=d;k[h>>2]=j;a=1;return a|0}k[a>>2]=f;k[m>>2]=j;d=k[h>>2]|0;if((i[l+d>>0]|0)>=(i[g>>0]|0)){a=1;return a|0}k[m>>2]=d;k[h>>2]=j;a=1;return a|0}case 4:{k4(a,a+4|0,a+8|0,b+-4|0,k[c>>2]|0)|0;a=1;return a|0}case 5:{l=a+4|0;j=a+8|0;g=a+12|0;d=b+-4|0;k4(a,l,j,g,k[c>>2]|0)|0;e=k[d>>2]|0;f=k[g>>2]|0;h=k[c>>2]|0;if((i[h+e>>0]|0)>=(i[h+f>>0]|0)){a=1;return a|0}k[g>>2]=e;k[d>>2]=f;e=k[g>>2]|0;d=k[j>>2]|0;f=h+e|0;if((i[f>>0]|0)>=(i[h+d>>0]|0)){a=1;return a|0}k[j>>2]=e;k[g>>2]=d;d=k[l>>2]|0;if((i[f>>0]|0)>=(i[h+d>>0]|0)){a=1;return a|0}k[l>>2]=e;k[j>>2]=d;d=k[a>>2]|0;if((i[f>>0]|0)>=(i[h+d>>0]|0)){a=1;return a|0}k[a>>2]=e;k[l>>2]=d;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{m=a+8|0;j=a+4|0;f=k[j>>2]|0;l=k[a>>2]|0;c=k[c>>2]|0;n=i[c+f>>0]|0;d=c+l|0;e=k[m>>2]|0;g=c+e|0;h=(i[g>>0]|0)<n<<24>>24;do if(n<<24>>24<(i[d>>0]|0)){if(h){k[a>>2]=e;k[m>>2]=l;f=l;break}k[a>>2]=f;k[j>>2]=l;if((i[g>>0]|0)<(i[d>>0]|0)){k[j>>2]=e;k[m>>2]=l;f=l}else f=e}else if(h){k[j>>2]=e;k[m>>2]=f;if((i[g>>0]|0)<(i[d>>0]|0)){k[a>>2]=e;k[j>>2]=l}}else f=e;while(0);d=a+12|0;a:do if((d|0)==(b|0)){e=1;d=0}else{l=d;e=0;d=m;while(1){j=k[l>>2]|0;h=c+j|0;if((i[h>>0]|0)<(i[c+f>>0]|0)){g=l;while(1){k[g>>2]=f;if((d|0)==(a|0)){d=a;break}g=d+-4|0;f=k[g>>2]|0;if((i[h>>0]|0)>=(i[c+f>>0]|0))break;else{n=d;d=g;g=n}}k[d>>2]=j;e=e+1|0;d=l+4|0;if((e|0)==8){e=0;d=(d|0)==(b|0);break a}}else d=l+4|0;if((d|0)==(b|0)){e=1;d=0;break a}f=k[l>>2]|0;n=l;l=d;d=n}}while(0);n=d|e;return n|0}}return 0}function m4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;t=b;a:while(1){o=t;s=t+-4|0;while(1){u=a;b:while(1){n=u;a=o-n|0;b=a>>2;switch(b|0){case 2:{r=5;break a}case 3:{r=7;break a}case 4:{r=15;break a}case 5:{r=16;break a}case 1:case 0:{r=83;break a}default:{}}if((a|0)<124){r=22;break a}m=u+(((b|0)/2|0)<<2)|0;do if((a|0)>3996){g=(b|0)/4|0;h=u+(g<<2)|0;g=m+(g<<2)|0;a=n4(u,h,m,g,k[c>>2]|0)|0;d=k[s>>2]|0;e=k[g>>2]|0;b=k[c>>2]|0;if((l[b+d>>0]|0)<(l[b+e>>0]|0)){k[g>>2]=d;k[s>>2]=e;d=a+1|0;e=k[g>>2]|0;f=k[m>>2]|0;if((l[b+e>>0]|0)<(l[b+f>>0]|0)){k[m>>2]=e;k[g>>2]=f;d=a+2|0;e=k[m>>2]|0;f=k[h>>2]|0;if((l[b+e>>0]|0)<(l[b+f>>0]|0)){k[h>>2]=e;k[m>>2]=f;d=k[h>>2]|0;e=k[u>>2]|0;if((l[b+d>>0]|0)<(l[b+e>>0]|0)){k[u>>2]=d;k[h>>2]=e;a=a+4|0}else a=a+3|0}else a=d}else a=d}}else{a=k[m>>2]|0;e=k[u>>2]|0;g=k[c>>2]|0;j=i[g+a>>0]|0;f=g+e|0;b=k[s>>2]|0;d=(l[g+b>>0]|0)<(j&255);if((j&255)>=(l[f>>0]|0)){if(!d){a=0;b=g;break}k[m>>2]=b;k[s>>2]=a;a=k[m>>2]|0;b=k[u>>2]|0;if((l[g+a>>0]|0)>=(l[g+b>>0]|0)){a=1;b=g;break}k[u>>2]=a;k[m>>2]=b;a=2;b=g;break}if(d){k[u>>2]=b;k[s>>2]=e;a=1;b=g;break}k[u>>2]=a;k[m>>2]=e;a=k[s>>2]|0;if((l[g+a>>0]|0)<(l[f>>0]|0)){k[m>>2]=a;k[s>>2]=e;a=2;b=g}else{a=1;b=g}}while(0);f=k[u>>2]|0;d=k[m>>2]|0;if((l[b+f>>0]|0)<(l[b+d>>0]|0)){b=s;break}g=k[c>>2]|0;d=g+d|0;b=s;while(1){b=b+-4|0;if((u|0)==(b|0))break;e=k[b>>2]|0;if((l[g+e>>0]|0)<(l[d>>0]|0)){r=66;break b}}a=u+4|0;e=k[s>>2]|0;d=i[g+f>>0]|0;if((d&255)>=(l[g+e>>0]|0)){if((a|0)==(s|0)){r=83;break a}while(1){b=k[a>>2]|0;if((d&255)<(l[g+b>>0]|0))break;a=a+4|0;if((a|0)==(s|0)){r=83;break a}}k[a>>2]=e;k[s>>2]=b;a=a+4|0}if((a|0)==(s|0)){r=83;break a}else b=s;while(1){g=k[c>>2]|0;h=i[g+(k[u>>2]|0)>>0]|0;while(1){e=k[a>>2]|0;f=a+4|0;if((h&255)<(l[g+e>>0]|0))break;else a=f}do{b=b+-4|0;d=k[b>>2]|0}while((h&255)<(l[g+d>>0]|0));if(a>>>0>=b>>>0){u=a;continue b}k[a>>2]=d;k[b>>2]=e;a=f}}if((r|0)==66){r=0;k[u>>2]=e;k[b>>2]=f;a=a+1|0}d=u+4|0;c:do if(d>>>0<b>>>0)while(1){h=k[c>>2]|0;j=i[h+(k[m>>2]|0)>>0]|0;while(1){f=k[d>>2]|0;g=d+4|0;if((l[h+f>>0]|0)<(j&255))d=g;else break}do{b=b+-4|0;e=k[b>>2]|0}while((l[h+e>>0]|0)>=(j&255));if(d>>>0>b>>>0){b=m;break c}k[d>>2]=e;k[b>>2]=f;m=(m|0)==(d|0)?b:m;d=g;a=a+1|0}else b=m;while(0);if((d|0)!=(b|0)?(p=k[b>>2]|0,q=k[d>>2]|0,m=k[c>>2]|0,(l[m+p>>0]|0)<(l[m+q>>0]|0)):0){k[d>>2]=p;k[b>>2]=q;a=a+1|0}if(!a){b=o4(u,d,c)|0;a=d+4|0;if(o4(a,t,c)|0){r=82;break}if(b)continue}m=d;if((m-n|0)>=(o-m|0)){r=81;break}m4(u,d,c);a=d+4|0}if((r|0)==81){r=0;m4(d+4|0,t,c);a=u;t=d;continue}else if((r|0)==82){r=0;if(b){r=83;break}else{a=u;t=d;continue}}}if((r|0)==5){a=k[s>>2]|0;b=k[u>>2]|0;t=k[c>>2]|0;if((l[t+a>>0]|0)>=(l[t+b>>0]|0))return;k[u>>2]=a;k[s>>2]=b;return}else if((r|0)==7){h=u+4|0;d=k[h>>2]|0;f=k[u>>2]|0;g=k[c>>2]|0;t=i[g+d>>0]|0;e=g+f|0;a=k[s>>2]|0;b=(l[g+a>>0]|0)<(t&255);if((t&255)>=(l[e>>0]|0)){if(!b)return;k[h>>2]=a;k[s>>2]=d;a=k[h>>2]|0;b=k[u>>2]|0;if((l[g+a>>0]|0)>=(l[g+b>>0]|0))return;k[u>>2]=a;k[h>>2]=b;return}if(b){k[u>>2]=a;k[s>>2]=f;return}k[u>>2]=d;k[h>>2]=f;a=k[s>>2]|0;if((l[g+a>>0]|0)>=(l[e>>0]|0))return;k[h>>2]=a;k[s>>2]=f;return}else if((r|0)==15){n4(u,u+4|0,u+8|0,s,k[c>>2]|0)|0;return}else if((r|0)==16){h=u+4|0;f=u+8|0;e=u+12|0;n4(u,h,f,e,k[c>>2]|0)|0;a=k[s>>2]|0;b=k[e>>2]|0;g=k[c>>2]|0;if((l[g+a>>0]|0)>=(l[g+b>>0]|0))return;k[e>>2]=a;k[s>>2]=b;b=k[e>>2]|0;a=k[f>>2]|0;d=g+b|0;if((l[d>>0]|0)>=(l[g+a>>0]|0))return;k[f>>2]=b;k[e>>2]=a;a=k[h>>2]|0;if((l[d>>0]|0)>=(l[g+a>>0]|0))return;k[h>>2]=b;k[f>>2]=a;a=k[u>>2]|0;if((l[d>>0]|0)>=(l[g+a>>0]|0))return;k[u>>2]=b;k[h>>2]=a;return}else if((r|0)==22){a=u+8|0;h=u+4|0;d=k[h>>2]|0;j=k[u>>2]|0;m=k[c>>2]|0;s=i[m+d>>0]|0;b=m+j|0;e=k[a>>2]|0;f=m+e|0;g=(l[f>>0]|0)<(s&255);do if((s&255)<(l[b>>0]|0)){if(g){k[u>>2]=e;k[a>>2]=j;d=j;break}k[u>>2]=d;k[h>>2]=j;if((l[f>>0]|0)<(l[b>>0]|0)){k[h>>2]=e;k[a>>2]=j;d=j}else d=e}else if(g){k[h>>2]=e;k[a>>2]=d;if((l[f>>0]|0)<(l[b>>0]|0)){k[u>>2]=e;k[h>>2]=j}}else d=e;while(0);b=u+12|0;if((b|0)==(t|0))return;while(1){g=k[b>>2]|0;f=m+g|0;if((l[f>>0]|0)<(l[m+d>>0]|0)){e=b;while(1){k[e>>2]=d;if((a|0)==(u|0)){a=u;break}e=a+-4|0;d=k[e>>2]|0;if((l[f>>0]|0)>=(l[m+d>>0]|0))break;else{s=a;a=e;e=s}}k[a>>2]=g}a=b+4|0;if((a|0)==(t|0))break;d=k[b>>2]|0;s=b;b=a;a=s}return}else if((r|0)==83)return}function n4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0;m=k[b>>2]|0;j=k[a>>2]|0;n=i[e+m>>0]|0;h=e+j|0;g=k[c>>2]|0;f=(l[e+g>>0]|0)<(n&255);do if((n&255)<(l[h>>0]|0)){if(f){k[a>>2]=g;k[c>>2]=j;h=1;g=j;break}k[a>>2]=m;k[b>>2]=j;g=k[c>>2]|0;if((l[e+g>>0]|0)<(l[h>>0]|0)){k[b>>2]=g;k[c>>2]=j;h=2;g=j}else h=1}else if(f){k[b>>2]=g;k[c>>2]=m;f=k[b>>2]|0;g=k[a>>2]|0;if((l[e+f>>0]|0)<(l[e+g>>0]|0)){k[a>>2]=f;k[b>>2]=g;h=2;g=k[c>>2]|0}else{h=1;g=m}}else h=0;while(0);f=k[d>>2]|0;if((l[e+f>>0]|0)>=(l[e+g>>0]|0)){n=h;return n|0}k[c>>2]=f;k[d>>2]=g;f=k[c>>2]|0;g=k[b>>2]|0;if((l[e+f>>0]|0)>=(l[e+g>>0]|0)){n=h+1|0;return n|0}k[b>>2]=f;k[c>>2]=g;f=k[b>>2]|0;g=k[a>>2]|0;if((l[e+f>>0]|0)>=(l[e+g>>0]|0)){n=h+2|0;return n|0}k[a>>2]=f;k[b>>2]=g;n=h+3|0;return n|0}function o4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=k[d>>2]|0;f=k[a>>2]|0;b=k[c>>2]|0;if((l[b+e>>0]|0)>=(l[b+f>>0]|0)){a=1;return a|0}k[a>>2]=e;k[d>>2]=f;a=1;return a|0}case 3:{n=a+4|0;h=b+-4|0;f=k[n>>2]|0;j=k[a>>2]|0;m=k[c>>2]|0;b=i[m+f>>0]|0;g=m+j|0;d=k[h>>2]|0;e=(l[m+d>>0]|0)<(b&255);if((b&255)>=(l[g>>0]|0)){if(!e){a=1;return a|0}k[n>>2]=d;k[h>>2]=f;d=k[n>>2]|0;e=k[a>>2]|0;if((l[m+d>>0]|0)>=(l[m+e>>0]|0)){a=1;return a|0}k[a>>2]=d;k[n>>2]=e;a=1;return a|0}if(e){k[a>>2]=d;k[h>>2]=j;a=1;return a|0}k[a>>2]=f;k[n>>2]=j;d=k[h>>2]|0;if((l[m+d>>0]|0)>=(l[g>>0]|0)){a=1;return a|0}k[n>>2]=d;k[h>>2]=j;a=1;return a|0}case 4:{n4(a,a+4|0,a+8|0,b+-4|0,k[c>>2]|0)|0;a=1;return a|0}case 5:{m=a+4|0;j=a+8|0;g=a+12|0;d=b+-4|0;n4(a,m,j,g,k[c>>2]|0)|0;e=k[d>>2]|0;f=k[g>>2]|0;h=k[c>>2]|0;if((l[h+e>>0]|0)>=(l[h+f>>0]|0)){a=1;return a|0}k[g>>2]=e;k[d>>2]=f;e=k[g>>2]|0;d=k[j>>2]|0;f=h+e|0;if((l[f>>0]|0)>=(l[h+d>>0]|0)){a=1;return a|0}k[j>>2]=e;k[g>>2]=d;d=k[m>>2]|0;if((l[f>>0]|0)>=(l[h+d>>0]|0)){a=1;return a|0}k[m>>2]=e;k[j>>2]=d;d=k[a>>2]|0;if((l[f>>0]|0)>=(l[h+d>>0]|0)){a=1;return a|0}k[a>>2]=e;k[m>>2]=d;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{n=a+8|0;j=a+4|0;f=k[j>>2]|0;m=k[a>>2]|0;c=k[c>>2]|0;o=i[c+f>>0]|0;d=c+m|0;e=k[n>>2]|0;g=c+e|0;h=(l[g>>0]|0)<(o&255);do if((o&255)<(l[d>>0]|0)){if(h){k[a>>2]=e;k[n>>2]=m;f=m;break}k[a>>2]=f;k[j>>2]=m;if((l[g>>0]|0)<(l[d>>0]|0)){k[j>>2]=e;k[n>>2]=m;f=m}else f=e}else if(h){k[j>>2]=e;k[n>>2]=f;if((l[g>>0]|0)<(l[d>>0]|0)){k[a>>2]=e;k[j>>2]=m}}else f=e;while(0);d=a+12|0;a:do if((d|0)==(b|0)){e=1;d=0}else{m=d;e=0;d=n;while(1){j=k[m>>2]|0;h=c+j|0;if((l[h>>0]|0)<(l[c+f>>0]|0)){g=m;while(1){k[g>>2]=f;if((d|0)==(a|0)){d=a;break}g=d+-4|0;f=k[g>>2]|0;if((l[h>>0]|0)>=(l[c+f>>0]|0))break;else{o=d;d=g;g=o}}k[d>>2]=j;e=e+1|0;d=m+4|0;if((e|0)==8){e=0;d=(d|0)==(b|0);break a}}else d=m+4|0;if((d|0)==(b|0)){e=1;d=0;break a}f=k[m>>2]|0;o=m;m=d;d=o}}while(0);o=d|e;return o|0}}return 0}function p4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+32|0;o=p+8|0;n=p;f=b+4|0;if((k[f>>2]|0)==(c|0)){_1(a,b,1,0);r=p;return}if(!(k[b>>2]&16384)){d=o+4|0;e=ZT(76)|0;k[e>>2]=1;l=e+4|0;k[o>>2]=l;k[d>>2]=71;i[e+75>>0]=0;g=220813;m=l+71|0;do{i[l>>0]=i[g>>0]|0;l=l+1|0;g=g+1|0}while((l|0)<(m|0));Y8(-213,o,218913,216975,4376);k[d>>2]=0;k[o>>2]=0;o=k[e>>2]|0;k[e>>2]=o+-1;if((o|0)==1)ggb(k[e+-4>>2]|0);k[a>>2]=1124007936;d=a+8|0;e=a+40|0;l=a+4|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[e>>2]=d;o=a+48|0;k[a+44>>2]=o;k[a+52>>2]=0;k[o>>2]=0;r=p;return}d=o+4|0;e=ZT(68)|0;k[e>>2]=1;l=e+4|0;k[o>>2]=l;k[d>>2]=62;i[e+66>>0]=0;g=220687;m=l+62|0;do{i[l>>0]=i[g>>0]|0;l=l+1|0;g=g+1|0}while((l|0)<(m|0));Y8(-215,o,218913,216975,4340);k[d>>2]=0;k[o>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0);f=k[f>>2]|0;if((f|0)<3)d=aa(k[b+12>>2]|0,k[b+8>>2]|0)|0;else{g=k[b+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}f=aa(((k[b>>2]|0)>>>3&511)+1|0,d)|0;h=o+8|0;k[o>>2]=h;j=o+4|0;k[j>>2]=4;if(c>>>0>4){e=c>>>0>1073741823?-1:c<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[o>>2]=d}k[j>>2]=c;if((c|0)>0)Vd();if((f|0)!=1){k[n>>2]=0;d=n+4|0;k[d>>2]=0;e=ZT(68)|0;k[e>>2]=1;l=e+4|0;k[n>>2]=l;k[d>>2]=62;i[e+66>>0]=0;g=220750;m=l+62|0;do{i[l>>0]=i[g>>0]|0;l=l+1|0;g=g+1|0}while((l|0)<(m|0));Y8(-209,n,218913,216975,4367);k[d>>2]=0;k[n>>2]=0;n=k[e>>2]|0;k[e>>2]=n+-1;if((n|0)==1)ggb(k[e+-4>>2]|0)}AF(a,b);k[a>>2]=k[a>>2]&-4089;x1(a,c,k[o>>2]|0,0,1);d=k[o>>2]|0;if((d|0)!=(h|0)){if(d|0)ggb(d);k[o>>2]=h;k[j>>2]=4}r=p;return}function q4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=k[a>>2]|0;if(k[n>>2]&16384|0){d=a+8|0;n=a+12|0;c=(k[(c?d:n)>>2]|0)+(aa(k[a+4>>2]|0,b)|0)|0;k[d>>2]=c;b=k[n>>2]|0;if(c>>>0<b>>>0){k[d>>2]=b;return}b=k[a+16>>2]|0;if(c>>>0<=b>>>0)return;k[d>>2]=b;return}m=k[n+4>>2]|0;if((m|0)==2){d=k[n+44>>2]|0;if(c){c=k[n+16>>2]|0;h=(k[a+8>>2]|0)-c|0;m=k[d>>2]|0;g=(h>>>0)/(m>>>0)|0;i=k[n+12>>2]|0;l=aa(i,g)|0;g=h-(aa(g,m)|0)|0;h=a+4|0;e=k[h>>2]|0;g=l+b+((g>>>0)/(e>>>0)|0)|0;b=m}else{e=a+4|0;g=b;h=e;i=k[n+12>>2]|0;b=k[d>>2]|0;c=k[n+16>>2]|0;e=k[e>>2]|0}f=(g|0)/(i|0)|0;m=(f|0)<0;d=k[n+8>>2]|0;l=d+-1|0;n=m?0:f;b=c+(aa(b,(l|0)<(n|0)?l:n)|0)|0;k[a+12>>2]=b;c=b+(aa(e,i)|0)|0;k[a+16>>2]=c;if(!m)if((f|0)<(d|0)){n=g-(aa(i,f)|0)|0;b=b+(aa(n,k[h>>2]|0)|0)|0}else b=c;k[a+8>>2]=b;return}if(c){if((m|0)>0){f=k[n+44>>2]|0;g=k[n+40>>2]|0;d=(k[a+8>>2]|0)-(k[n+16>>2]|0)|0;c=0;e=0;do{j=k[f+(e<<2)>>2]|0;l=(d>>>0)/(j>>>0)|0;d=d-(aa(l,j)|0)|0;c=(aa(k[g+(e<<2)>>2]|0,c)|0)+l|0;e=e+1|0}while((e|0)!=(m|0))}else c=0;b=c+b|0}h=(b|0)<0?0:b;g=k[n+40>>2]|0;j=k[g+(m+-1<<2)>>2]|0;c=(h|0)/(j|0)|0;h=h-(aa(c,j)|0)|0;b=k[n+16>>2]|0;l=k[a+4>>2]|0;h=aa(h,l)|0;i=a+8|0;k[i>>2]=b+h;f=a+12|0;k[f>>2]=b;d=m+-2|0;if((d|0)>-1){e=k[n+44>>2]|0;while(1){n=k[g+(d<<2)>>2]|0;m=c;c=(c|0)/(n|0)|0;n=m-(aa(c,n)|0)|0;b=b+(aa(n,k[e+(d<<2)>>2]|0)|0)|0;if((d|0)<=0)break;else d=d+-1|0}k[f>>2]=b}n=b+(aa(l,j)|0)|0;k[a+16>>2]=n;k[i>>2]=(c|0)>0?n:b+h|0;return}function r4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+8|0;d=k[j>>2]|0;l=a+4|0;c=k[l>>2]|0;if(d-c>>2>>>0>=b>>>0){zpb(c|0,0,b<<2|0)|0;k[l>>2]=c+(b<<2);return}i=k[a>>2]|0;h=c-i|0;g=h>>2;c=g+b|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);e=d-i|0;f=e>>1;f=e>>2>>>0<536870911?(f>>>0<c>>>0?c:f):1073741823;if(!f)c=0;else{if(f>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<2)|0;zpb(e|0,0,b<<2|0)|0;d=e+(0-g<<2)|0;if((h|0)>0)upb(d|0,i|0,h|0)|0;k[a>>2]=d;k[l>>2]=e+(b<<2);k[j>>2]=c+(f<<2);if(!i)return;ggb(i);return}function s4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;i=c;g=b;f=i-g|0;m=f>>2;h=a+8|0;d=k[h>>2]|0;l=k[a>>2]|0;j=l;if(m>>>0<=d-l>>2>>>0){h=a+4|0;a=(k[h>>2]|0)-l>>2;f=m>>>0>a>>>0;a=f?b+(a<<2)|0:c;e=a;d=e-g|0;c=d>>2;if(c|0)wpb(l|0,b|0,d|0)|0;c=j+(c<<2)|0;if(f){d=i-e|0;if((d|0)<=0)return;upb(k[h>>2]|0,a|0,d|0)|0;k[h>>2]=(k[h>>2]|0)+(d>>2<<2);return}else{d=k[h>>2]|0;if((d|0)==(c|0))return;k[h>>2]=d+(~((d+-4-c|0)>>>2)<<2);return}}e=l;if(l){d=a+4|0;c=k[d>>2]|0;if((c|0)!=(j|0))k[d>>2]=c+(~((c+-4-l|0)>>>2)<<2);ggb(e);k[h>>2]=0;k[d>>2]=0;k[a>>2]=0;d=0}if(m>>>0>1073741823)ad(426534,426557,304,426811);e=d>>1;e=d>>2>>>0<536870911?(e>>>0<m>>>0?m:e):1073741823;if(e>>>0>1073741823)bob();c=e<<2;c=(c|0)==0?1:c;while(1){d=fgb(c)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}c=a+4|0;k[c>>2]=d;k[a>>2]=d;k[h>>2]=d+(e<<2);if((f|0)<=0)return;upb(d|0,b|0,f|0)|0;k[c>>2]=d+(m<<2);return}function t4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,l=0,m=0,n=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0;u=b>>>2;t=e>>>2;if((c|0)<=0){f=1;return f|0}r=(d|0)==0|(f|0)<1;b=1;n=0;while(1){p=n+1|0;j=(p|0)<(c|0);if(j){e=n;g=p;do{m=a+((aa(g,u)|0)+n<<2)|0;q=+P(+(+o[m>>2]));m=a+((aa(e,u)|0)+n<<2)|0;m=q>+P(+(+o[m>>2]));e=m?g:e;g=g+1|0}while((g|0)!=(c|0))}else e=n;i=aa(e,u)|0;if(+P(+(+o[a+(i+n<<2)>>2]))<1.1920928955078125e-06){b=0;s=28;break}m=aa(n,u)|0;if((e|0)!=(n|0)){g=n;do{w=a+(g+m<<2)|0;l=a+(g+i<<2)|0;v=k[w>>2]|0;k[w>>2]=k[l>>2];k[l>>2]=v;g=g+1|0}while((g|0)!=(c|0));if(!r){i=aa(n,t)|0;g=aa(e,t)|0;e=0;do{l=d+(e+i<<2)|0;w=d+(e+g<<2)|0;v=k[l>>2]|0;k[l>>2]=k[w>>2];k[w>>2]=v;e=e+1|0}while((e|0)!=(f|0))}b=0-b|0}l=a+(m+n<<2)|0;q=-1.0/+o[l>>2];if(!j)break;j=aa(n,t)|0;i=p;do{g=aa(i,u)|0;h=q*+o[a+(g+n<<2)>>2];e=p;do{w=a+(e+g<<2)|0;o[w>>2]=+o[w>>2]+h*+o[a+(e+m<<2)>>2];e=e+1|0}while((e|0)!=(c|0));if(!r){g=aa(i,t)|0;e=0;do{w=d+(e+g<<2)|0;o[w>>2]=+o[w>>2]+h*+o[d+(e+j<<2)>>2];e=e+1|0}while((e|0)!=(f|0))}i=i+1|0}while((i|0)!=(c|0));o[l>>2]=-q;n=p}if((s|0)==28)return b|0;o[l>>2]=-q;if((d|0)!=0&(f|0)>0)l=c;else{w=b;return w|0}do{m=l;l=l+-1|0;n=aa(l,t)|0;i=aa(l,u)|0;p=a+(i+l<<2)|0;if((m|0)<(c|0)){g=0;do{j=d+(g+n<<2)|0;h=+o[j>>2];e=m;do{w=d+((aa(e,t)|0)+g<<2)|0;h=h-+o[a+(e+i<<2)>>2]*+o[w>>2];e=e+1|0}while((e|0)!=(c|0));o[j>>2]=h*+o[p>>2];g=g+1|0}while((g|0)!=(f|0))}else{e=0;do{w=d+(e+n<<2)|0;o[w>>2]=+o[w>>2]*+o[p>>2];e=e+1|0}while((e|0)!=(f|0))}}while((m|0)>1);return b|0}function u4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0,u=0;t=b>>>3;s=e>>>3;if((c|0)<=0){f=1;return f|0}q=(d|0)==0|(f|0)<1;b=1;m=0;while(1){n=m+1|0;j=(n|0)<(c|0);if(j){e=m;g=n;do{l=a+((aa(g,t)|0)+m<<3)|0;o=+P(+(+p[l>>3]));l=a+((aa(e,t)|0)+m<<3)|0;l=o>+P(+(+p[l>>3]));e=l?g:e;g=g+1|0}while((g|0)!=(c|0))}else e=m;i=aa(e,t)|0;if(+P(+(+p[a+(i+m<<3)>>3]))<2.220446049250313e-14){b=0;r=28;break}l=aa(m,t)|0;if((e|0)!=(m|0)){g=m;do{u=a+(g+l<<3)|0;k=a+(g+i<<3)|0;o=+p[u>>3];p[u>>3]=+p[k>>3];p[k>>3]=o;g=g+1|0}while((g|0)!=(c|0));if(!q){i=aa(m,s)|0;g=aa(e,s)|0;e=0;do{k=d+(e+i<<3)|0;u=d+(e+g<<3)|0;o=+p[k>>3];p[k>>3]=+p[u>>3];p[u>>3]=o;e=e+1|0}while((e|0)!=(f|0))}b=0-b|0}k=a+(l+m<<3)|0;o=-1.0/+p[k>>3];if(!j)break;j=aa(m,s)|0;i=n;do{g=aa(i,t)|0;h=o*+p[a+(g+m<<3)>>3];e=n;do{u=a+(e+g<<3)|0;p[u>>3]=+p[u>>3]+h*+p[a+(e+l<<3)>>3];e=e+1|0}while((e|0)!=(c|0));if(!q){g=aa(i,s)|0;e=0;do{u=d+(e+g<<3)|0;p[u>>3]=+p[u>>3]+h*+p[d+(e+j<<3)>>3];e=e+1|0}while((e|0)!=(f|0))}i=i+1|0}while((i|0)!=(c|0));p[k>>3]=-o;m=n}if((r|0)==28)return b|0;p[k>>3]=-o;if((d|0)!=0&(f|0)>0)k=c;else{u=b;return u|0}do{l=k;k=k+-1|0;m=aa(k,s)|0;i=aa(k,t)|0;n=a+(i+k<<3)|0;if((l|0)<(c|0)){g=0;do{j=d+(g+m<<3)|0;h=+p[j>>3];e=l;do{u=d+((aa(e,s)|0)+g<<3)|0;h=h-+p[a+(e+i<<3)>>3]*+p[u>>3];e=e+1|0}while((e|0)!=(c|0));p[j>>3]=h*+p[n>>3];g=g+1|0}while((g|0)!=(f|0))}else{e=0;do{u=d+(e+m<<3)|0;p[u>>3]=+p[u>>3]*+p[n>>3];e=e+1|0}while((e|0)!=(f|0))}}while((l|0)>1);return b|0}function v4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,p=0.0,q=0;n=b>>>2;m=e>>>2;if((c|0)>0)k=0;else{f=1;return f|0}do{j=aa(k,n)|0;if((k|0)>0){i=0;do{e=a+(i+j<<2)|0;g=+o[e>>2];h=aa(i,n)|0;if((i|0)>0){b=0;do{g=g-+o[a+(b+j<<2)>>2]*+o[a+(b+h<<2)>>2];b=b+1|0}while((b|0)!=(i|0))}o[e>>2]=g*+o[a+(h+i<<2)>>2];i=i+1|0}while((i|0)!=(k|0));b=a+(j+k<<2)|0;e=0;g=+o[b>>2];do{p=+o[a+(e+j<<2)>>2];g=g-p*p;e=e+1|0}while((e|0)!=(k|0))}else{b=a+(j+k<<2)|0;g=+o[b>>2]}if(g<1.1920928955078125e-07){b=0;l=25;break}p=1.0/+Q(+g);o[b>>2]=p;k=k+1|0}while((k|0)<(c|0));if((l|0)==25)return b|0;if((d|0)!=0&(f|0)>0)l=0;else{f=1;return f|0}do{j=aa(l,m)|0;h=aa(l,n)|0;k=a+(h+l<<2)|0;if((l|0)>0){b=0;do{i=d+(b+j<<2)|0;e=0;g=+o[i>>2];do{q=d+((aa(e,m)|0)+b<<2)|0;g=g-+o[a+(e+h<<2)>>2]*+o[q>>2];e=e+1|0}while((e|0)!=(l|0));o[i>>2]=g*+o[k>>2];b=b+1|0}while((b|0)!=(f|0))}else{b=0;do{q=d+(b+j<<2)|0;o[q>>2]=+o[q>>2]*+o[k>>2];b=b+1|0}while((b|0)!=(f|0))}l=l+1|0}while((l|0)!=(c|0));j=c+-1|0;i=j;while(1){k=aa(i,m)|0;l=a+((aa(i,n)|0)+i<<2)|0;if((j|0)>(i|0)){b=0;do{h=d+(b+k<<2)|0;e=j;g=+o[h>>2];do{c=a+((aa(e,n)|0)+i<<2)|0;q=d+((aa(e,m)|0)+b<<2)|0;g=g-+o[c>>2]*+o[q>>2];e=e+-1|0}while((e|0)>(i|0));o[h>>2]=g*+o[l>>2];b=b+1|0}while((b|0)!=(f|0))}else{b=0;do{q=d+(b+k<<2)|0;o[q>>2]=+o[q>>2]*+o[l>>2];b=b+1|0}while((b|0)!=(f|0))}if((i|0)>0)i=i+-1|0;else{b=1;break}}return b|0}function w4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0;n=b>>>3;m=e>>>3;if((c|0)>0)k=0;else{f=1;return f|0}do{j=aa(k,n)|0;if((k|0)>0){i=0;do{e=a+(i+j<<3)|0;g=+p[e>>3];h=aa(i,n)|0;if((i|0)>0){b=0;do{g=g-+p[a+(b+j<<3)>>3]*+p[a+(b+h<<3)>>3];b=b+1|0}while((b|0)!=(i|0))}p[e>>3]=g*+p[a+(h+i<<3)>>3];i=i+1|0}while((i|0)!=(k|0));b=a+(j+k<<3)|0;e=0;g=+p[b>>3];do{o=+p[a+(e+j<<3)>>3];g=g-o*o;e=e+1|0}while((e|0)!=(k|0))}else{b=a+(j+k<<3)|0;g=+p[b>>3]}if(g<2.220446049250313e-16){b=0;l=25;break}o=1.0/+Q(+g);p[b>>3]=o;k=k+1|0}while((k|0)<(c|0));if((l|0)==25)return b|0;if((d|0)!=0&(f|0)>0)l=0;else{f=1;return f|0}do{j=aa(l,m)|0;h=aa(l,n)|0;k=a+(h+l<<3)|0;if((l|0)>0){b=0;do{i=d+(b+j<<3)|0;e=0;g=+p[i>>3];do{q=d+((aa(e,m)|0)+b<<3)|0;g=g-+p[a+(e+h<<3)>>3]*+p[q>>3];e=e+1|0}while((e|0)!=(l|0));p[i>>3]=g*+p[k>>3];b=b+1|0}while((b|0)!=(f|0))}else{b=0;do{q=d+(b+j<<3)|0;p[q>>3]=+p[q>>3]*+p[k>>3];b=b+1|0}while((b|0)!=(f|0))}l=l+1|0}while((l|0)!=(c|0));j=c+-1|0;i=j;while(1){k=aa(i,m)|0;l=a+((aa(i,n)|0)+i<<3)|0;if((j|0)>(i|0)){b=0;do{h=d+(b+k<<3)|0;e=j;g=+p[h>>3];do{c=a+((aa(e,n)|0)+i<<3)|0;q=d+((aa(e,m)|0)+b<<3)|0;g=g-+p[c>>3]*+p[q>>3];e=e+-1|0}while((e|0)>(i|0));p[h>>3]=g*+p[l>>3];b=b+1|0}while((b|0)!=(f|0))}else{b=0;do{q=d+(b+k<<3)|0;p[q>>3]=+p[q>>3]*+p[l>>3];b=b+1|0}while((b|0)!=(f|0))}if((i|0)>0)i=i+-1|0;else{b=1;break}}return b|0}function x4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=(d|0)%4|0;m=(m|0)==0?4:m;switch(m|0){case 1:{g=k[a>>2]|0;if((c|0)>0){e=0;f=0;while(1){i[b+f>>0]=i[g+e>>0]|0;e=e+1|0;if((e|0)==(c|0))break;else f=f+d|0}}else return;break}case 2:{g=k[a>>2]|0;h=k[a+4>>2]|0;if((c|0)>0){e=0;f=0;while(1){i[b+e>>0]=i[g+f>>0]|0;i[b+(e+1)>>0]=i[h+f>>0]|0;f=f+1|0;if((f|0)==(c|0))break;else e=e+d|0}}else return;break}case 3:{g=k[a>>2]|0;h=k[a+4>>2]|0;j=k[a+8>>2]|0;if((c|0)>0){e=0;f=0;while(1){i[b+e>>0]=i[g+f>>0]|0;i[b+(e+1)>>0]=i[h+f>>0]|0;i[b+(e+2)>>0]=i[j+f>>0]|0;f=f+1|0;if((f|0)==(c|0))break;else e=e+d|0}}else return;break}default:{g=k[a>>2]|0;h=k[a+4>>2]|0;j=k[a+8>>2]|0;l=k[a+12>>2]|0;if((c|0)>0){e=0;f=0;while(1){i[b+e>>0]=i[g+f>>0]|0;i[b+(e+1)>>0]=i[h+f>>0]|0;i[b+(e+2)>>0]=i[j+f>>0]|0;i[b+(e+3)>>0]=i[l+f>>0]|0;f=f+1|0;if((f|0)==(c|0))break;else e=e+d|0}}else return}}if((c|0)>0&(m|0)<(d|0))e=m;else return;do{h=k[a+(e<<2)>>2]|0;j=k[a+(e+1<<2)>>2]|0;l=k[a+(e+2<<2)>>2]|0;m=k[a+(e+3<<2)>>2]|0;f=e;g=0;while(1){i[b+f>>0]=i[h+g>>0]|0;i[b+(f+1)>>0]=i[j+g>>0]|0;i[b+(f+2)>>0]=i[l+g>>0]|0;i[b+(f+3)>>0]=i[m+g>>0]|0;g=g+1|0;if((g|0)==(c|0))break;else f=f+d|0}e=e+4|0}while((e|0)<(d|0));return}function y4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,l=0,m=0;m=(d|0)%4|0;m=(m|0)==0?4:m;switch(m|0){case 1:{g=k[a>>2]|0;if((c|0)>0){e=0;f=0;while(1){j[b+(f<<1)>>1]=j[g+(e<<1)>>1]|0;e=e+1|0;if((e|0)==(c|0))break;else f=f+d|0}}else return;break}case 2:{g=k[a>>2]|0;h=k[a+4>>2]|0;if((c|0)>0){e=0;f=0;while(1){j[b+(e<<1)>>1]=j[g+(f<<1)>>1]|0;j[b+(e+1<<1)>>1]=j[h+(f<<1)>>1]|0;f=f+1|0;if((f|0)==(c|0))break;else e=e+d|0}}else return;break}case 3:{g=k[a>>2]|0;h=k[a+4>>2]|0;i=k[a+8>>2]|0;if((c|0)>0){e=0;f=0;while(1){j[b+(e<<1)>>1]=j[g+(f<<1)>>1]|0;j[b+(e+1<<1)>>1]=j[h+(f<<1)>>1]|0;j[b+(e+2<<1)>>1]=j[i+(f<<1)>>1]|0;f=f+1|0;if((f|0)==(c|0))break;else e=e+d|0}}else return;break}default:{g=k[a>>2]|0;h=k[a+4>>2]|0;i=k[a+8>>2]|0;l=k[a+12>>2]|0;if((c|0)>0){e=0;f=0;while(1){j[b+(e<<1)>>1]=j[g+(f<<1)>>1]|0;j[b+(e+1<<1)>>1]=j[h+(f<<1)>>1]|0;j[b+(e+2<<1)>>1]=j[i+(f<<1)>>1]|0;j[b+(e+3<<1)>>1]=j[l+(f<<1)>>1]|0;f=f+1|0;if((f|0)==(c|0))break;else e=e+d|0}}else return}}if((c|0)>0&(m|0)<(d|0))e=m;else return;do{h=k[a+(e<<2)>>2]|0;i=k[a+(e+1<<2)>>2]|0;l=k[a+(e+2<<2)>>2]|0;m=k[a+(e+3<<2)>>2]|0;f=e;g=0;while(1){j[b+(f<<1)>>1]=j[h+(g<<1)>>1]|0;j[b+(f+1<<1)>>1]=j[i+(g<<1)>>1]|0;j[b+(f+2<<1)>>1]=j[l+(g<<1)>>1]|0;j[b+(f+3<<1)>>1]=j[m+(g<<1)>>1]|0;g=g+1|0;if((g|0)==(c|0))break;else f=f+d|0}e=e+4|0}while((e|0)<(d|0));return}function z4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=(d|0)%4|0;l=(l|0)==0?4:l;switch(l|0){case 1:{g=k[a>>2]|0;if((c|0)>0){e=0;f=0;while(1){k[b+(f<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0;if((e|0)==(c|0))break;else f=f+d|0}}else return;break}case 2:{g=k[a>>2]|0;h=k[a+4>>2]|0;if((c|0)>0){e=0;f=0;while(1){k[b+(e<<2)>>2]=k[g+(f<<2)>>2];k[b+(e+1<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0;if((f|0)==(c|0))break;else e=e+d|0}}else return;break}case 3:{g=k[a>>2]|0;h=k[a+4>>2]|0;i=k[a+8>>2]|0;if((c|0)>0){e=0;f=0;while(1){k[b+(e<<2)>>2]=k[g+(f<<2)>>2];k[b+(e+1<<2)>>2]=k[h+(f<<2)>>2];k[b+(e+2<<2)>>2]=k[i+(f<<2)>>2];f=f+1|0;if((f|0)==(c|0))break;else e=e+d|0}}else return;break}default:{g=k[a>>2]|0;h=k[a+4>>2]|0;i=k[a+8>>2]|0;j=k[a+12>>2]|0;if((c|0)>0){e=0;f=0;while(1){k[b+(e<<2)>>2]=k[g+(f<<2)>>2];k[b+(e+1<<2)>>2]=k[h+(f<<2)>>2];k[b+(e+2<<2)>>2]=k[i+(f<<2)>>2];k[b+(e+3<<2)>>2]=k[j+(f<<2)>>2];f=f+1|0;if((f|0)==(c|0))break;else e=e+d|0}}else return}}if((c|0)>0&(l|0)<(d|0))e=l;else return;do{h=k[a+(e<<2)>>2]|0;i=k[a+(e+1<<2)>>2]|0;j=k[a+(e+2<<2)>>2]|0;l=k[a+(e+3<<2)>>2]|0;f=e;g=0;while(1){k[b+(f<<2)>>2]=k[h+(g<<2)>>2];k[b+(f+1<<2)>>2]=k[i+(g<<2)>>2];k[b+(f+2<<2)>>2]=k[j+(g<<2)>>2];k[b+(f+3<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0;if((g|0)==(c|0))break;else f=f+d|0}e=e+4|0}while((e|0)<(d|0));return}function A4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;l=(d|0)%4|0;l=(l|0)==0?4:l;switch(l|0){case 1:{g=k[a>>2]|0;if((c|0)>0){e=0;f=0;while(1){h=g+(e<<3)|0;i=k[h+4>>2]|0;j=b+(f<<3)|0;k[j>>2]=k[h>>2];k[j+4>>2]=i;e=e+1|0;if((e|0)==(c|0))break;else f=f+d|0}}else return;break}case 2:{g=k[a>>2]|0;h=k[a+4>>2]|0;if((c|0)>0){e=0;f=0;while(1){j=g+(f<<3)|0;i=k[j+4>>2]|0;m=b+(e<<3)|0;k[m>>2]=k[j>>2];k[m+4>>2]=i;m=h+(f<<3)|0;i=k[m+4>>2]|0;j=b+(e+1<<3)|0;k[j>>2]=k[m>>2];k[j+4>>2]=i;f=f+1|0;if((f|0)==(c|0))break;else e=e+d|0}}else return;break}case 3:{g=k[a>>2]|0;h=k[a+4>>2]|0;i=k[a+8>>2]|0;if((c|0)>0){e=0;f=0;while(1){n=g+(f<<3)|0;j=k[n+4>>2]|0;m=b+(e<<3)|0;k[m>>2]=k[n>>2];k[m+4>>2]=j;m=h+(f<<3)|0;j=k[m+4>>2]|0;n=b+(e+1<<3)|0;k[n>>2]=k[m>>2];k[n+4>>2]=j;n=i+(f<<3)|0;j=k[n+4>>2]|0;m=b+(e+2<<3)|0;k[m>>2]=k[n>>2];k[m+4>>2]=j;f=f+1|0;if((f|0)==(c|0))break;else e=e+d|0}}else return;break}default:{j=k[a>>2]|0;g=k[a+4>>2]|0;h=k[a+8>>2]|0;i=k[a+12>>2]|0;if((c|0)>0){e=0;f=0;while(1){n=j+(f<<3)|0;m=k[n+4>>2]|0;o=b+(e<<3)|0;k[o>>2]=k[n>>2];k[o+4>>2]=m;o=g+(f<<3)|0;m=k[o+4>>2]|0;n=b+(e+1<<3)|0;k[n>>2]=k[o>>2];k[n+4>>2]=m;n=h+(f<<3)|0;m=k[n+4>>2]|0;o=b+(e+2<<3)|0;k[o>>2]=k[n>>2];k[o+4>>2]=m;o=i+(f<<3)|0;m=k[o+4>>2]|0;n=b+(e+3<<3)|0;k[n>>2]=k[o>>2];k[n+4>>2]=m;f=f+1|0;if((f|0)==(c|0))break;else e=e+d|0}}else return}}if((c|0)>0&(l|0)<(d|0))e=l;else return;do{h=k[a+(e<<2)>>2]|0;i=k[a+(e+1<<2)>>2]|0;j=k[a+(e+2<<2)>>2]|0;l=k[a+(e+3<<2)>>2]|0;f=e;g=0;while(1){o=h+(g<<3)|0;n=k[o+4>>2]|0;m=b+(f<<3)|0;k[m>>2]=k[o>>2];k[m+4>>2]=n;m=i+(g<<3)|0;n=k[m+4>>2]|0;o=b+(f+1<<3)|0;k[o>>2]=k[m>>2];k[o+4>>2]=n;o=j+(g<<3)|0;n=k[o+4>>2]|0;m=b+(f+2<<3)|0;k[m>>2]=k[o>>2];k[m+4>>2]=n;m=l+(g<<3)|0;n=k[m+4>>2]|0;o=b+(f+3<<3)|0;k[o>>2]=k[m>>2];k[o+4>>2]=n;g=g+1|0;if((g|0)==(c|0))break;else f=f+d|0}e=e+4|0}while((e|0)<(d|0));return}function B4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=(b|0)==(a|0);i[b+12>>0]=h&1;if(h)return;while(1){f=b+8|0;h=k[f>>2]|0;d=h+12|0;if(i[d>>0]|0){c=37;break}g=h+8|0;e=k[g>>2]|0;c=k[e>>2]|0;if((c|0)==(h|0)){c=k[e+4>>2]|0;if(!c){c=8;break}c=c+12|0;if(i[c>>0]|0){c=8;break}i[d>>0]=1;i[e+12>>0]=(e|0)==(a|0)&1;i[c>>0]=1}else{if(!c){c=24;break}c=c+12|0;if(i[c>>0]|0){c=24;break}i[d>>0]=1;i[e+12>>0]=(e|0)==(a|0)&1;i[c>>0]=1}if((e|0)==(a|0)){c=37;break}else b=e}if((c|0)==8){if((k[h>>2]|0)==(b|0)){b=h;a=e}else{f=h+4|0;b=k[f>>2]|0;c=k[b>>2]|0;k[f>>2]=c;if(!c)c=e;else{k[c+8>>2]=h;c=k[g>>2]|0}d=b+8|0;k[d>>2]=c;c=k[g>>2]|0;if((k[c>>2]|0)==(h|0))k[c>>2]=b;else k[c+4>>2]=b;k[b>>2]=h;k[g>>2]=b;a=k[d>>2]|0}i[b+12>>0]=1;i[a+12>>0]=0;d=k[a>>2]|0;e=d+4|0;b=k[e>>2]|0;k[a>>2]=b;if(b|0)k[b+8>>2]=a;b=a+8|0;k[d+8>>2]=k[b>>2];c=k[b>>2]|0;if((k[c>>2]|0)==(a|0))k[c>>2]=d;else k[c+4>>2]=d;k[e>>2]=a;k[b>>2]=d;return}else if((c|0)==24){if((k[h>>2]|0)==(b|0)){d=b+4|0;c=k[d>>2]|0;k[h>>2]=c;if(!c)c=e;else{k[c+8>>2]=h;c=k[g>>2]|0}k[f>>2]=c;c=k[g>>2]|0;if((k[c>>2]|0)==(h|0))k[c>>2]=b;else k[c+4>>2]=b;k[d>>2]=h;k[g>>2]=b;e=k[f>>2]|0}else b=h;i[b+12>>0]=1;i[e+12>>0]=0;h=e+4|0;d=k[h>>2]|0;b=k[d>>2]|0;k[h>>2]=b;if(b|0)k[b+8>>2]=e;b=e+8|0;k[d+8>>2]=k[b>>2];c=k[b>>2]|0;if((k[c>>2]|0)==(e|0))k[c>>2]=d;else k[c+4>>2]=d;k[d>>2]=e;k[b>>2]=d;return}else if((c|0)==37)return}function C4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=a+32|0;if((d|0)!=(b|0)){g=i[b+11>>0]|0;f=g<<24>>24<0;lob(d,f?k[b>>2]|0:b,f?k[b+4>>2]|0:g&255)}f=a+44|0;k[f>>2]=0;g=a+48|0;c=k[g>>2]|0;if(c&8|0){b=i[d+11>>0]|0;if(b<<24>>24<0){b=k[d>>2]|0;e=b;b=b+(k[a+36>>2]|0)|0}else{e=d;b=d+(b&255)|0}k[f>>2]=b;k[a+8>>2]=e;k[a+12>>2]=e;k[a+16>>2]=b}if(!(c&16))return;c=d+11|0;b=i[c>>0]|0;if(b<<24>>24<0){e=k[a+36>>2]|0;k[f>>2]=(k[d>>2]|0)+e;b=(k[a+40>>2]&2147483647)+-1|0}else{e=b&255;k[f>>2]=d+e;b=10}oob(d,b);b=i[c>>0]|0;if(b<<24>>24<0){d=k[d>>2]|0;b=k[a+36>>2]|0}else b=b&255;c=a+24|0;k[c>>2]=d;k[a+20>>2]=d;k[a+28>>2]=d+b;if(!(k[g>>2]&3))return;k[c>>2]=d+e;return}function D4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=k[b+48>>2]|0;if(c&16|0){c=b+44|0;d=k[c>>2]|0;e=k[b+24>>2]|0;if(d>>>0<e>>>0)k[c>>2]=e;else e=d;d=k[b+20>>2]|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;g=e-d|0;if(g>>>0>4294967279)ad(426704,426733,1183,426811);if(g>>>0<11){i[a+11>>0]=g;c=a}else{f=g+16&-16;b=(f|0)==0?1:f;while(1){c=fgb(b)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[a>>2]=c;k[a+8>>2]=f|-2147483648;k[a+4>>2]=g}if((d|0)!=(e|0)){b=c;while(1){i[b>>0]=i[d>>0]|0;d=d+1|0;if((d|0)==(e|0))break;else b=b+1|0}c=c+g|0}i[c>>0]=0;return}if(!(c&8)){k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return}d=k[b+8>>2]|0;f=k[b+16>>2]|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;g=f-d|0;if(g>>>0>4294967279)ad(426704,426733,1183,426811);if(g>>>0<11){i[a+11>>0]=g;c=a}else{b=g+16&-16;e=(b|0)==0?1:b;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[a>>2]=c;k[a+8>>2]=b|-2147483648;k[a+4>>2]=g}if((d|0)!=(f|0)){e=c;while(1){i[e>>0]=i[d>>0]|0;d=d+1|0;if((d|0)==(f|0))break;else e=e+1|0}c=c+g|0}i[c>>0]=0;return}function E4(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=49464;d=a+56|0;k[d>>2]=49484;b=a+4|0;k[b>>2]=49500;c=a+36|0;if((i[c+11>>0]|0)<0)ggb(k[c>>2]|0);k[b>>2]=169272;a=k[a+8>>2]|0;b=a+4|0;c=k[b>>2]|0;k[b>>2]=c+-1;if(c|0){Tgb(d);return}Uh[k[(k[a>>2]|0)+8>>2]&2047](a);Tgb(d);return}function F4(a){a=a|0;var b=0,c=0;k[a>>2]=49500;b=a+32|0;if((i[b+11>>0]|0)<0)ggb(k[b>>2]|0);k[a>>2]=169272;a=k[a+4>>2]|0;c=a+4|0;b=k[c>>2]|0;k[c>>2]=b+-1;if(b|0)return;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);return}function G4(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=49500;b=a+32|0;if((i[b+11>>0]|0)<0)ggb(k[b>>2]|0);k[a>>2]=169272;b=k[a+4>>2]|0;d=b+4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if(c|0){ggb(a);return}Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function H4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0;g=b+44|0;h=k[g>>2]|0;m=b+24|0;n=k[m>>2]|0;j=n;if(h>>>0<n>>>0){k[g>>2]=n;l=j}else l=h;g=f&24;if(!g){n=a;k[n>>2]=0;k[n+4>>2]=0;n=a+8|0;k[n>>2]=-1;k[n+4>>2]=-1;return}if((e|0)==1&(g|0)==24){n=a;k[n>>2]=0;k[n+4>>2]=0;n=a+8|0;k[n>>2]=-1;k[n+4>>2]=-1;return}a:do switch(e|0){case 0:{g=0;h=0;break}case 1:if(!(f&8)){h=j-(k[b+20>>2]|0)|0;g=h;h=((h|0)<0)<<31>>31;break a}else{h=(k[b+12>>2]|0)-(k[b+8>>2]|0)|0;g=h;h=((h|0)<0)<<31>>31;break a}case 2:{g=b+32|0;if((i[g+11>>0]|0)<0)g=k[g>>2]|0;h=l-g|0;g=h;h=((h|0)<0)<<31>>31;break}default:{n=a;k[n>>2]=0;k[n+4>>2]=0;n=a+8|0;k[n>>2]=-1;k[n+4>>2]=-1;return}}while(0);h=kpb(g|0,h|0,c|0,d|0)|0;j=N;if((j|0)>=0){g=b+32|0;if((i[g+11>>0]|0)<0)g=k[g>>2]|0;d=l-g|0;c=((d|0)<0)<<31>>31;if(!((c|0)<(j|0)|(c|0)==(j|0)&d>>>0<h>>>0)){g=f&8;if(!((h|0)==0&(j|0)==0)){if(g|0?(k[b+12>>2]|0)==0:0){n=a;k[n>>2]=0;k[n+4>>2]=0;n=a+8|0;k[n>>2]=-1;k[n+4>>2]=-1;return}if((f&16|0)!=0&(n|0)==0){n=a;k[n>>2]=0;k[n+4>>2]=0;n=a+8|0;k[n>>2]=-1;k[n+4>>2]=-1;return}}if(g|0){k[b+12>>2]=(k[b+8>>2]|0)+h;k[b+16>>2]=l}if(f&16|0)k[m>>2]=(k[b+20>>2]|0)+h;n=a;k[n>>2]=0;k[n+4>>2]=0;n=a+8|0;k[n>>2]=h;k[n+4>>2]=j;return}}n=a;k[n>>2]=0;k[n+4>>2]=0;n=a+8|0;k[n>>2]=-1;k[n+4>>2]=-1;return}function I4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c=c+8|0;Lg[k[(k[b>>2]|0)+16>>2]&255](a,b,k[c>>2]|0,k[c+4>>2]|0,0,d);return}function J4(a){a=a|0;var b=0,c=0,d=0;b=a+44|0;d=k[b>>2]|0;c=k[a+24>>2]|0;if(d>>>0<c>>>0){k[b>>2]=c;d=c}if(!(k[a+48>>2]&8)){a=-1;return a|0}b=a+16|0;c=k[b>>2]|0;if(c>>>0<d>>>0){k[b>>2]=d;c=d}b=k[a+12>>2]|0;if(b>>>0>=c>>>0){a=-1;return a|0}a=l[b>>0]|0;return a|0}function K4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=a+44|0;c=k[d>>2]|0;e=k[a+24>>2]|0;if(c>>>0<e>>>0){k[d>>2]=e;c=e}f=a+12|0;d=k[f>>2]|0;if((k[a+8>>2]|0)>>>0>=d>>>0){b=-1;return b|0}if((b|0)==-1){k[f>>2]=d+-1;k[a+16>>2]=c;b=0;return b|0}if(!(k[a+48>>2]&16)){e=b&255;d=d+-1|0;if(e<<24>>24!=(i[d>>0]|0)){b=-1;return b|0}}else{e=b&255;d=d+-1|0}k[f>>2]=d;k[a+16>>2]=c;i[d>>0]=e;return b|0}function L4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+16|0;p=v;if((b|0)==-1){u=0;r=v;return u|0}q=a+12|0;s=a+8|0;t=(k[q>>2]|0)-(k[s>>2]|0)|0;u=a+24|0;c=k[u>>2]|0;n=a+28|0;d=k[n>>2]|0;if((c|0)==(d|0)){h=a+48|0;if(!(k[h>>2]&16)){u=-1;r=v;return u|0}m=a+20|0;l=k[m>>2]|0;j=c-l|0;o=a+44|0;l=(k[o>>2]|0)-l|0;d=a+32|0;g=d+11|0;c=i[g>>0]|0;e=c<<24>>24<0;if(e){f=k[a+36>>2]|0;c=(k[a+40>>2]&2147483647)+-1|0}else{f=c&255;c=10}if((f|0)==(c|0)){pob(d,c,1,c,c);if((i[g>>0]|0)>-1)e=11;else e=12}else if(e)e=12;else e=11;if((e|0)==11){i[g>>0]=f+1;c=d}else if((e|0)==12){c=k[d>>2]|0;k[a+36>>2]=f+1}f=c+f|0;i[f>>0]=0;i[f+1>>0]=0;if((i[g>>0]|0)<0)c=(k[a+40>>2]&2147483647)+-1|0;else c=10;oob(d,c);c=i[g>>0]|0;if(c<<24>>24<0){d=k[d>>2]|0;c=k[a+36>>2]|0}else c=c&255;g=d+c|0;k[m>>2]=d;k[n>>2]=g;j=d+j|0;k[u>>2]=j;c=d+l|0;k[o>>2]=c;l=o;e=o}else{g=a+44|0;l=g;h=a+48|0;e=g;j=c;c=k[g>>2]|0;g=d}f=j+1|0;k[p>>2]=f;d=k[(f>>>0<c>>>0?e:p)>>2]|0;k[l>>2]=d;if(k[h>>2]&8|0){c=a+32|0;if((i[c+11>>0]|0)<0)c=k[c>>2]|0;k[s>>2]=c;k[q>>2]=c+t;k[a+16>>2]=d}if((j|0)==(g|0)){u=Hh[k[(k[a>>2]|0)+52>>2]&511](a,b&255)|0;r=v;return u|0}else{k[u>>2]=f;i[j>>0]=b;u=b&255;r=v;return u|0}return 0}function M4(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=49464;d=a+56|0;k[d>>2]=49484;b=a+4|0;k[b>>2]=49500;c=a+36|0;if((i[c+11>>0]|0)<0)ggb(k[c>>2]|0);k[b>>2]=169272;b=k[a+8>>2]|0;e=b+4|0;c=k[e>>2]|0;k[e>>2]=c+-1;if(c|0){Tgb(d);ggb(a);return}Uh[k[(k[b>>2]|0)+8>>2]&2047](b);Tgb(d);ggb(a);return}function N4(a){a=a|0;var b=0,c=0,d=0;b=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;k[b>>2]=49464;c=b+56|0;k[c>>2]=49484;a=b+4|0;k[a>>2]=49500;b=b+36|0;if((i[b+11>>0]|0)<0)ggb(k[b>>2]|0);k[a>>2]=169272;a=k[a+4>>2]|0;d=a+4|0;b=k[d>>2]|0;k[d>>2]=b+-1;if(b|0){Tgb(c);return}Uh[k[(k[a>>2]|0)+8>>2]&2047](a);Tgb(c);return}function O4(a){a=a|0;var b=0,c=0,d=0,e=0;c=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;k[c>>2]=49464;d=c+56|0;k[d>>2]=49484;a=c+4|0;k[a>>2]=49500;b=c+36|0;if((i[b+11>>0]|0)<0)ggb(k[b>>2]|0);k[a>>2]=169272;a=k[a+4>>2]|0;e=a+4|0;b=k[e>>2]|0;k[e>>2]=b+-1;if(b|0){Tgb(d);ggb(c);return}Uh[k[(k[a>>2]|0)+8>>2]&2047](a);Tgb(d);ggb(c);return}function P4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>2;c=g+1|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>1;f=e>>2>>>0<536870911?(f>>>0<c>>>0?c:f):1073741823;if(!f)c=0;else{if(f>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<2)|0;k[e>>2]=k[b>>2];d=e+(0-g<<2)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+4;k[l>>2]=c+(f<<2);if(!i)return;ggb(i);return}function Q4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>2;c=g+1|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>1;f=e>>2>>>0<536870911?(f>>>0<c>>>0?c:f):1073741823;if(!f)c=0;else{if(f>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<2)|0;k[e>>2]=k[b>>2];d=e+(0-g<<2)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+4;k[l>>2]=c+(f<<2);if(!i)return;ggb(i);return}function R4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;e=r;r=r+16|0;a=e;b=a+4|0;c=ZT(52)|0;k[c>>2]=1;d=c+4|0;k[a>>2]=d;k[b>>2]=46;i[c+50>>0]=0;f=221205;g=d+46|0;do{i[d>>0]=i[f>>0]|0;d=d+1|0;f=f+1|0}while((d|0)<(g|0));Y8(-218,a,221252,221265,60);k[b>>2]=0;k[a>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)!=1){r=e;return}ggb(k[c+-4>>2]|0);r=e;return}function S4(a){a=a|0;return}function T4(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;k[a>>2]=49564;e=a+20|0;f=a+24|0;c=k[f>>2]|0;if((c|0)==(k[e>>2]|0)){b=c;if(b|0)d=6}else{d=a+8|0;do{_4(k[d>>2]|0);c=(k[f>>2]|0)+-1|0;k[f>>2]=c;b=c}while((b|0)!=(k[e>>2]|0));d=6}if((d|0)==6){if((c|0)!=(b|0))k[f>>2]=b;ggb(b)}f=a+12|0;b=k[f>>2]|0;k[a+16>>2]=0;k[f>>2]=0;if(b|0?(e=b+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[b+-8>>2]|0);b=a+4|0;c=k[b>>2]|0;if(!c){k[b>>2]=0;a=a+8|0;k[a>>2]=0;return}e=c+4|0;f=k[e>>2]|0;k[e>>2]=f+-1;if((f|0)!=1){k[b>>2]=0;a=a+8|0;k[a>>2]=0;return}Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;a=a+8|0;k[a>>2]=0;return}function U4(a){a=a|0;T4(a);ggb(a);return}function V4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;Uh[k[(k[a>>2]|0)+16>>2]&2047](a);f=a+4|0;e=k[b>>2]|0;if(!(k[d+4>>2]|0))b=0;else{b=k[d>>2]|0;b=(b|0)==0?1016759:b}e=a5((e|0)==0?1016759:e,c,b)|0;if(!e)b=0;else{while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b+4>>2]=1;k[b>>2]=49596;k[b+8>>2]=e}d=k[f>>2]|0;k[f>>2]=b;k[a+8>>2]=e;if(d|0?(c=d+4|0,f=k[c>>2]|0,k[c>>2]=f+-1,(f|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);f=Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0;k[a+32>>2]=f?6:0;return f|0}function W4(a){a=a|0;a=k[a+8>>2]|0;if(!a){a=0;return a|0}a=(i[a+272>>0]|0)!=0;return a|0}function X4(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+4|0;c=k[b>>2]|0;if(c|0?(e=c+4|0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+8>>2]=0;b=k[a+20>>2]|0;c=a+24|0;if((k[c>>2]|0)==(b|0)){e=a+32|0;k[e>>2]=0;return}k[c>>2]=b;e=a+32|0;k[e>>2]=0;return}function Y4(a,b){a=a|0;b=b|0;var c=0;k[a>>2]=0;k[a+4>>2]=0;c=k[b+8>>2]|0;if(c|0?k[c+268>>2]|0:0)Z4(c,a);Uh[k[(k[b>>2]|0)+16>>2]&2047](b);return}function Z4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;h=n;m=(b|0)!=0;if((m?(c=k[b>>2]|0,k[b+4>>2]=0,k[b>>2]=0,c|0):0)?(j=c+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[c+-8>>2]|0);if(!a){c=h+4|0;d=ZT(40)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=35;i[d+39>>0]=0;f=221809;g=e+35|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-27,h,221845,221854,519);k[c>>2]=0;k[h>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}l=a+272|0;if(i[l>>0]|0){j=a+64|0;do if(k[a+8>>2]|0){if(((k[j>>2]|0)==0?(k[a+68>>2]|0)==0:0)?(k[a+268>>2]|0)==0:0)break;c=a+36|0;h=k[c>>2]|0;if(h|0?(k[h+24>>2]|0)>0:0)do _4(a);while((k[(k[c>>2]|0)+24>>2]|0)>0);h=a+72|0;c=k[h>>2]|0;f=a+76|0;d=k[f>>2]|0;g=a+56|0;e=k[g>>2]|0;if(c>>>0>(d+e|0)>>>0){i[c>>0]=10;i[c+1>>0]=0;$4(a,k[f>>2]|0);d=k[f>>2]|0;k[h>>2]=d;e=k[g>>2]|0}c=k[a+40>>2]|0;if((c|0)==(e|0))c=e;else{if((c|0)>(e|0)){zpb(d+e|0,32,c-e|0)|0;d=k[f>>2]|0}k[g>>2]=c}k[h>>2]=d+c;if((k[a+4>>2]|0)==8)$4(a,221924)}while(0);c=k[j>>2]|0;if(!c){c=a+68|0;d=k[c>>2]|0;if(d)Ieb(d)}else{Qfb(c)|0;c=a+68|0}k[j>>2]=0;k[c>>2]=0;k[a+256>>2]=0;k[a+264>>2]=0;i[l>>0]=0}c=k[a+268>>2]|0;if(!(m&(c|0)!=0)){r=n;return}d=k[c+4>>2]|0;e=k[c+16>>2]|0;l=d+(e>>>12<<2)|0;f=k[c+20>>2]|0;if((k[c+8>>2]|0)==(d|0)){j=0;m=0;c=d+((e+f|0)>>>12<<2)|0}else{m=e+f|0;c=d+(m>>>12<<2)|0;j=(k[l>>2]|0)+(e&4095)|0;m=(k[c>>2]|0)+(m&4095)|0}h=j;if((m|0)==(h|0)){g=ZT(8)|0;k[g>>2]=1;g=g+4|0;i[g>>0]=0;d=0}else{d=(c-l<<10)-j+m-(k[c>>2]|0)+(k[l>>2]|0)|0;g=ZT(d+8&-4)|0;k[g>>2]=1;g=g+4|0;i[g+d>>0]=0;a=g;f=l;e=j;c=h;while(1){i[a>>0]=i[c>>0]|0;c=e+1|0;e=c;if((e-(k[f>>2]|0)|0)==4096){f=f+4|0;c=k[f>>2]|0;e=c}if((c|0)==(m|0))break;else a=a+1|0}}c=g;e=k[b>>2]|0;f=b+4|0;k[f>>2]=0;k[b>>2]=0;if(e|0?(a=e+-4|0,m=k[a>>2]|0,k[a>>2]=m+-1,(m|0)==1):0)ggb(k[e+-8>>2]|0);m=g+-4|0;k[m>>2]=(k[m>>2]|0)+1;k[b>>2]=c;k[f>>2]=d;m=g+-4|0;b=k[m>>2]|0;k[m>>2]=b+-1;if((b|0)!=1){r=n;return}ggb(k[g+-8>>2]|0);r=n;return}function _4(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;h=j;b=(a|0)!=0;if(!(b?(k[a>>2]|0)==1280131417:0)){b=b?-5:-27;c=h+4|0;d=ZT(36)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=31;i[d+35>>0]=0;f=221977;g=e+31|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(b,h,222009,221854,2941);k[c>>2]=0;k[h>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0)}if(k[a+8>>2]|0){h=a+232|0;h=k[h>>2]|0;Uh[h&2047](a);r=j;return}b=h+4|0;c=ZT(44)|0;k[c>>2]=1;e=c+4|0;k[h>>2]=e;k[b>>2]=38;i[c+42>>0]=0;f=222026;g=e+38|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-2,h,222009,221854,2941);k[b>>2]=0;k[h>>2]=0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0);h=a+232|0;h=k[h>>2]|0;Uh[h&2047](a);r=j;return}function $4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+16|0;h=w;v=k[a+268>>2]|0;if(!v){l=k[a+64>>2]|0;if(l|0){a=b;a:do if(!(a&3)){e=b;j=135}else{c=b;d=a;while(1){if(!(i[c>>0]|0)){f=d;break a}c=c+1|0;d=c;if(!(d&3)){e=c;j=135;break}}}while(0);if((j|0)==135){c=e;while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0);f=c}f=f-a|0;a=l+16|0;c=k[a>>2]|0;d=(c|0)==0;if((k[l+76>>2]|0)>-1){do if(d){c=l+74|0;v=i[c>>0]|0;i[c>>0]=v+255|v;c=k[l>>2]|0;if(!(c&8)){k[l+8>>2]=0;k[l+4>>2]=0;v=k[l+44>>2]|0;k[l+28>>2]=v;e=l+20|0;k[e>>2]=v;d=v+(k[l+48>>2]|0)|0;k[a>>2]=d;a=v;break}k[l>>2]=c|32;r=w;return}else{a=l+20|0;d=c;e=a;a=k[a>>2]|0}while(0);c=a;if((d-a|0)>>>0<f>>>0){ci[k[l+36>>2]&255](l,b,f)|0;r=w;return}b:do if((i[l+75>>0]|0)>-1){a=f;while(1){if(!a){d=f;break b}d=a+-1|0;if((i[b+d>>0]|0)==10)break;else a=d}if((ci[k[l+36>>2]&255](l,b,a)|0)>>>0<a>>>0){r=w;return}else{d=f-a|0;b=b+a|0;c=k[e>>2]|0;break}}else d=f;while(0);upb(c|0,b|0,d|0)|0;k[e>>2]=(k[e>>2]|0)+d;r=w;return}else{do if(d){c=l+74|0;v=i[c>>0]|0;i[c>>0]=v+255|v;c=k[l>>2]|0;if(!(c&8)){k[l+8>>2]=0;k[l+4>>2]=0;v=k[l+44>>2]|0;k[l+28>>2]=v;e=l+20|0;k[e>>2]=v;d=v+(k[l+48>>2]|0)|0;k[a>>2]=d;a=v;break}k[l>>2]=c|32;r=w;return}else{a=l+20|0;d=c;e=a;a=k[a>>2]|0}while(0);c=a;if((d-a|0)>>>0<f>>>0){ci[k[l+36>>2]&255](l,b,f)|0;r=w;return}c:do if((i[l+75>>0]|0)>-1){a=f;while(1){if(!a){d=f;break c}d=a+-1|0;if((i[b+d>>0]|0)==10)break;else a=d}if((ci[k[l+36>>2]&255](l,b,a)|0)>>>0<a>>>0){r=w;return}else{d=f-a|0;b=b+a|0;c=k[e>>2]|0;break}}else d=f;while(0);upb(c|0,b|0,d|0)|0;k[e>>2]=(k[e>>2]|0)+d;r=w;return}}q=k[a+68>>2]|0;if(!q){c=h+4|0;b=ZT(32)|0;k[b>>2]=1;d=b+4|0;k[h>>2]=d;k[c>>2]=25;i[b+29>>0]=0;a=221943;e=d+25|0;do{i[d>>0]=i[a>>0]|0;d=d+1|0;a=a+1|0}while((d|0)<(e|0));Y8(-2,h,221969,221854,256);k[c>>2]=0;k[h>>2]=0;v=k[b>>2]|0;k[b>>2]=v+-1;if((v|0)==1)ggb(k[b+-4>>2]|0);r=w;return}f=b;d:do if(!(f&3)){d=b;j=171}else{a=b;e=f;while(1){if(!(i[a>>0]|0)){g=e;break d}a=a+1|0;e=a;if(!(e&3)){d=a;j=171;break}}}while(0);if((j|0)==171){while(1){a=k[d>>2]|0;if(!((a&-2139062144^-2139062144)&a+-16843009))d=d+4|0;else break}if((a&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0);g=d}n=g-f|0;o=q+84|0;if((k[q+12>>2]|0)!=31153){r=w;return}if(k[q+76>>2]|0){r=w;return}if((n|0)<0){Jeb(q,-3,418660);r=w;return}if(!n){r=w;return}p=q+24|0;if((k[p>>2]|0)==0?(Leb(q)|0)==-1:0){r=w;return}d=q+72|0;e:do if(k[d>>2]|0){k[d>>2]=0;d=k[q+68>>2]|0;f=q+88|0;if(k[f>>2]|0?(Meb(q,0)|0)==-1:0){r=w;return}if(d){g=q+32|0;h=q+84|0;j=q+8|0;a=0;while(1){e=k[p>>2]|0;e=(e|0)<0|(e|0)>(d|0)?d:e;if(!a)zpb(k[g>>2]|0,0,e|0)|0;k[f>>2]=e;k[h>>2]=k[g>>2];k[j>>2]=(k[j>>2]|0)+e;d=d-e|0;if((Meb(q,0)|0)==-1)break;if(!d)break e;else a=1}r=w;return}}else f=q+88|0;while(0);if((k[p>>2]|0)>>>0<=n>>>0){if(k[f>>2]|0?(Meb(q,0)|0)==-1:0){r=w;return}k[f>>2]=n;k[o>>2]=b;v=q+8|0;k[v>>2]=(k[v>>2]|0)+n;Meb(q,0)|0;r=w;return}l=q+32|0;m=q+8|0;j=b;g=n;while(1){d=k[f>>2]|0;if(!d){e=k[l>>2]|0;k[o>>2]=e;h=e;a=h}else{h=k[l>>2]|0;a=k[o>>2]|0;e=h}u=a+d-e|0;d=(k[p>>2]|0)-u|0;d=d>>>0>g>>>0?g:d;upb(h+u|0,j|0,d|0)|0;k[f>>2]=d+(k[f>>2]|0);k[m>>2]=(k[m>>2]|0)+d;g=g-d|0;if(!g){j=206;break}if((Meb(q,0)|0)==-1){j=206;break}else j=j+d|0}if((j|0)==206){r=w;return}}e=b;f:do if(!(e&3)){c=b;j=5}else{d=b;a=e;while(1){if(!(i[d>>0]|0)){s=a;break f}d=d+1|0;a=d;if(!(a&3)){c=d;j=5;break}}}while(0);if((j|0)==5){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0);s=c}u=s-e|0;p=b+u|0;if(!u){r=w;return}o=v+20|0;q=v+8|0;s=v+4|0;t=v+16|0;u=v+12|0;d=k[o>>2]|0;g:while(1){c=k[q>>2]|0;h=k[s>>2]|0;l=c-h|0;a=k[t>>2]|0;m=h;n=c;if((((l|0)==0?0:(l<<10)+-1|0)|0)==(a+d|0)){do if(a>>>0>4095){k[t>>2]=a+-4096;l=k[h>>2]|0;j=m+4|0;k[s>>2]=j;m=k[u>>2]|0;e=m;d=c;do if((n|0)==(m|0)){d=k[v>>2]|0;a=d;if(j>>>0>d>>>0){d=j;a=((d-a>>2)+1|0)/-2|0;e=j+(a<<2)|0;c=c-d|0;d=c>>2;if(!d)c=j;else{wpb(e|0,j|0,c|0)|0;c=k[s>>2]|0}n=e+(d<<2)|0;k[q>>2]=n;k[s>>2]=c+(a<<2);c=n;break}f=e-a>>1;f=(f|0)==0?1:f;if(f>>>0>1073741823){j=20;break g}e=f>>>2;a=f<<2;a=(a|0)==0?1:a;while(1){c=fgb(a)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}h=c;a=c+(e<<2)|0;g=a;e=c+(f<<2)|0;if((j|0)==(n|0))c=g;else{c=g;d=j;do{k[a>>2]=k[d>>2];a=c+4|0;c=a;d=d+4|0}while((d|0)!=(n|0));d=k[v>>2]|0}k[v>>2]=h;k[s>>2]=g;k[q>>2]=c;k[u>>2]=e;if(d){ggb(d);c=k[q>>2]|0}}else c=d;while(0);k[c>>2]=l;k[q>>2]=(k[q>>2]|0)+4}else{a=k[u>>2]|0;e=k[v>>2]|0;f=a-e|0;g=a;d=e;if(l>>>0>=f>>>0){j=f>>1;j=(j|0)==0?1:j;if(j>>>0>1073741823){j=90;break g}f=l>>2;d=j<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=c;a=c+(f<<2)|0;g=a;h=c+(j<<2)|0;while(1){d=fgb(4096)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}l=d;do if((f|0)==(j|0)){if(a>>>0>c>>>0){g=a+((((g-e>>2)+1|0)/-2|0)<<2)|0;a=g;c=h;break}f=h-e>>1;f=(f|0)==0?1:f;if(f>>>0>1073741823){j=103;break g}a=f<<2;a=(a|0)==0?1:a;while(1){d=fgb(a)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}g=d+(f>>>2<<2)|0;ggb(c);a=g;e=d;c=d+(f<<2)|0}else c=h;while(0);k[a>>2]=l;d=k[q>>2]|0;h=g;g=g+4|0;f=c;while(1){if((d|0)==(k[s>>2]|0))break;n=d+-4|0;c=h;do if((c|0)==(e|0)){m=g;if(m>>>0<f>>>0){a=m+((((f-g>>2)+1|0)/2|0)<<2)|0;c=g-h|0;m=c>>2;d=a+(0-m<<2)|0;if(!m)d=a;else wpb(d|0,h|0,c|0)|0;h=d;c=d;break}g=f-e>>1;g=(g|0)==0?1:g;if(g>>>0>1073741823){j=117;break g}f=(g+3|0)>>>2;a=g<<2;a=(a|0)==0?1:a;while(1){d=fgb(a)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d;l=d+(f<<2)|0;j=l;f=d+(g<<2)|0;if((c|0)==(m|0))c=j;else{a=l;d=j;do{k[a>>2]=k[c>>2];a=d+4|0;d=a;c=c+4|0}while((c|0)!=(m|0));c=d}if(!h){h=j;a=c;c=l}else{ggb(h);h=j;a=c;c=l}}else a=g;while(0);k[c+-4>>2]=k[n>>2];d=n;h=h+-4|0;g=a}c=k[v>>2]|0;k[v>>2]=e;k[s>>2]=h;k[q>>2]=g;k[u>>2]=f;if(!c)break;ggb(c);break}if((a|0)!=(c|0)){while(1){a=fgb(4096)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}j=a;do if((n|0)==(g|0)){if(m>>>0>d>>>0){d=((h-e>>2)+1|0)/-2|0;a=m+(d<<2)|0;e=l>>2;if(!e)c=m;else{wpb(a|0,h|0,l|0)|0;c=k[s>>2]|0}n=a+(e<<2)|0;k[q>>2]=n;k[s>>2]=c+(d<<2);c=n;break}f=f>>1;f=(f|0)==0?1:f;if(f>>>0>1073741823){j=42;break g}e=f>>>2;a=f<<2;a=(a|0)==0?1:a;while(1){c=fgb(a)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}h=c;a=c+(e<<2)|0;g=a;e=c+(f<<2)|0;if((m|0)==(n|0))c=g;else{c=g;d=m;do{k[a>>2]=k[d>>2];a=c+4|0;c=a;d=d+4|0}while((d|0)!=(n|0));d=k[v>>2]|0}k[v>>2]=h;k[s>>2]=g;k[q>>2]=c;k[u>>2]=e;if(d){ggb(d);c=k[q>>2]|0}}while(0);k[c>>2]=j;k[q>>2]=(k[q>>2]|0)+4;break}while(1){c=fgb(4096)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}m=k[s>>2]|0;n=k[v>>2]|0;e=n;do if((m|0)==(n|0)){a=k[q>>2]|0;n=k[u>>2]|0;d=n;if(a>>>0<n>>>0){e=a;g=((d-e>>2)+1|0)/2|0;d=a+(g<<2)|0;e=e-m|0;n=e>>2;f=d+(0-n<<2)|0;if(n){wpb(f|0,m|0,e|0)|0;d=f;a=k[q>>2]|0}k[s>>2]=d;k[q>>2]=a+(g<<2);break}g=d-e>>1;g=(g|0)==0?1:g;if(g>>>0>1073741823){j=62;break g}f=(g+3|0)>>>2;e=g<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0){e=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){e=0;break}Qh[d&7]()}l=e;d=e+(f<<2)|0;j=d;h=e+(g<<2)|0;if((m|0)==(a|0)){e=j;a=m}else{g=d;e=j;f=m;do{k[g>>2]=k[f>>2];g=e+4|0;e=g;f=f+4|0}while((f|0)!=(a|0));a=k[v>>2]|0}k[v>>2]=l;k[s>>2]=j;k[q>>2]=e;k[u>>2]=h;if(a){ggb(a);d=k[s>>2]|0}}else d=m;while(0);k[d+-4>>2]=c;l=k[s>>2]|0;m=l+-4|0;k[s>>2]=m;m=k[m>>2]|0;k[s>>2]=l;j=k[q>>2]|0;n=k[u>>2]|0;c=n;f=j;do if((j|0)==(n|0)){d=k[v>>2]|0;a=d;if(l>>>0>d>>>0){c=l;a=((c-a>>2)+1|0)/-2|0;e=l+(a<<2)|0;c=f-c|0;d=c>>2;if(!d)c=l;else{wpb(e|0,l|0,c|0)|0;c=k[s>>2]|0}n=e+(d<<2)|0;k[q>>2]=n;k[s>>2]=c+(a<<2);c=n;break}f=c-a>>1;f=(f|0)==0?1:f;if(f>>>0>1073741823){j=78;break g}e=f>>>2;a=f<<2;a=(a|0)==0?1:a;while(1){c=fgb(a)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}h=c;a=c+(e<<2)|0;g=a;e=c+(f<<2)|0;if((l|0)==(j|0))c=g;else{c=g;d=l;do{k[a>>2]=k[d>>2];a=c+4|0;c=a;d=d+4|0}while((d|0)!=(j|0));d=k[v>>2]|0}k[v>>2]=h;k[s>>2]=g;k[q>>2]=c;k[u>>2]=e;if(d){ggb(d);c=k[q>>2]|0}}else c=j;while(0);k[c>>2]=m;k[q>>2]=(k[q>>2]|0)+4}while(0);a=k[t>>2]|0;d=k[o>>2]|0;c=k[s>>2]|0}else c=m;d=d+a|0;i[(k[c+(d>>>12<<2)>>2]|0)+(d&4095)>>0]=i[b>>0]|0;d=(k[o>>2]|0)+1|0;k[o>>2]=d;b=b+1|0;if((b|0)==(p|0)){j=206;break}}if((j|0)==20){w=te(4)|0;k[w>>2]=172664;Cf(w|0,28816,1287)}else if((j|0)==42){w=te(4)|0;k[w>>2]=172664;Cf(w|0,28816,1287)}else if((j|0)==62){w=te(4)|0;k[w>>2]=172664;Cf(w|0,28816,1287)}else if((j|0)==78){w=te(4)|0;k[w>>2]=172664;Cf(w|0,28816,1287)}else if((j|0)==90){w=te(4)|0;k[w>>2]=172664;Cf(w|0,28816,1287)}else if((j|0)==103){w=te(4)|0;k[w>>2]=172664;Cf(w|0,28816,1287)}else if((j|0)==117){w=te(4)|0;k[w>>2]=172664;Cf(w|0,28816,1287)}else if((j|0)==206){r=w;return}}function a5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1360|0;X=$+200|0;W=$+184|0;V=$+168|0;U=$+152|0;T=$+136|0;S=$+120|0;Q=$+104|0;P=$+88|0;J=$+72|0;D=$+48|0;R=$+40|0;w=$+16|0;x=$+8|0;v=$;Z=$+232|0;L=$+228|0;M=$+224|0;N=$+220|0;O=$+216|0;_=$+212|0;e=$+1336|0;k[_>>2]=0;n=b&3;G=(n|0)==2;h=b>>>2;n=(n|0)!=0;A=(a|0)!=0;if(A?(f=i[a>>0]|0,f<<24>>24!=0):0){j=a;a:do if(!(j&3)){d=a;Y=11}else{g=a;d=j;while(1){if(!(f<<24>>24))break a;f=g+1|0;d=f;if(!(d&3)){d=f;Y=11;break a}g=f;f=i[f>>0]|0}}while(0);if((Y|0)==11){while(1){f=k[d>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))d=d+4|0;else break}if((f&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}y=(h&1|0)!=0;g=d-j|0}else if(n){y=1;g=0}else{u=h&1;F=Z+4|0;y=u<<1|20;d=ZT(28)|0;k[d>>2]=1;t=d+4|0;k[Z>>2]=t;k[F>>2]=y;i[t+y>>0]=0;upb(t|0,(u|0?222134:222157)|0,y|0)|0;Y8(-27,Z,222178,221854,2664);k[F>>2]=0;k[Z>>2]=0;F=k[d>>2]|0;k[d>>2]=F+-1;if((F|0)==1)ggb(k[d+-4>>2]|0);y=1;g=0}F=G^1;if(!(F|y^1)){d=Z+4|0;f=ZT(76)|0;k[f>>2]=1;j=f+4|0;k[Z>>2]=j;k[d>>2]=68;i[f+72>>0]=0;l=222196;m=j+68|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-206,Z,222178,221854,2671);k[d>>2]=0;k[Z>>2]=0;u=k[f>>2]|0;k[f>>2]=u+-1;if((u|0)==1)ggb(k[f+-4>>2]|0)}f=ZT(276)|0;k[_>>2]=f;zpb(f|0,0,276)|0;f=zY(262144)|0;d=k[_>>2]|0;k[d+16>>2]=f;k[d+20>>2]=f;k[d>>2]=1280131417;k[d+8>>2]=n&1;b:do if(!y){d=FY(f,g+1|0)|0;k[(k[_>>2]|0)+60>>2]=d;f=a;c:do if(!((f^d)&3)){if(!(f&3))f=a;else{f=a;do{u=i[f>>0]|0;i[d>>0]=u;if(!(u<<24>>24))break c;f=f+1|0;d=d+1|0}while((f&3|0)!=0)}h=k[f>>2]|0;if(!((h&-2139062144^-2139062144)&h+-16843009))while(1){f=f+4|0;j=d+4|0;k[d>>2]=h;h=k[f>>2]|0;if((h&-2139062144^-2139062144)&h+-16843009|0){d=j;break}else d=j}p=f;o=d;Y=29}else{p=a;o=d;Y=29}while(0);if((Y|0)==29?(u=i[p>>0]|0,i[o>>0]=u,u<<24>>24):0){f=o;d=p;do{d=d+1|0;f=f+1|0;u=i[d>>0]|0;i[f>>0]=u}while(u<<24>>24!=0)}j=k[_>>2]|0;l=k[j+60>>2]|0;h=l;d:do if(!(h&3)){d=l;Y=34}else{f=l;d=h;while(1){if(!(i[f>>0]|0))break d;f=f+1|0;d=f;if(!(d&3)){d=f;Y=34;break}}}while(0);if((Y|0)==34){while(1){f=k[d>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))d=d+4|0;else break}if((f&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}d=d-h+1|0;while(1){if(!d)break;d=d+-1|0;q=l+d|0;if((i[q>>0]|0)==46){Y=42;break}}do if((((Y|0)==42?q|0:0)?(i[q+1>>0]|0)==103:0)?(i[q+2>>0]|0)==122:0){h=q+3|0;d=i[h>>0]|0;if(d<<24>>24){if((d+-48&255)>=10)break;if(i[q+4>>0]|0)break}if(G){d5(_);d=Z+4|0;f=ZT(60)|0;k[f>>2]=1;j=f+4|0;k[Z>>2]=j;k[d>>2]=52;i[f+56>>0]=0;l=222265;m=j+52|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-213,Z,222178,221854,2696);k[d>>2]=0;k[Z>>2]=0;u=k[f>>2]|0;k[f>>2]=u+-1;if((u|0)==1)ggb(k[f+-4>>2]|0);d=i[h>>0]|0}if(!(d<<24>>24))d=0;else{i[h>>0]=0;g=g+-1|0}s=k[_>>2]|0;f=k[s+8>>2]|0?119:114;i[Z>>0]=f;i[Z+1>>0]=98;i[Z+2>>0]=d<<24>>24?d:51;i[Z+3>>0]=0;s=k[s+60>>2]|0;e:do if(s|0?(z=fgb(140)|0,z|0):0){k[z+24>>2]=0;k[z+28>>2]=8192;u=z+80|0;k[u>>2]=0;t=z+12|0;k[t>>2]=0;o=z+60|0;k[o>>2]=-1;p=z+64|0;k[p>>2]=0;q=z+40|0;k[q>>2]=0;l=0;n=Z;j=0;m=0;h=0;f:while(1){d=f<<24>>24;g:do if((f+-48&255)<10){k[o>>2]=d+-48;d=m}else do switch(d|0){case 43:{Y=64;break f}case 114:{k[t>>2]=7247;h=7247;d=m;break g}case 119:{k[t>>2]=31153;h=31153;d=m;break g}case 97:{k[t>>2]=1;h=1;d=m;break g}case 84:{k[q>>2]=1;d=1;break g}case 101:{l=1;d=m;break g}case 120:{j=1;d=m;break g}case 102:{k[p>>2]=1;d=m;break g}case 104:{k[p>>2]=2;d=m;break g}case 82:{k[p>>2]=3;d=m;break g}case 70:{k[p>>2]=4;d=m;break g}default:{d=m;break g}}while(0);while(0);n=n+1|0;f=i[n>>0]|0;if(!(f<<24>>24))break;else m=d}if((Y|0)==64){ggb(z);break}h:do if((h|0)>=7247){switch(h|0){case 7247:break;default:break h}if(!d){k[q>>2]=1;break}else{ggb(z);break e}}else{switch(h|0){case 0:break;default:break h}ggb(z);break e}while(0);h=s;i:do if(!(h&3)){d=s;Y=81}else{f=s;d=h;while(1){if(!(i[f>>0]|0))break i;f=f+1|0;d=f;if(!(d&3)){d=f;Y=81;break}}}while(0);if((Y|0)==81){while(1){f=k[d>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))d=d+4|0;else break}if((f&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}d=d-h+1|0;f=fgb(d)|0;h=z+20|0;k[h>>2]=f;if(!f){ggb(z);break}k[v>>2]=s;kfb(f,d,418563,v)|0;d=k[t>>2]|0;if((d|0)==7247)d=0;else d=((d|0)==31153?512:1024)|(j|0?193:65);k[x>>2]=438;f=yfb(s,d|(l|0?557056:32768),x)|0;k[z+16>>2]=f;if((f|0)==-1){ggb(k[h>>2]|0);ggb(z);break}d=k[t>>2]|0;j:do if((d|0)<7247){switch(d|0){case 1:break;default:{Y=94;break j}}k[t>>2]=31153;Y=94}else{switch(d|0){case 7247:break;default:{Y=94;break j}}k[w>>2]=f;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=x;k[w+16>>2]=1;d=zd(140,w|0)|0;if(d>>>0>4294963200){if(!(k[206783]|0))f=827176;else{f=(Fpb()|0)+64|0;f=k[f>>2]|0}k[f>>2]=0-d;d=-1}x=d|0?-1:k[x>>2]|0;k[z+48>>2]=(x|0)==-1?0:x;x=k[t>>2]|0;k[z>>2]=0;if((x|0)!=7247)break;k[z+52>>2]=0;k[z+56>>2]=0;k[z+44>>2]=0}while(0);if((Y|0)==94)k[z>>2]=0;k[z+72>>2]=0;f=k[u>>2]|0;d=z+76|0;if(f|0){if((k[d>>2]|0)!=-4)ggb(f);k[u>>2]=0}k[d>>2]=0;k[z+8>>2]=0;k[z+88>>2]=0;d=k[_>>2]|0;k[d+68>>2]=z;h=1;Y=107;break b}while(0);d=k[_>>2]|0;k[d+68>>2]=0;break b}while(0);z=Ufb(l,(k[j+8>>2]|0)==0?222325:G?222318:222322)|0;d=k[_>>2]|0;k[d+64>>2]=z;if(z){h=0;Y=107}}else{h=0;Y=107}while(0);if((Y|0)==107){k[d+32>>2]=0;k[d+40>>2]=0;k[d+44>>2]=0;k[d+84>>2]=71;do if(!(k[d+8>>2]|0)){if(y){k[d+256>>2]=a;k[d+260>>2]=g}e5(d,e,14)|0;d=i[e>>0]|0;k:do if(!(d<<24>>24)){f=222623;d=0}else{g=6;f=222623;while(1){g=g+-1|0;R=i[f>>0]|0;if(!(d<<24>>24==R<<24>>24&((g|0)!=0&R<<24>>24!=0)))break k;e=e+1|0;f=f+1|0;d=i[e>>0]|0;if(!(d<<24>>24)){d=0;break}}}while(0);e=k[_>>2]|0;k[e+4>>2]=d<<24>>24==(i[f>>0]|0)?16:8;if(h)j=1048576;else{if(y)d=k[e+260>>2]|0;else{d=k[e+64>>2]|0;e=d+20|0;f=d+28|0;g=(k[e>>2]|0)>>>0>(k[f>>2]|0)>>>0;do if((k[d+76>>2]|0)>-1){if(g?(ci[k[d+36>>2]&255](d,0,0)|0,(k[e>>2]|0)==0):0)break;k[d+16>>2]=0;k[f>>2]=0;k[e>>2]=0;if((ci[k[d+40>>2]&255](d,0,2)|0)>=0){k[d+8>>2]=0;k[d+4>>2]=0;k[d>>2]=k[d>>2]&-17}}else{if(g?(ci[k[d+36>>2]&255](d,0,0)|0,(k[e>>2]|0)==0):0)break;k[d+16>>2]=0;k[f>>2]=0;k[e>>2]=0;if((ci[k[d+40>>2]&255](d,0,2)|0)>=0){k[d+8>>2]=0;k[d+4>>2]=0;k[d>>2]=k[d>>2]&-17}}while(0);f=k[(k[_>>2]|0)+64>>2]|0;e=k[f+40>>2]|0;d=(k[f>>2]&128|0)==0;if((k[f+76>>2]|0)>-1){if(d)d=1;else d=(k[f+20>>2]|0)>>>0>(k[f+28>>2]|0)>>>0?2:1;d=ci[e&255](f,0,d)|0;if((d|0)>=0)d=d-(k[f+8>>2]|0)+(k[f+4>>2]|0)+(k[f+20>>2]|0)-(k[f+28>>2]|0)|0}else{if(d)d=1;else d=(k[f+20>>2]|0)>>>0>(k[f+28>>2]|0)>>>0?2:1;d=ci[e&255](f,0,d)|0;if((d|0)>=0)d=d-(k[f+8>>2]|0)+(k[f+4>>2]|0)+(k[f+20>>2]|0)-(k[f+28>>2]|0)|0}e=k[_>>2]|0}j=d>>>0>1048576?1048576:d;j=j>>>0<9216?9216:j}h=k[e+64>>2]|0;l:do if(!h){g=k[e+68>>2]|0;if(g|0?(E=g+12|0,(k[E>>2]|0)==7247):0){h=g+76|0;switch(k[h>>2]|0){case -5:case 0:break;default:break l}f=k[g+48>>2]|0;k[D>>2]=k[g+16>>2];k[D+4>>2]=0;k[D+8>>2]=f;k[D+12>>2]=Z;k[D+16>>2]=0;f=zd(140,D|0)|0;if(f>>>0>4294963200){if(!(k[206783]|0))d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}k[d>>2]=0-f;break}if(!((f|0)!=0|(k[Z>>2]|0)==-1)){k[g>>2]=0;if((k[E>>2]|0)==7247){k[g+52>>2]=0;k[g+56>>2]=0;k[g+44>>2]=0}k[g+72>>2]=0;d=g+80|0;f=k[d>>2]|0;if(f|0){if((k[h>>2]|0)!=-4)ggb(f);k[d>>2]=0}k[h>>2]=0;k[g+8>>2]=0;k[g+88>>2]=0}}}else{d=h+20|0;f=h+28|0;g=(k[d>>2]|0)>>>0>(k[f>>2]|0)>>>0;if((k[h+76>>2]|0)>-1){if(!(g?(ci[k[h+36>>2]&255](h,0,0)|0,!(k[d>>2]|0)):0))Y=279;if((Y|0)==279?(k[h+16>>2]=0,k[f>>2]=0,k[d>>2]=0,(ci[k[h+40>>2]&255](h,0,0)|0)>=0):0){k[h+8>>2]=0;k[h+4>>2]=0;k[h>>2]=k[h>>2]&-17}k[h>>2]=k[h>>2]&-33;break}else{if(!(g?(ci[k[h+36>>2]&255](h,0,0)|0,!(k[d>>2]|0)):0))Y=284;if((Y|0)==284?(k[h+16>>2]=0,k[f>>2]=0,k[d>>2]=0,(ci[k[h+40>>2]&255](h,0,0)|0)>=0):0){k[h+8>>2]=0;k[h+4>>2]=0;k[h>>2]=k[h>>2]&-17}k[h>>2]=k[h>>2]&-33;break}}while(0);k[e+264>>2]=0;q=k[(k[_>>2]|0)+16>>2]|0;d=WY(0,72,16,q)|0;k[d+64>>2]=256;q=FY(q,1024)|0;k[d+68>>2]=q;zpb(q|0,0,1024)|0;q=k[_>>2]|0;k[q+28>>2]=d;q=HY(0,56,16,k[q+16>>2]|0)|0;k[(k[_>>2]|0)+32>>2]=q;q=ZT(j+256|0)|0;d=k[_>>2]|0;k[d+76>>2]=q;k[d+72>>2]=q;k[d+80>>2]=q+j;i[q>>0]=10;i[(k[(k[_>>2]|0)+72>>2]|0)+1>>0]=0;q=k[_>>2]|0;d=k[q+76>>2]|0;m:do if((k[q+4>>2]|0)!=8){d=w5(q,d,0)|0;if(d|0){o=q+92|0;m=q+60|0;n=q+88|0;p=q+32|0;l=0;while(1){n:do if(l)while(1){e=i[d>>0]|0;o:do switch(e<<24>>24){case 37:{h=d;f=6;j=222623;e=37;while(1){if(e<<24>>24!=(i[j>>0]|0))break;e=f+-1|0;g=h+1|0;if(!e){h=d;f=8;j=222779;e=37;Y=331;break}h=g;f=e;j=j+1|0;e=i[g>>0]|0}p:do if((Y|0)==331){while(1){Y=0;if(e<<24>>24!=(i[j>>0]|0))break;e=f+-1|0;g=h+1|0;if(!e)break p;h=g;f=e;j=j+1|0;e=i[g>>0]|0;Y=331}R=k[n>>2]|0;k[S>>2]=k[m>>2];k[S+4>>2]=R;k[S+8>>2]=222788;Cfb(Z,222630,S);l9(222830,Z,1360)}while(0);i[d>>0]=0;break}case 45:{h=d;f=3;j=222775;e=45;while(1){if(e<<24>>24!=(i[j>>0]|0))break o;e=f+-1|0;g=h+1|0;if(!e){Y=352;break n}h=g;f=e;j=j+1|0;e=i[g>>0]|0}}default:{if(e<<24>>24==95|((e+-48&255)<10|((e&-33)+-65&255)<26)){Y=354;break n}if(k[o>>2]|0)break n;R=k[n>>2]|0;k[T>>2]=k[m>>2];k[T+4>>2]=R;k[T+8>>2]=222842;Cfb(Z,222630,T);l9(222830,Z,1382)}}while(0);d=w5(q,d,0)|0;if(!d)break m}else{q:while(1){e=i[d>>0]|0;switch(e<<24>>24){case 45:{h=d;f=3;j=222775;e=45;break q}case 37:{h=d;f=6;j=222623;e=37;while(1){if(e<<24>>24!=(i[j>>0]|0))break;e=f+-1|0;g=h+1|0;if(!e){h=d;f=8;j=222779;e=37;Y=344;break}h=g;f=e;j=j+1|0;e=i[g>>0]|0}r:do if((Y|0)==344){while(1){Y=0;if(e<<24>>24!=(i[j>>0]|0))break;e=f+-1|0;g=h+1|0;if(!e)break r;h=g;f=e;j=j+1|0;e=i[g>>0]|0;Y=344}R=k[n>>2]|0;k[U>>2]=k[m>>2];k[U+4>>2]=R;k[U+8>>2]=222788;Cfb(Z,222630,U);l9(222830,Z,1360)}while(0);i[d>>0]=0;break}default:{if(e<<24>>24==95|((e+-48&255)<10|((e&-33)+-65&255)<26)){Y=354;break n}if(k[o>>2]|0)break n;R=k[n>>2]|0;k[W>>2]=k[m>>2];k[W+4>>2]=R;k[W+8>>2]=222842;Cfb(Z,222630,W);l9(222830,Z,1382)}}d=w5(q,d,0)|0;if(!d)break m}while(1){if(e<<24>>24!=(i[j>>0]|0))break n;e=f+-1|0;g=h+1|0;if(!e){Y=352;break n}h=g;f=e;j=j+1|0;e=i[g>>0]|0}}while(0);if((Y|0)==352){Y=0;d=d+3|0}else if((Y|0)==354){Y=0;if(l){R=k[n>>2]|0;k[V>>2]=k[m>>2];k[V+4>>2]=R;k[V+8>>2]=222872;Cfb(Z,222630,V);l9(222830,Z,1376)}}d=w5(q,d,0)|0;if(!(((i[d>>0]|0)==46?(i[d+1>>0]|0)==46:0)?(i[d+2>>0]|0)==46:0)){R=SY(k[p>>2]|0,0)|0;d=x5(q,d,R,0,0)|0;if((k[R>>2]&7)>>>0<=4){R=k[n>>2]|0;k[X>>2]=k[m>>2];k[X+4>>2]=R;k[X+8>>2]=222933;Cfb(Z,222630,X);l9(222830,Z,1393)}d=w5(q,d,0)|0;if(!d)break m}if(k[o>>2]|0)break m;d=w5(q,d+3|0,0)|0;if(!d)break;else l=1}}}else{k[L>>2]=0;k[M>>2]=0;k[N>>2]=0;k[O>>2]=0;e=t5(q,d,2)|0;d=i[e>>0]|0;if(d<<24>>24==60){d=i[e+1>>0]|0;if(d<<24>>24==63){d=i[e+2>>0]|0;if(d<<24>>24==120){d=i[e+3>>0]|0;if(d<<24>>24==109){d=i[e+4>>0]|0;if(d<<24>>24!=108){H=108;I=d;Y=305}}else{H=109;I=d;Y=305}}else{H=120;I=d;Y=305}}else{H=63;I=d;Y=305}}else{H=60;I=d;Y=305}if((Y|0)==305?(I&255|0)!=(H|0):0){X=k[q+88>>2]|0;k[J>>2]=k[q+60>>2];k[J+4>>2]=X;k[J+8>>2]=222641;Cfb(Z,222630,J);l9(222683,Z,2220)}d=u5(q,e,L,N,O)|0;s:do if(i[d>>0]|0){m=q+32|0;j=q+60|0;l=q+88|0;do{d=t5(q,d,0)|0;if(!(i[d>>0]|0))break s;f=u5(q,d,L,N,O)|0;if((k[O>>2]|0)==1?(K=k[(k[L>>2]|0)+8>>2]|0,(i[K>>0]|0)==111):0){d=222695;e=K;do{e=e+1|0;d=d+1|0;g=i[e>>0]|0;h=i[d>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24!=h<<24>>24)Y=314}else Y=314;if((Y|0)==314){Y=0;X=k[l>>2]|0;k[P>>2]=k[j>>2];k[P+4>>2]=X;k[P+8>>2]=222710;Cfb(Z,222630,P);l9(222683,Z,2249)}d=u5(q,v5(q,f,SY(k[m>>2]|0,0)|0,0)|0,M,N,O)|0;if(!((k[O>>2]|0)==2?(k[L>>2]|0)==(k[M>>2]|0):0)){X=k[l>>2]|0;k[Q>>2]=k[j>>2];k[Q+4>>2]=X;k[Q+8>>2]=222742;Cfb(Z,222630,Q);l9(222683,Z,2255)}d=t5(q,d,0)|0}while((i[d>>0]|0)!=0)}while(0)}while(0);d=k[_>>2]|0;e=k[d+76>>2]|0;if(e){ggb(k[e+-4>>2]|0);d=k[_>>2]|0}k[d+76>>2]=0;k[d+80>>2]=0;k[d+72>>2]=0}else{f=b&56;if(y){while(1){e=fgb(24)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;k[e+16>>2]=0;k[e+20>>2]=0;k[d+268>>2]=e}if(A&(f|0)==0){g=a+g+(h?-7:-4)|0;t:do if(g>>>0<a>>>0)e=16;else{e=i[g>>0]|0;if(e<<24>>24==46){e=g+1|0;f=i[e>>0]|0;if(f<<24>>24==120){e=e+1|0;f=i[e>>0]|0;if(f<<24>>24==109){e=i[e+1>>0]|0;if(e<<24>>24!=108){B=108;C=e;Y=117}}else{B=109;C=f;Y=117}}else{B=120;C=f;Y=117}}else{B=46;C=e;Y=117}do if((Y|0)==117?(C&255|0)!=(B|0):0){e=i[g>>0]|0;if(e<<24>>24==46){f=g+1|0;e=i[f>>0]|0;if(e<<24>>24==88){f=f+1|0;e=i[f>>0]|0;if(e<<24>>24==77){e=i[f+1>>0]|0;if(e<<24>>24==76)break;else f=76}else f=77}else f=88}else f=46;if((e&255|0)!=(f|0)){e=i[g>>0]|0;if(e<<24>>24==46){f=g+1|0;e=i[f>>0]|0;if(e<<24>>24==88){f=f+1|0;e=i[f>>0]|0;if(e<<24>>24==109){e=i[f+1>>0]|0;if(e<<24>>24==108)break;else f=108}else f=109}else f=88}else f=46;if((e&255|0)!=(f|0)){e=16;break t}}}while(0);e=8}while(0);k[d+4>>2]=e}else{e=f|0?f:8;k[d+4>>2]=e}h=(e|0)==8?25600:17408;if(G){d=k[d+64>>2]|0;e=d+20|0;f=d+28|0;g=(k[e>>2]|0)>>>0>(k[f>>2]|0)>>>0;do if((k[d+76>>2]|0)>-1){if(g?(ci[k[d+36>>2]&255](d,0,0)|0,(k[e>>2]|0)==0):0)break;k[d+16>>2]=0;k[f>>2]=0;k[e>>2]=0;if((ci[k[d+40>>2]&255](d,0,2)|0)>=0){k[d+8>>2]=0;k[d+4>>2]=0;k[d>>2]=k[d>>2]&-17}}else{if(g?(ci[k[d+36>>2]&255](d,0,0)|0,(k[e>>2]|0)==0):0)break;k[d+16>>2]=0;k[f>>2]=0;k[e>>2]=0;if((ci[k[d+40>>2]&255](d,0,2)|0)>=0){k[d+8>>2]=0;k[d+4>>2]=0;k[d>>2]=k[d>>2]&-17}}while(0);d=k[_>>2]|0;e=k[d+4>>2]|0}e=HY(0,56,(e|0)==8?24:4,k[d+16>>2]|0)|0;X=k[_>>2]|0;k[X+36>>2]=e;k[X+12>>2]=1;k[X+40>>2]=0;k[X+44>>2]=32;X=ZT(h+1024|0)|0;e=k[_>>2]|0;k[e+72>>2]=X;k[e+76>>2]=X;k[e+80>>2]=X+h;if((k[e+4>>2]|0)!=8){if(G)$4(e,222614);else $4(e,222603);d=k[_>>2]|0;k[d+228>>2]=191;k[d+232>>2]=1446;k[d+236>>2]=295;k[d+240>>2]=39;k[d+244>>2]=192;k[d+248>>2]=296;k[d+252>>2]=1447;break}f=k[e+64>>2]|0;if(!f)d=0;else{e=k[f+40>>2]|0;d=(k[f>>2]&128|0)==0;if((k[f+76>>2]|0)>-1){if(d)d=1;else d=(k[f+20>>2]|0)>>>0>(k[f+28>>2]|0)>>>0?2:1;d=ci[e&255](f,0,d)|0;if((d|0)>=0)d=d-(k[f+8>>2]|0)+(k[f+4>>2]|0)+(k[f+20>>2]|0)-(k[f+28>>2]|0)|0}else{if(d)d=1;else d=(k[f+20>>2]|0)>>>0>(k[f+28>>2]|0)>>>0?2:1;d=ci[e&255](f,0,d)|0;if((d|0)>=0)d=d-(k[f+8>>2]|0)+(k[f+4>>2]|0)+(k[f+20>>2]|0)-(k[f+28>>2]|0)|0}e=k[_>>2]|0}X=AY(k[e+16>>2]|0)|0;e=k[_>>2]|0;k[e+24>>2]=X;if((d|0)==0|F){if(!c)$4(e,222468);else{h=i[c>>0]|0;j=h<<24>>24==85;if(j){d=222328;e=c;do{e=e+1|0;d=d+1|0;f=i[e>>0]|0;g=i[d>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=g<<24>>24));if(f<<24>>24==g<<24>>24)Y=161;else Y=155}else Y=155;do if((Y|0)==155){if(h<<24>>24==117){d=222335;e=c;do{e=e+1|0;d=d+1|0;f=i[e>>0]|0;g=i[d>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=g<<24>>24));if(f<<24>>24==g<<24>>24){Y=161;break}}if(j){d=222342;e=c;do{e=e+1|0;d=d+1|0;f=i[e>>0]|0;g=i[d>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=g<<24>>24));if(f<<24>>24==g<<24>>24)Y=161}}while(0);if((Y|0)==161){d5(_);d=Z+4|0;e=ZT(64)|0;k[e>>2]=1;j=e+4|0;k[Z>>2]=j;k[d>>2]=57;i[e+61>>0]=0;l=222349;m=j+57|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-5,Z,222178,221854,2773);k[d>>2]=0;k[Z>>2]=0;X=k[e>>2]|0;k[e>>2]=X+-1;if((X|0)==1)ggb(k[e+-4>>2]|0)}f=c;u:do if(!(f&3)){d=c;Y=167}else{d=c;e=f;while(1){if(!(i[d>>0]|0)){d=e;break u}d=d+1|0;e=d;if(!(e&3)){Y=167;break}}}while(0);if((Y|0)==167){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}if((d-f|0)>>>0>=1e3){d=Z+4|0;e=ZT(28)|0;k[e>>2]=1;j=e+4|0;k[Z>>2]=j;k[d>>2]=23;i[e+27>>0]=0;l=222407;m=j+23|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,Z,222178,221854,2776);k[d>>2]=0;k[Z>>2]=0;Y=k[e>>2]|0;k[e>>2]=Y+-1;if((Y|0)==1)ggb(k[e+-4>>2]|0)}k[R>>2]=c;Cfb(Z,222431,R);$4(k[_>>2]|0,Z)}$4(k[_>>2]|0,222491)}else{j=(d|0)<1024?d:1024;d=k[e+64>>2]|0;e=0-j|0;f=d+20|0;g=d+28|0;h=(k[f>>2]|0)>>>0>(k[g>>2]|0)>>>0;do if((k[d+76>>2]|0)>-1){if(h?(ci[k[d+36>>2]&255](d,0,0)|0,(k[f>>2]|0)==0):0)break;k[d+16>>2]=0;k[g>>2]=0;k[f>>2]=0;if((ci[k[d+40>>2]&255](d,e,2)|0)>=0){k[d+8>>2]=0;k[d+4>>2]=0;k[d>>2]=k[d>>2]&-17}}else{if(h?(ci[k[d+36>>2]&255](d,0,0)|0,(k[f>>2]|0)==0):0)break;k[d+16>>2]=0;k[g>>2]=0;k[f>>2]=0;if((ci[k[d+40>>2]&255](d,e,2)|0)>=0){k[d+8>>2]=0;k[d+4>>2]=0;k[d>>2]=k[d>>2]&-17}}while(0);h=ZT(j+2|0)|0;f=k[(k[_>>2]|0)+64>>2]|0;e=k[f+40>>2]|0;d=(k[f>>2]&128|0)==0;if((k[f+76>>2]|0)>-1){if(d)d=1;else d=(k[f+20>>2]|0)>>>0>(k[f+28>>2]|0)>>>0?2:1;d=ci[e&255](f,0,d)|0;if((d|0)>=0)d=d-(k[f+8>>2]|0)+(k[f+4>>2]|0)+(k[f+20>>2]|0)-(k[f+28>>2]|0)|0}else{if(d)d=1;else d=(k[f+20>>2]|0)>>>0>(k[f+28>>2]|0)>>>0?2:1;d=ci[e&255](f,0,d)|0;if((d|0)>=0)d=d-(k[f+8>>2]|0)+(k[f+4>>2]|0)+(k[f+20>>2]|0)-(k[f+28>>2]|0)|0}e=e5(k[_>>2]|0,h,j)|0;if(!e)if(!h){f=-1;Y=216}else{ggb(k[h+-4>>2]|0);f=-1;Y=216}else{f=-1;do{g=Bfb(e,222509)|0;if(g){f=g;while(1){g=Bfb(f+17|0,222509)|0;if(!g)break;else f=g}f=d-e+f|0}g=k[(k[_>>2]|0)+64>>2]|0;e=k[g+40>>2]|0;d=(k[g>>2]&128|0)==0;do if((k[g+76>>2]|0)>-1){if(d)d=1;else d=(k[g+20>>2]|0)>>>0>(k[g+28>>2]|0)>>>0?2:1;d=ci[e&255](g,0,d)|0;if((d|0)<0)break;d=d-(k[g+8>>2]|0)+(k[g+4>>2]|0)+(k[g+20>>2]|0)-(k[g+28>>2]|0)|0}else{if(d)d=1;else d=(k[g+20>>2]|0)>>>0>(k[g+28>>2]|0)>>>0?2:1;d=ci[e&255](g,0,d)|0;if((d|0)<0)break;d=d-(k[g+8>>2]|0)+(k[g+4>>2]|0)+(k[g+20>>2]|0)-(k[g+28>>2]|0)|0}while(0);e=e5(k[_>>2]|0,h,j)|0}while((e|0)!=0);if(h|0)ggb(k[h+-4>>2]|0);if((f|0)<0)Y=216;else h=f}if((Y|0)==216){d5(_);d=Z+4|0;e=ZT(60)|0;k[e>>2]=1;j=e+4|0;k[Z>>2]=j;k[d>>2]=53;i[e+57>>0]=0;l=222527;m=j+53|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-2,Z,222178,221854,2814);k[d>>2]=0;k[Z>>2]=0;Z=k[e>>2]|0;k[e>>2]=Z+-1;if((Z|0)==1)ggb(k[e+-4>>2]|0);h=f}f=k[_>>2]|0;g=f+64|0;d=k[g>>2]|0;if(!d){d=f+68|0;e=k[d>>2]|0;if(e)Ieb(e)}else{Qfb(d)|0;d=f+68|0}k[g>>2]=0;k[d>>2]=0;k[f+256>>2]=0;k[f+264>>2]=0;i[f+272>>0]=0;d=Ufb(k[(k[_>>2]|0)+60>>2]|0,222581)|0;k[(k[_>>2]|0)+64>>2]=d;e=d+20|0;f=d+28|0;g=(k[e>>2]|0)>>>0>(k[f>>2]|0)>>>0;do if((k[d+76>>2]|0)>-1){if(g?(ci[k[d+36>>2]&255](d,0,0)|0,(k[e>>2]|0)==0):0)break;k[d+16>>2]=0;k[f>>2]=0;k[e>>2]=0;if((ci[k[d+40>>2]&255](d,h,0)|0)<0)break;k[d+8>>2]=0;k[d+4>>2]=0;k[d>>2]=k[d>>2]&-17}else{if(g?(ci[k[d+36>>2]&255](d,0,0)|0,(k[e>>2]|0)==0):0)break;k[d+16>>2]=0;k[f>>2]=0;k[e>>2]=0;if((ci[k[d+40>>2]&255](d,h,0)|0)<0)break;k[d+8>>2]=0;k[d+4>>2]=0;k[d>>2]=k[d>>2]&-17}while(0);$4(k[_>>2]|0,222585);d=k[(k[_>>2]|0)+64>>2]|0;e=d+20|0;f=d+28|0;g=(k[e>>2]|0)>>>0>(k[f>>2]|0)>>>0;do if((k[d+76>>2]|0)>-1){if(g?(ci[k[d+36>>2]&255](d,0,0)|0,(k[e>>2]|0)==0):0)break;k[d+16>>2]=0;k[f>>2]=0;k[e>>2]=0;if((ci[k[d+40>>2]&255](d,0,2)|0)<0)break;k[d+8>>2]=0;k[d+4>>2]=0;k[d>>2]=k[d>>2]&-17}else{if(g?(ci[k[d+36>>2]&255](d,0,0)|0,(k[e>>2]|0)==0):0)break;k[d+16>>2]=0;k[f>>2]=0;k[e>>2]=0;if((ci[k[d+40>>2]&255](d,0,2)|0)<0)break;k[d+8>>2]=0;k[d+4>>2]=0;k[d>>2]=k[d>>2]&-17}while(0);$4(k[_>>2]|0,359738)}d=k[_>>2]|0;k[d+228>>2]=189;k[d+232>>2]=1444;k[d+236>>2]=293;k[d+240>>2]=38;k[d+244>>2]=190;k[d+248>>2]=294;k[d+252>>2]=1445}while(0);i[d+272>>0]=1}if(!d){_=0;r=$;return _|0}g=d+64|0;e=k[g>>2]|0;f=(e|0)==0;if(((f?(k[d+68>>2]|0)==0:0)?(k[d+268>>2]|0)==0:0)?(k[d+256>>2]|0)==0:0){d5(_);_=k[_>>2]|0;r=$;return _|0}if(k[d+8>>2]|0){_=d;r=$;return _|0}if(f){e=d+68|0;f=k[e>>2]|0;if(f)Ieb(f)}else{Qfb(e)|0;e=d+68|0}k[g>>2]=0;k[e>>2]=0;k[d+256>>2]=0;k[d+264>>2]=0;i[d+272>>0]=0;_=k[_>>2]|0;i[_+272>>0]=1;r=$;return _|0}function b5(a){a=a|0;ggb(a);return}function c5(a){a=a|0;var b=0,c=0;b=r;r=r+16|0;c=b;k[c>>2]=k[a+8>>2];d5(c);if(!a){r=b;return}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);r=b;return}function d5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;b=o;if(!a){c=b+4|0;d=ZT(40)|0;k[d>>2]=1;e=d+4|0;k[b>>2]=e;k[c>>2]=35;i[d+39>>0]=0;f=221809;g=e+35|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-27,b,225741,221854,550);k[c>>2]=0;k[b>>2]=0;n=k[d>>2]|0;k[d>>2]=n+-1;if((n|0)==1)ggb(k[d+-4>>2]|0)}n=k[a>>2]|0;if(!n){r=o;return}k[a>>2]=0;Z4(n,0);BY(n+24|0);b=n+76|0;c=k[b>>2]|0;if(c|0)ggb(k[c+-4>>2]|0);k[b>>2]=0;BY(n+16|0);m=k[n+268>>2]|0;if(!m)zpb(n|0,0,276)|0;else{j=m+4|0;c=k[j>>2]|0;h=m+16|0;b=k[h>>2]|0;d=c+(b>>>12<<2)|0;l=m+8|0;a=k[l>>2]|0;e=a;f=c;if((a|0)==(c|0)){g=0;a=m+20|0;b=0}else{a=m+20|0;g=(k[a>>2]|0)+b|0;g=(k[c+(g>>>12<<2)>>2]|0)+(g&4095)|0;b=(k[d>>2]|0)+(b&4095)|0}a:while(1){do{if((b|0)==(g|0))break a;b=b+1|0}while((b-(k[d>>2]|0)|0)!=4096);b=d+4|0;d=b;b=k[b>>2]|0}k[a>>2]=0;b=e-f>>2;if(b>>>0>2)do{ggb(k[c>>2]|0);c=(k[j>>2]|0)+4|0;k[j>>2]=c;b=(k[l>>2]|0)-c>>2}while(b>>>0>2);switch(b|0){case 1:{k[h>>2]=2048;break}case 2:{k[h>>2]=4096;break}default:{}}b=k[j>>2]|0;c=k[l>>2]|0;if((b|0)!=(c|0)){do{ggb(k[b>>2]|0);b=b+4|0}while((b|0)!=(c|0));b=k[j>>2]|0;c=k[l>>2]|0;if((c|0)!=(b|0))k[l>>2]=c+(~((c+-4-b|0)>>>2)<<2)}b=k[m>>2]|0;if(b|0)ggb(b);ggb(m);zpb(n|0,0,276)|0}ggb(k[n+-4>>2]|0);r=o;return}function e5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+16|0;l=p;m=k[a+256>>2]|0;if(m|0){j=a+264|0;g=k[a+260>>2]|0;a=c+-1|0;e=k[j>>2]|0;d=0;while(1){if(!((d|0)<(a|0)&e>>>0<g>>>0))break;f=e+1|0;e=i[m+e>>0]|0;h=d+1|0;if(!(e<<24>>24)){e=f;break}i[b+d>>0]=e;if(e<<24>>24==10){e=f;d=h;break}else{e=f;d=h}}i[b+d>>0]=0;k[j>>2]=e;b=(d|0)>0?b:0;r=p;return b|0}e=k[a+64>>2]|0;if(e|0){b=Vfb(b,c,e)|0;r=p;return b|0}n=k[a+68>>2]|0;if(!n){d=l+4|0;e=ZT(32)|0;k[e>>2]=1;a=e+4|0;k[l>>2]=a;k[d>>2]=25;i[e+29>>0]=0;f=221943;g=a+25|0;do{i[a>>0]=i[f>>0]|0;a=a+1|0;f=f+1|0}while((a|0)<(g|0));Y8(-2,l,225733,221854,285);k[d>>2]=0;k[l>>2]=0;b=k[e>>2]|0;k[e>>2]=b+-1;if((b|0)==1)ggb(k[e+-4>>2]|0);b=0;r=p;return b|0}if((b|0)==0|(c|0)<1){b=0;r=p;return b|0}if((k[n+12>>2]|0)!=7247){b=0;r=p;return b|0}switch(k[n+76>>2]|0){case -5:case 0:break;default:{b=0;r=p;return b|0}}e=n+72|0;a:do if(k[e>>2]|0?(k[e>>2]=0,d=k[n+68>>2]|0,f=n+88|0,g=n+52|0,h=n+4|0,j=n+8|0,d|0):0){b:while(1){while(1){e=k[n>>2]|0;if(e|0)break;if(k[g>>2]|0?(k[f>>2]|0)==0:0)break a;if((Keb(n)|0)==-1){d=0;break b}}m=(e|0)<0|(e|0)>(d|0)?d:e;k[n>>2]=e-m;k[h>>2]=(k[h>>2]|0)+m;k[j>>2]=(k[j>>2]|0)+m;d=d-m|0;if(!d)break a}r=p;return d|0}while(0);e=c+-1|0;if(!e){b=0;r=p;return b|0}l=n+4|0;m=n+8|0;d=b;a=k[n>>2]|0;do{if(!a){if((Keb(n)|0)==-1){d=0;o=45;break}a=k[n>>2]|0;if(!a){o=26;break}}h=a>>>0>e>>>0?e:a;j=k[l>>2]|0;c=j;g=(h|0)!=0;c:do if(g&(c&3|0)!=0){f=j;a=h;while(1){if((i[f>>0]|0)==10)break c;f=f+1|0;a=a+-1|0;g=(a|0)!=0;if(!(g&(f&3|0)!=0)){o=30;break}}}else{f=j;a=h;o=30}while(0);d:do if((o|0)==30){o=0;if(g){if((i[f>>0]|0)!=10){e:do if(a>>>0>3)while(1){g=k[f>>2]|0;if((g&-2139062144^-2139062144)&(g^168430090)+-16843009|0)break;f=f+4|0;a=a+-4|0;if(a>>>0<=3){o=36;break e}}else o=36;while(0);if((o|0)==36){o=0;if(!a){a=0;break}}while(1){if((i[f>>0]|0)==10)break d;f=f+1|0;a=a+-1|0;if(!a){a=0;break}}}}else a=0}while(0);a=a|0?f:0;g=(a|0)==0;c=g?h:a+1-c|0;upb(d|0,j|0,c|0)|0;a=(k[n>>2]|0)-c|0;k[n>>2]=a;k[l>>2]=(k[l>>2]|0)+c;k[m>>2]=(k[m>>2]|0)+c;e=e-c|0;d=d+c|0}while(g&(e|0)!=0);if((o|0)==26)k[n+56>>2]=1;else if((o|0)==45){r=p;return d|0}if((d|0)==(b|0)){b=0;r=p;return b|0}i[d>>0]=0;r=p;return b|0}function f5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+80|0;n=u+48|0;m=u+8|0;g=u;s=c&15|32;if((c&7)>>>0<=4){e=g+4|0;f=ZT(72)|0;k[f>>2]=1;h=f+4|0;k[g>>2]=h;k[e>>2]=66;i[f+70>>0]=0;j=225643;l=h+66|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,g,225710,221854,2368);k[e>>2]=0;k[g>>2]=0;q=k[f>>2]|0;k[f>>2]=q+-1;if((q|0)==1)ggb(k[f+-4>>2]|0)}if(!d)e=0;else{k[m>>2]=223823;k[m+4>>2]=d;e=2}k[m+(e<<2)>>2]=0;G5(a,b,1,m);o=a+44|0;k[n+20>>2]=k[o>>2]&-33;h=a+40|0;k[n+16>>2]=k[h>>2];p=a+48|0;m=p;g=k[m+4>>2]|0;q=n+8|0;k[q>>2]=k[m>>2];k[q+4>>2]=g;q=a+24|0;DY(k[q>>2]|0,n);SY(k[a+36>>2]|0,n)|0;g=(k[h>>2]|0)+2|0;k[h>>2]=g;if(!(c&8)){m=a+72|0;d=k[m>>2]|0;j=a+76|0;e=k[j>>2]|0;l=a+56|0;f=k[l>>2]|0;if(d>>>0>(e+f|0)>>>0){i[d>>0]=10;i[d+1>>0]=0;$4(a,k[j>>2]|0);e=k[j>>2]|0;k[m>>2]=e;d=k[h>>2]|0;f=k[l>>2]|0}else d=g;if((d|0)!=(f|0)){if((d|0)>(f|0)){zpb(e+f|0,32,d-f|0)|0;e=k[j>>2]|0}k[l>>2]=d}k[m>>2]=e+d}k[o>>2]=s;if(!b){k[a+52>>2]=0;k[p>>2]=0;r=u;return}d=k[q>>2]|0;g=b;a:do if(!(g&3)){e=b;t=19}else{e=b;f=g;while(1){if(!(i[e>>0]|0)){e=f;break a}e=e+1|0;f=e;if(!(f&3)){t=19;break}}}while(0);if((t|0)==19){while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}s=e-g|0;t=FY(d,s+1|0)|0;upb(t|0,b|0,s|0)|0;i[t+s>>0]=0;k[a+48>>2]=s;k[a+52>>2]=t;r=u;return}function g5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+32|0;b=h+8|0;c=h;d=a+36|0;if(!(k[(k[d>>2]|0)+24>>2]|0)){e=c+4|0;f=ZT(28)|0;k[f>>2]=1;g=f+4|0;k[c>>2]=g;k[e>>2]=20;i[f+24>>0]=0;j=225601;l=g+20|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-2,c,225622,221854,2408);k[e>>2]=0;k[c>>2]=0;l=k[f>>2]|0;k[f>>2]=l+-1;if((l|0)==1)ggb(k[f+-4>>2]|0)}G5(a,k[a+52>>2]|0,2,0);TY(k[d>>2]|0,b);k[a+40>>2]=k[b+16>>2];k[a+44>>2]=k[b+20>>2];g=b+8|0;j=k[g+4>>2]|0;l=a+48|0;k[l>>2]=k[g>>2];k[l+4>>2]=j;EY(k[a+24>>2]|0,b);r=h;return}function h5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+128|0;e=j+23|0;i[e>>0]=0;f=(c|0)>-1?c:0-c|0;while(1){h=f;f=(f>>>0)/10|0;d=h+48+(aa(f,-10)|0)&255;g=e+-1|0;i[g>>0]=d;if(h>>>0<=9)break;else e=g}if((c|0)<0){g=e+-2|0;i[g>>0]=45;d=45}h=g;a:do if(!(h&3))d=g;else{c=g;e=d;d=h;while(1){if(!(e<<24>>24))break;d=c+1|0;f=d;if(!(f&3))break a;c=d;e=i[d>>0]|0;d=f}h=d-h|0;F5(a,b,g,h);r=j;return}while(0);while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0);c=d;h=c-h|0;F5(a,b,g,h);r=j;return}function i5(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,h=0;h=r;r=r+128|0;g=h;d=E5(g,c)|0;f=d;a:do if(f&3){e=f;while(1){if(!(i[d>>0]|0)){d=e;break}d=d+1|0;e=d;if(!(e&3))break a}f=d-f|0;F5(a,b,g,f);r=h;return}while(0);while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0);e=d;f=e-f|0;F5(a,b,g,f);r=h;return}function j5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+24608|0;n=q;o=q+16|0;m=q+8|0;if(!c){e=m+4|0;f=ZT(24)|0;k[f>>2]=1;g=f+4|0;k[m>>2]=g;k[e>>2]=19;i[f+23>>0]=0;h=224663;j=g+19|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-27,m,225300,221854,2503);k[e>>2]=0;k[m>>2]=0;l=k[f>>2]|0;k[f>>2]=l+-1;if((l|0)==1)ggb(k[f+-4>>2]|0)}g=c;a:do if(!(g&3)){e=c;p=8}else{f=c;e=g;while(1){if(!(i[f>>0]|0))break a;f=f+1|0;e=f;if(!(e&3)){e=f;p=8;break}}}while(0);if((p|0)==8){while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}l=e-g|0;if((l|0)>4096){e=m+4|0;f=ZT(36)|0;k[f>>2]=1;g=f+4|0;k[m>>2]=g;k[e>>2]=30;i[f+34>>0]=0;h=224701;j=g+30|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,m,225300,221854,2507);k[e>>2]=0;k[m>>2]=0;m=k[f>>2]|0;k[f>>2]=m+-1;if((m|0)==1)ggb(k[f+-4>>2]|0)}e=(d|0)!=0|(l|0)==0;if((!e?(i[c>>0]|0)==34:0)?(i[c+(l+-1)>>0]|0)==34:0){p=l;o=c;F5(a,b,o,p);r=q;return}e=e&1;f=o+1|0;i[o>>0]=34;if((l|0)>0){j=0;do{g=i[c+j>>0]|0;h=g&255;b:do if(g<<24>>24<0|g<<24>>24==32){i[f>>0]=g;e=1}else{c:do if((g&255)>=32){switch(g<<24>>24){case 34:case 38:case 39:case 60:case 62:break c;default:{}}i[f>>0]=g;break b}while(0);e=f+1|0;i[f>>0]=38;switch(g<<24>>24){case 60:{i[e>>0]=108;i[e+1>>0]=116;f=f+3|0;break}case 62:{i[e>>0]=103;i[e+1>>0]=116;f=f+3|0;break}case 38:{i[e>>0]=i[224130]|0;i[e+1>>0]=i[224131]|0;i[e+2>>0]=i[224132]|0;f=f+4|0;break}case 39:{i[e>>0]=97;i[e+1>>0]=112;i[e+2>>0]=111;i[e+3>>0]=115;f=f+5|0;break}case 34:{i[e>>0]=113;i[e+1>>0]=117;i[e+2>>0]=111;i[e+3>>0]=116;f=f+5|0;break}default:{k[n>>2]=h;Cfb(e,225318,n);f=f+5|0}}i[f>>0]=59;e=1}while(0);f=f+1|0;j=j+1|0}while((j|0)!=(l|0))}if(!e){e=i[c>>0]|0;if((e+-48&255)<10){e=1;p=38}else switch(e<<24>>24){case 46:case 45:case 43:{e=1;p=38;break}default:e=0}}else p=38;if((p|0)==38){i[f>>0]=34;f=f+1|0;e=(e|0)!=0}c=e&1^1;i[f>>0]=0;p=f-o-c|0;o=o+c|0;F5(a,b,o,p);r=q;return}function k5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+16|0;n=u;f=u+8|0;q=(b|0)==0;if(q){d=f+4|0;e=ZT(20)|0;k[e>>2]=1;g=e+4|0;k[f>>2]=g;k[d>>2]=12;i[e+16>>0]=0;h=224631;j=g+12|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-27,f,225211,221854,2586);k[d>>2]=0;k[f>>2]=0;s=k[e>>2]|0;k[e>>2]=s+-1;if((s|0)==1)ggb(k[e+-4>>2]|0)}if(Bfb(b,225230)|0){d=f+4|0;e=ZT(56)|0;k[e>>2]=1;g=e+4|0;k[f>>2]=g;k[d>>2]=49;i[e+53>>0]=0;h=225233;j=g+49|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,f,225211,221854,2589);k[d>>2]=0;k[f>>2]=0;s=k[e>>2]|0;k[e>>2]=s+-1;if((s|0)==1)ggb(k[e+-4>>2]|0)}f=b;g=(f&3|0)==0;a:do if(g){d=b;t=12}else{e=b;d=f;while(1){if(!(i[e>>0]|0))break a;e=e+1|0;d=e;if(!(d&3)){d=e;t=12;break}}}while(0);if((t|0)==12){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}j=d-f|0;b:do if(g){d=b;t=20}else{d=b;while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 10:break b;default:{}}d=d+1|0;if(!(d&3)){t=20;break b}}}while(0);c:do if((t|0)==20){e=k[d>>2]|0;d:do if(!((e&-2139062144^-2139062144)&e+-16843009))do{if((e&-2139062144^-2139062144)&(e^168430090)+-16843009|0)break d;d=d+4|0;e=k[d>>2]|0}while(!((e&-2139062144^-2139062144)&e+-16843009|0));while(0);while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 10:break c;default:d=d+1|0}}}while(0);l=e<<24>>24==10?d:0;m=(l|0)!=0;s=a+72|0;d=k[s>>2]|0;if((c|0)!=0&(m^1)?((k[a+80>>2]|0)-d|0)>=(j+5|0):0){if(d>>>0>((k[a+76>>2]|0)+(k[a+40>>2]|0)|0)>>>0){i[d>>0]=32;d=d+1|0}}else{g=a+76|0;e=k[g>>2]|0;h=a+56|0;f=k[h>>2]|0;if(d>>>0>(e+f|0)>>>0){i[d>>0]=10;i[d+1>>0]=0;$4(a,k[g>>2]|0);e=k[g>>2]|0;k[s>>2]=e;f=k[h>>2]|0}d=k[a+40>>2]|0;if((d|0)==(f|0))d=f;else{if((d|0)>(f|0)){zpb(e+f|0,32,d-f|0)|0;e=k[g>>2]|0}k[h>>2]=d}d=e+d|0;k[s>>2]=d}if(m){i[d>>0]=i[225295]|0;i[d+1>>0]=i[225296]|0;i[d+2>>0]=i[225297]|0;i[d+3>>0]=i[225298]|0;i[d+4>>0]=i[225299]|0;e=4}else{e=j+9|0;h=a+80|0;f=k[h>>2]|0;if((d+e|0)>>>0>=f>>>0){j=a+76|0;p=k[j>>2]|0;g=d-p|0;f=((f-p|0)*3|0)/2|0;d=g+e|0;d=(d|0)<(f|0)?f:d;e=ZT(d+256|0)|0;f=k[j>>2]|0;k[s>>2]=e+((k[s>>2]|0)-f);if((g|0)>0)upb(e|0,f|0,g|0)|0;k[j>>2]=e;k[h>>2]=e+d;d=e+g|0}k[n>>2]=b;Cfb(d,225283,n);g=d;e:do if(!(g&3)){e=d;t=44}else{f=d;e=g;while(1){if(!(i[f>>0]|0))break e;f=f+1|0;e=f;if(!(e&3)){e=f;t=44;break}}}while(0);if((t|0)==44){while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}e=e-g|0}d=d+e|0;k[s>>2]=d;o=a+76|0;f=k[o>>2]|0;p=a+56|0;e=k[p>>2]|0;if(d>>>0>(f+e|0)>>>0){i[d>>0]=10;i[d+1>>0]=0;$4(a,k[o>>2]|0);f=k[o>>2]|0;k[s>>2]=f;d=f;e=k[p>>2]|0}else d=f;n=a+40|0;g=k[n>>2]|0;if((g|0)!=(e|0)){if((g|0)>(e|0)){zpb(d+e|0,32,g-e|0)|0;f=k[o>>2]|0;d=f}k[p>>2]=g;e=g}d=d+e|0;k[s>>2]=d;if(!m){r=u;return}if(!q){m=a+80|0;c=f;while(1){if(!l){g=b;f:do if(!(g&3)){e=b;t=77}else{f=b;e=g;while(1){if(!(i[f>>0]|0))break f;f=f+1|0;e=f;if(!(e&3)){e=f;t=77;break}}}while(0);if((t|0)==77){t=0;while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}h=e-g|0;e=k[m>>2]|0;if((d+h|0)>>>0>=e>>>0){g=d-c|0;e=((e-c|0)*3|0)/2|0;d=g+h|0;d=(d|0)<(e|0)?e:d;e=ZT(d+256|0)|0;f=k[o>>2]|0;k[s>>2]=e+((k[s>>2]|0)-f);if((g|0)>0)upb(e|0,f|0,g|0)|0;k[o>>2]=e;k[m>>2]=e+d;d=e+g|0}upb(d|0,b|0,h|0)|0;l=0;j=0;d=d+h|0}else{h=l-b|0;j=h+1|0;e=k[m>>2]|0;if((d+j|0)>>>0>=e>>>0){g=d-c|0;e=((e-c|0)*3|0)/2|0;d=g+j|0;d=(d|0)<(e|0)?e:d;e=ZT(d+256|0)|0;f=k[o>>2]|0;k[s>>2]=e+((k[s>>2]|0)-f);if((g|0)>0)upb(e|0,f|0,g|0)|0;k[o>>2]=e;k[m>>2]=e+d;d=e+g|0}upb(d|0,b|0,j|0)|0;g=d+h|0;f=l+1|0;g:do if(!(f&3)){d=f;t=68}else{d=f;while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 10:break g;default:{}}d=d+1|0;if(!(d&3)){t=68;break g}}}while(0);h:do if((t|0)==68){t=0;e=k[d>>2]|0;i:do if(!((e&-2139062144^-2139062144)&e+-16843009))do{if((e&-2139062144^-2139062144)&(e^168430090)+-16843009|0)break i;d=d+4|0;e=k[d>>2]|0}while(!((e&-2139062144^-2139062144)&e+-16843009|0));while(0);while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 10:break h;default:d=d+1|0}}}while(0);l=e<<24>>24==10?d:0;j=f;d=g}k[s>>2]=d;f=k[o>>2]|0;e=k[p>>2]|0;if(d>>>0>(f+e|0)>>>0){i[d>>0]=10;i[d+1>>0]=0;$4(a,k[o>>2]|0);f=k[o>>2]|0;k[s>>2]=f;d=f;e=k[p>>2]|0}else d=f;g=k[n>>2]|0;if((g|0)!=(e|0)){if((g|0)>(e|0)){zpb(d+e|0,32,g-e|0)|0;f=k[o>>2]|0;d=f}k[p>>2]=g;e=g}d=d+e|0;k[s>>2]=d;if(!j)break;else{b=j;c=f}}}i[d>>0]=45;i[d+1>>0]=45;i[d+2>>0]=62;i[d+3>>0]=0;g=d+3|0;k[s>>2]=g;e=k[o>>2]|0;f=k[p>>2]|0;if(g>>>0>(e+f|0)>>>0){i[g>>0]=10;i[d+4>>0]=0;$4(a,k[o>>2]|0);e=k[o>>2]|0;k[s>>2]=e;f=k[p>>2]|0}d=k[n>>2]|0;if((d|0)==(f|0))d=f;else{if((d|0)>(f|0)){zpb(e+f|0,32,d-f|0)|0;e=k[o>>2]|0}k[p>>2]=d}k[s>>2]=e+d;r=u;return}function l5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;if(k[a+12>>2]|0)return;b=a+36|0;if((k[(k[b>>2]|0)+24>>2]|0)>0)do g5(a);while((k[(k[b>>2]|0)+24>>2]|0)>0);e=a+40|0;k[e>>2]=0;g=a+72|0;d=k[g>>2]|0;h=a+76|0;b=k[h>>2]|0;f=a+56|0;c=k[f>>2]|0;if(d>>>0>(b+c|0)>>>0){i[d>>0]=10;i[d+1>>0]=0;$4(a,k[h>>2]|0);b=k[h>>2]|0;k[g>>2]=b;d=k[e>>2]|0;c=k[f>>2]|0}else d=0;if((d|0)!=(c|0)){if((d|0)>(c|0)){zpb(b+c|0,32,d-c|0)|0;b=k[h>>2]|0}k[f>>2]=d}k[g>>2]=b+d;$4(a,225188);k[g>>2]=k[h>>2];return}function m5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+5152|0;m=u+8|0;s=u;t=u+24|0;e=u+32|0;j=u+16|0;q=c&15;f=q|32;l=c&7;if(l>>>0<=4){g=j+4|0;h=ZT(76)|0;k[h>>2]=1;n=h+4|0;k[j>>2]=n;k[g>>2]=68;i[h+72>>0]=0;o=225083;p=n+68|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-5,j,225152,221854,1522);k[g>>2]=0;k[j>>2]=0;p=k[h>>2]|0;k[h>>2]=p+-1;if((p|0)==1)ggb(k[h+-4>>2]|0)}do if(!(c&8))if(!d)e=0;else{k[m>>2]=d;Cfb(e,225183,m)}else{g=(l|0)==6?123:91;f=q|40;if(!d){i[e>>0]=g;i[e+1>>0]=0;break}else{k[s>>2]=d;k[s+4>>2]=g&255;Cfb(e,225175,s);break}}while(0);D5(a,b,e);e=a+44|0;k[t>>2]=k[e>>2];SY(k[a+36>>2]|0,t)|0;k[e>>2]=f;e=a+40|0;if(k[t>>2]&8|0){r=u;return}k[e>>2]=(f>>>3&1)+3+(k[e>>2]|0);r=u;return}function n5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;m=o+8|0;g=o;k[m>>2]=0;n=a+44|0;l=k[n>>2]|0;h=a+36|0;b=k[h>>2]|0;if(!(k[b+24>>2]|0)){b=g+4|0;c=ZT(52)|0;k[c>>2]=1;d=c+4|0;k[g>>2]=d;k[b>>2]=44;i[c+48>>0]=0;e=225017;f=d+44|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-2,g,225062,221854,1563);k[b>>2]=0;k[g>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0);b=k[h>>2]|0}TY(b,m);j=l&8;do if(!j){if(!(l&32)){c=a+40|0;break}h=a+72|0;b=k[h>>2]|0;f=a+76|0;d=k[f>>2]|0;g=a+56|0;c=k[g>>2]|0;if(b>>>0>(d+c|0)>>>0){i[b>>0]=10;i[b+1>>0]=0;$4(a,k[f>>2]|0);d=k[f>>2]|0;k[h>>2]=d;e=k[g>>2]|0}else e=c;c=a+40|0;b=k[c>>2]|0;if((b|0)==(e|0))b=e;else{if((b|0)>(e|0)){zpb(d+e|0,32,b-e|0)|0;d=k[f>>2]|0}k[g>>2]=b}a=d+b|0;l=(l&7|0)==6?32123:23899;i[a>>0]=l;i[a+1>>0]=l>>8;k[h>>2]=a+2}else{d=a+72|0;b=k[d>>2]|0;c=a+40|0;if((l&32|0)==0?b>>>0>((k[a+76>>2]|0)+(k[c>>2]|0)|0)>>>0:0){i[b>>0]=32;b=b+1|0}i[b>>0]=(l&7|0)==6?125:93;k[d>>2]=b+1}while(0);b=k[m>>2]|0;if(b&8|0){k[n>>2]=b;r=o;return}k[c>>2]=-3-(j>>>3)+(k[c>>2]|0);k[n>>2]=b;r=o;return}function o5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+128|0;d=g+23|0;i[d>>0]=0;e=(c|0)>-1?c:0-c|0;while(1){h=e;e=(e>>>0)/10|0;j=h+48+(aa(e,-10)|0)&255;f=d+-1|0;i[f>>0]=j;if(h>>>0<=9)break;else d=f}if((c|0)>=0){j=f;D5(a,b,j);r=g;return}j=d+-2|0;i[j>>0]=45;D5(a,b,j);r=g;return}function p5(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=r;r=r+128|0;D5(a,b,E5(d,c)|0);r=d;return}function q5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+16416|0;o=s;p=s+16|0;m=s+8|0;if(!c){e=m+4|0;f=ZT(24)|0;k[f>>2]=1;g=f+4|0;k[m>>2]=g;k[e>>2]=19;i[f+23>>0]=0;h=224663;j=g+19|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-27,m,224683,221854,1632);k[e>>2]=0;k[m>>2]=0;l=k[f>>2]|0;k[f>>2]=l+-1;if((l|0)==1)ggb(k[f+-4>>2]|0)}g=c;a:do if(!(g&3)){e=c;q=8}else{f=c;e=g;while(1){if(!(i[f>>0]|0))break a;f=f+1|0;e=f;if(!(e&3)){e=f;q=8;break}}}while(0);if((q|0)==8){while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}l=e-g|0;if((l|0)>4096){e=m+4|0;f=ZT(36)|0;k[f>>2]=1;g=f+4|0;k[m>>2]=g;k[e>>2]=30;i[f+34>>0]=0;h=224701;j=g+30|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,m,224683,221854,1636);k[e>>2]=0;k[m>>2]=0;m=k[f>>2]|0;k[f>>2]=m+-1;if((m|0)==1)ggb(k[f+-4>>2]|0)}e=(d|0)!=0|(l|0)==0;b:do if(!e?(n=i[c>>0]|0,n<<24>>24==(i[c+(l+-1)>>0]|0)):0){switch(n<<24>>24){case 39:case 34:break;default:break b}D5(a,b,c);r=s;return}while(0);e=e&1;f=p+1|0;i[p>>0]=34;if((l|0)>0){d=0;do{j=i[c+d>>0]|0;h=j+-48<<24>>24;c:do if(!e){g=(j&-33)+-65<<24>>24;if((h&255)<10|(g&255)<26)e=0;else{switch(j<<24>>24){case 32:case 40:case 41:case 43:case 45:case 47:case 59:case 95:{e=0;break c}default:{}}e=1}}else g=(j&-33)+-65<<24>>24;while(0);d:do if((h&255)<10|(g&255)<26)q=35;else{if((j&255)>31){switch(j<<24>>24){case 34:case 39:case 92:break;default:{q=35;break d}}i[f>>0]=92;i[f+1>>0]=j;f=f+2|0;break}g=f+1|0;i[f>>0]=92;switch(j<<24>>24){case 10:{i[g>>0]=110;f=f+2|0;break d}case 13:{i[g>>0]=114;f=f+2|0;break d}case 9:{i[g>>0]=116;f=f+2|0;break d}default:{k[o>>2]=j<<24>>24;Cfb(g,224732,o);f=f+4|0;break d}}}while(0);if((q|0)==35){q=0;i[f>>0]=j;f=f+1|0}d=d+1|0}while((d|0)!=(l|0))}if(!e){c=i[c>>0]|0;if((c+-48&255)<10){e=1;q=40}else switch(c<<24>>24){case 46:case 45:case 43:{e=1;q=40;break}default:c=0}}else q=40;if((q|0)==40){i[f>>0]=34;f=f+1|0;c=(e|0)!=0}i[f>>0]=0;q=p+(c&1^1)|0;D5(a,b,q);r=s;return}function r5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+16|0;d=t;m=(b|0)==0;if(m){e=d+4|0;f=ZT(20)|0;k[f>>2]=1;g=f+4|0;k[d>>2]=g;k[e>>2]=12;i[f+16>>0]=0;h=224631;j=g+12|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-27,d,224644,221854,1694);k[e>>2]=0;k[d>>2]=0;q=k[f>>2]|0;k[f>>2]=q+-1;if((q|0)==1)ggb(k[f+-4>>2]|0)}g=b;f=(g&3|0)==0;a:do if(f){d=b;s=8}else{d=b;while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 10:break a;default:{}}d=d+1|0;if(!(d&3)){s=8;break a}}}while(0);b:do if((s|0)==8){e=k[d>>2]|0;c:do if(!((e&-2139062144^-2139062144)&e+-16843009))do{if((e&-2139062144^-2139062144)&(e^168430090)+-16843009|0)break c;d=d+4|0;e=k[d>>2]|0}while(!((e&-2139062144^-2139062144)&e+-16843009|0));while(0);while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 10:break b;default:d=d+1|0}}}while(0);l=e<<24>>24==10?d:0;q=a+72|0;j=k[q>>2]|0;if(!((c|0)==0|(l|0)!=0)){d:do if(f){d=b;s=17}else{e=b;d=g;while(1){if(!(i[e>>0]|0))break d;e=e+1|0;d=e;if(!(d&3)){d=e;s=17;break}}}while(0);if((s|0)==17){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}if(((k[a+80>>2]|0)-j|0)>=(d-g|0)?(j|0)!=(k[a+76>>2]|0):0){i[j>>0]=32;d=j+1|0}else s=24}else s=24;if((s|0)==24){g=a+76|0;e=k[g>>2]|0;h=a+56|0;d=k[h>>2]|0;if(j>>>0>(e+d|0)>>>0){i[j>>0]=10;i[j+1>>0]=0;$4(a,k[g>>2]|0);e=k[g>>2]|0;k[q>>2]=e;f=k[h>>2]|0}else f=d;d=k[a+40>>2]|0;if((d|0)==(f|0))d=f;else{if((d|0)>(f|0)){zpb(e+f|0,32,d-f|0)|0;e=k[g>>2]|0}k[h>>2]=d}d=e+d|0;k[q>>2]=d}if(m){r=t;return}n=a+80|0;o=a+76|0;p=a+56|0;m=a+40|0;e=d;c=b;while(1){i[e>>0]=35;d=e+2|0;i[e+1>>0]=32;if(!l){g=c;e:do if(!(g&3)){e=c;s=51}else{f=c;e=g;while(1){if(!(i[f>>0]|0))break e;f=f+1|0;e=f;if(!(e&3)){e=f;s=51;break}}}while(0);if((s|0)==51){s=0;while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}h=e-g|0;e=k[n>>2]|0;if((d+h|0)>>>0>=e>>>0){f=k[o>>2]|0;g=d-f|0;e=((e-f|0)*3|0)/2|0;d=g+h|0;d=(d|0)<(e|0)?e:d;e=ZT(d+256|0)|0;f=k[o>>2]|0;k[q>>2]=e+((k[q>>2]|0)-f);if((g|0)>0)upb(e|0,f|0,g|0)|0;k[o>>2]=e;k[n>>2]=e+d;d=e+g|0}upb(d|0,c|0,h|0)|0;e=d+h|0;k[q>>2]=e;h=0;g=0}else{h=l-c|0;j=h+1|0;e=k[n>>2]|0;if((d+j|0)>>>0>=e>>>0){f=k[o>>2]|0;g=d-f|0;e=((e-f|0)*3|0)/2|0;d=g+j|0;d=(d|0)<(e|0)?e:d;e=ZT(d+256|0)|0;f=k[o>>2]|0;k[q>>2]=e+((k[q>>2]|0)-f);if((g|0)>0)upb(e|0,f|0,g|0)|0;k[o>>2]=e;k[n>>2]=e+d;d=e+g|0}upb(d|0,c|0,j|0)|0;j=d+h|0;k[q>>2]=j;f=l+1|0;f:do if(!(f&3)){d=f;s=42}else{d=f;while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 10:break f;default:{}}d=d+1|0;if(!(d&3)){s=42;break f}}}while(0);g:do if((s|0)==42){s=0;e=k[d>>2]|0;h:do if(!((e&-2139062144^-2139062144)&e+-16843009))do{if((e&-2139062144^-2139062144)&(e^168430090)+-16843009|0)break h;d=d+4|0;e=k[d>>2]|0}while(!((e&-2139062144^-2139062144)&e+-16843009|0));while(0);while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 10:break g;default:d=d+1|0}}}while(0);h=f;g=e<<24>>24==10?d:0;e=j}d=k[o>>2]|0;f=k[p>>2]|0;if(e>>>0>(d+f|0)>>>0){i[e>>0]=10;i[e+1>>0]=0;$4(a,k[o>>2]|0);d=k[o>>2]|0;k[q>>2]=d;f=k[p>>2]|0}e=k[m>>2]|0;if((e|0)==(f|0))e=f;else{if((e|0)>(f|0)){zpb(d+f|0,32,e-f|0)|0;d=k[o>>2]|0}k[p>>2]=e}e=d+e|0;k[q>>2]=e;if(!h)break;else{l=g;c=h}}r=t;return}function s5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;if(k[a+12>>2]|0)return;b=a+36|0;if((k[(k[b>>2]|0)+24>>2]|0)>0)do n5(a);while((k[(k[b>>2]|0)+24>>2]|0)>0);e=a+40|0;k[e>>2]=0;g=a+72|0;d=k[g>>2]|0;h=a+76|0;b=k[h>>2]|0;f=a+56|0;c=k[f>>2]|0;if(d>>>0>(b+c|0)>>>0){i[d>>0]=10;i[d+1>>0]=0;$4(a,k[h>>2]|0);b=k[h>>2]|0;k[g>>2]=b;d=k[e>>2]|0;c=k[f>>2]|0}else d=0;if((d|0)!=(c|0)){if((d|0)>(c|0)){zpb(b+c|0,32,d-c|0)|0;b=k[h>>2]|0}k[f>>2]=d}k[g>>2]=b+d;$4(a,224621);$4(a,224626);k[g>>2]=k[h>>2];return}function t5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+1072|0;x=z+32|0;w=z+16|0;v=z;n=z+48|0;o=a+80|0;p=a+76|0;j=a+60|0;l=a+88|0;q=a+256|0;s=a+64|0;t=a+68|0;u=a+264|0;m=a+260|0;e=b;d=0;a:while(1){b=e+-1|0;b:do switch(c|0){case 1:{c=i[e>>0]|0;c:do if((c&255)>31|c<<24>>24==9)while(1){if((c<<24>>24==45?(i[b+2>>0]|0)==45:0)?(i[b+3>>0]|0)==62:0){c=45;break c}f=e+1|0;c=i[f>>0]|0;if((c&255)>31|c<<24>>24==9){b=e;e=f}else{b=e;e=f;break}}while(0);g=c<<24>>24==45;c=g&1^1;b=g?b+4|0:e;break}case 3:{while(1){b=b+1|0;c=i[b>>0]|0;d=(c<<24>>24==60&1)+d+((c<<24>>24==62)<<31>>31)|0;if((d|0)<0){y=43;break a}if(!((c&255)>31|c<<24>>24==9)){c=3;break}}break}default:{d:while(1){f=b+1|0;e=i[f>>0]|0;switch(e<<24>>24){case 9:case 32:{b=f;break}case 60:break d;default:{y=18;break d}}}if((y|0)==18){y=0;if((e&255)>31){b=f;y=43;break a}else{b=f;break b}}if((i[b+2>>0]|0)!=33){b=f;y=43;break a}if((i[b+3>>0]|0)!=45){b=f;y=43;break a}if((i[b+4>>0]|0)!=45){b=f;y=43;break a}if(c|0){g=k[l>>2]|0;k[v>>2]=k[j>>2];k[v+4>>2]=g;k[v+8>>2]=224542;Cfb(n,222630,v);l9(224572,n,1782)}c=1;b=b+5|0}}while(0);e=i[b>>0]|0;if((e&255)>31){e=b;continue}b=k[p>>2]|0;f=(k[o>>2]|0)-b|0;switch(e<<24>>24){case 13:case 10:case 0:break;default:{b=k[l>>2]|0;k[w>>2]=k[j>>2];k[w+4>>2]=b;k[w+8>>2]=224589;Cfb(n,222630,w);l9(224572,n,1794);b=k[p>>2]|0}}g=e5(a,b,f)|0;if(!g){y=42;break}f=g;e:do if(!(f&3)){b=g;y=26}else{e=g;b=f;while(1){if(!(i[e>>0]|0))break e;e=e+1|0;b=e;if(!(b&3)){b=e;y=26;break}}}while(0);if((y|0)==26){y=0;while(1){e=k[b>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))b=b+4|0;else break}if((e&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}f:do switch(i[g+(b-f+-1)>>0]|0){case 13:case 10:break;default:{do if(!(k[q>>2]|0)){b=k[s>>2]|0;if(b|0){h=(k[b>>2]|0)>>>4&1;y=39;break}b=k[t>>2]|0;if(b|0?(k[b+12>>2]|0)==7247:0){h=k[b+56>>2]|0;y=39}}else{h=(k[u>>2]|0)>>>0>=(k[m>>2]|0)>>>0&1;y=39}while(0);if((y|0)==39?(y=0,h|0):0)break f;f=k[l>>2]|0;k[x>>2]=k[j>>2];k[x+4>>2]=f;k[x+8>>2]=223667;Cfb(n,222630,x);l9(224572,n,1807)}}while(0);k[l>>2]=(k[l>>2]|0)+1;e=g}if((y|0)==42){y=k[p>>2]|0;i[y>>0]=0;k[a+92>>2]=1;r=z;return y|0}else if((y|0)==43){r=z;return b|0}return 0}function u5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=r;r=r+1200|0;D=H+160|0;E=H+144|0;G=H+128|0;C=H+112|0;B=H+96|0;A=H+80|0;z=H+64|0;j=H+48|0;h=H+32|0;g=H+16|0;F=H+176|0;y=H;f=i[b>>0]|0;if(!(f<<24>>24)){f=k[a+88>>2]|0;k[g>>2]=k[a+60>>2];k[g+4>>2]=f;k[g+8>>2]=224187;Cfb(F,222630,g);l9(224217,F,2077);f=i[b>>0]|0}if(f<<24>>24!=60){x=k[a+88>>2]|0;k[h>>2]=k[a+60>>2];k[h+4>>2]=x;k[h+8>>2]=224232;Cfb(F,222630,h);l9(224217,F,2080)}f=b+1|0;g=i[f>>0]|0;a:do if((g+-48&255)<10|((g&-33)+-65&255)<26)u=1;else switch(g<<24>>24){case 95:{u=1;break a}case 47:{f=b+2|0;u=2;break a}case 63:{f=b+2|0;u=4;break a}case 33:{f=b+2|0;u=5;break a}default:{u=k[a+88>>2]|0;k[j>>2]=k[a+60>>2];k[j+4>>2]=u;k[j+8>>2]=224258;Cfb(F,222630,j);l9(224217,F,2102);u=0;break a}}while(0);x=(u|0)==4;p=(u|0)==1;v=a+60|0;w=a+88|0;q=y+8+4|0;s=(u|0)==2;t=a+16|0;j=f;o=0;m=0;n=0;h=0;b:while(1){l=i[j>>0]|0;if(!(((l&-33)+-65&255)<26|l<<24>>24==95)){l=k[w>>2]|0;k[z>>2]=k[v>>2];k[z+4>>2]=l;k[z+8>>2]=224275;Cfb(F,222630,z);l9(224217,F,2109)}f=j+-1|0;c:while(1){f=f+1|0;g=i[f>>0]|0;if((g+-48&255)<10|((g&-33)+-65&255)<26)continue;switch(g<<24>>24){case 45:case 95:break;default:break c}}l=B5(a,j,f-j|0)|0;if(!o){o=l;b=m}else{if(s){j=k[w>>2]|0;k[A>>2]=k[v>>2];k[A+4>>2]=j;k[A+8>>2]=224321;Cfb(F,222630,A);l9(224217,F,2123)}j=(n|0)!=0;if((h|0)>3|j^1){g=FY(k[t>>2]|0,44)|0;h=g+4|0;b=h+40|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(b|0));k[g>>2]=g+8;if(j){k[n+4>>2]=g;h=0;b=m}else{h=0;b=g}}else{b=m;g=n}k[(k[g>>2]|0)+(h<<1<<2)>>2]=k[l+8>>2];n=g}if(!n)l=h;else{if((i[f>>0]|0)!=61){f=t5(a,f,2)|0;if((i[f>>0]|0)!=61){m=k[w>>2]|0;k[B>>2]=k[v>>2];k[B+4>>2]=m;k[B+8>>2]=224367;Cfb(F,222630,B);l9(224217,F,2149)}}f=f+1|0;d:do switch(i[f>>0]|0){case 39:case 34:break;default:{f=t5(a,f,2)|0;switch(i[f>>0]|0){case 39:case 34:break d;default:{}}m=k[w>>2]|0;k[C>>2]=k[v>>2];k[C+4>>2]=m;k[C+8>>2]=224408;Cfb(F,222630,C);l9(224217,F,2157)}}while(0);f=v5(a,f,y,3)|0;k[(k[n>>2]|0)+((h<<1|1)<<2)>>2]=k[q>>2];l=h+1|0}h=i[f>>0]|0;if(h<<24>>24==62){g=34;break}f=t5(a,f,2)|0;g=i[f>>0]|0;if(g<<24>>24==62){g=34;break}if(x&g<<24>>24==63){g=38;break}if(g<<24>>24==47?p&(i[f+1>>0]|0)==62:0){g=43;break}switch(h<<24>>24){case 0:case 9:case 10:case 11:case 12:case 13:case 32:{j=f;m=b;h=l;continue b}default:{}}j=k[w>>2]|0;k[D>>2]=k[v>>2];k[D+4>>2]=j;k[D+8>>2]=224501;Cfb(F,222630,D);l9(224217,F,2197);j=f;m=b;h=l}if((g|0)==34){if(x){E=k[w>>2]|0;k[G>>2]=k[v>>2];k[G+4>>2]=E;k[G+8>>2]=224467;Cfb(F,222630,G);l9(224217,F,2178)}F=u;G=f+1|0;k[c>>2]=o;k[e>>2]=F;k[d>>2]=b;r=H;return G|0}else if((g|0)==38){if((i[f+1>>0]|0)!=62){G=k[w>>2]|0;k[E>>2]=k[v>>2];k[E+4>>2]=G;k[E+8>>2]=224467;Cfb(F,222630,E);l9(224217,F,2185)}F=4;G=f+2|0;k[c>>2]=o;k[e>>2]=F;k[d>>2]=b;r=H;return G|0}else if((g|0)==43){F=3;G=f+2|0;k[c>>2]=o;k[e>>2]=F;k[d>>2]=b;r=H;return G|0}return 0}function v5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0;ia=r;r=r+5360|0;ga=ia+192|0;$=ia+176|0;_=ia+160|0;Z=ia+144|0;Y=ia+128|0;X=ia+112|0;V=ia+96|0;U=ia+80|0;T=ia+64|0;S=ia+48|0;aa=ia+32|0;W=ia+16|0;R=ia;fa=ia+4336|0;M=ia+4328|0;N=ia+216|0;O=ia+212|0;P=ia+208|0;Q=ia+204|0;ha=d&16;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;da=d&7;ba=a+60|0;ca=a+88|0;t=(da|0)==3;u=a+16|0;v=(da+-1|0)>>>0<4;ea=c+8|0;w=fa+4|0;x=fa+44|0;y=fa+8|0;z=fa+76|0;A=fa+104|0;B=fa+108|0;C=fa+100|0;D=N;E=(D&3|0)==0;F=fa+4|0;G=fa+44|0;H=fa+8|0;I=fa+76|0;J=fa+104|0;K=fa+108|0;L=fa+100|0;g=1;e=1;a:while(1){d=i[b>>0]|0;switch(d<<24>>24){case 0:case 9:case 10:case 11:case 12:case 13:case 32:{s=5;break}case 60:{f=i[b+1>>0]|0;if(f<<24>>24==33)if((i[b+2>>0]|0)==45)s=5;else{d=60;f=33;s=7}else{d=60;s=7}break}default:{f=g;s=6}}if((s|0)==5){b=t5(a,b,0)|0;d=i[b>>0]|0;f=1;s=6}b:do if((s|0)==6){s=0;h=i[b+1>>0]|0;switch(d<<24>>24){case 0:case 60:{g=f;f=h;s=7;break b}default:{}}if(!f){q=k[ca>>2]|0;k[T>>2]=k[ba>>2];k[T+4>>2]=q;k[T+8>>2]=223885;Cfb(fa,222630,T);l9(223777,fa,1911)}f=k[c>>2]|0;if(!f)q=c;else{if((f&7)>>>0<=4){f=HY(0,56,16,k[u>>2]|0)|0;if(k[c>>2]&7|0)SY(f,c)|0;k[ea>>2]=f;k[c>>2]=5;IY(f,8)}q=SY(k[ea>>2]|0,0)|0;k[q+4>>2]=0}c:do if(!t){d:do if((d+-48&255)<10)f=d;else switch(d<<24>>24){case 43:case 45:if(h<<24>>24==46|(h+-48&255)<10){f=d;break d}else{s=67;break c}case 46:if((h+-48&255)<10|((h&-33)+-65&255)<26){f=46;break d}else{s=67;break c}default:{s=67;break c}}while(0);f=b+((d<<24>>24==43|f<<24>>24==45)&1)|0;while(1){k[M>>2]=f;d=i[f>>0]|0;if((d+-48&255)<10)f=f+1|0;else break}switch(d<<24>>24){case 101:case 46:{ja=+y5(a,b,M);k[q>>2]=2;p[q+8>>3]=ja;d=k[M>>2]|0;break}default:{k[fa>>2]=0;k[F>>2]=b;k[G>>2]=b;o=(b|0)<0?-1:b+2147483647|0;k[H>>2]=o;k[I>>2]=-1;k[J>>2]=0;k[K>>2]=o-b;k[L>>2]=o;o=Efb(fa,0,1,-2147483648,0)|0;d=b+((k[F>>2]|0)+(k[K>>2]|0)-(k[H>>2]|0))|0;k[M>>2]=d;k[q>>2]=1;k[q+8>>2]=o}}if((d|0)==(b|0)){q=k[ca>>2]|0;k[U>>2]=k[ba>>2];k[U+4>>2]=q;k[U+8>>2]=223040;Cfb(fa,222630,U);l9(223777,fa,1948)}else b=d}else s=67;while(0);if((s|0)==67){s=0;k[q>>2]=3;o=d<<24>>24==34;d=0;l=o?b:b+-1|0;e:while(1){b=l+1|0;f=i[b>>0]|0;f:do if((f+-48&255)<10|((f&-33)+-65&255)<26)g=f;else{if(f<<24>>24==34){s=70;break e}if((f&255)<32|f<<24>>24==60){s=76;break e}if(o)switch(f<<24>>24){case 62:case 39:{s=79;break}case 38:break;default:{g=f;break f}}else switch(f<<24>>24){case 9:case 10:case 11:case 12:case 13:case 32:break e;case 62:case 39:{s=79;break}case 38:break;default:{g=f;break f}}if((s|0)==79){s=0;g=k[ca>>2]|0;k[Y>>2]=k[ba>>2];k[Y+4>>2]=g;k[Y+8>>2]=223999;Cfb(fa,222630,Y);l9(223777,fa,1983);g=f;break}j=l+2|0;if((i[j>>0]|0)==35){b=l+3|0;f=(i[b>>0]|0)==120;b=f?l+4|0:b;k[fa>>2]=0;k[w>>2]=b;k[x>>2]=b;n=(b|0)<0?-1:b+2147483647|0;k[y>>2]=n;k[z>>2]=-1;k[A>>2]=0;k[B>>2]=n-b;k[C>>2]=n;f=Efb(fa,f?16:10,1,-2147483648,0)|0;b=b+((k[w>>2]|0)+(k[B>>2]|0)-(k[y>>2]|0))|0;k[M>>2]=b;if(!(f>>>0<256?(i[b>>0]|0)==59:0)){n=k[ca>>2]|0;k[Z>>2]=k[ba>>2];k[Z+4>>2]=n;k[Z+8>>2]=224050;Cfb(fa,222630,Z);l9(223777,fa,1999)}g=f&255;break}k[M>>2]=j;n=j;do{n=n+1|0;g=i[n>>0]|0}while((g+-48&255)<10|((g&-33)+-65&255)<26);k[M>>2]=n;if(g<<24>>24!=59){m=k[ca>>2]|0;k[_>>2]=k[ba>>2];k[_+4>>2]=m;k[_+8>>2]=224086;Cfb(fa,222630,_);l9(223777,fa,2008)}m=n-j|0;switch(m|0){case 2:{f=i[j>>0]|0;if(f<<24>>24==108){f=i[l+3>>0]|0;if(f<<24>>24==116){g=60;b=n;break f}else h=116}else h=108;if((f&255|0)==(h|0)){g=60;b=n;break f}f=i[j>>0]|0;if(f<<24>>24==103){f=i[l+3>>0]|0;if(f<<24>>24==116){g=62;b=n;break f}else h=116}else h=103;if((f&255|0)==(h|0)){g=62;b=n;break f}break}case 3:{f=i[j>>0]|0;if(f<<24>>24==97){f=i[l+3>>0]|0;if(f<<24>>24==109){f=i[l+4>>0]|0;if(f<<24>>24==112){g=38;b=n;break f}else h=112}else h=109}else h=97;if((f&255|0)==(h|0)){g=38;b=n;break f}break}case 4:{f=i[j>>0]|0;if(f<<24>>24==97){f=i[l+3>>0]|0;if(f<<24>>24==112){f=i[l+4>>0]|0;if(f<<24>>24==111){f=i[l+5>>0]|0;if(f<<24>>24==115){g=39;b=n;break f}else h=115}else h=111}else h=112}else h=97;if((f&255|0)==(h|0)){g=39;b=n;break f}f=i[j>>0]|0;do if(f<<24>>24==113){f=i[l+3>>0]|0;if(f<<24>>24==117){f=i[l+4>>0]|0;if(f<<24>>24!=111){h=111;break}f=i[l+5>>0]|0;if(f<<24>>24==116){g=34;b=n;break f}else h=116}else h=117}else h=113;while(0);if((f&255|0)==(h|0)){g=34;b=n;break f}break}default:{}}m=m+2|0;upb(N+d|0,b|0,m|0)|0;d=m+d|0;b=n}while(0);f=d+1|0;i[N+d>>0]=g;if((d|0)<=4094){d=f;l=b;continue}d=k[ca>>2]|0;k[$>>2]=k[ba>>2];k[$+4>>2]=d;k[$+8>>2]=223124;Cfb(fa,222630,$);l9(223777,fa,2031);d=f;l=b}if((s|0)==70){s=0;if(!o){o=k[ca>>2]|0;k[V>>2]=k[ba>>2];k[V+4>>2]=o;k[V+8>>2]=223924;Cfb(fa,222630,V);l9(223777,fa,1971)}b=l+2|0}else if((s|0)==76){s=0;if(o){o=k[ca>>2]|0;k[X>>2]=k[ba>>2];k[X+4>>2]=o;k[X+8>>2]=223977;Cfb(fa,222630,X);l9(223777,fa,1978)}}g=k[u>>2]|0;if((d|0)<=-1){g:do if(E){d=N;s=112}else{f=N;d=D;while(1){if(!(i[f>>0]|0))break g;f=f+1|0;d=f;if(!(d&3)){d=f;s=112;break}}}while(0);if((s|0)==112){s=0;while(1){f=k[d>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))d=d+4|0;else break}if((f&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}d=d-D|0}o=FY(g,d+1|0)|0;upb(o|0,N|0,d|0)|0;i[o+d>>0]=0;q=q+8|0;k[q>>2]=d;k[q+4>>2]=o}if(v)break a;else d=0}while(0);if((s|0)==7){s=0;k[N>>2]=0;k[O>>2]=0;k[P>>2]=0;k[Q>>2]=0;if(!(f<<24>>24==47|d<<24>>24==0)){n=u5(a,b,N,P,Q)|0;switch(k[Q>>2]|0){case 5:{q=k[ca>>2]|0;k[R>>2]=k[ba>>2];k[R+4>>2]=q;k[R+8>>2]=223741;Cfb(fa,222630,R);l9(223777,fa,1861);break}case 3:{q=k[ca>>2]|0;k[W>>2]=k[ba>>2];k[W+4>>2]=q;k[W+8>>2]=223794;Cfb(fa,222630,W);l9(223777,fa,1863);break}default:{}}d=k[P>>2]|0;h:do if(d){i:while(1){m=k[d>>2]|0;if(!m){g=0;d=0;break h}b=k[m>>2]|0;if(b|0){l=0;f=0;do{g=i[b>>0]|0;if(g<<24>>24==116){h=223823;do{h=h+1|0;b=b+1|0;j=i[h>>0]|0;g=i[b>>0]|0}while(!(j<<24>>24==0?1:j<<24>>24!=g<<24>>24));b=j}else b=116;l=l+1|0;if(b<<24>>24==g<<24>>24)break i;f=l<<1;b=k[m+(f<<2)>>2]|0}while((b|0)!=0)}d=k[d+4>>2]|0;if(!d){g=0;d=0;break h}}j=k[m+((f|1)<<2)>>2]|0;if(j){l=i[j>>0]|0;h=l<<24>>24==115;if(h){d=223028;b=j;do{b=b+1|0;d=d+1|0;f=i[b>>0]|0;g=i[d>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=g<<24>>24));if(f<<24>>24==g<<24>>24){g=3;d=0;break}}if(l<<24>>24==109){d=223036;b=j;do{b=b+1|0;d=d+1|0;f=i[b>>0]|0;g=i[d>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=g<<24>>24));if(f<<24>>24==g<<24>>24){g=6;d=0;break}}if(h){d=223032;b=j;do{b=b+1|0;d=d+1|0;f=i[b>>0]|0;g=i[d>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=g<<24>>24));if(f<<24>>24==g<<24>>24){g=5;d=0;break}}d=k[107193]|0;j:do if(!d)d=0;else while(1){f=k[d+16>>2]|0;b=i[f>>0]|0;if(b<<24>>24==0?1:b<<24>>24!=l<<24>>24)f=l;else{h=j;do{f=f+1|0;h=h+1|0;b=i[f>>0]|0;g=i[h>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=g<<24>>24));f=g}if(b<<24>>24==f<<24>>24)break j;d=k[d+12>>2]|0;if(!d){d=0;break}}while(0);g=(d|0)==0?0:16}else{g=0;d=0}}else{g=0;d=0}while(0);h=k[N>>2]|0;if((k[h+4>>2]|0)==1)f=(i[k[h+8>>2]>>0]|0)==95;else f=0;b=k[c>>2]&7;if(b>>>0>4){if(f^(b|0)==5){q=k[ca>>2]|0;k[aa>>2]=k[ba>>2];k[aa+4>>2]=q;k[aa+8>>2]=f?223831:223514;Cfb(fa,222630,aa);l9(223777,fa,1891)}}else z5(a,f?5:6,c);if(f){b=SY(k[ea>>2]|0,0)|0;g=v5(a,n,b,g)|0;f=b;b=k[b>>2]|0}else{f=C5(a,c,h)|0;g=v5(a,n,f,g)|0;b=k[f>>2]|64;k[f>>2]=b}e=(b&7)>>>0<5&e;k[f+4>>2]=d;b=u5(a,g,O,P,Q)|0;if((k[Q>>2]|0)==2?(k[O>>2]|0)==(h|0):0){f=1;d=1}else{f=k[ca>>2]|0;k[S>>2]=k[ba>>2];k[S+4>>2]=f;k[S+8>>2]=223862;Cfb(fa,222630,S);l9(223777,fa,1905);f=1;d=1}}else{f=0;d=g}if(!f)break}g=d}d=k[c>>2]&7;if(!d){if(da>>>0>4)s=124}else if(da>>>0>4&(d>>>0<5&(d|0)!=(da|0)))s=124;if((s|0)==124)z5(a,(da|0)==6?6:5,c);if(da|0?(da|0)!=(k[c>>2]&7|0):0){a=k[ca>>2]|0;k[ga>>2]=k[ba>>2];k[ga+4>>2]=a;k[ga+8>>2]=224134;Cfb(fa,222630,ga);l9(223777,fa,2053)}d=k[c>>2]|0;if(!((e|0)!=0&(d&7)>>>0>4)){ha=d|ha;k[c>>2]=ha;r=ia;return b|0}ga=k[ea>>2]|0;k[ga>>2]=k[ga>>2]|256;ha=d|ha;k[c>>2]=ha;r=ia;return b|0}function w5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+1072|0;w=y+32|0;v=y+16|0;u=y;m=y+48|0;h=a+60|0;j=a+88|0;n=a+80|0;o=a+76|0;p=a+256|0;q=a+64|0;s=a+68|0;t=a+264|0;l=a+260|0;a:while(1){b:while(1){d=i[b>>0]|0;switch(d<<24>>24){case 35:{x=5;break b}case 32:break;default:break b}b=b+1|0}if((x|0)==5){x=0;i[b>>0]=0;continue}if((d&255)>31)break;switch(d<<24>>24){case 13:case 10:case 0:break;default:{f=k[j>>2]|0;k[w>>2]=k[h>>2];k[w+4>>2]=f;k[w+8>>2]=d<<24>>24==9?223712:223106;Cfb(m,222630,w);l9(223650,m,991);continue a}}b=k[o>>2]|0;b=e5(a,b,(k[n>>2]|0)-b|0)|0;if(!b){x=30;break}f=b;c:do if(!(f&3)){d=b;x=14}else{e=b;d=f;while(1){if(!(i[e>>0]|0))break c;e=e+1|0;d=e;if(!(d&3)){d=e;x=14;break}}}while(0);if((x|0)==14){x=0;while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}d:do switch(i[b+(d-f+-1)>>0]|0){case 13:case 10:break;default:{do if(!(k[p>>2]|0)){d=k[q>>2]|0;if(d|0){g=(k[d>>2]|0)>>>4&1;x=27;break}d=k[s>>2]|0;if(d|0?(k[d+12>>2]|0)==7247:0){g=k[d+56>>2]|0;x=27}}else{g=(k[t>>2]|0)>>>0>=(k[l>>2]|0)>>>0&1;x=27}while(0);if((x|0)==27?(x=0,g|0):0)break d;f=k[j>>2]|0;k[v>>2]=k[h>>2];k[v+4>>2]=f;k[v+8>>2]=223667;Cfb(m,222630,v);l9(223650,m,985)}}while(0);k[j>>2]=(k[j>>2]|0)+1}if((x|0)==30){x=k[o>>2]|0;i[x+2>>0]=46;i[x+1>>0]=46;i[x>>0]=46;i[x+3>>0]=0;k[a+92>>2]=1;r=y;return x|0}if((b-(k[o>>2]|0)|0)>=(c|0)){x=b;r=y;return x|0}x=k[j>>2]|0;k[u>>2]=k[h>>2];k[u+4>>2]=x;k[u+8>>2]=223279;Cfb(m,222630,u);l9(223650,m,965);x=b;r=y;return x|0}function x5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0;K=r;r=r+6368|0;E=K+1216|0;D=K+1200|0;C=K+1184|0;z=K+1168|0;t=K+1152|0;s=K+1136|0;w=K+1120|0;v=K+1104|0;B=K+1088|0;y=K+1072|0;x=K+1056|0;o=K+1040|0;l=K+1024|0;J=K;G=K+1240|0;F=K+1232|0;H=K+1228|0;k[F>>2]=0;f=i[b>>0]|0;h=b+1|0;g=i[h>>0]|0;q=d&8;A=(q|0)!=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;a:do if(f<<24>>24==33){switch(g<<24>>24){case 94:case 33:{b=h;d=16;break}default:d=0}k[F>>2]=b;h=b;do{h=h+1|0;k[F>>2]=h;g=i[h>>0]|0}while((g&255)>=33);n=b+1|0;j=h-n|0;do if(!j){f=k[a+88>>2]|0;k[l>>2]=k[a+60>>2];k[l+4>>2]=f;k[l+8>>2]=222995;Cfb(J,222630,l);l9(223011,J,1057);f=i[h>>0]|0;i[h>>0]=0;if(!d){d=0;g=f}else{g=f;I=28}}else{i[h>>0]=0;f=(d|0)==0;if(!(f&(j|0)==3)){if(!(f&(j|0)==5))if(f){d=0;break}else{I=28;break}f=i[n>>0]|0;if(f<<24>>24==102){f=i[b+2>>0]|0;if(f<<24>>24==108){f=i[b+3>>0]|0;if(f<<24>>24==111){f=i[b+4>>0]|0;if(f<<24>>24==97){f=i[b+5>>0]|0;if(f<<24>>24==116)f=0;else{b=116;I=25}}else{b=97;I=25}}else{b=111;I=25}}else{b=108;I=25}}else{b=102;I=25}if((I|0)==25)f=(f&255)-b|0;d=(f|0)==0?2:0;break}f=i[n>>0]|0;if(f<<24>>24==115){f=i[b+2>>0]|0;if(f<<24>>24==116){f=i[b+3>>0]|0;if(f<<24>>24==114){d=3;break}else d=114}else d=116}else d=115;if((f&255|0)!=(d|0)){f=i[n>>0]|0;if(f<<24>>24==105){f=i[b+2>>0]|0;if(f<<24>>24==110){f=i[b+3>>0]|0;if(f<<24>>24==116){d=1;break}else d=116}else d=110}else d=105;if((f&255|0)!=(d|0)){f=i[n>>0]|0;if(f<<24>>24==115){f=i[b+2>>0]|0;if(f<<24>>24==101){f=i[b+3>>0]|0;if(f<<24>>24==113){d=5;break}else d=113}else d=101}else d=115;if((f&255|0)==(d|0))d=5;else{f=i[n>>0]|0;if(f<<24>>24==109){f=i[b+2>>0]|0;if(f<<24>>24==97){f=i[b+3>>0]|0;if(f<<24>>24==112)f=0;else{b=112;I=20}}else{b=97;I=20}}else{b=109;I=20}if((I|0)==20)f=(f&255)-b|0;d=(f|0)==0?6:0}}else d=1}else d=3}while(0);b:do if((I|0)==28){f=k[107193]|0;c:do if(f|0){m=i[n>>0]|0;while(1){h=k[f+16>>2]|0;b=i[h>>0]|0;if(b<<24>>24==0?1:b<<24>>24!=m<<24>>24)h=m;else{l=n;do{h=h+1|0;l=l+1|0;b=i[h>>0]|0;j=i[l>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=j<<24>>24));h=j}if(b<<24>>24==h<<24>>24)break;f=k[f+12>>2]|0;if(!f)break c}k[c+4>>2]=f;break b}while(0);k[c+4>>2]=0;k[c>>2]=k[c>>2]&-17}while(0);b=k[F>>2]|0;i[b>>0]=g;b=w5(a,b,e)|0;f=i[b>>0]|0;if(!(d&16)){switch(d|0){case 1:{I=47;break a}case 2:{I=46;break a}case 3:break;default:{I=39;break a}}switch(f<<24>>24){case 34:case 39:{d=3;I=39;break}default:{d=3;I=110}}}else I=39}else{d=0;I=39}while(0);d:do if((I|0)==39){e:do if((f+-48&255)>=10){switch(f<<24>>24){case 43:case 45:{if(g<<24>>24==46|(g+-48&255)<10)break e;else I=50;break}case 46:{if((g+-48&255)<10|((g&-33)+-65&255)<26)break e;break}default:I=50}f:do if((I|0)==50){g=f<<24>>24==39;switch(f<<24>>24){case 34:case 39:break;default:{o=f<<24>>24==91;switch(f<<24>>24){case 91:case 123:break;default:if(f<<24>>24==45&(A^1)){g=5;break d}else break f}m=(q>>>3^1)+e|0;h=f<<24>>24==123?14:13;j=h&7;z5(a,(k[c+4>>2]|0?16:0)|j,c);n=c+8|0;j=(j|0)==6;d=a+60|0;g=a+88|0;l=1;f=b+1|0;g:while(1){k[H>>2]=0;f=w5(a,f,m)|0;b=i[f>>0]|0;switch(b<<24>>24){case 93:case 125:{I=92;break g}default:{}}if(k[(k[n>>2]|0)+24>>2]|0){if(b<<24>>24!=44){G=k[g>>2]|0;k[w>>2]=k[d>>2];k[w+4>>2]=G;k[w+8>>2]=223174;Cfb(J,222630,w);l9(223011,J,1227)}f=w5(a,f+1|0,m)|0}if(j){f=w5(a,A5(a,f,c,H)|0,m)|0;G=k[H>>2]|0;f=x5(a,f,G,h,m)|0;b=k[G>>2]|64;k[G>>2]=b}else{if((i[f>>0]|0)==93)break;b=SY(k[n>>2]|0,0)|0;k[H>>2]=b;f=x5(a,f,b,h,m)|0;b=k[b>>2]|0}l=(b&7)>>>0<5&l}if((I|0)==92){if((b<<24>>24|0)!=((o?93:125)|0)){c=k[g>>2]|0;k[v>>2]=k[d>>2];k[v+4>>2]=c;k[v+8>>2]=223148;Cfb(J,222630,v);l9(223011,J,1219)}f=f+1|0}c=k[n>>2]|0;k[c>>2]=k[c>>2]|(l|0?256:0);c=f;r=K;return c|0}}k[c>>2]=3;s=a+60|0;t=a+88|0;h:do if(g){d=0;while(1){g=b+1|0;f=i[g>>0]|0;i:do if((f+-48&255)<10|((f&-33)+-65&255)<26){b=g;I=57}else{while(1){if(f<<24>>24!=39&(f&255)>31){b=g;I=57;break i}if(f<<24>>24==39)break;b=k[t>>2]|0;k[x>>2]=k[s>>2];k[x+4>>2]=b;k[x+8>>2]=223106;Cfb(J,222630,x);l9(223011,J,1149);b=g+1|0;f=i[b>>0]|0;if((f+-48&255)<10|((f&-33)+-65&255)<26){I=57;break i}else{H=g;g=b;b=H}}b=b+2|0;if((i[b>>0]|0)!=39){I=78;break h}i[G+d>>0]=39}while(0);if((I|0)==57){I=0;i[G+d>>0]=f}d=d+1|0;if((d|0)>=4096){I=77;break}}}else{j=J+4|0;l=J+44|0;m=J+8|0;n=J+76|0;o=J+104|0;q=J+108|0;e=J+100|0;d=0;j:while(1){g=b+1|0;f=i[g>>0]|0;k:do if((f+-48&255)<10|((f&-33)+-65&255)<26)I=64;else{switch(f<<24>>24){case 34:break j;case 92:break;default:{if((f&255)>31){I=64;break k}b=k[t>>2]|0;k[y>>2]=k[s>>2];k[y+4>>2]=b;k[y+8>>2]=223106;Cfb(J,222630,y);l9(223011,J,1192);b=g;break k}}h=b+2|0;f=i[h>>0]|0;switch(f<<24>>24){case 39:{i[G+d>>0]=39;d=d+1|0;b=h;break k}case 92:case 34:{i[G+d>>0]=f;d=d+1|0;b=h;break k}case 110:{i[G+d>>0]=10;d=d+1|0;b=h;break k}case 114:{i[G+d>>0]=13;d=d+1|0;b=h;break k}case 116:{i[G+d>>0]=9;d=d+1|0;b=h;break k}default:{g=f<<24>>24==120;if(!g?!(f<<24>>24<56&(f+-48&255)<10):0){b=h;break k}D=b+5|0;C=i[D>>0]|0;i[D>>0]=0;b=h+(g&1)|0;k[J>>2]=0;k[j>>2]=b;k[l>>2]=b;E=(b|0)<0?-1:b+2147483647|0;k[m>>2]=E;k[n>>2]=-1;k[o>>2]=0;k[q>>2]=E-b;k[e>>2]=E;E=Efb(J,g?8:16,1,-2147483648,0)|0;H=(k[j>>2]|0)+(k[q>>2]|0)-(k[m>>2]|0)|0;b=b+H|0;k[F>>2]=b;i[D>>0]=C;H=(H|0)==0;i[G+d>>0]=H?120:E&255;d=d+1|0;b=H?h:b;break k}}}while(0);if((I|0)==64){I=0;i[G+d>>0]=f;d=d+1|0;b=g}if((d|0)>=4096){I=77;break h}}b=b+2|0;I=78}while(0);if((I|0)==77){f=k[t>>2]|0;k[B>>2]=k[s>>2];k[B+4>>2]=f;k[B+8>>2]=223124;Cfb(J,222630,B);l9(223011,J,1196);f=k[a+16>>2]|0;I=J;k[I>>2]=0;k[I+4>>2]=0}else if((I|0)==78){h=k[a+16>>2]|0;a=J;k[a>>2]=0;k[a+4>>2]=0;if((d|0)>-1)f=h;else{g=G;l:do if(!(g&3)){f=G;I=82}else{f=G;d=g;while(1){if(!(i[f>>0]|0)){f=d;break l}f=f+1|0;d=f;if(!(d&3)){I=82;break}}}while(0);if((I|0)==82){while(1){d=k[f>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))f=f+4|0;else break}if((d&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}d=f-g|0;f=h}}k[J>>2]=d;I=FY(f,d+1|0)|0;k[J+4>>2]=I;upb(I|0,G|0,d|0)|0;i[I+d>>0]=0;c=c+8|0;p[u>>3]=+p[J>>3];k[c>>2]=k[u>>2];k[c+4>>2]=k[u+4>>2];c=b;r=K;return c|0}while(0);if(A){I=110;break d}switch(f<<24>>24){case 63:{I=k[a+88>>2]|0;k[s>>2]=k[a+60>>2];k[s+4>>2]=I;k[s+8>>2]=223205;Cfb(J,222630,s);l9(223011,J,1259);I=110;break d}case 62:case 124:{I=k[a+88>>2]|0;k[t>>2]=k[a+60>>2];k[t+4>>2]=I;k[t+8>>2]=223236;Cfb(J,222630,t);l9(223011,J,1261);I=110;break d}default:{I=110;break d}}}while(0);d=b+((f<<24>>24==45|f<<24>>24==43)&1)|0;while(1){k[F>>2]=d;f=i[d>>0]|0;if((f+-48&255)<10)d=d+1|0;else break}switch(f<<24>>24){case 101:case 46:{I=46;break}default:I=47}}while(0);if((I|0)==46){L=+y5(a,b,F);k[c>>2]=2;p[c+8>>3]=L;f=k[F>>2]|0;I=48}else if((I|0)==47){k[J>>2]=0;E=J+4|0;k[E>>2]=b;k[J+44>>2]=b;H=(b|0)<0?-1:b+2147483647|0;f=J+8|0;k[f>>2]=H;k[J+76>>2]=-1;k[J+104>>2]=0;G=J+108|0;k[G>>2]=H-b;k[J+100>>2]=H;H=Efb(J,0,1,-2147483648,0)|0;f=b+((k[E>>2]|0)+(k[G>>2]|0)-(k[f>>2]|0))|0;k[F>>2]=f;k[c>>2]=1;k[c+8>>2]=H;I=48}else if((I|0)==110){k[F>>2]=b;f=i[b>>0]|0;if((f&255)>31){d=(d|0)==3;m:do if(A)if(d){d=b;while(1){switch(f<<24>>24){case 93:case 125:case 44:break m;default:{}}d=d+1|0;k[F>>2]=d;f=i[d>>0]|0;if((f&255)<=31)break m}}else{d=b;while(1){switch(f<<24>>24){case 93:case 125:case 44:break m;default:{}}d=d+1|0;k[F>>2]=d;f=i[d>>0]|0;if((f&255)<=31)break m}}else{if(d){f=b;while(1){d=f+1|0;k[F>>2]=d;f=i[d>>0]|0;if((f&255)>31)f=d;else break m}}else d=b;do{if(f<<24>>24==58){f=58;break m}d=d+1|0;k[F>>2]=d;f=i[d>>0]|0}while((f&255)>31)}while(0);if((d|0)==(b|0))I=122;else j=d}else I=122;if((I|0)==122){j=k[a+88>>2]|0;k[z>>2]=k[a+60>>2];k[z+4>>2]=j;k[z+8>>2]=223106;Cfb(J,222630,z);l9(223011,J,1273);j=b}if(f<<24>>24==58&(A^1))g=6;else{k[c>>2]=3;d=j;while(1){f=d+-1|0;if(f>>>0<=b>>>0)break;if((i[f>>0]|0)==32)d=f;else break}h=k[a+16>>2]|0;g=b;f=d-g|0;if((f|0)<=-1){n:do if(!(g&3)){f=b;I=148}else{f=b;d=g;while(1){if(!(i[f>>0]|0)){f=d;break n}f=f+1|0;d=f;if(!(d&3)){I=148;break}}}while(0);if((I|0)==148){while(1){d=k[f>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))f=f+4|0;else break}if((d&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}f=f-g|0}J=FY(h,f+1|0)|0;upb(J|0,b|0,f|0)|0;i[J+f>>0]=0;c=c+8|0;k[c>>2]=f;k[c+4>>2]=J;c=j;r=K;return c|0}}if((I|0)==48){if(!((f|0)==0|(f|0)==(b|0))){c=f;r=K;return c|0}c=k[a+88>>2]|0;k[o>>2]=k[a+60>>2];k[o+4>>2]=c;k[o+8>>2]=223040;Cfb(J,222630,o);l9(223011,J,1128);c=f;r=K;return c|0}z5(a,(k[c+4>>2]|0?16:0)|g,c);l=a+76|0;m=b-(k[l>>2]|0)|0;n=m+1|0;h=a+60|0;j=a+88|0;o=c+8|0;o:do if((g|0)==6){f=1;do{k[H>>2]=0;b=w5(a,A5(a,b,c,H)|0,n)|0;G=k[H>>2]|0;b=x5(a,b,G,6,n)|0;d=k[G>>2]|0;k[G>>2]=d|64;f=(d&7)>>>0<5&f;b=w5(a,b,0)|0;d=b-(k[l>>2]|0)|0;if((d|0)!=(m|0)){if((d|0)<(m|0)){I=142;break o}G=k[j>>2]|0;k[C>>2]=k[h>>2];k[C+4>>2]=G;k[C+8>>2]=223279;Cfb(J,222630,C);l9(223011,J,1327)}}while(!(((i[b>>0]|0)==46?(i[b+1>>0]|0)==46:0)?(i[b+2>>0]|0)==46:0))}else{f=1;do{k[H>>2]=0;if((i[b>>0]|0)!=45){c=k[j>>2]|0;k[D>>2]=k[h>>2];k[D+4>>2]=c;k[D+8>>2]=223301;Cfb(J,222630,D);l9(223011,J,1310)}d=SY(k[o>>2]|0,0)|0;k[H>>2]=d;b=x5(a,w5(a,b+1|0,n)|0,d,g,n)|0;f=(k[d>>2]&7)>>>0<5&f;b=w5(a,b,0)|0;d=b-(k[l>>2]|0)|0;if((d|0)!=(m|0)){if((d|0)<(m|0)){I=142;break o}c=k[j>>2]|0;k[E>>2]=k[h>>2];k[E+4>>2]=c;k[E+8>>2]=223279;Cfb(J,222630,E);l9(223011,J,1327)}}while(!(((i[b>>0]|0)==46?(i[b+1>>0]|0)==46:0)?(i[b+2>>0]|0)==46:0))}while(0);c=k[o>>2]|0;k[c>>2]=k[c>>2]|(f|0?256:0);c=b;r=K;return c|0}function y5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0.0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;p=r;r=r+1056|0;n=p+16|0;m=p;l=p+32|0;g=l;h=g+108|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=l+4|0;k[g>>2]=b;h=l+8|0;k[h>>2]=-1;k[l+44>>2]=b;k[l+76>>2]=-1;k[l+104>>2]=0;j=~b;e=l+108|0;k[e>>2]=j;k[l+100>>2]=-1;d=+Ifb(l,1,1);e=(k[g>>2]|0)-(k[h>>2]|0)+(k[e>>2]|0)|0;if(!c)Vd();e=e|0?b+e|0:b;k[c>>2]=e;if((i[e>>0]|0)==46){i[e>>0]=44;g=l;h=g+108|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));q=l+4|0;k[q>>2]=b;h=l+8|0;k[h>>2]=-1;k[l+44>>2]=b;k[l+76>>2]=-1;k[l+104>>2]=0;g=l+108|0;k[g>>2]=j;k[l+100>>2]=-1;f=+Ifb(l,1,1);g=(k[q>>2]|0)-(k[h>>2]|0)+(k[g>>2]|0)|0;k[c>>2]=g|0?b+g|0:b;i[e>>0]=46;g=k[c>>2]|0;if(g>>>0>e>>>0){d=f;e=g}else k[c>>2]=e}if((e|0)!=(b|0)?((i[e>>0]&-33)+-65&255)>=26:0){f=d;r=p;return +f}e=i[b>>0]|0;switch(e<<24>>24){case 43:case 45:{b=b+1|0;d=e<<24>>24==45?-D:D;e=i[b>>0]|0;break}default:d=D}if(e<<24>>24!=46){q=k[a+88>>2]|0;k[m>>2]=k[a+60>>2];k[m+4>>2]=q;k[m+8>>2]=223588;Cfb(l,222630,m);l9(223626,l,907)}q=i[b+1>>0]|0;switch(((q+-97|0)>>>0<26?q&95:q)|0){case 73:{q=i[b+2>>0]|0;if(!((((q+-97|0)>>>0<26?q&95:q)|0)==78?(q=i[b+3>>0]|0,(((q+-97|0)>>>0<26?q&95:q)|0)==70):0))o=17;break}case 78:{q=i[b+2>>0]|0;if((((q+-97|0)>>>0<26?q&95:q)|0)==65?(q=i[b+3>>0]|0,(((q+-97|0)>>>0<26?q&95:q)|0)==78):0)d=C;else o=17;break}default:o=17}if((o|0)==17){q=k[a+88>>2]|0;k[n>>2]=k[a+60>>2];k[n+4>>2]=q;k[n+8>>2]=223588;Cfb(l,222630,n);l9(223626,l,916);d=0.0}k[c>>2]=b+4;f=d;r=p;return +f}function z5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=r;r=r+1040|0;e=f;d=f+16|0;if((b&7|0)==6){if(k[c>>2]|0){g=k[a+88>>2]|0;k[e>>2]=k[a+60>>2];k[e+4>>2]=g;k[e+8>>2]=223514;Cfb(d,222630,e);l9(223566,d,409)}d=k[a+16>>2]|0;a=WY(0,72,24,d)|0;k[a+64>>2]=16;d=FY(d,64)|0;k[a+68>>2]=d;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c+8>>2]=a;g=a;k[c>>2]=b;IY(g,8);r=f;return}else{a=HY(0,56,16,k[a+16>>2]|0)|0;if(k[c>>2]&7|0)SY(a,c)|0;k[c+8>>2]=a;g=a;k[c>>2]=b;IY(g,8);r=f;return}}function A5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;m=r;r=r+1072|0;l=m+32|0;h=m+16|0;f=m;j=m+48|0;e=b+-1|0;if((i[b>>0]|0)==45){g=k[a+88>>2]|0;k[f>>2]=k[a+60>>2];k[f+4>>2]=g;k[f+8>>2]=223351;Cfb(j,222630,f);l9(223378,j,1007);g=e}else g=e;while(1){f=g+1|0;n=i[f>>0]|0;e=n<<24>>24==58;if((n&255)<32|e)break;else g=f}if(!e){n=k[a+88>>2]|0;k[h>>2]=k[a+60>>2];k[h+4>>2]=n;k[h+8>>2]=223393;Cfb(j,222630,h);l9(223378,j,1013)}while(1){e=f+-1|0;if((i[e>>0]|0)==32)f=e;else break}e=g+2|0;if((f|0)!=(b|0)){l=f;n=b;n=l-n|0;n=B5(a,b,n)|0;n=C5(a,c,n)|0;k[d>>2]=n;r=m;return e|0}n=k[a+88>>2]|0;k[l>>2]=k[a+60>>2];k[l+4>>2]=n;k[l+8>>2]=223405;Cfb(j,222630,l);l9(223378,j,1021);l=f;n=b;n=l-n|0;n=B5(a,b,n)|0;n=C5(a,c,n)|0;k[d>>2]=n;r=m;return e|0}function B5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(!a){b=0;return b|0}s=k[a+28>>2]|0;if((c|0)<0){d=i[b>>0]|0;if(!(d<<24>>24)){c=0;a=0}else{c=0;a=0;do{a=(d&255)+(a*33|0)|0;c=c+1|0;d=i[b+c>>0]|0}while(d<<24>>24!=0)}}else if(!c){c=0;a=0}else{a=0;d=0;do{a=(l[b+d>>0]|0)+(a*33|0)|0;d=d+1|0}while((d|0)<(c|0))}p=a&2147483647;a=k[s+64>>2]|0;d=a+-1|0;if(!(d&a))q=d&p;else q=(p>>>0)%(a>>>0)|0;r=s+68|0;a=k[(k[r>>2]|0)+(q<<2)>>2]|0;a:do if(a|0){g=(c|0)==0;b:while(1){c:do if((k[a>>2]|0)==(p|0)?(k[a+4>>2]|0)==(c|0):0){if(g){t=35;break b}d=k[a+8>>2]|0;e=c;f=b;while(1){if((i[d>>0]|0)!=(i[f>>0]|0))break c;e=e+-1|0;if(!e){t=35;break b}else{d=d+1|0;f=f+1|0}}}while(0);a=k[a+12>>2]|0;if(!a)break a}if((t|0)==35)return a|0}while(0);o=s+56|0;a=k[o>>2]|0;if(!a){g=s+24|0;a=k[g>>2]|0;h=k[s+28>>2]|0;QY(s);j=s+36|0;m=k[j>>2]|0;k[o>>2]=m;d=m+h|0;f=k[s+32>>2]|0;n=f;if(d>>>0>f>>>0)d=m;else{e=m;while(1){k[e>>2]=a|-2147483648;k[e+4>>2]=d;a=a+1|0;e=d+h|0;if(e>>>0>f>>>0)break;else{u=d;d=e;e=u}}}k[d+(0-h)+4>>2]=0;f=(k[k[s+52>>2]>>2]|0)+12|0;k[f>>2]=a-(k[g>>2]|0)+(k[f>>2]|0);k[g>>2]=a;k[j>>2]=n;k[o>>2]=k[m+4>>2];k[m>>2]=k[m>>2]&67108863;f=s+60|0;k[f>>2]=(k[f>>2]|0)+1;f=m}else{k[o>>2]=k[a+4>>2];k[a>>2]=k[a>>2]&67108863;f=s+60|0;k[f>>2]=(k[f>>2]|0)+1;f=a}k[f>>2]=p;e=k[s+44>>2]|0;if((c|0)>-1)a=c;else{d=b;d:do if(!(d&3)){a=b;t=28}else{a=b;c=d;while(1){if(!(i[a>>0]|0)){a=c;break d}a=a+1|0;c=a;if(!(c&3)){t=28;break}}}while(0);if((t|0)==28){while(1){c=k[a>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))a=a+4|0;else break}if((c&255)<<24>>24)do a=a+1|0;while((i[a>>0]|0)!=0)}a=a-d|0}u=FY(e,a+1|0)|0;upb(u|0,b|0,a|0)|0;i[u+a>>0]=0;k[f+4>>2]=a;k[f+8>>2]=u;u=(k[r>>2]|0)+(q<<2)|0;k[f+12>>2]=k[u>>2];k[u>>2]=f;u=f;return u|0}function C5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+1040|0;z=C;B=C+16|0;if(!a){B=0;r=C;return B|0}if((k[a>>2]|0)!=1280131417){d=B+4|0;e=ZT(36)|0;k[e>>2]=1;f=e+4|0;k[B>>2]=f;k[d>>2]=31;i[e+35>>0]=0;g=221977;h=f+31|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-5,B,223418,221854,634);k[d>>2]=0;k[B>>2]=0;y=k[e>>2]|0;k[e>>2]=y+-1;if((y|0)==1)ggb(k[e+-4>>2]|0)}if(!c){d=B+4|0;e=ZT(24)|0;k[e>>2]=1;f=e+4|0;k[B>>2]=f;k[d>>2]=16;i[e+20>>0]=0;g=223432;h=f+16|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-27,B,223418,221854,637);k[d>>2]=0;k[B>>2]=0;y=k[e>>2]|0;k[e>>2]=y+-1;if((y|0)==1)ggb(k[e+-4>>2]|0)}x=(b|0)!=0;y=a+32|0;if(x){d=k[y>>2]|0;if(!d){B=0;r=C;return B|0}d=k[d+24>>2]|0;if((d|0)>0)u=d;else{B=0;r=C;return B|0}}else u=1;w=u+-1|0;v=a+60|0;t=a+88|0;d=0;s=0;a:while(1){if(x)e=b;else{h=k[y>>2]|0;g=k[h+24>>2]|0;if(g>>>0<=s>>>0){e=s-((s|0)>=(g|0)?g:0)|0;if(e>>>0<g>>>0)A=17;else e=0}else{e=s;A=17}if((A|0)==17){A=0;f=k[h+52>>2]|0;if((e<<1|0)<=(g|0)){g=k[f+12>>2]|0;if((e|0)>=(g|0))do{f=k[f+4>>2]|0;e=e-g|0;g=k[f+12>>2]|0}while((e|0)>=(g|0))}else{do{f=k[f>>2]|0;g=g-(k[f+12>>2]|0)|0}while((e|0)<(g|0));e=e-g|0}e=(k[f+16>>2]|0)+(aa(k[h+28>>2]|0,e)|0)|0}}f=k[e>>2]|0;switch(f&7){case 5:{A=25;break a}case 6:break;default:{A=26;break a}}q=k[e+8>>2]|0;e=k[q+64>>2]|0;f=e+-1|0;g=k[c>>2]|0;if(!(f&e))o=g&f;else o=(g>>>0)%(e>>>0)|0;p=q+68|0;e=k[(k[p>>2]|0)+(o<<2)>>2]|0;if(e|0)do{if((k[e+16>>2]|0)==(c|0)){n=k[t>>2]|0;k[z>>2]=k[v>>2];k[z+4>>2]=n;k[z+8>>2]=223499;Cfb(B,222630,z);l9(223418,B,680)}e=k[e+20>>2]|0}while((e|0)!=0);if((s|0)==(w|0)){n=q+56|0;d=k[n>>2]|0;if(!d){a=q+24|0;e=k[a>>2]|0;j=k[q+28>>2]|0;QY(q);l=q+36|0;d=k[l>>2]|0;k[n>>2]=d;f=d+j|0;h=k[q+32>>2]|0;m=h;if(f>>>0>h>>>0)f=d;else{g=d;while(1){k[g>>2]=e|-2147483648;k[g+4>>2]=f;e=e+1|0;g=f+j|0;if(g>>>0>h>>>0)break;else{D=f;f=g;g=D}}}k[f+(0-j)+4>>2]=0;D=(k[k[q+52>>2]>>2]|0)+12|0;k[D>>2]=e-(k[a>>2]|0)+(k[D>>2]|0);k[a>>2]=e;k[l>>2]=m;k[n>>2]=k[d+4>>2];k[d>>2]=k[d>>2]&67108863;D=q+60|0;k[D>>2]=(k[D>>2]|0)+1}else{k[n>>2]=k[d+4>>2];k[d>>2]=k[d>>2]&67108863;D=q+60|0;k[D>>2]=(k[D>>2]|0)+1}k[d+16>>2]=c;D=(k[p>>2]|0)+(o<<2)|0;k[d+20>>2]=k[D>>2];k[D>>2]=d}s=s+1|0;if((s|0)>=(u|0)){A=45;break}}if((A|0)==25){if((f&7|0)==0?1:(k[(k[e+8>>2]|0)+24>>2]|0)==0){D=0;r=C;return D|0}}else if((A|0)==26){if(!(f&7)){D=0;r=C;return D|0}}else if((A|0)==45){r=C;return d|0}d=B+4|0;e=ZT(56)|0;k[e>>2]=1;f=e+4|0;k[B>>2]=f;k[d>>2]=49;i[e+53>>0]=0;g=223449;h=f+49|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,B,223418,221854,660);k[d>>2]=0;k[B>>2]=0;D=k[e>>2]|0;k[e>>2]=D+-1;if((D|0)==1)ggb(k[e+-4>>2]|0);D=0;r=C;return D|0}function D5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+16|0;v=y;x=a+44|0;e=k[x>>2]|0;if(!b)u=0;else u=(i[b>>0]|0)==0?0:b;b=e&7;if(b>>>0>4)if((b|0)==6^(u|0)!=0){b=v+4|0;d=ZT(92)|0;k[d>>2]=1;g=d+4|0;k[v>>2]=g;k[b>>2]=85;i[d+89>>0]=0;h=224738;j=g+85|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,v,224824,221854,1430);k[b>>2]=0;k[v>>2]=0;w=k[d>>2]|0;k[d>>2]=w+-1;if((w|0)==1)ggb(k[d+-4>>2]|0);w=e}else w=e;else{k[a+12>>2]=0;w=u|0?38:37}s=(u|0)!=0;do if(s){e=u;a:do if(!(e&3)){b=u;f=13}else{d=u;b=e;while(1){if(!(i[d>>0]|0))break a;d=d+1|0;b=d;if(!(b&3)){b=d;f=13;break}}}while(0);if((f|0)==13){while(1){d=k[b>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))b=b+4|0;else break}if((d&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}b=b-e|0;if(!b){b=v+4|0;d=ZT(24)|0;k[d>>2]=1;g=d+4|0;k[v>>2]=g;k[b>>2]=19;i[d+23>>0]=0;h=224836;j=g+19|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,v,224824,221854,1442);k[b>>2]=0;k[v>>2]=0;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0);q=0;break}if((b|0)>4096){d=v+4|0;e=ZT(24)|0;k[e>>2]=1;g=e+4|0;k[v>>2]=g;k[d>>2]=19;i[e+23>>0]=0;h=224856;j=g+19|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,v,224824,221854,1445);k[d>>2]=0;k[v>>2]=0;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)ggb(k[e+-4>>2]|0);q=b}else q=b}else q=0;while(0);t=(c|0)!=0;if(t){e=c;b:do if(!(e&3)){b=c;f=30}else{b=c;d=e;while(1){if(!(i[b>>0]|0)){b=d;break b}b=b+1|0;d=b;if(!(d&3)){f=30;break}}}while(0);if((f|0)==30){while(1){d=k[b>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))b=b+4|0;else break}if((d&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}o=b-e|0}else o=0;l=(w&8|0)==0;p=a+72|0;e=k[p>>2]|0;do if(l){f=a+76|0;d=k[f>>2]|0;g=a+56|0;b=k[g>>2]|0;if(e>>>0>(d+b|0)>>>0){i[e>>0]=10;i[e+1>>0]=0;$4(a,k[f>>2]|0);d=k[f>>2]|0;k[p>>2]=d;e=k[g>>2]|0}else e=b;b=k[a+40>>2]|0;if((b|0)==(e|0))b=e;else{if((b|0)>(e|0)){zpb(d+e|0,32,b-e|0)|0;d=k[f>>2]|0}k[g>>2]=b}b=d+b|0;k[p>>2]=b;if((w&7|0)!=6){d=b+1|0;i[b>>0]=45;if(t){i[d>>0]=32;b=b+2|0}else b=d}}else{if(!(w&32)){i[e>>0]=44;e=e+1|0}g=a+76|0;b=k[g>>2]|0;d=o+q-b+e|0;if((d|0)>(k[a+84>>2]|0)?(m=a+40|0,n=k[m>>2]|0,(d-n|0)>10):0){k[p>>2]=e;f=a+56|0;d=k[f>>2]|0;if(e>>>0>(b+d|0)>>>0){i[e>>0]=10;i[e+1>>0]=0;$4(a,k[g>>2]|0);b=k[g>>2]|0;k[p>>2]=b;e=k[m>>2]|0;d=k[f>>2]|0}else e=n;if((e|0)!=(d|0)){if((e|0)>(d|0)){zpb(b+d|0,32,e-d|0)|0;b=k[g>>2]|0}k[f>>2]=e}b=b+e|0;k[p>>2]=b;break}i[e>>0]=32;b=e+1|0}while(0);if(s){s=i[u>>0]|0;if(!(((s&-33)+-65&255)<26|s<<24>>24==95)){d=v+4|0;e=ZT(40)|0;k[e>>2]=1;g=e+4|0;k[v>>2]=g;k[d>>2]=33;i[e+37>>0]=0;h=224876;j=g+33|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,v,224824,221854,1480);k[d>>2]=0;k[v>>2]=0;s=k[e>>2]|0;k[e>>2]=s+-1;if((s|0)==1)ggb(k[e+-4>>2]|0)}g=a+80|0;d=k[g>>2]|0;if((b+q|0)>>>0>=d>>>0){h=a+76|0;e=k[h>>2]|0;f=b-e|0;d=((d-e|0)*3|0)/2|0;b=f+q|0;b=(b|0)<(d|0)?d:b;d=ZT(b+256|0)|0;e=k[h>>2]|0;k[p>>2]=d+((k[p>>2]|0)-e);if((f|0)>0)upb(d|0,e|0,f|0)|0;k[h>>2]=d;k[g>>2]=d+b;b=d+f|0}if((q|0)>0){f=v+4|0;e=0;do{d=i[u+e>>0]|0;i[b+e>>0]=d;c:do if(!((d+-48&255)<10|((d&-33)+-65&255)<26)){switch(d<<24>>24){case 32:case 45:case 95:break c;default:{}}d=ZT(88)|0;k[d>>2]=1;g=d+4|0;k[v>>2]=g;k[f>>2]=80;i[d+84>>0]=0;h=224910;j=g+80|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,v,224824,221854,1490);k[f>>2]=0;k[v>>2]=0;s=k[d>>2]|0;k[d>>2]=s+-1;if((s|0)==1)ggb(k[d+-4>>2]|0)}while(0);e=e+1|0}while((e|0)<(q|0))}v=b+q|0;b=v+1|0;i[v>>0]=58;if(t&l){i[b>>0]=32;b=b+1|0}}if(!t){c=b;k[p>>2]=c;c=w&-33;k[x>>2]=c;r=y;return}h=a+80|0;d=k[h>>2]|0;if((b+o|0)>>>0>=d>>>0){g=a+76|0;e=k[g>>2]|0;f=b-e|0;d=((d-e|0)*3|0)/2|0;b=f+o|0;b=(b|0)<(d|0)?d:b;d=ZT(b+256|0)|0;e=k[g>>2]|0;k[p>>2]=d+((k[p>>2]|0)-e);if((f|0)>0)upb(d|0,e|0,f|0)|0;k[g>>2]=d;k[h>>2]=d+b;b=d+f|0}upb(b|0,c|0,o|0)|0;c=b+o|0;k[p>>2]=c;c=w&-33;k[x>>2]=c;r=y;return}function E5(a,b){a=a|0;b=+b;var c=0,d=0,e=0.0,f=0,g=0,h=0;h=r;r=r+16|0;g=h+8|0;f=h;p[u>>3]=b;c=k[u>>2]|0;d=k[u+4>>2]|0;if((d&2146435072|0)!=2146435072){c=d&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){c=(d|0)<0;e=c?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}else e=b;c=~~e;if(+(c|0)==b){k[f>>2]=c;Cfb(a,224991,f);r=h;return a|0}p[g>>3]=b;Cfb(a,224995,g);switch(i[a>>0]|0){case 45:case 43:{c=a+1|0;break}default:c=a}while(1){d=i[c>>0]|0;if((d+-48&255)<10)c=c+1|0;else break}if(d<<24>>24!=44){r=h;return a|0}i[c>>0]=46;r=h;return a|0}if(((d&2147483647)+((c|0)!=0&1)|0)>>>0>2146435072){i[a>>0]=i[225001]|0;i[a+1>>0]=i[225002]|0;i[a+2>>0]=i[225003]|0;i[a+3>>0]=i[225004]|0;i[a+4>>0]=i[225005]|0;r=h;return a|0}d=(d|0)<0?225006:225012;c=d;if(!((c^a)&3)){a:do if(!(c&3))c=a;else{c=a;while(1){g=i[d>>0]|0;i[c>>0]=g;if(!(g<<24>>24))break;d=d+1|0;c=c+1|0;if(!(d&3))break a}r=h;return a|0}while(0);f=k[d>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))while(1){d=d+4|0;g=c+4|0;k[c>>2]=f;f=k[d>>2]|0;if((f&-2139062144^-2139062144)&f+-16843009|0){c=g;break}else c=g}}else c=a;g=i[d>>0]|0;i[c>>0]=g;if(!(g<<24>>24)){r=h;return a|0}do{d=d+1|0;c=c+1|0;g=i[d>>0]|0;i[c>>0]=g}while(g<<24>>24!=0);r=h;return a|0}function F5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+16|0;n=q;o=a+44|0;e=k[o>>2]&7;if((e|0)!=6?(f=(b|0)!=0,!(f&e>>>0<5)):0){p=a+72|0;e=k[p>>2]|0;b=a+76|0;m=e-(k[b>>2]|0)+d|0;if(f){f=n+4|0;g=ZT(56)|0;k[g>>2]=1;h=g+4|0;k[n>>2]=h;k[f>>2]=49;i[g+53>>0]=0;j=225325;l=h+49|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,n,225375,221854,2459);k[f>>2]=0;k[n>>2]=0;n=k[g>>2]|0;k[g>>2]=n+-1;if((n|0)==1)ggb(k[g+-4>>2]|0)}k[o>>2]=5;if((m|0)>(k[a+84>>2]|0)?(m-(k[a+40>>2]|0)|0)>10:0){f=k[b>>2]|0;g=17}else g=15;do if((g|0)==15){f=k[b>>2]|0;if(e>>>0>f>>>0?(i[e+-1>>0]|0)==62:0){g=17;break}if(e>>>0>(f+(k[a+40>>2]|0)|0)>>>0?(i[e+-1>>0]|0)!=62:0){i[e>>0]=32;e=e+1|0}}while(0);if((g|0)==17){e=k[p>>2]|0;h=a+56|0;g=k[h>>2]|0;if(e>>>0>(f+g|0)>>>0){i[e>>0]=10;i[e+1>>0]=0;$4(a,k[b>>2]|0);f=k[b>>2]|0;k[p>>2]=f;g=k[h>>2]|0}e=k[a+40>>2]|0;if((e|0)==(g|0))e=g;else{if((e|0)>(g|0)){zpb(f+g|0,32,e-g|0)|0;f=k[b>>2]|0}k[h>>2]=e}e=f+e|0;k[p>>2]=e}upb(e|0,c|0,d|0)|0;k[p>>2]=e+d;r=q;return}G5(a,b,1,0);m=a+72|0;e=k[m>>2]|0;j=a+80|0;f=k[j>>2]|0;if((e+d|0)>>>0>=f>>>0){l=a+76|0;g=k[l>>2]|0;h=e-g|0;f=((f-g|0)*3|0)/2|0;e=h+d|0;e=(e|0)<(f|0)?f:e;f=ZT(e+256|0)|0;g=k[l>>2]|0;k[m>>2]=f+((k[m>>2]|0)-g);if((h|0)>0)upb(f|0,g|0,h|0)|0;k[l>>2]=f;k[j>>2]=f+e;e=f+h|0}upb(e|0,c|0,d|0)|0;k[m>>2]=e+d;G5(a,b,2,0);r=q;return}function G5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+16|0;s=x;v=a+72|0;g=k[v>>2]|0;w=a+44|0;h=k[w>>2]|0;if(!b)m=0;else m=(i[b>>0]|0)==0?0:b;t=(c|0)==3;if((c|2|0)==3){b=h&7;if(b>>>0>4)if((b|0)==6^(m|0)!=0){b=s+4|0;f=ZT(92)|0;k[f>>2]=1;n=f+4|0;k[s>>2]=n;k[b>>2]=85;i[f+89>>0]=0;o=224738;p=n+85|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-5,s,225393,221854,2286);k[b>>2]=0;k[s>>2]=0;q=k[f>>2]|0;k[f>>2]=q+-1;if((q|0)==1)ggb(k[f+-4>>2]|0);l=h}else l=h;else{k[a+12>>2]=0;l=m|0?38:37}if(!(l&32)){b=k[v>>2]|0;h=a+76|0;f=k[h>>2]|0;j=a+56|0;g=k[j>>2]|0;if(b>>>0>(f+g|0)>>>0){i[b>>0]=10;i[b+1>>0]=0;$4(a,k[h>>2]|0);f=k[h>>2]|0;k[v>>2]=f;g=k[j>>2]|0}b=k[a+40>>2]|0;if((b|0)==(g|0))b=g;else{if((b|0)>(g|0)){zpb(f+g|0,32,b-g|0)|0;f=k[h>>2]|0}k[j>>2]=b}j=f+b|0;k[v>>2]=j}else j=g}else{j=g;l=h}if(m)if((i[m>>0]|0)==95?(i[m+1>>0]|0)==0:0){b=s+4|0;f=ZT(40)|0;k[f>>2]=1;n=f+4|0;k[s>>2]=n;k[b>>2]=33;i[f+37>>0]=0;o=225408;p=n+33|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-5,s,225393,221854,2301);k[b>>2]=0;k[s>>2]=0;q=k[f>>2]|0;k[f>>2]=q+-1;if((q|0)==1)ggb(k[f+-4>>2]|0);q=m}else q=m;else q=225442;g=q;a:do if(!(g&3)){b=q;u=27}else{f=q;b=g;while(1){if(!(i[f>>0]|0))break a;f=f+1|0;b=f;if(!(b&3)){b=f;u=27;break}}}while(0);if((u|0)==27){while(1){f=k[b>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))b=b+4|0;else break}if((f&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}m=b-g|0;g=j+1|0;i[j>>0]=60;if((c|0)==2){if(d|0){b=s+4|0;f=ZT(52)|0;k[f>>2]=1;n=f+4|0;k[s>>2]=n;k[b>>2]=45;i[f+49>>0]=0;o=225444;p=n+45|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-5,s,225393,221854,2308);k[b>>2]=0;k[s>>2]=0;c=k[f>>2]|0;k[f>>2]=c+-1;if((c|0)==1)ggb(k[f+-4>>2]|0)}i[g>>0]=47;g=j+2|0}c=i[q>>0]|0;if(!(((c&-33)+-65&255)<26|c<<24>>24==95)){b=s+4|0;f=ZT(40)|0;k[f>>2]=1;n=f+4|0;k[s>>2]=n;k[b>>2]=35;i[f+39>>0]=0;o=225490;p=n+35|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-5,s,225393,221854,2313);k[b>>2]=0;k[s>>2]=0;c=k[f>>2]|0;k[f>>2]=c+-1;if((c|0)==1)ggb(k[f+-4>>2]|0)}c=a+80|0;b=k[c>>2]|0;if((g+m|0)>>>0>=b>>>0){j=a+76|0;f=k[j>>2]|0;h=g-f|0;f=((b-f|0)*3|0)/2|0;b=h+m|0;b=(b|0)<(f|0)?f:b;f=ZT(b+256|0)|0;g=k[j>>2]|0;k[v>>2]=f+((k[v>>2]|0)-g);if((h|0)>0)upb(f|0,g|0,h|0)|0;k[j>>2]=f;k[c>>2]=f+b;g=f+h|0}if((m|0)>0){f=s+4|0;b=0;do{h=i[q+b>>0]|0;b:do if(!((h+-48&255)<10|((h&-33)+-65&255)<26)){switch(h<<24>>24){case 45:case 95:break b;default:{}}j=ZT(80)|0;k[j>>2]=1;n=j+4|0;k[s>>2]=n;k[f>>2]=74;i[j+78>>0]=0;o=225526;p=n+74|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-5,s,225393,221854,2320);k[f>>2]=0;k[s>>2]=0;p=k[j>>2]|0;k[j>>2]=p+-1;if((p|0)==1)ggb(k[j+-4>>2]|0)}while(0);i[g+b>>0]=h;b=b+1|0}while((b|0)<(m|0))}b=g+m|0;o=a+76|0;if((d|0)!=0?(e=k[d>>2]|0,(e|0)!=0):0){n=d;do{g=e;c:do if(!(g&3))u=59;else{f=e;e=g;while(1){if(!(i[f>>0]|0))break c;f=f+1|0;e=f;if(!(e&3)){e=f;u=59;break}}}while(0);if((u|0)==59){u=0;while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}j=e-g|0;m=n+4|0;e=k[m>>2]|0;g=e;d:do if(!(g&3))u=67;else{f=e;e=g;while(1){if(!(i[f>>0]|0))break d;f=f+1|0;e=f;if(!(e&3)){e=f;u=67;break}}}while(0);if((u|0)==67){u=0;while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}h=e-g|0;e=j+4+h|0;f=k[c>>2]|0;if((b+e|0)>>>0>=f>>>0){d=k[o>>2]|0;g=b-d|0;f=((f-d|0)*3|0)/2|0;b=g+e|0;b=(b|0)<(f|0)?f:b;e=ZT(b+256|0)|0;f=k[o>>2]|0;k[v>>2]=e+((k[v>>2]|0)-f);if((g|0)>0)upb(e|0,f|0,g|0)|0;k[o>>2]=e;k[c>>2]=e+b;b=e+g|0}e=b+1|0;i[b>>0]=32;upb(e|0,k[n>>2]|0,j|0)|0;e=e+j|0;b=e+1|0;i[e>>0]=61;e=b+1|0;i[b>>0]=34;upb(e|0,k[m>>2]|0,h|0)|0;e=e+h|0;b=e+1|0;i[e>>0]=34;n=n+8|0;e=k[n>>2]|0}while((e|0)!=0)}if(!t){t=b;u=t+1|0;i[t>>0]=62;k[v>>2]=u;v=l&-33;k[w>>2]=v;r=x;return}i[b>>0]=47;t=b+1|0;u=t+1|0;i[t>>0]=62;k[v>>2]=u;v=l&-33;k[w>>2]=v;r=x;return}function H5(){var a=0,b=0;a=r;r=r+48|0;b=a;k[b>>2]=0;k[b+4>>2]=40;k[b+16>>2]=225781;k[b+12>>2]=0;k[b+8>>2]=0;k[b+20>>2]=762;k[b+24>>2]=1448;k[b+36>>2]=763;k[b+28>>2]=261;k[b+32>>2]=193;N5(b);k[107195]=k[107193];ud(1449,428780,x|0)|0;k[b>>2]=0;k[b+4>>2]=40;k[b+16>>2]=225797;k[b+12>>2]=0;k[b+8>>2]=0;k[b+20>>2]=762;k[b+24>>2]=1448;k[b+36>>2]=763;k[b+28>>2]=262;k[b+32>>2]=193;N5(b);k[107196]=k[107193];ud(1449,428784,x|0)|0;k[b>>2]=0;k[b+4>>2]=40;k[b+16>>2]=225818;k[b+12>>2]=0;k[b+8>>2]=0;k[b+20>>2]=764;k[b+24>>2]=1450;k[b+36>>2]=765;k[b+28>>2]=263;k[b+32>>2]=194;N5(b);k[107197]=k[107193];ud(1449,428788,x|0)|0;k[b>>2]=0;k[b+4>>2]=40;k[b+16>>2]=225831;k[b+12>>2]=0;k[b+8>>2]=0;k[b+20>>2]=766;k[b+24>>2]=1451;k[b+36>>2]=767;k[b+28>>2]=264;k[b+32>>2]=195;N5(b);k[107198]=k[107193];ud(1449,428792,x|0)|0;k[b>>2]=0;k[b+4>>2]=40;k[b+16>>2]=225852;k[b+12>>2]=0;k[b+8>>2]=0;k[b+20>>2]=768;k[b+24>>2]=1452;k[b+36>>2]=769;k[b+28>>2]=265;k[b+32>>2]=196;N5(b);k[107199]=k[107193];ud(1449,428796,x|0)|0;k[b>>2]=0;k[b+4>>2]=40;k[b+16>>2]=225865;k[b+12>>2]=0;k[b+8>>2]=0;k[b+20>>2]=770;k[b+24>>2]=1453;k[b+36>>2]=771;k[b+28>>2]=266;k[b+32>>2]=197;N5(b);k[107200]=k[107193];ud(1449,428800,x|0)|0;k[b>>2]=0;k[b+4>>2]=40;k[b+16>>2]=225879;k[b+12>>2]=0;k[b+8>>2]=0;k[b+20>>2]=772;k[b+24>>2]=1454;k[b+36>>2]=773;k[b+28>>2]=267;k[b+32>>2]=198;N5(b);k[107201]=k[107193];ud(1449,428804,x|0)|0;r=a;return}function I5(a){a=a|0;if(!a)a=0;else a=(k[a>>2]&-65536|0)==1117323264;return a&1|0}function J5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;f=r;r=r+16|0;b=f;if(a|0){k[a>>2]=0;r=f;return}c=b+4|0;d=ZT(24)|0;k[d>>2]=1;e=d+4|0;k[b>>2]=e;k[c>>2]=19;i[d+23>>0]=0;g=227921;h=e+19|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-27,b,228668,221854,3996);k[c>>2]=0;k[b>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);k[a>>2]=0;r=f;return}function K5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+48|0;p=q+8|0;m=q;if(!((a|0)!=0?(k[a>>2]&-65536|0)==1117323264:0)){b=m+4|0;c=ZT(28)|0;k[c>>2]=1;h=c+4|0;k[m>>2]=h;k[b>>2]=23;i[c+27>>0]=0;j=212505;l=h+23|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,m,212529,211567,1610);k[b>>2]=0;k[m>>2]=0;o=k[c>>2]|0;k[c>>2]=o+-1;if((o|0)==1)ggb(k[c+-4>>2]|0)}b=k[a+44>>2]|0;if(!b){b=m+4|0;c=ZT(28)|0;k[c>>2]=1;h=c+4|0;k[m>>2]=h;k[b>>2]=20;i[c+24>>0]=0;j=243280;l=h+20|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-27,m,212529,211567,1616);k[b>>2]=0;k[m>>2]=0;o=k[c>>2]|0;k[c>>2]=o+-1;if((o|0)==1)ggb(k[c+-4>>2]|0);b=0}g=a+28|0;o=k[g>>2]|0;f=k[a+24>>2]|0;d=(f|0)<1073741823?f:1073741823;n=(f|0)>0?0:0-f|0;if(!(d>>>0<=f>>>0?!((d|0)!=0&n>>>0>=f>>>0):0)){c=m+4|0;e=ZT(24)|0;k[e>>2]=1;h=e+4|0;k[m>>2]=h;k[c>>2]=18;i[e+22>>0]=0;j=212540;l=h+18|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-211,m,212529,211567,1627);k[c>>2]=0;k[m>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}h=HY(k[a>>2]|0,k[a+4>>2]|0,o,b)|0;if((f|0)<=0){r=q;return h|0}b=p+4|0;m=b+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[p>>2]=32;k[b>>2]=a;b=k[a+52>>2]|0;if(!b){f=p+8|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;e=p+12|0;b=p+20|0}else{f=k[b>>2]|0;m=k[b+16>>2]|0;e=p+12|0;k[e>>2]=m;a=k[g>>2]|0;f=(k[f+16>>2]|0)+(aa((k[f+12>>2]|0)+-1|0,a)|0)|0;k[p+28>>2]=f;k[p+24>>2]=k[b+8>>2];f=p+8|0;k[f>>2]=b;k[p+16>>2]=m;a=m+(aa(a,k[b+12>>2]|0)|0)|0;b=p+20|0;k[b>>2]=a}LY(p,n,0);c=k[e>>2]|0;b=((k[b>>2]|0)-c|0)/(o|0)|0;while(1){b=(b|0)>(d|0)?d:b;UY(h,c,b);d=d-b|0;b=k[(k[f>>2]|0)+4>>2]|0;k[f>>2]=b;c=k[b+16>>2]|0;k[e>>2]=c;if((d|0)<=0)break;else b=k[b+12>>2]|0}r=q;return h|0}function L5(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+1056|0;A=C+544|0;B=C+512|0;z=C;c=k6(a,b,227233)|0;if((c|0)!=0?(k[c>>2]&7|0)==3:0)g=k[c+8+4>>2]|0;else g=0;c=k6(a,b,367797)|0;a:do if(!c)y=-1;else{switch(k[c>>2]&7){case 1:{y=k[c+8>>2]|0;break a}case 2:break;default:{y=2147483647;break a}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;y=c&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}y=~~d}while(0);c=k6(a,b,225918)|0;if((c|0)!=0?(k[c>>2]&7|0)==3:0){c=k[c+8+4>>2]|0;if((g|0)!=0&(y|0)!=-1&(c|0)!=0)x=c;else e=14}else{c=0;e=14}if((e|0)==14){e=A+4|0;f=ZT(56)|0;k[f>>2]=1;q=f+4|0;k[A>>2]=q;k[e>>2]=48;i[f+52>>0]=0;s=228459;t=q+48|0;do{i[q>>0]=i[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(t|0));Y8(-2,A,228508,221854,4220);k[e>>2]=0;k[A>>2]=0;x=k[f>>2]|0;k[f>>2]=x+-1;if((x|0)==1)ggb(k[f+-4>>2]|0);x=c}if(((i[g>>0]|0)+-48&255)>=10){c=(Bfb(g,228519)|0)==0;c=c?1117323264:1117327360;w=(Bfb(g,228525)|0)==0;c=w?c:c|16384;w=(Bfb(g,228532)|0)==0;c=w?c:c|32768;if(!(Bfb(g,228537)|0))c=m6(x)|0|c}else{k[A>>2]=0;t=A+4|0;k[t>>2]=g;k[A+44>>2]=g;c=(g|0)<0?-1:g+2147483647|0;w=A+8|0;k[w>>2]=c;k[A+76>>2]=-1;k[A+104>>2]=0;v=A+108|0;k[v>>2]=c-g;k[A+100>>2]=c;c=Efb(A,16,1,-2147483648,0)|0;if(!((c&-65536|0)==1117323264?((k[t>>2]|0)+(k[v>>2]|0)|0)!=(k[w>>2]|0):0)){e=A+4|0;f=ZT(36)|0;k[f>>2]=1;q=f+4|0;k[A>>2]=q;k[e>>2]=30;i[f+34>>0]=0;s=227650;t=q+30|0;do{i[q>>0]=i[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(t|0));Y8(-2,A,228508,221854,4237);k[e>>2]=0;k[A>>2]=0;w=k[f>>2]|0;k[f>>2]=w+-1;if((w|0)==1)ggb(k[f+-4>>2]|0)}c=c&33279|c<<2&16384|((c&3584|0)==512?1117327360:1117323264)}e=k6(a,b,227302)|0;if((e|0)!=0?(k[e>>2]&7|0)==3:0)n=k[e+8+4>>2]|0;else n=0;m=k6(a,b,227420)|0;h=(n|0)!=0;o=(m|0)!=0;g=o&1;if(h^o){e=A+4|0;f=ZT(80)|0;k[f>>2]=1;q=f+4|0;k[A>>2]=q;k[e>>2]=74;i[f+78>>0]=0;s=227681;t=q+74|0;do{i[q>>0]=i[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(t|0));Y8(-2,A,228508,221854,4271);k[e>>2]=0;k[A>>2]=0;w=k[f>>2]|0;k[f>>2]=w+-1;if((w|0)==1)ggb(k[f+-4>>2]|0)}w=k6(a,b,379272)|0;v=k6(a,b,226942)|0;j=(w|0)!=0;l=(v|0)!=0;if(((j&1)+g+(l&1)|0)>>>0>1){e=A+4|0;f=ZT(72)|0;k[f>>2]=1;q=f+4|0;k[A>>2]=q;k[e>>2]=66;i[f+70>>0]=0;s=228545;t=q+66|0;do{i[q>>0]=i[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(t|0));Y8(-2,A,228508,221854,4277);k[e>>2]=0;k[A>>2]=0;t=k[f>>2]|0;k[f>>2]=t+-1;if((t|0)==1)ggb(k[f+-4>>2]|0)}if(h){t=j6(n,A)|0;g=t<<1;if((t|0)>0){e=56;f=0;do{t=k[A+((f|1)<<2)>>2]|0;t=(t>>>3&511)+1<<(47696>>>(t<<1&14)&3);e=(e+-1+t&0-t)+(aa(t,k[A+(f<<2)>>2]|0)|0)|0;f=f+2|0}while((f|0)<(g|0))}else e=56;f=A}else{e=j?88:l?64:56;f=A}t=j6(x,f)|0;h=t<<1;if((t|0)>0){f=0;g=0;do{t=k[A+((g|1)<<2)>>2]|0;t=(t>>>3&511)+1<<(47696>>>(t<<1&14)&3);f=(f+-1+t&0-t)+(aa(t,k[A+(g<<2)>>2]|0)|0)|0;g=g+2|0}while((g|0)<(h|0))}else f=0;h=k[A+4>>2]|0;h=(h>>>3&511)+1<<(47696>>>(h<<1&14)&3);h=HY(c,e,f+-1+h&0-h,k[a+20>>2]|0)|0;do if(o)l6(a,m,h+56|0,n);else{if(!j){if(!l)break;c=k6(a,v,226979)|0;b:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break b}case 2:break;default:{c=2147483647;break b}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;w=c&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[h+56>>2]=c;c=k6(a,v,226981)|0;c:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break c}case 2:break;default:{c=2147483647;break c}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;w=c&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[h+60>>2]=c;break}c=k6(a,w,226979)|0;d:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break d}case 2:break;default:{c=2147483647;break d}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[h+56>>2]=c;c=k6(a,w,226981)|0;e:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break e}case 2:break;default:{c=2147483647;break e}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[h+60>>2]=c;c=k6(a,w,380241)|0;f:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break f}case 2:break;default:{c=2147483647;break f}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[h+64>>2]=c;c=k6(a,w,380234)|0;g:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break g}case 2:break;default:{c=2147483647;break g}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;w=c&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[h+68>>2]=c;c=k6(a,b,227406)|0;h:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break h}case 2:break;default:{c=2147483647;break h}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;w=c&2146435072;do if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(!(d==0.0))break;d=c?-0.0:0.0}while(0);c=~~d}while(0);k[h+72>>2]=c}while(0);UY(h,0,y);w=j6(x,z)|0;f=w<<1;if((w|0)>0){e=0;c=0;do{c=(k[z+(e<<2)>>2]|0)+c|0;e=e+2|0}while((e|0)<(f|0));g=c}else g=0;f=k6(a,b,225921)|0;if(!f){c=A+4|0;e=ZT(48)|0;k[e>>2]=1;q=e+4|0;k[A>>2]=q;k[c>>2]=43;i[e+47>>0]=0;s=227082;t=q+43|0;do{i[q>>0]=i[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(t|0));Y8(-2,A,228508,221854,4319);k[c>>2]=0;k[A>>2]=0;b=k[e>>2]|0;k[e>>2]=b+-1;if((b|0)==1)ggb(k[e+-4>>2]|0)}c=k[f>>2]&7;if(c>>>0>4)c=k[(k[f+8>>2]|0)+24>>2]|0;else c=(c|0)!=0&1;if((c|0)!=(aa(g,y)|0)){c=A+4|0;e=ZT(60)|0;k[e>>2]=1;q=e+4|0;k[A>>2]=q;k[c>>2]=55;i[e+59>>0]=0;s=228612;t=q+55|0;do{i[q>>0]=i[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(t|0));Y8(-2,A,228508,221854,4322);k[c>>2]=0;k[A>>2]=0;A=k[e>>2]|0;k[e>>2]=A+-1;if((A|0)==1)ggb(k[e+-4>>2]|0)}n6(a,f,B);e=h+52|0;c=k[e>>2]|0;if(!c){r=C;return h|0}while(1){A=aa(k[c+12>>2]|0,g)|0;o6(a,B,A,k[c+16>>2]|0,x);if((c|0)==(k[k[e>>2]>>2]|0)){e=114;break}c=k[c+4>>2]|0;if(!c){e=114;break}}if((e|0)==114){r=C;return h|0}return 0}function M5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+16|0;s=t;m=d;a:do{o=k[m>>2]|0;if(!o)break;f=k[o>>2]|0;if(f|0){l=0;n=0;while(1){g=i[f>>0]|0;if(g<<24>>24==114){h=228413;do{h=h+1|0;f=f+1|0;j=i[h>>0]|0;g=i[f>>0]|0}while(!(j<<24>>24==0?1:j<<24>>24!=g<<24>>24));f=j}else f=114;l=l+1|0;if(f<<24>>24==g<<24>>24){p=9;break a}g=l<<1;f=k[o+(g<<2)>>2]|0;if(!f)break;else n=g}}m=k[m+4>>2]|0}while((m|0)!=0);b:do if((p|0)==9?(e=k[o+((n|1)<<2)>>2]|0,e|0):0){l=i[e>>0]|0;switch(l<<24>>24){case 48:{f=228423;g=e;do{g=g+1|0;f=f+1|0;h=i[g>>0]|0;j=i[f>>0]|0}while(!(h<<24>>24==0?1:h<<24>>24!=j<<24>>24));if(h<<24>>24==j<<24>>24)break b;switch(l<<24>>24){case 102:{f=426481;g=e;p=14;break}case 70:{f=228425;g=e;p=17;break}default:{}}break}case 102:{f=426481;g=e;p=14;break}case 70:{f=228425;g=e;p=17;break}default:{}}if((p|0)==14){while(1){p=0;g=g+1|0;f=f+1|0;h=i[g>>0]|0;j=i[f>>0]|0;if(h<<24>>24==0?1:h<<24>>24!=j<<24>>24)break;else p=14}if(h<<24>>24==j<<24>>24)break;if(l<<24>>24==70){f=228425;g=e;p=17}}if((p|0)==17){while(1){p=0;g=g+1|0;f=f+1|0;h=i[g>>0]|0;j=i[f>>0]|0;if(h<<24>>24==0?1:h<<24>>24!=j<<24>>24)break;else p=17}if(h<<24>>24==j<<24>>24)break;else h=228431;do{e=e+1|0;h=h+1|0;f=i[e>>0]|0;g=i[h>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=g<<24>>24));if(f<<24>>24==g<<24>>24)break}g6(a,b,6,225797);g6(a,227957,5,0);$Y(s,c,2147483647);e=k[s>>2]|0;if(e|0){j=k[d>>2]|0;m=s+4|0;l=s+8|0;h=k[d+4>>2]|0;f=e;e=k[m>>2]|0;c:while(1){t6(a,0,f,j,h,e);g=k[s>>2]|0;e=k[m>>2]|0;if(!g)break;f=k[g+20>>2]|0;if((f|0)!=0?(q=e+1|0,(q|0)<(k[l>>2]|0)):0)e=q;else p=27;if((p|0)==27){while(1){p=0;f=k[g+12>>2]|0;if(f|0)break;f=e+-1|0;if((e|0)<1){e=f;break c}else{g=k[g+16>>2]|0;e=f;p=27}}if((g|0)==0|(k[l>>2]|0)==0)break}k[s>>2]=f;k[m>>2]=e}k[s>>2]=0;k[m>>2]=e}_4(a);_4(a);r=t;return}while(0);t6(a,b,c,k[d>>2]|0,k[d+4>>2]|0,-1);r=t;return}function N5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;m=n;if(!((a|0)!=0?(k[a+4>>2]|0)==40:0)){b=m+4|0;c=ZT(24)|0;k[c>>2]=1;f=c+4|0;k[m>>2]=f;k[b>>2]=17;i[c+21>>0]=0;g=228201;h=f+17|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-201,m,228219,221854,4821);k[b>>2]=0;k[m>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)==1)ggb(k[c+-4>>2]|0)}if(!((((k[a+20>>2]|0)!=0?(k[a+24>>2]|0)!=0:0)?(k[a+28>>2]|0)!=0:0)?(k[a+32>>2]|0)!=0:0)){b=m+4|0;c=ZT(88)|0;k[c>>2]=1;f=c+4|0;k[m>>2]=f;k[b>>2]=81;i[c+85>>0]=0;g=228234;h=f+81|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-27,m,228219,221854,4827);k[b>>2]=0;k[m>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)==1)ggb(k[c+-4>>2]|0)}l=a+16|0;b=k[l>>2]|0;h=i[b>>0]|0;if((h+-97&255)>=26?!(h<<24>>24==95|(h+-65&255)<26):0){b=m+4|0;c=ZT(48)|0;k[c>>2]=1;f=c+4|0;k[m>>2]=f;k[b>>2]=41;i[c+45>>0]=0;g=228316;h=f+41|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-5,m,228219,221854,4831);k[b>>2]=0;k[m>>2]=0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0);b=k[l>>2]|0}e=b;a:do if(!(e&3)){c=b;j=21}else{c=b;d=e;while(1){if(!(i[c>>0]|0)){c=d;break a}c=c+1|0;d=c;if(!(d&3)){j=21;break}}}while(0);if((j|0)==21){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}e=c-e|0;b:do if((e|0)>0){d=m+4|0;c=0;while(1){b=i[b+c>>0]|0;c:do if(!((b+-48&255)<10|((b&-33)+-65&255)<26)){switch(b<<24>>24){case 45:case 95:break c;default:{}}b=ZT(60)|0;k[b>>2]=1;f=b+4|0;k[m>>2]=f;k[d>>2]=54;i[b+58>>0]=0;g=228358;h=f+54|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-5,m,228219,221854,4840);k[d>>2]=0;k[m>>2]=0;j=k[b>>2]|0;k[b>>2]=j+-1;if((j|0)==1)ggb(k[b+-4>>2]|0)}while(0);b=c+1|0;if((b|0)>=(e|0))break b;c=b;b=k[l>>2]|0}}while(0);c=ZT(e+41|0)|0;f=c;g=a;h=f+40|0;do{k[f>>2]=k[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));b=c+40|0;k[c+16>>2]=b;upb(b|0,k[l>>2]|0,e+1|0)|0;k[c>>2]=0;b=k[107193]|0;k[c+12>>2]=b;k[c+8>>2]=0;if(!b){k[107194]=c;k[107193]=c;r=n;return}else{k[b+8>>2]=c;k[107193]=c;r=n;return}}function O5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;f=k[(k[a>>2]|0)+16>>2]|0;if(!f)return;b=k[107193]|0;if(!b)return;g=i[f>>0]|0;j=b;while(1){c=k[j+16>>2]|0;a=i[c>>0]|0;if(a<<24>>24==0?1:a<<24>>24!=g<<24>>24)c=g;else{e=f;do{c=c+1|0;e=e+1|0;a=i[c>>0]|0;d=i[e>>0]|0}while(!(a<<24>>24==0?1:a<<24>>24!=d<<24>>24));c=d}if(a<<24>>24==c<<24>>24)break;a=k[j+12>>2]|0;if(!a){h=17;break}else j=a}if((h|0)==17)return;a=k[j+8>>2]|0;c=j+12|0;d=k[c>>2]|0;e=d;f=a;if(!a){k[107193]=d;c=e;b=e}else{k[a+12>>2]=d;c=k[c>>2]|0}if(!c)k[107194]=f;else{k[c+8>>2]=f;a=k[107194]|0}if(!((b|0)!=0&(a|0)!=0)){k[107194]=0;k[107193]=0}ggb(k[j+-4>>2]|0);return}function P5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+48|0;f=C+8|0;A=C;c=k6(a,b,227957)|0;if(!((c|0)!=0?(k[c>>2]&7|0)==5:0)){d=A+4|0;b=ZT(96)|0;k[b>>2]=1;g=b+4|0;k[A>>2]=g;k[d>>2]=90;i[b+94>>0]=0;h=227967;j=g+90|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-212,A,228058,221854,4353);k[d>>2]=0;k[A>>2]=0;z=k[b>>2]|0;k[b>>2]=z+-1;if((z|0)==1)ggb(k[b+-4>>2]|0)}b=k[c+8>>2]|0;x=k[b+24>>2]|0;KY(b,f);if((x|0)<=0){B=0;r=C;return B|0}y=f+12|0;z=A+4|0;t=b+28|0;v=f+20|0;w=f+8|0;s=f+4|0;q=f+16|0;l=0;d=0;m=0;n=0;o=0;c=k[y>>2]|0;while(1){b=m;m=s6(a,c)|0;c=k6(a,c,228073)|0;a:do if(c){switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break}case 2:{e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;j=c&2146435072;if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}c=~~e;break}default:{f=2147483647;break a}}if((c|0)<0)B=16;else f=c}else{c=-1;B=16}while(0);if((B|0)==16){B=0;f=ZT(64)|0;k[f>>2]=1;g=f+4|0;k[A>>2]=g;k[z>>2]=56;i[f+60>>0]=0;h=228079;j=g+56|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-212,A,228058,221854,4367);k[z>>2]=0;k[A>>2]=0;j=k[f>>2]|0;k[f>>2]=j+-1;if((j|0)==1)ggb(k[f+-4>>2]|0);f=c}o=(o|0)==0?m:o;if((f|0)<=(d|0)){if((f|0)<(d|0))while(1){c=k[b+16>>2]|0;if((d|0)>(f|0)){d=d+-1|0;b=c}else break}else c=l;k[m+8>>2]=b;if(!b)b=c;else{k[b+12>>2]=m;b=c}}else{if(b|0)k[b+20>>2]=m;k[m+8>>2]=0}k[m+16>>2]=b;c=(k[y>>2]|0)+(k[t>>2]|0)|0;k[y>>2]=c;if(c>>>0>=(k[v>>2]|0)>>>0){l=k[(k[w>>2]|0)+4>>2]|0;k[w>>2]=l;c=k[l+16>>2]|0;k[y>>2]=c;h=c;j=k[(k[s>>2]|0)+28>>2]|0;l=k[l+12>>2]|0;k[q>>2]=h;l=h+(aa(j,l)|0)|0;k[v>>2]=l}n=n+1|0;if((n|0)>=(x|0))break;else{l=b;d=f}}B=o;r=C;return B|0}function Q5(a){a=a|0;var b=0;if((a|0)!=0?(b=k[a>>2]|0,(b&-65536|0)==1117257728):0)a=(b&12288|0)==4096;else a=0;return a&1|0}function R5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;f=r;r=r+16|0;b=f;if(a|0){k[a>>2]=0;r=f;return}c=b+4|0;d=ZT(24)|0;k[d>>2]=1;e=d+4|0;k[b>>2]=e;k[c>>2]=19;i[d+23>>0]=0;g=227921;h=e+19|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-27,b,227941,221854,4410);k[c>>2]=0;k[b>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);k[a>>2]=0;r=f;return}function S5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;w=r;r=r+48|0;q=w+8|0;p=w;if(!((a|0)!=0?(k[a>>2]&-53248|0)==1117261824:0)){b=p+4|0;c=ZT(28)|0;k[c>>2]=1;d=c+4|0;k[p>>2]=d;k[b>>2]=21;i[c+25>>0]=0;e=212742;f=d+21|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-5,p,212764,211567,3261);k[b>>2]=0;k[p>>2]=0;v=k[c>>2]|0;k[c>>2]=v+-1;if((v|0)==1)ggb(k[c+-4>>2]|0)}b=k[a+44>>2]|0;if(!b){b=p+4|0;c=ZT(28)|0;k[c>>2]=1;d=c+4|0;k[p>>2]=d;k[b>>2]=20;i[c+24>>0]=0;e=243280;f=d+20|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-27,p,212764,211567,3267);k[b>>2]=0;k[p>>2]=0;v=k[c>>2]|0;k[c>>2]=v+-1;if((v|0)==1)ggb(k[c+-4>>2]|0);b=0}o=a+28|0;t=k[o>>2]|0;m=a+64|0;n=k[(k[m>>2]|0)+28>>2]|0;l=a+24|0;u=ZT(k[l>>2]<<2)|0;v=ZT(k[l>>2]<<2)|0;j=a+4|0;s=YY(k[a>>2]|0,k[j>>2]|0,t,n,b)|0;upb(s+4624|0,a+4624|0,(k[j>>2]|0)+-68|0)|0;KY(a,q);if((k[l>>2]|0)>0){f=q+12|0;g=q+20|0;h=q+8|0;e=q+4|0;j=q+16|0;d=0;c=0;b=k[f>>2]|0;do{if((k[b>>2]|0)>-1){k[p>>2]=0;ZY(s,b,p);y=k[b>>2]|0;x=k[p>>2]|0;k[x>>2]=y;k[u+(c<<2)>>2]=y;k[b>>2]=c;k[v+(c<<2)>>2]=x;c=c+1|0;b=k[f>>2]|0}b=b+t|0;k[f>>2]=b;if(b>>>0>=(k[g>>2]|0)>>>0){y=k[(k[h>>2]|0)+4>>2]|0;k[h>>2]=y;b=k[y+16>>2]|0;k[f>>2]=b;y=k[y+12>>2]|0;x=k[(k[e>>2]|0)+28>>2]|0;k[j>>2]=b;y=b+(aa(x,y)|0)|0;k[g>>2]=y}d=d+1|0}while((d|0)<(k[l>>2]|0))}KY(k[m>>2]|0,q);b=k[m>>2]|0;c=k[b+24>>2]|0;if((c|0)>0){g=q+12|0;h=q+20|0;j=q+8|0;d=q+4|0;l=q+16|0;f=0;b=k[g>>2]|0;do{if((k[b>>2]|0)>-1){k[p>>2]=0;_Y(s,k[v+(k[k[b+16>>2]>>2]<<2)>>2]|0,k[v+(k[k[b+20>>2]>>2]<<2)>>2]|0,b,p)|0;k[k[p>>2]>>2]=k[b>>2];b=k[g>>2]|0}b=b+n|0;k[g>>2]=b;if(b>>>0>=(k[h>>2]|0)>>>0){y=k[(k[j>>2]|0)+4>>2]|0;k[j>>2]=y;b=k[y+16>>2]|0;k[g>>2]=b;y=k[y+12>>2]|0;x=k[(k[d>>2]|0)+28>>2]|0;k[l>>2]=b;y=b+(aa(x,y)|0)|0;k[h>>2]=y}f=f+1|0;e=k[m>>2]|0;c=k[e+24>>2]|0}while((f|0)<(c|0))}else{d=q+4|0;e=b}b=q+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[q>>2]=32;k[d>>2]=a;b=k[a+52>>2]|0;if(!b){f=q+8|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;f=0;c=k[e+24>>2]|0;b=0;e=0}else{y=k[b>>2]|0;f=k[b+16>>2]|0;k[q+12>>2]=f;e=k[o>>2]|0;y=(k[y+16>>2]|0)+(aa((k[y+12>>2]|0)+-1|0,e)|0)|0;k[q+28>>2]=y;k[q+24>>2]=k[b+8>>2];k[q+8>>2]=b;y=f;k[q+16>>2]=y;e=y+(aa(e,k[b+12>>2]|0)|0)|0;k[q+20>>2]=e}if((c|0)>0){l=q+12|0;m=q+20|0;n=q+8|0;j=q+16|0;h=0;g=0;d=f;do{if((k[d>>2]|0)>-1){k[d>>2]=k[u+(g<<2)>>2];g=g+1|0}d=f+t|0;k[l>>2]=d;if(d>>>0<e>>>0)f=d;else{b=k[b+4>>2]|0;k[n>>2]=b;d=k[b+16>>2]|0;k[l>>2]=d;f=d;e=k[b+12>>2]|0;y=k[a+28>>2]|0;k[j>>2]=f;e=f+(aa(y,e)|0)|0;k[m>>2]=e}h=h+1|0}while((h|0)!=(c|0))}if(u|0)ggb(k[u+-4>>2]|0);if(!v){r=w;return s|0}ggb(k[v+-4>>2]|0);r=w;return s|0}function T5(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;W=r;r=r+1168|0;w=W;T=W+656|0;t=W+144|0;U=W+16|0;V=W+8|0;c=k6(a,b,227233)|0;if((c|0)!=0?(k[c>>2]&7|0)==3:0)f=k[c+8+4>>2]|0;else f=0;c=k6(a,b,227252)|0;if((c|0)!=0?(k[c>>2]&7|0)==3:0)S=k[c+8+4>>2]|0;else S=0;c=k6(a,b,227273)|0;if((c|0)!=0?(k[c>>2]&7|0)==3:0)R=k[c+8+4>>2]|0;else R=0;c=k6(a,b,227239)|0;a:do if(!c)Q=-1;else{switch(k[c>>2]&7){case 1:{Q=k[c+8>>2]|0;break a}case 2:break;default:{Q=2147483647;break a}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;Q=c&2146435072;if(!(Q>>>0>1126170624|(Q|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}Q=~~d}while(0);c=k6(a,b,227262)|0;b:do if(!c)P=-1;else{switch(k[c>>2]&7){case 1:{P=k[c+8>>2]|0;break b}case 2:break;default:{P=2147483647;break b}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;P=c&2146435072;if(!(P>>>0>1126170624|(P|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}P=~~d}while(0);if(!((R|0)!=0&(((f|0)==0|(Q|0)==-1|(P|0)==-1)^1))){c=T+4|0;e=ZT(52)|0;k[e>>2]=1;J=e+4|0;k[T>>2]=J;k[c>>2]=45;i[e+49>>0]=0;K=227591;L=J+45|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-2,T,227637,221854,4589);k[c>>2]=0;k[T>>2]=0;O=k[e>>2]|0;k[e>>2]=O+-1;if((O|0)==1)ggb(k[e+-4>>2]|0)}O=i[f>>0]|0;if((O+-48|0)>>>0<10|((O|32)+-97|0)>>>0<6){k[T>>2]=0;M=T+4|0;k[M>>2]=f;k[T+44>>2]=f;c=(f|0)<0?-1:f+2147483647|0;O=T+8|0;k[O>>2]=c;k[T+76>>2]=-1;k[T+104>>2]=0;N=T+108|0;k[N>>2]=c-f;k[T+100>>2]=c;c=Efb(T,16,1,-2147483648,0)|0;if(!((c&-65536|0)==1117257728?((k[M>>2]|0)+(k[N>>2]|0)|0)!=(k[O>>2]|0):0)){e=T+4|0;f=ZT(36)|0;k[f>>2]=1;J=f+4|0;k[T>>2]=J;k[e>>2]=30;i[f+34>>0]=0;K=227650;L=J+30|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-2,T,227637,221854,4602);k[e>>2]=0;k[T>>2]=0;O=k[f>>2]|0;k[f>>2]=O+-1;if((O|0)==1)ggb(k[f+-4>>2]|0)}c=(c&4096|0)==0}else c=(Bfb(f,227224)|0)==0;n=c?1117261824:1117278208;c=k6(a,b,227302)|0;if((c|0)!=0?(k[c>>2]&7|0)==3:0)q=k[c+8+4>>2]|0;else q=0;o=k6(a,b,227420)|0;c=(q|0)!=0;s=(o|0)!=0;if(c^s){e=T+4|0;f=ZT(80)|0;k[f>>2]=1;J=f+4|0;k[T>>2]=J;k[e>>2]=74;i[f+78>>0]=0;K=227681;L=J+74|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-2,T,227637,221854,4617);k[e>>2]=0;k[T>>2]=0;O=k[f>>2]|0;k[f>>2]=O+-1;if((O|0)==1)ggb(k[f+-4>>2]|0)}if(c){O=j6(q,T)|0;f=O<<1;if((O|0)>0){c=68;e=0;do{O=k[T+((e|1)<<2)>>2]|0;O=(O>>>3&511)+1<<(47696>>>(O<<1&14)&3);c=(c+-1+O&0-O)+(aa(O,k[T+(e<<2)>>2]|0)|0)|0;e=e+2|0}while((e|0)<(f|0))}else c=68}else c=68;m=(S|0)==0;if(!m){O=j6(S,T)|0;g=O<<1;if((O|0)>0){e=0;f=0;do{O=k[T+((f|1)<<2)>>2]|0;O=(O>>>3&511)+1<<(47696>>>(O<<1&14)&3);e=(e+-1+O&0-O)+(aa(O,k[T+(f<<2)>>2]|0)|0)|0;f=f+2|0}while((f|0)<(g|0))}else e=0;j=k[T+4>>2]|0;j=(j>>>3&511)+1<<(47696>>>(j<<1&14)&3);j=e+-1+j&0-j;O=j6(S,T)|0;g=O<<1;if((O|0)>0){e=8;f=0;do{O=k[T+((f|1)<<2)>>2]|0;O=(O>>>3&511)+1<<(47696>>>(O<<1&14)&3);e=(e+-1+O&0-O)+(aa(O,k[T+(f<<2)>>2]|0)|0)|0;f=f+2|0}while((f|0)<(g|0))}else e=8;O=j6(R,t)|0;h=O<<1;if((O|0)>0){f=0;g=0;do{f=(k[t+(g<<2)>>2]|0)+f|0;g=g+2|0}while((g|0)<(h|0));O=e;N=j;e=t}else{O=e;N=j;f=0;e=t}}else{O=8;N=0;f=0;e=t}l=j6(R,e)|0;e=k[e>>2]|0;if(!((((l|0)>1&(e|0)==2?(k[t+4>>2]|0)==4:0)?(k[t+8>>2]|0)>=1:0)?(k[t+12>>2]|0)==5:0)){g=T+4|0;h=ZT(60)|0;k[h>>2]=1;J=h+4|0;k[T>>2]=J;k[g>>2]=52;i[h+56>>0]=0;K=227756;L=J+52|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-5,T,227637,221854,4643);k[g>>2]=0;k[T>>2]=0;M=k[h>>2]|0;k[h>>2]=M+-1;if((M|0)==1)ggb(k[h+-4>>2]|0)}if((l|0)<=2)if((l|0)>0){j=4;v=64}else{M=0;j=4}else{j=k[t+20>>2]|0;j=((j>>>3&511)+1<<(47696>>>(j<<1&14)&3)|0)>7?8:4;v=64}if((v|0)==64){g=l<<1;if((g|0)>2){h=2;do{e=(k[t+(h<<2)>>2]|0)+e|0;h=h+2|0}while((h|0)<(g|0));M=e}else M=e}e=R+2|0;g=i[e>>0]|0;switch(g<<24>>24){case 102:{v=68;break}case 49:{if((i[R+3>>0]|0)==102)v=68;else v=69;break}default:v=69}if((v|0)==68)e=R+3+((g+-48&255)<10&1)|0;else if((v|0)==69){k[T>>2]=0;I=T+4|0;k[I>>2]=e;k[T+44>>2]=e;L=(e|0)<0?-1:R+-2147483647|0;K=T+8|0;k[K>>2]=L;k[T+76>>2]=-1;k[T+104>>2]=0;J=T+108|0;k[J>>2]=L-e;k[T+100>>2]=L;L=Efb(T,10,1,-2147483648,0)|0;e=e+((k[I>>2]|0)+(k[J>>2]|0)-(k[K>>2]|0))|0;k[w>>2]=L+-1;k[w+4>>2]=e;Cfb(U,227809,w);e=U}L=j6(e,T)|0;h=L<<1;if((L|0)>0){e=24;g=0;do{L=k[T+((g|1)<<2)>>2]|0;L=(L>>>3&511)+1<<(47696>>>(L<<1&14)&3);e=(e+-1+L&0-L)+(aa(L,k[T+(g<<2)>>2]|0)|0)|0;g=g+2|0}while((g|0)<(h|0));I=e}else I=24;L=j6(R,T)|0;h=L<<1;if((L|0)>0){e=0;g=0;do{L=k[T+((g|1)<<2)>>2]|0;L=(L>>>3&511)+1<<(47696>>>(L<<1&14)&3);e=(e+-1+L&0-L)+(aa(L,k[T+(g<<2)>>2]|0)|0)|0;g=g+2|0}while((g|0)<(h|0));e=e+-1|0}else e=-1;H=k[T+4>>2]|0;H=(H>>>3&511)+1<<(47696>>>(H<<1&14)&3);H=e+H&0-H;G=YY(n,c,O,I,k[a+20>>2]|0)|0;if(s)l6(a,o,G+68|0,q);D=N*3|0;D=(D|0)<65536?65536:D;C=H*3|0;C=(C|0)<(D|0)?D:C;D=ZT(C)|0;E=ZT(Q<<2)|0;F=k6(a,b,227287)|0;B=k6(a,b,227296)|0;if(!B){c=T+4|0;e=ZT(20)|0;k[e>>2]=1;J=e+4|0;k[T>>2]=J;k[c>>2]=13;i[e+17>>0]=0;K=227815;L=J+13|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-5,T,227637,221854,4679);k[c>>2]=0;k[T>>2]=0;L=k[e>>2]|0;k[e>>2]=L+-1;if((L|0)==1)ggb(k[e+-4>>2]|0)}if(!(m|(F|0)!=0)){c=T+4|0;e=ZT(24)|0;k[e>>2]=1;J=e+4|0;k[T>>2]=J;k[c>>2]=16;i[e+20>>0]=0;K=227829;L=J+16|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-5,T,227637,221854,4681);k[c>>2]=0;k[T>>2]=0;L=k[e>>2]|0;k[e>>2]=L+-1;if((L|0)==1)ggb(k[e+-4>>2]|0)}z=V+4|0;A=j+-1|0;t=0-j|0;v=V+4|0;s=0;do{w=(s|0)==0;m=w?S:R;c=w?O:I;b=w?N:H;n=w?f:M;x=w?Q:P;o=(C|0)/(((b|0)<1?1:b)|0)|0;e=(m|0)!=0;if(e)n6(a,w?F:B,T);c:do if((x|0)>0){y=(c|0)>24;q=c+-24|0;if(e){e=0;g=D;l=0}else{h=D;j=0;while(1){if(!w){k[U>>2]=0;c=k[h>>2]|0;e=k[h+4>>2]|0;if(!(c>>>0<Q>>>0&e>>>0<Q>>>0)){g=ZT(52)|0;k[g>>2]=1;J=g+4|0;k[V>>2]=J;k[v>>2]=46;i[g+50>>0]=0;K=227846;L=J+46|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-211,V,227637,221854,4726);k[v>>2]=0;k[V>>2]=0;L=k[g>>2]|0;k[g>>2]=L+-1;if((L|0)==1)ggb(k[g+-4>>2]|0)}if(!(_Y(G,k[E+(c<<2)>>2]|0,k[E+(e<<2)>>2]|0,0,U)|0)){c=ZT(32)|0;k[c>>2]=1;J=c+4|0;k[V>>2]=J;k[z>>2]=27;i[c+31>>0]=0;K=227893;L=J+27|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-5,V,227637,221854,4732);k[z>>2]=0;k[V>>2]=0;L=k[c>>2]|0;k[c>>2]=L+-1;if((L|0)==1)ggb(k[c+-4>>2]|0)}c=k[U>>2]|0;k[c+4>>2]=k[h+8>>2];if(y)upb(c+24|0,A+(h+12)&t|0,q|0)|0}else{ZY(G,0,U);k[E+(j<<2)>>2]=k[U>>2]}j=j+1|0;if((x|0)<=(j|0))break c;else h=h+b|0}}while(1){c=x-l|0;if(!e){e=aa((c|0)>(o|0)?o:c,n)|0;o6(a,T,e,D,m);g=D}if(!w){k[U>>2]=0;c=k[g>>2]|0;h=k[g+4>>2]|0;if(!(c>>>0<Q>>>0&h>>>0<Q>>>0)){j=ZT(52)|0;k[j>>2]=1;J=j+4|0;k[V>>2]=J;k[v>>2]=46;i[j+50>>0]=0;K=227846;L=J+46|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-211,V,227637,221854,4726);k[v>>2]=0;k[V>>2]=0;L=k[j>>2]|0;k[j>>2]=L+-1;if((L|0)==1)ggb(k[j+-4>>2]|0)}if(!(_Y(G,k[E+(c<<2)>>2]|0,k[E+(h<<2)>>2]|0,0,U)|0)){c=ZT(32)|0;k[c>>2]=1;J=c+4|0;k[V>>2]=J;k[z>>2]=27;i[c+31>>0]=0;K=227893;L=J+27|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-5,V,227637,221854,4732);k[z>>2]=0;k[V>>2]=0;L=k[c>>2]|0;k[c>>2]=L+-1;if((L|0)==1)ggb(k[c+-4>>2]|0)}c=k[U>>2]|0;k[c+4>>2]=k[g+8>>2];if(y)upb(c+24|0,A+(g+12)&t|0,q|0)|0}else{ZY(G,0,U);k[E+(l<<2)>>2]=k[U>>2];upb((k[U>>2]|0)+8|0,g|0,b|0)|0}l=l+1|0;if((x|0)<=(l|0))break;else{e=e+-1|0;g=g+b|0}}}while(0);s=s+1|0}while((s|0)<2);if(D|0)ggb(k[D+-4>>2]|0);if(!E){r=W;return G|0}ggb(k[E+-4>>2]|0);r=W;return G|0}function U5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;K=r;r=r+928|0;I=K;G=K+512|0;t=K+800|0;p=K+672|0;H=K+544|0;q=k[c+60>>2]|0;E=c+64|0;s=k[(k[E>>2]|0)+60>>2]|0;J=ZT(q<<2)|0;KY(c,G);F=c+24|0;if((k[F>>2]|0)>0){j=G+12|0;l=c+28|0;m=G+20|0;n=G+8|0;i=G+4|0;o=G+16|0;g=0;h=0;e=k[j>>2]|0;do{f=k[e>>2]|0;if((f|0)>-1){k[J+(g<<2)>>2]=f;k[e>>2]=g;g=g+1|0}e=e+(k[l>>2]|0)|0;k[j>>2]=e;if(e>>>0>=(k[m>>2]|0)>>>0){D=k[(k[n>>2]|0)+4>>2]|0;k[n>>2]=D;e=k[D+16>>2]|0;k[j>>2]=e;B=e;C=k[(k[i>>2]|0)+28>>2]|0;D=k[D+12>>2]|0;k[o>>2]=B;D=B+(aa(C,D)|0)|0;k[m>>2]=D}h=h+1|0}while((h|0)<(k[F>>2]|0))}g6(a,b,6,225818);i6(a,227233,k[c>>2]&16384|0?227224:1016759,1);p6(a,227239,q);w=q6(c,227252,d,8,p)|0;if(w|0)i6(a,227252,w,0);p6(a,227262,s);y=q6(k[E>>2]|0,227273,d,24,t)|0;k[I>>2]=y|0?y:1016759;Cfb(H,227281,I);i6(a,227273,H,0);r6(a,c,d,68);y=c+28|0;z=(k[y>>2]|0)*3|0;z=(z|0)<65536?65536:z;d=(k[(k[E>>2]|0)+28>>2]|0)*3|0;d=(d|0)<(z|0)?z:d;z=ZT(d)|0;t=I+4|0;u=I+20|0;A=G+12|0;B=G+20|0;C=G+8|0;x=G+4|0;D=G+16|0;s=0;do{i=(s|0)==0;v=i?w:H;if(v|0){if(i)h=c;else h=k[E>>2]|0;q=h+28|0;b=k[q>>2]|0;p=j6(v,I)|0;g=p<<1;if((p|0)>0){e=0;f=0;do{p=k[I+((f|1)<<2)>>2]|0;p=(p>>>3&511)+1<<(47696>>>(p<<1&14)&3);e=(e+-1+p&0-p)+(aa(p,k[I+(f<<2)>>2]|0)|0)|0;f=f+2|0}while((f|0)<(g|0))}else e=0;o=k[t>>2]|0;o=(o>>>3&511)+1<<(47696>>>(o<<1&14)&3);o=e+-1+o&0-o;p=(d|0)/(o|0)|0;if((s|0)==1)if((j6(v,I)|0)>2){e=k[u>>2]|0;e=((e>>>3&511)+1<<(47696>>>(e<<1&14)&3)|0)>7?8:4}else e=4;else e=4;g6(a,i?227287:227296,13,0);KY(h,G);n=h+24|0;if((k[n>>2]|0)>0){m=e+-1|0;j=0-e|0;l=b+-24|0;if(!i){f=k[A>>2]|0;if((b|0)>24){e=0;g=z;h=0;do{if((k[f>>2]|0)>-1){b=g+3&-4;g=b;k[b>>2]=k[k[f+16>>2]>>2];k[g+4>>2]=k[k[f+20>>2]>>2];k[g+8>>2]=k[f+4>>2];upb(m+(g+12)&j|0,f+24|0,l|0)|0;e=e+1|0;if((e|0)<(p|0))g=g+o|0;else{h6(a,z,e,v);e=0;g=z}}f=(k[A>>2]|0)+(k[q>>2]|0)|0;k[A>>2]=f;if(f>>>0>=(k[B>>2]|0)>>>0){b=k[(k[C>>2]|0)+4>>2]|0;k[C>>2]=b;f=k[b+16>>2]|0;k[A>>2]=f;i=k[(k[x>>2]|0)+28>>2]|0;b=k[b+12>>2]|0;k[D>>2]=f;b=f+(aa(i,b)|0)|0;k[B>>2]=b}h=h+1|0}while((h|0)<(k[n>>2]|0))}else{e=0;g=z;h=0;do{if((k[f>>2]|0)>-1){m=g+3&-4;g=m;k[m>>2]=k[k[f+16>>2]>>2];k[g+4>>2]=k[k[f+20>>2]>>2];k[g+8>>2]=k[f+4>>2];e=e+1|0;if((e|0)<(p|0))g=g+o|0;else{h6(a,z,e,v);e=0;g=z;f=k[A>>2]|0}}f=f+(k[q>>2]|0)|0;k[A>>2]=f;if(f>>>0>=(k[B>>2]|0)>>>0){m=k[(k[C>>2]|0)+4>>2]|0;k[C>>2]=m;f=k[m+16>>2]|0;k[A>>2]=f;l=k[(k[x>>2]|0)+28>>2]|0;m=k[m+12>>2]|0;k[D>>2]=f;m=f+(aa(l,m)|0)|0;k[B>>2]=m}h=h+1|0}while((h|0)<(k[n>>2]|0))}}else{e=0;g=z;h=0;f=k[A>>2]|0;do{if((k[f>>2]|0)>-1){upb(g|0,f+8|0,o|0)|0;e=e+1|0;if((e|0)<(p|0))g=g+o|0;else{h6(a,z,e,v);e=0;g=z}}f=(k[A>>2]|0)+(k[q>>2]|0)|0;k[A>>2]=f;if(f>>>0>=(k[B>>2]|0)>>>0){m=k[(k[C>>2]|0)+4>>2]|0;k[C>>2]=m;f=k[m+16>>2]|0;k[A>>2]=f;l=k[(k[x>>2]|0)+28>>2]|0;m=k[m+12>>2]|0;k[D>>2]=f;m=f+(aa(l,m)|0)|0;k[B>>2]=m}h=h+1|0}while((h|0)<(k[n>>2]|0))}if((e|0)>0)h6(a,z,e,v)}_4(a)}s=s+1|0}while((s|0)!=2);_4(a);KY(c,G);h=k[F>>2]|0;if((h|0)>0){f=0;g=0;e=k[A>>2]|0;do{if((k[e>>2]|0)>-1){k[e>>2]=k[J+(f<<2)>>2];f=f+1|0}e=e+(k[y>>2]|0)|0;k[A>>2]=e;if(e>>>0>=(k[B>>2]|0)>>>0){I=k[(k[C>>2]|0)+4>>2]|0;k[C>>2]=I;e=k[I+16>>2]|0;k[A>>2]=e;G=e;H=k[(k[x>>2]|0)+28>>2]|0;I=k[I+12>>2]|0;k[D>>2]=G;I=G+(aa(H,I)|0)|0;k[B>>2]=I}g=g+1|0}while((g|0)!=(h|0))}if(z|0)ggb(k[z+-4>>2]|0);if(!J){r=K;return}ggb(k[J+-4>>2]|0);r=K;return}function V5(a){a=a|0;if(!a)a=0;else a=(k[a>>2]&-65536|0)==1111752704;return a&1|0}
function wi(a){a=a|0;var b=0;b=r;r=r+a|0;r=r+15&-16;return b|0}function xi(){return r|0}function yi(a){a=a|0;r=a}function zi(a,b){a=a|0;b=b|0;r=a;s=b}function Ai(a,b){a=a|0;b=b|0;if(!y){y=a;z=b}}function Bi(a){a=a|0;N=a}function Ci(){return N|0}function Di(){var a=0;if(i[427728]|0)return;k[107176]=39828;a=427728;k[a>>2]=1;k[a+4>>2]=0;return}function Ei(){var a=0;if(i[427720]|0)return;k[107177]=39776;a=427720;k[a>>2]=1;k[a+4>>2]=0;return}function Fi(){var a=0;if(i[427712]|0)return;k[107178]=39724;a=427712;k[a>>2]=1;k[a+4>>2]=0;return}function Gi(){var a=0;if(i[427704]|0)return;k[107179]=39672;a=427704;k[a>>2]=1;k[a+4>>2]=0;return}function Hi(){var a=0;if(i[427696]|0)return;k[107180]=39620;a=427696;k[a>>2]=1;k[a+4>>2]=0;return}function Ii(){var a=0;if(i[427688]|0)return;k[107181]=39568;a=427688;k[a>>2]=1;k[a+4>>2]=0;return}function Ji(){var a=0;if(i[427680]|0)return;k[107182]=39516;a=427680;k[a>>2]=1;k[a+4>>2]=0;return}function Ki(){var a=0;if(i[427672]|0)return;k[107183]=39464;a=427672;k[a>>2]=1;k[a+4>>2]=0;return}function Li(){var a=0;if(i[427664]|0)return;k[107184]=39412;a=427664;k[a>>2]=1;k[a+4>>2]=0;return}function Mi(){MK();Ni();return}function Ni(){var a=0,b=0;ff(177434,4,37612,202491,15,102);ff(236463,7,37584,202968,1,1);ff(177443,7,37556,203604,1,1);ff(177456,10,37516,203699,1,1);ff(177469,10,37476,203687,1,1);ff(177480,8,37444,203677,1,1);ff(341361,3,37432,202695,118,615);ff(210671,4,37416,202822,103,119);ff(177492,8,37384,203667,1,2);ff(216325,4,37368,202977,14,12);ff(177502,5,37348,201808,91,104);ff(177517,5,37328,201808,92,105);ff(177528,5,37308,201573,5,3);ff(177540,5,37348,201808,91,106);ff(231540,3,37296,203067,13,3);ff(177551,6,37272,202848,120,93);ff(177563,6,37248,202848,121,94);ff(177572,9,37212,203656,1,2);ff(177579,10,37172,203644,1,2);ff(177585,4,37416,202822,103,120);ff(235889,4,37156,202822,107,121);ff(236096,5,37136,201808,95,108);ff(236032,4,37156,202822,107,122);ff(236215,5,37116,203561,1,7);ff(354123,8,37084,203634,1,1);ff(388487,6,37060,202848,122,96);ff(177593,8,37028,203624,1,1);ff(242279,4,37012,202822,109,123);ff(236450,5,36992,203561,2,8);ff(348464,3,36980,203067,14,4);ff(177605,9,36944,203613,1,1);ff(231260,11,36900,203322,1,2);ff(351922,7,36872,203604,3,2);ff(177617,5,37136,201808,95,110);ff(177629,4,37156,202822,107,124);ff(177641,5,37136,201808,95,111);ff(177652,5,37136,201808,95,112);ff(177664,6,36848,202848,123,97);ff(211200,4,36832,202491,16,57);ff(177669,2,36824,202749,94,616);ff(177682,8,36792,197386,122,53);ff(177692,3,36780,202695,125,617);ff(403426,9,36744,194610,1,13);ff(334502,7,36716,203595,1,8);ff(215891,6,36692,202848,124,98);ff(334084,8,36660,197386,123,54);ff(404657,11,36616,203582,1,1);ff(403606,12,36568,203568,7,1);ff(214672,6,36544,202848,125,99);ff(246410,8,36512,197386,124,55);ff(177702,4,36496,202491,17,58);ff(177711,7,36468,202983,1,1);ff(209514,5,36448,201808,100,113);ff(334717,4,36432,202977,15,15);ff(220410,3,36420,202695,126,618);ff(242626,5,36400,200915,53,18);ff(242889,7,36372,194464,7,69);ff(348527,3,36980,203067,14,5);ff(338702,7,36344,202434,56,126);ff(210533,5,36324,197743,1,3);ff(243746,5,36304,201808,101,114);ff(243862,4,37416,202822,103,127);ff(211301,9,36268,203011,93,125);ff(177723,6,36244,202848,127,102);ff(177746,7,36216,203002,1,4);ff(177759,6,36244,202848,127,103);ff(244166,6,36192,202848,128,104);ff(229955,2,36184,202749,95,381);ff(347256,4,36168,202822,115,128);ff(237536,5,36148,201808,105,116);ff(213266,4,37012,202822,109,129);ff(393925,4,36132,202822,117,130);ff(244399,5,36148,201808,105,118);ff(394056,5,36112,203561,3,9);ff(177777,5,36092,203554,2,4);ff(213706,2,36084,202745,6,79);ff(212914,5,36148,201808,105,119);ff(177791,8,36052,197386,126,57);ff(245492,6,36244,202848,127,106);ff(177798,7,36024,202434,58,129);ff(177826,6,36e3,203079,5,4);ff(177833,5,35980,203547,1,1);ff(246949,10,35940,203535,3,94);ff(386053,6,35916,202848,130,107);ff(177841,8,35884,197386,127,59);ff(386232,11,35840,203322,2,4);ff(177852,11,35796,203322,3,5);ff(177867,6,35772,203189,1,3);ff(213926,4,35756,202491,19,59);ff(246518,11,35712,203309,1,1);ff(177888,6,35688,202848,131,108);ff(177897,8,35656,197386,128,60);ff(334811,3,35644,202695,131,619);ff(177910,8,36052,197386,126,61);ff(404364,4,35628,202491,20,120);ff(214812,3,35644,202695,131,620);ff(210430,4,37012,202822,109,132);ff(394218,6,35604,203301,3,1);ff(177916,7,35576,202434,62,132);ff(396148,7,35548,203292,2,2);ff(398232,9,35512,203281,1,1);ff(396176,8,35480,203271,2,1);ff(177938,9,35444,203011,95,129);ff(246600,6,35420,202848,133,109);ff(246680,7,35392,202434,63,134);ff(177965,8,35360,203261,1,2);ff(243584,7,35332,202434,64,135);ff(231486,3,35644,202695,131,621);ff(401634,7,35304,203252,1,4);ff(348586,2,35296,202749,96,622);ff(339666,7,35268,203243,2,2);ff(211163,4,37012,202822,109,133);ff(215412,8,35236,203233,1,1);ff(339330,3,35224,200947,60,134);ff(177974,4,35208,202491,21,121);ff(178e3,8,35176,197386,130,65);ff(256808,8,35144,203223,1,1);ff(351440,4,35128,202739,1,10);ff(178016,2,35120,202749,97,382);ff(339239,3,35224,200947,60,135);ff(347825,6,35096,202848,136,110);ff(178034,4,35080,203217,1,5);ff(346858,4,35064,202491,22,122);ff(178054,6,35040,203209,1,4);ff(247130,10,35e3,203197,1,1);ff(257471,8,34968,197386,131,66);ff(383925,5,34948,201573,6,4);ff(220248,3,34936,202695,136,623);ff(178066,4,37012,202822,109,137);ff(178071,5,36148,201808,105,123);ff(178076,6,34912,203189,2,4);ff(178095,3,34900,200947,61,138);ff(357885,5,34880,200915,54,23);ff(178104,3,34868,200947,62,139);ff(178111,4,34852,202491,24,63);ff(178123,4,34836,202491,25,64);ff(209752,5,37348,201808,91,124);ff(354446,9,34800,203011,96,132);ff(356186,10,34760,203097,1,1);ff(178131,6,36e3,203079,5,5);ff(210485,4,37012,202822,109,140);ff(352386,4,37012,202822,109,141);ff(178139,6,36692,202848,124,111);ff(178149,7,34732,202434,67,137);ff(257073,5,34712,202249,2,16);ff(213842,4,34696,202977,17,16);ff(339150,3,35644,202695,131,624);ff(243951,2,34688,202749,98,383);ff(213348,8,34656,203087,1,2);ff(246168,8,34624,197386,133,68);ff(178159,6,34600,203079,6,6);ff(214816,3,35644,202695,131,625);ff(178171,6,34600,203079,6,7);ff(214511,4,37416,202822,103,142);ff(340574,5,34580,203072,1,1);ff(353796,6,34556,202848,138,112);ff(178180,4,37416,202822,103,143);ff(230005,3,34544,200947,65,144);ff(401507,4,34528,202491,26,66);ff(230010,5,34508,201808,113,125);ff(351606,4,37012,202822,109,145);ff(210102,3,34936,202695,136,626);ff(178184,4,37416,202822,103,146);ff(178188,2,35296,202749,96,627);ff(178200,3,34496,203067,17,7);ff(210246,4,34480,202822,126,147);ff(341335,3,34468,200947,67,148);ff(346904,9,34432,203011,97,134);ff(213253,6,34408,202848,139,114);ff(216089,7,34380,203002,3,7);ff(178221,6,36e3,203079,5,8);ff(366900,4,34364,202977,18,18);ff(178230,5,34344,195854,3,19);ff(210826,8,34312,202992,1,1);ff(214845,3,34300,202734,1,75);ff(178236,7,34272,202983,3,3);ff(215782,4,37156,202822,107,149);ff(214589,5,34252,201808,115,127);ff(257011,4,34236,202977,20,19);ff(214762,6,36544,202848,125,116);ff(246802,8,34204,197386,135,69);ff(214820,4,34188,196816,11,6);ff(244139,5,36148,201808,105,128);ff(178249,10,34148,195537,1,2);ff(347306,5,34128,201808,117,129);ff(348172,7,34100,202968,3,3);ff(347566,5,34128,201808,117,130);ff(178257,4,34084,202822,131,150);ff(178263,4,34084,202822,131,151);ff(246323,8,34624,197386,133,70);ff(220440,6,36244,202848,127,118);ff(338208,8,34052,197386,136,71);ff(211168,5,34032,201808,119,132);ff(335645,7,37556,203604,1,3);ff(339532,4,34016,202491,27,68);ff(215859,5,33996,202942,2,4);ff(399700,7,33968,202434,72,140);ff(178269,9,33932,202931,1,2);ff(220360,3,33920,202695,152,628);ff(214268,5,33900,200915,55,28);ff(215067,3,33888,200947,69,99);ff(215264,4,34696,202977,17,20);ff(220644,4,37012,202822,109,153);ff(220649,4,37012,202822,109,154);ff(352015,6,36692,202848,124,120);ff(209959,3,33876,202695,155,629);ff(178281,8,36792,197386,122,73);ff(178294,3,35644,202695,131,630);ff(178299,5,36092,203554,2,6);ff(178311,6,37060,202848,122,121);ff(178320,2,33868,202749,100,631);ff(178329,7,33840,202922,4,4);ff(393853,6,33816,202914,1,1);ff(220372,2,33868,202749,100,632);ff(215754,4,37156,202822,107,156);ff(218978,3,35644,202695,131,633);ff(355009,6,33792,202848,141,122);ff(356032,7,33764,202434,74,142);ff(220337,3,34936,202695,136,634);ff(338864,8,33732,197386,137,75);ff(338994,8,33732,197386,137,76);ff(348009,3,35644,202695,131,635);ff(220936,1,33728,202887,1293,3);ff(178347,1,33724,202890,384,1);ff(178359,1,33724,202890,384,2);ff(178370,1,33724,202890,384,3);ff(178381,2,33716,201779,636,1294);ff(178394,1,33724,202890,384,4);Wd(8856,8888,8872,6688,202890,385,202890,386,202890,387,399235,202887,1295);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;ze(8856,178404,3,33704,202882,2,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;k[a+4>>2]=1;ze(8856,178422,2,33696,202856,8,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;k[a+4>>2]=1;ze(8856,178440,2,33696,202856,8,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=123;ze(8856,399869,6,33672,202848,143,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=157;ze(8856,178458,4,33656,202822,133,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;k[a+4>>2]=1;ze(8856,178467,2,33696,202856,8,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=77;ze(8856,178487,3,33704,202882,2,a|0,0);td(8856,4,33640,202816,1,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=78;ze(8856,178507,3,33704,202882,2,a|0,0);ef(8848,8856,178525,0,202890,388,225902,5,202890,389,202887,1296);Wd(8800,8832,8816,5632,202890,390,202890,391,202890,392,178543,202887,1297);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=112;k[a+4>>2]=1;ze(8800,178568,2,33632,202749,101,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=80;k[a+4>>2]=1;ze(8800,178585,2,33624,202745,9,a|0,1);td(8800,4,33608,202739,2,12);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=79;ze(8800,178596,3,33596,202734,3,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=80;ze(8800,178606,3,33596,202734,3,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=128;k[a+4>>2]=1;ze(8800,178625,2,33624,202745,9,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;k[a+4>>2]=1;ze(8800,178644,2,33588,202749,102,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=104;k[a+4>>2]=1;ze(8800,178657,2,33624,202745,9,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=637;ze(8800,178689,3,33576,202695,158,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=81;ze(8800,178702,3,33596,202734,3,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=120;k[a+4>>2]=1;ze(8800,178713,2,33588,202749,102,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=638;ze(8800,178728,3,33564,202695,159,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=88;k[a+4>>2]=1;ze(8800,178745,2,33624,202745,9,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=82;ze(8800,178755,3,33596,202734,3,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=639;ze(8800,178765,3,33576,202695,158,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=83;ze(8800,178776,3,33596,202734,3,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=72;k[a+4>>2]=1;ze(8800,178792,2,33624,202745,9,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;ze(8800,178811,3,33596,202734,3,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=96;k[a+4>>2]=1;ze(8800,178830,2,33624,202745,9,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;k[a+4>>2]=1;ze(8800,178840,2,33624,202745,9,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=85;ze(8800,178859,3,33596,202734,3,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;k[a+4>>2]=1;ze(8800,178878,2,33588,202749,102,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=640;ze(8800,178889,3,33576,202695,158,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=86;ze(8800,178904,3,33596,202734,3,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=64;k[a+4>>2]=1;ze(8800,178936,2,33624,202745,9,a|0,1);ef(8792,8800,178952,0,202890,393,225902,6,202890,394,202887,1298);Wd(8760,8776,8744,6632,202890,395,202890,396,202890,397,393825,202887,1299);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=44;k[a+4>>2]=1;ze(8760,178982,2,33556,202856,10,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=52;k[a+4>>2]=1;ze(8760,178995,2,33548,202749,103,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=87;ze(8760,179007,3,33536,202882,4,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=641;ze(8760,179020,3,33524,202695,160,a|0,0);td(8760,3,33512,202589,1,5);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=36;k[a+4>>2]=1;ze(8760,179031,2,33504,202749,104,a|0,1);ef(8736,8760,179042,0,202890,398,225902,7,202890,399,202887,1300);Wd(20744,8720,8656,0,202890,400,202497,0,202497,0,179066,202887,1301);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=70;ze(20744,179080,4,33488,202491,29,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=2;ze(20744,386843,9,33452,202480,1,a|0,0);td(20744,1,33448,202890,401,8);td(20744,13,33396,202465,1,1);td(20744,2,33388,202749,105,402);qf(20744,179085,1,33384,202890,403,1302);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=144;ze(20744,383842,7,33356,202434,77,a|0,0);qf(20744,179110,1,33384,202890,403,1303);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=404;k[a+4>>2]=0;ze(20744,179135,2,33348,202749,106,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=80;k[a+4>>2]=0;ze(20744,179153,2,33340,202745,11,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=145;ze(20744,386760,7,33312,202434,78,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=161;ze(20744,377166,4,33296,202822,134,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=642;ze(20744,384225,3,33284,202695,162,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=405;k[a+4>>2]=0;ze(20744,383655,2,33276,202749,107,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=2;ze(20744,379340,11,33232,202286,1,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=4;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=4;Qd(20744,384053,5016,202749,108,a|0,5016,202695,163,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=12;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=12;Qd(20744,384061,5016,202749,108,a|0,5016,202695,163,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=20;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=20;Qd(20744,384071,5016,202749,108,a|0,5016,202695,163,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=28;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=28;Qd(20744,384187,5016,202749,108,a|0,5016,202695,163,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=36;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=36;Qd(20744,384083,28960,202749,109,a|0,28960,202695,164,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=40;Qd(20744,384089,28960,202749,109,a|0,28960,202695,164,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=48;Qd(20744,384196,29032,202745,12,a|0,29032,202734,6,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=56;Qd(20744,384103,28960,202749,109,a|0,28960,202695,164,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=64;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=64;Qd(20744,384121,29032,202745,12,a|0,29032,202734,6,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=72;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=72;Qd(20744,384136,28896,202749,110,a|0,28896,202695,165,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=76;Qd(20744,179165,7304,202749,111,a|0,7304,202695,166,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=140;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=140;Qd(20744,384152,28960,202749,109,a|0,28960,202695,164,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=144;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=144;Qd(20744,384160,28896,202749,110,a|0,28896,202695,165,b|0);Wd(8624,8640,8608,19304,202890,406,202890,407,202890,408,179177,202887,1304);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=100;k[a+4>>2]=1;ze(8624,179199,2,33224,202749,112,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=643;ze(8624,179215,3,33212,202695,167,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(8624,179230,2,33204,202749,113,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;k[a+4>>2]=1;ze(8624,179244,2,33204,202749,113,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=21;ze(8624,372250,5,33184,202249,4,a|0,0);td(8624,1,33180,202890,409,1305);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=60;k[a+4>>2]=1;ze(8624,179259,2,33172,202745,13,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=644;ze(8624,179275,3,33160,202695,168,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=645;ze(8624,179291,3,33212,202695,167,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=646;ze(8624,392032,3,33212,202695,167,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=88;ze(8624,179308,3,33148,202734,7,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(8624,179324,2,33204,202749,113,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=92;k[a+4>>2]=1;ze(8624,179342,2,33204,202749,113,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=647;ze(8624,179359,3,33212,202695,167,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=108;k[a+4>>2]=1;ze(8624,179377,2,33140,202749,114,a|0,1);ef(8600,8624,179395,0,202890,410,225902,9,202890,411,202887,1306);Wd(8568,8584,8552,5256,202890,412,202890,413,202890,414,179422,202887,1307);td(8568,4,33124,202109,1,5);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=648;ze(8568,179449,3,33112,202695,169,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;k[a+4>>2]=1;ze(8568,179461,2,33104,202749,115,a|0,1);Wd(8504,8536,8520,20976,202890,415,202890,416,202890,417,179473,202887,1308);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(8504,179494,2,33096,202749,116,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(8504,178982,2,33088,202749,117,a|0,1);td(8504,4,33072,202491,30,135);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;k[a+4>>2]=1;ze(8504,179515,2,33088,202749,117,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=649;ze(8504,179523,3,33060,202695,170,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=650;ze(8504,179007,3,33048,202695,171,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=651;ze(8504,179544,3,33048,202695,171,a|0,0);ef(8496,8504,179552,0,202890,418,225902,10,202890,419,202887,1309);Wd(8448,8480,8464,6232,202890,420,202890,421,202890,422,179578,202887,1310);td(8448,1,33044,202890,423,1311);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=164;k[a+4>>2]=1;ze(8448,179587,2,33036,202745,14,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=652;ze(8448,179605,3,33024,202695,172,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=156;k[a+4>>2]=1;ze(8448,179618,2,33016,202749,118,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=148;k[a+4>>2]=1;ze(8448,179631,2,33016,202749,118,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=89;ze(8448,179644,3,33004,202734,8,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=653;ze(8448,179662,3,33024,202695,172,a|0,0);ef(8440,8448,179675,0,202890,424,225902,11,202890,425,202887,1312);Wd(5576,8408,8424,10416,202890,426,202890,427,202890,428,179689,202887,1313);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=136;ze(5576,404929,5,32984,201808,124,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=36;k[a+4>>2]=1;ze(5576,179706,2,32976,201779,654,a|0,1);Wd(8360,8392,8376,10416,202890,429,202890,430,202890,431,179721,202887,1314);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;ze(8360,339812,6,32952,201714,70,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=146;ze(8360,386843,7,32924,202434,79,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=173;ze(8360,340047,4,32908,202822,137,a|0,0);td(8360,9,32872,201676,1,1);ef(8352,8360,179741,0,202890,432,225902,12,202890,433,202887,1315);Wd(5632,8336,8320,10416,202890,434,202890,435,202890,436,179766,202887,1316);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=6;ze(5632,400950,5,32852,201573,7,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=655;ze(5632,400839,3,32840,202695,174,a|0,0);Wd(8288,8304,8272,5256,202890,437,202890,438,202890,439,179787,202887,1317);td(8288,3,32828,202589,2,9);Wd(8232,8240,8256,0,202890,440,202497,0,202497,0,179813,202887,1318);qf(8232,232984,5,32808,201808,125,138);qf(8232,179822,8,32776,201444,2,4);td(8232,1,32772,202890,441,13);td(8232,8,32740,201418,1,8);qf(8232,179831,4,32724,201397,22,21);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;Qd(8232,179839,7408,202749,119,a|0,7408,202695,175,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=8;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=8;Qd(8232,380512,29008,202856,15,a|0,29008,202882,10,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=12;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=12;Qd(8232,179842,29008,202856,15,a|0,29008,202882,10,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=16;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=16;Qd(8232,179848,29008,202856,15,a|0,29008,202882,10,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=20;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=20;Qd(8232,179857,28960,202749,120,a|0,28960,202695,176,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=24;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=24;Qd(8232,179864,28960,202749,120,a|0,28960,202695,176,b|0);Wd(8184,8216,8200,6456,202890,442,202890,443,202890,444,179873,202887,1319);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=656;ze(8184,179882,3,32712,202695,177,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=139;ze(8184,179889,5,32692,201808,126,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=127;ze(8184,399869,6,32668,202848,147,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=178;ze(8184,178458,4,32652,202822,140,a|0,0);td(8184,4,32636,202491,31,141);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=657;ze(8184,179904,3,32624,202695,179,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=60;k[a+4>>2]=1;ze(8184,179920,2,32616,202749,121,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=658;ze(8184,179936,3,32624,202695,179,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=142;ze(8184,179947,5,32596,201808,128,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(8184,179956,2,32588,202749,122,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=52;k[a+4>>2]=1;ze(8184,179963,2,32616,202749,121,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=143;ze(8184,393400,4,32572,202491,32,a|0,0);ef(8168,8184,179974,0,202890,445,225902,14,202890,446,202887,1320);Wd(8120,8152,8136,6336,202890,447,202890,448,202890,449,179988,202887,1321);td(8120,2,32564,202749,123,659);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;k[a+4>>2]=1;ze(8120,180006,2,32556,202749,124,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=660;ze(8120,180020,3,32544,202695,180,a|0,0);ef(8112,8120,180034,0,202890,450,225902,15,202890,451,202887,1322);Wd(8064,8096,8080,6688,202890,452,202890,453,202890,454,398980,202887,1323);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=129;ze(8064,399869,6,32520,202848,148,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=144;ze(8064,178458,5,32500,201808,130,a|0,0);td(8064,1,32496,202890,455,1324);ef(8056,8064,180057,0,202890,456,225902,16,202890,457,202887,1325);Wd(5256,8040,8024,10416,202890,458,202890,459,202890,460,180075,202887,1326);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;k[a+4>>2]=1;ze(5256,180098,2,32488,202749,125,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;k[a+4>>2]=1;ze(5256,180110,2,32480,202856,16,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=145;ze(5256,180125,5,32460,201808,131,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=661;ze(5256,180141,3,32448,202695,181,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=90;ze(5256,180153,3,32436,202882,11,a|0,0);ef(7104,5256,180168,0,202890,461,225902,17,202890,462,202887,1327);Wd(6232,8008,7992,19304,202890,463,202890,464,202890,465,180196,202887,1328);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=100;k[a+4>>2]=1;ze(6232,180206,2,32428,202749,126,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(6232,180220,2,32420,202749,127,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=662;ze(6232,180238,3,32408,202695,182,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=663;ze(6232,371195,3,32396,202695,183,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=664;ze(6232,180260,3,32396,202695,183,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=108;k[a+4>>2]=1;ze(6232,180278,2,32428,202749,126,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=665;ze(6232,370995,3,32396,202695,183,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=666;ze(6232,371354,3,32396,202695,183,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=124;k[a+4>>2]=1;ze(6232,180300,2,32388,202749,128,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;k[a+4>>2]=1;ze(6232,180310,2,32420,202749,127,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=667;ze(6232,180321,3,32408,202695,182,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=668;ze(6232,180338,3,32408,202695,182,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=60;k[a+4>>2]=1;ze(6232,180352,2,32420,202749,127,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=92;k[a+4>>2]=1;ze(6232,180369,2,32428,202749,126,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=91;ze(6232,371138,3,32376,202882,12,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(6232,180386,2,32420,202749,127,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=669;ze(6232,180398,3,32364,202695,184,a|0,0);td(6232,1,32360,202890,466,1329);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=116;k[a+4>>2]=1;ze(6232,180408,2,32352,202856,17,a|0,1);ef(7984,6232,180430,0,202890,467,225902,18,202890,468,202887,1330);Wd(20856,7952,7968,20848,202890,469,202890,470,202890,471,180445,202887,1331);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=670;ze(20856,384743,2,32344,202749,129,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=185;ze(20856,180462,3,32332,200947,71,a|0,0);td(20856,5,32312,200915,57,33);Wd(21320,7904,7936,21272,202890,472,202890,473,202890,474,389088,202887,1332);td(21320,3,32300,200947,72,130);Wd(7856,7888,7872,4896,202890,475,202890,476,202890,477,400437,202887,1333);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=52;k[a+4>>2]=1;ze(7856,180471,2,32292,202856,18,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=44;k[a+4>>2]=1;ze(7856,180485,2,32292,202856,18,a|0,1);td(7856,4,32276,202816,2,2);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=92;ze(7856,180494,3,32264,202882,13,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=93;ze(7856,180508,3,32264,202882,13,a|0,0);ef(7848,7856,180517,0,202890,478,225902,19,202890,479,202887,1334);Wd(19304,7832,7816,10416,202890,480,202890,481,202890,482,180537,202887,1335);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=36;k[a+4>>2]=1;ze(19304,180550,2,32172,202749,131,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;k[a+4>>2]=1;ze(19304,180560,2,32172,202749,131,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=23;ze(19304,372250,5,32244,202249,5,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=24;ze(19304,180573,5,32224,202249,6,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=32;k[a+4>>2]=1;ze(19304,180583,2,32216,202749,132,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=73;ze(19304,389152,4,32200,202491,34,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=35;ze(19304,180595,5,32180,200915,58,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=20;k[a+4>>2]=1;ze(19304,219976,2,32172,202749,131,a|0,0);Wd(4896,7800,7784,10416,202890,483,202890,484,202890,485,399790,202887,1336);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=186;ze(4896,399869,4,32156,202822,146,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=94;ze(4896,180602,3,32144,202882,14,a|0,0);td(4896,2,32136,200630,1,95);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=36;k[a+4>>2]=1;ze(4896,180611,2,32128,202856,19,a|0,1);ef(7776,4896,180620,0,202890,486,225902,20,202890,487,202887,1337);Wd(7728,7760,7744,19304,202890,488,202890,489,202890,490,180633,202887,1338);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=671;ze(7728,180645,3,32116,202695,187,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(7728,180661,2,32108,202749,133,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=672;ze(7728,180677,3,32096,202695,188,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=673;ze(7728,180694,3,32096,202695,188,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=674;ze(7728,180702,3,32096,202695,188,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=60;k[a+4>>2]=1;ze(7728,180714,2,32088,202749,134,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(7728,180726,2,32088,202749,134,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;k[a+4>>2]=1;ze(7728,180734,2,32088,202749,134,a|0,1);td(7728,1,32084,202890,491,1339);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=5;ze(7728,372666,7,32056,200524,3,a|0,0);ef(7720,7728,180751,0,202890,492,225902,21,202890,493,202887,1340);Wd(7672,7704,7688,20976,202890,494,202890,495,202890,496,180768,202887,1341);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(7672,179494,2,32048,202749,135,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(7672,178982,2,32040,202749,136,a|0,1);td(7672,4,32024,202491,36,147);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;k[a+4>>2]=1;ze(7672,179515,2,32040,202749,136,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=675;ze(7672,179523,3,32012,202695,189,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=676;ze(7672,179007,3,32e3,202695,190,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=677;ze(7672,179544,3,32e3,202695,190,a|0,0);ef(7664,7672,180788,0,202890,497,225902,22,202890,498,202887,1342);Wd(7400,7624,7648,0,202890,499,202497,0,202497,0,180813,202887,1343);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=137;ze(7400,352285,3,31988,200947,74,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=678;ze(7400,180822,3,31976,202695,191,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=75;ze(7400,180830,4,31960,202491,37,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;ze(7400,180838,4,31944,202491,38,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=679;ze(7400,180849,3,31932,202695,192,a|0,0);td(7400,1,31928,202890,500,23);td(7400,2,31920,202749,138,501);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=77;ze(7400,180862,4,31944,202491,38,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=680;ze(7400,180870,3,31908,202695,193,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=139;ze(7400,180886,3,31896,200947,78,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=79;ze(7400,180895,4,31960,202491,37,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=681;ze(7400,180903,3,31884,202695,194,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=148;ze(7400,180915,4,31868,202491,39,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=149;ze(7400,180925,5,31848,201808,132,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=140;ze(7400,180945,3,31896,200947,78,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=80;ze(7400,372666,4,31832,202491,40,a|0,0);Wd(7368,7384,7352,20976,202890,502,202890,503,202890,504,180953,202887,1344);td(7368,4,31816,202109,2,7);td(7368,6,31792,199660,1,5);ef(7296,7368,180959,0,202890,505,225902,24,202890,506,202887,1345);Wd(7272,7256,7280,0,202890,507,202497,0,202497,0,180970,202887,1346);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=141;ze(7272,372250,3,31780,200947,81,a|0,0);td(7272,1,31776,202890,508,25);td(7272,5,31756,200915,59,41);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=142;ze(7272,180983,3,31780,200947,81,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;Qd(7272,180991,4568,202749,143,a|0,4568,202695,195,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=56;Qd(7272,181e3,4568,202749,143,a|0,4568,202695,195,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=112;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=112;Qd(7272,181010,4568,202749,143,a|0,4568,202695,195,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=168;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=168;Qd(7272,181027,4568,202749,143,a|0,4568,202695,195,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=224;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=224;Qd(7272,181041,4568,202749,143,a|0,4568,202695,195,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=280;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=280;Qd(7272,181059,4568,202749,143,a|0,4568,202695,195,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=336;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=336;Qd(7272,181075,4568,202749,143,a|0,4568,202695,195,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=392;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=392;Qd(7272,181095,4568,202749,143,a|0,4568,202695,195,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=448;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=448;Qd(7272,181107,4568,202749,143,a|0,4568,202695,195,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=504;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=504;Qd(7272,181112,4568,202749,143,a|0,4568,202695,195,b|0);Wd(7224,7240,7208,5256,202890,509,202890,510,202890,511,181125,202887,1347);td(7224,4,33124,202109,1,8);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=682;ze(7224,179449,3,31744,202695,196,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;k[a+4>>2]=1;ze(7224,179461,2,31736,202749,144,a|0,1);Wd(7176,7192,7160,6336,202890,512,202890,513,202890,514,181151,202887,1348);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=96;ze(7176,181183,3,31724,202734,15,a|0,0);td(7176,2,31716,199429,2,97);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;k[a+4>>2]=1;ze(7176,181210,2,31708,202745,20,a|0,1);ef(7152,7176,181237,0,202890,515,225902,26,202890,516,202887,1349);Wd(7088,7136,7120,4824,202890,517,202890,518,202890,519,181274,202887,1350);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=96;k[a+4>>2]=1;ze(7088,181304,2,31700,202856,21,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=683;ze(7088,392321,3,31688,202695,197,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=120;k[a+4>>2]=1;ze(7088,181327,2,31680,202749,145,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=136;k[a+4>>2]=1;ze(7088,181344,2,31672,202749,146,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=684;ze(7088,181366,3,31660,202695,198,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=112;k[a+4>>2]=1;ze(7088,179230,2,31652,202749,147,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=98;ze(7088,181388,3,31640,202882,16,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;k[a+4>>2]=1;ze(7088,181410,2,31700,202856,21,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=99;ze(7088,181425,3,31640,202882,16,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=685;ze(7088,181450,3,31628,202695,199,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=100;ze(7088,181471,3,31640,202882,16,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=101;ze(7088,181494,3,31640,202882,16,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=686;ze(7088,181504,3,31616,202695,200,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=102;ze(7088,392231,3,31640,202882,16,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=80;k[a+4>>2]=1;ze(7088,181521,2,31700,202856,21,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=72;k[a+4>>2]=1;ze(7088,181543,2,31608,202749,148,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;k[a+4>>2]=1;ze(7088,181564,2,31652,202749,147,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=201;ze(7088,392151,4,31592,202822,150,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=88;k[a+4>>2]=1;ze(7088,181579,2,31700,202856,21,a|0,1);td(7088,8,31560,199139,1,2);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=64;k[a+4>>2]=1;ze(7088,181604,2,31700,202856,21,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=103;ze(7088,392261,3,31640,202882,16,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=687;ze(7088,392032,3,31688,202695,197,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;k[a+4>>2]=1;ze(7088,181619,2,31652,202749,147,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=128;k[a+4>>2]=1;ze(7088,181633,2,31700,202856,21,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=202;ze(7088,392206,4,31544,202822,151,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=688;ze(7088,392291,3,31688,202695,197,a|0,0);ef(7080,7088,181643,0,202890,520,225902,27,202890,521,202887,1351);Wd(7032,7064,7048,20976,202890,522,202890,523,202890,524,181678,202887,1352);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=689;ze(7032,181683,3,31532,202695,203,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=690;ze(7032,181695,3,31520,202695,204,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=92;k[a+4>>2]=1;ze(7032,181712,2,31512,202749,149,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=100;k[a+4>>2]=1;ze(7032,181724,2,31512,202749,149,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=691;ze(7032,181741,3,31520,202695,204,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(7032,181753,2,31504,202749,150,a|0,1);td(7032,7,31476,199034,1,2);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(7032,181764,2,31504,202749,150,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=692;ze(7032,181776,3,31532,202695,203,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=693;ze(7032,181787,3,31520,202695,204,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;k[a+4>>2]=1;ze(7032,178982,2,31468,202745,22,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=108;k[a+4>>2]=1;ze(7032,181802,2,31512,202749,149,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=104;ze(7032,179007,3,31456,202734,17,a|0,0);ef(7024,7032,181817,0,202890,525,225902,28,202890,526,202887,1353);Wd(6632,7008,6992,10416,202890,527,202890,528,202890,529,181827,202887,1354);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=152;ze(6632,399869,5,31436,201808,133,a|0,0);Wd(6944,6976,6960,20976,202890,530,202890,531,202890,532,181840,202887,1355);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=694;ze(6944,181695,3,31424,202695,205,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=695;ze(6944,181846,3,31424,202695,205,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=108;k[a+4>>2]=1;ze(6944,181724,2,31416,202749,151,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=696;ze(6944,181741,3,31424,202695,205,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(6944,181864,2,31416,202749,151,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=92;k[a+4>>2]=1;ze(6944,178982,2,31408,202745,23,a|0,1);td(6944,8,31376,198909,1,3);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=100;k[a+4>>2]=1;ze(6944,181712,2,31416,202749,151,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=697;ze(6944,181882,3,31424,202695,205,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=105;ze(6944,179007,3,31364,202734,18,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;k[a+4>>2]=1;ze(6944,181904,2,31416,202749,151,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=698;ze(6944,181926,3,31424,202695,205,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=699;ze(6944,181787,3,31424,202695,205,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=116;k[a+4>>2]=1;ze(6944,181802,2,31416,202749,151,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(6944,383655,2,31416,202749,151,a|0,1);ef(6936,6944,181944,0,202890,533,225902,29,202890,534,202887,1356);Wd(20976,6920,6904,10416,202890,535,202890,536,202890,537,181955,202887,1357);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=153;ze(20976,386843,5,31344,201808,134,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=154;ze(20976,386760,5,31324,201808,135,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=60;k[a+4>>2]=1;ze(20976,181965,2,31316,202749,152,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=149;ze(20976,390333,7,31288,202434,80,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=52;k[a+4>>2]=1;ze(20976,181977,2,31316,202749,152,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;k[a+4>>2]=1;ze(20976,181992,2,31316,202749,152,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=20;k[a+4>>2]=1;ze(20976,219976,2,31280,202749,153,a|0,0);Wd(19712,6848,6872,0,202890,538,202497,0,202497,0,182007,202887,1358);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=82;ze(19712,179080,4,31264,202491,42,a|0,0);td(19712,1,31260,202890,539,30);td(19712,4,31244,202491,43,83);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=2;ze(19712,377193,8,31212,198811,1,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=540;k[a+4>>2]=0;ze(19712,182019,2,31204,202749,154,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=155;ze(19712,377442,5,31184,201808,136,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=541;k[a+4>>2]=0;ze(19712,182032,2,31176,202749,155,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=28;k[a+4>>2]=1;ze(19712,372928,2,31168,201779,700,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=701;ze(19712,377166,3,31156,202695,206,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=150;ze(19712,377418,7,31128,202434,81,a|0,0);Wd(6776,6808,6792,19304,202890,542,202890,543,202890,544,182044,202887,1359);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=7;ze(6776,367323,6,31104,198555,6,a|0,0);td(6776,1,31100,202890,545,1360);ef(6768,6776,182069,0,202890,546,225902,31,202890,547,202887,1361);Wd(6688,6752,6736,10416,202890,548,202890,549,202890,550,182099,202887,1362);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=137;ze(6688,399869,6,31076,202848,151,a|0,0);Wd(6672,6720,6704,6688,202890,551,202890,552,202890,553,399507,202887,1363);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=138;ze(6672,399869,6,31052,202848,152,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=156;ze(6672,178458,5,31032,201808,139,a|0,0);td(6672,1,31028,202890,554,1364);ef(6664,6672,182114,0,202890,555,225902,32,202890,556,202887,1365);Wd(6616,6648,6600,6632,202890,557,202890,558,202890,559,393607,202887,1366);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=702;ze(6616,182134,3,31016,202695,207,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=52;k[a+4>>2]=1;ze(6616,182144,2,31008,202749,156,a|0,1);td(6616,4,30992,198312,3,13);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=44;k[a+4>>2]=1;ze(6616,182154,2,30984,202749,157,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=106;ze(6616,182165,3,30972,202882,19,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=703;ze(6616,182175,3,30960,202695,208,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=36;k[a+4>>2]=1;ze(6616,182186,2,30952,202856,24,a|0,1);ef(6592,6616,182196,0,202890,560,225902,33,202890,561,202887,1367);Wd(20872,6520,6504,0,202890,562,202497,0,202497,0,182218,202887,1368);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=704;ze(20872,182244,3,30940,202695,209,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=157;ze(20872,386760,5,30920,201808,140,a|0,0);td(20872,3,30908,200947,84,158);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=563;k[a+4>>2]=0;ze(20872,182258,2,30900,202749,159,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=564;k[a+4>>2]=0;ze(20872,181977,2,30892,202749,160,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=565;k[a+4>>2]=0;ze(20872,181992,2,30892,202749,160,a|0,0);Wd(6456,6488,6472,10416,202890,566,202890,567,202890,568,182272,202887,1369);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=141;ze(6456,399869,6,30868,202848,153,a|0,0);Wd(10416,6424,6440,0,202890,569,202497,0,202497,0,182287,202887,1370);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=705;ze(10416,182297,2,30860,202749,161,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=8;k[a+4>>2]=1;ze(10416,220047,2,30852,201779,706,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=707;ze(10416,377166,3,30840,202695,210,a|0,0);Wd(6336,6408,6392,10416,202890,570,202890,571,202890,572,182312,202887,1371);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=154;ze(6336,392673,7,30812,202434,82,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=158;ze(6336,392901,5,30792,201808,142,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=22;ze(6336,392764,4,30776,201397,25,a|0,0);Wd(6288,6320,6304,19304,202890,573,202890,574,202890,575,182329,202887,1372);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=64;k[a+4>>2]=1;ze(6288,179244,2,30768,202749,162,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=120;k[a+4>>2]=1;ze(6288,182340,2,30760,202745,25,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=128;k[a+4>>2]=1;ze(6288,182356,2,30760,202745,25,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=107;ze(6288,182370,3,30748,202734,20,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=112;k[a+4>>2]=1;ze(6288,182386,2,30760,202745,25,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=108;ze(6288,182401,3,30748,202734,20,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=109;ze(6288,182424,3,30748,202734,20,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=7;ze(6288,360455,5,30728,197743,5,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=96;k[a+4>>2]=1;ze(6288,182438,2,30760,202745,25,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=136;k[a+4>>2]=1;ze(6288,182463,2,30760,202745,25,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=110;ze(6288,182477,3,30748,202734,20,a|0,0);td(6288,1,30724,202890,576,1373);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=111;ze(6288,182491,3,30748,202734,20,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=112;ze(6288,182503,3,30748,202734,20,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=113;ze(6288,182528,3,30748,202734,20,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=8;ze(6288,179215,5,30728,197743,5,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=708;ze(6288,179275,3,30712,202695,211,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=709;ze(6288,360413,3,30700,202695,212,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(6288,182543,2,30692,202749,163,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=88;k[a+4>>2]=1;ze(6288,182557,2,30760,202745,25,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=80;k[a+4>>2]=1;ze(6288,179199,2,30684,202749,164,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=213;ze(6288,360236,3,30672,200947,85,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=104;k[a+4>>2]=1;ze(6288,182580,2,30760,202745,25,a|0,1);ef(6280,6288,182592,0,202890,577,225902,34,202890,578,202887,1374);Wd(6216,6264,6248,6232,202890,579,202890,580,202890,581,182608,202887,1375);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=164;k[a+4>>2]=1;ze(6216,179199,2,30664,202749,165,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=148;k[a+4>>2]=1;ze(6216,182618,2,30656,202749,166,a|0,1);td(6216,1,30652,202890,582,1376);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=710;ze(6216,182644,3,30640,202695,214,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=172;k[a+4>>2]=1;ze(6216,182670,2,30632,202749,167,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=711;ze(6216,179275,3,30620,202695,215,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=156;k[a+4>>2]=1;ze(6216,182687,2,30612,202749,168,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=712;ze(6216,182705,3,30600,202695,216,a|0,0);ef(6208,6216,182723,0,202890,583,225902,35,202890,584,202887,1377);Wd(4824,6192,6176,10416,202890,585,202890,586,202890,587,182738,202887,1378);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=23;ze(4824,392374,4,30584,201397,26,a|0,0);Wd(6144,6160,6128,20976,202890,588,202890,589,202890,590,182761,202887,1379);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=92;k[a+4>>2]=1;ze(6144,182774,2,30576,202749,169,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=108;k[a+4>>2]=1;ze(6144,182787,2,30568,202745,26,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=713;ze(6144,182792,3,30556,202695,217,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=714;ze(6144,182810,3,30544,202695,218,a|0,0);td(6144,7,30516,197494,1,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=114;ze(6144,182823,3,30504,202734,21,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=715;ze(6144,182839,3,30544,202695,218,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=115;ze(6144,182854,3,30504,202734,21,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(6144,182859,2,30576,202749,169,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=116;ze(6144,182874,3,30504,202734,21,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;k[a+4>>2]=1;ze(6144,182889,2,30568,202745,26,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(6144,182904,2,30568,202745,26,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=100;k[a+4>>2]=1;ze(6144,182920,2,30496,202749,170,a|0,1);ef(6120,6144,182938,0,202890,591,225902,36,202890,592,202887,1380);Wd(21272,6104,5992,10416,202890,593,202890,594,202890,595,182956,202887,1381);td(21272,2,30488,202749,171,716);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=8;k[a+4>>2]=1;ze(21272,220047,2,30480,201779,717,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=83;ze(21272,389853,8,30448,197386,138,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=155;ze(21272,182974,7,30420,202434,84,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=718;ze(21272,388487,3,30408,202695,219,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;k[a+4>>2]=1;ze(21272,389152,2,30480,201779,717,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=143;ze(21272,182984,6,30384,202848,156,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=159;ze(21272,182990,5,30364,201808,144,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=596;k[a+4>>2]=0;ze(21272,182997,2,30356,202749,172,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=36;k[a+4>>2]=1;ze(21272,183017,2,30348,202749,173,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=20;k[a+4>>2]=1;ze(21272,219976,2,30348,202749,173,a|0,0);ef(5984,21272,183033,0,202890,597,225902,37,202890,598,202887,1382);Wd(5960,5944,5968,0,202890,599,202497,0,202497,0,183056,202887,1383);td(5960,1,30344,202890,600,38);td(5960,4,30328,202109,3,86);td(5960,5,30308,197023,5,44);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;Qd(5960,183063,28960,202749,174,a|0,28960,202695,220,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=4;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=4;Qd(5960,183072,28960,202749,174,a|0,28960,202695,220,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=8;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=8;Qd(5960,183081,28960,202749,174,a|0,28960,202695,220,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=12;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=12;Qd(5960,391168,29008,202856,27,a|0,29008,202882,22,b|0);Wd(5912,5928,5896,4896,202890,601,202890,602,202890,603,400132,202887,1384);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=117;ze(5912,183088,3,30296,202882,23,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=118;ze(5912,183102,3,30296,202882,23,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=119;ze(5912,180494,3,30296,202882,23,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=52;k[a+4>>2]=1;ze(5912,183116,2,30288,202856,28,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=60;k[a+4>>2]=1;ze(5912,183128,2,30288,202856,28,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(5912,183142,2,30288,202856,28,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=44;k[a+4>>2]=1;ze(5912,180471,2,30288,202856,28,a|0,1);td(5912,6,30264,196949,1,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=120;ze(5912,183156,3,30296,202882,23,a|0,0);ef(5888,5912,183168,0,202890,604,225902,39,202890,605,202887,1385);Wd(21288,5856,5872,21272,202890,606,202890,607,202890,608,183187,202887,1386);td(21288,3,30252,200947,87,175);Wd(20672,5840,5824,10416,202890,609,202890,610,202890,611,183197,202887,1387);Wd(19224,5792,5808,0,202890,612,202497,0,202497,0,183219,202887,1388);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=221;ze(19224,363461,4,30236,202822,160,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;k[a+4>>2]=1;ze(19224,183232,2,30228,202749,176,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=7;ze(19224,363407,4,30212,196816,14,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=161;ze(19224,363573,5,30192,201808,145,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=16;k[a+4>>2]=1;ze(19224,183250,2,30184,202749,177,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;k[a+4>>2]=1;ze(19224,183266,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=12;k[a+4>>2]=1;ze(19224,183283,2,30184,202749,177,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;k[a+4>>2]=1;ze(19224,183300,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=60;k[a+4>>2]=1;ze(19224,183310,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=72;k[a+4>>2]=1;ze(19224,183334,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=120;k[a+4>>2]=1;ze(19224,183351,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=28;k[a+4>>2]=1;ze(19224,183366,2,30184,202749,177,a|0,1);td(19224,8,30152,196785,14,139);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=64;k[a+4>>2]=1;ze(19224,183378,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=24;k[a+4>>2]=1;ze(19224,183391,2,30184,202749,177,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=162;ze(19224,363659,5,30132,201808,146,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=178;ze(19224,363497,3,30120,200947,88,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=100;k[a+4>>2]=1;ze(19224,183400,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=52;k[a+4>>2]=1;ze(19224,183417,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(19224,183442,2,30228,202749,176,a|0,1);qf(19224,362196,4,30104,202491,45,163);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=80;k[a+4>>2]=1;ze(19224,183464,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=140;k[a+4>>2]=1;ze(19224,363353,2,30096,201779,719,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=147;ze(19224,183485,5,30076,200915,60,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=88;k[a+4>>2]=1;ze(19224,183501,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=96;k[a+4>>2]=1;ze(19224,183512,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;k[a+4>>2]=1;ze(19224,183530,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=112;k[a+4>>2]=1;ze(19224,183541,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=128;k[a+4>>2]=1;ze(19224,183563,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=124;k[a+4>>2]=1;ze(19224,183573,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=20;k[a+4>>2]=1;ze(19224,183583,2,30184,202749,177,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=36;k[a+4>>2]=1;ze(19224,182154,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(19224,183595,2,30228,202749,176,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=92;k[a+4>>2]=1;ze(19224,183615,2,30184,202749,177,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=8;k[a+4>>2]=1;ze(19224,183631,2,30184,202749,177,a|0,1);ef(5784,19224,183641,0,202890,613,225902,40,202890,614,202887,1389);Wd(5688,5768,5752,20976,202890,615,202890,616,202890,617,183659,202887,1390);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=96;k[a+4>>2]=1;ze(5688,183664,2,30068,202749,179,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=720;ze(5688,183677,3,30056,202695,222,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=72;k[a+4>>2]=1;ze(5688,183688,2,30048,202749,180,a|0,1);td(5688,10,30008,196699,1,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=88;k[a+4>>2]=1;ze(5688,183697,2,30048,202749,180,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=721;ze(5688,183708,3,30056,202695,222,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=722;ze(5688,183719,3,29996,202695,223,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=80;k[a+4>>2]=1;ze(5688,183732,2,30048,202749,180,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=164;ze(5688,390134,5,29976,201808,148,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=723;ze(5688,183743,3,30056,202695,222,a|0,0);ef(5680,5688,183752,0,202890,618,225902,41,202890,619,202887,1391);Wd(5616,5664,5648,5632,202890,620,202890,621,202890,622,183762,202887,1392);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=72;k[a+4>>2]=1;ze(5616,178568,2,29968,202749,181,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=64;k[a+4>>2]=1;ze(5616,183786,2,29960,202749,182,a|0,1);td(5616,4,29944,202739,4,15);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=724;ze(5616,178728,3,29932,202695,224,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;k[a+4>>2]=1;ze(5616,183800,2,29924,202745,29,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=121;ze(5616,183818,3,29912,202734,24,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;k[a+4>>2]=1;ze(5616,183583,2,29960,202749,182,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=725;ze(5616,183836,3,29900,202695,225,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;k[a+4>>2]=1;ze(5616,178878,2,29960,202749,182,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=726;ze(5616,178889,3,29900,202695,225,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=727;ze(5616,178765,3,29900,202695,225,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=728;ze(5616,183850,3,29900,202695,225,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=88;k[a+4>>2]=1;ze(5616,178625,2,29924,202745,29,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=80;k[a+4>>2]=1;ze(5616,178713,2,29960,202749,182,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=122;ze(5616,178811,3,29912,202734,24,a|0,0);ef(5608,5616,183862,0,202890,623,225902,42,202890,624,202887,1393);Wd(5560,5592,5544,5576,202890,625,202890,626,202890,627,183891,202887,1394);td(5560,1,29896,202890,628,1395);ef(5536,5560,183911,0,202890,629,225902,43,202890,630,202887,1396);Wd(5488,5520,5504,10416,202890,631,202890,632,202890,633,183936,202887,1397);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=729;ze(5488,183942,3,29884,202695,226,a|0,0);td(5488,3,29872,196200,1,8);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=52;k[a+4>>2]=1;ze(5488,179706,2,29864,201779,730,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=123;ze(5488,183959,3,29852,202734,25,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;k[a+4>>2]=1;ze(5488,183972,2,29844,202749,183,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;k[a+4>>2]=1;ze(5488,183989,2,29836,202745,30,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=227;ze(5488,400950,4,29820,202822,165,a|0,0);ef(5480,5488,184002,0,202890,634,225902,44,202890,635,202887,1398);Wd(5352,5448,5464,0,202890,636,202497,0,202497,0,184013,202887,1399);td(5352,1,29816,202890,637,45);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;Qd(5352,385149,29008,202856,31,a|0,29008,202882,26,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=4;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=4;Qd(5352,385163,29008,202856,31,a|0,29008,202882,26,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=8;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=8;Qd(5352,385176,29008,202856,31,a|0,29008,202882,26,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=12;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=12;Qd(5352,385189,28984,202749,184,a|0,28984,202695,228,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=16;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=16;Qd(5352,385206,29008,202856,31,a|0,29008,202882,26,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=20;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=20;Qd(5352,385226,28896,202749,185,a|0,28896,202695,229,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=21;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=21;Qd(5352,385240,28928,202749,186,a|0,28928,202695,230,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=22;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=22;Qd(5352,385250,28896,202749,185,a|0,28896,202695,229,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=24;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=24;Qd(5352,385263,29008,202856,31,a|0,29008,202882,26,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=28;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=28;Qd(5352,385271,29008,202856,31,a|0,29008,202882,26,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=32;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=32;Qd(5352,385279,28896,202749,185,a|0,28896,202695,229,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=36;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=36;Qd(5352,385299,29008,202856,31,a|0,29008,202882,26,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=40;Qd(5352,385314,29008,202856,31,a|0,29008,202882,26,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=44;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=44;Qd(5352,385329,28896,202749,185,a|0,28896,202695,229,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=48;Qd(5352,385345,29008,202856,31,a|0,29008,202882,26,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=52;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=52;Qd(5352,385361,29008,202856,31,a|0,29008,202882,26,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=56;Qd(5352,385377,28896,202749,185,a|0,28896,202695,229,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=60;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=60;Qd(5352,385395,29008,202856,31,a|0,29008,202882,26,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=64;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=64;Qd(5352,385408,29008,202856,31,a|0,29008,202882,26,b|0);Wd(5424,5432,5408,0,202890,638,202497,0,202497,0,184039,202887,1400);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;Qd(5424,184047,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=8;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=8;Qd(5424,184051,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=16;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=16;Qd(5424,184055,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=24;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=24;Qd(5424,184059,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=32;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=32;Qd(5424,184063,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=40;Qd(5424,184067,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=48;Qd(5424,184071,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=56;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=56;Qd(5424,184075,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=64;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=64;Qd(5424,184079,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=72;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=72;Qd(5424,184083,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=80;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=80;Qd(5424,184087,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=88;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=88;Qd(5424,184092,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=96;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=96;Qd(5424,184097,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=104;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=104;Qd(5424,184102,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=112;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=112;Qd(5424,184107,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=120;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=120;Qd(5424,184112,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=128;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=128;Qd(5424,184117,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=136;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=136;Qd(5424,184122,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=144;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=144;Qd(5424,184127,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=152;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=152;Qd(5424,184132,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=160;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=160;Qd(5424,184137,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=168;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=168;Qd(5424,184142,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=176;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=176;Qd(5424,184147,29032,202745,32,a|0,29032,202734,27,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=184;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=184;Qd(5424,184152,29032,202745,32,a|0,29032,202734,27,b|0);Wd(5376,5392,5360,20976,202890,639,202890,640,202890,641,184157,202887,1401);td(5376,2,29808,202749,187,731);ef(5344,5376,184176,0,202890,642,225902,46,202890,643,202887,1402);Wd(5312,5328,5296,19304,202890,644,202890,645,202890,646,184200,202887,1403);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;k[a+4>>2]=1;ze(5312,184207,2,29800,202745,33,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=92;k[a+4>>2]=1;ze(5312,184217,2,29800,202745,33,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=124;ze(5312,184222,3,29788,202734,28,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=108;k[a+4>>2]=1;ze(5312,184231,2,29800,202745,33,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=125;ze(5312,184236,3,29788,202734,28,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=732;ze(5312,179544,3,29776,202695,231,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=148;k[a+4>>2]=1;ze(5312,184242,2,29704,202749,188,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=126;ze(5312,184260,3,29788,202734,28,a|0,0);td(5312,1,29772,202890,647,1404);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=127;ze(5312,184270,3,29788,202734,28,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=60;k[a+4>>2]=1;ze(5312,179515,2,29764,202749,189,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=733;ze(5312,179275,3,29752,202695,232,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=128;ze(5312,180602,3,29788,202734,28,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=129;ze(5312,184275,3,29788,202734,28,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(5312,184280,2,29800,202745,33,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(5312,180611,2,29800,202745,33,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=132;k[a+4>>2]=1;ze(5312,248200,2,29764,202749,189,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=124;k[a+4>>2]=1;ze(5312,179199,2,29744,202749,190,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=27;ze(5312,368866,5,29724,195854,8,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=116;k[a+4>>2]=1;ze(5312,184289,2,29704,202749,188,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=734;ze(5312,184305,3,29776,202695,231,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=735;ze(5312,184315,3,29712,202695,233,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=100;k[a+4>>2]=1;ze(5312,184331,2,29800,202745,33,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=736;k[a+4>>2]=0;ze(5312,370717,2,29704,202749,188,a|0,0);ef(5288,5312,184337,0,202890,648,225902,47,202890,649,202887,1405);Wd(5240,5272,5224,5256,202890,650,202890,651,202890,652,184349,202887,1406);td(5240,3,32828,202589,2,29);Wd(4984,5160,5048,0,202890,653,202497,0,202497,0,184377,202887,1407);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=191;ze(4984,179080,3,29692,200947,89,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=654;k[a+4>>2]=0;ze(4984,380155,2,29684,202749,192,a|0,0);qf(4984,232984,4,29668,202491,46,90);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=193;ze(4984,401059,3,29656,200947,91,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=3;ze(4984,184395,10,29616,195537,2,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=655;k[a+4>>2]=0;ze(4984,380114,2,29608,202749,194,a|0,0);td(4984,1,29604,202890,656,48);td(4984,2,29596,202749,195,657);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=2;ze(4984,184413,12,29548,195324,1,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=737;k[a+4>>2]=0;ze(4984,380133,2,29540,202749,196,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=658;k[a+4>>2]=0;ze(4984,219976,2,29608,202749,194,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=2;ze(4984,379340,9,29504,195136,4,a|0,0);Wd(4952,4968,4936,4896,202890,659,202890,660,202890,661,400281,202887,1408);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=130;ze(4952,184431,3,29492,202882,30,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=131;ze(4952,184450,3,29492,202882,30,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=44;k[a+4>>2]=1;ze(4952,184469,2,29484,202856,34,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=52;k[a+4>>2]=1;ze(4952,184482,2,29484,202856,34,a|0,1);td(4952,5,29464,195057,1,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=132;ze(4952,184501,3,29492,202882,30,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=60;k[a+4>>2]=1;ze(4952,184514,2,29484,202856,34,a|0,1);ef(4928,4952,184533,0,202890,662,225902,49,202890,663,202887,1409);Wd(4880,4912,4864,4896,202890,664,202890,665,202890,666,400003,202887,1410);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=133;ze(4880,184554,3,29452,202882,31,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=44;k[a+4>>2]=1;ze(4880,180471,2,29444,202856,35,a|0,1);td(4880,4,29428,202816,3,3);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=52;k[a+4>>2]=1;ze(4880,184562,2,29444,202856,35,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=134;ze(4880,180494,3,29452,202882,31,a|0,0);ef(4856,4880,184570,0,202890,667,225902,50,202890,668,202887,1411);Wd(4808,4840,4792,4824,202890,669,202890,670,202890,671,184588,202887,1412);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=738;ze(4808,184615,3,29416,202695,234,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=135;ze(4808,391082,3,29404,202882,32,a|0,0);td(4808,3,29392,202589,3,33);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=40;k[a+4>>2]=1;ze(4808,184631,2,29384,202749,197,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=48;k[a+4>>2]=1;ze(4808,184647,2,29376,202856,36,a|0,1);ef(4784,4808,184665,0,202890,672,225902,51,202890,673,202887,1413);Wd(20848,4768,4752,0,202890,674,202497,0,202497,0,184697,202887,1414);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=675;k[a+4>>2]=0;ze(20848,184708,2,29368,202749,198,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=739;ze(20848,384743,2,29360,202749,199,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=235;ze(20848,180462,3,29348,200947,92,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=740;ze(20848,388487,3,29336,202695,236,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=8;k[a+4>>2]=1;ze(20848,220047,2,29328,201779,741,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=676;k[a+4>>2]=0;ze(20848,184723,2,29320,202749,200,a|0,0);Wd(4704,4736,4720,20976,202890,677,202890,678,202890,679,184740,202887,1415);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(4704,182859,2,29312,202749,201,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=742;ze(4704,184744,3,29300,202695,237,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=743;ze(4704,184761,3,29300,202695,237,a|0,0);td(4704,10,29260,194676,1,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=132;k[a+4>>2]=1;ze(4704,184775,2,29312,202749,201,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=744;ze(4704,182839,3,29300,202695,237,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=108;k[a+4>>2]=1;ze(4704,184792,2,29312,202749,201,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;k[a+4>>2]=1;ze(4704,184801,2,29312,202749,201,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=745;ze(4704,184812,3,29300,202695,237,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=746;ze(4704,184823,3,29300,202695,237,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(4704,184840,2,29252,202745,37,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=747;ze(4704,184855,3,29300,202695,237,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=748;ze(4704,184868,3,29300,202695,237,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=136;ze(4704,184877,3,29240,202734,34,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=124;k[a+4>>2]=1;ze(4704,184892,2,29312,202749,201,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=92;k[a+4>>2]=1;ze(4704,184905,2,29312,202749,201,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=100;k[a+4>>2]=1;ze(4704,184922,2,29312,202749,201,a|0,1);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=116;k[a+4>>2]=1;ze(4704,184936,2,29312,202749,201,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=749;ze(4704,184949,3,29300,202695,237,a|0,0);ef(4696,4704,184962,0,202890,680,225902,52,202890,681,202887,1416);Wd(4552,4680,4584,19304,202890,682,202890,683,202890,684,184971,202887,1417);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=15;ze(4552,184977,9,29204,194610,2,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=76;k[a+4>>2]=1;ze(4552,179199,2,29196,202749,202,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=750;ze(4552,184984,3,29184,202695,238,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=84;k[a+4>>2]=1;ze(4552,360236,2,29176,202749,203,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=751;ze(4552,365252,3,29164,202695,239,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=71;ze(4552,184992,7,29136,194464,9,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=166;ze(4552,365089,4,29120,202491,47,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=60;k[a+4>>2]=1;ze(4552,184999,2,29112,202749,204,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=752;ze(4552,179275,3,29100,202695,240,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=1;ze(4552,185017,2,29112,202749,204,a|0,1);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=753;ze(4552,365213,3,29164,202695,239,a|0,0);td(4552,1,29096,202890,685,1418);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=88;k[a+4>>2]=1;ze(4552,185041,2,29176,202749,203,a|0,1);while(1){a=fgb(4)|0;if(a|0){b=2477;break}a=k[207666]|0;k[207666]=a+0;if(!a){a=0;b=2477;break}Qh[a&7]()}if((b|0)==2477){k[a>>2]=61;ze(4552,185050,6,29072,201714,72,a|0,0);ef(4544,4552,185058,0,202890,686,225902,53,202890,687,202887,1419);Df(4536,185069,4,0);qd(4536,185092,0);qd(4536,185115,1);Df(4528,185142,4,0);qd(4528,185163,0);qd(4528,185178,0);qd(4528,185193,1);qd(4528,185208,1);qd(4528,185223,2);qd(4528,185238,2);qd(4528,185253,3);qd(4528,185268,3);qd(4528,185283,4);qd(4528,185297,4);qd(4528,185311,5);qd(4528,185327,5);qd(4528,185343,6);qd(4528,185358,7);qd(4528,185373,8);qd(4528,185388,8);qd(4528,185403,9);qd(4528,185419,9);qd(4528,185435,10);qd(4528,185451,11);qd(4528,185467,12);qd(4528,185484,13);qd(4528,185501,14);qd(4528,185518,15);qd(4528,185535,16);qd(4528,185553,17);qd(4528,185571,18);qd(4528,185589,19);qd(4528,185607,20);qd(4528,185625,21);qd(4528,185643,22);qd(4528,185660,23);qd(4528,185677,24);qd(4528,185694,25);qd(4528,185711,26);qd(4528,185729,27);qd(4528,185747,28);qd(4528,185765,29);qd(4528,185783,30);qd(4528,185801,31);qd(4528,185819,32);qd(4528,185833,33);qd(4528,185847,34);qd(4528,185861,35);qd(4528,185875,36);qd(4528,185891,37);qd(4528,185907,38);qd(4528,185923,39);qd(4528,185939,40);qd(4528,185953,41);qd(4528,185967,44);qd(4528,185981,45);qd(4528,185995,50);qd(4528,186009,51);qd(4528,186023,52);qd(4528,186037,53);qd(4528,186051,54);qd(4528,186065,55);qd(4528,186079,56);qd(4528,186093,57);qd(4528,186107,58);qd(4528,186121,59);qd(4528,186135,60);qd(4528,186149,61);qd(4528,186163,66);qd(4528,186182,67);qd(4528,186201,68);qd(4528,186220,69);qd(4528,186239,70);qd(4528,186258,71);qd(4528,186277,72);qd(4528,186296,73);qd(4528,186315,74);qd(4528,186330,75);qd(4528,186345,76);qd(4528,186360,77);qd(4528,186375,78);qd(4528,186390,79);qd(4528,186405,80);qd(4528,186420,81);qd(4528,186435,82);qd(4528,186449,83);qd(4528,186463,84);qd(4528,186477,85);qd(4528,186491,90);qd(4528,186510,91);qd(4528,186529,92);qd(4528,186548,93);qd(4528,186567,92);qd(4528,186586,93);qd(4528,186605,94);qd(4528,186625,95);qd(4528,186645,96);qd(4528,186665,97);qd(4528,186685,96);qd(4528,186705,97);qd(4528,186725,98);qd(4528,186744,99);qd(4528,186763,100);qd(4528,186782,101);qd(4528,186801,100);qd(4528,186820,101);qd(4528,186839,98);qd(4528,186857,99);qd(4528,186875,102);qd(4528,186895,103);qd(4528,186915,104);qd(4528,186935,105);qd(4528,186955,104);qd(4528,186975,105);qd(4528,186995,102);qd(4528,187014,103);qd(4528,187033,106);qd(4528,187052,106);qd(4528,187072,106);qd(4528,187092,106);qd(4528,187112,106);qd(4528,187132,106);qd(4528,187152,106);qd(4528,187172,106);qd(4528,187191,107);qd(4528,187210,108);qd(4528,187229,107);qd(4528,187248,108);qd(4528,187267,107);qd(4528,187286,108);qd(4528,187305,111);qd(4528,187325,112);qd(4528,187345,111);qd(4528,187365,112);qd(4528,187385,111);qd(4528,187405,112);qd(4528,187425,115);qd(4528,187444,116);qd(4528,187463,117);qd(4528,187482,118);qd(4528,187501,115);qd(4528,187520,116);qd(4528,187539,115);qd(4528,187558,116);qd(4528,187577,119);qd(4528,187597,120);qd(4528,187617,121);qd(4528,187637,122);qd(4528,187657,119);qd(4528,187677,120);qd(4528,187697,119);qd(4528,187717,120);qd(4528,187737,123);qd(4528,187757,124);qd(4528,187777,123);qd(4528,187797,123);qd(4528,187817,124);qd(4528,187837,124);qd(4528,187857,124);qd(4528,187877,125);qd(4528,187894,126);qd(4528,187911,127);qd(4528,187930,128);qd(4528,187949,127);qd(4528,187968,128);qd(4528,187987,129);qd(4528,188007,130);qd(4528,188027,129);qd(4528,188047,130);qd(4528,188067,131);qd(4528,188086,132);qd(4528,188105,133);qd(4528,188125,134);qd(4528,188145,46);qd(4528,188163,47);qd(4528,188181,48);qd(4528,188199,49);qd(4528,188217,48);qd(4528,188235,49);qd(4528,188253,46);qd(4528,188271,47);qd(4528,188289,86);qd(4528,188308,87);qd(4528,188327,88);qd(4528,188346,89);qd(4528,188365,62);qd(4528,188387,63);qd(4528,188409,64);qd(4528,188431,65);qd(4528,188453,64);qd(4528,188475,65);qd(4528,188497,62);qd(4528,188519,63);qd(4528,188541,135);qd(4528,188562,136);qd(4528,188583,137);qd(4528,188604,138);qd(4528,188625,137);qd(4528,188646,138);qd(4528,188667,135);qd(4528,188688,136);qd(4528,188709,139);Df(4520,188728,4,0);qd(4520,188742,0);qd(4520,188758,1);qd(4520,188772,2);qd(4520,188785,3);qd(4520,188801,4);qd(4520,188818,5);qd(4520,188833,6);qd(4520,188849,7);qd(4520,188865,8);qd(4520,188879,9);qd(4520,188892,10);qd(4520,188906,11);qd(4520,188919,12);Df(4512,188935,4,0);qd(4512,188960,0);qd(4512,188973,1);qd(4512,188985,2);qd(4512,188999,3);qd(4512,189014,4);qd(4512,189027,5);Df(4504,189039,4,0);qd(4504,189065,1);qd(4504,189083,2);qd(4504,189103,3);qd(4504,189124,4);Df(4496,189147,4,0);qd(4496,189158,0);qd(4496,189174,1);qd(4496,189187,2);qd(4496,189201,4);qd(4496,189213,8);qd(4496,189224,16);Df(4488,189235,4,0);qd(4488,189263,0);qd(4488,189280,1);Df(4480,189297,4,0);qd(4480,189320,3);qd(4480,189332,5);qd(4480,189344,0);Df(4472,189362,4,1);qd(4472,189376,-1);qd(4472,189386,1);qd(4472,189394,2);qd(4472,189402,3);qd(4472,189409,4);qd(4472,189418,5);qd(4472,189428,6);qd(4472,189440,7);Df(4464,189451,4,0);qd(4464,189466,65536);qd(4464,189488,131072);Df(4456,189508,4,0);qd(4456,189523,0);qd(4456,189530,1);qd(4456,189537,2);qd(4456,189547,3);Df(4448,189557,4,0);qd(4448,189570,0);qd(4448,189588,1);qd(4448,189606,2);Df(4440,189614,4,0);qd(4440,189627,0);qd(4440,189648,1);qd(4440,189667,2);qd(4440,189687,3);qd(4440,189708,4);qd(4440,189729,5);qd(4440,189756,6);qd(4440,189784,7);qd(4440,189812,16);Df(4432,189824,4,0);qd(4432,189840,0);qd(4432,189855,1);qd(4432,189870,2);qd(4432,189888,3);qd(4432,189910,3);qd(4432,189928,4);qd(4432,189947,5);Df(4424,189962,4,0);qd(4424,189973,0);qd(4424,189988,1);qd(4424,190008,2);qd(4424,190026,3);Df(4416,190041,4,1);qd(4416,190053,-1);qd(4416,190070,0);qd(4416,190087,1);qd(4416,190100,2);qd(4416,190116,4);qd(4416,190132,8);qd(4416,190149,16);qd(4416,190176,17);qd(4416,190199,32);qd(4416,190226,33);qd(4416,190249,64);qd(4416,190276,65);Df(4408,190299,4,0);qd(4408,190312,1);qd(4408,190333,2);qd(4408,190358,3);qd(4408,190380,4);qd(4408,190406,5);qd(4408,190432,6);qd(4408,190460,16);qd(4408,190484,17);qd(4408,190505,18);qd(4408,190525,32);qd(4408,190544,64);Df(4400,190565,4,0);qd(4400,190581,0);qd(4400,190610,1);qd(4400,190640,2);qd(4400,190674,3);qd(4400,190699,4);Df(4392,190726,4,0);qd(4392,190745,0);qd(4392,190759,1);qd(4392,190772,2);qd(4392,190784,3);qd(4392,190795,4);qd(4392,190810,7);qd(4392,190820,8);qd(4392,190839,16);Df(4384,190856,4,0);qd(4384,190875,5);qd(4384,190886,10);qd(4384,190898,32);qd(4384,190913,1024);Df(4376,190929,4,0);qd(4376,190941,0);qd(4376,190963,2);qd(4376,190981,1);Df(4368,191007,4,0);qd(4368,191032,0);qd(4368,191048,1);qd(4368,191063,2);Df(4360,191078,4,1);qd(4360,191088,-1);qd(4360,191095,4);qd(4360,191102,8);qd(4360,191109,16);Df(4352,191117,4,0);qd(4352,191129,0);qd(4352,191142,1);qd(4352,191162,2);qd(4352,191174,3);qd(4352,191189,4);qd(4352,191203,5);qd(4352,191222,6);Df(4344,191243,4,0);qd(4344,191255,0);qd(4344,191266,1);qd(4344,191278,2);Df(4336,191292,4,0);qd(4336,191303,0);qd(4336,191315,1);qd(4336,191328,2);qd(4336,191339,3);qd(4336,191351,4);qd(4336,191366,5);qd(4336,191379,6);qd(4336,191394,7);Df(4328,191408,4,0);qd(4328,191418,0);qd(4328,191430,1);qd(4328,191442,2);Df(4320,191450,4,0);qd(4320,191475,0);qd(4320,191490,1);qd(4320,191508,2);Df(4312,191523,4,0);qd(4312,191535,0);qd(4312,191546,1);qd(4312,191557,2);qd(4312,191568,3);Df(4304,191579,4,0);qd(4304,191594,0);qd(4304,191608,1);qd(4304,191618,2);qd(4304,191629,3);qd(4304,191639,4);Df(4296,191654,4,0);qd(4296,191664,1);qd(4296,191673,2);qd(4296,191679,4);Df(4288,191687,4,0);qd(4288,191697,0);qd(4288,191712,1);qd(4288,191730,0);qd(4288,191745,16);Df(4280,191761,4,0);qd(4280,191780,0);qd(4280,191790,1);qd(4280,191807,2);qd(4280,191816,3);qd(4280,191832,4);qd(4280,191842,5);Df(4272,191859,4,0);qd(4272,191877,1);qd(4272,191883,1);qd(4272,191892,2);Df(4264,191896,4,0);qd(4264,191911,0);qd(4264,191925,1);qd(4264,191943,2);qd(4264,191956,3);qd(4264,191970,4);qd(4264,191988,7);qd(4264,192e3,8);qd(4264,192012,16);Df(4256,192028,4,0);qd(4256,192043,0);qd(4256,192057,1);qd(4256,192084,2);qd(4256,192113,4);qd(4256,192142,2147483647);Df(4248,192167,4,0);qd(4248,192182,0);qd(4248,192203,1);Df(4240,192225,4,0);qd(4240,361441,0);qd(4240,361429,1);qd(4240,361450,2);Df(4232,192256,4,0);qd(4232,192278,1);qd(4232,192293,2);qd(4232,192308,4);Df(4224,192324,4,0);qd(4224,361550,0);qd(4224,361581,1);Df(4216,192351,4,0);qd(4216,192366,0);qd(4216,192375,1);qd(4216,192380,2);qd(4216,192386,3);Df(4208,192393,4,0);qd(4208,192409,0);qd(4208,192422,256);qd(4208,192434,512);qd(4208,192451,768);Df(4200,192464,4,0);qd(4200,192476,0);qd(4200,192494,1);qd(4200,192511,2);qd(4200,192527,1);Df(4192,192543,4,0);qd(4192,192557,0);qd(4192,192568,1);Df(4184,192580,4,0);qd(4184,192598,1);qd(4184,192610,2);Df(4176,192617,4,0);qd(4176,192647,0);qd(4176,192653,1);Df(4168,192664,4,1);qd(4168,192695,-1);qd(4168,192707,0);qd(4168,192714,1);Df(4160,192721,4,1);qd(4160,192740,-1);qd(4160,370509,0);qd(4160,370516,1);qd(4160,370521,2);qd(4160,370525,3);qd(4160,370533,4);qd(4160,370538,5);Df(4152,192747,4,0);qd(4152,424444,0);qd(4152,192765,1);qd(4152,192771,2);qd(4152,192773,3);qd(4152,192776,4);qd(4152,192781,5);Df(4144,192788,4,0);qd(4144,370396,100);qd(4144,370402,101);qd(4144,370409,102);qd(4144,370419,103);qd(4144,370427,104);Df(4136,192801,4,0);qd(4136,192816,0);qd(4136,192827,1);Df(4128,192838,4,0);qd(4128,192857,1);qd(4128,192870,1);qd(4128,192881,2);qd(4128,192898,4);Df(4120,192917,4,0);qd(4120,192934,0);qd(4120,192948,0);qd(4120,192960,1);Df(4112,192976,4,0);qd(4112,192998,0);qd(4112,193013,1);qd(4112,193028,0);return}}function Oi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0.0,j=0,l=0,m=0.0,n=0,q=0.0,s=0.0,t=0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,R=0,U=0,V=0.0;U=r;r=r+384|0;O=U+328|0;J=U+280|0;D=U;B=U+264|0;C=U+192|0;A=U+248|0;k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=16842752;k[A+4>>2]=b;y=k[d>>2]|0;z=k[d+4>>2]|0;g=+p[d+8>>3];k[O>>2]=1124007936;R=O+4|0;d=O+8|0;M=O+40|0;e=R;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[M>>2]=d;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;k[J>>2]=1124007936;H=J+4|0;G=J+32|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;k[H+16>>2]=0;k[H+20>>2]=0;k[H+24>>2]=0;k[G>>2]=J+8;K=J+40|0;I=J+36|0;k[I>>2]=K;k[J+44>>2]=0;k[K>>2]=0;k[D>>2]=k[b>>2];t=D+4|0;e=b+4|0;d=k[e>>2]|0;k[t>>2]=d;F=D+8|0;k[F>>2]=k[b+8>>2];k[D+12>>2]=k[b+12>>2];k[D+16>>2]=k[b+16>>2];k[D+20>>2]=k[b+20>>2];k[D+24>>2]=k[b+24>>2];k[D+28>>2]=k[b+28>>2];k[D+32>>2]=k[b+32>>2];f=k[b+36>>2]|0;k[D+36>>2]=f;j=D+40|0;k[j>>2]=F;F=D+48|0;n=D+44|0;k[n>>2]=F;k[D+52>>2]=0;k[F>>2]=0;if(f){d=f+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[e>>2]|0}if((d|0)>=3){k[t>>2]=0;x1(D,d,0,0,0);if((k[t>>2]|0)>0){l=k[b+40>>2]|0;j=k[j>>2]|0;f=k[b+44>>2]|0;e=k[n>>2]|0;d=0;do{k[j+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[t>>2]|0))}}else{E=k[b+44>>2]|0;F=k[n>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2]}KG(O,D)|0;F=k[M>>2]|0;E=k[F+4>>2]|0;F=k[F>>2]|0;f=D+36|0;d=k[f>>2]|0;if(d|0?(t=d+12|0,b=k[t>>2]|0,k[t>>2]=b+-1,(b|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[D+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;b=D+16|0;e=D+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[e>>2]|0)>0){f=k[D+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[D+44>>2]|0;if(!((d|0)==(D+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);x6a(A,c,y,z,g)|0;f=k[c>>2]|0;f=(f|0)<10?0:f+-10|0;k[c>>2]=f;n=c+4|0;d=k[n>>2]|0;d=(d|0)<10?0:d+-10|0;k[n>>2]=d;t=c+8|0;b=(k[t>>2]|0)+20|0;k[t>>2]=(f+b|0)>(E|0)?E-f|0:b;b=c+12|0;f=(k[b>>2]|0)+20|0;k[b>>2]=(d+f|0)>(F|0)?F-d|0:f;I1(C,O,c);k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=C;$oa(D,B,0);f=C+36|0;d=k[f>>2]|0;if(d|0?(A=d+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[C+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;B=C+16|0;e=C+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[e>>2]|0)>0){f=k[C+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[C+44>>2]|0;if(!((d|0)==(C+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);g=+p[D>>3];i=+p[D+88>>3];w=+p[D+80>>3];x=+p[D+96>>3];if(+P(+g)<2.220446049250313e-16){k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0}else{h=+p[D+16>>3];v=1.0/g;g=v*+p[D+8>>3]+ +(k[c>>2]|0);p[u>>3]=g;d=k[u+4>>2]|0;D=d&2146435072;if(!(D>>>0>1126170624|(D|0)==1126170624&0>0)){d=(d|0)<0;g=d?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=d?-0.0:0.0}j=~~g;g=v*h+ +(k[n>>2]|0);p[u>>3]=g;d=k[u+4>>2]|0;D=d&2146435072;if(!(D>>>0>1126170624|(D|0)==1126170624&0>0)){d=(d|0)<0;g=d?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=d?-0.0:0.0}f=~~g;q=i*v;m=v*w-v*x;m=+Y(+(q*2.0),+(m+ +Q(+(q*(q*4.0)+m*m))));q=+S(+m);s=+T(+m);V=q*q;g=i*(q*2.0*s);h=s*s;i=+Q(+(v*(x*h+(w*V+g))))*4.0;g=+Q(+(v*(x*V+(w*h-g))))*4.0;if(i<g){h=i;m=1.5707963267948966-m;i=g;v=q;q=s}else{h=g;v=s}g=+P(+(q*i));p[u>>3]=g;d=k[u+4>>2]|0;D=d&2146435072;if(!(D>>>0>1126170624|(D|0)==1126170624&0>0)){d=(d|0)<0;g=d?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=d?-0.0:0.0}e=~~g;g=+P(+(v*h));p[u>>3]=g;d=k[u+4>>2]|0;D=d&2146435072;if(!(D>>>0>1126170624|(D|0)==1126170624&0>0)){d=(d|0)<0;g=d?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=d?-0.0:0.0}l=~~g;l=((e|0)<(l|0)?l:e)+2|0;d=E-j<<1;l=(l|0)>(d|0)?d:l;g=+P(+(v*i));p[u>>3]=g;d=k[u+4>>2]|0;D=d&2146435072;if(!(D>>>0>1126170624|(D|0)==1126170624&0>0)){d=(d|0)<0;g=d?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=d?-0.0:0.0}e=~~g;g=+P(+(q*h));p[u>>3]=g;d=k[u+4>>2]|0;D=d&2146435072;if(!(D>>>0>1126170624|(D|0)==1126170624&0>0)){d=(d|0)<0;g=d?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=d?-0.0:0.0}D=~~g;D=((e|0)<(D|0)?D:e)+2|0;e=F-f<<1;D=(D|0)>(e|0)?e:D;j=j-((l|0)/2|0)|0;j=(j|0)>0?j:0;k[c>>2]=j;f=f-((D|0)/2|0)|0;f=(f|0)>0?f:0;k[n>>2]=f;e=E-j|0;e=(e|0)>(l|0)?l:e;k[t>>2]=e;d=F-f|0;d=(d|0)>(D|0)?D:d;k[b>>2]=d;g=(m+1.5707963267948966)*180.0/3.141592653589793;if(g<0.0)do g=g+360.0;while(g<0.0);if(g>=360.0)do g=g+-360.0;while(g>=360.0);o[a>>2]=+(j|0)+ +(e|0)*.5;o[a+4>>2]=+(f|0)+ +(d|0)*.5;o[a+8>>2]=h;o[a+12>>2]=i;o[a+16>>2]=!(g>=180.0)?g:g+-180.0}f=J+24|0;d=k[f>>2]|0;if(d|0?(a=d+8|0,J=k[a>>2]|0,k[a>>2]=J+-1,(J|0)==1):0){J=k[f>>2]|0;a=k[J+4>>2]|0;jh[k[(k[a>>2]|0)+16>>2]&1023](a,J);k[f>>2]=0}if((k[H>>2]|0)>0){e=k[G>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[H>>2]|0))}k[f>>2]=0;d=k[I>>2]|0;if(!((d|0)==(K|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=O+36|0;d=k[f>>2]|0;if(d|0?(J=d+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[O+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[R>>2]|0)>0){e=k[M>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[R>>2]|0))}d=k[L>>2]|0;if((d|0)==(N|0)|(d|0)==0){r=U;return}ggb(k[d+-4>>2]|0);r=U;return}function Pi(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;var g=0,h=0,i=0;g=r;r=r+32|0;i=g+16|0;h=g;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=a;a=h+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=b;uaa(i,h,c,d,e,f);r=g;return}function Qi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;var g=0,h=0,i=0,j=0;g=r;r=r+48|0;j=g+24|0;i=g+8|0;h=g;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;a=i+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=b;k[h>>2]=k[c>>2];k[h+4>>2]=k[c+4>>2];uua(j,i,h,d,e,f);r=g;return}function Ri(a,b,c,d,e,f,g,h,m){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;m=m|0;var n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0;Ua=r;r=r+432|0;Sa=Ua;Ha=Ua+368|0;Ia=Ua+352|0;Ja=Ua+336|0;Ma=Ua+320|0;Ka=Ua+288|0;F=Ua+224|0;L=Ua+168|0;M=Ua+144|0;Ta=Ua+88|0;G=Ua+56|0;s=Ua+272|0;Oa=Ua+256|0;k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;t=s+4|0;k[t>>2]=a;Na=Oa+4|0;N=Oa+4+4|0;k[N>>2]=0;k[N+4>>2]=0;k[Oa>>2]=33619968;k[Na>>2]=b;N=zY(4096)|0;if(N){while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1;k[a>>2]=63124;k[a+8>>2]=N;if((k[s>>2]&2031616|0)==65536){D=Ta;E=a;La=7}else{Q1(Ta,s,-1);b=Ta+16|0;y=Ta+8|0;Ra=Ta+4|0;s=Ta+12|0;t=Ta;Qa=b;C=Ta+44|0;D=Ta;E=a}}else{D=Ta;E=0;a=0;La=7}do if((La|0)==7){v=k[t>>2]|0;k[Ta>>2]=k[v>>2];z=Ta+4|0;b=v+4|0;k[z>>2]=k[b>>2];y=Ta+8|0;k[y>>2]=k[v+8>>2];A=Ta+12|0;k[A>>2]=k[v+12>>2];B=Ta+16|0;k[B>>2]=k[v+16>>2];k[Ta+20>>2]=k[v+20>>2];k[Ta+24>>2]=k[v+24>>2];k[Ta+28>>2]=k[v+28>>2];k[Ta+32>>2]=k[v+32>>2];s=k[v+36>>2]|0;k[Ta+36>>2]=s;t=Ta+40|0;k[t>>2]=y;Ra=Ta+48|0;C=Ta+44|0;k[C>>2]=Ra;k[Ta+52>>2]=0;k[Ra>>2]=0;if(s|0){Ra=s+12|0;k[Ra>>2]=(k[Ra>>2]|0)+1}if((k[b>>2]|0)<3){s=k[v+44>>2]|0;Ra=k[C>>2]|0;k[Ra>>2]=k[s>>2];k[Ra+4>>2]=k[s+4>>2];Ra=z;s=A;t=Ta;Qa=B;b=B;break}k[z>>2]=0;x1(Ta,k[b>>2]|0,0,0,0);if((k[z>>2]|0)>0){x=k[v+40>>2]|0;w=k[t>>2]|0;s=k[v+44>>2]|0;t=k[C>>2]|0;b=0;do{k[w+(b<<2)>>2]=k[x+(b<<2)>>2];k[t+(b<<2)>>2]=k[s+(b<<2)>>2];b=b+1|0}while((b|0)<(k[z>>2]|0));Ra=z;s=A;t=Ta;Qa=B;b=B}else{Ra=z;s=A;t=Ta;Qa=B;b=B}}while(0);Ea=k[y>>2]|0;Fa=(k[Ra>>2]|0)==1?1:k[s>>2]|0;Ga=k[t>>2]|0;ya=Ga&4095;Da=k[b>>2]|0;Ca=aa((Ga>>>3&511)+1<<(47696>>>(ya<<1&14)&3),Fa)|0;k[G>>2]=ya|1111638016;b=G+4|0;k[b>>2]=Ca;k[G+8>>2]=0;k[G+12>>2]=0;k[G+16>>2]=Da;k[G+20>>2]=Ea;k[G+24>>2]=Fa;k[b>>2]=k[k[C>>2]>>2];k[G>>2]=Ga&20479|1111621632;p[u>>3]=f;b=k[u+4>>2]|0;Ga=b&2146435072;if(!(Ga>>>0>1126170624|(Ga|0)==1126170624&0>0)){b=(b|0)<0;f=b?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=b?-0.0:0.0}v=~~f;p[u>>3]=g;b=k[u+4>>2]|0;Ga=b&2146435072;if(!(Ga>>>0>1126170624|(Ga|0)==1126170624&0>0)){b=(b|0)<0;f=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=b?-0.0:0.0}else f=g;Ga=~~f;y=G9(G,F,0,0)|0;if(k[y>>2]&4094|0){k[Sa>>2]=0;b=Sa+4|0;k[b>>2]=0;s=ZT(52)|0;k[s>>2]=1;w=s+4|0;k[Sa>>2]=w;k[b>>2]=46;i[s+50>>0]=0;A=335262;B=w+46|0;do{i[w>>0]=i[A>>0]|0;w=w+1|0;A=A+1|0}while((w|0)<(B|0));Y8(-5,Sa,335309,334918,1240);k[b>>2]=0;k[Sa>>2]=0;Fa=k[s>>2]|0;k[s>>2]=Fa+-1;if((Fa|0)==1)ggb(k[s+-4>>2]|0)}t=(N|0)!=0;if(!t){k[Sa>>2]=0;b=Sa+4|0;k[b>>2]=0;s=ZT(24)|0;k[s>>2]=1;w=s+4|0;k[Sa>>2]=w;k[b>>2]=16;i[s+20>>0]=0;A=335093;B=w+16|0;do{i[w>>0]=i[A>>0]|0;w=w+1|0;A=A+1|0}while((w|0)<(B|0));Y8(-27,Sa,335309,334918,1243);k[b>>2]=0;k[Sa>>2]=0;Fa=k[s>>2]|0;k[s>>2]=Fa+-1;if((Fa|0)==1)ggb(k[s+-4>>2]|0)}if(d<=0.0|e<=0.0|(v|0)<1|(Ga|0)<1){k[Sa>>2]=0;b=Sa+4|0;k[b>>2]=0;s=ZT(84)|0;k[s>>2]=1;w=s+4|0;k[Sa>>2]=w;k[b>>2]=76;i[s+80>>0]=0;A=335324;B=w+76|0;do{i[w>>0]=i[A>>0]|0;w=w+1|0;A=A+1|0}while((w|0)<(B|0));Y8(-211,Sa,335309,334918,1246);k[b>>2]=0;k[Sa>>2]=0;Fa=k[s>>2]|0;k[s>>2]=Fa+-1;if((Fa|0)==1)ggb(k[s+-4>>2]|0)}fa=(h|0)<0?0:h;if((m|0)<1){ea=k[y+20>>2]|0;Fa=k[y+24>>2]|0;ea=(ea|0)<(Fa|0)?Fa:ea}else ea=(fa|0)<(m|0)?m:fa+2|0;do if(t){b=k[N>>2]|0;s=b&-65536;if((s|0)==1116274688){Da=2147483647;z=HY(21,56,12,N)|0;N=0;break}if((((s|0)==1111621632?(J=N+24|0,H=k[J>>2]|0,(H|0)>0):0)?(I=N+20|0,q=k[I>>2]|0,(q|0)>0):0)?(K=N+16|0,n=k[K>>2]|0,(n|0)!=0):0){if((b&16384|0)!=0?(b&4095|0)==21&((H|0)==1|(q|0)==1):0)b=H;else{k[Sa>>2]=0;n=Sa+4|0;k[n>>2]=0;b=ZT(92)|0;k[b>>2]=1;w=b+4|0;k[Sa>>2]=w;k[n>>2]=84;i[b+88>>0]=0;A=335110;B=w+84|0;do{i[w>>0]=i[A>>0]|0;w=w+1|0;A=A+1|0}while((w|0)<(B|0));Y8(-5,Sa,335309,334918,1266);k[n>>2]=0;k[Sa>>2]=0;Fa=k[b>>2]|0;k[b>>2]=Fa+-1;if((Fa|0)==1)ggb(k[b+-4>>2]|0);q=k[I>>2]|0;b=k[J>>2]|0;n=k[K>>2]|0}z=MY(21,56,12,n,q+-1+b|0,L,M)|0;Da=k[z+24>>2]|0;VY(z)}else La=49}else La=49;while(0);if((La|0)==49){k[Sa>>2]=0;n=Sa+4|0;k[n>>2]=0;b=ZT(48)|0;k[b>>2]=1;w=b+4|0;k[Sa>>2]=w;k[n>>2]=43;i[b+47>>0]=0;A=335195;B=w+43|0;do{i[w>>0]=i[A>>0]|0;w=w+1|0;A=A+1|0}while((w|0)<(B|0));Y8(-5,Sa,335309,334918,1274);k[n>>2]=0;k[Sa>>2]=0;Fa=k[b>>2]|0;k[b>>2]=Fa+-1;if((Fa|0)==1)ggb(k[b+-4>>2]|0);Da=2147483647;z=0;N=0}do if((c|0)!=3){k[Sa>>2]=0;n=Sa+4|0;k[n>>2]=0;b=ZT(28)|0;k[b>>2]=1;w=b+4|0;k[Sa>>2]=w;k[n>>2]=22;i[b+26>>0]=0;A=335239;B=w+22|0;do{i[w>>0]=i[A>>0]|0;w=w+1|0;A=A+1|0}while((w|0)<(B|0));Y8(-5,Sa,335309,334918,1284);k[n>>2]=0;k[Sa>>2]=0;Ma=k[b>>2]|0;k[b>>2]=Ma+-1;if((Ma|0)==1)ggb(k[b+-4>>2]|0)}else{f=d;da=e;k[Ma>>2]=0;Ea=Ma+4|0;k[Ea>>2]=0;k[Ma+8>>2]=0;za=+(fa|0);za=za*za;Aa=+(ea|0);Ba=Aa*Aa;s=y+20|0;t=y+24|0;x=y9(k[s>>2]|0,k[t>>2]|0,0)|0;z9(x);if(!x)Fa=0;else{while(1){n=fgb(16)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}k[n+4>>2]=1;k[n>>2]=85876;k[n+8>>2]=x;Fa=n}waa(y,x,(v|0)<2?1.0:+((v|0)/2|0|0),+(v|0));w=y9(k[s>>2]|0,k[t>>2]|0,3)|0;z9(w);if(!w)Ca=0;else{while(1){n=fgb(16)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}k[n+4>>2]=1;k[n>>2]=85876;k[n+8>>2]=w;Ca=n}v=y9(k[s>>2]|0,k[t>>2]|0,3)|0;z9(v);if(!v)ya=0;else{while(1){n=fgb(16)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}k[n+4>>2]=1;k[n>>2]=85876;k[n+8>>2]=v;ya=n}wfa(y,w,1,0);wfa(y,v,0,1);wa=f<1.0?1.0:f;$=1.0/wa;O=$*+(k[s>>2]|0);xa=~~O;P=$*+(k[t>>2]|0);q=~~P;q=y9(xa+2+(+(xa|0)<O&1)|0,q+2+(+(q|0)<P&1)|0,4)|0;z9(q);if(!q)xa=0;else{while(1){n=fgb(16)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}k[n+4>>2]=1;k[n>>2]=85876;k[n+8>>2]=q;xa=n}yY(q);b=zY(0)|0;if(!b)va=0;else{while(1){n=fgb(16)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}k[n+4>>2]=1;k[n>>2]=63124;k[n+8>>2]=b;va=n}ua=HY(12,56,8,b)|0;ca=HY(4,56,4,b)|0;Z=k[s>>2]|0;W=k[t>>2]|0;_=k[q+20>>2]|0;X=_+-2|0;ta=k[q+24>>2]|0;Y=ta+-2|0;ba=k[q+16>>2]|0;U=(k[q+4>>2]|0)>>>2;if((Z|0)>0){V=x+16|0;S=x+4|0;T=w+16|0;c=w+4|0;R=v+16|0;m=v+4|0;H=(W|0)>0;I=Sa+4|0;J=(fa|0)>(ea|0);h=0;do{K=(k[V>>2]|0)+(aa(k[S>>2]|0,h)|0)|0;L=(k[T>>2]|0)+(aa(k[c>>2]|0,h)|0)|0;M=(k[R>>2]|0)+(aa(k[m>>2]|0,h)|0)|0;a:do if(H){O=$*+(h|0)*1024.0;if(J){n=0;while(1){k[Sa>>2]=0;k[I>>2]=0;if(!((i[K+n>>0]|0)==0?1:(j[M+(n<<1)>>1]|j[L+(n<<1)>>1])<<16>>16==0)){k[Sa>>2]=n;k[I>>2]=h;SY(ua,Sa)|0}n=n+1|0;if((n|0)>=(W|0))break a}}F=(o[u>>2]=O,k[u>>2]|0);G=(F&2130706432)>>>0>1249902592;F=(F|0)<0;e=F?O+-8388608.0+8388608.0:O+8388608.0+-8388608.0;P=F?-0.0:0.0;F=0;do{k[Sa>>2]=0;k[I>>2]=0;sa=j[L+(F<<1)>>1]|0;f=+(sa<<16>>16);ra=j[M+(F<<1)>>1]|0;g=+(ra<<16>>16);if(!((i[K+F>>0]|0)==0|(ra|sa)<<16>>16==0)){d=+Q(+(f*f+g*g));f=$*f*1024.0/d;n=(o[u>>2]=f,k[u>>2]|0);do if((n&2130706432)>>>0<=1249902592){n=(n|0)<0;f=n?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(!(f==0.0))break;f=n?-0.0:0.0}while(0);B=~~f;f=$*g*1024.0/d;n=(o[u>>2]=f,k[u>>2]|0);do if((n&2130706432)>>>0<=1249902592){n=(n|0)<0;f=n?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(!(f==0.0))break;f=n?-0.0:0.0}while(0);A=~~f;f=$*+(F|0)*1024.0;n=(o[u>>2]=f,k[u>>2]|0);do if((n&2130706432)>>>0<=1249902592){n=(n|0)<0;f=n?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(!(f==0.0))break;f=n?-0.0:0.0}while(0);s=~~f;x=~~(G|e!=0.0?(G?O:e):P);t=aa(B,fa)|0;y=aa(A,fa)|0;n=s+t|0;b=x+y|0;q=fa;while(1){v=n>>10;w=b>>10;if(!(v>>>0<Y>>>0&w>>>0<X>>>0))break;sa=ba+((aa(w,U)|0)+v<<2)|0;k[sa>>2]=(k[sa>>2]|0)+1;if((q|0)<(ea|0)){n=n+B|0;b=b+A|0;q=q+1|0}else break}t=s-t|0;n=x-y|0;b=fa;while(1){q=t>>10;s=n>>10;if(!(q>>>0<Y>>>0&s>>>0<X>>>0))break;sa=ba+((aa(s,U)|0)+q<<2)|0;k[sa>>2]=(k[sa>>2]|0)+1;if((b|0)<(ea|0)){t=t-B|0;n=n-A|0;b=b+1|0}else break}k[Sa>>2]=F;k[I>>2]=h;SY(ua,Sa)|0}F=F+1|0}while((F|0)<(W|0))}while(0);h=h+1|0}while((h|0)<(Z|0))}sa=k[ua+24>>2]|0;b:do if(sa){q=_+-3|0;do if((q|0)>1){s=ta+-3|0;if((s|0)>1)b=1;else break;do{t=aa(b,ta)|0;n=1;do{v=n+t|0;k[Sa>>2]=v;w=k[ba+(v<<2)>>2]|0;do if((w|0)>(Ga|0)){if((w|0)<=(k[ba+(v+-1<<2)>>2]|0))break;if((w|0)<=(k[ba+(v+1<<2)>>2]|0))break;if((w|0)<=(k[ba+(v-ta<<2)>>2]|0))break;if((w|0)<=(k[ba+(v+ta<<2)>>2]|0))break;SY(ca,Sa)|0}while(0);n=n+1|0}while((n|0)<(s|0));b=b+1|0}while((b|0)<(q|0))}while(0);ra=ca+24|0;v=k[ra>>2]|0;if(v){q=(v|0)<(sa|0)?sa:v;t=k[Ea>>2]|0;b=k[Ma>>2]|0;s=t-b>>2;n=b;do if(q>>>0>s>>>0){U1(Ma,q-s|0);n=k[Ma>>2]|0;b=n}else{if(q>>>0>=s>>>0)break;q=n+(q<<2)|0;if((t|0)==(q|0))break;k[Ea>>2]=t+(~((t+-4-q|0)>>>2)<<2)}while(0);JY(ca,b,0,1073741823);k[Sa>>2]=ba;Jla(n,n+(v<<2)|0,Sa);VY(ca);UY(ca,b,v);qa=y9(1,sa,5)|0;z9(qa);if(!qa)s=0;else{while(1){s=fgb(16)|0;if(s|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){s=0;break}Qh[n&7]()}k[s+4>>2]=1;k[s>>2]=85876;k[s+8>>2]=qa}pa=k[qa+16>>2]|0;$=wa>da?wa:da;$=$*$;n=k[ra>>2]|0;if((n|0)<=0)break;ha=z+24|0;ia=(sa|0)>0;ja=qa+24|0;ka=Sa+4|0;la=Sa+8|0;ma=Ka+12|0;na=Ka+20|0;oa=ca+52|0;G=ca+28|0;h=Ka+8|0;F=Ka+4|0;m=Ka+16|0;H=Sa+40|0;I=Ha+40|0;J=Ia+8|0;K=Ia+12|0;L=Ia+4|0;M=Ja+4|0;c=M+4|0;R=Ha+36|0;S=Ha+16|0;T=Ha+4|0;U=Ha+44|0;V=Ha+48|0;W=Sa+36|0;X=Sa+16|0;Y=Sa+4|0;Z=Sa+44|0;_=Sa+48|0;ba=Sa+32|0;ca=Ha+32|0;ea=Ia+4|0;fa=z+52|0;ga=z+28|0;y=0;q=n;do{if(q>>>0>y>>>0)n=y;else n=y-((y|0)>=(q|0)?q:0)|0;b=k[oa>>2]|0;do if((n<<1|0)>(q|0)){do{b=k[b>>2]|0;q=q-(k[b+12>>2]|0)|0}while((n|0)<(q|0));n=n-q|0}else{q=k[b+12>>2]|0;if((n|0)<(q|0))break;do{b=k[b+4>>2]|0;n=n-q|0;q=k[b+12>>2]|0}while((n|0)>=(q|0))}while(0);B=(k[b+16>>2]|0)+(aa(k[G>>2]|0,n)|0)|0;B=k[B>>2]|0;v=(B|0)/(ta|0)|0;O=wa*(+(B-(aa(v,ta)|0)|0)+.5);P=wa*(+(v|0)+.5);v=k[ha>>2]|0;c:do if((v|0)>0){n=0;do{b=k[fa>>2]|0;do if((n<<1|0)>(v|0)){q=v;do{b=k[b>>2]|0;q=q-(k[b+12>>2]|0)|0}while((n|0)<(q|0));q=n-q|0}else{t=k[b+12>>2]|0;if((n|0)<(t|0)){q=n;break}else q=n;do{b=k[b+4>>2]|0;q=q-t|0;t=k[b+12>>2]|0}while((q|0)>=(t|0))}while(0);B=(k[b+16>>2]|0)+(aa(k[ga>>2]|0,q)|0)|0;e=+o[B>>2]-O;da=+o[B+4>>2]-P;if(e*e+da*da<$)break c;n=n+1|0}while((n|0)<(v|0))}else n=0;while(0);do if((n|0)>=(v|0)){KY(ua,Ka);if(!ia)break;x=k[Ma>>2]|0;v=0;w=0;n=k[ma>>2]|0;b=k[na>>2]|0;do{t=n;q=t;q=l[q>>0]|l[q+1>>0]<<8|l[q+2>>0]<<16|l[q+3>>0]<<24;t=t+4|0;t=l[t>>0]|l[t+1>>0]<<8|l[t+2>>0]<<16|l[t+3>>0]<<24;n=n+8|0;k[ma>>2]=n;if(n>>>0>=b>>>0){b=k[(k[h>>2]|0)+4>>2]|0;k[h>>2]=b;n=k[b+16>>2]|0;k[ma>>2]=n;A=n;B=k[(k[F>>2]|0)+28>>2]|0;b=k[b+12>>2]|0;k[m>>2]=A;b=A+(aa(B,b)|0)|0;k[na>>2]=b}da=O-+(q|0);f=P-+(t|0);f=da*da+f*f;if(!(!(za<=f)|!(f<=Ba))){o[pa+(v<<2)>>2]=f;k[x+(v<<2)>>2]=v;v=v+1|0}w=w+1|0}while((w|0)!=(sa|0));x=v+-1|0;if(!v)break;k[ja>>2]=v;M1(Sa,qa,0,1,0,0);M1(Ha,qa,0,1,0,0);d:do if(!((k[Ha>>2]^k[Sa>>2])&4095)){b=k[H>>2]|0;q=k[b+-4>>2]|0;t=k[I>>2]|0;if((q|0)!=(k[t+-4>>2]|0)){La=160;break}if((q|0)==2){if((k[b>>2]|0)!=(k[t>>2]|0)){La=160;break}if((k[b+4>>2]|0)==(k[t+4>>2]|0))break;else{La=160;break}}if((q|0)>0)n=0;else break;do{if((k[b+(n<<2)>>2]|0)!=(k[t+(n<<2)>>2]|0)){La=160;break d}n=n+1|0}while((n|0)<(q|0))}else La=160;while(0);if((La|0)==160){La=0;k[Ia>>2]=0;k[ea>>2]=0;n=ZT(56)|0;k[n>>2]=1;w=n+4|0;k[Ia>>2]=w;k[ea>>2]=48;i[n+52>>0]=0;A=214971;B=w+48|0;do{i[w>>0]=i[A>>0]|0;w=w+1|0;A=A+1|0}while((w|0)<(B|0));Y8(-215,Ia,215026,214521,1881);k[ea>>2]=0;k[Ia>>2]=0;B=k[n>>2]|0;k[n>>2]=B+-1;if((B|0)==1)ggb(k[n+-4>>2]|0)}k[J>>2]=0;k[K>>2]=0;k[Ia>>2]=16842752;k[L>>2]=Sa;n=c;k[n>>2]=0;k[n+4>>2]=0;k[Ja>>2]=33619968;k[M>>2]=Ha;ZZ(Ia,.5,Ja);n=k[R>>2]|0;do if(n|0){A=n+12|0;B=k[A>>2]|0;k[A>>2]=B+-1;if((B|0)!=1)break;b=k[R>>2]|0;if(b|0){n=k[b+4>>2]|0;do if(!n){n=k[ca>>2]|0;if(n|0)break;n=B1()|0;b=k[R>>2]|0}while(0);jh[k[(k[n>>2]|0)+24>>2]&1023](n,b)}k[R>>2]=0}while(0);k[R>>2]=0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[T>>2]|0)>0){b=k[I>>2]|0;n=0;do{k[b+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(k[T>>2]|0))}n=k[U>>2]|0;if(!((n|0)==(V|0)|(n|0)==0))ggb(k[n+-4>>2]|0);n=k[W>>2]|0;do if(n|0){A=n+12|0;B=k[A>>2]|0;k[A>>2]=B+-1;if((B|0)!=1)break;b=k[W>>2]|0;if(b|0){n=k[b+4>>2]|0;do if(!n){n=k[ba>>2]|0;if(n|0)break;n=B1()|0;b=k[W>>2]|0}while(0);jh[k[(k[n>>2]|0)+24>>2]&1023](n,b)}k[W>>2]=0}while(0);k[W>>2]=0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[Y>>2]|0)>0){b=k[H>>2]|0;n=0;do{k[b+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(k[Y>>2]|0))}n=k[Z>>2]|0;if(!((n|0)==(_|0)|(n|0)==0))ggb(k[n+-4>>2]|0);w=k[Ma>>2]|0;k[Sa>>2]=pa;Jla(w,w+(v<<2)|0,Sa);b=v+-2|0;e:do if((b|0)>-1){t=x;n=0;f=0.0;g=+o[pa+(k[w+(x<<2)>>2]<<2)>>2];while(1){d=+o[pa+(k[w+(b<<2)>>2]<<2)>>2];if(d>Aa)break e;do if(d-g>wa){e=+o[pa+(k[w+(((b+t|0)/2|0)<<2)>>2]<<2)>>2];q=t-b|0;if(!(f*+(q|0)>=+(n|0)*e)?!(f<1.1920928955078125e-07)|(q|0)<(n|0):0){t=b;g=d;break}t=b;g=d;n=q;f=e}while(0);if((b|0)>0)b=b+-1|0;else break}}else{n=0;f=0.0}while(0);if((n|0)<=(Ga|0))break;o[Sa>>2]=O;o[ka>>2]=P;o[la>>2]=f;SY(z,Sa)|0;if((k[ha>>2]|0)>(Da|0))break b}while(0);y=y+1|0;q=k[ra>>2]|0}while((y|0)<(q|0))}else s=0}else s=0;while(0);n=va;if(va|0?(Ka=n+4|0,La=k[Ka>>2]|0,k[Ka>>2]=La+-1,(La|0)==1):0)Uh[k[(k[va>>2]|0)+8>>2]&2047](n);n=k[Ma>>2]|0;b=n;if(n|0){q=k[Ea>>2]|0;if((q|0)!=(n|0))k[Ea>>2]=q+(~((q+-4-b|0)>>>2)<<2);ggb(n)}n=s;do if(s|0){La=n+4|0;Ma=k[La>>2]|0;k[La>>2]=Ma+-1;if((Ma|0)!=1)break;Uh[k[(k[s>>2]|0)+8>>2]&2047](n)}while(0);n=xa;do if(xa|0){La=n+4|0;Ma=k[La>>2]|0;k[La>>2]=Ma+-1;if((Ma|0)!=1)break;Uh[k[(k[xa>>2]|0)+8>>2]&2047](n)}while(0);n=Fa;do if(Fa|0){La=n+4|0;Ma=k[La>>2]|0;k[La>>2]=Ma+-1;if((Ma|0)!=1)break;Uh[k[(k[Fa>>2]|0)+8>>2]&2047](n)}while(0);n=ya;do if(ya|0){La=n+4|0;Ma=k[La>>2]|0;k[La>>2]=Ma+-1;if((Ma|0)!=1)break;Uh[k[(k[ya>>2]|0)+8>>2]&2047](n)}while(0);n=Ca;if(!Ca)break;La=n+4|0;Ma=k[La>>2]|0;k[La>>2]=Ma+-1;if((Ma|0)!=1)break;Uh[k[(k[Ca>>2]|0)+8>>2]&2047](n)}while(0);do if(N){q=N+24|0;b=N+20|0;n=k[z+24>>2]|0;if((k[q>>2]|0)>(k[b>>2]|0)){k[q>>2]=n;z=0;break}else{k[b>>2]=n;z=0;break}}while(0);if((z|0)!=0?(Pa=k[z+24>>2]|0,(Pa|0)>0):0){Ma=k[z>>2]|0;k[Sa>>2]=1;k[Sa+4>>2]=Pa;P1(Oa,2,Sa,Ma,-1,1,0);do if((k[Oa>>2]&2031616|0)==65536){s=k[Na>>2]|0;k[Sa>>2]=k[s>>2];w=Sa+4|0;n=s+4|0;k[w>>2]=k[n>>2];Pa=Sa+8|0;k[Pa>>2]=k[s+8>>2];k[Sa+12>>2]=k[s+12>>2];x=Sa+16|0;k[x>>2]=k[s+16>>2];k[Sa+20>>2]=k[s+20>>2];k[Sa+24>>2]=k[s+24>>2];k[Sa+28>>2]=k[s+28>>2];k[Sa+32>>2]=k[s+32>>2];b=k[s+36>>2]|0;k[Sa+36>>2]=b;q=Sa+40|0;k[q>>2]=Pa;Pa=Sa+48|0;y=Sa+44|0;k[y>>2]=Pa;k[Sa+52>>2]=0;k[Pa>>2]=0;if(b|0){Pa=b+12|0;k[Pa>>2]=(k[Pa>>2]|0)+1}if((k[n>>2]|0)<3){t=k[s+44>>2]|0;s=k[y>>2]|0;k[s>>2]=k[t>>2];k[s+4>>2]=k[t+4>>2];s=x;t=y;break}k[w>>2]=0;x1(Sa,k[n>>2]|0,0,0,0);if((k[w>>2]|0)>0){v=k[s+40>>2]|0;t=k[q>>2]|0;b=k[s+44>>2]|0;q=k[y>>2]|0;n=0;do{k[t+(n<<2)>>2]=k[v+(n<<2)>>2];k[q+(n<<2)>>2]=k[b+(n<<2)>>2];n=n+1|0}while((n|0)<(k[w>>2]|0));s=x;t=y}else{s=x;t=y}}else{Q1(Sa,Oa,-1);s=Sa+16|0;t=Sa+44|0}while(0);JY(z,k[s>>2]|0,0,1073741823);q=Sa+36|0;n=k[q>>2]|0;if(n|0?(Oa=n+12|0,Pa=k[Oa>>2]|0,k[Oa>>2]=Pa+-1,(Pa|0)==1):0){b=k[q>>2]|0;if(b|0){n=k[b+4>>2]|0;do if(!n){n=k[Sa+32>>2]|0;if(n|0)break;n=B1()|0;b=k[q>>2]|0}while(0);jh[k[(k[n>>2]|0)+24>>2]&1023](n,b)}k[q>>2]=0}k[q>>2]=0;q=Sa+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[q>>2]|0)>0){b=k[Sa+40>>2]|0;n=0;do{k[b+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(k[q>>2]|0))}n=k[t>>2]|0;if(!((n|0)==(Sa+48|0)|(n|0)==0))ggb(k[n+-4>>2]|0)}else b2(Oa);s=Ta+36|0;n=k[s>>2]|0;if((n|0)!=0?(Pa=n+12|0,Sa=k[Pa>>2]|0,k[Pa>>2]=Sa+-1,(Sa|0)==1):0){b=k[s>>2]|0;if(!b)n=E;else{n=k[b+4>>2]|0;if(!n){n=k[Ta+32>>2]|0;if(!n){n=B1()|0;b=k[s>>2]|0}}jh[k[(k[n>>2]|0)+24>>2]&1023](n,b);n=E}k[s>>2]=0;q=a;b=n}else{q=a;b=E}k[s>>2]=0;k[Qa>>2]=0;k[Qa+4>>2]=0;k[Qa+8>>2]=0;k[Qa+12>>2]=0;if((k[Ra>>2]|0)>0){n=k[Ta+40>>2]|0;a=0;do{k[n+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Ra>>2]|0))}a=k[C>>2]|0;if(!((a|0)==(Ta+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);if(!q){r=Ua;return}Sa=q+4|0;Ta=k[Sa>>2]|0;k[Sa>>2]=Ta+-1;if((Ta|0)!=1){r=Ua;return}Uh[k[(k[q>>2]|0)+8>>2]&2047](b);r=Ua;return}function Si(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h=+h;j=+j;var m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,R=0,T=0,U=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;pa=r;r=r+192|0;ja=pa+168|0;ia=pa+156|0;ha=pa+144|0;oa=pa+72|0;na=pa+56|0;la=pa;ma=pa+128|0;v=ma+4+4|0;k[v>>2]=0;k[v+4>>2]=0;k[ma>>2]=33619968;k[ma+4>>2]=b;k[oa>>2]=k[a>>2];v=oa+4|0;m=a+4|0;b=k[m>>2]|0;k[v>>2]=b;ka=oa+8|0;k[ka>>2]=k[a+8>>2];k[oa+12>>2]=k[a+12>>2];k[oa+16>>2]=k[a+16>>2];k[oa+20>>2]=k[a+20>>2];k[oa+24>>2]=k[a+24>>2];k[oa+28>>2]=k[a+28>>2];k[oa+32>>2]=k[a+32>>2];n=k[a+36>>2]|0;k[oa+36>>2]=n;q=oa+40|0;k[q>>2]=ka;ka=oa+48|0;t=oa+44|0;k[t>>2]=ka;k[oa+52>>2]=0;k[ka>>2]=0;if(n){b=n+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[m>>2]|0}if((b|0)>=3){k[v>>2]=0;x1(oa,b,0,0,0);if((k[v>>2]|0)>0){s=k[a+40>>2]|0;q=k[q>>2]|0;n=k[a+44>>2]|0;m=k[t>>2]|0;b=0;do{k[q+(b<<2)>>2]=k[s+(b<<2)>>2];k[m+(b<<2)>>2]=k[n+(b<<2)>>2];b=b+1|0}while((b|0)<(k[v>>2]|0))}}else{fa=k[a+44>>2]|0;ka=k[t>>2]|0;k[ka>>2]=k[fa>>2];k[ka+4>>2]=k[fa+4>>2]}k[na>>2]=0;ka=na+4|0;k[ka>>2]=0;k[na+8>>2]=0;if(!(f==0.0&g==0.0)){p[u>>3]=f;b=k[u+4>>2]|0;fa=b&2146435072;if(!(fa>>>0>1126170624|(fa|0)==1126170624&0>0)){b=(b|0)<0;f=b?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=b?-0.0:0.0}a=~~f;p[u>>3]=g;b=k[u+4>>2]|0;fa=b&2146435072;if(!(fa>>>0>1126170624|(fa|0)==1126170624&0>0)){b=(b|0)<0;f=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=b?-0.0:0.0}else f=g;da=~~f;ea=aa(da,a)|0;k[ja>>2]=0;fa=ja+4|0;k[fa>>2]=0;k[ja+8>>2]=0;if(!(k[oa>>2]&4095)){ba=ja+8|0;b=0;m=0}else{k[ia>>2]=0;b=ia+4|0;k[b>>2]=0;m=ZT(28)|0;k[m>>2]=1;n=m+4|0;k[ia>>2]=n;k[b>>2]=21;i[m+25>>0]=0;q=334881;s=n+21|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(s|0));Y8(-215,ia,334903,334918,224);k[b>>2]=0;k[ia>>2]=0;ca=k[m>>2]|0;k[m>>2]=ca+-1;if((ca|0)==1)ggb(k[m+-4>>2]|0);m=ja+8|0;ba=m;b=k[fa>>2]|0;m=k[m>>2]|0}$=(e|0)>255?255:e;y=k[oa+16>>2]|0;z=k[oa+48>>2]|0;F=k[oa+12>>2]|0;G=k[oa+8>>2]|0;M=1.0/c;N=1.0/d;V=+(a|0);W=c/V;X=d/+(da|0);Y=1.0/W;O=1.0/X;E=+(F|0);L=+(G|0);L=M*+Q(+(E*E+L*L));Z=~~L;Z=Z-(+(Z|0)>L&1)|0;L=N;E=L*6.283185307179586;_=~~E;_=_-(+(_|0)>E&1)|0;k[ia>>2]=$;o[ia+4>>2]=-1.0;o[ia+8>>2]=0.0;if((b|0)==(m|0))Hla(ja,ia);else{k[b>>2]=k[ia>>2];k[b+4>>2]=k[ia+4>>2];k[b+8>>2]=k[ia+8>>2];k[fa>>2]=b+12}s=aa(da*5|0,_)|0;k[ia>>2]=0;if(s){if(s>>>0>1073741823)ad(426534,426557,304,426811);q=s<<2;n=(q|0)==0?1:q;while(1){m=fgb(n)|0;if(m|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){m=0;break}Qh[b&7]()}k[ia>>2]=m;zpb(m|0,0,q|0)|0;if((s|0)>0){b=0;do{E=+S(+(X*+(b|0)*.20000000298023224));o[m+(b<<2)>>2]=E;b=b+1|0}while((b|0)!=(s|0));U=m}else U=m}else U=0;x=aa(Z,_)|0;if(!x)ca=0;else{if((x|0)<0)ad(426534,426557,304,426811);while(1){b=fgb(x)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}m=x;n=b;while(1){i[n>>0]=0;m=m+-1|0;if(!m){ca=b;break}else n=n+1|0}}a=(G|0)>0;w=(F|0)>0;if(a&w){m=0;b=0;do{q=aa(m,z)|0;n=0;do{b=((i[y+(n+q)>>0]|0)!=0&1)+b|0;n=n+1|0}while((n|0)!=(F|0));m=m+1|0}while((m|0)!=(G|0));s=b;n=(s|0)==0;if(!n){if(s>>>0>1073741823)ad(426534,426557,304,426811);q=s<<2;m=(q|0)==0?1:q;while(1){b=fgb(m)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}zpb(b|0,0,q|0)|0;if(n){R=s;T=0}else{if(s>>>0>1073741823)ad(426534,426557,304,426811);q=s<<2;n=(q|0)==0?1:q;while(1){m=fgb(n)|0;if(m|0)break;m=k[207666]|0;k[207666]=m+0;if(!m){m=0;break}Qh[m&7]()}zpb(m|0,0,q|0)|0;R=s;T=m}}else{R=s;T=0;b=0}}else{R=0;T=0;b=0}if(a){m=0;e=0;do{if(w){t=aa(e,z)|0;D=+(e|0)+.5;E=D;E=E*E;v=D<0.0;a=0;do{do if(i[y+(a+t)>>0]|0){k[b+(m<<2)>>2]=a;k[T+(m<<2)>>2]=e;m=m+1|0;A=+(a|0)+.5;f=+P(+A);g=+P(+D);if(!(f>=g)){C=f/(g+2.220446049250313e-16);f=C*C;f=90.0-C*(f*(f*(8.914000511169434-f*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{C=g/(f+2.220446049250313e-16);f=C*C;f=C*(f*(f*(8.914000511169434-f*2.539724588394165)+-18.66744613647461)+57.283626556396484)}f=A<0.0?180.0-f:f;f=+P(+((v?360.0-f:f)*.01745329238474369));B=A;B=+Q(+(E+B*B));A=M*B;C=L*(f+1.5707963267948966);s=~~C;s=ca+(s-(+(s|0)>C&1))|0;i[s>>0]=(i[s>>0]|0)+1<<24>>24;B=c/B;B=B<d?B:d;C=N*B;g=3.141592653589793/B;s=~~g;s=s-(+(s|0)>g&1)|0;if((s|0)<=1)break;f=N*(f+B);g=-1.5707963705062866;n=-1;q=1;while(1){g=B+g;K=~~f;J=n;n=(aa(~~(A*+S(+g)),_)|0)+(K-(+(K|0)>f&1))|0;K=ca+n|0;i[K>>0]=((n|0)!=(J|0)&1)+(l[K>>0]|0);q=q+1|0;if((q|0)==(s|0))break;else f=C+f}}while(0);a=a+1|0}while((a|0)!=(F|0))}e=e+1|0}while((e|0)!=(G|0))}a=(Z|0)>0;J=(_|0)>0;if(a&J){n=0;m=0;do{s=aa(n,_)|0;q=0;do{m=((l[ca+(q+s)>>0]|0)>($|0)&1)+m|0;q=q+1|0}while((q|0)!=(_|0));n=n+1|0}while((n|0)!=(Z|0))}else m=0;if((m*100|0)<=(x|0)){n=ea+2|0;if(!n)K=0;else{if((ea|0)<-2)ad(426534,426557,304,426811);while(1){m=fgb(n)|0;if(m|0)break;m=k[207666]|0;k[207666]=m+0;if(!m){m=0;break}Qh[m&7]()}q=m;while(1){i[q>>0]=0;n=n+-1|0;if(!n){K=m;break}else q=q+1|0}}I=K+1|0;if(a){H=(R|0)>0;C=O;x=(da|0)>0;y=(ea|0)>0;z=ha+4|0;F=ha+8|0;e=0;while(1){if(J){G=aa(e,_)|0;E=+(e|0);D=V*E;E=E*c;w=0;do{do if((l[ca+(w+G)>>0]|0)>($|0)){zpb(I|0,0,ea|0)|0;do if(H){s=aa(w,da)|0;if(x)q=0;else break;do{B=+(k[T+(q<<2)>>2]|0)+.5;A=+(k[b+(q<<2)>>2]|0)+.5;f=+P(+A);g=+P(+B);if(!(f>=g)){j=f/(g+2.220446049250313e-16);f=j*j;f=90.0-j*(f*(f*(8.914000511169434-f*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{j=g/(f+2.220446049250313e-16);f=j*j;f=j*(f*(f*(8.914000511169434-f*2.539724588394165)+-18.66744613647461)+57.283626556396484)}j=A<0.0?180.0-f:f;f=A;h=B;f=Y*+Q(+(h*h+f*f));j=C*(+P(+((B<0.0?360.0-j:j)*.01745329238474369))+1.5707963267948966);m=~~j;m=(s-m+(+(m|0)>j&1)|0)*5|0;n=0;while(1){j=f*+o[U+(((m|0)>-1?m:0-m|0)<<2)>>2]-D;v=~~j;v=(aa(v-(+(v|0)>j&1)|0,da)|0)+n|0;v=v>>31&~v^v;v=I+(((v|0)>=(ea|0)?v^ea:0)^v)|0;i[v>>0]=(i[v>>0]|0)+1<<24>>24;n=n+1|0;if((n|0)==(da|0))break;else m=m+5|0}q=q+1|0}while((q|0)!=(R|0))}while(0);if(!y)break;f=+(w|0)*d;q=k[fa>>2]|0;a=k[ja>>2]|0;v=0;s=a;t=q;while(1){s=t-s|0;m=((s|0)/12|0)+-1|0;if((s|0)>=12){n=i[I+v>>0]|0;if((k[a+(m*12|0)>>2]|0)<(n&255|0))ga=107;else{n=a;m=t}}else{n=i[I+v>>0]|0;ga=107}if((ga|0)==107){ga=0;k[ha>>2]=n&255;o[z>>2]=E+W*+((v|0)/(da|0)|0|0);o[F>>2]=f+X*+((v|0)%(da|0)|0|0)+-1.5707963705062866;if((q|0)==(k[ba>>2]|0))Hla(ja,ha);else{k[q>>2]=k[ha>>2];k[q+4>>2]=k[ha+4>>2];k[q+8>>2]=k[ha+8>>2];k[fa>>2]=(k[fa>>2]|0)+12}a=k[ja>>2]|0;a:do if((s|0)>0){q=k[ha>>2]|0;while(1){n=a+(m*12|0)|0;if((k[n>>2]|0)>(q|0))break a;t=a+((m+1|0)*12|0)|0;k[t>>2]=k[n>>2];k[t+4>>2]=k[n+4>>2];k[t+8>>2]=k[n+8>>2];n=m+-1|0;if((m|0)>0)m=n;else{m=n;break}}}while(0);m=a+((m+1|0)*12|0)|0;k[m>>2]=k[ha>>2];k[m+4>>2]=k[ha+4>>2];k[m+8>>2]=k[ha+8>>2];m=k[fa>>2]|0;n=a;q=m}v=v+1|0;if((v|0)>=(ea|0))break;else{s=n;t=m;a=n}}}while(0);w=w+1|0}while((w|0)<(_|0))}e=e+1|0;if((e|0)>=(Z|0)){e=fa;w=ja;break}}}else{e=fa;w=ja}n=k[e>>2]|0;m=k[w>>2]|0;if((n|0)!=(m|0)){t=ha+4|0;v=na+8|0;a=0;do{q=m;f=+o[q+(a*12|0)+4>>2];if(!(f<0.0)){q=k[q+(a*12|0)+8>>2]|0;o[ha>>2]=f;k[t>>2]=q;s=k[ka>>2]|0;if((s|0)==(k[v>>2]|0)){Ila(na,ha);n=k[e>>2]|0;m=k[w>>2]|0}else{o[s>>2]=f;k[s+4>>2]=q;k[ka>>2]=s+8}}a=a+1|0}while(a>>>0<((n-m|0)/12|0)>>>0)}if(K)ggb(K)}else Gla(oa,c,d,$,na,h,j);if(T|0)ggb(T);if(b|0)ggb(b);if(ca|0)ggb(ca);b=k[ia>>2]|0;if(b|0)ggb(b);b=k[ja>>2]|0;m=b;if(b|0){n=k[fa>>2]|0;if((n|0)!=(b|0))k[fa>>2]=n+(~(((n+-12-m|0)>>>0)/12|0)*12|0);ggb(b)}}else Gla(oa,c,d,e,na,h,j);k[la>>2]=1124024333;x=la+4|0;k[x>>2]=2;z=la+8|0;ja=k[ka>>2]|0;b=k[na>>2]|0;m=ja-b|0;k[z>>2]=m>>3;k[la+12>>2]=1;v=la+16|0;k[v>>2]=0;n=la+20|0;k[n>>2]=0;q=la+24|0;k[q>>2]=0;t=la+32|0;k[t>>2]=0;e=la+36|0;k[e>>2]=0;w=la+40|0;k[w>>2]=z;z=la+48|0;y=la+44|0;k[y>>2]=z;s=la+52|0;k[s>>2]=0;k[z>>2]=0;a=b;if((a|0)!=(ja|0)){k[s>>2]=8;k[z>>2]=8;k[v>>2]=a;k[n>>2]=a;ja=b+m|0;k[q>>2]=ja;k[la+28>>2]=ja}mY(la,ma);b=k[e>>2]|0;if(b|0?(la=b+12|0,ma=k[la>>2]|0,k[la>>2]=ma+-1,(ma|0)==1):0){m=k[e>>2]|0;if(m|0){b=k[m+4>>2]|0;if(!b){b=k[t>>2]|0;if(!b){b=B1()|0;m=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,m)}k[e>>2]=0}k[e>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[x>>2]|0)>0){m=k[w>>2]|0;b=0;do{k[m+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[x>>2]|0))}b=k[y>>2]|0;if(!((b|0)==(z|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[na>>2]|0;m=b;if(b|0){n=k[ka>>2]|0;if((n|0)!=(b|0))k[ka>>2]=n+(~((n+-8-m|0)>>>3)<<3);ggb(b)}n=oa+36|0;b=k[n>>2]|0;if(b|0?(ma=b+12|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){m=k[n>>2]|0;if(m|0){b=k[m+4>>2]|0;if(!b){b=k[oa+32>>2]|0;if(!b){b=B1()|0;m=k[n>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,m)}k[n>>2]=0}k[n>>2]=0;na=oa+16|0;m=oa+4|0;k[na>>2]=0;k[na+4>>2]=0;k[na+8>>2]=0;k[na+12>>2]=0;if((k[m>>2]|0)>0){n=k[oa+40>>2]|0;b=0;do{k[n+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[oa+44>>2]|0;if((b|0)==(oa+48|0)|(b|0)==0){r=pa;return}ggb(k[b+-4>>2]|0);r=pa;return}function Ti(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;var h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0;Ca=r;r=r+544|0;v=Ca+520|0;w=Ca+512|0;wa=Ca+456|0;s=Ca;va=Ca+400|0;ta=Ca+384|0;ua=Ca+368|0;Ba=Ca+296|0;Aa=Ca+280|0;ya=Ca+224|0;za=Ca+352|0;q=za+4+4|0;k[q>>2]=0;k[q+4>>2]=0;k[za>>2]=33619968;k[za+4>>2]=b;k[Ba>>2]=k[a>>2];q=Ba+4|0;h=a+4|0;b=k[h>>2]|0;k[q>>2]=b;xa=Ba+8|0;k[xa>>2]=k[a+8>>2];k[Ba+12>>2]=k[a+12>>2];k[Ba+16>>2]=k[a+16>>2];k[Ba+20>>2]=k[a+20>>2];k[Ba+24>>2]=k[a+24>>2];k[Ba+28>>2]=k[a+28>>2];k[Ba+32>>2]=k[a+32>>2];j=k[a+36>>2]|0;k[Ba+36>>2]=j;l=Ba+40|0;k[l>>2]=xa;xa=Ba+48|0;n=Ba+44|0;k[n>>2]=xa;k[Ba+52>>2]=0;k[xa>>2]=0;if(j){b=j+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[h>>2]|0}if((b|0)>=3){k[q>>2]=0;x1(Ba,b,0,0,0);if((k[q>>2]|0)>0){m=k[a+40>>2]|0;l=k[l>>2]|0;j=k[a+44>>2]|0;h=k[n>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[m+(b<<2)>>2];k[h+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else{sa=k[a+44>>2]|0;xa=k[n>>2]|0;k[xa>>2]=k[sa>>2];k[xa+4>>2]=k[sa+4>>2]}k[Aa>>2]=0;xa=Aa+4|0;k[xa>>2]=0;k[Aa+8>>2]=0;p[u>>3]=f;b=k[u+4>>2]|0;sa=b&2146435072;if(!(sa>>>0>1126170624|(sa|0)==1126170624&0>0)){b=(b|0)<0;f=b?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=b?-0.0:0.0}sa=~~f;p[u>>3]=g;b=k[u+4>>2]|0;ra=b&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){b=(b|0)<0;f=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=b?-0.0:0.0}else f=g;ra=~~f;k[w>>2]=0;t=w+4|0;k[t>>2]=0;g=1.0/c;if(k[Ba>>2]&4095|0){k[v>>2]=0;b=v+4|0;k[b>>2]=0;h=ZT(28)|0;k[h>>2]=1;l=h+4|0;k[v>>2]=l;k[b>>2]=23;i[h+27>>0]=0;j=335045;m=l+23|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(m|0));Y8(-215,v,335069,334918,424);k[b>>2]=0;k[v>>2]=0;qa=k[h>>2]|0;k[h>>2]=qa+-1;if((qa|0)==1)ggb(k[h+-4>>2]|0)}la=k[Ba+12>>2]|0;ma=k[Ba+8>>2]|0;f=3.141592653589793/d;p[u>>3]=f;b=k[u+4>>2]|0;qa=b&2146435072;if(!(qa>>>0>1126170624|(qa|0)==1126170624&0>0)){b=(b|0)<0;f=b?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=b?-0.0:0.0}ka=~~f;f=+(ma+la<<1|1|0)/c;b=(o[u>>2]=f,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;f=b?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=b?-0.0:0.0}ga=~~f;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=1124007936;b=s+16|0;h=s+48|0;l=s+12|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[h>>2]=b;b=s+56|0;k[s+52>>2]=b;k[s+60>>2]=0;k[b>>2]=0;k[s+64>>2]=1124007936;b=s+72|0;h=s+104|0;l=s+68|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[h>>2]=b;b=s+112|0;k[s+108>>2]=b;k[s+116>>2]=0;k[b>>2]=0;k[s+120>>2]=1124007936;b=s+128|0;h=s+160|0;l=s+124|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[h>>2]=b;l=s+168|0;k[s+164>>2]=l;m=l+56|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[v>>2]=ga;k[v+4>>2]=ka;j1(s,48,v,4);k[wa>>2]=1124007936;pa=wa+4|0;b=wa+8|0;na=wa+40|0;l=pa;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[na>>2]=b;qa=wa+48|0;oa=wa+44|0;k[oa>>2]=qa;k[wa+52>>2]=0;k[qa>>2]=0;ja=k[s>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,s,wa,-1);XN(s);k[va>>2]=1124007936;ja=va+4|0;b=va+8|0;ha=va+40|0;l=ja;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[ha>>2]=b;ia=va+48|0;fa=va+44|0;k[fa>>2]=ia;k[va+52>>2]=0;k[ia>>2]=0;k[v>>2]=ma;k[v+4>>2]=la;G1(va,2,v,0);if(ka){if(ka<<1>>>0>1073741823)ad(426534,426557,304,426811);j=ka<<3;h=(j|0)==0?1:j;while(1){b=fgb(h)|0;if(b|0){h=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){h=0;break}Qh[b&7]()}zpb(h|0,0,j|0)|0;if((ka|0)>0){f=g;b=0;do{g=d*+(b|0);c=f*+S(+g);ea=b<<1;o[h+(ea<<2)>>2]=c;g=f*+T(+g);o[h+((ea|1)<<2)>>2]=g;b=b+1|0}while((b|0)!=(ka|0));ca=1}else ca=0}else{h=0;ca=0}ea=va+16|0;ba=k[ea>>2]|0;k[v>>2]=0;da=v+4|0;k[da>>2]=0;k[v+8>>2]=0;k[t>>2]=0;do if((ma|0)>0){n=Ba+16|0;q=Ba+44|0;s=v+8|0;if((la|0)>0){b=0;j=ba}else{k[w>>2]=0;k[t>>2]=ma;_=0;b=0;j=0;$=0;break}while(1){a=(k[n>>2]|0)+(aa(k[k[q>>2]>>2]|0,b)|0)|0;l=j+(aa(k[k[fa>>2]>>2]|0,b)|0)|0;k[w>>2]=0;m=0;do{j=l+m|0;do if(i[a+m>>0]|0){i[j>>0]=1;j=k[da>>2]|0;if((j|0)==(k[s>>2]|0)){Efa(v,w);break}else{k[j>>2]=m;k[j+4>>2]=b;k[da>>2]=j+8;break}}else i[j>>0]=0;while(0);m=m+1|0;k[w>>2]=m}while((m|0)<(la|0));b=b+1|0;k[t>>2]=b;if((b|0)>=(ma|0))break;j=k[ea>>2]|0}$=k[da>>2]|0;b=k[v>>2]|0;_=b;j=$}else{_=0;b=0;j=0;$=0}while(0);b=j-b|0;if((b|0)>0){M=e+-1|0;O=wa+16|0;Q=(ga+-1|0)/2|0;R=ta+8|0;U=ta+12|0;V=ta+4|0;W=ua+4|0;X=ua+8|0;Y=ua+12|0;Z=Aa+8|0;L=ca^1;H=b>>3;J=-1;K=-1;do{G=Epb(J|0,0,-130063606,0)|0;J=kpb(G|0,N|0,K|0,0)|0;K=N;G=(J>>>0)%(H>>>0)|0;F=_+(G<<3)|0;q=k[F>>2]|0;G=_+(G<<3)+4|0;n=k[G>>2]|0;k[ta>>2]=0;k[ta+4>>2]=0;k[ta+8>>2]=0;k[ta+12>>2]=0;b=k[O>>2]|0;I=H;H=H+-1|0;k[F>>2]=k[_+(H<<3)>>2];k[G>>2]=k[_+(H<<3)+4>>2];G=ba+((aa(n,la)|0)+q)|0;if(!((i[G>>0]|0)==0|L)){c=+(q|0);d=+(n|0);l=M;m=0;a=0;while(1){j=m<<1;f=c*+o[h+(j<<2)>>2]+d*+o[h+((j|1)<<2)>>2];j=(o[u>>2]=f,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;f=j?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=j?-0.0:0.0}E=b+(~~f+Q<<2)|0;F=k[E>>2]|0;G=F+1|0;k[E>>2]=G;F=(l|0)>(F|0);a=F?a:m;l=F?l:G;m=m+1|0;if((m|0)==(ka|0))break;else b=b+(ga<<2)|0}if((l|0)>=(e|0)){G=a<<1;f=+o[h+((G|1)<<2)>>2];c=+o[h+(G<<2)>>2];d=+P(+-f);g=+P(+c);if(d>g){l=f<-0.0?1:-1;f=c*65536.0/d;b=(o[u>>2]=f,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;f=b?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=b?-0.0:0.0}G=0;j=~~f;F=l;E=n<<16|32768;B=q}else{j=c>0.0?1:-1;f=f*-65536.0/g;b=(o[u>>2]=f,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;f=b?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=b?-0.0:0.0}G=1;F=~~f;E=n;B=q<<16|32768}C=0-F|0;D=0-j|0;m=E>>16;l=B>>16;a:do if(((G?l:B)|0)>=0){b:do if(G){a=l;n=E;q=B;b=0;while(1){if(!((n|0)<(ma|0)&((a|0)<(la|0)&(n|0)>-1)))break b;A=ba+(aa(n,la)|0)+a|0;if(!(i[A>>0]|0))if((b|0)<(ra|0))b=b+1|0;else break b;else{k[V>>2]=n;k[ta>>2]=a;b=0}q=q+F|0;a=q>>16;if((a|0)<0)break;else n=n+j|0}}else{n=B;q=m;a=E;b=0;while(1){if(!((q|0)<(ma|0)&((n|0)<(la|0)&(q|0)>-1)))break b;A=ba+(aa(q,la)|0)+n|0;if(!(i[A>>0]|0))if((b|0)<(ra|0))b=b+1|0;else break b;else{k[V>>2]=q;k[ta>>2]=n;b=0}n=n+F|0;a=a+j|0;if((n|0)<0)break;else q=a>>16}}while(0);if(G){m=E;a=B;b=0;while(1){if(!((m|0)<(ma|0)&((l|0)<(la|0)&(m|0)>-1)))break a;A=ba+(aa(m,la)|0)+l|0;if(!(i[A>>0]|0))if((b|0)<(ra|0))b=b+1|0;else break a;else{k[U>>2]=m;k[R>>2]=l;b=0}a=a-F|0;l=a>>16;if((l|0)<0)break;else m=m-j|0}}else{a=B;l=E;b=0;while(1){if(!((m|0)<(ma|0)&((a|0)<(la|0)&(m|0)>-1)))break a;A=ba+(aa(m,la)|0)+a|0;if(!(i[A>>0]|0))if((b|0)<(ra|0))b=b+1|0;else break a;else{k[U>>2]=m;k[R>>2]=a;b=0}a=a-F|0;l=l-j|0;if((a|0)<0)break;else m=l>>16}}}while(0);A=(k[R>>2]|0)-(k[ta>>2]|0)|0;if((((A|0)>-1?A:0-A|0)|0)<(sa|0)){z=(k[U>>2]|0)-(k[V>>2]|0)|0;z=(((z|0)>-1?z:0-z|0)|0)>=(sa|0)}else z=1;A=z&ca;y=0;do{w=(y|0)==1;x=w?C:F;w=w?D:j;v=ta+(y<<3)|0;t=ta+(y<<3)+4|0;c:do if(G){m=E;a=B;while(1){q=a>>16;s=ba+(aa(m,la)|0)+q|0;if(i[s>>0]|0){if(A){c=+(q|0);d=+(m|0);l=0;n=k[O>>2]|0;while(1){b=l<<1;f=c*+o[h+(b<<2)>>2]+d*+o[h+((b|1)<<2)>>2];b=(o[u>>2]=f,k[u>>2]|0);do if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;f=b?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(!(f==0.0))break;f=b?-0.0:0.0}while(0);b=n+(~~f+Q<<2)|0;k[b>>2]=(k[b>>2]|0)+-1;l=l+1|0;if((l|0)==(ka|0))break;else n=n+(ga<<2)|0}}i[s>>0]=0}if((m|0)==(k[t>>2]|0)?(q|0)==(k[v>>2]|0):0)break c;m=m+w|0;a=a+x|0}}else{if(z){m=E;a=B}else{q=k[t>>2]|0;m=k[v>>2]|0;b=E;l=B;while(1){a=b>>16;n=ba+(aa(a,la)|0)+l|0;if(i[n>>0]|0)i[n>>0]=0;if((a|0)==(q|0)&(l|0)==(m|0))break c;b=b+w|0;l=l+x|0}}while(1){q=m>>16;s=ba+(aa(q,la)|0)+a|0;if(i[s>>0]|0){if(ca){c=+(a|0);d=+(q|0);l=0;n=k[O>>2]|0;while(1){b=l<<1;f=c*+o[h+(b<<2)>>2]+d*+o[h+((b|1)<<2)>>2];b=(o[u>>2]=f,k[u>>2]|0);do if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;f=b?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(!(f==0.0))break;f=b?-0.0:0.0}while(0);b=n+(~~f+Q<<2)|0;k[b>>2]=(k[b>>2]|0)+-1;l=l+1|0;if((l|0)==(ka|0))break;else n=n+(ga<<2)|0}}i[s>>0]=0}if((q|0)==(k[t>>2]|0)?(a|0)==(k[v>>2]|0):0)break c;m=m+w|0;a=a+x|0}}while(0);y=y+1|0}while((y|0)!=2);if(z){b=k[ta>>2]|0;j=k[V>>2]|0;l=k[R>>2]|0;m=k[U>>2]|0;k[ua>>2]=b;k[W>>2]=j;k[X>>2]=l;k[Y>>2]=m;a=k[xa>>2]|0;if((a|0)==(k[Z>>2]|0))Vea(Aa,ua);else{k[a>>2]=b;k[a+4>>2]=j;k[a+8>>2]=l;k[a+12>>2]=m;k[xa>>2]=a+16}}}}}while((I|0)>1)}b=_;if(_|0){if(($|0)!=(_|0))k[da>>2]=$+(~(($+-8-b|0)>>>3)<<3);ggb(_)}if(h|0)ggb(h);j=va+36|0;b=k[j>>2]|0;if(b|0?(ua=b+12|0,e=k[ua>>2]|0,k[ua>>2]=e+-1,(e|0)==1):0){h=k[j>>2]|0;if(h|0){b=k[h+4>>2]|0;if(!b){b=k[va+32>>2]|0;if(!b){b=B1()|0;h=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[j>>2]=0}k[j>>2]=0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[ja>>2]|0)>0){h=k[ha>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ja>>2]|0))}b=k[fa>>2]|0;if(!((b|0)==(ia|0)|(b|0)==0))ggb(k[b+-4>>2]|0);j=wa+36|0;b=k[j>>2]|0;if(b|0?(e=b+12|0,va=k[e>>2]|0,k[e>>2]=va+-1,(va|0)==1):0){h=k[j>>2]|0;if(h|0){b=k[h+4>>2]|0;do if(!b){b=k[wa+32>>2]|0;if(b|0)break;b=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[j>>2]=0}k[j>>2]=0;wa=wa+16|0;k[wa>>2]=0;k[wa+4>>2]=0;k[wa+8>>2]=0;k[wa+12>>2]=0;if((k[pa>>2]|0)>0){h=k[na>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[pa>>2]|0))}b=k[oa>>2]|0;if(!((b|0)==(qa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[ya>>2]=1124024348;v=ya+4|0;k[v>>2]=2;x=ya+8|0;wa=k[xa>>2]|0;b=k[Aa>>2]|0;h=wa-b|0;k[x>>2]=h>>4;k[ya+12>>2]=1;q=ya+16|0;k[q>>2]=0;j=ya+20|0;k[j>>2]=0;l=ya+24|0;k[l>>2]=0;n=ya+32|0;k[n>>2]=0;s=ya+36|0;k[s>>2]=0;t=ya+40|0;k[t>>2]=x;x=ya+48|0;w=ya+44|0;k[w>>2]=x;m=ya+52|0;k[m>>2]=0;k[x>>2]=0;a=b;if((a|0)!=(wa|0)){k[m>>2]=16;k[x>>2]=16;k[q>>2]=a;k[j>>2]=a;wa=b+h|0;k[l>>2]=wa;k[ya+28>>2]=wa}mY(ya,za);b=k[s>>2]|0;do if(b|0){ya=b+12|0;za=k[ya>>2]|0;k[ya>>2]=za+-1;if((za|0)!=1)break;h=k[s>>2]|0;if(h|0){b=k[h+4>>2]|0;do if(!b){b=k[n>>2]|0;if(b|0)break;b=B1()|0;h=k[s>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[s>>2]=0}while(0);k[s>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[v>>2]|0)>0){h=k[t>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[v>>2]|0))}b=k[w>>2]|0;if(!((b|0)==(x|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Aa>>2]|0;h=b;if(b|0){j=k[xa>>2]|0;if((j|0)!=(b|0))k[xa>>2]=j+(~((j+-16-h|0)>>>4)<<4);ggb(b)}j=Ba+36|0;b=k[j>>2]|0;do if(b|0){za=b+12|0;Aa=k[za>>2]|0;k[za>>2]=Aa+-1;if((Aa|0)!=1)break;h=k[j>>2]|0;if(h|0){b=k[h+4>>2]|0;do if(!b){b=k[Ba+32>>2]|0;if(b|0)break;b=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[j>>2]=0}while(0);k[j>>2]=0;Aa=Ba+16|0;h=Ba+4|0;k[Aa>>2]=0;k[Aa+4>>2]=0;k[Aa+8>>2]=0;k[Aa+12>>2]=0;if((k[h>>2]|0)>0){j=k[Ba+40>>2]|0;b=0;do{k[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[h>>2]|0))}b=k[Ba+44>>2]|0;if((b|0)==(Ba+48|0)|(b|0)==0){r=Ca;return}ggb(k[b+-4>>2]|0);r=Ca;return}function Ui(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0.0,q=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;n=r;r=r+80|0;m=n+24|0;l=n+16|0;c=n;d=c+4|0;j=c+4+4|0;k[j>>2]=0;k[j+4>>2]=0;k[c>>2]=33619968;k[d>>2]=b;c2(c,7,1,6,-1,0,0);do if((k[c>>2]&2031616|0)==65536){e=k[d>>2]|0;k[m>>2]=k[e>>2];j=m+4|0;b=e+4|0;k[j>>2]=k[b>>2];h=m+8|0;k[h>>2]=k[e+8>>2];k[m+12>>2]=k[e+12>>2];k[m+16>>2]=k[e+16>>2];k[m+20>>2]=k[e+20>>2];k[m+24>>2]=k[e+24>>2];k[m+28>>2]=k[e+28>>2];k[m+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[m+36>>2]=c;d=m+40|0;k[d>>2]=h;h=m+48|0;g=m+44|0;k[g>>2]=h;k[m+52>>2]=0;k[h>>2]=0;if(c|0){h=c+12|0;k[h>>2]=(k[h>>2]|0)+1}if((k[b>>2]|0)<3){j=k[e+44>>2]|0;b=k[g>>2]|0;k[b>>2]=k[j>>2];k[b+4>>2]=k[j+4>>2];b=m;break}k[j>>2]=0;x1(m,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0));b=m}else b=m}else{Q1(m,c,-1);b=m}while(0);if(!(k[b>>2]&16384)){k[l>>2]=0;b=l+4|0;k[b>>2]=0;c=ZT(24)|0;k[c>>2]=1;d=c+4|0;k[l>>2]=d;k[b>>2]=17;i[c+21>>0]=0;e=341343;f=d+17|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,l,341361,341222,761);k[b>>2]=0;k[l>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)==1)ggb(k[c+-4>>2]|0)}e=m+16|0;d=k[e>>2]|0;f=m+44|0;h=a+160|0;j=a+176|0;t=+p[h>>3]+ +p[j>>3];l=a+168|0;b=a+184|0;s=+p[l>>3]+ +p[b>>3];o=t*t;q=s*s;g=a+144|0;v=+p[g>>3]*4.0;x=+p[a+136>>3];w=+p[a+152>>3];u=x-w;p[d>>3]=x+w;p[d+8>>3]=u*u+v*+p[g>>3];p[d+24>>3]=o+q;p[d+40>>3]=s*(t*v)+(o-q)*u;t=t*(o-q*3.0);q=s*(o*3.0-q);o=+p[h>>3]-+p[j>>3]*3.0;s=+p[l>>3]*3.0-+p[b>>3];p[d+16>>3]=o*o+s*s;p[d+32>>3]=t*o+q*s;p[d+48>>3]=t*s-q*o;d=m+36|0;b=k[d>>2]|0;if(b|0?(l=b+12|0,a=k[l>>2]|0,k[l>>2]=a+-1,(a|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[m+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=m+4|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){c=k[m+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[f>>2]|0;if((b|0)==(m+48|0)|(b|0)==0){r=n;return}ggb(k[b+-4>>2]|0);r=n;return}function Vi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=r;r=r+48|0;g=d+32|0;f=d+16|0;e=d;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;b=e+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=c;OX(g,f,e);r=d;return}function Wi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;var h=0,i=0,j=0;h=r;r=r+32|0;j=h+16|0;i=h;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;a=i+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=b;vfa(j,i,c,d,e,f,g);r=h;return}function Xi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0,j=0.0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+1312|0;A=B+1248|0;z=B+1192|0;y=B+1136|0;x=B;t=B+1128|0;n=B+1112|0;s=B+1096|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;m=n+4|0;k[m>>2]=b;k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;q=s+4|0;k[q>>2]=c;k[A>>2]=k[a>>2];l=A+4|0;c=a+4|0;b=k[c>>2]|0;k[l>>2]=b;w=A+8|0;k[w>>2]=k[a+8>>2];k[A+12>>2]=k[a+12>>2];k[A+16>>2]=k[a+16>>2];k[A+20>>2]=k[a+20>>2];k[A+24>>2]=k[a+24>>2];k[A+28>>2]=k[a+28>>2];k[A+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[A+36>>2]=d;f=A+40|0;k[f>>2]=w;w=A+48|0;h=A+44|0;k[h>>2]=w;k[A+52>>2]=0;k[w>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[l>>2]=0;x1(A,b,0,0,0);if((k[l>>2]|0)>0){g=k[a+40>>2]|0;f=k[f>>2]|0;d=k[a+44>>2]|0;c=k[h>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[g+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{v=k[a+44>>2]|0;w=k[h>>2]|0;k[w>>2]=k[v>>2];k[w+4>>2]=k[v+4>>2]}do if((k[n>>2]&2031616|0)==65536){g=k[m>>2]|0;k[z>>2]=k[g>>2];l=z+4|0;c=g+4|0;k[l>>2]=k[c>>2];w=z+8|0;k[w>>2]=k[g+8>>2];k[z+12>>2]=k[g+12>>2];k[z+16>>2]=k[g+16>>2];k[z+20>>2]=k[g+20>>2];k[z+24>>2]=k[g+24>>2];k[z+28>>2]=k[g+28>>2];k[z+32>>2]=k[g+32>>2];b=k[g+36>>2]|0;k[z+36>>2]=b;d=z+40|0;k[d>>2]=w;w=z+48|0;h=z+44|0;k[h>>2]=w;k[z+52>>2]=0;k[w>>2]=0;if(b|0){w=b+12|0;k[w>>2]=(k[w>>2]|0)+1}if((k[c>>2]|0)<3){v=k[g+44>>2]|0;w=k[h>>2]|0;k[w>>2]=k[v>>2];k[w+4>>2]=k[v+4>>2];break}k[l>>2]=0;x1(z,k[c>>2]|0,0,0,0);if((k[l>>2]|0)>0){a=k[g+40>>2]|0;f=k[d>>2]|0;d=k[g+44>>2]|0;c=k[h>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(z,n,-1);while(0);do if((k[s>>2]&2031616|0)==65536){f=k[q>>2]|0;k[y>>2]=k[f>>2];l=y+4|0;b=f+4|0;k[l>>2]=k[b>>2];w=y+8|0;k[w>>2]=k[f+8>>2];k[y+12>>2]=k[f+12>>2];k[y+16>>2]=k[f+16>>2];k[y+20>>2]=k[f+20>>2];k[y+24>>2]=k[f+24>>2];k[y+28>>2]=k[f+28>>2];k[y+32>>2]=k[f+32>>2];c=k[f+36>>2]|0;k[y+36>>2]=c;d=y+40|0;k[d>>2]=w;w=y+48|0;h=y+44|0;k[h>>2]=w;k[y+52>>2]=0;k[w>>2]=0;if(c|0){w=c+12|0;k[w>>2]=(k[w>>2]|0)+1}if((k[b>>2]|0)<3){v=k[f+44>>2]|0;w=k[h>>2]|0;k[w>>2]=k[v>>2];k[w+4>>2]=k[v+4>>2];break}k[l>>2]=0;x1(y,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){a=k[f+40>>2]|0;g=k[d>>2]|0;d=k[f+44>>2]|0;c=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(y,s,-1);while(0);l=k[A>>2]|0;d=l&4095;w=A+40|0;a=k[w>>2]|0;h=k[a+4>>2]|0;a=k[a>>2]|0;s=aa(aa(a,h)|0,(l>>>3&511)+1|0)|0;u=x+8|0;k[x>>2]=u;v=x+4|0;k[v>>2]=136;if(s>>>0>136){c=s>>>0>536870911?-1:s<<3;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[x>>2]=b}k[v>>2]=s;if(((((d|0)==(k[z>>2]&4095|0)?(d|0)==(k[y>>2]&4095|0):0)?(q=k[z+40>>2]|0,(a|0)==(k[q>>2]|0)?(h|0)==(k[q+4>>2]|0):0):0)?(s|0)==(k[y+8>>2]|0):0)?(s|0)==(k[y+12>>2]|0):0)c=l;else{k[t>>2]=0;b=t+4|0;k[b>>2]=0;c=ZT(112)|0;k[c>>2]=1;d=c+4|0;k[t>>2]=d;k[b>>2]=105;i[c+109>>0]=0;f=216219;g=d+105|0;do{i[d>>0]=i[f>>0]|0;d=d+1|0;f=f+1|0}while((d|0)<(g|0));Y8(-215,t,216325,215417,2497);k[b>>2]=0;k[t>>2]=0;q=k[c>>2]|0;k[c>>2]=q+-1;if((q|0)==1)ggb(k[c+-4>>2]|0);c=k[A>>2]|0}b=aa((c>>>3&511)+1|0,h)|0;if(!(c&16384)){n=b;f=a}else{f=(k[z>>2]&16384|0)!=0;n=aa(f?a:1,b)|0;f=f?1:a}a:do switch(l&7){case 5:{l=(k[A+48>>2]|0)>>>2;m=(k[z+48>>2]|0)>>>2;d=k[y+16>>2]|0;q=(k[y+48>>2]|0)>>>2;b=k[x>>2]|0;if((f|0)!=0&(n|0)>0){g=b;h=k[z+16>>2]|0;a=k[A+16>>2]|0;while(1){c=0;do{p[g+(c<<3)>>3]=+o[a+(c<<2)>>2]-+o[h+(c<<2)>>2];c=c+1|0}while((c|0)!=(n|0));f=f+-1|0;if(!f)break;else{g=g+(n<<3)|0;h=h+(m<<2)|0;a=a+(l<<2)|0}}}if((s|0)>0){g=s+-4|0;if((s|0)<4){e=0.0;f=0;while(1){j=0.0;c=0;do{j=j+ +p[b+(c<<3)>>3]*+o[d+(c<<2)>>2];c=c+1|0}while((c|0)!=(s|0));e=e+j*+p[b+(f<<3)>>3];f=f+1|0;if((f|0)==(s|0))break a;else d=d+(q<<2)|0}}h=s&-4;a=(h|0)<(s|0);e=0.0;f=0;while(1){j=0.0;c=0;do{m=c|1;n=c|2;t=c|3;j=j+(+p[b+(c<<3)>>3]*+o[d+(c<<2)>>2]+ +p[b+(m<<3)>>3]*+o[d+(m<<2)>>2]+ +p[b+(n<<3)>>3]*+o[d+(n<<2)>>2]+ +p[b+(t<<3)>>3]*+o[d+(t<<2)>>2]);c=c+4|0}while((c|0)<=(g|0));if(a){c=h;do{j=j+ +p[b+(c<<3)>>3]*+o[d+(c<<2)>>2];c=c+1|0}while((c|0)!=(s|0))}e=e+j*+p[b+(f<<3)>>3];f=f+1|0;if((f|0)==(s|0))break;else d=d+(q<<2)|0}}else e=0.0;break}case 6:{l=(k[A+48>>2]|0)>>>3;m=(k[z+48>>2]|0)>>>3;d=k[y+16>>2]|0;q=(k[y+48>>2]|0)>>>3;b=k[x>>2]|0;if((f|0)!=0&(n|0)>0){g=b;h=k[z+16>>2]|0;a=k[A+16>>2]|0;while(1){c=0;do{p[g+(c<<3)>>3]=+p[a+(c<<3)>>3]-+p[h+(c<<3)>>3];c=c+1|0}while((c|0)!=(n|0));f=f+-1|0;if(!f)break;else{g=g+(n<<3)|0;h=h+(m<<3)|0;a=a+(l<<3)|0}}}if((s|0)>0){g=s+-4|0;if((s|0)<4){e=0.0;f=0;while(1){j=0.0;c=0;do{j=j+ +p[b+(c<<3)>>3]*+p[d+(c<<3)>>3];c=c+1|0}while((c|0)!=(s|0));e=e+j*+p[b+(f<<3)>>3];f=f+1|0;if((f|0)==(s|0))break a;else d=d+(q<<3)|0}}h=s&-4;a=(h|0)<(s|0);e=0.0;f=0;while(1){j=0.0;c=0;do{m=c|1;n=c|2;t=c|3;j=j+(+p[b+(c<<3)>>3]*+p[d+(c<<3)>>3]+ +p[b+(m<<3)>>3]*+p[d+(m<<3)>>3]+ +p[b+(n<<3)>>3]*+p[d+(n<<3)>>3]+ +p[b+(t<<3)>>3]*+p[d+(t<<3)>>3]);c=c+4|0}while((c|0)<=(g|0));if(a){c=h;do{j=j+ +p[b+(c<<3)>>3]*+p[d+(c<<3)>>3];c=c+1|0}while((c|0)!=(s|0))}e=e+j*+p[b+(f<<3)>>3];f=f+1|0;if((f|0)==(s|0))break;else d=d+(q<<3)|0}}else e=0.0;break}default:{k[t>>2]=0;s=t+4|0;k[s>>2]=0;b=ZT(8)|0;k[b>>2]=1;q=b+4|0;k[t>>2]=q;k[s>>2]=0;i[q>>0]=0;Y8(-210,t,216325,215417,2569);k[s>>2]=0;k[t>>2]=0;t=k[b>>2]|0;k[b>>2]=t+-1;if((t|0)==1)ggb(k[b+-4>>2]|0);e=0.0;b=k[x>>2]|0}}while(0);e=+Q(+e);if((b|0)!=(u|0)){if(b|0)ggb(b);k[x>>2]=u;k[v>>2]=136}d=y+36|0;b=k[d>>2]|0;if(b|0?(v=b+12|0,x=k[v>>2]|0,k[v>>2]=x+-1,(x|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[y+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;x=y+16|0;c=y+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[c>>2]|0)>0){d=k[y+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[y+44>>2]|0;if(!((b|0)==(y+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=z+36|0;b=k[d>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[z+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;y=z+16|0;c=z+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[z+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[z+44>>2]|0;if(!((b|0)==(z+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=A+36|0;b=k[d>>2]|0;if(b|0?(y=b+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[A+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;z=A+16|0;d=A+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[d>>2]|0)>0){c=k[w>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[A+44>>2]|0;if((b|0)==(A+48|0)|(b|0)==0){r=B;return +e}ggb(k[b+-4>>2]|0);r=B;return +e}function Yi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=r;r=r+480|0;F=G+416|0;D=G+360|0;C=G+304|0;z=G+248|0;A=G+216|0;B=G+184|0;E=G;m=G+232|0;l=G+200|0;y=G+168|0;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;n=m+4|0;k[n>>2]=a;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;j=l+4|0;k[j>>2]=c;q=y+4+4|0;k[q>>2]=0;k[q+4>>2]=0;k[y>>2]=33619968;k[y+4>>2]=d;k[E>>2]=1124007936;q=E+4|0;u=E+8|0;t=E+40|0;d=q;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[t>>2]=u;a=E+48|0;k[E+44>>2]=a;k[E+52>>2]=0;k[a>>2]=0;k[E+56>>2]=1124007936;a=E+64|0;c=E+96|0;d=E+60|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=a;o=E+104|0;k[E+100>>2]=o;k[E+108>>2]=0;k[o>>2]=0;k[E+112>>2]=1124007936;o=E+116|0;x=E+120|0;p=E+152|0;d=o;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[p>>2]=x;h=E+160|0;k[E+156>>2]=h;k[E+164>>2]=0;k[h>>2]=0;k[F>>2]=k[b>>2];h=F+4|0;c=b+4|0;a=k[c>>2]|0;k[h>>2]=a;s=F+8|0;k[s>>2]=k[b+8>>2];k[F+12>>2]=k[b+12>>2];k[F+16>>2]=k[b+16>>2];k[F+20>>2]=k[b+20>>2];k[F+24>>2]=k[b+24>>2];k[F+28>>2]=k[b+28>>2];k[F+32>>2]=k[b+32>>2];d=k[b+36>>2]|0;k[F+36>>2]=d;e=F+40|0;k[e>>2]=s;s=F+48|0;g=F+44|0;k[g>>2]=s;k[F+52>>2]=0;k[s>>2]=0;if(d){a=d+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[c>>2]|0}if((a|0)>=3){k[h>>2]=0;x1(F,a,0,0,0);if((k[h>>2]|0)>0){f=k[b+40>>2]|0;e=k[e>>2]|0;d=k[b+44>>2]|0;c=k[g>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[f+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else{b=k[b+44>>2]|0;s=k[g>>2]|0;k[s>>2]=k[b>>2];k[s+4>>2]=k[b+4>>2]}s=E+112|0;KG(s,F)|0;d=F+36|0;a=k[d>>2]|0;if(a|0?(h=a+12|0,b=k[h>>2]|0,k[h>>2]=b+-1,(b|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[F+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;b=F+16|0;c=F+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[c>>2]|0)>0){d=k[F+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[F+44>>2]|0;if(!((a|0)==(F+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);do if((k[l>>2]&2031616|0)==65536){e=k[j>>2]|0;k[F>>2]=k[e>>2];b=F+4|0;a=e+4|0;k[b>>2]=k[a>>2];l=F+8|0;k[l>>2]=k[e+8>>2];k[F+12>>2]=k[e+12>>2];k[F+16>>2]=k[e+16>>2];k[F+20>>2]=k[e+20>>2];k[F+24>>2]=k[e+24>>2];k[F+28>>2]=k[e+28>>2];k[F+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[F+36>>2]=c;d=F+40|0;k[d>>2]=l;l=F+48|0;g=F+44|0;k[g>>2]=l;k[F+52>>2]=0;k[l>>2]=0;if(c|0){l=c+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[a>>2]|0)<3){j=k[e+44>>2]|0;l=k[g>>2]|0;k[l>>2]=k[j>>2];k[l+4>>2]=k[j+4>>2];break}k[b>>2]=0;x1(F,k[a>>2]|0,0,0,0);if((k[b>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[b>>2]|0))}}else Q1(F,l,-1);while(0);KG(E,F)|0;d=F+36|0;a=k[d>>2]|0;if(a|0?(j=a+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[F+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;l=F+16|0;c=F+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[c>>2]|0)>0){d=k[F+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[F+44>>2]|0;if(!((a|0)==(F+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);do if((k[m>>2]&2031616|0)==65536){e=k[n>>2]|0;k[F>>2]=k[e>>2];b=F+4|0;a=e+4|0;k[b>>2]=k[a>>2];n=F+8|0;k[n>>2]=k[e+8>>2];k[F+12>>2]=k[e+12>>2];k[F+16>>2]=k[e+16>>2];k[F+20>>2]=k[e+20>>2];k[F+24>>2]=k[e+24>>2];k[F+28>>2]=k[e+28>>2];k[F+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[F+36>>2]=c;d=F+40|0;k[d>>2]=n;n=F+48|0;g=F+44|0;k[g>>2]=n;k[F+52>>2]=0;k[n>>2]=0;if(c|0){n=c+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[a>>2]|0)<3){m=k[e+44>>2]|0;n=k[g>>2]|0;k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];break}k[b>>2]=0;x1(F,k[a>>2]|0,0,0,0);if((k[b>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[b>>2]|0))}}else Q1(F,m,-1);while(0);do if(k[E+128>>2]|0){e=k[o>>2]|0;if((e|0)<3)a=aa(k[E+124>>2]|0,k[x>>2]|0)|0;else{d=k[p>>2]|0;c=0;a=1;do{a=aa(k[d+(c<<2)>>2]|0,a)|0;c=c+1|0}while((c|0)!=(e|0))}if((a|0)!=0?(k[E+16>>2]|0)!=0:0){e=k[q>>2]|0;if((e|0)<3)a=aa(k[E+12>>2]|0,k[u>>2]|0)|0;else{d=k[t>>2]|0;c=0;a=1;do{a=aa(k[d+(c<<2)>>2]|0,a)|0;c=c+1|0}while((c|0)!=(e|0))}if(a){if((k[x>>2]|0)==1?(k[u>>2]|0)==(k[F+12>>2]|0):0)break;if(!((k[E+124>>2]|0)==1?(k[u>>2]|0)==(k[F+8>>2]|0):0))w=68}else w=68}else w=68}else w=68;while(0);if((w|0)==68?(k[D>>2]=0,w=D+4|0,k[w>>2]=0,v=ZT(156)|0,k[v>>2]=1,u=v+4|0,k[D>>2]=u,k[w>>2]=148,i[v+152>>0]=0,upb(u|0,221648,148)|0,Y8(-215,D,221797,221375,327),k[w>>2]=0,k[D>>2]=0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0)ggb(k[v+-4>>2]|0);k[D>>2]=1124007936;l=D+4|0;a=D+8|0;b=D+40|0;d=l;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[b>>2]=a;m=D+48|0;j=D+44|0;k[j>>2]=m;k[D+52>>2]=0;k[m>>2]=0;k[C>>2]=1124007936;h=C+4|0;a=C+8|0;f=C+40|0;d=h;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[f>>2]=a;g=C+48|0;e=C+44|0;k[e>>2]=g;k[C+52>>2]=0;k[g>>2]=0;w=z+4|0;v=w+4|0;k[v>>2]=0;k[v+4>>2]=0;k[z>>2]=33619968;k[w>>2]=D;SW(F,z,k[s>>2]&4095,1.0,0.0);if((k[x>>2]|0)==1){tY(z,s,k[F+8>>2]|0,1);KG(C,z)|0;d=z+36|0;a=k[d>>2]|0;if(a|0?(w=a+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;do if(!a){a=k[z+32>>2]|0;if(a|0)break;a=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;x=z+16|0;c=z+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[c>>2]|0)>0){d=k[z+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[z+44>>2]|0;if(!((a|0)==(z+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[z+8>>2]=0;k[z+12>>2]=0;k[z>>2]=16842752;k[z+4>>2]=D;k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=16842752;k[A+4>>2]=E;k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=C;s_(z,A,1.0,B,1.0,y,0)}else{tY(z,s,1,k[F+12>>2]|0);KG(C,z)|0;d=z+36|0;a=k[d>>2]|0;if(a|0?(w=a+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;do if(!a){a=k[z+32>>2]|0;if(a|0)break;a=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;x=z+16|0;c=z+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[c>>2]|0)>0){d=k[z+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[z+44>>2]|0;if(!((a|0)==(z+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[z+8>>2]=0;k[z+12>>2]=0;k[z>>2]=16842752;k[z+4>>2]=E;k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=16842752;k[A+4>>2]=D;k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=C;s_(z,A,1.0,B,1.0,y,1)}d=C+36|0;a=k[d>>2]|0;if(a|0?(A=a+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[C+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;C=C+16|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[h>>2]|0)>0){c=k[f>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[e>>2]|0;if(!((a|0)==(g|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=D+36|0;a=k[d>>2]|0;if(a|0?(B=a+12|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;do if(!a){a=k[D+32>>2]|0;if(a|0)break;a=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[l>>2]|0)>0){c=k[b>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[j>>2]|0;if(!((a|0)==(m|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=F+36|0;a=k[d>>2]|0;do if(a|0){C=a+12|0;D=k[C>>2]|0;k[C>>2]=D+-1;if((D|0)!=1)break;c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;do if(!a){a=k[F+32>>2]|0;if(a|0)break;a=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}while(0);k[d>>2]=0;D=F+16|0;c=F+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[c>>2]|0)>0){d=k[F+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[F+44>>2]|0;if((a|0)==(F+48|0)|(a|0)==0){z$(E);r=G;return}ggb(k[a+-4>>2]|0);z$(E);r=G;return}function Zi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;Z=r;r=r+816|0;P=Z+792|0;N=Z+776|0;Y=Z+720|0;U=Z+664|0;T=Z+608|0;Q=Z+520|0;H=Z+464|0;F=Z+408|0;E=Z+352|0;s=Z+296|0;q=Z+280|0;M=Z+224|0;S=Z+168|0;V=Z;W=Z+592|0;X=Z+576|0;l=W+4|0;f=W+4+4|0;k[f>>2]=0;k[f+4>>2]=0;k[W>>2]=50397184;k[l>>2]=b;b=X+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[X>>2]=33619968;k[X+4>>2]=c;k[V>>2]=1124007936;b=V+8|0;c=V+40|0;f=V+4|0;o=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(o|0));k[c>>2]=b;b=V+48|0;k[V+44>>2]=b;k[V+52>>2]=0;k[b>>2]=0;k[V+56>>2]=1124007936;b=V+64|0;c=V+96|0;f=V+60|0;o=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(o|0));k[c>>2]=b;n=V+104|0;k[V+100>>2]=n;k[V+108>>2]=0;k[n>>2]=0;k[V+112>>2]=1124007936;n=V+116|0;p=V+120|0;b=V+152|0;f=n;o=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(o|0));k[b>>2]=p;j=V+160|0;k[V+156>>2]=j;k[V+164>>2]=0;k[j>>2]=0;k[Y>>2]=k[a>>2];j=Y+4|0;c=a+4|0;b=k[c>>2]|0;k[j>>2]=b;R=Y+8|0;k[R>>2]=k[a+8>>2];k[Y+12>>2]=k[a+12>>2];k[Y+16>>2]=k[a+16>>2];k[Y+20>>2]=k[a+20>>2];k[Y+24>>2]=k[a+24>>2];k[Y+28>>2]=k[a+28>>2];k[Y+32>>2]=k[a+32>>2];e=k[a+36>>2]|0;k[Y+36>>2]=e;f=Y+40|0;k[f>>2]=R;R=Y+48|0;h=Y+44|0;k[h>>2]=R;k[Y+52>>2]=0;k[R>>2]=0;if(e){b=e+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[j>>2]=0;x1(Y,b,0,0,0);if((k[j>>2]|0)>0){g=k[a+40>>2]|0;f=k[f>>2]|0;e=k[a+44>>2]|0;c=k[h>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[g+(b<<2)>>2];k[c+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else{O=k[a+44>>2]|0;R=k[h>>2]|0;k[R>>2]=k[O>>2];k[R+4>>2]=k[O+4>>2]}do if((k[W>>2]&2031616|0)==65536){f=k[l>>2]|0;k[U>>2]=k[f>>2];a=U+4|0;b=f+4|0;k[a>>2]=k[b>>2];R=U+8|0;k[R>>2]=k[f+8>>2];k[U+12>>2]=k[f+12>>2];k[U+16>>2]=k[f+16>>2];k[U+20>>2]=k[f+20>>2];k[U+24>>2]=k[f+24>>2];k[U+28>>2]=k[f+28>>2];k[U+32>>2]=k[f+32>>2];c=k[f+36>>2]|0;k[U+36>>2]=c;e=U+40|0;k[e>>2]=R;R=U+48|0;h=U+44|0;k[h>>2]=R;k[U+52>>2]=0;k[R>>2]=0;if(c|0){R=c+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[b>>2]|0)<3){O=k[f+44>>2]|0;R=k[h>>2]|0;k[R>>2]=k[O>>2];k[R+4>>2]=k[O+4>>2];break}k[a>>2]=0;x1(U,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;c=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[c+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0))}}else Q1(U,W,-1);while(0);b=k[Y>>2]|0;if(b&4088){k[P>>2]=0;b=P+4|0;k[b>>2]=0;c=ZT(28)|0;k[c>>2]=1;f=c+4|0;k[P>>2]=f;k[b>>2]=20;i[c+24>>0]=0;e=221354;o=f+20|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(o|0));Y8(-215,P,369779,221375,72);k[b>>2]=0;k[P>>2]=0;R=k[c>>2]|0;k[c>>2]=R+-1;if((R|0)==1)ggb(k[c+-4>>2]|0);b=k[Y>>2]|0}h=Y+12|0;m=k[h>>2]|0;j=Y+8|0;D=k[j>>2]|0;g=(D|0)<(m|0);D=g?D:m;G=(d|0)>0&(D|0)>(d|0)?d:D;g=g&1^13;d=b&7;d=d>>>0>5?d:5;R=V+112|0;if((((k[n>>2]|0)<3&(k[p>>2]|0)==1?(k[V+124>>2]|0)==(m|0):0)?(k[R>>2]&4095|0)==(d|0):0)?(k[V+128>>2]|0)!=0:0){a=P;l=P+4|0}else{k[P>>2]=1;l=P+4|0;k[l>>2]=m;G1(R,2,P,d);a=P}k[T>>2]=1124007936;K=T+4|0;b=T+8|0;I=T+40|0;f=K;o=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(o|0));k[I>>2]=b;L=T+48|0;J=T+44|0;k[J>>2]=L;k[T+52>>2]=0;k[L>>2]=0;k[a>>2]=D;k[l>>2]=D;G1(T,2,a,d);O=U+16|0;if(k[O>>2]|0){e=k[U+4>>2]|0;if((e|0)<3)b=aa(k[U+12>>2]|0,k[U+8>>2]|0)|0;else{f=k[U+40>>2]|0;c=0;b=1;do{b=aa(k[f+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(e|0))}if(b){C=k[U+40>>2]|0;if(!((k[C>>2]|0)==1?(k[C+4>>2]|0)==(m|0):0)){k[P>>2]=0;b=P+4|0;k[b>>2]=0;c=ZT(28)|0;k[c>>2]=1;f=c+4|0;k[P>>2]=f;k[b>>2]=23;i[c+27>>0]=0;e=221437;o=f+23|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(o|0));Y8(-215,P,369779,221375,104);k[b>>2]=0;k[P>>2]=0;C=k[c>>2]|0;k[c>>2]=C+-1;if((C|0)==1)ggb(k[c+-4>>2]|0)}b=P+4|0;C=b+4|0;k[C>>2]=0;k[C+4>>2]=0;k[P>>2]=33619968;k[b>>2]=R;SW(U,P,d,1.0,0.0);b=g|2}else b=g}else b=g;k[P+8>>2]=0;k[P+12>>2]=0;k[P>>2]=16842752;k[P+4>>2]=Y;C=N+4|0;B=C+4|0;k[B>>2]=0;k[B+4>>2]=0;k[N>>2]=33619968;k[C>>2]=T;C=Q+4|0;B=C+4|0;k[B>>2]=0;k[B+4>>2]=0;k[Q>>2]=50397184;k[C>>2]=R;Z_(P,N,Q,b,d);k[P+8>>2]=0;k[P+12>>2]=0;k[P>>2]=16842752;k[P+4>>2]=T;C=V+56|0;B=N+4|0;A=B+4|0;k[A>>2]=0;k[A+4>>2]=0;k[N>>2]=33619968;k[B>>2]=C;B=Q+4|0;A=B+4|0;k[A>>2]=0;k[A+4>>2]=0;k[Q>>2]=33619968;k[B>>2]=V;FZ(P,N,Q);if(!(b&1)){k[Q>>2]=1124007936;A=Q+4|0;b=Q+8|0;y=Q+40|0;f=A;o=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(o|0));k[y>>2]=b;B=Q+48|0;z=Q+44|0;k[z>>2]=B;k[Q+52>>2]=0;k[B>>2]=0;tY(H,R,(k[j>>2]|0)/(k[p>>2]|0)|0,(k[h>>2]|0)/(k[V+124>>2]|0)|0);if((k[Y>>2]&4095|0)==(d|0)?(k[H+16>>2]|0)!=(k[V+128>>2]|0):0){k[P+8>>2]=0;k[P+12>>2]=0;k[P>>2]=16842752;k[P+4>>2]=Y;k[N+8>>2]=0;k[N+12>>2]=0;k[N>>2]=16842752;k[N+4>>2]=H;x=F+4|0;w=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[F>>2]=33619968;k[x>>2]=H;sU(P,N,F,49332,-1,39968,0,0);KG(Q,H)|0}else{x=P+4|0;w=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[P>>2]=33619968;k[x>>2]=Q;SW(Y,P,d,1.0,0.0);k[P+8>>2]=0;k[P+12>>2]=0;k[P>>2]=16842752;k[P+4>>2]=Q;k[N+8>>2]=0;k[N+12>>2]=0;k[N>>2]=16842752;k[N+4>>2]=H;x=F+4|0;w=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[F>>2]=33619968;k[x>>2]=Q;sU(P,N,F,49332,-1,39968,0,0)}k[F>>2]=1124007936;w=F+4|0;b=F+8|0;u=F+40|0;f=w;o=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(o|0));k[u>>2]=b;x=F+48|0;v=F+44|0;k[v>>2]=x;k[F+52>>2]=0;k[x>>2]=0;k[a>>2]=D;k[l>>2]=m;G1(F,2,a,d);k[P+8>>2]=0;k[P+12>>2]=0;k[P>>2]=16842752;k[P+4>>2]=V;k[N+8>>2]=0;k[N+12>>2]=0;k[N>>2]=16842752;k[N+4>>2]=Q;k[s>>2]=1124007936;j=s+4|0;b=s+8|0;g=s+40|0;f=j;o=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(o|0));k[g>>2]=b;h=s+48|0;f=s+44|0;k[f>>2]=h;k[s+52>>2]=0;k[h>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;k[E>>2]=16842752;k[E+4>>2]=s;e=q+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[q>>2]=33619968;k[e>>2]=F;s_(P,N,1.0,E,0.0,q,0);e=s+36|0;b=k[e>>2]|0;if(b|0?(q=b+12|0,t=k[q>>2]|0,k[q>>2]=t+-1,(t|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[s+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;t=s+16|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[j>>2]|0)>0){c=k[g>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[f>>2]|0;if(!((b|0)==(h|0)|(b|0)==0))ggb(k[b+-4>>2]|0);KG(V,F)|0;if((G|0)>0){f=P+4|0;g=N+4|0;h=P+8|0;j=P+12|0;a=P+4|0;l=N+4|0;d=l+4|0;m=E+36|0;n=E+16|0;o=E+4|0;p=E+40|0;q=E+44|0;s=E+48|0;t=E+32|0;e=0;do{k[P>>2]=e;e=e+1|0;k[f>>2]=e;k[N>>2]=-2147483648;k[g>>2]=2147483647;H1(E,V,P,N);k[h>>2]=0;k[j>>2]=0;k[P>>2]=16842752;k[a>>2]=E;b=d;k[b>>2]=0;k[b+4>>2]=0;k[N>>2]=50397184;k[l>>2]=E;$X(P,N,1.0,0.0,4,-1,49332);b=k[m>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[m>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[t>>2]|0;if(b|0)break;b=B1()|0;c=k[m>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[m>>2]=0}k[m>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[o>>2]|0)>0){c=k[p>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[o>>2]|0))}b=k[q>>2]|0;if(!((b|0)==(s|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((e|0)<(G|0))}e=F+36|0;b=k[e>>2]|0;if(b|0?(t=b+12|0,E=k[t>>2]|0,k[t>>2]=E+-1,(E|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[F+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;F=F+16|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[w>>2]|0)>0){c=k[u>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[w>>2]|0))}b=k[v>>2]|0;if(!((b|0)==(x|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=H+36|0;b=k[e>>2]|0;if(b|0?(E=b+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[H+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;F=H+16|0;c=H+4|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[c>>2]|0)>0){e=k[H+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[H+44>>2]|0;if(!((b|0)==(H+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=Q+36|0;b=k[e>>2]|0;do if(b|0){F=b+12|0;H=k[F>>2]|0;k[F>>2]=H+-1;if((H|0)!=1)break;c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Q+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}while(0);k[e>>2]=0;H=Q+16|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[A>>2]|0)>0){c=k[y>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[A>>2]|0))}b=k[z>>2]|0;if(!((b|0)==(B|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if((D|0)>(G|0)){k[P>>2]=0;k[P+4>>2]=G;k[N>>2]=-2147483648;k[N+4>>2]=2147483647;H1(M,C,P,N);k[Q>>2]=1124007936;j=Q+4|0;b=Q+8|0;g=Q+40|0;f=j;o=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(o|0));k[g>>2]=b;h=Q+48|0;f=Q+44|0;k[f>>2]=h;k[Q+52>>2]=0;k[h>>2]=0;e=P+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[P>>2]=33619968;k[e>>2]=Q;mY(M,P);KG(C,Q)|0;e=Q+36|0;b=k[e>>2]|0;if(b|0?(F=b+12|0,H=k[F>>2]|0,k[F>>2]=H+-1,(H|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Q+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;H=Q+16|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[j>>2]|0)>0){c=k[g>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[f>>2]|0;if(!((b|0)==(h|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=M+36|0;b=k[e>>2]|0;if(b|0?(F=b+12|0,H=k[F>>2]|0,k[F>>2]=H+-1,(H|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[M+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;H=M+16|0;c=M+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[c>>2]|0)>0){e=k[M+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[M+44>>2]|0;if(!((b|0)==(M+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[P>>2]=0;k[P+4>>2]=G;k[N>>2]=-2147483648;k[N+4>>2]=2147483647;H1(S,V,P,N);k[Q>>2]=1124007936;j=Q+4|0;b=Q+8|0;g=Q+40|0;f=j;o=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(o|0));k[g>>2]=b;h=Q+48|0;f=Q+44|0;k[f>>2]=h;k[Q+52>>2]=0;k[h>>2]=0;e=P+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[P>>2]=33619968;k[e>>2]=Q;mY(S,P);KG(V,Q)|0;e=Q+36|0;b=k[e>>2]|0;if(b|0?(N=b+12|0,P=k[N>>2]|0,k[N>>2]=P+-1,(P|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Q+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;Q=Q+16|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[j>>2]|0)>0){c=k[g>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[f>>2]|0;if(!((b|0)==(h|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=S+36|0;b=k[e>>2]|0;do if(b|0){P=b+12|0;Q=k[P>>2]|0;k[P>>2]=Q+-1;if((Q|0)!=1)break;c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[S+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}while(0);k[e>>2]=0;Q=S+16|0;c=S+4|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[c>>2]|0)>0){e=k[S+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[S+44>>2]|0;if(!((b|0)==(S+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}e=T+36|0;b=k[e>>2]|0;if(b|0?(Q=b+12|0,S=k[Q>>2]|0,k[Q>>2]=S+-1,(S|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[T+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;T=T+16|0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[K>>2]|0)>0){c=k[I>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[K>>2]|0))}b=k[J>>2]|0;if(!((b|0)==(L|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=U+36|0;b=k[e>>2]|0;if(b|0?(S=b+12|0,T=k[S>>2]|0,k[S>>2]=T+-1,(T|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[U+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;e=U+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[e>>2]|0)>0){c=k[U+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[U+44>>2]|0;if(!((b|0)==(U+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=Y+36|0;b=k[e>>2]|0;if(b|0?(T=b+12|0,U=k[T>>2]|0,k[T>>2]=U+-1,(U|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Y+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;U=Y+16|0;c=Y+4|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[c>>2]|0)>0){e=k[Y+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[Y+44>>2]|0;if((b|0)==(Y+48|0)|(b|0)==0){mY(R,W);mY(V,X);z$(V);r=Z;return}ggb(k[b+-4>>2]|0);mY(R,W);mY(V,X);z$(V);r=Z;return}function _i(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0.0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0;fa=r;r=r+848|0;V=fa+792|0;U=fa+776|0;ea=fa+720|0;$=fa+664|0;_=fa+576|0;X=fa+520|0;K=fa+464|0;J=fa+408|0;I=fa+352|0;x=fa+296|0;w=fa+280|0;R=fa+224|0;Z=fa+168|0;ba=fa;ca=fa+648|0;da=fa+632|0;m=ca+4|0;H=ca+4+4|0;k[H>>2]=0;k[H+4>>2]=0;k[ca>>2]=50397184;k[m>>2]=b;H=da+4+4|0;k[H>>2]=0;k[H+4>>2]=0;k[da>>2]=33619968;k[da+4>>2]=c;k[ba>>2]=1124007936;H=ba+8|0;b=ba+40|0;u=ba+4|0;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[b>>2]=H;O=ba+48|0;k[ba+44>>2]=O;k[ba+52>>2]=0;k[O>>2]=0;k[ba+56>>2]=1124007936;O=ba+64|0;L=ba+96|0;u=ba+60|0;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[L>>2]=O;s=ba+104|0;M=ba+100|0;k[M>>2]=s;k[ba+108>>2]=0;k[s>>2]=0;k[ba+112>>2]=1124007936;s=ba+116|0;t=ba+120|0;b=ba+152|0;u=s;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[b>>2]=t;l=ba+160|0;k[ba+156>>2]=l;k[ba+164>>2]=0;k[l>>2]=0;k[ea>>2]=k[a>>2];l=ea+4|0;c=a+4|0;b=k[c>>2]|0;k[l>>2]=b;Y=ea+8|0;k[Y>>2]=k[a+8>>2];k[ea+12>>2]=k[a+12>>2];k[ea+16>>2]=k[a+16>>2];k[ea+20>>2]=k[a+20>>2];k[ea+24>>2]=k[a+24>>2];k[ea+28>>2]=k[a+28>>2];k[ea+32>>2]=k[a+32>>2];e=k[a+36>>2]|0;k[ea+36>>2]=e;f=ea+40|0;k[f>>2]=Y;Y=ea+48|0;j=ea+44|0;k[j>>2]=Y;k[ea+52>>2]=0;k[Y>>2]=0;if(e){b=e+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[l>>2]=0;x1(ea,b,0,0,0);if((k[l>>2]|0)>0){h=k[a+40>>2]|0;f=k[f>>2]|0;e=k[a+44>>2]|0;c=k[j>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{W=k[a+44>>2]|0;Y=k[j>>2]|0;k[Y>>2]=k[W>>2];k[Y+4>>2]=k[W+4>>2]}do if((k[ca>>2]&2031616|0)==65536){f=k[m>>2]|0;k[$>>2]=k[f>>2];a=$+4|0;b=f+4|0;k[a>>2]=k[b>>2];Y=$+8|0;k[Y>>2]=k[f+8>>2];k[$+12>>2]=k[f+12>>2];k[$+16>>2]=k[f+16>>2];k[$+20>>2]=k[f+20>>2];k[$+24>>2]=k[f+24>>2];k[$+28>>2]=k[f+28>>2];k[$+32>>2]=k[f+32>>2];c=k[f+36>>2]|0;k[$+36>>2]=c;e=$+40|0;k[e>>2]=Y;Y=$+48|0;j=$+44|0;k[j>>2]=Y;k[$+52>>2]=0;k[Y>>2]=0;if(c|0){Y=c+12|0;k[Y>>2]=(k[Y>>2]|0)+1}if((k[b>>2]|0)<3){W=k[f+44>>2]|0;Y=k[j>>2]|0;k[Y>>2]=k[W>>2];k[Y+4>>2]=k[W+4>>2];break}k[a>>2]=0;x1($,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){l=k[f+40>>2]|0;h=k[e>>2]|0;e=k[f+44>>2]|0;c=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[c+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0))}}else Q1($,ca,-1);while(0);if(k[ea>>2]&4088|0){k[V>>2]=0;b=V+4|0;k[b>>2]=0;c=ZT(28)|0;k[c>>2]=1;u=c+4|0;k[V>>2]=u;k[b>>2]=20;i[c+24>>0]=0;f=221354;v=u+20|0;do{i[u>>0]=i[f>>0]|0;u=u+1|0;f=f+1|0}while((u|0)<(v|0));Y8(-215,V,369779,221375,209);k[b>>2]=0;k[V>>2]=0;Y=k[c>>2]|0;k[c>>2]=Y+-1;if((Y|0)==1)ggb(k[c+-4>>2]|0)}j=ea+12|0;q=k[j>>2]|0;l=ea+8|0;b=k[l>>2]|0;if(!(d>0.0&d<=1.0)){k[V>>2]=0;c=V+4|0;k[c>>2]=0;e=ZT(52)|0;k[e>>2]=1;u=e+4|0;k[V>>2]=u;k[c>>2]=45;i[e+49>>0]=0;f=221461;v=u+45|0;do{i[u>>0]=i[f>>0]|0;u=u+1|0;f=f+1|0}while((u|0)<(v|0));Y8(-215,V,369779,221375,225);k[c>>2]=0;k[V>>2]=0;Y=k[e>>2]|0;k[e>>2]=Y+-1;if((Y|0)==1)ggb(k[e+-4>>2]|0)}h=(b|0)<(q|0);n=h?b:q;h=h&1^13;G=k[ea>>2]&7;G=G>>>0>5?G:5;Y=ba+112|0;if((((k[s>>2]|0)<3&(k[t>>2]|0)==1?(k[ba+124>>2]|0)==(q|0):0)?(k[Y>>2]&4095|0)==(G|0):0)?(k[ba+128>>2]|0)!=0:0){a=V;m=V+4|0}else{k[V>>2]=1;m=V+4|0;k[m>>2]=q;G1(Y,2,V,G);a=V}k[_>>2]=1124007936;S=_+4|0;b=_+8|0;P=_+40|0;u=S;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[P>>2]=b;T=_+48|0;Q=_+44|0;k[Q>>2]=T;k[_+52>>2]=0;k[T>>2]=0;k[a>>2]=n;k[m>>2]=n;G1(_,2,a,G);W=$+16|0;if(k[W>>2]|0){e=k[$+4>>2]|0;if((e|0)<3)b=aa(k[$+12>>2]|0,k[$+8>>2]|0)|0;else{f=k[$+40>>2]|0;c=0;b=1;do{b=aa(k[f+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(e|0))}if(b|0){N=k[$+40>>2]|0;if(!((k[N>>2]|0)==1?(k[N+4>>2]|0)==(q|0):0)){k[V>>2]=0;b=V+4|0;k[b>>2]=0;c=ZT(28)|0;k[c>>2]=1;u=c+4|0;k[V>>2]=u;k[b>>2]=23;i[c+27>>0]=0;f=221437;v=u+23|0;do{i[u>>0]=i[f>>0]|0;u=u+1|0;f=f+1|0}while((u|0)<(v|0));Y8(-215,V,369779,221375,241);k[b>>2]=0;k[V>>2]=0;N=k[c>>2]|0;k[c>>2]=N+-1;if((N|0)==1)ggb(k[c+-4>>2]|0)}N=V+4|0;F=N+4|0;k[F>>2]=0;k[F+4>>2]=0;k[V>>2]=33619968;k[N>>2]=Y;SW($,V,G,1.0,0.0)}}k[V+8>>2]=0;k[V+12>>2]=0;k[V>>2]=16842752;k[V+4>>2]=ea;N=U+4|0;F=N+4|0;k[F>>2]=0;k[F+4>>2]=0;k[U>>2]=33619968;k[N>>2]=_;N=X+4|0;F=N+4|0;k[F>>2]=0;k[F+4>>2]=0;k[X>>2]=50397184;k[N>>2]=Y;Z_(V,U,X,h,G);k[V+8>>2]=0;k[V+12>>2]=0;k[V>>2]=16842752;k[V+4>>2]=_;N=ba+56|0;F=U+4|0;E=F+4|0;k[E>>2]=0;k[E+4>>2]=0;k[U>>2]=33619968;k[F>>2]=N;F=X+4|0;E=F+4|0;k[E>>2]=0;k[E+4>>2]=0;k[X>>2]=33619968;k[F>>2]=ba;FZ(V,U,X);if(!(h&1)){k[X>>2]=1124007936;E=X+4|0;b=X+8|0;C=X+40|0;u=E;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[C>>2]=b;F=X+48|0;D=X+44|0;k[D>>2]=F;k[X+52>>2]=0;k[F>>2]=0;tY(K,Y,(k[l>>2]|0)/(k[t>>2]|0)|0,(k[j>>2]|0)/(k[ba+124>>2]|0)|0);if((k[ea>>2]&4095|0)==(G|0)?(k[K+16>>2]|0)!=(k[ba+128>>2]|0):0){k[V+8>>2]=0;k[V+12>>2]=0;k[V>>2]=16842752;k[V+4>>2]=ea;k[U+8>>2]=0;k[U+12>>2]=0;k[U>>2]=16842752;k[U+4>>2]=K;B=J+4|0;A=B+4|0;k[A>>2]=0;k[A+4>>2]=0;k[J>>2]=33619968;k[B>>2]=K;sU(V,U,J,49332,-1,39968,0,0);KG(X,K)|0}else{B=V+4|0;A=B+4|0;k[A>>2]=0;k[A+4>>2]=0;k[V>>2]=33619968;k[B>>2]=X;SW(ea,V,G,1.0,0.0);k[V+8>>2]=0;k[V+12>>2]=0;k[V>>2]=16842752;k[V+4>>2]=X;k[U+8>>2]=0;k[U+12>>2]=0;k[U>>2]=16842752;k[U+4>>2]=K;B=J+4|0;A=B+4|0;k[A>>2]=0;k[A+4>>2]=0;k[J>>2]=33619968;k[B>>2]=X;sU(V,U,J,49332,-1,39968,0,0)}k[J>>2]=1124007936;A=J+4|0;b=J+8|0;y=J+40|0;u=A;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[y>>2]=b;B=J+48|0;z=J+44|0;k[z>>2]=B;k[J+52>>2]=0;k[B>>2]=0;k[a>>2]=n;k[m>>2]=q;G1(J,2,a,G);k[V+8>>2]=0;k[V+12>>2]=0;k[V>>2]=16842752;k[V+4>>2]=ba;k[U+8>>2]=0;k[U+12>>2]=0;k[U>>2]=16842752;k[U+4>>2]=X;k[x>>2]=1124007936;l=x+4|0;b=x+8|0;h=x+40|0;u=l;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[h>>2]=b;j=x+48|0;f=x+44|0;k[f>>2]=j;k[x+52>>2]=0;k[j>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;k[I>>2]=16842752;k[I+4>>2]=x;e=w+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[w>>2]=33619968;k[e>>2]=J;s_(V,U,1.0,I,0.0,w,0);e=x+36|0;b=k[e>>2]|0;if(b|0?(v=b+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[x+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;x=x+16|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[l>>2]|0)>0){c=k[h>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[f>>2]|0;if(!((b|0)==(j|0)|(b|0)==0))ggb(k[b+-4>>2]|0);KG(ba,J)|0;if((k[H>>2]|0)>0){f=V+4|0;h=U+4|0;j=V+8|0;l=V+12|0;a=V+4|0;m=U+4|0;n=m+4|0;q=I+36|0;s=I+16|0;t=I+4|0;u=I+40|0;v=I+44|0;w=I+48|0;x=I+32|0;e=0;do{k[V>>2]=e;e=e+1|0;k[f>>2]=e;k[U>>2]=-2147483648;k[h>>2]=2147483647;H1(I,ba,V,U);k[j>>2]=0;k[l>>2]=0;k[V>>2]=16842752;k[a>>2]=I;b=n;k[b>>2]=0;k[b+4>>2]=0;k[U>>2]=50397184;k[m>>2]=I;$X(V,U,1.0,0.0,4,-1,49332);b=k[q>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[q>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[x>>2]|0;if(b|0)break;b=B1()|0;c=k[q>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[q>>2]=0}k[q>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[t>>2]|0)>0){c=k[u>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[v>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((e|0)<(k[H>>2]|0))}e=J+36|0;b=k[e>>2]|0;if(b|0?(H=b+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[J+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;J=J+16|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[A>>2]|0)>0){c=k[y>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[A>>2]|0))}b=k[z>>2]|0;if(!((b|0)==(B|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=K+36|0;b=k[e>>2]|0;if(b|0?(I=b+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[K+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;J=K+16|0;c=K+4|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[c>>2]|0)>0){e=k[K+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[K+44>>2]|0;if(!((b|0)==(K+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=X+36|0;b=k[e>>2]|0;do if(b|0){J=b+12|0;K=k[J>>2]|0;k[J>>2]=K+-1;if((K|0)!=1)break;c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[X+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}while(0);k[e>>2]=0;K=X+16|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[E>>2]|0)>0){c=k[C>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[E>>2]|0))}b=k[D>>2]|0;if(!((b|0)==(F|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if((G|0)==5){c=k[L>>2]|0;b=k[c+4>>2]|0;c=k[c>>2]|0;k[V>>2]=1124007936;t=V+4|0;e=V+8|0;n=V+40|0;u=t;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[n>>2]=e;s=V+48|0;q=V+44|0;k[q>>2]=s;k[V+52>>2]=0;k[s>>2]=0;k[U>>2]=c;k[U+4>>2]=b;G1(V,2,U,5);m=k[e>>2]|0;if((m|0)>0){j=k[V+16>>2]|0;l=k[k[q>>2]>>2]|0;a=k[ba+72>>2]|0;e=k[k[M>>2]>>2]|0;c=0;h=1;while(1){f=j+(aa(l,c)|0)|0;o[f>>2]=0.0;b=0;g=0.0;do{M=a+(aa(e,b)|0)|0;g=+o[M>>2]+g;o[f>>2]=g;b=b+1|0}while((b|0)!=(h|0));c=c+1|0;if((c|0)==(m|0))break;else h=h+1|0}}c=k[O>>2]|0;a:do if((c|0)>0){e=k[V+16>>2]|0;f=k[k[q>>2]>>2]|0;b=e+(aa(m+-1|0,f)|0)|0;g=+o[b>>2];b=0;do{O=e+(aa(f,b)|0)|0;if(+o[O>>2]/g>d)break a;b=b+1|0}while((b|0)<(c|0))}else b=0;while(0);f=(b|0)>2?b:2;e=V+36|0;b=k[e>>2]|0;if(b|0?(M=b+12|0,O=k[M>>2]|0,k[M>>2]=O+-1,(O|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[V+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;O=V+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[t>>2]|0)>0){c=k[n>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[q>>2]|0;if(!((b|0)==(s|0)|(b|0)==0))ggb(k[b+-4>>2]|0);a=f}else{c=k[L>>2]|0;b=k[c+4>>2]|0;c=k[c>>2]|0;k[V>>2]=1124007936;t=V+4|0;e=V+8|0;n=V+40|0;u=t;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[n>>2]=e;s=V+48|0;q=V+44|0;k[q>>2]=s;k[V+52>>2]=0;k[s>>2]=0;k[U>>2]=c;k[U+4>>2]=b;G1(V,2,U,6);m=k[e>>2]|0;if((m|0)>0){j=k[V+16>>2]|0;l=k[k[q>>2]>>2]|0;a=k[ba+72>>2]|0;e=k[k[M>>2]>>2]|0;c=0;h=1;while(1){f=j+(aa(l,c)|0)|0;p[f>>3]=0.0;b=0;g=0.0;do{M=a+(aa(e,b)|0)|0;g=+p[M>>3]+g;p[f>>3]=g;b=b+1|0}while((b|0)!=(h|0));c=c+1|0;if((c|0)==(m|0))break;else h=h+1|0}}c=k[O>>2]|0;b:do if((c|0)>0){e=k[V+16>>2]|0;f=k[k[q>>2]>>2]|0;b=e+(aa(m+-1|0,f)|0)|0;g=+p[b>>3];b=0;do{O=e+(aa(f,b)|0)|0;if(+p[O>>3]/g>d)break b;b=b+1|0}while((b|0)<(c|0))}else b=0;while(0);f=(b|0)>2?b:2;e=V+36|0;b=k[e>>2]|0;if(b|0?(M=b+12|0,O=k[M>>2]|0,k[M>>2]=O+-1,(O|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[V+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;O=V+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[t>>2]|0)>0){c=k[n>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[q>>2]|0;if(!((b|0)==(s|0)|(b|0)==0))ggb(k[b+-4>>2]|0);a=f}k[V>>2]=0;k[V+4>>2]=a;k[U>>2]=-2147483648;k[U+4>>2]=2147483647;H1(R,N,V,U);k[X>>2]=1124007936;l=X+4|0;b=X+8|0;h=X+40|0;u=l;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[h>>2]=b;j=X+48|0;f=X+44|0;k[f>>2]=j;k[X+52>>2]=0;k[j>>2]=0;e=V+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[V>>2]=33619968;k[e>>2]=X;mY(R,V);KG(N,X)|0;e=X+36|0;b=k[e>>2]|0;if(b|0?(N=b+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[X+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;O=X+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[l>>2]|0)>0){c=k[h>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[f>>2]|0;if(!((b|0)==(j|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=R+36|0;b=k[e>>2]|0;if(b|0?(N=b+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[R+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;O=R+16|0;c=R+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[c>>2]|0)>0){e=k[R+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[R+44>>2]|0;if(!((b|0)==(R+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[V>>2]=0;k[V+4>>2]=a;k[U>>2]=-2147483648;k[U+4>>2]=2147483647;H1(Z,ba,V,U);k[X>>2]=1124007936;l=X+4|0;b=X+8|0;h=X+40|0;u=l;v=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(v|0));k[h>>2]=b;j=X+48|0;f=X+44|0;k[f>>2]=j;k[X+52>>2]=0;k[j>>2]=0;e=V+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[V>>2]=33619968;k[e>>2]=X;mY(Z,V);KG(ba,X)|0;e=X+36|0;b=k[e>>2]|0;if(b|0?(U=b+12|0,V=k[U>>2]|0,k[U>>2]=V+-1,(V|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[X+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;X=X+16|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[l>>2]|0)>0){c=k[h>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[f>>2]|0;if(!((b|0)==(j|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=Z+36|0;b=k[e>>2]|0;do if(b|0){V=b+12|0;X=k[V>>2]|0;k[V>>2]=X+-1;if((X|0)!=1)break;c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Z+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}while(0);k[e>>2]=0;X=Z+16|0;c=Z+4|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[c>>2]|0)>0){e=k[Z+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[Z+44>>2]|0;if(!((b|0)==(Z+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=_+36|0;b=k[e>>2]|0;do if(b|0){X=b+12|0;Z=k[X>>2]|0;k[X>>2]=Z+-1;if((Z|0)!=1)break;c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[_+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}while(0);k[e>>2]=0;_=_+16|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[S>>2]|0)>0){c=k[P>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[S>>2]|0))}b=k[Q>>2]|0;if(!((b|0)==(T|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=$+36|0;b=k[e>>2]|0;do if(b|0){Z=b+12|0;_=k[Z>>2]|0;k[Z>>2]=_+-1;if((_|0)!=1)break;c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[$+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}while(0);k[e>>2]=0;e=$+4|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[e>>2]|0)>0){c=k[$+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[$+44>>2]|0;if(!((b|0)==($+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=ea+36|0;b=k[e>>2]|0;do if(b|0){_=b+12|0;$=k[_>>2]|0;k[_>>2]=$+-1;if(($|0)!=1)break;c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ea+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}while(0);k[e>>2]=0;$=ea+16|0;c=ea+4|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[c>>2]|0)>0){e=k[ea+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[ea+44>>2]|0;if((b|0)==(ea+48|0)|(b|0)==0){mY(Y,ca);mY(ba,da);z$(ba);r=fa;return}ggb(k[b+-4>>2]|0);mY(Y,ca);mY(ba,da);z$(ba);r=fa;return}function $i(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=r;r=r+496|0;F=G+432|0;D=G+376|0;C=G+320|0;y=G+304|0;z=G+288|0;A=G+272|0;B=G+168|0;E=G;m=G+256|0;l=G+240|0;x=G+224|0;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;n=m+4|0;k[n>>2]=a;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;j=l+4|0;k[j>>2]=c;q=x+4+4|0;k[q>>2]=0;k[q+4>>2]=0;k[x>>2]=33619968;k[x+4>>2]=d;k[E>>2]=1124007936;q=E+4|0;t=E+8|0;u=E+40|0;e=q;g=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(g|0));k[u>>2]=t;a=E+48|0;k[E+44>>2]=a;k[E+52>>2]=0;k[a>>2]=0;k[E+56>>2]=1124007936;a=E+64|0;c=E+96|0;e=E+60|0;g=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(g|0));k[c>>2]=a;o=E+104|0;k[E+100>>2]=o;k[E+108>>2]=0;k[o>>2]=0;k[E+112>>2]=1124007936;o=E+116|0;w=E+120|0;p=E+152|0;e=o;g=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(g|0));k[p>>2]=w;h=E+160|0;k[E+156>>2]=h;k[E+164>>2]=0;k[h>>2]=0;k[F>>2]=k[b>>2];h=F+4|0;c=b+4|0;a=k[c>>2]|0;k[h>>2]=a;s=F+8|0;k[s>>2]=k[b+8>>2];k[F+12>>2]=k[b+12>>2];k[F+16>>2]=k[b+16>>2];k[F+20>>2]=k[b+20>>2];k[F+24>>2]=k[b+24>>2];k[F+28>>2]=k[b+28>>2];k[F+32>>2]=k[b+32>>2];d=k[b+36>>2]|0;k[F+36>>2]=d;e=F+40|0;k[e>>2]=s;s=F+48|0;g=F+44|0;k[g>>2]=s;k[F+52>>2]=0;k[s>>2]=0;if(d){a=d+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[c>>2]|0}if((a|0)>=3){k[h>>2]=0;x1(F,a,0,0,0);if((k[h>>2]|0)>0){f=k[b+40>>2]|0;e=k[e>>2]|0;d=k[b+44>>2]|0;c=k[g>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[f+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else{b=k[b+44>>2]|0;s=k[g>>2]|0;k[s>>2]=k[b>>2];k[s+4>>2]=k[b+4>>2]}s=E+112|0;KG(s,F)|0;d=F+36|0;a=k[d>>2]|0;if(a|0?(h=a+12|0,b=k[h>>2]|0,k[h>>2]=b+-1,(b|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[F+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;b=F+16|0;c=F+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[c>>2]|0)>0){d=k[F+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[F+44>>2]|0;if(!((a|0)==(F+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);do if((k[l>>2]&2031616|0)==65536){e=k[j>>2]|0;k[F>>2]=k[e>>2];b=F+4|0;a=e+4|0;k[b>>2]=k[a>>2];l=F+8|0;k[l>>2]=k[e+8>>2];k[F+12>>2]=k[e+12>>2];k[F+16>>2]=k[e+16>>2];k[F+20>>2]=k[e+20>>2];k[F+24>>2]=k[e+24>>2];k[F+28>>2]=k[e+28>>2];k[F+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[F+36>>2]=c;d=F+40|0;k[d>>2]=l;l=F+48|0;g=F+44|0;k[g>>2]=l;k[F+52>>2]=0;k[l>>2]=0;if(c|0){l=c+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[a>>2]|0)<3){j=k[e+44>>2]|0;l=k[g>>2]|0;k[l>>2]=k[j>>2];k[l+4>>2]=k[j+4>>2];break}k[b>>2]=0;x1(F,k[a>>2]|0,0,0,0);if((k[b>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[b>>2]|0))}}else Q1(F,l,-1);while(0);KG(E,F)|0;d=F+36|0;a=k[d>>2]|0;if(a|0?(j=a+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[F+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;l=F+16|0;c=F+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[c>>2]|0)>0){d=k[F+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[F+44>>2]|0;if(!((a|0)==(F+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);do if((k[m>>2]&2031616|0)==65536){e=k[n>>2]|0;k[F>>2]=k[e>>2];b=F+4|0;a=e+4|0;k[b>>2]=k[a>>2];n=F+8|0;k[n>>2]=k[e+8>>2];k[F+12>>2]=k[e+12>>2];k[F+16>>2]=k[e+16>>2];k[F+20>>2]=k[e+20>>2];k[F+24>>2]=k[e+24>>2];k[F+28>>2]=k[e+28>>2];k[F+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[F+36>>2]=c;d=F+40|0;k[d>>2]=n;n=F+48|0;g=F+44|0;k[g>>2]=n;k[F+52>>2]=0;k[n>>2]=0;if(c|0){n=c+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[a>>2]|0)<3){m=k[e+44>>2]|0;n=k[g>>2]|0;k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];break}k[b>>2]=0;x1(F,k[a>>2]|0,0,0,0);if((k[b>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[b>>2]|0))}}else Q1(F,m,-1);while(0);f=E+128|0;do if(k[f>>2]|0){e=k[o>>2]|0;if((e|0)<3)a=aa(k[E+124>>2]|0,k[w>>2]|0)|0;else{d=k[p>>2]|0;c=0;a=1;do{a=aa(k[d+(c<<2)>>2]|0,a)|0;c=c+1|0}while((c|0)!=(e|0))}if((a|0)!=0?(k[E+16>>2]|0)!=0:0){e=k[q>>2]|0;if((e|0)<3)a=aa(k[E+12>>2]|0,k[t>>2]|0)|0;else{d=k[u>>2]|0;c=0;a=1;do{a=aa(k[d+(c<<2)>>2]|0,a)|0;c=c+1|0}while((c|0)!=(e|0))}if(a){a=k[w>>2]|0;c=k[E+124>>2]|0;if((a|0)==1?(c|0)==(k[F+12>>2]|0):0){a=1;break}if((c|0)==1?(a|0)==(k[F+8>>2]|0):0)c=1;else v=68}else v=68}else v=68}else v=68;while(0);if((v|0)==68){k[D>>2]=0;v=D+4|0;k[v>>2]=0;a=ZT(140)|0;k[a>>2]=1;u=a+4|0;k[D>>2]=u;k[v>>2]=132;i[a+136>>0]=0;upb(u|0,221507,132)|0;Y8(-215,D,221640,221375,296);k[v>>2]=0;k[D>>2]=0;v=k[a>>2]|0;k[a>>2]=v+-1;if((v|0)==1)ggb(k[a+-4>>2]|0);a=k[w>>2]|0;c=k[E+124>>2]|0}k[D>>2]=1124007936;l=D+4|0;d=D+8|0;b=D+40|0;e=l;g=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(g|0));k[b>>2]=d;m=D+48|0;j=D+44|0;k[j>>2]=m;k[D+52>>2]=0;k[m>>2]=0;tY(C,s,(k[F+8>>2]|0)/(a|0)|0,(k[F+12>>2]|0)/(c|0)|0);a=k[s>>2]&4095;if((k[F>>2]&4095|0)==(a|0)?(k[C+16>>2]|0)!=(k[f>>2]|0):0){k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=F;k[z+8>>2]=0;k[z+12>>2]=0;k[z>>2]=16842752;k[z+4>>2]=C;v=A+4|0;u=v+4|0;k[u>>2]=0;k[u+4>>2]=0;k[A>>2]=33619968;k[v>>2]=C;sU(y,z,A,49332,-1,39968,0,0);KG(D,C)|0}else{v=y+4|0;u=v+4|0;k[u>>2]=0;k[u+4>>2]=0;k[y>>2]=33619968;k[v>>2]=D;SW(F,y,a,1.0,0.0);k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=D;k[z+8>>2]=0;k[z+12>>2]=0;k[z>>2]=16842752;k[z+4>>2]=C;v=A+4|0;u=v+4|0;k[u>>2]=0;k[u+4>>2]=0;k[A>>2]=33619968;k[v>>2]=D;sU(y,z,A,49332,-1,39968,0,0)}if((k[w>>2]|0)==1){k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=D;k[z+8>>2]=0;k[z+12>>2]=0;k[z>>2]=16842752;k[z+4>>2]=E;k[B>>2]=1124007936;h=B+4|0;a=B+8|0;f=B+40|0;e=h;g=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(g|0));k[f>>2]=a;g=B+48|0;e=B+44|0;k[e>>2]=g;k[B+52>>2]=0;k[g>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=16842752;k[A+4>>2]=B;s_(y,z,1.0,A,0.0,x,2);d=B+36|0;a=k[d>>2]|0;if(a|0?(z=a+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;do if(!a){a=k[B+32>>2]|0;if(a|0)break;a=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;B=B+16|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[h>>2]|0)>0){c=k[f>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[e>>2]|0;if(!((a|0)==(g|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else{k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=E;k[z+8>>2]=0;k[z+12>>2]=0;k[z>>2]=16842752;k[z+4>>2]=D;k[B>>2]=1124007936;h=B+4|0;a=B+8|0;f=B+40|0;e=h;g=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(g|0));k[f>>2]=a;g=B+48|0;e=B+44|0;k[e>>2]=g;k[B+52>>2]=0;k[g>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=16842752;k[A+4>>2]=B;s_(y,z,1.0,A,0.0,x,0);d=B+36|0;a=k[d>>2]|0;if(a|0?(z=a+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;do if(!a){a=k[B+32>>2]|0;if(a|0)break;a=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;B=B+16|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[h>>2]|0)>0){c=k[f>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[e>>2]|0;if(!((a|0)==(g|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}d=C+36|0;a=k[d>>2]|0;if(a|0?(A=a+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;do if(!a){a=k[C+32>>2]|0;if(a|0)break;a=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;B=C+16|0;c=C+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[c>>2]|0)>0){d=k[C+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[C+44>>2]|0;if(!((a|0)==(C+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=D+36|0;a=k[d>>2]|0;if(a|0?(B=a+12|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;do if(!a){a=k[D+32>>2]|0;if(a|0)break;a=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[l>>2]|0)>0){c=k[b>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[j>>2]|0;if(!((a|0)==(m|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=F+36|0;a=k[d>>2]|0;do if(a|0){C=a+12|0;D=k[C>>2]|0;k[C>>2]=D+-1;if((D|0)!=1)break;c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;do if(!a){a=k[F+32>>2]|0;if(a|0)break;a=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}while(0);k[d>>2]=0;D=F+16|0;c=F+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[c>>2]|0)>0){d=k[F+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[F+44>>2]|0;if((a|0)==(F+48|0)|(a|0)==0){z$(E);r=G;return}ggb(k[a+-4>>2]|0);z$(E);r=G;return}function aj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0.0;j=r;r=r+48|0;f=j+32|0;g=j+16|0;h=j;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b;if((S1(g,-1)|0)&7|0){k[f>>2]=0;a=f+4|0;k[a>>2]=0;b=ZT(28)|0;k[b>>2]=1;c=b+4|0;k[f>>2]=c;k[a>>2]=22;i[b+26>>0]=0;d=231517;e=c+22|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,f,231540,229892,3881);k[a>>2]=0;k[f>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0)}l=+h8(g,h,5,49332);h=F2(g)|0;l=+Pfb(255.0/(+Q(+(l/+((aa(((S1(g,-1)|0)>>>3&511)+1|0,h)|0)>>>0)))+2.220446049250313e-16))*20.0;r=j;return +l}function bj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0;f=r;r=r+80|0;l=f+64|0;j=f+48|0;i=f+32|0;h=f+16|0;g=f;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=a;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=b;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=c;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=d;d=g+4+4|0;k[d>>2]=0;k[d+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=e;EZ(l,j,i,h,g);r=f;return}function cj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+64|0;j=f+48|0;i=f+32|0;h=f+16|0;g=f;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;a=i+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=b;b=h+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;c=g+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=d;DZ(j,i,h,g,e);r=f;return}function dj(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;var i=0,j=0,l=0;i=r;r=r+32|0;l=i+16|0;j=i;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=a;a=j+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=b;ufa(l,j,c,d,e,f,g,h);r=i;return}function ej(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;var j=0,l=0,m=0;j=r;r=r+32|0;m=j+16|0;l=j;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;a=l+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[l>>2]=33619968;k[l+4>>2]=b;tfa(m,l,c,d,e,f,g,h,i);r=j;return}function fj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=r;r=r+48|0;g=d+32|0;f=d+16|0;e=d;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;b=e+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=c;sU(g,f,e,49332,-1,4e4,0,0);r=d;return}function gj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+288|0;y=z+224|0;x=z+168|0;w=z+112|0;q=z+96|0;u=z+48|0;v=z;g=z+80|0;l=z+64|0;n=z+32|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;f=g+4|0;k[f>>2]=a;j=l+4|0;m=l+4+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=50397184;k[j>>2]=b;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;m=n+4|0;k[m>>2]=c;a=S1(g,-1)|0;p=a&7;a=a>>>3&511;t=a+1|0;b=S1(l,-1)|0;o=b&7;if(!(E2(g,l)|0?(b>>>3&511|0)==(a|0):0)){k[y>>2]=0;a=y+4|0;k[a>>2]=0;b=ZT(40)|0;k[b>>2]=1;c=b+4|0;k[y>>2]=c;k[a>>2]=33;i[b+37>>0]=0;d=235855;e=c+33|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,y,235889,235900,915);k[a>>2]=0;k[y>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0)}do if(!(G2(n)|0)){if(E2(g,n)|0?(S1(n,-1)|0)==0:0)break;k[y>>2]=0;a=y+4|0;k[a>>2]=0;b=ZT(72)|0;k[b>>2]=1;c=b+4|0;k[y>>2]=c;k[a>>2]=64;i[b+68>>0]=0;d=235967;e=c+64|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,y,235889,235900,916);k[a>>2]=0;k[y>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0)}while(0);do if((k[g>>2]&2031616|0)==65536){e=k[f>>2]|0;k[y>>2]=k[e>>2];h=y+4|0;a=e+4|0;k[h>>2]=k[a>>2];f=y+8|0;k[f>>2]=k[e+8>>2];k[y+12>>2]=k[e+12>>2];k[y+16>>2]=k[e+16>>2];k[y+20>>2]=k[e+20>>2];k[y+24>>2]=k[e+24>>2];k[y+28>>2]=k[e+28>>2];k[y+32>>2]=k[e+32>>2];b=k[e+36>>2]|0;k[y+36>>2]=b;c=y+40|0;k[c>>2]=f;f=y+48|0;g=y+44|0;k[g>>2]=f;k[y+52>>2]=0;k[f>>2]=0;if(b|0){f=b+12|0;k[f>>2]=(k[f>>2]|0)+1}if((k[a>>2]|0)<3){f=k[e+44>>2]|0;h=k[g>>2]|0;k[h>>2]=k[f>>2];k[h+4>>2]=k[f+4>>2];break}k[h>>2]=0;x1(y,k[a>>2]|0,0,0,0);if((k[h>>2]|0)>0){f=k[e+40>>2]|0;d=k[c>>2]|0;c=k[e+44>>2]|0;b=k[g>>2]|0;a=0;do{k[d+(a<<2)>>2]=k[f+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else Q1(y,g,-1);while(0);do if((k[l>>2]&2031616|0)==65536){d=k[j>>2]|0;k[x>>2]=k[d>>2];h=x+4|0;a=d+4|0;k[h>>2]=k[a>>2];l=x+8|0;k[l>>2]=k[d+8>>2];k[x+12>>2]=k[d+12>>2];k[x+16>>2]=k[d+16>>2];k[x+20>>2]=k[d+20>>2];k[x+24>>2]=k[d+24>>2];k[x+28>>2]=k[d+28>>2];k[x+32>>2]=k[d+32>>2];b=k[d+36>>2]|0;k[x+36>>2]=b;c=x+40|0;k[c>>2]=l;l=x+48|0;f=x+44|0;k[f>>2]=l;k[x+52>>2]=0;k[l>>2]=0;if(b|0){l=b+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[a>>2]|0)<3){j=k[d+44>>2]|0;l=k[f>>2]|0;k[l>>2]=k[j>>2];k[l+4>>2]=k[j+4>>2];break}k[h>>2]=0;x1(x,k[a>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[d+40>>2]|0;e=k[c>>2]|0;c=k[d+44>>2]|0;b=k[f>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else Q1(x,l,-1);while(0);do if((k[n>>2]&2031616|0)==65536){d=k[m>>2]|0;k[w>>2]=k[d>>2];h=w+4|0;a=d+4|0;k[h>>2]=k[a>>2];n=w+8|0;k[n>>2]=k[d+8>>2];k[w+12>>2]=k[d+12>>2];k[w+16>>2]=k[d+16>>2];k[w+20>>2]=k[d+20>>2];k[w+24>>2]=k[d+24>>2];k[w+28>>2]=k[d+28>>2];k[w+32>>2]=k[d+32>>2];b=k[d+36>>2]|0;k[w+36>>2]=b;c=w+40|0;k[c>>2]=n;n=w+48|0;f=w+44|0;k[f>>2]=n;k[w+52>>2]=0;k[n>>2]=0;if(b|0){n=b+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[a>>2]|0)<3){m=k[d+44>>2]|0;n=k[f>>2]|0;k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];break}k[h>>2]=0;x1(w,k[a>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[d+40>>2]|0;e=k[c>>2]|0;c=k[d+44>>2]|0;b=k[f>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else Q1(w,n,-1);while(0);a=(p|0)==0;c=(o|0)==5;if(!(a&c)){b=(o|0)==6;if(!(a&b)){a=(p|0)==2;if(!(a&c))if(!(a&b)){a=(p|0)==5;if(!(a&c))if(!(a&b))if((p|0)==6&b){a=6;s=46}else{k[q>>2]=0;a=q+4|0;k[a>>2]=0;b=ZT(16)|0;k[b>>2]=1;c=b+4|0;k[q>>2]=c;k[a>>2]=9;i[b+13>>0]=0;d=335726;e=c+9|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,q,235889,235900,929);k[a>>2]=0;k[q>>2]=0;p=k[b>>2]|0;k[b>>2]=p+-1;if((p|0)==1)ggb(k[b+-4>>2]|0);f=0}else{a=5;s=46}else{a=4;s=46}}else{a=3;s=46}else{a=2;s=46}}else{a=1;s=46}}else{a=0;s=46}if((s|0)==46)f=k[51680+(a<<2)>>2]|0;k[q>>2]=y;k[q+4>>2]=x;k[q+8>>2]=w;k[q+12>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;k[v+16>>2]=0;k[v+20>>2]=0;k[v+24>>2]=0;k[v+28>>2]=0;z1(v,q,0,u,-1);b=k[v+20>>2]|0;c=v+16|0;d=u+4|0;e=u+8|0;a=0;while(1){if(a>>>0>=(k[c>>2]|0)>>>0)break;eh[f&255](k[u>>2]|0,k[d>>2]|0,k[e>>2]|0,b,t);A1(v);a=a+1|0}c=w+36|0;a=k[c>>2]|0;if(a|0?(u=a+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[w+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;v=w+16|0;b=w+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[b>>2]|0)>0){c=k[w+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[w+44>>2]|0;if(!((a|0)==(w+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=x+36|0;a=k[c>>2]|0;if(a|0?(v=a+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[x+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;w=x+16|0;b=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[b>>2]|0)>0){c=k[x+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[x+44>>2]|0;if(!((a|0)==(x+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=y+36|0;a=k[c>>2]|0;if(a|0?(w=a+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;x=y+16|0;b=y+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[b>>2]|0)>0){c=k[y+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[y+44>>2]|0;if((a|0)==(y+48|0)|(a|0)==0){r=z;return}ggb(k[a+-4>>2]|0);r=z;return}function hj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+368|0;C=D+304|0;B=D+248|0;A=D+192|0;z=D+136|0;u=D+96|0;y=D+48|0;x=D;h=D+120|0;m=D+80|0;o=D+64|0;q=D+32|0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;j=h+4|0;k[j>>2]=a;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;l=m+4|0;k[l>>2]=b;n=o+4|0;p=o+4+4|0;k[p>>2]=0;k[p+4>>2]=0;k[o>>2]=50397184;k[n>>2]=c;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;p=q+4|0;k[p>>2]=d;a=S1(h,-1)|0;t=a&7;c=a>>>3&511;w=c+1|0;d=S1(o,-1)|0;s=d&7;d=d>>>3&511;if(!(E2(h,m)|0?(a|0)==(S1(m,-1)|0):0)){k[C>>2]=0;a=C+4|0;k[a>>2]=0;b=ZT(52)|0;k[b>>2]=1;e=b+4|0;k[C>>2]=e;k[a>>2]=46;i[b+50>>0]=0;f=236049;g=e+46|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,C,236096,235900,1105);k[a>>2]=0;k[C>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0)}if(!((d|0)==(c|0)&(E2(h,o)|0))){k[C>>2]=0;a=C+4|0;k[a>>2]=0;b=ZT(40)|0;k[b>>2]=1;e=b+4|0;k[C>>2]=e;k[a>>2]=34;i[b+38>>0]=0;f=236114;g=e+34|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,C,236096,235900,1106);k[a>>2]=0;k[C>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0)}do if(!(G2(q)|0)){if(E2(h,q)|0?(S1(q,-1)|0)==0:0)break;k[C>>2]=0;a=C+4|0;k[a>>2]=0;b=ZT(72)|0;k[b>>2]=1;e=b+4|0;k[C>>2]=e;k[a>>2]=65;i[b+69>>0]=0;f=236149;g=e+65|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,C,236096,235900,1107);k[a>>2]=0;k[C>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0)}while(0);do if((k[h>>2]&2031616|0)==65536){e=k[j>>2]|0;k[C>>2]=k[e>>2];h=C+4|0;b=e+4|0;k[h>>2]=k[b>>2];j=C+8|0;k[j>>2]=k[e+8>>2];k[C+12>>2]=k[e+12>>2];k[C+16>>2]=k[e+16>>2];k[C+20>>2]=k[e+20>>2];k[C+24>>2]=k[e+24>>2];k[C+28>>2]=k[e+28>>2];k[C+32>>2]=k[e+32>>2];a=k[e+36>>2]|0;k[C+36>>2]=a;c=C+40|0;k[c>>2]=j;j=C+48|0;f=C+44|0;k[f>>2]=j;k[C+52>>2]=0;k[j>>2]=0;if(a|0){j=a+12|0;k[j>>2]=(k[j>>2]|0)+1}if((k[b>>2]|0)<3){h=k[e+44>>2]|0;j=k[f>>2]|0;k[j>>2]=k[h>>2];k[j+4>>2]=k[h+4>>2];break}k[h>>2]=0;x1(C,k[b>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[e+40>>2]|0;d=k[c>>2]|0;c=k[e+44>>2]|0;b=k[f>>2]|0;a=0;do{k[d+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else Q1(C,h,-1);while(0);do if((k[m>>2]&2031616|0)==65536){d=k[l>>2]|0;k[B>>2]=k[d>>2];h=B+4|0;a=d+4|0;k[h>>2]=k[a>>2];m=B+8|0;k[m>>2]=k[d+8>>2];k[B+12>>2]=k[d+12>>2];k[B+16>>2]=k[d+16>>2];k[B+20>>2]=k[d+20>>2];k[B+24>>2]=k[d+24>>2];k[B+28>>2]=k[d+28>>2];k[B+32>>2]=k[d+32>>2];b=k[d+36>>2]|0;k[B+36>>2]=b;c=B+40|0;k[c>>2]=m;m=B+48|0;f=B+44|0;k[f>>2]=m;k[B+52>>2]=0;k[m>>2]=0;if(b|0){m=b+12|0;k[m>>2]=(k[m>>2]|0)+1}if((k[a>>2]|0)<3){l=k[d+44>>2]|0;m=k[f>>2]|0;k[m>>2]=k[l>>2];k[m+4>>2]=k[l+4>>2];break}k[h>>2]=0;x1(B,k[a>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[d+40>>2]|0;e=k[c>>2]|0;c=k[d+44>>2]|0;b=k[f>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else Q1(B,m,-1);while(0);do if((k[o>>2]&2031616|0)==65536){d=k[n>>2]|0;k[A>>2]=k[d>>2];h=A+4|0;a=d+4|0;k[h>>2]=k[a>>2];o=A+8|0;k[o>>2]=k[d+8>>2];k[A+12>>2]=k[d+12>>2];k[A+16>>2]=k[d+16>>2];k[A+20>>2]=k[d+20>>2];k[A+24>>2]=k[d+24>>2];k[A+28>>2]=k[d+28>>2];k[A+32>>2]=k[d+32>>2];b=k[d+36>>2]|0;k[A+36>>2]=b;c=A+40|0;k[c>>2]=o;o=A+48|0;f=A+44|0;k[f>>2]=o;k[A+52>>2]=0;k[o>>2]=0;if(b|0){o=b+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[a>>2]|0)<3){n=k[d+44>>2]|0;o=k[f>>2]|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];break}k[h>>2]=0;x1(A,k[a>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[d+40>>2]|0;e=k[c>>2]|0;c=k[d+44>>2]|0;b=k[f>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else Q1(A,o,-1);while(0);do if((k[q>>2]&2031616|0)==65536){d=k[p>>2]|0;k[z>>2]=k[d>>2];h=z+4|0;a=d+4|0;k[h>>2]=k[a>>2];q=z+8|0;k[q>>2]=k[d+8>>2];k[z+12>>2]=k[d+12>>2];k[z+16>>2]=k[d+16>>2];k[z+20>>2]=k[d+20>>2];k[z+24>>2]=k[d+24>>2];k[z+28>>2]=k[d+28>>2];k[z+32>>2]=k[d+32>>2];b=k[d+36>>2]|0;k[z+36>>2]=b;c=z+40|0;k[c>>2]=q;q=z+48|0;f=z+44|0;k[f>>2]=q;k[z+52>>2]=0;k[q>>2]=0;if(b|0){q=b+12|0;k[q>>2]=(k[q>>2]|0)+1}if((k[a>>2]|0)<3){p=k[d+44>>2]|0;q=k[f>>2]|0;k[q>>2]=k[p>>2];k[q+4>>2]=k[p+4>>2];break}k[h>>2]=0;x1(z,k[a>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[d+40>>2]|0;e=k[c>>2]|0;c=k[d+44>>2]|0;b=k[f>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else Q1(z,q,-1);while(0);a=(t|0)==0;c=(s|0)==5;if(!(a&c)){b=(s|0)==6;if(!(a&b)){a=(t|0)==2;if(!(a&c))if(!(a&b)){a=(t|0)==5;if(!(a&c))if(!(a&b))if((t|0)==6&b){a=6;v=59}else{k[u>>2]=0;a=u+4|0;k[a>>2]=0;b=ZT(16)|0;k[b>>2]=1;e=b+4|0;k[u>>2]=e;k[a>>2]=9;i[b+13>>0]=0;f=335726;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,u,236096,235900,1119);k[a>>2]=0;k[u>>2]=0;t=k[b>>2]|0;k[b>>2]=t+-1;if((t|0)==1)ggb(k[b+-4>>2]|0);g=0}else{a=5;v=59}else{a=4;v=59}}else{a=3;v=59}else{a=2;v=59}}else{a=1;v=59}}else{a=0;v=59}if((v|0)==59)g=k[51736+(a<<2)>>2]|0;k[u>>2]=C;k[u+4>>2]=B;k[u+8>>2]=A;k[u+12>>2]=z;k[u+16>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;k[x+16>>2]=0;k[x+20>>2]=0;k[x+24>>2]=0;k[x+28>>2]=0;z1(x,u,0,y,-1);b=k[x+20>>2]|0;c=x+16|0;d=y+4|0;e=y+8|0;f=y+12|0;a=0;while(1){if(a>>>0>=(k[c>>2]|0)>>>0)break;Lg[g&255](k[y>>2]|0,k[d>>2]|0,k[e>>2]|0,k[f>>2]|0,b,w);A1(x);a=a+1|0}c=z+36|0;a=k[c>>2]|0;if(a|0?(x=a+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[z+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;y=z+16|0;b=z+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[b>>2]|0)>0){c=k[z+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[z+44>>2]|0;if(!((a|0)==(z+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=A+36|0;a=k[c>>2]|0;if(a|0?(y=a+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[A+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;z=A+16|0;b=A+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[b>>2]|0)>0){c=k[A+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[A+44>>2]|0;if(!((a|0)==(A+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=B+36|0;a=k[c>>2]|0;if(a|0?(z=a+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[B+32>>2]|0;if(a|0)break;a=B1()|0;b=k[c>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;A=B+16|0;b=B+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[b>>2]|0)>0){c=k[B+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[B+44>>2]|0;if(!((a|0)==(B+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=C+36|0;a=k[c>>2]|0;if(a|0?(A=a+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[C+32>>2]|0;if(a|0)break;a=B1()|0;b=k[c>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;B=C+16|0;b=C+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[b>>2]|0)>0){c=k[C+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[C+44>>2]|0;if((a|0)==(C+48|0)|(a|0)==0){r=D;return}ggb(k[a+-4>>2]|0);r=D;return}function ij(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+288|0;y=z+224|0;x=z+168|0;w=z+112|0;q=z+96|0;u=z+48|0;v=z;g=z+80|0;l=z+64|0;n=z+32|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;f=g+4|0;k[f>>2]=a;j=l+4|0;m=l+4+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=50397184;k[j>>2]=b;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;m=n+4|0;k[m>>2]=c;a=S1(g,-1)|0;p=a&7;a=a>>>3&511;t=a+1|0;b=S1(l,-1)|0;o=b&7;if(!(E2(g,l)|0?(b>>>3&511|0)==(a|0):0)){k[y>>2]=0;a=y+4|0;k[a>>2]=0;b=ZT(40)|0;k[b>>2]=1;c=b+4|0;k[y>>2]=c;k[a>>2]=33;i[b+37>>0]=0;d=235855;e=c+33|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,y,236032,235900,1007);k[a>>2]=0;k[y>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0)}do if(!(G2(n)|0)){if(E2(g,n)|0?(S1(n,-1)|0)==0:0)break;k[y>>2]=0;a=y+4|0;k[a>>2]=0;b=ZT(72)|0;k[b>>2]=1;c=b+4|0;k[y>>2]=c;k[a>>2]=64;i[b+68>>0]=0;d=235967;e=c+64|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,y,236032,235900,1008);k[a>>2]=0;k[y>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0)}while(0);do if((k[g>>2]&2031616|0)==65536){e=k[f>>2]|0;k[y>>2]=k[e>>2];h=y+4|0;a=e+4|0;k[h>>2]=k[a>>2];f=y+8|0;k[f>>2]=k[e+8>>2];k[y+12>>2]=k[e+12>>2];k[y+16>>2]=k[e+16>>2];k[y+20>>2]=k[e+20>>2];k[y+24>>2]=k[e+24>>2];k[y+28>>2]=k[e+28>>2];k[y+32>>2]=k[e+32>>2];b=k[e+36>>2]|0;k[y+36>>2]=b;c=y+40|0;k[c>>2]=f;f=y+48|0;g=y+44|0;k[g>>2]=f;k[y+52>>2]=0;k[f>>2]=0;if(b|0){f=b+12|0;k[f>>2]=(k[f>>2]|0)+1}if((k[a>>2]|0)<3){f=k[e+44>>2]|0;h=k[g>>2]|0;k[h>>2]=k[f>>2];k[h+4>>2]=k[f+4>>2];break}k[h>>2]=0;x1(y,k[a>>2]|0,0,0,0);if((k[h>>2]|0)>0){f=k[e+40>>2]|0;d=k[c>>2]|0;c=k[e+44>>2]|0;b=k[g>>2]|0;a=0;do{k[d+(a<<2)>>2]=k[f+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else Q1(y,g,-1);while(0);do if((k[l>>2]&2031616|0)==65536){d=k[j>>2]|0;k[x>>2]=k[d>>2];h=x+4|0;a=d+4|0;k[h>>2]=k[a>>2];l=x+8|0;k[l>>2]=k[d+8>>2];k[x+12>>2]=k[d+12>>2];k[x+16>>2]=k[d+16>>2];k[x+20>>2]=k[d+20>>2];k[x+24>>2]=k[d+24>>2];k[x+28>>2]=k[d+28>>2];k[x+32>>2]=k[d+32>>2];b=k[d+36>>2]|0;k[x+36>>2]=b;c=x+40|0;k[c>>2]=l;l=x+48|0;f=x+44|0;k[f>>2]=l;k[x+52>>2]=0;k[l>>2]=0;if(b|0){l=b+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[a>>2]|0)<3){j=k[d+44>>2]|0;l=k[f>>2]|0;k[l>>2]=k[j>>2];k[l+4>>2]=k[j+4>>2];break}k[h>>2]=0;x1(x,k[a>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[d+40>>2]|0;e=k[c>>2]|0;c=k[d+44>>2]|0;b=k[f>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else Q1(x,l,-1);while(0);do if((k[n>>2]&2031616|0)==65536){d=k[m>>2]|0;k[w>>2]=k[d>>2];h=w+4|0;a=d+4|0;k[h>>2]=k[a>>2];n=w+8|0;k[n>>2]=k[d+8>>2];k[w+12>>2]=k[d+12>>2];k[w+16>>2]=k[d+16>>2];k[w+20>>2]=k[d+20>>2];k[w+24>>2]=k[d+24>>2];k[w+28>>2]=k[d+28>>2];k[w+32>>2]=k[d+32>>2];b=k[d+36>>2]|0;k[w+36>>2]=b;c=w+40|0;k[c>>2]=n;n=w+48|0;f=w+44|0;k[f>>2]=n;k[w+52>>2]=0;k[n>>2]=0;if(b|0){n=b+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[a>>2]|0)<3){m=k[d+44>>2]|0;n=k[f>>2]|0;k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];break}k[h>>2]=0;x1(w,k[a>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[d+40>>2]|0;e=k[c>>2]|0;c=k[d+44>>2]|0;b=k[f>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else Q1(w,n,-1);while(0);a=(p|0)==0;c=(o|0)==5;if(!(a&c)){b=(o|0)==6;if(!(a&b)){a=(p|0)==2;if(!(a&c))if(!(a&b)){a=(p|0)==5;if(!(a&c))if(!(a&b))if((p|0)==6&b){a=6;s=46}else{k[q>>2]=0;a=q+4|0;k[a>>2]=0;b=ZT(16)|0;k[b>>2]=1;c=b+4|0;k[q>>2]=c;k[a>>2]=9;i[b+13>>0]=0;d=335726;e=c+9|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,q,236032,235900,1020);k[a>>2]=0;k[q>>2]=0;p=k[b>>2]|0;k[b>>2]=p+-1;if((p|0)==1)ggb(k[b+-4>>2]|0);f=0}else{a=5;s=46}else{a=4;s=46}}else{a=3;s=46}else{a=2;s=46}}else{a=1;s=46}}else{a=0;s=46}if((s|0)==46)f=k[51708+(a<<2)>>2]|0;k[q>>2]=y;k[q+4>>2]=x;k[q+8>>2]=w;k[q+12>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;k[v+16>>2]=0;k[v+20>>2]=0;k[v+24>>2]=0;k[v+28>>2]=0;z1(v,q,0,u,-1);b=k[v+20>>2]|0;c=v+16|0;d=u+4|0;e=u+8|0;a=0;while(1){if(a>>>0>=(k[c>>2]|0)>>>0)break;eh[f&255](k[u>>2]|0,k[d>>2]|0,k[e>>2]|0,b,t);A1(v);a=a+1|0}c=w+36|0;a=k[c>>2]|0;if(a|0?(u=a+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[w+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;v=w+16|0;b=w+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[b>>2]|0)>0){c=k[w+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[w+44>>2]|0;if(!((a|0)==(w+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=x+36|0;a=k[c>>2]|0;if(a|0?(v=a+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[x+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;w=x+16|0;b=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[b>>2]|0)>0){c=k[x+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[x+44>>2]|0;if(!((a|0)==(x+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=y+36|0;a=k[c>>2]|0;if(a|0?(w=a+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;x=y+16|0;b=y+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[b>>2]|0)>0){c=k[y+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[y+44>>2]|0;if((a|0)==(y+48|0)|(a|0)==0){r=z;return}ggb(k[a+-4>>2]|0);r=z;return}function jj(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+288|0;z=A+224|0;y=A+168|0;x=A+112|0;s=A+96|0;v=A+48|0;w=A;g=A+80|0;m=A+64|0;o=A+32|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;h=g+4|0;k[h>>2]=a;l=m+4|0;n=m+4+4|0;k[n>>2]=0;k[n+4>>2]=0;k[m>>2]=50397184;k[l>>2]=b;k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;n=o+4|0;k[n>>2]=d;a=S1(g,-1)|0;q=a&7;a=a>>>3&511;u=a+1|0;b=S1(m,-1)|0;p=b&7;if(!(E2(g,m)|0?(b>>>3&511|0)==(a|0):0)){k[z>>2]=0;a=z+4|0;k[a>>2]=0;b=ZT(40)|0;k[b>>2]=1;d=b+4|0;k[z>>2]=d;k[a>>2]=33;i[b+37>>0]=0;e=235855;f=d+33|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,z,236215,235900,1201);k[a>>2]=0;k[z>>2]=0;j=k[b>>2]|0;k[b>>2]=j+-1;if((j|0)==1)ggb(k[b+-4>>2]|0)}do if(!(G2(o)|0)){if(E2(g,o)|0?(S1(o,-1)|0)==0:0)break;k[z>>2]=0;a=z+4|0;k[a>>2]=0;b=ZT(72)|0;k[b>>2]=1;d=b+4|0;k[z>>2]=d;k[a>>2]=64;i[b+68>>0]=0;e=235967;f=d+64|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,z,236215,235900,1202);k[a>>2]=0;k[z>>2]=0;j=k[b>>2]|0;k[b>>2]=j+-1;if((j|0)==1)ggb(k[b+-4>>2]|0)}while(0);do if((k[g>>2]&2031616|0)==65536){f=k[h>>2]|0;k[z>>2]=k[f>>2];j=z+4|0;a=f+4|0;k[j>>2]=k[a>>2];g=z+8|0;k[g>>2]=k[f+8>>2];k[z+12>>2]=k[f+12>>2];k[z+16>>2]=k[f+16>>2];k[z+20>>2]=k[f+20>>2];k[z+24>>2]=k[f+24>>2];k[z+28>>2]=k[f+28>>2];k[z+32>>2]=k[f+32>>2];b=k[f+36>>2]|0;k[z+36>>2]=b;d=z+40|0;k[d>>2]=g;g=z+48|0;h=z+44|0;k[h>>2]=g;k[z+52>>2]=0;k[g>>2]=0;if(b|0){g=b+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[a>>2]|0)<3){g=k[f+44>>2]|0;j=k[h>>2]|0;k[j>>2]=k[g>>2];k[j+4>>2]=k[g+4>>2];break}k[j>>2]=0;x1(z,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){g=k[f+40>>2]|0;e=k[d>>2]|0;d=k[f+44>>2]|0;b=k[h>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else Q1(z,g,-1);while(0);do if((k[m>>2]&2031616|0)==65536){e=k[l>>2]|0;k[y>>2]=k[e>>2];j=y+4|0;a=e+4|0;k[j>>2]=k[a>>2];m=y+8|0;k[m>>2]=k[e+8>>2];k[y+12>>2]=k[e+12>>2];k[y+16>>2]=k[e+16>>2];k[y+20>>2]=k[e+20>>2];k[y+24>>2]=k[e+24>>2];k[y+28>>2]=k[e+28>>2];k[y+32>>2]=k[e+32>>2];b=k[e+36>>2]|0;k[y+36>>2]=b;d=y+40|0;k[d>>2]=m;m=y+48|0;g=y+44|0;k[g>>2]=m;k[y+52>>2]=0;k[m>>2]=0;if(b|0){m=b+12|0;k[m>>2]=(k[m>>2]|0)+1}if((k[a>>2]|0)<3){l=k[e+44>>2]|0;m=k[g>>2]|0;k[m>>2]=k[l>>2];k[m+4>>2]=k[l+4>>2];break}k[j>>2]=0;x1(y,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;b=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[b+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else Q1(y,m,-1);while(0);do if((k[o>>2]&2031616|0)==65536){e=k[n>>2]|0;k[x>>2]=k[e>>2];j=x+4|0;a=e+4|0;k[j>>2]=k[a>>2];o=x+8|0;k[o>>2]=k[e+8>>2];k[x+12>>2]=k[e+12>>2];k[x+16>>2]=k[e+16>>2];k[x+20>>2]=k[e+20>>2];k[x+24>>2]=k[e+24>>2];k[x+28>>2]=k[e+28>>2];k[x+32>>2]=k[e+32>>2];b=k[e+36>>2]|0;k[x+36>>2]=b;d=x+40|0;k[d>>2]=o;o=x+48|0;g=x+44|0;k[g>>2]=o;k[x+52>>2]=0;k[o>>2]=0;if(b|0){o=b+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[a>>2]|0)<3){n=k[e+44>>2]|0;o=k[g>>2]|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];break}k[j>>2]=0;x1(x,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;b=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[b+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else Q1(x,o,-1);while(0);a=(q|0)==0;d=(p|0)==5;if(!(a&d)){b=(p|0)==6;if(!(a&b)){a=(q|0)==2;if(!(a&d))if(!(a&b)){a=(q|0)==5;if(!(a&d))if(!(a&b))if((q|0)==6&b){a=6;t=46}else{k[s>>2]=0;a=s+4|0;k[a>>2]=0;b=ZT(16)|0;k[b>>2]=1;d=b+4|0;k[s>>2]=d;k[a>>2]=9;i[b+13>>0]=0;e=335726;f=d+9|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,s,236215,235900,1215);k[a>>2]=0;k[s>>2]=0;q=k[b>>2]|0;k[b>>2]=q+-1;if((q|0)==1)ggb(k[b+-4>>2]|0);g=0}else{a=5;t=46}else{a=4;t=46}}else{a=3;t=46}else{a=2;t=46}}else{a=1;t=46}}else{a=0;t=46}if((t|0)==46)g=k[51764+(a<<2)>>2]|0;k[s>>2]=z;k[s+4>>2]=y;k[s+8>>2]=x;k[s+12>>2]=0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;k[w+16>>2]=0;k[w+20>>2]=0;k[w+24>>2]=0;k[w+28>>2]=0;z1(w,s,0,v,-1);b=k[w+20>>2]|0;d=w+16|0;e=v+4|0;f=v+8|0;a=0;while(1){if(a>>>0>=(k[d>>2]|0)>>>0)break;Jg[g&15](k[v>>2]|0,k[e>>2]|0,k[f>>2]|0,b,u,c);A1(w);a=a+1|0}d=x+36|0;a=k[d>>2]|0;if(a|0?(v=a+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[x+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;w=x+16|0;b=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[b>>2]|0)>0){d=k[x+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[x+44>>2]|0;if(!((a|0)==(x+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=y+36|0;a=k[d>>2]|0;if(a|0?(w=a+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;x=y+16|0;b=y+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[b>>2]|0)>0){d=k[y+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[y+44>>2]|0;if(!((a|0)==(y+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=z+36|0;a=k[d>>2]|0;if(a|0?(x=a+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[z+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;y=z+16|0;b=z+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[b>>2]|0)>0){d=k[z+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[z+44>>2]|0;if((a|0)==(z+48|0)|(a|0)==0){r=A;return}ggb(k[a+-4>>2]|0);r=A;return}function kj(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=+g;var h=0,j=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;V=r;r=r+1072|0;U=V+1016|0;T=V+960|0;v=V+952|0;R=V;N=V+184|0;J=V+128|0;w=V+120|0;x=V+112|0;y=V+80|0;z=V+64|0;A=V+56|0;s=V+96|0;t=s+4|0;q=s+4+4|0;k[q>>2]=0;k[q+4>>2]=0;k[s>>2]=33619968;k[t>>2]=b;k[U>>2]=k[a>>2];q=U+4|0;h=a+4|0;b=k[h>>2]|0;k[q>>2]=b;S=U+8|0;k[S>>2]=k[a+8>>2];k[U+12>>2]=k[a+12>>2];k[U+16>>2]=k[a+16>>2];k[U+20>>2]=k[a+20>>2];k[U+24>>2]=k[a+24>>2];k[U+28>>2]=k[a+28>>2];k[U+32>>2]=k[a+32>>2];j=k[a+36>>2]|0;k[U+36>>2]=j;m=U+40|0;k[m>>2]=S;S=U+48|0;o=U+44|0;k[o>>2]=S;k[U+52>>2]=0;k[S>>2]=0;if(j){b=j+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[h>>2]|0}if((b|0)>=3){k[q>>2]=0;x1(U,b,0,0,0);if((k[q>>2]|0)>0){n=k[a+40>>2]|0;m=k[m>>2]|0;j=k[a+44>>2]|0;h=k[o>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[n+(b<<2)>>2];k[h+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else{I=k[a+44>>2]|0;S=k[o>>2]|0;k[S>>2]=k[I>>2];k[S+4>>2]=k[I+4>>2]}if(k[U>>2]&4095|0){k[T>>2]=0;b=T+4|0;k[b>>2]=0;h=ZT(28)|0;k[h>>2]=1;m=h+4|0;k[T>>2]=m;k[b>>2]=21;i[h+25>>0]=0;j=354023;a=m+21|0;do{i[m>>0]=i[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(a|0));Y8(-215,T,354123,353955,1286);k[b>>2]=0;k[T>>2]=0;S=k[h>>2]|0;k[h>>2]=S+-1;if((S|0)==1)ggb(k[h+-4>>2]|0)}if(!((f|0)>1&((f|0)%2|0|0)==1)){k[T>>2]=0;b=T+4|0;k[b>>2]=0;h=ZT(40)|0;k[h>>2]=1;m=h+4|0;k[T>>2]=m;k[b>>2]=35;i[h+39>>0]=0;j=354141;a=m+35|0;do{i[m>>0]=i[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(a|0));Y8(-215,T,354123,353955,1287);k[b>>2]=0;k[T>>2]=0;S=k[h>>2]|0;k[h>>2]=S+-1;if((S|0)==1)ggb(k[h+-4>>2]|0)}S=U+40|0;G=k[S>>2]|0;D=k[G+4>>2]|0;G=k[G>>2]|0;k[v>>2]=D;k[v+4>>2]=G;x2(s,v,k[U>>2]&4095,0);do if((k[s>>2]&2031616|0)==65536){m=k[t>>2]|0;k[T>>2]=k[m>>2];q=T+4|0;b=m+4|0;k[q>>2]=k[b>>2];I=T+8|0;k[I>>2]=k[m+8>>2];k[T+12>>2]=k[m+12>>2];k[T+16>>2]=k[m+16>>2];k[T+20>>2]=k[m+20>>2];k[T+24>>2]=k[m+24>>2];k[T+28>>2]=k[m+28>>2];k[T+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[T+36>>2]=h;j=T+40|0;k[j>>2]=I;I=T+48|0;a=T+44|0;k[a>>2]=I;k[T+52>>2]=0;k[I>>2]=0;if(h|0){I=h+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[b>>2]|0)<3){H=k[m+44>>2]|0;I=k[a>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2];break}k[q>>2]=0;x1(T,k[b>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[m+40>>2]|0;n=k[j>>2]|0;j=k[m+44>>2]|0;h=k[a>>2]|0;b=0;do{k[n+(b<<2)>>2]=k[o+(b<<2)>>2];k[h+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else Q1(T,s,-1);while(0);if(!(c<0.0)){k[R>>2]=1124007936;H=R+4|0;b=R+8|0;E=R+40|0;m=H;a=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(a|0));k[E>>2]=b;I=R+48|0;F=R+44|0;k[F>>2]=I;k[R+52>>2]=0;k[I>>2]=0;B=U+16|0;C=T+16|0;if((k[B>>2]|0)!=(k[C>>2]|0))KG(R,T)|0;switch(d|0){case 0:{k[N+8>>2]=0;k[N+12>>2]=0;k[N>>2]=16842752;k[N+4>>2]=U;A=J+4|0;z=A+4|0;k[z>>2]=0;k[z+4>>2]=0;k[J>>2]=33619968;k[A>>2]=R;A=k[U>>2]&4095;k[w>>2]=f;k[w+4>>2]=f;k[x>>2]=-1;k[x+4>>2]=-1;_ta(N,J,A,w,x,1,1);break}case 1:{k[N>>2]=1124007936;t=N+4|0;b=N+8|0;q=N+40|0;m=t;a=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(a|0));k[q>>2]=b;v=N+48|0;s=N+44|0;k[s>>2]=v;k[N+52>>2]=0;k[v>>2]=0;k[J>>2]=1124007936;o=J+4|0;b=J+8|0;n=J+40|0;m=o;a=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(a|0));k[n>>2]=b;a=J+48|0;m=J+44|0;k[m>>2]=a;k[J+52>>2]=0;k[a>>2]=0;j=y+4|0;b=j+4|0;k[b>>2]=0;k[b+4>>2]=0;k[y>>2]=33619968;k[j>>2]=N;SW(U,y,5,1.0,0.0);KG(J,N)|0;k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=N;j=z+4|0;b=j+4|0;k[b>>2]=0;k[b+4>>2]=0;k[z>>2]=33619968;k[j>>2]=J;k[A>>2]=f;k[A+4>>2]=f;uua(y,z,A,0.0,0.0,1);j=y+4|0;b=j+4|0;k[b>>2]=0;k[b+4>>2]=0;k[y>>2]=33619968;k[j>>2]=R;SW(J,y,k[U>>2]&4095,1.0,0.0);j=J+36|0;b=k[j>>2]|0;if(b|0?(A=b+12|0,f=k[A>>2]|0,k[A>>2]=f+-1,(f|0)==1):0){h=k[j>>2]|0;if(h|0){b=k[h+4>>2]|0;if(!b){b=k[J+32>>2]|0;if(!b){b=B1()|0;h=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[j>>2]=0}k[j>>2]=0;f=J+16|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[o>>2]|0)>0){h=k[n>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[o>>2]|0))}b=k[m>>2]|0;if(!((b|0)==(a|0)|(b|0)==0))ggb(k[b+-4>>2]|0);j=N+36|0;b=k[j>>2]|0;if(b|0?(A=b+12|0,f=k[A>>2]|0,k[A>>2]=f+-1,(f|0)==1):0){h=k[j>>2]|0;if(h|0){b=k[h+4>>2]|0;if(!b){b=k[N+32>>2]|0;if(!b){b=B1()|0;h=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[j>>2]=0}k[j>>2]=0;f=N+16|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[t>>2]|0)>0){h=k[q>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[s>>2]|0;if(!((b|0)==(v|0)|(b|0)==0))ggb(k[b+-4>>2]|0);break}default:{k[N>>2]=0;b=N+4|0;k[b>>2]=0;h=ZT(52)|0;k[h>>2]=1;m=h+4|0;k[N>>2]=m;k[b>>2]=45;i[h+49>>0]=0;j=354177;a=m+45|0;do{i[m>>0]=i[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(a|0));Y8(-206,N,354123,353955,1316);k[b>>2]=0;k[N>>2]=0;f=k[h>>2]|0;k[h>>2]=f+-1;if((f|0)==1)ggb(k[h+-4>>2]|0)}}p[u>>3]=c;b=k[u+4>>2]|0;f=b&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){b=(b|0)<0;c=b?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=b?-0.0:0.0}j=~~c;j=(j>>>0<256?j:(j|0)>0?255:0)&255;b=~~g;c=+(b|0);a:do if(!e){h=0-(b+(c<g&1))|0;b=0;do{i[N+b>>0]=(b+-255|0)>(h|0)?j:0;b=b+1|0}while((b|0)!=768)}else{if((e|0)==1){h=(c>g&1)-b|0;b=0;while(1){i[N+b>>0]=(b+-255|0)<=(h|0)?j:0;b=b+1|0;if((b|0)==768)break a}}k[J>>2]=0;b=J+4|0;k[b>>2]=0;h=ZT(40)|0;k[h>>2]=1;m=h+4|0;k[J>>2]=m;k[b>>2]=34;i[h+38>>0]=0;j=354223;a=m+34|0;do{i[m>>0]=i[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(a|0));Y8(-206,J,354123,353955,1330);k[b>>2]=0;k[J>>2]=0;J=k[h>>2]|0;k[h>>2]=J+-1;if((J|0)==1)ggb(k[h+-4>>2]|0)}while(0);if((k[U>>2]&16384|0)!=0?(k[R>>2]&16384|0)!=0:0){J=(k[T>>2]&16384|0)!=0;b=aa(J?G:1,D)|0;if(J){L=b;M=1;b=77}else{K=b;b=76}}else{K=D;b=76}if((b|0)==76?(G|0)>0:0){L=K;M=G;b=77}if((b|0)==77?(O=U+44|0,P=R+16|0,Q=T+44|0,(L|0)>0):0){h=0;do{j=(k[B>>2]|0)+(aa(k[k[O>>2]>>2]|0,h)|0)|0;m=(k[P>>2]|0)+(aa(k[k[F>>2]>>2]|0,h)|0)|0;n=(k[C>>2]|0)+(aa(k[k[Q>>2]>>2]|0,h)|0)|0;b=0;do{i[n+b>>0]=i[N+((l[j+b>>0]|0)+255-(l[m+b>>0]|0))>>0]|0;b=b+1|0}while((b|0)!=(L|0));h=h+1|0}while((h|0)!=(M|0))}j=R+36|0;b=k[j>>2]|0;if(b|0?(P=b+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){h=k[j>>2]|0;if(h|0){b=k[h+4>>2]|0;if(!b){b=k[R+32>>2]|0;if(!b){b=B1()|0;h=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[j>>2]=0}k[j>>2]=0;R=R+16|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[H>>2]|0)>0){h=k[E>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[H>>2]|0))}b=k[F>>2]|0;if(!((b|0)==(I|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;k[R+16>>2]=0;k[R+20>>2]=0;k[R+24>>2]=0;k[R+28>>2]=0;oY(T,R)}j=T+36|0;b=k[j>>2]|0;if(b|0?(Q=b+12|0,R=k[Q>>2]|0,k[Q>>2]=R+-1,(R|0)==1):0){h=k[j>>2]|0;if(h|0){b=k[h+4>>2]|0;if(!b){b=k[T+32>>2]|0;if(!b){b=B1()|0;h=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[j>>2]=0}k[j>>2]=0;R=T+16|0;h=T+4|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[h>>2]|0)>0){j=k[T+40>>2]|0;b=0;do{k[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[h>>2]|0))}b=k[T+44>>2]|0;if(!((b|0)==(T+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);j=U+36|0;b=k[j>>2]|0;if(b|0?(R=b+12|0,T=k[R>>2]|0,k[R>>2]=T+-1,(T|0)==1):0){h=k[j>>2]|0;if(h|0){b=k[h+4>>2]|0;if(!b){b=k[U+32>>2]|0;if(!b){b=B1()|0;h=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[j>>2]=0}k[j>>2]=0;T=U+16|0;j=U+4|0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[j>>2]|0)>0){h=k[S>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[U+44>>2]|0;if((b|0)==(U+48|0)|(b|0)==0){r=V;return}ggb(k[b+-4>>2]|0);r=V;return}function lj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+64|0;j=f+48|0;i=f+32|0;h=f+16|0;g=f;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b;b=h+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=d;sU(j,i,h,g,e,39936,0,0);r=f;return}function mj(a,b,c,d,e,f,g){a=a|0;b=+b;c=c|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+80|0;i=h;m=h+56|0;l=h+40|0;j=h+24|0;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=c;c=j+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=f;p[i>>3]=b;p[i+8>>3]=d;p[i+16>>3]=e;sU(m,l,j,49332,g,40128,1,i);r=h;return}function nj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+48|0;d=j+32|0;g=j+16|0;h=j;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;f=h+4+4|0;k[f>>2]=0;k[f+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=b;do switch(c|0){case 0:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=53880;Zda(a,256);break}case 1:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=53920;_da(a,256);break}case 8:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=53940;$da(a,256);break}case 11:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=53960;aea(a,256);break}case 9:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=53980;bea(a,256);break}case 2:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=54e3;cea(a,256);break}case 5:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=54020;dea(a,256);break}case 12:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=54040;eea(a,256);break}case 10:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=54060;fea(a,256);break}case 4:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=54080;gea(a,256);break}case 7:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=54100;hea(a,256);break}case 6:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=54120;iea(a,256);break}case 3:{while(1){a=fgb(60)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a+4>>2]=1124007936;b=a+12|0;c=a+44|0;e=a+8|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+52|0;k[a+48>>2]=f;k[a+56>>2]=0;k[f>>2]=0;k[a>>2]=54140;jea(a,256);break}default:{k[d>>2]=0;a=d+4|0;k[a>>2]=0;b=ZT(48)|0;k[b>>2]=1;e=b+4|0;k[d>>2]=e;k[a>>2]=42;i[b+46>>0]=0;c=242236;f=e+42|0;do{i[e>>0]=i[c>>0]|0;e=e+1|0;c=c+1|0}while((e|0)<(f|0));Y8(-5,d,242279,241929,548);k[a>>2]=0;k[d>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0);Vda(0,g,h);r=j;return}}while(0);Vda(a,g,h);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);r=j;return}function oj(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0.0,n=0.0,p=0,q=0,s=0,t=0,v=0.0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0;Q=r;r=r+2336|0;O=Q+2272|0;N=Q+1176|0;M=Q+80|0;p=Q+72|0;L=Q;K=Q+56|0;l=K+4+4|0;k[l>>2]=0;k[l+4>>2]=0;k[K>>2]=33619968;k[K+4>>2]=b;k[O>>2]=k[a>>2];l=O+4|0;e=a+4|0;b=k[e>>2]|0;k[l>>2]=b;J=O+8|0;k[J>>2]=k[a+8>>2];k[O+12>>2]=k[a+12>>2];k[O+16>>2]=k[a+16>>2];k[O+20>>2]=k[a+20>>2];k[O+24>>2]=k[a+24>>2];k[O+28>>2]=k[a+28>>2];k[O+32>>2]=k[a+32>>2];f=k[a+36>>2]|0;k[O+36>>2]=f;g=O+40|0;k[g>>2]=J;J=O+48|0;j=O+44|0;k[j>>2]=J;k[O+52>>2]=0;k[J>>2]=0;if(f){b=f+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[e>>2]|0}if((b|0)>=3){k[l>>2]=0;x1(O,b,0,0,0);if((k[l>>2]|0)>0){h=k[a+40>>2]|0;g=k[g>>2]|0;f=k[a+44>>2]|0;e=k[j>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[h+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{I=k[a+44>>2]|0;J=k[j>>2]|0;k[J>>2]=k[I>>2];k[J+4>>2]=k[I+4>>2]}D=y2(O,2,-1,1)|0;a=k[O>>2]|0;F=a&7;if(!((D|0)>-1&(F|1|0)==5)){k[N>>2]=0;b=N+4|0;k[b>>2]=0;e=ZT(60)|0;k[e>>2]=1;f=e+4|0;k[N>>2]=f;k[b>>2]=52;i[e+56>>0]=0;g=236397;h=f+52|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,N,236450,236291,679);k[b>>2]=0;k[N>>2]=0;J=k[e>>2]|0;k[e>>2]=J+-1;if((J|0)==1)ggb(k[e+-4>>2]|0)}if(D){I=N+8|0;zpb(I|0,0,1088)|0;k[N>>2]=I;J=N+4|0;k[J>>2]=136;f=D>>>0>136;if(f){e=D>>>0>536870911?-1:D<<3;e=(e|0)==0?1:e;while(1){b=fgb(e)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}zpb(b|0,0,D<<3|0)|0;k[N>>2]=b;E=b}else E=I;k[J>>2]=D;G=M+8|0;zpb(G|0,0,1088)|0;k[M>>2]=G;H=M+4|0;k[H>>2]=136;if(f){e=D>>>0>536870911?-1:D<<3;e=(e|0)==0?1:e;while(1){b=fgb(e)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}zpb(b|0,0,D<<3|0)|0;k[M>>2]=b}else b=G;k[H>>2]=D;switch(a&7){case 4:{A=k[O+16>>2]|0;B=d&1;x=c*c;if(!d){f=D+-1|0;if((k[A+(f<<3)>>2]|0)==(k[A>>2]|0)?(k[A+(f<<3)+4>>2]|0)==(k[A+4>>2]|0):0){l=1;p=30}else{a=b;k[a>>2]=0;k[a+4>>2]=f;a=1;h=b;e=D;z=0;g=D;p=51}}else{l=3;p=30}do if((p|0)==30){if((D|0)>1){j=0;f=0;h=0;do{f=(f+h|0)%(D|0)|0;g=k[A+(f<<3)>>2]|0;e=k[A+(f<<3)+4>>2]|0;f=f+1|0;a=1;c=0.0;f=(f|0)>=(D|0)?0:f;do{w=f+1|0;z=f;f=(w|0)>=(D|0)?0:w;y=+((k[A+(z<<3)>>2]|0)-g|0);C=+((k[A+(z<<3)+4>>2]|0)-e|0);C=y*y+C*C;z=C>c;h=z?a:h;c=z?C:c;a=a+1|0}while((a|0)!=(D|0));j=j+1|0}while((j|0)<(l|0))}else{e=0;f=0;do{a=(f|0)%(D|0)|0;z=a+1|0;f=(z|0)>=(D|0)?0:z;e=e+1|0}while((e|0)<(l|0));c=0.0;g=k[A+(a<<3)>>2]|0;h=0;e=k[A+(a<<3)+4>>2]|0}if(c<=x){k[E>>2]=g;k[E+4>>2]=e;b=1;break}j=(f|0)%(D|0)|0;g=(j+h|0)%(D|0)|0;z=b;k[z>>2]=g;k[z+4>>2]=j;if(D>>>0>1)e=D;else{h=(D*3|0)>>>1;b=k[H>>2]|0;if(b>>>0<h>>>0){a=k[M>>2]|0;k[M>>2]=G;k[H>>2]=h;a:do if((b|0)!=0&(G|0)!=(a|0)){t=a;w=k[t+4>>2]|0;z=G;k[z>>2]=k[t>>2];k[z+4>>2]=w;if((b|0)!=1){t=a+8|0;w=k[t+4>>2]|0;z=M+16|0;k[z>>2]=k[t>>2];k[z+4>>2]=w;if((b|0)==2)b=2;else{f=G;e=2;while(1){t=a+(e<<3)|0;w=k[t+4>>2]|0;z=f+(e<<3)|0;k[z>>2]=k[t>>2];k[z+4>>2]=w;e=e+1|0;if((e|0)==(b|0))break a;f=k[M>>2]|0}}}else b=1}while(0);do{z=(k[M>>2]|0)+(b<<3)|0;k[z>>2]=0;k[z+4>>2]=0;b=b+1|0}while((b|0)!=(h|0));if(!((a|0)==(G|0)|(a|0)==0))ggb(a)}else k[H>>2]=h;b=k[M>>2]|0;e=k[H>>2]|0}a=b+8|0;k[a>>2]=j;k[a+4>>2]=g;a=2;h=b;z=1;f=D+-1|0;p=51}while(0);if((p|0)==51){b=0;p=h;b:while(1){w=a;while(1){s=w+-1|0;q=p+(s<<3)|0;t=k[q>>2]|0;q=k[q+4>>2]|0;j=k[A+(t<<3)>>2]|0;l=k[A+(t<<3)+4>>2]|0;h=t+1|0;h=(h|0)>=(D|0)?0:h;if((h|0)!=(q|0)){n=+((k[A+(q<<3)>>2]|0)-j|0);v=+((k[A+(q<<3)+4>>2]|0)-l|0);m=0.0;c:while(1){a=h;do{if((a|0)==(q|0))break c;R=a+1|0;h=a;a=(R|0)>=(D|0)?0:R;c=+P(+(n*+((k[A+(h<<3)+4>>2]|0)-l|0)-v*+((k[A+(h<<3)>>2]|0)-j|0)))}while(!(c>m));m=c;h=a;g=(f+a|0)%(D|0)|0}if(!(m*m<=x*(v*v+n*n)))break}h=b+1|0;k[E+(b<<3)>>2]=j;k[E+(b<<3)+4>>2]=l;if(!s){b=h;break b}else{b=h;w=s}}if(s>>>0<e>>>0)h=p;else{h=e*3|0;j=h>>>1;e=k[H>>2]|0;if(e>>>0<j>>>0){l=k[M>>2]|0;if(h>>>0>273){a=j>>>0>536870911?-1:j<<3;a=(a|0)==0?1:a;while(1){h=fgb(a)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}zpb(h|0,0,j<<3|0)|0}else h=G;k[M>>2]=h;k[H>>2]=j;if((e|0)!=0&(h|0)!=(l|0)){a=l;p=k[a+4>>2]|0;R=h;k[R>>2]=k[a>>2];k[R+4>>2]=p;if((e|0)!=1){a=l+8|0;p=k[a+4>>2]|0;R=h+8|0;k[R>>2]=k[a>>2];k[R+4>>2]=p;if((e|0)==2)e=2;else{h=2;do{a=l+(h<<3)|0;p=k[a+4>>2]|0;R=(k[M>>2]|0)+(h<<3)|0;k[R>>2]=k[a>>2];k[R+4>>2]=p;h=h+1|0}while((h|0)!=(e|0))}}else e=1}do{R=(k[M>>2]|0)+(e<<3)|0;k[R>>2]=0;k[R+4>>2]=0;e=e+1|0}while((e|0)!=(j|0));if(!((l|0)==(G|0)|(l|0)==0))ggb(l)}else k[H>>2]=j;h=k[M>>2]|0;e=k[H>>2]|0}R=h+(s<<3)|0;k[R>>2]=g;k[R+4>>2]=q;if(w>>>0>=e>>>0){h=e*3|0;j=h>>>1;e=k[H>>2]|0;if(e>>>0<j>>>0){l=k[M>>2]|0;if(h>>>0>273){a=j>>>0>536870911?-1:j<<3;a=(a|0)==0?1:a;while(1){h=fgb(a)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}zpb(h|0,0,j<<3|0)|0}else h=G;k[M>>2]=h;k[H>>2]=j;do if((e|0)!=0&(h|0)!=(l|0)){q=l;s=k[q+4>>2]|0;R=h;k[R>>2]=k[q>>2];k[R+4>>2]=s;if((e|0)==1)e=1;else{q=l+8|0;s=k[q+4>>2]|0;R=h+8|0;k[R>>2]=k[q>>2];k[R+4>>2]=s;if((e|0)==2){e=2;break}else h=2;do{q=l+(h<<3)|0;s=k[q+4>>2]|0;R=(k[M>>2]|0)+(h<<3)|0;k[R>>2]=k[q>>2];k[R+4>>2]=s;h=h+1|0}while((h|0)!=(e|0))}}while(0);do{R=(k[M>>2]|0)+(e<<3)|0;k[R>>2]=0;k[R+4>>2]=0;e=e+1|0}while((e|0)!=(j|0));if(!((l|0)==(G|0)|(l|0)==0))ggb(l)}else k[H>>2]=j;h=k[M>>2]|0;e=k[H>>2]|0}a=w+1|0;R=h+(w<<3)|0;k[R>>2]=t;k[R+4>>2]=g;if(!a)break;else p=h}if(!z){k[E+(b<<3)>>2]=k[A+(f<<3)>>2];k[E+(b<<3)+4>>2]=k[A+(f<<3)+4>>2];b=b+1|0}}j=d?b+-1|0:0;g=j+1|0;g=(g|0)>=(b|0)?0:g;f=k[E+(g<<3)>>2]|0;e=k[E+(g<<3)+4>>2]|0;a=g+1|0;h=B^1;z=b-h|0;if((b|0)>2&(h|0)<(z|0)){c=x*.5;w=b;l=(a|0)>=(b|0)?0:a;t=f;f=k[E+(j<<3)>>2]|0;s=e;e=k[E+(j<<3)+4>>2]|0;while(1){q=k[E+(l<<3)>>2]|0;a=k[E+(l<<3)+4>>2]|0;p=l+1|0;p=(p|0)>=(b|0)?0:p;R=q-f|0;y=+(R|0);D=a-e|0;C=+(D|0);B=t-f|0;A=s-e|0;x=+P(+(+(B|0)*C-+(A|0)*y));if(((aa(a-s|0,A)|0)+(aa(q-t|0,B)|0)|0)>-1&((D|0)!=0&(R|0?x*x<=c*(y*y+C*C):0))){k[E+(g<<3)>>2]=q;k[E+(g<<3)+4>>2]=a;g=g+1|0;l=p+1|0;g=(g|0)>=(b|0)?0:g;h=h+1|0;j=w+-1|0;l=(l|0)>=(b|0)?0:l;f=k[E+(p<<3)>>2]|0;e=k[E+(p<<3)+4>>2]|0}else{k[E+(g<<3)>>2]=t;k[E+(g<<3)+4>>2]=s;g=g+1|0;g=(g|0)>=(b|0)?0:g;j=w;l=p;f=q;q=t;e=a;a=s}h=h+1|0;if(!((j|0)>2&(h|0)<(z|0))){b=j;break}else{w=j;t=f;f=q;s=e;e=a}}}if(!d){k[E+(g<<3)>>2]=f;k[E+(g<<3)+4>>2]=e}break}case 5:{A=k[O+16>>2]|0;B=d&1;C=c*c;do if(d){l=3;p=110}else{f=D+-1|0;if(!(+o[A+(f<<3)>>2]!=+o[A>>2])?!(+o[A+(f<<3)+4>>2]!=+o[A+4>>2]):0){l=1;p=110;break}a=b;k[a>>2]=0;k[a+4>>2]=f;a=1;h=b;e=D;z=0;g=D;p=131}while(0);do if((p|0)==110){if((D|0)>1){j=0;f=0;h=0;do{f=(f+h|0)%(D|0)|0;g=k[A+(f<<3)>>2]|0;e=k[A+(f<<3)+4>>2]|0;f=f+1|0;m=(k[u>>2]=g,+o[u>>2]);n=(k[u>>2]=e,+o[u>>2]);a=1;c=0.0;f=(f|0)>=(D|0)?0:f;do{z=f+1|0;R=f;f=(z|0)>=(D|0)?0:z;x=+o[A+(R<<3)>>2]-m;y=+o[A+(R<<3)+4>>2]-n;y=x*x+y*y;R=y>c;h=R?a:h;c=R?y:c;a=a+1|0}while((a|0)!=(D|0));j=j+1|0}while((j|0)<(l|0))}else{e=0;f=0;do{a=(f|0)%(D|0)|0;R=a+1|0;f=(R|0)>=(D|0)?0:R;e=e+1|0}while((e|0)<(l|0));c=0.0;g=k[A+(a<<3)>>2]|0;h=0;e=k[A+(a<<3)+4>>2]|0}if(c<=C){k[E>>2]=g;k[E+4>>2]=e;b=1;break}j=(f|0)%(D|0)|0;g=(j+h|0)%(D|0)|0;R=b;k[R>>2]=g;k[R+4>>2]=j;if(D>>>0>1)e=D;else{h=(D*3|0)>>>1;b=k[H>>2]|0;if(b>>>0<h>>>0){a=k[M>>2]|0;k[M>>2]=G;k[H>>2]=h;d:do if((b|0)!=0&(G|0)!=(a|0)){w=a;z=k[w+4>>2]|0;R=G;k[R>>2]=k[w>>2];k[R+4>>2]=z;if((b|0)!=1){w=a+8|0;z=k[w+4>>2]|0;R=M+16|0;k[R>>2]=k[w>>2];k[R+4>>2]=z;if((b|0)==2)b=2;else{f=G;e=2;while(1){w=a+(e<<3)|0;z=k[w+4>>2]|0;R=f+(e<<3)|0;k[R>>2]=k[w>>2];k[R+4>>2]=z;e=e+1|0;if((e|0)==(b|0))break d;f=k[M>>2]|0}}}else b=1}while(0);do{R=(k[M>>2]|0)+(b<<3)|0;k[R>>2]=0;k[R+4>>2]=0;b=b+1|0}while((b|0)!=(h|0));if(!((a|0)==(G|0)|(a|0)==0))ggb(a)}else k[H>>2]=h;b=k[M>>2]|0;e=k[H>>2]|0}a=b+8|0;k[a>>2]=j;k[a+4>>2]=g;a=2;h=b;z=1;f=D+-1|0;p=131}while(0);if((p|0)==131){b=0;p=h;e:while(1){w=a;while(1){s=w+-1|0;q=p+(s<<3)|0;t=k[q>>2]|0;q=k[q+4>>2]|0;j=k[A+(t<<3)>>2]|0;l=k[A+(t<<3)+4>>2]|0;h=t+1|0;h=(h|0)>=(D|0)?0:h;if((h|0)!=(q|0)){n=(k[u>>2]=j,+o[u>>2]);v=+o[A+(q<<3)>>2]-n;x=(k[u>>2]=l,+o[u>>2]);y=+o[A+(q<<3)+4>>2]-x;m=0.0;f:while(1){a=h;do{if((a|0)==(q|0))break f;h=a+1|0;R=a;a=(h|0)>=(D|0)?0:h;c=+P(+(v*(+o[A+(R<<3)+4>>2]-x)-y*(+o[A+(R<<3)>>2]-n)))}while(!(c>m));m=c;h=a;g=(f+a|0)%(D|0)|0}if(!(m*m<=C*(y*y+v*v)))break}h=b+1|0;k[E+(b<<3)>>2]=j;k[E+(b<<3)+4>>2]=l;if(!s){b=h;break e}else{b=h;w=s}}if(s>>>0<e>>>0)h=p;else{h=e*3|0;j=h>>>1;e=k[H>>2]|0;if(e>>>0<j>>>0){l=k[M>>2]|0;if(h>>>0>273){a=j>>>0>536870911?-1:j<<3;a=(a|0)==0?1:a;while(1){h=fgb(a)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}zpb(h|0,0,j<<3|0)|0}else h=G;k[M>>2]=h;k[H>>2]=j;if((e|0)!=0&(h|0)!=(l|0)){a=l;p=k[a+4>>2]|0;R=h;k[R>>2]=k[a>>2];k[R+4>>2]=p;if((e|0)!=1){a=l+8|0;p=k[a+4>>2]|0;R=h+8|0;k[R>>2]=k[a>>2];k[R+4>>2]=p;if((e|0)==2)e=2;else{h=2;do{a=l+(h<<3)|0;p=k[a+4>>2]|0;R=(k[M>>2]|0)+(h<<3)|0;k[R>>2]=k[a>>2];k[R+4>>2]=p;h=h+1|0}while((h|0)!=(e|0))}}else e=1}do{R=(k[M>>2]|0)+(e<<3)|0;k[R>>2]=0;k[R+4>>2]=0;e=e+1|0}while((e|0)!=(j|0));if(!((l|0)==(G|0)|(l|0)==0))ggb(l)}else k[H>>2]=j;h=k[M>>2]|0;e=k[H>>2]|0}R=h+(s<<3)|0;k[R>>2]=g;k[R+4>>2]=q;if(w>>>0>=e>>>0){h=e*3|0;j=h>>>1;e=k[H>>2]|0;if(e>>>0<j>>>0){l=k[M>>2]|0;if(h>>>0>273){a=j>>>0>536870911?-1:j<<3;a=(a|0)==0?1:a;while(1){h=fgb(a)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}zpb(h|0,0,j<<3|0)|0}else h=G;k[M>>2]=h;k[H>>2]=j;do if((e|0)!=0&(h|0)!=(l|0)){q=l;s=k[q+4>>2]|0;R=h;k[R>>2]=k[q>>2];k[R+4>>2]=s;if((e|0)==1)e=1;else{q=l+8|0;s=k[q+4>>2]|0;R=h+8|0;k[R>>2]=k[q>>2];k[R+4>>2]=s;if((e|0)==2){e=2;break}else h=2;do{q=l+(h<<3)|0;s=k[q+4>>2]|0;R=(k[M>>2]|0)+(h<<3)|0;k[R>>2]=k[q>>2];k[R+4>>2]=s;h=h+1|0}while((h|0)!=(e|0))}}while(0);do{R=(k[M>>2]|0)+(e<<3)|0;k[R>>2]=0;k[R+4>>2]=0;e=e+1|0}while((e|0)!=(j|0));if(!((l|0)==(G|0)|(l|0)==0))ggb(l)}else k[H>>2]=j;h=k[M>>2]|0;e=k[H>>2]|0}a=w+1|0;R=h+(w<<3)|0;k[R>>2]=t;k[R+4>>2]=g;if(!a)break;else p=h}if(!z){k[E+(b<<3)>>2]=k[A+(f<<3)>>2];k[E+(b<<3)+4>>2]=k[A+(f<<3)+4>>2];b=b+1|0}}j=d?b+-1|0:0;g=j+1|0;g=(g|0)>=(b|0)?0:g;f=k[E+(g<<3)>>2]|0;e=k[E+(g<<3)+4>>2]|0;a=g+1|0;h=B^1;z=b-h|0;if((b|0)>2&(h|0)<(z|0)){c=C*.5;w=b;l=(a|0)>=(b|0)?0:a;t=f;f=k[E+(j<<3)>>2]|0;s=e;e=k[E+(j<<3)+4>>2]|0;while(1){q=k[E+(l<<3)>>2]|0;a=k[E+(l<<3)+4>>2]|0;p=l+1|0;p=(p|0)>=(b|0)?0:p;V=(k[u>>2]=q,+o[u>>2]);W=(k[u>>2]=f,+o[u>>2]);v=V-W;y=v;S=(k[u>>2]=a,+o[u>>2]);T=(k[u>>2]=e,+o[u>>2]);n=S-T;C=n;U=(k[u>>2]=t,+o[u>>2]);W=U-W;m=(k[u>>2]=s,+o[u>>2]);T=m-T;x=+P(+(W*C-T*y));if(W*(V-U)+T*(S-m)>=0.0&(n!=0.0&(v!=0.0?x*x<=c*(y*y+C*C):0))){k[E+(g<<3)>>2]=q;k[E+(g<<3)+4>>2]=a;g=g+1|0;l=p+1|0;g=(g|0)>=(b|0)?0:g;h=h+1|0;j=w+-1|0;l=(l|0)>=(b|0)?0:l;f=k[E+(p<<3)>>2]|0;e=k[E+(p<<3)+4>>2]|0}else{k[E+(g<<3)>>2]=t;k[E+(g<<3)+4>>2]=s;g=g+1|0;g=(g|0)>=(b|0)?0:g;j=w;l=p;f=q;q=t;e=a;a=s}h=h+1|0;if(!((j|0)>2&(h|0)<(z|0))){b=j;break}else{w=j;t=f;f=q;s=e;e=a}}}if(!d){k[E+(g<<3)>>2]=f;k[E+(g<<3)+4>>2]=e}break}default:{k[p>>2]=0;R=p+4|0;k[R>>2]=0;b=ZT(8)|0;k[b>>2]=1;d=b+4|0;k[p>>2]=d;k[R>>2]=0;i[d>>0]=0;Y8(-210,p,236450,236291,697);k[R>>2]=0;k[p>>2]=0;R=k[b>>2]|0;k[b>>2]=R+-1;if((R|0)==1)ggb(k[b+-4>>2]|0);b=0}}JN(L,b,1,F|8,E,0);mY(L,K);f=L+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,R=k[K>>2]|0,k[K>>2]=R+-1,(R|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[L+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;R=L+16|0;e=L+4|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[e>>2]|0)>0){f=k[L+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[L+44>>2]|0;if(!((b|0)==(L+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[M>>2]|0;if((b|0)!=(G|0)){if(b|0)ggb(b);k[M>>2]=G;k[H>>2]=136}b=k[N>>2]|0;if((b|0)!=(I|0)){if(b|0)ggb(b);k[N>>2]=I;k[J>>2]=136}}else b2(K);f=O+36|0;b=k[f>>2]|0;if(b|0?(N=b+12|0,R=k[N>>2]|0,k[N>>2]=R+-1,(R|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[O+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;R=O+16|0;e=O+4|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[e>>2]|0)>0){f=k[O+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[O+44>>2]|0;if((b|0)==(O+48|0)|(b|0)==0){r=Q;return}ggb(k[b+-4>>2]|0);r=Q;return}function pj(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0;d=r;r=r+16|0;e=d;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=a;c=+Yra(e,b);r=d;return +c}function qj(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;var i=0.0,j=0.0,l=0.0,m=0,n=0,o=0.0,q=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;x=r;r=r+64|0;z=x+56|0;y=x+48|0;m=x+40|0;n=x+32|0;t=x+24|0;v=x+16|0;w=x;s=w+4+4|0;k[s>>2]=0;k[s+4>>2]=0;k[w>>2]=50397184;k[w+4>>2]=a;a=k[b>>2]|0;b=k[b+4>>2]|0;s=k[c>>2]|0;c=k[c+4>>2]|0;q=+(a-s|0);o=+(b-c|0);o=+Q(+(q*q+o*o))*h;k[z>>2]=a;k[z+4>>2]=b;k[y>>2]=s;k[y+4>>2]=c;Gfa(w,z,y,d,e,f,g);q=+(c|0);l=+(s|0);j=+Y(+(+(b|0)-q),+(+(a|0)-l));i=j+.7853981633974483;h=l+o*+S(+i);p[u>>3]=h;a=k[u+4>>2]|0;b=a&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}b=~~h;h=q+o*+T(+i);p[u>>3]=h;a=k[u+4>>2]|0;z=a&2146435072;if(!(z>>>0>1126170624|(z|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}k[m>>2]=b;k[m+4>>2]=~~h;k[n>>2]=s;k[n+4>>2]=c;Gfa(w,m,n,d,e,f,g);i=j+-.7853981633974483;h=l+o*+S(+i);p[u>>3]=h;a=k[u+4>>2]|0;z=a&2146435072;if(!(z>>>0>1126170624|(z|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}b=~~h;h=q+o*+T(+i);p[u>>3]=h;a=k[u+4>>2]|0;z=a&2146435072;if(z>>>0>1126170624|(z|0)==1126170624&0>0){q=h;y=~~q;k[t>>2]=b;z=t+4|0;k[z>>2]=y;k[v>>2]=s;z=v+4|0;k[z>>2]=c;Gfa(w,t,v,d,e,f,g);r=x;return}a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(!(h==0.0)){q=h;y=~~q;k[t>>2]=b;z=t+4|0;k[z>>2]=y;k[v>>2]=s;z=v+4|0;k[z>>2]=c;Gfa(w,t,v,d,e,f,g);r=x;return}q=a?-0.0:0.0;y=~~q;k[t>>2]=b;z=t+4|0;k[z>>2]=y;k[v>>2]=s;z=v+4|0;k[z>>2]=c;Gfa(w,t,v,d,e,f,g);r=x;return}function rj(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=r;r=r+80|0;q=l+64|0;p=l+48|0;o=l+32|0;n=l+16|0;m=l;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=a;k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=b;b=o+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[o>>2]=33619968;k[o+4>>2]=c;c=n+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[n>>2]=33619968;k[n+4>>2]=e;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=h;F8(q,p,o,d,n,f,g,m,i,j);r=l;return}function sj(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;var g=0,h=0,i=0;g=r;r=r+32|0;i=g+16|0;h=g;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=a;a=h+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=b;wua(i,h,c,d,e,f);r=g;return}function tj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=r;r=r+80|0;f=e+64|0;j=e+48|0;i=e+32|0;h=e+16|0;g=e;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b;b=h+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=d;k[f>>2]=98;aU(j,i,h,g,f,1,9);r=e;return}function uj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=r;r=r+64|0;e=d+48|0;h=d+32|0;g=d+16|0;f=d;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=a;a=g+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=b;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=c;k[e>>2]=99;aU(h,h,g,f,e,1,12);r=d;return}function vj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=r;r=r+80|0;f=e+64|0;j=e+48|0;i=e+32|0;h=e+16|0;g=e;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b;b=h+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=d;k[f>>2]=100;aU(j,i,h,g,f,1,10);r=e;return}function wj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=r;r=r+80|0;f=e+64|0;j=e+48|0;i=e+32|0;h=e+16|0;g=e;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b;b=h+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=d;k[f>>2]=101;aU(j,i,h,g,f,1,11);r=e;return}function xj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+48|0;h=f+40|0;g=f+32|0;j=f+16|0;i=f;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;a=i+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=b;a=k[c+4>>2]|0;b=k[d>>2]|0;d=k[d+4>>2]|0;k[h>>2]=k[c>>2];k[h+4>>2]=a;k[g>>2]=b;k[g+4>>2]=d;_ta(j,i,-1,h,g,1,e);r=f;return}function yj(a,b,c){a=a|0;b=b|0;c=c|0;return uY(a,b,c)|0}function zj(a,b){a=a|0;b=b|0;var c=0,d=0;c=r;r=r+16|0;d=c;k[d+8>>2]=0;k[d+12>>2]=0;k[d>>2]=16842752;k[d+4>>2]=b;$ra(a,d);r=c;return}function Aj(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+48|0;m=h+32|0;l=h+16|0;j=h+8|0;i=h;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;a=l+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[l>>2]=33619968;k[l+4>>2]=b;k[j>>2]=k[d>>2];k[j+4>>2]=k[d+4>>2];k[i>>2]=k[e>>2];k[i+4>>2]=k[e+4>>2];_ta(m,l,c,j,i,f,g);r=h;return}function Bj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0.0,m=0.0,n=0.0,p=0.0,q=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0;t=r;r=r+80|0;s=t+16|0;c=t;n=+o[a>>2];p=+o[a+4>>2];q=+o[a+8>>2];m=+o[a+12>>2];l=+o[a+16>>2];a=c+4|0;j=c+4+4|0;k[j>>2]=0;k[j+4>>2]=0;k[c>>2]=33619968;k[a>>2]=b;c2(c,4,2,5,-1,0,0);do if((k[c>>2]&2031616|0)==65536){e=k[a>>2]|0;k[s>>2]=k[e>>2];h=s+4|0;a=e+4|0;k[h>>2]=k[a>>2];g=s+8|0;k[g>>2]=k[e+8>>2];k[s+12>>2]=k[e+12>>2];i=s+16|0;k[i>>2]=k[e+16>>2];k[s+20>>2]=k[e+20>>2];k[s+24>>2]=k[e+24>>2];k[s+28>>2]=k[e+28>>2];k[s+32>>2]=k[e+32>>2];c=s+36|0;b=k[e+36>>2]|0;k[c>>2]=b;d=s+40|0;k[d>>2]=g;g=s+48|0;j=s+44|0;k[j>>2]=g;k[s+52>>2]=0;k[g>>2]=0;if(b|0){g=b+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[a>>2]|0)<3){e=k[e+44>>2]|0;d=k[j>>2]|0;k[d>>2]=k[e>>2];k[d+4>>2]=k[e+4>>2];d=i;e=j;break}k[h>>2]=0;x1(s,k[a>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[e+40>>2]|0;f=k[d>>2]|0;b=k[e+44>>2]|0;d=k[j>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[g+(a<<2)>>2];k[d+(a<<2)>>2]=k[b+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0));d=i;e=j}else{d=i;e=j}}else{Q1(s,c,-1);d=s+16|0;e=s+44|0;c=s+36|0}while(0);a=k[d>>2]|0;l=l*3.141592653589793/180.0;v=+S(+l)*.5;l=+T(+l)*.5;x=l*m;w=v*q;u=n-x-w;o[a>>2]=u;v=v*m;q=l*q;l=p+v-q;o[a+4>>2]=l;m=n+x-w;o[a+8>>2]=m;q=p-v-q;o[a+12>>2]=q;n=n*2.0;o[a+16>>2]=n-u;p=p*2.0;o[a+20>>2]=p-l;o[a+24>>2]=n-m;o[a+28>>2]=p-q;a=k[c>>2]|0;if(a|0?(i=a+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[s+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;c=s+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){b=k[s+40>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[e>>2]|0;if((a|0)==(s+48|0)|(a|0)==0){r=t;return}ggb(k[a+-4>>2]|0);r=t;return}function Cj(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0;i=r;r=r+48|0;m=i+24|0;l=i+8|0;j=i;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;a=l+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[l>>2]=33882112;k[l+4>>2]=b;k[j>>2]=k[c>>2];k[j+4>>2]=k[c+4>>2];h=C6a(m,l,j,d,e,f,g,h)|0;r=i;return h|0}function Dj(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,n=0,q=0.0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;na=r;r=r+4240|0;X=na+2176|0;W=na+1920|0;ka=na+1864|0;ea=na+1848|0;da=na+1836|0;ba=na+1824|0;O=na+1816|0;M=na+1808|0;ca=na+1752|0;ma=na+1664|0;la=na+1592|0;H=na+1464|0;ja=na;E=na+1736|0;J=na+1720|0;N=na+1648|0;k[E+8>>2]=0;k[E+12>>2]=0;k[E>>2]=17104896;k[E+4>>2]=a;k[J+8>>2]=0;k[J+12>>2]=0;k[J>>2]=16842752;I=J+4|0;k[I>>2]=c;L=N+4|0;t=N+4+4|0;k[t>>2]=0;k[t+4>>2]=0;k[N>>2]=33619968;k[L>>2]=d;k[ma>>2]=k[c>>2];t=ma+4|0;d=c+4|0;a=k[d>>2]|0;k[t>>2]=a;ia=ma+8|0;k[ia>>2]=k[c+8>>2];k[ma+12>>2]=k[c+12>>2];k[ma+16>>2]=k[c+16>>2];k[ma+20>>2]=k[c+20>>2];k[ma+24>>2]=k[c+24>>2];k[ma+28>>2]=k[c+28>>2];k[ma+32>>2]=k[c+32>>2];g=k[c+36>>2]|0;k[ma+36>>2]=g;h=ma+40|0;k[h>>2]=ia;ia=ma+48|0;s=ma+44|0;k[s>>2]=ia;k[ma+52>>2]=0;k[ia>>2]=0;if(g){a=g+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[d>>2]|0}if((a|0)>=3){k[t>>2]=0;x1(ma,a,0,0,0);if((k[t>>2]|0)>0){n=k[c+40>>2]|0;h=k[h>>2]|0;g=k[c+44>>2]|0;d=k[s>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[n+(a<<2)>>2];k[d+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[t>>2]|0))}}else{ha=k[c+44>>2]|0;ia=k[s>>2]|0;k[ia>>2]=k[ha>>2];k[ia+4>>2]=k[ha+4>>2]}k[la>>2]=1124007936;ha=la+4|0;x=la+8|0;fa=la+40|0;B=ha;C=B+36|0;do{k[B>>2]=0;B=B+4|0}while((B|0)<(C|0));k[fa>>2]=x;ia=la+48|0;ga=la+44|0;k[ga>>2]=ia;k[la+52>>2]=0;k[ia>>2]=0;a=k[ma>>2]|0;$=a>>>3&511;g=$+1|0;if($){if(!(a&16384)){k[X>>2]=0;a=X+4|0;k[a>>2]=0;d=ZT(24)|0;k[d>>2]=1;B=d+4|0;k[X>>2]=B;k[a>>2]=17;i[d+21>>0]=0;z=334518;C=B+17|0;do{i[B>>0]=i[z>>0]|0;B=B+1|0;z=z+1|0}while((B|0)<(C|0));Y8(-215,X,334502,333645,2300);k[a>>2]=0;k[X>>2]=0;$=k[d>>2]|0;k[d>>2]=$+-1;if(($|0)==1)ggb(k[d+-4>>2]|0);a=k[ma>>2]|0}n=k[ma+4>>2]|0;upb(X|0,k[ma+40>>2]|0,n<<2|0)|0;k[X+(n<<2)>>2]=g;n=n+1|0;d=a&7;g=k[ma+16>>2]|0;w=W+4|0;a=W+8|0;c=W+16|0;h=W+20|0;t=W+40|0;B=w;C=B+36|0;do{k[B>>2]=0;B=B+4|0}while((B|0)<(C|0));k[t>>2]=a;v=W+48|0;s=W+44|0;k[s>>2]=v;k[W+52>>2]=0;k[v>>2]=0;k[W>>2]=d|1124007936;k[c>>2]=g;k[h>>2]=g;x1(W,n,X,0,1);y1(W);KG(la,W)|0;g=W+36|0;a=k[g>>2]|0;if(a|0?(_=a+12|0,$=k[_>>2]|0,k[_>>2]=$+-1,($|0)==1):0){d=k[g>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[W+32>>2]|0;if(!a){a=B1()|0;d=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[g>>2]=0}k[g>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[w>>2]|0)>0){d=k[t>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[s>>2]|0;if(!((a|0)==(v|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else KG(la,ma)|0;a=(k[x>>2]|0)==1;d=(k[la+12>>2]|0)==1;n=a|d;s=k[ha>>2]|0;t=(k[e+4>>2]|0)-(k[e>>2]|0)|0;A=t>>2;c=(k[b+4>>2]|0)-(k[b>>2]|0)>>2;K=F2(E)|0;v=(K|0)>0;if(!v){k[X>>2]=0;g=X+4|0;k[g>>2]=0;h=ZT(16)|0;k[h>>2]=1;B=h+4|0;k[X>>2]=B;k[g>>2]=11;i[h+15>>0]=0;z=334536;C=B+11|0;do{i[B>>0]=i[z>>0]|0;B=B+1|0;z=z+1|0}while((B|0)<(C|0));Y8(-215,X,334502,333645,2313);k[g>>2]=0;k[X>>2]=0;$=k[h>>2]|0;k[h>>2]=$+-1;if(($|0)==1)ggb(k[h+-4>>2]|0)}do if((A|0)!=(s<<1|0)?(A|0)!=2|(a|d)^1:0){if((A|0)==0?((S1(E,0)|0)&7|0)==0:0)break;k[X>>2]=0;a=X+4|0;k[a>>2]=0;d=ZT(84)|0;k[d>>2]=1;B=d+4|0;k[X>>2]=B;k[a>>2]=76;i[d+80>>0]=0;z=334548;C=B+76|0;do{i[B>>0]=i[z>>0]|0;B=B+1|0;z=z+1|0}while((B|0)<(C|0));Y8(-215,X,334502,333645,2314);k[a>>2]=0;k[X>>2]=0;$=k[d>>2]|0;k[d>>2]=$+-1;if(($|0)==1)ggb(k[d+-4>>2]|0)}while(0);x=(c|0)==0;if(!(x|(c|0)==(s|0))?(c|0)!=1|n^1:0){k[X>>2]=0;a=X+4|0;k[a>>2]=0;d=ZT(52)|0;k[d>>2]=1;B=d+4|0;k[X>>2]=B;k[a>>2]=44;i[d+48>>0]=0;z=334625;C=B+44|0;do{i[B>>0]=i[z>>0]|0;B=B+1|0;z=z+1|0}while((B|0)<(C|0));Y8(-215,X,334502,333645,2315);k[a>>2]=0;k[X>>2]=0;$=k[d>>2]|0;k[d>>2]=$+-1;if(($|0)==1)ggb(k[d+-4>>2]|0)}if((t|0)>0?(D=(A|0)/2|0,(t|0)>4):0){d=k[e>>2]|0;a=0;do{k[H+(a<<2)>>2]=d+(a<<1<<2);a=a+1|0}while((a|0)<(D|0))}NV(ja,K);a=k[ja>>2]|0;if(v){h=X+4|0;n=X+16|0;s=X+36|0;c=X+40|0;t=X+48|0;v=X+44|0;w=X+32|0;g=0;do{Q1(X,E,g);KG(a+(g*56|0)|0,X)|0;a=k[s>>2]|0;if(a|0?(_=a+12|0,$=k[_>>2]|0,k[_>>2]=$+-1,($|0)==1):0){d=k[s>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[w>>2]|0;if(!a){a=B1()|0;d=k[s>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[s>>2]=0}k[s>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[h>>2]|0)>0){d=k[c>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[v>>2]|0;if(!((a|0)==(t|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=g+1|0;a=k[ja>>2]|0}while((g|0)<(K|0));e=a}else e=a;x=x?0:k[b>>2]|0;E=A|0?H:0;do if((k[J>>2]&2031616|0)==65536){h=k[I>>2]|0;k[ka>>2]=k[h>>2];t=ka+4|0;a=h+4|0;k[t>>2]=k[a>>2];$=ka+8|0;k[$>>2]=k[h+8>>2];k[ka+12>>2]=k[h+12>>2];k[ka+16>>2]=k[h+16>>2];k[ka+20>>2]=k[h+20>>2];k[ka+24>>2]=k[h+24>>2];k[ka+28>>2]=k[h+28>>2];k[ka+32>>2]=k[h+32>>2];d=k[h+36>>2]|0;k[ka+36>>2]=d;g=ka+40|0;k[g>>2]=$;$=ka+48|0;s=ka+44|0;k[s>>2]=$;k[ka+52>>2]=0;k[$>>2]=0;if(d|0){$=d+12|0;k[$>>2]=(k[$>>2]|0)+1}if((k[a>>2]|0)<3){_=k[h+44>>2]|0;$=k[s>>2]|0;k[$>>2]=k[_>>2];k[$+4>>2]=k[_+4>>2];break}k[t>>2]=0;x1(ka,k[a>>2]|0,0,0,0);if((k[t>>2]|0)>0){c=k[h+40>>2]|0;n=k[g>>2]|0;g=k[h+44>>2]|0;d=k[s>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[c+(a<<2)>>2];k[d+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[t>>2]|0))}}else{Q1(ka,J,-1);t=ka+4|0}while(0);k[ea>>2]=0;$=ea+4|0;k[$>>2]=0;k[ea+8>>2]=0;k[da>>2]=0;_=da+4|0;k[_>>2]=0;k[da+8>>2]=0;k[ba>>2]=0;Z=ba+4|0;k[Z>>2]=0;k[ba+8>>2]=0;k[O>>2]=0;w=O+4|0;k[w>>2]=0;h=k[t>>2]|0;if((h|0)!=2)if((h|0)>0){n=h;D=76}else{g=0;D=82}else{n=(k[(k[ka+40>>2]|0)+4>>2]|0)==1?1:2;D=76}if((D|0)==76)if(k[ka+16>>2]|0){if((h|0)<3)a=aa(k[ka+12>>2]|0,k[ka+8>>2]|0)|0;else{g=k[ka+40>>2]|0;d=0;a=1;do{a=aa(k[g+(d<<2)>>2]|0,a)|0;d=d+1|0}while((d|0)!=(h|0))}if(a){H=1;b=n}else{g=1;h=n;D=82}}else{g=1;h=n;D=82}if((D|0)==82){k[X>>2]=0;a=X+4|0;k[a>>2]=0;d=ZT(32)|0;k[d>>2]=1;B=d+4|0;k[X>>2]=B;k[a>>2]=25;i[d+29>>0]=0;z=334476;C=B+25|0;do{i[B>>0]=i[z>>0]|0;B=B+1|0;z=z+1|0}while((B|0)<(C|0));Y8(-215,X,334502,333645,1950);k[a>>2]=0;k[X>>2]=0;Y=k[d>>2]|0;k[d>>2]=Y+-1;if((Y|0)==1)ggb(k[d+-4>>2]|0);H=g;b=h}V=k[e+40>>2]|0;Y=k[V>>2]|0;k[M>>2]=k[V+4>>2];k[M+4>>2]=Y;x2(N,M,k[e>>2]&7,0);do if((k[N>>2]&2031616|0)==65536){h=k[L>>2]|0;k[ca>>2]=k[h>>2];v=ca+4|0;a=h+4|0;k[v>>2]=k[a>>2];Y=ca+8|0;k[Y>>2]=k[h+8>>2];k[ca+12>>2]=k[h+12>>2];k[ca+16>>2]=k[h+16>>2];k[ca+20>>2]=k[h+20>>2];k[ca+24>>2]=k[h+24>>2];k[ca+28>>2]=k[h+28>>2];k[ca+32>>2]=k[h+32>>2];d=k[h+36>>2]|0;k[ca+36>>2]=d;g=ca+40|0;k[g>>2]=Y;Y=ca+48|0;s=ca+44|0;k[s>>2]=Y;k[ca+52>>2]=0;k[Y>>2]=0;if(d|0){Y=d+12|0;k[Y>>2]=(k[Y>>2]|0)+1}if((k[a>>2]|0)<3){V=k[h+44>>2]|0;Y=k[s>>2]|0;k[Y>>2]=k[V>>2];k[Y+4>>2]=k[V+4>>2];break}k[v>>2]=0;x1(ca,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){c=k[h+40>>2]|0;n=k[g>>2]|0;g=k[h+44>>2]|0;d=k[s>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[c+(a<<2)>>2];k[d+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(ca,N,-1);while(0);Y=ka+40|0;zla(e,K,x,ca,b,k[Y>>2]|0,E,ea,da,O,ba);C=k[ba>>2]|0;switch(k[e>>2]&7){case 0:{N=k[O>>2]|0;s=k[w>>2]|0;J=k[ea>>2]|0;I=k[da>>2]|0;L=k[ka+16>>2]|0;n=k[J+(b<<2)>>2]|0;M=k[I+((b<<1|1)<<2)>>2]|0;k[X>>2]=0;O=X+4|0;k[O>>2]=0;k[X+8>>2]=0;k[W>>2]=1123876864;k[W+4>>2]=0;Ala(ka,W,b,C,X);K=k[X>>2]|0;switch(b|0){case 1:{A=k[I>>2]|0;B=k[I+4>>2]|0;zpb(W|0,0,256)|0;a=k[J>>2]|0;g=0;do{d=k[K+(g<<2)>>2]|0;if(d>>>0<1073741824){q=f*+o[L+d>>2];d=(o[u>>2]=q,k[u>>2]|0);if((d&2130706432)>>>0<=1249902592){d=(d|0)<0;q=d?q+-8388608.0+8388608.0:q+8388608.0+-8388608.0;if(q==0.0)q=d?-0.0:0.0}V=~~q;i[W+g>>0]=V>>>0<256?V:(V|0)>0?255:0}g=g+1|0}while((g|0)!=256);h=s+-1|0;a:do if(s|0){x=A<<1;d=(N|0)<4;z=N+-4|0;if((A|0)==1){if(d){s=(N|0)>0;while(1){if(s){d=0;g=a;while(1){i[n+d>>0]=i[W+(l[g>>0]|0)>>0]|0;d=d+1|0;if((d|0)==(N|0))break;else g=g+1|0}a=a+N|0}if(!h)break a;else{n=n+M|0;a=a+B|0;h=h+-1|0}}}s=N&-4;c=(s|0)<(N|0);while(1){g=0;d=a;while(1){U=g|1;V=i[W+(l[a+U>>0]|0)>>0]|0;i[n+g>>0]=i[W+(l[d>>0]|0)>>0]|0;i[n+U>>0]=V;U=g|2;d=g|3;V=i[W+(l[a+d>>0]|0)>>0]|0;i[n+U>>0]=i[W+(l[a+U>>0]|0)>>0]|0;i[n+d>>0]=V;d=g+4|0;if((d|0)>(z|0))break;else{g=d;d=a+d|0}}if(c){d=s;g=a+s|0;while(1){i[n+d>>0]=i[W+(l[g>>0]|0)>>0]|0;d=d+1|0;if((d|0)==(N|0)){d=N;break}else g=g+1|0}}else d=s;if(!h)break;else{n=n+M|0;a=a+d+B|0;h=h+-1|0}}}else{if(d){s=aa(A,N)|0;c=(N|0)>0;while(1){if(c){d=0;g=a;while(1){i[n+d>>0]=i[W+(l[g>>0]|0)>>0]|0;d=d+1|0;if((d|0)==(N|0))break;else g=g+A|0}a=a+s|0}if(!h)break a;else{n=n+M|0;a=a+B|0;h=h+-1|0}}}s=N&-4;c=aa(A,s)|0;v=aa(N,A)|0;w=(s|0)<(N|0);while(1){g=0;d=a;while(1){V=i[W+(l[d+A>>0]|0)>>0]|0;i[n+g>>0]=i[W+(l[d>>0]|0)>>0]|0;i[n+(g|1)>>0]=V;d=d+x|0;V=i[W+(l[d+A>>0]|0)>>0]|0;i[n+(g|2)>>0]=i[W+(l[d>>0]|0)>>0]|0;i[n+(g|3)>>0]=V;g=g+4|0;if((g|0)>(z|0))break;else d=d+x|0}if(w){d=s;g=a+c|0;while(1){i[n+d>>0]=i[W+(l[g>>0]|0)>>0]|0;d=d+1|0;if((d|0)==(N|0)){d=v;break}else g=g+A|0}}else d=c;if(!h)break;else{n=n+M|0;a=a+d+B|0;h=h+-1|0}}}}while(0);break}case 2:{A=k[I>>2]|0;B=k[I+4>>2]|0;C=k[I+8>>2]|0;w=k[I+12>>2]|0;if((s|0)!=0&(N|0)>0){x=aa(A,N)|0;z=aa(C,N)|0;v=k[J>>2]|0;c=k[J+4>>2]|0;while(1){d=v;g=c;h=0;while(1){a=(k[K+((l[g>>0]|0|256)<<2)>>2]|0)+(k[K+((l[d>>0]|0)<<2)>>2]|0)|0;if(a>>>0<1073741824){q=f*+o[L+a>>2];a=(o[u>>2]=q,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;q=a?q+-8388608.0+8388608.0:q+8388608.0+-8388608.0;if(!(q==0.0))break;q=a?-0.0:0.0}while(0);a=~~q;a=(a>>>0<256?a:(a|0)>0?255:0)&255}else a=0;i[n+h>>0]=a;h=h+1|0;if((h|0)==(N|0))break;else{d=d+A|0;g=g+C|0}}s=s+-1|0;if(!s)break;else{v=v+x+B|0;c=c+z+w|0;n=n+M|0}}}break}case 3:{e=k[I>>2]|0;D=k[I+4>>2]|0;E=k[I+8>>2]|0;b=k[I+12>>2]|0;H=k[I+16>>2]|0;z=k[I+20>>2]|0;if((s|0)!=0&(N|0)>0){A=aa(e,N)|0;B=aa(E,N)|0;C=aa(H,N)|0;w=k[J+8>>2]|0;x=k[J+4>>2]|0;v=k[J>>2]|0;while(1){s=s+-1|0;d=w;g=x;h=v;c=0;while(1){a=(k[K+((l[g>>0]|0|256)<<2)>>2]|0)+(k[K+((l[h>>0]|0)<<2)>>2]|0)+(k[K+((l[d>>0]|0|512)<<2)>>2]|0)|0;if(a>>>0<1073741824){q=f*+o[L+a>>2];a=(o[u>>2]=q,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;q=a?q+-8388608.0+8388608.0:q+8388608.0+-8388608.0;if(!(q==0.0))break;q=a?-0.0:0.0}while(0);a=~~q;a=(a>>>0<256?a:(a|0)>0?255:0)&255}else a=0;i[n+c>>0]=a;c=c+1|0;if((c|0)==(N|0))break;else{d=d+H|0;g=g+E|0;h=h+e|0}}if(!s)break;else{w=w+C+z|0;x=x+B+b|0;v=v+A+D|0;n=n+M|0}}}break}default:if(s|0){z=(b|0)==0;A=(N|0)>0;x=n;v=s;w=0;while(1){a=n+(aa(M,w)|0)|0;v=v+-1|0;b:do if(A){if(H)c=0;else{if(z)d=0;else{zpb(a|0,0,N|0)|0;break}while(1){q=f*+o[L>>2];a=(o[u>>2]=q,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;q=a?q+-8388608.0+8388608.0:q+8388608.0+-8388608.0;if(!(q==0.0))break;q=a?-0.0:0.0}while(0);W=~~q;i[x+d>>0]=W>>>0<256?W:(W|0)>0?255:0;d=d+1|0;if((d|0)==(N|0)){D=173;break b}}}do{d=L;a=0;do{h=J+(a<<2)|0;s=k[h>>2]|0;g=k[K+((l[s>>0]|0|a<<8)<<2)>>2]|0;if(g>>>0>1073741823)break;d=d+g|0;k[h>>2]=s+(k[I+(a<<1<<2)>>2]|0);a=a+1|0}while((a|0)<(b|0));do if((a|0)==(b|0)){q=f*+o[d>>2];a=(o[u>>2]=q,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;q=a?q+-8388608.0+8388608.0:q+8388608.0+-8388608.0;if(!(q==0.0))break;q=a?-0.0:0.0}while(0);W=~~q;i[x+c>>0]=W>>>0<256?W:(W|0)>0?255:0}else{i[x+c>>0]=0;if((a|0)>=(b|0))break;do{W=J+(a<<2)|0;k[W>>2]=(k[W>>2]|0)+(k[I+(a<<1<<2)>>2]|0);a=a+1|0}while((a|0)!=(b|0))}while(0);c=c+1|0}while((c|0)!=(N|0));D=173}else D=173;while(0);if((D|0)==173?(D=0,H):0){a=0;do{W=J+(a<<2)|0;k[W>>2]=(k[W>>2]|0)+(k[I+((a<<1|1)<<2)>>2]|0);a=a+1|0}while((a|0)!=(b|0))}if(!v)break;else{x=x+M|0;w=w+1|0}}}}a=k[X>>2]|0;d=a;if(a|0){g=k[O>>2]|0;if((g|0)!=(a|0))k[O>>2]=g+(~((g+-4-d|0)>>>2)<<2);ggb(a)}break}case 2:{V=k[O>>2]|0;h=k[w>>2]|0;S=f;R=k[ea>>2]|0;B=k[da>>2]|0;T=k[ka+16>>2]|0;s=k[R+(b<<2)>>2]|0;U=k[B+((b<<1|1)<<2)>>2]|0;if(H){N=k[ka+44>>2]|0;O=b<<2;upb(X|0,k[Y>>2]|0,O|0)|0;upb(W|0,N|0,O|0)|0}switch(b|0){case 1:{y=+p[C>>3];f=+p[C+8>>3];w=k[X>>2]|0;x=k[B>>2]|0;c=k[B+4>>2]|0;if(h|0?(V|0)>0:0){v=aa(V,x)|0;n=k[R>>2]|0;while(1){d=0;g=n;while(1){Q=f+y*+(m[g>>1]|0);a=~~Q;a=a-(+(a|0)>Q&1)|0;if(a>>>0<w>>>0){q=S*+o[T+(a<<2)>>2];a=(o[u>>2]=q,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;q=a?q+-8388608.0+8388608.0:q+8388608.0+-8388608.0;if(!(q==0.0))break;q=a?-0.0:0.0}while(0);a=~~q;a=(a>>>0<65536?a:(a|0)>0?65535:0)&65535}else a=0;j[s+(d<<1)>>1]=a;d=d+1|0;if((d|0)==(V|0))break;else g=g+(x<<1)|0}h=h+-1|0;if(!h)break;else{s=s+(U<<1)|0;n=n+(v<<1)+(c<<1)|0}}}break}case 2:{y=+p[C>>3];F=+p[C+8>>3];G=+p[C+16>>3];f=+p[C+24>>3];b=k[X>>2]|0;C=k[X+4>>2]|0;e=k[B>>2]|0;D=k[B+4>>2]|0;E=k[B+8>>2]|0;B=k[B+12>>2]|0;x=k[W>>2]|0;if((V|0)>0&(h|0)!=0){z=aa(V,e)|0;A=aa(V,E)|0;w=k[R>>2]|0;v=k[R+4>>2]|0;while(1){g=0;n=w;c=v;while(1){Q=F+y*+(m[n>>1]|0);a=~~Q;a=a-(+(a|0)>Q&1)|0;Q=f+G*+(m[c>>1]|0);d=~~Q;d=d-(+(d|0)>Q&1)|0;if(a>>>0<b>>>0&d>>>0<C>>>0){a=T+(aa(a,x)|0)+(d<<2)|0;q=S*+o[a>>2];a=(o[u>>2]=q,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;q=a?q+-8388608.0+8388608.0:q+8388608.0+-8388608.0;if(!(q==0.0))break;q=a?-0.0:0.0}while(0);a=~~q;a=(a>>>0<65536?a:(a|0)>0?65535:0)&65535}else a=0;j[s+(g<<1)>>1]=a;g=g+1|0;if((g|0)==(V|0))break;else{n=n+(e<<1)|0;c=c+(E<<1)|0}}h=h+-1|0;if(!h)break;else{w=w+(z<<1)+(D<<1)|0;v=v+(A<<1)+(B<<1)|0;s=s+(U<<1)|0}}}break}case 3:{y=+p[C>>3];F=+p[C+8>>3];G=+p[C+16>>3];P=+p[C+24>>3];Q=+p[C+32>>3];f=+p[C+40>>3];N=k[X>>2]|0;O=k[X+4>>2]|0;L=k[X+8>>2]|0;M=k[B>>2]|0;H=k[B+4>>2]|0;I=k[B+8>>2]|0;J=k[B+12>>2]|0;K=k[B+16>>2]|0;E=k[B+20>>2]|0;b=k[W>>2]|0;B=k[W+4>>2]|0;if((V|0)>0&(h|0)!=0){C=aa(V,M)|0;e=aa(V,I)|0;D=aa(V,K)|0;z=k[R>>2]|0;A=k[R+8>>2]|0;x=k[R+4>>2]|0;while(1){h=h+-1|0;n=z;c=A;v=x;w=0;while(1){q=F+y*+(m[n>>1]|0);a=~~q;a=a-(+(a|0)>q&1)|0;q=P+G*+(m[v>>1]|0);d=~~q;d=d-(+(d|0)>q&1)|0;q=f+Q*+(m[c>>1]|0);g=~~q;g=g-(+(g|0)>q&1)|0;if(a>>>0<N>>>0&d>>>0<O>>>0&g>>>0<L>>>0){a=T+(aa(a,b)|0)+(aa(d,B)|0)+(g<<2)|0;q=S*+o[a>>2];a=(o[u>>2]=q,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;q=a?q+-8388608.0+8388608.0:q+8388608.0+-8388608.0;if(!(q==0.0))break;q=a?-0.0:0.0}while(0);a=~~q;a=(a>>>0<65536?a:(a|0)>0?65535:0)&65535}else a=0;j[s+(w<<1)>>1]=a;w=w+1|0;if((w|0)==(V|0))break;else{n=n+(M<<1)|0;c=c+(K<<1)|0;v=v+(I<<1)|0}}if(!h)break;else{z=z+(C<<1)+(H<<1)|0;A=A+(D<<1)+(E<<1)|0;x=x+(e<<1)+(J<<1)|0;s=s+(U<<1)|0}}}break}default:if(h|0){z=(E|0)==0;A=(V|0)>0;x=s;while(1){h=h+-1|0;if(A){w=0;do{c:do if(H){if(z){d=T;a=0;while(1){g=R+(a<<2)|0;n=k[g>>2]|0;s=a<<1;Q=+(m[n>>1]|0)*+p[C+(s<<3)>>3]+ +p[C+((s|1)<<3)>>3];c=~~Q;c=c-(+(c|0)>Q&1)|0;if(c>>>0>=(k[X+(a<<2)>>2]|0)>>>0)break c;k[g>>2]=n+(k[B+(s<<2)>>2]<<1);d=d+(aa(k[W+(a<<2)>>2]|0,c)|0)|0;a=a+1|0;if((a|0)>=(b|0))break c}}else{d=T;a=0}do{g=R+(a<<2)|0;n=k[g>>2]|0;s=j[n>>1]|0;c=a<<1;Q=+(s&65535)*+p[C+(c<<3)>>3]+ +p[C+((c|1)<<3)>>3];v=~~Q;v=v-(+(v|0)>Q&1)|0;if(v>>>0>=(k[X+(a<<2)>>2]|0)>>>0)break c;if(+(s&65535)>=+o[(k[E+(a<<2)>>2]|0)+4>>2])break c;k[g>>2]=n+(k[B+(c<<2)>>2]<<1);d=d+(aa(k[W+(a<<2)>>2]|0,v)|0)|0;a=a+1|0}while((a|0)<(b|0))}else{d=T;a=0}while(0);do if((a|0)==(b|0)){q=S*+o[d>>2];a=(o[u>>2]=q,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;q=a?q+-8388608.0+8388608.0:q+8388608.0+-8388608.0;if(!(q==0.0))break;q=a?-0.0:0.0}while(0);O=~~q;j[x+(w<<1)>>1]=O>>>0<65536?O:(O|0)>0?65535:0}else{j[x+(w<<1)>>1]=0;if((a|0)>=(b|0))break;do{O=R+(a<<2)|0;k[O>>2]=(k[O>>2]|0)+(k[B+(a<<1<<2)>>2]<<1);a=a+1|0}while((a|0)!=(b|0))}while(0);w=w+1|0}while((w|0)!=(V|0))}if(H){a=0;do{O=R+(a<<2)|0;k[O>>2]=(k[O>>2]|0)+(k[B+((a<<1|1)<<2)>>2]<<1);a=a+1|0}while((a|0)!=(b|0))}if(!h)break;else x=x+(U<<1)|0}}}break}case 5:{V=k[O>>2]|0;h=k[w>>2]|0;S=f;R=k[ea>>2]|0;A=k[da>>2]|0;T=k[ka+16>>2]|0;s=k[R+(b<<2)>>2]|0;U=k[A+((b<<1|1)<<2)>>2]|0;if(H){N=k[ka+44>>2]|0;O=b<<2;upb(X|0,k[Y>>2]|0,O|0)|0;upb(W|0,N|0,O|0)|0}switch(b|0){case 1:{y=+p[C>>3];f=+p[C+8>>3];w=k[X>>2]|0;x=k[A>>2]|0;c=k[A+4>>2]|0;if(h|0?(V|0)>0:0){v=aa(V,x)|0;n=k[R>>2]|0;while(1){d=0;g=n;while(1){Q=f+y*+o[g>>2];a=~~Q;a=a-(+(a|0)>Q&1)|0;if(a>>>0<w>>>0)q=S*+o[T+(a<<2)>>2];else q=0.0;o[s+(d<<2)>>2]=q;d=d+1|0;if((d|0)==(V|0))break;else g=g+(x<<2)|0}h=h+-1|0;if(!h)break;else{s=s+(U<<2)|0;n=n+(v<<2)+(c<<2)|0}}}break}case 2:{y=+p[C>>3];F=+p[C+8>>3];G=+p[C+16>>3];f=+p[C+24>>3];b=k[X>>2]|0;C=k[X+4>>2]|0;e=k[A>>2]|0;D=k[A+4>>2]|0;E=k[A+8>>2]|0;B=k[A+12>>2]|0;x=k[W>>2]|0;if((V|0)>0&(h|0)!=0){z=aa(V,e)|0;A=aa(V,E)|0;w=k[R>>2]|0;v=k[R+4>>2]|0;while(1){g=0;n=w;c=v;while(1){Q=F+y*+o[n>>2];a=~~Q;a=a-(+(a|0)>Q&1)|0;Q=f+G*+o[c>>2];d=~~Q;d=d-(+(d|0)>Q&1)|0;if(a>>>0<b>>>0&d>>>0<C>>>0){X=T+(aa(a,x)|0)+(d<<2)|0;q=S*+o[X>>2]}else q=0.0;o[s+(g<<2)>>2]=q;g=g+1|0;if((g|0)==(V|0))break;else{n=n+(e<<2)|0;c=c+(E<<2)|0}}h=h+-1|0;if(!h)break;else{w=w+(z<<2)+(D<<2)|0;v=v+(A<<2)+(B<<2)|0;s=s+(U<<2)|0}}}break}case 3:{y=+p[C>>3];F=+p[C+8>>3];G=+p[C+16>>3];P=+p[C+24>>3];Q=+p[C+32>>3];f=+p[C+40>>3];N=k[X>>2]|0;O=k[X+4>>2]|0;H=k[X+8>>2]|0;I=k[A>>2]|0;J=k[A+4>>2]|0;K=k[A+8>>2]|0;L=k[A+12>>2]|0;M=k[A+16>>2]|0;E=k[A+20>>2]|0;b=k[W>>2]|0;B=k[W+4>>2]|0;if((V|0)>0&(h|0)!=0){C=aa(V,I)|0;e=aa(V,K)|0;D=aa(V,M)|0;z=k[R>>2]|0;A=k[R+8>>2]|0;x=k[R+4>>2]|0;while(1){h=h+-1|0;n=z;c=A;v=x;w=0;while(1){q=F+y*+o[n>>2];a=~~q;a=a-(+(a|0)>q&1)|0;q=P+G*+o[v>>2];d=~~q;d=d-(+(d|0)>q&1)|0;q=f+Q*+o[c>>2];g=~~q;g=g-(+(g|0)>q&1)|0;if(a>>>0<N>>>0&d>>>0<O>>>0&g>>>0<H>>>0){X=T+(aa(a,b)|0)+(aa(d,B)|0)+(g<<2)|0;q=S*+o[X>>2]}else q=0.0;o[s+(w<<2)>>2]=q;w=w+1|0;if((w|0)==(V|0))break;else{n=n+(I<<2)|0;c=c+(M<<2)|0;v=v+(K<<2)|0}}if(!h)break;else{z=z+(C<<2)+(J<<2)|0;A=A+(D<<2)+(E<<2)|0;x=x+(e<<2)+(L<<2)|0;s=s+(U<<2)|0}}}break}default:if(h|0){x=(E|0)==0;z=(V|0)>0;while(1){h=h+-1|0;if(z){w=0;do{d:do if(H){if(x){d=T;a=0;while(1){g=R+(a<<2)|0;n=k[g>>2]|0;c=a<<1;Q=+o[n>>2]*+p[C+(c<<3)>>3]+ +p[C+((c|1)<<3)>>3];v=~~Q;v=v-(+(v|0)>Q&1)|0;if(v>>>0>=(k[X+(a<<2)>>2]|0)>>>0)break d;k[g>>2]=n+(k[A+(c<<2)>>2]<<2);d=d+(aa(k[W+(a<<2)>>2]|0,v)|0)|0;a=a+1|0;if((a|0)>=(b|0))break d}}else{d=T;a=0}do{g=R+(a<<2)|0;n=k[g>>2]|0;q=+o[n>>2];c=a<<1;Q=q*+p[C+(c<<3)>>3]+ +p[C+((c|1)<<3)>>3];v=~~Q;v=v-(+(v|0)>Q&1)|0;if(v>>>0>=(k[X+(a<<2)>>2]|0)>>>0)break d;if(q>=+o[(k[E+(a<<2)>>2]|0)+4>>2])break d;k[g>>2]=n+(k[A+(c<<2)>>2]<<2);d=d+(aa(k[W+(a<<2)>>2]|0,v)|0)|0;a=a+1|0}while((a|0)<(b|0))}else{d=T;a=0}while(0);do if((a|0)==(b|0))o[s+(w<<2)>>2]=S*+o[d>>2];else{o[s+(w<<2)>>2]=0.0;if((a|0)>=(b|0))break;do{O=R+(a<<2)|0;k[O>>2]=(k[O>>2]|0)+(k[A+(a<<1<<2)>>2]<<2);a=a+1|0}while((a|0)!=(b|0))}while(0);w=w+1|0}while((w|0)!=(V|0))}if(H){a=0;do{O=R+(a<<2)|0;k[O>>2]=(k[O>>2]|0)+(k[A+((a<<1|1)<<2)>>2]<<2);a=a+1|0}while((a|0)!=(b|0))}if(!h)break;else s=s+(U<<2)|0}}}break}default:{k[X>>2]=0;W=X+4|0;k[W>>2]=0;a=ZT(8)|0;k[a>>2]=1;V=a+4|0;k[X>>2]=V;k[W>>2]=0;i[V>>0]=0;Y8(-210,X,334502,333645,1965);k[W>>2]=0;k[X>>2]=0;X=k[a>>2]|0;k[a>>2]=X+-1;if((X|0)==1)ggb(k[a+-4>>2]|0)}}g=ca+36|0;a=k[g>>2]|0;if(a|0?(W=a+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){d=k[g>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[ca+32>>2]|0;if(!a){a=B1()|0;d=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[g>>2]=0}k[g>>2]=0;X=ca+16|0;d=ca+4|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[d>>2]|0)>0){g=k[ca+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[ca+44>>2]|0;if(!((a|0)==(ca+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[ba>>2]|0;d=a;if(a|0){g=k[Z>>2]|0;if((g|0)!=(a|0))k[Z>>2]=g+(~((g+-8-d|0)>>>3)<<3);ggb(a)}a=k[da>>2]|0;d=a;if(a|0){g=k[_>>2]|0;if((g|0)!=(a|0))k[_>>2]=g+(~((g+-4-d|0)>>>2)<<2);ggb(a)}a=k[ea>>2]|0;d=a;if(a|0){g=k[$>>2]|0;if((g|0)!=(a|0))k[$>>2]=g+(~((g+-4-d|0)>>>2)<<2);ggb(a)}g=ka+36|0;a=k[g>>2]|0;if(a|0?(da=a+12|0,ea=k[da>>2]|0,k[da>>2]=ea+-1,(ea|0)==1):0){d=k[g>>2]|0;if(d|0){a=k[d+4>>2]|0;do if(!a){a=k[ka+32>>2]|0;if(a|0)break;a=B1()|0;d=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[g>>2]=0}k[g>>2]=0;ea=ka+16|0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[t>>2]|0)>0){d=k[Y>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[t>>2]|0))}a=k[ka+44>>2]|0;if(!((a|0)==(ka+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);OV(ja);g=la+36|0;a=k[g>>2]|0;do if(a|0){ja=a+12|0;ka=k[ja>>2]|0;k[ja>>2]=ka+-1;if((ka|0)!=1)break;d=k[g>>2]|0;if(d|0){a=k[d+4>>2]|0;do if(!a){a=k[la+32>>2]|0;if(a|0)break;a=B1()|0;d=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[g>>2]=0}while(0);k[g>>2]=0;la=la+16|0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[ha>>2]|0)>0){d=k[fa>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ha>>2]|0))}a=k[ga>>2]|0;if(!((a|0)==(ia|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=ma+36|0;a=k[g>>2]|0;do if(a|0){ka=a+12|0;la=k[ka>>2]|0;k[ka>>2]=la+-1;if((la|0)!=1)break;d=k[g>>2]|0;if(d|0){a=k[d+4>>2]|0;do if(!a){a=k[ma+32>>2]|0;if(a|0)break;a=B1()|0;d=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[g>>2]=0}while(0);k[g>>2]=0;la=ma+16|0;d=ma+4|0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[d>>2]|0)>0){g=k[ma+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[ma+44>>2]|0;if((a|0)==(ma+48|0)|(a|0)==0){r=na;return}ggb(k[a+-4>>2]|0);r=na;return}function Ej(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=r;r=r+48|0;i=f+32|0;h=f+16|0;g=f;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=a;a=h+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=b;b=g+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=50397184;k[g+4>>2]=c;Z_(i,h,g,d,e);r=f;return}function Fj(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+1696|0;z=B+1568|0;A=B+72|0;w=B;v=B+1552|0;x=B+1536|0;y=B+56|0;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=17104896;k[v+4>>2]=a;k[x+8>>2]=0;k[x+12>>2]=0;k[x>>2]=16842752;k[x+4>>2]=c;a=y+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[y>>2]=33619968;k[y+4>>2]=d;a=(k[e+4>>2]|0)-(k[e>>2]|0)|0;s=a>>2;j=(k[f+4>>2]|0)-(k[f>>2]|0)|0;t=j>>2;h=(k[b+4>>2]|0)-(k[b>>2]|0)>>2;u=F2(v)|0;o=(u|0)>0;if(!((a|0)>0&o)){k[z>>2]=0;c=z+4|0;k[c>>2]=0;d=ZT(28)|0;k[d>>2]=1;l=d+4|0;k[z>>2]=l;k[c>>2]=23;i[d+27>>0]=0;m=334372;n=l+23|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,z,334084,333645,1625);k[c>>2]=0;k[z>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}do if((t|0)!=(a>>1|0)){if((t|0)==0?((S1(v,0)|0)&7|0)==0:0)break;k[z>>2]=0;a=z+4|0;k[a>>2]=0;c=ZT(60)|0;k[c>>2]=1;l=c+4|0;k[z>>2]=l;k[a>>2]=55;i[c+59>>0]=0;m=334396;n=l+55|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,z,334084,333645,1626);k[a>>2]=0;k[z>>2]=0;q=k[c>>2]|0;k[c>>2]=q+-1;if((q|0)==1)ggb(k[c+-4>>2]|0)}while(0);q=(h|0)==0;if(!(q|(h|0)==(s|0))){k[z>>2]=0;a=z+4|0;k[a>>2]=0;c=ZT(28)|0;k[c>>2]=1;l=c+4|0;k[z>>2]=l;k[a>>2]=23;i[c+27>>0]=0;m=334452;n=l+23|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,z,334084,333645,1627);k[a>>2]=0;k[z>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)==1)ggb(k[c+-4>>2]|0)}if((j|0)>0?(p=(t|0)/2|0,(j|0)>4):0){c=k[f>>2]|0;a=0;do{k[z+(a<<2)>>2]=c+(a<<1<<2);a=a+1|0}while((a|0)<(p|0))}NV(A,u);a=k[A>>2]|0;if(!o){w=a;b=k[b>>2]|0;b=q?0:b;e=k[e>>2]|0;v=(t|0)!=0;z=v?z:0;yla(w,u,b,x,y,s,e,z,g);OV(A);r=B;return}h=w+4|0;j=w+16|0;l=w+36|0;m=w+40|0;n=w+48|0;o=w+44|0;f=w+32|0;d=0;do{Q1(w,v,d);KG(a+(d*56|0)|0,w)|0;a=k[l>>2]|0;if(a|0?(c=a+12|0,p=k[c>>2]|0,k[c>>2]=p+-1,(p|0)==1):0){c=k[l>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[f>>2]|0;if(!a){a=B1()|0;c=k[l>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[l>>2]=0}k[l>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[h>>2]|0)>0){c=k[m>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[o>>2]|0;if(!((a|0)==(n|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=d+1|0;a=k[A>>2]|0}while((d|0)<(u|0));b=k[b>>2]|0;b=q?0:b;e=k[e>>2]|0;w=(t|0)!=0;z=w?z:0;yla(a,u,b,x,y,s,e,z,g);OV(A);r=B;return}function Gj(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;j=+j;l=l|0;var m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,_=0,$=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0.0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0.0,me=0.0,ne=0.0,oe=0.0;he=r;r=r+7056|0;Fd=he+3192|0;Gd=he+2128|0;Hd=he+1064|0;Id=he;Jd=he+5992|0;Kd=he+4928|0;ge=he+4872|0;fe=he+4816|0;Ld=he+4808|0;ee=he+4752|0;ce=he+4680|0;be=he+4608|0;C=he+4600|0;Zd=he+4544|0;Nd=he+4536|0;Od=he+4528|0;Pd=he+4416|0;Qd=he+4360|0;Rd=he+4304|0;Sd=he+4296|0;Td=he+4288|0;v=he+4736|0;D=he+4664|0;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=16842752;w=v+4|0;k[w>>2]=b;B=D+4|0;t=D+4+4|0;k[t>>2]=0;k[t+4>>2]=0;k[D>>2]=50397184;k[B>>2]=c;k[ge>>2]=k[a>>2];t=ge+4|0;c=a+4|0;b=k[c>>2]|0;k[t>>2]=b;de=ge+8|0;k[de>>2]=k[a+8>>2];k[ge+12>>2]=k[a+12>>2];k[ge+16>>2]=k[a+16>>2];k[ge+20>>2]=k[a+20>>2];k[ge+24>>2]=k[a+24>>2];k[ge+28>>2]=k[a+28>>2];k[ge+32>>2]=k[a+32>>2];m=k[a+36>>2]|0;k[ge+36>>2]=m;n=ge+40|0;k[n>>2]=de;de=ge+48|0;s=ge+44|0;k[s>>2]=de;k[ge+52>>2]=0;k[de>>2]=0;if(m){b=m+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[t>>2]=0;x1(ge,b,0,0,0);if((k[t>>2]|0)>0){q=k[a+40>>2]|0;n=k[n>>2]|0;m=k[a+44>>2]|0;c=k[s>>2]|0;b=0;do{k[n+(b<<2)>>2]=k[q+(b<<2)>>2];k[c+(b<<2)>>2]=k[m+(b<<2)>>2];b=b+1|0}while((b|0)<(k[t>>2]|0))}}else{ae=k[a+44>>2]|0;de=k[s>>2]|0;k[de>>2]=k[ae>>2];k[de+4>>2]=k[ae+4>>2]}do if((k[v>>2]&2031616|0)==65536){m=k[w>>2]|0;k[fe>>2]=k[m>>2];a=fe+4|0;b=m+4|0;k[a>>2]=k[b>>2];de=fe+8|0;k[de>>2]=k[m+8>>2];k[fe+12>>2]=k[m+12>>2];k[fe+16>>2]=k[m+16>>2];k[fe+20>>2]=k[m+20>>2];k[fe+24>>2]=k[m+24>>2];k[fe+28>>2]=k[m+28>>2];k[fe+32>>2]=k[m+32>>2];c=k[m+36>>2]|0;k[fe+36>>2]=c;t=fe+40|0;k[t>>2]=de;de=fe+48|0;n=fe+44|0;k[n>>2]=de;k[fe+52>>2]=0;k[de>>2]=0;if(c|0){de=c+12|0;k[de>>2]=(k[de>>2]|0)+1}if((k[b>>2]|0)<3){ae=k[m+44>>2]|0;de=k[n>>2]|0;k[de>>2]=k[ae>>2];k[de+4>>2]=k[ae+4>>2];break}k[a>>2]=0;x1(fe,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){q=k[m+40>>2]|0;s=k[t>>2]|0;m=k[m+44>>2]|0;c=k[n>>2]|0;b=0;do{k[s+(b<<2)>>2]=k[q+(b<<2)>>2];k[c+(b<<2)>>2]=k[m+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0))}}else{Q1(fe,v,-1);t=fe+40|0}while(0);k[Ld>>2]=ge;k[Ld+4>>2]=fe;k[ee>>2]=1124007936;_d=ee+4|0;zd=ee+8|0;Yd=ee+40|0;s=_d;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[Yd>>2]=zd;ae=ee+48|0;$d=ee+44|0;k[$d>>2]=ae;k[ee+52>>2]=0;k[ae>>2]=0;k[ce>>2]=1124007936;Vd=ce+4|0;Ad=ce+8|0;Md=ce+40|0;s=Vd;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[Md>>2]=Ad;Xd=ce+48|0;Wd=ce+44|0;k[Wd>>2]=Xd;k[ce+52>>2]=0;k[Xd>>2]=0;k[be>>2]=1124007936;Dd=be+4|0;b=be+8|0;Bd=be+40|0;s=Dd;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[Bd>>2]=b;Ed=be+48|0;Cd=be+44|0;k[Cd>>2]=Ed;k[be+52>>2]=0;k[Ed>>2]=0;de=ge+40|0;b=k[de>>2]|0;c=k[b+4>>2]|0;b=k[b>>2]|0;yd=k[t>>2]|0;if(!((((b|0)==(k[yd>>2]|0)?(c|0)==(k[yd+4>>2]|0):0)?(A=(k[ge>>2]|0)>>>3&511,(A|0)==((k[fe>>2]|0)>>>3&511|0)):0)?d<1.0&(A|0)==0:0)){k[Fd>>2]=0;b=Fd+4|0;k[b>>2]=0;c=ZT(116)|0;k[c>>2]=1;s=c+4|0;k[Fd>>2]=s;k[b>>2]=110;i[c+114>>0]=0;q=404546;a=s+110|0;do{i[s>>0]=i[q>>0]|0;s=s+1|0;q=q+1|0}while((s|0)<(a|0));Y8(-215,Fd,404657,404682,1102);k[b>>2]=0;k[Fd>>2]=0;yd=k[c>>2]|0;k[c>>2]=yd+-1;if((yd|0)==1)ggb(k[c+-4>>2]|0);b=k[de>>2]|0;c=k[b+4>>2]|0;b=k[b>>2]|0}k[C>>2]=c;k[C+4>>2]=b;x2(D,C,13,0);do if((k[D>>2]&2031616|0)==65536){n=k[B>>2]|0;k[Zd>>2]=k[n>>2];v=Zd+4|0;b=n+4|0;k[v>>2]=k[b>>2];yd=Zd+8|0;k[yd>>2]=k[n+8>>2];k[Zd+12>>2]=k[n+12>>2];k[Zd+16>>2]=k[n+16>>2];k[Zd+20>>2]=k[n+20>>2];k[Zd+24>>2]=k[n+24>>2];k[Zd+28>>2]=k[n+28>>2];k[Zd+32>>2]=k[n+32>>2];c=k[n+36>>2]|0;k[Zd+36>>2]=c;m=Zd+40|0;k[m>>2]=yd;yd=Zd+48|0;s=Zd+44|0;k[s>>2]=yd;k[Zd+52>>2]=0;k[yd>>2]=0;if(c|0){yd=c+12|0;k[yd>>2]=(k[yd>>2]|0)+1}if((k[b>>2]|0)<3){xd=k[n+44>>2]|0;yd=k[s>>2]|0;k[yd>>2]=k[xd>>2];k[yd+4>>2]=k[xd+4>>2];break}k[v>>2]=0;x1(Zd,k[b>>2]|0,0,0,0);if((k[v>>2]|0)>0){a=k[n+40>>2]|0;q=k[m>>2]|0;m=k[n+44>>2]|0;c=k[s>>2]|0;b=0;do{k[q+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[m+(b<<2)>>2];b=b+1|0}while((b|0)<(k[v>>2]|0))}}else Q1(Zd,D,-1);while(0);if((e|0)>0){c=ge+8|0;m=ge+12|0;y=+(k[m>>2]|0);z=+(k[c>>2]|0);x=1.0;b=0;do{x=x*d;if(x*y<32.0|x*z<32.0)break;b=b+1|0}while((b|0)<(e|0));if((b|0)>-1)Ud=36}else{b=0;c=ge+8|0;m=ge+12|0;Ud=36}if((Ud|0)==36){Fc=ce+12|0;Gc=ce+16|0;Hc=Gd+4|0;Ic=ee+16|0;Jc=(l&4|0)==0;Kc=Fd+8|0;Lc=Fd+12|0;Mc=Fd+4|0;Nc=Gd+4|0;Oc=Nc+4|0;Pc=Nd+4|0;Qc=Fd+4|0;Rc=Qc+4|0;Sc=Qd+4|0;Tc=Qd+8|0;Uc=Qd+40|0;Vc=Qd+48|0;Wc=Qd+44|0;Xc=Qd+52|0;Yc=Rd+4|0;Zc=Rd+8|0;_c=Rd+40|0;$c=Rd+48|0;ad=Rd+44|0;bd=Rd+52|0;cd=Fd+4|0;dd=cd+4|0;ed=Fd+8|0;fd=Fd+12|0;gd=Fd+4|0;hd=Gd+4|0;id=hd+4|0;jd=Sd+4|0;kd=Fd+8|0;ld=Fd+12|0;md=Fd+4|0;nd=Gd+4|0;od=nd+4|0;pd=Td+4|0;qd=Qd+12|0;rd=(h*6|0)+3|0;sd=Jd+8|0;td=Jd+4|0;ud=rd>>>0>264;_=rd>>>0>1073741823?-1:rd<<2;vd=h<<1;wd=Kd+8|0;xd=Kd+4|0;yd=h*3|0;yc=j<1.1920928955078125e-07?+(h|0)*.3:j;ac=0-h|0;bc=(ac|0)>(h|0);cc=Fd+4|0;dc=Fd+8|0;ec=Fd+40|0;fc=Fd+48|0;gc=Fd+44|0;hc=Fd+52|0;ic=Gd+8|0;jc=Gd+12|0;kc=Gd+4|0;$b=Fd+16|0;lc=Gd+4|0;mc=Gd+8|0;nc=Gd+40|0;oc=Gd+48|0;pc=Gd+44|0;qc=Gd+52|0;rc=Gd+16|0;sc=Gd+36|0;tc=Fd+36|0;uc=Qd+16|0;vc=(h|0)<1;wc=(h|0)>0;xc=h+1|0;yc=yc*(yc*2.0);zc=Fd+4|0;Ac=Pd+56|0;Bc=(g|0)>0;Cc=Rd+36|0;Dc=Rd+16|0;Ec=Qd+36|0;ba=(l&256|0)==0;ca=g+-1|0;da=(f|0)/2|0;ea=1.0/+(aa(f,f)|0);fa=da<<1;ga=Fd+8|0;ha=Fd+4|0;ia=da*5|0;ja=ia+5|0;oa=da+2|0;ka=+(oa|0);la=(f|0)>3;ma=(ja|0)>0;na=+(oa|0);Ea=+(da|0)*.3;oa=Fd+8|0;pa=Fd+4|0;qa=Gd+8|0;ra=Gd+4|0;sa=qa;ta=ia+21|0;ua=Hd+8|0;va=Hd+4|0;wa=ta>>>0>264;$=ta>>>0>1073741823?-1:ta<<2;xa=fa|1;ya=Id+8|0;za=Id+4|0;Aa=xa>>>0>264;Y=xa>>>0>1073741823?-1:xa<<2;Ba=(f|0)<2;Ca=(f|0)<-1;Da=(ia|0)>0;Ea=Ea*(Ea*2.0);Fa=ee+12|0;Ga=Fd+8|0;Ha=Fd+12|0;Ia=Fd+4|0;Ja=Gd+4|0;Ka=Ja+4|0;La=Od+4|0;Ma=1.0/d;Na=Fd+4|0;Oa=Na+4|0;Pa=Pd+4|0;Qa=Pd+8|0;Ra=Pd+40|0;Sa=Pd+48|0;Ta=Pd+44|0;Ua=Pd+52|0;Va=Pd+56|0;Wa=Pd+60|0;Xa=Pd+64|0;Ya=Pd+96|0;Za=Pd+104|0;_a=Pd+100|0;$a=Pd+108|0;ab=Pd+92|0;bb=Pd+72|0;cb=Pd+36|0;db=Pd+16|0;eb=Gd+4|0;fb=Gd+8|0;gb=Gd+12|0;hb=Gd+16|0;ib=Gd+48|0;jb=Gd+56|0;kb=Gd+52|0;lb=Gd+60|0;mb=Gd+64|0;nb=Gd+68|0;ob=Gd+72|0;pb=Gd+104|0;qb=Gd+112|0;rb=Gd+108|0;sb=Gd+116|0;tb=Gd+120|0;ub=Gd+124|0;vb=Gd+128|0;wb=Gd+160|0;xb=Gd+168|0;yb=Gd+164|0;zb=Fd+4|0;_=(_|0)==0?1:_;Ab=Id+4|0;Bb=Id+8|0;Cb=Id+12|0;Db=Id+16|0;Eb=Id+48|0;Fb=Id+56|0;Gb=Id+52|0;Hb=Id+60|0;Ib=Id+64|0;Jb=Id+68|0;Kb=Id+72|0;Lb=Id+104|0;Mb=Id+112|0;Nb=Id+108|0;Ob=Id+116|0;Pb=Id+120|0;Qb=Id+124|0;Rb=Id+128|0;Sb=Id+160|0;Tb=Id+168|0;Ub=Id+164|0;Vb=Fd+32|0;Wb=Gd+32|0;Xb=Pd+32|0;Yb=Pd+88|0;Zb=Qd+32|0;_b=Rd+32|0;$=($|0)==0?1:$;Y=(Y|0)==0?1:Y;while(1){X=(b|0)>0;if(X){n=0;x=1.0;do{x=x*d;n=n+1|0}while((n|0)!=(b|0))}else x=1.0;W=(1.0/x+-1.0)*.5;y=W*5.0;p[u>>3]=y;n=k[u+4>>2]|0;V=n&2146435072;if(!(V>>>0>1126170624|(V|0)==1126170624&0>0)){n=(n|0)<0;y=n?y+-4503599627370496.0+4503599627370496.0:y+4503599627370496.0+-4503599627370496.0;if(y==0.0)y=n?-0.0:0.0}V=~~y|1;V=(V|0)<3?3:V;y=x*+(k[m>>2]|0);p[u>>3]=y;n=k[u+4>>2]|0;U=n&2146435072;if(!(U>>>0>1126170624|(U|0)==1126170624&0>0)){n=(n|0)<0;y=n?y+-4503599627370496.0+4503599627370496.0:y+4503599627370496.0+-4503599627370496.0;if(y==0.0)y=n?-0.0:0.0}U=~~y;y=x*+(k[c>>2]|0);p[u>>3]=y;n=k[u+4>>2]|0;T=n&2146435072;if(!(T>>>0>1126170624|(T|0)==1126170624&0>0)){n=(n|0)<0;y=n?y+-4503599627370496.0+4503599627370496.0:y+4503599627370496.0+-4503599627370496.0;if(y==0.0)y=n?-0.0:0.0}T=~~y;do if(X){if(((k[Vd>>2]|0)<3?(k[Ad>>2]|0)==(T|0):0)&(k[Fc>>2]|0)==(U|0)?!((k[Gc>>2]|0)==0?1:(k[ce>>2]&4095|0)!=13):0)break;k[Gd>>2]=T;k[Hc>>2]=U;G1(ce,2,Gd,13)}else KG(ce,Zd)|0;while(0);if(k[Ic>>2]|0){s=k[_d>>2]|0;if((s|0)<3)n=aa(k[Fa>>2]|0,k[zd>>2]|0)|0;else{a=k[Yd>>2]|0;q=0;n=1;do{n=aa(k[a+(q<<2)>>2]|0,n)|0;q=q+1|0}while((q|0)!=(s|0))}if(n){k[Ga>>2]=0;k[Ha>>2]=0;k[Fd>>2]=16842752;k[Ia>>2]=ee;S=Ka;k[S>>2]=0;k[S+4>>2]=0;k[Gd>>2]=33619968;k[Ja>>2]=ce;k[Od>>2]=U;k[La>>2]=T;Rla(Fd,Gd,Od,0.0,0.0,1);S=Oa;k[S>>2]=0;k[S+4>>2]=0;k[Fd>>2]=33619968;k[Na>>2]=ce;SW(ce,Fd,-1,Ma,0.0)}else Ud=61}else Ud=61;do if((Ud|0)==61){Ud=0;if(Jc){k[Gd>>2]=0;k[eb>>2]=0;k[fb>>2]=1124007936;s=gb;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[ib>>2]=hb;k[kb>>2]=jb;k[lb>>2]=0;k[jb>>2]=0;k[mb>>2]=1124007936;s=nb;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[pb>>2]=ob;k[rb>>2]=qb;k[sb>>2]=0;k[qb>>2]=0;k[tb>>2]=1124007936;s=ub;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[wb>>2]=vb;k[yb>>2]=xb;s=xb;a=s+56|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[Fd>>2]=U;k[zb>>2]=T;j1(Gd,48,Fd,13);S=k[Gd>>2]|0;dh[k[(k[S>>2]|0)+12>>2]&255](S,Gd,ce,-1);XN(Gd);break}else{k[Kc>>2]=0;k[Lc>>2]=0;k[Fd>>2]=16842752;k[Mc>>2]=Zd;S=Oc;k[S>>2]=0;k[S+4>>2]=0;k[Gd>>2]=33619968;k[Nc>>2]=ce;k[Nd>>2]=U;k[Pc>>2]=T;Rla(Fd,Gd,Nd,0.0,0.0,3);S=Rc;k[S>>2]=0;k[S+4>>2]=0;k[Fd>>2]=33619968;k[Qc>>2]=ce;SW(ce,Fd,-1,x,0.0);break}}while(0);k[Pd>>2]=1124007936;s=Pa;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[Ra>>2]=Qa;k[Ta>>2]=Sa;k[Ua>>2]=0;k[Sa>>2]=0;k[Va>>2]=1124007936;s=Wa;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[Ya>>2]=Xa;k[_a>>2]=Za;k[$a>>2]=0;k[Za>>2]=0;k[Qd>>2]=1124007936;s=Sc;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[Uc>>2]=Tc;k[Wc>>2]=Vc;k[Xc>>2]=0;k[Vc>>2]=0;k[Rd>>2]=1124007936;s=Yc;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[_c>>2]=Zc;k[ad>>2]=$c;k[bd>>2]=0;k[$c>>2]=0;S=0;do{A=k[Ld+(S<<2)>>2]|0;R=dd;k[R>>2]=0;k[R+4>>2]=0;k[Fd>>2]=33619968;k[cd>>2]=be;SW(A,Fd,5,1.0,0.0);k[ed>>2]=0;k[fd>>2]=0;k[Fd>>2]=16842752;k[gd>>2]=be;A=id;k[A>>2]=0;k[A+4>>2]=0;k[Gd>>2]=33619968;k[hd>>2]=be;k[Sd>>2]=V;k[jd>>2]=V;uua(Fd,Gd,Sd,W,W,4);k[kd>>2]=0;k[ld>>2]=0;k[Fd>>2]=16842752;k[md>>2]=be;A=od;k[A>>2]=0;k[A+4>>2]=0;k[Gd>>2]=33619968;k[nd>>2]=Qd;k[Td>>2]=U;k[pd>>2]=T;Rla(Fd,Gd,Td,1.0,0.0,1);A=Pd+(S*56|0)|0;if((k[Qd>>2]&4095|0)!=5){k[Fd>>2]=0;k[zc>>2]=0;n=ZT(28)|0;k[n>>2]=1;s=n+4|0;k[Fd>>2]=s;k[zc>>2]=22;i[n+26>>0]=0;q=404751;a=s+22|0;do{i[s>>0]=i[q>>0]|0;s=s+1|0;q=q+1|0}while((s|0)<(a|0));Y8(-215,Fd,404774,404682,120);k[zc>>2]=0;k[Fd>>2]=0;R=k[n>>2]|0;k[n>>2]=R+-1;if((R|0)==1)ggb(k[n+-4>>2]|0)}Q=k[qd>>2]|0;R=k[Tc>>2]|0;k[Jd>>2]=sd;k[td>>2]=264;if(ud){while(1){n=fgb(_)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}k[Jd>>2]=n}else n=sd;k[td>>2]=rd;a=(Q+vd|0)*3|0;k[Kd>>2]=wd;k[xd>>2]=264;if(a>>>0>264){s=a>>>0>1073741823?-1:a<<2;s=(s|0)==0?1:s;while(1){q=fgb(s)|0;if(q|0)break;q=k[207666]|0;k[207666]=q+0;if(!q){q=0;break}Qh[q&7]()}k[Kd>>2]=q}else q=wd;k[xd>>2]=a;N=n+(h<<2)|0;O=N+(vd<<2)+4|0;P=O+(vd<<2)+4|0;I=q+(yd<<2)|0;if(!bc){n=ac;x=0.0;while(1){M=+Z(+(+(aa(n,0-n|0)|0)/yc));o[N+(n<<2)>>2]=M;x=x+M;if((n|0)>=(h|0))break;else n=n+1|0}x=1.0/x;n=ac;while(1){H=N+(n<<2)|0;M=x*+o[H>>2];o[H>>2]=M;o[O+(n<<2)>>2]=+(n|0)*M;M=+(aa(n,n)|0)*M;o[P+(n<<2)>>2]=M;if((n|0)<(h|0))n=n+1|0;else break}}k[Fd>>2]=1124007936;s=cc;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[ec>>2]=dc;k[gc>>2]=fc;k[hc>>2]=0;k[fc>>2]=0;k[Gd>>2]=6;k[Hc>>2]=6;G1(Fd,2,Gd,6);p[Hd>>3]=0.0;k[Gd>>2]=-1056833530;k[kc>>2]=Hd;k[ic>>2]=1;k[jc>>2]=1;pY(Fd,Gd,49332);if(bc){n=k[$b>>2]|0;q=n}else{w=k[$b>>2]|0;v=k[k[gc>>2]>>2]|0;s=w+v+8|0;a=w+(v*3|0)+24|0;v=w+(v*5|0)+40|0;q=ac;while(1){x=+o[N+(q<<2)>>2];y=+(q|0);n=ac;while(1){M=x*+o[N+(n<<2)>>2];p[w>>3]=+p[w>>3]+M;L=+(n|0);M=L*(L*M);p[s>>3]=+p[s>>3]+M;p[a>>3]=+p[a>>3]+L*(L*M);p[v>>3]=y*(y*M)+ +p[v>>3];if((n|0)<(h|0))n=n+1|0;else break}if((q|0)<(h|0))q=q+1|0;else{q=w;n=w;break}}}H=k[k[gc>>2]>>2]|0;M=+p[q+H+8>>3];a=q+(H<<2)|0;p[a>>3]=M;s=q+(H*3|0)|0;p[s>>3]=M;p[n+32>>3]=M;p[n+24>>3]=M;p[n+(H<<1)+16>>3]=M;p[a+32>>3]=+p[s+24>>3];M=+p[q+(H*5|0)+40>>3];p[a+24>>3]=M;p[s+32>>3]=M;k[Id>>2]=0;k[Ab>>2]=0;k[Bb>>2]=1124007936;s=Cb;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[Eb>>2]=Db;k[Gb>>2]=Fb;k[Hb>>2]=0;k[Fb>>2]=0;k[Ib>>2]=1124007936;s=Jb;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[Lb>>2]=Kb;k[Nb>>2]=Mb;k[Ob>>2]=0;k[Mb>>2]=0;k[Pb>>2]=1124007936;s=Qb;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[Sb>>2]=Rb;k[Ub>>2]=Tb;s=Tb;a=s+56|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));Y$(Id,3,Fd);s=lc;a=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(a|0));k[nc>>2]=mc;k[pc>>2]=oc;k[qc>>2]=0;k[oc>>2]=0;k[Gd>>2]=1124007942;H=k[Id>>2]|0;dh[k[(k[H>>2]|0)+12>>2]&255](H,Id,Gd,6);XN(Id);H=k[rc>>2]|0;n=k[k[pc>>2]>>2]|0;J=+p[H+n+8>>3];K=+p[H+24>>3];L=+p[H+(n*3|0)+24>>3];M=+p[H+(n*5|0)+40>>3];n=k[sc>>2]|0;do if(n|0){G=n+12|0;H=k[G>>2]|0;k[G>>2]=H+-1;if((H|0)!=1)break;q=k[sc>>2]|0;if(q|0){n=k[q+4>>2]|0;do if(!n){n=k[Wb>>2]|0;if(n|0)break;n=B1()|0;q=k[sc>>2]|0}while(0);jh[k[(k[n>>2]|0)+24>>2]&1023](n,q)}k[sc>>2]=0}while(0);k[sc>>2]=0;k[rc>>2]=0;k[rc+4>>2]=0;k[rc+8>>2]=0;k[rc+12>>2]=0;if((k[lc>>2]|0)>0){q=k[nc>>2]|0;n=0;do{k[q+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(k[lc>>2]|0))}n=k[pc>>2]|0;if(!((n|0)==(oc|0)|(n|0)==0))ggb(k[n+-4>>2]|0);n=k[tc>>2]|0;do if(n|0){G=n+12|0;H=k[G>>2]|0;k[G>>2]=H+-1;if((H|0)!=1)break;q=k[tc>>2]|0;if(q|0){n=k[q+4>>2]|0;do if(!n){n=k[Vb>>2]|0;if(n|0)break;n=B1()|0;q=k[tc>>2]|0}while(0);jh[k[(k[n>>2]|0)+24>>2]&1023](n,q)}k[tc>>2]=0}while(0);k[tc>>2]=0;k[$b>>2]=0;k[$b+4>>2]=0;k[$b+8>>2]=0;k[$b+12>>2]=0;if((k[cc>>2]|0)>0){q=k[ec>>2]|0;n=0;do{k[q+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(k[cc>>2]|0))}n=k[gc>>2]|0;if(!((n|0)==(fc|0)|(n|0)==0))ggb(k[n+-4>>2]|0);do if((k[Pd+(S*56|0)+4>>2]|0)<3){if((k[Pd+(S*56|0)+8>>2]|0)!=(R|0)){Ud=122;break}if((k[Pd+(S*56|0)+12>>2]|0)!=(Q|0)){Ud=122;break}if((k[A>>2]&4095|0)!=37){Ud=122;break}if(!(k[Pd+(S*56|0)+16>>2]|0))Ud=122}else Ud=122;while(0);if((Ud|0)==122){Ud=0;k[Gd>>2]=R;k[Hc>>2]=Q;G1(A,2,Gd,37)}if((R|0)>0){w=k[uc>>2]|0;A=k[k[Wc>>2]>>2]|0;B=k[Pd+(S*56|0)+16>>2]|0;C=k[k[Pd+(S*56|0)+44>>2]>>2]|0;D=(Q|0)>0;e=Q*3|0;l=R+-1|0;H=vc|D^1;v=0;do{x=+o[N>>2];q=w+(aa(v,A)|0)|0;G=B+(aa(v,C)|0)|0;do if(D){n=0;do{a=n*3|0;o[I+(a<<2)>>2]=x*+o[q+(n<<2)>>2];o[I+(a+2<<2)>>2]=0.0;o[I+(a+1<<2)>>2]=0.0;n=n+1|0}while((n|0)!=(Q|0));if(H)break;else n=1;do{y=+o[N+(n<<2)>>2];z=+o[O+(n<<2)>>2];j=+o[P+(n<<2)>>2];s=v-n|0;s=w+(aa((s|0)<0?0:s,A)|0)|0;a=n+v|0;a=w+(aa((l|0)<(a|0)?l:a,A)|0)|0;q=0;do{E=+o[s+(q<<2)>>2];F=+o[a+(q<<2)>>2];le=E+F;ie=q*3|0;ke=I+(ie<<2)|0;je=I+(ie+1<<2)|0;E=+o[je>>2]+z*(F-E);ie=I+(ie+2<<2)|0;F=j*le+ +o[ie>>2];o[ke>>2]=+o[ke>>2]+y*le;o[je>>2]=E;o[ie>>2]=F;q=q+1|0}while((q|0)!=(Q|0));n=n+1|0}while((n|0)!=(xc|0))}while(0);if(wc){n=0;do{k[I+(~n<<2)>>2]=k[I+(2-n<<2)>>2];ke=n+e|0;k[I+(ke<<2)>>2]=k[I+(ke+-3<<2)>>2];n=n+1|0}while((n|0)<(yd|0))}a:do if(D){n=0;while(1){ke=n*3|0;y=x*+o[I+(ke<<2)>>2];E=x*+o[I+(ke+1<<2)>>2];x=x*+o[I+(ke+2<<2)>>2];if(vc){j=0.0;F=0.0;z=0.0}else{j=0.0;F=0.0;z=0.0;q=1;do{je=(q+n|0)*3|0;me=+o[I+(je<<2)>>2];ke=(n-q|0)*3|0;ne=+o[I+(ke<<2)>>2];oe=me+ne;le=+o[N+(q<<2)>>2];y=y+oe*le;F=F+oe*+o[P+(q<<2)>>2];oe=+o[O+(q<<2)>>2];z=z+(me-ne)*oe;ne=+o[I+(je+1<<2)>>2];me=+o[I+(ke+1<<2)>>2];E=E+le*(ne+me);j=j+oe*(ne-me);x=x+le*(+o[I+(je+2<<2)>>2]+ +o[I+(ke+2<<2)>>2]);q=q+1|0}while((q|0)!=(xc|0))}ke=n*5|0;o[G+(ke+1<<2)>>2]=J*z;o[G+(ke<<2)>>2]=J*E;oe=K*y;o[G+(ke+3<<2)>>2]=oe+L*F;o[G+(ke+2<<2)>>2]=oe+L*x;o[G+(ke+4<<2)>>2]=M*j;n=n+1|0;if((n|0)==(Q|0))break a;x=+o[N>>2]}}while(0);v=v+1|0}while((v|0)!=(R|0))}n=k[Kd>>2]|0;if((n|0)!=(wd|0)){if(n|0)ggb(n);k[Kd>>2]=wd;k[xd>>2]=264}n=k[Jd>>2]|0;if((n|0)!=(sd|0)){if(n|0)ggb(n);k[Jd>>2]=sd;k[td>>2]=264}S=S+1|0}while((S|0)<2);H6a(Pd,Ac,ce,Rd,0,k[Ad>>2]|0);if(Bc){R=0;do{O=(R|0)<(ca|0);P=k[Fc>>2]|0;Q=k[Ad>>2]|0;N=1024/(P|0)|0;N=(N|0)<(f|0)?f:N;if(ba){s=((P+fa|0)*5|0)+10|0;k[Fd>>2]=ga;k[ha>>2]=136;if(s>>>0>136){q=s>>>0>536870911?-1:s<<3;q=(q|0)==0?1:q;while(1){n=fgb(q)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}k[Fd>>2]=n}else n=ga;k[ha>>2]=s;G=n+(ja<<3)|0;A=k[Dc>>2]|0;H=P*5|0;I=(P|0)>0;if(I){q=0;do{p[G+(q<<3)>>3]=ka*+o[A+(q<<2)>>2];q=q+1|0}while((q|0)<(H|0))}do if(la){s=Q+-1|0;a=k[k[ad>>2]>>2]|0;if(I)w=1;else break;do{v=A+(aa((s|0)<(w|0)?s:w,a)|0)|0;q=0;do{ke=G+(q<<3)|0;p[ke>>3]=+p[ke>>3]+ +o[v+(q<<2)>>2];q=q+1|0}while((q|0)<(H|0));w=w+1|0}while((w|0)<(da|0))}while(0);if((Q|0)>0){B=Q+-1|0;C=G+8|0;D=G+16|0;e=G+24|0;l=G+32|0;n=0;s=A;w=0;while(1){v=(k[Gc>>2]|0)+(aa(k[k[Wd>>2]>>2]|0,w)|0)|0;a=w-da+-1|0;je=k[k[ad>>2]>>2]|0;a=s+(aa(je,(a|0)<0?0:a)|0)|0;ke=w+da|0;s=s+(aa(je,(B|0)<(ke|0)?B:ke)|0)|0;if(I){q=0;do{ke=G+(q<<3)|0;p[ke>>3]=+p[ke>>3]+(+o[s+(q<<2)>>2]-+o[a+(q<<2)>>2]);q=q+1|0}while((q|0)<(H|0))}if(ma){q=0;do{p[G+(~q<<3)>>3]=+p[G+(4-q<<3)>>3];ke=q+H|0;p[G+(ke<<3)>>3]=+p[G+(ke+-5<<3)>>3];q=q+1|0}while((q|0)!=(ja|0))}x=na*+p[G>>3];j=na*+p[C>>3];E=na*+p[D>>3];y=na*+p[e>>3];z=na*+p[l>>3];if(la){q=1;do{ke=q*5|0;x=x+ +p[G+(ke<<3)>>3];j=j+ +p[G+(ke+1<<3)>>3];E=E+ +p[G+(ke+2<<3)>>3];y=y+ +p[G+(ke+3<<3)>>3];z=z+ +p[G+(ke+4<<3)>>3];q=q+1|0}while((q|0)<(da|0))}if(I){q=0;do{je=(q+da|0)*5|0;ke=(q-da|0)*5|0;x=x+(+p[G+(je<<3)>>3]-+p[G+(ke+-5<<3)>>3]);j=j+(+p[G+(je+1<<3)>>3]-+p[G+(ke+-4<<3)>>3]);E=E+(+p[G+(je+2<<3)>>3]-+p[G+(ke+-3<<3)>>3]);y=y+(+p[G+(je+3<<3)>>3]-+p[G+(ke+-2<<3)>>3]);z=z+(+p[G+(je+4<<3)>>3]-+p[G+(ke+-1<<3)>>3]);M=ea*x;ne=ea*j;le=ea*E;me=ea*y;oe=ea*z;W=1.0/(M*le-ne*ne+.001);ke=q<<1;o[v+(ke<<2)>>2]=W*(M*oe-ne*me);o[v+((ke|1)<<2)>>2]=W*(le*me-ne*oe);q=q+1|0}while((q|0)!=(P|0))}q=(w|0)==(B|0)?Q:w-f|0;do if(O){if((q|0)!=(Q|0)&(q|0)<(n+N|0))break;H6a(Pd,Ac,ce,Rd,n,q);n=q}while(0);q=w+1|0;if((q|0)>=(Q|0))break;s=k[Dc>>2]|0;w=q}n=k[Fd>>2]|0}if((n|0)!=(ga|0)){if(n|0)ggb(n);k[Fd>>2]=ga;k[ha>>2]=136}}else{s=((P+fa|0)*5|0)+26|0;k[Fd>>2]=oa;k[pa>>2]=264;if(s>>>0>264){q=s>>>0>1073741823?-1:s<<2;q=(q|0)==0?1:q;while(1){n=fgb(q)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}k[Fd>>2]=n;a=n}else a=oa;k[pa>>2]=s;H=P*5|0;s=H+16|0;k[Gd>>2]=qa;k[ra>>2]=264;if(s>>>0>264){q=s>>>0>1073741823?-1:s<<2;q=(q|0)==0?1:q;while(1){n=fgb(q)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}k[Gd>>2]=n;q=n}else q=sa;k[ra>>2]=s;k[Hd>>2]=ua;k[va>>2]=264;if(wa){while(1){n=fgb($)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}k[Hd>>2]=n;G=n}else G=ua;k[va>>2]=ta;k[Id>>2]=ya;k[za>>2]=264;if(Aa){while(1){n=fgb(Y)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}k[Id>>2]=n}else n=ya;k[za>>2]=xa;l=a+(ja<<2)+15&-16;e=q+15&-16;o[G>>2]=1.0;if(Ba)x=1.0;else{q=1;x=1.0;while(1){oe=+Z(+(+(aa(q,0-q|0)|0)/Ea));o[G+(q<<2)>>2]=oe;x=x+oe*2.0;if((q|0)<(da|0))q=q+1|0;else break}}x=1.0/x;if(!Ca){q=0;while(1){ke=G+(q<<2)|0;o[ke>>2]=x*+o[ke>>2];if((q|0)<(da|0))q=q+1|0;else break}}if((Q|0)>0){B=(P|0)>0;C=n+(da<<2)|0;D=Q+-1|0;A=0;q=0;do{w=(k[Gc>>2]|0)+(aa(k[k[Wd>>2]>>2]|0,A)|0)|0;if(!Ca){a=k[Dc>>2]|0;v=k[k[ad>>2]>>2]|0;s=0;while(1){ke=A-s|0;ke=a+(aa((ke|0)<0?0:ke,v)|0)|0;k[n+(da-s<<2)>>2]=ke;ke=s+A|0;ke=a+(aa((D|0)<(ke|0)?D:ke,v)|0)|0;k[n+(s+da<<2)>>2]=ke;if((da|0)>(s|0))s=s+1|0;else break}}b:do if(B){v=k[C>>2]|0;if(Ba){s=0;while(1){o[l+(s<<2)>>2]=+o[v+(s<<2)>>2]*+o[G>>2];s=s+1|0;if((s|0)>=(H|0))break b}}else s=0;do{x=+o[v+(s<<2)>>2]*+o[G>>2];a=1;while(1){x=x+(+o[(k[n+(a+da<<2)>>2]|0)+(s<<2)>>2]+ +o[(k[n+(da-a<<2)>>2]|0)+(s<<2)>>2])*+o[G+(a<<2)>>2];if((da|0)<=(a|0))break;else a=a+1|0}o[l+(s<<2)>>2]=x;s=s+1|0}while((s|0)<(H|0))}while(0);if(Da){s=0;do{k[l+(~s<<2)>>2]=k[l+(4-s<<2)>>2];ke=s+H|0;k[l+(ke<<2)>>2]=k[l+(ke+-5<<2)>>2];s=s+1|0}while((s|0)!=(ia|0))}if(B){if(Ba){s=0;do{o[e+(s<<2)>>2]=+o[l+(s<<2)>>2]*+o[G>>2];s=s+1|0}while((s|0)<(H|0));s=0}else{s=0;do{x=+o[l+(s<<2)>>2]*+o[G>>2];a=1;while(1){ke=a*5|0;x=x+ +o[G+(a<<2)>>2]*(+o[l+(s-ke<<2)>>2]+ +o[l+(ke+s<<2)>>2]);if((a|0)>=(da|0))break;else a=a+1|0}o[e+(s<<2)>>2]=x;s=s+1|0}while((s|0)<(H|0));s=0}do{ke=s*5|0;M=+o[e+(ke<<2)>>2];me=+o[e+(ke+1<<2)>>2];W=+o[e+(ke+2<<2)>>2];le=+o[e+(ke+3<<2)>>2];ne=+o[e+(ke+4<<2)>>2];oe=1.0/(M*W-me*me+.001);ke=s<<1;o[w+(ke<<2)>>2]=(M*ne-me*le)*oe;o[w+((ke|1)<<2)>>2]=(W*le-me*ne)*oe;s=s+1|0}while((s|0)!=(P|0))}s=(A|0)==(D|0)?Q:A-f|0;do if(O){if((s|0)!=(Q|0)&(s|0)<(q+N|0))break;H6a(Pd,Ac,ce,Rd,q,s);q=s}while(0);A=A+1|0}while((A|0)<(Q|0));n=k[Id>>2]|0}if((n|0)!=(ya|0)){if(n|0)ggb(n);k[Id>>2]=ya;k[za>>2]=264}n=k[Hd>>2]|0;if((n|0)!=(ua|0)){if(n|0)ggb(n);k[Hd>>2]=ua;k[va>>2]=264}n=k[Gd>>2]|0;if((n|0)!=(qa|0)){if(n|0)ggb(n);k[Gd>>2]=qa;k[ra>>2]=264}n=k[Fd>>2]|0;if((n|0)!=(oa|0)){if(n|0)ggb(n);k[Fd>>2]=oa;k[pa>>2]=264}}R=R+1|0}while((R|0)<(g|0))}KG(ee,ce)|0;n=k[Cc>>2]|0;if(n|0?(je=n+12|0,ke=k[je>>2]|0,k[je>>2]=ke+-1,(ke|0)==1):0){q=k[Cc>>2]|0;if(q|0){n=k[q+4>>2]|0;do if(!n){n=k[_b>>2]|0;if(n|0)break;n=B1()|0;q=k[Cc>>2]|0}while(0);jh[k[(k[n>>2]|0)+24>>2]&1023](n,q)}k[Cc>>2]=0}k[Cc>>2]=0;k[Dc>>2]=0;k[Dc+4>>2]=0;k[Dc+8>>2]=0;k[Dc+12>>2]=0;if((k[Yc>>2]|0)>0){q=k[_c>>2]|0;n=0;do{k[q+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(k[Yc>>2]|0))}n=k[ad>>2]|0;if(!((n|0)==($c|0)|(n|0)==0))ggb(k[n+-4>>2]|0);n=k[Ec>>2]|0;do if(n|0){je=n+12|0;ke=k[je>>2]|0;k[je>>2]=ke+-1;if((ke|0)!=1)break;q=k[Ec>>2]|0;if(q|0){n=k[q+4>>2]|0;do if(!n){n=k[Zb>>2]|0;if(n|0)break;n=B1()|0;q=k[Ec>>2]|0}while(0);jh[k[(k[n>>2]|0)+24>>2]&1023](n,q)}k[Ec>>2]=0}while(0);k[Ec>>2]=0;k[uc>>2]=0;k[uc+4>>2]=0;k[uc+8>>2]=0;k[uc+12>>2]=0;if((k[Sc>>2]|0)>0){q=k[Uc>>2]|0;n=0;do{k[q+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(k[Sc>>2]|0))}n=k[Wc>>2]|0;if(!((n|0)==(Vc|0)|(n|0)==0))ggb(k[n+-4>>2]|0);n=k[ab>>2]|0;do if(n|0){je=n+12|0;ke=k[je>>2]|0;k[je>>2]=ke+-1;if((ke|0)!=1)break;q=k[ab>>2]|0;if(q|0){n=k[q+4>>2]|0;do if(!n){n=k[Yb>>2]|0;if(n|0)break;n=B1()|0;q=k[ab>>2]|0}while(0);jh[k[(k[n>>2]|0)+24>>2]&1023](n,q)}k[ab>>2]=0}while(0);k[ab>>2]=0;k[bb>>2]=0;k[bb+4>>2]=0;k[bb+8>>2]=0;k[bb+12>>2]=0;if((k[Wa>>2]|0)>0){q=k[Ya>>2]|0;n=0;do{k[q+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(k[Wa>>2]|0))}n=k[_a>>2]|0;if(!((n|0)==(Za|0)|(n|0)==0))ggb(k[n+-4>>2]|0);n=k[cb>>2]|0;do if(n|0){je=n+12|0;ke=k[je>>2]|0;k[je>>2]=ke+-1;if((ke|0)!=1)break;q=k[cb>>2]|0;if(q|0){n=k[q+4>>2]|0;do if(!n){n=k[Xb>>2]|0;if(n|0)break;n=B1()|0;q=k[cb>>2]|0}while(0);jh[k[(k[n>>2]|0)+24>>2]&1023](n,q)}k[cb>>2]=0}while(0);k[cb>>2]=0;k[db>>2]=0;k[db+4>>2]=0;k[db+8>>2]=0;k[db+12>>2]=0;if((k[Pa>>2]|0)>0){q=k[Ra>>2]|0;n=0;do{k[q+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(k[Pa>>2]|0))}n=k[Ta>>2]|0;if(!((n|0)==(Sa|0)|(n|0)==0))ggb(k[n+-4>>2]|0);if(X)b=b+-1|0;else break}}m=Zd+36|0;b=k[m>>2]|0;if(b|0?(je=b+12|0,ke=k[je>>2]|0,k[je>>2]=ke+-1,(ke|0)==1):0){c=k[m>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Zd+32>>2]|0;if(!b){b=B1()|0;c=k[m>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[m>>2]=0}k[m>>2]=0;ke=Zd+16|0;c=Zd+4|0;k[ke>>2]=0;k[ke+4>>2]=0;k[ke+8>>2]=0;k[ke+12>>2]=0;if((k[c>>2]|0)>0){m=k[Zd+40>>2]|0;b=0;do{k[m+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[Zd+44>>2]|0;if(!((b|0)==(Zd+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);m=be+36|0;b=k[m>>2]|0;if(b|0?(je=b+12|0,ke=k[je>>2]|0,k[je>>2]=ke+-1,(ke|0)==1):0){c=k[m>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[be+32>>2]|0;if(!b){b=B1()|0;c=k[m>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[m>>2]=0}k[m>>2]=0;ke=be+16|0;k[ke>>2]=0;k[ke+4>>2]=0;k[ke+8>>2]=0;k[ke+12>>2]=0;if((k[Dd>>2]|0)>0){c=k[Bd>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Dd>>2]|0))}b=k[Cd>>2]|0;if(!((b|0)==(Ed|0)|(b|0)==0))ggb(k[b+-4>>2]|0);m=ce+36|0;b=k[m>>2]|0;if(b|0?(je=b+12|0,ke=k[je>>2]|0,k[je>>2]=ke+-1,(ke|0)==1):0){c=k[m>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[ce+32>>2]|0;if(!b){b=B1()|0;c=k[m>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[m>>2]=0}k[m>>2]=0;ke=ce+16|0;k[ke>>2]=0;k[ke+4>>2]=0;k[ke+8>>2]=0;k[ke+12>>2]=0;if((k[Vd>>2]|0)>0){c=k[Md>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Vd>>2]|0))}b=k[Wd>>2]|0;if(!((b|0)==(Xd|0)|(b|0)==0))ggb(k[b+-4>>2]|0);m=ee+36|0;b=k[m>>2]|0;if(b|0?(je=b+12|0,ke=k[je>>2]|0,k[je>>2]=ke+-1,(ke|0)==1):0){c=k[m>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ee+32>>2]|0;if(b|0)break;b=B1()|0;c=k[m>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[m>>2]=0}k[m>>2]=0;ke=ee+16|0;k[ke>>2]=0;k[ke+4>>2]=0;k[ke+8>>2]=0;k[ke+12>>2]=0;if((k[_d>>2]|0)>0){c=k[Yd>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[_d>>2]|0))}b=k[$d>>2]|0;if(!((b|0)==(ae|0)|(b|0)==0))ggb(k[b+-4>>2]|0);m=fe+36|0;b=k[m>>2]|0;do if(b|0){je=b+12|0;ke=k[je>>2]|0;k[je>>2]=ke+-1;if((ke|0)!=1)break;c=k[m>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[fe+32>>2]|0;if(b|0)break;b=B1()|0;c=k[m>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[m>>2]=0}while(0);k[m>>2]=0;ke=fe+16|0;m=fe+4|0;k[ke>>2]=0;k[ke+4>>2]=0;k[ke+8>>2]=0;k[ke+12>>2]=0;if((k[m>>2]|0)>0){c=k[t>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[fe+44>>2]|0;if(!((b|0)==(fe+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);m=ge+36|0;b=k[m>>2]|0;do if(b|0){je=b+12|0;ke=k[je>>2]|0;k[je>>2]=ke+-1;if((ke|0)!=1)break;c=k[m>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ge+32>>2]|0;if(b|0)break;b=B1()|0;c=k[m>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[m>>2]=0}while(0);k[m>>2]=0;ke=ge+16|0;m=ge+4|0;k[ke>>2]=0;k[ke+4>>2]=0;k[ke+8>>2]=0;k[ke+12>>2]=0;if((k[m>>2]|0)>0){c=k[de>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[ge+44>>2]|0;if((b|0)==(ge+48|0)|(b|0)==0){r=he;return}ggb(k[b+-4>>2]|0);r=he;return}function Hj(a,b,c,d,e,f,g,h,i,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;l=+l;var m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0;m=r;r=r+112|0;v=m+88|0;u=m+72|0;t=m+56|0;s=m+40|0;q=m+24|0;o=m+8|0;n=m;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=16842752;k[v+4>>2]=a;k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=16842752;k[u+4>>2]=b;k[t+8>>2]=0;k[t+12>>2]=0;k[t>>2]=16842752;k[t+4>>2]=c;c=s+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[s>>2]=50397184;k[s+4>>2]=d;d=q+4+4|0;k[d>>2]=0;k[d+4>>2]=0;k[q>>2]=33619968;k[q+4>>2]=e;e=o+4+4|0;k[e>>2]=0;k[e+4>>2]=0;k[o>>2]=33619968;k[o+4>>2]=f;k[n>>2]=k[g>>2];k[n+4>>2]=k[g+4>>2];E6a(v,u,t,s,q,o,n,h,k[i>>2]|0,k[i+4>>2]|0,+p[i+8>>3],j,l);r=m;return}function Ij(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+64|0;j=f+48|0;i=f+32|0;h=f+16|0;g=f;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b;b=h+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;c=g+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=d;WZ(j,i,h,g,e);r=f;return}function Jj(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0;h=r;r=r+32|0;j=h+8|0;i=h;l=j+4+4|0;k[l>>2]=0;k[l+4>>2]=0;k[j>>2]=50397184;k[j+4>>2]=a;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];Zfa(j,i,c,d,e,f,g);r=h;return}function Kj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=k[a>>2]|0;e=k[a+4>>2]|0;h=k[a+8>>2]|0;a=k[a+12>>2]|0;k[b>>2]=(k[b>>2]|0)-f;g=b+4|0;k[g>>2]=(k[g>>2]|0)-e;k[c>>2]=(k[c>>2]|0)-f;d=c+4|0;k[d>>2]=(k[d>>2]|0)-e;a=Cfa(h,a,b,c)|0;k[b>>2]=(k[b>>2]|0)+f;k[g>>2]=(k[g>>2]|0)+e;k[c>>2]=(k[c>>2]|0)+f;k[d>>2]=(k[d>>2]|0)+e;return a|0}function Lj(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=r;r=r+1280|0;C=P+1224|0;G=P+1168|0;O=P+1112|0;N=P+1056|0;p=P+1048|0;M=P+992|0;K=P+936|0;s=P+224|0;J=P+848|0;t=P;I=P+448|0;m=P+920|0;q=P+904|0;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;n=m+4|0;k[n>>2]=b;o=q+4|0;l=q+4+4|0;k[l>>2]=0;k[l+4>>2]=0;k[q>>2]=33619968;k[o>>2]=c;k[O>>2]=k[a>>2];l=O+4|0;c=a+4|0;b=k[c>>2]|0;k[l>>2]=b;L=O+8|0;k[L>>2]=k[a+8>>2];k[O+12>>2]=k[a+12>>2];k[O+16>>2]=k[a+16>>2];k[O+20>>2]=k[a+20>>2];k[O+24>>2]=k[a+24>>2];k[O+28>>2]=k[a+28>>2];k[O+32>>2]=k[a+32>>2];g=k[a+36>>2]|0;k[O+36>>2]=g;h=O+40|0;k[h>>2]=L;L=O+48|0;j=O+44|0;k[j>>2]=L;k[O+52>>2]=0;k[L>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[l>>2]=0;x1(O,b,0,0,0);if((k[l>>2]|0)>0){i=k[a+40>>2]|0;h=k[h>>2]|0;g=k[a+44>>2]|0;c=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[i+(b<<2)>>2];k[c+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{H=k[a+44>>2]|0;L=k[j>>2]|0;k[L>>2]=k[H>>2];k[L+4>>2]=k[H+4>>2]}do if((k[m>>2]&2031616|0)==65536){i=k[n>>2]|0;k[N>>2]=k[i>>2];l=N+4|0;c=i+4|0;k[l>>2]=k[c>>2];L=N+8|0;k[L>>2]=k[i+8>>2];k[N+12>>2]=k[i+12>>2];k[N+16>>2]=k[i+16>>2];k[N+20>>2]=k[i+20>>2];k[N+24>>2]=k[i+24>>2];k[N+28>>2]=k[i+28>>2];k[N+32>>2]=k[i+32>>2];b=k[i+36>>2]|0;k[N+36>>2]=b;g=N+40|0;k[g>>2]=L;L=N+48|0;j=N+44|0;k[j>>2]=L;k[N+52>>2]=0;k[L>>2]=0;if(b|0){L=b+12|0;k[L>>2]=(k[L>>2]|0)+1}if((k[c>>2]|0)<3){H=k[i+44>>2]|0;L=k[j>>2]|0;k[L>>2]=k[H>>2];k[L+4>>2]=k[H+4>>2];break}k[l>>2]=0;x1(N,k[c>>2]|0,0,0,0);if((k[l>>2]|0)>0){a=k[i+40>>2]|0;h=k[g>>2]|0;g=k[i+44>>2]|0;c=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(N,m,-1);while(0);L=O+40|0;F=k[L>>2]|0;H=k[F>>2]|0;k[p>>2]=k[F+4>>2];k[p+4>>2]=H;x2(q,p,k[O>>2]&4095,0);do if((k[q>>2]&2031616|0)==65536){h=k[o>>2]|0;k[M>>2]=k[h>>2];l=M+4|0;b=h+4|0;k[l>>2]=k[b>>2];H=M+8|0;k[H>>2]=k[h+8>>2];k[M+12>>2]=k[h+12>>2];k[M+16>>2]=k[h+16>>2];k[M+20>>2]=k[h+20>>2];k[M+24>>2]=k[h+24>>2];k[M+28>>2]=k[h+28>>2];k[M+32>>2]=k[h+32>>2];c=k[h+36>>2]|0;k[M+36>>2]=c;g=M+40|0;k[g>>2]=H;H=M+48|0;j=M+44|0;k[j>>2]=H;k[M+52>>2]=0;k[H>>2]=0;if(c|0){H=c+12|0;k[H>>2]=(k[H>>2]|0)+1}if((k[b>>2]|0)<3){F=k[h+44>>2]|0;H=k[j>>2]|0;k[H>>2]=k[F>>2];k[H+4>>2]=k[F+4>>2];break}k[l>>2]=0;x1(M,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){a=k[h+40>>2]|0;i=k[g>>2]|0;g=k[h+44>>2]|0;c=k[j>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(M,q,-1);while(0);H=N+40|0;h=k[H>>2]|0;g=k[h+4>>2]|0;h=k[h>>2]|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=1124007936;b=s+16|0;c=s+48|0;j=s+12|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[c>>2]=b;b=s+56|0;k[s+52>>2]=b;k[s+60>>2]=0;k[b>>2]=0;k[s+64>>2]=1124007936;b=s+72|0;c=s+104|0;j=s+68|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[c>>2]=b;b=s+112|0;k[s+108>>2]=b;k[s+116>>2]=0;k[b>>2]=0;k[s+120>>2]=1124007936;b=s+128|0;c=s+160|0;j=s+124|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[c>>2]=b;j=s+168|0;k[s+164>>2]=j;l=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[C>>2]=g;k[C+4>>2]=h;j1(s,48,C,0);k[K>>2]=1124007936;E=K+4|0;b=K+8|0;B=K+40|0;j=E;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[B>>2]=b;F=K+48|0;D=K+44|0;k[D>>2]=F;k[K+52>>2]=0;k[F>>2]=0;A=k[s>>2]|0;dh[k[(k[A>>2]|0)+12>>2]&255](A,s,K,-1);XN(s);if((k[N>>2]&4088|0)==16){k[C+8>>2]=0;k[C+12>>2]=0;k[C>>2]=16842752;k[C+4>>2]=N;A=G+4|0;z=A+4|0;k[z>>2]=0;k[z+4>>2]=0;k[G>>2]=33619968;k[A>>2]=K;$aa(C,G,6,0)}else KG(K,N)|0;h=k[L>>2]|0;g=k[h+4>>2]|0;h=k[h>>2]|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=1124007936;b=t+16|0;c=t+48|0;j=t+12|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[c>>2]=b;b=t+56|0;k[t+52>>2]=b;k[t+60>>2]=0;k[b>>2]=0;k[t+64>>2]=1124007936;b=t+72|0;c=t+104|0;j=t+68|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[c>>2]=b;b=t+112|0;k[t+108>>2]=b;k[t+116>>2]=0;k[b>>2]=0;k[t+120>>2]=1124007936;b=t+128|0;c=t+160|0;j=t+124|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[c>>2]=b;j=t+168|0;k[t+164>>2]=j;l=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[C>>2]=g;k[C+4>>2]=h;j1(t,48,C,16);k[J>>2]=1124007936;z=J+4|0;b=J+8|0;x=J+40|0;j=z;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[x>>2]=b;A=J+48|0;y=J+44|0;k[y>>2]=A;k[J+52>>2]=0;k[A>>2]=0;b=k[t>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,t,J,-1);XN(t);b=C+4|0;j=b+4|0;k[j>>2]=0;k[j+4>>2]=0;k[C>>2]=33619968;k[b>>2]=J;k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=K;nY(O,C,G);b=I+36|0;j=I;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[b>>2]=1124007936;b=I+44|0;c=I+76|0;j=I+40|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[c>>2]=b;b=I+84|0;k[I+80>>2]=b;k[I+88>>2]=0;k[b>>2]=0;k[I+92>>2]=1124007936;b=I+100|0;c=I+132|0;j=I+96|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[c>>2]=b;h=I+140|0;k[I+136>>2]=h;k[I+144>>2]=0;k[h>>2]=0;k[I+148>>2]=1124007936;h=I+152|0;g=I+156|0;i=I+188|0;j=h;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[i>>2]=g;u=I+196|0;a=I+192|0;k[a>>2]=u;k[I+200>>2]=0;k[u>>2]=0;k[I+204>>2]=1124007936;u=I+208|0;t=I+212|0;v=I+244|0;j=u;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[v>>2]=t;b=I+252|0;w=I+248|0;k[w>>2]=b;k[I+256>>2]=0;k[b>>2]=0;k[I+260>>2]=1124007936;b=I+268|0;c=I+300|0;j=I+264|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[c>>2]=b;b=I+308|0;k[I+304>>2]=b;k[I+312>>2]=0;k[b>>2]=0;k[I+316>>2]=1124007936;b=I+324|0;c=I+356|0;j=I+320|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[c>>2]=b;p=I+364|0;k[I+360>>2]=p;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;k[p+16>>2]=0;k[p+20>>2]=0;k[p+24>>2]=0;k[p+28>>2]=0;U3a(I,O,J,K);p=I+148|0;b=I+260|0;W3a(p,b,p);s=I+204|0;W3a(s,b,s);k[C>>2]=k[p>>2];p=C+4|0;b=k[h>>2]|0;k[p>>2]=b;q=C+8|0;k[q>>2]=k[g>>2];k[C+12>>2]=k[I+160>>2];l=C+16|0;k[l>>2]=k[I+164>>2];k[C+20>>2]=k[I+168>>2];k[C+24>>2]=k[I+172>>2];k[C+28>>2]=k[I+176>>2];j=C+32|0;k[j>>2]=k[I+180>>2];m=C+36|0;c=k[I+184>>2]|0;k[m>>2]=c;n=C+40|0;k[n>>2]=q;q=C+48|0;o=C+44|0;k[o>>2]=q;k[C+52>>2]=0;k[q>>2]=0;if(c){b=c+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[h>>2]|0}if((b|0)>=3){k[p>>2]=0;x1(C,b,0,0,0);if((k[p>>2]|0)>0){h=k[i>>2]|0;i=k[n>>2]|0;c=k[a>>2]|0;g=k[o>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[h+(b<<2)>>2];k[g+(b<<2)>>2]=k[c+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0))}}else{i=k[a>>2]|0;a=k[o>>2]|0;k[a>>2]=k[i>>2];k[a+4>>2]=k[i+4>>2]}V3a(C,d,e,f);b=k[m>>2]|0;if(b|0?(a=b+12|0,C=k[a>>2]|0,k[a>>2]=C+-1,(C|0)==1):0){c=k[m>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[j>>2]|0;if(!b){b=B1()|0;c=k[m>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[m>>2]=0}k[m>>2]=0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[p>>2]|0)>0){c=k[n>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[p>>2]|0))}b=k[o>>2]|0;if(!((b|0)==(q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[G>>2]=k[s>>2];o=G+4|0;b=k[u>>2]|0;k[o>>2]=b;p=G+8|0;k[p>>2]=k[t>>2];k[G+12>>2]=k[I+216>>2];a=G+16|0;k[a>>2]=k[I+220>>2];k[G+20>>2]=k[I+224>>2];k[G+24>>2]=k[I+228>>2];k[G+28>>2]=k[I+232>>2];j=G+32|0;k[j>>2]=k[I+236>>2];l=G+36|0;c=k[I+240>>2]|0;k[l>>2]=c;m=G+40|0;k[m>>2]=p;p=G+48|0;n=G+44|0;k[n>>2]=p;k[G+52>>2]=0;k[p>>2]=0;if(c){b=c+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[u>>2]|0}if((b|0)>=3){k[o>>2]=0;x1(G,b,0,0,0);if((k[o>>2]|0)>0){h=k[v>>2]|0;i=k[m>>2]|0;c=k[w>>2]|0;g=k[n>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[h+(b<<2)>>2];k[g+(b<<2)>>2]=k[c+(b<<2)>>2];b=b+1|0}while((b|0)<(k[o>>2]|0))}}else{w=k[w>>2]|0;C=k[n>>2]|0;k[C>>2]=k[w>>2];k[C+4>>2]=k[w+4>>2]}V3a(G,d,e,f);b=k[l>>2]|0;if(b|0?(C=b+12|0,G=k[C>>2]|0,k[C>>2]=G+-1,(G|0)==1):0){c=k[l>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[j>>2]|0;if(!b){b=B1()|0;c=k[l>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[l>>2]=0}k[l>>2]=0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[o>>2]|0)>0){c=k[m>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[o>>2]|0))}b=k[n>>2]|0;if(!((b|0)==(p|0)|(b|0)==0))ggb(k[b+-4>>2]|0);X3a(I,O,K,M);P3a(I);g=J+36|0;b=k[g>>2]|0;if(b|0?(G=b+12|0,I=k[G>>2]|0,k[G>>2]=I+-1,(I|0)==1):0){c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[J+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}k[g>>2]=0;J=J+16|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[z>>2]|0)>0){c=k[x>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[y>>2]|0;if(!((b|0)==(A|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=K+36|0;b=k[g>>2]|0;do if(b|0){I=b+12|0;J=k[I>>2]|0;k[I>>2]=J+-1;if((J|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[K+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;K=K+16|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[E>>2]|0)>0){c=k[B>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[E>>2]|0))}b=k[D>>2]|0;if(!((b|0)==(F|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=M+36|0;b=k[g>>2]|0;do if(b|0){J=b+12|0;K=k[J>>2]|0;k[J>>2]=K+-1;if((K|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[M+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;K=M+16|0;c=M+4|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[c>>2]|0)>0){g=k[M+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[M+44>>2]|0;if(!((b|0)==(M+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=N+36|0;b=k[g>>2]|0;do if(b|0){K=b+12|0;M=k[K>>2]|0;k[K>>2]=M+-1;if((M|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[N+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;M=N+16|0;g=N+4|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[g>>2]|0)>0){c=k[H>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[N+44>>2]|0;if(!((b|0)==(N+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=O+36|0;b=k[g>>2]|0;do if(b|0){M=b+12|0;N=k[M>>2]|0;k[M>>2]=N+-1;if((N|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[O+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;N=O+16|0;g=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[g>>2]|0)>0){c=k[L>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[O+44>>2]|0;if((b|0)==(O+48|0)|(b|0)==0){r=P;return}ggb(k[b+-4>>2]|0);r=P;return}function Mj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=r;r=r+48|0;h=e+32|0;g=e+16|0;f=e;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=a;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;b=f+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=c;oV(h,g,f,d);r=e;return}function Nj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0,h=0,j=0,l=0.0,m=0,n=0,p=0,q=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=r;r=r+304|0;L=M+240|0;K=M+184|0;v=M+168|0;J=M+56|0;D=M+24|0;E=M+16|0;p=M;k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;n=p+4|0;k[n>>2]=b;k[L>>2]=k[a>>2];m=L+4|0;d=a+4|0;b=k[d>>2]|0;k[m>>2]=b;I=L+8|0;k[I>>2]=k[a+8>>2];k[L+12>>2]=k[a+12>>2];k[L+16>>2]=k[a+16>>2];k[L+20>>2]=k[a+20>>2];k[L+24>>2]=k[a+24>>2];k[L+28>>2]=k[a+28>>2];k[L+32>>2]=k[a+32>>2];e=k[a+36>>2]|0;k[L+36>>2]=e;g=L+40|0;k[g>>2]=I;I=L+48|0;j=L+44|0;k[j>>2]=I;k[L+52>>2]=0;k[I>>2]=0;if(e){b=e+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[d>>2]|0}if((b|0)>=3){k[m>>2]=0;x1(L,b,0,0,0);if((k[m>>2]|0)>0){h=k[a+40>>2]|0;g=k[g>>2]|0;e=k[a+44>>2]|0;d=k[j>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[h+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else{H=k[a+44>>2]|0;I=k[j>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2]}do if((k[p>>2]&2031616|0)==65536){h=k[n>>2]|0;k[K>>2]=k[h>>2];m=K+4|0;d=h+4|0;k[m>>2]=k[d>>2];I=K+8|0;k[I>>2]=k[h+8>>2];k[K+12>>2]=k[h+12>>2];k[K+16>>2]=k[h+16>>2];k[K+20>>2]=k[h+20>>2];k[K+24>>2]=k[h+24>>2];k[K+28>>2]=k[h+28>>2];k[K+32>>2]=k[h+32>>2];b=k[h+36>>2]|0;k[K+36>>2]=b;e=K+40|0;k[e>>2]=I;I=K+48|0;a=K+44|0;k[a>>2]=I;k[K+52>>2]=0;k[I>>2]=0;if(b|0){I=b+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[d>>2]|0)<3){H=k[h+44>>2]|0;I=k[a>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2];break}k[m>>2]=0;x1(K,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[h+40>>2]|0;g=k[e>>2]|0;e=k[h+44>>2]|0;d=k[a>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(K,p,-1);while(0);k[v>>2]=L;k[v+4>>2]=K;k[v+8>>2]=0;k[J>>2]=1124007936;H=J+4|0;b=J+8|0;F=J+40|0;g=H;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[F>>2]=b;I=J+48|0;G=J+44|0;k[G>>2]=I;k[J+52>>2]=0;k[I>>2]=0;k[J+56>>2]=1124007936;B=J+60|0;b=J+64|0;z=J+96|0;g=B;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[z>>2]=b;C=J+104|0;A=J+100|0;k[A>>2]=C;k[J+108>>2]=0;k[C>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;z1(D,v,J,0,-1);v=k[L>>2]|0;if(!((v&7|0)==5?((k[K>>2]^v)&4095|0)==0:0)){k[E>>2]=0;b=E+4|0;k[b>>2]=0;d=ZT(52)|0;k[d>>2]=1;g=d+4|0;k[E>>2]=g;k[b>>2]=46;i[d+50>>0]=0;e=334670;h=g+46|0;do{i[g>>0]=i[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(h|0));Y8(-215,E,334717,333645,2344);k[b>>2]=0;k[E>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0)}p=D+4|0;v=k[p>>2]|0;if(!((k[v>>2]&16384|0)!=0?(k[v+56>>2]&16384|0)!=0:0)){k[E>>2]=0;b=E+4|0;k[b>>2]=0;d=ZT(64)|0;k[d>>2]=1;g=d+4|0;k[E>>2]=g;k[b>>2]=58;i[d+62>>0]=0;e=334729;h=g+58|0;do{i[g>>0]=i[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(h|0));Y8(-215,E,334717,333645,2348);k[b>>2]=0;k[E>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0)}j=D+16|0;m=(c|0)==1;n=E+4|0;w=0.0;t=0.0;x=0.0;y=0.0;u=0.0;s=0.0;a=0;while(1){if(a>>>0>=(k[j>>2]|0)>>>0)break;g=k[p>>2]|0;d=k[g+16>>2]|0;e=k[g+72>>2]|0;g=aa(k[g+12>>2]|0,k[g+8>>2]|0)|0;g=aa(g,((k[L>>2]|0)>>>3&511)+1|0)|0;switch(c|0){case 1:case 4:{if((g|0)>0)if(m){b=0;f=w;do{l=+o[d+(b<<2)>>2];q=l-+o[e+(b<<2)>>2];if(+P(+l)>2.220446049250313e-16)f=f+q*q/l;b=b+1|0}while((b|0)!=(g|0));q=y;l=x}else{b=0;f=w;do{w=+o[d+(b<<2)>>2];q=+o[e+(b<<2)>>2];l=w-q;q=w+q;if(+P(+q)>2.220446049250313e-16)f=f+l*l/q;b=b+1|0}while((b|0)!=(g|0));q=y;l=x}else{q=y;l=x;f=w}break}case 0:{if((g|0)>0){b=0;l=x;q=y;f=u;do{x=+o[d+(b<<2)>>2];y=+o[e+(b<<2)>>2];f=f+x*y;t=t+x;q=q+x*x;l=l+y;s=s+y*y;b=b+1|0}while((b|0)!=(g|0));u=f;f=w}else{q=y;l=x;f=w}break}case 2:{if((g|0)>0){b=0;f=w;do{q=+o[e+(b<<2)>>2];w=+o[d+(b<<2)>>2];f=f+(q<w?q:w);b=b+1|0}while((b|0)!=(g|0));q=y;l=x}else{q=y;l=x;f=w}break}case 3:{if((g|0)>0){q=t;l=x;b=0;f=w;while(1){t=+o[d+(b<<2)>>2];x=+o[e+(b<<2)>>2];f=f+ +Q(+(t*x));t=q+t;l=l+x;b=b+1|0;if((b|0)==(g|0)){q=y;break}else q=t}}else{q=y;l=x;f=w}break}case 5:{if((g|0)>0){b=0;f=w;do{w=+o[d+(b<<2)>>2];l=w;q=+o[e+(b<<2)>>2];if(!(+P(+w)<=2.220446049250313e-16)){v=!(+P(+q)<=2.220446049250313e-16);f=f+l*+_(+(l/(v?q:1.0e-10)))}b=b+1|0}while((b|0)!=(g|0));q=y;l=x}else{q=y;l=x;f=w}break}default:{k[E>>2]=0;k[n>>2]=0;b=ZT(32)|0;k[b>>2]=1;g=b+4|0;k[E>>2]=g;k[n>>2]=25;i[b+29>>0]=0;e=340548;h=g+25|0;do{i[g>>0]=i[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(h|0));Y8(-5,E,334717,333645,2517);k[n>>2]=0;k[E>>2]=0;v=k[b>>2]|0;k[b>>2]=v+-1;if((v|0)==1)ggb(k[b+-4>>2]|0);q=y;l=x;f=w}}A1(D);w=f;x=l;y=q;a=a+1|0}switch(c|0){case 4:{f=w*2.0;break}case 0:{e=k[L+4>>2]|0;if((e|0)<3)b=aa(k[L+12>>2]|0,k[L+8>>2]|0)|0;else{g=k[L+40>>2]|0;d=0;b=1;do{b=aa(k[g+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}l=1.0/+(b>>>0);f=(y-t*t*l)*(s-x*x*l);if(+P(+f)>2.220446049250313e-16)f=(u-x*t*l)/+Q(+f);else f=1.0;break}case 3:{f=x*t;if(+P(+f)>1.1920928955078125e-07)f=1.0/+Q(+f);else f=1.0;f=1.0-w*f;f=+Q(+(f<0.0?0.0:f));break}default:f=w}e=J+92|0;b=k[e>>2]|0;if(b|0?(D=b+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[J+88>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;E=J+72|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[B>>2]|0))}b=k[A>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=J+36|0;b=k[e>>2]|0;if(b|0?(D=b+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[J+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;J=J+16|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[H>>2]|0)>0){d=k[F>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[H>>2]|0))}b=k[G>>2]|0;if(!((b|0)==(I|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=K+36|0;b=k[e>>2]|0;if(b|0?(I=b+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[K+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;J=K+16|0;d=K+4|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[d>>2]|0)>0){e=k[K+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[K+44>>2]|0;if(!((b|0)==(K+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=L+36|0;b=k[e>>2]|0;if(b|0?(J=b+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[L+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;K=L+16|0;d=L+4|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[d>>2]|0)>0){e=k[L+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[L+44>>2]|0;if((b|0)==(L+48|0)|(b|0)==0){r=M;return +f}ggb(k[b+-4>>2]|0);r=M;return +f}function Oj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+16|0;d=c;e=d+4+4|0;k[e>>2]=0;k[e+4>>2]=0;k[d>>2]=50397184;k[d+4>>2]=a;S2(d,b);r=c;return}function Pj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;d=Aea(g,f,c,d)|0;r=e;return d|0}function Qj(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+320|0;w=x+256|0;o=x+248|0;u=x+192|0;t=x+56|0;s=x+48|0;m=x+32|0;p=x+16|0;q=x;n=m+4|0;l=m+4+4|0;k[l>>2]=0;k[l+4>>2]=0;k[m>>2]=33619968;k[n>>2]=b;l=p+4+4|0;k[l>>2]=0;k[l+4>>2]=0;k[p>>2]=33619968;k[p+4>>2]=c;l=q+4+4|0;k[l>>2]=0;k[l+4>>2]=0;k[q>>2]=33619968;k[q+4>>2]=d;k[w>>2]=k[a>>2];l=w+4|0;c=a+4|0;b=k[c>>2]|0;k[l>>2]=b;h=w+8|0;k[h>>2]=k[a+8>>2];k[w+12>>2]=k[a+12>>2];k[w+16>>2]=k[a+16>>2];k[w+20>>2]=k[a+20>>2];k[w+24>>2]=k[a+24>>2];k[w+28>>2]=k[a+28>>2];k[w+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[w+36>>2]=d;v=w+40|0;k[v>>2]=h;h=w+48|0;j=w+44|0;k[j>>2]=h;k[w+52>>2]=0;k[h>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[l>>2]=0;x1(w,b,0,0,0);if((k[l>>2]|0)>0){g=k[a+40>>2]|0;h=k[v>>2]|0;d=k[a+44>>2]|0;c=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[g+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{a=k[a+44>>2]|0;l=k[j>>2]|0;k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2]}a=k[v>>2]|0;l=k[a>>2]|0;k[o>>2]=k[a+4>>2];k[o+4>>2]=l;x2(m,o,f&7,0);do if((k[m>>2]&2031616|0)==65536){g=k[n>>2]|0;k[u>>2]=k[g>>2];l=u+4|0;b=g+4|0;k[l>>2]=k[b>>2];o=u+8|0;k[o>>2]=k[g+8>>2];k[u+12>>2]=k[g+12>>2];k[u+16>>2]=k[g+16>>2];k[u+20>>2]=k[g+20>>2];k[u+24>>2]=k[g+24>>2];k[u+28>>2]=k[g+28>>2];k[u+32>>2]=k[g+32>>2];c=k[g+36>>2]|0;k[u+36>>2]=c;d=u+40|0;k[d>>2]=o;o=u+48|0;j=u+44|0;k[j>>2]=o;k[u+52>>2]=0;k[o>>2]=0;if(c|0){o=c+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[b>>2]|0)<3){n=k[g+44>>2]|0;o=k[j>>2]|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];break}k[l>>2]=0;x1(u,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){a=k[g+40>>2]|0;h=k[d>>2]|0;d=k[g+44>>2]|0;c=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(u,m,-1);while(0);k[t>>2]=p;k[t+4>>2]=1124007936;b=t+12|0;c=t+44|0;g=t+8|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[c>>2]=b;b=t+52|0;k[t+48>>2]=b;k[t+56>>2]=0;k[b>>2]=0;k[t+60>>2]=q;k[t+64>>2]=1124007936;b=t+72|0;c=t+104|0;g=t+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[c>>2]=b;q=t+112|0;k[t+108>>2]=q;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;k[q+16>>2]=0;switch(f|0){case 2:{g=Cea(w,u,e,t)|0;break}case 4:{g=Cea(w,u,e,t)|0;break}default:{k[s>>2]=0;b=s+4|0;k[b>>2]=0;c=ZT(44)|0;k[c>>2]=1;g=c+4|0;k[s>>2]=g;k[b>>2]=37;i[c+41>>0]=0;d=242588;h=g+37|0;do{i[g>>0]=i[d>>0]|0;g=g+1|0;d=d+1|0}while((g|0)<(h|0));Y8(-210,s,242889,242646,394);k[b>>2]=0;k[s>>2]=0;s=k[c>>2]|0;k[c>>2]=s+-1;if((s|0)==1)ggb(k[c+-4>>2]|0);g=0}}Dea(t);d=u+36|0;b=k[d>>2]|0;if(b|0?(s=b+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[u+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;t=u+16|0;c=u+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[c>>2]|0)>0){d=k[u+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[u+44>>2]|0;if(!((b|0)==(u+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=w+36|0;b=k[d>>2]|0;if(b|0?(t=b+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[w+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;u=w+16|0;d=w+4|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[d>>2]|0)>0){c=k[v>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[w+44>>2]|0;if((b|0)==(w+48|0)|(b|0)==0){r=x;return g|0}ggb(k[b+-4>>2]|0);r=x;return g|0}function Rj(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0;d=r;r=r+16|0;e=d;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=a;c=+Zra(e,b);r=d;return +c}function Sj(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0;g=r;r=r+64|0;l=g+48|0;j=g+32|0;i=g+16|0;h=g;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=a;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=b;b=i+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=c;c=h+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=d;goa(l,j,i,h,e,f);r=g;return}function Tj(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;KW(g,f,c,d);r=e;return}function Uj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;Kea(g,f,c,d);r=e;return}function Vj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0.0,n=0,o=0,q=0,s=0.0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0;M=r;r=r+240|0;L=M+176|0;K=M+120|0;I=M+104|0;D=M+72|0;G=M;l=M+88|0;H=M+56|0;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;j=l+4|0;k[j>>2]=b;h=H+4+4|0;k[h>>2]=0;k[h+4>>2]=0;k[H>>2]=33619968;k[H+4>>2]=c;k[L>>2]=k[a>>2];h=L+4|0;c=a+4|0;b=k[c>>2]|0;k[h>>2]=b;F=L+8|0;k[F>>2]=k[a+8>>2];k[L+12>>2]=k[a+12>>2];k[L+16>>2]=k[a+16>>2];k[L+20>>2]=k[a+20>>2];k[L+24>>2]=k[a+24>>2];k[L+28>>2]=k[a+28>>2];k[L+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[L+36>>2]=d;e=L+40|0;k[e>>2]=F;F=L+48|0;g=L+44|0;k[g>>2]=F;k[L+52>>2]=0;k[F>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[h>>2]=0;x1(L,b,0,0,0);if((k[h>>2]|0)>0){f=k[a+40>>2]|0;e=k[e>>2]|0;d=k[a+44>>2]|0;c=k[g>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else{E=k[a+44>>2]|0;F=k[g>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2]}B=y2(L,2,4,1)|0;if((B|0)>-1)if((B|0)>=4){do if((k[l>>2]&2031616|0)==65536){f=k[j>>2]|0;k[K>>2]=k[f>>2];h=K+4|0;c=f+4|0;k[h>>2]=k[c>>2];F=K+8|0;k[F>>2]=k[f+8>>2];k[K+12>>2]=k[f+12>>2];k[K+16>>2]=k[f+16>>2];k[K+20>>2]=k[f+20>>2];k[K+24>>2]=k[f+24>>2];k[K+28>>2]=k[f+28>>2];k[K+32>>2]=k[f+32>>2];b=k[f+36>>2]|0;k[K+36>>2]=b;d=K+40|0;k[d>>2]=F;F=K+48|0;g=K+44|0;k[g>>2]=F;k[K+52>>2]=0;k[F>>2]=0;if(b|0){F=b+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[c>>2]|0)<3){E=k[f+44>>2]|0;F=k[g>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2];break}k[h>>2]=0;x1(K,k[c>>2]|0,0,0,0);if((k[h>>2]|0)>0){a=k[f+40>>2]|0;e=k[d>>2]|0;d=k[f+44>>2]|0;c=k[g>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else Q1(K,l,-1);while(0);A=y2(K,1,4,1)|0;if((A|0)<=2){k[I>>2]=0;b=I+4|0;k[b>>2]=0;c=ZT(16)|0;k[c>>2]=1;f=c+4|0;k[I>>2]=f;k[b>>2]=11;i[c+15>>0]=0;g=243879;a=f+11|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(a|0));Y8(-215,I,243862,243757,279);k[b>>2]=0;k[I>>2]=0;F=k[c>>2]|0;k[c>>2]=F+-1;if((F|0)==1)ggb(k[c+-4>>2]|0)}w=k[L+16>>2]|0;E=K+16|0;x=k[E>>2]|0;F=K+44|0;k[I>>2]=0;C=I+4|0;k[C>>2]=0;k[I+8>>2]=0;e=k[x+4>>2]|0;z=k[x>>2]|0;y=k[x+8>>2]|0;y=(((y|0)>(e|0)&1)+((e|0)>(z|0)&1)+((z|0)>(y|0)&1)|0)!=2;z=A+-1|0;e=k[x+((y?0:z)<<2)>>2]|0;if(!((e|0)>-1&(e|0)<(B|0))){k[D>>2]=0;b=D+4|0;k[b>>2]=0;c=ZT(36)|0;k[c>>2]=1;f=c+4|0;k[D>>2]=f;k[b>>2]=29;i[c+33>>0]=0;g=243891;a=f+29|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(a|0));Y8(-215,D,243862,243757,290);k[b>>2]=0;k[D>>2]=0;q=k[c>>2]|0;k[c>>2]=q+-1;if((q|0)==1)ggb(k[c+-4>>2]|0)}if((A|0)>0){j=D+4|0;l=D+8|0;n=D+12|0;o=I+8|0;q=D+4|0;d=0;b=0;c=e;while(1){h=k[x+((y?z-b|0:b)<<2)>>2]|0;if(!((h|0)>-1&(h|0)<(B|0))){k[D>>2]=0;k[q>>2]=0;e=ZT(36)|0;k[e>>2]=1;f=e+4|0;k[D>>2]=f;k[q>>2]=29;i[e+33>>0]=0;g=243921;a=f+29|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(a|0));Y8(-215,D,243862,243757,295);k[q>>2]=0;k[D>>2]=0;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)==1)ggb(k[e+-4>>2]|0)}f=k[w+(c<<3)>>2]|0;g=k[w+(c<<3)+4>>2]|0;a=(k[w+(h<<3)>>2]|0)-f|0;s=+(a|0);e=(k[w+(h<<3)+4>>2]|0)-g|0;t=+(e|0);if(!(e|a))v=0.0;else v=1.0/+Q(+(s*s+t*t));d=d+1|0;d=(d|0)<(B|0)?d:0;if((d|0)!=(h|0)){e=0;m=0.0;a=-1;do{O=v*+P(+(s*+((k[w+(d<<3)+4>>2]|0)-g|0)-t*+((k[w+(d<<3)>>2]|0)-f|0)));N=O>m;a=N?d:a;m=N?O:m;e=e|N;N=d+1|0;d=(N|0)<(B|0)?N:0}while((d|0)!=(h|0));if(e){m=m*256.0;p[u>>3]=m;d=k[u+4>>2]|0;N=d&2146435072;if(!(N>>>0>1126170624|(N|0)==1126170624&0>0)){d=(d|0)<0;m=d?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=d?-0.0:0.0}d=~~m;k[D>>2]=c;k[j>>2]=h;k[l>>2]=a;k[n>>2]=d;e=k[C>>2]|0;if((e|0)==(k[o>>2]|0))Vea(I,D);else{k[e>>2]=c;k[e+4>>2]=h;k[e+8>>2]=a;k[e+12>>2]=d;k[C>>2]=e+16}}}b=b+1|0;if((A|0)>(b|0)){d=h;c=h}else break}}k[G>>2]=1124024348;n=G+4|0;k[n>>2]=2;q=G+8|0;N=k[C>>2]|0;b=k[I>>2]|0;c=N-b|0;k[q>>2]=c>>4;k[G+12>>2]=1;h=G+16|0;k[h>>2]=0;d=G+20|0;k[d>>2]=0;e=G+24|0;k[e>>2]=0;a=G+32|0;k[a>>2]=0;j=G+36|0;k[j>>2]=0;l=G+40|0;k[l>>2]=q;q=G+48|0;o=G+44|0;k[o>>2]=q;f=G+52|0;k[f>>2]=0;k[q>>2]=0;g=b;if((g|0)!=(N|0)){k[f>>2]=16;k[q>>2]=16;k[h>>2]=g;k[d>>2]=g;N=b+c|0;k[e>>2]=N;k[G+28>>2]=N}mY(G,H);b=k[j>>2]|0;if(b|0?(H=b+12|0,N=k[H>>2]|0,k[H>>2]=N+-1,(N|0)==1):0){c=k[j>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a>>2]|0;if(!b){b=B1()|0;c=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[j>>2]=0}k[j>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[n>>2]|0)>0){c=k[l>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[n>>2]|0))}b=k[o>>2]|0;if(!((b|0)==(q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[I>>2]|0;c=b;if(b|0){d=k[C>>2]|0;if((d|0)!=(b|0))k[C>>2]=d+(~((d+-16-c|0)>>>4)<<4);ggb(b)}d=K+36|0;b=k[d>>2]|0;if(b|0?(I=b+12|0,N=k[I>>2]|0,k[I>>2]=N+-1,(N|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[K+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=K+4|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[d>>2]|0)>0){c=k[K+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[F>>2]|0;if(!((b|0)==(K+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else J=13;else{k[K>>2]=0;b=K+4|0;k[b>>2]=0;c=ZT(20)|0;k[c>>2]=1;f=c+4|0;k[K>>2]=f;k[b>>2]=12;i[c+16>>0]=0;g=243849;a=f+12|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(a|0));Y8(-215,K,243862,243757,269);k[b>>2]=0;k[K>>2]=0;N=k[c>>2]|0;k[c>>2]=N+-1;if((N|0)==1)ggb(k[c+-4>>2]|0);J=13}if((J|0)==13)b2(H);d=L+36|0;b=k[d>>2]|0;if(b|0?(K=b+12|0,N=k[K>>2]|0,k[K>>2]=N+-1,(N|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[L+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;N=L+16|0;c=L+4|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[c>>2]|0)>0){d=k[L+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[L+44>>2]|0;if((b|0)==(L+48|0)|(b|0)==0){r=M;return}ggb(k[b+-4>>2]|0);r=M;return}function Wj(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0;i=r;r=r+32|0;l=i+16|0;j=i;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=a;a=j+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=b;vY(l,j,c,d,e,f,g,h);r=i;return}function Xj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+144|0;s=t+88|0;n=t+80|0;o=t+72|0;q=t+16|0;p=t;m=p+4|0;l=p+4+4|0;k[l>>2]=0;k[l+4>>2]=0;k[p>>2]=33619968;k[m>>2]=b;k[s>>2]=k[a>>2];l=s+4|0;f=a+4|0;b=k[f>>2]|0;k[l>>2]=b;i=s+8|0;k[i>>2]=k[a+8>>2];k[s+12>>2]=k[a+12>>2];k[s+16>>2]=k[a+16>>2];k[s+20>>2]=k[a+20>>2];k[s+24>>2]=k[a+24>>2];k[s+28>>2]=k[a+28>>2];k[s+32>>2]=k[a+32>>2];g=k[a+36>>2]|0;k[s+36>>2]=g;h=s+40|0;k[h>>2]=i;i=s+48|0;j=s+44|0;k[j>>2]=i;k[s+52>>2]=0;k[i>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[f>>2]|0}if((b|0)>=3){k[l>>2]=0;x1(s,b,0,0,0);if((k[l>>2]|0)>0){i=k[a+40>>2]|0;h=k[h>>2]|0;g=k[a+44>>2]|0;f=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[i+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{a=k[a+44>>2]|0;l=k[j>>2]|0;k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2]}R1(n,p,-1);b=S1(p,-1)|0;if(!((k[n+4>>2]|0)==(k[s+8>>2]|0)?(n=aa(k[n>>2]|0,(b>>>3&511)+1|0)|0,(b&7|0)==5?(n|0)==((k[s+12>>2]|0)*6|0):0):0)){l=k[s+40>>2]|0;n=k[l>>2]|0;k[o>>2]=k[l+4>>2];k[o+4>>2]=n;x2(p,o,45,0)}do if((k[p>>2]&2031616|0)==65536){h=k[m>>2]|0;k[q>>2]=k[h>>2];l=q+4|0;b=h+4|0;k[l>>2]=k[b>>2];p=q+8|0;k[p>>2]=k[h+8>>2];k[q+12>>2]=k[h+12>>2];k[q+16>>2]=k[h+16>>2];k[q+20>>2]=k[h+20>>2];k[q+24>>2]=k[h+24>>2];k[q+28>>2]=k[h+28>>2];k[q+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[q+36>>2]=f;g=q+40|0;k[g>>2]=p;p=q+48|0;a=q+44|0;k[a>>2]=p;k[q+52>>2]=0;k[p>>2]=0;if(f|0){p=f+12|0;k[p>>2]=(k[p>>2]|0)+1}if((k[b>>2]|0)<3){o=k[h+44>>2]|0;p=k[a>>2]|0;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];break}k[l>>2]=0;x1(q,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[h+40>>2]|0;i=k[g>>2]|0;g=k[h+44>>2]|0;f=k[a>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[j+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(q,p,-1);while(0);Xea(s,q,c,d,2,0.0,e);g=q+36|0;b=k[g>>2]|0;if(b|0?(d=b+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[q+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;e=q+16|0;f=q+4|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[f>>2]|0)>0){g=k[q+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[q+44>>2]|0;if(!((b|0)==(q+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=s+36|0;b=k[g>>2]|0;if(b|0?(e=b+12|0,q=k[e>>2]|0,k[e>>2]=q+-1,(q|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[s+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;q=s+16|0;f=s+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[f>>2]|0)>0){g=k[s+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[s+44>>2]|0;if((b|0)==(s+48|0)|(b|0)==0){r=t;return}ggb(k[b+-4>>2]|0);r=t;return}function Yj(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;var g=0,h=0,i=0;g=r;r=r+32|0;i=g+16|0;h=g;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=a;a=h+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=b;Yea(i,h,c,d,e,f);r=g;return}function Zj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=r;r=r+32|0;h=f+16|0;g=f;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=a;a=g+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=b;Wea(h,g,c,d,e);r=f;return}function _j(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0,j=0,l=0.0,m=0,n=0,q=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0;ua=r;r=r+288|0;pa=ua+272|0;ta=ua+216|0;sa=ua+160|0;ra=ua+104|0;qa=ua+32|0;ma=ua+24|0;na=ua+16|0;oa=ua;m=ua+88|0;n=m+4|0;la=m+4+4|0;k[la>>2]=0;k[la+4>>2]=0;k[m>>2]=50397184;k[n>>2]=b;la=k[c>>2]|0;ka=k[c+4>>2]|0;B=k[d>>2]|0;A=k[d+4>>2]|0;c=k[e>>2]|0;b=k[e+4>>2]|0;g=+p[e+8>>3];y=la<<1;ia=y|1;z=ka<<1;ja=z|1;if(!(c&1))ha=100;else{ha=(b|0)<1?1:b;ha=(ha|0)>100?100:ha}ga=(c&2|0)==0|g<0.0?0.0:g;ga=ga*ga;k[ta>>2]=k[a>>2];j=ta+4|0;c=a+4|0;b=k[c>>2]|0;k[j>>2]=b;fa=ta+8|0;k[fa>>2]=k[a+8>>2];k[ta+12>>2]=k[a+12>>2];k[ta+16>>2]=k[a+16>>2];k[ta+20>>2]=k[a+20>>2];k[ta+24>>2]=k[a+24>>2];k[ta+28>>2]=k[a+28>>2];k[ta+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[ta+36>>2]=d;e=ta+40|0;k[e>>2]=fa;fa=ta+48|0;h=ta+44|0;k[h>>2]=fa;k[ta+52>>2]=0;k[fa>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[j>>2]=0;x1(ta,b,0,0,0);if((k[j>>2]|0)>0){f=k[a+40>>2]|0;e=k[e>>2]|0;d=k[a+44>>2]|0;c=k[h>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else{ea=k[a+44>>2]|0;fa=k[h>>2]|0;k[fa>>2]=k[ea>>2];k[fa+4>>2]=k[ea+4>>2]}do if((k[m>>2]&2031616|0)==65536){e=k[n>>2]|0;k[sa>>2]=k[e>>2];a=sa+4|0;b=e+4|0;k[a>>2]=k[b>>2];fa=sa+8|0;k[fa>>2]=k[e+8>>2];k[sa+12>>2]=k[e+12>>2];k[sa+16>>2]=k[e+16>>2];k[sa+20>>2]=k[e+20>>2];k[sa+24>>2]=k[e+24>>2];k[sa+28>>2]=k[e+28>>2];k[sa+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[sa+36>>2]=c;d=sa+40|0;k[d>>2]=fa;fa=sa+48|0;h=sa+44|0;k[h>>2]=fa;k[sa+52>>2]=0;k[fa>>2]=0;if(c|0){fa=c+12|0;k[fa>>2]=(k[fa>>2]|0)+1}if((k[b>>2]|0)<3){ea=k[e+44>>2]|0;fa=k[h>>2]|0;k[fa>>2]=k[ea>>2];k[fa+4>>2]=k[ea+4>>2];break}k[a>>2]=0;x1(sa,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){j=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[h>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[j+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0))}}else Q1(sa,m,-1);while(0);ba=y2(sa,2,5,1)|0;if((ba|0)>-1){e=sa+16|0;f=sa+44|0;if(ba)x=24}else{k[pa>>2]=0;b=pa+4|0;k[b>>2]=0;c=ZT(16)|0;k[c>>2]=1;h=c+4|0;k[pa>>2]=h;k[b>>2]=10;i[c+14>>0]=0;d=244155;j=h+10|0;do{i[h>>0]=i[d>>0]|0;h=h+1|0;d=d+1|0}while((h|0)<(j|0));Y8(-215,pa,244166,244179,56);k[b>>2]=0;k[pa>>2]=0;fa=k[c>>2]|0;k[c>>2]=fa+-1;if((fa|0)==1)ggb(k[c+-4>>2]|0);e=sa+16|0;f=sa+44|0;x=24}if((x|0)==24){_=k[e>>2]|0;if(!((la|0)>0&(ka|0)>0)){k[pa>>2]=0;b=pa+4|0;k[b>>2]=0;c=ZT(36)|0;k[c>>2]=1;h=c+4|0;k[pa>>2]=h;k[b>>2]=31;i[c+35>>0]=0;d=244253;j=h+31|0;do{i[h>>0]=i[d>>0]|0;h=h+1|0;d=d+1|0}while((h|0)<(j|0));Y8(-215,pa,244166,244179,62);k[b>>2]=0;k[pa>>2]=0;fa=k[c>>2]|0;k[c>>2]=fa+-1;if((fa|0)==1)ggb(k[c+-4>>2]|0)}X=ta+12|0;if(!((k[X>>2]|0)>=(y+5|0)?(k[ta+8>>2]|0)>=(z+5|0):0)){k[pa>>2]=0;b=pa+4|0;k[b>>2]=0;c=ZT(64)|0;k[c>>2]=1;h=c+4|0;k[pa>>2]=h;k[b>>2]=59;i[c+63>>0]=0;d=244285;j=h+59|0;do{i[h>>0]=i[d>>0]|0;h=h+1|0;d=d+1|0}while((h|0)<(j|0));Y8(-215,pa,244166,244179,63);k[b>>2]=0;k[pa>>2]=0;fa=k[c>>2]|0;k[c>>2]=fa+-1;if((fa|0)==1)ggb(k[c+-4>>2]|0)}if(k[ta>>2]&4088|0){k[pa>>2]=0;b=pa+4|0;k[b>>2]=0;c=ZT(24)|0;k[c>>2]=1;h=c+4|0;k[pa>>2]=h;k[b>>2]=19;i[c+23>>0]=0;d=244345;j=h+19|0;do{i[h>>0]=i[d>>0]|0;h=h+1|0;d=d+1|0}while((h|0)<(j|0));Y8(-215,pa,244166,244179,64);k[b>>2]=0;k[pa>>2]=0;fa=k[c>>2]|0;k[c>>2]=fa+-1;if((fa|0)==1)ggb(k[c+-4>>2]|0)}k[ra>>2]=1124007936;ea=ra+4|0;b=ra+8|0;ca=ra+40|0;h=ea;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[ca>>2]=b;fa=ra+48|0;da=ra+44|0;k[da>>2]=fa;k[ra+52>>2]=0;k[fa>>2]=0;k[pa>>2]=ja;c=pa+4|0;k[c>>2]=ia;G1(ra,2,pa,5);S=ja+2|0;T=ia+2|0;k[qa>>2]=1124007936;Y=qa+4|0;b=qa+8|0;V=qa+40|0;h=Y;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[V>>2]=b;W=qa+48|0;U=qa+44|0;k[U>>2]=W;k[qa+52>>2]=0;k[W>>2]=0;k[pa>>2]=S;k[c>>2]=T;G1(qa,2,pa,5);$=ra+16|0;Q=k[$>>2]|0;R=(ja|0)>0;if(R?(q=+(ka|0),(ia|0)>0):0){g=+(la|0);c=0;do{l=+(c-ka|0)/q;l=+Z(+-(l*l));d=aa(c,ia)|0;b=0;do{M=+(b-la|0)/g;M=l*+Z(+-(M*M));o[Q+(b+d<<2)>>2]=M;b=b+1|0}while((b|0)!=(ia|0));c=c+1|0}while((c|0)!=(ja|0))}if((((((B|A|0)>-1?(B<<1|1|0)<(ia|0):0)?(G=A<<1,(G|1|0)<(ja|0)):0)?(C=ka-A|0,D=A+ka|0,(C|0)<=(D|0)):0)?(E=la-B|0,F=B+la|0,(E|0)<=(F|0)):0)?(J=Q+(la+(aa(C,ia)|0)-B<<2)|0,H=la<<3|4,I=B+1-la+((F|0)>(E|0)?F:E)<<2,zpb(J|0,0,I|0)|0,(C|0)<(D|0)):0){b=0;do{b=b+1|0;zpb(J+(aa(H,b)|0)|0,0,I|0)|0}while((b|0)!=(G|0))}if((ba|0)>0){A=pa+8|0;B=pa+12|0;C=pa+4|0;D=ma+4|0;E=na+4|0;F=oa+4|0;G=F+4|0;H=qa+16|0;I=(ia|0)>0;J=-2-ia|0;K=ta+8|0;L=+(la|0);M=+(ka|0);z=0;do{N=_+(z<<3)|0;x=k[N>>2]|0;O=_+(z<<3)+4|0;y=k[O>>2]|0;n=0;c=x;b=y;do{k[A>>2]=0;k[B>>2]=0;k[pa>>2]=16842752;k[C>>2]=ta;k[ma>>2]=T;k[D>>2]=S;k[na>>2]=c;k[E>>2]=b;m=G;k[m>>2]=0;k[m+4>>2]=0;k[oa>>2]=33619968;k[F>>2]=qa;Wra(pa,ma,na,oa,k[qa>>2]&4095);if(R?I:0){h=0;j=(k[H>>2]|0)+(k[k[U>>2]>>2]|0)+4|0;w=0.0;v=0.0;q=0.0;l=0.0;s=0.0;m=0;while(1){g=+(m-ka|0);a=h;d=0;while(1){wa=+o[Q+(a<<2)>>2];ya=d;d=d+1|0;va=+o[j+(d<<2)>>2]-+o[j+(ya+-1<<2)>>2];t=+o[j+(T+ya<<2)>>2]-+o[j+(J+ya<<2)>>2];xa=wa*(va*va);va=wa*(va*t);t=wa*(t*t);wa=+(ya-la|0);s=s+xa;l=l+va;q=q+t;v=v+(xa*wa+g*va);w=w+(wa*va+g*t);if((d|0)==(ia|0))break;else a=a+1|0}m=m+1|0;if((m|0)==(ja|0))break;else{h=ia+h|0;j=j+(T<<2)|0}}}else{w=0.0;v=0.0;q=0.0;l=0.0;s=0.0}g=s*q-l*l;if(+P(+g)<=4.930380657631324e-32)break;wa=1.0/g;xa=(k[u>>2]=c,+o[u>>2]);g=l*wa;t=xa+v*(q*wa)-w*g;c=(o[u>>2]=t,k[u>>2]|0);q=(k[u>>2]=b,+o[u>>2]);g=w*(s*wa)+(q-v*g);b=(o[u>>2]=g,k[u>>2]|0);l=t-xa;q=g-q;if(t<0.0)break;if(g<0.0?1:t>=+(k[X>>2]|0))break;if(g>=+(k[K>>2]|0))break;n=n+1|0}while((n|0)<(ha|0)?l*l+q*q>ga:0);xa=(k[u>>2]=c,+o[u>>2]);if(!(!(+P(+(xa-(k[u>>2]=x,+o[u>>2])))>L)?(xa=(k[u>>2]=b,+o[u>>2]),!(+P(+(xa-(k[u>>2]=y,+o[u>>2])))>M)):0)){c=x;b=y}k[N>>2]=c;k[O>>2]=b;z=z+1|0}while((z|0)<(ba|0))}d=qa+36|0;b=k[d>>2]|0;if(b|0?(pa=b+12|0,ya=k[pa>>2]|0,k[pa>>2]=ya+-1,(ya|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[qa+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;ya=qa+16|0;k[ya>>2]=0;k[ya+4>>2]=0;k[ya+8>>2]=0;k[ya+12>>2]=0;if((k[Y>>2]|0)>0){c=k[V>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Y>>2]|0))}b=k[U>>2]|0;if(!((b|0)==(W|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=ra+36|0;b=k[d>>2]|0;if(b|0?(qa=b+12|0,ya=k[qa>>2]|0,k[qa>>2]=ya+-1,(ya|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ra+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[ea>>2]|0)>0){c=k[ca>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ea>>2]|0))}b=k[da>>2]|0;if(!((b|0)==(fa|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}d=sa+36|0;b=k[d>>2]|0;if(b|0?(ra=b+12|0,ya=k[ra>>2]|0,k[ra>>2]=ya+-1,(ya|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[sa+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=sa+4|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){c=k[sa+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[f>>2]|0;if(!((b|0)==(sa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=ta+36|0;b=k[d>>2]|0;if(b|0?(sa=b+12|0,ya=k[sa>>2]|0,k[sa>>2]=ya+-1,(ya|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[ta+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;ya=ta+16|0;c=ta+4|0;k[ya>>2]=0;k[ya+4>>2]=0;k[ya+8>>2]=0;k[ya+12>>2]=0;if((k[c>>2]|0)>0){d=k[ta+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[ta+44>>2]|0;if((b|0)==(ta+48|0)|(b|0)==0){r=ua;return}ggb(k[b+-4>>2]|0);r=ua;return}function $j(a){a=a|0;var b=0,c=0;b=r;r=r+16|0;c=b;k[c+8>>2]=0;k[c+12>>2]=0;k[c>>2]=16842752;k[c+4>>2]=a;a=o7(c)|0;r=b;return a|0}function ak(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0,h=0,j=0,l=0,m=0,n=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;A=r;r=r+1216|0;z=A+1152|0;l=A+1144|0;y=A;w=A+1128|0;x=A+1096|0;m=A+1112|0;n=m+4|0;j=m+4+4|0;k[j>>2]=0;k[j+4>>2]=0;k[m>>2]=33619968;k[n>>2]=a;j=k[b>>2]|0;a=k[b+4>>2]|0;if((c+-5|0)>>>0>=2){k[z>>2]=0;b=z+4|0;k[b>>2]=0;d=ZT(44)|0;k[d>>2]=1;e=d+4|0;k[z>>2]=e;k[b>>2]=36;i[d+40>>0]=0;g=347219;h=e+36|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-215,z,347256,347148,574);k[b>>2]=0;k[z>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}k[l>>2]=j;k[l+4>>2]=a;x2(m,l,c,0);do if((k[m>>2]&2031616|0)==65536){h=k[n>>2]|0;k[z>>2]=k[h>>2];m=z+4|0;d=h+4|0;k[m>>2]=k[d>>2];a=z+8|0;k[a>>2]=k[h+8>>2];b=z+12|0;k[b>>2]=k[h+12>>2];k[z+16>>2]=k[h+16>>2];k[z+20>>2]=k[h+20>>2];k[z+24>>2]=k[h+24>>2];k[z+28>>2]=k[h+28>>2];k[z+32>>2]=k[h+32>>2];e=k[h+36>>2]|0;k[z+36>>2]=e;g=z+40|0;k[g>>2]=a;n=z+48|0;c=z+44|0;k[c>>2]=n;k[z+52>>2]=0;k[n>>2]=0;if(e|0){n=e+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[d>>2]|0)<3){m=k[h+44>>2]|0;n=k[c>>2]|0;k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];break}k[m>>2]=0;x1(z,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;e=k[c>>2]|0;d=0;do{k[j+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[g+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else{Q1(z,m,-1);a=z+8|0;b=z+12|0}while(0);h=k[a>>2]|0;g=k[b>>2]|0;j=y+8|0;k[y>>2]=j;c=y+4|0;k[c>>2]=136;if(g>>>0>136){b=g>>>0>536870911?-1:g<<3;b=(b|0)==0?1:b;while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[y>>2]=a}else a=j;k[c>>2]=g;f=6.283185307179586/+(g+-1|0);q=6.283185307179586/+(h+-1|0);d=(g|0)>0;if(d){b=0;do{B=(1.0-+S(+(f*+(b|0))))*.5;p[a+(b<<3)>>3]=B;b=b+1|0}while((b|0)!=(g|0))}b=(h|0)>0;if((k[z>>2]&7|0)==5){if(b?(u=k[z+16>>2]|0,v=k[k[z+44>>2]>>2]|0,d):0){d=0;do{e=u+(aa(v,d)|0)|0;f=(1.0-+S(+(q*+(d|0))))*.5;b=0;do{o[e+(b<<2)>>2]=f*+p[a+(b<<3)>>3];b=b+1|0}while((b|0)!=(g|0));d=d+1|0}while((d|0)!=(h|0))}}else if(b?(s=k[z+16>>2]|0,t=k[k[z+44>>2]>>2]|0,d):0){b=0;do{e=s+(aa(t,b)|0)|0;f=(1.0-+S(+(q*+(b|0))))*.5;d=0;do{p[e+(d<<3)>>3]=f*+p[a+(d<<3)>>3];d=d+1|0}while((d|0)!=(g|0));b=b+1|0}while((b|0)!=(h|0))}k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=z;a=x+4|0;v=a+4|0;k[v>>2]=0;k[v+4>>2]=0;k[x>>2]=33619968;k[a>>2]=z;ZZ(w,.5,x);a=k[y>>2]|0;if((a|0)!=(j|0)){if(a|0)ggb(a);k[y>>2]=j;k[c>>2]=136}d=z+36|0;a=k[d>>2]|0;if(a|0?(x=a+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[z+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;y=z+16|0;b=z+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[b>>2]|0)>0){d=k[z+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[z+44>>2]|0;if((a|0)==(z+48|0)|(a|0)==0){r=A;return}ggb(k[a+-4>>2]|0);r=A;return}function bk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;$aa(g,f,c,d);r=e;return}function ck(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+32|0;f=d+16|0;e=d;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=a;a=e+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=b;sZ(f,e,c);r=d;return}function dk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=r;r=r+48|0;g=d+32|0;f=d+16|0;e=d;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;b=e+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=c;v0a(g,f,e);r=d;return}function ek(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;Zea(g,f,c,d);r=e;return}function fk(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0,Xa=0.0,Ya=0;Sa=r;r=r+928|0;Ka=Sa+472|0;Ja=Sa+464|0;Ra=Sa+864|0;Qa=Sa+808|0;n=Sa+240|0;Ma=Sa+792|0;Aa=Sa+16|0;Ba=Sa+772|0;Ca=Sa+752|0;Da=Sa+732|0;Ea=Sa+712|0;Fa=Sa;Ga=Sa+696|0;m=a+4|0;f=k[m>>2]|0;e=k[a>>2]|0;M=(d|0)>0;if(c>0.0&(M&(f|0)!=(e|0)))za=a;else{e=Ka+4|0;f=ZT(52)|0;k[f>>2]=1;K=f+4|0;k[Ka>>2]=K;k[e>>2]=45;i[f+49>>0]=0;g=394010;L=K+45|0;do{i[K>>0]=i[g>>0]|0;K=K+1|0;g=g+1|0}while((K|0)<(L|0));Y8(-215,Ka,394056,394069,76);k[e>>2]=0;k[Ka>>2]=0;Pa=k[f>>2]|0;k[f>>2]=Pa+-1;if((Pa|0)==1)ggb(k[f+-4>>2]|0);za=a;e=k[a>>2]|0;f=k[m>>2]|0}p[Ja>>3]=c;xa=k[e+8>>2]|0;ya=k[e+12>>2]|0;g=e;if((f-g|0)>56){j=Ka+4|0;h=1;while(1){if(!((k[e+(h*56|0)+8>>2]|0)==(xa|0)?(k[e+(h*56|0)+12>>2]|0)==(ya|0):0)){e=ZT(64)|0;k[e>>2]=1;K=e+4|0;k[Ka>>2]=K;k[j>>2]=56;i[e+60>>0]=0;g=394141;L=K+56|0;do{i[K>>0]=i[g>>0]|0;K=K+1|0;g=g+1|0}while((K|0)<(L|0));Y8(-215,Ka,394056,394069,85);k[j>>2]=0;k[Ka>>2]=0;Pa=k[e>>2]|0;k[e>>2]=Pa+-1;if((Pa|0)==1)ggb(k[e+-4>>2]|0);g=k[a>>2]|0;f=k[m>>2]|0}h=h+1|0;if((h|0)>=((f-g|0)/56|0|0))break;else e=g}}k[Ra>>2]=1124007936;Na=Ra+4|0;sa=Ra+8|0;La=Ra+40|0;K=Na;L=K+36|0;do{k[K>>2]=0;K=K+4|0}while((K|0)<(L|0));k[La>>2]=sa;Pa=Ra+48|0;Oa=Ra+44|0;k[Oa>>2]=Pa;k[Ra+52>>2]=0;k[Pa>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=1124007936;e=n+16|0;f=n+48|0;K=n+12|0;L=K+36|0;do{k[K>>2]=0;K=K+4|0}while((K|0)<(L|0));k[f>>2]=e;e=n+56|0;k[n+52>>2]=e;k[n+60>>2]=0;k[e>>2]=0;k[n+64>>2]=1124007936;e=n+72|0;f=n+104|0;K=n+68|0;L=K+36|0;do{k[K>>2]=0;K=K+4|0}while((K|0)<(L|0));k[f>>2]=e;e=n+112|0;k[n+108>>2]=e;k[n+116>>2]=0;k[e>>2]=0;k[n+120>>2]=1124007936;e=n+128|0;f=n+160|0;K=n+124|0;L=K+36|0;do{k[K>>2]=0;K=K+4|0}while((K|0)<(L|0));k[f>>2]=e;K=n+168|0;k[n+164>>2]=K;L=K+56|0;do{k[K>>2]=0;K=K+4|0}while((K|0)<(L|0));k[Ka>>2]=ya;k[Ka+4>>2]=xa;j1(n,48,Ka,14);k[Qa>>2]=1124007936;va=Qa+4|0;e=Qa+8|0;ta=Qa+40|0;K=va;L=K+36|0;do{k[K>>2]=0;K=K+4|0}while((K|0)<(L|0));k[ta>>2]=e;wa=Qa+48|0;ua=Qa+44|0;k[ua>>2]=wa;k[Qa+52>>2]=0;k[wa>>2]=0;f=k[n>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,n,Qa,-1);XN(n);f=k[za>>2]|0;g=Ka+4|0;n=g+4|0;k[n>>2]=0;k[n+4>>2]=0;k[Ka>>2]=33619968;k[g>>2]=Ra;SW(f,Ka,6,.00392156862745098,0.0);f=(k[m>>2]|0)-(k[a>>2]|0)|0;g=(f|0)/56|0;k[Ma>>2]=0;n=Ma+4|0;k[n>>2]=0;k[Ma+8>>2]=0;if(!f){a=0;m=0;ra=0;e=0}else{if(g>>>0>76695844)ad(426534,426557,304,426811);while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[n>>2]=e;k[Ma>>2]=e;m=e+(g*56|0)|0;k[Ma+8>>2]=m;a=e;f=e;while(1){h=f+8|0;j=f+40|0;K=f+4|0;L=K+36|0;do{k[K>>2]=0;K=K+4|0}while((K|0)<(L|0));k[j>>2]=h;ra=f+48|0;k[f+44>>2]=ra;k[f+52>>2]=0;k[ra>>2]=0;k[f>>2]=1124007942;g=g+-1|0;if(!g)break;else f=f+56|0}k[n>>2]=m;ra=e}if((m-a|0)>0){g=Aa+4|0;h=Aa+8|0;j=Aa+12|0;n=Aa+16|0;o=Aa+48|0;q=Aa+56|0;s=Aa+52|0;t=Aa+60|0;u=Aa+64|0;v=Aa+68|0;w=Aa+72|0;x=Aa+104|0;y=Aa+112|0;z=Aa+108|0;A=Aa+116|0;B=Aa+120|0;C=Aa+124|0;D=Aa+128|0;E=Aa+160|0;F=Aa+168|0;G=Aa+164|0;H=Ka+4|0;I=(m-a|0)/56|0;J=a;f=0;while(1){k[Aa>>2]=0;k[g>>2]=0;k[h>>2]=1124007936;K=j;L=K+36|0;do{k[K>>2]=0;K=K+4|0}while((K|0)<(L|0));k[o>>2]=n;k[s>>2]=q;k[t>>2]=0;k[q>>2]=0;k[u>>2]=1124007936;K=v;L=K+36|0;do{k[K>>2]=0;K=K+4|0}while((K|0)<(L|0));k[x>>2]=w;k[z>>2]=y;k[A>>2]=0;k[y>>2]=0;k[B>>2]=1124007936;K=C;L=K+36|0;do{k[K>>2]=0;K=K+4|0}while((K|0)<(L|0));k[E>>2]=D;k[G>>2]=F;K=F;L=K+56|0;do{k[K>>2]=0;K=K+4|0}while((K|0)<(L|0));k[Ka>>2]=ya;k[H>>2]=xa;j1(Aa,48,Ka,6);qa=k[Aa>>2]|0;dh[k[(k[qa>>2]|0)+12>>2]&255](qa,Aa,e+(f*56|0)|0,6);XN(Aa);f=f+1|0;if((f|0)>=(I|0)){e=J;break}else e=J}}if(M){C=(xa|0)>0;D=Ra+16|0;E=xa+-1|0;F=Qa+16|0;G=ya+-1|0;H=(ya|0)>1;I=Ba+4|0;J=Ba+8|0;K=Ba+12|0;L=Ba+16|0;M=Da+4|0;N=Da+8|0;O=Da+12|0;R=Da+16|0;S=Ea+4|0;T=Ea+8|0;U=Ea+12|0;V=Ea+16|0;W=Ca+8|0;X=Ka+8|0;Y=Ka+12|0;Z=Ka+4|0;_=Aa+8|0;$=Aa+12|0;ba=Aa+4|0;ca=Fa+4|0;da=ca+4|0;ea=Ka+8|0;fa=Ka+12|0;ga=Ka+4|0;ha=Aa+8|0;ia=Aa+12|0;ja=Aa+4|0;ka=Ga+4|0;la=ka+4|0;B=a;ma=Ca+4|0;na=Ca+12|0;oa=Ca+16|0;pa=(m-a|0)/56|0;qa=a;A=0;g=a;f=m;x=m;y=m;z=m;j=m;while(1){c=(A|0)==0?7.25:6.25;a:do if(C){t=k[D>>2]|0;u=k[k[Oa>>2]>>2]|0;v=k[F>>2]|0;w=k[k[ua>>2]>>2]|0;if(H)n=0;else{h=0;while(1){o=t+(aa(u,h)|0)|0;q=h;h=h+1|0;n=t+(aa(u,(E|0)<(h|0)?E:h)|0)|0;q=v+(aa(w,q)|0)|0;s=q+8|0;Ua=+p[s>>3]+c*(+p[n>>3]-+p[o>>3]);Ta=+P(+Ua);p[q>>3]=0.0;p[s>>3]=Ua*(1.0/(Ta<1.0?1.0:Ta));if((h|0)==(xa|0))break a}}do{o=t+(aa(u,n)|0)|0;s=n;n=n+1|0;q=t+(aa(u,(E|0)<(n|0)?E:n)|0)|0;s=v+(aa(w,s)|0)|0;h=0;do{Ya=h;h=h+1|0;Ta=+p[o+(Ya<<3)>>3];Wa=s+(Ya<<4)|0;Xa=+p[Wa>>3]+c*(+p[o+(h<<3)>>3]-Ta);Va=s+(Ya<<4)+8|0;Ta=+p[Va>>3]+c*(+p[q+(Ya<<3)>>3]-Ta);Ua=+Q(+(Xa*Xa+Ta*Ta));Ua=1.0/(Ua<1.0?1.0:Ua);p[Wa>>3]=Xa*Ua;p[Va>>3]=Ta*Ua}while((h|0)!=(G|0));Ya=s+(G<<4)+8|0;Ua=+p[Ya>>3]+c*(+p[q+(G<<3)>>3]-+p[o+(G<<3)>>3]);Xa=+P(+Ua);p[s+(G<<4)>>3]=0.0;p[Ya>>3]=Ua*(1.0/(Xa<1.0?1.0:Xa))}while((n|0)!=(xa|0))}while(0);if((f-g|0)>0){q=0;while(1){f=e+(q*56|0)|0;k[Ba>>2]=f;h=k[e+(q*56|0)+4>>2]|0;if((h|0)>0)n=k[(k[e+(q*56|0)+44>>2]|0)+(h+-1<<2)>>2]|0;else n=0;k[I>>2]=n;k[J>>2]=0;k[K>>2]=0;k[L>>2]=0;if(k[f>>2]&16384|0){j=k[e+(q*56|0)+16>>2]|0;k[K>>2]=j;if((h|0)<3)e=aa(k[e+(q*56|0)+12>>2]|0,k[e+(q*56|0)+8>>2]|0)|0;else{g=k[e+(q*56|0)+40>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}Ya=j+(aa(e,n)|0)|0;k[L>>2]=Ya}q4(Ba,0,0);e=ra+(q*56|0)|0;k[Ca>>2]=e;n=ra+(q*56|0)+4|0;h=k[n>>2]|0;if((h|0)>0)o=k[(k[ra+(q*56|0)+44>>2]|0)+(h+-1<<2)>>2]|0;else o=0;k[ma>>2]=o;k[W>>2]=0;k[na>>2]=0;k[oa>>2]=0;if(k[e>>2]&16384|0){j=k[ra+(q*56|0)+16>>2]|0;k[na>>2]=j;if((h|0)<3)e=aa(k[ra+(q*56|0)+12>>2]|0,k[ra+(q*56|0)+8>>2]|0)|0;else{g=k[ra+(q*56|0)+40>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}Ya=j+(aa(e,o)|0)|0;k[oa>>2]=Ya}q4(Ca,0,0);g=k[n>>2]|0;if((g|0)<3)e=aa(k[ra+(q*56|0)+12>>2]|0,k[ra+(q*56|0)+8>>2]|0)|0;else{h=k[ra+(q*56|0)+40>>2]|0;f=0;e=1;do{e=aa(k[h+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(g|0))}if(!((e|0)==0|(k[Ca>>2]|0)==0)?(Ha=aa(k[ma>>2]|0,e)|0,Ia=(k[W>>2]|0)+Ha|0,k[W>>2]=Ia,!(Ia>>>0>=(k[na>>2]|0)>>>0?(k[oa>>2]|0)>>>0>Ia>>>0:0)):0){k[W>>2]=Ia+(0-Ha);q4(Ca,e,1)}f=k[za>>2]|0;e=f+(q*56|0)|0;k[Da>>2]=e;h=k[f+(q*56|0)+4>>2]|0;if((h|0)>0)n=k[(k[f+(q*56|0)+44>>2]|0)+(h+-1<<2)>>2]|0;else n=0;k[M>>2]=n;k[N>>2]=0;k[O>>2]=0;k[R>>2]=0;if(k[e>>2]&16384|0){j=k[f+(q*56|0)+16>>2]|0;k[O>>2]=j;if((h|0)<3)e=aa(k[f+(q*56|0)+12>>2]|0,k[f+(q*56|0)+8>>2]|0)|0;else{g=k[f+(q*56|0)+40>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}Ya=j+(aa(e,n)|0)|0;k[R>>2]=Ya}q4(Da,0,0);e=ra+(q*56|0)|0;k[Ea>>2]=e;h=k[ra+(q*56|0)+4>>2]|0;if((h|0)>0)n=k[(k[ra+(q*56|0)+44>>2]|0)+(h+-1<<2)>>2]|0;else n=0;k[S>>2]=n;k[T>>2]=0;k[U>>2]=0;k[V>>2]=0;if(k[e>>2]&16384|0){j=k[ra+(q*56|0)+16>>2]|0;k[U>>2]=j;if((h|0)<3)e=aa(k[ra+(q*56|0)+12>>2]|0,k[ra+(q*56|0)+8>>2]|0)|0;else{g=k[ra+(q*56|0)+40>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}Ya=j+(aa(e,n)|0)|0;k[V>>2]=Ya}q4(Ea,0,0);n=k[Ca>>2]|0;o=k[W>>2]|0;while(1){f=k[Ba>>2]|0;if((f|0)==(n|0)){e=k[J>>2]|0;if((e|0)==(o|0))break;else g=e}else{e=k[J>>2]|0;g=e}h=k[N>>2]|0;j=k[T>>2]|0;p[j>>3]=+p[g>>3]-+(l[h>>0]|0)*.024509803921568627;do if(f|0){f=k[I>>2]|0;e=e+f|0;k[J>>2]=e;if(e>>>0<(k[L>>2]|0)>>>0)break;k[J>>2]=e+(0-f);q4(Ba,1,1)}while(0);do if(k[Da>>2]|0){f=k[M>>2]|0;e=h+f|0;k[N>>2]=e;if(e>>>0<(k[R>>2]|0)>>>0)break;k[N>>2]=e+(0-f);q4(Da,1,1)}while(0);if(!(k[Ea>>2]|0))continue;f=k[S>>2]|0;e=j+f|0;k[T>>2]=e;if(e>>>0<(k[V>>2]|0)>>>0)continue;k[T>>2]=e+(0-f);q4(Ea,1,1)}c1(Ka,6.25,Ra);Ya=k[Ka>>2]|0;Ph[k[(k[Ya>>2]|0)+24>>2]&511](Ya,Ka,ra+(q*56|0)|0);XN(Ka);Ya=ra+(q*56|0)|0;k[X>>2]=0;k[Y>>2]=0;k[Ka>>2]=-2130640890;k[Z>>2]=Ya;k[Aa>>2]=-1056833530;k[ba>>2]=Ja;k[_>>2]=1;k[$>>2]=1;Wa=da;k[Wa>>2]=0;k[Wa+4>>2]=0;k[Fa>>2]=-2113863674;k[ca>>2]=Ya;aU(Ka,Aa,Fa,49332,39904,0,13);Ya=ra+(q*56|0)|0;k[ea>>2]=0;k[fa>>2]=0;k[Ka>>2]=-2130640890;k[ga>>2]=Ya;p[Fa>>3]=-+p[Ja>>3];k[Aa>>2]=-1056833530;k[ja>>2]=Fa;k[ha>>2]=1;k[ia>>2]=1;Wa=la;k[Wa>>2]=0;k[Wa+4>>2]=0;k[Ga>>2]=-2113863674;k[ka>>2]=Ya;aU(Ka,Aa,Ga,49332,39872,0,14);q=q+1|0;if((q|0)>=(pa|0)){j=m;x=m;n=m;h=m;e=qa;g=a;f=m;break}else e=qa}}else{n=y;h=z}if(C){s=k[D>>2]|0;t=k[k[Oa>>2]>>2]|0;u=k[F>>2]|0;v=k[k[ua>>2]>>2]|0;w=(j-a|0)>0;y=(x-a|0)/56|0;q=0;f=h;e=j;while(1){h=s+(aa(t,q)|0)|0;j=u+(aa(v,q)|0)|0;o=q+-1|0;o=u+(aa(v,(o|0)<0?0:o)|0)|0;if(w){g=(f-a|0)/56|0;c=0.0;e=0;do{Ya=(k[B+(e*56|0)+16>>2]|0)+(aa(k[k[B+(e*56|0)+44>>2]>>2]|0,q)|0)|0;c=c+ +p[Ya>>3];e=e+1|0}while((e|0)<(g|0));g=f}else{c=0.0;g=e}Xa=+p[h>>3];Ua=Xa+(+p[j+8>>3]-+p[o+8>>3])*.02-c*.02;p[h>>3]=Ua+(Ua-Xa);b:do if(H){if((n-a|0)>0)e=1;else{e=1;while(1){Ya=h+(e<<3)|0;Xa=+p[Ya>>3];Ua=Xa+(+p[j+(e<<4)>>3]-+p[j+(e+-1<<4)>>3]+ +p[j+(e<<4)+8>>3]-+p[o+(e<<4)+8>>3])*.02;p[Ya>>3]=Ua+(Ua-Xa);e=e+1|0;if((e|0)==(ya|0)){e=n;f=n;o=n;break b}}}do{c=0.0;f=0;do{Ya=(k[B+(f*56|0)+16>>2]|0)+(aa(k[k[B+(f*56|0)+44>>2]>>2]|0,q)|0)+(e<<3)|0;c=c+ +p[Ya>>3];f=f+1|0}while((f|0)<(y|0));Ya=h+(e<<3)|0;Xa=+p[Ya>>3];Ua=Xa+(+p[j+(e<<4)>>3]-+p[j+(e+-1<<4)>>3]+ +p[j+(e<<4)+8>>3]-+p[o+(e<<4)+8>>3])*.02-c*.02;p[Ya>>3]=Ua+(Ua-Xa);e=e+1|0}while((e|0)!=(ya|0));e=x;f=x;o=x}else{e=n;o=g}while(0);q=q+1|0;if((q|0)==(xa|0)){n=e;h=f;j=o;e=B;g=a;f=o;break}else{n=e;e=o}}}A=A+1|0;if((A|0)>=(d|0))break;else{y=n;z=h}}}e=k[sa>>2]|0;f=k[Ra+12>>2]|0;if(!(((((k[b+4>>2]|0)<3?(k[b+8>>2]|0)==(e|0):0)?(k[b+12>>2]|0)==(f|0):0)?(k[b>>2]&4095|0)==0:0)?(k[b+16>>2]|0)!=0:0)){k[Ka>>2]=e;k[Ka+4>>2]=f;G1(b,2,Ka,0)}g=Ka+4|0;e=g+4|0;k[e>>2]=0;k[e+4>>2]=0;k[Ka>>2]=33619968;k[g>>2]=b;SW(Ra,Ka,0,255.0,0.0);x0a(Ma);g=Qa+36|0;e=k[g>>2]|0;if(e|0?(Wa=e+12|0,Ya=k[Wa>>2]|0,k[Wa>>2]=Ya+-1,(Ya|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[Qa+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;Ya=Qa+16|0;k[Ya>>2]=0;k[Ya+4>>2]=0;k[Ya+8>>2]=0;k[Ya+12>>2]=0;if((k[va>>2]|0)>0){f=k[ta>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[va>>2]|0))}e=k[ua>>2]|0;if(!((e|0)==(wa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=Ra+36|0;e=k[g>>2]|0;if(e|0?(Wa=e+12|0,Ya=k[Wa>>2]|0,k[Wa>>2]=Ya+-1,(Ya|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[Ra+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;Ya=Ra+16|0;k[Ya>>2]=0;k[Ya+4>>2]=0;k[Ya+8>>2]=0;k[Ya+12>>2]=0;if((k[Na>>2]|0)>0){f=k[La>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Na>>2]|0))}e=k[Oa>>2]|0;if((e|0)==(Pa|0)|(e|0)==0){r=Sa;return}ggb(k[e+-4>>2]|0);r=Sa;return}function gk(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1232|0;D=$+232|0;_=$+1176|0;n=$+1168|0;Y=$+1112|0;X=$+1056|0;W=$+1e3|0;V=$+944|0;Q=$+888|0;M=$+872|0;K=$+800|0;H=$+352|0;E=$+296|0;B=$+8|0;C=$+280|0;v=$;w=$+264|0;l=$+856|0;m=l+4|0;j=l+4+4|0;k[j>>2]=0;k[j+4>>2]=0;k[l>>2]=33619968;k[m>>2]=b;k[_>>2]=k[a>>2];j=_+4|0;e=a+4|0;b=k[e>>2]|0;k[j>>2]=b;U=_+8|0;k[U>>2]=k[a+8>>2];k[_+12>>2]=k[a+12>>2];k[_+16>>2]=k[a+16>>2];k[_+20>>2]=k[a+20>>2];k[_+24>>2]=k[a+24>>2];k[_+28>>2]=k[a+28>>2];k[_+32>>2]=k[a+32>>2];f=k[a+36>>2]|0;k[_+36>>2]=f;Z=_+40|0;k[Z>>2]=U;U=_+48|0;i=_+44|0;k[i>>2]=U;k[_+52>>2]=0;k[U>>2]=0;if(f){b=f+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[e>>2]|0}if((b|0)>=3){k[j>>2]=0;x1(_,b,0,0,0);if((k[j>>2]|0)>0){g=k[a+40>>2]|0;h=k[Z>>2]|0;f=k[a+44>>2]|0;e=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[g+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else{T=k[a+44>>2]|0;U=k[i>>2]|0;k[U>>2]=k[T>>2];k[U+4>>2]=k[T+4>>2]}T=k[Z>>2]|0;U=k[T>>2]|0;k[n>>2]=k[T+4>>2];k[n+4>>2]=U;x2(l,n,16,0);do if((k[l>>2]&2031616|0)==65536){h=k[m>>2]|0;k[Y>>2]=k[h>>2];j=Y+4|0;b=h+4|0;k[j>>2]=k[b>>2];U=Y+8|0;k[U>>2]=k[h+8>>2];k[Y+12>>2]=k[h+12>>2];k[Y+16>>2]=k[h+16>>2];k[Y+20>>2]=k[h+20>>2];k[Y+24>>2]=k[h+24>>2];k[Y+28>>2]=k[h+28>>2];k[Y+32>>2]=k[h+32>>2];e=k[h+36>>2]|0;k[Y+36>>2]=e;f=Y+40|0;k[f>>2]=U;U=Y+48|0;a=Y+44|0;k[a>>2]=U;k[Y+52>>2]=0;k[U>>2]=0;if(e|0){U=e+12|0;k[U>>2]=(k[U>>2]|0)+1}if((k[b>>2]|0)<3){T=k[h+44>>2]|0;U=k[a>>2]|0;k[U>>2]=k[T>>2];k[U+4>>2]=k[T+4>>2];break}k[j>>2]=0;x1(Y,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){i=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;e=k[a>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[i+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else Q1(Y,l,-1);while(0);m=k[Z>>2]|0;l=k[m>>2]|0;m=k[m+4>>2]|0;k[X>>2]=1124007936;T=X+4|0;b=X+8|0;R=X+40|0;n=T;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[R>>2]=b;U=X+48|0;S=X+44|0;k[S>>2]=U;k[X+52>>2]=0;k[U>>2]=0;k[D>>2]=l;j=D+4|0;k[j>>2]=m;G1(X,2,D,21);O=D+4|0;b=O+4|0;k[b>>2]=0;k[b+4>>2]=0;k[D>>2]=33619968;k[O>>2]=X;SW(_,D,21,.00392156862745098,0.0);k[W>>2]=1124007936;O=W+4|0;b=W+8|0;L=W+40|0;n=O;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[L>>2]=b;P=W+48|0;N=W+44|0;k[N>>2]=P;k[W+52>>2]=0;k[P>>2]=0;k[D>>2]=l;k[j>>2]=m;G1(W,2,D,5);f=D+4|0;e=f+4|0;k[e>>2]=0;k[e+4>>2]=0;k[D>>2]=33619968;k[f>>2]=W;SW(Y,D,21,.00392156862745098,0.0);f=k[R>>2]|0;e=k[f+4>>2]|0;f=k[f>>2]|0;k[V>>2]=1124007936;I=V+4|0;b=V+8|0;F=V+40|0;n=I;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[F>>2]=b;J=V+48|0;G=V+44|0;k[G>>2]=J;k[V+52>>2]=0;k[J>>2]=0;k[D>>2]=f;k[j>>2]=e;G1(V,2,D,21);f=k[R>>2]|0;e=k[f+4>>2]|0;f=k[f>>2]|0;k[Q>>2]=1124007936;z=Q+4|0;b=Q+8|0;x=Q+40|0;n=z;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[x>>2]=b;A=Q+48|0;y=Q+44|0;k[y>>2]=A;k[Q+52>>2]=0;k[A>>2]=0;k[D>>2]=f;k[j>>2]=e;G1(Q,2,D,21);k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=X;f=K+4|0;e=f+4|0;k[e>>2]=0;k[e+4>>2]=0;k[K>>2]=33619968;k[f>>2]=Q;$aa(D,K,44,0);k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=Q;f=K+4|0;e=f+4|0;k[e>>2]=0;k[e+4>>2]=0;k[K>>2]=33882112;k[f>>2]=M;FV(D,K);f=k[R>>2]|0;e=k[f+4>>2]|0;f=k[f>>2]|0;k[K>>2]=1124007936;t=K+4|0;b=K+8|0;q=K+40|0;n=t;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[q>>2]=b;u=K+48|0;s=K+44|0;k[s>>2]=u;k[K+52>>2]=0;k[u>>2]=0;k[D>>2]=f;k[j>>2]=e;G1(K,2,D,5);b=k[M>>2]|0;e=D+4|0;n=e+4|0;k[n>>2]=0;k[n+4>>2]=0;k[D>>2]=33619968;k[e>>2]=K;SW(b,D,5,.00392156862745098,0.0);k[H>>2]=1124007936;b=H+8|0;e=H+40|0;n=H+4|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;b=H+48|0;k[H+44>>2]=b;k[H+52>>2]=0;k[b>>2]=0;k[H+56>>2]=1124007936;b=H+64|0;e=H+96|0;n=H+60|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;b=H+104|0;k[H+100>>2]=b;k[H+108>>2]=0;k[b>>2]=0;k[H+112>>2]=1124007936;b=H+120|0;e=H+152|0;n=H+116|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;b=H+160|0;k[H+156>>2]=b;k[H+164>>2]=0;k[b>>2]=0;k[H+168>>2]=1124007936;b=H+176|0;e=H+208|0;n=H+172|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;b=H+216|0;k[H+212>>2]=b;k[H+220>>2]=0;k[b>>2]=0;k[H+224>>2]=1124007936;b=H+232|0;e=H+264|0;n=H+228|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;b=H+272|0;k[H+268>>2]=b;k[H+276>>2]=0;k[b>>2]=0;k[H+280>>2]=1124007936;b=H+288|0;e=H+320|0;n=H+284|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;b=H+328|0;k[H+324>>2]=b;k[H+332>>2]=0;k[b>>2]=0;k[H+336>>2]=1124007936;b=H+344|0;e=H+376|0;n=H+340|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;b=H+384|0;k[H+380>>2]=b;k[H+388>>2]=0;k[b>>2]=0;k[H+392>>2]=1124007936;b=H+400|0;e=H+432|0;n=H+396|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;a=H+440|0;k[H+436>>2]=a;k[H+444>>2]=0;k[a>>2]=0;M3a(H,K,W,c,d,1);k[E>>2]=1124007936;a=E+4|0;b=E+8|0;g=E+40|0;n=a;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[g>>2]=b;i=E+48|0;h=E+44|0;k[h>>2]=i;k[E+52>>2]=0;k[i>>2]=0;k[D>>2]=l;k[j>>2]=m;G1(E,2,D,5);k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=1124007936;b=B+16|0;e=B+48|0;n=B+12|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;b=B+56|0;k[B+52>>2]=b;k[B+60>>2]=0;k[b>>2]=0;k[B+64>>2]=1124007936;b=B+72|0;e=B+104|0;n=B+68|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;b=B+112|0;k[B+108>>2]=b;k[B+116>>2]=0;k[b>>2]=0;k[B+120>>2]=1124007936;b=B+128|0;e=B+160|0;n=B+124|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;n=B+168|0;k[B+164>>2]=n;o=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;G0(B,K,W,1.0,-1.0,D);b=k[B>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,B,E,-1);XN(B);k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=E;p[v>>3]=3.0;k[C>>2]=-1056833530;k[C+4>>2]=v;k[C+8>>2]=1;k[C+12>>2]=1;b=w+4|0;e=b+4|0;k[e>>2]=0;k[e+4>>2]=0;k[w>>2]=33619968;k[b>>2]=E;p[D>>3]=1.0;sU(B,C,w,49332,-1,40032,1,D);k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=1124007936;b=B+16|0;e=B+48|0;n=B+12|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;b=B+56|0;k[B+52>>2]=b;k[B+60>>2]=0;k[b>>2]=0;k[B+64>>2]=1124007936;b=B+72|0;e=B+104|0;n=B+68|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;b=B+112|0;k[B+108>>2]=b;k[B+116>>2]=0;k[b>>2]=0;k[B+120>>2]=1124007936;b=B+128|0;e=B+160|0;n=B+124|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=b;n=B+168|0;k[B+164>>2]=n;o=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;G0(B,W,E,1.0,1.0,D);f=k[B>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,B,K,-1);XN(B);f=k[M>>2]|0;b=D+4|0;w=b+4|0;k[w>>2]=0;k[w+4>>2]=0;k[D>>2]=33619968;k[b>>2]=f;SW(K,D,5,255.0,0.0);k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=17104896;k[B+4>>2]=M;b=C+4|0;f=b+4|0;k[f>>2]=0;k[f+4>>2]=0;k[C>>2]=33619968;k[b>>2]=Q;k[D>>2]=0;b=D+4|0;k[b>>2]=0;k[D+8>>2]=0;B2(B,D);f=k[D>>2]|0;b=k[b>>2]|0;GV((f|0)==(b|0)?0:f,(b-f|0)/56|0,C);zF(D);k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=Q;f=B+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[B>>2]=33619968;k[f>>2]=V;$aa(D,B,56,0);f=D+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[D>>2]=33619968;k[f>>2]=Y;SW(V,D,16,255.0,0.0);f=E+36|0;b=k[f>>2]|0;if(b|0?(C=b+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[E+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;E=E+16|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[a>>2]|0)>0){e=k[g>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[h>>2]|0;if(!((b|0)==(i|0)|(b|0)==0))ggb(k[b+-4>>2]|0);N3a(H);f=K+36|0;b=k[f>>2]|0;if(b|0?(E=b+12|0,H=k[E>>2]|0,k[E>>2]=H+-1,(H|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[K+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;K=K+16|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[t>>2]|0)>0){e=k[q>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[s>>2]|0;if(!((b|0)==(u|0)|(b|0)==0))ggb(k[b+-4>>2]|0);zF(M);f=Q+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,M=k[K>>2]|0,k[K>>2]=M+-1,(M|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Q+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Q=Q+16|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[z>>2]|0)>0){e=k[x>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[y>>2]|0;if(!((b|0)==(A|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=V+36|0;b=k[f>>2]|0;if(b|0?(M=b+12|0,Q=k[M>>2]|0,k[M>>2]=Q+-1,(Q|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[V+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;V=V+16|0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[I>>2]|0)>0){e=k[F>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[I>>2]|0))}b=k[G>>2]|0;if(!((b|0)==(J|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=W+36|0;b=k[f>>2]|0;if(b|0?(Q=b+12|0,V=k[Q>>2]|0,k[Q>>2]=V+-1,(V|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[W+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;W=W+16|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[O>>2]|0)>0){e=k[L>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[O>>2]|0))}b=k[N>>2]|0;if(!((b|0)==(P|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=X+36|0;b=k[f>>2]|0;do if(b|0){V=b+12|0;W=k[V>>2]|0;k[V>>2]=W+-1;if((W|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[X+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;X=X+16|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[T>>2]|0)>0){e=k[R>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[T>>2]|0))}b=k[S>>2]|0;if(!((b|0)==(U|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Y+36|0;b=k[f>>2]|0;do if(b|0){W=b+12|0;X=k[W>>2]|0;k[W>>2]=X+-1;if((X|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Y+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;X=Y+16|0;e=Y+4|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[e>>2]|0)>0){f=k[Y+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Y+44>>2]|0;if(!((b|0)==(Y+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=_+36|0;b=k[f>>2]|0;do if(b|0){X=b+12|0;Y=k[X>>2]|0;k[X>>2]=Y+-1;if((Y|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[_+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;Y=_+16|0;f=_+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[f>>2]|0)>0){e=k[Z>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[_+44>>2]|0;if((b|0)==(_+48|0)|(b|0)==0){r=$;return}ggb(k[b+-4>>2]|0);r=$;return}function hk(a){a=a|0;var b=0,c=0,d=0,e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;y=r;r=r+1168|0;u=y+1112|0;t=y+72|0;s=y+16|0;n=y;k[u>>2]=k[a>>2];h=u+4|0;d=a+4|0;b=k[d>>2]|0;k[h>>2]=b;m=u+8|0;k[m>>2]=k[a+8>>2];k[u+12>>2]=k[a+12>>2];v=u+16|0;k[v>>2]=k[a+16>>2];k[u+20>>2]=k[a+20>>2];k[u+24>>2]=k[a+24>>2];k[u+28>>2]=k[a+28>>2];k[u+32>>2]=k[a+32>>2];c=k[a+36>>2]|0;k[u+36>>2]=c;f=u+40|0;k[f>>2]=m;x=u+48|0;w=u+44|0;k[w>>2]=x;k[u+52>>2]=0;k[x>>2]=0;if(c){b=c+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[d>>2]|0}if((b|0)>=3){k[h>>2]=0;x1(u,b,0,0,0);if((k[h>>2]|0)>0){g=k[a+40>>2]|0;f=k[f>>2]|0;c=k[a+44>>2]|0;d=k[w>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[g+(b<<2)>>2];k[d+(b<<2)>>2]=k[c+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else{j=k[a+44>>2]|0;q=k[w>>2]|0;k[q>>2]=k[j>>2];k[q+4>>2]=k[j+4>>2]}a=k[u>>2]&4095;q=k[m>>2]|0;h=k[x>>2]|0;j=k[v>>2]|0;if(j){d=k[u+4>>2]|0;if((d|0)<3)b=aa(k[u+12>>2]|0,q)|0;else{f=k[u+40>>2]|0;c=0;b=1;do{b=aa(k[f+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(d|0))}if(b)b=q;else l=14}else l=14;if((l|0)==14){k[t>>2]=0;b=t+4|0;k[b>>2]=0;c=ZT(20)|0;k[c>>2]=1;d=c+4|0;k[t>>2]=d;k[b>>2]=12;i[c+16>>0]=0;f=213693;g=d+12|0;do{i[d>>0]=i[f>>0]|0;d=d+1|0;f=f+1|0}while((d|0)<(g|0));Y8(-215,t,213706,213718,722);k[b>>2]=0;k[t>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)==1)ggb(k[c+-4>>2]|0);b=k[m>>2]|0}if(!((a+-5|0)>>>0<2?(b|0)==(k[u+12>>2]|0):0)){k[t>>2]=0;c=t+4|0;k[c>>2]=0;b=ZT(64)|0;k[b>>2]=1;d=b+4|0;k[t>>2]=d;k[c>>2]=58;i[b+62>>0]=0;f=213783;g=d+58|0;do{i[d>>0]=i[f>>0]|0;d=d+1|0;f=f+1|0}while((d|0)<(g|0));Y8(-215,t,213706,213718,723);k[c>>2]=0;k[t>>2]=0;m=k[b>>2]|0;k[b>>2]=m+-1;if((m|0)==1)ggb(k[b+-4>>2]|0)}b=(q|0)==2;a:do if((a|0)==5){if(b){t=j+h|0;e=+o[j>>2]*+o[t+4>>2]-+o[j+4>>2]*+o[t>>2];break}switch(q|0){case 3:{s=j+h|0;D=+o[s+4>>2];t=j+(h<<1)|0;B=+o[t+8>>2];z=+o[s+8>>2];C=+o[t+4>>2];A=+o[s>>2];e=+o[t>>2];e=+o[j+8>>2]*(C*A-D*e)+(+o[j>>2]*(D*B-z*C)-+o[j+4>>2]*(B*A-z*e));break a}case 1:{e=+o[j>>2];break a}default:{c=(aa(q,q)|0)<<2;l=t+8|0;k[t>>2]=l;m=t+4|0;k[m>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[t>>2]=b}else b=l;k[m>>2]=c;a=s+4|0;k[a>>2]=2;j=s+8|0;k[j>>2]=q;k[s+12>>2]=q;f=s+16|0;k[f>>2]=b;k[s+20>>2]=b;d=s+24|0;g=s+40|0;h=d+8|0;k[h>>2]=0;k[h+4>>2]=0;k[g>>2]=j;j=s+48|0;h=s+44|0;k[h>>2]=j;c=q<<2;k[s>>2]=1124024325;k[j>>2]=c;k[s+52>>2]=4;b=b+(aa(q,c)|0)|0;k[s+28>>2]=b;k[d>>2]=b+(0-c)+c;d=n+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[n>>2]=33619968;k[d>>2]=s;mY(u,n);n=t4(k[f>>2]|0,k[j>>2]|0,q,0,0,0)|0;e=+(n|0);if(n){if((q|0)>0){c=k[f>>2]|0;d=k[k[h>>2]>>2]|0;b=0;do{n=c+(aa(d,b)|0)+(b<<2)|0;e=e*+o[n>>2];b=b+1|0}while((b|0)!=(q|0))}e=1.0/e}d=s+36|0;b=k[d>>2]|0;if(b|0?(n=b+12|0,q=k[n>>2]|0,k[n>>2]=q+-1,(q|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[s+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[a>>2]|0)>0){c=k[g>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[h>>2]|0;if(!((b|0)==(j|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[t>>2]|0;if((b|0)!=(l|0)){if(b|0)ggb(b);k[t>>2]=l;k[m>>2]=1032}break a}}}else{if(b){t=j+h|0;e=+p[j>>3]*+p[t+8>>3]-+p[j+8>>3]*+p[t>>3];break}switch(q|0){case 3:{s=j+h|0;z=+p[s+8>>3];t=j+(h<<1)|0;B=+p[t+16>>3];D=+p[s+16>>3];A=+p[t+8>>3];C=+p[s>>3];e=+p[t>>3];e=+p[j+16>>3]*(A*C-z*e)+(+p[j>>3]*(z*B-D*A)-+p[j+8>>3]*(B*C-D*e));break a}case 1:{e=+p[j>>3];break a}default:{c=(aa(q,q)|0)<<3;l=t+8|0;k[t>>2]=l;m=t+4|0;k[m>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[t>>2]=b}else b=l;k[m>>2]=c;a=s+4|0;k[a>>2]=2;j=s+8|0;k[j>>2]=q;k[s+12>>2]=q;f=s+16|0;k[f>>2]=b;k[s+20>>2]=b;d=s+24|0;g=s+40|0;h=d+8|0;k[h>>2]=0;k[h+4>>2]=0;k[g>>2]=j;j=s+48|0;h=s+44|0;k[h>>2]=j;c=q<<3;k[s>>2]=1124024326;k[j>>2]=c;k[s+52>>2]=8;b=b+(aa(q,c)|0)|0;k[s+28>>2]=b;k[d>>2]=b+(0-c)+c;d=n+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[n>>2]=33619968;k[d>>2]=s;mY(u,n);n=u4(k[f>>2]|0,k[j>>2]|0,q,0,0,0)|0;e=+(n|0);if(n){if((q|0)>0){c=k[f>>2]|0;d=k[k[h>>2]>>2]|0;b=0;do{n=c+(aa(d,b)|0)+(b<<3)|0;e=e*+p[n>>3];b=b+1|0}while((b|0)!=(q|0))}e=1.0/e}d=s+36|0;b=k[d>>2]|0;if(b|0?(n=b+12|0,q=k[n>>2]|0,k[n>>2]=q+-1,(q|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[s+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[a>>2]|0)>0){c=k[g>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[h>>2]|0;if(!((b|0)==(j|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[t>>2]|0;if((b|0)!=(l|0)){if(b|0)ggb(b);k[t>>2]=l;k[m>>2]=1032}break a}}}while(0);d=u+36|0;b=k[d>>2]|0;if(b|0?(s=b+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[u+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=u+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[d>>2]|0)>0){c=k[u+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[w>>2]|0;if((b|0)==(x|0)|(b|0)==0){r=y;return +e}ggb(k[b+-4>>2]|0);r=y;return +e}function ik(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;bZ(g,f,c,d);r=e;return}function jk(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+64|0;i=h+48|0;m=h+32|0;l=h+16|0;j=h;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;a=l+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[l>>2]=33619968;k[l+4>>2]=b;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=c;c=k[d+4>>2]|0;k[i>>2]=k[d>>2];k[i+4>>2]=c;Dra(1,m,l,j,i,e,f,g);r=h;return}function kk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+416|0;y=B+160|0;t=B+152|0;A=B+96|0;n=B+72|0;z=B;f=B+80|0;j=B+56|0;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=a;m=j+4|0;x=j+4+4|0;k[x>>2]=0;k[x+4>>2]=0;k[j>>2]=33619968;k[m>>2]=b;if(!((c|0)==1&(e|0)==0)){xfa(f,j,49332,c,d,1);r=B;return}k[A>>2]=k[a>>2];h=A+4|0;f=a+4|0;b=k[f>>2]|0;k[h>>2]=b;x=A+8|0;k[x>>2]=k[a+8>>2];k[A+12>>2]=k[a+12>>2];k[A+16>>2]=k[a+16>>2];k[A+20>>2]=k[a+20>>2];k[A+24>>2]=k[a+24>>2];k[A+28>>2]=k[a+28>>2];k[A+32>>2]=k[a+32>>2];c=k[a+36>>2]|0;k[A+36>>2]=c;d=A+40|0;k[d>>2]=x;x=A+48|0;g=A+44|0;k[g>>2]=x;k[A+52>>2]=0;k[x>>2]=0;if(c){b=c+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[f>>2]|0}if((b|0)>=3){k[h>>2]=0;x1(A,b,0,0,0);if((k[h>>2]|0)>0){e=k[a+40>>2]|0;d=k[d>>2]|0;c=k[a+44>>2]|0;f=k[g>>2]|0;b=0;do{k[d+(b<<2)>>2]=k[e+(b<<2)>>2];k[f+(b<<2)>>2]=k[c+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else{w=k[a+44>>2]|0;x=k[g>>2]|0;k[x>>2]=k[w>>2];k[x+4>>2]=k[w+4>>2]}if(k[A>>2]&4095|0){k[y>>2]=0;b=y+4|0;k[b>>2]=0;f=ZT(28)|0;k[f>>2]=1;d=f+4|0;k[y>>2]=d;k[b>>2]=21;i[f+25>>0]=0;e=354023;g=d+21|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));Y8(-215,y,245913,245510,686);k[b>>2]=0;k[y>>2]=0;x=k[f>>2]|0;k[f>>2]=x+-1;if((x|0)==1)ggb(k[f+-4>>2]|0)}x=A+40|0;v=k[x>>2]|0;w=k[v>>2]|0;k[n>>2]=k[v+4>>2];k[n+4>>2]=w;x2(j,n,0,0);do if((k[j>>2]&2031616|0)==65536){d=k[m>>2]|0;k[z>>2]=k[d>>2];a=z+4|0;b=d+4|0;k[a>>2]=k[b>>2];m=z+8|0;k[m>>2]=k[d+8>>2];k[z+12>>2]=k[d+12>>2];j=z+16|0;k[j>>2]=k[d+16>>2];k[z+20>>2]=k[d+20>>2];k[z+24>>2]=k[d+24>>2];k[z+28>>2]=k[d+28>>2];k[z+32>>2]=k[d+32>>2];f=k[d+36>>2]|0;k[z+36>>2]=f;c=z+40|0;k[c>>2]=m;m=z+48|0;g=z+44|0;k[g>>2]=m;k[z+52>>2]=0;k[m>>2]=0;if(f|0){w=f+12|0;k[w>>2]=(k[w>>2]|0)+1}if((k[b>>2]|0)<3){v=k[d+44>>2]|0;w=k[g>>2]|0;k[w>>2]=k[v>>2];k[w+4>>2]=k[v+4>>2];break}k[a>>2]=0;x1(z,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){h=k[d+40>>2]|0;e=k[c>>2]|0;c=k[d+44>>2]|0;f=k[g>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[h+(b<<2)>>2];k[f+(b<<2)>>2]=k[c+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0))}}else{Q1(z,j,-1);j=z+16|0;m=z+48|0}while(0);p=k[A+12>>2]|0;q=k[A+8>>2]|0;v=A+16|0;n=k[v>>2]|0;b=k[j>>2]|0;w=A+48|0;o=k[w>>2]|0;s=k[m>>2]|0;if(!((k[A>>2]&4095|0)==0?!(k[z>>2]&4095|0):0)){k[t>>2]=0;f=t+4|0;k[f>>2]=0;c=ZT(52)|0;k[c>>2]=1;d=c+4|0;k[t>>2]=d;k[f>>2]=46;i[c+50>>0]=0;e=245937;g=d+46|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));Y8(-215,t,245984,245510,617);k[f>>2]=0;k[t>>2]=0;u=k[c>>2]|0;k[c>>2]=u+-1;if((u|0)==1)ggb(k[c+-4>>2]|0)}h=k[x>>2]|0;u=z+40|0;a=k[u>>2]|0;if((k[h>>2]|0)==(k[a>>2]|0)?(k[h+4>>2]|0)==(k[a+4>>2]|0):0)f=0;else{k[t>>2]=0;f=t+4|0;k[f>>2]=0;c=ZT(32)|0;k[c>>2]=1;d=c+4|0;k[t>>2]=d;k[f>>2]=24;i[c+28>>0]=0;e=348093;g=d+24|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));Y8(-215,t,245984,245510,618);k[f>>2]=0;k[t>>2]=0;t=k[c>>2]|0;k[c>>2]=t+-1;if((t|0)==1)ggb(k[c+-4>>2]|0);f=0}do{t=f;f=f+1|0;i[y+t>>0]=f>>>0<256?f:(t>>>31)+255|0}while((f|0)!=256);f=((i[n>>0]|0)!=0)<<31>>31;i[b>>0]=f;d=(p|0)>1;if(d){c=1;do{if(!(i[n+c>>0]|0))f=0;else f=l[y+(f&255)>>0]|0;f=f&255;i[b+c>>0]=f;c=c+1|0}while((c|0)!=(p|0))}do if((q|0)>1){h=0-s|0;a=aa(s,q+-1|0)|0;if(d){e=1;g=b;d=n}else{d=1;e=b;f=n;do{f=f+o|0;e=e+s|0;if(!(i[f>>0]|0))c=0;else c=l[y+(l[e+h>>0]|0)>>0]|0;i[e>>0]=c;d=d+1|0}while((d|0)!=(q|0));b=b+a|0;break}do{d=d+o|0;g=g+s|0;if(!(i[d>>0]|0))f=0;else f=l[y+(l[g+h>>0]|0)>>0]|0;i[g>>0]=f;c=1;do{if(!(i[d+c>>0]|0))f=0;else{t=l[g+(c-s)>>0]|0;f=l[y+((f|0)>(t|0)?t:f)>>0]|0}i[g+c>>0]=f;c=c+1|0}while((c|0)!=(p|0));e=e+1|0}while((e|0)!=(q|0));b=b+a|0}while(0);a=p+-1|0;h=p+-2|0;d=(h|0)>-1;if(d){f=l[b+a>>0]|0;c=h;while(1){p=l[y+f>>0]|0;t=b+c|0;f=p-(l[352559+((p|256)-(l[t>>0]|0))>>0]|0)|0;i[t>>0]=f;if((c|0)<=0)break;else c=c+-1|0}}f=q+-2|0;a:do if((f|0)>-1){e=0-s|0;g=s+a|0;if(!d)while(1){b=b+e|0;s=i[y+(l[b+g>>0]|0)>>0]|0;t=b+a|0;q=i[t>>0]|0;i[t>>0]=(s&255)>(q&255)?q:s;if((f|0)<=0)break a;else f=f+-1|0}while(1){b=b+e|0;c=i[y+(l[b+g>>0]|0)>>0]|0;d=b+a|0;t=i[d>>0]|0;c=(c&255)>(t&255)?t:c;i[d>>0]=c;c=c&255;d=h;while(1){t=l[b+(d+s)>>0]|0;c=i[y+(c>>>0>t>>>0?t:c)>>0]|0;t=b+d|0;q=i[t>>0]|0;c=(c&255)>(q&255)?q:c;i[t>>0]=c;if((d|0)>0){c=c&255;d=d+-1|0}else break}if((f|0)<=0)break;else f=f+-1|0}}while(0);c=z+36|0;b=k[c>>2]|0;if(b|0?(t=b+12|0,y=k[t>>2]|0,k[t>>2]=y+-1,(y|0)==1):0){f=k[c>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[z+32>>2]|0;if(!b){b=B1()|0;f=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[c>>2]=0}k[c>>2]=0;c=z+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[c>>2]|0)>0){f=k[u>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[z+44>>2]|0;if(!((b|0)==(m|0)|(b|0)==0))ggb(k[b+-4>>2]|0);c=A+36|0;b=k[c>>2]|0;if(b|0?(y=b+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){f=k[c>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[A+32>>2]|0;if(b|0)break;b=B1()|0;f=k[c>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[c>>2]=0}k[c>>2]=0;c=A+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[c>>2]|0)>0){f=k[x>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[A+44>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0);r=B;return}function lk(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=r;r=r+48|0;j=g+32|0;i=g+16|0;h=g;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;a=i+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=b;b=h+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;xfa(j,i,h,d,e,f);r=g;return}function mk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+64|0;g=f;j=f+40|0;i=f+24|0;h=f+8|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b;b=h+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;p[g>>3]=d;sU(j,i,h,49332,e,40064,1,g);r=f;return}function nk(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=r;r=r+48|0;f=e;h=e+24|0;g=e+8|0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b;b=g+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=c;p[f>>3]=a;sU(h,h,g,49332,d,40096,1,f);r=e;return}function ok(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0;za=r;r=r+576|0;na=za+520|0;sa=za+508|0;pa=za+496|0;O=za+112|0;P=za+80|0;qa=za+440|0;_=za+48|0;$=za+16|0;ba=za+408|0;ca=za+8|0;da=za+400|0;ea=za+392|0;fa=za+384|0;ga=za+376|0;ha=za+368|0;ia=za;ja=za+360|0;ka=za+352|0;la=za+344|0;ya=za+288|0;xa=za+232|0;N=za+184|0;wa=za+156|0;va=za+144|0;M=za+216|0;t=za+168|0;k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=17104896;L=M+4|0;k[L>>2]=b;k[t+8>>2]=0;k[t+12>>2]=0;k[t>>2]=16842752;s=t+4|0;k[s>>2]=g;Z=k[j>>2]|0;Y=k[j+4>>2]|0;k[ya>>2]=k[a>>2];q=ya+4|0;g=a+4|0;b=k[g>>2]|0;k[q>>2]=b;ua=ya+8|0;k[ua>>2]=k[a+8>>2];k[ya+12>>2]=k[a+12>>2];k[ya+16>>2]=k[a+16>>2];k[ya+20>>2]=k[a+20>>2];k[ya+24>>2]=k[a+24>>2];k[ya+28>>2]=k[a+28>>2];k[ya+32>>2]=k[a+32>>2];j=k[a+36>>2]|0;k[ya+36>>2]=j;m=ya+40|0;k[m>>2]=ua;ua=ya+48|0;o=ya+44|0;k[o>>2]=ua;k[ya+52>>2]=0;k[ua>>2]=0;if(j){b=j+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[g>>2]|0}if((b|0)>=3){k[q>>2]=0;x1(ya,b,0,0,0);if((k[q>>2]|0)>0){n=k[a+40>>2]|0;m=k[m>>2]|0;j=k[a+44>>2]|0;g=k[o>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[n+(b<<2)>>2];k[g+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else{ta=k[a+44>>2]|0;ua=k[o>>2]|0;k[ua>>2]=k[ta>>2];k[ua+4>>2]=k[ta+4>>2]}do if((k[t>>2]&2031616|0)==65536){m=k[s>>2]|0;k[xa>>2]=k[m>>2];q=xa+4|0;b=m+4|0;k[q>>2]=k[b>>2];ua=xa+8|0;k[ua>>2]=k[m+8>>2];k[xa+12>>2]=k[m+12>>2];k[xa+16>>2]=k[m+16>>2];k[xa+20>>2]=k[m+20>>2];k[xa+24>>2]=k[m+24>>2];k[xa+28>>2]=k[m+28>>2];k[xa+32>>2]=k[m+32>>2];g=k[m+36>>2]|0;k[xa+36>>2]=g;j=xa+40|0;k[j>>2]=ua;ua=xa+48|0;o=xa+44|0;k[o>>2]=ua;k[xa+52>>2]=0;k[ua>>2]=0;if(g|0){ua=g+12|0;k[ua>>2]=(k[ua>>2]|0)+1}if((k[b>>2]|0)<3){ta=k[m+44>>2]|0;ua=k[o>>2]|0;k[ua>>2]=k[ta>>2];k[ua+4>>2]=k[ta+4>>2];break}k[q>>2]=0;x1(xa,k[b>>2]|0,0,0,0);if((k[q>>2]|0)>0){a=k[m+40>>2]|0;n=k[j>>2]|0;j=k[m+44>>2]|0;g=k[o>>2]|0;b=0;do{k[n+(b<<2)>>2]=k[a+(b<<2)>>2];k[g+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else Q1(xa,t,-1);while(0);W=k[ya+8>>2]|0;ta=ya+4|0;ua=(k[ta>>2]|0)==1?1:k[ya+12>>2]|0;K=k[ya>>2]|0;X=K&4095;ra=ya+16|0;V=k[ra>>2]|0;U=aa((K>>>3&511)+1<<(47696>>>(X<<1&14)&3),ua)|0;k[N>>2]=X|1111638016;X=N+4|0;k[X>>2]=U;k[N+8>>2]=0;k[N+12>>2]=0;k[N+16>>2]=V;k[N+20>>2]=W;k[N+24>>2]=ua;ua=ya+44|0;k[X>>2]=k[k[ua>>2]>>2];k[N>>2]=K&20479|1111621632;K=F2(M)|0;k[wa>>2]=0;X=wa+4|0;k[X>>2]=0;k[wa+8>>2]=0;k[va>>2]=0;W=va+4|0;k[W>>2]=0;k[va+8>>2]=0;if(K|0){o=wa+8|0;if(K>>>0>76695844)ad(426534,426557,304,426811);g=K*56|0;g=(g|0)==0?1:g;while(1){b=fgb(g)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}j=K;g=b;n=b;do{F=g;G=F+56|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));g=n+56|0;n=g;j=j+-1|0}while((j|0)!=0);g=k[wa>>2]|0;j=(k[X>>2]|0)-g|0;m=b+(((j|0)/-56|0)*56|0)|0;if((j|0)>0)upb(m|0,g|0,j|0)|0;k[wa>>2]=m;k[X>>2]=n;k[o>>2]=b+(K*56|0);if(g|0)ggb(g);j=k[W>>2]|0;g=k[va>>2]|0;n=(j-g|0)/20|0;b=g;m=j;do if(K>>>0>n>>>0){q=K-n|0;s=va+8|0;b=k[s>>2]|0;if(((b-j|0)/20|0)>>>0>=q>>>0){b=q;g=m;while(1){k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;g=g+20|0;b=b+-1|0;if(!b)break;else j=g}k[W>>2]=m+(q*20|0);break}if(K>>>0>214748364)ad(426534,426557,304,426811);V=(b-g|0)/20|0;a=V<<1;a=V>>>0<107374182?(a>>>0<K>>>0?K:a):214748364;if(!a)b=0;else{if(a>>>0>214748364){za=te(4)|0;k[za>>2]=172664;Cf(za|0,28816,1287)}g=a*20|0;g=(g|0)==0?1:g;while(1){b=fgb(g)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}}o=b+(n*20|0)|0;g=q;j=o;n=o;do{k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;j=n+20|0;n=j;g=g+-1|0}while((g|0)!=0);j=k[va>>2]|0;m=(k[W>>2]|0)-j|0;g=o+(((m|0)/-20|0)*20|0)|0;if((m|0)>0)upb(g|0,j|0,m|0)|0;k[va>>2]=g;k[W>>2]=n;k[s>>2]=b+(a*20|0);if(j|0)ggb(j)}else if(K>>>0<n>>>0?(u=b+(K*20|0)|0,(m|0)!=(u|0)):0)k[W>>2]=m+(~(((m+-20-u|0)>>>0)/20|0)*20|0);while(0);g=k[wa>>2]|0;b=0;do{k[g+(b*56|0)+52>>2]=0;b=b+1|0}while((b|0)!=(K|0));I=(c|0)>-1;if(I){if((K|0)<=(c|0)){k[na>>2]=0;b=na+4|0;k[b>>2]=0;g=ZT(48)|0;k[g>>2]=1;F=g+4|0;k[na>>2]=F;k[b>>2]=41;i[g+45>>0]=0;D=246907;G=F+41|0;do{i[F>>0]=i[D>>0]|0;F=F+1|0;D=D+1|0}while((F|0)<(G|0));Y8(-215,na,246949,246054,2369);k[b>>2]=0;k[na>>2]=0;V=k[g>>2]|0;k[g>>2]=V+-1;if((V|0)==1)ggb(k[g+-4>>2]|0)}J=c;H=c+1|0}else{J=0;H=K}E=H>>>0>J>>>0;if(E){a=na+4|0;q=na+8|0;s=na+12|0;t=na+16|0;u=na+20|0;c=na+24|0;v=na+28|0;w=na+32|0;x=na+36|0;y=na+40|0;z=na+48|0;A=na+44|0;B=na+52|0;C=sa+4|0;o=J;do{do if((o|0)<0?(k[M>>2]&2031616|0)==65536:0){j=k[L>>2]|0;k[na>>2]=k[j>>2];b=j+4|0;k[a>>2]=k[b>>2];k[q>>2]=k[j+8>>2];k[s>>2]=k[j+12>>2];k[t>>2]=k[j+16>>2];k[u>>2]=k[j+20>>2];k[c>>2]=k[j+24>>2];k[v>>2]=k[j+28>>2];k[w>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[x>>2]=g;k[y>>2]=q;k[A>>2]=z;k[B>>2]=0;k[z>>2]=0;if(g|0){V=g+12|0;k[V>>2]=(k[V>>2]|0)+1}if((k[b>>2]|0)<3){U=k[j+44>>2]|0;V=k[A>>2]|0;k[V>>2]=k[U>>2];k[V+4>>2]=k[U+4>>2];break}k[a>>2]=0;x1(na,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){m=k[j+40>>2]|0;n=k[y>>2]|0;g=k[j+44>>2]|0;j=k[A>>2]|0;b=0;do{k[n+(b<<2)>>2]=k[m+(b<<2)>>2];k[j+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0))}}else Q1(na,M,o);while(0);n=k[t>>2]|0;if(n|0){j=k[a>>2]|0;if((j|0)<3)b=aa(k[s>>2]|0,k[q>>2]|0)|0;else{m=k[y>>2]|0;g=0;b=1;do{b=aa(k[m+(g<<2)>>2]|0,b)|0;g=g+1|0}while((g|0)!=(j|0))}if(b|0){g=y2(na,2,4,1)|0;if((g|0)>0)b=n;else{k[sa>>2]=0;k[C>>2]=0;b=ZT(16)|0;k[b>>2]=1;F=b+4|0;k[sa>>2]=F;k[C>>2]=11;i[b+15>>0]=0;D=246962;G=F+11|0;do{i[F>>0]=i[D>>0]|0;F=F+1|0;D=D+1|0}while((F|0)<(G|0));Y8(-215,sa,246949,246054,2380);k[C>>2]=0;k[sa>>2]=0;V=k[b>>2]|0;k[b>>2]=V+-1;if((V|0)==1)ggb(k[b+-4>>2]|0);b=k[t>>2]|0}MY(20492,56,8,b,g,(k[wa>>2]|0)+(o*56|0)|0,(k[va>>2]|0)+(o*20|0)|0)|0}}b=k[x>>2]|0;if(b|0?(U=b+12|0,V=k[U>>2]|0,k[U>>2]=V+-1,(V|0)==1):0){g=k[x>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[w>>2]|0;if(b|0)break;b=B1()|0;g=k[x>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[x>>2]=0}k[x>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[a>>2]|0)>0){g=k[y>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[A>>2]|0;if(!((b|0)==(z|0)|(b|0)==0))ggb(k[b+-4>>2]|0);o=o+1|0}while(o>>>0<H>>>0)}q=xa+16|0;j=k[q>>2]|0;do if(j){o=k[xa+4>>2]|0;n=(o|0)<3;if(n)b=aa(k[xa+12>>2]|0,k[xa+8>>2]|0)|0;else{m=k[xa+40>>2]|0;g=0;b=1;do{b=aa(k[m+(g<<2)>>2]|0,b)|0;g=g+1|0}while((g|0)!=(o|0))}if(!((h|0)==0|(b|0)==0)){a=H-J|0;if(n)b=aa(k[xa+12>>2]|0,k[xa+8>>2]|0)|0;else{m=k[xa+40>>2]|0;g=0;b=1;do{b=aa(k[m+(g<<2)>>2]|0,b)|0;g=g+1|0}while((g|0)!=(o|0))}if(!((b|0)==(K|0)?(k[xa>>2]&4095|0)==28:0)){k[na>>2]=0;b=na+4|0;k[b>>2]=0;g=ZT(68)|0;k[g>>2]=1;F=g+4|0;k[na>>2]=F;k[b>>2]=62;i[g+66>>0]=0;D=246974;G=F+62|0;do{i[F>>0]=i[D>>0]|0;F=F+1|0;D=D+1|0}while((F|0)<(G|0));Y8(-215,na,246949,246054,2394);k[b>>2]=0;k[na>>2]=0;V=k[g>>2]|0;k[g>>2]=V+-1;if((V|0)==1)ggb(k[g+-4>>2]|0);j=k[q>>2]|0}if((a|0)!=(K|0)){b=k[j+(J<<4)+8>>2]|0;if((b|0)<=-1)break;$fa(M,K,j,b,wa,va);V=k[wa>>2]|0;k[V+(J*56|0)+20>>2]=V+(b*56|0);break}if(E){g=k[wa>>2]|0;b=J;do{S=k[j+(b<<4)>>2]|0;T=k[j+(b<<4)+4>>2]|0;U=k[j+(b<<4)+8>>2]|0;V=k[j+(b<<4)+12>>2]|0;k[g+(b*56|0)+12>>2]=S>>>0<K>>>0?g+(S*56|0)|0:0;k[g+(b*56|0)+8>>2]=T>>>0<K>>>0?g+(T*56|0)|0:0;k[g+(b*56|0)+20>>2]=U>>>0<K>>>0?g+(U*56|0)|0:0;k[g+(b*56|0)+16>>2]=V>>>0<K>>>0?g+(V*56|0)|0:0;b=b+1|0}while((b|0)!=(H|0))}}else oa=104}else oa=104;while(0);if((oa|0)==104?E:0){g=H+-1|0;j=k[wa>>2]|0;b=J;do{V=b;b=b+1|0;k[j+(V*56|0)+12>>2]=V>>>0<g>>>0?j+(b*56|0)|0:0;k[j+(V*56|0)+8>>2]=V>>>0>J>>>0?j+((V+-1|0)*56|0)|0:0}while((b|0)!=(H|0))}m=k[wa>>2]|0;n=m+(J*56|0)|0;Da=+p[d>>3];Ca=+p[d+8>>3];Ba=+p[d+16>>3];Aa=+p[d+24>>3];j=I?0-h|0:h;k[sa>>2]=0;V=sa+4|0;k[V>>2]=0;k[sa+8>>2]=0;k[pa>>2]=0;U=pa+4|0;k[U>>2]=0;k[pa+8>>2]=0;p[O>>3]=Da;p[O+8>>3]=Ca;p[O+16>>3]=Ba;p[O+24>>3]=Aa;p[P>>3]=Da;p[P+8>>3]=Ca;p[P+16>>3]=Ba;p[P+24>>3]=Aa;M1(qa,N,0,1,0,0);if((f|0)==16)f=(k[qa>>2]&7|0)==0?16:8;if(n|0){if((e|0)>=32768){k[ba>>2]=0;b=ba+4|0;k[b>>2]=0;g=ZT(32)|0;k[g>>2]=1;F=g+4|0;k[ba>>2]=F;k[b>>2]=26;i[g+30>>0]=0;D=246296;G=F+26|0;do{i[F>>0]=i[D>>0]|0;F=F+1|0;D=D+1|0}while((F|0)<(G|0));Y8(-215,ba,247037,246054,2453);k[b>>2]=0;k[ba>>2]=0;T=k[g>>2]|0;k[g>>2]=T+-1;if((T|0)==1)ggb(k[g+-4>>2]|0)}z2(O,_,k[qa>>2]&4095,0);z2(P,$,k[qa>>2]&4095,0);b=(j|0)<-2147483646?-2147483646:j;b=(b|0)==2147483647?2147483646:b;T=m+(J*56|0)+12|0;if((b|0)<0){S=k[T>>2]|0;k[T>>2]=0;b=1-b|0}else S=0;$Y(na,n,b);w=(e|0)<0;x=ca+4|0;y=ba+12|0;z=ba+20|0;A=(e|0)>-1;B=da+4|0;C=ea+4|0;E=pa+8|0;H=fa+4|0;I=ga+4|0;J=ha+4|0;K=ca+4|0;L=ia+4|0;M=ja+4|0;d=ka+4|0;h=la+4|0;N=ca+4|0;O=na+4|0;P=ba+8|0;v=ba+4|0;Q=ba+16|0;R=na+8|0;while(1){m=k[na>>2]|0;g=k[O>>2]|0;if(!m)break;b=k[m+20>>2]|0;if((b|0)!=0?(ma=g+1|0,(ma|0)<(k[R>>2]|0)):0)g=ma;else{j=m;oa=136}a:do if((oa|0)==136){while(1){oa=0;b=k[j+12>>2]|0;if(b|0)break;b=g+-1|0;if((g|0)<1){g=b;b=0;break a}else{j=k[j+16>>2]|0;g=b;oa=136}}if(!j){b=0;break}b=(k[R>>2]|0)==0?0:b}while(0);k[na>>2]=b;k[O>>2]=g;u=k[m+24>>2]|0;c=k[m>>2]|0;j=c&4095;c=(c&32768|0)==0?_:$;KY(m,ba);do if(w){G=k[U>>2]|0;b=k[pa>>2]|0;g=G;if((G|0)==(b|0)|(g|0)==(b|0))break;k[U>>2]=g+(~((g+-8-b|0)>>>3)<<3)}while(0);b=k[m>>2]|0;do if((b&12288|0)==4096){if((b&16384|0)==0?1:(k[m+28>>2]|0)!=1){oa=167;break}t=m+56|0;o=k[t>>2]|0;s=m+60|0;a=k[s>>2]|0;k[ca>>2]=o;k[x>>2]=a;n=k[y>>2]|0;if(!n)b=0;else b=i[n>>0]|0;j=b&255;g=o+Z|0;b=a+Y|0;b:do if((u|0)>0){if(A){m=0;q=o;while(1){o=i[n>>0]|0;G=n+1|0;k[y>>2]=G;if(G>>>0>=(k[z>>2]|0)>>>0){G=k[(k[P>>2]|0)+4>>2]|0;k[P>>2]=G;D=k[G+16>>2]|0;k[y>>2]=D;F=k[(k[v>>2]|0)+28>>2]|0;G=k[G+12>>2]|0;k[Q>>2]=D;G=D+(aa(F,G)|0)|0;k[z>>2]=G}n=o<<24>>24;if(o<<24>>24!=j<<24>>24){k[da>>2]=g;k[B>>2]=b;k[ea>>2]=q;k[C>>2]=a;Hfa(qa,da,ea,c,e,f,2,0);j=o;g=q;b=a}o=q+(k[70328+(n<<3)>>2]|0)|0;k[ca>>2]=o;n=a+(k[70328+(n<<3)+4>>2]|0)|0;k[x>>2]=n;m=m+1|0;if((m|0)>=(u|0))break b;q=o;a=n;n=k[y>>2]|0}}else{m=0;q=o}while(1){o=i[n>>0]|0;G=n+1|0;k[y>>2]=G;if(G>>>0>=(k[z>>2]|0)>>>0){G=k[(k[P>>2]|0)+4>>2]|0;k[P>>2]=G;D=k[G+16>>2]|0;k[y>>2]=D;F=k[(k[v>>2]|0)+28>>2]|0;G=k[G+12>>2]|0;k[Q>>2]=D;G=D+(aa(F,G)|0)|0;k[z>>2]=G}n=o<<24>>24;do if(o<<24>>24!=j<<24>>24){b=k[U>>2]|0;if((b|0)==(k[E>>2]|0)){Efa(pa,ca);j=o;g=q;b=a;break}else{k[b>>2]=q;k[b+4>>2]=a;k[U>>2]=b+8;j=o;g=q;b=a;break}}while(0);o=q+(k[70328+(n<<3)>>2]|0)|0;k[ca>>2]=o;n=a+(k[70328+(n<<3)+4>>2]|0)|0;k[x>>2]=n;m=m+1|0;if((m|0)>=(u|0))break b;q=o;a=n;n=k[y>>2]|0}}while(0);if(A){k[fa>>2]=g;k[H>>2]=b;G=(k[s>>2]|0)+Y|0;k[ga>>2]=(k[t>>2]|0)+Z;k[I>>2]=G;Hfa(qa,fa,ga,c,e,f,2,0)}else{F=k[pa>>2]|0;G=(k[U>>2]|0)-F>>3;k[ha>>2]=Z;k[J>>2]=Y;Pfa(qa,F,G,sa,_,f,0,ha)}}else oa=167;while(0);do if((oa|0)==167){oa=0;if((b&16382|0)!=4108)break;if((j|0)!=12){k[ca>>2]=0;k[N>>2]=0;b=ZT(28)|0;k[b>>2]=1;F=b+4|0;k[ca>>2]=F;k[N>>2]=21;i[b+25>>0]=0;D=247052;G=F+21|0;do{i[F>>0]=i[D>>0]|0;F=F+1|0;D=D+1|0}while((F|0)<(G|0));Y8(-215,ca,247037,246054,2519);k[N>>2]=0;k[ca>>2]=0;G=k[b>>2]|0;k[b>>2]=G+-1;if((G|0)==1)ggb(k[b+-4>>2]|0);b=k[m>>2]|0}k[ia>>2]=0;k[L>>2]=0;o=u-(b>>>14&1^1)|0;G=k[y>>2]|0;g=G;b=g;b=l[b>>0]|l[b+1>>0]<<8|l[b+2>>0]<<16|l[b+3>>0]<<24;g=g+4|0;g=l[g>>0]|l[g+1>>0]<<8|l[g+2>>0]<<16|l[g+3>>0]<<24;F=ca;k[F>>2]=b;k[F+4>>2]=g;G=G+8|0;k[y>>2]=G;if(G>>>0>=(k[z>>2]|0)>>>0){G=k[(k[P>>2]|0)+4>>2]|0;k[P>>2]=G;D=k[G+16>>2]|0;k[y>>2]=D;F=k[(k[v>>2]|0)+28>>2]|0;G=k[G+12>>2]|0;k[Q>>2]=D;G=D+(aa(F,G)|0)|0;k[z>>2]=G}j=b+Z|0;k[ca>>2]=j;g=g+Y|0;k[K>>2]=g;do if(w){b=k[U>>2]|0;if((b|0)==(k[E>>2]|0)){Efa(pa,ca);break}else{k[b>>2]=j;k[b+4>>2]=g;k[U>>2]=b+8;break}}while(0);c:do if((o|0)>0){if(A){n=0;while(1){G=k[y>>2]|0;m=G;b=m;b=l[b>>0]|l[b+1>>0]<<8|l[b+2>>0]<<16|l[b+3>>0]<<24;m=m+4|0;m=l[m>>0]|l[m+1>>0]<<8|l[m+2>>0]<<16|l[m+3>>0]<<24;F=ia;k[F>>2]=b;k[F+4>>2]=m;G=G+8|0;k[y>>2]=G;if(G>>>0>=(k[z>>2]|0)>>>0){G=k[(k[P>>2]|0)+4>>2]|0;k[P>>2]=G;D=k[G+16>>2]|0;k[y>>2]=D;F=k[(k[v>>2]|0)+28>>2]|0;G=k[G+12>>2]|0;k[Q>>2]=D;G=D+(aa(F,G)|0)|0;k[z>>2]=G}F=j;j=b+Z|0;k[ia>>2]=j;G=g;g=m+Y|0;k[L>>2]=g;k[ja>>2]=F;k[M>>2]=G;k[ka>>2]=j;k[d>>2]=g;Hfa(qa,ja,ka,c,e,f,2,0);k[ca>>2]=j;k[K>>2]=g;n=n+1|0;if((n|0)>=(o|0))break c}}else m=0;do{G=k[y>>2]|0;g=G;b=g;b=l[b>>0]|l[b+1>>0]<<8|l[b+2>>0]<<16|l[b+3>>0]<<24;g=g+4|0;g=l[g>>0]|l[g+1>>0]<<8|l[g+2>>0]<<16|l[g+3>>0]<<24;F=ia;k[F>>2]=b;k[F+4>>2]=g;G=G+8|0;k[y>>2]=G;if(G>>>0>=(k[z>>2]|0)>>>0){G=k[(k[P>>2]|0)+4>>2]|0;k[P>>2]=G;D=k[G+16>>2]|0;k[y>>2]=D;F=k[(k[v>>2]|0)+28>>2]|0;G=k[G+12>>2]|0;k[Q>>2]=D;G=D+(aa(F,G)|0)|0;k[z>>2]=G}j=b+Z|0;k[ia>>2]=j;b=g+Y|0;k[L>>2]=b;g=k[U>>2]|0;if((g|0)==(k[E>>2]|0))Efa(pa,ia);else{k[g>>2]=j;k[g+4>>2]=b;k[U>>2]=g+8}k[ca>>2]=j;k[K>>2]=b;m=m+1|0}while((m|0)<(o|0))}while(0);if(w){F=k[pa>>2]|0;G=(k[U>>2]|0)-F>>3;k[la>>2]=0;k[h>>2]=0;Pfa(qa,F,G,sa,_,f,0,la)}}while(0)}k[na>>2]=0;if(w)Qfa(qa,sa,_);if(S|0)k[T>>2]=S}j=qa+36|0;b=k[j>>2]|0;if(b|0?(na=b+12|0,oa=k[na>>2]|0,k[na>>2]=oa+-1,(oa|0)==1):0){g=k[j>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[qa+32>>2]|0;if(b|0)break;b=B1()|0;g=k[j>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[j>>2]=0}k[j>>2]=0;oa=qa+16|0;g=qa+4|0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[g>>2]|0)>0){j=k[qa+40>>2]|0;b=0;do{k[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[qa+44>>2]|0;if(!((b|0)==(qa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[pa>>2]|0;g=b;if(b|0){j=k[U>>2]|0;if((j|0)!=(b|0))k[U>>2]=j+(~((j+-8-g|0)>>>3)<<3);ggb(b)}b=k[sa>>2]|0;g=b;if(b|0){j=k[V>>2]|0;if((j|0)!=(b|0))k[V>>2]=j+(~(((j+-20-g|0)>>>0)/20|0)*20|0);ggb(b)}b=k[va>>2]|0;g=b;if(b|0){j=k[W>>2]|0;if((j|0)!=(b|0))k[W>>2]=j+(~(((j+-20-g|0)>>>0)/20|0)*20|0);ggb(b)}}b=k[wa>>2]|0;g=b;if(b|0){j=k[X>>2]|0;if((j|0)!=(b|0))k[X>>2]=j+(~(((j+-56-g|0)>>>0)/56|0)*56|0);ggb(b)}j=xa+36|0;b=k[j>>2]|0;if(b|0?(va=b+12|0,wa=k[va>>2]|0,k[va>>2]=wa+-1,(wa|0)==1):0){g=k[j>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[xa+32>>2]|0;if(!b){b=B1()|0;g=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[j>>2]=0}k[j>>2]=0;wa=xa+16|0;g=xa+4|0;k[wa>>2]=0;k[wa+4>>2]=0;k[wa+8>>2]=0;k[wa+12>>2]=0;if((k[g>>2]|0)>0){j=k[xa+40>>2]|0;b=0;do{k[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[xa+44>>2]|0;if(!((b|0)==(xa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);j=ya+36|0;b=k[j>>2]|0;if(b|0?(wa=b+12|0,xa=k[wa>>2]|0,k[wa>>2]=xa+-1,(xa|0)==1):0){g=k[j>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[ya+32>>2]|0;if(!b){b=B1()|0;g=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[j>>2]=0}k[j>>2]=0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[ta>>2]|0)>0){g=k[ya+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ta>>2]|0))}b=k[ua>>2]|0;if((b|0)==(ya+48|0)|(b|0)==0){r=za;return}ggb(k[b+-4>>2]|0);r=za;return}function pk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=r;r=r+32|0;h=f+16|0;g=f;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=a;a=g+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[g>>2]=50397184;k[g+4>>2]=c;cVa(h,b,g,d,e);r=f;return}function qk(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=r;r=r+16|0;i=h;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];Ffa(a,i,c,d,e,f,g);r=h;return}function rk(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;O=r;r=r+192|0;N=O+136|0;I=O+80|0;A=O+64|0;B=O;m=O+48|0;n=O+32|0;D=O+16|0;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=c;M=D+4+4|0;k[M>>2]=0;k[M+4>>2]=0;k[D>>2]=50397184;k[D+4>>2]=f;M=k[j>>2]|0;z=j+4|0;L=k[z>>2]|0;if((M|0)!=(L|0)?(L-M|0)!=((k[e+4>>2]|0)-(k[e>>2]|0)>>4|0):0){k[N>>2]=0;a=N+4|0;k[a>>2]=0;c=ZT(56)|0;k[c>>2]=1;o=c+4|0;k[N>>2]=o;k[a>>2]=50;i[c+54>>0]=0;f=386181;p=o+50|0;do{i[o>>0]=i[f>>0]|0;o=o+1|0;f=f+1|0}while((o|0)<(p|0));Y8(-201,N,386232,386067,196);k[a>>2]=0;k[N>>2]=0;M=k[c>>2]|0;k[c>>2]=M+-1;if((M|0)==1)ggb(k[c+-4>>2]|0)}k[N>>2]=1124007936;L=N+4|0;a=N+8|0;J=N+40|0;o=L;p=o+36|0;do{k[o>>2]=0;o=o+4|0}while((o|0)<(p|0));k[J>>2]=a;M=N+48|0;K=N+44|0;k[K>>2]=M;k[N+52>>2]=0;k[M>>2]=0;k[I>>2]=1124007936;G=I+4|0;a=I+8|0;E=I+40|0;o=G;p=o+36|0;do{k[o>>2]=0;o=o+4|0}while((o|0)<(p|0));k[E>>2]=a;H=I+48|0;F=I+44|0;k[F>>2]=H;k[I+52>>2]=0;k[H>>2]=0;eVa(m,b,n,d,D,N,I,h,l);h=e+4|0;c=k[h>>2]|0;a=k[e>>2]|0;if((c|0)!=(a|0)){q=b+4|0;s=d+4|0;t=A+4|0;u=t+4|0;v=B+4|0;w=v+4|0;x=A+4|0;y=A+4|0;n=0;do{f=a;p=k[j>>2]|0;if(!((p|0)!=(k[z>>2]|0)?(i[p+n>>0]|0)==0:0)){m=k[f+(n<<4)>>2]|0;c=k[f+(n<<4)+4>>2]|0;if(!((m|0)>-1?(m|0)<(((k[q>>2]|0)-(k[b>>2]|0)|0)/28|0|0):0)){k[A>>2]=0;k[y>>2]=0;a=ZT(56)|0;k[a>>2]=1;o=a+4|0;k[A>>2]=o;k[y>>2]=51;i[a+55>>0]=0;f=386244;p=o+51|0;do{i[o>>0]=i[f>>0]|0;o=o+1|0;f=f+1|0}while((o|0)<(p|0));Y8(-215,A,386232,386067,209);k[y>>2]=0;k[A>>2]=0;p=k[a>>2]|0;k[a>>2]=p+-1;if((p|0)==1)ggb(k[a+-4>>2]|0)}if((c|0)>-1?(C=k[d>>2]|0,(c|0)<(((k[s>>2]|0)-C|0)/28|0|0)):0)a=C;else{k[A>>2]=0;k[x>>2]=0;a=ZT(56)|0;k[a>>2]=1;o=a+4|0;k[A>>2]=o;k[x>>2]=51;i[a+55>>0]=0;f=386296;p=o+51|0;do{i[o>>0]=i[f>>0]|0;o=o+1|0;f=f+1|0}while((o|0)<(p|0));Y8(-215,A,386232,386067,210);k[x>>2]=0;k[A>>2]=0;p=k[a>>2]|0;k[a>>2]=p+-1;if((p|0)==1)ggb(k[a+-4>>2]|0);a=k[d>>2]|0}p=(k[b>>2]|0)+(m*28|0)|0;o=u;k[o>>2]=0;k[o+4>>2]=0;k[A>>2]=50397184;k[t>>2]=N;o=w;k[o>>2]=0;k[o+4>>2]=0;k[B>>2]=50397184;k[v>>2]=I;fVa(D,A,B,p,a+(c*28|0)|0,g,l);a=k[e>>2]|0;c=k[h>>2]|0}n=n+1|0}while(n>>>0<c-a>>4>>>0)}f=I+36|0;a=k[f>>2]|0;if(a|0?(j=a+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){c=k[f>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[I+32>>2]|0;if(!a){a=B1()|0;c=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[f>>2]=0}k[f>>2]=0;I=I+16|0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[G>>2]|0)>0){c=k[E>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[G>>2]|0))}a=k[F>>2]|0;if(!((a|0)==(H|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=N+36|0;a=k[f>>2]|0;if(a|0?(H=a+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){c=k[f>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[N+32>>2]|0;if(!a){a=B1()|0;c=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[f>>2]=0}k[f>>2]=0;N=N+16|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[L>>2]|0)>0){c=k[J>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[L>>2]|0))}a=k[K>>2]|0;if((a|0)==(M|0)|(a|0)==0){r=O;return}ggb(k[a+-4>>2]|0);r=O;return}function sk(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;I=r;r=r+192|0;H=I+136|0;C=I+80|0;w=I+64|0;x=I+32|0;o=I+48|0;p=I+16|0;y=I;k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=a;k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=c;G=y+4+4|0;k[G>>2]=0;k[G+4>>2]=0;k[y>>2]=50397184;k[y+4>>2]=f;G=k[j>>2]|0;u=j+4|0;F=k[u>>2]|0;if((G|0)!=(F|0)?(F-G|0)!=((k[e+4>>2]|0)-(k[e>>2]|0)|0):0){k[H>>2]=0;a=H+4|0;k[a>>2]=0;c=ZT(56)|0;k[c>>2]=1;m=c+4|0;k[H>>2]=m;k[a>>2]=50;i[c+54>>0]=0;f=386181;n=m+50|0;do{i[m>>0]=i[f>>0]|0;m=m+1|0;f=f+1|0}while((m|0)<(n|0));Y8(-201,H,386232,386067,225);k[a>>2]=0;k[H>>2]=0;G=k[c>>2]|0;k[c>>2]=G+-1;if((G|0)==1)ggb(k[c+-4>>2]|0)}k[H>>2]=1124007936;F=H+4|0;a=H+8|0;D=H+40|0;m=F;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[D>>2]=a;G=H+48|0;E=H+44|0;k[E>>2]=G;k[H+52>>2]=0;k[G>>2]=0;k[C>>2]=1124007936;B=C+4|0;a=C+8|0;z=C+40|0;m=B;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[z>>2]=a;A=C+48|0;v=C+44|0;k[v>>2]=A;k[C+52>>2]=0;k[A>>2]=0;eVa(o,b,p,d,y,H,C,h,l);p=e+4|0;a=k[p>>2]|0;c=k[e>>2]|0;if((a|0)!=(c|0)){h=w+4|0;q=h+4|0;s=x+4|0;t=s+4|0;o=0;do{f=c;if((k[f+(o*12|0)+4>>2]|0)!=(k[f+(o*12|0)>>2]|0)){n=0;a=f;do{m=k[a+(o*12|0)>>2]|0;f=k[m+(n<<4)>>2]|0;m=k[m+(n<<4)+4>>2]|0;J=k[j>>2]|0;if(!((J|0)!=(k[u>>2]|0)?(i[(k[J+(o*12|0)>>2]|0)+n>>0]|0)==0:0)){a=(k[b>>2]|0)+(f*28|0)|0;c=(k[d>>2]|0)+(m*28|0)|0;J=q;k[J>>2]=0;k[J+4>>2]=0;k[w>>2]=50397184;k[h>>2]=H;J=t;k[J>>2]=0;k[J+4>>2]=0;k[x>>2]=50397184;k[s>>2]=C;fVa(y,w,x,a,c,g,l);c=k[e>>2]|0;a=c}n=n+1|0}while(n>>>0<(k[a+(o*12|0)+4>>2]|0)-(k[a+(o*12|0)>>2]|0)>>4>>>0);a=k[p>>2]|0}o=o+1|0}while(o>>>0<((a-c|0)/12|0)>>>0)}f=C+36|0;a=k[f>>2]|0;if(a|0?(l=a+12|0,J=k[l>>2]|0,k[l>>2]=J+-1,(J|0)==1):0){c=k[f>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[C+32>>2]|0;if(!a){a=B1()|0;c=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[f>>2]=0}k[f>>2]=0;J=C+16|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[B>>2]|0)>0){c=k[z>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[B>>2]|0))}a=k[v>>2]|0;if(!((a|0)==(A|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=H+36|0;a=k[f>>2]|0;if(a|0?(C=a+12|0,J=k[C>>2]|0,k[C>>2]=J+-1,(J|0)==1):0){c=k[f>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[H+32>>2]|0;if(!a){a=B1()|0;c=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[f>>2]=0}k[f>>2]=0;J=H+16|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[F>>2]|0)>0){c=k[D>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[F>>2]|0))}a=k[E>>2]|0;if((a|0)==(G|0)|(a|0)==0){r=I;return}ggb(k[a+-4>>2]|0);r=I;return}function tk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+736|0;s=z+712|0;y=z+656|0;o=z+648|0;w=z+592|0;v=z+536|0;u=z+88|0;t=z+32|0;q=z;m=z+16|0;n=m+4|0;l=m+4+4|0;k[l>>2]=0;k[l+4>>2]=0;k[m>>2]=33619968;k[n>>2]=b;k[y>>2]=k[a>>2];l=y+4|0;f=a+4|0;b=k[f>>2]|0;k[l>>2]=b;p=y+8|0;k[p>>2]=k[a+8>>2];k[y+12>>2]=k[a+12>>2];k[y+16>>2]=k[a+16>>2];k[y+20>>2]=k[a+20>>2];k[y+24>>2]=k[a+24>>2];k[y+28>>2]=k[a+28>>2];k[y+32>>2]=k[a+32>>2];g=k[a+36>>2]|0;k[y+36>>2]=g;x=y+40|0;k[x>>2]=p;p=y+48|0;j=y+44|0;k[j>>2]=p;k[y+52>>2]=0;k[p>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[f>>2]|0}if((b|0)>=3){k[l>>2]=0;x1(y,b,0,0,0);if((k[l>>2]|0)>0){h=k[a+40>>2]|0;i=k[x>>2]|0;g=k[a+44>>2]|0;f=k[j>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[h+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{l=k[a+44>>2]|0;p=k[j>>2]|0;k[p>>2]=k[l>>2];k[p+4>>2]=k[l+4>>2]}l=k[x>>2]|0;p=k[l>>2]|0;k[o>>2]=k[l+4>>2];k[o+4>>2]=p;x2(m,o,16,0);do if((k[m>>2]&2031616|0)==65536){i=k[n>>2]|0;k[w>>2]=k[i>>2];l=w+4|0;f=i+4|0;k[l>>2]=k[f>>2];p=w+8|0;k[p>>2]=k[i+8>>2];k[w+12>>2]=k[i+12>>2];k[w+16>>2]=k[i+16>>2];k[w+20>>2]=k[i+20>>2];k[w+24>>2]=k[i+24>>2];k[w+28>>2]=k[i+28>>2];k[w+32>>2]=k[i+32>>2];b=k[i+36>>2]|0;k[w+36>>2]=b;g=w+40|0;k[g>>2]=p;p=w+48|0;a=w+44|0;k[a>>2]=p;k[w+52>>2]=0;k[p>>2]=0;if(b|0){p=b+12|0;k[p>>2]=(k[p>>2]|0)+1}if((k[f>>2]|0)<3){o=k[i+44>>2]|0;p=k[a>>2]|0;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];break}k[l>>2]=0;x1(w,k[f>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[i+40>>2]|0;h=k[g>>2]|0;g=k[i+44>>2]|0;f=k[a>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(w,m,-1);while(0);g=k[x>>2]|0;f=k[g>>2]|0;g=k[g+4>>2]|0;k[v>>2]=1124007936;o=v+4|0;b=v+8|0;m=v+40|0;h=o;a=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(a|0));k[m>>2]=b;p=v+48|0;n=v+44|0;k[n>>2]=p;k[v+52>>2]=0;k[p>>2]=0;k[s>>2]=f;l=s+4|0;k[l>>2]=g;G1(v,2,s,21);b=s+4|0;f=b+4|0;k[f>>2]=0;k[f+4>>2]=0;k[s>>2]=33619968;k[b>>2]=v;SW(w,s,21,.00392156862745098,0.0);k[u>>2]=1124007936;b=u+8|0;f=u+40|0;h=u+4|0;a=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(a|0));k[f>>2]=b;b=u+48|0;k[u+44>>2]=b;k[u+52>>2]=0;k[b>>2]=0;k[u+56>>2]=1124007936;b=u+64|0;f=u+96|0;h=u+60|0;a=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(a|0));k[f>>2]=b;b=u+104|0;k[u+100>>2]=b;k[u+108>>2]=0;k[b>>2]=0;k[u+112>>2]=1124007936;b=u+120|0;f=u+152|0;h=u+116|0;a=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(a|0));k[f>>2]=b;b=u+160|0;k[u+156>>2]=b;k[u+164>>2]=0;k[b>>2]=0;k[u+168>>2]=1124007936;b=u+176|0;f=u+208|0;h=u+172|0;a=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(a|0));k[f>>2]=b;b=u+216|0;k[u+212>>2]=b;k[u+220>>2]=0;k[b>>2]=0;k[u+224>>2]=1124007936;b=u+232|0;f=u+264|0;h=u+228|0;a=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(a|0));k[f>>2]=b;b=u+272|0;k[u+268>>2]=b;k[u+276>>2]=0;k[b>>2]=0;k[u+280>>2]=1124007936;b=u+288|0;f=u+320|0;h=u+284|0;a=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(a|0));k[f>>2]=b;b=u+328|0;k[u+324>>2]=b;k[u+332>>2]=0;k[b>>2]=0;k[u+336>>2]=1124007936;b=u+344|0;f=u+376|0;h=u+340|0;a=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(a|0));k[f>>2]=b;b=u+384|0;k[u+380>>2]=b;k[u+388>>2]=0;k[b>>2]=0;k[u+392>>2]=1124007936;b=u+400|0;f=u+432|0;h=u+396|0;a=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(a|0));k[f>>2]=b;g=u+440|0;k[u+436>>2]=g;k[u+444>>2]=0;k[g>>2]=0;g=k[x>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[t>>2]=1124007936;j=t+4|0;b=t+8|0;i=t+40|0;h=j;a=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(a|0));k[i>>2]=b;a=t+48|0;h=t+44|0;k[h>>2]=a;k[t+52>>2]=0;k[a>>2]=0;k[s>>2]=g;k[l>>2]=f;G1(t,2,s,21);g=s+4|0;b=g+4|0;k[b>>2]=0;k[b+4>>2]=0;k[s>>2]=33619968;k[g>>2]=t;SW(y,s,21,.00392156862745098,0.0);M3a(u,t,v,d,e,c);k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=v;g=q+4|0;b=g+4|0;k[b>>2]=0;k[b+4>>2]=0;k[q>>2]=33619968;k[g>>2]=w;KW(s,q,255.0,0.0);g=t+36|0;b=k[g>>2]|0;if(b|0?(c=b+12|0,s=k[c>>2]|0,k[c>>2]=s+-1,(s|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[t+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;t=t+16|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[j>>2]|0)>0){f=k[i>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[h>>2]|0;if(!((b|0)==(a|0)|(b|0)==0))ggb(k[b+-4>>2]|0);N3a(u);g=v+36|0;b=k[g>>2]|0;if(b|0?(t=b+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[v+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;v=v+16|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[o>>2]|0)>0){f=k[m>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[o>>2]|0))}b=k[n>>2]|0;if(!((b|0)==(p|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=w+36|0;b=k[g>>2]|0;if(b|0?(u=b+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[w+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;v=w+16|0;f=w+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[f>>2]|0)>0){g=k[w+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[w+44>>2]|0;if(!((b|0)==(w+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=y+36|0;b=k[g>>2]|0;if(b|0?(v=b+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[y+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;w=y+16|0;g=y+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[g>>2]|0)>0){f=k[x>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[y+44>>2]|0;if((b|0)==(y+48|0)|(b|0)==0){r=z;return}ggb(k[b+-4>>2]|0);r=z;return}function uk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=r;r=r+48|0;g=d+32|0;f=d+16|0;e=d;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;b=e+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=c;FZ(g,f,e);r=d;return 1}function vk(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+112|0;B=C+48|0;x=C;y=C+40|0;z=C+32|0;A=k[b>>2]|0;v=k[b+4>>2]|0;w=k[c>>2]|0;t=k[c+4>>2]|0;k[B>>2]=k[a>>2];s=B+4|0;c=a+4|0;b=k[c>>2]|0;k[s>>2]=b;o=B+8|0;k[o>>2]=k[a+8>>2];k[B+12>>2]=k[a+12>>2];k[B+16>>2]=k[a+16>>2];k[B+20>>2]=k[a+20>>2];k[B+24>>2]=k[a+24>>2];k[B+28>>2]=k[a+28>>2];k[B+32>>2]=k[a+32>>2];m=k[a+36>>2]|0;k[B+36>>2]=m;n=B+40|0;k[n>>2]=o;o=B+48|0;q=B+44|0;k[q>>2]=o;k[B+52>>2]=0;k[o>>2]=0;if(m){b=m+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[s>>2]=0;x1(B,b,0,0,0);if((k[s>>2]|0)>0){o=k[a+40>>2]|0;n=k[n>>2]|0;m=k[a+44>>2]|0;c=k[q>>2]|0;b=0;do{k[n+(b<<2)>>2]=k[o+(b<<2)>>2];k[c+(b<<2)>>2]=k[m+(b<<2)>>2];b=b+1|0}while((b|0)<(k[s>>2]|0))}}else{a=k[a+44>>2]|0;s=k[q>>2]|0;k[s>>2]=k[a>>2];k[s+4>>2]=k[a+4>>2]}if((j|0)==16)j=(k[B>>2]&7|0)==0?16:8;if(!((w|0)>-1?(l|0)<17&((h|0)<32768&(t|l|0)>-1):0)){k[x>>2]=0;b=x+4|0;k[b>>2]=0;c=ZT(108)|0;k[c>>2]=1;m=c+4|0;k[x>>2]=m;k[b>>2]=100;i[c+104>>0]=0;n=246417;o=m+100|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,x,246518,246054,1839);k[b>>2]=0;k[x>>2]=0;s=k[c>>2]|0;k[c>>2]=s+-1;if((s|0)==1)ggb(k[c+-4>>2]|0)}z2(g,x,k[B>>2]&4095,0);p[u>>3]=d;b=k[u+4>>2]|0;g=b&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){b=(b|0)<0;d=b?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=b?-0.0:0.0}m=~~d;p[u>>3]=e;b=k[u+4>>2]|0;g=b&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){b=(b|0)<0;d=b?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=b?-0.0:0.0}else d=e;c=~~d;p[u>>3]=f;b=k[u+4>>2]|0;g=b&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){b=(b|0)<0;d=b?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=b?-0.0:0.0}else d=f;b=16-l|0;k[y>>2]=A<<b;k[y+4>>2]=v<<b;k[z>>2]=w<<b;k[z+4>>2]=t<<b;Nfa(B,y,z,m,c,~~d,x,h,j);m=B+36|0;b=k[m>>2]|0;if(b|0?(h=b+12|0,l=k[h>>2]|0,k[h>>2]=l+-1,(l|0)==1):0){c=k[m>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[B+32>>2]|0;if(!b){b=B1()|0;c=k[m>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[m>>2]=0}k[m>>2]=0;l=B+16|0;c=B+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[c>>2]|0)>0){m=k[B+40>>2]|0;b=0;do{k[m+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[B+44>>2]|0;if((b|0)==(B+48|0)|(b|0)==0){r=C;return}ggb(k[b+-4>>2]|0);r=C;return}function wk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0;w=r;r=r+112|0;v=w+48|0;q=w;s=w+40|0;t=w+32|0;k[v>>2]=k[a>>2];p=v+4|0;g=a+4|0;f=k[g>>2]|0;k[p>>2]=f;m=v+8|0;k[m>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[v+16>>2]=k[a+16>>2];k[v+20>>2]=k[a+20>>2];k[v+24>>2]=k[a+24>>2];k[v+28>>2]=k[a+28>>2];k[v+32>>2]=k[a+32>>2];h=k[a+36>>2]|0;k[v+36>>2]=h;l=v+40|0;k[l>>2]=m;m=v+48|0;n=v+44|0;k[n>>2]=m;k[v+52>>2]=0;k[m>>2]=0;if(h){f=h+12|0;k[f>>2]=(k[f>>2]|0)+1;f=k[g>>2]|0}if((f|0)>=3){k[p>>2]=0;x1(v,f,0,0,0);if((k[p>>2]|0)>0){m=k[a+40>>2]|0;l=k[l>>2]|0;h=k[a+44>>2]|0;g=k[n>>2]|0;f=0;do{k[l+(f<<2)>>2]=k[m+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[p>>2]|0))}}else{a=k[a+44>>2]|0;p=k[n>>2]|0;k[p>>2]=k[a>>2];k[p+4>>2]=k[a+4>>2]}if((e|0)==16)e=(k[v>>2]&7|0)==0?16:8;a=b+8|0;if(!(+o[a>>2]>=0.0?((d|0)<32768?+o[b+12>>2]>=0.0:0):0)){k[q>>2]=0;f=q+4|0;k[f>>2]=0;g=ZT(80)|0;k[g>>2]=1;h=g+4|0;k[q>>2]=h;k[f>>2]=73;i[g+77>>0]=0;l=246526;m=h+73|0;do{i[h>>0]=i[l>>0]|0;h=h+1|0;l=l+1|0}while((h|0)<(m|0));Y8(-215,q,246518,246054,1865);k[f>>2]=0;k[q>>2]=0;p=k[g>>2]|0;k[g>>2]=p+-1;if((p|0)==1)ggb(k[g+-4>>2]|0)}z2(c,q,k[v>>2]&4095,0);j=+o[b+16>>2];f=(o[u>>2]=j,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;j=f?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=f?-0.0:0.0}m=~~j;j=+o[b>>2]*65536.0;f=(o[u>>2]=j,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;j=f?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=f?-0.0:0.0}l=~~j;j=+o[b+4>>2]*65536.0;f=(o[u>>2]=j,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;j=f?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=f?-0.0:0.0}h=~~j;j=+o[a>>2]*32768.0;f=(o[u>>2]=j,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;j=f?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=f?-0.0:0.0}g=~~j;j=+o[b+12>>2]*32768.0;f=(o[u>>2]=j,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;j=f?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=f?-0.0:0.0}k[s>>2]=l;k[s+4>>2]=h;k[t>>2]=g;k[t+4>>2]=~~j;Nfa(v,s,t,m,0,360,q,d,e);h=v+36|0;f=k[h>>2]|0;if(f|0?(s=f+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[v+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;t=v+16|0;g=v+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[g>>2]|0)>0){h=k[v+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[v+44>>2]|0;if((f|0)==(v+48|0)|(f|0)==0){r=w;return}ggb(k[f+-4>>2]|0);r=w;return}function xk(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=r;r=r+16|0;i=h;k[i>>2]=k[a>>2];k[i+4>>2]=k[a+4>>2];Dfa(i,k[b>>2]|0,k[b+4>>2]|0,c,d,e,f,g);r=h;return}function yk(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=r;r=r+2272|0;E=F+2216|0;q=F+2208|0;D=F+2152|0;B=F+2144|0;w=F+1120|0;x=F+96|0;s=F+80|0;C=F+64|0;z=F+56|0;t=F+40|0;v=F;g=F+24|0;n=F+8|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;h=g+4|0;k[h>>2]=a;m=n+4|0;y=n+4+4|0;k[y>>2]=0;k[y+4>>2]=0;k[n>>2]=33619968;k[m>>2]=b;if(S1(g,-1)|0){k[E>>2]=0;a=E+4|0;k[a>>2]=0;b=ZT(28)|0;k[b>>2]=1;c=b+4|0;k[E>>2]=c;k[a>>2]=22;i[b+26>>0]=0;e=334788;f=c+22|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));Y8(-215,E,334811,333645,3687);k[a>>2]=0;k[E>>2]=0;y=k[b>>2]|0;k[b>>2]=y+-1;if((y|0)==1)ggb(k[b+-4>>2]|0)}if(G2(g)|0){r=F;return}do if((k[g>>2]&2031616|0)==65536){c=k[h>>2]|0;k[E>>2]=k[c>>2];h=E+4|0;a=c+4|0;k[h>>2]=k[a>>2];y=E+8|0;k[y>>2]=k[c+8>>2];k[E+12>>2]=k[c+12>>2];k[E+16>>2]=k[c+16>>2];k[E+20>>2]=k[c+20>>2];k[E+24>>2]=k[c+24>>2];k[E+28>>2]=k[c+28>>2];k[E+32>>2]=k[c+32>>2];b=k[c+36>>2]|0;k[E+36>>2]=b;j=E+40|0;k[j>>2]=y;y=E+48|0;e=E+44|0;k[e>>2]=y;k[E+52>>2]=0;k[y>>2]=0;if(b|0){y=b+12|0;k[y>>2]=(k[y>>2]|0)+1}if((k[a>>2]|0)<3){a=k[c+44>>2]|0;y=k[e>>2]|0;k[y>>2]=k[a>>2];k[y+4>>2]=k[a+4>>2];y=j;a=E;break}k[h>>2]=0;x1(E,k[a>>2]|0,0,0,0);if((k[h>>2]|0)>0){f=k[c+40>>2]|0;g=k[j>>2]|0;c=k[c+44>>2]|0;b=k[e>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[f+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0));y=j;a=E}else{y=j;a=E}}else{Q1(E,g,-1);y=E+40|0;a=E}while(0);h=k[y>>2]|0;j=k[h>>2]|0;k[q>>2]=k[h+4>>2];k[q+4>>2]=j;x2(n,q,k[a>>2]&4095,0);do if((k[n>>2]&2031616|0)==65536){e=k[m>>2]|0;k[D>>2]=k[e>>2];j=D+4|0;a=e+4|0;k[j>>2]=k[a>>2];q=D+8|0;k[q>>2]=k[e+8>>2];k[D+12>>2]=k[e+12>>2];k[D+16>>2]=k[e+16>>2];k[D+20>>2]=k[e+20>>2];k[D+24>>2]=k[e+24>>2];k[D+28>>2]=k[e+28>>2];k[D+32>>2]=k[e+32>>2];b=k[e+36>>2]|0;k[D+36>>2]=b;c=D+40|0;k[c>>2]=q;q=D+48|0;g=D+44|0;k[g>>2]=q;k[D+52>>2]=0;k[q>>2]=0;if(b|0){q=b+12|0;k[q>>2]=(k[q>>2]|0)+1}if((k[a>>2]|0)<3){n=k[e+44>>2]|0;q=k[g>>2]|0;k[q>>2]=k[n>>2];k[q+4>>2]=k[n+4>>2];break}k[j>>2]=0;x1(D,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[e+40>>2]|0;f=k[c>>2]|0;c=k[e+44>>2]|0;b=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else Q1(D,n,-1);while(0);m9(B);zpb(w|0,0,1024)|0;k[s>>2]=85836;k[s+4>>2]=E;k[s+8>>2]=w;k[s+12>>2]=B;k[C>>2]=85856;k[C+4>>2]=E;k[C+8>>2]=D;k[C+12>>2]=x;j=E+8|0;n=k[j>>2]|0;k[z>>2]=0;k[z+4>>2]=n;n=E+4|0;b=k[n>>2]|0;if((b|0)>=3){a=0;do a=a+1|0;while((a|0)!=(b|0))}Cla(s,z);g=0;while(1){f=k[w+(g<<2)>>2]|0;b=g+1|0;if(!f)g=b;else break}m=k[n>>2]|0;h=(m|0)<3;if(h)a=aa(k[E+12>>2]|0,k[j>>2]|0)|0;else{e=k[y>>2]|0;c=0;a=1;do{a=aa(k[e+(c<<2)>>2]|0,a)|0;c=c+1|0}while((c|0)!=(m|0))}do if((a|0)!=(f|0)){l=255.0/+(a-f|0);k[x+(g<<2)>>2]=0;if((b|0)<256){c=0;do{c=(k[w+(b<<2)>>2]|0)+c|0;d=l*+(c|0);a=(o[u>>2]=d,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;d=a?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=a?-0.0:0.0}v=~~d;k[x+(b<<2)>>2]=(v>>>0<256?v:(v|0)>0?255:0)&255;b=b+1|0}while((b|0)!=256)}if(h)a=aa(k[E+12>>2]|0,k[j>>2]|0)|0;else{c=k[y>>2]|0;b=0;a=1;do{a=aa(k[c+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(m|0))}if(a>>>0>307199){jh[k[(k[C>>2]|0)+8>>2]&1023](C,z);break}else{Dla(C,z);break}}else{p[v>>3]=+(g|0);k[t>>2]=-1056833530;k[t+4>>2]=v;k[t+8>>2]=1;k[t+12>>2]=1;pY(D,t,49332)}while(0);z=(k[B>>2]|0)+28|0;C=k[z>>2]|0;k[z>>2]=C+-1;if((C|0)==1?(A=k[B>>2]|0,A|0):0){rf(A|0)|0;ggb(A)}c=D+36|0;a=k[c>>2]|0;if(a|0?(B=a+12|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[D+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;C=D+16|0;b=D+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[b>>2]|0)>0){c=k[D+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[D+44>>2]|0;if(!((a|0)==(D+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=E+36|0;a=k[c>>2]|0;if(a|0?(C=a+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[E+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;D=E+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[n>>2]|0)>0){b=k[y>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[E+44>>2]|0;if(!((a|0)==(E+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=F;return}function zk(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+64|0;i=h+48|0;m=h+32|0;l=h+16|0;j=h;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;a=l+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[l>>2]=33619968;k[l+4>>2]=b;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=c;c=k[d+4>>2]|0;k[i>>2]=k[d>>2];k[i+4>>2]=c;Dra(0,m,l,j,i,e,f,g);r=h;return}function Ak(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=c;F6a(a,g,f,d);r=e;return}function Bk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+32|0;e=c+16|0;d=c;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=a;a=d+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[d>>2]=33619968;k[d+4>>2]=b;XZ(e,d);r=c;return}function Ck(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+32|0;f=d+16|0;e=d;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=a;a=e+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=b;QV(f,e,c);r=d;return}function Dk(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;i=r;r=r+48|0;f=i+32|0;g=i+16|0;h=i;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=h+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=b;k[f>>2]=0;b=f+4|0;k[b>>2]=0;k[f+8>>2]=0;while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[f>>2]=a;j=a+4|0;k[f+8>>2]=j;o[a>>2]=c;k[b>>2]=j;y0a(g,h,f,d,e,4);ggb(a);r=i;return}function Ek(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=r;r=r+32|0;i=g+16|0;h=g;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=a;a=h+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=b;y0a(i,h,c,d,e,f);r=g;return}function Fk(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;va=r;r=r+672|0;T=va+648|0;K=va+640|0;ua=va+584|0;t=va+576|0;ta=va+520|0;sa=va+464|0;y=va+408|0;E=va+352|0;x=va+224|0;Q=va+184|0;R=va+72|0;W=va+16|0;S=va;ra=va+336|0;q=va+208|0;k[ra+8>>2]=0;k[ra+12>>2]=0;k[ra>>2]=16842752;k[ra+4>>2]=a;s=q+4|0;p=q+4+4|0;k[p>>2]=0;k[p+4>>2]=0;k[q>>2]=33619968;k[s>>2]=b;p=S1(ra,-1)|0;N=p&7;P=(p>>>3&511)+1|0;R1(K,ra,-1);switch(p|0){case 16:case 24:break;default:{k[T>>2]=0;b=T+4|0;k[b>>2]=0;g=ZT(56)|0;k[g>>2]=1;l=g+4|0;k[T>>2]=l;k[b>>2]=49;i[g+53>>0]=0;h=396098;m=l+49|0;do{i[l>>0]=i[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(m|0));Y8(-5,T,396148,394239,176);k[b>>2]=0;k[T>>2]=0;ua=k[g>>2]|0;k[g>>2]=ua+-1;if((ua|0)==1)ggb(k[g+-4>>2]|0);r=va;return}}k[ua>>2]=k[a>>2];n=ua+4|0;g=a+4|0;b=k[g>>2]|0;k[n>>2]=b;ra=ua+8|0;k[ra>>2]=k[a+8>>2];k[ua+12>>2]=k[a+12>>2];k[ua+16>>2]=k[a+16>>2];k[ua+20>>2]=k[a+20>>2];k[ua+24>>2]=k[a+24>>2];k[ua+28>>2]=k[a+28>>2];k[ua+32>>2]=k[a+32>>2];h=k[a+36>>2]|0;k[ua+36>>2]=h;j=ua+40|0;k[j>>2]=ra;ra=ua+48|0;m=ua+44|0;k[m>>2]=ra;k[ua+52>>2]=0;k[ra>>2]=0;if(h){b=h+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[g>>2]|0}if((b|0)>=3){k[n>>2]=0;x1(ua,b,0,0,0);if((k[n>>2]|0)>0){l=k[a+40>>2]|0;j=k[j>>2]|0;h=k[a+44>>2]|0;g=k[m>>2]|0;b=0;do{k[j+(b<<2)>>2]=k[l+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else{qa=k[a+44>>2]|0;ra=k[m>>2]|0;k[ra>>2]=k[qa>>2];k[ra+4>>2]=k[qa+4>>2]}k[t>>2]=k[K>>2];F=K+4|0;k[t+4>>2]=k[F>>2];x2(q,t,p,0);do if((k[q>>2]&2031616|0)==65536){j=k[s>>2]|0;k[ta>>2]=k[j>>2];n=ta+4|0;b=j+4|0;k[n>>2]=k[b>>2];ra=ta+8|0;k[ra>>2]=k[j+8>>2];k[ta+12>>2]=k[j+12>>2];k[ta+16>>2]=k[j+16>>2];k[ta+20>>2]=k[j+20>>2];k[ta+24>>2]=k[j+24>>2];k[ta+28>>2]=k[j+28>>2];k[ta+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[ta+36>>2]=g;h=ta+40|0;k[h>>2]=ra;ra=ta+48|0;a=ta+44|0;k[a>>2]=ra;k[ta+52>>2]=0;k[ra>>2]=0;if(g|0){ra=g+12|0;k[ra>>2]=(k[ra>>2]|0)+1}if((k[b>>2]|0)<3){qa=k[j+44>>2]|0;ra=k[a>>2]|0;k[ra>>2]=k[qa>>2];k[ra+4>>2]=k[qa+4>>2];break}k[n>>2]=0;x1(ta,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[a>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[m+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else Q1(ta,q,-1);while(0);k[sa>>2]=1124007936;qa=sa+4|0;b=sa+8|0;oa=sa+40|0;l=qa;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[oa>>2]=b;ra=sa+48|0;pa=sa+44|0;k[pa>>2]=ra;k[sa+52>>2]=0;k[ra>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;k[T>>2]=16842752;k[T+4>>2]=ua;g=y+4|0;b=g+4|0;k[b>>2]=0;k[b+4>>2]=0;k[y>>2]=33619968;k[g>>2]=sa;$aa(T,y,74,0);g=k[K>>2]|0;b=k[F>>2]|0;k[y>>2]=1124007936;la=y+4|0;q=y+8|0;ka=y+40|0;l=la;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[ka>>2]=q;na=y+48|0;ma=y+44|0;k[ma>>2]=na;k[y+52>>2]=0;k[na>>2]=0;k[T>>2]=b;D=T+4|0;k[D>>2]=g;G1(y,2,T,N);b=k[K>>2]|0;g=k[F>>2]|0;h=N|8;k[E>>2]=1124007936;ea=E+4|0;u=E+8|0;da=E+40|0;l=ea;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[da>>2]=u;ga=E+48|0;fa=E+44|0;k[fa>>2]=ga;k[E+52>>2]=0;k[ga>>2]=0;k[T>>2]=g;k[D>>2]=b;G1(E,2,T,h);k[x>>2]=k[y>>2];aa=x+4|0;b=k[la>>2]|0;k[aa>>2]=b;ca=x+8|0;k[ca>>2]=k[q>>2];a=y+12|0;k[x+12>>2]=k[a>>2];X=x+16|0;ia=y+16|0;k[X>>2]=k[ia>>2];m=y+20|0;k[x+20>>2]=k[m>>2];n=y+24|0;k[x+24>>2]=k[n>>2];p=y+28|0;k[x+28>>2]=k[p>>2];U=x+32|0;ha=y+32|0;k[U>>2]=k[ha>>2];Y=x+36|0;ja=y+36|0;g=k[ja>>2]|0;k[Y>>2]=g;Z=x+40|0;k[Z>>2]=ca;ca=x+48|0;ba=x+44|0;k[ba>>2]=ca;k[x+52>>2]=0;k[ca>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[la>>2]|0}if((b|0)>=3){k[aa>>2]=0;x1(x,b,0,0,0);if((k[aa>>2]|0)>0){g=k[ka>>2]|0;h=k[Z>>2]|0;j=k[ma>>2]|0;l=k[ba>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[g+(b<<2)>>2];k[l+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[aa>>2]|0))}}else{_=k[ma>>2]|0;$=k[ba>>2]|0;k[$>>2]=k[_>>2];k[$+4>>2]=k[_+4>>2]}h=x+56|0;k[h>>2]=k[E>>2];L=x+60|0;b=k[ea>>2]|0;k[L>>2]=b;O=x+64|0;k[O>>2]=k[u>>2];s=E+12|0;k[x+68>>2]=k[s>>2];H=x+72|0;_=E+16|0;k[H>>2]=k[_>>2];t=E+20|0;k[x+76>>2]=k[t>>2];v=E+24|0;k[x+80>>2]=k[v>>2];w=E+28|0;k[x+84>>2]=k[w>>2];G=x+88|0;V=E+32|0;k[G>>2]=k[V>>2];I=x+92|0;$=E+36|0;g=k[$>>2]|0;k[I>>2]=g;J=x+96|0;k[J>>2]=O;O=x+104|0;M=x+100|0;k[M>>2]=O;k[x+108>>2]=0;k[O>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[ea>>2]|0}if((b|0)>=3){k[L>>2]=0;x1(h,b,0,0,0);if((k[L>>2]|0)>0){g=k[da>>2]|0;h=k[J>>2]|0;j=k[fa>>2]|0;l=k[M>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[g+(b<<2)>>2];k[l+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[L>>2]|0))}}else{B=k[fa>>2]|0;C=k[M>>2]|0;k[C>>2]=k[B>>2];k[C+4>>2]=k[B+4>>2]};k[Q>>2]=k[37642];k[Q+4>>2]=k[37643];k[Q+8>>2]=k[37644];k[Q+12>>2]=k[37645];k[Q+16>>2]=k[37646];k[Q+20>>2]=k[37647];HV(sa,1,x,2,Q,3);k[R+8>>2]=0;k[R+12>>2]=0;k[R>>2]=16842752;k[R+4>>2]=y;g=W+4|0;C=g+4|0;k[C>>2]=0;k[C+4>>2]=0;k[W>>2]=33619968;k[g>>2]=y;k[T>>2]=0;g=T+4|0;k[g>>2]=0;k[T+8>>2]=0;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[T>>2]=b;C=b+4|0;k[T+8>>2]=C;o[b>>2]=c;k[g>>2]=C;y0a(R,W,T,e,f,4);ggb(b);k[R+8>>2]=0;k[R+12>>2]=0;k[R>>2]=16842752;k[R+4>>2]=E;g=W+4|0;C=g+4|0;k[C>>2]=0;k[C+4>>2]=0;k[W>>2]=33619968;k[g>>2]=E;k[T>>2]=0;g=T+4|0;k[g>>2]=0;k[T+8>>2]=0;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[T>>2]=b;C=b+4|0;k[T+8>>2]=C;o[b>>2]=d;k[g>>2]=C;y0a(R,W,T,e,f,4);ggb(b);k[R>>2]=k[y>>2];C=R+4|0;b=k[la>>2]|0;k[C>>2]=b;B=R+8|0;k[B>>2]=k[q>>2];k[R+12>>2]=k[a>>2];A=R+16|0;k[A>>2]=k[ia>>2];k[R+20>>2]=k[m>>2];k[R+24>>2]=k[n>>2];k[R+28>>2]=k[p>>2];y=R+32|0;k[y>>2]=k[ha>>2];e=R+36|0;g=k[ja>>2]|0;k[e>>2]=g;f=R+40|0;k[f>>2]=B;B=R+48|0;z=R+44|0;k[z>>2]=B;k[R+52>>2]=0;k[B>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[la>>2]|0}if((b|0)>=3){k[C>>2]=0;x1(R,b,0,0,0);if((k[C>>2]|0)>0){g=k[ka>>2]|0;h=k[f>>2]|0;j=k[ma>>2]|0;l=k[z>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[g+(b<<2)>>2];k[l+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[C>>2]|0))}}else{q=k[ma>>2]|0;x=k[z>>2]|0;k[x>>2]=k[q>>2];k[x+4>>2]=k[q+4>>2]}h=R+56|0;k[h>>2]=k[E>>2];x=R+60|0;b=k[ea>>2]|0;k[x>>2]=b;E=R+64|0;k[E>>2]=k[u>>2];k[R+68>>2]=k[s>>2];u=R+72|0;k[u>>2]=k[_>>2];k[R+76>>2]=k[t>>2];k[R+80>>2]=k[v>>2];k[R+84>>2]=k[w>>2];p=R+88|0;k[p>>2]=k[V>>2];q=R+92|0;g=k[$>>2]|0;k[q>>2]=g;s=R+96|0;k[s>>2]=E;v=R+104|0;t=R+100|0;k[t>>2]=v;k[R+108>>2]=0;k[v>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[ea>>2]|0}if((b|0)>=3){k[x>>2]=0;x1(h,b,0,0,0);if((k[x>>2]|0)>0){g=k[da>>2]|0;h=k[s>>2]|0;j=k[fa>>2]|0;l=k[t>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[g+(b<<2)>>2];k[l+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[x>>2]|0))}}else{w=k[fa>>2]|0;E=k[t>>2]|0;k[E>>2]=k[w>>2];k[E+4>>2]=k[w+4>>2]}j=k[K>>2]|0;h=k[F>>2]|0;g=N|16;k[W>>2]=1124007936;n=W+4|0;b=W+8|0;a=W+40|0;l=n;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[a>>2]=b;m=W+48|0;l=W+44|0;k[l>>2]=m;k[W+52>>2]=0;k[m>>2]=0;k[T>>2]=h;k[D>>2]=j;G1(W,2,T,g);HV(R,2,W,1,Q,3);k[T+8>>2]=0;k[T+12>>2]=0;k[T>>2]=16842752;k[T+4>>2]=W;h=S+4|0;b=h+4|0;k[b>>2]=0;k[b+4>>2]=0;k[S>>2]=33619968;k[h>>2]=ta;$aa(T,S,78,P);h=W+36|0;b=k[h>>2]|0;if(b|0?(S=b+12|0,T=k[S>>2]|0,k[S>>2]=T+-1,(T|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[W+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;W=W+16|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[n>>2]|0)>0){g=k[a>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[n>>2]|0))}b=k[l>>2]|0;if(!((b|0)==(m|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[q>>2]|0;if(b|0?(T=b+12|0,W=k[T>>2]|0,k[T>>2]=W+-1,(W|0)==1):0){g=k[q>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[p>>2]|0;if(b|0)break;b=B1()|0;g=k[q>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[q>>2]=0}k[q>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[x>>2]|0)>0){g=k[s>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[x>>2]|0))}b=k[t>>2]|0;if(!((b|0)==(v|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[e>>2]|0;if(b|0?(T=b+12|0,W=k[T>>2]|0,k[T>>2]=W+-1,(W|0)==1):0){g=k[e>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[y>>2]|0;if(b|0)break;b=B1()|0;g=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[e>>2]=0}k[e>>2]=0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[C>>2]|0)>0){g=k[f>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[C>>2]|0))}b=k[z>>2]|0;if(!((b|0)==(B|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[I>>2]|0;do if(b|0){T=b+12|0;W=k[T>>2]|0;k[T>>2]=W+-1;if((W|0)!=1)break;g=k[I>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[G>>2]|0;if(b|0)break;b=B1()|0;g=k[I>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[I>>2]=0}while(0);k[I>>2]=0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[L>>2]|0)>0){g=k[J>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[L>>2]|0))}b=k[M>>2]|0;if(!((b|0)==(O|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Y>>2]|0;do if(b|0){T=b+12|0;W=k[T>>2]|0;k[T>>2]=W+-1;if((W|0)!=1)break;g=k[Y>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[U>>2]|0;if(b|0)break;b=B1()|0;g=k[Y>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[Y>>2]=0}while(0);k[Y>>2]=0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[aa>>2]|0)>0){g=k[Z>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[aa>>2]|0))}b=k[ba>>2]|0;if(!((b|0)==(ca|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[$>>2]|0;do if(b|0){ba=b+12|0;ca=k[ba>>2]|0;k[ba>>2]=ca+-1;if((ca|0)!=1)break;g=k[$>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[V>>2]|0;if(b|0)break;b=B1()|0;g=k[$>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[$>>2]=0}while(0);k[$>>2]=0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[ea>>2]|0)>0){g=k[da>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ea>>2]|0))}b=k[fa>>2]|0;if(!((b|0)==(ga|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[ja>>2]|0;do if(b|0){fa=b+12|0;ga=k[fa>>2]|0;k[fa>>2]=ga+-1;if((ga|0)!=1)break;g=k[ja>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[ha>>2]|0;if(b|0)break;b=B1()|0;g=k[ja>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[ja>>2]=0}while(0);k[ja>>2]=0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[la>>2]|0)>0){g=k[ka>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[la>>2]|0))}b=k[ma>>2]|0;if(!((b|0)==(na|0)|(b|0)==0))ggb(k[b+-4>>2]|0);h=sa+36|0;b=k[h>>2]|0;do if(b|0){ma=b+12|0;na=k[ma>>2]|0;k[ma>>2]=na+-1;if((na|0)!=1)break;g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[sa+32>>2]|0;if(b|0)break;b=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}while(0);k[h>>2]=0;sa=sa+16|0;k[sa>>2]=0;k[sa+4>>2]=0;k[sa+8>>2]=0;k[sa+12>>2]=0;if((k[qa>>2]|0)>0){g=k[oa>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[qa>>2]|0))}b=k[pa>>2]|0;if(!((b|0)==(ra|0)|(b|0)==0))ggb(k[b+-4>>2]|0);h=ta+36|0;b=k[h>>2]|0;do if(b|0){ra=b+12|0;sa=k[ra>>2]|0;k[ra>>2]=sa+-1;if((sa|0)!=1)break;g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[ta+32>>2]|0;if(b|0)break;b=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}while(0);k[h>>2]=0;sa=ta+16|0;g=ta+4|0;k[sa>>2]=0;k[sa+4>>2]=0;k[sa+8>>2]=0;k[sa+12>>2]=0;if((k[g>>2]|0)>0){h=k[ta+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[ta+44>>2]|0;if(!((b|0)==(ta+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);h=ua+36|0;b=k[h>>2]|0;do if(b|0){sa=b+12|0;ta=k[sa>>2]|0;k[sa>>2]=ta+-1;if((ta|0)!=1)break;g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[ua+32>>2]|0;if(b|0)break;b=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}while(0);k[h>>2]=0;ta=ua+16|0;g=ua+4|0;k[ta>>2]=0;k[ta+4>>2]=0;k[ta+8>>2]=0;k[ta+12>>2]=0;if((k[g>>2]|0)>0){h=k[ua+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[ua+44>>2]|0;if(!((b|0)==(ua+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);r=va;return}function Gk(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;yb=r;r=r+752|0;rb=yb+640|0;xb=yb+624|0;kb=yb+616|0;wb=yb+560|0;ob=yb+536|0;tb=yb+524|0;ub=yb+512|0;vb=yb+480|0;mb=yb;nb=yb+408|0;pb=yb+296|0;sb=yb+240|0;qb=yb+224|0;lb=yb+496|0;j=yb+464|0;k[lb+8>>2]=0;k[lb+12>>2]=0;k[lb>>2]=17104896;k[lb+4>>2]=a;a=j+4|0;s=j+4+4|0;k[s>>2]=0;k[s+4>>2]=0;k[j>>2]=33619968;k[a>>2]=b;k[xb>>2]=0;s=xb+4|0;k[s>>2]=0;k[xb+8>>2]=0;B2(lb,xb);M1a(xb,c,d,g,h);lb=k[xb>>2]|0;ib=k[lb+40>>2]|0;jb=k[ib>>2]|0;k[kb>>2]=k[ib+4>>2];k[kb+4>>2]=jb;x2(j,kb,k[lb>>2]&4095,0);do if((k[j>>2]&2031616|0)==65536){l=k[a>>2]|0;k[wb>>2]=k[l>>2];q=wb+4|0;a=l+4|0;k[q>>2]=k[a>>2];lb=wb+8|0;k[lb>>2]=k[l+8>>2];k[wb+12>>2]=k[l+12>>2];k[wb+16>>2]=k[l+16>>2];k[wb+20>>2]=k[l+20>>2];k[wb+24>>2]=k[l+24>>2];k[wb+28>>2]=k[l+28>>2];k[wb+32>>2]=k[l+32>>2];b=k[l+36>>2]|0;k[wb+36>>2]=b;j=wb+40|0;k[j>>2]=lb;lb=wb+48|0;n=wb+44|0;k[n>>2]=lb;k[wb+52>>2]=0;k[lb>>2]=0;if(b|0){lb=b+12|0;k[lb>>2]=(k[lb>>2]|0)+1}if((k[a>>2]|0)<3){kb=k[l+44>>2]|0;lb=k[n>>2]|0;k[lb>>2]=k[kb>>2];k[lb+4>>2]=k[kb+4>>2];break}k[q>>2]=0;x1(wb,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;b=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[p+(a<<2)>>2];k[b+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(wb,j,-1);while(0);kb=k[xb>>2]|0;jb=k[kb>>2]|0;lb=jb&7;s=(k[s>>2]|0)-kb|0;kb=(s|0)/56|0;if((jb&4095|0)!=16){k[rb>>2]=0;a=rb+4|0;k[a>>2]=0;b=ZT(44)|0;k[b>>2]=1;ib=b+4|0;k[rb>>2]=ib;k[a>>2]=39;i[b+43>>0]=0;j=398192;jb=ib+39|0;do{i[ib>>0]=i[j>>0]|0;ib=ib+1|0;j=j+1|0}while((ib|0)<(jb|0));Y8(-5,rb,398232,394239,396);k[a>>2]=0;k[rb>>2]=0;vb=k[b>>2]|0;k[b>>2]=vb+-1;if((vb|0)==1)ggb(k[b+-4>>2]|0)}else{k[ob>>2]=k[37642];k[ob+4>>2]=k[37643];k[ob+8>>2]=k[37644];k[ob+12>>2]=k[37645];k[ob+16>>2]=k[37646];k[ob+20>>2]=k[37647];k[tb>>2]=0;p=tb+4|0;k[p>>2]=0;k[tb+8>>2]=0;q=(s|0)==0;if(!q){if(kb>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(s)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[p>>2]=a;k[tb>>2]=a;k[tb+8>>2]=a+(kb*56|0);b=kb;n=a;m=a;while(1){k[n>>2]=1124007936;j=n+8|0;l=n+40|0;ib=n+4|0;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[l>>2]=j;j=n+48|0;k[n+44>>2]=j;k[n+52>>2]=0;k[j>>2]=0;j=m+56|0;b=b+-1|0;if(!b)break;else{n=j;m=j}}k[p>>2]=a+(kb*56|0)}k[ub>>2]=0;p=ub+4|0;k[p>>2]=0;k[ub+8>>2]=0;if(!q){if(kb>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(s)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[p>>2]=a;k[ub>>2]=a;k[ub+8>>2]=a+(kb*56|0);b=kb;n=a;m=a;while(1){k[n>>2]=1124007936;j=n+8|0;l=n+40|0;ib=n+4|0;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[l>>2]=j;j=n+48|0;k[n+44>>2]=j;k[n+52>>2]=0;k[j>>2]=0;j=m+56|0;b=b+-1|0;if(!b)break;else{n=j;m=j}}k[p>>2]=a+(kb*56|0)}k[vb>>2]=0;p=vb+4|0;k[p>>2]=0;k[vb+8>>2]=0;if(!q){if(kb>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(s)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[p>>2]=a;k[vb>>2]=a;k[vb+8>>2]=a+(kb*56|0);b=kb;n=a;m=a;while(1){k[n>>2]=1124007936;j=n+8|0;l=n+40|0;ib=n+4|0;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[l>>2]=j;j=n+48|0;k[n+44>>2]=j;k[n+52>>2]=0;k[j>>2]=0;j=m+56|0;b=b+-1|0;if(!b)break;else{n=j;m=j}}k[p>>2]=a+(kb*56|0);if((s|0)>0){s=lb|8;t=rb+8|0;u=rb+12|0;v=rb+4|0;w=mb+4|0;x=w+4|0;y=rb+4|0;z=rb+8|0;A=rb+12|0;B=rb+16|0;C=rb+20|0;D=rb+24|0;E=rb+28|0;F=rb+32|0;G=rb+36|0;H=rb+40|0;I=rb+48|0;J=rb+44|0;K=rb+52|0;q=rb+56|0;L=rb+60|0;M=rb+64|0;N=rb+68|0;O=rb+72|0;P=rb+76|0;Q=rb+80|0;R=rb+84|0;S=rb+88|0;T=rb+92|0;U=rb+96|0;V=rb+104|0;W=rb+100|0;X=rb+108|0;Y=mb+4|0;Z=mb+8|0;_=mb+12|0;$=mb+16|0;aa=mb+48|0;ba=mb+56|0;ca=mb+52|0;da=mb+60|0;ea=mb+64|0;fa=mb+68|0;ga=mb+72|0;ha=mb+104|0;ia=mb+112|0;ja=mb+108|0;ka=mb+116|0;la=mb+120|0;ma=mb+124|0;na=mb+128|0;oa=mb+160|0;pa=mb+168|0;qa=mb+164|0;ra=rb+4|0;sa=mb+4|0;ta=mb+8|0;ua=mb+12|0;va=mb+16|0;wa=mb+48|0;xa=mb+56|0;ya=mb+52|0;za=mb+60|0;Aa=mb+64|0;Ba=mb+68|0;Ca=mb+72|0;Da=mb+104|0;Ea=mb+112|0;Fa=mb+108|0;Ga=mb+116|0;Ha=mb+120|0;Ia=mb+124|0;Ja=mb+128|0;Ka=mb+160|0;La=mb+168|0;Ma=mb+164|0;Na=rb+4|0;Oa=mb+4|0;Pa=mb+8|0;Qa=mb+12|0;Ra=mb+16|0;Sa=mb+48|0;Ta=mb+56|0;Ua=mb+52|0;Va=mb+60|0;Wa=mb+64|0;Xa=mb+68|0;Ya=mb+72|0;Za=mb+104|0;_a=mb+112|0;$a=mb+108|0;ab=mb+116|0;bb=mb+120|0;cb=mb+124|0;db=mb+128|0;eb=mb+160|0;fb=mb+168|0;gb=mb+164|0;hb=rb+4|0;p=0;do{a=k[tb>>2]|0;n=k[xb>>2]|0;m=n+40|0;j=k[m>>2]|0;b=k[j+4>>2]|0;j=k[j>>2]|0;k[mb>>2]=0;k[Y>>2]=0;k[Z>>2]=1124007936;ib=_;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[aa>>2]=$;k[ca>>2]=ba;k[da>>2]=0;k[ba>>2]=0;k[ea>>2]=1124007936;ib=fa;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[ha>>2]=ga;k[ja>>2]=ia;k[ka>>2]=0;k[ia>>2]=0;k[la>>2]=1124007936;ib=ma;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[oa>>2]=na;k[qa>>2]=pa;ib=pa;jb=ib+56|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[rb>>2]=b;k[ra>>2]=j;j1(mb,48,rb,16);l=a+(p*56|0)|0;a=k[mb>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,mb,l,-1);XN(mb);a=k[ub>>2]|0;j=k[m>>2]|0;b=k[j+4>>2]|0;j=k[j>>2]|0;k[mb>>2]=0;k[sa>>2]=0;k[ta>>2]=1124007936;ib=ua;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[wa>>2]=va;k[ya>>2]=xa;k[za>>2]=0;k[xa>>2]=0;k[Aa>>2]=1124007936;ib=Ba;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[Da>>2]=Ca;k[Fa>>2]=Ea;k[Ga>>2]=0;k[Ea>>2]=0;k[Ha>>2]=1124007936;ib=Ia;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[Ka>>2]=Ja;k[Ma>>2]=La;ib=La;jb=ib+56|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[rb>>2]=b;k[Na>>2]=j;j1(mb,48,rb,lb);j=k[mb>>2]|0;dh[k[(k[j>>2]|0)+12>>2]&255](j,mb,a+(p*56|0)|0,-1);XN(mb);j=k[vb>>2]|0;b=k[m>>2]|0;a=k[b+4>>2]|0;b=k[b>>2]|0;k[mb>>2]=0;k[Oa>>2]=0;k[Pa>>2]=1124007936;ib=Qa;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[Sa>>2]=Ra;k[Ua>>2]=Ta;k[Va>>2]=0;k[Ta>>2]=0;k[Wa>>2]=1124007936;ib=Xa;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[Za>>2]=Ya;k[$a>>2]=_a;k[ab>>2]=0;k[_a>>2]=0;k[bb>>2]=1124007936;ib=cb;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[eb>>2]=db;k[gb>>2]=fb;ib=fb;jb=ib+56|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[rb>>2]=a;k[hb>>2]=b;j1(mb,48,rb,s);a=k[mb>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,mb,j+(p*56|0)|0,-1);XN(mb);k[t>>2]=0;k[u>>2]=0;k[rb>>2]=16842752;k[v>>2]=n+(p*56|0);j=x;k[j>>2]=0;k[j+4>>2]=0;k[mb>>2]=33619968;k[w>>2]=l;$aa(rb,mb,74,0);j=k[ub>>2]|0;k[rb>>2]=k[j+(p*56|0)>>2];a=j+(p*56|0)+4|0;k[y>>2]=k[a>>2];k[z>>2]=k[j+(p*56|0)+8>>2];k[A>>2]=k[j+(p*56|0)+12>>2];k[B>>2]=k[j+(p*56|0)+16>>2];k[C>>2]=k[j+(p*56|0)+20>>2];k[D>>2]=k[j+(p*56|0)+24>>2];k[E>>2]=k[j+(p*56|0)+28>>2];k[F>>2]=k[j+(p*56|0)+32>>2];b=k[j+(p*56|0)+36>>2]|0;k[G>>2]=b;k[H>>2]=z;k[J>>2]=I;k[K>>2]=0;k[I>>2]=0;if(b|0){jb=b+12|0;k[jb>>2]=(k[jb>>2]|0)+1}if((k[a>>2]|0)>=3){k[y>>2]=0;x1(rb,k[a>>2]|0,0,0,0);if((k[y>>2]|0)>0){l=k[j+(p*56|0)+40>>2]|0;m=k[H>>2]|0;b=k[j+(p*56|0)+44>>2]|0;j=k[J>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[l+(a<<2)>>2];k[j+(a<<2)>>2]=k[b+(a<<2)>>2];a=a+1|0}while((a|0)<(k[y>>2]|0))}}else{ib=k[j+(p*56|0)+44>>2]|0;jb=k[J>>2]|0;k[jb>>2]=k[ib>>2];k[jb+4>>2]=k[ib+4>>2]}j=k[vb>>2]|0;k[q>>2]=k[j+(p*56|0)>>2];a=j+(p*56|0)+4|0;k[L>>2]=k[a>>2];k[M>>2]=k[j+(p*56|0)+8>>2];k[N>>2]=k[j+(p*56|0)+12>>2];k[O>>2]=k[j+(p*56|0)+16>>2];k[P>>2]=k[j+(p*56|0)+20>>2];k[Q>>2]=k[j+(p*56|0)+24>>2];k[R>>2]=k[j+(p*56|0)+28>>2];k[S>>2]=k[j+(p*56|0)+32>>2];b=k[j+(p*56|0)+36>>2]|0;k[T>>2]=b;k[U>>2]=M;k[W>>2]=V;k[X>>2]=0;k[V>>2]=0;if(b|0){jb=b+12|0;k[jb>>2]=(k[jb>>2]|0)+1}if((k[a>>2]|0)>=3){k[L>>2]=0;x1(q,k[a>>2]|0,0,0,0);if((k[L>>2]|0)>0){l=k[j+(p*56|0)+40>>2]|0;m=k[U>>2]|0;b=k[j+(p*56|0)+44>>2]|0;j=k[W>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[l+(a<<2)>>2];k[j+(a<<2)>>2]=k[b+(a<<2)>>2];a=a+1|0}while((a|0)<(k[L>>2]|0))}}else{ib=k[j+(p*56|0)+44>>2]|0;jb=k[W>>2]|0;k[jb>>2]=k[ib>>2];k[jb+4>>2]=k[ib+4>>2]}HV((k[tb>>2]|0)+(p*56|0)|0,1,rb,2,ob,3);a=k[T>>2]|0;if(a|0?(ib=a+12|0,jb=k[ib>>2]|0,k[ib>>2]=jb+-1,(jb|0)==1):0){b=k[T>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[S>>2]|0;if(a|0)break;a=B1()|0;b=k[T>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[T>>2]=0}k[T>>2]=0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[L>>2]|0)>0){b=k[U>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[L>>2]|0))}a=k[W>>2]|0;if(!((a|0)==(V|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[G>>2]|0;if(a|0?(ib=a+12|0,jb=k[ib>>2]|0,k[ib>>2]=jb+-1,(jb|0)==1):0){b=k[G>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[F>>2]|0;if(a|0)break;a=B1()|0;b=k[G>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[G>>2]=0}k[G>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[y>>2]|0)>0){b=k[H>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[y>>2]|0))}a=k[J>>2]|0;if(!((a|0)==(I|0)|(a|0)==0))ggb(k[a+-4>>2]|0);p=p+1|0}while((p|0)<(kb|0))}}k[mb>>2]=1124007936;R=mb+4|0;j=mb+8|0;Q=mb+40|0;ib=R;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[Q>>2]=j;T=mb+48|0;S=mb+44|0;k[S>>2]=T;k[mb+52>>2]=0;k[T>>2]=0;k[nb>>2]=1124007936;N=nb+4|0;n=nb+8|0;M=nb+40|0;ib=N;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[M>>2]=n;P=nb+48|0;O=nb+44|0;k[O>>2]=P;k[nb+52>>2]=0;k[P>>2]=0;k[pb+8>>2]=0;k[pb+12>>2]=0;k[pb>>2]=17104896;k[pb+4>>2]=ub;b=sb+4|0;lb=b+4|0;k[lb>>2]=0;k[lb+4>>2]=0;k[sb>>2]=33619968;k[b>>2]=mb;k[rb>>2]=0;b=rb+4|0;k[b>>2]=0;k[rb+8>>2]=0;while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[rb>>2]=a;lb=a+4|0;k[rb+8>>2]=lb;o[a>>2]=e;k[b>>2]=lb;L1a(pb,sb,c,d,rb,g,h,4);ggb(a);k[pb+8>>2]=0;k[pb+12>>2]=0;k[pb>>2]=17104896;k[pb+4>>2]=vb;b=sb+4|0;lb=b+4|0;k[lb>>2]=0;k[lb+4>>2]=0;k[sb>>2]=33619968;k[b>>2]=nb;k[rb>>2]=0;b=rb+4|0;k[b>>2]=0;k[rb+8>>2]=0;while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[rb>>2]=a;I=a+4|0;k[rb+8>>2]=I;o[a>>2]=f;k[b>>2]=I;L1a(pb,sb,c,d,rb,g,h,4);ggb(a);k[pb>>2]=k[mb>>2];I=pb+4|0;a=k[R>>2]|0;k[I>>2]=a;H=pb+8|0;k[H>>2]=k[j>>2];k[pb+12>>2]=k[mb+12>>2];E=pb+16|0;L=mb+16|0;k[E>>2]=k[L>>2];k[pb+20>>2]=k[mb+20>>2];k[pb+24>>2]=k[mb+24>>2];k[pb+28>>2]=k[mb+28>>2];A=pb+32|0;J=mb+32|0;k[A>>2]=k[J>>2];F=pb+36|0;K=mb+36|0;b=k[K>>2]|0;k[F>>2]=b;C=pb+40|0;k[C>>2]=H;H=pb+48|0;G=pb+44|0;k[G>>2]=H;k[pb+52>>2]=0;k[H>>2]=0;if(b){a=b+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[R>>2]|0}if((a|0)>=3){k[I>>2]=0;x1(pb,a,0,0,0);if((k[I>>2]|0)>0){b=k[Q>>2]|0;j=k[C>>2]|0;l=k[S>>2]|0;m=k[G>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[b+(a<<2)>>2];k[m+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[I>>2]|0))}}else{h=k[S>>2]|0;mb=k[G>>2]|0;k[mb>>2]=k[h>>2];k[mb+4>>2]=k[h+4>>2]}j=pb+56|0;k[j>>2]=k[nb>>2];y=pb+60|0;a=k[N>>2]|0;k[y>>2]=a;x=pb+64|0;k[x>>2]=k[n>>2];k[pb+68>>2]=k[nb+12>>2];u=pb+72|0;D=nb+16|0;k[u>>2]=k[D>>2];k[pb+76>>2]=k[nb+20>>2];k[pb+80>>2]=k[nb+24>>2];k[pb+84>>2]=k[nb+28>>2];s=pb+88|0;z=nb+32|0;k[s>>2]=k[z>>2];v=pb+92|0;B=nb+36|0;b=k[B>>2]|0;k[v>>2]=b;t=pb+96|0;k[t>>2]=x;x=pb+104|0;w=pb+100|0;k[w>>2]=x;k[pb+108>>2]=0;k[x>>2]=0;if(b){a=b+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[N>>2]|0}if((a|0)>=3){k[y>>2]=0;x1(j,a,0,0,0);if((k[y>>2]|0)>0){b=k[M>>2]|0;j=k[t>>2]|0;l=k[O>>2]|0;m=k[w>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[b+(a<<2)>>2];k[m+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[y>>2]|0))}}else{mb=k[O>>2]|0;nb=k[w>>2]|0;k[nb>>2]=k[mb>>2];k[nb+4>>2]=k[mb+4>>2]}l=k[xb>>2]|0;j=k[l+40>>2]|0;b=k[j+4>>2]|0;j=k[j>>2]|0;l=k[l>>2]&4095;k[sb>>2]=1124007936;q=sb+4|0;a=sb+8|0;n=sb+40|0;ib=q;jb=ib+36|0;do{k[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));k[n>>2]=a;p=sb+48|0;m=sb+44|0;k[m>>2]=p;k[sb+52>>2]=0;k[p>>2]=0;k[rb>>2]=j;k[rb+4>>2]=b;G1(sb,2,rb,l);HV(pb,2,sb,1,ob,3);k[rb+8>>2]=0;k[rb+12>>2]=0;k[rb>>2]=16842752;k[rb+4>>2]=sb;j=qb+4|0;a=j+4|0;k[a>>2]=0;k[a+4>>2]=0;k[qb>>2]=33619968;k[j>>2]=wb;$aa(rb,qb,78,0);j=sb+36|0;a=k[j>>2]|0;if(a|0?(qb=a+12|0,rb=k[qb>>2]|0,k[qb>>2]=rb+-1,(rb|0)==1):0){b=k[j>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[sb+32>>2]|0;if(!a){a=B1()|0;b=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[j>>2]=0}k[j>>2]=0;sb=sb+16|0;k[sb>>2]=0;k[sb+4>>2]=0;k[sb+8>>2]=0;k[sb+12>>2]=0;if((k[q>>2]|0)>0){b=k[n>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[q>>2]|0))}a=k[m>>2]|0;if(!((a|0)==(p|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[v>>2]|0;if(a|0?(rb=a+12|0,sb=k[rb>>2]|0,k[rb>>2]=sb+-1,(sb|0)==1):0){b=k[v>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[s>>2]|0;if(a|0)break;a=B1()|0;b=k[v>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[v>>2]=0}k[v>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[y>>2]|0)>0){b=k[t>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[y>>2]|0))}a=k[w>>2]|0;if(!((a|0)==(x|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[F>>2]|0;if(a|0?(rb=a+12|0,sb=k[rb>>2]|0,k[rb>>2]=sb+-1,(sb|0)==1):0){b=k[F>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[A>>2]|0;if(a|0)break;a=B1()|0;b=k[F>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[F>>2]=0}k[F>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[I>>2]|0)>0){b=k[C>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[I>>2]|0))}a=k[G>>2]|0;if(!((a|0)==(H|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[B>>2]|0;do if(a|0){rb=a+12|0;sb=k[rb>>2]|0;k[rb>>2]=sb+-1;if((sb|0)!=1)break;b=k[B>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[z>>2]|0;if(a|0)break;a=B1()|0;b=k[B>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[B>>2]=0}while(0);k[B>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[N>>2]|0)>0){b=k[M>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[N>>2]|0))}a=k[O>>2]|0;if(!((a|0)==(P|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[K>>2]|0;do if(a|0){rb=a+12|0;sb=k[rb>>2]|0;k[rb>>2]=sb+-1;if((sb|0)!=1)break;b=k[K>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[J>>2]|0;if(a|0)break;a=B1()|0;b=k[K>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[K>>2]=0}while(0);k[K>>2]=0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[R>>2]|0)>0){b=k[Q>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[R>>2]|0))}a=k[S>>2]|0;if(!((a|0)==(T|0)|(a|0)==0))ggb(k[a+-4>>2]|0);zF(vb);zF(ub);zF(tb)}j=wb+36|0;a=k[j>>2]|0;if(a|0?(ub=a+12|0,vb=k[ub>>2]|0,k[ub>>2]=vb+-1,(vb|0)==1):0){b=k[j>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[wb+32>>2]|0;if(!a){a=B1()|0;b=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[j>>2]=0}k[j>>2]=0;vb=wb+16|0;b=wb+4|0;k[vb>>2]=0;k[vb+4>>2]=0;k[vb+8>>2]=0;k[vb+12>>2]=0;if((k[b>>2]|0)>0){j=k[wb+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[wb+44>>2]|0;if((a|0)==(wb+48|0)|(a|0)==0){zF(xb);r=yb;return}ggb(k[a+-4>>2]|0);zF(xb);r=yb;return}function Hk(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;l=r;r=r+48|0;h=l+32|0;i=l+16|0;j=l;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=17104896;k[i+4>>2]=a;a=j+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=b;k[h>>2]=0;b=h+4|0;k[b>>2]=0;k[h+8>>2]=0;while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[h>>2]=a;m=a+4|0;k[h+8>>2]=m;o[a>>2]=e;k[b>>2]=m;L1a(i,j,c,d,h,f,g,4);ggb(a);r=l;return}function Ik(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0;i=r;r=r+32|0;l=i+16|0;j=i;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=17104896;k[l+4>>2]=a;a=j+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=b;L1a(l,j,c,d,e,f,g,h);r=i;return}function Jk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+176|0;p=u;q=u+160|0;t=u+104|0;s=u+48|0;o=u+32|0;k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;n=o+4|0;k[n>>2]=b;k[t>>2]=k[a>>2];m=t+4|0;f=a+4|0;b=k[f>>2]|0;k[m>>2]=b;j=t+8|0;k[j>>2]=k[a+8>>2];k[t+12>>2]=k[a+12>>2];k[t+16>>2]=k[a+16>>2];k[t+20>>2]=k[a+20>>2];k[t+24>>2]=k[a+24>>2];k[t+28>>2]=k[a+28>>2];k[t+32>>2]=k[a+32>>2];g=k[a+36>>2]|0;k[t+36>>2]=g;h=t+40|0;k[h>>2]=j;j=t+48|0;l=t+44|0;k[l>>2]=j;k[t+52>>2]=0;k[j>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[f>>2]|0}if((b|0)>=3){k[m>>2]=0;x1(t,b,0,0,0);if((k[m>>2]|0)>0){j=k[a+40>>2]|0;h=k[h>>2]|0;g=k[a+44>>2]|0;f=k[l>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else{a=k[a+44>>2]|0;m=k[l>>2]|0;k[m>>2]=k[a>>2];k[m+4>>2]=k[a+4>>2]}do if((k[o>>2]&2031616|0)==65536){j=k[n>>2]|0;k[s>>2]=k[j>>2];m=s+4|0;f=j+4|0;k[m>>2]=k[f>>2];o=s+8|0;k[o>>2]=k[j+8>>2];k[s+12>>2]=k[j+12>>2];k[s+16>>2]=k[j+16>>2];k[s+20>>2]=k[j+20>>2];k[s+24>>2]=k[j+24>>2];k[s+28>>2]=k[j+28>>2];k[s+32>>2]=k[j+32>>2];b=k[j+36>>2]|0;k[s+36>>2]=b;g=s+40|0;k[g>>2]=o;o=s+48|0;a=s+44|0;k[a>>2]=o;k[s+52>>2]=0;k[o>>2]=0;if(b|0){o=b+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[f>>2]|0)<3){n=k[j+44>>2]|0;o=k[a>>2]|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];break}k[m>>2]=0;x1(s,k[f>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[j+40>>2]|0;h=k[g>>2]|0;g=k[j+44>>2]|0;f=k[a>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(s,o,-1);while(0);if((y2(s,2,4,1)|0)<=-1){k[p>>2]=0;b=p+4|0;k[b>>2]=0;f=ZT(40)|0;k[f>>2]=1;a=f+4|0;k[p>>2]=a;k[b>>2]=34;i[f+38>>0]=0;l=246842;m=a+34|0;do{i[a>>0]=i[l>>0]|0;a=a+1|0;l=l+1|0}while((a|0)<(m|0));Y8(-215,p,246600,246054,2256);k[b>>2]=0;k[p>>2]=0;o=k[f>>2]|0;k[f>>2]=o+-1;if((o|0)==1)ggb(k[f+-4>>2]|0)}n=s+16|0;h=k[n>>2]|0;o=s+44|0;m=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;m=aa(m,((k[s>>2]|0)>>>3&511)+1|0)|0;j=(m|0)/2|0;if(!((h|0)==0|(m|0)<2)){if((d|0)==16)b=(k[t>>2]&7|0)==0?16:8;else b=d;if(e>>>0>=17){k[q>>2]=0;f=q+4|0;k[f>>2]=0;g=ZT(36)|0;k[g>>2]=1;a=g+4|0;k[q>>2]=a;k[f>>2]=31;i[g+35>>0]=0;l=246173;m=a+31|0;do{i[a>>0]=i[l>>0]|0;a=a+1|0;l=l+1|0}while((a|0)<(m|0));Y8(-215,q,246600,246054,1888);k[f>>2]=0;k[q>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0)}z2(c,p,k[t>>2]&4095,0);Lfa(t,h,j,p,b,e)}g=s+36|0;b=k[g>>2]|0;if(b|0?(p=b+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[s+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;g=s+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[g>>2]|0)>0){f=k[s+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[o>>2]|0;if(!((b|0)==(s+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=t+36|0;b=k[g>>2]|0;if(b|0?(q=b+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[t+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;s=t+16|0;f=t+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[f>>2]|0)>0){g=k[t+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[t+44>>2]|0;if((b|0)==(t+48|0)|(b|0)==0){r=u;return}ggb(k[b+-4>>2]|0);r=u;return}function Kk(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;L=r;r=r+2288|0;F=L;G=L+2264|0;H=L+2256|0;K=L+2200|0;J=L+1136|0;I=L+56|0;A=L+1120|0;k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=17104896;k[A+4>>2]=b;E=k[f>>2]|0;D=k[f+4>>2]|0;k[K>>2]=k[a>>2];m=K+4|0;f=a+4|0;b=k[f>>2]|0;k[m>>2]=b;C=K+8|0;k[C>>2]=k[a+8>>2];k[K+12>>2]=k[a+12>>2];k[K+16>>2]=k[a+16>>2];k[K+20>>2]=k[a+20>>2];k[K+24>>2]=k[a+24>>2];k[K+28>>2]=k[a+28>>2];k[K+32>>2]=k[a+32>>2];g=k[a+36>>2]|0;k[K+36>>2]=g;h=K+40|0;k[h>>2]=C;C=K+48|0;l=K+44|0;k[l>>2]=C;k[K+52>>2]=0;k[C>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[f>>2]|0}if((b|0)>=3){k[m>>2]=0;x1(K,b,0,0,0);if((k[m>>2]|0)>0){j=k[a+40>>2]|0;h=k[h>>2]|0;g=k[a+44>>2]|0;f=k[l>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else{B=k[a+44>>2]|0;C=k[l>>2]|0;k[C>>2]=k[B>>2];k[C+4>>2]=k[B+4>>2]}x=F2(A)|0;if(x|0){B=J+8|0;k[J>>2]=B;C=J+4|0;k[C>>2]=264;g=x>>>0>264;if(g){f=x>>>0>1073741823?-1:x<<2;f=(f|0)==0?1:f;while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[J>>2]=b}else b=B;k[C>>2]=x;y=I+8|0;k[I>>2]=y;z=I+4|0;k[z>>2]=264;if(g){g=x>>>0>1073741823?-1:x<<2;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[I>>2]=f;k[z>>2]=x;if((x|0)>0)n=22;else a=f}else{k[z>>2]=x;f=y;n=22}if((n|0)==22){a=F+4|0;n=F+8|0;o=F+12|0;p=F+16|0;q=F+36|0;s=F+40|0;t=F+48|0;u=F+44|0;v=G+4|0;w=F+32|0;l=0;do{Q1(F,A,l);if((y2(F,2,4,1)|0)<=-1){k[G>>2]=0;k[v>>2]=0;g=ZT(36)|0;k[g>>2]=1;h=g+4|0;k[G>>2]=h;k[v>>2]=29;i[g+33>>0]=0;j=246877;m=h+29|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));Y8(-215,G,246680,246054,2276);k[v>>2]=0;k[G>>2]=0;m=k[g>>2]|0;k[g>>2]=m+-1;if((m|0)==1)ggb(k[g+-4>>2]|0)}k[b+(l<<2)>>2]=k[p>>2];g=aa(k[o>>2]|0,k[n>>2]|0)|0;g=(aa(g,((k[F>>2]|0)>>>3&511)+1|0)|0)/2|0;k[f+(l<<2)>>2]=g;g=k[q>>2]|0;if(g|0?(j=g+12|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0){h=k[q>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[w>>2]|0;if(!g){g=B1()|0;h=k[q>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[q>>2]=0}k[q>>2]=0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[a>>2]|0)>0){h=k[s>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[a>>2]|0))}g=k[u>>2]|0;if(!((g|0)==(t|0)|(g|0)==0))ggb(k[g+-4>>2]|0);l=l+1|0}while((l|0)<(x|0));a=f}if((d|0)==16)l=(k[K>>2]&7|0)==0?16:8;else l=d;if(!((e|0)<17&((b|0)!=0&(a|0)!=0&(x|e|0)>-1))){k[F>>2]=0;f=F+4|0;k[f>>2]=0;g=ZT(72)|0;k[g>>2]=1;h=g+4|0;k[F>>2]=h;k[f>>2]=64;i[g+68>>0]=0;j=246615;m=h+64|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));Y8(-215,F,246680,246054,1901);k[f>>2]=0;k[F>>2]=0;d=k[g>>2]|0;k[g>>2]=d+-1;if((d|0)==1)ggb(k[g+-4>>2]|0)}z2(c,F,k[K>>2]&4095,0);k[G>>2]=0;j=G+4|0;k[j>>2]=0;k[G+8>>2]=0;h=(x|0)>0;if(h){f=0;g=0;do{g=(k[a+(f<<2)>>2]|0)+g|0;f=f+1|0}while((f|0)!=(x|0));Xfa(G,g+1|0);if(h){g=H+4|0;f=0;do{d=k[b+(f<<2)>>2]|0;c=k[a+(f<<2)>>2]|0;k[H>>2]=E;k[g>>2]=D;Pfa(K,d,c,G,F,l,e,H);f=f+1|0}while((f|0)<(x|0))}}else Xfa(G,1);Qfa(K,G,F);b=k[G>>2]|0;f=b;if(b|0){g=k[j>>2]|0;if((g|0)!=(b|0))k[j>>2]=g+(~(((g+-20-f|0)>>>0)/20|0)*20|0);ggb(b)}b=k[I>>2]|0;if((b|0)!=(y|0)){if(b|0)ggb(b);k[I>>2]=y;k[z>>2]=264}b=k[J>>2]|0;if((b|0)!=(B|0)){if(b|0)ggb(b);k[J>>2]=B;k[C>>2]=264}}g=K+36|0;b=k[g>>2]|0;if(b|0?(I=b+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[K+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;J=K+16|0;f=K+4|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[f>>2]|0)>0){g=k[K+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[K+44>>2]|0;if((b|0)==(K+48|0)|(b|0)==0){r=L;return}ggb(k[b+-4>>2]|0);r=L;return}function Lk(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+64|0;m=h+40|0;l=h+24|0;j=h+8|0;i=h;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;a=l+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[l>>2]=33619968;k[l+4>>2]=b;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=d;k[i>>2]=k[e>>2];k[i+4>>2]=k[e+4>>2];fla(m,l,c,j,i,f,g);r=h;return}function Mk(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0;g=r;r=r+64|0;l=g+40|0;j=g+24|0;i=g+8|0;h=g;m=l+4+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=50397184;k[l+4>>2]=a;a=j+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[j>>2]=33882112;k[j+4>>2]=b;b=i+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=c;k[h>>2]=k[f>>2];k[h+4>>2]=k[f+4>>2];Jea(l,j,i,d,e,h);r=g;return}function Nk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+144|0;o=p+80|0;n=p+24|0;m=p;j=p+8|0;l=j+4|0;h=j+4+4|0;k[h>>2]=0;k[h+4>>2]=0;k[j>>2]=33619968;k[l>>2]=b;k[o>>2]=k[a>>2];h=o+4|0;c=a+4|0;b=k[c>>2]|0;k[h>>2]=b;f=o+8|0;k[f>>2]=k[a+8>>2];k[o+12>>2]=k[a+12>>2];k[o+16>>2]=k[a+16>>2];k[o+20>>2]=k[a+20>>2];k[o+24>>2]=k[a+24>>2];k[o+28>>2]=k[a+28>>2];k[o+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[o+36>>2]=d;e=o+40|0;k[e>>2]=f;f=o+48|0;g=o+44|0;k[g>>2]=f;k[o+52>>2]=0;k[f>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[h>>2]=0;x1(o,b,0,0,0);if((k[h>>2]|0)>0){f=k[a+40>>2]|0;e=k[e>>2]|0;d=k[a+44>>2]|0;c=k[g>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else{a=k[a+44>>2]|0;h=k[g>>2]|0;k[h>>2]=k[a>>2];k[h+4>>2]=k[a+4>>2]}if(k[o>>2]&4095|0){k[n>>2]=0;b=n+4|0;k[b>>2]=0;c=ZT(28)|0;k[c>>2]=1;d=c+4|0;k[n>>2]=d;k[b>>2]=21;i[c+25>>0]=0;e=354023;f=d+21|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,n,231486,229892,3856);k[b>>2]=0;k[n>>2]=0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0)}k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=o;b=o7(n)|0;if(b){if((k[j>>2]&2031616|0)==65536?(h=J2(j,-1)|0,(k[h>>2]&16384|0)==0):0)b2(j);c2(j,b,1,12,-1,0,0);do if((k[j>>2]&2031616|0)==65536){e=k[l>>2]|0;k[n>>2]=k[e>>2];h=n+4|0;b=e+4|0;k[h>>2]=k[b>>2];l=n+8|0;k[l>>2]=k[e+8>>2];k[n+12>>2]=k[e+12>>2];k[n+16>>2]=k[e+16>>2];k[n+20>>2]=k[e+20>>2];k[n+24>>2]=k[e+24>>2];k[n+28>>2]=k[e+28>>2];k[n+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[n+36>>2]=c;d=n+40|0;k[d>>2]=l;l=n+48|0;a=n+44|0;k[a>>2]=l;k[n+52>>2]=0;k[l>>2]=0;if(c|0){l=c+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[b>>2]|0)<3){l=k[e+44>>2]|0;b=k[a>>2]|0;k[b>>2]=k[l>>2];k[b+4>>2]=k[l+4>>2];b=n;break}k[h>>2]=0;x1(n,k[b>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[a>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[g+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0));b=n}else b=n}else{Q1(n,j,-1);b=n}while(0);if(!(k[b>>2]&16384)){k[m>>2]=0;b=m+4|0;k[b>>2]=0;c=ZT(24)|0;k[c>>2]=1;d=c+4|0;k[m>>2]=d;k[b>>2]=18;i[c+22>>0]=0;e=231498;f=d+18|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,m,231486,229892,3867);k[b>>2]=0;k[m>>2]=0;m=k[c>>2]|0;k[c>>2]=m+-1;if((m|0)==1)ggb(k[c+-4>>2]|0)}l=n+16|0;m=n+44|0;h=k[o+8>>2]|0;if((h|0)>0){f=k[o+16>>2]|0;a=k[o+44>>2]|0;g=k[o+12>>2]|0;j=(g|0)>0;e=0;b=k[l>>2]|0;do{d=f+(aa(k[a>>2]|0,e)|0)|0;if(j){c=0;do{if(i[d+c>>0]|0){k[b>>2]=c;k[b+4>>2]=e;b=b+8|0}c=c+1|0}while((c|0)!=(g|0))}e=e+1|0}while((e|0)!=(h|0))}d=n+36|0;b=k[d>>2]|0;if(b|0?(h=b+12|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[n+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=n+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[d>>2]|0)>0){c=k[n+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[m>>2]|0;if(!((b|0)==(n+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else b2(j);d=o+36|0;b=k[d>>2]|0;if(b|0?(m=b+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[o+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;n=o+16|0;c=o+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[c>>2]|0)>0){d=k[o+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[o+44>>2]|0;if((b|0)==(o+48|0)|(b|0)==0){r=p;return}ggb(k[b+-4>>2]|0);r=p;return}function Ok(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0,j=0,l=0,m=0;h=r;r=r+64|0;m=h+48|0;l=h+32|0;j=h+16|0;i=h;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=b;b=j+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[j>>2]=50397184;k[j+4>>2]=c;b=k[e>>2]|0;c=k[e+4>>2]|0;g=+p[e+8>>3];k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=f;g=+y6a(m,l,j,d,b,c,g,i);r=h;return +g}function Pk(a,b){a=a|0;b=b|0;var c=0,d=0;c=r;r=r+16|0;d=c;k[d+8>>2]=0;k[d+12>>2]=0;k[d>>2]=16842752;k[d+4>>2]=b;_ra(a,d);r=c;return}
function x2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0;Ta=r;r=r+64|0;Ra=Ta;Sa=k[b>>2]|0;Ma=k[b+4>>2]|0;Na=a+96|0;Oa=k[Na>>2]|0;Pa=a+92|0;Qa=k[Pa>>2]|0;La=aa(aa(Qa,Oa)|0,Qa)|0;c=La>>>0>1073741823?-1:La<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ka=a+88|0;d=aa(aa(aa(Oa,k[Ka>>2]|0)|0,Qa)|0,Qa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ja=a+8|0;f=k[Ja>>2]|0;e=aa(aa(aa(Oa,f)|0,Qa)|0,Qa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Sa|0)<(Ma|0)){Ba=a+104|0;Ca=a+12|0;Da=a+16|0;Ea=a+84|0;Fa=a+116|0;Ga=a+120|0;Ha=a+100|0;Ia=a+44|0;O=a+72|0;P=Ra+4|0;Q=Ra+8|0;R=Ra+12|0;S=Ra+16|0;T=Ra+20|0;U=Ra+24|0;V=Ra+28|0;W=Ra+32|0;X=Ra+36|0;Y=Ra+40|0;Z=Ra+48|0;_=Ra+44|0;$=Ra+52|0;ba=Ra+4|0;ca=Ra+8|0;da=Ra+12|0;ea=Ra+16|0;fa=Ra+20|0;ga=Ra+24|0;ha=Ra+28|0;ia=Ra+32|0;ja=Ra+36|0;ka=Ra+40|0;la=Ra+48|0;ma=Ra+44|0;na=Ra+52|0;oa=Ra+4|0;pa=Ra+8|0;qa=Ra+12|0;ra=Ra+16|0;sa=Ra+20|0;ta=Ra+24|0;ua=Ra+28|0;va=Ra+32|0;wa=Ra+36|0;xa=Ra+40|0;ya=Ra+48|0;za=Ra+44|0;Aa=Ra+52|0;a=-1;N=Sa;e=f;do{if((e|0)>0){M=(N|0)==(Sa|0);L=0;do{f=k[Ba>>2]|0;J=N-f|0;K=L-f|0;if(!L)if((k[Na>>2]|0)>0){D=0;do{f=k[Da>>2]|0;k[Ra>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[ba>>2]=k[e>>2];k[ca>>2]=k[f+(D*56|0)+8>>2];k[da>>2]=k[f+(D*56|0)+12>>2];k[ea>>2]=k[f+(D*56|0)+16>>2];k[fa>>2]=k[f+(D*56|0)+20>>2];k[ga>>2]=k[f+(D*56|0)+24>>2];k[ha>>2]=k[f+(D*56|0)+28>>2];k[ia>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ja>>2]=a;k[ka>>2]=ca;k[ma>>2]=la;k[na>>2]=0;k[la>>2]=0;if(a|0){I=a+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[e>>2]|0)>=3){k[ba>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[ba>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ka>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ma>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ba>>2]|0))}}else{H=k[f+(D*56|0)+44>>2]|0;I=k[ma>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2]}e=k[Pa>>2]|0;if((e|0)>0){z=aa(aa(Qa,D)|0,Qa)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+N|0;u=aa(Qa,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ka>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ka>>2]|0}while((a|0)<(e|0))}p=k[Ba>>2]|0;o=t-p|0;p=s-p|0;f=k[Ha>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Ia>>2]|0;h=k[O>>2]|0;j=k[ea>>2]|0;while(1){F=k[Ea>>2]|0;E=F+a|0;Ua=g+(aa(k[h>>2]|0,f+N+F|0)|0)|0;e=m+F|0;F=j+(aa(k[k[ma>>2]>>2]|0,o+f+F|0)|0)|0;H=(l[Ua+(E<<2)>>0]|0)-(l[F+(e<<2)>>0]|0)|0;G=(l[Ua+(E<<2)+1>>0]|0)-(l[F+(e<<2)+1>>0]|0)|0;I=(l[Ua+(E<<2)+2>>0]|0)-(l[F+(e<<2)+2>>0]|0)|0;e=(l[Ua+(E<<2)+3>>0]|0)-(l[F+(e<<2)+3>>0]|0)|0;e=((G|0)>-1?G:0-G|0)+((H|0)>-1?H:0-H|0)+((I|0)>-1?I:0-I|0)+((e|0)>-1?e:0-e|0)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Ha>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(La<<2)|0}else break}e=k[Ka>>2]|0}e=c+((aa(aa(aa(Oa,e+-1|0)|0,Qa)|0,Qa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Pa>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ja>>2]|0;if(e|0?(I=e+12|0,Ua=k[I>>2]|0,k[I>>2]=Ua+-1,(Ua|0)==1):0){a=k[ja>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ia>>2]|0;if(e|0)break;e=B1()|0;a=k[ja>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ja>>2]=0}k[ja>>2]=0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[ba>>2]|0)>0){a=k[ka>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ba>>2]|0))}e=k[ma>>2]|0;if(!((e|0)==(la|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[Na>>2]|0}while((D|0)<(e|0));a=0;C=125}else{a=0;j=0;h=0;g=0;f=0;e=0}else{e=k[Ea>>2]|0;if(M){F=e+Sa|0;D=e+L+(k[Ha>>2]|0)|0;E=F-f|0;e=k[Na>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)|0;C=d+((aa(aa(aa(Oa,L)|0,Qa)|0,Qa)|0)<<2)|0;z=0;do{g=k[Da>>2]|0;k[Ra>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[oa>>2]=k[e>>2];k[pa>>2]=k[g+(z*56|0)+8>>2];k[qa>>2]=k[g+(z*56|0)+12>>2];k[ra>>2]=k[g+(z*56|0)+16>>2];k[sa>>2]=k[g+(z*56|0)+20>>2];k[ta>>2]=k[g+(z*56|0)+24>>2];k[ua>>2]=k[g+(z*56|0)+28>>2];k[va>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[wa>>2]=f;k[xa>>2]=pa;k[za>>2]=ya;k[Aa>>2]=0;k[ya>>2]=0;if(f|0){Ua=f+12|0;k[Ua>>2]=(k[Ua>>2]|0)+1}if((k[e>>2]|0)>=3){k[oa>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[oa>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[xa>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[za>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[oa>>2]|0))}}else{I=k[g+(z*56|0)+44>>2]|0;Ua=k[za>>2]|0;k[Ua>>2]=k[I>>2];k[Ua+4>>2]=k[I+4>>2]}e=k[Pa>>2]|0;if((e|0)>0){y=aa(aa(Qa,z)|0,Qa)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Qa,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;Ua=k[Ha>>2]|0;e=0-Ua|0;if((Ua|0)<(e|0))e=0;else{g=k[Ia>>2]|0;h=k[O>>2]|0;j=k[ra>>2]|0;f=e;e=0;while(1){Va=g+(aa(k[h>>2]|0,f+F|0)|0)|0;Ua=j+(aa(k[k[za>>2]>>2]|0,q+f|0)|0)|0;G=(l[Va+(D<<2)>>0]|0)-(l[Ua+(m<<2)>>0]|0)|0;H=(l[Va+(D<<2)+1>>0]|0)-(l[Ua+(m<<2)+1>>0]|0)|0;I=(l[Va+(D<<2)+2>>0]|0)-(l[Ua+(m<<2)+2>>0]|0)|0;Ua=(l[Va+(D<<2)+3>>0]|0)-(l[Ua+(m<<2)+3>>0]|0)|0;e=e+((G|0)>-1?G:0-G|0)+((H|0)>-1?H:0-H|0)+((I|0)>-1?I:0-I|0)+((Ua|0)>-1?Ua:0-Ua|0)|0;k[n>>2]=e;if((f|0)<(k[Ha>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Pa>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[wa>>2]|0;if(e|0?(Ua=e+12|0,Va=k[Ua>>2]|0,k[Ua>>2]=Va+-1,(Va|0)==1):0){f=k[wa>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[va>>2]|0;if(e|0)break;e=B1()|0;f=k[wa>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[wa>>2]=0}k[wa>>2]=0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[oa>>2]|0)>0){f=k[xa>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[oa>>2]|0))}e=k[za>>2]|0;if(!((e|0)==(ya|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[Na>>2]|0}while((z|0)<(e|0))}}else{Va=e+N|0;G=e+L|0;H=k[Ha>>2]|0;h=G+H|0;I=Va-f|0;G=G-f+H|0;e=k[Ia>>2]|0;f=k[k[O>>2]>>2]|0;g=e+(aa(f,Va+~H|0)|0)|0;f=e+(aa(f,Va+H|0)|0)|0;H=k[Pa>>2]|0;e=k[Na>>2]|0;if((e|0)>0){B=(H|0)>0;C=I+-1|0;D=l[f+(h<<2)>>0]|0;E=l[f+(h<<2)+1>>0]|0;F=l[f+(h<<2)+2>>0]|0;x=l[f+(h<<2)+3>>0]|0;y=l[g+(h<<2)>>0]|0;z=l[g+(h<<2)+1>>0]|0;A=l[g+(h<<2)+2>>0]|0;u=l[g+(h<<2)+3>>0]|0;v=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)|0;w=d+((aa(aa(aa(Oa,L)|0,Qa)|0,Qa)|0)<<2)|0;t=0;do{g=k[Da>>2]|0;k[Ra>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[P>>2]=k[e>>2];k[Q>>2]=k[g+(t*56|0)+8>>2];k[R>>2]=k[g+(t*56|0)+12>>2];k[S>>2]=k[g+(t*56|0)+16>>2];k[T>>2]=k[g+(t*56|0)+20>>2];k[U>>2]=k[g+(t*56|0)+24>>2];k[V>>2]=k[g+(t*56|0)+28>>2];k[W>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[X>>2]=f;k[Y>>2]=Q;k[_>>2]=Z;k[$>>2]=0;k[Z>>2]=0;if(f|0){Va=f+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[e>>2]|0)>=3){k[P>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[P>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[Y>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[_>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[P>>2]|0))}}else{Ua=k[g+(t*56|0)+44>>2]|0;Va=k[_>>2]|0;k[Va>>2]=k[Ua>>2];k[Va+4>>2]=k[Ua+4>>2]}m=aa(aa(Qa,t)|0,Qa)|0;h=b+(m<<2)|0;j=v+(m<<2)|0;m=w+(m<<2)|0;if(B){g=k[S>>2]|0;f=0;do{p=aa(f,Qa)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Ha>>2]|0;e=k[k[_>>2]>>2]|0;q=g+(aa(e,C+f-s|0)|0)|0;s=g+(aa(e,f+I+s|0)|0)|0;e=0;do{Ua=o+(e<<2)|0;Wa=n+(e<<2)|0;k[Wa>>2]=(k[Wa>>2]|0)-(k[Ua>>2]|0);Va=p+(e<<2)|0;$a=G+e|0;_a=D-(l[s+($a<<2)>>0]|0)|0;Za=E-(l[s+($a<<2)+1>>0]|0)|0;Ya=F-(l[s+($a<<2)+2>>0]|0)|0;Xa=x-(l[s+($a<<2)+3>>0]|0)|0;cb=y-(l[q+($a<<2)>>0]|0)|0;bb=z-(l[q+($a<<2)+1>>0]|0)|0;ab=A-(l[q+($a<<2)+2>>0]|0)|0;$a=u-(l[q+($a<<2)+3>>0]|0)|0;Xa=(k[Va>>2]|0)-((cb|0)>-1?cb:0-cb|0)-((bb|0)>-1?bb:0-bb|0)-((ab|0)>-1?ab:0-ab|0)-(($a|0)>-1?$a:0-$a|0)+((_a|0)>-1?_a:0-_a|0)+((Za|0)>-1?Za:0-Za|0)+((Ya|0)>-1?Ya:0-Ya|0)+((Xa|0)>-1?Xa:0-Xa|0)|0;k[Ua>>2]=Xa;k[Wa>>2]=Xa+(k[Wa>>2]|0);k[Va>>2]=k[Ua>>2];e=e+1|0}while((e|0)!=(H|0));f=f+1|0}while((f|0)!=(H|0))}e=k[X>>2]|0;if(e|0?(bb=e+12|0,cb=k[bb>>2]|0,k[bb>>2]=cb+-1,(cb|0)==1):0){f=k[X>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[W>>2]|0;if(e|0)break;e=B1()|0;f=k[X>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[X>>2]=0}k[X>>2]=0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[P>>2]|0)>0){f=k[Y>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[P>>2]|0))}e=k[_>>2]|0;if(!((e|0)==(Z|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[Na>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ka>>2]|0)|0;C=125}if((C|0)==125){C=0;if((e|0)>0){z=k[Da>>2]|0;A=k[Pa>>2]|0;B=(A|0)>0;y=0;h=0;g=0;f=0;m=0;j=0;do{if(B){u=k[Ea>>2]|0;v=k[z+(y*56|0)+16>>2]|0;w=k[k[z+(y*56|0)+44>>2]>>2]|0;x=b+((aa(aa(Qa,y)|0,Qa)|0)<<2)|0;s=k[Fa>>2]|0;t=k[Ga>>2]|0;q=0;do{o=v+(aa(w,J+q+u|0)|0)|0;p=x+((aa(Qa,q)|0)<<2)|0;n=0;do{cb=k[t+(k[p+(n<<2)>>2]>>s<<2)>>2]|0;bb=K+n+u|0;h=h+(aa(l[o+(bb<<2)>>0]|0,cb)|0)|0;g=g+(aa(l[o+(bb<<2)+1>>0]|0,cb)|0)|0;f=f+(aa(l[o+(bb<<2)+2>>0]|0,cb)|0)|0;m=m+(aa(l[o+(bb<<2)+3>>0]|0,cb)|0)|0;j=cb+j|0;n=n+1|0}while((n|0)!=(A|0));q=q+1|0}while((q|0)!=(A|0))}y=y+1|0}while((y|0)!=(e|0));e=m}else{j=0;h=0;g=0;f=0;e=0}}ab=(j|0)/2|0;$a=((h+ab|0)>>>0)/(j>>>0)|0;bb=((g+ab|0)>>>0)/(j>>>0)|0;cb=((f+ab|0)>>>0)/(j>>>0)|0;ab=((e+ab|0)>>>0)/(j>>>0)|0;e=k[Ca>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,N)|0)+(L<<2)|0;cb=($a>>>0<256?$a:($a|0)>0?255:0)&255|(ab>>>0<256?ab:(ab|0)>0?255:0)<<24|(bb>>>0<256?bb:(bb|0)>0?255:0)<<8&65280|(cb>>>0<256?cb:(cb|0)>0?255:0)<<16&16711680;i[e>>0]=cb;i[e+1>>0]=cb>>8;i[e+2>>0]=cb>>16;i[e+3>>0]=cb>>24;L=L+1|0;e=k[Ja>>2]|0}while((L|0)<(e|0))}N=N+1|0}while((N|0)<(Ma|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Ta;return}ggb(b);r=Ta;return}function y2a(a){a=a|0;Y1a(a);ggb(a);return}function z2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;Ra=r;r=r+64|0;Pa=Ra;Qa=k[b>>2]|0;Ka=k[b+4>>2]|0;La=a+96|0;Ma=k[La>>2]|0;Na=a+92|0;Oa=k[Na>>2]|0;Ja=aa(aa(Oa,Ma)|0,Oa)|0;c=Ja>>>0>1073741823?-1:Ja<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ia=a+88|0;d=aa(aa(aa(Ma,k[Ia>>2]|0)|0,Oa)|0,Oa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ha=a+8|0;f=k[Ha>>2]|0;e=aa(aa(aa(Ma,f)|0,Oa)|0,Oa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Qa|0)<(Ka|0)){za=a+104|0;Aa=a+12|0;Ba=a+16|0;Ca=a+84|0;Da=a+116|0;Ea=a+120|0;Fa=a+100|0;Ga=a+44|0;M=a+72|0;N=Pa+4|0;O=Pa+8|0;P=Pa+12|0;Q=Pa+16|0;R=Pa+20|0;S=Pa+24|0;T=Pa+28|0;U=Pa+32|0;V=Pa+36|0;W=Pa+40|0;X=Pa+48|0;Y=Pa+44|0;Z=Pa+52|0;_=Pa+4|0;$=Pa+8|0;ba=Pa+12|0;ca=Pa+16|0;da=Pa+20|0;ea=Pa+24|0;fa=Pa+28|0;ga=Pa+32|0;ha=Pa+36|0;ia=Pa+40|0;ja=Pa+48|0;ka=Pa+44|0;la=Pa+52|0;ma=Pa+4|0;na=Pa+8|0;oa=Pa+12|0;pa=Pa+16|0;qa=Pa+20|0;ra=Pa+24|0;sa=Pa+28|0;ta=Pa+32|0;ua=Pa+36|0;va=Pa+40|0;wa=Pa+48|0;xa=Pa+44|0;ya=Pa+52|0;a=-1;L=Qa;e=f;do{if((e|0)>0){K=(L|0)==(Qa|0);J=0;do{f=k[za>>2]|0;H=L-f|0;I=J-f|0;if(!J)if((k[La>>2]|0)>0){D=0;do{f=k[Ba>>2]|0;k[Pa>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[_>>2]=k[e>>2];k[$>>2]=k[f+(D*56|0)+8>>2];k[ba>>2]=k[f+(D*56|0)+12>>2];k[ca>>2]=k[f+(D*56|0)+16>>2];k[da>>2]=k[f+(D*56|0)+20>>2];k[ea>>2]=k[f+(D*56|0)+24>>2];k[fa>>2]=k[f+(D*56|0)+28>>2];k[ga>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ha>>2]=a;k[ia>>2]=$;k[ka>>2]=ja;k[la>>2]=0;k[ja>>2]=0;if(a|0){G=a+12|0;k[G>>2]=(k[G>>2]|0)+1}if((k[e>>2]|0)>=3){k[_>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[_>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ia>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ka>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[_>>2]|0))}}else{F=k[f+(D*56|0)+44>>2]|0;G=k[ka>>2]|0;k[G>>2]=k[F>>2];k[G+4>>2]=k[F+4>>2]}e=k[Na>>2]|0;if((e|0)>0){z=aa(aa(Oa,D)|0,Oa)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+L|0;u=aa(Oa,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ia>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ia>>2]|0}while((a|0)<(e|0))}p=k[za>>2]|0;o=t-p|0;p=s-p|0;f=k[Fa>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Ga>>2]|0;h=k[M>>2]|0;j=k[ca>>2]|0;while(1){E=k[Ca>>2]|0;Sa=E+a|0;Ta=g+(aa(k[h>>2]|0,f+L+E|0)|0)|0;e=m+E|0;E=j+(aa(k[k[ka>>2]>>2]|0,o+f+E|0)|0)|0;G=(l[Ta+(Sa*3|0)>>0]|0)-(l[E+(e*3|0)>>0]|0)|0;F=(l[Ta+(Sa*3|0)+1>>0]|0)-(l[E+(e*3|0)+1>>0]|0)|0;e=(l[Ta+(Sa*3|0)+2>>0]|0)-(l[E+(e*3|0)+2>>0]|0)|0;e=((F|0)>-1?F:0-F|0)+((G|0)>-1?G:0-G|0)+((e|0)>-1?e:0-e|0)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Fa>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(Ja<<2)|0}else break}e=k[Ia>>2]|0}e=c+((aa(aa(aa(Ma,e+-1|0)|0,Oa)|0,Oa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Na>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ha>>2]|0;if(e|0?(Sa=e+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){a=k[ha>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ga>>2]|0;if(e|0)break;e=B1()|0;a=k[ha>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ha>>2]=0}k[ha>>2]=0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;if((k[_>>2]|0)>0){a=k[ia>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[_>>2]|0))}e=k[ka>>2]|0;if(!((e|0)==(ja|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[La>>2]|0}while((D|0)<(e|0));a=0;D=125}else{a=0;m=0;j=0;h=0;g=0;f=0;e=0}else{e=k[Ca>>2]|0;if(K){F=e+Qa|0;D=e+J+(k[Fa>>2]|0)|0;E=F-f|0;e=k[La>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)|0;C=d+((aa(aa(aa(Ma,J)|0,Oa)|0,Oa)|0)<<2)|0;z=0;do{g=k[Ba>>2]|0;k[Pa>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[ma>>2]=k[e>>2];k[na>>2]=k[g+(z*56|0)+8>>2];k[oa>>2]=k[g+(z*56|0)+12>>2];k[pa>>2]=k[g+(z*56|0)+16>>2];k[qa>>2]=k[g+(z*56|0)+20>>2];k[ra>>2]=k[g+(z*56|0)+24>>2];k[sa>>2]=k[g+(z*56|0)+28>>2];k[ta>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[ua>>2]=f;k[va>>2]=na;k[xa>>2]=wa;k[ya>>2]=0;k[wa>>2]=0;if(f|0){Ta=f+12|0;k[Ta>>2]=(k[Ta>>2]|0)+1}if((k[e>>2]|0)>=3){k[ma>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[ma>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[va>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[xa>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ma>>2]|0))}}else{Sa=k[g+(z*56|0)+44>>2]|0;Ta=k[xa>>2]|0;k[Ta>>2]=k[Sa>>2];k[Ta+4>>2]=k[Sa+4>>2]}e=k[Na>>2]|0;if((e|0)>0){y=aa(aa(Oa,z)|0,Oa)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Oa,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;Ta=k[Fa>>2]|0;e=0-Ta|0;if((Ta|0)<(e|0))e=0;else{g=k[Ga>>2]|0;h=k[M>>2]|0;j=k[pa>>2]|0;f=e;e=0;while(1){Ua=g+(aa(k[h>>2]|0,f+F|0)|0)|0;Ta=j+(aa(k[k[xa>>2]>>2]|0,q+f|0)|0)|0;G=(l[Ua+(D*3|0)>>0]|0)-(l[Ta+(m*3|0)>>0]|0)|0;Sa=(l[Ua+(D*3|0)+1>>0]|0)-(l[Ta+(m*3|0)+1>>0]|0)|0;Ta=(l[Ua+(D*3|0)+2>>0]|0)-(l[Ta+(m*3|0)+2>>0]|0)|0;e=((G|0)>-1?G:0-G|0)+e+((Sa|0)>-1?Sa:0-Sa|0)+((Ta|0)>-1?Ta:0-Ta|0)|0;k[n>>2]=e;if((f|0)<(k[Fa>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Na>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[ua>>2]|0;if(e|0?(Ta=e+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){f=k[ua>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[ta>>2]|0;if(e|0)break;e=B1()|0;f=k[ua>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ua>>2]=0}k[ua>>2]=0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[ma>>2]|0)>0){f=k[va>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ma>>2]|0))}e=k[xa>>2]|0;if(!((e|0)==(wa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[La>>2]|0}while((z|0)<(e|0))}}else{Ua=e+L|0;E=e+J|0;F=k[Fa>>2]|0;h=E+F|0;G=Ua-f|0;E=E-f+F|0;e=k[Ga>>2]|0;f=k[k[M>>2]>>2]|0;g=e+(aa(f,Ua+~F|0)|0)|0;f=e+(aa(f,Ua+F|0)|0)|0;F=k[Na>>2]|0;e=k[La>>2]|0;if((e|0)>0){A=(F|0)>0;B=G+-1|0;C=l[f+(h*3|0)>>0]|0;D=l[f+(h*3|0)+1>>0]|0;x=l[f+(h*3|0)+2>>0]|0;y=l[g+(h*3|0)>>0]|0;z=l[g+(h*3|0)+1>>0]|0;u=l[g+(h*3|0)+2>>0]|0;v=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)|0;w=d+((aa(aa(aa(Ma,J)|0,Oa)|0,Oa)|0)<<2)|0;t=0;do{g=k[Ba>>2]|0;k[Pa>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[N>>2]=k[e>>2];k[O>>2]=k[g+(t*56|0)+8>>2];k[P>>2]=k[g+(t*56|0)+12>>2];k[Q>>2]=k[g+(t*56|0)+16>>2];k[R>>2]=k[g+(t*56|0)+20>>2];k[S>>2]=k[g+(t*56|0)+24>>2];k[T>>2]=k[g+(t*56|0)+28>>2];k[U>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[V>>2]=f;k[W>>2]=O;k[Y>>2]=X;k[Z>>2]=0;k[X>>2]=0;if(f|0){Ua=f+12|0;k[Ua>>2]=(k[Ua>>2]|0)+1}if((k[e>>2]|0)>=3){k[N>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[N>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[W>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[Y>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[N>>2]|0))}}else{Ta=k[g+(t*56|0)+44>>2]|0;Ua=k[Y>>2]|0;k[Ua>>2]=k[Ta>>2];k[Ua+4>>2]=k[Ta+4>>2]}m=aa(aa(Oa,t)|0,Oa)|0;h=b+(m<<2)|0;j=v+(m<<2)|0;m=w+(m<<2)|0;if(A){g=k[Q>>2]|0;f=0;do{p=aa(f,Oa)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Fa>>2]|0;e=k[k[Y>>2]>>2]|0;q=g+(aa(e,B+f-s|0)|0)|0;s=g+(aa(e,f+G+s|0)|0)|0;e=0;do{Ta=o+(e<<2)|0;Sa=n+(e<<2)|0;k[Sa>>2]=(k[Sa>>2]|0)-(k[Ta>>2]|0);Ua=p+(e<<2)|0;Ya=E+e|0;Xa=C-(l[s+(Ya*3|0)>>0]|0)|0;Wa=D-(l[s+(Ya*3|0)+1>>0]|0)|0;Va=x-(l[s+(Ya*3|0)+2>>0]|0)|0;_a=y-(l[q+(Ya*3|0)>>0]|0)|0;Za=z-(l[q+(Ya*3|0)+1>>0]|0)|0;Ya=u-(l[q+(Ya*3|0)+2>>0]|0)|0;Va=(k[Ua>>2]|0)-((_a|0)>-1?_a:0-_a|0)-((Za|0)>-1?Za:0-Za|0)-((Ya|0)>-1?Ya:0-Ya|0)+((Xa|0)>-1?Xa:0-Xa|0)+((Wa|0)>-1?Wa:0-Wa|0)+((Va|0)>-1?Va:0-Va|0)|0;k[Ta>>2]=Va;k[Sa>>2]=Va+(k[Sa>>2]|0);k[Ua>>2]=k[Ta>>2];e=e+1|0}while((e|0)!=(F|0));f=f+1|0}while((f|0)!=(F|0))}e=k[V>>2]|0;if(e|0?(Za=e+12|0,_a=k[Za>>2]|0,k[Za>>2]=_a+-1,(_a|0)==1):0){f=k[V>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[U>>2]|0;if(e|0)break;e=B1()|0;f=k[V>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[V>>2]=0}k[V>>2]=0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[N>>2]|0)>0){f=k[W>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[N>>2]|0))}e=k[Y>>2]|0;if(!((e|0)==(X|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[La>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ia>>2]|0)|0;D=125}if((D|0)==125){D=0;if((e|0)>0){A=k[Ba>>2]|0;B=k[Na>>2]|0;C=(B|0)>0;z=0;j=0;g=0;n=0;m=0;h=0;f=0;do{if(C){v=k[Ca>>2]|0;w=k[A+(z*56|0)+16>>2]|0;x=k[k[A+(z*56|0)+44>>2]>>2]|0;y=b+((aa(aa(Oa,z)|0,Oa)|0)<<2)|0;t=k[Da>>2]|0;u=k[Ea>>2]|0;s=0;do{p=w+(aa(x,H+s+v|0)|0)|0;q=y+((aa(Oa,s)|0)<<2)|0;o=0;do{_a=k[q+(o<<2)>>2]>>t;Ya=k[u+(_a*12|0)>>2]|0;Za=k[u+(_a*12|0)+4>>2]|0;_a=k[u+(_a*12|0)+8>>2]|0;Xa=I+o+v|0;j=j+(aa(l[p+(Xa*3|0)>>0]|0,Ya)|0)|0;g=g+(aa(l[p+(Xa*3|0)+1>>0]|0,Za)|0)|0;n=n+(aa(l[p+(Xa*3|0)+2>>0]|0,_a)|0)|0;m=m+Ya|0;h=h+Za|0;f=f+_a|0;o=o+1|0}while((o|0)!=(B|0));s=s+1|0}while((s|0)!=(B|0))}z=z+1|0}while((z|0)!=(e|0));e=n}else{m=0;j=0;h=0;g=0;f=0;e=0}}Ya=((((m|0)/2|0)+j|0)>>>0)/(m>>>0)|0;Za=((((h|0)/2|0)+g|0)>>>0)/(h>>>0)|0;_a=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[Aa>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,L)|0)|0;i[e+(J*3|0)>>0]=Ya>>>0<256?Ya:(Ya|0)>0?255:0;i[e+(J*3|0)+1>>0]=Za>>>0<256?Za:(Za|0)>0?255:0;i[e+(J*3|0)+2>>0]=_a>>>0<256?_a:(_a|0)>0?255:0;J=J+1|0;e=k[Ha>>2]|0}while((J|0)<(e|0))}L=L+1|0}while((L|0)<(Ka|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Ra;return}ggb(b);r=Ra;return}function A2a(a){a=a|0;X1a(a);ggb(a);return}function B2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;Ra=r;r=r+64|0;Pa=Ra;Qa=k[b>>2]|0;Ka=k[b+4>>2]|0;La=a+96|0;Ma=k[La>>2]|0;Na=a+92|0;Oa=k[Na>>2]|0;Ja=aa(aa(Oa,Ma)|0,Oa)|0;c=Ja>>>0>1073741823?-1:Ja<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ia=a+88|0;d=aa(aa(aa(Ma,k[Ia>>2]|0)|0,Oa)|0,Oa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ha=a+8|0;f=k[Ha>>2]|0;e=aa(aa(aa(Ma,f)|0,Oa)|0,Oa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Qa|0)<(Ka|0)){za=a+104|0;Aa=a+12|0;Ba=a+16|0;Ca=a+84|0;Da=a+116|0;Ea=a+120|0;Fa=a+100|0;Ga=a+44|0;M=a+72|0;N=Pa+4|0;O=Pa+8|0;P=Pa+12|0;Q=Pa+16|0;R=Pa+20|0;S=Pa+24|0;T=Pa+28|0;U=Pa+32|0;V=Pa+36|0;W=Pa+40|0;X=Pa+48|0;Y=Pa+44|0;Z=Pa+52|0;_=Pa+4|0;$=Pa+8|0;ba=Pa+12|0;ca=Pa+16|0;da=Pa+20|0;ea=Pa+24|0;fa=Pa+28|0;ga=Pa+32|0;ha=Pa+36|0;ia=Pa+40|0;ja=Pa+48|0;ka=Pa+44|0;la=Pa+52|0;ma=Pa+4|0;na=Pa+8|0;oa=Pa+12|0;pa=Pa+16|0;qa=Pa+20|0;ra=Pa+24|0;sa=Pa+28|0;ta=Pa+32|0;ua=Pa+36|0;va=Pa+40|0;wa=Pa+48|0;xa=Pa+44|0;ya=Pa+52|0;a=-1;L=Qa;e=f;do{if((e|0)>0){K=(L|0)==(Qa|0);J=0;do{f=k[za>>2]|0;H=L-f|0;I=J-f|0;if(!J)if((k[La>>2]|0)>0){D=0;do{f=k[Ba>>2]|0;k[Pa>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[_>>2]=k[e>>2];k[$>>2]=k[f+(D*56|0)+8>>2];k[ba>>2]=k[f+(D*56|0)+12>>2];k[ca>>2]=k[f+(D*56|0)+16>>2];k[da>>2]=k[f+(D*56|0)+20>>2];k[ea>>2]=k[f+(D*56|0)+24>>2];k[fa>>2]=k[f+(D*56|0)+28>>2];k[ga>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ha>>2]=a;k[ia>>2]=$;k[ka>>2]=ja;k[la>>2]=0;k[ja>>2]=0;if(a|0){G=a+12|0;k[G>>2]=(k[G>>2]|0)+1}if((k[e>>2]|0)>=3){k[_>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[_>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ia>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ka>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[_>>2]|0))}}else{F=k[f+(D*56|0)+44>>2]|0;G=k[ka>>2]|0;k[G>>2]=k[F>>2];k[G+4>>2]=k[F+4>>2]}e=k[Na>>2]|0;if((e|0)>0){z=aa(aa(Oa,D)|0,Oa)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+L|0;u=aa(Oa,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ia>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ia>>2]|0}while((a|0)<(e|0))}p=k[za>>2]|0;o=t-p|0;p=s-p|0;f=k[Fa>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Ga>>2]|0;h=k[M>>2]|0;j=k[ca>>2]|0;while(1){E=k[Ca>>2]|0;Sa=E+a|0;Ta=g+(aa(k[h>>2]|0,f+L+E|0)|0)|0;e=m+E|0;E=j+(aa(k[k[ka>>2]>>2]|0,o+f+E|0)|0)|0;G=(l[Ta+(Sa*3|0)>>0]|0)-(l[E+(e*3|0)>>0]|0)|0;F=(l[Ta+(Sa*3|0)+1>>0]|0)-(l[E+(e*3|0)+1>>0]|0)|0;e=(l[Ta+(Sa*3|0)+2>>0]|0)-(l[E+(e*3|0)+2>>0]|0)|0;e=((F|0)>-1?F:0-F|0)+((G|0)>-1?G:0-G|0)+((e|0)>-1?e:0-e|0)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Fa>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(Ja<<2)|0}else break}e=k[Ia>>2]|0}e=c+((aa(aa(aa(Ma,e+-1|0)|0,Oa)|0,Oa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Na>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ha>>2]|0;if(e|0?(Sa=e+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){a=k[ha>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ga>>2]|0;if(e|0)break;e=B1()|0;a=k[ha>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ha>>2]=0}k[ha>>2]=0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;if((k[_>>2]|0)>0){a=k[ia>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[_>>2]|0))}e=k[ka>>2]|0;if(!((e|0)==(ja|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[La>>2]|0}while((D|0)<(e|0));a=0;B=125}else{a=0;h=0;g=0;f=0;e=0}else{e=k[Ca>>2]|0;if(K){F=e+Qa|0;D=e+J+(k[Fa>>2]|0)|0;E=F-f|0;e=k[La>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)|0;C=d+((aa(aa(aa(Ma,J)|0,Oa)|0,Oa)|0)<<2)|0;z=0;do{g=k[Ba>>2]|0;k[Pa>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[ma>>2]=k[e>>2];k[na>>2]=k[g+(z*56|0)+8>>2];k[oa>>2]=k[g+(z*56|0)+12>>2];k[pa>>2]=k[g+(z*56|0)+16>>2];k[qa>>2]=k[g+(z*56|0)+20>>2];k[ra>>2]=k[g+(z*56|0)+24>>2];k[sa>>2]=k[g+(z*56|0)+28>>2];k[ta>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[ua>>2]=f;k[va>>2]=na;k[xa>>2]=wa;k[ya>>2]=0;k[wa>>2]=0;if(f|0){Ta=f+12|0;k[Ta>>2]=(k[Ta>>2]|0)+1}if((k[e>>2]|0)>=3){k[ma>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[ma>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[va>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[xa>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ma>>2]|0))}}else{Sa=k[g+(z*56|0)+44>>2]|0;Ta=k[xa>>2]|0;k[Ta>>2]=k[Sa>>2];k[Ta+4>>2]=k[Sa+4>>2]}e=k[Na>>2]|0;if((e|0)>0){y=aa(aa(Oa,z)|0,Oa)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Oa,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;Ta=k[Fa>>2]|0;e=0-Ta|0;if((Ta|0)<(e|0))e=0;else{g=k[Ga>>2]|0;h=k[M>>2]|0;j=k[pa>>2]|0;f=e;e=0;while(1){Ua=g+(aa(k[h>>2]|0,f+F|0)|0)|0;Ta=j+(aa(k[k[xa>>2]>>2]|0,q+f|0)|0)|0;G=(l[Ua+(D*3|0)>>0]|0)-(l[Ta+(m*3|0)>>0]|0)|0;Sa=(l[Ua+(D*3|0)+1>>0]|0)-(l[Ta+(m*3|0)+1>>0]|0)|0;Ta=(l[Ua+(D*3|0)+2>>0]|0)-(l[Ta+(m*3|0)+2>>0]|0)|0;e=((G|0)>-1?G:0-G|0)+e+((Sa|0)>-1?Sa:0-Sa|0)+((Ta|0)>-1?Ta:0-Ta|0)|0;k[n>>2]=e;if((f|0)<(k[Fa>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Na>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[ua>>2]|0;if(e|0?(Ta=e+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){f=k[ua>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[ta>>2]|0;if(e|0)break;e=B1()|0;f=k[ua>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ua>>2]=0}k[ua>>2]=0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[ma>>2]|0)>0){f=k[va>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ma>>2]|0))}e=k[xa>>2]|0;if(!((e|0)==(wa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[La>>2]|0}while((z|0)<(e|0))}}else{Ua=e+L|0;E=e+J|0;F=k[Fa>>2]|0;h=E+F|0;G=Ua-f|0;E=E-f+F|0;e=k[Ga>>2]|0;f=k[k[M>>2]>>2]|0;g=e+(aa(f,Ua+~F|0)|0)|0;f=e+(aa(f,Ua+F|0)|0)|0;F=k[Na>>2]|0;e=k[La>>2]|0;if((e|0)>0){A=(F|0)>0;B=G+-1|0;C=l[f+(h*3|0)>>0]|0;D=l[f+(h*3|0)+1>>0]|0;x=l[f+(h*3|0)+2>>0]|0;y=l[g+(h*3|0)>>0]|0;z=l[g+(h*3|0)+1>>0]|0;u=l[g+(h*3|0)+2>>0]|0;v=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)|0;w=d+((aa(aa(aa(Ma,J)|0,Oa)|0,Oa)|0)<<2)|0;t=0;do{g=k[Ba>>2]|0;k[Pa>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[N>>2]=k[e>>2];k[O>>2]=k[g+(t*56|0)+8>>2];k[P>>2]=k[g+(t*56|0)+12>>2];k[Q>>2]=k[g+(t*56|0)+16>>2];k[R>>2]=k[g+(t*56|0)+20>>2];k[S>>2]=k[g+(t*56|0)+24>>2];k[T>>2]=k[g+(t*56|0)+28>>2];k[U>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[V>>2]=f;k[W>>2]=O;k[Y>>2]=X;k[Z>>2]=0;k[X>>2]=0;if(f|0){Ua=f+12|0;k[Ua>>2]=(k[Ua>>2]|0)+1}if((k[e>>2]|0)>=3){k[N>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[N>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[W>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[Y>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[N>>2]|0))}}else{Ta=k[g+(t*56|0)+44>>2]|0;Ua=k[Y>>2]|0;k[Ua>>2]=k[Ta>>2];k[Ua+4>>2]=k[Ta+4>>2]}m=aa(aa(Oa,t)|0,Oa)|0;h=b+(m<<2)|0;j=v+(m<<2)|0;m=w+(m<<2)|0;if(A){g=k[Q>>2]|0;f=0;do{p=aa(f,Oa)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Fa>>2]|0;e=k[k[Y>>2]>>2]|0;q=g+(aa(e,B+f-s|0)|0)|0;s=g+(aa(e,f+G+s|0)|0)|0;e=0;do{Ta=o+(e<<2)|0;Sa=n+(e<<2)|0;k[Sa>>2]=(k[Sa>>2]|0)-(k[Ta>>2]|0);Ua=p+(e<<2)|0;Ya=E+e|0;Xa=C-(l[s+(Ya*3|0)>>0]|0)|0;Wa=D-(l[s+(Ya*3|0)+1>>0]|0)|0;Va=x-(l[s+(Ya*3|0)+2>>0]|0)|0;_a=y-(l[q+(Ya*3|0)>>0]|0)|0;Za=z-(l[q+(Ya*3|0)+1>>0]|0)|0;Ya=u-(l[q+(Ya*3|0)+2>>0]|0)|0;Va=(k[Ua>>2]|0)-((_a|0)>-1?_a:0-_a|0)-((Za|0)>-1?Za:0-Za|0)-((Ya|0)>-1?Ya:0-Ya|0)+((Xa|0)>-1?Xa:0-Xa|0)+((Wa|0)>-1?Wa:0-Wa|0)+((Va|0)>-1?Va:0-Va|0)|0;k[Ta>>2]=Va;k[Sa>>2]=Va+(k[Sa>>2]|0);k[Ua>>2]=k[Ta>>2];e=e+1|0}while((e|0)!=(F|0));f=f+1|0}while((f|0)!=(F|0))}e=k[V>>2]|0;if(e|0?(Za=e+12|0,_a=k[Za>>2]|0,k[Za>>2]=_a+-1,(_a|0)==1):0){f=k[V>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[U>>2]|0;if(e|0)break;e=B1()|0;f=k[V>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[V>>2]=0}k[V>>2]=0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[N>>2]|0)>0){f=k[W>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[N>>2]|0))}e=k[Y>>2]|0;if(!((e|0)==(X|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[La>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ia>>2]|0)|0;B=125}if((B|0)==125){B=0;if((e|0)>0){y=k[Ba>>2]|0;z=k[Na>>2]|0;A=(z|0)>0;x=0;g=0;f=0;j=0;h=0;do{if(A){t=k[Ca>>2]|0;u=k[y+(x*56|0)+16>>2]|0;v=k[k[y+(x*56|0)+44>>2]>>2]|0;w=b+((aa(aa(Oa,x)|0,Oa)|0)<<2)|0;q=k[Da>>2]|0;s=k[Ea>>2]|0;p=0;do{n=u+(aa(v,H+p+t|0)|0)|0;o=w+((aa(Oa,p)|0)<<2)|0;m=0;do{_a=k[s+(k[o+(m<<2)>>2]>>q<<2)>>2]|0;Za=I+m+t|0;g=g+(aa(l[n+(Za*3|0)>>0]|0,_a)|0)|0;f=f+(aa(l[n+(Za*3|0)+1>>0]|0,_a)|0)|0;j=j+(aa(l[n+(Za*3|0)+2>>0]|0,_a)|0)|0;h=_a+h|0;m=m+1|0}while((m|0)!=(z|0));p=p+1|0}while((p|0)!=(z|0))}x=x+1|0}while((x|0)!=(e|0));e=j}else{h=0;g=0;f=0;e=0}}_a=(h|0)/2|0;Ya=((g+_a|0)>>>0)/(h>>>0)|0;Za=((f+_a|0)>>>0)/(h>>>0)|0;_a=((e+_a|0)>>>0)/(h>>>0)|0;e=k[Aa>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,L)|0)|0;i[e+(J*3|0)>>0]=Ya>>>0<256?Ya:(Ya|0)>0?255:0;i[e+(J*3|0)+1>>0]=Za>>>0<256?Za:(Za|0)>0?255:0;i[e+(J*3|0)+2>>0]=_a>>>0<256?_a:(_a|0)>0?255:0;J=J+1|0;e=k[Ha>>2]|0}while((J|0)<(e|0))}L=L+1|0}while((L|0)<(Ka|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Ra;return}ggb(b);r=Ra;return}function C2a(a){a=a|0;W1a(a);ggb(a);return}function D2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;Qa=r;r=r+64|0;Oa=Qa;Pa=k[b>>2]|0;Ja=k[b+4>>2]|0;Ka=a+96|0;La=k[Ka>>2]|0;Ma=a+92|0;Na=k[Ma>>2]|0;Ia=aa(aa(Na,La)|0,Na)|0;c=Ia>>>0>1073741823?-1:Ia<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ha=a+88|0;d=aa(aa(aa(La,k[Ha>>2]|0)|0,Na)|0,Na)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ga=a+8|0;f=k[Ga>>2]|0;e=aa(aa(aa(La,f)|0,Na)|0,Na)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Pa|0)<(Ja|0)){ya=a+104|0;za=a+12|0;Aa=a+16|0;Ba=a+84|0;Ca=a+116|0;Da=a+120|0;Ea=a+100|0;Fa=a+44|0;L=a+72|0;M=Oa+4|0;N=Oa+8|0;O=Oa+12|0;P=Oa+16|0;Q=Oa+20|0;R=Oa+24|0;S=Oa+28|0;T=Oa+32|0;U=Oa+36|0;V=Oa+40|0;W=Oa+48|0;X=Oa+44|0;Y=Oa+52|0;Z=Oa+4|0;_=Oa+8|0;$=Oa+12|0;ba=Oa+16|0;ca=Oa+20|0;da=Oa+24|0;ea=Oa+28|0;fa=Oa+32|0;ga=Oa+36|0;ha=Oa+40|0;ia=Oa+48|0;ja=Oa+44|0;ka=Oa+52|0;la=Oa+4|0;ma=Oa+8|0;na=Oa+12|0;oa=Oa+16|0;pa=Oa+20|0;qa=Oa+24|0;ra=Oa+28|0;sa=Oa+32|0;ta=Oa+36|0;ua=Oa+40|0;va=Oa+48|0;wa=Oa+44|0;xa=Oa+52|0;a=-1;K=Pa;e=f;do{if((e|0)>0){J=(K|0)==(Pa|0);I=0;do{f=k[ya>>2]|0;G=K-f|0;H=I-f|0;if(!I)if((k[Ka>>2]|0)>0){D=0;do{f=k[Aa>>2]|0;k[Oa>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[Z>>2]=k[e>>2];k[_>>2]=k[f+(D*56|0)+8>>2];k[$>>2]=k[f+(D*56|0)+12>>2];k[ba>>2]=k[f+(D*56|0)+16>>2];k[ca>>2]=k[f+(D*56|0)+20>>2];k[da>>2]=k[f+(D*56|0)+24>>2];k[ea>>2]=k[f+(D*56|0)+28>>2];k[fa>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ga>>2]=a;k[ha>>2]=_;k[ja>>2]=ia;k[ka>>2]=0;k[ia>>2]=0;if(a|0){F=a+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[e>>2]|0)>=3){k[Z>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[Z>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ha>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ja>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[Z>>2]|0))}}else{E=k[f+(D*56|0)+44>>2]|0;F=k[ja>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2]}e=k[Ma>>2]|0;if((e|0)>0){z=aa(aa(Na,D)|0,Na)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+K|0;u=aa(Na,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ha>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ha>>2]|0}while((a|0)<(e|0))}p=k[ya>>2]|0;o=t-p|0;p=s-p|0;f=k[Ea>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Fa>>2]|0;h=k[L>>2]|0;j=k[ba>>2]|0;while(1){E=k[Ba>>2]|0;Ra=E+a|0;Sa=g+(aa(k[h>>2]|0,f+K+E|0)|0)|0;F=m+E|0;E=j+(aa(k[k[ja>>2]>>2]|0,o+f+E|0)|0)|0;e=(l[Sa+(Ra<<1)>>0]|0)-(l[E+(F<<1)>>0]|0)|0;F=(l[Sa+(Ra<<1)+1>>0]|0)-(l[E+(F<<1)+1>>0]|0)|0;e=((F|0)>-1?F:0-F|0)+((e|0)>-1?e:0-e|0)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Ea>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(Ia<<2)|0}else break}e=k[Ha>>2]|0}e=c+((aa(aa(aa(La,e+-1|0)|0,Na)|0,Na)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Ma>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ga>>2]|0;if(e|0?(Ra=e+12|0,Sa=k[Ra>>2]|0,k[Ra>>2]=Sa+-1,(Sa|0)==1):0){a=k[ga>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[fa>>2]|0;if(e|0)break;e=B1()|0;a=k[ga>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ga>>2]=0}k[ga>>2]=0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[Z>>2]|0)>0){a=k[ha>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Z>>2]|0))}e=k[ja>>2]|0;if(!((e|0)==(ia|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[Ka>>2]|0}while((D|0)<(e|0));a=0;B=125}else{a=0;h=0;g=0;f=0;e=0}else{e=k[Ba>>2]|0;if(J){F=e+Pa|0;D=e+I+(k[Ea>>2]|0)|0;E=F-f|0;e=k[Ka>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)|0;C=d+((aa(aa(aa(La,I)|0,Na)|0,Na)|0)<<2)|0;z=0;do{g=k[Aa>>2]|0;k[Oa>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[la>>2]=k[e>>2];k[ma>>2]=k[g+(z*56|0)+8>>2];k[na>>2]=k[g+(z*56|0)+12>>2];k[oa>>2]=k[g+(z*56|0)+16>>2];k[pa>>2]=k[g+(z*56|0)+20>>2];k[qa>>2]=k[g+(z*56|0)+24>>2];k[ra>>2]=k[g+(z*56|0)+28>>2];k[sa>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[ta>>2]=f;k[ua>>2]=ma;k[wa>>2]=va;k[xa>>2]=0;k[va>>2]=0;if(f|0){Sa=f+12|0;k[Sa>>2]=(k[Sa>>2]|0)+1}if((k[e>>2]|0)>=3){k[la>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[la>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[ua>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[wa>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[la>>2]|0))}}else{Ra=k[g+(z*56|0)+44>>2]|0;Sa=k[wa>>2]|0;k[Sa>>2]=k[Ra>>2];k[Sa+4>>2]=k[Ra+4>>2]}e=k[Ma>>2]|0;if((e|0)>0){y=aa(aa(Na,z)|0,Na)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Na,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;Sa=k[Ea>>2]|0;e=0-Sa|0;if((Sa|0)<(e|0))e=0;else{g=k[Fa>>2]|0;h=k[L>>2]|0;j=k[oa>>2]|0;f=e;e=0;while(1){Ta=g+(aa(k[h>>2]|0,f+F|0)|0)|0;Sa=j+(aa(k[k[wa>>2]>>2]|0,q+f|0)|0)|0;Ra=(l[Ta+(D<<1)>>0]|0)-(l[Sa+(m<<1)>>0]|0)|0;Sa=(l[Ta+(D<<1)+1>>0]|0)-(l[Sa+(m<<1)+1>>0]|0)|0;e=((Ra|0)>-1?Ra:0-Ra|0)+e+((Sa|0)>-1?Sa:0-Sa|0)|0;k[n>>2]=e;if((f|0)<(k[Ea>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Ma>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[ta>>2]|0;if(e|0?(Sa=e+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){f=k[ta>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[sa>>2]|0;if(e|0)break;e=B1()|0;f=k[ta>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ta>>2]=0}k[ta>>2]=0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[la>>2]|0)>0){f=k[ua>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[la>>2]|0))}e=k[wa>>2]|0;if(!((e|0)==(va|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[Ka>>2]|0}while((z|0)<(e|0))}}else{Ta=e+K|0;C=e+I|0;D=k[Ea>>2]|0;h=C+D|0;E=Ta-f|0;C=C-f+D|0;e=k[Fa>>2]|0;f=k[k[L>>2]>>2]|0;g=e+(aa(f,Ta+~D|0)|0)|0;f=e+(aa(f,Ta+D|0)|0)|0;D=k[Ma>>2]|0;e=k[Ka>>2]|0;if((e|0)>0){z=(D|0)>0;A=E+-1|0;B=l[f+(h<<1)>>0]|0;x=l[f+(h<<1)+1>>0]|0;y=l[g+(h<<1)>>0]|0;u=l[g+(h<<1)+1>>0]|0;v=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)|0;w=d+((aa(aa(aa(La,I)|0,Na)|0,Na)|0)<<2)|0;t=0;do{g=k[Aa>>2]|0;k[Oa>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[M>>2]=k[e>>2];k[N>>2]=k[g+(t*56|0)+8>>2];k[O>>2]=k[g+(t*56|0)+12>>2];k[P>>2]=k[g+(t*56|0)+16>>2];k[Q>>2]=k[g+(t*56|0)+20>>2];k[R>>2]=k[g+(t*56|0)+24>>2];k[S>>2]=k[g+(t*56|0)+28>>2];k[T>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[U>>2]=f;k[V>>2]=N;k[X>>2]=W;k[Y>>2]=0;k[W>>2]=0;if(f|0){Ta=f+12|0;k[Ta>>2]=(k[Ta>>2]|0)+1}if((k[e>>2]|0)>=3){k[M>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[M>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[V>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[X>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[M>>2]|0))}}else{Sa=k[g+(t*56|0)+44>>2]|0;Ta=k[X>>2]|0;k[Ta>>2]=k[Sa>>2];k[Ta+4>>2]=k[Sa+4>>2]}m=aa(aa(Na,t)|0,Na)|0;h=b+(m<<2)|0;j=v+(m<<2)|0;m=w+(m<<2)|0;if(z){g=k[P>>2]|0;f=0;do{p=aa(f,Na)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Ea>>2]|0;e=k[k[X>>2]>>2]|0;q=g+(aa(e,A+f-s|0)|0)|0;s=g+(aa(e,f+E+s|0)|0)|0;e=0;do{Sa=o+(e<<2)|0;Ra=n+(e<<2)|0;k[Ra>>2]=(k[Ra>>2]|0)-(k[Sa>>2]|0);Ta=p+(e<<2)|0;Va=C+e|0;Ua=B-(l[s+(Va<<1)>>0]|0)|0;F=x-(l[s+(Va<<1)+1>>0]|0)|0;Wa=y-(l[q+(Va<<1)>>0]|0)|0;Va=u-(l[q+(Va<<1)+1>>0]|0)|0;F=(k[Ta>>2]|0)-((Wa|0)>-1?Wa:0-Wa|0)-((Va|0)>-1?Va:0-Va|0)+((Ua|0)>-1?Ua:0-Ua|0)+((F|0)>-1?F:0-F|0)|0;k[Sa>>2]=F;k[Ra>>2]=F+(k[Ra>>2]|0);k[Ta>>2]=k[Sa>>2];e=e+1|0}while((e|0)!=(D|0));f=f+1|0}while((f|0)!=(D|0))}e=k[U>>2]|0;if(e|0?(Va=e+12|0,Wa=k[Va>>2]|0,k[Va>>2]=Wa+-1,(Wa|0)==1):0){f=k[U>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[T>>2]|0;if(e|0)break;e=B1()|0;f=k[U>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[U>>2]=0}k[U>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[M>>2]|0)>0){f=k[V>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[M>>2]|0))}e=k[X>>2]|0;if(!((e|0)==(W|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[Ka>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ha>>2]|0)|0;B=125}if((B|0)==125){B=0;if((e|0)>0){y=k[Aa>>2]|0;z=k[Ma>>2]|0;A=(z|0)>0;x=0;g=0;j=0;h=0;f=0;do{if(A){t=k[Ba>>2]|0;u=k[y+(x*56|0)+16>>2]|0;v=k[k[y+(x*56|0)+44>>2]>>2]|0;w=b+((aa(aa(Na,x)|0,Na)|0)<<2)|0;q=k[Ca>>2]|0;s=k[Da>>2]|0;p=0;do{n=u+(aa(v,G+p+t|0)|0)|0;o=w+((aa(Na,p)|0)<<2)|0;m=0;do{Wa=k[o+(m<<2)>>2]>>q;Va=k[s+(Wa<<3)>>2]|0;Wa=k[s+(Wa<<3)+4>>2]|0;Ua=H+m+t|0;g=g+(aa(l[n+(Ua<<1)>>0]|0,Va)|0)|0;j=j+(aa(l[n+(Ua<<1)+1>>0]|0,Wa)|0)|0;h=h+Va|0;f=f+Wa|0;m=m+1|0}while((m|0)!=(z|0));p=p+1|0}while((p|0)!=(z|0))}x=x+1|0}while((x|0)!=(e|0));e=j}else{h=0;g=0;f=0;e=0}}Wa=((((h|0)/2|0)+g|0)>>>0)/(h>>>0)|0;Va=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[za>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,K)|0)+(I<<1)|0;Wa=((Va>>>0<256?Va:(Va|0)>0?255:0)&65535)<<8&65535|(Wa>>>0<256?Wa:(Wa|0)>0?255:0)&255;i[e>>0]=Wa;i[e+1>>0]=Wa>>8;I=I+1|0;e=k[Ga>>2]|0}while((I|0)<(e|0))}K=K+1|0}while((K|0)<(Ja|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Qa;return}ggb(b);r=Qa;return}function E2a(a){a=a|0;V1a(a);ggb(a);return}function F2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;Qa=r;r=r+64|0;Oa=Qa;Pa=k[b>>2]|0;Ja=k[b+4>>2]|0;Ka=a+96|0;La=k[Ka>>2]|0;Ma=a+92|0;Na=k[Ma>>2]|0;Ia=aa(aa(Na,La)|0,Na)|0;c=Ia>>>0>1073741823?-1:Ia<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ha=a+88|0;d=aa(aa(aa(La,k[Ha>>2]|0)|0,Na)|0,Na)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ga=a+8|0;f=k[Ga>>2]|0;e=aa(aa(aa(La,f)|0,Na)|0,Na)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Pa|0)<(Ja|0)){ya=a+104|0;za=a+12|0;Aa=a+16|0;Ba=a+84|0;Ca=a+116|0;Da=a+120|0;Ea=a+100|0;Fa=a+44|0;L=a+72|0;M=Oa+4|0;N=Oa+8|0;O=Oa+12|0;P=Oa+16|0;Q=Oa+20|0;R=Oa+24|0;S=Oa+28|0;T=Oa+32|0;U=Oa+36|0;V=Oa+40|0;W=Oa+48|0;X=Oa+44|0;Y=Oa+52|0;Z=Oa+4|0;_=Oa+8|0;$=Oa+12|0;ba=Oa+16|0;ca=Oa+20|0;da=Oa+24|0;ea=Oa+28|0;fa=Oa+32|0;ga=Oa+36|0;ha=Oa+40|0;ia=Oa+48|0;ja=Oa+44|0;ka=Oa+52|0;la=Oa+4|0;ma=Oa+8|0;na=Oa+12|0;oa=Oa+16|0;pa=Oa+20|0;qa=Oa+24|0;ra=Oa+28|0;sa=Oa+32|0;ta=Oa+36|0;ua=Oa+40|0;va=Oa+48|0;wa=Oa+44|0;xa=Oa+52|0;a=-1;K=Pa;e=f;do{if((e|0)>0){J=(K|0)==(Pa|0);I=0;do{f=k[ya>>2]|0;G=K-f|0;H=I-f|0;if(!I)if((k[Ka>>2]|0)>0){D=0;do{f=k[Aa>>2]|0;k[Oa>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[Z>>2]=k[e>>2];k[_>>2]=k[f+(D*56|0)+8>>2];k[$>>2]=k[f+(D*56|0)+12>>2];k[ba>>2]=k[f+(D*56|0)+16>>2];k[ca>>2]=k[f+(D*56|0)+20>>2];k[da>>2]=k[f+(D*56|0)+24>>2];k[ea>>2]=k[f+(D*56|0)+28>>2];k[fa>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ga>>2]=a;k[ha>>2]=_;k[ja>>2]=ia;k[ka>>2]=0;k[ia>>2]=0;if(a|0){F=a+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[e>>2]|0)>=3){k[Z>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[Z>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ha>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ja>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[Z>>2]|0))}}else{E=k[f+(D*56|0)+44>>2]|0;F=k[ja>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2]}e=k[Ma>>2]|0;if((e|0)>0){z=aa(aa(Na,D)|0,Na)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+K|0;u=aa(Na,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ha>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ha>>2]|0}while((a|0)<(e|0))}p=k[ya>>2]|0;o=t-p|0;p=s-p|0;f=k[Ea>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Fa>>2]|0;h=k[L>>2]|0;j=k[ba>>2]|0;while(1){E=k[Ba>>2]|0;Ra=E+a|0;Sa=g+(aa(k[h>>2]|0,f+K+E|0)|0)|0;F=m+E|0;E=j+(aa(k[k[ja>>2]>>2]|0,o+f+E|0)|0)|0;e=(l[Sa+(Ra<<1)>>0]|0)-(l[E+(F<<1)>>0]|0)|0;F=(l[Sa+(Ra<<1)+1>>0]|0)-(l[E+(F<<1)+1>>0]|0)|0;e=((F|0)>-1?F:0-F|0)+((e|0)>-1?e:0-e|0)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Ea>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(Ia<<2)|0}else break}e=k[Ha>>2]|0}e=c+((aa(aa(aa(La,e+-1|0)|0,Na)|0,Na)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Ma>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ga>>2]|0;if(e|0?(Ra=e+12|0,Sa=k[Ra>>2]|0,k[Ra>>2]=Sa+-1,(Sa|0)==1):0){a=k[ga>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[fa>>2]|0;if(e|0)break;e=B1()|0;a=k[ga>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ga>>2]=0}k[ga>>2]=0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[Z>>2]|0)>0){a=k[ha>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Z>>2]|0))}e=k[ja>>2]|0;if(!((e|0)==(ia|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[Ka>>2]|0}while((D|0)<(e|0));a=0;A=125}else{a=0;g=0;f=0;e=0}else{e=k[Ba>>2]|0;if(J){F=e+Pa|0;D=e+I+(k[Ea>>2]|0)|0;E=F-f|0;e=k[Ka>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)|0;C=d+((aa(aa(aa(La,I)|0,Na)|0,Na)|0)<<2)|0;z=0;do{g=k[Aa>>2]|0;k[Oa>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[la>>2]=k[e>>2];k[ma>>2]=k[g+(z*56|0)+8>>2];k[na>>2]=k[g+(z*56|0)+12>>2];k[oa>>2]=k[g+(z*56|0)+16>>2];k[pa>>2]=k[g+(z*56|0)+20>>2];k[qa>>2]=k[g+(z*56|0)+24>>2];k[ra>>2]=k[g+(z*56|0)+28>>2];k[sa>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[ta>>2]=f;k[ua>>2]=ma;k[wa>>2]=va;k[xa>>2]=0;k[va>>2]=0;if(f|0){Sa=f+12|0;k[Sa>>2]=(k[Sa>>2]|0)+1}if((k[e>>2]|0)>=3){k[la>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[la>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[ua>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[wa>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[la>>2]|0))}}else{Ra=k[g+(z*56|0)+44>>2]|0;Sa=k[wa>>2]|0;k[Sa>>2]=k[Ra>>2];k[Sa+4>>2]=k[Ra+4>>2]}e=k[Ma>>2]|0;if((e|0)>0){y=aa(aa(Na,z)|0,Na)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Na,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;Sa=k[Ea>>2]|0;e=0-Sa|0;if((Sa|0)<(e|0))e=0;else{g=k[Fa>>2]|0;h=k[L>>2]|0;j=k[oa>>2]|0;f=e;e=0;while(1){Ta=g+(aa(k[h>>2]|0,f+F|0)|0)|0;Sa=j+(aa(k[k[wa>>2]>>2]|0,q+f|0)|0)|0;Ra=(l[Ta+(D<<1)>>0]|0)-(l[Sa+(m<<1)>>0]|0)|0;Sa=(l[Ta+(D<<1)+1>>0]|0)-(l[Sa+(m<<1)+1>>0]|0)|0;e=((Ra|0)>-1?Ra:0-Ra|0)+e+((Sa|0)>-1?Sa:0-Sa|0)|0;k[n>>2]=e;if((f|0)<(k[Ea>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Ma>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[ta>>2]|0;if(e|0?(Sa=e+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){f=k[ta>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[sa>>2]|0;if(e|0)break;e=B1()|0;f=k[ta>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ta>>2]=0}k[ta>>2]=0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[la>>2]|0)>0){f=k[ua>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[la>>2]|0))}e=k[wa>>2]|0;if(!((e|0)==(va|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[Ka>>2]|0}while((z|0)<(e|0))}}else{Ta=e+K|0;C=e+I|0;D=k[Ea>>2]|0;h=C+D|0;E=Ta-f|0;C=C-f+D|0;e=k[Fa>>2]|0;f=k[k[L>>2]>>2]|0;g=e+(aa(f,Ta+~D|0)|0)|0;f=e+(aa(f,Ta+D|0)|0)|0;D=k[Ma>>2]|0;e=k[Ka>>2]|0;if((e|0)>0){z=(D|0)>0;A=E+-1|0;B=l[f+(h<<1)>>0]|0;x=l[f+(h<<1)+1>>0]|0;y=l[g+(h<<1)>>0]|0;u=l[g+(h<<1)+1>>0]|0;v=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)|0;w=d+((aa(aa(aa(La,I)|0,Na)|0,Na)|0)<<2)|0;t=0;do{g=k[Aa>>2]|0;k[Oa>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[M>>2]=k[e>>2];k[N>>2]=k[g+(t*56|0)+8>>2];k[O>>2]=k[g+(t*56|0)+12>>2];k[P>>2]=k[g+(t*56|0)+16>>2];k[Q>>2]=k[g+(t*56|0)+20>>2];k[R>>2]=k[g+(t*56|0)+24>>2];k[S>>2]=k[g+(t*56|0)+28>>2];k[T>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[U>>2]=f;k[V>>2]=N;k[X>>2]=W;k[Y>>2]=0;k[W>>2]=0;if(f|0){Ta=f+12|0;k[Ta>>2]=(k[Ta>>2]|0)+1}if((k[e>>2]|0)>=3){k[M>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[M>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[V>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[X>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[M>>2]|0))}}else{Sa=k[g+(t*56|0)+44>>2]|0;Ta=k[X>>2]|0;k[Ta>>2]=k[Sa>>2];k[Ta+4>>2]=k[Sa+4>>2]}m=aa(aa(Na,t)|0,Na)|0;h=b+(m<<2)|0;j=v+(m<<2)|0;m=w+(m<<2)|0;if(z){g=k[P>>2]|0;f=0;do{p=aa(f,Na)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Ea>>2]|0;e=k[k[X>>2]>>2]|0;q=g+(aa(e,A+f-s|0)|0)|0;s=g+(aa(e,f+E+s|0)|0)|0;e=0;do{Sa=o+(e<<2)|0;Ra=n+(e<<2)|0;k[Ra>>2]=(k[Ra>>2]|0)-(k[Sa>>2]|0);Ta=p+(e<<2)|0;Va=C+e|0;Ua=B-(l[s+(Va<<1)>>0]|0)|0;F=x-(l[s+(Va<<1)+1>>0]|0)|0;Wa=y-(l[q+(Va<<1)>>0]|0)|0;Va=u-(l[q+(Va<<1)+1>>0]|0)|0;F=(k[Ta>>2]|0)-((Wa|0)>-1?Wa:0-Wa|0)-((Va|0)>-1?Va:0-Va|0)+((Ua|0)>-1?Ua:0-Ua|0)+((F|0)>-1?F:0-F|0)|0;k[Sa>>2]=F;k[Ra>>2]=F+(k[Ra>>2]|0);k[Ta>>2]=k[Sa>>2];e=e+1|0}while((e|0)!=(D|0));f=f+1|0}while((f|0)!=(D|0))}e=k[U>>2]|0;if(e|0?(Va=e+12|0,Wa=k[Va>>2]|0,k[Va>>2]=Wa+-1,(Wa|0)==1):0){f=k[U>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[T>>2]|0;if(e|0)break;e=B1()|0;f=k[U>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[U>>2]=0}k[U>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[M>>2]|0)>0){f=k[V>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[M>>2]|0))}e=k[X>>2]|0;if(!((e|0)==(W|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[Ka>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ha>>2]|0)|0;A=125}if((A|0)==125){A=0;if((e|0)>0){x=k[Aa>>2]|0;y=k[Ma>>2]|0;z=(y|0)>0;w=0;f=0;h=0;g=0;do{if(z){s=k[Ba>>2]|0;t=k[x+(w*56|0)+16>>2]|0;u=k[k[x+(w*56|0)+44>>2]>>2]|0;v=b+((aa(aa(Na,w)|0,Na)|0)<<2)|0;p=k[Ca>>2]|0;q=k[Da>>2]|0;o=0;do{m=t+(aa(u,G+o+s|0)|0)|0;n=v+((aa(Na,o)|0)<<2)|0;j=0;do{Wa=k[q+(k[n+(j<<2)>>2]>>p<<2)>>2]|0;Va=H+j+s|0;f=f+(aa(l[m+(Va<<1)>>0]|0,Wa)|0)|0;h=h+(aa(l[m+(Va<<1)+1>>0]|0,Wa)|0)|0;g=Wa+g|0;j=j+1|0}while((j|0)!=(y|0));o=o+1|0}while((o|0)!=(y|0))}w=w+1|0}while((w|0)!=(e|0));e=h}else{g=0;f=0;e=0}}Va=(g|0)/2|0;Wa=((f+Va|0)>>>0)/(g>>>0)|0;Va=((e+Va|0)>>>0)/(g>>>0)|0;e=k[za>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,K)|0)+(I<<1)|0;Wa=((Va>>>0<256?Va:(Va|0)>0?255:0)&65535)<<8&65535|(Wa>>>0<256?Wa:(Wa|0)>0?255:0)&255;i[e>>0]=Wa;i[e+1>>0]=Wa>>8;I=I+1|0;e=k[Ga>>2]|0}while((I|0)<(e|0))}K=K+1|0}while((K|0)<(Ja|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Qa;return}ggb(b);r=Qa;return}function G2a(a){a=a|0;U1a(a);ggb(a);return}function H2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0;Sa=r;r=r+64|0;Oa=Sa;Pa=k[b>>2]|0;Ja=k[b+4>>2]|0;Ka=a+96|0;La=k[Ka>>2]|0;Ma=a+92|0;Na=k[Ma>>2]|0;Ia=aa(aa(Na,La)|0,Na)|0;c=Ia>>>0>1073741823?-1:Ia<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ha=a+88|0;d=aa(aa(aa(La,k[Ha>>2]|0)|0,Na)|0,Na)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ga=a+8|0;f=k[Ga>>2]|0;e=aa(aa(aa(La,f)|0,Na)|0,Na)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Pa|0)<(Ja|0)){ya=a+104|0;za=a+16|0;Aa=a+84|0;Ba=a+116|0;Ca=a+120|0;Da=a+12|0;Ea=a+100|0;Fa=a+44|0;L=a+72|0;M=Oa+4|0;N=Oa+8|0;O=Oa+12|0;P=Oa+16|0;Q=Oa+20|0;R=Oa+24|0;S=Oa+28|0;T=Oa+32|0;U=Oa+36|0;V=Oa+40|0;W=Oa+48|0;X=Oa+44|0;Y=Oa+52|0;Z=Oa+4|0;_=Oa+8|0;$=Oa+12|0;ba=Oa+16|0;ca=Oa+20|0;da=Oa+24|0;ea=Oa+28|0;fa=Oa+32|0;ga=Oa+36|0;ha=Oa+40|0;ia=Oa+48|0;ja=Oa+44|0;ka=Oa+52|0;la=Oa+4|0;ma=Oa+8|0;na=Oa+12|0;oa=Oa+16|0;pa=Oa+20|0;qa=Oa+24|0;ra=Oa+28|0;sa=Oa+32|0;ta=Oa+36|0;ua=Oa+40|0;va=Oa+48|0;wa=Oa+44|0;xa=Oa+52|0;a=-1;K=Pa;e=f;do{if((e|0)>0){J=(K|0)==(Pa|0);I=0;do{f=k[ya>>2]|0;G=K-f|0;H=I-f|0;if(!I)if((k[Ka>>2]|0)>0){D=0;do{f=k[za>>2]|0;k[Oa>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[Z>>2]=k[e>>2];k[_>>2]=k[f+(D*56|0)+8>>2];k[$>>2]=k[f+(D*56|0)+12>>2];k[ba>>2]=k[f+(D*56|0)+16>>2];k[ca>>2]=k[f+(D*56|0)+20>>2];k[da>>2]=k[f+(D*56|0)+24>>2];k[ea>>2]=k[f+(D*56|0)+28>>2];k[fa>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ga>>2]=a;k[ha>>2]=_;k[ja>>2]=ia;k[ka>>2]=0;k[ia>>2]=0;if(a|0){F=a+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[e>>2]|0)>=3){k[Z>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[Z>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ha>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ja>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[Z>>2]|0))}}else{E=k[f+(D*56|0)+44>>2]|0;F=k[ja>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2]}e=k[Ma>>2]|0;if((e|0)>0){z=aa(aa(Na,D)|0,Na)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+K|0;u=aa(Na,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ha>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ha>>2]|0}while((a|0)<(e|0))}p=k[ya>>2]|0;o=t-p|0;p=s-p|0;f=k[Ea>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Fa>>2]|0;h=k[L>>2]|0;j=k[ba>>2]|0;while(1){e=k[Aa>>2]|0;F=g+(aa(k[h>>2]|0,f+K+e|0)|0)+(e+a)|0;e=j+(aa(k[k[ja>>2]>>2]|0,o+f+e|0)|0)+(m+e)|0;e=(l[F>>0]|0)-(l[e>>0]|0)|0;e=(e|0)>-1?e:0-e|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Ea>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(Ia<<2)|0}else break}e=k[Ha>>2]|0}e=c+((aa(aa(aa(La,e+-1|0)|0,Na)|0,Na)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Ma>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ga>>2]|0;if(e|0?(E=e+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){a=k[ga>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[fa>>2]|0;if(e|0)break;e=B1()|0;a=k[ga>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ga>>2]=0}k[ga>>2]=0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[Z>>2]|0)>0){a=k[ha>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Z>>2]|0))}e=k[ja>>2]|0;if(!((e|0)==(ia|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[Ka>>2]|0}while((D|0)<(e|0));a=0;s=e;w=125}else{a=0;f=0;e=0}else{e=k[Aa>>2]|0;if(J){F=e+Pa|0;D=e+I+(k[Ea>>2]|0)|0;E=F-f|0;e=k[Ka>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)|0;C=d+((aa(aa(aa(La,I)|0,Na)|0,Na)|0)<<2)|0;z=0;do{g=k[za>>2]|0;k[Oa>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[la>>2]=k[e>>2];k[ma>>2]=k[g+(z*56|0)+8>>2];k[na>>2]=k[g+(z*56|0)+12>>2];k[oa>>2]=k[g+(z*56|0)+16>>2];k[pa>>2]=k[g+(z*56|0)+20>>2];k[qa>>2]=k[g+(z*56|0)+24>>2];k[ra>>2]=k[g+(z*56|0)+28>>2];k[sa>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[ta>>2]=f;k[ua>>2]=ma;k[wa>>2]=va;k[xa>>2]=0;k[va>>2]=0;if(f|0){y=f+12|0;k[y>>2]=(k[y>>2]|0)+1}if((k[e>>2]|0)>=3){k[la>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[la>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[ua>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[wa>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[la>>2]|0))}}else{x=k[g+(z*56|0)+44>>2]|0;y=k[wa>>2]|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2]}e=k[Ma>>2]|0;if((e|0)>0){y=aa(aa(Na,z)|0,Na)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Na,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;j=k[Ea>>2]|0;e=0-j|0;if((j|0)<(e|0))e=0;else{g=k[Fa>>2]|0;h=k[L>>2]|0;j=k[oa>>2]|0;f=e;e=0;while(1){Ua=g+(aa(k[h>>2]|0,f+F|0)|0)+D|0;Ta=j+(aa(k[k[wa>>2]>>2]|0,q+f|0)|0)+m|0;Ta=(l[Ua>>0]|0)-(l[Ta>>0]|0)|0;e=((Ta|0)>-1?Ta:0-Ta|0)+e|0;k[n>>2]=e;if((f|0)<(k[Ea>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Ma>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[ta>>2]|0;if(e|0?(Ta=e+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){f=k[ta>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[sa>>2]|0;if(e|0)break;e=B1()|0;f=k[ta>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ta>>2]=0}k[ta>>2]=0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[la>>2]|0)>0){f=k[ua>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[la>>2]|0))}e=k[wa>>2]|0;if(!((e|0)==(va|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[Ka>>2]|0}while((z|0)<(e|0))}}else{m=e+K|0;A=e+I|0;h=k[Ea>>2]|0;j=A+h|0;C=m-f|0;A=A-f+h|0;f=k[Fa>>2]|0;g=k[k[L>>2]>>2]|0;B=k[Ma>>2]|0;e=k[Ka>>2]|0;if((e|0)>0){w=f+(aa(g,m+h|0)|0)+j|0;x=f+(aa(g,m+~h|0)|0)+j|0;u=(B|0)>0;v=C+-1|0;w=l[w>>0]|0;x=l[x>>0]|0;y=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)|0;z=d+((aa(aa(aa(La,I)|0,Na)|0,Na)|0)<<2)|0;t=0;do{g=k[za>>2]|0;k[Oa>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[M>>2]=k[e>>2];k[N>>2]=k[g+(t*56|0)+8>>2];k[O>>2]=k[g+(t*56|0)+12>>2];k[P>>2]=k[g+(t*56|0)+16>>2];k[Q>>2]=k[g+(t*56|0)+20>>2];k[R>>2]=k[g+(t*56|0)+24>>2];k[S>>2]=k[g+(t*56|0)+28>>2];k[T>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[U>>2]=f;k[V>>2]=N;k[X>>2]=W;k[Y>>2]=0;k[W>>2]=0;if(f|0){Ua=f+12|0;k[Ua>>2]=(k[Ua>>2]|0)+1}if((k[e>>2]|0)>=3){k[M>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[M>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[V>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[X>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[M>>2]|0))}}else{Ta=k[g+(t*56|0)+44>>2]|0;Ua=k[X>>2]|0;k[Ua>>2]=k[Ta>>2];k[Ua+4>>2]=k[Ta+4>>2]}m=aa(aa(Na,t)|0,Na)|0;h=b+(m<<2)|0;j=y+(m<<2)|0;m=z+(m<<2)|0;if(u){g=k[P>>2]|0;f=0;do{p=aa(f,Na)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Ea>>2]|0;e=k[k[X>>2]>>2]|0;q=g+(aa(e,v+f-s|0)|0)|0;s=g+(aa(e,f+C+s|0)|0)|0;e=0;do{Ta=o+(e<<2)|0;F=n+(e<<2)|0;k[F>>2]=(k[F>>2]|0)-(k[Ta>>2]|0);Ua=p+(e<<2)|0;E=A+e|0;D=w-(l[s+E>>0]|0)|0;E=x-(l[q+E>>0]|0)|0;E=((D|0)>-1?D:0-D|0)-((E|0)>-1?E:0-E|0)+(k[Ua>>2]|0)|0;k[Ta>>2]=E;k[F>>2]=E+(k[F>>2]|0);k[Ua>>2]=k[Ta>>2];e=e+1|0}while((e|0)!=(B|0));f=f+1|0}while((f|0)!=(B|0))}e=k[U>>2]|0;if(e|0?(Ta=e+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){f=k[U>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[T>>2]|0;if(e|0)break;e=B1()|0;f=k[U>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[U>>2]=0}k[U>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[M>>2]|0)>0){f=k[V>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[M>>2]|0))}e=k[X>>2]|0;if(!((e|0)==(W|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[Ka>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ha>>2]|0)|0;s=e;w=125}if((w|0)==125){w=0;if((s|0)>0?(Qa=k[za>>2]|0,Ra=k[Ma>>2]|0,(Ra|0)>0):0){o=k[Aa>>2]|0;p=k[Ba>>2]|0;q=k[Ca>>2]|0;n=0;f=0;e=0;do{t=k[Qa+(n*56|0)+16>>2]|0;u=k[k[Qa+(n*56|0)+44>>2]>>2]|0;v=b+((aa(aa(Na,n)|0,Na)|0)<<2)|0;m=0;do{h=t+(aa(u,G+m+o|0)|0)|0;j=v+((aa(Na,m)|0)<<2)|0;g=0;do{Ua=k[q+(k[j+(g<<2)>>2]>>p<<2)>>2]|0;e=(aa(l[h+(H+g+o)>>0]|0,Ua)|0)+e|0;f=Ua+f|0;g=g+1|0}while((g|0)!=(Ra|0));m=m+1|0}while((m|0)!=(Ra|0));n=n+1|0}while((n|0)!=(s|0))}else{f=0;e=0}}Ua=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[Da>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,K)|0)+I|0;i[e>>0]=Ua>>>0<256?Ua:(Ua|0)>0?255:0;I=I+1|0;e=k[Ga>>2]|0}while((I|0)<(e|0))}K=K+1|0}while((K|0)<(Ja|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Sa;return}ggb(b);r=Sa;return}function I2a(a){a=a|0;T1a(a);ggb(a);return}function J2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0;Ta=r;r=r+64|0;Ra=Ta;Sa=k[b>>2]|0;Ma=k[b+4>>2]|0;Na=a+96|0;Oa=k[Na>>2]|0;Pa=a+92|0;Qa=k[Pa>>2]|0;La=aa(aa(Qa,Oa)|0,Qa)|0;c=La>>>0>1073741823?-1:La<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ka=a+88|0;d=aa(aa(aa(Oa,k[Ka>>2]|0)|0,Qa)|0,Qa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ja=a+8|0;f=k[Ja>>2]|0;e=aa(aa(aa(Oa,f)|0,Qa)|0,Qa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Sa|0)<(Ma|0)){Ba=a+104|0;Ca=a+12|0;Da=a+16|0;Ea=a+84|0;Fa=a+116|0;Ga=a+120|0;Ha=a+100|0;Ia=a+44|0;O=a+72|0;P=Ra+4|0;Q=Ra+8|0;R=Ra+12|0;S=Ra+16|0;T=Ra+20|0;U=Ra+24|0;V=Ra+28|0;W=Ra+32|0;X=Ra+36|0;Y=Ra+40|0;Z=Ra+48|0;_=Ra+44|0;$=Ra+52|0;ba=Ra+4|0;ca=Ra+8|0;da=Ra+12|0;ea=Ra+16|0;fa=Ra+20|0;ga=Ra+24|0;ha=Ra+28|0;ia=Ra+32|0;ja=Ra+36|0;ka=Ra+40|0;la=Ra+48|0;ma=Ra+44|0;na=Ra+52|0;oa=Ra+4|0;pa=Ra+8|0;qa=Ra+12|0;ra=Ra+16|0;sa=Ra+20|0;ta=Ra+24|0;ua=Ra+28|0;va=Ra+32|0;wa=Ra+36|0;xa=Ra+40|0;ya=Ra+48|0;za=Ra+44|0;Aa=Ra+52|0;a=-1;N=Sa;e=f;do{if((e|0)>0){M=(N|0)==(Sa|0);L=0;do{f=k[Ba>>2]|0;J=N-f|0;K=L-f|0;if(!L)if((k[Na>>2]|0)>0){D=0;do{f=k[Da>>2]|0;k[Ra>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[ba>>2]=k[e>>2];k[ca>>2]=k[f+(D*56|0)+8>>2];k[da>>2]=k[f+(D*56|0)+12>>2];k[ea>>2]=k[f+(D*56|0)+16>>2];k[fa>>2]=k[f+(D*56|0)+20>>2];k[ga>>2]=k[f+(D*56|0)+24>>2];k[ha>>2]=k[f+(D*56|0)+28>>2];k[ia>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ja>>2]=a;k[ka>>2]=ca;k[ma>>2]=la;k[na>>2]=0;k[la>>2]=0;if(a|0){I=a+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[e>>2]|0)>=3){k[ba>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[ba>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ka>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ma>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ba>>2]|0))}}else{H=k[f+(D*56|0)+44>>2]|0;I=k[ma>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2]}e=k[Pa>>2]|0;if((e|0)>0){z=aa(aa(Qa,D)|0,Qa)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+N|0;u=aa(Qa,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ka>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ka>>2]|0}while((a|0)<(e|0))}p=k[Ba>>2]|0;o=t-p|0;p=s-p|0;f=k[Ha>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Ia>>2]|0;h=k[O>>2]|0;j=k[ea>>2]|0;while(1){F=k[Ea>>2]|0;E=F+a|0;Ua=g+(aa(k[h>>2]|0,f+N+F|0)|0)|0;e=m+F|0;F=j+(aa(k[k[ma>>2]>>2]|0,o+f+F|0)|0)|0;H=(l[Ua+(E<<2)>>0]|0)-(l[F+(e<<2)>>0]|0)|0;G=(l[Ua+(E<<2)+1>>0]|0)-(l[F+(e<<2)+1>>0]|0)|0;I=(l[Ua+(E<<2)+2>>0]|0)-(l[F+(e<<2)+2>>0]|0)|0;e=(l[Ua+(E<<2)+3>>0]|0)-(l[F+(e<<2)+3>>0]|0)|0;e=(aa(G,G)|0)+(aa(H,H)|0)+(aa(I,I)|0)+(aa(e,e)|0)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Ha>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(La<<2)|0}else break}e=k[Ka>>2]|0}e=c+((aa(aa(aa(Oa,e+-1|0)|0,Qa)|0,Qa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Pa>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ja>>2]|0;if(e|0?(I=e+12|0,Ua=k[I>>2]|0,k[I>>2]=Ua+-1,(Ua|0)==1):0){a=k[ja>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ia>>2]|0;if(e|0)break;e=B1()|0;a=k[ja>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ja>>2]=0}k[ja>>2]=0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[ba>>2]|0)>0){a=k[ka>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ba>>2]|0))}e=k[ma>>2]|0;if(!((e|0)==(la|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[Na>>2]|0}while((D|0)<(e|0));a=0;F=125}else{a=0;o=0;n=0;m=0;j=0;h=0;g=0;f=0;e=0}else{e=k[Ea>>2]|0;if(M){F=e+Sa|0;D=e+L+(k[Ha>>2]|0)|0;E=F-f|0;e=k[Na>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)|0;C=d+((aa(aa(aa(Oa,L)|0,Qa)|0,Qa)|0)<<2)|0;z=0;do{g=k[Da>>2]|0;k[Ra>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[oa>>2]=k[e>>2];k[pa>>2]=k[g+(z*56|0)+8>>2];k[qa>>2]=k[g+(z*56|0)+12>>2];k[ra>>2]=k[g+(z*56|0)+16>>2];k[sa>>2]=k[g+(z*56|0)+20>>2];k[ta>>2]=k[g+(z*56|0)+24>>2];k[ua>>2]=k[g+(z*56|0)+28>>2];k[va>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[wa>>2]=f;k[xa>>2]=pa;k[za>>2]=ya;k[Aa>>2]=0;k[ya>>2]=0;if(f|0){Ua=f+12|0;k[Ua>>2]=(k[Ua>>2]|0)+1}if((k[e>>2]|0)>=3){k[oa>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[oa>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[xa>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[za>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[oa>>2]|0))}}else{I=k[g+(z*56|0)+44>>2]|0;Ua=k[za>>2]|0;k[Ua>>2]=k[I>>2];k[Ua+4>>2]=k[I+4>>2]}e=k[Pa>>2]|0;if((e|0)>0){y=aa(aa(Qa,z)|0,Qa)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Qa,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;Ua=k[Ha>>2]|0;e=0-Ua|0;if((Ua|0)<(e|0))e=0;else{g=k[Ia>>2]|0;h=k[O>>2]|0;j=k[ra>>2]|0;f=e;e=0;while(1){Va=g+(aa(k[h>>2]|0,f+F|0)|0)|0;Ua=j+(aa(k[k[za>>2]>>2]|0,q+f|0)|0)|0;H=(l[Va+(D<<2)>>0]|0)-(l[Ua+(m<<2)>>0]|0)|0;G=(l[Va+(D<<2)+1>>0]|0)-(l[Ua+(m<<2)+1>>0]|0)|0;I=(l[Va+(D<<2)+2>>0]|0)-(l[Ua+(m<<2)+2>>0]|0)|0;Ua=(l[Va+(D<<2)+3>>0]|0)-(l[Ua+(m<<2)+3>>0]|0)|0;e=(aa(G,G)|0)+(aa(H,H)|0)+e+(aa(I,I)|0)+(aa(Ua,Ua)|0)|0;k[n>>2]=e;if((f|0)<(k[Ha>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Pa>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[wa>>2]|0;if(e|0?(Ua=e+12|0,Va=k[Ua>>2]|0,k[Ua>>2]=Va+-1,(Va|0)==1):0){f=k[wa>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[va>>2]|0;if(e|0)break;e=B1()|0;f=k[wa>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[wa>>2]=0}k[wa>>2]=0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[oa>>2]|0)>0){f=k[xa>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[oa>>2]|0))}e=k[za>>2]|0;if(!((e|0)==(ya|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[Na>>2]|0}while((z|0)<(e|0))}}else{Va=e+N|0;G=e+L|0;H=k[Ha>>2]|0;h=G+H|0;I=Va-f|0;G=G-f+H|0;e=k[Ia>>2]|0;f=k[k[O>>2]>>2]|0;g=e+(aa(f,Va+~H|0)|0)|0;f=e+(aa(f,Va+H|0)|0)|0;H=k[Pa>>2]|0;e=k[Na>>2]|0;if((e|0)>0){B=(H|0)>0;C=I+-1|0;D=l[f+(h<<2)>>0]|0;E=l[f+(h<<2)+1>>0]|0;F=l[f+(h<<2)+2>>0]|0;x=l[f+(h<<2)+3>>0]|0;y=l[g+(h<<2)>>0]|0;z=l[g+(h<<2)+1>>0]|0;A=l[g+(h<<2)+2>>0]|0;u=l[g+(h<<2)+3>>0]|0;v=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)|0;w=d+((aa(aa(aa(Oa,L)|0,Qa)|0,Qa)|0)<<2)|0;t=0;do{g=k[Da>>2]|0;k[Ra>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[P>>2]=k[e>>2];k[Q>>2]=k[g+(t*56|0)+8>>2];k[R>>2]=k[g+(t*56|0)+12>>2];k[S>>2]=k[g+(t*56|0)+16>>2];k[T>>2]=k[g+(t*56|0)+20>>2];k[U>>2]=k[g+(t*56|0)+24>>2];k[V>>2]=k[g+(t*56|0)+28>>2];k[W>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[X>>2]=f;k[Y>>2]=Q;k[_>>2]=Z;k[$>>2]=0;k[Z>>2]=0;if(f|0){Va=f+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[e>>2]|0)>=3){k[P>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[P>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[Y>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[_>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[P>>2]|0))}}else{Ua=k[g+(t*56|0)+44>>2]|0;Va=k[_>>2]|0;k[Va>>2]=k[Ua>>2];k[Va+4>>2]=k[Ua+4>>2]}m=aa(aa(Qa,t)|0,Qa)|0;h=b+(m<<2)|0;j=v+(m<<2)|0;m=w+(m<<2)|0;if(B){g=k[S>>2]|0;f=0;do{p=aa(f,Qa)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Ha>>2]|0;e=k[k[_>>2]>>2]|0;q=g+(aa(e,C+f-s|0)|0)|0;s=g+(aa(e,f+I+s|0)|0)|0;e=0;do{Ua=o+(e<<2)|0;Wa=n+(e<<2)|0;k[Wa>>2]=(k[Wa>>2]|0)-(k[Ua>>2]|0);Va=p+(e<<2)|0;Xa=G+e|0;cb=D-(l[s+(Xa<<2)>>0]|0)|0;bb=E-(l[s+(Xa<<2)+1>>0]|0)|0;ab=F-(l[s+(Xa<<2)+2>>0]|0)|0;$a=x-(l[s+(Xa<<2)+3>>0]|0)|0;Za=y-(l[q+(Xa<<2)>>0]|0)|0;_a=z-(l[q+(Xa<<2)+1>>0]|0)|0;Ya=A-(l[q+(Xa<<2)+2>>0]|0)|0;Xa=u-(l[q+(Xa<<2)+3>>0]|0)|0;Xa=(aa(cb,cb)|0)+(k[Va>>2]|0)+(aa(bb,bb)|0)+(aa(ab,ab)|0)+(aa($a,$a)|0)-((aa(_a,_a)|0)+(aa(Za,Za)|0)+(aa(Ya,Ya)|0)+(aa(Xa,Xa)|0))|0;k[Ua>>2]=Xa;k[Wa>>2]=Xa+(k[Wa>>2]|0);k[Va>>2]=k[Ua>>2];e=e+1|0}while((e|0)!=(H|0));f=f+1|0}while((f|0)!=(H|0))}e=k[X>>2]|0;if(e|0?(bb=e+12|0,cb=k[bb>>2]|0,k[bb>>2]=cb+-1,(cb|0)==1):0){f=k[X>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[W>>2]|0;if(e|0)break;e=B1()|0;f=k[X>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[X>>2]=0}k[X>>2]=0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[P>>2]|0)>0){f=k[Y>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[P>>2]|0))}e=k[_>>2]|0;if(!((e|0)==(Z|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[Na>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ka>>2]|0)|0;F=125}if((F|0)==125){F=0;if((e|0)>0){C=k[Da>>2]|0;D=k[Pa>>2]|0;E=(D|0)>0;B=0;n=0;j=0;g=0;p=0;o=0;m=0;h=0;f=0;do{if(E){x=k[Ea>>2]|0;y=k[C+(B*56|0)+16>>2]|0;z=k[k[C+(B*56|0)+44>>2]>>2]|0;A=b+((aa(aa(Qa,B)|0,Qa)|0)<<2)|0;v=k[Fa>>2]|0;w=k[Ga>>2]|0;u=0;do{s=y+(aa(z,J+u+x|0)|0)|0;t=A+((aa(Qa,u)|0)<<2)|0;q=0;do{cb=k[t+(q<<2)>>2]>>v;$a=k[w+(cb<<4)>>2]|0;ab=k[w+(cb<<4)+4>>2]|0;bb=k[w+(cb<<4)+8>>2]|0;cb=k[w+(cb<<4)+12>>2]|0;_a=K+q+x|0;n=n+(aa(l[s+(_a<<2)>>0]|0,$a)|0)|0;j=j+(aa(l[s+(_a<<2)+1>>0]|0,ab)|0)|0;g=g+(aa(l[s+(_a<<2)+2>>0]|0,bb)|0)|0;p=p+(aa(l[s+(_a<<2)+3>>0]|0,cb)|0)|0;o=o+$a|0;m=m+ab|0;h=h+bb|0;f=f+cb|0;q=q+1|0}while((q|0)!=(D|0));u=u+1|0}while((u|0)!=(D|0))}B=B+1|0}while((B|0)!=(e|0));e=p}else{o=0;n=0;m=0;j=0;h=0;g=0;f=0;e=0}}$a=((((o|0)/2|0)+n|0)>>>0)/(o>>>0)|0;bb=((((m|0)/2|0)+j|0)>>>0)/(m>>>0)|0;cb=((((h|0)/2|0)+g|0)>>>0)/(h>>>0)|0;ab=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[Ca>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,N)|0)+(L<<2)|0;cb=($a>>>0<256?$a:($a|0)>0?255:0)&255|(ab>>>0<256?ab:(ab|0)>0?255:0)<<24|(bb>>>0<256?bb:(bb|0)>0?255:0)<<8&65280|(cb>>>0<256?cb:(cb|0)>0?255:0)<<16&16711680;i[e>>0]=cb;i[e+1>>0]=cb>>8;i[e+2>>0]=cb>>16;i[e+3>>0]=cb>>24;L=L+1|0;e=k[Ja>>2]|0}while((L|0)<(e|0))}N=N+1|0}while((N|0)<(Ma|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Ta;return}ggb(b);r=Ta;return}function K2a(a){a=a|0;S1a(a);ggb(a);return}function L2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0;Ta=r;r=r+64|0;Ra=Ta;Sa=k[b>>2]|0;Ma=k[b+4>>2]|0;Na=a+96|0;Oa=k[Na>>2]|0;Pa=a+92|0;Qa=k[Pa>>2]|0;La=aa(aa(Qa,Oa)|0,Qa)|0;c=La>>>0>1073741823?-1:La<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ka=a+88|0;d=aa(aa(aa(Oa,k[Ka>>2]|0)|0,Qa)|0,Qa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ja=a+8|0;f=k[Ja>>2]|0;e=aa(aa(aa(Oa,f)|0,Qa)|0,Qa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Sa|0)<(Ma|0)){Ba=a+104|0;Ca=a+12|0;Da=a+16|0;Ea=a+84|0;Fa=a+116|0;Ga=a+120|0;Ha=a+100|0;Ia=a+44|0;O=a+72|0;P=Ra+4|0;Q=Ra+8|0;R=Ra+12|0;S=Ra+16|0;T=Ra+20|0;U=Ra+24|0;V=Ra+28|0;W=Ra+32|0;X=Ra+36|0;Y=Ra+40|0;Z=Ra+48|0;_=Ra+44|0;$=Ra+52|0;ba=Ra+4|0;ca=Ra+8|0;da=Ra+12|0;ea=Ra+16|0;fa=Ra+20|0;ga=Ra+24|0;ha=Ra+28|0;ia=Ra+32|0;ja=Ra+36|0;ka=Ra+40|0;la=Ra+48|0;ma=Ra+44|0;na=Ra+52|0;oa=Ra+4|0;pa=Ra+8|0;qa=Ra+12|0;ra=Ra+16|0;sa=Ra+20|0;ta=Ra+24|0;ua=Ra+28|0;va=Ra+32|0;wa=Ra+36|0;xa=Ra+40|0;ya=Ra+48|0;za=Ra+44|0;Aa=Ra+52|0;a=-1;N=Sa;e=f;do{if((e|0)>0){M=(N|0)==(Sa|0);L=0;do{f=k[Ba>>2]|0;J=N-f|0;K=L-f|0;if(!L)if((k[Na>>2]|0)>0){D=0;do{f=k[Da>>2]|0;k[Ra>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[ba>>2]=k[e>>2];k[ca>>2]=k[f+(D*56|0)+8>>2];k[da>>2]=k[f+(D*56|0)+12>>2];k[ea>>2]=k[f+(D*56|0)+16>>2];k[fa>>2]=k[f+(D*56|0)+20>>2];k[ga>>2]=k[f+(D*56|0)+24>>2];k[ha>>2]=k[f+(D*56|0)+28>>2];k[ia>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ja>>2]=a;k[ka>>2]=ca;k[ma>>2]=la;k[na>>2]=0;k[la>>2]=0;if(a|0){I=a+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[e>>2]|0)>=3){k[ba>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[ba>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ka>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ma>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ba>>2]|0))}}else{H=k[f+(D*56|0)+44>>2]|0;I=k[ma>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2]}e=k[Pa>>2]|0;if((e|0)>0){z=aa(aa(Qa,D)|0,Qa)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+N|0;u=aa(Qa,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ka>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ka>>2]|0}while((a|0)<(e|0))}p=k[Ba>>2]|0;o=t-p|0;p=s-p|0;f=k[Ha>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Ia>>2]|0;h=k[O>>2]|0;j=k[ea>>2]|0;while(1){F=k[Ea>>2]|0;E=F+a|0;Ua=g+(aa(k[h>>2]|0,f+N+F|0)|0)|0;e=m+F|0;F=j+(aa(k[k[ma>>2]>>2]|0,o+f+F|0)|0)|0;H=(l[Ua+(E<<2)>>0]|0)-(l[F+(e<<2)>>0]|0)|0;G=(l[Ua+(E<<2)+1>>0]|0)-(l[F+(e<<2)+1>>0]|0)|0;I=(l[Ua+(E<<2)+2>>0]|0)-(l[F+(e<<2)+2>>0]|0)|0;e=(l[Ua+(E<<2)+3>>0]|0)-(l[F+(e<<2)+3>>0]|0)|0;e=(aa(G,G)|0)+(aa(H,H)|0)+(aa(I,I)|0)+(aa(e,e)|0)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Ha>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(La<<2)|0}else break}e=k[Ka>>2]|0}e=c+((aa(aa(aa(Oa,e+-1|0)|0,Qa)|0,Qa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Pa>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ja>>2]|0;if(e|0?(I=e+12|0,Ua=k[I>>2]|0,k[I>>2]=Ua+-1,(Ua|0)==1):0){a=k[ja>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ia>>2]|0;if(e|0)break;e=B1()|0;a=k[ja>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ja>>2]=0}k[ja>>2]=0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[ba>>2]|0)>0){a=k[ka>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ba>>2]|0))}e=k[ma>>2]|0;if(!((e|0)==(la|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[Na>>2]|0}while((D|0)<(e|0));a=0;C=125}else{a=0;j=0;h=0;g=0;f=0;e=0}else{e=k[Ea>>2]|0;if(M){F=e+Sa|0;D=e+L+(k[Ha>>2]|0)|0;E=F-f|0;e=k[Na>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)|0;C=d+((aa(aa(aa(Oa,L)|0,Qa)|0,Qa)|0)<<2)|0;z=0;do{g=k[Da>>2]|0;k[Ra>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[oa>>2]=k[e>>2];k[pa>>2]=k[g+(z*56|0)+8>>2];k[qa>>2]=k[g+(z*56|0)+12>>2];k[ra>>2]=k[g+(z*56|0)+16>>2];k[sa>>2]=k[g+(z*56|0)+20>>2];k[ta>>2]=k[g+(z*56|0)+24>>2];k[ua>>2]=k[g+(z*56|0)+28>>2];k[va>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[wa>>2]=f;k[xa>>2]=pa;k[za>>2]=ya;k[Aa>>2]=0;k[ya>>2]=0;if(f|0){Ua=f+12|0;k[Ua>>2]=(k[Ua>>2]|0)+1}if((k[e>>2]|0)>=3){k[oa>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[oa>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[xa>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[za>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[oa>>2]|0))}}else{I=k[g+(z*56|0)+44>>2]|0;Ua=k[za>>2]|0;k[Ua>>2]=k[I>>2];k[Ua+4>>2]=k[I+4>>2]}e=k[Pa>>2]|0;if((e|0)>0){y=aa(aa(Qa,z)|0,Qa)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Qa,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;Ua=k[Ha>>2]|0;e=0-Ua|0;if((Ua|0)<(e|0))e=0;else{g=k[Ia>>2]|0;h=k[O>>2]|0;j=k[ra>>2]|0;f=e;e=0;while(1){Va=g+(aa(k[h>>2]|0,f+F|0)|0)|0;Ua=j+(aa(k[k[za>>2]>>2]|0,q+f|0)|0)|0;H=(l[Va+(D<<2)>>0]|0)-(l[Ua+(m<<2)>>0]|0)|0;G=(l[Va+(D<<2)+1>>0]|0)-(l[Ua+(m<<2)+1>>0]|0)|0;I=(l[Va+(D<<2)+2>>0]|0)-(l[Ua+(m<<2)+2>>0]|0)|0;Ua=(l[Va+(D<<2)+3>>0]|0)-(l[Ua+(m<<2)+3>>0]|0)|0;e=(aa(G,G)|0)+(aa(H,H)|0)+e+(aa(I,I)|0)+(aa(Ua,Ua)|0)|0;k[n>>2]=e;if((f|0)<(k[Ha>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Pa>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[wa>>2]|0;if(e|0?(Ua=e+12|0,Va=k[Ua>>2]|0,k[Ua>>2]=Va+-1,(Va|0)==1):0){f=k[wa>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[va>>2]|0;if(e|0)break;e=B1()|0;f=k[wa>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[wa>>2]=0}k[wa>>2]=0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[oa>>2]|0)>0){f=k[xa>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[oa>>2]|0))}e=k[za>>2]|0;if(!((e|0)==(ya|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[Na>>2]|0}while((z|0)<(e|0))}}else{Va=e+N|0;G=e+L|0;H=k[Ha>>2]|0;h=G+H|0;I=Va-f|0;G=G-f+H|0;e=k[Ia>>2]|0;f=k[k[O>>2]>>2]|0;g=e+(aa(f,Va+~H|0)|0)|0;f=e+(aa(f,Va+H|0)|0)|0;H=k[Pa>>2]|0;e=k[Na>>2]|0;if((e|0)>0){B=(H|0)>0;C=I+-1|0;D=l[f+(h<<2)>>0]|0;E=l[f+(h<<2)+1>>0]|0;F=l[f+(h<<2)+2>>0]|0;x=l[f+(h<<2)+3>>0]|0;y=l[g+(h<<2)>>0]|0;z=l[g+(h<<2)+1>>0]|0;A=l[g+(h<<2)+2>>0]|0;u=l[g+(h<<2)+3>>0]|0;v=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)|0;w=d+((aa(aa(aa(Oa,L)|0,Qa)|0,Qa)|0)<<2)|0;t=0;do{g=k[Da>>2]|0;k[Ra>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[P>>2]=k[e>>2];k[Q>>2]=k[g+(t*56|0)+8>>2];k[R>>2]=k[g+(t*56|0)+12>>2];k[S>>2]=k[g+(t*56|0)+16>>2];k[T>>2]=k[g+(t*56|0)+20>>2];k[U>>2]=k[g+(t*56|0)+24>>2];k[V>>2]=k[g+(t*56|0)+28>>2];k[W>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[X>>2]=f;k[Y>>2]=Q;k[_>>2]=Z;k[$>>2]=0;k[Z>>2]=0;if(f|0){Va=f+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[e>>2]|0)>=3){k[P>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[P>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[Y>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[_>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[P>>2]|0))}}else{Ua=k[g+(t*56|0)+44>>2]|0;Va=k[_>>2]|0;k[Va>>2]=k[Ua>>2];k[Va+4>>2]=k[Ua+4>>2]}m=aa(aa(Qa,t)|0,Qa)|0;h=b+(m<<2)|0;j=v+(m<<2)|0;m=w+(m<<2)|0;if(B){g=k[S>>2]|0;f=0;do{p=aa(f,Qa)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Ha>>2]|0;e=k[k[_>>2]>>2]|0;q=g+(aa(e,C+f-s|0)|0)|0;s=g+(aa(e,f+I+s|0)|0)|0;e=0;do{Ua=o+(e<<2)|0;Wa=n+(e<<2)|0;k[Wa>>2]=(k[Wa>>2]|0)-(k[Ua>>2]|0);Va=p+(e<<2)|0;Xa=G+e|0;cb=D-(l[s+(Xa<<2)>>0]|0)|0;bb=E-(l[s+(Xa<<2)+1>>0]|0)|0;ab=F-(l[s+(Xa<<2)+2>>0]|0)|0;$a=x-(l[s+(Xa<<2)+3>>0]|0)|0;Za=y-(l[q+(Xa<<2)>>0]|0)|0;_a=z-(l[q+(Xa<<2)+1>>0]|0)|0;Ya=A-(l[q+(Xa<<2)+2>>0]|0)|0;Xa=u-(l[q+(Xa<<2)+3>>0]|0)|0;Xa=(aa(cb,cb)|0)+(k[Va>>2]|0)+(aa(bb,bb)|0)+(aa(ab,ab)|0)+(aa($a,$a)|0)-((aa(_a,_a)|0)+(aa(Za,Za)|0)+(aa(Ya,Ya)|0)+(aa(Xa,Xa)|0))|0;k[Ua>>2]=Xa;k[Wa>>2]=Xa+(k[Wa>>2]|0);k[Va>>2]=k[Ua>>2];e=e+1|0}while((e|0)!=(H|0));f=f+1|0}while((f|0)!=(H|0))}e=k[X>>2]|0;if(e|0?(bb=e+12|0,cb=k[bb>>2]|0,k[bb>>2]=cb+-1,(cb|0)==1):0){f=k[X>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[W>>2]|0;if(e|0)break;e=B1()|0;f=k[X>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[X>>2]=0}k[X>>2]=0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[P>>2]|0)>0){f=k[Y>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[P>>2]|0))}e=k[_>>2]|0;if(!((e|0)==(Z|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[Na>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ka>>2]|0)|0;C=125}if((C|0)==125){C=0;if((e|0)>0){z=k[Da>>2]|0;A=k[Pa>>2]|0;B=(A|0)>0;y=0;h=0;g=0;f=0;m=0;j=0;do{if(B){u=k[Ea>>2]|0;v=k[z+(y*56|0)+16>>2]|0;w=k[k[z+(y*56|0)+44>>2]>>2]|0;x=b+((aa(aa(Qa,y)|0,Qa)|0)<<2)|0;s=k[Fa>>2]|0;t=k[Ga>>2]|0;q=0;do{o=v+(aa(w,J+q+u|0)|0)|0;p=x+((aa(Qa,q)|0)<<2)|0;n=0;do{cb=k[t+(k[p+(n<<2)>>2]>>s<<2)>>2]|0;bb=K+n+u|0;h=h+(aa(l[o+(bb<<2)>>0]|0,cb)|0)|0;g=g+(aa(l[o+(bb<<2)+1>>0]|0,cb)|0)|0;f=f+(aa(l[o+(bb<<2)+2>>0]|0,cb)|0)|0;m=m+(aa(l[o+(bb<<2)+3>>0]|0,cb)|0)|0;j=cb+j|0;n=n+1|0}while((n|0)!=(A|0));q=q+1|0}while((q|0)!=(A|0))}y=y+1|0}while((y|0)!=(e|0));e=m}else{j=0;h=0;g=0;f=0;e=0}}ab=(j|0)/2|0;$a=((h+ab|0)>>>0)/(j>>>0)|0;bb=((g+ab|0)>>>0)/(j>>>0)|0;cb=((f+ab|0)>>>0)/(j>>>0)|0;ab=((e+ab|0)>>>0)/(j>>>0)|0;e=k[Ca>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,N)|0)+(L<<2)|0;cb=($a>>>0<256?$a:($a|0)>0?255:0)&255|(ab>>>0<256?ab:(ab|0)>0?255:0)<<24|(bb>>>0<256?bb:(bb|0)>0?255:0)<<8&65280|(cb>>>0<256?cb:(cb|0)>0?255:0)<<16&16711680;i[e>>0]=cb;i[e+1>>0]=cb>>8;i[e+2>>0]=cb>>16;i[e+3>>0]=cb>>24;L=L+1|0;e=k[Ja>>2]|0}while((L|0)<(e|0))}N=N+1|0}while((N|0)<(Ma|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Ta;return}ggb(b);r=Ta;return}function M2a(a){a=a|0;R1a(a);ggb(a);return}function N2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;Ra=r;r=r+64|0;Pa=Ra;Qa=k[b>>2]|0;Ka=k[b+4>>2]|0;La=a+96|0;Ma=k[La>>2]|0;Na=a+92|0;Oa=k[Na>>2]|0;Ja=aa(aa(Oa,Ma)|0,Oa)|0;c=Ja>>>0>1073741823?-1:Ja<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ia=a+88|0;d=aa(aa(aa(Ma,k[Ia>>2]|0)|0,Oa)|0,Oa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ha=a+8|0;f=k[Ha>>2]|0;e=aa(aa(aa(Ma,f)|0,Oa)|0,Oa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Qa|0)<(Ka|0)){za=a+104|0;Aa=a+12|0;Ba=a+16|0;Ca=a+84|0;Da=a+116|0;Ea=a+120|0;Fa=a+100|0;Ga=a+44|0;M=a+72|0;N=Pa+4|0;O=Pa+8|0;P=Pa+12|0;Q=Pa+16|0;R=Pa+20|0;S=Pa+24|0;T=Pa+28|0;U=Pa+32|0;V=Pa+36|0;W=Pa+40|0;X=Pa+48|0;Y=Pa+44|0;Z=Pa+52|0;_=Pa+4|0;$=Pa+8|0;ba=Pa+12|0;ca=Pa+16|0;da=Pa+20|0;ea=Pa+24|0;fa=Pa+28|0;ga=Pa+32|0;ha=Pa+36|0;ia=Pa+40|0;ja=Pa+48|0;ka=Pa+44|0;la=Pa+52|0;ma=Pa+4|0;na=Pa+8|0;oa=Pa+12|0;pa=Pa+16|0;qa=Pa+20|0;ra=Pa+24|0;sa=Pa+28|0;ta=Pa+32|0;ua=Pa+36|0;va=Pa+40|0;wa=Pa+48|0;xa=Pa+44|0;ya=Pa+52|0;a=-1;L=Qa;e=f;do{if((e|0)>0){K=(L|0)==(Qa|0);J=0;do{f=k[za>>2]|0;H=L-f|0;I=J-f|0;if(!J)if((k[La>>2]|0)>0){D=0;do{f=k[Ba>>2]|0;k[Pa>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[_>>2]=k[e>>2];k[$>>2]=k[f+(D*56|0)+8>>2];k[ba>>2]=k[f+(D*56|0)+12>>2];k[ca>>2]=k[f+(D*56|0)+16>>2];k[da>>2]=k[f+(D*56|0)+20>>2];k[ea>>2]=k[f+(D*56|0)+24>>2];k[fa>>2]=k[f+(D*56|0)+28>>2];k[ga>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ha>>2]=a;k[ia>>2]=$;k[ka>>2]=ja;k[la>>2]=0;k[ja>>2]=0;if(a|0){G=a+12|0;k[G>>2]=(k[G>>2]|0)+1}if((k[e>>2]|0)>=3){k[_>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[_>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ia>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ka>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[_>>2]|0))}}else{F=k[f+(D*56|0)+44>>2]|0;G=k[ka>>2]|0;k[G>>2]=k[F>>2];k[G+4>>2]=k[F+4>>2]}e=k[Na>>2]|0;if((e|0)>0){z=aa(aa(Oa,D)|0,Oa)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+L|0;u=aa(Oa,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ia>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ia>>2]|0}while((a|0)<(e|0))}p=k[za>>2]|0;o=t-p|0;p=s-p|0;f=k[Fa>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Ga>>2]|0;h=k[M>>2]|0;j=k[ca>>2]|0;while(1){E=k[Ca>>2]|0;Sa=E+a|0;Ta=g+(aa(k[h>>2]|0,f+L+E|0)|0)|0;e=m+E|0;E=j+(aa(k[k[ka>>2]>>2]|0,o+f+E|0)|0)|0;G=(l[Ta+(Sa*3|0)>>0]|0)-(l[E+(e*3|0)>>0]|0)|0;F=(l[Ta+(Sa*3|0)+1>>0]|0)-(l[E+(e*3|0)+1>>0]|0)|0;e=(l[Ta+(Sa*3|0)+2>>0]|0)-(l[E+(e*3|0)+2>>0]|0)|0;e=(aa(F,F)|0)+(aa(G,G)|0)+(aa(e,e)|0)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Fa>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(Ja<<2)|0}else break}e=k[Ia>>2]|0}e=c+((aa(aa(aa(Ma,e+-1|0)|0,Oa)|0,Oa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Na>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ha>>2]|0;if(e|0?(Sa=e+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){a=k[ha>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ga>>2]|0;if(e|0)break;e=B1()|0;a=k[ha>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ha>>2]=0}k[ha>>2]=0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;if((k[_>>2]|0)>0){a=k[ia>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[_>>2]|0))}e=k[ka>>2]|0;if(!((e|0)==(ja|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[La>>2]|0}while((D|0)<(e|0));a=0;D=125}else{a=0;m=0;j=0;h=0;g=0;f=0;e=0}else{e=k[Ca>>2]|0;if(K){F=e+Qa|0;D=e+J+(k[Fa>>2]|0)|0;E=F-f|0;e=k[La>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)|0;C=d+((aa(aa(aa(Ma,J)|0,Oa)|0,Oa)|0)<<2)|0;z=0;do{g=k[Ba>>2]|0;k[Pa>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[ma>>2]=k[e>>2];k[na>>2]=k[g+(z*56|0)+8>>2];k[oa>>2]=k[g+(z*56|0)+12>>2];k[pa>>2]=k[g+(z*56|0)+16>>2];k[qa>>2]=k[g+(z*56|0)+20>>2];k[ra>>2]=k[g+(z*56|0)+24>>2];k[sa>>2]=k[g+(z*56|0)+28>>2];k[ta>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[ua>>2]=f;k[va>>2]=na;k[xa>>2]=wa;k[ya>>2]=0;k[wa>>2]=0;if(f|0){Ta=f+12|0;k[Ta>>2]=(k[Ta>>2]|0)+1}if((k[e>>2]|0)>=3){k[ma>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[ma>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[va>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[xa>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ma>>2]|0))}}else{Sa=k[g+(z*56|0)+44>>2]|0;Ta=k[xa>>2]|0;k[Ta>>2]=k[Sa>>2];k[Ta+4>>2]=k[Sa+4>>2]}e=k[Na>>2]|0;if((e|0)>0){y=aa(aa(Oa,z)|0,Oa)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Oa,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;Ta=k[Fa>>2]|0;e=0-Ta|0;if((Ta|0)<(e|0))e=0;else{g=k[Ga>>2]|0;h=k[M>>2]|0;j=k[pa>>2]|0;f=e;e=0;while(1){Ua=g+(aa(k[h>>2]|0,f+F|0)|0)|0;Ta=j+(aa(k[k[xa>>2]>>2]|0,q+f|0)|0)|0;G=(l[Ua+(D*3|0)>>0]|0)-(l[Ta+(m*3|0)>>0]|0)|0;Sa=(l[Ua+(D*3|0)+1>>0]|0)-(l[Ta+(m*3|0)+1>>0]|0)|0;Ta=(l[Ua+(D*3|0)+2>>0]|0)-(l[Ta+(m*3|0)+2>>0]|0)|0;e=e+(aa(G,G)|0)+(aa(Sa,Sa)|0)+(aa(Ta,Ta)|0)|0;k[n>>2]=e;if((f|0)<(k[Fa>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Na>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[ua>>2]|0;if(e|0?(Ta=e+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){f=k[ua>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[ta>>2]|0;if(e|0)break;e=B1()|0;f=k[ua>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ua>>2]=0}k[ua>>2]=0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[ma>>2]|0)>0){f=k[va>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ma>>2]|0))}e=k[xa>>2]|0;if(!((e|0)==(wa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[La>>2]|0}while((z|0)<(e|0))}}else{Ua=e+L|0;E=e+J|0;F=k[Fa>>2]|0;h=E+F|0;G=Ua-f|0;E=E-f+F|0;e=k[Ga>>2]|0;f=k[k[M>>2]>>2]|0;g=e+(aa(f,Ua+~F|0)|0)|0;f=e+(aa(f,Ua+F|0)|0)|0;F=k[Na>>2]|0;e=k[La>>2]|0;if((e|0)>0){A=(F|0)>0;B=G+-1|0;C=l[f+(h*3|0)>>0]|0;D=l[f+(h*3|0)+1>>0]|0;x=l[f+(h*3|0)+2>>0]|0;y=l[g+(h*3|0)>>0]|0;z=l[g+(h*3|0)+1>>0]|0;u=l[g+(h*3|0)+2>>0]|0;v=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)|0;w=d+((aa(aa(aa(Ma,J)|0,Oa)|0,Oa)|0)<<2)|0;t=0;do{g=k[Ba>>2]|0;k[Pa>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[N>>2]=k[e>>2];k[O>>2]=k[g+(t*56|0)+8>>2];k[P>>2]=k[g+(t*56|0)+12>>2];k[Q>>2]=k[g+(t*56|0)+16>>2];k[R>>2]=k[g+(t*56|0)+20>>2];k[S>>2]=k[g+(t*56|0)+24>>2];k[T>>2]=k[g+(t*56|0)+28>>2];k[U>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[V>>2]=f;k[W>>2]=O;k[Y>>2]=X;k[Z>>2]=0;k[X>>2]=0;if(f|0){Ua=f+12|0;k[Ua>>2]=(k[Ua>>2]|0)+1}if((k[e>>2]|0)>=3){k[N>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[N>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[W>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[Y>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[N>>2]|0))}}else{Ta=k[g+(t*56|0)+44>>2]|0;Ua=k[Y>>2]|0;k[Ua>>2]=k[Ta>>2];k[Ua+4>>2]=k[Ta+4>>2]}m=aa(aa(Oa,t)|0,Oa)|0;h=b+(m<<2)|0;j=v+(m<<2)|0;m=w+(m<<2)|0;if(A){g=k[Q>>2]|0;f=0;do{p=aa(f,Oa)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Fa>>2]|0;e=k[k[Y>>2]>>2]|0;q=g+(aa(e,B+f-s|0)|0)|0;s=g+(aa(e,f+G+s|0)|0)|0;e=0;do{Ta=o+(e<<2)|0;Sa=n+(e<<2)|0;k[Sa>>2]=(k[Sa>>2]|0)-(k[Ta>>2]|0);Ua=p+(e<<2)|0;Va=E+e|0;_a=C-(l[s+(Va*3|0)>>0]|0)|0;Za=D-(l[s+(Va*3|0)+1>>0]|0)|0;Ya=x-(l[s+(Va*3|0)+2>>0]|0)|0;Wa=y-(l[q+(Va*3|0)>>0]|0)|0;Xa=z-(l[q+(Va*3|0)+1>>0]|0)|0;Va=u-(l[q+(Va*3|0)+2>>0]|0)|0;Va=(aa(_a,_a)|0)+(k[Ua>>2]|0)+(aa(Za,Za)|0)+(aa(Ya,Ya)|0)-((aa(Xa,Xa)|0)+(aa(Wa,Wa)|0)+(aa(Va,Va)|0))|0;k[Ta>>2]=Va;k[Sa>>2]=Va+(k[Sa>>2]|0);k[Ua>>2]=k[Ta>>2];e=e+1|0}while((e|0)!=(F|0));f=f+1|0}while((f|0)!=(F|0))}e=k[V>>2]|0;if(e|0?(Za=e+12|0,_a=k[Za>>2]|0,k[Za>>2]=_a+-1,(_a|0)==1):0){f=k[V>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[U>>2]|0;if(e|0)break;e=B1()|0;f=k[V>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[V>>2]=0}k[V>>2]=0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[N>>2]|0)>0){f=k[W>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[N>>2]|0))}e=k[Y>>2]|0;if(!((e|0)==(X|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[La>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ia>>2]|0)|0;D=125}if((D|0)==125){D=0;if((e|0)>0){A=k[Ba>>2]|0;B=k[Na>>2]|0;C=(B|0)>0;z=0;j=0;g=0;n=0;m=0;h=0;f=0;do{if(C){v=k[Ca>>2]|0;w=k[A+(z*56|0)+16>>2]|0;x=k[k[A+(z*56|0)+44>>2]>>2]|0;y=b+((aa(aa(Oa,z)|0,Oa)|0)<<2)|0;t=k[Da>>2]|0;u=k[Ea>>2]|0;s=0;do{p=w+(aa(x,H+s+v|0)|0)|0;q=y+((aa(Oa,s)|0)<<2)|0;o=0;do{_a=k[q+(o<<2)>>2]>>t;Ya=k[u+(_a*12|0)>>2]|0;Za=k[u+(_a*12|0)+4>>2]|0;_a=k[u+(_a*12|0)+8>>2]|0;Xa=I+o+v|0;j=j+(aa(l[p+(Xa*3|0)>>0]|0,Ya)|0)|0;g=g+(aa(l[p+(Xa*3|0)+1>>0]|0,Za)|0)|0;n=n+(aa(l[p+(Xa*3|0)+2>>0]|0,_a)|0)|0;m=m+Ya|0;h=h+Za|0;f=f+_a|0;o=o+1|0}while((o|0)!=(B|0));s=s+1|0}while((s|0)!=(B|0))}z=z+1|0}while((z|0)!=(e|0));e=n}else{m=0;j=0;h=0;g=0;f=0;e=0}}Ya=((((m|0)/2|0)+j|0)>>>0)/(m>>>0)|0;Za=((((h|0)/2|0)+g|0)>>>0)/(h>>>0)|0;_a=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[Aa>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,L)|0)|0;i[e+(J*3|0)>>0]=Ya>>>0<256?Ya:(Ya|0)>0?255:0;i[e+(J*3|0)+1>>0]=Za>>>0<256?Za:(Za|0)>0?255:0;i[e+(J*3|0)+2>>0]=_a>>>0<256?_a:(_a|0)>0?255:0;J=J+1|0;e=k[Ha>>2]|0}while((J|0)<(e|0))}L=L+1|0}while((L|0)<(Ka|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Ra;return}ggb(b);r=Ra;return}function O2a(a){a=a|0;Q1a(a);ggb(a);return}function P2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;Ra=r;r=r+64|0;Pa=Ra;Qa=k[b>>2]|0;Ka=k[b+4>>2]|0;La=a+96|0;Ma=k[La>>2]|0;Na=a+92|0;Oa=k[Na>>2]|0;Ja=aa(aa(Oa,Ma)|0,Oa)|0;c=Ja>>>0>1073741823?-1:Ja<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ia=a+88|0;d=aa(aa(aa(Ma,k[Ia>>2]|0)|0,Oa)|0,Oa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ha=a+8|0;f=k[Ha>>2]|0;e=aa(aa(aa(Ma,f)|0,Oa)|0,Oa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Qa|0)<(Ka|0)){za=a+104|0;Aa=a+12|0;Ba=a+16|0;Ca=a+84|0;Da=a+116|0;Ea=a+120|0;Fa=a+100|0;Ga=a+44|0;M=a+72|0;N=Pa+4|0;O=Pa+8|0;P=Pa+12|0;Q=Pa+16|0;R=Pa+20|0;S=Pa+24|0;T=Pa+28|0;U=Pa+32|0;V=Pa+36|0;W=Pa+40|0;X=Pa+48|0;Y=Pa+44|0;Z=Pa+52|0;_=Pa+4|0;$=Pa+8|0;ba=Pa+12|0;ca=Pa+16|0;da=Pa+20|0;ea=Pa+24|0;fa=Pa+28|0;ga=Pa+32|0;ha=Pa+36|0;ia=Pa+40|0;ja=Pa+48|0;ka=Pa+44|0;la=Pa+52|0;ma=Pa+4|0;na=Pa+8|0;oa=Pa+12|0;pa=Pa+16|0;qa=Pa+20|0;ra=Pa+24|0;sa=Pa+28|0;ta=Pa+32|0;ua=Pa+36|0;va=Pa+40|0;wa=Pa+48|0;xa=Pa+44|0;ya=Pa+52|0;a=-1;L=Qa;e=f;do{if((e|0)>0){K=(L|0)==(Qa|0);J=0;do{f=k[za>>2]|0;H=L-f|0;I=J-f|0;if(!J)if((k[La>>2]|0)>0){D=0;do{f=k[Ba>>2]|0;k[Pa>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[_>>2]=k[e>>2];k[$>>2]=k[f+(D*56|0)+8>>2];k[ba>>2]=k[f+(D*56|0)+12>>2];k[ca>>2]=k[f+(D*56|0)+16>>2];k[da>>2]=k[f+(D*56|0)+20>>2];k[ea>>2]=k[f+(D*56|0)+24>>2];k[fa>>2]=k[f+(D*56|0)+28>>2];k[ga>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ha>>2]=a;k[ia>>2]=$;k[ka>>2]=ja;k[la>>2]=0;k[ja>>2]=0;if(a|0){G=a+12|0;k[G>>2]=(k[G>>2]|0)+1}if((k[e>>2]|0)>=3){k[_>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[_>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ia>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ka>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[_>>2]|0))}}else{F=k[f+(D*56|0)+44>>2]|0;G=k[ka>>2]|0;k[G>>2]=k[F>>2];k[G+4>>2]=k[F+4>>2]}e=k[Na>>2]|0;if((e|0)>0){z=aa(aa(Oa,D)|0,Oa)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+L|0;u=aa(Oa,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ia>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ia>>2]|0}while((a|0)<(e|0))}p=k[za>>2]|0;o=t-p|0;p=s-p|0;f=k[Fa>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Ga>>2]|0;h=k[M>>2]|0;j=k[ca>>2]|0;while(1){E=k[Ca>>2]|0;Sa=E+a|0;Ta=g+(aa(k[h>>2]|0,f+L+E|0)|0)|0;e=m+E|0;E=j+(aa(k[k[ka>>2]>>2]|0,o+f+E|0)|0)|0;G=(l[Ta+(Sa*3|0)>>0]|0)-(l[E+(e*3|0)>>0]|0)|0;F=(l[Ta+(Sa*3|0)+1>>0]|0)-(l[E+(e*3|0)+1>>0]|0)|0;e=(l[Ta+(Sa*3|0)+2>>0]|0)-(l[E+(e*3|0)+2>>0]|0)|0;e=(aa(F,F)|0)+(aa(G,G)|0)+(aa(e,e)|0)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Fa>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(Ja<<2)|0}else break}e=k[Ia>>2]|0}e=c+((aa(aa(aa(Ma,e+-1|0)|0,Oa)|0,Oa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Na>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ha>>2]|0;if(e|0?(Sa=e+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){a=k[ha>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ga>>2]|0;if(e|0)break;e=B1()|0;a=k[ha>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ha>>2]=0}k[ha>>2]=0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;if((k[_>>2]|0)>0){a=k[ia>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[_>>2]|0))}e=k[ka>>2]|0;if(!((e|0)==(ja|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[La>>2]|0}while((D|0)<(e|0));a=0;B=125}else{a=0;h=0;g=0;f=0;e=0}else{e=k[Ca>>2]|0;if(K){F=e+Qa|0;D=e+J+(k[Fa>>2]|0)|0;E=F-f|0;e=k[La>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)|0;C=d+((aa(aa(aa(Ma,J)|0,Oa)|0,Oa)|0)<<2)|0;z=0;do{g=k[Ba>>2]|0;k[Pa>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[ma>>2]=k[e>>2];k[na>>2]=k[g+(z*56|0)+8>>2];k[oa>>2]=k[g+(z*56|0)+12>>2];k[pa>>2]=k[g+(z*56|0)+16>>2];k[qa>>2]=k[g+(z*56|0)+20>>2];k[ra>>2]=k[g+(z*56|0)+24>>2];k[sa>>2]=k[g+(z*56|0)+28>>2];k[ta>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[ua>>2]=f;k[va>>2]=na;k[xa>>2]=wa;k[ya>>2]=0;k[wa>>2]=0;if(f|0){Ta=f+12|0;k[Ta>>2]=(k[Ta>>2]|0)+1}if((k[e>>2]|0)>=3){k[ma>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[ma>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[va>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[xa>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ma>>2]|0))}}else{Sa=k[g+(z*56|0)+44>>2]|0;Ta=k[xa>>2]|0;k[Ta>>2]=k[Sa>>2];k[Ta+4>>2]=k[Sa+4>>2]}e=k[Na>>2]|0;if((e|0)>0){y=aa(aa(Oa,z)|0,Oa)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Oa,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;Ta=k[Fa>>2]|0;e=0-Ta|0;if((Ta|0)<(e|0))e=0;else{g=k[Ga>>2]|0;h=k[M>>2]|0;j=k[pa>>2]|0;f=e;e=0;while(1){Ua=g+(aa(k[h>>2]|0,f+F|0)|0)|0;Ta=j+(aa(k[k[xa>>2]>>2]|0,q+f|0)|0)|0;G=(l[Ua+(D*3|0)>>0]|0)-(l[Ta+(m*3|0)>>0]|0)|0;Sa=(l[Ua+(D*3|0)+1>>0]|0)-(l[Ta+(m*3|0)+1>>0]|0)|0;Ta=(l[Ua+(D*3|0)+2>>0]|0)-(l[Ta+(m*3|0)+2>>0]|0)|0;e=e+(aa(G,G)|0)+(aa(Sa,Sa)|0)+(aa(Ta,Ta)|0)|0;k[n>>2]=e;if((f|0)<(k[Fa>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Na>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[ua>>2]|0;if(e|0?(Ta=e+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){f=k[ua>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[ta>>2]|0;if(e|0)break;e=B1()|0;f=k[ua>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ua>>2]=0}k[ua>>2]=0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[ma>>2]|0)>0){f=k[va>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ma>>2]|0))}e=k[xa>>2]|0;if(!((e|0)==(wa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[La>>2]|0}while((z|0)<(e|0))}}else{Ua=e+L|0;E=e+J|0;F=k[Fa>>2]|0;h=E+F|0;G=Ua-f|0;E=E-f+F|0;e=k[Ga>>2]|0;f=k[k[M>>2]>>2]|0;g=e+(aa(f,Ua+~F|0)|0)|0;f=e+(aa(f,Ua+F|0)|0)|0;F=k[Na>>2]|0;e=k[La>>2]|0;if((e|0)>0){A=(F|0)>0;B=G+-1|0;C=l[f+(h*3|0)>>0]|0;D=l[f+(h*3|0)+1>>0]|0;x=l[f+(h*3|0)+2>>0]|0;y=l[g+(h*3|0)>>0]|0;z=l[g+(h*3|0)+1>>0]|0;u=l[g+(h*3|0)+2>>0]|0;v=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)|0;w=d+((aa(aa(aa(Ma,J)|0,Oa)|0,Oa)|0)<<2)|0;t=0;do{g=k[Ba>>2]|0;k[Pa>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[N>>2]=k[e>>2];k[O>>2]=k[g+(t*56|0)+8>>2];k[P>>2]=k[g+(t*56|0)+12>>2];k[Q>>2]=k[g+(t*56|0)+16>>2];k[R>>2]=k[g+(t*56|0)+20>>2];k[S>>2]=k[g+(t*56|0)+24>>2];k[T>>2]=k[g+(t*56|0)+28>>2];k[U>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[V>>2]=f;k[W>>2]=O;k[Y>>2]=X;k[Z>>2]=0;k[X>>2]=0;if(f|0){Ua=f+12|0;k[Ua>>2]=(k[Ua>>2]|0)+1}if((k[e>>2]|0)>=3){k[N>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[N>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[W>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[Y>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[N>>2]|0))}}else{Ta=k[g+(t*56|0)+44>>2]|0;Ua=k[Y>>2]|0;k[Ua>>2]=k[Ta>>2];k[Ua+4>>2]=k[Ta+4>>2]}m=aa(aa(Oa,t)|0,Oa)|0;h=b+(m<<2)|0;j=v+(m<<2)|0;m=w+(m<<2)|0;if(A){g=k[Q>>2]|0;f=0;do{p=aa(f,Oa)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Fa>>2]|0;e=k[k[Y>>2]>>2]|0;q=g+(aa(e,B+f-s|0)|0)|0;s=g+(aa(e,f+G+s|0)|0)|0;e=0;do{Ta=o+(e<<2)|0;Sa=n+(e<<2)|0;k[Sa>>2]=(k[Sa>>2]|0)-(k[Ta>>2]|0);Ua=p+(e<<2)|0;Va=E+e|0;_a=C-(l[s+(Va*3|0)>>0]|0)|0;Za=D-(l[s+(Va*3|0)+1>>0]|0)|0;Ya=x-(l[s+(Va*3|0)+2>>0]|0)|0;Wa=y-(l[q+(Va*3|0)>>0]|0)|0;Xa=z-(l[q+(Va*3|0)+1>>0]|0)|0;Va=u-(l[q+(Va*3|0)+2>>0]|0)|0;Va=(aa(_a,_a)|0)+(k[Ua>>2]|0)+(aa(Za,Za)|0)+(aa(Ya,Ya)|0)-((aa(Xa,Xa)|0)+(aa(Wa,Wa)|0)+(aa(Va,Va)|0))|0;k[Ta>>2]=Va;k[Sa>>2]=Va+(k[Sa>>2]|0);k[Ua>>2]=k[Ta>>2];e=e+1|0}while((e|0)!=(F|0));f=f+1|0}while((f|0)!=(F|0))}e=k[V>>2]|0;if(e|0?(Za=e+12|0,_a=k[Za>>2]|0,k[Za>>2]=_a+-1,(_a|0)==1):0){f=k[V>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[U>>2]|0;if(e|0)break;e=B1()|0;f=k[V>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[V>>2]=0}k[V>>2]=0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[N>>2]|0)>0){f=k[W>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[N>>2]|0))}e=k[Y>>2]|0;if(!((e|0)==(X|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[La>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ia>>2]|0)|0;B=125}if((B|0)==125){B=0;if((e|0)>0){y=k[Ba>>2]|0;z=k[Na>>2]|0;A=(z|0)>0;x=0;g=0;f=0;j=0;h=0;do{if(A){t=k[Ca>>2]|0;u=k[y+(x*56|0)+16>>2]|0;v=k[k[y+(x*56|0)+44>>2]>>2]|0;w=b+((aa(aa(Oa,x)|0,Oa)|0)<<2)|0;q=k[Da>>2]|0;s=k[Ea>>2]|0;p=0;do{n=u+(aa(v,H+p+t|0)|0)|0;o=w+((aa(Oa,p)|0)<<2)|0;m=0;do{_a=k[s+(k[o+(m<<2)>>2]>>q<<2)>>2]|0;Za=I+m+t|0;g=g+(aa(l[n+(Za*3|0)>>0]|0,_a)|0)|0;f=f+(aa(l[n+(Za*3|0)+1>>0]|0,_a)|0)|0;j=j+(aa(l[n+(Za*3|0)+2>>0]|0,_a)|0)|0;h=_a+h|0;m=m+1|0}while((m|0)!=(z|0));p=p+1|0}while((p|0)!=(z|0))}x=x+1|0}while((x|0)!=(e|0));e=j}else{h=0;g=0;f=0;e=0}}_a=(h|0)/2|0;Ya=((g+_a|0)>>>0)/(h>>>0)|0;Za=((f+_a|0)>>>0)/(h>>>0)|0;_a=((e+_a|0)>>>0)/(h>>>0)|0;e=k[Aa>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,L)|0)|0;i[e+(J*3|0)>>0]=Ya>>>0<256?Ya:(Ya|0)>0?255:0;i[e+(J*3|0)+1>>0]=Za>>>0<256?Za:(Za|0)>0?255:0;i[e+(J*3|0)+2>>0]=_a>>>0<256?_a:(_a|0)>0?255:0;J=J+1|0;e=k[Ha>>2]|0}while((J|0)<(e|0))}L=L+1|0}while((L|0)<(Ka|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Ra;return}ggb(b);r=Ra;return}function Q2a(a){a=a|0;P1a(a);ggb(a);return}function R2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;Qa=r;r=r+64|0;Oa=Qa;Pa=k[b>>2]|0;Ja=k[b+4>>2]|0;Ka=a+96|0;La=k[Ka>>2]|0;Ma=a+92|0;Na=k[Ma>>2]|0;Ia=aa(aa(Na,La)|0,Na)|0;c=Ia>>>0>1073741823?-1:Ia<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ha=a+88|0;d=aa(aa(aa(La,k[Ha>>2]|0)|0,Na)|0,Na)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ga=a+8|0;f=k[Ga>>2]|0;e=aa(aa(aa(La,f)|0,Na)|0,Na)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Pa|0)<(Ja|0)){ya=a+104|0;za=a+12|0;Aa=a+16|0;Ba=a+84|0;Ca=a+116|0;Da=a+120|0;Ea=a+100|0;Fa=a+44|0;L=a+72|0;M=Oa+4|0;N=Oa+8|0;O=Oa+12|0;P=Oa+16|0;Q=Oa+20|0;R=Oa+24|0;S=Oa+28|0;T=Oa+32|0;U=Oa+36|0;V=Oa+40|0;W=Oa+48|0;X=Oa+44|0;Y=Oa+52|0;Z=Oa+4|0;_=Oa+8|0;$=Oa+12|0;ba=Oa+16|0;ca=Oa+20|0;da=Oa+24|0;ea=Oa+28|0;fa=Oa+32|0;ga=Oa+36|0;ha=Oa+40|0;ia=Oa+48|0;ja=Oa+44|0;ka=Oa+52|0;la=Oa+4|0;ma=Oa+8|0;na=Oa+12|0;oa=Oa+16|0;pa=Oa+20|0;qa=Oa+24|0;ra=Oa+28|0;sa=Oa+32|0;ta=Oa+36|0;ua=Oa+40|0;va=Oa+48|0;wa=Oa+44|0;xa=Oa+52|0;a=-1;K=Pa;e=f;do{if((e|0)>0){J=(K|0)==(Pa|0);I=0;do{f=k[ya>>2]|0;G=K-f|0;H=I-f|0;if(!I)if((k[Ka>>2]|0)>0){D=0;do{f=k[Aa>>2]|0;k[Oa>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[Z>>2]=k[e>>2];k[_>>2]=k[f+(D*56|0)+8>>2];k[$>>2]=k[f+(D*56|0)+12>>2];k[ba>>2]=k[f+(D*56|0)+16>>2];k[ca>>2]=k[f+(D*56|0)+20>>2];k[da>>2]=k[f+(D*56|0)+24>>2];k[ea>>2]=k[f+(D*56|0)+28>>2];k[fa>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ga>>2]=a;k[ha>>2]=_;k[ja>>2]=ia;k[ka>>2]=0;k[ia>>2]=0;if(a|0){F=a+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[e>>2]|0)>=3){k[Z>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[Z>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ha>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ja>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[Z>>2]|0))}}else{E=k[f+(D*56|0)+44>>2]|0;F=k[ja>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2]}e=k[Ma>>2]|0;if((e|0)>0){z=aa(aa(Na,D)|0,Na)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+K|0;u=aa(Na,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ha>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ha>>2]|0}while((a|0)<(e|0))}p=k[ya>>2]|0;o=t-p|0;p=s-p|0;f=k[Ea>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Fa>>2]|0;h=k[L>>2]|0;j=k[ba>>2]|0;while(1){E=k[Ba>>2]|0;Ra=E+a|0;Sa=g+(aa(k[h>>2]|0,f+K+E|0)|0)|0;F=m+E|0;E=j+(aa(k[k[ja>>2]>>2]|0,o+f+E|0)|0)|0;e=(l[Sa+(Ra<<1)>>0]|0)-(l[E+(F<<1)>>0]|0)|0;F=(l[Sa+(Ra<<1)+1>>0]|0)-(l[E+(F<<1)+1>>0]|0)|0;e=(aa(F,F)|0)+(aa(e,e)|0)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Ea>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(Ia<<2)|0}else break}e=k[Ha>>2]|0}e=c+((aa(aa(aa(La,e+-1|0)|0,Na)|0,Na)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Ma>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ga>>2]|0;if(e|0?(Ra=e+12|0,Sa=k[Ra>>2]|0,k[Ra>>2]=Sa+-1,(Sa|0)==1):0){a=k[ga>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[fa>>2]|0;if(e|0)break;e=B1()|0;a=k[ga>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ga>>2]=0}k[ga>>2]=0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[Z>>2]|0)>0){a=k[ha>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Z>>2]|0))}e=k[ja>>2]|0;if(!((e|0)==(ia|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[Ka>>2]|0}while((D|0)<(e|0));a=0;B=125}else{a=0;h=0;g=0;f=0;e=0}else{e=k[Ba>>2]|0;if(J){F=e+Pa|0;D=e+I+(k[Ea>>2]|0)|0;E=F-f|0;e=k[Ka>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)|0;C=d+((aa(aa(aa(La,I)|0,Na)|0,Na)|0)<<2)|0;z=0;do{g=k[Aa>>2]|0;k[Oa>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[la>>2]=k[e>>2];k[ma>>2]=k[g+(z*56|0)+8>>2];k[na>>2]=k[g+(z*56|0)+12>>2];k[oa>>2]=k[g+(z*56|0)+16>>2];k[pa>>2]=k[g+(z*56|0)+20>>2];k[qa>>2]=k[g+(z*56|0)+24>>2];k[ra>>2]=k[g+(z*56|0)+28>>2];k[sa>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[ta>>2]=f;k[ua>>2]=ma;k[wa>>2]=va;k[xa>>2]=0;k[va>>2]=0;if(f|0){Sa=f+12|0;k[Sa>>2]=(k[Sa>>2]|0)+1}if((k[e>>2]|0)>=3){k[la>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[la>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[ua>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[wa>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[la>>2]|0))}}else{Ra=k[g+(z*56|0)+44>>2]|0;Sa=k[wa>>2]|0;k[Sa>>2]=k[Ra>>2];k[Sa+4>>2]=k[Ra+4>>2]}e=k[Ma>>2]|0;if((e|0)>0){y=aa(aa(Na,z)|0,Na)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Na,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;Sa=k[Ea>>2]|0;e=0-Sa|0;if((Sa|0)<(e|0))e=0;else{g=k[Fa>>2]|0;h=k[L>>2]|0;j=k[oa>>2]|0;f=e;e=0;while(1){Ta=g+(aa(k[h>>2]|0,f+F|0)|0)|0;Sa=j+(aa(k[k[wa>>2]>>2]|0,q+f|0)|0)|0;Ra=(l[Ta+(D<<1)>>0]|0)-(l[Sa+(m<<1)>>0]|0)|0;Sa=(l[Ta+(D<<1)+1>>0]|0)-(l[Sa+(m<<1)+1>>0]|0)|0;e=(aa(Ra,Ra)|0)+e+(aa(Sa,Sa)|0)|0;k[n>>2]=e;if((f|0)<(k[Ea>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Ma>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[ta>>2]|0;if(e|0?(Sa=e+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){f=k[ta>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[sa>>2]|0;if(e|0)break;e=B1()|0;f=k[ta>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ta>>2]=0}k[ta>>2]=0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[la>>2]|0)>0){f=k[ua>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[la>>2]|0))}e=k[wa>>2]|0;if(!((e|0)==(va|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[Ka>>2]|0}while((z|0)<(e|0))}}else{Ta=e+K|0;C=e+I|0;D=k[Ea>>2]|0;h=C+D|0;E=Ta-f|0;C=C-f+D|0;e=k[Fa>>2]|0;f=k[k[L>>2]>>2]|0;g=e+(aa(f,Ta+~D|0)|0)|0;f=e+(aa(f,Ta+D|0)|0)|0;D=k[Ma>>2]|0;e=k[Ka>>2]|0;if((e|0)>0){z=(D|0)>0;A=E+-1|0;B=l[f+(h<<1)>>0]|0;x=l[f+(h<<1)+1>>0]|0;y=l[g+(h<<1)>>0]|0;u=l[g+(h<<1)+1>>0]|0;v=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)|0;w=d+((aa(aa(aa(La,I)|0,Na)|0,Na)|0)<<2)|0;t=0;do{g=k[Aa>>2]|0;k[Oa>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[M>>2]=k[e>>2];k[N>>2]=k[g+(t*56|0)+8>>2];k[O>>2]=k[g+(t*56|0)+12>>2];k[P>>2]=k[g+(t*56|0)+16>>2];k[Q>>2]=k[g+(t*56|0)+20>>2];k[R>>2]=k[g+(t*56|0)+24>>2];k[S>>2]=k[g+(t*56|0)+28>>2];k[T>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[U>>2]=f;k[V>>2]=N;k[X>>2]=W;k[Y>>2]=0;k[W>>2]=0;if(f|0){Ta=f+12|0;k[Ta>>2]=(k[Ta>>2]|0)+1}if((k[e>>2]|0)>=3){k[M>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[M>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[V>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[X>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[M>>2]|0))}}else{Sa=k[g+(t*56|0)+44>>2]|0;Ta=k[X>>2]|0;k[Ta>>2]=k[Sa>>2];k[Ta+4>>2]=k[Sa+4>>2]}m=aa(aa(Na,t)|0,Na)|0;h=b+(m<<2)|0;j=v+(m<<2)|0;m=w+(m<<2)|0;if(z){g=k[P>>2]|0;f=0;do{p=aa(f,Na)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Ea>>2]|0;e=k[k[X>>2]>>2]|0;q=g+(aa(e,A+f-s|0)|0)|0;s=g+(aa(e,f+E+s|0)|0)|0;e=0;do{Sa=o+(e<<2)|0;Ra=n+(e<<2)|0;k[Ra>>2]=(k[Ra>>2]|0)-(k[Sa>>2]|0);Ta=p+(e<<2)|0;Ua=C+e|0;Wa=B-(l[s+(Ua<<1)>>0]|0)|0;Va=x-(l[s+(Ua<<1)+1>>0]|0)|0;F=y-(l[q+(Ua<<1)>>0]|0)|0;Ua=u-(l[q+(Ua<<1)+1>>0]|0)|0;F=(aa(Wa,Wa)|0)+(k[Ta>>2]|0)+(aa(Va,Va)|0)-((aa(Ua,Ua)|0)+(aa(F,F)|0))|0;k[Sa>>2]=F;k[Ra>>2]=F+(k[Ra>>2]|0);k[Ta>>2]=k[Sa>>2];e=e+1|0}while((e|0)!=(D|0));f=f+1|0}while((f|0)!=(D|0))}e=k[U>>2]|0;if(e|0?(Va=e+12|0,Wa=k[Va>>2]|0,k[Va>>2]=Wa+-1,(Wa|0)==1):0){f=k[U>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[T>>2]|0;if(e|0)break;e=B1()|0;f=k[U>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[U>>2]=0}k[U>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[M>>2]|0)>0){f=k[V>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[M>>2]|0))}e=k[X>>2]|0;if(!((e|0)==(W|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[Ka>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ha>>2]|0)|0;B=125}if((B|0)==125){B=0;if((e|0)>0){y=k[Aa>>2]|0;z=k[Ma>>2]|0;A=(z|0)>0;x=0;g=0;j=0;h=0;f=0;do{if(A){t=k[Ba>>2]|0;u=k[y+(x*56|0)+16>>2]|0;v=k[k[y+(x*56|0)+44>>2]>>2]|0;w=b+((aa(aa(Na,x)|0,Na)|0)<<2)|0;q=k[Ca>>2]|0;s=k[Da>>2]|0;p=0;do{n=u+(aa(v,G+p+t|0)|0)|0;o=w+((aa(Na,p)|0)<<2)|0;m=0;do{Wa=k[o+(m<<2)>>2]>>q;Va=k[s+(Wa<<3)>>2]|0;Wa=k[s+(Wa<<3)+4>>2]|0;Ua=H+m+t|0;g=g+(aa(l[n+(Ua<<1)>>0]|0,Va)|0)|0;j=j+(aa(l[n+(Ua<<1)+1>>0]|0,Wa)|0)|0;h=h+Va|0;f=f+Wa|0;m=m+1|0}while((m|0)!=(z|0));p=p+1|0}while((p|0)!=(z|0))}x=x+1|0}while((x|0)!=(e|0));e=j}else{h=0;g=0;f=0;e=0}}Wa=((((h|0)/2|0)+g|0)>>>0)/(h>>>0)|0;Va=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[za>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,K)|0)+(I<<1)|0;Wa=((Va>>>0<256?Va:(Va|0)>0?255:0)&65535)<<8&65535|(Wa>>>0<256?Wa:(Wa|0)>0?255:0)&255;i[e>>0]=Wa;i[e+1>>0]=Wa>>8;I=I+1|0;e=k[Ga>>2]|0}while((I|0)<(e|0))}K=K+1|0}while((K|0)<(Ja|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Qa;return}ggb(b);r=Qa;return}function S2a(a){a=a|0;O1a(a);ggb(a);return}function T2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;Qa=r;r=r+64|0;Oa=Qa;Pa=k[b>>2]|0;Ja=k[b+4>>2]|0;Ka=a+96|0;La=k[Ka>>2]|0;Ma=a+92|0;Na=k[Ma>>2]|0;Ia=aa(aa(Na,La)|0,Na)|0;c=Ia>>>0>1073741823?-1:Ia<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ha=a+88|0;d=aa(aa(aa(La,k[Ha>>2]|0)|0,Na)|0,Na)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ga=a+8|0;f=k[Ga>>2]|0;e=aa(aa(aa(La,f)|0,Na)|0,Na)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Pa|0)<(Ja|0)){ya=a+104|0;za=a+12|0;Aa=a+16|0;Ba=a+84|0;Ca=a+116|0;Da=a+120|0;Ea=a+100|0;Fa=a+44|0;L=a+72|0;M=Oa+4|0;N=Oa+8|0;O=Oa+12|0;P=Oa+16|0;Q=Oa+20|0;R=Oa+24|0;S=Oa+28|0;T=Oa+32|0;U=Oa+36|0;V=Oa+40|0;W=Oa+48|0;X=Oa+44|0;Y=Oa+52|0;Z=Oa+4|0;_=Oa+8|0;$=Oa+12|0;ba=Oa+16|0;ca=Oa+20|0;da=Oa+24|0;ea=Oa+28|0;fa=Oa+32|0;ga=Oa+36|0;ha=Oa+40|0;ia=Oa+48|0;ja=Oa+44|0;ka=Oa+52|0;la=Oa+4|0;ma=Oa+8|0;na=Oa+12|0;oa=Oa+16|0;pa=Oa+20|0;qa=Oa+24|0;ra=Oa+28|0;sa=Oa+32|0;ta=Oa+36|0;ua=Oa+40|0;va=Oa+48|0;wa=Oa+44|0;xa=Oa+52|0;a=-1;K=Pa;e=f;do{if((e|0)>0){J=(K|0)==(Pa|0);I=0;do{f=k[ya>>2]|0;G=K-f|0;H=I-f|0;if(!I)if((k[Ka>>2]|0)>0){D=0;do{f=k[Aa>>2]|0;k[Oa>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[Z>>2]=k[e>>2];k[_>>2]=k[f+(D*56|0)+8>>2];k[$>>2]=k[f+(D*56|0)+12>>2];k[ba>>2]=k[f+(D*56|0)+16>>2];k[ca>>2]=k[f+(D*56|0)+20>>2];k[da>>2]=k[f+(D*56|0)+24>>2];k[ea>>2]=k[f+(D*56|0)+28>>2];k[fa>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ga>>2]=a;k[ha>>2]=_;k[ja>>2]=ia;k[ka>>2]=0;k[ia>>2]=0;if(a|0){F=a+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[e>>2]|0)>=3){k[Z>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[Z>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ha>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ja>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[Z>>2]|0))}}else{E=k[f+(D*56|0)+44>>2]|0;F=k[ja>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2]}e=k[Ma>>2]|0;if((e|0)>0){z=aa(aa(Na,D)|0,Na)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+K|0;u=aa(Na,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ha>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ha>>2]|0}while((a|0)<(e|0))}p=k[ya>>2]|0;o=t-p|0;p=s-p|0;f=k[Ea>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Fa>>2]|0;h=k[L>>2]|0;j=k[ba>>2]|0;while(1){E=k[Ba>>2]|0;Ra=E+a|0;Sa=g+(aa(k[h>>2]|0,f+K+E|0)|0)|0;F=m+E|0;E=j+(aa(k[k[ja>>2]>>2]|0,o+f+E|0)|0)|0;e=(l[Sa+(Ra<<1)>>0]|0)-(l[E+(F<<1)>>0]|0)|0;F=(l[Sa+(Ra<<1)+1>>0]|0)-(l[E+(F<<1)+1>>0]|0)|0;e=(aa(F,F)|0)+(aa(e,e)|0)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Ea>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(Ia<<2)|0}else break}e=k[Ha>>2]|0}e=c+((aa(aa(aa(La,e+-1|0)|0,Na)|0,Na)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Ma>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ga>>2]|0;if(e|0?(Ra=e+12|0,Sa=k[Ra>>2]|0,k[Ra>>2]=Sa+-1,(Sa|0)==1):0){a=k[ga>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[fa>>2]|0;if(e|0)break;e=B1()|0;a=k[ga>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ga>>2]=0}k[ga>>2]=0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[Z>>2]|0)>0){a=k[ha>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Z>>2]|0))}e=k[ja>>2]|0;if(!((e|0)==(ia|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[Ka>>2]|0}while((D|0)<(e|0));a=0;A=125}else{a=0;g=0;f=0;e=0}else{e=k[Ba>>2]|0;if(J){F=e+Pa|0;D=e+I+(k[Ea>>2]|0)|0;E=F-f|0;e=k[Ka>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)|0;C=d+((aa(aa(aa(La,I)|0,Na)|0,Na)|0)<<2)|0;z=0;do{g=k[Aa>>2]|0;k[Oa>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[la>>2]=k[e>>2];k[ma>>2]=k[g+(z*56|0)+8>>2];k[na>>2]=k[g+(z*56|0)+12>>2];k[oa>>2]=k[g+(z*56|0)+16>>2];k[pa>>2]=k[g+(z*56|0)+20>>2];k[qa>>2]=k[g+(z*56|0)+24>>2];k[ra>>2]=k[g+(z*56|0)+28>>2];k[sa>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[ta>>2]=f;k[ua>>2]=ma;k[wa>>2]=va;k[xa>>2]=0;k[va>>2]=0;if(f|0){Sa=f+12|0;k[Sa>>2]=(k[Sa>>2]|0)+1}if((k[e>>2]|0)>=3){k[la>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[la>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[ua>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[wa>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[la>>2]|0))}}else{Ra=k[g+(z*56|0)+44>>2]|0;Sa=k[wa>>2]|0;k[Sa>>2]=k[Ra>>2];k[Sa+4>>2]=k[Ra+4>>2]}e=k[Ma>>2]|0;if((e|0)>0){y=aa(aa(Na,z)|0,Na)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Na,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;Sa=k[Ea>>2]|0;e=0-Sa|0;if((Sa|0)<(e|0))e=0;else{g=k[Fa>>2]|0;h=k[L>>2]|0;j=k[oa>>2]|0;f=e;e=0;while(1){Ta=g+(aa(k[h>>2]|0,f+F|0)|0)|0;Sa=j+(aa(k[k[wa>>2]>>2]|0,q+f|0)|0)|0;Ra=(l[Ta+(D<<1)>>0]|0)-(l[Sa+(m<<1)>>0]|0)|0;Sa=(l[Ta+(D<<1)+1>>0]|0)-(l[Sa+(m<<1)+1>>0]|0)|0;e=(aa(Ra,Ra)|0)+e+(aa(Sa,Sa)|0)|0;k[n>>2]=e;if((f|0)<(k[Ea>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Ma>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[ta>>2]|0;if(e|0?(Sa=e+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){f=k[ta>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[sa>>2]|0;if(e|0)break;e=B1()|0;f=k[ta>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ta>>2]=0}k[ta>>2]=0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[la>>2]|0)>0){f=k[ua>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[la>>2]|0))}e=k[wa>>2]|0;if(!((e|0)==(va|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[Ka>>2]|0}while((z|0)<(e|0))}}else{Ta=e+K|0;C=e+I|0;D=k[Ea>>2]|0;h=C+D|0;E=Ta-f|0;C=C-f+D|0;e=k[Fa>>2]|0;f=k[k[L>>2]>>2]|0;g=e+(aa(f,Ta+~D|0)|0)|0;f=e+(aa(f,Ta+D|0)|0)|0;D=k[Ma>>2]|0;e=k[Ka>>2]|0;if((e|0)>0){z=(D|0)>0;A=E+-1|0;B=l[f+(h<<1)>>0]|0;x=l[f+(h<<1)+1>>0]|0;y=l[g+(h<<1)>>0]|0;u=l[g+(h<<1)+1>>0]|0;v=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)|0;w=d+((aa(aa(aa(La,I)|0,Na)|0,Na)|0)<<2)|0;t=0;do{g=k[Aa>>2]|0;k[Oa>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[M>>2]=k[e>>2];k[N>>2]=k[g+(t*56|0)+8>>2];k[O>>2]=k[g+(t*56|0)+12>>2];k[P>>2]=k[g+(t*56|0)+16>>2];k[Q>>2]=k[g+(t*56|0)+20>>2];k[R>>2]=k[g+(t*56|0)+24>>2];k[S>>2]=k[g+(t*56|0)+28>>2];k[T>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[U>>2]=f;k[V>>2]=N;k[X>>2]=W;k[Y>>2]=0;k[W>>2]=0;if(f|0){Ta=f+12|0;k[Ta>>2]=(k[Ta>>2]|0)+1}if((k[e>>2]|0)>=3){k[M>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[M>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[V>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[X>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[M>>2]|0))}}else{Sa=k[g+(t*56|0)+44>>2]|0;Ta=k[X>>2]|0;k[Ta>>2]=k[Sa>>2];k[Ta+4>>2]=k[Sa+4>>2]}m=aa(aa(Na,t)|0,Na)|0;h=b+(m<<2)|0;j=v+(m<<2)|0;m=w+(m<<2)|0;if(z){g=k[P>>2]|0;f=0;do{p=aa(f,Na)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Ea>>2]|0;e=k[k[X>>2]>>2]|0;q=g+(aa(e,A+f-s|0)|0)|0;s=g+(aa(e,f+E+s|0)|0)|0;e=0;do{Sa=o+(e<<2)|0;Ra=n+(e<<2)|0;k[Ra>>2]=(k[Ra>>2]|0)-(k[Sa>>2]|0);Ta=p+(e<<2)|0;Ua=C+e|0;Wa=B-(l[s+(Ua<<1)>>0]|0)|0;Va=x-(l[s+(Ua<<1)+1>>0]|0)|0;F=y-(l[q+(Ua<<1)>>0]|0)|0;Ua=u-(l[q+(Ua<<1)+1>>0]|0)|0;F=(aa(Wa,Wa)|0)+(k[Ta>>2]|0)+(aa(Va,Va)|0)-((aa(Ua,Ua)|0)+(aa(F,F)|0))|0;k[Sa>>2]=F;k[Ra>>2]=F+(k[Ra>>2]|0);k[Ta>>2]=k[Sa>>2];e=e+1|0}while((e|0)!=(D|0));f=f+1|0}while((f|0)!=(D|0))}e=k[U>>2]|0;if(e|0?(Va=e+12|0,Wa=k[Va>>2]|0,k[Va>>2]=Wa+-1,(Wa|0)==1):0){f=k[U>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[T>>2]|0;if(e|0)break;e=B1()|0;f=k[U>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[U>>2]=0}k[U>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[M>>2]|0)>0){f=k[V>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[M>>2]|0))}e=k[X>>2]|0;if(!((e|0)==(W|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[Ka>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ha>>2]|0)|0;A=125}if((A|0)==125){A=0;if((e|0)>0){x=k[Aa>>2]|0;y=k[Ma>>2]|0;z=(y|0)>0;w=0;f=0;h=0;g=0;do{if(z){s=k[Ba>>2]|0;t=k[x+(w*56|0)+16>>2]|0;u=k[k[x+(w*56|0)+44>>2]>>2]|0;v=b+((aa(aa(Na,w)|0,Na)|0)<<2)|0;p=k[Ca>>2]|0;q=k[Da>>2]|0;o=0;do{m=t+(aa(u,G+o+s|0)|0)|0;n=v+((aa(Na,o)|0)<<2)|0;j=0;do{Wa=k[q+(k[n+(j<<2)>>2]>>p<<2)>>2]|0;Va=H+j+s|0;f=f+(aa(l[m+(Va<<1)>>0]|0,Wa)|0)|0;h=h+(aa(l[m+(Va<<1)+1>>0]|0,Wa)|0)|0;g=Wa+g|0;j=j+1|0}while((j|0)!=(y|0));o=o+1|0}while((o|0)!=(y|0))}w=w+1|0}while((w|0)!=(e|0));e=h}else{g=0;f=0;e=0}}Va=(g|0)/2|0;Wa=((f+Va|0)>>>0)/(g>>>0)|0;Va=((e+Va|0)>>>0)/(g>>>0)|0;e=k[za>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,K)|0)+(I<<1)|0;Wa=((Va>>>0<256?Va:(Va|0)>0?255:0)&65535)<<8&65535|(Wa>>>0<256?Wa:(Wa|0)>0?255:0)&255;i[e>>0]=Wa;i[e+1>>0]=Wa>>8;I=I+1|0;e=k[Ga>>2]|0}while((I|0)<(e|0))}K=K+1|0}while((K|0)<(Ja|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Qa;return}ggb(b);r=Qa;return}function U2a(a){a=a|0;N1a(a);ggb(a);return}function V2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0;Sa=r;r=r+64|0;Oa=Sa;Pa=k[b>>2]|0;Ja=k[b+4>>2]|0;Ka=a+96|0;La=k[Ka>>2]|0;Ma=a+92|0;Na=k[Ma>>2]|0;Ia=aa(aa(Na,La)|0,Na)|0;c=Ia>>>0>1073741823?-1:Ia<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ha=a+88|0;d=aa(aa(aa(La,k[Ha>>2]|0)|0,Na)|0,Na)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ga=a+8|0;f=k[Ga>>2]|0;e=aa(aa(aa(La,f)|0,Na)|0,Na)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Pa|0)<(Ja|0)){ya=a+104|0;za=a+16|0;Aa=a+84|0;Ba=a+116|0;Ca=a+120|0;Da=a+12|0;Ea=a+100|0;Fa=a+44|0;L=a+72|0;M=Oa+4|0;N=Oa+8|0;O=Oa+12|0;P=Oa+16|0;Q=Oa+20|0;R=Oa+24|0;S=Oa+28|0;T=Oa+32|0;U=Oa+36|0;V=Oa+40|0;W=Oa+48|0;X=Oa+44|0;Y=Oa+52|0;Z=Oa+4|0;_=Oa+8|0;$=Oa+12|0;ba=Oa+16|0;ca=Oa+20|0;da=Oa+24|0;ea=Oa+28|0;fa=Oa+32|0;ga=Oa+36|0;ha=Oa+40|0;ia=Oa+48|0;ja=Oa+44|0;ka=Oa+52|0;la=Oa+4|0;ma=Oa+8|0;na=Oa+12|0;oa=Oa+16|0;pa=Oa+20|0;qa=Oa+24|0;ra=Oa+28|0;sa=Oa+32|0;ta=Oa+36|0;ua=Oa+40|0;va=Oa+48|0;wa=Oa+44|0;xa=Oa+52|0;a=-1;K=Pa;e=f;do{if((e|0)>0){J=(K|0)==(Pa|0);I=0;do{f=k[ya>>2]|0;G=K-f|0;H=I-f|0;if(!I)if((k[Ka>>2]|0)>0){D=0;do{f=k[za>>2]|0;k[Oa>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[Z>>2]=k[e>>2];k[_>>2]=k[f+(D*56|0)+8>>2];k[$>>2]=k[f+(D*56|0)+12>>2];k[ba>>2]=k[f+(D*56|0)+16>>2];k[ca>>2]=k[f+(D*56|0)+20>>2];k[da>>2]=k[f+(D*56|0)+24>>2];k[ea>>2]=k[f+(D*56|0)+28>>2];k[fa>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ga>>2]=a;k[ha>>2]=_;k[ja>>2]=ia;k[ka>>2]=0;k[ia>>2]=0;if(a|0){F=a+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[e>>2]|0)>=3){k[Z>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[Z>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ha>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ja>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[Z>>2]|0))}}else{E=k[f+(D*56|0)+44>>2]|0;F=k[ja>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2]}e=k[Ma>>2]|0;if((e|0)>0){z=aa(aa(Na,D)|0,Na)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+K|0;u=aa(Na,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ha>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ha>>2]|0}while((a|0)<(e|0))}p=k[ya>>2]|0;o=t-p|0;p=s-p|0;f=k[Ea>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Fa>>2]|0;h=k[L>>2]|0;j=k[ba>>2]|0;while(1){e=k[Aa>>2]|0;F=g+(aa(k[h>>2]|0,f+K+e|0)|0)+(e+a)|0;e=j+(aa(k[k[ja>>2]>>2]|0,o+f+e|0)|0)+(m+e)|0;e=(l[F>>0]|0)-(l[e>>0]|0)|0;e=aa(e,e)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=(k[n>>2]|0)+e;e=k[Ea>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(Ia<<2)|0}else break}e=k[Ha>>2]|0}e=c+((aa(aa(aa(La,e+-1|0)|0,Na)|0,Na)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Ma>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ga>>2]|0;if(e|0?(E=e+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){a=k[ga>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[fa>>2]|0;if(e|0)break;e=B1()|0;a=k[ga>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ga>>2]=0}k[ga>>2]=0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[Z>>2]|0)>0){a=k[ha>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Z>>2]|0))}e=k[ja>>2]|0;if(!((e|0)==(ia|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[Ka>>2]|0}while((D|0)<(e|0));a=0;s=e;w=125}else{a=0;f=0;e=0}else{e=k[Aa>>2]|0;if(J){F=e+Pa|0;D=e+I+(k[Ea>>2]|0)|0;E=F-f|0;e=k[Ka>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)|0;C=d+((aa(aa(aa(La,I)|0,Na)|0,Na)|0)<<2)|0;z=0;do{g=k[za>>2]|0;k[Oa>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[la>>2]=k[e>>2];k[ma>>2]=k[g+(z*56|0)+8>>2];k[na>>2]=k[g+(z*56|0)+12>>2];k[oa>>2]=k[g+(z*56|0)+16>>2];k[pa>>2]=k[g+(z*56|0)+20>>2];k[qa>>2]=k[g+(z*56|0)+24>>2];k[ra>>2]=k[g+(z*56|0)+28>>2];k[sa>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[ta>>2]=f;k[ua>>2]=ma;k[wa>>2]=va;k[xa>>2]=0;k[va>>2]=0;if(f|0){y=f+12|0;k[y>>2]=(k[y>>2]|0)+1}if((k[e>>2]|0)>=3){k[la>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[la>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[ua>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[wa>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[la>>2]|0))}}else{x=k[g+(z*56|0)+44>>2]|0;y=k[wa>>2]|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2]}e=k[Ma>>2]|0;if((e|0)>0){y=aa(aa(Na,z)|0,Na)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Na,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;j=k[Ea>>2]|0;e=0-j|0;if((j|0)<(e|0))e=0;else{g=k[Fa>>2]|0;h=k[L>>2]|0;j=k[oa>>2]|0;f=e;e=0;while(1){Ua=g+(aa(k[h>>2]|0,f+F|0)|0)+D|0;Ta=j+(aa(k[k[wa>>2]>>2]|0,q+f|0)|0)+m|0;Ta=(l[Ua>>0]|0)-(l[Ta>>0]|0)|0;e=(aa(Ta,Ta)|0)+e|0;k[n>>2]=e;if((f|0)<(k[Ea>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Ma>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[ta>>2]|0;if(e|0?(Ta=e+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){f=k[ta>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[sa>>2]|0;if(e|0)break;e=B1()|0;f=k[ta>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ta>>2]=0}k[ta>>2]=0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[la>>2]|0)>0){f=k[ua>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[la>>2]|0))}e=k[wa>>2]|0;if(!((e|0)==(va|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[Ka>>2]|0}while((z|0)<(e|0))}}else{m=e+K|0;A=e+I|0;h=k[Ea>>2]|0;j=A+h|0;C=m-f|0;A=A-f+h|0;f=k[Fa>>2]|0;g=k[k[L>>2]>>2]|0;B=k[Ma>>2]|0;e=k[Ka>>2]|0;if((e|0)>0){w=f+(aa(g,m+h|0)|0)+j|0;x=f+(aa(g,m+~h|0)|0)+j|0;u=(B|0)>0;v=C+-1|0;w=l[w>>0]|0;x=l[x>>0]|0;y=c+((aa(aa(aa(La,a)|0,Na)|0,Na)|0)<<2)|0;z=d+((aa(aa(aa(La,I)|0,Na)|0,Na)|0)<<2)|0;t=0;do{g=k[za>>2]|0;k[Oa>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[M>>2]=k[e>>2];k[N>>2]=k[g+(t*56|0)+8>>2];k[O>>2]=k[g+(t*56|0)+12>>2];k[P>>2]=k[g+(t*56|0)+16>>2];k[Q>>2]=k[g+(t*56|0)+20>>2];k[R>>2]=k[g+(t*56|0)+24>>2];k[S>>2]=k[g+(t*56|0)+28>>2];k[T>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[U>>2]=f;k[V>>2]=N;k[X>>2]=W;k[Y>>2]=0;k[W>>2]=0;if(f|0){Ua=f+12|0;k[Ua>>2]=(k[Ua>>2]|0)+1}if((k[e>>2]|0)>=3){k[M>>2]=0;x1(Oa,k[e>>2]|0,0,0,0);if((k[M>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[V>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[X>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[M>>2]|0))}}else{Ta=k[g+(t*56|0)+44>>2]|0;Ua=k[X>>2]|0;k[Ua>>2]=k[Ta>>2];k[Ua+4>>2]=k[Ta+4>>2]}m=aa(aa(Na,t)|0,Na)|0;h=b+(m<<2)|0;j=y+(m<<2)|0;m=z+(m<<2)|0;if(u){g=k[P>>2]|0;f=0;do{p=aa(f,Na)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Ea>>2]|0;e=k[k[X>>2]>>2]|0;q=g+(aa(e,v+f-s|0)|0)|0;s=g+(aa(e,f+C+s|0)|0)|0;e=0;do{Ta=o+(e<<2)|0;F=n+(e<<2)|0;k[F>>2]=(k[F>>2]|0)-(k[Ta>>2]|0);Ua=p+(e<<2)|0;E=A+e|0;D=w-(l[s+E>>0]|0)|0;E=x-(l[q+E>>0]|0)|0;E=(aa(D-E|0,D+E|0)|0)+(k[Ua>>2]|0)|0;k[Ta>>2]=E;k[F>>2]=E+(k[F>>2]|0);k[Ua>>2]=k[Ta>>2];e=e+1|0}while((e|0)!=(B|0));f=f+1|0}while((f|0)!=(B|0))}e=k[U>>2]|0;if(e|0?(Ta=e+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){f=k[U>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[T>>2]|0;if(e|0)break;e=B1()|0;f=k[U>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[U>>2]=0}k[U>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[M>>2]|0)>0){f=k[V>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[M>>2]|0))}e=k[X>>2]|0;if(!((e|0)==(W|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[Ka>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ha>>2]|0)|0;s=e;w=125}if((w|0)==125){w=0;if((s|0)>0?(Qa=k[za>>2]|0,Ra=k[Ma>>2]|0,(Ra|0)>0):0){o=k[Aa>>2]|0;p=k[Ba>>2]|0;q=k[Ca>>2]|0;n=0;f=0;e=0;do{t=k[Qa+(n*56|0)+16>>2]|0;u=k[k[Qa+(n*56|0)+44>>2]>>2]|0;v=b+((aa(aa(Na,n)|0,Na)|0)<<2)|0;m=0;do{h=t+(aa(u,G+m+o|0)|0)|0;j=v+((aa(Na,m)|0)<<2)|0;g=0;do{Ua=k[q+(k[j+(g<<2)>>2]>>p<<2)>>2]|0;e=(aa(l[h+(H+g+o)>>0]|0,Ua)|0)+e|0;f=Ua+f|0;g=g+1|0}while((g|0)!=(Ra|0));m=m+1|0}while((m|0)!=(Ra|0));n=n+1|0}while((n|0)!=(s|0))}else{f=0;e=0}}Ua=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[Da>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,K)|0)+I|0;i[e>>0]=Ua>>>0<256?Ua:(Ua|0)>0?255:0;I=I+1|0;e=k[Ga>>2]|0}while((I|0)<(e|0))}K=K+1|0}while((K|0)<(Ja|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Sa;return}ggb(b);r=Sa;return}function W2a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+16|0;q=s;b=k[a>>2]|0;d=a+4|0;c=k[d>>2]|0;if((b|0)==(c|0)){b=q+4|0;c=ZT(20)|0;k[c>>2]=1;e=c+4|0;k[q>>2]=e;k[b>>2]=15;i[c+19>>0]=0;f=398265;g=e+15|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,q,398281,398302,51);k[b>>2]=0;k[q>>2]=0;p=k[c>>2]|0;k[c>>2]=p+-1;if((p|0)==1)ggb(k[c+-4>>2]|0);b=k[a>>2]|0;p=d;c=k[d>>2]|0}else p=d;d=b;m=k[b+12>>2]|0;n=k[b+8>>2]|0;o=k[b>>2]|0;if((c|0)==(d|0)){r=s;return}j=q+4|0;l=q+4|0;h=0;e=m;c=d;while(1){if(!((e|0)==(m|0)?(k[b+(h*56|0)+8>>2]|0)==(n|0):0)){b=ZT(56)|0;k[b>>2]=1;e=b+4|0;k[q>>2]=e;k[l>>2]=51;i[b+55>>0]=0;f=398372;g=e+51|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,q,398281,398302,57);k[l>>2]=0;k[q>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0);c=k[a>>2]|0;b=c}if((k[b+(h*56|0)>>2]^o)&4095){b=ZT(32)|0;k[b>>2]=1;e=b+4|0;k[q>>2]=e;k[j>>2]=24;i[b+28>>0]=0;f=398424;g=e+24|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,q,398281,398302,58);k[j>>2]=0;k[q>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0);c=k[a>>2]|0}d=h+1|0;b=c;if(d>>>0>=(((k[p>>2]|0)-c|0)/56|0)>>>0)break;h=d;e=k[b+(d*56|0)+12>>2]|0}r=s;return}function X2a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;m=r;r=r+16|0;e=m;k[a>>2]=1124007936;b=a+8|0;j=a+40|0;c=a+4|0;d=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));k[j>>2]=b;g=a+48|0;h=a+44|0;k[h>>2]=g;k[a+52>>2]=0;k[g>>2]=0;k[e>>2]=256;k[e+4>>2]=1;G1(a,2,e,5);g=a+16|0;f=a+12|0;e=(k[a>>2]&16384|0)==0;d=0;do{do if(e?(i=k[j>>2]|0,(k[i>>2]|0)!=1):0){b=k[g>>2]|0;c=k[h>>2]|0;if((k[i+4>>2]|0)==1){b=b+(aa(k[c>>2]|0,d)|0)|0;break}else{a=k[f>>2]|0;n=(d|0)/(a|0)|0;a=d-(aa(n,a)|0)|0;b=b+(aa(k[c>>2]|0,n)|0)+(a<<2)|0;break}}else l=4;while(0);if((l|0)==4){l=0;b=(k[g>>2]|0)+(d<<2)|0}o[b>>2]=(d|0)<128?+(d|0)+1.0:+(256-d|0);d=d+1|0}while((d|0)!=256);r=m;return}function Y2a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0;m=r;r=r+16|0;e=m;k[a>>2]=1124007936;b=a+8|0;j=a+40|0;c=a+4|0;d=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));k[j>>2]=b;g=a+48|0;h=a+44|0;k[h>>2]=g;k[a+52>>2]=0;k[g>>2]=0;k[e>>2]=256;k[e+4>>2]=1;G1(a,2,e,21);g=a+16|0;e=a+12|0;d=0;do{f=+(d|0)/63.75+-2.0;f=+Z(+-(f*f));do if((k[a>>2]&16384|0)==0?(i=k[j>>2]|0,(k[i>>2]|0)!=1):0){b=k[g>>2]|0;c=k[h>>2]|0;if((k[i+4>>2]|0)==1){b=b+(aa(k[c>>2]|0,d)|0)|0;break}else{n=k[e>>2]|0;p=(d|0)/(n|0)|0;n=d-(aa(p,n)|0)|0;b=b+(aa(k[c>>2]|0,p)|0)+(n*12|0)|0;break}}else l=4;while(0);if((l|0)==4){l=0;b=(k[g>>2]|0)+(d*12|0)|0}o[b>>2]=f;o[b+4>>2]=f;o[b+8>>2]=f;d=d+1|0}while((d|0)!=256);r=m;return}function Z2a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;w=r;r=r+480|0;s=w+224|0;t=w+464|0;u=w+448|0;v=w;k[t>>2]=0;m=t+4|0;k[m>>2]=0;k[t+8>>2]=0;while(1){f=fgb(168)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[t>>2]=f;i=f+168|0;k[t+8>>2]=i;k[f>>2]=1124007936;g=f+8|0;h=f+40|0;j=f+4|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[h>>2]=g;g=f+48|0;k[f+44>>2]=g;k[f+52>>2]=0;k[g>>2]=0;k[f+56>>2]=1124007936;g=f+64|0;h=f+96|0;j=f+60|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[h>>2]=g;g=f+104|0;k[f+100>>2]=g;k[f+108>>2]=0;k[g>>2]=0;k[f+112>>2]=1124007936;g=f+120|0;h=f+152|0;j=f+116|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[h>>2]=g;j=f+160|0;k[f+156>>2]=j;k[f+164>>2]=0;k[j>>2]=0;k[m>>2]=i;k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=a;j=u+4|0;l=j+4|0;k[l>>2]=0;k[l+4>>2]=0;k[u>>2]=33882112;k[j>>2]=t;FV(s,u);j=u+8|0;l=u+12|0;a=u+4|0;m=s+8|0;n=s+12|0;o=s+4|0;p=u+4|0;q=p+4|0;g=u+8|0;h=u+12|0;i=u+4|0;f=0;do{x=(k[t>>2]|0)+(f*56|0)|0;g1(v,c);k[j>>2]=0;k[l>>2]=0;k[u>>2]=-1056571392;k[a>>2]=v;i1(s,x,u,1.0);y=k[s>>2]|0;dh[k[(k[y>>2]|0)+12>>2]&255](y,s,x,-1);XN(s);XN(v);x=(k[t>>2]|0)+(f*56|0)|0;k[m>>2]=0;k[n>>2]=0;k[s>>2]=16842752;k[o>>2]=x;y=q;k[y>>2]=0;k[y+4>>2]=0;k[u>>2]=33619968;k[p>>2]=x;ZZ(s,e,u);x=(k[t>>2]|0)+(f*56|0)|0;k[g>>2]=0;k[h>>2]=0;k[u>>2]=16842752;k[i>>2]=d;i1(s,x,u,1.0);y=k[s>>2]|0;dh[k[(k[y>>2]|0)+12>>2]&255](y,s,x,-1);XN(s);f=f+1|0}while((f|0)<3);k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=17104896;k[u+4>>2]=t;x=v+4|0;y=x+4|0;k[y>>2]=0;k[y+4>>2]=0;k[v>>2]=33619968;k[x>>2]=b;k[s>>2]=0;x=s+4|0;k[x>>2]=0;k[s+8>>2]=0;B2(u,s);y=k[s>>2]|0;x=k[x>>2]|0;GV((y|0)==(x|0)?0:y,(x-y|0)/56|0,v);zF(s);zF(t);r=w;return}function _2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0.0;l=r;r=r+16|0;f=l;e=(b<<3)+4093|0;k[a>>2]=1124007936;b=a+8|0;h=a+40|0;c=a+4|0;d=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));k[h>>2]=b;d=a+48|0;g=a+44|0;k[g>>2]=d;k[a+52>>2]=0;k[d>>2]=0;k[f>>2]=256;k[f+4>>2]=1;G1(a,2,f,e&4093);e=a+16|0;f=a+12|0;d=0;do{do if((k[a>>2]&16384|0)==0?(i=k[h>>2]|0,(k[i>>2]|0)!=1):0){b=k[e>>2]|0;c=k[g>>2]|0;if((k[i+4>>2]|0)==1){b=b+(aa(k[c>>2]|0,d)|0)|0;break}else{m=k[f>>2]|0;n=(d|0)/(m|0)|0;m=d-(aa(n,m)|0)|0;b=b+(aa(k[c>>2]|0,n)|0)+(m*12|0)|0;break}}else j=4;while(0);if((j|0)==4){j=0;b=(k[e>>2]|0)+(d*12|0)|0}p=+(d|0);o[b>>2]=p;o[b+4>>2]=p;o[b+8>>2]=p;d=d+1|0}while((d|0)!=256);r=l;return}function $2a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,q=0,s=0,t=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0.0,Z=0.0,_=0.0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0;Sa=r;r=r+320|0;O=Sa+192|0;g=Sa+280|0;h=Sa+252|0;j=Sa+224|0;y=Sa+160|0;A=Sa+128|0;z=Sa+96|0;L=Sa+64|0;M=Sa+32|0;N=Sa;p[u>>3]=d;f=k[u+4>>2]|0;Ra=f&2146435072;if(!(Ra>>>0>1126170624|(Ra|0)==1126170624&0>0)){f=(f|0)<0;d=f?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=f?-0.0:0.0}ja=~~d;q=G9(a,g,0,0)|0;x=G9(b,h,0,0)|0;ha=G9(c,j,0,0)|0;g=q+20|0;f=k[g>>2]|0;if(!((((f|0)==(k[ha+20>>2]|0)?(m=k[q+24>>2]|0,(m|0)==(k[ha+24>>2]|0)):0)?(f|0)==(k[x+20>>2]|0):0)?(m|0)==(k[x+24>>2]|0):0)){k[O>>2]=0;f=O+4|0;k[f>>2]=0;a=ZT(60)|0;k[a>>2]=1;b=a+4|0;k[O>>2]=b;k[f>>2]=55;i[a+59>>0]=0;h=398449;c=b+55|0;do{i[b>>0]=i[h>>0]|0;b=b+1|0;h=h+1|0}while((b|0)<(c|0));Y8(-209,O,398505,398515,745);k[f>>2]=0;k[O>>2]=0;Ra=k[a>>2]|0;k[a>>2]=Ra+-1;if((Ra|0)==1)ggb(k[a+-4>>2]|0)}f=k[q>>2]|0;switch(f&4095){case 16:case 0:{if((k[ha>>2]^f)&4095|0)n=13;break}default:n=13}if((n|0)==13){k[O>>2]=0;f=O+4|0;k[f>>2]=0;a=ZT(76)|0;k[a>>2]=1;b=a+4|0;k[O>>2]=b;k[f>>2]=68;i[a+72>>0]=0;h=398582;c=b+68|0;do{i[b>>0]=i[h>>0]|0;b=b+1|0;h=h+1|0}while((b|0)<(c|0));Y8(-210,O,398505,398515,751);k[f>>2]=0;k[O>>2]=0;Ra=k[a>>2]|0;k[a>>2]=Ra+-1;if((Ra|0)==1)ggb(k[a+-4>>2]|0)}if(k[x>>2]&4095|0){k[O>>2]=0;f=O+4|0;k[f>>2]=0;a=ZT(44)|0;k[a>>2]=1;b=a+4|0;k[O>>2]=b;k[f>>2]=38;i[a+42>>0]=0;h=398651;c=b+38|0;do{i[b>>0]=i[h>>0]|0;b=b+1|0;h=h+1|0}while((b|0)<(c|0));Y8(-210,O,398505,398515,754);k[f>>2]=0;k[O>>2]=0;Ra=k[a>>2]|0;k[a>>2]=Ra+-1;if((Ra|0)==1)ggb(k[a+-4>>2]|0)}fa=(ja|0)<1;Na=fa?1:ja;ga=(Na|0)>100;Na=ga?100:Na;K=(k[q+24>>2]|0)+2|0;S=k[g>>2]|0;B=S+2|0;C=y9(B,K,0)|0;z9(C);if(!C)Ra=0;else{while(1){f=fgb(16)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[f+4>>2]=1;k[f>>2]=85876;k[f+8>>2]=C;Ra=f}ea=y9(B,K,5)|0;z9(ea);if(!ea)Qa=0;else{while(1){f=fgb(16)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[f+4>>2]=1;k[f>>2]=85876;k[f+8>>2]=ea;Qa=f}R=y9(B,K,0)|0;z9(R);if(!R)Pa=0;else{while(1){f=fgb(16)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[f+4>>2]=1;k[f>>2]=85876;k[f+8>>2]=R;Pa=f}da=y9(B,K,0)|0;z9(da);if(!da)Oa=0;else{while(1){f=fgb(16)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[f+4>>2]=1;k[f>>2]=85876;k[f+8>>2]=da;Oa=f}s=Hra(3,3,1,1,1)|0;if(!s)Ma=0;else{while(1){f=fgb(16)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[f+4>>2]=1;k[f>>2]=151020;k[f+8>>2]=s;Ma=f}wY(q,ha);k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;k[y+16>>2]=0;k[y+20>>2]=0;k[y+24>>2]=0;k[y+28>>2]=0;k[O>>2]=k[y>>2];k[O+4>>2]=k[y+4>>2];k[O+8>>2]=k[y+8>>2];k[O+12>>2]=k[y+12>>2];k[O+16>>2]=k[y+16>>2];k[O+20>>2]=k[y+20>>2];k[O+24>>2]=k[y+24>>2];k[O+28>>2]=k[y+28>>2];xY(da,O,0);m=x+20|0;if((k[m>>2]|0)>0){n=x+24|0;q=x+16|0;h=x+4|0;c=da+16|0;j=da+4|0;b=0;f=k[n>>2]|0;do{g=b;b=b+1|0;if((f|0)>0){a=0;do{La=(k[q>>2]|0)+(aa(k[h>>2]|0,g)|0)+a|0;if(!(i[La>>0]|0))a=a+1|0;else{a=a+1|0;f=(k[c>>2]|0)+(aa(k[j>>2]|0,b)|0)+a|0;i[f>>0]=2;f=k[n>>2]|0}}while((a|0)<(f|0))}}while((b|0)<(k[m>>2]|0))}Da=da+24|0;f=k[Da>>2]|0;if((f|0)>0){g=da+16|0;a=0;do{i[(k[g>>2]|0)+a>>0]=0;a=a+1|0;f=k[Da>>2]|0}while((a|0)<(f|0))}Ca=da+20|0;if(((k[Ca>>2]|0)+-1|0)>1){g=da+16|0;b=da+4|0;a=1;do{f=(k[g>>2]|0)+(aa(k[b>>2]|0,a)|0)+(f+-1)|0;i[f>>0]=0;f=(k[g>>2]|0)+(aa(k[b>>2]|0,a)|0)|0;i[f>>0]=0;a=a+1|0;f=k[Da>>2]|0}while((a|0)<((k[Ca>>2]|0)+-1|0))}if((f|0)>0){a=da+16|0;g=da+4|0;b=S+1|0;f=0;do{La=(k[a>>2]|0)+(aa(k[g>>2]|0,b)|0)+f|0;i[La>>0]=0;f=f+1|0}while((f|0)<(k[Da>>2]|0))};k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;k[A+16>>2]=0;k[A+20>>2]=0;k[A+24>>2]=0;k[A+28>>2]=0;k[O>>2]=k[A>>2];k[O+4>>2]=k[A+4>>2];k[O+8>>2]=k[A+8>>2];k[O+12>>2]=k[A+12>>2];k[O+16>>2]=k[A+16>>2];k[O+20>>2]=k[A+20>>2];k[O+24>>2]=k[A+24>>2];k[O+28>>2]=k[A+28>>2];xY(C,O,0);p[z>>3]=1.0e6;La=z+8|0;k[La>>2]=0;k[La+4>>2]=0;k[La+8>>2]=0;k[La+12>>2]=0;k[La+16>>2]=0;k[La+20>>2]=0;k[O>>2]=k[z>>2];k[O+4>>2]=k[z+4>>2];k[O+8>>2]=k[z+8>>2];k[O+12>>2]=k[z+12>>2];k[O+16>>2]=k[z+16>>2];k[O+20>>2]=k[z+20>>2];k[O+24>>2]=k[z+24>>2];k[O+28>>2]=k[z+28>>2];xY(ea,O,0);Ira(da,R,s);while(1){f=fgb(24)|0;if(f|0){ca=f;break}f=k[207666]|0;k[207666]=f+0;if(!f){ca=0;break}Qh[f&7]()}k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;k[ca+16>>2]=0;k[ca+20>>2]=0;while(1){f=fgb(16)|0;if(f|0){Ka=f;break}f=k[207666]|0;k[207666]=f+0;if(!f){Ka=0;break}Qh[f&7]()}La=Ka+4|0;k[La>>2]=1;k[Ka>>2]=151040;k[Ka+8>>2]=ca;k[La>>2]=(k[La>>2]|0)+1;Ja=k[La>>2]|0;k[La>>2]=Ja+-1;if((Ja|0)==1)Uh[k[(k[Ka>>2]|0)+8>>2]&2047](Ka);a:do if(a3a(ca,R)|0){DV(R,da,R);J=R+24|0;f=k[J>>2]|0;if((f|0)>0){g=R+16|0;a=0;do{i[(k[g>>2]|0)+a>>0]=0;a=a+1|0;f=k[J>>2]|0}while((a|0)<(f|0))}I=R+20|0;a=k[I>>2]|0;if((a+-1|0)>1){g=R+16|0;b=R+4|0;i[(k[g>>2]|0)+(k[b>>2]|0)+(f+-1)>>0]=0;i[(k[g>>2]|0)+(k[b>>2]|0)>>0]=0;a=k[I>>2]|0;if((a+-1|0)>2){f=2;do{a=(k[g>>2]|0)+(aa(k[b>>2]|0,f)|0)+((k[J>>2]|0)+-1)|0;i[a>>0]=0;a=(k[g>>2]|0)+(aa(k[b>>2]|0,f)|0)|0;i[a>>0]=0;f=f+1|0;a=k[I>>2]|0}while((f|0)<(a+-1|0))}f=k[J>>2]|0}if((f|0)>0){g=R+16|0;b=R+4|0;h=S+1|0;a=0;do{f=(k[g>>2]|0)+(aa(k[b>>2]|0,h)|0)+a|0;i[f>>0]=0;a=a+1|0;f=k[J>>2]|0}while((a|0)<(f|0));a=k[I>>2]|0}if((a|0)>0){n=R+16|0;q=R+4|0;s=ca+4|0;x=ca+12|0;y=ca+20|0;m=0;do{if((f|0)>0){j=aa(k[q>>2]|0,m)|0;c=0;do{if(i[(k[n>>2]|0)+j+c>>0]|0){b=k[s>>2]|0;if((b|0)==(k[x>>2]|0)){a=0;g=0;b=0;break a}else g=b;while(1){h=g+12|0;f=k[h>>2]|0;if(+o[f>>2]>0.0)g=f;else break}f=b+16|0;a=k[f>>2]|0;if((g|0)==(b|0))k[s>>2]=a;else{Ia=b+12|0;Ha=k[Ia>>2]|0;k[Ha+16>>2]=a;Ja=k[f>>2]|0;k[Ja+12>>2]=Ha;k[s>>2]=Ja;Ja=k[h>>2]|0;k[Ia>>2]=Ja;k[f>>2]=g;k[Ja+16>>2]=b;k[(k[f>>2]|0)+12>>2]=b}k[b+4>>2]=m;k[b+8>>2]=c;o[b>>2]=0.0;k[y>>2]=(k[y>>2]|0)+1;f=k[J>>2]|0}c=c+1|0}while((c|0)<(f|0));a=k[I>>2]|0}m=m+1|0}while((m|0)<(a|0))}p[L>>3]=1.0;Ja=L+8|0;k[Ja>>2]=0;k[Ja+4>>2]=0;k[Ja+8>>2]=0;k[Ja+12>>2]=0;k[Ja+16>>2]=0;k[Ja+20>>2]=0;k[O>>2]=k[L>>2];k[O+4>>2]=k[L+4>>2];k[O+8>>2]=k[L+8>>2];k[O+12>>2]=k[L+12>>2];k[O+16>>2]=k[L+16>>2];k[O+20>>2]=k[L+20>>2];k[O+24>>2]=k[L+24>>2];k[O+28>>2]=k[L+28>>2];xY(C,O,R);p[M>>3]=2.0;Ja=M+8|0;k[Ja>>2]=0;k[Ja+4>>2]=0;k[Ja+8>>2]=0;k[Ja+12>>2]=0;k[Ja+16>>2]=0;k[Ja+20>>2]=0;k[O>>2]=k[M>>2];k[O+4>>2]=k[M+4>>2];k[O+8>>2]=k[M+8>>2];k[O+12>>2]=k[M+12>>2];k[O+16>>2]=k[M+16>>2];k[O+20>>2]=k[M+20>>2];k[O+24>>2]=k[M+24>>2];k[O+28>>2]=k[M+28>>2];xY(C,O,da);k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;k[N+16>>2]=0;k[N+20>>2]=0;k[N+24>>2]=0;k[N+28>>2]=0;k[O>>2]=k[N>>2];k[O+4>>2]=k[N+4>>2];k[O+8>>2]=k[N+8>>2];k[O+12>>2]=k[N+12>>2];k[O+16>>2]=k[N+16>>2];k[O+20>>2]=k[N+20>>2];k[O+24>>2]=k[N+24>>2];k[O+28>>2]=k[N+28>>2];xY(ea,O,R);switch(e|0){case 1:{ba=y9(B,K,0)|0;z9(ba);if(!ba)b=0;else{while(1){b=fgb(16)|0;if(b|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){b=0;break}Qh[f&7]()}k[b+4>>2]=1;k[b>>2]=85876;k[b+8>>2]=ba}g=Na<<1|1;g=Hra(g,g,Na,Na,0)|0;if(!g)a=0;else{while(1){a=fgb(16)|0;if(a|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){a=0;break}Qh[f&7]()}k[a+4>>2]=1;k[a>>2]=151020;k[a+8>>2]=g}Ira(da,ba,g);DV(ba,da,ba);while(1){f=fgb(24)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;while(1){g=fgb(16)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}Ia=h+4|0;k[Ia>>2]=1;k[h>>2]=151040;k[h+8>>2]=f;g=h;k[Ia>>2]=(k[Ia>>2]|0)+1;Ja=k[Ia>>2]|0;k[Ia>>2]=Ja+-1;if((Ja|0)==1)Uh[k[(k[h>>2]|0)+8>>2]&2047](h);if(!(a3a(f,ba)|0))break a;h=k[I>>2]|0;if((h|0)>0){y=R+16|0;z=R+4|0;A=f+4|0;B=f+12|0;C=f+20|0;x=0;c=k[J>>2]|0;do{if((c|0)>0){s=aa(k[z>>2]|0,x)|0;q=0;do{if(i[(k[y>>2]|0)+s+q>>0]|0){m=k[A>>2]|0;if((m|0)==(k[B>>2]|0))break a;else j=m;while(1){n=j+12|0;h=k[n>>2]|0;if(+o[h>>2]>0.0)j=h;else break}h=m+16|0;c=k[h>>2]|0;if((j|0)==(m|0))k[A>>2]=c;else{Ia=m+12|0;Ha=k[Ia>>2]|0;k[Ha+16>>2]=c;Ja=k[h>>2]|0;k[Ja+12>>2]=Ha;k[A>>2]=Ja;Ja=k[n>>2]|0;k[Ia>>2]=Ja;k[h>>2]=j;k[Ja+16>>2]=m;k[(k[h>>2]|0)+12>>2]=m}k[m+4>>2]=x;k[m+8>>2]=q;o[m>>2]=0.0;k[C>>2]=(k[C>>2]|0)+1;c=k[J>>2]|0}q=q+1|0}while((q|0)<(c|0));h=k[I>>2]|0}x=x+1|0}while((x|0)<(h|0))}DV(ba,R,ba);$=ba+24|0;h=k[$>>2]|0;if((h|0)>0){j=ba+16|0;c=0;do{i[(k[j>>2]|0)+c>>0]=0;c=c+1|0;h=k[$>>2]|0}while((c|0)<(h|0))}X=ba+20|0;if(((k[X>>2]|0)+-1|0)>1){j=ba+16|0;m=ba+4|0;c=1;do{h=(k[j>>2]|0)+(aa(k[m>>2]|0,c)|0)+(h+-1)|0;i[h>>0]=0;h=(k[j>>2]|0)+(aa(k[m>>2]|0,c)|0)|0;i[h>>0]=0;c=c+1|0;h=k[$>>2]|0}while((c|0)<((k[X>>2]|0)+-1|0))}if((h|0)>0){j=ba+16|0;m=ba+4|0;c=S+1|0;h=0;do{Ja=(k[j>>2]|0)+(aa(k[m>>2]|0,c)|0)+h|0;i[Ja>>0]=0;h=h+1|0}while((h|0)<(k[$>>2]|0))}R=f+8|0;c=k[(k[R>>2]|0)+16>>2]|0;S=f+4|0;h=k[S>>2]|0;if((h|0)!=(c|0)){T=f+20|0;U=ba+16|0;V=ba+4|0;e=ea+4|0;O=ea+16|0;N=f+12|0;do{L=k[c+4>>2]|0;M=k[c+8>>2]|0;C=c+16|0;J=c+12|0;I=k[J>>2]|0;k[I+16>>2]=k[C>>2];k[(k[C>>2]|0)+12>>2]=I;I=k[h+12>>2]|0;k[J>>2]=I;k[C>>2]=h;k[I+16>>2]=c;k[(k[C>>2]|0)+12>>2]=c;k[S>>2]=c;k[T>>2]=(k[T>>2]|0)+-1;C=(k[U>>2]|0)+(aa(k[V>>2]|0,L)|0)+M|0;i[C>>0]=3;C=M+1|0;I=L+-1|0;J=M+-1|0;K=L+1|0;B=0;do{switch(B|0){case 0:{z=I;A=M;break}case 1:{z=L;A=J;break}case 2:{z=K;A=M;break}default:{z=L;A=C}}do if(!((A|0)<1|(z|0)<1)){if((z|0)>(k[X>>2]|0))break;if((A|0)>(k[$>>2]|0))break;c=k[U>>2]|0;j=k[V>>2]|0;n=c+(aa(j,z)|0)|0;s=n+A|0;if((i[s>>0]|0)!=2)break;q=z+-1|0;m=A+-1|0;f=k[e>>2]|0;h=k[O>>2]|0;x=A<<2;y=h+(aa(f,q)|0)+x|0;F=+o[y>>2];y=h+(aa(f,z)|0)|0;v=+o[y+(m<<2)>>2];d=F>v?v:F;q=c+(aa(j,q)|0)+A|0;q=(i[q>>0]|0)==2;m=(i[n+m>>0]|0)!=2;do if(q)if(m){d=v+1.0;break}else{d=d+1.0;break}else{if(!m){d=F+1.0;break}t=F-v;if(!(+P(+t)>=1.0)){d=(F+v+ +Q(+(2.0-t*t)))*.5;break}else{d=d+1.0;break}}while(0);G=d;Ja=z+1|0;h=h+(aa(f,Ja)|0)+x|0;E=+o[h>>2];t=E>v?v:E;h=c+(aa(j,Ja)|0)+A|0;h=(i[h>>0]|0)==2;do if(h)if(m){d=v+1.0;break}else{d=t+1.0;break}else{if(!m){d=E+1.0;break}d=E-v;if(!(+P(+d)>=1.0)){d=(v+E+ +Q(+(2.0-d*d)))*.5;break}else{d=t+1.0;break}}while(0);D=d;f=A+1|0;w=+o[y+(f<<2)>>2];t=F>w?w:F;f=(i[n+f>>0]|0)!=2;do if(q)if(f){d=w+1.0;break}else{d=t+1.0;break}else{if(!f){d=F+1.0;break}d=F-w;if(!(+P(+d)>=1.0)){d=(F+w+ +Q(+(2.0-d*d)))*.5;break}else{d=t+1.0;break}}while(0);v=d;t=E>w?w:E;do if(h)if(f){d=w+1.0;break}else{d=t+1.0;break}else{if(!f){d=E+1.0;break}d=E-w;if(!(+P(+d)>=1.0)){d=(E+w+ +Q(+(2.0-d*d)))*.5;break}else{d=t+1.0;break}}while(0);ia=d;d=G>D?D:G;ia=v>ia?ia:v;d=d>ia?ia:d;o[y+x>>2]=d;i[s>>0]=1;j=k[S>>2]|0;if((j|0)==(k[N>>2]|0))break;else c=j;while(1){m=c+12|0;f=k[m>>2]|0;if(+o[f>>2]>d)c=f;else break}f=j+16|0;h=k[f>>2]|0;if((c|0)==(j|0))k[S>>2]=h;else{Ia=j+12|0;Ha=k[Ia>>2]|0;k[Ha+16>>2]=h;Ja=k[f>>2]|0;k[Ja+12>>2]=Ha;k[S>>2]=Ja;Ja=k[m>>2]|0;k[Ia>>2]=Ja;k[f>>2]=c;k[Ja+16>>2]=j;k[(k[f>>2]|0)+12>>2]=j}k[j+4>>2]=z;k[j+8>>2]=A;o[j>>2]=d;k[T>>2]=(k[T>>2]|0)+1}while(0);B=B+1|0}while((B|0)!=4);c=k[(k[R>>2]|0)+16>>2]|0;h=k[S>>2]|0}while((h|0)!=(c|0))}f=k[X>>2]|0;if((f|0)>0){s=ba+16|0;m=ba+4|0;n=ea+16|0;q=ea+4|0;j=0;h=k[$>>2]|0;do{if((h|0)>0){c=0;f=h;do{h=(k[s>>2]|0)+(aa(k[m>>2]|0,j)|0)+c|0;if((i[h>>0]|0)==3){i[h>>0]=0;f=(k[n>>2]|0)+(aa(k[q>>2]|0,j)|0)+(c<<2)|0;o[f>>2]=-+o[f>>2];f=k[$>>2]|0}c=c+1|0}while((c|0)<(f|0));h=f;f=k[X>>2]|0}j=j+1|0}while((j|0)<(f|0))}switch((k[ha>>2]|0)>>>3&511){case 2:break;case 0:{ya=ca+8|0;f=k[(k[ya>>2]|0)+16>>2]|0;za=ca+4|0;h=k[za>>2]|0;if((h|0)==(f|0))break a;Aa=ca+20|0;Ba=da+16|0;va=da+4|0;wa=ea+20|0;xa=ea+24|0;ua=ea+4|0;sa=ea+16|0;ta=ha+16|0;ra=ha+4|0;qa=aa(ja,ja)|0;qa=ga?1e4:fa?1:qa;pa=ca+12|0;c=0;j=0;while(1){na=k[f+4>>2]|0;oa=k[f+8>>2]|0;ja=f+16|0;la=f+12|0;ka=k[la>>2]|0;k[ka+16>>2]=k[ja>>2];k[(k[ja>>2]|0)+12>>2]=ka;ka=k[h+12>>2]|0;k[la>>2]=ka;k[ja>>2]=h;k[ka+16>>2]=f;k[(k[ja>>2]|0)+12>>2]=f;k[za>>2]=f;k[Aa>>2]=(k[Aa>>2]|0)+-1;ja=(k[Ba>>2]|0)+(aa(k[va>>2]|0,na)|0)+oa|0;i[ja>>0]=0;ja=na+-1|0;ka=oa+-1|0;la=na+1|0;ma=oa+1|0;ha=0;h=c;f=j;while(1){switch(ha|0){case 0:{j=ja;c=oa;break}case 1:{j=na;c=ka;break}case 2:{j=la;c=oa;break}case 3:{j=na;c=ma;break}default:{j=f;c=h}}do if(!((c|0)<2|(j|0)<2)){C=k[wa>>2]|0;if((j|0)>=(C|0))break;I=k[xa>>2]|0;if((c|0)>=(I|0))break;da=k[Ba>>2]|0;ea=k[va>>2]|0;h=da+(aa(ea,j)|0)|0;if((i[h+c>>0]|0)!=2)break;fa=j+-1|0;ga=c+-1|0;ba=k[ua>>2]|0;ca=k[sa>>2]|0;q=c<<2;B=ca+(aa(ba,fa)|0)+q|0;F=+o[B>>2];s=ca+(aa(ba,j)|0)|0;W=+o[s+(ga<<2)>>2];w=W;d=F>w?w:F;A=da+(aa(ea,fa)|0)+c|0;m=(i[A>>0]|0)==2;x=h+ga|0;f=(i[x>>0]|0)!=2;do if(m)if(f){d=w+1.0;break}else{d=d+1.0;break}else{if(!f){d=F+1.0;break}t=F-w;if(!(+P(+t)>=1.0)){d=(F+w+ +Q(+(2.0-t*t)))*.5;break}else{d=d+1.0;break}}while(0);z=j+1|0;y=ca+(aa(ba,z)|0)+q|0;G=+o[y>>2];v=G>w?w:G;z=da+(aa(ea,z)|0)+c|0;n=(i[z>>0]|0)==2;do if(n)if(f){t=w+1.0;break}else{t=v+1.0;break}else{if(!f){t=G+1.0;break}t=G-w;if(!(+P(+t)>=1.0)){t=(w+G+ +Q(+(2.0-t*t)))*.5;break}else{t=v+1.0;break}}while(0);E=t;f=c+1|0;H=+o[s+(f<<2)>>2];D=H;v=F>D?D:F;h=h+f|0;f=(i[h>>0]|0)!=2;do if(m)if(f){t=D+1.0;break}else{t=v+1.0;break}else{if(!f){t=F+1.0;break}t=F-D;if(!(+P(+t)>=1.0)){t=(F+D+ +Q(+(2.0-t*t)))*.5;break}else{t=v+1.0;break}}while(0);w=t;v=G>D?D:G;do if(n)if(f){t=D+1.0;break}else{t=v+1.0;break}else{if(!f){t=G+1.0;break}t=G-D;if(!(+P(+t)>=1.0)){t=(G+D+ +Q(+(2.0-t*t)))*.5;break}else{t=v+1.0;break}}while(0);_=t;ia=d>E?E:d;_=w>_?_:w;ia=ia>_?_:ia;o[s+q>>2]=ia;n=j-Na|0;U=j+Na|0;m=(n|0)>(U|0);V=c-Na|0;X=c+Na|0;$=(V|0)>(X|0);f=(i[x>>0]|0)!=2;do if((i[h>>0]|0)!=2)if(f){h=(o[u>>2]=(H-W)*.5,k[u>>2]|0);break}else{h=(o[u>>2]=H-ia,k[u>>2]|0);break}else{if(!f){h=0;break}h=(o[u>>2]=ia-W,k[u>>2]|0)}while(0);f=(i[A>>0]|0)!=2;do if((i[z>>0]|0)!=2){d=+o[y>>2];if(f){f=(o[u>>2]=(d-+o[B>>2])*.5,k[u>>2]|0);break}else{f=(o[u>>2]=d-ia,k[u>>2]|0);break}}else{if(!f){f=0;break}f=(o[u>>2]=ia-+o[B>>2],k[u>>2]|0)}while(0);if(m){w=9.999999682655225e-21;v=0.0;t=0.0;d=0.0}else{T=C+-2|0;_=(k[u>>2]=h,+o[u>>2]);Z=(k[u>>2]=f,+o[u>>2]);R=C+-1|0;S=I+-2|0;O=I+-1|0;w=9.999999682655225e-21;v=0.0;t=0.0;d=0.0;while(1){h=n+-1|0;B=((n|0)==1&1)+h|0;C=h-((n|0)==(T|0)&1)|0;if($)f=n+1|0;else{I=(n|0)>0;J=n-j|0;J=aa(J,J)|0;H=+(j-n|0);W=H*H;Y=Z*H;f=n+1|0;K=B+-1|0;L=C+1|0;M=(n|0)<(R|0);N=da+(aa(n,ea)|0)|0;e=da+(aa(f,ea)|0)|0;z=da+(aa(h,ea)|0)|0;A=ca+(aa(ba,n)|0)|0;y=V;while(1){h=y+-1|0;x=((y|0)==1&1)+h|0;m=h-((y|0)==(S|0)&1)|0;do if(I&(y|0)>0&(M&(y|0)<(O|0))){if((i[N+y>>0]|0)==2)break;Ja=y-c|0;if(((aa(Ja,Ja)|0)+J|0)>>>0>qa>>>0)break;F=+(c-y|0);D=W+F*F;D=1.0/(D*+Q(+D));E=1.0/(+P(+(+o[A+(y<<2)>>2]-ia))+1.0);G=Y+_*F;q=!(+P(+G)<=.01);G=+P(+(D*E*(q?G:9.999999974752427e-07)));q=(i[N+h>>0]|0)!=2;do if((i[N+(y+1)>>0]|0)!=2){s=(k[ta>>2]|0)+(aa(k[ra>>2]|0,B)|0)|0;h=l[s+(m+1)>>0]|0;if(q){E=+(h-(l[s+(x+-1)>>0]|0)|0)*2.0;break}else{E=+(h-(l[s+x>>0]|0)|0);break}}else{if(!q){E=0.0;break}Ja=(k[ta>>2]|0)+(aa(k[ra>>2]|0,B)|0)|0;E=+((l[Ja+m>>0]|0)-(l[Ja+(x+-1)>>0]|0)|0)}while(0);h=(i[z+y>>0]|0)!=2;do if((i[e+y>>0]|0)!=2){m=k[ta>>2]|0;q=k[ra>>2]|0;s=m+(aa(q,L)|0)+x|0;s=l[s>>0]|0;if(h){Ja=m+(aa(q,K)|0)+x|0;D=+(s-(l[Ja>>0]|0)|0)*2.0;break}else{Ja=m+(aa(q,B)|0)+x|0;D=+(s-(l[Ja>>0]|0)|0);break}}else{if(!h){D=0.0;break}Ha=k[ta>>2]|0;Ja=k[ra>>2]|0;Ia=Ha+(aa(Ja,C)|0)+x|0;Ja=Ha+(aa(Ja,K)|0)+x|0;D=+((l[Ia>>0]|0)-(l[Ja>>0]|0)|0)}while(0);Ja=(k[ta>>2]|0)+(aa(k[ra>>2]|0,B)|0)+x|0;w=w+G;v=v-G*(H*D);t=t-G*(F*E);d=d+G*+(l[Ja>>0]|0)}while(0);if((y|0)<(X|0))y=y+1|0;else break}}if((n|0)<(U|0))n=f;else break}}d=d/w+(t+v)/(+Q(+(t*t+v*v))+9.999999682655225e-21)+.5;f=(o[u>>2]=d,k[u>>2]|0);do if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;d=f?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(!(d==0.0))break;d=f?-0.0:0.0}while(0);Ja=~~d;n=(k[ta>>2]|0)+(aa(k[ra>>2]|0,fa)|0)+ga|0;i[n>>0]=Ja>>>0<256?Ja:(Ja|0)>0?255:0;n=(k[Ba>>2]|0)+(aa(k[va>>2]|0,j)|0)+c|0;i[n>>0]=1;n=k[za>>2]|0;if((n|0)==(k[pa>>2]|0))break;else m=n;while(1){q=m+12|0;f=k[q>>2]|0;if(+o[f>>2]>ia)m=f;else break}f=n+16|0;h=k[f>>2]|0;if((m|0)==(n|0))k[za>>2]=h;else{Ia=n+12|0;Ha=k[Ia>>2]|0;k[Ha+16>>2]=h;Ja=k[f>>2]|0;k[Ja+12>>2]=Ha;k[za>>2]=Ja;Ja=k[q>>2]|0;k[Ia>>2]=Ja;k[f>>2]=m;k[Ja+16>>2]=n;k[(k[f>>2]|0)+12>>2]=n}k[n+4>>2]=j;k[n+8>>2]=c;o[n>>2]=ia;k[Aa>>2]=(k[Aa>>2]|0)+1}while(0);ha=ha+1|0;if((ha|0)==4)break;else{h=c;f=j}}f=k[(k[ya>>2]|0)+16>>2]|0;h=k[za>>2]|0;if((h|0)==(f|0))break a}}default:break a}Ga=ca+8|0;f=k[(k[Ga>>2]|0)+16>>2]|0;Ha=ca+4|0;h=k[Ha>>2]|0;if((h|0)==(f|0))break a;Ia=ca+20|0;Ja=da+16|0;Da=da+4|0;Ea=ea+20|0;Fa=ea+24|0;Ca=ea+4|0;Aa=ea+16|0;Ba=ha+16|0;za=ha+4|0;ya=aa(ja,ja)|0;ya=ga?1e4:fa?1:ya;xa=ca+12|0;c=0;j=0;do{va=k[f+4>>2]|0;wa=k[f+8>>2]|0;ra=f+16|0;ta=f+12|0;sa=k[ta>>2]|0;k[sa+16>>2]=k[ra>>2];k[(k[ra>>2]|0)+12>>2]=sa;sa=k[h+12>>2]|0;k[ta>>2]=sa;k[ra>>2]=h;k[sa+16>>2]=f;k[(k[ra>>2]|0)+12>>2]=f;k[Ha>>2]=f;k[Ia>>2]=(k[Ia>>2]|0)+-1;ra=(k[Ja>>2]|0)+(aa(k[Da>>2]|0,va)|0)+wa|0;i[ra>>0]=0;ra=va+-1|0;sa=wa+-1|0;ta=va+1|0;ua=wa+1|0;qa=0;h=c;f=j;while(1){switch(qa|0){case 0:{j=ra;c=wa;break}case 1:{j=va;c=sa;break}case 2:{j=ta;c=wa;break}case 3:{j=va;c=ua;break}default:{j=f;c=h}}do if(!((c|0)<2|(j|0)<2)){if((j|0)>=(k[Ea>>2]|0))break;if((c|0)>=(k[Fa>>2]|0))break;y=k[Ja>>2]|0;x=k[Da>>2]|0;s=y+(aa(x,j)|0)|0;if((i[s+c>>0]|0)!=2)break;ma=j+-1|0;na=c+-1|0;f=k[Ca>>2]|0;h=k[Aa>>2]|0;oa=c<<2;q=h+(aa(f,ma)|0)+oa|0;D=+o[q>>2];q=h+(aa(f,j)|0)|0;pa=na<<2;w=+o[q+pa>>2];d=D>w?w:D;n=y+(aa(x,ma)|0)+c|0;n=(i[n>>0]|0)==2;m=(i[s+na>>0]|0)!=2;do if(n)if(m){d=w+1.0;break}else{d=d+1.0;break}else{if(!m){d=D+1.0;break}t=D-w;if(!(+P(+t)>=1.0)){d=(D+w+ +Q(+(2.0-t*t)))*.5;break}else{d=d+1.0;break}}while(0);la=j+1|0;h=h+(aa(f,la)|0)+oa|0;F=+o[h>>2];v=F>w?w:F;h=y+(aa(x,la)|0)+c|0;h=(i[h>>0]|0)==2;do if(h)if(m){t=w+1.0;break}else{t=v+1.0;break}else{if(!m){t=F+1.0;break}t=F-w;if(!(+P(+t)>=1.0)){t=(w+F+ +Q(+(2.0-t*t)))*.5;break}else{t=v+1.0;break}}while(0);ja=c+1|0;ka=ja<<2;E=+o[q+ka>>2];w=D>E?E:D;f=(i[s+ja>>0]|0)!=2;do if(n)if(f){v=E+1.0;break}else{v=w+1.0;break}else{if(!f){v=D+1.0;break}v=D-E;if(!(+P(+v)>=1.0)){v=(D+E+ +Q(+(2.0-v*v)))*.5;break}else{v=w+1.0;break}}while(0);D=v;w=F>E?E:F;do if(h)if(f){v=E+1.0;break}else{v=w+1.0;break}else{if(!f){v=F+1.0;break}v=F-E;if(!(+P(+v)>=1.0)){v=(F+E+ +Q(+(2.0-v*v)))*.5;break}else{v=w+1.0;break}}while(0);_=v;ia=d>t?t:d;_=D>_?_:D;ia=ia>_?_:ia;o[q+oa>>2]=ia;ba=j-Na|0;ca=j+Na|0;da=(ba|0)>(ca|0);ea=na*3|0;fa=c-Na|0;ga=c+Na|0;ha=(fa|0)>(ga|0);$=0;f=s;do{h=(i[f+na>>0]|0)!=2;do if((i[f+ja>>0]|0)!=2){f=(k[Aa>>2]|0)+(aa(k[Ca>>2]|0,j)|0)|0;d=+o[f+ka>>2];if(h){n=(o[u>>2]=(d-+o[f+pa>>2])*.5,k[u>>2]|0);break}else{n=(o[u>>2]=d-+o[f+oa>>2],k[u>>2]|0);break}}else{if(!h){n=0;break}n=(k[Aa>>2]|0)+(aa(k[Ca>>2]|0,j)|0)|0;n=(o[u>>2]=+o[n+oa>>2]-+o[n+pa>>2],k[u>>2]|0)}while(0);X=y+(aa(x,la)|0)+c|0;f=y+(aa(x,ma)|0)+c|0;f=(i[f>>0]|0)!=2;do if((i[X>>0]|0)!=2){h=k[Aa>>2]|0;m=k[Ca>>2]|0;X=h+(aa(m,la)|0)+oa|0;d=+o[X>>2];if(f){f=h+(aa(m,ma)|0)+oa|0;f=(o[u>>2]=(d-+o[f>>2])*.5,k[u>>2]|0);break}else{f=h+(aa(m,j)|0)+oa|0;f=(o[u>>2]=d-+o[f>>2],k[u>>2]|0);break}}else{if(!f){f=0;break}V=k[Aa>>2]|0;f=k[Ca>>2]|0;X=V+(aa(f,j)|0)+oa|0;f=V+(aa(f,ma)|0)+oa|0;f=(o[u>>2]=+o[X>>2]-+o[f>>2],k[u>>2]|0)}while(0);if(da){w=0.0;v=0.0;t=0.0;d=9.999999682655225e-21}else{V=k[Ea>>2]|0;X=V+-2|0;_=(k[u>>2]=n,+o[u>>2]);Z=(k[u>>2]=f,+o[u>>2]);T=$+-3|0;U=$+3|0;V=V+-1|0;S=ba;w=0.0;v=0.0;t=0.0;d=9.999999682655225e-21;while(1){h=S+-1|0;B=((S|0)==1&1)+h|0;C=h-((S|0)==(X|0)&1)|0;if(ha)f=S+1|0;else{K=k[Fa>>2]|0;I=K+-2|0;J=(S|0)>0;K=K+-1|0;L=S-j|0;L=aa(L,L)|0;H=+(j-S|0);W=H*H;Y=Z*H;f=S+1|0;M=B+-1|0;N=C+1|0;e=(S|0)<(V|0);O=y+(aa(S,x)|0)|0;R=y+(aa(f,x)|0)|0;A=y+(aa(h,x)|0)|0;z=fa;while(1){h=z+-1|0;s=((z|0)==1&1)+h|0;m=h-((z|0)==(I|0)&1)|0;do if(J&(z|0)>0&(e&(z|0)<(K|0))){if((i[O+z>>0]|0)==2)break;q=z-c|0;if(((aa(q,q)|0)+L|0)>>>0>ya>>>0)break;F=+(c-z|0);D=W+F*F;D=1.0/(D*+Q(+D));Ta=k[Aa>>2]|0;n=k[Ca>>2]|0;q=Ta+(aa(n,S)|0)+(z<<2)|0;n=Ta+(aa(n,j)|0)+oa|0;E=1.0/(+P(+(+o[q>>2]-+o[n>>2]))+1.0);G=Y+_*F;n=!(+P(+G)<=.01);G=+P(+(D*E*(n?G:9.999999974752427e-07)));n=(i[O+h>>0]|0)!=2;do if((i[O+(z+1)>>0]|0)!=2){q=(k[Ba>>2]|0)+(aa(k[za>>2]|0,B)|0)|0;h=l[q+(U+(m*3|0))>>0]|0;m=s*3|0;if(n){E=+(h-(l[q+(m+T)>>0]|0)|0)*2.0;break}else{E=+(h-(l[q+(m+$)>>0]|0)|0);break}}else{if(!n){E=0.0;break}Ta=(k[Ba>>2]|0)+(aa(k[za>>2]|0,B)|0)|0;E=+((l[Ta+((m*3|0)+$)>>0]|0)-(l[Ta+((s*3|0)+T)>>0]|0)|0)}while(0);m=(i[A+z>>0]|0)!=2;do if((i[R+z>>0]|0)==2)if(m){q=k[Ba>>2]|0;Ta=k[za>>2]|0;h=(s*3|0)+$|0;s=q+(aa(Ta,C)|0)+h|0;Ta=q+(aa(Ta,M)|0)+h|0;D=+((l[s>>0]|0)-(l[Ta>>0]|0)|0);break}else{h=(s*3|0)+$|0;D=0.0;break}else{n=k[Ba>>2]|0;q=k[za>>2]|0;h=(s*3|0)+$|0;s=n+(aa(q,N)|0)+h|0;s=l[s>>0]|0;if(m){Ta=n+(aa(q,M)|0)+h|0;D=+(s-(l[Ta>>0]|0)|0)*2.0;break}else{Ta=n+(aa(q,B)|0)+h|0;D=+(s-(l[Ta>>0]|0)|0);break}}while(0);Ta=(k[Ba>>2]|0)+(aa(k[za>>2]|0,B)|0)+h|0;w=w+G*+(l[Ta>>0]|0);v=v-G*(F*E);t=t-G*(H*D);d=d+G}while(0);if((z|0)<(ga|0))z=z+1|0;else break}}if((S|0)<(ca|0))S=f;else break}}d=w/d+(t+v)/(+Q(+(t*t+v*v))+9.999999682655225e-21)+.5;f=(o[u>>2]=d,k[u>>2]|0);do if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;d=f?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(!(d==0.0))break;d=f?-0.0:0.0}while(0);x=~~d;y=(k[Ba>>2]|0)+(aa(k[za>>2]|0,ma)|0)+($+ea)|0;i[y>>0]=x>>>0<256?x:(x|0)>0?255:0;$=$+1|0;y=k[Ja>>2]|0;x=k[Da>>2]|0;f=y+(aa(x,j)|0)|0}while(($|0)!=3);i[f+c>>0]=1;n=k[Ha>>2]|0;if((n|0)==(k[xa>>2]|0))break;else m=n;while(1){q=m+12|0;f=k[q>>2]|0;if(+o[f>>2]>ia)m=f;else break}f=n+16|0;h=k[f>>2]|0;if((m|0)==(n|0))k[Ha>>2]=h;else{pa=n+12|0;oa=k[pa>>2]|0;k[oa+16>>2]=h;Ta=k[f>>2]|0;k[Ta+12>>2]=oa;k[Ha>>2]=Ta;Ta=k[q>>2]|0;k[pa>>2]=Ta;k[f>>2]=m;k[Ta+16>>2]=n;k[(k[f>>2]|0)+12>>2]=n}k[n+4>>2]=j;k[n+8>>2]=c;o[n>>2]=ia;k[Ia>>2]=(k[Ia>>2]|0)+1}while(0);qa=qa+1|0;if((qa|0)==4)break;else{h=c;f=j}}f=k[(k[Ga>>2]|0)+16>>2]|0;h=k[Ha>>2]|0}while((h|0)!=(f|0));break}case 0:{switch((k[ha>>2]|0)>>>3&511){case 2:break;case 0:{va=ca+8|0;f=k[(k[va>>2]|0)+16>>2]|0;wa=ca+4|0;a=k[wa>>2]|0;if((a|0)==(f|0)){a=0;g=0;b=0;break a}xa=ca+20|0;ya=da+16|0;sa=da+4|0;ta=ea+20|0;ua=ea+24|0;ra=ea+4|0;pa=ea+16|0;qa=ha+16|0;oa=ha+4|0;na=ca+12|0;ma=aa(ja,ja)|0;ma=ga?1e4:fa?1:ma;g=0;b=0;while(1){ka=k[f+4>>2]|0;la=k[f+8>>2]|0;fa=f+16|0;ha=f+12|0;ga=k[ha>>2]|0;k[ga+16>>2]=k[fa>>2];k[(k[fa>>2]|0)+12>>2]=ga;ga=k[a+12>>2]|0;k[ha>>2]=ga;k[fa>>2]=a;k[ga+16>>2]=f;k[(k[fa>>2]|0)+12>>2]=f;k[wa>>2]=f;k[xa>>2]=(k[xa>>2]|0)+-1;fa=(k[ya>>2]|0)+(aa(k[sa>>2]|0,ka)|0)+la|0;i[fa>>0]=0;fa=ka+-1|0;ga=la+-1|0;ha=ka+1|0;ja=la+1|0;ea=0;a=g;f=b;while(1){switch(ea|0){case 0:{b=fa;g=la;break}case 1:{b=ka;g=ga;break}case 2:{b=ha;g=la;break}case 3:{b=ka;g=ja;break}default:{b=f;g=a}}do if(!((g|0)<2|(b|0)<2)){s=k[ta>>2]|0;if((b|0)>=(s|0))break;q=k[ua>>2]|0;if((g|0)>=(q|0))break;$=k[ya>>2]|0;ba=k[sa>>2]|0;c=$+(aa(ba,b)|0)|0;if((i[c+g>>0]|0)!=2)break;ca=b+-1|0;da=g+-1|0;f=k[ra>>2]|0;a=k[pa>>2]|0;m=g<<2;n=a+(aa(f,ca)|0)+m|0;F=+o[n>>2];n=a+(aa(f,b)|0)|0;v=+o[n+(da<<2)>>2];d=F>v?v:F;j=$+(aa(ba,ca)|0)+g|0;j=(i[j>>0]|0)==2;h=(i[c+da>>0]|0)!=2;do if(j)if(h){d=v+1.0;break}else{d=d+1.0;break}else{if(!h){d=F+1.0;break}t=F-v;if(!(+P(+t)>=1.0)){d=(F+v+ +Q(+(2.0-t*t)))*.5;break}else{d=d+1.0;break}}while(0);G=d;Ta=b+1|0;a=a+(aa(f,Ta)|0)+m|0;E=+o[a>>2];t=E>v?v:E;a=$+(aa(ba,Ta)|0)+g|0;a=(i[a>>0]|0)==2;do if(a)if(h){d=v+1.0;break}else{d=t+1.0;break}else{if(!h){d=E+1.0;break}d=E-v;if(!(+P(+d)>=1.0)){d=(v+E+ +Q(+(2.0-d*d)))*.5;break}else{d=t+1.0;break}}while(0);D=d;f=g+1|0;w=+o[n+(f<<2)>>2];t=F>w?w:F;f=(i[c+f>>0]|0)!=2;do if(j)if(f){d=w+1.0;break}else{d=t+1.0;break}else{if(!f){d=F+1.0;break}d=F-w;if(!(+P(+d)>=1.0)){d=(F+w+ +Q(+(2.0-d*d)))*.5;break}else{d=t+1.0;break}}while(0);v=d;t=E>w?w:E;do if(a)if(f){d=w+1.0;break}else{d=t+1.0;break}else{if(!f){d=E+1.0;break}d=E-w;if(!(+P(+d)>=1.0)){d=(E+w+ +Q(+(2.0-d*d)))*.5;break}else{d=t+1.0;break}}while(0);ia=d;W=G>D?D:G;ia=v>ia?ia:v;W=W>ia?ia:W;o[n+m>>2]=W;f=b-Na|0;R=b+Na|0;if((f|0)>(R|0)){t=9.999999682655225e-21;d=0.0}else{S=s+-2|0;T=g-Na|0;U=g+Na|0;V=(T|0)>(U|0);X=q+-2|0;O=q+-1|0;e=s+-1|0;t=9.999999682655225e-21;d=0.0;while(1){h=f+-1|0;A=((f|0)==1&1)+h|0;B=h-((f|0)==(S|0)&1)|0;if(V)a=f+1|0;else{C=(f|0)>0;I=f-b|0;I=aa(I,I)|0;G=+(b-f|0);H=G*G;a=f+1|0;J=A+-1|0;K=B+1|0;L=(f|0)<(e|0);M=$+(aa(f,ba)|0)|0;N=$+(aa(a,ba)|0)|0;z=$+(aa(h,ba)|0)|0;y=T;while(1){q=y+-1|0;x=((y|0)==1&1)+q|0;s=((y|0)==(X|0))<<31>>31;do if(C&(y|0)>0&(L&(y|0)<(O|0))){if((i[M+y>>0]|0)==2)break;Ta=y-g|0;if(((aa(Ta,Ta)|0)+I|0)>>>0>ma>>>0)break;v=+(g-y|0);E=H+v*v;F=1.0/(E*E+1.0);h=(i[z+y>>0]|0)!=2;do if((i[N+y>>0]|0)!=2){c=k[qa>>2]|0;j=k[oa>>2]|0;n=c+(aa(j,K)|0)+x|0;m=c+(aa(j,B)|0)+x|0;m=l[m>>0]|0;n=(l[n>>0]|0)-m|0;n=(n|0)>-1?n:0-n|0;if(h){Ta=c+(aa(j,J)|0)+x|0;Ta=m-(l[Ta>>0]|0)|0;n=(o[u>>2]=+(((Ta|0)>-1?Ta:0-Ta|0)+n|0),k[u>>2]|0);break}else{n=(o[u>>2]=+(n|0)*2.0,k[u>>2]|0);break}}else{if(!h){n=0;break}Ja=k[qa>>2]|0;n=k[oa>>2]|0;Ta=Ja+(aa(n,B)|0)+x|0;n=Ja+(aa(n,J)|0)+x|0;n=(l[Ta>>0]|0)-(l[n>>0]|0)|0;n=(o[u>>2]=+(((n|0)>-1?n:0-n|0)|0)*2.0,k[u>>2]|0)}while(0);c=(i[M+q>>0]|0)!=2;do if((i[M+(y+1)>>0]|0)!=2){j=(k[qa>>2]|0)+(aa(k[oa>>2]|0,A)|0)|0;m=l[j+x>>0]|0;h=(l[j+(s+y)>>0]|0)-m|0;h=(h|0)>-1?h:0-h|0;if(c){Ta=m-(l[j+(x+-1)>>0]|0)|0;h=(o[u>>2]=+(((Ta|0)>-1?Ta:0-Ta|0)+h|0),k[u>>2]|0);break}else{h=(o[u>>2]=+(h|0)*2.0,k[u>>2]|0);break}}else{if(!c){h=0;break}h=(k[qa>>2]|0)+(aa(k[oa>>2]|0,A)|0)|0;h=(l[h+x>>0]|0)-(l[h+(x+-1)>>0]|0)|0;h=(o[u>>2]=+(((h|0)>-1?h:0-h|0)|0)*2.0,k[u>>2]|0)}while(0);D=(k[u>>2]=n,+o[u>>2]);w=(k[u>>2]=h,+o[u>>2]);v=G*w-v*D;if(!(+P(+v)<=.01))v=+P(+(v/+Q(+(E*(D*D+w*w)))));else v=9.999999974752427e-07;ia=F*v;Ta=(k[qa>>2]|0)+(aa(k[oa>>2]|0,A)|0)+x|0;t=t+ia;d=d+ia*+(l[Ta>>0]|0)}while(0);if((y|0)<(U|0))y=y+1|0;else break}}if((f|0)<(R|0))f=a;else break}}d=d/t;p[u>>3]=d;f=k[u+4>>2]|0;Ta=f&2146435072;do if(!(Ta>>>0>1126170624|(Ta|0)==1126170624&0>0)){f=(f|0)<0;d=f?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(!(d==0.0))break;d=f?-0.0:0.0}while(0);Ta=~~d;c=(k[qa>>2]|0)+(aa(k[oa>>2]|0,ca)|0)+da|0;i[c>>0]=Ta>>>0<256?Ta:(Ta|0)>0?255:0;c=(k[ya>>2]|0)+(aa(k[sa>>2]|0,b)|0)+g|0;i[c>>0]=1;c=k[wa>>2]|0;if((c|0)==(k[na>>2]|0))break;else h=c;while(1){j=h+12|0;f=k[j>>2]|0;if(+o[f>>2]>W)h=f;else break}f=c+16|0;a=k[f>>2]|0;if((h|0)==(c|0))k[wa>>2]=a;else{Ja=c+12|0;Ia=k[Ja>>2]|0;k[Ia+16>>2]=a;Ta=k[f>>2]|0;k[Ta+12>>2]=Ia;k[wa>>2]=Ta;Ta=k[j>>2]|0;k[Ja>>2]=Ta;k[f>>2]=h;k[Ta+16>>2]=c;k[(k[f>>2]|0)+12>>2]=c}k[c+4>>2]=b;k[c+8>>2]=g;o[c>>2]=W;k[xa>>2]=(k[xa>>2]|0)+1}while(0);ea=ea+1|0;if((ea|0)==4)break;else{a=g;f=b}}f=k[(k[va>>2]|0)+16>>2]|0;a=k[wa>>2]|0;if((a|0)==(f|0)){a=0;g=0;b=0;break a}}}default:{a=0;g=0;b=0;break a}}ya=ca+8|0;f=k[(k[ya>>2]|0)+16>>2]|0;za=ca+4|0;a=k[za>>2]|0;if((a|0)==(f|0)){a=0;g=0;b=0;break a}Aa=ca+20|0;Ba=da+16|0;va=da+4|0;wa=ea+20|0;xa=ea+24|0;ua=ea+4|0;sa=ea+16|0;ta=ha+16|0;ra=ha+4|0;qa=aa(ja,ja)|0;qa=ga?1e4:fa?1:qa;pa=ca+12|0;g=0;b=0;do{na=k[f+4>>2]|0;oa=k[f+8>>2]|0;ja=f+16|0;la=f+12|0;ka=k[la>>2]|0;k[ka+16>>2]=k[ja>>2];k[(k[ja>>2]|0)+12>>2]=ka;ka=k[a+12>>2]|0;k[la>>2]=ka;k[ja>>2]=a;k[ka+16>>2]=f;k[(k[ja>>2]|0)+12>>2]=f;k[za>>2]=f;k[Aa>>2]=(k[Aa>>2]|0)+-1;ja=(k[Ba>>2]|0)+(aa(k[va>>2]|0,na)|0)+oa|0;i[ja>>0]=0;ja=na+-1|0;ka=oa+-1|0;la=na+1|0;ma=oa+1|0;ha=0;a=g;f=b;while(1){switch(ha|0){case 0:{b=ja;g=oa;break}case 1:{b=na;g=ka;break}case 2:{b=la;g=oa;break}case 3:{b=na;g=ma;break}default:{b=f;g=a}}do if(!((g|0)<2|(b|0)<2)){if((b|0)>=(k[wa>>2]|0))break;if((g|0)>=(k[xa>>2]|0))break;h=k[Ba>>2]|0;c=k[va>>2]|0;m=h+(aa(c,b)|0)|0;if((i[m+g>>0]|0)!=2)break;ga=b+-1|0;x=g+-1|0;f=k[ua>>2]|0;a=k[sa>>2]|0;q=g<<2;s=a+(aa(f,ga)|0)+q|0;F=+o[s>>2];s=a+(aa(f,b)|0)|0;v=+o[s+(x<<2)>>2];d=F>v?v:F;n=h+(aa(c,ga)|0)+g|0;n=(i[n>>0]|0)==2;j=(i[m+x>>0]|0)!=2;do if(n)if(j){d=v+1.0;break}else{d=d+1.0;break}else{if(!j){d=F+1.0;break}t=F-v;if(!(+P(+t)>=1.0)){d=(F+v+ +Q(+(2.0-t*t)))*.5;break}else{d=d+1.0;break}}while(0);G=d;Ta=b+1|0;a=a+(aa(f,Ta)|0)+q|0;E=+o[a>>2];t=E>v?v:E;a=h+(aa(c,Ta)|0)+g|0;a=(i[a>>0]|0)==2;do if(a)if(j){d=v+1.0;break}else{d=t+1.0;break}else{if(!j){d=E+1.0;break}d=E-v;if(!(+P(+d)>=1.0)){d=(v+E+ +Q(+(2.0-d*d)))*.5;break}else{d=t+1.0;break}}while(0);D=d;f=g+1|0;w=+o[s+(f<<2)>>2];t=F>w?w:F;f=(i[m+f>>0]|0)!=2;do if(n)if(f){d=w+1.0;break}else{d=t+1.0;break}else{if(!f){d=F+1.0;break}d=F-w;if(!(+P(+d)>=1.0)){d=(F+w+ +Q(+(2.0-d*d)))*.5;break}else{d=t+1.0;break}}while(0);v=d;t=E>w?w:E;do if(a)if(f){d=w+1.0;break}else{d=t+1.0;break}else{if(!f){d=E+1.0;break}d=E-w;if(!(+P(+d)>=1.0)){d=(E+w+ +Q(+(2.0-d*d)))*.5;break}else{d=t+1.0;break}}while(0);ia=d;W=G>D?D:G;ia=v>ia?ia:v;W=W>ia?ia:W;o[s+q>>2]=W;da=b-Na|0;ea=b+Na|0;fa=(da|0)>(ea|0);X=x*3|0;$=g-Na|0;ba=g+Na|0;ca=($|0)>(ba|0);V=0;do{if(fa){t=0.0;d=9.999999682655225e-21}else{U=k[Ca>>2]|0;R=U+-2|0;S=V+-3|0;T=V+3|0;U=U+-1|0;O=da;t=0.0;d=9.999999682655225e-21;while(1){A=O+-1|0;B=((O|0)==1&1)+A|0;C=A-((O|0)==(R|0)&1)|0;if(ca)f=O+1|0;else{K=k[Da>>2]|0;I=K+-2|0;J=(O|0)>0;K=K+-1|0;f=O-b|0;L=aa(f,f)|0;G=+(f|0);H=G*G;f=O+1|0;M=B+-1|0;N=C+1|0;e=(O|0)<(U|0);z=$;while(1){q=z+-1|0;y=((z|0)==1&1)+q|0;x=q-((z|0)==(I|0)&1)|0;do if(J&(z|0)>0&(e&(z|0)<(K|0))){h=k[Ba>>2]|0;c=k[va>>2]|0;s=h+(aa(c,O)|0)|0;if((i[s+z>>0]|0)==2)break;a=z-g|0;if(((aa(a,a)|0)+L|0)>>>0>qa>>>0)break;v=+(a|0);E=H+v*v;F=1.0/(E*E+1.0);Ta=h+(aa(c,f)|0)+z|0;a=h+(aa(c,A)|0)+z|0;a=(i[a>>0]|0)!=2;do if((i[Ta>>0]|0)!=2){h=k[ta>>2]|0;c=k[ra>>2]|0;j=(y*3|0)+V|0;n=h+(aa(c,N)|0)+j|0;m=h+(aa(c,C)|0)+j|0;m=l[m>>0]|0;n=(l[n>>0]|0)-m|0;n=(n|0)>-1?n:0-n|0;if(a){Ta=h+(aa(c,M)|0)+j|0;Ta=m-(l[Ta>>0]|0)|0;n=(o[u>>2]=+(((Ta|0)>-1?Ta:0-Ta|0)+n|0),k[u>>2]|0);break}else{n=(o[u>>2]=+(n|0)*2.0,k[u>>2]|0);break}}else{if(!a){n=0;break}Ia=k[ta>>2]|0;Ja=k[ra>>2]|0;n=(y*3|0)+V|0;Ta=Ia+(aa(Ja,C)|0)+n|0;n=Ia+(aa(Ja,M)|0)+n|0;n=(l[Ta>>0]|0)-(l[n>>0]|0)|0;n=(o[u>>2]=+(((n|0)>-1?n:0-n|0)|0)*2.0,k[u>>2]|0)}while(0);m=(i[s+q>>0]|0)!=2;do if((i[s+(z+1)>>0]|0)!=2){h=(k[ta>>2]|0)+(aa(k[ra>>2]|0,B)|0)|0;c=y*3|0;j=l[h+(c+V)>>0]|0;a=(l[h+(T+(x*3|0))>>0]|0)-j|0;a=(a|0)>-1?a:0-a|0;if(m){Ta=j-(l[h+(c+S)>>0]|0)|0;a=(o[u>>2]=+(((Ta|0)>-1?Ta:0-Ta|0)+a|0),k[u>>2]|0);break}else{a=(o[u>>2]=+(a|0)*2.0,k[u>>2]|0);break}}else{if(!m){a=0;break}Ta=(k[ta>>2]|0)+(aa(k[ra>>2]|0,B)|0)|0;a=y*3|0;a=(l[Ta+(a+V)>>0]|0)-(l[Ta+(a+S)>>0]|0)|0;a=(o[u>>2]=+(((a|0)>-1?a:0-a|0)|0)*2.0,k[u>>2]|0)}while(0);D=(k[u>>2]=n,+o[u>>2]);w=(k[u>>2]=a,+o[u>>2]);v=G*w-v*D;if(!(+P(+v)<=.01))v=+P(+(v/+Q(+(E*(D*D+w*w)))));else v=9.999999974752427e-07;ia=F*v;Ta=(k[ta>>2]|0)+(aa(k[ra>>2]|0,B)|0)+((y*3|0)+V)|0;t=t+ia*+(l[Ta>>0]|0);d=d+ia}while(0);if((z|0)<(ba|0))z=z+1|0;else break}}if((O|0)<(ea|0))O=f;else break}}d=t/d;p[u>>3]=d;f=k[u+4>>2]|0;Ta=f&2146435072;do if(!(Ta>>>0>1126170624|(Ta|0)==1126170624&0>0)){f=(f|0)<0;d=f?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(!(d==0.0))break;d=f?-0.0:0.0}while(0);Ja=~~d;Ta=(k[ta>>2]|0)+(aa(k[ra>>2]|0,ga)|0)+(V+X)|0;i[Ta>>0]=Ja>>>0<256?Ja:(Ja|0)>0?255:0;V=V+1|0}while((V|0)!=3);c=(k[Ba>>2]|0)+(aa(k[va>>2]|0,b)|0)+g|0;i[c>>0]=1;c=k[za>>2]|0;if((c|0)==(k[pa>>2]|0))break;else h=c;while(1){j=h+12|0;f=k[j>>2]|0;if(+o[f>>2]>W)h=f;else break}f=c+16|0;a=k[f>>2]|0;if((h|0)==(c|0))k[za>>2]=a;else{Ja=c+12|0;Ia=k[Ja>>2]|0;k[Ia+16>>2]=a;Ta=k[f>>2]|0;k[Ta+12>>2]=Ia;k[za>>2]=Ta;Ta=k[j>>2]|0;k[Ja>>2]=Ta;k[f>>2]=h;k[Ta+16>>2]=c;k[(k[f>>2]|0)+12>>2]=c}k[c+4>>2]=b;k[c+8>>2]=g;o[c>>2]=W;k[Aa>>2]=(k[Aa>>2]|0)+1}while(0);ha=ha+1|0;if((ha|0)==4)break;else{a=g;f=b}}f=k[(k[ya>>2]|0)+16>>2]|0;a=k[za>>2]|0}while((a|0)!=(f|0));a=0;g=0;b=0;break}default:{k[O>>2]=0;f=O+4|0;k[f>>2]=0;a=ZT(72)|0;k[a>>2]=1;b=a+4|0;k[O>>2]=b;k[f>>2]=67;i[a+71>>0]=0;h=398690;c=b+67|0;do{i[b>>0]=i[h>>0]|0;b=b+1|0;h=h+1|0}while((b|0)<(c|0));Y8(-5,O,398505,398515,806);k[f>>2]=0;k[O>>2]=0;Ta=k[a>>2]|0;k[a>>2]=Ta+-1;if((Ta|0)==1)ggb(k[a+-4>>2]|0);a=0;g=0;b=0;break a}}}else{a=0;g=0;b=0}while(0);f=a;if(a|0?(Na=f+4|0,Ta=k[Na>>2]|0,k[Na>>2]=Ta+-1,(Ta|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](f);f=Ma;if(Ma|0?(Na=f+4|0,Ta=k[Na>>2]|0,k[Na>>2]=Ta+-1,(Ta|0)==1):0)Uh[k[(k[Ma>>2]|0)+8>>2]&2047](f);f=g;if(g|0?(Na=f+4|0,Ta=k[Na>>2]|0,k[Na>>2]=Ta+-1,(Ta|0)==1):0)Uh[k[(k[g>>2]|0)+8>>2]&2047](f);Ta=k[La>>2]|0;k[La>>2]=Ta+-1;if((Ta|0)==1)Uh[k[(k[Ka>>2]|0)+8>>2]&2047](Ka);f=b;do if(b|0){Na=f+4|0;Ta=k[Na>>2]|0;k[Na>>2]=Ta+-1;if((Ta|0)!=1)break;Uh[k[(k[b>>2]|0)+8>>2]&2047](f)}while(0);f=Qa;do if(Qa|0){Na=f+4|0;Ta=k[Na>>2]|0;k[Na>>2]=Ta+-1;if((Ta|0)!=1)break;Uh[k[(k[Qa>>2]|0)+8>>2]&2047](f)}while(0);f=Ra;do if(Ra|0){Qa=f+4|0;Ta=k[Qa>>2]|0;k[Qa>>2]=Ta+-1;if((Ta|0)!=1)break;Uh[k[(k[Ra>>2]|0)+8>>2]&2047](f)}while(0);f=Pa;do if(Pa|0){Ra=f+4|0;Ta=k[Ra>>2]|0;k[Ra>>2]=Ta+-1;if((Ta|0)!=1)break;Uh[k[(k[Pa>>2]|0)+8>>2]&2047](f)}while(0);f=Oa;if(!Oa){r=Sa;return}Ra=f+4|0;Ta=k[Ra>>2]|0;k[Ra>>2]=Ta+-1;if((Ta|0)!=1){r=Sa;return}Uh[k[(k[Oa>>2]|0)+8>>2]&2047](f);r=Sa;return}function a3a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=a+16|0;k[m>>2]=0;h=b+20|0;c=k[h>>2]|0;if((c|0)<=0){a=0;return a|0}j=b+24|0;l=b+16|0;g=b+4|0;f=0;d=0;b=k[j>>2]|0;do{if((b|0)>0){c=(k[l>>2]|0)+(aa(k[g>>2]|0,f)|0)|0;b=0;do{d=((i[c+b>>0]|0)!=0&1)+d|0;k[m>>2]=d;b=b+1|0;e=k[j>>2]|0}while((b|0)<(e|0));c=k[h>>2]|0;b=e}f=f+1|0}while((f|0)<(c|0));if((d|0)<1){a=0;return a|0}f=ZT((d*20|0)+40|0)|0;k[a>>2]=f;if(!f){a=0;return a|0}k[a+8>>2]=f;k[f+8>>2]=-1;k[f+4>>2]=-1;k[f+12>>2]=0;b=f+20|0;k[f+16>>2]=b;o[f>>2]=-3402823466385288598117041.0e14;k[a+4>>2]=b;c=k[m>>2]|0;if((c|0)<1)c=1;else{d=c+1|0;e=f+((c*20|0)+20)|0;c=1;while(1){k[f+(c*20|0)+12>>2]=b+-20;k[f+(c*20|0)+16>>2]=f+(c*20|0)+20;k[f+(c*20|0)+4>>2]=-1;o[f+(c*20|0)>>2]=3402823466385288598117041.0e14;b=c+1|0;if((b|0)==(d|0))break;else{c=b;b=f+(b*20|0)|0}}c=d;b=e}k[a+12>>2]=b;k[f+(c*20|0)+8>>2]=-1;k[b+4>>2]=-1;k[b+12>>2]=f+(c*20|0)+-20;k[b+16>>2]=0;o[b>>2]=3402823466385288598117041.0e14;a=1;return a|0}function b3a(a){a=a|0;ggb(a);return}function c3a(a){a=a|0;var b=0,c=0;b=k[a+8>>2]|0;if(b|0){c=k[b>>2]|0;if(c|0)ggb(k[c+-4>>2]|0);ggb(b)}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function d3a(a){a=a|0;ggb(a);return}function e3a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)ggb(k[b+-4>>2]|0);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function f3a(a){a=a|0;var b=0,c=0,d=0,e=0;while(1){b=fgb(68)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=151080;c=b+4|0;k[c>>2]=0;e=b+8|0;k[e>>2]=0;d=ZT(20)|0;k[d>>2]=1;k[c>>2]=d+4;k[e>>2]=12;i[d+16>>0]=0;c=k[c>>2]|0;d=398980;e=c+12|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));X2a(b+12|0);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=c+4|0;k[e>>2]=1;k[c>>2]=151060;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function g3a(a){a=a|0;ggb(a);return}function h3a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function i3a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=151080;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if(!((b|0)==(a+60|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;d=b+-4|0;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;ggb(k[b+-8>>2]|0);return}function j3a(a){a=a|0;i3a(a);ggb(a);return}function k3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0;Nb=r;r=r+1664|0;Db=Nb+928|0;Eb=Nb+704|0;Fb=Nb+480|0;Lb=Nb+1632|0;Mb=Nb+1576|0;n=Nb+1648|0;Kb=Nb+1520|0;Jb=Nb+1464|0;Ib=Nb+1408|0;ub=Nb+1352|0;Hb=Nb+1336|0;Gb=Nb+1280|0;t=Nb+256|0;vb=Nb+1264|0;wb=Nb+1208|0;xb=Nb+32|0;yb=Nb+1152|0;zb=Nb;k[Lb>>2]=0;Ab=Lb+4|0;k[Ab>>2]=0;k[Lb+8>>2]=0;B2(b,Lb);do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[Mb>>2]=k[g>>2];m=Mb+4|0;b=g+4|0;k[m>>2]=k[b>>2];tb=Mb+8|0;k[tb>>2]=k[g+8>>2];k[Mb+12>>2]=k[g+12>>2];k[Mb+16>>2]=k[g+16>>2];k[Mb+20>>2]=k[g+20>>2];k[Mb+24>>2]=k[g+24>>2];k[Mb+28>>2]=k[g+28>>2];k[Mb+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[Mb+36>>2]=d;f=Mb+40|0;k[f>>2]=tb;tb=Mb+48|0;j=Mb+44|0;k[j>>2]=tb;k[Mb+52>>2]=0;k[tb>>2]=0;if(d|0){tb=d+12|0;k[tb>>2]=(k[tb>>2]|0)+1}if((k[b>>2]|0)<3){sb=k[g+44>>2]|0;tb=k[j>>2]|0;k[tb>>2]=k[sb>>2];k[tb+4>>2]=k[sb+4>>2];break}k[m>>2]=0;x1(Mb,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;d=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[d+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else{Q1(Mb,d,-1);m=Mb+4|0}while(0);h=((k[Ab>>2]|0)-(k[Lb>>2]|0)|0)/56|0;g=k[m>>2]|0;if((g|0)<3)b=aa(k[Mb+12>>2]|0,k[Mb+8>>2]|0)|0;else{f=k[Mb+40>>2]|0;d=0;b=1;do{b=aa(k[f+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(g|0))}if((h|0)!=(b|0)){k[Db>>2]=0;b=Db+4|0;k[b>>2]=0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[Db>>2]=g;k[b>>2]=30;i[d+34>>0]=0;f=398993;h=g+30|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,Db,399869,399024,65);k[b>>2]=0;k[Db>>2]=0;tb=k[d>>2]|0;k[d>>2]=tb+-1;if((tb|0)==1)ggb(k[d+-4>>2]|0)}W2a(Lb);d=k[Lb>>2]|0;b=k[d>>2]|0;if(b&7){k[Db>>2]=0;b=Db+4|0;k[b>>2]=0;d=ZT(32)|0;k[d>>2]=1;g=d+4|0;k[Db>>2]=g;k[b>>2]=26;i[d+30>>0]=0;f=399089;h=g+26|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,Db,399869,399024,67);k[b>>2]=0;k[Db>>2]=0;tb=k[d>>2]|0;k[d>>2]=tb+-1;if((tb|0)==1)ggb(k[d+-4>>2]|0);d=k[Lb>>2]|0;b=k[d>>2]|0}qb=b>>>3&511;u=qb+1|0;pb=k[d+40>>2]|0;ob=k[pb+4>>2]|0;pb=k[pb>>2]|0;s=(u<<3)+-3|0;k[n>>2]=ob;k[n+4>>2]=pb;x2(c,n,s,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[Kb>>2]=k[g>>2];n=Kb+4|0;b=g+4|0;k[n>>2]=k[b>>2];tb=Kb+8|0;k[tb>>2]=k[g+8>>2];k[Kb+12>>2]=k[g+12>>2];k[Kb+16>>2]=k[g+16>>2];k[Kb+20>>2]=k[g+20>>2];k[Kb+24>>2]=k[g+24>>2];k[Kb+28>>2]=k[g+28>>2];k[Kb+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[Kb+36>>2]=d;f=Kb+40|0;k[f>>2]=tb;tb=Kb+48|0;j=Kb+44|0;k[j>>2]=tb;k[Kb+52>>2]=0;k[tb>>2]=0;if(d|0){tb=d+12|0;k[tb>>2]=(k[tb>>2]|0)+1}if((k[b>>2]|0)<3){sb=k[g+44>>2]|0;tb=k[j>>2]|0;k[tb>>2]=k[sb>>2];k[tb+4>>2]=k[sb+4>>2];break}k[n>>2]=0;x1(Kb,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;d=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[d+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else Q1(Kb,c,-1);while(0);do if((k[e>>2]&2031616|0)==65536){g=k[e+4>>2]|0;k[Jb>>2]=k[g>>2];n=Jb+4|0;b=g+4|0;k[n>>2]=k[b>>2];tb=Jb+8|0;k[tb>>2]=k[g+8>>2];k[Jb+12>>2]=k[g+12>>2];c=Jb+16|0;k[c>>2]=k[g+16>>2];k[Jb+20>>2]=k[g+20>>2];k[Jb+24>>2]=k[g+24>>2];k[Jb+28>>2]=k[g+28>>2];k[Jb+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[Jb+36>>2]=d;f=Jb+40|0;k[f>>2]=tb;tb=Jb+48|0;j=Jb+44|0;k[j>>2]=tb;k[Jb+52>>2]=0;k[tb>>2]=0;if(d|0){tb=d+12|0;k[tb>>2]=(k[tb>>2]|0)+1}if((k[b>>2]|0)<3){sb=k[g+44>>2]|0;tb=k[j>>2]|0;k[tb>>2]=k[sb>>2];k[tb+4>>2]=k[sb+4>>2];break}k[n>>2]=0;x1(Jb,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;d=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[d+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else{Q1(Jb,e,-1);c=Jb+16|0}while(0);if(k[c>>2]|0){f=k[Jb+4>>2]|0;if((f|0)<3)b=aa(k[Jb+12>>2]|0,k[Jb+8>>2]|0)|0;else{g=k[Jb+40>>2]|0;d=0;b=1;do{b=aa(k[g+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(f|0))}if(!b)Cb=46}else Cb=46;if((Cb|0)==46){_2a(Db,u);KG(Jb,Db)|0;f=Db+36|0;b=k[f>>2]|0;if(b|0?(sb=b+12|0,tb=k[sb>>2]|0,k[sb>>2]=tb+-1,(tb|0)==1):0){d=k[f>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Db+32>>2]|0;if(!b){b=B1()|0;d=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[f>>2]=0}k[f>>2]=0;tb=Db+16|0;d=Db+4|0;k[tb>>2]=0;k[tb+4>>2]=0;k[tb+8>>2]=0;k[tb+12>>2]=0;if((k[d>>2]|0)>0){f=k[Db+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[Db+44>>2]|0;if(!((b|0)==(Db+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=k[c>>2]|0;do if((k[Jb>>2]&16384|0)==0?(q=k[Jb+40>>2]|0,(k[q>>2]|0)!=1):0){b=k[Jb+44>>2]|0;if((k[q+4>>2]|0)==1){b=d+(k[b>>2]|0)|0;break}else{tb=k[Jb+12>>2]|0;sb=(tb+1|0)>>>0<3?tb:0;tb=1-(aa(sb,tb)|0)|0;b=d+(aa(sb,k[b>>2]|0)|0)+(tb*12|0)|0;break}}else Cb=61;while(0);if((Cb|0)==61)b=d+12|0;k[d>>2]=k[b>>2];k[d+4>>2]=k[b+4>>2];k[d+8>>2]=k[b+8>>2]}k[Ib>>2]=1124007936;lb=Ib+4|0;b=Ib+8|0;kb=Ib+40|0;g=lb;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[kb>>2]=b;nb=Ib+48|0;mb=Ib+44|0;k[mb>>2]=nb;k[Ib+52>>2]=0;k[nb>>2]=0;k[Db+8>>2]=0;k[Db+12>>2]=0;k[Db>>2]=16842752;k[Db+4>>2]=Jb;tb=Eb+4|0;sb=tb+4|0;k[sb>>2]=0;k[sb+4>>2]=0;k[Eb>>2]=33619968;k[tb>>2]=Ib;YZ(Db,Eb);if(!(((k[b>>2]|0)==256?(k[Ib+12>>2]|0)==1:0)?((k[Ib>>2]|0)>>>3&511|0)==(qb|0):0)){k[Db>>2]=0;b=Db+4|0;k[b>>2]=0;d=ZT(100)|0;k[d>>2]=1;g=d+4|0;k[Db>>2]=g;k[b>>2]=94;i[d+98>>0]=0;f=399116;h=g+94|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,Db,399869,399024,86);k[b>>2]=0;k[Db>>2]=0;tb=k[d>>2]|0;k[d>>2]=tb+-1;if((tb|0)==1)ggb(k[d+-4>>2]|0)}k[ub>>2]=k[Mb>>2];hb=ub+4|0;b=k[m>>2]|0;k[hb>>2]=b;jb=ub+8|0;k[jb>>2]=k[Mb+8>>2];cb=ub+12|0;k[cb>>2]=k[Mb+12>>2];eb=ub+16|0;sb=Mb+16|0;k[eb>>2]=k[sb>>2];k[ub+20>>2]=k[Mb+20>>2];k[ub+24>>2]=k[Mb+24>>2];k[ub+28>>2]=k[Mb+28>>2];db=ub+32|0;rb=Mb+32|0;k[db>>2]=k[rb>>2];fb=ub+36|0;tb=Mb+36|0;d=k[tb>>2]|0;k[fb>>2]=d;gb=ub+40|0;k[gb>>2]=jb;jb=ub+48|0;ib=ub+44|0;k[ib>>2]=jb;k[ub+52>>2]=0;k[jb>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[m>>2]|0}if((b|0)>=3){k[hb>>2]=0;x1(ub,k[Mb+4>>2]|0,0,0,0);if((k[hb>>2]|0)>0){d=k[Mb+40>>2]|0;f=k[gb>>2]|0;g=k[Mb+44>>2]|0;h=k[ib>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[d+(b<<2)>>2];k[h+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[hb>>2]|0))}}else{ab=k[Mb+44>>2]|0;bb=k[ib>>2]|0;k[bb>>2]=k[ab>>2];k[bb+4>>2]=k[ab+4>>2]}k[Db+8>>2]=0;k[Db+12>>2]=0;k[Db>>2]=16842752;k[Db+4>>2]=ub;b=Eb+4|0;d=b+4|0;k[d>>2]=0;k[d+4>>2]=0;k[Eb>>2]=33619968;k[b>>2]=ub;YZ(Db,Eb);k[Eb>>2]=0;k[Eb+4>>2]=0;k[Eb+8>>2]=1124007936;b=Eb+16|0;d=Eb+48|0;g=Eb+12|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=b;b=Eb+56|0;k[Eb+52>>2]=b;k[Eb+60>>2]=0;k[b>>2]=0;k[Eb+64>>2]=1124007936;b=Eb+72|0;d=Eb+104|0;g=Eb+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=b;b=Eb+112|0;k[Eb+108>>2]=b;k[Eb+116>>2]=0;k[b>>2]=0;k[Eb+120>>2]=1124007936;b=Eb+128|0;d=Eb+160|0;g=Eb+124|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=b;g=Eb+168|0;k[Eb+164>>2]=g;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Db>>2]=ob;k[Db+4>>2]=pb;j1(Eb,48,Db,s);b=k[Eb>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,Eb,Kb,-1);XN(Eb);k[Hb>>2]=0;k[Hb+4>>2]=0;k[Hb+8>>2]=0;k[Db+8>>2]=0;k[Db+12>>2]=0;k[Db>>2]=16842752;k[Db+4>>2]=Kb;b=Eb+4|0;d=b+4|0;k[d>>2]=0;k[d+4>>2]=0;k[Eb>>2]=33882112;k[b>>2]=Hb;FV(Db,Eb);k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=1124007936;b=t+16|0;d=t+48|0;g=t+12|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=b;b=t+56|0;k[t+52>>2]=b;k[t+60>>2]=0;k[b>>2]=0;k[t+64>>2]=1124007936;b=t+72|0;d=t+104|0;g=t+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=b;b=t+112|0;k[t+108>>2]=b;k[t+116>>2]=0;k[b>>2]=0;k[t+120>>2]=1124007936;b=t+128|0;d=t+160|0;g=t+124|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=b;g=t+168|0;k[t+164>>2]=g;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Db>>2]=ob;k[Db+4>>2]=pb;j1(t,48,Db,5);k[Gb>>2]=1124007936;ab=Gb+4|0;b=Gb+8|0;_a=Gb+40|0;g=ab;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[_a>>2]=b;bb=Gb+48|0;$a=Gb+44|0;k[$a>>2]=bb;k[Gb+52>>2]=0;k[bb>>2]=0;Za=k[t>>2]|0;dh[k[(k[Za>>2]|0)+12>>2]&255](Za,t,Gb,-1);XN(t);if((k[Ab>>2]|0)!=(k[Lb>>2]|0)){Ka=vb+4|0;La=vb+8|0;Ma=Db+8|0;Na=Db+12|0;Oa=Db+4|0;Pa=Eb+4|0;Qa=Pa+4|0;Ra=wb+4|0;Sa=wb+8|0;Ta=wb+40|0;Ua=wb+48|0;Va=wb+44|0;Wa=wb+52|0;Xa=Db+8|0;Ya=Db+12|0;Za=Db+4|0;ua=a+12|0;va=Eb+8|0;wa=Eb+12|0;xa=Eb+4|0;ya=Fb+4|0;za=ya+4|0;Aa=Db+8|0;Ba=Db+12|0;Ca=Db+4|0;Da=Eb+8|0;Ea=Eb+12|0;Fa=Eb+4|0;Ga=Fb+4|0;Ha=Ga+4|0;Ia=Db+4|0;Ja=Ia+4|0;v=1.0/+(u|0);l=yb+4|0;n=yb+8|0;e=yb+40|0;q=yb+48|0;s=yb+44|0;t=yb+52|0;u=Db+8|0;a=Db+12|0;w=Db+4|0;x=Eb+8|0;y=Eb+12|0;z=Eb+4|0;A=Fb+4|0;B=A+4|0;C=Db+8|0;D=Db+12|0;E=Db+4|0;F=Eb+4|0;G=F+4|0;H=zb+8|0;I=Eb+8|0;J=Eb+12|0;K=Eb+4|0;L=Db+8|0;M=Db+12|0;N=Db+4|0;O=Eb+8|0;P=Eb+12|0;Q=Eb+4|0;R=Fb+4|0;S=R+4|0;T=yb+36|0;U=yb+16|0;V=wb+36|0;W=wb+16|0;X=xb+4|0;Y=xb+8|0;Z=xb+12|0;_=xb+16|0;$=xb+48|0;ba=xb+56|0;ca=xb+52|0;da=xb+60|0;ea=xb+64|0;fa=xb+68|0;ga=xb+72|0;ha=xb+104|0;ia=xb+112|0;ja=xb+108|0;ka=xb+116|0;la=xb+120|0;ma=xb+124|0;na=xb+128|0;oa=xb+160|0;pa=xb+168|0;qa=xb+164|0;ra=Db+4|0;sa=wb+32|0;ta=yb+32|0;j=0;d=k[Lb>>2]|0;do{k[vb>>2]=0;k[Ka>>2]=0;k[La>>2]=0;k[Ma>>2]=0;k[Na>>2]=0;k[Db>>2]=16842752;k[Oa>>2]=d+(j*56|0);g=Qa;k[g>>2]=0;k[g+4>>2]=0;k[Eb>>2]=33882112;k[Pa>>2]=vb;FV(Db,Eb);k[xb>>2]=0;k[X>>2]=0;k[Y>>2]=1124007936;g=Z;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[$>>2]=_;k[ca>>2]=ba;k[da>>2]=0;k[ba>>2]=0;k[ea>>2]=1124007936;g=fa;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[ha>>2]=ga;k[ja>>2]=ia;k[ka>>2]=0;k[ia>>2]=0;k[la>>2]=1124007936;g=ma;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[oa>>2]=na;k[qa>>2]=pa;g=pa;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Db>>2]=ob;k[ra>>2]=pb;j1(xb,48,Db,5);k[wb>>2]=1124007936;g=Ra;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Ta>>2]=Sa;k[Va>>2]=Ua;k[Wa>>2]=0;k[Ua>>2]=0;b=k[xb>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,xb,wb,-1);XN(xb);b=0;while(1){h=(k[vb>>2]|0)+(b*56|0)|0;k[Xa>>2]=0;k[Ya>>2]=0;k[Db>>2]=16842752;k[Za>>2]=h;k[va>>2]=0;k[wa>>2]=0;k[Eb>>2]=16842752;k[xa>>2]=ua;g=za;k[g>>2]=0;k[g+4>>2]=0;k[Fb>>2]=33619968;k[ya>>2]=h;OX(Db,Eb,Fb);h=(k[vb>>2]|0)+(b*56|0)|0;k[Aa>>2]=0;k[Ba>>2]=0;k[Db>>2]=16842752;k[Ca>>2]=wb;k[Da>>2]=0;k[Ea>>2]=0;k[Eb>>2]=16842752;k[Fa>>2]=h;h=Ha;k[h>>2]=0;k[h+4>>2]=0;k[Fb>>2]=33619968;k[Ga>>2]=wb;sU(Db,Eb,Fb,49332,-1,39936,0,0);if((b|0)<(qb|0))b=b+1|0;else break}g=Ja;k[g>>2]=0;k[g+4>>2]=0;k[Db>>2]=33619968;k[Ia>>2]=wb;SW(wb,Db,-1,v,0.0);k[yb>>2]=1124007936;g=l;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[e>>2]=n;k[s>>2]=q;k[t>>2]=0;k[q>>2]=0;k[u>>2]=0;k[a>>2]=0;k[Db>>2]=16842752;k[w>>2]=d+(j*56|0);k[x>>2]=0;k[y>>2]=0;k[Eb>>2]=16842752;k[z>>2]=Ib;f=B;k[f>>2]=0;k[f+4>>2]=0;k[Fb>>2]=33619968;k[A>>2]=yb;OX(Db,Eb,Fb);k[C>>2]=0;k[D>>2]=0;k[Db>>2]=16842752;k[E>>2]=yb;f=G;k[f>>2]=0;k[f+4>>2]=0;k[Eb>>2]=33882112;k[F>>2]=vb;FV(Db,Eb);f=0;while(1){g=(k[Hb>>2]|0)+(f*56|0)|0;h=(k[vb>>2]|0)+(f*56|0)|0;do if((k[ub>>2]&16384|0)==0?(Bb=k[gb>>2]|0,(k[Bb>>2]|0)!=1):0){b=k[eb>>2]|0;d=k[ib>>2]|0;if((k[Bb+4>>2]|0)==1){b=b+(aa(k[d>>2]|0,j)|0)|0;break}else{Ob=k[cb>>2]|0;Pb=(j|0)/(Ob|0)|0;Ob=j-(aa(Pb,Ob)|0)|0;b=b+(aa(k[d>>2]|0,Pb)|0)+(Ob<<2)|0;break}}else Cb=88;while(0);if((Cb|0)==88){Cb=0;b=(k[eb>>2]|0)+(j<<2)|0}p[zb>>3]=+o[b>>2];k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;k[H+16>>2]=0;k[H+20>>2]=0;Y0(Fb,h,zb);k[I>>2]=0;k[J>>2]=0;k[Eb>>2]=-1056571392;k[K>>2]=Fb;i1(Db,wb,Eb,1.0);Pb=k[Db>>2]|0;Ph[k[(k[Pb>>2]|0)+24>>2]&511](Pb,Db,g);XN(Db);XN(Fb);if((f|0)<(qb|0))f=f+1|0;else break}k[L>>2]=0;k[M>>2]=0;k[Db>>2]=16842752;k[N>>2]=Gb;k[O>>2]=0;k[P>>2]=0;k[Eb>>2]=16842752;k[Q>>2]=wb;b=S;k[b>>2]=0;k[b+4>>2]=0;k[Fb>>2]=33619968;k[R>>2]=Gb;sU(Db,Eb,Fb,49332,-1,39936,0,0);b=k[T>>2]|0;if(b|0?(Ob=b+12|0,Pb=k[Ob>>2]|0,k[Ob>>2]=Pb+-1,(Pb|0)==1):0){d=k[T>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[ta>>2]|0;if(b|0)break;b=B1()|0;d=k[T>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[T>>2]=0}k[T>>2]=0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[l>>2]|0)>0){d=k[e>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[s>>2]|0;if(!((b|0)==(q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[V>>2]|0;if(b|0?(Ob=b+12|0,Pb=k[Ob>>2]|0,k[Ob>>2]=Pb+-1,(Pb|0)==1):0){d=k[V>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[sa>>2]|0;if(b|0)break;b=B1()|0;d=k[V>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[V>>2]=0}k[V>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Ra>>2]|0)>0){d=k[Ta>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ra>>2]|0))}b=k[Va>>2]|0;if(!((b|0)==(Ua|0)|(b|0)==0))ggb(k[b+-4>>2]|0);zF(vb);j=j+1|0;d=k[Lb>>2]|0}while(j>>>0<(((k[Ab>>2]|0)-d|0)/56|0)>>>0)}g1(Db,Gb);d=k[Db>>2]|0;dh[k[(k[d>>2]|0)+12>>2]&255](d,Db,Gb,-1);XN(Db);d=Eb+8|0;f=Eb+12|0;g=Eb+4|0;b=0;while(1){Pb=(k[Hb>>2]|0)+(b*56|0)|0;k[d>>2]=0;k[f>>2]=0;k[Eb>>2]=16842752;k[g>>2]=Gb;i1(Db,Pb,Eb,1.0);Ob=k[Db>>2]|0;dh[k[(k[Ob>>2]|0)+12>>2]&255](Ob,Db,Pb,-1);XN(Db);if((b|0)<(qb|0))b=b+1|0;else break}k[Eb+8>>2]=0;k[Eb+12>>2]=0;k[Eb>>2]=17104896;k[Eb+4>>2]=Hb;b=Fb+4|0;f=b+4|0;k[f>>2]=0;k[f+4>>2]=0;k[Fb>>2]=33619968;k[b>>2]=Kb;k[Db>>2]=0;b=Db+4|0;k[b>>2]=0;k[Db+8>>2]=0;B2(Eb,Db);f=k[Db>>2]|0;b=k[b>>2]|0;GV((f|0)==(b|0)?0:f,(b-f|0)/56|0,Fb);zF(Db);k[Db+8>>2]=0;k[Db+12>>2]=0;k[Db>>2]=16842752;k[Db+4>>2]=Kb;f=Eb+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[Eb>>2]=33619968;k[f>>2]=Kb;XZ(Db,Eb);f=Gb+36|0;b=k[f>>2]|0;if(b|0?(Ob=b+12|0,Pb=k[Ob>>2]|0,k[Ob>>2]=Pb+-1,(Pb|0)==1):0){d=k[f>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Gb+32>>2]|0;if(!b){b=B1()|0;d=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[f>>2]=0}k[f>>2]=0;Pb=Gb+16|0;k[Pb>>2]=0;k[Pb+4>>2]=0;k[Pb+8>>2]=0;k[Pb+12>>2]=0;if((k[ab>>2]|0)>0){d=k[_a>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ab>>2]|0))}b=k[$a>>2]|0;if(!((b|0)==(bb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);zF(Hb);b=k[fb>>2]|0;if(b|0?(Ob=b+12|0,Pb=k[Ob>>2]|0,k[Ob>>2]=Pb+-1,(Pb|0)==1):0){d=k[fb>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[db>>2]|0;if(b|0)break;b=B1()|0;d=k[fb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[fb>>2]=0}k[fb>>2]=0;k[eb>>2]=0;k[eb+4>>2]=0;k[eb+8>>2]=0;k[eb+12>>2]=0;if((k[hb>>2]|0)>0){d=k[gb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[hb>>2]|0))}b=k[ib>>2]|0;if(!((b|0)==(jb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Ib+36|0;b=k[f>>2]|0;if(b|0?(Ob=b+12|0,Pb=k[Ob>>2]|0,k[Ob>>2]=Pb+-1,(Pb|0)==1):0){d=k[f>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Ib+32>>2]|0;if(b|0)break;b=B1()|0;d=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[f>>2]=0}k[f>>2]=0;Pb=Ib+16|0;k[Pb>>2]=0;k[Pb+4>>2]=0;k[Pb+8>>2]=0;k[Pb+12>>2]=0;if((k[lb>>2]|0)>0){d=k[kb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[lb>>2]|0))}b=k[mb>>2]|0;if(!((b|0)==(nb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Jb+36|0;b=k[f>>2]|0;do if(b|0){Ob=b+12|0;Pb=k[Ob>>2]|0;k[Ob>>2]=Pb+-1;if((Pb|0)!=1)break;d=k[f>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Jb+32>>2]|0;if(b|0)break;b=B1()|0;d=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[f>>2]=0}while(0);k[f>>2]=0;f=Jb+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[f>>2]|0)>0){d=k[Jb+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[Jb+44>>2]|0;if(!((b|0)==(Jb+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Kb+36|0;b=k[f>>2]|0;do if(b|0){Ob=b+12|0;Pb=k[Ob>>2]|0;k[Ob>>2]=Pb+-1;if((Pb|0)!=1)break;d=k[f>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Kb+32>>2]|0;if(b|0)break;b=B1()|0;d=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[f>>2]=0}while(0);k[f>>2]=0;Pb=Kb+16|0;d=Kb+4|0;k[Pb>>2]=0;k[Pb+4>>2]=0;k[Pb+8>>2]=0;k[Pb+12>>2]=0;if((k[d>>2]|0)>0){f=k[Kb+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[Kb+44>>2]|0;if(!((b|0)==(Kb+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[tb>>2]|0;do if(b|0){Ob=b+12|0;Pb=k[Ob>>2]|0;k[Ob>>2]=Pb+-1;if((Pb|0)!=1)break;d=k[tb>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[rb>>2]|0;if(b|0)break;b=B1()|0;d=k[tb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[tb>>2]=0}while(0);k[tb>>2]=0;k[sb>>2]=0;k[sb+4>>2]=0;k[sb+8>>2]=0;k[sb+12>>2]=0;if((k[m>>2]|0)>0){d=k[Mb+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[Mb+44>>2]|0;if((b|0)==(Mb+48|0)|(b|0)==0){zF(Lb);r=Nb;return}ggb(k[b+-4>>2]|0);zF(Lb);r=Nb;return}function l3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+80|0;h=p+56|0;n=p;i=k[(k[a>>2]|0)+32>>2]|0;k[n>>2]=1124007936;o=n+4|0;e=n+8|0;l=n+40|0;f=o;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[l>>2]=e;m=n+48|0;j=n+44|0;k[j>>2]=m;k[n+52>>2]=0;k[m>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=n;eh[i&255](a,b,c,d,h);g=n+36|0;e=k[g>>2]|0;if(e|0?(h=e+12|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[n+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;n=n+16|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[o>>2]|0)>0){f=k[l>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[o>>2]|0))}e=k[j>>2]|0;if((e|0)==(m|0)|(e|0)==0){r=p;return}ggb(k[e+-4>>2]|0);r=p;return}function m3a(a){a=a|0;ggb(a);return}function n3a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function o3a(a){a=a|0;var b=0,c=0;k[a>>2]=151128;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b)return;a=b+-4|0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)!=1)return;ggb(k[b+-8>>2]|0);return}function p3a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=151128;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b){ggb(a);return}d=b+-4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function q3a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;f=g+4|0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=4;i[e+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+4|0)|0;d=g+4|0;e=ZT(20)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[d>>2]=15;i[e+19>>0]=0;e=399355;f=c+15|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));b=z6(b,g)|0;c=k[g>>2]|0;k[d>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=A3a(b,a+12|0)|0;d=g+4|0;e=ZT(24)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[d>>2]=17;i[e+21>>0]=0;e=399371;f=c+17|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));b=z6(b,g)|0;c=k[g>>2]|0;k[d>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=A3a(b,a+16|0)|0;d=g+4|0;e=ZT(20)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[d>>2]=15;i[e+19>>0]=0;e=399389;f=c+15|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));b=z6(b,g)|0;c=k[g>>2]|0;k[d>>2]=0;k[g>>2]=0;if(!c){g=a+20|0;A3a(b,g)|0;r=h;return}f=c+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){g=a+20|0;A3a(b,g)|0;r=h;return}ggb(k[c+-8>>2]|0);g=a+20|0;A3a(b,g)|0;r=h;return}function r3a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0;q=r;r=r+16|0;m=q;n=b+4|0;c=k6(k[b>>2]|0,k[n>>2]|0,401026)|0;do if((c|0)!=0?(k[c>>2]&7|0)==3:0){k[m>>2]=0;j=m+4|0;k[j>>2]=0;J6(c,m,m);h=k[m>>2]|0;c=k[a+4>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[m>>2]=0;if(h|0?(j=h+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[h+-8>>2]|0);break}f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[m>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c)l=14}else l=14;while(0);if((l|0)==14){c=m+4|0;e=ZT(40)|0;k[e>>2]=1;f=e+4|0;k[m>>2]=f;k[c>>2]=33;i[e+37>>0]=0;g=399944;h=f+33|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,m,401059,399024,277);k[c>>2]=0;k[m>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}c=k6(k[b>>2]|0,k[n>>2]|0,399355)|0;a:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break a}case 2:{d=+p[c+8>>3];break a}default:{d=1000000015047466219876688.0e6;break a}}while(0);o[a+12>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,399371)|0;b:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break b}case 2:{d=+p[c+8>>3];break b}default:{d=1000000015047466219876688.0e6;break b}}while(0);o[a+16>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,399389)|0;if(!c){d=0.0;a=a+20|0;o[a>>2]=d;r=q;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+20|0;o[a>>2]=d;r=q;return}case 2:{d=+p[c+8>>3];a=a+20|0;o[a>>2]=d;r=q;return}default:{d=1000000015047466219876688.0e6;a=a+20|0;o[a>>2]=d;r=q;return}}}function s3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ph[k[(k[a>>2]|0)+36>>2]&511](a,b,c);return}function t3a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0.0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0.0;Uf=r;r=r+2064|0;Of=Uf+1400|0;Qf=Uf+952|0;If=Uf+728|0;Jf=Uf+2008|0;Sf=Uf+1988|0;Tf=Uf+1976|0;Rf=Uf+1920|0;m=Uf+1176|0;Pf=Uf+1864|0;zf=Uf+1808|0;Af=Uf+1752|0;Bf=Uf+1696|0;pf=Uf+1680|0;qf=Uf+1624|0;rf=Uf+504|0;sf=Uf;tf=Uf+280|0;uf=Uf+56|0;Hf=Uf+2e3|0;k[Sf>>2]=0;Cf=Sf+4|0;k[Cf>>2]=0;k[Sf+8>>2]=0;B2(b,Sf);W2a(Sf);b=k[Sf>>2]|0;xf=(k[b>>2]|0)>>>3&511;yf=xf+1|0;of=(yf|0)==3;if((yf|2|0)!=3){k[Of>>2]=0;b=Of+4|0;k[b>>2]=0;d=ZT(36)|0;k[d>>2]=1;vf=d+4|0;k[Of>>2]=vf;k[b>>2]=30;i[d+34>>0]=0;e=399324;wf=vf+30|0;do{i[vf>>0]=i[e>>0]|0;vf=vf+1|0;e=e+1|0}while((vf|0)<(wf|0));Y8(-215,Of,399869,399024,161);k[b>>2]=0;k[Of>>2]=0;Nf=k[d>>2]|0;k[d>>2]=Nf+-1;if((Nf|0)==1)ggb(k[d+-4>>2]|0);b=k[Sf>>2]|0}Ff=k[b+40>>2]|0;Ef=k[Ff+4>>2]|0;Ff=k[Ff>>2]|0;Gf=(yf<<3)+-3|0;d=(k[Cf>>2]|0)-b|0;j=(d|0)/56|0;k[Tf>>2]=0;l=Tf+4|0;k[l>>2]=0;k[Tf+8>>2]=0;if(d|0){if(j>>>0>76695844)ad(426534,426557,304,426811);while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[l>>2]=b;k[Tf>>2]=b;k[Tf+8>>2]=b+(j*56|0);d=j;h=b;g=b;while(1){k[h>>2]=1124007936;e=h+8|0;f=h+40|0;vf=h+4|0;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[f>>2]=e;e=h+48|0;k[h+44>>2]=e;k[h+52>>2]=0;k[e>>2]=0;e=g+56|0;d=d+-1|0;if(!d)break;else{h=e;g=e}}k[l>>2]=b+(j*56|0)}k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=1124007936;b=m+16|0;d=m+48|0;vf=m+12|0;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[d>>2]=b;b=m+56|0;k[m+52>>2]=b;k[m+60>>2]=0;k[b>>2]=0;k[m+64>>2]=1124007936;b=m+72|0;d=m+104|0;vf=m+68|0;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[d>>2]=b;b=m+112|0;k[m+108>>2]=b;k[m+116>>2]=0;k[b>>2]=0;k[m+120>>2]=1124007936;b=m+128|0;d=m+160|0;vf=m+124|0;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[d>>2]=b;vf=m+168|0;k[m+164>>2]=vf;wf=vf+56|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Of>>2]=Ef;k[Of+4>>2]=Ff;j1(m,48,Of,5);k[Rf>>2]=1124007936;Mf=Rf+4|0;b=Rf+8|0;Kf=Rf+40|0;vf=Mf;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Kf>>2]=b;Nf=Rf+48|0;Lf=Rf+44|0;k[Lf>>2]=Nf;k[Rf+52>>2]=0;k[Nf>>2]=0;d=k[m>>2]|0;dh[k[(k[d>>2]|0)+12>>2]&255](d,m,Rf,-1);XN(m);d=k[Cf>>2]|0;if((d|0)==(k[Sf>>2]|0))b=d;else{Vc=Jf+4|0;Wc=Jf+8|0;Xc=Jf+40|0;Yc=Jf+48|0;Zc=Jf+44|0;_c=Jf+52|0;$c=Pf+4|0;bd=Pf+8|0;cd=Pf+40|0;dd=Pf+48|0;ed=Pf+44|0;fd=Pf+52|0;gd=zf+4|0;hd=zf+8|0;id=zf+40|0;jd=zf+48|0;kd=zf+44|0;ld=zf+52|0;md=Af+4|0;nd=Af+8|0;od=Af+40|0;pd=Af+48|0;qd=Af+44|0;rd=Af+52|0;sd=Bf+4|0;td=Bf+8|0;ud=Bf+40|0;vd=Bf+48|0;wd=Bf+44|0;xd=Bf+52|0;yd=Of+4|0;zd=yd+4|0;Ad=Of+8|0;Bd=Of+12|0;Cd=Of+4|0;Dd=Qf+4|0;Ed=Dd+4|0;Fd=Of+8|0;Gd=Of+12|0;Hd=Of+4|0;Id=Qf+4|0;Jd=Id+4|0;Kd=Of+8|0;Ld=Of+12|0;Md=Of+4|0;Nd=Qf+4|0;Od=Nd+4|0;Pd=qf+4|0;Qd=qf+8|0;Rd=qf+40|0;Sd=qf+48|0;Td=qf+44|0;Ud=qf+52|0;Vd=Of+8|0;Wd=Of+12|0;Xd=Of+4|0;Yd=Qf+8|0;Zd=Qf+12|0;_d=Qf+4|0;$d=If+4|0;ae=$d+4|0;be=Of+4|0;ce=be+4|0;de=1.0/+(yf|0);ee=sf+4|0;fe=sf+8|0;ge=sf+40|0;he=sf+48|0;ie=sf+44|0;je=sf+52|0;ke=Of+8|0;le=Of+12|0;me=Of+4|0;ne=Qf+4|0;oe=ne+4|0;pe=Of+8|0;qe=Of+12|0;re=Of+4|0;se=Qf+8|0;te=Qf+12|0;ue=Qf+4|0;ve=If+4|0;we=ve+4|0;xe=sf+36|0;ye=sf+16|0;ze=Of+8|0;Ae=Of+12|0;Be=Of+4|0;Ce=Qf+4|0;De=Ce+4|0;Ee=Qf+8|0;Fe=Of+4|0;Ge=Of+8|0;He=Of+40|0;Ie=Of+48|0;Je=Of+44|0;Ke=Of+52|0;Le=Qf+8|0;Me=Qf+12|0;Ne=Qf+4|0;Oe=If+4|0;Pe=Oe+4|0;Qe=Qf+8|0;Re=Qf+12|0;Se=Qf+4|0;Te=If+4|0;Ue=Te+4|0;Ve=If+8|0;We=If+12|0;Xe=If+4|0;Ye=Of+36|0;Ze=Of+16|0;_e=Of+8|0;$e=Of+12|0;af=Of+4|0;bf=a+12|0;cf=Qf+4|0;df=cf+4|0;ef=Of+8|0;ff=Of+12|0;gf=Of+4|0;hf=a+16|0;jf=Qf+4|0;kf=jf+4|0;lf=Of+8|0;mf=Of+12|0;nf=Of+4|0;l=a+20|0;m=Qf+4|0;a=m+4|0;n=Qf+8|0;q=Qf+12|0;s=Qf+4|0;t=If+8|0;u=If+12|0;v=If+4|0;w=sf+8|0;x=Of+8|0;y=Of+12|0;z=Of+4|0;A=Qf+8|0;B=Qf+12|0;C=Qf+4|0;D=If+4|0;E=D+4|0;F=qf+36|0;G=qf+16|0;H=Bf+36|0;I=Bf+16|0;J=Af+36|0;K=Af+16|0;L=zf+36|0;M=zf+16|0;N=Pf+36|0;O=Pf+16|0;P=Jf+36|0;Q=Jf+16|0;R=Of+4|0;S=R+4|0;T=pf+4|0;U=pf+8|0;V=yf*56|0;W=pf+8|0;X=Qf+4|0;Y=Qf+8|0;Z=Qf+12|0;$=Qf+16|0;ba=Qf+48|0;ca=Qf+56|0;da=Qf+52|0;ea=Qf+60|0;fa=Qf+64|0;ga=Qf+68|0;ha=Qf+72|0;ia=Qf+104|0;ja=Qf+112|0;ka=Qf+108|0;la=Qf+116|0;ma=Qf+120|0;na=Qf+124|0;oa=Qf+128|0;pa=Qf+160|0;qa=Qf+168|0;ra=Qf+164|0;sa=rf+4|0;ta=rf+8|0;ua=rf+12|0;va=rf+16|0;wa=rf+48|0;xa=rf+56|0;ya=rf+52|0;za=rf+60|0;Aa=rf+64|0;Ba=rf+68|0;Ca=rf+72|0;Da=rf+104|0;Ea=rf+112|0;Fa=rf+108|0;Ga=rf+116|0;Ha=rf+120|0;Ia=rf+124|0;Ja=rf+128|0;Ka=rf+160|0;La=rf+168|0;Ma=rf+164|0;Na=Of+4|0;Oa=Qf+4|0;Pa=Qf+8|0;Qa=Qf+12|0;Ra=Qf+16|0;Sa=Qf+48|0;Ta=Qf+56|0;Ua=Qf+52|0;Va=Qf+60|0;Wa=Qf+64|0;Xa=Qf+68|0;Ya=Qf+72|0;Za=Qf+104|0;_a=Qf+112|0;$a=Qf+108|0;ab=Qf+116|0;bb=Qf+120|0;cb=Qf+124|0;db=Qf+128|0;eb=Qf+160|0;fb=Qf+168|0;gb=Qf+164|0;hb=Of+4|0;ib=tf+4|0;jb=tf+8|0;kb=tf+12|0;lb=tf+16|0;mb=tf+48|0;nb=tf+56|0;ob=tf+52|0;pb=tf+60|0;qb=tf+64|0;rb=tf+68|0;sb=tf+72|0;tb=tf+104|0;ub=tf+112|0;vb=tf+108|0;wb=tf+116|0;xb=tf+120|0;yb=tf+124|0;zb=tf+128|0;Ab=tf+160|0;Bb=tf+168|0;Cb=tf+164|0;Db=sf+32|0;Eb=Qf+4|0;Fb=Qf+8|0;Gb=Qf+12|0;Hb=Qf+16|0;Ib=Qf+48|0;Jb=Qf+56|0;Kb=Qf+52|0;Lb=Qf+60|0;Mb=Qf+64|0;Nb=Qf+68|0;Ob=Qf+72|0;Pb=Qf+104|0;Qb=Qf+112|0;Rb=Qf+108|0;Sb=Qf+116|0;Tb=Qf+120|0;Ub=Qf+124|0;Vb=Qf+128|0;Wb=Qf+160|0;Xb=Qf+168|0;Yb=Qf+164|0;Zb=Of+4|0;_b=Qf+4|0;$b=Qf+8|0;ac=Qf+12|0;bc=Qf+16|0;cc=Qf+48|0;dc=Qf+56|0;ec=Qf+52|0;fc=Qf+60|0;gc=Qf+64|0;hc=Qf+68|0;ic=Qf+72|0;jc=Qf+104|0;kc=Qf+112|0;lc=Qf+108|0;mc=Qf+116|0;nc=Qf+120|0;oc=Qf+124|0;pc=Qf+128|0;qc=Qf+160|0;rc=Qf+168|0;sc=Qf+164|0;tc=Of+32|0;uc=Of+4|0;vc=Of+8|0;wc=Of+12|0;xc=Of+16|0;yc=Of+48|0;zc=Of+56|0;Ac=Of+52|0;Bc=Of+60|0;Cc=Of+64|0;Dc=Of+68|0;Ec=Of+72|0;Fc=Of+104|0;Gc=Of+112|0;Hc=Of+108|0;Ic=Of+116|0;Jc=Of+120|0;Kc=Of+124|0;Lc=Of+128|0;Mc=Of+160|0;Nc=Of+168|0;Oc=Of+164|0;Pc=Jf+32|0;Qc=Pf+32|0;Rc=zf+32|0;Sc=Af+32|0;Tc=Bf+32|0;Uc=qf+32|0;j=0;do{k[Jf>>2]=1124007936;vf=Vc;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Xc>>2]=Wc;k[Zc>>2]=Yc;k[_c>>2]=0;k[Yc>>2]=0;k[Pf>>2]=1124007936;vf=$c;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[cd>>2]=bd;k[ed>>2]=dd;k[fd>>2]=0;k[dd>>2]=0;k[zf>>2]=1124007936;vf=gd;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[id>>2]=hd;k[kd>>2]=jd;k[ld>>2]=0;k[jd>>2]=0;k[Af>>2]=1124007936;vf=md;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[od>>2]=nd;k[qd>>2]=pd;k[rd>>2]=0;k[pd>>2]=0;k[Bf>>2]=1124007936;vf=sd;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[ud>>2]=td;k[wd>>2]=vd;k[xd>>2]=0;k[vd>>2]=0;k[pf>>2]=0;k[T>>2]=0;k[U>>2]=0;while(1){b=fgb(V)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[T>>2]=b;k[pf>>2]=b;k[W>>2]=b+(yf*56|0);d=yf;h=b;g=b;while(1){k[h>>2]=1124007936;e=h+8|0;f=h+40|0;vf=h+4|0;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[f>>2]=e;e=h+48|0;k[h+44>>2]=e;k[h+52>>2]=0;k[e>>2]=0;e=g+56|0;d=d+-1|0;if(!d)break;else{h=e;g=e}}k[T>>2]=b+(yf*56|0);wf=(k[Sf>>2]|0)+(j*56|0)|0;vf=zd;k[vf>>2]=0;k[vf+4>>2]=0;k[Of>>2]=33619968;k[yd>>2]=Jf;SW(wf,Of,5,.003921568859368563,0.0);if(of){k[Ad>>2]=0;k[Bd>>2]=0;k[Of>>2]=16842752;k[Cd>>2]=Jf;wf=Ed;k[wf>>2]=0;k[wf+4>>2]=0;k[Qf>>2]=33619968;k[Dd>>2]=Pf;$aa(Of,Qf,7,0)}else{wf=S;k[wf>>2]=0;k[wf+4>>2]=0;k[Of>>2]=33619968;k[R>>2]=Pf;mY(Jf,Of)}k[Fd>>2]=0;k[Gd>>2]=0;k[Of>>2]=16842752;k[Hd>>2]=Jf;vf=Jd;k[vf>>2]=0;k[vf+4>>2]=0;k[Qf>>2]=33882112;k[Id>>2]=pf;FV(Of,Qf);k[Kd>>2]=0;k[Ld>>2]=0;k[Of>>2]=16842752;k[Md>>2]=Pf;vf=Od;k[vf>>2]=0;k[vf+4>>2]=0;k[Qf>>2]=33619968;k[Nd>>2]=zf;vfa(Of,Qf,5,1,1.0,0.0,4);k[Qf>>2]=0;k[X>>2]=0;k[Y>>2]=1124007936;vf=Z;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[ba>>2]=$;k[da>>2]=ca;k[ea>>2]=0;k[ca>>2]=0;k[fa>>2]=1124007936;vf=ga;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[ia>>2]=ha;k[ka>>2]=ja;k[la>>2]=0;k[ja>>2]=0;k[ma>>2]=1124007936;vf=na;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[pa>>2]=oa;k[ra>>2]=qa;vf=qa;wf=vf+56|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Of>>2]=0;k[Of+4>>2]=0;k[Of+8>>2]=0;k[Of+12>>2]=0;k[Of+16>>2]=0;k[Of+20>>2]=0;k[Of+24>>2]=0;k[Of+28>>2]=0;z0(Qf,zf,Of);vf=k[Qf>>2]|0;dh[k[(k[vf>>2]|0)+12>>2]&255](vf,Qf,zf,-1);XN(Qf);k[rf>>2]=0;k[sa>>2]=0;k[ta>>2]=1124007936;vf=ua;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[wa>>2]=va;k[ya>>2]=xa;k[za>>2]=0;k[xa>>2]=0;k[Aa>>2]=1124007936;vf=Ba;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Da>>2]=Ca;k[Fa>>2]=Ea;k[Ga>>2]=0;k[Ea>>2]=0;k[Ha>>2]=1124007936;vf=Ia;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Ka>>2]=Ja;k[Ma>>2]=La;vf=La;wf=vf+56|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Of>>2]=Ef;k[Na>>2]=Ff;j1(rf,48,Of,5);k[qf>>2]=1124007936;vf=Pd;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Rd>>2]=Qd;k[Td>>2]=Sd;k[Ud>>2]=0;k[Sd>>2]=0;b=k[rf>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,rf,qf,-1);XN(rf);b=0;while(1){wf=(k[pf>>2]|0)+(b*56|0)|0;k[Vd>>2]=0;k[Wd>>2]=0;k[Of>>2]=16842752;k[Xd>>2]=qf;k[Yd>>2]=0;k[Zd>>2]=0;k[Qf>>2]=16842752;k[_d>>2]=wf;wf=ae;k[wf>>2]=0;k[wf+4>>2]=0;k[If>>2]=33619968;k[$d>>2]=qf;sU(Of,Qf,If,49332,-1,39936,0,0);if((b|0)<(xf|0))b=b+1|0;else break}vf=ce;k[vf>>2]=0;k[vf+4>>2]=0;k[Of>>2]=33619968;k[be>>2]=qf;SW(qf,Of,-1,de,0.0);k[Qf>>2]=0;k[Oa>>2]=0;k[Pa>>2]=1124007936;vf=Qa;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Sa>>2]=Ra;k[Ua>>2]=Ta;k[Va>>2]=0;k[Ta>>2]=0;k[Wa>>2]=1124007936;vf=Xa;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Za>>2]=Ya;k[$a>>2]=_a;k[ab>>2]=0;k[_a>>2]=0;k[bb>>2]=1124007936;vf=cb;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[eb>>2]=db;k[gb>>2]=fb;vf=fb;wf=vf+56|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Of>>2]=Ef;k[hb>>2]=Ff;j1(Qf,48,Of,5);e=k[Qf>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,Qf,Af,-1);XN(Qf);e=0;while(1){b=(k[pf>>2]|0)+(e*56|0)|0;k[tf>>2]=0;k[ib>>2]=0;k[jb>>2]=1124007936;vf=kb;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[mb>>2]=lb;k[ob>>2]=nb;k[pb>>2]=0;k[nb>>2]=0;k[qb>>2]=1124007936;vf=rb;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[tb>>2]=sb;k[vb>>2]=ub;k[wb>>2]=0;k[ub>>2]=0;k[xb>>2]=1124007936;vf=yb;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Ab>>2]=zb;k[Cb>>2]=Bb;vf=Bb;wf=vf+56|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Of>>2]=0;k[Of+4>>2]=0;k[Of+8>>2]=0;k[Of+12>>2]=0;k[Of+16>>2]=0;k[Of+20>>2]=0;k[Of+24>>2]=0;k[Of+28>>2]=0;G0(tf,b,qf,1.0,-1.0,Of);k[sf>>2]=1124007936;vf=ee;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[ge>>2]=fe;k[ie>>2]=he;k[je>>2]=0;k[he>>2]=0;b=k[tf>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,tf,sf,-1);XN(tf);k[ke>>2]=0;k[le>>2]=0;k[Of>>2]=16842752;k[me>>2]=sf;b=oe;k[b>>2]=0;k[b+4>>2]=0;k[Qf>>2]=33619968;k[ne>>2]=sf;ZZ(Of,2.0,Qf);k[pe>>2]=0;k[qe>>2]=0;k[Of>>2]=16842752;k[re>>2]=Af;k[se>>2]=0;k[te>>2]=0;k[Qf>>2]=16842752;k[ue>>2]=sf;b=we;k[b>>2]=0;k[b+4>>2]=0;k[If>>2]=33619968;k[ve>>2]=Af;sU(Of,Qf,If,49332,-1,39936,0,0);b=k[xe>>2]|0;if(b|0?(vf=b+12|0,wf=k[vf>>2]|0,k[vf>>2]=wf+-1,(wf|0)==1):0){d=k[xe>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Db>>2]|0;if(!b){b=B1()|0;d=k[xe>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[xe>>2]=0}k[xe>>2]=0;k[ye>>2]=0;k[ye+4>>2]=0;k[ye+8>>2]=0;k[ye+12>>2]=0;if((k[ee>>2]|0)>0){d=k[ge>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ee>>2]|0))}b=k[ie>>2]|0;if(!((b|0)==(he|0)|(b|0)==0))ggb(k[b+-4>>2]|0);if((e|0)<(xf|0))e=e+1|0;else break}k[ze>>2]=0;k[Ae>>2]=0;k[Of>>2]=16842752;k[Be>>2]=Af;vf=De;k[vf>>2]=0;k[vf+4>>2]=0;k[Qf>>2]=33619968;k[Ce>>2]=Af;ZZ(Of,.5,Qf);k[Qf>>2]=0;k[Eb>>2]=0;k[Fb>>2]=1124007936;vf=Gb;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Ib>>2]=Hb;k[Kb>>2]=Jb;k[Lb>>2]=0;k[Jb>>2]=0;k[Mb>>2]=1124007936;vf=Nb;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Pb>>2]=Ob;k[Rb>>2]=Qb;k[Sb>>2]=0;k[Qb>>2]=0;k[Tb>>2]=1124007936;vf=Ub;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Wb>>2]=Vb;k[Yb>>2]=Xb;vf=Xb;wf=vf+56|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Of>>2]=Ef;k[Zb>>2]=Ff;j1(Qf,49,Of,5);e=k[Qf>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,Qf,Bf,-1);XN(Qf);e=0;while(1){vf=(k[pf>>2]|0)+(e*56|0)|0;p[Qf>>3]=.5;k[Ee>>2]=0;k[Ee+4>>2]=0;k[Ee+8>>2]=0;k[Ee+12>>2]=0;k[Ee+16>>2]=0;k[Ee+20>>2]=0;Y0(uf,vf,Qf);k[Of>>2]=1124007936;vf=Fe;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[He>>2]=Ge;k[Je>>2]=Ie;k[Ke>>2]=0;k[Ie>>2]=0;vf=k[uf>>2]|0;dh[k[(k[vf>>2]|0)+12>>2]&255](vf,uf,Of,-1);XN(uf);k[Le>>2]=0;k[Me>>2]=0;k[Qf>>2]=16842752;k[Ne>>2]=Of;vf=Pe;k[vf>>2]=0;k[vf+4>>2]=0;k[If>>2]=33619968;k[Oe>>2]=Of;ZZ(Qf,2.0,If);$0(If,Of);k[Qf>>2]=0;k[_b>>2]=0;k[$b>>2]=1124007936;vf=ac;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[cc>>2]=bc;k[ec>>2]=dc;k[fc>>2]=0;k[dc>>2]=0;k[gc>>2]=1124007936;vf=hc;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[jc>>2]=ic;k[lc>>2]=kc;k[mc>>2]=0;k[kc>>2]=0;k[nc>>2]=1124007936;vf=oc;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[qc>>2]=pc;k[sc>>2]=rc;vf=rc;wf=vf+56|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));b=k[If>>2]|0;nh[k[(k[b>>2]|0)+72>>2]&15](b,If,12.50000027939678,Qf);b=k[Qf>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,Qf,Of,-1);XN(Qf);XN(If);k[Qe>>2]=0;k[Re>>2]=0;k[Qf>>2]=16842752;k[Se>>2]=Of;b=Ue;k[b>>2]=0;k[b+4>>2]=0;k[If>>2]=33619968;k[Te>>2]=Of;XZ(Qf,If);k[Ve>>2]=0;k[We>>2]=0;k[If>>2]=16842752;k[Xe>>2]=Of;i1(Qf,Bf,If,1.0);b=k[Qf>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,Qf,Bf,-1);XN(Qf);b=k[Ye>>2]|0;if(b|0?(vf=b+12|0,wf=k[vf>>2]|0,k[vf>>2]=wf+-1,(wf|0)==1):0){d=k[Ye>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[tc>>2]|0;if(!b){b=B1()|0;d=k[Ye>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[Ye>>2]=0}k[Ye>>2]=0;k[Ze>>2]=0;k[Ze+4>>2]=0;k[Ze+8>>2]=0;k[Ze+12>>2]=0;if((k[Fe>>2]|0)>0){d=k[He>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Fe>>2]|0))}b=k[Je>>2]|0;if(!((b|0)==(Ie|0)|(b|0)==0))ggb(k[b+-4>>2]|0);if((e|0)<(xf|0))e=e+1|0;else break}k[_e>>2]=0;k[$e>>2]=0;k[Of>>2]=16842752;k[af>>2]=zf;Vf=+o[bf>>2];b=df;k[b>>2]=0;k[b+4>>2]=0;k[Qf>>2]=33619968;k[cf>>2]=zf;ZZ(Of,Vf,Qf);k[ef>>2]=0;k[ff>>2]=0;k[Of>>2]=16842752;k[gf>>2]=Af;Vf=+o[hf>>2];b=kf;k[b>>2]=0;k[b+4>>2]=0;k[Qf>>2]=33619968;k[jf>>2]=Af;ZZ(Of,Vf,Qf);k[lf>>2]=0;k[mf>>2]=0;k[Of>>2]=16842752;k[nf>>2]=Bf;Vf=+o[l>>2];b=a;k[b>>2]=0;k[b+4>>2]=0;k[Qf>>2]=33619968;k[m>>2]=Bf;ZZ(Of,Vf,Qf);b=(k[Tf>>2]|0)+(j*56|0)|0;KG(b,zf)|0;if(of){k[n>>2]=0;k[q>>2]=0;k[Qf>>2]=16842752;k[s>>2]=Af;i1(Of,b,Qf,1.0);wf=k[Of>>2]|0;dh[k[(k[wf>>2]|0)+12>>2]&255](wf,Of,b,-1);XN(Of)}k[t>>2]=0;k[u>>2]=0;k[If>>2]=16842752;k[v>>2]=Bf;i1(Qf,b,If,1.0);p[sf>>3]=9.999999960041972e-13;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;k[w+16>>2]=0;k[w+20>>2]=0;k[Of>>2]=0;k[uc>>2]=0;k[vc>>2]=1124007936;vf=wc;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[yc>>2]=xc;k[Ac>>2]=zc;k[Bc>>2]=0;k[zc>>2]=0;k[Cc>>2]=1124007936;vf=Dc;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Fc>>2]=Ec;k[Hc>>2]=Gc;k[Ic>>2]=0;k[Gc>>2]=0;k[Jc>>2]=1124007936;vf=Kc;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[Mc>>2]=Lc;k[Oc>>2]=Nc;vf=Nc;wf=vf+56|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));wf=k[Qf>>2]|0;dh[k[(k[wf>>2]|0)+56>>2]&255](wf,Qf,sf,Of);wf=k[Of>>2]|0;dh[k[(k[wf>>2]|0)+12>>2]&255](wf,Of,b,-1);XN(Of);XN(Qf);k[x>>2]=0;k[y>>2]=0;k[Of>>2]=16842752;k[z>>2]=Rf;k[A>>2]=0;k[B>>2]=0;k[Qf>>2]=16842752;k[C>>2]=b;b=E;k[b>>2]=0;k[b+4>>2]=0;k[If>>2]=33619968;k[D>>2]=Rf;sU(Of,Qf,If,49332,-1,39936,0,0);b=k[F>>2]|0;if(b|0?(vf=b+12|0,wf=k[vf>>2]|0,k[vf>>2]=wf+-1,(wf|0)==1):0){d=k[F>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Uc>>2]|0;if(!b){b=B1()|0;d=k[F>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[F>>2]=0}k[F>>2]=0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[Pd>>2]|0)>0){d=k[Rd>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Pd>>2]|0))}b=k[Td>>2]|0;if(!((b|0)==(Sd|0)|(b|0)==0))ggb(k[b+-4>>2]|0);zF(pf);b=k[H>>2]|0;if(b|0?(vf=b+12|0,wf=k[vf>>2]|0,k[vf>>2]=wf+-1,(wf|0)==1):0){d=k[H>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Tc>>2]|0;if(!b){b=B1()|0;d=k[H>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[H>>2]=0}k[H>>2]=0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[sd>>2]|0)>0){d=k[ud>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[sd>>2]|0))}b=k[wd>>2]|0;if(!((b|0)==(vd|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[J>>2]|0;if(b|0?(vf=b+12|0,wf=k[vf>>2]|0,k[vf>>2]=wf+-1,(wf|0)==1):0){d=k[J>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Sc>>2]|0;if(b|0)break;b=B1()|0;d=k[J>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[J>>2]=0}k[J>>2]=0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[md>>2]|0)>0){d=k[od>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[md>>2]|0))}b=k[qd>>2]|0;if(!((b|0)==(pd|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[L>>2]|0;if(b|0?(vf=b+12|0,wf=k[vf>>2]|0,k[vf>>2]=wf+-1,(wf|0)==1):0){d=k[L>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Rc>>2]|0;if(b|0)break;b=B1()|0;d=k[L>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[L>>2]=0}k[L>>2]=0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[gd>>2]|0)>0){d=k[id>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[gd>>2]|0))}b=k[kd>>2]|0;if(!((b|0)==(jd|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[N>>2]|0;do if(b|0){vf=b+12|0;wf=k[vf>>2]|0;k[vf>>2]=wf+-1;if((wf|0)!=1)break;d=k[N>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Qc>>2]|0;if(b|0)break;b=B1()|0;d=k[N>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[N>>2]=0}while(0);k[N>>2]=0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[$c>>2]|0)>0){d=k[cd>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[$c>>2]|0))}b=k[ed>>2]|0;if(!((b|0)==(dd|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[P>>2]|0;do if(b|0){vf=b+12|0;wf=k[vf>>2]|0;k[vf>>2]=wf+-1;if((wf|0)!=1)break;d=k[P>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Pc>>2]|0;if(b|0)break;b=B1()|0;d=k[P>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[P>>2]=0}while(0);k[P>>2]=0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[Vc>>2]|0)>0){d=k[Xc>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Vc>>2]|0))}b=k[Zc>>2]|0;if(!((b|0)==(Yc|0)|(b|0)==0))ggb(k[b+-4>>2]|0);j=j+1|0;d=k[Cf>>2]|0;b=k[Sf>>2]|0}while(j>>>0<((d-b|0)/56|0)>>>0)}Va=~~(+_(+(+(((Ff|0)<(Ef|0)?Ff:Ef)|0)))/.6931471824645996);j=Va+1|0;k[Pf>>2]=0;l=Pf+4|0;k[l>>2]=0;k[Pf+8>>2]=0;if(j){if(j>>>0>76695844)ad(426534,426557,304,426811);d=j*56|0;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[l>>2]=b;k[Pf>>2]=b;k[Pf+8>>2]=b+(j*56|0);d=j;h=b;g=b;while(1){k[h>>2]=1124007936;e=h+8|0;f=h+40|0;vf=h+4|0;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[f>>2]=e;e=h+48|0;k[h+44>>2]=e;k[h+52>>2]=0;k[e>>2]=0;e=g+56|0;d=d+-1|0;if(!d)break;else{h=e;g=e}}k[l>>2]=b+(j*56|0);d=k[Cf>>2]|0;b=k[Sf>>2]|0}if((d|0)!=(b|0)){m=Qf+8|0;a=Qf+12|0;n=Qf+4|0;q=If+8|0;s=If+12|0;t=If+4|0;u=Jf+4|0;v=u+4|0;w=Jf+4|0;x=Jf+8|0;y=Jf+40|0;z=Jf+48|0;A=Jf+44|0;B=Jf+52|0;C=Of+4|0;D=C+4|0;E=zf+4|0;F=zf+8|0;G=Af+4|0;H=Af+8|0;I=Of+8|0;J=Of+12|0;K=Of+4|0;L=Qf+4|0;M=L+4|0;N=Of+8|0;O=Of+12|0;P=Of+4|0;Q=Qf+4|0;R=Q+4|0;S=(Va|0)>0;T=(Va|0)<0;U=Jf+36|0;V=Jf+16|0;W=Of+8|0;X=Of+12|0;Y=Of+4|0;Z=Qf+4|0;$=Z+4|0;ba=Qf+8|0;ca=Qf+12|0;da=Qf+4|0;ea=Qf+8|0;fa=Qf+12|0;ga=Qf+4|0;ha=If+4|0;ia=ha+4|0;ja=Of+8|0;ka=Of+12|0;la=Of+4|0;ma=Qf+8|0;na=Qf+12|0;oa=Qf+4|0;pa=If+4|0;qa=pa+4|0;ra=Bf+4|0;sa=Bf+8|0;ta=Bf+40|0;ua=Bf+48|0;va=Bf+44|0;wa=Bf+52|0;xa=Of+8|0;ya=Of+12|0;za=Of+4|0;Aa=Qf+4|0;Ba=Aa+4|0;Ca=If+4|0;Da=Of+8|0;Ea=Of+12|0;Fa=Of+4|0;Ga=Qf+8|0;Ha=Qf+12|0;Ia=Qf+4|0;Ja=If+4|0;Ka=Ja+4|0;La=Bf+36|0;Ma=Bf+16|0;Na=Jf+32|0;Oa=Bf+4|0;Pa=Bf+8|0;Qa=yf*56|0;Ra=Bf+8|0;Sa=Of+4|0;Ta=Of+8|0;Ua=Bf+32|0;l=0;do{b=(k[Tf>>2]|0)+(l*56|0)|0;k[m>>2]=0;k[a>>2]=0;k[Qf>>2]=16842752;k[n>>2]=b;k[q>>2]=0;k[s>>2]=0;k[If>>2]=16842752;k[t>>2]=Rf;vf=v;k[vf>>2]=0;k[vf+4>>2]=0;k[Jf>>2]=33619968;k[u>>2]=b;p[Of>>3]=1.0;sU(Qf,If,Jf,49332,-1,40064,1,Of);k[Jf>>2]=1124007936;vf=w;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[y>>2]=x;k[A>>2]=z;k[B>>2]=0;k[z>>2]=0;wf=(k[Sf>>2]|0)+(l*56|0)|0;vf=D;k[vf>>2]=0;k[vf+4>>2]=0;k[Of>>2]=33619968;k[C>>2]=Jf;SW(wf,Of,5,.003921568859368563,0.0);k[zf>>2]=0;k[E>>2]=0;k[F>>2]=0;k[Af>>2]=0;k[G>>2]=0;k[H>>2]=0;k[I>>2]=0;k[J>>2]=0;k[Of>>2]=16842752;k[K>>2]=Jf;wf=M;k[wf>>2]=0;k[wf+4>>2]=0;k[Qf>>2]=33882112;k[L>>2]=zf;Vra(Of,Qf,Va);k[N>>2]=0;k[O>>2]=0;k[Of>>2]=16842752;k[P>>2]=b;wf=R;k[wf>>2]=0;k[wf+4>>2]=0;k[Qf>>2]=33882112;k[Q>>2]=Af;Vra(Of,Qf,Va);if(S){e=0;do{k[Bf>>2]=1124007936;vf=ra;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[ta>>2]=sa;k[va>>2]=ua;k[wa>>2]=0;k[ua>>2]=0;b=e;e=e+1|0;vf=k[zf>>2]|0;k[xa>>2]=0;k[ya>>2]=0;k[Of>>2]=16842752;k[za>>2]=vf+(e*56|0);wf=Ba;k[wf>>2]=0;k[wf+4>>2]=0;k[Qf>>2]=33619968;k[Aa>>2]=Bf;vf=k[vf+(b*56|0)+40>>2]|0;wf=k[vf>>2]|0;k[If>>2]=k[vf+4>>2];k[Ca>>2]=wf;Pra(Of,Qf,If,4);b=(k[zf>>2]|0)+(b*56|0)|0;k[Da>>2]=0;k[Ea>>2]=0;k[Of>>2]=16842752;k[Fa>>2]=b;k[Ga>>2]=0;k[Ha>>2]=0;k[Qf>>2]=16842752;k[Ia>>2]=Bf;wf=Ka;k[wf>>2]=0;k[wf+4>>2]=0;k[If>>2]=33619968;k[Ja>>2]=b;sU(Of,Qf,If,49332,-1,39968,0,0);b=k[La>>2]|0;if(b|0?(vf=b+12|0,wf=k[vf>>2]|0,k[vf>>2]=wf+-1,(wf|0)==1):0){d=k[La>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Ua>>2]|0;if(!b){b=B1()|0;d=k[La>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[La>>2]=0}k[La>>2]=0;k[Ma>>2]=0;k[Ma+4>>2]=0;k[Ma+8>>2]=0;k[Ma+12>>2]=0;if((k[ra>>2]|0)>0){d=k[ta>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ra>>2]|0))}b=k[va>>2]|0;if(!((b|0)==(ua|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((e|0)<(Va|0))}if(!T){j=0;while(1){k[Bf>>2]=0;k[Oa>>2]=0;k[Pa>>2]=0;while(1){b=fgb(Qa)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[Oa>>2]=b;k[Bf>>2]=b;k[Ra>>2]=b+(yf*56|0);d=yf;h=b;g=b;while(1){k[h>>2]=1124007936;e=h+8|0;f=h+40|0;vf=h+4|0;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[f>>2]=e;e=h+48|0;k[h+44>>2]=e;k[h+52>>2]=0;k[e>>2]=0;e=g+56|0;d=d+-1|0;if(!d)break;else{h=e;g=e}}k[Oa>>2]=b+(yf*56|0);b=(k[zf>>2]|0)+(j*56|0)|0;k[W>>2]=0;k[X>>2]=0;k[Of>>2]=16842752;k[Y>>2]=b;b=$;k[b>>2]=0;k[b+4>>2]=0;k[Qf>>2]=33882112;k[Z>>2]=Bf;FV(Of,Qf);b=0;while(1){wf=(k[Bf>>2]|0)+(b*56|0)|0;vf=(k[Af>>2]|0)+(j*56|0)|0;k[ba>>2]=0;k[ca>>2]=0;k[Qf>>2]=16842752;k[da>>2]=vf;i1(Of,wf,Qf,1.0);vf=k[Of>>2]|0;dh[k[(k[vf>>2]|0)+12>>2]&255](vf,Of,wf,-1);XN(Of);if((b|0)<(xf|0))b=b+1|0;else break}k[ea>>2]=0;k[fa>>2]=0;k[Qf>>2]=17104896;k[ga>>2]=Bf;g=(k[zf>>2]|0)+(j*56|0)|0;wf=ia;k[wf>>2]=0;k[wf+4>>2]=0;k[If>>2]=33619968;k[ha>>2]=g;k[Of>>2]=0;k[Sa>>2]=0;k[Ta>>2]=0;B2(Qf,Of);g=k[Of>>2]|0;wf=k[Sa>>2]|0;GV((g|0)==(wf|0)?0:g,(wf-g|0)/56|0,If);zF(Of);g=k[Pf>>2]|0;if(k[g+(j*56|0)+16>>2]|0){d=k[g+(j*56|0)+4>>2]|0;if((d|0)<3)e=aa(k[g+(j*56|0)+12>>2]|0,k[g+(j*56|0)+8>>2]|0)|0;else{f=k[g+(j*56|0)+40>>2]|0;b=0;e=1;do{e=aa(k[f+(b<<2)>>2]|0,e)|0;b=b+1|0}while((b|0)!=(d|0))}d=g+(j*56|0)|0;b=(k[zf>>2]|0)+(j*56|0)|0;if(!e)Df=183;else{k[ja>>2]=0;k[ka>>2]=0;k[Of>>2]=16842752;k[la>>2]=d;k[ma>>2]=0;k[na>>2]=0;k[Qf>>2]=16842752;k[oa>>2]=b;wf=qa;k[wf>>2]=0;k[wf+4>>2]=0;k[If>>2]=33619968;k[pa>>2]=d;sU(Of,Qf,If,49332,-1,39936,0,0)}}else{d=g+(j*56|0)|0;b=(k[zf>>2]|0)+(j*56|0)|0;Df=183}if((Df|0)==183){Df=0;KG(d,b)|0}zF(Bf);if((j|0)<(Va|0))j=j+1|0;else break}}zF(Af);zF(zf);b=k[U>>2]|0;if(b|0?(vf=b+12|0,wf=k[vf>>2]|0,k[vf>>2]=wf+-1,(wf|0)==1):0){d=k[U>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Na>>2]|0;if(!b){b=B1()|0;d=k[U>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[U>>2]=0}k[U>>2]=0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[w>>2]|0)>0){d=k[y>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[w>>2]|0))}b=k[A>>2]|0;if(!((b|0)==(z|0)|(b|0)==0))ggb(k[b+-4>>2]|0);l=l+1|0}while(l>>>0<(((k[Cf>>2]|0)-(k[Sf>>2]|0)|0)/56|0)>>>0)}if((Va|0)>0){g=Jf+4|0;h=Jf+8|0;j=Jf+40|0;l=Jf+48|0;m=Jf+44|0;a=Jf+52|0;n=Of+8|0;q=Of+12|0;s=Of+4|0;t=Qf+4|0;u=t+4|0;v=If+4|0;w=Of+8|0;x=Of+12|0;y=Of+4|0;z=Qf+8|0;A=Qf+12|0;B=Qf+4|0;C=If+4|0;D=C+4|0;E=Jf+36|0;F=Jf+16|0;G=Jf+32|0;f=Va;do{k[Jf>>2]=1124007936;vf=g;wf=vf+36|0;do{k[vf>>2]=0;vf=vf+4|0}while((vf|0)<(wf|0));k[j>>2]=h;k[m>>2]=l;k[a>>2]=0;k[l>>2]=0;b=k[Pf>>2]|0;k[n>>2]=0;k[q>>2]=0;k[Of>>2]=16842752;k[s>>2]=b+(f*56|0);e=u;k[e>>2]=0;k[e+4>>2]=0;k[Qf>>2]=33619968;k[t>>2]=Jf;e=f;f=f+-1|0;Cf=k[b+(f*56|0)+40>>2]|0;Df=k[Cf>>2]|0;k[If>>2]=k[Cf+4>>2];k[v>>2]=Df;Pra(Of,Qf,If,4);b=b+(f*56|0)|0;k[w>>2]=0;k[x>>2]=0;k[Of>>2]=16842752;k[y>>2]=b;k[z>>2]=0;k[A>>2]=0;k[Qf>>2]=16842752;k[B>>2]=Jf;Df=D;k[Df>>2]=0;k[Df+4>>2]=0;k[If>>2]=33619968;k[C>>2]=b;sU(Of,Qf,If,49332,-1,39936,0,0);b=k[E>>2]|0;if(b|0?(Cf=b+12|0,Df=k[Cf>>2]|0,k[Cf>>2]=Df+-1,(Df|0)==1):0){d=k[E>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[G>>2]|0;if(!b){b=B1()|0;d=k[E>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[E>>2]=0}k[E>>2]=0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[g>>2]|0)>0){d=k[j>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[m>>2]|0;if(!((b|0)==(l|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((e|0)>1)}k[Hf>>2]=Ef;k[Hf+4>>2]=Ff;x2(c,Hf,Gf,0);m=k[Pf>>2]|0;do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[Qf>>2]=k[f>>2];l=Qf+4|0;b=f+4|0;k[l>>2]=k[b>>2];c=Qf+8|0;k[c>>2]=k[f+8>>2];k[Qf+12>>2]=k[f+12>>2];k[Qf+16>>2]=k[f+16>>2];k[Qf+20>>2]=k[f+20>>2];k[Qf+24>>2]=k[f+24>>2];k[Qf+28>>2]=k[f+28>>2];k[Qf+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[Qf+36>>2]=d;e=Qf+40|0;k[e>>2]=c;c=Qf+48|0;h=Qf+44|0;k[h>>2]=c;k[Qf+52>>2]=0;k[c>>2]=0;if(d|0){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[b>>2]|0)<3){Jf=k[f+44>>2]|0;c=k[h>>2]|0;k[c>>2]=k[Jf>>2];k[c+4>>2]=k[Jf+4>>2];break}k[l>>2]=0;x1(Qf,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(Qf,c,-1);while(0);e=Of+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[Of>>2]=-1040121856;k[e>>2]=Qf;mY(m,Of);e=Qf+36|0;b=k[e>>2]|0;if(b|0?(c=b+12|0,Of=k[c>>2]|0,k[c>>2]=Of+-1,(Of|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Qf+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;Of=Qf+16|0;d=Qf+4|0;k[Of>>2]=0;k[Of+4>>2]=0;k[Of+8>>2]=0;k[Of+12>>2]=0;if((k[d>>2]|0)>0){e=k[Qf+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[Qf+44>>2]|0;if(!((b|0)==(Qf+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);zF(Pf);e=Rf+36|0;b=k[e>>2]|0;if(b|0?(Pf=b+12|0,Qf=k[Pf>>2]|0,k[Pf>>2]=Qf+-1,(Qf|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Rf+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;Rf=Rf+16|0;k[Rf>>2]=0;k[Rf+4>>2]=0;k[Rf+8>>2]=0;k[Rf+12>>2]=0;if((k[Mf>>2]|0)>0){d=k[Kf>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Mf>>2]|0))}b=k[Lf>>2]|0;if((b|0)==(Nf|0)|(b|0)==0){zF(Tf);zF(Sf);r=Uf;return}ggb(k[b+-4>>2]|0);zF(Tf);zF(Sf);r=Uf;return}function u3a(a){a=a|0;return +(+o[a+12>>2])}function v3a(a,b){a=a|0;b=+b;o[a+12>>2]=b;return}function w3a(a){a=a|0;return +(+o[a+16>>2])}function x3a(a,b){a=a|0;b=+b;o[a+16>>2]=b;return}function y3a(a){a=a|0;return +(+o[a+20>>2])}function z3a(a,b){a=a|0;b=+b;o[a+20>>2]=b;return}function A3a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+o[b>>2]);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function B3a(a){a=a|0;var b=0,c=0,d=0,e=0;while(1){b=fgb(68)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=151240;c=b+4|0;k[c>>2]=0;e=b+8|0;k[e>>2]=0;d=ZT(20)|0;k[d>>2]=1;k[c>>2]=d+4;k[e>>2]=14;i[d+18>>0]=0;c=k[c>>2]|0;d=399507;e=c+14|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y2a(b+12|0);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=c+4|0;k[e>>2]=1;k[c>>2]=151220;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function C3a(a){a=a|0;ggb(a);return}function D3a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function E3a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=151240;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if(!((b|0)==(a+60|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;d=b+-4|0;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;ggb(k[b+-8>>2]|0);return}function F3a(a){a=a|0;E3a(a);ggb(a);return}function G3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;Pa=r;r=r+1392|0;Ha=Pa+896|0;Na=Pa+1368|0;Oa=Pa+1304|0;n=Pa+1360|0;Ma=Pa+1248|0;La=Pa+1192|0;Ka=Pa+448|0;u=Pa+672|0;Ca=Pa+1136|0;Da=Pa+224|0;Ea=Pa;Fa=Pa+1120|0;k[Na>>2]=0;Ga=Na+4|0;k[Ga>>2]=0;k[Na+8>>2]=0;B2(b,Na);do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[Oa>>2]=k[g>>2];m=Oa+4|0;b=g+4|0;k[m>>2]=k[b>>2];Ba=Oa+8|0;k[Ba>>2]=k[g+8>>2];k[Oa+12>>2]=k[g+12>>2];k[Oa+16>>2]=k[g+16>>2];k[Oa+20>>2]=k[g+20>>2];k[Oa+24>>2]=k[g+24>>2];k[Oa+28>>2]=k[g+28>>2];k[Oa+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[Oa+36>>2]=d;f=Oa+40|0;k[f>>2]=Ba;Ba=Oa+48|0;j=Oa+44|0;k[j>>2]=Ba;k[Oa+52>>2]=0;k[Ba>>2]=0;if(d|0){Ba=d+12|0;k[Ba>>2]=(k[Ba>>2]|0)+1}if((k[b>>2]|0)<3){Aa=k[g+44>>2]|0;Ba=k[j>>2]|0;k[Ba>>2]=k[Aa>>2];k[Ba+4>>2]=k[Aa+4>>2];break}k[m>>2]=0;x1(Oa,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;d=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[d+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else{Q1(Oa,d,-1);m=Oa+4|0}while(0);h=((k[Ga>>2]|0)-(k[Na>>2]|0)|0)/56|0;f=k[m>>2]|0;if((f|0)<3)b=aa(k[Oa+12>>2]|0,k[Oa+8>>2]|0)|0;else{g=k[Oa+40>>2]|0;d=0;b=1;do{b=aa(k[g+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(f|0))}if((h|0)!=(b|0)){k[Ha>>2]=0;b=Ha+4|0;k[b>>2]=0;d=ZT(36)|0;k[d>>2]=1;ha=d+4|0;k[Ha>>2]=ha;k[b>>2]=30;i[d+34>>0]=0;f=398993;ia=ha+30|0;do{i[ha>>0]=i[f>>0]|0;ha=ha+1|0;f=f+1|0}while((ha|0)<(ia|0));Y8(-215,Ha,399869,399024,308);k[b>>2]=0;k[Ha>>2]=0;Ba=k[d>>2]|0;k[d>>2]=Ba+-1;if((Ba|0)==1)ggb(k[d+-4>>2]|0)}W2a(Na);d=k[Na>>2]|0;b=k[d>>2]|0;if(b&7){k[Ha>>2]=0;b=Ha+4|0;k[b>>2]=0;d=ZT(32)|0;k[d>>2]=1;ha=d+4|0;k[Ha>>2]=ha;k[b>>2]=26;i[d+30>>0]=0;f=399089;ia=ha+26|0;do{i[ha>>0]=i[f>>0]|0;ha=ha+1|0;f=f+1|0}while((ha|0)<(ia|0));Y8(-215,Ha,399869,399024,310);k[b>>2]=0;k[Ha>>2]=0;Ba=k[d>>2]|0;k[d>>2]=Ba+-1;if((Ba|0)==1)ggb(k[d+-4>>2]|0);d=k[Na>>2]|0;b=k[d>>2]|0}q=b>>>3&511;p=q+1|0;t=(p<<3)+-3|0;Aa=k[d+40>>2]|0;Ba=k[Aa>>2]|0;k[n>>2]=k[Aa+4>>2];k[n+4>>2]=Ba;x2(c,n,t,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[Ma>>2]=k[g>>2];c=Ma+4|0;b=g+4|0;k[c>>2]=k[b>>2];Ba=Ma+8|0;k[Ba>>2]=k[g+8>>2];k[Ma+12>>2]=k[g+12>>2];k[Ma+16>>2]=k[g+16>>2];k[Ma+20>>2]=k[g+20>>2];k[Ma+24>>2]=k[g+24>>2];k[Ma+28>>2]=k[g+28>>2];k[Ma+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[Ma+36>>2]=d;f=Ma+40|0;k[f>>2]=Ba;Ba=Ma+48|0;j=Ma+44|0;k[j>>2]=Ba;k[Ma+52>>2]=0;k[Ba>>2]=0;if(d|0){Ba=d+12|0;k[Ba>>2]=(k[Ba>>2]|0)+1}if((k[b>>2]|0)<3){Aa=k[g+44>>2]|0;Ba=k[j>>2]|0;k[Ba>>2]=k[Aa>>2];k[Ba+4>>2]=k[Aa+4>>2];break}k[c>>2]=0;x1(Ma,k[b>>2]|0,0,0,0);if((k[c>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;d=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[d+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[c>>2]|0))}}else Q1(Ma,c,-1);while(0);do if((k[e>>2]&2031616|0)==65536){g=k[e+4>>2]|0;k[La>>2]=k[g>>2];c=La+4|0;b=g+4|0;k[c>>2]=k[b>>2];Ba=La+8|0;k[Ba>>2]=k[g+8>>2];k[La+12>>2]=k[g+12>>2];n=La+16|0;k[n>>2]=k[g+16>>2];k[La+20>>2]=k[g+20>>2];k[La+24>>2]=k[g+24>>2];k[La+28>>2]=k[g+28>>2];k[La+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[La+36>>2]=d;f=La+40|0;k[f>>2]=Ba;Ba=La+48|0;j=La+44|0;k[j>>2]=Ba;k[La+52>>2]=0;k[Ba>>2]=0;if(d|0){Ba=d+12|0;k[Ba>>2]=(k[Ba>>2]|0)+1}if((k[b>>2]|0)<3){Aa=k[g+44>>2]|0;Ba=k[j>>2]|0;k[Ba>>2]=k[Aa>>2];k[Ba+4>>2]=k[Aa+4>>2];break}k[c>>2]=0;x1(La,k[b>>2]|0,0,0,0);if((k[c>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;d=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[d+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[c>>2]|0))}}else{Q1(La,e,-1);n=La+16|0}while(0);if(k[n>>2]|0){f=k[La+4>>2]|0;if((f|0)<3)b=aa(k[La+12>>2]|0,k[La+8>>2]|0)|0;else{g=k[La+40>>2]|0;d=0;b=1;do{b=aa(k[g+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(f|0))}if(!b)Ja=46}else Ja=46;if((Ja|0)==46){_2a(Ka,p);f1(Ha,Ka,128.0);f=k[Ha>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,Ha,La,-1);XN(Ha);f=Ka+36|0;b=k[f>>2]|0;if(b|0?(Aa=b+12|0,Ba=k[Aa>>2]|0,k[Aa>>2]=Ba+-1,(Ba|0)==1):0){d=k[f>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Ka+32>>2]|0;if(!b){b=B1()|0;d=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[f>>2]=0}k[f>>2]=0;Ba=Ka+16|0;d=Ka+4|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;if((k[d>>2]|0)>0){f=k[Ka+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[Ka+44>>2]|0;if(!((b|0)==(Ka+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if(!(((k[La+8>>2]|0)==256?(k[La+12>>2]|0)==1:0)?((k[La>>2]|0)>>>3&511|0)==(q|0):0)){k[Ha>>2]=0;b=Ha+4|0;k[b>>2]=0;d=ZT(88)|0;k[d>>2]=1;ha=d+4|0;k[Ha>>2]=ha;k[b>>2]=82;i[d+86>>0]=0;f=399522;ia=ha+82|0;do{i[ha>>0]=i[f>>0]|0;ha=ha+1|0;f=f+1|0}while((ha|0)<(ia|0));Y8(-215,Ha,399869,399024,324);k[b>>2]=0;k[Ha>>2]=0;Ba=k[d>>2]|0;k[d>>2]=Ba+-1;if((Ba|0)==1)ggb(k[d+-4>>2]|0)}f=k[Na>>2]|0;j=f+40|0;h=k[j>>2]|0;g=k[h+4>>2]|0;h=k[h>>2]|0;k[Ka>>2]=0;k[Ka+4>>2]=0;k[Ka+8>>2]=1124007936;b=Ka+16|0;d=Ka+48|0;ha=Ka+12|0;ia=ha+36|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[d>>2]=b;b=Ka+56|0;k[Ka+52>>2]=b;k[Ka+60>>2]=0;k[b>>2]=0;k[Ka+64>>2]=1124007936;b=Ka+72|0;d=Ka+104|0;ha=Ka+68|0;ia=ha+36|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[d>>2]=b;b=Ka+112|0;k[Ka+108>>2]=b;k[Ka+116>>2]=0;k[b>>2]=0;k[Ka+120>>2]=1124007936;b=Ka+128|0;d=Ka+160|0;ha=Ka+124|0;ia=ha+36|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[d>>2]=b;ha=Ka+168|0;k[Ka+164>>2]=ha;ia=ha+56|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[Ha>>2]=g;k[Ha+4>>2]=h;h=f;j1(Ka,48,Ha,t);g=k[Ka>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,Ka,Ma,-1);XN(Ka);g=k[j>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=1124007936;b=u+16|0;d=u+48|0;ha=u+12|0;ia=ha+36|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[d>>2]=b;b=u+56|0;k[u+52>>2]=b;k[u+60>>2]=0;k[b>>2]=0;k[u+64>>2]=1124007936;b=u+72|0;d=u+104|0;ha=u+68|0;ia=ha+36|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[d>>2]=b;b=u+112|0;k[u+108>>2]=b;k[u+116>>2]=0;k[b>>2]=0;k[u+120>>2]=1124007936;b=u+128|0;d=u+160|0;ha=u+124|0;ia=ha+36|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[d>>2]=b;ha=u+168|0;k[u+164>>2]=ha;ia=ha+56|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[Ha>>2]=f;k[Ha+4>>2]=g;j1(u,48,Ha,t);k[Ka>>2]=1124007936;Aa=Ka+4|0;b=Ka+8|0;ya=Ka+40|0;ha=Aa;ia=ha+36|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[ya>>2]=b;Ba=Ka+48|0;za=Ka+44|0;k[za>>2]=Ba;k[Ka+52>>2]=0;k[Ba>>2]=0;xa=k[u>>2]|0;dh[k[(k[xa>>2]|0)+12>>2]&255](xa,u,Ka,-1);XN(u);if((k[Ga>>2]|0)!=(h|0)){ja=Ha+4|0;ka=Ha+8|0;la=Ha+40|0;ma=Ha+48|0;na=Ha+44|0;oa=Ha+52|0;pa=Ca+4|0;qa=Ca+8|0;ra=Ca+40|0;sa=Ca+48|0;ta=Ca+44|0;ua=Ca+52|0;va=Da+8|0;wa=Da+12|0;xa=Da+4|0;j=a+12|0;l=Ea+8|0;c=Ea+12|0;p=Ea+4|0;q=Fa+4|0;e=q+4|0;t=Da+8|0;u=Da+12|0;a=Da+4|0;v=Ea+8|0;w=Ea+12|0;x=Ea+4|0;y=Fa+4|0;z=y+4|0;A=Oa+40|0;B=Oa+16|0;C=Oa+44|0;D=Oa+12|0;E=Fa+8|0;F=Fa+12|0;G=Fa+4|0;H=Ca+36|0;I=Ca+16|0;J=Ha+36|0;K=Ha+16|0;L=Da+4|0;M=Da+8|0;N=Da+12|0;O=Da+16|0;P=Da+48|0;Q=Da+56|0;R=Da+52|0;S=Da+60|0;T=Da+64|0;U=Da+68|0;V=Da+72|0;W=Da+104|0;X=Da+112|0;Y=Da+108|0;Z=Da+116|0;_=Da+120|0;$=Da+124|0;ba=Da+128|0;ca=Da+160|0;da=Da+168|0;ea=Da+164|0;fa=Ha+32|0;ga=Ca+32|0;g=0;b=h;do{k[Ha>>2]=1124007936;ha=ja;ia=ha+36|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[la>>2]=ka;k[na>>2]=ma;k[oa>>2]=0;k[ma>>2]=0;k[Ca>>2]=1124007936;ha=pa;ia=ha+36|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[ra>>2]=qa;k[ta>>2]=sa;k[ua>>2]=0;k[sa>>2]=0;k[va>>2]=0;k[wa>>2]=0;k[Da>>2]=16842752;k[xa>>2]=b+(g*56|0);k[l>>2]=0;k[c>>2]=0;k[Ea>>2]=16842752;k[p>>2]=j;ia=e;k[ia>>2]=0;k[ia+4>>2]=0;k[Fa>>2]=33619968;k[q>>2]=Ca;OX(Da,Ea,Fa);ia=(k[Na>>2]|0)+(g*56|0)|0;k[t>>2]=0;k[u>>2]=0;k[Da>>2]=16842752;k[a>>2]=ia;k[v>>2]=0;k[w>>2]=0;k[Ea>>2]=16842752;k[x>>2]=La;ia=z;k[ia>>2]=0;k[ia+4>>2]=0;k[Fa>>2]=33619968;k[y>>2]=Ha;OX(Da,Ea,Fa);do if((k[Oa>>2]&16384|0)==0?(Ia=k[A>>2]|0,(k[Ia>>2]|0)!=1):0){b=k[B>>2]|0;d=k[C>>2]|0;if((k[Ia+4>>2]|0)==1){b=b+(aa(k[d>>2]|0,g)|0)|0;break}else{ia=k[D>>2]|0;ha=(g|0)/(ia|0)|0;ia=g-(aa(ha,ia)|0)|0;b=b+(aa(k[d>>2]|0,ha)|0)+(ia<<2)|0;break}}else Ja=71;while(0);if((Ja|0)==71){Ja=0;b=(k[B>>2]|0)+(g<<2)|0}s=+o[b>>2];k[E>>2]=0;k[F>>2]=0;k[Fa>>2]=16842752;k[G>>2]=Ha;i1(Ea,Ca,Fa,1.0);k[Da>>2]=0;k[L>>2]=0;k[M>>2]=1124007936;ha=N;ia=ha+36|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[P>>2]=O;k[R>>2]=Q;k[S>>2]=0;k[Q>>2]=0;k[T>>2]=1124007936;ha=U;ia=ha+36|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[W>>2]=V;k[Y>>2]=X;k[Z>>2]=0;k[X>>2]=0;k[_>>2]=1124007936;ha=$;ia=ha+36|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));k[ca>>2]=ba;k[ea>>2]=da;ha=da;ia=ha+56|0;do{k[ha>>2]=0;ha=ha+4|0}while((ha|0)<(ia|0));ia=k[Ea>>2]|0;nh[k[(k[ia>>2]|0)+72>>2]&15](ia,Ea,s,Da);ia=k[Da>>2]|0;Ph[k[(k[ia>>2]|0)+24>>2]&511](ia,Da,Ma);XN(Da);XN(Ea);do if(!(k[Oa>>2]&16384)){d=k[A>>2]|0;if((k[d>>2]|0)==1){Ja=k[B>>2]|0;b=Ja;s=+o[Ja+(g<<2)>>2];Ja=82;break}f=k[B>>2]|0;b=k[C>>2]|0;if((k[d+4>>2]|0)==1)b=f+(aa(k[b>>2]|0,g)|0)|0;else{ia=k[D>>2]|0;ha=(g|0)/(ia|0)|0;ia=g-(aa(ha,ia)|0)|0;b=f+(aa(k[b>>2]|0,ha)|0)+(ia<<2)|0}s=+o[b>>2];b=k[C>>2]|0;if((k[d+4>>2]|0)==1){b=f+(aa(k[b>>2]|0,g)|0)|0;break}else{ia=k[D>>2]|0;ha=(g|0)/(ia|0)|0;ia=g-(aa(ha,ia)|0)|0;b=f+(aa(k[b>>2]|0,ha)|0)+(ia<<2)|0;break}}else{Ja=k[B>>2]|0;b=Ja;s=+o[Ja+(g<<2)>>2];Ja=82}while(0);if((Ja|0)==82){Ja=0;b=b+(g<<2)|0}c1(Da,s*+o[b>>2],Ca);b=k[Da>>2]|0;Ph[k[(k[b>>2]|0)+24>>2]&511](b,Da,Ka);XN(Da);b=k[H>>2]|0;if(b|0?(ha=b+12|0,ia=k[ha>>2]|0,k[ha>>2]=ia+-1,(ia|0)==1):0){d=k[H>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[ga>>2]|0;if(b|0)break;b=B1()|0;d=k[H>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[H>>2]=0}k[H>>2]=0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[pa>>2]|0)>0){d=k[ra>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[pa>>2]|0))}b=k[ta>>2]|0;if(!((b|0)==(sa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[J>>2]|0;if(b|0?(ha=b+12|0,ia=k[ha>>2]|0,k[ha>>2]=ia+-1,(ia|0)==1):0){d=k[J>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[fa>>2]|0;if(b|0)break;b=B1()|0;d=k[J>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[J>>2]=0}k[J>>2]=0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[ja>>2]|0)>0){d=k[la>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ja>>2]|0))}b=k[na>>2]|0;if(!((b|0)==(ma|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=g+1|0;b=k[Na>>2]|0}while(g>>>0<(((k[Ga>>2]|0)-b|0)/56|0)>>>0)}g1(Da,Ka);k[Ca+8>>2]=0;k[Ca+12>>2]=0;k[Ca>>2]=-1056571392;k[Ca+4>>2]=Da;i1(Ha,Ma,Ca,1.0);f=k[Ha>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,Ha,Ma,-1);XN(Ha);XN(Da);f=Ka+36|0;b=k[f>>2]|0;if(b|0?(Ia=b+12|0,Ja=k[Ia>>2]|0,k[Ia>>2]=Ja+-1,(Ja|0)==1):0){d=k[f>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Ka+32>>2]|0;if(!b){b=B1()|0;d=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[f>>2]=0}k[f>>2]=0;Ka=Ka+16|0;k[Ka>>2]=0;k[Ka+4>>2]=0;k[Ka+8>>2]=0;k[Ka+12>>2]=0;if((k[Aa>>2]|0)>0){d=k[ya>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Aa>>2]|0))}b=k[za>>2]|0;if(!((b|0)==(Ba|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=La+36|0;b=k[f>>2]|0;if(b|0?(Ja=b+12|0,Ka=k[Ja>>2]|0,k[Ja>>2]=Ka+-1,(Ka|0)==1):0){d=k[f>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[La+32>>2]|0;if(!b){b=B1()|0;d=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[f>>2]=0}k[f>>2]=0;f=La+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[f>>2]|0)>0){d=k[La+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[La+44>>2]|0;if(!((b|0)==(La+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Ma+36|0;b=k[f>>2]|0;if(b|0?(Ka=b+12|0,La=k[Ka>>2]|0,k[Ka>>2]=La+-1,(La|0)==1):0){d=k[f>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Ma+32>>2]|0;if(b|0)break;b=B1()|0;d=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[f>>2]=0}k[f>>2]=0;La=Ma+16|0;d=Ma+4|0;k[La>>2]=0;k[La+4>>2]=0;k[La+8>>2]=0;k[La+12>>2]=0;if((k[d>>2]|0)>0){f=k[Ma+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[Ma+44>>2]|0;if(!((b|0)==(Ma+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Oa+36|0;b=k[f>>2]|0;do if(b|0){La=b+12|0;Ma=k[La>>2]|0;k[La>>2]=Ma+-1;if((Ma|0)!=1)break;d=k[f>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Oa+32>>2]|0;if(b|0)break;b=B1()|0;d=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[f>>2]=0}while(0);k[f>>2]=0;Ma=Oa+16|0;k[Ma>>2]=0;k[Ma+4>>2]=0;k[Ma+8>>2]=0;k[Ma+12>>2]=0;if((k[m>>2]|0)>0){d=k[Oa+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[Oa+44>>2]|0;if((b|0)==(Oa+48|0)|(b|0)==0){zF(Na);r=Pa;return}ggb(k[b+-4>>2]|0);zF(Na);r=Pa;return}function H3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+80|0;h=p+56|0;n=p;i=k[(k[a>>2]|0)+32>>2]|0;k[n>>2]=1124007936;o=n+4|0;e=n+8|0;l=n+40|0;f=o;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[l>>2]=e;m=n+48|0;j=n+44|0;k[j>>2]=m;k[n+52>>2]=0;k[m>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=n;eh[i&255](a,b,c,d,h);g=n+36|0;e=k[g>>2]|0;if(e|0?(h=e+12|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[n+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;n=n+16|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[o>>2]|0)>0){f=k[l>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[o>>2]|0))}e=k[j>>2]|0;if((e|0)==(m|0)|(e|0)==0){r=p;return}ggb(k[e+-4>>2]|0);r=p;return}function I3a(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0;H=r;r=r+128|0;v=H+112|0;E=H+56|0;B=H;w=k[a+8>>2]|0;t=k[a+12>>2]|0;u=((k[a>>2]|0)>>>3&511)+1|0;c=+Z(+(-1.4142135623730951/c));k[E>>2]=1124007936;F=E+4|0;d=E+8|0;C=E+40|0;e=F;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[C>>2]=d;G=E+48|0;D=E+44|0;k[D>>2]=G;k[E+52>>2]=0;k[G>>2]=0;k[v>>2]=w;g=v+4|0;k[g>>2]=t;G1(E,2,v,21);A=v+4|0;d=A+4|0;k[d>>2]=0;k[d+4>>2]=0;k[v>>2]=33619968;k[A>>2]=E;mY(a,v);k[B>>2]=1124007936;A=B+4|0;d=B+8|0;y=B+40|0;e=A;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[y>>2]=d;z=B+48|0;x=B+44|0;k[x>>2]=z;k[B+52>>2]=0;k[z>>2]=0;k[v>>2]=w;k[g>>2]=t;G1(B,2,v,5);if((w|0)>0){i=k[b+16>>2]|0;s=B+16|0;j=k[s>>2]|0;if((t|0)>0){f=k[k[b+44>>2]>>2]|0;g=k[k[x>>2]>>2]|0;e=0;do{b=i+(aa(f,e)|0)|0;h=j+(aa(g,e)|0)|0;d=0;do{I=+R(+c,+(+o[b+(d<<2)>>2]));o[h+(d<<2)>>2]=I;d=d+1|0}while((d|0)!=(t|0));e=e+1|0}while((e|0)!=(w|0));d=E+16|0;i=k[d>>2]|0;j=k[s>>2]|0;if((t|0)>1){b=k[k[D>>2]>>2]|0;h=k[k[x>>2]>>2]|0;g=0;do{l=i+(aa(b,g)|0)|0;m=j+(aa(h,g)|0)|0;f=1;do{n=aa(f,u)|0;p=aa(f+-1|0,u)|0;q=m+(f<<2)|0;e=0;do{J=l+(e+n<<2)|0;I=+o[J>>2];o[J>>2]=I+(+o[l+(e+p<<2)>>2]-I)*+o[q>>2];e=e+1|0}while((e|0)!=(u|0));f=f+1|0}while((f|0)!=(t|0));g=g+1|0}while((g|0)!=(w|0));j=k[s>>2]|0}}else d=E+16|0;q=t+-2|0;i=k[d>>2]|0;if((q|0)>-1){g=k[k[D>>2]>>2]|0;b=k[k[x>>2]>>2]|0;e=0;do{l=i+(aa(g,e)|0)|0;m=j+(aa(b,e)|0)|0;d=q;while(1){n=aa(d,u)|0;h=d+1|0;p=aa(h,u)|0;h=m+(h<<2)|0;f=0;do{J=l+(f+n<<2)|0;I=+o[J>>2];o[J>>2]=I+(+o[l+(f+p<<2)>>2]-I)*+o[h>>2];f=f+1|0}while((f|0)!=(u|0));if((d|0)>0)d=d+-1|0;else break}e=e+1|0}while((e|0)!=(w|0))}}f=v+4|0;d=f+4|0;k[d>>2]=0;k[d+4>>2]=0;k[v>>2]=33619968;k[f>>2]=a;mY(E,v);f=B+36|0;d=k[f>>2]|0;if(d|0?(w=d+12|0,J=k[w>>2]|0,k[w>>2]=J+-1,(J|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[B+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;J=B+16|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[A>>2]|0)>0){e=k[y>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[A>>2]|0))}d=k[x>>2]|0;if(!((d|0)==(z|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=E+36|0;d=k[f>>2]|0;if(d|0?(B=d+12|0,J=k[B>>2]|0,k[B>>2]=J+-1,(J|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[E+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;J=E+16|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[F>>2]|0)>0){e=k[C>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[F>>2]|0))}d=k[D>>2]|0;if((d|0)==(G|0)|(d|0)==0){r=H;return}ggb(k[d+-4>>2]|0);r=H;return}function J3a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,i=0,j=0,l=0.0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0;wc=r;r=r+2080|0;jc=wc+1568|0;sc=wc+2016|0;oc=wc+1960|0;lc=wc+224|0;j=wc+1344|0;kc=wc;ac=wc+1120|0;bc=wc+1904|0;cc=wc+896|0;dc=wc+1848|0;ec=wc+672|0;fc=wc+1792|0;gc=wc+448|0;k[sc>>2]=1124007936;uc=sc+4|0;g=sc+8|0;rc=sc+40|0;m=uc;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[rc>>2]=g;vc=sc+48|0;tc=sc+44|0;k[tc>>2]=vc;k[sc+52>>2]=0;k[vc>>2]=0;k[jc>>2]=b;h=jc+4|0;k[h>>2]=c;G1(sc,2,jc,5);k[oc>>2]=1124007936;pc=oc+4|0;g=oc+8|0;mc=oc+40|0;m=pc;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[mc>>2]=g;qc=oc+48|0;nc=oc+44|0;k[nc>>2]=qc;k[oc+52>>2]=0;k[qc>>2]=0;k[jc>>2]=b;k[h>>2]=c;G1(oc,2,jc,5);l=f;p[lc>>3]=l;ic=lc+8|0;k[ic>>2]=0;k[ic+4>>2]=0;k[ic+8>>2]=0;k[ic+12>>2]=0;k[ic+16>>2]=0;k[ic+20>>2]=0;Y0(jc,d,lc);ic=k[jc>>2]|0;dh[k[(k[ic>>2]|0)+12>>2]&255](ic,jc,sc,-1);XN(jc);p[lc>>3]=l;ic=lc+8|0;k[ic>>2]=0;k[ic+4>>2]=0;k[ic+8>>2]=0;k[ic+12>>2]=0;k[ic+16>>2]=0;k[ic+20>>2]=0;U0(jc,d,lc);ic=k[jc>>2]|0;dh[k[(k[ic>>2]|0)+12>>2]&255](ic,jc,oc,-1);XN(jc);ic=a+336|0;k[lc>>2]=0;k[lc+4>>2]=0;k[lc+8>>2]=1124007936;g=lc+16|0;h=lc+48|0;m=lc+12|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[h>>2]=g;g=lc+56|0;k[lc+52>>2]=g;k[lc+60>>2]=0;k[g>>2]=0;k[lc+64>>2]=1124007936;g=lc+72|0;h=lc+104|0;m=lc+68|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[h>>2]=g;g=lc+112|0;k[lc+108>>2]=g;k[lc+116>>2]=0;k[g>>2]=0;k[lc+120>>2]=1124007936;g=lc+128|0;h=lc+160|0;m=lc+124|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[h>>2]=g;m=lc+168|0;k[lc+164>>2]=m;n=m+56|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[jc>>2]=c;k[jc+4>>2]=b;j1(lc,48,jc,5);$b=k[lc>>2]|0;dh[k[(k[$b>>2]|0)+12>>2]&255]($b,lc,ic,-1);XN(lc);$b=a+392|0;k[lc>>2]=0;k[lc+4>>2]=0;k[lc+8>>2]=1124007936;g=lc+16|0;h=lc+48|0;m=lc+12|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[h>>2]=g;g=lc+56|0;k[lc+52>>2]=g;k[lc+60>>2]=0;k[g>>2]=0;k[lc+64>>2]=1124007936;g=lc+72|0;h=lc+104|0;m=lc+68|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[h>>2]=g;g=lc+112|0;k[lc+108>>2]=g;k[lc+116>>2]=0;k[g>>2]=0;k[lc+120>>2]=1124007936;g=lc+128|0;h=lc+160|0;m=lc+124|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[h>>2]=g;m=lc+168|0;k[lc+164>>2]=m;n=m+56|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[jc>>2]=c;k[jc+4>>2]=b;j1(lc,48,jc,5);i=k[lc>>2]|0;dh[k[(k[i>>2]|0)+12>>2]&255](i,lc,$b,-1);XN(lc);i=c+1|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=1124007936;h=j+16|0;g=j+48|0;m=j+12|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[g>>2]=h;g=j+56|0;k[j+52>>2]=g;k[j+60>>2]=0;k[g>>2]=0;k[j+64>>2]=1124007936;g=j+72|0;h=j+104|0;m=j+68|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[h>>2]=g;g=j+112|0;k[j+108>>2]=g;k[j+116>>2]=0;k[g>>2]=0;k[j+120>>2]=1124007936;g=j+128|0;h=j+160|0;m=j+124|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[h>>2]=g;m=j+168|0;k[j+164>>2]=m;n=m+56|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[jc>>2]=i;k[jc+4>>2]=1;j1(j,48,jc,5);k[lc>>2]=1124007936;Zb=lc+4|0;g=lc+8|0;Xb=lc+40|0;m=Zb;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[Xb>>2]=g;_b=lc+48|0;Yb=lc+44|0;k[Yb>>2]=_b;k[lc+52>>2]=0;k[_b>>2]=0;Wb=k[j>>2]|0;dh[k[(k[Wb>>2]|0)+12>>2]&255](Wb,j,lc,-1);XN(j);if((b|0)>0){lb=(c|0)>0;mb=lc+16|0;nb=kc+4|0;ob=kc+8|0;pb=kc+40|0;qb=kc+48|0;rb=kc+44|0;sb=kc+52|0;tb=bc+4|0;ub=bc+8|0;vb=bc+40|0;wb=bc+48|0;xb=bc+44|0;yb=bc+52|0;zb=dc+4|0;Ab=dc+8|0;Bb=dc+40|0;Cb=dc+48|0;Db=dc+44|0;Eb=dc+52|0;Fb=fc+4|0;Gb=fc+8|0;Hb=fc+40|0;Ib=fc+48|0;Jb=fc+44|0;Kb=fc+52|0;Lb=(c|0)>1;Mb=fc+36|0;Nb=fc+16|0;Ob=dc+36|0;Pb=dc+16|0;Qb=bc+36|0;Rb=bc+16|0;Sb=kc+36|0;Tb=kc+16|0;Ub=a+352|0;Vb=a+380|0;Wb=a+408|0;hb=a+436|0;ib=sc+16|0;jb=oc+16|0;kb=d+16|0;u=d+44|0;v=ac+4|0;w=ac+8|0;x=ac+12|0;y=ac+16|0;z=ac+48|0;A=ac+56|0;B=ac+52|0;C=ac+60|0;E=ac+64|0;F=ac+68|0;G=ac+72|0;H=ac+104|0;I=ac+112|0;J=ac+108|0;K=ac+116|0;L=ac+120|0;M=ac+124|0;N=ac+128|0;O=ac+160|0;P=ac+168|0;Q=ac+164|0;R=jc+4|0;S=cc+4|0;T=cc+8|0;U=cc+12|0;V=cc+16|0;W=cc+48|0;X=cc+56|0;Y=cc+52|0;Z=cc+60|0;_=cc+64|0;$=cc+68|0;ba=cc+72|0;ca=cc+104|0;da=cc+112|0;ea=cc+108|0;fa=cc+116|0;ga=cc+120|0;ha=cc+124|0;ia=cc+128|0;ja=cc+160|0;ka=cc+168|0;la=cc+164|0;ma=jc+4|0;na=ec+4|0;oa=ec+8|0;pa=ec+12|0;qa=ec+16|0;ra=ec+48|0;sa=ec+56|0;ta=ec+52|0;ua=ec+60|0;va=ec+64|0;wa=ec+68|0;xa=ec+72|0;ya=ec+104|0;za=ec+112|0;Aa=ec+108|0;Ba=ec+116|0;Ca=ec+120|0;Da=ec+124|0;Ea=ec+128|0;Fa=ec+160|0;Ga=ec+168|0;Ha=ec+164|0;Ia=jc+4|0;Ja=gc+4|0;Ka=gc+8|0;La=gc+12|0;Ma=gc+16|0;Na=gc+48|0;Oa=gc+56|0;Pa=gc+52|0;Qa=gc+60|0;Ra=gc+64|0;Sa=gc+68|0;Ta=gc+72|0;Ua=gc+104|0;Va=gc+112|0;Wa=gc+108|0;Xa=gc+116|0;Ya=gc+120|0;Za=gc+124|0;_a=gc+128|0;$a=gc+160|0;ab=gc+168|0;bb=gc+164|0;cb=jc+4|0;db=kc+32|0;eb=bc+32|0;fb=dc+32|0;gb=fc+32|0;t=0;do{if(lb){i=(k[kb>>2]|0)+(aa(k[k[u>>2]>>2]|0,t)|0)|0;g=k[mb>>2]|0;h=0;do{k[g+(h<<2)>>2]=k[i+(h<<2)>>2];h=h+1|0}while((h|0)!=(c|0))}else g=k[mb>>2]|0;o[g+(c<<2)>>2]=D;k[ac>>2]=0;k[v>>2]=0;k[w>>2]=1124007936;m=x;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[z>>2]=y;k[B>>2]=A;k[C>>2]=0;k[A>>2]=0;k[E>>2]=1124007936;m=F;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[H>>2]=G;k[J>>2]=I;k[K>>2]=0;k[I>>2]=0;k[L>>2]=1124007936;m=M;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[O>>2]=N;k[Q>>2]=P;m=P;n=m+56|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[jc>>2]=c;k[R>>2]=1;j1(ac,48,jc,5);k[kc>>2]=1124007936;m=nb;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[pb>>2]=ob;k[rb>>2]=qb;k[sb>>2]=0;k[qb>>2]=0;m=k[ac>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,ac,kc,-1);XN(ac);k[cc>>2]=0;k[S>>2]=0;k[T>>2]=1124007936;m=U;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[W>>2]=V;k[Y>>2]=X;k[Z>>2]=0;k[X>>2]=0;k[_>>2]=1124007936;m=$;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[ca>>2]=ba;k[ea>>2]=da;k[fa>>2]=0;k[da>>2]=0;k[ga>>2]=1124007936;m=ha;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[ja>>2]=ia;k[la>>2]=ka;m=ka;n=m+56|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[jc>>2]=c;k[ma>>2]=1;j1(cc,48,jc,5);k[bc>>2]=1124007936;m=tb;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[vb>>2]=ub;k[xb>>2]=wb;k[yb>>2]=0;k[wb>>2]=0;s=k[cc>>2]|0;dh[k[(k[s>>2]|0)+12>>2]&255](s,cc,bc,-1);XN(cc);if(lb){h=(k[ib>>2]|0)+(aa(k[k[tc>>2]>>2]|0,t)|0)|0;i=k[Tb>>2]|0;j=(k[jb>>2]|0)+(aa(k[k[nc>>2]>>2]|0,t)|0)|0;a=k[Rb>>2]|0;g=0;do{k[i+(g<<2)>>2]=k[h+(g<<2)>>2];k[a+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)!=(c|0))}k[ec>>2]=0;k[na>>2]=0;k[oa>>2]=1124007936;m=pa;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[ra>>2]=qa;k[ta>>2]=sa;k[ua>>2]=0;k[sa>>2]=0;k[va>>2]=1124007936;m=wa;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[ya>>2]=xa;k[Aa>>2]=za;k[Ba>>2]=0;k[za>>2]=0;k[Ca>>2]=1124007936;m=Da;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[Fa>>2]=Ea;k[Ha>>2]=Ga;m=Ga;n=m+56|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[jc>>2]=c;k[Ia>>2]=1;j1(ec,48,jc,5);k[dc>>2]=1124007936;m=zb;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[Bb>>2]=Ab;k[Db>>2]=Cb;k[Eb>>2]=0;k[Cb>>2]=0;m=k[ec>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,ec,dc,-1);XN(ec);k[gc>>2]=0;k[Ja>>2]=0;k[Ka>>2]=1124007936;m=La;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[Na>>2]=Ma;k[Pa>>2]=Oa;k[Qa>>2]=0;k[Oa>>2]=0;k[Ra>>2]=1124007936;m=Sa;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[Ua>>2]=Ta;k[Wa>>2]=Va;k[Xa>>2]=0;k[Va>>2]=0;k[Ya>>2]=1124007936;m=Za;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[$a>>2]=_a;k[bb>>2]=ab;m=ab;n=m+56|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[jc>>2]=c;k[cb>>2]=1;j1(gc,48,jc,5);k[fc>>2]=1124007936;m=Fb;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[Hb>>2]=Gb;k[Jb>>2]=Ib;k[Kb>>2]=0;k[Ib>>2]=0;s=k[gc>>2]|0;dh[k[(k[s>>2]|0)+12>>2]&255](s,gc,fc,-1);XN(gc);a:do if(lb){h=k[mb>>2]|0;f=+o[k[Tb>>2]>>2];g=0;do{if(+o[h+(g<<2)>>2]>f){hc=14;break}g=g+1|0}while((g|0)<(c|0));if((hc|0)==14){hc=0;o[k[Pb>>2]>>2]=+(g|0)}f=+o[k[Rb>>2]>>2];g=0;while(1){if(+o[h+(g<<2)>>2]>f)break;g=g+1|0;if((g|0)>=(c|0))break a}o[k[Nb>>2]>>2]=+(g|0)}while(0);if(Lb){d=k[Pb>>2]|0;m=k[Nb>>2]|0;n=k[mb>>2]|0;q=k[Rb>>2]|0;s=k[Tb>>2]|0;a=1;g=0;do{j=a+-1|0;l=+o[d+(j<<2)>>2];h=~~l;b:do if((h|0)<=(c|0)){f=+o[s+(a<<2)>>2];i=0;while(1){if(+o[n+(h<<2)>>2]>f){g=i;break b}if((h|0)<(c|0)){h=h+1|0;i=i+1|0}else break}}while(0);o[d+(a<<2)>>2]=+(g|0)+l;l=+o[m+(j<<2)>>2];h=~~l;c:do if((h|0)<=(c|0)){f=+o[q+(a<<2)>>2];i=0;while(1){if(+o[n+(h<<2)>>2]>f){g=i;break c}if((h|0)<(c|0)){h=h+1|0;i=i+1|0}else break}}while(0);o[m+(a<<2)>>2]=+(g|0)+l;a=a+1|0}while((a|0)!=(c|0))}if(lb){h=k[Pb>>2]|0;i=(k[Ub>>2]|0)+(aa(k[k[Vb>>2]>>2]|0,t)|0)|0;j=k[Nb>>2]|0;a=(k[Wb>>2]|0)+(aa(k[k[hb>>2]>>2]|0,t)|0)|0;g=0;do{o[i+(g<<2)>>2]=+o[h+(g<<2)>>2]+1.0;o[a+(g<<2)>>2]=+o[j+(g<<2)>>2]+1.0;g=g+1|0}while((g|0)!=(c|0))}g=k[Mb>>2]|0;if(g|0?(q=g+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){h=k[Mb>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[gb>>2]|0;if(!g){g=B1()|0;h=k[Mb>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[Mb>>2]=0}k[Mb>>2]=0;k[Nb>>2]=0;k[Nb+4>>2]=0;k[Nb+8>>2]=0;k[Nb+12>>2]=0;if((k[Fb>>2]|0)>0){h=k[Hb>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[Fb>>2]|0))}g=k[Jb>>2]|0;if(!((g|0)==(Ib|0)|(g|0)==0))ggb(k[g+-4>>2]|0);g=k[Ob>>2]|0;if(g|0?(q=g+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){h=k[Ob>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[fb>>2]|0;if(!g){g=B1()|0;h=k[Ob>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[Ob>>2]=0}k[Ob>>2]=0;k[Pb>>2]=0;k[Pb+4>>2]=0;k[Pb+8>>2]=0;k[Pb+12>>2]=0;if((k[zb>>2]|0)>0){h=k[Bb>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[zb>>2]|0))}g=k[Db>>2]|0;if(!((g|0)==(Cb|0)|(g|0)==0))ggb(k[g+-4>>2]|0);g=k[Qb>>2]|0;if(g|0?(q=g+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){h=k[Qb>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[eb>>2]|0;if(g|0)break;g=B1()|0;h=k[Qb>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[Qb>>2]=0}k[Qb>>2]=0;k[Rb>>2]=0;k[Rb+4>>2]=0;k[Rb+8>>2]=0;k[Rb+12>>2]=0;if((k[tb>>2]|0)>0){h=k[vb>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[tb>>2]|0))}g=k[xb>>2]|0;if(!((g|0)==(wb|0)|(g|0)==0))ggb(k[g+-4>>2]|0);g=k[Sb>>2]|0;if(g|0?(q=g+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){h=k[Sb>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[db>>2]|0;if(g|0)break;g=B1()|0;h=k[Sb>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[Sb>>2]=0}k[Sb>>2]=0;k[Tb>>2]=0;k[Tb+4>>2]=0;k[Tb+8>>2]=0;k[Tb+12>>2]=0;if((k[nb>>2]|0)>0){h=k[pb>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[nb>>2]|0))}g=k[rb>>2]|0;if(!((g|0)==(qb|0)|(g|0)==0))ggb(k[g+-4>>2]|0);t=t+1|0}while((t|0)<(b|0))}k[kc>>2]=0;k[kc+4>>2]=0;k[kc+8>>2]=1124007936;g=kc+16|0;h=kc+48|0;m=kc+12|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[h>>2]=g;g=kc+56|0;k[kc+52>>2]=g;k[kc+60>>2]=0;k[g>>2]=0;k[kc+64>>2]=1124007936;g=kc+72|0;h=kc+104|0;m=kc+68|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[h>>2]=g;g=kc+112|0;k[kc+108>>2]=g;k[kc+116>>2]=0;k[g>>2]=0;k[kc+120>>2]=1124007936;g=kc+128|0;h=kc+160|0;m=kc+124|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[h>>2]=g;m=kc+168|0;k[kc+164>>2]=m;n=m+56|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[jc>>2]=0;k[jc+4>>2]=0;k[jc+8>>2]=0;k[jc+12>>2]=0;k[jc+16>>2]=0;k[jc+20>>2]=0;k[jc+24>>2]=0;k[jc+28>>2]=0;G0(kc,$b,ic,1.0,-1.0,jc);i=k[kc>>2]|0;dh[k[(k[i>>2]|0)+12>>2]&255](i,kc,e,-1);XN(kc);i=lc+36|0;g=k[i>>2]|0;if(g|0?(jc=g+12|0,kc=k[jc>>2]|0,k[jc>>2]=kc+-1,(kc|0)==1):0){h=k[i>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[lc+32>>2]|0;if(!g){g=B1()|0;h=k[i>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[i>>2]=0}k[i>>2]=0;lc=lc+16|0;k[lc>>2]=0;k[lc+4>>2]=0;k[lc+8>>2]=0;k[lc+12>>2]=0;if((k[Zb>>2]|0)>0){h=k[Xb>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[Zb>>2]|0))}g=k[Yb>>2]|0;if(!((g|0)==(_b|0)|(g|0)==0))ggb(k[g+-4>>2]|0);i=oc+36|0;g=k[i>>2]|0;if(g|0?(kc=g+12|0,lc=k[kc>>2]|0,k[kc>>2]=lc+-1,(lc|0)==1):0){h=k[i>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[oc+32>>2]|0;if(!g){g=B1()|0;h=k[i>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[i>>2]=0}k[i>>2]=0;oc=oc+16|0;k[oc>>2]=0;k[oc+4>>2]=0;k[oc+8>>2]=0;k[oc+12>>2]=0;if((k[pc>>2]|0)>0){h=k[mc>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[pc>>2]|0))}g=k[nc>>2]|0;if(!((g|0)==(qc|0)|(g|0)==0))ggb(k[g+-4>>2]|0);i=sc+36|0;g=k[i>>2]|0;if(g|0?(pc=g+12|0,qc=k[pc>>2]|0,k[pc>>2]=qc+-1,(qc|0)==1):0){h=k[i>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[sc+32>>2]|0;if(!g){g=B1()|0;h=k[i>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[i>>2]=0}k[i>>2]=0;sc=sc+16|0;k[sc>>2]=0;k[sc+4>>2]=0;k[sc+8>>2]=0;k[sc+12>>2]=0;if((k[uc>>2]|0)>0){h=k[rc>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[uc>>2]|0))}g=k[tc>>2]|0;if((g|0)==(vc|0)|(g|0)==0){r=wc;return}ggb(k[g+-4>>2]|0);r=wc;return}function K3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0;cd=r;r=r+2352|0;Qc=cd+1832|0;bd=cd+2288|0;f=cd+1608|0;Yc=cd+2232|0;u=cd+1384|0;Xc=cd+2176|0;v=cd+1160|0;Wc=cd+2120|0;x=cd+936|0;Rc=cd+2064|0;y=cd+712|0;xc=cd+2008|0;yc=cd+488|0;zc=cd+1952|0;Ac=cd+1896|0;Bc=cd+264|0;Cc=cd+40|0;Dc=cd+8|0;Ec=cd+1880|0;Fc=cd;Gc=cd+1864|0;Hc=k[b+8>>2]|0;Ic=k[b+12>>2]|0;Jc=(k[b>>2]|0)>>>3&511;Kc=Jc+1|0;J3a(a,Hc,Ic,c,d,e);z=Ic+1|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=1124007936;c=f+16|0;d=f+48|0;g=f+12|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=f+56|0;k[f+52>>2]=c;k[f+60>>2]=0;k[c>>2]=0;k[f+64>>2]=1124007936;c=f+72|0;d=f+104|0;g=f+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=f+112|0;k[f+108>>2]=c;k[f+116>>2]=0;k[c>>2]=0;k[f+120>>2]=1124007936;c=f+128|0;d=f+160|0;g=f+124|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;g=f+168|0;k[f+164>>2]=g;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Qc>>2]=z;k[Qc+4>>2]=Hc;j1(f,48,Qc,21);k[bd>>2]=1124007936;$c=bd+4|0;c=bd+8|0;Zc=bd+40|0;g=$c;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Zc>>2]=c;ad=bd+48|0;_c=bd+44|0;k[_c>>2]=ad;k[bd+52>>2]=0;k[ad>>2]=0;uc=k[f>>2]|0;dh[k[(k[uc>>2]|0)+12>>2]&255](uc,f,bd,-1);XN(f);uc=(Hc|0)>0;a:do if(uc){l=k[b+16>>2]|0;m=k[k[b+44>>2]>>2]|0;n=k[bd+16>>2]|0;q=k[k[_c>>2]>>2]|0;s=Jc+2|0;t=Jc+3|0;if((Ic|0)<2){c=0;while(1){Uc=l+(aa(m,c)|0)|0;Vc=n+(aa(q,c)|0)|0;k[Vc+(Kc<<2)>>2]=k[Uc>>2];k[Vc+(s<<2)>>2]=k[Uc+4>>2];k[Vc+(t<<2)>>2]=k[Uc+8>>2];c=c+1|0;if((c|0)==(Hc|0))break a}}else c=0;do{g=l+(aa(m,c)|0)|0;h=n+(aa(q,c)|0)|0;k[h+(Kc<<2)>>2]=k[g>>2];k[h+(s<<2)>>2]=k[g+4>>2];k[h+(t<<2)>>2]=k[g+8>>2];f=2;do{i=aa(f+-1|0,Kc)|0;j=aa(f,Kc)|0;d=0;do{Vc=d+i|0;o[h+(d+j<<2)>>2]=+o[g+(Vc<<2)>>2]+ +o[h+(Vc<<2)>>2];d=d+1|0}while((d|0)!=(Kc|0));f=f+1|0}while((f|0)!=(z|0));c=c+1|0}while((c|0)!=(Hc|0))}while(0);k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=1124007936;c=u+16|0;d=u+48|0;g=u+12|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=u+56|0;k[u+52>>2]=c;k[u+60>>2]=0;k[c>>2]=0;k[u+64>>2]=1124007936;c=u+72|0;d=u+104|0;g=u+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=u+112|0;k[u+108>>2]=c;k[u+116>>2]=0;k[c>>2]=0;k[u+120>>2]=1124007936;c=u+128|0;d=u+160|0;g=u+124|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;g=u+168|0;k[u+164>>2]=g;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Qc>>2]=Ic;k[Qc+4>>2]=Hc;j1(u,48,Qc,5);k[Yc>>2]=1124007936;Uc=Yc+4|0;c=Yc+8|0;Sc=Yc+40|0;g=Uc;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Sc>>2]=c;Vc=Yc+48|0;Tc=Yc+44|0;k[Tc>>2]=Vc;k[Yc+52>>2]=0;k[Vc>>2]=0;c=k[u>>2]|0;dh[k[(k[c>>2]|0)+12>>2]&255](c,u,Yc,-1);XN(u);k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=1124007936;c=v+16|0;d=v+48|0;g=v+12|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=v+56|0;k[v+52>>2]=c;k[v+60>>2]=0;k[c>>2]=0;k[v+64>>2]=1124007936;c=v+72|0;d=v+104|0;g=v+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=v+112|0;k[v+108>>2]=c;k[v+116>>2]=0;k[c>>2]=0;k[v+120>>2]=1124007936;c=v+128|0;d=v+160|0;g=v+124|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;g=v+168|0;k[v+164>>2]=g;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Qc>>2]=Ic;k[Qc+4>>2]=Hc;j1(v,48,Qc,21);k[Xc>>2]=1124007936;vc=Xc+4|0;c=Xc+8|0;sc=Xc+40|0;g=vc;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[sc>>2]=c;wc=Xc+48|0;tc=Xc+44|0;k[tc>>2]=wc;k[Xc+52>>2]=0;k[wc>>2]=0;rc=k[v>>2]|0;dh[k[(k[rc>>2]|0)+12>>2]&255](rc,v,Xc,-1);XN(v);if(uc?(w=k[Yc+16>>2]|0,(Ic|0)>0):0){f=k[k[Tc>>2]>>2]|0;d=0;do{e=+(d|0)+1.0;g=w+(aa(f,d)|0)|0;c=0;do{o[g+(c<<2)>>2]=e;c=c+1|0}while((c|0)!=(Ic|0));d=d+1|0}while((d|0)!=(Hc|0))}k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=1124007936;c=x+16|0;d=x+48|0;g=x+12|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=x+56|0;k[x+52>>2]=c;k[x+60>>2]=0;k[c>>2]=0;k[x+64>>2]=1124007936;c=x+72|0;d=x+104|0;g=x+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=x+112|0;k[x+108>>2]=c;k[x+116>>2]=0;k[c>>2]=0;k[x+120>>2]=1124007936;c=x+128|0;d=x+160|0;g=x+124|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;g=x+168|0;k[x+164>>2]=g;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Qc>>2]=Ic;k[Qc+4>>2]=Hc;j1(x,48,Qc,5);k[Wc>>2]=1124007936;pc=Wc+4|0;c=Wc+8|0;nc=Wc+40|0;g=pc;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[nc>>2]=c;qc=Wc+48|0;oc=Wc+44|0;k[oc>>2]=qc;k[Wc+52>>2]=0;k[qc>>2]=0;c=k[x>>2]|0;dh[k[(k[c>>2]|0)+12>>2]&255](c,x,Wc,-1);XN(x);k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=1124007936;c=y+16|0;d=y+48|0;g=y+12|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=y+56|0;k[y+52>>2]=c;k[y+60>>2]=0;k[c>>2]=0;k[y+64>>2]=1124007936;c=y+72|0;d=y+104|0;g=y+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;c=y+112|0;k[y+108>>2]=c;k[y+116>>2]=0;k[c>>2]=0;k[y+120>>2]=1124007936;c=y+128|0;d=y+160|0;g=y+124|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=c;g=y+168|0;k[y+164>>2]=g;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Qc>>2]=Ic;k[Qc+4>>2]=Hc;j1(y,48,Qc,5);k[Rc>>2]=1124007936;jc=Rc+4|0;c=Rc+8|0;hc=Rc+40|0;g=jc;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[hc>>2]=c;kc=Rc+48|0;ic=Rc+44|0;k[ic>>2]=kc;k[Rc+52>>2]=0;k[kc>>2]=0;Eb=k[y>>2]|0;dh[k[(k[Eb>>2]|0)+12>>2]&255](Eb,y,Rc,-1);XN(y);Eb=xc+4|0;Fb=xc+8|0;Gb=xc+40|0;Hb=xc+48|0;Ib=xc+44|0;Jb=xc+52|0;Kb=zc+8|0;Lb=zc+12|0;Mb=zc+4|0;Nb=Ac+8|0;Ob=Ac+12|0;Pb=Ac+4|0;Qb=Cc+4|0;Rb=Qb+4|0;Sb=zc+4|0;Tb=zc+8|0;Ub=zc+40|0;Vb=zc+48|0;Wb=zc+44|0;Xb=zc+52|0;Yb=Ac+4|0;Zb=Ac+8|0;_b=Ac+40|0;$b=Ac+48|0;ac=Ac+44|0;bc=Ac+52|0;cc=Dc+8|0;dc=Bc+8|0;ec=Bc+12|0;fc=Bc+4|0;Sa=aa(z,Hc)|0;e=+(Sa|0);Ta=Ec+8|0;Ua=Ec+12|0;Va=Ec+4|0;Wa=Gc+4|0;Xa=Wa+4|0;Ya=a+336|0;Za=Dc+8|0;_a=Bc+8|0;$a=Bc+12|0;ab=Bc+4|0;bb=+(Hc|0);cb=Ec+8|0;db=Ec+12|0;eb=Ec+4|0;fb=Gc+4|0;gb=fb+4|0;hb=Dc+8|0;ib=Bc+8|0;jb=Bc+12|0;kb=Bc+4|0;lb=Ec+8|0;mb=Ec+12|0;nb=Ec+4|0;ob=Gc+4|0;pb=ob+4|0;qb=a+392|0;rb=Dc+8|0;sb=Bc+8|0;tb=Bc+12|0;ub=Bc+4|0;vb=Ec+8|0;wb=Ec+12|0;xb=Ec+4|0;yb=Gc+4|0;zb=yb+4|0;Ab=(Ic|0)>0;gc=Rc+16|0;lc=Wc+16|0;rc=bd+16|0;Bb=a+408|0;Cb=a+436|0;Db=a+352|0;y=a+380|0;mc=Xc+16|0;z=Ac+36|0;a=Ac+16|0;A=zc+36|0;B=zc+16|0;C=xc+36|0;D=xc+16|0;E=yc+4|0;F=yc+8|0;G=yc+12|0;H=yc+16|0;I=yc+48|0;J=yc+56|0;K=yc+52|0;L=yc+60|0;M=yc+64|0;N=yc+68|0;O=yc+72|0;P=yc+104|0;Q=yc+112|0;R=yc+108|0;S=yc+116|0;T=yc+120|0;U=yc+124|0;V=yc+128|0;W=yc+160|0;X=yc+168|0;Y=yc+164|0;Z=Qc+4|0;_=Cc+4|0;$=Cc+8|0;ba=Cc+12|0;ca=Cc+16|0;da=Cc+48|0;ea=Cc+56|0;fa=Cc+52|0;ga=Cc+60|0;ha=Cc+64|0;ia=Cc+68|0;ja=Cc+72|0;ka=Cc+104|0;la=Cc+112|0;ma=Cc+108|0;na=Cc+116|0;oa=Cc+120|0;pa=Cc+124|0;qa=Cc+128|0;ra=Cc+160|0;sa=Cc+168|0;ta=Cc+164|0;ua=Cc+4|0;va=Cc+8|0;wa=Cc+12|0;xa=Cc+16|0;ya=Cc+48|0;za=Cc+56|0;Aa=Cc+52|0;Ba=Cc+60|0;Ca=Cc+64|0;Da=Cc+68|0;Ea=Cc+72|0;Fa=Cc+104|0;Ga=Cc+112|0;Ha=Cc+108|0;Ia=Cc+116|0;Ja=Cc+120|0;Ka=Cc+124|0;La=Cc+128|0;Ma=Cc+160|0;Na=Cc+168|0;Oa=Cc+164|0;Pa=xc+32|0;Qa=zc+32|0;Ra=Ac+32|0;w=0;do{k[yc>>2]=0;k[E>>2]=0;k[F>>2]=1124007936;g=G;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[I>>2]=H;k[K>>2]=J;k[L>>2]=0;k[J>>2]=0;k[M>>2]=1124007936;g=N;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[P>>2]=O;k[R>>2]=Q;k[S>>2]=0;k[Q>>2]=0;k[T>>2]=1124007936;g=U;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[W>>2]=V;k[Y>>2]=X;g=X;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Qc>>2]=Ic;k[Z>>2]=Hc;j1(yc,49,Qc,5);k[xc>>2]=1124007936;g=Eb;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Gb>>2]=Fb;k[Ib>>2]=Hb;k[Jb>>2]=0;k[Hb>>2]=0;x=k[yc>>2]|0;dh[k[(k[x>>2]|0)+12>>2]&255](x,yc,xc,-1);XN(yc);k[Kb>>2]=0;k[Lb>>2]=0;k[zc>>2]=16842752;k[Mb>>2]=xc;x=w;w=w+1|0;p[Bc>>3]=+(w|0);k[Ac>>2]=-1056833530;k[Pb>>2]=Bc;k[Nb>>2]=1;k[Ob>>2]=1;g=Rb;k[g>>2]=0;k[g+4>>2]=0;k[Cc>>2]=33619968;k[Qb>>2]=xc;p[Qc>>3]=1.0;sU(zc,Ac,Cc,49332,-1,40032,1,Qc);k[zc>>2]=1124007936;g=Sb;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Ub>>2]=Tb;k[Wb>>2]=Vb;k[Xb>>2]=0;k[Vb>>2]=0;k[Ac>>2]=1124007936;g=Yb;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[_b>>2]=Zb;k[ac>>2]=$b;k[bc>>2]=0;k[$b>>2]=0;p[Dc>>3]=1.0;k[cc>>2]=0;k[cc+4>>2]=0;k[cc+8>>2]=0;k[cc+12>>2]=0;k[cc+16>>2]=0;k[cc+20>>2]=0;Y0(Cc,xc,Dc);k[dc>>2]=0;k[ec>>2]=0;k[Bc>>2]=-1056571392;k[fc>>2]=Cc;p[Fc>>3]=e;k[Ec>>2]=-1056833530;k[Va>>2]=Fc;k[Ta>>2]=1;k[Ua>>2]=1;g=Xa;k[g>>2]=0;k[g+4>>2]=0;k[Gc>>2]=33619968;k[Wa>>2]=zc;p[Qc>>3]=1.0;sU(Bc,Ec,Gc,49332,-1,40032,1,Qc);XN(Cc);p[Dc>>3]=1.0;k[Za>>2]=0;k[Za+4>>2]=0;k[Za+8>>2]=0;k[Za+12>>2]=0;k[Za+16>>2]=0;k[Za+20>>2]=0;Y0(Cc,Ya,Dc);k[_a>>2]=0;k[$a>>2]=0;k[Bc>>2]=-1056571392;k[ab>>2]=Cc;p[Fc>>3]=bb;k[Ec>>2]=-1056833530;k[eb>>2]=Fc;k[cb>>2]=1;k[db>>2]=1;g=gb;k[g>>2]=0;k[g+4>>2]=0;k[Gc>>2]=33619968;k[fb>>2]=Ac;p[Qc>>3]=1.0;sU(Bc,Ec,Gc,49332,-1,40032,1,Qc);XN(Cc);k[Cc>>2]=0;k[_>>2]=0;k[$>>2]=1124007936;g=ba;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[da>>2]=ca;k[fa>>2]=ea;k[ga>>2]=0;k[ea>>2]=0;k[ha>>2]=1124007936;g=ia;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[ka>>2]=ja;k[ma>>2]=la;k[na>>2]=0;k[la>>2]=0;k[oa>>2]=1124007936;g=pa;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[ra>>2]=qa;k[ta>>2]=sa;g=sa;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Qc>>2]=0;k[Qc+4>>2]=0;k[Qc+8>>2]=0;k[Qc+12>>2]=0;k[Qc+16>>2]=0;k[Qc+20>>2]=0;k[Qc+24>>2]=0;k[Qc+28>>2]=0;G0(Cc,zc,Ac,1.0,1.0,Qc);W0(Bc,Cc,Yc);g=k[Bc>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,Bc,Wc,-1);XN(Bc);XN(Cc);p[Dc>>3]=1.0;k[hb>>2]=0;k[hb+4>>2]=0;k[hb+8>>2]=0;k[hb+12>>2]=0;k[hb+16>>2]=0;k[hb+20>>2]=0;Y0(Cc,xc,Dc);k[ib>>2]=0;k[jb>>2]=0;k[Bc>>2]=-1056571392;k[kb>>2]=Cc;p[Fc>>3]=e;k[Ec>>2]=-1056833530;k[nb>>2]=Fc;k[lb>>2]=1;k[mb>>2]=1;g=pb;k[g>>2]=0;k[g+4>>2]=0;k[Gc>>2]=33619968;k[ob>>2]=zc;p[Qc>>3]=1.0;sU(Bc,Ec,Gc,49332,-1,40032,1,Qc);XN(Cc);p[Dc>>3]=1.0;k[rb>>2]=0;k[rb+4>>2]=0;k[rb+8>>2]=0;k[rb+12>>2]=0;k[rb+16>>2]=0;k[rb+20>>2]=0;Y0(Cc,qb,Dc);k[sb>>2]=0;k[tb>>2]=0;k[Bc>>2]=-1056571392;k[ub>>2]=Cc;p[Fc>>3]=bb;k[Ec>>2]=-1056833530;k[xb>>2]=Fc;k[vb>>2]=1;k[wb>>2]=1;g=zb;k[g>>2]=0;k[g+4>>2]=0;k[Gc>>2]=33619968;k[yb>>2]=Ac;p[Qc>>3]=1.0;sU(Bc,Ec,Gc,49332,-1,40032,1,Qc);XN(Cc);k[Cc>>2]=0;k[ua>>2]=0;k[va>>2]=1124007936;g=wa;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[ya>>2]=xa;k[Aa>>2]=za;k[Ba>>2]=0;k[za>>2]=0;k[Ca>>2]=1124007936;g=Da;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Fa>>2]=Ea;k[Ha>>2]=Ga;k[Ia>>2]=0;k[Ga>>2]=0;k[Ja>>2]=1124007936;g=Ka;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Ma>>2]=La;k[Oa>>2]=Na;g=Na;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Qc>>2]=0;k[Qc+4>>2]=0;k[Qc+8>>2]=0;k[Qc+12>>2]=0;k[Qc+16>>2]=0;k[Qc+20>>2]=0;k[Qc+24>>2]=0;k[Qc+28>>2]=0;G0(Cc,zc,Ac,1.0,1.0,Qc);W0(Bc,Cc,Yc);v=k[Bc>>2]|0;dh[k[(k[v>>2]|0)+12>>2]&255](v,Bc,Rc,-1);XN(Bc);XN(Cc);if(uc?(Lc=k[gc>>2]|0,Mc=k[lc>>2]|0,Nc=k[rc>>2]|0,Oc=2-x|0,Pc=k[mc>>2]|0,Ab):0){f=k[k[ic>>2]>>2]|0;g=k[k[oc>>2]>>2]|0;h=k[k[_c>>2]>>2]|0;i=k[Bb>>2]|0;j=k[k[Cb>>2]>>2]|0;l=k[Db>>2]|0;m=k[k[y>>2]>>2]|0;n=k[k[tc>>2]>>2]|0;d=0;do{q=Lc+(aa(f,d)|0)|0;s=Mc+(aa(g,d)|0)|0;t=i+(aa(j,d)|0)|0;u=l+(aa(m,d)|0)|0;v=Pc+(aa(n,d)|0)|0;c=0;do{ld=~~+o[q+(c<<2)>>2];kd=(ld|0)/(Sa|0)|0;ld=ld-(aa(Sa,kd)|0)|0;fd=(ld|0)/(Hc|0)|0;ld=ld-(aa(fd,Hc)|0)|0;id=(fd|0)==0;ld=id?Hc:ld;jd=(ld|0)==0;hd=~~+o[s+(c<<2)>>2];gd=(hd|0)/(Sa|0)|0;hd=hd-(aa(Sa,gd)|0)|0;ed=(hd|0)/(Hc|0)|0;hd=hd-(aa(ed,Hc)|0)|0;dd=(hd|0)==0;fd=Nc+(aa(h,(jd?Hc:ld)+-1|0)|0)+(2-kd+(id&1)+(aa((jd<<31>>31)+(id?Ic:fd)|0,Kc)|0)<<2)|0;ed=Nc+(aa((dd?Hc:hd)+-1|0,h)|0)+(2-gd+(aa((dd<<31>>31)+ed|0,Kc)|0)<<2)|0;dd=v+(Oc+(aa(c,Kc)|0)<<2)|0;o[dd>>2]=(+o[fd>>2]-+o[ed>>2])/(+o[t+(c<<2)>>2]-+o[u+(c<<2)>>2]);c=c+1|0}while((c|0)!=(Ic|0));d=d+1|0}while((d|0)!=(Hc|0))}c=k[z>>2]|0;if(c|0?(kd=c+12|0,ld=k[kd>>2]|0,k[kd>>2]=ld+-1,(ld|0)==1):0){d=k[z>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[Ra>>2]|0;if(!c){c=B1()|0;d=k[z>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[z>>2]=0}k[z>>2]=0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[Yb>>2]|0)>0){d=k[_b>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Yb>>2]|0))}c=k[ac>>2]|0;if(!((c|0)==($b|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[A>>2]|0;if(c|0?(kd=c+12|0,ld=k[kd>>2]|0,k[kd>>2]=ld+-1,(ld|0)==1):0){d=k[A>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[Qa>>2]|0;if(!c){c=B1()|0;d=k[A>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[A>>2]=0}k[A>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[Sb>>2]|0)>0){d=k[Ub>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Sb>>2]|0))}c=k[Wb>>2]|0;if(!((c|0)==(Vb|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[C>>2]|0;if(c|0?(kd=c+12|0,ld=k[kd>>2]|0,k[kd>>2]=ld+-1,(ld|0)==1):0){d=k[C>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[Pa>>2]|0;if(!c){c=B1()|0;d=k[C>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[C>>2]=0}k[C>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[Eb>>2]|0)>0){d=k[Gb>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Eb>>2]|0))}c=k[Ib>>2]|0;if(!((c|0)==(Hb|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}while((x|0)<(Jc|0));f=Qc+4|0;c=f+4|0;k[c>>2]=0;k[c+4>>2]=0;k[Qc>>2]=33619968;k[f>>2]=b;mY(Xc,Qc);f=Rc+36|0;c=k[f>>2]|0;if(c|0?(kd=c+12|0,ld=k[kd>>2]|0,k[kd>>2]=ld+-1,(ld|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[Rc+32>>2]|0;if(!c){c=B1()|0;d=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;k[gc>>2]=0;k[gc+4>>2]=0;k[gc+8>>2]=0;k[gc+12>>2]=0;if((k[jc>>2]|0)>0){d=k[hc>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[jc>>2]|0))}c=k[ic>>2]|0;if(!((c|0)==(kc|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=Wc+36|0;c=k[f>>2]|0;if(c|0?(kd=c+12|0,ld=k[kd>>2]|0,k[kd>>2]=ld+-1,(ld|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[Wc+32>>2]|0;if(!c){c=B1()|0;d=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;k[lc>>2]=0;k[lc+4>>2]=0;k[lc+8>>2]=0;k[lc+12>>2]=0;if((k[pc>>2]|0)>0){d=k[nc>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[pc>>2]|0))}c=k[oc>>2]|0;if(!((c|0)==(qc|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=Xc+36|0;c=k[f>>2]|0;if(c|0?(kd=c+12|0,ld=k[kd>>2]|0,k[kd>>2]=ld+-1,(ld|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[Xc+32>>2]|0;if(!c){c=B1()|0;d=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;k[mc>>2]=0;k[mc+4>>2]=0;k[mc+8>>2]=0;k[mc+12>>2]=0;if((k[vc>>2]|0)>0){d=k[sc>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[vc>>2]|0))}c=k[tc>>2]|0;if(!((c|0)==(wc|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=Yc+36|0;c=k[f>>2]|0;if(c|0?(kd=c+12|0,ld=k[kd>>2]|0,k[kd>>2]=ld+-1,(ld|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[Yc+32>>2]|0;if(!c){c=B1()|0;d=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;ld=Yc+16|0;k[ld>>2]=0;k[ld+4>>2]=0;k[ld+8>>2]=0;k[ld+12>>2]=0;if((k[Uc>>2]|0)>0){d=k[Sc>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Uc>>2]|0))}c=k[Tc>>2]|0;if(!((c|0)==(Vc|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=bd+36|0;c=k[f>>2]|0;if(c|0?(kd=c+12|0,ld=k[kd>>2]|0,k[kd>>2]=ld+-1,(ld|0)==1):0){d=k[f>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[bd+32>>2]|0;if(c|0)break;c=B1()|0;d=k[f>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[f>>2]=0}k[f>>2]=0;k[rc>>2]=0;k[rc+4>>2]=0;k[rc+8>>2]=0;k[rc+12>>2]=0;if((k[$c>>2]|0)>0){d=k[Zc>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[$c>>2]|0))}c=k[_c>>2]|0;if((c|0)==(ad|0)|(c|0)==0){r=cd;return}ggb(k[c+-4>>2]|0);r=cd;return}function L3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;oa=r;r=r+1616|0;N=oa+960|0;na=oa+1552|0;h=oa+736|0;ia=oa+1496|0;i=oa+512|0;ha=oa+1440|0;E=oa+288|0;ca=oa+1384|0;F=oa+64|0;ba=oa+1328|0;$=oa+1272|0;_=oa+1216|0;T=oa+8|0;K=oa+1200|0;L=oa;M=oa+1184|0;j=b+40|0;Z=k[j>>2]|0;Y=k[Z>>2]|0;Z=k[Z+4>>2]|0;I=((k[b>>2]|0)>>>3&511)+1|0;G=Z+-1|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=1124007936;f=h+16|0;g=h+48|0;l=h+12|0;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[g>>2]=f;f=h+56|0;k[h+52>>2]=f;k[h+60>>2]=0;k[f>>2]=0;k[h+64>>2]=1124007936;f=h+72|0;g=h+104|0;l=h+68|0;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[g>>2]=f;f=h+112|0;k[h+108>>2]=f;k[h+116>>2]=0;k[f>>2]=0;k[h+120>>2]=1124007936;f=h+128|0;g=h+160|0;l=h+124|0;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[g>>2]=f;l=h+168|0;k[h+164>>2]=l;t=l+56|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[N>>2]=G;k[N+4>>2]=Y;j1(h,48,N,21);k[na>>2]=1124007936;la=na+4|0;f=na+8|0;ja=na+40|0;l=la;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[ja>>2]=f;ma=na+48|0;ka=na+44|0;k[ka>>2]=ma;k[na+52>>2]=0;k[ma>>2]=0;H=k[h>>2]|0;dh[k[(k[H>>2]|0)+12>>2]&255](H,h,na,-1);XN(h);H=Y+-1|0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=1124007936;f=i+16|0;g=i+48|0;l=i+12|0;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[g>>2]=f;f=i+56|0;k[i+52>>2]=f;k[i+60>>2]=0;k[f>>2]=0;k[i+64>>2]=1124007936;f=i+72|0;g=i+104|0;l=i+68|0;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[g>>2]=f;f=i+112|0;k[i+108>>2]=f;k[i+116>>2]=0;k[f>>2]=0;k[i+120>>2]=1124007936;f=i+128|0;g=i+160|0;l=i+124|0;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[g>>2]=f;l=i+168|0;k[i+164>>2]=l;t=l+56|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[N>>2]=Z;k[N+4>>2]=H;j1(i,48,N,21);k[ia>>2]=1124007936;fa=ia+4|0;f=ia+8|0;da=ia+40|0;l=fa;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[da>>2]=f;ga=ia+48|0;ea=ia+44|0;k[ea>>2]=ga;k[ia+52>>2]=0;k[ga>>2]=0;A=k[i>>2]|0;dh[k[(k[A>>2]|0)+12>>2]&255](A,i,ia,-1);XN(i);A=((k[b>>2]|0)>>>3&511)+1|0;f=k[j>>2]|0;y=k[f>>2]|0;if((y|0)>0){z=k[f+4>>2]|0;l=b+16|0;m=k[l>>2]|0;n=k[na+16>>2]|0;if((z|0)>1){i=k[k[b+44>>2]>>2]|0;j=k[k[ka>>2]>>2]|0;q=z+-1|0;g=0;do{t=m+(aa(g,i)|0)|0;v=n+(aa(g,j)|0)|0;f=0;do{x=f;f=f+1|0;w=aa(f,A)|0;x=aa(x,A)|0;h=0;do{X=h+x|0;o[v+(X<<2)>>2]=+o[t+(h+w<<2)>>2]-+o[t+(X<<2)>>2];h=h+1|0}while((h|0)!=(A|0))}while((f|0)!=(q|0));g=g+1|0}while((g|0)!=(y|0))}if((y|0)>1?(B=y+-1|0,C=k[l>>2]|0,D=k[ia+16>>2]|0,(z|0)>0):0){i=k[k[b+44>>2]>>2]|0;j=k[k[ea>>2]>>2]|0;g=0;do{n=g;g=g+1|0;l=C+(aa(g,i)|0)|0;m=C+(aa(n,i)|0)|0;n=D+(aa(n,j)|0)|0;f=0;do{q=aa(f,A)|0;h=0;do{X=h+q|0;o[n+(X<<2)>>2]=+o[l+(X<<2)>>2]-+o[m+(X<<2)>>2];h=h+1|0}while((h|0)!=(A|0));f=f+1|0}while((f|0)!=(z|0))}while((g|0)!=(B|0))}}k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=1124007936;f=E+16|0;g=E+48|0;l=E+12|0;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[g>>2]=f;f=E+56|0;k[E+52>>2]=f;k[E+60>>2]=0;k[f>>2]=0;k[E+64>>2]=1124007936;f=E+72|0;g=E+104|0;l=E+68|0;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[g>>2]=f;f=E+112|0;k[E+108>>2]=f;k[E+116>>2]=0;k[f>>2]=0;k[E+120>>2]=1124007936;f=E+128|0;g=E+160|0;l=E+124|0;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[g>>2]=f;l=E+168|0;k[E+164>>2]=l;t=l+56|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[N>>2]=Z;k[N+4>>2]=Y;j1(E,48,N,5);k[ha>>2]=1124007936;W=ha+4|0;f=ha+8|0;U=ha+40|0;l=W;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[U>>2]=f;X=ha+48|0;V=ha+44|0;k[V>>2]=X;k[ha+52>>2]=0;k[X>>2]=0;f=k[E>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,E,ha,-1);XN(E);k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=1124007936;f=F+16|0;g=F+48|0;l=F+12|0;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[g>>2]=f;f=F+56|0;k[F+52>>2]=f;k[F+60>>2]=0;k[f>>2]=0;k[F+64>>2]=1124007936;f=F+72|0;g=F+104|0;l=F+68|0;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[g>>2]=f;f=F+112|0;k[F+108>>2]=f;k[F+116>>2]=0;k[f>>2]=0;k[F+120>>2]=1124007936;f=F+128|0;g=F+160|0;l=F+124|0;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[g>>2]=f;l=F+168|0;k[F+164>>2]=l;t=l+56|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[N>>2]=Z;k[N+4>>2]=Y;j1(F,48,N,5);k[ca>>2]=1124007936;R=ca+4|0;f=ca+8|0;O=ca+40|0;l=R;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[O>>2]=f;S=ca+48|0;Q=ca+44|0;k[Q>>2]=S;k[ca+52>>2]=0;k[S>>2]=0;J=k[F>>2]|0;dh[k[(k[J>>2]|0)+12>>2]&255](J,F,ca,-1);XN(F);J=(Y|0)>0;if(J){m=k[ha+16>>2]|0;n=k[na+16>>2]|0;if((Z|0)>1){j=k[k[V>>2]>>2]|0;l=k[k[ka>>2]>>2]|0;i=0;do{q=m+(aa(j,i)|0)|0;t=n+(aa(l,i)|0)|0;g=1;h=0;while(1){w=q+(g<<2)|0;v=aa(h,I)|0;f=0;s=+o[w>>2];do{s=s+ +P(+(+o[t+(f+v<<2)>>2]));o[w>>2]=s;f=f+1|0}while((f|0)!=(I|0));h=h+1|0;if((h|0)==(G|0))break;else g=g+1|0}i=i+1|0}while((i|0)!=(Y|0))}if((Y|0)>1){m=k[ca+16>>2]|0;n=k[ia+16>>2]|0;if((Z|0)>0){j=k[k[Q>>2]>>2]|0;l=k[k[ea>>2]>>2]|0;h=1;i=0;while(1){q=m+(aa(j,h)|0)|0;t=n+(aa(l,i)|0)|0;g=0;do{w=q+(g<<2)|0;v=aa(g,I)|0;f=0;s=+o[w>>2];do{s=s+ +P(+(+o[t+(f+v<<2)>>2]));o[w>>2]=s;f=f+1|0}while((f|0)!=(I|0));g=g+1|0}while((g|0)!=(Z|0));i=i+1|0;if((i|0)==(H|0)){E=1;break}else h=h+1|0}}else E=1}else E=0}else E=0;q=a+112|0;k[ba>>2]=1124007936;m=ba+4|0;f=ba+8|0;j=ba+40|0;l=m;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[j>>2]=f;l=ba+48|0;i=ba+44|0;k[i>>2]=l;k[ba+52>>2]=0;k[l>>2]=0;k[N>>2]=Y;v=N+4|0;k[v>>2]=Z;G1(ba,2,N,5);KG(q,ba)|0;h=ba+36|0;f=k[h>>2]|0;if(f|0?(H=f+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[ba+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;I=ba+16|0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[m>>2]|0)>0){g=k[j>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[m>>2]|0))}f=k[i>>2]|0;if(!((f|0)==(l|0)|(f|0)==0))ggb(k[f+-4>>2]|0);n=a+168|0;k[ba>>2]=1124007936;m=ba+4|0;f=ba+8|0;j=ba+40|0;l=m;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[j>>2]=f;l=ba+48|0;i=ba+44|0;k[i>>2]=l;k[ba+52>>2]=0;k[l>>2]=0;k[N>>2]=Y;k[v>>2]=Z;G1(ba,2,N,5);KG(n,ba)|0;h=ba+36|0;f=k[h>>2]|0;if(f|0?(H=f+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[ba+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;I=ba+16|0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[m>>2]|0)>0){g=k[j>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[m>>2]|0))}f=k[i>>2]|0;if(!((f|0)==(l|0)|(f|0)==0))ggb(k[f+-4>>2]|0);k[ba>>2]=1124007936;H=ba+4|0;f=ba+8|0;F=ba+40|0;l=H;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[F>>2]=f;I=ba+48|0;G=ba+44|0;k[G>>2]=I;k[ba+52>>2]=0;k[I>>2]=0;k[N>>2]=Y;k[v>>2]=Z;G1(ba,2,N,21);k[$>>2]=1124007936;C=$+4|0;f=$+8|0;A=$+40|0;l=C;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[A>>2]=f;D=$+48|0;B=$+44|0;k[B>>2]=D;k[$+52>>2]=0;k[D>>2]=0;k[_>>2]=1124007936;y=_+4|0;f=_+8|0;w=_+40|0;l=y;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[w>>2]=f;z=_+48|0;x=_+44|0;k[x>>2]=z;k[_+52>>2]=0;k[z>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;k[T>>2]=16842752;k[T+4>>2]=ha;e=d/e;p[L>>3]=e;k[K>>2]=-1056833530;k[K+4>>2]=L;k[K+8>>2]=1;k[K+12>>2]=1;m=M+4|0;f=m+4|0;k[f>>2]=0;k[f+4>>2]=0;k[M>>2]=33619968;k[m>>2]=$;p[N>>3]=1.0;sU(T,K,M,49332,-1,40032,1,N);k[T+8>>2]=0;k[T+12>>2]=0;k[T>>2]=16842752;k[T+4>>2]=ca;p[L>>3]=e;k[K>>2]=-1056833530;k[K+4>>2]=L;k[K+8>>2]=1;k[K+12>>2]=1;m=M+4|0;f=m+4|0;k[f>>2]=0;k[f+4>>2]=0;k[M>>2]=33619968;k[m>>2]=_;p[N>>3]=1.0;sU(T,K,M,49332,-1,40032,1,N);p[T>>3]=1.0;m=T+8|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[m+16>>2]=0;k[m+20>>2]=0;V0(N,T,$);m=k[N>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,N,q,-1);XN(N);p[T>>3]=1.0;m=T+8|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[m+16>>2]=0;k[m+20>>2]=0;V0(N,T,_);m=k[N>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,N,n,-1);XN(N);n=a+224|0;k[T>>2]=1124007936;m=T+4|0;f=T+8|0;j=T+40|0;l=m;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[j>>2]=f;l=T+48|0;i=T+44|0;k[i>>2]=l;k[T+52>>2]=0;k[l>>2]=0;k[N>>2]=Y;k[v>>2]=Z;G1(T,2,N,21);KG(n,T)|0;h=T+36|0;f=k[h>>2]|0;if(f|0?(L=f+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[T+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;M=T+16|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[m>>2]|0)>0){g=k[j>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[m>>2]|0))}f=k[i>>2]|0;if(!((f|0)==(l|0)|(f|0)==0))ggb(k[f+-4>>2]|0);m=N+4|0;f=m+4|0;k[f>>2]=0;k[f+4>>2]=0;k[N>>2]=33619968;k[m>>2]=n;mY(b,N);k[T>>2]=1124007936;m=T+4|0;f=T+8|0;j=T+40|0;l=m;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[j>>2]=f;l=T+48|0;i=T+44|0;k[i>>2]=l;k[T+52>>2]=0;k[l>>2]=0;k[N>>2]=Z;k[v>>2]=Y;G1(T,2,N,21);KG(a+280|0,T)|0;h=T+36|0;f=k[h>>2]|0;if(f|0?(M=f+12|0,b=k[M>>2]|0,k[M>>2]=b+-1,(b|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[T+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;b=T+16|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[m>>2]|0)>0){g=k[j>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[m>>2]|0))}f=k[i>>2]|0;if(!((f|0)==(l|0)|(f|0)==0))ggb(k[f+-4>>2]|0);a:do if((c|0)==2){k[T>>2]=1124007936;m=T+4|0;f=T+8|0;j=T+40|0;l=m;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[j>>2]=f;l=T+48|0;i=T+44|0;k[i>>2]=l;k[T+52>>2]=0;k[l>>2]=0;k[N>>2]=Y;k[v>>2]=Z;G1(T,2,N,5);KG(a,T)|0;h=T+36|0;f=k[h>>2]|0;if(f|0?(b=f+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[T+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;c=T+16|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[m>>2]|0)>0){g=k[j>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[m>>2]|0))}f=k[i>>2]|0;if(!((f|0)==(l|0)|(f|0)==0))ggb(k[f+-4>>2]|0);k[T>>2]=1124007936;m=T+4|0;f=T+8|0;j=T+40|0;l=m;t=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(t|0));k[j>>2]=f;l=T+48|0;i=T+44|0;k[i>>2]=l;k[T+52>>2]=0;k[l>>2]=0;k[N>>2]=Y;k[v>>2]=Z;G1(T,2,N,5);KG(a+56|0,T)|0;h=T+36|0;f=k[h>>2]|0;do if(f|0){c=f+12|0;N=k[c>>2]|0;k[c>>2]=N+-1;if((N|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[T+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;T=T+16|0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[m>>2]|0)>0){g=k[j>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[m>>2]|0))}f=k[i>>2]|0;if(!((f|0)==(l|0)|(f|0)==0))ggb(k[f+-4>>2]|0);b:do if(J){j=k[a+128>>2]|0;l=k[k[a+156>>2]>>2]|0;m=k[a+16>>2]|0;n=k[k[a+44>>2]>>2]|0;if((Z|0)>1)g=0;else{f=0;while(1){N=j+(aa(l,f)|0)|0;T=m+(aa(n,f)|0)|0;k[T>>2]=k[N>>2];f=f+1|0;if((f|0)==(Y|0))break b}}do{h=j+(aa(l,g)|0)|0;T=k[h>>2]|0;i=m+(aa(n,g)|0)|0;k[i>>2]=T;f=1;s=(k[u>>2]=T,+o[u>>2]);do{s=+o[h+(f<<2)>>2]+s;o[i+(f<<2)>>2]=s;f=f+1|0}while((f|0)!=(Z|0));g=g+1|0}while((g|0)!=(Y|0))}while(0);if((Z|0)<=0)break;j=k[a+184>>2]|0;l=k[a+72>>2]|0;if(!E){f=0;while(1){k[l+(f<<2)>>2]=k[j+(f<<2)>>2];f=f+1|0;if((f|0)==(Z|0))break a}}i=k[k[a+212>>2]>>2]|0;h=k[k[a+100>>2]>>2]|0;f=0;do{k[l+(f<<2)>>2]=k[j+(f<<2)>>2];g=1;do{N=j+(aa(i,g)|0)+(f<<2)|0;T=l+(aa(h,g+-1|0)|0)+(f<<2)|0;a=l+(aa(h,g)|0)+(f<<2)|0;o[a>>2]=+o[N>>2]+ +o[T>>2];g=g+1|0}while((g|0)!=(Y|0));f=f+1|0}while((f|0)!=(Z|0))}while(0);h=_+36|0;f=k[h>>2]|0;if(f|0?(Y=f+12|0,Z=k[Y>>2]|0,k[Y>>2]=Z+-1,(Z|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[_+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;_=_+16|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[y>>2]|0)>0){g=k[w>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[y>>2]|0))}f=k[x>>2]|0;if(!((f|0)==(z|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=$+36|0;f=k[h>>2]|0;do if(f|0){Z=f+12|0;_=k[Z>>2]|0;k[Z>>2]=_+-1;if((_|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[$+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;$=$+16|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[C>>2]|0)>0){g=k[A>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[C>>2]|0))}f=k[B>>2]|0;if(!((f|0)==(D|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=ba+36|0;f=k[h>>2]|0;do if(f|0){_=f+12|0;$=k[_>>2]|0;k[_>>2]=$+-1;if(($|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[ba+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;ba=ba+16|0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[H>>2]|0)>0){g=k[F>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[H>>2]|0))}f=k[G>>2]|0;if(!((f|0)==(I|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=ca+36|0;f=k[h>>2]|0;do if(f|0){$=f+12|0;ba=k[$>>2]|0;k[$>>2]=ba+-1;if((ba|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[ca+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;ca=ca+16|0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;if((k[R>>2]|0)>0){g=k[O>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[R>>2]|0))}f=k[Q>>2]|0;if(!((f|0)==(S|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=ha+36|0;f=k[h>>2]|0;do if(f|0){ba=f+12|0;ca=k[ba>>2]|0;k[ba>>2]=ca+-1;if((ca|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[ha+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;ha=ha+16|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[W>>2]|0)>0){g=k[U>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[W>>2]|0))}f=k[V>>2]|0;if(!((f|0)==(X|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=ia+36|0;f=k[h>>2]|0;do if(f|0){ca=f+12|0;ha=k[ca>>2]|0;k[ca>>2]=ha+-1;if((ha|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[ia+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;ia=ia+16|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[fa>>2]|0)>0){g=k[da>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[fa>>2]|0))}f=k[ea>>2]|0;if(!((f|0)==(ga|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=na+36|0;f=k[h>>2]|0;do if(f|0){ha=f+12|0;ia=k[ha>>2]|0;k[ha>>2]=ia+-1;if((ia|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[na+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;na=na+16|0;k[na>>2]=0;k[na+4>>2]=0;k[na+8>>2]=0;k[na+12>>2]=0;if((k[la>>2]|0)>0){g=k[ja>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[la>>2]|0))}f=k[ka>>2]|0;if((f|0)==(ma|0)|(f|0)==0){r=oa;return}ggb(k[f+-4>>2]|0);r=oa;return}function M3a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;sa=r;r=r+1008|0;qa=sa+672|0;h=sa+448|0;ra=sa;i=sa+224|0;ka=sa+952|0;ha=sa+896|0;l=k[b+40>>2]|0;j=k[l>>2]|0;l=k[l+4>>2]|0;L3a(a,b,f,d,e);switch(f|0){case 1:{g=a+168|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=1124007936;b=h+16|0;f=h+48|0;oa=h+12|0;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[f>>2]=b;b=h+56|0;k[h+52>>2]=b;k[h+60>>2]=0;k[b>>2]=0;k[h+64>>2]=1124007936;b=h+72|0;f=h+104|0;oa=h+68|0;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[f>>2]=b;b=h+112|0;k[h+108>>2]=b;k[h+116>>2]=0;k[b>>2]=0;k[h+120>>2]=1124007936;b=h+128|0;f=h+160|0;oa=h+124|0;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[f>>2]=b;oa=h+168|0;k[h+164>>2]=oa;pa=oa+56|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));y0(h,g,1.0);k[qa>>2]=1124007936;ca=qa+4|0;b=qa+8|0;$=qa+40|0;oa=ca;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[$>>2]=b;da=qa+48|0;ba=qa+44|0;k[ba>>2]=da;k[qa+52>>2]=0;k[da>>2]=0;aa=k[h>>2]|0;dh[k[(k[aa>>2]|0)+12>>2]&255](aa,h,qa,-1);XN(h);d=d*1.7320508075688772;aa=a+224|0;_=a+112|0;D=a+280|0;e=d*4.0/7.937253933193772;I3a(aa,_,e);k[ra>>2]=0;E=ra+4|0;k[E>>2]=0;F=ra+8|0;k[F>>2]=1124007936;G=ra+12|0;H=ra+16|0;I=ra+48|0;oa=G;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[I>>2]=H;J=ra+56|0;K=ra+52|0;k[K>>2]=J;L=ra+60|0;k[L>>2]=0;k[J>>2]=0;M=ra+64|0;k[M>>2]=1124007936;O=ra+68|0;P=ra+72|0;Q=ra+104|0;oa=O;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[Q>>2]=P;R=ra+112|0;S=ra+108|0;k[S>>2]=R;T=ra+116|0;k[T>>2]=0;k[R>>2]=0;U=ra+120|0;k[U>>2]=1124007936;V=ra+124|0;W=ra+128|0;X=ra+160|0;oa=V;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[X>>2]=W;Y=ra+168|0;Z=ra+164|0;k[Z>>2]=Y;oa=Y;pa=oa+56|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));y0(ra,aa,1.0);h=k[ra>>2]|0;dh[k[(k[h>>2]|0)+12>>2]&255](h,ra,D,-1);XN(ra);I3a(D,qa,e);k[ra>>2]=0;h=ra+4|0;k[h>>2]=0;i=ra+8|0;k[i>>2]=1124007936;j=ra+12|0;l=ra+16|0;m=ra+48|0;oa=j;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[m>>2]=l;n=ra+56|0;o=ra+52|0;k[o>>2]=n;q=ra+60|0;k[q>>2]=0;k[n>>2]=0;s=ra+64|0;k[s>>2]=1124007936;t=ra+68|0;v=ra+72|0;w=ra+104|0;oa=t;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[w>>2]=v;x=ra+112|0;y=ra+108|0;k[y>>2]=x;z=ra+116|0;k[z>>2]=0;k[x>>2]=0;A=ra+120|0;k[A>>2]=1124007936;B=ra+124|0;C=ra+128|0;b=ra+160|0;oa=B;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[b>>2]=C;f=ra+168|0;g=ra+164|0;k[g>>2]=f;oa=f;pa=oa+56|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));y0(ra,D,1.0);oa=k[ra>>2]|0;dh[k[(k[oa>>2]|0)+12>>2]&255](oa,ra,aa,-1);XN(ra);e=d*2.0/7.937253933193772;I3a(aa,_,e);k[ra>>2]=0;k[E>>2]=0;k[F>>2]=1124007936;oa=G;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[I>>2]=H;k[K>>2]=J;k[L>>2]=0;k[J>>2]=0;k[M>>2]=1124007936;oa=O;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[Q>>2]=P;k[S>>2]=R;k[T>>2]=0;k[R>>2]=0;k[U>>2]=1124007936;oa=V;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[X>>2]=W;k[Z>>2]=Y;oa=Y;pa=oa+56|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));y0(ra,aa,1.0);oa=k[ra>>2]|0;dh[k[(k[oa>>2]|0)+12>>2]&255](oa,ra,D,-1);XN(ra);I3a(D,qa,e);k[ra>>2]=0;k[h>>2]=0;k[i>>2]=1124007936;oa=j;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[m>>2]=l;k[o>>2]=n;k[q>>2]=0;k[n>>2]=0;k[s>>2]=1124007936;oa=t;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[w>>2]=v;k[y>>2]=x;k[z>>2]=0;k[x>>2]=0;k[A>>2]=1124007936;oa=B;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[b>>2]=C;k[g>>2]=f;oa=f;pa=oa+56|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));y0(ra,D,1.0);oa=k[ra>>2]|0;dh[k[(k[oa>>2]|0)+12>>2]&255](oa,ra,aa,-1);XN(ra);e=d/7.937253933193772;I3a(aa,_,e);k[ra>>2]=0;k[E>>2]=0;k[F>>2]=1124007936;oa=G;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[I>>2]=H;k[K>>2]=J;k[L>>2]=0;k[J>>2]=0;k[M>>2]=1124007936;oa=O;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[Q>>2]=P;k[S>>2]=R;k[T>>2]=0;k[R>>2]=0;k[U>>2]=1124007936;oa=V;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[X>>2]=W;k[Z>>2]=Y;oa=Y;pa=oa+56|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));y0(ra,aa,1.0);oa=k[ra>>2]|0;dh[k[(k[oa>>2]|0)+12>>2]&255](oa,ra,D,-1);XN(ra);I3a(D,qa,e);k[ra>>2]=0;k[h>>2]=0;k[i>>2]=1124007936;oa=j;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[m>>2]=l;k[o>>2]=n;k[q>>2]=0;k[n>>2]=0;k[s>>2]=1124007936;oa=t;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[w>>2]=v;k[y>>2]=x;k[z>>2]=0;k[x>>2]=0;k[A>>2]=1124007936;oa=B;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[b>>2]=C;k[g>>2]=f;oa=f;pa=oa+56|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));y0(ra,D,1.0);g=k[ra>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,ra,aa,-1);XN(ra);g=qa+36|0;b=k[g>>2]|0;if(b|0?(oa=b+12|0,pa=k[oa>>2]|0,k[oa>>2]=pa+-1,(pa|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[qa+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;pa=qa+16|0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[ca>>2]|0)>0){f=k[$>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ca>>2]|0))}b=k[ba>>2]|0;if(!((b|0)==(da|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=aa;break}case 2:{g=a+56|0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=1124007936;b=i+16|0;f=i+48|0;oa=i+12|0;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[f>>2]=b;b=i+56|0;k[i+52>>2]=b;k[i+60>>2]=0;k[b>>2]=0;k[i+64>>2]=1124007936;b=i+72|0;f=i+104|0;oa=i+68|0;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[f>>2]=b;b=i+112|0;k[i+108>>2]=b;k[i+116>>2]=0;k[b>>2]=0;k[i+120>>2]=1124007936;b=i+128|0;f=i+160|0;oa=i+124|0;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[f>>2]=b;oa=i+168|0;k[i+164>>2]=oa;pa=oa+56|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));y0(i,g,1.0);k[ra>>2]=1124007936;ma=ra+4|0;b=ra+8|0;ja=ra+40|0;oa=ma;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[ja>>2]=b;na=ra+48|0;la=ra+44|0;k[la>>2]=na;k[ra+52>>2]=0;k[na>>2]=0;fa=k[i>>2]|0;dh[k[(k[fa>>2]|0)+12>>2]&255](fa,i,ra,-1);XN(i);k[ka>>2]=1124007936;fa=ka+4|0;b=ka+8|0;da=ka+40|0;oa=fa;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[da>>2]=b;ga=ka+48|0;ea=ka+44|0;k[ea>>2]=ga;k[ka+52>>2]=0;k[ga>>2]=0;k[qa>>2]=j;f=qa+4|0;k[f>>2]=l;G1(ka,2,qa,5);k[ha>>2]=1124007936;ba=ha+4|0;b=ha+8|0;$=ha+40|0;oa=ba;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[$>>2]=b;ca=ha+48|0;aa=ha+44|0;k[aa>>2]=ca;k[ha+52>>2]=0;k[ca>>2]=0;k[qa>>2]=l;k[f>>2]=j;G1(ha,2,qa,5);e=d*1.7320508075688772;ia=a+224|0;f=a+280|0;g=qa+4|0;h=qa+8|0;i=qa+12|0;j=qa+16|0;l=qa+48|0;m=qa+56|0;n=qa+52|0;o=qa+60|0;q=qa+64|0;s=qa+68|0;t=qa+72|0;v=qa+104|0;w=qa+112|0;x=qa+108|0;y=qa+116|0;z=qa+120|0;A=qa+124|0;B=qa+128|0;C=qa+160|0;D=qa+168|0;E=qa+164|0;F=qa+4|0;G=qa+8|0;H=qa+12|0;I=qa+16|0;J=qa+48|0;K=qa+56|0;L=qa+52|0;M=qa+60|0;O=qa+64|0;P=qa+68|0;Q=qa+72|0;R=qa+104|0;S=qa+112|0;T=qa+108|0;U=qa+116|0;V=qa+120|0;W=qa+124|0;X=qa+128|0;Y=qa+160|0;Z=qa+168|0;_=qa+164|0;b=0;do{pa=Apb(2-b+1023|0,0,52)|0;b=b+1|0;oa=N;k[u>>2]=pa;k[u+4>>2]=oa;d=e*+p[u>>3]/7.937253933193772*1.7320507764816284;K3a(a,ia,a,ka,d);k[qa>>2]=0;k[g>>2]=0;k[h>>2]=1124007936;oa=i;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[l>>2]=j;k[n>>2]=m;k[o>>2]=0;k[m>>2]=0;k[q>>2]=1124007936;oa=s;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[v>>2]=t;k[x>>2]=w;k[y>>2]=0;k[w>>2]=0;k[z>>2]=1124007936;oa=A;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[C>>2]=B;k[E>>2]=D;oa=D;pa=oa+56|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));y0(qa,ia,1.0);oa=k[qa>>2]|0;dh[k[(k[oa>>2]|0)+12>>2]&255](oa,qa,f,-1);XN(qa);K3a(a,f,ra,ha,d);k[qa>>2]=0;k[F>>2]=0;k[G>>2]=1124007936;oa=H;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[J>>2]=I;k[L>>2]=K;k[M>>2]=0;k[K>>2]=0;k[O>>2]=1124007936;oa=P;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[R>>2]=Q;k[T>>2]=S;k[U>>2]=0;k[S>>2]=0;k[V>>2]=1124007936;oa=W;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[Y>>2]=X;k[_>>2]=Z;oa=Z;pa=oa+56|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));y0(qa,f,1.0);pa=k[qa>>2]|0;dh[k[(k[pa>>2]|0)+12>>2]&255](pa,qa,ia,-1);XN(qa)}while((b|0)<3);g=ha+36|0;b=k[g>>2]|0;if(b|0?(oa=b+12|0,pa=k[oa>>2]|0,k[oa>>2]=pa+-1,(pa|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[ha+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;pa=ha+16|0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[ba>>2]|0)>0){f=k[$>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ba>>2]|0))}b=k[aa>>2]|0;if(!((b|0)==(ca|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=ka+36|0;b=k[g>>2]|0;if(b|0?(oa=b+12|0,pa=k[oa>>2]|0,k[oa>>2]=pa+-1,(pa|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[ka+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;pa=ka+16|0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[fa>>2]|0)>0){f=k[da>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[fa>>2]|0))}b=k[ea>>2]|0;if(!((b|0)==(ga|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=ra+36|0;b=k[g>>2]|0;if(b|0?(oa=b+12|0,pa=k[oa>>2]|0,k[oa>>2]=pa+-1,(pa|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[ra+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;pa=ra+16|0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[ma>>2]|0)>0){f=k[ja>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ma>>2]|0))}b=k[la>>2]|0;if(!((b|0)==(na|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ia;break}default:f=a+224|0}k[ra>>2]=1124007936;l=ra+4|0;b=ra+8|0;i=ra+40|0;oa=l;pa=oa+36|0;do{k[oa>>2]=0;oa=oa+4|0}while((oa|0)<(pa|0));k[i>>2]=b;j=ra+48|0;h=ra+44|0;k[h>>2]=j;k[ra+52>>2]=0;k[j>>2]=0;g=qa+4|0;b=g+4|0;k[b>>2]=0;k[b+4>>2]=0;k[qa>>2]=33619968;k[g>>2]=ra;mY(f,qa);KG(c,ra)|0;g=ra+36|0;b=k[g>>2]|0;if(b|0?(c=b+12|0,qa=k[c>>2]|0,k[c>>2]=qa+-1,(qa|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[ra+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;ra=ra+16|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[l>>2]|0)>0){f=k[i>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[h>>2]|0;if((b|0)==(j|0)|(b|0)==0){r=sa;return}ggb(k[b+-4>>2]|0);r=sa;return}function N3a(a){a=a|0;var b=0,c=0,d=0;d=a+428|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+424>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+408|0;c=a+396|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+432>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+436>>2]|0;if(!((b|0)==(a+440|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+372|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+368>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+352|0;c=a+340|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+376>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+380>>2]|0;if(!((b|0)==(a+384|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+316|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+312>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+296|0;d=a+284|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+320>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+324>>2]|0;if(!((b|0)==(a+328|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+260|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+256>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+240|0;c=a+228|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+264>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+268>>2]|0;if(!((b|0)==(a+272|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+204|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+200>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+184|0;c=a+172|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+208>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+212>>2]|0;if(!((b|0)==(a+216|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+148|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+144>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+128|0;c=a+116|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+152>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+156>>2]|0;if(!((b|0)==(a+160|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+92|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+88>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+72|0;c=a+60|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+96>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+100>>2]|0;if(!((b|0)==(a+104|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+36|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+16|0;c=a+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+44>>2]|0;if((b|0)==(a+48|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function O3a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;va=r;r=r+3360|0;Y=va+2288|0;O=va+2232|0;M=va+2176|0;ua=va+2112|0;ta=va+2056|0;sa=va+2e3|0;u=va+2168|0;ra=va+1944|0;qa=va+1888|0;oa=va+1832|0;v=va+672|0;ma=va+1776|0;w=va+448|0;ka=va+1720|0;x=va+224|0;ja=va+1664|0;z=va;C=va+1536|0;E=va+1464|0;ga=va+1352|0;da=va+1296|0;A=va+1608|0;B=va+1552|0;D=va+1480|0;F=va+1408|0;Z=va+896|0;do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[ua>>2]=k[j>>2];p=ua+4|0;a=j+4|0;k[p>>2]=k[a>>2];pa=ua+8|0;k[pa>>2]=k[j+8>>2];k[ua+12>>2]=k[j+12>>2];k[ua+16>>2]=k[j+16>>2];k[ua+20>>2]=k[j+20>>2];k[ua+24>>2]=k[j+24>>2];k[ua+28>>2]=k[j+28>>2];k[ua+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[ua+36>>2]=g;h=ua+40|0;k[h>>2]=pa;pa=ua+48|0;m=ua+44|0;k[m>>2]=pa;k[ua+52>>2]=0;k[pa>>2]=0;if(g|0){pa=g+12|0;k[pa>>2]=(k[pa>>2]|0)+1}if((k[a>>2]|0)<3){na=k[j+44>>2]|0;pa=k[m>>2]|0;k[pa>>2]=k[na>>2];k[pa+4>>2]=k[na+4>>2];break}k[p>>2]=0;x1(ua,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(ua,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[ta>>2]=k[j>>2];p=ta+4|0;a=j+4|0;k[p>>2]=k[a>>2];pa=ta+8|0;k[pa>>2]=k[j+8>>2];k[ta+12>>2]=k[j+12>>2];k[ta+16>>2]=k[j+16>>2];k[ta+20>>2]=k[j+20>>2];k[ta+24>>2]=k[j+24>>2];k[ta+28>>2]=k[j+28>>2];k[ta+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[ta+36>>2]=g;h=ta+40|0;k[h>>2]=pa;pa=ta+48|0;m=ta+44|0;k[m>>2]=pa;k[ta+52>>2]=0;k[pa>>2]=0;if(g|0){pa=g+12|0;k[pa>>2]=(k[pa>>2]|0)+1}if((k[a>>2]|0)<3){na=k[j+44>>2]|0;pa=k[m>>2]|0;k[pa>>2]=k[na>>2];k[pa+4>>2]=k[na+4>>2];break}k[p>>2]=0;x1(ta,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(ta,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){j=k[c+4>>2]|0;k[sa>>2]=k[j>>2];p=sa+4|0;a=j+4|0;k[p>>2]=k[a>>2];pa=sa+8|0;k[pa>>2]=k[j+8>>2];k[sa+12>>2]=k[j+12>>2];k[sa+16>>2]=k[j+16>>2];k[sa+20>>2]=k[j+20>>2];k[sa+24>>2]=k[j+24>>2];k[sa+28>>2]=k[j+28>>2];k[sa+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[sa+36>>2]=g;h=sa+40|0;k[h>>2]=pa;pa=sa+48|0;m=sa+44|0;k[m>>2]=pa;k[sa+52>>2]=0;k[pa>>2]=0;if(g|0){pa=g+12|0;k[pa>>2]=(k[pa>>2]|0)+1}if((k[a>>2]|0)<3){na=k[j+44>>2]|0;pa=k[m>>2]|0;k[pa>>2]=k[na>>2];k[pa+4>>2]=k[na+4>>2];break}k[p>>2]=0;x1(sa,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(sa,c,-1);while(0);pa=ta+40|0;la=k[pa>>2]|0;na=k[la>>2]|0;k[u>>2]=k[la+4>>2];k[u+4>>2]=na;x2(e,u,16,0);do if((k[e>>2]&2031616|0)==65536){j=k[e+4>>2]|0;k[ra>>2]=k[j>>2];p=ra+4|0;a=j+4|0;k[p>>2]=k[a>>2];na=ra+8|0;k[na>>2]=k[j+8>>2];k[ra+12>>2]=k[j+12>>2];k[ra+16>>2]=k[j+16>>2];k[ra+20>>2]=k[j+20>>2];k[ra+24>>2]=k[j+24>>2];k[ra+28>>2]=k[j+28>>2];k[ra+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[ra+36>>2]=g;h=ra+40|0;k[h>>2]=na;na=ra+48|0;m=ra+44|0;k[m>>2]=na;k[ra+52>>2]=0;k[na>>2]=0;if(g|0){na=g+12|0;k[na>>2]=(k[na>>2]|0)+1}if((k[a>>2]|0)<3){la=k[j+44>>2]|0;na=k[m>>2]|0;k[na>>2]=k[la>>2];k[na+4>>2]=k[la+4>>2];break}k[p>>2]=0;x1(ra,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(ra,e,-1);while(0);la=sa+40|0;c=k[la>>2]|0;b=k[c>>2]|0;c=k[c+4>>2]|0;k[qa>>2]=1124007936;ha=qa+4|0;a=qa+8|0;ea=qa+40|0;u=ha;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[ea>>2]=a;ia=qa+48|0;fa=qa+44|0;k[fa>>2]=ia;k[qa+52>>2]=0;k[ia>>2]=0;k[Y>>2]=b;k[Y+4>>2]=c;G1(qa,2,Y,0);j=k[pa>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=1124007936;a=v+16|0;g=v+48|0;u=v+12|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=v+56|0;k[v+52>>2]=a;k[v+60>>2]=0;k[a>>2]=0;k[v+64>>2]=1124007936;a=v+72|0;g=v+104|0;u=v+68|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=v+112|0;k[v+108>>2]=a;k[v+116>>2]=0;k[a>>2]=0;k[v+120>>2]=1124007936;a=v+128|0;g=v+160|0;u=v+124|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;u=v+168|0;k[v+164>>2]=u;e=u+56|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[Y>>2]=h;k[Y+4>>2]=j;j1(v,48,Y,0);k[oa>>2]=1124007936;ba=oa+4|0;a=oa+8|0;_=oa+40|0;u=ba;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[_>>2]=a;ca=oa+48|0;$=oa+44|0;k[$>>2]=ca;k[oa+52>>2]=0;k[ca>>2]=0;na=k[v>>2]|0;dh[k[(k[na>>2]|0)+12>>2]&255](na,v,oa,-1);XN(v);na=ua+40|0;j=k[na>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=1124007936;a=w+16|0;g=w+48|0;u=w+12|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=w+56|0;k[w+52>>2]=a;k[w+60>>2]=0;k[a>>2]=0;k[w+64>>2]=1124007936;a=w+72|0;g=w+104|0;u=w+68|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=w+112|0;k[w+108>>2]=a;k[w+116>>2]=0;k[a>>2]=0;k[w+120>>2]=1124007936;a=w+128|0;g=w+160|0;u=w+124|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;u=w+168|0;k[w+164>>2]=u;e=u+56|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[Y>>2]=h;k[Y+4>>2]=j;j1(w,48,Y,16);k[ma>>2]=1124007936;W=ma+4|0;a=ma+8|0;U=ma+40|0;u=W;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[U>>2]=a;X=ma+48|0;V=ma+44|0;k[V>>2]=X;k[ma+52>>2]=0;k[X>>2]=0;j=k[w>>2]|0;dh[k[(k[j>>2]|0)+12>>2]&255](j,w,ma,-1);XN(w);j=k[pa>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=1124007936;a=x+16|0;g=x+48|0;u=x+12|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=x+56|0;k[x+52>>2]=a;k[x+60>>2]=0;k[a>>2]=0;k[x+64>>2]=1124007936;a=x+72|0;g=x+104|0;u=x+68|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=x+112|0;k[x+108>>2]=a;k[x+116>>2]=0;k[a>>2]=0;k[x+120>>2]=1124007936;a=x+128|0;g=x+160|0;u=x+124|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;u=x+168|0;k[x+164>>2]=u;e=u+56|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[Y>>2]=h;k[Y+4>>2]=j;j1(x,48,Y,16);k[ka>>2]=1124007936;R=ka+4|0;a=ka+8|0;N=ka+40|0;u=R;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[N>>2]=a;S=ka+48|0;Q=ka+44|0;k[Q>>2]=S;k[ka+52>>2]=0;k[S>>2]=0;L=k[x>>2]|0;dh[k[(k[L>>2]|0)+12>>2]&255](L,x,ka,-1);XN(x);if((k[sa>>2]&4088|0)==16){k[Y+8>>2]=0;k[Y+12>>2]=0;k[Y>>2]=16842752;k[Y+4>>2]=sa;L=O+4|0;K=L+4|0;k[K>>2]=0;k[K+4>>2]=0;k[O>>2]=33619968;k[L>>2]=qa;$aa(Y,O,6,0)}else KG(qa,sa)|0;if((b|0)>0?(y=k[qa+16>>2]|0,(c|0)>0):0){m=k[k[fa>>2]>>2]|0;j=2147483647;a=-2147483648;g=-2147483648;h=2147483647;p=0;do{n=y+(aa(m,p)|0)|0;l=0;do{if((i[n+l>>0]|0)==-1){h=(p|0)<(h|0)?p:h;j=(l|0)<(j|0)?l:j;a=(a|0)<(p|0)?p:a;g=(g|0)<(l|0)?l:g}l=l+1|0}while((l|0)!=(c|0));p=p+1|0}while((p|0)!=(b|0))}else{h=2147483647;j=2147483647;a=-2147483648;g=-2147483648}b=a-h|0;p=g-j|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=1124007936;a=z+16|0;g=z+48|0;u=z+12|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=z+56|0;k[z+52>>2]=a;k[z+60>>2]=0;k[a>>2]=0;k[z+64>>2]=1124007936;a=z+72|0;g=z+104|0;u=z+68|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=z+112|0;k[z+108>>2]=a;k[z+116>>2]=0;k[a>>2]=0;k[z+120>>2]=1124007936;a=z+128|0;g=z+160|0;u=z+124|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;u=z+168|0;k[z+164>>2]=u;e=u+56|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[Y>>2]=p;k[Y+4>>2]=b;j1(z,48,Y,16);k[ja>>2]=1124007936;K=ja+4|0;a=ja+8|0;I=ja+40|0;u=K;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[I>>2]=a;L=ja+48|0;J=ja+44|0;k[J>>2]=L;k[ja+52>>2]=0;k[L>>2]=0;G=k[z>>2]|0;dh[k[(k[G>>2]|0)+12>>2]&255](G,z,ja,-1);XN(z);z=k[d+4>>2]|0;G=(b|0)/2|0;n=z-G|0;d=k[d>>2]|0;H=(p|0)/2|0;a=d-H|0;H=d+H|0;if(!(((a|n|0)>-1?(z+G|0)<=(k[ta+8>>2]|0):0)?(H|0)<=(k[ta+12>>2]|0):0)){k[Y>>2]=0;g=Y+4|0;k[g>>2]=0;l=ZT(76)|0;k[l>>2]=1;u=l+4|0;k[Y>>2]=u;k[g>>2]=68;i[l+72>>0]=0;m=399631;e=u+68|0;do{i[u>>0]=i[m>>0]|0;u=u+1|0;m=m+1|0}while((u|0)<(e|0));Y8(-215,Y,399700,399714,96);k[g>>2]=0;k[Y>>2]=0;H=k[l>>2]|0;k[l>>2]=H+-1;if((H|0)==1)ggb(k[l+-4>>2]|0)}k[C>>2]=a;k[C+4>>2]=n;k[C+8>>2]=p;k[C+12>>2]=b;k[E>>2]=j;k[E+4>>2]=h;k[E+8>>2]=p;k[E+12>>2]=b;I1(ga,oa,C);I1(da,ma,E);I1(A,qa,E);h=Y+4|0;a=h+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Y>>2]=33619968;k[h>>2]=ga;mY(A,Y);h=A+36|0;a=k[h>>2]|0;if(a|0?(G=a+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[A+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;H=A+16|0;g=A+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[g>>2]|0)>0){h=k[A+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[A+44>>2]|0;if(!((a|0)==(A+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);I1(B,ua,E);h=Y+4|0;a=h+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Y>>2]=33619968;k[h>>2]=da;I1(M,qa,E);k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=M;nY(B,Y,O);h=M+36|0;a=k[h>>2]|0;if(a|0?(G=a+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[M+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;H=M+16|0;g=M+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[g>>2]|0)>0){h=k[M+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[M+44>>2]|0;if(!((a|0)==(M+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=B+36|0;a=k[h>>2]|0;if(a|0?(G=a+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[B+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;H=B+16|0;g=B+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[g>>2]|0)>0){h=k[B+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[B+44>>2]|0;if(!((a|0)==(B+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);I1(D,ua,E);h=Y+4|0;a=h+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Y>>2]=33619968;k[h>>2]=ja;I1(M,qa,E);k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=M;nY(D,Y,O);h=M+36|0;a=k[h>>2]|0;if(a|0?(G=a+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[M+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;H=M+16|0;g=M+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[g>>2]|0)>0){h=k[M+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[M+44>>2]|0;if(!((a|0)==(M+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=D+36|0;a=k[h>>2]|0;do if(a|0){G=a+12|0;H=k[G>>2]|0;k[G>>2]=H+-1;if((H|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[D+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;H=D+16|0;g=D+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[g>>2]|0)>0){h=k[D+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[D+44>>2]|0;if(!((a|0)==(D+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);I1(Y,ka,C);KG(ga,Y)|0;h=Y+36|0;a=k[h>>2]|0;do if(a|0){G=a+12|0;H=k[G>>2]|0;k[G>>2]=H+-1;if((H|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[Y+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;H=Y+16|0;g=Y+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[g>>2]|0)>0){h=k[Y+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[Y+44>>2]|0;if(!((a|0)==(Y+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);I1(F,ma,E);h=Y+4|0;a=h+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Y>>2]=33619968;k[h>>2]=ga;mY(F,Y);h=F+36|0;a=k[h>>2]|0;do if(a|0){G=a+12|0;H=k[G>>2]|0;k[G>>2]=H+-1;if((H|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[F+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;H=F+16|0;g=F+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[g>>2]|0)>0){h=k[F+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[F+44>>2]|0;if(!((a|0)==(F+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=Z+36|0;u=Z;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[a>>2]=1124007936;a=Z+44|0;g=Z+76|0;u=Z+40|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=Z+84|0;p=Z+80|0;k[p>>2]=a;k[Z+88>>2]=0;k[a>>2]=0;k[Z+92>>2]=1124007936;a=Z+100|0;g=Z+132|0;u=Z+96|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=Z+140|0;b=Z+136|0;k[b>>2]=a;k[Z+144>>2]=0;k[a>>2]=0;k[Z+148>>2]=1124007936;a=Z+156|0;g=Z+188|0;u=Z+152|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=Z+196|0;l=Z+192|0;k[l>>2]=a;k[Z+200>>2]=0;k[a>>2]=0;k[Z+204>>2]=1124007936;a=Z+212|0;g=Z+244|0;u=Z+208|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=Z+252|0;m=Z+248|0;k[m>>2]=a;k[Z+256>>2]=0;k[a>>2]=0;k[Z+260>>2]=1124007936;a=Z+268|0;g=Z+300|0;u=Z+264|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;a=Z+308|0;n=Z+304|0;k[n>>2]=a;k[Z+312>>2]=0;k[a>>2]=0;k[Z+316>>2]=1124007936;a=Z+324|0;g=Z+356|0;u=Z+320|0;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[g>>2]=a;G=Z+364|0;k[Z+360>>2]=G;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;k[G+16>>2]=0;k[G+20>>2]=0;k[G+24>>2]=0;k[G+28>>2]=0;G=k[ta+8>>2]|0;h=((k[ta>>2]|0)>>>3&511)+1|0;H=aa(h,k[ta+12>>2]|0)|0;U3a(Z,ta,ka,oa);switch(f|0){case 1:{Y=Z+148|0;T=Z+260|0;W3a(Y,T,Y);Y=Z+204|0;W3a(Y,T,Y);break}case 2:{E=Y+8|0;k[Y>>2]=E;F=Y+4|0;k[F>>2]=264;if(H>>>0>264){g=H>>>0>1073741823?-1:H<<2;g=(g|0)==0?1:g;while(1){a=fgb(g)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[Y>>2]=a}else a=E;k[F>>2]=H;j=(H|0)>0;if(j){g=0;do{k[a+(g<<2)>>2]=(g|0)/(h|0)|0;g=g+1|0}while((g|0)!=(H|0))}do if((G|0)>0){D=k[Z+164>>2]|0;B=k[k[l>>2]>>2]|0;C=k[Z+220>>2]|0;d=k[k[m>>2]>>2]|0;A=k[Z+52>>2]|0;y=k[k[p>>2]>>2]|0;z=k[Z+108>>2]|0;w=k[k[b>>2]>>2]|0;x=k[Z+276>>2]|0;v=k[k[n>>2]>>2]|0;a=k[Y>>2]|0;if(j)m=0;else break;do{n=D+(aa(B,m)|0)|0;p=C+(aa(d,m)|0)|0;b=A+(aa(y,m)|0)|0;c=z+(aa(w,m)|0)|0;u=x+(aa(v,m)|0)|0;l=0;do{g=n+(l<<2)|0;q=+o[g>>2];e=p+(l<<2)|0;t=+P(+(q-+o[e>>2]));s=+o[b+(l<<2)>>2];h=c+(l<<2)|0;T=t>+P(+(s-+o[h>>2]));j=u+(k[a+(l<<2)>>2]<<2)|0;t=+o[j>>2];if(T){o[g>>2]=q*t;q=+o[j>>2]*+o[e>>2]}else{o[g>>2]=s*t;q=+o[h>>2]*+o[j>>2]}o[e>>2]=q;l=l+1|0}while((l|0)!=(H|0));m=m+1|0}while((m|0)!=(G|0));T=163}else T=163;while(0);if((T|0)==163)a=k[Y>>2]|0;if((a|0)!=(E|0)){if(a|0)ggb(a);k[Y>>2]=E;k[F>>2]=264}break}case 3:{h=k[N>>2]|0;g=k[h+4>>2]|0;h=k[h>>2]|0;k[O>>2]=1124007936;n=O+4|0;a=O+8|0;l=O+40|0;u=n;e=u+36|0;do{k[u>>2]=0;u=u+4|0}while((u|0)<(e|0));k[l>>2]=a;m=O+48|0;j=O+44|0;k[j>>2]=m;k[O+52>>2]=0;k[m>>2]=0;k[Y>>2]=h;k[Y+4>>2]=g;G1(O,2,Y,0);k[Y+8>>2]=0;k[Y+12>>2]=0;k[Y>>2]=16842752;k[Y+4>>2]=ka;h=M+4|0;a=h+4|0;k[a>>2]=0;k[a+4>>2]=0;k[M>>2]=33619968;k[h>>2]=O;$aa(Y,M,6,0);Y=Z+148|0;Q3a(O,Y);h=Z+204|0;R3a(O,h);a=Z+260|0;W3a(Y,a,Y);W3a(h,a,h);h=O+36|0;a=k[h>>2]|0;do if(a|0){T=a+12|0;Y=k[T>>2]|0;k[T>>2]=Y+-1;if((Y|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[O+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;Y=O+16|0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[n>>2]|0)>0){g=k[l>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[j>>2]|0;if(!((a|0)==(m|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break}default:{}}X3a(Z,ta,oa,ra);P3a(Z);h=da+36|0;a=k[h>>2]|0;do if(a|0){Y=a+12|0;Z=k[Y>>2]|0;k[Y>>2]=Z+-1;if((Z|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[da+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;Z=da+16|0;g=da+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[g>>2]|0)>0){h=k[da+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[da+44>>2]|0;if(!((a|0)==(da+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=ga+36|0;a=k[h>>2]|0;do if(a|0){Z=a+12|0;da=k[Z>>2]|0;k[Z>>2]=da+-1;if((da|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ga+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;da=ga+16|0;g=ga+4|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[g>>2]|0)>0){h=k[ga+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[ga+44>>2]|0;if(!((a|0)==(ga+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=ja+36|0;a=k[h>>2]|0;do if(a|0){da=a+12|0;ga=k[da>>2]|0;k[da>>2]=ga+-1;if((ga|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ja+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;ja=ja+16|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[K>>2]|0)>0){g=k[I>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[K>>2]|0))}a=k[J>>2]|0;if(!((a|0)==(L|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=ka+36|0;a=k[h>>2]|0;do if(a|0){ga=a+12|0;ja=k[ga>>2]|0;k[ga>>2]=ja+-1;if((ja|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ka+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;ka=ka+16|0;k[ka>>2]=0;k[ka+4>>2]=0;k[ka+8>>2]=0;k[ka+12>>2]=0;if((k[R>>2]|0)>0){g=k[N>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[R>>2]|0))}a=k[Q>>2]|0;if(!((a|0)==(S|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=ma+36|0;a=k[h>>2]|0;do if(a|0){ja=a+12|0;ka=k[ja>>2]|0;k[ja>>2]=ka+-1;if((ka|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ma+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;ma=ma+16|0;k[ma>>2]=0;k[ma+4>>2]=0;k[ma+8>>2]=0;k[ma+12>>2]=0;if((k[W>>2]|0)>0){g=k[U>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[W>>2]|0))}a=k[V>>2]|0;if(!((a|0)==(X|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=oa+36|0;a=k[h>>2]|0;do if(a|0){ka=a+12|0;ma=k[ka>>2]|0;k[ka>>2]=ma+-1;if((ma|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[oa+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;oa=oa+16|0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[ba>>2]|0)>0){g=k[_>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ba>>2]|0))}a=k[$>>2]|0;if(!((a|0)==(ca|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=qa+36|0;a=k[h>>2]|0;do if(a|0){ma=a+12|0;oa=k[ma>>2]|0;k[ma>>2]=oa+-1;if((oa|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[qa+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;qa=qa+16|0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[qa+12>>2]=0;if((k[ha>>2]|0)>0){g=k[ea>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ha>>2]|0))}a=k[fa>>2]|0;if(!((a|0)==(ia|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=ra+36|0;a=k[h>>2]|0;do if(a|0){oa=a+12|0;qa=k[oa>>2]|0;k[oa>>2]=qa+-1;if((qa|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ra+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;qa=ra+16|0;g=ra+4|0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[qa+12>>2]=0;if((k[g>>2]|0)>0){h=k[ra+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[ra+44>>2]|0;if(!((a|0)==(ra+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=sa+36|0;a=k[h>>2]|0;do if(a|0){qa=a+12|0;ra=k[qa>>2]|0;k[qa>>2]=ra+-1;if((ra|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[sa+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;ra=sa+16|0;h=sa+4|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[h>>2]|0)>0){g=k[la>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[sa+44>>2]|0;if(!((a|0)==(sa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=ta+36|0;a=k[h>>2]|0;do if(a|0){ra=a+12|0;sa=k[ra>>2]|0;k[ra>>2]=sa+-1;if((sa|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ta+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;sa=ta+16|0;h=ta+4|0;k[sa>>2]=0;k[sa+4>>2]=0;k[sa+8>>2]=0;k[sa+12>>2]=0;if((k[h>>2]|0)>0){g=k[pa>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[ta+44>>2]|0;if(!((a|0)==(ta+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=ua+36|0;a=k[h>>2]|0;do if(a|0){sa=a+12|0;ta=k[sa>>2]|0;k[sa>>2]=ta+-1;if((ta|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ua+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;ta=ua+16|0;h=ua+4|0;k[ta>>2]=0;k[ta+4>>2]=0;k[ta+8>>2]=0;k[ta+12>>2]=0;if((k[h>>2]|0)>0){g=k[na>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[ua+44>>2]|0;if((a|0)==(ua+48|0)|(a|0)==0){r=va;return}ggb(k[a+-4>>2]|0);r=va;return}function P3a(a){a=a|0;var b=0,c=0,d=0,e=0;b=k[a+384>>2]|0;c=b;if(b|0){d=a+388|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+372>>2]|0;c=b;if(b|0){d=a+376|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+352|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+348>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+332|0;c=a+320|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+356>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+360>>2]|0;if(!((b|0)==(a+364|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+296|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+292>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+276|0;c=a+264|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+300>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+304>>2]|0;if(!((b|0)==(a+308|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+240|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+236>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+220|0;c=a+208|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+244>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+248>>2]|0;if(!((b|0)==(a+252|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+184|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+180>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+164|0;c=a+152|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+188>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+192>>2]|0;if(!((b|0)==(a+196|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+128|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+124>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+108|0;c=a+96|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+132>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+136>>2]|0;if(!((b|0)==(a+140|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+72|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+68>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+52|0;c=a+40|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+76>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+80>>2]|0;if((b|0)==(a+84|0)|(b|0)==0){e=a+24|0;zF(e);e=a+12|0;zF(e);zF(a);return}ggb(k[b+-4>>2]|0);e=a+24|0;zF(e);e=a+12|0;zF(e);zF(a);return}function Q3a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;G=r;r=r+512|0;z=G+344|0;F=G+288|0;e=G;m=G+272|0;n=G+256|0;f=G+248|0;o=G+224|0;p=G+240|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=1124007936;c=e+16|0;d=e+48|0;h=e+12|0;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[d>>2]=c;c=e+56|0;k[e+52>>2]=c;k[e+60>>2]=0;k[c>>2]=0;k[e+64>>2]=1124007936;c=e+72|0;d=e+104|0;h=e+68|0;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[d>>2]=c;c=e+112|0;k[e+108>>2]=c;k[e+116>>2]=0;k[c>>2]=0;k[e+120>>2]=1124007936;c=e+128|0;d=e+160|0;h=e+124|0;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[d>>2]=c;h=e+168|0;k[e+164>>2]=h;l=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[z>>2]=3;k[z+4>>2]=1;j1(e,48,z,1);k[F>>2]=1124007936;D=F+4|0;c=F+8|0;B=F+40|0;h=D;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[B>>2]=c;E=F+48|0;C=F+44|0;k[C>>2]=E;k[F+52>>2]=0;k[E>>2]=0;A=k[e>>2]|0;dh[k[(k[A>>2]|0)+12>>2]&255](A,e,F,-1);XN(e);A=F+16|0;i[(k[A>>2]|0)+2>>0]=1;i[(k[A>>2]|0)+1>>0]=-1;switch((k[a>>2]|0)>>>3&511){case 2:{k[z+8>>2]=0;k[z+12>>2]=0;k[z>>2]=16842752;k[z+4>>2]=a;y=m+4|0;x=y+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[y>>2]=b;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=F;k[f>>2]=-1;k[f+4>>2]=-1;fla(z,m,5,n,f,0.0,4);break}case 0:{k[z>>2]=1124007936;x=z+4|0;c=z+8|0;v=z+40|0;h=x;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[v>>2]=c;y=z+48|0;w=z+44|0;k[w>>2]=y;k[z+52>>2]=0;k[y>>2]=0;k[z+56>>2]=1124007936;t=z+60|0;c=z+64|0;q=z+96|0;h=t;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[q>>2]=c;u=z+104|0;s=z+100|0;k[s>>2]=u;k[z+108>>2]=0;k[u>>2]=0;k[z+112>>2]=1124007936;j=z+116|0;c=z+120|0;g=z+152|0;h=j;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[g>>2]=c;h=z+160|0;f=z+156|0;k[f>>2]=h;k[z+164>>2]=0;k[h>>2]=0;L=m+8|0;K=m+12|0;J=m+4|0;H=n+4|0;I=H+4|0;d=o+8|0;l=o+12|0;c=o+4|0;e=p+4|0;k[L>>2]=0;k[K>>2]=0;k[m>>2]=16842752;k[J>>2]=a;M=I;k[M>>2]=0;k[M+4>>2]=0;k[n>>2]=33619968;k[H>>2]=z;k[d>>2]=0;k[l>>2]=0;k[o>>2]=16842752;k[c>>2]=F;k[p>>2]=-1;k[e>>2]=-1;fla(m,n,5,o,p,0.0,4);k[L>>2]=0;k[K>>2]=0;k[m>>2]=16842752;k[J>>2]=a;M=I;k[M>>2]=0;k[M+4>>2]=0;k[n>>2]=33619968;k[H>>2]=z+56;k[d>>2]=0;k[l>>2]=0;k[o>>2]=16842752;k[c>>2]=F;k[p>>2]=-1;k[e>>2]=-1;fla(m,n,5,o,p,0.0,4);k[L>>2]=0;k[K>>2]=0;k[m>>2]=16842752;k[J>>2]=a;a=I;k[a>>2]=0;k[a+4>>2]=0;k[n>>2]=33619968;k[H>>2]=z+112;k[d>>2]=0;k[l>>2]=0;k[o>>2]=16842752;k[c>>2]=F;k[p>>2]=-1;k[e>>2]=-1;fla(m,n,5,o,p,0.0,4);e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=b;GV(z,3,m);e=z+148|0;c=k[e>>2]|0;if(c|0?(L=c+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[z+144>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;M=z+128|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[j>>2]|0)>0){d=k[g>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[j>>2]|0))}c=k[f>>2]|0;if(!((c|0)==(h|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=z+92|0;c=k[e>>2]|0;if(c|0?(L=c+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[z+88>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;M=z+72|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[t>>2]|0)>0){d=k[q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[t>>2]|0))}c=k[s>>2]|0;if(!((c|0)==(u|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=z+36|0;c=k[e>>2]|0;if(c|0?(L=c+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[z+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;M=z+16|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[x>>2]|0)>0){d=k[v>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[x>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(y|0)|(c|0)==0))ggb(k[c+-4>>2]|0);break}default:{}}e=F+36|0;c=k[e>>2]|0;if(c|0?(L=c+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[F+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[D>>2]|0)>0){d=k[B>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[D>>2]|0))}c=k[C>>2]|0;if((c|0)==(E|0)|(c|0)==0){r=G;return}ggb(k[c+-4>>2]|0);r=G;return}function R3a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;G=r;r=r+512|0;z=G+344|0;F=G+288|0;e=G;m=G+272|0;n=G+256|0;f=G+248|0;o=G+224|0;p=G+240|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=1124007936;c=e+16|0;d=e+48|0;h=e+12|0;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[d>>2]=c;c=e+56|0;k[e+52>>2]=c;k[e+60>>2]=0;k[c>>2]=0;k[e+64>>2]=1124007936;c=e+72|0;d=e+104|0;h=e+68|0;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[d>>2]=c;c=e+112|0;k[e+108>>2]=c;k[e+116>>2]=0;k[c>>2]=0;k[e+120>>2]=1124007936;c=e+128|0;d=e+160|0;h=e+124|0;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[d>>2]=c;h=e+168|0;k[e+164>>2]=h;l=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[z>>2]=1;k[z+4>>2]=3;j1(e,48,z,1);k[F>>2]=1124007936;D=F+4|0;c=F+8|0;B=F+40|0;h=D;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[B>>2]=c;E=F+48|0;C=F+44|0;k[C>>2]=E;k[F+52>>2]=0;k[E>>2]=0;A=k[e>>2]|0;dh[k[(k[A>>2]|0)+12>>2]&255](A,e,F,-1);XN(e);A=F+16|0;i[(k[A>>2]|0)+(k[k[C>>2]>>2]<<1)>>0]=1;i[(k[A>>2]|0)+(k[k[C>>2]>>2]|0)>>0]=-1;switch((k[a>>2]|0)>>>3&511){case 2:{k[z+8>>2]=0;k[z+12>>2]=0;k[z>>2]=16842752;k[z+4>>2]=a;y=m+4|0;x=y+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[y>>2]=b;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=F;k[f>>2]=-1;k[f+4>>2]=-1;fla(z,m,5,n,f,0.0,4);break}case 0:{k[z>>2]=1124007936;x=z+4|0;c=z+8|0;v=z+40|0;h=x;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[v>>2]=c;y=z+48|0;w=z+44|0;k[w>>2]=y;k[z+52>>2]=0;k[y>>2]=0;k[z+56>>2]=1124007936;t=z+60|0;c=z+64|0;q=z+96|0;h=t;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[q>>2]=c;u=z+104|0;s=z+100|0;k[s>>2]=u;k[z+108>>2]=0;k[u>>2]=0;k[z+112>>2]=1124007936;j=z+116|0;c=z+120|0;g=z+152|0;h=j;l=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(l|0));k[g>>2]=c;h=z+160|0;f=z+156|0;k[f>>2]=h;k[z+164>>2]=0;k[h>>2]=0;L=m+8|0;K=m+12|0;J=m+4|0;H=n+4|0;I=H+4|0;d=o+8|0;l=o+12|0;c=o+4|0;e=p+4|0;k[L>>2]=0;k[K>>2]=0;k[m>>2]=16842752;k[J>>2]=a;M=I;k[M>>2]=0;k[M+4>>2]=0;k[n>>2]=33619968;k[H>>2]=z;k[d>>2]=0;k[l>>2]=0;k[o>>2]=16842752;k[c>>2]=F;k[p>>2]=-1;k[e>>2]=-1;fla(m,n,5,o,p,0.0,4);k[L>>2]=0;k[K>>2]=0;k[m>>2]=16842752;k[J>>2]=a;M=I;k[M>>2]=0;k[M+4>>2]=0;k[n>>2]=33619968;k[H>>2]=z+56;k[d>>2]=0;k[l>>2]=0;k[o>>2]=16842752;k[c>>2]=F;k[p>>2]=-1;k[e>>2]=-1;fla(m,n,5,o,p,0.0,4);k[L>>2]=0;k[K>>2]=0;k[m>>2]=16842752;k[J>>2]=a;a=I;k[a>>2]=0;k[a+4>>2]=0;k[n>>2]=33619968;k[H>>2]=z+112;k[d>>2]=0;k[l>>2]=0;k[o>>2]=16842752;k[c>>2]=F;k[p>>2]=-1;k[e>>2]=-1;fla(m,n,5,o,p,0.0,4);e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=b;GV(z,3,m);e=z+148|0;c=k[e>>2]|0;if(c|0?(L=c+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[z+144>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;M=z+128|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[j>>2]|0)>0){d=k[g>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[j>>2]|0))}c=k[f>>2]|0;if(!((c|0)==(h|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=z+92|0;c=k[e>>2]|0;if(c|0?(L=c+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[z+88>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;M=z+72|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[t>>2]|0)>0){d=k[q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[t>>2]|0))}c=k[s>>2]|0;if(!((c|0)==(u|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=z+36|0;c=k[e>>2]|0;if(c|0?(L=c+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[z+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;M=z+16|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[x>>2]|0)>0){d=k[v>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[x>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(y|0)|(c|0)==0))ggb(k[c+-4>>2]|0);break}default:{}}e=F+36|0;c=k[e>>2]|0;if(c|0?(L=c+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[F+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[D>>2]|0)>0){d=k[B>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[D>>2]|0))}c=k[C>>2]|0;if((c|0)==(E|0)|(c|0)==0){r=G;return}ggb(k[c+-4>>2]|0);r=G;return}function S3a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0;fa=r;r=r+1632|0;M=fa+1120|0;N=fa+1568|0;h=fa+896|0;$=fa+1456|0;Z=fa+1400|0;u=fa+672|0;P=fa+224|0;B=fa+448|0;H=fa;O=fa+1344|0;I=a+8|0;f=k[I>>2]|0;J=a+12|0;g=(k[J>>2]<<1)+2|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=1124007936;d=h+16|0;e=h+48|0;v=h+12|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;d=h+56|0;k[h+52>>2]=d;k[h+60>>2]=0;k[d>>2]=0;k[h+64>>2]=1124007936;d=h+72|0;e=h+104|0;v=h+68|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;d=h+112|0;k[h+108>>2]=d;k[h+116>>2]=0;k[d>>2]=0;k[h+120>>2]=1124007936;d=h+128|0;e=h+160|0;v=h+124|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;v=h+168|0;k[h+164>>2]=v;w=v+56|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[M>>2]=g;k[M+4>>2]=f;j1(h,48,M,5);k[N>>2]=1124007936;ca=N+4|0;x=N+8|0;ba=N+40|0;v=ca;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[ba>>2]=x;ea=N+48|0;da=N+44|0;k[da>>2]=ea;k[N+52>>2]=0;k[ea>>2]=0;z=k[h>>2]|0;dh[k[(k[z>>2]|0)+12>>2]&255](z,h,N,-1);XN(h);z=c?7:4;d=k[J>>2]|0;f=k[I>>2]|0;k[Z>>2]=1;k[Z+4>>2]=0;k[Z+8>>2]=d;k[Z+12>>2]=f;I1($,N,Z);f=M+4|0;d=f+4|0;k[d>>2]=0;k[d+4>>2]=0;k[M>>2]=-1040121856;k[f>>2]=$;mY(a,M);f=$+36|0;d=k[f>>2]|0;if(d|0?(Y=d+12|0,_=k[Y>>2]|0,k[Y>>2]=_+-1,(_|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[$+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;_=$+16|0;e=$+4|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[e>>2]|0)>0){f=k[$+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[$+44>>2]|0;if(!((d|0)==($+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);g=k[I>>2]|0;_=N+16|0;if((g|0)>0){c=k[_>>2]|0;h=k[k[da>>2]>>2]|0;i=k[a+16>>2]|0;j=k[k[a+44>>2]>>2]|0;l=k[J>>2]|0;d=c;if((l|0)>0){f=0;do{m=c+(aa(h,f)|0)|0;n=i+(aa(j,f)|0)|0;e=0;do{o[m+(e+2+l<<2)>>2]=-+o[n+(l+~e<<2)>>2];e=e+1|0}while((e|0)!=(l|0));f=f+1|0}while((f|0)!=(g|0))}}else d=k[_>>2]|0;k[$>>2]=k[N>>2];V=$+4|0;e=k[ca>>2]|0;k[V>>2]=e;W=$+8|0;k[W>>2]=k[x>>2];p=N+12|0;k[$+12>>2]=k[p>>2];T=$+16|0;k[T>>2]=d;q=N+20|0;k[$+20>>2]=k[q>>2];s=N+24|0;k[$+24>>2]=k[s>>2];t=N+28|0;k[$+28>>2]=k[t>>2];Q=$+32|0;X=N+32|0;k[Q>>2]=k[X>>2];R=$+36|0;Y=N+36|0;d=k[Y>>2]|0;k[R>>2]=d;S=$+40|0;k[S>>2]=W;W=$+48|0;U=$+44|0;k[U>>2]=W;k[$+52>>2]=0;k[W>>2]=0;if(!d)d=e;else{d=d+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[ca>>2]|0}if((d|0)>=3){k[V>>2]=0;x1($,d,0,0,0);if((k[V>>2]|0)>0){e=k[ba>>2]|0;f=k[S>>2]|0;g=k[da>>2]|0;c=k[U>>2]|0;d=0;do{k[f+(d<<2)>>2]=k[e+(d<<2)>>2];k[c+(d<<2)>>2]=k[g+(d<<2)>>2];d=d+1|0}while((d|0)<(k[V>>2]|0))}}else{K=k[da>>2]|0;L=k[U>>2]|0;k[L>>2]=k[K>>2];k[L+4>>2]=k[K+4>>2]}c=$+56|0;g=k[ba>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=1124007936;d=u+16|0;e=u+48|0;v=u+12|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;d=u+56|0;k[u+52>>2]=d;k[u+60>>2]=0;k[d>>2]=0;k[u+64>>2]=1124007936;d=u+72|0;e=u+104|0;v=u+68|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;d=u+112|0;k[u+108>>2]=d;k[u+116>>2]=0;k[d>>2]=0;k[u+120>>2]=1124007936;d=u+128|0;e=u+160|0;v=u+124|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;v=u+168|0;k[u+164>>2]=v;w=v+56|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[M>>2]=f;k[M+4>>2]=g;j1(u,48,M,5);k[c>>2]=1124007936;K=$+60|0;d=$+64|0;F=$+96|0;v=K;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[F>>2]=d;L=$+104|0;G=$+100|0;k[G>>2]=L;k[$+108>>2]=0;k[L>>2]=0;D=k[u>>2]|0;dh[k[(k[D>>2]|0)+12>>2]&255](D,u,c,-1);XN(u);k[Z>>2]=1124007936;D=Z+4|0;d=Z+8|0;A=Z+40|0;v=D;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[A>>2]=d;E=Z+48|0;C=Z+44|0;k[C>>2]=E;k[Z+52>>2]=0;k[E>>2]=0;f=M+4|0;g=f+4|0;k[g>>2]=0;k[g+4>>2]=0;k[M>>2]=33619968;k[f>>2]=Z;GV($,2,M);k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=16842752;k[M+4>>2]=Z;f=P+4|0;g=f+4|0;k[g>>2]=0;k[g+4>>2]=0;k[P>>2]=33619968;k[f>>2]=Z;bZ(M,P,z,0);EV(Z,$);f=k[J>>2]|0;g=(k[I>>2]<<1)+2|0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=1124007936;d=P+16|0;e=P+48|0;v=P+12|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;d=P+56|0;k[P+52>>2]=d;k[P+60>>2]=0;k[d>>2]=0;k[P+64>>2]=1124007936;d=P+72|0;e=P+104|0;v=P+68|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;d=P+112|0;k[P+108>>2]=d;k[P+116>>2]=0;k[d>>2]=0;k[P+120>>2]=1124007936;d=P+128|0;e=P+160|0;v=P+124|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;v=P+168|0;k[P+164>>2]=v;w=v+56|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[M>>2]=g;k[M+4>>2]=f;j1(P,48,M,5);c=k[P>>2]|0;dh[k[(k[c>>2]|0)+12>>2]&255](c,P,N,-1);XN(P);c=k[J>>2]|0;if((c|0)>0){h=k[_>>2]|0;i=k[k[da>>2]>>2]|0;j=k[I>>2]|0;l=k[$+72>>2]|0;m=k[p>>2]|0;e=h;if((j|0)>0){g=k[k[G>>2]>>2]|0;f=0;do{n=h+(aa(i,f)|0)|0;f=f+1|0;d=0;do{y=l+(aa(g,d)|0)+(f<<2)|0;ga=+o[y>>2];y=d;d=d+1|0;o[n+(d<<2)>>2]=ga;o[n+(m+~y<<2)>>2]=-ga}while((d|0)!=(j|0))}while((f|0)!=(c|0))}}else e=k[_>>2]|0;k[P>>2]=k[N>>2];y=P+4|0;d=k[ca>>2]|0;k[y>>2]=d;w=P+8|0;k[w>>2]=k[x>>2];k[P+12>>2]=k[p>>2];u=P+16|0;k[u>>2]=e;k[P+20>>2]=k[q>>2];k[P+24>>2]=k[s>>2];k[P+28>>2]=k[t>>2];m=P+32|0;k[m>>2]=k[X>>2];n=P+36|0;e=k[Y>>2]|0;k[n>>2]=e;p=P+40|0;k[p>>2]=w;s=P+48|0;q=P+44|0;k[q>>2]=s;k[P+52>>2]=0;k[s>>2]=0;if(e){d=e+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[ca>>2]|0}if((d|0)>=3){k[y>>2]=0;x1(P,d,0,0,0);if((k[y>>2]|0)>0){e=k[ba>>2]|0;f=k[p>>2]|0;g=k[da>>2]|0;c=k[q>>2]|0;d=0;do{k[f+(d<<2)>>2]=k[e+(d<<2)>>2];k[c+(d<<2)>>2]=k[g+(d<<2)>>2];d=d+1|0}while((d|0)<(k[y>>2]|0))}}else{w=k[da>>2]|0;x=k[q>>2]|0;k[x>>2]=k[w>>2];k[x+4>>2]=k[w+4>>2]}c=P+56|0;g=k[ba>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=1124007936;d=B+16|0;e=B+48|0;v=B+12|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;d=B+56|0;k[B+52>>2]=d;k[B+60>>2]=0;k[d>>2]=0;k[B+64>>2]=1124007936;d=B+72|0;e=B+104|0;v=B+68|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;d=B+112|0;k[B+108>>2]=d;k[B+116>>2]=0;k[d>>2]=0;k[B+120>>2]=1124007936;d=B+128|0;e=B+160|0;v=B+124|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;v=B+168|0;k[B+164>>2]=v;w=v+56|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[M>>2]=f;k[M+4>>2]=g;j1(B,48,M,5);k[c>>2]=1124007936;j=P+60|0;d=P+64|0;h=P+96|0;v=j;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[h>>2]=d;l=P+104|0;i=P+100|0;k[i>>2]=l;k[P+108>>2]=0;k[l>>2]=0;d=k[B>>2]|0;dh[k[(k[d>>2]|0)+12>>2]&255](d,B,c,-1);XN(B);d=M+4|0;e=d+4|0;k[e>>2]=0;k[e+4>>2]=0;k[M>>2]=33619968;k[d>>2]=Z;GV(P,2,M);k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=16842752;k[M+4>>2]=Z;d=H+4|0;e=d+4|0;k[e>>2]=0;k[e+4>>2]=0;k[H>>2]=33619968;k[d>>2]=Z;bZ(M,H,z,0);EV(Z,P);k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=1124007936;d=M+16|0;e=M+48|0;v=M+12|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;d=M+56|0;k[M+52>>2]=d;k[M+60>>2]=0;k[d>>2]=0;k[M+64>>2]=1124007936;d=M+72|0;e=M+104|0;v=M+68|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;d=M+112|0;k[M+108>>2]=d;k[M+116>>2]=0;k[d>>2]=0;k[M+120>>2]=1124007936;d=M+128|0;e=M+160|0;v=M+124|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;v=M+168|0;k[M+164>>2]=v;w=v+56|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));y0(M,c,1.0);g=k[M>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,M,N,-1);XN(M);g=k[a+40>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=1124007936;d=H+16|0;e=H+48|0;v=H+12|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;d=H+56|0;k[H+52>>2]=d;k[H+60>>2]=0;k[d>>2]=0;k[H+64>>2]=1124007936;d=H+72|0;e=H+104|0;v=H+68|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;d=H+112|0;k[H+108>>2]=d;k[H+116>>2]=0;k[d>>2]=0;k[H+120>>2]=1124007936;d=H+128|0;e=H+160|0;v=H+124|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=d;v=H+168|0;k[H+164>>2]=v;w=v+56|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[M>>2]=f;k[M+4>>2]=g;j1(H,48,M,5);d=k[H>>2]|0;dh[k[(k[d>>2]|0)+12>>2]&255](d,H,b,-1);XN(H);d=k[J>>2]|0;f=k[I>>2]|0;k[M>>2]=0;k[M+4>>2]=1;k[M+8>>2]=d;k[M+12>>2]=f;I1(O,N,M);f=H+4|0;d=f+4|0;k[d>>2]=0;k[d+4>>2]=0;k[H>>2]=33619968;k[f>>2]=b;mY(O,H);f=O+36|0;d=k[f>>2]|0;if(d|0?(M=d+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[O+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;N=O+16|0;e=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[e>>2]|0)>0){f=k[O+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[O+44>>2]|0;if(!((d|0)==(O+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=P+92|0;d=k[f>>2]|0;if(d|0?(N=d+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[P+88>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;P=P+72|0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[j>>2]|0)>0){e=k[h>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[i>>2]|0;if(!((d|0)==(l|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[n>>2]|0;if(d|0?(O=d+12|0,P=k[O>>2]|0,k[O>>2]=P+-1,(P|0)==1):0){e=k[n>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[m>>2]|0;if(d|0)break;d=B1()|0;e=k[n>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[n>>2]=0}k[n>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[y>>2]|0)>0){e=k[p>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[y>>2]|0))}d=k[q>>2]|0;if(!((d|0)==(s|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=Z+36|0;d=k[f>>2]|0;do if(d|0){O=d+12|0;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1)break;e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[Z+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}while(0);k[f>>2]=0;Z=Z+16|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[D>>2]|0)>0){e=k[A>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[D>>2]|0))}d=k[C>>2]|0;if(!((d|0)==(E|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=$+92|0;d=k[f>>2]|0;do if(d|0){P=d+12|0;Z=k[P>>2]|0;k[P>>2]=Z+-1;if((Z|0)!=1)break;e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[$+88>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}while(0);k[f>>2]=0;$=$+72|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[K>>2]|0)>0){e=k[F>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[K>>2]|0))}d=k[G>>2]|0;if(!((d|0)==(L|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[R>>2]|0;do if(d|0){Z=d+12|0;$=k[Z>>2]|0;k[Z>>2]=$+-1;if(($|0)!=1)break;e=k[R>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[Q>>2]|0;if(d|0)break;d=B1()|0;e=k[R>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[R>>2]=0}while(0);k[R>>2]=0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[V>>2]|0)>0){e=k[S>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[V>>2]|0))}d=k[U>>2]|0;if(!((d|0)==(W|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[Y>>2]|0;do if(d|0){Z=d+12|0;$=k[Z>>2]|0;k[Z>>2]=$+-1;if(($|0)!=1)break;e=k[Y>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[X>>2]|0;if(d|0)break;d=B1()|0;e=k[Y>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[Y>>2]=0}while(0);k[Y>>2]=0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[ca>>2]|0)>0){e=k[ba>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[ca>>2]|0))}d=k[da>>2]|0;if((d|0)==(ea|0)|(d|0)==0){r=fa;return}ggb(k[d+-4>>2]|0);r=fa;return}function T3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0.0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;U=r;r=r+640|0;D=U+504|0;Q=U+560|0;O=U+280|0;j=U+624|0;l=U+616|0;K=U+224|0;I=U;n=b+12|0;p=k[n>>2]|0;s=b+8|0;q=k[s>>2]|0;h=k[b+40>>2]|0;g=k[h+4>>2]|0;h=k[h>>2]|0;k[Q>>2]=1124007936;S=Q+4|0;f=Q+8|0;P=Q+40|0;t=S;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[P>>2]=f;T=Q+48|0;R=Q+44|0;k[R>>2]=T;k[Q+52>>2]=0;k[T>>2]=0;k[D>>2]=h;k[D+4>>2]=g;G1(Q,2,D,5);k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=1124007936;f=O+16|0;g=O+48|0;t=O+12|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[g>>2]=f;f=O+56|0;k[O+52>>2]=f;k[O+60>>2]=0;k[f>>2]=0;k[O+64>>2]=1124007936;f=O+72|0;g=O+104|0;t=O+68|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[g>>2]=f;f=O+112|0;k[O+108>>2]=f;k[O+116>>2]=0;k[f>>2]=0;k[O+120>>2]=1124007936;f=O+128|0;g=O+160|0;t=O+124|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[g>>2]=f;t=O+168|0;k[O+164>>2]=t;u=t+56|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;G0(O,c,d,1.0,1.0,D);M=k[O>>2]|0;dh[k[(k[M>>2]|0)+12>>2]&255](M,O,Q,-1);XN(O);k[O>>2]=1124007936;M=O+4|0;f=O+8|0;J=O+40|0;t=M;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[J>>2]=f;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;G=D+4|0;f=G+4|0;k[f>>2]=0;k[f+4>>2]=0;k[D>>2]=33619968;k[G>>2]=O;mY(b,D);G=D+4|0;f=G+4|0;k[f>>2]=0;k[f+4>>2]=0;k[D>>2]=50397184;k[G>>2]=O;k[j>>2]=1;k[j+4>>2]=1;G=(k[s>>2]|0)+-2|0;k[l>>2]=(k[n>>2]|0)+-2;k[l+4>>2]=G;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;k[K+16>>2]=0;k[K+20>>2]=0;k[K+24>>2]=0;k[K+28>>2]=0;Yfa(D,j,l,K,-1,8,0);k[K>>2]=1124007936;G=K+4|0;f=K+8|0;E=K+40|0;t=G;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[E>>2]=f;H=K+48|0;F=K+44|0;k[F>>2]=H;k[K+52>>2]=0;k[H>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=O;f=I+4|0;g=f+4|0;k[g>>2]=0;k[g+4>>2]=0;k[I>>2]=33619968;k[f>>2]=K;vfa(D,I,5,1,1.0,0.0,4);k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=1124007936;f=I+16|0;g=I+48|0;t=I+12|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[g>>2]=f;f=I+56|0;k[I+52>>2]=f;k[I+60>>2]=0;k[f>>2]=0;k[I+64>>2]=1124007936;f=I+72|0;g=I+104|0;t=I+68|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[g>>2]=f;f=I+112|0;k[I+108>>2]=f;k[I+116>>2]=0;k[f>>2]=0;k[I+120>>2]=1124007936;f=I+128|0;g=I+160|0;t=I+124|0;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[g>>2]=f;t=I+168|0;k[I+164>>2]=t;u=t+56|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;G0(I,Q,K,1.0,-1.0,D);y=k[I>>2]|0;dh[k[(k[y>>2]|0)+12>>2]&255](y,I,K,-1);XN(I);k[D>>2]=1;k[D+4>>2]=1;k[D+8>>2]=p+-2;k[D+12>>2]=q+-2;I1(I,K,D);y=k[n>>2]|0;n=k[s>>2]|0;k[D>>2]=1124007936;C=D+4|0;f=D+8|0;A=D+40|0;t=C;u=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(u|0));k[A>>2]=f;B=D+48|0;z=D+44|0;k[z>>2]=B;k[D+52>>2]=0;k[B>>2]=0;S3a(I,D,0);l=n+-2|0;if((n|0)>2?(v=k[D+16>>2]|0,w=k[k[z>>2]>>2]|0,x=y+-2|0,(y|0)>2):0){j=k[a+372>>2]|0;h=k[a+384>>2]|0;f=0;do{c=v+(aa(w,f)|0)|0;d=h+(f<<2)|0;g=0;do{a=c+(g<<2)|0;o[a>>2]=+o[a>>2]/(+o[j+(g<<2)>>2]+ +o[d>>2]+-4.0);g=g+1|0}while((g|0)!=(x|0));f=f+1|0}while((f|0)!=(l|0))}S3a(D,I,1);s=e+16|0;p=e+44|0;u=b+16|0;t=b+44|0;a=(y|0)>0;if(a){f=0;do{i[(k[s>>2]|0)+f>>0]=i[(k[u>>2]|0)+f>>0]|0;f=f+1|0}while((f|0)!=(y|0))}q=n+-1|0;f=k[s>>2]|0;g=k[k[p>>2]>>2]|0;a:do if((q|0)>1){j=I+16|0;l=I+44|0;n=y+-1|0;if((n|0)>1)d=1;else{h=1;while(1){f=f+(aa(g,h)|0)|0;g=(k[u>>2]|0)+(aa(k[k[t>>2]>>2]|0,h)|0)|0;i[f>>0]=i[g>>0]|0;i[f+n>>0]=i[g+n>>0]|0;h=h+1|0;f=k[s>>2]|0;g=k[k[p>>2]>>2]|0;if((h|0)==(q|0))break a}}do{g=f+(aa(g,d)|0)|0;h=(k[u>>2]|0)+(aa(k[k[t>>2]>>2]|0,d)|0)|0;c=(k[j>>2]|0)+(aa(k[k[l>>2]>>2]|0,d+-1|0)|0)|0;i[g>>0]=i[h>>0]|0;f=1;do{m=+o[c+(f+-1<<2)>>2];do if(!(m<0.0))if(m>255.0){i[g+f>>0]=-1;break}else{i[g+f>>0]=~~m;break}else i[g+f>>0]=0;while(0);f=f+1|0}while((f|0)!=(n|0));i[g+n>>0]=i[h+n>>0]|0;d=d+1|0;f=k[s>>2]|0;g=k[k[p>>2]>>2]|0}while((d|0)!=(q|0))}while(0);h=f+(aa(g,q)|0)|0;g=(k[u>>2]|0)+(aa(k[k[t>>2]>>2]|0,q)|0)|0;if(a){f=0;do{i[h+f>>0]=i[g+f>>0]|0;f=f+1|0}while((f|0)!=(y|0))}h=D+36|0;f=k[h>>2]|0;if(f|0?(b=f+12|0,y=k[b>>2]|0,k[b>>2]=y+-1,(y|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[D+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[C>>2]|0)>0){g=k[A>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[C>>2]|0))}f=k[z>>2]|0;if(!((f|0)==(B|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=I+36|0;f=k[h>>2]|0;if(f|0?(C=f+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[I+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;D=I+16|0;g=I+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[g>>2]|0)>0){h=k[I+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[I+44>>2]|0;if(!((f|0)==(I+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=K+36|0;f=k[h>>2]|0;if(f|0?(D=f+12|0,I=k[D>>2]|0,k[D>>2]=I+-1,(I|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[K+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;K=K+16|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[G>>2]|0)>0){g=k[E>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[G>>2]|0))}f=k[F>>2]|0;if(!((f|0)==(H|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=O+36|0;f=k[h>>2]|0;if(f|0?(I=f+12|0,K=k[I>>2]|0,k[I>>2]=K+-1,(K|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[O+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){g=k[J>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[M>>2]|0))}f=k[L>>2]|0;if(!((f|0)==(N|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=Q+36|0;f=k[h>>2]|0;if(f|0?(N=f+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[Q+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Q=Q+16|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[S>>2]|0)>0){g=k[P>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[S>>2]|0))}f=k[R>>2]|0;if((f|0)==(T|0)|(f|0)==0){r=U;return}ggb(k[f+-4>>2]|0);r=U;return}function U3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0.0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;F=r;r=r+176|0;z=F+152|0;E=F+96|0;A=F+32|0;B=F+80|0;C=F+64|0;D=F;y=a+36|0;n=b+40|0;f=k[n>>2]|0;g=k[f+4>>2]|0;f=k[f>>2]|0;k[E>>2]=1124007936;m=E+4|0;e=E+8|0;j=E+40|0;q=m;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[j>>2]=e;l=E+48|0;i=E+44|0;k[i>>2]=l;k[E+52>>2]=0;k[l>>2]=0;k[z>>2]=f;w=z+4|0;k[w>>2]=g;G1(E,2,z,21);KG(y,E)|0;g=E+36|0;e=k[g>>2]|0;if(e|0?(v=e+12|0,x=k[v>>2]|0,k[v>>2]=x+-1,(x|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[E+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;x=E+16|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[m>>2]|0)>0){f=k[j>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[m>>2]|0))}e=k[i>>2]|0;if(!((e|0)==(l|0)|(e|0)==0))ggb(k[e+-4>>2]|0);x=a+92|0;g=k[n>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[E>>2]=1124007936;m=E+4|0;e=E+8|0;j=E+40|0;q=m;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[j>>2]=e;l=E+48|0;i=E+44|0;k[i>>2]=l;k[E+52>>2]=0;k[l>>2]=0;k[z>>2]=g;k[w>>2]=f;G1(E,2,z,21);KG(x,E)|0;g=E+36|0;e=k[g>>2]|0;if(e|0?(u=e+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[E+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;v=E+16|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[m>>2]|0)>0){f=k[j>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[m>>2]|0))}e=k[i>>2]|0;if(!((e|0)==(l|0)|(e|0)==0))ggb(k[e+-4>>2]|0);v=a+148|0;g=k[n>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[E>>2]=1124007936;m=E+4|0;e=E+8|0;j=E+40|0;q=m;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[j>>2]=e;l=E+48|0;i=E+44|0;k[i>>2]=l;k[E+52>>2]=0;k[l>>2]=0;k[z>>2]=g;k[w>>2]=f;G1(E,2,z,21);KG(v,E)|0;g=E+36|0;e=k[g>>2]|0;if(e|0?(t=e+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[E+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;u=E+16|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[m>>2]|0)>0){f=k[j>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[m>>2]|0))}e=k[i>>2]|0;if(!((e|0)==(l|0)|(e|0)==0))ggb(k[e+-4>>2]|0);u=a+204|0;g=k[n>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[E>>2]=1124007936;m=E+4|0;e=E+8|0;j=E+40|0;q=m;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[j>>2]=e;l=E+48|0;i=E+44|0;k[i>>2]=l;k[E+52>>2]=0;k[l>>2]=0;k[z>>2]=g;k[w>>2]=f;G1(E,2,z,21);KG(u,E)|0;g=E+36|0;e=k[g>>2]|0;if(e|0?(s=e+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[E+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;t=E+16|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[m>>2]|0)>0){f=k[j>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[m>>2]|0))}e=k[i>>2]|0;if(!((e|0)==(l|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=a+260|0;n=d+40|0;g=k[n>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[E>>2]=1124007936;m=E+4|0;e=E+8|0;j=E+40|0;q=m;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[j>>2]=e;l=E+48|0;i=E+44|0;k[i>>2]=l;k[E+52>>2]=0;k[l>>2]=0;k[z>>2]=g;k[w>>2]=f;G1(E,2,z,5);KG(t,E)|0;g=E+36|0;e=k[g>>2]|0;if(e|0?(q=e+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[E+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;s=E+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[m>>2]|0)>0){f=k[j>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[m>>2]|0))}e=k[i>>2]|0;if(!((e|0)==(l|0)|(e|0)==0))ggb(k[e+-4>>2]|0);i=a+316|0;g=k[n>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[E>>2]=1124007936;n=E+4|0;e=E+8|0;l=E+40|0;q=n;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[l>>2]=e;m=E+48|0;j=E+44|0;k[j>>2]=m;k[E+52>>2]=0;k[m>>2]=0;k[z>>2]=g;k[w>>2]=f;G1(E,2,z,5);KG(i,E)|0;g=E+36|0;e=k[g>>2]|0;if(e|0?(s=e+12|0,w=k[s>>2]|0,k[s>>2]=w+-1,(w|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[E+32>>2]|0;if(e|0)break;e=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;w=E+16|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[n>>2]|0)>0){f=k[l>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[n>>2]|0))}e=k[j>>2]|0;if(!((e|0)==(m|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=k[b+12>>2]|0;l=a+372|0;m=g+-2|0;i=a+376|0;j=k[i>>2]|0;f=k[l>>2]|0;e=j-f>>2;do if(m>>>0>e>>>0)FEa(l,m-e|0);else{if(m>>>0>=e>>>0)break;e=f+(m<<2)|0;if((j|0)==(e|0))break;k[i>>2]=j+(~((j+-4-e|0)>>>2)<<2)}while(0);if((g|0)>2){h=+(g+-1|0);f=k[l>>2]|0;e=0;do{w=e;e=e+1|0;G=+S(+(+(e|0)*3.1415927410125732/h))*2.0;o[f+(w<<2)>>2]=G}while((e|0)!=(m|0))}j=k[b+8>>2]|0;l=a+384|0;m=j+-2|0;g=a+388|0;i=k[g>>2]|0;f=k[l>>2]|0;e=i-f>>2;do if(m>>>0>e>>>0)FEa(l,m-e|0);else{if(m>>>0>=e>>>0)break;e=f+(m<<2)|0;if((i|0)==(e|0))break;k[g>>2]=i+(~((i+-4-e|0)>>>2)<<2)}while(0);if((j|0)>2){h=+(j+-1|0);f=k[l>>2]|0;e=0;do{a=e;e=e+1|0;G=+S(+(+(e|0)*3.1415927410125732/h))*2.0;o[f+(a<<2)>>2]=G}while((e|0)!=(m|0))}Q3a(b,y);R3a(b,x);Q3a(c,v);R3a(c,u);k[E>>2]=1124007936;m=E+4|0;e=E+8|0;j=E+40|0;q=m;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[j>>2]=e;l=E+48|0;i=E+44|0;k[i>>2]=l;k[E+52>>2]=0;k[l>>2]=0;k[z>>2]=3;k[z+4>>2]=3;G1(E,2,z,0);p[A>>3]=1.0;g=A+8|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g+16>>2]=0;k[g+20>>2]=0;k[z>>2]=-1056833530;k[z+4>>2]=A;k[z+8>>2]=1;k[z+12>>2]=4;pY(E,z,49332);k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=16842752;k[A+4>>2]=d;g=B+4|0;e=g+4|0;k[e>>2]=0;k[e+4>>2]=0;k[B>>2]=-1040121856;k[g>>2]=d;k[C+8>>2]=0;k[C+12>>2]=0;k[C>>2]=16842752;k[C+4>>2]=E;p[D>>3]=1797693134862315708145274.0e284;p[D+8>>3]=1797693134862315708145274.0e284;p[D+16>>3]=1797693134862315708145274.0e284;p[D+24>>3]=1797693134862315708145274.0e284;k[z>>2]=-1;k[z+4>>2]=-1;Dra(0,A,B,C,z,3,0,D);g=z+4|0;e=g+4|0;k[e>>2]=0;k[e+4>>2]=0;k[z>>2]=33619968;k[g>>2]=t;SW(d,z,5,.00392156862745098,0.0);g=E+36|0;e=k[g>>2]|0;do if(e|0){C=e+12|0;D=k[C>>2]|0;k[C>>2]=D+-1;if((D|0)!=1)break;f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[E+32>>2]|0;if(e|0)break;e=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}while(0);k[g>>2]=0;E=E+16|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[m>>2]|0)>0){f=k[j>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[m>>2]|0))}e=k[i>>2]|0;if((e|0)==(l|0)|(e|0)==0){r=F;return}ggb(k[e+-4>>2]|0);r=F;return}function V3a(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;e=r;r=r+96|0;g=e+8|0;f=e+72|0;j=e+56|0;h=e+40|0;l=e;i=e+24|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;m=j+4|0;n=m+4|0;k[n>>2]=0;k[n+4>>2]=0;k[j>>2]=33882112;k[m>>2]=f;FV(g,j);m=(k[f>>2]|0)+112|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=m;p[l>>3]=b;k[h>>2]=-1056833530;k[h+4>>2]=l;k[h+8>>2]=1;k[h+12>>2]=1;n=i+4|0;o=n+4|0;k[o>>2]=0;k[o+4>>2]=0;k[i>>2]=33619968;k[n>>2]=m;p[g>>3]=1.0;sU(j,h,i,49332,-1,40032,1,g);n=(k[f>>2]|0)+56|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=n;p[l>>3]=c;k[h>>2]=-1056833530;k[h+4>>2]=l;k[h+8>>2]=1;k[h+12>>2]=1;m=i+4|0;o=m+4|0;k[o>>2]=0;k[o+4>>2]=0;k[i>>2]=33619968;k[m>>2]=n;p[g>>3]=1.0;sU(j,h,i,49332,-1,40032,1,g);m=k[f>>2]|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=m;p[l>>3]=d;k[h>>2]=-1056833530;k[h+4>>2]=l;k[h+8>>2]=1;k[h+12>>2]=1;l=i+4|0;n=l+4|0;k[n>>2]=0;k[n+4>>2]=0;k[i>>2]=33619968;k[l>>2]=m;p[g>>3]=1.0;sU(j,h,i,49332,-1,40032,1,g);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=17104896;k[j+4>>2]=f;i=h+4|0;l=i+4|0;k[l>>2]=0;k[l+4>>2]=0;k[h>>2]=33619968;k[i>>2]=a;k[g>>2]=0;i=g+4|0;k[i>>2]=0;k[g+8>>2]=0;B2(j,g);a=k[g>>2]|0;i=k[i>>2]|0;GV((a|0)==(i|0)?0:a,(i-a|0)/56|0,h);zF(g);zF(f);r=e;return}function W3a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0;d=r;r=r+96|0;g=d;e=d+76|0;f=d+64|0;i=d+48|0;h=d+32|0;j=d+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;u=i+4|0;t=u+4|0;k[t>>2]=0;k[t+4>>2]=0;k[i>>2]=33882112;k[u>>2]=e;FV(g,i);k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=c;u=i+4|0;t=u+4|0;k[t>>2]=0;k[t+4>>2]=0;k[i>>2]=33882112;k[u>>2]=f;FV(g,i);u=i+8|0;t=i+12|0;q=i+4|0;o=h+8|0;n=h+12|0;m=h+4|0;a=j+4|0;l=a+4|0;s=k[e>>2]|0;k[u>>2]=0;k[t>>2]=0;k[i>>2]=16842752;k[q>>2]=s;k[o>>2]=0;k[n>>2]=0;k[h>>2]=16842752;k[m>>2]=b;s=k[f>>2]|0;v=l;k[v>>2]=0;k[v+4>>2]=0;k[j>>2]=33619968;k[a>>2]=s;p[g>>3]=1.0;sU(i,h,j,49332,-1,40032,1,g);s=(k[e>>2]|0)+56|0;k[u>>2]=0;k[t>>2]=0;k[i>>2]=16842752;k[q>>2]=s;k[o>>2]=0;k[n>>2]=0;k[h>>2]=16842752;k[m>>2]=b;s=(k[f>>2]|0)+56|0;v=l;k[v>>2]=0;k[v+4>>2]=0;k[j>>2]=33619968;k[a>>2]=s;p[g>>3]=1.0;sU(i,h,j,49332,-1,40032,1,g);s=(k[e>>2]|0)+112|0;k[u>>2]=0;k[t>>2]=0;k[i>>2]=16842752;k[q>>2]=s;k[o>>2]=0;k[n>>2]=0;k[h>>2]=16842752;k[m>>2]=b;b=(k[f>>2]|0)+112|0;k[l>>2]=0;k[l+4>>2]=0;k[j>>2]=33619968;k[a>>2]=b;p[g>>3]=1.0;sU(i,h,j,49332,-1,40032,1,g);k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=17104896;k[i+4>>2]=f;b=h+4|0;a=b+4|0;k[a>>2]=0;k[a+4>>2]=0;k[h>>2]=33619968;k[b>>2]=c;k[g>>2]=0;b=g+4|0;k[b>>2]=0;k[g+8>>2]=0;B2(i,g);c=k[g>>2]|0;b=k[b>>2]|0;GV((c|0)==(b|0)?0:c,(b-c|0)/56|0,h);zF(g);zF(f);zF(e);r=d;return}function X3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=r;r=r+640|0;D=G+448|0;E=G+224|0;F=G;p=G+616|0;q=G+600|0;s=G+592|0;z=G+536|0;x=G+480|0;k[E+8>>2]=0;k[E+12>>2]=0;k[E>>2]=16842752;k[E+4>>2]=c;f=F+4|0;j=f+4|0;k[j>>2]=0;k[j+4>>2]=0;k[F>>2]=-1040121856;k[f>>2]=c;k[D>>2]=99;aU(E,E,F,49332,D,1,12);f=a+316|0;j=D+4|0;l=j+4|0;k[l>>2]=0;k[l+4>>2]=0;k[D>>2]=33619968;k[j>>2]=f;SW(c,D,5,.00392156862745098,0.0);j=a+36|0;W3a(j,f,j);l=a+92|0;W3a(l,f,l);f=b+40|0;e=k[f>>2]|0;g=k[e+4>>2]|0;e=k[e>>2]|0;k[z>>2]=1124007936;B=z+4|0;c=z+8|0;y=z+40|0;n=B;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[y>>2]=c;C=z+48|0;A=z+44|0;k[A>>2]=C;k[z+52>>2]=0;k[C>>2]=0;k[D>>2]=e;h=D+4|0;k[h>>2]=g;G1(z,2,D,21);f=k[f>>2]|0;e=k[f+4>>2]|0;f=k[f>>2]|0;k[x>>2]=1124007936;v=x+4|0;c=x+8|0;t=x+40|0;n=v;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[t>>2]=c;w=x+48|0;u=x+44|0;k[u>>2]=w;k[x+52>>2]=0;k[w>>2]=0;k[D>>2]=f;k[h>>2]=e;G1(x,2,D,21);f=a+148|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=1124007936;c=E+16|0;e=E+48|0;n=E+12|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=c;c=E+56|0;k[E+52>>2]=c;k[E+60>>2]=0;k[c>>2]=0;k[E+64>>2]=1124007936;c=E+72|0;e=E+104|0;n=E+68|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=c;c=E+112|0;k[E+108>>2]=c;k[E+116>>2]=0;k[c>>2]=0;k[E+120>>2]=1124007936;c=E+128|0;e=E+160|0;n=E+124|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=c;n=E+168|0;k[E+164>>2]=n;o=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;G0(E,j,f,1.0,1.0,D);f=k[E>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,E,z,-1);XN(E);f=a+204|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=1124007936;c=E+16|0;e=E+48|0;n=E+12|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=c;c=E+56|0;k[E+52>>2]=c;k[E+60>>2]=0;k[c>>2]=0;k[E+64>>2]=1124007936;c=E+72|0;e=E+104|0;n=E+68|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=c;c=E+112|0;k[E+108>>2]=c;k[E+116>>2]=0;k[c>>2]=0;k[E+120>>2]=1124007936;c=E+128|0;e=E+160|0;n=E+124|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=c;n=E+168|0;k[E+164>>2]=n;o=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;G0(E,l,f,1.0,1.0,D);c=k[E>>2]|0;dh[k[(k[c>>2]|0)+12>>2]&255](c,E,x,-1);XN(E);k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=1124007936;c=F+16|0;e=F+48|0;n=F+12|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=c;c=F+56|0;k[F+52>>2]=c;k[F+60>>2]=0;k[c>>2]=0;k[F+64>>2]=1124007936;c=F+72|0;e=F+104|0;n=F+68|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=c;c=F+112|0;k[F+108>>2]=c;k[F+116>>2]=0;k[c>>2]=0;k[F+120>>2]=1124007936;c=F+128|0;e=F+160|0;n=F+124|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=c;n=F+168|0;k[F+164>>2]=n;o=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[D>>2]=3;k[D+4>>2]=1;j1(F,48,D,1);k[E>>2]=1124007936;m=E+4|0;c=E+8|0;j=E+40|0;n=m;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[j>>2]=c;l=E+48|0;h=E+44|0;k[h>>2]=l;k[E+52>>2]=0;k[l>>2]=0;f=k[F>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,F,E,-1);XN(F);f=E+16|0;i[k[f>>2]>>0]=-1;i[(k[f>>2]|0)+1>>0]=1;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=z;g=p+4|0;c=g+4|0;k[c>>2]=0;k[c+4>>2]=0;k[p>>2]=33619968;k[g>>2]=z;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=E;k[s>>2]=-1;k[s+4>>2]=-1;fla(D,p,5,q,s,0.0,4);g=E+36|0;c=k[g>>2]|0;if(c|0?(n=c+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){e=k[g>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[E+32>>2]|0;if(!c){c=B1()|0;e=k[g>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[g>>2]=0}k[g>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[m>>2]|0)>0){e=k[j>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[m>>2]|0))}c=k[h>>2]|0;if(!((c|0)==(l|0)|(c|0)==0))ggb(k[c+-4>>2]|0);k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=1124007936;c=F+16|0;e=F+48|0;n=F+12|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=c;c=F+56|0;k[F+52>>2]=c;k[F+60>>2]=0;k[c>>2]=0;k[F+64>>2]=1124007936;c=F+72|0;e=F+104|0;n=F+68|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=c;c=F+112|0;k[F+108>>2]=c;k[F+116>>2]=0;k[c>>2]=0;k[F+120>>2]=1124007936;c=F+128|0;e=F+160|0;n=F+124|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[e>>2]=c;n=F+168|0;k[F+164>>2]=n;o=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[D>>2]=1;k[D+4>>2]=3;j1(F,48,D,1);k[E>>2]=1124007936;m=E+4|0;c=E+8|0;j=E+40|0;n=m;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[j>>2]=c;l=E+48|0;h=E+44|0;k[h>>2]=l;k[E+52>>2]=0;k[l>>2]=0;g=k[F>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,F,E,-1);XN(F);g=E+16|0;i[k[g>>2]>>0]=-1;i[(k[g>>2]|0)+(k[k[h>>2]>>2]|0)>>0]=1;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=x;f=p+4|0;c=f+4|0;k[c>>2]=0;k[c+4>>2]=0;k[p>>2]=33619968;k[f>>2]=x;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=E;k[s>>2]=-1;k[s+4>>2]=-1;fla(D,p,5,q,s,0.0,4);f=E+36|0;c=k[f>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[E+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[m>>2]|0)>0){e=k[j>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[m>>2]|0))}c=k[h>>2]|0;if(!((c|0)==(l|0)|(c|0)==0))ggb(k[c+-4>>2]|0);k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=z;c=E+4|0;g=c+4|0;k[g>>2]=0;k[g+4>>2]=0;k[E>>2]=33882112;k[c>>2]=a;FV(D,E);k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=x;c=a+12|0;g=E+4|0;f=g+4|0;k[f>>2]=0;k[f+4>>2]=0;k[E>>2]=33882112;k[g>>2]=c;FV(D,E);k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=b;g=a+24|0;f=E+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[E>>2]=33882112;k[f>>2]=g;FV(D,E);f=k[g>>2]|0;T3a(a,f,k[a>>2]|0,k[c>>2]|0,f);f=(k[g>>2]|0)+56|0;T3a(a,f,(k[a>>2]|0)+56|0,(k[c>>2]|0)+56|0,f);f=(k[g>>2]|0)+112|0;T3a(a,f,(k[a>>2]|0)+112|0,(k[c>>2]|0)+112|0,f);f=x+36|0;c=k[f>>2]|0;if(c|0?(b=c+12|0,a=k[b>>2]|0,k[b>>2]=a+-1,(a|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[x+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;x=x+16|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[v>>2]|0)>0){e=k[t>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[u>>2]|0;if(!((c|0)==(w|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=z+36|0;c=k[f>>2]|0;if(c|0?(w=c+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[z+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;z=z+16|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[B>>2]|0)>0){e=k[y>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if((c|0)==(C|0)|(c|0)==0){C=E+8|0;k[C>>2]=0;C=E+12|0;k[C>>2]=0;k[E>>2]=17104896;C=E+4|0;k[C>>2]=g;C=F+4|0;B=C+4|0;A=B;k[A>>2]=0;B=B+4|0;k[B>>2]=0;k[F>>2]=-1040121856;k[C>>2]=d;k[D>>2]=0;C=D+4|0;k[C>>2]=0;d=D+8|0;k[d>>2]=0;B2(E,D);E=k[D>>2]|0;C=k[C>>2]|0;d=(E|0)==(C|0);d=d?0:E;E=C-E|0;E=(E|0)/56|0;GV(d,E,F);zF(D);r=G;return}ggb(k[c+-4>>2]|0);C=E+8|0;k[C>>2]=0;C=E+12|0;k[C>>2]=0;k[E>>2]=17104896;C=E+4|0;k[C>>2]=g;C=F+4|0;B=C+4|0;A=B;k[A>>2]=0;B=B+4|0;k[B>>2]=0;k[F>>2]=-1040121856;k[C>>2]=d;k[D>>2]=0;C=D+4|0;k[C>>2]=0;d=D+8|0;k[d>>2]=0;B2(E,D);E=k[D>>2]|0;C=k[C>>2]|0;d=(E|0)==(C|0);d=d?0:E;E=C-E|0;E=(E|0)/56|0;GV(d,E,F);zF(D);r=G;return}function Y3a(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;Qh[d&7]()}k[d>>2]=151288;c=d+4|0;k[c>>2]=0;f=d+8|0;k[f>>2]=0;e=ZT(12)|0;k[e>>2]=1;k[c>>2]=e+4;k[f>>2]=7;i[e+11>>0]=0;c=k[c>>2]|0;i[c>>0]=i[399790]|0;i[c+1>>0]=i[399791]|0;i[c+2>>0]=i[399792]|0;i[c+3>>0]=i[399793]|0;i[c+4>>0]=i[399794]|0;i[c+5>>0]=i[399795]|0;i[c+6>>0]=i[399796]|0;o[d+12>>2]=b;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=c+4|0;k[e>>2]=1;k[c>>2]=151340;k[c+8>>2]=d;k[a>>2]=c;k[a+4>>2]=d;k[e>>2]=(k[e>>2]|0)+1;f=k[e>>2]|0;k[e>>2]=f+-1;if((f|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function Z3a(a){a=a|0;ggb(a);return}function _3a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function $3a(a){a=a|0;var b=0,c=0;k[a>>2]=151288;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b)return;a=b+-4|0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)!=1)return;ggb(k[b+-8>>2]|0);return}function a4a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=151288;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b){ggb(a);return}d=b+-4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function b4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;d=e;f=d+4|0;g=ZT(12)|0;k[g>>2]=1;c=g+4|0;k[d>>2]=c;k[f>>2]=4;i[g+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,d)|0;c=k[d>>2]|0;k[f>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+4|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=5;i[f+9>>0]=0;i[c>>0]=i[399978]|0;i[c+1>>0]=i[399979]|0;i[c+2>>0]=i[399980]|0;i[c+3>>0]=i[399981]|0;i[c+4>>0]=i[399982]|0;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(!c){g=a+12|0;g4a(b,g)|0;r=e;return}f=c+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){g=a+12|0;g4a(b,g)|0;r=e;return}ggb(k[c+-8>>2]|0);g=a+12|0;g4a(b,g)|0;r=e;return}function c4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0.0;n=r;r=r+16|0;l=n;m=b+4|0;c=k6(k[b>>2]|0,k[m>>2]|0,401026)|0;do if((c|0)!=0?(k[c>>2]&7|0)==3:0){k[l>>2]=0;h=l+4|0;k[h>>2]=0;J6(c,l,l);g=k[l>>2]|0;c=k[a+4>>2]|0;if((g|0)==(c|0)){k[h>>2]=0;k[l>>2]=0;if(g|0?(h=g+-4|0,l=k[h>>2]|0,k[h>>2]=l+-1,(l|0)==1):0)ggb(k[g+-8>>2]|0);break}e=(g|0)==0?1016759:g;d=(c|0)==0?1016759:c;c=i[e>>0]|0;f=i[d>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=f<<24>>24)d=f;else{do{e=e+1|0;d=d+1|0;c=i[e>>0]|0;f=i[d>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=f<<24>>24));d=f}c=c<<24>>24==d<<24>>24;k[h>>2]=0;k[l>>2]=0;if(g|0?(f=g+-4|0,h=k[f>>2]|0,k[f>>2]=h+-1,(h|0)==1):0)ggb(k[g+-8>>2]|0);if(!c)j=14}else j=14;while(0);if((j|0)==14){c=l+4|0;d=ZT(40)|0;k[d>>2]=1;e=d+4|0;k[l>>2]=e;k[c>>2]=33;i[d+37>>0]=0;f=399944;g=e+33|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,l,401059,399877,93);k[c>>2]=0;k[l>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}c=k6(k[b>>2]|0,k[m>>2]|0,399978)|0;if(!c){q=0.0;a=a+12|0;o[a>>2]=q;r=n;return}switch(k[c>>2]&7){case 1:{q=+(k[c+8>>2]|0);a=a+12|0;o[a>>2]=q;r=n;return}case 2:{q=+p[c+8>>3];a=a+12|0;o[a>>2]=q;r=n;return}default:{q=1000000015047466219876688.0e6;a=a+12|0;o[a>>2]=q;r=n;return}}}function d4a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+624|0;z=A+560|0;y=A+504|0;s=A+496|0;u=A+488|0;v=A+480|0;w=A+256|0;x=A+32|0;t=A;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[z>>2]=k[g>>2];m=z+4|0;b=g+4|0;k[m>>2]=k[b>>2];l=z+8|0;k[l>>2]=k[g+8>>2];k[z+12>>2]=k[g+12>>2];n=z+16|0;k[n>>2]=k[g+16>>2];k[z+20>>2]=k[g+20>>2];k[z+24>>2]=k[g+24>>2];k[z+28>>2]=k[g+28>>2];k[z+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[z+36>>2]=d;e=z+40|0;k[e>>2]=l;l=z+48|0;j=z+44|0;k[j>>2]=l;k[z+52>>2]=0;k[l>>2]=0;if(d|0){l=d+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[b>>2]|0)<3){l=k[g+44>>2]|0;m=k[j>>2]|0;k[m>>2]=k[l>>2];k[m+4>>2]=k[l+4>>2];break}k[m>>2]=0;x1(z,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[e>>2]|0;e=k[g+44>>2]|0;d=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else{Q1(z,b,-1);n=z+16|0}while(0);if(k[n>>2]|0){e=k[z+4>>2]|0;if((e|0)<3)b=aa(k[z+12>>2]|0,k[z+8>>2]|0)|0;else{g=k[z+40>>2]|0;d=0;b=1;do{b=aa(k[g+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if(!b)q=16}else q=16;if((q|0)==16){k[y>>2]=0;b=y+4|0;k[b>>2]=0;d=ZT(20)|0;k[d>>2]=1;g=d+4|0;k[y>>2]=g;k[b>>2]=12;i[d+16>>0]=0;e=401621;h=g+12|0;do{i[g>>0]=i[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(h|0));Y8(-215,y,399869,399877,66);k[b>>2]=0;k[y>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}q=z+40|0;l=k[q>>2]|0;m=k[l>>2]|0;k[s>>2]=k[l+4>>2];k[s+4>>2]=m;x2(c,s,21,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[y>>2]=k[g>>2];m=y+4|0;b=g+4|0;k[m>>2]=k[b>>2];s=y+8|0;k[s>>2]=k[g+8>>2];k[y+12>>2]=k[g+12>>2];k[y+16>>2]=k[g+16>>2];k[y+20>>2]=k[g+20>>2];k[y+24>>2]=k[g+24>>2];k[y+28>>2]=k[g+28>>2];k[y+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[y+36>>2]=d;e=y+40|0;k[e>>2]=s;s=y+48|0;j=y+44|0;k[j>>2]=s;k[y+52>>2]=0;k[s>>2]=0;if(d|0){s=d+12|0;k[s>>2]=(k[s>>2]|0)+1}if((k[b>>2]|0)<3){c=k[g+44>>2]|0;s=k[j>>2]|0;k[s>>2]=k[c>>2];k[s+4>>2]=k[c+4>>2];break}k[m>>2]=0;x1(y,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[e>>2]|0;e=k[g+44>>2]|0;d=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(y,c,-1);while(0);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=z;L7(w,u,v,0,0,49332);f=+p[u>>3];if(+p[v>>3]-f>2.220446049250313e-16){p[t>>3]=f;b=t+8|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;Y0(x,z,t);f=+p[v>>3]-+p[u>>3];k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=1124007936;b=w+16|0;d=w+48|0;g=w+12|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=b;b=w+56|0;k[w+52>>2]=b;k[w+60>>2]=0;k[b>>2]=0;k[w+64>>2]=1124007936;b=w+72|0;d=w+104|0;g=w+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=b;b=w+112|0;k[w+108>>2]=b;k[w+116>>2]=0;k[b>>2]=0;k[w+120>>2]=1124007936;b=w+128|0;d=w+160|0;g=w+124|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=b;g=w+168|0;k[w+164>>2]=g;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));v=k[x>>2]|0;nh[k[(k[v>>2]|0)+72>>2]&15](v,x,1.0/f,w);v=k[w>>2]|0;dh[k[(k[v>>2]|0)+12>>2]&255](v,w,y,-1);XN(w);XN(x)}else{v=w+4|0;u=v+4|0;k[u>>2]=0;k[u+4>>2]=0;k[w>>2]=33619968;k[v>>2]=y;mY(z,w)}k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=y;f=+o[a+12>>2];e=x+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[x>>2]=33619968;k[e>>2]=y;ZZ(w,1.0/f,x);e=y+36|0;b=k[e>>2]|0;if(b|0?(w=b+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[y+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;x=y+16|0;d=y+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[d>>2]|0)>0){e=k[y+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[y+44>>2]|0;if(!((b|0)==(y+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=z+36|0;b=k[e>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[z+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;e=z+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[e>>2]|0)>0){d=k[q>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[z+44>>2]|0;if((b|0)==(z+48|0)|(b|0)==0){r=A;return}ggb(k[b+-4>>2]|0);r=A;return}function e4a(a){a=a|0;return +(+o[a+12>>2])}function f4a(a,b){a=a|0;b=+b;o[a+12>>2]=b;return}function g4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+o[b>>2]);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function h4a(a){a=a|0;ggb(a);return}function i4a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function j4a(a){a=a|0;var b=0,c=0;k[a>>2]=151360;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b)return;a=b+-4|0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)!=1)return;ggb(k[b+-8>>2]|0);return}function k4a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=151360;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b){ggb(a);return}d=b+-4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function l4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;f=g+4|0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=4;i[e+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+4|0)|0;f=g+4|0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=5;i[e+9>>0]=0;i[c>>0]=i[399978]|0;i[c+1>>0]=i[399979]|0;i[c+2>>0]=i[399980]|0;i[c+3>>0]=i[399981]|0;i[c+4>>0]=i[399982]|0;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=g4a(b,a+12|0)|0;f=g+4|0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=4;i[e+8>>0]=0;i[c>>0]=98;i[c+1>>0]=105;i[c+2>>0]=97;i[c+3>>0]=115;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=g4a(b,a+20|0)|0;f=g+4|0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[f>>2]=10;i[d+14>>0]=0;d=400097;e=c+10|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(!c){g=a+16|0;g4a(b,g)|0;r=h;return}f=c+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){g=a+16|0;g4a(b,g)|0;r=h;return}ggb(k[c+-8>>2]|0);g=a+16|0;g4a(b,g)|0;r=h;return}function m4a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0;q=r;r=r+16|0;m=q;n=b+4|0;c=k6(k[b>>2]|0,k[n>>2]|0,401026)|0;do if((c|0)!=0?(k[c>>2]&7|0)==3:0){k[m>>2]=0;j=m+4|0;k[j>>2]=0;J6(c,m,m);h=k[m>>2]|0;c=k[a+4>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[m>>2]=0;if(h|0?(j=h+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[h+-8>>2]|0);break}f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[m>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c)l=14}else l=14;while(0);if((l|0)==14){c=m+4|0;e=ZT(40)|0;k[e>>2]=1;f=e+4|0;k[m>>2]=f;k[c>>2]=33;i[e+37>>0]=0;g=399944;h=f+33|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,m,401059,399877,173);k[c>>2]=0;k[m>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}c=k6(k[b>>2]|0,k[n>>2]|0,399978)|0;a:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break a}case 2:{d=+p[c+8>>3];break a}default:{d=1000000015047466219876688.0e6;break a}}while(0);o[a+12>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,400092)|0;b:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break b}case 2:{d=+p[c+8>>3];break b}default:{d=1000000015047466219876688.0e6;break b}}while(0);o[a+20>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,400097)|0;if(!c){d=0.0;a=a+16|0;o[a>>2]=d;r=q;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+16|0;o[a>>2]=d;r=q;return}case 2:{d=+p[c+8>>3];a=a+16|0;o[a>>2]=d;r=q;return}default:{d=1000000015047466219876688.0e6;a=a+16|0;o[a>>2]=d;r=q;return}}}function n4a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;Ha=r;r=r+1536|0;u=Ha+984|0;J=Ha+1480|0;Ba=Ha+928|0;Aa=Ha+704|0;Ga=Ha+1416|0;s=Ha+1472|0;Fa=Ha+1360|0;Ea=Ha+1352|0;y=Ha+1296|0;Ca=Ha+1128|0;t=Ha+672|0;ya=Ha+448|0;v=Ha+224|0;w=Ha;x=Ha+1e3|0;da=Ha+1240|0;fa=Ha+1184|0;ga=Ha+1072|0;ha=Ha+1016|0;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[Ga>>2]=k[f>>2];l=Ga+4|0;b=f+4|0;k[l>>2]=k[b>>2];Da=Ga+8|0;k[Da>>2]=k[f+8>>2];k[Ga+12>>2]=k[f+12>>2];m=Ga+16|0;k[m>>2]=k[f+16>>2];k[Ga+20>>2]=k[f+20>>2];k[Ga+24>>2]=k[f+24>>2];k[Ga+28>>2]=k[f+28>>2];k[Ga+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[Ga+36>>2]=d;e=Ga+40|0;k[e>>2]=Da;Da=Ga+48|0;h=Ga+44|0;k[h>>2]=Da;k[Ga+52>>2]=0;k[Da>>2]=0;if(d|0){Da=d+12|0;k[Da>>2]=(k[Da>>2]|0)+1}if((k[b>>2]|0)<3){za=k[f+44>>2]|0;Da=k[h>>2]|0;k[Da>>2]=k[za>>2];k[Da+4>>2]=k[za+4>>2];break}k[l>>2]=0;x1(Ga,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{Q1(Ga,b,-1);m=Ga+16|0}while(0);if(k[m>>2]|0){e=k[Ga+4>>2]|0;if((e|0)<3)b=aa(k[Ga+12>>2]|0,k[Ga+8>>2]|0)|0;else{f=k[Ga+40>>2]|0;d=0;b=1;do{b=aa(k[f+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if(!b)q=16}else q=16;if((q|0)==16){k[u>>2]=0;b=u+4|0;k[b>>2]=0;d=ZT(20)|0;k[d>>2]=1;f=d+4|0;k[u>>2]=f;k[b>>2]=12;i[d+16>>0]=0;e=401621;g=f+12|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,u,399869,399877,121);k[b>>2]=0;k[u>>2]=0;Da=k[d>>2]|0;k[d>>2]=Da+-1;if((Da|0)==1)ggb(k[d+-4>>2]|0)}Da=Ga+40|0;xa=k[Da>>2]|0;za=k[xa>>2]|0;k[s>>2]=k[xa+4>>2];k[s+4>>2]=za;x2(c,s,21,0);do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[Fa>>2]=k[f>>2];l=Fa+4|0;b=f+4|0;k[l>>2]=k[b>>2];za=Fa+8|0;k[za>>2]=k[f+8>>2];k[Fa+12>>2]=k[f+12>>2];k[Fa+16>>2]=k[f+16>>2];k[Fa+20>>2]=k[f+20>>2];k[Fa+24>>2]=k[f+24>>2];k[Fa+28>>2]=k[f+28>>2];k[Fa+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[Fa+36>>2]=d;e=Fa+40|0;k[e>>2]=za;za=Fa+48|0;h=Fa+44|0;k[h>>2]=za;k[Fa+52>>2]=0;k[za>>2]=0;if(d|0){za=d+12|0;k[za>>2]=(k[za>>2]|0)+1}if((k[b>>2]|0)<3){xa=k[f+44>>2]|0;za=k[h>>2]|0;k[za>>2]=k[xa>>2];k[za+4>>2]=k[xa+4>>2];break}k[l>>2]=0;x1(Fa,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(Fa,c,-1);while(0);Y3a(Ea,1.0);ea=Ea+4|0;wa=k[ea>>2]|0;s=k[(k[wa>>2]|0)+32>>2]|0;k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=16842752;k[u+4>>2]=Ga;va=J+4|0;f=va+4|0;k[f>>2]=0;k[f+4>>2]=0;k[J>>2]=33619968;k[va>>2]=Fa;Ph[s&511](wa,u,J);k[y>>2]=1124007936;wa=y+4|0;s=y+8|0;va=y+40|0;f=wa;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[va>>2]=s;za=y+48|0;xa=y+44|0;k[xa>>2]=za;k[y+52>>2]=0;k[za>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=16842752;k[u+4>>2]=Fa;sa=J+4|0;b=sa+4|0;k[b>>2]=0;k[b+4>>2]=0;k[J>>2]=33619968;k[sa>>2]=y;$aa(u,J,7,0);k[Ca>>2]=1124007936;sa=Ca+4|0;b=Ca+8|0;ra=Ca+40|0;f=sa;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[ra>>2]=b;ua=Ca+48|0;ta=Ca+44|0;k[ta>>2]=ua;k[Ca+52>>2]=0;k[ua>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=16842752;k[u+4>>2]=y;p[Ba>>3]=.0001;p[Ba+8>>3]=.0001;p[Ba+16>>3]=.0001;p[Ba+24>>3]=.0001;k[J>>2]=-1056833530;k[J+4>>2]=Ba;k[J+8>>2]=1;k[J+12>>2]=4;f=Aa+4|0;qa=f+4|0;k[qa>>2]=0;k[qa+4>>2]=0;k[Aa>>2]=33619968;k[f>>2]=Ca;aU(u,J,Aa,49332,39872,0,14);k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=16842752;k[u+4>>2]=Ca;f=J+4|0;qa=f+4|0;k[qa>>2]=0;k[qa+4>>2]=0;k[J>>2]=33619968;k[f>>2]=Ca;YZ(u,J);k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=16842752;k[u+4>>2]=Ca;g7(t,u);n=+p[t>>3];f=k[sa>>2]|0;if((f|0)<3)b=aa(k[Ca+12>>2]|0,k[b>>2]|0)|0;else{e=k[ra>>2]|0;d=0;b=1;do{b=aa(k[e+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(f|0))}n=+Z(+(n/+(b>>>0)));qa=u+4|0;b=qa+4|0;k[b>>2]=0;k[b+4>>2]=0;k[u>>2]=33619968;k[qa>>2]=y;SW(y,u,-1,1.0/n,0.0);qa=Ca+36|0;b=k[qa>>2]|0;if(b|0?(oa=b+12|0,pa=k[oa>>2]|0,k[oa>>2]=pa+-1,(pa|0)==1):0){d=k[qa>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Ca+32>>2]|0;if(!b){b=B1()|0;d=k[qa>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[qa>>2]=0}k[qa>>2]=0;pa=Ca+16|0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[sa>>2]|0)>0){d=k[ra>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[sa>>2]|0))}k[J+8>>2]=0;k[J+12>>2]=0;k[J>>2]=16842752;k[J+4>>2]=y;L7(J,0,u,0,0,49332);k[J>>2]=1124007936;ia=J+4|0;B=J+8|0;ca=J+40|0;f=ia;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[ca>>2]=B;ka=J+48|0;ja=J+44|0;k[ja>>2]=ka;k[J+52>>2]=0;k[ka>>2]=0;p[ya>>3]=1.0;$=ya+8|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;U0(Aa,y,ya);k[Ba+8>>2]=0;k[Ba+12>>2]=0;k[Ba>>2]=-1056571392;k[Ba+4>>2]=Aa;$=v+4|0;b=$+4|0;k[b>>2]=0;k[b+4>>2]=0;k[v>>2]=33619968;k[$>>2]=J;YZ(Ba,v);XN(Aa);k[Ba>>2]=1124007936;$=Ba+4|0;b=Ba+8|0;X=Ba+40|0;f=$;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[X>>2]=b;ba=Ba+48|0;Y=Ba+44|0;k[Y>>2]=ba;k[Ba+52>>2]=0;k[ba>>2]=0;f1(ya,y,+p[u>>3]);k[Aa+8>>2]=0;k[Aa+12>>2]=0;k[Aa>>2]=-1056571392;k[Aa+4>>2]=ya;n=+o[a+20>>2];b=v+4|0;d=b+4|0;k[d>>2]=0;k[d+4>>2]=0;k[v>>2]=33619968;k[b>>2]=Ba;ZZ(Aa,+_(+n)/-.6931471824645996,v);XN(ya);p[v>>3]=2.0;b=v+8|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;c1(w,8.0,Ba);k[ya>>2]=0;k[ya+4>>2]=0;k[ya+8>>2]=1124007936;b=ya+16|0;d=ya+48|0;f=ya+12|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=b;b=ya+56|0;k[ya+52>>2]=b;k[ya+60>>2]=0;k[b>>2]=0;k[ya+64>>2]=1124007936;b=ya+72|0;d=ya+104|0;f=ya+68|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=b;b=ya+112|0;k[ya+108>>2]=b;k[ya+116>>2]=0;k[b>>2]=0;k[ya+120>>2]=1124007936;b=ya+128|0;d=ya+160|0;f=ya+124|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=b;f=ya+168|0;k[ya+164>>2]=f;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));W=k[w>>2]|0;dh[k[(k[W>>2]|0)+56>>2]&255](W,w,v,ya);k[Aa+8>>2]=0;k[Aa+12>>2]=0;k[Aa>>2]=-1056571392;k[Aa+4>>2]=ya;W=x+4|0;b=W+4|0;k[b>>2]=0;k[b+4>>2]=0;k[x>>2]=33619968;k[W>>2]=Ba;YZ(Aa,x);XN(ya);XN(w);g1(v,Ba);k[ya+8>>2]=0;k[ya+12>>2]=0;k[ya>>2]=-1056571392;k[ya+4>>2]=v;i1(Aa,J,ya,1.0);W=k[Aa>>2]|0;dh[k[(k[W>>2]|0)+12>>2]&255](W,Aa,J,-1);XN(Aa);XN(v);W=Ba+36|0;b=k[W>>2]|0;if(b|0?(na=b+12|0,oa=k[na>>2]|0,k[na>>2]=oa+-1,(oa|0)==1):0){d=k[W>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Ba+32>>2]|0;if(!b){b=B1()|0;d=k[W>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[W>>2]=0}k[W>>2]=0;S=Ba+16|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[$>>2]|0)>0){d=k[X>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[$>>2]|0))}k[da>>2]=k[Fa>>2];P=da+4|0;oa=Fa+4|0;b=k[oa>>2]|0;k[P>>2]=b;R=da+8|0;h=Fa+8|0;k[R>>2]=k[h>>2];j=Fa+12|0;k[da+12>>2]=k[j>>2];M=da+16|0;ma=Fa+16|0;k[M>>2]=k[ma>>2];l=Fa+20|0;k[da+20>>2]=k[l>>2];q=Fa+24|0;k[da+24>>2]=k[q>>2];c=Fa+28|0;k[da+28>>2]=k[c>>2];L=da+32|0;la=Fa+32|0;k[L>>2]=k[la>>2];N=da+36|0;na=Fa+36|0;d=k[na>>2]|0;k[N>>2]=d;O=da+40|0;k[O>>2]=R;R=da+48|0;Q=da+44|0;k[Q>>2]=R;k[da+52>>2]=0;k[R>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[oa>>2]|0}if((b|0)>=3){k[P>>2]=0;x1(da,b,0,0,0);if((k[P>>2]|0)>0){d=k[Fa+40>>2]|0;e=k[O>>2]|0;f=k[Fa+44>>2]|0;g=k[Q>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[P>>2]|0))}}else{U=k[Fa+44>>2]|0;V=k[Q>>2]|0;k[V>>2]=k[U>>2];k[V+4>>2]=k[U+4>>2]}k[fa>>2]=k[Fa>>2];I=fa+4|0;b=k[oa>>2]|0;k[I>>2]=b;H=fa+8|0;k[H>>2]=k[h>>2];k[fa+12>>2]=k[j>>2];G=fa+16|0;k[G>>2]=k[ma>>2];k[fa+20>>2]=k[l>>2];k[fa+24>>2]=k[q>>2];k[fa+28>>2]=k[c>>2];C=fa+32|0;k[C>>2]=k[la>>2];D=fa+36|0;d=k[na>>2]|0;k[D>>2]=d;E=fa+40|0;k[E>>2]=H;H=fa+48|0;F=fa+44|0;k[F>>2]=H;k[fa+52>>2]=0;k[H>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[oa>>2]|0}if((b|0)>=3){k[I>>2]=0;x1(fa,b,0,0,0);if((k[I>>2]|0)>0){d=k[Fa+40>>2]|0;e=k[E>>2]|0;f=k[Fa+44>>2]|0;g=k[F>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[I>>2]|0))}}else{U=k[Fa+44>>2]|0;V=k[F>>2]|0;k[V>>2]=k[U>>2];k[V+4>>2]=k[U+4>>2]}k[ga>>2]=k[y>>2];A=ga+4|0;b=k[wa>>2]|0;k[A>>2]=b;z=ga+8|0;k[z>>2]=k[s>>2];k[ga+12>>2]=k[y+12>>2];w=ga+16|0;V=y+16|0;k[w>>2]=k[V>>2];k[ga+20>>2]=k[y+20>>2];k[ga+24>>2]=k[y+24>>2];k[ga+28>>2]=k[y+28>>2];u=ga+32|0;T=y+32|0;k[u>>2]=k[T>>2];x=ga+36|0;U=y+36|0;d=k[U>>2]|0;k[x>>2]=d;v=ga+40|0;k[v>>2]=z;z=ga+48|0;y=ga+44|0;k[y>>2]=z;k[ga+52>>2]=0;k[z>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[wa>>2]|0}if((b|0)>=3){k[A>>2]=0;x1(ga,b,0,0,0);if((k[A>>2]|0)>0){d=k[va>>2]|0;e=k[v>>2]|0;f=k[xa>>2]|0;g=k[y>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[A>>2]|0))}}else{t=k[xa>>2]|0;K=k[y>>2]|0;k[K>>2]=k[t>>2];k[K+4>>2]=k[t+4>>2]}k[ha>>2]=k[J>>2];t=ha+4|0;b=k[ia>>2]|0;k[t>>2]=b;s=ha+8|0;k[s>>2]=k[B>>2];k[ha+12>>2]=k[J+12>>2];l=ha+16|0;K=J+16|0;k[l>>2]=k[K>>2];k[ha+20>>2]=k[J+20>>2];k[ha+24>>2]=k[J+24>>2];k[ha+28>>2]=k[J+28>>2];h=ha+32|0;B=J+32|0;k[h>>2]=k[B>>2];q=ha+36|0;J=J+36|0;d=k[J>>2]|0;k[q>>2]=d;j=ha+40|0;k[j>>2]=s;s=ha+48|0;c=ha+44|0;k[c>>2]=s;k[ha+52>>2]=0;k[s>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[ia>>2]|0}if((b|0)>=3){k[t>>2]=0;x1(ha,b,0,0,0);if((k[t>>2]|0)>0){d=k[ca>>2]|0;e=k[j>>2]|0;f=k[ja>>2]|0;g=k[c>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[t>>2]|0))}}else{f=k[ja>>2]|0;g=k[c>>2]|0;k[g>>2]=k[f>>2];k[g+4>>2]=k[f+4>>2]}Z2a(da,fa,ga,ha,+o[a+16>>2]);b=k[q>>2]|0;if(b|0?(ga=b+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){d=k[q>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[h>>2]|0;if(b|0)break;b=B1()|0;d=k[q>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[q>>2]=0}k[q>>2]=0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[t>>2]|0)>0){d=k[j>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[c>>2]|0;if(!((b|0)==(s|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[x>>2]|0;do if(b|0){ga=b+12|0;ha=k[ga>>2]|0;k[ga>>2]=ha+-1;if((ha|0)!=1)break;d=k[x>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[u>>2]|0;if(b|0)break;b=B1()|0;d=k[x>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[x>>2]=0}while(0);k[x>>2]=0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[A>>2]|0)>0){d=k[v>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[A>>2]|0))}b=k[y>>2]|0;if(!((b|0)==(z|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[D>>2]|0;do if(b|0){ga=b+12|0;ha=k[ga>>2]|0;k[ga>>2]=ha+-1;if((ha|0)!=1)break;d=k[D>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[C>>2]|0;if(b|0)break;b=B1()|0;d=k[D>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[D>>2]=0}while(0);k[D>>2]=0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[I>>2]|0)>0){d=k[E>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[I>>2]|0))}b=k[F>>2]|0;if(!((b|0)==(H|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[N>>2]|0;do if(b|0){ga=b+12|0;ha=k[ga>>2]|0;k[ga>>2]=ha+-1;if((ha|0)!=1)break;d=k[N>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[L>>2]|0;if(b|0)break;b=B1()|0;d=k[N>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[N>>2]=0}while(0);k[N>>2]=0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[P>>2]|0)>0){d=k[O>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[P>>2]|0))}b=k[Q>>2]|0;if(!((b|0)==(R|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[ea>>2]|0;gh[k[(k[b>>2]|0)+40>>2]&255](b,+o[a+12>>2]);a=k[(k[b>>2]|0)+32>>2]|0;k[Aa+8>>2]=0;k[Aa+12>>2]=0;k[Aa>>2]=16842752;k[Aa+4>>2]=Fa;ha=ya+4|0;ga=ha+4|0;k[ga>>2]=0;k[ga+4>>2]=0;k[ya>>2]=33619968;k[ha>>2]=Fa;Ph[a&511](b,Aa,ya);b=k[W>>2]|0;do if(b|0){ya=b+12|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;d=k[W>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Ba+32>>2]|0;if(b|0)break;b=B1()|0;d=k[W>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[W>>2]=0}while(0);k[W>>2]=0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[$>>2]|0)>0){d=k[X>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[$>>2]|0))}b=k[Y>>2]|0;if(!((b|0)==(ba|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[J>>2]|0;do if(b|0){Aa=b+12|0;Ba=k[Aa>>2]|0;k[Aa>>2]=Ba+-1;if((Ba|0)!=1)break;d=k[J>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[B>>2]|0;if(b|0)break;b=B1()|0;d=k[J>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[J>>2]=0}while(0);k[J>>2]=0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[ia>>2]|0)>0){d=k[ca>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ia>>2]|0))}b=k[ja>>2]|0;if(!((b|0)==(ka|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[qa>>2]|0;do if(b|0){Aa=b+12|0;Ba=k[Aa>>2]|0;k[Aa>>2]=Ba+-1;if((Ba|0)!=1)break;d=k[qa>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Ca+32>>2]|0;if(b|0)break;b=B1()|0;d=k[qa>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[qa>>2]=0}while(0);k[qa>>2]=0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[sa>>2]|0)>0){d=k[ra>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[sa>>2]|0))}b=k[ta>>2]|0;if(!((b|0)==(ua|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[U>>2]|0;do if(b|0){Ba=b+12|0;Ca=k[Ba>>2]|0;k[Ba>>2]=Ca+-1;if((Ca|0)!=1)break;d=k[U>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[T>>2]|0;if(b|0)break;b=B1()|0;d=k[U>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[U>>2]=0}while(0);k[U>>2]=0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[wa>>2]|0)>0){d=k[va>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[wa>>2]|0))}b=k[xa>>2]|0;if(!((b|0)==(za|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Ea>>2]|0;do if(b|0){Ca=b+4|0;Ea=k[Ca>>2]|0;k[Ca>>2]=Ea+-1;if((Ea|0)!=1)break;Uh[k[(k[b>>2]|0)+8>>2]&2047](b)}while(0);b=k[na>>2]|0;do if(b|0){Ca=b+12|0;Ea=k[Ca>>2]|0;k[Ca>>2]=Ea+-1;if((Ea|0)!=1)break;d=k[na>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[la>>2]|0;if(b|0)break;b=B1()|0;d=k[na>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[na>>2]=0}while(0);k[na>>2]=0;k[ma>>2]=0;k[ma+4>>2]=0;k[ma+8>>2]=0;k[ma+12>>2]=0;if((k[oa>>2]|0)>0){d=k[Fa+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[oa>>2]|0))}b=k[Fa+44>>2]|0;if(!((b|0)==(Fa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=Ga+36|0;b=k[e>>2]|0;do if(b|0){Ea=b+12|0;Fa=k[Ea>>2]|0;k[Ea>>2]=Fa+-1;if((Fa|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Ga+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;e=Ga+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[e>>2]|0)>0){d=k[Da>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Ga+44>>2]|0;if((b|0)==(Ga+48|0)|(b|0)==0){r=Ha;return}ggb(k[b+-4>>2]|0);r=Ha;return}function o4a(a){a=a|0;return +(+o[a+12>>2])}function p4a(a,b){a=a|0;b=+b;o[a+12>>2]=b;return}function q4a(a){a=a|0;return +(+o[a+16>>2])}function r4a(a,b){a=a|0;b=+b;o[a+16>>2]=b;return}function s4a(a){a=a|0;return +(+o[a+20>>2])}function t4a(a,b){a=a|0;b=+b;o[a+20>>2]=b;return}function u4a(a){a=a|0;ggb(a);return}function v4a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function w4a(a){a=a|0;var b=0,c=0;k[a>>2]=151448;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b)return;a=b+-4|0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)!=1)return;ggb(k[b+-8>>2]|0);return}function x4a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=151448;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b){ggb(a);return}d=b+-4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function y4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;f=g+4|0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=4;i[e+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+4|0)|0;k[g>>2]=0;f=g+4|0;k[f>>2]=0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=5;i[e+9>>0]=0;i[c>>0]=i[399978]|0;i[c+1>>0]=i[399979]|0;i[c+2>>0]=i[399980]|0;i[c+3>>0]=i[399981]|0;i[c+4>>0]=i[399982]|0;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=g4a(b,a+12|0)|0;k[g>>2]=0;f=g+4|0;k[f>>2]=0;e=ZT(16)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=8;i[e+12>>0]=0;e=c;i[e>>0]=99;i[e+1>>0]=111;i[e+2>>0]=110;i[e+3>>0]=116;c=c+4|0;i[c>>0]=114;i[c+1>>0]=97;i[c+2>>0]=115;i[c+3>>0]=116;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=g4a(b,a+16|0)|0;d=g+4|0;e=ZT(16)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[d>>2]=11;i[e+15>>0]=0;e=400232;f=c+11|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));b=z6(b,g)|0;c=k[g>>2]|0;k[d>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=g4a(b,a+24|0)|0;d=g+4|0;e=ZT(16)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[d>>2]=11;i[e+15>>0]=0;e=400244;f=c+11|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));b=z6(b,g)|0;c=k[g>>2]|0;k[d>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=g4a(b,a+28|0)|0;d=g+4|0;e=ZT(16)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[d>>2]=10;i[e+14>>0]=0;e=400097;f=c+10|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));b=z6(b,g)|0;c=k[g>>2]|0;k[d>>2]=0;k[g>>2]=0;if(!c){g=a+20|0;g4a(b,g)|0;r=h;return}f=c+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){g=a+20|0;g4a(b,g)|0;r=h;return}ggb(k[c+-8>>2]|0);g=a+20|0;g4a(b,g)|0;r=h;return}function z4a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0;q=r;r=r+16|0;m=q;n=b+4|0;c=k6(k[b>>2]|0,k[n>>2]|0,401026)|0;do if((c|0)!=0?(k[c>>2]&7|0)==3:0){k[m>>2]=0;j=m+4|0;k[j>>2]=0;J6(c,m,m);h=k[m>>2]|0;c=k[a+4>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[m>>2]=0;if(h|0?(j=h+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[h+-8>>2]|0);break}f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[m>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c)l=14}else l=14;while(0);if((l|0)==14){c=m+4|0;e=ZT(40)|0;k[e>>2]=1;f=e+4|0;k[m>>2]=f;k[c>>2]=33;i[e+37>>0]=0;g=399944;h=f+33|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,m,401059,399877,256);k[c>>2]=0;k[m>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}c=k6(k[b>>2]|0,k[n>>2]|0,399978)|0;a:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break a}case 2:{d=+p[c+8>>3];break a}default:{d=1000000015047466219876688.0e6;break a}}while(0);o[a+12>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,400223)|0;b:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break b}case 2:{d=+p[c+8>>3];break b}default:{d=1000000015047466219876688.0e6;break b}}while(0);o[a+16>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,400232)|0;c:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break c}case 2:{d=+p[c+8>>3];break c}default:{d=1000000015047466219876688.0e6;break c}}while(0);o[a+24>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,400244)|0;d:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break d}case 2:{d=+p[c+8>>3];break d}default:{d=1000000015047466219876688.0e6;break d}}while(0);o[a+28>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,400097)|0;if(!c){d=0.0;a=a+20|0;o[a>>2]=d;r=q;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+20|0;o[a>>2]=d;r=q;return}case 2:{d=+p[c+8>>3];a=a+20|0;o[a>>2]=d;r=q;return}default:{d=1000000015047466219876688.0e6;a=a+20|0;o[a>>2]=d;r=q;return}}}function A4a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0;wa=r;r=r+1056|0;C=wa+992|0;u=wa+480|0;v=wa+448|0;qa=wa+976|0;va=wa+912|0;q=wa+968|0;ua=wa+856|0;ta=wa+848|0;x=wa+792|0;ra=wa+568|0;pa=wa+224|0;s=wa;t=wa+496|0;U=wa+736|0;V=wa+680|0;W=wa+624|0;X=wa+512|0;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[va>>2]=k[f>>2];l=va+4|0;b=f+4|0;k[l>>2]=k[b>>2];sa=va+8|0;k[sa>>2]=k[f+8>>2];k[va+12>>2]=k[f+12>>2];m=va+16|0;k[m>>2]=k[f+16>>2];k[va+20>>2]=k[f+20>>2];k[va+24>>2]=k[f+24>>2];k[va+28>>2]=k[f+28>>2];k[va+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[va+36>>2]=d;e=va+40|0;k[e>>2]=sa;sa=va+48|0;h=va+44|0;k[h>>2]=sa;k[va+52>>2]=0;k[sa>>2]=0;if(d|0){sa=d+12|0;k[sa>>2]=(k[sa>>2]|0)+1}if((k[b>>2]|0)<3){oa=k[f+44>>2]|0;sa=k[h>>2]|0;k[sa>>2]=k[oa>>2];k[sa+4>>2]=k[oa+4>>2];break}k[l>>2]=0;x1(va,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{Q1(va,b,-1);m=va+16|0}while(0);if(k[m>>2]|0){e=k[va+4>>2]|0;if((e|0)<3)b=aa(k[va+12>>2]|0,k[va+8>>2]|0)|0;else{f=k[va+40>>2]|0;d=0;b=1;do{b=aa(k[f+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if(!b)n=16}else n=16;if((n|0)==16){k[C>>2]=0;b=C+4|0;k[b>>2]=0;d=ZT(20)|0;k[d>>2]=1;f=d+4|0;k[C>>2]=f;k[b>>2]=12;i[d+16>>0]=0;e=401621;g=f+12|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,C,399869,399877,205);k[b>>2]=0;k[C>>2]=0;sa=k[d>>2]|0;k[d>>2]=sa+-1;if((sa|0)==1)ggb(k[d+-4>>2]|0)}sa=va+40|0;na=k[sa>>2]|0;oa=k[na>>2]|0;k[q>>2]=k[na+4>>2];k[q+4>>2]=oa;x2(c,q,21,0);do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[ua>>2]=k[f>>2];l=ua+4|0;b=f+4|0;k[l>>2]=k[b>>2];oa=ua+8|0;k[oa>>2]=k[f+8>>2];k[ua+12>>2]=k[f+12>>2];k[ua+16>>2]=k[f+16>>2];k[ua+20>>2]=k[f+20>>2];k[ua+24>>2]=k[f+24>>2];k[ua+28>>2]=k[f+28>>2];k[ua+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[ua+36>>2]=d;e=ua+40|0;k[e>>2]=oa;oa=ua+48|0;h=ua+44|0;k[h>>2]=oa;k[ua+52>>2]=0;k[oa>>2]=0;if(d|0){oa=d+12|0;k[oa>>2]=(k[oa>>2]|0)+1}if((k[b>>2]|0)<3){na=k[f+44>>2]|0;oa=k[h>>2]|0;k[oa>>2]=k[na>>2];k[oa+4>>2]=k[na+4>>2];break}k[l>>2]=0;x1(ua,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(ua,c,-1);while(0);Y3a(ta,1.0);ma=k[ta+4>>2]|0;q=k[(k[ma>>2]|0)+32>>2]|0;k[C+8>>2]=0;k[C+12>>2]=0;k[C>>2]=16842752;k[C+4>>2]=va;la=u+4|0;f=la+4|0;k[f>>2]=0;k[f+4>>2]=0;k[u>>2]=33619968;k[la>>2]=ua;Ph[q&511](ma,C,u);k[x>>2]=1124007936;ma=x+4|0;q=x+8|0;la=x+40|0;f=ma;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[la>>2]=q;oa=x+48|0;na=x+44|0;k[na>>2]=oa;k[x+52>>2]=0;k[oa>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;k[C>>2]=16842752;k[C+4>>2]=ua;ga=u+4|0;b=ga+4|0;k[b>>2]=0;k[b+4>>2]=0;k[u>>2]=33619968;k[ga>>2]=x;$aa(C,u,7,0);k[ra>>2]=1124007936;ga=ra+4|0;b=ra+8|0;da=ra+40|0;f=ga;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[da>>2]=b;ha=ra+48|0;ea=ra+44|0;k[ea>>2]=ha;k[ra+52>>2]=0;k[ha>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;k[C>>2]=16842752;k[C+4>>2]=x;p[v>>3]=.0001;p[v+8>>3]=.0001;p[v+16>>3]=.0001;p[v+24>>3]=.0001;k[u>>2]=-1056833530;k[u+4>>2]=v;k[u+8>>2]=1;k[u+12>>2]=4;ba=qa+4|0;A=ba+4|0;k[A>>2]=0;k[A+4>>2]=0;k[qa>>2]=33619968;k[ba>>2]=ra;aU(C,u,qa,49332,39872,0,14);k[C+8>>2]=0;k[C+12>>2]=0;k[C>>2]=16842752;k[C+4>>2]=ra;ba=u+4|0;A=ba+4|0;k[A>>2]=0;k[A+4>>2]=0;k[u>>2]=33619968;k[ba>>2]=ra;YZ(C,u);k[C>>2]=1124007936;ba=C+4|0;A=C+8|0;Z=C+40|0;f=ba;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Z>>2]=A;$=C+48|0;_=C+44|0;k[_>>2]=$;k[C+52>>2]=0;k[$>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=16842752;k[u+4>>2]=ra;ca=v+4|0;b=ca+4|0;k[b>>2]=0;k[b+4>>2]=0;k[v>>2]=33619968;k[ca>>2]=C;wua(u,v,-1,+o[a+24>>2],+o[a+28>>2],4);k[qa+8>>2]=0;k[qa+12>>2]=0;k[qa>>2]=16842752;k[qa+4>>2]=C;L7(qa,u,v,0,0,49332);b1(s,C,+o[a+16>>2]/(+p[v>>3]-+p[u>>3])+-1.0);W0(pa,s,ra);k[qa+8>>2]=0;k[qa+12>>2]=0;k[qa>>2]=-1056571392;k[qa+4>>2]=pa;ca=t+4|0;b=ca+4|0;k[b>>2]=0;k[b+4>>2]=0;k[t>>2]=33619968;k[ca>>2]=C;XZ(qa,t);XN(pa);XN(s);ca=ra+36|0;b=k[ca>>2]|0;if(b|0?(ja=b+12|0,ka=k[ja>>2]|0,k[ja>>2]=ka+-1,(ka|0)==1):0){d=k[ca>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[ra+32>>2]|0;if(!b){b=B1()|0;d=k[ca>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[ca>>2]=0}k[ca>>2]=0;Y=ra+16|0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[ga>>2]|0)>0){d=k[da>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ga>>2]|0))}k[U>>2]=k[ua>>2];O=U+4|0;ka=ua+4|0;b=k[ka>>2]|0;k[O>>2]=b;R=U+8|0;h=ua+8|0;k[R>>2]=k[h>>2];j=ua+12|0;k[U+12>>2]=k[j>>2];L=U+16|0;ia=ua+16|0;k[L>>2]=k[ia>>2];l=ua+20|0;k[U+20>>2]=k[l>>2];n=ua+24|0;k[U+24>>2]=k[n>>2];c=ua+28|0;k[U+28>>2]=k[c>>2];K=U+32|0;fa=ua+32|0;k[K>>2]=k[fa>>2];M=U+36|0;ja=ua+36|0;d=k[ja>>2]|0;k[M>>2]=d;N=U+40|0;k[N>>2]=R;R=U+48|0;P=U+44|0;k[P>>2]=R;k[U+52>>2]=0;k[R>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[ka>>2]|0}if((b|0)>=3){k[O>>2]=0;x1(U,b,0,0,0);if((k[O>>2]|0)>0){d=k[ua+40>>2]|0;e=k[N>>2]|0;f=k[ua+44>>2]|0;g=k[P>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[O>>2]|0))}}else{S=k[ua+44>>2]|0;T=k[P>>2]|0;k[T>>2]=k[S>>2];k[T+4>>2]=k[S+4>>2]}k[V>>2]=k[ua>>2];J=V+4|0;b=k[ka>>2]|0;k[J>>2]=b;I=V+8|0;k[I>>2]=k[h>>2];k[V+12>>2]=k[j>>2];H=V+16|0;k[H>>2]=k[ia>>2];k[V+20>>2]=k[l>>2];k[V+24>>2]=k[n>>2];k[V+28>>2]=k[c>>2];B=V+32|0;k[B>>2]=k[fa>>2];E=V+36|0;d=k[ja>>2]|0;k[E>>2]=d;F=V+40|0;k[F>>2]=I;I=V+48|0;G=V+44|0;k[G>>2]=I;k[V+52>>2]=0;k[I>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[ka>>2]|0}if((b|0)>=3){k[J>>2]=0;x1(V,b,0,0,0);if((k[J>>2]|0)>0){d=k[ua+40>>2]|0;e=k[F>>2]|0;f=k[ua+44>>2]|0;g=k[G>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[J>>2]|0))}}else{S=k[ua+44>>2]|0;T=k[G>>2]|0;k[T>>2]=k[S>>2];k[T+4>>2]=k[S+4>>2]}k[W>>2]=k[x>>2];z=W+4|0;b=k[ma>>2]|0;k[z>>2]=b;y=W+8|0;k[y>>2]=k[q>>2];k[W+12>>2]=k[x+12>>2];v=W+16|0;T=x+16|0;k[v>>2]=k[T>>2];k[W+20>>2]=k[x+20>>2];k[W+24>>2]=k[x+24>>2];k[W+28>>2]=k[x+28>>2];t=W+32|0;Q=x+32|0;k[t>>2]=k[Q>>2];w=W+36|0;S=x+36|0;d=k[S>>2]|0;k[w>>2]=d;u=W+40|0;k[u>>2]=y;y=W+48|0;x=W+44|0;k[x>>2]=y;k[W+52>>2]=0;k[y>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[ma>>2]|0}if((b|0)>=3){k[z>>2]=0;x1(W,b,0,0,0);if((k[z>>2]|0)>0){d=k[la>>2]|0;e=k[u>>2]|0;f=k[na>>2]|0;g=k[x>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[z>>2]|0))}}else{s=k[na>>2]|0;D=k[x>>2]|0;k[D>>2]=k[s>>2];k[D+4>>2]=k[s+4>>2]}k[X>>2]=k[C>>2];s=X+4|0;b=k[ba>>2]|0;k[s>>2]=b;q=X+8|0;k[q>>2]=k[A>>2];k[X+12>>2]=k[C+12>>2];l=X+16|0;D=C+16|0;k[l>>2]=k[D>>2];k[X+20>>2]=k[C+20>>2];k[X+24>>2]=k[C+24>>2];k[X+28>>2]=k[C+28>>2];h=X+32|0;A=C+32|0;k[h>>2]=k[A>>2];n=X+36|0;C=C+36|0;d=k[C>>2]|0;k[n>>2]=d;j=X+40|0;k[j>>2]=q;q=X+48|0;c=X+44|0;k[c>>2]=q;k[X+52>>2]=0;k[q>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[ba>>2]|0}if((b|0)>=3){k[s>>2]=0;x1(X,b,0,0,0);if((k[s>>2]|0)>0){d=k[Z>>2]|0;e=k[j>>2]|0;f=k[_>>2]|0;g=k[c>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[s>>2]|0))}}else{f=k[_>>2]|0;g=k[c>>2]|0;k[g>>2]=k[f>>2];k[g+4>>2]=k[f+4>>2]}Z2a(U,V,W,X,+o[a+20>>2]);b=k[n>>2]|0;if(b|0?(W=b+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){d=k[n>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[h>>2]|0;if(b|0)break;b=B1()|0;d=k[n>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[n>>2]=0}k[n>>2]=0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[s>>2]|0)>0){d=k[j>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[s>>2]|0))}b=k[c>>2]|0;if(!((b|0)==(q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[w>>2]|0;if(b|0?(W=b+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){d=k[w>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[t>>2]|0;if(b|0)break;b=B1()|0;d=k[w>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[w>>2]=0}k[w>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[z>>2]|0)>0){d=k[u>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[x>>2]|0;if(!((b|0)==(y|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[E>>2]|0;do if(b|0){W=b+12|0;X=k[W>>2]|0;k[W>>2]=X+-1;if((X|0)!=1)break;d=k[E>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[B>>2]|0;if(b|0)break;b=B1()|0;d=k[E>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[E>>2]=0}while(0);k[E>>2]=0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[J>>2]|0)>0){d=k[F>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[J>>2]|0))}b=k[G>>2]|0;if(!((b|0)==(I|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[M>>2]|0;do if(b|0){W=b+12|0;X=k[W>>2]|0;k[W>>2]=X+-1;if((X|0)!=1)break;d=k[M>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[K>>2]|0;if(b|0)break;b=B1()|0;d=k[M>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[M>>2]=0}while(0);k[M>>2]=0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[O>>2]|0)>0){d=k[N>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[O>>2]|0))}b=k[P>>2]|0;if(!((b|0)==(R|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[qa+8>>2]=0;k[qa+12>>2]=0;k[qa>>2]=16842752;k[qa+4>>2]=ua;xa=+o[a+12>>2];b=pa+4|0;a=b+4|0;k[a>>2]=0;k[a+4>>2]=0;k[pa>>2]=33619968;k[b>>2]=ua;ZZ(qa,1.0/xa,pa);b=k[C>>2]|0;do if(b|0){pa=b+12|0;qa=k[pa>>2]|0;k[pa>>2]=qa+-1;if((qa|0)!=1)break;d=k[C>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[A>>2]|0;if(b|0)break;b=B1()|0;d=k[C>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[C>>2]=0}while(0);k[C>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[ba>>2]|0)>0){d=k[Z>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ba>>2]|0))}b=k[_>>2]|0;if(!((b|0)==($|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[ca>>2]|0;do if(b|0){pa=b+12|0;qa=k[pa>>2]|0;k[pa>>2]=qa+-1;if((qa|0)!=1)break;d=k[ca>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[ra+32>>2]|0;if(b|0)break;b=B1()|0;d=k[ca>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[ca>>2]=0}while(0);k[ca>>2]=0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[ga>>2]|0)>0){d=k[da>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ga>>2]|0))}b=k[ea>>2]|0;if(!((b|0)==(ha|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[S>>2]|0;do if(b|0){qa=b+12|0;ra=k[qa>>2]|0;k[qa>>2]=ra+-1;if((ra|0)!=1)break;d=k[S>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Q>>2]|0;if(b|0)break;b=B1()|0;d=k[S>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[S>>2]=0}while(0);k[S>>2]=0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[ma>>2]|0)>0){d=k[la>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ma>>2]|0))}b=k[na>>2]|0;if(!((b|0)==(oa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[ta>>2]|0;do if(b|0){ra=b+4|0;ta=k[ra>>2]|0;k[ra>>2]=ta+-1;if((ta|0)!=1)break;Uh[k[(k[b>>2]|0)+8>>2]&2047](b)}while(0);b=k[ja>>2]|0;do if(b|0){ra=b+12|0;ta=k[ra>>2]|0;k[ra>>2]=ta+-1;if((ta|0)!=1)break;d=k[ja>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[fa>>2]|0;if(b|0)break;b=B1()|0;d=k[ja>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[ja>>2]=0}while(0);k[ja>>2]=0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[ka>>2]|0)>0){d=k[ua+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ka>>2]|0))}b=k[ua+44>>2]|0;if(!((b|0)==(ua+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=va+36|0;b=k[e>>2]|0;do if(b|0){ta=b+12|0;ua=k[ta>>2]|0;k[ta>>2]=ua+-1;if((ua|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[va+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;e=va+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[e>>2]|0)>0){d=k[sa>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[va+44>>2]|0;if((b|0)==(va+48|0)|(b|0)==0){r=wa;return}ggb(k[b+-4>>2]|0);r=wa;return}function B4a(a){a=a|0;return +(+o[a+12>>2])}function C4a(a,b){a=a|0;b=+b;o[a+12>>2]=b;return}function D4a(a){a=a|0;return +(+o[a+20>>2])}function E4a(a,b){a=a|0;b=+b;o[a+20>>2]=b;return}function F4a(a){a=a|0;return +(+o[a+16>>2])}function G4a(a,b){a=a|0;b=+b;o[a+16>>2]=b;return}function H4a(a){a=a|0;return +(+o[a+28>>2])}function I4a(a,b){a=a|0;b=+b;o[a+28>>2]=b;return}function J4a(a){a=a|0;return +(+o[a+24>>2])}function K4a(a,b){a=a|0;b=+b;o[a+24>>2]=b;return}function L4a(a){a=a|0;ggb(a);return}function M4a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function N4a(a){a=a|0;var b=0,c=0;k[a>>2]=151552;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b)return;a=b+-4|0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)!=1)return;ggb(k[b+-8>>2]|0);return}function O4a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=151552;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b){ggb(a);return}d=b+-4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function P4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;f=g+4|0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=4;i[e+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+4|0)|0;k[g>>2]=0;f=g+4|0;k[f>>2]=0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=5;i[e+9>>0]=0;i[c>>0]=i[399978]|0;i[c+1>>0]=i[399979]|0;i[c+2>>0]=i[399980]|0;i[c+3>>0]=i[399981]|0;i[c+4>>0]=i[399982]|0;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=g4a(b,a+12|0)|0;d=g+4|0;e=ZT(16)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[d>>2]=9;i[e+13>>0]=0;e=400376;f=c+9|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));b=z6(b,g)|0;c=k[g>>2]|0;k[d>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=g4a(b,a+16|0)|0;d=g+4|0;e=ZT(16)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[d>>2]=11;i[e+15>>0]=0;e=400386;f=c+11|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));b=z6(b,g)|0;c=k[g>>2]|0;k[d>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=g4a(b,a+20|0)|0;d=g+4|0;e=ZT(16)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[d>>2]=11;i[e+15>>0]=0;e=400398;f=c+11|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));b=z6(b,g)|0;c=k[g>>2]|0;k[d>>2]=0;k[g>>2]=0;if(!c){g=a+24|0;g4a(b,g)|0;r=h;return}f=c+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){g=a+24|0;g4a(b,g)|0;r=h;return}ggb(k[c+-8>>2]|0);g=a+24|0;g4a(b,g)|0;r=h;return}function Q4a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0;q=r;r=r+16|0;m=q;n=b+4|0;c=k6(k[b>>2]|0,k[n>>2]|0,401026)|0;do if((c|0)!=0?(k[c>>2]&7|0)==3:0){k[m>>2]=0;j=m+4|0;k[j>>2]=0;J6(c,m,m);h=k[m>>2]|0;c=k[a+4>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[m>>2]=0;if(h|0?(j=h+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[h+-8>>2]|0);break}f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[m>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c)l=14}else l=14;while(0);if((l|0)==14){c=m+4|0;e=ZT(40)|0;k[e>>2]=1;f=e+4|0;k[m>>2]=f;k[c>>2]=33;i[e+37>>0]=0;g=399944;h=f+33|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,m,401059,399877,352);k[c>>2]=0;k[m>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}c=k6(k[b>>2]|0,k[n>>2]|0,399978)|0;a:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break a}case 2:{d=+p[c+8>>3];break a}default:{d=1000000015047466219876688.0e6;break a}}while(0);o[a+12>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,400376)|0;b:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break b}case 2:{d=+p[c+8>>3];break b}default:{d=1000000015047466219876688.0e6;break b}}while(0);o[a+16>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,400386)|0;c:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break c}case 2:{d=+p[c+8>>3];break c}default:{d=1000000015047466219876688.0e6;break c}}while(0);o[a+20>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,400398)|0;if(!c){d=0.0;a=a+24|0;o[a>>2]=d;r=q;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+24|0;o[a>>2]=d;r=q;return}case 2:{d=+p[c+8>>3];a=a+24|0;o[a>>2]=d;r=q;return}default:{d=1000000015047466219876688.0e6;a=a+24|0;o[a>>2]=d;r=q;return}}}function R4a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0.0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0.0;Pb=r;r=r+1616|0;Ib=Pb+1072|0;u=Pb+1056|0;v=Pb+1024|0;Eb=Pb+992|0;Ob=Pb+1544|0;s=Pb+1600|0;Nb=Pb+1488|0;Mb=Pb+1480|0;Kb=Pb+1424|0;Jb=Pb+1368|0;t=Pb+960|0;w=Pb+928|0;Fb=Pb+1352|0;Gb=Pb+1296|0;Ab=Pb+704|0;Hb=Pb+480|0;Bb=Pb+448|0;Cb=Pb+224|0;Db=Pb;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[Ob>>2]=k[f>>2];l=Ob+4|0;b=f+4|0;k[l>>2]=k[b>>2];Lb=Ob+8|0;k[Lb>>2]=k[f+8>>2];k[Ob+12>>2]=k[f+12>>2];m=Ob+16|0;k[m>>2]=k[f+16>>2];k[Ob+20>>2]=k[f+20>>2];k[Ob+24>>2]=k[f+24>>2];k[Ob+28>>2]=k[f+28>>2];k[Ob+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[Ob+36>>2]=d;e=Ob+40|0;k[e>>2]=Lb;Lb=Ob+48|0;h=Ob+44|0;k[h>>2]=Lb;k[Ob+52>>2]=0;k[Lb>>2]=0;if(d|0){Lb=d+12|0;k[Lb>>2]=(k[Lb>>2]|0)+1}if((k[b>>2]|0)<3){zb=k[f+44>>2]|0;Lb=k[h>>2]|0;k[Lb>>2]=k[zb>>2];k[Lb+4>>2]=k[zb+4>>2];break}k[l>>2]=0;x1(Ob,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{Q1(Ob,b,-1);m=Ob+16|0}while(0);if(k[m>>2]|0){e=k[Ob+4>>2]|0;if((e|0)<3)b=aa(k[Ob+12>>2]|0,k[Ob+8>>2]|0)|0;else{f=k[Ob+40>>2]|0;d=0;b=1;do{b=aa(k[f+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if(!b)q=16}else q=16;if((q|0)==16){k[Ib>>2]=0;b=Ib+4|0;k[b>>2]=0;d=ZT(20)|0;k[d>>2]=1;mb=d+4|0;k[Ib>>2]=mb;k[b>>2]=12;i[d+16>>0]=0;e=401621;nb=mb+12|0;do{i[mb>>0]=i[e>>0]|0;mb=mb+1|0;e=e+1|0}while((mb|0)<(nb|0));Y8(-215,Ib,399869,399877,289);k[b>>2]=0;k[Ib>>2]=0;Lb=k[d>>2]|0;k[d>>2]=Lb+-1;if((Lb|0)==1)ggb(k[d+-4>>2]|0)}Lb=Ob+40|0;yb=k[Lb>>2]|0;zb=k[yb>>2]|0;k[s>>2]=k[yb+4>>2];k[s+4>>2]=zb;x2(c,s,21,0);do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[Nb>>2]=k[f>>2];l=Nb+4|0;b=f+4|0;k[l>>2]=k[b>>2];zb=Nb+8|0;k[zb>>2]=k[f+8>>2];k[Nb+12>>2]=k[f+12>>2];k[Nb+16>>2]=k[f+16>>2];k[Nb+20>>2]=k[f+20>>2];k[Nb+24>>2]=k[f+24>>2];k[Nb+28>>2]=k[f+28>>2];k[Nb+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[Nb+36>>2]=d;e=Nb+40|0;k[e>>2]=zb;zb=Nb+48|0;h=Nb+44|0;k[h>>2]=zb;k[Nb+52>>2]=0;k[zb>>2]=0;if(d|0){zb=d+12|0;k[zb>>2]=(k[zb>>2]|0)+1}if((k[b>>2]|0)<3){yb=k[f+44>>2]|0;zb=k[h>>2]|0;k[zb>>2]=k[yb>>2];k[zb+4>>2]=k[yb+4>>2];break}k[l>>2]=0;x1(Nb,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(Nb,c,-1);while(0);Y3a(Mb,1.0);rb=Mb+4|0;yb=k[rb>>2]|0;b=k[(k[yb>>2]|0)+32>>2]|0;k[Ib+8>>2]=0;k[Ib+12>>2]=0;k[Ib>>2]=16842752;k[Ib+4>>2]=Ob;wb=u+4|0;mb=wb+4|0;k[mb>>2]=0;k[mb+4>>2]=0;k[u>>2]=33619968;k[wb>>2]=Nb;Ph[b&511](yb,Ib,u);k[Kb>>2]=1124007936;yb=Kb+4|0;b=Kb+8|0;wb=Kb+40|0;mb=yb;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[wb>>2]=b;zb=Kb+48|0;xb=Kb+44|0;k[xb>>2]=zb;k[Kb+52>>2]=0;k[zb>>2]=0;k[Ib+8>>2]=0;k[Ib+12>>2]=0;k[Ib>>2]=16842752;k[Ib+4>>2]=Nb;tb=u+4|0;b=tb+4|0;k[b>>2]=0;k[b+4>>2]=0;k[u>>2]=33619968;k[tb>>2]=Kb;$aa(Ib,u,7,0);k[Jb>>2]=1124007936;tb=Jb+4|0;b=Jb+8|0;sb=Jb+40|0;mb=tb;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[sb>>2]=b;vb=Jb+48|0;ub=Jb+44|0;k[ub>>2]=vb;k[Jb+52>>2]=0;k[vb>>2]=0;k[Ib+8>>2]=0;k[Ib+12>>2]=0;k[Ib>>2]=16842752;k[Ib+4>>2]=Kb;p[v>>3]=.0001;p[v+8>>3]=.0001;p[v+16>>3]=.0001;p[v+24>>3]=.0001;k[u>>2]=-1056833530;k[u+4>>2]=v;k[u+8>>2]=1;k[u+12>>2]=4;f=Eb+4|0;qb=f+4|0;k[qb>>2]=0;k[qb+4>>2]=0;k[Eb>>2]=33619968;k[f>>2]=Jb;aU(Ib,u,Eb,49332,39872,0,14);k[Ib+8>>2]=0;k[Ib+12>>2]=0;k[Ib>>2]=16842752;k[Ib+4>>2]=Jb;f=u+4|0;qb=f+4|0;k[qb>>2]=0;k[qb+4>>2]=0;k[u>>2]=33619968;k[f>>2]=Jb;YZ(Ib,u);k[Ib+8>>2]=0;k[Ib+12>>2]=0;k[Ib>>2]=16842752;k[Ib+4>>2]=Jb;g7(t,Ib);n=+p[t>>3];f=k[tb>>2]|0;if((f|0)<3)b=aa(k[Jb+12>>2]|0,k[b>>2]|0)|0;else{e=k[sb>>2]|0;d=0;b=1;do{b=aa(k[e+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(f|0))}n=n/+(b>>>0);k[Ib+8>>2]=0;k[Ib+12>>2]=0;k[Ib>>2]=16842752;k[Ib+4>>2]=Jb;L7(Ib,u,v,0,0,49332);qb=Jb+36|0;b=k[qb>>2]|0;if(b|0?(ob=b+12|0,pb=k[ob>>2]|0,k[ob>>2]=pb+-1,(pb|0)==1):0){d=k[qb>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Jb+32>>2]|0;if(!b){b=B1()|0;d=k[qb>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[qb>>2]=0}k[qb>>2]=0;pb=Jb+16|0;k[pb>>2]=0;k[pb+4>>2]=0;k[pb+8>>2]=0;k[pb+12>>2]=0;if((k[tb>>2]|0)>0){d=k[sb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[tb>>2]|0))}lb=+p[v>>3];n=+R(+((lb-n)/(lb-+p[u>>3])),1.399999976158142)*.699999988079071+.30000001192092896;ob=a+16|0;lb=+Z(+-+o[ob>>2]);o[ob>>2]=lb;k[Ib+8>>2]=0;k[Ib+12>>2]=0;k[Ib>>2]=16842752;k[Ib+4>>2]=Nb;u7(Eb,Ib,49332);k[Ib+8>>2]=0;k[Ib+12>>2]=0;k[Ib>>2]=16842752;k[Ib+4>>2]=Kb;u7(w,Ib,49332);lb=+p[w>>3];k[Fb>>2]=0;g=Fb+4|0;k[g>>2]=0;k[Fb+8>>2]=0;while(1){b=fgb(168)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[Fb>>2]=b;f=b+168|0;k[Fb+8>>2]=f;k[b>>2]=1124007936;d=b+8|0;e=b+40|0;mb=b+4|0;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[e>>2]=d;d=b+48|0;k[b+44>>2]=d;k[b+52>>2]=0;k[d>>2]=0;k[b+56>>2]=1124007936;d=b+64|0;e=b+96|0;mb=b+60|0;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[e>>2]=d;d=b+104|0;k[b+100>>2]=d;k[b+108>>2]=0;k[d>>2]=0;k[b+112>>2]=1124007936;d=b+120|0;e=b+152|0;mb=b+116|0;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[e>>2]=d;Za=b+160|0;k[b+156>>2]=Za;k[b+164>>2]=0;k[Za>>2]=0;k[g>>2]=f;k[Ib+8>>2]=0;k[Ib+12>>2]=0;k[Ib>>2]=16842752;k[Ib+4>>2]=Nb;Za=Gb+4|0;_a=Za+4|0;k[_a>>2]=0;k[_a+4>>2]=0;k[Gb>>2]=33882112;k[Za>>2]=Fb;FV(Ib,Gb);Za=a+24|0;_a=Gb+4|0;$a=Gb+8|0;ab=Gb+40|0;bb=Gb+48|0;cb=Gb+44|0;db=Gb+52|0;eb=a+20|0;fb=Bb+8|0;gb=Ib+8|0;hb=Ib+12|0;ib=Ib+4|0;jb=Bb+4|0;kb=jb+4|0;f=Bb+8|0;g=Bb+12|0;h=Bb+4|0;j=Gb+36|0;l=Gb+16|0;q=Ab+4|0;c=Ab+8|0;s=Ab+12|0;t=Ab+16|0;u=Ab+48|0;v=Ab+56|0;w=Ab+52|0;y=Ab+60|0;z=Ab+64|0;A=Ab+68|0;B=Ab+72|0;C=Ab+104|0;D=Ab+112|0;E=Ab+108|0;F=Ab+116|0;G=Ab+120|0;H=Ab+124|0;I=Ab+128|0;J=Ab+160|0;K=Ab+168|0;L=Ab+164|0;M=Ib+4|0;N=Ib+8|0;O=Ib+12|0;P=Ib+16|0;Q=Ib+48|0;S=Ib+56|0;T=Ib+52|0;U=Ib+60|0;V=Ib+64|0;W=Ib+68|0;X=Ib+72|0;Y=Ib+104|0;_=Ib+112|0;$=Ib+108|0;ba=Ib+116|0;ca=Ib+120|0;da=Ib+124|0;ea=Ib+128|0;fa=Ib+160|0;ga=Ib+168|0;ha=Ib+164|0;ia=Db+4|0;ja=Db+8|0;ka=Db+12|0;la=Db+16|0;ma=Db+48|0;na=Db+56|0;oa=Db+52|0;pa=Db+60|0;qa=Db+64|0;ra=Db+68|0;sa=Db+72|0;ta=Db+104|0;ua=Db+112|0;va=Db+108|0;wa=Db+116|0;xa=Db+120|0;ya=Db+124|0;za=Db+128|0;Aa=Db+160|0;Ba=Db+168|0;Ca=Db+164|0;Da=Cb+4|0;Ea=Cb+8|0;Fa=Cb+12|0;Ga=Cb+16|0;Ha=Cb+48|0;Ia=Cb+56|0;Ja=Cb+52|0;Ka=Cb+60|0;La=Cb+64|0;Ma=Cb+68|0;Na=Cb+72|0;Oa=Cb+104|0;Pa=Cb+112|0;Qa=Cb+108|0;Ra=Cb+116|0;Sa=Cb+120|0;Ta=Cb+124|0;Ua=Cb+128|0;Va=Cb+160|0;Wa=Cb+168|0;Xa=Cb+164|0;Ya=Gb+32|0;e=0;do{Qb=+o[Za>>2];x=lb*(1.0-Qb)+Qb*+p[Eb+(e<<3)>>3];c1(Ib,Qb,(k[Fb>>2]|0)+(e*56|0)|0);c1(Hb,1.0-+o[Za>>2],Kb);k[Ab>>2]=0;k[q>>2]=0;k[c>>2]=1124007936;mb=s;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[u>>2]=t;k[w>>2]=v;k[y>>2]=0;k[v>>2]=0;k[z>>2]=1124007936;mb=A;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[C>>2]=B;k[E>>2]=D;k[F>>2]=0;k[D>>2]=0;k[G>>2]=1124007936;mb=H;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[J>>2]=I;k[L>>2]=K;mb=K;nb=mb+56|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));mb=k[Ib>>2]|0;dh[k[(k[mb>>2]|0)+52>>2]&255](mb,Ib,Hb,Ab);k[Gb>>2]=1124007936;mb=_a;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[ab>>2]=$a;k[cb>>2]=bb;k[db>>2]=0;k[bb>>2]=0;mb=k[Ab>>2]|0;dh[k[(k[mb>>2]|0)+12>>2]&255](mb,Ab,Gb,-1);XN(Ab);XN(Hb);XN(Ib);c1(Hb,+o[eb>>2],Gb);p[Bb>>3]=x*(1.0-+o[eb>>2]);k[fb>>2]=0;k[fb+4>>2]=0;k[fb+8>>2]=0;k[fb+12>>2]=0;k[fb+16>>2]=0;k[fb+20>>2]=0;k[Ib>>2]=0;k[M>>2]=0;k[N>>2]=1124007936;mb=O;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[Q>>2]=P;k[T>>2]=S;k[U>>2]=0;k[S>>2]=0;k[V>>2]=1124007936;mb=W;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[Y>>2]=X;k[$>>2]=_;k[ba>>2]=0;k[_>>2]=0;k[ca>>2]=1124007936;mb=da;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[fa>>2]=ea;k[ha>>2]=ga;mb=ga;nb=mb+56|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));b=k[Hb>>2]|0;dh[k[(k[b>>2]|0)+56>>2]&255](b,Hb,Bb,Ib);b=k[Ib>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,Ib,Gb,-1);XN(Ib);XN(Hb);c1(Hb,+o[ob>>2],Gb);k[gb>>2]=0;k[hb>>2]=0;k[Ib>>2]=-1056571392;k[ib>>2]=Hb;b=kb;k[b>>2]=0;k[b+4>>2]=0;k[Bb>>2]=33619968;k[jb>>2]=Gb;ZZ(Ib,n,Bb);XN(Hb);b=(k[Fb>>2]|0)+(e*56|0)|0;k[Db>>2]=0;k[ia>>2]=0;k[ja>>2]=1124007936;mb=ka;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[ma>>2]=la;k[oa>>2]=na;k[pa>>2]=0;k[na>>2]=0;k[qa>>2]=1124007936;mb=ra;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[ta>>2]=sa;k[va>>2]=ua;k[wa>>2]=0;k[ua>>2]=0;k[xa>>2]=1124007936;mb=ya;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[Aa>>2]=za;k[Ca>>2]=Ba;mb=Ba;nb=mb+56|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[Ib>>2]=0;k[Ib+4>>2]=0;k[Ib+8>>2]=0;k[Ib+12>>2]=0;k[Ib+16>>2]=0;k[Ib+20>>2]=0;k[Ib+24>>2]=0;k[Ib+28>>2]=0;G0(Db,Gb,b,1.0,1.0,Ib);k[Cb>>2]=0;k[Da>>2]=0;k[Ea>>2]=1124007936;mb=Fa;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[Ha>>2]=Ga;k[Ja>>2]=Ia;k[Ka>>2]=0;k[Ia>>2]=0;k[La>>2]=1124007936;mb=Ma;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[Oa>>2]=Na;k[Qa>>2]=Pa;k[Ra>>2]=0;k[Pa>>2]=0;k[Sa>>2]=1124007936;mb=Ta;nb=mb+36|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));k[Va>>2]=Ua;k[Xa>>2]=Wa;mb=Wa;nb=mb+56|0;do{k[mb>>2]=0;mb=mb+4|0}while((mb|0)<(nb|0));nb=k[Db>>2]|0;Zh[k[(k[nb>>2]|0)+80>>2]&7](nb,1.0,Db,Cb);k[f>>2]=0;k[g>>2]=0;k[Bb>>2]=-1056571392;k[h>>2]=Cb;i1(Hb,b,Bb,1.0);nb=k[Hb>>2]|0;dh[k[(k[nb>>2]|0)+12>>2]&255](nb,Hb,b,-1);XN(Hb);XN(Cb);XN(Db);b=k[j>>2]|0;if(b|0?(mb=b+12|0,nb=k[mb>>2]|0,k[mb>>2]=nb+-1,(nb|0)==1):0){d=k[j>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Ya>>2]|0;if(!b){b=B1()|0;d=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[j>>2]=0}k[j>>2]=0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[_a>>2]|0)>0){d=k[ab>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[_a>>2]|0))}b=k[cb>>2]|0;if(!((b|0)==(bb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=e+1|0}while((e|0)<3);f=Kb+36|0;b=k[f>>2]|0;if(b|0?(Db=b+12|0,Eb=k[Db>>2]|0,k[Db>>2]=Eb+-1,(Eb|0)==1):0){d=k[f>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Kb+32>>2]|0;if(!b){b=B1()|0;d=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[f>>2]=0}k[f>>2]=0;e=Kb+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[yb>>2]|0)>0){d=k[wb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[yb>>2]|0))}k[Gb+8>>2]=0;k[Gb+12>>2]=0;k[Gb>>2]=17104896;k[Gb+4>>2]=Fb;Eb=Hb+4|0;b=Eb+4|0;k[b>>2]=0;k[b+4>>2]=0;k[Hb>>2]=33619968;k[Eb>>2]=Nb;k[Ib>>2]=0;Eb=Ib+4|0;k[Eb>>2]=0;k[Ib+8>>2]=0;B2(Gb,Ib);b=k[Ib>>2]|0;Eb=k[Eb>>2]|0;GV((b|0)==(Eb|0)?0:b,(Eb-b|0)/56|0,Hb);zF(Ib);b=k[rb>>2]|0;gh[k[(k[b>>2]|0)+40>>2]&255](b,+o[a+12>>2]);Hb=k[(k[b>>2]|0)+32>>2]|0;k[Ib+8>>2]=0;k[Ib+12>>2]=0;k[Ib>>2]=16842752;k[Ib+4>>2]=Nb;a=Gb+4|0;Eb=a+4|0;k[Eb>>2]=0;k[Eb+4>>2]=0;k[Gb>>2]=33619968;k[a>>2]=Nb;Ph[Hb&511](b,Ib,Gb);zF(Fb);b=k[qb>>2]|0;if(b|0?(Hb=b+12|0,Ib=k[Hb>>2]|0,k[Hb>>2]=Ib+-1,(Ib|0)==1):0){d=k[qb>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Jb+32>>2]|0;if(!b){b=B1()|0;d=k[qb>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[qb>>2]=0}k[qb>>2]=0;k[pb>>2]=0;k[pb+4>>2]=0;k[pb+8>>2]=0;k[pb+12>>2]=0;if((k[tb>>2]|0)>0){d=k[sb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[tb>>2]|0))}b=k[ub>>2]|0;if(!((b|0)==(vb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[f>>2]|0;if(b|0?(Ib=b+12|0,Jb=k[Ib>>2]|0,k[Ib>>2]=Jb+-1,(Jb|0)==1):0){d=k[f>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Kb+32>>2]|0;if(!b){b=B1()|0;d=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[f>>2]=0}k[f>>2]=0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[yb>>2]|0)>0){d=k[wb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[yb>>2]|0))}b=k[xb>>2]|0;if(!((b|0)==(zb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Mb>>2]|0;if(b|0?(Kb=b+4|0,Mb=k[Kb>>2]|0,k[Kb>>2]=Mb+-1,(Mb|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);e=Nb+36|0;b=k[e>>2]|0;if(b|0?(Kb=b+12|0,Mb=k[Kb>>2]|0,k[Kb>>2]=Mb+-1,(Mb|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Nb+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;Mb=Nb+16|0;d=Nb+4|0;k[Mb>>2]=0;k[Mb+4>>2]=0;k[Mb+8>>2]=0;k[Mb+12>>2]=0;if((k[d>>2]|0)>0){e=k[Nb+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[Nb+44>>2]|0;if(!((b|0)==(Nb+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=Ob+36|0;b=k[e>>2]|0;do if(b|0){Mb=b+12|0;Nb=k[Mb>>2]|0;k[Mb>>2]=Nb+-1;if((Nb|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Ob+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;e=Ob+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[e>>2]|0)>0){d=k[Lb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Ob+44>>2]|0;if((b|0)==(Ob+48|0)|(b|0)==0){r=Pb;return}ggb(k[b+-4>>2]|0);r=Pb;return}function S4a(a){a=a|0;return +(+o[a+12>>2])}function T4a(a,b){a=a|0;b=+b;o[a+12>>2]=b;return}function U4a(a){a=a|0;return +(+o[a+16>>2])}function V4a(a,b){a=a|0;b=+b;o[a+16>>2]=b;return}function W4a(a){a=a|0;return +(+o[a+20>>2])}function X4a(a,b){a=a|0;b=+b;o[a+20>>2]=b;return}function Y4a(a){a=a|0;return +(+o[a+24>>2])}function Z4a(a,b){a=a|0;b=+b;o[a+24>>2]=b;return}function _4a(a){a=a|0;ggb(a);return}function $4a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function a5a(a){a=a|0;var b=0,c=0;k[a>>2]=151648;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b)return;a=b+-4|0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)!=1)return;ggb(k[b+-8>>2]|0);return}function b5a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=151648;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b){ggb(a);return}d=b+-4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function c5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;f=g+4|0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=4;i[e+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+4|0)|0;f=g+4|0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=5;i[e+9>>0]=0;i[c>>0]=i[399978]|0;i[c+1>>0]=i[399979]|0;i[c+2>>0]=i[399980]|0;i[c+3>>0]=i[399981]|0;i[c+4>>0]=i[399982]|0;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=g4a(b,a+12|0)|0;f=g+4|0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=5;i[e+9>>0]=0;i[c>>0]=i[400530]|0;i[c+1>>0]=i[400531]|0;i[c+2>>0]=i[400532]|0;i[c+3>>0]=i[400533]|0;i[c+4>>0]=i[400534]|0;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=g4a(b,a+16|0)|0;f=g+4|0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[f>>2]=10;i[d+14>>0]=0;d=400097;e=c+10|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(!c){g=a+20|0;g4a(b,g)|0;r=h;return}f=c+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){g=a+20|0;g4a(b,g)|0;r=h;return}ggb(k[c+-8>>2]|0);g=a+20|0;g4a(b,g)|0;r=h;return}function d5a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0;q=r;r=r+16|0;m=q;n=b+4|0;c=k6(k[b>>2]|0,k[n>>2]|0,401026)|0;do if((c|0)!=0?(k[c>>2]&7|0)==3:0){k[m>>2]=0;j=m+4|0;k[j>>2]=0;J6(c,m,m);h=k[m>>2]|0;c=k[a+4>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[m>>2]=0;if(h|0?(j=h+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[h+-8>>2]|0);break}f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[m>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c)l=14}else l=14;while(0);if((l|0)==14){c=m+4|0;e=ZT(40)|0;k[e>>2]=1;f=e+4|0;k[m>>2]=f;k[c>>2]=33;i[e+37>>0]=0;g=399944;h=f+33|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,m,401059,399877,458);k[c>>2]=0;k[m>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}c=k6(k[b>>2]|0,k[n>>2]|0,399978)|0;a:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break a}case 2:{d=+p[c+8>>3];break a}default:{d=1000000015047466219876688.0e6;break a}}while(0);o[a+12>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,400530)|0;b:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break b}case 2:{d=+p[c+8>>3];break b}default:{d=1000000015047466219876688.0e6;break b}}while(0);o[a+16>>2]=d;c=k6(k[b>>2]|0,k[n>>2]|0,400097)|0;if(!c){d=0.0;a=a+20|0;o[a>>2]=d;r=q;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+20|0;o[a>>2]=d;r=q;return}case 2:{d=+p[c+8>>3];a=a+20|0;o[a>>2]=d;r=q;return}default:{d=1000000015047466219876688.0e6;a=a+20|0;o[a>>2]=d;r=q;return}}}function e5a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0.0;bb=r;r=r+1408|0;Ia=bb+256|0;Xa=bb+1392|0;Ya=bb+224|0;Wa=bb+1328|0;ab=bb+1272|0;q=bb+1384|0;$a=bb+1160|0;_a=bb+1152|0;V=bb+1096|0;C=bb+928|0;u=bb+1216|0;N=bb+648|0;Ra=bb+592|0;Ka=bb+536|0;la=bb+480|0;D=bb+1040|0;Ha=bb;O=bb+984|0;ua=bb+872|0;va=bb+816|0;wa=bb+760|0;xa=bb+704|0;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[ab>>2]=k[f>>2];l=ab+4|0;b=f+4|0;k[l>>2]=k[b>>2];Za=ab+8|0;k[Za>>2]=k[f+8>>2];k[ab+12>>2]=k[f+12>>2];m=ab+16|0;k[m>>2]=k[f+16>>2];k[ab+20>>2]=k[f+20>>2];k[ab+24>>2]=k[f+24>>2];k[ab+28>>2]=k[f+28>>2];k[ab+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[ab+36>>2]=d;e=ab+40|0;k[e>>2]=Za;Za=ab+48|0;h=ab+44|0;k[h>>2]=Za;k[ab+52>>2]=0;k[Za>>2]=0;if(d|0){Za=d+12|0;k[Za>>2]=(k[Za>>2]|0)+1}if((k[b>>2]|0)<3){Va=k[f+44>>2]|0;Za=k[h>>2]|0;k[Za>>2]=k[Va>>2];k[Za+4>>2]=k[Va+4>>2];break}k[l>>2]=0;x1(ab,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{Q1(ab,b,-1);m=ab+16|0}while(0);if(k[m>>2]|0){e=k[ab+4>>2]|0;if((e|0)<3)b=aa(k[ab+12>>2]|0,k[ab+8>>2]|0)|0;else{f=k[ab+40>>2]|0;d=0;b=1;do{b=aa(k[f+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if(!b)n=16}else n=16;if((n|0)==16){k[Ia>>2]=0;b=Ia+4|0;k[b>>2]=0;d=ZT(20)|0;k[d>>2]=1;f=d+4|0;k[Ia>>2]=f;k[b>>2]=12;i[d+16>>0]=0;e=401621;g=f+12|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,Ia,399869,399877,383);k[b>>2]=0;k[Ia>>2]=0;Za=k[d>>2]|0;k[d>>2]=Za+-1;if((Za|0)==1)ggb(k[d+-4>>2]|0)}Za=ab+40|0;Ua=k[Za>>2]|0;Va=k[Ua>>2]|0;k[q>>2]=k[Ua+4>>2];k[q+4>>2]=Va;x2(c,q,21,0);do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[$a>>2]=k[f>>2];l=$a+4|0;b=f+4|0;k[l>>2]=k[b>>2];Va=$a+8|0;k[Va>>2]=k[f+8>>2];k[$a+12>>2]=k[f+12>>2];k[$a+16>>2]=k[f+16>>2];k[$a+20>>2]=k[f+20>>2];k[$a+24>>2]=k[f+24>>2];k[$a+28>>2]=k[f+28>>2];k[$a+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[$a+36>>2]=d;e=$a+40|0;k[e>>2]=Va;Va=$a+48|0;h=$a+44|0;k[h>>2]=Va;k[$a+52>>2]=0;k[Va>>2]=0;if(d|0){Va=d+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[b>>2]|0)<3){Ua=k[f+44>>2]|0;Va=k[h>>2]|0;k[Va>>2]=k[Ua>>2];k[Va+4>>2]=k[Ua+4>>2];break}k[l>>2]=0;x1($a,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1($a,c,-1);while(0);Y3a(_a,1.0);ya=_a+4|0;Ta=k[ya>>2]|0;R=k[(k[Ta>>2]|0)+32>>2]|0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;k[Ia>>2]=16842752;k[Ia+4>>2]=ab;Sa=Xa+4|0;f=Sa+4|0;k[f>>2]=0;k[f+4>>2]=0;k[Xa>>2]=33619968;k[Sa>>2]=$a;Ph[R&511](Ta,Ia,Xa);k[V>>2]=1124007936;Ta=V+4|0;R=V+8|0;Sa=V+40|0;f=Ta;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Sa>>2]=R;Va=V+48|0;Ua=V+44|0;k[Ua>>2]=Va;k[V+52>>2]=0;k[Va>>2]=0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;k[Ia>>2]=16842752;k[Ia+4>>2]=$a;Oa=Xa+4|0;v=Oa+4|0;k[v>>2]=0;k[v+4>>2]=0;k[Xa>>2]=33619968;k[Oa>>2]=V;$aa(Ia,Xa,7,0);k[C>>2]=1124007936;Oa=C+4|0;v=C+8|0;La=C+40|0;f=Oa;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[La>>2]=v;Qa=C+48|0;Pa=C+44|0;k[Pa>>2]=Qa;k[C+52>>2]=0;k[Qa>>2]=0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;k[Ia>>2]=16842752;k[Ia+4>>2]=V;p[Ya>>3]=.0001;p[Ya+8>>3]=.0001;p[Ya+16>>3]=.0001;p[Ya+24>>3]=.0001;k[Xa>>2]=-1056833530;k[Xa+4>>2]=Ya;k[Xa+8>>2]=1;k[Xa+12>>2]=4;s=Wa+4|0;c=s+4|0;k[c>>2]=0;k[c+4>>2]=0;k[Wa>>2]=33619968;k[s>>2]=C;aU(Ia,Xa,Wa,49332,39872,0,14);k[Ia+8>>2]=0;k[Ia+12>>2]=0;k[Ia>>2]=16842752;k[Ia+4>>2]=C;s=Xa+4|0;c=s+4|0;k[c>>2]=0;k[c+4>>2]=0;k[Xa>>2]=33619968;k[s>>2]=C;YZ(Ia,Xa);k[Xa>>2]=0;s=Xa+4|0;k[s>>2]=0;k[Xa+8>>2]=0;k[Ya>>2]=0;k[Ya+4>>2]=0;k[Ya+8>>2]=0;k[u>>2]=k[C>>2];c=u+4|0;b=k[Oa>>2]|0;k[c>>2]=b;t=u+8|0;k[t>>2]=k[v>>2];w=C+12|0;k[u+12>>2]=k[w>>2];j=u+16|0;Ma=C+16|0;k[j>>2]=k[Ma>>2];x=C+20|0;k[u+20>>2]=k[x>>2];y=C+24|0;k[u+24>>2]=k[y>>2];z=C+28|0;k[u+28>>2]=k[z>>2];h=u+32|0;Ja=C+32|0;k[h>>2]=k[Ja>>2];l=u+36|0;Na=C+36|0;d=k[Na>>2]|0;k[l>>2]=d;n=u+40|0;k[n>>2]=t;t=u+48|0;q=u+44|0;k[q>>2]=t;k[u+52>>2]=0;k[t>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[Oa>>2]|0}if((b|0)>=3){k[c>>2]=0;x1(u,b,0,0,0);if((k[c>>2]|0)>0){d=k[La>>2]|0;e=k[n>>2]|0;f=k[Pa>>2]|0;g=k[q>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[c>>2]|0))}}else{Fa=k[Pa>>2]|0;Ga=k[q>>2]|0;k[Ga>>2]=k[Fa>>2];k[Ga+4>>2]=k[Fa+4>>2]}l5a(u,Xa,Ya);b=k[l>>2]|0;if(b|0?(Fa=b+12|0,Ga=k[Fa>>2]|0,k[Fa>>2]=Ga+-1,(Ga|0)==1):0){d=k[l>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[h>>2]|0;if(!b){b=B1()|0;d=k[l>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[l>>2]=0}k[l>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[c>>2]|0)>0){d=k[n>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[q>>2]|0;if(!((b|0)==(t|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[s>>2]|0;e=k[Xa>>2]|0;if((b|0)!=(e|0)){f=k[Ya>>2]|0;d=(b-e|0)/56|0;b=0;do{m5a(a,e+(b*56|0)|0);m5a(a,f+(b*56|0)|0);b=b+1|0}while(b>>>0<d>>>0)}e=k[Za>>2]|0;d=k[e+4>>2]|0;e=k[e>>2]|0;k[Wa>>2]=1124007936;Fa=Wa+4|0;b=Wa+8|0;Da=Wa+40|0;f=Fa;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Da>>2]=b;Ga=Wa+48|0;Ea=Wa+44|0;k[Ea>>2]=Ga;k[Wa+52>>2]=0;k[Ga>>2]=0;k[Ia>>2]=e;k[Ia+4>>2]=d;G1(Wa,2,Ia,5);n5a(Xa,Ya,Wa);k[N>>2]=1124007936;Aa=N+4|0;M=N+8|0;za=N+40|0;f=Aa;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[za>>2]=M;Ca=N+48|0;Ba=N+44|0;k[Ba>>2]=Ca;k[N+52>>2]=0;k[Ca>>2]=0;k[Ra>>2]=1124007936;sa=Ra+4|0;b=Ra+8|0;qa=Ra+40|0;f=sa;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[qa>>2]=b;ta=Ra+48|0;ra=Ra+44|0;k[ra>>2]=ta;k[Ra+52>>2]=0;k[ta>>2]=0;k[Ka>>2]=1124007936;oa=Ka+4|0;b=Ka+8|0;ma=Ka+40|0;f=oa;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[ma>>2]=b;pa=Ka+48|0;na=Ka+44|0;k[na>>2]=pa;k[Ka+52>>2]=0;k[pa>>2]=0;k[la>>2]=k[C>>2];ka=la+4|0;b=k[Oa>>2]|0;k[ka>>2]=b;W=la+8|0;k[W>>2]=k[v>>2];T=la+12|0;k[T>>2]=k[w>>2];ia=la+16|0;k[ia>>2]=k[Ma>>2];U=la+20|0;k[U>>2]=k[x>>2];S=la+24|0;k[S>>2]=k[y>>2];Q=la+28|0;k[Q>>2]=k[z>>2];ea=la+32|0;k[ea>>2]=k[Ja>>2];fa=la+36|0;d=k[Na>>2]|0;k[fa>>2]=d;ga=la+40|0;k[ga>>2]=W;ja=la+48|0;ha=la+44|0;k[ha>>2]=ja;k[la+52>>2]=0;k[ja>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[Oa>>2]|0}if((b|0)>=3){k[ka>>2]=0;x1(la,b,0,0,0);b=k[ka>>2]|0;if((b|0)>0){e=k[La>>2]|0;f=k[ga>>2]|0;g=k[Pa>>2]|0;h=k[ha>>2]|0;d=0;do{k[f+(d<<2)>>2]=k[e+(d<<2)>>2];k[h+(d<<2)>>2]=k[g+(d<<2)>>2];d=d+1|0;b=k[ka>>2]|0}while((d|0)<(b|0))}}else{da=k[Pa>>2]|0;b=k[ha>>2]|0;k[b>>2]=k[da>>2];k[b+4>>2]=k[da+4>>2];b=k[ka>>2]|0}k[D>>2]=k[la>>2];c=D+4|0;k[c>>2]=b;s=D+8|0;k[s>>2]=k[W>>2];k[D+12>>2]=k[T>>2];j=D+16|0;k[j>>2]=k[ia>>2];k[D+20>>2]=k[U>>2];k[D+24>>2]=k[S>>2];k[D+28>>2]=k[Q>>2];h=D+32|0;k[h>>2]=k[ea>>2];l=D+36|0;d=k[fa>>2]|0;k[l>>2]=d;n=D+40|0;k[n>>2]=s;s=D+48|0;q=D+44|0;k[q>>2]=s;k[D+52>>2]=0;k[s>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[ka>>2]|0}if((b|0)>=3){k[c>>2]=0;x1(D,b,0,0,0);if((k[c>>2]|0)>0){d=k[ga>>2]|0;e=k[n>>2]|0;f=k[ha>>2]|0;g=k[q>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[c>>2]|0))}}else{ca=k[ha>>2]|0;da=k[q>>2]|0;k[da>>2]=k[ca>>2];k[da+4>>2]=k[ca+4>>2]}o5a(D,Ra);b=k[l>>2]|0;if(b|0?(ca=b+12|0,da=k[ca>>2]|0,k[ca>>2]=da+-1,(da|0)==1):0){d=k[l>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[h>>2]|0;if(b|0)break;b=B1()|0;d=k[l>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[l>>2]=0}k[l>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[c>>2]|0)>0){d=k[n>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[q>>2]|0;if(!((b|0)==(s|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ha+8>>2]=1124007936;b=Ha+16|0;d=Ha+48|0;f=Ha+12|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=b;b=Ha+56|0;k[Ha+52>>2]=b;k[Ha+60>>2]=0;k[b>>2]=0;k[Ha+64>>2]=1124007936;b=Ha+72|0;d=Ha+104|0;f=Ha+68|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=b;b=Ha+112|0;k[Ha+108>>2]=b;k[Ha+116>>2]=0;k[b>>2]=0;k[Ha+120>>2]=1124007936;b=Ha+128|0;d=Ha+160|0;f=Ha+124|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=b;f=Ha+168|0;k[Ha+164>>2]=f;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Ia>>2]=0;k[Ia+4>>2]=0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;k[Ia+16>>2]=0;k[Ia+20>>2]=0;k[Ia+24>>2]=0;k[Ia+28>>2]=0;G0(Ha,Wa,Ra,1.0,-1.0,Ia);j=k[Ha>>2]|0;dh[k[(k[j>>2]|0)+12>>2]&255](j,Ha,Ra,-1);XN(Ha);j=Ia+4|0;l=j+4|0;k[l>>2]=0;k[l+4>>2]=0;k[Ia>>2]=33619968;k[j>>2]=N;mY(Ra,Ia);k[Ia+8>>2]=0;k[Ia+12>>2]=0;k[Ia>>2]=16842752;k[Ia+4>>2]=Wa;B=+r$(Wa,Ia)*1.0000001111620804e-06;k[Ia+8>>2]=0;k[Ia+12>>2]=0;k[Ia>>2]=16842752;k[Ia+4>>2]=Ra;j=O+4|0;l=O+8|0;n=O+12|0;c=N+12|0;q=O+16|0;ca=N+16|0;s=O+20|0;t=N+20|0;u=O+24|0;v=N+24|0;w=O+28|0;x=N+28|0;y=O+32|0;ba=N+32|0;z=O+36|0;da=N+36|0;C=O+40|0;D=O+48|0;E=O+44|0;F=O+52|0;G=Ia+8|0;H=Ia+12|0;I=Ia+4|0;J=Ia+8|0;K=Ia+12|0;L=Ia+4|0;h=0;A=+r$(Ra,Ia);do{k[O>>2]=k[N>>2];b=k[Aa>>2]|0;k[j>>2]=b;k[l>>2]=k[M>>2];k[n>>2]=k[c>>2];k[q>>2]=k[ca>>2];k[s>>2]=k[t>>2];k[u>>2]=k[v>>2];k[w>>2]=k[x>>2];k[y>>2]=k[ba>>2];d=k[da>>2]|0;k[z>>2]=d;k[C>>2]=l;k[E>>2]=D;k[F>>2]=0;k[D>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[Aa>>2]|0}do if((b|0)<3){_=k[Ba>>2]|0;$=k[E>>2]|0;k[$>>2]=k[_>>2];k[$+4>>2]=k[_+4>>2]}else{k[j>>2]=0;x1(O,b,0,0,0);if((k[j>>2]|0)<=0)break;d=k[za>>2]|0;e=k[C>>2]|0;f=k[Ba>>2]|0;g=k[E>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}while(0);o5a(O,Ka);b=k[z>>2]|0;do if(b|0){_=b+12|0;$=k[_>>2]|0;k[_>>2]=$+-1;if(($|0)!=1)break;d=k[z>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[y>>2]|0;if(b|0)break;b=B1()|0;d=k[z>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[z>>2]=0}while(0);k[z>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[j>>2]|0)>0){d=k[C>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[E>>2]|0;if(!((b|0)==(D|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[G>>2]=0;k[H>>2]=0;k[Ia>>2]=16842752;k[I>>2]=Ka;cb=A/+r$(N,Ia);c1(Ia,cb,Ka);$=k[Ia>>2]|0;Ph[k[(k[$>>2]|0)+28>>2]&511]($,Ia,Ra);XN(Ia);c1(Ia,cb,N);$=k[Ia>>2]|0;Ph[k[(k[$>>2]|0)+24>>2]&511]($,Ia,la);XN(Ia);k[J>>2]=0;k[K>>2]=0;k[Ia>>2]=16842752;k[L>>2]=Ra;cb=A;A=+r$(Ra,Ia);c1(Ha,A/cb,N);X0(Ia,Ra,Ha);$=k[Ia>>2]|0;dh[k[(k[$>>2]|0)+12>>2]&255]($,Ia,N,-1);XN(Ia);XN(Ha);h=h+1|0}while(!(A<B)&(h|0)<100);k[Ia+8>>2]=0;k[Ia+12>>2]=0;k[Ia>>2]=16842752;k[Ia+4>>2]=la;N=Ha+4|0;$=N+4|0;k[$>>2]=0;k[$+4>>2]=0;k[Ha>>2]=33619968;k[N>>2]=la;XZ(Ia,Ha);k[ua>>2]=k[$a>>2];N=ua+4|0;$=$a+4|0;b=k[$>>2]|0;k[N>>2]=b;P=ua+8|0;h=$a+8|0;k[P>>2]=k[h>>2];j=$a+12|0;k[ua+12>>2]=k[j>>2];K=ua+16|0;Z=$a+16|0;k[K>>2]=k[Z>>2];l=$a+20|0;k[ua+20>>2]=k[l>>2];n=$a+24|0;k[ua+24>>2]=k[n>>2];c=$a+28|0;k[ua+28>>2]=k[c>>2];J=ua+32|0;Y=$a+32|0;k[J>>2]=k[Y>>2];L=ua+36|0;_=$a+36|0;d=k[_>>2]|0;k[L>>2]=d;M=ua+40|0;k[M>>2]=P;P=ua+48|0;O=ua+44|0;k[O>>2]=P;k[ua+52>>2]=0;k[P>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[$>>2]|0}if((b|0)>=3){k[N>>2]=0;x1(ua,b,0,0,0);if((k[N>>2]|0)>0){d=k[$a+40>>2]|0;e=k[M>>2]|0;f=k[$a+44>>2]|0;g=k[O>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[N>>2]|0))}}else{I=k[$a+44>>2]|0;X=k[O>>2]|0;k[X>>2]=k[I>>2];k[X+4>>2]=k[I+4>>2]}k[va>>2]=k[$a>>2];I=va+4|0;b=k[$>>2]|0;k[I>>2]=b;H=va+8|0;k[H>>2]=k[h>>2];k[va+12>>2]=k[j>>2];G=va+16|0;k[G>>2]=k[Z>>2];k[va+20>>2]=k[l>>2];k[va+24>>2]=k[n>>2];k[va+28>>2]=k[c>>2];C=va+32|0;k[C>>2]=k[Y>>2];D=va+36|0;d=k[_>>2]|0;k[D>>2]=d;E=va+40|0;k[E>>2]=H;H=va+48|0;F=va+44|0;k[F>>2]=H;k[va+52>>2]=0;k[H>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[$>>2]|0}do if((b|0)<3){z=k[$a+44>>2]|0;X=k[F>>2]|0;k[X>>2]=k[z>>2];k[X+4>>2]=k[z+4>>2]}else{k[I>>2]=0;x1(va,b,0,0,0);if((k[I>>2]|0)<=0)break;d=k[$a+40>>2]|0;e=k[E>>2]|0;f=k[$a+44>>2]|0;g=k[F>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[I>>2]|0))}while(0);k[wa>>2]=k[V>>2];z=wa+4|0;b=k[Ta>>2]|0;k[z>>2]=b;y=wa+8|0;k[y>>2]=k[R>>2];k[wa+12>>2]=k[V+12>>2];v=wa+16|0;X=V+16|0;k[v>>2]=k[X>>2];k[wa+20>>2]=k[V+20>>2];k[wa+24>>2]=k[V+24>>2];k[wa+28>>2]=k[V+28>>2];t=wa+32|0;R=V+32|0;k[t>>2]=k[R>>2];w=wa+36|0;V=V+36|0;d=k[V>>2]|0;k[w>>2]=d;u=wa+40|0;k[u>>2]=y;y=wa+48|0;x=wa+44|0;k[x>>2]=y;k[wa+52>>2]=0;k[y>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[Ta>>2]|0}do if((b|0)<3){q=k[Ua>>2]|0;s=k[x>>2]|0;k[s>>2]=k[q>>2];k[s+4>>2]=k[q+4>>2]}else{k[z>>2]=0;x1(wa,b,0,0,0);if((k[z>>2]|0)<=0)break;d=k[Sa>>2]|0;e=k[u>>2]|0;f=k[Ua>>2]|0;g=k[x>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[z>>2]|0))}while(0);k[xa>>2]=k[la>>2];s=xa+4|0;b=k[ka>>2]|0;k[s>>2]=b;q=xa+8|0;k[q>>2]=k[W>>2];k[xa+12>>2]=k[T>>2];c=xa+16|0;k[c>>2]=k[ia>>2];k[xa+20>>2]=k[U>>2];k[xa+24>>2]=k[S>>2];k[xa+28>>2]=k[Q>>2];h=xa+32|0;k[h>>2]=k[ea>>2];j=xa+36|0;d=k[fa>>2]|0;k[j>>2]=d;l=xa+40|0;k[l>>2]=q;q=xa+48|0;n=xa+44|0;k[n>>2]=q;k[xa+52>>2]=0;k[q>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[ka>>2]|0}do if((b|0)<3){W=k[ha>>2]|0;la=k[n>>2]|0;k[la>>2]=k[W>>2];k[la+4>>2]=k[W+4>>2]}else{k[s>>2]=0;x1(xa,b,0,0,0);if((k[s>>2]|0)<=0)break;d=k[ga>>2]|0;e=k[l>>2]|0;f=k[ha>>2]|0;g=k[n>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[s>>2]|0))}while(0);Z2a(ua,va,wa,xa,+o[a+20>>2]);b=k[j>>2]|0;do if(b|0){wa=b+12|0;xa=k[wa>>2]|0;k[wa>>2]=xa+-1;if((xa|0)!=1)break;d=k[j>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[h>>2]|0;if(b|0)break;b=B1()|0;d=k[j>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[j>>2]=0}while(0);k[j>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[s>>2]|0)>0){d=k[l>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[s>>2]|0))}b=k[n>>2]|0;if(!((b|0)==(q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[w>>2]|0;do if(b|0){wa=b+12|0;xa=k[wa>>2]|0;k[wa>>2]=xa+-1;if((xa|0)!=1)break;d=k[w>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[t>>2]|0;if(b|0)break;b=B1()|0;d=k[w>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[w>>2]=0}while(0);k[w>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[z>>2]|0)>0){d=k[u>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[x>>2]|0;if(!((b|0)==(y|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[D>>2]|0;do if(b|0){wa=b+12|0;xa=k[wa>>2]|0;k[wa>>2]=xa+-1;if((xa|0)!=1)break;d=k[D>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[C>>2]|0;if(b|0)break;b=B1()|0;d=k[D>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[D>>2]=0}while(0);k[D>>2]=0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[I>>2]|0)>0){d=k[E>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[I>>2]|0))}b=k[F>>2]|0;if(!((b|0)==(H|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[L>>2]|0;do if(b|0){wa=b+12|0;xa=k[wa>>2]|0;k[wa>>2]=xa+-1;if((xa|0)!=1)break;d=k[L>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[J>>2]|0;if(b|0)break;b=B1()|0;d=k[L>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[L>>2]=0}while(0);k[L>>2]=0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[N>>2]|0)>0){d=k[M>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[N>>2]|0))}b=k[O>>2]|0;if(!((b|0)==(P|0)|(b|0)==0))ggb(k[b+-4>>2]|0);Y3a(Ia,+o[a+12>>2]);b=k[Ia>>2]|0;d=k[Ia+4>>2]|0;if(b|0){a=b+4|0;k[a>>2]=(k[a>>2]|0)+1}e=k[_a>>2]|0;k[_a>>2]=b;k[ya>>2]=d;do if(e|0){xa=e+4|0;a=k[xa>>2]|0;k[xa>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[e>>2]|0)+8>>2]&2047](e)}while(0);b=k[Ia>>2]|0;do if(b|0){xa=b+4|0;a=k[xa>>2]|0;k[xa>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[b>>2]|0)+8>>2]&2047](b)}while(0);b=k[ya>>2]|0;a=k[(k[b>>2]|0)+32>>2]|0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;k[Ia>>2]=16842752;k[Ia+4>>2]=$a;ya=Ha+4|0;xa=ya+4|0;k[xa>>2]=0;k[xa+4>>2]=0;k[Ha>>2]=33619968;k[ya>>2]=$a;Ph[a&511](b,Ia,Ha);b=k[fa>>2]|0;do if(b|0){Ha=b+12|0;Ia=k[Ha>>2]|0;k[Ha>>2]=Ia+-1;if((Ia|0)!=1)break;d=k[fa>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[ea>>2]|0;if(b|0)break;b=B1()|0;d=k[fa>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[fa>>2]=0}while(0);k[fa>>2]=0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[ka>>2]|0)>0){d=k[ga>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ka>>2]|0))}b=k[ha>>2]|0;if(!((b|0)==(ja|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=Ka+36|0;b=k[e>>2]|0;do if(b|0){Ha=b+12|0;Ia=k[Ha>>2]|0;k[Ha>>2]=Ia+-1;if((Ia|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Ka+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;Ka=Ka+16|0;k[Ka>>2]=0;k[Ka+4>>2]=0;k[Ka+8>>2]=0;k[Ka+12>>2]=0;if((k[oa>>2]|0)>0){d=k[ma>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[oa>>2]|0))}b=k[na>>2]|0;if(!((b|0)==(pa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=Ra+36|0;b=k[e>>2]|0;do if(b|0){Ia=b+12|0;Ka=k[Ia>>2]|0;k[Ia>>2]=Ka+-1;if((Ka|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Ra+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;Ra=Ra+16|0;k[Ra>>2]=0;k[Ra+4>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;if((k[sa>>2]|0)>0){d=k[qa>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[sa>>2]|0))}b=k[ra>>2]|0;if(!((b|0)==(ta|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[da>>2]|0;do if(b|0){Ka=b+12|0;Ra=k[Ka>>2]|0;k[Ka>>2]=Ra+-1;if((Ra|0)!=1)break;d=k[da>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[ba>>2]|0;if(b|0)break;b=B1()|0;d=k[da>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[da>>2]=0}while(0);k[da>>2]=0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;if((k[Aa>>2]|0)>0){d=k[za>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Aa>>2]|0))}b=k[Ba>>2]|0;if(!((b|0)==(Ca|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=Wa+36|0;b=k[e>>2]|0;do if(b|0){Ka=b+12|0;Ra=k[Ka>>2]|0;k[Ka>>2]=Ra+-1;if((Ra|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Wa+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;Wa=Wa+16|0;k[Wa>>2]=0;k[Wa+4>>2]=0;k[Wa+8>>2]=0;k[Wa+12>>2]=0;if((k[Fa>>2]|0)>0){d=k[Da>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Fa>>2]|0))}b=k[Ea>>2]|0;if(!((b|0)==(Ga|0)|(b|0)==0))ggb(k[b+-4>>2]|0);zF(Ya);zF(Xa);b=k[Na>>2]|0;do if(b|0){Xa=b+12|0;Ya=k[Xa>>2]|0;k[Xa>>2]=Ya+-1;if((Ya|0)!=1)break;d=k[Na>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Ja>>2]|0;if(b|0)break;b=B1()|0;d=k[Na>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[Na>>2]=0}while(0);k[Na>>2]=0;k[Ma>>2]=0;k[Ma+4>>2]=0;k[Ma+8>>2]=0;k[Ma+12>>2]=0;if((k[Oa>>2]|0)>0){d=k[La>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Oa>>2]|0))}b=k[Pa>>2]|0;if(!((b|0)==(Qa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[V>>2]|0;do if(b|0){Xa=b+12|0;Ya=k[Xa>>2]|0;k[Xa>>2]=Ya+-1;if((Ya|0)!=1)break;d=k[V>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[R>>2]|0;if(b|0)break;b=B1()|0;d=k[V>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[V>>2]=0}while(0);k[V>>2]=0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[Ta>>2]|0)>0){d=k[Sa>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ta>>2]|0))}b=k[Ua>>2]|0;if(!((b|0)==(Va|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[_a>>2]|0;do if(b|0){Ya=b+4|0;_a=k[Ya>>2]|0;k[Ya>>2]=_a+-1;if((_a|0)!=1)break;Uh[k[(k[b>>2]|0)+8>>2]&2047](b)}while(0);b=k[_>>2]|0;do if(b|0){Ya=b+12|0;_a=k[Ya>>2]|0;k[Ya>>2]=_a+-1;if((_a|0)!=1)break;d=k[_>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Y>>2]|0;if(b|0)break;b=B1()|0;d=k[_>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[_>>2]=0}while(0);k[_>>2]=0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[$>>2]|0)>0){d=k[$a+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[$>>2]|0))}b=k[$a+44>>2]|0;if(!((b|0)==($a+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=ab+36|0;b=k[e>>2]|0;do if(b|0){_a=b+12|0;$a=k[_a>>2]|0;k[_a>>2]=$a+-1;if(($a|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[ab+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;e=ab+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[e>>2]|0)>0){d=k[Za>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[ab+44>>2]|0;if((b|0)==(ab+48|0)|(b|0)==0){r=bb;return}ggb(k[b+-4>>2]|0);r=bb;return}function f5a(a){a=a|0;return +(+o[a+12>>2])}function g5a(a,b){a=a|0;b=+b;o[a+12>>2]=b;return}function h5a(a){a=a|0;return +(+o[a+16>>2])}function i5a(a,b){a=a|0;b=+b;o[a+16>>2]=b;return}function j5a(a){a=a|0;return +(+o[a+20>>2])}function k5a(a,b){a=a|0;b=+b;o[a+20>>2]=b;return}function l5a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;Aa=r;r=r+432|0;wa=Aa+376|0;pa=Aa+360|0;qa=Aa+304|0;ra=Aa+232|0;sa=Aa;ta=Aa+288|0;ua=Aa+224|0;xa=k[a+12>>2]|0;na=k[a+8>>2]|0;na=~~(+_(+(+(((xa|0)<(na|0)?xa:na)|0)))/.6931471824645996);Y1(b,na);Y1(c,na);k[wa>>2]=1124007936;xa=wa+4|0;oa=wa+8|0;va=wa+40|0;d=xa;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[va>>2]=oa;za=wa+48|0;ya=wa+44|0;k[ya>>2]=za;k[wa+52>>2]=0;k[za>>2]=0;ma=pa+4|0;la=ma+4|0;k[la>>2]=0;k[la+4>>2]=0;k[pa>>2]=33619968;k[ma>>2]=wa;mY(a,pa);if((na|0)>0){j=qa+4|0;l=qa+8|0;m=qa+12|0;n=wa+12|0;o=qa+16|0;p=wa+16|0;q=qa+20|0;s=wa+20|0;t=qa+24|0;u=wa+24|0;v=qa+28|0;w=wa+28|0;x=qa+32|0;y=wa+32|0;z=qa+36|0;f=wa+36|0;A=qa+40|0;B=qa+48|0;C=qa+44|0;D=qa+52|0;E=ra+4|0;F=ra+8|0;G=ra+40|0;H=ra+48|0;I=ra+44|0;J=ra+52|0;K=ra+36|0;L=ra+16|0;M=pa+8|0;N=pa+12|0;O=pa+4|0;P=ta+4|0;Q=P+4|0;R=ua+4|0;S=sa+4|0;T=sa+8|0;U=sa+12|0;V=sa+16|0;W=sa+48|0;X=sa+56|0;Y=sa+52|0;Z=sa+60|0;$=sa+64|0;aa=sa+68|0;ba=sa+72|0;ca=sa+104|0;da=sa+112|0;ea=sa+108|0;fa=sa+116|0;ga=sa+120|0;ha=sa+124|0;ia=sa+128|0;ja=sa+160|0;ka=sa+168|0;la=sa+164|0;ma=ra+32|0;i=0;do{k[qa>>2]=k[wa>>2];a=k[xa>>2]|0;k[j>>2]=a;k[l>>2]=k[oa>>2];k[m>>2]=k[n>>2];k[o>>2]=k[p>>2];k[q>>2]=k[s>>2];k[t>>2]=k[u>>2];k[v>>2]=k[w>>2];k[x>>2]=k[y>>2];d=k[f>>2]|0;k[z>>2]=d;k[A>>2]=l;k[C>>2]=B;k[D>>2]=0;k[B>>2]=0;if(d){a=d+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[xa>>2]|0}if((a|0)>=3){k[j>>2]=0;x1(qa,a,0,0,0);if((k[j>>2]|0)>0){d=k[va>>2]|0;e=k[A>>2]|0;g=k[ya>>2]|0;h=k[C>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[d+(a<<2)>>2];k[h+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else{g=k[ya>>2]|0;h=k[C>>2]|0;k[h>>2]=k[g>>2];k[h+4>>2]=k[g+4>>2]}p5a(qa,(k[b>>2]|0)+(i*56|0)|0,0);a=k[z>>2]|0;if(a|0?(g=a+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){d=k[z>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[x>>2]|0;if(!a){a=B1()|0;d=k[z>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[z>>2]=0}k[z>>2]=0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[j>>2]|0)>0){d=k[A>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[C>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[sa>>2]=0;k[S>>2]=0;k[T>>2]=1124007936;d=U;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[W>>2]=V;k[Y>>2]=X;k[Z>>2]=0;k[X>>2]=0;k[$>>2]=1124007936;d=aa;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[ca>>2]=ba;k[ea>>2]=da;k[fa>>2]=0;k[da>>2]=0;k[ga>>2]=1124007936;d=ha;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[ja>>2]=ia;k[la>>2]=ka;d=ka;e=d+56|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));y0(sa,wa,1.0);k[ra>>2]=1124007936;d=E;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[G>>2]=F;k[I>>2]=H;k[J>>2]=0;k[H>>2]=0;a=k[sa>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,sa,ra,-1);p5a(ra,(k[c>>2]|0)+(i*56|0)|0,0);a=k[K>>2]|0;if(a|0?(g=a+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){d=k[K>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[ma>>2]|0;if(!a){a=B1()|0;d=k[K>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[K>>2]=0}k[K>>2]=0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[E>>2]|0)>0){d=k[G>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[E>>2]|0))}a=k[I>>2]|0;if(!((a|0)==(H|0)|(a|0)==0))ggb(k[a+-4>>2]|0);XN(sa);k[M>>2]=0;k[N>>2]=0;k[pa>>2]=16842752;k[O>>2]=wa;h=Q;k[h>>2]=0;k[h+4>>2]=0;k[ta>>2]=33619968;k[P>>2]=wa;h=(k[oa>>2]|0)/2|0;k[ua>>2]=(k[n>>2]|0)/2|0;k[R>>2]=h;Rla(pa,ta,ua,0.0,0.0,1);i=i+1|0}while((i|0)<(na|0))}else f=wa+36|0;a=k[f>>2]|0;if(a|0?(ta=a+12|0,ua=k[ta>>2]|0,k[ta>>2]=ua+-1,(ua|0)==1):0){e=wa+36|0;d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[wa+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[f>>2]=0;wa=wa+16|0;k[wa>>2]=0;k[wa+4>>2]=0;k[wa+8>>2]=0;k[wa+12>>2]=0;if((k[xa>>2]|0)>0){d=k[va>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[xa>>2]|0))}a=k[ya>>2]|0;if((a|0)==(za|0)|(a|0)==0){r=Aa;return}ggb(k[a+-4>>2]|0);r=Aa;return}function m5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;D=r;r=r+128|0;q=D+112|0;h=D+56|0;C=D;k[h>>2]=k[b>>2];p=h+4|0;B=b+4|0;c=k[B>>2]|0;k[p>>2]=c;s=h+8|0;t=b+8|0;k[s>>2]=k[t>>2];u=b+12|0;k[h+12>>2]=k[u>>2];j=h+16|0;v=b+16|0;k[j>>2]=k[v>>2];w=b+20|0;k[h+20>>2]=k[w>>2];x=b+24|0;k[h+24>>2]=k[x>>2];y=b+28|0;k[h+28>>2]=k[y>>2];i=h+32|0;z=b+32|0;k[i>>2]=k[z>>2];l=h+36|0;A=b+36|0;d=k[A>>2]|0;k[l>>2]=d;m=h+40|0;k[m>>2]=s;s=h+48|0;n=h+44|0;k[n>>2]=s;k[h+52>>2]=0;k[s>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[B>>2]|0}if((c|0)>=3){k[p>>2]=0;x1(h,c,0,0,0);if((k[p>>2]|0)>0){d=k[b+40>>2]|0;e=k[m>>2]|0;f=k[b+44>>2]|0;g=k[n>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[d+(c<<2)>>2];k[g+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[p>>2]|0))}}else{f=k[b+44>>2]|0;g=k[n>>2]|0;k[g>>2]=k[f>>2];k[g+4>>2]=k[f+4>>2]}q5a(h,.41850000619888306,b);c=k[l>>2]|0;if(c|0?(g=c+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){d=k[l>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[i>>2]|0;if(!c){c=B1()|0;d=k[l>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[l>>2]=0}k[l>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[p>>2]|0)>0){d=k[m>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[p>>2]|0))}c=k[n>>2]|0;if(!((c|0)==(s|0)|(c|0)==0))ggb(k[c+-4>>2]|0);E=+o[a+16>>2];p=q+4|0;c=p+4|0;k[c>>2]=0;k[c+4>>2]=0;k[q>>2]=33619968;k[p>>2]=b;SW(b,q,-1,E,0.0);k[C>>2]=k[b>>2];p=C+4|0;c=k[B>>2]|0;k[p>>2]=c;m=C+8|0;k[m>>2]=k[t>>2];k[C+12>>2]=k[u>>2];n=C+16|0;k[n>>2]=k[v>>2];k[C+20>>2]=k[w>>2];k[C+24>>2]=k[x>>2];k[C+28>>2]=k[y>>2];h=C+32|0;k[h>>2]=k[z>>2];j=C+36|0;d=k[A>>2]|0;k[j>>2]=d;i=C+40|0;k[i>>2]=m;m=C+48|0;l=C+44|0;k[l>>2]=m;k[C+52>>2]=0;k[m>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[B>>2]|0}if((c|0)>=3){k[p>>2]=0;x1(C,c,0,0,0);if((k[p>>2]|0)>0){d=k[b+40>>2]|0;e=k[i>>2]|0;f=k[b+44>>2]|0;g=k[l>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[d+(c<<2)>>2];k[g+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[p>>2]|0))}}else{A=k[b+44>>2]|0;B=k[l>>2]|0;k[B>>2]=k[A>>2];k[B+4>>2]=k[A+4>>2]}q5a(C,2.389486312866211,b);c=k[j>>2]|0;if(c|0?(b=c+12|0,C=k[b>>2]|0,k[b>>2]=C+-1,(C|0)==1):0){d=k[j>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[h>>2]|0;if(!c){c=B1()|0;d=k[j>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[j>>2]=0}k[j>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[p>>2]|0)>0){d=k[i>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[p>>2]|0))}c=k[l>>2]|0;if((c|0)==(m|0)|(c|0)==0){r=D;return}ggb(k[c+-4>>2]|0);r=D;return}function n5a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;La=r;r=r+848|0;Ea=La+792|0;Fa=La+448|0;Ga=La+736|0;Ha=La+680|0;Ia=La+224|0;Ja=La;Ka=La+672|0;e=k[a>>2]|0;d=k[a+4>>2]|0;if((e|0)==(d|0)){r=La;return}h=d-e|0;i=((h|0)/56|0)+-1|0;g=k[e+(i*56|0)+40>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[Fa>>2]=0;k[Fa+4>>2]=0;k[Fa+8>>2]=1124007936;d=Fa+16|0;e=Fa+48|0;j=Fa+12|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;d=Fa+56|0;k[Fa+52>>2]=d;k[Fa+60>>2]=0;k[d>>2]=0;k[Fa+64>>2]=1124007936;d=Fa+72|0;e=Fa+104|0;j=Fa+68|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;d=Fa+112|0;k[Fa+108>>2]=d;k[Fa+116>>2]=0;k[d>>2]=0;k[Fa+120>>2]=1124007936;d=Fa+128|0;e=Fa+160|0;j=Fa+124|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;j=Fa+168|0;k[Fa+164>>2]=j;l=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[Ea>>2]=f;k[Ea+4>>2]=g;j1(Fa,48,Ea,5);Da=k[Fa>>2]|0;dh[k[(k[Da>>2]|0)+12>>2]&255](Da,Fa,c,-1);XN(Fa);if((h|0)<=0){r=La;return}J=Ea+4|0;K=Ea+8|0;L=Ea+40|0;M=Ea+48|0;N=Ea+44|0;O=Ea+52|0;P=Fa+4|0;Q=Fa+8|0;R=Fa+40|0;S=Fa+48|0;T=Fa+44|0;U=Fa+52|0;V=Ga+4|0;W=Ga+8|0;X=Ga+12|0;Y=Ga+16|0;Z=Ga+20|0;_=Ga+24|0;$=Ga+28|0;aa=Ga+32|0;ba=Ga+36|0;ca=Ga+40|0;da=Ga+48|0;ea=Ga+44|0;fa=Ga+52|0;ga=Ha+4|0;ha=Ha+8|0;ia=Ha+12|0;ja=Ha+16|0;ka=Ha+20|0;la=Ha+24|0;ma=Ha+28|0;na=Ha+32|0;oa=Ha+36|0;pa=Ha+40|0;qa=Ha+48|0;ra=Ha+44|0;sa=Ha+52|0;ta=Ia+8|0;ua=Ia+12|0;va=Ia+4|0;wa=Ja+4|0;xa=wa+4|0;ya=Ka+4|0;za=Fa+36|0;Aa=Fa+16|0;Ba=Ea+36|0;Ca=Ea+16|0;Da=Ja+4|0;m=Ja+8|0;n=Ja+12|0;o=Ja+16|0;p=Ja+48|0;q=Ja+56|0;s=Ja+52|0;t=Ja+60|0;u=Ja+64|0;v=Ja+68|0;w=Ja+72|0;x=Ja+104|0;y=Ja+112|0;z=Ja+108|0;A=Ja+116|0;B=Ja+120|0;C=Ja+124|0;D=Ja+128|0;E=Ja+160|0;F=Ja+168|0;G=Ja+164|0;H=Ea+32|0;I=Fa+32|0;while(1){k[Ea>>2]=1124007936;j=J;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[L>>2]=K;k[N>>2]=M;k[O>>2]=0;k[M>>2]=0;k[Fa>>2]=1124007936;j=P;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[R>>2]=Q;k[T>>2]=S;k[U>>2]=0;k[S>>2]=0;f=k[a>>2]|0;k[Ga>>2]=k[f+(i*56|0)>>2];d=f+(i*56|0)+4|0;k[V>>2]=k[d>>2];k[W>>2]=k[f+(i*56|0)+8>>2];k[X>>2]=k[f+(i*56|0)+12>>2];k[Y>>2]=k[f+(i*56|0)+16>>2];k[Z>>2]=k[f+(i*56|0)+20>>2];k[_>>2]=k[f+(i*56|0)+24>>2];k[$>>2]=k[f+(i*56|0)+28>>2];k[aa>>2]=k[f+(i*56|0)+32>>2];e=k[f+(i*56|0)+36>>2]|0;k[ba>>2]=e;k[ca>>2]=W;k[ea>>2]=da;k[fa>>2]=0;k[da>>2]=0;if(e|0){l=e+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[d>>2]|0)>=3){k[V>>2]=0;x1(Ga,k[d>>2]|0,0,0,0);if((k[V>>2]|0)>0){g=k[f+(i*56|0)+40>>2]|0;h=k[ca>>2]|0;e=k[f+(i*56|0)+44>>2]|0;f=k[ea>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[g+(d<<2)>>2];k[f+(d<<2)>>2]=k[e+(d<<2)>>2];d=d+1|0}while((d|0)<(k[V>>2]|0))}}else{j=k[f+(i*56|0)+44>>2]|0;l=k[ea>>2]|0;k[l>>2]=k[j>>2];k[l+4>>2]=k[j+4>>2]}p5a(Ga,Ea,1);d=k[ba>>2]|0;if(d|0?(j=d+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){e=k[ba>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[aa>>2]|0;if(!d){d=B1()|0;e=k[ba>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[ba>>2]=0}k[ba>>2]=0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[V>>2]|0)>0){e=k[ca>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[V>>2]|0))}d=k[ea>>2]|0;if(!((d|0)==(da|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=k[b>>2]|0;k[Ha>>2]=k[f+(i*56|0)>>2];d=f+(i*56|0)+4|0;k[ga>>2]=k[d>>2];k[ha>>2]=k[f+(i*56|0)+8>>2];k[ia>>2]=k[f+(i*56|0)+12>>2];k[ja>>2]=k[f+(i*56|0)+16>>2];k[ka>>2]=k[f+(i*56|0)+20>>2];k[la>>2]=k[f+(i*56|0)+24>>2];k[ma>>2]=k[f+(i*56|0)+28>>2];k[na>>2]=k[f+(i*56|0)+32>>2];e=k[f+(i*56|0)+36>>2]|0;k[oa>>2]=e;k[pa>>2]=ha;k[ra>>2]=qa;k[sa>>2]=0;k[qa>>2]=0;if(e|0){l=e+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[d>>2]|0)>=3){k[ga>>2]=0;x1(Ha,k[d>>2]|0,0,0,0);if((k[ga>>2]|0)>0){g=k[f+(i*56|0)+40>>2]|0;h=k[pa>>2]|0;e=k[f+(i*56|0)+44>>2]|0;f=k[ra>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[g+(d<<2)>>2];k[f+(d<<2)>>2]=k[e+(d<<2)>>2];d=d+1|0}while((d|0)<(k[ga>>2]|0))}}else{j=k[f+(i*56|0)+44>>2]|0;l=k[ra>>2]|0;k[l>>2]=k[j>>2];k[l+4>>2]=k[j+4>>2]}p5a(Ha,Fa,1);d=k[oa>>2]|0;if(d|0?(j=d+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){e=k[oa>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[na>>2]|0;if(!d){d=B1()|0;e=k[oa>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[oa>>2]=0}k[oa>>2]=0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[ga>>2]|0)>0){e=k[pa>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[ga>>2]|0))}d=k[ra>>2]|0;if(!((d|0)==(qa|0)|(d|0)==0))ggb(k[d+-4>>2]|0);k[ta>>2]=0;k[ua>>2]=0;k[Ia>>2]=16842752;k[va>>2]=c;l=xa;k[l>>2]=0;k[l+4>>2]=0;k[Ja>>2]=33619968;k[wa>>2]=c;l=k[(k[a>>2]|0)+(i*56|0)+40>>2]|0;j=k[l>>2]|0;k[Ka>>2]=k[l+4>>2];k[ya>>2]=j;Rla(Ia,Ja,Ka,0.0,0.0,1);k[Ja>>2]=0;k[Da>>2]=0;k[m>>2]=1124007936;j=n;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[p>>2]=o;k[s>>2]=q;k[t>>2]=0;k[q>>2]=0;k[u>>2]=1124007936;j=v;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[x>>2]=w;k[z>>2]=y;k[A>>2]=0;k[y>>2]=0;k[B>>2]=1124007936;j=C;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[E>>2]=D;k[G>>2]=F;j=F;l=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));y0(Ja,Fa,1.0);X0(Ia,Ea,Ja);d=k[Ia>>2]|0;Ph[k[(k[d>>2]|0)+24>>2]&511](d,Ia,c);XN(Ia);XN(Ja);d=k[za>>2]|0;if(d|0?(j=d+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){e=k[za>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[I>>2]|0;if(d|0)break;d=B1()|0;e=k[za>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[za>>2]=0}k[za>>2]=0;k[Aa>>2]=0;k[Aa+4>>2]=0;k[Aa+8>>2]=0;k[Aa+12>>2]=0;if((k[P>>2]|0)>0){e=k[R>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[P>>2]|0))}d=k[T>>2]|0;if(!((d|0)==(S|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[Ba>>2]|0;if(d|0?(j=d+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){e=k[Ba>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[H>>2]|0;if(d|0)break;d=B1()|0;e=k[Ba>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[Ba>>2]=0}k[Ba>>2]=0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[J>>2]|0)>0){e=k[L>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[J>>2]|0))}d=k[N>>2]|0;if(!((d|0)==(M|0)|(d|0)==0))ggb(k[d+-4>>2]|0);if((i|0)>0)i=i+-1|0;else break}r=La;return}function o5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+80|0;p=t+68|0;q=t+56|0;h=t;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[h>>2]=k[a>>2];n=h+4|0;d=a+4|0;c=k[d>>2]|0;k[n>>2]=c;s=h+8|0;k[s>>2]=k[a+8>>2];k[h+12>>2]=k[a+12>>2];j=h+16|0;k[j>>2]=k[a+16>>2];k[h+20>>2]=k[a+20>>2];k[h+24>>2]=k[a+24>>2];k[h+28>>2]=k[a+28>>2];i=h+32|0;k[i>>2]=k[a+32>>2];l=h+36|0;e=k[a+36>>2]|0;k[l>>2]=e;m=h+40|0;k[m>>2]=s;s=h+48|0;o=h+44|0;k[o>>2]=s;k[h+52>>2]=0;k[s>>2]=0;if(e){c=e+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[d>>2]|0}if((c|0)>=3){k[n>>2]=0;x1(h,c,0,0,0);if((k[n>>2]|0)>0){f=k[a+40>>2]|0;g=k[m>>2]|0;d=k[a+44>>2]|0;e=k[o>>2]|0;c=0;do{k[g+(c<<2)>>2]=k[f+(c<<2)>>2];k[e+(c<<2)>>2]=k[d+(c<<2)>>2];c=c+1|0}while((c|0)<(k[n>>2]|0))}}else{g=k[a+44>>2]|0;a=k[o>>2]|0;k[a>>2]=k[g>>2];k[a+4>>2]=k[g+4>>2]}l5a(h,p,q);c=k[l>>2]|0;if(c|0?(a=c+12|0,h=k[a>>2]|0,k[a>>2]=h+-1,(h|0)==1):0){d=k[l>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[i>>2]|0;if(!c){c=B1()|0;d=k[l>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[l>>2]=0}k[l>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[n>>2]|0)>0){d=k[m>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[n>>2]|0))}c=k[o>>2]|0;if((c|0)==(s|0)|(c|0)==0){n5a(p,q,b);zF(q);zF(p);r=t;return}ggb(k[c+-4>>2]|0);n5a(p,q,b);zF(q);zF(p);r=t;return}function p5a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=r;r=r+816|0;l=E+448|0;m=E+224|0;D=E+704|0;y=E+648|0;t=E+592|0;j=E;n=E+536|0;o=E+480|0;s=E+760|0;g=k[a+40>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=1124007936;d=m+16|0;e=m+48|0;h=m+12|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[e>>2]=d;d=m+56|0;k[m+52>>2]=d;k[m+60>>2]=0;k[d>>2]=0;k[m+64>>2]=1124007936;d=m+72|0;e=m+104|0;h=m+68|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[e>>2]=d;d=m+112|0;k[m+108>>2]=d;k[m+116>>2]=0;k[d>>2]=0;k[m+120>>2]=1124007936;d=m+128|0;e=m+160|0;h=m+124|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[e>>2]=d;h=m+168|0;k[m+164>>2]=h;i=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[l>>2]=f;k[l+4>>2]=g;j1(m,48,l,5);B=k[m>>2]|0;dh[k[(k[B>>2]|0)+12>>2]&255](B,m,b,-1);XN(m);k[D>>2]=1124007936;B=D+4|0;d=D+8|0;z=D+40|0;h=B;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[z>>2]=d;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;k[y>>2]=1124007936;w=y+4|0;d=y+8|0;u=y+40|0;h=w;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[u>>2]=d;x=y+48|0;v=y+44|0;k[v>>2]=x;k[y+52>>2]=0;k[x>>2]=0;g=a+12|0;d=k[g>>2]|0;k[l>>2]=-2147483648;k[l+4>>2]=2147483647;k[m>>2]=1;k[m+4>>2]=d;H1(n,a,l,m);d=(k[g>>2]|0)+-1|0;k[l>>2]=-2147483648;k[l+4>>2]=2147483647;k[m>>2]=0;k[m+4>>2]=d;H1(o,a,l,m);k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=1124007936;d=j+16|0;e=j+48|0;h=j+12|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[e>>2]=d;d=j+56|0;k[j+52>>2]=d;k[j+60>>2]=0;k[d>>2]=0;k[j+64>>2]=1124007936;d=j+72|0;e=j+104|0;h=j+68|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[e>>2]=d;d=j+112|0;k[j+108>>2]=d;k[j+116>>2]=0;k[d>>2]=0;k[j+120>>2]=1124007936;d=j+128|0;e=j+160|0;h=j+124|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[e>>2]=d;h=j+168|0;k[j+164>>2]=h;i=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;k[l+16>>2]=0;k[l+20>>2]=0;k[l+24>>2]=0;k[l+28>>2]=0;G0(j,n,o,1.0,-1.0,l);k[t>>2]=1124007936;q=t+4|0;d=t+8|0;p=t+40|0;h=q;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[p>>2]=d;i=t+48|0;h=t+44|0;k[h>>2]=i;k[t+52>>2]=0;k[i>>2]=0;f=k[j>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,j,t,-1);XN(j);f=o+36|0;d=k[f>>2]|0;if(d|0?(e=d+12|0,j=k[e>>2]|0,k[e>>2]=j+-1,(j|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[o+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;j=o+16|0;e=o+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[e>>2]|0)>0){f=k[o+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[o+44>>2]|0;if(!((d|0)==(o+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=n+36|0;d=k[f>>2]|0;if(d|0?(e=d+12|0,j=k[e>>2]|0,k[e>>2]=j+-1,(j|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[n+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;j=n+16|0;e=n+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[e>>2]|0)>0){f=k[n+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[n+44>>2]|0;if(!((d|0)==(n+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=c+-1+(k[g>>2]|0)|0;k[l>>2]=-2147483648;k[l+4>>2]=2147483647;k[m>>2]=c;k[m+4>>2]=f;H1(o,b,l,m);f=n+4|0;d=f+4|0;k[d>>2]=0;k[d+4>>2]=0;k[n>>2]=-1040121856;k[f>>2]=o;mY(t,n);f=o+36|0;d=k[f>>2]|0;if(d|0?(g=d+12|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[o+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;j=o+16|0;e=o+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[e>>2]|0)>0){f=k[o+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[o+44>>2]|0;if(!((d|0)==(o+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);if((c|0)==1){k[l>>2]=-2147483648;k[l+4>>2]=2147483647;k[m>>2]=0;k[m+4>>2]=1;H1(s,a,l,m);k[l>>2]=-2147483648;k[l+4>>2]=2147483647;k[m>>2]=0;k[m+4>>2]=1;H1(o,b,l,m);f=n+4|0;d=f+4|0;k[d>>2]=0;k[d+4>>2]=0;k[n>>2]=-1040121856;k[f>>2]=o;mY(s,n);f=o+36|0;d=k[f>>2]|0;if(d|0?(m=d+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[o+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;n=o+16|0;e=o+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[e>>2]|0)>0){f=k[o+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[o+44>>2]|0;if(!((d|0)==(o+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=s+36|0;d=k[f>>2]|0;if(d|0?(n=d+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[s+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;o=s+16|0;e=s+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[e>>2]|0)>0){f=k[s+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[s+44>>2]|0;if(!((d|0)==(s+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}f=t+36|0;d=k[f>>2]|0;if(d|0?(o=d+12|0,s=k[o>>2]|0,k[o>>2]=s+-1,(s|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[t+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;t=t+16|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[q>>2]|0)>0){e=k[p>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[q>>2]|0))}d=k[h>>2]|0;if(!((d|0)==(i|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=y+36|0;d=k[f>>2]|0;if(d|0?(s=d+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[y+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;y=y+16|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[w>>2]|0)>0){e=k[u>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[w>>2]|0))}d=k[v>>2]|0;if(!((d|0)==(x|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=D+36|0;d=k[f>>2]|0;if(d|0?(x=d+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[D+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){e=k[z>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[B>>2]|0))}d=k[A>>2]|0;if((d|0)==(C|0)|(d|0)==0){r=E;return}ggb(k[d+-4>>2]|0);r=E;return}function q5a(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0;t=r;r=r+960|0;g=t+672|0;s=t+896|0;f=t+448|0;h=t+224|0;i=t;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=1124007936;d=f+16|0;e=f+48|0;j=f+12|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;d=f+56|0;k[f+52>>2]=d;k[f+60>>2]=0;k[d>>2]=0;k[f+64>>2]=1124007936;d=f+72|0;e=f+104|0;j=f+68|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;d=f+112|0;k[f+108>>2]=d;k[f+116>>2]=0;k[d>>2]=0;k[f+120>>2]=1124007936;d=f+128|0;e=f+160|0;j=f+124|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;j=f+168|0;k[f+164>>2]=j;l=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));h1(f,1,a,0.0);k[s>>2]=1124007936;o=s+4|0;d=s+8|0;m=s+40|0;j=o;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[m>>2]=d;q=s+48|0;n=s+44|0;k[n>>2]=q;k[s+52>>2]=0;k[q>>2]=0;d=k[f>>2]|0;dh[k[(k[d>>2]|0)+12>>2]&255](d,f,s,-1);XN(f);d=g+4|0;e=d+4|0;k[e>>2]=0;k[e+4>>2]=0;k[g>>2]=33619968;k[d>>2]=s;SW(s,g,5,.003921568859368563,0.0);b1(i,s,2.0);k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=1124007936;d=h+16|0;e=h+48|0;j=h+12|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;d=h+56|0;k[h+52>>2]=d;k[h+60>>2]=0;k[d>>2]=0;k[h+64>>2]=1124007936;d=h+72|0;e=h+104|0;j=h+68|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;d=h+112|0;k[h+108>>2]=d;k[h+116>>2]=0;k[d>>2]=0;k[h+120>>2]=1124007936;d=h+128|0;e=h+160|0;j=h+124|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;j=h+168|0;k[h+164>>2]=j;l=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));d=k[i>>2]|0;e=k[(k[d>>2]|0)+56>>2]|0;p[g>>3]=-1.0;p[g+8>>3]=-0.0;p[g+16>>3]=-0.0;p[g+24>>3]=-0.0;dh[e&255](d,i,g,h);d=k[h>>2]|0;dh[k[(k[d>>2]|0)+12>>2]&255](d,h,s,-1);XN(h);XN(i);k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=1124007936;d=i+16|0;e=i+48|0;j=i+12|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;d=i+56|0;k[i+52>>2]=d;k[i+60>>2]=0;k[d>>2]=0;k[i+64>>2]=1124007936;d=i+72|0;e=i+104|0;j=i+68|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;d=i+112|0;k[i+108>>2]=d;k[i+116>>2]=0;k[d>>2]=0;k[i+120>>2]=1124007936;d=i+128|0;e=i+160|0;j=i+124|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[e>>2]=d;j=i+168|0;k[i+164>>2]=j;l=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g+16>>2]=0;k[g+20>>2]=0;k[g+24>>2]=0;k[g+28>>2]=0;z0(i,a,g);k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=-1056571392;k[h+4>>2]=i;f=g+4|0;d=f+4|0;k[d>>2]=0;k[d+4>>2]=0;k[g>>2]=33619968;k[f>>2]=c;ZZ(h,b,g);XN(i);k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=s;i1(g,c,h,1.0);f=k[g>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,g,c,-1);XN(g);f=s+36|0;d=k[f>>2]|0;if(d|0?(j=d+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[s+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[o>>2]|0)>0){e=k[m>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[o>>2]|0))}d=k[n>>2]|0;if((d|0)==(q|0)|(d|0)==0){r=t;return}ggb(k[d+-4>>2]|0);r=t;return}function r5a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=151736;d=a+448|0;b=k[d>>2]|0;k[a+452>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+428|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+424>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+408|0;c=a+396|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+432>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+436>>2]|0;if(!((b|0)==(a+440|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+372|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+368>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+352|0;c=a+340|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+376>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+380>>2]|0;if(!((b|0)==(a+384|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+316|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[a+312>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;d=a+296|0;c=a+284|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+320>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+324>>2]|0;if(!((b|0)==(a+328|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+260|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+256>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+240|0;c=a+228|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+264>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+268>>2]|0;if(!((b|0)==(a+272|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+204|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+200>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+184|0;c=a+172|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+208>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+212>>2]|0;if(!((b|0)==(a+216|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+148|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+144>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+128|0;c=a+116|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+152>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+156>>2]|0;if(!((b|0)==(a+160|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+92|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+88>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+72|0;c=a+60|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+96>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+100>>2]|0;if((b|0)==(a+104|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function s5a(a){a=a|0;r5a(a);ggb(a);return}function t5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0;m=r;r=r+16|0;j=m+8|0;g=m+4|0;h=m;f=j+4|0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[j>>2]=c;k[f>>2]=4;i[e+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;c=z6(b,j)|0;b=k[j>>2]|0;k[f>>2]=0;k[j>>2]=0;if(b|0?(e=b+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[b+-8>>2]|0);b=z6(c,a+448|0)|0;k[j>>2]=0;f=j+4|0;k[f>>2]=0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[j>>2]=c;k[f>>2]=7;i[e+11>>0]=0;i[c>>0]=i[401064]|0;i[c+1>>0]=i[401065]|0;i[c+2>>0]=i[401066]|0;i[c+3>>0]=i[401067]|0;i[c+4>>0]=i[401068]|0;i[c+5>>0]=i[401069]|0;i[c+6>>0]=i[401070]|0;b=z6(b,j)|0;c=k[j>>2]|0;k[f>>2]=0;k[j>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=L5a(b,a+20|0)|0;k[j>>2]=0;f=j+4|0;k[f>>2]=0;e=ZT(16)|0;k[e>>2]=1;c=e+4|0;k[j>>2]=c;k[f>>2]=8;i[e+12>>0]=0;e=c;i[e>>0]=110;i[e+1>>0]=115;i[e+2>>0]=97;i[e+3>>0]=109;c=c+4|0;i[c>>0]=112;i[c+1>>0]=108;i[c+2>>0]=101;i[c+3>>0]=115;b=z6(b,j)|0;c=k[j>>2]|0;k[f>>2]=0;k[j>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=L5a(b,a+28|0)|0;k[j>>2]=0;f=j+4|0;k[f>>2]=0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[j>>2]=c;k[f>>2]=4;i[e+8>>0]=0;i[c>>0]=110;i[c+1>>0]=75;i[c+2>>0]=78;i[c+3>>0]=78;b=z6(b,j)|0;c=k[j>>2]|0;k[f>>2]=0;k[j>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=L5a(b,a+32|0)|0;k[j>>2]=0;d=j+4|0;k[d>>2]=0;e=ZT(20)|0;k[e>>2]=1;c=e+4|0;k[j>>2]=c;k[d>>2]=14;i[e+18>>0]=0;e=400644;f=c+14|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));b=z6(b,j)|0;c=k[j>>2]|0;k[d>>2]=0;k[j>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=M5a(b,a+24|0)|0;d=j+4|0;e=ZT(20)|0;k[e>>2]=1;c=e+4|0;k[j>>2]=c;k[d>>2]=13;i[e+17>>0]=0;e=401178;f=c+13|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));b=z6(b,j)|0;c=k[j>>2]|0;k[d>>2]=0;k[j>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);k[g>>2]=l[a+36>>0];b=L5a(b,g)|0;d=j+4|0;e=ZT(16)|0;k[e>>2]=1;c=e+4|0;k[j>>2]=c;k[d>>2]=11;i[e+15>>0]=0;e=401192;f=c+11|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));c=z6(b,j)|0;b=k[j>>2]|0;k[d>>2]=0;k[j>>2]=0;if(b|0?(f=b+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[b+-8>>2]|0);k[h>>2]=l[a+37>>0];b=L5a(c,h)|0;d=j+4|0;e=ZT(20)|0;k[e>>2]=1;c=e+4|0;k[j>>2]=c;k[d>>2]=15;i[e+19>>0]=0;e=401204;f=c+15|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));b=z6(b,j)|0;c=k[j>>2]|0;k[d>>2]=0;k[j>>2]=0;if(!c){j=a+40|0;M5a(b,j)|0;r=m;return}h=c+-4|0;j=k[h>>2]|0;k[h>>2]=j+-1;if((j|0)!=1){j=a+40|0;M5a(b,j)|0;r=m;return}ggb(k[c+-8>>2]|0);j=a+40|0;M5a(b,j)|0;r=m;return}
function Qk(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;var g=0,h=0,j=0.0,l=0.0,m=0,n=0,p=0,q=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0,O=0,R=0,U=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0;da=r;r=r+1248|0;X=da+176|0;W=da+152|0;ca=da+80|0;aa=da+56|0;ba=da;$=da+136|0;q=$+4+4|0;k[q>>2]=0;k[q+4>>2]=0;k[$>>2]=33619968;k[$+4>>2]=b;k[ca>>2]=k[a>>2];q=ca+4|0;g=a+4|0;b=k[g>>2]|0;k[q>>2]=b;_=ca+8|0;k[_>>2]=k[a+8>>2];k[ca+12>>2]=k[a+12>>2];k[ca+16>>2]=k[a+16>>2];k[ca+20>>2]=k[a+20>>2];k[ca+24>>2]=k[a+24>>2];k[ca+28>>2]=k[a+28>>2];k[ca+32>>2]=k[a+32>>2];h=k[a+36>>2]|0;k[ca+36>>2]=h;m=ca+40|0;k[m>>2]=_;_=ca+48|0;p=ca+44|0;k[p>>2]=_;k[ca+52>>2]=0;k[_>>2]=0;if(h){b=h+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[g>>2]|0}if((b|0)>=3){k[q>>2]=0;x1(ca,b,0,0,0);if((k[q>>2]|0)>0){n=k[a+40>>2]|0;m=k[m>>2]|0;h=k[a+44>>2]|0;g=k[p>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[n+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else{Z=k[a+44>>2]|0;_=k[p>>2]|0;k[_>>2]=k[Z>>2];k[_+4>>2]=k[Z+4>>2]};k[aa>>2]=0;k[aa+4>>2]=0;k[aa+8>>2]=0;k[aa+12>>2]=0;k[aa+16>>2]=0;k[aa+20>>2]=0;Z=y2(ca,2,-1,0)|0;R=y2(ca,3,-1,0)|0;q=(Z|0)>-1;if((R&Z|0)<=-1){k[X>>2]=0;b=X+4|0;k[b>>2]=0;g=ZT(36)|0;k[g>>2]=1;n=g+4|0;k[X>>2]=n;k[b>>2]=30;i[g+34>>0]=0;h=339635;t=n+30|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(t|0));Y8(-215,X,339666,339674,603);k[b>>2]=0;k[X>>2]=0;_=k[g>>2]|0;k[g>>2]=_+-1;if((_|0)==1)ggb(k[g+-4>>2]|0)}if((k[ca>>2]&16391|0)!=16389){k[X>>2]=1124007936;p=X+4|0;b=X+8|0;a=X+40|0;n=p;t=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(t|0));k[a>>2]=b;n=X+48|0;m=X+44|0;k[m>>2]=n;k[X+52>>2]=0;k[n>>2]=0;h=W+4|0;b=h+4|0;k[b>>2]=0;k[b+4>>2]=0;k[W>>2]=33619968;k[h>>2]=X;SW(ca,W,5,1.0,0.0);KG(ca,X)|0;h=X+36|0;b=k[h>>2]|0;if(b|0?(U=b+12|0,_=k[U>>2]|0,k[U>>2]=_+-1,(_|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[X+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;_=X+16|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[p>>2]|0)>0){g=k[a>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[p>>2]|0))}b=k[m>>2]|0;if(!((b|0)==(n|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}_=ca+16|0;U=k[_>>2]|0;if(q){L=d;K=e;s=+(Z|0);J=s*1.1920928955078125e-07;K=K!=0.0?K:1.0;m=f!=0.0;k[aa>>2]=0;k[aa+4>>2]=0;k[aa+8>>2]=0;k[aa+12>>2]=0;switch(c|0){case 2:{if((Z|0)>0){b=0;l=0.0;e=0.0;d=0.0;f=0.0;j=0.0;do{K=+o[U+(b<<3)>>2];j=j+K;L=+o[U+(b<<3)+4>>2];l=l+L;e=e+K*K;d=d+L*L;f=f+K*L;b=b+1|0}while((b|0)!=(Z|0))}else{j=0.0;l=0.0;e=0.0;d=0.0;f=0.0}J=s;K=j/J;L=l/J;J=+Y(+((f/J-L*K)*2.0),+(e/J-K*K-(d/J-L*L)))*.5;z=+S(+J);o[aa>>2]=z;J=+T(+J);o[aa+4>>2]=J;o[aa+8>>2]=K;o[aa+12>>2]=L;break}case 1:{F=241;G=0;A=39;break}case 4:{F=242;G=0;A=39;break}case 5:{F=0;G=9;A=39;break}case 6:{F=0;G=10;A=39;break}case 7:{F=0;G=11;A=39;break}default:{k[X>>2]=0;b=X+4|0;k[b>>2]=0;g=ZT(28)|0;k[g>>2]=1;n=g+4|0;k[X>>2]=n;k[b>>2]=21;i[g+25>>0]=0;h=339743;t=n+21|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(t|0));Y8(-5,X,339765,339674,359);k[b>>2]=0;k[X>>2]=0;R=k[g>>2]|0;k[g>>2]=R+-1;if((R|0)==1)ggb(k[g+-4>>2]|0);F=0;G=0;A=39}}if((A|0)==39){h=Z<<1;H=X+8|0;k[X>>2]=H;I=X+4|0;k[I>>2]=264;if(h>>>0>264){g=h>>>0>1073741823?-1:h<<2;g=(g|0)==0?1:g;while(1){b=fgb(g)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[X>>2]=b}else b=H;k[I>>2]=h;B=b+(Z<<2)|0;C=(Z|0)>0;D=(Z|0)>10?10:Z;E=W+4|0;z=m?f:.009999999776482582;p=W+8|0;q=W+12|0;t=(F|0)==0;c=Z<<2;A=(Z|0)==0|C^1;a=0;s=0.0;f=1797693134862315708145274.0e284;l=0.0;e=0.0;j=0.0;d=0.0;g=-1;h=-1;while(1){if(C)zpb(b|0,0,c|0)|0;if(A)m=g;else{n=0;while(1){m=g;do{g=Epb(m|0,0,-130063606,0)|0;m=kpb(g|0,N|0,h|0,0)|0;h=N;g=b+(((m>>>0)%(Z>>>0)|0)<<2)|0}while(!(+o[g>>2]<1.1920928955078125e-07));n=n+1|0;o[g>>2]=1.0;if((n|0)>=(D|0))break;else g=m}}voa(U,Z,b,W);g=0;n=0;u=l;v=e;w=d;while(1){if(g){d=+o[W>>2];e=+o[E>>2];y=u*d+v*e;y=y<-1.0?-1.0:y;if(+P(+(+V(+(y>1.0?1.0:y))))<z?(x=+P(+(+o[p>>2]-j)),y=+P(+(+o[q>>2]-w)),(x>y?x:y)<K):0){l=u;e=v;d=w;break}else l=d}else{l=+o[W>>2];e=+o[E>>2]}x=+o[p>>2];y=+o[q>>2];if(C){d=0.0;g=0;do{s=+P(+(e*(+o[U+(g<<3)>>2]-x)-l*(+o[U+(g<<3)+4>>2]-y)));o[B+(g<<2)>>2]=s;d=d+s;g=g+1|0}while((g|0)!=(Z|0));s=d}else s=0.0;if(s<J){l=u;e=v;d=w;break}if(t)ah[G&31](B,Z,b,L);else Ph[F&511](B,Z,b);if(C){g=0;d=0.0;do{d=d+ +o[b+(g<<2)>>2];g=g+1|0}while((g|0)!=(Z|0))}else d=0.0;if(+P(+d)>1.1920928955078125e-07){d=1.0/d;if(C){g=0;do{R=b+(g<<2)|0;o[R>>2]=d*+o[R>>2];g=g+1|0}while((g|0)!=(Z|0))}}else if(C){g=0;do{o[b+(g<<2)>>2]=1.0;g=g+1|0}while((g|0)!=(Z|0))}voa(U,Z,b,W);n=n+1|0;if((n|0)>=30){j=x;d=y;break}else{g=1;u=l;v=e;j=x;w=y}}if(s<f){k[aa>>2]=k[W>>2];k[aa+4>>2]=k[W+4>>2];k[aa+8>>2]=k[W+8>>2];k[aa+12>>2]=k[W+12>>2];if(s<J)break;else f=s}a=a+1|0;if((a|0)>=20)break;else g=m}b=k[X>>2]|0;if((b|0)!=(H|0)){if(b|0)ggb(b);k[X>>2]=H;k[I>>2]=264}}}else{L=d;K=e;J=+(R|0)*1.1920928955078125e-07;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;k[W+16>>2]=0;k[W+20>>2]=0;K=K!=0.0?K:1.0;m=f!=0.0;switch(c|0){case 2:{woa(U,R,0,aa);break}case 1:{H=241;I=0;A=89;break}case 4:{H=242;I=0;A=89;break}case 5:{H=0;I=9;A=89;break}case 6:{H=0;I=10;A=89;break}case 7:{H=0;I=11;A=89;break}default:{k[X>>2]=0;b=X+4|0;k[b>>2]=0;g=ZT(24)|0;k[g>>2]=1;n=g+4|0;k[X>>2]=n;k[b>>2]=16;i[g+20>>0]=0;h=339775;t=n+16|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(t|0));Y8(-5,X,339792,339674,494);k[b>>2]=0;k[X>>2]=0;O=k[g>>2]|0;k[g>>2]=O+-1;if((O|0)==1)ggb(k[g+-4>>2]|0);H=0;I=0;A=89}}if((A|0)==89){h=R<<1;M=X+8|0;k[X>>2]=M;O=X+4|0;k[O>>2]=264;if(h>>>0>264){g=h>>>0>1073741823?-1:h<<2;g=(g|0)==0?1:g;while(1){b=fgb(g)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[X>>2]=b}else b=M;k[O>>2]=h;C=b+(R<<2)|0;D=(R|0)>0;E=(R|0)>10?10:R;F=W+4|0;G=W+8|0;z=m?f:.009999999776482582;p=W+12|0;q=W+16|0;t=W+20|0;c=(H|0)==0;A=R<<2;B=(R|0)==0|D^1;a=0;f=1797693134862315708145274.0e284;j=0.0;w=0.0;u=0.0;s=0.0;l=0.0;d=0.0;e=0.0;g=-1;h=-1;while(1){if(D)zpb(b|0,0,A|0)|0;if(B)m=g;else{n=0;while(1){m=g;do{g=Epb(m|0,0,-130063606,0)|0;m=kpb(g|0,N|0,h|0,0)|0;h=N;g=b+(((m>>>0)%(R>>>0)|0)<<2)|0}while(!(+o[g>>2]<1.1920928955078125e-07));n=n+1|0;o[g>>2]=1.0;if((n|0)>=(E|0))break;else g=m}}woa(U,R,b,W);g=0;n=0;x=d;v=e;while(1){y=+o[W>>2];if(g){d=+o[F>>2];e=+o[G>>2];ea=w*y+x*d+v*e;ea=ea<-1.0?-1.0:ea;if(+P(+(+V(+(ea>1.0?1.0:ea))))<z?(ia=+o[p>>2]-u,ea=+o[q>>2]-s,ka=+o[t>>2]-l,ha=y-w,ja=d-x,fa=e-v,ga=+P(+(fa*ea-ja*ka)),fa=+P(+(ha*ka-fa*ia)),ea=+P(+(ja*ia-ha*ea)),(ga>fa?(ga>ea?ga:ea):fa>ea?fa:ea)<K):0){d=x;e=v;break}else x=d}else{x=+o[F>>2];e=+o[G>>2]}u=+o[p>>2];s=+o[q>>2];l=+o[t>>2];if(D){d=0.0;g=0;do{ia=+o[U+(g*12|0)>>2]-u;ha=+o[U+(g*12|0)+4>>2]-s;ka=+o[U+(g*12|0)+8>>2]-l;ja=x*ka-e*ha;ka=e*ia-y*ka;ia=y*ha-x*ia;ka=+Q(+(ia*ia+(ja*ja+ka*ka)));o[C+(g<<2)>>2]=ka;d=d+ka;g=g+1|0}while((g|0)!=(R|0));j=d}else j=0.0;if(c)ah[I&31](C,R,b,L);else Ph[H&511](C,R,b);if(D){g=0;d=0.0;do{d=d+ +o[b+(g<<2)>>2];g=g+1|0}while((g|0)!=(R|0))}else d=0.0;if(+P(+d)>1.1920928955078125e-07){d=1.0/d;if(D){g=0;do{la=b+(g<<2)|0;o[la>>2]=d*+o[la>>2];g=g+1|0}while((g|0)!=(R|0))}}else if(D){g=0;do{o[b+(g<<2)>>2]=1.0;g=g+1|0}while((g|0)!=(R|0))}woa(U,R,b,W);n=n+1|0;if((n|0)>=30){w=y;d=x;break}else{g=1;w=y;v=e}}if(j<f){k[aa>>2]=k[W>>2];k[aa+4>>2]=k[W+4>>2];k[aa+8>>2]=k[W+8>>2];k[aa+12>>2]=k[W+12>>2];k[aa+16>>2]=k[W+16>>2];k[aa+20>>2]=k[W+20>>2];if(j<J)break;else f=j}a=a+1|0;if((a|0)>=20)break;else g=m}b=k[X>>2]|0;if((b|0)!=(M|0)){if(b|0)ggb(b);k[X>>2]=M;k[O>>2]=264}}}b=Z>>31&2|4;a=ba+4|0;k[a>>2]=2;q=ba+8|0;k[q>>2]=b;k[ba+12>>2]=1;m=ba+16|0;k[m>>2]=aa;k[ba+20>>2]=aa;h=ba+24|0;n=ba+40|0;p=h+8|0;k[p>>2]=0;k[p+4>>2]=0;k[n>>2]=q;q=ba+48|0;p=ba+44|0;k[p>>2]=q;k[ba>>2]=1124024325;k[q>>2]=4;k[ba+52>>2]=4;b=aa+(b<<2)|0;k[ba+28>>2]=b;k[h>>2]=b;mY(ba,$);h=ba+36|0;b=k[h>>2]|0;if(b|0?(aa=b+12|0,la=k[aa>>2]|0,k[aa>>2]=la+-1,(la|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[ba+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[a>>2]|0)>0){g=k[n>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[p>>2]|0;if(!((b|0)==(q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);h=ca+36|0;b=k[h>>2]|0;if(b|0?(ba=b+12|0,la=k[ba>>2]|0,k[ba>>2]=la+-1,(la|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[ca+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;h=ca+4|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[h>>2]|0)>0){g=k[ca+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[h>>2]|0))}b=k[ca+44>>2]|0;if((b|0)==(ca+48|0)|(b|0)==0){r=da;return}ggb(k[b+-4>>2]|0);r=da;return}function Rk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+32|0;f=d+16|0;e=d;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=a;a=e+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=b;qY(f,e,c);r=d;return}function Sk(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+64|0;m=h+48|0;l=h+32|0;j=h+16|0;i=h;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=b;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=d;d=i+4+4|0;k[d>>2]=0;k[d+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=f;s_(m,l,c,j,e,i,g);r=h;return}function Tk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0;N=r;r=r+688|0;C=N+48|0;K=N+624|0;D=N;I=N+568|0;G=N+512|0;E=N+496|0;F=N+480|0;B=N+464|0;M=N+392|0;L=N+336|0;l=N+448|0;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;m=l+4|0;k[m>>2]=c;k[M>>2]=k[b>>2];j=M+4|0;d=b+4|0;c=k[d>>2]|0;k[j>>2]=c;J=M+8|0;k[J>>2]=k[b+8>>2];k[M+12>>2]=k[b+12>>2];k[M+16>>2]=k[b+16>>2];k[M+20>>2]=k[b+20>>2];k[M+24>>2]=k[b+24>>2];k[M+28>>2]=k[b+28>>2];k[M+32>>2]=k[b+32>>2];e=k[b+36>>2]|0;k[M+36>>2]=e;f=M+40|0;k[f>>2]=J;J=M+48|0;h=M+44|0;k[h>>2]=J;k[M+52>>2]=0;k[J>>2]=0;if(e){c=e+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[d>>2]|0}if((c|0)>=3){k[j>>2]=0;x1(M,c,0,0,0);if((k[j>>2]|0)>0){g=k[b+40>>2]|0;f=k[f>>2]|0;e=k[b+44>>2]|0;d=k[h>>2]|0;c=0;do{k[f+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[j>>2]|0))}}else{H=k[b+44>>2]|0;J=k[h>>2]|0;k[J>>2]=k[H>>2];k[J+4>>2]=k[H+4>>2]}do if((k[l>>2]&2031616|0)==65536){g=k[m>>2]|0;k[L>>2]=k[g>>2];j=L+4|0;d=g+4|0;k[j>>2]=k[d>>2];J=L+8|0;k[J>>2]=k[g+8>>2];k[L+12>>2]=k[g+12>>2];k[L+16>>2]=k[g+16>>2];k[L+20>>2]=k[g+20>>2];k[L+24>>2]=k[g+24>>2];k[L+28>>2]=k[g+28>>2];k[L+32>>2]=k[g+32>>2];c=k[g+36>>2]|0;k[L+36>>2]=c;e=L+40|0;k[e>>2]=J;J=L+48|0;b=L+44|0;k[b>>2]=J;k[L+52>>2]=0;k[J>>2]=0;if(c|0){J=c+12|0;k[J>>2]=(k[J>>2]|0)+1}if((k[d>>2]|0)<3){H=k[g+44>>2]|0;J=k[b>>2]|0;k[J>>2]=k[H>>2];k[J+4>>2]=k[H+4>>2];break}k[j>>2]=0;x1(L,k[d>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[g+40>>2]|0;f=k[e>>2]|0;e=k[g+44>>2]|0;d=k[b>>2]|0;c=0;do{k[f+(c<<2)>>2]=k[h+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[j>>2]|0))}}else Q1(L,l,-1);while(0);if(!((y2(M,2,5,1)|0)==3?(y2(L,2,5,1)|0)==3:0)){k[C>>2]=0;c=C+4|0;k[c>>2]=0;d=ZT(72)|0;k[d>>2]=1;l=d+4|0;k[C>>2]=l;k[c>>2]=66;i[d+70>>0]=0;f=339263;m=l+66|0;do{i[l>>0]=i[f>>0]|0;l=l+1|0;f=f+1|0}while((l|0)<(m|0));Y8(-215,C,339330,335515,6360);k[c>>2]=0;k[C>>2]=0;J=k[d>>2]|0;k[d>>2]=J+-1;if((J|0)==1)ggb(k[d+-4>>2]|0)}J=M+16|0;n=k[J>>2]|0;H=L+16|0;q=k[H>>2]|0;k[a>>2]=1124007936;c=a+8|0;d=a+40|0;l=a+4|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[d>>2]=c;c=a+48|0;k[a+44>>2]=c;k[a+52>>2]=0;k[c>>2]=0;k[C>>2]=2;k[C+4>>2]=3;G1(a,2,C,6);c=k[a+16>>2]|0;k[K>>2]=1124007942;y=K+4|0;k[y>>2]=2;b=K+8|0;k[b>>2]=6;e=K+12|0;k[e>>2]=1;w=K+16|0;k[w>>2]=c;g=K+20|0;k[g>>2]=c;h=K+24|0;j=K+28|0;x=K+40|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[x>>2]=b;A=K+48|0;z=K+44|0;k[z>>2]=A;k[K+52>>2]=0;k[A>>2]=0;if(!c){k[C>>2]=0;c=C+4|0;k[c>>2]=0;d=ZT(36)|0;k[d>>2]=1;l=d+4|0;k[C>>2]=l;k[c>>2]=28;i[d+32>>0]=0;f=390609;m=l+28|0;do{i[l>>0]=i[f>>0]|0;l=l+1|0;f=f+1|0}while((l|0)<(m|0));Y8(-215,C,390638,390642,410);k[c>>2]=0;k[C>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0);d=k[e>>2]|0;e=k[K>>2]|0;f=k[z>>2]|0;c=k[g>>2]|0}else{d=1;e=1124007942;f=A}t=d<<3;k[K>>2]=e|16384;k[f>>2]=t;k[f+4>>2]=8;v=c+(aa(k[b>>2]|0,t)|0)|0;k[j>>2]=v;k[h>>2]=v+(0-t)+t;t=I+4|0;k[t>>2]=2;v=I+8|0;k[v>>2]=6;k[I+12>>2]=6;a=I+16|0;k[a>>2]=C;k[I+20>>2]=C;b=I+24|0;s=I+40|0;u=b+8|0;k[u>>2]=0;k[u+4>>2]=0;k[s>>2]=v;v=I+48|0;u=I+44|0;k[u>>2]=v;k[I>>2]=1124024326;k[v>>2]=48;k[I+52>>2]=8;k[I+28>>2]=C+288;k[b>>2]=C+288;b=G+4|0;k[b>>2]=2;j=G+8|0;k[j>>2]=6;k[G+12>>2]=1;f=G+16|0;k[f>>2]=D;k[G+20>>2]=D;l=G+24|0;g=G+40|0;h=l+8|0;k[h>>2]=0;k[h+4>>2]=0;k[g>>2]=j;j=G+48|0;h=G+44|0;k[h>>2]=j;k[G>>2]=1124024326;k[j>>2]=8;k[G+52>>2]=8;k[G+28>>2]=D+48;k[l>>2]=D+48;O=+o[n>>2];p[C+72>>3]=O;p[C>>3]=O;O=+o[n+4>>2];p[C+80>>3]=O;p[C+8>>3]=O;p[C+88>>3]=1.0;p[C+16>>3]=1.0;l=C+24|0;m=l+48|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));p[D>>3]=+o[q>>2];p[D+8>>3]=+o[q+4>>2];O=+o[n+8>>2];p[C+168>>3]=O;p[C+96>>3]=O;O=+o[n+12>>2];p[C+176>>3]=O;p[C+104>>3]=O;p[C+184>>3]=1.0;p[C+112>>3]=1.0;c=q+8|0;l=C+120|0;m=l+48|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));p[D+16>>3]=+o[c>>2];p[D+24>>3]=+o[q+12>>2];O=+o[n+16>>2];p[C+264>>3]=O;p[C+192>>3]=O;O=+o[n+20>>2];p[C+272>>3]=O;p[C+200>>3]=O;p[C+280>>3]=1.0;p[C+208>>3]=1.0;c=q+16|0;l=C+216|0;m=l+48|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));p[D+32>>3]=+o[c>>2];p[D+40>>3]=+o[q+20>>2];k[E+8>>2]=0;k[E+12>>2]=0;k[E>>2]=16842752;k[E+4>>2]=I;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=G;e=B+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[B>>2]=33619968;k[e>>2]=K;NZ(E,F,B,0)|0;e=G+36|0;c=k[e>>2]|0;if(c|0?(E=c+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[G+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[b>>2]|0)>0){d=k[g>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[h>>2]|0;if(!((c|0)==(j|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=I+36|0;c=k[e>>2]|0;if(c|0?(F=c+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[I+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[t>>2]|0)>0){d=k[s>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[t>>2]|0))}c=k[u>>2]|0;if(!((c|0)==(v|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=K+36|0;c=k[e>>2]|0;if(c|0?(G=c+12|0,I=k[G>>2]|0,k[G>>2]=I+-1,(I|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[K+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[y>>2]|0)>0){d=k[x>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[y>>2]|0))}c=k[z>>2]|0;if(!((c|0)==(A|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=L+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,K=k[I>>2]|0,k[I>>2]=K+-1,(K|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[L+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=L+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[e>>2]|0)>0){d=k[L+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[L+44>>2]|0;if(!((c|0)==(L+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=M+36|0;c=k[e>>2]|0;if(c|0?(K=c+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[M+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=M+4|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[e>>2]|0)>0){d=k[M+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[M+44>>2]|0;if((c|0)==(M+48|0)|(c|0)==0){r=N;return}ggb(k[c+-4>>2]|0);r=N;return}function Uk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+8|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;k[f>>2]=k[c>>2];k[f+4>>2]=k[c+4>>2];ava(a,g,f,d);r=e;return}function Vk(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0;j=r;r=r+32|0;h=j+16|0;i=j;l=h+4+4|0;k[l>>2]=0;k[l+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=a;a=i+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=b;if((e|0)<1){rfa(h,i,c,d,f,g);r=j;return}else{sfa(h,i,c,d,e,f,g);r=j;return}}function Wk(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;h=h|0;var j=0,l=0,m=0,n=0,q=0.0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0;D=r;r=r+16|0;z=D;j=k[b>>2]|0;l=k[b+4>>2]|0;q=c/f;C=+S(+d);B=+T(+d);if((j|0)>0)A=j>>>1;else{f=+P(+(c*3.0*C));s=+P(+(q*3.0*B));f=f<s?s:f;p[u>>3]=f;b=k[u+4>>2]|0;A=b&2146435072;if(!(A>>>0>1126170624|(A|0)==1126170624&0>0)){b=(b|0)<0;f=b?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=b?-0.0:0.0}A=~~f}if((l|0)>0)w=l>>>1;else{f=+P(+(c*3.0*B));s=+P(+(q*3.0*C));f=f<s?s:f;p[u>>3]=f;b=k[u+4>>2]|0;y=b&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){b=(b|0)<0;f=b?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=b?-0.0:0.0}w=~~f}x=0-A|0;j=0-w|0;y=(h|0)==5;if((h+-5|0)>>>0>=2){b=z+4|0;l=ZT(40)|0;k[l>>2]=1;t=l+4|0;k[z>>2]=t;k[b>>2]=34;i[l+38>>0]=0;m=351405;v=t+34|0;do{i[t>>0]=i[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(v|0));Y8(-215,z,256808,256823,73);k[b>>2]=0;k[z>>2]=0;v=k[l>>2]|0;k[l>>2]=v+-1;if((v|0)==1)ggb(k[l+-4>>2]|0)}m=w<<1|1;n=A<<1|1;k[a>>2]=1124007936;b=a+8|0;l=a+40|0;t=a+4|0;v=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(v|0));k[l>>2]=b;v=a+48|0;b=a+44|0;k[b>>2]=v;k[a+52>>2]=0;k[v>>2]=0;k[z>>2]=m;k[z+4>>2]=n;G1(a,2,z,h&4095);s=-.5/(c*c);c=-.5/(q*q);q=6.283185307179586/e;if((w|0)<(j|0)|(A|0)<(x|0)){r=D;return}n=k[a+16>>2]|0;m=k[k[b>>2]>>2]|0;while(1){d=+(j|0);f=B*d;d=C*d;l=n+(aa(m,w-j|0)|0)|0;if(y){b=x;while(1){e=f+C*+(b|0);E=d+B*+(0-b|0);e=+Z(+(e*(s*e)+E*(c*E)))*+S(+(q*e+g));o[l+(A-b<<2)>>2]=e;if((A|0)>(b|0))b=b+1|0;else break}}else{b=x;while(1){E=f+C*+(b|0);e=d+B*+(0-b|0);E=+Z(+(E*(s*E)+e*(c*e)))*+S(+(q*E+g));p[l+(A-b<<3)>>3]=E;if((A|0)>(b|0))b=b+1|0;else break}}if((w|0)>(j|0))j=j+1|0;else break}r=D;return}function Xk(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;tua(a,b,c,d);return}function Yk(a){a=a|0;var b=0,c=0,d=0,e=0;if(a>>>0>2125763999){a=-1;return a|0}else{b=1650;c=0}do{d=b+c>>1;e=(k[41108+(d<<2)>>2]|0)<(a|0);c=e?d+1|0:c;b=e?b:d}while((c|0)<(b|0));e=k[41108+(b<<2)>>2]|0;return e|0}function Zk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0;M=r;r=r+928|0;B=M+64|0;J=M+864|0;C=M;H=M+808|0;F=M+752|0;D=M+736|0;E=M+720|0;A=M+704|0;L=M+632|0;K=M+576|0;l=M+688|0;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;m=l+4|0;k[m>>2]=c;k[L>>2]=k[b>>2];j=L+4|0;d=b+4|0;c=k[d>>2]|0;k[j>>2]=c;I=L+8|0;k[I>>2]=k[b+8>>2];k[L+12>>2]=k[b+12>>2];k[L+16>>2]=k[b+16>>2];k[L+20>>2]=k[b+20>>2];k[L+24>>2]=k[b+24>>2];k[L+28>>2]=k[b+28>>2];k[L+32>>2]=k[b+32>>2];e=k[b+36>>2]|0;k[L+36>>2]=e;f=L+40|0;k[f>>2]=I;I=L+48|0;h=L+44|0;k[h>>2]=I;k[L+52>>2]=0;k[I>>2]=0;if(e){c=e+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[d>>2]|0}if((c|0)>=3){k[j>>2]=0;x1(L,c,0,0,0);if((k[j>>2]|0)>0){g=k[b+40>>2]|0;f=k[f>>2]|0;e=k[b+44>>2]|0;d=k[h>>2]|0;c=0;do{k[f+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[j>>2]|0))}}else{G=k[b+44>>2]|0;I=k[h>>2]|0;k[I>>2]=k[G>>2];k[I+4>>2]=k[G+4>>2]}do if((k[l>>2]&2031616|0)==65536){g=k[m>>2]|0;k[K>>2]=k[g>>2];j=K+4|0;d=g+4|0;k[j>>2]=k[d>>2];I=K+8|0;k[I>>2]=k[g+8>>2];k[K+12>>2]=k[g+12>>2];k[K+16>>2]=k[g+16>>2];k[K+20>>2]=k[g+20>>2];k[K+24>>2]=k[g+24>>2];k[K+28>>2]=k[g+28>>2];k[K+32>>2]=k[g+32>>2];c=k[g+36>>2]|0;k[K+36>>2]=c;e=K+40|0;k[e>>2]=I;I=K+48|0;b=K+44|0;k[b>>2]=I;k[K+52>>2]=0;k[I>>2]=0;if(c|0){I=c+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[d>>2]|0)<3){G=k[g+44>>2]|0;I=k[b>>2]|0;k[I>>2]=k[G>>2];k[I+4>>2]=k[G+4>>2];break}k[j>>2]=0;x1(K,k[d>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[g+40>>2]|0;f=k[e>>2]|0;e=k[g+44>>2]|0;d=k[b>>2]|0;c=0;do{k[f+(c<<2)>>2]=k[h+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[j>>2]|0))}}else Q1(K,l,-1);while(0);if(!((y2(L,2,5,1)|0)==4?(y2(K,2,5,1)|0)==4:0)){k[B>>2]=0;c=B+4|0;k[c>>2]=0;d=ZT(72)|0;k[d>>2]=1;l=d+4|0;k[B>>2]=l;k[c>>2]=66;i[d+70>>0]=0;f=339172;m=l+66|0;do{i[l>>0]=i[f>>0]|0;l=l+1|0;f=f+1|0}while((l|0)<(m|0));Y8(-215,B,339239,335515,6353);k[c>>2]=0;k[B>>2]=0;I=k[d>>2]|0;k[d>>2]=I+-1;if((I|0)==1)ggb(k[d+-4>>2]|0)}I=L+16|0;n=k[I>>2]|0;G=K+16|0;q=k[G>>2]|0;k[a>>2]=1124007936;c=a+8|0;d=a+40|0;l=a+4|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[d>>2]=c;c=a+48|0;k[a+44>>2]=c;k[a+52>>2]=0;k[c>>2]=0;k[B>>2]=3;k[B+4>>2]=3;G1(a,2,B,6);a=a+16|0;c=k[a>>2]|0;k[J>>2]=1124007942;x=J+4|0;k[x>>2]=2;b=J+8|0;k[b>>2]=8;e=J+12|0;k[e>>2]=1;v=J+16|0;k[v>>2]=c;g=J+20|0;k[g>>2]=c;h=J+24|0;j=J+28|0;w=J+40|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[w>>2]=b;z=J+48|0;y=J+44|0;k[y>>2]=z;k[J+52>>2]=0;k[z>>2]=0;if(!c){k[B>>2]=0;c=B+4|0;k[c>>2]=0;d=ZT(36)|0;k[d>>2]=1;l=d+4|0;k[B>>2]=l;k[c>>2]=28;i[d+32>>0]=0;f=390609;m=l+28|0;do{i[l>>0]=i[f>>0]|0;l=l+1|0;f=f+1|0}while((l|0)<(m|0));Y8(-215,B,390638,390642,410);k[c>>2]=0;k[B>>2]=0;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0);d=k[e>>2]|0;e=k[J>>2]|0;f=k[y>>2]|0;c=k[g>>2]|0}else{d=1;e=1124007942;f=z}s=d<<3;k[J>>2]=e|16384;k[f>>2]=s;k[f+4>>2]=8;u=c+(aa(k[b>>2]|0,s)|0)|0;k[j>>2]=u;k[h>>2]=u+(0-s)+s;s=H+4|0;k[s>>2]=2;u=H+8|0;k[u>>2]=8;k[H+12>>2]=8;l=H+16|0;k[l>>2]=B;k[H+20>>2]=B;b=H+24|0;m=H+40|0;t=b+8|0;k[t>>2]=0;k[t+4>>2]=0;k[m>>2]=u;u=H+48|0;t=H+44|0;k[t>>2]=u;k[H>>2]=1124024326;k[u>>2]=64;k[H+52>>2]=8;k[H+28>>2]=B+512;k[b>>2]=B+512;b=F+4|0;k[b>>2]=2;j=F+8|0;k[j>>2]=8;k[F+12>>2]=1;f=F+16|0;k[f>>2]=C;k[F+20>>2]=C;c=F+24|0;g=F+40|0;h=c+8|0;k[h>>2]=0;k[h+4>>2]=0;k[g>>2]=j;j=F+48|0;h=F+44|0;k[h>>2]=j;k[F>>2]=1124024326;k[j>>2]=8;k[F+52>>2]=8;k[F+28>>2]=C+64;k[c>>2]=C+64;c=0;do{Q=+o[n+(c<<3)>>2];P=Q;e=c+4|0;p[B+(e<<6)+24>>3]=P;p[B+(c<<6)>>3]=P;P=+o[n+(c<<3)+4>>2];O=P;p[B+(e<<6)+32>>3]=O;p[B+(c<<6)+8>>3]=O;p[B+(e<<6)+40>>3]=1.0;p[B+(c<<6)+16>>3]=1.0;d=B+(e<<6)|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;d=B+(c<<6)+24|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;O=+o[q+(c<<3)>>2];p[B+(c<<6)+48>>3]=-(Q*O);p[B+(c<<6)+56>>3]=-(P*O);N=+o[q+(c<<3)+4>>2];p[B+(e<<6)+48>>3]=-(Q*N);p[B+(e<<6)+56>>3]=-(P*N);p[C+(c<<3)>>3]=O;p[C+(e<<3)>>3]=N;c=c+1|0}while((c|0)!=4);k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=H;k[E+8>>2]=0;k[E+12>>2]=0;k[E>>2]=16842752;k[E+4>>2]=F;e=A+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[A>>2]=33619968;k[e>>2]=J;NZ(D,E,A,1)|0;p[(k[a>>2]|0)+64>>3]=1.0;e=F+36|0;c=k[e>>2]|0;if(c|0?(D=c+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[F+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[b>>2]|0)>0){d=k[g>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[h>>2]|0;if(!((c|0)==(j|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=H+36|0;c=k[e>>2]|0;if(c|0?(E=c+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[H+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[s>>2]|0)>0){d=k[m>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[s>>2]|0))}c=k[t>>2]|0;if(!((c|0)==(u|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=J+36|0;c=k[e>>2]|0;if(c|0?(F=c+12|0,H=k[F>>2]|0,k[F>>2]=H+-1,(H|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[x>>2]|0)>0){d=k[w>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[x>>2]|0))}c=k[y>>2]|0;if(!((c|0)==(z|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=K+36|0;c=k[e>>2]|0;if(c|0?(H=c+12|0,J=k[H>>2]|0,k[H>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[K+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=K+4|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[e>>2]|0)>0){d=k[K+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[K+44>>2]|0;if(!((c|0)==(K+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=L+36|0;c=k[e>>2]|0;if(c|0?(J=c+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[L+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=L+4|0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[e>>2]|0)>0){d=k[L+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[L+44>>2]|0;if((c|0)==(L+48|0)|(c|0)==0){r=M;return}ggb(k[c+-4>>2]|0);r=M;return}function _k(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+48|0;j=f+32|0;i=f+24|0;h=f+16|0;g=f;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];k[h>>2]=k[c>>2];k[h+4>>2]=k[c+4>>2];c=g+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=d;Wra(j,i,h,g,e);r=f;return}function $k(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,h=0.0,i=0.0,j=0,l=0.0,m=0,n=0.0;m=r;r=r+16|0;j=m;l=+o[b>>2];i=+o[b+4>>2];c=c*.017453292519943295;h=+S(+c)*d;c=+T(+c)*d;k[a>>2]=1124007936;b=a+8|0;e=a+40|0;f=a+4|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=b;g=a+48|0;k[a+44>>2]=g;k[a+52>>2]=0;k[g>>2]=0;k[j>>2]=2;k[j+4>>2]=3;G1(a,2,j,6);j=k[a+16>>2]|0;p[j>>3]=h;p[j+8>>3]=c;d=1.0-h;n=l;l=i;p[j+16>>3]=d*n-c*l;p[j+24>>3]=-c;p[j+32>>3]=h;p[j+40>>3]=c*n+d*l;r=m;return}function al(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+16|0;g=e+8|0;f=e;k[g>>2]=k[c>>2];k[g+4>>2]=k[c+4>>2];k[f>>2]=k[d>>2];k[f+4>>2]=k[d+4>>2];Cra(a,b,g,f);r=e;return}function bl(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;var g=0.0,h=0,j=0,m=0,n=0.0,o=0,q=0,r=0,s=0,t=0,v=0;h=b+11|0;j=i[h>>0]|0;m=j<<24>>24<0;if(!((m?k[b+4>>2]|0:j&255)|0)){v=0;r=0}else{r=m?k[b+4>>2]|0:j&255;v=ZT(r+8&-4)|0;k[v>>2]=1;v=v+4|0;i[v+r>>0]=0;upb(v|0,((i[h>>0]|0)<0?k[b>>2]|0:b)|0,r|0)|0}k[a>>2]=0;h=a+4|0;s=_fa(c)|0;b=k[s>>2]|0;t=b&15;g=+((e+1|0)/2|0|0)+ +((b>>>4&15)+t|0)*d;p[u>>3]=g;b=k[u+4>>2]|0;q=b&2146435072;if(!(q>>>0>1126170624|(q|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}k[h>>2]=~~g;if((r|0)>0){q=(c|0)==3;h=0;g=0.0;do{c=i[v+h>>0]|0;b=c&255;a:do if(q&c<<24>>24<0){switch(c<<24>>24){case -48:{j=h+1|0;b=i[v+j>>0]|0;if((b+112&255)<48){b=(b&255)+-17|0;c=175;o=127;h=j;break a}else m=b;break}case -47:{j=h+1|0;b=i[v+j>>0]|0;if(b<<24>>24<0&(b&255)<144){b=(b&255)+47|0;c=191;o=175;h=j;break a}else m=b;break}default:{if((c&255)<=191){b=63;c=127;o=32;break a}j=h+1|0;j=(i[v+j>>0]|0)==0?h:j;if((c&255)<=223){b=63;c=127;o=32;h=j;break a}b=j+1|0;o=(i[v+b>>0]|0)==0;h=o?j:b;b=o?j:b;if((c&255)<=239){b=63;c=127;o=32;break a}o=b+1|0;m=(i[v+o>>0]|0)==0;h=m?h:o;b=m?b:o;if((c&255)<=247){b=63;c=127;o=32;break a}j=b+1|0;m=(i[v+j>>0]|0)==0;h=m?h:j;if((c&255)<=251){b=63;c=127;o=32;break a}m=(m?b:j)+1|0;b=63;c=127;o=32;h=(i[v+m>>0]|0)==0?h:m;break a}}b=63;c=127;o=32;h=m<<24>>24==0?h:j}else{c=127;o=32}while(0);o=k[72624+(k[s+(((b|0)>=(c|0)|(b|0)<(o|0)?32:b+-31|0)<<2)>>2]<<2)>>2]|0;g=g+ +((l[o+1>>0]|0)-(l[o>>0]|0)|0)*d;h=h+1|0}while((h|0)<(r|0))}else g=0.0;n=+(e|0);g=n+g;p[u>>3]=g;b=k[u+4>>2]|0;e=b&2146435072;if(!(e>>>0>1126170624|(e|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}k[a>>2]=~~g;if(f|0){g=n*.5+ +(t|0)*d;p[u>>3]=g;b=k[u+4>>2]|0;a=b&2146435072;if(!(a>>>0>1126170624|(a|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}k[f>>2]=~~g}if(!v)return;a=v+-4|0;f=k[a>>2]|0;k[a>>2]=f+-1;if((f|0)!=1)return;ggb(k[v+-8>>2]|0);return}function cl(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;var j=0,l=0,m=0,n=0;j=r;r=r+48|0;n=j+32|0;m=j+16|0;l=j;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=a;a=m+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[m>>2]=33619968;k[m+4>>2]=b;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=f;aga(n,m,c,d,e,l,g,h,i);r=j;return}function dl(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0,n=0;h=r;r=r+80|0;n=h+64|0;m=h+48|0;l=h+32|0;j=h+16|0;i=h;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=a;a=m+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[m>>2]=50397184;k[m+4>>2]=b;k[l>>2]=k[c>>2];k[l+4>>2]=k[c+4>>2];k[l+8>>2]=k[c+8>>2];k[l+12>>2]=k[c+12>>2];c=j+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[j>>2]=50397184;k[j+4>>2]=d;d=i+4+4|0;k[d>>2]=0;k[d+4>>2]=0;k[i>>2]=50397184;k[i+4>>2]=e;mla(n,m,l,j,i,f,g);r=h;return}function el(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;QRa(a,c,d,b,0);return}function fl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=r;r=r+48|0;d=c+32|0;f=c+16|0;e=c;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=17104896;k[f+4>>2]=a;a=e+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=b;k[d>>2]=0;a=d+4|0;k[a>>2]=0;k[d+8>>2]=0;B2(f,d);b=k[d>>2]|0;a=k[a>>2]|0;O2((b|0)==(a|0)?0:b,(a-b|0)/56|0,e);zF(d);r=c;return}function gl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+32|0;f=d+16|0;e=d;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=a;a=e+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=b;sZ(f,e,c|1);r=d;return}function hl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;bZ(g,f,c|1,d);r=e;return}function il(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;ja=r;r=r+1792|0;P=ja+688|0;ba=ja+1736|0;$=ja+1680|0;_=ja+1624|0;W=ja+1568|0;U=ja+1512|0;L=ja+1496|0;M=ja+1480|0;J=ja+672|0;K=ja+1464|0;N=ja+448|0;ia=ja+1376|0;ha=ja+1320|0;o=ja+1312|0;ga=ja+1256|0;ea=ja+1200|0;s=ja+224|0;da=ja+1144|0;t=ja;ca=ja+744|0;l=ja+1448|0;q=ja+1432|0;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;m=l+4|0;k[m>>2]=b;n=q+4|0;j=q+4+4|0;k[j>>2]=0;k[j+4>>2]=0;k[q>>2]=33619968;k[n>>2]=c;k[ia>>2]=k[a>>2];j=ia+4|0;c=a+4|0;b=k[c>>2]|0;k[j>>2]=b;fa=ia+8|0;k[fa>>2]=k[a+8>>2];k[ia+12>>2]=k[a+12>>2];k[ia+16>>2]=k[a+16>>2];k[ia+20>>2]=k[a+20>>2];k[ia+24>>2]=k[a+24>>2];k[ia+28>>2]=k[a+28>>2];k[ia+32>>2]=k[a+32>>2];f=k[a+36>>2]|0;k[ia+36>>2]=f;g=ia+40|0;k[g>>2]=fa;fa=ia+48|0;i=ia+44|0;k[i>>2]=fa;k[ia+52>>2]=0;k[fa>>2]=0;if(f){b=f+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[j>>2]=0;x1(ia,b,0,0,0);if((k[j>>2]|0)>0){h=k[a+40>>2]|0;g=k[g>>2]|0;f=k[a+44>>2]|0;c=k[i>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else{aa=k[a+44>>2]|0;fa=k[i>>2]|0;k[fa>>2]=k[aa>>2];k[fa+4>>2]=k[aa+4>>2]}do if((k[l>>2]&2031616|0)==65536){g=k[m>>2]|0;k[ha>>2]=k[g>>2];j=ha+4|0;b=g+4|0;k[j>>2]=k[b>>2];fa=ha+8|0;k[fa>>2]=k[g+8>>2];k[ha+12>>2]=k[g+12>>2];k[ha+16>>2]=k[g+16>>2];k[ha+20>>2]=k[g+20>>2];k[ha+24>>2]=k[g+24>>2];k[ha+28>>2]=k[g+28>>2];k[ha+32>>2]=k[g+32>>2];c=k[g+36>>2]|0;k[ha+36>>2]=c;f=ha+40|0;k[f>>2]=fa;fa=ha+48|0;i=ha+44|0;k[i>>2]=fa;k[ha+52>>2]=0;k[fa>>2]=0;if(c|0){fa=c+12|0;k[fa>>2]=(k[fa>>2]|0)+1}if((k[b>>2]|0)<3){aa=k[g+44>>2]|0;fa=k[i>>2]|0;k[fa>>2]=k[aa>>2];k[fa+4>>2]=k[aa+4>>2];break}k[j>>2]=0;x1(ha,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){a=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;c=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else Q1(ha,l,-1);while(0);fa=ia+40|0;Z=k[fa>>2]|0;aa=k[Z>>2]|0;k[o>>2]=k[Z+4>>2];k[o+4>>2]=aa;x2(q,o,k[ia>>2]&4095,0);do if((k[q>>2]&2031616|0)==65536){g=k[n>>2]|0;k[ga>>2]=k[g>>2];j=ga+4|0;b=g+4|0;k[j>>2]=k[b>>2];aa=ga+8|0;k[aa>>2]=k[g+8>>2];k[ga+12>>2]=k[g+12>>2];k[ga+16>>2]=k[g+16>>2];k[ga+20>>2]=k[g+20>>2];k[ga+24>>2]=k[g+24>>2];k[ga+28>>2]=k[g+28>>2];k[ga+32>>2]=k[g+32>>2];c=k[g+36>>2]|0;k[ga+36>>2]=c;f=ga+40|0;k[f>>2]=aa;aa=ga+48|0;i=ga+44|0;k[i>>2]=aa;k[ga+52>>2]=0;k[aa>>2]=0;if(c|0){aa=c+12|0;k[aa>>2]=(k[aa>>2]|0)+1}if((k[b>>2]|0)<3){Z=k[g+44>>2]|0;aa=k[i>>2]|0;k[aa>>2]=k[Z>>2];k[aa+4>>2]=k[Z+4>>2];break}k[j>>2]=0;x1(ga,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){a=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;c=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else Q1(ga,q,-1);while(0);aa=ha+40|0;g=k[aa>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=1124007936;b=s+16|0;c=s+48|0;i=s+12|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;b=s+56|0;k[s+52>>2]=b;k[s+60>>2]=0;k[b>>2]=0;k[s+64>>2]=1124007936;b=s+72|0;c=s+104|0;i=s+68|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;b=s+112|0;k[s+108>>2]=b;k[s+116>>2]=0;k[b>>2]=0;k[s+120>>2]=1124007936;b=s+128|0;c=s+160|0;i=s+124|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;i=s+168|0;k[s+164>>2]=i;w=i+56|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[P>>2]=f;k[P+4>>2]=g;j1(s,48,P,0);k[ea>>2]=1124007936;Y=ea+4|0;b=ea+8|0;V=ea+40|0;i=Y;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[V>>2]=b;Z=ea+48|0;X=ea+44|0;k[X>>2]=Z;k[ea+52>>2]=0;k[Z>>2]=0;T=k[s>>2]|0;dh[k[(k[T>>2]|0)+12>>2]&255](T,s,ea,-1);XN(s);if((k[ha>>2]&4088|0)==16){k[P+8>>2]=0;k[P+12>>2]=0;k[P>>2]=16842752;k[P+4>>2]=ha;T=ba+4|0;S=T+4|0;k[S>>2]=0;k[S+4>>2]=0;k[ba>>2]=33619968;k[T>>2]=ea;$aa(P,ba,6,0)}else KG(ea,ha)|0;g=k[fa>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=1124007936;b=t+16|0;c=t+48|0;i=t+12|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;b=t+56|0;k[t+52>>2]=b;k[t+60>>2]=0;k[b>>2]=0;k[t+64>>2]=1124007936;b=t+72|0;c=t+104|0;i=t+68|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;b=t+112|0;k[t+108>>2]=b;k[t+116>>2]=0;k[b>>2]=0;k[t+120>>2]=1124007936;b=t+128|0;c=t+160|0;i=t+124|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;i=t+168|0;k[t+164>>2]=i;w=i+56|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[P>>2]=f;k[P+4>>2]=g;j1(t,48,P,16);k[da>>2]=1124007936;S=da+4|0;b=da+8|0;O=da+40|0;i=S;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[O>>2]=b;T=da+48|0;Q=da+44|0;k[Q>>2]=T;k[da+52>>2]=0;k[T>>2]=0;b=k[t>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,t,da,-1);XN(t);b=P+4|0;i=b+4|0;k[i>>2]=0;k[i+4>>2]=0;k[P>>2]=33619968;k[b>>2]=da;k[ba+8>>2]=0;k[ba+12>>2]=0;k[ba>>2]=16842752;k[ba+4>>2]=ea;nY(ia,P,ba);b=ca+36|0;i=ca;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[b>>2]=1124007936;b=ca+44|0;c=ca+76|0;i=ca+40|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;b=ca+84|0;k[ca+80>>2]=b;k[ca+88>>2]=0;k[b>>2]=0;k[ca+92>>2]=1124007936;b=ca+100|0;c=ca+132|0;i=ca+96|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;b=ca+140|0;k[ca+136>>2]=b;k[ca+144>>2]=0;k[b>>2]=0;k[ca+148>>2]=1124007936;b=ca+156|0;c=ca+188|0;i=ca+152|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;b=ca+196|0;k[ca+192>>2]=b;k[ca+200>>2]=0;k[b>>2]=0;k[ca+204>>2]=1124007936;b=ca+212|0;c=ca+244|0;i=ca+208|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;b=ca+252|0;k[ca+248>>2]=b;k[ca+256>>2]=0;k[b>>2]=0;k[ca+260>>2]=1124007936;b=ca+268|0;c=ca+300|0;i=ca+264|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;b=ca+308|0;k[ca+304>>2]=b;k[ca+312>>2]=0;k[b>>2]=0;k[ca+316>>2]=1124007936;b=ca+324|0;c=ca+356|0;i=ca+320|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;j=ca+364|0;k[ca+360>>2]=j;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;k[j+20>>2]=0;k[j+24>>2]=0;k[j+28>>2]=0;U3a(ca,ia,da,ea);j=ca+148|0;f=ca+260|0;W3a(j,f,j);l=ca+204|0;W3a(l,f,l);f=k[fa>>2]|0;c=k[f+4>>2]|0;f=k[f>>2]|0;k[ba>>2]=1124007936;H=ba+4|0;b=ba+8|0;F=ba+40|0;i=H;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[F>>2]=b;I=ba+48|0;G=ba+44|0;k[G>>2]=I;k[ba+52>>2]=0;k[I>>2]=0;k[P>>2]=f;k[P+4>>2]=c;G1(ba,2,P,21);k[P+8>>2]=0;k[P+12>>2]=0;k[P>>2]=16842752;k[P+4>>2]=j;k[$+8>>2]=0;k[$+12>>2]=0;k[$>>2]=16842752;k[$+4>>2]=l;D=_+4|0;b=D+4|0;k[b>>2]=0;k[b+4>>2]=0;k[_>>2]=33619968;k[D>>2]=ba;UZ(P,$,_);k[$>>2]=1124007936;D=$+4|0;b=$+8|0;B=$+40|0;i=D;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[B>>2]=b;E=$+48|0;C=$+44|0;k[C>>2]=E;k[$+52>>2]=0;k[E>>2]=0;k[_>>2]=1124007936;z=_+4|0;b=_+8|0;x=_+40|0;i=z;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[x>>2]=b;A=_+48|0;y=_+44|0;k[y>>2]=A;k[_+52>>2]=0;k[A>>2]=0;k[W>>2]=1124007936;u=W+4|0;b=W+8|0;s=W+40|0;i=u;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[s>>2]=b;v=W+48|0;t=W+44|0;k[t>>2]=v;k[W+52>>2]=0;k[v>>2]=0;k[U>>2]=1124007936;o=U+4|0;b=U+8|0;m=U+40|0;i=o;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[m>>2]=b;q=U+48|0;n=U+44|0;k[n>>2]=q;k[U+52>>2]=0;k[q>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=j;d=+R(+d,+e);p[J>>3]=d;k[M>>2]=-1056833530;k[M+4>>2]=J;k[M+8>>2]=1;k[M+12>>2]=1;b=K+4|0;c=b+4|0;k[c>>2]=0;k[c+4>>2]=0;k[K>>2]=33619968;k[b>>2]=$;p[P>>3]=1.0;sU(L,M,K,49332,-1,40032,1,P);k[P+8>>2]=0;k[P+12>>2]=0;k[P>>2]=16842752;k[P+4>>2]=ba;e=-e;b=L+4|0;c=b+4|0;k[c>>2]=0;k[c+4>>2]=0;k[L>>2]=33619968;k[b>>2]=W;ZZ(P,e,L);k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=$;k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=16842752;k[M+4>>2]=W;b=J+4|0;c=b+4|0;k[c>>2]=0;k[c+4>>2]=0;k[J>>2]=33619968;k[b>>2]=j;p[P>>3]=1.0;sU(L,M,J,49332,-1,40032,1,P);b=P+4|0;c=b+4|0;k[c>>2]=0;k[c+4>>2]=0;k[P>>2]=50397184;k[b>>2]=j;k_(P,0.0);k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=l;p[J>>3]=d;k[M>>2]=-1056833530;k[M+4>>2]=J;k[M+8>>2]=1;k[M+12>>2]=1;b=K+4|0;c=b+4|0;k[c>>2]=0;k[c+4>>2]=0;k[K>>2]=33619968;k[b>>2]=_;p[P>>3]=1.0;sU(L,M,K,49332,-1,40032,1,P);k[P+8>>2]=0;k[P+12>>2]=0;k[P>>2]=16842752;k[P+4>>2]=ba;b=L+4|0;c=b+4|0;k[c>>2]=0;k[c+4>>2]=0;k[L>>2]=33619968;k[b>>2]=U;ZZ(P,e,L);k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=_;k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=16842752;k[M+4>>2]=U;b=J+4|0;c=b+4|0;k[c>>2]=0;k[c+4>>2]=0;k[J>>2]=33619968;k[b>>2]=l;p[P>>3]=1.0;sU(L,M,J,49332,-1,40032,1,P);b=P+4|0;c=b+4|0;k[c>>2]=0;k[c+4>>2]=0;k[P>>2]=50397184;k[b>>2]=l;k_(P,0.0);k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=1124007936;b=N+16|0;c=N+48|0;i=N+12|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;b=N+56|0;k[N+52>>2]=b;k[N+60>>2]=0;k[b>>2]=0;k[N+64>>2]=1124007936;b=N+72|0;c=N+104|0;i=N+68|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;b=N+112|0;k[N+108>>2]=b;k[N+116>>2]=0;k[b>>2]=0;k[N+120>>2]=1124007936;b=N+128|0;c=N+160|0;i=N+124|0;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[c>>2]=b;i=N+168|0;k[N+164>>2]=i;w=i+56|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));h1(N,5,j,0.0);k[P>>2]=1124007936;a=P+4|0;b=P+8|0;h=P+40|0;i=a;w=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(w|0));k[h>>2]=b;i=P+48|0;g=P+44|0;k[g>>2]=i;k[P+52>>2]=0;k[i>>2]=0;f=k[N>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,N,P,-1);XN(N);f=L+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[L>>2]=33619968;k[f>>2]=j;k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=16842752;k[M+4>>2]=P;nY(j,L,M);f=L+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[L>>2]=33619968;k[f>>2]=l;k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=16842752;k[M+4>>2]=P;nY(l,L,M);X3a(ca,ia,ea,ga);f=P+36|0;b=k[f>>2]|0;if(b|0?(M=b+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[P+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;P=P+16|0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[a>>2]|0)>0){c=k[h>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[g>>2]|0;if(!((b|0)==(i|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=U+36|0;b=k[f>>2]|0;if(b|0?(N=b+12|0,P=k[N>>2]|0,k[N>>2]=P+-1,(P|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[U+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;U=U+16|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[o>>2]|0)>0){c=k[m>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[o>>2]|0))}b=k[n>>2]|0;if(!((b|0)==(q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=W+36|0;b=k[f>>2]|0;if(b|0?(P=b+12|0,U=k[P>>2]|0,k[P>>2]=U+-1,(U|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[W+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;W=W+16|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[u>>2]|0)>0){c=k[s>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[u>>2]|0))}b=k[t>>2]|0;if(!((b|0)==(v|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=_+36|0;b=k[f>>2]|0;if(b|0?(U=b+12|0,W=k[U>>2]|0,k[U>>2]=W+-1,(W|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[_+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;_=_+16|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[z>>2]|0)>0){c=k[x>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[y>>2]|0;if(!((b|0)==(A|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=$+36|0;b=k[f>>2]|0;if(b|0?(W=b+12|0,_=k[W>>2]|0,k[W>>2]=_+-1,(_|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[$+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;$=$+16|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[D>>2]|0)>0){c=k[B>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[D>>2]|0))}b=k[C>>2]|0;if(!((b|0)==(E|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ba+36|0;b=k[f>>2]|0;do if(b|0){_=b+12|0;$=k[_>>2]|0;k[_>>2]=$+-1;if(($|0)!=1)break;c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ba+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}while(0);k[f>>2]=0;ba=ba+16|0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[H>>2]|0)>0){c=k[F>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[H>>2]|0))}b=k[G>>2]|0;if(!((b|0)==(I|0)|(b|0)==0))ggb(k[b+-4>>2]|0);P3a(ca);f=da+36|0;b=k[f>>2]|0;do if(b|0){ba=b+12|0;ca=k[ba>>2]|0;k[ba>>2]=ca+-1;if((ca|0)!=1)break;c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[da+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}while(0);k[f>>2]=0;da=da+16|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[S>>2]|0)>0){c=k[O>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[S>>2]|0))}b=k[Q>>2]|0;if(!((b|0)==(T|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ea+36|0;b=k[f>>2]|0;do if(b|0){ca=b+12|0;da=k[ca>>2]|0;k[ca>>2]=da+-1;if((da|0)!=1)break;c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ea+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}while(0);k[f>>2]=0;ea=ea+16|0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[Y>>2]|0)>0){c=k[V>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Y>>2]|0))}b=k[X>>2]|0;if(!((b|0)==(Z|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ga+36|0;b=k[f>>2]|0;do if(b|0){da=b+12|0;ea=k[da>>2]|0;k[da>>2]=ea+-1;if((ea|0)!=1)break;c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ga+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}while(0);k[f>>2]=0;ea=ga+16|0;c=ga+4|0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[c>>2]|0)>0){f=k[ga+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[ga+44>>2]|0;if(!((b|0)==(ga+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ha+36|0;b=k[f>>2]|0;do if(b|0){ea=b+12|0;ga=k[ea>>2]|0;k[ea>>2]=ga+-1;if((ga|0)!=1)break;c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ha+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}while(0);k[f>>2]=0;ga=ha+16|0;f=ha+4|0;k[ga>>2]=0;k[ga+4>>2]=0;k[ga+8>>2]=0;k[ga+12>>2]=0;if((k[f>>2]|0)>0){c=k[aa>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[ha+44>>2]|0;if(!((b|0)==(ha+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ia+36|0;b=k[f>>2]|0;do if(b|0){ga=b+12|0;ha=k[ga>>2]|0;k[ga>>2]=ha+-1;if((ha|0)!=1)break;c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ia+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}while(0);k[f>>2]=0;ha=ia+16|0;f=ia+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[f>>2]|0)>0){c=k[fa>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[ia+44>>2]|0;if((b|0)==(ia+48|0)|(b|0)==0){r=ja;return}ggb(k[b+-4>>2]|0);r=ja;return}function jl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=r;r=r+176|0;v=H+24|0;q=H+16|0;p=H+8|0;n=H;o=H+168|0;w=H+160|0;E=H+104|0;D=H+96|0;B=H+88|0;G=H+32|0;k[G>>2]=k[b>>2];l=G+4|0;e=b+4|0;d=k[e>>2]|0;k[l>>2]=d;A=G+8|0;k[A>>2]=k[b+8>>2];k[G+12>>2]=k[b+12>>2];F=G+16|0;k[F>>2]=k[b+16>>2];k[G+20>>2]=k[b+20>>2];k[G+24>>2]=k[b+24>>2];k[G+28>>2]=k[b+28>>2];k[G+32>>2]=k[b+32>>2];f=k[b+36>>2]|0;k[G+36>>2]=f;g=G+40|0;k[g>>2]=A;A=G+48|0;j=G+44|0;k[j>>2]=A;k[G+52>>2]=0;k[A>>2]=0;if(f){d=f+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[e>>2]|0}if((d|0)>=3){k[l>>2]=0;x1(G,d,0,0,0);if((k[l>>2]|0)>0){h=k[b+40>>2]|0;g=k[g>>2]|0;f=k[b+44>>2]|0;e=k[j>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[h+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else{z=k[b+44>>2]|0;A=k[j>>2]|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2]}k[a>>2]=1124007936;u=a+4|0;m=a+8|0;s=a+40|0;g=u;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[s>>2]=m;A=a+48|0;k[a+44>>2]=A;k[a+52>>2]=0;k[A>>2]=0;if(k[F>>2]|0){f=k[G+4>>2]|0;if((f|0)<3)d=aa(k[G+12>>2]|0,k[G+8>>2]|0)|0;else{g=k[G+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}if(!((d|0)!=0?(k[G>>2]&16384|0)!=0:0))C=15}else C=15;if((C|0)==15){k[o>>2]=0;d=o+4|0;k[d>>2]=0;e=ZT(40)|0;k[e>>2]=1;g=e+4|0;k[o>>2]=g;k[d>>2]=34;i[e+38>>0]=0;f=357792;h=g+34|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,o,357827,357634,490);k[d>>2]=0;k[o>>2]=0;A=k[e>>2]|0;k[e>>2]=A+-1;if((A|0)==1)ggb(k[e+-4>>2]|0)}k[w>>2]=0;k[E>>2]=1124007936;A=E+4|0;d=E+8|0;y=E+40|0;g=A;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[y>>2]=d;z=E+48|0;x=E+44|0;k[x>>2]=z;k[E+52>>2]=0;k[z>>2]=0;k[D>>2]=0;t=D+4|0;k[t>>2]=0;b=G+8|0;j=G+12|0;do if((aa(k[j>>2]|0,k[b>>2]|0)|0)>=1?(k[G>>2]&16384|0)!=0:0){e=k[206763]|0;if((k[206764]|0)==(e|0))d=0;else{d=0;f=0;do{l=k[e+(f<<3)+4>>2]|0;l=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;d=d>>>0<l>>>0?l:d;f=f+1|0;e=k[206763]|0}while(f>>>0<(k[206764]|0)-e>>3>>>0)}k[o>>2]=0;g=o+4|0;k[g>>2]=0;f=ZT(d+8&-4)|0;k[f>>2]=1;f=f+4|0;k[o>>2]=f;k[g>>2]=d;i[f+d>>0]=0;zpb(k[o>>2]|0,32,d|0)|0;f=aa(k[j>>2]|0,k[b>>2]|0)|0;h=G+4|0;e=k[h>>2]|0;if((e|0)>0)e=k[(k[G+44>>2]|0)+(e+-1<<2)>>2]|0;else e=0;l=aa(f,e)|0;f=k[o>>2]|0;upb(((f|0)==0?1016759:f)|0,k[F>>2]|0,(l>>>0<d>>>0?l:d)|0)|0;d=k[206763]|0;a:do if((k[206764]|0)==(d|0))C=29;else{e=0;while(1){l=k[d+(e<<3)+4>>2]|0;if(Hh[k[(k[l>>2]|0)+40>>2]&511](l,o)|0)break;e=e+1|0;d=k[206763]|0;if(e>>>0>=(k[206764]|0)-d>>3>>>0){C=29;break a}}l=k[(k[206763]|0)+(e<<3)+4>>2]|0;jh[k[(k[l>>2]|0)+44>>2]&1023](B,l)}while(0);if((C|0)==29){k[B>>2]=0;k[B+4>>2]=0}d=k[o>>2]|0;k[g>>2]=0;k[o>>2]=0;if(d|0?(g=d+-4|0,l=k[g>>2]|0,k[g>>2]=l+-1,(l|0)==1):0)ggb(k[d+-8>>2]|0);e=B+4|0;d=k[e>>2]|0;if(d){if(!(Hh[k[(k[d>>2]|0)+16>>2]&511](d,G)|0)){k9(o);d=k[D>>2]|0;k[t>>2]=0;k[D>>2]=0;if(d|0?(g=d+-4|0,l=k[g>>2]|0,k[g>>2]=l+-1,(l|0)==1):0)ggb(k[d+-8>>2]|0);d=k[o>>2]|0;if(!d)f=0;else{d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1;d=k[o>>2]|0;f=d}k[D>>2]=f;l=o+4|0;k[t>>2]=k[l>>2];k[l>>2]=0;k[o>>2]=0;if(d|0?(g=d+-4|0,l=k[g>>2]|0,k[g>>2]=l+-1,(l|0)==1):0)ggb(k[d+-8>>2]|0);l=k[D>>2]|0;l=Ufb((l|0)==0?1016759:l,377117)|0;if(!l)break;f=aa(k[b>>2]|0,k[j>>2]|0)|0;d=k[h>>2]|0;if((d|0)>0)d=k[(k[G+44>>2]|0)+(d+-1<<2)>>2]|0;else d=0;j=aa(f,d)|0;f=k[F>>2]|0;h=l+16|0;d=k[h>>2]|0;g=(d|0)==0;b:do if((k[l+76>>2]|0)>-1){do if(g){d=l+74|0;b=i[d>>0]|0;i[d>>0]=b+255|b;d=k[l>>2]|0;if(!(d&8)){k[l+8>>2]=0;k[l+4>>2]=0;d=k[l+44>>2]|0;k[l+28>>2]=d;b=l+20|0;k[b>>2]=d;g=d+(k[l+48>>2]|0)|0;k[h>>2]=g;h=d;break}else{k[l>>2]=d|32;break b}}else{h=l+20|0;g=d;b=h;h=k[h>>2]|0}while(0);d=h;if((g-h|0)>>>0<j>>>0){ci[k[l+36>>2]&255](l,f,j)|0;break}c:do if((i[l+75>>0]|0)>-1){h=j;while(1){if(!h){g=j;break c}g=h+-1|0;if((i[f+g>>0]|0)==10)break;else h=g}if((ci[k[l+36>>2]&255](l,f,h)|0)>>>0<h>>>0)break b;g=j-h|0;f=f+h|0;d=k[b>>2]|0}else g=j;while(0);upb(d|0,f|0,g|0)|0;k[b>>2]=(k[b>>2]|0)+g}else{do if(g){d=l+74|0;b=i[d>>0]|0;i[d>>0]=b+255|b;d=k[l>>2]|0;if(!(d&8)){k[l+8>>2]=0;k[l+4>>2]=0;d=k[l+44>>2]|0;k[l+28>>2]=d;b=l+20|0;k[b>>2]=d;g=d+(k[l+48>>2]|0)|0;k[h>>2]=g;h=d;break}else{k[l>>2]=d|32;break b}}else{h=l+20|0;g=d;b=h;h=k[h>>2]|0}while(0);d=h;if((g-h|0)>>>0<j>>>0){ci[k[l+36>>2]&255](l,f,j)|0;break}d:do if((i[l+75>>0]|0)>-1){h=j;while(1){if(!h){g=j;break d}g=h+-1|0;if((i[f+g>>0]|0)==10)break;else h=g}if((ci[k[l+36>>2]&255](l,f,h)|0)>>>0<h>>>0)break b;g=j-h|0;f=f+h|0;d=k[b>>2]|0}else g=j;while(0);upb(d|0,f|0,g|0)|0;k[b>>2]=(k[b>>2]|0)+g}while(0);Qfb(l)|0;l=k[e>>2]|0;Hh[k[(k[l>>2]|0)+12>>2]&511](l,D)|0}l=k[e>>2]|0;if(!(Xh[k[(k[l>>2]|0)+24>>2]&1023](l)|0)){if(!(k[t>>2]|0))break;h=k[D>>2]|0;h=(h|0)==0?1016759:h;k[n>>2]=h;g=_d(10,n|0)|0;if(g>>>0>4294963200){d=k[206783]|0;if(!d)f=827176;else{f=(Fpb()|0)+64|0;f=k[f>>2]|0}k[f>>2]=0-g}else{if(!g)break;d=k[206783]|0}if(!d)d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}if((k[d>>2]|0)!=21)break;k[p>>2]=h;f=_e(40,p|0)|0;if(f>>>0<=4294963200)break;if(!(k[206783]|0))d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}k[d>>2]=0-f;break}d=k[e>>2]|0;f=k[d+4>>2]|0;g=k[d+8>>2]|0;d=Xh[k[(k[d>>2]|0)+8>>2]&1023](d)|0;do if(!(c&8)){p=d&4088;d=(c&2|0)==0?p:d;if((c&1|0)==0?(c&4|0)==0|(p|0)==0:0){d=d&7;break}d=d&7|16}while(0);d=d&4095;if(!(((((k[u>>2]|0)<3?(k[m>>2]|0)==(g|0):0)?(k[a+12>>2]|0)==(f|0):0)?(k[a>>2]&4095|0)==(d|0):0)?(k[a+16>>2]|0)!=0:0)){k[o>>2]=g;k[o+4>>2]=f;G1(a,2,o,d)}b=k[e>>2]|0;b=Hh[k[(k[b>>2]|0)+28>>2]&511](b,a)|0;do if(k[t>>2]|0){h=k[D>>2]|0;h=(h|0)==0?1016759:h;k[q>>2]=h;g=_d(10,q|0)|0;if(g>>>0>4294963200){d=k[206783]|0;if(!d)f=827176;else{f=(Fpb()|0)+64|0;f=k[f>>2]|0}k[f>>2]=0-g}else{if(!g)break;d=k[206783]|0}if(!d)d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}if((k[d>>2]|0)==21){k[v>>2]=h;f=_e(40,v|0)|0;if(f>>>0<=4294963200)break;if(!(k[206783]|0))d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}k[d>>2]=0-f}}while(0);if(!b?(B9(w),(a|0)!=0):0){g=a+36|0;d=k[g>>2]|0;do if(d|0){v=d+12|0;w=k[v>>2]|0;k[v>>2]=w+-1;if((w|0)!=1)break;f=k[g>>2]|0;if(f|0){d=k[f+4>>2]|0;do if(!d){d=k[a+32>>2]|0;if(d|0)break;d=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,f)}k[g>>2]=0}while(0);k[g>>2]=0;a=a+16|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[u>>2]|0)>0){f=k[s>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[u>>2]|0))}}}}else C=21;while(0);if((C|0)==21){k[B>>2]=0;e=B+4|0;k[e>>2]=0}d=k[B>>2]|0;if(d|0?(B=d+4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);k[e>>2]=0;d=k[D>>2]|0;k[t>>2]=0;k[D>>2]=0;if(d|0?(C=d+-4|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0)ggb(k[d+-8>>2]|0);f=E+36|0;d=k[f>>2]|0;if(d|0?(C=d+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[E+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;E=E+16|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[A>>2]|0)>0){e=k[y>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[A>>2]|0))}d=k[x>>2]|0;if(!((d|0)==(z|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=G+36|0;d=k[f>>2]|0;if(d|0?(D=d+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[G+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;f=G+4|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[f>>2]|0)>0){e=k[G+40>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[f>>2]|0))}d=k[G+44>>2]|0;if((d|0)==(G+48|0)|(d|0)==0){r=H;return}ggb(k[d+-4>>2]|0);r=H;return}function kl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+160|0;w=C+8|0;u=C;B=C+96|0;z=C+88|0;y=C+32|0;q=C+16|0;f=a+11|0;g=i[f>>0]|0;e=g<<24>>24<0;if(!((e?k[a+4>>2]|0:g&255)|0)){A=0;m=0}else{m=e?k[a+4>>2]|0:g&255;A=ZT(m+8&-4)|0;k[A>>2]=1;A=A+4|0;i[A+m>>0]=0;upb(A|0,((i[f>>0]|0)<0?k[a>>2]|0:a)|0,m|0)|0}k[B>>2]=k[b>>2];l=B+4|0;e=b+4|0;a=k[e>>2]|0;k[l>>2]=a;h=B+8|0;k[h>>2]=k[b+8>>2];k[B+12>>2]=k[b+12>>2];k[B+16>>2]=k[b+16>>2];k[B+20>>2]=k[b+20>>2];k[B+24>>2]=k[b+24>>2];k[B+28>>2]=k[b+28>>2];k[B+32>>2]=k[b+32>>2];f=k[b+36>>2]|0;k[B+36>>2]=f;g=B+40|0;k[g>>2]=h;h=B+48|0;j=B+44|0;k[j>>2]=h;k[B+52>>2]=0;k[h>>2]=0;if(f){a=f+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[e>>2]|0}if((a|0)>=3){k[l>>2]=0;x1(B,a,0,0,0);if((k[l>>2]|0)>0){h=k[b+40>>2]|0;g=k[g>>2]|0;f=k[b+44>>2]|0;e=k[j>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[h+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[l>>2]|0))}}else{l=k[b+44>>2]|0;b=k[j>>2]|0;k[b>>2]=k[l>>2];k[b+4>>2]=k[l+4>>2]}switch((k[B>>2]|0)>>>3&511){case 0:case 2:case 3:break;default:{k[z>>2]=0;a=z+4|0;k[a>>2]=0;e=ZT(52)|0;k[e>>2]=1;g=e+4|0;k[z>>2]=g;k[a>>2]=47;i[e+51>>0]=0;f=357837;h=g+47|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,z,357885,357634,594);k[a>>2]=0;k[z>>2]=0;b=k[e>>2]|0;k[e>>2]=b+-1;if((b|0)==1)ggb(k[e+-4>>2]|0)}}Kva(z,A,m);b=z+4|0;a=k[b>>2]|0;if(!a){k[y>>2]=0;a=y+4|0;k[a>>2]=0;e=ZT(56)|0;k[e>>2]=1;g=e+4|0;k[y>>2]=g;k[a>>2]=50;i[e+54>>0]=0;f=357894;h=g+50|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-2,y,357885,357634,598);k[a>>2]=0;k[y>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0);a=k[b>>2]|0}if(!(Hh[k[(k[a>>2]|0)+8>>2]&511](a,k[B>>2]&7)|0)){m=k[b>>2]|0;if(!(Hh[k[(k[m>>2]|0)+8>>2]&511](m,0)|0)){k[y>>2]=0;a=y+4|0;k[a>>2]=0;e=ZT(40)|0;k[e>>2]=1;g=e+4|0;k[y>>2]=g;k[a>>2]=33;i[e+37>>0]=0;f=357758;h=g+33|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,y,357885,357634,602);k[a>>2]=0;k[y>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}k[y>>2]=1124007936;l=y+4|0;a=y+8|0;j=y+40|0;g=l;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[j>>2]=a;h=y+48|0;g=y+44|0;k[g>>2]=h;k[y+52>>2]=0;k[h>>2]=0;f=q+4|0;a=f+4|0;k[a>>2]=0;k[a+4>>2]=0;k[q>>2]=33619968;k[f>>2]=y;SW(B,q,0,1.0,0.0);KG(B,y)|0;f=y+36|0;a=k[f>>2]|0;if(a|0?(e=a+12|0,m=k[e>>2]|0,k[e>>2]=m+-1,(m|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;m=y+16|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[l>>2]|0)>0){e=k[j>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[g>>2]|0;if(!((a|0)==(h|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}m=k[b>>2]|0;if(Hh[k[(k[m>>2]|0)+16>>2]&511](m,c)|0){x=k[b>>2]|0;x=ci[k[(k[x>>2]|0)+20>>2]&255](x,B,d)|0;w=k[b>>2]|0;Uh[k[(k[w>>2]|0)+32>>2]&2047](w);if(x)g=1;else{k[y>>2]=0;x=y+4|0;k[x>>2]=0;a=ZT(12)|0;k[a>>2]=1;w=a+4|0;k[y>>2]=w;k[x>>2]=4;i[a+8>>0]=0;i[w>>0]=99;i[w+1>>0]=111;i[w+2>>0]=100;i[w+3>>0]=101;Y8(-215,y,357885,357634,613);k[x>>2]=0;k[y>>2]=0;y=k[a>>2]|0;k[a>>2]=y+-1;if((y|0)==1)ggb(k[a+-4>>2]|0);g=0}}else{k9(y);m=k[b>>2]|0;if(!(Hh[k[(k[m>>2]|0)+12>>2]&511](m,y)|0)?(k[q>>2]=0,m=q+4|0,k[m>>2]=0,n=ZT(12)|0,k[n>>2]=1,l=n+4|0,k[q>>2]=l,k[m>>2]=4,i[n+8>>0]=0,i[l>>0]=99,i[l+1>>0]=111,i[l+2>>0]=100,i[l+3>>0]=101,Y8(-215,q,357885,357634,619),k[m>>2]=0,k[q>>2]=0,m=k[n>>2]|0,k[n>>2]=m+-1,(m|0)==1):0)ggb(k[n+-4>>2]|0);m=k[b>>2]|0;m=ci[k[(k[m>>2]|0)+20>>2]&255](m,B,d)|0;d=k[b>>2]|0;Uh[k[(k[d>>2]|0)+32>>2]&2047](d);if(!m?(k[q>>2]=0,d=q+4|0,k[d>>2]=0,o=ZT(12)|0,k[o>>2]=1,n=o+4|0,k[q>>2]=n,k[d>>2]=4,i[o+8>>0]=0,i[n>>0]=99,i[n+1>>0]=111,i[n+2>>0]=100,i[n+3>>0]=101,Y8(-215,q,357885,357634,623),k[d>>2]=0,k[q>>2]=0,d=k[o>>2]|0,k[o>>2]=d+-1,(d|0)==1):0)ggb(k[o+-4>>2]|0);l=k[y>>2]|0;l=Ufb((l|0)==0?1016759:l,373005)|0;if((l|0)==0?(k[q>>2]=0,o=q+4|0,k[o>>2]=0,p=ZT(12)|0,k[p>>2]=1,d=p+4|0,k[q>>2]=d,k[o>>2]=6,i[p+10>>0]=0,i[d>>0]=i[357945]|0,i[d+1>>0]=i[357946]|0,i[d+2>>0]=i[357947]|0,i[d+3>>0]=i[357948]|0,i[d+4>>0]=i[357949]|0,i[d+5>>0]=i[357950]|0,Y8(-215,q,357885,357634,626),k[o>>2]=0,k[q>>2]=0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[p+-4>>2]|0);j=l+76|0;a=l+20|0;e=l+28|0;f=(k[a>>2]|0)>>>0>(k[e>>2]|0)>>>0;do if((k[j>>2]|0)>-1){if(f?(ci[k[l+36>>2]&255](l,0,0)|0,(k[a>>2]|0)==0):0)break;k[l+16>>2]=0;k[e>>2]=0;k[a>>2]=0;if((ci[k[l+40>>2]&255](l,0,2)|0)>=0){k[l+8>>2]=0;k[l+4>>2]=0;k[l>>2]=k[l>>2]&-17}}else{if(f?(ci[k[l+36>>2]&255](l,0,0)|0,(k[a>>2]|0)==0):0)break;k[l+16>>2]=0;k[e>>2]=0;k[a>>2]=0;if((ci[k[l+40>>2]&255](l,0,2)|0)>=0){k[l+8>>2]=0;k[l+4>>2]=0;k[l>>2]=k[l>>2]&-17}}while(0);e=k[l+40>>2]|0;a=(k[l>>2]&128|0)==0;if((k[j>>2]|0)>-1){if(a)a=1;else a=(k[l+20>>2]|0)>>>0>(k[l+28>>2]|0)>>>0?2:1;a=ci[e&255](l,0,a)|0;if((a|0)>=0)a=a-(k[l+8>>2]|0)+(k[l+4>>2]|0)+(k[l+20>>2]|0)-(k[l+28>>2]|0)|0}else{if(a)a=1;else a=(k[l+20>>2]|0)>>>0>(k[l+28>>2]|0)>>>0?2:1;a=ci[e&255](l,0,a)|0;if((a|0)>=0)a=a-(k[l+8>>2]|0)+(k[l+4>>2]|0)+(k[l+20>>2]|0)-(k[l+28>>2]|0)|0}h=c+4|0;g=k[h>>2]|0;f=k[c>>2]|0;e=g-f|0;if(a>>>0<=e>>>0){if(a>>>0<e>>>0?(s=f+a|0,(g|0)!=(s|0)):0)k[h>>2]=s}else T1(c,a-e|0);a=l+20|0;e=l+28|0;f=(k[a>>2]|0)>>>0>(k[e>>2]|0)>>>0;do if((k[j>>2]|0)>-1){if(f?(ci[k[l+36>>2]&255](l,0,0)|0,(k[a>>2]|0)==0):0)break;k[l+16>>2]=0;k[e>>2]=0;k[a>>2]=0;if((ci[k[l+40>>2]&255](l,0,0)|0)>=0){k[l+8>>2]=0;k[l+4>>2]=0;k[l>>2]=k[l>>2]&-17}}else{if(f?(ci[k[l+36>>2]&255](l,0,0)|0,(k[a>>2]|0)==0):0)break;k[l+16>>2]=0;k[e>>2]=0;k[a>>2]=0;if((ci[k[l+40>>2]&255](l,0,0)|0)>=0){k[l+8>>2]=0;k[l+4>>2]=0;k[l>>2]=k[l>>2]&-17}}while(0);a=k[c>>2]|0;a=_fb(a,1,(k[h>>2]|0)-a|0,l)|0;g=k[h>>2]|0;f=k[c>>2]|0;e=g-f|0;if(a>>>0<=e>>>0){if(a>>>0<e>>>0?(t=f+a|0,(g|0)!=(t|0)):0)k[h>>2]=t}else T1(c,a-e|0);Qfb(l)|0;g=k[y>>2]|0;g=(g|0)==0?1016759:g;k[u>>2]=g;f=_d(10,u|0)|0;if(f>>>0<=4294963200){if(f|0){a=k[206783]|0;v=97}}else{a=k[206783]|0;if(!a)e=827176;else{e=(Fpb()|0)+64|0;e=k[e>>2]|0}k[e>>2]=0-f;v=97}if((v|0)==97){if(!a)a=827176;else{a=(Fpb()|0)+64|0;a=k[a>>2]|0}if((k[a>>2]|0)==21?(k[w>>2]=g,x=_e(40,w|0)|0,x>>>0>4294963200):0){if(!(k[206783]|0))a=827176;else{a=(Fpb()|0)+64|0;a=k[a>>2]|0}k[a>>2]=0-x}}a=k[y>>2]|0;k[y+4>>2]=0;k[y>>2]=0;if(a|0?(x=a+-4|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0)ggb(k[a+-8>>2]|0);g=m}a=k[z>>2]|0;if(a|0?(y=a+4|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);f=B+36|0;a=k[f>>2]|0;if(a|0?(y=a+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[B+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;z=B+16|0;e=B+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[e>>2]|0)>0){f=k[B+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[B+44>>2]|0;if(!((a|0)==(B+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);if(!A){r=C;return g|0}z=A+-4|0;B=k[z>>2]|0;k[z>>2]=B+-1;if((B|0)!=1){r=C;return g|0}ggb(k[A+-8>>2]|0);r=C;return g|0}function ll(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;B=r;r=r+128|0;h=B+104|0;j=B+96|0;y=B+40|0;l=B+32|0;m=B+8|0;n=B;A=B+24|0;k[A>>2]=0;z=A+4|0;k[z>>2]=0;d=b+11|0;e=i[d>>0]|0;f=e<<24>>24<0;if((f?k[b+4>>2]|0:e&255)|0){x=f?k[b+4>>2]|0:e&255;w=ZT(x+8&-4)|0;k[w>>2]=1;w=w+4|0;k[A>>2]=w;k[z>>2]=x;i[w+x>>0]=0;upb(k[A>>2]|0,((i[d>>0]|0)<0?k[b>>2]|0:b)|0,x|0)|0}k[a>>2]=1124007936;t=a+4|0;g=a+8|0;s=a+40|0;d=t;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[s>>2]=g;x=a+48|0;k[a+44>>2]=x;k[a+52>>2]=0;k[x>>2]=0;k[j>>2]=0;k[y>>2]=1124007936;x=y+4|0;b=y+8|0;v=y+40|0;d=x;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[v>>2]=b;w=y+48|0;u=y+44|0;k[u>>2]=w;k[y+52>>2]=0;k[w>>2]=0;Jva(h,A);o=k[h>>2]|0;f=k[h+4>>2]|0;p=(o|0)==0;q=o;if(p){b=h;d=q}else{b=q+4|0;k[b>>2]=(k[b>>2]|0)+1;b=h;d=k[h>>2]|0}if(d|0?(C=d+4|0,e=k[C>>2]|0,k[C>>2]=e+-1,(e|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);k[b>>2]=0;if(f|0){k[l>>2]=1;do if((c|0)>8){if(c&16|0){k[l>>2]=2;break}if(c&32|0){k[l>>2]=4;break}if(c&64|0)k[l>>2]=8}while(0);Hh[k[(k[f>>2]|0)+20>>2]&511](f,l)|0;Hh[k[(k[f>>2]|0)+12>>2]&511](f,A)|0;do if(Xh[k[(k[f>>2]|0)+24>>2]&1023](f)|0){d=k[f+4>>2]|0;e=k[f+8>>2]|0;b=Xh[k[(k[f>>2]|0)+8>>2]&1023](f)|0;do if(!(c&8)){C=b&4088;b=(c&2|0)==0?C:b;if((c&1|0)==0?(c&4|0)==0|(C|0)==0:0){b=b&7;break}b=b&7|16}while(0);b=b&4095;if(!(((((k[t>>2]|0)<3?(k[g>>2]|0)==(e|0):0)?(k[a+12>>2]|0)==(d|0):0)?(k[a>>2]&4095|0)==(b|0):0)?(k[a+16>>2]|0)!=0:0)){k[h>>2]=e;k[h+4>>2]=d;G1(a,2,h,b)}if(Hh[k[(k[f>>2]|0)+28>>2]&511](f,a)|0){if((Hh[k[(k[f>>2]|0)+20>>2]&511](f,l)|0)<=1)break;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=a;C=m+4|0;t=C+4|0;k[t>>2]=0;k[t+4>>2]=0;k[m>>2]=33619968;k[C>>2]=a;C=k[l>>2]|0;k[n>>2]=(d|0)/(C|0)|0;k[n+4>>2]=(e|0)/(C|0)|0;Rla(h,m,n,0.0,0.0,1);break}B9(j);e=a+36|0;b=k[e>>2]|0;if(b|0?(n=b+12|0,C=k[n>>2]|0,k[n>>2]=C+-1,(C|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[a+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;C=a+16|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[t>>2]|0)>0){d=k[s>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}}while(0)}if(!p?(a=q+4|0,C=k[a>>2]|0,k[a>>2]=C+-1,(C|0)==1):0)Uh[k[(k[o>>2]|0)+8>>2]&2047](q);e=y+36|0;b=k[e>>2]|0;if(b|0?(a=b+12|0,C=k[a>>2]|0,k[a>>2]=C+-1,(C|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[y+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;C=y+16|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[x>>2]|0)>0){d=k[v>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[x>>2]|0))}b=k[u>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[A>>2]|0;k[z>>2]=0;k[A>>2]=0;if(!b){r=B;return}A=b+-4|0;C=k[A>>2]|0;k[A>>2]=C+-1;if((C|0)!=1){r=B;return}ggb(k[b+-8>>2]|0);r=B;return}function ml(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=r;r=r+80|0;L=P+64|0;M=P;N=P+56|0;k[N>>2]=0;O=N+4|0;k[O>>2]=0;d=a+11|0;e=i[d>>0]|0;f=e<<24>>24<0;if((f?k[a+4>>2]|0:e&255)|0){K=f?k[a+4>>2]|0:e&255;J=ZT(K+8&-4)|0;k[J>>2]=1;J=J+4|0;k[N>>2]=J;k[O>>2]=K;i[J+K>>0]=0;upb(k[N>>2]|0,((i[d>>0]|0)<0?k[a>>2]|0:a)|0,K|0)|0}Jva(L,N);I=k[L>>2]|0;H=k[L+4>>2]|0;J=(I|0)==0;K=I;if(J){a=L;d=K}else{a=K+4|0;k[a>>2]=(k[a>>2]|0)+1;a=L;d=k[L>>2]|0}if(d|0?(F=d+4|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);k[a>>2]=0;if((H|0)!=0?(Hh[k[(k[H>>2]|0)+12>>2]&511](H,N)|0,Xh[k[(k[H>>2]|0)+24>>2]&1023](H)|0):0){E=(c&8|0)==0;F=(c&2|0)==0;G=(c&1|0)==0;j=(c&4|0)==0;l=H+8|0;m=H+4|0;n=M+4|0;o=M+8|0;p=M+40|0;q=M+48|0;s=M+44|0;t=M+52|0;u=L+4|0;v=b+4|0;w=b+8|0;x=M+12|0;y=M+16|0;z=M+20|0;A=M+24|0;B=M+28|0;C=M+32|0;D=M+36|0;do{a=Xh[k[(k[H>>2]|0)+8>>2]&1023](H)|0;d=F?0:a&7;if(E)a=G&(j|(a&4088|0)==0)?d:d|16;d=k[l>>2]|0;e=k[m>>2]|0;k[M>>2]=1124007936;f=n;c=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(c|0));k[p>>2]=o;k[s>>2]=q;k[t>>2]=0;k[q>>2]=0;k[L>>2]=d;k[u>>2]=e;G1(M,2,L,a&4095);if(Hh[k[(k[H>>2]|0)+28>>2]&511](H,M)|0){d=k[v>>2]|0;if((d|0)==(k[w>>2]|0))Doa(b,M);else{k[d>>2]=k[M>>2];h=d+4|0;k[h>>2]=k[n>>2];g=d+8|0;k[g>>2]=k[o>>2];k[d+12>>2]=k[x>>2];k[d+16>>2]=k[y>>2];k[d+20>>2]=k[z>>2];k[d+24>>2]=k[A>>2];k[d+28>>2]=k[B>>2];k[d+32>>2]=k[C>>2];a=k[D>>2]|0;k[d+36>>2]=a;e=d+40|0;k[e>>2]=g;g=d+48|0;c=d+44|0;k[c>>2]=g;k[d+52>>2]=0;k[g>>2]=0;if(a|0){g=a+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[n>>2]|0)>=3){k[h>>2]=0;x1(d,k[n>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[p>>2]|0;e=k[e>>2]|0;f=k[s>>2]|0;d=k[c>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[g+(a<<2)>>2];k[d+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0))}}else{g=k[s>>2]|0;h=k[c>>2]|0;k[h>>2]=k[g>>2];k[h+4>>2]=k[g+4>>2]}k[v>>2]=(k[v>>2]|0)+56}e=Xh[k[(k[H>>2]|0)+32>>2]&1023](H)|0;e=e?0:2}else e=2;a=k[D>>2]|0;if(a|0?(g=a+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){d=k[D>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[C>>2]|0;if(!a){a=B1()|0;d=k[D>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[D>>2]=0}k[D>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[n>>2]|0)>0){d=k[p>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[s>>2]|0;if(!((a|0)==(q|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}while(!(e|0));d=(k[b>>2]|0)!=(k[v>>2]|0)}else d=0;if(!J?(L=K+4|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0)Uh[k[(k[I>>2]|0)+8>>2]&2047](K);a=k[N>>2]|0;k[O>>2]=0;k[N>>2]=0;if(!a){r=P;return d|0}N=a+-4|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1){r=P;return d|0}ggb(k[a+-8>>2]|0);r=P;return d|0}function nl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+144|0;p=u+88|0;o=u+80|0;n=u+64|0;q=u;s=u+56|0;k[s>>2]=0;t=s+4|0;k[t>>2]=0;f=a+11|0;d=i[f>>0]|0;e=d<<24>>24<0;if((e?k[a+4>>2]|0:d&255)|0){m=e?k[a+4>>2]|0:d&255;l=ZT(m+8&-4)|0;k[l>>2]=1;l=l+4|0;k[s>>2]=l;k[t>>2]=m;i[l+m>>0]=0;upb(k[s>>2]|0,((i[f>>0]|0)<0?k[a>>2]|0:a)|0,m|0)|0}k[q>>2]=k[b>>2];j=q+4|0;d=b+4|0;a=k[d>>2]|0;k[j>>2]=a;m=q+8|0;k[m>>2]=k[b+8>>2];k[q+12>>2]=k[b+12>>2];k[q+16>>2]=k[b+16>>2];k[q+20>>2]=k[b+20>>2];k[q+24>>2]=k[b+24>>2];k[q+28>>2]=k[b+28>>2];k[q+32>>2]=k[b+32>>2];e=k[b+36>>2]|0;k[q+36>>2]=e;f=q+40|0;k[f>>2]=m;m=q+48|0;h=q+44|0;k[h>>2]=m;k[q+52>>2]=0;k[m>>2]=0;if(e){a=e+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[d>>2]|0}if((a|0)>=3){k[j>>2]=0;x1(q,a,0,0,0);if((k[j>>2]|0)>0){g=k[b+40>>2]|0;f=k[f>>2]|0;e=k[b+44>>2]|0;d=k[h>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[g+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else{l=k[b+44>>2]|0;m=k[h>>2]|0;k[m>>2]=k[l>>2];k[m+4>>2]=k[l+4>>2]}k[p>>2]=1124007936;l=p+4|0;a=p+8|0;j=p+40|0;g=l;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[j>>2]=a;m=p+48|0;b=p+44|0;k[b>>2]=m;k[p+52>>2]=0;k[m>>2]=0;switch((k[q>>2]|0)>>>3&511){case 3:case 2:case 0:break;default:{k[o>>2]=0;a=o+4|0;k[a>>2]=0;d=ZT(76)|0;k[d>>2]=1;g=d+4|0;k[o>>2]=g;k[a>>2]=71;i[d+75>>0]=0;e=357553;h=g+71|0;do{i[g>>0]=i[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(h|0));Y8(-215,o,357625,357634,455);k[a>>2]=0;k[o>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}}Kva(o,k[s>>2]|0,k[t>>2]|0);f=o+4|0;a=k[f>>2]|0;if(!a){k[n>>2]=0;a=n+4|0;k[a>>2]=0;d=ZT(56)|0;k[d>>2]=1;g=d+4|0;k[n>>2]=g;k[a>>2]=51;i[d+55>>0]=0;e=357706;h=g+51|0;do{i[g>>0]=i[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(h|0));Y8(-2,n,357625,357634,459);k[a>>2]=0;k[n>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);a=k[f>>2]|0}if(Hh[k[(k[a>>2]|0)+8>>2]&511](a,k[q>>2]&7)|0)a=q;else{h=k[f>>2]|0;if(!(Hh[k[(k[h>>2]|0)+8>>2]&511](h,0)|0)){k[n>>2]=0;a=n+4|0;k[a>>2]=0;d=ZT(40)|0;k[d>>2]=1;g=d+4|0;k[n>>2]=g;k[a>>2]=33;i[d+37>>0]=0;e=357758;h=g+33|0;do{i[g>>0]=i[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(h|0));Y8(-215,n,357625,357634,462);k[a>>2]=0;k[n>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}a=n+4|0;h=a+4|0;k[h>>2]=0;k[h+4>>2]=0;k[n>>2]=33619968;k[a>>2]=p;SW(q,n,0,1.0,0.0);a=p}n=k[f>>2]|0;Hh[k[(k[n>>2]|0)+12>>2]&511](n,s)|0;f=k[f>>2]|0;f=ci[k[(k[f>>2]|0)+20>>2]&255](f,a,c)|0;a=k[o>>2]|0;if(a|0?(c=a+4|0,o=k[c>>2]|0,k[c>>2]=o+-1,(o|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);e=p+36|0;a=k[e>>2]|0;if(a|0?(c=a+12|0,o=k[c>>2]|0,k[c>>2]=o+-1,(o|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[p+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;p=p+16|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[l>>2]|0)>0){d=k[j>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[b>>2]|0;if(!((a|0)==(m|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=q+36|0;a=k[e>>2]|0;if(a|0?(o=a+12|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[q+44>>2]|0;if(!((a|0)==(q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[s>>2]|0;k[t>>2]=0;k[s>>2]=0;if(!a){r=u;return f|0}s=a+-4|0;t=k[s>>2]|0;k[s>>2]=t+-1;if((t|0)!=1){r=u;return f|0}ggb(k[a+-8>>2]|0);r=u;return f|0}function ol(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1536|0;Q=$+1472|0;_=$+1416|0;Z=$+1360|0;Y=$+1304|0;X=$+1248|0;H=$+1236|0;G=$+1216|0;T=$+1200|0;U=$+1168|0;W=$+128|0;J=$+104|0;K=$+80|0;P=$+8|0;V=$;l=$+112|0;o=$+88|0;F=$+64|0;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;m=l+4|0;k[m>>2]=b;k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;n=o+4|0;k[n>>2]=c;E=F+4|0;j=F+4+4|0;k[j>>2]=0;k[j+4>>2]=0;k[F>>2]=33619968;k[E>>2]=d;k[_>>2]=k[a>>2];j=_+4|0;c=a+4|0;b=k[c>>2]|0;k[j>>2]=b;S=_+8|0;k[S>>2]=k[a+8>>2];k[_+12>>2]=k[a+12>>2];k[_+16>>2]=k[a+16>>2];k[_+20>>2]=k[a+20>>2];k[_+24>>2]=k[a+24>>2];k[_+28>>2]=k[a+28>>2];k[_+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[_+36>>2]=d;e=_+40|0;k[e>>2]=S;S=_+48|0;h=_+44|0;k[h>>2]=S;k[_+52>>2]=0;k[S>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[j>>2]=0;x1(_,b,0,0,0);if((k[j>>2]|0)>0){f=k[a+40>>2]|0;e=k[e>>2]|0;d=k[a+44>>2]|0;c=k[h>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else{R=k[a+44>>2]|0;S=k[h>>2]|0;k[S>>2]=k[R>>2];k[S+4>>2]=k[R+4>>2]}do if((k[l>>2]&2031616|0)==65536){f=k[m>>2]|0;k[Z>>2]=k[f>>2];j=Z+4|0;b=f+4|0;k[j>>2]=k[b>>2];S=Z+8|0;k[S>>2]=k[f+8>>2];k[Z+12>>2]=k[f+12>>2];k[Z+16>>2]=k[f+16>>2];k[Z+20>>2]=k[f+20>>2];k[Z+24>>2]=k[f+24>>2];k[Z+28>>2]=k[f+28>>2];k[Z+32>>2]=k[f+32>>2];c=k[f+36>>2]|0;k[Z+36>>2]=c;d=Z+40|0;k[d>>2]=S;S=Z+48|0;h=Z+44|0;k[h>>2]=S;k[Z+52>>2]=0;k[S>>2]=0;if(c|0){S=c+12|0;k[S>>2]=(k[S>>2]|0)+1}if((k[b>>2]|0)<3){R=k[f+44>>2]|0;S=k[h>>2]|0;k[S>>2]=k[R>>2];k[S+4>>2]=k[R+4>>2];break}k[j>>2]=0;x1(Z,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){a=k[f+40>>2]|0;e=k[d>>2]|0;d=k[f+44>>2]|0;c=k[h>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else Q1(Z,l,-1);while(0);do if((k[o>>2]&2031616|0)==65536){e=k[n>>2]|0;k[Y>>2]=k[e>>2];j=Y+4|0;b=e+4|0;k[j>>2]=k[b>>2];S=Y+8|0;k[S>>2]=k[e+8>>2];k[Y+12>>2]=k[e+12>>2];k[Y+16>>2]=k[e+16>>2];k[Y+20>>2]=k[e+20>>2];k[Y+24>>2]=k[e+24>>2];k[Y+28>>2]=k[e+28>>2];k[Y+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[Y+36>>2]=c;d=Y+40|0;k[d>>2]=S;S=Y+48|0;h=Y+44|0;k[h>>2]=S;k[Y+52>>2]=0;k[S>>2]=0;if(c|0){S=c+12|0;k[S>>2]=(k[S>>2]|0)+1}if((k[b>>2]|0)<3){R=k[e+44>>2]|0;S=k[h>>2]|0;k[S>>2]=k[R>>2];k[S+4>>2]=k[R+4>>2];break}k[j>>2]=0;x1(Y,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){a=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[h>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else Q1(Y,o,-1);while(0);c=k[_+40>>2]|0;d=k[c+-4>>2]|0;e=k[Z+40>>2]|0;a:do if((d|0)==(k[e+-4>>2]|0)){if((d|0)==2){if((k[c>>2]|0)!=(k[e>>2]|0)){D=34;break}if((k[c+4>>2]|0)!=(k[e+4>>2]|0)){D=34;break}}else if((d|0)>0){b=0;do{if((k[c+(b<<2)>>2]|0)!=(k[e+(b<<2)>>2]|0)){D=34;break a}b=b+1|0}while((b|0)<(d|0))}if(!((k[Z>>2]^k[_>>2])&4095))O=0;else D=34}else D=34;while(0);do if((D|0)==34){b=k[_>>2]|0;if(((k[Z+4>>2]|0)<=2?(q=k[Z>>2]|0,q&16384|0):0)?(t=k[Z+40>>2]|0,s=k[t+4>>2]|0,t=k[t>>2]|0,v=(s|0)==1,w=(t|0)==1,v|w):0){b=(b>>>3&511)+1|0;if((s|0)==(b|0)&w|v&(w|(t|0)==(b|0))){O=1;break}if(v&(t|0)==4?b>>>0<5&(q&4095|0)==6:0){O=1;break}}k[Q>>2]=0;b=Q+4|0;k[b>>2]=0;c=ZT(96)|0;k[c>>2]=1;v=c+4|0;k[Q>>2]=v;k[b>>2]=89;i[c+93>>0]=0;w=209662;x=v+89|0;do{i[v>>0]=i[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));Y8(-209,Q,209752,208690,1906);k[b>>2]=0;k[Q>>2]=0;S=k[c>>2]|0;k[c>>2]=S+-1;if((S|0)==1)ggb(k[c+-4>>2]|0);O=1}while(0);c=k[_+40>>2]|0;d=k[c+-4>>2]|0;e=k[Y+40>>2]|0;b:do if((d|0)==(k[e+-4>>2]|0)){if((d|0)==2){if((k[c>>2]|0)!=(k[e>>2]|0)){D=51;break}if((k[c+4>>2]|0)!=(k[e+4>>2]|0)){D=51;break}}else if((d|0)>0){b=0;do{if((k[c+(b<<2)>>2]|0)!=(k[e+(b<<2)>>2]|0)){D=51;break b}b=b+1|0}while((b|0)<(d|0))}if(!((k[Y>>2]^k[_>>2])&4095)){b=O&1;if(O){e=0;f=0;D=62}else{e=0;z=_;f=0}}else D=51}else D=51;while(0);if((D|0)==51){b=k[_>>2]|0;if(((k[Y+4>>2]|0)<=2?(y=k[Y>>2]|0,(y&16384|0)!=0):0)?(A=k[Y+40>>2]|0,z=k[A+4>>2]|0,A=k[A>>2]|0,B=(z|0)==1,C=(A|0)==1,B|C):0){b=(b>>>3&511)+1|0;if(!((z|0)==(b|0)&C|B&(C|(A|0)==(b|0))))if(!(B&(A|0)==4?b>>>0<5&(y&4095|0)==6:0))D=57}else D=57;if((D|0)==57){k[Q>>2]=0;b=Q+4|0;k[b>>2]=0;c=ZT(96)|0;k[c>>2]=1;v=c+4|0;k[Q>>2]=v;k[b>>2]=89;i[c+93>>0]=0;w=209760;x=v+89|0;do{i[v>>0]=i[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));Y8(-209,Q,209752,208690,1915);k[b>>2]=0;k[Q>>2]=0;S=k[c>>2]|0;k[c>>2]=S+-1;if((S|0)==1)ggb(k[c+-4>>2]|0)}b=O&1;if(O){e=1;z=_;f=1}else{e=1;f=1;D=62}}if((D|0)==62){k[Q>>2]=0;c=Q+4|0;k[c>>2]=0;d=ZT(28)|0;k[d>>2]=1;v=d+4|0;k[Q>>2]=v;k[c>>2]=20;i[d+24>>0]=0;w=209850;x=v+20|0;do{i[v>>0]=i[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));Y8(-215,Q,209752,208690,1919);k[c>>2]=0;k[Q>>2]=0;S=k[d>>2]|0;k[d>>2]=S+-1;if((S|0)==1)ggb(k[d+-4>>2]|0);z=_}q=k[z>>2]|0;B=q>>>3;L=B&511;M=L+1|0;q=q&7;S=_+4|0;c=k[S>>2]|0;if((c|0)>0)N=k[(k[_+44>>2]|0)+(c+-1<<2)>>2]|0;else N=0;o=((N+1023|0)>>>0)/(N>>>0)|0;R=_+40|0;P1(F,c,k[R>>2]|0,0,-1,0,0);do if((k[F>>2]&2031616|0)==65536){a=k[E>>2]|0;k[X>>2]=k[a>>2];n=X+4|0;c=a+4|0;k[n>>2]=k[c>>2];I=X+8|0;k[I>>2]=k[a+8>>2];k[X+12>>2]=k[a+12>>2];k[X+16>>2]=k[a+16>>2];k[X+20>>2]=k[a+20>>2];k[X+24>>2]=k[a+24>>2];k[X+28>>2]=k[a+28>>2];k[X+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[X+36>>2]=d;h=X+40|0;k[h>>2]=I;I=X+48|0;l=X+44|0;k[l>>2]=I;k[X+52>>2]=0;k[I>>2]=0;if(d|0){I=d+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[c>>2]|0)<3){F=k[a+44>>2]|0;I=k[l>>2]|0;k[I>>2]=k[F>>2];k[I+4>>2]=k[F+4>>2];break}k[n>>2]=0;x1(X,k[c>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[a+40>>2]|0;j=k[h>>2]|0;h=k[a+44>>2]|0;d=k[l>>2]|0;c=0;do{k[j+(c<<2)>>2]=k[m+(c<<2)>>2];k[d+(c<<2)>>2]=k[h+(c<<2)>>2];c=c+1|0}while((c|0)<(k[n>>2]|0))}}else Q1(X,F,-1);while(0);I=k[40192+(q<<2)>>2]|0;k[H>>2]=_;k[H+4>>2]=X;k[H+8>>2]=0;k[G>>2]=_;k[G+4>>2]=X;k[G+8>>2]=Z;k[G+12>>2]=Y;k[G+16>>2]=0;d=O&e;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;k[U+16>>2]=0;k[U+20>>2]=0;k[U+24>>2]=0;k[U+28>>2]=0;z1(U,d?H:G,0,T,-1);G=k[U+20>>2]|0;F=o>>>0<G>>>0?o:G;c=(M<<3)+128+(aa(F,(aa(N,b+f|0)|0)+M|0)|0)|0;D=W+8|0;k[W>>2]=D;E=W+4|0;k[E>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[W>>2]=b;C=b}else C=D;k[E>>2]=c;A=C+(aa(F,M)|0)+15&-16;if(d){d=aa(F,N)|0;s=A+d+15&-16;b=k[Z>>2]|0;if((k[Y>>2]^b)&4095){k[Q>>2]=0;b=Q+4|0;k[b>>2]=0;c=ZT(28)|0;k[c>>2]=1;v=c+4|0;k[Q>>2]=v;k[b>>2]=22;i[c+26>>0]=0;w=209871;x=v+22|0;do{i[v>>0]=i[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));Y8(-215,Q,209752,208690,1946);k[b>>2]=0;k[Q>>2]=0;H=k[c>>2]|0;k[c>>2]=H+-1;if((H|0)==1)ggb(k[c+-4>>2]|0);b=k[Z>>2]|0}b=b&7;if(q>>>0<4&(b|0)!=(q|0)){v=s+d+15&-16;w=v;j=v;y=j+(M<<2)|0;H=k[40448+(b<<2)>>2]|0;b=k[Z+16>>2]|0;k[J>>2]=M;k[J+4>>2]=1;sh[H&255](b,1,0,1,w,1,J,0);b=k[Y+16>>2]|0;k[K>>2]=M;k[K+4>>2]=1;sh[H&255](b,1,0,1,y,1,K,0);g=+p[10424+(q<<3)>>3];p[u>>3]=g;b=k[u+4>>2]|0;K=b&2146435072;if(!(K>>>0>1126170624|(K|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}a=~~g;g=+p[10488+(q<<3)>>3];p[u>>3]=g;b=k[u+4>>2]|0;K=b&2146435072;if(!(K>>>0>1126170624|(K|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}c=~~g;d=a+1|0;b=0;do{f=j+(b<<2)|0;J=k[f>>2]|0;h=y+(b<<2)|0;K=k[h>>2]|0;if((K|0)<(a|0)|((J|0)>(c|0)|(J|0)>(K|0))){k[f>>2]=d;k[h>>2]=a}b=b+1|0}while((b|0)!=(M|0));k[P>>2]=1124007940;o=P+4|0;k[o>>2]=2;a=P+8|0;k[a>>2]=M;d=P+12|0;k[d>>2]=1;m=P+16|0;k[m>>2]=w;h=P+20|0;k[h>>2]=w;j=P+24|0;l=P+28|0;n=P+40|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[n>>2]=a;t=P+48|0;q=P+44|0;k[q>>2]=t;k[P+52>>2]=0;k[t>>2]=0;if(!v){k[Q>>2]=0;b=Q+4|0;k[b>>2]=0;c=ZT(36)|0;k[c>>2]=1;v=c+4|0;k[Q>>2]=v;k[b>>2]=28;i[c+32>>0]=0;w=390609;x=v+28|0;do{i[v>>0]=i[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));Y8(-215,Q,390638,390642,410);k[b>>2]=0;k[Q>>2]=0;K=k[c>>2]|0;k[c>>2]=K+-1;if((K|0)==1)ggb(k[c+-4>>2]|0);c=k[d>>2]|0;d=k[P>>2]|0;f=k[q>>2]|0;b=k[h>>2]|0}else{c=1;d=1124007940;f=t;b=w}K=c<<2;k[P>>2]=d|16384;k[f>>2]=K;k[f+4>>2]=4;d=b+(aa(k[a>>2]|0,K)|0)|0;k[l>>2]=d;k[j>>2]=d+(0-K)+K;KG(Z,P)|0;d=P+36|0;b=k[d>>2]|0;if(b|0?(J=b+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[P+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[o>>2]|0)>0){c=k[n>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[o>>2]|0))}b=k[q>>2]|0;if(!((b|0)==(t|0)|(b|0)==0))ggb(k[b+-4>>2]|0);a=Q+4|0;k[a>>2]=2;l=Q+8|0;k[l>>2]=M;k[Q+12>>2]=1;f=Q+16|0;k[f>>2]=y;k[Q+20>>2]=y;d=Q+24|0;h=Q+40|0;j=d+8|0;k[j>>2]=0;k[j+4>>2]=0;k[h>>2]=l;l=Q+48|0;j=Q+44|0;k[j>>2]=l;k[Q>>2]=1124024324;k[l>>2]=4;k[Q+52>>2]=4;b=y+(M<<2)|0;k[Q+28>>2]=b;k[d>>2]=b+-4+4;KG(Y,Q)|0;d=Q+36|0;b=k[d>>2]|0;do if(b|0){K=b+12|0;P=k[K>>2]|0;k[K>>2]=P+-1;if((P|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Q+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[a>>2]|0)>0){c=k[h>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[j>>2]|0;if(!((b|0)==(l|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}_T(Z,k[z>>2]&4095,A,F);_T(Y,k[z>>2]&4095,s,F)}else{A=0;s=0}t=U+16|0;v=(G|0)==0;w=T+((O?2:3)<<2)|0;x=(L|0)==0;y=T+4|0;z=V+4|0;a=B+1&3;a=(a|0)==0?4:a;q=a&255;m=a>>>0>=M>>>0;n=T+8|0;l=0;while(1){if(l>>>0>=(k[t>>2]|0)>>>0)break;if(!v){j=0;do{h=G-j|0;h=h>>>0>F>>>0?F:h;o=aa(h,N)|0;if(O)c=A;else{c=k[n>>2]|0;k[n>>2]=c+o}if(e)b=s;else{b=k[w>>2]|0;k[w>>2]=b+o}P=k[T>>2]|0;Q=x?k[y>>2]|0:C;K=aa(h,M)|0;k[V>>2]=K;k[z>>2]=1;Gh[I&127](P,0,c,0,b,0,Q,0,V);c:do if(!x){f=k[y>>2]|0;switch(q&7){case 1:{if(!h)break c;else{b=0;c=0}while(1){i[f+b>>0]=i[C+c>>0]|0;b=b+1|0;if((b|0)==(h|0))break;else c=c+M|0}break}case 2:{if(!h)break c;else{b=0;c=0}while(1){i[f+c>>0]=i[C+(b+1)>>0]&i[C+b>>0];c=c+1|0;if((c|0)==(h|0))break;else b=b+M|0}break}case 3:{if(!h)break c;else{b=0;c=0}while(1){i[f+c>>0]=i[C+(b+1)>>0]&i[C+b>>0]&i[C+(b+2)>>0];c=c+1|0;if((c|0)==(h|0))break;else b=b+M|0}break}default:{if(!h)break c;else{b=0;c=0}while(1){i[f+b>>0]=i[C+(c+1)>>0]&i[C+c>>0]&i[C+(c+2)>>0]&i[C+(c+3)>>0];b=b+1|0;if((b|0)==(h|0))break;else c=c+M|0}}}if(!(m|(h|0)==0)){b=a;do{c=0;d=b;while(1){Q=f+c|0;i[Q>>0]=i[C+(d+1)>>0]&i[C+d>>0]&i[C+(d+2)>>0]&i[C+(d+3)>>0]&i[Q>>0];c=c+1|0;if((c|0)==(h|0))break;else d=d+M|0}b=b+4|0}while((b|0)<=(L|0))}}while(0);k[T>>2]=(k[T>>2]|0)+o;k[y>>2]=(k[y>>2]|0)+h;j=j+F|0}while(G>>>0>j>>>0)}A1(U);l=l+1|0}b=k[W>>2]|0;if((b|0)!=(D|0)){if(b|0)ggb(b);k[W>>2]=D;k[E>>2]=1032}d=X+36|0;b=k[d>>2]|0;if(b|0?(V=b+12|0,W=k[V>>2]|0,k[V>>2]=W+-1,(W|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[X+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;W=X+16|0;c=X+4|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[c>>2]|0)>0){d=k[X+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[X+44>>2]|0;if(!((b|0)==(X+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=Y+36|0;b=k[d>>2]|0;if(b|0?(W=b+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Y+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;X=Y+16|0;c=Y+4|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[c>>2]|0)>0){d=k[Y+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[Y+44>>2]|0;if(!((b|0)==(Y+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=Z+36|0;b=k[d>>2]|0;if(b|0?(X=b+12|0,Y=k[X>>2]|0,k[X>>2]=Y+-1,(Y|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Z+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;Y=Z+16|0;c=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[c>>2]|0)>0){d=k[Z+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[Z+44>>2]|0;if(!((b|0)==(Z+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=_+36|0;b=k[d>>2]|0;do if(b|0){Y=b+12|0;Z=k[Y>>2]|0;k[Y>>2]=Z+-1;if((Z|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[_+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;Z=_+16|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[S>>2]|0)>0){c=k[R>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[S>>2]|0))}b=k[_+44>>2]|0;if((b|0)==(_+48|0)|(b|0)==0){r=$;return}ggb(k[b+-4>>2]|0);r=$;return}function pl(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;i=r;r=r+112|0;q=i+88|0;p=i+72|0;o=i+56|0;n=i+40|0;m=i+32|0;l=i+16|0;j=i;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=a;k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=b;k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=c;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=d;k[m>>2]=k[e>>2];k[m+4>>2]=k[e+4>>2];e=l+4+4|0;k[e>>2]=0;k[e+4>>2]=0;k[l>>2]=33619968;k[l+4>>2]=g;g=j+4+4|0;k[g>>2]=0;k[g+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=h;bva(q,p,o,n,m,f,l,j);r=i;return}function ql(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=+j;var l=0,m=0,n=0,q=0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,Q=0.0,R=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0.0,gb=0.0;eb=r;r=r+1008|0;Aa=eb+464|0;La=eb+408|0;Ia=eb+984|0;db=eb+928|0;cb=eb+872|0;va=eb+296|0;A=eb+224|0;bb=eb+816|0;ab=eb+760|0;$a=eb+748|0;_a=eb+736|0;Za=eb+680|0;B=eb;xa=eb+672|0;Sa=eb+568|0;Ga=eb+512|0;ta=eb+496|0;ua=eb+480|0;za=eb+472|0;q=eb+656|0;Ba=eb+640|0;Ja=eb+624|0;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;s=q+4|0;k[s>>2]=b;ra=k[c>>2]|0;sa=k[c+4>>2]|0;ya=Ba+4|0;n=Ba+4+4|0;k[n>>2]=0;k[n+4>>2]=0;k[Ba>>2]=33619968;k[ya>>2]=f;n=Ja+4+4|0;k[n>>2]=0;k[n+4>>2]=0;k[Ja>>2]=33619968;k[Ja+4>>2]=g;k[db>>2]=k[a>>2];n=db+4|0;c=a+4|0;b=k[c>>2]|0;k[n>>2]=b;Ya=db+8|0;k[Ya>>2]=k[a+8>>2];k[db+12>>2]=k[a+12>>2];k[db+16>>2]=k[a+16>>2];k[db+20>>2]=k[a+20>>2];k[db+24>>2]=k[a+24>>2];k[db+28>>2]=k[a+28>>2];k[db+32>>2]=k[a+32>>2];f=k[a+36>>2]|0;k[db+36>>2]=f;g=db+40|0;k[g>>2]=Ya;Ya=db+48|0;m=db+44|0;k[m>>2]=Ya;k[db+52>>2]=0;k[Ya>>2]=0;if(f){b=f+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[n>>2]=0;x1(db,b,0,0,0);if((k[n>>2]|0)>0){l=k[a+40>>2]|0;g=k[g>>2]|0;f=k[a+44>>2]|0;c=k[m>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[l+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else{Xa=k[a+44>>2]|0;Ya=k[m>>2]|0;k[Ya>>2]=k[Xa>>2];k[Ya+4>>2]=k[Xa+4>>2]}do if((k[q>>2]&2031616|0)==65536){g=k[s>>2]|0;k[cb>>2]=k[g>>2];a=cb+4|0;b=g+4|0;k[a>>2]=k[b>>2];q=cb+8|0;k[q>>2]=k[g+8>>2];s=cb+12|0;k[s>>2]=k[g+12>>2];k[cb+16>>2]=k[g+16>>2];k[cb+20>>2]=k[g+20>>2];k[cb+24>>2]=k[g+24>>2];k[cb+28>>2]=k[g+28>>2];k[cb+32>>2]=k[g+32>>2];c=k[g+36>>2]|0;k[cb+36>>2]=c;f=cb+40|0;k[f>>2]=q;Ya=cb+48|0;m=cb+44|0;k[m>>2]=Ya;k[cb+52>>2]=0;k[Ya>>2]=0;if(c|0){Ya=c+12|0;k[Ya>>2]=(k[Ya>>2]|0)+1}if((k[b>>2]|0)<3){Ya=k[g+44>>2]|0;f=k[m>>2]|0;k[f>>2]=k[Ya>>2];k[f+4>>2]=k[Ya+4>>2];f=cb;break}k[a>>2]=0;x1(cb,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){n=k[g+40>>2]|0;l=k[f>>2]|0;f=k[g+44>>2]|0;c=k[m>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[n+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0));f=cb}else f=cb}else{Q1(cb,q,-1);q=cb+8|0;s=cb+12|0;f=cb}while(0);g=va;m=g+112|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(m|0));g=A;m=g+72|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(m|0));Na=k[q>>2]|0;Ra=k[s>>2]|0;Oa=k[f>>2]&4088;Wa=bb+4|0;k[Wa>>2]=2;Ya=bb+8|0;k[Ya>>2]=Na;k[bb+12>>2]=Ra;Ta=bb+16|0;k[Ta>>2]=va;k[bb+20>>2]=va;Pa=bb+24|0;Ua=bb+40|0;Xa=Pa+8|0;k[Xa>>2]=0;k[Xa+4>>2]=0;k[Ua>>2]=Ya;Ya=bb+48|0;Xa=bb+44|0;k[Xa>>2]=Ya;Ma=Oa+8|0;Ra=aa(Ma,Ra)|0;k[bb>>2]=Oa|1124024326;k[Ya>>2]=Ra;k[bb+52>>2]=Ma;Na=va+(aa(Na,Ra)|0)|0;k[bb+28>>2]=Na;k[Pa>>2]=Na+(0-Ra)+Ra;Pa=ab+4|0;k[Pa>>2]=2;Ra=ab+8|0;k[Ra>>2]=3;k[ab+12>>2]=3;Na=ab+16|0;k[Na>>2]=A;k[ab+20>>2]=A;Ma=ab+24|0;Oa=ab+40|0;Qa=Ma+8|0;k[Qa>>2]=0;k[Qa+4>>2]=0;k[Oa>>2]=Ra;Ra=ab+48|0;Qa=ab+44|0;k[Qa>>2]=Ra;k[ab>>2]=1124024326;k[Ra>>2]=24;k[ab+52>>2]=8;k[ab+28>>2]=A+72;k[Ma>>2]=A+72;wa=+(d+-1|0)*.5;k[$a>>2]=0;Ma=$a+4|0;k[Ma>>2]=0;k[$a+8>>2]=0;while(1){b=fgb(8)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[$a>>2]=b;Ka=b+8|0;k[$a+8>>2]=Ka;Va=b;k[Va>>2]=0;k[Va+4>>2]=0;k[Ma>>2]=Ka;k[_a>>2]=0;Ka=_a+4|0;k[Ka>>2]=0;k[_a+8>>2]=0;while(1){b=fgb(8)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[_a>>2]=b;c=b+8|0;k[_a+8>>2]=c;k[b>>2]=0;k[b+4>>2]=0;k[Ka>>2]=c;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=1124007936;b=B+16|0;c=B+48|0;g=B+12|0;m=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(m|0));k[c>>2]=b;b=B+56|0;k[B+52>>2]=b;k[B+60>>2]=0;k[b>>2]=0;k[B+64>>2]=1124007936;b=B+72|0;c=B+104|0;g=B+68|0;m=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(m|0));k[c>>2]=b;b=B+112|0;k[B+108>>2]=b;k[B+116>>2]=0;k[b>>2]=0;k[B+120>>2]=1124007936;b=B+128|0;c=B+160|0;g=B+124|0;m=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(m|0));k[c>>2]=b;g=B+168|0;k[B+164>>2]=g;m=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(m|0));k[La>>2]=3;k[La+4>>2]=3;j1(B,73,La,6);k[Za>>2]=1124007936;Ea=Za+4|0;b=Za+8|0;Ca=Za+40|0;g=Ea;m=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(m|0));k[Ca>>2]=b;Fa=Za+48|0;Da=Za+44|0;k[Da>>2]=Fa;k[Za+52>>2]=0;k[Fa>>2]=0;c=k[B>>2]|0;dh[k[(k[c>>2]|0)+12>>2]&255](c,B,Za,-1);XN(B);o[xa>>2]=j;c=k[s>>2]|0;b=k[q>>2]|0;if((c|0)==1|(b|0)==1){Va=aa(b,c)|0;switch(aa(Va,((k[f>>2]|0)>>>3&511)+1|0)|0){case 4:case 5:case 8:case 12:case 14:break;default:F=27}}else F=27;if((F|0)==27?(k[La>>2]=0,Va=La+4|0,k[Va>>2]=0,C=ZT(144)|0,k[C>>2]=1,K=C+4|0,k[La>>2]=K,k[Va>>2]=137,i[C+141>>0]=0,upb(K|0,356048,137)|0,Y8(-215,La,356186,354470,538),k[Va>>2]=0,k[La>>2]=0,Va=k[C>>2]|0,k[C>>2]=Va+-1,(Va|0)==1):0)ggb(k[C+-4>>2]|0);Va=db+40|0;K=k[Va>>2]|0;if(!((k[K>>2]|0)==3?(k[K+4>>2]|0)==3:0)){k[La>>2]=0;b=La+4|0;k[b>>2]=0;c=ZT(40)|0;k[c>>2]=1;g=c+4|0;k[La>>2]=g;k[b>>2]=33;i[c+37>>0]=0;f=356207;m=g+33|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(m|0));Y8(-215,La,356186,354470,539);k[b>>2]=0;k[La>>2]=0;K=k[c>>2]|0;k[c>>2]=K+-1;if((K|0)==1)ggb(k[c+-4>>2]|0)}K=La+4|0;f=K+4|0;k[f>>2]=0;k[f+4>>2]=0;k[La>>2]=33619968;k[K>>2]=bb;SW(cb,La,6,1.0,0.0);K=La+4|0;f=K+4|0;k[f>>2]=0;k[f+4>>2]=0;k[La>>2]=33619968;k[K>>2]=ab;SW(db,La,6,1.0,0.0);o[La>>2]=.9990000128746033;K=k[(j>.9990000128746033?La:xa)>>2]|0;k[xa>>2]=K;f=La+8|0;g=La+12|0;l=La+4|0;m=Ia+4|0;n=m+4|0;a=Sa+8|0;q=Sa+12|0;s=Sa+4|0;A=Ga+8|0;B=Ga+12|0;C=Ga+4|0;D=ta+8|0;E=ta+12|0;F=ta+4|0;G=ua+8|0;H=ua+12|0;I=ua+4|0;J=(k[u>>2]=K,+o[u>>2]);K=La+4|0;z=+(ra|0);x=+(sa|0);j=3402823466385288598117041.0e14;t=-3402823466385288598117041.0e14;v=3402823466385288598117041.0e14;w=-3402823466385288598117041.0e14;b=0;do{y=+(b|0)*x*.125;c=0;do{sa=k[$a>>2]|0;o[sa>>2]=+(c|0)*z*.125;o[sa+4>>2]=y;k[f>>2]=0;k[g>>2]=0;k[La>>2]=-2130509811;k[l>>2]=$a;sa=n;k[sa>>2]=0;k[sa+4>>2]=0;k[Ia>>2]=-2113732595;k[m>>2]=_a;k[a>>2]=0;k[q>>2]=0;k[Sa>>2]=16842752;k[s>>2]=ab;k[A>>2]=0;k[B>>2]=0;k[Ga>>2]=16842752;k[C>>2]=bb;k[D>>2]=0;k[E>>2]=0;k[ta>>2]=16842752;k[F>>2]=Za;k[G>>2]=0;k[H>>2]=0;k[ua>>2]=16842752;k[I>>2]=Za;dva(La,Ia,Sa,Ga,ta,ua);sa=k[_a>>2]|0;eva(La,+o[sa>>2],+o[sa+4>>2],J,0,h);Ha=+o[La>>2];j=j>Ha?Ha:j;t=t<Ha?Ha:t;Ha=+o[K>>2];v=v>Ha?Ha:v;w=w<Ha?Ha:w;c=c+1|0}while((c|0)<9);b=b+1|0}while((b|0)<9);Ha=wa/+P(+t);qa=wa/+P(+j);Ha=qa<Ha?qa:Ha;qa=+P(+v)*Ha*2.0;pa=+P(+w)*Ha*2.0;qa=qa<pa?pa:qa;A=~~qa;A=(+(A|0)<qa&1)+A|0;qa=+(A+-1|0)*.5;k[Sa>>2]=1124007936;D=Sa+4|0;b=Sa+8|0;B=Sa+40|0;g=D;m=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(m|0));k[B>>2]=b;E=Sa+48|0;C=Sa+44|0;k[C>>2]=E;k[Sa+52>>2]=0;k[E>>2]=0;k[La>>2]=A;k[La+4>>2]=d;G1(Sa,2,La,13);ca=+p[va>>3];da=+p[va+8>>3];ea=+p[va+16>>3];fa=+p[va+24>>3];ga=+p[va+32>>3];ha=+p[va+40>>3];ia=+p[va+48>>3];ja=+p[va+56>>3];ka=+p[va+64>>3];la=+p[va+72>>3];ma=+p[va+80>>3];na=+p[va+88>>3];ua=k[Na>>2]|0;oa=+p[ua>>3];pa=+p[ua+(k[k[Qa>>2]>>2]|0)+8>>3];N=+p[va+96>>3];M=+p[va+104>>3];R=+S(+N);N=+T(+N);L=+S(+M);M=+T(+M);Q=M*0.0;Z=L+0.0-Q;U=L*0.0;$=U+0.0;O=R*0.0;_=N*M+(O+$);V=N*0.0;$=V+$-R*M;X=R+0.0-V;Y=O+(N+0.0);M=U+(M+0.0);Q=Q+0.0;N=O+Q-N*L;Q=R*L+(V+Q);V=-$;L=-Y;R=M*V+(Z*Q+0.0);O=X*0.0;U=N*V+(O+(_*Q+0.0));ba=Y*0.0;V=Q*V+(ba+($*Q+0.0));Z=Z*0.0+0.0;W=M*L+(Z+Q*0.0);_=_*0.0+0.0;X=N*L+(_+X*Q);$=$*0.0+0.0;Y=Q*L+($+Y*Q);Z=M+Z;_=N+(O+_);$=Q+(ba+$);if((A|0)>0){q=Sa+16|0;s=(d|0)>0;ba=1.0/Ha;O=+o[xa>>2];g=Ia+4|0;l=La+16|0;m=La+8|0;n=La+24|0;c=0;do{a=(k[q>>2]|0)+(aa(k[k[C>>2]>>2]|0,c)|0)|0;if(s){Q=ba*(+(c|0)-qa);f=0;do{N=ba*(+(f|0)-wa);k[La>>2]=0;k[La+4>>2]=0;k[La+8>>2]=0;k[La+12>>2]=0;k[La+16>>2]=0;k[La+20>>2]=0;k[La+24>>2]=0;k[La+28>>2]=0;b=0;L=N;M=Q;while(1){j=L;t=M;eva(Ia,j,t,O,La,h);v=+o[Ia>>2]-N;w=+o[g>>2]-Q;if(v*v+w*w<1.0e-12){F=48;break}gb=+p[La>>3];J=+p[l>>3];t=gb*gb+J*J;fb=+p[m>>3];j=+p[n>>3];z=gb*fb+J*j;x=fb*fb+j*j;y=t*x-z*z;y=y!=0.0?1.0/y:0.0;z=-(z*y);J=v*gb+w*J;j=v*fb+w*j;b=b+1|0;if((b|0)<5){L=L-(J*(x*y)+j*z);M=M-(J*z+j*(t*y))}else{F=47;break}}if((F|0)==47)F=51;else if((F|0)==48){F=0;b=(k[206761]|0)+b|0;k[206761]=b;xa=(k[206762]|0)+1|0;k[206762]=xa;if((xa|0)==1500){p[Aa>>3]=+(b|0)/1500.0;dgb(0,Aa)}if(!(t<=-3402823466385288598117041.0e14)|!(j<=-3402823466385288598117041.0e14)){fb=j*j;M=t*t;gb=M+fb;L=t*(j*2.0);N=gb*(ca+gb*(da+ea*gb))/(gb*(ha+gb*(ia+ja*gb))+1.0)+1.0;fb=gb*(la*gb)+(ka*gb+(ga*(gb+fb*2.0)+(fa*L+j*N)));N=gb*(na*gb)+(ma*gb+(ga*L+(fa*(M*2.0+gb)+t*N)));gb=$+(_*N+(Z*fb+0.0));gb=gb!=0.0?1.0/gb:1.0;o[a+(f<<3)>>2]=(V+(U*N+(R*fb+0.0)))*(oa*gb)+0.0;o[a+(f<<3)+4>>2]=(Y+(X*N+(W*fb+0.0)))*(pa*gb)+0.0}else F=51}if((F|0)==51){k[a+(f<<3)>>2]=-1082130432;k[a+(f<<3)+4>>2]=-1082130432}f=f+1|0}while((f|0)<(d|0))}c=c+1|0}while((c|0)<(A|0))}if((e|0)==13){e=k[B>>2]|0;Ga=k[e>>2]|0;k[za>>2]=k[e+4>>2];k[za+4>>2]=Ga;x2(Ba,za,k[Sa>>2]&4095,0);do if((k[Ba>>2]&2031616|0)==65536){g=k[ya>>2]|0;k[La>>2]=k[g>>2];a=La+4|0;b=g+4|0;k[a>>2]=k[b>>2];Ga=La+8|0;k[Ga>>2]=k[g+8>>2];k[La+12>>2]=k[g+12>>2];k[La+16>>2]=k[g+16>>2];k[La+20>>2]=k[g+20>>2];k[La+24>>2]=k[g+24>>2];k[La+28>>2]=k[g+28>>2];k[La+32>>2]=k[g+32>>2];c=k[g+36>>2]|0;k[La+36>>2]=c;f=La+40|0;k[f>>2]=Ga;Ga=La+48|0;m=La+44|0;k[m>>2]=Ga;k[La+52>>2]=0;k[Ga>>2]=0;if(c|0){Ga=c+12|0;k[Ga>>2]=(k[Ga>>2]|0)+1}if((k[b>>2]|0)<3){e=k[g+44>>2]|0;Ga=k[m>>2]|0;k[Ga>>2]=k[e>>2];k[Ga+4>>2]=k[e+4>>2];break}k[a>>2]=0;x1(La,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){n=k[g+40>>2]|0;l=k[f>>2]|0;f=k[g+44>>2]|0;c=k[m>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[n+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0))}}else Q1(La,Ba,-1);while(0);f=Ia+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[Ia>>2]=33619968;k[f>>2]=La;mY(Sa,Ia);b2(Ja);f=La+36|0;b=k[f>>2]|0;if(b|0?(Ia=b+12|0,Ja=k[Ia>>2]|0,k[Ia>>2]=Ja+-1,(Ja|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[La+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;Ja=La+16|0;c=La+4|0;k[Ja>>2]=0;k[Ja+4>>2]=0;k[Ja+8>>2]=0;k[Ja+12>>2]=0;if((k[c>>2]|0)>0){f=k[La+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[La+44>>2]|0;if(!((b|0)==(La+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{k[La+8>>2]=0;k[La+12>>2]=0;k[La>>2]=16842752;k[La+4>>2]=Sa;k[Ga>>2]=1124007936;n=Ga+4|0;b=Ga+8|0;l=Ga+40|0;g=n;m=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(m|0));k[l>>2]=b;m=Ga+48|0;g=Ga+44|0;k[g>>2]=m;k[Ga+52>>2]=0;k[m>>2]=0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;k[Ia>>2]=16842752;k[Ia+4>>2]=Ga;goa(La,Ia,Ba,Ja,e,0);f=Ga+36|0;b=k[f>>2]|0;if(b|0?(Ja=b+12|0,La=k[Ja>>2]|0,k[Ja>>2]=La+-1,(La|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Ga+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;La=Ga+16|0;k[La>>2]=0;k[La+4>>2]=0;k[La+8>>2]=0;k[La+12>>2]=0;if((k[n>>2]|0)>0){c=k[l>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[n>>2]|0))}b=k[g>>2]|0;if(!((b|0)==(m|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}f=Sa+36|0;b=k[f>>2]|0;if(b|0?(Ja=b+12|0,La=k[Ja>>2]|0,k[Ja>>2]=La+-1,(La|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Sa+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;Sa=Sa+16|0;k[Sa>>2]=0;k[Sa+4>>2]=0;k[Sa+8>>2]=0;k[Sa+12>>2]=0;if((k[D>>2]|0)>0){c=k[B>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[D>>2]|0))}b=k[C>>2]|0;if(!((b|0)==(E|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Za+36|0;b=k[f>>2]|0;if(b|0?(La=b+12|0,Sa=k[La>>2]|0,k[La>>2]=Sa+-1,(Sa|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Za+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;Za=Za+16|0;k[Za>>2]=0;k[Za+4>>2]=0;k[Za+8>>2]=0;k[Za+12>>2]=0;if((k[Ea>>2]|0)>0){c=k[Ca>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ea>>2]|0))}b=k[Da>>2]|0;if(!((b|0)==(Fa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[_a>>2]|0;c=b;if(b|0){f=k[Ka>>2]|0;if((f|0)!=(b|0))k[Ka>>2]=f+(~((f+-8-c|0)>>>3)<<3);ggb(b)}b=k[$a>>2]|0;c=b;if(b|0){f=k[Ma>>2]|0;if((f|0)!=(b|0))k[Ma>>2]=f+(~((f+-8-c|0)>>>3)<<3);ggb(b)}f=ab+36|0;b=k[f>>2]|0;if(b|0?(_a=b+12|0,$a=k[_a>>2]|0,k[_a>>2]=$a+-1,($a|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ab+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;k[Na>>2]=0;k[Na+4>>2]=0;k[Na+8>>2]=0;k[Na+12>>2]=0;if((k[Pa>>2]|0)>0){c=k[Oa>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Pa>>2]|0))}b=k[Qa>>2]|0;if(!((b|0)==(Ra|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=bb+36|0;b=k[f>>2]|0;do if(b|0){$a=b+12|0;ab=k[$a>>2]|0;k[$a>>2]=ab+-1;if((ab|0)!=1)break;c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[bb+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}while(0);k[f>>2]=0;k[Ta>>2]=0;k[Ta+4>>2]=0;k[Ta+8>>2]=0;k[Ta+12>>2]=0;if((k[Wa>>2]|0)>0){c=k[Ua>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Wa>>2]|0))}b=k[Xa>>2]|0;if(!((b|0)==(Ya|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=cb+36|0;b=k[f>>2]|0;do if(b|0){ab=b+12|0;bb=k[ab>>2]|0;k[ab>>2]=bb+-1;if((bb|0)!=1)break;c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[cb+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}while(0);k[f>>2]=0;bb=cb+16|0;c=cb+4|0;k[bb>>2]=0;k[bb+4>>2]=0;k[bb+8>>2]=0;k[bb+12>>2]=0;if((k[c>>2]|0)>0){f=k[cb+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[cb+44>>2]|0;if(!((b|0)==(cb+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=db+36|0;b=k[f>>2]|0;do if(b|0){bb=b+12|0;cb=k[bb>>2]|0;k[bb>>2]=cb+-1;if((cb|0)!=1)break;c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[db+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}while(0);k[f>>2]=0;cb=db+16|0;f=db+4|0;k[cb>>2]=0;k[cb+4>>2]=0;k[cb+8>>2]=0;k[cb+12>>2]=0;if((k[f>>2]|0)>0){c=k[Va>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[db+44>>2]|0;if((b|0)==(db+48|0)|(b|0)==0){r=eb;return +Ha}ggb(k[b+-4>>2]|0);r=eb;return +Ha}function rl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=r;r=r+304|0;D=E+240|0;C=E+184|0;n=E+176|0;A=E+144|0;B=E+116|0;y=E+88|0;z=E+32|0;l=E+16|0;p=E;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;m=l+4|0;k[m>>2]=b;o=p+4|0;j=p+4+4|0;k[j>>2]=0;k[j+4>>2]=0;k[p>>2]=33619968;k[o>>2]=c;k[D>>2]=k[a>>2];j=D+4|0;c=a+4|0;b=k[c>>2]|0;k[j>>2]=b;x=D+8|0;k[x>>2]=k[a+8>>2];k[D+12>>2]=k[a+12>>2];k[D+16>>2]=k[a+16>>2];k[D+20>>2]=k[a+20>>2];k[D+24>>2]=k[a+24>>2];k[D+28>>2]=k[a+28>>2];k[D+32>>2]=k[a+32>>2];f=k[a+36>>2]|0;k[D+36>>2]=f;g=D+40|0;k[g>>2]=x;x=D+48|0;i=D+44|0;k[i>>2]=x;k[D+52>>2]=0;k[x>>2]=0;if(f){b=f+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[j>>2]=0;x1(D,b,0,0,0);if((k[j>>2]|0)>0){h=k[a+40>>2]|0;g=k[g>>2]|0;f=k[a+44>>2]|0;c=k[i>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else{w=k[a+44>>2]|0;x=k[i>>2]|0;k[x>>2]=k[w>>2];k[x+4>>2]=k[w+4>>2]}do if((k[l>>2]&2031616|0)==65536){h=k[m>>2]|0;k[C>>2]=k[h>>2];j=C+4|0;c=h+4|0;k[j>>2]=k[c>>2];x=C+8|0;k[x>>2]=k[h+8>>2];k[C+12>>2]=k[h+12>>2];k[C+16>>2]=k[h+16>>2];k[C+20>>2]=k[h+20>>2];k[C+24>>2]=k[h+24>>2];k[C+28>>2]=k[h+28>>2];k[C+32>>2]=k[h+32>>2];b=k[h+36>>2]|0;k[C+36>>2]=b;f=C+40|0;k[f>>2]=x;x=C+48|0;i=C+44|0;k[i>>2]=x;k[C+52>>2]=0;k[x>>2]=0;if(b|0){x=b+12|0;k[x>>2]=(k[x>>2]|0)+1}if((k[c>>2]|0)<3){w=k[h+44>>2]|0;x=k[i>>2]|0;k[x>>2]=k[w>>2];k[x+4>>2]=k[w+4>>2];break}k[j>>2]=0;x1(C,k[c>>2]|0,0,0,0);if((k[j>>2]|0)>0){a=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;c=k[i>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else Q1(C,l,-1);while(0);v=D+40|0;w=k[v>>2]|0;t=k[w>>2]|0;k[n>>2]=k[w+4>>2];k[n+4>>2]=t;x2(p,n,k[D>>2]&4095,0);t=k[D+8>>2]|0;w=D+4|0;x=(k[w>>2]|0)==1?1:k[D+12>>2]|0;l=k[D>>2]|0;s=l&4095;u=D+16|0;n=k[u>>2]|0;m=aa((l>>>3&511)+1<<(47696>>>(s<<1&14)&3),x)|0;k[A>>2]=s|1111638016;s=A+4|0;k[s>>2]=m;k[A+8>>2]=0;k[A+12>>2]=0;k[A+16>>2]=n;k[A+20>>2]=t;k[A+24>>2]=x;x=D+44|0;k[s>>2]=k[k[x>>2]>>2];k[A>>2]=l&20479|1111621632;l=k[C+8>>2]|0;s=C+4|0;t=(k[s>>2]|0)==1?1:k[C+12>>2]|0;n=k[C>>2]|0;m=n&4095;q=C+16|0;j=k[q>>2]|0;a=aa((n>>>3&511)+1<<(47696>>>(m<<1&14)&3),t)|0;k[B>>2]=m|1111638016;m=B+4|0;k[m>>2]=a;k[B+8>>2]=0;k[B+12>>2]=0;k[B+16>>2]=j;k[B+20>>2]=l;k[B+24>>2]=t;t=C+44|0;k[m>>2]=k[k[t>>2]>>2];k[B>>2]=n&20479|1111621632;do if((k[p>>2]&2031616|0)==65536){g=k[o>>2]|0;k[z>>2]=k[g>>2];j=z+4|0;b=g+4|0;k[j>>2]=k[b>>2];a=z+8|0;k[a>>2]=k[g+8>>2];l=z+12|0;k[l>>2]=k[g+12>>2];m=z+16|0;k[m>>2]=k[g+16>>2];k[z+20>>2]=k[g+20>>2];k[z+24>>2]=k[g+24>>2];k[z+28>>2]=k[g+28>>2];k[z+32>>2]=k[g+32>>2];o=z+36|0;c=k[g+36>>2]|0;k[o>>2]=c;f=z+40|0;k[f>>2]=a;p=z+48|0;n=z+44|0;k[n>>2]=p;k[z+52>>2]=0;k[p>>2]=0;if(c|0){p=c+12|0;k[p>>2]=(k[p>>2]|0)+1}if((k[b>>2]|0)<3){c=k[g+44>>2]|0;g=k[n>>2]|0;k[g>>2]=k[c>>2];k[g+4>>2]=k[c+4>>2];g=a;c=l;f=z;i=m;b=m;a=n;h=o;break}k[j>>2]=0;x1(z,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){i=k[g+40>>2]|0;h=k[f>>2]|0;c=k[g+44>>2]|0;f=k[n>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[i+(b<<2)>>2];k[f+(b<<2)>>2]=k[c+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0));g=a;c=l;f=z;i=m;b=m;a=n;h=o}else{g=a;c=l;f=z;i=m;b=m;a=n;h=o}}else{Q1(z,p,-1);b=z+16|0;g=z+8|0;j=z+4|0;c=z+12|0;f=z;i=b;a=z+44|0;h=z+36|0}while(0);n=k[g>>2]|0;o=(k[j>>2]|0)==1?1:k[c>>2]|0;p=k[f>>2]|0;g=p&4095;m=k[b>>2]|0;l=aa((p>>>3&511)+1<<(47696>>>(g<<1&14)&3),o)|0;k[y>>2]=g|1111638016;b=y+4|0;k[b>>2]=l;k[y+8>>2]=0;k[y+12>>2]=0;k[y+16>>2]=m;k[y+20>>2]=n;k[y+24>>2]=o;k[b>>2]=k[k[a>>2]>>2];k[y>>2]=p&20479|1111621632;b=k[h>>2]|0;if(b|0?(o=b+12|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0){f=z+36|0;c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[z+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[h>>2]=0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;if((k[j>>2]|0)>0){c=k[z+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[a>>2]|0;if(!((b|0)==(z+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);$2a(A,B,y,d,e);f=C+36|0;b=k[f>>2]|0;if(b|0?(A=b+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[C+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[s>>2]|0)>0){c=k[C+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[s>>2]|0))}b=k[t>>2]|0;if(!((b|0)==(C+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=D+36|0;b=k[f>>2]|0;if(b|0?(B=b+12|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[D+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[w>>2]|0)>0){c=k[v>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[w>>2]|0))}b=k[x>>2]|0;if((b|0)==(D+48|0)|(b|0)==0){r=E;return}ggb(k[b+-4>>2]|0);r=E;return}function sl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+224|0;t=w+208|0;v=w+152|0;u=w+96|0;m=w+80|0;s=w+64|0;n=w+32|0;o=w;j=w+48|0;q=w+16|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;l=j+4|0;k[l>>2]=a;p=q+4|0;a=q+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[q>>2]=50397184;k[p>>2]=b;a=S1(j,-1)|0;d=a&4088;b=S1(q,-1)|0;e=b>>>3&511;if(!(E2(j,q)|0?!((b^a)&7|0):0)){k[t>>2]=0;a=t+4|0;k[a>>2]=0;b=ZT(44)|0;k[b>>2]=1;f=b+4|0;k[t>>2]=f;k[a>>2]=39;i[b+43>>0]=0;g=210445;h=f+39|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,t,210485,209965,693);k[a>>2]=0;k[t>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0)}if(!((c|0)>-1?(d|0)==0&(e|0)>=(c|0):0)){k[t>>2]=0;a=t+4|0;k[a>>2]=0;b=ZT(40)|0;k[b>>2]=1;f=b+4|0;k[t>>2]=f;k[a>>2]=33;i[b+37>>0]=0;g=210499;h=f+33|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,t,210485,209965,694);k[a>>2]=0;k[t>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0)}k[t>>2]=0;k[t+4>>2]=c;a=(n9(c9()|0)|0)+16|0;b=k[a>>2]|0;if((b|0)>=0){if((b|0?(a2(j)|0)<3:0)?(k[q>>2]&2031616|0)==655360:0){A2(v,j);A2(u,q);RV(s,v);k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=17498112;k[m+4>>2]=s;RV(o,u);f=n+4|0;q=f+4|0;k[q>>2]=0;k[q+4>>2]=0;k[n>>2]=1124794368;k[f>>2]=o;MV(m,n,t);f=k[o>>2]|0;if(f|0){g=o+4|0;while(1){h=k[g>>2]|0;if((h|0)==(f|0))break;k[g>>2]=h+-48;e=h+-24|0;a=k[e>>2]|0;if(a|0?(q=a+8|0,t=k[q>>2]|0,k[q>>2]=t+-1,(t|0)==1):0){t=k[e>>2]|0;q=k[t+4>>2]|0;jh[k[(k[q>>2]|0)+16>>2]&1023](q,t);k[e>>2]=0}b=h+-44|0;if((k[b>>2]|0)>0){d=k[h+-16>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}k[e>>2]=0;a=k[h+-12>>2]|0;if((a|0)==(h+-8|0)|(a|0)==0)continue;ggb(k[a+-4>>2]|0)}ggb(k[o>>2]|0)}f=k[s>>2]|0;if(f|0){g=s+4|0;while(1){h=k[g>>2]|0;if((h|0)==(f|0))break;k[g>>2]=h+-48;e=h+-24|0;a=k[e>>2]|0;if(a|0?(q=a+8|0,t=k[q>>2]|0,k[q>>2]=t+-1,(t|0)==1):0){t=k[e>>2]|0;q=k[t+4>>2]|0;jh[k[(k[q>>2]|0)+16>>2]&1023](q,t);k[e>>2]=0}b=h+-44|0;if((k[b>>2]|0)>0){d=k[h+-16>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}k[e>>2]=0;a=k[h+-12>>2]|0;if((a|0)==(h+-8|0)|(a|0)==0)continue;ggb(k[a+-4>>2]|0)}ggb(k[s>>2]|0)}e=u+24|0;a=k[e>>2]|0;if(a|0?(s=a+8|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){t=k[e>>2]|0;s=k[t+4>>2]|0;jh[k[(k[s>>2]|0)+16>>2]&1023](s,t);k[e>>2]=0}b=u+4|0;if((k[b>>2]|0)>0){d=k[u+32>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}k[e>>2]=0;a=k[u+36>>2]|0;if(!((a|0)==(u+40|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=v+24|0;a=k[e>>2]|0;if(a|0?(t=a+8|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){u=k[e>>2]|0;t=k[u+4>>2]|0;jh[k[(k[t>>2]|0)+16>>2]&1023](t,u);k[e>>2]=0}b=v+4|0;if((k[b>>2]|0)>0){d=k[v+32>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}k[e>>2]=0;a=k[v+36>>2]|0;if(!((a|0)==(v+40|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=w;return}}else k[a>>2]=0;do if((k[j>>2]&2031616|0)==65536){e=k[l>>2]|0;k[v>>2]=k[e>>2];c=v+4|0;a=e+4|0;k[c>>2]=k[a>>2];s=v+8|0;k[s>>2]=k[e+8>>2];k[v+12>>2]=k[e+12>>2];k[v+16>>2]=k[e+16>>2];k[v+20>>2]=k[e+20>>2];k[v+24>>2]=k[e+24>>2];k[v+28>>2]=k[e+28>>2];k[v+32>>2]=k[e+32>>2];b=k[e+36>>2]|0;k[v+36>>2]=b;d=v+40|0;k[d>>2]=s;s=v+48|0;g=v+44|0;k[g>>2]=s;k[v+52>>2]=0;k[s>>2]=0;if(b|0){s=b+12|0;k[s>>2]=(k[s>>2]|0)+1}if((k[a>>2]|0)<3){o=k[e+44>>2]|0;s=k[g>>2]|0;k[s>>2]=k[o>>2];k[s+4>>2]=k[o+4>>2];break}k[c>>2]=0;x1(v,k[a>>2]|0,0,0,0);if((k[c>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;b=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[b+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[c>>2]|0))}}else Q1(v,j,-1);while(0);do if((k[q>>2]&2031616|0)==65536){e=k[p>>2]|0;k[u>>2]=k[e>>2];c=u+4|0;a=e+4|0;k[c>>2]=k[a>>2];s=u+8|0;k[s>>2]=k[e+8>>2];k[u+12>>2]=k[e+12>>2];k[u+16>>2]=k[e+16>>2];k[u+20>>2]=k[e+20>>2];k[u+24>>2]=k[e+24>>2];k[u+28>>2]=k[e+28>>2];k[u+32>>2]=k[e+32>>2];b=k[e+36>>2]|0;k[u+36>>2]=b;d=u+40|0;k[d>>2]=s;s=u+48|0;g=u+44|0;k[g>>2]=s;k[u+52>>2]=0;k[s>>2]=0;if(b|0){s=b+12|0;k[s>>2]=(k[s>>2]|0)+1}if((k[a>>2]|0)<3){q=k[e+44>>2]|0;s=k[g>>2]|0;k[s>>2]=k[q>>2];k[s+4>>2]=k[q+4>>2];break}k[c>>2]=0;x1(u,k[a>>2]|0,0,0,0);if((k[c>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;b=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[b+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[c>>2]|0))}}else Q1(u,q,-1);while(0);HV(v,1,u,1,t,1);d=u+36|0;a=k[d>>2]|0;if(a|0?(s=a+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[u+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;t=u+16|0;b=u+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[b>>2]|0)>0){d=k[u+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[u+44>>2]|0;if(!((a|0)==(u+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=v+36|0;a=k[d>>2]|0;if(a|0?(t=a+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[v+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;u=v+16|0;b=v+4|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[b>>2]|0)>0){d=k[v+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[v+44>>2]|0;if(!((a|0)==(v+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=w;return}function tl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+32|0;f=d+16|0;e=d;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=a;a=e+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=b;Iua(f,e,49332,49332,c,-1);r=d;return}function ul(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=r;r=r+48|0;i=f+32|0;h=f+16|0;g=f;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=a;a=h+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=b;b=g+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=c;Iua(i,h,g,49332,d,e);r=f;return}function vl(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0;g=r;r=r+64|0;l=g+48|0;j=g+32|0;i=g+16|0;h=g;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=a;a=j+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=b;b=i+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=c;c=h+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=d;Iua(l,j,i,h,e,f);r=g;return}function wl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0,j=0,l=0,m=0.0,n=0,p=0,q=0,s=0,t=0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;qa=r;r=r+1392|0;la=qa+1336|0;pa=qa+1280|0;oa=qa+1224|0;na=qa+128|0;Z=qa+120|0;ma=qa+48|0;ja=qa+16|0;ga=qa+8|0;ha=qa;n=qa+104|0;ka=qa+32|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;p=n+4|0;k[p>>2]=b;l=ka+4+4|0;k[l>>2]=0;k[l+4>>2]=0;k[ka>>2]=33619968;k[ka+4>>2]=c;k[pa>>2]=k[a>>2];l=pa+4|0;c=a+4|0;b=k[c>>2]|0;k[l>>2]=b;fa=pa+8|0;k[fa>>2]=k[a+8>>2];k[pa+12>>2]=k[a+12>>2];k[pa+16>>2]=k[a+16>>2];k[pa+20>>2]=k[a+20>>2];k[pa+24>>2]=k[a+24>>2];k[pa+28>>2]=k[a+28>>2];k[pa+32>>2]=k[a+32>>2];e=k[a+36>>2]|0;k[pa+36>>2]=e;g=pa+40|0;k[g>>2]=fa;fa=pa+48|0;j=pa+44|0;k[j>>2]=fa;k[pa+52>>2]=0;k[fa>>2]=0;if(e){b=e+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[l>>2]=0;x1(pa,b,0,0,0);if((k[l>>2]|0)>0){h=k[a+40>>2]|0;g=k[g>>2]|0;e=k[a+44>>2]|0;c=k[j>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{ea=k[a+44>>2]|0;fa=k[j>>2]|0;k[fa>>2]=k[ea>>2];k[fa+4>>2]=k[ea+4>>2]}do if((k[n>>2]&2031616|0)==65536){h=k[p>>2]|0;k[oa>>2]=k[h>>2];l=oa+4|0;c=h+4|0;k[l>>2]=k[c>>2];fa=oa+8|0;k[fa>>2]=k[h+8>>2];k[oa+12>>2]=k[h+12>>2];k[oa+16>>2]=k[h+16>>2];k[oa+20>>2]=k[h+20>>2];k[oa+24>>2]=k[h+24>>2];k[oa+28>>2]=k[h+28>>2];k[oa+32>>2]=k[h+32>>2];b=k[h+36>>2]|0;k[oa+36>>2]=b;e=oa+40|0;k[e>>2]=fa;fa=oa+48|0;j=oa+44|0;k[j>>2]=fa;k[oa+52>>2]=0;k[fa>>2]=0;if(b|0){fa=b+12|0;k[fa>>2]=(k[fa>>2]|0)+1}if((k[c>>2]|0)<3){ea=k[h+44>>2]|0;fa=k[j>>2]|0;k[fa>>2]=k[ea>>2];k[fa+4>>2]=k[ea+4>>2];break}k[l>>2]=0;x1(oa,k[c>>2]|0,0,0,0);if((k[l>>2]|0)>0){a=k[h+40>>2]|0;g=k[e>>2]|0;e=k[h+44>>2]|0;c=k[j>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(oa,n,-1);while(0);if((k[pa>>2]&6|0)!=4){k[la>>2]=0;b=la+4|0;k[b>>2]=0;c=ZT(52)|0;k[c>>2]=1;N=c+4|0;k[la>>2]=N;k[b>>2]=44;i[c+48>>0]=0;O=257028;Q=N+44|0;do{i[N>>0]=i[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(Q|0));Y8(-215,la,257073,256890,508);k[b>>2]=0;k[la>>2]=0;fa=k[c>>2]|0;k[c>>2]=fa+-1;if((fa|0)==1)ggb(k[c+-4>>2]|0)}b=k[oa>>2]|0;if((b&6|0)!=4){k[la>>2]=0;b=la+4|0;k[b>>2]=0;c=ZT(52)|0;k[c>>2]=1;N=c+4|0;k[la>>2]=N;k[b>>2]=44;i[c+48>>0]=0;O=257095;Q=N+44|0;do{i[N>>0]=i[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(Q|0));Y8(-215,la,257073,256890,509);k[b>>2]=0;k[la>>2]=0;fa=k[c>>2]|0;k[c>>2]=fa+-1;if((fa|0)==1)ggb(k[c+-4>>2]|0);b=k[oa>>2]|0}ca=y2(pa,2,k[pa>>2]&7,1)|0;ba=y2(oa,2,b&7,1)|0;if((ba|ca|0)<=-1){k[la>>2]=0;b=la+4|0;k[b>>2]=0;c=ZT(24)|0;k[c>>2]=1;N=c+4|0;k[la>>2]=N;k[b>>2]=16;i[c+20>>0]=0;O=257140;Q=N+16|0;do{i[N>>0]=i[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(Q|0));Y8(-215,la,257073,256890,514);k[b>>2]=0;k[la>>2]=0;fa=k[c>>2]|0;k[c>>2]=fa+-1;if((fa|0)==1)ggb(k[c+-4>>2]|0)}if((ca|0)<2|(ba|0)<2){b2(ka);f=0.0}else{e=ba+ca<<1|1;ea=na+8|0;zpb(ea|0,0,1088)|0;k[na>>2]=ea;fa=na+4|0;k[fa>>2]=136;if(e>>>0>136){c=e>>>0>536870911?-1:e<<3;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}zpb(b|0,0,e<<3|0)|0;k[na>>2]=b;$=b}else $=ea;k[fa>>2]=e;_=$+(ca<<3)|0;b=_+(ba<<3)|0;a=Z+4|0;l=ma+4|0;n=l+4|0;p=la+16|0;q=la+44|0;s=la+36|0;t=la+4|0;y=la+40|0;z=la+48|0;A=ma+8|0;B=ma+12|0;C=ma+4|0;D=ja+4|0;E=D+4|0;F=la+8|0;G=ma+4|0;H=la+32|0;j=1;e=0;while(1){h=(j|0)==1;da=h?pa:oa;g=h?ca:ba;h=h?$:_;O=k[da+40>>2]|0;Q=k[O>>2]|0;k[Z>>2]=k[O+4>>2];k[a>>2]=Q;YN(la,Z,k[da>>2]&4088|5,h,0);Q=n;k[Q>>2]=0;k[Q+4>>2]=0;k[ma>>2]=33619968;k[l>>2]=la;SW(da,ma,5,1.0,0.0);if((k[p>>2]|0)!=(h|0)){k[ma>>2]=0;k[G>>2]=0;c=ZT(32)|0;k[c>>2]=1;N=c+4|0;k[ma>>2]=N;k[G>>2]=26;i[c+30>>0]=0;O=257157;Q=N+26|0;do{i[N>>0]=i[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(Q|0));Y8(-215,ma,257073,256890,535);k[G>>2]=0;k[ma>>2]=0;da=k[c>>2]|0;k[c>>2]=da+-1;if((da|0)==1)ggb(k[c+-4>>2]|0)}c=g+-1|0;a:do if((g|0)>1){m=+o[h+4>>2];f=+o[h>>2];x=f-+o[h+(c<<3)>>2];v=m-+o[h+(c<<3)+4>>2];c=1;while(1){w=f;f=+o[h+(c<<3)>>2];Y=m;m=+o[h+(c<<3)+4>>2];w=x*(m-Y)-v*(f-w);c=c+1|0;if(w!=0.0)break;if((c|0)>=(g|0)){da=e;break a}}if(w<0.0){k[A>>2]=0;k[B>>2]=0;k[ma>>2]=16842752;k[C>>2]=la;da=E;k[da>>2]=0;k[da+4>>2]=0;k[ja>>2]=33619968;k[D>>2]=la;qY(ma,ja,(k[F>>2]|0)<2&1);da=e+1|0}else da=e}else da=e;while(0);c=k[s>>2]|0;if(c|0?(O=c+12|0,Q=k[O>>2]|0,k[O>>2]=Q+-1,(Q|0)==1):0){e=k[s>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[H>>2]|0;if(!c){c=B1()|0;e=k[s>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[s>>2]=0}k[s>>2]=0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[t>>2]|0)>0){e=k[y>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[t>>2]|0))}c=k[q>>2]|0;if(!((c|0)==(z|0)|(c|0)==0))ggb(k[c+-4>>2]|0);j=j+1|0;if((j|0)>=3)break;else e=da}N=b;k[b>>2]=2139095039;O=b+4|0;k[O>>2]=2139095039;E=ca+-1|0;F=ba+-1|0;G=ca<<1;H=ba<<1;C=0;D=0;l=2;g=1;h=0;j=0;c=b+8|0;b:while(1){A=(E+C|0)%(ca|0)|0;q=(F+D|0)%(ba|0)|0;B=$+(C<<3)|0;x=+o[B>>2];p=$+(C<<3)+4|0;R=+o[p>>2];L=+o[$+(A<<3)>>2];X=+o[$+(A<<3)+4>>2];A=_+(D<<3)|0;f=+o[A>>2];n=_+(D<<3)+4|0;v=+o[n>>2];K=+o[_+(q<<3)>>2];V=+o[_+(q<<3)+4>>2];W=x-L;S=v-V;T=f-K;Y=R-X;M=W*S-Y*T;q=M>1.0e-05?1:(M<-1.0e-05)<<31>>31;M=T*(R-V)-(x-K)*S;s=M>1.0e-05;t=s?1:(M<-1.0e-05)<<31>>31;M=W*(v-X)-Y*(f-L);y=M>1.0e-05;z=y?1:(M<-1.0e-05)<<31>>31;M=L;m=M*S;I=x;w=f;J=K;U=(X-R)*J+(w*Y+(I*(V-v)+m));c:do if(U==0.0){U=W*(V-X)-Y*(K-L);if(!(U>1.0e-05)&!(U<-1.0e-05)){e=L!=x;do if(e){if(!(K<=x)|!(L<=K)?!(K>=x&L>=K):0){ia=50;break}if(!(f<=x)|!(L<=f)?!(f>=x&L>=f):0)ia=50;else{x=f;f=K;w=v;v=V}}else{if(!(V<=R)|!(X<=V)?!(V>=R&X>=V):0){ia=50;break}if(!(v<=R)|!(X<=v)?!(v>=R&X>=v):0)ia=50;else{x=f;f=K;w=v;v=V}}while(0);d:do if((ia|0)==50){ia=0;a=K!=f;do if(a){if(!(L<=f)|!(K<=L)?!(L>=f&K>=L):0)break;if(!(!(x<=f)|!(K<=x))){f=L;w=R;v=X;break d}if(x>=f&K>=x){f=L;w=R;v=X;break d}}else{if(!(X<=v)|!(V<=X)?!(X>=v&V>=X):0)break;if(!(!(R<=v)|!(V<=R))){f=L;w=R;v=X;break d}if(R>=v&V>=R){f=L;w=R;v=X;break d}}while(0);if(e)if(!(K<=x)|!(L<=K)?!(K>=x&L>=K):0)ia=70;else ia=64;else if(!(V<=R)|!(X<=V)?!(V>=R&X>=V):0)ia=72;else ia=64;if((ia|0)==64){ia=0;if(a){if(!(!(x<=f)|!(K<=x))){f=K;w=R;v=V;break}if(x>=f&K>=x){f=K;w=R;v=V;break}}else{if(!(!(R<=v)|!(V<=R))){f=K;w=R;v=V;break}if(R>=v&V>=R){f=K;w=R;v=V;break}}if(e)ia=70;else ia=72}if((ia|0)==70)if(!(K<=x)|!(L<=K)?!(K>=x&L>=K):0)ia=80;else ia=74;else if((ia|0)==72)if(!(V<=R)|!(X<=V)?!(V>=R&X>=V):0)ia=82;else ia=74;if((ia|0)==74){ia=0;if(a){if(!(!(L<=f)|!(K<=L))){x=L;f=K;w=X;v=V;break}if(L>=f&K>=L){x=L;f=K;w=X;v=V;break}}else{if(!(!(X<=v)|!(V<=X))){x=L;f=K;w=X;v=V;break}if(X>=v&V>=X){x=L;f=K;w=X;v=V;break}}if(e)ia=80;else ia=82}if((ia|0)==80)if(!(f<=x)|!(L<=f)?!(f>=x&L>=f):0)ia=90;else ia=84;else if((ia|0)==82)if(!(v<=R)|!(X<=v)?!(v>=R&X>=v):0)ia=92;else ia=84;if((ia|0)==84){ia=0;if(a){if(!(!(x<=f)|!(K<=x))){w=R;break}if(x>=f&K>=x){w=R;break}}else{if(!(!(R<=v)|!(V<=R))){w=R;break}if(R>=v&V>=R){w=R;break}}if(e)ia=90;else ia=92}if((ia|0)==90){ia=0;if(!(f<=x)|!(L<=f)?!(f>=x&L>=f):0){a=g;break c}}else if(((ia|0)==92?(ia=0,!(v<=R)|!(X<=v)):0)?!(v>=R&X>=v):0){a=g;break c}if(a){if(!(!(L<=f)|!(K<=L))){x=L;w=X;break}if(L>=f&K>=L){x=L;w=X;break}else{a=g;break c}}else{if(!(!(X<=v)|!(V<=X))){x=L;w=X;break}if(X>=v&V>=X){x=L;w=X;break}else{a=g;break c}}}while(0);if(W*T+Y*S<0.0){ia=109;break b}else a=g}else a=g}else{w=w*(V-X)+(J*(X-v)+m);x=w/U;f=Y*J+(M*(V-R)+I*(X-V));m=-f;v=m/U;if(v<1.0&(v>0.0&(x>0.0&x<1.0))){a=(o[u>>2]=M+W*x,k[u>>2]|0);f=+(X+Y*x)}else{e=(o[u>>2]=M+W*x,k[u>>2]|0);switch((v>1.0|(v<0.0|(x<0.0|x>1.0))?48:f==-0.0|U==m|(w==0.0|w==U)?118:63)&127){case 49:case 118:{a=e;f=+(X+Y*x);break}default:{a=g;break c}}}if(!((l|0)!=2|g^1)){Z=c;k[c>>2]=a;o[Z+4>>2]=f;g=0;h=0;j=0;c=Z+8|0}e=c;if(!(!((k[u>>2]=a,+o[u>>2])!=+o[e+-8>>2])?!((o[u>>2]=f,+o[u>>2])!=+o[e+-4>>2]):0)){k[c>>2]=a;o[e+4>>2]=f;c=e+8|0}l=s?0:y?1:l;a=g}while(0);if((q|0)==0&(t&z|0)<0){ia=117;break}do if(!(q|z|t))if(!l){e=C;g=(D+1|0)%(ba|0)|0;j=j+1|0;break}else{e=(C+1|0)%(ca|0)|0;g=D;h=h+1|0;break}else if((q|0)>-1)if(y){g=k[p>>2]|0;do if(!l){f=+o[B>>2];e=c;if(!(f!=+o[e+-8>>2])?!((k[u>>2]=g,+o[u>>2])!=+o[e+-4>>2]):0)break;o[e>>2]=f;k[e+4>>2]=g;c=e+8|0}while(0);e=(C+1|0)%(ca|0)|0;g=D;h=h+1|0;break}else{g=k[n>>2]|0;do if((l|0)==1){f=+o[A>>2];e=c;if(!(f!=+o[e+-8>>2])?!((k[u>>2]=g,+o[u>>2])!=+o[e+-4>>2]):0)break;o[e>>2]=f;k[e+4>>2]=g;c=e+8|0}while(0);e=C;g=(D+1|0)%(ba|0)|0;j=j+1|0;break}else if(s){g=k[n>>2]|0;do if((l|0)==1){f=+o[A>>2];e=c;if(!(f!=+o[e+-8>>2])?!((k[u>>2]=g,+o[u>>2])!=+o[e+-4>>2]):0)break;o[e>>2]=f;k[e+4>>2]=g;c=e+8|0}while(0);e=C;g=(D+1|0)%(ba|0)|0;j=j+1|0;break}else{g=k[p>>2]|0;do if(!l){f=+o[B>>2];e=c;if(!(f!=+o[e+-8>>2])?!((k[u>>2]=g,+o[u>>2])!=+o[e+-4>>2]):0)break;o[e>>2]=f;k[e+4>>2]=g;c=e+8|0}while(0);e=(C+1|0)%(ca|0)|0;g=D;h=h+1|0;break}while(0);if((j|0)<(H|0)&((h|0)<(G|0)&((j|0)<(ba|0)|(h|0)<(ca|0)))){C=e;D=g;g=a}else{ia=146;break}}if((ia|0)==109){e=c;m=+o[e+-8>>2];if(!(f!=m)?!(v!=+o[e+-4>>2]):0)f=m;else{Z=e+8|0;o[e>>2]=f;o[e+4>>2]=v;c=Z;e=Z}if(!(!(x!=f)?!(w!=+o[e+-4>>2]):0)){o[e>>2]=x;o[e+4>>2]=w;c=e+8|0}f=0.0;c=c-N>>3}else if((ia|0)==117){f=0.0;c=c-N>>3}else if((ia|0)==146){a=c-N|0;h=a>>3;j=h+-1|0;a=(a|0)>8;if(a){c=1;f=0.0;e=b+(j<<3)|0;g=b+(j<<3)+4|0;do{X=+o[e>>2];Y=+o[g>>2];N=c+-1|0;e=b+(c<<3)|0;Z=k[e>>2]|0;k[b+(N<<3)>>2]=Z;g=b+(c<<3)+4|0;Q=k[g>>2]|0;k[b+(N<<3)+4>>2]=Q;X=X*(k[u>>2]=Q,+o[u>>2]);f=f+(X-Y*(k[u>>2]=Z,+o[u>>2]));c=c+1|0}while((c|0)<(h|0));f=f*.5}else f=0.0;c=h+-2|0;if(+o[b+(c<<3)>>2]==+o[b>>2])c=+o[b+(c<<3)+4>>2]==+o[O>>2];else c=0;c=(a&c?j:h)+-1|0}do if(!c){if(!d){b2(ka);f=0.0;break}k[la>>2]=-1056833523;k[la+4>>2]=$;k[la+8>>2]=ca;k[la+12>>2]=1;k[ga>>2]=k[_>>2];k[ga+4>>2]=k[$+(ca<<3)+4>>2];if(!(+hla(la,ga,0)>=0.0)){k[la>>2]=-1056833523;k[la+4>>2]=_;k[la+8>>2]=ca;k[la+12>>2]=1;k[ha>>2]=k[$>>2];k[ha+4>>2]=k[$+4>>2];if(!(+hla(la,ha,0)>=0.0)){b2(ka);f=0.0;break}else{c=ca;b=$}}else{c=ba;b=_}k[la>>2]=-1056833523;k[la+4>>2]=b;k[la+8>>2]=c;k[la+12>>2]=1;f=+Zra(la,0);ia=184}else ia=184;while(0);if((ia|0)==184){if(k[ka>>2]&2031616|0){k[ma>>2]=1124007949;q=ma+4|0;k[q>>2]=2;j=ma+8|0;k[j>>2]=c;e=ma+12|0;k[e>>2]=1;n=ma+16|0;k[n>>2]=b;h=ma+20|0;k[h>>2]=b;a=ma+24|0;l=ma+28|0;p=ma+40|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[p>>2]=j;t=ma+48|0;s=ma+44|0;k[s>>2]=t;k[ma+52>>2]=0;k[t>>2]=0;if((b|0)==0&(c|0)!=0){k[la>>2]=0;b=la+4|0;k[b>>2]=0;c=ZT(36)|0;k[c>>2]=1;N=c+4|0;k[la>>2]=N;k[b>>2]=28;i[c+32>>0]=0;O=390609;Q=N+28|0;do{i[N>>0]=i[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(Q|0));Y8(-215,la,390638,390642,410);k[b>>2]=0;k[la>>2]=0;ia=k[c>>2]|0;k[c>>2]=ia+-1;if((ia|0)==1)ggb(k[c+-4>>2]|0);c=k[e>>2]|0;e=k[ma>>2]|0;g=k[s>>2]|0;b=k[h>>2]|0}else{c=1;e=1124007949;g=t}ia=c<<3;k[ma>>2]=e|16384;k[g>>2]=ia;k[g+4>>2]=8;d=b+(aa(k[j>>2]|0,ia)|0)|0;k[l>>2]=d;k[a>>2]=d+(0-ia)+ia;if((da|0)==2){k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=ma;ia=ja+4|0;d=ia+4|0;k[d>>2]=0;k[d+4>>2]=0;k[ja>>2]=33619968;k[ia>>2]=ma;qY(la,ja,0)}mY(ma,ka);e=ma+36|0;b=k[e>>2]|0;if(b|0?(ka=b+12|0,la=k[ka>>2]|0,k[ka>>2]=la+-1,(la|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ma+32>>2]|0;if(b|0)break;b=B1()|0;c=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[q>>2]|0)>0){c=k[p>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[q>>2]|0))}b=k[s>>2]|0;if(!((b|0)==(t|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}f=+P(+f)}b=k[na>>2]|0;if((b|0)!=(ea|0)){if(b|0)ggb(b);k[na>>2]=ea;k[fa>>2]=136}}e=oa+36|0;b=k[e>>2]|0;if(b|0?(ma=b+12|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[oa+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;na=oa+16|0;c=oa+4|0;k[na>>2]=0;k[na+4>>2]=0;k[na+8>>2]=0;k[na+12>>2]=0;if((k[c>>2]|0)>0){e=k[oa+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[oa+44>>2]|0;if(!((b|0)==(oa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=pa+36|0;b=k[e>>2]|0;if(b|0?(na=b+12|0,oa=k[na>>2]|0,k[na>>2]=oa+-1,(oa|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[pa+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;oa=pa+16|0;c=pa+4|0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[c>>2]|0)>0){e=k[pa+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[pa+44>>2]|0;if((b|0)==(pa+48|0)|(b|0)==0){r=qa;return +f}ggb(k[b+-4>>2]|0);r=qa;return +f}function xl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;d=+CZ(g,f,c);r=e;return +d}function yl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0,j=0.0,l=0.0,m=0.0,n=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;y=r;r=r+144|0;x=y+80|0;w=y+24|0;v=y;t=y+8|0;u=t+4|0;q=t+4+4|0;k[q>>2]=0;k[q+4>>2]=0;k[t>>2]=33619968;k[u>>2]=b;k[x>>2]=k[a>>2];q=x+4|0;c=a+4|0;b=k[c>>2]|0;k[q>>2]=b;s=x+8|0;k[s>>2]=k[a+8>>2];k[x+12>>2]=k[a+12>>2];k[x+16>>2]=k[a+16>>2];k[x+20>>2]=k[a+20>>2];k[x+24>>2]=k[a+24>>2];k[x+28>>2]=k[a+28>>2];k[x+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[x+36>>2]=d;e=x+40|0;k[e>>2]=s;f=x+48|0;h=x+44|0;k[h>>2]=f;k[x+52>>2]=0;k[f>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[q>>2]=0;x1(x,b,0,0,0);if((k[q>>2]|0)>0){f=k[a+40>>2]|0;e=k[e>>2]|0;d=k[a+44>>2]|0;c=k[h>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else{a=k[a+44>>2]|0;q=k[h>>2]|0;k[q>>2]=k[a>>2];k[q+4>>2]=k[a+4>>2]}if(!((k[s>>2]|0)==2?(k[x+12>>2]|0)==3:0)){k[w>>2]=0;b=w+4|0;k[b>>2]=0;c=ZT(40)|0;k[c>>2]=1;d=c+4|0;k[w>>2]=d;k[b>>2]=32;i[c+36>>0]=0;e=339117;f=d+32|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,w,339150,335515,6312);k[b>>2]=0;k[w>>2]=0;s=k[c>>2]|0;k[c>>2]=s+-1;if((s|0)==1)ggb(k[c+-4>>2]|0)}c2(t,2,3,k[x>>2]&4095,-1,0,0);do if((k[t>>2]&2031616|0)==65536){f=k[u>>2]|0;k[w>>2]=k[f>>2];q=w+4|0;c=f+4|0;k[q>>2]=k[c>>2];u=w+8|0;k[u>>2]=k[f+8>>2];k[w+12>>2]=k[f+12>>2];k[w+16>>2]=k[f+16>>2];k[w+20>>2]=k[f+20>>2];k[w+24>>2]=k[f+24>>2];k[w+28>>2]=k[f+28>>2];k[w+32>>2]=k[f+32>>2];b=k[f+36>>2]|0;k[w+36>>2]=b;d=w+40|0;k[d>>2]=u;u=w+48|0;a=w+44|0;k[a>>2]=u;k[w+52>>2]=0;k[u>>2]=0;if(b|0){u=b+12|0;k[u>>2]=(k[u>>2]|0)+1}if((k[c>>2]|0)<3){t=k[f+44>>2]|0;u=k[a>>2]|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];break}k[q>>2]=0;x1(w,k[c>>2]|0,0,0,0);if((k[q>>2]|0)>0){h=k[f+40>>2]|0;e=k[d>>2]|0;d=k[f+44>>2]|0;c=k[a>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else Q1(w,t,-1);while(0);switch(k[x>>2]&4095){case 5:{b=k[x+16>>2]|0;c=k[w+16>>2]|0;d=(k[x+48>>2]|0)>>>2;e=(k[w+48>>2]|0)>>>2;j=+o[b>>2];l=+o[b+(d+1<<2)>>2];m=+o[b+4>>2];n=+o[b+(d<<2)>>2];g=j*l-m*n;if(g!=0.0)g=1.0/g;else g=0.0;A=g*l;l=g*j;z=g*-m;j=g*-n;m=+o[b+8>>2];n=+o[b+(d+2<<2)>>2];o[c>>2]=A;o[c+4>>2]=z;o[c+8>>2]=-(A*m)-z*n;o[c+(e<<2)>>2]=j;o[c+(e+1<<2)>>2]=l;o[c+(e+2<<2)>>2]=-(j*m)-l*n;break}case 6:{s=k[x+16>>2]|0;u=k[w+16>>2]|0;t=(k[x+48>>2]|0)>>>3;v=(k[w+48>>2]|0)>>>3;A=+p[s>>3];j=+p[s+(t+1<<3)>>3];l=+p[s+8>>3];m=+p[s+(t<<3)>>3];n=A*j-l*m;n=n!=0.0?1.0/n:0.0;j=j*n;A=A*n;l=-(l*n);n=m*n;m=+p[s+16>>3];z=+p[s+(t+2<<3)>>3];p[u>>3]=j;p[u+8>>3]=l;p[u+16>>3]=-(m*j)-z*l;p[u+(v<<3)>>3]=-n;p[u+(v+1<<3)>>3]=A;p[u+(v+2<<3)>>3]=m*n-z*A;break}default:{k[v>>2]=0;u=v+4|0;k[u>>2]=0;b=ZT(8)|0;k[b>>2]=1;t=b+4|0;k[v>>2]=t;k[u>>2]=0;i[t>>0]=0;Y8(-210,v,339150,335515,6347);k[u>>2]=0;k[v>>2]=0;v=k[b>>2]|0;k[b>>2]=v+-1;if((v|0)==1)ggb(k[b+-4>>2]|0)}}d=w+36|0;b=k[d>>2]|0;if(b|0?(u=b+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[w+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;v=w+16|0;c=w+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[c>>2]|0)>0){d=k[w+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[w+44>>2]|0;if(!((b|0)==(w+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=x+36|0;b=k[d>>2]|0;if(b|0?(v=b+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[x+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;w=x+16|0;c=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[c>>2]|0)>0){d=k[x+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[x+44>>2]|0;if((b|0)==(x+48|0)|(b|0)==0){r=y;return}ggb(k[b+-4>>2]|0);r=y;return}function zl(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0.0,h=0.0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0.0,v=0.0,w=0.0;q=r;r=r+64|0;p=q+8|0;m=q;k[p>>2]=k[a>>2];l=p+4|0;d=a+4|0;b=k[d>>2]|0;k[l>>2]=b;n=p+8|0;k[n>>2]=k[a+8>>2];k[p+12>>2]=k[a+12>>2];k[p+16>>2]=k[a+16>>2];k[p+20>>2]=k[a+20>>2];k[p+24>>2]=k[a+24>>2];k[p+28>>2]=k[a+28>>2];k[p+32>>2]=k[a+32>>2];c=k[a+36>>2]|0;k[p+36>>2]=c;e=p+40|0;k[e>>2]=n;n=p+48|0;j=p+44|0;k[j>>2]=n;k[p+52>>2]=0;k[n>>2]=0;if(c){b=c+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[d>>2]|0}if((b|0)>=3){k[l>>2]=0;x1(p,b,0,0,0);if((k[l>>2]|0)>0){f=k[a+40>>2]|0;e=k[e>>2]|0;d=k[a+44>>2]|0;c=k[j>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{l=k[a+44>>2]|0;n=k[j>>2]|0;k[n>>2]=k[l>>2];k[n+4>>2]=k[l+4>>2]}n=y2(p,2,-1,1)|0;a=k[p>>2]&7;if(!((n|0)>-1&(a|1|0)==5)){k[m>>2]=0;b=m+4|0;k[b>>2]=0;c=ZT(56)|0;k[c>>2]=1;d=c+4|0;k[m>>2]=d;k[b>>2]=50;i[c+54>>0]=0;e=243695;f=d+50|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,m,243951,243757,382);k[b>>2]=0;k[m>>2]=0;m=k[c>>2]|0;k[c>>2]=m+-1;if((m|0)==1)ggb(k[c+-4>>2]|0)}a:do if(n){l=k[p+16>>2]|0;if((a|0)==4){b=((n<<1)+-2|0)%(n|0)|0;a=n+-1|0;c=k[l+(a<<3)>>2]|0;a=k[l+(a<<3)+4>>2]|0;if((n|0)<=0){e=1;break}j=c-(k[l+(b<<3)>>2]|0)|0;d=a-(k[l+(b<<3)+4>>2]|0)|0;e=0;f=0;b=a;while(1){m=c;c=k[l+(f<<3)>>2]|0;s=b;b=k[l+(f<<3)+4>>2]|0;a=j;j=c-m|0;m=d;d=b-s|0;m=aa(j,m)|0;a=aa(d,a)|0;e=((a|0)>(m|0)?1:(a|0)<(m|0)?2:3)|e;f=f+1|0;if((e|0)==3){e=0;break a}if((f|0)>=(n|0)){e=1;break}}}else{b=((n<<1)+-2|0)%(n|0)|0;f=n+-1|0;c=k[l+(f<<3)>>2]|0;f=k[l+(f<<3)+4>>2]|0;if((n|0)<=0){e=1;break}h=(k[u>>2]=f,+o[u>>2])-+o[l+(b<<3)+4>>2];g=(k[u>>2]=c,+o[u>>2])-+o[l+(b<<3)>>2];d=0;e=0;b=f;while(1){m=c;c=k[l+(e<<3)>>2]|0;s=b;b=k[l+(e<<3)+4>>2]|0;w=(k[u>>2]=c,+o[u>>2]);v=g;g=w-(k[u>>2]=m,+o[u>>2]);w=(k[u>>2]=b,+o[u>>2]);t=h;h=w-(k[u>>2]=s,+o[u>>2]);t=t*g;v=v*h;d=(v>t?1:v<t?2:3)|d;e=e+1|0;if((d|0)==3){e=0;break a}if((e|0)>=(n|0)){e=1;break}}}}else e=0;while(0);d=p+36|0;b=k[d>>2]|0;if(b|0?(n=b+12|0,s=k[n>>2]|0,k[n>>2]=s+-1,(s|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[p+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;s=p+16|0;c=p+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[c>>2]|0)>0){d=k[p+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[p+44>>2]|0;if((b|0)==(p+48|0)|(b|0)==0){r=q;return e|0}ggb(k[b+-4>>2]|0);r=q;return e|0}function Al(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0,l=0,m=0;i=r;r=r+48|0;m=i+32|0;l=i+16|0;j=i;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;a=l+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[l>>2]=50397184;k[l+4>>2]=c;a=k[d>>2]|0;c=k[d+4>>2]|0;h=+p[d+8>>3];d=j+4+4|0;k[d>>2]=0;k[d+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=g;h=+xZ(m,b,l,a,c,h,e,f,j);r=i;return +h}function Bl(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+32|0;l=h+16|0;j=h+8|0;i=h;m=l+4+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=50397184;k[l+4>>2]=a;k[j>>2]=k[b>>2];k[j+4>>2]=k[b+4>>2];k[i>>2]=k[c>>2];k[i+4>>2]=k[c+4>>2];Gfa(l,j,i,d,e,f,g);r=h;return}function Cl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0.0,h=0.0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0.0;ba=r;r=r+1440|0;Y=ba+32|0;w=ba+1400|0;z=ba+1372|0;P=ba+1344|0;Q=ba+1316|0;R=ba+1288|0;U=ba+224|0;Z=ba;$=ba+168|0;q=ba+160|0;v=ba+116|0;x=ba+88|0;s=ba+144|0;t=s+4|0;p=s+4+4|0;k[p>>2]=0;k[p+4>>2]=0;k[s>>2]=33619968;k[t>>2]=b;h=+o[c>>2];g=+o[c+4>>2];k[$>>2]=k[a>>2];p=$+4|0;c=a+4|0;b=k[c>>2]|0;k[p>>2]=b;X=$+8|0;k[X>>2]=k[a+8>>2];k[$+12>>2]=k[a+12>>2];k[$+16>>2]=k[a+16>>2];k[$+20>>2]=k[a+20>>2];k[$+24>>2]=k[a+24>>2];k[$+28>>2]=k[a+28>>2];k[$+32>>2]=k[a+32>>2];f=k[a+36>>2]|0;k[$+36>>2]=f;_=$+40|0;k[_>>2]=X;X=$+48|0;n=$+44|0;k[n>>2]=X;k[$+52>>2]=0;k[X>>2]=0;if(f){b=f+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[p>>2]=0;x1($,b,0,0,0);if((k[p>>2]|0)>0){l=k[a+40>>2]|0;m=k[_>>2]|0;f=k[a+44>>2]|0;c=k[n>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[l+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0))}}else{W=k[a+44>>2]|0;X=k[n>>2]|0;k[X>>2]=k[W>>2];k[X+4>>2]=k[W+4>>2]}X=k[_>>2]|0;G=k[X>>2]|0;k[q>>2]=k[X+4>>2];k[q+4>>2]=G;x2(s,q,k[$>>2]&4095,0);G=k[$+8>>2]|0;X=$+4|0;W=(k[X>>2]|0)==1?1:k[$+12>>2]|0;I=k[$>>2]|0;H=I&4095;V=$+16|0;F=k[V>>2]|0;E=aa((I>>>3&511)+1<<(47696>>>(H<<1&14)&3),W)|0;k[v>>2]=H|1111638016;H=v+4|0;k[H>>2]=E;k[v+8>>2]=0;k[v+12>>2]=0;k[v+16>>2]=F;k[v+20>>2]=G;k[v+24>>2]=W;W=$+44|0;k[H>>2]=k[k[W>>2]>>2];k[v>>2]=I&20479|1111621632;do if((k[s>>2]&2031616|0)==65536){l=k[t>>2]|0;k[Y>>2]=k[l>>2];p=Y+4|0;b=l+4|0;k[p>>2]=k[b>>2];a=Y+8|0;k[a>>2]=k[l+8>>2];q=Y+12|0;k[q>>2]=k[l+12>>2];s=Y+16|0;k[s>>2]=k[l+16>>2];k[Y+20>>2]=k[l+20>>2];k[Y+24>>2]=k[l+24>>2];k[Y+28>>2]=k[l+28>>2];k[Y+32>>2]=k[l+32>>2];u=Y+36|0;c=k[l+36>>2]|0;k[u>>2]=c;f=Y+40|0;k[f>>2]=a;I=Y+48|0;t=Y+44|0;k[t>>2]=I;k[Y+52>>2]=0;k[I>>2]=0;if(c|0){I=c+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[b>>2]|0)<3){c=k[l+44>>2]|0;l=k[t>>2]|0;k[l>>2]=k[c>>2];k[l+4>>2]=k[c+4>>2];l=a;c=q;f=Y;n=s;b=s;a=t;m=u;break}k[p>>2]=0;x1(Y,k[b>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[l+40>>2]|0;m=k[f>>2]|0;c=k[l+44>>2]|0;f=k[t>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[n+(b<<2)>>2];k[f+(b<<2)>>2]=k[c+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0));l=a;c=q;f=Y;n=s;b=s;a=t;m=u}else{l=a;c=q;f=Y;n=s;b=s;a=t;m=u}}else{Q1(Y,s,-1);b=Y+16|0;l=Y+8|0;p=Y+4|0;c=Y+12|0;f=Y;n=b;a=Y+44|0;m=Y+36|0}while(0);G=k[l>>2]|0;H=(k[p>>2]|0)==1?1:k[c>>2]|0;I=k[f>>2]|0;D=I&4095;F=k[b>>2]|0;E=aa((I>>>3&511)+1<<(47696>>>(D<<1&14)&3),H)|0;k[x>>2]=D|1111638016;b=x+4|0;k[b>>2]=E;k[x+8>>2]=0;k[x+12>>2]=0;k[x+16>>2]=F;k[x+20>>2]=G;k[x+24>>2]=H;k[b>>2]=k[k[a>>2]>>2];k[x>>2]=I&20479|1111621632;b=k[m>>2]|0;if(b|0?(H=b+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){f=Y+36|0;c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Y+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[m>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[p>>2]|0)>0){c=k[Y+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[p>>2]|0))}b=k[a>>2]|0;if(!((b|0)==(Y+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);I=G9(v,w,0,0)|0;H=G9(x,z,0,0)|0;if((k[H>>2]^k[I>>2])&4095|0?(k[Y>>2]=0,G=Y+4|0,k[G>>2]=0,A=ZT(8)|0,k[A>>2]=1,F=A+4|0,k[Y>>2]=F,k[G>>2]=0,i[F>>0]=0,Y8(-205,Y,339493,335515,6612),k[G>>2]=0,k[Y>>2]=0,G=k[A>>2]|0,k[A>>2]=G+-1,(G|0)==1):0)ggb(k[A+-4>>2]|0);f=k[I+24>>2]|0;c=k[I+20>>2]|0;D=k[H+24>>2]|0;E=k[H+20>>2]|0;G=y9(E,D,5)|0;z9(G);if(!G)F=0;else{while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b+4>>2]=1;k[b>>2]=85876;k[b+8>>2]=G;F=b}C=y9(E,D,5)|0;z9(C);if(!C)B=0;else{while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b+4>>2]=1;k[b>>2]=85876;k[b+8>>2]=C;B=b}if(!(e&16)){if((E|0)>0?(y=+(E|0),J=k[G+16>>2]|0,K=k[G+4>>2]|0,L=k[C+16>>2]|0,M=k[C+4>>2]|0,N=+(D|0),O=h,(D|0)>0):0){b=0;do{j=+(b<<1|0)*3.141592653589793/y;h=+S(+j);j=+T(+j);f=J+(aa(K,b)|0)|0;l=L+(aa(M,b)|0)|0;c=0;do{U=c;c=c+1|0;ca=+(c|0)*d/N;o[f+(U<<2)>>2]=h*ca+O;o[l+(U<<2)>>2]=j*ca+g}while((c|0)!=(D|0));b=b+1|0}while((b|0)!=(E|0))}}else{y=+(c|0)/6.283185307179586;j=+(f|0)/d;f=D<<2;z=U+8|0;k[U>>2]=z;A=U+4|0;k[A>>2]=264;if(f>>>0>264){c=f>>>0>1073741823?-1:f<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[U>>2]=b}else b=z;k[A>>2]=f;k[Y>>2]=1111638021;k[Y+4>>2]=f;k[Y+8>>2]=0;k[Y+12>>2]=0;k[Y+16>>2]=b;k[Y+20>>2]=1;k[Y+24>>2]=D;l=b+(D<<2)|0;k[P>>2]=1111638021;k[P+4>>2]=f;k[P+8>>2]=0;k[P+12>>2]=0;k[P+16>>2]=l;k[P+20>>2]=1;k[P+24>>2]=D;k[Q>>2]=1111638021;k[Q+4>>2]=f;k[Q+8>>2]=0;k[Q+12>>2]=0;k[Q+16>>2]=b+(D<<1<<2);k[Q+20>>2]=1;k[Q+24>>2]=D;k[R>>2]=1111638021;k[R+4>>2]=f;k[R+8>>2]=0;k[R+12>>2]=0;k[R+16>>2]=b+(D*3<<2);k[R+20>>2]=1;k[R+24>>2]=D;f=(D|0)>0;if(f){c=0;do{o[b+(c<<2)>>2]=+(c|0)-h;c=c+1|0}while((c|0)!=(D|0))}a:do if((E|0)>0){q=G+16|0;s=G+4|0;t=C+16|0;u=C+4|0;v=Q+16|0;w=R+16|0;x=P+16|0;if(f)b=0;else{b=0;while(1){l_(Y,P,Q,R);b=b+1|0;if((b|0)>=(E|0))break a}}while(1){f=k[q>>2]|0;m=aa(k[s>>2]|0,b)|0;n=k[t>>2]|0;a=aa(k[u>>2]|0,b)|0;h=+(b|0)-g;c=0;do{o[l+(c<<2)>>2]=h;c=c+1|0}while((c|0)!=(D|0));p=f+m|0;m=n+a|0;l_(Y,P,Q,R);l=k[v>>2]|0;c=0;do{M=l+(c<<2)|0;o[M>>2]=+o[M>>2]+1.0;c=c+1|0}while((c|0)!=(D|0));f=k[w>>2]|0;c=0;do{ca=y*+o[f+(c<<2)>>2];o[p+(c<<2)>>2]=j*+o[l+(c<<2)>>2];o[m+(c<<2)>>2]=ca;c=c+1|0}while((c|0)!=(D|0));b=b+1|0;if((b|0)>=(E|0))break a;l=k[x>>2]|0}}while(0);b=k[U>>2]|0;if((b|0)!=(z|0)){if(b|0)ggb(b);k[U>>2]=z;k[A>>2]=264}};k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;k[Z+16>>2]=0;k[Z+20>>2]=0;k[Z+24>>2]=0;k[Z+28>>2]=0;k[Y>>2]=k[Z>>2];k[Y+4>>2]=k[Z+4>>2];k[Y+8>>2]=k[Z+8>>2];k[Y+12>>2]=k[Z+12>>2];k[Y+16>>2]=k[Z+16>>2];k[Y+20>>2]=k[Z+20>>2];k[Y+24>>2]=k[Z+24>>2];k[Y+28>>2]=k[Z+28>>2];poa(I,H,G,C,e,Y);b=B;if(B|0?(Z=b+4|0,e=k[Z>>2]|0,k[Z>>2]=e+-1,(e|0)==1):0)Uh[k[(k[B>>2]|0)+8>>2]&2047](b);b=F;if(F|0?(Z=b+4|0,e=k[Z>>2]|0,k[Z>>2]=e+-1,(e|0)==1):0)Uh[k[(k[F>>2]|0)+8>>2]&2047](b);f=$+36|0;b=k[f>>2]|0;if(b|0?(Z=b+12|0,e=k[Z>>2]|0,k[Z>>2]=e+-1,(e|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[$+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[X>>2]|0)>0){c=k[_>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[X>>2]|0))}b=k[W>>2]|0;if((b|0)==($+48|0)|(b|0)==0){r=ba;return}ggb(k[b+-4>>2]|0);r=ba;return}function Dl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+32|0;e=c+16|0;d=c;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=a;a=d+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[d>>2]=33619968;k[d+4>>2]=b;YZ(e,d);r=c;return}function El(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0,h=0,j=0.0,l=0.0,m=0.0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,_=0,$=0,ba=0,ca=0;ca=r;r=r+2480|0;Y=ca+32|0;x=ca+2440|0;z=ca+2412|0;P=ca+2384|0;Q=ca+2356|0;R=ca+2328|0;U=ca+1264|0;_=ca;ba=ca+1192|0;s=ca+1184|0;w=ca+1156|0;y=ca+1128|0;t=ca+1248|0;u=t+4|0;q=t+4+4|0;k[q>>2]=0;k[q+4>>2]=0;k[t>>2]=33619968;k[u>>2]=b;l=+o[c>>2];j=+o[c+4>>2];k[ba>>2]=k[a>>2];q=ba+4|0;c=a+4|0;b=k[c>>2]|0;k[q>>2]=b;X=ba+8|0;k[X>>2]=k[a+8>>2];k[ba+12>>2]=k[a+12>>2];k[ba+16>>2]=k[a+16>>2];k[ba+20>>2]=k[a+20>>2];k[ba+24>>2]=k[a+24>>2];k[ba+28>>2]=k[a+28>>2];k[ba+32>>2]=k[a+32>>2];f=k[a+36>>2]|0;k[ba+36>>2]=f;$=ba+40|0;k[$>>2]=X;X=ba+48|0;n=ba+44|0;k[n>>2]=X;k[ba+52>>2]=0;k[X>>2]=0;if(f){b=f+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[q>>2]=0;x1(ba,b,0,0,0);if((k[q>>2]|0)>0){g=k[a+40>>2]|0;h=k[$>>2]|0;f=k[a+44>>2]|0;c=k[n>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[g+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else{W=k[a+44>>2]|0;X=k[n>>2]|0;k[X>>2]=k[W>>2];k[X+4>>2]=k[W+4>>2]}X=k[$>>2]|0;G=k[X>>2]|0;k[s>>2]=k[X+4>>2];k[s+4>>2]=G;x2(t,s,k[ba>>2]&4095,0);G=k[ba+8>>2]|0;X=ba+4|0;W=(k[X>>2]|0)==1?1:k[ba+12>>2]|0;I=k[ba>>2]|0;H=I&4095;V=ba+16|0;F=k[V>>2]|0;E=aa((I>>>3&511)+1<<(47696>>>(H<<1&14)&3),W)|0;k[w>>2]=H|1111638016;H=w+4|0;k[H>>2]=E;k[w+8>>2]=0;k[w+12>>2]=0;k[w+16>>2]=F;k[w+20>>2]=G;k[w+24>>2]=W;W=ba+44|0;k[H>>2]=k[k[W>>2]>>2];k[w>>2]=I&20479|1111621632;do if((k[t>>2]&2031616|0)==65536){g=k[u>>2]|0;k[Y>>2]=k[g>>2];q=Y+4|0;b=g+4|0;k[q>>2]=k[b>>2];a=Y+8|0;k[a>>2]=k[g+8>>2];s=Y+12|0;k[s>>2]=k[g+12>>2];t=Y+16|0;k[t>>2]=k[g+16>>2];k[Y+20>>2]=k[g+20>>2];k[Y+24>>2]=k[g+24>>2];k[Y+28>>2]=k[g+28>>2];k[Y+32>>2]=k[g+32>>2];v=Y+36|0;c=k[g+36>>2]|0;k[v>>2]=c;f=Y+40|0;k[f>>2]=a;I=Y+48|0;u=Y+44|0;k[u>>2]=I;k[Y+52>>2]=0;k[I>>2]=0;if(c|0){I=c+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[b>>2]|0)<3){c=k[g+44>>2]|0;g=k[u>>2]|0;k[g>>2]=k[c>>2];k[g+4>>2]=k[c+4>>2];g=a;c=s;f=Y;n=t;b=t;a=u;h=v;break}k[q>>2]=0;x1(Y,k[b>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[g+40>>2]|0;h=k[f>>2]|0;c=k[g+44>>2]|0;f=k[u>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[n+(b<<2)>>2];k[f+(b<<2)>>2]=k[c+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0));g=a;c=s;f=Y;n=t;b=t;a=u;h=v}else{g=a;c=s;f=Y;n=t;b=t;a=u;h=v}}else{Q1(Y,t,-1);b=Y+16|0;g=Y+8|0;q=Y+4|0;c=Y+12|0;f=Y;n=b;a=Y+44|0;h=Y+36|0}while(0);G=k[g>>2]|0;H=(k[q>>2]|0)==1?1:k[c>>2]|0;I=k[f>>2]|0;D=I&4095;F=k[b>>2]|0;E=aa((I>>>3&511)+1<<(47696>>>(D<<1&14)&3),H)|0;k[y>>2]=D|1111638016;b=y+4|0;k[b>>2]=E;k[y+8>>2]=0;k[y+12>>2]=0;k[y+16>>2]=F;k[y+20>>2]=G;k[y+24>>2]=H;k[b>>2]=k[k[a>>2]>>2];k[y>>2]=I&20479|1111621632;b=k[h>>2]|0;if(b|0?(H=b+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){f=Y+36|0;c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Y+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[h>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[q>>2]|0)>0){c=k[Y+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[q>>2]|0))}b=k[a>>2]|0;if(!((b|0)==(Y+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);I=G9(w,x,0,0)|0;H=G9(y,z,0,0)|0;if((k[H>>2]^k[I>>2])&4095|0?(k[Y>>2]=0,G=Y+4|0,k[G>>2]=0,A=ZT(8)|0,k[A>>2]=1,F=A+4|0,k[Y>>2]=F,k[G>>2]=0,i[F>>0]=0,Y8(-205,Y,339467,335515,6485),k[G>>2]=0,k[Y>>2]=0,G=k[A>>2]|0,k[A>>2]=G+-1,(G|0)==1):0)ggb(k[A+-4>>2]|0);if(d<=0.0){k[Y>>2]=0;b=Y+4|0;k[b>>2]=0;c=ZT(20)|0;k[c>>2]=1;f=c+4|0;k[Y>>2]=f;k[b>>2]=14;i[c+18>>0]=0;g=339478;h=f+14|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-211,Y,339467,335515,6488);k[b>>2]=0;k[Y>>2]=0;G=k[c>>2]|0;k[c>>2]=G+-1;if((G|0)==1)ggb(k[c+-4>>2]|0)}c=k[I+20>>2]|0;E=k[H+20>>2]|0;f=H+24|0;D=k[f>>2]|0;G=y9(E,D,5)|0;z9(G);if(!G)F=0;else{while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b+4>>2]=1;k[b>>2]=85876;k[b+8>>2]=G;F=b}C=y9(E,D,5)|0;z9(C);if(!C)B=0;else{while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b+4>>2]=1;k[b>>2]=85876;k[b+8>>2]=C;B=b}if(!(e&16)){n=Y+8|0;k[Y>>2]=n;a=Y+4|0;k[a>>2]=136;if(D>>>0>136){c=D>>>0>536870911?-1:D<<3;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[Y>>2]=b}else b=n;k[a>>2]=D;f=k[f>>2]|0;if((f|0)>0){c=0;do{m=+Z(+(+(c|0)/d));p[b+(c<<3)>>3]=m;c=c+1|0}while((c|0)!=(f|0))}if((E|0)>0?(J=+(E|0),K=k[G+16>>2]|0,L=k[G+4>>2]|0,M=k[C+16>>2]|0,N=k[C+4>>2]|0,O=l,(D|0)>0):0){c=0;do{m=+(c<<1|0)*3.141592653589793/J;l=+S(+m);m=+T(+m);g=K+(aa(L,c)|0)|0;h=M+(aa(N,c)|0)|0;f=0;do{d=+p[b+(f<<3)>>3];o[g+(f<<2)>>2]=l*d+O;o[h+(f<<2)>>2]=m*d+j;f=f+1|0}while((f|0)!=(D|0));c=c+1|0}while((c|0)!=(E|0))}if((b|0)!=(n|0)){ggb(b);k[Y>>2]=n;k[a>>2]=136}}else{m=+(c|0)/6.283185307179586;f=D<<2;z=U+8|0;k[U>>2]=z;A=U+4|0;k[A>>2]=264;if(f>>>0>264){c=f>>>0>1073741823?-1:f<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[U>>2]=b}else b=z;k[A>>2]=f;k[Y>>2]=1111638021;k[Y+4>>2]=f;k[Y+8>>2]=0;k[Y+12>>2]=0;k[Y+16>>2]=b;k[Y+20>>2]=1;k[Y+24>>2]=D;g=b+(D<<2)|0;k[P>>2]=1111638021;k[P+4>>2]=f;k[P+8>>2]=0;k[P+12>>2]=0;k[P+16>>2]=g;k[P+20>>2]=1;k[P+24>>2]=D;k[Q>>2]=1111638021;k[Q+4>>2]=f;k[Q+8>>2]=0;k[Q+12>>2]=0;k[Q+16>>2]=b+(D<<1<<2);k[Q+20>>2]=1;k[Q+24>>2]=D;k[R>>2]=1111638021;k[R+4>>2]=f;k[R+8>>2]=0;k[R+12>>2]=0;k[R+16>>2]=b+(D*3<<2);k[R+20>>2]=1;k[R+24>>2]=D;f=(D|0)>0;if(f){c=0;do{o[b+(c<<2)>>2]=+(c|0)-l;c=c+1|0}while((c|0)!=(D|0))}a:do if((E|0)>0){s=G+16|0;t=G+4|0;u=C+16|0;v=C+4|0;w=Q+16|0;x=R+16|0;y=P+16|0;if(f)b=0;else{b=0;while(1){l_(Y,P,Q,R);m_(Q,Q);b=b+1|0;if((b|0)>=(E|0))break a}}while(1){f=k[s>>2]|0;h=aa(k[t>>2]|0,b)|0;n=k[u>>2]|0;a=aa(k[v>>2]|0,b)|0;l=+(b|0)-j;c=0;do{o[g+(c<<2)>>2]=l;c=c+1|0}while((c|0)!=(D|0));q=f+h|0;h=n+a|0;l_(Y,P,Q,R);f=k[w>>2]|0;c=0;do{N=f+(c<<2)|0;o[N>>2]=+o[N>>2]+1.0;c=c+1|0}while((c|0)!=(D|0));m_(Q,Q);f=k[w>>2]|0;g=k[x>>2]|0;c=0;do{O=m*+o[g+(c<<2)>>2];o[q+(c<<2)>>2]=+o[f+(c<<2)>>2]*d;o[h+(c<<2)>>2]=O;c=c+1|0}while((c|0)!=(D|0));b=b+1|0;if((b|0)>=(E|0))break a;g=k[y>>2]|0}}while(0);b=k[U>>2]|0;if((b|0)!=(z|0)){if(b|0)ggb(b);k[U>>2]=z;k[A>>2]=264}};k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;k[_+16>>2]=0;k[_+20>>2]=0;k[_+24>>2]=0;k[_+28>>2]=0;k[Y>>2]=k[_>>2];k[Y+4>>2]=k[_+4>>2];k[Y+8>>2]=k[_+8>>2];k[Y+12>>2]=k[_+12>>2];k[Y+16>>2]=k[_+16>>2];k[Y+20>>2]=k[_+20>>2];k[Y+24>>2]=k[_+24>>2];k[Y+28>>2]=k[_+28>>2];poa(I,H,G,C,e,Y);b=B;if(B|0?(_=b+4|0,e=k[_>>2]|0,k[_>>2]=e+-1,(e|0)==1):0)Uh[k[(k[B>>2]|0)+8>>2]&2047](b);b=F;if(F|0?(_=b+4|0,e=k[_>>2]|0,k[_>>2]=e+-1,(e|0)==1):0)Uh[k[(k[F>>2]|0)+8>>2]&2047](b);f=ba+36|0;b=k[f>>2]|0;if(b|0?(_=b+12|0,e=k[_>>2]|0,k[_>>2]=e+-1,(e|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ba+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[X>>2]|0)>0){c=k[$>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[X>>2]|0))}b=k[W>>2]|0;if((b|0)==(ba+48|0)|(b|0)==0){r=ca;return}ggb(k[b+-4>>2]|0);r=ca;return}function Fl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=r;r=r+48|0;g=d+32|0;f=d+16|0;e=d;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;b=e+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=c;UZ(g,f,e);r=d;return}function Gl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0.0,h=0.0,j=0.0,l=0.0,m=0,n=0.0,o=0,q=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0;o=r;r=r+336|0;e=o+248|0;f=o+192|0;m=o;B=o+320|0;A=o+304|0;k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=a;k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=16842752;k[A+4>>2]=b;$oa(m,B,0);v=+p[m+160>>3];t=+p[m+176>>3];s=v+t;d=+p[m+168>>3];q=+p[m+184>>3];g=d+q;u=s*s;j=g*g;z=+p[m+144>>3];x=z*4.0;w=+p[m+136>>3];y=+p[m+152>>3];l=w+y;y=w-y;p[e>>3]=l;p[e+8>>3]=y*y+x*z;p[e+24>>3]=u+j;p[e+40>>3]=g*(s*x)+(u-j)*y;s=s*(u-j*3.0);j=g*(u*3.0-j);t=v-t*3.0;q=d*3.0-q;p[e+16>>3]=t*t+q*q;p[e+32>>3]=s*t+j*q;p[e+48>>3]=s*q-j*t;$oa(m,A,0);t=+p[m+160>>3];j=+p[m+176>>3];q=t+j;s=+p[m+168>>3];d=+p[m+184>>3];v=s+d;u=q*q;g=v*v;y=+p[m+144>>3];x=y*4.0;z=+p[m+136>>3];w=+p[m+152>>3];h=z+w;w=z-w;p[f>>3]=h;p[f+8>>3]=w*w+x*y;p[f+24>>3]=u+g;p[f+40>>3]=v*(q*x)+(u-g)*w;q=q*(u-g*3.0);g=v*(u*3.0-g);j=t-j*3.0;d=s*3.0-d;p[f+16>>3]=j*j+d*d;p[f+32>>3]=q*j+g*d;p[f+48>>3]=q*d-g*j;switch(c|0){case 1:{b=0;d=0.0;while(1){g=+P(+l);j=+P(+h);if(g>1.0e-05&j>1.0e-05){z=1.0/((l>0.0?1.0:l<0.0?-1.0:0.0)*+Pfb(g));d=d+ +P(+(1.0/((h>0.0?1.0:h<0.0?-1.0:0.0)*+Pfb(j))-z))}a=b+1|0;if((a|0)==7)break;b=a;l=+p[e+(a<<3)>>3];h=+p[f+(a<<3)>>3]}r=o;return +d}case 2:{b=0;d=0.0;while(1){g=+P(+l);j=+P(+h);if(g>1.0e-05&j>1.0e-05){z=(l>0.0?1.0:l<0.0?-1.0:0.0)*+Pfb(g);d=d+ +P(+((h>0.0?1.0:h<0.0?-1.0:0.0)*+Pfb(j)-z))}a=b+1|0;if((a|0)==7)break;b=a;l=+p[e+(a<<3)>>3];h=+p[f+(a<<3)>>3]}r=o;return +d}case 3:{b=0;d=0.0;while(1){g=+P(+l);j=+P(+h);if(g>1.0e-05&j>1.0e-05?(n=(l>0.0?1.0:l<0.0?-1.0:0.0)*+Pfb(g),n=+P(+((n-(h>0.0?1.0:h<0.0?-1.0:0.0)*+Pfb(j))/n)),d<n):0)d=n;a=b+1|0;if((a|0)==7)break;b=a;l=+p[e+(a<<3)>>3];h=+p[f+(a<<3)>>3]}r=o;return +d}default:{k[m>>2]=0;a=m+4|0;k[a>>2]=0;b=ZT(32)|0;k[b>>2]=1;c=b+4|0;k[m>>2]=c;k[a>>2]=25;i[b+29>>0]=0;e=340548;f=c+25|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));Y8(-5,m,340574,340586,143);k[a>>2]=0;k[m>>2]=0;B=k[b>>2]|0;k[b>>2]=B+-1;if((B|0)==1)ggb(k[b+-4>>2]|0);z=0.0;r=o;return +z}}return 0.0}function Hl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+64|0;j=f+48|0;i=f+32|0;h=f+16|0;g=f;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b;b=h+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=e;Xua(j,i,h,d,g);r=f;return}function Il(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=r;r=r+48|0;e=d+32|0;g=d+16|0;f=d;h=e+4|0;i=h+4|0;k[i>>2]=0;k[i+4>>2]=0;k[e>>2]=33619968;k[h>>2]=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;aU(g,f,e,49332,39872,0,14);r=d;return}function Jl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+32|0;f=d+16|0;e=d;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=c;u7(a,f,e);r=d;return}function Kl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=a;c=x6a(e,b,k[c>>2]|0,k[c+4>>2]|0,+p[c+8>>3])|0;r=d;return c|0}function Ll(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=r;r=r+64|0;i=e+48|0;h=e+32|0;g=e+16|0;f=e;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=a;a=h+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=b;b=g+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=c;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=d;v7(i,h,g,f);r=e;return}function Ml(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+32|0;f=d+16|0;e=d;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=a;a=e+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=b;vua(f,e,c);r=d;return}function Nl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=r;r=r+48|0;d=c+32|0;f=c+16|0;e=c;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=17104896;k[f+4>>2]=a;a=e+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=b;k[d>>2]=0;a=d+4|0;k[a>>2]=0;k[d+8>>2]=0;B2(f,d);b=k[d>>2]|0;a=k[a>>2]|0;GV((b|0)==(a|0)?0:b,(a-b|0)/56|0,e);zF(d);r=c;return}function Ol(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=r;r=r+48|0;e=d+32|0;g=d+16|0;f=d;h=e+4|0;i=h+4|0;k[i>>2]=0;k[i+4>>2]=0;k[e>>2]=33619968;k[h>>2]=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;aU(g,f,e,49332,39904,0,13);r=d;return}function Pl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0.0,g=0.0,h=0.0,j=0.0,l=0.0,m=0,n=0,p=0,q=0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,R=0.0,S=0.0,T=0.0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;$=r;r=r+1168|0;U=$+96|0;O=$+80|0;y=$+72|0;V=$+16|0;c=$;k[c+8>>2]=0;k[c+12>>2]=0;k[c>>2]=16842752;k[c+4>>2]=b;k[V>>2]=1124007936;Z=V+4|0;b=V+8|0;W=V+40|0;p=Z;s=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(s|0));k[W>>2]=b;_=V+48|0;X=V+44|0;k[X>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;L=U+4|0;K=L+4|0;k[K>>2]=0;k[K+4>>2]=0;k[U>>2]=33619968;k[L>>2]=V;Kea(c,U,1,1);if((k[V>>2]&7|0)!=5){k[U>>2]=1124007936;q=U+4|0;b=U+8|0;n=U+40|0;p=q;s=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(s|0));k[n>>2]=b;p=U+48|0;m=U+44|0;k[m>>2]=p;k[U+52>>2]=0;k[p>>2]=0;d=O+4|0;b=d+4|0;k[b>>2]=0;k[b+4>>2]=0;k[O>>2]=33619968;k[d>>2]=U;SW(V,O,5,1.0,0.0);KG(V,U)|0;d=U+36|0;b=k[d>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[U+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;L=U+16|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[q>>2]|0)>0){c=k[n>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[q>>2]|0))}b=k[m>>2]|0;if(!((b|0)==(p|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}H=y2(V,2,-1,1)|0;L=V+16|0;I=k[L>>2]|0;a:do if((H|0)>2){d=H*3|0;J=U+8|0;k[U>>2]=J;K=U+4|0;k[K>>2]=264;if(d>>>0>264){c=d>>>0>1073741823?-1:d<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[U>>2]=b}else b=J;k[K>>2]=d;G=b+(H<<2)|0;k[O>>2]=-1;k[O+4>>2]=-1;k[O+8>>2]=-1;k[O+12>>2]=-1;d=k[I>>2]|0;m=k[I+4>>2]|0;f=(k[u>>2]=d,+o[u>>2]);h=(k[u>>2]=m,+o[u>>2]);c=0;F=0;C=0;D=0;E=0;e=f;g=h;while(1){j=(k[u>>2]=d,+o[u>>2]);n=j<e;F=n?c:F;p=j>f;D=p?c:D;l=(k[u>>2]=m,+o[u>>2]);q=l>g;E=q?c:E;s=l<h;C=s?c:C;B=c;c=c+1|0;A=(c|0)<(H|0)?c:0;d=k[I+(A<<3)>>2]|0;m=k[I+(A<<3)+4>>2]|0;t=(k[u>>2]=d,+o[u>>2])-j;w=t;v=(k[u>>2]=m,+o[u>>2])-l;x=v;o[G+(B<<3)>>2]=t;o[G+(B<<3)+4>>2]=v;x=1.0/+Q(+(w*w+x*x));o[b+(B<<2)>>2]=x;if((c|0)==(H|0))break;else{e=n?j:e;f=p?j:f;g=q?l:g;h=s?l:h}}c=H+-1|0;e=+o[G+(c<<3)>>2];f=+o[G+(c<<3)+4>>2];c=0;while(1){x=e;e=+o[G+(c<<3)>>2];g=f;f=+o[G+(c<<3)+4>>2];g=x*f-g*e;c=c+1|0;if(g!=0.0){B=28;break}if((c|0)>=(H|0)){B=29;break}}if((B|0)==28)e=g>0.0?1.0:-1.0;else if((B|0)==29){k[y>>2]=0;c=y+4|0;k[c>>2]=0;d=ZT(24)|0;k[d>>2]=1;p=d+4|0;k[y>>2]=p;k[c>>2]=16;i[d+20>>0]=0;m=347699;s=p+16|0;do{i[p>>0]=i[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(s|0));Y8(-215,y,347716,347733,166);k[c>>2]=0;k[y>>2]=0;A=k[d>>2]|0;k[d>>2]=A+-1;if((A|0)==1)ggb(k[d+-4>>2]|0);e=0.0}k[O>>2]=C;y=O+4|0;k[y>>2]=D;z=O+8|0;k[z>>2]=E;A=O+12|0;k[A>>2]=F;s=0;g=0.0;l=3402823466385288598117041.0e14;p=0;t=0.0;v=0.0;w=0.0;q=0;x=0.0;n=C;m=D;d=E;c=F;b:while(1){f=(e*+o[G+(n<<3)>>2]+g*+o[G+(n<<3)+4>>2])*+o[b+(n<<2)>>2];j=(e*+o[G+(m<<3)+4>>2]-g*+o[G+(m<<3)>>2])*+o[b+(m<<2)>>2];F=j>f;f=F?j:f;j=(-(e*+o[G+(d<<3)>>2])-g*+o[G+(d<<3)+4>>2])*+o[b+(d<<2)>>2];d=j>f;F=(g*+o[G+(c<<3)>>2]-e*+o[G+(c<<3)+4>>2])*+o[b+(c<<2)>>2]>(d?j:f)?3:d?2:F&1;c=O+(F<<2)|0;d=k[c>>2]|0;g=+o[b+(d<<2)>>2];f=+o[G+(d<<3)>>2]*g;g=g*+o[G+(d<<3)+4>>2];switch(F&3){case 0:{e=f;break}case 1:{e=g;g=-f;break}case 2:{e=-f;g=-g;break}case 3:{e=-g;g=f;break}default:{B=37;break b}}m=d+1|0;k[c>>2]=(m|0)==(H|0)?0:m;m=k[y>>2]|0;c=k[A>>2]|0;h=e*(+o[I+(m<<3)>>2]-+o[I+(c<<3)>>2])+g*(+o[I+(m<<3)+4>>2]-+o[I+(c<<3)+4>>2]);d=k[z>>2]|0;n=k[O>>2]|0;j=e*(+o[I+(d<<3)+4>>2]-+o[I+(n<<3)+4>>2])-g*(+o[I+(d<<3)>>2]-+o[I+(n<<3)>>2]);f=h*j;if(!(f<=l)){f=l;N=p;P=t;R=v;S=w;M=q;T=x}else{N=c;P=h;R=g;S=j;M=n;T=e}s=s+1|0;if((s|0)>=(H|0))break;else{l=f;p=N;t=P;v=R;w=S;q=M;x=T}}g=-R;j=T*+o[I+(N<<3)>>2]+R*+o[I+(N<<3)+4>>2];l=+o[I+(M<<3)>>2]*g+T*+o[I+(M<<3)+4>>2];f=1.0/(T*T-R*g);h=f*(T*j-R*l);j=f*(T*l-j*g);l=P*T;f=R*P;g=S*g;e=S*T;b=k[U>>2]|0;if((b|0)!=(J|0)){if(b|0)ggb(b);k[U>>2]=J;k[K>>2]=264}o[a>>2]=h+(l+g)*.5;o[a+4>>2]=j+(f+e)*.5;T=l;S=f;P=+Q(+(T*T+S*S));o[a+8>>2]=P;P=g;R=e;R=+Q(+(P*P+R*R));o[a+12>>2]=R;T=+Y(+S,+T);o[a+16>>2]=T}else switch(H|0){case 2:{T=+o[I>>2];P=+o[I+8>>2];o[a>>2]=(T+P)*.5;S=+o[I+4>>2];R=+o[I+12>>2];o[a+4>>2]=(S+R)*.5;T=P-T;S=R-S;R=+Q(+(T*T+S*S));o[a+8>>2]=R;o[a+12>>2]=0.0;T=+Y(+S,+T);o[a+16>>2]=T;break a}case 1:{k[a>>2]=k[I>>2];k[a+4>>2]=k[I+4>>2];break a}default:break a}while(0);d=a+16|0;o[d>>2]=+o[d>>2]*180.0/3.141592653589793;d=V+36|0;b=k[d>>2]|0;if(b|0?(a=b+12|0,U=k[a>>2]|0,k[a>>2]=U+-1,(U|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[V+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[Z>>2]|0)>0){c=k[W>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Z>>2]|0))}b=k[X>>2]|0;if((b|0)==(_|0)|(b|0)==0){r=$;return}ggb(k[b+-4>>2]|0);r=$;return}function Ql(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0.0;Pa=r;r=r+208|0;Ka=Pa+32|0;na=Pa+16|0;oa=Pa;pa=Pa+192|0;wa=Pa+184|0;Da=Pa+176|0;Ha=Pa+168|0;Ia=Pa+160|0;ja=Pa+136|0;ka=Pa+128|0;la=Pa+120|0;ma=Pa+112|0;Na=Pa+100|0;La=Pa+88|0;Ja=Pa+144|0;Oa=Ja+4+4|0;k[Oa>>2]=0;k[Oa+4>>2]=0;k[Ja>>2]=33619968;k[Ja+4>>2]=b;k[Na>>2]=0;Oa=Na+4|0;k[Oa>>2]=0;k[Na+8>>2]=0;k[La>>2]=0;Ma=La+4|0;k[Ma>>2]=0;k[La+8>>2]=0;k[Ka>>2]=k[a>>2];h=Ka+4|0;c=a+4|0;b=k[c>>2]|0;k[h>>2]=b;ha=Ka+8|0;k[ha>>2]=k[a+8>>2];k[Ka+12>>2]=k[a+12>>2];k[Ka+16>>2]=k[a+16>>2];k[Ka+20>>2]=k[a+20>>2];k[Ka+24>>2]=k[a+24>>2];k[Ka+28>>2]=k[a+28>>2];k[Ka+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[Ka+36>>2]=d;e=Ka+40|0;k[e>>2]=ha;ha=Ka+48|0;g=Ka+44|0;k[g>>2]=ha;k[Ka+52>>2]=0;k[ha>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[h>>2]=0;x1(Ka,b,0,0,0);if((k[h>>2]|0)>0){f=k[a+40>>2]|0;e=k[e>>2]|0;d=k[a+44>>2]|0;c=k[g>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else{ga=k[a+44>>2]|0;ha=k[g>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2]}k[na>>2]=0;e=na+4|0;k[e>>2]=0;k[na+8>>2]=0;if(!((y2(Ka,2,-1,1)|0)>0?(k[Ka>>2]&6|0)==4:0)){k[oa>>2]=0;b=oa+4|0;k[b>>2]=0;c=ZT(104)|0;k[c>>2]=1;h=c+4|0;k[oa>>2]=h;k[b>>2]=98;i[c+102>>0]=0;j=340661;l=h+98|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,oa,340760,340777,340);k[b>>2]=0;k[oa>>2]=0;ha=k[c>>2]|0;k[c>>2]=ha+-1;if((ha|0)==1)ggb(k[c+-4>>2]|0)}b=oa+4|0;c=b+4|0;k[c>>2]=0;k[c+4>>2]=0;k[oa>>2]=-2113732595;k[b>>2]=na;SW(Ka,oa,5,1.0,0.0);k[oa+8>>2]=0;k[oa+12>>2]=0;k[oa>>2]=-2130509811;k[oa+4>>2]=na;b=pa+4|0;c=b+4|0;k[c>>2]=0;k[c+4>>2]=0;k[pa>>2]=-2113732595;k[b>>2]=La;Kea(oa,pa,1,1);b=k[na>>2]|0;c=b;if(b|0){d=k[e>>2]|0;if((d|0)!=(b|0))k[e>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(b)}d=Ka+36|0;b=k[d>>2]|0;if(b|0?(ga=b+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Ka+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;ha=Ka+16|0;c=Ka+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[c>>2]|0)>0){d=k[Ka+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[Ka+44>>2]|0;if(!((b|0)==(Ka+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Na>>2]|0;c=k[Oa>>2]|0;if((c|0)==(b|0))c=b;else{c=c+(~((c+-8-b|0)>>>3)<<3)|0;k[Oa>>2]=c}e=k[La>>2]|0;ha=(k[Ma>>2]|0)-e>>3;do if(ha>>>0>3){o[Da>>2]=0.0;T=Da+4|0;o[T>>2]=0.0;o[Ha>>2]=0.0;U=Ha+4|0;o[U>>2]=0.0;o[Ia>>2]=0.0;V=Ia+4|0;o[V>>2]=0.0;o[ja>>2]=0.0;W=ja+4|0;o[W>>2]=0.0;o[ka>>2]=0.0;X=ka+4|0;o[X>>2]=0.0;o[la>>2]=0.0;Z=la+4|0;o[Z>>2]=0.0;o[ma>>2]=0.0;_=ma+4|0;o[_>>2]=0.0;$=Ka+4|0;aa=Ka+4|0;ba=Ka+4|0;ca=pa+4|0;da=wa+4|0;ea=Ka+4|0;fa=Na+8|0;ga=Ka+4|0;s=1797693134862315708145274.0e284;c=0;f=2;a=1;d=e;while(1){x=+o[d+(c<<3)>>2];y=+o[d+(c<<3)+4>>2];n=((c|0)==0?ha:c)+-1|0;z=+o[d+(n<<3)>>2]-x;A=+o[d+(n<<3)+4>>2]-y;B=+Q(+(z*z+A*A));if(!(B!=0.0)){ia=38;break}b=f;C=+o[d+(f<<3)+4>>2];v=+o[d+(f<<3)>>2];while(1){e=((b+1|0)>>>0)%(ha>>>0)|0;w=v;v=+o[d+(e<<3)>>2];S=C;C=+o[d+(e<<3)+4>>2];t=+P(+(z*(y-C)-A*(x-v)))/B;w=+P(+(z*(y-S)-A*(x-w)))/B;if(t>w){b=e;continue}O=+P(+(t-w));S=+P(+t);R=+P(+w);S=S>1.0?S:1.0;if(!(O<=(S<R?R:S)*1.0e-05))break;else b=e}o[Ka>>2]=0.0;o[$>>2]=0.0;a:while(1){while(1){O=+o[d+(c<<3)>>2];M=+o[d+(c<<3)+4>>2];L=+o[d+(n<<3)>>2]-O;N=+o[d+(n<<3)+4>>2]-M;S=+Q(+(L*L+N*N));q=S!=0.0;R=+P(+(L*(M-+o[d+(b<<3)+4>>2])-N*(O-+o[d+(b<<3)>>2])))/S;S=+P(+(L*(M-+o[d+(a<<3)+4>>2])-N*(O-+o[d+(a<<3)>>2])))/S;if(!((q?R:0.0)>(q?S:0.0)))break a;if(!(Voa(a,Ka,La,ha,a,c)|0)){ia=43;break}d=k[La>>2]|0;S=+Y(+(+o[$>>2]-+o[d+(b<<3)+4>>2]),+(+o[Ka>>2]-+o[d+(b<<3)>>2]))*180.0/3.141592653589793;if((Woa(S<0.0?S+360.0:S,b,d,ha,c)|0)!=1)break;b=((b+1|0)>>>0)%(ha>>>0)|0}if((ia|0)==43){ia=0;d=k[La>>2]|0}a=((a+1|0)>>>0)%(ha>>>0)|0}o[Ka>>2]=0.0;o[aa>>2]=0.0;b:do if(Voa(b,Ka,La,ha,a,c)|0){e=((a|0)==0?ha:a)+-1|0;do{d=k[La>>2]|0;t=+o[d+(b<<3)>>2];v=+o[d+(b<<3)+4>>2];S=+Y(+(+o[aa>>2]-v),+(+o[Ka>>2]-t))*180.0/3.141592653589793;if((Woa(S<0.0?S+360.0:S,b,d,ha,c)|0)!=1)break b;R=+o[d+(c<<3)>>2];N=+o[d+(c<<3)+4>>2];M=+o[d+(n<<3)>>2]-R;O=+o[d+(n<<3)+4>>2]-N;S=+Q(+(M*M+O*O));ia=S!=0.0;v=+P(+((N-v)*M-(R-t)*O))/S;v=ia?v:0.0;t=+P(+(M*(N-+o[d+(e<<3)+4>>2])-O*(R-+o[d+(e<<3)>>2])))/S;t=ia?t:0.0;if(!(v>t)?(O=+P(+(v-t)),S=+P(+v),R=+P(+t),S=S>1.0?S:1.0,!(O<=(S<R?R:S)*1.0e-05)):0)break b;b=((b+1|0)>>>0)%(ha>>>0)|0}while(Voa(b,Ka,La,ha,a,c)|0)}while(0);f=k[La>>2]|0;d=k[f+(n<<3)>>2]|0;k[la>>2]=d;h=k[f+(n<<3)+4>>2]|0;k[Z>>2]=h;j=k[f+(c<<3)>>2]|0;k[ma>>2]=j;l=k[f+(c<<3)+4>>2]|0;k[_>>2]=l;q=((a|0)==0?ha:a)+-1|0;e=k[f+(q<<3)>>2]|0;m=k[f+(q<<3)+4>>2]|0;g=k[f+(a<<3)>>2]|0;f=k[f+(a<<3)+4>>2]|0;o[Ka>>2]=0.0;o[ba>>2]=0.0;ia=Voa(b,Ka,La,ha,a,c)|0;N=(k[u>>2]=d,+o[u>>2]);O=(k[u>>2]=h,+o[u>>2]);R=(k[u>>2]=j,+o[u>>2]);S=(k[u>>2]=l,+o[u>>2]);if(ia){d=k[La>>2]|0;v=+o[d+(b<<3)>>2];t=+o[d+(b<<3)+4>>2];M=+Y(+(t-+o[ba>>2]),+(v-+o[Ka>>2]))*180.0/3.141592653589793;if((Woa(M<0.0?M+360.0:M,b,d,ha,c)|0)==2)ia=57;else ia=56}else{ia=k[La>>2]|0;d=ia;t=+o[ia+(b<<3)+4>>2];v=+o[ia+(b<<3)>>2];ia=56}if((ia|0)==56){ia=0;K=+o[d+(c<<3)>>2];I=+o[d+(c<<3)+4>>2];H=+o[d+(n<<3)>>2]-K;J=+o[d+(n<<3)+4>>2]-I;M=+Q(+(H*H+J*J));l=M!=0.0;L=+P(+((I-t)*H-(K-v)*J))/M;M=+P(+(H*(I-+o[d+(q<<3)+4>>2])-J*(K-+o[d+(q<<3)>>2])))/M;if((l?L:0.0)<(l?M:0.0))ia=57;else{if(!(Voa(b,ja,La,ha,a,c)|0)){k[Ka>>2]=0;k[ga>>2]=0;d=ZT(92)|0;k[d>>2]=1;h=d+4|0;k[Ka>>2]=h;k[ga>>2]=87;i[d+91>>0]=0;j=340991;l=h+87|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-3,Ka,341079,340777,641);k[ga>>2]=0;k[Ka>>2]=0;n=k[d>>2]|0;k[d>>2]=n+-1;if((n|0)==1)ggb(k[d+-4>>2]|0)}h=k[La>>2]|0;j=k[h+(b<<3)>>2]|0;k[ka>>2]=j;d=k[h+(b<<3)+4>>2]|0;k[X>>2]=d;K=(k[u>>2]=j,+o[u>>2]);j=1;M=+o[ja>>2];L=+o[W>>2];J=(k[u>>2]=d,+o[u>>2]);d=m}}if((ia|0)==57){ia=0;h=((b|0)==0?ha:b)+-1|0;Qa=k[d+(h<<3)>>2]|0;k[ja>>2]=Qa;h=k[d+(h<<3)+4>>2]|0;k[W>>2]=h;j=k[d+(b<<3)>>2]|0;k[ka>>2]=j;l=k[d+(b<<3)+4>>2]|0;k[X>>2]=l;t=(k[u>>2]=e,+o[u>>2]);v=(k[u>>2]=m,+o[u>>2]);D=(k[u>>2]=Qa,+o[u>>2]);E=(k[u>>2]=h,+o[u>>2]);F=(k[u>>2]=j,+o[u>>2]);G=(k[u>>2]=l,+o[u>>2]);w=G-E;x=D-F;y=E*x+D*w;z=S-O;A=N-R;B=O*A+N*z;C=A*w-z*x;M=+P(+C);if((!(M<=(M>1.0?M:1.0)*1.0e-05)?(qa=(k[u>>2]=f,+o[u>>2]),qa=qa-v,ra=t-(k[u>>2]=g,+o[u>>2]),sa=v*ra+t*qa,ta=ra*w-qa*x,M=+P(+ta),!(M<=(M>1.0?M:1.0)*1.0e-05)):0)?(K=+o[d+(c<<3)>>2],I=+o[d+(c<<3)+4>>2],H=+o[d+(n<<3)>>2]-K,J=+o[d+(n<<3)+4>>2]-I,M=+Q(+(H*H+J*J)),Qa=M!=0.0,L=+P(+((I-((sa*w-qa*y)/ta+(B*w-z*y)/C)*.5)*H-(K-((ra*y-sa*x)/ta+(A*y-B*x)/C)*.5)*J))/M,ua=+o[d+(q<<3)>>2],va=+o[d+(q<<3)+4>>2],M=+P(+(H*(I-va)-J*(K-ua)))/M,(Qa?L:0.0)<(Qa?M:0.0)):0){f=(o[u>>2]=ua,k[u>>2]|0);d=(o[u>>2]=va,k[u>>2]|0);o[pa>>2]=0.0;o[ca>>2]=0.0;o[wa>>2]=0.0;o[da>>2]=0.0;if(!(Xoa(La,ha,c,q,ja,ka,la,ma,pa,wa)|0)){k[Ka>>2]=0;k[ea>>2]=0;e=ZT(116)|0;k[e>>2]=1;h=e+4|0;k[Ka>>2]=h;k[ea>>2]=110;i[e+114>>0]=0;j=340861;l=h+110|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-3,Ka,340972,340777,964);k[ea>>2]=0;k[Ka>>2]=0;Qa=k[e>>2]|0;k[e>>2]=Qa+-1;if((Qa|0)==1)ggb(k[e+-4>>2]|0)}Qa=c+1|0;Qa=(Qa|0)==(ha|0)?0:Qa;g=k[La>>2]|0;Yoa(g+(c<<3)|0,g+(n<<3)|0,Ka,na,oa);J=+p[Ka>>3];M=+o[pa>>2];L=+p[na>>3];t=+o[ca>>2];I=+p[oa>>3];K=I+(J*M+L*t);L=I+(J*+o[g+(Qa<<3)>>2]+L*+o[g+(Qa<<3)+4>>2]);Qa=((K>0.0?1:(K<0.0)<<31>>31)|0)==((L>0.0?1:(L<0.0)<<31>>31)|0);g=(o[u>>2]=M,k[u>>2]|0);j=0;h=k[La>>2]|0;M=D;L=E;K=F;J=G;g=Qa?g:k[wa>>2]|0;e=f;f=Qa?(o[u>>2]=t,k[u>>2]|0):k[da>>2]|0}else{j=2;h=d;M=D;L=E;K=F;J=G;d=m}}F=(k[u>>2]=e,+o[u>>2]);E=(k[u>>2]=d,+o[u>>2]);B=(k[u>>2]=g,+o[u>>2]);z=(k[u>>2]=f,+o[u>>2]);t=z-E;A=F-B;v=F*t+E*A;x=J-L;G=M-K;y=M*x+L*G;w=G*t-x*A;I=+P(+w);do if((!(I<=(I>1.0?I:1.0)*1.0e-05)?(xa=(G*v-y*A)/w,o[Ia>>2]=xa,ya=(y*t-x*v)/w,o[V>>2]=ya,za=S-O,Aa=N-R,Ba=O*Aa+N*za,Ca=Aa*t-za*A,I=+P(+Ca),!(I<=(I>1.0?I:1.0)*1.0e-05)):0)?(Ea=(Aa*v-Ba*A)/Ca,o[Ha>>2]=Ea,Fa=(Ba*t-za*v)/Ca,o[U>>2]=Fa,Ga=Aa*x-za*G,I=+P(+Ga),!(I<=(I>1.0?I:1.0)*1.0e-05)):0){I=(Aa*y-Ba*G)/Ga;o[Da>>2]=I;H=(Ba*x-za*y)/Ga;o[T>>2]=H;v=(Ea+xa)*.5;w=(Fa+ya)*.5;x=(I+xa)*.5;y=(H+ya)*.5;C=(I+Ea)*.5;D=(H+Fa)*.5;do if(!j){E=+o[h+(q<<3)>>2];t=+o[h+(q<<3)+4>>2];B=+P(+(v-E));F=+P(+v);E=+P(+E);F=F>1.0?F:1.0;if(!(B<=(F<E?E:F)*1.0e-05)){d=0;ia=79;break}B=+P(+(w-t));F=+P(+w);E=+P(+t);F=F>1.0?F:1.0;d=B<=(F<E?E:F)*1.0e-05;ia=79}else{Ra=v-F;t=w-E;B=v-B;F=w-z;E=E-z;E=+Q(+(E*E+A*A));F=+Q(+(Ra*Ra+t*t))+ +Q(+(B*B+F*F));B=+P(+(F-E));F=+P(+F);E=+P(+E);F=F>1.0?F:1.0;d=B<=(F<E?E:F)*1.0e-05;if((j|0)!=1){ia=79;break}M=+o[h+(b<<3)>>2];t=+o[h+(b<<3)+4>>2];L=+P(+(x-M));Ra=+P(+x);M=+P(+M);Ra=Ra>1.0?Ra:1.0;if(!(L<=(Ra<M?M:Ra)*1.0e-05)){e=0;break}L=+P(+(y-t));Ra=+P(+y);M=+P(+t);Ra=Ra>1.0?Ra:1.0;e=L<=(Ra<M?M:Ra)*1.0e-05}while(0);if((ia|0)==79){ia=0;E=x-M;F=y-L;K=x-K;Ra=y-J;M=L-J;M=+Q(+(M*M+G*G));Ra=+Q(+(E*E+F*F))+ +Q(+(K*K+Ra*Ra));L=+P(+(Ra-M));Ra=+P(+Ra);M=+P(+M);Ra=Ra>1.0?Ra:1.0;e=L<=(Ra<M?M:Ra)*1.0e-05}M=C-N;N=D-O;R=C-R;Ra=D-S;S=O-S;S=+Q(+(Aa*Aa+S*S));Ra=+Q(+(M*M+N*N))+ +Q(+(R*R+Ra*Ra));R=+P(+(Ra-S));Ra=+P(+Ra);S=+P(+S);Ra=Ra>1.0?Ra:1.0;if(d&(e&R<=(Ra<S?S:Ra)*1.0e-05)){t=+P(+(Ea*ya+(I*Fa+H*xa)-(H*Ea+(Fa*xa+I*ya))))*.5;if(!(t<s))break;d=k[Na>>2]|0;e=k[Oa>>2]|0;if((e|0)==(d|0))e=d;else{e=e+(~((e+-8-d|0)>>>3)<<3)|0;k[Oa>>2]=e}d=k[fa>>2]|0;if((e|0)==(d|0)){dga(Na,Da);e=k[Oa>>2]|0;d=k[fa>>2]|0}else{o[e>>2]=I;o[e+4>>2]=H;e=e+8|0;k[Oa>>2]=e}if((e|0)==(d|0)){dga(Na,Ha);e=k[Oa>>2]|0;d=k[fa>>2]|0}else{o[e>>2]=Ea;o[e+4>>2]=Fa;e=e+8|0;k[Oa>>2]=e}if((e|0)==(d|0)){dga(Na,Ia);s=t;break}else{o[e>>2]=xa;o[e+4>>2]=ya;k[Oa>>2]=e+8;s=t;break}}}while(0);c=c+1|0;if(c>>>0>=ha>>>0){ia=95;break}f=b;d=k[La>>2]|0}if((ia|0)==38)while(1)ia=38;else if((ia|0)==95){a=k[Na>>2]|0;break}}else{a=Na+8|0;b=e;d=k[a>>2]|0;if((c|0)==(d|0)){dga(Na,b);b=k[La>>2]|0;f=k[Oa>>2]|0;d=k[a>>2]|0}else{k[c>>2]=k[e>>2];k[c+4>>2]=k[b+4>>2];f=c+8|0;k[Oa>>2]=f}c=(ha|0)!=1&1;e=b+(c<<3)|0;if((f|0)==(d|0)){dga(Na,e);e=k[La>>2]|0;f=k[Oa>>2]|0;d=k[a>>2]|0}else{k[f>>2]=k[e>>2];k[f+4>>2]=k[b+(c<<3)+4>>2];f=f+8|0;k[Oa>>2]=f;e=b}b=2%(ha>>>0)|0;c=e+(b<<3)|0;if((f|0)==(d|0))dga(Na,c);else{k[f>>2]=k[c>>2];k[f+4>>2]=k[e+(b<<3)+4>>2];k[Oa>>2]=f+8}a=k[Na>>2]|0;Ra=+o[a>>2];Ca=+o[a+4>>2];Ea=+o[a+8>>2];Fa=+o[a+12>>2];Ga=+o[a+16>>2];s=+o[a+20>>2];s=+P(+(Ra*Fa+Ca*Ga+Ea*s-(Ca*Ea+(Fa*Ga+Ra*s))))*.5}while(0);k[Ka>>2]=1124024333;m=Ka+4|0;k[m>>2]=2;q=Ka+8|0;Qa=k[Oa>>2]|0;b=Qa-a|0;k[q>>2]=b>>3;k[Ka+12>>2]=1;h=Ka+16|0;k[h>>2]=0;c=Ka+20|0;k[c>>2]=0;d=Ka+24|0;k[d>>2]=0;g=Ka+32|0;k[g>>2]=0;j=Ka+36|0;k[j>>2]=0;l=Ka+40|0;k[l>>2]=q;q=Ka+48|0;n=Ka+44|0;k[n>>2]=q;e=Ka+52|0;k[e>>2]=0;k[q>>2]=0;f=a;if((f|0)!=(Qa|0)){k[e>>2]=8;k[q>>2]=8;k[h>>2]=f;k[c>>2]=f;Qa=a+b|0;k[d>>2]=Qa;k[Ka+28>>2]=Qa}mY(Ka,Ja);b=k[j>>2]|0;if(b|0?(Ka=b+12|0,Qa=k[Ka>>2]|0,k[Ka>>2]=Qa+-1,(Qa|0)==1):0){c=k[j>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[g>>2]|0;if(!b){b=B1()|0;c=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[j>>2]=0}k[j>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[m>>2]|0)>0){c=k[l>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[n>>2]|0;if(!((b|0)==(q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[La>>2]|0;c=b;if(b|0){d=k[Ma>>2]|0;if((d|0)!=(b|0))k[Ma>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(b)}b=k[Na>>2]|0;if(!b){r=Pa;return +s}c=k[Oa>>2]|0;if((c|0)!=(b|0))k[Oa>>2]=c+(~((c+-8-b|0)>>>3)<<3);ggb(b);r=Pa;return +s}function Rl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=r;r=r+1536|0;E=G+72|0;F=G;p=G+56|0;k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=17104896;k[p+4>>2]=a;D=c+4|0;if((k[c>>2]|0)==(k[D>>2]|0)){r=G;return}a=k[b>>2]&2031616;a:do if((a|0)>=327680)if((a|0)<720896)switch(a|0){case 327680:{a=4;break a}default:{a=3;break a}}else switch(a|0){case 720896:{a=4;break a}default:{a=3;break a}}else switch(a|0){case 262144:{a=4;break}default:a=3}while(0);if((a|0)==3){s=1;B=F2(p)|0;C=1}else if((a|0)==4){B=F2(p)|0;s=0;C=F2(b)|0}h=(B|0)>0;o=(C|0)>0;if(!(o&(h&((k[D>>2]|0)-(k[c>>2]|0)&4|0)==0))){k[E>>2]=0;a=E+4|0;k[a>>2]=0;d=ZT(52)|0;k[d>>2]=1;e=d+4|0;k[E>>2]=e;k[a>>2]=44;i[d+48>>0]=0;f=210364;g=e+44|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,E,210246,209965,658);k[a>>2]=0;k[E>>2]=0;A=k[d>>2]|0;k[d>>2]=A+-1;if((A|0)==1)ggb(k[d+-4>>2]|0)}NV(E,C+B|0);A=k[E>>2]|0;if(h){f=F+4|0;g=F+16|0;h=F+32|0;j=F+36|0;l=F+40|0;m=F+48|0;n=F+44|0;e=0;do{Q1(F,p,e);KG(A+(e*56|0)|0,F)|0;a=k[j>>2]|0;if(a|0?(y=a+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){d=k[j>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[h>>2]|0;if(!a){a=B1()|0;d=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[j>>2]=0}k[j>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[f>>2]|0)>0){d=k[l>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[n>>2]|0;if(!((a|0)==(m|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=e+1|0}while((e|0)<(B|0))}b:do if(o){j=b+4|0;t=F+4|0;l=F+8|0;m=F+12|0;u=F+16|0;n=F+20|0;o=F+24|0;p=F+28|0;v=F+32|0;w=F+36|0;x=F+40|0;y=F+48|0;z=F+44|0;q=F+52|0;if(s)h=0;else{e=0;while(1){Q1(F,b,e);KG(A+((e+B|0)*56|0)|0,F)|0;a=k[w>>2]|0;if(a|0?(q=a+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){d=k[w>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[v>>2]|0;if(!a){a=B1()|0;d=k[w>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[w>>2]=0}k[w>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[t>>2]|0)>0){d=k[x>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[t>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(y|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=e+1|0;if((e|0)>=(C|0))break b}}do{do if((k[b>>2]&2031616|0)==65536){e=k[j>>2]|0;k[F>>2]=k[e>>2];a=e+4|0;k[t>>2]=k[a>>2];k[l>>2]=k[e+8>>2];k[m>>2]=k[e+12>>2];k[u>>2]=k[e+16>>2];k[n>>2]=k[e+20>>2];k[o>>2]=k[e+24>>2];k[p>>2]=k[e+28>>2];k[v>>2]=k[e+32>>2];d=k[e+36>>2]|0;k[w>>2]=d;k[x>>2]=l;k[z>>2]=y;k[q>>2]=0;k[y>>2]=0;if(d|0){s=d+12|0;k[s>>2]=(k[s>>2]|0)+1}if((k[a>>2]|0)<3){g=k[e+44>>2]|0;s=k[z>>2]|0;k[s>>2]=k[g>>2];k[s+4>>2]=k[g+4>>2];break}k[t>>2]=0;x1(F,k[a>>2]|0,0,0,0);if((k[t>>2]|0)>0){f=k[e+40>>2]|0;g=k[x>>2]|0;d=k[e+44>>2]|0;e=k[z>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[f+(a<<2)>>2];k[e+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[t>>2]|0))}}else Q1(F,b,-1);while(0);KG(A+((h+B|0)*56|0)|0,F)|0;a=k[w>>2]|0;if(a|0?(g=a+12|0,s=k[g>>2]|0,k[g>>2]=s+-1,(s|0)==1):0){d=k[w>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[v>>2]|0;if(!a){a=B1()|0;d=k[w>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[w>>2]=0}k[w>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[t>>2]|0)>0){d=k[x>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[t>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(y|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=h+1|0}while((h|0)<(C|0))}while(0);F=k[c>>2]|0;HV(A,B,A+(B*56|0)|0,C,F,(k[D>>2]|0)-F>>2>>>1);OV(E);r=G;return}function Sl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b;$oa(a,e,c);r=d;return}function Tl(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;_=r;r=r+1008|0;M=_+224|0;L=_;E=_+984|0;Z=_+896|0;o=_+888|0;p=_+880|0;X=_+824|0;W=_+768|0;v=_+760|0;V=_+704|0;U=_+648|0;T=_+592|0;S=_+536|0;N=_+480|0;F=_+464|0;G=_+448|0;s=_+968|0;w=_+952|0;k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;t=s+4|0;k[t>>2]=a;u=w+4|0;D=w+4+4|0;k[D>>2]=0;k[D+4>>2]=0;k[w>>2]=33619968;k[u>>2]=b;D=k[e>>2]|0;C=k[e+4>>2]|0;k[Z>>2]=k[d>>2];n=Z+4|0;b=d+4|0;a=k[b>>2]|0;k[n>>2]=a;R=Z+8|0;k[R>>2]=k[d+8>>2];k[Z+12>>2]=k[d+12>>2];Y=Z+16|0;k[Y>>2]=k[d+16>>2];k[Z+20>>2]=k[d+20>>2];k[Z+24>>2]=k[d+24>>2];k[Z+28>>2]=k[d+28>>2];k[Z+32>>2]=k[d+32>>2];e=k[d+36>>2]|0;k[Z+36>>2]=e;j=Z+40|0;k[j>>2]=R;R=Z+48|0;m=Z+44|0;k[m>>2]=R;k[Z+52>>2]=0;k[R>>2]=0;if(e){a=e+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[b>>2]|0}if((a|0)>=3){k[n>>2]=0;x1(Z,a,0,0,0);if((k[n>>2]|0)>0){l=k[d+40>>2]|0;j=k[j>>2]|0;e=k[d+44>>2]|0;b=k[m>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[l+(a<<2)>>2];k[b+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else{Q=k[d+44>>2]|0;R=k[m>>2]|0;k[R>>2]=k[Q>>2];k[R+4>>2]=k[Q+4>>2]}if(k[Y>>2]|0){e=k[Z+4>>2]|0;if((e|0)<3)a=aa(k[Z+12>>2]|0,k[Z+8>>2]|0)|0;else{j=k[Z+40>>2]|0;b=0;a=1;do{a=aa(k[j+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(e|0))}if(!a)q=14}else q=14;if((q|0)==14){k[o>>2]=3;k[o+4>>2]=3;k[p>>2]=1;k[p+4>>2]=1;Cra(M,0,o,p);KG(Z,M)|0;e=M+36|0;a=k[e>>2]|0;if(a|0?(Q=a+12|0,R=k[Q>>2]|0,k[Q>>2]=R+-1,(R|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[M+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;R=M+16|0;b=M+4|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[b>>2]|0)>0){e=k[M+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[M+44>>2]|0;if(!((a|0)==(M+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}do if((k[s>>2]&2031616|0)==65536){e=k[t>>2]|0;k[X>>2]=k[e>>2];d=X+4|0;a=e+4|0;k[d>>2]=k[a>>2];R=X+8|0;k[R>>2]=k[e+8>>2];k[X+12>>2]=k[e+12>>2];k[X+16>>2]=k[e+16>>2];k[X+20>>2]=k[e+20>>2];k[X+24>>2]=k[e+24>>2];k[X+28>>2]=k[e+28>>2];k[X+32>>2]=k[e+32>>2];b=k[e+36>>2]|0;k[X+36>>2]=b;n=X+40|0;k[n>>2]=R;R=X+48|0;j=X+44|0;k[j>>2]=R;k[X+52>>2]=0;k[R>>2]=0;if(b|0){R=b+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[a>>2]|0)<3){R=k[e+44>>2]|0;p=k[j>>2]|0;k[p>>2]=k[R>>2];k[p+4>>2]=k[R+4>>2];p=X;break}k[d>>2]=0;x1(X,k[a>>2]|0,0,0,0);if((k[d>>2]|0)>0){l=k[e+40>>2]|0;m=k[n>>2]|0;e=k[e+44>>2]|0;b=k[j>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[l+(a<<2)>>2];k[b+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[d>>2]|0));p=X}else p=X}else{Q1(X,s,-1);n=X+40|0;p=X}while(0);k[W>>2]=1124007936;Q=W+4|0;a=W+8|0;O=W+40|0;j=Q;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[O>>2]=a;R=W+48|0;P=W+44|0;k[P>>2]=R;k[W+52>>2]=0;k[R>>2]=0;J=k[n>>2]|0;K=k[J>>2]|0;k[v>>2]=k[J+4>>2];k[v+4>>2]=K;x2(w,v,k[p>>2]&4095,0);do if((k[w>>2]&2031616|0)==65536){j=k[u>>2]|0;k[V>>2]=k[j>>2];o=V+4|0;a=j+4|0;k[o>>2]=k[a>>2];K=V+8|0;k[K>>2]=k[j+8>>2];k[V+12>>2]=k[j+12>>2];k[V+16>>2]=k[j+16>>2];k[V+20>>2]=k[j+20>>2];k[V+24>>2]=k[j+24>>2];k[V+28>>2]=k[j+28>>2];k[V+32>>2]=k[j+32>>2];b=k[j+36>>2]|0;k[V+36>>2]=b;e=V+40|0;k[e>>2]=K;K=V+48|0;m=V+44|0;k[m>>2]=K;k[V+52>>2]=0;k[K>>2]=0;if(b|0){K=b+12|0;k[K>>2]=(k[K>>2]|0)+1}if((k[a>>2]|0)<3){J=k[j+44>>2]|0;K=k[m>>2]|0;k[K>>2]=k[J>>2];k[K+4>>2]=k[J+4>>2];break}k[o>>2]=0;x1(V,k[a>>2]|0,0,0,0);if((k[o>>2]|0)>0){d=k[j+40>>2]|0;l=k[e>>2]|0;e=k[j+44>>2]|0;b=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[d+(a<<2)>>2];k[b+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[o>>2]|0))}}else Q1(V,w,-1);while(0);k[U>>2]=1124007936;J=U+4|0;a=U+8|0;H=U+40|0;j=J;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[H>>2]=a;K=U+48|0;I=U+44|0;k[I>>2]=K;k[U+52>>2]=0;k[K>>2]=0;k[T>>2]=1124007936;A=T+4|0;a=T+8|0;y=T+40|0;j=A;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[y>>2]=a;B=T+48|0;z=T+44|0;k[z>>2]=B;k[T+52>>2]=0;k[B>>2]=0;k[S>>2]=1124007936;w=S+4|0;a=S+8|0;u=S+40|0;j=w;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[u>>2]=a;x=S+48|0;v=S+44|0;k[v>>2]=x;k[S+52>>2]=0;k[x>>2]=0;k[N>>2]=1124007936;s=N+4|0;a=N+8|0;o=N+40|0;j=s;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[o>>2]=a;t=N+48|0;q=N+44|0;k[q>>2]=t;k[N+52>>2]=0;k[t>>2]=0;switch(c|0){case 0:{k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=X;G=E+4|0;c=G+4|0;k[c>>2]=0;k[c+4>>2]=0;k[E>>2]=33619968;k[G>>2]=V;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=Z;k[M>>2]=D;k[M+4>>2]=C;Dra(0,L,E,F,M,f,g,h);break}case 1:{k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=X;G=E+4|0;c=G+4|0;k[c>>2]=0;k[c+4>>2]=0;k[E>>2]=33619968;k[G>>2]=V;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=Z;k[M>>2]=D;k[M+4>>2]=C;Dra(1,L,E,F,M,f,g,h);break}case 2:{k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=X;G=E+4|0;c=G+4|0;k[c>>2]=0;k[c+4>>2]=0;k[E>>2]=33619968;k[G>>2]=V;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=Z;k[M>>2]=D;k[M+4>>2]=C;Dra(0,L,E,F,M,f,g,h);k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=V;G=E+4|0;c=G+4|0;k[c>>2]=0;k[c+4>>2]=0;k[E>>2]=33619968;k[G>>2]=V;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=Z;k[M>>2]=D;k[M+4>>2]=C;Dra(1,L,E,F,M,f,g,h);break}case 3:{k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=X;G=E+4|0;c=G+4|0;k[c>>2]=0;k[c+4>>2]=0;k[E>>2]=33619968;k[G>>2]=V;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=Z;k[M>>2]=D;k[M+4>>2]=C;Dra(1,L,E,F,M,f,g,h);k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=V;G=E+4|0;c=G+4|0;k[c>>2]=0;k[c+4>>2]=0;k[E>>2]=33619968;k[G>>2]=V;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=Z;k[M>>2]=D;k[M+4>>2]=C;Dra(0,L,E,F,M,f,g,h);break}case 4:{k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=X;G=E+4|0;c=G+4|0;k[c>>2]=0;k[c+4>>2]=0;k[E>>2]=33619968;k[G>>2]=W;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=Z;k[M>>2]=D;k[M+4>>2]=C;Dra(0,L,E,F,M,f,g,h);k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=X;G=E+4|0;c=G+4|0;k[c>>2]=0;k[c+4>>2]=0;k[E>>2]=33619968;k[G>>2]=V;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=Z;k[M>>2]=D;k[M+4>>2]=C;Dra(1,L,E,F,M,f,g,h);k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=16842752;k[M+4>>2]=V;k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=W;h=E+4|0;g=h+4|0;k[g>>2]=0;k[g+4>>2]=0;k[E>>2]=33619968;k[h>>2]=V;sU(M,L,E,49332,-1,39968,0,0);break}case 5:{if((k[X+16>>2]|0)!=(k[V+16>>2]|0))KG(W,V)|0;k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=X;a=E+4|0;b=a+4|0;k[b>>2]=0;k[b+4>>2]=0;k[E>>2]=33619968;k[a>>2]=W;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=Z;k[M>>2]=D;k[M+4>>2]=C;Dra(0,L,E,F,M,f,g,h);k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=W;a=E+4|0;b=a+4|0;k[b>>2]=0;k[b+4>>2]=0;k[E>>2]=33619968;k[a>>2]=W;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=Z;k[M>>2]=D;k[M+4>>2]=C;Dra(1,L,E,F,M,f,g,h);k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=1124007936;a=L+16|0;b=L+48|0;j=L+12|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;a=L+56|0;k[L+52>>2]=a;k[L+60>>2]=0;k[a>>2]=0;k[L+64>>2]=1124007936;a=L+72|0;b=L+104|0;j=L+68|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;a=L+112|0;k[L+108>>2]=a;k[L+116>>2]=0;k[a>>2]=0;k[L+120>>2]=1124007936;a=L+128|0;b=L+160|0;j=L+124|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;j=L+168|0;k[L+164>>2]=j;m=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;k[M+16>>2]=0;k[M+20>>2]=0;k[M+24>>2]=0;k[M+28>>2]=0;G0(L,X,W,1.0,-1.0,M);M=k[L>>2]|0;dh[k[(k[M>>2]|0)+12>>2]&255](M,L,V,-1);XN(L);break}case 6:{if((k[X+16>>2]|0)!=(k[V+16>>2]|0))KG(W,V)|0;k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=X;a=E+4|0;b=a+4|0;k[b>>2]=0;k[b+4>>2]=0;k[E>>2]=33619968;k[a>>2]=W;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=Z;k[M>>2]=D;k[M+4>>2]=C;Dra(1,L,E,F,M,f,g,h);k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=W;a=E+4|0;b=a+4|0;k[b>>2]=0;k[b+4>>2]=0;k[E>>2]=33619968;k[a>>2]=W;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=Z;k[M>>2]=D;k[M+4>>2]=C;Dra(0,L,E,F,M,f,g,h);k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=1124007936;a=L+16|0;b=L+48|0;j=L+12|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;a=L+56|0;k[L+52>>2]=a;k[L+60>>2]=0;k[a>>2]=0;k[L+64>>2]=1124007936;a=L+72|0;b=L+104|0;j=L+68|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;a=L+112|0;k[L+108>>2]=a;k[L+116>>2]=0;k[a>>2]=0;k[L+120>>2]=1124007936;a=L+128|0;b=L+160|0;j=L+124|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;j=L+168|0;k[L+164>>2]=j;m=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;k[M+16>>2]=0;k[M+20>>2]=0;k[M+24>>2]=0;k[M+28>>2]=0;G0(L,W,X,1.0,-1.0,M);M=k[L>>2]|0;dh[k[(k[M>>2]|0)+12>>2]&255](M,L,V,-1);XN(L);break}case 7:{if(k[p>>2]&4095|0){k[M>>2]=0;a=M+4|0;k[a>>2]=0;b=ZT(28)|0;k[b>>2]=1;j=b+4|0;k[M>>2]=j;k[a>>2]=21;i[b+25>>0]=0;e=354023;m=j+21|0;do{i[j>>0]=i[e>>0]|0;j=j+1|0;e=e+1|0}while((j|0)<(m|0));Y8(-215,M,346904,341434,1913);k[a>>2]=0;k[M>>2]=0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)==1)ggb(k[b+-4>>2]|0)}k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=1124007936;a=M+16|0;b=M+48|0;j=M+12|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;a=M+56|0;k[M+52>>2]=a;k[M+60>>2]=0;k[a>>2]=0;k[M+64>>2]=1124007936;a=M+72|0;b=M+104|0;j=M+68|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;a=M+112|0;k[M+108>>2]=a;k[M+116>>2]=0;k[a>>2]=0;k[M+120>>2]=1124007936;a=M+128|0;b=M+160|0;j=M+124|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;j=M+168|0;k[M+164>>2]=j;m=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));h1(M,0,Z,1.0);a=k[M>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,M,U,-1);XN(M);k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=1124007936;a=M+16|0;b=M+48|0;j=M+12|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;a=M+56|0;k[M+52>>2]=a;k[M+60>>2]=0;k[a>>2]=0;k[M+64>>2]=1124007936;a=M+72|0;b=M+104|0;j=M+68|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;a=M+112|0;k[M+108>>2]=a;k[M+116>>2]=0;k[a>>2]=0;k[M+120>>2]=1124007936;a=M+128|0;b=M+160|0;j=M+124|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;j=M+168|0;k[M+164>>2]=j;m=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));h1(M,0,Z,-1.0);c=k[M>>2]|0;dh[k[(k[c>>2]|0)+12>>2]&255](c,M,T,-1);XN(M);k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=16842752;k[M+4>>2]=U;if((o7(M)|0)<1)KG(S,X)|0;else{k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=X;c=E+4|0;p=c+4|0;k[p>>2]=0;k[p+4>>2]=0;k[E>>2]=33619968;k[c>>2]=S;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=U;k[M>>2]=D;k[M+4>>2]=C;Dra(0,L,E,F,M,f,g,h)}k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=16842752;k[M+4>>2]=T;if((o7(M)|0)>=1){k[L>>2]=1124007936;d=L+4|0;a=L+8|0;l=L+40|0;j=d;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[l>>2]=a;m=L+48|0;j=L+44|0;k[j>>2]=m;k[L+52>>2]=0;k[m>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;k[E>>2]=16842752;k[E+4>>2]=X;e=F+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[F>>2]=33619968;k[e>>2]=L;k[M>>2]=99;aU(E,E,F,49332,M,1,12);k[E+8>>2]=0;k[E+12>>2]=0;k[E>>2]=16842752;k[E+4>>2]=L;e=F+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[F>>2]=33619968;k[e>>2]=N;k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=T;k[M>>2]=D;k[M+4>>2]=C;Dra(0,E,F,G,M,f,g,h);e=L+36|0;a=k[e>>2]|0;if(a|0?(g=a+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[L+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;L=L+16|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[d>>2]|0)>0){b=k[l>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[j>>2]|0;if(!((a|0)==(m|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else KG(N,X)|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=1124007936;a=M+16|0;b=M+48|0;j=M+12|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;a=M+56|0;k[M+52>>2]=a;k[M+60>>2]=0;k[a>>2]=0;k[M+64>>2]=1124007936;a=M+72|0;b=M+104|0;j=M+68|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;a=M+112|0;k[M+108>>2]=a;k[M+116>>2]=0;k[a>>2]=0;k[M+120>>2]=1124007936;a=M+128|0;b=M+160|0;j=M+124|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[b>>2]=a;j=M+168|0;k[M+164>>2]=j;m=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));A0(M,38,S,N,1.0);L=k[M>>2]|0;dh[k[(k[L>>2]|0)+12>>2]&255](L,M,V,-1);XN(M);break}default:{k[M>>2]=0;a=M+4|0;k[a>>2]=0;b=ZT(36)|0;k[b>>2]=1;j=b+4|0;k[M>>2]=j;k[a>>2]=31;i[b+35>>0]=0;e=346917;m=j+31|0;do{i[j>>0]=i[e>>0]|0;j=j+1|0;e=e+1|0}while((j|0)<(m|0));Y8(-5,M,346904,341434,1931);k[a>>2]=0;k[M>>2]=0;M=k[b>>2]|0;k[b>>2]=M+-1;if((M|0)==1)ggb(k[b+-4>>2]|0)}}e=N+36|0;a=k[e>>2]|0;if(a|0?(L=a+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[N+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;N=N+16|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[s>>2]|0)>0){b=k[o>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[s>>2]|0))}a=k[q>>2]|0;if(!((a|0)==(t|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=S+36|0;a=k[e>>2]|0;if(a|0?(M=a+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[S+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;S=S+16|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[w>>2]|0)>0){b=k[u>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[v>>2]|0;if(!((a|0)==(x|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=T+36|0;a=k[e>>2]|0;if(a|0?(N=a+12|0,S=k[N>>2]|0,k[N>>2]=S+-1,(S|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[T+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;T=T+16|0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[A>>2]|0)>0){b=k[y>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=U+36|0;a=k[e>>2]|0;if(a|0?(S=a+12|0,T=k[S>>2]|0,k[S>>2]=T+-1,(T|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[U+32>>2]|0;if(a|0)break;a=B1()|0;b=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;U=U+16|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[J>>2]|0)>0){b=k[H>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[J>>2]|0))}a=k[I>>2]|0;if(!((a|0)==(K|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=V+36|0;a=k[e>>2]|0;if(a|0?(T=a+12|0,U=k[T>>2]|0,k[T>>2]=U+-1,(U|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[V+32>>2]|0;if(a|0)break;a=B1()|0;b=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;U=V+16|0;b=V+4|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[b>>2]|0)>0){e=k[V+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[V+44>>2]|0;if(!((a|0)==(V+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=W+36|0;a=k[e>>2]|0;do if(a|0){U=a+12|0;V=k[U>>2]|0;k[U>>2]=V+-1;if((V|0)!=1)break;b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[W+32>>2]|0;if(a|0)break;a=B1()|0;b=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}while(0);k[e>>2]=0;W=W+16|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Q>>2]|0)>0){b=k[O>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Q>>2]|0))}a=k[P>>2]|0;if(!((a|0)==(R|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=X+36|0;a=k[e>>2]|0;do if(a|0){V=a+12|0;W=k[V>>2]|0;k[V>>2]=W+-1;if((W|0)!=1)break;b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[X+32>>2]|0;if(a|0)break;a=B1()|0;b=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}while(0);k[e>>2]=0;W=X+16|0;e=X+4|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[e>>2]|0)>0){b=k[n>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[X+44>>2]|0;if(!((a|0)==(X+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=Z+36|0;a=k[e>>2]|0;do if(a|0){W=a+12|0;X=k[W>>2]|0;k[W>>2]=X+-1;if((X|0)!=1)break;b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[Z+32>>2]|0;if(a|0)break;a=B1()|0;b=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}while(0);k[e>>2]=0;e=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[e>>2]|0)>0){b=k[Z+40>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[Z+44>>2]|0;if((a|0)==(Z+48|0)|(a|0)==0){r=_;return}ggb(k[a+-4>>2]|0);r=_;return}function Ul(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=r;r=r+48|0;i=f+32|0;h=f+16|0;g=f;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=a;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b;b=g+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=c;rZ(i,h,g,d,e);r=f;return}function Vl(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;var g=0,h=0,i=0,j=0;g=r;r=r+48|0;j=g+32|0;i=g+16|0;h=g;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;a=i+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=b;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=d;__(j,i,c,h,e,f);r=g;return}function Wl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+64|0;g=f;j=f+40|0;i=f+24|0;h=f+8|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b;b=h+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;p[g>>3]=d;sU(j,i,h,49332,e,40032,1,g);r=f;return}function Xl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=c;d=+N7(g,b,f);r=e;return +d}function Yl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0;f=r;r=r+48|0;i=f+32|0;h=f+16|0;g=f;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=a;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=d;e=+h8(i,h,c,g);r=f;return +e}function Zl(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0;h=r;r=r+48|0;l=h+32|0;j=h+16|0;i=h;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=a;a=j+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[j>>2]=50397184;k[j+4>>2]=b;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=g;$X(l,j,c,d,e,f,i);r=h;return}function _l(a,b){a=a|0;b=+b;var c=0,d=0,e=0;c=r;r=r+16|0;d=c;e=d+4+4|0;k[e>>2]=0;k[e+4>>2]=0;k[d>>2]=50397184;k[d+4>>2]=a;k_(d,b);r=c;return}function $l(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0;uc=r;r=r+1936|0;lc=uc+448|0;kc=uc+1872|0;jc=uc+1856|0;ic=uc+1800|0;w=uc+224|0;dc=uc+1744|0;cc=uc+1688|0;x=uc;Zb=uc+1632|0;Ub=uc+1576|0;Pb=uc+1520|0;Qb=uc+1472|0;tc=uc+1416|0;m=uc+1408|0;rc=uc+1352|0;t=uc+1344|0;qc=uc+1288|0;pc=uc+1232|0;oc=uc+784|0;nc=uc+728|0;mc=uc+672|0;n=uc+1504|0;v=uc+1488|0;q=n+4|0;s=n+4+4|0;k[s>>2]=0;k[s+4>>2]=0;k[n>>2]=33619968;k[q>>2]=b;s=v+4|0;l=v+4+4|0;k[l>>2]=0;k[l+4>>2]=0;k[v>>2]=33619968;k[s>>2]=c;k[tc>>2]=k[a>>2];l=tc+4|0;c=a+4|0;b=k[c>>2]|0;k[l>>2]=b;hc=tc+8|0;k[hc>>2]=k[a+8>>2];k[tc+12>>2]=k[a+12>>2];k[tc+16>>2]=k[a+16>>2];k[tc+20>>2]=k[a+20>>2];k[tc+24>>2]=k[a+24>>2];k[tc+28>>2]=k[a+28>>2];k[tc+32>>2]=k[a+32>>2];g=k[a+36>>2]|0;k[tc+36>>2]=g;sc=tc+40|0;k[sc>>2]=hc;hc=tc+48|0;j=tc+44|0;k[j>>2]=hc;k[tc+52>>2]=0;k[hc>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[l>>2]=0;x1(tc,b,0,0,0);if((k[l>>2]|0)>0){h=k[a+40>>2]|0;i=k[sc>>2]|0;g=k[a+44>>2]|0;c=k[j>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{gc=k[a+44>>2]|0;hc=k[j>>2]|0;k[hc>>2]=k[gc>>2];k[hc+4>>2]=k[gc+4>>2]}gc=k[sc>>2]|0;hc=k[gc>>2]|0;k[m>>2]=k[gc+4>>2];k[m+4>>2]=hc;x2(n,m,0,0);do if((k[n>>2]&2031616|0)==65536){h=k[q>>2]|0;k[rc>>2]=k[h>>2];l=rc+4|0;b=h+4|0;k[l>>2]=k[b>>2];hc=rc+8|0;k[hc>>2]=k[h+8>>2];k[rc+12>>2]=k[h+12>>2];k[rc+16>>2]=k[h+16>>2];k[rc+20>>2]=k[h+20>>2];k[rc+24>>2]=k[h+24>>2];k[rc+28>>2]=k[h+28>>2];k[rc+32>>2]=k[h+32>>2];c=k[h+36>>2]|0;k[rc+36>>2]=c;g=rc+40|0;k[g>>2]=hc;hc=rc+48|0;j=rc+44|0;k[j>>2]=hc;k[rc+52>>2]=0;k[hc>>2]=0;if(c|0){hc=c+12|0;k[hc>>2]=(k[hc>>2]|0)+1}if((k[b>>2]|0)<3){gc=k[h+44>>2]|0;hc=k[j>>2]|0;k[hc>>2]=k[gc>>2];k[hc+4>>2]=k[gc+4>>2];break}k[l>>2]=0;x1(rc,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){a=k[h+40>>2]|0;i=k[g>>2]|0;g=k[h+44>>2]|0;c=k[j>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(rc,n,-1);while(0);gc=k[sc>>2]|0;hc=k[gc>>2]|0;k[t>>2]=k[gc+4>>2];k[t+4>>2]=hc;x2(v,t,16,0);do if((k[v>>2]&2031616|0)==65536){h=k[s>>2]|0;k[qc>>2]=k[h>>2];l=qc+4|0;b=h+4|0;k[l>>2]=k[b>>2];hc=qc+8|0;k[hc>>2]=k[h+8>>2];k[qc+12>>2]=k[h+12>>2];k[qc+16>>2]=k[h+16>>2];k[qc+20>>2]=k[h+20>>2];k[qc+24>>2]=k[h+24>>2];k[qc+28>>2]=k[h+28>>2];k[qc+32>>2]=k[h+32>>2];c=k[h+36>>2]|0;k[qc+36>>2]=c;g=qc+40|0;k[g>>2]=hc;hc=qc+48|0;j=qc+44|0;k[j>>2]=hc;k[qc+52>>2]=0;k[hc>>2]=0;if(c|0){hc=c+12|0;k[hc>>2]=(k[hc>>2]|0)+1}if((k[b>>2]|0)<3){gc=k[h+44>>2]|0;hc=k[j>>2]|0;k[hc>>2]=k[gc>>2];k[hc+4>>2]=k[gc+4>>2];break}k[l>>2]=0;x1(qc,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){a=k[h+40>>2]|0;i=k[g>>2]|0;g=k[h+44>>2]|0;c=k[j>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(qc,v,-1);while(0);c=k[sc>>2]|0;g=k[c+4>>2]|0;c=k[c>>2]|0;k[pc>>2]=1124007936;gc=pc+4|0;b=pc+8|0;ec=pc+40|0;i=gc;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[ec>>2]=b;hc=pc+48|0;fc=pc+44|0;k[fc>>2]=hc;k[pc+52>>2]=0;k[hc>>2]=0;k[lc>>2]=c;h=lc+4|0;k[h>>2]=g;G1(pc,2,lc,21);b=lc+4|0;c=b+4|0;k[c>>2]=0;k[c+4>>2]=0;k[lc>>2]=33619968;k[b>>2]=pc;SW(tc,lc,21,.00392156862745098,0.0);k[oc>>2]=1124007936;b=oc+8|0;c=oc+40|0;i=oc+4|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[c>>2]=b;b=oc+48|0;k[oc+44>>2]=b;k[oc+52>>2]=0;k[b>>2]=0;k[oc+56>>2]=1124007936;b=oc+64|0;c=oc+96|0;i=oc+60|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[c>>2]=b;b=oc+104|0;k[oc+100>>2]=b;k[oc+108>>2]=0;k[b>>2]=0;k[oc+112>>2]=1124007936;b=oc+120|0;c=oc+152|0;i=oc+116|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[c>>2]=b;b=oc+160|0;k[oc+156>>2]=b;k[oc+164>>2]=0;k[b>>2]=0;k[oc+168>>2]=1124007936;b=oc+176|0;c=oc+208|0;i=oc+172|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[c>>2]=b;Bb=oc+216|0;k[oc+212>>2]=Bb;k[oc+220>>2]=0;k[Bb>>2]=0;k[oc+224>>2]=1124007936;Bb=oc+232|0;b=oc+264|0;i=oc+228|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[b>>2]=Bb;Ab=oc+272|0;k[oc+268>>2]=Ab;k[oc+276>>2]=0;k[Ab>>2]=0;k[oc+280>>2]=1124007936;Ab=oc+288|0;b=oc+320|0;i=oc+284|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[b>>2]=Ab;b=oc+328|0;k[oc+324>>2]=b;k[oc+332>>2]=0;k[b>>2]=0;k[oc+336>>2]=1124007936;b=oc+344|0;c=oc+376|0;i=oc+340|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[c>>2]=b;b=oc+384|0;k[oc+380>>2]=b;k[oc+388>>2]=0;k[b>>2]=0;k[oc+392>>2]=1124007936;b=oc+400|0;c=oc+432|0;i=oc+396|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[c>>2]=b;g=oc+440|0;k[oc+436>>2]=g;k[oc+444>>2]=0;k[g>>2]=0;g=k[sc>>2]|0;c=k[g+4>>2]|0;g=k[g>>2]|0;k[nc>>2]=1124007936;ac=nc+4|0;b=nc+8|0;_b=nc+40|0;i=ac;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[_b>>2]=b;bc=nc+48|0;$b=nc+44|0;k[$b>>2]=bc;k[nc+52>>2]=0;k[bc>>2]=0;k[lc>>2]=g;k[h>>2]=c;G1(nc,2,lc,5);g=k[sc>>2]|0;c=k[g+4>>2]|0;g=k[g>>2]|0;k[mc>>2]=1124007936;Xb=mc+4|0;b=mc+8|0;Vb=mc+40|0;i=Xb;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[Vb>>2]=b;Yb=mc+48|0;Wb=mc+44|0;k[Wb>>2]=Yb;k[mc+52>>2]=0;k[Yb>>2]=0;k[lc>>2]=g;k[h>>2]=c;G1(mc,2,lc,21);L3a(oc,pc,2,d,e);sb=k[ec>>2]|0;rb=k[sb>>2]|0;sb=k[sb+4>>2]|0;k[kc>>2]=1124007936;Nb=kc+4|0;b=kc+8|0;Lb=kc+40|0;i=Nb;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[Lb>>2]=b;Ob=kc+48|0;Mb=kc+44|0;k[Mb>>2]=Ob;k[kc+52>>2]=0;k[Ob>>2]=0;k[lc>>2]=rb;h=lc+4|0;k[h>>2]=sb;G1(kc,2,lc,21);k[lc+8>>2]=0;k[lc+12>>2]=0;k[lc>>2]=16842752;k[lc+4>>2]=pc;g=jc+4|0;b=g+4|0;k[b>>2]=0;k[b+4>>2]=0;k[jc>>2]=33619968;k[g>>2]=kc;$aa(lc,jc,36,0);k[jc>>2]=0;k[jc+4>>2]=0;k[jc+8>>2]=0;g=oc+56|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=1124007936;b=w+16|0;c=w+48|0;i=w+12|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[c>>2]=b;b=w+56|0;k[w+52>>2]=b;k[w+60>>2]=0;k[b>>2]=0;k[w+64>>2]=1124007936;b=w+72|0;c=w+104|0;i=w+68|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[c>>2]=b;b=w+112|0;k[w+108>>2]=b;k[w+116>>2]=0;k[b>>2]=0;k[w+120>>2]=1124007936;b=w+128|0;c=w+160|0;i=w+124|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[c>>2]=b;i=w+168|0;k[w+164>>2]=i;j=i+56|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));y0(w,g,1.0);k[ic>>2]=1124007936;Jb=ic+4|0;b=ic+8|0;Hb=ic+40|0;i=Jb;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[Hb>>2]=b;Kb=ic+48|0;Ib=ic+44|0;k[Ib>>2]=Kb;k[ic+52>>2]=0;k[Kb>>2]=0;Fb=k[w>>2]|0;dh[k[(k[Fb>>2]|0)+12>>2]&255](Fb,w,ic,-1);XN(w);k[dc>>2]=1124007936;Fb=dc+4|0;b=dc+8|0;Db=dc+40|0;i=Fb;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[Db>>2]=b;Gb=dc+48|0;Eb=dc+44|0;k[Eb>>2]=Gb;k[dc+52>>2]=0;k[Gb>>2]=0;k[lc>>2]=rb;k[h>>2]=sb;G1(dc,2,lc,5);k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=1124007936;b=x+16|0;c=x+48|0;i=x+12|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[c>>2]=b;b=x+56|0;k[x+52>>2]=b;k[x+60>>2]=0;k[b>>2]=0;k[x+64>>2]=1124007936;b=x+72|0;c=x+104|0;i=x+68|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[c>>2]=b;b=x+112|0;k[x+108>>2]=b;k[x+116>>2]=0;k[b>>2]=0;k[x+120>>2]=1124007936;b=x+128|0;c=x+160|0;i=x+124|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[c>>2]=b;i=x+168|0;k[x+164>>2]=i;j=i+56|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[lc>>2]=sb;k[lc+4>>2]=rb;j1(x,48,lc,5);k[cc>>2]=1124007936;yb=cc+4|0;b=cc+8|0;wb=cc+40|0;i=yb;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[wb>>2]=b;zb=cc+48|0;xb=cc+44|0;k[xb>>2]=zb;k[cc+52>>2]=0;k[zb>>2]=0;tb=k[x>>2]|0;dh[k[(k[tb>>2]|0)+12>>2]&255](tb,x,cc,-1);XN(x);k[Zb>>2]=1124007936;tb=Zb+4|0;b=Zb+8|0;pb=Zb+40|0;i=tb;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[pb>>2]=b;ub=Zb+48|0;qb=Zb+44|0;k[qb>>2]=ub;k[Zb+52>>2]=0;k[ub>>2]=0;k[lc>>2]=sb;k[h>>2]=rb;G1(Zb,2,lc,5);k[Ub>>2]=1124007936;nb=Ub+4|0;b=Ub+8|0;lb=Ub+40|0;i=nb;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[lb>>2]=b;ob=Ub+48|0;mb=Ub+44|0;k[mb>>2]=ob;k[Ub+52>>2]=0;k[ob>>2]=0;d=d*1.7320508075688772;s=oc+224|0;t=oc+280|0;v=(rb|0)>0;w=(sb|0)>0;Cb=dc+16|0;kb=Ub+16|0;vb=cc+16|0;x=Pb+4|0;y=Pb+8|0;z=Pb+40|0;A=Pb+48|0;B=Pb+44|0;C=Pb+52|0;D=lc+4|0;E=D+4|0;F=Pb+36|0;G=Pb+16|0;H=lc+8|0;I=lc+12|0;J=lc+4|0;K=Pb+4|0;L=K+4|0;M=lc+4|0;O=M+4|0;P=Pb+8|0;Q=Pb+12|0;R=Pb+4|0;S=Qb+4|0;T=S+4|0;U=lc+8|0;V=lc+12|0;W=lc+4|0;X=Pb+4|0;Y=X+4|0;q=oc+236|0;Z=lc+4|0;_=lc+8|0;$=lc+12|0;ba=lc+16|0;ca=lc+48|0;da=lc+56|0;ea=lc+52|0;fa=lc+60|0;ga=lc+64|0;ha=lc+68|0;ia=lc+72|0;ja=lc+104|0;ka=lc+112|0;la=lc+108|0;ma=lc+116|0;na=lc+120|0;oa=lc+124|0;pa=lc+128|0;qa=lc+160|0;ra=lc+168|0;sa=lc+164|0;n=oc+292|0;ta=lc+4|0;ua=lc+8|0;va=lc+12|0;wa=lc+16|0;xa=lc+48|0;ya=lc+56|0;za=lc+52|0;Aa=lc+60|0;Ba=lc+64|0;Ca=lc+68|0;Da=lc+72|0;Ea=lc+104|0;Fa=lc+112|0;Ga=lc+108|0;Ha=lc+116|0;Ia=lc+120|0;Ja=lc+124|0;Ka=lc+128|0;La=lc+160|0;Ma=lc+168|0;Na=lc+164|0;Oa=lc+4|0;Pa=lc+8|0;Qa=lc+12|0;Ra=lc+16|0;Sa=lc+48|0;Ta=lc+56|0;Ua=lc+52|0;Va=lc+60|0;Wa=lc+64|0;Xa=lc+68|0;Ya=lc+72|0;Za=lc+104|0;_a=lc+112|0;$a=lc+108|0;ab=lc+116|0;bb=lc+120|0;cb=lc+124|0;db=lc+128|0;eb=lc+160|0;fb=lc+168|0;gb=lc+164|0;hb=lc+4|0;ib=lc+8|0;jb=Pb+32|0;m=0;do{j=Apb(2-m+1023|0,0,52)|0;i=N;k[u>>2]=j;k[u+4>>2]=i;e=d*+p[u>>3]/7.937253933193772*1.7320507764816284;J3a(oc,k[Bb>>2]|0,k[q>>2]|0,oc,dc,e);k[lc>>2]=0;k[Z>>2]=0;k[_>>2]=1124007936;i=$;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[ca>>2]=ba;k[ea>>2]=da;k[fa>>2]=0;k[da>>2]=0;k[ga>>2]=1124007936;i=ha;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[ja>>2]=ia;k[la>>2]=ka;k[ma>>2]=0;k[ka>>2]=0;k[na>>2]=1124007936;i=oa;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[qa>>2]=pa;k[sa>>2]=ra;i=ra;j=i+56|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));y0(lc,s,1.0);i=k[lc>>2]|0;dh[k[(k[i>>2]|0)+12>>2]&255](i,lc,t,-1);XN(lc);J3a(oc,k[Ab>>2]|0,k[n>>2]|0,ic,Zb,e);k[lc>>2]=0;k[ta>>2]=0;k[ua>>2]=1124007936;i=va;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[xa>>2]=wa;k[za>>2]=ya;k[Aa>>2]=0;k[ya>>2]=0;k[Ba>>2]=1124007936;i=Ca;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[Ea>>2]=Da;k[Ga>>2]=Fa;k[Ha>>2]=0;k[Fa>>2]=0;k[Ia>>2]=1124007936;i=Ja;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[La>>2]=Ka;k[Na>>2]=Ma;i=Ma;j=i+56|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));y0(lc,t,1.0);i=k[lc>>2]|0;dh[k[(k[i>>2]|0)+12>>2]&255](i,lc,s,-1);XN(lc);k[lc>>2]=0;k[Oa>>2]=0;k[Pa>>2]=1124007936;i=Qa;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[Sa>>2]=Ra;k[Ua>>2]=Ta;k[Va>>2]=0;k[Ta>>2]=0;k[Wa>>2]=1124007936;i=Xa;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[Za>>2]=Ya;k[$a>>2]=_a;k[ab>>2]=0;k[_a>>2]=0;k[bb>>2]=1124007936;i=cb;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[eb>>2]=db;k[gb>>2]=fb;i=fb;j=i+56|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));y0(lc,Zb,1.0);l=k[lc>>2]|0;dh[k[(k[l>>2]|0)+12>>2]&255](l,lc,Ub,-1);XN(lc);if(v?(Rb=k[Cb>>2]|0,Sb=k[kb>>2]|0,Tb=k[vb>>2]|0,w):0){g=k[k[Eb>>2]>>2]|0;h=k[k[mb>>2]>>2]|0;i=k[k[xb>>2]>>2]|0;c=0;do{j=Rb+(aa(g,c)|0)|0;a=Sb+(aa(h,c)|0)|0;l=Tb+(aa(i,c)|0)|0;b=0;do{o[l+(b<<2)>>2]=(+o[j+(b<<2)>>2]+ +o[a+(b<<2)>>2])*f;b=b+1|0}while((b|0)!=(sb|0));c=c+1|0}while((c|0)!=(rb|0))}if(!m){k[Pb>>2]=1124007936;i=x;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[z>>2]=y;k[B>>2]=A;k[C>>2]=0;k[A>>2]=0;b=E;k[b>>2]=0;k[b+4>>2]=0;k[lc>>2]=33619968;k[D>>2]=Pb;mY(cc,lc);KG(nc,Pb)|0;b=k[F>>2]|0;if(b|0?(a=b+12|0,l=k[a>>2]|0,k[a>>2]=l+-1,(l|0)==1):0){c=k[F>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[jb>>2]|0;if(!b){b=B1()|0;c=k[F>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[F>>2]=0}k[F>>2]=0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[x>>2]|0)>0){c=k[z>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[x>>2]|0))}b=k[B>>2]|0;if(!((b|0)==(A|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[H>>2]=0;k[I>>2]=0;k[lc>>2]=16842752;k[J>>2]=kc;l=L;k[l>>2]=0;k[l+4>>2]=0;k[Pb>>2]=33882112;k[K>>2]=jc;FV(lc,Pb);l=k[jc>>2]|0;a=O;k[a>>2]=0;k[a+4>>2]=0;k[lc>>2]=33619968;k[M>>2]=l;mY(cc,lc);k[P>>2]=0;k[Q>>2]=0;k[Pb>>2]=17104896;k[R>>2]=jc;l=T;k[l>>2]=0;k[l+4>>2]=0;k[Qb>>2]=33619968;k[S>>2]=kc;k[lc>>2]=0;k[hb>>2]=0;k[ib>>2]=0;B2(Pb,lc);l=k[lc>>2]|0;a=k[hb>>2]|0;GV((l|0)==(a|0)?0:l,(a-l|0)/56|0,Qb);zF(lc);k[U>>2]=0;k[V>>2]=0;k[lc>>2]=16842752;k[W>>2]=kc;l=Y;k[l>>2]=0;k[l+4>>2]=0;k[Pb>>2]=33619968;k[X>>2]=mc;$aa(lc,Pb,38,0)}m=m+1|0}while((m|0)<3);g=Ub+36|0;b=k[g>>2]|0;if(b|0?(Sb=b+12|0,Tb=k[Sb>>2]|0,k[Sb>>2]=Tb+-1,(Tb|0)==1):0){c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Ub+32>>2]|0;if(!b){b=B1()|0;c=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}k[g>>2]=0;k[kb>>2]=0;k[kb+4>>2]=0;k[kb+8>>2]=0;k[kb+12>>2]=0;if((k[nb>>2]|0)>0){c=k[lb>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[nb>>2]|0))}b=k[mb>>2]|0;if(!((b|0)==(ob|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=Zb+36|0;b=k[g>>2]|0;if(b|0?(Tb=b+12|0,Ub=k[Tb>>2]|0,k[Tb>>2]=Ub+-1,(Ub|0)==1):0){c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Zb+32>>2]|0;if(!b){b=B1()|0;c=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}k[g>>2]=0;Zb=Zb+16|0;k[Zb>>2]=0;k[Zb+4>>2]=0;k[Zb+8>>2]=0;k[Zb+12>>2]=0;if((k[tb>>2]|0)>0){c=k[pb>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[tb>>2]|0))}b=k[qb>>2]|0;if(!((b|0)==(ub|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=cc+36|0;b=k[g>>2]|0;if(b|0?(Ub=b+12|0,Zb=k[Ub>>2]|0,k[Ub>>2]=Zb+-1,(Zb|0)==1):0){c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[cc+32>>2]|0;if(!b){b=B1()|0;c=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}k[g>>2]=0;k[vb>>2]=0;k[vb+4>>2]=0;k[vb+8>>2]=0;k[vb+12>>2]=0;if((k[yb>>2]|0)>0){c=k[wb>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[yb>>2]|0))}b=k[xb>>2]|0;if(!((b|0)==(zb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=dc+36|0;b=k[g>>2]|0;if(b|0?(Zb=b+12|0,cc=k[Zb>>2]|0,k[Zb>>2]=cc+-1,(cc|0)==1):0){c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[dc+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}k[g>>2]=0;k[Cb>>2]=0;k[Cb+4>>2]=0;k[Cb+8>>2]=0;k[Cb+12>>2]=0;if((k[Fb>>2]|0)>0){c=k[Db>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Fb>>2]|0))}b=k[Eb>>2]|0;if(!((b|0)==(Gb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=ic+36|0;b=k[g>>2]|0;if(b|0?(cc=b+12|0,dc=k[cc>>2]|0,k[cc>>2]=dc+-1,(dc|0)==1):0){c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ic+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}k[g>>2]=0;ic=ic+16|0;k[ic>>2]=0;k[ic+4>>2]=0;k[ic+8>>2]=0;k[ic+12>>2]=0;if((k[Jb>>2]|0)>0){c=k[Hb>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Jb>>2]|0))}b=k[Ib>>2]|0;if(!((b|0)==(Kb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);zF(jc);g=kc+36|0;b=k[g>>2]|0;do if(b|0){ic=b+12|0;jc=k[ic>>2]|0;k[ic>>2]=jc+-1;if((jc|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[kc+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;kc=kc+16|0;k[kc>>2]=0;k[kc+4>>2]=0;k[kc+8>>2]=0;k[kc+12>>2]=0;if((k[Nb>>2]|0)>0){c=k[Lb>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Nb>>2]|0))}b=k[Mb>>2]|0;if(!((b|0)==(Ob|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=lc+4|0;b=g+4|0;k[b>>2]=0;k[b+4>>2]=0;k[lc>>2]=33619968;k[g>>2]=rc;SW(nc,lc,0,255.0,0.0);g=lc+4|0;b=g+4|0;k[b>>2]=0;k[b+4>>2]=0;k[lc>>2]=33619968;k[g>>2]=qc;SW(mc,lc,16,255.0,0.0);g=mc+36|0;b=k[g>>2]|0;do if(b|0){kc=b+12|0;lc=k[kc>>2]|0;k[kc>>2]=lc+-1;if((lc|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[mc+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;mc=mc+16|0;k[mc>>2]=0;k[mc+4>>2]=0;k[mc+8>>2]=0;k[mc+12>>2]=0;if((k[Xb>>2]|0)>0){c=k[Vb>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Xb>>2]|0))}b=k[Wb>>2]|0;if(!((b|0)==(Yb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=nc+36|0;b=k[g>>2]|0;do if(b|0){lc=b+12|0;mc=k[lc>>2]|0;k[lc>>2]=mc+-1;if((mc|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[nc+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;nc=nc+16|0;k[nc>>2]=0;k[nc+4>>2]=0;k[nc+8>>2]=0;k[nc+12>>2]=0;if((k[ac>>2]|0)>0){c=k[_b>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ac>>2]|0))}b=k[$b>>2]|0;if(!((b|0)==(bc|0)|(b|0)==0))ggb(k[b+-4>>2]|0);N3a(oc);g=pc+36|0;b=k[g>>2]|0;do if(b|0){nc=b+12|0;oc=k[nc>>2]|0;k[nc>>2]=oc+-1;if((oc|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[pc+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;pc=pc+16|0;k[pc>>2]=0;k[pc+4>>2]=0;k[pc+8>>2]=0;k[pc+12>>2]=0;if((k[gc>>2]|0)>0){c=k[ec>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[gc>>2]|0))}b=k[fc>>2]|0;if(!((b|0)==(hc|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=qc+36|0;b=k[g>>2]|0;do if(b|0){oc=b+12|0;pc=k[oc>>2]|0;k[oc>>2]=pc+-1;if((pc|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[qc+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;pc=qc+16|0;c=qc+4|0;k[pc>>2]=0;k[pc+4>>2]=0;k[pc+8>>2]=0;k[pc+12>>2]=0;if((k[c>>2]|0)>0){g=k[qc+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[qc+44>>2]|0;if(!((b|0)==(qc+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=rc+36|0;b=k[g>>2]|0;do if(b|0){pc=b+12|0;qc=k[pc>>2]|0;k[pc>>2]=qc+-1;if((qc|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[rc+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;qc=rc+16|0;c=rc+4|0;k[qc>>2]=0;k[qc+4>>2]=0;k[qc+8>>2]=0;k[qc+12>>2]=0;if((k[c>>2]|0)>0){g=k[rc+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[rc+44>>2]|0;if(!((b|0)==(rc+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=tc+36|0;b=k[g>>2]|0;do if(b|0){qc=b+12|0;rc=k[qc>>2]|0;k[qc>>2]=rc+-1;if((rc|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[tc+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;rc=tc+16|0;g=tc+4|0;k[rc>>2]=0;k[rc+4>>2]=0;k[rc+8>>2]=0;k[rc+12>>2]=0;if((k[g>>2]|0)>0){c=k[sc>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[tc+44>>2]|0;if((b|0)==(tc+48|0)|(b|0)==0){r=uc;return}ggb(k[b+-4>>2]|0);r=uc;return}function am(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=r;r=r+1408|0;A=H+1392|0;G=H+1336|0;F=H+1280|0;q=H+1272|0;E=H+1216|0;D=H;C=H+1144|0;B=H+1096|0;o=H+1200|0;l=H+1128|0;p=o+4|0;j=o+4+4|0;k[j>>2]=0;k[j+4>>2]=0;k[o>>2]=33619968;k[p>>2]=b;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;j=l+4|0;k[j>>2]=c;k[G>>2]=k[a>>2];h=G+4|0;c=a+4|0;b=k[c>>2]|0;k[h>>2]=b;z=G+8|0;k[z>>2]=k[a+8>>2];k[G+12>>2]=k[a+12>>2];k[G+16>>2]=k[a+16>>2];k[G+20>>2]=k[a+20>>2];k[G+24>>2]=k[a+24>>2];k[G+28>>2]=k[a+28>>2];k[G+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[G+36>>2]=d;e=G+40|0;k[e>>2]=z;z=G+48|0;g=G+44|0;k[g>>2]=z;k[G+52>>2]=0;k[z>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[h>>2]=0;x1(G,b,0,0,0);if((k[h>>2]|0)>0){f=k[a+40>>2]|0;e=k[e>>2]|0;d=k[a+44>>2]|0;c=k[g>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else{y=k[a+44>>2]|0;z=k[g>>2]|0;k[z>>2]=k[y>>2];k[z+4>>2]=k[y+4>>2]}do if((k[l>>2]&2031616|0)==65536){a=k[j>>2]|0;k[F>>2]=k[a>>2];l=F+4|0;e=a+4|0;k[l>>2]=k[e>>2];b=F+8|0;k[b>>2]=k[a+8>>2];c=F+12|0;k[c>>2]=k[a+12>>2];k[F+16>>2]=k[a+16>>2];k[F+20>>2]=k[a+20>>2];k[F+24>>2]=k[a+24>>2];k[F+28>>2]=k[a+28>>2];k[F+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[F+36>>2]=d;f=F+40|0;k[f>>2]=b;z=F+48|0;h=F+44|0;k[h>>2]=z;k[F+52>>2]=0;k[z>>2]=0;if(d|0){z=d+12|0;k[z>>2]=(k[z>>2]|0)+1}if((k[e>>2]|0)<3){y=k[a+44>>2]|0;z=k[h>>2]|0;k[z>>2]=k[y>>2];k[z+4>>2]=k[y+4>>2];break}k[l>>2]=0;x1(F,k[e>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[a+40>>2]|0;g=k[f>>2]|0;f=k[a+44>>2]|0;e=k[h>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else{Q1(F,l,-1);b=F+8|0;c=F+12|0}while(0);t=k[G>>2]|0;d=t&7;t=t>>>3&511;y=t+1|0;n=k[b>>2]|0;x=n+-1|0;t=t+2|0;if((t|0)!=(k[c>>2]|0)){k[A>>2]=0;b=A+4|0;k[b>>2]=0;c=ZT(24)|0;k[c>>2]=1;j=c+4|0;k[A>>2]=j;k[b>>2]=17;i[c+21>>0]=0;l=215764;m=j+17|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,A,215782,215417,2125);k[b>>2]=0;k[A>>2]=0;z=k[c>>2]|0;k[c>>2]=z+-1;if((z|0)==1)ggb(k[c+-4>>2]|0)}w=(d|0)==5;if((d+-5|0)>>>0>=2){k[A>>2]=0;b=A+4|0;k[b>>2]=0;c=ZT(40)|0;k[c>>2]=1;j=c+4|0;k[A>>2]=j;k[b>>2]=34;i[c+38>>0]=0;l=215803;m=j+34|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,A,215782,215417,2126);k[b>>2]=0;k[A>>2]=0;z=k[c>>2]|0;k[c>>2]=z+-1;if((z|0)==1)ggb(k[c+-4>>2]|0)}z=G+40|0;u=k[z>>2]|0;v=k[u>>2]|0;k[q>>2]=k[u+4>>2];k[q+4>>2]=v;x2(o,q,(n<<3)+-16|d,0);do if((k[o>>2]&2031616|0)==65536){e=k[p>>2]|0;k[E>>2]=k[e>>2];h=E+4|0;b=e+4|0;k[h>>2]=k[b>>2];v=E+8|0;k[v>>2]=k[e+8>>2];k[E+12>>2]=k[e+12>>2];k[E+16>>2]=k[e+16>>2];k[E+20>>2]=k[e+20>>2];k[E+24>>2]=k[e+24>>2];k[E+28>>2]=k[e+28>>2];k[E+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[E+36>>2]=c;d=E+40|0;k[d>>2]=v;v=E+48|0;g=E+44|0;k[g>>2]=v;k[E+52>>2]=0;k[v>>2]=0;if(c|0){v=c+12|0;k[v>>2]=(k[v>>2]|0)+1}if((k[b>>2]|0)<3){u=k[e+44>>2]|0;v=k[g>>2]|0;k[v>>2]=k[u>>2];k[v+4>>2]=k[u+4>>2];break}k[h>>2]=0;x1(E,k[b>>2]|0,0,0,0);if((k[h>>2]|0)>0){a=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else Q1(E,o,-1);while(0);u=D+8|0;k[D>>2]=u;v=D+4|0;k[v>>2]=136;if((k[F>>2]&20479|0)==16390)g=k[F+16>>2]|0;else{d=aa(t,n)|0;if(d>>>0>136){c=d>>>0>536870911?-1:d<<3;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[D>>2]=b}else b=u;k[v>>2]=d;k[C>>2]=1124007942;q=C+4|0;k[q>>2]=2;h=C+8|0;k[h>>2]=n;e=C+12|0;k[e>>2]=t;n=C+16|0;k[n>>2]=b;f=C+20|0;k[f>>2]=b;g=C+24|0;a=C+28|0;o=C+40|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[o>>2]=h;s=C+48|0;p=C+44|0;k[p>>2]=s;k[C+52>>2]=0;k[s>>2]=0;if((d|0)!=0&(b|0)==0){k[A>>2]=0;b=A+4|0;k[b>>2]=0;c=ZT(36)|0;k[c>>2]=1;j=c+4|0;k[A>>2]=j;k[b>>2]=28;i[c+32>>0]=0;l=390609;m=j+28|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,A,390638,390642,410);k[b>>2]=0;k[A>>2]=0;t=k[c>>2]|0;k[c>>2]=t+-1;if((t|0)==1)ggb(k[c+-4>>2]|0);c=k[e>>2]|0;d=k[C>>2]|0;e=k[p>>2]|0;b=k[f>>2]|0}else{c=t;d=1124007942;e=s}t=c<<3;k[C>>2]=d|16384;k[e>>2]=t;k[e+4>>2]=8;d=b+(aa(k[h>>2]|0,t)|0)|0;k[a>>2]=d;k[g>>2]=d+(0-t)+t;d=A+4|0;b=d+4|0;k[b>>2]=0;k[b+4>>2]=0;k[A>>2]=33619968;k[d>>2]=C;SW(F,A,6,1.0,0.0);KG(F,C)|0;d=C+36|0;b=k[d>>2]|0;if(b|0?(m=b+12|0,t=k[m>>2]|0,k[m>>2]=t+-1,(t|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[C+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[q>>2]|0)>0){c=k[o>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[q>>2]|0))}b=k[p>>2]|0;if(!((b|0)==(s|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=u}f=w?158:157;k[A>>2]=G;k[A+4>>2]=E;k[A+8>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;k[B+16>>2]=0;k[B+20>>2]=0;k[B+24>>2]=0;k[B+28>>2]=0;z1(B,A,0,C,-1);c=k[B+20>>2]|0;d=B+16|0;e=C+4|0;b=0;while(1){if(b>>>0>=(k[d>>2]|0)>>>0)break;Lg[f&255](k[C>>2]|0,k[e>>2]|0,g,c,y,x);A1(B);b=b+1|0}b=k[D>>2]|0;if((b|0)!=(u|0)){if(b|0)ggb(b);k[D>>2]=u;k[v>>2]=136}d=E+36|0;b=k[d>>2]|0;if(b|0?(C=b+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[E+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;D=E+16|0;c=E+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[c>>2]|0)>0){d=k[E+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[E+44>>2]|0;if(!((b|0)==(E+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=F+36|0;b=k[d>>2]|0;if(b|0?(D=b+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[F+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;E=F+16|0;c=F+4|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[c>>2]|0)>0){d=k[F+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[F+44>>2]|0;if(!((b|0)==(F+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=G+36|0;b=k[d>>2]|0;if(b|0?(E=b+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[G+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;F=G+16|0;d=G+4|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[d>>2]|0)>0){c=k[z>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[G+44>>2]|0;if((b|0)==(G+48|0)|(b|0)==0){r=H;return}ggb(k[b+-4>>2]|0);r=H;return}function bm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=r;r=r+48|0;h=e+32|0;g=e+16|0;f=e;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=a;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;b=f+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=c;VZ(h,g,f,d);r=e;return}function cm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0;e=r;r=r+32|0;g=e+8|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;k[f>>2]=k[b>>2];k[f+4>>2]=k[b+4>>2];d=+hla(g,f,c);r=e;return +d}function dm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0.0,n=0.0,q=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0;U=r;r=r+1424|0;T=U+1368|0;S=U+1312|0;R=U+1256|0;Q=U+1200|0;C=U+1176|0;M=U+1160|0;N=U+1112|0;O=U+32|0;f=U+1144|0;s=U+1096|0;x=U+16|0;z=U;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;h=f+4|0;k[h>>2]=a;k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;q=s+4|0;k[q>>2]=b;w=x+4|0;y=x+4+4|0;k[y>>2]=0;k[y+4>>2]=0;k[x>>2]=33619968;k[w>>2]=c;y=z+4|0;v=z+4+4|0;k[v>>2]=0;k[v+4>>2]=0;k[z>>2]=33619968;k[y>>2]=d;v=S1(s,-1)|0;P=v&7;A=v>>>3&511;B=A+1|0;L=(P|0)==5;I=(P|0)==6;do if((P+-5|0)>>>0<2){if(!(G2(f)|0)?(S1(f,-1)|0)!=(v|0):0){j=4;break}l=T;j=8}else j=4;while(0);if((j|0)==4){k[T>>2]=0;a=T+4|0;k[a>>2]=0;b=ZT(84)|0;k[b>>2]=1;c=b+4|0;k[T>>2]=c;k[a>>2]=77;i[b+81>>0]=0;d=214684;g=c+77|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(g|0));Y8(-215,T,214762,214521,626);k[a>>2]=0;k[T>>2]=0;P=k[b>>2]|0;k[b>>2]=P+-1;if((P|0)==1)ggb(k[b+-4>>2]|0);if((k[f>>2]&2031616|0)==65536){l=T;j=8}else{Q1(T,f,-1);l=T}}do if((j|0)==8){f=k[h>>2]|0;k[T>>2]=k[f>>2];j=T+4|0;a=f+4|0;k[j>>2]=k[a>>2];P=T+8|0;k[P>>2]=k[f+8>>2];k[T+12>>2]=k[f+12>>2];k[T+16>>2]=k[f+16>>2];k[T+20>>2]=k[f+20>>2];k[T+24>>2]=k[f+24>>2];k[T+28>>2]=k[f+28>>2];k[T+32>>2]=k[f+32>>2];b=k[f+36>>2]|0;k[T+36>>2]=b;c=T+40|0;k[c>>2]=P;P=T+48|0;h=T+44|0;k[h>>2]=P;k[T+52>>2]=0;k[P>>2]=0;if(b|0){P=b+12|0;k[P>>2]=(k[P>>2]|0)+1}if((k[a>>2]|0)<3){K=k[f+44>>2]|0;P=k[h>>2]|0;k[P>>2]=k[K>>2];k[P+4>>2]=k[K+4>>2];break}k[j>>2]=0;x1(T,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){g=k[f+40>>2]|0;d=k[c>>2]|0;c=k[f+44>>2]|0;b=k[h>>2]|0;a=0;do{k[d+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}while(0);do if((k[s>>2]&2031616|0)==65536){d=k[q>>2]|0;k[S>>2]=k[d>>2];j=S+4|0;a=d+4|0;k[j>>2]=k[a>>2];P=S+8|0;k[P>>2]=k[d+8>>2];k[S+12>>2]=k[d+12>>2];k[S+16>>2]=k[d+16>>2];k[S+20>>2]=k[d+20>>2];k[S+24>>2]=k[d+24>>2];k[S+28>>2]=k[d+28>>2];k[S+32>>2]=k[d+32>>2];b=k[d+36>>2]|0;k[S+36>>2]=b;c=S+40|0;k[c>>2]=P;P=S+48|0;g=S+44|0;k[g>>2]=P;k[S+52>>2]=0;k[P>>2]=0;if(b|0){P=b+12|0;k[P>>2]=(k[P>>2]|0)+1}if((k[a>>2]|0)<3){K=k[d+44>>2]|0;P=k[g>>2]|0;k[P>>2]=k[K>>2];k[P+4>>2]=k[K+4>>2];break}k[j>>2]=0;x1(S,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[d+40>>2]|0;f=k[c>>2]|0;c=k[d+44>>2]|0;b=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else Q1(S,s,-1);while(0);P=T+16|0;a:do if(k[P>>2]|0){c=k[T+4>>2]|0;if((c|0)<3)a=aa(k[T+12>>2]|0,k[T+8>>2]|0)|0;else{d=k[T+40>>2]|0;b=0;a=1;do{a=aa(k[d+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(c|0))}if(a|0){b=k[S+40>>2]|0;c=k[b+-4>>2]|0;d=k[T+40>>2]|0;b:do if((c|0)==(k[d+-4>>2]|0)){if((c|0)==2){if((k[b>>2]|0)!=(k[d>>2]|0))break;if((k[b+4>>2]|0)==(k[d+4>>2]|0))break a;else break}if((c|0)>0)a=0;else break a;while(1){if((k[b+(a<<2)>>2]|0)!=(k[d+(a<<2)>>2]|0))break b;a=a+1|0;if((a|0)>=(c|0))break a}}while(0);k[R>>2]=0;a=R+4|0;k[a>>2]=0;b=ZT(44)|0;k[b>>2]=1;c=b+4|0;k[R>>2]=c;k[a>>2]=37;i[b+41>>0]=0;d=214774;g=c+37|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(g|0));Y8(-215,R,214762,214521,632);k[a>>2]=0;k[R>>2]=0;K=k[b>>2]|0;k[b>>2]=K+-1;if((K|0)==1)ggb(k[b+-4>>2]|0)}}while(0);K=S+4|0;J=S+40|0;P1(x,k[K>>2]|0,k[J>>2]|0,v,-1,0,0);P1(z,k[K>>2]|0,k[J>>2]|0,v,-1,0,0);do if((k[x>>2]&2031616|0)==65536){d=k[w>>2]|0;k[R>>2]=k[d>>2];j=R+4|0;a=d+4|0;k[j>>2]=k[a>>2];H=R+8|0;k[H>>2]=k[d+8>>2];k[R+12>>2]=k[d+12>>2];k[R+16>>2]=k[d+16>>2];k[R+20>>2]=k[d+20>>2];k[R+24>>2]=k[d+24>>2];k[R+28>>2]=k[d+28>>2];k[R+32>>2]=k[d+32>>2];b=k[d+36>>2]|0;k[R+36>>2]=b;c=R+40|0;k[c>>2]=H;H=R+48|0;g=R+44|0;k[g>>2]=H;k[R+52>>2]=0;k[H>>2]=0;if(b|0){H=b+12|0;k[H>>2]=(k[H>>2]|0)+1}if((k[a>>2]|0)<3){G=k[d+44>>2]|0;H=k[g>>2]|0;k[H>>2]=k[G>>2];k[H+4>>2]=k[G+4>>2];break}k[j>>2]=0;x1(R,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[d+40>>2]|0;f=k[c>>2]|0;c=k[d+44>>2]|0;b=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else Q1(R,x,-1);while(0);do if((k[z>>2]&2031616|0)==65536){d=k[y>>2]|0;k[Q>>2]=k[d>>2];j=Q+4|0;a=d+4|0;k[j>>2]=k[a>>2];H=Q+8|0;k[H>>2]=k[d+8>>2];k[Q+12>>2]=k[d+12>>2];k[Q+16>>2]=k[d+16>>2];k[Q+20>>2]=k[d+20>>2];k[Q+24>>2]=k[d+24>>2];k[Q+28>>2]=k[d+28>>2];k[Q+32>>2]=k[d+32>>2];b=k[d+36>>2]|0;k[Q+36>>2]=b;c=Q+40|0;k[c>>2]=H;H=Q+48|0;g=Q+44|0;k[g>>2]=H;k[Q+52>>2]=0;k[H>>2]=0;if(b|0){H=b+12|0;k[H>>2]=(k[H>>2]|0)+1}if((k[a>>2]|0)<3){G=k[d+44>>2]|0;H=k[g>>2]|0;k[H>>2]=k[G>>2];k[H+4>>2]=k[G+4>>2];break}k[j>>2]=0;x1(Q,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[d+40>>2]|0;f=k[c>>2]|0;c=k[d+44>>2]|0;b=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else Q1(Q,z,-1);while(0);k[C>>2]=T;k[C+4>>2]=S;k[C+8>>2]=R;k[C+12>>2]=Q;k[C+16>>2]=0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;k[N+16>>2]=0;k[N+20>>2]=0;k[N+24>>2]=0;k[N+28>>2]=0;z1(N,C,0,M,-1);G=O+8|0;k[O>>2]=G;H=O+4|0;k[H>>2]=264;F=aa(k[N+20>>2]|0,B)|0;D=A|1024;D=D-((D>>>0)%(B>>>0)|0)|0;D=(D|0)<(F|0)?D:F;E=1212424721>>>(k[S>>2]<<2&28)&15;if(I){c=D<<1;if(c>>>0>264){b=c>>>0>1073741823?-1:c<<2;b=(b|0)==0?1:b;while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[O>>2]=a}else a=G;k[H>>2]=c;C=a;w=a+(D<<2)|0}else{C=0;w=0}x=N+16|0;y=(F|0)>0;z=M+4|0;A=M+8|0;B=M+12|0;t=e?.17777777777777778:10.185916357881302;v=0;while(1){if(v>>>0>=(k[x>>2]|0)>>>0)break;if(y){s=0;do{q=F-s|0;q=(D|0)<(q|0)?D:q;do if(L){a=k[M>>2]|0;d=k[z>>2]|0;f=k[A>>2]|0;g=k[B>>2]|0;if((q|0)>0){c=0;do{n=t*+o[d+(c<<2)>>2];p[u>>3]=n;b=k[u+4>>2]|0;e=b&2146435072;if(!(e>>>0>1126170624|(e|0)==1126170624&0>0)){b=(b|0)<0;m=b?n+-4503599627370496.0+4503599627370496.0:n+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=b?-0.0:0.0}else m=n;e=~~m;V=n-+(e|0);n=V*(V*(V*-1.5767166072981726e-04)+.09817477042468103);V=V*(V*-.004817389940423465)+1.0;m=+p[11376+((e&63)<<3)>>3];W=+p[11376+((16-e&63)<<3)>>3];o[g+(c<<2)>>2]=m*V+W*n;o[f+(c<<2)>>2]=W*V-m*n;c=c+1|0}while((c|0)!=(q|0));if(a){b=0;do{W=+o[a+(b<<2)>>2];e=f+(b<<2)|0;o[e>>2]=W*+o[e>>2];e=g+(b<<2)|0;o[e>>2]=W*+o[e>>2];b=b+1|0}while((b|0)<(q|0));j=94}else j=92}else j=92}else{a=k[M>>2]|0;c=k[z>>2]|0;g=k[A>>2]|0;h=k[B>>2]|0;f=(q|0)>0;if(f){b=0;do{o[C+(b<<2)>>2]=+p[c+(b<<3)>>3];b=b+1|0}while((b|0)<(q|0));c=0;do{d=C+(c<<2)|0;n=t*+o[d>>2];p[u>>3]=n;b=k[u+4>>2]|0;e=b&2146435072;if(!(e>>>0>1126170624|(e|0)==1126170624&0>0)){b=(b|0)<0;m=b?n+-4503599627370496.0+4503599627370496.0:n+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=b?-0.0:0.0}else m=n;e=~~m;n=n-+(e|0);W=n*(n*(n*-1.5767166072981726e-04)+.09817477042468103);n=n*(n*-.004817389940423465)+1.0;V=+p[11376+((e&63)<<3)>>3];m=+p[11376+((16-e&63)<<3)>>3];o[w+(c<<2)>>2]=V*n+m*W;o[d>>2]=m*n-V*W;c=c+1|0}while((c|0)!=(q|0))}if(!a){a=q<<2;upb(g|0,C|0,a|0)|0;upb(h|0,w|0,a|0)|0;a=k[M>>2]|0;j=92;break}if(f){b=0;do{W=+p[a+(b<<3)>>3];p[g+(b<<3)>>3]=W*+o[C+(b<<2)>>2];p[h+(b<<3)>>3]=W*+o[w+(b<<2)>>2];b=b+1|0}while((b|0)<(q|0));j=94}else j=92}while(0);if((j|0)==92){j=0;if(!a)a=aa(q,E)|0;else j=94}if((j|0)==94){e=aa(q,E)|0;k[M>>2]=a+e;a=e}k[z>>2]=(k[z>>2]|0)+a;k[A>>2]=(k[A>>2]|0)+a;k[B>>2]=(k[B>>2]|0)+a;s=s+D|0}while((F|0)>(s|0))}A1(N);v=v+1|0}a=k[O>>2]|0;if((a|0)!=(G|0)){if(a|0)ggb(a);k[O>>2]=G;k[H>>2]=264}c=Q+36|0;a=k[c>>2]|0;if(a|0?(N=a+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[Q+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;O=Q+16|0;b=Q+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[b>>2]|0)>0){c=k[Q+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[Q+44>>2]|0;if(!((a|0)==(Q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=R+36|0;a=k[c>>2]|0;if(a|0?(O=a+12|0,Q=k[O>>2]|0,k[O>>2]=Q+-1,(Q|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[R+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;Q=R+16|0;b=R+4|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[b>>2]|0)>0){c=k[R+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[R+44>>2]|0;if(!((a|0)==(R+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=S+36|0;a=k[c>>2]|0;if((a|0)!=0?(Q=a+12|0,R=k[Q>>2]|0,k[Q>>2]=R+-1,(R|0)==1):0){b=k[c>>2]|0;if(b){a=k[b+4>>2]|0;do if(!a){a=k[S+32>>2]|0;if(a|0)break;a=B1()|0;b=k[c>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;R=S+16|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[K>>2]|0)>0){b=k[J>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[K>>2]|0))}a=k[S+44>>2]|0;if(!((a|0)==(S+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=T+36|0;a=k[c>>2]|0;if(a|0?(R=a+12|0,S=k[R>>2]|0,k[R>>2]=S+-1,(S|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[T+32>>2]|0;if(a|0)break;a=B1()|0;b=k[c>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;c=T+4|0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[c>>2]|0)>0){b=k[T+40>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[T+44>>2]|0;if((a|0)==(T+48|0)|(a|0)==0){r=U;return}ggb(k[a+-4>>2]|0);r=U;return}function em(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;S=r;r=r+2272|0;O=S;R=S+2208|0;Q=S+1144|0;P=S+80|0;L=S+56|0;M=S+64|0;k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=17104896;N=M+4|0;k[N>>2]=b;k[R>>2]=k[a>>2];o=R+4|0;h=a+4|0;b=k[h>>2]|0;k[o>>2]=b;K=R+8|0;k[K>>2]=k[a+8>>2];k[R+12>>2]=k[a+12>>2];k[R+16>>2]=k[a+16>>2];k[R+20>>2]=k[a+20>>2];k[R+24>>2]=k[a+24>>2];k[R+28>>2]=k[a+28>>2];k[R+32>>2]=k[a+32>>2];j=k[a+36>>2]|0;k[R+36>>2]=j;l=R+40|0;k[l>>2]=K;K=R+48|0;n=R+44|0;k[n>>2]=K;k[R+52>>2]=0;k[K>>2]=0;if(j){b=j+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[h>>2]|0}if((b|0)>=3){k[o>>2]=0;x1(R,b,0,0,0);if((k[o>>2]|0)>0){m=k[a+40>>2]|0;l=k[l>>2]|0;j=k[a+44>>2]|0;h=k[n>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[m+(b<<2)>>2];k[h+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[o>>2]|0))}}else{J=k[a+44>>2]|0;K=k[n>>2]|0;k[K>>2]=k[J>>2];k[K+4>>2]=k[J+4>>2]}b=k[M>>2]&2031616;if((b|0)<327680)switch(b|0){case 262144:{a=9;break}default:{F=0;p=1;a=10}}else switch(b|0){case 327680:{a=9;break}default:{F=0;p=1;a=10}}if((a|0)==9?(p=F2(M)|0,p|0):0){F=1;a=10}if((a|0)==10){J=Q+8|0;k[Q>>2]=J;K=Q+4|0;k[K>>2]=264;j=p>>>0>264;if(j){h=p>>>0>1073741823?-1:p<<2;h=(h|0)==0?1:h;while(1){b=fgb(h)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[Q>>2]=b;G=b}else G=J;k[K>>2]=p;H=P+8|0;k[P>>2]=H;I=P+4|0;k[I>>2]=264;if(j){h=p>>>0>1073741823?-1:p<<2;h=(h|0)==0?1:h;while(1){b=fgb(h)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[P>>2]=b;k[I>>2]=p;if((p|0)>0)a=23;else l=b}else{k[I>>2]=p;b=H;a=23}if((a|0)==23){q=O+4|0;s=O+8|0;t=O+12|0;u=O+16|0;v=O+20|0;w=O+24|0;x=O+28|0;y=O+32|0;z=O+36|0;A=O+40|0;B=O+48|0;C=O+44|0;D=O+52|0;E=L+4|0;o=0;do{h=F?o:-1;do if((h|0)<0?(k[M>>2]&2031616|0)==65536:0){l=k[N>>2]|0;k[O>>2]=k[l>>2];h=l+4|0;k[q>>2]=k[h>>2];k[s>>2]=k[l+8>>2];k[t>>2]=k[l+12>>2];k[u>>2]=k[l+16>>2];k[v>>2]=k[l+20>>2];k[w>>2]=k[l+24>>2];k[x>>2]=k[l+28>>2];k[y>>2]=k[l+32>>2];j=k[l+36>>2]|0;k[z>>2]=j;k[A>>2]=s;k[C>>2]=B;k[D>>2]=0;k[B>>2]=0;if(j|0){n=j+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[h>>2]|0)<3){n=k[l+44>>2]|0;a=k[C>>2]|0;k[a>>2]=k[n>>2];k[a+4>>2]=k[n+4>>2];a=33;break}k[q>>2]=0;x1(O,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){a=k[l+40>>2]|0;n=k[A>>2]|0;j=k[l+44>>2]|0;l=k[C>>2]|0;h=0;do{k[n+(h<<2)>>2]=k[a+(h<<2)>>2];k[l+(h<<2)>>2]=k[j+(h<<2)>>2];h=h+1|0;m=k[q>>2]|0}while((h|0)<(m|0));a=34}else a=36}else{Q1(O,M,h);a=33}while(0);if((a|0)==33){m=k[q>>2]|0;a=34}if((a|0)==34){a=0;if((m|0)<3)a=36;else{l=k[A>>2]|0;j=0;h=1;do{h=aa(k[l+(j<<2)>>2]|0,h)|0;j=j+1|0}while((j|0)!=(m|0))}}if((a|0)==36)h=aa(k[t>>2]|0,k[s>>2]|0)|0;if(!h){k[G+(o<<2)>>2]=0;k[b+(o<<2)>>2]=0}else{if((y2(O,2,4,1)|0)<=-1){k[L>>2]=0;k[E>>2]=0;h=ZT(36)|0;k[h>>2]=1;m=h+4|0;k[L>>2]=m;k[E>>2]=29;i[h+33>>0]=0;a=246877;n=m+29|0;do{i[m>>0]=i[a>>0]|0;m=m+1|0;a=a+1|0}while((m|0)<(n|0));Y8(-215,L,246802,246054,2308);k[E>>2]=0;k[L>>2]=0;n=k[h>>2]|0;k[h>>2]=n+-1;if((n|0)==1)ggb(k[h+-4>>2]|0)}k[G+(o<<2)>>2]=k[u>>2];n=aa(k[t>>2]|0,k[s>>2]|0)|0;n=(aa(n,((k[O>>2]|0)>>>3&511)+1|0)|0)/2|0;k[b+(o<<2)>>2]=n}h=k[z>>2]|0;if(h|0?(a=h+12|0,n=k[a>>2]|0,k[a>>2]=n+-1,(n|0)==1):0){j=k[z>>2]|0;if(j|0){h=k[j+4>>2]|0;if(!h){h=k[y>>2]|0;if(!h){h=B1()|0;j=k[z>>2]|0}}jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[z>>2]=0}k[z>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[q>>2]|0)>0){j=k[A>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[q>>2]|0))}h=k[C>>2]|0;if(!((h|0)==(B|0)|(h|0)==0))ggb(k[h+-4>>2]|0);o=o+1|0}while((o|0)<(p|0));l=b}if((f|0)==16)j=(k[R>>2]&7|0)==0?16:8;else j=f;if(!(g>>>0<17&((e|0)<32768&((G|0)!=0&(l|0)!=0&(p|e|0)>-1)))){k[O>>2]=0;b=O+4|0;k[b>>2]=0;h=ZT(120)|0;k[h>>2]=1;m=h+4|0;k[O>>2]=m;k[b>>2]=112;i[h+116>>0]=0;a=246689;n=m+112|0;do{i[m>>0]=i[a>>0]|0;m=m+1|0;a=a+1|0}while((m|0)<(n|0));Y8(-215,O,246802,246054,1928);k[b>>2]=0;k[O>>2]=0;f=k[h>>2]|0;k[h>>2]=f+-1;if((f|0)==1)ggb(k[h+-4>>2]|0)}z2(d,O,k[R>>2]&4095,0);if((p|0)>0){b=0;do{Ofa(R,k[G+(b<<2)>>2]|0,k[l+(b<<2)>>2]|0,c,O,e,j,g);b=b+1|0}while((b|0)!=(p|0))}b=k[P>>2]|0;if((b|0)!=(H|0)){if(b|0)ggb(b);k[P>>2]=H;k[I>>2]=264}b=k[Q>>2]|0;if((b|0)!=(J|0)){if(b|0)ggb(b);k[Q>>2]=J;k[K>>2]=264}}j=R+36|0;b=k[j>>2]|0;if(b|0?(P=b+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){h=k[j>>2]|0;if(h|0){b=k[h+4>>2]|0;if(!b){b=k[R+32>>2]|0;if(!b){b=B1()|0;h=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[j>>2]=0}k[j>>2]=0;Q=R+16|0;h=R+4|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[h>>2]|0)>0){j=k[R+40>>2]|0;b=0;do{k[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[h>>2]|0))}b=k[R+44>>2]|0;if((b|0)==(R+48|0)|(b|0)==0){r=S;return}ggb(k[b+-4>>2]|0);r=S;return}function fm(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0;d=r;r=r+32|0;f=d+16|0;e=d;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=a;a=e+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=c;ZZ(f,b,e);r=d;return}function gm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0.0;ha=r;r=r+464|0;ga=ha+408|0;ba=ha+352|0;X=ha+296|0;S=ha+240|0;N=ha+184|0;M=ha+128|0;p=ha+120|0;H=ha+64|0;s=ha+48|0;t=ha+16|0;j=ha+32|0;q=ha;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;l=j+4|0;k[l>>2]=a;n=q+4|0;fa=q+4+4|0;k[fa>>2]=0;k[fa+4>>2]=0;k[q>>2]=33619968;k[n>>2]=b;switch(S1(j,-1)|0){case 0:case 5:{b=16842752;break}default:{k[ga>>2]=0;a=ga+4|0;k[a>>2]=0;b=ZT(40)|0;k[b>>2]=1;g=b+4|0;k[ga>>2]=g;k[a>>2]=35;i[b+39>>0]=0;e=244103;h=g+35|0;do{i[g>>0]=i[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(h|0));Y8(-215,ga,244139,244035,723);k[a>>2]=0;k[ga>>2]=0;fa=k[b>>2]|0;k[b>>2]=fa+-1;if((fa|0)==1)ggb(k[b+-4>>2]|0);b=k[j>>2]|0}}k[ga>>2]=1124007936;ea=ga+4|0;a=ga+8|0;ca=ga+40|0;g=ea;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[ca>>2]=a;fa=ga+48|0;da=ga+44|0;k[da>>2]=fa;k[ga+52>>2]=0;k[fa>>2]=0;k[ba>>2]=1124007936;_=ba+4|0;a=ba+8|0;Y=ba+40|0;g=_;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Y>>2]=a;$=ba+48|0;Z=ba+44|0;k[Z>>2]=$;k[ba+52>>2]=0;k[$>>2]=0;k[X>>2]=1124007936;V=X+4|0;a=X+8|0;T=X+40|0;g=V;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[T>>2]=a;W=X+48|0;U=X+44|0;k[U>>2]=W;k[X+52>>2]=0;k[W>>2]=0;k[S>>2]=1124007936;Q=S+4|0;a=S+8|0;O=S+40|0;g=Q;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[O>>2]=a;R=S+48|0;P=S+44|0;k[P>>2]=R;k[S+52>>2]=0;k[R>>2]=0;k[N>>2]=1124007936;L=N+4|0;a=N+8|0;J=N+40|0;g=L;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[J>>2]=a;K=N+48|0;I=N+44|0;k[I>>2]=K;k[N+52>>2]=0;k[K>>2]=0;do if((b&2031616|0)==65536){e=k[l>>2]|0;k[M>>2]=k[e>>2];l=M+4|0;a=e+4|0;k[l>>2]=k[a>>2];u=M+8|0;k[u>>2]=k[e+8>>2];k[M+12>>2]=k[e+12>>2];k[M+16>>2]=k[e+16>>2];k[M+20>>2]=k[e+20>>2];k[M+24>>2]=k[e+24>>2];k[M+28>>2]=k[e+28>>2];k[M+32>>2]=k[e+32>>2];b=k[e+36>>2]|0;k[M+36>>2]=b;m=M+40|0;k[m>>2]=u;u=M+48|0;j=M+44|0;k[j>>2]=u;k[M+52>>2]=0;k[u>>2]=0;if(b|0){u=b+12|0;k[u>>2]=(k[u>>2]|0)+1}if((k[a>>2]|0)<3){l=k[e+44>>2]|0;u=k[j>>2]|0;k[u>>2]=k[l>>2];k[u+4>>2]=k[l+4>>2];u=m;break}k[l>>2]=0;x1(M,k[a>>2]|0,0,0,0);if((k[l>>2]|0)>0){g=k[e+40>>2]|0;h=k[m>>2]|0;e=k[e+44>>2]|0;b=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[l>>2]|0));u=m}else u=m}else{Q1(M,j,-1);u=M+40|0}while(0);l=k[u>>2]|0;m=k[l>>2]|0;k[p>>2]=k[l+4>>2];k[p+4>>2]=m;x2(q,p,5,0);do if((k[q>>2]&2031616|0)==65536){g=k[n>>2]|0;k[H>>2]=k[g>>2];m=H+4|0;a=g+4|0;k[m>>2]=k[a>>2];q=H+8|0;k[q>>2]=k[g+8>>2];k[H+12>>2]=k[g+12>>2];k[H+16>>2]=k[g+16>>2];k[H+20>>2]=k[g+20>>2];k[H+24>>2]=k[g+24>>2];k[H+28>>2]=k[g+28>>2];k[H+32>>2]=k[g+32>>2];b=k[g+36>>2]|0;k[H+36>>2]=b;e=H+40|0;k[e>>2]=q;q=H+48|0;j=H+44|0;k[j>>2]=q;k[H+52>>2]=0;k[q>>2]=0;if(b|0){q=b+12|0;k[q>>2]=(k[q>>2]|0)+1}if((k[a>>2]|0)<3){p=k[g+44>>2]|0;q=k[j>>2]|0;k[q>>2]=k[p>>2];k[q+4>>2]=k[p+4>>2];break}k[m>>2]=0;x1(H,k[a>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[e>>2]|0;e=k[g+44>>2]|0;b=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[l+(a<<2)>>2];k[b+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0))}}else Q1(H,q,-1);while(0);k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=M;g=t+4|0;e=g+4|0;k[e>>2]=0;k[e+4>>2]=0;k[t>>2]=33619968;k[g>>2]=ga;tfa(s,t,5,1,0,c,1.0,0.0,d);k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=M;g=t+4|0;e=g+4|0;k[e>>2]=0;k[e+4>>2]=0;k[t>>2]=33619968;k[g>>2]=ba;tfa(s,t,5,0,1,c,1.0,0.0,d);k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=M;g=t+4|0;e=g+4|0;k[e>>2]=0;k[e+4>>2]=0;k[t>>2]=33619968;k[g>>2]=X;tfa(s,t,5,2,0,c,1.0,0.0,d);k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=M;g=t+4|0;e=g+4|0;k[e>>2]=0;k[e+4>>2]=0;k[t>>2]=33619968;k[g>>2]=S;tfa(s,t,5,0,2,c,1.0,0.0,d);k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=M;g=t+4|0;e=g+4|0;k[e>>2]=0;k[e+4>>2]=0;k[t>>2]=33619968;k[g>>2]=N;tfa(s,t,5,1,1,c,1.0,0.0,d);f=+(1<<c+-1|0);f=(k[M>>2]&7|0)==0?f*255.0:f;f=1.0/(f*(f*f));g=k[u>>2]|0;e=k[g+4>>2]|0;g=k[g>>2]|0;if((g|0)>0?(v=k[H+16>>2]|0,w=k[k[H+44>>2]>>2]|0,x=k[ga+16>>2]|0,y=k[k[da>>2]>>2]|0,z=k[ba+16>>2]|0,A=k[k[Z>>2]>>2]|0,B=k[X+16>>2]|0,C=k[k[U>>2]>>2]|0,D=k[S+16>>2]|0,E=k[k[P>>2]>>2]|0,F=k[N+16>>2]|0,G=k[k[I>>2]>>2]|0,(e|0)>0):0){a=0;do{h=v+(aa(w,a)|0)|0;j=x+(aa(y,a)|0)|0;l=z+(aa(A,a)|0)|0;m=B+(aa(C,a)|0)|0;n=D+(aa(E,a)|0)|0;p=F+(aa(G,a)|0)|0;b=0;do{ja=+o[j+(b<<2)>>2];ia=+o[l+(b<<2)>>2];o[h+(b<<2)>>2]=f*(ja*ja*+o[n+(b<<2)>>2]+ia*ia*+o[m+(b<<2)>>2]-ja*2.0*ia*+o[p+(b<<2)>>2]);b=b+1|0}while((b|0)!=(e|0));a=a+1|0}while((a|0)!=(g|0))}e=H+36|0;a=k[e>>2]|0;if(a|0?(F=a+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[H+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;G=H+16|0;b=H+4|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[b>>2]|0)>0){e=k[H+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[H+44>>2]|0;if(!((a|0)==(H+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=M+36|0;a=k[e>>2]|0;if(a|0?(G=a+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[M+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;H=M+16|0;e=M+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[e>>2]|0)>0){b=k[u>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[M+44>>2]|0;if(!((a|0)==(M+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=N+36|0;a=k[e>>2]|0;if(a|0?(H=a+12|0,M=k[H>>2]|0,k[H>>2]=M+-1,(M|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[N+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;N=N+16|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[L>>2]|0)>0){b=k[J>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[L>>2]|0))}a=k[I>>2]|0;if(!((a|0)==(K|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=S+36|0;a=k[e>>2]|0;if(a|0?(M=a+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[S+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;S=S+16|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[Q>>2]|0)>0){b=k[O>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Q>>2]|0))}a=k[P>>2]|0;if(!((a|0)==(R|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=X+36|0;a=k[e>>2]|0;if(a|0?(R=a+12|0,S=k[R>>2]|0,k[R>>2]=S+-1,(S|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[X+32>>2]|0;if(a|0)break;a=B1()|0;b=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;X=X+16|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[V>>2]|0)>0){b=k[T>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[V>>2]|0))}a=k[U>>2]|0;if(!((a|0)==(W|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=ba+36|0;a=k[e>>2]|0;do if(a|0){W=a+12|0;X=k[W>>2]|0;k[W>>2]=X+-1;if((X|0)!=1)break;b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[ba+32>>2]|0;if(a|0)break;a=B1()|0;b=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}while(0);k[e>>2]=0;ba=ba+16|0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[_>>2]|0)>0){b=k[Y>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[_>>2]|0))}a=k[Z>>2]|0;if(!((a|0)==($|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=ga+36|0;a=k[e>>2]|0;do if(a|0){$=a+12|0;ba=k[$>>2]|0;k[$>>2]=ba+-1;if((ba|0)!=1)break;b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[ga+32>>2]|0;if(a|0)break;a=B1()|0;b=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}while(0);k[e>>2]=0;ga=ga+16|0;k[ga>>2]=0;k[ga+4>>2]=0;k[ga+8>>2]=0;k[ga+12>>2]=0;if((k[ea>>2]|0)>0){b=k[ca>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ea>>2]|0))}a=k[da>>2]|0;if((a|0)==(fa|0)|(a|0)==0){r=ha;return}ggb(k[a+-4>>2]|0);r=ha;return}function hm(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;j=j|0;var m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;K=r;r=r+144|0;J=K+88|0;E=K+32|0;F=K+72|0;G=K+64|0;s=K;m=b+11|0;n=i[m>>0]|0;o=n<<24>>24<0;if(!((o?k[b+4>>2]|0:n&255)|0)){I=0;D=0}else{D=o?k[b+4>>2]|0:n&255;I=ZT(D+8&-4)|0;k[I>>2]=1;I=I+4|0;i[I+D>>0]=0;upb(I|0,((i[m>>0]|0)<0?k[b>>2]|0:b)|0,D|0)|0}t=k[c>>2]|0;v=k[c+4>>2]|0;b=0;while(1){if((b|0)==4)break;p[s+(b<<3)>>3]=+p[f+(b<<3)>>3];b=b+1|0}if(D|0){k[J>>2]=k[a>>2];q=J+4|0;m=a+4|0;b=k[m>>2]|0;k[q>>2]=b;C=J+8|0;k[C>>2]=k[a+8>>2];k[J+12>>2]=k[a+12>>2];k[J+16>>2]=k[a+16>>2];k[J+20>>2]=k[a+20>>2];k[J+24>>2]=k[a+24>>2];k[J+28>>2]=k[a+28>>2];k[J+32>>2]=k[a+32>>2];n=k[a+36>>2]|0;k[J+36>>2]=n;o=J+40|0;k[o>>2]=C;C=J+48|0;f=J+44|0;k[f>>2]=C;k[J+52>>2]=0;k[C>>2]=0;if(n){b=n+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[m>>2]|0}if((b|0)>=3){k[q>>2]=0;x1(J,b,0,0,0);if((k[q>>2]|0)>0){c=k[a+40>>2]|0;o=k[o>>2]|0;n=k[a+44>>2]|0;m=k[f>>2]|0;b=0;do{k[o+(b<<2)>>2]=k[c+(b<<2)>>2];k[m+(b<<2)>>2]=k[n+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else{B=k[a+44>>2]|0;C=k[f>>2]|0;k[C>>2]=k[B>>2];k[C+4>>2]=k[B+4>>2]}C=_fa(d)|0;z2(s,E,k[J>>2]&4095,0);o=k[C>>2]&15;e=e*65536.0;p[u>>3]=e;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;e=b?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=b?-0.0:0.0}B=~~e;if((h|0)==16)h=(k[J>>2]&7|0)==0?16:8;z=j?0-B|0:B;n=t<<16;x=v<<16;k[F>>2]=0;A=F+4|0;k[A>>2]=0;k[F+8>>2]=0;y=F+8|0;while(1){b=fgb(8192)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}m=b;k[F>>2]=m;k[A>>2]=m;k[y>>2]=b+8192;if((D|0)>0){j=-82-o|0;w=G+4|0;v=(d|0)==3;o=0;a=m;q=m;while(1){f=i[I+o>>0]|0;b=f&255;a:do if(v&f<<24>>24<0){switch(f<<24>>24){case -48:{m=o+1|0;b=i[I+m>>0]|0;if((b+112&255)<48){s=175;b=(b&255)+-17|0;f=127;o=m;break a}else c=b;break}case -47:{m=o+1|0;b=i[I+m>>0]|0;if(b<<24>>24<0&(b&255)<144){s=191;b=(b&255)+47|0;f=175;o=m;break a}else c=b;break}default:{if((f&255)<=191){s=127;b=63;f=32;break a}m=o+1|0;m=(i[I+m>>0]|0)==0?o:m;if((f&255)<=223){s=127;b=63;f=32;o=m;break a}b=m+1|0;d=(i[I+b>>0]|0)==0;o=d?m:b;b=d?m:b;if((f&255)<=239){s=127;b=63;f=32;break a}d=b+1|0;t=(i[I+d>>0]|0)==0;c=t?o:d;b=t?b:d;if((f&255)<=247){s=127;b=63;f=32;o=c;break a}m=b+1|0;o=(i[I+m>>0]|0)==0;c=o?c:m;if((f&255)<=251){s=127;b=63;f=32;o=c;break a}o=(o?b:m)+1|0;s=127;b=63;f=32;o=(i[I+o>>0]|0)==0?c:o;break a}}s=127;b=63;f=32;o=c<<24>>24==0?o:m}else{s=127;f=32}while(0);m=k[72624+(k[C+(((b|0)>=(s|0)|(b|0)<(f|0)?32:b+-31|0)<<2)>>2]<<2)>>2]|0;t=aa((l[m+1>>0]|0)+-82|0,B)|0;s=n-(aa((l[m>>0]|0)+-82|0,B)|0)|0;b=q;if(!((q|0)==(a|0)|(b|0)==(a|0)))k[A>>2]=b+(~((b+-8-a|0)>>>3)<<3);c=m+2|0;b:while(1){b=i[c>>0]|0;switch(b<<24>>24){case 0:case 32:break;default:{b=(aa((b&255)+-82|0,B)|0)+s|0;m=(aa(j+(l[c+1>>0]|0)|0,z)|0)+x|0;k[G>>2]=b;k[w>>2]=m;n=k[A>>2]|0;if((n|0)==(k[y>>2]|0))Efa(F,G);else{k[n>>2]=b;k[n+4>>2]=m;k[A>>2]=n+8}c=c+2|0;continue b}}q=k[A>>2]|0;a=k[F>>2]|0;n=q-a>>3;f=a;m=q;if(n>>>0>1){Ofa(J,f,n,0,E,g,h,16);b=i[c>>0]|0}if(!(b<<24>>24))break;b=c+1|0;if((q|0)==(a|0)|(m|0)==(f|0)){c=b;continue}k[A>>2]=m+(~((m+-8-a|0)>>>3)<<3);c=b}b=o+1|0;if((b|0)<(D|0)){o=b;n=s+t|0}else break}if(a|0){b=a;if((m|0)==(f|0))H=28;else{k[A>>2]=m+(~((m+-8-a|0)>>>3)<<3);H=28}}}else H=28;if((H|0)==28)ggb(b);n=J+36|0;b=k[n>>2]|0;if(b|0?(g=b+12|0,H=k[g>>2]|0,k[g>>2]=H+-1,(H|0)==1):0){m=k[n>>2]|0;if(m|0){b=k[m+4>>2]|0;if(!b){b=k[J+32>>2]|0;if(!b){b=B1()|0;m=k[n>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,m)}k[n>>2]=0}k[n>>2]=0;H=J+16|0;m=J+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[m>>2]|0)>0){n=k[J+40>>2]|0;b=0;do{k[n+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[J+44>>2]|0;if(!((b|0)==(J+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if(!I){r=K;return}H=I+-4|0;J=k[H>>2]|0;k[H>>2]=J+-1;if((J|0)!=1){r=K;return}ggb(k[I+-8>>2]|0);r=K;return}function im(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;Jra(g,f,c,d);r=e;return}function jm(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0;Kb=r;r=r+3568|0;Db=Kb+3552|0;Jb=Kb+3496|0;t=Kb+3488|0;Hb=Kb+3432|0;Fb=Kb+3420|0;Gb=Kb+3408|0;Eb=Kb+3352|0;vb=Kb+280|0;wb=Kb+208|0;xb=Kb+152|0;yb=Kb+32|0;zb=Kb+136|0;Ab=Kb+120|0;Bb=Kb+64|0;Cb=Kb;q=Kb+264|0;s=q+4|0;x=q+4+4|0;k[x>>2]=0;k[x+4>>2]=0;k[q>>2]=33619968;k[s>>2]=b;x=k[f>>2]|0;w=k[f+4>>2]|0;C=+p[f+8>>3];k[Jb>>2]=k[a>>2];n=Jb+4|0;f=a+4|0;b=k[f>>2]|0;k[n>>2]=b;ub=Jb+8|0;k[ub>>2]=k[a+8>>2];k[Jb+12>>2]=k[a+12>>2];Ib=Jb+16|0;k[Ib>>2]=k[a+16>>2];k[Jb+20>>2]=k[a+20>>2];k[Jb+24>>2]=k[a+24>>2];k[Jb+28>>2]=k[a+28>>2];k[Jb+32>>2]=k[a+32>>2];g=k[a+36>>2]|0;k[Jb+36>>2]=g;h=Jb+40|0;k[h>>2]=ub;ub=Jb+48|0;m=Jb+44|0;k[m>>2]=ub;k[Jb+52>>2]=0;k[ub>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[f>>2]|0}if((b|0)>=3){k[n>>2]=0;x1(Jb,b,0,0,0);if((k[n>>2]|0)>0){j=k[a+40>>2]|0;h=k[h>>2]|0;g=k[a+44>>2]|0;f=k[m>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else{tb=k[a+44>>2]|0;ub=k[m>>2]|0;k[ub>>2]=k[tb>>2];k[ub+4>>2]=k[tb+4>>2]}if(k[Ib>>2]|0){g=k[Jb+4>>2]|0;if((g|0)<3)b=aa(k[Jb+12>>2]|0,k[Jb+8>>2]|0)|0;else{h=k[Jb+40>>2]|0;f=0;b=1;do{b=aa(k[h+(f<<2)>>2]|0,b)|0;f=f+1|0}while((f|0)!=(g|0))}if(b|0){v=Jb+40|0;tb=k[v>>2]|0;ub=k[tb>>2]|0;k[t>>2]=k[tb+4>>2];k[t+4>>2]=ub;x2(q,t,k[Jb>>2]&4095,0);do if((k[q>>2]&2031616|0)==65536){h=k[s>>2]|0;k[Hb>>2]=k[h>>2];n=Hb+4|0;b=h+4|0;k[n>>2]=k[b>>2];ub=Hb+8|0;k[ub>>2]=k[h+8>>2];k[Hb+12>>2]=k[h+12>>2];k[Hb+16>>2]=k[h+16>>2];k[Hb+20>>2]=k[h+20>>2];k[Hb+24>>2]=k[h+24>>2];k[Hb+28>>2]=k[h+28>>2];k[Hb+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[Hb+36>>2]=f;g=Hb+40|0;k[g>>2]=ub;ub=Hb+48|0;m=Hb+44|0;k[m>>2]=ub;k[Hb+52>>2]=0;k[ub>>2]=0;if(f|0){ub=f+12|0;k[ub>>2]=(k[ub>>2]|0)+1}if((k[b>>2]|0)<3){tb=k[h+44>>2]|0;ub=k[m>>2]|0;k[ub>>2]=k[tb>>2];k[ub+4>>2]=k[tb+4>>2];break}k[n>>2]=0;x1(Hb,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){a=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[m>>2]|0;b=0;do{k[j+(b<<2)>>2]=k[a+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else Q1(Hb,q,-1);while(0);if(e>>>0>8){k[Db>>2]=0;b=Db+4|0;k[b>>2]=0;f=ZT(60)|0;k[f>>2]=1;s=f+4|0;k[Db>>2]=s;k[b>>2]=53;i[f+57>>0]=0;g=348118;t=s+53|0;do{i[s>>0]=i[g>>0]|0;s=s+1|0;g=g+1|0}while((s|0)<(t|0));Y8(-211,Db,348172,348019,347);k[b>>2]=0;k[Db>>2]=0;ub=k[f>>2]|0;k[f>>2]=ub+-1;if((ub|0)==1)ggb(k[f+-4>>2]|0)}q=e+1|0;k[Fb>>2]=0;a=Fb+4|0;k[a>>2]=0;k[Fb+8>>2]=0;n=(q|0)==0;if(!n){if(q>>>0>76695844)ad(426534,426557,304,426811);f=q*56|0;f=(f|0)==0?1:f;while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[a>>2]=b;k[Fb>>2]=b;k[Fb+8>>2]=b+(q*56|0);f=q;m=b;j=b;while(1){k[m>>2]=1124007936;g=m+8|0;h=m+40|0;s=m+4|0;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[h>>2]=g;g=m+48|0;k[m+44>>2]=g;k[m+52>>2]=0;k[g>>2]=0;g=j+56|0;f=f+-1|0;if(!f)break;else{m=g;j=g}}k[a>>2]=b+(q*56|0)}k[Gb>>2]=0;a=Gb+4|0;k[a>>2]=0;k[Gb+8>>2]=0;if(!n){if(q>>>0>76695844)ad(426534,426557,304,426811);f=q*56|0;f=(f|0)==0?1:f;while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[a>>2]=b;k[Gb>>2]=b;k[Gb+8>>2]=b+(q*56|0);f=q;m=b;j=b;while(1){k[m>>2]=1124007936;g=m+8|0;h=m+40|0;s=m+4|0;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[h>>2]=g;g=m+48|0;k[m+44>>2]=g;k[m+52>>2]=0;k[g>>2]=0;g=j+56|0;f=f+-1|0;if(!f)break;else{m=g;j=g}}k[a>>2]=b+(q*56|0)}k[Eb>>2]=1124007936;sb=Eb+4|0;B=Eb+8|0;rb=Eb+40|0;s=sb;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[rb>>2]=B;ub=Eb+48|0;tb=Eb+44|0;k[tb>>2]=ub;k[Eb+52>>2]=0;k[ub>>2]=0;d=d*d;p[u>>3]=d;b=k[u+4>>2]|0;qb=b&2146435072;if(!(qb>>>0>1126170624|(qb|0)==1126170624&0>0)){b=(b|0)<0;d=b?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=b?-0.0:0.0}ob=~~d;pb=(ob|0)<16?16:ob;b=k[Jb>>2]|0;if((b&4095|0)!=16){k[Db>>2]=0;b=Db+4|0;k[b>>2]=0;f=ZT(48)|0;k[f>>2]=1;s=f+4|0;k[Db>>2]=s;k[b>>2]=42;i[f+46>>0]=0;g=348194;t=s+42|0;do{i[s>>0]=i[g>>0]|0;s=s+1|0;g=g+1|0}while((s|0)<(t|0));Y8(-210,Db,348172,348019,364);k[b>>2]=0;k[Db>>2]=0;qb=k[f>>2]|0;k[f>>2]=qb+-1;if((qb|0)==1)ggb(k[f+-4>>2]|0);b=k[Jb>>2]|0}if((k[Hb>>2]^b)&4095|0){k[Db>>2]=0;b=Db+4|0;k[b>>2]=0;f=ZT(56)|0;k[f>>2]=1;s=f+4|0;k[Db>>2]=s;k[b>>2]=51;i[f+55>>0]=0;g=348237;t=s+51|0;do{i[s>>0]=i[g>>0]|0;s=s+1|0;g=g+1|0}while((s|0)<(t|0));Y8(-205,Db,348172,348019,367);k[b>>2]=0;k[Db>>2]=0;qb=k[f>>2]|0;k[f>>2]=qb+-1;if((qb|0)==1)ggb(k[f+-4>>2]|0)}lb=k[v>>2]|0;qb=Hb+40|0;nb=k[qb>>2]|0;if((k[lb>>2]|0)!=(k[nb>>2]|0)?1:(k[lb+4>>2]|0)!=(k[nb+4>>2]|0)){k[Db>>2]=0;b=Db+4|0;k[b>>2]=0;f=ZT(56)|0;k[f>>2]=1;s=f+4|0;k[Db>>2]=s;k[b>>2]=51;i[f+55>>0]=0;g=348289;t=s+51|0;do{i[s>>0]=i[g>>0]|0;s=s+1|0;g=g+1|0}while((s|0)<(t|0));Y8(-209,Db,348172,348019,370);k[b>>2]=0;k[Db>>2]=0;nb=k[f>>2]|0;k[f>>2]=nb+-1;if((nb|0)==1)ggb(k[f+-4>>2]|0)}D=(x&1|0)==0?5:w;D=(D|0)<1?1:D;nb=(D|0)>100?100:D;d=(x&2|0)==0?1.0:C;f=d<0.0;b=0;do{lb=b+-255|0;lb=aa(lb,lb)|0;k[vb+(b<<2)>>2]=lb;b=b+1|0}while((b|0)!=768);mb=f?0.0:d;a=k[Fb>>2]|0;KG(a,Jb)|0;n=k[Gb>>2]|0;KG(n,Hb)|0;if((e|0)>=1){q=Db+4|0;s=Db+8|0;t=Db+12|0;v=Db+4|0;w=wb+4|0;x=w+4|0;y=xb+4|0;m=1;while(1){z=a+(m*56|0)|0;A=m+-1|0;g=((k[a+(A*56|0)+8>>2]|0)+1|0)/2|0;j=((k[a+(A*56|0)+12>>2]|0)+1|0)/2|0;b=k[a+(A*56|0)>>2]&4095;do if((k[a+(m*56|0)+4>>2]|0)<3?(k[a+(m*56|0)+8>>2]|0)==(g|0):0){if((k[a+(m*56|0)+12>>2]|0)!=(j|0)){F=71;break}f=k[z>>2]|0;if((f&4095|0)!=(b|0)){F=71;break}if(!(k[a+(m*56|0)+16>>2]|0))F=71}else F=71;while(0);if((F|0)==71){F=0;k[Db>>2]=g;k[q>>2]=j;G1(z,2,Db,b);f=k[a+(m*56|0)>>2]|0;g=k[a+(m*56|0)+8>>2]|0;j=k[a+(m*56|0)+12>>2]|0}h=n+(m*56|0)|0;b=f&4095;do if((k[n+(m*56|0)+4>>2]|0)<3){if((k[n+(m*56|0)+8>>2]|0)!=(g|0)){F=77;break}if((k[n+(m*56|0)+12>>2]|0)!=(j|0)){F=77;break}if((k[h>>2]&4095|0)!=(b|0)){F=77;break}if(!(k[n+(m*56|0)+16>>2]|0))F=77}else F=77;while(0);if((F|0)==77){F=0;k[Db>>2]=g;k[q>>2]=j;G1(h,2,Db,b)}k[s>>2]=0;k[t>>2]=0;k[Db>>2]=16842752;k[v>>2]=a+(A*56|0);kb=x;k[kb>>2]=0;k[kb+4>>2]=0;k[wb>>2]=33619968;k[w>>2]=z;kb=k[a+(m*56|0)+40>>2]|0;lb=k[kb>>2]|0;k[xb>>2]=k[kb+4>>2];k[y>>2]=lb;Jra(Db,wb,xb,4);if((m|0)<(e|0))m=m+1|0;else break}}b=k[Jb+8>>2]|0;f=k[Jb+12>>2]|0;if(!(((((k[sb>>2]|0)<3?(k[B>>2]|0)==(b|0):0)?(k[Eb+12>>2]|0)==(f|0):0)?(k[Eb>>2]&4095|0)==0:0)?(k[Eb+16>>2]|0)!=0:0)){k[Db>>2]=b;k[Db+4>>2]=f;G1(Eb,2,Db,0)}if((e|0)>-1){ia=wb+4|0;ja=wb+8|0;ka=wb+12|0;la=wb+16|0;ma=wb+20|0;na=wb+24|0;oa=wb+28|0;pa=wb+32|0;qa=wb+36|0;ra=wb+40|0;sa=wb+48|0;ta=wb+44|0;ua=wb+52|0;va=Eb+16|0;wa=xb+4|0;xa=xb+8|0;ya=xb+12|0;za=xb+16|0;Aa=xb+20|0;Ba=xb+24|0;Ca=xb+28|0;Da=xb+40|0;Ea=xb+48|0;Fa=xb+44|0;Ga=xb+52|0;Ha=Db+4|0;Ia=Db+8|0;Ja=Db+12|0;Ka=Db+4|0;La=yb+4|0;Ma=La+4|0;Na=zb+4|0;Oa=Db+8|0;Pa=Db+12|0;Qa=Db+4|0;Ra=yb+8|0;Sa=yb+12|0;Ta=yb+4|0;Ua=zb+4|0;Va=Ua+4|0;Wa=Bb+4|0;Xa=Bb+8|0;Ya=Bb+40|0;Za=Bb+48|0;_a=Bb+44|0;$a=Bb+52|0;ab=Ab+8|0;bb=Ab+12|0;cb=Ab+4|0;db=Cb+8|0;eb=Cb+16|0;fb=Cb+24|0;gb=Bb+36|0;hb=Bb+16|0;ib=xb+36|0;jb=Db+4|0;kb=xb+32|0;lb=Bb+32|0;ha=(D|0)>0;ga=e;while(1){g=k[Fb>>2]|0;k[wb>>2]=k[g+(ga*56|0)>>2];b=g+(ga*56|0)+4|0;k[ia>>2]=k[b>>2];k[ja>>2]=k[g+(ga*56|0)+8>>2];k[ka>>2]=k[g+(ga*56|0)+12>>2];k[la>>2]=k[g+(ga*56|0)+16>>2];k[ma>>2]=k[g+(ga*56|0)+20>>2];k[na>>2]=k[g+(ga*56|0)+24>>2];k[oa>>2]=k[g+(ga*56|0)+28>>2];k[pa>>2]=k[g+(ga*56|0)+32>>2];f=k[g+(ga*56|0)+36>>2]|0;k[qa>>2]=f;k[ra>>2]=ja;k[ta>>2]=sa;k[ua>>2]=0;k[sa>>2]=0;if(f|0){ea=f+12|0;k[ea>>2]=(k[ea>>2]|0)+1}do if((k[b>>2]|0)<3){da=k[g+(ga*56|0)+44>>2]|0;ea=k[ta>>2]|0;k[ea>>2]=k[da>>2];k[ea+4>>2]=k[da+4>>2]}else{k[ia>>2]=0;x1(wb,k[b>>2]|0,0,0,0);if((k[ia>>2]|0)<=0)break;h=k[g+(ga*56|0)+40>>2]|0;j=k[ra>>2]|0;f=k[g+(ga*56|0)+44>>2]|0;g=k[ta>>2]|0;b=0;do{k[j+(b<<2)>>2]=k[h+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[ia>>2]|0))}while(0);da=k[ra>>2]|0;ca=k[da+4>>2]|0;da=k[da>>2]|0;V=k[la>>2]|0;ea=k[sa>>2]|0;fa=c/+(1<<ga|0);fa=fa<1.0?1.0:fa;if((ga|0)<(e|0)){a=ga+1|0;b=k[Gb>>2]|0;n=k[b+(a*56|0)+40>>2]|0;S=k[n+4>>2]|0;n=k[n>>2]|0;f=k[va>>2]|0;k[xb>>2]=1124007936;k[wa>>2]=2;k[xa>>2]=da;k[ya>>2]=ca;k[za>>2]=f;k[Aa>>2]=f;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;k[Da>>2]=xa;k[Fa>>2]=Ea;k[Ga>>2]=0;k[Ea>>2]=0;if((aa(da,ca)|0)!=0&(f|0)==0){k[Db>>2]=0;k[Ha>>2]=0;b=ZT(36)|0;k[b>>2]=1;s=b+4|0;k[Db>>2]=s;k[Ha>>2]=28;i[b+32>>0]=0;g=390609;t=s+28|0;do{i[s>>0]=i[g>>0]|0;s=s+1|0;g=g+1|0}while((s|0)<(t|0));Y8(-215,Db,390638,390642,410);k[Ha>>2]=0;k[Db>>2]=0;ba=k[b>>2]|0;k[b>>2]=ba+-1;if((ba|0)==1)ggb(k[b+-4>>2]|0);g=k[xb>>2]|0;h=k[ya>>2]|0;j=k[Fa>>2]|0;m=k[Aa>>2]|0;b=k[Gb>>2]|0;q=k[za>>2]|0}else{g=1124007936;h=ca;j=Ea;m=f;q=f}k[xb>>2]=g|16384;k[j>>2]=h;k[j+4>>2]=1;T=m+(aa(k[xa>>2]|0,h)|0)|0;k[Ca>>2]=T;k[Ba>>2]=T+(0-h)+h;T=k[b+(a*56|0)+48>>2]|0;f=(k[b+(a*56|0)+16>>2]|0)+T+3|0;U=k[Ea>>2]|0;k[Ia>>2]=0;k[Ja>>2]=0;k[Db>>2]=16842752;k[Ka>>2]=b+(a*56|0);ba=Ma;k[ba>>2]=0;k[ba+4>>2]=0;k[yb>>2]=33619968;k[La>>2]=b+(ga*56|0);ba=k[b+(ga*56|0)+40>>2]|0;t=k[ba>>2]|0;k[zb>>2]=k[ba+4>>2];k[Na>>2]=t;Pra(Db,yb,zb,4);k[yb>>2]=0;k[yb+4>>2]=0;k[yb+8>>2]=0;k[yb+12>>2]=0;k[yb+16>>2]=0;k[yb+20>>2]=0;k[yb+24>>2]=0;k[yb+28>>2]=0;k[Db>>2]=-1056833530;k[Qa>>2]=yb;k[Oa>>2]=1;k[Pa>>2]=4;pY(xb,Db,49332);t=n+-1|0;if((t|0)>1){v=S+-1|0;w=(v|0)>1;x=(aa(S,-3)|0)+6+T|0;y=U<<1;z=-3-T|0;A=z+1|0;B=z+2|0;D=0-T|0;F=1-T|0;G=2-T|0;H=3-T|0;I=H+1|0;J=H+2|0;K=T+-3|0;L=T+-2|0;M=T+-1|0;N=T+1|0;O=T+2|0;P=T+3|0;Q=T+4|0;R=T+5|0;s=S*3|0;q=q+U|0;b=f;n=1;while(1){if(w){m=1;a=b;do{g=(l[a>>0]|0)+255|0;h=(l[a+1>>0]|0)+255|0;j=(l[a+2>>0]|0)+255|0;f=a;a=a+3|0;do if(((k[vb+(h-(l[f+-2>>0]|0)<<2)>>2]|0)+(k[vb+(g-(l[f+-3>>0]|0)<<2)>>2]|0)+(k[vb+(j-(l[f+-1>>0]|0)<<2)>>2]|0)|0)<(pb|0)){if(((k[vb+(h-(l[f+4>>0]|0)<<2)>>2]|0)+(k[vb+(g-(l[a>>0]|0)<<2)>>2]|0)+(k[vb+(j-(l[f+5>>0]|0)<<2)>>2]|0)|0)>=(pb|0)){f=1;break}if(((k[vb+(h-(l[f+A>>0]|0)<<2)>>2]|0)+(k[vb+(g-(l[f+z>>0]|0)<<2)>>2]|0)+(k[vb+(j-(l[f+B>>0]|0)<<2)>>2]|0)|0)>=(pb|0)){f=1;break}if(((k[vb+(h-(l[f+F>>0]|0)<<2)>>2]|0)+(k[vb+(g-(l[f+D>>0]|0)<<2)>>2]|0)+(k[vb+(j-(l[f+G>>0]|0)<<2)>>2]|0)|0)>=(pb|0)){f=1;break}if(((k[vb+(h-(l[f+I>>0]|0)<<2)>>2]|0)+(k[vb+(g-(l[f+H>>0]|0)<<2)>>2]|0)+(k[vb+(j-(l[f+J>>0]|0)<<2)>>2]|0)|0)>=(pb|0)){f=1;break}if(((k[vb+(h-(l[f+L>>0]|0)<<2)>>2]|0)+(k[vb+(g-(l[f+K>>0]|0)<<2)>>2]|0)+(k[vb+(j-(l[f+M>>0]|0)<<2)>>2]|0)|0)>=(pb|0)){f=1;break}if(((k[vb+(h-(l[f+N>>0]|0)<<2)>>2]|0)+(k[vb+(g-(l[f+T>>0]|0)<<2)>>2]|0)+(k[vb+(j-(l[f+O>>0]|0)<<2)>>2]|0)|0)>=(pb|0)){f=1;break}f=((k[vb+(h-(l[f+Q>>0]|0)<<2)>>2]|0)+(k[vb+(g-(l[f+P>>0]|0)<<2)>>2]|0)+(k[vb+(j-(l[f+R>>0]|0)<<2)>>2]|0)|0)>=(pb|0)}else f=1;while(0);i[q+((m<<1)+-1)>>0]=f&1;m=m+1|0}while((m|0)!=(v|0));b=b+-6+s|0}n=n+1|0;if((n|0)==(t|0))break;else{q=q+y|0;b=b+x|0}}}k[Ra>>2]=0;k[Sa>>2]=0;k[yb>>2]=16842752;k[Ta>>2]=xb;s=Va;k[s>>2]=0;k[s+4>>2]=0;k[zb>>2]=33619968;k[Ua>>2]=xb;k[Bb>>2]=1124007936;s=Wa;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[Ya>>2]=Xa;k[_a>>2]=Za;k[$a>>2]=0;k[Za>>2]=0;k[ab>>2]=0;k[bb>>2]=0;k[Ab>>2]=16842752;k[cb>>2]=Bb;p[Cb>>3]=1797693134862315708145274.0e284;p[db>>3]=1797693134862315708145274.0e284;p[eb>>3]=1797693134862315708145274.0e284;p[fb>>3]=1797693134862315708145274.0e284;k[Db>>2]=-1;k[jb>>2]=-1;Dra(1,yb,zb,Ab,Db,1,0,Cb);b=k[gb>>2]|0;do if(b|0){$=b+12|0;ba=k[$>>2]|0;k[$>>2]=ba+-1;if((ba|0)!=1)break;f=k[gb>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[lb>>2]|0;if(b|0)break;b=B1()|0;f=k[gb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[gb>>2]=0}while(0);k[gb>>2]=0;k[hb>>2]=0;k[hb+4>>2]=0;k[hb+8>>2]=0;k[hb+12>>2]=0;if((k[Wa>>2]|0)>0){f=k[Ya>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Wa>>2]|0))}b=k[_a>>2]|0;if(!((b|0)==(Za|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=k[za>>2]|0;b=k[ib>>2]|0;do if(b|0){$=b+12|0;ba=k[$>>2]|0;k[$>>2]=ba+-1;if((ba|0)!=1)break;f=k[ib>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[kb>>2]|0;if(b|0)break;b=B1()|0;f=k[ib>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[ib>>2]=0}while(0);k[ib>>2]=0;k[za>>2]=0;k[za+4>>2]=0;k[za+8>>2]=0;k[za+12>>2]=0;if((k[wa>>2]|0)>0){f=k[Da>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[wa>>2]|0))}b=k[Fa>>2]|0;if(!((b|0)==(Ea|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=g}else{U=0;f=0}g=k[Gb>>2]|0;if((da|0)>0){X=(ca|0)>0;Y=ca*3|0;Z=ea-Y|0;_=(k[g+(ga*56|0)+48>>2]|0)-Y|0;$=ca+-1|0;ba=da+-1|0;W=ea+-3|0;b=V;V=0;g=k[g+(ga*56|0)+16>>2]|0;while(1){if(X){T=(f|0)==0;Q=0;R=b;S=g;while(1){if(!(!T?!(i[f+Q>>0]|0):0)){h=l[R>>0]|0;m=l[R+1>>0]|0;j=l[R+2>>0]|0;a:do if(ha){N=0;O=V;P=Q;do{C=+(P|0);d=C-fa;a=(o[u>>2]=d,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;d=a?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(!(d==0.0))break;d=a?-0.0:0.0}while(0);J=~~d;J=(J|0)<0?0:J;E=+(O|0);d=E-fa;a=(o[u>>2]=d,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;d=a?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(!(d==0.0))break;d=a?-0.0:0.0}while(0);n=~~d;n=(n|0)<0?0:n;d=fa+C;a=(o[u>>2]=d,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;d=a?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(!(d==0.0))break;d=a?-0.0:0.0}while(0);H=~~d;H=(H|0)>($|0)?$:H;d=fa+E;a=(o[u>>2]=d,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;d=a?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(!(d==0.0))break;d=a?-0.0:0.0}while(0);B=~~d;B=(B|0)>(ba|0)?ba:B;if((n|0)>(B|0))break a;D=J+3|0;F=(D|0)>(H|0);G=W+(aa(H-J|0,-3)|0)|0;K=255-h|0;L=255-m|0;M=255-j|0;I=0;t=0;v=0;s=0;a=0;z=0;A=n;n=R+(aa(n-V|0,ea)|0)+((J-Q|0)*3|0)|0;while(1){if(F){q=0;w=J}else{q=0;y=J;x=D;while(1){Zb=l[n>>0]|0;Vb=l[n+1>>0]|0;Rb=l[n+2>>0]|0;Nb=((k[vb+(L+Vb<<2)>>2]|0)+(k[vb+(K+Zb<<2)>>2]|0)+(k[vb+(M+Rb<<2)>>2]|0)|0)>(ob|0);Yb=l[n+3>>0]|0;Ub=l[n+4>>0]|0;Qb=l[n+5>>0]|0;Mb=((k[vb+(L+Ub<<2)>>2]|0)+(k[vb+(K+Yb<<2)>>2]|0)+(k[vb+(M+Qb<<2)>>2]|0)|0)>(ob|0);Xb=l[n+6>>0]|0;Tb=l[n+7>>0]|0;Pb=l[n+8>>0]|0;Lb=((k[vb+(L+Tb<<2)>>2]|0)+(k[vb+(K+Xb<<2)>>2]|0)+(k[vb+(M+Pb<<2)>>2]|0)|0)>(ob|0);Wb=l[n+9>>0]|0;Sb=l[n+10>>0]|0;Ob=l[n+11>>0]|0;w=((k[vb+(L+Sb<<2)>>2]|0)+(k[vb+(K+Wb<<2)>>2]|0)+(k[vb+(M+Ob<<2)>>2]|0)|0)>(ob|0);a=(Nb?0:Zb)+a+(Mb?0:Yb)+(Lb?0:Xb)+(w?0:Wb)|0;s=(Nb?0:Vb)+s+(Mb?0:Ub)+(Lb?0:Tb)+(w?0:Sb)|0;v=(Nb?0:Rb)+v+(Mb?0:Qb)+(Lb?0:Pb)+(w?0:Ob)|0;t=(Nb?0:y)+t+(Mb?0:y+1|0)+(Lb?0:y+2|0)+(w?0:x)|0;q=(Nb&1^1)+q+(Mb&1^1)+(Lb&1^1)+(w&1^1)|0;w=y+4|0;n=n+12|0;x=y+7|0;if((x|0)>(H|0))break;else y=w}}if((w|0)<=(H|0))while(1){Wb=l[n>>0]|0;Xb=l[n+1>>0]|0;Yb=l[n+2>>0]|0;Zb=((k[vb+(L+Xb<<2)>>2]|0)+(k[vb+(K+Wb<<2)>>2]|0)+(k[vb+(M+Yb<<2)>>2]|0)|0)>(ob|0);a=(Zb?0:Wb)+a|0;s=(Zb?0:Xb)+s|0;v=(Zb?0:Yb)+v|0;t=(Zb?0:w)+t|0;q=(Zb&1^1)+q|0;n=n+3|0;if((w|0)<(H|0))w=w+1|0;else break}z=q+z|0;I=(aa(q,A)|0)+I|0;if((A|0)>=(B|0))break;else{A=A+1|0;n=n+G|0}}if(!z)break a;C=1.0/+(z|0);d=C*+(t|0);p[u>>3]=d;h=k[u+4>>2]|0;Zb=h&2146435072;do if(!(Zb>>>0>1126170624|(Zb|0)==1126170624&0>0)){h=(h|0)<0;d=h?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(!(d==0.0))break;d=h?-0.0:0.0}while(0);q=P;P=~~d;d=C*+(I|0);p[u>>3]=d;h=k[u+4>>2]|0;Zb=h&2146435072;do if(!(Zb>>>0>1126170624|(Zb|0)==1126170624&0>0)){h=(h|0)<0;d=h?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(!(d==0.0))break;d=h?-0.0:0.0}while(0);n=O;O=~~d;d=+(a|0)*C;p[u>>3]=d;h=k[u+4>>2]|0;Zb=h&2146435072;do if(!(Zb>>>0>1126170624|(Zb|0)==1126170624&0>0)){h=(h|0)<0;d=h?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(!(d==0.0))break;d=h?-0.0:0.0}while(0);h=~~d;d=C*+(s|0);p[u>>3]=d;j=k[u+4>>2]|0;Zb=j&2146435072;do if(!(Zb>>>0>1126170624|(Zb|0)==1126170624&0>0)){j=(j|0)<0;d=j?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(!(d==0.0))break;d=j?-0.0:0.0}while(0);m=~~d;d=C*+(v|0);p[u>>3]=d;j=k[u+4>>2]|0;Zb=j&2146435072;do if(!(Zb>>>0>1126170624|(Zb|0)==1126170624&0>0)){j=(j|0)<0;d=j?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(!(d==0.0))break;d=j?-0.0:0.0}while(0);j=~~d;if((P|0)==(q|0)&(O|0)==(n|0))break a;Zb=P-q|0;Yb=O-n|0;N=N+1|0}while((N|0)<(nb|0)?!(+(((Yb|0)>-1?Yb:0-Yb|0)+((Zb|0)>-1?Zb:0-Zb|0)+(k[vb+(K+h<<2)>>2]|0)+(k[vb+(L+m<<2)>>2]|0)+(k[vb+(M+j<<2)>>2]|0)|0)<=mb):0)}while(0);i[S>>0]=h;i[S+1>>0]=m;i[S+2>>0]=j}Q=Q+1|0;if((Q|0)==(ca|0))break;else{R=R+3|0;S=S+3|0}}b=b+Y|0;g=g+Y|0}V=V+1|0;if((V|0)==(da|0))break;else{b=b+Z|0;f=f+U|0;g=g+_|0}}}b=k[qa>>2]|0;do if(b|0){Yb=b+12|0;Zb=k[Yb>>2]|0;k[Yb>>2]=Zb+-1;if((Zb|0)!=1)break;f=k[qa>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[pa>>2]|0;if(b|0)break;b=B1()|0;f=k[qa>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[qa>>2]=0}while(0);k[qa>>2]=0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[ia>>2]|0)>0){f=k[ra>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ia>>2]|0))}b=k[ta>>2]|0;if(!((b|0)==(sa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);if((ga|0)>0)ga=ga+-1|0;else break}}g=Eb+36|0;b=k[g>>2]|0;if(b|0?(Yb=b+12|0,Zb=k[Yb>>2]|0,k[Yb>>2]=Zb+-1,(Zb|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[Eb+32>>2]|0;if(b|0)break;b=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;Zb=Eb+16|0;k[Zb>>2]=0;k[Zb+4>>2]=0;k[Zb+8>>2]=0;k[Zb+12>>2]=0;if((k[sb>>2]|0)>0){f=k[rb>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[sb>>2]|0))}b=k[tb>>2]|0;if(!((b|0)==(ub|0)|(b|0)==0))ggb(k[b+-4>>2]|0);zF(Gb);zF(Fb);g=Hb+36|0;b=k[g>>2]|0;do if(b|0){Yb=b+12|0;Zb=k[Yb>>2]|0;k[Yb>>2]=Zb+-1;if((Zb|0)!=1)break;f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[Hb+32>>2]|0;if(b|0)break;b=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}while(0);k[g>>2]=0;Zb=Hb+16|0;g=Hb+4|0;k[Zb>>2]=0;k[Zb+4>>2]=0;k[Zb+8>>2]=0;k[Zb+12>>2]=0;if((k[g>>2]|0)>0){f=k[qb>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[Hb+44>>2]|0;if(!((b|0)==(Hb+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}}g=Jb+36|0;b=k[g>>2]|0;if(b|0?(Yb=b+12|0,Zb=k[Yb>>2]|0,k[Yb>>2]=Zb+-1,(Zb|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;if(!b){b=k[Jb+32>>2]|0;if(!b){b=B1()|0;f=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;g=Jb+4|0;k[Ib>>2]=0;k[Ib+4>>2]=0;k[Ib+8>>2]=0;k[Ib+12>>2]=0;if((k[g>>2]|0)>0){f=k[Jb+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[Jb+44>>2]|0;if((b|0)==(Jb+48|0)|(b|0)==0){r=Kb;return}ggb(k[b+-4>>2]|0);r=Kb;return}function km(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;Pra(g,f,c,d);r=e;return}function lm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=r;r=r+48|0;g=d+32|0;f=d+16|0;e=d;h=g+4+4|0;k[h>>2]=0;k[h+4>>2]=0;k[g>>2]=50397184;k[g+4>>2]=a;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=c;K6(n9(c9()|0)|0,g,1,f,e);r=d;return}function mm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=r;r=r+48|0;g=d+32|0;f=d+16|0;e=d;h=g+4+4|0;k[h>>2]=0;k[h+4>>2]=0;k[g>>2]=50397184;k[g+4>>2]=a;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=c;K6(n9(c9()|0)|0,g,0,f,e);r=d;return}function nm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+32|0;l=h+16|0;j=h+8|0;i=h;m=l+4+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=50397184;k[l+4>>2]=a;k[j>>2]=k[b>>2];k[j+4>>2]=k[b+4>>2];k[i>>2]=k[c>>2];k[i+4>>2]=k[c+4>>2];Yfa(l,j,i,d,e,f,g);r=h;return}function om(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=r;r=r+32|0;h=f+16|0;g=f;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=a;a=g+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=b;T2(h,g,c,d,e);r=f;return}function pm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+64|0;m=h+48|0;l=h+32|0;j=h+16|0;i=h;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;a=l+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[l>>2]=33619968;k[l+4>>2]=b;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=c;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=d;Jna(m,l,j,i,e,f,g);r=h;return}function qm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=d;sY(g,b,c,f);r=e;return}function rm(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;var g=0,h=0,i=0,j=0;g=r;r=r+48|0;j=g+24|0;i=g+8|0;h=g;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;a=i+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=b;k[h>>2]=k[c>>2];k[h+4>>2]=k[c+4>>2];Rla(j,i,h,d,e,f);r=g;return}function sm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0.0,l=0.0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,Q=0.0,R=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;ma=r;r=r+288|0;e=ma+248|0;f=ma+216|0;ga=ma+184|0;q=ma+152|0;ka=ma+136|0;v=ma+80|0;ha=ma+72|0;ia=ma;ja=ma+56|0;la=ja+4+4|0;k[la>>2]=0;k[la+4>>2]=0;k[ja>>2]=33619968;k[ja+4>>2]=c;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;k[e+16>>2]=0;k[e+20>>2]=0;k[e+24>>2]=0;k[e+28>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[f+28>>2]=0;la=ga+4+20|0;k[la>>2]=0;k[la+4>>2]=0;la=q+4+8|0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;k[la+16>>2]=0;k[ka>>2]=0;la=ka+4|0;k[la>>2]=0;k[ka+8>>2]=0;_=+o[a+16>>2]*3.141592653589793/180.0;l=+S(+_)*.5;_=+T(+_)*.5;da=+o[a>>2];ba=+o[a+12>>2];ca=_*ba;aa=+o[a+8>>2];$=l*aa;fa=da-ca-$;o[ga>>2]=fa;ea=+o[a+4>>2];ba=l*ba;aa=_*aa;_=ea+ba-aa;h=ga+4|0;o[h>>2]=_;$=da+ca-$;o[ga+8>>2]=$;aa=ea-ba-aa;p=ga+12|0;o[p>>2]=aa;da=da*2.0;ba=da-fa;o[ga+16>>2]=ba;ea=ea*2.0;ca=ea-_;s=ga+20|0;o[s>>2]=ca;da=da-$;o[ga+24>>2]=da;ea=ea-aa;t=ga+28|0;o[t>>2]=ea;l=+o[b+16>>2]*3.141592653589793/180.0;Z=+S(+l)*.5;l=+T(+l)*.5;U=+o[b>>2];Q=+o[b+12>>2];R=l*Q;O=+o[b+8>>2];N=Z*O;j=U-R-N;o[q>>2]=j;V=+o[b+4>>2];Q=Z*Q;O=l*O;l=V+Q-O;n=q+4|0;o[n>>2]=l;N=U+R-N;o[q+8>>2]=N;O=V-Q-O;o[q+12>>2]=O;U=U*2.0;Q=U-j;o[q+16>>2]=Q;V=V*2.0;R=V-l;o[q+20>>2]=R;U=U-N;o[q+24>>2]=U;V=V-O;o[q+28>>2]=V;b=+P(+(fa-j))>9.999999747378752e-06;d=(o[u>>2]=fa,k[u>>2]|0);if(((((((!b?(b=+P(+(_-l))>9.999999747378752e-06,m=(o[u>>2]=_,k[u>>2]|0),!b):0)?!(+P(+($-N))>9.999999747378752e-06):0)?!(+P(+(aa-O))>9.999999747378752e-06):0)?!(+P(+(ba-Q))>9.999999747378752e-06):0)?!(+P(+(ca-R))>9.999999747378752e-06):0)?!(+P(+(da-U))>9.999999747378752e-06):0)?!(+P(+(ea-V))>9.999999747378752e-06):0){f=k[la>>2]|0;e=k[ka>>2]|0;c=f-e>>3;b=e;a=f;if(c>>>0>=4)if((c|0)!=4?(g=b+32|0,(a|0)!=(g|0)):0){n=a+(~((a+-8-g|0)>>>3)<<3)|0;k[la>>2]=n;a=b;c=m;q=e}else{a=b;c=m;q=e;n=f}else{o9(ka,4-c|0);q=k[ka>>2]|0;d=k[ga>>2]|0;a=q;c=k[h>>2]|0;n=k[la>>2]|0}k[a>>2]=d;k[a+4>>2]=c;k[a+8>>2]=k[ga+8>>2];k[a+12>>2]=k[p>>2];k[a+16>>2]=k[ga+16>>2];k[a+20>>2]=k[s>>2];k[a+24>>2]=k[ga+24>>2];k[a+28>>2]=k[t>>2];k[v>>2]=1124024333;p=v+4|0;k[p>>2]=2;t=v+8|0;c=n-q|0;k[t>>2]=c>>3;k[v+12>>2]=1;g=v+16|0;k[g>>2]=0;a=v+20|0;k[a>>2]=0;b=v+24|0;k[b>>2]=0;f=v+32|0;k[f>>2]=0;h=v+36|0;k[h>>2]=0;m=v+40|0;k[m>>2]=t;t=v+48|0;s=v+44|0;k[s>>2]=t;d=v+52|0;k[d>>2]=0;k[t>>2]=0;e=q;if((e|0)!=(n|0)){k[d>>2]=8;k[t>>2]=8;k[g>>2]=e;k[a>>2]=e;ia=q+c|0;k[b>>2]=ia;k[v+28>>2]=ia}mY(v,ja);c=k[h>>2]|0;if(c|0?(ia=c+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){a=k[h>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[f>>2]|0;if(!c){c=B1()|0;a=k[h>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[h>>2]=0}k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[p>>2]|0)>0){a=k[m>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[p>>2]|0))}c=k[s>>2]|0;if((c|0)==(t|0)|(c|0)==0)b=2;else{ggb(k[c+-4>>2]|0);b=2}}else{W=$-fa;o[e>>2]=W;G=aa-_;o[e+4>>2]=G;H=N-j;o[f>>2]=H;B=O-l;o[f+4>>2]=B;X=ba-$;o[e+8>>2]=X;K=ca-aa;o[e+12>>2]=K;I=Q-N;o[f+8>>2]=I;C=R-O;o[f+12>>2]=C;Y=da-ba;o[e+16>>2]=Y;L=ea-ca;o[e+20>>2]=L;J=U-Q;o[f+16>>2]=J;E=V-R;o[f+20>>2]=E;Z=fa-da;o[e+24>>2]=Z;M=_-ea;o[e+28>>2]=M;F=j-U;o[f+24>>2]=F;D=l-V;o[f+28>>2]=D;d=ha+4|0;g=ka+8|0;b=0;y=fa;z=_;A=G;x=W;while(1){a=0;do{w=+o[q+(a<<3)>>2]-y;na=+o[q+(a<<3)+4>>2]-z;oa=+o[f+(a<<3)>>2];l=+o[f+(a<<3)+4>>2];j=A*oa-x*l;l=(na*oa-w*l)/j;j=(x*na-w*A)/j;c=(o[u>>2]=l,k[u>>2]|0)&2147483647;if(((c|0)!=2139095040?!(((o[u>>2]=j,k[u>>2]|0)&2139095040)>>>0>2139095039|c>>>0>2139095040):0)?j<=1.0&(j>=0.0&(l>=0.0&l<=1.0)):0){w=y+x*l;j=z+A*l;o[ha>>2]=w;o[d>>2]=j;c=k[la>>2]|0;if((c|0)==(k[g>>2]|0))dga(ka,ha);else{o[c>>2]=w;o[c+4>>2]=j;k[la>>2]=c+8}}a=a+1|0}while((a|0)<4);c=b+1|0;if((c|0)>=4)break;b=c;y=+o[ga+(c<<3)>>2];z=+o[ga+(c<<3)+4>>2];A=+o[e+(c<<3)+4>>2];x=+o[e+(c<<3)>>2]}b=(k[ka>>2]|0)==(k[la>>2]|0)?2:1;B=-B;A=-C;z=-E;y=-D;x=+o[q>>2];l=+o[n>>2];d=0;w=_;while(1){c=ga+(d<<3)|0;j=+o[c>>2];v=!(j*B+w*H-(x*B+H*l)>=0.0)&1;t=!(j*A+w*I-(N*A+I*O)>=0.0)&1;s=!(j*z+w*J-(Q*z+J*R)>=0.0)&1;p=!(j*y+w*F-(U*y+F*V)>=0.0)&1;do if((p+(s+(t+v))|0)==4?1:((p^1)+((s^1)+((t^1)+(v^1)))|0)==4){a=k[la>>2]|0;if((a|0)==(k[g>>2]|0)){dga(ka,c);break}else{o[a>>2]=j;o[a+4>>2]=w;k[la>>2]=a+8;break}}while(0);c=d+1|0;if((c|0)>=4)break;d=c;w=+o[ga+(c<<3)+4>>2]}z=-G;y=-K;x=-L;w=-M;d=0;while(1){c=q+(d<<3)|0;j=+o[c>>2];ga=!(j*z+l*W-(fa*z+W*_)>=0.0)&1;v=!(j*y+l*X-($*y+X*aa)>=0.0)&1;t=!(j*x+l*Y-(ba*x+Y*ca)>=0.0)&1;s=!(j*w+l*Z-(da*w+Z*ea)>=0.0)&1;do if((s+(t+(v+ga))|0)==4?1:((s^1)+((t^1)+((v^1)+(ga^1)))|0)==4){a=k[la>>2]|0;if((a|0)==(k[g>>2]|0)){dga(ka,c);break}else{o[a>>2]=j;o[a+4>>2]=l;k[la>>2]=a+8;break}}while(0);c=d+1|0;if((c|0)>=4)break;d=c;l=+o[q+(c<<3)+4>>2]}a=k[la>>2]|0;h=k[ka>>2]|0;ga=a-h|0;c=ga>>3;d=a;t=h;if((ga|0)>8){s=0;g=a;f=d;while(1){c=s;s=s+1|0;if(s>>>0<g-h>>3>>>0){q=t+(c<<3)|0;p=t+(c<<3)+4|0;c=s;n=d;d=f;e=g;m=g;while(1){f=t+(c<<3)|0;j=+o[f>>2];na=+o[q>>2]-j;g=t+(c<<3)+4|0;l=+o[g>>2];oa=+o[p>>2]-l;if(na*na+oa*oa<9.999999439624929e-11){d=n+-8|0;k[f>>2]=k[d>>2];e=n+-4|0;k[g>>2]=k[e>>2];o[d>>2]=j;o[e>>2]=l;k[la>>2]=d;e=d;c=c+-1|0;f=e;a=e}else f=m;c=c+1|0;if(c>>>0>=f-h>>3>>>0)break;else{n=f;m=f}}}else{e=g;d=f}c=e-h>>3;if((s|0)>=(c+-1|0))break;else{g=e;f=d;d=e}}}if((t|0)!=(d|0)){if(c>>>0>=9){k[ha>>2]=0;c=ha+4|0;k[c>>2]=0;a=ZT(32)|0;k[a>>2]=1;d=a+4|0;k[ha>>2]=d;k[c>>2]=24;i[a+28>>0]=0;e=339507;f=d+24|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,ha,339532,339561,245);k[c>>2]=0;k[ha>>2]=0;ha=k[a>>2]|0;k[a>>2]=ha+-1;if((ha|0)==1)ggb(k[a+-4>>2]|0);h=k[ka>>2]|0;a=k[la>>2]|0}k[ia>>2]=1124024333;s=ia+4|0;k[s>>2]=2;v=ia+8|0;c=a-h|0;k[v>>2]=c>>3;k[ia+12>>2]=1;n=ia+16|0;k[n>>2]=0;d=ia+20|0;k[d>>2]=0;e=ia+24|0;k[e>>2]=0;m=ia+32|0;k[m>>2]=0;p=ia+36|0;k[p>>2]=0;q=ia+40|0;k[q>>2]=v;v=ia+48|0;t=ia+44|0;k[t>>2]=v;f=ia+52|0;k[f>>2]=0;k[v>>2]=0;g=h;if((g|0)!=(a|0)){k[f>>2]=8;k[v>>2]=8;k[n>>2]=g;k[d>>2]=g;ha=h+c|0;k[e>>2]=ha;k[ia+28>>2]=ha}mY(ia,ja);c=k[p>>2]|0;if(c|0?(ia=c+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){a=k[p>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[m>>2]|0;if(!c){c=B1()|0;a=k[p>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[p>>2]=0}k[p>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[s>>2]|0)>0){a=k[q>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[s>>2]|0))}c=k[t>>2]|0;if(!((c|0)==(v|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}else b=0}c=k[ka>>2]|0;if(!c){r=ma;return b|0}a=k[la>>2]|0;if((a|0)!=(c|0))k[la>>2]=a+(~((a+-8-c|0)>>>3)<<3);ggb(c);r=ma;return b|0}function tm(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=r;r=r+48|0;h=e+32|0;g=e+16|0;f=e;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=a;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=c;c=f+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=d;W_(h,b,g,f);r=e;return}function um(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0;g=r;r=r+80|0;m=g+56|0;l=g+40|0;j=g+24|0;i=g+16|0;h=g;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=b;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=c;k[i>>2]=k[d>>2];k[i+4>>2]=k[d+4>>2];d=h+4+4|0;k[d>>2]=0;k[d+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=e;O3a(m,l,j,i,h,f);r=g;return}function vm(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;var i=0,j=0,l=0,m=0,n=0,o=0;i=r;r=r+80|0;o=i+56|0;n=i+40|0;m=i+24|0;l=i+8|0;j=i;k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=a;a=n+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[n>>2]=33619968;k[n+4>>2]=b;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=d;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=e;k[j>>2]=k[f>>2];k[j+4>>2]=k[f+4>>2];gla(o,n,c,m,l,j,g,h);r=i;return}function wm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+16|0;d=c;e=d+4+4|0;k[e>>2]=0;k[e+4>>2]=0;k[d>>2]=50397184;k[d+4>>2]=a;R2(d,b);r=c;return}function xm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=r;r=r+48|0;h=e+32|0;g=e+16|0;f=e;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=a;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;b=f+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=c;d=NZ(h,g,f,d)|0;r=e;return d|0}function ym(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+32|0;e=c+16|0;d=c;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=a;a=d+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[d>>2]=33619968;k[d+4>>2]=b;b=n_(e,d)|0;r=c;return b|0}function zm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0,h=0.0,j=0,l=0.0,m=0,n=0,o=0,q=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;ua=r;r=r+1568|0;oa=ua+1552|0;ta=ua+1496|0;sa=ua+1440|0;ra=ua;qa=ua+1384|0;w=ua+1376|0;la=ua+1304|0;ia=ua+1232|0;ja=ua+1216|0;pa=ua+1160|0;o=ua+1360|0;s=ua+1288|0;k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=a;t=s+4|0;n=s+4+4|0;k[n>>2]=0;k[n+4>>2]=0;k[s>>2]=33619968;k[t>>2]=b;k[ta>>2]=k[a>>2];n=ta+4|0;d=a+4|0;b=k[d>>2]|0;k[n>>2]=b;na=ta+8|0;k[na>>2]=k[a+8>>2];k[ta+12>>2]=k[a+12>>2];k[ta+16>>2]=k[a+16>>2];k[ta+20>>2]=k[a+20>>2];k[ta+24>>2]=k[a+24>>2];k[ta+28>>2]=k[a+28>>2];k[ta+32>>2]=k[a+32>>2];e=k[a+36>>2]|0;k[ta+36>>2]=e;g=ta+40|0;k[g>>2]=na;na=ta+48|0;m=ta+44|0;k[m>>2]=na;k[ta+52>>2]=0;k[na>>2]=0;if(e){b=e+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[d>>2]|0}if((b|0)>=3){k[n>>2]=0;x1(ta,b,0,0,0);if((k[n>>2]|0)>0){j=k[a+40>>2]|0;g=k[g>>2]|0;e=k[a+44>>2]|0;d=k[m>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else{ha=k[a+44>>2]|0;na=k[m>>2]|0;k[na>>2]=k[ha>>2];k[na+4>>2]=k[ha+4>>2]}na=S1(o,-1)|0;a=na&7;if(!(a>>>0>4?((na>>>3&511)+1|0)>>>0<3:0)){k[oa>>2]=0;b=oa+4|0;k[b>>2]=0;d=ZT(60)|0;k[d>>2]=1;m=d+4|0;k[oa>>2]=m;k[b>>2]=54;i[d+58>>0]=0;j=215209;n=m+54|0;do{i[m>>0]=i[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(n|0));Y8(-215,oa,215264,214521,2073);k[b>>2]=0;k[oa>>2]=0;na=k[d>>2]|0;k[d>>2]=na+-1;if((na|0)==1)ggb(k[d+-4>>2]|0)}e=ta+8|0;b=k[e>>2]|0;g=ta+12|0;if((b|0)!=1){if((k[g>>2]|0)!=1){k[oa>>2]=0;b=oa+4|0;k[b>>2]=0;d=ZT(44)|0;k[d>>2]=1;m=d+4|0;k[oa>>2]=m;k[b>>2]=38;i[d+42>>0]=0;j=215274;n=m+38|0;do{i[m>>0]=i[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(n|0));Y8(-215,oa,215264,214521,2074);k[b>>2]=0;k[oa>>2]=0;na=k[d>>2]|0;k[d>>2]=na+-1;if((na|0)==1)ggb(k[d+-4>>2]|0);b=k[e>>2]|0}}else b=1;q=k[g>>2]|0;fa=q+-2+b|0;k[oa>>2]=fa;k[oa+4>>2]=1;P1(s,2,oa,a|8,-1,1,96);do if((k[s>>2]&2031616|0)==65536){j=k[t>>2]|0;k[sa>>2]=k[j>>2];o=sa+4|0;d=j+4|0;k[o>>2]=k[d>>2];na=sa+8|0;k[na>>2]=k[j+8>>2];k[sa+12>>2]=k[j+12>>2];k[sa+16>>2]=k[j+16>>2];k[sa+20>>2]=k[j+20>>2];k[sa+24>>2]=k[j+24>>2];k[sa+28>>2]=k[j+28>>2];k[sa+32>>2]=k[j+32>>2];e=k[j+36>>2]|0;k[sa+36>>2]=e;g=sa+40|0;k[g>>2]=na;na=sa+48|0;m=sa+44|0;k[m>>2]=na;k[sa+52>>2]=0;k[na>>2]=0;if(e|0){na=e+12|0;k[na>>2]=(k[na>>2]|0)+1}if((k[d>>2]|0)<3){ha=k[j+44>>2]|0;na=k[m>>2]|0;k[na>>2]=k[ha>>2];k[na+4>>2]=k[ha+4>>2];break}k[o>>2]=0;x1(sa,k[d>>2]|0,0,0,0);if((k[o>>2]|0)>0){n=k[j+40>>2]|0;a=k[g>>2]|0;g=k[j+44>>2]|0;e=k[m>>2]|0;d=0;do{k[a+(d<<2)>>2]=k[n+(d<<2)>>2];k[e+(d<<2)>>2]=k[g+(d<<2)>>2];d=d+1|0}while((d|0)<(k[o>>2]|0))}}else Q1(sa,s,-1);while(0);g=(fa<<1)+2|0;ga=ra+8|0;zpb(ga|0,0,1152)|0;k[ra>>2]=ga;ha=ra+4|0;k[ha>>2]=72;if(g>>>0>72){e=g>>>0>268435455?-1:g<<4;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}zpb(d|0,0,g<<4|0)|0;k[ra>>2]=d;da=d}else da=ga;k[ha>>2]=g;ea=da+(fa<<4)+16|0;na=ta+40|0;ba=k[na>>2]|0;ca=k[ba>>2]|0;k[w>>2]=k[ba+4>>2];k[w+4>>2]=ca;ca=((k[ta>>2]|0)>>>3&511)+1|0;YN(qa,w,(ca<<3)+-2|0,(ca|0)==2?da:ea,0);ca=oa+4|0;ba=ca+4|0;k[ba>>2]=0;k[ba+4>>2]=0;k[oa>>2]=33619968;k[ca>>2]=qa;SW(ta,oa,k[qa>>2]&4095,1.0,0.0);if(!(k[ta>>2]&4088))if((fa|0)<0){b=fa;e=0}else{d=q+b+-1|0;b=0;do{p[da+(b<<4)>>3]=+p[ea+(b<<3)>>3];p[da+(b<<4)+8>>3]=0.0;b=b+1|0}while((b|0)!=(d|0));ma=36}else ma=36;do if((ma|0)==36){if((fa|0)<=1)if((fa|0)==1){b=1;e=1}else{b=fa;e=0;break}else{b=fa;while(1){B=+P(+(+p[da+(b<<4)>>3]));if(B+ +P(+(+p[da+(b<<4)+8>>3]))>2.220446049250313e-16){d=b;break}b=b+-1|0;if((b|0)<=1){d=1;break}}b=d;e=(d|0)>0}d=0;f=1.0;h=0.0;while(1){ca=ea+(d<<4)|0;p[ca>>3]=f;p[ca+8>>3]=h;l=f+h;d=d+1|0;if((d|0)==(b|0))break;else{f=f-h;h=l}}}while(0);w=(c|0)<1?1e3:c;a:do if((w|0)>0){q=da+(b<<4)|0;t=da+(b<<4)+8|0;c=la+4|0;C=la+8|0;D=la+40|0;E=la+48|0;F=la+44|0;G=la+52|0;H=oa+4|0;I=ia+4|0;J=ia+8|0;K=ia+40|0;L=ia+48|0;M=ia+44|0;N=ia+52|0;O=la+16|0;S=la+12|0;T=oa+8|0;U=oa+12|0;V=oa+4|0;W=ja+4|0;X=W+4|0;Y=ia+16|0;Z=ia+36|0;_=la+36|0;$=la+32|0;ba=ia+32|0;a=0;while(1){if(e){f=0.0;o=0}else{f=0.0;break a}do{ca=ea+(o<<4)|0;A=+p[ca>>3];s=ca+8|0;B=+p[s>>3];y=+p[q>>3];h=+p[t>>3];g=0;d=1;v=y;z=h;while(1){n=b-g+-1|0;x=y;y=A*y-B*z+ +p[da+(n<<4)>>3];z=B*x+A*z+ +p[da+(n<<4)+8>>3];do if((g|0)!=(o|0)){n=ea+(g<<4)|0;l=A-+p[n>>3];u=B-+p[n+8>>3];if(l!=0.0|u!=0.0){x=v*l-h*u;h=h*l+v*u;break}else{d=d+1|0;x=v;break}}else x=v;while(0);g=g+1|0;if((g|0)==(b|0))break;else v=x}u=1.0/(x*x+h*h);v=u*(x*y+h*z);u=u*(x*z-h*y);if((d|0)>1){if(((d<<31>>31)+(d>>>1)|0)>0){h=v+ +Q(+(v*v+u*u));l=+Q(+(h*.5));h=+Q(+((h-v)*.5));h=v<0.0?-h:h}else{l=v;h=u}if(d&1){k[la>>2]=1124007936;m=c;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[D>>2]=C;k[F>>2]=E;k[G>>2]=0;k[E>>2]=0;k[oa>>2]=4;k[H>>2]=1;G1(la,2,oa,6);k[ia>>2]=1124007936;m=I;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[K>>2]=J;k[M>>2]=L;k[N>>2]=0;k[L>>2]=0;k[oa>>2]=3;k[H>>2]=1;G1(ia,2,oa,14);h=-+R(+v,3.0);j=(k[la>>2]&16384|0)==0;do if(j?(ka=k[D>>2]|0,(k[ka>>2]|0)!=1):0){g=k[O>>2]|0;d=k[F>>2]|0;if((k[ka+4>>2]|0)==1){d=g+((k[d>>2]|0)*3|0)|0;break}else{n=k[S>>2]|0;m=3/(n|0)|0;n=3-(aa(m,n)|0)|0;d=g+(aa(k[d>>2]|0,m)|0)+(n<<3)|0;break}}else ma=59;while(0);if((ma|0)==59){ma=0;g=k[O>>2]|0;d=g+24|0}p[d>>3]=h;h=-(v*v*15.0+u*u*27.0);do if(j){j=k[D>>2]|0;if((k[j>>2]|0)==1){p[g+16>>3]=h;p[g+8>>3]=v*-48.0;break}d=k[O>>2]|0;g=k[F>>2]|0;if((k[j+4>>2]|0)==1)d=d+(k[g>>2]<<1)|0;else{n=k[S>>2]|0;m=2/(n|0)|0;n=2-(aa(m,n)|0)|0;d=d+(aa(k[g>>2]|0,m)|0)+(n<<3)|0}p[d>>3]=h;d=k[O>>2]|0;g=k[F>>2]|0;if((k[j+4>>2]|0)==1)d=d+(k[g>>2]|0)|0;else{n=k[S>>2]|0;m=(n+1|0)>>>0<3?n:0;n=1-(aa(m,n)|0)|0;d=d+(aa(m,k[g>>2]|0)|0)+(n<<3)|0}p[d>>3]=v*-48.0}else{p[g+16>>3]=h;p[g+8>>3]=v*-48.0}while(0);p[k[O>>2]>>3]=64.0;k[T>>2]=0;k[U>>2]=0;k[oa>>2]=16842752;k[V>>2]=la;n=X;k[n>>2]=0;k[n+4>>2]=0;k[ja>>2]=33619968;k[W>>2]=ia;n_(oa,ja)|0;h=+p[k[Y>>2]>>3];if(!(h>=0.0))l=-+R(+-h,.3333333333333333);else l=+R(+h,.3333333333333333);h=+Q(+(l*l/3.0-v/(l*3.0)));d=k[Z>>2]|0;do if(d|0){m=d+12|0;n=k[m>>2]|0;k[m>>2]=n+-1;if((n|0)!=1)break;g=k[Z>>2]|0;if(g|0){d=k[g+4>>2]|0;do if(!d){d=k[ba>>2]|0;if(d|0)break;d=B1()|0;g=k[Z>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[Z>>2]=0}while(0);k[Z>>2]=0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[I>>2]|0)>0){g=k[K>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[I>>2]|0))}d=k[M>>2]|0;if(!((d|0)==(L|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[_>>2]|0;do if(d|0){m=d+12|0;n=k[m>>2]|0;k[m>>2]=n+-1;if((n|0)!=1)break;g=k[_>>2]|0;if(g|0){d=k[g+4>>2]|0;do if(!d){d=k[$>>2]|0;if(d|0)break;d=B1()|0;g=k[_>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[_>>2]=0}while(0);k[_>>2]=0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[c>>2]|0)>0){g=k[D>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[c>>2]|0))}d=k[F>>2]|0;if(!((d|0)==(E|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}}else{l=v;h=u}p[ca>>3]=A-l;p[s>>3]=B-h;B=+Q(+(l*l+h*h));f=f<B?B:f;o=o+1|0}while((o|0)<(b|0));a=a+1|0;if(!(!(f<=0.0)&(a|0)<(w|0))){ma=106;break}}}else{f=0.0;ma=106}while(0);if((ma|0)==106)if((k[ta>>2]&4088|0)==0&e){d=0;do{e=ea+(d<<4)+8|0;if(+P(+(+p[e>>3]))<1.0e-100)p[e>>3]=0.0;d=d+1|0}while((d|0)!=(b|0))}if((b|0)<(fa|0))do{la=b;b=b+1|0;ma=ea+(b<<4)|0;la=ea+(la<<4)|0;k[ma>>2]=k[la>>2];k[ma+4>>2]=k[la+4>>2];k[ma+8>>2]=k[la+8>>2];k[ma+12>>2]=k[la+12>>2]}while((b|0)!=(fa|0));o=sa+40|0;ma=k[o>>2]|0;b=k[ma+4>>2]|0;ma=k[ma>>2]|0;a=pa+4|0;k[a>>2]=2;n=pa+8|0;k[n>>2]=ma;k[pa+12>>2]=b;g=pa+16|0;k[g>>2]=ea;k[pa+20>>2]=ea;e=pa+24|0;j=pa+40|0;m=e+8|0;k[m>>2]=0;k[m+4>>2]=0;k[j>>2]=n;n=pa+48|0;m=pa+44|0;k[m>>2]=n;b=b<<4;k[pa>>2]=1124024334;k[n>>2]=b;k[pa+52>>2]=16;ma=ea+(aa(ma,b)|0)|0;k[pa+28>>2]=ma;k[e>>2]=ma+(0-b)+b;e=oa+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[oa>>2]=33619968;k[e>>2]=sa;SW(pa,oa,k[sa>>2]&4095,1.0,0.0);e=pa+36|0;b=k[e>>2]|0;if(b|0?(ma=b+12|0,oa=k[ma>>2]|0,k[ma>>2]=oa+-1,(oa|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[pa+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[a>>2]|0)>0){d=k[j>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[m>>2]|0;if(!((b|0)==(n|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=qa+36|0;b=k[e>>2]|0;if(b|0?(oa=b+12|0,pa=k[oa>>2]|0,k[oa>>2]=pa+-1,(pa|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[qa+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;pa=qa+16|0;d=qa+4|0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[d>>2]|0)>0){e=k[qa+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[qa+44>>2]|0;if(!((b|0)==(qa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[ra>>2]|0;if((b|0)!=(ga|0)){if(b|0)ggb(b);k[ra>>2]=ga;k[ha>>2]=72}e=sa+36|0;b=k[e>>2]|0;if(b|0?(qa=b+12|0,ra=k[qa>>2]|0,k[qa>>2]=ra+-1,(ra|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[sa+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;ra=sa+16|0;e=sa+4|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[e>>2]|0)>0){d=k[o>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[sa+44>>2]|0;if(!((b|0)==(sa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=ta+36|0;b=k[e>>2]|0;do if(b|0){ra=b+12|0;sa=k[ra>>2]|0;k[ra>>2]=sa+-1;if((sa|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[ta+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;sa=ta+16|0;e=ta+4|0;k[sa>>2]=0;k[sa+4>>2]=0;k[sa+8>>2]=0;k[sa+12>>2]=0;if((k[e>>2]|0)>0){d=k[na>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[ta+44>>2]|0;if((b|0)==(ta+48|0)|(b|0)==0){r=ua;return +f}ggb(k[b+-4>>2]|0);r=ua;return +f}function Am(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+32|0;f=d+16|0;e=d;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=a;a=e+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=b;G3(f,e,c);r=d;return}function Bm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+32|0;f=d+16|0;e=d;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=a;a=e+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=b;O3(f,e,c);r=d;return}function Cm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=r;r=r+224|0;O=P+168|0;M=P+112|0;q=P+104|0;s=P+96|0;L=P+8|0;w=P;o=P+80|0;v=P+64|0;p=o+4|0;u=o+4+4|0;k[u>>2]=0;k[u+4>>2]=0;k[o>>2]=33619968;k[p>>2]=b;u=v+4|0;n=v+4+4|0;k[n>>2]=0;k[n+4>>2]=0;k[v>>2]=33619968;k[u>>2]=c;k[O>>2]=k[a>>2];n=O+4|0;c=a+4|0;b=k[c>>2]|0;k[n>>2]=b;K=O+8|0;k[K>>2]=k[a+8>>2];k[O+12>>2]=k[a+12>>2];N=O+16|0;k[N>>2]=k[a+16>>2];k[O+20>>2]=k[a+20>>2];k[O+24>>2]=k[a+24>>2];k[O+28>>2]=k[a+28>>2];k[O+32>>2]=k[a+32>>2];f=k[a+36>>2]|0;k[O+36>>2]=f;g=O+40|0;k[g>>2]=K;K=O+48|0;m=O+44|0;k[m>>2]=K;k[O+52>>2]=0;k[K>>2]=0;if(f){b=f+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[n>>2]=0;x1(O,b,0,0,0);if((k[n>>2]|0)>0){h=k[a+40>>2]|0;g=k[g>>2]|0;f=k[a+44>>2]|0;c=k[m>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else{I=k[a+44>>2]|0;K=k[m>>2]|0;k[K>>2]=k[I>>2];k[K+4>>2]=k[I+4>>2]}if(k[N>>2]|0){f=k[O+4>>2]|0;if((f|0)<3)b=aa(k[O+12>>2]|0,k[O+8>>2]|0)|0;else{g=k[O+40>>2]|0;c=0;b=1;do{b=aa(k[g+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(f|0))}if(!b)J=14}else J=14;if((J|0)==14){k[M>>2]=0;b=M+4|0;k[b>>2]=0;c=ZT(20)|0;k[c>>2]=1;f=c+4|0;k[M>>2]=f;k[b>>2]=12;i[c+16>>0]=0;g=401621;h=f+12|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,M,352015,352031,84);k[b>>2]=0;k[M>>2]=0;K=k[c>>2]|0;k[c>>2]=K+-1;if((K|0)==1)ggb(k[c+-4>>2]|0)}if(k[O>>2]&4095|0){k[M>>2]=0;b=M+4|0;k[b>>2]=0;c=ZT(28)|0;k[c>>2]=1;f=c+4|0;k[M>>2]=f;k[b>>2]=21;i[c+25>>0]=0;g=354023;h=f+21|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,M,352015,352031,85);k[b>>2]=0;k[M>>2]=0;K=k[c>>2]|0;k[c>>2]=K+-1;if((K|0)==1)ggb(k[c+-4>>2]|0)}t=(e|0)==4;switch(e|0){case 1:case 4:break;default:{k[M>>2]=0;b=M+4|0;k[b>>2]=0;c=ZT(68)|0;k[c>>2]=1;f=c+4|0;k[M>>2]=f;k[b>>2]=62;i[c+66>>0]=0;g=352108;h=f+62|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,M,352015,352031,86);k[b>>2]=0;k[M>>2]=0;K=k[c>>2]|0;k[c>>2]=K+-1;if((K|0)==1)ggb(k[c+-4>>2]|0)}}K=O+40|0;I=k[K>>2]|0;H=k[I>>2]|0;k[q>>2]=k[I+4>>2];k[q+4>>2]=H;x2(o,q,3,0);H=k[K>>2]|0;I=k[H>>2]|0;k[s>>2]=k[H+4>>2];k[s+4>>2]=I;x2(v,s,3,0);do if((k[o>>2]&2031616|0)==65536){g=k[p>>2]|0;k[M>>2]=k[g>>2];n=M+4|0;b=g+4|0;k[n>>2]=k[b>>2];I=M+8|0;k[I>>2]=k[g+8>>2];k[M+12>>2]=k[g+12>>2];k[M+16>>2]=k[g+16>>2];k[M+20>>2]=k[g+20>>2];k[M+24>>2]=k[g+24>>2];k[M+28>>2]=k[g+28>>2];k[M+32>>2]=k[g+32>>2];c=k[g+36>>2]|0;k[M+36>>2]=c;f=M+40|0;k[f>>2]=I;I=M+48|0;m=M+44|0;k[m>>2]=I;k[M+52>>2]=0;k[I>>2]=0;if(c|0){I=c+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[b>>2]|0)<3){H=k[g+44>>2]|0;I=k[m>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2];break}k[n>>2]=0;x1(M,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){a=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;c=k[m>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else Q1(M,o,-1);while(0);do if((k[v>>2]&2031616|0)==65536){g=k[u>>2]|0;k[L>>2]=k[g>>2];n=L+4|0;b=g+4|0;k[n>>2]=k[b>>2];I=L+8|0;k[I>>2]=k[g+8>>2];k[L+12>>2]=k[g+12>>2];k[L+16>>2]=k[g+16>>2];k[L+20>>2]=k[g+20>>2];k[L+24>>2]=k[g+24>>2];k[L+28>>2]=k[g+28>>2];k[L+32>>2]=k[g+32>>2];c=k[g+36>>2]|0;k[L+36>>2]=c;f=L+40|0;k[f>>2]=I;I=L+48|0;m=L+44|0;k[m>>2]=I;k[L+52>>2]=0;k[I>>2]=0;if(c|0){I=c+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[b>>2]|0)<3){H=k[g+44>>2]|0;I=k[m>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2];break}k[n>>2]=0;x1(L,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){a=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;c=k[m>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else Q1(L,v,-1);while(0);if((d|0)!=3){k[w>>2]=0;b=w+4|0;k[b>>2]=0;c=ZT(16)|0;k[c>>2]=1;f=c+4|0;k[w>>2]=f;k[b>>2]=10;i[c+14>>0]=0;g=352171;h=f+10|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,w,352015,352031,95);k[b>>2]=0;k[w>>2]=0;I=k[c>>2]|0;k[c>>2]=I+-1;if((I|0)==1)ggb(k[c+-4>>2]|0)}G=k[O+8>>2]|0;H=k[O+12>>2]|0;I=G+-1|0;if(t){E=(G|0)>1;D=(H|0)>1;C=D<<31>>31;D=D&1;b=E&1;E=E?G+-2|0:I}else{C=0;D=0;b=0;E=I}if((G|0)>0){F=O+44|0;d=0-b|0;w=M+16|0;x=M+44|0;y=L+16|0;z=L+44|0;v=(H|0)<2?C:1;A=H+-1|0;t=0;do{if(!t){c=k[N>>2]|0;b=k[k[F>>2]>>2]|0;u=c+(b&d)|0}else{c=k[N>>2]|0;b=k[k[F>>2]>>2]|0;u=c+(aa(b,t+-1|0)|0)|0}B=c+(aa(b,t)|0)|0;f=t;t=t+1|0;p=c+(aa(b,(f|0)==(I|0)?E:t)|0)|0;q=(k[w>>2]|0)+(aa(k[k[x>>2]>>2]|0,f)|0)|0;s=(k[y>>2]|0)+(aa(k[k[z>>2]>>2]|0,f)|0)|0;c=(l[p+v>>0]|0)-(l[u+D>>0]|0)|0;a=(l[u+v>>0]|0)-(l[p+D>>0]|0)|0;b=(l[p>>0]|0)-(l[u>>0]|0)|0;j[q>>1]=((l[B+v>>0]|0)-(l[B+D>>0]|0)<<1)+a+c;j[s>>1]=c-a+(b<<1);b=f>>>31^1;f=f>>31;a=i[u+f>>0]|0;c=i[u+b>>0]|0;g=i[B+f>>0]|0;f=i[p+f>>0]|0;m=i[p+b>>0]|0;if((b|0)>=(A|0)){if((b|0)<(H|0)){h=g;g=c;c=a;J=58}}else{e=f;o=i[B+b>>0]|0;n=g;f=m;while(1){J=b;b=b+1|0;g=i[u+b>>0]|0;h=i[B+b>>0]|0;m=i[p+b>>0]|0;a=(m&255)-(a&255)|0;e=(g&255)-(e&255)|0;j[q+(J<<1)>>1]=a+e+((h&255)-(n&255)<<1);j[s+(J<<1)>>1]=((f&255)-(c&255)<<1)-e+a;if((b|0)==(A|0)){h=o;b=A;J=58;break}else{a=c;n=o;e=f;o=h;c=g;f=m}}}if((J|0)==58){J=0;o=b+C|0;p=(l[p+o>>0]|0)-(c&255)|0;u=(l[u+o>>0]|0)-(f&255)|0;j[q+(b<<1)>>1]=p+u+((l[B+o>>0]|0)-(h&255)<<1);j[s+(b<<1)>>1]=((m&255)-(g&255)<<1)-u+p}}while((t|0)!=(G|0))}f=L+36|0;b=k[f>>2]|0;if(b|0?(I=b+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[L+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;J=L+16|0;c=L+4|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[c>>2]|0)>0){f=k[L+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[L+44>>2]|0;if(!((b|0)==(L+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=M+36|0;b=k[f>>2]|0;if(b|0?(J=b+12|0,L=k[J>>2]|0,k[J>>2]=L+-1,(L|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[M+32>>2]|0;if(!b){b=B1()|0;c=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;L=M+16|0;c=M+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[c>>2]|0)>0){f=k[M+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[M+44>>2]|0;if(!((b|0)==(M+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=O+36|0;b=k[f>>2]|0;if(b|0?(L=b+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){c=k[f>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[O+32>>2]|0;if(b|0)break;b=B1()|0;c=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[f>>2]=0}k[f>>2]=0;f=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[f>>2]|0)>0){c=k[K>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[O+44>>2]|0;if((b|0)==(O+48|0)|(b|0)==0){r=P;return}ggb(k[b+-4>>2]|0);r=P;return}function Dm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+32|0;e=c+16|0;d=c;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=a;a=d+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[d>>2]=33882112;k[d+4>>2]=b;FV(e,d);r=c;return}function Em(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=r;r=r+240|0;t=H+32|0;D=H;p=H+224|0;G=H+168|0;m=H+160|0;F=H+104|0;E=H+96|0;B=H+88|0;A=H+80|0;C=H+40|0;y=H+64|0;n=H+48|0;k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=a;o=n+4|0;s=n+4+4|0;k[s>>2]=0;k[s+4>>2]=0;k[n>>2]=33619968;k[o>>2]=b;b=k[d>>2]|0;d=k[d+4>>2]|0;s=k[e>>2]|0;x=k[e+4>>2]|0;z=S1(y,-1)|0;e=z&7;i=z&4088;R1(p,y,-1);if((g|0)==0|f^1){u=b;v=d}else{u=(k[p>>2]|0)==1?1:b;v=(k[p+4>>2]|0)==1?1:d}q=(e|0)==0;y=(q?4:6)|i;w=((c|0)<0?(e>>>0<5?5:6):c)&7|i;k[G>>2]=k[a>>2];l=G+4|0;d=a+4|0;b=k[d>>2]|0;k[l>>2]=b;c=G+8|0;k[c>>2]=k[a+8>>2];k[G+12>>2]=k[a+12>>2];k[G+16>>2]=k[a+16>>2];k[G+20>>2]=k[a+20>>2];k[G+24>>2]=k[a+24>>2];k[G+28>>2]=k[a+28>>2];k[G+32>>2]=k[a+32>>2];e=k[a+36>>2]|0;k[G+36>>2]=e;i=G+40|0;k[i>>2]=c;c=G+48|0;j=G+44|0;k[j>>2]=c;k[G+52>>2]=0;k[c>>2]=0;if(e){b=e+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[d>>2]|0}if((b|0)>=3){k[l>>2]=0;x1(G,b,0,0,0);if((k[l>>2]|0)>0){c=k[a+40>>2]|0;i=k[i>>2]|0;e=k[a+44>>2]|0;d=k[j>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[c+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{l=k[a+44>>2]|0;a=k[j>>2]|0;k[a>>2]=k[l>>2];k[a+4>>2]=k[l+4>>2]}k[m>>2]=k[p>>2];k[m+4>>2]=k[p+4>>2];x2(n,m,w,0);do if((k[n>>2]&2031616|0)==65536){i=k[o>>2]|0;k[F>>2]=k[i>>2];a=F+4|0;b=i+4|0;k[a>>2]=k[b>>2];p=F+8|0;k[p>>2]=k[i+8>>2];k[F+12>>2]=k[i+12>>2];k[F+16>>2]=k[i+16>>2];k[F+20>>2]=k[i+20>>2];k[F+24>>2]=k[i+24>>2];k[F+28>>2]=k[i+28>>2];k[F+32>>2]=k[i+32>>2];d=k[i+36>>2]|0;k[F+36>>2]=d;e=F+40|0;k[e>>2]=p;p=F+48|0;j=F+44|0;k[j>>2]=p;k[F+52>>2]=0;k[p>>2]=0;if(d|0){p=d+12|0;k[p>>2]=(k[p>>2]|0)+1}if((k[b>>2]|0)<3){o=k[i+44>>2]|0;p=k[j>>2]|0;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];break}k[a>>2]=0;x1(F,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){l=k[i+40>>2]|0;c=k[e>>2]|0;e=k[i+44>>2]|0;d=k[j>>2]|0;b=0;do{k[c+(b<<2)>>2]=k[l+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0))}}else Q1(F,n,-1);while(0);e=(s|0)<0?(u|0)/2|0:s;a:do if(q){while(1){b=fgb(12)|0;if(b|0){d=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){d=0;break}Qh[b&7]()}k[d>>2]=88980;k[d+4>>2]=u;k[d+8>>2]=e;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}s=b+4|0;k[s>>2]=1;k[b>>2]=89e3;k[b+8>>2]=d;k[E>>2]=b;k[E+4>>2]=d;k[s>>2]=(k[s>>2]|0)+1;t=k[s>>2]|0;k[s>>2]=t+-1;if((t|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b)}else switch(z&7){case 2:{while(1){b=fgb(12)|0;if(b|0){d=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){d=0;break}Qh[b&7]()}k[d>>2]=89020;k[d+4>>2]=u;k[d+8>>2]=e;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}s=b+4|0;k[s>>2]=1;k[b>>2]=89040;k[b+8>>2]=d;k[E>>2]=b;k[E+4>>2]=d;k[s>>2]=(k[s>>2]|0)+1;t=k[s>>2]|0;k[s>>2]=t+-1;if((t|0)!=1)break a;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);break a}case 3:{while(1){b=fgb(12)|0;if(b|0){d=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){d=0;break}Qh[b&7]()}k[d>>2]=89060;k[d+4>>2]=u;k[d+8>>2]=e;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}s=b+4|0;k[s>>2]=1;k[b>>2]=89080;k[b+8>>2]=d;k[E>>2]=b;k[E+4>>2]=d;k[s>>2]=(k[s>>2]|0)+1;t=k[s>>2]|0;k[s>>2]=t+-1;if((t|0)!=1)break a;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);break a}case 5:{while(1){b=fgb(12)|0;if(b|0){d=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){d=0;break}Qh[b&7]()}k[d>>2]=89100;k[d+4>>2]=u;k[d+8>>2]=e;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}s=b+4|0;k[s>>2]=1;k[b>>2]=89120;k[b+8>>2]=d;k[E>>2]=b;k[E+4>>2]=d;k[s>>2]=(k[s>>2]|0)+1;t=k[s>>2]|0;k[s>>2]=t+-1;if((t|0)!=1)break a;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);break a}case 6:{while(1){b=fgb(12)|0;if(b|0){d=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){d=0;break}Qh[b&7]()}k[d>>2]=89140;k[d+4>>2]=u;k[d+8>>2]=e;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}s=b+4|0;k[s>>2]=1;k[b>>2]=89160;k[b+8>>2]=d;k[E>>2]=b;k[E+4>>2]=d;k[s>>2]=(k[s>>2]|0)+1;t=k[s>>2]|0;k[s>>2]=t+-1;if((t|0)!=1)break a;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);break a}default:{k[t>>2]=z;k[t+4>>2]=y;$8(D,348914,t);Y8(-213,D,350926,348846,1520);b=k[D>>2]|0;k[D+4>>2]=0;k[D>>2]=0;if(b|0?(s=b+-4|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0)ggb(k[b+-8>>2]|0);k[E>>2]=0;k[E+4>>2]=0;break a}}while(0);if(f)h=1.0/+(aa(u,v)|0);else h=1.0;Nsa(B,y,w,v,x,h);k[A>>2]=0;k[A+4>>2]=0;while(1){b=fgb(200)|0;if(b|0){i=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){i=0;break}Qh[b&7]()}k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;qga(i,A,E,B,z,w,y,g,-1,D);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}e=b+4|0;k[e>>2]=1;k[b>>2]=72040;k[b+8>>2]=i;d=k[A>>2]|0;if(d|0?(g=d+4|0,A=k[g>>2]|0,k[g>>2]=A+-1,(A|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);A=k[(k[i>>2]|0)+20>>2]|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=-1;k[D+12>>2]=-1;k[C>>2]=0;k[C+4>>2]=0;Lg[A&255](i,G,F,D,C,0);D=k[e>>2]|0;k[e>>2]=D+-1;if((D|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);b=k[B>>2]|0;if(b|0?(C=b+4|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);b=k[E>>2]|0;if(b|0?(D=b+4|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);e=F+36|0;b=k[e>>2]|0;if(b|0?(D=b+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[F+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;E=F+16|0;d=F+4|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[d>>2]|0)>0){e=k[F+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[F+44>>2]|0;if(!((b|0)==(F+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=G+36|0;b=k[e>>2]|0;if(b|0?(E=b+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[G+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;F=G+16|0;d=G+4|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[d>>2]|0)>0){e=k[G+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[G+44>>2]|0;if((b|0)==(G+48|0)|(b|0)==0){r=H;return}ggb(k[b+-4>>2]|0);r=H;return}function Fm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+32|0;e=c+16|0;d=c;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=a;a=d+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[d>>2]=33619968;k[d+4>>2]=b;ZZ(e,.5,d);r=c;return}function Gm(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0;Ca=r;r=r+1984|0;la=Ca+448|0;qa=Ca+1928|0;ma=Ca+1872|0;na=Ca+1816|0;oa=Ca+1760|0;pa=Ca+1704|0;$=Ca+1648|0;W=Ca+1592|0;S=Ca+1536|0;O=Ca+1464|0;L=Ca+1408|0;F=Ca+224|0;G=Ca;Ba=Ca+1352|0;l=Ca+1344|0;za=Ca+1288|0;ya=Ca+1232|0;xa=Ca+1176|0;wa=Ca+1120|0;sa=Ca+672|0;m=Ca+1520|0;n=m+4|0;j=m+4+4|0;k[j>>2]=0;k[j+4>>2]=0;k[m>>2]=33619968;k[n>>2]=b;k[Ba>>2]=k[a>>2];j=Ba+4|0;e=a+4|0;b=k[e>>2]|0;k[j>>2]=b;va=Ba+8|0;k[va>>2]=k[a+8>>2];k[Ba+12>>2]=k[a+12>>2];k[Ba+16>>2]=k[a+16>>2];k[Ba+20>>2]=k[a+20>>2];k[Ba+24>>2]=k[a+24>>2];k[Ba+28>>2]=k[a+28>>2];k[Ba+32>>2]=k[a+32>>2];f=k[a+36>>2]|0;k[Ba+36>>2]=f;Aa=Ba+40|0;k[Aa>>2]=va;va=Ba+48|0;i=Ba+44|0;k[i>>2]=va;k[Ba+52>>2]=0;k[va>>2]=0;if(f){b=f+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[e>>2]|0}if((b|0)>=3){k[j>>2]=0;x1(Ba,b,0,0,0);if((k[j>>2]|0)>0){g=k[a+40>>2]|0;h=k[Aa>>2]|0;f=k[a+44>>2]|0;e=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[g+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else{ua=k[a+44>>2]|0;va=k[i>>2]|0;k[va>>2]=k[ua>>2];k[va+4>>2]=k[ua+4>>2]}ua=k[Aa>>2]|0;va=k[ua>>2]|0;k[l>>2]=k[ua+4>>2];k[l+4>>2]=va;x2(m,l,16,0);do if((k[m>>2]&2031616|0)==65536){g=k[n>>2]|0;k[za>>2]=k[g>>2];j=za+4|0;b=g+4|0;k[j>>2]=k[b>>2];va=za+8|0;k[va>>2]=k[g+8>>2];k[za+12>>2]=k[g+12>>2];k[za+16>>2]=k[g+16>>2];k[za+20>>2]=k[g+20>>2];k[za+24>>2]=k[g+24>>2];k[za+28>>2]=k[g+28>>2];k[za+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[za+36>>2]=e;f=za+40|0;k[f>>2]=va;va=za+48|0;a=za+44|0;k[a>>2]=va;k[za+52>>2]=0;k[va>>2]=0;if(e|0){va=e+12|0;k[va>>2]=(k[va>>2]|0)+1}if((k[b>>2]|0)<3){ua=k[g+44>>2]|0;va=k[a>>2]|0;k[va>>2]=k[ua>>2];k[va+4>>2]=k[ua+4>>2];break}k[j>>2]=0;x1(za,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){i=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[a>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[i+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else Q1(za,m,-1);while(0);e=k[Aa>>2]|0;f=k[e+4>>2]|0;e=k[e>>2]|0;k[ya>>2]=1124007936;ua=ya+4|0;b=ya+8|0;ra=ya+40|0;v=ua;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[ra>>2]=b;va=ya+48|0;ta=ya+44|0;k[ta>>2]=va;k[ya+52>>2]=0;k[va>>2]=0;k[la>>2]=e;ca=la+4|0;k[ca>>2]=f;G1(ya,2,la,21);ba=la+4|0;aa=ba+4|0;k[aa>>2]=0;k[aa+4>>2]=0;k[la>>2]=33619968;k[ba>>2]=ya;SW(Ba,la,21,.00392156862745098,0.0);ba=k[ra>>2]|0;aa=k[ba>>2]|0;ba=k[ba+4>>2]|0;k[xa>>2]=1124007936;ia=xa+4|0;f=xa+8|0;ha=xa+40|0;v=ia;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[ha>>2]=f;ka=xa+48|0;ja=xa+44|0;k[ja>>2]=ka;k[xa+52>>2]=0;k[ka>>2]=0;k[la>>2]=aa;k[ca>>2]=ba;G1(xa,2,la,21);k[wa>>2]=1124007936;fa=wa+4|0;b=wa+8|0;da=wa+40|0;v=fa;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[da>>2]=b;ga=wa+48|0;ea=wa+44|0;k[ea>>2]=ga;k[wa+52>>2]=0;k[ga>>2]=0;k[la>>2]=aa;k[ca>>2]=ba;G1(wa,2,la,5);k[sa>>2]=1124007936;b=sa+8|0;e=sa+40|0;v=sa+4|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=b;b=sa+48|0;k[sa+44>>2]=b;k[sa+52>>2]=0;k[b>>2]=0;k[sa+56>>2]=1124007936;b=sa+64|0;e=sa+96|0;v=sa+60|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=b;b=sa+104|0;k[sa+100>>2]=b;k[sa+108>>2]=0;k[b>>2]=0;k[sa+112>>2]=1124007936;b=sa+120|0;e=sa+152|0;v=sa+116|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=b;b=sa+160|0;k[sa+156>>2]=b;k[sa+164>>2]=0;k[b>>2]=0;k[sa+168>>2]=1124007936;b=sa+176|0;e=sa+208|0;v=sa+172|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=b;b=sa+216|0;k[sa+212>>2]=b;k[sa+220>>2]=0;k[b>>2]=0;k[sa+224>>2]=1124007936;b=sa+232|0;e=sa+264|0;v=sa+228|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=b;b=sa+272|0;k[sa+268>>2]=b;k[sa+276>>2]=0;k[b>>2]=0;k[sa+280>>2]=1124007936;b=sa+288|0;e=sa+320|0;v=sa+284|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=b;b=sa+328|0;k[sa+324>>2]=b;k[sa+332>>2]=0;k[b>>2]=0;k[sa+336>>2]=1124007936;b=sa+344|0;e=sa+376|0;v=sa+340|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=b;b=sa+384|0;k[sa+380>>2]=b;k[sa+388>>2]=0;k[b>>2]=0;k[sa+392>>2]=1124007936;b=sa+400|0;e=sa+432|0;v=sa+396|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=b;g=sa+440|0;k[sa+436>>2]=g;k[sa+444>>2]=0;k[g>>2]=0;M3a(sa,ya,xa,c,d,2);f=k[f>>2]|0;g=k[xa+12>>2]|0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=xa;Z=ma+4|0;b=Z+4|0;k[b>>2]=0;k[b+4>>2]=0;k[ma>>2]=33882112;k[Z>>2]=qa;FV(la,ma);k[ma>>2]=1124007936;Z=ma+4|0;b=ma+8|0;X=ma+40|0;v=Z;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[X>>2]=b;_=ma+48|0;Y=ma+44|0;k[Y>>2]=_;k[ma+52>>2]=0;k[_>>2]=0;k[la>>2]=f;e=la+4|0;k[e>>2]=g;G1(ma,2,la,5);k[na>>2]=1124007936;U=na+4|0;b=na+8|0;R=na+40|0;v=U;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[R>>2]=b;V=na+48|0;T=na+44|0;k[T>>2]=V;k[na+52>>2]=0;k[V>>2]=0;k[la>>2]=f;k[e>>2]=g;G1(na,2,la,5);k[oa>>2]=1124007936;P=oa+4|0;b=oa+8|0;M=oa+40|0;v=P;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[M>>2]=b;Q=oa+48|0;N=oa+44|0;k[N>>2]=Q;k[oa+52>>2]=0;k[Q>>2]=0;k[la>>2]=f;k[e>>2]=g;G1(oa,2,la,5);k[pa>>2]=1124007936;J=pa+4|0;b=pa+8|0;H=pa+40|0;v=J;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[H>>2]=b;K=pa+48|0;I=pa+44|0;k[I>>2]=K;k[pa+52>>2]=0;k[K>>2]=0;k[la>>2]=f;k[e>>2]=g;G1(pa,2,la,5);k[$>>2]=1124007936;D=$+4|0;b=$+8|0;B=$+40|0;v=D;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[B>>2]=b;E=$+48|0;C=$+44|0;k[C>>2]=E;k[$+52>>2]=0;k[E>>2]=0;k[la>>2]=f;k[e>>2]=g;G1($,2,la,5);k[W>>2]=1124007936;z=W+4|0;b=W+8|0;x=W+40|0;v=z;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[x>>2]=b;A=W+48|0;y=W+44|0;k[y>>2]=A;k[W+52>>2]=0;k[A>>2]=0;k[la>>2]=f;k[e>>2]=g;G1(W,2,la,5);t=k[qa>>2]|0;k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=t;t=S+4|0;b=t+4|0;k[b>>2]=0;k[b+4>>2]=0;k[S>>2]=33619968;k[t>>2]=ma;tfa(la,S,5,1,0,3,1.0,0.0,4);t=k[qa>>2]|0;k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=t;t=S+4|0;b=t+4|0;k[b>>2]=0;k[b+4>>2]=0;k[S>>2]=33619968;k[t>>2]=na;tfa(la,S,5,0,1,3,1.0,0.0,4);t=(k[qa>>2]|0)+56|0;k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=t;t=S+4|0;b=t+4|0;k[b>>2]=0;k[b+4>>2]=0;k[S>>2]=33619968;k[t>>2]=oa;tfa(la,S,5,1,0,3,1.0,0.0,4);t=(k[qa>>2]|0)+56|0;k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=t;t=S+4|0;b=t+4|0;k[b>>2]=0;k[b+4>>2]=0;k[S>>2]=33619968;k[t>>2]=pa;tfa(la,S,5,0,1,3,1.0,0.0,4);t=(k[qa>>2]|0)+112|0;k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=t;t=S+4|0;b=t+4|0;k[b>>2]=0;k[b+4>>2]=0;k[S>>2]=33619968;k[t>>2]=$;tfa(la,S,5,1,0,3,1.0,0.0,4);t=(k[qa>>2]|0)+112|0;k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=t;t=S+4|0;b=t+4|0;k[b>>2]=0;k[b+4>>2]=0;k[S>>2]=33619968;k[t>>2]=W;tfa(la,S,5,0,1,3,1.0,0.0,4);k[S>>2]=1124007936;t=S+4|0;b=S+8|0;q=S+40|0;v=t;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[q>>2]=b;u=S+48|0;s=S+44|0;k[s>>2]=u;k[S+52>>2]=0;k[u>>2]=0;k[la>>2]=f;k[e>>2]=g;G1(S,2,la,5);k[O>>2]=1124007936;n=O+4|0;b=O+8|0;l=O+40|0;v=n;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[l>>2]=b;o=O+48|0;m=O+44|0;k[m>>2]=o;k[O+52>>2]=0;k[o>>2]=0;k[la>>2]=f;k[e>>2]=g;G1(O,2,la,5);k[L>>2]=1124007936;i=L+4|0;b=L+8|0;h=L+40|0;v=i;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[h>>2]=b;j=L+48|0;a=L+44|0;k[a>>2]=j;k[L+52>>2]=0;k[j>>2]=0;k[la>>2]=f;k[e>>2]=g;G1(L,2,la,5);k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=ma;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=na;b=G+4|0;e=b+4|0;k[e>>2]=0;k[e+4>>2]=0;k[G>>2]=33619968;k[b>>2]=S;UZ(la,F,G);k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=oa;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=pa;b=G+4|0;e=b+4|0;k[e>>2]=0;k[e+4>>2]=0;k[G>>2]=33619968;k[b>>2]=O;UZ(la,F,G);k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=$;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=W;b=G+4|0;e=b+4|0;k[e>>2]=0;k[e+4>>2]=0;k[G>>2]=33619968;k[b>>2]=L;UZ(la,F,G);k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=1124007936;b=G+16|0;e=G+48|0;v=G+12|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=b;b=G+56|0;k[G+52>>2]=b;k[G+60>>2]=0;k[b>>2]=0;k[G+64>>2]=1124007936;b=G+72|0;e=G+104|0;v=G+68|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=b;b=G+112|0;k[G+108>>2]=b;k[G+116>>2]=0;k[b>>2]=0;k[G+120>>2]=1124007936;b=G+128|0;e=G+160|0;v=G+124|0;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[e>>2]=b;v=G+168|0;k[G+164>>2]=v;w=v+56|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;k[la+16>>2]=0;k[la+20>>2]=0;k[la+24>>2]=0;k[la+28>>2]=0;G0(G,S,O,1.0,1.0,la);W0(F,G,L);f=k[F>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,F,wa,-1);XN(F);XN(G);p[F>>3]=1.0;f=F+8|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;Z0(la,F,wa);f=k[la>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,la,wa,-1);XN(la);f=L+36|0;b=k[f>>2]|0;if(b|0?(F=b+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[L+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=L+16|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[i>>2]|0)>0){e=k[h>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[i>>2]|0))}b=k[a>>2]|0;if(!((b|0)==(j|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=O+36|0;b=k[f>>2]|0;if(b|0?(G=b+12|0,L=k[G>>2]|0,k[G>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[O+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[n>>2]|0)>0){e=k[l>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[n>>2]|0))}b=k[m>>2]|0;if(!((b|0)==(o|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=S+36|0;b=k[f>>2]|0;if(b|0?(L=b+12|0,O=k[L>>2]|0,k[L>>2]=O+-1,(O|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[S+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;S=S+16|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[t>>2]|0)>0){e=k[q>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[s>>2]|0;if(!((b|0)==(u|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=W+36|0;b=k[f>>2]|0;if(b|0?(O=b+12|0,S=k[O>>2]|0,k[O>>2]=S+-1,(S|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[W+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;W=W+16|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[z>>2]|0)>0){e=k[x>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[y>>2]|0;if(!((b|0)==(A|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=$+36|0;b=k[f>>2]|0;if(b|0?(S=b+12|0,W=k[S>>2]|0,k[S>>2]=W+-1,(W|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[$+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;$=$+16|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[D>>2]|0)>0){e=k[B>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[D>>2]|0))}b=k[C>>2]|0;if(!((b|0)==(E|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=pa+36|0;b=k[f>>2]|0;do if(b|0){W=b+12|0;$=k[W>>2]|0;k[W>>2]=$+-1;if(($|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[pa+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;$=pa+16|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[J>>2]|0)>0){e=k[H>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[J>>2]|0))}b=k[I>>2]|0;if(!((b|0)==(K|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=oa+36|0;b=k[f>>2]|0;do if(b|0){W=b+12|0;$=k[W>>2]|0;k[W>>2]=$+-1;if(($|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[oa+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;$=oa+16|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[P>>2]|0)>0){e=k[M>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[P>>2]|0))}b=k[N>>2]|0;if(!((b|0)==(Q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=na+36|0;b=k[f>>2]|0;do if(b|0){W=b+12|0;$=k[W>>2]|0;k[W>>2]=$+-1;if(($|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[na+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;$=na+16|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[U>>2]|0)>0){e=k[R>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[U>>2]|0))}b=k[T>>2]|0;if(!((b|0)==(V|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ma+36|0;b=k[f>>2]|0;do if(b|0){W=b+12|0;$=k[W>>2]|0;k[W>>2]=$+-1;if(($|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ma+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;$=ma+16|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[Z>>2]|0)>0){e=k[X>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Z>>2]|0))}b=k[Y>>2]|0;if(!((b|0)==(_|0)|(b|0)==0))ggb(k[b+-4>>2]|0);zF(qa);k[qa>>2]=1124007936;i=qa+4|0;b=qa+8|0;h=qa+40|0;v=i;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[h>>2]=b;a=qa+48|0;g=qa+44|0;k[g>>2]=a;k[qa+52>>2]=0;k[a>>2]=0;k[la>>2]=aa;k[ca>>2]=ba;G1(qa,2,la,21);k[ma>>2]=0;k[ma+4>>2]=0;k[ma+8>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=xa;f=na+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[na>>2]=33882112;k[f>>2]=ma;FV(la,na);f=k[ma>>2]|0;k[na+8>>2]=0;k[na+12>>2]=0;k[na>>2]=16842752;k[na+4>>2]=f;k[oa+8>>2]=0;k[oa+12>>2]=0;k[oa>>2]=16842752;k[oa+4>>2]=wa;b=pa+4|0;ca=b+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[pa>>2]=33619968;k[b>>2]=f;p[la>>3]=1.0;sU(na,oa,pa,49332,-1,40032,1,la);b=(k[ma>>2]|0)+56|0;k[na+8>>2]=0;k[na+12>>2]=0;k[na>>2]=16842752;k[na+4>>2]=b;k[oa+8>>2]=0;k[oa+12>>2]=0;k[oa>>2]=16842752;k[oa+4>>2]=wa;f=pa+4|0;ca=f+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[pa>>2]=33619968;k[f>>2]=b;p[la>>3]=1.0;sU(na,oa,pa,49332,-1,40032,1,la);f=(k[ma>>2]|0)+112|0;k[na+8>>2]=0;k[na+12>>2]=0;k[na>>2]=16842752;k[na+4>>2]=f;k[oa+8>>2]=0;k[oa+12>>2]=0;k[oa>>2]=16842752;k[oa+4>>2]=wa;b=pa+4|0;ca=b+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[pa>>2]=33619968;k[b>>2]=f;p[la>>3]=1.0;sU(na,oa,pa,49332,-1,40032,1,la);k[na+8>>2]=0;k[na+12>>2]=0;k[na>>2]=17104896;k[na+4>>2]=ma;b=oa+4|0;f=b+4|0;k[f>>2]=0;k[f+4>>2]=0;k[oa>>2]=33619968;k[b>>2]=qa;k[la>>2]=0;b=la+4|0;k[b>>2]=0;k[la+8>>2]=0;B2(na,la);f=k[la>>2]|0;b=k[b>>2]|0;GV((f|0)==(b|0)?0:f,(b-f|0)/56|0,oa);zF(la);f=la+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[la>>2]=33619968;k[f>>2]=za;SW(qa,la,16,255.0,0.0);zF(ma);f=qa+36|0;b=k[f>>2]|0;do if(b|0){oa=b+12|0;pa=k[oa>>2]|0;k[oa>>2]=pa+-1;if((pa|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[qa+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;qa=qa+16|0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[qa+12>>2]=0;if((k[i>>2]|0)>0){e=k[h>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[i>>2]|0))}b=k[g>>2]|0;if(!((b|0)==(a|0)|(b|0)==0))ggb(k[b+-4>>2]|0);N3a(sa);f=wa+36|0;b=k[f>>2]|0;do if(b|0){qa=b+12|0;sa=k[qa>>2]|0;k[qa>>2]=sa+-1;if((sa|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[wa+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;wa=wa+16|0;k[wa>>2]=0;k[wa+4>>2]=0;k[wa+8>>2]=0;k[wa+12>>2]=0;if((k[fa>>2]|0)>0){e=k[da>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[fa>>2]|0))}b=k[ea>>2]|0;if(!((b|0)==(ga|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=xa+36|0;b=k[f>>2]|0;do if(b|0){sa=b+12|0;wa=k[sa>>2]|0;k[sa>>2]=wa+-1;if((wa|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[xa+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;xa=xa+16|0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[ia>>2]|0)>0){e=k[ha>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ia>>2]|0))}b=k[ja>>2]|0;if(!((b|0)==(ka|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ya+36|0;b=k[f>>2]|0;do if(b|0){wa=b+12|0;xa=k[wa>>2]|0;k[wa>>2]=xa+-1;if((xa|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ya+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;ya=ya+16|0;k[ya>>2]=0;k[ya+4>>2]=0;k[ya+8>>2]=0;k[ya+12>>2]=0;if((k[ua>>2]|0)>0){e=k[ra>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ua>>2]|0))}b=k[ta>>2]|0;if(!((b|0)==(va|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=za+36|0;b=k[f>>2]|0;do if(b|0){xa=b+12|0;ya=k[xa>>2]|0;k[xa>>2]=ya+-1;if((ya|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[za+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;ya=za+16|0;e=za+4|0;k[ya>>2]=0;k[ya+4>>2]=0;k[ya+8>>2]=0;k[ya+12>>2]=0;if((k[e>>2]|0)>0){f=k[za+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[za+44>>2]|0;if(!((b|0)==(za+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Ba+36|0;b=k[f>>2]|0;do if(b|0){ya=b+12|0;za=k[ya>>2]|0;k[ya>>2]=za+-1;if((za|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Ba+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;za=Ba+16|0;f=Ba+4|0;k[za>>2]=0;k[za+4>>2]=0;k[za+8>>2]=0;k[za+12>>2]=0;if((k[f>>2]|0)>0){e=k[Aa>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[Ba+44>>2]|0;if((b|0)==(Ba+48|0)|(b|0)==0){r=Ca;return}ggb(k[b+-4>>2]|0);r=Ca;return}function Hm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+64|0;j=f+48|0;i=f+32|0;h=f+16|0;g=f;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=a;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b;b=h+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=d;sU(j,i,h,g,e,39968,0,0);r=f;return}function Im(a,b){a=a|0;b=b|0;var c=0,d=0;c=r;r=r+16|0;d=c;k[d+8>>2]=0;k[d+12>>2]=0;k[d>>2]=16842752;k[d+4>>2]=b;g7(a,d);r=c;return}function Jm(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;T=r;r=r+1600|0;I=T+1536|0;L=T+1480|0;J=T+1424|0;H=T+672|0;F=T+448|0;G=T+1408|0;S=T+1336|0;R=T+1264|0;q=T+1256|0;Q=T+1200|0;O=T+1144|0;t=T+224|0;N=T+1088|0;u=T;M=T+688|0;m=T+1392|0;s=T+1320|0;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;n=m+4|0;k[n>>2]=b;o=s+4|0;l=s+4+4|0;k[l>>2]=0;k[l+4>>2]=0;k[s>>2]=33619968;k[o>>2]=c;k[S>>2]=k[a>>2];l=S+4|0;c=a+4|0;b=k[c>>2]|0;k[l>>2]=b;P=S+8|0;k[P>>2]=k[a+8>>2];k[S+12>>2]=k[a+12>>2];k[S+16>>2]=k[a+16>>2];k[S+20>>2]=k[a+20>>2];k[S+24>>2]=k[a+24>>2];k[S+28>>2]=k[a+28>>2];k[S+32>>2]=k[a+32>>2];g=k[a+36>>2]|0;k[S+36>>2]=g;h=S+40|0;k[h>>2]=P;P=S+48|0;j=S+44|0;k[j>>2]=P;k[S+52>>2]=0;k[P>>2]=0;if(g){b=g+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[l>>2]=0;x1(S,b,0,0,0);if((k[l>>2]|0)>0){i=k[a+40>>2]|0;h=k[h>>2]|0;g=k[a+44>>2]|0;c=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[i+(b<<2)>>2];k[c+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else{K=k[a+44>>2]|0;P=k[j>>2]|0;k[P>>2]=k[K>>2];k[P+4>>2]=k[K+4>>2]}do if((k[m>>2]&2031616|0)==65536){i=k[n>>2]|0;k[R>>2]=k[i>>2];l=R+4|0;b=i+4|0;k[l>>2]=k[b>>2];P=R+8|0;k[P>>2]=k[i+8>>2];k[R+12>>2]=k[i+12>>2];k[R+16>>2]=k[i+16>>2];k[R+20>>2]=k[i+20>>2];k[R+24>>2]=k[i+24>>2];k[R+28>>2]=k[i+28>>2];k[R+32>>2]=k[i+32>>2];c=k[i+36>>2]|0;k[R+36>>2]=c;g=R+40|0;k[g>>2]=P;P=R+48|0;j=R+44|0;k[j>>2]=P;k[R+52>>2]=0;k[P>>2]=0;if(c|0){P=c+12|0;k[P>>2]=(k[P>>2]|0)+1}if((k[b>>2]|0)<3){K=k[i+44>>2]|0;P=k[j>>2]|0;k[P>>2]=k[K>>2];k[P+4>>2]=k[K+4>>2];break}k[l>>2]=0;x1(R,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){a=k[i+40>>2]|0;h=k[g>>2]|0;g=k[i+44>>2]|0;c=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(R,m,-1);while(0);P=S+40|0;E=k[P>>2]|0;K=k[E>>2]|0;k[q>>2]=k[E+4>>2];k[q+4>>2]=K;x2(s,q,k[S>>2]&4095,0);do if((k[s>>2]&2031616|0)==65536){h=k[o>>2]|0;k[Q>>2]=k[h>>2];l=Q+4|0;b=h+4|0;k[l>>2]=k[b>>2];K=Q+8|0;k[K>>2]=k[h+8>>2];k[Q+12>>2]=k[h+12>>2];k[Q+16>>2]=k[h+16>>2];k[Q+20>>2]=k[h+20>>2];k[Q+24>>2]=k[h+24>>2];k[Q+28>>2]=k[h+28>>2];k[Q+32>>2]=k[h+32>>2];c=k[h+36>>2]|0;k[Q+36>>2]=c;g=Q+40|0;k[g>>2]=K;K=Q+48|0;j=Q+44|0;k[j>>2]=K;k[Q+52>>2]=0;k[K>>2]=0;if(c|0){K=c+12|0;k[K>>2]=(k[K>>2]|0)+1}if((k[b>>2]|0)<3){E=k[h+44>>2]|0;K=k[j>>2]|0;k[K>>2]=k[E>>2];k[K+4>>2]=k[E+4>>2];break}k[l>>2]=0;x1(Q,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){a=k[h+40>>2]|0;i=k[g>>2]|0;g=k[h+44>>2]|0;c=k[j>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(Q,s,-1);while(0);K=R+40|0;h=k[K>>2]|0;g=k[h+4>>2]|0;h=k[h>>2]|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=1124007936;b=t+16|0;c=t+48|0;j=t+12|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;b=t+56|0;k[t+52>>2]=b;k[t+60>>2]=0;k[b>>2]=0;k[t+64>>2]=1124007936;b=t+72|0;c=t+104|0;j=t+68|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;b=t+112|0;k[t+108>>2]=b;k[t+116>>2]=0;k[b>>2]=0;k[t+120>>2]=1124007936;b=t+128|0;c=t+160|0;j=t+124|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;j=t+168|0;k[t+164>>2]=j;w=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[I>>2]=g;k[I+4>>2]=h;j1(t,48,I,0);k[O>>2]=1124007936;D=O+4|0;b=O+8|0;B=O+40|0;j=D;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[B>>2]=b;E=O+48|0;C=O+44|0;k[C>>2]=E;k[O+52>>2]=0;k[E>>2]=0;A=k[t>>2]|0;dh[k[(k[A>>2]|0)+12>>2]&255](A,t,O,-1);XN(t);if((k[R>>2]&4088|0)==16){k[I+8>>2]=0;k[I+12>>2]=0;k[I>>2]=16842752;k[I+4>>2]=R;A=L+4|0;z=A+4|0;k[z>>2]=0;k[z+4>>2]=0;k[L>>2]=33619968;k[A>>2]=O;$aa(I,L,6,0)}else KG(O,R)|0;h=k[P>>2]|0;g=k[h+4>>2]|0;h=k[h>>2]|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=1124007936;b=u+16|0;c=u+48|0;j=u+12|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;b=u+56|0;k[u+52>>2]=b;k[u+60>>2]=0;k[b>>2]=0;k[u+64>>2]=1124007936;b=u+72|0;c=u+104|0;j=u+68|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;b=u+112|0;k[u+108>>2]=b;k[u+116>>2]=0;k[b>>2]=0;k[u+120>>2]=1124007936;b=u+128|0;c=u+160|0;j=u+124|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;j=u+168|0;k[u+164>>2]=j;w=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[I>>2]=g;k[I+4>>2]=h;j1(u,48,I,16);k[N>>2]=1124007936;z=N+4|0;b=N+8|0;x=N+40|0;j=z;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[x>>2]=b;A=N+48|0;y=N+44|0;k[y>>2]=A;k[N+52>>2]=0;k[A>>2]=0;b=k[u>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,u,N,-1);XN(u);b=I+4|0;j=b+4|0;k[j>>2]=0;k[j+4>>2]=0;k[I>>2]=33619968;k[b>>2]=N;k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=O;nY(S,I,L);b=M+36|0;j=M;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[b>>2]=1124007936;b=M+44|0;c=M+76|0;j=M+40|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;b=M+84|0;k[M+80>>2]=b;k[M+88>>2]=0;k[b>>2]=0;k[M+92>>2]=1124007936;b=M+100|0;c=M+132|0;j=M+96|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;b=M+140|0;k[M+136>>2]=b;k[M+144>>2]=0;k[b>>2]=0;k[M+148>>2]=1124007936;b=M+156|0;i=M+188|0;j=M+152|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[i>>2]=b;b=M+196|0;k[M+192>>2]=b;k[M+200>>2]=0;k[b>>2]=0;k[M+204>>2]=1124007936;b=M+212|0;c=M+244|0;j=M+208|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;b=M+252|0;k[M+248>>2]=b;k[M+256>>2]=0;k[b>>2]=0;k[M+260>>2]=1124007936;b=M+268|0;c=M+300|0;j=M+264|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;b=M+308|0;k[M+304>>2]=b;k[M+312>>2]=0;k[b>>2]=0;k[M+316>>2]=1124007936;b=M+324|0;c=M+356|0;j=M+320|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;c=M+364|0;k[M+360>>2]=c;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;k[c+16>>2]=0;k[c+20>>2]=0;k[c+24>>2]=0;k[c+28>>2]=0;U3a(M,S,N,O);c=k[x>>2]|0;g=k[c+4>>2]|0;c=k[c>>2]|0;k[L>>2]=1124007936;u=L+4|0;b=L+8|0;s=L+40|0;j=u;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[s>>2]=b;v=L+48|0;t=L+44|0;k[t>>2]=v;k[L+52>>2]=0;k[v>>2]=0;k[I>>2]=c;h=I+4|0;k[h>>2]=g;G1(L,2,I,0);k[I+8>>2]=0;k[I+12>>2]=0;k[I>>2]=16842752;k[I+4>>2]=N;l=J+4|0;g=l+4|0;k[g>>2]=0;k[g+4>>2]=0;k[J>>2]=33619968;k[l>>2]=L;uaa(I,J,d,e,f,0);l=M+148|0;g=k[i>>2]|0;c=k[g+4>>2]|0;g=k[g>>2]|0;k[J>>2]=1124007936;o=J+4|0;b=J+8|0;m=J+40|0;j=o;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[m>>2]=b;q=J+48|0;n=J+44|0;k[n>>2]=q;k[J+52>>2]=0;k[q>>2]=0;k[I>>2]=g;k[h>>2]=c;G1(J,2,I,21);p[H>>3]=0.0;k[I>>2]=-1056833530;k[I+4>>2]=H;k[I+8>>2]=1;k[I+12>>2]=1;pY(J,I,49332);k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=1124007936;b=F+16|0;c=F+48|0;j=F+12|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;b=F+56|0;k[F+52>>2]=b;k[F+60>>2]=0;k[b>>2]=0;k[F+64>>2]=1124007936;b=F+72|0;c=F+104|0;j=F+68|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;b=F+112|0;k[F+108>>2]=b;k[F+116>>2]=0;k[b>>2]=0;k[F+120>>2]=1124007936;b=F+128|0;c=F+160|0;j=F+124|0;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[c>>2]=b;j=F+168|0;k[F+164>>2]=j;w=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));h1(F,5,L,255.0);k[I>>2]=1124007936;a=I+4|0;b=I+8|0;i=I+40|0;j=a;w=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(w|0));k[i>>2]=b;j=I+48|0;h=I+44|0;k[h>>2]=j;k[I+52>>2]=0;k[j>>2]=0;g=k[F>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,F,I,-1);XN(F);g=H+4|0;b=g+4|0;k[b>>2]=0;k[b+4>>2]=0;k[H>>2]=33619968;k[g>>2]=l;k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=I;nY(J,H,G);g=M+204|0;b=H+4|0;F=b+4|0;k[F>>2]=0;k[F+4>>2]=0;k[H>>2]=33619968;k[b>>2]=g;k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=I;nY(J,H,G);b=M+260|0;W3a(l,b,l);W3a(g,b,g);X3a(M,S,O,Q);g=I+36|0;b=k[g>>2]|0;if(b|0?(G=b+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[I+32>>2]|0;if(!b){b=B1()|0;c=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}k[g>>2]=0;I=I+16|0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[a>>2]|0)>0){c=k[i>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[h>>2]|0;if(!((b|0)==(j|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=J+36|0;b=k[g>>2]|0;if(b|0?(H=b+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[J+32>>2]|0;if(!b){b=B1()|0;c=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}k[g>>2]=0;J=J+16|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[o>>2]|0)>0){c=k[m>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[o>>2]|0))}b=k[n>>2]|0;if(!((b|0)==(q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=L+36|0;b=k[g>>2]|0;if(b|0?(I=b+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[L+32>>2]|0;if(!b){b=B1()|0;c=k[g>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}k[g>>2]=0;L=L+16|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[u>>2]|0)>0){c=k[s>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[u>>2]|0))}b=k[t>>2]|0;if(!((b|0)==(v|0)|(b|0)==0))ggb(k[b+-4>>2]|0);P3a(M);g=N+36|0;b=k[g>>2]|0;if(b|0?(L=b+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[N+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}k[g>>2]=0;N=N+16|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[z>>2]|0)>0){c=k[x>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[y>>2]|0;if(!((b|0)==(A|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=O+36|0;b=k[g>>2]|0;if(b|0?(M=b+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[O+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}k[g>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[D>>2]|0)>0){c=k[B>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[D>>2]|0))}b=k[C>>2]|0;if(!((b|0)==(E|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=Q+36|0;b=k[g>>2]|0;do if(b|0){N=b+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Q+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;O=Q+16|0;c=Q+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[c>>2]|0)>0){g=k[Q+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[Q+44>>2]|0;if(!((b|0)==(Q+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=R+36|0;b=k[g>>2]|0;do if(b|0){O=b+12|0;Q=k[O>>2]|0;k[O>>2]=Q+-1;if((Q|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[R+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;Q=R+16|0;g=R+4|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[g>>2]|0)>0){c=k[K>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[R+44>>2]|0;if(!((b|0)==(R+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=S+36|0;b=k[g>>2]|0;do if(b|0){Q=b+12|0;R=k[Q>>2]|0;k[Q>>2]=R+-1;if((R|0)!=1)break;c=k[g>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[S+32>>2]|0;if(b|0)break;b=B1()|0;c=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[g>>2]=0}while(0);k[g>>2]=0;R=S+16|0;g=S+4|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[g>>2]|0)>0){c=k[P>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[S+44>>2]|0;if((b|0)==(S+48|0)|(b|0)==0){r=T;return}ggb(k[b+-4>>2]|0);r=T;return}function Km(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var f=0,g=0,h=0;f=r;r=r+32|0;h=f+16|0;g=f;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=a;a=g+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=b;d=+Yua(h,g,c,d,e);r=f;return +d}function Lm(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+128|0;m=n+72|0;h=n+56|0;j=n;AF(m,b);l=m+4|0;if((k[l>>2]|0)>=3){k[h>>2]=0;b=h+4|0;k[b>>2]=0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[b>>2]=11;i[d+15>>0]=0;f=233283;g=e+11|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,h,220372,216975,2965);k[b>>2]=0;k[h>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0)}g=k[m+12>>2]|0;f=k[m+8>>2]|0;f=(g|0)<(f|0)?g:f;switch(k[m>>2]&4095){case 5:{d=k[m+16>>2]|0;e=((k[m+48>>2]|0)>>>2)+1|0;if((f|0)>0){c=0.0;b=0;do{j=d+((aa(b,e)|0)<<2)|0;c=c+ +o[j>>2];b=b+1|0}while((b|0)<(f|0))}else c=0.0;p[a>>3]=c;a=a+8|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;break}case 6:{d=k[m+16>>2]|0;e=((k[m+48>>2]|0)>>>3)+1|0;if((f|0)>0){c=0.0;b=0;do{j=d+((aa(b,e)|0)<<3)|0;c=c+ +p[j>>3];b=b+1|0}while((b|0)<(f|0))}else c=0.0;p[a>>3]=c;a=a+8|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;break}default:{J1(j,m,0);k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=j;g7(a,h);e=j+36|0;b=k[e>>2]|0;if(b|0?(h=b+12|0,a=k[h>>2]|0,k[h>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[j+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;a=j+16|0;d=j+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[d>>2]|0)>0){e=k[j+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[j+44>>2]|0;if(!((b|0)==(j+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}}e=m+36|0;b=k[e>>2]|0;if(b|0?(j=b+12|0,a=k[j>>2]|0,k[j>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[m+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;a=m+16|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[l>>2]|0)>0){d=k[m+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[m+44>>2]|0;if((b|0)==(m+48|0)|(b|0)==0){r=n;return}ggb(k[b+-4>>2]|0);r=n;return}function Mm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=r;r=r+48|0;g=d+32|0;f=d+16|0;e=d;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=a;a=f+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=c;F_(g,f,e);r=d;return}function Nm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+32|0;e=c+16|0;d=c;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=a;a=d+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[d>>2]=33619968;k[d+4>>2]=b;$1(e,d);r=c;return}function Om(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0;cb=r;r=r+1184|0;Qa=cb+256|0;Ra=cb+1168|0;bb=cb+1112|0;ab=cb+1056|0;$a=cb+1e3|0;_a=cb+944|0;s=cb+936|0;Za=cb+880|0;Ya=cb+824|0;Wa=cb+768|0;Ua=cb+712|0;Ta=cb+656|0;Sa=cb+600|0;w=cb+32|0;Ia=cb+480|0;Ja=cb+424|0;Ka=cb+368|0;La=cb+352|0;Ma=cb+336|0;Na=cb+328|0;Oa=cb;Pa=cb+312|0;t=cb+584|0;l=cb+568|0;n=cb+552|0;q=cb+536|0;u=t+4|0;j=t+4+4|0;k[j>>2]=0;k[j+4>>2]=0;k[t>>2]=33619968;k[u>>2]=b;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;j=l+4|0;k[j>>2]=c;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;m=n+4|0;k[m>>2]=d;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;o=q+4|0;k[o>>2]=e;k[bb>>2]=k[a>>2];h=bb+4|0;c=a+4|0;b=k[c>>2]|0;k[h>>2]=b;Xa=bb+8|0;k[Xa>>2]=k[a+8>>2];k[bb+12>>2]=k[a+12>>2];k[bb+16>>2]=k[a+16>>2];k[bb+20>>2]=k[a+20>>2];k[bb+24>>2]=k[a+24>>2];k[bb+28>>2]=k[a+28>>2];k[bb+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[bb+36>>2]=d;e=bb+40|0;k[e>>2]=Xa;Xa=bb+48|0;g=bb+44|0;k[g>>2]=Xa;k[bb+52>>2]=0;k[Xa>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[h>>2]=0;x1(bb,b,0,0,0);if((k[h>>2]|0)>0){f=k[a+40>>2]|0;e=k[e>>2]|0;d=k[a+44>>2]|0;c=k[g>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else{Va=k[a+44>>2]|0;Xa=k[g>>2]|0;k[Xa>>2]=k[Va>>2];k[Xa+4>>2]=k[Va+4>>2]}do if((k[l>>2]&2031616|0)==65536){e=k[j>>2]|0;k[ab>>2]=k[e>>2];a=ab+4|0;b=e+4|0;k[a>>2]=k[b>>2];Xa=ab+8|0;k[Xa>>2]=k[e+8>>2];k[ab+12>>2]=k[e+12>>2];k[ab+16>>2]=k[e+16>>2];k[ab+20>>2]=k[e+20>>2];k[ab+24>>2]=k[e+24>>2];k[ab+28>>2]=k[e+28>>2];k[ab+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[ab+36>>2]=c;d=ab+40|0;k[d>>2]=Xa;Xa=ab+48|0;g=ab+44|0;k[g>>2]=Xa;k[ab+52>>2]=0;k[Xa>>2]=0;if(c|0){Xa=c+12|0;k[Xa>>2]=(k[Xa>>2]|0)+1}if((k[b>>2]|0)<3){Va=k[e+44>>2]|0;Xa=k[g>>2]|0;k[Xa>>2]=k[Va>>2];k[Xa+4>>2]=k[Va+4>>2];break}k[a>>2]=0;x1(ab,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0))}}else Q1(ab,l,-1);while(0);do if((k[n>>2]&2031616|0)==65536){e=k[m>>2]|0;k[$a>>2]=k[e>>2];a=$a+4|0;b=e+4|0;k[a>>2]=k[b>>2];Xa=$a+8|0;k[Xa>>2]=k[e+8>>2];k[$a+12>>2]=k[e+12>>2];k[$a+16>>2]=k[e+16>>2];k[$a+20>>2]=k[e+20>>2];k[$a+24>>2]=k[e+24>>2];k[$a+28>>2]=k[e+28>>2];k[$a+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[$a+36>>2]=c;d=$a+40|0;k[d>>2]=Xa;Xa=$a+48|0;g=$a+44|0;k[g>>2]=Xa;k[$a+52>>2]=0;k[Xa>>2]=0;if(c|0){Xa=c+12|0;k[Xa>>2]=(k[Xa>>2]|0)+1}if((k[b>>2]|0)<3){Va=k[e+44>>2]|0;Xa=k[g>>2]|0;k[Xa>>2]=k[Va>>2];k[Xa+4>>2]=k[Va+4>>2];break}k[a>>2]=0;x1($a,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0))}}else Q1($a,n,-1);while(0);do if((k[q>>2]&2031616|0)==65536){e=k[o>>2]|0;k[_a>>2]=k[e>>2];a=_a+4|0;b=e+4|0;k[a>>2]=k[b>>2];Xa=_a+8|0;k[Xa>>2]=k[e+8>>2];k[_a+12>>2]=k[e+12>>2];k[_a+16>>2]=k[e+16>>2];k[_a+20>>2]=k[e+20>>2];k[_a+24>>2]=k[e+24>>2];k[_a+28>>2]=k[e+28>>2];k[_a+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[_a+36>>2]=c;d=_a+40|0;k[d>>2]=Xa;Xa=_a+48|0;g=_a+44|0;k[g>>2]=Xa;k[_a+52>>2]=0;k[Xa>>2]=0;if(c|0){Xa=c+12|0;k[Xa>>2]=(k[Xa>>2]|0)+1}if((k[b>>2]|0)<3){Va=k[e+44>>2]|0;Xa=k[g>>2]|0;k[Xa>>2]=k[Va>>2];k[Xa+4>>2]=k[Va+4>>2];break}k[a>>2]=0;x1(_a,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0))}}else Q1(_a,q,-1);while(0);Xa=bb+40|0;Ha=k[Xa>>2]|0;Va=k[Ha>>2]|0;k[s>>2]=k[Ha+4>>2];k[s+4>>2]=Va;x2(t,s,k[bb>>2]&4095,0);do if((k[t>>2]&2031616|0)==65536){e=k[u>>2]|0;k[Za>>2]=k[e>>2];a=Za+4|0;b=e+4|0;k[a>>2]=k[b>>2];Va=Za+8|0;k[Va>>2]=k[e+8>>2];k[Za+12>>2]=k[e+12>>2];j=Za+16|0;k[j>>2]=k[e+16>>2];k[Za+20>>2]=k[e+20>>2];k[Za+24>>2]=k[e+24>>2];k[Za+28>>2]=k[e+28>>2];k[Za+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[Za+36>>2]=c;d=Za+40|0;k[d>>2]=Va;Va=Za+48|0;g=Za+44|0;k[g>>2]=Va;k[Za+52>>2]=0;k[Va>>2]=0;if(c|0){Va=c+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[b>>2]|0)<3){Ha=k[e+44>>2]|0;Va=k[g>>2]|0;k[Va>>2]=k[Ha>>2];k[Va+4>>2]=k[Ha+4>>2];break}k[a>>2]=0;x1(Za,k[b>>2]|0,0,0,0);if((k[a>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[a>>2]|0))}}else{Q1(Za,t,-1);j=Za+16|0}while(0);Va=bb+16|0;if((k[j>>2]|0)==(k[Va>>2]|0)){k[Qa>>2]=0;b=Qa+4|0;k[b>>2]=0;c=ZT(28)|0;k[c>>2]=1;e=c+4|0;k[Qa>>2]=e;k[b>>2]=20;i[c+24>>0]=0;d=354988;f=e+20|0;do{i[e>>0]=i[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(f|0));Y8(-215,Qa,355009,354470,191);k[b>>2]=0;k[Qa>>2]=0;Ha=k[c>>2]|0;k[c>>2]=Ha+-1;if((Ha|0)==1)ggb(k[c+-4>>2]|0)}ma=bb+12|0;c=k[ma>>2]|0;oa=4096/(((c|0)<1?1:c)|0)|0;na=bb+8|0;Ea=k[na>>2]|0;oa=(oa|0)>1?oa:1;oa=(Ea|0)<(oa|0)?Ea:oa;k[Ya>>2]=1124007936;Ea=Ya+4|0;b=Ya+8|0;Ca=Ya+40|0;e=Ea;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[Ca>>2]=b;Fa=Ya+48|0;Da=Ya+44|0;k[Da>>2]=Fa;k[Ya+52>>2]=0;k[Fa>>2]=0;k[Qa>>2]=oa;g=Qa+4|0;k[g>>2]=c;G1(Ya,2,Qa,11);c=k[ma>>2]|0;k[Wa>>2]=1124007936;Aa=Wa+4|0;b=Wa+8|0;xa=Wa+40|0;e=Aa;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[xa>>2]=b;Ba=Wa+48|0;za=Wa+44|0;k[za>>2]=Ba;k[Wa+52>>2]=0;k[Ba>>2]=0;k[Qa>>2]=oa;k[g>>2]=c;G1(Wa,2,Qa,2);va=Ua+4|0;b=Ua+8|0;ta=Ua+40|0;e=va;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[ta>>2]=b;wa=Ua+48|0;ua=Ua+44|0;k[ua>>2]=wa;k[Ua+52>>2]=0;k[wa>>2]=0;k[Ua>>2]=1124007942;ra=Ta+4|0;b=Ta+8|0;pa=Ta+40|0;e=ra;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[pa>>2]=b;sa=Ta+48|0;qa=Ta+44|0;k[qa>>2]=sa;k[Ta+52>>2]=0;k[sa>>2]=0;k[Ta>>2]=1124007942;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=1124007936;b=w+16|0;c=w+48|0;e=w+12|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;b=w+56|0;k[w+52>>2]=b;k[w+60>>2]=0;k[b>>2]=0;k[w+64>>2]=1124007936;b=w+72|0;c=w+104|0;e=w+68|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;b=w+112|0;k[w+108>>2]=b;k[w+116>>2]=0;k[b>>2]=0;k[w+120>>2]=1124007936;b=w+128|0;c=w+160|0;e=w+124|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;e=w+168|0;k[w+164>>2]=e;f=e+56|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[Qa>>2]=3;k[Qa+4>>2]=3;j1(w,73,Qa,6);cva(Sa,w);XN(w);Ga=Qa+4|0;f=Ga+4|0;k[f>>2]=0;k[f+4>>2]=0;k[Qa>>2]=-2113863674;k[Ga>>2]=Ua;SW(ab,Qa,6,1.0,0.0);Ga=$a+16|0;f=(k[Ga>>2]|0)==0;Ha=$a+4|0;e=k[Ha>>2]|0;if(!f){if((e|0)<3)b=aa(k[$a+12>>2]|0,k[$a+8>>2]|0)|0;else{d=k[$a+40>>2]|0;c=0;b=1;do{b=aa(k[d+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(e|0))}if(b){Eoa(Qa,$a);KG($a,Qa)|0;d=Qa+36|0;b=k[d>>2]|0;if(b|0?(la=b+12|0,ya=k[la>>2]|0,k[la>>2]=ya+-1,(ya|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Qa+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;ya=Qa+16|0;c=Qa+4|0;k[ya>>2]=0;k[ya+4>>2]=0;k[ya+8>>2]=0;k[ya+12>>2]=0;if((k[c>>2]|0)>0){d=k[Qa+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[Qa+44>>2]|0;if(!((b|0)==(Qa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else x=68}else x=68;if((x|0)==68){if(!((((e|0)<3?(k[$a+8>>2]|0)==5:0)?(k[$a+12>>2]|0)==1:0)?!((k[$a>>2]&4095|0)!=6|f):0))x=72;if((x|0)==72){k[Qa>>2]=5;k[g>>2]=1;G1($a,2,Qa,6)};k[Qa>>2]=0;k[Qa+4>>2]=0;k[Qa+8>>2]=0;k[Qa+12>>2]=0;k[Qa+16>>2]=0;k[Qa+20>>2]=0;k[Qa+24>>2]=0;k[Qa+28>>2]=0;oY($a,Qa)}ya=_a+16|0;if(k[ya>>2]|0){d=k[_a+4>>2]|0;if((d|0)<3)b=aa(k[_a+12>>2]|0,k[_a+8>>2]|0)|0;else{e=k[_a+40>>2]|0;c=0;b=1;do{b=aa(k[e+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(d|0))}if(b){la=Qa+4|0;ka=la+4|0;k[ka>>2]=0;k[ka+4>>2]=0;k[Qa>>2]=-2113863674;k[la>>2]=Ta;SW(_a,Qa,6,1.0,0.0)}else x=81}else x=81;if((x|0)==81){la=Qa+4|0;ka=la+4|0;k[ka>>2]=0;k[ka+4>>2]=0;k[Qa>>2]=-2113863674;k[la>>2]=Ta;mY(Ua,Qa)}la=Ta+16|0;v=+p[(k[la>>2]|0)+(k[k[qa>>2]>>2]|0)+16>>3];b=k[na>>2]|0;if((b|0)>0){e=Qa+4|0;f=Ra+4|0;g=Qa+4|0;h=Ra+4|0;a=Qa+4|0;l=Ra+4|0;m=Qa+8|0;n=Qa+12|0;o=Qa+4|0;q=Ra+8|0;s=Ra+12|0;t=Ra+4|0;u=La+8|0;w=La+12|0;x=La+4|0;y=Ma+8|0;z=Ma+12|0;A=Ma+4|0;B=Na+4|0;C=Oa+4|0;D=C+4|0;E=Pa+4|0;F=E+4|0;G=Qa+8|0;H=Qa+12|0;I=Qa+4|0;J=Ra+4|0;K=J+4|0;L=La+8|0;M=La+12|0;N=La+4|0;O=Ma+8|0;P=Ma+12|0;Q=Ma+4|0;R=Ka+36|0;S=Ka+16|0;T=Ka+4|0;U=Ka+40|0;V=Ka+44|0;W=Ka+48|0;X=Ja+36|0;Y=Ja+16|0;Z=Ja+4|0;_=Ja+40|0;$=Ja+44|0;ba=Ja+48|0;ca=Ia+36|0;da=Ia+16|0;ea=Ia+4|0;fa=Ia+40|0;ga=Ia+44|0;ha=Ia+48|0;ia=Ia+32|0;ja=Ja+32|0;ka=Ka+32|0;d=0;do{b=b-d|0;b=(b|0)<(oa|0)?b:oa;p[(k[la>>2]|0)+(k[k[qa>>2]>>2]|0)+16>>3]=v-+(d|0);k[Qa>>2]=0;k[e>>2]=b;k[Ra>>2]=-2147483648;k[f>>2]=2147483647;H1(Ia,Ya,Qa,Ra);k[Qa>>2]=0;k[g>>2]=b;k[Ra>>2]=-2147483648;k[h>>2]=2147483647;H1(Ja,Wa,Qa,Ra);k[Qa>>2]=d;k[a>>2]=b+d;k[Ra>>2]=-2147483648;k[l>>2]=2147483647;H1(Ka,Za,Qa,Ra);k[m>>2]=0;k[n>>2]=0;k[Qa>>2]=-2130640890;k[o>>2]=Ua;k[q>>2]=0;k[s>>2]=0;k[Ra>>2]=16842752;k[t>>2]=$a;k[u>>2]=0;k[w>>2]=0;k[La>>2]=-2130640890;k[x>>2]=Sa;k[y>>2]=0;k[z>>2]=0;k[Ma>>2]=-2130640890;k[A>>2]=Ta;k[Na>>2]=k[ma>>2];k[B>>2]=b;b=k[Ia>>2]&4095;c=D;k[c>>2]=0;k[c+4>>2]=0;k[Oa>>2]=33619968;k[C>>2]=Ia;c=F;k[c>>2]=0;k[c+4>>2]=0;k[Pa>>2]=33619968;k[E>>2]=Ja;bva(Qa,Ra,La,Ma,Na,b,Oa,Pa);k[G>>2]=0;k[H>>2]=0;k[Qa>>2]=16842752;k[I>>2]=bb;b=K;k[b>>2]=0;k[b+4>>2]=0;k[Ra>>2]=33619968;k[J>>2]=Ka;k[L>>2]=0;k[M>>2]=0;k[La>>2]=16842752;k[N>>2]=Ia;k[O>>2]=0;k[P>>2]=0;k[Ma>>2]=16842752;k[Q>>2]=Ja;k[Oa>>2]=0;k[Oa+4>>2]=0;k[Oa+8>>2]=0;k[Oa+12>>2]=0;k[Oa+16>>2]=0;k[Oa+20>>2]=0;k[Oa+24>>2]=0;k[Oa+28>>2]=0;Jna(Qa,Ra,La,Ma,1,0,Oa);b=k[R>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[R>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[ka>>2]|0;if(!b){b=B1()|0;c=k[R>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[R>>2]=0}k[R>>2]=0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[T>>2]|0)>0){c=k[U>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[T>>2]|0))}b=k[V>>2]|0;if(!((b|0)==(W|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[X>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[X>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ja>>2]|0;if(b|0)break;b=B1()|0;c=k[X>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[X>>2]=0}k[X>>2]=0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[Z>>2]|0)>0){c=k[_>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Z>>2]|0))}b=k[$>>2]|0;if(!((b|0)==(ba|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[ca>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[ca>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ia>>2]|0;if(b|0)break;b=B1()|0;c=k[ca>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[ca>>2]=0}while(0);k[ca>>2]=0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[ea>>2]|0)>0){c=k[fa>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ea>>2]|0))}b=k[ga>>2]|0;if(!((b|0)==(ha|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=d+oa|0;b=k[na>>2]|0}while((b|0)>(d|0))}d=Sa+36|0;b=k[d>>2]|0;if(b|0?(Qa=b+12|0,Ra=k[Qa>>2]|0,k[Qa>>2]=Ra+-1,(Ra|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Sa+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;Ra=Sa+16|0;c=Sa+4|0;k[Ra>>2]=0;k[Ra+4>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;if((k[c>>2]|0)>0){d=k[Sa+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[Sa+44>>2]|0;if(!((b|0)==(Sa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=Ta+36|0;b=k[d>>2]|0;if(b|0?(Ra=b+12|0,Sa=k[Ra>>2]|0,k[Ra>>2]=Sa+-1,(Sa|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Ta+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[ra>>2]|0)>0){c=k[pa>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ra>>2]|0))}b=k[qa>>2]|0;if(!((b|0)==(sa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=Ua+36|0;b=k[d>>2]|0;if(b|0?(Sa=b+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Ua+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;Ua=Ua+16|0;k[Ua>>2]=0;k[Ua+4>>2]=0;k[Ua+8>>2]=0;k[Ua+12>>2]=0;if((k[va>>2]|0)>0){c=k[ta>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[va>>2]|0))}b=k[ua>>2]|0;if(!((b|0)==(wa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=Wa+36|0;b=k[d>>2]|0;do if(b|0){Ta=b+12|0;Ua=k[Ta>>2]|0;k[Ta>>2]=Ua+-1;if((Ua|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Wa+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;Wa=Wa+16|0;k[Wa>>2]=0;k[Wa+4>>2]=0;k[Wa+8>>2]=0;k[Wa+12>>2]=0;if((k[Aa>>2]|0)>0){c=k[xa>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Aa>>2]|0))}b=k[za>>2]|0;if(!((b|0)==(Ba|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=Ya+36|0;b=k[d>>2]|0;do if(b|0){Ua=b+12|0;Wa=k[Ua>>2]|0;k[Ua>>2]=Wa+-1;if((Wa|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Ya+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;Ya=Ya+16|0;k[Ya>>2]=0;k[Ya+4>>2]=0;k[Ya+8>>2]=0;k[Ya+12>>2]=0;if((k[Ea>>2]|0)>0){c=k[Ca>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ea>>2]|0))}b=k[Da>>2]|0;if(!((b|0)==(Fa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=Za+36|0;b=k[d>>2]|0;do if(b|0){Wa=b+12|0;Ya=k[Wa>>2]|0;k[Wa>>2]=Ya+-1;if((Ya|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Za+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=Za+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[d>>2]|0)>0){c=k[Za+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[Za+44>>2]|0;if(!((b|0)==(Za+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=_a+36|0;b=k[d>>2]|0;do if(b|0){Ya=b+12|0;Za=k[Ya>>2]|0;k[Ya>>2]=Za+-1;if((Za|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[_a+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=_a+4|0;k[ya>>2]=0;k[ya+4>>2]=0;k[ya+8>>2]=0;k[ya+12>>2]=0;if((k[d>>2]|0)>0){c=k[_a+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[_a+44>>2]|0;if(!((b|0)==(_a+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=$a+36|0;b=k[d>>2]|0;do if(b|0){Za=b+12|0;_a=k[Za>>2]|0;k[Za>>2]=_a+-1;if((_a|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[$a+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;k[Ga>>2]=0;k[Ga+4>>2]=0;k[Ga+8>>2]=0;k[Ga+12>>2]=0;if((k[Ha>>2]|0)>0){c=k[$a+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ha>>2]|0))}b=k[$a+44>>2]|0;if(!((b|0)==($a+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=ab+36|0;b=k[d>>2]|0;do if(b|0){_a=b+12|0;$a=k[_a>>2]|0;k[_a>>2]=$a+-1;if(($a|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ab+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;$a=ab+16|0;c=ab+4|0;k[$a>>2]=0;k[$a+4>>2]=0;k[$a+8>>2]=0;k[$a+12>>2]=0;if((k[c>>2]|0)>0){d=k[ab+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[ab+44>>2]|0;if(!((b|0)==(ab+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=bb+36|0;b=k[d>>2]|0;do if(b|0){$a=b+12|0;ab=k[$a>>2]|0;k[$a>>2]=ab+-1;if((ab|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[bb+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=bb+4|0;k[Va>>2]=0;k[Va+4>>2]=0;k[Va+8>>2]=0;k[Va+12>>2]=0;if((k[d>>2]|0)>0){c=k[Xa>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[bb+44>>2]|0;if((b|0)==(bb+48|0)|(b|0)==0){r=cb;return}ggb(k[b+-4>>2]|0);r=cb;return}function Pm(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0;g=r;r=r+96|0;n=g+80|0;m=g+64|0;l=g+48|0;j=g+32|0;i=g+16|0;h=g;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=a;a=m+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[m>>2]=33619968;k[m+4>>2]=b;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=c;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=d;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=e;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=f;dva(n,m,l,j,i,h);r=g;return}function Qm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+32|0;e=c+16|0;d=c;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=17104896;k[e+4>>2]=a;a=d+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[d>>2]=33619968;k[d+4>>2]=b;Q2(e,d);r=c;return}function Rm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+64|0;m=h+40|0;l=h+24|0;j=h+8|0;i=h;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;a=l+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[l>>2]=33619968;k[l+4>>2]=b;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=c;k[i>>2]=k[d>>2];k[i+4>>2]=k[d+4>>2];hoa(m,l,j,i,e,f,g);r=h;return}function Sm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+64|0;m=h+40|0;l=h+24|0;j=h+8|0;i=h;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=a;a=l+4+4|0;k[a>>2]=0;k[a+4>>2]=0;k[l>>2]=33619968;k[l+4>>2]=b;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=c;k[i>>2]=k[d>>2];k[i+4>>2]=k[d+4>>2];loa(m,l,j,i,e,f,g);r=h;return}function Tm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=r;r=r+4256|0;O=P+4200|0;N=P+4144|0;J=P+4128|0;K=P+2080|0;L=P+24|0;n=P+16|0;j=P;m=j+4|0;h=j+4+4|0;k[h>>2]=0;k[h+4>>2]=0;k[j>>2]=50397184;k[m>>2]=b;k[O>>2]=k[a>>2];h=O+4|0;c=a+4|0;b=k[c>>2]|0;k[h>>2]=b;I=O+8|0;k[I>>2]=k[a+8>>2];k[O+12>>2]=k[a+12>>2];k[O+16>>2]=k[a+16>>2];k[O+20>>2]=k[a+20>>2];k[O+24>>2]=k[a+24>>2];k[O+28>>2]=k[a+28>>2];k[O+32>>2]=k[a+32>>2];d=k[a+36>>2]|0;k[O+36>>2]=d;e=O+40|0;k[e>>2]=I;I=O+48|0;g=O+44|0;k[g>>2]=I;k[O+52>>2]=0;k[I>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[h>>2]=0;x1(O,b,0,0,0);if((k[h>>2]|0)>0){f=k[a+40>>2]|0;e=k[e>>2]|0;d=k[a+44>>2]|0;c=k[g>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else{H=k[a+44>>2]|0;I=k[g>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2]}do if((k[j>>2]&2031616|0)==65536){f=k[m>>2]|0;k[N>>2]=k[f>>2];h=N+4|0;c=f+4|0;k[h>>2]=k[c>>2];I=N+8|0;k[I>>2]=k[f+8>>2];k[N+12>>2]=k[f+12>>2];k[N+16>>2]=k[f+16>>2];k[N+20>>2]=k[f+20>>2];k[N+24>>2]=k[f+24>>2];k[N+28>>2]=k[f+28>>2];k[N+32>>2]=k[f+32>>2];b=k[f+36>>2]|0;k[N+36>>2]=b;d=N+40|0;k[d>>2]=I;I=N+48|0;a=N+44|0;k[a>>2]=I;k[N+52>>2]=0;k[I>>2]=0;if(b|0){I=b+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[c>>2]|0)<3){H=k[f+44>>2]|0;I=k[a>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2];break}k[h>>2]=0;x1(N,k[c>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[f+40>>2]|0;e=k[d>>2]|0;d=k[f+44>>2]|0;c=k[a>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[g+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else Q1(N,j,-1);while(0);I=O+40|0;a=k[I>>2]|0;g=k[a+4>>2]|0;a=k[a>>2]|0;k[J>>2]=0;B=J+4|0;k[B>>2]=0;k[J+8>>2]=0;zpb(K|0,0,2048)|0;if((k[O>>2]&4095|0)==16?(k[N>>2]&4095|0)==4:0){b=g;c=a}else{k[n>>2]=0;b=n+4|0;k[b>>2]=0;c=ZT(52)|0;k[c>>2]=1;d=c+4|0;k[n>>2]=d;k[b>>2]=47;i[c+51>>0]=0;e=347961;f=d+47|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,n,348009,348019,159);k[b>>2]=0;k[n>>2]=0;H=k[c>>2]|0;k[c>>2]=H+-1;if((H|0)==1)ggb(k[c+-4>>2]|0);c=k[I>>2]|0;b=k[c+4>>2]|0;c=k[c>>2]|0}E=N+40|0;H=k[E>>2]|0;if(!((c|0)==(k[H>>2]|0)?(b|0)==(k[H+4>>2]|0):0)){k[n>>2]=0;b=n+4|0;k[b>>2]=0;c=ZT(32)|0;k[c>>2]=1;d=c+4|0;k[n>>2]=d;k[b>>2]=24;i[c+28>>0]=0;e=348093;f=d+24|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,n,348009,348019,160);k[b>>2]=0;k[n>>2]=0;H=k[c>>2]|0;k[c>>2]=H+-1;if((H|0)==1)ggb(k[c+-4>>2]|0)}F=O+16|0;e=k[F>>2]|0;H=O+48|0;z=k[H>>2]|0;A=N+16|0;d=k[A>>2]|0;D=N+48|0;c=k[D>>2]|0;zpb(L|0,0,1024)|0;C=N+44|0;b=256;do{k[L+(b<<2)>>2]=b+-256;b=b+1|0}while((b|0)!=513);G=O+44|0;y=c>>>2;x=a+-1|0;if((g|0)>0){c=aa(y,x)|0;b=0;do{k[d+(b+c<<2)>>2]=-1;k[d+(b<<2)>>2]=-1;b=b+1|0}while((b|0)!=(g|0))}if((x|0)>1){t=g+-1|0;u=(t|0)>1;v=0-y|0;w=0-z|0;c=0;s=1;do{e=e+z|0;d=d+(y<<2)|0;k[d+(t<<2)>>2]=-1;k[d>>2]=-1;if(u){p=aa(s,y)|0;q=aa(s,z)|0;o=1;do{n=d+(o<<2)|0;b=k[n>>2]|0;if((b|0)>=0){if(!b)M=39}else{k[n>>2]=0;M=39}do if((M|0)==39){M=0;if((k[n+-4>>2]|0)>0){m=o*3|0;a=e+m|0;j=(l[a>>0]|0)-(l[a+-3>>0]|0)|0;b=(l[a+1>>0]|0)-(l[a+-2>>0]|0)|0;b=(b|0)>-1?b:0-b|0;f=(l[a+2>>0]|0)-(l[a+-1>>0]|0)|0;f=(f|0)>-1?f:0-f|0;f=f+(k[L+((k[L+(((j|0)>-1?j:0-j|0)+256-b<<2)>>2]|0)+256+b-f<<2)>>2]|0)|0;b=k[n+4>>2]|0}else{b=k[n+4>>2]|0;if(((b|0)<=0?(k[n+(v<<2)>>2]|0)<=0:0)?(k[n+(y<<2)>>2]|0)<=0:0)break;m=o*3|0;f=256;a=e+m|0}if((b|0)>0){h=(l[a>>0]|0)-(l[a+3>>0]|0)|0;j=(l[a+1>>0]|0)-(l[a+4>>0]|0)|0;j=(j|0)>-1?j:0-j|0;b=(l[a+2>>0]|0)-(l[a+5>>0]|0)|0;b=(b|0)>-1?b:0-b|0;b=f-(k[L+(f+256-(k[L+((k[L+(((h|0)>-1?h:0-h|0)+256-j<<2)>>2]|0)+256+j-b<<2)>>2]|0)-b<<2)>>2]|0)|0}else b=f;if((k[n+(v<<2)>>2]|0)>0){j=a+w|0;g=(l[a>>0]|0)-(l[j>>0]|0)|0;h=(l[a+1>>0]|0)-(l[j+1>>0]|0)|0;h=(h|0)>-1?h:0-h|0;j=(l[a+2>>0]|0)-(l[j+2>>0]|0)|0;j=(j|0)>-1?j:0-j|0;b=b-(k[L+(b+256-(k[L+((k[L+(((g|0)>-1?g:0-g|0)+256-h<<2)>>2]|0)+256+h-j<<2)>>2]|0)-j<<2)>>2]|0)|0}if((k[n+(y<<2)>>2]|0)>0){j=a+z|0;g=(l[a>>0]|0)-(l[j>>0]|0)|0;h=(l[a+1>>0]|0)-(l[j+1>>0]|0)|0;h=(h|0)>-1?h:0-h|0;j=(l[a+2>>0]|0)-(l[j+2>>0]|0)|0;j=(j|0)>-1?j:0-j|0;b=b-(k[L+(b+256-(k[L+((k[L+(((g|0)>-1?g:0-g|0)+256-h<<2)>>2]|0)+256+h-j<<2)>>2]|0)-j<<2)>>2]|0)|0}if(!c){f=k[B>>2]|0;g=k[J>>2]|0;h=f-g|0;c=(h|0)/12|0;j=c*3|0;j=(j|0)>257?(j|0)/2|0:128;do if(j>>>0>c>>>0){Xra(J,j-c|0);g=k[J>>2]|0}else{if(j>>>0>=c>>>0)break;a=g+(j*12|0)|0;if((f|0)==(a|0))break;k[B>>2]=f+(~(((f+-12-a|0)>>>0)/12|0)*12|0)}while(0);if(!h){k[g>>2]=0;c=1}a=j+-1|0;if((c|0)<(a|0)){f=c;do{j=f;f=f+1|0;k[g+(j*12|0)>>2]=f}while((f|0)!=(a|0))}k[g+(a*12|0)>>2]=0}else g=k[J>>2]|0;f=g+(c*12|0)|0;h=k[f>>2]|0;k[f>>2]=0;k[g+(c*12|0)+4>>2]=o+p;k[g+(c*12|0)+8>>2]=m+q;f=K+(b<<3)+4|0;a=k[f>>2]|0;if(!a)k[K+(b<<3)>>2]=c;else k[g+(a*12|0)>>2]=c;k[f>>2]=c;k[n>>2]=-2;c=h}while(0);o=o+1|0}while((o|0)<(t|0))}s=s+1|0}while((s|0)<(x|0))}else c=0;b=0;while(1){if(k[K+(b<<3)>>2]|0){M=72;break}b=b+1|0;if((b|0)>=256){M=71;break}}if((M|0)==71?(b|0)!=256:0)M=72;a:do if((M|0)==72){u=k[F>>2]|0;v=k[A>>2]|0;w=0-y|0;x=0-z|0;b:while(1){d=k[K+(b<<3)>>2]|0;c:do if(!d){while(1){d=b+1|0;if((d|0)>=256)break;e=k[K+(d<<3)>>2]|0;if(!e)b=d;else{b=d;d=e;break c}}if((d|0)==256)break a;b=d;d=k[K+(d<<3)>>2]|0}while(0);f=k[J>>2]|0;e=f+(d*12|0)|0;t=k[e>>2]|0;k[K+(b<<3)>>2]=t;g=f;if(!t)k[K+(b<<3)+4>>2]=0;k[e>>2]=c;s=k[f+(d*12|0)+4>>2]|0;t=k[f+(d*12|0)+8>>2]|0;a=v+(s<<2)|0;p=u+t|0;m=a+-4|0;h=k[m>>2]|0;c=(h|0)>0?h:0;n=a+4|0;j=k[n>>2]|0;if((j|0)>0)if(!c)c=j;else c=(j|0)==(c|0)?c:-1;o=a+(w<<2)|0;e=k[o>>2]|0;if((e|0)>0)if(!c)c=e;else c=(e|0)==(c|0)?c:-1;q=a+(y<<2)|0;e=k[q>>2]|0;do if((e|0)>0){if(!c){k[a>>2]=e;break}if((e|0)!=(c|0)){k[a>>2]=-1;c=d;continue b}else M=91}else M=91;while(0);if((M|0)==91?(M=0,k[a>>2]=c,(c|0)==-1):0){c=d;continue}if(!h){h=p+-3|0;a=(l[p>>0]|0)-(l[h>>0]|0)|0;j=(l[p+1>>0]|0)-(l[h+1>>0]|0)|0;j=(j|0)>-1?j:0-j|0;h=(l[p+2>>0]|0)-(l[h+2>>0]|0)|0;h=(h|0)>-1?h:0-h|0;h=h+(k[L+((k[L+(((a|0)>-1?a:0-a|0)+256-j<<2)>>2]|0)+256+j-h<<2)>>2]|0)|0;if(!d){c=k[B>>2]|0;a=c-g|0;d=(a|0)/12|0;g=d*3|0;g=(g|0)>257?(g|0)/2|0:128;do if(g>>>0>d>>>0){Xra(J,g-d|0);f=k[J>>2]|0}else{if(g>>>0>=d>>>0)break;e=f+(g*12|0)|0;if((c|0)==(e|0))break;k[B>>2]=c+(~(((c+-12-e|0)>>>0)/12|0)*12|0)}while(0);if(!a){k[f>>2]=0;d=1}a=f;e=g+-1|0;if((d|0)<(e|0)){c=d;do{j=c;c=c+1|0;k[f+(j*12|0)>>2]=c}while((c|0)!=(e|0))}k[f+(e*12|0)>>2]=0;g=a}e=f+(d*12|0)|0;c=k[e>>2]|0;k[e>>2]=0;k[f+(d*12|0)+4>>2]=s+-1;k[f+(d*12|0)+8>>2]=t+-3;e=K+(h<<3)+4|0;a=k[e>>2]|0;if(!a)k[K+(h<<3)>>2]=d;else k[f+(a*12|0)>>2]=d;k[e>>2]=d;b=b-(k[L+(b+256-h<<2)>>2]|0)|0;k[m>>2]=-2;e=k[n>>2]|0;d=g}else{c=d;e=j;d=g}if(!e){h=p+3|0;j=(l[p>>0]|0)-(l[h>>0]|0)|0;m=(l[p+1>>0]|0)-(l[h+1>>0]|0)|0;m=(m|0)>-1?m:0-m|0;h=(l[p+2>>0]|0)-(l[h+2>>0]|0)|0;h=(h|0)>-1?h:0-h|0;h=h+(k[L+((k[L+(((j|0)>-1?j:0-j|0)+256-m<<2)>>2]|0)+256+m-h<<2)>>2]|0)|0;if(!c){e=k[B>>2]|0;a=e-d|0;c=(a|0)/12|0;g=c*3|0;g=(g|0)>257?(g|0)/2|0:128;do if(g>>>0>c>>>0){Xra(J,g-c|0);f=k[J>>2]|0}else{if(g>>>0>=c>>>0)break;d=d+(g*12|0)|0;if((e|0)==(d|0))break;k[B>>2]=e+(~(((e+-12-d|0)>>>0)/12|0)*12|0)}while(0);if(!a){k[f>>2]=0;c=1}d=f;a=g+-1|0;if((c|0)<(a|0)){e=c;do{m=e;e=e+1|0;k[f+(m*12|0)>>2]=e}while((e|0)!=(a|0))}k[f+(a*12|0)>>2]=0}e=f+(c*12|0)|0;g=k[e>>2]|0;k[e>>2]=0;k[f+(c*12|0)+4>>2]=s+1;k[f+(c*12|0)+8>>2]=t+3;e=K+(h<<3)+4|0;a=k[e>>2]|0;if(!a)k[K+(h<<3)>>2]=c;else k[f+(a*12|0)>>2]=c;k[e>>2]=c;b=b-(k[L+(b+256-h<<2)>>2]|0)|0;k[n>>2]=-2;c=g}if(!(k[o>>2]|0)){h=p+x|0;m=(l[p>>0]|0)-(l[h>>0]|0)|0;n=(l[p+1>>0]|0)-(l[h+1>>0]|0)|0;n=(n|0)>-1?n:0-n|0;h=(l[p+2>>0]|0)-(l[h+2>>0]|0)|0;h=(h|0)>-1?h:0-h|0;h=h+(k[L+((k[L+(((m|0)>-1?m:0-m|0)+256-n<<2)>>2]|0)+256+n-h<<2)>>2]|0)|0;if(!c){e=k[B>>2]|0;a=e-d|0;c=(a|0)/12|0;g=c*3|0;g=(g|0)>257?(g|0)/2|0:128;do if(g>>>0>c>>>0){Xra(J,g-c|0);f=k[J>>2]|0}else{if(g>>>0>=c>>>0)break;d=d+(g*12|0)|0;if((e|0)==(d|0))break;k[B>>2]=e+(~(((e+-12-d|0)>>>0)/12|0)*12|0)}while(0);if(!a){k[f>>2]=0;c=1}d=f;a=g+-1|0;if((c|0)<(a|0)){e=c;do{n=e;e=e+1|0;k[f+(n*12|0)>>2]=e}while((e|0)!=(a|0))}k[f+(a*12|0)>>2]=0}a=f+(c*12|0)|0;e=k[a>>2]|0;k[a>>2]=0;k[f+(c*12|0)+4>>2]=s-y;k[f+(c*12|0)+8>>2]=t-z;a=K+(h<<3)+4|0;g=k[a>>2]|0;if(!g)k[K+(h<<3)>>2]=c;else k[f+(g*12|0)>>2]=c;k[a>>2]=c;b=b-(k[L+(b+256-h<<2)>>2]|0)|0;k[o>>2]=-2;c=e}if(k[q>>2]|0)continue;h=p+z|0;n=(l[p>>0]|0)-(l[h>>0]|0)|0;o=(l[p+1>>0]|0)-(l[h+1>>0]|0)|0;o=(o|0)>-1?o:0-o|0;h=(l[p+2>>0]|0)-(l[h+2>>0]|0)|0;h=(h|0)>-1?h:0-h|0;h=h+(k[L+((k[L+(((n|0)>-1?n:0-n|0)+256-o<<2)>>2]|0)+256+o-h<<2)>>2]|0)|0;if(!c){e=k[B>>2]|0;a=e-d|0;c=(a|0)/12|0;g=c*3|0;g=(g|0)>257?(g|0)/2|0:128;do if(g>>>0>c>>>0){Xra(J,g-c|0);f=k[J>>2]|0}else{if(g>>>0>=c>>>0)break;d=d+(g*12|0)|0;if((e|0)==(d|0))break;k[B>>2]=e+(~(((e+-12-d|0)>>>0)/12|0)*12|0)}while(0);if(!a){k[f>>2]=0;c=1}e=g+-1|0;if((c|0)<(e|0)){d=c;do{p=d;d=d+1|0;k[f+(p*12|0)>>2]=d}while((d|0)!=(e|0))}k[f+(e*12|0)>>2]=0}d=f+(c*12|0)|0;a=k[d>>2]|0;k[d>>2]=0;k[f+(c*12|0)+4>>2]=s+y;k[f+(c*12|0)+8>>2]=t+z;d=K+(h<<3)+4|0;e=k[d>>2]|0;if(!e)k[K+(h<<3)>>2]=c;else k[f+(e*12|0)>>2]=c;k[d>>2]=c;b=b-(k[L+(b+256-h<<2)>>2]|0)|0;k[q>>2]=-2;c=a}}while(0);b=k[J>>2]|0;c=b;if(b|0){d=k[B>>2]|0;if((d|0)!=(b|0))k[B>>2]=d+(~(((d+-12-c|0)>>>0)/12|0)*12|0);ggb(b)}d=N+36|0;b=k[d>>2]|0;if(b|0?(L=b+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[N+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=N+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[d>>2]|0)>0){c=k[E>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[C>>2]|0;if(!((b|0)==(D|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=O+36|0;b=k[d>>2]|0;if(b|0?(M=b+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[O+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=O+4|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[d>>2]|0)>0){c=k[I>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[G>>2]|0;if((b|0)==(H|0)|(b|0)==0){r=P;return}ggb(k[b+-4>>2]|0);r=P;return}function Um(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+16|0;n=p;o=p+8|0;b=(n9(c9()|0)|0)+12|0;b=k[b>>2]|0;if(!b){r=p;return}if(!(k[b+4>>2]|0)){r=p;return}if(!(i[1012368]|0)){f=Ce(220885)|0;if(f){e=f;a:do if(!(e&3)){b=f;d=9}else{b=f;c=e;while(1){if(!(i[b>>0]|0)){b=c;break a}b=b+1|0;c=b;if(!(c&3)){d=9;break}}}while(0);if((d|0)==9){while(1){c=k[b>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))b=b+4|0;else break}if((c&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}g=b-e|0;h=ZT(g+8&-4)|0;k[h>>2]=1;j=h+4|0;i[j+g>>0]=0;upb(j|0,f|0,g|0)|0;do if((j|0)!=221005){g=i[j>>0]|0;if(g<<24>>24==49){d=221005;e=j;do{e=e+1|0;d=d+1|0;b=i[e>>0]|0;c=i[d>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=c<<24>>24))}else{c=49;b=g}if(!((j|0)==221007?1:b<<24>>24==c<<24>>24)){f=g<<24>>24==84;if(f){d=221007;e=j;do{e=e+1|0;d=d+1|0;b=i[e>>0]|0;c=i[d>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=c<<24>>24))}else{c=84;b=g}if(!((j|0)==426487?1:b<<24>>24==c<<24>>24)){if(g<<24>>24==116){d=426487;e=j;do{e=e+1|0;d=d+1|0;b=i[e>>0]|0;c=i[d>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=c<<24>>24))}else{c=116;b=g}if(!((j|0)==221012?1:b<<24>>24==c<<24>>24)){if(f){b=221012;c=j;do{c=c+1|0;b=b+1|0;d=i[c>>0]|0;e=i[b>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=e<<24>>24));if(d<<24>>24==e<<24>>24){a=1;break}}if((j|0)!=228423){if(g<<24>>24==48){d=228423;e=j;do{e=e+1|0;d=d+1|0;b=i[e>>0]|0;c=i[d>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=c<<24>>24))}else{c=48;b=g}if(!((j|0)==228425?1:b<<24>>24==c<<24>>24)){f=g<<24>>24==70;if(f){d=228425;e=j;do{e=e+1|0;d=d+1|0;b=i[e>>0]|0;c=i[d>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=c<<24>>24))}else{c=70;b=g}if((j|0)==426481?1:b<<24>>24==c<<24>>24){a=0;break}if(g<<24>>24==102){c=426481;d=j;do{d=d+1|0;c=c+1|0;b=i[d>>0]|0;e=i[c>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=e<<24>>24));c=e}else{c=102;b=g}if((j|0)==228431?1:b<<24>>24==c<<24>>24){a=0;break}if(f){l=228431;m=j}else{k[n>>2]=220885;g=n+4|0;k[g>>2]=j;$8(o,221017,n);Y8(-5,o,221052,220943,89)}do{m=m+1|0;l=l+1|0;b=i[m>>0]|0;c=i[l>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=c<<24>>24));if(b<<24>>24==c<<24>>24){a=0;break}k[n>>2]=220885;m=n+4|0;k[m>>2]=j;$8(o,221017,n);Y8(-5,o,221052,220943,89)}else a=0}else a=0}else a=1}else a=1}else a=1}else a=1;while(0);n=k[h>>2]|0;k[h>>2]=n+-1;if((n|0)==1)ggb(k[h+-4>>2]|0)}else a=0;a=a&1;i[1012369]=a;i[1012368]=1}else a=i[1012369]|0;if(!(a<<24>>24)){r=p;return}a=o+4|0;b=ZT(32)|0;k[b>>2]=1;c=b+4|0;k[o>>2]=c;k[a>>2]=24;i[b+28>>0]=0;d=220911;e=c+24|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,o,220936,220943,3117);k[a>>2]=0;k[o>>2]=0;o=k[b>>2]|0;k[b>>2]=o+-1;if((o|0)==1)ggb(k[b+-4>>2]|0);r=p;return}function Vm(){return 0}function Wm(){return 0}function Xm(){return 0}function Ym(a){a=a|0;return}function Zm(){var a=0,b=0;a=(n9(c9()|0)|0)+16|0;b=k[a>>2]|0;if((b|0)>=0){b=(b|0)>0;return b|0}k[a>>2]=0;b=0;b=(b|0)>0;return b|0}function _m(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function $m(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function an(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+60>>2]&255](a,b);return}function bn(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function cn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function dn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0;f=r;r=r+64|0;j=f+48|0;i=f+32|0;h=f+16|0;g=f;l=k[(k[a>>2]|0)+32>>2]|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=17104896;k[j+4>>2]=b;b=i+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=c;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=d;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=e;eh[l&255](a,j,i,h,g);r=f;return}function en(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[k[a>>2]&255](b,c,d,e,f);return}function fn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=r;r=r+32|0;f=d+16|0;e=d;g=k[(k[a>>2]|0)+36>>2]|0;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=17104896;k[f+4>>2]=b;b=e+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=c;Ph[g&511](a,f,e);r=d;return}function gn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[k[a>>2]&511](b,c,d);return}function hn(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+52>>2]&255](a,b);return}function jn(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;var e=0,f=0,g=0,h=0;while(1){e=fgb(24)|0;if(e|0){h=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){h=0;break}Qh[e&7]()}k[h>>2]=151128;e=h+4|0;k[e>>2]=0;g=h+8|0;k[g>>2]=0;f=ZT(20)|0;k[f>>2]=1;k[e>>2]=f+4;k[g>>2]=12;i[f+16>>0]=0;e=k[e>>2]|0;f=399235;g=e+12|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));o[h+12>>2]=b;o[h+16>>2]=c;o[h+20>>2]=d;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}g=e+4|0;k[g>>2]=1;k[e>>2]=151200;k[e+8>>2]=h;k[a>>2]=e;k[a+4>>2]=h;k[g>>2]=(k[g>>2]|0)+1;a=k[g>>2]|0;k[g>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[e>>2]|0)+8>>2]&2047](e);return}function kn(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;var e=0,f=0,g=0;f=r;r=r+16|0;e=f;oh[a&3](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];g=e+4|0;k[a+4>>2]=k[g>>2];k[e>>2]=0;k[g>>2]=0;r=f;return a|0}function ln(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+44>>2]&255](a,b);return}function mn(a){a=a|0;return k[a+4>>2]|0}function nn(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function on(a){a=a|0;return 0}function pn(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function qn(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function rn(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function sn(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function tn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function un(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;while(1){e=fgb(192)|0;if(e|0){m=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){m=0;break}Qh[e&7]()}k[m>>2]=151860;g=m+4|0;h=m+8|0;k[m+16>>2]=1124007936;e=m+24|0;f=m+56|0;j=m+20|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[f>>2]=e;e=m+64|0;k[m+60>>2]=e;k[m+68>>2]=0;k[e>>2]=0;k[m+72>>2]=1124007936;e=m+80|0;f=m+112|0;j=m+76|0;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[f>>2]=e;j=m+120|0;k[m+116>>2]=j;k[m+124>>2]=0;k[j>>2]=0;j=m+184|0;l=m+188|0;k[g>>2]=0;k[h>>2]=0;k[m+12>>2]=0;k[m+128>>2]=0;k[m+132>>2]=(b|0)>0?b:500;p[m+144>>3]=c>0.0?c:16.0;i[m+176>>0]=d&1;k[m+136>>2]=5;o[m+152>>2]=.8999999761581421;o[m+160>>2]=15.0;o[m+168>>2]=75.0;o[m+164>>2]=4.0;o[m+156>>2]=9.0;o[m+172>>2]=.05000000074505806;i[m+177>>0]=127;o[m+180>>2]=.5;k[l>>2]=0;k[j>>2]=0;e=ZT(32)|0;k[e>>2]=1;k[j>>2]=e+4;k[l>>2]=25;i[e+29>>0]=0;j=k[j>>2]|0;e=401473;l=j+25|0;do{i[j>>0]=i[e>>0]|0;j=j+1|0;e=e+1|0}while((j|0)<(l|0));while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}d=e+4|0;k[d>>2]=1;k[e>>2]=152024;k[e+8>>2]=m;k[a>>2]=e;k[a+4>>2]=m;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[e>>2]|0)+8>>2]&2047](e);return}function vn(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0;f=r;r=r+16|0;e=f;nh[a&15](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];d=e+4|0;k[a+4>>2]=k[d>>2];k[e>>2]=0;k[d>>2]=0;r=f;return a|0}function wn(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+100>>2]&255](a,b);return}function xn(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function yn(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+60>>2]&255](a,b);return}function zn(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function An(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+52>>2]&1023](a,b);return}function Bn(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Cn(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+84>>2]&255](a,b);return}function Dn(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+116>>2]&1023](a,b);return}function En(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Fn(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+92>>2]&255](a,b);return}function Gn(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+44>>2]&1023](a,b);return}function Hn(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+68>>2]&255](a,b);return}function In(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+132>>2]&255](a,b);return}function Jn(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+76>>2]&255](a,b);return}function Kn(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+124>>2]&1023](a,b);return}function Ln(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+108>>2]&255](a,b);return}function Mn(a){a=a|0;return k[a+4>>2]|0}function Nn(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function On(a){a=a|0;return 0}function Pn(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function Qn(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Rn(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Sn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function Tn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;c=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](i,a);while(1){c=fgb(56)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[i>>2];a=i+4|0;k[c+4>>2]=k[a>>2];e=c+8|0;b=i+8|0;k[e>>2]=k[b>>2];k[c+12>>2]=k[i+12>>2];g=i+16|0;k[c+16>>2]=k[g>>2];k[c+20>>2]=k[i+20>>2];k[c+24>>2]=k[i+24>>2];k[c+28>>2]=k[i+28>>2];k[c+32>>2]=k[i+32>>2];h=i+36|0;k[c+36>>2]=k[h>>2];d=c+40|0;k[d>>2]=e;e=c+44|0;f=c+48|0;k[e>>2]=f;k[c+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return c|0}ggb(k[a+-4>>2]|0);r=j;return c|0}function Un(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+48>>2]&255](a,b);return}function Vn(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function Wn(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+40>>2]&1023](a,b);return}function Xn(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Yn(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0;while(1){d=fgb(132)|0;if(d|0){g=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){g=0;break}Qh[d&7]()}k[g>>2]=150092;e=g+4|0;k[e>>2]=0;f=g+8|0;k[f>>2]=0;d=ZT(24)|0;k[d>>2]=1;k[e>>2]=d+4;k[f>>2]=18;i[d+22>>0]=0;e=k[e>>2]|0;d=393825;f=e+18|0;do{i[e>>0]=i[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(f|0));k[g+12>>2]=b;o[g+16>>2]=c;Y2a(g+20|0);k[g+76>>2]=1124007936;d=g+84|0;b=g+116|0;e=g+80|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[b>>2]=d;f=g+124|0;k[g+120>>2]=f;k[g+128>>2]=0;k[f>>2]=0;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=d+4|0;k[f>>2]=1;k[d>>2]=150072;k[d+8>>2]=g;k[a>>2]=d;k[a+4>>2]=g;k[f>>2]=(k[f>>2]|0)+1;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);return}function Zn(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;e=r;r=r+16|0;d=e;Rh[a&63](d,b,c);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[d>>2];b=d+4|0;k[a+4>>2]=k[b>>2];k[d>>2]=0;k[b>>2]=0;r=e;return a|0}function _n(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function $n(a){a=a|0;return k[a+4>>2]|0}function ao(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function bo(a){a=a|0;return 0}function co(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function eo(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function fo(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function go(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;j=m+8|0;h=m;g=k[(k[a>>2]|0)+20>>2]|0;k[j>>2]=0;l=j+4|0;k[l>>2]=0;f=b+11|0;d=i[f>>0]|0;e=d<<24>>24<0;if((e?k[b+4>>2]|0:d&255)|0){e=e?k[b+4>>2]|0:d&255;d=ZT(e+8&-4)|0;k[d>>2]=1;d=d+4|0;k[j>>2]=d;k[l>>2]=e;i[d+e>>0]=0;upb(k[j>>2]|0,((i[f>>0]|0)<0?k[b>>2]|0:b)|0,e|0)|0}k[h>>2]=0;f=h+4|0;k[f>>2]=0;b=c+11|0;d=i[b>>0]|0;e=d<<24>>24<0;if((e?k[c+4>>2]|0:d&255)|0){e=e?k[c+4>>2]|0:d&255;d=ZT(e+8&-4)|0;k[d>>2]=1;d=d+4|0;k[h>>2]=d;k[f>>2]=e;i[d+e>>0]=0;upb(k[h>>2]|0,((i[b>>0]|0)<0?k[c>>2]|0:c)|0,e|0)|0}d=ci[g&255](a,j,h)|0;b=k[h>>2]|0;k[f>>2]=0;k[h>>2]=0;if(b|0?(g=b+-4|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[b+-8>>2]|0);b=k[j>>2]|0;k[l>>2]=0;k[j>>2]=0;if(!b){r=m;return d|0}j=b+-4|0;l=k[j>>2]|0;k[j>>2]=l+-1;if((l|0)!=1){r=m;return d|0}ggb(k[b+-8>>2]|0);r=m;return d|0}function ho(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+32|0;j=m+12|0;l=m;h=k[a>>2]|0;f=c+4|0;g=k[c>>2]|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;if(g>>>0>4294967279)hob();if(g>>>0<11){i[j+11>>0]=g;if(!g)a=j;else{a=j;e=10}}else{e=g+16&-16;c=(e|0)==0?1:e;while(1){a=fgb(c)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[j>>2]=a;k[j+8>>2]=e|-2147483648;k[j+4>>2]=g;e=10}if((e|0)==10)upb(a|0,f|0,g|0)|0;i[a+g>>0]=0;f=d+4|0;g=k[d>>2]|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;if(g>>>0>4294967279)hob();if(g>>>0<11){i[l+11>>0]=g;if(!g)a=l;else{a=l;e=20}}else{e=g+16&-16;c=(e|0)==0?1:e;while(1){a=fgb(c)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[l>>2]=a;k[l+8>>2]=e|-2147483648;k[l+4>>2]=g;e=20}if((e|0)==20)upb(a|0,f|0,g|0)|0;i[a+g>>0]=0;a=ci[h&255](b,j,l)|0;if((i[l+11>>0]|0)<0)ggb(k[l>>2]|0);if((i[j+11>>0]|0)>=0){r=m;return a|0}ggb(k[j>>2]|0);r=m;return a|0}function io(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0;i=r;r=r+16|0;l=i+8|0;j=i;m=k[(k[a>>2]|0)+36>>2]|0;k[l>>2]=k[f>>2];k[l+4>>2]=k[f+4>>2];k[j>>2]=k[g>>2];k[j+4>>2]=k[g+4>>2];Of[m&3](a,b,c,d,e,l,j,h);r=i;return}function jo(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0;j=r;r=r+16|0;m=j+8|0;l=j;a=k[a>>2]|0;k[m>>2]=k[g>>2];k[m+4>>2]=k[g+4>>2];k[l>>2]=k[h>>2];k[l+4>>2]=k[h+4>>2];Of[a&3](b,c,d,e,f,m,l,i);r=j;return}function ko(){var a=0,b=0;while(1){a=fgb(152)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=95608;k[a+4>>2]=64;k[a+8>>2]=128;k[a+12>>2]=16;k[a+16>>2]=16;k[a+20>>2]=8;k[a+24>>2]=8;k[a+28>>2]=8;k[a+32>>2]=8;k[a+36>>2]=9;k[a+40>>2]=1;p[a+48>>3]=-1.0;k[a+56>>2]=0;p[a+64>>3]=.2;i[a+72>>0]=1;k[a+76>>2]=0;k[a+80>>2]=0;k[a+84>>2]=0;k[a+88>>2]=1124007936;b=a+92|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;k[b+24>>2]=0;k[a+120>>2]=a+96;b=a+128|0;k[a+124>>2]=b;k[a+132>>2]=0;k[b>>2]=0;o[a+136>>2]=-1.0;k[a+140>>2]=64;i[a+144>>0]=0;return a|0}function lo(a){a=a|0;return Nh[a&127]()|0}function mo(a,b,c,d,e,f,g,h,j,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;var q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0;while(1){q=fgb(152)|0;if(q|0)break;q=k[207666]|0;k[207666]=q+0;if(!q){q=0;break}Qh[q&7]()}w=k[a>>2]|0;v=k[a+4>>2]|0;u=k[b>>2]|0;t=k[b+4>>2]|0;a=k[c>>2]|0;b=k[c+4>>2]|0;c=k[d>>2]|0;d=k[d+4>>2]|0;e=k[e>>2]|0;f=k[f>>2]|0;s=+p[g>>3];g=k[h>>2]|0;r=+p[j>>3];h=i[l>>0]&1;j=k[m>>2]|0;l=i[n>>0]&1;k[q>>2]=95608;k[q+4>>2]=w;k[q+8>>2]=v;k[q+12>>2]=u;k[q+16>>2]=t;k[q+20>>2]=a;k[q+24>>2]=b;k[q+28>>2]=c;k[q+32>>2]=d;k[q+36>>2]=e;k[q+40>>2]=f;p[q+48>>3]=s;k[q+56>>2]=g;p[q+64>>3]=r;i[q+72>>0]=h;k[q+76>>2]=0;k[q+80>>2]=0;k[q+84>>2]=0;k[q+88>>2]=1124007936;h=q+92|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[q+120>>2]=q+96;h=q+128|0;k[q+124>>2]=h;k[q+132>>2]=0;k[h>>2]=0;o[q+136>>2]=-1.0;k[q+140>>2]=j;i[q+144>>0]=l;return q|0}function no(a,b,c,d,e,f,g,h,j,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;j=j|0;l=+l;m=m|0;n=n|0;o=o|0;var q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;q=r;r=r+80|0;D=q+56|0;C=q+48|0;B=q+40|0;A=q+32|0;z=q+28|0;y=q+24|0;x=q+8|0;w=q+20|0;v=q;u=q+65|0;t=q+16|0;s=q+64|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2];k[C>>2]=k[c>>2];k[C+4>>2]=k[c+4>>2];k[B>>2]=k[d>>2];k[B+4>>2]=k[d+4>>2];k[A>>2]=k[e>>2];k[A+4>>2]=k[e+4>>2];k[z>>2]=f;k[y>>2]=g;p[x>>3]=h;k[w>>2]=j;p[v>>3]=l;i[u>>0]=m&1;k[t>>2]=n;i[s>>0]=o&1;j=ki[a&1](D,C,B,A,z,y,x,w,v,u,t,s)|0;r=q;return j|0}function oo(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;e=r;r=r+16|0;d=e;while(1){b=fgb(152)|0;if(b|0){c=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){c=0;break}Qh[b&7]()}k[c>>2]=95608;f=c+4|0;k[c+76>>2]=0;k[c+80>>2]=0;k[c+84>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[f+28>>2]=0;k[c+88>>2]=1124007936;f=c+92|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[c+120>>2]=c+96;f=c+128|0;k[c+124>>2]=f;k[c+132>>2]=0;k[f>>2]=0;k[d>>2]=0;f=d+4|0;k[f>>2]=0;PSa(c,a,d)|0;b=k[d>>2]|0;k[f>>2]=0;k[d>>2]=0;if(!b){r=e;return c|0}d=b+-4|0;f=k[d>>2]|0;k[d>>2]=f+-1;if((f|0)!=1){r=e;return c|0}ggb(k[b+-8>>2]|0);r=e;return c|0}function po(a,b){a=a|0;b=b|0;return Xh[a&1023](b)|0}function qo(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;e=a+4|0;k[e>>2]=0;f=a+8|0;k[f>>2]=0;k[a>>2]=k[b>>2];d=b+4|0;k[e>>2]=k[d>>2];e=b+8|0;k[f>>2]=k[e>>2];k[e>>2]=0;k[d>>2]=0;k[b>>2]=0;r=c;return a|0}function ro(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=r;r=r+16|0;i=g+8|0;h=g;j=k[(k[a>>2]|0)+52>>2]|0;k[i>>2]=k[e>>2];k[i+4>>2]=k[e+4>>2];k[h>>2]=k[f>>2];k[h+4>>2]=k[f+4>>2];Lg[j&255](a,b,c,d,i,h);r=g;return}function so(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=r;r=r+16|0;j=h+8|0;i=h;a=k[a>>2]|0;k[j>>2]=k[f>>2];k[j+4>>2]=k[f+4>>2];k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2];Lg[a&255](b,c,d,e,j,i);r=h;return}function to(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function uo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function vo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0;g=r;r=r+32|0;j=g+16|0;i=g+8|0;h=g;l=k[(k[a>>2]|0)+32>>2]|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=b;k[i>>2]=k[d>>2];k[i+4>>2]=k[d+4>>2];k[h>>2]=k[e>>2];k[h+4>>2]=k[e+4>>2];Lg[l&255](a,j,c,i,h,f);r=g;return}function wo(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=r;r=r+16|0;j=h+8|0;i=h;a=k[a>>2]|0;k[j>>2]=k[e>>2];k[j+4>>2]=k[e+4>>2];k[i>>2]=k[f>>2];k[i+4>>2]=k[f+4>>2];Lg[a&255](b,c,d,j,i,g);r=h;return}function xo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;j=m+8|0;h=m;g=k[(k[a>>2]|0)+24>>2]|0;k[j>>2]=0;l=j+4|0;k[l>>2]=0;f=b+11|0;d=i[f>>0]|0;e=d<<24>>24<0;if((e?k[b+4>>2]|0:d&255)|0){e=e?k[b+4>>2]|0:d&255;d=ZT(e+8&-4)|0;k[d>>2]=1;d=d+4|0;k[j>>2]=d;k[l>>2]=e;i[d+e>>0]=0;upb(k[j>>2]|0,((i[f>>0]|0)<0?k[b>>2]|0:b)|0,e|0)|0}k[h>>2]=0;f=h+4|0;k[f>>2]=0;b=c+11|0;d=i[b>>0]|0;e=d<<24>>24<0;if((e?k[c+4>>2]|0:d&255)|0){e=e?k[c+4>>2]|0:d&255;d=ZT(e+8&-4)|0;k[d>>2]=1;d=d+4|0;k[h>>2]=d;k[f>>2]=e;i[d+e>>0]=0;upb(k[h>>2]|0,((i[b>>0]|0)<0?k[c>>2]|0:c)|0,e|0)|0}Ph[g&511](a,j,h);b=k[h>>2]|0;k[f>>2]=0;k[h>>2]=0;if(b|0?(g=b+-4|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[b+-8>>2]|0);b=k[j>>2]|0;k[l>>2]=0;k[j>>2]=0;if(!b){r=m;return}j=b+-4|0;l=k[j>>2]|0;k[j>>2]=l+-1;if((l|0)!=1){r=m;return}ggb(k[b+-8>>2]|0);r=m;return}function yo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+32|0;j=m+12|0;l=m;h=k[a>>2]|0;f=c+4|0;g=k[c>>2]|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;if(g>>>0>4294967279)hob();if(g>>>0<11){i[j+11>>0]=g;if(!g)a=j;else{a=j;e=10}}else{e=g+16&-16;c=(e|0)==0?1:e;while(1){a=fgb(c)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[j>>2]=a;k[j+8>>2]=e|-2147483648;k[j+4>>2]=g;e=10}if((e|0)==10)upb(a|0,f|0,g|0)|0;i[a+g>>0]=0;f=d+4|0;g=k[d>>2]|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;if(g>>>0>4294967279)hob();if(g>>>0<11){i[l+11>>0]=g;if(!g)a=l;else{a=l;e=20}}else{e=g+16&-16;c=(e|0)==0?1:e;while(1){a=fgb(c)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[l>>2]=a;k[l+8>>2]=e|-2147483648;k[l+4>>2]=g;e=20}if((e|0)==20)upb(a|0,f|0,g|0)|0;i[a+g>>0]=0;Ph[h&511](b,j,l);if((i[l+11>>0]|0)<0)ggb(k[l>>2]|0);if((i[j+11>>0]|0)>=0){r=m;return}ggb(k[j>>2]|0);r=m;return}function zo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+16|0;d=c;e=k[(k[a>>2]|0)+8>>2]|0;k[d+8>>2]=0;k[d+12>>2]=0;k[d>>2]=16842752;k[d+4>>2]=b;jh[e&1023](a,d);r=c;return}function Ao(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Bo(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Co(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;j=j|0;var l=0,m=0,n=0,o=0,p=0;l=r;r=r+32|0;o=l+16|0;n=l+8|0;m=l;p=k[(k[a>>2]|0)+44>>2]|0;k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=b;k[n>>2]=k[f>>2];k[n+4>>2]=k[f+4>>2];k[m>>2]=k[g>>2];k[m+4>>2]=k[g+4>>2];jg[p&3](a,o,c,d,e,n,m,h,i,j);r=l;return}function Do(a,b,c,d,e,f,g,h,i,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;l=l|0;var m=0,n=0,o=0;m=r;r=r+16|0;o=m+8|0;n=m;a=k[a>>2]|0;k[o>>2]=k[g>>2];k[o+4>>2]=k[g+4>>2];k[n>>2]=k[h>>2];k[n+4>>2]=k[h+4>>2];jg[a&3](b,c,d,e,f,o,n,i,j,l);r=m;return}function Eo(a,b){a=a|0;b=b|0;b=b+(k[a>>2]|0)|0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];return a|0}function Fo(a,b,c){a=a|0;b=b|0;c=c|0;b=b+(k[a>>2]|0)|0;k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];return}function Go(a,b){a=a|0;b=b|0;return k[b+(k[a>>2]|0)>>2]|0}function Ho(a,b,c){a=a|0;b=b|0;c=c|0;k[b+(k[a>>2]|0)>>2]=c;return}function Io(a,b){a=a|0;b=b|0;return +(+p[b+(k[a>>2]|0)>>3])}function Jo(a,b,c){a=a|0;b=b|0;c=+c;p[b+(k[a>>2]|0)>>3]=c;return}function Ko(a,b){a=a|0;b=b|0;return (i[b+(k[a>>2]|0)>>0]&1)!=0|0}function Lo(a,b,c){a=a|0;b=b|0;c=c|0;i[b+(k[a>>2]|0)>>0]=c&1;return}function Mo(a,b){a=a|0;b=b|0;b=b+(k[a>>2]|0)|0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}BH(a,b);return a|0}function No(a,b,c){a=a|0;b=b|0;c=c|0;a=b+(k[a>>2]|0)|0;if((a|0)==(c|0))return;zH(a,k[c>>2]|0,k[c+4>>2]|0);return}function Oo(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Po(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Qo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=r;r=r+16|0;d=e;c=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](d,a);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];r=e;return c|0}function Ro(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+88>>2]&1023](a,b);return}function So(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function To(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Uo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0;f=r;r=r+32|0;h=f+16|0;g=f;i=k[(k[a>>2]|0)+56>>2]|0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b;b=g+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=c;e=+wh[i&31](a,h,g,d);r=f;return +e}function Vo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+wh[k[a>>2]&31](b,c,d,e))}function Wo(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];d=b+4|0;k[a+4>>2]=k[d>>2];k[b>>2]=0;k[d>>2]=0;r=c;return a|0}function Xo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function Yo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+16|0;d=c;e=k[(k[a>>2]|0)+104>>2]|0;k[d>>2]=k[b>>2];k[d+4>>2]=k[b+4>>2];k[d+8>>2]=k[b+8>>2];k[d+12>>2]=k[b+12>>2];jh[e&1023](a,d);r=c;return}function Zo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;a=k[a>>2]|0;k[e>>2]=k[c>>2];k[e+4>>2]=k[c+4>>2];k[e+8>>2]=k[c+8>>2];k[e+12>>2]=k[c+12>>2];jh[a&1023](b,e);r=d;return}function _o(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+96>>2]&1023](a,b);return}function $o(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+72>>2]&1023](a,b);return}function ap(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+64>>2]&255](a,b);return}function bp(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function cp(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+80>>2]&1023](a,b);return}function dp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;c=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](i,a);while(1){c=fgb(56)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[i>>2];a=i+4|0;k[c+4>>2]=k[a>>2];e=c+8|0;b=i+8|0;k[e>>2]=k[b>>2];k[c+12>>2]=k[i+12>>2];g=i+16|0;k[c+16>>2]=k[g>>2];k[c+20>>2]=k[i+20>>2];k[c+24>>2]=k[i+24>>2];k[c+28>>2]=k[i+28>>2];k[c+32>>2]=k[i+32>>2];h=i+36|0;k[c+36>>2]=k[h>>2];d=c+40|0;k[d>>2]=e;e=c+44|0;f=c+48|0;k[e>>2]=f;k[c+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return c|0}ggb(k[a+-4>>2]|0);r=j;return c|0}function ep(a){a=a|0;return k[a+4>>2]|0}function fp(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function gp(a){a=a|0;return 0}function hp(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function ip(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function jp(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function kp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0;while(1){e=fgb(24)|0;if(e|0){f=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){f=0;break}Qh[e&7]()}k[f>>2]=149296;e=f+16|0;g=f+20|0;k[f+4>>2]=b;k[f+8>>2]=c;o[f+12>>2]=d;k[g>>2]=0;k[e>>2]=0;b=ZT(32)|0;k[b>>2]=1;k[e>>2]=b+4;k[g>>2]=26;i[b+30>>0]=0;e=k[e>>2]|0;b=391578;c=e+26|0;do{i[e>>0]=i[b>>0]|0;e=e+1|0;b=b+1|0}while((e|0)<(c|0));while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[e+4>>2]=1;k[e>>2]=149552;k[e+8>>2]=f;k[a>>2]=e;k[a+4>>2]=f;return}function lp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0;f=r;r=r+16|0;e=f;ah[a&31](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];c=e+4|0;k[a+4>>2]=k[c>>2];k[e>>2]=0;k[c>>2]=0;r=f;return a|0}function mp(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+52>>2]&1023](a,b);return}function np(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function op(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function pp(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function qp(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function rp(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function sp(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function tp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;while(1){e=fgb(16)|0;if(e|0){f=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){f=0;break}Qh[e&7]()}k[f>>2]=128284;k[f+4>>2]=b;i[f+8>>0]=c&1;k[f+12>>2]=d<<16>>16;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}d=e+4|0;k[d>>2]=1;k[e>>2]=128380;k[e+8>>2]=f;k[a>>2]=e;k[a+4>>2]=f;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[e>>2]|0)+8>>2]&2047](e);return}function up(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;f=r;r=r+16|0;e=f;dh[a&255](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];d=e+4|0;k[a+4>>2]=k[d>>2];k[e>>2]=0;k[d>>2]=0;r=f;return a|0}function vp(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+72>>2]&1023](a,b);return}function wp(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function xp(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+64>>2]&1023](a,b);return}function yp(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function zp(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+80>>2]&1023](a,b);return}function Ap(a){a=a|0;return k[a+4>>2]|0}function Bp(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function Cp(a){a=a|0;return 0}function Dp(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function Ep(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Fp(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Gp(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];d=b+4|0;k[a+4>>2]=k[d>>2];k[b>>2]=0;k[d>>2]=0;r=c;return a|0}function Hp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function Ip(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+160>>2]&1023](a,b);return}function Jp(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Kp(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Lp(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+168>>2]&255](a,b);return}function Mp(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function Np(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+152>>2]&1023](a,b);return}function Op(a){a=a|0;return k[a+4>>2]|0}function Pp(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function Qp(a){a=a|0;return 0}function Rp(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function Sp(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Tp(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Up(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=r;r=r+48|0;h=e+32|0;g=e+16|0;f=e;i=k[(k[a>>2]|0)+32>>2]|0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=c;c=f+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[f>>2]=50397184;k[f+4>>2]=d;dh[i&255](a,h,g,f);r=e;return}function Vp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function Wp(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;Uh[d&2047](a);return}else{d=k[(k[a>>2]|0)+c>>2]|0;Uh[d&2047](a);return}}function Xp(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Yp(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Zp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+48|0;i=f+32|0;h=f+16|0;g=f;j=k[(k[a>>2]|0)+40>>2]|0;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=c;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=d;d=g+4+4|0;k[d>>2]=0;k[d+4>>2]=0;k[g>>2]=50397184;k[g+4>>2]=e;e=$g[j&127](a,b,i,h,g)|0;r=f;return e|0}function _p(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return $g[k[a>>2]&127](b,c,d,e,f)|0}function $p(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0;g=r;r=r+80|0;m=g+64|0;l=g+48|0;j=g+32|0;i=g+16|0;h=g;n=k[(k[a>>2]|0)+32>>2]|0;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=b;b=l+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[l>>2]=33619968;k[l+4>>2]=c;c=j+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=d;d=i+4+4|0;k[d>>2]=0;k[d+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=e;e=h+4+4|0;k[e>>2]=0;k[e+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=f;Lg[n&255](a,m,l,j,i,h);r=g;return}function aq(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Lg[k[a>>2]&255](b,c,d,e,f,g);return}function bq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=r;r=r+32|0;f=d+16|0;e=d;g=k[(k[a>>2]|0)+36>>2]|0;h=f+4+4|0;k[h>>2]=0;k[h+4>>2]=0;k[f>>2]=50397184;k[f+4>>2]=b;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=c;Ph[g&511](a,f,e);r=d;return}function cq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[k[a>>2]&511](b,c,d);return}function dq(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;h=+h;j=j|0;var l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+16|0;t=v;while(1){l=fgb(384)|0;if(l|0){u=l;break}l=k[207666]|0;k[207666]=l+0;if(!l){u=0;break}Qh[l&7]()}k[u>>2]=86764;k[u+4>>2]=1124007936;l=u+12|0;m=u+44|0;o=u+8|0;q=o+36|0;do{k[o>>2]=0;o=o+4|0}while((o|0)<(q|0));k[m>>2]=l;l=u+52|0;k[u+48>>2]=l;k[u+56>>2]=0;k[l>>2]=0;l=u+60|0;m=u+68|0;n=u+100|0;o=u+64|0;q=o+36|0;do{k[o>>2]=0;o=o+4|0}while((o|0)<(q|0));k[n>>2]=m;m=u+108|0;k[u+104>>2]=m;k[u+112>>2]=0;k[m>>2]=0;k[l>>2]=1124007942;l=u+120|0;m=u+128|0;n=u+160|0;o=u+124|0;q=o+36|0;do{k[o>>2]=0;o=o+4|0}while((o|0)<(q|0));k[n>>2]=m;m=u+168|0;k[u+164>>2]=m;k[u+172>>2]=0;k[m>>2]=0;k[l>>2]=1124007942;l=u+180|0;m=u+188|0;n=u+220|0;o=u+184|0;q=o+36|0;do{k[o>>2]=0;o=o+4|0}while((o|0)<(q|0));k[n>>2]=m;m=u+228|0;k[u+224>>2]=m;k[u+232>>2]=0;k[m>>2]=0;k[l>>2]=1124007942;l=u+240|0;m=u+248|0;n=u+280|0;o=u+244|0;q=o+36|0;do{k[o>>2]=0;o=o+4|0}while((o|0)<(q|0));k[n>>2]=m;q=u+288|0;k[u+284>>2]=q;k[u+292>>2]=0;k[q>>2]=0;k[l>>2]=1124007936;p[u+320>>3]=c;k[u+328>>2]=b;p[u+336>>3]=d;p[u+344>>3]=e;p[u+352>>3]=f;p[u+360>>3]=g;p[u+368>>3]=h;k[u+376>>2]=j;if(!((j|0)>0&(h<1.0&(f<180.0&(c>0.0&d>0.0&e>=0.0&f>0.0)&h>=0.0)))?(k[t>>2]=0,j=t+4|0,k[j>>2]=0,s=ZT(136)|0,k[s>>2]=1,b=s+4|0,k[t>>2]=b,k[j>>2]=131,i[s+135>>0]=0,upb(b|0,340392,131)|0,Y8(-215,t,340524,339828,409),k[j>>2]=0,k[t>>2]=0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0)ggb(k[s+-4>>2]|0);while(1){l=fgb(16)|0;if(l|0)break;l=k[207666]|0;k[207666]=l+0;if(!l){l=0;break}Qh[l&7]()}t=l+4|0;k[t>>2]=1;k[l>>2]=86816;k[l+8>>2]=u;k[a>>2]=l;k[a+4>>2]=u;k[t>>2]=(k[t>>2]|0)+1;a=k[t>>2]|0;k[t>>2]=a+-1;if((a|0)!=1){r=v;return}Uh[k[(k[l>>2]|0)+8>>2]&2047](l);r=v;return}function eq(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;h=+h;i=i|0;var j=0,l=0;l=r;r=r+16|0;j=l;zh[a&1](j,b,c,d,e,f,g,h,i);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[j>>2];i=j+4|0;k[a+4>>2]=k[i>>2];k[j>>2]=0;k[i>>2]=0;r=l;return a|0}function fq(a){a=a|0;return k[a+4>>2]|0}function gq(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function hq(a){a=a|0;return 0}function iq(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function jq(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function kq(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function lq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0;e=r;r=r+32|0;g=e+16|0;f=e;h=k[(k[a>>2]|0)+32>>2]|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;b=f+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=c;ah[h&31](a,g,f,d);r=e;return}function mq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;ah[k[a>>2]&31](b,c,d,e);return}function nq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=r;r=r+16|0;d=c;e=k[(k[a>>2]|0)+36>>2]|0;f=d+4+4|0;k[f>>2]=0;k[f+4>>2]=0;k[d>>2]=33619968;k[d+4>>2]=b;jh[e&1023](a,d);r=c;return}function oq(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function pq(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function qq(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function rq(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0;while(1){d=fgb(20)|0;if(d|0){g=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){g=0;break}Qh[d&7]()}k[g>>2]=149432;d=g+4|0;e=d;k[e>>2]=0;k[e+4>>2]=0;e=ZT(32)|0;k[e>>2]=1;k[d>>2]=e+4;k[g+8>>2]=26;i[e+30>>0]=0;d=k[d>>2]|0;e=391811;f=d+26|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));k[g+12>>2]=b;o[g+16>>2]=c;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d+4>>2]=1;k[d>>2]=149592;k[d+8>>2]=g;k[a>>2]=d;k[a+4>>2]=g;return}function sq(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;e=r;r=r+16|0;d=e;Rh[a&63](d,b,c);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[d>>2];b=d+4|0;k[a+4>>2]=k[b>>2];k[d>>2]=0;k[b>>2]=0;r=e;return a|0}function tq(a){a=a|0;return 8232}function uq(a){a=a|0;if(a|0)ggb(a);return}function vq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+16|0;p=s;e=k[d>>2]|0;q=d+4|0;m=k[q>>2]|0;f=m;a=e;if((e|0)==(m|0)){f=b+4|0;e=k[f>>2]|0;a=k[b>>2]|0;h=(e-a|0)/28|0;j=c+4|0;n=k[j>>2]|0;m=k[c>>2]|0;l=n-m>>3;g=a;if(h>>>0<=l>>>0){if(h>>>0<l>>>0?(o=m+(h<<3)|0,(n|0)!=(o|0)):0)k[j>>2]=n+(~((n+-8-o|0)>>>3)<<3)}else{o9(c,h-l|0);g=k[b>>2]|0;e=k[f>>2]|0;a=g}if((e|0)==(a|0)){r=s;return}f=k[c>>2]|0;e=(e-g|0)/28|0;a=0;do{k[f+(a<<3)>>2]=k[g+(a*28|0)>>2];k[f+(a<<3)+4>>2]=k[g+(a*28|0)+4>>2];a=a+1|0}while(a>>>0<e>>>0);r=s;return}g=f-a>>2;h=c+4|0;m=k[h>>2]|0;l=k[c>>2]|0;j=m-l>>3;if(g>>>0<=j>>>0){if(g>>>0<j>>>0?(n=l+(g<<3)|0,(m|0)!=(n|0)):0)k[h>>2]=m+(~((m+-8-n|0)>>>3)<<3)}else{o9(c,g-j|0);a=k[d>>2]|0;e=a;f=k[q>>2]|0}if((f|0)==(a|0)){r=s;return}j=p+4|0;h=0;g=f;while(1){e=k[e+(h<<2)>>2]|0;if((e|0)>-1){f=k[c>>2]|0;o=k[b>>2]|0;k[f+(h<<3)>>2]=k[o+(e*28|0)>>2];k[f+(h<<3)+4>>2]=k[o+(e*28|0)+4>>2];f=a;e=g}else{a=ZT(64)|0;k[a>>2]=1;e=a+4|0;k[p>>2]=e;k[j>>2]=56;i[a+60>>0]=0;f=232927;g=e+56|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-5,p,232984,232992,82);k[j>>2]=0;k[p>>2]=0;o=k[a>>2]|0;k[a>>2]=o+-1;if((o|0)==1)ggb(k[a+-4>>2]|0);f=k[d>>2]|0;e=k[q>>2]|0}h=h+1|0;if(h>>>0>=e-f>>2>>>0)break;else{a=f;g=e;e=f}}r=s;return}function wq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[a&255](b,c,d,e);return}function xq(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0;r=b+4|0;i=k[r>>2]|0;h=k[b>>2]|0;j=i-h>>3;l=c+4|0;p=k[l>>2]|0;n=k[c>>2]|0;m=(p-n|0)/28|0;a=h;if(j>>>0<=m>>>0){if(j>>>0<m>>>0?(q=n+(j*28|0)|0,(p|0)!=(q|0)):0)k[l>>2]=p+(~(((p+-28-q|0)>>>0)/28|0)*28|0)}else{p9(c,j-m|0);a=k[b>>2]|0;i=k[r>>2]|0;h=a}if((i|0)==(h|0))return;h=0;do{q=k[c>>2]|0;p=k[a+(h<<3)+4>>2]|0;k[q+(h*28|0)>>2]=k[a+(h<<3)>>2];k[q+(h*28|0)+4>>2]=p;o[q+(h*28|0)+8>>2]=d;o[q+(h*28|0)+12>>2]=-1.0;o[q+(h*28|0)+16>>2]=e;k[q+(h*28|0)+20>>2]=f;k[q+(h*28|0)+24>>2]=g;h=h+1|0;a=k[b>>2]|0}while(h>>>0<(k[r>>2]|0)-a>>3>>>0);return}function yq(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Ih[a&7](b,c,d,e,f,g,h);return}function zq(){var a=0;while(1){a=fgb(28)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}o[a>>2]=0.0;o[a+4>>2]=0.0;o[a+8>>2]=0.0;o[a+12>>2]=-1.0;o[a+16>>2]=0.0;k[a+20>>2]=0;k[a+24>>2]=-1;return a|0}function Aq(a){a=a|0;return Nh[a&127]()|0}function Bq(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;while(1){h=fgb(28)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}b=k[b>>2]|0;c=k[c>>2]|0;d=k[d>>2]|0;e=k[e>>2]|0;f=k[f>>2]|0;g=k[g>>2]|0;k[h>>2]=k[a>>2];k[h+4>>2]=b;k[h+8>>2]=c;k[h+12>>2]=d;k[h+16>>2]=e;k[h+20>>2]=f;k[h+24>>2]=g;return h|0}function Cq(a,b,c,d,e,f,g,h){a=a|0;b=+b;c=+c;d=+d;e=+e;f=+f;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0;i=r;r=r+32|0;s=i+24|0;q=i+20|0;p=i+16|0;n=i+12|0;m=i+8|0;l=i+4|0;j=i;o[s>>2]=b;o[q>>2]=c;o[p>>2]=d;o[n>>2]=e;o[m>>2]=f;k[l>>2]=g;k[j>>2]=h;h=vg[a&15](s,q,p,n,m,l,j)|0;r=i;return h|0}function Dq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0;f=+o[b+8>>2];g=f*.5;h=+o[c+8>>2];i=h*.5;j=g*g;e=i*i;k=+o[b>>2]-+o[c>>2];d=+o[b+4>>2]-+o[c+4>>2];d=+Q(+(k*k+d*d));if((i<g?i:g)+d<=(g<i?i:g)){k=(e<j?e:j)/(j<e?e:j);return +k}if(!(d<g+i)){k=0.0;return +k}g=d*d;i=(e+g-j)/(h*d);g=(j+g-e)/(f*d);k=+V(+i);h=+V(+g);k=e*k+j*h-g*(j*+T(+h))-i*(e*+T(+k));k=k/((j+e)*3.1415927410125732-k);return +k}function Eq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Ug[a&31](b,c,d))}function Fq(a,b){a=a|0;b=b|0;b=b+(k[a>>2]|0)|0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];return a|0}function Gq(a,b,c){a=a|0;b=b|0;c=c|0;b=b+(k[a>>2]|0)|0;k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];return}function Hq(a,b){a=a|0;b=b|0;return +(+o[b+(k[a>>2]|0)>>2])}function Iq(a,b,c){a=a|0;b=b|0;c=+c;o[b+(k[a>>2]|0)>>2]=c;return}function Jq(a,b){a=a|0;b=b|0;return k[b+(k[a>>2]|0)>>2]|0}function Kq(a,b,c){a=a|0;b=b|0;c=c|0;k[b+(k[a>>2]|0)>>2]=c;return}function Lq(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Mq(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Nq(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+72>>2]&1023](a,b);return}function Oq(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Pq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=r;r=r+48|0;h=e+32|0;g=e+16|0;f=e;i=k[(k[a>>2]|0)+48>>2]|0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b;b=g+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=c;c=f+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=d;dh[i&255](a,h,g,f);r=e;return}function Qq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function Rq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+48|0;i=f+32|0;h=f+16|0;g=f;j=k[(k[a>>2]|0)+32>>2]|0;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=17104896;k[i+4>>2]=b;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=d;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=e;eh[j&255](a,i,c,h,g);r=f;return}function Sq(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[k[a>>2]&255](b,c,d,e,f);return}function Tq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+16|0;e=d;f=k[(k[a>>2]|0)+36>>2]|0;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=17104896;k[e+4>>2]=b;Ph[f&511](a,e,c);r=d;return}function Uq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[k[a>>2]&511](b,c,d);return}function Vq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=d&1;while(1){d=fgb(24)|0;if(d|0){f=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){f=0;break}Qh[d&7]()}k[f>>2]=149880;d=f+4|0;k[d>>2]=0;h=f+8|0;k[h>>2]=0;g=ZT(16)|0;k[g>>2]=1;k[d>>2]=g+4;k[h>>2]=8;i[g+12>>0]=0;d=k[d>>2]|0;g=d;i[g>>0]=65;i[g+1>>0]=108;i[g+2>>0]=105;i[g+3>>0]=103;d=d+4|0;i[d>>0]=110;i[d+1>>0]=77;i[d+2>>0]=84;i[d+3>>0]=66;k[f+12>>2]=b;k[f+16>>2]=c;i[f+20>>0]=e;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}g=d+4|0;k[g>>2]=1;k[d>>2]=149964;k[d+8>>2]=f;k[a>>2]=d;k[a+4>>2]=f;k[g>>2]=(k[g>>2]|0)+1;h=k[g>>2]|0;k[g>>2]=h+-1;if((h|0)!=1)return;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);return}function Wq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;f=r;r=r+16|0;e=f;dh[a&255](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];d=e+4|0;k[a+4>>2]=k[d>>2];k[e>>2]=0;k[d>>2]=0;r=f;return a|0}function Xq(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+64>>2]&1023](a,b);return}function Yq(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Zq(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function _q(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+56>>2]&1023](a,b);return}function $q(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=r;r=r+48|0;h=e+24|0;g=e+8|0;f=e;i=k[(k[a>>2]|0)+44>>2]|0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b;b=g+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=c;k[f>>2]=k[d>>2];k[f+4>>2]=k[d+4>>2];dh[i&255](a,h,g,f);r=e;return}function ar(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=r;r=r+16|0;g=f;a=k[a>>2]|0;k[g>>2]=k[e>>2];k[g+4>>2]=k[e+4>>2];dh[a&255](b,c,d,g);r=f;return}function br(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function cr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=r;r=r+32|0;g=e+16|0;f=e;h=k[(k[b>>2]|0)+40>>2]|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=c;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=d;dh[h&255](a,b,g,f);r=e;return}function dr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;f=r;r=r+16|0;e=f;dh[k[a>>2]&255](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];k[a+4>>2]=k[e+4>>2];r=f;return a|0}function er(a){a=a|0;return k[a+4>>2]|0}function fr(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function gr(a){a=a|0;return 0}function hr(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function ir(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function jr(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function kr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;while(1){c=fgb(76)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=149136;k[c+8>>2]=1124007936;e=c+16|0;d=c+48|0;f=c+12|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=e;f=c+56|0;k[c+52>>2]=f;k[c+60>>2]=0;k[f>>2]=0;f=c+68|0;g=c+72|0;i[c+4>>0]=b&1;k[g>>2]=0;k[f>>2]=0;d=ZT(28)|0;k[d>>2]=1;k[f>>2]=d+4;k[g>>2]=20;i[d+24>>0]=0;f=k[f>>2]|0;d=391017;g=f+20|0;do{i[f>>0]=i[d>>0]|0;f=f+1|0;d=d+1|0}while((f|0)<(g|0));while(1){d=fgb(16)|0;if(d|0){e=9;break}d=k[207666]|0;k[207666]=d+0;if(!d){d=0;e=9;break}Qh[d&7]()}if((e|0)==9){k[d+4>>2]=1;k[d>>2]=149196;k[d+8>>2]=c;k[a>>2]=d;k[a+4>>2]=c;return}}function lr(a,b){a=a|0;b=b|0;var c=0,d=0;d=r;r=r+16|0;c=d;jh[a&1023](c,b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[c>>2];b=c+4|0;k[a+4>>2]=k[b>>2];k[c>>2]=0;k[b>>2]=0;r=d;return a|0}function mr(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function nr(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+44>>2]&1023](a,b);return}function or(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function pr(a){a=a|0;return k[a+4>>2]|0}function qr(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function rr(a){a=a|0;return 0}function sr(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function tr(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function ur(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function vr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0;f=r;r=r+64|0;j=f+48|0;i=f+32|0;h=f+16|0;g=f;l=k[(k[a>>2]|0)+32>>2]|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=17104896;k[j+4>>2]=b;b=i+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=c;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=d;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=e;eh[l&255](a,j,i,h,g);r=f;return}function wr(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[k[a>>2]&255](b,c,d,e,f);return}function xr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=r;r=r+48|0;h=e+32|0;g=e+16|0;f=e;i=k[(k[a>>2]|0)+36>>2]|0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=17104896;k[h+4>>2]=b;b=g+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=c;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=d;dh[i&255](a,h,g,f);r=e;return}function yr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function zr(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];d=b+4|0;k[a+4>>2]=k[d>>2];k[b>>2]=0;k[d>>2]=0;r=c;return a|0}function Ar(a){a=a|0;return k[a+4>>2]|0}function Br(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function Cr(a){a=a|0;return 0}function Dr(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function Er(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Fr(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Gr(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Hr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function Ir(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=r;r=r+48|0;h=e+32|0;g=e+16|0;f=e;i=k[(k[a>>2]|0)+32>>2]|0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=c;c=f+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=d;dh[i&255](a,h,g,f);r=e;return}function Jr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function Kr(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+36>>2]&1023](a,b);return}function Lr(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Mr(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+44>>2]&255](a,b);return}function Nr(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function Or(a){a=a|0;return k[a+4>>2]|0}function Pr(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function Qr(a){a=a|0;return 0}function Rr(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function Sr(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Tr(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Ur(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Vr(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Wr(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+112>>2]&1023](a,b);return}function Xr(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Yr(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+72>>2]&1023](a,b);return}function Zr(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function _r(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+80>>2]&1023](a,b);return}function $r(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+64>>2]&1023](a,b);return}function as(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+88>>2]&1023](a,b);return}function bs(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;c=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](i,a);while(1){c=fgb(56)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[i>>2];a=i+4|0;k[c+4>>2]=k[a>>2];e=c+8|0;b=i+8|0;k[e>>2]=k[b>>2];k[c+12>>2]=k[i+12>>2];g=i+16|0;k[c+16>>2]=k[g>>2];k[c+20>>2]=k[i+20>>2];k[c+24>>2]=k[i+24>>2];k[c+28>>2]=k[i+28>>2];k[c+32>>2]=k[i+32>>2];h=i+36|0;k[c+36>>2]=k[h>>2];d=c+40|0;k[d>>2]=e;e=c+44|0;f=c+48|0;k[e>>2]=f;k[c+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return c|0}ggb(k[a+-4>>2]|0);r=j;return c|0}function cs(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+96>>2]&1023](a,b);return}function ds(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+104>>2]&1023](a,b);return}function es(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+120>>2]&255](a,b);return}function fs(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function gs(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+128>>2]&1023](a,b);return}function hs(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function is(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];d=b+4|0;k[a+4>>2]=k[d>>2];k[b>>2]=0;k[d>>2]=0;r=c;return a|0}function js(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function ks(a){a=a|0;return k[a+4>>2]|0}function ls(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function ms(a){a=a|0;return 0}function ns(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function os(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function ps(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function qs(a,b){a=a|0;b=b|0;jh[k[(k[b>>2]|0)+12>>2]&1023](a,b);return}function rs(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;jh[k[a>>2]&1023](i,b);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function ss(a,b,c){a=a|0;b=b|0;c=c|0;Ph[k[(k[b>>2]|0)+16>>2]&511](a,b,c);return}function ts(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;Ph[k[a>>2]&511](i,b,c);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function us(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;while(1){e=fgb(48)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}a=k[a>>2]|0;c=k[c>>2]|0;d=k[d>>2]|0;f=e+4|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[e>>2]=141208;k[e+20>>2]=a;a=e+24|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[e+40>>2]=c;k[e+44>>2]=d;return e|0}function vs(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=r;r=r+16|0;i=f+8|0;h=f+4|0;g=f;k[i>>2]=b;k[h>>2]=d;k[g>>2]=e;e=Dg[a&127](i,c,h,g)|0;r=f;return e|0}function ws(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function xs(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function ys(a,b){a=a|0;b=b|0;var c=0;while(1){c=fgb(128)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}QXa(c,a,b);return c|0}function zs(a,b,c){a=a|0;b=b|0;c=c|0;return Hh[a&511](b,c)|0}function As(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Bs(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Cs(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function Ds(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;var e=0,f=0,g=0,h=0;while(1){e=fgb(24)|0;if(e|0){h=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){h=0;break}Qh[e&7]()}k[h>>2]=151648;e=h+4|0;k[e>>2]=0;g=h+8|0;k[g>>2]=0;f=ZT(20)|0;k[f>>2]=1;k[e>>2]=f+4;k[g>>2]=14;i[f+18>>0]=0;e=k[e>>2]|0;f=400437;g=e+14|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));o[h+12>>2]=b;o[h+16>>2]=c;o[h+20>>2]=d;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}g=e+4|0;k[g>>2]=1;k[e>>2]=151716;k[e+8>>2]=h;k[a>>2]=e;k[a+4>>2]=h;k[g>>2]=(k[g>>2]|0)+1;a=k[g>>2]|0;k[g>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[e>>2]|0)+8>>2]&2047](e);return}function Es(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;var e=0,f=0,g=0;f=r;r=r+16|0;e=f;oh[a&3](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];g=e+4|0;k[a+4>>2]=k[g>>2];k[e>>2]=0;k[g>>2]=0;r=f;return a|0}function Fs(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+56>>2]&255](a,b);return}function Gs(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function Hs(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+48>>2]&255](a,b);return}function Is(a){a=a|0;return k[a+4>>2]|0}function Js(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function Ks(a){a=a|0;return 0}function Ls(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function Ms(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Ns(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Os(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Ps(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0;f=r;r=r+32|0;h=f+16|0;g=f;i=k[(k[a>>2]|0)+56>>2]|0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b;b=g+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=c;e=+wh[i&31](a,h,g,d);r=f;return +e}function Qs(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+wh[k[a>>2]&31](b,c,d,e))}function Rs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0;f=r;r=r+16|0;g=f;h=k[(k[a>>2]|0)+52>>2]|0;i=g+4+4|0;k[i>>2]=0;k[i+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=d;e=+wh[h&31](a,b,c,g);r=f;return +e}function Ss(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+wh[k[a>>2]&31](b,c,d,e))}function Ts(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Us(a,b,c){a=a|0;b=b|0;c=c|0;return ci[k[(k[a>>2]|0)+44>>2]&255](a,b,c)|0}function Vs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[k[a>>2]&255](b,c,d)|0}function Ws(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=r;r=r+32|0;g=e+16|0;f=e;h=k[(k[a>>2]|0)+48>>2]|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=d;d=Dg[h&127](a,g,c,f)|0;r=e;return d|0}function Xs(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Dg[k[a>>2]&127](b,c,d,e)|0}function Ys(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Zs(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function _s(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=r;r=r+32|0;f=d+16|0;e=d;g=k[(k[a>>2]|0)+32>>2]|0;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;b=e+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=c;Ph[g&511](a,f,e);r=d;return}function $s(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[k[a>>2]&511](b,c,d);return}function at(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+40>>2]&255](a,b);return}function bt(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function ct(a,b){a=a|0;b=+b;Y3a(a,b);return}function dt(a,b){a=a|0;b=+b;var c=0,d=0,e=0;d=r;r=r+16|0;c=d;gh[a&255](c,b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[c>>2];e=c+4|0;k[a+4>>2]=k[e>>2];k[c>>2]=0;k[e>>2]=0;r=d;return a|0}function et(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function ft(a){a=a|0;return k[a+4>>2]|0}function gt(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function ht(a){a=a|0;return 0}function it(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function jt(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function kt(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function lt(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+72>>2]&1023](a,b);return}function mt(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function nt(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function ot(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+88>>2]&1023](a,b);return}function pt(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function qt(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+80>>2]&1023](a,b);return}function rt(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+64>>2]&1023](a,b);return}function st(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function tt(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];d=b+4|0;k[a+4>>2]=k[d>>2];k[b>>2]=0;k[d>>2]=0;r=c;return a|0}function ut(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0,j=0,l=0,m=0,n=0;h=r;r=r+64|0;m=h+48|0;l=h+32|0;j=h+16|0;i=h;n=k[(k[a>>2]|0)+92>>2]|0;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=b;b=l+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[l>>2]=33619968;k[l+4>>2]=d;d=j+4+4|0;k[d>>2]=0;k[d+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=e;e=i+4+4|0;k[e>>2]=0;k[e+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=f;g=+pi[n&7](a,m,c,l,j,i);r=h;return +g}function vt(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return +(+pi[k[a>>2]&7](b,c,d,e,f,g))}function wt(a){a=a|0;return k[a+4>>2]|0}function xt(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function yt(a){a=a|0;return 0}function zt(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function At(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Bt(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Ct(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Dt(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Et(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;while(1){e=fgb(16)|0;if(e|0){f=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){f=0;break}Qh[e&7]()}k[f>>2]=141536;k[f+4>>2]=b;i[f+8>>0]=c&1;k[f+12>>2]=d<<16>>16;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}d=e+4|0;k[d>>2]=1;k[e>>2]=141632;k[e+8>>2]=f;k[a>>2]=e;k[a+4>>2]=f;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[e>>2]|0)+8>>2]&2047](e);return}function Ft(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;f=r;r=r+16|0;e=f;dh[a&255](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];d=e+4|0;k[a+4>>2]=k[d>>2];k[e>>2]=0;k[d>>2]=0;r=f;return a|0}function Gt(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+72>>2]&1023](a,b);return}function Ht(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function It(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+64>>2]&1023](a,b);return}function Jt(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Kt(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+80>>2]&1023](a,b);return}function Lt(a){a=a|0;return k[a+4>>2]|0}function Mt(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function Nt(a){a=a|0;return 0}function Ot(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function Pt(a){a=a|0;return 7400}function Qt(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;b=k[a+12>>2]|0;if(b|0){c=a+16|0;d=k[c>>2]|0;while(1){if((b|0)==(d|0))break;e=d+-32|0;k[c>>2]=e;d=e}ggb(b)}d=k[a>>2]|0;if(d|0){b=a+4|0;c=k[b>>2]|0;while(1){if((d|0)==(c|0))break;e=c+-16|0;k[b>>2]=e;c=e}ggb(d)}ggb(a);return}function Rt(a,b){a=a|0;b=b|0;var c=0,d=0;c=r;r=r+16|0;d=c;k[d>>2]=k[b>>2];k[d+4>>2]=k[b+4>>2];b=Fua(a,d)|0;r=c;return b|0}function St(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;a=k[a>>2]|0;k[e>>2]=k[c>>2];k[e+4>>2]=k[c+4>>2];c=Hh[a&511](b,e)|0;r=d;return c|0}function Tt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;h=r;r=r+16|0;e=h;f=b+4|0;c=k[b>>2]|0;if((k[f>>2]|0)==(c|0)){r=h;return}g=e+4|0;d=0;do{i=c;k[e>>2]=k[i+(d<<3)>>2];k[g>>2]=k[i+(d<<3)+4>>2];Fua(a,e)|0;d=d+1|0;c=k[b>>2]|0}while(d>>>0<(k[f>>2]|0)-c>>3>>>0);r=h;return}function Ut(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Vt(a,b,c){a=a|0;b=b|0;c=c|0;b=k[(k[a+12>>2]|0)+(b>>2<<5)+16+((b&3)<<2)>>2]|0;if(!c)return b|0;a=k[a>>2]|0;k[c>>2]=k[a+(b<<4)+8>>2];k[c+4>>2]=k[a+(b<<4)+12>>2];return b|0}function Wt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[k[a>>2]&255](b,c,d)|0}function Xt(a,b,c){a=a|0;b=b|0;c=c|0;return c+b&3|b&-4|0}function Yt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[k[a>>2]&255](b,c,d)|0}function Zt(a,b){a=a|0;b=b|0;var c=0,d=0;c=r;r=r+16|0;d=c;k[d>>2]=k[b>>2];k[d+4>>2]=k[b+4>>2];k[d+8>>2]=k[b+8>>2];k[d+12>>2]=k[b+12>>2];Bua(a,d);r=c;return}function _t(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;a=k[a>>2]|0;k[e>>2]=k[c>>2];k[e+4>>2]=k[c+4>>2];k[e+8>>2]=k[c+8>>2];k[e+12>>2]=k[c+12>>2];jh[a&1023](b,e);r=d;return}function $t(){var a=0,b=0;while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}b=a+36|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;k[a+24>>2]=0;k[a+28>>2]=0;i[a+32>>0]=0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;return a|0}function au(a){a=a|0;return Nh[a&127]()|0}function bu(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;d=r;r=r+16|0;c=d;while(1){b=fgb(56)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}g=k[a>>2]|0;f=k[a+4>>2]|0;e=k[a+8>>2]|0;a=k[a+12>>2]|0;h=b+36|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;k[b+24>>2]=0;k[b+28>>2]=0;i[b+32>>0]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[c>>2]=g;k[c+4>>2]=f;k[c+8>>2]=e;k[c+12>>2]=a;Bua(b,c);r=d;return b|0}function cu(a,b){a=a|0;b=b|0;var c=0,d=0;c=r;r=r+16|0;d=c;k[d>>2]=k[b>>2];k[d+4>>2]=k[b+4>>2];k[d+8>>2]=k[b+8>>2];k[d+12>>2]=k[b+12>>2];b=Xh[a&1023](d)|0;r=c;return b|0}function du(a,b,c){a=a|0;b=b|0;c=c|0;b=k[(k[a+12>>2]|0)+(b>>2<<5)+((c+b&3)<<2)>>2]|0;return b+(c>>>4)&3|b&-4|0}function eu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=k[b>>2]|0;w=b+4|0;d=k[w>>2]|0;if((d|0)!=(c|0))k[w>>2]=d+(~(((d+-24-c|0)>>>0)/24|0)*24|0);f=(k[a+16>>2]|0)-(k[a+12>>2]|0)|0;v=f>>3;if(v){if((f|0)<0)ad(426534,426557,304,426811);d=((v+-1|0)>>>5<<2)+4|0;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=v>>>5;zpb(c|0,0,e<<2|0)|0;d=v-(e<<5)|0;e=c+(e<<2)|0;if(d)k[e>>2]=k[e>>2]&~(-1>>>(32-d|0))}else c=0;a:do if((f|0)>32){t=a+12|0;u=b+8|0;s=4;h=c;d=c;b:while(1){e=d+(s>>>5<<2)|0;f=1<<(s&30);g=k[e>>2]|0;do if(!(g&f)){p=s>>2;n=k[t>>2]|0;r=k[n+(p<<5)+16+((s&2)<<2)>>2]|0;o=k[a>>2]|0;q=k[o+(r<<4)+8>>2]|0;r=k[o+(r<<4)+12>>2]|0;k[e>>2]=g|f;e=k[n+(p<<5)+((s+3&3)<<2)>>2]|0;f=e+1&3;p=e>>2;l=k[n+(p<<5)+16+(f<<2)>>2]|0;j=k[o+(l<<4)+8>>2]|0;l=k[o+(l<<4)+12>>2]|0;m=d+(e>>>5<<2)|0;k[m>>2]=k[m>>2]|1<<(f|e&28);e=k[n+(p<<5)+((e&3)<<2)>>2]|0;p=e+1&3;n=k[n+(e>>2<<5)+16+(p<<2)>>2]|0;m=k[o+(n<<4)+8>>2]|0;n=k[o+(n<<4)+12>>2]|0;f=d+(e>>>5<<2)|0;k[f>>2]=k[f>>2]|1<<(p|e&28);f=k[w>>2]|0;e=k[u>>2]|0;if((f|0)!=(e|0)){k[f>>2]=q;k[f+4>>2]=r;k[f+8>>2]=j;k[f+12>>2]=l;k[f+16>>2]=m;k[f+20>>2]=n;k[w>>2]=f+24;e=h;d=h;break}p=k[b>>2]|0;i=(f-p|0)/24|0;d=i+1|0;if(d>>>0>178956970){c=18;break b}o=p;h=(e-p|0)/24|0;g=h<<1;g=h>>>0<89478485?(g>>>0<d>>>0?d:g):178956970;if(!g)e=0;else{if(g>>>0>178956970){c=21;break b}e=g*24|0;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d}d=e+(i*24|0)|0;h=e+(g*24|0)|0;k[d>>2]=q;k[e+(i*24|0)+4>>2]=r;k[e+(i*24|0)+8>>2]=j;k[e+(i*24|0)+12>>2]=l;k[e+(i*24|0)+16>>2]=m;k[e+(i*24|0)+20>>2]=n;g=d+24|0;if((f|0)!=(o|0))while(1){e=d+-24|0;r=f;f=f+-24|0;k[e>>2]=k[f>>2];k[d+-20>>2]=k[r+-20>>2];k[d+-16>>2]=k[r+-16>>2];k[d+-12>>2]=k[r+-12>>2];k[d+-8>>2]=k[r+-8>>2];k[d+-4>>2]=k[r+-4>>2];if((f|0)==(o|0)){d=e;break}else d=e}k[b>>2]=d;k[w>>2]=g;k[u>>2]=h;if(!p){e=c;d=c}else{ggb(p);e=c;d=c}}else e=h;while(0);s=s+2|0;if((s|0)>=(v|0)){x=d;break a}else h=e}if((c|0)==18)ad(426534,426557,304,426811);else if((c|0)==21){x=te(4)|0;k[x>>2]=172664;Cf(x|0,28816,1287)}}else x=c;while(0);if(!x)return;ggb(x);return}function fu(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function gu(a,b){a=a|0;b=b|0;return k[(k[a+12>>2]|0)+(b>>2<<5)+((b&3)<<2)>>2]|0}function hu(a,b,c){a=a|0;b=b|0;c=c|0;return Hh[k[a>>2]&511](b,c)|0}function iu(a,b,c){a=a|0;b=b|0;c=c|0;b=k[(k[a+12>>2]|0)+(b>>2<<5)+16+((b+2&3)<<2)>>2]|0;if(!c)return b|0;a=k[a>>2]|0;k[c>>2]=k[a+(b<<4)+8>>2];k[c+4>>2]=k[a+(b<<4)+12>>2];return b|0}function ju(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+16|0;s=w;c=k[b>>2]|0;v=b+4|0;d=k[v>>2]|0;if((d|0)!=(c|0))k[v>>2]=d+(~((d+-16-c|0)>>>4)<<4);l=a+12|0;m=a+16|0;d=k[m>>2]|0;c=k[l>>2]|0;if(d-c>>5>>>0<=4){r=w;return}n=s+4|0;o=s+8|0;p=s+12|0;q=b+8|0;j=4;do{e=c;if(((k[e+(j<<5)>>2]|0)>=1?(t=k[e+(j<<5)+16>>2]|0,(t|0)>0):0)?(u=k[e+(j<<5)+24>>2]|0,(u|0)>0):0){h=k[a>>2]|0;e=k[h+(t<<4)+8>>2]|0;f=k[h+(t<<4)+12>>2]|0;g=k[h+(u<<4)+8>>2]|0;h=k[h+(u<<4)+12>>2]|0;k[s>>2]=e;k[n>>2]=f;k[o>>2]=g;k[p>>2]=h;i=k[v>>2]|0;if((i|0)==(k[q>>2]|0)){Joa(b,s);d=k[m>>2]|0;c=k[l>>2]|0}else{k[i>>2]=e;k[i+4>>2]=f;k[i+8>>2]=g;k[i+12>>2]=h;k[v>>2]=i+16}}j=j+1|0}while(j>>>0<d-c>>5>>>0);r=w;return}function ku(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function lu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=k[b>>2]|0;if(d|0)k[d>>2]=k[b+(c<<4)>>2];k[a>>2]=k[b+(c<<4)+8>>2];k[a+4>>2]=k[b+(c<<4)+12>>2];return}function mu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;f=r;r=r+16|0;e=f;dh[k[a>>2]&255](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];k[a+4>>2]=k[e+4>>2];r=f;return a|0}function nu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+16|0;z=A;Gua(a);i=k[c>>2]|0;y=c+4|0;e=k[y>>2]|0;if((e|0)!=(i|0))do{f=e+-12|0;k[y>>2]=f;g=k[f>>2]|0;h=g;if(!g)e=f;else{e=e+-8|0;f=k[e>>2]|0;if((f|0)!=(g|0))k[e>>2]=f+(~((f+-8-h|0)>>>3)<<3);ggb(g);e=k[y>>2]|0}}while((e|0)!=(i|0));e=k[d>>2]|0;w=d+4|0;f=k[w>>2]|0;if((f|0)!=(e|0))k[w>>2]=f+(~((f+-8-e|0)>>>3)<<3);k[z>>2]=0;x=z+4|0;k[x>>2]=0;k[z+8>>2]=0;g=k[b>>2]|0;q=b+4|0;f=k[q>>2]|0;if((g|0)==(f|0)){e=4;p=(k[a+4>>2]|0)-(k[a>>2]|0)>>4}else{e=0;p=f-g>>2}if(e>>>0>=p>>>0){r=A;return}s=a+12|0;t=z+8|0;u=c+8|0;v=d+8|0;a:while(1){if((g|0)==(f|0))o=e;else o=k[g+(e<<2)>>2]|0;i=k[a>>2]|0;do if(!(k[i+(o<<4)+4>>2]|0)){n=k[i+(o<<4)>>2]|0;n=n+1&3|n&-4;f=k[z>>2]|0;g=k[x>>2]|0;if((g|0)==(f|0))h=f;else{h=g+(~((g+-8-f|0)>>>3)<<3)|0;k[x>>2]=h}f=n;g=k[s>>2]|0;while(1){m=f>>2;j=k[g+(m<<5)+16+((f&3)<<2)>>2]|0;l=i+(j<<4)+8|0;if((h|0)==(k[t>>2]|0)){dga(z,l);g=k[s>>2]|0}else{k[h>>2]=k[l>>2];k[h+4>>2]=k[i+(j<<4)+12>>2];k[x>>2]=h+8}f=k[g+(m<<5)+((f+3&3)<<2)>>2]|0;f=f+1&3|f&-4;if((f|0)==(n|0))break;i=k[a>>2]|0;h=k[x>>2]|0}f=k[y>>2]|0;n=k[u>>2]|0;g=n;if((f|0)==(n|0)){h=k[c>>2]|0;j=(f-h|0)/12|0;f=j+1|0;if(f>>>0>357913941){e=28;break a}n=(g-h|0)/12|0;i=n<<1;i=n>>>0<178956970?(i>>>0<f>>>0?f:i):357913941;if(!i)f=0;else{if(i>>>0>357913941){e=31;break a}g=i*12|0;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}}g=f+(j*12|0)|0;h=g;j=f+(i*12|0)|0;Hua(g,z);l=g+12|0;i=k[c>>2]|0;f=k[y>>2]|0;if((f|0)==(i|0)){f=h;m=i;g=i}else{do{f=f+-12|0;Hua(g+-12|0,f);g=h+-12|0;h=g}while((f|0)!=(i|0));f=h;m=k[c>>2]|0;g=k[y>>2]|0}k[c>>2]=f;k[y>>2]=l;k[u>>2]=j;l=m;if((g|0)!=(l|0))do{f=g;g=g+-12|0;i=k[g>>2]|0;j=i;if(i|0){f=f+-8|0;h=k[f>>2]|0;if((h|0)!=(i|0))k[f>>2]=h+(~((h+-8-j|0)>>>3)<<3);ggb(i)}}while((g|0)!=(l|0));if(m|0)ggb(m)}else{Hua(f,z);k[y>>2]=(k[y>>2]|0)+12}f=k[a>>2]|0;g=f+(o<<4)+8|0;h=k[w>>2]|0;if((h|0)==(k[v>>2]|0)){dga(d,g);break}else{k[h>>2]=k[g>>2];k[h+4>>2]=k[f+(o<<4)+12>>2];k[w>>2]=h+8;break}}while(0);e=e+1|0;if(e>>>0>=p>>>0){e=54;break}g=k[b>>2]|0;f=k[q>>2]|0}if((e|0)==28)ad(426534,426557,304,426811);else if((e|0)==31){A=te(4)|0;k[A>>2]=172664;Cf(A|0,28816,1287)}else if((e|0)==54){e=k[z>>2]|0;if(!e){r=A;return}f=k[x>>2]|0;if((f|0)!=(e|0))k[x>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(e);r=A;return}}function ou(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function pu(a,b){a=a|0;b=b|0;return b^2|0}function qu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0.0,h=0.0,j=0.0,l=0,m=0.0,n=0,p=0,q=0,s=0,t=0.0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0;F=r;r=r+32|0;D=F+20|0;B=F+16|0;d=F+8|0;C=F;e=k[b>>2]|0;b=k[b+4>>2]|0;if(!(i[a+32>>0]|0))Gua(a);k[D>>2]=0;k[B>>2]=0;k[d>>2]=e;k[d+4>>2]=b;switch(Eua(a,d,B,D)|0){case 0:case 2:break;default:{E=k[D>>2]|0;r=F;return E|0}}k[D>>2]=0;w=k[B>>2]|0;A=a+12|0;d=k[A>>2]|0;x=k[d+(w>>2<<5)+16+((w&3)<<2)>>2]|0;l=k[a>>2]|0;g=+o[l+(x<<4)+8>>2];f=+o[l+(x<<4)+12>>2];h=(k[u>>2]=e,+o[u>>2]);j=(k[u>>2]=b,+o[u>>2]);b=w+1&3|w&-4;k[B>>2]=b;w=(k[a+4>>2]|0)-l|0;x=w>>4;if((w|0)<=0){E=0;r=F;return E|0}y=g;z=j-f;t=h-g;v=C+4|0;w=C+4|0;s=0;e=l;while(1){while(1){l=b>>2;q=k[d+(l<<5)+16+((b+2&3)<<2)>>2]|0;m=+o[e+(q<<4)+8>>2];g=+o[e+(q<<4)+12>>2];if((q|0)<=0){d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[C>>2]=e;k[v>>2]=21;i[d+25>>0]=0;p=352340;q=e+21|0;do{i[e>>0]=i[p>>0]|0;e=e+1|0;p=p+1|0}while((e|0)<(q|0));Y8(-215,C,372666,352210,672);k[v>>2]=0;k[C>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}if(!(z*(y-m)-t*(f-g)<0.0))break;d=k[A>>2]|0;e=k[d+(l<<5)+((b+3&3)<<2)>>2]|0;e=e+1&3|e&-4;k[B>>2]=e;b=e;e=k[a>>2]|0}d=k[A>>2]|0;while(1){l=b&3;n=b>>2;q=k[d+(n<<5)+16+(l<<2)>>2]|0;p=k[a>>2]|0;g=+o[p+(q<<4)+8>>2];m=+o[p+(q<<4)+12>>2];if((q|0)<=0){d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[C>>2]=e;k[w>>2]=23;i[d+27>>0]=0;p=352362;q=e+23|0;do{i[e>>0]=i[p>>0]|0;e=e+1|0;p=p+1|0}while((e|0)<(q|0));Y8(-215,C,372666,352210,681);k[w>>2]=0;k[C>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}if(z*(y-g)-t*(f-m)<0.0)break;d=k[A>>2]|0;b=k[d+(n<<5)+(l<<2)>>2]|0;b=b+2&3|b&-4;k[B>>2]=b}d=k[A>>2]|0;q=k[d+(n<<5)+16+((b+2&3)<<2)>>2]|0;e=k[a>>2]|0;p=k[d+(n<<5)+16+(l<<2)>>2]|0;g=+o[e+(p<<4)+8>>2];m=+o[e+(p<<4)+12>>2];if(!((+o[e+(q<<4)+12>>2]-m)*(g-h)-(+o[e+(q<<4)+8>>2]-g)*(m-j)<0.0))break;b=b^2;k[B>>2]=b;s=s+1|0;if((s|0)>=(x|0)){b=0;E=25;break}}if((E|0)==25){r=F;return b|0}b=k[d+(n<<5)+16+((b+3&3)<<2)>>2]|0;k[D>>2]=b;if(!((c|0)!=0&(b|0)>0)){E=b;r=F;return E|0}k[c>>2]=k[e+(b<<4)+8>>2];k[c+4>>2]=k[e+(b<<4)+12>>2];E=b;r=F;return E|0}function ru(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=r;r=r+16|0;f=e;a=k[a>>2]|0;k[f>>2]=k[c>>2];k[f+4>>2]=k[c+4>>2];d=ci[a&255](b,f,d)|0;r=e;return d|0}function su(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function tu(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function uu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0.0;n=r;r=r+48|0;i=n+24|0;j=n+12|0;l=n;while(1){e=fgb(56)|0;if(e|0){m=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){m=0;break}Qh[e&7]()}k[m>>2]=141412;k[m+4>>2]=b;k[m+8>>2]=c;k[i>>2]=0;h=i+4|0;k[h>>2]=0;k[i+8>>2]=0;k[j>>2]=0;f=j+4|0;k[f>>2]=0;k[j+8>>2]=0;FEa(i,5);U1(j,5);c=k[j>>2]|0;p=d*.85;g=k[i>>2]|0;o[g>>2]=p*0.0;o[g+4>>2]=p*2.9;o[g+8>>2]=p*4.9;o[g+12>>2]=p*7.4;o[g+16>>2]=p*10.8;k[c>>2]=1;k[c+4>>2]=10;k[c+8>>2]=14;k[c+12>>2]=15;k[c+16>>2]=20;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;$Ua(m,i,j,d*5.85,d*8.2,l);e=c;if(c|0){b=k[f>>2]|0;if((b|0)!=(c|0))k[f>>2]=b+(~((b+-4-e|0)>>>2)<<2);ggb(c)}e=g;if(g|0){b=k[h>>2]|0;if((b|0)!=(g|0))k[h>>2]=b+(~((b+-4-e|0)>>>2)<<2);ggb(g)}while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}l=e+4|0;k[l>>2]=1;k[e>>2]=141484;k[e+8>>2]=m;k[a>>2]=e;k[a+4>>2]=m;k[l>>2]=(k[l>>2]|0)+1;a=k[l>>2]|0;k[l>>2]=a+-1;if((a|0)!=1){r=n;return}Uh[k[(k[e>>2]|0)+8>>2]&2047](e);r=n;return}function vu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0;f=r;r=r+16|0;e=f;ah[a&31](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];c=e+4|0;k[a+4>>2]=k[c>>2];k[e>>2]=0;k[c>>2]=0;r=f;return a|0}function wu(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+16|0;m=p+4|0;o=p;while(1){i=fgb(56)|0;if(i|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){i=0;break}Qh[g&7]()}k[m>>2]=0;n=m+4|0;k[n>>2]=0;k[m+8>>2]=0;g=f+4|0;h=(k[g>>2]|0)-(k[f>>2]|0)>>2;if(h|0?(eQ(m,h),j=k[f>>2]|0,l=(k[g>>2]|0)-j|0,(l|0)>0):0){f=k[n>>2]|0;upb(f|0,j|0,l|0)|0;k[n>>2]=f+(l>>2<<2)}k[i>>2]=141412;$Ua(i,b,c,d,e,m);k[i+4>>2]=20;k[i+8>>2]=3;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[g+4>>2]=1;k[g>>2]=141484;k[g+8>>2]=i;j=g;k[o>>2]=j;h=k[m>>2]|0;b=h;if(h|0){c=k[n>>2]|0;if((c|0)!=(h|0))k[n>>2]=c+(~((c+-4-b|0)>>>2)<<2);ggb(h)}k[a>>2]=j;k[a+4>>2]=i;if(g){g=g+4|0;k[g>>2]=(k[g>>2]|0)+1;g=k[o>>2]|0}if(!g){k[o>>2]=0;r=p;return}n=g+4|0;a=k[n>>2]|0;k[n>>2]=a+-1;if((a|0)!=1){k[o>>2]=0;r=p;return}Uh[k[(k[g>>2]|0)+8>>2]&2047](g);k[o>>2]=0;r=p;return}function xu(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;var g=0,h=0;h=r;r=r+16|0;g=h;_g[a&7](g,b,c,d,e,f);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[g>>2];f=g+4|0;k[a+4>>2]=k[f>>2];k[g>>2]=0;k[f>>2]=0;r=h;return a|0}function yu(a){a=a|0;return k[a+4>>2]|0}function zu(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function Au(a){a=a|0;return 0}function Bu(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function Cu(a){a=a|0;return 7272}function Du(a){a=a|0;var b=0,c=0,d=0;if(!a)return;d=a+820|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+816>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+800|0;c=a+788|0;d=a+824|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+828>>2]|0;if(!((b|0)==(a+832|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+764|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+760>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+744|0;c=a+732|0;d=a+768|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+772>>2]|0;if(!((b|0)==(a+776|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+708|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+704>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+688|0;c=a+676|0;d=a+712|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+716>>2]|0;if(!((b|0)==(a+720|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+652|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+648>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+632|0;c=a+620|0;d=a+656|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+660>>2]|0;if(!((b|0)==(a+664|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+596|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+592>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+576|0;c=a+564|0;d=a+600|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+604>>2]|0;if(!((b|0)==(a+608|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+540|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+536>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+520|0;c=a+508|0;d=a+544|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+548>>2]|0;if(!((b|0)==(a+552|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+484|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+480>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+464|0;c=a+452|0;d=a+488|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+492>>2]|0;if(!((b|0)==(a+496|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+428|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+424>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+408|0;c=a+396|0;d=a+432|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+436>>2]|0;if(!((b|0)==(a+440|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+372|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+368>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+352|0;c=a+340|0;d=a+376|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+380>>2]|0;if(!((b|0)==(a+384|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+316|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+312>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;b=a+296|0;c=a+284|0;d=a+320|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+324>>2]|0;if(!((b|0)==(a+328|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+260|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+256>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;b=a+240|0;c=a+228|0;d=a+264|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+268>>2]|0;if(!((b|0)==(a+272|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+204|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+200>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;b=a+184|0;c=a+172|0;d=a+208|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+212>>2]|0;if(!((b|0)==(a+216|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+148|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+144>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;b=a+128|0;c=a+116|0;d=a+152|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+156>>2]|0;if(!((b|0)==(a+160|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+92|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+88>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;b=a+72|0;c=a+60|0;d=a+96|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+100>>2]|0;if(!((b|0)==(a+104|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+36|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;b=a+16|0;c=a+4|0;d=a+40|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+44>>2]|0;if(!((b|0)==(a+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);ggb(a);return}function Eu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=r;r=r+272|0;g=n;h=n+256|0;i=n+240|0;j=n+224|0;l=a+112|0;m=a+56|0;a1(g,l,m);f=k[g>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,g,a,-1);XN(g);if(k[b+16>>2]|0){e=k[b+4>>2]|0;if((e|0)<3)c=aa(k[b+12>>2]|0,k[b+8>>2]|0)|0;else{f=k[b+40>>2]|0;d=0;c=1;do{c=aa(k[f+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(e|0))}if(c|0){a1(g,a+168|0,b);b=k[g>>2]|0;Ph[k[(k[b>>2]|0)+24>>2]&511](b,g,a);XN(g)}}f=a+560|0;b=a+504|0;a1(g,l,b);e=k[g>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,g,f,-1);XN(g);k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=f;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=l;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=a+280;l=a+392|0;f=j+4|0;e=f+4|0;k[e>>2]=0;k[e+4>>2]=0;k[j>>2]=33619968;k[f>>2]=l;s_(g,h,1.0,i,1.0,j,2);j=g+4|0;i=j+4|0;k[i>>2]=0;k[i+4>>2]=0;k[g>>2]=33619968;k[j>>2]=m;mY(a,g);m=g+4|0;j=m+4|0;k[j>>2]=0;k[j+4>>2]=0;k[g>>2]=33619968;k[m>>2]=b;mY(l,g);r=n;return a|0}function Fu(a,b,c){a=a|0;b=b|0;c=c|0;b=Hh[k[a>>2]&511](b,c)|0;while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}AF(a,b);return a|0}function Gu(){var a=0,b=0,c=0,d=0,e=0;while(1){a=fgb(840)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=1124007936;b=a+8|0;c=a+40|0;d=a+4|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+48|0;k[a+44>>2]=b;k[a+52>>2]=0;k[b>>2]=0;k[a+56>>2]=1124007936;b=a+64|0;c=a+96|0;d=a+60|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+104|0;k[a+100>>2]=b;k[a+108>>2]=0;k[b>>2]=0;k[a+112>>2]=1124007936;b=a+120|0;c=a+152|0;d=a+116|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+160|0;k[a+156>>2]=b;k[a+164>>2]=0;k[b>>2]=0;k[a+168>>2]=1124007936;b=a+176|0;c=a+208|0;d=a+172|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+216|0;k[a+212>>2]=b;k[a+220>>2]=0;k[b>>2]=0;k[a+224>>2]=1124007936;b=a+232|0;c=a+264|0;d=a+228|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+272|0;k[a+268>>2]=b;k[a+276>>2]=0;k[b>>2]=0;k[a+280>>2]=1124007936;b=a+288|0;c=a+320|0;d=a+284|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+328|0;k[a+324>>2]=b;k[a+332>>2]=0;k[b>>2]=0;k[a+336>>2]=1124007936;b=a+344|0;c=a+376|0;d=a+340|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+384|0;k[a+380>>2]=b;k[a+388>>2]=0;k[b>>2]=0;k[a+392>>2]=1124007936;b=a+400|0;c=a+432|0;d=a+396|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+440|0;k[a+436>>2]=b;k[a+444>>2]=0;k[b>>2]=0;k[a+448>>2]=1124007936;b=a+456|0;c=a+488|0;d=a+452|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+496|0;k[a+492>>2]=b;k[a+500>>2]=0;k[b>>2]=0;k[a+504>>2]=1124007936;b=a+512|0;c=a+544|0;d=a+508|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+552|0;k[a+548>>2]=b;k[a+556>>2]=0;k[b>>2]=0;k[a+560>>2]=1124007936;b=a+568|0;c=a+600|0;d=a+564|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+608|0;k[a+604>>2]=b;k[a+612>>2]=0;k[b>>2]=0;k[a+616>>2]=1124007936;b=a+624|0;c=a+656|0;d=a+620|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+664|0;k[a+660>>2]=b;k[a+668>>2]=0;k[b>>2]=0;k[a+672>>2]=1124007936;b=a+680|0;c=a+712|0;d=a+676|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+720|0;k[a+716>>2]=b;k[a+724>>2]=0;k[b>>2]=0;k[a+728>>2]=1124007936;b=a+736|0;c=a+768|0;d=a+732|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+776|0;k[a+772>>2]=b;k[a+780>>2]=0;k[b>>2]=0;k[a+784>>2]=1124007936;b=a+792|0;c=a+824|0;d=a+788|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;e=a+832|0;k[a+828>>2]=e;k[a+836>>2]=0;k[e>>2]=0;return a|0}function Hu(a){a=a|0;return Nh[a&127]()|0}function Iu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=r;r=r+240|0;O=P+224|0;K=P;while(1){e=fgb(840)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}N=k[a>>2]|0;M=k[b>>2]|0;f=k[c>>2]|0;L=k[d>>2]|0;k[e>>2]=1124007936;a=e+8|0;b=e+40|0;I=e+4|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;d=e+48|0;k[e+44>>2]=d;k[e+52>>2]=0;k[d>>2]=0;d=e+56|0;k[d>>2]=1124007936;a=e+64|0;b=e+96|0;I=e+60|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;g=e+104|0;k[e+100>>2]=g;k[e+108>>2]=0;k[g>>2]=0;g=e+112|0;k[g>>2]=1124007936;a=e+120|0;b=e+152|0;I=e+116|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;F=e+160|0;k[e+156>>2]=F;k[e+164>>2]=0;k[F>>2]=0;F=e+168|0;k[F>>2]=1124007936;H=e+172|0;a=e+176|0;G=e+208|0;I=H;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[G>>2]=a;j=e+216|0;k[e+212>>2]=j;k[e+220>>2]=0;k[j>>2]=0;j=e+224|0;k[j>>2]=1124007936;a=e+232|0;b=e+264|0;I=e+228|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;h=e+272|0;k[e+268>>2]=h;k[e+276>>2]=0;k[h>>2]=0;h=e+280|0;k[h>>2]=1124007936;a=e+288|0;b=e+320|0;I=e+284|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;l=e+328|0;k[e+324>>2]=l;k[e+332>>2]=0;k[l>>2]=0;l=e+336|0;k[l>>2]=1124007936;a=e+344|0;b=e+376|0;I=e+340|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;m=e+384|0;k[e+380>>2]=m;k[e+388>>2]=0;k[m>>2]=0;m=e+392|0;k[m>>2]=1124007936;a=e+400|0;b=e+432|0;I=e+396|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;o=e+440|0;k[e+436>>2]=o;k[e+444>>2]=0;k[o>>2]=0;o=e+448|0;k[o>>2]=1124007936;a=e+456|0;b=e+488|0;I=e+452|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;n=e+496|0;k[e+492>>2]=n;k[e+500>>2]=0;k[n>>2]=0;n=e+504|0;k[n>>2]=1124007936;a=e+512|0;b=e+544|0;I=e+508|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;C=e+552|0;k[e+548>>2]=C;k[e+556>>2]=0;k[C>>2]=0;C=e+560|0;k[C>>2]=1124007936;D=e+564|0;E=e+568|0;a=e+600|0;I=D;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[a>>2]=E;z=e+608|0;k[e+604>>2]=z;k[e+612>>2]=0;k[z>>2]=0;z=e+616|0;k[z>>2]=1124007936;A=e+620|0;B=e+624|0;a=e+656|0;I=A;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[a>>2]=B;x=e+664|0;k[e+660>>2]=x;k[e+668>>2]=0;k[x>>2]=0;x=e+672|0;k[x>>2]=1124007936;y=e+676|0;w=e+680|0;a=e+712|0;I=y;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[a>>2]=w;t=e+720|0;k[e+716>>2]=t;k[e+724>>2]=0;k[t>>2]=0;t=e+728|0;k[t>>2]=1124007936;u=e+732|0;v=e+736|0;a=e+768|0;I=u;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[a>>2]=v;p=e+776|0;k[e+772>>2]=p;k[e+780>>2]=0;k[p>>2]=0;p=e+784|0;k[p>>2]=1124007936;q=e+788|0;s=e+792|0;a=e+824|0;I=q;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[a>>2]=s;J=e+832|0;k[e+828>>2]=J;k[e+836>>2]=0;k[J>>2]=0;if(!((N|0)>0&(M|0)>0)){k[O>>2]=0;a=O+4|0;k[a>>2]=0;b=ZT(24)|0;k[b>>2]=1;I=b+4|0;k[O>>2]=I;k[a>>2]=16;i[b+20>>0]=0;c=403210;J=I+16|0;do{i[I>>0]=i[c>>0]|0;I=I+1|0;c=c+1|0}while((I|0)<(J|0));Y8(-215,O,403227,403232,54);k[a>>2]=0;k[O>>2]=0;J=k[b>>2]|0;k[b>>2]=J+-1;if((J|0)==1)ggb(k[b+-4>>2]|0)}if((L+-5|0)>>>0>=2){k[O>>2]=0;a=O+4|0;k[a>>2]=0;b=ZT(40)|0;k[b>>2]=1;I=b+4|0;k[O>>2]=I;k[a>>2]=32;i[b+36>>0]=0;c=403298;J=I+32|0;do{i[I>>0]=i[c>>0]|0;I=I+1|0;c=c+1|0}while((I|0)<(J|0));Y8(-215,O,403227,403232,55);k[a>>2]=0;k[O>>2]=0;J=k[b>>2]|0;k[b>>2]=J+-1;if((J|0)==1)ggb(k[b+-4>>2]|0)}c=(f|0)<0?0:f;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=1124007936;a=K+16|0;b=K+48|0;I=K+12|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+56|0;k[K+52>>2]=a;k[K+60>>2]=0;k[a>>2]=0;k[K+64>>2]=1124007936;a=K+72|0;b=K+104|0;I=K+68|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+112|0;k[K+108>>2]=a;k[K+116>>2]=0;k[a>>2]=0;k[K+120>>2]=1124007936;a=K+128|0;b=K+160|0;I=K+124|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;I=K+168|0;k[K+164>>2]=I;J=I+56|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[O>>2]=1;k[O+4>>2]=N;j1(K,48,O,L);a=k[K>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,K,e,-1);XN(K);k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=1124007936;a=K+16|0;b=K+48|0;I=K+12|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+56|0;k[K+52>>2]=a;k[K+60>>2]=0;k[a>>2]=0;k[K+64>>2]=1124007936;a=K+72|0;b=K+104|0;I=K+68|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+112|0;k[K+108>>2]=a;k[K+116>>2]=0;k[a>>2]=0;k[K+120>>2]=1124007936;a=K+128|0;b=K+160|0;I=K+124|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;I=K+168|0;k[K+164>>2]=I;J=I+56|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[O>>2]=1;k[O+4>>2]=N;j1(K,48,O,L);a=k[K>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,K,d,-1);XN(K);k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=1124007936;a=K+16|0;b=K+48|0;I=K+12|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+56|0;k[K+52>>2]=a;k[K+60>>2]=0;k[a>>2]=0;k[K+64>>2]=1124007936;a=K+72|0;b=K+104|0;I=K+68|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+112|0;k[K+108>>2]=a;k[K+116>>2]=0;k[a>>2]=0;k[K+120>>2]=1124007936;a=K+128|0;b=K+160|0;I=K+124|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;I=K+168|0;k[K+164>>2]=I;J=I+56|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[O>>2]=N;k[O+4>>2]=N;j1(K,73,O,L);a=k[K>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,K,g,-1);XN(K);k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=1124007936;a=K+16|0;b=K+48|0;I=K+12|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+56|0;k[K+52>>2]=a;k[K+60>>2]=0;k[a>>2]=0;k[K+64>>2]=1124007936;a=K+72|0;b=K+104|0;I=K+68|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+112|0;k[K+108>>2]=a;k[K+116>>2]=0;k[a>>2]=0;k[K+120>>2]=1124007936;a=K+128|0;b=K+160|0;I=K+124|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;I=K+168|0;k[K+164>>2]=I;J=I+56|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[O>>2]=N;k[O+4>>2]=N;j1(K,73,O,L);a=k[K>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,K,h,-1);XN(K);k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=1124007936;a=K+16|0;b=K+48|0;I=K+12|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+56|0;k[K+52>>2]=a;k[K+60>>2]=0;k[a>>2]=0;k[K+64>>2]=1124007936;a=K+72|0;b=K+104|0;I=K+68|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+112|0;k[K+108>>2]=a;k[K+116>>2]=0;k[a>>2]=0;k[K+120>>2]=1124007936;a=K+128|0;b=K+160|0;I=K+124|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;I=K+168|0;k[K+164>>2]=I;J=I+56|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[O>>2]=N;k[O+4>>2]=M;j1(K,48,O,L);a=k[K>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,K,j,-1);XN(K);k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=1124007936;a=K+16|0;b=K+48|0;I=K+12|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+56|0;k[K+52>>2]=a;k[K+60>>2]=0;k[a>>2]=0;k[K+64>>2]=1124007936;a=K+72|0;b=K+104|0;I=K+68|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+112|0;k[K+108>>2]=a;k[K+116>>2]=0;k[a>>2]=0;k[K+120>>2]=1124007936;a=K+128|0;b=K+160|0;I=K+124|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;I=K+168|0;k[K+164>>2]=I;J=I+56|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[O>>2]=M;k[O+4>>2]=M;j1(K,73,O,L);a=k[K>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,K,l,-1);XN(K);k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=1124007936;a=K+16|0;b=K+48|0;I=K+12|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+56|0;k[K+52>>2]=a;k[K+60>>2]=0;k[a>>2]=0;k[K+64>>2]=1124007936;a=K+72|0;b=K+104|0;I=K+68|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+112|0;k[K+108>>2]=a;k[K+116>>2]=0;k[a>>2]=0;k[K+120>>2]=1124007936;a=K+128|0;b=K+160|0;I=K+124|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;I=K+168|0;k[K+164>>2]=I;J=I+56|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[O>>2]=N;k[O+4>>2]=N;j1(K,48,O,L);a=k[K>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,K,m,-1);XN(K);k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=1124007936;a=K+16|0;b=K+48|0;I=K+12|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+56|0;k[K+52>>2]=a;k[K+60>>2]=0;k[a>>2]=0;k[K+64>>2]=1124007936;a=K+72|0;b=K+104|0;I=K+68|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+112|0;k[K+108>>2]=a;k[K+116>>2]=0;k[a>>2]=0;k[K+120>>2]=1124007936;a=K+128|0;b=K+160|0;I=K+124|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;I=K+168|0;k[K+164>>2]=I;J=I+56|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[O>>2]=N;k[O+4>>2]=N;j1(K,48,O,L);a=k[K>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,K,n,-1);XN(K);k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=1124007936;a=K+16|0;b=K+48|0;I=K+12|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+56|0;k[K+52>>2]=a;k[K+60>>2]=0;k[a>>2]=0;k[K+64>>2]=1124007936;a=K+72|0;b=K+104|0;I=K+68|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+112|0;k[K+108>>2]=a;k[K+116>>2]=0;k[a>>2]=0;k[K+120>>2]=1124007936;a=K+128|0;b=K+160|0;I=K+124|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;I=K+168|0;k[K+164>>2]=I;J=I+56|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[O>>2]=M;k[O+4>>2]=N;j1(K,48,O,L);J=k[K>>2]|0;dh[k[(k[J>>2]|0)+12>>2]&255](J,K,o,-1);XN(K);if((c|0)<=0){c=e+204|0;a=k[c>>2]|0;if(a|0?(J=a+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[e+200>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;K=e+184|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[H>>2]|0)>0){b=k[G>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[H>>2]|0))}}else{k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=1124007936;a=K+16|0;b=K+48|0;I=K+12|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+56|0;k[K+52>>2]=a;k[K+60>>2]=0;k[a>>2]=0;k[K+64>>2]=1124007936;a=K+72|0;b=K+104|0;I=K+68|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;a=K+112|0;k[K+108>>2]=a;k[K+116>>2]=0;k[a>>2]=0;k[K+120>>2]=1124007936;a=K+128|0;b=K+160|0;I=K+124|0;J=I+36|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[b>>2]=a;I=K+168|0;k[K+164>>2]=I;J=I+56|0;do{k[I>>2]=0;I=I+4|0}while((I|0)<(J|0));k[O>>2]=c;k[O+4>>2]=N;j1(K,48,O,L);J=k[K>>2]|0;dh[k[(k[J>>2]|0)+12>>2]&255](J,K,F,-1);XN(K)}a=L&4095;if(!(((((k[D>>2]|0)<3?(k[E>>2]|0)==(N|0):0)?(k[e+572>>2]|0)==(N|0):0)?(k[C>>2]&4095|0)==(a|0):0)?(k[e+576>>2]|0)!=0:0)){k[O>>2]=N;k[O+4>>2]=N;G1(C,2,O,a)}if(!(((((k[A>>2]|0)<3?(k[B>>2]|0)==(M|0):0)?(k[e+628>>2]|0)==(N|0):0)?(k[z>>2]&4095|0)==(a|0):0)?(k[e+632>>2]|0)!=0:0)){k[O>>2]=M;k[O+4>>2]=N;G1(z,2,O,a)}if(!(((((k[y>>2]|0)<3?(k[w>>2]|0)==(M|0):0)?(k[e+684>>2]|0)==(M|0):0)?(k[x>>2]&4095|0)==(a|0):0)?(k[e+688>>2]|0)!=0:0)){k[O>>2]=M;k[O+4>>2]=M;G1(x,2,O,a)}if(!(((((k[u>>2]|0)<3?(k[v>>2]|0)==(M|0):0)?(k[e+740>>2]|0)==(N|0):0)?(k[t>>2]&4095|0)==(a|0):0)?(k[e+744>>2]|0)!=0:0)){k[O>>2]=M;k[O+4>>2]=N;G1(t,2,O,a)}if(((((k[q>>2]|0)<3?(k[s>>2]|0)==(M|0):0)?(k[e+796>>2]|0)==1:0)?(k[p>>2]&4095|0)==(a|0):0)?k[e+800>>2]|0:0){r=P;return e|0}k[O>>2]=M;k[O+4>>2]=1;G1(p,2,O,a);r=P;return e|0}function Ju(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+16|0;j=f+12|0;i=f+8|0;h=f+4|0;g=f;k[j>>2]=b;k[i>>2]=c;k[h>>2]=d;k[g>>2]=e;e=Dg[a&127](j,i,h,g)|0;r=f;return e|0}function Ku(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;n=r;r=r+480|0;e=n+224|0;f=n;h=n+464|0;c=n+448|0;i=a+616|0;j=a+224|0;l=a+392|0;a1(e,j,l);g=k[e>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,e,i,-1);XN(e);k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=i;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=j;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=a+336;g=a+672|0;d=c+4|0;m=d+4|0;k[m>>2]=0;k[m+4>>2]=0;k[c>>2]=33619968;k[d>>2]=g;s_(e,f,1.0,h,1.0,c,2);k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=g;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=i;g=a+728|0;c=h+4|0;d=c+4|0;k[d>>2]=0;k[d+4>>2]=0;k[h>>2]=33619968;k[c>>2]=g;NZ(e,f,h,1)|0;h=a+448|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=1124007936;c=e+16|0;d=e+48|0;m=e+12|0;o=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(o|0));k[d>>2]=c;c=e+56|0;k[e+52>>2]=c;k[e+60>>2]=0;k[c>>2]=0;k[e+64>>2]=1124007936;c=e+72|0;d=e+104|0;m=e+68|0;o=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(o|0));k[d>>2]=c;c=e+112|0;k[e+108>>2]=c;k[e+116>>2]=0;k[c>>2]=0;k[e+120>>2]=1124007936;c=e+128|0;d=e+160|0;m=e+124|0;o=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(o|0));k[d>>2]=c;m=e+168|0;k[e+164>>2]=m;o=m+56|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(o|0));y0(e,g,1.0);m=k[e>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,e,h,-1);XN(e);m=a+784|0;a1(f,j,a);_0(e,b,f);o=k[e>>2]|0;dh[k[(k[o>>2]|0)+12>>2]&255](o,e,m,-1);XN(e);XN(f);o=a+56|0;a1(f,h,m);X0(e,a,f);m=k[e>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,e,o,-1);XN(e);XN(f);a1(f,h,i);_0(e,l,f);m=k[e>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,e,a+504|0,-1);XN(e);XN(f);r=n;return o|0}function Lu(a,b){a=a|0;b=b|0;b=b+(k[a>>2]|0)|0;while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}AF(a,b);return a|0}function Mu(a,b,c){a=a|0;b=b|0;c=c|0;KG(b+(k[a>>2]|0)|0,c)|0;return}function Nu(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Ou(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Pu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0;while(1){e=fgb(24)|0;if(e|0){f=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){f=0;break}Qh[e&7]()}k[f>>2]=149364;e=f+16|0;g=f+20|0;k[f+4>>2]=b;k[f+8>>2]=c;o[f+12>>2]=d;k[g>>2]=0;k[e>>2]=0;b=ZT(32)|0;k[b>>2]=1;k[e>>2]=b+4;k[g>>2]=26;i[b+30>>0]=0;e=k[e>>2]|0;b=391695;c=e+26|0;do{i[e>>0]=i[b>>0]|0;e=e+1|0;b=b+1|0}while((e|0)<(c|0));while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[e+4>>2]=1;k[e>>2]=149572;k[e+8>>2]=f;k[a>>2]=e;k[a+4>>2]=f;return}function Qu(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+52>>2]&1023](a,b);return}function Ru(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Su(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Tu(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Uu(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Vu(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+44>>2]&255](a,b);return}function Wu(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function Xu(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0;while(1){c=fgb(144)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=149800;k[c+20>>2]=1124007936;e=c+28|0;d=c+60|0;f=c+24|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=e;d=c+68|0;k[c+64>>2]=d;k[c+72>>2]=0;k[d>>2]=0;k[c+76>>2]=1124007936;d=c+84|0;e=c+116|0;f=c+80|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;g=c+124|0;k[c+120>>2]=g;f=c+132|0;k[g>>2]=0;k[g+4>>2]=0;p[c+8>>3]=b;g=c+136|0;k[g>>2]=0;k[f>>2]=0;d=ZT(28)|0;k[d>>2]=1;k[f>>2]=d+4;k[g>>2]=20;i[d+24>>0]=0;f=k[f>>2]|0;d=393095;g=f+20|0;do{i[f>>0]=i[d>>0]|0;f=f+1|0;d=d+1|0}while((f|0)<(g|0));i[c+4>>0]=0;while(1){d=fgb(16)|0;if(d|0){e=9;break}d=k[207666]|0;k[207666]=d+0;if(!d){d=0;e=9;break}Qh[d&7]()}if((e|0)==9){k[d+4>>2]=1;k[d>>2]=149860;k[d+8>>2]=c;k[a>>2]=d;k[a+4>>2]=c;return}}function Yu(a,b){a=a|0;b=+b;var c=0,d=0,e=0;d=r;r=r+16|0;c=d;gh[a&255](c,b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[c>>2];e=c+4|0;k[a+4>>2]=k[e>>2];k[c>>2]=0;k[e>>2]=0;r=d;return a|0}function Zu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function _u(a){a=a|0;return k[a+4>>2]|0}function $u(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function av(a){a=a|0;return 0}function bv(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function cv(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function dv(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function ev(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function fv(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+36>>2]&1023](a,b);return}function gv(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function hv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=r;r=r+16|0;d=e;c=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](d,a);while(1){c=fgb(8)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[d>>2];f=d+4|0;k[c+4>>2]=k[f>>2];k[d>>2]=0;k[f>>2]=0;r=e;return c|0}function iv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=r;r=r+16|0;d=e;c=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](d,a);while(1){c=fgb(8)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[d>>2];f=d+4|0;k[c+4>>2]=k[f>>2];k[d>>2]=0;k[f>>2]=0;r=e;return c|0}function jv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=r;r=r+16|0;c=f;d=k[(k[a>>2]|0)+132>>2]|0;e=k[b>>2]|0;k[c>>2]=e;k[c+4>>2]=k[b+4>>2];if(e|0){e=e+4|0;k[e>>2]=(k[e>>2]|0)+1}jh[d&1023](a,c);a=k[c>>2]|0;if(!a){r=f;return}d=a+4|0;e=k[d>>2]|0;k[d>>2]=e+-1;if((e|0)!=1){r=f;return}Uh[k[(k[a>>2]|0)+8>>2]&2047](a);r=f;return}function kv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=r;r=r+16|0;e=f;a=k[a>>2]|0;d=k[c>>2]|0;k[e>>2]=d;k[e+4>>2]=k[c+4>>2];if(d|0){c=d+4|0;k[c>>2]=(k[c>>2]|0)+1}jh[a&1023](b,e);a=k[e>>2]|0;if(!a){r=f;return}c=a+4|0;e=k[c>>2]|0;k[c>>2]=e+-1;if((e|0)!=1){r=f;return}Uh[k[(k[a>>2]|0)+8>>2]&2047](a);r=f;return}function lv(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function mv(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+76>>2]&255](a,b);return}function nv(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function ov(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+84>>2]&255](a,b);return}function pv(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+68>>2]&1023](a,b);return}function qv(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function rv(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+92>>2]&255](a,b);return}function sv(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+124>>2]&255](a,b);return}function tv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=r;r=r+16|0;c=f;d=k[(k[a>>2]|0)+116>>2]|0;e=k[b>>2]|0;k[c>>2]=e;k[c+4>>2]=k[b+4>>2];if(e|0){e=e+4|0;k[e>>2]=(k[e>>2]|0)+1}jh[d&1023](a,c);a=k[c>>2]|0;if(!a){r=f;return}d=a+4|0;e=k[d>>2]|0;k[d>>2]=e+-1;if((e|0)!=1){r=f;return}Uh[k[(k[a>>2]|0)+8>>2]&2047](a);r=f;return}function uv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=r;r=r+16|0;e=f;a=k[a>>2]|0;d=k[c>>2]|0;k[e>>2]=d;k[e+4>>2]=k[c+4>>2];if(d|0){c=d+4|0;k[c>>2]=(k[c>>2]|0)+1}jh[a&1023](b,e);a=k[e>>2]|0;if(!a){r=f;return}c=a+4|0;e=k[c>>2]|0;k[c>>2]=e+-1;if((e|0)!=1){r=f;return}Uh[k[(k[a>>2]|0)+8>>2]&2047](a);r=f;return}function vv(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+60>>2]&255](a,b);return}function wv(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function xv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=r;r=r+32|0;f=d+16|0;e=d;g=k[(k[a>>2]|0)+104>>2]|0;h=f+4+4|0;k[h>>2]=0;k[h+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=b;b=e+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=c;Ph[g&511](a,f,e);r=d;return}function yv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[k[a>>2]&511](b,c,d);return}function zv(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;while(1){j=fgb(184)|0;if(j|0){u=j;break}j=k[207666]|0;k[207666]=j+0;if(!j){u=0;break}Qh[j&7]()}k[u>>2]=149632;s=u+32|0;t=u+36|0;q=u+40|0;r=u+44|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[u+48>>2]=1124007936;j=u+56|0;l=u+88|0;m=u+52|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;j=u+96|0;k[u+92>>2]=j;k[u+100>>2]=0;k[j>>2]=0;k[u+104>>2]=1124007936;j=u+112|0;l=u+144|0;m=u+108|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[l>>2]=j;n=u+152|0;k[u+148>>2]=n;k[u+156>>2]=0;k[n>>2]=0;n=u+176|0;k[n>>2]=0;p=u+180|0;k[p>>2]=0;k[u+4>>2]=b;k[u+8>>2]=c;o[u+12>>2]=d;o[u+16>>2]=e;i[u+20>>0]=0;m=k[g>>2]|0;l=k[g+4>>2]|0;if(m){j=m+4|0;k[j>>2]=(k[j>>2]|0)+1;j=k[q>>2]|0;k[q>>2]=m;k[r>>2]=l;if(j|0?(r=j+4|0,g=k[r>>2]|0,k[r>>2]=g+-1,(g|0)==1):0)Uh[k[(k[j>>2]|0)+8>>2]&2047](j)}else{k[q>>2]=0;k[r>>2]=l}k[u+28>>2]=f;m=k[h>>2]|0;j=k[h+4>>2]|0;if(m|0){h=m+4|0;k[h>>2]=(k[h>>2]|0)+1}l=k[s>>2]|0;k[s>>2]=m;k[t>>2]=j;if(l|0?(t=l+4|0,h=k[t>>2]|0,k[t>>2]=h+-1,(h|0)==1):0)Uh[k[(k[l>>2]|0)+8>>2]&2047](l);o[u+160>>2]=.30000001192092896;o[u+164>>2]=0.0;o[u+168>>2]=1.0;o[u+172>>2]=10.0;j=k[n>>2]|0;k[p>>2]=0;k[n>>2]=0;if(j|0?(t=j+-4|0,h=k[t>>2]|0,k[t>>2]=h+-1,(h|0)==1):0)ggb(k[j+-8>>2]|0);m=ZT(32)|0;k[m>>2]=1;k[n>>2]=m+4;k[p>>2]=26;i[m+30>>0]=0;m=k[n>>2]|0;j=392628;n=m+26|0;do{i[m>>0]=i[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(n|0));while(1){j=fgb(16)|0;if(j|0){l=22;break}j=k[207666]|0;k[207666]=j+0;if(!j){j=0;l=22;break}Qh[j&7]()}if((l|0)==22){k[j+4>>2]=1;k[j>>2]=149780;k[j+8>>2]=u;k[a>>2]=j;k[a+4>>2]=u;return}}function Av(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;var i=0,j=0;j=r;r=r+16|0;i=j;ai[a&3](i,b,c,d,e,f,g,h);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];h=i+4|0;k[a+4>>2]=k[h>>2];k[i>>2]=0;k[h>>2]=0;r=j;return a|0}function Bv(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+52>>2]&255](a,b);return}function Cv(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+108>>2]&1023](a,b);return}function Dv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=r;r=r+32|0;f=d+16|0;e=d;g=k[(k[a>>2]|0)+100>>2]|0;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=c;Ph[g&511](a,f,e);r=d;return}function Ev(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[k[a>>2]&511](b,c,d);return}function Fv(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+44>>2]&1023](a,b);return}function Gv(a){a=a|0;return k[a+4>>2]|0}function Hv(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function Iv(a){a=a|0;return 0}function Jv(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function Kv(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Lv(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Mv(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+64>>2]&1023](a,b);return}function Nv(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Ov(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+96>>2]&1023](a,b);return}function Pv(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Qv(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Rv(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+88>>2]&1023](a,b);return}function Sv(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Tv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;var h=0,j=0;while(1){h=fgb(24)|0;if(h|0){j=h;break}h=k[207666]|0;k[207666]=h+0;if(!h){j=0;break}Qh[h&7]()}k[j>>2]=142144;i[j+4>>0]=b&1;i[j+5>>0]=c&1;o[j+8>>2]=d;k[j+12>>2]=e;k[j+16>>2]=f;k[j+20>>2]=g;while(1){h=fgb(16)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}g=h+4|0;k[g>>2]=1;k[h>>2]=142264;k[h+8>>2]=j;k[a>>2]=h;k[a+4>>2]=j;k[g>>2]=(k[g>>2]|0)+1;a=k[g>>2]|0;k[g>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[h>>2]|0)+8>>2]&2047](h);return}function Uv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;var h=0,i=0;i=r;r=r+16|0;h=i;Qf[a&3](h,b,c,d,e,f,g);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[h>>2];g=h+4|0;k[a+4>>2]=k[g>>2];k[h>>2]=0;k[g>>2]=0;r=i;return a|0}function Vv(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+72>>2]&1023](a,b);return}function Wv(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+104>>2]&1023](a,b);return}function Xv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function Yv(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+80>>2]&255](a,b);return}function Zv(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function _v(a){a=a|0;return k[a+4>>2]|0}function $v(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function aw(a){a=a|0;return 0}function bw(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function cw(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function dw(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function ew(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=r;r=r+48|0;h=e+32|0;g=e+16|0;f=e;i=k[(k[a>>2]|0)+32>>2]|0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=17104896;k[h+4>>2]=b;b=g+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=c;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=d;dh[i&255](a,h,g,f);r=e;return}function fw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function gw(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function hw(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function iw(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+104>>2]&1023](a,b);return}function jw(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function kw(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+64>>2]&1023](a,b);return}function lw(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function mw(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+96>>2]&1023](a,b);return}function nw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function ow(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;var i=0,j=0;while(1){i=fgb(32)|0;if(i|0){j=i;break}i=k[207666]|0;k[207666]=i+0;if(!i){j=0;break}Qh[i&7]()}k[j>>2]=141032;k[j+4>>2]=b;k[j+8>>2]=d;k[j+12>>2]=c;o[j+16>>2]=e;k[j+20>>2]=f;k[j+24>>2]=g;k[j+28>>2]=h;while(1){i=fgb(16)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}h=i+4|0;k[h>>2]=1;k[i>>2]=141160;k[i+8>>2]=j;k[a>>2]=i;k[a+4>>2]=j;k[h>>2]=(k[h>>2]|0)+1;a=k[h>>2]|0;k[h>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[i>>2]|0)+8>>2]&2047](i);return}function pw(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;var i=0,j=0;j=r;r=r+16|0;i=j;Of[a&3](i,b,c,d,e,f,g,h);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];h=i+4|0;k[a+4>>2]=k[h>>2];k[i>>2]=0;k[h>>2]=0;r=j;return a|0}function qw(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+80>>2]&1023](a,b);return}function rw(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+88>>2]&255](a,b);return}function sw(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function tw(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+72>>2]&1023](a,b);return}function uw(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+112>>2]&1023](a,b);return}function vw(a){a=a|0;return k[a+4>>2]|0}function ww(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function xw(a){a=a|0;return 0}function yw(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function zw(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Aw(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Bw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=r;r=r+32|0;g=e+16|0;f=e;h=k[(k[a>>2]|0)+32>>2]|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=d;dh[h&255](a,g,c,f);r=e;return}function Cw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function Dw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=r;r=r+32|0;g=e+16|0;f=e;h=k[(k[a>>2]|0)+40>>2]|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;b=f+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=d;dh[h&255](a,g,c,f);r=e;return}function Ew(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function Fw(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Gw(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0;g=r;r=r+48|0;j=g+32|0;i=g+16|0;h=g;l=k[(k[a>>2]|0)+48>>2]|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=b;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=c;c=h+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=e;Lg[l&255](a,j,i,d,h,f);r=g;return}function Hw(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Lg[k[a>>2]&255](b,c,d,e,f,g);return}function Iw(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Jw(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Kw(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Lw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+32|0;f=l+8|0;j=l;g=k[(k[a>>2]|0)+24>>2]|0;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;k[j>>2]=0;h=j+4|0;k[h>>2]=0;b=c+11|0;d=i[b>>0]|0;e=d<<24>>24<0;if((e?k[c+4>>2]|0:d&255)|0){e=e?k[c+4>>2]|0:d&255;d=ZT(e+8&-4)|0;k[d>>2]=1;d=d+4|0;k[j>>2]=d;k[h>>2]=e;i[d+e>>0]=0;upb(k[j>>2]|0,((i[b>>0]|0)<0?k[c>>2]|0:c)|0,e|0)|0}b=ci[g&255](a,f,j)|0;d=k[j>>2]|0;k[h>>2]=0;k[j>>2]=0;if(!d){r=l;return b|0}h=d+-4|0;j=k[h>>2]|0;k[h>>2]=j+-1;if((j|0)!=1){r=l;return b|0}ggb(k[d+-8>>2]|0);r=l;return b|0}function Mw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;h=k[a>>2]|0;f=d+4|0;g=k[d>>2]|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;if(g>>>0>4294967279)hob();if(g>>>0<11){i[j+11>>0]=g;if(!g)a=j;else{a=j;e=10}}else{e=g+16&-16;d=(e|0)==0?1:e;while(1){a=fgb(d)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[j>>2]=a;k[j+8>>2]=e|-2147483648;k[j+4>>2]=g;e=10}if((e|0)==10)upb(a|0,f|0,g|0)|0;i[a+g>>0]=0;a=ci[h&255](b,c,j)|0;if((i[j+11>>0]|0)>=0){r=l;return a|0}ggb(k[j>>2]|0);r=l;return a|0}function Nw(){var a=0;while(1){a=fgb(20)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=93156;k[a+16>>2]=0;k[a+12>>2]=5;k[a+8>>2]=0;k[a+4>>2]=1;return a|0}function Ow(a){a=a|0;return Nh[a&127]()|0}function Pw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){d=fgb(20)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}c=k[c>>2]|0;k[d>>2]=93156;k[d+16>>2]=0;k[d+12>>2]=5;k[d+8>>2]=0;k[d+4>>2]=1;OHa(d,a,b,c);return d|0}function Qw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=r;r=r+16|0;f=e;k[f>>2]=d;d=ci[a&255](b,c,f)|0;r=e;return d|0}function Rw(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;h=r;r=r+48|0;l=h+32|0;j=h+16|0;i=h;m=k[(k[a>>2]|0)+16>>2]|0;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=b;b=j+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=c;c=i+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=d;g=oi[m&3](a,l,j,i,e,f,g)|0;r=h;return g|0}function Sw(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;return oi[k[a>>2]&3](b,c,d,e,f,g,h)|0}function Tw(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Uw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+16|0;f=e;g=k[(k[a>>2]|0)+8>>2]|0;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;dh[g&255](a,f,c,d);r=e;return}function Vw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function Ww(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Xw(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;Uh[d&2047](a);return}else{d=k[(k[a>>2]|0)+c>>2]|0;Uh[d&2047](a);return}}function Yw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;g=j;c=k[(k[a>>2]|0)+20>>2]|0;k[g>>2]=0;h=g+4|0;k[h>>2]=0;d=b+11|0;e=i[d>>0]|0;f=e<<24>>24<0;if((f?k[b+4>>2]|0:e&255)|0){f=f?k[b+4>>2]|0:e&255;e=ZT(f+8&-4)|0;k[e>>2]=1;e=e+4|0;k[g>>2]=e;k[h>>2]=f;i[e+f>>0]=0;upb(k[g>>2]|0,((i[d>>0]|0)<0?k[b>>2]|0:b)|0,f|0)|0}jh[c&1023](a,g);a=k[g>>2]|0;k[h>>2]=0;k[g>>2]=0;if(!a){r=j;return}g=a+-4|0;h=k[g>>2]|0;k[g>>2]=h+-1;if((h|0)!=1){r=j;return}ggb(k[a+-8>>2]|0);r=j;return}function Zw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;h=j;g=k[a>>2]|0;e=c+4|0;f=k[c>>2]|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;if(f>>>0>4294967279)hob();if(f>>>0<11){i[h+11>>0]=f;if(!f)a=h;else{a=h;d=10}}else{d=f+16&-16;c=(d|0)==0?1:d;while(1){a=fgb(c)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[h>>2]=a;k[h+8>>2]=d|-2147483648;k[h+4>>2]=f;d=10}if((d|0)==10)upb(a|0,e|0,f|0)|0;i[a+f>>0]=0;jh[g&1023](b,h);if((i[h+11>>0]|0)>=0){r=j;return}ggb(k[h>>2]|0);r=j;return}function _w(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0;g=r;r=r+48|0;j=g+32|0;i=g+16|0;h=g;l=k[(k[a>>2]|0)+12>>2]|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=b;b=i+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=c;c=h+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=d;Lg[l&255](a,j,i,h,e,f);r=g;return}function $w(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Lg[k[a>>2]&255](b,c,d,e,f,g);return}function ax(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function bx(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function cx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0,j=0,l=0;g=r;r=r+48|0;j=g+32|0;i=g+16|0;h=g;l=k[(k[a>>2]|0)+60>>2]|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=b;b=i+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=c;c=h+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=d;f=+hi[l&15](a,j,i,h,e);r=g;return +f}function dx(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return +(+hi[k[a>>2]&15](b,c,d,e,f))}function ex(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];d=b+4|0;k[a+4>>2]=k[d>>2];k[b>>2]=0;k[d>>2]=0;r=c;return a|0}function fx(a){a=a|0;return k[a+4>>2]|0}
function gx(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function hx(a){a=a|0;return 0}function ix(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function jx(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function kx(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function lx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0;f=r;r=r+64|0;j=f+48|0;i=f+32|0;h=f+16|0;g=f;l=k[(k[a>>2]|0)+32>>2]|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=17104896;k[j+4>>2]=b;b=i+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=c;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=d;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=e;eh[l&255](a,j,i,h,g);r=f;return}function mx(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[k[a>>2]&255](b,c,d,e,f);return}function nx(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function ox(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function px(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0;f=r;r=r+64|0;j=f+48|0;i=f+32|0;h=f+16|0;g=f;l=k[(k[a>>2]|0)+32>>2]|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=17104896;k[j+4>>2]=b;b=i+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=c;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=d;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=e;eh[l&255](a,j,i,h,g);r=f;return}function qx(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[k[a>>2]&255](b,c,d,e,f);return}function rx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=r;r=r+48|0;h=e+32|0;g=e+16|0;f=e;i=k[(k[a>>2]|0)+36>>2]|0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=17104896;k[h+4>>2]=b;b=g+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=c;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=d;dh[i&255](a,h,g,f);r=e;return}function sx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function tx(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];d=b+4|0;k[a+4>>2]=k[d>>2];k[b>>2]=0;k[d>>2]=0;r=c;return a|0}function ux(a){a=a|0;return k[a+4>>2]|0}function vx(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function wx(a){a=a|0;return 0}function xx(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function yx(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function zx(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Ax(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+56>>2]&1023](a,b);return}function Bx(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Cx(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Dx(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0,g=0,h=0;while(1){e=fgb(80)|0;if(e|0){h=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){h=0;break}Qh[e&7]()}k[h>>2]=150004;e=h+4|0;k[e>>2]=0;g=h+8|0;k[g>>2]=0;f=ZT(24)|0;k[f>>2]=1;k[e>>2]=f+4;k[g>>2]=16;i[f+20>>0]=0;e=k[e>>2]|0;f=393607;g=e+16|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));k[h+12>>2]=b;o[h+16>>2]=c;i[h+20>>0]=d&1;X2a(h+24|0);while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}d=e+4|0;k[d>>2]=1;k[e>>2]=149984;k[e+8>>2]=h;k[a>>2]=e;k[a+4>>2]=h;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[e>>2]|0)+8>>2]&2047](e);return}function Ex(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0;f=r;r=r+16|0;e=f;nh[a&15](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];d=e+4|0;k[a+4>>2]=k[d>>2];k[e>>2]=0;k[d>>2]=0;r=f;return a|0}function Fx(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Gx(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+40>>2]&255](a,b);return}function Hx(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function Ix(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+48>>2]&1023](a,b);return}function Jx(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Kx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function Lx(a){a=a|0;return k[a+4>>2]|0}function Mx(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function Nx(a){a=a|0;return 0}function Ox(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function Px(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Qx(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Rx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=r;r=r+32|0;e=c+16|0;d=c;g=a+72|0;f=k[g>>2]|0;Uh[k[(k[f>>2]|0)+8>>2]&2047](f);f=a+4|0;KG(f,b)|0;b=k[g>>2]|0;a=k[(k[b>>2]|0)+32>>2]|0;lwa(d,1,f);k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=17104896;k[e+4>>2]=d;jh[a&1023](b,e);zF(d);r=c;return}function Sx(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Tx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0;C=r;r=r+224|0;t=C+200|0;v=C+184|0;w=C;p=C+168|0;u=C+160|0;B=C+104|0;s=C+88|0;e=C+72|0;n=C+56|0;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b;j=n+4|0;A=n+4+4|0;k[A>>2]=0;k[A+4>>2]=0;k[n>>2]=33619968;k[j>>2]=d;b2(n);if((k[c>>2]|0)==(k[c+4>>2]|0)){r=C;return}k[B>>2]=1124007936;z=B+4|0;b=B+8|0;x=B+40|0;l=z;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[x>>2]=b;A=B+48|0;y=B+44|0;k[y>>2]=A;k[B+52>>2]=0;k[A>>2]=0;g=k[a+64>>2]|0;b=k[(k[g>>2]|0)+40>>2]|0;q=t+4|0;m=q+4|0;k[m>>2]=0;k[m+4>>2]=0;k[t>>2]=33619968;k[q>>2]=B;dh[b&255](g,e,c,t);k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=B;g=a+20|0;b=k[g>>2]|0;if(b){c=k[a+8>>2]|0;if((c|0)<3)d=aa(k[a+16>>2]|0,k[a+12>>2]|0)|0;else{f=k[a+44>>2]|0;e=0;d=1;do{d=aa(k[f+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(c|0))}if(!d)h=8}else h=8;if((h|0)==8){k[t>>2]=0;b=t+4|0;k[b>>2]=0;d=ZT(24)|0;k[d>>2]=1;l=d+4|0;k[t>>2]=l;k[b>>2]=19;i[d+23>>0]=0;h=384991;m=l+19|0;do{i[l>>0]=i[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(m|0));Y8(-215,t,386760,384751,175);k[b>>2]=0;k[t>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0);b=k[g>>2]|0}if(b){e=k[a+8>>2]|0;if((e|0)<3)b=aa(k[a+16>>2]|0,k[a+12>>2]|0)|0;else{c=k[a+44>>2]|0;d=0;b=1;do{b=aa(k[c+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if(b)b=k[a+12>>2]|0;else b=0}else b=0;k[v>>2]=0;q=v+4|0;k[q>>2]=0;k[v+8>>2]=0;fYa(k[a+72>>2]|0,s,v,49332);c2(n,1,b,5,-1,0,0);k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;k[w+16>>2]=0;k[w+20>>2]=0;k[w+24>>2]=0;k[w+28>>2]=0;k[t>>2]=-1056833530;k[t+4>>2]=w;k[t+8>>2]=1;k[t+12>>2]=4;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;N2(n,t,p);do if((k[n>>2]&2031616|0)==65536){c=k[j>>2]|0;k[w>>2]=k[c>>2];h=w+4|0;b=c+4|0;k[h>>2]=k[b>>2];p=w+8|0;k[p>>2]=k[c+8>>2];k[w+12>>2]=k[c+12>>2];j=w+16|0;k[j>>2]=k[c+16>>2];k[w+20>>2]=k[c+20>>2];k[w+24>>2]=k[c+24>>2];k[w+28>>2]=k[c+28>>2];k[w+32>>2]=k[c+32>>2];d=k[c+36>>2]|0;k[w+36>>2]=d;e=w+40|0;k[e>>2]=p;p=w+48|0;a=w+44|0;k[a>>2]=p;k[w+52>>2]=0;k[p>>2]=0;if(d|0){p=d+12|0;k[p>>2]=(k[p>>2]|0)+1}if((k[b>>2]|0)<3){n=k[c+44>>2]|0;p=k[a>>2]|0;k[p>>2]=k[n>>2];k[p+4>>2]=k[n+4>>2];break}k[h>>2]=0;x1(w,k[b>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[c+40>>2]|0;f=k[e>>2]|0;d=k[c+44>>2]|0;e=k[a>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[g+(b<<2)>>2];k[e+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else{Q1(w,n,-1);j=w+16|0;a=w+44|0}while(0);f=k[j>>2]|0;d=k[q>>2]|0;b=k[v>>2]|0;if((d|0)!=(b|0)){g=t+4|0;c=0;do{p=b;e=k[p+(c<<4)+4>>2]|0;if((k[p+(c<<4)>>2]|0)!=(c|0)){k[t>>2]=0;k[g>>2]=0;b=ZT(24)|0;k[b>>2]=1;l=b+4|0;k[t>>2]=l;k[g>>2]=18;i[b+22>>0]=0;h=385011;m=l+18|0;do{i[l>>0]=i[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(m|0));Y8(-215,t,386760,384751,200);k[g>>2]=0;k[t>>2]=0;p=k[b>>2]|0;k[b>>2]=p+-1;if((p|0)==1)ggb(k[b+-4>>2]|0);b=k[v>>2]|0;d=k[q>>2]|0}p=f+(e<<2)|0;o[p>>2]=+o[p>>2]+1.0;c=c+1|0}while(c>>>0<d-b>>4>>>0)}R1(u,s,-1);D=+(k[u+4>>2]|0);e=t+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[t>>2]=33619968;k[e>>2]=w;SW(w,t,-1,1.0/D,0.0);e=w+36|0;b=k[e>>2]|0;if(b|0?(t=b+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[w+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;e=w+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[e>>2]|0)>0){d=k[w+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[a>>2]|0;if(!((b|0)==(w+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[v>>2]|0;d=b;if(b|0){e=k[q>>2]|0;if((e|0)!=(b|0))k[q>>2]=e+(~((e+-16-d|0)>>>4)<<4);ggb(b)}e=B+36|0;b=k[e>>2]|0;if(b|0?(v=b+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[B+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;B=B+16|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[z>>2]|0)>0){d=k[x>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[y>>2]|0;if(!((b|0)==(A|0)|(b|0)==0))ggb(k[b+-4>>2]|0);r=C;return}function Ux(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function Vx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;while(1){c=fgb(76)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=141236;k[c+4>>2]=1124007936;e=c+12|0;d=c+44|0;f=c+8|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=e;d=c+52|0;k[c+48>>2]=d;k[c+56>>2]=0;k[d>>2]=0;d=k[a>>2]|0;k[c+60>>2]=d;k[c+64>>2]=k[a+4>>2];if(d|0){a=d+4|0;k[a>>2]=(k[a>>2]|0)+1}d=k[b>>2]|0;k[c+68>>2]=d;k[c+72>>2]=k[b+4>>2];if(!d)return c|0;b=d+4|0;k[b>>2]=(k[b>>2]|0)+1;return c|0}function Wx(a,b,c){a=a|0;b=b|0;c=c|0;return Hh[a&511](b,c)|0}function Xx(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;b=Xh[c&1023](a)|0;while(1){c=fgb(56)|0;if(c|0){a=8;break}c=k[207666]|0;k[207666]=c+0;if(!c){c=0;a=8;break}Qh[c&7]()}if((a|0)==8){AF(c,b);return c|0}return 0}function Yx(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Zx(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function _x(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function $x(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+48|0;i=f+32|0;h=f+16|0;g=f;j=k[(k[a>>2]|0)+32>>2]|0;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=17104896;k[i+4>>2]=b;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=d;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=e;eh[j&255](a,i,c,h,g);r=f;return}function ay(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[k[a>>2]&255](b,c,d,e,f);return}function by(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function cy(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function dy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;h=j;jh[k[(k[b>>2]|0)+28>>2]&1023](h,b);e=k[h>>2]|0;g=h+4|0;f=k[g>>2]|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;if(f>>>0>4294967279)hob();if(f>>>0<11){i[a+11>>0]=f;if(!f)b=a;else{b=a;c=10}}else{d=f+16&-16;c=(d|0)==0?1:d;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[a>>2]=b;k[a+8>>2]=d|-2147483648;k[a+4>>2]=f;c=10}if((c|0)==10)upb(b|0,e|0,f|0)|0;i[b+f>>0]=0;b=k[h>>2]|0;k[g>>2]=0;k[h>>2]=0;if(!b){r=j;return}g=b+-4|0;h=k[g>>2]|0;k[g>>2]=h+-1;if((h|0)!=1){r=j;return}ggb(k[b+-8>>2]|0);r=j;return}function ey(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=r;r=r+16|0;c=d;jh[k[a>>2]&1023](c,b);b=c+11|0;a=i[b>>0]|0;a=fgb((a<<24>>24<0?k[c+4>>2]|0:a&255)+4|0)|0;e=i[b>>0]|0;k[a>>2]=e<<24>>24<0?k[c+4>>2]|0:e&255;e=i[b>>0]|0;f=e<<24>>24<0;upb(a+4|0,(f?k[c>>2]|0:c)|0,(f?k[c+4>>2]|0:e&255)|0)|0;if((i[b>>0]|0)>=0){r=d;return a|0}ggb(k[c>>2]|0);r=d;return a|0}function fy(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;Uh[d&2047](a);return}else{d=k[(k[a>>2]|0)+c>>2]|0;Uh[d&2047](a);return}}function gy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;g=j;c=k[(k[a>>2]|0)+24>>2]|0;k[g>>2]=0;h=g+4|0;k[h>>2]=0;d=b+11|0;e=i[d>>0]|0;f=e<<24>>24<0;if((f?k[b+4>>2]|0:e&255)|0){f=f?k[b+4>>2]|0:e&255;e=ZT(f+8&-4)|0;k[e>>2]=1;e=e+4|0;k[g>>2]=e;k[h>>2]=f;i[e+f>>0]=0;upb(k[g>>2]|0,((i[d>>0]|0)<0?k[b>>2]|0:b)|0,f|0)|0}jh[c&1023](a,g);a=k[g>>2]|0;k[h>>2]=0;k[g>>2]=0;if(!a){r=j;return}g=a+-4|0;h=k[g>>2]|0;k[g>>2]=h+-1;if((h|0)!=1){r=j;return}ggb(k[a+-8>>2]|0);r=j;return}function hy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;h=j;g=k[a>>2]|0;e=c+4|0;f=k[c>>2]|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;if(f>>>0>4294967279)hob();if(f>>>0<11){i[h+11>>0]=f;if(!f)a=h;else{a=h;d=10}}else{d=f+16&-16;c=(d|0)==0?1:d;while(1){a=fgb(c)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[h>>2]=a;k[h+8>>2]=d|-2147483648;k[h+4>>2]=f;d=10}if((d|0)==10)upb(a|0,e|0,f|0)|0;i[a+f>>0]=0;jh[g&1023](b,h);if((i[h+11>>0]|0)>=0){r=j;return}ggb(k[h>>2]|0);r=j;return}function iy(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function jy(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function ky(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=r;r=r+32|0;i=g+16|0;h=g;j=k[(k[a>>2]|0)+40>>2]|0;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b;b=h+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;Lg[j&255](a,i,h,d,e,f);r=g;return}function ly(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Lg[k[a>>2]&255](b,c,d,e,f,g);return}function my(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=r;r=r+32|0;g=e+16|0;f=e;h=k[(k[a>>2]|0)+32>>2]|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=c;dh[h&255](a,g,f,d);r=e;return}function ny(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function oy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0;e=r;r=r+32|0;g=e+16|0;f=e;h=k[(k[a>>2]|0)+36>>2]|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;b=f+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=c;d=+Ug[h&31](a,g,f);r=e;return +d}function py(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Ug[k[a>>2]&31](b,c,d))}function qy(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function ry(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function sy(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function ty(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function uy(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+124>>2]&255](a,b);return}function vy(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function wy(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+92>>2]&255](a,b);return}function xy(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+132>>2]&255](a,b);return}function yy(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;mh[k[(k[a>>2]|0)+68>>2]&15](a,b,c,d);return}function zy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;mh[k[a>>2]&15](b,c,d,e);return}function Ay(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+140>>2]&255](a,b);return}function By(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];d=b+4|0;k[a+4>>2]=k[d>>2];k[b>>2]=0;k[d>>2]=0;r=c;return a|0}function Cy(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+108>>2]&255](a,b);return}function Dy(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+100>>2]&255](a,b);return}function Ey(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+116>>2]&255](a,b);return}function Fy(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;mh[k[(k[a>>2]|0)+60>>2]&15](a,b,c,d);return}function Gy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+16|0;d=c;e=k[(k[a>>2]|0)+84>>2]|0;k[d>>2]=k[b>>2];k[d+4>>2]=k[b+4>>2];k[d+8>>2]=k[b+8>>2];k[d+12>>2]=k[b+12>>2];jh[e&1023](a,d);r=c;return}function Hy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;a=k[a>>2]|0;k[e>>2]=k[c>>2];k[e+4>>2]=k[c+4>>2];k[e+8>>2]=k[c+8>>2];k[e+12>>2]=k[c+12>>2];jh[a&1023](b,e);r=d;return}function Iy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+16|0;d=c;e=k[(k[a>>2]|0)+72>>2]|0;k[d+8>>2]=0;k[d+12>>2]=0;k[d>>2]=16842752;k[d+4>>2]=b;jh[e&1023](a,d);r=c;return}function Jy(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Ky(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;c=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](i,a);while(1){c=fgb(56)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[i>>2];a=i+4|0;k[c+4>>2]=k[a>>2];e=c+8|0;b=i+8|0;k[e>>2]=k[b>>2];k[c+12>>2]=k[i+12>>2];g=i+16|0;k[c+16>>2]=k[g>>2];k[c+20>>2]=k[i+20>>2];k[c+24>>2]=k[i+24>>2];k[c+28>>2]=k[i+28>>2];k[c+32>>2]=k[i+32>>2];h=i+36|0;k[c+36>>2]=k[h>>2];d=c+40|0;k[d>>2]=e;e=c+44|0;f=c+48|0;k[e>>2]=f;k[c+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return c|0}ggb(k[a+-4>>2]|0);r=j;return c|0}function Ly(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=r;r=r+16|0;d=e;c=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](d,a);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];r=e;return c|0}function My(a,b,c){a=a|0;b=b|0;c=c|0;Ph[k[(k[b>>2]|0)+144>>2]&511](a,b,c);return}function Ny(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;Ph[k[a>>2]&511](i,b,c);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function Oy(a){a=a|0;return k[a+4>>2]|0}function Py(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function Qy(a){a=a|0;return 0}function Ry(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function Sy(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Ty(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Uy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=r;r=r+16|0;d=e;c=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](d,a);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];r=e;return c|0}function Vy(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Wy(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];d=b+4|0;k[a+4>>2]=k[d>>2];k[b>>2]=0;k[d>>2]=0;r=c;return a|0}function Xy(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+152>>2]&1023](a,b);return}function Yy(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Zy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;c=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](i,a);while(1){c=fgb(56)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[i>>2];a=i+4|0;k[c+4>>2]=k[a>>2];e=c+8|0;b=i+8|0;k[e>>2]=k[b>>2];k[c+12>>2]=k[i+12>>2];g=i+16|0;k[c+16>>2]=k[g>>2];k[c+20>>2]=k[i+20>>2];k[c+24>>2]=k[i+24>>2];k[c+28>>2]=k[i+28>>2];k[c+32>>2]=k[i+32>>2];h=i+36|0;k[c+36>>2]=k[h>>2];d=c+40|0;k[d>>2]=e;e=c+44|0;f=c+48|0;k[e>>2]=f;k[c+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return c|0}ggb(k[a+-4>>2]|0);r=j;return c|0}function _y(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+168>>2]&1023](a,b);return}function $y(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function az(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function bz(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+160>>2]&1023](a,b);return}function cz(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function dz(a){a=a|0;return k[a+4>>2]|0}function ez(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function fz(a){a=a|0;return 0}function gz(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function hz(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function iz(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function jz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0;e=r;r=r+32|0;g=e+16|0;f=e;h=k[(k[a>>2]|0)+32>>2]|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=c;d=+Ug[h&31](a,g,f);r=e;return +d}function kz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Ug[k[a>>2]&31](b,c,d))}function lz(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function mz(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function nz(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function oz(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function pz(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+96>>2]&1023](a,b);return}function qz(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function rz(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+88>>2]&1023](a,b);return}function sz(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function tz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=+g;var h=0,j=0;while(1){h=fgb(40)|0;if(h|0){j=h;break}h=k[207666]|0;k[207666]=h+0;if(!h){j=0;break}Qh[h&7]()}k[j>>2]=141972;k[j+4>>2]=b;p[j+8>>3]=c;p[j+16>>3]=d;k[j+24>>2]=e;i[j+28>>0]=f&1;p[j+32>>3]=g;while(1){h=fgb(16)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}f=h+4|0;k[f>>2]=1;k[h>>2]=142092;k[h+8>>2]=j;k[a>>2]=h;k[a+4>>2]=j;k[f>>2]=(k[f>>2]|0)+1;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[h>>2]|0)+8>>2]&2047](h);return}function uz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=+g;var h=0,i=0;i=r;r=r+16|0;h=i;xg[a&1](h,b,c,d,e,f,g);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[h>>2];f=h+4|0;k[a+4>>2]=k[f>>2];k[h>>2]=0;k[f>>2]=0;r=i;return a|0}function vz(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+72>>2]&255](a,b);return}function wz(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function xz(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+64>>2]&1023](a,b);return}function yz(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+104>>2]&255](a,b);return}function zz(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+80>>2]&255](a,b);return}function Az(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Bz(a){a=a|0;return k[a+4>>2]|0}function Cz(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function Dz(a){a=a|0;return 0}function Ez(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function Fz(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function Gz(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Hz(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+32|0;s=u+24|0;m=u+16|0;l=u+8|0;q=u;e=b+11|0;c=i[e>>0]|0;d=c<<24>>24<0;if((d?k[b+4>>2]|0:c&255)|0){d=d?k[b+4>>2]|0:c&255;c=ZT(d+8&-4)|0;k[c>>2]=1;c=c+4|0;i[c+d>>0]=0;upb(c|0,((i[e>>0]|0)<0?k[b>>2]|0:b)|0,d|0)|0;k[a>>2]=0;d=a+4|0;k[d>>2]=0;if((c|0)==389862){p=c;o=d;n=a;t=7}else{n=a;o=d;t=4}}else{k[a>>2]=0;o=a+4|0;k[o>>2]=0;c=0;n=a;t=4}a:do if((t|0)==4){d=(c|0)==0?1016759:c;b=i[d>>0]|0;if(b<<24>>24==70){e=389862;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){p=c;t=7;break}}do if((c|0)!=389873){j=b<<24>>24==66;if(j){e=389873;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24)break}do if((c|0)!=389884){if(j){e=389884;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24)break}do if((c|0)!=389899){if(j){e=389899;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24)break}do if((c|0)!=389913){if(j){e=389913;f=d;do{f=f+1|0;e=e+1|0;b=i[f>>0]|0;g=i[e>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=g<<24>>24));e=g}else e=66;if(!((c|0)==389932?1:b<<24>>24==e<<24>>24)){if(j){b=389932;e=d;do{e=e+1|0;b=b+1|0;f=i[e>>0]|0;g=i[b>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=g<<24>>24));if(f<<24>>24==g<<24>>24)break}do if((c|0)!=389954){if(j){f=389954;do{d=d+1|0;f=f+1|0;b=i[d>>0]|0;e=i[f>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=e<<24>>24));if(b<<24>>24==e<<24>>24)break}k[s>>2]=0;d=s+4|0;k[d>>2]=0;b=ZT(28)|0;k[b>>2]=1;f=b+4|0;k[s>>2]=f;k[d>>2]=20;i[b+24>>0]=0;g=389976;h=f+20|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-5,s,389997,388491,1016);k[d>>2]=0;k[s>>2]=0;a=k[b>>2]|0;k[b>>2]=a+-1;if((a|0)==1)ggb(k[b+-4>>2]|0);break a}while(0);while(1){d=fgb(36)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[s+16>>2]=0;k[s+20>>2]=0;k[d>>2]=142836;k[d+28>>2]=7;i[d+32>>0]=0;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=b+4|0;k[f>>2]=1;k[b>>2]=142900;k[b+8>>2]=d;k[f>>2]=(k[f>>2]|0)+1;e=k[n>>2]|0;k[a>>2]=b;k[o>>2]=d;do if(e|0){s=e+4|0;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[e>>2]|0)+8>>2]&2047](e)}while(0);a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1)break a;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);break a}}while(0);while(1){d=fgb(36)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[s+16>>2]=0;k[s+20>>2]=0;k[d>>2]=142836;k[d+28>>2]=6;i[d+32>>0]=0;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=b+4|0;k[f>>2]=1;k[b>>2]=142900;k[b+8>>2]=d;k[f>>2]=(k[f>>2]|0)+1;e=k[n>>2]|0;k[a>>2]=b;k[o>>2]=d;if(e|0?(s=e+4|0,a=k[s>>2]|0,k[s>>2]=a+-1,(a|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1)break a;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);break a}while(0);while(1){d=fgb(36)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[s+16>>2]=0;k[s+20>>2]=0;k[d>>2]=142836;k[d+28>>2]=2;i[d+32>>0]=0;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=b+4|0;k[f>>2]=1;k[b>>2]=142900;k[b+8>>2]=d;k[f>>2]=(k[f>>2]|0)+1;e=k[n>>2]|0;k[a>>2]=b;k[o>>2]=d;if(e|0?(s=e+4|0,a=k[s>>2]|0,k[s>>2]=a+-1,(a|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1)break a;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);break a}while(0);while(1){d=fgb(36)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[s+16>>2]=0;k[s+20>>2]=0;k[d>>2]=142836;k[d+28>>2]=5;i[d+32>>0]=0;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=b+4|0;k[f>>2]=1;k[b>>2]=142900;k[b+8>>2]=d;k[f>>2]=(k[f>>2]|0)+1;e=k[n>>2]|0;k[a>>2]=b;k[o>>2]=d;if(e|0?(s=e+4|0,a=k[s>>2]|0,k[s>>2]=a+-1,(a|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1)break a;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);break a}while(0);while(1){d=fgb(36)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[s+16>>2]=0;k[s+20>>2]=0;k[d>>2]=142836;k[d+28>>2]=4;i[d+32>>0]=0;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=b+4|0;k[f>>2]=1;k[b>>2]=142900;k[b+8>>2]=d;k[f>>2]=(k[f>>2]|0)+1;e=k[n>>2]|0;k[a>>2]=b;k[o>>2]=d;if(e|0?(s=e+4|0,a=k[s>>2]|0,k[s>>2]=a+-1,(a|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b)}while(0);do if((t|0)==7){while(1){c=fgb(128)|0;if(c|0){b=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){b=0;break}Qh[c&7]();t=7}while(1){c=fgb(4)|0;if(c|0){j=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){j=0;break}Qh[c&7]()}k[s>>2]=4;while(1){c=fgb(12)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=0;k[c+8>>2]=0;k[c>>2]=d;k[j>>2]=c;k[m>>2]=0;d=m+4|0;k[d>>2]=0;e=ZT(16)|0;k[e>>2]=1;f=e+4|0;k[m>>2]=f;k[d>>2]=9;i[e+13>>0]=0;g=373358;h=f+9|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));h=WHa(c,m)|0;k[l>>2]=1;g=k[h>>2]|0;t=h+4|0;jh[k[k[g>>2]>>2]&1023](g,t);k[h>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,l,t);k[d>>2]=0;k[m>>2]=0;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)ggb(k[e+-4>>2]|0);k[m>>2]=0;t=m+4|0;k[t>>2]=0;d=ZT(12)|0;k[d>>2]=1;h=d+4|0;k[m>>2]=h;k[t>>2]=5;i[d+9>>0]=0;i[h>>0]=i[380533]|0;i[h+1>>0]=i[380534]|0;i[h+2>>0]=i[380535]|0;i[h+3>>0]=i[380536]|0;i[h+4>>0]=i[380537]|0;h=WHa(c,m)|0;g=k[h>>2]|0;l=h+4|0;jh[k[k[g>>2]>>2]&1023](g,l);k[h>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,s,l);k[t>>2]=0;k[m>>2]=0;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0);while(1){c=fgb(16)|0;if(c|0){g=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){g=0;break}Qh[c&7]()}h=g+4|0;k[h>>2]=1;k[g>>2]=143064;k[g+8>>2]=j;k[q>>2]=g;l=q+4|0;k[l>>2]=j;k[h>>2]=(k[h>>2]|0)+1;while(1){c=fgb(4)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}zQa(c,32,0.0,1);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=d+4|0;k[f>>2]=1;k[d>>2]=143044;k[d+8>>2]=c;k[s>>2]=d;k[s+4>>2]=c;QXa(b,q,s);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c+4>>2]=1;k[c>>2]=142984;k[c+8>>2]=b;e=c;t=k[f>>2]|0;k[f>>2]=t+-1;if((t|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=k[q>>2]|0;if(d|0?(s=d+4|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);k[q>>2]=0;k[l>>2]=0;t=k[h>>2]|0;k[h>>2]=t+-1;if((t|0)==1)Uh[k[(k[g>>2]|0)+8>>2]&2047](g);if(!c){k[a>>2]=0;k[o>>2]=b;c=p;break}d=c+4|0;k[d>>2]=(k[d>>2]|0)+1;d=k[n>>2]|0;k[a>>2]=e;k[o>>2]=b;if((d|0)!=0?(t=d+4|0,a=k[t>>2]|0,k[t>>2]=a+-1,(a|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);if((c|0)!=0?(t=c+4|0,a=k[t>>2]|0,k[t>>2]=a+-1,(a|0)==1):0){Uh[k[(k[c>>2]|0)+8>>2]&2047](c);c=p}else c=p}while(0);if(!c){r=u;return}t=c+-4|0;a=k[t>>2]|0;k[t>>2]=a+-1;if((a|0)!=1){r=u;return}ggb(k[c+-8>>2]|0);r=u;return}function Iz(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+32|0;g=j+16|0;h=j;e=b+4|0;f=k[b>>2]|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;if(f>>>0>4294967279)hob();if(f>>>0<11){i[h+11>>0]=f;if(!f)b=h;else{b=h;c=10}}else{d=f+16&-16;c=(d|0)==0?1:d;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[h>>2]=b;k[h+8>>2]=d|-2147483648;k[h+4>>2]=f;c=10}if((c|0)==10)upb(b|0,e|0,f|0)|0;i[b+f>>0]=0;jh[a&1023](g,h);while(1){b=fgb(8)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=k[g>>2];f=g+4|0;k[b+4>>2]=k[f>>2];k[g>>2]=0;k[f>>2]=0;a=(i[h+11>>0]|0)<0;k[g>>2]=0;k[f>>2]=0;if(!a){r=j;return b|0}ggb(k[h>>2]|0);r=j;return b|0}function Jz(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;Uh[d&2047](a);return}else{d=k[(k[a>>2]|0)+c>>2]|0;Uh[d&2047](a);return}}function Kz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+128|0;s=t+120|0;o=t+104|0;p=t+88|0;q=t+32|0;n=t+16|0;m=t;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=b;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=c;Ph[k[(k[a>>2]|0)+44>>2]&511](s,a,1);l=s+4|0;b=k[l>>2]|0;jh[k[(k[b>>2]|0)+32>>2]&1023](b,m);l=k[l>>2]|0;k[q>>2]=k[f>>2];m=q+4|0;b=f+4|0;a=k[b>>2]|0;k[m>>2]=a;i=q+8|0;k[i>>2]=k[f+8>>2];k[q+12>>2]=k[f+12>>2];k[q+16>>2]=k[f+16>>2];k[q+20>>2]=k[f+20>>2];k[q+24>>2]=k[f+24>>2];k[q+28>>2]=k[f+28>>2];k[q+32>>2]=k[f+32>>2];c=k[f+36>>2]|0;k[q+36>>2]=c;h=q+40|0;k[h>>2]=i;i=q+48|0;j=q+44|0;k[j>>2]=i;k[q+52>>2]=0;k[i>>2]=0;if(c){a=c+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[b>>2]|0}if((a|0)>=3){k[m>>2]=0;x1(q,a,0,0,0);if((k[m>>2]|0)>0){i=k[f+40>>2]|0;h=k[h>>2]|0;c=k[f+44>>2]|0;b=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[i+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0))}}else{m=k[f+44>>2]|0;f=k[j>>2]|0;k[f>>2]=k[m>>2];k[f+4>>2]=k[m+4>>2]}lwa(p,1,q);k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=17104896;k[o+4>>2]=p;hYa(l,n,d,e,o,g);zF(p);c=q+36|0;a=k[c>>2]|0;if(a|0?(o=a+12|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;p=q+16|0;b=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[b>>2]|0)>0){c=k[q+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[q+44>>2]|0;if(!((a|0)==(q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[s>>2]|0;if(!a){r=t;return}q=a+4|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1){r=t;return}Uh[k[(k[a>>2]|0)+8>>2]&2047](a);r=t;return}function Lz(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Eh[k[a>>2]&127](b,c,d,e,f,g,h);return}function Mz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=r;r=r+32|0;i=g+16|0;h=g;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=17104896;k[h+4>>2]=e;hYa(a,i,c,d,h,f);r=g;return}function Nz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Lg[k[a>>2]&255](b,c,d,e,f,g);return}function Oz(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+16|0;d=c;e=k[(k[a>>2]|0)+32>>2]|0;k[d+8>>2]=0;k[d+12>>2]=0;k[d>>2]=17104896;k[d+4>>2]=b;jh[e&1023](a,d);r=c;return}function Pz(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function Qz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+128|0;o=q+120|0;l=q+104|0;m=q+88|0;p=q+32|0;n=q+16|0;j=q;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=b;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=c;Ph[k[(k[a>>2]|0)+44>>2]&511](o,a,1);i=o+4|0;b=k[i>>2]|0;jh[k[(k[b>>2]|0)+32>>2]&1023](b,j);i=k[i>>2]|0;k[p>>2]=k[e>>2];j=p+4|0;b=e+4|0;a=k[b>>2]|0;k[j>>2]=a;g=p+8|0;k[g>>2]=k[e+8>>2];k[p+12>>2]=k[e+12>>2];k[p+16>>2]=k[e+16>>2];k[p+20>>2]=k[e+20>>2];k[p+24>>2]=k[e+24>>2];k[p+28>>2]=k[e+28>>2];k[p+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[p+36>>2]=c;f=p+40|0;k[f>>2]=g;g=p+48|0;h=p+44|0;k[h>>2]=g;k[p+52>>2]=0;k[g>>2]=0;if(c){a=c+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[b>>2]|0}if((a|0)>=3){k[j>>2]=0;x1(p,a,0,0,0);if((k[j>>2]|0)>0){g=k[e+40>>2]|0;f=k[f>>2]|0;c=k[e+44>>2]|0;b=k[h>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else{j=k[e+44>>2]|0;e=k[h>>2]|0;k[e>>2]=k[j>>2];k[e+4>>2]=k[j+4>>2]}lwa(m,1,p);k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=17104896;k[l+4>>2]=m;fYa(i,n,d,l);zF(m);c=p+36|0;a=k[c>>2]|0;if(a|0?(m=a+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[p+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;n=p+16|0;b=p+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[b>>2]|0)>0){c=k[p+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[p+44>>2]|0;if(!((a|0)==(p+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[o>>2]|0;if(!a){r=q;return}o=a+4|0;p=k[o>>2]|0;k[o>>2]=p+-1;if((p|0)!=1){r=q;return}Uh[k[(k[a>>2]|0)+8>>2]&2047](a);r=q;return}function Rz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[k[a>>2]&255](b,c,d,e,f);return}function Sz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+32|0;g=e+16|0;f=e;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=17104896;k[f+4>>2]=d;fYa(a,g,c,f);r=e;return}function Tz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function Uz(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return yF(Xh[c&1023](a)|0)|0}function Vz(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function Wz(a){a=a|0;return k[a+4>>2]|0}function Xz(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function Yz(a){a=a|0;return 0}function Zz(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function _z(a){a=a|0;return 5960}function $z(a){a=a|0;if(a|0)ggb(a);return}function aA(){var a=0;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=-1;k[a+4>>2]=-1;k[a+8>>2]=-1;o[a+12>>2]=3402823466385288598117041.0e14;return a|0}function bA(a){a=a|0;return Nh[a&127]()|0}function cA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}b=k[b>>2]|0;c=k[c>>2]|0;k[d>>2]=k[a>>2];k[d+4>>2]=b;k[d+8>>2]=-1;k[d+12>>2]=c;return d|0}function dA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0;e=r;r=r+16|0;h=e+8|0;g=e+4|0;f=e;k[h>>2]=b;k[g>>2]=c;o[f>>2]=d;c=ci[a&255](h,g,f)|0;r=e;return c|0}function eA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}b=k[b>>2]|0;c=k[c>>2]|0;d=k[d>>2]|0;k[e>>2]=k[a>>2];k[e+4>>2]=b;k[e+8>>2]=c;k[e+12>>2]=d;return e|0}function fA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+16|0;j=f+12|0;i=f+8|0;h=f+4|0;g=f;k[j>>2]=b;k[i>>2]=c;k[h>>2]=d;o[g>>2]=e;d=Dg[a&127](j,i,h,g)|0;r=f;return d|0}function gA(a,b){a=a|0;b=b|0;return k[b+(k[a>>2]|0)>>2]|0}function hA(a,b,c){a=a|0;b=b|0;c=c|0;k[b+(k[a>>2]|0)>>2]=c;return}function iA(a,b){a=a|0;b=b|0;return +(+o[b+(k[a>>2]|0)>>2])}function jA(a,b,c){a=a|0;b=b|0;c=+c;o[b+(k[a>>2]|0)>>2]=c;return}function kA(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function lA(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function mA(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+64>>2]&255](a,b);return}function nA(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function oA(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+72>>2]&255](a,b);return}function pA(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+48>>2]&255](a,b);return}function qA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function rA(a,b,c,d,e,f){a=a|0;b=+b;c=+c;d=+d;e=+e;f=+f;var g=0,h=0,j=0,l=0;while(1){g=fgb(32)|0;if(g|0){l=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){l=0;break}Qh[g&7]()}k[l>>2]=151448;g=l+4|0;k[g>>2]=0;j=l+8|0;k[j>>2]=0;h=ZT(20)|0;k[h>>2]=1;k[g>>2]=h+4;k[j>>2]=13;i[h+17>>0]=0;g=k[g>>2]|0;h=400132;j=g+13|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));o[l+12>>2]=b;o[l+16>>2]=c;o[l+20>>2]=d;o[l+24>>2]=e;o[l+28>>2]=f;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}j=g+4|0;k[j>>2]=1;k[g>>2]=151532;k[g+8>>2]=l;k[a>>2]=g;k[a+4>>2]=l;k[j>>2]=(k[j>>2]|0)+1;a=k[j>>2]|0;k[j>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[g>>2]|0)+8>>2]&2047](g);return}function sA(a,b,c,d,e,f){a=a|0;b=+b;c=+c;d=+d;e=+e;f=+f;var g=0,h=0,i=0;h=r;r=r+16|0;g=h;yh[a&1](g,b,c,d,e,f);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[g>>2];i=g+4|0;k[a+4>>2]=k[i>>2];k[g>>2]=0;k[i>>2]=0;r=h;return a|0}function tA(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+56>>2]&255](a,b);return}function uA(a){a=a|0;return k[a+4>>2]|0}function vA(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function wA(a){a=a|0;return 0}function xA(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function yA(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function zA(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function AA(a,b){a=a|0;b=b|0;var c=0,d=0;while(1){c=fgb(36)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}a=k[a>>2]|0;b=i[b>>0]&1;d=c+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[c>>2]=142836;k[c+28>>2]=a;i[c+32>>0]=b;return c|0}function BA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+16|0;f=d;e=d+4|0;k[f>>2]=b;i[e>>0]=c&1;c=Hh[a&511](f,e)|0;r=d;return c|0}function CA(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function DA(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function EA(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function FA(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function GA(a,b,c){a=a|0;b=b|0;c=c|0;Ph[k[(k[a>>2]|0)+132>>2]&511](a,b,c);return}function HA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[k[a>>2]&511](b,c,d);return}function IA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;c=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](i,a);while(1){c=fgb(56)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[i>>2];a=i+4|0;k[c+4>>2]=k[a>>2];e=c+8|0;b=i+8|0;k[e>>2]=k[b>>2];k[c+12>>2]=k[i+12>>2];g=i+16|0;k[c+16>>2]=k[g>>2];k[c+20>>2]=k[i+20>>2];k[c+24>>2]=k[i+24>>2];k[c+28>>2]=k[i+28>>2];k[c+32>>2]=k[i+32>>2];h=i+36|0;k[c+36>>2]=k[h>>2];d=c+40|0;k[d>>2]=e;e=c+44|0;f=c+48|0;k[e>>2]=f;k[c+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return c|0}ggb(k[a+-4>>2]|0);r=j;return c|0}function JA(a,b,c){a=a|0;b=+b;c=c|0;$f[k[(k[a>>2]|0)+136>>2]&15](a,b,c);return}function KA(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;$f[k[a>>2]&15](b,c,d);return}function LA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+16|0;f=e;g=k[(k[a>>2]|0)+104>>2]|0;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=c;dh[g&255](a,b,f,d);r=e;return}function MA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function NA(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function OA(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0,o=0,p=0;i=r;r=r+96|0;p=i+80|0;o=i+64|0;n=i+48|0;m=i+32|0;l=i+16|0;j=i;k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=b;k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=d;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=e;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=f;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=g;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=h;HBa(a,p,c,o,n,m,l,j);r=i;return}function PA(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;j=r;r=r+16|0;i=j;sh[a&255](i,b,c,d,e,f,g,h);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];h=i+4|0;k[a+4>>2]=k[h>>2];k[i>>2]=0;k[h>>2]=0;r=j;return a|0}function QA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+16|0;f=e;g=k[(k[a>>2]|0)+32>>2]|0;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;dh[g&255](a,f,c,d);r=e;return}function RA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function SA(a,b){a=a|0;b=b|0;return Hh[k[(k[a>>2]|0)+116>>2]&511](a,b)|0}function TA(a,b,c){a=a|0;b=b|0;c=c|0;return Hh[k[a>>2]&511](b,c)|0}function UA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;KAa(a,c,d);return}function VA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;dh[a&255](i,b,c,d);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function WA(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;Uh[d&2047](a);return}else{d=k[(k[a>>2]|0)+c>>2]|0;Uh[d&2047](a);return}}function XA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;eh[k[(k[b>>2]|0)+44>>2]&255](a,b,c,d,e);return}function YA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;eh[k[a>>2]&255](i,b,c,d,e);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function ZA(a){a=a|0;return k[a+4>>2]|0}function _A(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function $A(a){a=a|0;return 0}function aB(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function bB(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function cB(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function dB(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function eB(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+76>>2]&1023](a,b);return}function fB(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function gB(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function hB(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;j=+j;l=l|0;var m=0,n=0,o=0,q=0,s=0,t=0,u=0;u=r;r=r+16|0;s=u;while(1){m=fgb(160)|0;if(m|0){t=m;break}m=k[207666]|0;k[207666]=m+0;if(!m){t=0;break}Qh[m&7]()}k[t>>2]=143116;k[t+4>>2]=1124007936;m=t+12|0;n=t+44|0;o=t+8|0;q=o+36|0;do{k[o>>2]=0;o=o+4|0}while((o|0)<(q|0));k[n>>2]=m;o=t+52|0;k[t+48>>2]=o;q=o+44|0;do{k[o>>2]=0;o=o+4|0}while((o|0)<(q|0));k[t+96>>2]=b;k[t+100>>2]=c;k[t+104>>2]=d;p[t+112>>3]=e;p[t+120>>3]=f;i[t+128>>0]=0;d=t+129|0;i[d>>0]=i[s>>0]|0;i[d+1>>0]=i[s+1>>0]|0;i[d+2>>0]=i[s+2>>0]|0;k[t+132>>2]=g;p[t+136>>3]=h;p[t+144>>3]=j;k[t+152>>2]=l;while(1){m=fgb(16)|0;if(m|0)break;m=k[207666]|0;k[207666]=m+0;if(!m){m=0;break}Qh[m&7]()}l=m+4|0;k[l>>2]=1;k[m>>2]=144824;k[m+8>>2]=t;k[a>>2]=m;k[a+4>>2]=t;k[l>>2]=(k[l>>2]|0)+1;a=k[l>>2]|0;k[l>>2]=a+-1;if((a|0)!=1){r=u;return}Uh[k[(k[m>>2]|0)+8>>2]&2047](m);r=u;return}function iB(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=j|0;var l=0,m=0;m=r;r=r+16|0;l=m;bg[a&1](l,b,c,d,e,f,g,h,i,j);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[l>>2];j=l+4|0;k[a+4>>2]=k[j>>2];k[l>>2]=0;k[j>>2]=0;r=m;return a|0}function jB(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+84>>2]&1023](a,b);return}function kB(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+92>>2]&1023](a,b);return}function lB(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function mB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+16|0;f=e;g=k[(k[a>>2]|0)+64>>2]|0;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;dh[g&255](a,f,c,d);r=e;return}function nB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[k[a>>2]&255](b,c,d,e);return}function oB(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+68>>2]&1023](a,b);return}function pB(a){a=a|0;return k[a+4>>2]|0}function qB(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function rB(a){a=a|0;return 0}function sB(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function tB(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function uB(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function vB(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function wB(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function xB(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0;while(1){e=fgb(456)|0;if(e|0){l=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){l=0;break}Qh[e&7]()}k[l>>2]=151736;g=l+4|0;k[g>>2]=0;k[l+8>>2]=0;k[l+56>>2]=1124007936;e=l+64|0;f=l+96|0;h=l+60|0;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[f>>2]=e;e=l+104|0;k[l+100>>2]=e;k[l+108>>2]=0;k[e>>2]=0;k[l+112>>2]=1124007936;e=l+120|0;f=l+152|0;h=l+116|0;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[f>>2]=e;e=l+160|0;k[l+156>>2]=e;k[l+164>>2]=0;k[e>>2]=0;k[l+168>>2]=1124007936;e=l+176|0;f=l+208|0;h=l+172|0;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[f>>2]=e;e=l+216|0;k[l+212>>2]=e;k[l+220>>2]=0;k[e>>2]=0;k[l+224>>2]=1124007936;e=l+232|0;f=l+264|0;h=l+228|0;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[f>>2]=e;e=l+272|0;k[l+268>>2]=e;k[l+276>>2]=0;k[e>>2]=0;k[l+280>>2]=1124007936;e=l+288|0;f=l+320|0;h=l+284|0;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[f>>2]=e;e=l+328|0;k[l+324>>2]=e;k[l+332>>2]=0;k[e>>2]=0;k[l+336>>2]=1124007936;e=l+344|0;f=l+376|0;h=l+340|0;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[f>>2]=e;e=l+384|0;k[l+380>>2]=e;k[l+388>>2]=0;k[e>>2]=0;k[l+392>>2]=1124007936;e=l+400|0;f=l+432|0;h=l+396|0;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[f>>2]=e;j=l+440|0;k[l+436>>2]=j;h=l+448|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[l+20>>2]=(b|0)>0?b:500;k[l+28>>2]=7;k[l+32>>2]=2;o[l+24>>2]=c>0.0?c:400.0;i[l+36>>0]=d&1;i[l+37>>0]=127;o[l+40>>2]=.5;j=l+452|0;k[j>>2]=0;k[h>>2]=0;e=ZT(32)|0;k[e>>2]=1;k[h>>2]=e+4;k[j>>2]=24;i[e+28>>0]=0;h=k[h>>2]|0;e=400781;j=h+24|0;do{i[h>>0]=i[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(j|0));while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}d=e+4|0;k[d>>2]=1;k[e>>2]=151840;k[e+8>>2]=l;k[a>>2]=e;k[a+4>>2]=l;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[e>>2]|0)+8>>2]&2047](e);return}function yB(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0;f=r;r=r+16|0;e=f;nh[a&15](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];d=e+4|0;k[a+4>>2]=k[d>>2];k[e>>2]=0;k[d>>2]=0;r=f;return a|0}function zB(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+76>>2]&1023](a,b);return}function AB(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function BB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function CB(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+60>>2]&255](a,b);return}function DB(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function EB(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+68>>2]&1023](a,b);return}function FB(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function GB(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+84>>2]&1023](a,b);return}function HB(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+44>>2]&1023](a,b);return}function IB(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+52>>2]&1023](a,b);return}function JB(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+92>>2]&255](a,b);return}function KB(a){a=a|0;return k[a+4>>2]|0}function LB(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function MB(a){a=a|0;return 0}function NB(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function OB(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function PB(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function QB(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];d=b+4|0;k[a+4>>2]=k[d>>2];k[b>>2]=0;k[d>>2]=0;r=c;return a|0}function RB(a){a=a|0;return k[a+4>>2]|0}function SB(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function TB(a){a=a|0;return 0}function UB(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function VB(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function WB(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function XB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+16|0;d=c;e=k[(k[a>>2]|0)+44>>2]|0;k[d>>2]=k[b>>2];k[d+4>>2]=k[b+4>>2];jh[e&1023](a,d);r=c;return}function YB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;a=k[a>>2]|0;k[e>>2]=k[c>>2];k[e+4>>2]=k[c+4>>2];jh[a&1023](b,e);r=d;return}function ZB(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0;e=k[c>>2]|0;d=k[c+4>>2]|0;while(1){c=fgb(136)|0;if(c|0){g=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){g=0;break}Qh[c&7]()}k[g>>2]=51860;p[g+8>>3]=b;k[g+16>>2]=e;k[g+20>>2]=d;k[g+24>>2]=1124007936;c=g+32|0;d=g+64|0;e=g+28|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;c=g+72|0;k[g+68>>2]=c;k[g+76>>2]=0;k[c>>2]=0;k[g+80>>2]=1124007936;c=g+88|0;d=g+120|0;e=g+84|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;f=g+128|0;k[g+124>>2]=f;k[g+132>>2]=0;k[f>>2]=0;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}f=c+4|0;k[f>>2]=1;k[c>>2]=51924;k[c+8>>2]=g;k[a>>2]=c;k[a+4>>2]=g;k[f>>2]=(k[f>>2]|0)+1;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function _B(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0;e=r;r=r+16|0;d=e+8|0;f=e;k[f>>2]=k[c>>2];k[f+4>>2]=k[c+4>>2];$f[a&15](d,b,f);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[d>>2];f=d+4|0;k[a+4>>2]=k[f>>2];k[d>>2]=0;k[f>>2]=0;r=e;return a|0}function $B(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;Uh[d&2047](a);return}else{d=k[(k[a>>2]|0)+c>>2]|0;Uh[d&2047](a);return}}function aC(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+36>>2]&255](a,b);return}function bC(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function cC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=r;r=r+16|0;d=e;c=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](d,a);while(1){c=fgb(8)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];r=e;return c|0}function dC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function eC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=r;r=r+32|0;f=d+16|0;e=d;g=k[(k[a>>2]|0)+32>>2]|0;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b;b=e+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[e>>2]=33619968;k[e+4>>2]=c;Ph[g&511](a,f,e);r=d;return}function fC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[k[a>>2]&511](b,c,d);return}function gC(a){a=a|0;return k[a+4>>2]|0}function hC(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function iC(a){a=a|0;return 0}function jC(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function kC(a){a=a|0;return 5352}function lC(a){a=a|0;if(a|0)ggb(a);return}function mC(){var a=0;while(1){a=fgb(68)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}o[a>>2]=10.0;o[a+4>>2]=50.0;o[a+8>>2]=220.0;k[a+12>>2]=2;o[a+16>>2]=10.0;i[a+20>>0]=1;i[a+21>>0]=0;i[a+22>>0]=1;o[a+24>>2]=25.0;o[a+28>>2]=5.0e3;i[a+32>>0]=0;o[a+36>>2]=.800000011920929;o[a+40>>2]=3402823466385288598117041.0e14;i[a+44>>0]=1;o[a+48>>2]=.10000000149011612;o[a+52>>2]=3402823466385288598117041.0e14;i[a+56>>0]=1;o[a+60>>2]=.949999988079071;o[a+64>>2]=3402823466385288598117041.0e14;return a|0}function nC(a){a=a|0;return Nh[a&127]()|0}function oC(a,b){a=a|0;b=b|0;return +(+o[b+(k[a>>2]|0)>>2])}function pC(a,b,c){a=a|0;b=b|0;c=+c;o[b+(k[a>>2]|0)>>2]=c;return}function qC(a,b){a=a|0;b=b|0;return k[b+(k[a>>2]|0)>>2]|0}function rC(a,b,c){a=a|0;b=b|0;c=c|0;k[b+(k[a>>2]|0)>>2]=c;return}function sC(a,b){a=a|0;b=b|0;return (i[b+(k[a>>2]|0)>>0]&1)!=0|0}function tC(a,b,c){a=a|0;b=b|0;c=c|0;i[b+(k[a>>2]|0)>>0]=c&1;return}function uC(a,b){a=a|0;b=b|0;return i[b+(k[a>>2]|0)>>0]|0}function vC(a,b,c){a=a|0;b=b|0;c=c|0;i[b+(k[a>>2]|0)>>0]=c;return}function wC(a){a=a|0;return 5424}function xC(a){a=a|0;if(a|0)ggb(a);return}function yC(a,b){a=a|0;b=b|0;return +(+p[b+(k[a>>2]|0)>>3])}function zC(a,b,c){a=a|0;b=b|0;c=+c;p[b+(k[a>>2]|0)>>3]=c;return}function AC(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function BC(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function CC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;while(1){c=fgb(72)|0;if(c|0){e=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){e=0;break}Qh[c&7]()}k[e>>2]=141284;d=e+4|0;c=b;b=d+68|0;do{k[d>>2]=k[c>>2];d=d+4|0;c=c+4|0}while((d|0)<(b|0));while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=141360;k[c+8>>2]=e;k[a>>2]=c;k[a+4>>2]=e;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function DC(a,b){a=a|0;b=b|0;var c=0,d=0;d=r;r=r+16|0;c=d;jh[a&1023](c,b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[c>>2];b=c+4|0;k[a+4>>2]=k[b>>2];k[c>>2]=0;k[b>>2]=0;r=d;return a|0}function EC(a){a=a|0;return k[a+4>>2]|0}function FC(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function GC(a){a=a|0;return 0}function HC(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function IC(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function JC(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function KC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function LC(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+80>>2]&255](a,b);return}function MC(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function NC(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+104>>2]&255](a,b);return}function OC(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+64>>2]&1023](a,b);return}function PC(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function QC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;c=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](i,a);while(1){c=fgb(56)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[i>>2];a=i+4|0;k[c+4>>2]=k[a>>2];e=c+8|0;b=i+8|0;k[e>>2]=k[b>>2];k[c+12>>2]=k[i+12>>2];g=i+16|0;k[c+16>>2]=k[g>>2];k[c+20>>2]=k[i+20>>2];k[c+24>>2]=k[i+24>>2];k[c+28>>2]=k[i+28>>2];k[c+32>>2]=k[i+32>>2];h=i+36|0;k[c+36>>2]=k[h>>2];d=c+40|0;k[d>>2]=e;e=c+44|0;f=c+48|0;k[e>>2]=f;k[c+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return c|0}ggb(k[a+-4>>2]|0);r=j;return c|0}function RC(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+88>>2]&255](a,b);return}function SC(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];d=b+4|0;k[a+4>>2]=k[d>>2];k[b>>2]=0;k[d>>2]=0;r=c;return a|0}function TC(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+96>>2]&255](a,b);return}function UC(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function VC(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+128>>2]&1023](a,b);return}function WC(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function XC(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+72>>2]&255](a,b);return}function YC(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+112>>2]&255](a,b);return}function ZC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=r;r=r+16|0;d=e;c=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](d,a);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];r=e;return c|0}function _C(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0,j=0;f=r;r=r+32|0;h=f+16|0;g=f;i=k[(k[a>>2]|0)+152>>2]|0;j=h+4+4|0;k[j>>2]=0;k[j+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=c;c=g+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=d;e=+wh[i&31](a,b,h,g);r=f;return +e}function $C(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+wh[k[a>>2]&31](b,c,d,e))}function aD(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+136>>2]&1023](a,b);return}function bD(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+120>>2]&1023](a,b);return}function cD(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function dD(a){a=a|0;return k[a+4>>2]|0}function eD(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function fD(a){a=a|0;return 0}function gD(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function hD(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function iD(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function jD(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0;while(1){d=fgb(20)|0;if(d|0){g=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){g=0;break}Qh[d&7]()}k[g>>2]=149492;d=g+4|0;e=d;k[e>>2]=0;k[e+4>>2]=0;e=ZT(32)|0;k[e>>2]=1;k[d>>2]=e+4;k[g+8>>2]=26;i[e+30>>0]=0;d=k[d>>2]|0;e=391811;f=d+26|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));k[g+12>>2]=b;o[g+16>>2]=c;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d+4>>2]=1;k[d>>2]=149612;k[d+8>>2]=g;k[a>>2]=d;k[a+4>>2]=g;return}function kD(a){a=a|0;return 4984}function lD(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function mD(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;f=h;k[f>>2]=0;g=f+4|0;k[g>>2]=0;c=b+11|0;d=i[c>>0]|0;e=d<<24>>24<0;if((e?k[b+4>>2]|0:d&255)|0){e=e?k[b+4>>2]|0:d&255;d=ZT(e+8&-4)|0;k[d>>2]=1;d=d+4|0;k[f>>2]=d;k[g>>2]=e;i[d+e>>0]=0;upb(k[f>>2]|0,((i[c>>0]|0)<0?k[b>>2]|0:b)|0,e|0)|0}a=cSa(a,f)|0;b=k[f>>2]|0;k[g>>2]=0;k[f>>2]=0;if(!b){r=h;return a|0}f=b+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){r=h;return a|0}ggb(k[b+-8>>2]|0);r=h;return a|0}function nD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;h=j;g=k[a>>2]|0;e=c+4|0;f=k[c>>2]|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;if(f>>>0>4294967279)hob();if(f>>>0<11){i[h+11>>0]=f;if(!f)a=h;else{a=h;d=10}}else{d=f+16&-16;c=(d|0)==0?1:d;while(1){a=fgb(c)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[h>>2]=a;k[h+8>>2]=d|-2147483648;k[h+4>>2]=f;d=10}if((d|0)==10)upb(a|0,e|0,f|0)|0;i[a+f>>0]=0;a=Hh[g&511](b,h)|0;if((i[h+11>>0]|0)>=0){r=j;return a|0}ggb(k[h>>2]|0);r=j;return a|0}function oD(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function pD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;g=j+8|0;f=j;k[g>>2]=0;h=g+4|0;k[h>>2]=0;a=b+11|0;d=i[a>>0]|0;e=d<<24>>24<0;if((e?k[b+4>>2]|0:d&255)|0){e=e?k[b+4>>2]|0:d&255;d=ZT(e+8&-4)|0;k[d>>2]=1;d=d+4|0;k[g>>2]=d;k[h>>2]=e;i[d+e>>0]=0;upb(d|0,((i[a>>0]|0)<0?k[b>>2]|0:b)|0,e|0)|0}k[f>>2]=0;b=f+4|0;k[b>>2]=0;a=c+11|0;d=i[a>>0]|0;e=d<<24>>24<0;if(!((e?k[c+4>>2]|0:d&255)|0))a=0;else{d=e?k[c+4>>2]|0:d&255;e=ZT(d+8&-4)|0;k[e>>2]=1;e=e+4|0;k[f>>2]=e;k[b>>2]=d;i[e+d>>0]=0;upb(e|0,((i[a>>0]|0)<0?k[c>>2]|0:c)|0,d|0)|0;a=e}d=lSa(g,f)|0;k[b>>2]=0;k[f>>2]=0;if(a|0?(c=a+-4|0,f=k[c>>2]|0,k[c>>2]=f+-1,(f|0)==1):0)ggb(k[a+-8>>2]|0);a=k[g>>2]|0;k[h>>2]=0;k[g>>2]=0;if(!a){r=j;return d|0}g=a+-4|0;h=k[g>>2]|0;k[g>>2]=h+-1;if((h|0)!=1){r=j;return d|0}ggb(k[a+-8>>2]|0);r=j;return d|0}function qD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+32|0;j=m+12|0;l=m;g=c+4|0;h=k[c>>2]|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;if(h>>>0>4294967279)hob();if(h>>>0<11){i[j+11>>0]=h;if(!h)c=j;else{c=j;e=10}}else{f=h+16&-16;e=(f|0)==0?1:f;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[j>>2]=c;k[j+8>>2]=f|-2147483648;k[j+4>>2]=h;e=10}if((e|0)==10)upb(c|0,g|0,h|0)|0;i[c+h>>0]=0;g=d+4|0;h=k[d>>2]|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;if(h>>>0>4294967279)hob();if(h>>>0<11){i[l+11>>0]=h;if(!h)c=l;else{c=l;e=20}}else{f=h+16&-16;e=(f|0)==0?1:f;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[l>>2]=c;k[l+8>>2]=f|-2147483648;k[l+4>>2]=h;e=20}if((e|0)==20)upb(c|0,g|0,h|0)|0;i[c+h>>0]=0;c=ci[a&255](b,j,l)|0;if((i[l+11>>0]|0)<0)ggb(k[l>>2]|0);if((i[j+11>>0]|0)>=0){r=m;return c|0}ggb(k[j>>2]|0);r=m;return c|0}function rD(a,b){a=a|0;b=b|0;return gSa(a,b)|0}function sD(a,b,c){a=a|0;b=b|0;c=c|0;return Hh[k[a>>2]&511](b,c)|0}function tD(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+48|0;u=w+40|0;o=w+32|0;p=w+24|0;q=w+16|0;s=w;k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=b;n=k[h>>2]|0;l=k[h+4>>2]|0;m=k[j>>2]|0;j=k[j+4>>2]|0;b=a+4|0;h=k[b>>2]|0;if(!((h|0)!=0?!(Xh[k[(k[h>>2]|0)+20>>2]&1023](h)|0):0))v=3;if((v|0)==3?(k[u>>2]=0,v=u+4|0,k[v>>2]=0,t=ZT(16)|0,k[t>>2]=1,a=t+4|0,k[u>>2]=a,k[v>>2]=8,i[t+12>>0]=0,a,h=a,i[h>>0]=33,i[h+1>>0]=101,i[h+2>>0]=109,i[h+3>>0]=112,a=a+4|0,i[a>>0]=116,i[a+1>>0]=121,i[a+2>>0]=40,i[a+3>>0]=41,Y8(-215,u,379340,378394,1651),k[v>>2]=0,k[u>>2]=0,v=k[t>>2]|0,k[t>>2]=v+-1,(v|0)==1):0)ggb(k[t+-4>>2]|0);v=k[b>>2]|0;u=k[(k[v>>2]|0)+40>>2]|0;k[o>>2]=n;k[o+4>>2]=l;k[p>>2]=m;k[p+4>>2]=j;Yf[u&7](v,s,c,d,e,f,g,o,p);R1(q,s,-1);hSa(k[q>>2]|0,k[q+4>>2]|0,c,d,0);r=w;return}function uD(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;var l=0,m=0,n=0;l=r;r=r+16|0;n=l+8|0;m=l;a=k[a>>2]|0;k[n>>2]=k[i>>2];k[n+4>>2]=k[i+4>>2];k[m>>2]=k[j>>2];k[m+4>>2]=k[j+4>>2];Yf[a&7](b,c,d,e,f,g,h,n,m);r=l;return}function vD(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function wD(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function xD(a){a=a|0;return Nh[a&127]()|0}function yD(a){a=a|0;var b=0;while(1){b=fgb(8)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;k[b+4>>2]=0;cSa(b,a)|0;return b|0}function zD(a,b){a=a|0;b=b|0;return Xh[a&1023](b)|0}function AD(a,b,c,d,e,f,g,h,j,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+48|0;q=y+40|0;s=y+32|0;t=y+24|0;u=y+16|0;v=y;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=16842752;k[v+4>>2]=b;p=k[j>>2]|0;n=k[j+4>>2]|0;o=k[l>>2]|0;l=k[l+4>>2]|0;b=a+4|0;j=k[b>>2]|0;if(!((j|0)!=0?!(Xh[k[(k[j>>2]|0)+20>>2]&1023](j)|0):0))x=3;if((x|0)==3?(k[q>>2]=0,x=q+4|0,k[x>>2]=0,w=ZT(16)|0,k[w>>2]=1,a=w+4|0,k[q>>2]=a,k[x>>2]=8,i[w+12>>0]=0,a,j=a,i[j>>0]=33,i[j+1>>0]=101,i[j+2>>0]=109,i[j+3>>0]=112,a=a+4|0,i[a>>0]=116,i[a+1>>0]=121,i[a+2>>0]=40,i[a+3>>0]=41,Y8(-215,q,379340,378394,1666),k[x>>2]=0,k[q>>2]=0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0)ggb(k[w+-4>>2]|0);x=k[b>>2]|0;w=k[(k[x>>2]|0)+44>>2]|0;k[s>>2]=p;k[s+4>>2]=n;k[t>>2]=o;k[t+4>>2]=l;Oh[w&3](x,v,c,d,e,f,g,h,s,t,m);R1(u,v,-1);hSa(k[u>>2]|0,k[u+4>>2]|0,c,d,e);r=y;return}function BD(a,b,c,d,e,f,g,h,i,j,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0;n=r;r=r+16|0;p=n+8|0;o=n;a=k[a>>2]|0;k[p>>2]=k[j>>2];k[p+4>>2]=k[j+4>>2];k[o>>2]=k[l>>2];k[o+4>>2]=k[l+4>>2];Oh[a&3](b,c,d,e,f,g,h,i,p,o,m);r=n;return}function CD(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=r;r=r+16|0;d=e;c=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](d,a);while(1){c=fgb(8)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];r=e;return c|0}function DD(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+48|0;s=v+40|0;t=v+32|0;n=v+24|0;o=v+16|0;p=v;k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=b;m=k[g>>2]|0;j=k[g+4>>2]|0;l=k[h>>2]|0;h=k[h+4>>2]|0;b=a+4|0;g=k[b>>2]|0;if(!((g|0)!=0?!(Xh[k[(k[g>>2]|0)+20>>2]&1023](g)|0):0))u=3;if((u|0)==3?(k[s>>2]=0,u=s+4|0,k[u>>2]=0,q=ZT(16)|0,k[q>>2]=1,a=q+4|0,k[s>>2]=a,k[u>>2]=8,i[q+12>>0]=0,a,g=a,i[g>>0]=33,i[g+1>>0]=101,i[g+2>>0]=109,i[g+3>>0]=112,a=a+4|0,i[a>>0]=116,i[a+1>>0]=121,i[a+2>>0]=40,i[a+3>>0]=41,Y8(-215,s,379340,378394,1639),k[u>>2]=0,k[s>>2]=0,u=k[q>>2]|0,k[q>>2]=u+-1,(u|0)==1):0)ggb(k[q+-4>>2]|0);u=k[b>>2]|0;s=k[(k[u>>2]|0)+36>>2]|0;k[t>>2]=m;k[t+4>>2]=j;k[n>>2]=l;k[n+4>>2]=h;Mg[s&3](u,p,c,d,e,f,t,n);R1(o,p,-1);hSa(k[o>>2]|0,k[o+4>>2]|0,c,0,0);r=v;return}function ED(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0;j=r;r=r+16|0;m=j+8|0;l=j;a=k[a>>2]|0;k[m>>2]=k[h>>2];k[m+4>>2]=k[h+4>>2];k[l>>2]=k[i>>2];k[l+4>>2]=k[i+4>>2];Mg[a&3](b,c,d,e,f,g,m,l);r=j;return}function FD(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function GD(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function HD(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+64>>2]&255](a,b);return}function ID(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function JD(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+56>>2]&255](a,b);return}function KD(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function LD(a,b,c,d,e){a=a|0;b=+b;c=+c;d=+d;e=+e;var f=0,g=0,h=0,j=0;while(1){f=fgb(28)|0;if(f|0){j=f;break}f=k[207666]|0;k[207666]=f+0;if(!f){j=0;break}Qh[f&7]()}k[j>>2]=151552;f=j+4|0;k[f>>2]=0;h=j+8|0;k[h>>2]=0;g=ZT(20)|0;k[g>>2]=1;k[f>>2]=g+4;k[h>>2]=15;i[g+19>>0]=0;f=k[f>>2]|0;g=400281;h=f+15|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));o[j+12>>2]=b;o[j+16>>2]=c;o[j+20>>2]=d;o[j+24>>2]=e;while(1){f=fgb(16)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}h=f+4|0;k[h>>2]=1;k[f>>2]=151628;k[f+8>>2]=j;k[a>>2]=f;k[a+4>>2]=j;k[h>>2]=(k[h>>2]|0)+1;a=k[h>>2]|0;k[h>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[f>>2]|0)+8>>2]&2047](f);return}function MD(a,b,c,d,e){a=a|0;b=+b;c=+c;d=+d;e=+e;var f=0,g=0,h=0;g=r;r=r+16|0;f=g;Pg[a&1](f,b,c,d,e);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[f>>2];h=f+4|0;k[a+4>>2]=k[h>>2];k[f>>2]=0;k[h>>2]=0;r=g;return a|0}function ND(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+48>>2]&255](a,b);return}function OD(a){a=a|0;return k[a+4>>2]|0}function PD(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function QD(a){a=a|0;return 0}function RD(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function SD(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function TD(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function UD(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+56>>2]&255](a,b);return}function VD(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function WD(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function XD(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;var e=0,f=0,g=0,h=0;while(1){e=fgb(24)|0;if(e|0){h=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){h=0;break}Qh[e&7]()}k[h>>2]=151360;e=h+4|0;k[e>>2]=0;g=h+8|0;k[g>>2]=0;f=ZT(20)|0;k[f>>2]=1;k[e>>2]=f+4;k[g>>2]=12;i[f+16>>0]=0;e=k[e>>2]|0;f=400003;g=e+12|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));o[h+12>>2]=b;o[h+16>>2]=c;o[h+20>>2]=d;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}g=e+4|0;k[g>>2]=1;k[e>>2]=151428;k[e+8>>2]=h;k[a>>2]=e;k[a+4>>2]=h;k[g>>2]=(k[g>>2]|0)+1;a=k[g>>2]|0;k[g>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[e>>2]|0)+8>>2]&2047](e);return}function YD(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;var e=0,f=0,g=0;f=r;r=r+16|0;e=f;oh[a&3](e,b,c,d);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];g=e+4|0;k[a+4>>2]=k[g>>2];k[e>>2]=0;k[g>>2]=0;r=f;return a|0}function ZD(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+48>>2]&255](a,b);return}function _D(a){a=a|0;return k[a+4>>2]|0}function $D(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function aE(a){a=a|0;return 0}function bE(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function cE(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function dE(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function eE(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+36>>2]&1023](a,b);return}function fE(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function gE(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+44>>2]&255](a,b);return}function hE(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function iE(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;while(1){d=fgb(20)|0;if(d|0){f=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){f=0;break}Qh[d&7]()}k[f>>2]=149216;d=f+12|0;e=f+16|0;k[f+4>>2]=b;o[f+8>>2]=c;k[e>>2]=0;k[d>>2]=0;b=ZT(32)|0;k[b>>2]=1;k[d>>2]=b+4;k[e>>2]=26;i[b+30>>0]=0;d=k[d>>2]|0;b=391220;e=d+26|0;do{i[d>>0]=i[b>>0]|0;d=d+1|0;b=b+1|0}while((d|0)<(e|0));while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d+4>>2]=1;k[d>>2]=149276;k[d+8>>2]=f;k[a>>2]=d;k[a+4>>2]=f;return}function jE(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;e=r;r=r+16|0;d=e;Rh[a&63](d,b,c);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[d>>2];b=d+4|0;k[a+4>>2]=k[b>>2];k[d>>2]=0;k[b>>2]=0;r=e;return a|0}function kE(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function lE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function mE(a){a=a|0;return k[a+4>>2]|0}function nE(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function oE(a){a=a|0;return 0}function pE(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function qE(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function rE(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function sE(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return yF(Xh[c&1023](a)|0)|0}function tE(a,b){a=a|0;b=b|0;jh[k[(k[b>>2]|0)+12>>2]&1023](a,b);return}function uE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;jh[k[a>>2]&1023](i,b);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function vE(a,b,c){a=a|0;b=b|0;c=c|0;Ph[k[(k[b>>2]|0)+16>>2]&511](a,b,c);return}function wE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;Ph[k[a>>2]&511](i,b,c);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function xE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;j=n;m=b+16|0;if(k[m>>2]|0){f=k[b+4>>2]|0;if((f|0)<3)c=aa(k[b+12>>2]|0,k[b+8>>2]|0)|0;else{e=k[b+40>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0))}if(!c)g=7}else g=7;if((g|0)==7){c=j+4|0;d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=21;i[d+25>>0]=0;f=384883;g=e+21|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,j,388487,384751,55);k[c>>2]=0;k[j>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}h=a+4|0;c=k[h>>2]|0;l=a+8|0;if((c|0)==(k[l>>2]|0)){d=k[b+8>>2]|0;k[a+16>>2]=d}else{if((k[c+12>>2]|0)!=(k[b+12>>2]|0)){c=j+4|0;d=ZT(48)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=40;i[d+44>>0]=0;f=384905;g=e+40|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,j,388487,384751,58);k[c>>2]=0;k[j>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0);c=k[h>>2]|0}if((k[b>>2]^k[c>>2])&4095|0){c=j+4|0;d=ZT(52)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=44;i[d+48>>0]=0;f=384946;g=e+44|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,j,388487,384751,59);k[c>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}d=k[b+8>>2]|0;c=a+16|0;k[c>>2]=(k[c>>2]|0)+d;c=k[l>>2]|0}if((c|0)==(k[a+12>>2]|0)){Doa(h,b);r=n;return}k[c>>2]=k[b>>2];j=c+4|0;f=b+4|0;k[j>>2]=k[f>>2];h=c+8|0;k[h>>2]=d;k[c+12>>2]=k[b+12>>2];k[c+16>>2]=k[m>>2];k[c+20>>2]=k[b+20>>2];k[c+24>>2]=k[b+24>>2];k[c+28>>2]=k[b+28>>2];k[c+32>>2]=k[b+32>>2];d=k[b+36>>2]|0;k[c+36>>2]=d;e=c+40|0;k[e>>2]=h;m=c+48|0;h=c+44|0;k[h>>2]=m;k[c+52>>2]=0;k[m>>2]=0;if(d|0){m=d+12|0;k[m>>2]=(k[m>>2]|0)+1}if((k[f>>2]|0)>=3){k[j>>2]=0;x1(c,k[f>>2]|0,0,0,0);if((k[j>>2]|0)>0){g=k[b+40>>2]|0;f=k[e>>2]|0;e=k[b+44>>2]|0;d=k[h>>2]|0;c=0;do{k[f+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[j>>2]|0))}}else{m=k[b+44>>2]|0;b=k[h>>2]|0;k[b>>2]=k[m>>2];k[b+4>>2]=k[m+4>>2]}k[l>>2]=(k[l>>2]|0)+56;r=n;return}function yE(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function zE(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;Uh[d&2047](a);return}else{d=k[(k[a>>2]|0)+c>>2]|0;Uh[d&2047](a);return}}function AE(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function BE(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function CE(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function DE(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function EE(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+88>>2]&1023](a,b);return}function FE(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function GE(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+96>>2]&1023](a,b);return}function HE(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var l=0,m=0;while(1){l=fgb(48)|0;if(l|0){m=l;break}l=k[207666]|0;k[207666]=l+0;if(!l){m=0;break}Qh[l&7]()}k[m>>2]=144876;k[m+4>>2]=b;p[m+8>>3]=c;k[m+16>>2]=d;k[m+20>>2]=e;k[m+24>>2]=f;k[m+28>>2]=g;k[m+32>>2]=h;k[m+36>>2]=i;k[m+40>>2]=j;while(1){l=fgb(16)|0;if(l|0)break;l=k[207666]|0;k[207666]=l+0;if(!l){l=0;break}Qh[l&7]()}j=l+4|0;k[j>>2]=1;k[l>>2]=149116;k[l+8>>2]=m;k[a>>2]=l;k[a+4>>2]=m;k[j>>2]=(k[j>>2]|0)+1;a=k[j>>2]|0;k[j>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[l>>2]|0)+8>>2]&2047](l);return}function IE(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var l=0,m=0;m=r;r=r+16|0;l=m;fh[a&1](l,b,c,d,e,f,g,h,i,j);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[l>>2];j=l+4|0;k[a+4>>2]=k[j>>2];k[l>>2]=0;k[j>>2]=0;r=m;return a|0}function JE(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+64>>2]&1023](a,b);return}function KE(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+80>>2]&1023](a,b);return}function LE(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+128>>2]&1023](a,b);return}function ME(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){d=c;e=+hg[d&127](a);return +e}else{d=k[(k[a>>2]|0)+c>>2]|0;e=+hg[d&127](a);return +e}return 0.0}function NE(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+120>>2]&1023](a,b);return}function OE(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+104>>2]&1023](a,b);return}function PE(a,b){a=a|0;b=+b;gh[k[(k[a>>2]|0)+72>>2]&255](a,b);return}function QE(a,b,c){a=a|0;b=b|0;c=+c;gh[k[a>>2]&255](b,c);return}function RE(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+112>>2]&1023](a,b);return}function SE(a){a=a|0;return k[a+4>>2]|0}function TE(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function UE(a){a=a|0;return 0}function VE(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function WE(a){a=a|0;return k[(k[a>>2]|0)+-4>>2]|0}function XE(a){a=a|0;if(!a)return;Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function YE(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;i=r;r=r+112|0;q=i+96|0;p=i+80|0;o=i+64|0;n=i+48|0;m=i+32|0;l=i+16|0;j=i;s=k[(k[a>>2]|0)+104>>2]|0;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=b;k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=c;k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=d;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=e;e=m+4+4|0;k[e>>2]=0;k[e+4>>2]=0;k[m>>2]=33619968;k[m+4>>2]=f;f=l+4+4|0;k[f>>2]=0;k[f+4>>2]=0;k[l>>2]=33619968;k[l+4>>2]=g;g=j+4+4|0;k[g>>2]=0;k[g+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=h;h=si[s&15](a,q,p,o,n,m,l,j)|0;r=i;return h|0}function ZE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return si[k[a>>2]&15](b,c,d,e,f,g,h,i)|0}function _E(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=r;r=r+16|0;d=e;c=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](d,a);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];r=e;return c|0}function $E(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+92>>2]&1023](a,b);return}function aF(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function bF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;c=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](i,a);while(1){c=fgb(56)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[i>>2];a=i+4|0;k[c+4>>2]=k[a>>2];e=c+8|0;b=i+8|0;k[e>>2]=k[b>>2];k[c+12>>2]=k[i+12>>2];g=i+16|0;k[c+16>>2]=k[g>>2];k[c+20>>2]=k[i+20>>2];k[c+24>>2]=k[i+24>>2];k[c+28>>2]=k[i+28>>2];k[c+32>>2]=k[i+32>>2];h=i+36|0;k[c+36>>2]=k[h>>2];d=c+40|0;k[d>>2]=e;e=c+44|0;f=c+48|0;k[e>>2]=f;k[c+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return c|0}ggb(k[a+-4>>2]|0);r=j;return c|0}function cF(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+64>>2]&1023](a,b);return}function dF(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function eF(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0;g=r;r=r+80|0;m=g+64|0;l=g+48|0;j=g+32|0;i=g+16|0;h=g;n=k[(k[a>>2]|0)+108>>2]|0;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=b;k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=c;c=j+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[j>>2]=33619968;k[j+4>>2]=d;d=i+4+4|0;k[d>>2]=0;k[d+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=e;e=h+4+4|0;k[e>>2]=0;k[e+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=f;f=Sf[n&127](a,m,l,j,i,h)|0;r=g;return f|0}function fF(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Sf[k[a>>2]&127](b,c,d,e,f,g)|0}function gF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=r;r=r+32|0;g=e+16|0;f=e;h=k[(k[b>>2]|0)+96>>2]|0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=c;c=f+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[f>>2]=33619968;k[f+4>>2]=d;dh[h&255](a,b,g,f);r=e;return}function hF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;f=r;r=r+16|0;e=f;dh[k[a>>2]&255](e,b,c,d);while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}b=0;while(1){if((b|0)==2)break;p[a+(b<<3)>>3]=+p[e+(b<<3)>>3];b=b+1|0}r=f;return a|0}function iF(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function jF(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+80>>2]&1023](a,b);return}function kF(a,b,c){a=a|0;b=b|0;c=c|0;jh[k[a>>2]&1023](b,c);return}function lF(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+72>>2]&1023](a,b);return}function mF(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;Uh[a&2047](b);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[b>>2];d=b+4|0;k[a+4>>2]=k[d>>2];k[b>>2]=0;k[d>>2]=0;r=c;return a|0}function nF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0;f=r;r=r+64|0;j=f+48|0;i=f+32|0;h=f+16|0;g=f;l=k[(k[a>>2]|0)+100>>2]|0;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=b;b=i+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[i>>2]=33619968;k[i+4>>2]=c;c=h+4+4|0;k[c>>2]=0;k[c+4>>2]=0;k[h>>2]=33619968;k[h+4>>2]=d;d=g+4+4|0;k[d>>2]=0;k[d+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=e;e=$g[l&127](a,j,i,h,g)|0;r=f;return e|0}function oF(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return $g[k[a>>2]&127](b,c,d,e,f)|0}function pF(a){a=a|0;return k[a+4>>2]|0}function qF(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function rF(a){a=a|0;return 0}function sF(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(a);return}function tF(a){a=a|0;var b=0,c=0;b=r;r=r+16|0;hd(a|0)|0;if(Ud(830656,4)|0)zob(427231,b);a=Ue(k[207665]|0)|0;if((a|0?(c=k[a>>2]|0,c|0):0)?(b=c+48|0,(k[b>>2]&-256|0)==1126902528?(k[b+4>>2]|0)==1129074247:0):0)Rob(k[c+12>>2]|0);c=k[43143]|0;k[43143]=c+0;Rob(c)}function uF(a){a=a|0;return a|0}function vF(a){a=a|0;return a|0}function wF(a){a=a|0;return a|0}function xF(a){a=a|0;return a|0}function yF(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;while(1){b=fgb(12)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;h=b+4|0;k[h>>2]=0;f=b+8|0;k[f>>2]=0;g=a+4|0;d=(k[g>>2]|0)-(k[a>>2]|0)|0;if(!d)return b|0;e=(d|0)/56|0;if(e>>>0>76695844)ad(426534,426557,304,426811);while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[h>>2]=c;k[b>>2]=c;k[f>>2]=c+(e*56|0);e=k[g>>2]|0;d=k[a>>2]|0;while(1){if((d|0)==(e|0))break;AF(c,d);a=(k[h>>2]|0)+56|0;k[h>>2]=a;d=d+56|0;c=a}return b|0}function zF(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;e=k[a>>2]|0;if(!e)return;f=a+4|0;while(1){g=k[f>>2]|0;if((e|0)==(g|0))break;k[f>>2]=g+-56;d=g+-20|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[g+-24>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=g+-40|0;c=g+-52|0;d=g+-16|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[g+-12>>2]|0;if((b|0)==(g+-8|0)|(b|0)==0)continue;ggb(k[b+-4>>2]|0)}ggb(k[a>>2]|0);return}function AF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;k[a>>2]=k[b>>2];h=a+4|0;d=b+4|0;k[h>>2]=k[d>>2];f=a+8|0;k[f>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];k[a+20>>2]=k[b+20>>2];k[a+24>>2]=k[b+24>>2];k[a+28>>2]=k[b+28>>2];k[a+32>>2]=k[b+32>>2];c=k[b+36>>2]|0;k[a+36>>2]=c;e=a+40|0;k[e>>2]=f;f=a+48|0;g=a+44|0;k[g>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(c|0){f=c+12|0;k[f>>2]=(k[f>>2]|0)+1}if((k[d>>2]|0)<3){h=b+44|0;k[k[g>>2]>>2]=k[k[h>>2]>>2];k[(k[g>>2]|0)+4>>2]=k[(k[h>>2]|0)+4>>2];return}k[h>>2]=0;x1(a,k[d>>2]|0,0,0,0);if((k[h>>2]|0)<=0)return;f=k[b+40>>2]|0;e=k[e>>2]|0;d=k[b+44>>2]|0;c=k[g>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[f+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0));return}function BF(a){a=a|0;return a|0}function CF(a){a=a|0;return a|0}function DF(a){a=a|0;return a|0}function EF(a){a=a|0;return a|0}function FF(a){a=a|0;return a|0}function GF(a){a=a|0;return a|0}function HF(a){a=a|0;var b=0,c=0;b=k[a>>2]|0;k[a+4>>2]=0;k[a>>2]=0;if(!b)return;c=b+-4|0;a=k[c>>2]|0;k[c>>2]=a+-1;if((a|0)!=1)return;ggb(k[b+-8>>2]|0);return}function IF(a){a=a|0;return a|0}function JF(a){a=a|0;return a|0}function KF(a){a=a|0;return a|0}function LF(a){a=a|0;return a|0}function MF(a){a=a|0;return a|0}function NF(a){a=a|0;return a|0}function OF(a){a=a|0;return a|0}function PF(a){a=a|0;return a|0}function QF(a){a=a|0;return a|0}function RF(a){a=a|0;return a|0}function SF(a){a=a|0;return a|0}function TF(a){a=a|0;return a|0}function UF(a){a=a|0;return a|0}function VF(a){a=a|0;return a|0}function WF(a){a=a|0;return a|0}function XF(a){a=a|0;return a|0}function YF(a){a=a|0;return a|0}function ZF(a){a=a|0;return a|0}function _F(a){a=a|0;return a|0}function $F(a){a=a|0;return a|0}function aG(a){a=a|0;return a|0}function bG(a){a=a|0;return a|0}function cG(a){a=a|0;return a|0}function dG(a){a=a|0;return a|0}function eG(a){a=a|0;return a|0}function fG(a){a=a|0;return a|0}function gG(a){a=a|0;return a|0}function hG(a){a=a|0;return a|0}function iG(a){a=a|0;return a|0}function jG(a){a=a|0;return a|0}function kG(a){a=a|0;return a|0}function lG(a){a=a|0;return a|0}function mG(a){a=a|0;return a|0}function nG(a){a=a|0;return a|0}function oG(a){a=a|0;return a|0}function pG(a){a=a|0;return a|0}function qG(a){a=a|0;return a|0}function rG(a){a=a|0;return a|0}function sG(a){a=a|0;return a|0}function tG(a){a=a|0;return a|0}function uG(a){a=a|0;return a|0}function vG(a){a=a|0;return a|0}function wG(a){a=a|0;if(!a){a=0;return a|0}a=Kob(a,10416,20976,-1)|0;return a|0}function xG(a){a=a|0;if(!a){a=0;return a|0}a=a+(k[(k[a>>2]|0)+-40>>2]|0)|0;return a|0}function yG(a){a=a|0;return a|0}function zG(a){a=a|0;return a|0}function AG(a){a=a|0;return a|0}function BG(a){a=a|0;return a|0}function CG(a){a=a|0;return a|0}function DG(a){a=a|0;return a|0}function EG(a){a=a|0;return a|0}function FG(a){a=a|0;return a|0}function GG(a){a=a|0;return a|0}function HG(a){a=a|0;return a|0}function IG(a){a=a|0;return a|0}function JG(a){a=a|0;return a|0}function KG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;if((a|0)==(b|0))return a|0;o=b+36|0;c=k[o>>2]|0;if(c|0){n=c+12|0;k[n>>2]=(k[n>>2]|0)+1}n=a+36|0;c=k[n>>2]|0;if(c|0?(l=c+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){d=k[n>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[a+32>>2]|0;if(!c){c=B1()|0;d=k[n>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[n>>2]=0}k[n>>2]=0;j=a+16|0;l=a+24|0;m=a+4|0;e=a+40|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;c=0;while(1){d=k[m>>2]|0;if((c|0)>=(d|0))break;k[(k[e>>2]|0)+(c<<2)>>2]=0;c=c+1|0}h=a+28|0;i=a+20|0;k[a>>2]=k[b>>2];c=k[b+4>>2]|0;if(!((d|0)<3&(c|0)<3)){x1(a,c,0,0,0);if((k[m>>2]|0)>0){g=k[b+40>>2]|0;d=k[e>>2]|0;e=k[b+44>>2]|0;f=k[a+44>>2]|0;c=0;do{k[d+(c<<2)>>2]=k[g+(c<<2)>>2];k[f+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[m>>2]|0))}}else{k[m>>2]=c;k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];g=b+44|0;m=a+44|0;k[k[m>>2]>>2]=k[k[g>>2]>>2];k[(k[m>>2]|0)+4>>2]=k[(k[g>>2]|0)+4>>2]}k[j>>2]=k[b+16>>2];k[i>>2]=k[b+20>>2];k[l>>2]=k[b+24>>2];k[h>>2]=k[b+28>>2];k[a+32>>2]=k[b+32>>2];k[n>>2]=k[o>>2];return a|0}function LG(a){a=a|0;return a|0}function MG(a){a=a|0;return a|0}function NG(a){a=a|0;return a|0}function OG(a){a=a|0;return a|0}function PG(a){a=a|0;return a|0}function QG(a){a=a|0;return a|0}function RG(a){a=a|0;return a|0}function SG(a){a=a|0;return a|0}function TG(a){a=a|0;return a|0}function UG(a){a=a|0;return a|0}function VG(a){a=a|0;return a|0}function WG(a){a=a|0;return a|0}function XG(a){a=a|0;return a|0}function YG(a){a=a|0;return a|0}function ZG(a){a=a|0;return a|0}function _G(a){a=a|0;return a|0}function $G(a){a=a|0;return a|0}function aH(a){a=a|0;return a|0}function bH(a){a=a|0;return a|0}function cH(a){a=a|0;return a|0}function dH(a){a=a|0;return a|0}function eH(a){a=a|0;return a|0}function fH(a){a=a|0;return a|0}function gH(a){a=a|0;return a|0}function hH(a){a=a|0;return a|0}function iH(a){a=a|0;return a|0}function jH(a){a=a|0;return a|0}function kH(a){a=a|0;return a|0}function lH(a){a=a|0;return a|0}function mH(a){a=a|0;return a|0}function nH(a){a=a|0;return a|0}function oH(a){a=a|0;return a|0}function pH(a){a=a|0;return a|0}function qH(a){a=a|0;return a|0}function rH(a){a=a|0;return a|0}function sH(a){a=a|0;return a|0}function tH(a){a=a|0;return a|0}function uH(a){a=a|0;return a|0}function vH(a){a=a|0;return a|0}function wH(a){a=a|0;return a|0}function xH(a){a=a|0;return a|0}function yH(a){a=a|0;return a|0}function zH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;j=c;i=b;h=j-i|0;m=h>>2;g=a+8|0;d=k[g>>2]|0;e=k[a>>2]|0;l=e;f=e;if(m>>>0<=d-e>>2>>>0){h=a+4|0;g=(k[h>>2]|0)-e>>2;a=m>>>0>g>>>0;g=a?b+(g<<2)|0:c;c=g;d=c-i|0;f=d>>2;if(f|0)wpb(e|0,b|0,d|0)|0;e=l+(f<<2)|0;if(a){d=j-c|0;if((d|0)<=0)return;upb(k[h>>2]|0,g|0,d|0)|0;k[h>>2]=(k[h>>2]|0)+(d>>2<<2);return}else{d=k[h>>2]|0;while(1){if((e|0)==(d|0))break;b=d+-4|0;k[h>>2]=b;d=b}return}}if(e){d=a+4|0;e=k[d>>2]|0;while(1){if((l|0)==(e|0))break;j=e+-4|0;k[d>>2]=j;e=j}ggb(f);k[g>>2]=0;k[d>>2]=0;k[a>>2]=0;e=0;d=0}if(m>>>0>1073741823)ad(426534,426557,304,426811);d=d-e|0;if(d>>2>>>0<536870911){d=d>>1;d=d>>>0<m>>>0?m:d}else d=1073741823;AH(a,d);d=a+4|0;if((h|0)<=0)return;upb(k[d>>2]|0,b|0,h|0)|0;k[d>>2]=(k[d>>2]|0)+(m<<2);return}function AH(a,b){a=a|0;b=b|0;var c=0,d=0;if(b>>>0>1073741823)ad(426534,426557,304,426811);d=b<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[a+4>>2]=c;k[a>>2]=c;k[a+8>>2]=c+(b<<2);return}function BH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;k[a>>2]=0;e=a+4|0;k[e>>2]=0;k[a+8>>2]=0;d=b+4|0;c=(k[d>>2]|0)-(k[b>>2]|0)>>2;if(!c)return;AH(a,c);b=k[b>>2]|0;a=(k[d>>2]|0)-b|0;if((a|0)<=0)return;upb(k[e>>2]|0,b|0,a|0)|0;k[e>>2]=(k[e>>2]|0)+(a>>2<<2);return}function CH(a){a=a|0;return a|0}function DH(a){a=a|0;return a|0}function EH(a){a=a|0;return a|0}function FH(a){a=a|0;return a|0}function GH(a){a=a|0;return a|0}function HH(a){a=a|0;return a|0}function IH(a,b){a=a|0;b=b|0;Uh[a&2047](b);return}function JH(a){a=a|0;return Nh[a&127]()|0}function KH(a){a=a|0;Qh[a&7]();return}function LH(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;i=r;r=r+16|0;j=i;k[j>>2]=k[e>>2];k[j+4>>2]=k[e+4>>2];Eh[a&127](b,c,d,j,f,g,h);r=i;return}function MH(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Lg[a&255](b,c,d,e,f,g);return}function NH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b,c,d,e,f);return}function OH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;return +(+Tg[a&1](b,c,d,e,f))}function PH(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;_g[a&7](b,c,d,e,f,g);return}function QH(a,b){a=a|0;b=b|0;var c=0,d=0;d=r;r=r+32|0;c=d;jh[a&1023](c,b);while(1){a=fgb(32)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}b=0;while(1){if((b|0)==4)break;p[a+(b<<3)>>3]=+p[c+(b<<3)>>3];b=b+1|0}r=d;return a|0}function RH(a,b,c){a=a|0;b=b|0;c=c|0;jh[a&1023](b,c);return}function SH(a,b,c){a=a|0;b=b|0;c=c|0;return Hh[a&511](b,c)|0}function TH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Dg[a&127](b,c,d,e)|0}function UH(a,b,c){a=a|0;b=b|0;c=c|0;jh[a&1023](b,c);return}function VH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;var j=0,l=0;j=r;r=r+16|0;l=j;k[l>>2]=k[g>>2];k[l+4>>2]=k[g+4>>2];Jh[a&3](b,c,d,e,f,l,h,i);r=j;return}function WH(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=r;r=r+16|0;i=h;k[i>>2]=k[e>>2];k[i+4>>2]=k[e+4>>2];Lg[a&255](b,c,d,i,f,g);r=h;return}function XH(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;Zh[a&7](b,c,d,e);return}function YH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[a&255](b,c,d)|0}function ZH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[a&255](b,c,d,e);return}function _H(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Eh[a&127](b,c,d,e,f,g,h);return}function $H(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[a&511](b,c,d);return}function aI(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,i=0;h=r;r=r+16|0;i=h;k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2];k[i+8>>2]=k[g+8>>2];k[i+12>>2]=k[g+12>>2];ag[a&3](b,c,d,e,f,i);r=h;return}function bI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[a&255](b,c,d,e);return}function cI(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+64|0;s=v+40|0;t=v+32|0;u=v;o=c+4|0;q=k[c>>2]|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;if(q>>>0>4294967279)hob();if(q>>>0<11){i[s+11>>0]=q;if(!q)c=s;else{c=s;m=10}}else{n=q+16&-16;m=(n|0)==0?1:n;while(1){c=fgb(m)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[s>>2]=c;k[s+8>>2]=n|-2147483648;k[s+4>>2]=q;m=10}if((m|0)==10)upb(c|0,o|0,q|0)|0;i[c+q>>0]=0;k[t>>2]=k[d>>2];k[t+4>>2]=k[d+4>>2];c=0;while(1){if((c|0)==4)break;p[u+(c<<3)>>3]=+p[g+(c<<3)>>3];c=c+1|0}Yf[a&7](b,s,t,e,f,u,h,j,l);if((i[s+11>>0]|0)>=0){r=v;return}ggb(k[s>>2]|0);r=v;return}function dI(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;$f[a&15](b,c,d);return}function eI(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Eh[a&127](b,c,d,e,f,g,h);return}function fI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0;f=r;r=r+16|0;g=f;k[g>>2]=k[c>>2];k[g+4>>2]=k[c+4>>2];e=+Ug[a&31](b,g,d);r=f;return +e}function gI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[a&255](b,c,d,e);return}function hI(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;Vg[a&3](b,c,d,e,f,g);return}function iI(a,b,c){a=a|0;b=b|0;c=+c;gh[a&255](b,c);return}function jI(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;wg[a&1](b,c,d,e,f,g,h);return}function kI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+wh[a&31](b,c,d,e))}function lI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Ug[a&31](b,c,d))}function mI(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;$h[a&7](b,c,d,e,f,g);return}function nI(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b,c,d,e,f);return}function oI(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0;j=r;r=r+16|0;l=j;k[l>>2]=k[f>>2];k[l+4>>2]=k[f+4>>2];sh[a&255](b,c,d,e,l,g,h,i);r=j;return}function pI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=r;r=r+192|0;d=e;Ph[a&511](d,b,c);while(1){a=fgb(192)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}upb(a|0,d|0,192)|0;r=e;return a|0}function qI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[a&511](b,c,d);return}function rI(a,b,c){a=a|0;b=b|0;c=c|0;return +(+og[a&63](b,c))}function sI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[a&255](b,c,d,e);return}function tI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=r;r=r+16|0;f=e;k[f>>2]=k[d>>2];k[f+4>>2]=k[d+4>>2];k[f+8>>2]=k[d+8>>2];k[f+12>>2]=k[d+12>>2];d=ci[a&255](b,c,f)|0;r=e;return d|0}function uI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=r;r=r+32|0;d=e;Ph[a&511](d,b,c);while(1){a=fgb(32)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}b=0;while(1){if((b|0)==4)break;p[a+(b<<3)>>3]=+p[d+(b<<3)>>3];b=b+1|0}r=e;return a|0}function vI(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b,c,d,e,f);return}function wI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return +(+rh[a&1](b,c,d,e))}function xI(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;var g=0,h=0;g=r;r=r+16|0;h=g;k[h>>2]=k[d>>2];k[h+4>>2]=k[d+4>>2];Og[a&15](b,c,h,e,f);r=g;return}function yI(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0;i=r;r=r+16|0;l=i+8|0;j=i;k[l>>2]=k[c>>2];k[l+4>>2]=k[c+4>>2];k[j>>2]=k[d>>2];k[j+4>>2]=k[d+4>>2];Eh[a&127](b,l,j,e,f,g,h);r=i;return}function zI(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,l=0;j=r;r=r+16|0;l=j;k[l>>2]=k[e>>2];k[l+4>>2]=k[e+4>>2];k[l+8>>2]=k[e+8>>2];k[l+12>>2]=k[e+12>>2];i=+lg[a&3](b,c,d,l,f,g,h);r=j;return +i}function AI(a,b){a=a|0;b=b|0;return Xh[a&1023](b)|0}function BI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Ug[a&31](b,c,d))}function CI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+wh[a&31](b,c,d,e))}function DI(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Lg[a&255](b,c,d,e,f,g);return}function EI(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;var l=0,m=0;l=r;r=r+16|0;m=l;k[m>>2]=k[d>>2];k[m+4>>2]=k[d+4>>2];j=+Lh[a&1](b,c,m,e,f,g,h,i,j);r=l;return +j}function FI(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0;j=r;r=r+16|0;l=j;k[l>>2]=k[f>>2];k[l+4>>2]=k[f+4>>2];sh[a&255](b,c,d,e,l,g,h,i);r=j;return}function GI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;g=b+4|0;h=k[b>>2]|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;if(h>>>0>4294967279)hob();if(h>>>0<11){i[j+11>>0]=h;if(!h)b=j;else{b=j;e=10}}else{f=h+16&-16;e=(f|0)==0?1:f;while(1){b=fgb(e)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[j>>2]=b;k[j+8>>2]=f|-2147483648;k[j+4>>2]=h;e=10}if((e|0)==10)upb(b|0,g|0,h|0)|0;i[b+h>>0]=0;b=ci[a&255](j,c,d)|0;if((i[j+11>>0]|0)>=0){r=l;return b|0}ggb(k[j>>2]|0);r=l;return b|0}function HI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;g=b+4|0;h=k[b>>2]|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;if(h>>>0>4294967279)hob();if(h>>>0<11){i[j+11>>0]=h;if(!h)b=j;else{b=j;e=10}}else{f=h+16&-16;e=(f|0)==0?1:f;while(1){b=fgb(e)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[j>>2]=b;k[j+8>>2]=f|-2147483648;k[j+4>>2]=h;e=10}if((e|0)==10)upb(b|0,g|0,h|0)|0;i[b+h>>0]=0;b=ci[a&255](j,c,d)|0;if((i[j+11>>0]|0)>=0){r=l;return b|0}ggb(k[j>>2]|0);r=l;return b|0}function II(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;m=r;r=r+80|0;j=m+16|0;l=m;f=b+4|0;g=k[b>>2]|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;if(g>>>0>4294967279)hob();if(g>>>0<11){i[l+11>>0]=g;if(!g)b=l;else{b=l;d=10}}else{e=g+16&-16;d=(e|0)==0?1:e;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[l>>2]=b;k[l+8>>2]=e|-2147483648;k[l+4>>2]=g;d=10}if((d|0)==10)upb(b|0,f|0,g|0)|0;i[b+g>>0]=0;Ph[a&511](j,l,c);while(1){b=fgb(56)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=k[j>>2];d=j+4|0;k[b+4>>2]=k[d>>2];g=b+8|0;e=j+8|0;k[g>>2]=k[e>>2];k[b+12>>2]=k[j+12>>2];c=j+16|0;k[b+16>>2]=k[c>>2];k[b+20>>2]=k[j+20>>2];k[b+24>>2]=k[j+24>>2];k[b+28>>2]=k[j+28>>2];k[b+32>>2]=k[j+32>>2];h=j+36|0;k[b+36>>2]=k[h>>2];f=b+40|0;k[f>>2]=g;g=b+44|0;a=b+48|0;k[g>>2]=a;k[b+52>>2]=0;k[a>>2]=0;if((k[d>>2]|0)<3){f=k[j+44>>2]|0;k[a>>2]=k[f>>2];k[(k[g>>2]|0)+4>>2]=k[f+4>>2]}else{n=j+44|0;k[g>>2]=k[n>>2];a=j+40|0;k[f>>2]=k[a>>2];k[n>>2]=j+48;k[a>>2]=e}k[j>>2]=1124007936;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[h>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;d=k[j+44>>2]|0;if(!((d|0)==(j+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);if((i[l+11>>0]|0)>=0){r=m;return b|0}ggb(k[l>>2]|0);r=m;return b|0}function JI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;l=m;h=b+4|0;j=k[b>>2]|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;if(j>>>0>4294967279)hob();if(j>>>0<11){i[l+11>>0]=j;if(!j)b=l;else{b=l;f=10}}else{g=j+16&-16;f=(g|0)==0?1:g;while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[l>>2]=b;k[l+8>>2]=g|-2147483648;k[l+4>>2]=j;f=10}if((f|0)==10)upb(b|0,h|0,j|0)|0;i[b+j>>0]=0;b=Dg[a&127](l,c,d,e)|0;if((i[l+11>>0]|0)>=0){r=m;return b|0}ggb(k[l>>2]|0);r=m;return b|0}function KI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;Ph[a&511](i,b,c);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function LI(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;Ng[a&7](b,c,d,e,f);return}function MI(a,b,c){a=a|0;b=b|0;c=c|0;jh[a&1023](b,c);return}function NI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;ah[a&31](b,c,d,e);return}function OI(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;i=r;r=r+16|0;j=i;k[j>>2]=k[d>>2];k[j+4>>2]=k[d+4>>2];k[j+8>>2]=k[d+8>>2];k[j+12>>2]=k[d+12>>2];Eh[a&127](b,c,j,e,f,g,h);r=i;return}function PI(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;pg[a&1](b,c,d,e,f,g,h,i,j);return}function QI(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+32|0;m=o+16|0;n=o;j=b+4|0;l=k[b>>2]|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;if(l>>>0>4294967279)hob();if(l>>>0<11){i[n+11>>0]=l;if(!l)b=n;else{b=n;g=10}}else{h=l+16&-16;g=(h|0)==0?1:h;while(1){b=fgb(g)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[n>>2]=b;k[n+8>>2]=h|-2147483648;k[n+4>>2]=l;g=10}if((g|0)==10)upb(b|0,j|0,l|0)|0;i[b+l>>0]=0;gg[a&7](m,n,c,d,e,f);while(1){b=fgb(8)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=k[m>>2];k[b+4>>2]=k[m+4>>2];if((i[n+11>>0]|0)>=0){r=o;return b|0}ggb(k[n>>2]|0);r=o;return b|0}function RI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+80|0;i=j+16|0;g=j+8|0;h=j;k[g>>2]=k[c>>2];k[g+4>>2]=k[c+4>>2];k[h>>2]=k[d>>2];k[h+4>>2]=k[d+4>>2];dh[a&255](i,b,g,h);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function SI(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;m=r;r=r+64|0;l=m+8|0;j=m;k[j>>2]=k[b>>2];k[j+4>>2]=k[b+4>>2];mh[a&15](l,j,c,d);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[l>>2];b=l+4|0;k[a+4>>2]=k[b>>2];g=a+8|0;e=l+8|0;k[g>>2]=k[e>>2];k[a+12>>2]=k[l+12>>2];i=l+16|0;k[a+16>>2]=k[i>>2];k[a+20>>2]=k[l+20>>2];k[a+24>>2]=k[l+24>>2];k[a+28>>2]=k[l+28>>2];k[a+32>>2]=k[l+32>>2];j=l+36|0;k[a+36>>2]=k[j>>2];f=a+40|0;k[f>>2]=g;g=a+44|0;h=a+48|0;k[g>>2]=h;k[a+52>>2]=0;k[h>>2]=0;if((k[b>>2]|0)<3){f=k[l+44>>2]|0;k[h>>2]=k[f>>2];k[(k[g>>2]|0)+4>>2]=k[f+4>>2]}else{n=l+44|0;k[g>>2]=k[n>>2];h=l+40|0;k[f>>2]=k[h>>2];k[n>>2]=l+48;k[h>>2]=e}k[l>>2]=1124007936;e=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(e|0));k[j>>2]=0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;b=k[l+44>>2]|0;if((b|0)==(l+48|0)|(b|0)==0){r=m;return a|0}ggb(k[b+-4>>2]|0);r=m;return a|0}function TI(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=r;r=r+16|0;i=g+8|0;h=g;k[i>>2]=k[c>>2];k[i+4>>2]=k[c+4>>2];k[h>>2]=k[d>>2];k[h+4>>2]=k[d+4>>2];eh[a&255](b,i,h,e,f);r=g;return}function UI(a,b){a=a|0;b=b|0;return Xh[a&1023](b)|0}function VI(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=r;r=r+64|0;j=l;nh[a&15](j,b,c,d);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[j>>2];b=j+4|0;k[a+4>>2]=k[b>>2];f=a+8|0;d=j+8|0;k[f>>2]=k[d>>2];k[a+12>>2]=k[j+12>>2];h=j+16|0;k[a+16>>2]=k[h>>2];k[a+20>>2]=k[j+20>>2];k[a+24>>2]=k[j+24>>2];k[a+28>>2]=k[j+28>>2];k[a+32>>2]=k[j+32>>2];i=j+36|0;k[a+36>>2]=k[i>>2];e=a+40|0;k[e>>2]=f;f=a+44|0;g=a+48|0;k[f>>2]=g;k[a+52>>2]=0;k[g>>2]=0;if((k[b>>2]|0)<3){e=k[j+44>>2]|0;k[g>>2]=k[e>>2];k[(k[f>>2]|0)+4>>2]=k[e+4>>2]}else{m=j+44|0;k[f>>2]=k[m>>2];g=j+40|0;k[e>>2]=k[g>>2];k[m>>2]=j+48;k[g>>2]=d}k[j>>2]=1124007936;d=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(d|0));k[i>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;b=k[j+44>>2]|0;if((b|0)==(j+48|0)|(b|0)==0){r=l;return a|0}ggb(k[b+-4>>2]|0);r=l;return a|0}function WI(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;h=h|0;var i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;p=r;r=r+64|0;o=p+8|0;n=p;k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];ng[a&1](o,n,c,d,e,f,g,h);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[o>>2];b=o+4|0;k[a+4>>2]=k[b>>2];j=a+8|0;h=o+8|0;k[j>>2]=k[h>>2];k[a+12>>2]=k[o+12>>2];m=o+16|0;k[a+16>>2]=k[m>>2];k[a+20>>2]=k[o+20>>2];k[a+24>>2]=k[o+24>>2];k[a+28>>2]=k[o+28>>2];k[a+32>>2]=k[o+32>>2];n=o+36|0;k[a+36>>2]=k[n>>2];i=a+40|0;k[i>>2]=j;j=a+44|0;l=a+48|0;k[j>>2]=l;k[a+52>>2]=0;k[l>>2]=0;if((k[b>>2]|0)<3){i=k[o+44>>2]|0;k[l>>2]=k[i>>2];k[(k[j>>2]|0)+4>>2]=k[i+4>>2]}else{q=o+44|0;k[j>>2]=k[q>>2];l=o+40|0;k[i>>2]=k[l>>2];k[q>>2]=o+48;k[l>>2]=h}k[o>>2]=1124007936;h=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(h|0));k[n>>2]=0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;b=k[o+44>>2]|0;if((b|0)==(o+48|0)|(b|0)==0){r=p;return a|0}ggb(k[b+-4>>2]|0);r=p;return a|0}function XI(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Eh[a&127](b,c,d,e,f,g,h);return}function YI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j+8|0;h=j;k[h>>2]=k[c>>2];k[h+4>>2]=k[c+4>>2];dh[a&255](i,b,h,d);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function ZI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;Ph[a&511](i,b,c);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function _I(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;di[a&1](b,c,d,e,f,g,h);return}function $I(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;Vg[a&3](b,c,d,e,f,g);return}function aJ(a,b){a=a|0;b=b|0;var c=0,d=0;d=r;r=r+32|0;c=d;jh[a&1023](c,b);while(1){a=fgb(20)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[a+16>>2]=k[c+16>>2];r=d;return a|0}function bJ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0;i=r;r=r+16|0;j=i;k[j>>2]=k[f>>2];k[j+4>>2]=k[f+4>>2];k[j+8>>2]=k[f+8>>2];k[j+12>>2]=k[f+12>>2];h=+pi[a&7](b,c,d,e,j,g);r=i;return +h}function cJ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=r;r=r+16|0;i=h;k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2];Lg[a&255](b,c,d,e,f,i);r=h;return}function dJ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;var i=0,j=0;i=r;r=r+16|0;j=i;k[j>>2]=k[f>>2];k[j+4>>2]=k[f+4>>2];cg[a&3](b,c,d,e,j,g,h);r=i;return}function eJ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=r;r=r+16|0;i=h;k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2];Lg[a&255](b,c,d,e,f,i);r=h;return}function fJ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b,c,d,e,f);return}function gJ(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;sh[a&255](b,c,d,e,f,g,h,i);return}function hJ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;gi[a&1](b,c,d,e,f,g,h);return}function iJ(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;ei[a&3](b,c,d,e,f,g,h,i);return}function jJ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;ag[a&3](b,c,d,e,f,g);return}function kJ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Lg[a&255](b,c,d,e,f,g);return}function lJ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;bh[a&3](b,c,d,e,f);return}function mJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;dh[a&255](i,b,c,d);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function nJ(a,b,c){a=a|0;b=b|0;c=c|0;jh[a&1023](b,c);return}function oJ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0;i=r;r=r+16|0;l=i+8|0;j=i;k[l>>2]=k[b>>2];k[l+4>>2]=k[b+4>>2];k[j>>2]=k[c>>2];k[j+4>>2]=k[c+4>>2];Eh[a&127](l,j,d,e,f,g,h);r=i;return}function pJ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b,c,d,e,f);return}function qJ(a,b,c,d,e,f,g,h,i,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;l=l|0;var m=0,n=0,o=0;m=r;r=r+16|0;o=m+8|0;n=m;k[o>>2]=k[c>>2];k[o+4>>2]=k[c+4>>2];k[n>>2]=k[d>>2];k[n+4>>2]=k[d+4>>2];th[a&1](b,o,n,e,f,g,h,i,j,l);r=m;return}function rJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[a&255](b,c,d)|0}function sJ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;Ng[a&7](b,c,d,e,f);return}function tJ(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;Sg[a&31](b,c,d,e,f,g,h,i,j,k);return}function uJ(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;Sg[a&31](b,c,d,e,f,g,h,i,j,k);return}function vJ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;i=r;r=r+16|0;j=i;k[j>>2]=k[c>>2];k[j+4>>2]=k[c+4>>2];Eh[a&127](b,j,d,e,f,g,h);r=i;return}function wJ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b,c,d,e,f);return}function xJ(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var l=0,m=0;l=r;r=r+16|0;m=l;k[m>>2]=k[j>>2];k[m+4>>2]=k[j+4>>2];Gh[a&127](b,c,d,e,f,g,h,i,m);r=l;return}function yJ(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;Kh[a&1](b,c,d,e);return}function zJ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;Og[a&15](b,c,d,e,f);return}function AJ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Lg[a&255](b,c,d,e,f,g);return}function BJ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;i=r;r=r+16|0;j=i;k[j>>2]=k[e>>2];k[j+4>>2]=k[e+4>>2];Eh[a&127](b,c,d,j,f,g,h);r=i;return}function CJ(a,b){a=a|0;b=b|0;return +(+hg[a&127](b))}function DJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;mh[a&15](b,c,d,e);return}function EJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;nh[a&15](b,c,d,e);return}function FJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[a&511](b,c,d);return}function GJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[a&255](b,c,d,e);return}function HJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=r;r=r+16|0;f=e;k[f>>2]=k[c>>2];k[f+4>>2]=k[c+4>>2];Ph[a&511](b,f,d);r=e;return}function IJ(a,b){a=a|0;b=b|0;return Xh[a&1023](b)|0}function JJ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=r;r=r+32|0;h=g;j=g+24|0;i=g+16|0;k[j>>2]=k[d>>2];k[j+4>>2]=k[d+4>>2];k[i>>2]=k[e>>2];k[i+4>>2]=k[e+4>>2];k[h>>2]=k[f>>2];k[h+4>>2]=k[f+4>>2];k[h+8>>2]=k[f+8>>2];k[h+12>>2]=k[f+12>>2];eh[a&255](b,c,j,i,h);r=g;return}function KJ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;$h[a&7](b,c,d,e,f,g);return}function LJ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b,c,d,e,f);return}function MJ(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;sh[a&255](b,c,d,e,f,g,h,i);return}function NJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[a&255](b,c,d,e);return}function OJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;mh[a&15](b,c,d,e);return}function PJ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Lg[a&255](b,c,d,e,f,g);return}function QJ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Sf[a&127](b,c,d,e,f,g)|0}function RJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Dg[a&127](b,c,d,e)|0}function SJ(a,b,c){a=a|0;b=b|0;c=c|0;jh[a&1023](b,c);return}function TJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Ug[a&31](b,c,d))}function UJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[a&255](b,c,d,e);return}function VJ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;Vg[a&3](b,c,d,e,f,g);return}function WJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=r;r=r+16|0;f=e;k[f>>2]=k[b>>2];k[f+4>>2]=k[b+4>>2];k[f+8>>2]=k[b+8>>2];k[f+12>>2]=k[b+12>>2];d=ci[a&255](f,c,d)|0;r=e;return d|0}function XJ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;i=r;r=r+16|0;j=i;k[j>>2]=k[c>>2];k[j+4>>2]=k[c+4>>2];Eh[a&127](b,j,d,e,f,g,h);r=i;return}function YJ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b,c,d,e,f);return}function ZJ(a,b,c,d,e,f,g,h,i,j,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;l=l|0;m=+m;var n=0,o=0,p=0;n=r;r=r+32|0;o=n;p=n+16|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[o>>2]=k[j>>2];k[o+4>>2]=k[j+4>>2];k[o+8>>2]=k[j+8>>2];k[o+12>>2]=k[j+12>>2];Xf[a&1](b,c,d,e,f,g,p,i,o,l,m);r=n;return}function _J(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;Zg[a&1](b,c,d,e,f,g,h,i,j,k);return}function $J(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Eh[a&127](b,c,d,e,f,g,h);return}function aK(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b,c,d,e,f);return}function bK(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;Jg[a&15](b,c,d,e,f,g);return}function cK(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0;j=r;r=r+16|0;l=j;k[l>>2]=k[d>>2];k[l+4>>2]=k[d+4>>2];i=si[a&15](b,c,l,e,f,g,h,i)|0;r=j;return i|0}function dK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+32|0;e=d;k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2];k[e+12>>2]=k[b+12>>2];k[e+16>>2]=k[b+16>>2];jh[a&1023](e,c);r=d;return}function eK(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0;i=r;r=r+16|0;l=i+8|0;j=i;k[l>>2]=k[e>>2];k[l+4>>2]=k[e+4>>2];k[j>>2]=k[f>>2];k[j+4>>2]=k[f+4>>2];Eh[a&127](b,c,d,l,j,g,h);r=i;return}function fK(a,b){a=a|0;b=b|0;var c=0,d=0;d=r;r=r+16|0;c=d;jh[a&1023](c,b);while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];r=d;return a|0}function gK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[a&255](b,c,d)|0}function hK(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=r;r=r+16|0;i=g+8|0;h=g;k[i>>2]=k[d>>2];k[i+4>>2]=k[d+4>>2];k[h>>2]=k[e>>2];k[h+4>>2]=k[e+4>>2];eh[a&255](b,c,i,h,f);r=g;return}function iK(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;_g[a&7](b,c,d,e,f,g);return}function jK(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;Sg[a&31](b,c,d,e,f,g,h,i,j,k);return}function kK(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;var j=0,l=0,m=0;j=r;r=r+16|0;m=j+8|0;l=j;k[m>>2]=k[c>>2];k[m+4>>2]=k[c+4>>2];k[l>>2]=k[d>>2];k[l+4>>2]=k[d+4>>2];uh[a&1](b,m,l,e,f,g,h,i);r=j;return}function lK(a,b,c){a=a|0;b=b|0;c=c|0;return +(+og[a&63](b,c))}function mK(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;nh[a&15](b,c,d,e);return}function nK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[a&511](b,c,d);return}function oK(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;qi[a&1](b,c,d,e,f,g,h);return}function pK(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b,c,d,e,f);return}function qK(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;Ag[a&1](b,c,d,e,f,g,h);return}function rK(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;nh[a&15](b,c,d,e);return}function sK(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[a&255](b,c,d,e);return}function tK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[a&511](b,c,d);return}function uK(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;vh[a&3](b,c,d,e,f,g,h,i,j);return}function vK(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;Pf[a&3](b,c,d,e,f,g,h,i);return}function wK(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b,c,d,e,f);return}function xK(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b,c,d,e,f);return}function yK(a,b,c){a=a|0;b=b|0;c=c|0;return +(+og[a&63](b,c))}function zK(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;ah[a&31](b,c,d,e);return}function AK(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[a&255](b,c,d,e);return}function BK(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[a&255](b,c,d,e);return}function CK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Ug[a&31](b,c,d))}function DK(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;Uf[a&7](b,c,d,e,f,g,h);return}function EK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[a&511](b,c,d);return}function FK(a,b,c){a=a|0;b=b|0;c=c|0;jh[a&1023](b,c);return}function GK(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;_f[a&1](b,c,d,e,f,g,h);return}function HK(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;dg[a&1](b,c,d,e,f,g,h,i,j);return}function IK(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;Hg[a&1](b,c,d,e,f,g,h,i,j);return}function JK(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;var h=0,i=0;h=r;r=r+16|0;i=h;k[i>>2]=k[d>>2];k[i+4>>2]=k[d+4>>2];_g[a&7](b,c,i,e,f,g);r=h;return}function KK(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;ag[a&3](b,c,d,e,f,g);return}function LK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;f=r;r=r+48|0;g=f;e=f+16|0;k[g>>2]=k[d>>2];k[g+4>>2]=k[d+4>>2];k[g+8>>2]=k[d+8>>2];k[g+12>>2]=k[d+12>>2];dh[a&255](e,b,c,g);while(1){a=fgb(20)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[e>>2];k[a+4>>2]=k[e+4>>2];k[a+8>>2]=k[e+8>>2];k[a+12>>2]=k[e+12>>2];k[a+16>>2]=k[e+16>>2];r=f;return a|0}function MK(){var a=0,b=0;Wd(5064,10088,10072,0,202890,688,202497,0,202497,0,203711,202887,1420);td(5064,1,39400,202890,689,54);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=754;k[a+4>>2]=0;ze(5064,366281,3,39388,202695,243,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=244;k[a+4>>2]=0;ze(5064,335645,4,39372,202822,167,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=690;k[a+4>>2]=0;ze(5064,380512,2,39364,202749,205,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=206;ze(5064,205353,3,39352,200947,93,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=94;ze(5064,389243,4,39336,202491,48,a|0,0);Wd(9040,10056,10040,0,202890,691,202497,0,202497,0,203721,202887,1421);td(9040,1,39332,202890,692,55);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=755;k[a+4>>2]=0;ze(9040,366281,3,39320,202695,245,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=246;k[a+4>>2]=0;ze(9040,335645,4,39304,202822,168,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=693;k[a+4>>2]=0;ze(9040,380512,2,39296,202749,207,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=208;ze(9040,205353,3,39284,200947,95,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=96;ze(9040,389243,4,39268,202491,49,a|0,0);Wd(9960,10024,10008,0,202890,694,202497,0,202497,0,203732,202887,1422);td(9960,1,39264,202890,695,56);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=756;k[a+4>>2]=0;ze(9960,366281,3,39252,202695,247,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=248;k[a+4>>2]=0;ze(9960,335645,4,39236,202822,169,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=696;k[a+4>>2]=0;ze(9960,380512,2,39228,202749,209,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=210;ze(9960,205353,3,39216,200947,97,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=98;ze(9960,389243,4,39200,202491,50,a|0,0);Wd(8944,9944,9928,0,202890,697,202497,0,202497,0,203747,202887,1423);td(8944,1,39196,202890,698,57);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=757;k[a+4>>2]=0;ze(8944,366281,3,39184,202695,249,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=250;k[a+4>>2]=0;ze(8944,335645,4,39168,202822,170,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=699;k[a+4>>2]=0;ze(8944,380512,2,39160,202749,211,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=212;ze(8944,205353,3,39148,200947,99,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=100;ze(8944,389243,4,39132,202491,51,a|0,0);Wd(9848,9912,9896,0,202890,700,202497,0,202497,0,203759,202887,1424);td(9848,1,39128,202890,701,58);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=758;k[a+4>>2]=0;ze(9848,366281,3,39116,202695,251,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=252;k[a+4>>2]=0;ze(9848,335645,4,39100,202822,171,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=702;k[a+4>>2]=0;ze(9848,380512,2,39092,202749,213,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=214;ze(9848,205353,3,39080,200947,101,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=102;ze(9848,389243,4,39064,202491,52,a|0,0);Wd(9768,9832,9816,0,202890,703,202497,0,202497,0,203769,202887,1425);td(9768,1,39060,202890,704,59);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=759;k[a+4>>2]=0;ze(9768,366281,3,39048,202695,253,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=254;k[a+4>>2]=0;ze(9768,335645,4,39032,202822,172,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=705;k[a+4>>2]=0;ze(9768,380512,2,39024,202749,215,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=216;ze(9768,205353,3,39012,200947,103,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=104;ze(9768,389243,4,38996,202491,53,a|0,0);Wd(7304,9752,9736,0,202890,706,202497,0,202497,0,203781,202887,1426);td(7304,1,38992,202890,707,60);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=760;k[a+4>>2]=0;ze(7304,366281,3,38980,202882,35,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=255;k[a+4>>2]=0;ze(7304,335645,4,38964,206507,12,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=708;k[a+4>>2]=0;ze(7304,380512,2,38956,202749,217,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=218;ze(7304,205353,3,38944,200947,105,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=106;ze(7304,389243,4,38928,202109,4,a|0,0);Wd(9656,9720,9704,0,202890,709,202497,0,202497,0,203793,202887,1427);td(9656,1,38924,202890,710,61);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=761;k[a+4>>2]=0;ze(9656,366281,3,38912,202695,256,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=257;k[a+4>>2]=0;ze(9656,335645,4,38896,202822,173,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=711;k[a+4>>2]=0;ze(9656,380512,2,38888,202749,219,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=220;ze(9656,205353,3,38876,200947,107,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=108;ze(9656,389243,4,38860,202491,54,a|0,0);Wd(5704,9640,9624,0,202890,712,202497,0,202497,0,203809,202887,1428);td(5704,1,38856,202890,713,62);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=762;k[a+4>>2]=0;ze(5704,366281,3,38844,202695,258,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=259;k[a+4>>2]=0;ze(5704,335645,4,38828,202822,174,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=714;k[a+4>>2]=0;ze(5704,380512,2,38820,202749,221,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=222;ze(5704,205353,3,38808,200947,109,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=110;ze(5704,389243,4,38792,202491,55,a|0,0);Wd(8672,9608,9592,0,202890,715,202497,0,202497,0,203827,202887,1429);td(8672,1,38788,202890,716,63);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=763;k[a+4>>2]=0;ze(8672,366281,3,38776,202695,260,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=261;k[a+4>>2]=0;ze(8672,335645,4,38760,202822,175,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=717;k[a+4>>2]=0;ze(8672,380512,2,38752,202749,223,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=224;ze(8672,205353,3,38740,200947,111,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=112;ze(8672,389243,4,38724,202491,56,a|0,0);Wd(9512,9576,9560,0,202890,718,202497,0,202497,0,203839,202887,1430);td(9512,1,38720,202890,719,64);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=764;k[a+4>>2]=0;ze(9512,366281,3,38708,202695,262,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=263;k[a+4>>2]=0;ze(9512,335645,4,38692,202822,176,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=720;k[a+4>>2]=0;ze(9512,380512,2,38684,202749,225,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=226;ze(9512,205353,3,38672,200947,113,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=114;ze(9512,389243,4,38656,202491,57,a|0,0);Wd(4624,9496,9480,0,202890,721,202497,0,202497,0,203851,202887,1431);td(4624,1,38652,202890,722,65);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=765;k[a+4>>2]=0;ze(4624,366281,3,38640,202695,264,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=265;k[a+4>>2]=0;ze(4624,335645,4,38624,202822,177,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=723;k[a+4>>2]=0;ze(4624,380512,2,38616,202749,227,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=228;ze(4624,205353,3,38604,200947,115,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=116;ze(4624,389243,4,38588,202491,58,a|0,0);Wd(6544,9464,9448,0,202890,724,202497,0,202497,0,203861,202887,1432);td(6544,1,38584,202890,725,66);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=766;k[a+4>>2]=0;ze(6544,366281,3,38572,202695,266,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=267;k[a+4>>2]=0;ze(6544,335645,4,38556,202822,178,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=726;k[a+4>>2]=0;ze(6544,380512,2,38548,202749,229,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=230;ze(6544,205353,3,38536,200947,117,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=118;ze(6544,389243,4,38520,202491,59,a|0,0);Wd(4992,9432,9416,0,202890,727,202497,0,202497,0,203876,202887,1433);td(4992,1,38516,202890,728,67);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=767;k[a+4>>2]=0;ze(4992,366281,3,38504,202695,268,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=269;k[a+4>>2]=0;ze(4992,335645,4,38488,202822,179,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=729;k[a+4>>2]=0;ze(4992,380512,2,38480,202749,231,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=232;ze(4992,205353,3,38468,200947,119,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=120;ze(4992,389243,4,38452,202491,60,a|0,0);Wd(7456,9400,9384,0,202890,730,202497,0,202497,0,203887,202887,1434);td(7456,1,38448,202890,731,68);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=768;k[a+4>>2]=0;ze(7456,366281,3,38436,202695,270,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=271;k[a+4>>2]=0;ze(7456,335645,4,38420,202822,180,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=732;k[a+4>>2]=0;ze(7456,380512,2,38412,202749,233,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=234;ze(7456,205353,3,38400,200947,121,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=122;ze(7456,389243,4,38384,202491,61,a|0,0);Wd(4576,9352,9368,0,202890,733,202497,0,202497,0,203901,202887,1435);td(4576,1,38380,202890,734,69);td(4576,4,38364,205304,5,123);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;Qd(4576,389384,28960,202749,235,a|0,28960,202695,272,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=4;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=4;Qd(4576,203914,28960,202749,235,a|0,28960,202695,272,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=8;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=8;Qd(4576,370619,29032,202745,38,a|0,29032,202734,36,b|0);Wd(4568,9272,9256,0,202890,735,202497,0,202497,0,390638,202887,1436);td(4568,1,38360,202890,736,70);td(4568,3,38348,200947,124,236);td(4568,4,38332,202491,62,125);td(4568,5,38312,200915,62,63);td(4568,2,38304,202749,237,737);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=738;k[a+4>>2]=0;ze(4568,203923,2,38296,202749,238,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=739;k[a+4>>2]=0;ze(4568,203933,2,38288,202749,239,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=6;ze(4568,210549,6,38264,205296,3,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=740;k[a+4>>2]=0;ze(4568,203942,2,38296,202749,238,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=273;k[a+4>>2]=0;ze(4568,203948,3,38252,200947,126,a|0,0);qf(4568,203952,4,38236,202491,64,181);qf(4568,203952,3,38224,200947,127,274);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=182;k[a+4>>2]=0;ze(4568,389997,5,38204,201808,149,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=275;k[a+4>>2]=0;ze(4568,389997,4,38188,202822,183,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=184;k[a+4>>2]=0;ze(4568,203956,4,38172,202491,65,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=276;k[a+4>>2]=0;ze(4568,203956,3,38160,200947,128,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=769;k[a+4>>2]=0;ze(4568,233543,3,38148,202695,277,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=278;k[a+4>>2]=0;ze(4568,233543,4,38132,202822,185,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=741;k[a+4>>2]=0;ze(4568,203965,2,38296,202749,238,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=742;k[a+4>>2]=0;ze(4568,389384,2,38288,202749,239,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=743;k[a+4>>2]=0;ze(4568,219976,2,38124,202749,240,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=186;k[a+4>>2]=0;ze(4568,203974,4,38172,202491,65,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=279;k[a+4>>2]=0;ze(4568,203974,3,38160,200947,128,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=241;k[a+4>>2]=0;ze(4568,203983,3,38112,200947,129,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=770;k[a+4>>2]=0;ze(4568,388992,2,38104,202749,242,a|0,0);qf(4568,203989,4,38236,202491,64,187);qf(4568,203989,3,38224,200947,127,280);qf(4568,203994,4,38236,202491,64,188);qf(4568,203994,3,38224,200947,127,281);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=744;k[a+4>>2]=0;ze(4568,371491,2,38288,202749,239,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=282;k[a+4>>2]=0;ze(4568,204e3,3,38252,200947,126,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=39;ze(4568,216391,3,37296,203067,24,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=13;ze(4568,204004,4,38088,205304,6,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=283;ze(4568,204008,3,34900,200947,130,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=771;ze(4568,204012,2,38080,202749,243,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=8;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=8;Qd(4568,226826,28960,202749,244,a|0,28960,202695,284,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=12;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=12;Qd(4568,226831,28960,202749,244,a|0,28960,202695,284,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=745;ze(4568,225921,2,38072,202749,245,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=746;ze(4568,204014,2,38072,202749,245,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=747;ze(4568,204021,2,38072,202749,245,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=748;ze(4568,204029,2,38072,202749,245,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=749;ze(4568,204037,2,38072,202749,245,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=750;ze(4568,204045,2,38072,202749,245,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=751;ze(4568,204053,2,38072,202749,245,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=246;ze(4568,204061,3,38060,200947,131,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=132;ze(4568,204061,4,38044,202491,66,a|0,0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=772;ze(4568,380512,2,38036,202749,247,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=248;k[a+4>>2]=0;ze(4568,204065,3,38024,200947,133,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=134;k[a+4>>2]=0;ze(4568,204065,4,38008,202491,67,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=68;k[a+4>>2]=0;ze(4568,204065,5,37988,200915,63,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=249;k[a+4>>2]=0;ze(4568,204078,3,37976,200947,135,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=136;k[a+4>>2]=0;ze(4568,204078,4,37960,202491,69,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=70;k[a+4>>2]=0;ze(4568,204078,5,37940,200915,64,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=250;k[a+4>>2]=0;ze(4568,204092,3,37928,200947,137,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=138;k[a+4>>2]=0;ze(4568,204092,4,37912,202491,71,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=72;k[a+4>>2]=0;ze(4568,204092,5,37892,200915,65,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=73;k[a+4>>2]=0;ze(4568,204103,5,37872,195854,9,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=251;k[a+4>>2]=0;ze(4568,204103,3,37860,203067,25,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=139;k[a+4>>2]=0;ze(4568,204103,4,37844,202977,28,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=252;k[a+4>>2]=0;ze(4568,204117,3,37832,205062,26,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=140;k[a+4>>2]=0;ze(4568,204117,4,37816,201397,29,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=74;k[a+4>>2]=0;ze(4568,204117,5,37796,202249,10,a|0,0);while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=285;k[a+4>>2]=0;ze(4568,204130,3,37784,200947,141,a|0,0);Wd(9216,9200,9240,0,202890,752,202497,0,202497,0,204142,202887,1437);td(9216,1,37780,202890,753,71);td(9216,5,37760,200915,66,75);Wd(9176,9184,9160,0,202890,754,202497,0,202497,0,204148,202887,1438);Me(5016,204152,225902,72,202887,1439);cN(4);cN(0);vd(5016);Me(8176,204157,225902,73,202887,1440);dN(0);dN(4);vd(8176);Me(7408,204163,225902,74,202887,1441);eN(0);eN(4);vd(7408);Wd(7640,9128,9144,0,202890,755,202497,0,202497,0,204171,202887,1442);td(7640,1,37756,202890,756,75);td(7640,3,37744,200947,142,253);td(7640,5,37724,200915,67,76);td(7640,2,37716,202749,254,757);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;Qd(7640,226979,28960,202749,255,a|0,28960,202695,286,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=4;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=4;Qd(7640,226981,28960,202749,255,a|0,28960,202695,286,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=8;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=8;Qd(7640,380241,28960,202749,255,a|0,28960,202695,286,b|0);while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=12;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=12;Qd(7640,380234,28960,202749,255,a|0,28960,202695,286,b|0);Wd(6352,9112,9096,0,202890,758,202497,0,202497,0,204176,202887,1443);td(6352,1,37712,202890,759,76);td(6352,2,37704,199429,3,760);td(6352,3,37692,204892,1,256);td(6352,4,37676,204886,4,143);td(6352,5,37656,204861,2,77);qf(6352,204183,2,37648,199429,4,137);while(1){a=fgb(8)|0;if(a|0){b=577;break}a=k[207666]|0;k[207666]=a+0;if(!a){a=0;b=577;break}Qh[a&7]()}if((b|0)==577){k[a>>2]=761;k[a+4>>2]=0;ze(6352,204187,2,37640,202749,257,a|0,0);ff(204194,3,37628,200947,144,258);yd(204207,28960,0);yd(204215,28960,8);yd(204223,28960,16);yd(204231,28960,24);yd(204239,28960,1);yd(204247,28960,9);yd(204255,28960,17);yd(204263,28960,25);yd(204271,28960,2);yd(204280,28960,10);yd(204289,28960,18);yd(204298,28960,26);yd(204307,28960,3);yd(204316,28960,11);yd(204325,28960,19);yd(204334,28960,27);yd(204343,28960,4);yd(204352,28960,12);yd(204361,28960,20);yd(204370,28960,28);yd(204379,28960,5);yd(204388,28960,13);yd(204397,28960,21);yd(204406,28960,29);yd(204415,28960,6);yd(204424,28960,14);yd(204433,28960,22);yd(204442,28960,30);yd(204451,28960,0);yd(204457,28960,1);yd(204463,28960,2);yd(204470,28960,3);yd(204477,28960,4);yd(204484,28960,5);yd(204484,28960,5);yd(204491,28960,0);yd(204507,28960,1);yd(204524,28960,2);yd(204539,28960,3);yd(204551,28960,4);yd(204570,28960,5);yd(204589,28960,4);yd(204607,28960,4);yd(204622,28960,16);yd(204638,28960,1);yd(204647,28960,2);yd(204655,28960,4);yd(204663,28960,5);yd(204674,28960,6);yd(204687,28960,7);yd(204701,28960,7);yd(204716,28960,8);yd(204730,28960,32);yd(204742,28960,0);yd(204753,28960,1);return}}function NK(a){a=a|0;return 4576}function OK(a){a=a|0;if(a|0)ggb(a);return}function PK(){var a=0;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;return a|0}function QK(a){a=a|0;return Nh[a&127]()|0}function RK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}b=k[b>>2]|0;e=+p[c>>3];k[d>>2]=k[a>>2];k[d+4>>2]=b;p[d+8>>3]=e;return d|0}function SK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0;e=r;r=r+16|0;h=e+12|0;g=e+8|0;f=e;k[h>>2]=b;k[g>>2]=c;p[f>>3]=d;c=ci[a&255](h,g,f)|0;r=e;return c|0}function TK(a,b){a=a|0;b=b|0;return k[b+(k[a>>2]|0)>>2]|0}function UK(a,b,c){a=a|0;b=b|0;c=c|0;k[b+(k[a>>2]|0)>>2]=c;return}function VK(a,b){a=a|0;b=b|0;return +(+p[b+(k[a>>2]|0)>>3])}function WK(a,b,c){a=a|0;b=b|0;c=+c;p[b+(k[a>>2]|0)>>3]=c;return}function XK(a){a=a|0;return 4568}function YK(a){a=a|0;var b=0,c=0,d=0;if(!a)return;d=a+36|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+16|0;c=a+4|0;d=a+40|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+44>>2]|0;if(!((b|0)==(a+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);ggb(a);return}function ZK(){var a=0,b=0,c=0,d=0,e=0;while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=1124007936;b=a+8|0;c=a+40|0;d=a+4|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;e=a+48|0;k[a+44>>2]=e;k[a+52>>2]=0;k[e>>2]=0;return a|0}function _K(a){a=a|0;return Nh[a&127]()|0}function $K(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=r;r=r+16|0;i=j;while(1){c=fgb(56)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}h=k[a>>2]|0;g=k[a+4>>2]|0;a=k[b>>2]|0;k[c>>2]=1124007936;b=c+8|0;d=c+40|0;e=c+4|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=b;f=c+48|0;k[c+44>>2]=f;k[c+52>>2]=0;k[f>>2]=0;k[i>>2]=g;k[i+4>>2]=h;G1(c,2,i,a&4095);r=j;return c|0}function aL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+16|0;f=d+8|0;e=d;k[f>>2]=k[b>>2];k[f+4>>2]=k[b+4>>2];k[e>>2]=c;c=Hh[a&511](f,e)|0;r=d;return c|0}function bL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=r;r=r+16|0;i=j;while(1){d=fgb(56)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}h=k[a>>2]|0;g=k[b>>2]|0;a=k[c>>2]|0;k[d>>2]=1124007936;b=d+8|0;c=d+40|0;e=d+4|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=d+48|0;k[d+44>>2]=f;k[d+52>>2]=0;k[f>>2]=0;k[i>>2]=h;k[i+4>>2]=g;G1(d,2,i,a&4095);r=j;return d|0}function cL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=r;r=r+16|0;h=e+8|0;g=e+4|0;f=e;k[h>>2]=b;k[g>>2]=c;k[f>>2]=d;d=ci[a&255](h,g,f)|0;r=e;return d|0}function dL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;g=r;r=r+16|0;f=g;while(1){e=fgb(56)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[f>>2]=k[a>>2];k[f+4>>2]=k[a+4>>2];YN(e,f,b,c,d);r=g;return e|0}function eL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=r;r=r+16|0;g=f;k[g>>2]=k[b>>2];k[g+4>>2]=k[b+4>>2];e=Dg[a&127](g,c,d,e)|0;r=f;return e|0}function fL(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;while(1){b=fgb(56)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=1124024320;k[b+4>>2]=2;g=b+8|0;h=a+4|0;k[g>>2]=(k[h>>2]|0)-(k[a>>2]|0);k[b+12>>2]=1;c=b+16|0;k[c>>2]=0;d=b+20|0;k[d>>2]=0;e=b+24|0;k[e>>2]=0;k[b+32>>2]=0;k[b+36>>2]=0;k[b+40>>2]=g;f=b+44|0;i=b+48|0;k[f>>2]=i;k[b+52>>2]=0;k[i>>2]=0;if((k[a>>2]|0)==(k[h>>2]|0))return b|0;k[b+52>>2]=1;k[k[f>>2]>>2]=1;i=k[a>>2]|0;k[c>>2]=i;k[d>>2]=i;i=i+(aa(k[g>>2]|0,k[k[f>>2]>>2]|0)|0)|0;k[e>>2]=i;k[b+28>>2]=i;return b|0}function gL(a,b){a=a|0;b=b|0;return Xh[a&1023](b)|0}function hL(a){a=a|0;return 1212424721>>>(k[a>>2]<<2&28)&15|0}function iL(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function jL(a){a=a|0;return ((k[a>>2]|0)>>>3&511)+1|0}function kL(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function lL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0,h=0;f=r;r=r+16|0;g=f;h=g+4+4|0;k[h>>2]=0;k[h+4>>2]=0;k[g>>2]=33619968;k[g+4>>2]=b;SW(a,g,c,d,e);r=f;return}function mL(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;Ng[k[a>>2]&7](b,c,d,e,f);return}function nL(a){a=a|0;var b=0,c=0,d=0,e=0;d=k[a+4>>2]|0;if((d|0)<3){d=aa(k[a+8>>2]|0,k[a+12>>2]|0)|0;return d|0}c=a+40|0;b=0;a=1;while(1){if((b|0)==(d|0))break;e=aa(a,k[(k[c>>2]|0)+(b<<2)>>2]|0)|0;b=b+1|0;a=e}return a|0}function oL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+16|0;f=d+8|0;e=d;k[f>>2]=c;k[f+4>>2]=c+1;k[e>>2]=-2147483648;k[e+4>>2]=2147483647;H1(a,b,f,e);r=d;return}function pL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;d=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)d=k[(k[a>>2]|0)+d>>2]|0;Ph[d&511](i,a,c);while(1){d=fgb(56)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d>>2]=k[i>>2];a=i+4|0;k[d+4>>2]=k[a>>2];e=d+8|0;b=i+8|0;k[e>>2]=k[b>>2];k[d+12>>2]=k[i+12>>2];g=i+16|0;k[d+16>>2]=k[g>>2];k[d+20>>2]=k[i+20>>2];k[d+24>>2]=k[i+24>>2];k[d+28>>2]=k[i+28>>2];k[d+32>>2]=k[i+32>>2];h=i+36|0;k[d+36>>2]=k[h>>2];c=d+40|0;k[c>>2]=e;e=d+44|0;f=d+48|0;k[e>>2]=f;k[d+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){c=k[i+44>>2]|0;k[f>>2]=k[c>>2];k[(k[e>>2]|0)+4>>2]=k[c+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[c>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return d|0}ggb(k[a+-4>>2]|0);r=j;return d|0}function qL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+240|0;g=j+224|0;h=j;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=1124007936;f=h+16|0;e=h+48|0;i=h+12|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[e>>2]=f;e=h+56|0;k[h+52>>2]=e;k[h+60>>2]=0;k[e>>2]=0;k[h+64>>2]=1124007936;e=h+72|0;f=h+104|0;i=h+68|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[f>>2]=e;e=h+112|0;k[h+108>>2]=e;k[h+116>>2]=0;k[e>>2]=0;k[h+120>>2]=1124007936;e=h+128|0;f=h+160|0;i=h+124|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[f>>2]=e;i=h+168|0;k[h+164>>2]=i;l=i+56|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[g>>2]=c;k[g+4>>2]=b;j1(h,73,g,d);k[a>>2]=1124007936;e=a+8|0;f=a+40|0;i=a+4|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[f>>2]=e;l=a+48|0;k[a+44>>2]=l;k[a+52>>2]=0;k[l>>2]=0;l=k[h>>2]|0;dh[k[(k[l>>2]|0)+12>>2]&255](l,h,a,-1);XN(h);r=j;return}function rL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;dh[a&255](i,b,c,d);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function sL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+240|0;f=l+224|0;j=l;g=k[b>>2]|0;e=k[b+4>>2]|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=1124007936;b=j+16|0;d=j+48|0;h=j+12|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=b;b=j+56|0;k[j+52>>2]=b;k[j+60>>2]=0;k[b>>2]=0;k[j+64>>2]=1124007936;b=j+72|0;d=j+104|0;h=j+68|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=b;b=j+112|0;k[j+108>>2]=b;k[j+116>>2]=0;k[b>>2]=0;k[j+120>>2]=1124007936;b=j+128|0;d=j+160|0;h=j+124|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=b;h=j+168|0;k[j+164>>2]=h;i=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[f>>2]=g;k[f+4>>2]=e;j1(j,73,f,c);k[a>>2]=1124007936;b=a+8|0;d=a+40|0;h=a+4|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=b;i=a+48|0;k[a+44>>2]=i;k[a+52>>2]=0;k[i>>2]=0;i=k[j>>2]|0;dh[k[(k[i>>2]|0)+12>>2]&255](i,j,a,-1);XN(j);r=l;return}function tL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j+8|0;h=j;k[h>>2]=k[b>>2];k[h+4>>2]=k[b+4>>2];Ph[a&511](i,h,c);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function uL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;f=r;r=r+16|0;e=f;d=d&4095;if(((((k[a+4>>2]|0)<3?(k[a+8>>2]|0)==(b|0):0)?(k[a+12>>2]|0)==(c|0):0)?(k[a>>2]&4095|0)==(d|0):0)?k[a+16>>2]|0:0){r=f;return}k[e>>2]=b;k[e+4>>2]=c;G1(a,2,e,d);r=f;return}function vL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=k[a>>2]|0;g=k[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){g=f;dh[g&255](a,c,d,e);return}else{g=k[(k[a>>2]|0)+f>>2]|0;dh[g&255](a,c,d,e);return}}function wL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;g=r;r=r+16|0;e=g;f=k[b+4>>2]|0;d=k[b>>2]|0;b=c&4095;if(((((k[a+4>>2]|0)<3?(k[a+8>>2]|0)==(f|0):0)?(k[a+12>>2]|0)==(d|0):0)?(k[a>>2]&4095|0)==(b|0):0)?k[a+16>>2]|0:0){r=g;return}k[e>>2]=f;k[e+4>>2]=d;G1(a,2,e,b);r=g;return}function xL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)e=k[(k[a>>2]|0)+e>>2]|0;k[f>>2]=k[c>>2];k[f+4>>2]=k[c+4>>2];Ph[e&511](a,f,d);r=g;return}function yL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+16|0;g=e+8|0;f=e;k[g>>2]=c;k[g+4>>2]=d;k[f>>2]=-2147483648;k[f+4>>2]=2147483647;H1(a,b,g,f);r=e;return}function zL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;e=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)e=k[(k[a>>2]|0)+e>>2]|0;dh[e&255](i,a,c,d);while(1){e=fgb(56)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[e>>2]=k[i>>2];a=i+4|0;k[e+4>>2]=k[a>>2];d=e+8|0;b=i+8|0;k[d>>2]=k[b>>2];k[e+12>>2]=k[i+12>>2];g=i+16|0;k[e+16>>2]=k[g>>2];k[e+20>>2]=k[i+20>>2];k[e+24>>2]=k[i+24>>2];k[e+28>>2]=k[i+28>>2];k[e+32>>2]=k[i+32>>2];h=i+36|0;k[e+36>>2]=k[h>>2];c=e+40|0;k[c>>2]=d;d=e+44|0;f=e+48|0;k[d>>2]=f;k[e+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){c=k[i+44>>2]|0;k[f>>2]=k[c>>2];k[(k[d>>2]|0)+4>>2]=k[c+4>>2]}else{l=i+44|0;k[d>>2]=k[l>>2];f=i+40|0;k[c>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return e|0}ggb(k[a+-4>>2]|0);r=j;return e|0}function AL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;k[e>>2]=-2147483648;k[e+4>>2]=2147483647;H1(a,b,c,e);r=d;return}function BL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;d=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)d=k[(k[a>>2]|0)+d>>2]|0;Ph[d&511](i,a,c);while(1){d=fgb(56)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d>>2]=k[i>>2];a=i+4|0;k[d+4>>2]=k[a>>2];e=d+8|0;b=i+8|0;k[e>>2]=k[b>>2];k[d+12>>2]=k[i+12>>2];g=i+16|0;k[d+16>>2]=k[g>>2];k[d+20>>2]=k[i+20>>2];k[d+24>>2]=k[i+24>>2];k[d+28>>2]=k[i+28>>2];k[d+32>>2]=k[i+32>>2];h=i+36|0;k[d+36>>2]=k[h>>2];c=d+40|0;k[c>>2]=e;e=d+44|0;f=d+48|0;k[e>>2]=f;k[d+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){c=k[i+44>>2]|0;k[f>>2]=k[c>>2];k[(k[e>>2]|0)+4>>2]=k[c+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[c>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return d|0}ggb(k[a+-4>>2]|0);r=j;return d|0}function CL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){e=d;jh[e&1023](a,c);return}else{e=k[(k[a>>2]|0)+d>>2]|0;jh[e&1023](a,c);return}}function DL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(!(f&1)){f=e;Ph[f&511](a,c,d);return}else{f=k[(k[a>>2]|0)+e>>2]|0;Ph[f&511](a,c,d);return}}function EL(a){a=a|0;var b=0;b=k[a+4>>2]|0;if((b|0)<=0){b=0;return b|0}b=k[(k[a+44>>2]|0)+(b+-1<<2)>>2]|0;return b|0}function FL(a){a=a|0;return k[a>>2]&4095|0}function GL(a){a=a|0;var b=0,c=0,d=0,e=0;if(!(k[a+16>>2]|0)){d=1;return d|0}d=k[a+4>>2]|0;a:do if((d|0)<3)a=aa(k[a+8>>2]|0,k[a+12>>2]|0)|0;else{c=a+40|0;b=0;a=1;while(1){if((b|0)==(d|0))break a;e=aa(a,k[(k[c>>2]|0)+(b<<2)>>2]|0)|0;b=b+1|0;a=e}}while(0);e=(a|0)==0;return e|0}function HL(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function IL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=r;r=r+16|0;g=e+8|0;f=e;k[g>>2]=-2147483648;k[g+4>>2]=2147483647;k[f>>2]=c;k[f+4>>2]=d;H1(a,b,g,f);r=e;return}function JL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;k[e>>2]=-2147483648;k[e+4>>2]=2147483647;H1(a,b,e,c);r=d;return}function KL(a,b){a=a|0;b=b|0;return ((k[(k[a+44>>2]|0)+(b<<2)>>2]|0)>>>0)/((1212424721>>>(k[a>>2]<<2&28)&15)>>>0)|0|0}function LL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(e&1)d=k[(k[a>>2]|0)+d>>2]|0;return Hh[d&511](a,c)|0}function ML(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+16|0;c=g;k[a>>2]=1124007936;d=a+8|0;e=a+40|0;f=a+4|0;h=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(h|0));k[e>>2]=d;h=a+48|0;k[a+44>>2]=h;k[a+52>>2]=0;k[h>>2]=0;h=c+4+4|0;k[h>>2]=0;k[h+4>>2]=0;k[c>>2]=33619968;k[c+4>>2]=a;mY(b,c);r=g;return}function NL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;c=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)c=k[(k[a>>2]|0)+c>>2]|0;jh[c&1023](i,a);while(1){c=fgb(56)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[i>>2];a=i+4|0;k[c+4>>2]=k[a>>2];e=c+8|0;b=i+8|0;k[e>>2]=k[b>>2];k[c+12>>2]=k[i+12>>2];g=i+16|0;k[c+16>>2]=k[g>>2];k[c+20>>2]=k[i+20>>2];k[c+24>>2]=k[i+24>>2];k[c+28>>2]=k[i+28>>2];k[c+32>>2]=k[i+32>>2];h=i+36|0;k[c+36>>2]=k[h>>2];d=c+40|0;k[d>>2]=e;e=c+44|0;f=c+48|0;k[e>>2]=f;k[c+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return c|0}ggb(k[a+-4>>2]|0);r=j;return c|0}function OL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+240|0;g=j+224|0;h=j;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=1124007936;f=h+16|0;e=h+48|0;i=h+12|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[e>>2]=f;e=h+56|0;k[h+52>>2]=e;k[h+60>>2]=0;k[e>>2]=0;k[h+64>>2]=1124007936;e=h+72|0;f=h+104|0;i=h+68|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[f>>2]=e;e=h+112|0;k[h+108>>2]=e;k[h+116>>2]=0;k[e>>2]=0;k[h+120>>2]=1124007936;e=h+128|0;f=h+160|0;i=h+124|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[f>>2]=e;i=h+168|0;k[h+164>>2]=i;l=i+56|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[g>>2]=c;k[g+4>>2]=b;j1(h,49,g,d);k[a>>2]=1124007936;e=a+8|0;f=a+40|0;i=a+4|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[f>>2]=e;l=a+48|0;k[a+44>>2]=l;k[a+52>>2]=0;k[l>>2]=0;l=k[h>>2]|0;dh[k[(k[l>>2]|0)+12>>2]&255](l,h,a,-1);XN(h);r=j;return}function PL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+240|0;f=l+224|0;j=l;g=k[b>>2]|0;e=k[b+4>>2]|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=1124007936;b=j+16|0;d=j+48|0;h=j+12|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=b;b=j+56|0;k[j+52>>2]=b;k[j+60>>2]=0;k[b>>2]=0;k[j+64>>2]=1124007936;b=j+72|0;d=j+104|0;h=j+68|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=b;b=j+112|0;k[j+108>>2]=b;k[j+116>>2]=0;k[b>>2]=0;k[j+120>>2]=1124007936;b=j+128|0;d=j+160|0;h=j+124|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=b;h=j+168|0;k[j+164>>2]=h;i=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[f>>2]=g;k[f+4>>2]=e;j1(j,49,f,c);k[a>>2]=1124007936;b=a+8|0;d=a+40|0;h=a+4|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=b;i=a+48|0;k[a+44>>2]=i;k[a+52>>2]=0;k[i>>2]=0;i=k[j>>2]|0;dh[k[(k[i>>2]|0)+12>>2]&255](i,j,a,-1);XN(j);r=l;return}function QL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+240|0;g=j+224|0;h=j;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=1124007936;f=h+16|0;e=h+48|0;i=h+12|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[e>>2]=f;e=h+56|0;k[h+52>>2]=e;k[h+60>>2]=0;k[e>>2]=0;k[h+64>>2]=1124007936;e=h+72|0;f=h+104|0;i=h+68|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[f>>2]=e;e=h+112|0;k[h+108>>2]=e;k[h+116>>2]=0;k[e>>2]=0;k[h+120>>2]=1124007936;e=h+128|0;f=h+160|0;i=h+124|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[f>>2]=e;i=h+168|0;k[h+164>>2]=i;l=i+56|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[g>>2]=c;k[g+4>>2]=b;j1(h,48,g,d);k[a>>2]=1124007936;e=a+8|0;f=a+40|0;i=a+4|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[f>>2]=e;l=a+48|0;k[a+44>>2]=l;k[a+52>>2]=0;k[l>>2]=0;l=k[h>>2]|0;dh[k[(k[l>>2]|0)+12>>2]&255](l,h,a,-1);XN(h);r=j;return}function RL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+240|0;f=l+224|0;j=l;g=k[b>>2]|0;e=k[b+4>>2]|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=1124007936;b=j+16|0;d=j+48|0;h=j+12|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=b;b=j+56|0;k[j+52>>2]=b;k[j+60>>2]=0;k[b>>2]=0;k[j+64>>2]=1124007936;b=j+72|0;d=j+104|0;h=j+68|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=b;b=j+112|0;k[j+108>>2]=b;k[j+116>>2]=0;k[b>>2]=0;k[j+120>>2]=1124007936;b=j+128|0;d=j+160|0;h=j+124|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=b;h=j+168|0;k[j+164>>2]=h;i=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[f>>2]=g;k[f+4>>2]=e;j1(j,48,f,c);k[a>>2]=1124007936;b=a+8|0;d=a+40|0;h=a+4|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=b;i=a+48|0;k[a+44>>2]=i;k[a+52>>2]=0;k[i>>2]=0;i=k[j>>2]|0;dh[k[(k[i>>2]|0)+12>>2]&255](i,j,a,-1);XN(j);r=l;return}function SL(a){a=a|0;return k[a>>2]&7|0}function TL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+16|0;f=d+8|0;e=d;k[f>>2]=-2147483648;k[f+4>>2]=2147483647;k[e>>2]=c;k[e+4>>2]=c+1;H1(a,b,f,e);r=d;return}function UL(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0;d=r;r=r+16|0;e=d;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b;c=+r$(a,e);r=d;return +c}function VL(a,b,c){a=a|0;b=b|0;c=c|0;return +(+og[k[a>>2]&63](b,c))}function WL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0;h=r;r=r+240|0;g=h;e=h+224|0;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=c;i1(g,b,e,d);k[a>>2]=1124007936;b=a+8|0;c=a+40|0;e=a+4|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;f=a+48|0;k[a+44>>2]=f;k[a+52>>2]=0;k[f>>2]=0;f=k[g>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,g,a,-1);XN(g);r=h;return}function XL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=r;r=r+64|0;j=l;ah[k[a>>2]&31](j,b,c,d);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[j>>2];b=j+4|0;k[a+4>>2]=k[b>>2];f=a+8|0;c=j+8|0;k[f>>2]=k[c>>2];k[a+12>>2]=k[j+12>>2];h=j+16|0;k[a+16>>2]=k[h>>2];k[a+20>>2]=k[j+20>>2];k[a+24>>2]=k[j+24>>2];k[a+28>>2]=k[j+28>>2];k[a+32>>2]=k[j+32>>2];i=j+36|0;k[a+36>>2]=k[i>>2];e=a+40|0;k[e>>2]=f;f=a+44|0;g=a+48|0;k[f>>2]=g;k[a+52>>2]=0;k[g>>2]=0;if((k[b>>2]|0)<3){e=k[j+44>>2]|0;k[g>>2]=k[e>>2];k[(k[f>>2]|0)+4>>2]=k[e+4>>2]}else{m=j+44|0;k[f>>2]=k[m>>2];g=j+40|0;k[e>>2]=k[g>>2];k[m>>2]=j+48;k[g>>2]=c}k[j>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[i>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;b=k[j+44>>2]|0;if((b|0)==(j+48|0)|(b|0)==0){r=l;return a|0}ggb(k[b+-4>>2]|0);r=l;return a|0}function YL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=r;r=r+224|0;f=h;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=1124007936;d=f+16|0;e=f+48|0;g=f+12|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;d=f+56|0;k[f+52>>2]=d;k[f+60>>2]=0;k[d>>2]=0;k[f+64>>2]=1124007936;d=f+72|0;e=f+104|0;g=f+68|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;d=f+112|0;k[f+108>>2]=d;k[f+116>>2]=0;k[d>>2]=0;k[f+120>>2]=1124007936;d=f+128|0;e=f+160|0;g=f+124|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;g=f+168|0;k[f+164>>2]=g;i=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));Y$(f,c,b);k[a>>2]=1124007936;d=a+8|0;e=a+40|0;g=a+4|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;i=a+48|0;k[a+44>>2]=i;k[a+52>>2]=0;k[i>>2]=0;i=k[f>>2]|0;dh[k[(k[i>>2]|0)+12>>2]&255](i,f,a,-1);XN(f);r=h;return}function ZL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;Ph[k[a>>2]&511](i,b,c);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function _L(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+224|0;e=g;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=1124007936;c=e+16|0;d=e+48|0;f=e+12|0;h=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(h|0));k[d>>2]=c;c=e+56|0;k[e+52>>2]=c;k[e+60>>2]=0;k[c>>2]=0;k[e+64>>2]=1124007936;c=e+72|0;d=e+104|0;f=e+68|0;h=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(h|0));k[d>>2]=c;c=e+112|0;k[e+108>>2]=c;k[e+116>>2]=0;k[c>>2]=0;k[e+120>>2]=1124007936;c=e+128|0;d=e+160|0;f=e+124|0;h=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(h|0));k[d>>2]=c;f=e+168|0;k[e+164>>2]=f;h=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(h|0));y0(e,b,1.0);k[a>>2]=1124007936;c=a+8|0;d=a+40|0;f=a+4|0;h=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(h|0));k[d>>2]=c;h=a+48|0;k[a+44>>2]=h;k[a+52>>2]=0;k[h>>2]=0;h=k[e>>2]|0;dh[k[(k[h>>2]|0)+12>>2]&255](h,e,a,-1);XN(e);r=g;return}function $L(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;jh[k[a>>2]&1023](i,b);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[i>>2];b=i+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=i+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[i+12>>2];g=i+16|0;k[a+16>>2]=k[g>>2];k[a+20>>2]=k[i+20>>2];k[a+24>>2]=k[i+24>>2];k[a+28>>2]=k[i+28>>2];k[a+32>>2]=k[i+32>>2];h=i+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){d=k[i+44>>2]|0;k[f>>2]=k[d>>2];k[(k[e>>2]|0)+4>>2]=k[d+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[d>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=c}k[i>>2]=1124007936;c=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;b=k[i+44>>2]|0;if((b|0)==(i+48|0)|(b|0)==0){r=j;return a|0}ggb(k[b+-4>>2]|0);r=j;return a|0}function aM(a,b){a=a|0;b=b|0;return k[b+(k[a>>2]|0)>>2]|0}function bM(a,b,c){a=a|0;b=b|0;c=c|0;k[b+(k[a>>2]|0)>>2]=c;return}function cM(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a+4>>2]|0;a:do if((e|0)<3)c=aa(k[a+8>>2]|0,k[a+12>>2]|0)|0;else{d=k[a+40>>2]|0;b=0;c=1;while(1){if((b|0)==(e|0))break a;h=aa(c,k[d+(b<<2)>>2]|0)|0;b=b+1|0;c=h}}while(0);if((e|0)>0)b=k[(k[a+44>>2]|0)+(e+-1<<2)>>2]|0;else b=0;e=aa(c,b)|0;h=k[a+16>>2]|0;k[f>>2]=e;k[f+4>>2]=h;h=ue(9288,f|0)|0;r=g;return h|0}function dM(a,b){a=a|0;b=b|0;b=Xh[k[a>>2]&1023](b)|0;nf(b|0);Td(b|0);return b|0}function eM(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a+4>>2]|0;a:do if((e|0)<3)c=aa(k[a+8>>2]|0,k[a+12>>2]|0)|0;else{d=k[a+40>>2]|0;b=0;c=1;while(1){if((b|0)==(e|0))break a;h=aa(c,k[d+(b<<2)>>2]|0)|0;b=b+1|0;c=h}}while(0);if((e|0)>0)b=k[(k[a+44>>2]|0)+(e+-1<<2)>>2]|0;else b=0;e=aa(c,b)|0;h=k[a+16>>2]|0;k[f>>2]=e;k[f+4>>2]=h;h=ue(9336,f|0)|0;r=g;return h|0}function fM(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a+4>>2]|0;a:do if((e|0)<3)c=aa(k[a+8>>2]|0,k[a+12>>2]|0)|0;else{d=k[a+40>>2]|0;b=0;c=1;while(1){if((b|0)==(e|0))break a;h=aa(c,k[d+(b<<2)>>2]|0)|0;b=b+1|0;c=h}}while(0);if((e|0)>0)b=k[(k[a+44>>2]|0)+(e+-1<<2)>>2]|0;else b=0;e=(aa(c,b)|0)>>>1;h=k[a+16>>2]|0;k[f>>2]=e;k[f+4>>2]=h;h=ue(9328,f|0)|0;r=g;return h|0}function gM(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a+4>>2]|0;a:do if((e|0)<3)c=aa(k[a+8>>2]|0,k[a+12>>2]|0)|0;else{d=k[a+40>>2]|0;b=0;c=1;while(1){if((b|0)==(e|0))break a;h=aa(c,k[d+(b<<2)>>2]|0)|0;b=b+1|0;c=h}}while(0);if((e|0)>0)b=k[(k[a+44>>2]|0)+(e+-1<<2)>>2]|0;else b=0;e=(aa(c,b)|0)>>>1;h=k[a+16>>2]|0;k[f>>2]=e;k[f+4>>2]=h;h=ue(9320,f|0)|0;r=g;return h|0}function hM(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a+4>>2]|0;a:do if((e|0)<3)c=aa(k[a+8>>2]|0,k[a+12>>2]|0)|0;else{d=k[a+40>>2]|0;b=0;c=1;while(1){if((b|0)==(e|0))break a;h=aa(c,k[d+(b<<2)>>2]|0)|0;b=b+1|0;c=h}}while(0);if((e|0)>0)b=k[(k[a+44>>2]|0)+(e+-1<<2)>>2]|0;else b=0;e=(aa(c,b)|0)>>>2;h=k[a+16>>2]|0;k[f>>2]=e;k[f+4>>2]=h;h=ue(9312,f|0)|0;r=g;return h|0}function iM(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a+4>>2]|0;a:do if((e|0)<3)c=aa(k[a+8>>2]|0,k[a+12>>2]|0)|0;else{d=k[a+40>>2]|0;b=0;c=1;while(1){if((b|0)==(e|0))break a;h=aa(c,k[d+(b<<2)>>2]|0)|0;b=b+1|0;c=h}}while(0);if((e|0)>0)b=k[(k[a+44>>2]|0)+(e+-1<<2)>>2]|0;else b=0;e=(aa(c,b)|0)>>>2;h=k[a+16>>2]|0;k[f>>2]=e;k[f+4>>2]=h;h=ue(9304,f|0)|0;r=g;return h|0}function jM(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a+4>>2]|0;a:do if((e|0)<3)c=aa(k[a+8>>2]|0,k[a+12>>2]|0)|0;else{d=k[a+40>>2]|0;b=0;c=1;while(1){if((b|0)==(e|0))break a;h=aa(c,k[d+(b<<2)>>2]|0)|0;b=b+1|0;c=h}}while(0);if((e|0)>0)b=k[(k[a+44>>2]|0)+(e+-1<<2)>>2]|0;else b=0;e=(aa(c,b)|0)>>>3;h=k[a+16>>2]|0;k[f>>2]=e;k[f+4>>2]=h;h=ue(9296,f|0)|0;r=g;return h|0}function kM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=r;r=r+16|0;d=c;e=k[k[a+44>>2]>>2]|0;b=(k[a+16>>2]|0)+(aa(e,b)|0)|0;k[d>>2]=(e>>>0)/((1212424721>>>(k[a>>2]<<2&28)&15)>>>0)|0;k[d+4>>2]=b;b=ue(9288,d|0)|0;r=c;return b|0}function lM(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function mM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=r;r=r+16|0;e=d;g=k[a+44>>2]|0;f=k[g+4>>2]|0;c=(k[a+16>>2]|0)+(aa(k[g>>2]|0,b)|0)+(aa(f,c)|0)|0;k[e>>2]=(f>>>0)/((1212424721>>>(k[a>>2]<<2&28)&15)>>>0)|0;k[e+4>>2]=c;c=ue(9288,e|0)|0;r=d;return c|0}function nM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=ci[k[a>>2]&255](b,c,d)|0;nf(d|0);Td(d|0);return d|0}function oM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;k[a>>2]=0;f=a+4|0;k[f>>2]=0;g=a+8|0;k[g>>2]=0;h=b+4|0;d=b+40|0;b=0;while(1){if((b|0)>=(k[h>>2]|0))break;e=(k[d>>2]|0)+(b<<2)|0;c=k[f>>2]|0;if((c|0)==(k[g>>2]|0))WN(a,e);else{k[c>>2]=k[e>>2];k[f>>2]=c+4}b=b+1|0}return}function pM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=r;r=r+16|0;c=d;jh[k[a>>2]&1023](c,b);while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;e=a+4|0;k[e>>2]=0;f=a+8|0;k[f>>2]=0;k[a>>2]=k[c>>2];b=c+4|0;k[e>>2]=k[b>>2];e=c+8|0;k[f>>2]=k[e>>2];k[e>>2]=0;k[b>>2]=0;k[c>>2]=0;r=d;return a|0}function qM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((k[a>>2]&16384|0)==0?(e=k[a+40>>2]|0,(k[e>>2]|0)!=1):0){c=k[a+16>>2]|0;d=k[a+44>>2]|0;if((k[e+4>>2]|0)==1){e=c+(aa(k[d>>2]|0,b)|0)|0;return e|0}else{e=k[a+12>>2]|0;a=(b|0)/(e|0)|0;e=b-(aa(a,e)|0)|0;e=c+(aa(k[d>>2]|0,a)|0)+e|0;return e|0}}e=(k[a+16>>2]|0)+b|0;return e|0}function rM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(e&1)d=k[(k[a>>2]|0)+d>>2]|0;e=Hh[d&511](a,c)|0;return i[e>>0]|0}function sM(a,b,c){a=a|0;b=b|0;c=c|0;return (k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,b)|0)+c|0}function tM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)e=k[(k[a>>2]|0)+e>>2]|0;f=ci[e&255](a,c,d)|0;return i[f>>0]|0}function uM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=k[a+44>>2]|0;b=(k[a+16>>2]|0)+(aa(k[e>>2]|0,b)|0)|0;c=b+(aa(k[e+4>>2]|0,c)|0)|0;return c+(aa(k[e+8>>2]|0,d)|0)|0}function vM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=k[a>>2]|0;g=k[a+4>>2]|0;a=b+(g>>1)|0;if(g&1)f=k[(k[a>>2]|0)+f>>2]|0;g=Dg[f&127](a,c,d,e)|0;return i[g>>0]|0}function wM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((k[a>>2]&16384|0)==0?(e=k[a+40>>2]|0,(k[e>>2]|0)!=1):0){c=k[a+16>>2]|0;d=k[a+44>>2]|0;if((k[e+4>>2]|0)==1){e=c+(aa(k[d>>2]|0,b)|0)|0;return e|0}else{e=k[a+12>>2]|0;a=(b|0)/(e|0)|0;e=b-(aa(a,e)|0)|0;e=c+(aa(k[d>>2]|0,a)|0)+(e<<1)|0;return e|0}}e=(k[a+16>>2]|0)+(b<<1)|0;return e|0}function xM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(e&1)d=k[(k[a>>2]|0)+d>>2]|0;e=Hh[d&511](a,c)|0;return j[e>>1]|0}function yM(a,b,c){a=a|0;b=b|0;c=c|0;return (k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,b)|0)+(c<<1)|0}function zM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)e=k[(k[a>>2]|0)+e>>2]|0;f=ci[e&255](a,c,d)|0;return j[f>>1]|0}function AM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=k[a+44>>2]|0;b=(k[a+16>>2]|0)+(aa(k[e>>2]|0,b)|0)|0;c=b+(aa(k[e+4>>2]|0,c)|0)|0;return c+(aa(k[e+8>>2]|0,d)|0)|0}function BM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=k[a>>2]|0;g=k[a+4>>2]|0;a=b+(g>>1)|0;if(g&1)f=k[(k[a>>2]|0)+f>>2]|0;g=Dg[f&127](a,c,d,e)|0;return j[g>>1]|0}function CM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((k[a>>2]&16384|0)==0?(e=k[a+40>>2]|0,(k[e>>2]|0)!=1):0){c=k[a+16>>2]|0;d=k[a+44>>2]|0;if((k[e+4>>2]|0)==1){e=c+(aa(k[d>>2]|0,b)|0)|0;return e|0}else{e=k[a+12>>2]|0;a=(b|0)/(e|0)|0;e=b-(aa(a,e)|0)|0;e=c+(aa(k[d>>2]|0,a)|0)+(e<<2)|0;return e|0}}e=(k[a+16>>2]|0)+(b<<2)|0;return e|0}function DM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(e&1)d=k[(k[a>>2]|0)+d>>2]|0;e=Hh[d&511](a,c)|0;return k[e>>2]|0}function EM(a,b,c){a=a|0;b=b|0;c=c|0;return (k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,b)|0)+(c<<2)|0}function FM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)e=k[(k[a>>2]|0)+e>>2]|0;f=ci[e&255](a,c,d)|0;return k[f>>2]|0}function GM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=k[a+44>>2]|0;b=(k[a+16>>2]|0)+(aa(k[e>>2]|0,b)|0)|0;c=b+(aa(k[e+4>>2]|0,c)|0)|0;return c+(aa(k[e+8>>2]|0,d)|0)|0}function HM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=k[a>>2]|0;g=k[a+4>>2]|0;a=b+(g>>1)|0;if(g&1)f=k[(k[a>>2]|0)+f>>2]|0;g=Dg[f&127](a,c,d,e)|0;return k[g>>2]|0}function IM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=k[a+44>>2]|0;b=(k[a+16>>2]|0)+(aa(k[e>>2]|0,b)|0)|0;c=b+(aa(k[e+4>>2]|0,c)|0)|0;return c+(aa(k[e+8>>2]|0,d)|0)|0}function JM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=k[a>>2]|0;g=k[a+4>>2]|0;a=b+(g>>1)|0;if(g&1)f=k[(k[a>>2]|0)+f>>2]|0;g=Dg[f&127](a,c,d,e)|0;return +(+p[g>>3])}function KM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((k[a>>2]&16384|0)==0?(e=k[a+40>>2]|0,(k[e>>2]|0)!=1):0){c=k[a+16>>2]|0;d=k[a+44>>2]|0;if((k[e+4>>2]|0)==1){e=c+(aa(k[d>>2]|0,b)|0)|0;return e|0}else{e=k[a+12>>2]|0;a=(b|0)/(e|0)|0;e=b-(aa(a,e)|0)|0;e=c+(aa(k[d>>2]|0,a)|0)+(e<<3)|0;return e|0}}e=(k[a+16>>2]|0)+(b<<3)|0;return e|0}function LM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(e&1)d=k[(k[a>>2]|0)+d>>2]|0;e=Hh[d&511](a,c)|0;return +(+p[e>>3])}function MM(a,b,c){a=a|0;b=b|0;c=c|0;return (k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,b)|0)+(c<<3)|0}function NM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)e=k[(k[a>>2]|0)+e>>2]|0;f=ci[e&255](a,c,d)|0;return +(+p[f>>3])}function OM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((k[a>>2]&16384|0)==0?(e=k[a+40>>2]|0,(k[e>>2]|0)!=1):0){c=k[a+16>>2]|0;d=k[a+44>>2]|0;if((k[e+4>>2]|0)==1){e=c+(aa(k[d>>2]|0,b)|0)|0;return e|0}else{e=k[a+12>>2]|0;a=(b|0)/(e|0)|0;e=b-(aa(a,e)|0)|0;e=c+(aa(k[d>>2]|0,a)|0)+(e<<2)|0;return e|0}}e=(k[a+16>>2]|0)+(b<<2)|0;return e|0}function PM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(e&1)d=k[(k[a>>2]|0)+d>>2]|0;e=Hh[d&511](a,c)|0;return +(+o[e>>2])}function QM(a,b,c){a=a|0;b=b|0;c=c|0;return (k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,b)|0)+(c<<2)|0}function RM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(f&1)e=k[(k[a>>2]|0)+e>>2]|0;f=ci[e&255](a,c,d)|0;return +(+o[f>>2])}function SM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=k[a+44>>2]|0;b=(k[a+16>>2]|0)+(aa(k[e>>2]|0,b)|0)|0;c=b+(aa(k[e+4>>2]|0,c)|0)|0;return c+(aa(k[e+8>>2]|0,d)|0)|0}function TM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=k[a>>2]|0;g=k[a+4>>2]|0;a=b+(g>>1)|0;if(g&1)f=k[(k[a>>2]|0)+f>>2]|0;g=Dg[f&127](a,c,d,e)|0;return +(+o[g>>2])}function UM(a,b,c){a=a|0;b=b|0;c=c|0;I1(a,b,c);return}function VM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+64|0;i=j;d=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)d=k[(k[a>>2]|0)+d>>2]|0;Ph[d&511](i,a,c);while(1){d=fgb(56)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d>>2]=k[i>>2];a=i+4|0;k[d+4>>2]=k[a>>2];e=d+8|0;b=i+8|0;k[e>>2]=k[b>>2];k[d+12>>2]=k[i+12>>2];g=i+16|0;k[d+16>>2]=k[g>>2];k[d+20>>2]=k[i+20>>2];k[d+24>>2]=k[i+24>>2];k[d+28>>2]=k[i+28>>2];k[d+32>>2]=k[i+32>>2];h=i+36|0;k[d+36>>2]=k[h>>2];c=d+40|0;k[c>>2]=e;e=d+44|0;f=d+48|0;k[e>>2]=f;k[d+52>>2]=0;k[f>>2]=0;if((k[a>>2]|0)<3){c=k[i+44>>2]|0;k[f>>2]=k[c>>2];k[(k[e>>2]|0)+4>>2]=k[c+4>>2]}else{l=i+44|0;k[e>>2]=k[l>>2];f=i+40|0;k[c>>2]=k[f>>2];k[l>>2]=i+48;k[f>>2]=b}k[i>>2]=1124007936;b=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;a=k[i+44>>2]|0;if((a|0)==(i+48|0)|(a|0)==0){r=j;return d|0}ggb(k[a+-4>>2]|0);r=j;return d|0}function WM(a){a=a|0;return 9216}function XM(a){a=a|0;if(a|0)ggb(a);return}function YM(){var a=0,b=0;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}b=0;while(1){if((b|0)==4)break;k[a+(b<<2)>>2]=0;b=b+1|0}return a|0}function ZM(a){a=a|0;return Nh[a&127]()|0}function _M(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}b=k[b>>2]|0;c=k[c>>2]|0;d=k[d>>2]|0;k[e>>2]=k[a>>2];k[e+4>>2]=b;k[e+8>>2]=c;k[e+12>>2]=d;return e|0}function $M(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+16|0;j=f+12|0;i=f+8|0;h=f+4|0;g=f;k[j>>2]=b;k[i>>2]=c;k[h>>2]=d;k[g>>2]=e;e=Dg[a&127](j,i,h,g)|0;r=f;return e|0}function aN(a){a=a|0;return 9176}function bN(a){a=a|0;if(a|0)ggb(a);return}function cN(a){a=a|0;var b=0,c=0;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=a;while(1){c=fgb(4)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=a;Xe(5016,28960,202749,259,b|0,28960,202695,287,c|0);return}function dN(a){a=a|0;var b=0,c=0;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=a;while(1){c=fgb(4)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=a;Xe(8176,28960,202749,260,b|0,28960,202695,288,c|0);return}function eN(a){a=a|0;var b=0,c=0;while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=a;while(1){c=fgb(4)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=a;Xe(7408,29008,202856,40,b|0,29008,202882,37,c|0);return}function fN(a){a=a|0;return 7640}function gN(a){a=a|0;if(a|0)ggb(a);return}function hN(){var a=0;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;return a|0}function iN(a){a=a|0;return Nh[a&127]()|0}function jN(a,b){a=a|0;b=b|0;var c=0;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=k[a>>2];k[c+4>>2]=k[a+4>>2];k[c+8>>2]=k[b>>2];k[c+12>>2]=k[b+4>>2];return c|0}function kN(a,b,c){a=a|0;b=b|0;c=c|0;return Hh[a&511](b,c)|0}function lN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}b=k[b>>2]|0;c=k[c>>2]|0;d=k[d>>2]|0;k[e>>2]=k[a>>2];k[e+4>>2]=b;k[e+8>>2]=c;k[e+12>>2]=d;return e|0}function mN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+16|0;j=f+12|0;i=f+8|0;h=f+4|0;g=f;k[j>>2]=b;k[i>>2]=c;k[h>>2]=d;k[g>>2]=e;e=Dg[a&127](j,i,h,g)|0;r=f;return e|0}function nN(a){a=a|0;var b=0;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=k[a>>2];k[b+4>>2]=k[a+4>>2];k[b+8>>2]=k[a+8>>2];k[b+12>>2]=k[a+12>>2];return b|0}function oN(a,b){a=a|0;b=b|0;return Xh[a&1023](b)|0}function pN(a,b){a=a|0;b=b|0;return k[b+(k[a>>2]|0)>>2]|0}function qN(a,b,c){a=a|0;b=b|0;c=c|0;k[b+(k[a>>2]|0)>>2]=c;return}function rN(a){a=a|0;return 6352}function sN(a){a=a|0;if(a|0)ggb(a);return}function tN(){var a=0,b=0;while(1){a=fgb(32)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}b=0;while(1){if((b|0)==4)break;p[a+(b<<3)>>3]=0.0;b=b+1|0}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;k[a+24>>2]=0;k[a+28>>2]=0;return a|0}function uN(a){a=a|0;return Nh[a&127]()|0}function vN(a){a=a|0;var b=0,c=0.0;while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}c=+p[a>>3];a=0;while(1){if((a|0)==4)break;p[b+(a<<3)>>3]=0.0;a=a+1|0}p[b>>3]=c;a=b+8|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;return b|0}function wN(a,b){a=a|0;b=+b;var c=0,d=0;c=r;r=r+16|0;d=c;p[d>>3]=b;a=Xh[a&1023](d)|0;r=c;return a|0}function xN(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0;while(1){c=fgb(32)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=+p[a>>3];d=+p[b>>3];a=0;while(1){if((a|0)==4)break;p[c+(a<<3)>>3]=0.0;a=a+1|0}p[c>>3]=e;p[c+8>>3]=d;b=c+16|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;return c|0}function yN(a,b,c){a=a|0;b=+b;c=+c;var d=0,e=0,f=0;d=r;r=r+16|0;f=d+8|0;e=d;p[f>>3]=b;p[e>>3]=c;a=Hh[a&511](f,e)|0;r=d;return a|0}function zN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}g=+p[a>>3];f=+p[b>>3];e=+p[c>>3];a=0;while(1){if((a|0)==4)break;p[d+(a<<3)>>3]=0.0;a=a+1|0}p[d>>3]=g;p[d+8>>3]=f;p[d+16>>3]=e;p[d+24>>3]=0.0;return d|0}function AN(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;var e=0,f=0,g=0,h=0;e=r;r=r+32|0;h=e+16|0;g=e+8|0;f=e;p[h>>3]=b;p[g>>3]=c;p[f>>3]=d;a=ci[a&255](h,g,f)|0;r=e;return a|0}function BN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,h=0.0,i=0.0;while(1){e=fgb(32)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}i=+p[a>>3];h=+p[b>>3];g=+p[c>>3];f=+p[d>>3];a=0;while(1){if((a|0)==4)break;p[e+(a<<3)>>3]=0.0;a=a+1|0}p[e>>3]=i;p[e+8>>3]=h;p[e+16>>3]=g;p[e+24>>3]=f;return e|0}function CN(a,b,c,d,e){a=a|0;b=+b;c=+c;d=+d;e=+e;var f=0,g=0,h=0,i=0,j=0;f=r;r=r+32|0;j=f+24|0;i=f+16|0;h=f+8|0;g=f;p[j>>3]=b;p[i>>3]=c;p[h>>3]=d;p[g>>3]=e;a=Dg[a&127](j,i,h,g)|0;r=f;return a|0}function DN(a,b){a=a|0;b=+b;var c=0;c=0;while(1){if((c|0)==4)break;p[a+(c<<3)>>3]=0.0;c=c+1|0}p[a>>3]=b;p[a+8>>3]=b;p[a+16>>3]=b;p[a+24>>3]=b;return}function EN(a,b){a=a|0;b=+b;var c=0,d=0,e=0;e=r;r=r+32|0;d=e;gh[a&255](d,b);while(1){a=fgb(32)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}c=0;while(1){if((c|0)==4)break;p[a+(c<<3)>>3]=+p[d+(c<<3)>>3];c=c+1|0}r=e;return a|0}function FN(a){a=a|0;if(!(+p[a+8>>3]==0.0)){a=0;return a|0}if(!(+p[a+16>>3]==0.0)){a=0;return a|0}a=+p[a+24>>3]==0.0;return a|0}function GN(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function HN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0.0;s=r;r=r+80|0;o=s;p=s+64|0;q=s+8|0;f=k[a>>2]|0;l=Ef(380241)|0;f=fd(f|0,l|0)|0;Td(l|0);t=+Jd(f|0,28984,o|0);l=~~t>>>0;$d(k[o>>2]|0);Td(f|0);f=k[a>>2]|0;m=Ef(380234)|0;f=fd(f|0,m|0)|0;Td(m|0);t=+Jd(f|0,28984,o|0);m=~~t>>>0;$d(k[o>>2]|0);Td(f|0);f=k[a>>2]|0;h=Ef(225921)|0;f=fd(f|0,h|0)|0;Td(h|0);h=Ef(204786)|0;g=fd(f|0,h|0)|0;Td(h|0);t=+Jd(g|0,5192,o|0);h=k[o>>2]|0;j=~~t>>>0;e=j+4|0;j=k[j>>2]|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;if(j>>>0>4294967279)hob();if(j>>>0<11){i[p+11>>0]=j;if(!j)a=p;else{a=p;c=10}}else{d=j+16&-16;c=(d|0)==0?1:d;while(1){a=fgb(c)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[p>>2]=a;k[p+8>>2]=d|-2147483648;k[p+4>>2]=j;c=10}if((c|0)==10)upb(a|0,e|0,j|0)|0;i[a+j>>0]=0;$d(h|0);Td(g|0);Td(f|0);n=p+11|0;JN(q,m,l,b,(i[n>>0]|0)<0?k[p>>2]|0:p,0);while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[q>>2];b=q+4|0;k[a+4>>2]=k[b>>2];e=a+8|0;c=q+8|0;k[e>>2]=k[c>>2];k[a+12>>2]=k[q+12>>2];j=q+16|0;k[a+16>>2]=k[j>>2];k[a+20>>2]=k[q+20>>2];k[a+24>>2]=k[q+24>>2];k[a+28>>2]=k[q+28>>2];g=q+32|0;k[a+32>>2]=k[g>>2];h=q+36|0;k[a+36>>2]=k[h>>2];d=a+40|0;k[d>>2]=e;e=a+44|0;f=a+48|0;k[e>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if((k[b>>2]|0)<3){m=k[q+44>>2]|0;k[f>>2]=k[m>>2];k[(k[e>>2]|0)+4>>2]=k[m+4>>2]}else{l=q+44|0;k[e>>2]=k[l>>2];m=q+40|0;k[d>>2]=k[m>>2];k[l>>2]=q+48;k[m>>2]=c}k[q>>2]=1124007936;c=b;d=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));k[o>>2]=a;d=ue(4568,o|0)|0;a=k[h>>2]|0;if(a|0?(m=a+12|0,o=k[m>>2]|0,k[m>>2]=o+-1,(o|0)==1):0){c=k[h>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[g>>2]|0;if(!a){a=B1()|0;c=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[h>>2]=0}k[h>>2]=0;c=q+40|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;a=0;while(1){if((a|0)>=(k[b>>2]|0))break;k[(k[c>>2]|0)+(a<<2)>>2]=0;a=a+1|0}a=k[q+44>>2]|0;if(!((a|0)==(q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);if((i[n>>0]|0)>=0){r=s;return d|0}ggb(k[p>>2]|0);r=s;return d|0}function IN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;k[e>>2]=b;c=Hh[a&511](e,c)|0;nf(c|0);Td(c|0);Td(k[e>>2]|0);r=d;return c|0}function JN(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+16|0;g=t+8|0;s=t;k[a>>2]=d&4095|1124007936;k[a+4>>2]=2;m=a+8|0;k[m>>2]=b;h=a+12|0;k[h>>2]=c;k[a+16>>2]=e;n=a+20|0;k[n>>2]=e;o=a+24|0;p=a+28|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;k[a+40>>2]=m;j=a+48|0;q=a+44|0;k[q>>2]=j;k[a+52>>2]=0;k[j>>2]=0;if((aa(b,c)|0)!=0&(e|0)==0){k[g>>2]=0;e=g+4|0;k[e>>2]=0;a:do if(!1){b=390609;l=5}else{c=390609;b=390609;while(1){if(!(i[c>>0]|0))break a;c=c+1|0;b=c;if(!(b&3)){b=c;l=5;break}}}while(0);if((l|0)==5){while(1){c=k[b>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))b=b+4|0;else break}if((c&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}j=b-390609|0;b=ZT(j+8&-4)|0;k[b>>2]=1;c=b+4|0;k[g>>2]=c;k[e>>2]=j;i[c+j>>0]=0;upb(c|0,390609,j|0)|0;Y8(-215,g,390638,204793,410);k[e>>2]=0;k[g>>2]=0;j=k[b>>2]|0;k[b>>2]=j+-1;if((j|0)==1)ggb(k[b+-4>>2]|0)}j=(d>>>3&511)+1<<(47696>>>(d<<1&14)&3);h=aa(k[h>>2]|0,j)|0;if(!f){s=h;l=k[a>>2]|16384;k[a>>2]=l;a=k[q>>2]|0;k[a>>2]=s;q=k[q>>2]|0;q=q+4|0;k[q>>2]=j;n=k[n>>2]|0;q=k[m>>2]|0;q=aa(s,q)|0;q=n+q|0;k[p>>2]=q;s=0-s|0;s=q+s|0;s=s+h|0;k[o>>2]=s;r=t;return}g=(k[m>>2]|0)==1?h:f;if((g>>>0)%((1212424721>>>(d<<2&28)&15)>>>0)|0|0){k[s>>2]=0;e=s+4|0;k[e>>2]=0;b:do if(!2){b=217242;l=18}else{b=217242;c=217242;while(1){if(!(i[b>>0]|0)){b=c;break b}b=b+1|0;c=b;if(!(c&3)){l=18;break}}}while(0);if((l|0)==18){while(1){c=k[b>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))b=b+4|0;else break}if((c&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}l=b-217242|0;b=ZT(l+8&-4)|0;k[b>>2]=1;d=b+4|0;k[s>>2]=d;k[e>>2]=l;i[d+l>>0]=0;upb(d|0,217242,l|0)|0;Y8(-13,s,390638,204793,426);k[e>>2]=0;k[s>>2]=0;s=k[b>>2]|0;k[b>>2]=s+-1;if((s|0)==1)ggb(k[b+-4>>2]|0)}s=g;l=k[a>>2]|((g|0)==(h|0)?16384:0);k[a>>2]=l;a=k[q>>2]|0;k[a>>2]=s;q=k[q>>2]|0;q=q+4|0;k[q>>2]=j;n=k[n>>2]|0;q=k[m>>2]|0;q=aa(s,q)|0;q=n+q|0;k[p>>2]=q;s=0-s|0;s=q+s|0;s=s+h|0;k[o>>2]=s;r=t;return}function KN(a,b){a=a|0;b=b|0;return +(+o[b+(k[a>>2]|0)>>2])}function LN(a,b,c){a=a|0;b=b|0;c=+c;o[b+(k[a>>2]|0)>>2]=c;return}function MN(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}o[a>>2]=0.0;o[a+4>>2]=0.0;return a|0}function NN(a){a=a|0;if(a|0)ggb(a);return}function ON(a,b){a=a|0;b=b|0;return k[b+(k[a>>2]|0)>>2]|0}function PN(a,b,c){a=a|0;b=b|0;c=c|0;k[b+(k[a>>2]|0)>>2]=c;return}function QN(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function RN(a){a=a|0;if(a|0)ggb(a);return}function SN(a,b){a=a|0;b=b|0;return k[b+(k[a>>2]|0)>>2]|0}function TN(a,b,c){a=a|0;b=b|0;c=c|0;k[b+(k[a>>2]|0)>>2]=c;return}function UN(){var a=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;return a|0}function VN(a){a=a|0;if(a|0)ggb(a);return}function WN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+4|0;c=k[a>>2]|0;f=(k[j>>2]|0)-c>>2;d=f+1|0;if(d>>>0>1073741823)ad(426534,426557,304,426811);l=a+8|0;c=(k[l>>2]|0)-c|0;if(c>>2>>>0<536870911){c=c>>1;c=c>>>0<d>>>0?d:c;if(c)if(c>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}else e=7;else{i=c;d=0}}else{c=1073741823;e=7}if((e|0)==7){e=c<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}i=c}h=d+(f<<2)|0;k[h>>2]=k[b>>2];e=k[a>>2]|0;c=k[j>>2]|0;f=e;b=c-f|0;g=h+(0-(b>>2)<<2)|0;if((b|0)>0){upb(g|0,e|0,b|0)|0;f=k[a>>2]|0;c=k[j>>2]|0}k[a>>2]=g;k[j>>2]=h+4;k[l>>2]=d+(i<<2);d=f;while(1){if((d|0)==(c|0))break;c=c+-4|0}if(!f)return;ggb(f);return}function XN(a){a=a|0;var b=0,c=0,d=0;d=a+156|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+152>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+136|0;c=a+124|0;d=a+160|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+164>>2]|0;if(!((b|0)==(a+168|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+100|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+96>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+80|0;c=a+68|0;d=a+104|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+108>>2]|0;if(!((b|0)==(a+112|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+44|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+40>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;b=a+24|0;c=a+12|0;d=a+48|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[c>>2]|0))break;k[(k[d>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[a+52>>2]|0;if((b|0)==(a+56|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function YN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+16|0;g=t+8|0;s=t;k[a>>2]=c&4095|1124007936;k[a+4>>2]=2;q=a+8|0;f=k[b+4>>2]|0;k[q>>2]=f;h=a+12|0;j=k[b>>2]|0;k[h>>2]=j;k[a+16>>2]=d;m=a+20|0;k[m>>2]=d;n=a+24|0;o=a+28|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[a+40>>2]=q;b=a+48|0;p=a+44|0;k[p>>2]=b;k[a+52>>2]=0;k[b>>2]=0;if((aa(f,j)|0)!=0&(d|0)==0){k[g>>2]=0;f=g+4|0;k[f>>2]=0;a:do if(!1){b=390609;l=5}else{d=390609;b=390609;while(1){if(!(i[d>>0]|0))break a;d=d+1|0;b=d;if(!(b&3)){b=d;l=5;break}}}while(0);if((l|0)==5){while(1){d=k[b>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))b=b+4|0;else break}if((d&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}j=b-390609|0;b=ZT(j+8&-4)|0;k[b>>2]=1;d=b+4|0;k[g>>2]=d;k[f>>2]=j;i[d+j>>0]=0;upb(d|0,390609,j|0)|0;Y8(-215,g,390638,204793,443);k[f>>2]=0;k[g>>2]=0;j=k[b>>2]|0;k[b>>2]=j+-1;if((j|0)==1)ggb(k[b+-4>>2]|0)}j=(c>>>3&511)+1<<(47696>>>(c<<1&14)&3);h=aa(k[h>>2]|0,j)|0;if(!e){s=h;l=k[a>>2]|16384;k[a>>2]=l;a=k[p>>2]|0;k[a>>2]=s;a=k[p>>2]|0;a=a+4|0;k[a>>2]=j;a=k[m>>2]|0;q=k[q>>2]|0;q=aa(s,q)|0;q=a+q|0;k[o>>2]=q;s=0-s|0;s=q+s|0;s=s+h|0;k[n>>2]=s;r=t;return}g=(k[q>>2]|0)==1?h:e;if((g>>>0)%((1212424721>>>(c<<2&28)&15)>>>0)|0|0){k[s>>2]=0;f=s+4|0;k[f>>2]=0;b:do if(!2){b=217242;l=18}else{b=217242;d=217242;while(1){if(!(i[b>>0]|0)){b=d;break b}b=b+1|0;d=b;if(!(d&3)){l=18;break}}}while(0);if((l|0)==18){while(1){d=k[b>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))b=b+4|0;else break}if((d&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}l=b-217242|0;b=ZT(l+8&-4)|0;k[b>>2]=1;c=b+4|0;k[s>>2]=c;k[f>>2]=l;i[c+l>>0]=0;upb(c|0,217242,l|0)|0;Y8(-13,s,390638,204793,459);k[f>>2]=0;k[s>>2]=0;s=k[b>>2]|0;k[b>>2]=s+-1;if((s|0)==1)ggb(k[b+-4>>2]|0)}s=g;l=k[a>>2]|((g|0)==(h|0)?16384:0);k[a>>2]=l;a=k[p>>2]|0;k[a>>2]=s;a=k[p>>2]|0;a=a+4|0;k[a>>2]=j;a=k[m>>2]|0;q=k[q>>2]|0;q=aa(s,q)|0;q=a+q|0;k[o>>2]=q;s=0-s|0;s=q+s|0;s=s+h|0;k[n>>2]=s;r=t;return}function ZN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+4|0;c=k[j>>2]|0;l=a+8|0;f=k[l>>2]|0;if((c|0)!=(f|0)){k[c>>2]=k[b>>2];k[c+4>>2]=k[b+4>>2];k[j>>2]=(k[j>>2]|0)+8;return}d=k[a>>2]|0;i=c-d>>3;e=i+1|0;if(e>>>0>536870911)ad(426534,426557,304,426811);c=f-d|0;if(c>>3>>>0<268435455){c=c>>2;c=c>>>0<e>>>0?e:c;if(c)if(c>>>0>536870911){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}else g=9;else d=0}else{c=536870911;g=9}if((g|0)==9){e=c<<3;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}e=d+(i<<3)|0;h=d+(c<<3)|0;k[e>>2]=k[b>>2];k[d+(i<<3)+4>>2]=k[b+4>>2];f=e+8|0;d=k[a>>2]|0;c=k[j>>2]|0;while(1){if((c|0)==(d|0))break;b=e+-8|0;i=c+-8|0;k[b>>2]=k[i>>2];k[e+-4>>2]=k[c+-4>>2];c=i;e=b}g=k[a>>2]|0;k[a>>2]=e;c=k[j>>2]|0;k[j>>2]=f;k[l>>2]=h;d=g;while(1){if((d|0)==(c|0))break;c=c+-8|0}if(!g)return;ggb(g);return}function _N(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=a+4|0;g=k[m>>2]|0;h=k[a>>2]|0;j=g-h>>3;e=h;d=g;if(j>>>0>=b>>>0){if(j>>>0<=b>>>0)return;e=e+(b<<3)|0;while(1){if((e|0)==(d|0))break;a=d+-8|0;k[m>>2]=a;d=a}return}e=b-j|0;l=a+8|0;f=k[l>>2]|0;if(f-g>>3>>>0>=e>>>0){f=c+4|0;do{k[d>>2]=k[c>>2];k[d+4>>2]=k[f>>2];d=(k[m>>2]|0)+8|0;k[m>>2]=d;e=e+-1|0}while((e|0)!=0);return}if(b>>>0>536870911)ad(426534,426557,304,426811);d=f-h|0;if(d>>3>>>0<268435455){d=d>>2;d=d>>>0<b>>>0?b:d;if(d)if(d>>>0>536870911){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}else i=11;else f=0}else{d=536870911;i=11}if((i|0)==11){g=d<<3;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}}b=f+(j<<3)|0;d=f+(d<<3)|0;f=c+4|0;h=b;do{j=h;k[h>>2]=k[c>>2];k[j+4>>2]=k[f>>2];h=j+8|0;e=e+-1|0}while((e|0)!=0);g=d;f=k[a>>2]|0;d=k[m>>2]|0;e=b;while(1){if((d|0)==(f|0))break;i=e;c=i+-8|0;j=d+-8|0;k[c>>2]=k[j>>2];k[i+-4>>2]=k[d+-4>>2];d=j;e=c}f=k[a>>2]|0;k[a>>2]=e;d=k[m>>2]|0;k[m>>2]=h;k[l>>2]=g;e=f;while(1){if((e|0)==(d|0))break;d=d+-8|0}if(!f)return;ggb(f);return}function $N(a){a=a|0;return 7456}function aO(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;b=k[a>>2]|0;if(b|0){c=a+4|0;d=k[c>>2]|0;while(1){if((b|0)==(d|0))break;e=d+-8|0;k[c>>2]=e;d=e}ggb(b)}ggb(a);return}function bO(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function cO(a){a=a|0;return Nh[a&127]()|0}function dO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){e=d;jh[e&1023](a,c);return}else{e=k[(k[a>>2]|0)+d>>2]|0;jh[e&1023](a,c);return}}function eO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(!(f&1)){f=e;Ph[f&511](a,c,d);return}else{f=k[(k[a>>2]|0)+e>>2]|0;Ph[f&511](a,c,d);return}}function fO(a){a=a|0;return (k[a+4>>2]|0)-(k[a>>2]|0)>>3|0}function gO(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function hO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=r;r=r+16|0;d=f;c=k[a>>2]|0;e=c;if((k[a+4>>2]|0)-c>>3>>>0<=b>>>0){e=1;r=f;return e|0}c=e+(b<<3)|0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[c>>2];k[a+4>>2]=k[e+(b<<3)+4>>2];k[d>>2]=a;e=ue(7408,d|0)|0;r=f;return e|0}function iO(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function jO(a,b,c){a=a|0;b=b|0;c=c|0;a=k[a>>2]|0;k[a+(b<<3)>>2]=k[c>>2];k[a+(b<<3)+4>>2]=k[c+4>>2];return 1}function kO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[k[a>>2]&255](b,c,d)|0}function lO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+4|0;c=k[j>>2]|0;l=a+8|0;f=k[l>>2]|0;if((c|0)!=(f|0)){k[c>>2]=k[b>>2];k[c+4>>2]=k[b+4>>2];k[c+8>>2]=k[b+8>>2];k[c+12>>2]=k[b+12>>2];k[j>>2]=(k[j>>2]|0)+16;return}d=k[a>>2]|0;i=c-d>>4;e=i+1|0;if(e>>>0>268435455)ad(426534,426557,304,426811);c=f-d|0;if(c>>4>>>0<134217727){c=c>>3;c=c>>>0<e>>>0?e:c;if(c)if(c>>>0>268435455){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}else g=9;else d=0}else{c=268435455;g=9}if((g|0)==9){e=c<<4;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}e=d+(i<<4)|0;h=d+(c<<4)|0;k[e>>2]=k[b>>2];k[d+(i<<4)+4>>2]=k[b+4>>2];k[d+(i<<4)+8>>2]=k[b+8>>2];k[d+(i<<4)+12>>2]=k[b+12>>2];f=e+16|0;d=k[a>>2]|0;c=k[j>>2]|0;while(1){if((c|0)==(d|0))break;b=c+-16|0;k[e+-16>>2]=k[b>>2];k[e+-12>>2]=k[c+-12>>2];k[e+-8>>2]=k[c+-8>>2];k[e+-4>>2]=k[c+-4>>2];c=b;e=e+-16|0}g=k[a>>2]|0;k[a>>2]=e;c=k[j>>2]|0;k[j>>2]=f;k[l>>2]=h;d=g;while(1){if((d|0)==(c|0))break;c=c+-16|0}if(!g)return;ggb(g);return}function mO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=a+4|0;g=k[m>>2]|0;h=k[a>>2]|0;j=g-h>>4;e=h;d=g;if(j>>>0>=b>>>0){if(j>>>0<=b>>>0)return;e=e+(b<<4)|0;while(1){if((e|0)==(d|0))break;c=d+-16|0;k[m>>2]=c;d=c}return}e=b-j|0;l=a+8|0;f=k[l>>2]|0;if(f-g>>4>>>0>=e>>>0){f=c+4|0;g=c+8|0;h=c+12|0;do{k[d>>2]=k[c>>2];k[d+4>>2]=k[f>>2];k[d+8>>2]=k[g>>2];k[d+12>>2]=k[h>>2];d=(k[m>>2]|0)+16|0;k[m>>2]=d;e=e+-1|0}while((e|0)!=0);return}if(b>>>0>268435455)ad(426534,426557,304,426811);d=f-h|0;if(d>>4>>>0<134217727){d=d>>3;d=d>>>0<b>>>0?b:d;if(d)if(d>>>0>268435455){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}else i=11;else f=0}else{d=268435455;i=11}if((i|0)==11){g=d<<4;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}}i=f+(j<<4)|0;g=f+(d<<4)|0;d=c+4|0;f=c+8|0;h=c+12|0;b=i;do{j=b;k[j>>2]=k[c>>2];k[j+4>>2]=k[d>>2];k[j+8>>2]=k[f>>2];k[j+12>>2]=k[h>>2];b=j+16|0;e=e+-1|0}while((e|0)!=0);f=k[a>>2]|0;d=k[m>>2]|0;e=i;while(1){if((d|0)==(f|0))break;c=e;j=d+-16|0;k[c+-16>>2]=k[j>>2];k[c+-12>>2]=k[d+-12>>2];k[c+-8>>2]=k[d+-8>>2];k[c+-4>>2]=k[d+-4>>2];d=j;e=c+-16|0}f=k[a>>2]|0;k[a>>2]=e;d=k[m>>2]|0;k[m>>2]=b;k[l>>2]=g;e=f;while(1){if((e|0)==(d|0))break;d=d+-16|0}if(!f)return;ggb(f);return}function nO(a){a=a|0;return 4992}function oO(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;b=k[a>>2]|0;if(b|0){c=a+4|0;d=k[c>>2]|0;while(1){if((b|0)==(d|0))break;e=d+-16|0;k[c>>2]=e;d=e}ggb(b)}ggb(a);return}function pO(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function qO(a){a=a|0;return Nh[a&127]()|0}function rO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){e=d;jh[e&1023](a,c);return}else{e=k[(k[a>>2]|0)+d>>2]|0;jh[e&1023](a,c);return}}function sO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(!(f&1)){f=e;Ph[f&511](a,c,d);return}else{f=k[(k[a>>2]|0)+e>>2]|0;Ph[f&511](a,c,d);return}}function tO(a){a=a|0;return (k[a+4>>2]|0)-(k[a>>2]|0)>>4|0}function uO(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function vO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=r;r=r+16|0;c=e;f=k[a>>2]|0;d=f;if((k[a+4>>2]|0)-f>>4>>>0<=b>>>0){f=1;r=e;return f|0}while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[d+(b<<4)>>2];k[a+4>>2]=k[d+(b<<4)+4>>2];k[a+8>>2]=k[d+(b<<4)+8>>2];k[a+12>>2]=k[d+(b<<4)+12>>2];k[c>>2]=a;f=ue(7640,c|0)|0;r=e;return f|0}function wO(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function xO(a,b,c){a=a|0;b=b|0;c=c|0;a=k[a>>2]|0;k[a+(b<<4)>>2]=k[c>>2];k[a+(b<<4)+4>>2]=k[c+4>>2];k[a+(b<<4)+8>>2]=k[c+8>>2];k[a+(b<<4)+12>>2]=k[c+12>>2];return 1}function yO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[k[a>>2]&255](b,c,d)|0}function zO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;j=a+4|0;c=k[j>>2]|0;l=a+8|0;f=k[l>>2]|0;if((c|0)!=(f|0)){k[c>>2]=k[b>>2];k[c+4>>2]=k[b+4>>2];l=c+8|0;a=b+8|0;k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2];k[l+8>>2]=k[a+8>>2];k[l+12>>2]=k[a+12>>2];k[l+16>>2]=k[a+16>>2];k[j>>2]=(k[j>>2]|0)+28;return}d=k[a>>2]|0;i=(c-d|0)/28|0;e=i+1|0;if(e>>>0>153391689)ad(426534,426557,304,426811);c=(f-d|0)/28|0;if(c>>>0<76695844){c=c<<1;c=c>>>0<e>>>0?e:c;if(!c)d=0;else g=7}else{c=153391689;g=7}if((g|0)==7){e=c*28|0;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}e=d+(i*28|0)|0;h=d+(c*28|0)|0;k[e>>2]=k[b>>2];k[d+(i*28|0)+4>>2]=k[b+4>>2];f=d+(i*28|0)+8|0;d=b+8|0;k[f>>2]=k[d>>2];k[f+4>>2]=k[d+4>>2];k[f+8>>2]=k[d+8>>2];k[f+12>>2]=k[d+12>>2];k[f+16>>2]=k[d+16>>2];f=e+28|0;d=k[a>>2]|0;c=k[j>>2]|0;while(1){if((c|0)==(d|0))break;b=e+-28|0;i=c+-28|0;k[b>>2]=k[i>>2];k[e+-24>>2]=k[c+-24>>2];g=e+-20|0;m=c+-20|0;k[g>>2]=k[m>>2];k[g+4>>2]=k[m+4>>2];k[g+8>>2]=k[m+8>>2];k[g+12>>2]=k[m+12>>2];k[g+16>>2]=k[m+16>>2];c=i;e=b}g=k[a>>2]|0;k[a>>2]=e;c=k[j>>2]|0;k[j>>2]=f;k[l>>2]=h;d=g;while(1){if((d|0)==(c|0))break;c=c+-28|0}if(!g)return;ggb(g);return}function AO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=a+4|0;g=k[m>>2]|0;h=k[a>>2]|0;j=(g-h|0)/28|0;e=h;d=g;if(j>>>0>=b>>>0){if(j>>>0<=b>>>0)return;e=e+(b*28|0)|0;while(1){if((e|0)==(d|0))break;a=d+-28|0;k[m>>2]=a;d=a}return}e=b-j|0;l=a+8|0;f=k[l>>2]|0;if(((f-g|0)/28|0)>>>0>=e>>>0){f=c+4|0;g=c+8|0;do{k[d>>2]=k[c>>2];k[d+4>>2]=k[f>>2];a=d+8|0;k[a>>2]=k[g>>2];k[a+4>>2]=k[g+4>>2];k[a+8>>2]=k[g+8>>2];k[a+12>>2]=k[g+12>>2];k[a+16>>2]=k[g+16>>2];d=(k[m>>2]|0)+28|0;k[m>>2]=d;e=e+-1|0}while((e|0)!=0);return}if(b>>>0>153391689)ad(426534,426557,304,426811);d=(f-h|0)/28|0;if(d>>>0<76695844){d=d<<1;d=d>>>0<b>>>0?b:d;if(!d)f=0;else i=9}else{d=153391689;i=9}if((i|0)==9){g=d*28|0;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}}b=f+(j*28|0)|0;g=f+(d*28|0)|0;d=c+4|0;f=c+8|0;h=b;do{j=h;k[h>>2]=k[c>>2];k[j+4>>2]=k[d>>2];i=j+8|0;k[i>>2]=k[f>>2];k[i+4>>2]=k[f+4>>2];k[i+8>>2]=k[f+8>>2];k[i+12>>2]=k[f+12>>2];k[i+16>>2]=k[f+16>>2];h=j+28|0;e=e+-1|0}while((e|0)!=0);f=k[a>>2]|0;d=k[m>>2]|0;e=b;while(1){if((d|0)==(f|0))break;i=e;c=i+-28|0;j=d+-28|0;k[c>>2]=k[j>>2];k[i+-24>>2]=k[d+-24>>2];i=i+-20|0;b=d+-20|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];k[i+8>>2]=k[b+8>>2];k[i+12>>2]=k[b+12>>2];k[i+16>>2]=k[b+16>>2];d=j;e=c}f=k[a>>2]|0;k[a>>2]=e;d=k[m>>2]|0;k[m>>2]=h;k[l>>2]=g;e=f;while(1){if((e|0)==(d|0))break;d=d+-28|0}if(!f)return;ggb(f);return}function BO(a){a=a|0;return 6544}function CO(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;b=k[a>>2]|0;if(b|0){c=a+4|0;d=k[c>>2]|0;while(1){if((b|0)==(d|0))break;e=d+-28|0;k[c>>2]=e;d=e}ggb(b)}ggb(a);return}function DO(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function EO(a){a=a|0;return Nh[a&127]()|0}function FO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){e=d;jh[e&1023](a,c);return}else{e=k[(k[a>>2]|0)+d>>2]|0;jh[e&1023](a,c);return}}function GO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(!(f&1)){f=e;Ph[f&511](a,c,d);return}else{f=k[(k[a>>2]|0)+e>>2]|0;Ph[f&511](a,c,d);return}}function HO(a){a=a|0;return ((k[a+4>>2]|0)-(k[a>>2]|0)|0)/28|0|0}function IO(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function JO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=r;r=r+16|0;d=f;c=k[a>>2]|0;e=c;if((((k[a+4>>2]|0)-c|0)/28|0)>>>0<=b>>>0){e=1;r=f;return e|0}c=e+(b*28|0)|0;while(1){a=fgb(28)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[c>>2];k[a+4>>2]=k[e+(b*28|0)+4>>2];c=a+8|0;e=e+(b*28|0)+8|0;k[c>>2]=k[e>>2];k[c+4>>2]=k[e+4>>2];k[c+8>>2]=k[e+8>>2];k[c+12>>2]=k[e+12>>2];k[c+16>>2]=k[e+16>>2];k[d>>2]=a;e=ue(8232,d|0)|0;r=f;return e|0}function KO(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function LO(a,b,c){a=a|0;b=b|0;c=c|0;a=k[a>>2]|0;k[a+(b*28|0)>>2]=k[c>>2];k[a+(b*28|0)+4>>2]=k[c+4>>2];b=a+(b*28|0)+8|0;c=c+8|0;k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[b+16>>2]=k[c+16>>2];return 1}function MO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[k[a>>2]&255](b,c,d)|0}function NO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+4|0;c=k[i>>2]|0;j=a+8|0;f=k[j>>2]|0;if((c|0)!=(f|0)){AF(c,b);k[i>>2]=(k[i>>2]|0)+56;return}d=k[a>>2]|0;h=(c-d|0)/56|0;e=h+1|0;if(e>>>0>76695844)ad(426534,426557,304,426811);c=(f-d|0)/56|0;if(c>>>0<38347922){c=c<<1;c=c>>>0<e>>>0?e:c;if(!c)d=0;else g=7}else{c=76695844;g=7}if((g|0)==7){e=c*56|0;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}e=d+(h*56|0)|0;g=d+(c*56|0)|0;AF(e,b);f=e+56|0;d=k[a>>2]|0;c=k[i>>2]|0;while(1){if((c|0)==(d|0))break;b=e+-56|0;h=c+-56|0;AF(b,h);c=h;e=b}b=k[a>>2]|0;k[a>>2]=e;c=k[i>>2]|0;k[i>>2]=f;k[j>>2]=g;h=b;while(1){if((h|0)==(c|0))break;g=c+-56|0;f=c+-20|0;d=k[f>>2]|0;if(d|0?(i=d+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[c+-24>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;d=c+-40|0;e=c+-52|0;f=c+-16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;d=0;while(1){if((d|0)>=(k[e>>2]|0))break;k[(k[f>>2]|0)+(d<<2)>>2]=0;d=d+1|0}d=k[c+-12>>2]|0;if((d|0)==(c+-8|0)|(d|0)==0){c=g;continue}ggb(k[d+-4>>2]|0);c=g}if(!b)return;ggb(b);return}function OO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=a+4|0;g=k[m>>2]|0;h=k[a>>2]|0;j=(g-h|0)/56|0;e=h;d=g;if(j>>>0>=b>>>0){if(j>>>0<=b>>>0)return;h=e+(b*56|0)|0;g=d;while(1){if((h|0)==(g|0))break;k[m>>2]=g+-56;f=g+-20|0;d=k[f>>2]|0;if(d|0?(l=d+12|0,a=k[l>>2]|0,k[l>>2]=a+-1,(a|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[g+-24>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;d=g+-40|0;e=g+-52|0;f=g+-16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;d=0;while(1){if((d|0)>=(k[e>>2]|0))break;k[(k[f>>2]|0)+(d<<2)>>2]=0;d=d+1|0}d=k[g+-12>>2]|0;if(!((d|0)==(g+-8|0)|(d|0)==0))ggb(k[d+-4>>2]|0);g=k[m>>2]|0}return}e=b-j|0;l=a+8|0;f=k[l>>2]|0;if(((f-g|0)/56|0)>>>0>=e>>>0){do{AF(d,c);d=(k[m>>2]|0)+56|0;k[m>>2]=d;e=e+-1|0}while((e|0)!=0);return}if(b>>>0>76695844)ad(426534,426557,304,426811);d=(f-h|0)/56|0;if(d>>>0<38347922){d=d<<1;d=d>>>0<b>>>0?b:d;if(!d)f=0;else i=8}else{d=76695844;i=8}if((i|0)==8){g=d*56|0;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}}h=f+(j*56|0)|0;b=f+(d*56|0)|0;g=h;do{j=g;AF(j,c);g=j+56|0;e=e+-1|0}while((e|0)!=0);f=k[a>>2]|0;d=k[m>>2]|0;e=h;while(1){if((d|0)==(f|0))break;c=e+-56|0;j=d+-56|0;AF(c,j);d=j;e=c}i=k[a>>2]|0;k[a>>2]=e;d=k[m>>2]|0;k[m>>2]=g;k[l>>2]=b;b=i;while(1){if((b|0)==(d|0))break;h=d+-56|0;g=d+-20|0;e=k[g>>2]|0;if(e|0?(a=e+12|0,m=k[a>>2]|0,k[a>>2]=m+-1,(m|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[d+-24>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;e=d+-40|0;f=d+-52|0;g=d+-16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;e=0;while(1){if((e|0)>=(k[f>>2]|0))break;k[(k[g>>2]|0)+(e<<2)>>2]=0;e=e+1|0}e=k[d+-12>>2]|0;if((e|0)==(d+-8|0)|(e|0)==0){d=h;continue}ggb(k[e+-4>>2]|0);d=h}if(!i)return;ggb(i);return}function PO(a){a=a|0;return 4624}function QO(a){a=a|0;if(!a)return;zF(a);ggb(a);return}function RO(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function SO(a){a=a|0;return Nh[a&127]()|0}function TO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){e=d;jh[e&1023](a,c);return}else{e=k[(k[a>>2]|0)+d>>2]|0;jh[e&1023](a,c);return}}function UO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(!(f&1)){f=e;Ph[f&511](a,c,d);return}else{f=k[(k[a>>2]|0)+e>>2]|0;Ph[f&511](a,c,d);return}}function VO(a){a=a|0;return ((k[a+4>>2]|0)-(k[a>>2]|0)|0)/56|0|0}function WO(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function XO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=r;r=r+16|0;d=e;c=k[a>>2]|0;if((((k[a+4>>2]|0)-c|0)/56|0)>>>0<=b>>>0){d=1;r=e;return d|0}b=c+(b*56|0)|0;while(1){a=fgb(56)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}AF(a,b);k[d>>2]=a;d=ue(4568,d|0)|0;r=e;return d|0}function YO(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function ZO(a,b,c){a=a|0;b=b|0;c=c|0;KG((k[a>>2]|0)+(b*56|0)|0,c)|0;return 1}function _O(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[k[a>>2]&255](b,c,d)|0}function $O(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;i=a+4|0;d=k[i>>2]|0;h=a+8|0;g=k[h>>2]|0;e=g;if((d|0)!=(g|0)){c=0;while(1){if((c|0)==4)break;k[d+(c<<2)>>2]=k[b+(c<<2)>>2];c=c+1|0}k[i>>2]=(k[i>>2]|0)+16;return}c=k[a>>2]|0;g=d-c>>4;d=g+1|0;if(d>>>0>268435455)ad(426534,426557,304,426811);c=e-c|0;if(c>>4>>>0<134217727){c=c>>3;c=c>>>0<d>>>0?d:c;if(c)if(c>>>0>268435455){i=te(4)|0;k[i>>2]=172664;Cf(i|0,28816,1287)}else f=11;else d=0}else{c=268435455;f=11}if((f|0)==11){e=c<<4;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}f=d+(g<<4)|0;e=d+(c<<4)|0;c=0;while(1){if((c|0)==4)break;k[d+(g<<4)+(c<<2)>>2]=k[b+(c<<2)>>2];c=c+1|0}b=f+16|0;g=k[a>>2]|0;d=k[i>>2]|0;while(1){if((d|0)==(g|0))break;else c=0;while(1){if((c|0)==4)break;k[f+-16+(c<<2)>>2]=k[d+-16+(c<<2)>>2];c=c+1|0}d=d+-16|0;f=f+-16|0}g=k[a>>2]|0;k[a>>2]=f;c=k[i>>2]|0;k[i>>2]=b;k[h>>2]=e;d=g;while(1){if((d|0)==(c|0))break;c=c+-16|0}if(!g)return;ggb(g);return}function aP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=a+4|0;g=k[m>>2]|0;h=k[a>>2]|0;j=g-h>>4;e=h;d=g;if(j>>>0>=b>>>0){if(j>>>0<=b>>>0)return;e=e+(b<<4)|0;while(1){if((e|0)==(d|0))break;a=d+-16|0;k[m>>2]=a;d=a}return}f=b-j|0;l=a+8|0;e=k[l>>2]|0;if(e-g>>4>>>0>=f>>>0){do{e=0;while(1){if((e|0)==4)break;k[d+(e<<2)>>2]=k[c+(e<<2)>>2];e=e+1|0}d=(k[m>>2]|0)+16|0;k[m>>2]=d;f=f+-1|0}while((f|0)!=0);return}if(b>>>0>268435455)ad(426534,426557,304,426811);d=e-h|0;if(d>>4>>>0<134217727){d=d>>3;d=d>>>0<b>>>0?b:d;if(d)if(d>>>0>268435455){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}else i=13;else e=0}else{d=268435455;i=13}if((i|0)==13){g=d<<4;g=(g|0)==0?1:g;while(1){e=fgb(g)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}}i=e+(j<<4)|0;g=e+(d<<4)|0;e=i;do{d=0;while(1){if((d|0)==4)break;k[e+(d<<2)>>2]=k[c+(d<<2)>>2];d=d+1|0}e=e+16|0;f=f+-1|0}while((f|0)!=0);b=g;h=k[a>>2]|0;g=k[m>>2]|0;d=i;while(1){if((g|0)==(h|0))break;f=d;d=0;while(1){if((d|0)==4)break;k[f+-16+(d<<2)>>2]=k[g+-16+(d<<2)>>2];d=d+1|0}g=g+-16|0;d=f+-16|0}f=k[a>>2]|0;k[a>>2]=d;d=k[m>>2]|0;k[m>>2]=e;k[l>>2]=b;e=f;while(1){if((e|0)==(d|0))break;d=d+-16|0}if(!f)return;ggb(f);return}function bP(a){a=a|0;return 9512}function cP(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;b=k[a>>2]|0;if(b|0){c=a+4|0;d=k[c>>2]|0;while(1){if((b|0)==(d|0))break;e=d+-16|0;k[c>>2]=e;d=e}ggb(b)}ggb(a);return}function dP(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function eP(a){a=a|0;return Nh[a&127]()|0}function fP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){e=d;jh[e&1023](a,c);return}else{e=k[(k[a>>2]|0)+d>>2]|0;jh[e&1023](a,c);return}}function gP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(!(f&1)){f=e;Ph[f&511](a,c,d);return}else{f=k[(k[a>>2]|0)+e>>2]|0;Ph[f&511](a,c,d);return}}function hP(a){a=a|0;return (k[a+4>>2]|0)-(k[a>>2]|0)>>4|0}function iP(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function jP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=r;r=r+16|0;d=f;c=k[a>>2]|0;e=c;if((k[a+4>>2]|0)-c>>4>>>0<=b>>>0){e=1;r=f;return e|0}while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}c=0;while(1){if((c|0)==4)break;k[a+(c<<2)>>2]=k[e+(b<<4)+(c<<2)>>2];c=c+1|0}k[d>>2]=a;e=ue(9216,d|0)|0;r=f;return e|0}function kP(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function lP(a,b,c){a=a|0;b=b|0;c=c|0;b=(k[a>>2]|0)+(b<<4)|0;k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];return 1}function mP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[k[a>>2]&255](b,c,d)|0}function nP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+4|0;c=k[j>>2]|0;l=a+8|0;f=k[l>>2]|0;if((c|0)!=(f|0)){k[c>>2]=k[b>>2];k[c+4>>2]=k[b+4>>2];k[j>>2]=(k[j>>2]|0)+8;return}d=k[a>>2]|0;i=c-d>>3;e=i+1|0;if(e>>>0>536870911)ad(426534,426557,304,426811);c=f-d|0;if(c>>3>>>0<268435455){c=c>>2;c=c>>>0<e>>>0?e:c;if(c)if(c>>>0>536870911){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}else g=9;else d=0}else{c=536870911;g=9}if((g|0)==9){e=c<<3;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}e=d+(i<<3)|0;h=d+(c<<3)|0;k[e>>2]=k[b>>2];k[d+(i<<3)+4>>2]=k[b+4>>2];f=e+8|0;d=k[a>>2]|0;c=k[j>>2]|0;while(1){if((c|0)==(d|0))break;b=c+-8|0;k[e+-8>>2]=k[b>>2];k[e+-4>>2]=k[c+-4>>2];c=b;e=e+-8|0}g=k[a>>2]|0;k[a>>2]=e;c=k[j>>2]|0;k[j>>2]=f;k[l>>2]=h;d=g;while(1){if((d|0)==(c|0))break;c=c+-8|0}if(!g)return;ggb(g);return}function oP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=a+4|0;g=k[m>>2]|0;h=k[a>>2]|0;j=g-h>>3;e=h;d=g;if(j>>>0>=b>>>0){if(j>>>0<=b>>>0)return;e=e+(b<<3)|0;while(1){if((e|0)==(d|0))break;a=d+-8|0;k[m>>2]=a;d=a}return}e=b-j|0;l=a+8|0;f=k[l>>2]|0;if(f-g>>3>>>0>=e>>>0){f=c+4|0;do{k[d>>2]=k[c>>2];k[d+4>>2]=k[f>>2];d=(k[m>>2]|0)+8|0;k[m>>2]=d;e=e+-1|0}while((e|0)!=0);return}if(b>>>0>536870911)ad(426534,426557,304,426811);d=f-h|0;if(d>>3>>>0<268435455){d=d>>2;d=d>>>0<b>>>0?b:d;if(d)if(d>>>0>536870911){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}else i=11;else f=0}else{d=536870911;i=11}if((i|0)==11){g=d<<3;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}}b=f+(j<<3)|0;d=f+(d<<3)|0;f=c+4|0;h=b;do{j=h;k[j>>2]=k[c>>2];k[j+4>>2]=k[f>>2];h=j+8|0;e=e+-1|0}while((e|0)!=0);g=d;f=k[a>>2]|0;d=k[m>>2]|0;e=b;while(1){if((d|0)==(f|0))break;c=e;j=d+-8|0;k[c+-8>>2]=k[j>>2];k[c+-4>>2]=k[d+-4>>2];d=j;e=c+-8|0}f=k[a>>2]|0;k[a>>2]=e;d=k[m>>2]|0;k[m>>2]=h;k[l>>2]=g;e=f;while(1){if((e|0)==(d|0))break;d=d+-8|0}if(!f)return;ggb(f);return}function pP(a){a=a|0;return 8672}function qP(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;b=k[a>>2]|0;if(b|0){c=a+4|0;d=k[c>>2]|0;while(1){if((b|0)==(d|0))break;e=d+-8|0;k[c>>2]=e;d=e}ggb(b)}ggb(a);return}function rP(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function sP(a){a=a|0;return Nh[a&127]()|0}function tP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){e=d;jh[e&1023](a,c);return}else{e=k[(k[a>>2]|0)+d>>2]|0;jh[e&1023](a,c);return}}function uP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(!(f&1)){f=e;Ph[f&511](a,c,d);return}else{f=k[(k[a>>2]|0)+e>>2]|0;Ph[f&511](a,c,d);return}}function vP(a){a=a|0;return (k[a+4>>2]|0)-(k[a>>2]|0)>>3|0}function wP(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function xP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=r;r=r+16|0;c=e;f=k[a>>2]|0;d=f;if((k[a+4>>2]|0)-f>>3>>>0<=b>>>0){f=1;r=e;return f|0}while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=k[d+(b<<3)>>2];k[a+4>>2]=k[d+(b<<3)+4>>2];k[c>>2]=a;f=ue(8176,c|0)|0;r=e;return f|0}function yP(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function zP(a,b,c){a=a|0;b=b|0;c=c|0;a=k[a>>2]|0;k[a+(b<<3)>>2]=k[c>>2];k[a+(b<<3)+4>>2]=k[c+4>>2];return 1}function AP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[k[a>>2]&255](b,c,d)|0}function BP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;i=a+4|0;c=k[i>>2]|0;j=a+8|0;f=k[j>>2]|0;if((c|0)!=(f|0)){QP(c,b);k[i>>2]=(k[i>>2]|0)+12;return}d=k[a>>2]|0;h=(c-d|0)/12|0;e=h+1|0;if(e>>>0>357913941)ad(426534,426557,304,426811);c=(f-d|0)/12|0;if(c>>>0<178956970){c=c<<1;c=c>>>0<e>>>0?e:c;if(!c)d=0;else g=7}else{c=357913941;g=7}if((g|0)==7){e=c*12|0;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}e=d+(h*12|0)|0;g=d+(c*12|0)|0;QP(e,b);f=e+12|0;d=k[a>>2]|0;c=k[i>>2]|0;while(1){if((c|0)==(d|0))break;n=e;b=n+-12|0;h=c+-12|0;k[b>>2]=0;m=n+-8|0;k[m>>2]=0;k[n+-4>>2]=0;k[b>>2]=k[h>>2];l=c+-8|0;k[m>>2]=k[l>>2];m=c+-4|0;k[n+-4>>2]=k[m>>2];k[m>>2]=0;k[l>>2]=0;k[h>>2]=0;c=h;e=b}h=k[a>>2]|0;k[a>>2]=e;c=k[i>>2]|0;k[i>>2]=f;k[j>>2]=g;g=h;while(1){if((g|0)==(c|0))break;f=c+-12|0;e=f;f=k[f>>2]|0;if(!f){c=e;continue}c=c+-8|0;d=k[c>>2]|0;while(1){if((f|0)==(d|0))break;n=d+-8|0;k[c>>2]=n;d=n}ggb(f);c=e}if(!h)return;ggb(h);return}function CP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;m=a+4|0;g=k[m>>2]|0;h=k[a>>2]|0;j=(g-h|0)/12|0;e=h;d=g;if(j>>>0>=b>>>0){if(j>>>0<=b>>>0)return;g=e+(b*12|0)|0;while(1){if((g|0)==(d|0))break;e=d+-12|0;k[m>>2]=e;f=k[e>>2]|0;if(!f){d=e;continue}d=d+-8|0;e=k[d>>2]|0;while(1){if((f|0)==(e|0))break;a=e+-8|0;k[d>>2]=a;e=a}ggb(f);d=k[m>>2]|0}return}e=b-j|0;l=a+8|0;f=k[l>>2]|0;if(((f-g|0)/12|0)>>>0>=e>>>0){do{QP(d,c);d=(k[m>>2]|0)+12|0;k[m>>2]=d;e=e+-1|0}while((e|0)!=0);return}if(b>>>0>357913941)ad(426534,426557,304,426811);d=(f-h|0)/12|0;if(d>>>0<178956970){d=d<<1;d=d>>>0<b>>>0?b:d;if(!d)f=0;else i=8}else{d=357913941;i=8}if((i|0)==8){g=d*12|0;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}}h=f+(j*12|0)|0;b=f+(d*12|0)|0;g=h;do{j=g;QP(j,c);g=j+12|0;e=e+-1|0}while((e|0)!=0);f=k[a>>2]|0;d=k[m>>2]|0;e=h;while(1){if((d|0)==(f|0))break;n=e;c=n+-12|0;j=d+-12|0;k[c>>2]=0;h=n+-8|0;k[h>>2]=0;k[n+-4>>2]=0;k[c>>2]=k[j>>2];i=d+-8|0;k[h>>2]=k[i>>2];h=d+-4|0;k[n+-4>>2]=k[h>>2];k[h>>2]=0;k[i>>2]=0;k[j>>2]=0;d=j;e=c}i=k[a>>2]|0;k[a>>2]=e;d=k[m>>2]|0;k[m>>2]=g;k[l>>2]=b;h=i;while(1){if((h|0)==(d|0))break;g=d+-12|0;f=g;g=k[g>>2]|0;if(!g){d=f;continue}d=d+-8|0;e=k[d>>2]|0;while(1){if((g|0)==(e|0))break;n=e+-8|0;k[d>>2]=n;e=n}ggb(g);d=f}if(!i)return;ggb(i);return}function DP(a){a=a|0;return 5704}function EP(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;if(!a)return;d=k[a>>2]|0;if(d|0){e=a+4|0;while(1){b=k[e>>2]|0;if((d|0)==(b|0))break;f=b+-12|0;k[e>>2]=f;f=k[f>>2]|0;if(!f)continue;b=b+-8|0;c=k[b>>2]|0;while(1){if((f|0)==(c|0))break;g=c+-8|0;k[b>>2]=g;c=g}ggb(f)}ggb(k[a>>2]|0)}ggb(a);return}function FP(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function GP(a){a=a|0;return Nh[a&127]()|0}function HP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){e=d;jh[e&1023](a,c);return}else{e=k[(k[a>>2]|0)+d>>2]|0;jh[e&1023](a,c);return}}function IP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(!(f&1)){f=e;Ph[f&511](a,c,d);return}else{f=k[(k[a>>2]|0)+e>>2]|0;Ph[f&511](a,c,d);return}}function JP(a){a=a|0;return ((k[a+4>>2]|0)-(k[a>>2]|0)|0)/12|0|0}function KP(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function LP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=r;r=r+16|0;d=e;c=k[a>>2]|0;if((((k[a+4>>2]|0)-c|0)/12|0)>>>0<=b>>>0){d=1;r=e;return d|0}b=c+(b*12|0)|0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}QP(a,b);k[d>>2]=a;d=ue(8672,d|0)|0;r=e;return d|0}function MP(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function NP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;g=k[a>>2]|0;j=g+(b*12|0)|0;if((j|0)==(c|0))return 1;a=k[c>>2]|0;h=a;m=k[c+4>>2]|0;i=m-h>>3;e=g+(b*12|0)+8|0;c=k[e>>2]|0;d=k[j>>2]|0;l=d;f=d;if(i>>>0<=c-d>>3>>>0){g=g+(b*12|0)+4|0;e=(k[g>>2]|0)-d>>3;f=i>>>0>e>>>0;e=f?a+(e<<3)|0:m;d=(e-h|0)>>>3;c=l;while(1){if((a|0)==(e|0))break;k[c>>2]=k[a>>2];k[c+4>>2]=k[a+4>>2];c=c+8|0;a=a+8|0}c=l+(d<<3)|0;if(f){a=e;while(1){if((a|0)==(m|0))break;l=k[g>>2]|0;k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2];k[g>>2]=(k[g>>2]|0)+8;a=a+8|0}return 1}a=k[g>>2]|0;while(1){if((c|0)==(a|0))break;m=a+-8|0;k[g>>2]=m;a=m}return 1}if(d){c=g+(b*12|0)+4|0;d=k[c>>2]|0;while(1){if((l|0)==(d|0))break;h=d+-8|0;k[c>>2]=h;d=h}ggb(f);k[e>>2]=0;k[c>>2]=0;k[j>>2]=0;d=0;c=0}if(i>>>0>536870911)ad(426534,426557,304,426811);c=c-d|0;if(c>>3>>>0<268435455){c=c>>2;c=c>>>0<i>>>0?i:c}else c=536870911;PP(j,c);c=g+(b*12|0)+4|0;while(1){if((a|0)==(m|0))break;l=k[c>>2]|0;k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2];k[c>>2]=(k[c>>2]|0)+8;a=a+8|0}return 1}function OP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[k[a>>2]&255](b,c,d)|0}function PP(a,b){a=a|0;b=b|0;var c=0,d=0;if(b>>>0>536870911)ad(426534,426557,304,426811);d=b<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[a+4>>2]=c;k[a>>2]=c;k[a+8>>2]=c+(b<<3);return}function QP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;k[a>>2]=0;e=a+4|0;k[e>>2]=0;k[a+8>>2]=0;c=b+4|0;d=(k[c>>2]|0)-(k[b>>2]|0)>>3;if(!d)return;PP(a,d);c=k[c>>2]|0;a=k[b>>2]|0;while(1){if((a|0)==(c|0))break;b=k[e>>2]|0;k[b>>2]=k[a>>2];k[b+4>>2]=k[a+4>>2];k[e>>2]=(k[e>>2]|0)+8;a=a+8|0}return}function RP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=a+4|0;h=k[n>>2]|0;m=a+8|0;d=k[m>>2]|0;e=d;if((h|0)!=(d|0)){k[h>>2]=0;e=h+4|0;k[e>>2]=0;k[h+8>>2]=0;c=b+4|0;d=(k[c>>2]|0)-(k[b>>2]|0)>>2;if(d|0?(eQ(h,d),f=k[b>>2]|0,g=(k[c>>2]|0)-f|0,(g|0)>0):0){upb(k[e>>2]|0,f|0,g|0)|0;k[e>>2]=(k[e>>2]|0)+(g>>2<<2)}k[n>>2]=(k[n>>2]|0)+12;return}c=k[a>>2]|0;h=(h-c|0)/12|0;d=h+1|0;if(d>>>0>357913941)ad(426534,426557,304,426811);c=(e-c|0)/12|0;if(c>>>0<178956970){c=c<<1;c=c>>>0<d>>>0?d:c;if(!c)e=0;else i=10}else{c=357913941;i=10}if((i|0)==10){e=c*12|0;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d}g=e+(h*12|0)|0;d=g;i=e+(c*12|0)|0;k[g>>2]=0;f=e+(h*12|0)+4|0;k[f>>2]=0;k[e+(h*12|0)+8>>2]=0;c=b+4|0;e=(k[c>>2]|0)-(k[b>>2]|0)>>2;if(e|0?(eQ(g,e),j=k[b>>2]|0,l=(k[c>>2]|0)-j|0,(l|0)>0):0){upb(k[f>>2]|0,j|0,l|0)|0;k[f>>2]=(k[f>>2]|0)+(l>>2<<2)}f=g+12|0;e=k[a>>2]|0;c=k[n>>2]|0;while(1){if((c|0)==(e|0))break;g=d;b=g+-12|0;l=c+-12|0;k[b>>2]=0;h=g+-8|0;k[h>>2]=0;k[g+-4>>2]=0;k[b>>2]=k[l>>2];j=c+-8|0;k[h>>2]=k[j>>2];h=c+-4|0;k[g+-4>>2]=k[h>>2];k[h>>2]=0;k[j>>2]=0;k[l>>2]=0;c=l;d=b}h=k[a>>2]|0;k[a>>2]=d;c=k[n>>2]|0;k[n>>2]=f;k[m>>2]=i;g=h;while(1){if((g|0)==(c|0))break;f=c+-12|0;e=f;f=k[f>>2]|0;if(!f){c=e;continue}c=c+-8|0;d=k[c>>2]|0;while(1){if((f|0)==(d|0))break;n=d+-4|0;k[c>>2]=n;d=n}ggb(f);c=e}if(!h)return;ggb(h);return}function SP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=a+4|0;f=k[q>>2]|0;h=k[a>>2]|0;m=(f-h|0)/12|0;e=h;d=f;if(m>>>0>=b>>>0){if(m>>>0<=b>>>0)return;g=e+(b*12|0)|0;while(1){if((g|0)==(d|0))break;e=d+-12|0;k[q>>2]=e;f=k[e>>2]|0;if(!f){d=e;continue}d=d+-8|0;e=k[d>>2]|0;while(1){if((f|0)==(e|0))break;c=e+-4|0;k[d>>2]=c;e=c}ggb(f);d=k[q>>2]|0}return}g=b-m|0;p=a+8|0;e=k[p>>2]|0;if(((e-f|0)/12|0)>>>0>=g>>>0){h=c+4|0;do{k[d>>2]=0;e=d+4|0;k[e>>2]=0;k[d+8>>2]=0;f=(k[h>>2]|0)-(k[c>>2]|0)>>2;if(f|0?(eQ(d,f),i=k[c>>2]|0,j=(k[h>>2]|0)-i|0,(j|0)>0):0){upb(k[e>>2]|0,i|0,j|0)|0;k[e>>2]=(k[e>>2]|0)+(j>>2<<2)}d=(k[q>>2]|0)+12|0;k[q>>2]=d;g=g+-1|0}while((g|0)!=0);return}if(b>>>0>357913941)ad(426534,426557,304,426811);d=(e-h|0)/12|0;if(d>>>0<178956970){d=d<<1;d=d>>>0<b>>>0?b:d;if(!d)f=0;else l=12}else{d=357913941;l=12}if((l|0)==12){f=d*12|0;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}f=e}e=f+(m*12|0)|0;i=f+(d*12|0)|0;b=c+4|0;h=e;do{d=h;k[d>>2]=0;f=d+4|0;k[f>>2]=0;k[d+8>>2]=0;h=(k[b>>2]|0)-(k[c>>2]|0)>>2;if(h|0?(eQ(d,h),n=k[c>>2]|0,o=(k[b>>2]|0)-n|0,(o|0)>0):0){upb(k[f>>2]|0,n|0,o|0)|0;k[f>>2]=(k[f>>2]|0)+(o>>2<<2)}h=d+12|0;g=g+-1|0}while((g|0)!=0);f=k[a>>2]|0;d=k[q>>2]|0;while(1){if((d|0)==(f|0))break;l=e;c=l+-12|0;o=d+-12|0;k[c>>2]=0;m=l+-8|0;k[m>>2]=0;k[l+-4>>2]=0;k[c>>2]=k[o>>2];n=d+-8|0;k[m>>2]=k[n>>2];m=d+-4|0;k[l+-4>>2]=k[m>>2];k[m>>2]=0;k[n>>2]=0;k[o>>2]=0;d=o;e=c}b=k[a>>2]|0;k[a>>2]=e;d=k[q>>2]|0;k[q>>2]=h;k[p>>2]=i;h=b;while(1){e=d;if((h|0)==(e|0))break;g=e+-12|0;d=g;g=k[g>>2]|0;if(!g)continue;e=e+-8|0;f=k[e>>2]|0;while(1){if((g|0)==(f|0))break;q=f+-4|0;k[e>>2]=q;f=q}ggb(g)}if(!b)return;ggb(b);return}function TP(a){a=a|0;return 9656}function UP(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;if(!a)return;d=k[a>>2]|0;if(d|0){e=a+4|0;while(1){b=k[e>>2]|0;if((d|0)==(b|0))break;f=b+-12|0;k[e>>2]=f;f=k[f>>2]|0;if(!f)continue;b=b+-8|0;c=k[b>>2]|0;while(1){if((f|0)==(c|0))break;g=c+-4|0;k[b>>2]=g;c=g}ggb(f)}ggb(k[a>>2]|0)}ggb(a);return}function VP(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function WP(a){a=a|0;return Nh[a&127]()|0}function XP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=k[a>>2]|0;e=k[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){e=d;jh[e&1023](a,c);return}else{e=k[(k[a>>2]|0)+d>>2]|0;jh[e&1023](a,c);return}}function YP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=k[a>>2]|0;f=k[a+4>>2]|0;a=b+(f>>1)|0;if(!(f&1)){f=e;Ph[f&511](a,c,d);return}else{f=k[(k[a>>2]|0)+e>>2]|0;Ph[f&511](a,c,d);return}}function ZP(a){a=a|0;return ((k[a+4>>2]|0)-(k[a>>2]|0)|0)/12|0|0}function _P(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function $P(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;i=r;r=r+16|0;f=i;e=k[a>>2]|0;c=e;if((((k[a+4>>2]|0)-e|0)/12|0)>>>0<=b>>>0){h=1;r=i;return h|0}e=c+(b*12|0)|0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;d=a+4|0;k[d>>2]=0;k[a+8>>2]=0;b=c+(b*12|0)+4|0;c=(k[b>>2]|0)-(k[e>>2]|0)>>2;if(c|0?(eQ(a,c),g=k[e>>2]|0,h=(k[b>>2]|0)-g|0,(h|0)>0):0){upb(k[d>>2]|0,g|0,h|0)|0;k[d>>2]=(k[d>>2]|0)+(h>>2<<2)}k[f>>2]=a;h=ue(5064,f|0)|0;r=i;return h|0}function aQ(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function bQ(a,b,c){a=a|0;b=b|0;c=c|0;a=(k[a>>2]|0)+(b*12|0)|0;if((a|0)==(c|0))return 1;dQ(a,k[c>>2]|0,k[c+4>>2]|0);return 1}function cQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[k[a>>2]&255](b,c,d)|0}function dQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;j=c;i=b;h=j-i|0;m=h>>2;g=a+8|0;d=k[g>>2]|0;e=k[a>>2]|0;l=e;f=e;if(m>>>0<=d-e>>2>>>0){h=a+4|0;g=(k[h>>2]|0)-e>>2;a=m>>>0>g>>>0;g=a?b+(g<<2)|0:c;c=g;d=c-i|0;f=d>>2;if(f|0)wpb(e|0,b|0,d|0)|0;e=l+(f<<2)|0;if(a){d=j-c|0;if((d|0)<=0)return;upb(k[h>>2]|0,g|0,d|0)|0;k[h>>2]=(k[h>>2]|0)+(d>>2<<2);return}else{d=k[h>>2]|0;while(1){if((e|0)==(d|0))break;b=d+-4|0;k[h>>2]=b;d=b}return}}if(e){d=a+4|0;e=k[d>>2]|0;while(1){if((l|0)==(e|0))break;j=e+-4|0;k[d>>2]=j;e=j}ggb(f);k[g>>2]=0;k[d>>2]=0;k[a>>2]=0;e=0;d=0}if(m>>>0>1073741823)ad(426534,426557,304,426811);d=d-e|0;if(d>>2>>>0<536870911){d=d>>1;d=d>>>0<m>>>0?m:d}else d=1073741823;eQ(a,d);d=a+4|0;if((h|0)<=0)return;upb(k[d>>2]|0,b|0,h|0)|0;k[d>>2]=(k[d>>2]|0)+(m<<2);return}function eQ(a,b){a=a|0;b=b|0;var c=0,d=0;if(b>>>0>1073741823)ad(426534,426557,304,426811);d=b<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[a+4>>2]=c;k[a>>2]=c;k[a+8>>2]=c+(b<<2);return}function fQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+4|0;c=k[l>>2]|0;m=a+8|0;f=k[m>>2]|0;if((c|0)!=(f|0)){k[c>>2]=k[b>>2];k[l>>2]=(k[l>>2]|0)+4;return}d=k[a>>2]|0;h=c-d>>2;e=h+1|0;if(e>>>0>1073741823)ad(426534,426557,304,426811);c=f-d|0;if(c>>2>>>0<536870911){c=c>>1;c=c>>>0<e>>>0?e:c;if(c)if(c>>>0>1073741823){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}else g=9;else{j=c;d=0}}else{c=1073741823;g=9}if((g|0)==9){e=c<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}j=c}i=d+(h<<2)|0;k[i>>2]=k[b>>2];e=k[a>>2]|0;c=k[l>>2]|0;f=e;g=c-f|0;h=i+(0-(g>>2)<<2)|0;if((g|0)>0){upb(h|0,e|0,g|0)|0;f=k[a>>2]|0;c=k[l>>2]|0}k[a>>2]=h;k[l>>2]=i+4;k[m>>2]=d+(j<<2);d=f;while(1){if((d|0)==(c|0))break;c=c+-4|0}if(!f)return;ggb(f);return}function gQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=k[g>>2]|0;e=k[a>>2]|0;f=d-e>>2;if(f>>>0<b>>>0){tQ(a,b-f|0,c);return}if(f>>>0<=b>>>0)return;a=e+(b<<2)|0;while(1){if((a|0)==(d|0))break;f=d+-4|0;k[g>>2]=f;d=f}return}function hQ(a){a=a|0;return 7304}function iQ(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;b=k[a>>2]|0;if(b|0){c=a+4|0;d=k[c>>2]|0;while(1){if((b|0)==(d|0))break;e=d+-4|0;k[c>>2]=e;d=e}ggb(b)}ggb(a);return}function jQ(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function kQ(a){a=a|0;return Nh[a&127]()|0}function lQ(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0;f=r;r=r+16|0;e=f;d=k[a>>2]|0;g=k[a+4>>2]|0;a=b+(g>>1)|0;if(g&1)d=k[(k[a>>2]|0)+d>>2]|0;o[e>>2]=c;jh[d&1023](a,e);r=f;return}function mQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)e=k[(k[a>>2]|0)+e>>2]|0;o[f>>2]=d;Ph[e&511](a,c,f);r=g;return}function nQ(a){a=a|0;return (k[a+4>>2]|0)-(k[a>>2]|0)>>2|0}function oQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function pQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=r;r=r+16|0;c=e;d=k[a>>2]|0;if((k[a+4>>2]|0)-d>>2>>>0<=b>>>0){d=1;r=e;return d|0}k[c>>2]=k[d+(b<<2)>>2];d=ue(29008,c|0)|0;r=e;return d|0}function qQ(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function rQ(a,b,c){a=a|0;b=b|0;c=c|0;k[(k[a>>2]|0)+(b<<2)>>2]=k[c>>2];return 1}function sQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0;e=r;r=r+16|0;f=e;a=k[a>>2]|0;o[f>>2]=d;c=ci[a&255](b,c,f)|0;r=e;return c|0}function tQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+8|0;g=k[j>>2]|0;l=a+4|0;d=k[l>>2]|0;if(g-d>>2>>>0>=b>>>0){do{k[d>>2]=k[c>>2];d=(k[l>>2]|0)+4|0;k[l>>2]=d;b=b+-1|0}while((b|0)!=0);return}e=k[a>>2]|0;i=d-e>>2;f=i+b|0;if(f>>>0>1073741823)ad(426534,426557,304,426811);d=g-e|0;if(d>>2>>>0<536870911){d=d>>1;d=d>>>0<f>>>0?f:d;if(d)if(d>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}else h=10;else e=0}else{d=1073741823;h=10}if((h|0)==10){f=d<<2;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}}g=e+(i<<2)|0;i=e+(d<<2)|0;h=g;do{f=h;k[f>>2]=k[c>>2];h=f+4|0;b=b+-1|0}while((b|0)!=0);b=k[a>>2]|0;d=k[l>>2]|0;e=b;f=d-e|0;g=g+(0-(f>>2)<<2)|0;if((f|0)>0){upb(g|0,b|0,f|0)|0;e=k[a>>2]|0;d=k[l>>2]|0}k[a>>2]=g;k[l>>2]=h;k[j>>2]=i;b=e;while(1){if((b|0)==(d|0))break;d=d+-4|0}if(!e)return;ggb(e);return}function uQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;i=a+4|0;c=k[i>>2]|0;j=a+8|0;f=k[j>>2]|0;if((c|0)!=(f|0)){j=k[b>>2]|0;k[c>>2]=j;nf(j|0);k[i>>2]=(k[i>>2]|0)+4;return}d=k[a>>2]|0;h=c-d>>2;e=h+1|0;if(e>>>0>1073741823)ad(426534,426557,304,426811);c=f-d|0;if(c>>2>>>0<536870911){c=c>>1;c=c>>>0<e>>>0?e:c;if(c)if(c>>>0>1073741823){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}else g=9;else d=0}else{c=1073741823;g=9}if((g|0)==9){e=c<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}e=d+(h<<2)|0;g=d+(c<<2)|0;f=k[b>>2]|0;k[e>>2]=f;nf(f|0);f=e+4|0;d=k[a>>2]|0;c=k[i>>2]|0;while(1){if((c|0)==(d|0))break;b=e+-4|0;h=c+-4|0;l=k[h>>2]|0;k[b>>2]=l;nf(l|0);c=h;e=b}h=k[a>>2]|0;k[a>>2]=e;c=k[i>>2]|0;k[i>>2]=f;k[j>>2]=g;d=h;while(1){if((d|0)==(c|0))break;c=c+-4|0;Td(k[c>>2]|0)}if(!h)return;ggb(h);return}function vQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=a+4|0;g=k[l>>2]|0;f=k[a>>2]|0;i=g-f>>2;e=f;d=g;if(i>>>0>=b>>>0){if(i>>>0<=b>>>0)return;e=e+(b<<2)|0;while(1){if((e|0)==(d|0))break;a=d+-4|0;k[l>>2]=a;Td(k[a>>2]|0);d=k[l>>2]|0}return}e=b-i|0;j=a+8|0;d=k[j>>2]|0;if(d-g>>2>>>0>=e>>>0){d=g;do{a=k[c>>2]|0;k[d>>2]=a;nf(a|0);d=(k[l>>2]|0)+4|0;k[l>>2]=d;e=e+-1|0}while((e|0)!=0);return}if(b>>>0>1073741823)ad(426534,426557,304,426811);d=d-f|0;if(d>>2>>>0<536870911){d=d>>1;d=d>>>0<b>>>0?b:d;if(d)if(d>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}else h=11;else f=0}else{d=1073741823;h=11}if((h|0)==11){b=d<<2;b=(b|0)==0?1:b;while(1){f=fgb(b)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}}g=f+(i<<2)|0;h=f+(d<<2)|0;b=g;do{i=k[c>>2]|0;k[b>>2]=i;nf(i|0);b=b+4|0;e=e+-1|0}while((e|0)!=0);f=k[a>>2]|0;d=k[l>>2]|0;e=g;while(1){if((d|0)==(f|0))break;c=e+-4|0;i=d+-4|0;g=k[i>>2]|0;k[c>>2]=g;nf(g|0);d=i;e=c}f=k[a>>2]|0;k[a>>2]=e;d=k[l>>2]|0;k[l>>2]=b;k[j>>2]=h;e=f;while(1){if((e|0)==(d|0))break;d=d+-4|0;Td(k[d>>2]|0)}if(!f)return;ggb(f);return}function wQ(a){a=a|0;return 9768}function xQ(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=k[a>>2]|0;if(b|0){c=a+4|0;while(1){d=k[c>>2]|0;if((b|0)==(d|0))break;d=d+-4|0;k[c>>2]=d;Td(k[d>>2]|0)}ggb(k[a>>2]|0)}ggb(a);return}function yQ(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function zQ(a){a=a|0;return Nh[a&127]()|0}function AQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=r;r=r+16|0;e=f;d=k[a>>2]|0;g=k[a+4>>2]|0;a=b+(g>>1)|0;if(g&1)d=k[(k[a>>2]|0)+d>>2]|0;k[e>>2]=c;jh[d&1023](a,e);Td(k[e>>2]|0);r=f;return}function BQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)e=k[(k[a>>2]|0)+e>>2]|0;k[f>>2]=d;Ph[e&511](a,c,f);Td(k[f>>2]|0);r=g;return}function CQ(a){a=a|0;return (k[a+4>>2]|0)-(k[a>>2]|0)>>2|0}function DQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function EQ(a,b){a=a|0;b=b|0;var c=0;c=k[a>>2]|0;if((k[a+4>>2]|0)-c>>2>>>0<=b>>>0){c=1;return c|0}c=k[c+(b<<2)>>2]|0;nf(c|0);return c|0}function FQ(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function GQ(a,b,c){a=a|0;b=b|0;c=c|0;b=(k[a>>2]|0)+(b<<2)|0;nf(k[c>>2]|0);Td(k[b>>2]|0);k[b>>2]=k[c>>2];return 1}function HQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=r;r=r+16|0;f=e;a=k[a>>2]|0;k[f>>2]=d;d=ci[a&255](b,c,f)|0;Td(k[f>>2]|0);r=e;return d|0}function IQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=a+4|0;g=k[o>>2]|0;n=a+8|0;l=k[n>>2]|0;e=l;if((g|0)!=(l|0)){k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;if((i[b+11>>0]|0)<0){f=k[b>>2]|0;b=k[b+4>>2]|0;if(b>>>0>4294967279)hob();if(b>>>0<11){i[g+11>>0]=b;if(!b)c=g;else{c=g;m=13}}else{e=b+16&-16;d=(e|0)==0?1:e;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[g>>2]=c;k[g+8>>2]=e|-2147483648;k[g+4>>2]=b;m=13}if((m|0)==13)upb(c|0,f|0,b|0)|0;i[c+b>>0]=0}else{k[g>>2]=k[b>>2];k[g+4>>2]=k[b+4>>2];k[g+8>>2]=k[b+8>>2]}k[o>>2]=(k[o>>2]|0)+12;return}c=k[a>>2]|0;l=(g-c|0)/12|0;d=l+1|0;if(d>>>0>357913941)ad(426534,426557,304,426811);c=(e-c|0)/12|0;if(c>>>0<178956970){c=c<<1;c=c>>>0<d>>>0?d:c;if(!c)d=0;else m=20}else{c=357913941;m=20}if((m|0)==20){e=c*12|0;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}e=d+(l*12|0)|0;j=d+(c*12|0)|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;if((i[b+11>>0]|0)<0){g=k[b>>2]|0;h=k[b+4>>2]|0;if(h>>>0>4294967279)hob();if(h>>>0<11){i[e+11>>0]=h;if(!h)c=e;else{c=e;m=36}}else{b=h+16&-16;f=(b|0)==0?1:b;while(1){c=fgb(f)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[e>>2]=c;k[d+(l*12|0)+8>>2]=b|-2147483648;k[d+(l*12|0)+4>>2]=h;m=36}if((m|0)==36)upb(c|0,g|0,h|0)|0;i[c+h>>0]=0}else{k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2]}b=e+12|0;f=k[a>>2]|0;c=k[o>>2]|0;while(1){if((c|0)==(f|0))break;c=c+-12|0;d=e+-12|0;k[d>>2]=k[c>>2];k[d+4>>2]=k[c+4>>2];k[d+8>>2]=k[c+8>>2];d=0;while(1){if((d|0)==3)break;k[c+(d<<2)>>2]=0;d=d+1|0}e=e+-12|0}f=k[a>>2]|0;k[a>>2]=e;c=k[o>>2]|0;k[o>>2]=b;k[n>>2]=j;e=f;while(1){if((e|0)==(c|0))break;d=c+-12|0;c=d;if((i[d+11>>0]|0)>=0)continue;ggb(k[d>>2]|0)}if(!f)return;ggb(f);return}function JQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=a+4|0;f=k[u>>2]|0;q=k[a>>2]|0;r=(f-q|0)/12|0;e=q;d=f;if(r>>>0>=b>>>0){if(r>>>0<=b>>>0)return;e=e+(b*12|0)|0;while(1){if((e|0)==(d|0))break;d=d+-12|0;k[u>>2]=d;if((i[d+11>>0]|0)>=0)continue;ggb(k[d>>2]|0);d=k[u>>2]|0}return}h=b-r|0;t=a+8|0;p=k[t>>2]|0;if(((p-f|0)/12|0)>>>0>=h>>>0){n=c+11|0;o=c+4|0;m=h;while(1){k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;if((i[n>>0]|0)<0){j=k[c>>2]|0;l=k[o>>2]|0;if(l>>>0>4294967279){s=7;break}if(l>>>0<11){i[d+11>>0]=l;if(l)s=15}else{g=l+16&-16;f=(g|0)==0?1:g;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[d>>2]=e;k[d+8>>2]=g|-2147483648;k[d+4>>2]=l;d=e;s=15}if((s|0)==15){s=0;upb(d|0,j|0,l|0)|0}i[d+l>>0]=0}else{k[d>>2]=k[c>>2];k[d+4>>2]=k[c+4>>2];k[d+8>>2]=k[c+8>>2]}d=(k[u>>2]|0)+12|0;k[u>>2]=d;m=m+-1|0;if(!m){s=59;break}}if((s|0)==7)hob();else if((s|0)==59)return}if(b>>>0>357913941)ad(426534,426557,304,426811);d=(p-q|0)/12|0;if(d>>>0<178956970){d=d<<1;d=d>>>0<b>>>0?b:d;if(!d)e=0;else s=22}else{d=357913941;s=22}if((s|0)==22){f=d*12|0;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}}p=e+(r*12|0)|0;q=e+(d*12|0)|0;n=c+11|0;o=c+4|0;j=p;do{l=j;d=j;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;if((i[n>>0]|0)<0){g=k[c>>2]|0;m=k[o>>2]|0;if(m>>>0>4294967279){s=31;break}if(m>>>0<11){i[j+11>>0]=m;if(m)s=39}else{f=m+16&-16;e=(f|0)==0?1:f;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[l>>2]=d;k[l+8>>2]=f|-2147483648;k[l+4>>2]=m;s=39}if((s|0)==39){s=0;upb(d|0,g|0,m|0)|0}i[d+m>>0]=0}else{k[d>>2]=k[c>>2];k[d+4>>2]=k[c+4>>2];k[d+8>>2]=k[c+8>>2]}j=l+12|0;h=h+-1|0}while((h|0)!=0);if((s|0)==31)hob();g=k[a>>2]|0;e=k[u>>2]|0;d=p;while(1){if((e|0)==(g|0))break;f=d;e=e+-12|0;d=f+-12|0;k[d>>2]=k[e>>2];k[d+4>>2]=k[e+4>>2];k[d+8>>2]=k[e+8>>2];d=0;while(1){if((d|0)==3)break;k[e+(d<<2)>>2]=0;d=d+1|0}d=f+-12|0}g=k[a>>2]|0;k[a>>2]=d;d=k[u>>2]|0;k[u>>2]=j;k[t>>2]=q;f=g;while(1){if((f|0)==(d|0))break;e=d+-12|0;d=e;if((i[e+11>>0]|0)>=0)continue;ggb(k[e>>2]|0)}if(!g)return;ggb(g);return}function KQ(a){a=a|0;return 9848}function LQ(a){a=a|0;var b=0,c=0,d=0;if(!a)return;c=k[a>>2]|0;if(c|0){d=a+4|0;while(1){b=k[d>>2]|0;if((c|0)==(b|0))break;b=b+-12|0;k[d>>2]=b;if((i[b+11>>0]|0)>=0)continue;ggb(k[b>>2]|0)}ggb(k[a>>2]|0)}ggb(a);return}function MQ(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function NQ(a){a=a|0;return Nh[a&127]()|0}function OQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;d=k[a>>2]|0;g=k[a+4>>2]|0;h=b+(g>>1)|0;if(g&1)d=k[(k[h>>2]|0)+d>>2]|0;f=c+4|0;g=k[c>>2]|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;if(g>>>0>4294967279)hob();if(g>>>0<11){i[j+11>>0]=g;if(!g)a=j;else{a=j;e=13}}else{c=g+16&-16;b=(c|0)==0?1:c;while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[j>>2]=a;k[j+8>>2]=c|-2147483648;k[j+4>>2]=g;e=13}if((e|0)==13)upb(a|0,f|0,g|0)|0;i[a+g>>0]=0;jh[d&1023](h,j);if((i[j+11>>0]|0)>=0){r=l;return}ggb(k[j>>2]|0);r=l;return}function PQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;l=m;e=k[a>>2]|0;h=k[a+4>>2]|0;j=b+(h>>1)|0;if(h&1)e=k[(k[j>>2]|0)+e>>2]|0;g=d+4|0;h=k[d>>2]|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;if(h>>>0>4294967279)hob();if(h>>>0<11){i[l+11>>0]=h;if(!h)a=l;else{a=l;f=13}}else{d=h+16&-16;b=(d|0)==0?1:d;while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[l>>2]=a;k[l+8>>2]=d|-2147483648;k[l+4>>2]=h;f=13}if((f|0)==13)upb(a|0,g|0,h|0)|0;i[a+h>>0]=0;Ph[e&511](j,c,l);if((i[l+11>>0]|0)>=0){r=m;return}ggb(k[l>>2]|0);r=m;return}function QQ(a){a=a|0;return ((k[a+4>>2]|0)-(k[a>>2]|0)|0)/12|0|0}function RQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function SQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;e=k[a>>2]|0;f=e;if((((k[a+4>>2]|0)-e|0)/12|0)>>>0<=b>>>0){g=1;r=h;return g|0}c=f+(b*12|0)|0;d=c+11|0;a=i[d>>0]|0;if(a<<24>>24<0)a=k[f+(b*12|0)+4>>2]|0;else a=a&255;e=fgb(a+4|0)|0;a=i[d>>0]|0;if(a<<24>>24<0)a=k[f+(b*12|0)+4>>2]|0;else a=a&255;k[e>>2]=a;a=i[d>>0]|0;if(a<<24>>24<0){c=k[c>>2]|0;a=k[f+(b*12|0)+4>>2]|0}else a=a&255;upb(e+4|0,c|0,a|0)|0;k[g>>2]=e;g=ue(5192,g|0)|0;r=h;return g|0}function TQ(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function UQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=(k[a>>2]|0)+(b*12|0)|0;if((a|0)==(c|0))return 1;b=i[c+11>>0]|0;d=b<<24>>24<0;lob(a,d?k[c>>2]|0:c,d?k[c+4>>2]|0:b&255);return 1}function VQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;h=k[a>>2]|0;f=d+4|0;g=k[d>>2]|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;if(g>>>0>4294967279)hob();if(g>>>0<11){i[j+11>>0]=g;if(!g)a=j;else{a=j;e=10}}else{e=g+16&-16;d=(e|0)==0?1:e;while(1){a=fgb(d)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[j>>2]=a;k[j+8>>2]=e|-2147483648;k[j+4>>2]=g;e=10}if((e|0)==10)upb(a|0,f|0,g|0)|0;i[a+g>>0]=0;a=ci[h&255](b,c,j)|0;if((i[j+11>>0]|0)>=0){r=l;return a|0}ggb(k[j>>2]|0);r=l;return a|0}function WQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;m=a+4|0;c=k[m>>2]|0;n=a+8|0;f=k[n>>2]|0;if((c|0)!=(f|0)){i[c>>0]=i[b>>0]|0;k[m>>2]=(k[m>>2]|0)+1;return}d=k[a>>2]|0;h=c-d|0;e=h+1|0;if((e|0)<0)ad(426534,426557,304,426811);c=f-d|0;if(c>>>0<1073741823){c=c<<1;c=c>>>0<e>>>0?e:c;if(!c){l=c;d=0}else g=7}else{c=2147483647;g=7}a:do if((g|0)==7)while(1){d=fgb(c)|0;if(d|0){l=c;break a}d=k[207666]|0;k[207666]=d+0;if(!d){l=c;d=0;break a}Qh[d&7]();g=7}while(0);j=d+h|0;i[j>>0]=i[b>>0]|0;e=k[a>>2]|0;c=k[m>>2]|0;f=e;g=c-f|0;h=j+(0-g)|0;if((g|0)>0){upb(h|0,e|0,g|0)|0;f=k[a>>2]|0;c=k[m>>2]|0}k[a>>2]=h;k[m>>2]=j+1;k[n>>2]=d+l;d=f;while(1){if((d|0)==(c|0))break;c=c+-1|0}if(!f)return;ggb(d);return}function XQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=a+4|0;g=k[n>>2]|0;h=k[a>>2]|0;l=g-h|0;e=h;d=g;if(l>>>0>=b>>>0){if(l>>>0<=b>>>0)return;e=e+b|0;while(1){if((e|0)==(d|0))break;a=d+-1|0;k[n>>2]=a;d=a}return}e=b-l|0;m=a+8|0;f=k[m>>2]|0;if((f-g|0)>>>0>=e>>>0){do{i[d>>0]=i[c>>0]|0;d=(k[n>>2]|0)+1|0;k[n>>2]=d;e=e+-1|0}while((e|0)!=0);return}if((b|0)<0)ad(426534,426557,304,426811);d=f-h|0;if(d>>>0<1073741823){d=d<<1;d=d>>>0<b>>>0?b:d;if(!d)f=0;else j=8}else{d=2147483647;j=8}a:do if((j|0)==8)while(1){f=fgb(d)|0;if(f|0)break a;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break a}Qh[f&7]();j=8}while(0);h=f+l|0;j=f+d|0;b=h;do{l=b;i[l>>0]=i[c>>0]|0;b=l+1|0;e=e+-1|0}while((e|0)!=0);e=k[a>>2]|0;d=k[n>>2]|0;f=e;g=d-f|0;h=h+(0-g)|0;if((g|0)>0){upb(h|0,e|0,g|0)|0;f=k[a>>2]|0;d=k[n>>2]|0}k[a>>2]=h;k[n>>2]=b;k[m>>2]=j;e=f;while(1){if((e|0)==(d|0))break;d=d+-1|0}if(!f)return;ggb(e);return}function YQ(a){a=a|0;return 8944}function ZQ(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;b=k[a>>2]|0;if(b|0){c=a+4|0;d=k[c>>2]|0;while(1){if((b|0)==(d|0))break;e=d+-1|0;k[c>>2]=e;d=e}ggb(b)}ggb(a);return}function _Q(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function $Q(a){a=a|0;return Nh[a&127]()|0}function aR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=r;r=r+16|0;e=f;d=k[a>>2]|0;g=k[a+4>>2]|0;a=b+(g>>1)|0;if(g&1)d=k[(k[a>>2]|0)+d>>2]|0;i[e>>0]=c;jh[d&1023](a,e);r=f;return}function bR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)e=k[(k[a>>2]|0)+e>>2]|0;i[f>>0]=d;Ph[e&511](a,c,f);r=g;return}function cR(a){a=a|0;return (k[a+4>>2]|0)-(k[a>>2]|0)|0}function dR(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function eR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=r;r=r+16|0;c=e;d=k[a>>2]|0;if(((k[a+4>>2]|0)-d|0)>>>0<=b>>>0){d=1;r=e;return d|0}k[c>>2]=l[d+b>>0];d=ue(28928,c|0)|0;r=e;return d|0}function fR(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function gR(a,b,c){a=a|0;b=b|0;c=c|0;i[(k[a>>2]|0)+b>>0]=i[c>>0]|0;return 1}function hR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=r;r=r+16|0;f=e;a=k[a>>2]|0;i[f>>0]=d;d=ci[a&255](b,c,f)|0;r=e;return d|0}function iR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+4|0;c=k[l>>2]|0;m=a+8|0;f=k[m>>2]|0;if((c|0)!=(f|0)){k[c>>2]=k[b>>2];k[l>>2]=(k[l>>2]|0)+4;return}d=k[a>>2]|0;h=c-d>>2;e=h+1|0;if(e>>>0>1073741823)ad(426534,426557,304,426811);c=f-d|0;if(c>>2>>>0<536870911){c=c>>1;c=c>>>0<e>>>0?e:c;if(c)if(c>>>0>1073741823){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}else g=9;else{j=c;d=0}}else{c=1073741823;g=9}if((g|0)==9){e=c<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}j=c}i=d+(h<<2)|0;k[i>>2]=k[b>>2];e=k[a>>2]|0;c=k[l>>2]|0;f=e;g=c-f|0;h=i+(0-(g>>2)<<2)|0;if((g|0)>0){upb(h|0,e|0,g|0)|0;f=k[a>>2]|0;c=k[l>>2]|0}k[a>>2]=h;k[l>>2]=i+4;k[m>>2]=d+(j<<2);d=f;while(1){if((d|0)==(c|0))break;c=c+-4|0}if(!f)return;ggb(f);return}function jR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=a+4|0;g=k[m>>2]|0;h=k[a>>2]|0;j=g-h>>2;e=h;d=g;if(j>>>0>=b>>>0){if(j>>>0<=b>>>0)return;e=e+(b<<2)|0;while(1){if((e|0)==(d|0))break;a=d+-4|0;k[m>>2]=a;d=a}return}e=b-j|0;l=a+8|0;f=k[l>>2]|0;if(f-g>>2>>>0>=e>>>0){do{k[d>>2]=k[c>>2];d=(k[m>>2]|0)+4|0;k[m>>2]=d;e=e+-1|0}while((e|0)!=0);return}if(b>>>0>1073741823)ad(426534,426557,304,426811);d=f-h|0;if(d>>2>>>0<536870911){d=d>>1;d=d>>>0<b>>>0?b:d;if(d)if(d>>>0>1073741823){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}else i=10;else f=0}else{d=1073741823;i=10}if((i|0)==10){g=d<<2;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}}h=f+(j<<2)|0;i=f+(d<<2)|0;b=h;do{j=b;k[j>>2]=k[c>>2];b=j+4|0;e=e+-1|0}while((e|0)!=0);e=k[a>>2]|0;d=k[m>>2]|0;f=e;g=d-f|0;h=h+(0-(g>>2)<<2)|0;if((g|0)>0){upb(h|0,e|0,g|0)|0;f=k[a>>2]|0;d=k[m>>2]|0}k[a>>2]=h;k[m>>2]=b;k[l>>2]=i;e=f;while(1){if((e|0)==(d|0))break;d=d+-4|0}if(!f)return;ggb(f);return}function kR(a){a=a|0;return 9960}function lR(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;b=k[a>>2]|0;if(b|0){c=a+4|0;d=k[c>>2]|0;while(1){if((b|0)==(d|0))break;e=d+-4|0;k[c>>2]=e;d=e}ggb(b)}ggb(a);return}function mR(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function nR(a){a=a|0;return Nh[a&127]()|0}function oR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=r;r=r+16|0;e=f;d=k[a>>2]|0;g=k[a+4>>2]|0;a=b+(g>>1)|0;if(g&1)d=k[(k[a>>2]|0)+d>>2]|0;k[e>>2]=c;jh[d&1023](a,e);r=f;return}function pR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)e=k[(k[a>>2]|0)+e>>2]|0;k[f>>2]=d;Ph[e&511](a,c,f);r=g;return}function qR(a){a=a|0;return (k[a+4>>2]|0)-(k[a>>2]|0)>>2|0}function rR(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function sR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=r;r=r+16|0;c=e;d=k[a>>2]|0;if((k[a+4>>2]|0)-d>>2>>>0<=b>>>0){d=1;r=e;return d|0}k[c>>2]=k[d+(b<<2)>>2];d=ue(28984,c|0)|0;r=e;return d|0}function tR(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function uR(a,b,c){a=a|0;b=b|0;c=c|0;k[(k[a>>2]|0)+(b<<2)>>2]=k[c>>2];return 1}function vR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=r;r=r+16|0;f=e;a=k[a>>2]|0;k[f>>2]=d;d=ci[a&255](b,c,f)|0;r=e;return d|0}function wR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;m=a+4|0;c=k[m>>2]|0;n=a+8|0;f=k[n>>2]|0;if((c|0)!=(f|0)){i[c>>0]=i[b>>0]|0;k[m>>2]=(k[m>>2]|0)+1;return}d=k[a>>2]|0;h=c-d|0;e=h+1|0;if((e|0)<0)ad(426534,426557,304,426811);c=f-d|0;if(c>>>0<1073741823){c=c<<1;c=c>>>0<e>>>0?e:c;if(!c){l=c;d=0}else g=7}else{c=2147483647;g=7}a:do if((g|0)==7)while(1){d=fgb(c)|0;if(d|0){l=c;break a}d=k[207666]|0;k[207666]=d+0;if(!d){l=c;d=0;break a}Qh[d&7]();g=7}while(0);j=d+h|0;i[j>>0]=i[b>>0]|0;e=k[a>>2]|0;c=k[m>>2]|0;f=e;g=c-f|0;h=j+(0-g)|0;if((g|0)>0){upb(h|0,e|0,g|0)|0;f=k[a>>2]|0;c=k[m>>2]|0}k[a>>2]=h;k[m>>2]=j+1;k[n>>2]=d+l;d=f;while(1){if((d|0)==(c|0))break;c=c+-1|0}if(!f)return;ggb(d);return}function xR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=a+4|0;g=k[n>>2]|0;h=k[a>>2]|0;l=g-h|0;e=h;d=g;if(l>>>0>=b>>>0){if(l>>>0<=b>>>0)return;e=e+b|0;while(1){if((e|0)==(d|0))break;a=d+-1|0;k[n>>2]=a;d=a}return}e=b-l|0;m=a+8|0;f=k[m>>2]|0;if((f-g|0)>>>0>=e>>>0){do{i[d>>0]=i[c>>0]|0;d=(k[n>>2]|0)+1|0;k[n>>2]=d;e=e+-1|0}while((e|0)!=0);return}if((b|0)<0)ad(426534,426557,304,426811);d=f-h|0;if(d>>>0<1073741823){d=d<<1;d=d>>>0<b>>>0?b:d;if(!d)f=0;else j=8}else{d=2147483647;j=8}a:do if((j|0)==8)while(1){f=fgb(d)|0;if(f|0)break a;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break a}Qh[f&7]();j=8}while(0);h=f+l|0;j=f+d|0;b=h;do{l=b;i[l>>0]=i[c>>0]|0;b=l+1|0;e=e+-1|0}while((e|0)!=0);e=k[a>>2]|0;d=k[n>>2]|0;f=e;g=d-f|0;h=h+(0-g)|0;if((g|0)>0){upb(h|0,e|0,g|0)|0;f=k[a>>2]|0;d=k[n>>2]|0}k[a>>2]=h;k[n>>2]=b;k[m>>2]=j;e=f;while(1){if((e|0)==(d|0))break;d=d+-1|0}if(!f)return;ggb(e);return}function yR(a){a=a|0;return 9040}function zR(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;b=k[a>>2]|0;if(b|0){c=a+4|0;d=k[c>>2]|0;while(1){if((b|0)==(d|0))break;e=d+-1|0;k[c>>2]=e;d=e}ggb(b)}ggb(a);return}function AR(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function BR(a){a=a|0;return Nh[a&127]()|0}function CR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=r;r=r+16|0;e=f;d=k[a>>2]|0;g=k[a+4>>2]|0;a=b+(g>>1)|0;if(g&1)d=k[(k[a>>2]|0)+d>>2]|0;i[e>>0]=c;jh[d&1023](a,e);r=f;return}function DR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)e=k[(k[a>>2]|0)+e>>2]|0;i[f>>0]=d;Ph[e&511](a,c,f);r=g;return}function ER(a){a=a|0;return (k[a+4>>2]|0)-(k[a>>2]|0)|0}function FR(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function GR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=r;r=r+16|0;c=e;d=k[a>>2]|0;if(((k[a+4>>2]|0)-d|0)>>>0<=b>>>0){d=1;r=e;return d|0}k[c>>2]=i[d+b>>0];d=ue(28904,c|0)|0;r=e;return d|0}function HR(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function IR(a,b,c){a=a|0;b=b|0;c=c|0;i[(k[a>>2]|0)+b>>0]=i[c>>0]|0;return 1}function JR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=r;r=r+16|0;f=e;a=k[a>>2]|0;i[f>>0]=d;d=ci[a&255](b,c,f)|0;r=e;return d|0}function KR(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=k[c>>2]|0;if((d|0)==(k[a+8>>2]|0)){WN(a,b);return}else{k[d>>2]=k[b>>2];k[c>>2]=(k[c>>2]|0)+4;return}}function LR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=k[g>>2]|0;e=k[a>>2]|0;f=d-e>>2;if(f>>>0<b>>>0){YR(a,b-f|0,c);return}if(f>>>0<=b>>>0)return;a=e+(b<<2)|0;while(1){if((a|0)==(d|0))break;f=d+-4|0;k[g>>2]=f;d=f}return}function MR(a){a=a|0;return 5064}function NR(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;b=k[a>>2]|0;if(b|0){c=a+4|0;d=k[c>>2]|0;while(1){if((b|0)==(d|0))break;e=d+-4|0;k[c>>2]=e;d=e}ggb(b)}ggb(a);return}function OR(){var a=0;while(1){a=fgb(12)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;return a|0}function PR(a){a=a|0;return Nh[a&127]()|0}function QR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=r;r=r+16|0;e=f;d=k[a>>2]|0;g=k[a+4>>2]|0;a=b+(g>>1)|0;if(g&1)d=k[(k[a>>2]|0)+d>>2]|0;k[e>>2]=c;jh[d&1023](a,e);r=f;return}function RR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;e=k[a>>2]|0;h=k[a+4>>2]|0;a=b+(h>>1)|0;if(h&1)e=k[(k[a>>2]|0)+e>>2]|0;k[f>>2]=d;Ph[e&511](a,c,f);r=g;return}function SR(a){a=a|0;return (k[a+4>>2]|0)-(k[a>>2]|0)>>2|0}function TR(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[a+4>>2]|0;a=b+(d>>1)|0;if(d&1)c=k[(k[a>>2]|0)+c>>2]|0;return Xh[c&1023](a)|0}function UR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=r;r=r+16|0;c=e;d=k[a>>2]|0;if((k[a+4>>2]|0)-d>>2>>>0<=b>>>0){d=1;r=e;return d|0}k[c>>2]=k[d+(b<<2)>>2];d=ue(28960,c|0)|0;r=e;return d|0}function VR(a,b,c){a=a|0;b=b|0;c=c|0;c=Hh[k[a>>2]&511](b,c)|0;nf(c|0);Td(c|0);return c|0}function WR(a,b,c){a=a|0;b=b|0;c=c|0;k[(k[a>>2]|0)+(b<<2)>>2]=k[c>>2];return 1}function XR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=r;r=r+16|0;f=e;a=k[a>>2]|0;k[f>>2]=d;d=ci[a&255](b,c,f)|0;r=e;return d|0}function YR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+8|0;g=k[j>>2]|0;l=a+4|0;d=k[l>>2]|0;if(g-d>>2>>>0>=b>>>0){do{k[d>>2]=k[c>>2];d=(k[l>>2]|0)+4|0;k[l>>2]=d;b=b+-1|0}while((b|0)!=0);return}e=k[a>>2]|0;i=d-e>>2;f=i+b|0;if(f>>>0>1073741823)ad(426534,426557,304,426811);d=g-e|0;if(d>>2>>>0<536870911){d=d>>1;d=d>>>0<f>>>0?f:d;if(d)if(d>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}else h=10;else e=0}else{d=1073741823;h=10}if((h|0)==10){f=d<<2;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}}g=e+(i<<2)|0;i=e+(d<<2)|0;h=g;do{f=h;k[f>>2]=k[c>>2];h=f+4|0;b=b+-1|0}while((b|0)!=0);b=k[a>>2]|0;d=k[l>>2]|0;e=b;f=d-e|0;g=g+(0-(f>>2)<<2)|0;if((f|0)>0){upb(g|0,b|0,f|0)|0;e=k[a>>2]|0;d=k[l>>2]|0}k[a>>2]=g;k[l>>2]=h;k[j>>2]=i;b=e;while(1){if((b|0)==(d|0))break;d=d+-4|0}if(!e)return;ggb(e);return}function ZR(a){a=a|0;return}function _R(a){a=a|0;return}function $R(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=k[b>>2]|0;if(!a){k[b>>2]=0;return}c=k[a>>2]|0;k[a+4>>2]=0;k[a>>2]=0;if(c|0?(e=c+-4|0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)ggb(k[c+-8>>2]|0);ggb(a);k[b>>2]=0;return}function aS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}d=k[b>>2]|0;k[a>>2]=d;k[a+4>>2]=k[b+4>>2];if(!d){k[c>>2]=a;return}b=d+-4|0;k[b>>2]=(k[b>>2]|0)+1;k[c>>2]=a;return}function bS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}d=k[b>>2]|0;b=k[d>>2]|0;k[a>>2]=b;k[a+4>>2]=k[d+4>>2];if(!b){k[c>>2]=a;return}d=b+-4|0;k[d>>2]=(k[d>>2]|0)+1;k[c>>2]=a;return}function cS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=k[c>>2]|0;a=k[d>>2]|0;k[d+4>>2]=0;k[d>>2]=0;if(a|0?(e=a+-4|0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)ggb(k[a+-8>>2]|0);d=k[c>>2]|0;c=k[b>>2]|0;if((c|0)==(d|0))return;a=k[d>>2]|0;b=d+4|0;k[b>>2]=0;k[d>>2]=0;if(a|0?(f=a+-4|0,e=k[f>>2]|0,k[f>>2]=e+-1,(e|0)==1):0)ggb(k[a+-8>>2]|0);a=k[c>>2]|0;if(a){a=a+-4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[c>>2]|0}k[d>>2]=a;k[b>>2]=k[c+4>>2];return}function dS(a,b){a=a|0;b=b|0;return k[b>>2]|0}function eS(a,b){a=a|0;b=b|0;return k[b>>2]|0}function fS(a){a=a|0;return 8}function gS(a){a=a|0;return 5176}function hS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=k[k[c>>2]>>2]|0;e=(e|0)==0?1016759:e;f=e;a:do if(!(f&3)){a=e;d=4}else{a=e;c=f;while(1){if(!(i[a>>0]|0)){a=c;break a}a=a+1|0;c=a;if(!(c&3)){d=4;break}}}while(0);if((d|0)==4){while(1){c=k[a>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))a=a+4|0;else break}if((c&255)<<24>>24)do a=a+1|0;while((i[a>>0]|0)!=0)}jS(b,e,a-f|0)|0;return}function iS(a){a=a|0;ggb(a);return}function jS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;e=l;d=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;if(!(k[d+16>>2]|0)){d=k[d+72>>2]|0;if(d|0?k[d+(k[(k[d>>2]|0)+-12>>2]|0)+24>>2]|0:0){Qhb(e,d);if(i[e>>0]|0?(j=k[d+(k[(k[d>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[j>>2]|0)+24>>2]&1023](j)|0)==-1):0){j=d+(k[(k[d>>2]|0)+-12>>2]|0)+16|0;k[j>>2]=k[j>>2]|1}d=k[e+4>>2]|0;j=d+(k[(k[d>>2]|0)+-12>>2]|0)|0;if((((k[j+24>>2]|0?(k[j+16>>2]|0)==0:0)?k[j+4>>2]&8192|0:0)?!(bd()|0):0)?(j=k[d+(k[(k[d>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[j>>2]|0)+24>>2]&1023](j)|0)==-1):0){j=d+(k[(k[d>>2]|0)+-12>>2]|0)+16|0;k[j>>2]=k[j>>2]|1}}h=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;j=k[h+24>>2]|0;g=b+c|0;f=(k[h+4>>2]&176|0)==32?g:b;c=h+76|0;d=k[c>>2]|0;if((d|0)==-1){e=k[h+28>>2]|0;d=e+4|0;k[d>>2]=(k[d>>2]|0)+1;d=Wib(828772)|0;d=k[(k[e+8>>2]|0)+(d<<2)>>2]|0;d=Hh[k[(k[d>>2]|0)+28>>2]&511](d,32)|0;n=e+4|0;m=k[n>>2]|0;k[n>>2]=m+-1;if(!m)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);d=d<<24>>24;k[c>>2]=d}if(!(kS(j,b,f,g,h,d&255)|0)){n=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[n>>2]=k[n>>2]|5}}d=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;if(!(k[d+24>>2]|0)){r=l;return a|0}if(k[d+16>>2]|0){r=l;return a|0}if(!(k[d+4>>2]&8192)){r=l;return a|0}if(bd()|0){r=l;return a|0}n=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+24>>2]|0;if((Xh[k[(k[n>>2]|0)+24>>2]&1023](n)|0)!=-1){r=l;return a|0}n=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[n>>2]=k[n>>2]|1;r=l;return a|0}function kS(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;g=a;n=o;if(!a){c=g;r=o;return c|0}h=b;j=d-h|0;m=e+12|0;l=k[m>>2]|0;j=(l|0)>(j|0)?l-j|0:0;l=c;e=l-h|0;if((e|0)>0?(ci[k[(k[a>>2]|0)+48>>2]&255](a,b,e)|0)!=(e|0):0){c=0;r=o;return c|0}if((j|0)>0){k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;if(j>>>0<11){b=n+11|0;i[b>>0]=j;e=n}else{h=j+16&-16;b=(h|0)==0?1:h;while(1){e=fgb(b)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[n>>2]=e;k[n+8>>2]=h|-2147483648;k[n+4>>2]=j;b=n+11|0}zpb(e|0,f|0,j|0)|0;i[e+j>>0]=0;e=(ci[k[(k[a>>2]|0)+48>>2]&255](a,(i[b>>0]|0)<0?k[n>>2]|0:n,j)|0)==(j|0);if((i[b>>0]|0)<0)ggb(k[n>>2]|0);if(e)g=e?g:0;else{c=0;r=o;return c|0}}d=d-l|0;if((d|0)>0?(ci[k[(k[g>>2]|0)+48>>2]&255](g,c,d)|0)!=(d|0):0){c=0;r=o;return c|0}k[m>>2]=0;c=g;r=o;return c|0}function lS(a){a=a|0;return}function mS(a,b){a=a|0;b=b|0;return}function nS(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function oS(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function pS(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function qS(a,b){a=a|0;b=b|0;return b|0}function rS(a,b){a=a|0;b=b|0;return b|0}function sS(a){a=a|0;return 4}function tS(a){a=a|0;return 28984}function uS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;m=r;r=r+16|0;j=m+8|0;l=m;h=k[c>>2]|0;a=k[(k[b>>2]|0)+-12>>2]|0;c=b+a|0;if(!(k[c+16>>2]|0)){c=k[c+72>>2]|0;if((c|0)!=0?(k[c+(k[(k[c>>2]|0)+-12>>2]|0)+24>>2]|0)!=0:0){Qhb(j,c);if(i[j>>0]|0?(g=k[c+(k[(k[c>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[g>>2]|0)+24>>2]&1023](g)|0)==-1):0){g=c+(k[(k[c>>2]|0)+-12>>2]|0)+16|0;k[g>>2]=k[g>>2]|1}a=k[j+4>>2]|0;g=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;if((((k[g+24>>2]|0?(k[g+16>>2]|0)==0:0)?k[g+4>>2]&8192|0:0)?!(bd()|0):0)?(g=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[g>>2]|0)+24>>2]&1023](g)|0)==-1):0){g=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[g>>2]=k[g>>2]|1}a=k[(k[b>>2]|0)+-12>>2]|0}a=k[b+a+28>>2]|0;g=a+4|0;k[g>>2]=(k[g>>2]|0)+1;g=Wib(828828)|0;g=k[(k[a+8>>2]|0)+(g<<2)>>2]|0;e=a+4|0;f=k[e>>2]|0;k[e>>2]=f+-1;if(!f)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);e=b+(k[(k[b>>2]|0)+-12>>2]|0)|0;f=k[e+24>>2]|0;d=e+76|0;a=k[d>>2]|0;if((a|0)==-1){a=k[e+28>>2]|0;c=a+4|0;k[c>>2]=(k[c>>2]|0)+1;c=Wib(828772)|0;c=k[(k[a+8>>2]|0)+(c<<2)>>2]|0;c=Hh[k[(k[c>>2]|0)+28>>2]&511](c,32)|0;o=a+4|0;n=k[o>>2]|0;k[o>>2]=n+-1;if(!n)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);a=c<<24>>24;k[d>>2]=a}o=k[(k[g>>2]|0)+24>>2]|0;k[l>>2]=f;k[j>>2]=k[l>>2];if(!($g[o&127](g,j,e,a&255,h)|0)){o=b+(k[(k[b>>2]|0)+-12>>2]|0)+16|0;k[o>>2]=k[o>>2]|5}}a=b+(k[(k[b>>2]|0)+-12>>2]|0)|0;if(!(k[a+24>>2]|0)){r=m;return}if(k[a+16>>2]|0){r=m;return}if(!(k[a+4>>2]&8192)){r=m;return}if(bd()|0){r=m;return}o=k[b+(k[(k[b>>2]|0)+-12>>2]|0)+24>>2]|0;if((Xh[k[(k[o>>2]|0)+24>>2]&1023](o)|0)!=-1){r=m;return}o=b+(k[(k[b>>2]|0)+-12>>2]|0)+16|0;k[o>>2]=k[o>>2]|1;r=m;return}function vS(a){a=a|0;ggb(a);return}function wS(a){a=a|0;return}function xS(a,b){a=a|0;b=b|0;a=k[b>>2]|0;if(a|0)ggb(a);k[b>>2]=0;return}function yS(a,b,c){a=a|0;b=b|0;c=c|0;while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;Qh[a&7]()}k[a>>2]=k[b>>2];k[c>>2]=a;return}function zS(a,b,c){a=a|0;b=b|0;c=c|0;while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;Qh[a&7]()}k[a>>2]=k[k[b>>2]>>2];k[c>>2]=a;return}function AS(a,b,c){a=a|0;b=b|0;c=c|0;k[k[c>>2]>>2]=k[k[b>>2]>>2];return}function BS(a,b){a=a|0;b=b|0;return k[b>>2]|0}function CS(a,b){a=a|0;b=b|0;return k[b>>2]|0}function DS(a){a=a|0;return 4}function ES(a){a=a|0;return 10192}function FS(a,b,c){a=a|0;b=b|0;c=c|0;Thb(b,k[k[c>>2]>>2]|0);return}function GS(a){a=a|0;ggb(a);return}function HS(a){a=a|0;return}function IS(a,b){a=a|0;b=b|0;a=k[b>>2]|0;if(a|0)ggb(a);k[b>>2]=0;return}function JS(a,b,c){a=a|0;b=b|0;c=c|0;while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;Qh[a&7]()}k[a>>2]=k[b>>2];k[c>>2]=a;return}function KS(a,b,c){a=a|0;b=b|0;c=c|0;while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;Qh[a&7]()}k[a>>2]=k[k[b>>2]>>2];k[c>>2]=a;return}function LS(a,b,c){a=a|0;b=b|0;c=c|0;k[k[c>>2]>>2]=k[k[b>>2]>>2];return}function MS(a,b){a=a|0;b=b|0;return k[b>>2]|0}function NS(a,b){a=a|0;b=b|0;return k[b>>2]|0}function OS(a){a=a|0;return 4}function PS(a){a=a|0;return 6888}function QS(a,b,c){a=a|0;b=b|0;c=c|0;Thb(b,k[k[c>>2]>>2]|0);return}function RS(a){a=a|0;ggb(a);return}function SS(a){a=a|0;return}function TS(a,b){a=a|0;b=b|0;return}function US(a,b,c){a=a|0;b=b|0;c=c|0;i[c>>0]=i[b>>0]&1;return}function VS(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function WS(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function XS(a,b){a=a|0;b=b|0;return b|0}function YS(a,b){a=a|0;b=b|0;return b|0}function ZS(a){a=a|0;return 1}function _S(a){a=a|0;return 28896}function $S(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;m=r;r=r+16|0;j=m+8|0;l=m;h=(i[c>>0]&1)!=0;a=k[(k[b>>2]|0)+-12>>2]|0;c=b+a|0;if(!(k[c+16>>2]|0)){c=k[c+72>>2]|0;if((c|0)!=0?(k[c+(k[(k[c>>2]|0)+-12>>2]|0)+24>>2]|0)!=0:0){Qhb(j,c);if(i[j>>0]|0?(g=k[c+(k[(k[c>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[g>>2]|0)+24>>2]&1023](g)|0)==-1):0){g=c+(k[(k[c>>2]|0)+-12>>2]|0)+16|0;k[g>>2]=k[g>>2]|1}a=k[j+4>>2]|0;g=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;if((((k[g+24>>2]|0?(k[g+16>>2]|0)==0:0)?k[g+4>>2]&8192|0:0)?!(bd()|0):0)?(g=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[g>>2]|0)+24>>2]&1023](g)|0)==-1):0){g=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[g>>2]=k[g>>2]|1}a=k[(k[b>>2]|0)+-12>>2]|0}a=k[b+a+28>>2]|0;g=a+4|0;k[g>>2]=(k[g>>2]|0)+1;g=Wib(828828)|0;g=k[(k[a+8>>2]|0)+(g<<2)>>2]|0;e=a+4|0;f=k[e>>2]|0;k[e>>2]=f+-1;if(!f)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);e=b+(k[(k[b>>2]|0)+-12>>2]|0)|0;f=k[e+24>>2]|0;d=e+76|0;a=k[d>>2]|0;if((a|0)==-1){a=k[e+28>>2]|0;c=a+4|0;k[c>>2]=(k[c>>2]|0)+1;c=Wib(828772)|0;c=k[(k[a+8>>2]|0)+(c<<2)>>2]|0;c=Hh[k[(k[c>>2]|0)+28>>2]&511](c,32)|0;o=a+4|0;n=k[o>>2]|0;k[o>>2]=n+-1;if(!n)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);a=c<<24>>24;k[d>>2]=a}o=k[(k[g>>2]|0)+12>>2]|0;k[l>>2]=f;k[j>>2]=k[l>>2];if(!($g[o&127](g,j,e,a&255,h)|0)){o=b+(k[(k[b>>2]|0)+-12>>2]|0)+16|0;k[o>>2]=k[o>>2]|5}}a=b+(k[(k[b>>2]|0)+-12>>2]|0)|0;if(!(k[a+24>>2]|0)){r=m;return}if(k[a+16>>2]|0){r=m;return}if(!(k[a+4>>2]&8192)){r=m;return}if(bd()|0){r=m;return}o=k[b+(k[(k[b>>2]|0)+-12>>2]|0)+24>>2]|0;if((Xh[k[(k[o>>2]|0)+24>>2]&1023](o)|0)!=-1){r=m;return}o=b+(k[(k[b>>2]|0)+-12>>2]|0)+16|0;k[o>>2]=k[o>>2]|1;r=m;return}function aT(a){a=a|0;ggb(a);return}function bT(a){a=a|0;return}function cT(a,b){a=a|0;b=b|0;return}function dT(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function eT(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function fT(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function gT(a,b){a=a|0;b=b|0;return b|0}function hT(a,b){a=a|0;b=b|0;return b|0}function iT(a){a=a|0;return 4}function jT(a){a=a|0;return 29008}function kT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,p=0;m=r;r=r+16|0;j=m+8|0;l=m;h=+o[c>>2];a=k[(k[b>>2]|0)+-12>>2]|0;c=b+a|0;if(!(k[c+16>>2]|0)){c=k[c+72>>2]|0;if((c|0)!=0?(k[c+(k[(k[c>>2]|0)+-12>>2]|0)+24>>2]|0)!=0:0){Qhb(j,c);if(i[j>>0]|0?(g=k[c+(k[(k[c>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[g>>2]|0)+24>>2]&1023](g)|0)==-1):0){g=c+(k[(k[c>>2]|0)+-12>>2]|0)+16|0;k[g>>2]=k[g>>2]|1}a=k[j+4>>2]|0;g=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;if((((k[g+24>>2]|0?(k[g+16>>2]|0)==0:0)?k[g+4>>2]&8192|0:0)?!(bd()|0):0)?(g=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[g>>2]|0)+24>>2]&1023](g)|0)==-1):0){g=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[g>>2]=k[g>>2]|1}a=k[(k[b>>2]|0)+-12>>2]|0}a=k[b+a+28>>2]|0;g=a+4|0;k[g>>2]=(k[g>>2]|0)+1;g=Wib(828828)|0;g=k[(k[a+8>>2]|0)+(g<<2)>>2]|0;e=a+4|0;f=k[e>>2]|0;k[e>>2]=f+-1;if(!f)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);e=b+(k[(k[b>>2]|0)+-12>>2]|0)|0;f=k[e+24>>2]|0;d=e+76|0;a=k[d>>2]|0;if((a|0)==-1){a=k[e+28>>2]|0;c=a+4|0;k[c>>2]=(k[c>>2]|0)+1;c=Wib(828772)|0;c=k[(k[a+8>>2]|0)+(c<<2)>>2]|0;c=Hh[k[(k[c>>2]|0)+28>>2]&511](c,32)|0;p=a+4|0;n=k[p>>2]|0;k[p>>2]=n+-1;if(!n)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);a=c<<24>>24;k[d>>2]=a}p=k[(k[g>>2]|0)+32>>2]|0;k[l>>2]=f;k[j>>2]=k[l>>2];if(!(ch[p&7](g,j,e,a&255,h)|0)){p=b+(k[(k[b>>2]|0)+-12>>2]|0)+16|0;k[p>>2]=k[p>>2]|5}}a=b+(k[(k[b>>2]|0)+-12>>2]|0)|0;if(!(k[a+24>>2]|0)){r=m;return}if(k[a+16>>2]|0){r=m;return}if(!(k[a+4>>2]&8192)){r=m;return}if(bd()|0){r=m;return}p=k[b+(k[(k[b>>2]|0)+-12>>2]|0)+24>>2]|0;if((Xh[k[(k[p>>2]|0)+24>>2]&1023](p)|0)!=-1){r=m;return}p=b+(k[(k[b>>2]|0)+-12>>2]|0)+16|0;k[p>>2]=k[p>>2]|1;r=m;return}function lT(a){a=a|0;ggb(a);return}function mT(a){a=a|0;return}function nT(a,b){a=a|0;b=b|0;return}function oT(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function pT(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function qT(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function rT(a,b){a=a|0;b=b|0;return b|0}function sT(a,b){a=a|0;b=b|0;return b|0}function tT(a){a=a|0;return 4}function uT(a){a=a|0;return 28960}function vT(a,b,c){a=a|0;b=b|0;c=c|0;Thb(b,k[c>>2]|0);return}function wT(a){a=a|0;ggb(a);return}function xT(a){a=a|0;return}function yT(a,b){a=a|0;b=b|0;return}function zT(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function AT(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function BT(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function CT(a,b){a=a|0;b=b|0;return b|0}function DT(a,b){a=a|0;b=b|0;return b|0}function ET(a){a=a|0;return 4}function FT(a){a=a|0;return 28912}function GT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=k[c>>2]|0;f=e;a:do if(!(f&3)){a=e;d=4}else{a=e;c=f;while(1){if(!(i[a>>0]|0)){a=c;break a}a=a+1|0;c=a;if(!(c&3)){d=4;break}}}while(0);if((d|0)==4){while(1){c=k[a>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))a=a+4|0;else break}if((c&255)<<24>>24)do a=a+1|0;while((i[a>>0]|0)!=0)}jS(b,e,a-f|0)|0;return}function HT(a){a=a|0;ggb(a);return}function IT(a){a=a|0;return}function JT(a,b){a=a|0;b=b|0;a=k[b>>2]|0;if(a|0)ggb(a);k[b>>2]=0;return}function KT(a,b,c){a=a|0;b=b|0;c=c|0;while(1){a=fgb(1)|0;if(a|0){b=5;break}a=k[207666]|0;k[207666]=a+0;if(!a){a=0;b=5;break}Qh[a&7]()}if((b|0)==5){k[c>>2]=a;return}}function LT(a,b,c){a=a|0;b=b|0;c=c|0;while(1){a=fgb(1)|0;if(a|0){b=5;break}a=k[207666]|0;k[207666]=a+0;if(!a){a=0;b=5;break}Qh[a&7]()}if((b|0)==5){k[c>>2]=a;return}}function MT(a,b,c){a=a|0;b=b|0;c=c|0;return}function NT(a,b){a=a|0;b=b|0;return k[b>>2]|0}function OT(a,b){a=a|0;b=b|0;return k[b>>2]|0}function PT(a){a=a|0;return 1}function QT(a){a=a|0;return 10392}function RT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:do if(!3){a=208379;d=4}else{a=208379;c=208379;while(1){if(!(i[a>>0]|0)){a=c;break a}a=a+1|0;c=a;if(!(c&3)){d=4;break}}}while(0);if((d|0)==4){while(1){c=k[a>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))a=a+4|0;else break}if((c&255)<<24>>24)do a=a+1|0;while((i[a>>0]|0)!=0)}jS(b,208379,a-208379|0)|0;return}function ST(a){a=a|0;ggb(a);return}function TT(a){a=a|0;return}function UT(a,b){a=a|0;b=b|0;return}function VT(a,b){a=a|0;b=b|0;return}function WT(a){a=a|0;return 0}function XT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+64|0;j=m+48|0;l=m+8|0;c=m;k[j>>2]=0;h=j+4|0;k[h>>2]=0;x6(l,b,1,j);k[h>>2]=0;k[j>>2]=0;jh[k[(k[a>>2]|0)+28>>2]&1023](c,a);b=z6(l,c)|0;k[j>>2]=0;h=j+4|0;k[h>>2]=0;f=ZT(8)|0;k[f>>2]=1;g=f+4|0;k[j>>2]=g;k[h>>2]=1;i[f+5>>0]=0;i[g>>0]=123;z6(b,j)|0;b=k[j>>2]|0;k[h>>2]=0;k[j>>2]=0;if(b|0?(g=b+-4|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[b+-8>>2]|0);b=k[c>>2]|0;k[c+4>>2]=0;k[c>>2]=0;if(b|0?(g=b+-4|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[b+-8>>2]|0);k[j>>2]=0;g=j+4|0;k[g>>2]=0;b=ZT(12)|0;k[b>>2]=1;h=b+4|0;k[j>>2]=h;k[g>>2]=6;i[b+10>>0]=0;i[h>>0]=i[371402]|0;i[h+1>>0]=i[371403]|0;i[h+2>>0]=i[371404]|0;i[h+3>>0]=i[371405]|0;i[h+4>>0]=i[371406]|0;i[h+5>>0]=i[371407]|0;h=z6(l,j)|0;b=k[j>>2]|0;k[g>>2]=0;k[j>>2]=0;if(b|0?(f=b+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[b+-8>>2]|0);if(Xh[k[(k[h>>2]|0)+12>>2]&1023](h)|0){g=h+32|0;if((k[g>>2]|0)==6){k[j>>2]=0;b=j+4|0;k[b>>2]=0;c=ZT(36)|0;k[c>>2]=1;d=c+4|0;k[j>>2]=d;k[b>>2]=30;i[c+34>>0]=0;e=401220;f=d+30|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-2,j,401251,401262,1064);k[b>>2]=0;k[j>>2]=0;f=k[c>>2]|0;k[c>>2]=f+-1;if((f|0)==1)ggb(k[c+-4>>2]|0)}if(!(k[h+16>>2]|0))b=0;else{b=k[h+12>>2]|0;b=(b|0)==0?1016759:b}p6(k[h+8>>2]|0,b,3);if(k[g>>2]&4|0)k[g>>2]=6}jh[k[(k[a>>2]|0)+12>>2]&1023](a,l);k[j>>2]=0;a=j+4|0;k[a>>2]=0;h=ZT(8)|0;k[h>>2]=1;b=h+4|0;k[j>>2]=b;k[a>>2]=1;i[h+5>>0]=0;i[b>>0]=125;z6(l,j)|0;b=k[j>>2]|0;k[a>>2]=0;k[j>>2]=0;if(!b){T4(l);r=m;return}a=b+-4|0;j=k[a>>2]|0;k[a>>2]=j+-1;if((j|0)!=1){T4(l);r=m;return}ggb(k[b+-8>>2]|0);T4(l);r=m;return}function YT(a,b){a=a|0;b=b|0;var c=0;c=ZT(16)|0;k[c>>2]=1;b=c+4|0;k[a>>2]=b;k[a+4>>2]=9;i[c+13>>0]=0;a=b;b=208531;c=a+9|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));return}function ZT(a){a=a|0;var b=0,c=0,d=0,e=0;e=r;r=r+16|0;c=e;d=e+8|0;b=fgb(a+20|0)|0;if(b|0){d=b+4+15&-16;k[d+-4>>2]=b;r=e;return d|0}k[c>>2]=a;$8(d,208557,c);Y8(-4,d,208586,208603,52);a=k[d>>2]|0;k[d+4>>2]=0;k[d>>2]=0;if(a|0?(c=a+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[a+-8>>2]|0);d=0;r=e;return d|0}function _T(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;n=r;r=r+16|0;j=n;m=n+8|0;h=k[a+4>>2]|0;if((h|0)<3)f=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{g=k[a+40>>2]|0;e=0;f=1;do{f=aa(k[g+(e<<2)>>2]|0,f)|0;e=e+1|0}while((e|0)!=(h|0))}p=b>>>3&511;o=p+1|0;e=b&7;g=o<<(47696>>>(e<<1)&3);h=k[40320+(e<<5)+((k[a>>2]&7)<<2)>>2]|0;b=k[a+16>>2]|0;a=(f|0)<=(p|0);k[j>>2]=a?f:o;k[j+4>>2]=1;sh[h&255](b,1,0,1,c,1,j,0);if(a){if((f|0)!=1?(p=m+4|0,l=ZT(16)|0,k[l>>2]=1,o=l+4|0,k[m>>2]=o,k[p>>2]=8,i[l+12>>0]=0,o,j=o,i[j>>0]=115,i[j+1>>0]=99,i[j+2>>0]=110,i[j+3>>0]=32,o=o+4|0,i[o>>0]=61,i[o+1>>0]=61,i[o+2>>0]=32,i[o+3>>0]=49,Y8(-215,m,208667,208690,68),k[p>>2]=0,k[m>>2]=0,p=k[l>>2]|0,k[l>>2]=p+-1,(p|0)==1):0)ggb(k[l+-4>>2]|0);f=1212424721>>>(e<<2)&15;if(f>>>0<g>>>0){e=f;do{i[c+e>>0]=i[c+(e-f)>>0]|0;e=e+1|0}while((e|0)!=(g|0))}}f=aa(g,d)|0;if(g>>>0<f>>>0)e=g;else{r=n;return}do{i[c+e>>0]=i[c+(e-g)>>0]|0;e=e+1|0}while((e|0)!=(f|0));r=n;return}function $T(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){j=0;do{i[e+j>>0]=i[c+j>>0]&i[h+j>>0];j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){j=0;do{p=j|1;a=i[c+p>>0]&i[h+p>>0];i[e+j>>0]=i[c+j>>0]&i[h+j>>0];i[e+p>>0]=a;p=j|2;a=j|3;o=i[c+a>>0]&i[h+a>>0];i[e+p>>0]=i[c+p>>0]&i[h+p>>0];i[e+a>>0]=o;j=j+4|0}while((j|0)<=(l|0));if(n){j=m;do{i[e+j>>0]=i[c+j>>0]&i[h+j>>0];j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function aU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0;R=r;r=r+1440|0;O=R+1376|0;s=R+1368|0;t=R+1352|0;n=R+1360|0;Q=R+312|0;P=R+256|0;M=R;L=R+184|0;K=R+128|0;F=R+104|0;I=R+88|0;J=R+56|0;H=R+248|0;G=R+240|0;C=a;D=b;q=k[a>>2]&2031616;v=k[b>>2]&2031616;A=S1(a,-1)|0;z=A&7;B=(A>>>3&511)+1|0;w=S1(b,-1)|0;u=w&7;x=(w>>>3&511)+1|0;o=a2(a)|0;h=a2(b)|0;o=(o|0)<3;if(o)R1(s,a,-1);else{k[s>>2]=0;k[s+4>>2]=0}h=(h|0)<3;if(h)R1(t,b,-1);else{k[t>>2]=0;k[t+4>>2]=0}E=(G2(d)|0)&1^1;if(((q|0)==(v|0)&(o&h)?(l=k[s>>2]|0,m=k[s+4>>2]|0,(l|0)==(k[t>>2]|0)?(m|0)==(k[t+4>>2]|0):0):0)?(A|0)==(w|0)&E<<24>>24==0:0){k[n>>2]=l;k[n+4>>2]=m;x2(c,n,A,0);if(f)q=B<<(47696>>>(A<<1&14)&3);else{e=e+(z<<2)|0;q=B}v=k[e>>2]|0;do if((k[a>>2]&2031616|0)==65536){m=k[a+4>>2]|0;k[O>>2]=k[m>>2];g=O+4|0;e=m+4|0;k[g>>2]=k[e>>2];M=O+8|0;k[M>>2]=k[m+8>>2];k[O+12>>2]=k[m+12>>2];k[O+16>>2]=k[m+16>>2];k[O+20>>2]=k[m+20>>2];k[O+24>>2]=k[m+24>>2];k[O+28>>2]=k[m+28>>2];k[O+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[O+36>>2]=h;j=O+40|0;k[j>>2]=M;M=O+48|0;o=O+44|0;k[o>>2]=M;k[O+52>>2]=0;k[M>>2]=0;if(h|0){M=h+12|0;k[M>>2]=(k[M>>2]|0)+1}if((k[e>>2]|0)<3){L=k[m+44>>2]|0;M=k[o>>2]|0;k[M>>2]=k[L>>2];k[M+4>>2]=k[L+4>>2];break}k[g>>2]=0;x1(O,k[e>>2]|0,0,0,0);if((k[g>>2]|0)>0){n=k[m+40>>2]|0;l=k[j>>2]|0;j=k[m+44>>2]|0;h=k[o>>2]|0;e=0;do{k[l+(e<<2)>>2]=k[n+(e<<2)>>2];k[h+(e<<2)>>2]=k[j+(e<<2)>>2];e=e+1|0}while((e|0)<(k[g>>2]|0))}}else Q1(O,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[Q>>2]=k[l>>2];g=Q+4|0;e=l+4|0;k[g>>2]=k[e>>2];M=Q+8|0;k[M>>2]=k[l+8>>2];k[Q+12>>2]=k[l+12>>2];k[Q+16>>2]=k[l+16>>2];k[Q+20>>2]=k[l+20>>2];k[Q+24>>2]=k[l+24>>2];k[Q+28>>2]=k[l+28>>2];k[Q+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[Q+36>>2]=h;j=Q+40|0;k[j>>2]=M;M=Q+48|0;n=Q+44|0;k[n>>2]=M;k[Q+52>>2]=0;k[M>>2]=0;if(h|0){M=h+12|0;k[M>>2]=(k[M>>2]|0)+1}if((k[e>>2]|0)<3){L=k[l+44>>2]|0;M=k[n>>2]|0;k[M>>2]=k[L>>2];k[M+4>>2]=k[L+4>>2];break}k[g>>2]=0;x1(Q,k[e>>2]|0,0,0,0);if((k[g>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;e=0;do{k[m+(e<<2)>>2]=k[o+(e<<2)>>2];k[h+(e<<2)>>2]=k[j+(e<<2)>>2];e=e+1|0}while((e|0)<(k[g>>2]|0))}}else Q1(Q,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){l=k[c+4>>2]|0;k[P>>2]=k[l>>2];g=P+4|0;e=l+4|0;k[g>>2]=k[e>>2];M=P+8|0;k[M>>2]=k[l+8>>2];k[P+12>>2]=k[l+12>>2];k[P+16>>2]=k[l+16>>2];k[P+20>>2]=k[l+20>>2];k[P+24>>2]=k[l+24>>2];k[P+28>>2]=k[l+28>>2];k[P+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[P+36>>2]=h;j=P+40|0;k[j>>2]=M;M=P+48|0;n=P+44|0;k[n>>2]=M;k[P+52>>2]=0;k[M>>2]=0;if(h|0){M=h+12|0;k[M>>2]=(k[M>>2]|0)+1}if((k[e>>2]|0)<3){M=k[l+44>>2]|0;e=k[n>>2]|0;k[e>>2]=k[M>>2];k[e+4>>2]=k[M+4>>2];e=P;break}k[g>>2]=0;x1(P,k[e>>2]|0,0,0,0);if((k[g>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;e=0;do{k[m+(e<<2)>>2]=k[o+(e<<2)>>2];k[h+(e<<2)>>2]=k[j+(e<<2)>>2];e=e+1|0}while((e|0)<(k[g>>2]|0));e=P}else e=P}else{Q1(P,c,-1);e=P}while(0);K=k[O>>2]|0;L=k[Q>>2]|0;M=k[e>>2]|0;e=k[O+12>>2]|0;j=k[O+8>>2]|0;h=Epb(j|0,((j|0)<0)<<31>>31|0,e|0,((e|0)<0)<<31>>31|0)|0;if((K&16384&L&M|0)!=0?(h|0)==(h|0)&(((h|0)<0)<<31>>31|0)==(N|0):0){e=h;j=1}e=aa(e,q)|0;s=O+16|0;t=O+44|0;u=O+48|0;o=Q+16|0;g=Q+44|0;q=Q+48|0;l=P+16|0;m=P+44|0;n=P+48|0;Gh[v&127](k[s>>2]|0,k[u>>2]|0,k[o>>2]|0,k[q>>2]|0,k[l>>2]|0,k[n>>2]|0,e,j,0);j=P+36|0;e=k[j>>2]|0;if(e|0?(L=e+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){h=k[j>>2]|0;if(h|0){e=k[h+4>>2]|0;if(!e){e=k[P+32>>2]|0;if(!e){e=B1()|0;h=k[j>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,h)}k[j>>2]=0}k[j>>2]=0;j=P+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[j>>2]|0)>0){h=k[P+40>>2]|0;e=0;do{k[h+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[j>>2]|0))}e=k[m>>2]|0;if(!((e|0)==(n|0)|(e|0)==0))ggb(k[e+-4>>2]|0);j=Q+36|0;e=k[j>>2]|0;if(e|0?(M=e+12|0,P=k[M>>2]|0,k[M>>2]=P+-1,(P|0)==1):0){h=k[j>>2]|0;if(h|0){e=k[h+4>>2]|0;do if(!e){e=k[Q+32>>2]|0;if(e|0)break;e=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,h)}k[j>>2]=0}k[j>>2]=0;j=Q+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[j>>2]|0)>0){h=k[Q+40>>2]|0;e=0;do{k[h+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[j>>2]|0))}e=k[g>>2]|0;if(!((e|0)==(q|0)|(e|0)==0))ggb(k[e+-4>>2]|0);j=O+36|0;e=k[j>>2]|0;if(e|0?(P=e+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){h=k[j>>2]|0;if(h|0){e=k[h+4>>2]|0;do if(!e){e=k[O+32>>2]|0;if(e|0)break;e=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,h)}k[j>>2]=0}k[j>>2]=0;j=O+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[j>>2]|0)>0){h=k[O+40>>2]|0;e=0;do{k[h+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[j>>2]|0))}e=k[t>>2]|0;if(!((e|0)==(u|0)|(e|0)==0))ggb(k[e+-4>>2]|0);r=R;return}a:do if((g|0)==12){v=1;u=z;g=A;x=B;s=D;h=C}else{n=(q|0)==131072;h=(v|0)==131072;if(((h&1)+(n&1)|0)!=1?(A|0)==(w|0)&(E2(a,b)|0):0){if(E2(a,b)|0){v=0;u=z;g=A;x=B;s=D;h=C;break}h=O+4|0;l=ZT(48)|0;k[l>>2]=1;m=l+4|0;k[O>>2]=m;k[h>>2]=41;i[l+45>>0]=0;n=208896;o=m+41|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,O,208886,208690,230);k[h>>2]=0;k[O>>2]=0;b=k[l>>2]|0;k[l>>2]=b+-1;if((b|0)==1)ggb(k[l+-4>>2]|0);v=0;u=z;g=A;x=B;s=D;h=C;break}b:do if((a2(a)|0)<=2?H2(a)|0:0){R1(O,a,-1);l=k[O>>2]|0;m=(l|0)==1;if(m){if(!((q|0)!=131072&h)){h=k[O+4>>2]|0;y=92}}else if(!((q|0)!=131072&h|(k[O+4>>2]|0)!=1)){h=1;y=92}do if((y|0)==92){q=(h|0)==1;if(!((l|0)==(x|0)&q|m&(q|(h|0)==(x|0)))){if(!(m&(h|0)==4))break;if(!(x>>>0<5&(S1(a,-1)|0)==6))break b}h=k[s>>2]|0;b=s+4|0;g=k[b>>2]|0;k[s>>2]=k[t>>2];v=t+4|0;k[b>>2]=k[v>>2];k[t>>2]=h;k[v>>2]=g;v=1;g=w;s=C;h=D;break a}while(0)}while(0);do if((a2(b)|0)<=2?H2(b)|0:0){R1(O,b,-1);l=k[O>>2]|0;m=(l|0)==1;if(m){if(!(n&(v|0)!=131072)){h=k[O+4>>2]|0;y=104}}else if(!(n&(v|0)!=131072|(k[O+4>>2]|0)!=1)){h=1;y=104}if((y|0)==104){y=(h|0)==1;if((l|0)==(B|0)&y|m&(y|(h|0)==(B|0))){v=1;u=z;g=A;x=B;s=D;h=C;break a}if(m&(h|0)==4)if(B>>>0<5&(S1(b,-1)|0)==6){v=1;u=z;g=A;x=B;s=D;h=C;break a}else break}}while(0);b=O+4|0;h=ZT(136)|0;k[h>>2]=1;y=h+4|0;k[O>>2]=y;k[b>>2]=130;i[h+134>>0]=0;upb(y|0,208755,130)|0;Y8(-209,O,208886,208690,225);k[b>>2]=0;k[O>>2]=0;b=k[h>>2]|0;k[h>>2]=b+-1;if((b|0)==1)ggb(k[h+-4>>2]|0);v=1;u=z;g=A;x=B;s=D;h=C}while(0);t=(g>>>3&511)+1<<(47696>>>(g<<1&14)&3);k[O>>2]=t;t=((t+1023|0)>>>0)/(t>>>0)|0;z=E<<24>>24!=0;if(z){if(!((S1(d,-1)|0|1|0)==1?(j=h,E2(d,j)|0):0)){j=Q+4|0;l=ZT(68)|0;k[l>>2]=1;m=l+4|0;k[Q>>2]=m;k[j>>2]=60;i[l+64>>0]=0;n=208938;o=m+60|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,Q,208886,208690,241);k[j>>2]=0;k[Q>>2]=0;b=k[l>>2]|0;k[l>>2]=b+-1;if((b|0)==1)ggb(k[l+-4>>2]|0);j=h}h=k[O>>2]|0;if(h>>>0<33){h=k[40936+(h<<2)>>2]|0;h=(h|0)==0?140:h}else h=140;if(E2(c,j)|0){l=(S1(c,-1)|0)!=(g|0);y=h;h=j}else{l=1;y=h;h=j}}else{l=0;y=0}A=Q+8|0;k[Q>>2]=A;B=Q+4|0;k[B>>2]=1032;K2(c,h,g);if(z&l){p[M>>3]=0.0;k[P>>2]=-1056833530;k[P+4>>2]=M;k[P+8>>2]=1;k[P+12>>2]=1;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;N2(c,P,L)}do if((k[h>>2]&2031616|0)==65536){m=k[h+4>>2]|0;k[P>>2]=k[m>>2];q=P+4|0;h=m+4|0;k[q>>2]=k[h>>2];b=P+8|0;k[b>>2]=k[m+8>>2];k[P+12>>2]=k[m+12>>2];k[P+16>>2]=k[m+16>>2];k[P+20>>2]=k[m+20>>2];k[P+24>>2]=k[m+24>>2];k[P+28>>2]=k[m+28>>2];k[P+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[P+36>>2]=j;l=P+40|0;k[l>>2]=b;b=P+48|0;o=P+44|0;k[o>>2]=b;k[P+52>>2]=0;k[b>>2]=0;if(j|0){b=j+12|0;k[b>>2]=(k[b>>2]|0)+1}if((k[h>>2]|0)<3){E=k[m+44>>2]|0;b=k[o>>2]|0;k[b>>2]=k[E>>2];k[b+4>>2]=k[E+4>>2];break}k[q>>2]=0;x1(P,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){g=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;h=0;do{k[n+(h<<2)>>2]=k[g+(h<<2)>>2];k[j+(h<<2)>>2]=k[l+(h<<2)>>2];h=h+1|0}while((h|0)<(k[q>>2]|0))}}else Q1(P,h,-1);while(0);h=s;do if((k[h>>2]&2031616|0)==65536){m=k[h+4>>2]|0;k[M>>2]=k[m>>2];q=M+4|0;h=m+4|0;k[q>>2]=k[h>>2];b=M+8|0;k[b>>2]=k[m+8>>2];k[M+12>>2]=k[m+12>>2];k[M+16>>2]=k[m+16>>2];k[M+20>>2]=k[m+20>>2];k[M+24>>2]=k[m+24>>2];k[M+28>>2]=k[m+28>>2];k[M+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[M+36>>2]=j;l=M+40|0;k[l>>2]=b;b=M+48|0;o=M+44|0;k[o>>2]=b;k[M+52>>2]=0;k[b>>2]=0;if(j|0){b=j+12|0;k[b>>2]=(k[b>>2]|0)+1}if((k[h>>2]|0)<3){E=k[m+44>>2]|0;b=k[o>>2]|0;k[b>>2]=k[E>>2];k[b+4>>2]=k[E+4>>2];break}k[q>>2]=0;x1(M,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){g=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;h=0;do{k[n+(h<<2)>>2]=k[g+(h<<2)>>2];k[j+(h<<2)>>2]=k[l+(h<<2)>>2];h=h+1|0}while((h|0)<(k[q>>2]|0))}}else Q1(M,h,-1);while(0);do if((k[c>>2]&2031616|0)==65536){m=k[c+4>>2]|0;k[L>>2]=k[m>>2];q=L+4|0;h=m+4|0;k[q>>2]=k[h>>2];c=L+8|0;k[c>>2]=k[m+8>>2];k[L+12>>2]=k[m+12>>2];k[L+16>>2]=k[m+16>>2];k[L+20>>2]=k[m+20>>2];k[L+24>>2]=k[m+24>>2];k[L+28>>2]=k[m+28>>2];k[L+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[L+36>>2]=j;l=L+40|0;k[l>>2]=c;c=L+48|0;o=L+44|0;k[o>>2]=c;k[L+52>>2]=0;k[c>>2]=0;if(j|0){c=j+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[h>>2]|0)<3){b=k[m+44>>2]|0;c=k[o>>2]|0;k[c>>2]=k[b>>2];k[c+4>>2]=k[b+4>>2];break}k[q>>2]=0;x1(L,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){g=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;h=0;do{k[n+(h<<2)>>2]=k[g+(h<<2)>>2];k[j+(h<<2)>>2]=k[l+(h<<2)>>2];h=h+1|0}while((h|0)<(k[q>>2]|0))}}else Q1(L,c,-1);while(0);do if((k[d>>2]&2031616|0)==65536){m=k[d+4>>2]|0;k[K>>2]=k[m>>2];q=K+4|0;h=m+4|0;k[q>>2]=k[h>>2];c=K+8|0;k[c>>2]=k[m+8>>2];k[K+12>>2]=k[m+12>>2];k[K+16>>2]=k[m+16>>2];k[K+20>>2]=k[m+20>>2];k[K+24>>2]=k[m+24>>2];k[K+28>>2]=k[m+28>>2];k[K+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[K+36>>2]=j;l=K+40|0;k[l>>2]=c;c=K+48|0;o=K+44|0;k[o>>2]=c;k[K+52>>2]=0;k[c>>2]=0;if(j|0){c=j+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[h>>2]|0)<3){d=k[m+44>>2]|0;c=k[o>>2]|0;k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];break}k[q>>2]=0;x1(K,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){g=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;h=0;do{k[n+(h<<2)>>2]=k[g+(h<<2)>>2];k[j+(h<<2)>>2]=k[l+(h<<2)>>2];h=h+1|0}while((h|0)<(k[q>>2]|0))}}else Q1(K,d,-1);while(0);x=f?k[O>>2]|0:x;a=k[(f?e:e+(u<<2)|0)>>2]|0;if(v){k[F>>2]=P;k[F+4>>2]=L;k[F+8>>2]=K;k[F+12>>2]=0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;k[J+16>>2]=0;k[J+20>>2]=0;k[J+24>>2]=0;k[J+28>>2]=0;z1(J,F,0,I,-1);u=k[J+20>>2]|0;t=t>>>0<u>>>0?t:u;h=(aa(aa(k[O>>2]|0,z?2:1)|0,t)|0)+32|0;if((k[B>>2]|0)>>>0<h>>>0){e=k[Q>>2]|0;if((e|0)!=(A|0)){if(e|0)ggb(e);k[Q>>2]=A;k[B>>2]=1032}if(h>>>0>1032){while(1){e=fgb(h)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[Q>>2]=e;k[B>>2]=h}else e=A}else{k[B>>2]=h;e=k[Q>>2]|0}n=e+(aa(k[O>>2]|0,t)|0)+15&-16;_T(M,k[P>>2]&4095,e,t);s=J+16|0;o=I+4|0;g=I+8|0;q=G+4|0;c:do if(!u){e=0;while(1){if(e>>>0>=(k[s>>2]|0)>>>0)break c;A1(J);e=e+1|0}}else{m=0;while(1){if(m>>>0>=(k[s>>2]|0)>>>0)break c;h=k[I>>2]|0;if(z){j=0;do{H=u-j|0;H=H>>>0>t>>>0?t:H;F=aa(H,x)|0;Gh[a&127](h,0,e,0,n,0,F,1,0);F=k[g>>2]|0;c=k[o>>2]|0;k[G>>2]=H;k[q>>2]=1;sh[y&255](n,0,F,0,c,0,G,O);k[g>>2]=(k[g>>2]|0)+H;H=aa(k[O>>2]|0,H)|0;h=(k[I>>2]|0)+H|0;k[I>>2]=h;k[o>>2]=(k[o>>2]|0)+H;j=j+t|0}while(u>>>0>j>>>0)}else{l=0;j=k[o>>2]|0;do{H=u-l|0;H=H>>>0>t>>>0?t:H;c=aa(H,x)|0;Gh[a&127](h,0,e,0,j,0,c,1,0);H=aa(k[O>>2]|0,H)|0;h=(k[I>>2]|0)+H|0;k[I>>2]=h;j=(k[o>>2]|0)+H|0;k[o>>2]=j;l=l+t|0}while(u>>>0>l>>>0)}A1(J);m=m+1|0}}while(0)}else{k[F>>2]=P;k[F+4>>2]=M;k[F+8>>2]=L;k[F+12>>2]=K;k[F+16>>2]=0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;k[J+16>>2]=0;k[J+20>>2]=0;k[J+24>>2]=0;k[J+28>>2]=0;z1(J,F,0,I,-1);w=k[J+20>>2]|0;if((aa(w,x)|0)<0)e=2147483647/(x|0)|0;else e=w;do if(z){e=t>>>0<e>>>0?t:e;j=aa(k[O>>2]|0,e)|0;if((k[B>>2]|0)>>>0>=j>>>0){k[B>>2]=j;h=k[Q>>2]|0;break}h=k[Q>>2]|0;if((h|0)!=(A|0)){if(h|0)ggb(h);k[Q>>2]=A;k[B>>2]=1032}if(j>>>0>1032){while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[Q>>2]=h;k[B>>2]=j}else h=A}else h=0;while(0);g=J+16|0;q=(w|0)==0;s=I+4|0;t=I+8|0;u=I+12|0;v=H+4|0;o=0;while(1){if(o>>>0>=(k[g>>2]|0)>>>0)break;d:do if(!q){l=k[I>>2]|0;j=k[s>>2]|0;if(z){m=0;while(1){G=w-m|0;G=G>>>0>e>>>0?e:G;F=aa(G,x)|0;Gh[a&127](l,0,j,0,h,0,F,1,0);F=k[u>>2]|0;c=k[t>>2]|0;k[H>>2]=G;k[v>>2]=1;sh[y&255](h,0,F,0,c,0,H,O);k[u>>2]=(k[u>>2]|0)+G;G=aa(k[O>>2]|0,G)|0;l=(k[I>>2]|0)+G|0;k[I>>2]=l;j=(k[s>>2]|0)+G|0;k[s>>2]=j;k[t>>2]=(k[t>>2]|0)+G;m=m+e|0;if(w>>>0<=m>>>0)break d}}n=0;m=k[t>>2]|0;do{G=w-n|0;G=G>>>0>e>>>0?e:G;c=aa(G,x)|0;Gh[a&127](l,0,j,0,m,0,c,1,0);G=aa(k[O>>2]|0,G)|0;l=(k[I>>2]|0)+G|0;k[I>>2]=l;j=(k[s>>2]|0)+G|0;k[s>>2]=j;m=(k[t>>2]|0)+G|0;k[t>>2]=m;n=n+e|0}while(w>>>0>n>>>0)}while(0);A1(J);o=o+1|0}}j=K+36|0;e=k[j>>2]|0;if(e|0?(J=e+12|0,O=k[J>>2]|0,k[J>>2]=O+-1,(O|0)==1):0){h=k[j>>2]|0;if(h|0){e=k[h+4>>2]|0;if(!e){e=k[K+32>>2]|0;if(!e){e=B1()|0;h=k[j>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,h)}k[j>>2]=0}k[j>>2]=0;O=K+16|0;h=K+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[h>>2]|0)>0){j=k[K+40>>2]|0;e=0;do{k[j+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[h>>2]|0))}e=k[K+44>>2]|0;if(!((e|0)==(K+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);j=L+36|0;e=k[j>>2]|0;if(e|0?(K=e+12|0,O=k[K>>2]|0,k[K>>2]=O+-1,(O|0)==1):0){h=k[j>>2]|0;if(h|0){e=k[h+4>>2]|0;do if(!e){e=k[L+32>>2]|0;if(e|0)break;e=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,h)}k[j>>2]=0}k[j>>2]=0;O=L+16|0;h=L+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[h>>2]|0)>0){j=k[L+40>>2]|0;e=0;do{k[j+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[h>>2]|0))}e=k[L+44>>2]|0;if(!((e|0)==(L+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);j=M+36|0;e=k[j>>2]|0;if(e|0?(L=e+12|0,O=k[L>>2]|0,k[L>>2]=O+-1,(O|0)==1):0){h=k[j>>2]|0;if(h|0){e=k[h+4>>2]|0;do if(!e){e=k[M+32>>2]|0;if(e|0)break;e=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,h)}k[j>>2]=0}k[j>>2]=0;O=M+16|0;h=M+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[h>>2]|0)>0){j=k[M+40>>2]|0;e=0;do{k[j+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[h>>2]|0))}e=k[M+44>>2]|0;if(!((e|0)==(M+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);j=P+36|0;e=k[j>>2]|0;do if(e|0){M=e+12|0;O=k[M>>2]|0;k[M>>2]=O+-1;if((O|0)!=1)break;h=k[j>>2]|0;if(h|0){e=k[h+4>>2]|0;do if(!e){e=k[P+32>>2]|0;if(e|0)break;e=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,h)}k[j>>2]=0}while(0);k[j>>2]=0;O=P+16|0;h=P+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[h>>2]|0)>0){j=k[P+40>>2]|0;e=0;do{k[j+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[h>>2]|0))}e=k[P+44>>2]|0;if(!((e|0)==(P+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[Q>>2]|0;if((e|0)!=(A|0)){if(e|0)ggb(e);k[Q>>2]=A;k[B>>2]=1032}r=R;return}function bU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){j=0;do{i[e+j>>0]=i[c+j>>0]|i[h+j>>0];j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){j=0;do{p=j|1;a=i[c+p>>0]|i[h+p>>0];i[e+j>>0]=i[c+j>>0]|i[h+j>>0];i[e+p>>0]=a;p=j|2;a=j|3;o=i[c+a>>0]|i[h+a>>0];i[e+p>>0]=i[c+p>>0]|i[h+p>>0];i[e+a>>0]=o;j=j+4|0}while((j|0)<=(l|0));if(n){j=m;do{i[e+j>>0]=i[c+j>>0]|i[h+j>>0];j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function cU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){j=0;do{i[e+j>>0]=i[c+j>>0]^i[h+j>>0];j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){j=0;do{p=j|1;a=i[c+p>>0]^i[h+p>>0];i[e+j>>0]=i[c+j>>0]^i[h+j>>0];i[e+p>>0]=a;p=j|2;a=j|3;o=i[c+a>>0]^i[h+a>>0];i[e+p>>0]=i[c+p>>0]^i[h+p>>0];i[e+a>>0]=o;j=j+4|0}while((j|0)<=(l|0));if(n){j=m;do{i[e+j>>0]=i[c+j>>0]^i[h+j>>0];j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function dU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,m=0,n=0,o=0;d=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){h=(g|0)>0;j=e;while(1){if(h){c=0;do{i[j+c>>0]=(l[a+c>>0]|0)^255;c=c+1|0}while((c|0)!=(g|0))}if(!d)break;else{j=j+f|0;a=a+b|0;d=d+-1|0}}return}k=g&-4;m=(k|0)<(g|0);j=e;while(1){c=0;do{o=c|1;e=((l[a+o>>0]|0)^255)&255;i[j+c>>0]=(l[a+c>>0]|0)^255;i[j+o>>0]=e;o=c|2;e=c|3;n=((l[a+e>>0]|0)^255)&255;i[j+o>>0]=(l[a+o>>0]|0)^255;i[j+e>>0]=n;c=c+4|0}while((c|0)<=(h|0));if(m){c=k;do{i[j+c>>0]=(l[a+c>>0]|0)^255;c=c+1|0}while((c|0)!=(g|0))}if(!d)break;else{j=j+f|0;a=a+b|0;d=d+-1|0}}return}function eU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0;k=h+-1|0;if(!h)return;m=g+-4|0;if((g|0)<4){m=(g|0)>0;h=a;while(1){if(m){j=0;do{a=l[h+j>>0]|0;i[e+j>>0]=(l[352559+(256-a+(l[c+j>>0]|0))>>0]|0)+a;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}n=g&-4;o=(n|0)<(g|0);h=a;while(1){j=0;do{a=l[h+j>>0]|0;q=j|1;r=l[h+q>>0]|0;r=(l[352559+(256-r+(l[c+q>>0]|0))>>0]|0)+r&255;i[e+j>>0]=(l[352559+(256-a+(l[c+j>>0]|0))>>0]|0)+a;i[e+q>>0]=r;q=j|2;r=l[h+q>>0]|0;a=j|3;p=l[h+a>>0]|0;p=(l[352559+(256-p+(l[c+a>>0]|0))>>0]|0)+p&255;i[e+q>>0]=(l[352559+(256-r+(l[c+q>>0]|0))>>0]|0)+r;i[e+a>>0]=p;j=j+4|0}while((j|0)<=(m|0));if(o){j=n;do{r=l[h+j>>0]|0;i[e+j>>0]=(l[352559+(256-r+(l[c+j>>0]|0))>>0]|0)+r;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function fU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){j=0;do{a=i[h+j>>0]|0;n=i[c+j>>0]|0;i[e+j>>0]=a<<24>>24<n<<24>>24?n:a;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){j=0;do{a=i[h+j>>0]|0;o=i[c+j>>0]|0;q=j|1;r=i[h+q>>0]|0;s=i[c+q>>0]|0;i[e+j>>0]=a<<24>>24<o<<24>>24?o:a;i[e+q>>0]=r<<24>>24<s<<24>>24?s:r;q=j|2;r=i[h+q>>0]|0;s=i[c+q>>0]|0;a=j|3;o=i[h+a>>0]|0;p=i[c+a>>0]|0;i[e+q>>0]=r<<24>>24<s<<24>>24?s:r;i[e+a>>0]=o<<24>>24<p<<24>>24?p:o;j=j+4|0}while((j|0)<=(l|0));if(n){j=m;do{s=i[h+j>>0]|0;r=i[c+j>>0]|0;i[e+j>>0]=s<<24>>24<r<<24>>24?r:s;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function gU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{a=j[h+(i<<1)>>1]|0;n=j[c+(i<<1)>>1]|0;j[e+(i<<1)>>1]=(a&65535)<(n&65535)?n:a;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){i=0;do{a=j[h+(i<<1)>>1]|0;o=j[c+(i<<1)>>1]|0;q=i|1;r=j[h+(q<<1)>>1]|0;s=j[c+(q<<1)>>1]|0;j[e+(i<<1)>>1]=(a&65535)<(o&65535)?o:a;j[e+(q<<1)>>1]=(r&65535)<(s&65535)?s:r;q=i|2;r=j[h+(q<<1)>>1]|0;s=j[c+(q<<1)>>1]|0;a=i|3;o=j[h+(a<<1)>>1]|0;p=j[c+(a<<1)>>1]|0;j[e+(q<<1)>>1]=(r&65535)<(s&65535)?s:r;j[e+(a<<1)>>1]=(o&65535)<(p&65535)?p:o;i=i+4|0}while((i|0)<=(l|0));if(n){i=m;do{s=j[h+(i<<1)>>1]|0;r=j[c+(i<<1)>>1]|0;j[e+(i<<1)>>1]=(s&65535)<(r&65535)?r:s;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function hU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{a=j[h+(i<<1)>>1]|0;n=j[c+(i<<1)>>1]|0;j[e+(i<<1)>>1]=a<<16>>16<n<<16>>16?n:a;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){i=0;do{a=j[h+(i<<1)>>1]|0;o=j[c+(i<<1)>>1]|0;q=i|1;r=j[h+(q<<1)>>1]|0;s=j[c+(q<<1)>>1]|0;j[e+(i<<1)>>1]=a<<16>>16<o<<16>>16?o:a;j[e+(q<<1)>>1]=r<<16>>16<s<<16>>16?s:r;q=i|2;r=j[h+(q<<1)>>1]|0;s=j[c+(q<<1)>>1]|0;a=i|3;o=j[h+(a<<1)>>1]|0;p=j[c+(a<<1)>>1]|0;j[e+(q<<1)>>1]=r<<16>>16<s<<16>>16?s:r;j[e+(a<<1)>>1]=o<<16>>16<p<<16>>16?p:o;i=i+4|0}while((i|0)<=(l|0));if(n){i=m;do{s=j[h+(i<<1)>>1]|0;r=j[c+(i<<1)>>1]|0;j[e+(i<<1)>>1]=s<<16>>16<r<<16>>16?r:s;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function iU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{a=k[h+(i<<2)>>2]|0;n=k[c+(i<<2)>>2]|0;k[e+(i<<2)>>2]=(a|0)<(n|0)?n:a;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){i=0;do{a=k[h+(i<<2)>>2]|0;o=k[c+(i<<2)>>2]|0;q=i|1;r=k[h+(q<<2)>>2]|0;s=k[c+(q<<2)>>2]|0;k[e+(i<<2)>>2]=(a|0)<(o|0)?o:a;k[e+(q<<2)>>2]=(r|0)<(s|0)?s:r;q=i|2;r=k[h+(q<<2)>>2]|0;s=k[c+(q<<2)>>2]|0;a=i|3;o=k[h+(a<<2)>>2]|0;p=k[c+(a<<2)>>2]|0;k[e+(q<<2)>>2]=(r|0)<(s|0)?s:r;k[e+(a<<2)>>2]=(o|0)<(p|0)?p:o;i=i+4|0}while((i|0)<=(l|0));if(n){i=m;do{s=k[h+(i<<2)>>2]|0;r=k[c+(i<<2)>>2]|0;k[e+(i<<2)>>2]=(s|0)<(r|0)?r:s;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function jU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0.0,p=0.0,q=0,r=0.0,s=0.0;j=h+-1|0;if(!h)return;k=g+-4|0;if((g|0)<4){k=(g|0)>0;h=a;while(1){if(k){i=0;do{n=+o[h+(i<<2)>>2];p=+o[c+(i<<2)>>2];o[e+(i<<2)>>2]=n<p?p:n;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}l=g&-4;m=(l|0)<(g|0);h=a;while(1){i=0;do{p=+o[h+(i<<2)>>2];n=+o[c+(i<<2)>>2];q=i|1;r=+o[h+(q<<2)>>2];s=+o[c+(q<<2)>>2];o[e+(i<<2)>>2]=p<n?n:p;o[e+(q<<2)>>2]=r<s?s:r;q=i|2;r=+o[h+(q<<2)>>2];s=+o[c+(q<<2)>>2];a=i|3;p=+o[h+(a<<2)>>2];n=+o[c+(a<<2)>>2];o[e+(q<<2)>>2]=r<s?s:r;o[e+(a<<2)>>2]=p<n?n:p;i=i+4|0}while((i|0)<=(k|0));if(m){i=l;do{s=+o[h+(i<<2)>>2];r=+o[c+(i<<2)>>2];o[e+(i<<2)>>2]=s<r?r:s;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function kU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0;j=h+-1|0;if(!h)return;k=g+-4|0;if((g|0)<4){k=(g|0)>0;h=a;while(1){if(k){i=0;do{n=+p[h+(i<<3)>>3];o=+p[c+(i<<3)>>3];p[e+(i<<3)>>3]=n<o?o:n;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}l=g&-4;m=(l|0)<(g|0);h=a;while(1){i=0;do{o=+p[h+(i<<3)>>3];n=+p[c+(i<<3)>>3];q=i|1;r=+p[h+(q<<3)>>3];s=+p[c+(q<<3)>>3];p[e+(i<<3)>>3]=o<n?n:o;p[e+(q<<3)>>3]=r<s?s:r;q=i|2;r=+p[h+(q<<3)>>3];s=+p[c+(q<<3)>>3];a=i|3;o=+p[h+(a<<3)>>3];n=+p[c+(a<<3)>>3];p[e+(q<<3)>>3]=r<s?s:r;p[e+(a<<3)>>3]=o<n?n:o;i=i+4|0}while((i|0)<=(k|0));if(m){i=l;do{s=+p[h+(i<<3)>>3];r=+p[c+(i<<3)>>3];p[e+(i<<3)>>3]=s<r?r:s;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function lU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0;k=h+-1|0;if(!h)return;m=g+-4|0;if((g|0)<4){m=(g|0)>0;h=a;while(1){if(m){j=0;do{a=l[h+j>>0]|0;i[e+j>>0]=a-(l[352559+((a|256)-(l[c+j>>0]|0))>>0]|0);j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}n=g&-4;o=(n|0)<(g|0);h=a;while(1){j=0;do{a=l[h+j>>0]|0;q=j|1;r=l[h+q>>0]|0;r=r-(l[352559+((r|256)-(l[c+q>>0]|0))>>0]|0)&255;i[e+j>>0]=a-(l[352559+((a|256)-(l[c+j>>0]|0))>>0]|0);i[e+q>>0]=r;q=j|2;r=l[h+q>>0]|0;a=j|3;p=l[h+a>>0]|0;p=p-(l[352559+((p|256)-(l[c+a>>0]|0))>>0]|0)&255;i[e+q>>0]=r-(l[352559+((r|256)-(l[c+q>>0]|0))>>0]|0);i[e+a>>0]=p;j=j+4|0}while((j|0)<=(m|0));if(o){j=n;do{r=l[h+j>>0]|0;i[e+j>>0]=r-(l[352559+((r|256)-(l[c+j>>0]|0))>>0]|0);j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function mU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){j=0;do{a=i[h+j>>0]|0;n=i[c+j>>0]|0;i[e+j>>0]=n<<24>>24<a<<24>>24?n:a;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){j=0;do{a=i[h+j>>0]|0;o=i[c+j>>0]|0;q=j|1;r=i[h+q>>0]|0;s=i[c+q>>0]|0;i[e+j>>0]=o<<24>>24<a<<24>>24?o:a;i[e+q>>0]=s<<24>>24<r<<24>>24?s:r;q=j|2;r=i[h+q>>0]|0;s=i[c+q>>0]|0;a=j|3;o=i[h+a>>0]|0;p=i[c+a>>0]|0;i[e+q>>0]=s<<24>>24<r<<24>>24?s:r;i[e+a>>0]=p<<24>>24<o<<24>>24?p:o;j=j+4|0}while((j|0)<=(l|0));if(n){j=m;do{s=i[h+j>>0]|0;r=i[c+j>>0]|0;i[e+j>>0]=r<<24>>24<s<<24>>24?r:s;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function nU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{a=j[h+(i<<1)>>1]|0;n=j[c+(i<<1)>>1]|0;j[e+(i<<1)>>1]=(n&65535)<(a&65535)?n:a;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){i=0;do{a=j[h+(i<<1)>>1]|0;o=j[c+(i<<1)>>1]|0;q=i|1;r=j[h+(q<<1)>>1]|0;s=j[c+(q<<1)>>1]|0;j[e+(i<<1)>>1]=(o&65535)<(a&65535)?o:a;j[e+(q<<1)>>1]=(s&65535)<(r&65535)?s:r;q=i|2;r=j[h+(q<<1)>>1]|0;s=j[c+(q<<1)>>1]|0;a=i|3;o=j[h+(a<<1)>>1]|0;p=j[c+(a<<1)>>1]|0;j[e+(q<<1)>>1]=(s&65535)<(r&65535)?s:r;j[e+(a<<1)>>1]=(p&65535)<(o&65535)?p:o;i=i+4|0}while((i|0)<=(l|0));if(n){i=m;do{s=j[h+(i<<1)>>1]|0;r=j[c+(i<<1)>>1]|0;j[e+(i<<1)>>1]=(r&65535)<(s&65535)?r:s;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function oU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{a=j[h+(i<<1)>>1]|0;n=j[c+(i<<1)>>1]|0;j[e+(i<<1)>>1]=n<<16>>16<a<<16>>16?n:a;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){i=0;do{a=j[h+(i<<1)>>1]|0;o=j[c+(i<<1)>>1]|0;q=i|1;r=j[h+(q<<1)>>1]|0;s=j[c+(q<<1)>>1]|0;j[e+(i<<1)>>1]=o<<16>>16<a<<16>>16?o:a;j[e+(q<<1)>>1]=s<<16>>16<r<<16>>16?s:r;q=i|2;r=j[h+(q<<1)>>1]|0;s=j[c+(q<<1)>>1]|0;a=i|3;o=j[h+(a<<1)>>1]|0;p=j[c+(a<<1)>>1]|0;j[e+(q<<1)>>1]=s<<16>>16<r<<16>>16?s:r;j[e+(a<<1)>>1]=p<<16>>16<o<<16>>16?p:o;i=i+4|0}while((i|0)<=(l|0));if(n){i=m;do{s=j[h+(i<<1)>>1]|0;r=j[c+(i<<1)>>1]|0;j[e+(i<<1)>>1]=r<<16>>16<s<<16>>16?r:s;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function pU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{a=k[h+(i<<2)>>2]|0;n=k[c+(i<<2)>>2]|0;k[e+(i<<2)>>2]=(n|0)<(a|0)?n:a;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){i=0;do{a=k[h+(i<<2)>>2]|0;o=k[c+(i<<2)>>2]|0;q=i|1;r=k[h+(q<<2)>>2]|0;s=k[c+(q<<2)>>2]|0;k[e+(i<<2)>>2]=(o|0)<(a|0)?o:a;k[e+(q<<2)>>2]=(s|0)<(r|0)?s:r;q=i|2;r=k[h+(q<<2)>>2]|0;s=k[c+(q<<2)>>2]|0;a=i|3;o=k[h+(a<<2)>>2]|0;p=k[c+(a<<2)>>2]|0;k[e+(q<<2)>>2]=(s|0)<(r|0)?s:r;k[e+(a<<2)>>2]=(p|0)<(o|0)?p:o;i=i+4|0}while((i|0)<=(l|0));if(n){i=m;do{s=k[h+(i<<2)>>2]|0;r=k[c+(i<<2)>>2]|0;k[e+(i<<2)>>2]=(r|0)<(s|0)?r:s;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function qU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0.0,p=0.0,q=0,r=0.0,s=0.0;j=h+-1|0;if(!h)return;k=g+-4|0;if((g|0)<4){k=(g|0)>0;h=a;while(1){if(k){i=0;do{n=+o[h+(i<<2)>>2];p=+o[c+(i<<2)>>2];o[e+(i<<2)>>2]=p<n?p:n;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}l=g&-4;m=(l|0)<(g|0);h=a;while(1){i=0;do{p=+o[h+(i<<2)>>2];n=+o[c+(i<<2)>>2];q=i|1;r=+o[h+(q<<2)>>2];s=+o[c+(q<<2)>>2];o[e+(i<<2)>>2]=n<p?n:p;o[e+(q<<2)>>2]=s<r?s:r;q=i|2;r=+o[h+(q<<2)>>2];s=+o[c+(q<<2)>>2];a=i|3;p=+o[h+(a<<2)>>2];n=+o[c+(a<<2)>>2];o[e+(q<<2)>>2]=s<r?s:r;o[e+(a<<2)>>2]=n<p?n:p;i=i+4|0}while((i|0)<=(k|0));if(m){i=l;do{s=+o[h+(i<<2)>>2];r=+o[c+(i<<2)>>2];o[e+(i<<2)>>2]=r<s?r:s;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function rU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0;j=h+-1|0;if(!h)return;k=g+-4|0;if((g|0)<4){k=(g|0)>0;h=a;while(1){if(k){i=0;do{n=+p[h+(i<<3)>>3];o=+p[c+(i<<3)>>3];p[e+(i<<3)>>3]=o<n?o:n;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}l=g&-4;m=(l|0)<(g|0);h=a;while(1){i=0;do{o=+p[h+(i<<3)>>3];n=+p[c+(i<<3)>>3];q=i|1;r=+p[h+(q<<3)>>3];s=+p[c+(q<<3)>>3];p[e+(i<<3)>>3]=n<o?n:o;p[e+(q<<3)>>3]=s<r?s:r;q=i|2;r=+p[h+(q<<3)>>3];s=+p[c+(q<<3)>>3];a=i|3;o=+p[h+(a<<3)>>3];n=+p[c+(a<<3)>>3];p[e+(q<<3)>>3]=s<r?s:r;p[e+(a<<3)>>3]=n<o?n:o;i=i+4|0}while((i|0)<=(k|0));if(m){i=l;do{s=+p[h+(i<<3)>>3];r=+p[c+(i<<3)>>3];p[e+(i<<3)>>3]=r<s?r:s;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function sU(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;ua=r;r=r+1504|0;ra=ua+1440|0;C=ua+1432|0;G=ua+1424|0;ta=ua;sa=ua+1368|0;qa=ua+1232|0;pa=ua+1168|0;oa=ua+128|0;$=ua+104|0;ma=ua+88|0;na=ua+56|0;ga=ua+1360|0;ha=ua+1352|0;ia=ua+1344|0;ja=ua+1336|0;ka=ua+1328|0;la=ua+1320|0;ba=ua+1312|0;ca=ua+1304|0;da=ua+1296|0;ea=ua+1288|0;fa=ua+1224|0;L=a;K=b;D=k[a>>2]&2031616;E=k[b>>2]&2031616;P=(G2(d)|0)&1^1;H=S1(a,-1)|0;O=H&7;v=H>>>3&511;I=v+1|0;J=S1(b,-1)|0;o=J&7;F=(J>>>3&511)+1|0;w=a2(a)|0;y=a2(b)|0;A=(w|0)<3;if(A)R1(C,a,-1);else{k[C>>2]=0;k[C+4>>2]=0}B=(y|0)<3;if(B)R1(G,b,-1);else{k[G>>2]=0;k[G+4>>2]=0}if((a2(a)|0)<=2?H2(a)|0:0){R1(ra,a,-1);m=k[ra>>2]|0;n=(m|0)==1;if(!n?(k[ra+4>>2]|0)!=1:0)j=0;else if(!((D|0)!=131072&(E|0)==131072)){j=k[ra+4>>2]|0;_=(j|0)==1;if(!((m|0)==(F|0)&_|n&(_|(j|0)==(F|0))))if(n&(j|0)==4)j=F>>>0<5&(S1(a,-1)|0)==6;else j=0;else j=1}else j=0}else j=0;if((a2(b)|0)<=2?H2(b)|0:0){R1(ra,b,-1);n=k[ra>>2]|0;q=(n|0)==1;if(!q?(k[ra+4>>2]|0)!=1:0)m=0;else if(!((D|0)==131072&(E|0)!=131072)){m=k[ra+4>>2]|0;_=(m|0)==1;if(!((n|0)==(I|0)&_|q&(_|(m|0)==(I|0))))if(q&(m|0)==4)m=I>>>0<5&(S1(b,-1)|0)==6;else m=0;else m=1}else m=0}else m=0;do if(((D|0)==(E|0)|(v|0)==0?B&(A&((k[C>>2]|0)==(k[G>>2]|0)?(k[C+4>>2]|0)==(k[G+4>>2]|0):0)):0)?(H|0)==(J|0)&P<<24>>24==0:0){if((k[c>>2]|0)<0){if(j^m|(S1(c,-1)|0)!=(H|0))break}else if(((e|0)<0|(e&7|0)==(O|0))^1|j^m)break;K2(c,a,H);do if((k[a>>2]&2031616|0)==65536){n=k[a+4>>2]|0;k[ra>>2]=k[n>>2];t=ra+4|0;j=n+4|0;k[t>>2]=k[j>>2];qa=ra+8|0;k[qa>>2]=k[n+8>>2];k[ra+12>>2]=k[n+12>>2];k[ra+16>>2]=k[n+16>>2];k[ra+20>>2]=k[n+20>>2];k[ra+24>>2]=k[n+24>>2];k[ra+28>>2]=k[n+28>>2];k[ra+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[ra+36>>2]=l;m=ra+40|0;k[m>>2]=qa;qa=ra+48|0;q=ra+44|0;k[q>>2]=qa;k[ra+52>>2]=0;k[qa>>2]=0;if(l|0){qa=l+12|0;k[qa>>2]=(k[qa>>2]|0)+1}if((k[j>>2]|0)<3){pa=k[n+44>>2]|0;qa=k[q>>2]|0;k[qa>>2]=k[pa>>2];k[qa+4>>2]=k[pa+4>>2];break}k[t>>2]=0;x1(ra,k[j>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[n+40>>2]|0;o=k[m>>2]|0;m=k[n+44>>2]|0;l=k[q>>2]|0;j=0;do{k[o+(j<<2)>>2]=k[s+(j<<2)>>2];k[l+(j<<2)>>2]=k[m+(j<<2)>>2];j=j+1|0}while((j|0)<(k[t>>2]|0))}}else Q1(ra,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){n=k[b+4>>2]|0;k[ta>>2]=k[n>>2];t=ta+4|0;j=n+4|0;k[t>>2]=k[j>>2];qa=ta+8|0;k[qa>>2]=k[n+8>>2];k[ta+12>>2]=k[n+12>>2];k[ta+16>>2]=k[n+16>>2];k[ta+20>>2]=k[n+20>>2];k[ta+24>>2]=k[n+24>>2];k[ta+28>>2]=k[n+28>>2];k[ta+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[ta+36>>2]=l;m=ta+40|0;k[m>>2]=qa;qa=ta+48|0;q=ta+44|0;k[q>>2]=qa;k[ta+52>>2]=0;k[qa>>2]=0;if(l|0){qa=l+12|0;k[qa>>2]=(k[qa>>2]|0)+1}if((k[j>>2]|0)<3){pa=k[n+44>>2]|0;qa=k[q>>2]|0;k[qa>>2]=k[pa>>2];k[qa+4>>2]=k[pa+4>>2];break}k[t>>2]=0;x1(ta,k[j>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[n+40>>2]|0;o=k[m>>2]|0;m=k[n+44>>2]|0;l=k[q>>2]|0;j=0;do{k[o+(j<<2)>>2]=k[s+(j<<2)>>2];k[l+(j<<2)>>2]=k[m+(j<<2)>>2];j=j+1|0}while((j|0)<(k[t>>2]|0))}}else Q1(ta,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){n=k[c+4>>2]|0;k[sa>>2]=k[n>>2];t=sa+4|0;j=n+4|0;k[t>>2]=k[j>>2];qa=sa+8|0;k[qa>>2]=k[n+8>>2];k[sa+12>>2]=k[n+12>>2];k[sa+16>>2]=k[n+16>>2];k[sa+20>>2]=k[n+20>>2];k[sa+24>>2]=k[n+24>>2];k[sa+28>>2]=k[n+28>>2];k[sa+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[sa+36>>2]=l;m=sa+40|0;k[m>>2]=qa;qa=sa+48|0;q=sa+44|0;k[q>>2]=qa;k[sa+52>>2]=0;k[qa>>2]=0;if(l|0){qa=l+12|0;k[qa>>2]=(k[qa>>2]|0)+1}if((k[j>>2]|0)<3){qa=k[n+44>>2]|0;j=k[q>>2]|0;k[j>>2]=k[qa>>2];k[j+4>>2]=k[qa+4>>2];j=sa;break}k[t>>2]=0;x1(sa,k[j>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[n+40>>2]|0;o=k[m>>2]|0;m=k[n+44>>2]|0;l=k[q>>2]|0;j=0;do{k[o+(j<<2)>>2]=k[s+(j<<2)>>2];k[l+(j<<2)>>2]=k[m+(j<<2)>>2];j=j+1|0}while((j|0)<(k[t>>2]|0));j=sa}else j=sa}else{Q1(sa,c,-1);j=sa}while(0);oa=k[ra>>2]|0;m=(oa>>>3&511)+1|0;pa=k[ta>>2]|0;qa=k[j>>2]|0;j=k[ra+12>>2]|0;n=k[ra+8>>2]|0;l=Epb(j|0,((j|0)<0)<<31>>31|0,m|0,0)|0;l=Epb(l|0,N|0,n|0,((n|0)<0)<<31>>31|0)|0;if((oa&16384&pa&qa|0)!=0?(l|0)==(l|0)&(((l|0)<0)<<31>>31|0)==(N|0):0)n=1;else l=aa(j,m)|0;y=ra+16|0;A=ra+44|0;B=ra+48|0;t=ta+16|0;v=ta+44|0;w=ta+48|0;o=sa+16|0;q=sa+44|0;s=sa+48|0;Gh[k[f+(O<<2)>>2]&127](k[y>>2]|0,k[B>>2]|0,k[t>>2]|0,k[w>>2]|0,k[o>>2]|0,k[s>>2]|0,l,n,h);m=sa+36|0;j=k[m>>2]|0;if(j|0?(qa=j+12|0,h=k[qa>>2]|0,k[qa>>2]=h+-1,(h|0)==1):0){l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[sa+32>>2]|0;if(j|0)break;j=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}k[m>>2]=0;m=sa+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[m>>2]|0)>0){l=k[sa+40>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[m>>2]|0))}j=k[q>>2]|0;if(!((j|0)==(s|0)|(j|0)==0))ggb(k[j+-4>>2]|0);m=ta+36|0;j=k[m>>2]|0;if(j|0?(h=j+12|0,sa=k[h>>2]|0,k[h>>2]=sa+-1,(sa|0)==1):0){l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[ta+32>>2]|0;if(j|0)break;j=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}k[m>>2]=0;m=ta+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[m>>2]|0)>0){l=k[ta+40>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[m>>2]|0))}j=k[v>>2]|0;if(!((j|0)==(w|0)|(j|0)==0))ggb(k[j+-4>>2]|0);m=ra+36|0;j=k[m>>2]|0;do if(j|0){sa=j+12|0;ta=k[sa>>2]|0;k[sa>>2]=ta+-1;if((ta|0)!=1)break;l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[ra+32>>2]|0;if(j|0)break;j=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}while(0);k[m>>2]=0;m=ra+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[m>>2]|0)>0){l=k[ra+40>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[m>>2]|0))}j=k[A>>2]|0;if(!((j|0)==(B|0)|(j|0)==0))ggb(k[j+-4>>2]|0);r=ua;return}while(0);do if((w|0)==(y|0)?(s=k[C>>2]|0,t=k[C+4>>2]|0,(I|0)==(F|0)&((s|0)==(k[G>>2]|0)?(t|0)==(k[G+4>>2]|0):0)):0){if((D|0)==131072?(s|0)==1&((t|0)==4|(t|0)==1):0){M=107;break}if((E|0)==131072?(s|0)==1&((t|0)==4|(t|0)==1):0)M=107;else{E=0;U=0;B=H;m=O;_=I;y=J;a=K;A=L}}else M=107;while(0);do if((M|0)==107){a:do if((a2(a)|0)<=2?H2(a)|0:0){R1(ra,a,-1);m=k[ra>>2]|0;n=(m|0)==1;if(!(!n?(k[ra+4>>2]|0)!=1:0))M=111;do if((M|0)==111?!((D|0)!=131072&(E|0)==131072):0){j=k[ra+4>>2]|0;_=(j|0)==1;if(!((m|0)==(F|0)&_|n&(_|(j|0)==(F|0)))){if(!(n&(j|0)==4))break;if(!(F>>>0<5&(S1(a,-1)|0)==6)){M=118;break a}}D=k[C>>2]|0;y=C+4|0;B=k[y>>2]|0;k[C>>2]=k[G>>2];C=G+4|0;k[y>>2]=k[C>>2];k[G>>2]=D;k[C>>2]=B;C=1;B=J;D=o;y=H;a=L;A=K;break a}while(0);M=118}else M=118;while(0);b:do if((M|0)==118){do if((a2(b)|0)<=2?H2(b)|0:0){R1(ra,b,-1);m=k[ra>>2]|0;n=(m|0)==1;if(!(!n?(k[ra+4>>2]|0)!=1:0))M=122;if((M|0)==122?!((D|0)==131072&(E|0)!=131072):0){j=k[ra+4>>2]|0;_=(j|0)==1;if((m|0)==(I|0)&_|n&(_|(j|0)==(I|0))){C=0;B=H;D=O;F=I;y=J;a=K;A=L;break b}if(n&(j|0)==4)if(I>>>0<5&(S1(b,-1)|0)==6){C=0;B=H;D=O;F=I;y=J;a=K;A=L;break b}else break}}while(0);_=ra+4|0;j=ZT(160)|0;k[j>>2]=1;Z=j+4|0;k[ra>>2]=Z;k[_>>2]=153;i[j+157>>0]=0;upb(Z|0,208999,153)|0;Y8(-209,ra,209153,208690,639);k[_>>2]=0;k[ra>>2]=0;_=k[j>>2]|0;k[j>>2]=_+-1;if((_|0)==1)ggb(k[j+-4>>2]|0);C=0;B=H;D=O;F=I;y=J;a=K;A=L}while(0);if((y|0)==6)switch(k[G+4>>2]|0){case 4:case 1:break;default:M=133}else M=133;if((M|0)==133){j=ra+4|0;m=ZT(60)|0;k[m>>2]=1;t=m+4|0;k[ra>>2]=t;k[j>>2]=55;i[m+59>>0]=0;v=209163;w=t+55|0;do{i[t>>0]=i[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Y8(-215,ra,209153,208690,641);k[j>>2]=0;k[ra>>2]=0;_=k[m>>2]|0;k[m>>2]=_+-1;if((_|0)==1)ggb(k[m+-4>>2]|0)}if(g){o=6;E=1;U=C<<24>>24!=0;m=D;_=F;break}j=a;do if((k[j>>2]&2031616|0)==65536){o=k[j+4>>2]|0;k[ra>>2]=k[o>>2];t=ra+4|0;j=o+4|0;k[t>>2]=k[j>>2];_=ra+8|0;k[_>>2]=k[o+8>>2];k[ra+12>>2]=k[o+12>>2];v=ra+16|0;k[v>>2]=k[o+16>>2];k[ra+20>>2]=k[o+20>>2];k[ra+24>>2]=k[o+24>>2];k[ra+28>>2]=k[o+28>>2];k[ra+32>>2]=k[o+32>>2];m=k[o+36>>2]|0;k[ra+36>>2]=m;n=ra+40|0;k[n>>2]=_;_=ra+48|0;w=ra+44|0;k[w>>2]=_;k[ra+52>>2]=0;k[_>>2]=0;if(m|0){_=m+12|0;k[_>>2]=(k[_>>2]|0)+1}if((k[j>>2]|0)<3){Z=k[o+44>>2]|0;_=k[w>>2]|0;k[_>>2]=k[Z>>2];k[_+4>>2]=k[Z+4>>2];break}k[t>>2]=0;x1(ra,k[j>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[o+40>>2]|0;q=k[n>>2]|0;m=k[o+44>>2]|0;n=k[w>>2]|0;j=0;do{k[q+(j<<2)>>2]=k[s+(j<<2)>>2];k[n+(j<<2)>>2]=k[m+(j<<2)>>2];j=j+1|0}while((j|0)<(k[t>>2]|0))}}else{Q1(ra,j,-1);v=ra+16|0;w=ra+44|0}while(0);n=k[v>>2]|0;m=0;o=-2147483648;q=2147483647;while(1){z=+p[n+(m<<3)>>3];p[u>>3]=z;j=k[u+4>>2]|0;_=j&2146435072;if(!(_>>>0>1126170624|(_|0)==1126170624&0>0)){j=(j|0)<0;x=j?z+-4503599627370496.0+4503599627370496.0:z+4503599627370496.0+-4503599627370496.0;if(x==0.0)x=j?-0.0:0.0}else x=z;j=~~x;if(+(j|0)!=z){M=156;break}q=(q|0)>(j|0)?j:q;o=(o|0)<(j|0)?j:o;m=m+1|0;if((m|0)>=(F|0)){M=152;break}}if((M|0)==152){j=(q|0)>-1;if(!(j&(o|0)<256))if(!((q|0)>-129&(o|0)<128))if(j&(o|0)<65536)o=2;else o=(q|0)>-32769&(o|0)<32768?3:4;else o=1;else o=0}else if((M|0)==156)o=D>>>0<4|(D|0)==5?5:6;n=ra+36|0;j=k[n>>2]|0;if(j|0?(Z=j+12|0,_=k[Z>>2]|0,k[Z>>2]=_+-1,(_|0)==1):0){m=k[n>>2]|0;if(m|0){j=k[m+4>>2]|0;if(!j){j=k[ra+32>>2]|0;if(!j){j=B1()|0;m=k[n>>2]|0}}jh[k[(k[j>>2]|0)+24>>2]&1023](j,m)}k[n>>2]=0}k[n>>2]=0;n=ra+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[n>>2]|0)>0){m=k[ra+40>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[n>>2]|0))}j=k[w>>2]|0;if(!((j|0)==(ra+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);E=1;U=C<<24>>24!=0;m=D;_=F}while(0);do if((e|0)<0){if((k[c>>2]|0)<0){s=S1(c,-1)|0;break}if((B|0)==(y|0)|E)s=B;else{Z=ra+4|0;j=ZT(144)|0;k[j>>2]=1;Y=j+4|0;k[ra>>2]=Y;k[Z>>2]=136;i[j+140>>0]=0;upb(Y|0,209219,136)|0;Y8(-5,ra,209153,208690,663);k[Z>>2]=0;k[ra>>2]=0;Z=k[j>>2]|0;k[j>>2]=Z+-1;if((Z|0)==1)ggb(k[j+-4>>2]|0);s=B}}else s=e;while(0);q=s&7;do if(!((m|0)==(o|0)&(q|0)==(m|0))){if(g){j=(o|0)<5?5:o;j=(m|0)<(j|0)?j:m;j=(j|0)<(q|0)?q:j;break}if(!((m|0)<2&(o|0)<2))if((m|0)<5&(o|0)<5)j=4;else j=(m|0)<(o|0)?o:m;else j=3;j=(j|0)<(q|0)?q:j;if(q>>>0<5)j=(m|0)<5|(o|0)<5?4:j}else j=o;while(0);o=(_<<3)+-8|0;n=q|o;C=j&7;D=C|o;Z=P<<24>>24!=0;do if(Z){if(!((S1(d,-1)|0|1|0)==1?(l=A,E2(d,l)|0):0)){l=ra+4|0;m=ZT(72)|0;k[m>>2]=1;t=m+4|0;k[ra>>2]=t;k[l>>2]=64;i[m+68>>0]=0;v=209356;w=t+64|0;do{i[t>>0]=i[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Y8(-215,ra,209153,208690,695);k[l>>2]=0;k[ra>>2]=0;Y=k[m>>2]|0;k[m>>2]=Y+-1;if((Y|0)==1)ggb(k[m+-4>>2]|0);l=A}if(E2(c,l)|0){Y=(S1(c,-1)|0)==(n|0);K2(c,l,n);if(Y)break}else K2(c,l,n);p[ta>>3]=0.0;k[ra>>2]=-1056833530;k[ra+4>>2]=ta;k[ra+8>>2]=1;k[ra+12>>2]=1;k[sa>>2]=0;k[sa+4>>2]=0;k[sa+8>>2]=0;k[sa+12>>2]=0;N2(c,ra,sa)}else K2(c,A,n);while(0);if((B|0)==(D|0))Y=0;else Y=k[40320+(C<<5)+((B&7)<<2)>>2]|0;if((y|0)!=(B|0))if((y|0)==(D|0))T=0;else T=k[40320+(C<<5)+((y&7)<<2)>>2]|0;else T=Y;if((n|0)==(D|0))X=0;else X=k[40320+(q<<5)+(C<<2)>>2]|0;W=(B>>>3&511)+1<<(47696>>>(B<<1&14)&3);S=(y>>>3&511)+1<<(47696>>>(y<<1&14)&3);w=(o>>>3&511)+1|0;l=w<<(47696>>>(s<<1&14)&3);k[ra>>2]=l;w=w<<(47696>>>(j<<1&14)&3);v=((w+1023|0)>>>0)/(w>>>0)|0;if(l>>>0<33){V=k[40936+(l<<2)>>2]|0;V=(V|0)==0?140:V}else V=140;j=A;do if((k[j>>2]&2031616|0)==65536){n=k[j+4>>2]|0;k[ta>>2]=k[n>>2];t=ta+4|0;j=n+4|0;k[t>>2]=k[j>>2];R=ta+8|0;k[R>>2]=k[n+8>>2];k[ta+12>>2]=k[n+12>>2];k[ta+16>>2]=k[n+16>>2];k[ta+20>>2]=k[n+20>>2];k[ta+24>>2]=k[n+24>>2];k[ta+28>>2]=k[n+28>>2];k[ta+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[ta+36>>2]=l;m=ta+40|0;k[m>>2]=R;R=ta+48|0;q=ta+44|0;k[q>>2]=R;k[ta+52>>2]=0;k[R>>2]=0;if(l|0){R=l+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[j>>2]|0)<3){Q=k[n+44>>2]|0;R=k[q>>2]|0;k[R>>2]=k[Q>>2];k[R+4>>2]=k[Q+4>>2];break}k[t>>2]=0;x1(ta,k[j>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[n+40>>2]|0;o=k[m>>2]|0;m=k[n+44>>2]|0;l=k[q>>2]|0;j=0;do{k[o+(j<<2)>>2]=k[s+(j<<2)>>2];k[l+(j<<2)>>2]=k[m+(j<<2)>>2];j=j+1|0}while((j|0)<(k[t>>2]|0))}}else Q1(ta,j,-1);while(0);j=a;do if((k[j>>2]&2031616|0)==65536){n=k[j+4>>2]|0;k[sa>>2]=k[n>>2];t=sa+4|0;j=n+4|0;k[t>>2]=k[j>>2];R=sa+8|0;k[R>>2]=k[n+8>>2];k[sa+12>>2]=k[n+12>>2];k[sa+16>>2]=k[n+16>>2];k[sa+20>>2]=k[n+20>>2];k[sa+24>>2]=k[n+24>>2];k[sa+28>>2]=k[n+28>>2];k[sa+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[sa+36>>2]=l;m=sa+40|0;k[m>>2]=R;R=sa+48|0;q=sa+44|0;k[q>>2]=R;k[sa+52>>2]=0;k[R>>2]=0;if(l|0){R=l+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[j>>2]|0)<3){Q=k[n+44>>2]|0;R=k[q>>2]|0;k[R>>2]=k[Q>>2];k[R+4>>2]=k[Q+4>>2];break}k[t>>2]=0;x1(sa,k[j>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[n+40>>2]|0;o=k[m>>2]|0;m=k[n+44>>2]|0;l=k[q>>2]|0;j=0;do{k[o+(j<<2)>>2]=k[s+(j<<2)>>2];k[l+(j<<2)>>2]=k[m+(j<<2)>>2];j=j+1|0}while((j|0)<(k[t>>2]|0))}}else Q1(sa,j,-1);while(0);do if((k[c>>2]&2031616|0)==65536){n=k[c+4>>2]|0;k[qa>>2]=k[n>>2];t=qa+4|0;j=n+4|0;k[t>>2]=k[j>>2];R=qa+8|0;k[R>>2]=k[n+8>>2];k[qa+12>>2]=k[n+12>>2];k[qa+16>>2]=k[n+16>>2];k[qa+20>>2]=k[n+20>>2];k[qa+24>>2]=k[n+24>>2];k[qa+28>>2]=k[n+28>>2];k[qa+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[qa+36>>2]=l;m=qa+40|0;k[m>>2]=R;R=qa+48|0;q=qa+44|0;k[q>>2]=R;k[qa+52>>2]=0;k[R>>2]=0;if(l|0){R=l+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[j>>2]|0)<3){Q=k[n+44>>2]|0;R=k[q>>2]|0;k[R>>2]=k[Q>>2];k[R+4>>2]=k[Q+4>>2];break}k[t>>2]=0;x1(qa,k[j>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[n+40>>2]|0;o=k[m>>2]|0;m=k[n+44>>2]|0;l=k[q>>2]|0;j=0;do{k[o+(j<<2)>>2]=k[s+(j<<2)>>2];k[l+(j<<2)>>2]=k[m+(j<<2)>>2];j=j+1|0}while((j|0)<(k[t>>2]|0))}}else Q1(qa,c,-1);while(0);do if((k[d>>2]&2031616|0)==65536){o=k[d+4>>2]|0;k[pa>>2]=k[o>>2];t=pa+4|0;l=o+4|0;k[t>>2]=k[l>>2];R=pa+8|0;k[R>>2]=k[o+8>>2];k[pa+12>>2]=k[o+12>>2];k[pa+16>>2]=k[o+16>>2];k[pa+20>>2]=k[o+20>>2];k[pa+24>>2]=k[o+24>>2];k[pa+28>>2]=k[o+28>>2];k[pa+32>>2]=k[o+32>>2];j=k[o+36>>2]|0;k[pa+36>>2]=j;m=pa+40|0;k[m>>2]=R;R=pa+48|0;q=pa+44|0;k[q>>2]=R;k[pa+52>>2]=0;k[R>>2]=0;if(j|0){R=j+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[l>>2]|0)<3){Q=k[o+44>>2]|0;R=k[q>>2]|0;k[R>>2]=k[Q>>2];k[R+4>>2]=k[Q+4>>2];break}k[t>>2]=0;x1(pa,k[l>>2]|0,0,0,0);if((k[t>>2]|0)<=0)break;s=k[o+40>>2]|0;n=k[m>>2]|0;m=k[o+44>>2]|0;l=k[q>>2]|0;j=0;do{k[n+(j<<2)>>2]=k[s+(j<<2)>>2];k[l+(j<<2)>>2]=k[m+(j<<2)>>2];j=j+1|0}while((j|0)<(k[t>>2]|0))}else Q1(pa,d,-1);while(0);Q=oa+8|0;k[oa>>2]=Q;R=oa+4|0;k[R>>2]=1032;d=(Y|0)!=0;m=(T|0)!=0;c=(X|0)!=0;j=(E|m?w:0)+(d?w:0)+(c?w:0)+(Z?k[ra>>2]|0:0)|0;P=k[f+(C<<2)>>2]|0;if(E){k[$>>2]=ta;k[$+4>>2]=qa;k[$+8>>2]=pa;k[$+12>>2]=0;k[na>>2]=0;k[na+4>>2]=0;k[na+8>>2]=0;k[na+12>>2]=0;k[na+16>>2]=0;k[na+20>>2]=0;k[na+24>>2]=0;k[na+28>>2]=0;z1(na,$,0,ma,-1);K=k[na+20>>2]|0;J=v>>>0<K>>>0?v:K;l=(aa(J,j)|0)+64|0;do if((k[R>>2]|0)>>>0<l>>>0){j=k[oa>>2]|0;if((j|0)!=(Q|0)){if(j|0)ggb(j);k[oa>>2]=Q;k[R>>2]=1032}if(l>>>0<=1032){j=Q;break}while(1){j=fgb(l)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}k[oa>>2]=j;k[R>>2]=l}else{k[R>>2]=l;j=k[oa>>2]|0}while(0);I=aa(J,w)|0;t=d?j+I+15&-16:j;H=d?j:0;b=t+I+15&-16;I=Z&c?b+I+15&-16:b;_T(sa,D,t,J);q=na+16|0;s=(K|0)==0;v=ma+4|0;w=ba+4|0;y=H;G=Z|c;A=ea+4|0;B=ma+8|0;a=fa+4|0;C=da+4|0;D=ca+4|0;n=0;while(1){if(n>>>0>=(k[q>>2]|0)>>>0)break;if(!s){m=0;j=k[ma>>2]|0;F=k[v>>2]|0;do{o=K-m|0;o=o>>>0>J>>>0?J:o;E=aa(o,_)|0;if(d){k[ba>>2]=E;k[w>>2]=1;sh[Y&255](j,1,0,1,H,1,ba,0);j=y}l=U?t:j;j=U?j:t;do if(G){Gh[P&127](l,1,j,1,b,1,E,1,h);if(!Z){k[ca>>2]=E;k[D>>2]=1;sh[X&255](b,1,0,1,F,1,ca,0);break}if(c){k[ea>>2]=E;k[A>>2]=1;sh[X&255](b,1,0,1,I,1,ea,0);f=k[B>>2]|0;k[fa>>2]=o;k[a>>2]=1;sh[V&255](I,1,f,1,F,1,fa,ra);k[B>>2]=(k[B>>2]|0)+o;break}else{f=k[B>>2]|0;k[da>>2]=o;k[C>>2]=1;sh[V&255](b,1,f,1,F,1,da,ra);k[B>>2]=(k[B>>2]|0)+o;break}}else Gh[P&127](l,1,j,1,F,1,E,1,h);while(0);j=aa(o,W)|0;j=(k[ma>>2]|0)+j|0;k[ma>>2]=j;F=aa(k[ra>>2]|0,o)|0;F=(k[v>>2]|0)+F|0;k[v>>2]=F;m=m+J|0}while(K>>>0>m>>>0)}A1(na);n=n+1|0}}else{k[$>>2]=ta;k[$+4>>2]=sa;k[$+8>>2]=qa;k[$+12>>2]=pa;k[$+16>>2]=0;k[na>>2]=0;k[na+4>>2]=0;k[na+8>>2]=0;k[na+12>>2]=0;k[na+16>>2]=0;k[na+20>>2]=0;k[na+24>>2]=0;k[na+28>>2]=0;z1(na,$,0,ma,-1);g=k[na+20>>2]|0;e=(Z|d|m|c)&v>>>0<g>>>0?v:g;l=(aa(e,j)|0)+64|0;do if((k[R>>2]|0)>>>0<l>>>0){j=k[oa>>2]|0;if((j|0)!=(Q|0)){if(j|0)ggb(j);k[oa>>2]=Q;k[R>>2]=1032}if(l>>>0<=1032){j=Q;break}while(1){j=fgb(l)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}k[oa>>2]=j;k[R>>2]=l}else{k[R>>2]=l;j=k[oa>>2]|0}while(0);b=aa(e,w)|0;G=d?j+b+15&-16:j;H=d?j:0;I=m?G+b+15&-16:G;G=m?G:0;b=Z&c?I+b+15&-16:I;J=na+16|0;K=(g|0)==0;L=ma+4|0;M=ma+8|0;O=ga+4|0;v=m^1;F=Z|c;w=ka+4|0;y=ma+12|0;A=la+4|0;B=ja+4|0;a=ia+4|0;C=ha+4|0;s=0;while(1){if(s>>>0>=(k[J>>2]|0)>>>0)break;if(!K){q=0;l=k[ma>>2]|0;n=k[L>>2]|0;E=k[M>>2]|0;do{t=g-q|0;t=t>>>0>e>>>0?e:t;D=aa(t,_)|0;if(d){k[ga>>2]=D;k[O>>2]=1;sh[Y&255](l,1,0,1,H,1,ga,0);o=j;l=k[ma>>2]|0;m=k[L>>2]|0}else{o=l;m=n}l=(l|0)==(m|0);if(l|v)l=l?o:n;else{k[ha>>2]=D;k[C>>2]=1;sh[T&255](n,1,0,1,G,1,ha,0);l=G}do if(F){Gh[P&127](o,1,l,1,I,0,D,1,h);if(!Z){k[ia>>2]=D;k[a>>2]=1;sh[X&255](I,1,0,1,E,1,ia,0);break}if(c){k[ka>>2]=D;k[w>>2]=1;sh[X&255](I,1,0,1,b,1,ka,0);f=k[y>>2]|0;k[la>>2]=t;k[A>>2]=1;sh[V&255](b,1,f,1,E,1,la,ra);k[y>>2]=(k[y>>2]|0)+t;break}else{f=k[y>>2]|0;k[ja>>2]=t;k[B>>2]=1;sh[V&255](I,1,f,1,E,1,ja,ra);k[y>>2]=(k[y>>2]|0)+t;break}}else Gh[P&127](o,1,l,1,E,1,D,1,h);while(0);l=aa(t,W)|0;l=(k[ma>>2]|0)+l|0;k[ma>>2]=l;n=aa(t,S)|0;n=(k[L>>2]|0)+n|0;k[L>>2]=n;E=aa(k[ra>>2]|0,t)|0;E=(k[M>>2]|0)+E|0;k[M>>2]=E;q=q+e|0}while(g>>>0>q>>>0)}A1(na);s=s+1|0}}j=k[oa>>2]|0;if((j|0)!=(Q|0)){if(j|0)ggb(j);k[oa>>2]=Q;k[R>>2]=1032}m=pa+36|0;j=k[m>>2]|0;do if(j|0){h=j+12|0;ra=k[h>>2]|0;k[h>>2]=ra+-1;if((ra|0)!=1)break;l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[pa+32>>2]|0;if(j|0)break;j=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}while(0);k[m>>2]=0;ra=pa+16|0;l=pa+4|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[l>>2]|0)>0){m=k[pa+40>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[pa+44>>2]|0;if(!((j|0)==(pa+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);m=qa+36|0;j=k[m>>2]|0;do if(j|0){h=j+12|0;ra=k[h>>2]|0;k[h>>2]=ra+-1;if((ra|0)!=1)break;l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[qa+32>>2]|0;if(j|0)break;j=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}while(0);k[m>>2]=0;ra=qa+16|0;l=qa+4|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[l>>2]|0)>0){m=k[qa+40>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[qa+44>>2]|0;if(!((j|0)==(qa+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);m=sa+36|0;j=k[m>>2]|0;do if(j|0){h=j+12|0;ra=k[h>>2]|0;k[h>>2]=ra+-1;if((ra|0)!=1)break;l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[sa+32>>2]|0;if(j|0)break;j=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}while(0);k[m>>2]=0;ra=sa+16|0;l=sa+4|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[l>>2]|0)>0){m=k[sa+40>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[sa+44>>2]|0;if(!((j|0)==(sa+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);m=ta+36|0;j=k[m>>2]|0;do if(j|0){ra=j+12|0;sa=k[ra>>2]|0;k[ra>>2]=sa+-1;if((sa|0)!=1)break;l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[ta+32>>2]|0;if(j|0)break;j=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}while(0);k[m>>2]=0;sa=ta+16|0;l=ta+4|0;k[sa>>2]=0;k[sa+4>>2]=0;k[sa+8>>2]=0;k[sa+12>>2]=0;if((k[l>>2]|0)>0){m=k[ta+40>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[ta+44>>2]|0;if(!((j|0)==(ta+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);r=ua;return}function tU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0;k=h+-1|0;if(!h)return;m=g+-4|0;if((g|0)<4){m=(g|0)>0;h=a;while(1){if(m){j=0;do{i[e+j>>0]=i[352559+((l[h+j>>0]|0|256)+(l[c+j>>0]|0))>>0]|0;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}n=g&-4;o=(n|0)<(g|0);h=a;while(1){j=0;do{q=j|1;a=i[352559+((l[h+q>>0]|0|256)+(l[c+q>>0]|0))>>0]|0;i[e+j>>0]=i[352559+((l[h+j>>0]|0|256)+(l[c+j>>0]|0))>>0]|0;i[e+q>>0]=a;q=j|2;a=j|3;p=i[352559+((l[h+a>>0]|0|256)+(l[c+a>>0]|0))>>0]|0;i[e+q>>0]=i[352559+((l[h+q>>0]|0|256)+(l[c+q>>0]|0))>>0]|0;i[e+a>>0]=p;j=j+4|0}while((j|0)<=(m|0));if(o){j=n;do{i[e+j>>0]=i[352559+((l[h+j>>0]|0|256)+(l[c+j>>0]|0))>>0]|0;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function uU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){j=0;do{a=(i[c+j>>0]|0)+(i[h+j>>0]|0)|0;i[e+j>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){j=0;do{a=(i[c+j>>0]|0)+(i[h+j>>0]|0)|0;p=j|1;q=(i[c+p>>0]|0)+(i[h+p>>0]|0)|0;i[e+j>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;i[e+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;p=j|2;q=(i[c+p>>0]|0)+(i[h+p>>0]|0)|0;a=j|3;o=(i[c+a>>0]|0)+(i[h+a>>0]|0)|0;i[e+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;i[e+a>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;j=j+4|0}while((j|0)<=(l|0));if(n){j=m;do{q=(i[c+j>>0]|0)+(i[h+j>>0]|0)|0;i[e+j>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function vU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,n=0,o=0,p=0,q=0,r=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{a=(m[c+(i<<1)>>1]|0)+(m[h+(i<<1)>>1]|0)|0;j[e+(i<<1)>>1]=a>>>0<65536?a:a|0?65535:0;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}n=g&-4;o=(n|0)<(g|0);h=a;while(1){i=0;do{a=(m[c+(i<<1)>>1]|0)+(m[h+(i<<1)>>1]|0)|0;q=i|1;r=(m[c+(q<<1)>>1]|0)+(m[h+(q<<1)>>1]|0)|0;j[e+(i<<1)>>1]=a>>>0<65536?a:a|0?65535:0;j[e+(q<<1)>>1]=r>>>0<65536?r:r|0?65535:0;q=i|2;r=(m[c+(q<<1)>>1]|0)+(m[h+(q<<1)>>1]|0)|0;a=i|3;p=(m[c+(a<<1)>>1]|0)+(m[h+(a<<1)>>1]|0)|0;j[e+(q<<1)>>1]=r>>>0<65536?r:r|0?65535:0;j[e+(a<<1)>>1]=p>>>0<65536?p:p|0?65535:0;i=i+4|0}while((i|0)<=(l|0));if(o){i=n;do{r=(m[c+(i<<1)>>1]|0)+(m[h+(i<<1)>>1]|0)|0;j[e+(i<<1)>>1]=r>>>0<65536?r:r|0?65535:0;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function wU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{a=(j[c+(i<<1)>>1]|0)+(j[h+(i<<1)>>1]|0)|0;j[e+(i<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){i=0;do{a=(j[c+(i<<1)>>1]|0)+(j[h+(i<<1)>>1]|0)|0;p=i|1;q=(j[c+(p<<1)>>1]|0)+(j[h+(p<<1)>>1]|0)|0;j[e+(i<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;j[e+(p<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;p=i|2;q=(j[c+(p<<1)>>1]|0)+(j[h+(p<<1)>>1]|0)|0;a=i|3;o=(j[c+(a<<1)>>1]|0)+(j[h+(a<<1)>>1]|0)|0;j[e+(p<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;j[e+(a<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;i=i+4|0}while((i|0)<=(l|0));if(n){i=m;do{q=(j[c+(i<<1)>>1]|0)+(j[h+(i<<1)>>1]|0)|0;j[e+(i<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function xU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0,n=0,o=0,p=0;j=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{k[e+(i<<2)>>2]=(k[c+(i<<2)>>2]|0)+(k[h+(i<<2)>>2]|0);i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){i=0;do{p=i|1;a=(k[c+(p<<2)>>2]|0)+(k[h+(p<<2)>>2]|0)|0;k[e+(i<<2)>>2]=(k[c+(i<<2)>>2]|0)+(k[h+(i<<2)>>2]|0);k[e+(p<<2)>>2]=a;p=i|2;a=i|3;o=(k[c+(a<<2)>>2]|0)+(k[h+(a<<2)>>2]|0)|0;k[e+(p<<2)>>2]=(k[c+(p<<2)>>2]|0)+(k[h+(p<<2)>>2]|0);k[e+(a<<2)>>2]=o;i=i+4|0}while((i|0)<=(l|0));if(n){i=m;do{k[e+(i<<2)>>2]=(k[c+(i<<2)>>2]|0)+(k[h+(i<<2)>>2]|0);i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function yU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0.0,p=0;j=h+-1|0;if(!h)return;k=g+-4|0;if((g|0)<4){k=(g|0)>0;h=a;while(1){if(k){i=0;do{o[e+(i<<2)>>2]=+o[h+(i<<2)>>2]+ +o[c+(i<<2)>>2];i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}l=g&-4;m=(l|0)<(g|0);h=a;while(1){i=0;do{p=i|1;n=+o[h+(p<<2)>>2]+ +o[c+(p<<2)>>2];o[e+(i<<2)>>2]=+o[h+(i<<2)>>2]+ +o[c+(i<<2)>>2];o[e+(p<<2)>>2]=n;p=i|2;a=i|3;n=+o[h+(a<<2)>>2]+ +o[c+(a<<2)>>2];o[e+(p<<2)>>2]=+o[h+(p<<2)>>2]+ +o[c+(p<<2)>>2];o[e+(a<<2)>>2]=n;i=i+4|0}while((i|0)<=(k|0));if(m){i=l;do{o[e+(i<<2)>>2]=+o[h+(i<<2)>>2]+ +o[c+(i<<2)>>2];i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function zU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0.0,o=0;j=h+-1|0;if(!h)return;k=g+-4|0;if((g|0)<4){k=(g|0)>0;h=a;while(1){if(k){i=0;do{p[e+(i<<3)>>3]=+p[h+(i<<3)>>3]+ +p[c+(i<<3)>>3];i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}l=g&-4;m=(l|0)<(g|0);h=a;while(1){i=0;do{o=i|1;n=+p[h+(o<<3)>>3]+ +p[c+(o<<3)>>3];p[e+(i<<3)>>3]=+p[h+(i<<3)>>3]+ +p[c+(i<<3)>>3];p[e+(o<<3)>>3]=n;o=i|2;a=i|3;n=+p[h+(a<<3)>>3]+ +p[c+(a<<3)>>3];p[e+(o<<3)>>3]=+p[h+(o<<3)>>3]+ +p[c+(o<<3)>>3];p[e+(a<<3)>>3]=n;i=i+4|0}while((i|0)<=(k|0));if(m){i=l;do{p[e+(i<<3)>>3]=+p[h+(i<<3)>>3]+ +p[c+(i<<3)>>3];i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function AU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0;k=h+-1|0;if(!h)return;m=g+-4|0;if((g|0)<4){m=(g|0)>0;h=a;while(1){if(m){j=0;do{i[e+j>>0]=i[352559+((l[h+j>>0]|0|256)-(l[c+j>>0]|0))>>0]|0;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}n=g&-4;o=(n|0)<(g|0);h=a;while(1){j=0;do{q=j|1;a=i[352559+((l[h+q>>0]|0|256)-(l[c+q>>0]|0))>>0]|0;i[e+j>>0]=i[352559+((l[h+j>>0]|0|256)-(l[c+j>>0]|0))>>0]|0;i[e+q>>0]=a;q=j|2;a=j|3;p=i[352559+((l[h+a>>0]|0|256)-(l[c+a>>0]|0))>>0]|0;i[e+q>>0]=i[352559+((l[h+q>>0]|0|256)-(l[c+q>>0]|0))>>0]|0;i[e+a>>0]=p;j=j+4|0}while((j|0)<=(m|0));if(o){j=n;do{i[e+j>>0]=i[352559+((l[h+j>>0]|0|256)-(l[c+j>>0]|0))>>0]|0;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function BU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){j=0;do{a=(i[h+j>>0]|0)-(i[c+j>>0]|0)|0;i[e+j>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){j=0;do{a=(i[h+j>>0]|0)-(i[c+j>>0]|0)|0;p=j|1;q=(i[h+p>>0]|0)-(i[c+p>>0]|0)|0;i[e+j>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;i[e+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;p=j|2;q=(i[h+p>>0]|0)-(i[c+p>>0]|0)|0;a=j|3;o=(i[h+a>>0]|0)-(i[c+a>>0]|0)|0;i[e+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;i[e+a>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;j=j+4|0}while((j|0)<=(l|0));if(n){j=m;do{q=(i[h+j>>0]|0)-(i[c+j>>0]|0)|0;i[e+j>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function CU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,n=0,o=0,p=0,q=0,r=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{a=(m[h+(i<<1)>>1]|0)-(m[c+(i<<1)>>1]|0)|0;j[e+(i<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}n=g&-4;o=(n|0)<(g|0);h=a;while(1){i=0;do{a=(m[h+(i<<1)>>1]|0)-(m[c+(i<<1)>>1]|0)|0;q=i|1;r=(m[h+(q<<1)>>1]|0)-(m[c+(q<<1)>>1]|0)|0;j[e+(i<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;j[e+(q<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;q=i|2;r=(m[h+(q<<1)>>1]|0)-(m[c+(q<<1)>>1]|0)|0;a=i|3;p=(m[h+(a<<1)>>1]|0)-(m[c+(a<<1)>>1]|0)|0;j[e+(q<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;j[e+(a<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;i=i+4|0}while((i|0)<=(l|0));if(o){i=n;do{r=(m[h+(i<<1)>>1]|0)-(m[c+(i<<1)>>1]|0)|0;j[e+(i<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function DU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{a=(j[h+(i<<1)>>1]|0)-(j[c+(i<<1)>>1]|0)|0;j[e+(i<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){i=0;do{a=(j[h+(i<<1)>>1]|0)-(j[c+(i<<1)>>1]|0)|0;p=i|1;q=(j[h+(p<<1)>>1]|0)-(j[c+(p<<1)>>1]|0)|0;j[e+(i<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;j[e+(p<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;p=i|2;q=(j[h+(p<<1)>>1]|0)-(j[c+(p<<1)>>1]|0)|0;a=i|3;o=(j[h+(a<<1)>>1]|0)-(j[c+(a<<1)>>1]|0)|0;j[e+(p<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;j[e+(a<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;i=i+4|0}while((i|0)<=(l|0));if(n){i=m;do{q=(j[h+(i<<1)>>1]|0)-(j[c+(i<<1)>>1]|0)|0;j[e+(i<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function EU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0,n=0,o=0,p=0;j=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{k[e+(i<<2)>>2]=(k[h+(i<<2)>>2]|0)-(k[c+(i<<2)>>2]|0);i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){i=0;do{p=i|1;a=(k[h+(p<<2)>>2]|0)-(k[c+(p<<2)>>2]|0)|0;k[e+(i<<2)>>2]=(k[h+(i<<2)>>2]|0)-(k[c+(i<<2)>>2]|0);k[e+(p<<2)>>2]=a;p=i|2;a=i|3;o=(k[h+(a<<2)>>2]|0)-(k[c+(a<<2)>>2]|0)|0;k[e+(p<<2)>>2]=(k[h+(p<<2)>>2]|0)-(k[c+(p<<2)>>2]|0);k[e+(a<<2)>>2]=o;i=i+4|0}while((i|0)<=(l|0));if(n){i=m;do{k[e+(i<<2)>>2]=(k[h+(i<<2)>>2]|0)-(k[c+(i<<2)>>2]|0);i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function FU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0.0,p=0;j=h+-1|0;if(!h)return;k=g+-4|0;if((g|0)<4){k=(g|0)>0;h=a;while(1){if(k){i=0;do{o[e+(i<<2)>>2]=+o[h+(i<<2)>>2]-+o[c+(i<<2)>>2];i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}l=g&-4;m=(l|0)<(g|0);h=a;while(1){i=0;do{p=i|1;n=+o[h+(p<<2)>>2]-+o[c+(p<<2)>>2];o[e+(i<<2)>>2]=+o[h+(i<<2)>>2]-+o[c+(i<<2)>>2];o[e+(p<<2)>>2]=n;p=i|2;a=i|3;n=+o[h+(a<<2)>>2]-+o[c+(a<<2)>>2];o[e+(p<<2)>>2]=+o[h+(p<<2)>>2]-+o[c+(p<<2)>>2];o[e+(a<<2)>>2]=n;i=i+4|0}while((i|0)<=(k|0));if(m){i=l;do{o[e+(i<<2)>>2]=+o[h+(i<<2)>>2]-+o[c+(i<<2)>>2];i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function GU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0.0,o=0;j=h+-1|0;if(!h)return;k=g+-4|0;if((g|0)<4){k=(g|0)>0;h=a;while(1){if(k){i=0;do{p[e+(i<<3)>>3]=+p[h+(i<<3)>>3]-+p[c+(i<<3)>>3];i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}l=g&-4;m=(l|0)<(g|0);h=a;while(1){i=0;do{o=i|1;n=+p[h+(o<<3)>>3]-+p[c+(o<<3)>>3];p[e+(i<<3)>>3]=+p[h+(i<<3)>>3]-+p[c+(i<<3)>>3];p[e+(o<<3)>>3]=n;o=i|2;a=i|3;n=+p[h+(a<<3)>>3]-+p[c+(a<<3)>>3];p[e+(o<<3)>>3]=+p[h+(o<<3)>>3]-+p[c+(o<<3)>>3];p[e+(a<<3)>>3]=n;i=i+4|0}while((i|0)<=(k|0));if(m){i=l;do{p[e+(i<<3)>>3]=+p[h+(i<<3)>>3]-+p[c+(i<<3)>>3];i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function HU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){j=0;do{o=i[h+j>>0]|0;m=i[c+j>>0]|0;a=o&255;n=m&255;i[e+j>>0]=(o&255)>(m&255)?a-n|0:n-a|0;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){j=0;do{a=i[h+j>>0]|0;q=i[c+j>>0]|0;o=a&255;r=q&255;s=j|1;u=i[h+s>>0]|0;t=i[c+s>>0]|0;w=u&255;v=t&255;i[e+j>>0]=(a&255)>(q&255)?o-r|0:r-o|0;i[e+s>>0]=(u&255)>(t&255)?w-v|0:v-w|0;s=j|2;w=i[h+s>>0]|0;v=i[c+s>>0]|0;t=w&255;u=v&255;o=j|3;r=i[h+o>>0]|0;q=i[c+o>>0]|0;a=r&255;p=q&255;i[e+s>>0]=(w&255)>(v&255)?t-u|0:u-t|0;i[e+o>>0]=(r&255)>(q&255)?a-p|0:p-a|0;j=j+4|0}while((j|0)<=(l|0));if(n){j=m;do{t=i[h+j>>0]|0;u=i[c+j>>0]|0;w=t&255;v=u&255;i[e+j>>0]=(t&255)>(u&255)?w-v|0:v-w|0;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function IU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){j=0;do{a=(i[h+j>>0]|0)-(i[c+j>>0]|0)|0;a=(a|0)>-1?a:0-a|0;i[e+j>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){j=0;do{a=(i[h+j>>0]|0)-(i[c+j>>0]|0)|0;a=(a|0)>-1?a:0-a|0;p=j|1;q=(i[h+p>>0]|0)-(i[c+p>>0]|0)|0;q=(q|0)>-1?q:0-q|0;i[e+j>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;i[e+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;p=j|2;q=(i[h+p>>0]|0)-(i[c+p>>0]|0)|0;q=(q|0)>-1?q:0-q|0;a=j|3;o=(i[h+a>>0]|0)-(i[c+a>>0]|0)|0;o=(o|0)>-1?o:0-o|0;i[e+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;i[e+a>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;j=j+4|0}while((j|0)<=(l|0));if(n){j=m;do{q=(i[h+j>>0]|0)-(i[c+j>>0]|0)|0;q=(q|0)>-1?q:0-q|0;i[e+j>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;j=j+1|0}while((j|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function JU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{o=j[h+(i<<1)>>1]|0;m=j[c+(i<<1)>>1]|0;a=o&65535;n=m&65535;j[e+(i<<1)>>1]=(o&65535)>(m&65535)?a-n|0:n-a|0;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){i=0;do{a=j[h+(i<<1)>>1]|0;q=j[c+(i<<1)>>1]|0;o=a&65535;r=q&65535;s=i|1;u=j[h+(s<<1)>>1]|0;t=j[c+(s<<1)>>1]|0;w=u&65535;v=t&65535;j[e+(i<<1)>>1]=(a&65535)>(q&65535)?o-r|0:r-o|0;j[e+(s<<1)>>1]=(u&65535)>(t&65535)?w-v|0:v-w|0;s=i|2;w=j[h+(s<<1)>>1]|0;v=j[c+(s<<1)>>1]|0;t=w&65535;u=v&65535;o=i|3;r=j[h+(o<<1)>>1]|0;q=j[c+(o<<1)>>1]|0;a=r&65535;p=q&65535;j[e+(s<<1)>>1]=(w&65535)>(v&65535)?t-u|0:u-t|0;j[e+(o<<1)>>1]=(r&65535)>(q&65535)?a-p|0:p-a|0;i=i+4|0}while((i|0)<=(l|0));if(n){i=m;do{t=j[h+(i<<1)>>1]|0;u=j[c+(i<<1)>>1]|0;w=t&65535;v=u&65535;j[e+(i<<1)>>1]=(t&65535)>(u&65535)?w-v|0:v-w|0;i=i+1|0}while((i|0)!=(g|0))}if(!k)break;else{c=c+d|0;e=e+f|0;h=h+b|0;k=k+-1|0}}return}function KU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!h)return;k=g+-4|0;l=(g|0)<4;m=g&-4;while(1){h=h+-1|0;if(l)i=0;else{i=0;do{n=(j[a+(i<<1)>>1]|0)-(j[c+(i<<1)>>1]|0)|0;n=(n|0)>-1?n:0-n|0;p=i|1;q=(j[a+(p<<1)>>1]|0)-(j[c+(p<<1)>>1]|0)|0;q=(q|0)>-1?q:0-q|0;j[e+(i<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;j[e+(p<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;p=i|2;q=(j[a+(p<<1)>>1]|0)-(j[c+(p<<1)>>1]|0)|0;q=(q|0)>-1?q:0-q|0;n=i|3;o=(j[a+(n<<1)>>1]|0)-(j[c+(n<<1)>>1]|0)|0;o=(o|0)>-1?o:0-o|0;j[e+(p<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;j[e+(n<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;i=i+4|0}while((i|0)<=(k|0));i=m}if((i|0)<(g|0))do{q=(j[a+(i<<1)>>1]|0)-(j[c+(i<<1)>>1]|0)|0;q=(q|0)>-1?q:0-q|0;j[e+(i<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;i=i+1|0}while((i|0)!=(g|0));if(!h)break;else{c=c+d|0;e=e+f|0;a=a+b|0}}return}function LU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=h+-1|0;if(!h)return;l=g+-4|0;if((g|0)<4){l=(g|0)>0;h=a;while(1){if(l){i=0;do{a=k[h+(i<<2)>>2]|0;n=k[c+(i<<2)>>2]|0;k[e+(i<<2)>>2]=(a|0)>(n|0)?a-n|0:n-a|0;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}m=g&-4;n=(m|0)<(g|0);h=a;while(1){i=0;do{a=k[h+(i<<2)>>2]|0;o=k[c+(i<<2)>>2]|0;q=i|1;r=k[h+(q<<2)>>2]|0;s=k[c+(q<<2)>>2]|0;k[e+(i<<2)>>2]=(a|0)>(o|0)?a-o|0:o-a|0;k[e+(q<<2)>>2]=(r|0)>(s|0)?r-s|0:s-r|0;q=i|2;r=k[h+(q<<2)>>2]|0;s=k[c+(q<<2)>>2]|0;a=i|3;o=k[h+(a<<2)>>2]|0;p=k[c+(a<<2)>>2]|0;k[e+(q<<2)>>2]=(r|0)>(s|0)?r-s|0:s-r|0;k[e+(a<<2)>>2]=(o|0)>(p|0)?o-p|0:p-o|0;i=i+4|0}while((i|0)<=(l|0));if(n){i=m;do{s=k[h+(i<<2)>>2]|0;r=k[c+(i<<2)>>2]|0;k[e+(i<<2)>>2]=(s|0)>(r|0)?s-r|0:r-s|0;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function MU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0.0,p=0.0,q=0,r=0.0,s=0.0;j=h+-1|0;if(!h)return;k=g+-4|0;if((g|0)<4){k=(g|0)>0;h=a;while(1){if(k){i=0;do{n=+o[h+(i<<2)>>2];p=+o[c+(i<<2)>>2];o[e+(i<<2)>>2]=n>p?n-p:p-n;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}l=g&-4;m=(l|0)<(g|0);h=a;while(1){i=0;do{p=+o[h+(i<<2)>>2];n=+o[c+(i<<2)>>2];q=i|1;r=+o[h+(q<<2)>>2];s=+o[c+(q<<2)>>2];o[e+(i<<2)>>2]=p>n?p-n:n-p;o[e+(q<<2)>>2]=r>s?r-s:s-r;q=i|2;r=+o[h+(q<<2)>>2];s=+o[c+(q<<2)>>2];a=i|3;p=+o[h+(a<<2)>>2];n=+o[c+(a<<2)>>2];o[e+(q<<2)>>2]=r>s?r-s:s-r;o[e+(a<<2)>>2]=p>n?p-n:n-p;i=i+4|0}while((i|0)<=(k|0));if(m){i=l;do{s=+o[h+(i<<2)>>2];r=+o[c+(i<<2)>>2];o[e+(i<<2)>>2]=s>r?s-r:r-s;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function NU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0;j=h+-1|0;if(!h)return;k=g+-4|0;if((g|0)<4){k=(g|0)>0;h=a;while(1){if(k){i=0;do{n=+p[h+(i<<3)>>3];o=+p[c+(i<<3)>>3];p[e+(i<<3)>>3]=n>o?n-o:o-n;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}l=g&-4;m=(l|0)<(g|0);h=a;while(1){i=0;do{o=+p[h+(i<<3)>>3];n=+p[c+(i<<3)>>3];q=i|1;r=+p[h+(q<<3)>>3];s=+p[c+(q<<3)>>3];p[e+(i<<3)>>3]=o>n?o-n:n-o;p[e+(q<<3)>>3]=r>s?r-s:s-r;q=i|2;r=+p[h+(q<<3)>>3];s=+p[c+(q<<3)>>3];a=i|3;o=+p[h+(a<<3)>>3];n=+p[c+(a<<3)>>3];p[e+(q<<3)>>3]=r>s?r-s:s-r;p[e+(a<<3)>>3]=o>n?o-n:n-o;i=i+4|0}while((i|0)<=(k|0));if(m){i=l;do{s=+p[h+(i<<3)>>3];r=+p[c+(i<<3)>>3];p[e+(i<<3)>>3]=s>r?s-r:r-s;i=i+1|0}while((i|0)!=(g|0))}if(!j)break;else{c=c+d|0;e=e+f|0;h=h+b|0;j=j+-1|0}}return}function OU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var m=0,n=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0;x=+p[j>>3];m=h+-1|0;j=(h|0)==0;if(x==1.0){if(j)return;q=g+-4|0;if((g|0)<4){if((g|0)>0)h=c;else return;while(1){j=0;do{w=aa(l[h+j>>0]|0,l[a+j>>0]|0)|0;i[e+j>>0]=w>>>0<256?w:w|0?255:0;j=j+1|0}while((j|0)!=(g|0));if(!m)break;else{h=h+d|0;e=e+f|0;a=a+b|0;m=m+-1|0}}return}r=g&-4;s=(r|0)<(g|0);h=c;while(1){j=0;do{w=aa(l[h+j>>0]|0,l[a+j>>0]|0)|0;t=j|1;c=aa(l[h+t>>0]|0,l[a+t>>0]|0)|0;i[e+j>>0]=w>>>0<256?w:w|0?255:0;i[e+t>>0]=c>>>0<256?c:c|0?255:0;t=j|2;c=aa(l[h+t>>0]|0,l[a+t>>0]|0)|0;w=j|3;v=aa(l[h+w>>0]|0,l[a+w>>0]|0)|0;i[e+t>>0]=c>>>0<256?c:c|0?255:0;i[e+w>>0]=v>>>0<256?v:v|0?255:0;j=j+4|0}while((j|0)<=(q|0));if(s){j=r;do{w=aa(l[h+j>>0]|0,l[a+j>>0]|0)|0;i[e+j>>0]=w>>>0<256?w:w|0?255:0;j=j+1|0}while((j|0)!=(g|0))}if(!m)break;else{h=h+d|0;e=e+f|0;a=a+b|0;m=m+-1|0}}return}if(j)return;t=g+-4|0;if((g|0)<4){if((g|0)>0)q=c;else return;while(1){h=0;do{n=x*+(l[a+h>>0]|0)*+(l[q+h>>0]|0);j=(o[u>>2]=n,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;n=j?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=j?-0.0:0.0}w=~~n;i[e+h>>0]=w>>>0<256?w:(w|0)>0?255:0;h=h+1|0}while((h|0)!=(g|0));if(!m)break;else{q=q+d|0;e=e+f|0;a=a+b|0;m=m+-1|0}}return}v=g&-4;w=(v|0)<(g|0);while(1){s=0;do{n=x*+(l[a+s>>0]|0)*+(l[c+s>>0]|0);j=(o[u>>2]=n,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;n=j?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=j?-0.0:0.0}h=~~n;h=(h>>>0<256?h:(h|0)>0?255:0)&255;q=s|1;n=x*+(l[a+q>>0]|0)*+(l[c+q>>0]|0);j=(o[u>>2]=n,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;n=j?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=j?-0.0:0.0}r=~~n;i[e+s>>0]=h;i[e+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=s|2;n=x*+(l[a+r>>0]|0)*+(l[c+r>>0]|0);j=(o[u>>2]=n,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;n=j?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=j?-0.0:0.0}h=~~n;h=(h>>>0<256?h:(h|0)>0?255:0)&255;q=s|3;n=x*+(l[a+q>>0]|0)*+(l[c+q>>0]|0);j=(o[u>>2]=n,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;n=j?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=j?-0.0:0.0}j=~~n;i[e+r>>0]=h;i[e+q>>0]=j>>>0<256?j:(j|0)>0?255:0;s=s+4|0}while((s|0)<=(t|0));if(w){h=v;do{n=x*+(l[a+h>>0]|0)*+(l[c+h>>0]|0);j=(o[u>>2]=n,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;n=j?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=j?-0.0:0.0}s=~~n;i[e+h>>0]=s>>>0<256?s:(s|0)>0?255:0;h=h+1|0}while((h|0)!=(g|0))}if(!m)break;else{c=c+d|0;e=e+f|0;a=a+b|0;m=m+-1|0}}return}function PU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0.0,n=0,q=0,r=0,s=0,t=0,v=0,w=0.0;w=+p[j>>3];l=h+-1|0;j=(h|0)==0;if(w==1.0){if(j)return;q=g+-4|0;if((g|0)<4){if((g|0)>0)h=c;else return;while(1){j=0;do{v=aa(i[h+j>>0]|0,i[a+j>>0]|0)|0;i[e+j>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;j=j+1|0}while((j|0)!=(g|0));if(!l)break;else{h=h+d|0;e=e+f|0;a=a+b|0;l=l+-1|0}}return}n=g&-4;if((n|0)<(g|0))h=c;else{h=c;while(1){j=0;do{g=aa(i[h+j>>0]|0,i[a+j>>0]|0)|0;t=j|1;s=aa(i[h+t>>0]|0,i[a+t>>0]|0)|0;i[e+j>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;i[e+t>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;t=j|2;s=aa(i[h+t>>0]|0,i[a+t>>0]|0)|0;g=j|3;v=aa(i[h+g>>0]|0,i[a+g>>0]|0)|0;i[e+t>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;i[e+g>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;j=j+4|0}while((j|0)<=(q|0));if(!l)break;else{h=h+d|0;e=e+f|0;a=a+b|0;l=l+-1|0}}return}while(1){j=0;do{v=aa(i[h+j>>0]|0,i[a+j>>0]|0)|0;s=j|1;r=aa(i[h+s>>0]|0,i[a+s>>0]|0)|0;i[e+j>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;i[e+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;s=j|2;r=aa(i[h+s>>0]|0,i[a+s>>0]|0)|0;v=j|3;t=aa(i[h+v>>0]|0,i[a+v>>0]|0)|0;i[e+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;i[e+v>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;j=j+4|0}while((j|0)<=(q|0));j=n;do{v=aa(i[h+j>>0]|0,i[a+j>>0]|0)|0;i[e+j>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;j=j+1|0}while((j|0)!=(g|0));if(!l)break;else{h=h+d|0;e=e+f|0;a=a+b|0;l=l+-1|0}}return}if(j)return;s=g+-4|0;if((g|0)<4){if((g|0)<=0)return;while(1){h=0;do{m=w*+(i[a+h>>0]|0)*+(i[c+h>>0]|0);j=(o[u>>2]=m,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;m=j?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=j?-0.0:0.0}v=~~m;i[e+h>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;h=h+1|0}while((h|0)!=(g|0));if(!l)break;else{c=c+d|0;e=e+f|0;a=a+b|0;l=l+-1|0}}return}t=g&-4;v=(t|0)<(g|0);while(1){r=0;do{m=w*+(i[a+r>>0]|0)*+(i[c+r>>0]|0);j=(o[u>>2]=m,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;m=j?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=j?-0.0:0.0}h=~~m;h=((h+128|0)>>>0<256?h:(h|0)>0?127:128)&255;n=r|1;m=w*+(i[a+n>>0]|0)*+(i[c+n>>0]|0);j=(o[u>>2]=m,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;m=j?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=j?-0.0:0.0}q=~~m;i[e+r>>0]=h;i[e+n>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;q=r|2;m=w*+(i[a+q>>0]|0)*+(i[c+q>>0]|0);j=(o[u>>2]=m,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;m=j?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=j?-0.0:0.0}h=~~m;h=((h+128|0)>>>0<256?h:(h|0)>0?127:128)&255;n=r|3;m=w*+(i[a+n>>0]|0)*+(i[c+n>>0]|0);j=(o[u>>2]=m,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;m=j?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=j?-0.0:0.0}j=~~m;i[e+q>>0]=h;i[e+n>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;r=r+4|0}while((r|0)<=(s|0));if(v){h=t;do{m=w*+(i[a+h>>0]|0)*+(i[c+h>>0]|0);j=(o[u>>2]=m,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;m=j?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=j?-0.0:0.0}r=~~m;i[e+h>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;h=h+1|0}while((h|0)!=(g|0))}if(!l)break;else{c=c+d|0;e=e+f|0;a=a+b|0;l=l+-1|0}}return}function QU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var l=0.0,n=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0;t=+p[i>>3];x=b>>>1;w=d>>>1;v=f>>>1;b=h+-1|0;i=(h|0)==0;if(t==1.0){if(i)return;f=g+-4|0;if((g|0)<4){if((g|0)>0)d=c;else return;while(1){i=0;do{s=aa(m[d+(i<<1)>>1]|0,m[a+(i<<1)>>1]|0)|0;j[e+(i<<1)>>1]=s>>>0<65536?s:s|0?65535:0;i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{d=d+(w<<1)|0;e=e+(v<<1)|0;a=a+(x<<1)|0;b=b+-1|0}}return}h=g&-4;n=(h|0)<(g|0);d=c;while(1){i=0;do{s=aa(m[d+(i<<1)>>1]|0,m[a+(i<<1)>>1]|0)|0;q=i|1;c=aa(m[d+(q<<1)>>1]|0,m[a+(q<<1)>>1]|0)|0;j[e+(i<<1)>>1]=s>>>0<65536?s:s|0?65535:0;j[e+(q<<1)>>1]=c>>>0<65536?c:c|0?65535:0;q=i|2;c=aa(m[d+(q<<1)>>1]|0,m[a+(q<<1)>>1]|0)|0;s=i|3;r=aa(m[d+(s<<1)>>1]|0,m[a+(s<<1)>>1]|0)|0;j[e+(q<<1)>>1]=c>>>0<65536?c:c|0?65535:0;j[e+(s<<1)>>1]=r>>>0<65536?r:r|0?65535:0;i=i+4|0}while((i|0)<=(f|0));if(n){i=h;do{s=aa(m[d+(i<<1)>>1]|0,m[a+(i<<1)>>1]|0)|0;j[e+(i<<1)>>1]=s>>>0<65536?s:s|0?65535:0;i=i+1|0}while((i|0)!=(g|0))}if(!b)break;else{d=d+(w<<1)|0;e=e+(v<<1)|0;a=a+(x<<1)|0;b=b+-1|0}}return}if(i)return;q=g+-4|0;r=(g|0)<4;s=g&-4;while(1){if(r)i=0;else{n=0;do{l=t*+(m[a+(n<<1)>>1]|0)*+(m[c+(n<<1)>>1]|0);i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}d=~~l;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;f=n|1;l=t*+(m[a+(f<<1)>>1]|0)*+(m[c+(f<<1)>>1]|0);i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}h=~~l;j[e+(n<<1)>>1]=d;j[e+(f<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;h=n|2;l=t*+(m[a+(h<<1)>>1]|0)*+(m[c+(h<<1)>>1]|0);i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}d=~~l;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;f=n|3;l=t*+(m[a+(f<<1)>>1]|0)*+(m[c+(f<<1)>>1]|0);i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}i=~~l;j[e+(h<<1)>>1]=d;j[e+(f<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;n=n+4|0}while((n|0)<=(q|0));i=s}if((i|0)<(g|0))do{l=t*+(m[a+(i<<1)>>1]|0)*+(m[c+(i<<1)>>1]|0);d=(o[u>>2]=l,k[u>>2]|0);if((d&2130706432)>>>0<=1249902592){d=(d|0)<0;l=d?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=d?-0.0:0.0}n=~~l;j[e+(i<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{c=c+(w<<1)|0;e=e+(v<<1)|0;a=a+(x<<1)|0;b=b+-1|0}}return}function RU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var l=0.0,m=0,n=0,q=0,r=0,s=0.0,t=0,v=0,w=0;s=+p[i>>3];w=b>>>1;v=d>>>1;t=f>>>1;b=h+-1|0;i=(h|0)==0;if(s==1.0){if(i)return;f=g+-4|0;if((g|0)<4){if((g|0)>0)d=c;else return;while(1){i=0;do{r=aa(j[d+(i<<1)>>1]|0,j[a+(i<<1)>>1]|0)|0;j[e+(i<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{d=d+(v<<1)|0;e=e+(t<<1)|0;a=a+(w<<1)|0;b=b+-1|0}}return}h=g&-4;m=(h|0)<(g|0);d=c;while(1){i=0;do{r=aa(j[d+(i<<1)>>1]|0,j[a+(i<<1)>>1]|0)|0;n=i|1;c=aa(j[d+(n<<1)>>1]|0,j[a+(n<<1)>>1]|0)|0;j[e+(i<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;j[e+(n<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;n=i|2;c=aa(j[d+(n<<1)>>1]|0,j[a+(n<<1)>>1]|0)|0;r=i|3;q=aa(j[d+(r<<1)>>1]|0,j[a+(r<<1)>>1]|0)|0;j[e+(n<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;j[e+(r<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;i=i+4|0}while((i|0)<=(f|0));if(m){i=h;do{r=aa(j[d+(i<<1)>>1]|0,j[a+(i<<1)>>1]|0)|0;j[e+(i<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;i=i+1|0}while((i|0)!=(g|0))}if(!b)break;else{d=d+(v<<1)|0;e=e+(t<<1)|0;a=a+(w<<1)|0;b=b+-1|0}}return}if(i)return;n=g+-4|0;q=(g|0)<4;r=g&-4;while(1){if(q)i=0;else{m=0;do{l=s*+(j[a+(m<<1)>>1]|0)*+(j[c+(m<<1)>>1]|0);i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}d=~~l;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;f=m|1;l=s*+(j[a+(f<<1)>>1]|0)*+(j[c+(f<<1)>>1]|0);i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}h=~~l;j[e+(m<<1)>>1]=d;j[e+(f<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;h=m|2;l=s*+(j[a+(h<<1)>>1]|0)*+(j[c+(h<<1)>>1]|0);i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}d=~~l;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;f=m|3;l=s*+(j[a+(f<<1)>>1]|0)*+(j[c+(f<<1)>>1]|0);i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}i=~~l;j[e+(h<<1)>>1]=d;j[e+(f<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;m=m+4|0}while((m|0)<=(n|0));i=r}if((i|0)<(g|0))do{l=s*+(j[a+(i<<1)>>1]|0)*+(j[c+(i<<1)>>1]|0);d=(o[u>>2]=l,k[u>>2]|0);if((d&2130706432)>>>0<=1249902592){d=(d|0)<0;l=d?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=d?-0.0:0.0}m=~~l;j[e+(i<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{c=c+(v<<1)|0;e=e+(t<<1)|0;a=a+(w<<1)|0;b=b+-1|0}}return}function SU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,l=0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0,v=0;q=+p[i>>3];t=b>>>2;s=d>>>2;r=f>>>2;b=h+-1|0;i=(h|0)==0;if(q==1.0){if(i)return;h=g+-4|0;if((g|0)<4){if((g|0)>0)d=c;else return;while(1){i=0;do{o=aa(k[d+(i<<2)>>2]|0,k[a+(i<<2)>>2]|0)|0;k[e+(i<<2)>>2]=o;i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{d=d+(s<<2)|0;e=e+(r<<2)|0;a=a+(t<<2)|0;b=b+-1|0}}return}f=g&-4;if((f|0)<(g|0))d=c;else{d=c;while(1){i=0;do{g=aa(k[d+(i<<2)>>2]|0,k[a+(i<<2)>>2]|0)|0;n=i|1;m=aa(k[d+(n<<2)>>2]|0,k[a+(n<<2)>>2]|0)|0;k[e+(i<<2)>>2]=g;k[e+(n<<2)>>2]=m;n=i|2;m=aa(k[d+(n<<2)>>2]|0,k[a+(n<<2)>>2]|0)|0;g=i|3;o=aa(k[d+(g<<2)>>2]|0,k[a+(g<<2)>>2]|0)|0;k[e+(n<<2)>>2]=m;k[e+(g<<2)>>2]=o;i=i+4|0}while((i|0)<=(h|0));if(!b)break;else{d=d+(s<<2)|0;e=e+(r<<2)|0;a=a+(t<<2)|0;b=b+-1|0}}return}while(1){i=0;do{o=aa(k[d+(i<<2)>>2]|0,k[a+(i<<2)>>2]|0)|0;m=i|1;l=aa(k[d+(m<<2)>>2]|0,k[a+(m<<2)>>2]|0)|0;k[e+(i<<2)>>2]=o;k[e+(m<<2)>>2]=l;m=i|2;l=aa(k[d+(m<<2)>>2]|0,k[a+(m<<2)>>2]|0)|0;o=i|3;n=aa(k[d+(o<<2)>>2]|0,k[a+(o<<2)>>2]|0)|0;k[e+(m<<2)>>2]=l;k[e+(o<<2)>>2]=n;i=i+4|0}while((i|0)<=(h|0));i=f;do{o=aa(k[d+(i<<2)>>2]|0,k[a+(i<<2)>>2]|0)|0;k[e+(i<<2)>>2]=o;i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{d=d+(s<<2)|0;e=e+(r<<2)|0;a=a+(t<<2)|0;b=b+-1|0}}return}if(i)return;m=g+-4|0;if((g|0)<4){if((g|0)>0)f=c;else return;while(1){d=0;do{j=q*+(k[a+(d<<2)>>2]|0)*+(k[f+(d<<2)>>2]|0);p[u>>3]=j;i=k[u+4>>2]|0;o=i&2146435072;if(!(o>>>0>1126170624|(o|0)==1126170624&0>0)){i=(i|0)<0;j=i?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=i?-0.0:0.0}k[e+(d<<2)>>2]=~~j;d=d+1|0}while((d|0)!=(g|0));if(!b)break;else{f=f+(s<<2)|0;e=e+(r<<2)|0;a=a+(t<<2)|0;b=b+-1|0}}return}n=g&-4;o=(n|0)<(g|0);while(1){l=0;do{j=q*+(k[a+(l<<2)>>2]|0)*+(k[c+(l<<2)>>2]|0);p[u>>3]=j;i=k[u+4>>2]|0;h=i&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){i=(i|0)<0;j=i?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=i?-0.0:0.0}d=~~j;f=l|1;j=q*+(k[a+(f<<2)>>2]|0)*+(k[c+(f<<2)>>2]|0);p[u>>3]=j;i=k[u+4>>2]|0;h=i&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){i=(i|0)<0;j=i?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=i?-0.0:0.0}k[e+(l<<2)>>2]=d;k[e+(f<<2)>>2]=~~j;h=l|2;j=q*+(k[a+(h<<2)>>2]|0)*+(k[c+(h<<2)>>2]|0);p[u>>3]=j;i=k[u+4>>2]|0;f=i&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){i=(i|0)<0;j=i?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=i?-0.0:0.0}d=~~j;f=l|3;j=q*+(k[a+(f<<2)>>2]|0)*+(k[c+(f<<2)>>2]|0);p[u>>3]=j;i=k[u+4>>2]|0;v=i&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){i=(i|0)<0;j=i?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=i?-0.0:0.0}k[e+(h<<2)>>2]=d;k[e+(f<<2)>>2]=~~j;l=l+4|0}while((l|0)<=(m|0));if(o){d=n;do{j=q*+(k[a+(d<<2)>>2]|0)*+(k[c+(d<<2)>>2]|0);p[u>>3]=j;i=k[u+4>>2]|0;v=i&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){i=(i|0)<0;j=i?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=i?-0.0:0.0}k[e+(d<<2)>>2]=~~j;d=d+1|0}while((d|0)!=(g|0))}if(!b)break;else{c=c+(s<<2)|0;e=e+(r<<2)|0;a=a+(t<<2)|0;b=b+-1|0}}return}function TU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0.0,l=0,m=0,n=0,q=0.0,r=0;k=+p[i>>3];n=b>>>2;m=d>>>2;l=f>>>2;b=h+-1|0;i=(h|0)==0;if(!(k==1.0)){if(i)return;f=g+-4|0;if((g|0)<4){if((g|0)>0)d=c;else return;while(1){i=0;do{o[e+(i<<2)>>2]=k*+o[a+(i<<2)>>2]*+o[d+(i<<2)>>2];i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{d=d+(m<<2)|0;e=e+(l<<2)|0;a=a+(n<<2)|0;b=b+-1|0}}return}h=g&-4;j=(h|0)<(g|0);d=c;while(1){i=0;do{r=i|1;q=k*+o[a+(r<<2)>>2]*+o[d+(r<<2)>>2];o[e+(i<<2)>>2]=k*+o[a+(i<<2)>>2]*+o[d+(i<<2)>>2];o[e+(r<<2)>>2]=q;r=i|2;c=i|3;q=k*+o[a+(c<<2)>>2]*+o[d+(c<<2)>>2];o[e+(r<<2)>>2]=k*+o[a+(r<<2)>>2]*+o[d+(r<<2)>>2];o[e+(c<<2)>>2]=q;i=i+4|0}while((i|0)<=(f|0));if(j){i=h;do{o[e+(i<<2)>>2]=k*+o[a+(i<<2)>>2]*+o[d+(i<<2)>>2];i=i+1|0}while((i|0)!=(g|0))}if(!b)break;else{d=d+(m<<2)|0;e=e+(l<<2)|0;a=a+(n<<2)|0;b=b+-1|0}}return}if(i)return;h=g+-4|0;if((g|0)<4){if((g|0)>0)d=c;else return;while(1){i=0;do{o[e+(i<<2)>>2]=+o[a+(i<<2)>>2]*+o[d+(i<<2)>>2];i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{d=d+(m<<2)|0;e=e+(l<<2)|0;a=a+(n<<2)|0;b=b+-1|0}}return}f=g&-4;if((f|0)<(g|0))d=c;else{d=c;while(1){i=0;do{g=i|1;q=+o[a+(g<<2)>>2]*+o[d+(g<<2)>>2];o[e+(i<<2)>>2]=+o[a+(i<<2)>>2]*+o[d+(i<<2)>>2];o[e+(g<<2)>>2]=q;g=i|2;r=i|3;q=+o[a+(r<<2)>>2]*+o[d+(r<<2)>>2];o[e+(g<<2)>>2]=+o[a+(g<<2)>>2]*+o[d+(g<<2)>>2];o[e+(r<<2)>>2]=q;i=i+4|0}while((i|0)<=(h|0));if(!b)break;else{d=d+(m<<2)|0;e=e+(l<<2)|0;a=a+(n<<2)|0;b=b+-1|0}}return}while(1){i=0;do{c=i|1;q=+o[a+(c<<2)>>2]*+o[d+(c<<2)>>2];o[e+(i<<2)>>2]=+o[a+(i<<2)>>2]*+o[d+(i<<2)>>2];o[e+(c<<2)>>2]=q;c=i|2;r=i|3;q=+o[a+(r<<2)>>2]*+o[d+(r<<2)>>2];o[e+(c<<2)>>2]=+o[a+(c<<2)>>2]*+o[d+(c<<2)>>2];o[e+(r<<2)>>2]=q;i=i+4|0}while((i|0)<=(h|0));i=f;do{o[e+(i<<2)>>2]=+o[a+(i<<2)>>2]*+o[d+(i<<2)>>2];i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{d=d+(m<<2)|0;e=e+(l<<2)|0;a=a+(n<<2)|0;b=b+-1|0}}return}function UU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0.0,l=0,m=0,n=0,o=0.0,q=0;k=+p[i>>3];n=b>>>3;m=d>>>3;l=f>>>3;b=h+-1|0;i=(h|0)==0;if(!(k==1.0)){if(i)return;f=g+-4|0;if((g|0)<4){if((g|0)>0)d=c;else return;while(1){i=0;do{p[e+(i<<3)>>3]=k*+p[a+(i<<3)>>3]*+p[d+(i<<3)>>3];i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{d=d+(m<<3)|0;e=e+(l<<3)|0;a=a+(n<<3)|0;b=b+-1|0}}return}h=g&-4;j=(h|0)<(g|0);d=c;while(1){i=0;do{q=i|1;o=k*+p[a+(q<<3)>>3]*+p[d+(q<<3)>>3];p[e+(i<<3)>>3]=k*+p[a+(i<<3)>>3]*+p[d+(i<<3)>>3];p[e+(q<<3)>>3]=o;q=i|2;c=i|3;o=k*+p[a+(c<<3)>>3]*+p[d+(c<<3)>>3];p[e+(q<<3)>>3]=k*+p[a+(q<<3)>>3]*+p[d+(q<<3)>>3];p[e+(c<<3)>>3]=o;i=i+4|0}while((i|0)<=(f|0));if(j){i=h;do{p[e+(i<<3)>>3]=k*+p[a+(i<<3)>>3]*+p[d+(i<<3)>>3];i=i+1|0}while((i|0)!=(g|0))}if(!b)break;else{d=d+(m<<3)|0;e=e+(l<<3)|0;a=a+(n<<3)|0;b=b+-1|0}}return}if(i)return;h=g+-4|0;if((g|0)<4){if((g|0)>0)d=c;else return;while(1){i=0;do{p[e+(i<<3)>>3]=+p[a+(i<<3)>>3]*+p[d+(i<<3)>>3];i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{d=d+(m<<3)|0;e=e+(l<<3)|0;a=a+(n<<3)|0;b=b+-1|0}}return}f=g&-4;if((f|0)<(g|0))d=c;else{d=c;while(1){i=0;do{g=i|1;o=+p[a+(g<<3)>>3]*+p[d+(g<<3)>>3];p[e+(i<<3)>>3]=+p[a+(i<<3)>>3]*+p[d+(i<<3)>>3];p[e+(g<<3)>>3]=o;g=i|2;q=i|3;o=+p[a+(q<<3)>>3]*+p[d+(q<<3)>>3];p[e+(g<<3)>>3]=+p[a+(g<<3)>>3]*+p[d+(g<<3)>>3];p[e+(q<<3)>>3]=o;i=i+4|0}while((i|0)<=(h|0));if(!b)break;else{d=d+(m<<3)|0;e=e+(l<<3)|0;a=a+(n<<3)|0;b=b+-1|0}}return}while(1){i=0;do{c=i|1;o=+p[a+(c<<3)>>3]*+p[d+(c<<3)>>3];p[e+(i<<3)>>3]=+p[a+(i<<3)>>3]*+p[d+(i<<3)>>3];p[e+(c<<3)>>3]=o;c=i|2;q=i|3;o=+p[a+(q<<3)>>3]*+p[d+(q<<3)>>3];p[e+(c<<3)>>3]=+p[a+(c<<3)>>3]*+p[d+(c<<3)>>3];p[e+(q<<3)>>3]=o;i=i+4|0}while((i|0)<=(h|0));i=f;do{p[e+(i<<3)>>3]=+p[a+(i<<3)>>3]*+p[d+(i<<3)>>3];i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{d=d+(m<<3)|0;e=e+(l<<3)|0;a=a+(n<<3)|0;b=b+-1|0}}return}function VU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var m=0.0,n=0,q=0.0;q=+p[j>>3];j=(g|0)>0&(h|0)!=0;if(!a){if(!j)return;while(1){a=0;do{j=i[c+a>>0]|0;if(!(j<<24>>24))j=0;else{m=q/+(j&255);j=(o[u>>2]=m,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;m=j?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=j?-0.0:0.0}j=~~m;j=(j>>>0<256?j:(j|0)>0?255:0)&255}i[e+a>>0]=j;a=a+1|0}while((a|0)!=(g|0));h=h+-1|0;if(!h)break;else{e=e+f|0;c=c+d|0}}return}else{if(!j)return;while(1){n=0;do{j=i[c+n>>0]|0;if(!(j<<24>>24))j=0;else{m=q*+(l[a+n>>0]|0)/+(j&255);j=(o[u>>2]=m,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;m=j?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=j?-0.0:0.0}j=~~m;j=(j>>>0<256?j:(j|0)>0?255:0)&255}i[e+n>>0]=j;n=n+1|0}while((n|0)!=(g|0));h=h+-1|0;if(!h)break;else{c=c+d|0;e=e+f|0;a=a+b|0}}return}}function WU(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0.0,m=0,n=0.0;n=+p[j>>3];if(!((g|0)>0&(h|0)!=0))return;while(1){m=0;do{j=i[c+m>>0]|0;if(!(j<<24>>24))j=0;else{l=n*+(i[a+m>>0]|0)/+(j<<24>>24);j=(o[u>>2]=l,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;l=j?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=j?-0.0:0.0}j=~~l;j=((j+128|0)>>>0<256?j:(j|0)>0?127:128)&255}i[e+m>>0]=j;m=m+1|0}while((m|0)!=(g|0));h=h+-1|0;if(!h)break;else{c=c+d|0;e=e+f|0;a=a+b|0}}return}function XU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var l=0.0,n=0.0,q=0,r=0;r=b>>>1;q=d>>>1;f=f>>>1;n=+p[i>>3];if(!((g|0)>0&(h|0)!=0))return;while(1){d=0;do{b=j[c+(d<<1)>>1]|0;if(!(b<<16>>16))b=0;else{l=n*+(m[a+(d<<1)>>1]|0)/+(b&65535);b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;b=(b>>>0<65536?b:(b|0)>0?65535:0)&65535}j[e+(d<<1)>>1]=b;d=d+1|0}while((d|0)!=(g|0));h=h+-1|0;if(!h)break;else{c=c+(q<<1)|0;e=e+(f<<1)|0;a=a+(r<<1)|0}}return}function YU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var l=0.0,m=0.0,n=0,q=0;q=b>>>1;n=d>>>1;f=f>>>1;m=+p[i>>3];if(!((g|0)>0&(h|0)!=0))return;while(1){d=0;do{b=j[c+(d<<1)>>1]|0;if(!(b<<16>>16))b=0;else{l=m*+(j[a+(d<<1)>>1]|0)/+(b<<16>>16);b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;b=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535}j[e+(d<<1)>>1]=b;d=d+1|0}while((d|0)!=(g|0));h=h+-1|0;if(!h)break;else{c=c+(n<<1)|0;e=e+(f<<1)|0;a=a+(q<<1)|0}}return}function ZU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,l=0.0,m=0,n=0;n=b>>>2;m=d>>>2;f=f>>>2;l=+p[i>>3];if(!((g|0)>0&(h|0)!=0))return;while(1){d=0;do{b=k[c+(d<<2)>>2]|0;if(!b)b=0;else{j=l*+(k[a+(d<<2)>>2]|0)/+(b|0);b=(o[u>>2]=j,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;j=b?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=b?-0.0:0.0}b=~~j}k[e+(d<<2)>>2]=b;d=d+1|0}while((d|0)!=(g|0));h=h+-1|0;if(!h)break;else{c=c+(m<<2)|0;e=e+(f<<2)|0;a=a+(n<<2)|0}}return}function _U(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0.0;n=+p[i>>3];m=b>>>2;l=d>>>2;k=f>>>2;if((g|0)>0&(h|0)!=0){f=e;d=a;b=h}else return;while(1){i=0;do{j=+o[c+(i<<2)>>2];if(j!=0.0)j=n*+o[d+(i<<2)>>2]/j;else j=0.0;o[f+(i<<2)>>2]=j;i=i+1|0}while((i|0)!=(g|0));b=b+-1|0;if(!b)break;else{c=c+(l<<2)|0;f=f+(k<<2)|0;d=d+(m<<2)|0}}return}function $U(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0.0;n=+p[i>>3];m=b>>>3;l=d>>>3;k=f>>>3;if((g|0)>0&(h|0)!=0){f=e;d=a;b=h}else return;while(1){i=0;do{j=+p[c+(i<<3)>>3];if(j!=0.0)j=n*+p[d+(i<<3)>>3]/j;else j=0.0;p[f+(i<<3)>>3]=j;i=i+1|0}while((i|0)!=(g|0));b=b+-1|0;if(!b)break;else{c=c+(l<<3)|0;f=f+(k<<3)|0;d=d+(m<<3)|0}}return}function aV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0.0,m=0.0;m=+p[j>>3];if(!((g|0)>0&(h|0)!=0))return;while(1){b=0;do{a=i[c+b>>0]|0;if(!(a<<24>>24))a=0;else{l=m/+(a&255);a=(o[u>>2]=l,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;l=a?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;a=(a>>>0<256?a:(a|0)>0?255:0)&255}i[e+b>>0]=a;b=b+1|0}while((b|0)!=(g|0));h=h+-1|0;if(!h)break;else{e=e+f|0;c=c+d|0}}return}function bV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0.0,m=0.0;m=+p[j>>3];if(!((g|0)>0&(h|0)!=0))return;while(1){b=0;do{a=i[c+b>>0]|0;if(!(a<<24>>24))a=0;else{l=m/+(a<<24>>24);a=(o[u>>2]=l,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;l=a?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;a=((a+128|0)>>>0<256?a:(a|0)>0?127:128)&255}i[e+b>>0]=a;b=b+1|0}while((b|0)!=(g|0));h=h+-1|0;if(!h)break;else{e=e+f|0;c=c+d|0}}return}function cV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var l=0.0,m=0.0,n=0;n=d>>>1;d=f>>>1;m=+p[i>>3];if(!((g|0)>0&(h|0)!=0))return;while(1){b=0;do{a=j[c+(b<<1)>>1]|0;if(!(a<<16>>16))a=0;else{l=m/+(a&65535);a=(o[u>>2]=l,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;l=a?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;a=(a>>>0<65536?a:(a|0)>0?65535:0)&65535}j[e+(b<<1)>>1]=a;b=b+1|0}while((b|0)!=(g|0));h=h+-1|0;if(!h)break;else{e=e+(d<<1)|0;c=c+(n<<1)|0}}return}function dV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var l=0.0,m=0.0,n=0;n=d>>>1;d=f>>>1;m=+p[i>>3];if(!((g|0)>0&(h|0)!=0))return;while(1){b=0;do{a=j[c+(b<<1)>>1]|0;if(!(a<<16>>16))a=0;else{l=m/+(a<<16>>16);a=(o[u>>2]=l,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;l=a?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;a=((a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768)&65535}j[e+(b<<1)>>1]=a;b=b+1|0}while((b|0)!=(g|0));h=h+-1|0;if(!h)break;else{e=e+(d<<1)|0;c=c+(n<<1)|0}}return}function eV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,l=0.0,m=0;m=d>>>2;d=f>>>2;l=+p[i>>3];if(!((g|0)>0&(h|0)!=0))return;while(1){b=0;do{a=k[c+(b<<2)>>2]|0;if(!a)a=0;else{j=l/+(a|0);a=(o[u>>2]=j,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;j=a?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=a?-0.0:0.0}a=~~j}k[e+(b<<2)>>2]=a;b=b+1|0}while((b|0)!=(g|0));h=h+-1|0;if(!h)break;else{e=e+(d<<2)|0;c=c+(m<<2)|0}}return}function fV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0;j=+p[i>>3];d=d>>>2;i=f>>>2;if((g|0)>0&(h|0)!=0)b=e;else return;while(1){a=0;do{k=+o[c+(a<<2)>>2];o[b+(a<<2)>>2]=k!=0.0?j/k:0.0;a=a+1|0}while((a|0)!=(g|0));h=h+-1|0;if(!h)break;else{b=b+(i<<2)|0;c=c+(d<<2)|0}}return}function gV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0;j=+p[i>>3];d=d>>>3;i=f>>>3;if((g|0)>0&(h|0)!=0)b=e;else return;while(1){a=0;do{k=+p[c+(a<<3)>>3];p[b+(a<<3)>>3]=k!=0.0?j/k:0.0;a=a+1|0}while((a|0)!=(g|0));h=h+-1|0;if(!h)break;else{b=b+(i<<3)|0;c=c+(d<<3)|0}}return}function hV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var m=0.0,n=0.0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0.0,z=0.0;y=+p[j>>3];z=+p[j+8>>3];t=+p[j+16>>3];if(!h)return;v=g+-4|0;w=(g|0)<4;x=g&-4;s=c;while(1){h=h+-1|0;if(w)j=0;else{r=0;do{n=t+(y*+o[50112+((l[a+r>>0]|0)+128<<2)>>2]+z*+o[50112+((l[s+r>>0]|0)+128<<2)>>2]);c=r|1;m=t+(y*+o[50112+((l[a+c>>0]|0)+128<<2)>>2]+z*+o[50112+((l[s+c>>0]|0)+128<<2)>>2]);j=(o[u>>2]=n,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;n=j?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=j?-0.0:0.0}j=~~n;i[e+r>>0]=j>>>0<256?j:(j|0)>0?255:0;j=(o[u>>2]=m,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;m=j?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=j?-0.0:0.0}q=~~m;i[e+c>>0]=q>>>0<256?q:(q|0)>0?255:0;c=r|2;n=t+(y*+o[50112+((l[a+c>>0]|0)+128<<2)>>2]+z*+o[50112+((l[s+c>>0]|0)+128<<2)>>2]);q=r|3;m=t+(y*+o[50112+((l[a+q>>0]|0)+128<<2)>>2]+z*+o[50112+((l[s+q>>0]|0)+128<<2)>>2]);j=(o[u>>2]=n,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;n=j?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=j?-0.0:0.0}j=~~n;i[e+c>>0]=j>>>0<256?j:(j|0)>0?255:0;j=(o[u>>2]=m,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;m=j?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=j?-0.0:0.0}c=~~m;i[e+q>>0]=c>>>0<256?c:(c|0)>0?255:0;r=r+4|0}while((r|0)<=(v|0));j=x}if((j|0)<(g|0))do{m=t+(y*+o[50112+((l[a+j>>0]|0)+128<<2)>>2]+z*+o[50112+((l[s+j>>0]|0)+128<<2)>>2]);c=(o[u>>2]=m,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;m=c?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=c?-0.0:0.0}r=~~m;i[e+j>>0]=r>>>0<256?r:(r|0)>0?255:0;j=j+1|0}while((j|0)!=(g|0));if(!h)break;else{e=e+f|0;a=a+b|0;s=s+d|0}}return}function iV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0.0,m=0,n=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0.0,y=0.0;x=+p[j>>3];y=+p[j+8>>3];s=+p[j+16>>3];if(!h)return;t=g+-4|0;v=(g|0)<4;w=g&-4;r=h;while(1){r=r+-1|0;if(v)j=0;else{q=0;do{l=s+(x*+(i[a+q>>0]|0)+y*+(i[c+q>>0]|0));j=(o[u>>2]=l,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;l=j?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=j?-0.0:0.0}h=~~l;h=((h+128|0)>>>0<256?h:(h|0)>0?127:128)&255;m=q|1;l=s+(x*+(i[a+m>>0]|0)+y*+(i[c+m>>0]|0));j=(o[u>>2]=l,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;l=j?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=j?-0.0:0.0}n=~~l;i[e+q>>0]=h;i[e+m>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;n=q|2;l=s+(x*+(i[a+n>>0]|0)+y*+(i[c+n>>0]|0));j=(o[u>>2]=l,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;l=j?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=j?-0.0:0.0}h=~~l;h=((h+128|0)>>>0<256?h:(h|0)>0?127:128)&255;m=q|3;l=s+(x*+(i[a+m>>0]|0)+y*+(i[c+m>>0]|0));j=(o[u>>2]=l,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;l=j?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=j?-0.0:0.0}j=~~l;i[e+n>>0]=h;i[e+m>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;q=q+4|0}while((q|0)<=(t|0));j=w}if((j|0)<(g|0))do{l=s+(x*+(i[a+j>>0]|0)+y*+(i[c+j>>0]|0));h=(o[u>>2]=l,k[u>>2]|0);if((h&2130706432)>>>0<=1249902592){h=(h|0)<0;l=h?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=h?-0.0:0.0}q=~~l;i[e+j>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;j=j+1|0}while((j|0)!=(g|0));if(!r)break;else{c=c+d|0;e=e+f|0;a=a+b|0}}return}function jV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var l=0.0,n=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0;y=+p[i>>3];z=+p[i+8>>3];x=+p[i+16>>3];w=b>>>1;v=d>>>1;q=f>>>1;if(!h)return;r=g+-4|0;s=(g|0)<4;t=g&-4;while(1){h=h+-1|0;if(s)i=0;else{n=0;do{l=x+(y*+(m[a+(n<<1)>>1]|0)+z*+(m[c+(n<<1)>>1]|0));i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}b=~~l;b=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;d=n|1;l=x+(y*+(m[a+(d<<1)>>1]|0)+z*+(m[c+(d<<1)>>1]|0));i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}f=~~l;j[e+(n<<1)>>1]=b;j[e+(d<<1)>>1]=f>>>0<65536?f:(f|0)>0?65535:0;f=n|2;l=x+(y*+(m[a+(f<<1)>>1]|0)+z*+(m[c+(f<<1)>>1]|0));i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}b=~~l;b=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;d=n|3;l=x+(y*+(m[a+(d<<1)>>1]|0)+z*+(m[c+(d<<1)>>1]|0));i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}i=~~l;j[e+(f<<1)>>1]=b;j[e+(d<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;n=n+4|0}while((n|0)<=(r|0));i=t}if((i|0)<(g|0))do{l=x+(y*+(m[a+(i<<1)>>1]|0)+z*+(m[c+(i<<1)>>1]|0));b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}n=~~l;j[e+(i<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;i=i+1|0}while((i|0)!=(g|0));if(!h)break;else{c=c+(v<<1)|0;e=e+(q<<1)|0;a=a+(w<<1)|0}}return}function kV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var l=0.0,m=0,n=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0.0;x=+p[i>>3];y=+p[i+8>>3];w=+p[i+16>>3];v=b>>>1;t=d>>>1;n=f>>>1;if(!h)return;q=g+-4|0;r=(g|0)<4;s=g&-4;while(1){h=h+-1|0;if(r)i=0;else{m=0;do{l=w+(x*+(j[a+(m<<1)>>1]|0)+y*+(j[c+(m<<1)>>1]|0));i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}b=~~l;b=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;d=m|1;l=w+(x*+(j[a+(d<<1)>>1]|0)+y*+(j[c+(d<<1)>>1]|0));i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}f=~~l;j[e+(m<<1)>>1]=b;j[e+(d<<1)>>1]=(f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768;f=m|2;l=w+(x*+(j[a+(f<<1)>>1]|0)+y*+(j[c+(f<<1)>>1]|0));i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}b=~~l;b=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;d=m|3;l=w+(x*+(j[a+(d<<1)>>1]|0)+y*+(j[c+(d<<1)>>1]|0));i=(o[u>>2]=l,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;l=i?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=i?-0.0:0.0}i=~~l;j[e+(f<<1)>>1]=b;j[e+(d<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;m=m+4|0}while((m|0)<=(q|0));i=s}if((i|0)<(g|0))do{l=w+(x*+(j[a+(i<<1)>>1]|0)+y*+(j[c+(i<<1)>>1]|0));b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}m=~~l;j[e+(i<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;i=i+1|0}while((i|0)!=(g|0));if(!h)break;else{c=c+(t<<1)|0;e=e+(n<<1)|0;a=a+(v<<1)|0}}return}function lV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0;w=+p[i>>3];v=+p[i+8>>3];t=+p[i+16>>3];s=b>>>2;r=d>>>2;q=f>>>2;d=h+-1|0;if(!h)return;m=g+-4|0;if((g|0)<4){if((g|0)>0){h=e;f=a}else return;while(1){b=0;do{j=t+(w*+(k[f+(b<<2)>>2]|0)+v*+(k[c+(b<<2)>>2]|0));p[u>>3]=j;i=k[u+4>>2]|0;o=i&2146435072;if(!(o>>>0>1126170624|(o|0)==1126170624&0>0)){i=(i|0)<0;j=i?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=i?-0.0:0.0}k[h+(b<<2)>>2]=~~j;b=b+1|0}while((b|0)!=(g|0));if(!d)break;else{c=c+(r<<2)|0;h=h+(q<<2)|0;f=f+(s<<2)|0;d=d+-1|0}}return}n=g&-4;o=(n|0)<(g|0);while(1){l=0;do{j=t+(w*+(k[a+(l<<2)>>2]|0)+v*+(k[c+(l<<2)>>2]|0));p[u>>3]=j;i=k[u+4>>2]|0;h=i&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){i=(i|0)<0;j=i?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=i?-0.0:0.0}b=~~j;f=l|1;j=t+(w*+(k[a+(f<<2)>>2]|0)+v*+(k[c+(f<<2)>>2]|0));p[u>>3]=j;i=k[u+4>>2]|0;h=i&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){i=(i|0)<0;j=i?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=i?-0.0:0.0}k[e+(l<<2)>>2]=b;k[e+(f<<2)>>2]=~~j;h=l|2;j=t+(w*+(k[a+(h<<2)>>2]|0)+v*+(k[c+(h<<2)>>2]|0));p[u>>3]=j;i=k[u+4>>2]|0;f=i&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){i=(i|0)<0;j=i?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=i?-0.0:0.0}b=~~j;f=l|3;j=t+(w*+(k[a+(f<<2)>>2]|0)+v*+(k[c+(f<<2)>>2]|0));p[u>>3]=j;i=k[u+4>>2]|0;x=i&2146435072;if(!(x>>>0>1126170624|(x|0)==1126170624&0>0)){i=(i|0)<0;j=i?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=i?-0.0:0.0}k[e+(h<<2)>>2]=b;k[e+(f<<2)>>2]=~~j;l=l+4|0}while((l|0)<=(m|0));if(o){b=n;do{j=t+(w*+(k[a+(b<<2)>>2]|0)+v*+(k[c+(b<<2)>>2]|0));p[u>>3]=j;i=k[u+4>>2]|0;x=i&2146435072;if(!(x>>>0>1126170624|(x|0)==1126170624&0>0)){i=(i|0)<0;j=i?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=i?-0.0:0.0}k[e+(b<<2)>>2]=~~j;b=b+1|0}while((b|0)!=(g|0))}if(!d)break;else{c=c+(r<<2)|0;e=e+(q<<2)|0;a=a+(s<<2)|0;d=d+-1|0}}return}function mV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,q=0.0,r=0.0,s=0.0,t=0.0;s=+p[i>>3];r=+p[i+8>>3];q=+p[i+16>>3];n=b>>>2;m=d>>>2;l=f>>>2;b=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){f=c;d=e}else return;while(1){i=0;do{o[d+(i<<2)>>2]=q+(s*+o[a+(i<<2)>>2]+r*+o[f+(i<<2)>>2]);i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{f=f+(m<<2)|0;d=d+(l<<2)|0;a=a+(n<<2)|0;b=b+-1|0}}return}j=g&-4;k=(j|0)<(g|0);f=c;d=e;while(1){i=0;do{c=i|1;t=q+(s*+o[a+(c<<2)>>2]+r*+o[f+(c<<2)>>2]);o[d+(i<<2)>>2]=q+(s*+o[a+(i<<2)>>2]+r*+o[f+(i<<2)>>2]);o[d+(c<<2)>>2]=t;c=i|2;e=i|3;t=q+(s*+o[a+(e<<2)>>2]+r*+o[f+(e<<2)>>2]);o[d+(c<<2)>>2]=q+(s*+o[a+(c<<2)>>2]+r*+o[f+(c<<2)>>2]);o[d+(e<<2)>>2]=t;i=i+4|0}while((i|0)<=(h|0));if(k){i=j;do{o[d+(i<<2)>>2]=q+(s*+o[a+(i<<2)>>2]+r*+o[f+(i<<2)>>2]);i=i+1|0}while((i|0)!=(g|0))}if(!b)break;else{f=f+(m<<2)|0;d=d+(l<<2)|0;a=a+(n<<2)|0;b=b+-1|0}}return}function nV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0;q=+p[i>>3];o=+p[i+8>>3];n=+p[i+16>>3];m=b>>>3;l=d>>>3;k=f>>>3;b=h+-1|0;if(!h)return;j=g+-4|0;if((g|0)<4){if((g|0)>0){f=c;d=e}else return;while(1){i=0;do{p[d+(i<<3)>>3]=n+(q*+p[a+(i<<3)>>3]+o*+p[f+(i<<3)>>3]);i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{f=f+(l<<3)|0;d=d+(k<<3)|0;a=a+(m<<3)|0;b=b+-1|0}}return}h=g&-4;if((h|0)<(g|0)){f=c;d=e}else{f=c;d=e;while(1){i=0;do{e=i|1;r=n+(q*+p[a+(e<<3)>>3]+o*+p[f+(e<<3)>>3]);p[d+(i<<3)>>3]=n+(q*+p[a+(i<<3)>>3]+o*+p[f+(i<<3)>>3]);p[d+(e<<3)>>3]=r;e=i|2;g=i|3;r=n+(q*+p[a+(g<<3)>>3]+o*+p[f+(g<<3)>>3]);p[d+(e<<3)>>3]=n+(q*+p[a+(e<<3)>>3]+o*+p[f+(e<<3)>>3]);p[d+(g<<3)>>3]=r;i=i+4|0}while((i|0)<=(j|0));if(!b)break;else{f=f+(l<<3)|0;d=d+(k<<3)|0;a=a+(m<<3)|0;b=b+-1|0}}return}while(1){i=0;do{c=i|1;r=n+(q*+p[a+(c<<3)>>3]+o*+p[f+(c<<3)>>3]);p[d+(i<<3)>>3]=n+(q*+p[a+(i<<3)>>3]+o*+p[f+(i<<3)>>3]);p[d+(c<<3)>>3]=r;c=i|2;e=i|3;r=n+(q*+p[a+(e<<3)>>3]+o*+p[f+(e<<3)>>3]);p[d+(c<<3)>>3]=n+(q*+p[a+(c<<3)>>3]+o*+p[f+(c<<3)>>3]);p[d+(e<<3)>>3]=r;i=i+4|0}while((i|0)<=(j|0));i=h;do{p[d+(i<<3)>>3]=n+(q*+p[a+(i<<3)>>3]+o*+p[f+(i<<3)>>3]);i=i+1|0}while((i|0)!=(g|0));if(!b)break;else{f=f+(l<<3)|0;d=d+(k<<3)|0;a=a+(m<<3)|0;b=b+-1|0}}return}function oV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0.0,n=0.0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0;Q=r;r=r+1456|0;P=Q+1392|0;L=Q+1384|0;O=Q+1264|0;v=Q+1376|0;M=Q+1208|0;A=Q+1320|0;B=Q+1192|0;H=Q+1168|0;I=Q+1136|0;G=Q+96|0;C=Q+88|0;D=Q+1184|0;E=Q+56|0;F=Q;k[L>>2]=d;if(d>>>0>=6){d=P+4|0;e=ZT(100)|0;k[e>>2]=1;f=e+4|0;k[P>>2]=f;k[d>>2]=92;i[e+96>>0]=0;g=209421;h=f+92|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,P,209514,208690,1198);k[d>>2]=0;k[P>>2]=0;K=k[e>>2]|0;k[e>>2]=K+-1;if((K|0)==1)ggb(k[e+-4>>2]|0)}if(((((k[b>>2]&2031616|0)==131072&1)+((k[a>>2]&2031616|0)==131072&1)|0)!=1?E2(a,b)|0:0)?(K=S1(a,-1)|0,(K|0)==(S1(b,-1)|0)):0)z=0;else J=8;a:do if((J|0)==8){d=S1(b,-1)|0;e=k[a>>2]&2031616;f=k[b>>2]&2031616;b:do if((a2(a)|0)<=2?H2(a)|0:0){R1(P,a,-1);g=k[P>>2]|0;h=(g|0)==1;if(!(!h?(k[P+4>>2]|0)!=1:0))J=12;do if((J|0)==12?(j=(d>>>3&511)+1|0,!((e|0)!=131072&(f|0)==131072)):0){d=k[P+4>>2]|0;K=(d|0)==1;if(!((g|0)==(j|0)&K|h&(K|(d|0)==(j|0)))){if(!(h&(d|0)==4))break;if(!(j>>>0<5&(S1(a,-1)|0)==6))break b}d=k[L>>2]|0;if((d|0)!=3)if((d|0)!=4)if((d|0)==2)d=4;else d=(d|0)==1?3:d;else d=2;else d=1;k[L>>2]=d;oV(b,a,c,d);r=Q;return}while(0)}while(0);d=S1(a,-1)|0;e=k[b>>2]&2031616;f=k[a>>2]&2031616;do if((a2(b)|0)<=2?H2(b)|0:0){R1(P,b,-1);g=k[P>>2]|0;h=(g|0)==1;if(!(!h?(k[P+4>>2]|0)!=1:0))J=27;if((J|0)==27?(l=(d>>>3&511)+1|0,!((e|0)!=131072&(f|0)==131072)):0){d=k[P+4>>2]|0;K=(d|0)==1;if((g|0)==(l|0)&K|h&(K|(d|0)==(l|0))){z=1;break a}if(h&(d|0)==4)if(l>>>0<5&(S1(b,-1)|0)==6){z=1;break a}else break}}while(0);K=P+4|0;d=ZT(144)|0;k[d>>2]=1;z=d+4|0;k[P>>2]=z;k[K>>2]=139;i[d+143>>0]=0;upb(z|0,209522,139)|0;Y8(-209,P,209514,208690,1217);k[K>>2]=0;k[P>>2]=0;K=k[d>>2]|0;k[d>>2]=K+-1;if((K|0)==1)ggb(k[d+-4>>2]|0);z=1}while(0);o=k[a>>2]|0;q=k[b>>2]|0;do if((o&2031616|0)==65536){g=k[a+4>>2]|0;k[P>>2]=k[g>>2];a=P+4|0;d=g+4|0;k[a>>2]=k[d>>2];K=P+8|0;k[K>>2]=k[g+8>>2];k[P+12>>2]=k[g+12>>2];k[P+16>>2]=k[g+16>>2];k[P+20>>2]=k[g+20>>2];k[P+24>>2]=k[g+24>>2];k[P+28>>2]=k[g+28>>2];k[P+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[P+36>>2]=e;f=P+40|0;k[f>>2]=K;K=P+48|0;j=P+44|0;k[j>>2]=K;k[P+52>>2]=0;k[K>>2]=0;if(e|0){K=e+12|0;k[K>>2]=(k[K>>2]|0)+1}if((k[d>>2]|0)<3){y=k[g+44>>2]|0;K=k[j>>2]|0;k[K>>2]=k[y>>2];k[K+4>>2]=k[y+4>>2];break}k[a>>2]=0;x1(P,k[d>>2]|0,0,0,0);if((k[a>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[a>>2]|0))}}else Q1(P,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[O>>2]=k[g>>2];a=O+4|0;d=g+4|0;k[a>>2]=k[d>>2];K=O+8|0;k[K>>2]=k[g+8>>2];k[O+12>>2]=k[g+12>>2];k[O+16>>2]=k[g+16>>2];k[O+20>>2]=k[g+20>>2];k[O+24>>2]=k[g+24>>2];k[O+28>>2]=k[g+28>>2];k[O+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[O+36>>2]=e;f=O+40|0;k[f>>2]=K;K=O+48|0;j=O+44|0;k[j>>2]=K;k[O+52>>2]=0;k[K>>2]=0;if(e|0){K=e+12|0;k[K>>2]=(k[K>>2]|0)+1}if((k[d>>2]|0)<3){y=k[g+44>>2]|0;K=k[j>>2]|0;k[K>>2]=k[y>>2];k[K+4>>2]=k[y+4>>2];break}k[a>>2]=0;x1(O,k[d>>2]|0,0,0,0);if((k[a>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[a>>2]|0))}}else Q1(O,b,-1);while(0);K=P+4|0;h=k[K>>2]|0;if((((o^q)&2031616|0)==0&(h|0)<3?(k[O+4>>2]|0)<3:0)?(w=k[P+40>>2]|0,s=k[w+4>>2]|0,t=k[w>>2]|0,y=k[O+40>>2]|0,(t|0)==(k[y>>2]|0)?(s|0)==(k[y+4>>2]|0):0):0){d=k[P>>2]|0;f=k[O>>2]|0;g=(d>>>3&511)+1|0;if(!((f^d)&4095)){k[v>>2]=s;k[v+4>>2]=t;x2(c,v,(g<<3)+-8|0,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[M>>2]=k[g>>2];a=M+4|0;d=g+4|0;k[a>>2]=k[d>>2];I=M+8|0;k[I>>2]=k[g+8>>2];k[M+12>>2]=k[g+12>>2];k[M+16>>2]=k[g+16>>2];k[M+20>>2]=k[g+20>>2];k[M+24>>2]=k[g+24>>2];k[M+28>>2]=k[g+28>>2];k[M+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[M+36>>2]=e;f=M+40|0;k[f>>2]=I;I=M+48|0;j=M+44|0;k[j>>2]=I;k[M+52>>2]=0;k[I>>2]=0;if(e|0){I=e+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[d>>2]|0)<3){I=k[g+44>>2]|0;d=k[j>>2]|0;k[d>>2]=k[I>>2];k[d+4>>2]=k[I+4>>2];d=M;break}k[a>>2]=0;x1(M,k[d>>2]|0,0,0,0);if((k[a>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[a>>2]|0));d=M}else d=M}else{Q1(M,c,-1);d=M}while(0);h=k[P>>2]|0;f=(h>>>3&511)+1|0;H=k[O>>2]|0;I=k[d>>2]|0;d=k[P+12>>2]|0;g=k[P+8>>2]|0;e=Epb(d|0,((d|0)<0)<<31>>31|0,f|0,0)|0;e=Epb(e|0,N|0,g|0,((g|0)<0)<<31>>31|0)|0;if((h&16384&H&I|0)!=0?(e|0)==(e|0)&(((e|0)<0)<<31>>31|0)==(N|0):0)d=1;else{e=aa(d,f)|0;d=g}g=M+16|0;j=M+44|0;l=M+48|0;Gh[k[40160+((h&7)<<2)>>2]&127](k[P+16>>2]|0,k[P+48>>2]|0,k[O+16>>2]|0,k[O+48>>2]|0,k[g>>2]|0,k[l>>2]|0,e,d,L);f=M+36|0;d=k[f>>2]|0;if(d|0?(I=d+12|0,L=k[I>>2]|0,k[I>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[M+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;f=M+4|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[f>>2]|0)>0){e=k[M+40>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[f>>2]|0))}d=k[j>>2]|0;if(!((d|0)==(l|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}else{e=d;d=w;J=85}}else{g=k[P>>2]|0;e=g;f=k[O>>2]|0;g=(g>>>3&511)+1|0;d=k[P+40>>2]|0;J=85}if((J|0)==85){y=e&7;x=f&7;P1(c,h,d,(g<<3)+-8|0,-1,0,0);_1(M,P,1,0);KG(P,M)|0;f=M+36|0;d=k[f>>2]|0;if(d|0?(v=d+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[M+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;w=M+16|0;e=M+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[e>>2]|0)>0){f=k[M+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[M+44>>2]|0;if(!((d|0)==(M+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);_1(M,O,1,0);KG(O,M)|0;f=M+36|0;d=k[f>>2]|0;if(d|0?(v=d+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[M+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;w=M+16|0;e=M+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[e>>2]|0)>0){f=k[M+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[M+44>>2]|0;if(!((d|0)==(M+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[A>>2]=k[g>>2];a=A+4|0;d=g+4|0;k[a>>2]=k[d>>2];c=A+8|0;k[c>>2]=k[g+8>>2];k[A+12>>2]=k[g+12>>2];k[A+16>>2]=k[g+16>>2];k[A+20>>2]=k[g+20>>2];k[A+24>>2]=k[g+24>>2];k[A+28>>2]=k[g+28>>2];k[A+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[A+36>>2]=e;f=A+40|0;k[f>>2]=c;c=A+48|0;j=A+44|0;k[j>>2]=c;k[A+52>>2]=0;k[c>>2]=0;if(e|0){c=e+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[d>>2]|0)<3){w=k[g+44>>2]|0;c=k[j>>2]|0;k[c>>2]=k[w>>2];k[c+4>>2]=k[w+4>>2];break}k[a>>2]=0;x1(A,k[d>>2]|0,0,0,0);if((k[a>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[a>>2]|0))}}else Q1(A,c,-1);while(0);_1(M,A,1,0);f=A+36|0;d=k[f>>2]|0;if(d|0?(w=d+12|0,c=k[w>>2]|0,k[w>>2]=c+-1,(c|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[A+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;c=A+16|0;e=A+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[e>>2]|0)>0){f=k[A+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[A+44>>2]|0;if(!((d|0)==(A+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[K>>2]|0;if((d|0)>0)v=k[(k[P+44>>2]|0)+(d+-1<<2)>>2]|0;else v=0;d=((v+1023|0)>>>0)/(v>>>0)|0;w=k[40160+(y<<2)>>2]|0;if(z){k[B>>2]=P;k[B+4>>2]=M;k[B+8>>2]=0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;k[I+16>>2]=0;k[I+20>>2]=0;k[I+24>>2]=0;k[I+28>>2]=0;z1(I,B,0,H,-1);b=k[I+20>>2]|0;q=d>>>0<b>>>0?d:b;e=aa(q,v)|0;s=G+8|0;k[G>>2]=s;t=G+4|0;k[t>>2]=1032;if(e>>>0>1032){while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[G>>2]=d;o=d}else o=s;k[t>>2]=e;c:do if(y>>>0>4){_T(O,y,o,q);J=174}else{p[C>>3]=0.0;A=k[40512+(x<<2)>>2]|0;B=k[O+16>>2]|0;k[D>>2]=1;k[D+4>>2]=1;sh[A&255](B,1,0,1,C,1,D,0);n=+p[C>>3];do if(n<+p[10424+(y<<3)>>3]){L=k[L>>2]|0;n=(L|0)==5|(L+-1|0)>>>0<2?255.0:0.0;p[E>>3]=n;p[E+8>>3]=n;p[E+16>>3]=n;p[E+24>>3]=n;oY(M,E)}else{if(n>+p[10488+(y<<3)>>3]){n=((k[L>>2]|0)+-3|0)>>>0<3?255.0:0.0;p[E>>3]=n;p[E+8>>3]=n;p[E+16>>3]=n;p[E+24>>3]=n;oY(M,E);break}p[u>>3]=n;d=k[u+4>>2]|0;D=d&2146435072;do if(D>>>0>1126170624|(D|0)==1126170624&0>0)m=n;else{d=(d|0)<0;m=d?n+-4503599627370496.0+4503599627370496.0:n+4503599627370496.0+-4503599627370496.0;if(!(m==0.0))break;m=d?-0.0:0.0}while(0);D=~~m;k[E>>2]=D;d:do if(n!=+(D|0)){d=k[L>>2]|0;if((d|1|0)==3){J=~~n;k[E>>2]=(+(J|0)<n&1)+J;break}switch(d|0){case 1:case 4:{J=~~n;k[E>>2]=J-(+(J|0)>n&1);break d}default:{n=(d|0)==5?255.0:0.0;p[F>>3]=n;p[F+8>>3]=n;p[F+16>>3]=n;p[F+24>>3]=n;oY(M,F);break c}}}while(0);j=F+4|0;k[j>>2]=2;a=F+8|0;k[a>>2]=1;k[F+12>>2]=1;g=F+16|0;k[g>>2]=E;k[F+20>>2]=E;f=F+24|0;h=F+40|0;l=f+8|0;k[l>>2]=0;k[l+4>>2]=0;k[h>>2]=a;a=F+48|0;l=F+44|0;k[l>>2]=a;k[F>>2]=1124024324;k[a>>2]=4;k[F+52>>2]=4;d=E+4|0;k[F+28>>2]=d;k[f>>2]=d;_T(F,y,o,q);f=F+36|0;d=k[f>>2]|0;do if(d|0){E=d+12|0;J=k[E>>2]|0;k[E>>2]=J+-1;if((J|0)!=1)break;e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[F+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}while(0);k[f>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[j>>2]|0)>0){e=k[h>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[l>>2]|0;if(!((d|0)==(a|0)|(d|0)==0))ggb(k[d+-4>>2]|0);J=174;break c}while(0)}while(0);e:do if((J|0)==174){j=I+16|0;f=H+4|0;if(!b){d=0;while(1){if(d>>>0>=(k[j>>2]|0)>>>0)break e;A1(I);d=d+1|0}}else e=0;while(1){if(e>>>0>=(k[j>>2]|0)>>>0)break e;d=0;g=k[H>>2]|0;h=k[f>>2]|0;do{J=b-d|0;J=J>>>0>q>>>0?q:J;Gh[w&127](g,0,o,0,h,0,J,1,L);F=aa(J,v)|0;g=(k[H>>2]|0)+F|0;k[H>>2]=g;h=(k[f>>2]|0)+J|0;k[f>>2]=h;d=d+q|0}while(b>>>0>d>>>0);A1(I);e=e+1|0}}while(0);d=k[G>>2]|0;if((d|0)!=(s|0)){if(d|0)ggb(d);k[G>>2]=s;k[t>>2]=1032}}else{k[B>>2]=P;k[B+4>>2]=O;k[B+8>>2]=M;k[B+12>>2]=0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;k[I+16>>2]=0;k[I+20>>2]=0;k[I+24>>2]=0;k[I+28>>2]=0;z1(I,B,0,H,-1);e=k[I+20>>2]|0;f=I+16|0;g=H+4|0;h=H+8|0;d=0;while(1){if(d>>>0>=(k[f>>2]|0)>>>0)break;Gh[w&127](k[H>>2]|0,0,k[g>>2]|0,0,k[h>>2]|0,0,e,1,L);A1(I);d=d+1|0}}f=M+36|0;d=k[f>>2]|0;do if(d|0){J=d+12|0;L=k[J>>2]|0;k[J>>2]=L+-1;if((L|0)!=1)break;e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[M+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}while(0);k[f>>2]=0;L=M+16|0;e=M+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[M+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[M+44>>2]|0;if(!((d|0)==(M+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}f=O+36|0;d=k[f>>2]|0;if(d|0?(L=d+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[O+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;M=O+16|0;e=O+4|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[e>>2]|0)>0){f=k[O+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[O+44>>2]|0;if(!((d|0)==(O+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=P+36|0;d=k[f>>2]|0;if(d|0?(M=d+12|0,O=k[M>>2]|0,k[M>>2]=O+-1,(O|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[P+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;O=P+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[K>>2]|0)>0){e=k[P+40>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[K>>2]|0))}d=k[P+44>>2]|0;if(!((d|0)==(P+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=Q;return}function pV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var m=0,n=0,o=0;j=k[j>>2]|0;if((j|1|0)==3){j=(j|0)==2?4:1;o=b;b=d;n=a}else{o=d;n=c;c=a}switch(j|0){case 1:case 4:{m=(j|0)==1?0:255;if((h|0)!=0&(g|0)>0){d=e;j=n}else return;while(1){a=0;do{i[d+a>>0]=((l[c+a>>0]|0)>(l[j+a>>0]|0))<<31>>31^m;a=a+1|0}while((a|0)!=(g|0));h=h+-1|0;if(!h)break;else{d=d+f|0;j=j+o|0;c=c+b|0}}return}default:{}}a=(j|0)==0;switch(j|0){case 0:case 5:break;default:return}m=a?0:255;if((h|0)!=0&(g|0)>0){d=e;j=n}else return;while(1){a=0;do{i[d+a>>0]=((i[c+a>>0]|0)==(i[j+a>>0]|0))<<31>>31^m;a=a+1|0}while((a|0)!=(g|0));h=h+-1|0;if(!h)break;else{d=d+f|0;j=j+o|0;c=c+b|0}}return}function qV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=k[j>>2]|0;j=a;if((l|1|0)==3){l=(l|0)==2?4:1;o=b;b=d;a=j;j=c}else{o=d;a=c}switch(l|0){case 1:case 4:{n=(l|0)==1?0:255;l=h+-1|0;if(!h)return;m=g+-4|0;if((g|0)<4){if((g|0)>0)d=e;else return;while(1){c=j;j=0;do{i[d+j>>0]=((i[c+j>>0]|0)>(i[a+j>>0]|0))<<31>>31^n;j=j+1|0}while((j|0)!=(g|0));if(!l)break;else{d=d+f|0;a=a+o|0;j=c+b|0;l=l+-1|0}}return}h=g&-4;if((h|0)<(g|0))d=e;else{d=e;while(1){c=j;j=0;do{h=j|1;g=((i[c+h>>0]|0)>(i[a+h>>0]|0))<<31>>31^n;i[d+j>>0]=((i[c+j>>0]|0)>(i[a+j>>0]|0))<<31>>31^n;i[d+h>>0]=g;h=j|2;g=j|3;e=((i[c+g>>0]|0)>(i[a+g>>0]|0))<<31>>31^n;i[d+h>>0]=((i[c+h>>0]|0)>(i[a+h>>0]|0))<<31>>31^n;i[d+g>>0]=e;j=j+4|0}while((j|0)<=(m|0));if(!l)break;else{d=d+f|0;a=a+o|0;j=c+b|0;l=l+-1|0}}return}while(1){c=0;do{q=c|1;e=((i[j+q>>0]|0)>(i[a+q>>0]|0))<<31>>31^n;i[d+c>>0]=((i[j+c>>0]|0)>(i[a+c>>0]|0))<<31>>31^n;i[d+q>>0]=e;q=c|2;e=c|3;p=((i[j+e>>0]|0)>(i[a+e>>0]|0))<<31>>31^n;i[d+q>>0]=((i[j+q>>0]|0)>(i[a+q>>0]|0))<<31>>31^n;i[d+e>>0]=p;c=c+4|0}while((c|0)<=(m|0));c=h;do{i[d+c>>0]=((i[j+c>>0]|0)>(i[a+c>>0]|0))<<31>>31^n;c=c+1|0}while((c|0)!=(g|0));if(!l)break;else{d=d+f|0;a=a+o|0;j=j+b|0;l=l+-1|0}}return}default:{}}c=(l|0)==0;switch(l|0){case 0:case 5:break;default:return}n=c?0:255;l=h+-1|0;if(!h)return;m=g+-4|0;if((g|0)<4){if((g|0)>0)d=e;else return;while(1){c=j;j=0;do{i[d+j>>0]=((i[c+j>>0]|0)==(i[a+j>>0]|0))<<31>>31^n;j=j+1|0}while((j|0)!=(g|0));if(!l)break;else{d=d+f|0;a=a+o|0;j=c+b|0;l=l+-1|0}}return}h=g&-4;if((h|0)<(g|0))d=e;else{d=e;while(1){c=j;j=0;do{g=j|1;q=((i[c+g>>0]|0)==(i[a+g>>0]|0))<<31>>31^n;i[d+j>>0]=((i[c+j>>0]|0)==(i[a+j>>0]|0))<<31>>31^n;i[d+g>>0]=q;g=j|2;q=j|3;p=((i[c+q>>0]|0)==(i[a+q>>0]|0))<<31>>31^n;i[d+g>>0]=((i[c+g>>0]|0)==(i[a+g>>0]|0))<<31>>31^n;i[d+q>>0]=p;j=j+4|0}while((j|0)<=(m|0));if(!l)break;else{d=d+f|0;a=a+o|0;j=c+b|0;l=l+-1|0}}return}while(1){c=0;do{e=c|1;q=((i[j+e>>0]|0)==(i[a+e>>0]|0))<<31>>31^n;i[d+c>>0]=((i[j+c>>0]|0)==(i[a+c>>0]|0))<<31>>31^n;i[d+e>>0]=q;e=c|2;q=c|3;p=((i[j+q>>0]|0)==(i[a+q>>0]|0))<<31>>31^n;i[d+e>>0]=((i[j+e>>0]|0)==(i[a+e>>0]|0))<<31>>31^n;i[d+q>>0]=p;c=c+4|0}while((c|0)<=(m|0));c=h;do{i[d+c>>0]=((i[j+c>>0]|0)==(i[a+c>>0]|0))<<31>>31^n;c=c+1|0}while((c|0)!=(g|0));if(!l)break;else{d=d+f|0;a=a+o|0;j=j+b|0;l=l+-1|0}}return}function rV(a,b,c,d,e,f,g,h,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;l=l|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=k[l>>2]|0;l=a;b=b>>>1;a=d>>>1;if((n|1|0)==3){n=(n|0)==2?4:1;s=b;b=a;q=l;l=c}else{s=a;q=c}switch(n|0){case 1:case 4:{r=(n|0)==1?0:255;d=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){n=e;a=q}else return;while(1){c=l;l=0;do{i[n+l>>0]=((m[c+(l<<1)>>1]|0)>(m[a+(l<<1)>>1]|0))<<31>>31^r;l=l+1|0}while((l|0)!=(g|0));if(!d)break;else{n=n+f|0;a=a+(s<<1)|0;l=c+(b<<1)|0;d=d+-1|0}}return}o=g&-4;p=(o|0)<(g|0);n=e;c=q;while(1){a=0;do{t=a|1;e=((m[l+(t<<1)>>1]|0)>(m[c+(t<<1)>>1]|0))<<31>>31^r;i[n+a>>0]=((m[l+(a<<1)>>1]|0)>(m[c+(a<<1)>>1]|0))<<31>>31^r;i[n+t>>0]=e;t=a|2;e=a|3;q=((m[l+(e<<1)>>1]|0)>(m[c+(e<<1)>>1]|0))<<31>>31^r;i[n+t>>0]=((m[l+(t<<1)>>1]|0)>(m[c+(t<<1)>>1]|0))<<31>>31^r;i[n+e>>0]=q;a=a+4|0}while((a|0)<=(h|0));if(p){a=o;do{i[n+a>>0]=((m[l+(a<<1)>>1]|0)>(m[c+(a<<1)>>1]|0))<<31>>31^r;a=a+1|0}while((a|0)!=(g|0))}if(!d)break;else{n=n+f|0;c=c+(s<<1)|0;l=l+(b<<1)|0;d=d+-1|0}}return}default:{}}a=(n|0)==0;switch(n|0){case 0:case 5:break;default:return}p=a?0:255;d=h+-1|0;if(!h)return;o=g+-4|0;if((g|0)<4){if((g|0)>0){n=e;a=q}else return;while(1){c=l;l=0;do{i[n+l>>0]=((j[c+(l<<1)>>1]|0)==(j[a+(l<<1)>>1]|0))<<31>>31^p;l=l+1|0}while((l|0)!=(g|0));if(!d)break;else{n=n+f|0;a=a+(s<<1)|0;l=c+(b<<1)|0;d=d+-1|0}}return}h=g&-4;if((h|0)<(g|0)){n=e;c=q}else{n=e;a=q;while(1){c=l;l=0;do{e=l|1;t=((j[c+(e<<1)>>1]|0)==(j[a+(e<<1)>>1]|0))<<31>>31^p;i[n+l>>0]=((j[c+(l<<1)>>1]|0)==(j[a+(l<<1)>>1]|0))<<31>>31^p;i[n+e>>0]=t;e=l|2;t=l|3;g=((j[c+(t<<1)>>1]|0)==(j[a+(t<<1)>>1]|0))<<31>>31^p;i[n+e>>0]=((j[c+(e<<1)>>1]|0)==(j[a+(e<<1)>>1]|0))<<31>>31^p;i[n+t>>0]=g;l=l+4|0}while((l|0)<=(o|0));if(!d)break;else{n=n+f|0;a=a+(s<<1)|0;l=c+(b<<1)|0;d=d+-1|0}}return}while(1){a=0;do{r=a|1;t=((j[l+(r<<1)>>1]|0)==(j[c+(r<<1)>>1]|0))<<31>>31^p;i[n+a>>0]=((j[l+(a<<1)>>1]|0)==(j[c+(a<<1)>>1]|0))<<31>>31^p;i[n+r>>0]=t;r=a|2;t=a|3;e=((j[l+(t<<1)>>1]|0)==(j[c+(t<<1)>>1]|0))<<31>>31^p;i[n+r>>0]=((j[l+(r<<1)>>1]|0)==(j[c+(r<<1)>>1]|0))<<31>>31^p;i[n+t>>0]=e;a=a+4|0}while((a|0)<=(o|0));a=h;do{i[n+a>>0]=((j[l+(a<<1)>>1]|0)==(j[c+(a<<1)>>1]|0))<<31>>31^p;a=a+1|0}while((a|0)!=(g|0));if(!d)break;else{n=n+f|0;c=c+(s<<1)|0;l=l+(b<<1)|0;d=d+-1|0}}return}function sV(a,b,c,d,e,f,g,h,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;l=l|0;var m=0,n=0,o=0;l=k[l>>2]|0;m=b>>>1;b=d>>>1;if((l|1|0)==3){d=(l|0)==2?4:1;o=m;l=a}else{d=l;o=b;b=m;l=c;c=a}switch(d|0){case 1:case 4:{n=(d|0)==1?0:255;if((h|0)!=0&(g|0)>0){d=e;m=h}else return;while(1){a=0;do{i[d+a>>0]=((j[c+(a<<1)>>1]|0)>(j[l+(a<<1)>>1]|0))<<31>>31^n;a=a+1|0}while((a|0)!=(g|0));m=m+-1|0;if(!m)break;else{d=d+f|0;l=l+(o<<1)|0;c=c+(b<<1)|0}}return}default:{}}a=(d|0)==0;switch(d|0){case 0:case 5:break;default:return}n=a?0:255;if((h|0)!=0&(g|0)>0){d=e;m=h}else return;while(1){a=0;do{i[d+a>>0]=((j[c+(a<<1)>>1]|0)==(j[l+(a<<1)>>1]|0))<<31>>31^n;a=a+1|0}while((a|0)!=(g|0));m=m+-1|0;if(!m)break;else{d=d+f|0;l=l+(o<<1)|0;c=c+(b<<1)|0}}return}function tV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=k[j>>2]|0;j=a;b=b>>>2;a=d>>>2;if((l|1|0)==3){l=(l|0)==2?4:1;q=b;b=a;o=j;j=c}else{q=a;o=c}switch(l|0){case 1:case 4:{p=(l|0)==1?0:255;d=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=e;a=o}else return;while(1){c=j;j=0;do{i[l+j>>0]=((k[c+(j<<2)>>2]|0)>(k[a+(j<<2)>>2]|0))<<31>>31^p;j=j+1|0}while((j|0)!=(g|0));if(!d)break;else{l=l+f|0;a=a+(q<<2)|0;j=c+(b<<2)|0;d=d+-1|0}}return}m=g&-4;n=(m|0)<(g|0);l=e;c=o;while(1){a=0;do{r=a|1;e=((k[j+(r<<2)>>2]|0)>(k[c+(r<<2)>>2]|0))<<31>>31^p;i[l+a>>0]=((k[j+(a<<2)>>2]|0)>(k[c+(a<<2)>>2]|0))<<31>>31^p;i[l+r>>0]=e;r=a|2;e=a|3;o=((k[j+(e<<2)>>2]|0)>(k[c+(e<<2)>>2]|0))<<31>>31^p;i[l+r>>0]=((k[j+(r<<2)>>2]|0)>(k[c+(r<<2)>>2]|0))<<31>>31^p;i[l+e>>0]=o;a=a+4|0}while((a|0)<=(h|0));if(n){a=m;do{i[l+a>>0]=((k[j+(a<<2)>>2]|0)>(k[c+(a<<2)>>2]|0))<<31>>31^p;a=a+1|0}while((a|0)!=(g|0))}if(!d)break;else{l=l+f|0;c=c+(q<<2)|0;j=j+(b<<2)|0;d=d+-1|0}}return}default:{}}a=(l|0)==0;switch(l|0){case 0:case 5:break;default:return}n=a?0:255;d=h+-1|0;if(!h)return;m=g+-4|0;if((g|0)<4){if((g|0)>0){l=e;a=o}else return;while(1){c=j;j=0;do{i[l+j>>0]=((k[c+(j<<2)>>2]|0)==(k[a+(j<<2)>>2]|0))<<31>>31^n;j=j+1|0}while((j|0)!=(g|0));if(!d)break;else{l=l+f|0;a=a+(q<<2)|0;j=c+(b<<2)|0;d=d+-1|0}}return}h=g&-4;if((h|0)<(g|0)){l=e;c=o}else{l=e;a=o;while(1){c=j;j=0;do{e=j|1;r=((k[c+(e<<2)>>2]|0)==(k[a+(e<<2)>>2]|0))<<31>>31^n;i[l+j>>0]=((k[c+(j<<2)>>2]|0)==(k[a+(j<<2)>>2]|0))<<31>>31^n;i[l+e>>0]=r;e=j|2;r=j|3;g=((k[c+(r<<2)>>2]|0)==(k[a+(r<<2)>>2]|0))<<31>>31^n;i[l+e>>0]=((k[c+(e<<2)>>2]|0)==(k[a+(e<<2)>>2]|0))<<31>>31^n;i[l+r>>0]=g;j=j+4|0}while((j|0)<=(m|0));if(!d)break;else{l=l+f|0;a=a+(q<<2)|0;j=c+(b<<2)|0;d=d+-1|0}}return}while(1){a=0;do{p=a|1;r=((k[j+(p<<2)>>2]|0)==(k[c+(p<<2)>>2]|0))<<31>>31^n;i[l+a>>0]=((k[j+(a<<2)>>2]|0)==(k[c+(a<<2)>>2]|0))<<31>>31^n;i[l+p>>0]=r;p=a|2;r=a|3;e=((k[j+(r<<2)>>2]|0)==(k[c+(r<<2)>>2]|0))<<31>>31^n;i[l+p>>0]=((k[j+(p<<2)>>2]|0)==(k[c+(p<<2)>>2]|0))<<31>>31^n;i[l+r>>0]=e;a=a+4|0}while((a|0)<=(m|0));a=h;do{i[l+a>>0]=((k[j+(a<<2)>>2]|0)==(k[c+(a<<2)>>2]|0))<<31>>31^n;a=a+1|0}while((a|0)!=(g|0));if(!d)break;else{l=l+f|0;c=c+(q<<2)|0;j=j+(b<<2)|0;d=d+-1|0}}return}function uV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,p=0,q=0,r=0,s=0;l=k[j>>2]|0;j=a;b=b>>>2;a=d>>>2;if((l|1|0)==3){l=(l|0)==2?4:1;r=b;b=a;p=j;j=c}else{r=a;p=c}switch(l|0){case 1:case 4:{q=(l|0)==1?0:255;d=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=e;a=p}else return;while(1){c=j;j=0;do{i[l+j>>0]=(+o[c+(j<<2)>>2]>+o[a+(j<<2)>>2])<<31>>31^q;j=j+1|0}while((j|0)!=(g|0));if(!d)break;else{l=l+f|0;a=a+(r<<2)|0;j=c+(b<<2)|0;d=d+-1|0}}return}m=g&-4;n=(m|0)<(g|0);l=e;c=p;while(1){a=0;do{s=a|1;e=(+o[j+(s<<2)>>2]>+o[c+(s<<2)>>2])<<31>>31^q;i[l+a>>0]=(+o[j+(a<<2)>>2]>+o[c+(a<<2)>>2])<<31>>31^q;i[l+s>>0]=e;s=a|2;e=a|3;p=(+o[j+(e<<2)>>2]>+o[c+(e<<2)>>2])<<31>>31^q;i[l+s>>0]=(+o[j+(s<<2)>>2]>+o[c+(s<<2)>>2])<<31>>31^q;i[l+e>>0]=p;a=a+4|0}while((a|0)<=(h|0));if(n){a=m;do{i[l+a>>0]=(+o[j+(a<<2)>>2]>+o[c+(a<<2)>>2])<<31>>31^q;a=a+1|0}while((a|0)!=(g|0))}if(!d)break;else{l=l+f|0;c=c+(r<<2)|0;j=j+(b<<2)|0;d=d+-1|0}}return}default:{}}a=(l|0)==0;switch(l|0){case 0:case 5:break;default:return}n=a?0:255;d=h+-1|0;if(!h)return;m=g+-4|0;if((g|0)<4){if((g|0)>0){l=e;a=p}else return;while(1){c=j;j=0;do{i[l+j>>0]=(+o[c+(j<<2)>>2]==+o[a+(j<<2)>>2])<<31>>31^n;j=j+1|0}while((j|0)!=(g|0));if(!d)break;else{l=l+f|0;a=a+(r<<2)|0;j=c+(b<<2)|0;d=d+-1|0}}return}h=g&-4;if((h|0)<(g|0)){l=e;c=p}else{l=e;a=p;while(1){c=j;j=0;do{e=j|1;s=(+o[c+(e<<2)>>2]==+o[a+(e<<2)>>2])<<31>>31^n;i[l+j>>0]=(+o[c+(j<<2)>>2]==+o[a+(j<<2)>>2])<<31>>31^n;i[l+e>>0]=s;e=j|2;s=j|3;g=(+o[c+(s<<2)>>2]==+o[a+(s<<2)>>2])<<31>>31^n;i[l+e>>0]=(+o[c+(e<<2)>>2]==+o[a+(e<<2)>>2])<<31>>31^n;i[l+s>>0]=g;j=j+4|0}while((j|0)<=(m|0));if(!d)break;else{l=l+f|0;a=a+(r<<2)|0;j=c+(b<<2)|0;d=d+-1|0}}return}while(1){a=0;do{q=a|1;s=(+o[j+(q<<2)>>2]==+o[c+(q<<2)>>2])<<31>>31^n;i[l+a>>0]=(+o[j+(a<<2)>>2]==+o[c+(a<<2)>>2])<<31>>31^n;i[l+q>>0]=s;q=a|2;s=a|3;e=(+o[j+(s<<2)>>2]==+o[c+(s<<2)>>2])<<31>>31^n;i[l+q>>0]=(+o[j+(q<<2)>>2]==+o[c+(q<<2)>>2])<<31>>31^n;i[l+s>>0]=e;a=a+4|0}while((a|0)<=(m|0));a=h;do{i[l+a>>0]=(+o[j+(a<<2)>>2]==+o[c+(a<<2)>>2])<<31>>31^n;a=a+1|0}while((a|0)!=(g|0));if(!d)break;else{l=l+f|0;c=c+(r<<2)|0;j=j+(b<<2)|0;d=d+-1|0}}return}function vV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0;l=k[j>>2]|0;j=a;b=b>>>3;a=d>>>3;if((l|1|0)==3){l=(l|0)==2?4:1;r=b;b=a;o=j;j=c}else{r=a;o=c}switch(l|0){case 1:case 4:{q=(l|0)==1?0:255;d=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=e;a=o}else return;while(1){c=j;j=0;do{i[l+j>>0]=(+p[c+(j<<3)>>3]>+p[a+(j<<3)>>3])<<31>>31^q;j=j+1|0}while((j|0)!=(g|0));if(!d)break;else{l=l+f|0;a=a+(r<<3)|0;j=c+(b<<3)|0;d=d+-1|0}}return}m=g&-4;n=(m|0)<(g|0);l=e;c=o;while(1){a=0;do{s=a|1;e=(+p[j+(s<<3)>>3]>+p[c+(s<<3)>>3])<<31>>31^q;i[l+a>>0]=(+p[j+(a<<3)>>3]>+p[c+(a<<3)>>3])<<31>>31^q;i[l+s>>0]=e;s=a|2;e=a|3;o=(+p[j+(e<<3)>>3]>+p[c+(e<<3)>>3])<<31>>31^q;i[l+s>>0]=(+p[j+(s<<3)>>3]>+p[c+(s<<3)>>3])<<31>>31^q;i[l+e>>0]=o;a=a+4|0}while((a|0)<=(h|0));if(n){a=m;do{i[l+a>>0]=(+p[j+(a<<3)>>3]>+p[c+(a<<3)>>3])<<31>>31^q;a=a+1|0}while((a|0)!=(g|0))}if(!d)break;else{l=l+f|0;c=c+(r<<3)|0;j=j+(b<<3)|0;d=d+-1|0}}return}default:{}}a=(l|0)==0;switch(l|0){case 0:case 5:break;default:return}n=a?0:255;d=h+-1|0;if(!h)return;m=g+-4|0;if((g|0)<4){if((g|0)>0){l=e;a=o}else return;while(1){c=j;j=0;do{i[l+j>>0]=(+p[c+(j<<3)>>3]==+p[a+(j<<3)>>3])<<31>>31^n;j=j+1|0}while((j|0)!=(g|0));if(!d)break;else{l=l+f|0;a=a+(r<<3)|0;j=c+(b<<3)|0;d=d+-1|0}}return}h=g&-4;if((h|0)<(g|0)){l=e;c=o}else{l=e;a=o;while(1){c=j;j=0;do{e=j|1;s=(+p[c+(e<<3)>>3]==+p[a+(e<<3)>>3])<<31>>31^n;i[l+j>>0]=(+p[c+(j<<3)>>3]==+p[a+(j<<3)>>3])<<31>>31^n;i[l+e>>0]=s;e=j|2;s=j|3;g=(+p[c+(s<<3)>>3]==+p[a+(s<<3)>>3])<<31>>31^n;i[l+e>>0]=(+p[c+(e<<3)>>3]==+p[a+(e<<3)>>3])<<31>>31^n;i[l+s>>0]=g;j=j+4|0}while((j|0)<=(m|0));if(!d)break;else{l=l+f|0;a=a+(r<<3)|0;j=c+(b<<3)|0;d=d+-1|0}}return}while(1){a=0;do{q=a|1;s=(+p[j+(q<<3)>>3]==+p[c+(q<<3)>>3])<<31>>31^n;i[l+a>>0]=(+p[j+(a<<3)>>3]==+p[c+(a<<3)>>3])<<31>>31^n;i[l+q>>0]=s;q=a|2;s=a|3;e=(+p[j+(s<<3)>>3]==+p[c+(s<<3)>>3])<<31>>31^n;i[l+q>>0]=(+p[j+(q<<3)>>3]==+p[c+(q<<3)>>3])<<31>>31^n;i[l+s>>0]=e;a=a+4|0}while((a|0)<=(m|0));a=h;do{i[l+a>>0]=(+p[j+(a<<3)>>3]==+p[c+(a<<3)>>3])<<31>>31^n;a=a+1|0}while((a|0)!=(g|0));if(!d)break;else{l=l+f|0;c=c+(r<<3)|0;j=j+(b<<3)|0;d=d+-1|0}}return}function wV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=k[j>>2]|0;m=k[j+4>>2]|0;if(!m)return;r=u+-4|0;if((u|0)<4){o=(u|0)>0;n=a;while(1){m=m+-1|0;if(o){a=0;do{j=i[n+a>>0]|0;if((l[c+a>>0]|0)>(j&255))j=0;else j=(j&255)<=(l[e+a>>0]|0);i[g+a>>0]=j<<31>>31;a=a+1|0}while((a|0)!=(u|0))}if(!m)break;else{n=n+b|0;g=g+h|0;e=e+f|0;c=c+d|0}}return}s=u&-4;t=(s|0)<(u|0);q=g;while(1){p=0;do{j=i[a+p>>0]|0;if((l[c+p>>0]|0)>(j&255))n=0;else n=(j&255)<=(l[e+p>>0]|0);g=p|1;j=i[a+g>>0]|0;if((l[c+g>>0]|0)>(j&255))j=0;else j=(j&255)<=(l[e+g>>0]|0);i[q+p>>0]=n<<31>>31;i[q+g>>0]=j<<31>>31;o=p|2;j=i[a+o>>0]|0;if((l[c+o>>0]|0)>(j&255))n=0;else n=(j&255)<=(l[e+o>>0]|0);g=p|3;j=i[a+g>>0]|0;if((l[c+g>>0]|0)>(j&255))j=0;else j=(j&255)<=(l[e+g>>0]|0);i[q+o>>0]=n<<31>>31;i[q+g>>0]=j<<31>>31;p=p+4|0}while((p|0)<=(r|0));m=m+-1|0;if(t){g=s;do{j=i[a+g>>0]|0;if((l[c+g>>0]|0)>(j&255))j=0;else j=(j&255)<=(l[e+g>>0]|0);i[q+g>>0]=j<<31>>31;g=g+1|0}while((g|0)!=(u|0))}if(!m)break;else{a=a+b|0;q=q+h|0;e=e+f|0;c=c+d|0}}return}function xV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;t=k[j>>2]|0;l=k[j+4>>2]|0;if(!l)return;q=t+-4|0;if((t|0)<4){n=(t|0)>0;m=a;while(1){l=l+-1|0;if(n){a=0;do{j=i[m+a>>0]|0;if((i[c+a>>0]|0)>j<<24>>24)j=0;else j=j<<24>>24<=(i[e+a>>0]|0);i[g+a>>0]=j<<31>>31;a=a+1|0}while((a|0)!=(t|0))}if(!l)break;else{m=m+b|0;g=g+h|0;e=e+f|0;c=c+d|0}}return}r=t&-4;s=(r|0)<(t|0);p=g;while(1){o=0;do{j=i[a+o>>0]|0;if((i[c+o>>0]|0)>j<<24>>24)m=0;else m=j<<24>>24<=(i[e+o>>0]|0);g=o|1;j=i[a+g>>0]|0;if((i[c+g>>0]|0)>j<<24>>24)j=0;else j=j<<24>>24<=(i[e+g>>0]|0);i[p+o>>0]=m<<31>>31;i[p+g>>0]=j<<31>>31;n=o|2;j=i[a+n>>0]|0;if((i[c+n>>0]|0)>j<<24>>24)m=0;else m=j<<24>>24<=(i[e+n>>0]|0);g=o|3;j=i[a+g>>0]|0;if((i[c+g>>0]|0)>j<<24>>24)j=0;else j=j<<24>>24<=(i[e+g>>0]|0);i[p+n>>0]=m<<31>>31;i[p+g>>0]=j<<31>>31;o=o+4|0}while((o|0)<=(q|0));l=l+-1|0;if(s){g=r;do{j=i[a+g>>0]|0;if((i[c+g>>0]|0)>j<<24>>24)j=0;else j=j<<24>>24<=(i[e+g>>0]|0);i[p+g>>0]=j<<31>>31;g=g+1|0}while((g|0)!=(t|0))}if(!l)break;else{a=a+b|0;p=p+h|0;e=e+f|0;c=c+d|0}}return}function yV(a,b,c,d,e,f,g,h,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;l=l|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=k[l>>2]|0;l=k[l+4>>2]|0;u=b>>>1;t=d>>>1;s=f>>>1;if(!l)return;p=v+-4|0;if((v|0)<4){n=(v|0)>0;f=c;d=l;while(1){d=d+-1|0;if(n){b=0;do{l=j[a+(b<<1)>>1]|0;if((m[f+(b<<1)>>1]|0)>(l&65535))l=0;else l=(l&65535)<=(m[e+(b<<1)>>1]|0);i[g+b>>0]=l<<31>>31;b=b+1|0}while((b|0)!=(v|0))}if(!d)break;else{a=a+(u<<1)|0;g=g+h|0;e=e+(s<<1)|0;f=f+(t<<1)|0}}return}q=v&-4;r=(q|0)<(v|0);o=l;while(1){n=0;do{l=j[a+(n<<1)>>1]|0;if((m[c+(n<<1)>>1]|0)>(l&65535))d=0;else d=(l&65535)<=(m[e+(n<<1)>>1]|0);b=n|1;l=j[a+(b<<1)>>1]|0;if((m[c+(b<<1)>>1]|0)>(l&65535))l=0;else l=(l&65535)<=(m[e+(b<<1)>>1]|0);i[g+n>>0]=d<<31>>31;i[g+b>>0]=l<<31>>31;f=n|2;l=j[a+(f<<1)>>1]|0;if((m[c+(f<<1)>>1]|0)>(l&65535))d=0;else d=(l&65535)<=(m[e+(f<<1)>>1]|0);b=n|3;l=j[a+(b<<1)>>1]|0;if((m[c+(b<<1)>>1]|0)>(l&65535))l=0;else l=(l&65535)<=(m[e+(b<<1)>>1]|0);i[g+f>>0]=d<<31>>31;i[g+b>>0]=l<<31>>31;n=n+4|0}while((n|0)<=(p|0));o=o+-1|0;if(r){b=q;do{l=j[a+(b<<1)>>1]|0;if((m[c+(b<<1)>>1]|0)>(l&65535))l=0;else l=(l&65535)<=(m[e+(b<<1)>>1]|0);i[g+b>>0]=l<<31>>31;b=b+1|0}while((b|0)!=(v|0))}if(!o)break;else{a=a+(u<<1)|0;g=g+h|0;e=e+(s<<1)|0;c=c+(t<<1)|0}}return}function zV(a,b,c,d,e,f,g,h,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=k[l>>2]|0;l=k[l+4>>2]|0;t=b>>>1;s=d>>>1;r=f>>>1;if(!l)return;o=u+-4|0;if((u|0)<4){m=(u|0)>0;f=c;d=l;while(1){d=d+-1|0;if(m){b=0;do{l=j[a+(b<<1)>>1]|0;if((j[f+(b<<1)>>1]|0)>l<<16>>16)l=0;else l=l<<16>>16<=(j[e+(b<<1)>>1]|0);i[g+b>>0]=l<<31>>31;b=b+1|0}while((b|0)!=(u|0))}if(!d)break;else{a=a+(t<<1)|0;g=g+h|0;e=e+(r<<1)|0;f=f+(s<<1)|0}}return}p=u&-4;q=(p|0)<(u|0);n=l;while(1){m=0;do{l=j[a+(m<<1)>>1]|0;if((j[c+(m<<1)>>1]|0)>l<<16>>16)d=0;else d=l<<16>>16<=(j[e+(m<<1)>>1]|0);b=m|1;l=j[a+(b<<1)>>1]|0;if((j[c+(b<<1)>>1]|0)>l<<16>>16)l=0;else l=l<<16>>16<=(j[e+(b<<1)>>1]|0);i[g+m>>0]=d<<31>>31;i[g+b>>0]=l<<31>>31;f=m|2;l=j[a+(f<<1)>>1]|0;if((j[c+(f<<1)>>1]|0)>l<<16>>16)d=0;else d=l<<16>>16<=(j[e+(f<<1)>>1]|0);b=m|3;l=j[a+(b<<1)>>1]|0;if((j[c+(b<<1)>>1]|0)>l<<16>>16)l=0;else l=l<<16>>16<=(j[e+(b<<1)>>1]|0);i[g+f>>0]=d<<31>>31;i[g+b>>0]=l<<31>>31;m=m+4|0}while((m|0)<=(o|0));n=n+-1|0;if(q){b=p;do{l=j[a+(b<<1)>>1]|0;if((j[c+(b<<1)>>1]|0)>l<<16>>16)l=0;else l=l<<16>>16<=(j[e+(b<<1)>>1]|0);i[g+b>>0]=l<<31>>31;b=b+1|0}while((b|0)!=(u|0))}if(!n)break;else{a=a+(t<<1)|0;g=g+h|0;e=e+(r<<1)|0;c=c+(s<<1)|0}}return}function AV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;t=k[j>>2]|0;j=k[j+4>>2]|0;s=b>>>2;r=d>>>2;q=f>>>2;if(!j)return;n=t+-4|0;if((t|0)<4){l=(t|0)>0;f=c;d=j;while(1){d=d+-1|0;if(l){b=0;do{j=k[a+(b<<2)>>2]|0;if((k[f+(b<<2)>>2]|0)>(j|0))j=0;else j=(j|0)<=(k[e+(b<<2)>>2]|0);i[g+b>>0]=j<<31>>31;b=b+1|0}while((b|0)!=(t|0))}if(!d)break;else{a=a+(s<<2)|0;g=g+h|0;e=e+(q<<2)|0;f=f+(r<<2)|0}}return}o=t&-4;p=(o|0)<(t|0);m=j;while(1){l=0;do{j=k[a+(l<<2)>>2]|0;if((k[c+(l<<2)>>2]|0)>(j|0))d=0;else d=(j|0)<=(k[e+(l<<2)>>2]|0);b=l|1;j=k[a+(b<<2)>>2]|0;if((k[c+(b<<2)>>2]|0)>(j|0))j=0;else j=(j|0)<=(k[e+(b<<2)>>2]|0);i[g+l>>0]=d<<31>>31;i[g+b>>0]=j<<31>>31;f=l|2;j=k[a+(f<<2)>>2]|0;if((k[c+(f<<2)>>2]|0)>(j|0))d=0;else d=(j|0)<=(k[e+(f<<2)>>2]|0);b=l|3;j=k[a+(b<<2)>>2]|0;if((k[c+(b<<2)>>2]|0)>(j|0))j=0;else j=(j|0)<=(k[e+(b<<2)>>2]|0);i[g+f>>0]=d<<31>>31;i[g+b>>0]=j<<31>>31;l=l+4|0}while((l|0)<=(n|0));m=m+-1|0;if(p){b=o;do{j=k[a+(b<<2)>>2]|0;if((k[c+(b<<2)>>2]|0)>(j|0))j=0;else j=(j|0)<=(k[e+(b<<2)>>2]|0);i[g+b>>0]=j<<31>>31;b=b+1|0}while((b|0)!=(t|0))}if(!m)break;else{a=a+(s<<2)|0;g=g+h|0;e=e+(q<<2)|0;c=c+(r<<2)|0}}return}function BV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0.0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=k[j>>2]|0;j=k[j+4>>2]|0;u=b>>>2;t=d>>>2;s=f>>>2;if(!j)return;p=v+-4|0;if((v|0)<4){m=(v|0)>0;f=c;d=j;while(1){d=d+-1|0;if(m){b=0;do{l=+o[a+(b<<2)>>2];if(!(+o[f+(b<<2)>>2]<=l))j=0;else j=l<=+o[e+(b<<2)>>2];i[g+b>>0]=j<<31>>31;b=b+1|0}while((b|0)!=(v|0))}if(!d)break;else{a=a+(u<<2)|0;g=g+h|0;e=e+(s<<2)|0;f=f+(t<<2)|0}}return}q=v&-4;r=(q|0)<(v|0);n=j;while(1){m=0;do{l=+o[a+(m<<2)>>2];if(!(+o[c+(m<<2)>>2]<=l))d=0;else d=l<=+o[e+(m<<2)>>2];b=m|1;l=+o[a+(b<<2)>>2];if(!(+o[c+(b<<2)>>2]<=l))j=0;else j=l<=+o[e+(b<<2)>>2];i[g+m>>0]=d<<31>>31;i[g+b>>0]=j<<31>>31;f=m|2;l=+o[a+(f<<2)>>2];if(!(+o[c+(f<<2)>>2]<=l))d=0;else d=l<=+o[e+(f<<2)>>2];b=m|3;l=+o[a+(b<<2)>>2];if(!(+o[c+(b<<2)>>2]<=l))j=0;else j=l<=+o[e+(b<<2)>>2];i[g+f>>0]=d<<31>>31;i[g+b>>0]=j<<31>>31;m=m+4|0}while((m|0)<=(p|0));n=n+-1|0;if(r){b=q;do{l=+o[a+(b<<2)>>2];if(!(+o[c+(b<<2)>>2]<=l))j=0;else j=l<=+o[e+(b<<2)>>2];i[g+b>>0]=j<<31>>31;b=b+1|0}while((b|0)!=(v|0))}if(!n)break;else{a=a+(u<<2)|0;g=g+h|0;e=e+(s<<2)|0;c=c+(t<<2)|0}}return}function CV(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;v=k[j>>2]|0;j=k[j+4>>2]|0;u=b>>>3;t=d>>>3;s=f>>>3;if(!j)return;o=v+-4|0;if((v|0)<4){m=(v|0)>0;f=c;d=j;while(1){d=d+-1|0;if(m){b=0;do{l=+p[a+(b<<3)>>3];if(!(+p[f+(b<<3)>>3]<=l))j=0;else j=l<=+p[e+(b<<3)>>3];i[g+b>>0]=j<<31>>31;b=b+1|0}while((b|0)!=(v|0))}if(!d)break;else{a=a+(u<<3)|0;g=g+h|0;e=e+(s<<3)|0;f=f+(t<<3)|0}}return}q=v&-4;r=(q|0)<(v|0);n=j;while(1){m=0;do{l=+p[a+(m<<3)>>3];if(!(+p[c+(m<<3)>>3]<=l))d=0;else d=l<=+p[e+(m<<3)>>3];b=m|1;l=+p[a+(b<<3)>>3];if(!(+p[c+(b<<3)>>3]<=l))j=0;else j=l<=+p[e+(b<<3)>>3];i[g+m>>0]=d<<31>>31;i[g+b>>0]=j<<31>>31;f=m|2;l=+p[a+(f<<3)>>3];if(!(+p[c+(f<<3)>>3]<=l))d=0;else d=l<=+p[e+(f<<3)>>3];b=m|3;l=+p[a+(b<<3)>>3];if(!(+p[c+(b<<3)>>3]<=l))j=0;else j=l<=+p[e+(b<<3)>>3];i[g+f>>0]=d<<31>>31;i[g+b>>0]=j<<31>>31;m=m+4|0}while((m|0)<=(o|0));n=n+-1|0;if(r){b=q;do{l=+p[a+(b<<3)>>3];if(!(+p[c+(b<<3)>>3]<=l))j=0;else j=l<=+p[e+(b<<3)>>3];i[g+b>>0]=j<<31>>31;b=b+1|0}while((b|0)!=(v|0))}if(!n)break;else{a=a+(u<<3)|0;g=g+h|0;e=e+(s<<3)|0;c=c+(t<<3)|0}}return}function DV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+288|0;w=x+232|0;u=x+176|0;t=x+120|0;q=x+64|0;h=x+48|0;j=x+32|0;l=x+16|0;g=x;M1(w,a,0,1,0,0);M1(u,b,0,1,0,0);M1(t,c,0,1,0,0);k[q>>2]=1124007936;o=q+4|0;a=q+8|0;m=q+40|0;d=o;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[m>>2]=a;p=q+48|0;n=q+44|0;k[n>>2]=p;k[q+52>>2]=0;k[p>>2]=0;v=w+40|0;b=k[v>>2]|0;c=k[b+-4>>2]|0;s=t+40|0;d=k[s>>2]|0;a:do if((c|0)==(k[d+-4>>2]|0)){if((c|0)==2){if((k[b>>2]|0)!=(k[d>>2]|0)){f=9;break}if((k[b+4>>2]|0)!=(k[d+4>>2]|0)){f=9;break}}else if((c|0)>0){a=0;do{if((k[b+(a<<2)>>2]|0)!=(k[d+(a<<2)>>2]|0)){f=9;break a}a=a+1|0}while((a|0)<(c|0))}a=k[t>>2]|0;if((a^k[w>>2])&4088)f=9}else f=9;while(0);if((f|0)==9){k[h>>2]=0;a=h+4|0;k[a>>2]=0;b=ZT(64)|0;k[b>>2]=1;d=b+4|0;k[h>>2]=d;k[a>>2]=58;i[b+62>>0]=0;c=209894;e=d+58|0;do{i[d>>0]=i[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(e|0));Y8(-215,h,209953,208690,2096);k[a>>2]=0;k[h>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0);a=k[t>>2]|0}k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=w;k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=u;c=l+4|0;f=c+4|0;k[f>>2]=0;k[f+4>>2]=0;k[l>>2]=33619968;k[c>>2]=t;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=q;sU(h,j,l,g,a&4095,39968,0,0);c=q+36|0;a=k[c>>2]|0;if(a|0?(j=a+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;q=q+16|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[o>>2]|0)>0){b=k[m>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[n>>2]|0;if(!((a|0)==(p|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=t+36|0;a=k[c>>2]|0;if(a|0?(p=a+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[t+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;q=t+16|0;c=t+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[c>>2]|0)>0){b=k[s>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[t+44>>2]|0;if(!((a|0)==(t+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=u+36|0;a=k[c>>2]|0;if(a|0?(s=a+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[u+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;t=u+16|0;b=u+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[b>>2]|0)>0){c=k[u+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[u+44>>2]|0;if(!((a|0)==(u+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=w+36|0;a=k[c>>2]|0;if(a|0?(t=a+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[w+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;u=w+16|0;c=w+4|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[c>>2]|0)>0){b=k[v>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[w+44>>2]|0;if((a|0)==(w+48|0)|(a|0)==0){r=x;return}ggb(k[a+-4>>2]|0);r=x;return}function EV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+1072|0;x=y+32|0;v=y;m=k[a>>2]|0;l=m&7;m=m>>>3&511;w=m+1|0;if(!m){w=x+4|0;v=w+4|0;k[v>>2]=0;k[v+4>>2]=0;k[x>>2]=33619968;k[w>>2]=b;mY(a,x);r=y;return}u=k[40224+(l<<2)>>2]|0;if((l|0)==7){c=x+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[x>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=335726;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,x,209959,209965,94);k[c>>2]=0;k[x>>2]=0;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0)}g=a+4|0;d=k[g>>2]|0;if((d|0)>0)q=k[(k[a+44>>2]|0)+(d+-1<<2)>>2]|0;else q=0;p=1212424721>>>(k[a>>2]<<2&28)&15;j=(q+1023|0)/(q|0)|0;h=m+2|0;e=(h<<3)+16|0;s=x+8|0;k[x>>2]=s;t=x+4|0;k[t>>2]=1032;if(e>>>0>1032){while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[x>>2]=c}else c=s;k[t>>2]=e;o=c+(w<<2)+4+15&-16;n=o;k[c>>2]=a;f=a+40|0;e=0;while(1){a=b+(e*56|0)|0;G1(a,d,k[f>>2]|0,l);d=e+1|0;k[c+(d<<2)>>2]=a;if((e|0)>=(m|0))break;e=d;d=k[g>>2]|0}k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;k[v+16>>2]=0;k[v+20>>2]=0;k[v+24>>2]=0;k[v+28>>2]=0;z1(v,c,0,o,h);l=k[v+20>>2]|0;g=w>>>0<5?l:(j|0)<(l|0)?j:l;h=v+16|0;a=n+4|0;j=(l|0)>0;f=0;while(1){if(f>>>0>=(k[h>>2]|0)>>>0)break;a:do if(j){e=0;do{c=l-e|0;c=(g|0)<(c|0)?g:c;dh[u&255](k[o>>2]|0,a,c,w);e=e+g|0;b=(e|0)<(l|0);if(!b)break a;d=aa(c,q)|0;k[o>>2]=(k[o>>2]|0)+d;d=aa(c,p)|0;c=0;do{c=c+1|0;m=n+(c<<2)|0;k[m>>2]=(k[m>>2]|0)+d}while((c|0)!=(w|0))}while(b)}while(0);A1(v);f=f+1|0}c=k[x>>2]|0;if((c|0)!=(s|0)){if(c|0)ggb(c);k[x>>2]=s;k[t>>2]=1032}r=y;return}function FV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+80|0;o=p+16|0;m=p;do if((k[a>>2]&2031616|0)==65536){f=k[a+4>>2]|0;k[o>>2]=k[f>>2];j=o+4|0;a=f+4|0;k[j>>2]=k[a>>2];h=o+8|0;k[h>>2]=k[f+8>>2];k[o+12>>2]=k[f+12>>2];l=o+16|0;k[l>>2]=k[f+16>>2];k[o+20>>2]=k[f+20>>2];k[o+24>>2]=k[f+24>>2];k[o+28>>2]=k[f+28>>2];k[o+32>>2]=k[f+32>>2];c=k[f+36>>2]|0;k[o+36>>2]=c;d=o+40|0;k[d>>2]=h;h=o+48|0;g=o+44|0;k[g>>2]=h;k[o+52>>2]=0;k[h>>2]=0;if(c|0){h=c+12|0;k[h>>2]=(k[h>>2]|0)+1}if((k[a>>2]|0)<3){h=k[f+44>>2]|0;j=k[g>>2]|0;k[j>>2]=k[h>>2];k[j+4>>2]=k[h+4>>2];break}k[j>>2]=0;x1(o,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[f+40>>2]|0;e=k[d>>2]|0;d=k[f+44>>2]|0;c=k[g>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[h+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else{Q1(o,a,-1);l=o+16|0}while(0);if(k[l>>2]|0){g=o+4|0;d=k[g>>2]|0;if((d|0)<3)a=aa(k[o+12>>2]|0,k[o+8>>2]|0)|0;else{e=k[o+40>>2]|0;c=0;a=1;do{a=aa(k[e+(c<<2)>>2]|0,a)|0;c=c+1|0}while((c|0)!=(d|0))}if(a){if(((k[b>>2]|0)<0?!(G2(b)|0):0)?(j=S1(b,-1)|0,(j|0)!=(k[o>>2]&7|0)):0){k[m>>2]=0;a=m+4|0;k[a>>2]=0;c=ZT(64)|0;k[c>>2]=1;d=c+4|0;k[m>>2]=d;k[a>>2]=58;i[c+62>>0]=0;e=210031;f=d+58|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,m,209959,209965,187);k[a>>2]=0;k[m>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0)}d=k[o>>2]|0;c=d&7;d=d>>>3&511;c2(b,d+1|0,1,c,-1,0,0);e=o+40|0;a=0;while(1){P1(b,k[g>>2]|0,k[e>>2]|0,c,a,0,0);if((a|0)<(d|0))a=a+1|0;else break}k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;B2(b,m);EV(o,k[m>>2]|0);zF(m)}else n=16}else n=16;if((n|0)==16)b2(b);d=o+36|0;a=k[d>>2]|0;if(a|0?(m=a+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[o+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;d=o+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[d>>2]|0)>0){c=k[o+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[o+44>>2]|0;if((a|0)==(o+48|0)|(a|0)==0){r=p;return}ggb(k[a+-4>>2]|0);r=p;return}function GV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+1152|0;z=A+1096|0;y=A+32|0;x=A;if(!((a|0)!=0&(b|0)!=0)){d=z+4|0;e=ZT(16)|0;k[e>>2]=1;h=e+4|0;k[z>>2]=h;k[d>>2]=11;i[e+15>>0]=0;j=210090;m=h+11|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));Y8(-215,z,210102,209965,202);k[d>>2]=0;k[z>>2]=0;w=k[e>>2]|0;k[e>>2]=w+-1;if((w|0)==1)ggb(k[e+-4>>2]|0)}v=k[a>>2]&7;s=(b|0)==0;if(!s){d=a+40|0;p=z+4|0;f=1;n=0;o=0;while(1){l=a+(o*56|0)|0;g=k[a+(o*56|0)+40>>2]|0;h=k[g+-4>>2]|0;j=k[d>>2]|0;a:do if((h|0)==(k[j+-4>>2]|0)){if((h|0)==2){if((k[g>>2]|0)!=(k[j>>2]|0)){q=15;break}if((k[g+4>>2]|0)!=(k[j+4>>2]|0)){q=15;break}}else if((h|0)>0){e=0;do{if((k[g+(e<<2)>>2]|0)!=(k[j+(e<<2)>>2]|0)){q=15;break a}e=e+1|0}while((e|0)<(h|0))}e=k[l>>2]|0;if((e&7|0)!=(v|0))q=15}else q=15;while(0);if((q|0)==15){q=0;e=ZT(56)|0;k[e>>2]=1;h=e+4|0;k[z>>2]=h;k[p>>2]=50;i[e+54>>0]=0;j=210108;m=h+50|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));Y8(-215,z,210102,209965,211);k[p>>2]=0;k[z>>2]=0;w=k[e>>2]|0;k[e>>2]=w+-1;if((w|0)==1)ggb(k[e+-4>>2]|0);e=k[l>>2]|0}f=f&(e&4088|0)==0;e=e>>>3&511;g=n+1+e|0;o=o+1|0;if(o>>>0>=b>>>0)break;else n=g}if((n+e|0)>>>0<512){n=f;w=g}else q=20}else{f=1;g=0;q=20}if((q|0)==20){d=z+4|0;e=ZT(32)|0;k[e>>2]=1;h=e+4|0;k[z>>2]=h;k[d>>2]=25;i[e+29>>0]=0;j=210159;m=h+25|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));Y8(-215,z,210102,209965,216);k[d>>2]=0;k[z>>2]=0;w=k[e>>2]|0;k[e>>2]=w+-1;if((w|0)==1)ggb(k[e+-4>>2]|0);n=f;w=g;d=a+40|0}P1(c,k[a+4>>2]|0,k[d>>2]|0,(w<<3)+-8|v,-1,0,0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[z>>2]=k[h>>2];m=z+4|0;e=h+4|0;k[m>>2]=k[e>>2];u=z+8|0;k[u>>2]=k[h+8>>2];k[z+12>>2]=k[h+12>>2];k[z+16>>2]=k[h+16>>2];k[z+20>>2]=k[h+20>>2];k[z+24>>2]=k[h+24>>2];k[z+28>>2]=k[h+28>>2];k[z+32>>2]=k[h+32>>2];d=k[h+36>>2]|0;k[z+36>>2]=d;f=z+40|0;k[f>>2]=u;u=z+48|0;j=z+44|0;k[j>>2]=u;k[z+52>>2]=0;k[u>>2]=0;if(d|0){u=d+12|0;k[u>>2]=(k[u>>2]|0)+1}if((k[e>>2]|0)<3){t=k[h+44>>2]|0;u=k[j>>2]|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];break}k[m>>2]=0;x1(z,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;e=k[j>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else Q1(z,c,-1);while(0);do if((b|0)!=1){if(!n){f=w<<1;j=y+8|0;k[y>>2]=j;l=y+4|0;k[l>>2]=264;if(f>>>0>264){e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[y>>2]=d}else d=j;k[l>>2]=f;if(!s){f=0;g=0;while(1){h=(k[a+(g*56|0)>>2]|0)>>>3&511;e=0;while(1){v=e+f|0;x=v<<1;k[d+(x<<2)>>2]=v;k[d+((x|1)<<2)>>2]=v;if((e|0)==(h|0))break;else e=e+1|0}g=g+1|0;if((g|0)==(b|0))break;else f=f+1+h|0}}HV(a,b,z,1,d,w);d=k[y>>2]|0;if((d|0)!=(j|0)){if(d|0)ggb(d);k[y>>2]=j;k[l>>2]=264}break}d=k[z+4>>2]|0;if((d|0)>0)b=k[(k[z+44>>2]|0)+(d+-1<<2)>>2]|0;else b=0;c=1212424721>>>(k[z>>2]<<2&28)&15;g=((b+1023|0)>>>0)/(b>>>0)|0;f=w+1|0;e=(f<<3)+16|0;t=y+8|0;k[y>>2]=t;u=y+4|0;k[u>>2]=1032;if(e>>>0>1032){while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[y>>2]=d}else d=t;k[u>>2]=e;s=d+(w<<2)+4+15&-16;p=s;k[d>>2]=z;h=(w|0)>0;if(h){e=0;do{q=e;e=e+1|0;k[d+(e<<2)>>2]=a+(q*56|0)}while((e|0)!=(w|0))};k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;k[x+16>>2]=0;k[x+20>>2]=0;k[x+24>>2]=0;k[x+28>>2]=0;z1(x,d,0,s,f);q=k[x+20>>2]|0;o=(w|0)<5?q:(g|0)<(q|0)?g:q;j=k[40256+(v<<2)>>2]|0;l=x+16|0;m=p+4|0;n=(q|0)>0;b:do if(h){g=0;while(1){if(g>>>0>=(k[l>>2]|0)>>>0)break b;c:do if(n){f=0;do{d=q-f|0;d=(o|0)<(d|0)?o:d;dh[j&255](m,k[s>>2]|0,d,w);f=f+o|0;h=(f|0)<(q|0);if(!h)break c;e=aa(d,b)|0;k[s>>2]=(k[s>>2]|0)+e;e=aa(d,c)|0;d=0;do{d=d+1|0;a=p+(d<<2)|0;k[a>>2]=(k[a>>2]|0)+e}while((d|0)!=(w|0))}while(h)}while(0);A1(x);g=g+1|0}}else{e=0;while(1){if(e>>>0>=(k[l>>2]|0)>>>0)break b;d:do if(n){d=0;while(1){f=q-d|0;f=(o|0)<(f|0)?o:f;dh[j&255](m,k[s>>2]|0,f,w);d=d+o|0;if((d|0)>=(q|0))break d;a=aa(f,b)|0;k[s>>2]=(k[s>>2]|0)+a}}while(0);A1(x);e=e+1|0}}while(0);d=k[y>>2]|0;if((d|0)!=(t|0)){if(d|0)ggb(d);k[y>>2]=t;k[u>>2]=1032}}else{x=y+4|0;w=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[y>>2]=33619968;k[x>>2]=z;mY(a,y)}while(0);f=z+36|0;d=k[f>>2]|0;if(d|0?(x=d+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[z+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;y=z+16|0;e=z+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[e>>2]|0)>0){f=k[z+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[z+44>>2]|0;if((d|0)==(z+48|0)|(d|0)==0){r=A;return}ggb(k[d+-4>>2]|0);r=A;return}function HV(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;K=r;r=r+1072|0;J=K+32|0;I=K;if(!f){r=K;return}w=(d|0)!=0;if(!((a|0)!=0&(b|0)!=0&(c|0)!=0&w&(e|0)!=0)){g=J+4|0;h=ZT(68)|0;k[h>>2]=1;m=h+4|0;k[J>>2]=m;k[g>>2]=60;i[h+64>>0]=0;n=210185;o=m+60|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,J,210246,209965,439);k[g>>2]=0;k[J>>2]=0;H=k[h>>2]|0;k[h>>2]=H+-1;if((H|0)==1)ggb(k[h+-4>>2]|0)}x=k[c>>2]|0;z=1212424721>>>(x<<2&28)&15;x=x&7;v=d+b|0;h=(v<<3)+8+(f<<5)|0;G=J+8|0;k[J>>2]=G;H=J+4|0;k[H>>2]=1032;if(h>>>0>1032){while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[J>>2]=g}else g=G;k[H>>2]=h;A=g+(b<<2)+(d<<2)|0;B=A+(b<<2)+(d<<2)+4|0;C=B+(f<<2)|0;D=C+(f<<2)|0;E=D+(f<<2<<2)|0;F=E+(f<<2)|0;u=(b|0)==0;if(!u){h=0;do{k[g+(h<<2)>>2]=a+(h*56|0);h=h+1|0}while((h|0)!=(b|0))}if(d|0){h=0;do{k[g+(h+b<<2)>>2]=c+(h*56|0);h=h+1|0}while((h|0)!=(d|0))}k[A+(v<<2)>>2]=0;s=I+4|0;t=I+4|0;q=0;do{p=q<<1;h=k[e+(p<<2)>>2]|0;p=k[e+((p|1)<<2)>>2]|0;if((h|0)>-1){a:do if(!u){j=0;while(1){l=k[a+(j*56|0)>>2]|0;m=l>>>3&511;if((h|0)<=(m|0))break;h=h+-1-m|0;j=j+1|0;if(j>>>0>=b>>>0){y=21;break a}}if((l&7|0)!=(x|0))y=21}else{j=0;y=21}while(0);if((y|0)==21){y=0;k[I>>2]=0;k[s>>2]=0;l=ZT(44)|0;k[l>>2]=1;m=l+4|0;k[I>>2]=m;k[s>>2]=36;i[l+40>>0]=0;n=210258;o=m+36|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,I,210246,209965,466);k[s>>2]=0;k[I>>2]=0;o=k[l>>2]|0;k[l>>2]=o+-1;if((o|0)==1)ggb(k[l+-4>>2]|0)}o=q<<2;k[D+(o<<2)>>2]=j;n=aa(h,z)|0;k[D+((o|1)<<2)>>2]=n;k[E+(q<<2)>>2]=((k[a+(j*56|0)>>2]|0)>>>3&511)+1}else{o=q<<2;k[D+(o<<2)>>2]=v;k[D+((o|1)<<2)>>2]=0;k[E+(q<<2)>>2]=0}b:do if(w){j=p;h=0;while(1){l=k[c+(h*56|0)>>2]|0;m=l>>>3&511;if((j|0)<=(m|0))break;j=j+-1-m|0;h=h+1|0;if(h>>>0>=d>>>0){y=30;break b}}if(!((j|0)>-1&(l&7|0)==(x|0)))y=30}else{j=p;h=0;y=30}while(0);if((y|0)==30){y=0;k[I>>2]=0;k[t>>2]=0;l=ZT(52)|0;k[l>>2]=1;m=l+4|0;k[I>>2]=m;k[t>>2]=47;i[l+51>>0]=0;n=210295;o=m+47|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,I,210246,209965,479);k[t>>2]=0;k[I>>2]=0;p=k[l>>2]|0;k[l>>2]=p+-1;if((p|0)==1)ggb(k[l+-4>>2]|0)}p=q<<2;k[D+((p|2)<<2)>>2]=h+b;o=aa(j,z)|0;k[D+((p|3)<<2)>>2]=o;k[F+(q<<2)>>2]=((k[c+(h*56|0)>>2]|0)>>>3&511)+1;q=q+1|0}while(q>>>0<f>>>0);k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;k[I+16>>2]=0;k[I+20>>2]=0;k[I+24>>2]=0;k[I+28>>2]=0;z1(I,g,0,A,v);q=k[I+20>>2]|0;p=((z+1023|0)>>>0)/(z>>>0)|0;p=(p|0)<(q|0)?p:q;m=k[40288+(x<<2)>>2]|0;n=I+16|0;o=(q|0)>0;l=aa(p,z)|0;j=0;while(1){if(j>>>0<(k[n>>2]|0)>>>0)g=0;else break;do{z=g<<2;k[B+(g<<2)>>2]=(k[A+(k[D+(z<<2)>>2]<<2)>>2]|0)+(k[D+((z|1)<<2)>>2]|0);k[C+(g<<2)>>2]=(k[A+(k[D+((z|2)<<2)>>2]<<2)>>2]|0)+(k[D+((z|3)<<2)>>2]|0);g=g+1|0}while((g|0)!=(f|0));c:do if(o){g=0;d:while(1){z=q-g|0;Lg[m&255](B,E,C,F,(p|0)<(z|0)?p:z,f);g=g+p|0;if((g|0)<(q|0))h=0;else break c;while(1){z=aa(l,k[E+(h<<2)>>2]|0)|0;y=B+(h<<2)|0;k[y>>2]=(k[y>>2]|0)+z;y=aa(l,k[F+(h<<2)>>2]|0)|0;z=C+(h<<2)|0;k[z>>2]=(k[z>>2]|0)+y;h=h+1|0;if((h|0)==(f|0))continue d}}}while(0);A1(I);j=j+1|0}g=k[J>>2]|0;if((g|0)!=(G|0)){if(g|0)ggb(g);k[J>>2]=G;k[H>>2]=1032}r=K;return}function IV(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;if((f|0)<=0)return;s=e+-2|0;if((e|0)<2){if((e|0)==1)g=0;else return;do{e=k[a+(g<<2)>>2]|0;if(!e)e=0;else e=i[e>>0]|0;i[k[c+(g<<2)>>2]>>0]=e;g=g+1|0}while((g|0)!=(f|0));return}r=e&-2;if((r|0)<(e|0))o=0;else{n=0;do{g=k[a+(n<<2)>>2]|0;e=k[c+(n<<2)>>2]|0;j=k[b+(n<<2)>>2]|0;o=k[d+(n<<2)>>2]|0;if(!g){h=o<<1;g=0;while(1){i[e+o>>0]=0;i[e>>0]=0;g=g+2|0;if((g|0)>(s|0))break;else e=e+h|0}}else{l=j<<1;m=o<<1;h=0;while(1){r=i[g+j>>0]|0;i[e>>0]=i[g>>0]|0;i[e+o>>0]=r;h=h+2|0;if((h|0)>(s|0))break;else{g=g+l|0;e=e+m|0}}}n=n+1|0}while((n|0)!=(f|0));return}do{j=k[a+(o<<2)>>2]|0;p=k[c+(o<<2)>>2]|0;l=k[b+(o<<2)>>2]|0;q=k[d+(o<<2)>>2]|0;if(!j){h=q<<1;e=p;g=0;while(1){i[e+q>>0]=0;i[e>>0]=0;g=g+2|0;if((g|0)>(s|0))break;else e=e+h|0}q=p+(aa(q,r)|0)|0;i[q>>0]=0}else{m=l<<1;n=q<<1;e=j;g=p;h=0;while(1){t=i[e+l>>0]|0;i[g>>0]=i[e>>0]|0;i[g+q>>0]=t;h=h+2|0;if((h|0)>(s|0))break;else{e=e+m|0;g=g+n|0}}t=p+(aa(q,r)|0)|0;q=j+(aa(l,r)|0)|0;i[t>>0]=i[q>>0]|0}o=o+1|0}while((o|0)!=(f|0));return}function JV(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((f|0)<=0)return;t=e+-2|0;if((e|0)<2){if((e|0)==1)g=0;else return;do{e=k[a+(g<<2)>>2]|0;if(!e)e=0;else e=j[e>>1]|0;j[k[c+(g<<2)>>2]>>1]=e;g=g+1|0}while((g|0)!=(f|0));return}r=t>>>1;s=(r<<2)+4|0;if(((r<<1)+2|0)<(e|0))p=0;else{n=0;do{g=k[a+(n<<2)>>2]|0;e=k[c+(n<<2)>>2]|0;i=k[b+(n<<2)>>2]|0;o=k[d+(n<<2)>>2]|0;if(!g){h=o<<1;g=0;while(1){j[e+(o<<1)>>1]=0;j[e>>1]=0;g=g+2|0;if((g|0)>(t|0))break;else e=e+(h<<1)|0}}else{l=i<<1;m=o<<1;h=0;while(1){s=j[g+(i<<1)>>1]|0;j[e>>1]=j[g>>1]|0;j[e+(o<<1)>>1]=s;h=h+2|0;if((h|0)>(t|0))break;else{g=g+(l<<1)|0;e=e+(m<<1)|0}}}n=n+1|0}while((n|0)!=(f|0));return}do{i=k[a+(p<<2)>>2]|0;q=k[c+(p<<2)>>2]|0;l=k[b+(p<<2)>>2]|0;r=k[d+(p<<2)>>2]|0;if(!i){h=r<<1;e=q;g=0;while(1){j[e+(r<<1)>>1]=0;j[e>>1]=0;g=g+2|0;if((g|0)>(t|0))break;else e=e+(h<<1)|0}r=q+(aa(r,s)|0)|0;j[r>>1]=0}else{m=l<<1;n=r<<1;o=aa(l,s)|0;e=i;g=q;h=0;while(1){u=j[e+(l<<1)>>1]|0;j[g>>1]=j[e>>1]|0;j[g+(r<<1)>>1]=u;h=h+2|0;if((h|0)>(t|0))break;else{e=e+(m<<1)|0;g=g+(n<<1)|0}}u=q+(aa(r,s)|0)|0;j[u>>1]=j[i+o>>1]|0}p=p+1|0}while((p|0)!=(f|0));return}function KV(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;if((f|0)<=0)return;s=e+-2|0;if((e|0)<2){if((e|0)==1)g=0;else return;do{e=k[a+(g<<2)>>2]|0;if(!e)e=0;else e=k[e>>2]|0;k[k[c+(g<<2)>>2]>>2]=e;g=g+1|0}while((g|0)!=(f|0));return}q=s>>>1;r=(q<<3)+8|0;if(((q<<1)+2|0)<(e|0))o=0;else{m=0;do{g=k[a+(m<<2)>>2]|0;e=k[c+(m<<2)>>2]|0;i=k[b+(m<<2)>>2]|0;n=k[d+(m<<2)>>2]|0;if(!g){h=n<<1;g=0;while(1){k[e+(n<<2)>>2]=0;k[e>>2]=0;g=g+2|0;if((g|0)>(s|0))break;else e=e+(h<<2)|0}}else{j=i<<1;l=n<<1;h=0;while(1){r=k[g+(i<<2)>>2]|0;k[e>>2]=k[g>>2];k[e+(n<<2)>>2]=r;h=h+2|0;if((h|0)>(s|0))break;else{g=g+(j<<2)|0;e=e+(l<<2)|0}}}m=m+1|0}while((m|0)!=(f|0));return}do{i=k[a+(o<<2)>>2]|0;p=k[c+(o<<2)>>2]|0;j=k[b+(o<<2)>>2]|0;q=k[d+(o<<2)>>2]|0;if(!i){h=q<<1;e=p;g=0;while(1){k[e+(q<<2)>>2]=0;k[e>>2]=0;g=g+2|0;if((g|0)>(s|0))break;else e=e+(h<<2)|0}q=p+(aa(q,r)|0)|0;k[q>>2]=0}else{l=j<<1;m=q<<1;n=aa(j,r)|0;e=i;g=p;h=0;while(1){t=k[e+(j<<2)>>2]|0;k[g>>2]=k[e>>2];k[g+(q<<2)>>2]=t;h=h+2|0;if((h|0)>(s|0))break;else{e=e+(l<<2)|0;g=g+(m<<2)|0}}t=p+(aa(q,r)|0)|0;k[t>>2]=k[i+n>>2]}o=o+1|0}while((o|0)!=(f|0));return}function LV(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if((f|0)<=0)return;s=e+-2|0;if((e|0)<2){if((e|0)==1)h=0;else return;do{e=k[a+(h<<2)>>2]|0;if(!e){e=0;g=0}else{g=e;e=k[g>>2]|0;g=k[g+4>>2]|0}s=k[c+(h<<2)>>2]|0;k[s>>2]=e;k[s+4>>2]=g;h=h+1|0}while((h|0)!=(f|0));return}q=s>>>1;r=(q<<4)+16|0;if(((q<<1)+2|0)<(e|0))o=0;else{m=0;do{g=k[a+(m<<2)>>2]|0;e=k[c+(m<<2)>>2]|0;i=k[b+(m<<2)>>2]|0;n=k[d+(m<<2)>>2]|0;if(!g){h=n<<1;g=0;while(1){r=e+(n<<3)|0;k[r>>2]=0;k[r+4>>2]=0;r=e;k[r>>2]=0;k[r+4>>2]=0;g=g+2|0;if((g|0)>(s|0))break;else e=e+(h<<3)|0}}else{j=i<<1;l=n<<1;h=0;while(1){t=g;o=k[t+4>>2]|0;q=g+(i<<3)|0;p=k[q>>2]|0;q=k[q+4>>2]|0;r=e;k[r>>2]=k[t>>2];k[r+4>>2]=o;r=e+(n<<3)|0;k[r>>2]=p;k[r+4>>2]=q;h=h+2|0;if((h|0)>(s|0))break;else{g=g+(j<<3)|0;e=e+(l<<3)|0}}}m=m+1|0}while((m|0)!=(f|0));return}do{i=k[a+(o<<2)>>2]|0;p=k[c+(o<<2)>>2]|0;j=k[b+(o<<2)>>2]|0;q=k[d+(o<<2)>>2]|0;if(!i){h=q<<1;e=p;g=0;while(1){t=e+(q<<3)|0;k[t>>2]=0;k[t+4>>2]=0;t=e;k[t>>2]=0;k[t+4>>2]=0;g=g+2|0;if((g|0)>(s|0))break;else e=e+(h<<3)|0}t=p+(aa(q,r)|0)|0;k[t>>2]=0;k[t+4>>2]=0}else{l=j<<1;m=q<<1;n=aa(j,r)|0;e=i;g=p;h=0;while(1){x=e;w=k[x+4>>2]|0;u=e+(j<<3)|0;v=k[u>>2]|0;u=k[u+4>>2]|0;t=g;k[t>>2]=k[x>>2];k[t+4>>2]=w;t=g+(q<<3)|0;k[t>>2]=v;k[t+4>>2]=u;h=h+2|0;if((h|0)>(s|0))break;else{e=e+(l<<3)|0;g=g+(m<<3)|0}}x=p+(aa(q,r)|0)|0;v=i+n|0;w=k[v+4>>2]|0;k[x>>2]=k[v>>2];k[x+4>>2]=w}o=o+1|0}while((o|0)!=(f|0));return}function MV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+1520|0;G=I+56|0;H=I;if(!c){r=I;return}d=k[a>>2]&2031616;a:do if((d|0)>=327680)if((d|0)<720896)switch(d|0){case 327680:{l=0;break a}default:{e=3;break a}}else switch(d|0){case 720896:{l=0;break a}default:{e=3;break a}}else switch(d|0){case 262144:{l=0;break}default:e=3}while(0);if((e|0)==3)l=1;d=k[b>>2]&2031616;b:do if((d|0)>=327680)if((d|0)<720896)switch(d|0){case 327680:{C=0;break b}default:{e=5;break b}}else switch(d|0){case 720896:{C=0;break b}default:{e=5;break b}}else switch(d|0){case 262144:{C=0;break}default:e=5}while(0);if((e|0)==5)C=1;if(l)E=1;else E=F2(a)|0;if(C)F=1;else F=F2(b)|0;j=(E|0)>0;B=(F|0)>0;if(!(j&B)){d=G+4|0;e=ZT(28)|0;k[e>>2]=1;f=e+4|0;k[G>>2]=f;k[d>>2]=20;i[e+24>>0]=0;g=210343;h=f+20|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,G,210246,209965,629);k[d>>2]=0;k[G>>2]=0;D=k[e>>2]|0;k[e>>2]=D+-1;if((D|0)==1)ggb(k[e+-4>>2]|0)}NV(G,F+E|0);D=k[G>>2]|0;c:do if(j){m=a+4|0;u=H+4|0;n=H+8|0;o=H+12|0;v=H+16|0;p=H+20|0;q=H+24|0;s=H+28|0;w=H+32|0;x=H+36|0;y=H+40|0;z=H+48|0;A=H+44|0;t=H+52|0;if(l)j=0;else{f=0;while(1){Q1(H,a,f);KG(D+(f*56|0)|0,H)|0;d=k[x>>2]|0;if(d|0?(s=d+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){e=k[x>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[w>>2]|0;if(!d){d=B1()|0;e=k[x>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[x>>2]=0}k[x>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[u>>2]|0)>0){e=k[y>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[u>>2]|0))}d=k[A>>2]|0;if(!((d|0)==(z|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=f+1|0;if((f|0)>=(E|0))break c}}do{do if((k[a>>2]&2031616|0)==65536){f=k[m>>2]|0;k[H>>2]=k[f>>2];d=f+4|0;k[u>>2]=k[d>>2];k[n>>2]=k[f+8>>2];k[o>>2]=k[f+12>>2];k[v>>2]=k[f+16>>2];k[p>>2]=k[f+20>>2];k[q>>2]=k[f+24>>2];k[s>>2]=k[f+28>>2];k[w>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[x>>2]=e;k[y>>2]=n;k[A>>2]=z;k[t>>2]=0;k[z>>2]=0;if(e|0){l=e+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[d>>2]|0)<3){h=k[f+44>>2]|0;l=k[A>>2]|0;k[l>>2]=k[h>>2];k[l+4>>2]=k[h+4>>2];break}k[u>>2]=0;x1(H,k[d>>2]|0,0,0,0);if((k[u>>2]|0)>0){g=k[f+40>>2]|0;h=k[y>>2]|0;e=k[f+44>>2]|0;f=k[A>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[g+(d<<2)>>2];k[f+(d<<2)>>2]=k[e+(d<<2)>>2];d=d+1|0}while((d|0)<(k[u>>2]|0))}}else Q1(H,a,-1);while(0);KG(D+(j*56|0)|0,H)|0;d=k[x>>2]|0;if(d|0?(h=d+12|0,l=k[h>>2]|0,k[h>>2]=l+-1,(l|0)==1):0){e=k[x>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[w>>2]|0;if(!d){d=B1()|0;e=k[x>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[x>>2]=0}k[x>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[u>>2]|0)>0){e=k[y>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[u>>2]|0))}d=k[A>>2]|0;if(!((d|0)==(z|0)|(d|0)==0))ggb(k[d+-4>>2]|0);j=j+1|0}while((j|0)<(E|0))}while(0);d:do if(B){l=b+4|0;t=H+4|0;m=H+8|0;n=H+12|0;u=H+16|0;o=H+20|0;p=H+24|0;q=H+28|0;v=H+32|0;w=H+36|0;x=H+40|0;y=H+48|0;z=H+44|0;s=H+52|0;if(C)j=0;else{f=0;while(1){Q1(H,b,f);KG(D+((f+E|0)*56|0)|0,H)|0;d=k[w>>2]|0;if(d|0?(a=d+12|0,C=k[a>>2]|0,k[a>>2]=C+-1,(C|0)==1):0){e=k[w>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[v>>2]|0;if(!d){d=B1()|0;e=k[w>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[w>>2]=0}k[w>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[t>>2]|0)>0){e=k[x>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[t>>2]|0))}d=k[z>>2]|0;if(!((d|0)==(y|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=f+1|0;if((f|0)>=(F|0))break d}}do{do if((k[b>>2]&2031616|0)==65536){f=k[l>>2]|0;k[H>>2]=k[f>>2];d=f+4|0;k[t>>2]=k[d>>2];k[m>>2]=k[f+8>>2];k[n>>2]=k[f+12>>2];k[u>>2]=k[f+16>>2];k[o>>2]=k[f+20>>2];k[p>>2]=k[f+24>>2];k[q>>2]=k[f+28>>2];k[v>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[w>>2]=e;k[x>>2]=m;k[z>>2]=y;k[s>>2]=0;k[y>>2]=0;if(e|0){C=e+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[d>>2]|0)<3){a=k[f+44>>2]|0;C=k[z>>2]|0;k[C>>2]=k[a>>2];k[C+4>>2]=k[a+4>>2];break}k[t>>2]=0;x1(H,k[d>>2]|0,0,0,0);if((k[t>>2]|0)>0){g=k[f+40>>2]|0;h=k[x>>2]|0;e=k[f+44>>2]|0;f=k[z>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[g+(d<<2)>>2];k[f+(d<<2)>>2]=k[e+(d<<2)>>2];d=d+1|0}while((d|0)<(k[t>>2]|0))}}else Q1(H,b,-1);while(0);KG(D+((j+E|0)*56|0)|0,H)|0;d=k[w>>2]|0;if(d|0?(a=d+12|0,C=k[a>>2]|0,k[a>>2]=C+-1,(C|0)==1):0){e=k[w>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[v>>2]|0;if(!d){d=B1()|0;e=k[w>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[w>>2]=0}k[w>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[t>>2]|0)>0){e=k[x>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[t>>2]|0))}d=k[z>>2]|0;if(!((d|0)==(y|0)|(d|0)==0))ggb(k[d+-4>>2]|0);j=j+1|0}while((j|0)<(F|0))}while(0);HV(D,E,D+(E*56|0)|0,F,c,1);OV(G);r=I;return}function NV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=0;do{k[a+8+(c*56|0)>>2]=1124007936;d=a+8+(c*56|0)+8|0;e=a+8+(c*56|0)+40|0;i=a+8+(c*56|0)+4|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[e>>2]=d;j=a+8+(c*56|0)+48|0;k[a+8+(c*56|0)+44>>2]=j;k[a+8+(c*56|0)+52>>2]=0;k[j>>2]=0;c=c+1|0}while((c|0)!=26);k[a>>2]=a+8;h=a+4|0;k[h>>2]=26;if(b>>>0<=26){k[h>>2]=b;return}PV(a);c=b*56|0;c=b>>>0>76695844|c>>>0>4294967291?-1:c+4|0;while(1){d=fgb(c)|0;if(d|0)break;j=k[207666]|0;k[207666]=j+0;Qh[j&7]()}k[d>>2]=b;c=d+4|0;d=c+(b*56|0)|0;e=c;do{k[e>>2]=1124007936;f=e+8|0;g=e+40|0;i=e+4|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[g>>2]=f;j=e+48|0;k[e+44>>2]=j;k[e+52>>2]=0;k[j>>2]=0;e=e+56|0}while((e|0)!=(d|0));k[a>>2]=c;k[h>>2]=b;return}function OV(a){a=a|0;var b=0,c=0,d=0,e=0;PV(a);e=a+8|0;d=a+1464|0;do{c=d+-20|0;a=k[c>>2]|0;if(a|0?(a=a+12|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[d+-24>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;c=d+-40|0;b=d+-52|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[b>>2]|0)>0){c=k[d+-16>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[d+-12>>2]|0;if(!((a|0)==(d+-8|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=d+-56|0}while((d|0)!=(e|0));return}function PV(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;f=k[a>>2]|0;g=a+8|0;if((f|0)==(g|0))return;if(f|0){h=f+-4|0;b=k[h>>2]|0;if(b|0){e=f+(b*56|0)|0;do{d=e+-20|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[e+-24>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=e+-40|0;c=e+-52|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[e+-16>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[e+-12>>2]|0;if(!((b|0)==(e+-8|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=e+-56|0}while((e|0)!=(f|0))}ggb(h)}k[a>>2]=g;k[a+4>>2]=26;return}function QV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+192|0;s=v+176|0;u=v+120|0;t=v+64|0;j=v+48|0;p=v+32|0;l=v+16|0;m=v;q=S1(a,-1)|0;n=q&7;if(!((c|0)>-1?(q>>>3&511|0)>=(c|0):0)){d=s+4|0;e=ZT(28)|0;k[e>>2]=1;f=e+4|0;k[s>>2]=f;k[d>>2]=20;i[e+24>>0]=0;g=210409;h=f+20|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,s,210430,209965,671);k[d>>2]=0;k[s>>2]=0;q=k[e>>2]|0;k[e>>2]=q+-1;if((q|0)==1)ggb(k[e+-4>>2]|0)}k[s>>2]=c;k[s+4>>2]=0;d=(n9(c9()|0)|0)+16|0;e=k[d>>2]|0;if((e|0)>=0){if((e|0?(a2(a)|0)<3:0)?(k[b>>2]&2031616|0)==655360:0){A2(u,a);q=u+4|0;o=u+32|0;P1(b,k[q>>2]|0,k[o>>2]|0,n,-1,0,0);A2(t,b);RV(p,u);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=17498112;k[j+4>>2]=p;RV(m,t);g=l+4|0;n=g+4|0;k[n>>2]=0;k[n+4>>2]=0;k[l>>2]=1124794368;k[g>>2]=m;MV(j,l,s);g=k[m>>2]|0;if(g|0){h=m+4|0;while(1){a=k[h>>2]|0;if((a|0)==(g|0))break;k[h>>2]=a+-48;f=a+-24|0;d=k[f>>2]|0;if(d|0?(n=d+8|0,s=k[n>>2]|0,k[n>>2]=s+-1,(s|0)==1):0){s=k[f>>2]|0;n=k[s+4>>2]|0;jh[k[(k[n>>2]|0)+16>>2]&1023](n,s);k[f>>2]=0}e=a+-44|0;if((k[e>>2]|0)>0){c=k[a+-16>>2]|0;d=0;do{k[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}k[f>>2]=0;d=k[a+-12>>2]|0;if((d|0)==(a+-8|0)|(d|0)==0)continue;ggb(k[d+-4>>2]|0)}ggb(k[m>>2]|0)}g=k[p>>2]|0;if(g|0){h=p+4|0;while(1){a=k[h>>2]|0;if((a|0)==(g|0))break;k[h>>2]=a+-48;f=a+-24|0;d=k[f>>2]|0;if(d|0?(n=d+8|0,s=k[n>>2]|0,k[n>>2]=s+-1,(s|0)==1):0){s=k[f>>2]|0;n=k[s+4>>2]|0;jh[k[(k[n>>2]|0)+16>>2]&1023](n,s);k[f>>2]=0}e=a+-44|0;if((k[e>>2]|0)>0){c=k[a+-16>>2]|0;d=0;do{k[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}k[f>>2]=0;d=k[a+-12>>2]|0;if((d|0)==(a+-8|0)|(d|0)==0)continue;ggb(k[d+-4>>2]|0)}ggb(k[p>>2]|0)}f=t+24|0;d=k[f>>2]|0;if(d|0?(p=d+8|0,s=k[p>>2]|0,k[p>>2]=s+-1,(s|0)==1):0){s=k[f>>2]|0;p=k[s+4>>2]|0;jh[k[(k[p>>2]|0)+16>>2]&1023](p,s);k[f>>2]=0}e=t+4|0;if((k[e>>2]|0)>0){c=k[t+32>>2]|0;d=0;do{k[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}k[f>>2]=0;d=k[t+36>>2]|0;if(!((d|0)==(t+40|0)|(d|0)==0))ggb(k[d+-4>>2]|0);c=u+24|0;d=k[c>>2]|0;if(d|0?(s=d+8|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){t=k[c>>2]|0;s=k[t+4>>2]|0;jh[k[(k[s>>2]|0)+16>>2]&1023](s,t);k[c>>2]=0}if((k[q>>2]|0)>0){e=k[o>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[q>>2]|0))}k[c>>2]=0;d=k[u+36>>2]|0;if(!((d|0)==(u+40|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=v;return}}else k[d>>2]=0;do if((k[a>>2]&2031616|0)==65536){c=k[a+4>>2]|0;k[u>>2]=k[c>>2];j=u+4|0;d=c+4|0;k[j>>2]=k[d>>2];q=u+8|0;k[q>>2]=k[c+8>>2];k[u+12>>2]=k[c+12>>2];k[u+16>>2]=k[c+16>>2];k[u+20>>2]=k[c+20>>2];k[u+24>>2]=k[c+24>>2];k[u+28>>2]=k[c+28>>2];k[u+32>>2]=k[c+32>>2];e=k[c+36>>2]|0;k[u+36>>2]=e;a=u+40|0;k[a>>2]=q;q=u+48|0;f=u+44|0;k[f>>2]=q;k[u+52>>2]=0;k[q>>2]=0;if(e|0){q=e+12|0;k[q>>2]=(k[q>>2]|0)+1}if((k[d>>2]|0)<3){m=k[c+44>>2]|0;l=k[f>>2]|0;k[l>>2]=k[m>>2];k[l+4>>2]=k[m+4>>2];l=a;m=j;break}k[j>>2]=0;x1(u,k[d>>2]|0,0,0,0);if((k[j>>2]|0)>0){g=k[c+40>>2]|0;h=k[a>>2]|0;c=k[c+44>>2]|0;e=k[f>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[g+(d<<2)>>2];k[e+(d<<2)>>2]=k[c+(d<<2)>>2];d=d+1|0}while((d|0)<(k[j>>2]|0));l=a;m=j}else{l=a;m=j}}else{Q1(u,a,-1);l=u+40|0;m=u+4|0}while(0);P1(b,k[m>>2]|0,k[l>>2]|0,n,-1,0,0);do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[t>>2]=k[f>>2];j=t+4|0;d=f+4|0;k[j>>2]=k[d>>2];q=t+8|0;k[q>>2]=k[f+8>>2];k[t+12>>2]=k[f+12>>2];k[t+16>>2]=k[f+16>>2];k[t+20>>2]=k[f+20>>2];k[t+24>>2]=k[f+24>>2];k[t+28>>2]=k[f+28>>2];k[t+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[t+36>>2]=e;c=t+40|0;k[c>>2]=q;q=t+48|0;h=t+44|0;k[h>>2]=q;k[t+52>>2]=0;k[q>>2]=0;if(e|0){q=e+12|0;k[q>>2]=(k[q>>2]|0)+1}if((k[d>>2]|0)<3){p=k[f+44>>2]|0;q=k[h>>2]|0;k[q>>2]=k[p>>2];k[q+4>>2]=k[p+4>>2];break}k[j>>2]=0;x1(t,k[d>>2]|0,0,0,0);if((k[j>>2]|0)>0){a=k[f+40>>2]|0;g=k[c>>2]|0;c=k[f+44>>2]|0;e=k[h>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[a+(d<<2)>>2];k[e+(d<<2)>>2]=k[c+(d<<2)>>2];d=d+1|0}while((d|0)<(k[j>>2]|0))}}else Q1(t,b,-1);while(0);HV(u,1,t,1,s,1);c=t+36|0;d=k[c>>2]|0;if(d|0?(q=d+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){e=k[c>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[t+32>>2]|0;if(!d){d=B1()|0;e=k[c>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[c>>2]=0}k[c>>2]=0;s=t+16|0;e=t+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[e>>2]|0)>0){c=k[t+40>>2]|0;d=0;do{k[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[t+44>>2]|0;if(!((d|0)==(t+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);c=u+36|0;d=k[c>>2]|0;if(d|0?(s=d+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){e=k[c>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[u+32>>2]|0;if(!d){d=B1()|0;e=k[c>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[c>>2]=0}k[c>>2]=0;t=u+16|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[m>>2]|0)>0){e=k[l>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[m>>2]|0))}d=k[u+44>>2]|0;if(!((d|0)==(u+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=v;return}function RV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;k[a>>2]=0;i=a+4|0;k[i>>2]=0;k[a+8>>2]=0;while(1){c=fgb(48)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[i>>2]=c;k[a>>2]=c;k[a+8>>2]=c+48;a=b+4|0;f=b+36|0;k[c>>2]=k[b>>2];h=c+4|0;k[h>>2]=k[a>>2];j=c+8|0;k[j>>2]=k[b+8>>2];k[c+12>>2]=k[b+12>>2];k[c+16>>2]=k[b+16>>2];k[c+20>>2]=k[b+20>>2];d=k[b+24>>2]|0;k[c+24>>2]=d;k[c+28>>2]=k[b+28>>2];e=c+32|0;k[e>>2]=j;j=c+40|0;g=c+36|0;k[g>>2]=j;k[c+44>>2]=0;k[j>>2]=0;if(d|0){j=d+8|0;k[j>>2]=(k[j>>2]|0)+1}if((k[a>>2]|0)<3){h=k[f>>2]|0;j=k[g>>2]|0;k[j>>2]=k[h>>2];k[j+4>>2]=k[h+4>>2];j=k[i>>2]|0;j=j+48|0;k[i>>2]=j;return}k[h>>2]=0;s9(c,k[a>>2]|0,0,0,0);if((k[h>>2]|0)<=0){j=k[i>>2]|0;j=j+48|0;k[i>>2]=j;return}b=k[b+32>>2]|0;e=k[e>>2]|0;d=k[f>>2]|0;a=k[g>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[b+(c<<2)>>2];k[a+(c<<2)>>2]=k[d+(c<<2)>>2];c=c+1|0}while((c|0)<(k[h>>2]|0));j=k[i>>2]|0;j=j+48|0;k[i>>2]=j;return}function SV(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;d=k[g>>2]|0;c=k[g+4>>2]|0;if(!c)return;while(1){c=c+-1|0;upb(e|0,a|0,d|0)|0;if(!c)break;else{a=a+b|0;e=e+f|0}}return}function TV(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0;n=k[g>>2]|0;d=k[g+4>>2]|0;if(!d)return;j=n+-4|0;if((n|0)<4){j=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(j){c=0;do{a=i[h+c>>0]|0;i[g+c>>0]=(a|0)<0?0:a;c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+f|0;h=h+b|0}}return}l=n&-4;m=(l|0)<(n|0);g=e;h=a;while(1){c=0;do{a=i[h+c>>0]|0;o=c|1;p=i[h+o>>0]|0;i[g+c>>0]=(a|0)<0?0:a;i[g+o>>0]=(p|0)<0?0:p;o=c|2;p=i[h+o>>0]|0;a=c|3;e=i[h+a>>0]|0;i[g+o>>0]=(p|0)<0?0:p;i[g+a>>0]=(e|0)<0?0:e;c=c+4|0}while((c|0)<=(j|0));d=d+-1|0;if(m){c=l;do{p=i[h+c>>0]|0;i[g+c>>0]=(p|0)<0?0:p;c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+f|0;h=h+b|0}}return}function UV(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,n=0,o=0,p=0,q=0;o=k[g>>2]|0;d=k[g+4>>2]|0;n=b>>>1;if(!d)return;b=o+-4|0;if((o|0)<4){b=(o|0)>0;g=e;h=a;while(1){d=d+-1|0;if(b){c=0;do{a=m[h+(c<<1)>>1]|0;i[g+c>>0]=a>>>0>255?255:a;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+f|0;h=h+(n<<1)|0}}return}j=o&-4;l=(j|0)<(o|0);g=e;h=a;while(1){c=0;do{a=m[h+(c<<1)>>1]|0;p=c|1;q=m[h+(p<<1)>>1]|0;i[g+c>>0]=a>>>0>255?255:a;i[g+p>>0]=q>>>0>255?255:q;p=c|2;q=m[h+(p<<1)>>1]|0;a=c|3;e=m[h+(a<<1)>>1]|0;i[g+p>>0]=q>>>0>255?255:q;i[g+a>>0]=e>>>0>255?255:e;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(l){c=j;do{q=m[h+(c<<1)>>1]|0;i[g+c>>0]=q>>>0>255?255:q;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+f|0;h=h+(n<<1)|0}}return}function VV(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0,m=0,n=0,o=0,p=0,q=0;o=k[g>>2]|0;d=k[g+4>>2]|0;n=b>>>1;if(!d)return;b=o+-4|0;if((o|0)<4){b=(o|0)>0;g=e;h=a;while(1){d=d+-1|0;if(b){c=0;do{a=j[h+(c<<1)>>1]|0;i[g+c>>0]=(a&65535)<256?a&65535:a<<16>>16>0?255:0;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+f|0;h=h+(n<<1)|0}}return}l=o&-4;m=(l|0)<(o|0);g=e;h=a;while(1){c=0;do{a=j[h+(c<<1)>>1]|0;p=c|1;q=j[h+(p<<1)>>1]|0;i[g+c>>0]=(a&65535)<256?a&65535:a<<16>>16>0?255:0;i[g+p>>0]=(q&65535)<256?q&65535:q<<16>>16>0?255:0;p=c|2;q=j[h+(p<<1)>>1]|0;a=c|3;e=j[h+(a<<1)>>1]|0;i[g+p>>0]=(q&65535)<256?q&65535:q<<16>>16>0?255:0;i[g+a>>0]=(e&65535)<256?e&65535:e<<16>>16>0?255:0;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(m){c=l;do{q=j[h+(c<<1)>>1]|0;i[g+c>>0]=(q&65535)<256?q&65535:q<<16>>16>0?255:0;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+f|0;h=h+(n<<1)|0}}return}function WV(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0;n=k[g>>2]|0;d=k[g+4>>2]|0;m=b>>>2;if(!d)return;b=n+-4|0;if((n|0)<4){b=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(b){c=0;do{a=k[h+(c<<2)>>2]|0;i[g+c>>0]=a>>>0<256?a:(a|0)>0?255:0;c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+f|0;h=h+(m<<2)|0}}return}j=n&-4;l=(j|0)<(n|0);g=e;h=a;while(1){c=0;do{a=k[h+(c<<2)>>2]|0;o=c|1;p=k[h+(o<<2)>>2]|0;i[g+c>>0]=a>>>0<256?a:(a|0)>0?255:0;i[g+o>>0]=p>>>0<256?p:(p|0)>0?255:0;o=c|2;p=k[h+(o<<2)>>2]|0;a=c|3;e=k[h+(a<<2)>>2]|0;i[g+o>>0]=p>>>0<256?p:(p|0)>0?255:0;i[g+a>>0]=e>>>0<256?e:(e|0)>0?255:0;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(l){c=j;do{p=k[h+(c<<2)>>2]|0;i[g+c>>0]=p>>>0<256?p:(p|0)>0?255:0;c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+f|0;h=h+(m<<2)|0}}return}function XV(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,p=0,q=0,r=0;r=k[g>>2]|0;h=k[g+4>>2]|0;q=b>>>2;if(!h)return;m=r+-4|0;if((r|0)<4){l=(r|0)>0;b=e;g=a;while(1){h=h+-1|0;if(l){d=0;do{j=+o[g+(d<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}p=~~j;i[b+d>>0]=p>>>0<256?p:(p|0)>0?255:0;d=d+1|0}while((d|0)!=(r|0))}if(!h)break;else{b=b+f|0;g=g+(q<<2)|0}}return}n=r&-4;p=(n|0)<(r|0);while(1){l=0;do{j=+o[a+(l<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;g=l|1;j=+o[a+(g<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+g>>0]=b>>>0<256?b:(b|0)>0?255:0;b=l|2;j=+o[a+(b<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;g=l|3;j=+o[a+(g<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+b>>0]=d;i[e+g>>0]=c>>>0<256?c:(c|0)>0?255:0;l=l+4|0}while((l|0)<=(m|0));h=h+-1|0;if(p){d=n;do{j=+o[a+(d<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+d>>0]=l>>>0<256?l:(l|0)>0?255:0;d=d+1|0}while((d|0)!=(r|0))}if(!h)break;else{e=e+f|0;a=a+(q<<2)|0}}return}function YV(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;r=k[g>>2]|0;h=k[g+4>>2]|0;q=b>>>3;if(!h)return;m=r+-4|0;if((r|0)<4){l=(r|0)>0;b=e;g=a;while(1){h=h+-1|0;if(l){d=0;do{j=+p[g+(d<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;o=c&2146435072;if(!(o>>>0>1126170624|(o|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}o=~~j;i[b+d>>0]=o>>>0<256?o:(o|0)>0?255:0;d=d+1|0}while((d|0)!=(r|0))}if(!h)break;else{b=b+f|0;g=g+(q<<3)|0}}return}n=r&-4;o=(n|0)<(r|0);while(1){l=0;do{j=+p[a+(l<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;g=l|1;j=+p[a+(g<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+g>>0]=b>>>0<256?b:(b|0)>0?255:0;b=l|2;j=+p[a+(b<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;g=c&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;g=l|3;j=+p[a+(g<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;s=c&2146435072;if(!(s>>>0>1126170624|(s|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}s=~~j;i[e+b>>0]=d;i[e+g>>0]=s>>>0<256?s:(s|0)>0?255:0;l=l+4|0}while((l|0)<=(m|0));h=h+-1|0;if(o){d=n;do{j=+p[a+(d<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;s=c&2146435072;if(!(s>>>0>1126170624|(s|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}s=~~j;i[e+d>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+1|0}while((d|0)!=(r|0))}if(!h)break;else{e=e+f|0;a=a+(q<<3)|0}}return}function ZV(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,m=0,n=0,o=0,p=0,q=0;o=k[g>>2]|0;d=k[g+4>>2]|0;if(!d)return;j=o+-4|0;if((o|0)<4){j=(o|0)>0;g=e;h=a;while(1){d=d+-1|0;if(j){c=0;do{a=l[h+c>>0]|0;i[g+c>>0]=a>>>0>127?127:a;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+f|0;h=h+b|0}}return}m=o&-4;n=(m|0)<(o|0);g=e;h=a;while(1){c=0;do{a=l[h+c>>0]|0;p=c|1;q=l[h+p>>0]|0;i[g+c>>0]=a>>>0>127?127:a;i[g+p>>0]=q>>>0>127?127:q;p=c|2;q=l[h+p>>0]|0;a=c|3;e=l[h+a>>0]|0;i[g+p>>0]=q>>>0>127?127:q;i[g+a>>0]=e>>>0>127?127:e;c=c+4|0}while((c|0)<=(j|0));d=d+-1|0;if(n){c=m;do{q=l[h+c>>0]|0;i[g+c>>0]=q>>>0>127?127:q;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+f|0;h=h+b|0}}return}function _V(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,n=0,o=0,p=0,q=0;o=k[g>>2]|0;d=k[g+4>>2]|0;n=b>>>1;if(!d)return;b=o+-4|0;if((o|0)<4){b=(o|0)>0;g=e;h=a;while(1){d=d+-1|0;if(b){c=0;do{a=m[h+(c<<1)>>1]|0;i[g+c>>0]=a>>>0>127?127:a;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+f|0;h=h+(n<<1)|0}}return}j=o&-4;l=(j|0)<(o|0);g=e;h=a;while(1){c=0;do{a=m[h+(c<<1)>>1]|0;p=c|1;q=m[h+(p<<1)>>1]|0;i[g+c>>0]=a>>>0>127?127:a;i[g+p>>0]=q>>>0>127?127:q;p=c|2;q=m[h+(p<<1)>>1]|0;a=c|3;e=m[h+(a<<1)>>1]|0;i[g+p>>0]=q>>>0>127?127:q;i[g+a>>0]=e>>>0>127?127:e;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(l){c=j;do{q=m[h+(c<<1)>>1]|0;i[g+c>>0]=q>>>0>127?127:q;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+f|0;h=h+(n<<1)|0}}return}function $V(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;o=k[g>>2]|0;d=k[g+4>>2]|0;n=b>>>1;if(!d)return;b=o+-4|0;if((o|0)<4){b=(o|0)>0;g=e;h=a;while(1){d=d+-1|0;if(b){c=0;do{a=j[h+(c<<1)>>1]|0;e=a<<16>>16;i[g+c>>0]=(e+128|0)>>>0<256?e:a<<16>>16>0?127:128;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+f|0;h=h+(n<<1)|0}}return}l=o&-4;m=(l|0)<(o|0);g=e;h=a;while(1){c=0;do{a=j[h+(c<<1)>>1]|0;e=a<<16>>16;q=c|1;r=j[h+(q<<1)>>1]|0;s=r<<16>>16;i[g+c>>0]=(e+128|0)>>>0<256?e:a<<16>>16>0?127:128;i[g+q>>0]=(s+128|0)>>>0<256?s:r<<16>>16>0?127:128;q=c|2;r=j[h+(q<<1)>>1]|0;s=r<<16>>16;a=c|3;e=j[h+(a<<1)>>1]|0;p=e<<16>>16;i[g+q>>0]=(s+128|0)>>>0<256?s:r<<16>>16>0?127:128;i[g+a>>0]=(p+128|0)>>>0<256?p:e<<16>>16>0?127:128;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(m){c=l;do{s=j[h+(c<<1)>>1]|0;r=s<<16>>16;i[g+c>>0]=(r+128|0)>>>0<256?r:s<<16>>16>0?127:128;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+f|0;h=h+(n<<1)|0}}return}function aW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0;n=k[g>>2]|0;d=k[g+4>>2]|0;m=b>>>2;if(!d)return;b=n+-4|0;if((n|0)<4){b=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(b){c=0;do{a=k[h+(c<<2)>>2]|0;i[g+c>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+f|0;h=h+(m<<2)|0}}return}j=n&-4;l=(j|0)<(n|0);g=e;h=a;while(1){c=0;do{a=k[h+(c<<2)>>2]|0;o=c|1;p=k[h+(o<<2)>>2]|0;i[g+c>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;i[g+o>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;o=c|2;p=k[h+(o<<2)>>2]|0;a=c|3;e=k[h+(a<<2)>>2]|0;i[g+o>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;i[g+a>>0]=(e+128|0)>>>0<256?e:(e|0)>0?127:128;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(l){c=j;do{p=k[h+(c<<2)>>2]|0;i[g+c>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+f|0;h=h+(m<<2)|0}}return}function bW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,p=0,q=0,r=0;r=k[g>>2]|0;h=k[g+4>>2]|0;q=b>>>2;if(!h)return;m=r+-4|0;if((r|0)<4){l=(r|0)>0;b=e;g=a;while(1){h=h+-1|0;if(l){d=0;do{j=+o[g+(d<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}p=~~j;i[b+d>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;d=d+1|0}while((d|0)!=(r|0))}if(!h)break;else{b=b+f|0;g=g+(q<<2)|0}}return}n=r&-4;p=(n|0)<(r|0);while(1){l=0;do{j=+o[a+(l<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;g=l|1;j=+o[a+(g<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+g>>0]=(b+128|0)>>>0<256?b:(b|0)>0?127:128;b=l|2;j=+o[a+(b<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;g=l|3;j=+o[a+(g<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+b>>0]=d;i[e+g>>0]=(c+128|0)>>>0<256?c:(c|0)>0?127:128;l=l+4|0}while((l|0)<=(m|0));h=h+-1|0;if(p){d=n;do{j=+o[a+(d<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+d>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;d=d+1|0}while((d|0)!=(r|0))}if(!h)break;else{e=e+f|0;a=a+(q<<2)|0}}return}function cW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;r=k[g>>2]|0;h=k[g+4>>2]|0;q=b>>>3;if(!h)return;m=r+-4|0;if((r|0)<4){l=(r|0)>0;b=e;g=a;while(1){h=h+-1|0;if(l){d=0;do{j=+p[g+(d<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;o=c&2146435072;if(!(o>>>0>1126170624|(o|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}o=~~j;i[b+d>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;d=d+1|0}while((d|0)!=(r|0))}if(!h)break;else{b=b+f|0;g=g+(q<<3)|0}}return}n=r&-4;o=(n|0)<(r|0);while(1){l=0;do{j=+p[a+(l<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;g=l|1;j=+p[a+(g<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+g>>0]=(b+128|0)>>>0<256?b:(b|0)>0?127:128;b=l|2;j=+p[a+(b<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;g=c&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;g=l|3;j=+p[a+(g<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;s=c&2146435072;if(!(s>>>0>1126170624|(s|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}s=~~j;i[e+b>>0]=d;i[e+g>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;l=l+4|0}while((l|0)<=(m|0));h=h+-1|0;if(o){d=n;do{j=+p[a+(d<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;s=c&2146435072;if(!(s>>>0>1126170624|(s|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}s=~~j;i[e+d>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;d=d+1|0}while((d|0)!=(r|0))}if(!h)break;else{e=e+f|0;a=a+(q<<3)|0}}return}function dW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,m=0,n=0,o=0,p=0;o=k[g>>2]|0;d=k[g+4>>2]|0;n=f>>>1;if(!d)return;f=o+-4|0;if((o|0)<4){f=(o|0)>0;g=e;h=a;while(1){d=d+-1|0;if(f){c=0;do{j[g+(c<<1)>>1]=l[h+c>>0]|0;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+(n<<1)|0;h=h+b|0}}return}i=o&-4;m=(i|0)<(o|0);g=e;h=a;while(1){c=0;do{p=c|1;a=l[h+p>>0]|0;j[g+(c<<1)>>1]=l[h+c>>0]|0;j[g+(p<<1)>>1]=a;p=c|2;a=c|3;e=l[h+a>>0]|0;j[g+(p<<1)>>1]=l[h+p>>0]|0;j[g+(a<<1)>>1]=e;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(m){c=i;do{j[g+(c<<1)>>1]=l[h+c>>0]|0;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+(n<<1)|0;h=h+b|0}}return}function eW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0,m=0,n=0,o=0,p=0,q=0;o=k[g>>2]|0;d=k[g+4>>2]|0;n=f>>>1;if(!d)return;f=o+-4|0;if((o|0)<4){f=(o|0)>0;g=e;h=a;while(1){d=d+-1|0;if(f){c=0;do{a=i[h+c>>0]|0;j[g+(c<<1)>>1]=(a|0)<0?0:a;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+(n<<1)|0;h=h+b|0}}return}l=o&-4;m=(l|0)<(o|0);g=e;h=a;while(1){c=0;do{a=i[h+c>>0]|0;p=c|1;q=i[h+p>>0]|0;j[g+(c<<1)>>1]=(a|0)<0?0:a;j[g+(p<<1)>>1]=(q|0)<0?0:q;p=c|2;q=i[h+p>>0]|0;a=c|3;e=i[h+a>>0]|0;j[g+(p<<1)>>1]=(q|0)<0?0:q;j[g+(a<<1)>>1]=(e|0)<0?0:e;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(m){c=l;do{q=i[h+c>>0]|0;j[g+(c<<1)>>1]=(q|0)<0?0:q;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+(n<<1)|0;h=h+b|0}}return}function fW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;c=k[g+4>>2]|0;b=b>>>1;h=f>>>1;if(!c)return;d=k[g>>2]<<1;while(1){c=c+-1|0;upb(e|0,a|0,d|0)|0;if(!c)break;else{a=a+(b<<1)|0;e=e+(h<<1)|0}}return}
function hYa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;h=l+8|0;j=l;if(Xh[k[(k[a>>2]|0)+20>>2]&1023](a)|0){r=l;return}if(G2(b)|0){r=l;return}if((d|0)<=0?(m=h+4|0,g=ZT(12)|0,k[g>>2]=1,n=g+4|0,k[h>>2]=n,k[m>>2]=7,i[g+11>>0]=0,i[n>>0]=i[389845]|0,i[n+1>>0]=i[389846]|0,i[n+2>>0]=i[389847]|0,i[n+3>>0]=i[389848]|0,i[n+4>>0]=i[389849]|0,i[n+5>>0]=i[389850]|0,i[n+6>>0]=i[389851]|0,Y8(-215,h,389853,388491,627),k[m>>2]=0,k[h>>2]=0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[g+-4>>2]|0);R1(j,b,-1);gYa(a,e,k[j+4>>2]|0);Uh[k[(k[a>>2]|0)+40>>2]&2047](a);Lg[k[(k[a>>2]|0)+48>>2]&255](a,b,c,d,e,f);r=l;return}function iYa(a){a=a|0;ggb(a);return}function jYa(a){a=a|0;var b=0,c=0;b=k[a+8>>2]|0;if(b|0){c=k[b>>2]|0;YHa(k[c+4>>2]|0);ggb(c);ggb(b)}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function kYa(a){a=a|0;DYa(a);return}function lYa(a){a=a|0;DYa(a);ggb(a);return}function mYa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0.0,p=0.0,q=0.0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;ka=r;r=r+192|0;ia=ka+172|0;ha=ka+160|0;fa=ka+104|0;ca=ka+84|0;da=ka+56|0;ea=ka;k[ia>>2]=0;ja=ia+4|0;k[ja>>2]=0;k[ia+8>>2]=0;k[ha>>2]=0;ga=ha+4|0;k[ga>>2]=0;k[ha+8>>2]=0;do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[fa>>2]=k[g>>2];m=fa+4|0;d=g+4|0;k[m>>2]=k[d>>2];ba=fa+8|0;k[ba>>2]=k[g+8>>2];k[fa+12>>2]=k[g+12>>2];k[fa+16>>2]=k[g+16>>2];k[fa+20>>2]=k[g+20>>2];k[fa+24>>2]=k[g+24>>2];k[fa+28>>2]=k[g+28>>2];k[fa+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[fa+36>>2]=e;f=fa+40|0;k[f>>2]=ba;ba=fa+48|0;j=fa+44|0;k[j>>2]=ba;k[fa+52>>2]=0;k[ba>>2]=0;if(e|0){ba=e+12|0;k[ba>>2]=(k[ba>>2]|0)+1}if((k[d>>2]|0)<3){$=k[g+44>>2]|0;ba=k[j>>2]|0;k[ba>>2]=k[$>>2];k[ba+4>>2]=k[$+4>>2];break}k[m>>2]=0;x1(fa,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else Q1(fa,d,-1);while(0);dh[k[(k[a>>2]|0)+64>>2]&255](a,b,ha,ia);g=k[ha>>2]|0;d=(k[ga>>2]|0)-g|0;$=(d|0)/12|0;e=k[c>>2]|0;ba=c+4|0;f=k[ba>>2]|0;if((f|0)!=(e|0))k[ba>>2]=f+(~(((f+-28-e|0)>>>0)/28|0)*28|0);a:do if((d|0)>0){t=ea+4|0;v=ea+8|0;w=ea+12|0;x=ea+16|0;y=ea+20|0;z=ea+24|0;A=ea+32|0;B=ea+36|0;C=ea+40|0;D=ea+48|0;E=ea+44|0;F=ea+52|0;G=da+8|0;H=da+12|0;I=da+4|0;J=ca+12|0;K=ca+8|0;L=ca+4|0;M=fa+16|0;N=da+4|0;O=da+8|0;P=da+12|0;R=da+16|0;S=da+20|0;T=da+24|0;U=c+8|0;V=fa+4|0;W=fa+8|0;X=fa+12|0;Y=fa+44|0;Z=fa+40|0;_=ea+28|0;d=0;while(1){b=k[ia>>2]|0;h=k[b+(d<<4)>>2]|0;j=k[b+(d<<4)+4>>2]|0;a=k[b+(d<<4)+8>>2]|0;b=k[b+(d<<4)+12>>2]|0;k[ea>>2]=1124024332;k[t>>2]=2;m=k[g+(d*12|0)+4>>2]|0;e=k[g+(d*12|0)>>2]|0;f=m-e|0;k[v>>2]=f>>3;k[w>>2]=1;k[x>>2]=0;k[y>>2]=0;k[z>>2]=0;k[A>>2]=0;k[B>>2]=0;k[C>>2]=v;k[E>>2]=D;k[F>>2]=0;k[D>>2]=0;g=e;if((g|0)!=(m|0)){k[F>>2]=8;k[D>>2]=8;k[x>>2]=g;k[y>>2]=g;m=e+f|0;k[z>>2]=m;k[_>>2]=m}k[G>>2]=0;k[H>>2]=0;k[da>>2]=16842752;k[I>>2]=ea;_ra(ca,da);e=k[B>>2]|0;if(e|0?(l=e+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){f=k[B>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[A>>2]|0;if(!e){e=B1()|0;f=k[B>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[B>>2]=0}k[B>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[t>>2]|0)>0){f=k[C>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[t>>2]|0))}e=k[E>>2]|0;if(!((e|0)==(D|0)|(e|0)==0))ggb(k[e+-4>>2]|0);q=+Q(+(+o[J>>2]*+o[K>>2]));do if(q>1.1920928955078125e-07){s=+o[ca>>2];e=(o[u>>2]=s,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;n=e?s+-8388608.0+8388608.0:s+8388608.0+-8388608.0;if(n==0.0)n=e?-0.0:0.0}else n=s;m=~~n;p=+o[L>>2];e=(o[u>>2]=p,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;n=e?p+-8388608.0+8388608.0:p+8388608.0+-8388608.0;if(n==0.0)n=e?-0.0:0.0}else n=p;l=~~n;if((h|0)<=(m|0)&(m|0)<(a+h|0)?(j|0)<=(l|0)&(l|0)<(b+j|0):0){j=k[M>>2]|0;if(j|0){g=k[V>>2]|0;if((g|0)<3)e=aa(k[X>>2]|0,k[W>>2]|0)|0;else{h=k[Z>>2]|0;f=0;e=1;do{e=aa(k[h+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(g|0))}if(e|0?(b=j+(aa(k[k[Y>>2]>>2]|0,l)|0)+m|0,(i[b>>0]|0)==0):0)break}o[da>>2]=s;o[N>>2]=p;o[O>>2]=q;o[P>>2]=-1.0;o[R>>2]=0.0;k[S>>2]=0;k[T>>2]=-1;e=k[ba>>2]|0;if((e|0)==(k[U>>2]|0))H6(c,da);else{o[e>>2]=s;o[e+4>>2]=p;b=e+8|0;k[b>>2]=k[O>>2];k[b+4>>2]=k[O+4>>2];k[b+8>>2]=k[O+8>>2];k[b+12>>2]=k[O+12>>2];k[b+16>>2]=k[O+16>>2];k[ba>>2]=(k[ba>>2]|0)+28}}}while(0);d=d+1|0;if((d|0)>=($|0))break a;g=k[ha>>2]|0}}while(0);f=fa+36|0;d=k[f>>2]|0;if(d|0?(da=d+12|0,ea=k[da>>2]|0,k[da>>2]=ea+-1,(ea|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[fa+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;ea=fa+16|0;e=fa+4|0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[e>>2]|0)>0){f=k[fa+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[fa+44>>2]|0;if(!((d|0)==(fa+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[ha>>2]|0;if(d|0){e=k[ga>>2]|0;if((e|0)!=(d|0)){do{f=e+-12|0;k[ga>>2]=f;g=k[f>>2]|0;h=g;if(!g)e=f;else{e=e+-8|0;f=k[e>>2]|0;if((f|0)!=(g|0))k[e>>2]=f+(~((f+-8-h|0)>>>3)<<3);ggb(g);e=k[ga>>2]|0}}while((e|0)!=(d|0));d=k[ha>>2]|0}ggb(d)}d=k[ia>>2]|0;if(!d){r=ka;return}e=k[ja>>2]|0;if((e|0)!=(d|0))k[ja>>2]=e+(~((e+-16-d|0)>>>4)<<4);ggb(d);r=ka;return}function nYa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,q=0,s=0.0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;fa=r;r=r+1232|0;ca=fa+200|0;F=fa+184|0;G=fa+176|0;H=fa+168|0;ba=fa+112|0;$=fa+56|0;ea=fa;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[ea>>2]=k[g>>2];n=ea+4|0;b=g+4|0;k[n>>2]=k[b>>2];da=ea+8|0;k[da>>2]=k[g+8>>2];k[ea+12>>2]=k[g+12>>2];k[ea+16>>2]=k[g+16>>2];k[ea+20>>2]=k[g+20>>2];k[ea+24>>2]=k[g+24>>2];k[ea+28>>2]=k[g+28>>2];k[ea+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[ea+36>>2]=e;f=ea+40|0;k[f>>2]=da;da=ea+48|0;j=ea+44|0;k[j>>2]=da;k[ea+52>>2]=0;k[da>>2]=0;if(e|0){da=e+12|0;k[da>>2]=(k[da>>2]|0)+1}if((k[b>>2]|0)<3){_=k[g+44>>2]|0;da=k[j>>2]|0;k[da>>2]=k[_>>2];k[da+4>>2]=k[_+4>>2];da=n;break}k[n>>2]=0;x1(ea,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[m+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0));da=n}else da=n}else{Q1(ea,b,-1);da=ea+4|0}while(0);f=k[da>>2]|0;if((f|0)<3)j=aa(k[ea+12>>2]|0,k[ea+8>>2]|0)|0;else{g=k[ea+40>>2]|0;e=0;b=1;do{b=aa(k[g+(e<<2)>>2]|0,b)|0;e=e+1|0}while((e|0)!=(f|0));j=b}h=k[c>>2]|0;_=c+4|0;b=k[_>>2]|0;if((b|0)!=(h|0)){e=b;while(1){b=e+-12|0;k[_>>2]=b;g=k[b>>2]|0;f=g;if(g){b=e+-8|0;e=k[b>>2]|0;if((e|0)!=(g|0))k[b>>2]=e+(~((e+-8-f|0)>>>3)<<3);ggb(g);b=k[_>>2]|0}if((b|0)==(h|0))break;else e=b}}b=k[d>>2]|0;V=d+4|0;e=k[V>>2]|0;if((e|0)==(b|0))e=b;else{e=e+(~((e+-16-b|0)>>>4)<<4)|0;k[V>>2]=e}a:do if(j|0){I=k[(k[ea+40>>2]|0)+4>>2]|0;f=k[ea>>2]|0;switch(f&4095){case 0:{if(!(f&16384)){ba=a+4|0;$=F+4|0;_=$+4|0;k[_>>2]=0;k[_+4>>2]=0;k[F>>2]=33619968;k[$>>2]=ba;mY(ea,F);KG(ea,ba)|0}zpb(ca|0,0,1024)|0;B=ea+12|0;A=k[B>>2]|0;C=ea+8|0;y=k[C>>2]|0;z=a+60|0;v=aa(y,A)|0;n=a+64|0;e=k[n>>2]|0;q=k[z>>2]|0;t=e-q|0;m=t>>2;b=q;f=e;do if(v>>>0>m>>>0){h=v-m|0;j=a+68|0;b=k[j>>2]|0;if(b-e>>2>>>0>=h>>>0){zpb(e|0,0,h<<2|0)|0;k[n>>2]=f+(h<<2);break}if(v>>>0>1073741823)ad(426534,426557,304,426811);ba=b-q|0;g=ba>>1;g=ba>>2>>>0<536870911?(g>>>0<v>>>0?v:g):1073741823;if(!g)b=0;else{if(g>>>0>1073741823){fa=te(4)|0;k[fa>>2]=172664;Cf(fa|0,28816,1287)}e=g<<2;e=(e|0)==0?1:e;while(1){b=fgb(e)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}}f=b+(m<<2)|0;zpb(f|0,0,h<<2|0)|0;e=f+(0-m<<2)|0;if((t|0)>0)upb(e|0,q|0,t|0)|0;k[z>>2]=e;k[n>>2]=f+(h<<2);k[j>>2]=b+(g<<2);if(q|0)ggb(q)}else if(v>>>0<m>>>0?(u=b+(v<<2)|0,(f|0)!=(u|0)):0)k[n>>2]=f+(~((f+-4-u|0)>>>2)<<2);while(0);t=a+72|0;g=v+256|0;u=a+76|0;h=k[u>>2]|0;j=k[t>>2]|0;n=h-j>>2;e=j;b=h;b:do if(g>>>0>n>>>0){e=g-n|0;q=a+80|0;f=k[q>>2]|0;if(f-h>>2>>>0>=e>>>0)while(1){k[b>>2]=0;b=(k[u>>2]|0)+4|0;k[u>>2]=b;e=e+-1|0;if(!e)break b}if(g>>>0>1073741823)ad(426534,426557,304,426811);ba=f-j|0;m=ba>>1;m=ba>>2>>>0<536870911?(m>>>0<g>>>0?g:m):1073741823;if(!m)b=0;else{if(m>>>0>1073741823){fa=te(4)|0;k[fa>>2]=172664;Cf(fa|0,28816,1287)}f=m<<2;f=(f|0)==0?1:f;while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}}j=b+(n<<2)|0;h=j;f=j;do{k[f>>2]=0;f=h+4|0;h=f;e=e+-1|0}while((e|0)!=0);f=k[t>>2]|0;g=(k[u>>2]|0)-f|0;e=j+(0-(g>>2)<<2)|0;if((g|0)>0)upb(e|0,f|0,g|0)|0;k[t>>2]=e;k[u>>2]=h;k[q>>2]=b+(m<<2);if(f|0)ggb(f)}else if(g>>>0<n>>>0?(x=e+(g<<2)|0,(b|0)!=(x|0)):0)k[u>>2]=b+(~((b+-4-x|0)>>>2)<<2);while(0);q=a+84|0;t=a+88|0;g=k[t>>2]|0;h=k[q>>2]|0;j=g-h>>5;e=h;b=g;c:do if(v>>>0>j>>>0){e=v-j|0;n=a+92|0;f=k[n>>2]|0;if(f-g>>5>>>0>=e>>>0)while(1){k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;o[b+20>>2]=-1.0;k[b+24>>2]=0;i[b+28>>0]=0;b=(k[t>>2]|0)+32|0;k[t>>2]=b;e=e+-1|0;if(!e)break c}if(v>>>0>134217727)ad(426534,426557,304,426811);ba=f-h|0;m=ba>>4;m=ba>>5>>>0<67108863?(m>>>0<v>>>0?v:m):134217727;if(!m)b=0;else{if(m>>>0>134217727){fa=te(4)|0;k[fa>>2]=172664;Cf(fa|0,28816,1287)}f=m<<5;f=(f|0)==0?1:f;while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}}j=b+(j<<5)|0;h=j;f=j;do{k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;o[f+20>>2]=-1.0;k[f+24>>2]=0;i[f+28>>0]=0;f=h+32|0;h=f;e=e+-1|0}while((e|0)!=0);f=k[q>>2]|0;g=(k[t>>2]|0)-f|0;e=j+(0-(g>>5)<<5)|0;if((g|0)>0)upb(e|0,f|0,g|0)|0;k[q>>2]=e;k[t>>2]=h;k[n>>2]=b+(m<<5);if(f|0)ggb(f)}else if(v>>>0<j>>>0?(D=e+(v<<5)|0,(b|0)!=(D|0)):0)k[t>>2]=b+(~((b+-32-D|0)>>>5)<<5);while(0);if((A|0)>0){g=k[z>>2]|0;e=y+-1|0;f=aa(e,A)|0;b=0;do{k[g+(b+f<<2)>>2]=-1610612736;k[g+(b<<2)>>2]=-1610612736;b=b+1|0}while((b|0)!=(A|0));n=e}else n=y+-1|0;d:do if((n|0)>1){q=A+-1|0;if((q|0)<=1){e=k[z>>2]|0;b=1;while(1){ba=e+((aa(b,A)|0)<<2)|0;k[ba+(q<<2)>>2]=-1610612736;k[ba>>2]=-1610612736;b=b+1|0;if((b|0)==(n|0))break d}}j=k[ea+16>>2]|0;m=k[ea+44>>2]|0;f=k[z>>2]|0;b=1;do{g=j+(aa(k[m>>2]|0,b)|0)|0;h=f+((aa(b,A)|0)<<2)|0;k[h+(q<<2)>>2]=-1610612736;k[h>>2]=-1610612736;e=1;do{ba=ca+(l[g+e>>0]<<2)|0;k[ba>>2]=(k[ba>>2]|0)+1;k[h+(e<<2)>>2]=0;e=e+1|0}while((e|0)!=(q|0));b=b+1|0}while((b|0)!=(n|0))}while(0);e=a+128|0;if(!(i[e>>0]|0)){wYa(a,k[ea+16>>2]|0,c,d,I,ca,0);b=0}else b=0;do{_=ca+(b<<2)|0;ba=ca+(255-b<<2)|0;$=k[_>>2]|0;k[_>>2]=k[ba>>2];k[ba>>2]=$;b=b+1|0}while((b|0)!=128);if(((i[e>>0]|0)==0?(N=k[B>>2]|0,J=k[C>>2]|0,(J+-1|0)>1):0)?(O=k[a+60>>2]|0,(N+-1|0)>1):0){f=N+2|0;g=(N<<2)+-8|0;b=J+-2|0;e=0;do{zpb(O+(f+(aa(e,N)|0)<<2)|0,0,g|0)|0;e=e+1|0}while((e|0)!=(b|0))}wYa(a,k[ea+16>>2]|0,c,d,I,ca,255);break a}case 24:case 16:break;default:{k[ca>>2]=0;b=ca+4|0;k[b>>2]=0;e=ZT(52)|0;k[e>>2]=1;h=e+4|0;k[ca>>2]=h;k[b>>2]=46;i[e+50>>0]=0;f=390087;j=h+46|0;do{i[h>>0]=i[f>>0]|0;h=h+1|0;f=f+1|0}while((h|0)<(j|0));Y8(-215,ca,390134,390148,1052);k[b>>2]=0;k[ca>>2]=0;Z=k[e>>2]|0;k[e>>2]=Z+-1;if((Z|0)==1)ggb(k[e+-4>>2]|0);e=k[V>>2]|0;b=k[d>>2]|0}}if((e|0)!=(b|0))k[V>>2]=e+(~((e+-16-b|0)>>>4)<<4);D=ea+12|0;C=ea+8|0;N=ZT(aa(k[D>>2]<<6,k[C>>2]|0)|0)|0;O=k[D>>2]|0;I=k[C>>2]|0;I=(aa(O<<1,I)|0)-O-I|0;O=ZT(I<<4)|0;P=ZT(aa((k[D>>2]|0)*24|0,k[C>>2]|0)|0)|0;e=k[C>>2]|0;f=(k[D>>2]|0)+-1|0;k[ba>>2]=1124007936;Y=ba+4|0;b=ba+8|0;W=ba+40|0;h=Y;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[W>>2]=b;Z=ba+48|0;X=ba+44|0;k[X>>2]=Z;k[ba+52>>2]=0;k[Z>>2]=0;k[ca>>2]=e;g=ca+4|0;k[g>>2]=f;G1(ba,2,ca,6);e=(k[C>>2]|0)+-1|0;f=k[D>>2]|0;k[$>>2]=1124007936;T=$+4|0;b=$+8|0;R=$+40|0;h=T;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[R>>2]=b;S=$+48|0;Q=$+44|0;k[Q>>2]=S;k[$+52>>2]=0;k[S>>2]=0;k[ca>>2]=e;k[g>>2]=f;G1($,2,ca,6);A=k[a+152>>2]|0;y=k[ea+48>>2]|0;B=k[D>>2]|0;z=(aa(B,-3)|0)+y|0;h=k[ea+16>>2]|0;U=ba+16|0;x=k[C>>2]|0;if((x|0)>0){t=z+3|0;u=B+-1|0;if((B|0)>1){v=(B*3|0)+-3|0;e=0;f=k[U>>2]|0;g=h+3|0;j=h;while(1){b=0;m=f;n=g;q=j;while(1){la=l[q>>0]|0;ma=l[n>>0]|0;na=la-ma|0;ia=l[q+1>>0]|0;ja=l[n+1>>0]|0;ka=ia-ja|0;J=l[q+2>>0]|0;ga=l[n+2>>0]|0;ha=J-ga|0;M=+(aa(na,na)|0)/(+(ma+la|0)+1.0e-10)+ +(aa(ka,ka)|0)/(+(ja+ia|0)+1.0e-10)+ +(aa(ha,ha)|0)/(+(ga+J|0)+1.0e-10);p[m>>3]=M;b=b+1|0;if((b|0)==(u|0))break;else{m=m+8|0;n=n+3|0;q=q+3|0}}e=e+1|0;if((e|0)==(x|0))break;else{f=f+(u<<3)|0;g=g+v+t|0;j=j+v+t|0}}}b=$+16|0;e=k[b>>2]|0;if((x|0)>1?(E=x+-1|0,(B|0)>0):0){u=B*3|0;q=0;t=e;n=h+y|0;while(1){f=0;g=t;j=n;m=h;while(1){ha=l[m>>0]|0;ga=l[j>>0]|0;J=ha-ga|0;ka=l[m+1>>0]|0;ja=l[j+1>>0]|0;ia=ka-ja|0;na=l[m+2>>0]|0;ma=l[j+2>>0]|0;la=na-ma|0;M=+(aa(J,J)|0)/(+(ga+ha|0)+1.0e-10)+ +(aa(ia,ia)|0)/(+(ja+ka|0)+1.0e-10)+ +(aa(la,la)|0)/(+(ma+na|0)+1.0e-10);p[g>>3]=M;f=f+1|0;if((f|0)==(B|0))break;else{g=g+8|0;j=j+3|0;m=m+3|0}}q=q+1|0;if((q|0)==(E|0))break;else{t=t+(B<<3)|0;n=n+u+z|0;h=h+u+z|0}}}}else{b=$+16|0;e=k[b>>2]|0}if((A|0)>0){k[ca+8>>2]=0;k[ca+12>>2]=0;k[ca>>2]=16842752;k[ca+4>>2]=ba;t=F+4|0;e=t+4|0;k[e>>2]=0;k[e+4>>2]=0;k[F>>2]=33619968;k[t>>2]=ba;k[G>>2]=A;k[G+4>>2]=A;uua(ca,F,G,0.0,0.0,4);k[ca+8>>2]=0;k[ca+12>>2]=0;k[ca>>2]=16842752;k[ca+4>>2]=$;t=F+4|0;e=t+4|0;k[e>>2]=0;k[e+4>>2]=0;k[F>>2]=33619968;k[t>>2]=$;k[H>>2]=A;k[H+4>>2]=A;uua(ca,F,H,0.0,0.0,4);t=k[D>>2]|0;e=k[b>>2]|0}else t=B;q=k[U>>2]|0;k[N+12>>2]=0;k[N+16>>2]=0;k[N+28>>2]=65535;k[N+24>>2]=0;k[N+32>>2]=1;k[N+36>>2]=1;k[N>>2]=N;k[N+8>>2]=N;k[N+4>>2]=N;k[N+20>>2]=0;s=+p[q>>3];p[O>>3]=s;s=s+0.0;k[O+8>>2]=N;b=N+64|0;k[O+12>>2]=b;h=q+8|0;f=O+16|0;B=t+-1|0;u=(B|0)>1;k[N+76>>2]=0;k[N+80>>2]=0;k[N+92>>2]=65535;k[N+88>>2]=0;k[N+96>>2]=1;k[N+100>>2]=1;k[b>>2]=b;k[N+72>>2]=b;k[N+68>>2]=b;if(u){m=(t<<6)+-64|0;n=t<<4;j=1;g=O;while(1){k[b+20>>2]=j;M=+p[h>>3];p[f>>3]=M;s=s+M;k[g+24>>2]=b;na=b;b=b+64|0;k[g+28>>2]=b;j=j+1|0;k[na+76>>2]=0;k[na+80>>2]=0;k[na+92>>2]=65535;k[na+88>>2]=0;k[na+96>>2]=1;k[na+100>>2]=1;k[b>>2]=b;k[na+72>>2]=b;k[na+68>>2]=b;if((j|0)==(B|0))break;else{g=f;f=f+16|0;h=h+8|0}}b=N+m|0;f=O+(n+-16)|0;h=q+(B<<3)|0}k[b+20>>2]=B;g=b+64|0;A=k[C>>2]|0;z=A+-1|0;k[b+76>>2]=0;k[b+80>>2]=0;k[b+92>>2]=65535;k[b+88>>2]=0;k[b+96>>2]=1;k[b+100>>2]=1;k[g>>2]=g;k[b+72>>2]=g;k[b+68>>2]=g;do if((z|0)>1){y=0-t|0;x=k[D>>2]|0;v=0-x|0;x=x+-1|0;if(u){u=1;do{q=u<<16;k[b+84>>2]=q;L=+p[e>>3];p[f>>3]=L;k[f+8>>2]=g+(y<<6);k[f+12>>2]=g;M=+p[h>>3];p[f+16>>3]=M;k[f+24>>2]=g;t=b+128|0;k[f+28>>2]=t;k[b+140>>2]=0;k[b+144>>2]=0;k[b+156>>2]=65535;k[b+152>>2]=0;k[b+160>>2]=1;k[b+164>>2]=1;k[t>>2]=t;k[b+136>>2]=t;k[b+132>>2]=t;m=1;g=f;n=f+32|0;s=s+L+M;j=e+8|0;h=h+8|0;while(1){k[t+20>>2]=m|q;L=+p[j>>3];p[n>>3]=L;k[g+40>>2]=t+(v<<6);k[g+44>>2]=t;M=+p[h>>3];p[g+48>>3]=M;s=s+L+M;k[g+56>>2]=t;b=t+64|0;k[g+60>>2]=b;m=m+1|0;e=n+32|0;f=j+8|0;h=h+8|0;k[t+76>>2]=0;k[t+80>>2]=0;k[t+92>>2]=65535;k[t+88>>2]=0;k[t+96>>2]=1;k[t+100>>2]=1;k[b>>2]=b;k[t+72>>2]=b;k[t+68>>2]=b;if((m|0)>=(x|0))break;else{g=n;n=e;t=b;j=f}}k[t+84>>2]=q|B;M=+p[f>>3];p[e>>3]=M;s=s+M;e=j+16|0;k[n+40>>2]=b+(y<<6);k[n+44>>2]=b;f=n+48|0;u=u+1|0;g=t+128|0;k[t+140>>2]=0;k[t+144>>2]=0;k[t+156>>2]=65535;k[t+152>>2]=0;k[t+160>>2]=1;k[t+164>>2]=1;k[g>>2]=g;k[t+136>>2]=g;k[t+132>>2]=g}while((u|0)!=(z|0));j=b;b=g;v=e}else{u=A<<1;v=A*3|0;n=1;q=b;t=f;j=e;m=h;while(1){ma=n<<16;k[q+84>>2]=ma;K=+p[j>>3];p[t>>3]=K;k[t+8>>2]=g+(y<<6);k[t+12>>2]=g;L=+p[m>>3];p[t+16>>3]=L;k[t+24>>2]=g;na=q;q=q+128|0;k[t+28>>2]=q;k[na+140>>2]=0;k[na+144>>2]=0;k[na+156>>2]=65535;k[na+152>>2]=0;k[na+160>>2]=1;k[na+164>>2]=1;k[q>>2]=q;k[na+136>>2]=q;k[na+132>>2]=q;k[na+148>>2]=ma|B;M=+p[j+8>>3];p[t+32>>3]=M;s=s+K+L+M;k[t+40>>2]=q+(y<<6);k[t+44>>2]=q;n=n+1|0;g=na+192|0;k[na+204>>2]=0;k[na+208>>2]=0;k[na+220>>2]=65535;k[na+216>>2]=0;k[na+224>>2]=1;k[na+228>>2]=1;k[g>>2]=g;k[na+200>>2]=g;k[na+196>>2]=g;if((n|0)==(z|0))break;else{t=t+48|0;j=j+16|0;m=m+8|0}}na=u+-4|0;j=b+(na<<6)|0;b=b+(u+-3<<6)|0;f=f+(v+-6<<4)|0;v=e+(na<<3)|0;h=h+(A+-2<<3)|0;break}}else{j=b;b=g;v=e}while(0);u=(A<<16)+-65536|0;k[j+84>>2]=u;L=+p[h>>3];p[f>>3]=L;k[f+8>>2]=b;e=j+128|0;k[f+12>>2]=e;M=+p[v>>3];p[f+16>>3]=M;s=s+L+M;g=k[D>>2]|0;t=0-g|0;k[f+24>>2]=b+(t<<6);k[f+28>>2]=b;b=v+8|0;q=g+-1|0;k[j+140>>2]=0;k[j+144>>2]=0;k[j+156>>2]=65535;k[j+152>>2]=0;k[j+160>>2]=1;k[j+164>>2]=1;k[e>>2]=e;k[j+136>>2]=e;k[j+132>>2]=e;if((q|0)>1){n=(g<<1)+-4|0;m=j+(g<<6)|0;g=1;j=f;while(1){ma=j;j=j+32|0;h=h+8|0;k[e+20>>2]=g|u;L=+p[h>>3];p[j>>3]=L;k[ma+40>>2]=e;na=e;e=e+64|0;k[ma+44>>2]=e;M=+p[b>>3];p[ma+48>>3]=M;s=s+L+M;k[ma+56>>2]=na+(t<<6);k[ma+60>>2]=na;g=g+1|0;k[na+76>>2]=0;k[na+80>>2]=0;k[na+92>>2]=65535;k[na+88>>2]=0;k[na+96>>2]=1;k[na+100>>2]=1;k[e>>2]=e;k[na+72>>2]=e;k[na+68>>2]=e;if((g|0)==(q|0))break;else b=b+8|0}f=f+(n<<4)|0;e=m;b=v+(q<<3)|0}k[e+20>>2]=q|u;M=+p[b>>3];p[f+32>>3]=M;k[f+40>>2]=e+(t<<6);k[f+44>>2]=e;M=(s+M)/+(I|0);y=O+(I<<4)|0;xYa(O,y);z=k[a+132>>2]|0;e:do if((z|0)>0){A=a+136|0;u=a+100|0;v=a+104|0;x=a+120|0;K=+(z|0);b=O;e=P;t=0;do{L=+(t|0)/K*399.0;na=~~L;na=na-(+(na|0)>L&1)|0;L=L-+(na|0);L=M*(+o[143216+(na+1<<2)>>2]*L+ +o[143216+(na<<2)>>2]*(1.0-L));if(b>>>0>=y>>>0)break e;while(1){w=+p[b>>3];if(!(w<L))break;f=k[b+8>>2]|0;j=f;while(1){g=k[j>>2]|0;k[j>>2]=f;if((g|0)==(j|0))break;else{f=j;j=g}}k[j>>2]=j;if((f|0)!=(j|0))do{na=f;f=k[f>>2]|0;k[na>>2]=j}while((f|0)!=(na|0));f=k[b+12>>2]|0;h=f;while(1){g=k[h>>2]|0;k[h>>2]=f;if((g|0)==(h|0))break;else{f=h;h=g}}k[h>>2]=h;if((f|0)!=(h|0))do{na=f;f=k[f>>2]|0;k[na>>2]=h}while((f|0)!=(na|0));do if((j|0)!=(h|0)){f=k[h+24>>2]|0;g=k[j+24>>2]|0;do if((f|0)>(g|0))f=j;else{if((g|0)!=(f|0)){f=h;h=j;break}f=(k[j+32>>2]|0)>(k[h+32>>2]|0);na=f?h:j;ma=na+24|0;k[ma>>2]=(k[ma>>2]|0)+1;f=f?j:h;h=na}while(0);k[f>>2]=h;na=f+32|0;q=h+32|0;n=(k[q>>2]|0)+(k[na>>2]|0)|0;k[q>>2]=n;q=h+4|0;k[(k[q>>2]|0)+8>>2]=f;ma=f+4|0;k[q>>2]=k[ma>>2];k[(k[ma>>2]|0)+8>>2]=h;k[ma>>2]=h;s=+(n|0);if(s>+p[A>>3]*+(n-(k[na>>2]|0)|0)){k[h+36>>2]=n;k[h+28>>2]=t;f=h+12|0;g=k[f>>2]|0;if(!g)f=h+48|0;else{na=h+48|0;p[g+8>>3]=+p[h+40>>3]-+p[na>>3];k[f>>2]=0;f=na}p[f>>3]=w;p[h+56>>3]=1.0e10;f=t}else f=k[h+28>>2]|0;p[h+40>>3]=w;if((t|0)<=(f|0))break;w=+(n-(k[h+36>>2]|0)|0)/(w-+p[h+48>>3]);m=h+56|0;if(!(w<+p[m>>3]))break;do if((t|0)>(f+1|0)){if(!((n|0)>(k[u>>2]|0)?(n|0)<(k[v>>2]|0):0))break;g=h+16|0;na=k[g>>2]|0;if(na|0?!(+(n-(k[na+16>>2]|0)|0)/s>+p[x>>3]):0)break;f=h+12|0;j=k[f>>2]|0;if(!j){k[f>>2]=e;k[g>>2]=e;f=e+24|0}else{f=e;e=j}k[e+16>>2]=n;k[e>>2]=h;k[e+4>>2]=k[q>>2];p[e+8>>3]=0.0;e=f}while(0);p[m>>3]=w}while(0);b=b+16|0;if(b>>>0>=y>>>0)break e}t=t+1|0}while((t|0)<(z|0))}else e=P;while(0);if(P>>>0<e>>>0){B=a+144|0;C=ca+4|0;D=ca+8|0;E=c+8|0;F=ca+4|0;G=ca+8|0;H=ca+12|0;I=d+8|0;J=ca+4|0;A=P;do{if(+p[A+8>>3]>+p[B>>3]){f=k[A>>2]|0;k[ca>>2]=0;k[C>>2]=0;k[D>>2]=0;b=k[_>>2]|0;if((b|0)==(k[E>>2]|0))yYa(c,ca);else{QP(b,ca);k[_>>2]=(k[_>>2]|0)+12}b=k[_>>2]|0;x=A+16|0;g=k[x>>2]|0;y=b+-12|0;if((g|0)>0){z=b+-8|0;v=b+-4|0;t=f;f=-2147483648;b=-2147483648;h=2147483647;j=2147483647;u=0;do{q=k[t+20>>2]|0;n=q&65535;k[ca>>2]=n;q=q>>16;k[J>>2]=q;j=(n|0)<(j|0)?n:j;b=(b|0)<(n|0)?n:b;h=(q|0)<(h|0)?q:h;f=(f|0)<(q|0)?q:f;t=k[t+8>>2]|0;m=k[z>>2]|0;if((m|0)==(k[v>>2]|0)){Efa(y,ca);g=k[x>>2]|0}else{k[m>>2]=n;k[m+4>>2]=q;k[z>>2]=m+8}u=u+1|0}while((u|0)<(g|0))}else{f=-2147483648;b=-2147483648;j=2147483647;h=2147483647}g=b+(1-j)|0;b=f+(1-h)|0;k[ca>>2]=j;k[F>>2]=h;k[G>>2]=g;k[H>>2]=b;f=k[V>>2]|0;if((f|0)==(k[I>>2]|0))SRa(d,ca);else{k[f>>2]=j;k[f+4>>2]=h;k[f+8>>2]=g;k[f+12>>2]=b;k[V>>2]=f+16}}A=A+24|0}while(A>>>0<e>>>0)}if(P|0)ggb(k[P+-4>>2]|0);if(O|0)ggb(k[O+-4>>2]|0);if(N|0)ggb(k[N+-4>>2]|0);f=$+36|0;b=k[f>>2]|0;if(b|0?(ma=b+12|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[$+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;na=$+16|0;k[na>>2]=0;k[na+4>>2]=0;k[na+8>>2]=0;k[na+12>>2]=0;if((k[T>>2]|0)>0){e=k[R>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[T>>2]|0))}b=k[Q>>2]|0;if(!((b|0)==(S|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ba+36|0;b=k[f>>2]|0;do if(b|0){ma=b+12|0;na=k[ma>>2]|0;k[ma>>2]=na+-1;if((na|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ba+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[Y>>2]|0)>0){e=k[W>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Y>>2]|0))}b=k[X>>2]|0;if(!((b|0)==(Z|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while(0);f=ea+36|0;b=k[f>>2]|0;if(b|0?(ma=b+12|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[ea+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;na=ea+16|0;k[na>>2]=0;k[na+4>>2]=0;k[na+8>>2]=0;k[na+12>>2]=0;if((k[da>>2]|0)>0){e=k[ea+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[da>>2]|0))}b=k[ea+44>>2]|0;if((b|0)==(ea+48|0)|(b|0)==0){r=fa;return}ggb(k[b+-4>>2]|0);r=fa;return}function oYa(a,b){a=a|0;b=b|0;k[a+96>>2]=b;return}function pYa(a){a=a|0;return k[a+96>>2]|0}function qYa(a,b){a=a|0;b=b|0;k[a+100>>2]=b;return}function rYa(a){a=a|0;return k[a+100>>2]|0}function sYa(a,b){a=a|0;b=b|0;k[a+104>>2]=b;return}function tYa(a){a=a|0;return k[a+104>>2]|0}function uYa(a,b){a=a|0;b=b|0;i[a+128>>0]=b&1;return}function vYa(a){a=a|0;return (i[a+128>>0]|0)!=0|0}function wYa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;K=r;r=r+6272|0;F=K+5248|0;j=K+108|0;J=K;G=K+88|0;H=K+80|0;h=k[a+84>>2]|0;E=k[a+60>>2]|0;zpb(j|0,0,5140)|0;m=J;n=a+96|0;q=m+60|0;do{k[m>>2]=k[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(q|0));k[J+64>>2]=c;k[J+68>>2]=d;C=J+72|0;k[C>>2]=E;k[J+76>>2]=e;d=k[a+72>>2]|0;k[F>>2]=d;k[d>>2]=0;c=1;do{d=d+(k[f+(c+-1<<2)>>2]<<2)+4|0;k[F+(c<<2)>>2]=d;k[d>>2]=0;c=c+1|0}while((c|0)!=256);d=e+1|0;p=E+(d<<2)|0;I=J+4|0;k[j+12>>2]=256;B=E;k[j+32>>2]=(l[b+(d<<2>>2)>>0]|0)^g;d=k[p>>2]&536870911|536870912;k[p>>2]=d;k[G>>2]=0;k[G+4>>2]=1;k[G+8>>2]=e;k[G+12>>2]=-1;k[G+16>>2]=0-e;A=H+4|0;e=p;p=j+20|0;a:while(1){c=(l[b+(e-B>>2)>>0]|0)^g;a=d>>>29;b:do if(d>>>0<2684354560){d=a;while(1){while(1){f=e+(k[G+(d<<2)>>2]<<2)|0;if((k[f>>2]|0)>>>0<=536870911){k[f>>2]=536870912;a=(l[b+(f-B>>2)>>0]|0)^g;if((a|0)<(c|0))break;y=F+(a<<2)|0;z=(k[y>>2]|0)+4|0;k[y>>2]=z;k[z>>2]=f}d=d+1|0;if((d|0)>=5){f=c;c=e;break b}}y=F+(c<<2)|0;z=(k[y>>2]|0)+4|0;k[y>>2]=z;k[z>>2]=e;k[e>>2]=(d<<29)+536870912;z=p+20|0;k[p+24>>2]=0;k[z>>2]=0;k[p+28>>2]=0;k[p+36>>2]=0;k[p+32>>2]=a;c=a;d=1;p=z;e=f}}else{f=c;d=a;c=e}while(0);k[c>>2]=d<<29;a=c-B>>2;if(!a){c=ZT(16)|0;k[c>>2]=1;m=c+4|0;k[H>>2]=m;k[A>>2]=11;i[c+15>>0]=0;n=390217;q=m+11|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(q|0));Y8(-215,H,390229,390148,469);k[A>>2]=0;k[H>>2]=0;z=k[c>>2]|0;k[c>>2]=z+-1;if((z|0)==1)ggb(k[c+-4>>2]|0)}c=p+4|0;d=k[c>>2]|0;if(!d)k[p>>2]=a;else{z=E+(d<<2)|0;k[z>>2]=k[z>>2]&-536870912|a}k[c>>2]=a;s=p+16|0;j=k[s>>2]|0;n=j+1|0;k[s>>2]=n;c=F+(f<<2)|0;d=k[c>>2]|0;a=k[d>>2]|0;c:do if(!a){y=f;while(1){q=y+1|0;if((q|0)>=256)break;if(!(k[k[F+(q<<2)>>2]>>2]|0))y=q;else break}if((y|0)>254)break a;c=F+(q<<2)|0;z=k[c>>2]|0;a=k[z>>2]|0;k[c>>2]=z+-4;c=k[p+-8>>2]|0;if((q|0)<(c|0)){if((y|0)<-1)q=k[p+12>>2]|0;m=p+8|0;d=k[m>>2]|0;f=(d|0)==0;e=d;if(!f){c=p+12|0;if(((j|0)>-1?(k[d+16>>2]|0)!=(n|0):0)?(k[c>>2]|0)!=(k[d+12>>2]|0):0)D=31}else D=31;if((D|0)==31){D=0;j=h;n=j+32|0;k[j+4>>2]=0;k[h>>2]=e;k[j+8>>2]=0;if(!f)k[d+4>>2]=j;c=p+12|0;k[j+12>>2]=k[c>>2];z=k[s>>2]|0;k[j+16>>2]=z;k[j+24>>2]=k[p>>2];k[m>>2]=j;h=j+20|0;o[h>>2]=3402823466385288598117041.0e14;d=j+28|0;i[d>>0]=1;if((z|0)<(k[I>>2]|0))h=n;else{o[h>>2]=-1.0;i[d>>0]=0;k[c>>2]=q;BYa(j,J,0,0,0);h=n;break}}k[c>>2]=q;break}do{w=p;p=p+-20|0;s=p;t=w;z=w+-8|0;x=w+-12|0;d=k[x>>2]|0;f=d;if(d){v=k[w+-4>>2]|0;if(((v|0)>0?(k[d+16>>2]|0)!=(v|0):0)?(c|0)!=(k[d+12>>2]|0):0)D=39}else D=39;if((D|0)==39){D=0;e=h;j=e+32|0;k[e+4>>2]=0;k[h>>2]=f;k[e+8>>2]=0;if(d|0)k[d+4>>2]=e;k[e+12>>2]=c;v=k[w+-4>>2]|0;k[e+16>>2]=v;k[e+24>>2]=k[p>>2];k[x>>2]=e;c=e+20|0;o[c>>2]=3402823466385288598117041.0e14;h=e+28|0;i[h>>0]=1;if((v|0)<(k[I>>2]|0))h=j;else{o[c>>2]=-1.0;i[h>>0]=0;BYa(e,J,0,0,0);h=j}}d=k[w+12>>2]|0;j=w+8|0;f=k[j>>2]|0;e=f;if(f){c=k[w+16>>2]|0;if(((c|0)>0?(k[f+16>>2]|0)!=(c|0):0)?(d|0)!=(k[f+12>>2]|0):0)D=46}else D=46;if((D|0)==46){D=0;m=h;n=m+32|0;k[m+4>>2]=0;k[h>>2]=e;k[m+8>>2]=0;if(f|0)k[f+4>>2]=m;k[m+12>>2]=d;f=w+16|0;c=k[f>>2]|0;k[m+16>>2]=c;k[m+24>>2]=k[w>>2];k[j>>2]=m;h=m+20|0;o[h>>2]=3402823466385288598117041.0e14;d=m+28|0;i[d>>0]=1;if((c|0)<(k[I>>2]|0))h=n;else{o[h>>2]=-1.0;i[d>>0]=0;BYa(m,J,0,0,0);h=n;c=k[f>>2]|0}}v=w+-4|0;c=(k[v>>2]|0)<(c|0);d=c?s:t;f=k[d+16>>2]|0;c=c?t:s;if(f){t=k[c+8>>2]|0;u=k[d+8>>2]|0;s=k[c+12>>2]|0;j=k[d+12>>2]|0;s=(s|0)<(j|0)?j:s;k[z>>2]=s;j=t;k[x>>2]=j;m=(k[C>>2]|0)+(k[c+4>>2]<<2)|0;k[m>>2]=k[m>>2]&-536870912|k[d>>2];m=k[c>>2]|0;k[p>>2]=m;k[w+-16>>2]=k[d+4>>2];c=f+(k[c+16>>2]|0)|0;k[v>>2]=c;e=k[I>>2]|0;n=(k[u+16>>2]|0)>(e|0);if(t)if(((c|0)>0?(k[t+16>>2]|0)!=(c|0):0)?n|(s|0)!=(k[t+12>>2]|0):0)D=55;else D=59;else D=55;if((D|0)==55){D=0;d=h;f=d+32|0;k[d+4>>2]=0;k[h>>2]=j;k[d+8>>2]=0;if(t|0)k[t+4>>2]=d;k[d+12>>2]=s;j=k[v>>2]|0;k[d+16>>2]=j;k[d+24>>2]=m;k[x>>2]=d;c=d+20|0;o[c>>2]=3402823466385288598117041.0e14;h=d+28|0;i[h>>0]=1;if((j|0)<(e|0)){h=f;D=59}else{o[c>>2]=-1.0;i[h>>0]=0;k[z>>2]=s;BYa(d,J,0,0,0);h=f}}if((D|0)==59){D=0;k[z>>2]=s}if(n){k[t+8>>2]=u;k[u+4>>2]=k[x>>2]}}else{k[z>>2]=k[c+12>>2];k[p>>2]=k[c>>2];k[w+-16>>2]=k[c+4>>2];k[v>>2]=k[c+16>>2];k[x>>2]=k[c+8>>2]}j=k[z>>2]|0;if((y|0)<(j|0))break c;c=k[w+-28>>2]|0}while((q|0)>=(c|0));e=(y|0)<-1?j:q;c=k[x>>2]|0;d=c;if(c){y=k[v>>2]|0;if(((y|0)>0?(k[c+16>>2]|0)!=(y|0):0)?(j|0)!=(k[c+12>>2]|0):0)D=67}else D=67;if((D|0)==67){D=0;f=h;m=f+32|0;k[f+4>>2]=0;k[h>>2]=d;k[f+8>>2]=0;if(c|0)k[c+4>>2]=f;k[f+12>>2]=j;y=k[v>>2]|0;k[f+16>>2]=y;k[f+24>>2]=k[p>>2];k[x>>2]=f;c=f+20|0;o[c>>2]=3402823466385288598117041.0e14;h=f+28|0;i[h>>0]=1;if((y|0)<(k[I>>2]|0))h=m;else{o[c>>2]=-1.0;i[h>>0]=0;k[z>>2]=e;BYa(f,J,0,0,0);h=m;break}}k[z>>2]=e}else k[c>>2]=d+-4;while(0);e=a;d=k[a>>2]|0}d=p+12|0;c=k[d>>2]|0;if((c|0)==256){r=K;return}else m=c;while(1){a=p+8|0;c=k[a>>2]|0;f=(c|0)==0;e=c;if(!(!f?(H=k[p+16>>2]|0,!((H|0)>0?(k[c+16>>2]|0)!=(H|0):0)):0)){n=h;j=n+32|0;k[n+4>>2]=0;k[h>>2]=e;k[n+8>>2]=0;if(!f)k[c+4>>2]=n;k[n+12>>2]=m;H=k[p+16>>2]|0;k[n+16>>2]=H;k[n+24>>2]=k[p>>2];k[a>>2]=n;c=n+20|0;o[c>>2]=3402823466385288598117041.0e14;h=n+28|0;i[h>>0]=1;if((H|0)<(k[I>>2]|0)){h=j;c=n}else{o[c>>2]=-1.0;i[h>>0]=0;h=j;c=n}}k[d>>2]=256;BYa(c,J,0,0,1);d=p+-8|0;m=k[d>>2]|0;if((m|0)==256)break;else p=p+-20|0}r=K;return}function xYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0.0;q=r;r=r+16|0;n=q;o=b;a:while(1){j=o;m=o+-16|0;while(1){b:while(1){i=a;b=j-i|0;c=b>>4;switch(c|0){case 2:{l=5;break a}case 3:{l=7;break a}case 4:{l=15;break a}case 5:{l=16;break a}case 1:case 0:{l=83;break a}default:{}}if((b|0)<496){l=22;break a}h=a+(((c|0)/2|0)<<4)|0;do if((b|0)>15984){c=(c|0)/4|0;g=a+(c<<4)|0;c=h+(c<<4)|0;b=zYa(a,g,h,c)|0;if(!(+p[m>>3]<+p[c>>3])){c=h;break};k[n>>2]=k[c>>2];k[n+4>>2]=k[c+4>>2];k[n+8>>2]=k[c+8>>2];k[n+12>>2]=k[c+12>>2];k[c>>2]=k[m>>2];k[c+4>>2]=k[m+4>>2];k[c+8>>2]=k[m+8>>2];k[c+12>>2]=k[m+12>>2];k[m>>2]=k[n>>2];k[m+4>>2]=k[n+4>>2];k[m+8>>2]=k[n+8>>2];k[m+12>>2]=k[n+12>>2];d=b+1|0;if(+p[c>>3]<+p[h>>3]){k[n>>2]=k[h>>2];k[n+4>>2]=k[h+4>>2];k[n+8>>2]=k[h+8>>2];k[n+12>>2]=k[h+12>>2];k[h>>2]=k[c>>2];k[h+4>>2]=k[c+4>>2];k[h+8>>2]=k[c+8>>2];k[h+12>>2]=k[c+12>>2];k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];k[c+12>>2]=k[n+12>>2];c=b+2|0;if(+p[h>>3]<+p[g>>3]){k[n>>2]=k[g>>2];k[n+4>>2]=k[g+4>>2];k[n+8>>2]=k[g+8>>2];k[n+12>>2]=k[g+12>>2];k[g>>2]=k[h>>2];k[g+4>>2]=k[h+4>>2];k[g+8>>2]=k[h+8>>2];k[g+12>>2]=k[h+12>>2];k[h>>2]=k[n>>2];k[h+4>>2]=k[n+4>>2];k[h+8>>2]=k[n+8>>2];k[h+12>>2]=k[n+12>>2];if(+p[g>>3]<+p[a>>3]){k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[g>>2];k[a+4>>2]=k[g+4>>2];k[a+8>>2]=k[g+8>>2];k[a+12>>2]=k[g+12>>2];k[g>>2]=k[n>>2];k[g+4>>2]=k[n+4>>2];k[g+8>>2]=k[n+8>>2];k[g+12>>2]=k[n+12>>2];b=b+4|0;c=h}else{b=b+3|0;c=h}}else{b=c;c=h}}else{b=d;c=h}}else{f=+p[h>>3];b=+p[m>>3]<f;if(!(f<+p[a>>3])){if(!b){b=0;c=h;break};k[n>>2]=k[h>>2];k[n+4>>2]=k[h+4>>2];k[n+8>>2]=k[h+8>>2];k[n+12>>2]=k[h+12>>2];k[h>>2]=k[m>>2];k[h+4>>2]=k[m+4>>2];k[h+8>>2]=k[m+8>>2];k[h+12>>2]=k[m+12>>2];k[m>>2]=k[n>>2];k[m+4>>2]=k[n+4>>2];k[m+8>>2]=k[n+8>>2];k[m+12>>2]=k[n+12>>2];if(!(+p[h>>3]<+p[a>>3])){b=1;c=h;break};k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[h>>2];k[a+4>>2]=k[h+4>>2];k[a+8>>2]=k[h+8>>2];k[a+12>>2]=k[h+12>>2];k[h>>2]=k[n>>2];k[h+4>>2]=k[n+4>>2];k[h+8>>2]=k[n+8>>2];k[h+12>>2]=k[n+12>>2];b=2;c=h;break}if(b){k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[m>>2];k[a+4>>2]=k[m+4>>2];k[a+8>>2]=k[m+8>>2];k[a+12>>2]=k[m+12>>2];k[m>>2]=k[n>>2];k[m+4>>2]=k[n+4>>2];k[m+8>>2]=k[n+8>>2];k[m+12>>2]=k[n+12>>2];b=1;c=h;break};k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[h>>2];k[a+4>>2]=k[h+4>>2];k[a+8>>2]=k[h+8>>2];k[a+12>>2]=k[h+12>>2];k[h>>2]=k[n>>2];k[h+4>>2]=k[n+4>>2];k[h+8>>2]=k[n+8>>2];k[h+12>>2]=k[n+12>>2];if(+p[m>>3]<+p[h>>3]){k[n>>2]=k[h>>2];k[n+4>>2]=k[h+4>>2];k[n+8>>2]=k[h+8>>2];k[n+12>>2]=k[h+12>>2];k[h>>2]=k[m>>2];k[h+4>>2]=k[m+4>>2];k[h+8>>2]=k[m+8>>2];k[h+12>>2]=k[m+12>>2];k[m>>2]=k[n>>2];k[m+4>>2]=k[n+4>>2];k[m+8>>2]=k[n+8>>2];k[m+12>>2]=k[n+12>>2];b=2;c=h}else{b=1;c=h}}while(0);f=+p[a>>3];e=+p[c>>3];if(f<e){c=m;break}else c=m;while(1){c=c+-16|0;if((a|0)==(c|0))break;if(+p[c>>3]<e){l=66;break b}}b=a+16|0;if(!(f<+p[m>>3])){if((b|0)==(m|0)){l=83;break a}while(1){if(f<+p[b>>3])break;b=b+16|0;if((b|0)==(m|0)){l=83;break a}}k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];k[n+8>>2]=k[b+8>>2];k[n+12>>2]=k[b+12>>2];k[b>>2]=k[m>>2];k[b+4>>2]=k[m+4>>2];k[b+8>>2]=k[m+8>>2];k[b+12>>2]=k[m+12>>2];k[m>>2]=k[n>>2];k[m+4>>2]=k[n+4>>2];k[m+8>>2]=k[n+8>>2];k[m+12>>2]=k[n+12>>2];b=b+16|0}if((b|0)==(m|0)){l=83;break a}else c=m;while(1){e=+p[a>>3];while(1){d=b+16|0;if(e<+p[b>>3])break;else b=d}do c=c+-16|0;while(e<+p[c>>3]);if(b>>>0>=c>>>0){a=b;continue b};k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];k[n+8>>2]=k[b+8>>2];k[n+12>>2]=k[b+12>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];k[c+12>>2]=k[n+12>>2];b=d}}if((l|0)==66){l=0;k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];k[c+12>>2]=k[n+12>>2];b=b+1|0}d=a+16|0;c:do if(d>>>0<c>>>0)while(1){e=+p[h>>3];while(1){g=d+16|0;if(+p[d>>3]<e)d=g;else break}do c=c+-16|0;while(!(+p[c>>3]<e));if(d>>>0>c>>>0){c=h;break c};k[n>>2]=k[d>>2];k[n+4>>2]=k[d+4>>2];k[n+8>>2]=k[d+8>>2];k[n+12>>2]=k[d+12>>2];k[d>>2]=k[c>>2];k[d+4>>2]=k[c+4>>2];k[d+8>>2]=k[c+8>>2];k[d+12>>2]=k[c+12>>2];k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];k[c+12>>2]=k[n+12>>2];h=(h|0)==(d|0)?c:h;d=g;b=b+1|0}else c=h;while(0);if((d|0)!=(c|0)?+p[c>>3]<+p[d>>3]:0){k[n>>2]=k[d>>2];k[n+4>>2]=k[d+4>>2];k[n+8>>2]=k[d+8>>2];k[n+12>>2]=k[d+12>>2];k[d>>2]=k[c>>2];k[d+4>>2]=k[c+4>>2];k[d+8>>2]=k[c+8>>2];k[d+12>>2]=k[c+12>>2];k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];k[c+12>>2]=k[n+12>>2];b=b+1|0}if(!b){b=AYa(a,d)|0;c=d+16|0;if(AYa(c,o)|0){l=82;break}if(b){a=c;continue}}h=d;if((h-i|0)>=(j-h|0)){l=81;break}xYa(a,d);a=d+16|0}if((l|0)==81){l=0;xYa(d+16|0,o);o=d;continue}else if((l|0)==82){l=0;if(b){l=83;break}else{o=d;continue}}}if((l|0)==5){if(!(+p[m>>3]<+p[a>>3])){r=q;return};k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[m>>2];k[a+4>>2]=k[m+4>>2];k[a+8>>2]=k[m+8>>2];k[a+12>>2]=k[m+12>>2];k[m>>2]=k[n>>2];k[m+4>>2]=k[n+4>>2];k[m+8>>2]=k[n+8>>2];k[m+12>>2]=k[n+12>>2];r=q;return}else if((l|0)==7){b=a+16|0;f=+p[b>>3];c=+p[m>>3]<f;if(!(f<+p[a>>3])){if(!c){r=q;return};k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];k[n+8>>2]=k[b+8>>2];k[n+12>>2]=k[b+12>>2];k[b>>2]=k[m>>2];k[b+4>>2]=k[m+4>>2];k[b+8>>2]=k[m+8>>2];k[b+12>>2]=k[m+12>>2];k[m>>2]=k[n>>2];k[m+4>>2]=k[n+4>>2];k[m+8>>2]=k[n+8>>2];k[m+12>>2]=k[n+12>>2];if(!(+p[b>>3]<+p[a>>3])){r=q;return};k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[n>>2];k[b+4>>2]=k[n+4>>2];k[b+8>>2]=k[n+8>>2];k[b+12>>2]=k[n+12>>2];r=q;return}if(c){k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[m>>2];k[a+4>>2]=k[m+4>>2];k[a+8>>2]=k[m+8>>2];k[a+12>>2]=k[m+12>>2];k[m>>2]=k[n>>2];k[m+4>>2]=k[n+4>>2];k[m+8>>2]=k[n+8>>2];k[m+12>>2]=k[n+12>>2];r=q;return};k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[n>>2];k[b+4>>2]=k[n+4>>2];k[b+8>>2]=k[n+8>>2];k[b+12>>2]=k[n+12>>2];if(!(+p[m>>3]<+p[b>>3])){r=q;return};k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];k[n+8>>2]=k[b+8>>2];k[n+12>>2]=k[b+12>>2];k[b>>2]=k[m>>2];k[b+4>>2]=k[m+4>>2];k[b+8>>2]=k[m+8>>2];k[b+12>>2]=k[m+12>>2];k[m>>2]=k[n>>2];k[m+4>>2]=k[n+4>>2];k[m+8>>2]=k[n+8>>2];k[m+12>>2]=k[n+12>>2];r=q;return}else if((l|0)==15){zYa(a,a+16|0,a+32|0,m)|0;r=q;return}else if((l|0)==16){b=a+16|0;c=a+32|0;d=a+48|0;zYa(a,b,c,d)|0;if(!(+p[m>>3]<+p[d>>3])){r=q;return};k[n>>2]=k[d>>2];k[n+4>>2]=k[d+4>>2];k[n+8>>2]=k[d+8>>2];k[n+12>>2]=k[d+12>>2];k[d>>2]=k[m>>2];k[d+4>>2]=k[m+4>>2];k[d+8>>2]=k[m+8>>2];k[d+12>>2]=k[m+12>>2];k[m>>2]=k[n>>2];k[m+4>>2]=k[n+4>>2];k[m+8>>2]=k[n+8>>2];k[m+12>>2]=k[n+12>>2];if(!(+p[d>>3]<+p[c>>3])){r=q;return};k[n>>2]=k[c>>2];k[n+4>>2]=k[c+4>>2];k[n+8>>2]=k[c+8>>2];k[n+12>>2]=k[c+12>>2];k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];k[d>>2]=k[n>>2];k[d+4>>2]=k[n+4>>2];k[d+8>>2]=k[n+8>>2];k[d+12>>2]=k[n+12>>2];if(!(+p[c>>3]<+p[b>>3])){r=q;return};k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];k[n+8>>2]=k[b+8>>2];k[n+12>>2]=k[b+12>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];k[c+12>>2]=k[n+12>>2];if(!(+p[b>>3]<+p[a>>3])){r=q;return};k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[n>>2];k[b+4>>2]=k[n+4>>2];k[b+8>>2]=k[n+8>>2];k[b+12>>2]=k[n+12>>2];r=q;return}else if((l|0)==22){c=a+32|0;b=a+16|0;s=+p[b>>3];e=+p[a>>3];f=+p[c>>3];d=f<s;do if(s<e){if(d){k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];k[c+12>>2]=k[n+12>>2];break};k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[n>>2];k[b+4>>2]=k[n+4>>2];k[b+8>>2]=k[n+8>>2];k[b+12>>2]=k[n+12>>2];if(f<+p[b>>3]){k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];k[n+8>>2]=k[b+8>>2];k[n+12>>2]=k[b+12>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];k[c+12>>2]=k[n+12>>2]}}else if(d?(k[n>>2]=k[b>>2],k[n+4>>2]=k[b+4>>2],k[n+8>>2]=k[b+8>>2],k[n+12>>2]=k[b+12>>2],k[b>>2]=k[c>>2],k[b+4>>2]=k[c+4>>2],k[b+8>>2]=k[c+8>>2],k[b+12>>2]=k[c+12>>2],k[c>>2]=k[n>>2],k[c+4>>2]=k[n+4>>2],k[c+8>>2]=k[n+8>>2],k[c+12>>2]=k[n+12>>2],+p[b>>3]<e):0){k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[n>>2];k[b+4>>2]=k[n+4>>2];k[b+8>>2]=k[n+8>>2];k[b+12>>2]=k[n+12>>2]}while(0);b=a+48|0;if((b|0)==(o|0)){r=q;return}while(1){e=+p[b>>3];if(e<+p[c>>3]){h=b+8|0;g=k[h>>2]|0;h=k[h+4>>2]|0;d=b;while(1){k[d>>2]=k[c>>2];k[d+4>>2]=k[c+4>>2];k[d+8>>2]=k[c+8>>2];k[d+12>>2]=k[c+12>>2];if((c|0)==(a|0)){c=a;break}d=c+-16|0;if(e<+p[d>>3]){n=c;c=d;d=n}else break}p[c>>3]=e;n=c+8|0;k[n>>2]=g;k[n+4>>2]=h}c=b+16|0;if((c|0)==(o|0))break;else{n=b;b=c;c=n}}r=q;return}else if((l|0)==83){r=q;return}}function yYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+4|0;c=k[a>>2]|0;e=((k[i>>2]|0)-c|0)/12|0;d=e+1|0;if(d>>>0>357913941)ad(426534,426557,304,426811);j=a+8|0;h=((k[j>>2]|0)-c|0)/12|0;f=h<<1;f=h>>>0<178956970?(f>>>0<d>>>0?d:f):357913941;if(!f)c=0;else{if(f>>>0>357913941){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=f*12|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}d=c+(e*12|0)|0;e=d;g=c+(f*12|0)|0;QP(d,b);b=d+12|0;f=k[a>>2]|0;c=k[i>>2]|0;if((c|0)==(f|0)){c=e;h=f;e=f}else{do{c=c+-12|0;QP(d+-12|0,c);d=e+-12|0;e=d}while((c|0)!=(f|0));c=e;h=k[a>>2]|0;e=k[i>>2]|0}k[a>>2]=c;k[i>>2]=b;k[j>>2]=g;g=h;if((e|0)!=(g|0))do{c=e;e=e+-12|0;f=k[e>>2]|0;b=f;if(f|0){c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(f|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(f)}}while((e|0)!=(g|0));if(!h)return;ggb(h);return}function zYa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0.0;g=r;r=r+16|0;f=g;h=+p[b>>3];e=+p[c>>3]<h;do if(h<+p[a>>3]){if(e){k[f>>2]=k[a>>2];k[f+4>>2]=k[a+4>>2];k[f+8>>2]=k[a+8>>2];k[f+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[f>>2];k[c+4>>2]=k[f+4>>2];k[c+8>>2]=k[f+8>>2];k[c+12>>2]=k[f+12>>2];e=1;break};k[f>>2]=k[a>>2];k[f+4>>2]=k[a+4>>2];k[f+8>>2]=k[a+8>>2];k[f+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[f>>2];k[b+4>>2]=k[f+4>>2];k[b+8>>2]=k[f+8>>2];k[b+12>>2]=k[f+12>>2];if(+p[c>>3]<+p[b>>3]){k[f>>2]=k[b>>2];k[f+4>>2]=k[b+4>>2];k[f+8>>2]=k[b+8>>2];k[f+12>>2]=k[b+12>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[c>>2]=k[f>>2];k[c+4>>2]=k[f+4>>2];k[c+8>>2]=k[f+8>>2];k[c+12>>2]=k[f+12>>2];e=2}else e=1}else if(e){k[f>>2]=k[b>>2];k[f+4>>2]=k[b+4>>2];k[f+8>>2]=k[b+8>>2];k[f+12>>2]=k[b+12>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[c>>2]=k[f>>2];k[c+4>>2]=k[f+4>>2];k[c+8>>2]=k[f+8>>2];k[c+12>>2]=k[f+12>>2];if(+p[b>>3]<+p[a>>3]){k[f>>2]=k[a>>2];k[f+4>>2]=k[a+4>>2];k[f+8>>2]=k[a+8>>2];k[f+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[f>>2];k[b+4>>2]=k[f+4>>2];k[b+8>>2]=k[f+8>>2];k[b+12>>2]=k[f+12>>2];e=2}else e=1}else e=0;while(0);if(!(+p[d>>3]<+p[c>>3])){f=e;r=g;return f|0};k[f>>2]=k[c>>2];k[f+4>>2]=k[c+4>>2];k[f+8>>2]=k[c+8>>2];k[f+12>>2]=k[c+12>>2];k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];k[d>>2]=k[f>>2];k[d+4>>2]=k[f+4>>2];k[d+8>>2]=k[f+8>>2];k[d+12>>2]=k[f+12>>2];if(!(+p[c>>3]<+p[b>>3])){f=e+1|0;r=g;return f|0};k[f>>2]=k[b>>2];k[f+4>>2]=k[b+4>>2];k[f+8>>2]=k[b+8>>2];k[f+12>>2]=k[b+12>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[c>>2]=k[f>>2];k[c+4>>2]=k[f+4>>2];k[c+8>>2]=k[f+8>>2];k[c+12>>2]=k[f+12>>2];if(!(+p[b>>3]<+p[a>>3])){f=e+2|0;r=g;return f|0};k[f>>2]=k[a>>2];k[f+4>>2]=k[a+4>>2];k[f+8>>2]=k[a+8>>2];k[f+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[f>>2];k[b+4>>2]=k[f+4>>2];k[b+8>>2]=k[f+8>>2];k[b+12>>2]=k[f+12>>2];f=e+3|0;r=g;return f|0}function AYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0.0,i=0,j=0,l=0,m=0.0,n=0;l=r;r=r+16|0;i=l;switch(b-a>>4|0){case 2:{c=b+-16|0;if(!(+p[c>>3]<+p[a>>3])){a=1;r=l;return a|0};k[i>>2]=k[a>>2];k[i+4>>2]=k[a+4>>2];k[i+8>>2]=k[a+8>>2];k[i+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[i>>2];k[c+4>>2]=k[i+4>>2];k[c+8>>2]=k[i+8>>2];k[c+12>>2]=k[i+12>>2];a=1;r=l;return a|0}case 3:{e=a+16|0;c=b+-16|0;h=+p[e>>3];d=+p[c>>3]<h;if(!(h<+p[a>>3])){if(!d){a=1;r=l;return a|0};k[i>>2]=k[e>>2];k[i+4>>2]=k[e+4>>2];k[i+8>>2]=k[e+8>>2];k[i+12>>2]=k[e+12>>2];k[e>>2]=k[c>>2];k[e+4>>2]=k[c+4>>2];k[e+8>>2]=k[c+8>>2];k[e+12>>2]=k[c+12>>2];k[c>>2]=k[i>>2];k[c+4>>2]=k[i+4>>2];k[c+8>>2]=k[i+8>>2];k[c+12>>2]=k[i+12>>2];if(!(+p[e>>3]<+p[a>>3])){a=1;r=l;return a|0};k[i>>2]=k[a>>2];k[i+4>>2]=k[a+4>>2];k[i+8>>2]=k[a+8>>2];k[i+12>>2]=k[a+12>>2];k[a>>2]=k[e>>2];k[a+4>>2]=k[e+4>>2];k[a+8>>2]=k[e+8>>2];k[a+12>>2]=k[e+12>>2];k[e>>2]=k[i>>2];k[e+4>>2]=k[i+4>>2];k[e+8>>2]=k[i+8>>2];k[e+12>>2]=k[i+12>>2];a=1;r=l;return a|0}if(d){k[i>>2]=k[a>>2];k[i+4>>2]=k[a+4>>2];k[i+8>>2]=k[a+8>>2];k[i+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[i>>2];k[c+4>>2]=k[i+4>>2];k[c+8>>2]=k[i+8>>2];k[c+12>>2]=k[i+12>>2];a=1;r=l;return a|0};k[i>>2]=k[a>>2];k[i+4>>2]=k[a+4>>2];k[i+8>>2]=k[a+8>>2];k[i+12>>2]=k[a+12>>2];k[a>>2]=k[e>>2];k[a+4>>2]=k[e+4>>2];k[a+8>>2]=k[e+8>>2];k[a+12>>2]=k[e+12>>2];k[e>>2]=k[i>>2];k[e+4>>2]=k[i+4>>2];k[e+8>>2]=k[i+8>>2];k[e+12>>2]=k[i+12>>2];if(!(+p[c>>3]<+p[e>>3])){a=1;r=l;return a|0};k[i>>2]=k[e>>2];k[i+4>>2]=k[e+4>>2];k[i+8>>2]=k[e+8>>2];k[i+12>>2]=k[e+12>>2];k[e>>2]=k[c>>2];k[e+4>>2]=k[c+4>>2];k[e+8>>2]=k[c+8>>2];k[e+12>>2]=k[c+12>>2];k[c>>2]=k[i>>2];k[c+4>>2]=k[i+4>>2];k[c+8>>2]=k[i+8>>2];k[c+12>>2]=k[i+12>>2];a=1;r=l;return a|0}case 4:{zYa(a,a+16|0,a+32|0,b+-16|0)|0;a=1;r=l;return a|0}case 5:{d=a+16|0;e=a+32|0;f=a+48|0;c=b+-16|0;zYa(a,d,e,f)|0;if(!(+p[c>>3]<+p[f>>3])){a=1;r=l;return a|0};k[i>>2]=k[f>>2];k[i+4>>2]=k[f+4>>2];k[i+8>>2]=k[f+8>>2];k[i+12>>2]=k[f+12>>2];k[f>>2]=k[c>>2];k[f+4>>2]=k[c+4>>2];k[f+8>>2]=k[c+8>>2];k[f+12>>2]=k[c+12>>2];k[c>>2]=k[i>>2];k[c+4>>2]=k[i+4>>2];k[c+8>>2]=k[i+8>>2];k[c+12>>2]=k[i+12>>2];if(!(+p[f>>3]<+p[e>>3])){a=1;r=l;return a|0};k[i>>2]=k[e>>2];k[i+4>>2]=k[e+4>>2];k[i+8>>2]=k[e+8>>2];k[i+12>>2]=k[e+12>>2];k[e>>2]=k[f>>2];k[e+4>>2]=k[f+4>>2];k[e+8>>2]=k[f+8>>2];k[e+12>>2]=k[f+12>>2];k[f>>2]=k[i>>2];k[f+4>>2]=k[i+4>>2];k[f+8>>2]=k[i+8>>2];k[f+12>>2]=k[i+12>>2];if(!(+p[e>>3]<+p[d>>3])){a=1;r=l;return a|0};k[i>>2]=k[d>>2];k[i+4>>2]=k[d+4>>2];k[i+8>>2]=k[d+8>>2];k[i+12>>2]=k[d+12>>2];k[d>>2]=k[e>>2];k[d+4>>2]=k[e+4>>2];k[d+8>>2]=k[e+8>>2];k[d+12>>2]=k[e+12>>2];k[e>>2]=k[i>>2];k[e+4>>2]=k[i+4>>2];k[e+8>>2]=k[i+8>>2];k[e+12>>2]=k[i+12>>2];if(!(+p[d>>3]<+p[a>>3])){a=1;r=l;return a|0};k[i>>2]=k[a>>2];k[i+4>>2]=k[a+4>>2];k[i+8>>2]=k[a+8>>2];k[i+12>>2]=k[a+12>>2];k[a>>2]=k[d>>2];k[a+4>>2]=k[d+4>>2];k[a+8>>2]=k[d+8>>2];k[a+12>>2]=k[d+12>>2];k[d>>2]=k[i>>2];k[d+4>>2]=k[i+4>>2];k[d+8>>2]=k[i+8>>2];k[d+12>>2]=k[i+12>>2];a=1;r=l;return a|0}case 1:case 0:{a=1;r=l;return a|0}default:{d=a+32|0;c=a+16|0;m=+p[c>>3];g=+p[a>>3];h=+p[d>>3];e=h<m;do if(m<g){if(e){k[i>>2]=k[a>>2];k[i+4>>2]=k[a+4>>2];k[i+8>>2]=k[a+8>>2];k[i+12>>2]=k[a+12>>2];k[a>>2]=k[d>>2];k[a+4>>2]=k[d+4>>2];k[a+8>>2]=k[d+8>>2];k[a+12>>2]=k[d+12>>2];k[d>>2]=k[i>>2];k[d+4>>2]=k[i+4>>2];k[d+8>>2]=k[i+8>>2];k[d+12>>2]=k[i+12>>2];break};k[i>>2]=k[a>>2];k[i+4>>2]=k[a+4>>2];k[i+8>>2]=k[a+8>>2];k[i+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[i>>2];k[c+4>>2]=k[i+4>>2];k[c+8>>2]=k[i+8>>2];k[c+12>>2]=k[i+12>>2];if(h<+p[c>>3]){k[i>>2]=k[c>>2];k[i+4>>2]=k[c+4>>2];k[i+8>>2]=k[c+8>>2];k[i+12>>2]=k[c+12>>2];k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];k[d>>2]=k[i>>2];k[d+4>>2]=k[i+4>>2];k[d+8>>2]=k[i+8>>2];k[d+12>>2]=k[i+12>>2]}}else if(e?(k[i>>2]=k[c>>2],k[i+4>>2]=k[c+4>>2],k[i+8>>2]=k[c+8>>2],k[i+12>>2]=k[c+12>>2],k[c>>2]=k[d>>2],k[c+4>>2]=k[d+4>>2],k[c+8>>2]=k[d+8>>2],k[c+12>>2]=k[d+12>>2],k[d>>2]=k[i>>2],k[d+4>>2]=k[i+4>>2],k[d+8>>2]=k[i+8>>2],k[d+12>>2]=k[i+12>>2],+p[c>>3]<g):0){k[i>>2]=k[a>>2];k[i+4>>2]=k[a+4>>2];k[i+8>>2]=k[a+8>>2];k[i+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[i>>2];k[c+4>>2]=k[i+4>>2];k[c+8>>2]=k[i+8>>2];k[c+12>>2]=k[i+12>>2]}while(0);c=a+48|0;a:do if((c|0)==(b|0)){d=1;c=0}else{e=0;while(1){g=+p[c>>3];if(g<+p[d>>3]){j=c+8|0;i=k[j>>2]|0;j=k[j+4>>2]|0;f=c;while(1){k[f>>2]=k[d>>2];k[f+4>>2]=k[d+4>>2];k[f+8>>2]=k[d+8>>2];k[f+12>>2]=k[d+12>>2];if((d|0)==(a|0)){d=a;break}f=d+-16|0;if(g<+p[f>>3]){n=d;d=f;f=n}else break}p[d>>3]=g;d=d+8|0;k[d>>2]=i;k[d+4>>2]=j;d=e+1|0;f=c+16|0;if((d|0)==8){d=0;c=(f|0)==(b|0);break a}else{e=d;d=f}}else d=c+16|0;if((d|0)==(b|0)){d=1;c=0;break}else{n=c;c=d;d=n}}}while(0);n=c|d;r=l;return n|0}}return 0}function BYa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0;s=r;r=r+16|0;l=s+4|0;i=s;q=a+20|0;if(+o[q>>2]>=0.0){r=s;return}n=k[b>>2]|0;k[l>>2]=0;k[i>>2]=0;f=k[a>>2]|0;p=a+16|0;a:do if(f|0?(k[p>>2]|0)>=(k[b+4>>2]|0):0){do{g=f+20|0;h=+o[g>>2];if(h<0.0){m=(f|0)==(k[a>>2]|0);BYa(f,b,m?l:0,m?i:0,e);h=+o[g>>2]}if(h<0.0)break a;f=k[f+8>>2]|0}while((f|0)!=0);f=k[i>>2]|0;if(f){m=(k[f+16>>2]|0)>(k[p>>2]|0)?f:a;j=9}else{m=a;j=9}}else{m=a;j=9}while(0);do if((j|0)==9){f=k[l>>2]|0;b:do if(f){i=a+12|0;if((f|0)==(a|0))f=a;else{g=(k[i>>2]|0)-n|0;while(1){if((k[f+12>>2]|0)>=(g|0))break b;f=k[f+4>>2]|0;if((f|0)==(a|0)){f=a;break}}}}else{i=a+12|0;f=a;while(1){g=k[f>>2]|0;if(!g)break b;if((k[g+12>>2]|0)<((k[i>>2]|0)-n|0))break;else f=g}}while(0);g=m;while(1){j=g+4|0;l=k[j>>2]|0;if(!l)break;if((k[l+12>>2]|0)>((k[i>>2]|0)+n|0))break;else g=l}if(c|0)k[c>>2]=f;if(d|0)k[d>>2]=g;if((!e?(k[j>>2]|0)==0:0)?(k[g+12>>2]|0)<((k[i>>2]|0)+n|0):0)break;o[q>>2]=+((k[g+16>>2]|0)-(k[f+16>>2]|0)|0)/+(k[p>>2]|0);f=k[a>>2]|0;if(f|0)do{CYa(f,b);f=k[f+8>>2]|0}while((f|0)!=0);if(e?(k[a+4>>2]|0)==0:0)CYa(a,b)}while(0);r=s;return}function CYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0.0,v=0;t=r;r=r+16|0;s=t;c=a+28|0;if(i[c>>0]|0){r=t;return}i[c>>0]=1;l=a+16|0;c=k[l>>2]|0;if((c|0)<(k[b+4>>2]|0)){r=t;return}if((c|0)>(k[b+8>>2]|0)){r=t;return}f=+o[a+20>>2];if(f<0.0){r=t;return}if(f>+p[b+16>>3]){r=t;return}c=k[a>>2]|0;a:do if(c|0){while(1){u=+o[c+20>>2];if(u>=0.0&f>u)break;c=k[c+8>>2]|0;if(!c)break a}r=t;return}while(0);c=k[a+4>>2]|0;if(c|0?(u=+o[c+20>>2],!(!(u>=0.0)|!(f>=u))):0){r=t;return}c=b+64|0;d=k[c>>2]|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;e=d+4|0;g=k[e>>2]|0;if((g|0)==(k[d+8>>2]|0))yYa(d,s);else{QP(g,s);k[e>>2]=(k[e>>2]|0)+12}d=k[(k[c>>2]|0)+4>>2]|0;c=k[l>>2]|0;h=k[d+-8>>2]|0;g=k[d+-12>>2]|0;j=d+-12|0;d=d+-8|0;e=h-g>>3;if(c>>>0<=e>>>0){if(c>>>0<e>>>0?(m=g+(c<<3)|0,(h|0)!=(m|0)):0)k[d>>2]=h+(~((h+-8-m|0)>>>3)<<3)}else{Uja(j,c-e|0);c=k[l>>2]|0}n=k[b+72>>2]|0;q=k[b+76>>2]|0;if((c|0)>0){h=k[j>>2]|0;l=2147483647;j=2147483647;g=-2147483648;m=-2147483648;d=k[a+24>>2]|0;e=0;while(1){a=(d|0)/(q|0)|0;v=d-(aa(a,q)|0)|0;l=(v|0)<(l|0)?v:l;g=(g|0)<(v|0)?v:g;j=(a|0)<(j|0)?a:j;m=(m|0)<(a|0)?a:m;k[h+(e<<3)>>2]=v;k[h+(e<<3)+4>>2]=a;e=e+1|0;if((e|0)==(c|0))break;else d=k[n+(d<<2)>>2]&536870911}c=g+1|0;d=m+1|0}else{c=-2147483647;d=-2147483647;l=2147483647;j=2147483647}h=k[b+68>>2]|0;g=c-l|0;c=d-j|0;k[s>>2]=l;k[s+4>>2]=j;k[s+8>>2]=g;k[s+12>>2]=c;d=h+4|0;e=k[d>>2]|0;if((e|0)==(k[h+8>>2]|0))SRa(h,s);else{k[e>>2]=l;k[e+4>>2]=j;k[e+8>>2]=g;k[e+12>>2]=c;k[d>>2]=e+16}r=t;return}function DYa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=143116;b=k[a+84>>2]|0;c=b;if(b|0){d=a+88|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-32-c|0)>>>5)<<5);ggb(b)}b=k[a+72>>2]|0;c=b;if(b|0){d=a+76|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+60>>2]|0;c=b;if(b|0){d=a+64|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+40|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+20|0;c=a+8|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function EYa(a){a=a|0;ggb(a);return}function FYa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function GYa(a){a=a|0;return}function HYa(a){a=a|0;ggb(a);return}function IYa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,q=0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0.0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0.0;Qc=r;r=r+5888|0;Ec=Qc+4824|0;Ic=Qc+4768|0;Qb=Qc+672|0;Jc=Qc+616|0;Tb=Qc+560|0;Pc=Qc+488|0;Oc=Qc+432|0;Nc=Qc+368|0;Mc=Qc+312|0;Lc=Qc+264|0;Kc=Qc+216|0;Ab=Qc+160|0;Bb=Qc+104|0;Cb=Qc+48|0;Db=Qc+32|0;Eb=Qc+552|0;Fb=Qc+544|0;Gb=Qc;Ub=Qc+424|0;Pb=a+36|0;if((k[Pb>>2]|0)<=1){g=Ec+4|0;h=ZT(20)|0;k[h>>2]=1;vb=h+4|0;k[Ec>>2]=vb;k[g>>2]=14;i[h+18>>0]=0;D=390318;wb=vb+14|0;do{i[vb>>0]=i[D>>0]|0;vb=vb+1|0;D=D+1|0}while((vb|0)<(wb|0));Y8(-215,Ec,390333,390350,960);k[g>>2]=0;k[Ec>>2]=0;Hc=k[h>>2]|0;k[h>>2]=Hc+-1;if((Hc|0)==1)ggb(k[h+-4>>2]|0)}Ob=(k[e>>2]&2031616|0)!=0;if(!(Ob|f^1)){r=Qc;return}if(G2(b)|0){r=Qc;return}h=k[Pb>>2]|0;Ib=a+20|0;zb=k[Ib>>2]|0;h=(h|0)<8?4:(h|0)/2|0;zb=((zb|0)<(h|0)?h:zb)+1|0;h=(n9(c9()|0)|0)+16|0;g=k[h>>2]|0;if((g|0)<0){k[h>>2]=0;g=0}Hb=(g|0)>0;do if((k[b>>2]&2031616|0)==65536){n=k[b+4>>2]|0;k[Pc>>2]=k[n>>2];t=Pc+4|0;g=n+4|0;k[t>>2]=k[g>>2];Hc=Pc+8|0;k[Hc>>2]=k[n+8>>2];k[Pc+12>>2]=k[n+12>>2];k[Pc+16>>2]=k[n+16>>2];k[Pc+20>>2]=k[n+20>>2];k[Pc+24>>2]=k[n+24>>2];k[Pc+28>>2]=k[n+28>>2];k[Pc+32>>2]=k[n+32>>2];h=k[n+36>>2]|0;k[Pc+36>>2]=h;j=Pc+40|0;k[j>>2]=Hc;Hc=Pc+48|0;s=Pc+44|0;k[s>>2]=Hc;k[Pc+52>>2]=0;k[Hc>>2]=0;if(h|0){Hc=h+12|0;k[Hc>>2]=(k[Hc>>2]|0)+1}if((k[g>>2]|0)<3){Gc=k[n+44>>2]|0;Hc=k[s>>2]|0;k[Hc>>2]=k[Gc>>2];k[Hc+4>>2]=k[Gc+4>>2];break}k[t>>2]=0;x1(Pc,k[g>>2]|0,0,0,0);if((k[t>>2]|0)>0){q=k[n+40>>2]|0;m=k[j>>2]|0;j=k[n+44>>2]|0;h=k[s>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[q+(g<<2)>>2];k[h+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[t>>2]|0))}}else Q1(Pc,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){m=k[c+4>>2]|0;k[Oc>>2]=k[m>>2];t=Oc+4|0;g=m+4|0;k[t>>2]=k[g>>2];Hc=Oc+8|0;k[Hc>>2]=k[m+8>>2];k[Oc+12>>2]=k[m+12>>2];k[Oc+16>>2]=k[m+16>>2];k[Oc+20>>2]=k[m+20>>2];k[Oc+24>>2]=k[m+24>>2];k[Oc+28>>2]=k[m+28>>2];k[Oc+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[Oc+36>>2]=h;j=Oc+40|0;k[j>>2]=Hc;Hc=Oc+48|0;q=Oc+44|0;k[q>>2]=Hc;k[Oc+52>>2]=0;k[Hc>>2]=0;if(h|0){Hc=h+12|0;k[Hc>>2]=(k[Hc>>2]|0)+1}if((k[g>>2]|0)<3){Gc=k[m+44>>2]|0;Hc=k[q>>2]|0;k[Hc>>2]=k[Gc>>2];k[Hc+4>>2]=k[Gc+4>>2];break}k[t>>2]=0;x1(Oc,k[g>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[m+40>>2]|0;n=k[j>>2]|0;j=k[m+44>>2]|0;h=k[q>>2]|0;g=0;do{k[n+(g<<2)>>2]=k[s+(g<<2)>>2];k[h+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[t>>2]|0))}}else Q1(Oc,c,-1);while(0);if(k[Pc>>2]&4095|0){Hc=Ec+4|0;Gc=Hc+4|0;k[Gc>>2]=0;k[Gc+4>>2]=0;k[Ec>>2]=33619968;k[Hc>>2]=Pc;$aa(b,Ec,6,0)}g=k[a+16>>2]|0;Sb=d+4|0;j=k[d>>2]|0;h=(k[Sb>>2]|0)-j|0;s=(h|0)/28|0;if(f){a:do if((h|0)>0){q=Ec+4|0;g=0;n=0;h=1;while(1){m=k[j+(n*28|0)+20>>2]|0;if((m|0)<=-1){k[Ec>>2]=0;k[q>>2]=0;j=ZT(16)|0;k[j>>2]=1;vb=j+4|0;k[Ec>>2]=vb;k[q>>2]=10;i[j+14>>0]=0;D=390418;wb=vb+10|0;do{i[vb>>0]=i[D>>0]|0;vb=vb+1|0;D=D+1|0}while((vb|0)<(wb|0));Y8(-215,Ec,390333,390350,997);k[q>>2]=0;k[Ec>>2]=0;Hc=k[j>>2]|0;k[j>>2]=Hc+-1;if((Hc|0)==1)ggb(k[j+-4>>2]|0)}if((n|0)>0)h=h&(m|0)>=(k[(k[d>>2]|0)+((n+-1|0)*28|0)+20>>2]|0);g=(g|0)<(m|0)?m:g;j=n+1|0;if((j|0)>=(s|0))break a;n=j;j=k[d>>2]|0}}else{g=0;h=1}while(0);Rb=g+1|0}else{Rb=g;h=1}yb=(Rb|0)==0;if(!yb){if(Rb>>>0>268435455)ad(426534,426557,304,426811);n=Rb<<4;m=(n|0)==0?1:n;while(1){j=fgb(m)|0;if(j|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){j=0;break}Qh[g&7]()}g=j;zpb(j|0,0,n|0)|0;t=j+n|0;if(!yb){if(Rb>>>0>1073741823)ad(426534,426557,304,426811);n=Rb<<2;m=(n|0)==0?1:n;while(1){j=fgb(m)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}s=j+(Rb<<2)|0;zpb(j|0,0,n|0)|0;if(yb)Hc=0;else{q=Rb<<2;n=(q|0)==0?1:q;while(1){m=fgb(n)|0;if(m|0)break;m=k[207666]|0;k[207666]=m+0;if(!m){m=0;break}Qh[m&7]()}zpb(m|0,0,q|0)|0;Hc=m}}else{Hc=0;j=0;s=0}}else{Hc=0;j=0;g=0;t=0;s=0}k[Nc>>2]=1124007936;Fc=Nc+4|0;m=Nc+8|0;Cc=Nc+40|0;vb=Fc;wb=vb+36|0;do{k[vb>>2]=0;vb=vb+4|0}while((vb|0)<(wb|0));k[Cc>>2]=m;Gc=Nc+48|0;Dc=Nc+44|0;k[Dc>>2]=Gc;k[Nc+52>>2]=0;k[Gc>>2]=0;k[Mc>>2]=1124007936;zc=Mc+4|0;Kb=Mc+8|0;yc=Mc+40|0;vb=zc;wb=vb+36|0;do{k[vb>>2]=0;vb=vb+4|0}while((vb|0)<(wb|0));k[yc>>2]=Kb;Bc=Mc+48|0;Ac=Mc+44|0;k[Ac>>2]=Bc;k[Mc+52>>2]=0;k[Bc>>2]=0;k[Lc>>2]=1124007936;uc=Lc+4|0;tc=Lc+32|0;k[uc>>2]=0;k[uc+4>>2]=0;k[uc+8>>2]=0;k[uc+12>>2]=0;k[uc+16>>2]=0;k[uc+20>>2]=0;k[uc+24>>2]=0;k[tc>>2]=Lc+8;xc=Lc+40|0;vc=Lc+36|0;k[vc>>2]=xc;k[Lc+44>>2]=0;k[xc>>2]=0;k[Kc>>2]=1124007936;nc=Kc+4|0;kc=Kc+32|0;k[nc>>2]=0;k[nc+4>>2]=0;k[nc+8>>2]=0;k[nc+12>>2]=0;k[nc+16>>2]=0;k[nc+20>>2]=0;k[nc+24>>2]=0;k[kc>>2]=Kc+8;pc=Kc+40|0;oc=Kc+36|0;k[oc>>2]=pc;k[Kc+44>>2]=0;k[pc>>2]=0;C=Pc+8|0;q=k[C>>2]|0;xb=zb<<1;m=q+xb|0;D=Pc+12|0;n=k[D>>2]|0;B=xb+15+n&-16;Nb=(Rb|0)>0;b:do if(Nb){z=a+24|0;E=+p[a+8>>3];A=g;y=0;b=0;c=0;while(1){w=+R(+E,+(+(c-(k[z>>2]|0)|0)));o[Hc+(c<<2)>>2]=w;v=+(n|0)/w;n=(o[u>>2]=v,k[u>>2]|0);if((n&2130706432)>>>0<=1249902592){n=(n|0)<0;v=n?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(v==0.0)v=n?-0.0:0.0}x=~~v;v=+(q|0)/w;n=(o[u>>2]=v,k[u>>2]|0);if((n&2130706432)>>>0<=1249902592){n=(n|0)<0;v=n?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(v==0.0)v=n?-0.0:0.0}rc=~~v;q=x+xb|0;wc=(q+y|0)>(B|0);n=wc?0:y;b=(wc?m:0)+b|0;m=wc?rc+xb|0:m;wc=n+zb|0;sc=b+zb|0;k[A+(c<<4)>>2]=wc;k[A+(c<<4)+4>>2]=sc;k[A+(c<<4)+8>>2]=x;k[A+(c<<4)+12>>2]=rc;wc=(aa(sc,B)|0)+wc|0;k[j+(c<<2)>>2]=wc;c=c+1|0;if((c|0)==(Rb|0)){mc=j;j=b;break b}y=n+q|0;n=k[D>>2]|0;q=k[C>>2]|0}}else{mc=j;j=0}while(0);c=m+j|0;k[Ec>>2]=c;Jb=Ec+4|0;k[Jb>>2]=B;G1(Nc,2,Ec,0);sc=Oc+16|0;do if(k[sc>>2]|0){n=k[Oc+4>>2]|0;if((n|0)<3)j=aa(k[Oc+12>>2]|0,k[Oc+8>>2]|0)|0;else{q=k[Oc+40>>2]|0;m=0;j=1;do{j=aa(k[q+(m<<2)>>2]|0,j)|0;m=m+1|0}while((m|0)!=(n|0))}if(j|0){if(((((k[zc>>2]|0)<3?(k[Kb>>2]|0)==(c|0):0)?(k[Mc+12>>2]|0)==(B|0):0)?(k[Mc>>2]&4095|0)==0:0)?k[Mc+16>>2]|0:0)break;k[Ec>>2]=c;k[Jb>>2]=B;G1(Mc,2,Ec,0)}}while(0);k[Ab>>2]=k[Pc>>2];gc=Ab+4|0;wc=Pc+4|0;j=k[wc>>2]|0;k[gc>>2]=j;fc=Ab+8|0;k[fc>>2]=k[C>>2];k[Ab+12>>2]=k[D>>2];bc=Ab+16|0;qc=Pc+16|0;k[bc>>2]=k[qc>>2];k[Ab+20>>2]=k[Pc+20>>2];k[Ab+24>>2]=k[Pc+24>>2];k[Ab+28>>2]=k[Pc+28>>2];ac=Ab+32|0;lc=Pc+32|0;k[ac>>2]=k[lc>>2];cc=Ab+36|0;rc=Pc+36|0;m=k[rc>>2]|0;k[cc>>2]=m;dc=Ab+40|0;k[dc>>2]=fc;fc=Ab+48|0;ec=Ab+44|0;k[ec>>2]=fc;k[Ab+52>>2]=0;k[fc>>2]=0;if(m){j=m+12|0;k[j>>2]=(k[j>>2]|0)+1;j=k[wc>>2]|0}if((j|0)>=3){k[gc>>2]=0;x1(Ab,j,0,0,0);if((k[gc>>2]|0)>0){m=k[Pc+40>>2]|0;n=k[dc>>2]|0;q=k[Pc+44>>2]|0;c=k[ec>>2]|0;j=0;do{k[n+(j<<2)>>2]=k[m+(j<<2)>>2];k[c+(j<<2)>>2]=k[q+(j<<2)>>2];j=j+1|0}while((j|0)<(k[gc>>2]|0))}}else{ic=k[Pc+44>>2]|0;jc=k[ec>>2]|0;k[jc>>2]=k[ic>>2];k[jc+4>>2]=k[ic+4>>2]}k[Bb>>2]=k[Oc>>2];Zb=Bb+4|0;jc=Oc+4|0;j=k[jc>>2]|0;k[Zb>>2]=j;$b=Bb+8|0;tb=Oc+8|0;k[$b>>2]=k[tb>>2];ub=Oc+12|0;k[Bb+12>>2]=k[ub>>2];Wb=Bb+16|0;k[Wb>>2]=k[sc>>2];k[Bb+20>>2]=k[Oc+20>>2];k[Bb+24>>2]=k[Oc+24>>2];k[Bb+28>>2]=k[Oc+28>>2];Vb=Bb+32|0;hc=Oc+32|0;k[Vb>>2]=k[hc>>2];Xb=Bb+36|0;ic=Oc+36|0;m=k[ic>>2]|0;k[Xb>>2]=m;Yb=Bb+40|0;k[Yb>>2]=$b;$b=Bb+48|0;_b=Bb+44|0;k[_b>>2]=$b;k[Bb+52>>2]=0;k[$b>>2]=0;if(m){j=m+12|0;k[j>>2]=(k[j>>2]|0)+1;j=k[jc>>2]|0}if((j|0)>=3){k[Zb>>2]=0;x1(Bb,j,0,0,0);if((k[Zb>>2]|0)>0){m=k[Oc+40>>2]|0;n=k[Yb>>2]|0;q=k[Oc+44>>2]|0;c=k[_b>>2]|0;j=0;do{k[n+(j<<2)>>2]=k[m+(j<<2)>>2];k[c+(j<<2)>>2]=k[q+(j<<2)>>2];j=j+1|0}while((j|0)<(k[Zb>>2]|0))}}else{vb=k[Oc+44>>2]|0;wb=k[_b>>2]|0;k[wb>>2]=k[vb>>2];k[wb+4>>2]=k[vb+4>>2]}if(Nb){x=Ec+4|0;y=Ec+8|0;z=Ec+12|0;A=Qb+4|0;B=Qb+8|0;C=Qb+40|0;D=Qb+48|0;F=Qb+44|0;G=Qb+52|0;H=Tb+4|0;I=Tb+8|0;J=Tb+12|0;K=Tb+4|0;L=Tb+8|0;M=Tb+40|0;O=Tb+48|0;U=Tb+44|0;V=Tb+52|0;W=a+24|0;X=Cb+8|0;Y=Cb+12|0;Z=Cb+4|0;_=Db+4|0;$=_+4|0;ba=Cb+8|0;ca=Cb+12|0;da=Cb+4|0;ea=Db+4|0;fa=ea+4|0;ga=Oc+40|0;ha=Tb+36|0;ia=Tb+16|0;ja=Jc+36|0;ka=Jc+16|0;la=Jc+4|0;ma=Jc+40|0;na=Jc+44|0;oa=Jc+48|0;pa=Qb+36|0;qa=Qb+16|0;ra=Ic+36|0;sa=Ic+16|0;ta=Ic+4|0;ua=Ic+40|0;va=Ic+44|0;wa=Ic+48|0;xa=Cb+8|0;ya=Cb+12|0;za=Cb+4|0;Aa=Db+4|0;Ba=Aa+4|0;Ca=Eb+4|0;Da=Cb+8|0;Ea=Cb+12|0;Fa=Cb+4|0;Ga=Db+4|0;Ha=Ga+4|0;Ia=Cb+8|0;Ja=Cb+12|0;Ka=Cb+4|0;La=Db+4|0;Ma=La+4|0;Na=Cb+8|0;Oa=Cb+12|0;Pa=Cb+4|0;Qa=Db+4|0;Ra=Qa+4|0;Sa=Fb+4|0;Ta=Cb+8|0;Ua=Cb+12|0;Va=Cb+4|0;Wa=Db+4|0;Xa=Wa+4|0;Ya=Cb+36|0;Za=Cb+16|0;_a=Cb+4|0;$a=Cb+40|0;ab=Cb+44|0;bb=Cb+48|0;cb=Db+4|0;db=Db+8|0;eb=Db+12|0;fb=Cb+36|0;gb=Cb+16|0;hb=Cb+4|0;ib=Cb+40|0;jb=Cb+44|0;kb=Cb+48|0;lb=g;mb=Ic+32|0;nb=Qb+32|0;ob=Jc+32|0;pb=Tb+32|0;qb=Cb+32|0;rb=Cb+32|0;sb=0;do{c=k[lb+(sb<<4)+8>>2]|0;b=k[lb+(sb<<4)+12>>2]|0;vb=(k[lb+(sb<<4)+4>>2]|0)-zb|0;k[Ec>>2]=(k[lb+(sb<<4)>>2]|0)-zb;k[x>>2]=vb;k[y>>2]=c+xb;k[z>>2]=b+xb;I1(Ic,Nc,Ec);k[Qb>>2]=1124007936;vb=A;wb=vb+36|0;do{k[vb>>2]=0;vb=vb+4|0}while((vb|0)<(wb|0));k[C>>2]=B;k[F>>2]=D;k[G>>2]=0;k[D>>2]=0;k[Tb>>2]=zb;k[H>>2]=zb;k[I>>2]=c;k[J>>2]=b;I1(Jc,Ic,Tb);k[Tb>>2]=1124007936;vb=K;wb=vb+36|0;do{k[vb>>2]=0;vb=vb+4|0}while((vb|0)<(wb|0));k[M>>2]=L;k[U>>2]=O;k[V>>2]=0;k[O>>2]=0;do if(k[sc>>2]|0){n=k[jc>>2]|0;if((n|0)<3)j=aa(k[ub>>2]|0,k[tb>>2]|0)|0;else{q=k[ga>>2]|0;m=0;j=1;do{j=aa(k[q+(m<<2)>>2]|0,j)|0;m=m+1|0}while((m|0)!=(n|0))}if(!j)break;I1(Cb,Mc,Ec);KG(Qb,Cb)|0;j=k[Ya>>2]|0;do if(j|0){vb=j+12|0;wb=k[vb>>2]|0;k[vb>>2]=wb+-1;if((wb|0)!=1)break;m=k[Ya>>2]|0;if(m|0){j=k[m+4>>2]|0;do if(!j){j=k[rb>>2]|0;if(j|0)break;j=B1()|0;m=k[Ya>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,m)}k[Ya>>2]=0}while(0);k[Ya>>2]=0;k[Za>>2]=0;k[Za+4>>2]=0;k[Za+8>>2]=0;k[Za+12>>2]=0;if((k[_a>>2]|0)>0){m=k[$a>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[_a>>2]|0))}j=k[ab>>2]|0;if(!((j|0)==(bb|0)|(j|0)==0))ggb(k[j+-4>>2]|0);k[Db>>2]=zb;k[cb>>2]=zb;k[db>>2]=c;k[eb>>2]=b;I1(Cb,Qb,Db);KG(Tb,Cb)|0;j=k[fb>>2]|0;do if(j|0){vb=j+12|0;wb=k[vb>>2]|0;k[vb>>2]=wb+-1;if((wb|0)!=1)break;m=k[fb>>2]|0;if(m|0){j=k[m+4>>2]|0;do if(!j){j=k[qb>>2]|0;if(j|0)break;j=B1()|0;m=k[fb>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,m)}k[fb>>2]=0}while(0);k[fb>>2]=0;k[gb>>2]=0;k[gb+4>>2]=0;k[gb+8>>2]=0;k[gb+12>>2]=0;if((k[hb>>2]|0)>0){m=k[ib>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[hb>>2]|0))}j=k[jb>>2]|0;if(!((j|0)==(kb|0)|(j|0)==0))ggb(k[j+-4>>2]|0)}while(0);do if((sb|0)==(k[W>>2]|0)){k[X>>2]=0;k[Y>>2]=0;k[Cb>>2]=16842752;k[Z>>2]=Pc;wb=$;k[wb>>2]=0;k[wb+4>>2]=0;k[Db>>2]=33619968;k[_>>2]=Ic;k[Gb>>2]=0;k[Gb+4>>2]=0;k[Gb+8>>2]=0;k[Gb+12>>2]=0;k[Gb+16>>2]=0;k[Gb+20>>2]=0;k[Gb+24>>2]=0;k[Gb+28>>2]=0;vY(Cb,Db,zb,zb,zb,zb,4,Gb);if(!(k[sc>>2]|0))break;n=k[jc>>2]|0;if((n|0)<3)j=aa(k[ub>>2]|0,k[tb>>2]|0)|0;else{q=k[ga>>2]|0;m=0;j=1;do{j=aa(k[q+(m<<2)>>2]|0,j)|0;m=m+1|0}while((m|0)!=(n|0))}if(!j)break;k[ba>>2]=0;k[ca>>2]=0;k[Cb>>2]=16842752;k[da>>2]=Oc;wb=fa;k[wb>>2]=0;k[wb+4>>2]=0;k[Db>>2]=33619968;k[ea>>2]=Qb;k[Gb>>2]=0;k[Gb+4>>2]=0;k[Gb+8>>2]=0;k[Gb+12>>2]=0;k[Gb+16>>2]=0;k[Gb+20>>2]=0;k[Gb+24>>2]=0;k[Gb+28>>2]=0;vY(Cb,Db,zb,zb,zb,zb,16,Gb)}else{k[xa>>2]=0;k[ya>>2]=0;k[Cb>>2]=16842752;k[za>>2]=Ab;wb=Ba;k[wb>>2]=0;k[wb+4>>2]=0;k[Db>>2]=33619968;k[Aa>>2]=Jc;k[Eb>>2]=c;k[Ca>>2]=b;Rla(Cb,Db,Eb,0.0,0.0,1);do if(k[sc>>2]|0){n=k[jc>>2]|0;if((n|0)<3)j=aa(k[ub>>2]|0,k[tb>>2]|0)|0;else{q=k[ga>>2]|0;m=0;j=1;do{j=aa(k[q+(m<<2)>>2]|0,j)|0;m=m+1|0}while((m|0)!=(n|0))}if(!j)break;k[Na>>2]=0;k[Oa>>2]=0;k[Cb>>2]=16842752;k[Pa>>2]=Bb;wb=Ra;k[wb>>2]=0;k[wb+4>>2]=0;k[Db>>2]=33619968;k[Qa>>2]=Tb;k[Fb>>2]=c;k[Sa>>2]=b;Rla(Cb,Db,Fb,0.0,0.0,1);if((sb|0)<=(k[W>>2]|0))break;k[Ta>>2]=0;k[Ua>>2]=0;k[Cb>>2]=16842752;k[Va>>2]=Tb;wb=Xa;k[wb>>2]=0;k[wb+4>>2]=0;k[Db>>2]=33619968;k[Wa>>2]=Tb;+Yua(Cb,Db,254.0,0.0,3)}while(0);k[Da>>2]=0;k[Ea>>2]=0;k[Cb>>2]=16842752;k[Fa>>2]=Jc;wb=Ha;k[wb>>2]=0;k[wb+4>>2]=0;k[Db>>2]=33619968;k[Ga>>2]=Ic;k[Gb>>2]=0;k[Gb+4>>2]=0;k[Gb+8>>2]=0;k[Gb+12>>2]=0;k[Gb+16>>2]=0;k[Gb+20>>2]=0;k[Gb+24>>2]=0;k[Gb+28>>2]=0;vY(Cb,Db,zb,zb,zb,zb,20,Gb);if(!(k[sc>>2]|0))break;n=k[jc>>2]|0;if((n|0)<3)j=aa(k[ub>>2]|0,k[tb>>2]|0)|0;else{q=k[ga>>2]|0;m=0;j=1;do{j=aa(k[q+(m<<2)>>2]|0,j)|0;m=m+1|0}while((m|0)!=(n|0))}if(!j)break;k[Ia>>2]=0;k[Ja>>2]=0;k[Cb>>2]=16842752;k[Ka>>2]=Tb;wb=Ma;k[wb>>2]=0;k[wb+4>>2]=0;k[Db>>2]=33619968;k[La>>2]=Qb;k[Gb>>2]=0;k[Gb+4>>2]=0;k[Gb+8>>2]=0;k[Gb+12>>2]=0;k[Gb+16>>2]=0;k[Gb+20>>2]=0;k[Gb+24>>2]=0;k[Gb+28>>2]=0;vY(Cb,Db,zb,zb,zb,zb,16,Gb)}while(0);KG(Ab,Jc)|0;KG(Bb,Tb)|0;j=k[ha>>2]|0;do if(j|0){vb=j+12|0;wb=k[vb>>2]|0;k[vb>>2]=wb+-1;if((wb|0)!=1)break;m=k[ha>>2]|0;if(m|0){j=k[m+4>>2]|0;do if(!j){j=k[pb>>2]|0;if(j|0)break;j=B1()|0;m=k[ha>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,m)}k[ha>>2]=0}while(0);k[ha>>2]=0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[K>>2]|0)>0){m=k[M>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[K>>2]|0))}j=k[U>>2]|0;if(!((j|0)==(O|0)|(j|0)==0))ggb(k[j+-4>>2]|0);j=k[ja>>2]|0;do if(j|0){vb=j+12|0;wb=k[vb>>2]|0;k[vb>>2]=wb+-1;if((wb|0)!=1)break;m=k[ja>>2]|0;if(m|0){j=k[m+4>>2]|0;do if(!j){j=k[ob>>2]|0;if(j|0)break;j=B1()|0;m=k[ja>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,m)}k[ja>>2]=0}while(0);k[ja>>2]=0;k[ka>>2]=0;k[ka+4>>2]=0;k[ka+8>>2]=0;k[ka+12>>2]=0;if((k[la>>2]|0)>0){m=k[ma>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[la>>2]|0))}j=k[na>>2]|0;if(!((j|0)==(oa|0)|(j|0)==0))ggb(k[j+-4>>2]|0);j=k[pa>>2]|0;do if(j|0){vb=j+12|0;wb=k[vb>>2]|0;k[vb>>2]=wb+-1;if((wb|0)!=1)break;m=k[pa>>2]|0;if(m|0){j=k[m+4>>2]|0;do if(!j){j=k[nb>>2]|0;if(j|0)break;j=B1()|0;m=k[pa>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,m)}k[pa>>2]=0}while(0);k[pa>>2]=0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[qa+12>>2]=0;if((k[A>>2]|0)>0){m=k[C>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[A>>2]|0))}j=k[F>>2]|0;if(!((j|0)==(D|0)|(j|0)==0))ggb(k[j+-4>>2]|0);j=k[ra>>2]|0;do if(j|0){vb=j+12|0;wb=k[vb>>2]|0;k[vb>>2]=wb+-1;if((wb|0)!=1)break;m=k[ra>>2]|0;if(m|0){j=k[m+4>>2]|0;do if(!j){j=k[mb>>2]|0;if(j|0)break;j=B1()|0;m=k[ra>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,m)}k[ra>>2]=0}while(0);k[ra>>2]=0;k[sa>>2]=0;k[sa+4>>2]=0;k[sa+8>>2]=0;k[sa+12>>2]=0;if((k[ta>>2]|0)>0){m=k[ua>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[ta>>2]|0))}j=k[va>>2]|0;if(!((j|0)==(wa|0)|(j|0)==0))ggb(k[j+-4>>2]|0);sb=sb+1|0}while((sb|0)<(Rb|0))}if(Hb){Gb=Qb+4|0;Fb=Gb+4|0;k[Fb>>2]=0;k[Fb+4>>2]=0;k[Qb>>2]=34209792;k[Gb>>2]=Kc;do if((mc|0)==(s|0))b2(Qb);else{j=s-mc|0;k[Ic>>2]=1124007936;A=Ic+4|0;k[A>>2]=2;c=Ic+8|0;k[c>>2]=1;n=Ic+12|0;k[n>>2]=j;y=Ic+16|0;k[y>>2]=mc;s=Ic+20|0;k[s>>2]=mc;b=Ic+24|0;x=Ic+28|0;z=Ic+40|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[z>>2]=c;C=Ic+48|0;B=Ic+44|0;k[B>>2]=C;k[Ic+52>>2]=0;k[C>>2]=0;if((mc|0)==0&(j|0)!=0){k[Ec>>2]=0;j=Ec+4|0;k[j>>2]=0;m=ZT(36)|0;k[m>>2]=1;vb=m+4|0;k[Ec>>2]=vb;k[j>>2]=28;i[m+32>>0]=0;D=390609;wb=vb+28|0;do{i[vb>>0]=i[D>>0]|0;vb=vb+1|0;D=D+1|0}while((vb|0)<(wb|0));Y8(-215,Ec,390638,390642,410);k[j>>2]=0;k[Ec>>2]=0;Gb=k[m>>2]|0;k[m>>2]=Gb+-1;if((Gb|0)==1)ggb(k[m+-4>>2]|0);q=k[Ic>>2]|16384;j=k[n>>2]|0;n=k[B>>2]|0;m=k[s>>2]|0}else{q=1124024320;n=C;m=mc}k[Ic>>2]=q;k[n>>2]=j;k[n+4>>2]=1;n=m+(aa(k[c>>2]|0,j)|0)|0;k[x>>2]=n;k[b>>2]=n+(0-j)+j;mY(Ic,Qb);n=Ic+36|0;j=k[n>>2]|0;do if(j|0){Fb=j+12|0;Gb=k[Fb>>2]|0;k[Fb>>2]=Gb+-1;if((Gb|0)!=1)break;m=k[n>>2]|0;if(m|0){j=k[m+4>>2]|0;do if(!j){j=k[Ic+32>>2]|0;if(j|0)break;j=B1()|0;m=k[n>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,m)}k[n>>2]=0}while(0);k[n>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[A>>2]|0)>0){m=k[z>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[A>>2]|0))}j=k[B>>2]|0;if((j|0)==(C|0)|(j|0)==0)break;ggb(k[j+-4>>2]|0)}while(0)}do if(f){Lb=k[Pc+40>>2]|0;cXa(d,k[Lb+4>>2]|0,k[Lb>>2]|0,k[Ib>>2]|0);if(!h){if(yb){x=0;n=0}else{if(Rb>>>0>357913941)ad(426534,426557,304,426811);m=Rb*12|0;j=(m|0)==0?1:m;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}zpb(h|0,0,m|0)|0;x=h;n=h+(Rb*12|0)|0}h=k[Sb>>2]|0;j=k[d>>2]|0;Lb=h-j|0;b=(Lb|0)/28|0;if((Lb|0)>0){c=Ec+4|0;t=0;do{s=k[j+(t*28|0)+20>>2]|0;if((s|0)<=-1){k[Ec>>2]=0;k[c>>2]=0;h=ZT(16)|0;k[h>>2]=1;vb=h+4|0;k[Ec>>2]=vb;k[c>>2]=10;i[h+14>>0]=0;D=390498;wb=vb+10|0;do{i[vb>>0]=i[D>>0]|0;vb=vb+1|0;D=D+1|0}while((vb|0)<(wb|0));Y8(-215,Ec,390333,390350,1109);k[c>>2]=0;k[Ec>>2]=0;Lb=k[h>>2]|0;k[h>>2]=Lb+-1;if((Lb|0)==1)ggb(k[h+-4>>2]|0);j=k[d>>2]|0}h=j+(t*28|0)|0;m=x+(s*12|0)+4|0;q=k[m>>2]|0;if((q|0)==(k[x+(s*12|0)+8>>2]|0))H6(x+(s*12|0)|0,h);else{k[q>>2]=k[h>>2];k[q+4>>2]=k[j+(t*28|0)+4>>2];Lb=q+8|0;Kb=j+(t*28|0)+8|0;k[Lb>>2]=k[Kb>>2];k[Lb+4>>2]=k[Kb+4>>2];k[Lb+8>>2]=k[Kb+8>>2];k[Lb+12>>2]=k[Kb+12>>2];k[Lb+16>>2]=k[Kb+16>>2];k[m>>2]=(k[m>>2]|0)+28}t=t+1|0;j=k[d>>2]|0}while((t|0)<(b|0));h=k[Sb>>2]|0}if((h|0)!=(j|0))k[Sb>>2]=h+(~(((h+-28-j|0)>>>0)/28|0)*28|0);if(Nb){q=d+8|0;h=x;s=0;do{j=k[h+(s*12|0)>>2]|0;m=k[h+(s*12|0)+4>>2]|0;if((j|0)!=(m|0)){do{h=k[Sb>>2]|0;if((h|0)==(k[q>>2]|0))H6(d,j);else{k[h>>2]=k[j>>2];k[h+4>>2]=k[j+4>>2];Lb=h+8|0;Kb=j+8|0;k[Lb>>2]=k[Kb>>2];k[Lb+4>>2]=k[Kb+4>>2];k[Lb+8>>2]=k[Kb+8>>2];k[Lb+12>>2]=k[Kb+12>>2];k[Lb+16>>2]=k[Kb+16>>2];k[Sb>>2]=(k[Sb>>2]|0)+28}j=j+28|0}while((j|0)!=(m|0));h=x}s=s+1|0}while((s|0)<(Rb|0))}else h=x;if(!h)break;if((n|0)!=(h|0)){do{j=n;n=n+-12|0;q=k[n>>2]|0;s=q;if(q|0){j=j+-8|0;m=k[j>>2]|0;if((m|0)!=(q|0))k[j>>2]=m+(~(((m+-28-s|0)>>>0)/28|0)*28|0);ggb(q)}}while((n|0)!=(h|0));h=x}ggb(h)}}else{if(Hb){f=Ec+4|0;Hb=f+4|0;k[Hb>>2]=0;k[Hb+4>>2]=0;k[Ec>>2]=34209792;k[f>>2]=Lc;mY(Nc,Ec)}q=k[a+4>>2]|0;v=+p[a+8>>3];ca=k[Ib>>2]|0;ha=k[Pb>>2]|0;fa=k[a+32>>2]|0;da=k[a+40>>2]|0;t=t-g|0;ga=t>>4;s=(ga|0)==0;if(s)ma=0;else{if(ga>>>0>1073741823)ad(426534,426557,304,426811);m=t>>2;j=(m|0)==0?1:m;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}zpb(h|0,0,m|0)|0;ma=h}E=1.0/v;n=ga+-1|0;if((t|0)>16){m=0;w=+(q|0)*(1.0-E)/(1.0-+R(+E,+(+(ga|0))));h=0;while(1){j=(o[u>>2]=w,k[u>>2]|0);do if((j&2130706432)>>>0>1249902592)v=w;else{j=(j|0)<0;v=j?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=j?-0.0:0.0}while(0);f=~~v;k[ma+(m<<2)>>2]=f;h=f+h|0;m=m+1|0;if((m|0)>=(n|0))break;else w=E*w}}else h=0;ja=q-h|0;k[ma+(n<<2)>>2]=(ja|0)<0?0:ja;ja=(ha|0)/2|0;h=ja+2|0;if(!h)la=0;else{if(h>>>0>1073741823)ad(426534,426557,304,426811);m=h<<2;j=(m|0)==0?1:m;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}zpb(h|0,0,m|0)|0;la=h}Mb=+(ja|0)*1.4142135381698608*.5;E=Mb+1.0;h=~~E;j=+(h|0)>E;q=~~Mb;q=(+(q|0)<Mb&1)+q|0;if((h|0)>=(j&1|0)){w=+(ja|0);w=w*w;m=h+1+(j<<31>>31)|0;j=0;do{v=+Q(+(w-+(aa(j,j)|0)));p[u>>3]=v;h=k[u+4>>2]|0;f=h&2146435072;do if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){h=(h|0)<0;v=h?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=h?-0.0:0.0}while(0);k[la+(j<<2)>>2]=~~v;j=j+1|0}while((j|0)!=(m|0))}if((ja|0)>=(q|0)){h=0;m=ja;while(1){n=k[la+(h<<2)>>2]|0;while(1){j=h+1|0;if((n|0)==(k[la+(j<<2)>>2]|0))h=j;else break}k[la+(m<<2)>>2]=h;if((m|0)>(q|0)){h=j;m=m+-1|0}else break}}h=k[d>>2]|0;j=k[Sb>>2]|0;if((j|0)!=(h|0))k[Sb>>2]=j+(~(((j+-28-h|0)>>>0)/28|0)*28|0);k[Ic>>2]=0;ka=Ic+4|0;k[ka>>2]=0;k[Ic+8>>2]=0;if(s)ia=0;else{if(ga>>>0>1073741823)ad(426534,426557,304,426811);m=t>>2;j=(m|0)==0?1:m;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}zpb(h|0,0,m|0)|0;ia=h}wTa(Ic,k[ma>>2]<<1);ea=(t|0)>0;if(ea){c=Mc+16|0;b=Qb+4|0;x=Qb+8|0;y=Qb+40|0;z=Qb+48|0;A=Qb+44|0;B=Qb+52|0;C=Jc+8|0;D=Jc+12|0;F=Jc+4|0;G=Tb+8|0;H=Tb+12|0;I=Tb+4|0;J=Ec+40|0;K=(fa|0)==0&1;L=Qb+36|0;M=Qb+16|0;O=Ec+36|0;U=Ec+16|0;V=Ec+4|0;W=Ec+44|0;X=Ec+48|0;Y=d+8|0;w=+(ha|0);Z=Mc+12|0;_=g;$=Ec+32|0;ba=Qb+32|0;t=0;do{s=k[ma+(t<<2)>>2]|0;q=_+(t<<4)|0;I1(Ec,Nc,q);do if(!(k[c>>2]|0))Lb=281;else{m=k[zc>>2]|0;if((m|0)<3)h=aa(k[Z>>2]|0,k[Kb>>2]|0)|0;else{n=k[yc>>2]|0;j=0;h=1;do{h=aa(k[n+(j<<2)>>2]|0,h)|0;j=j+1|0}while((j|0)!=(m|0))}if(!h){Lb=281;break}I1(Qb,Mc,q)}while(0);if((Lb|0)==281){Lb=0;k[Qb>>2]=1124007936;vb=b;wb=vb+36|0;do{k[vb>>2]=0;vb=vb+4|0}while((vb|0)<(wb|0));k[y>>2]=x;k[A>>2]=z;k[B>>2]=0;k[z>>2]=0}while(1){h=fgb(16)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[h>>2]=141536;k[h+4>>2]=da;i[h+8>>0]=1;k[h+12>>2]=2;while(1){j=fgb(16)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}Ib=j+4|0;k[Ib>>2]=1;k[j>>2]=141632;k[j+8>>2]=h;k[Ib>>2]=(k[Ib>>2]|0)+1;f=k[Ib>>2]|0;k[Ib>>2]=f+-1;if((f|0)==1)Uh[k[(k[j>>2]|0)+8>>2]&2047](j);f=k[(k[h>>2]|0)+32>>2]|0;k[C>>2]=0;k[D>>2]=0;k[Jc>>2]=16842752;k[F>>2]=Ec;k[G>>2]=0;k[H>>2]=0;k[Tb>>2]=16842752;k[I>>2]=Qb;dh[f&255](h,Jc,Ic,Tb);do if(j|0){Ib=j+4|0;f=k[Ib>>2]|0;k[Ib>>2]=f+-1;if((f|0)!=1)break;Uh[k[(k[j>>2]|0)+8>>2]&2047](j)}while(0);n=k[J>>2]|0;cXa(Ic,k[n+4>>2]|0,k[n>>2]|0,ca);aXa(Ic,s<<K);n=k[ka>>2]|0;j=k[Ic>>2]|0;f=n-j|0;m=(f|0)/28|0;k[ia+(t<<2)>>2]=m;if((f|0)>0){v=w*+o[Hc+(t<<2)>>2];h=0;do{k[j+(h*28|0)+20>>2]=t;o[j+(h*28|0)+8>>2]=v;h=h+1|0}while((h|0)<(m|0))}if((j|0)!=(n|0))do{h=k[Sb>>2]|0;if((h|0)==(k[Y>>2]|0))H6(d,j);else{k[h>>2]=k[j>>2];k[h+4>>2]=k[j+4>>2];f=h+8|0;Ib=j+8|0;k[f>>2]=k[Ib>>2];k[f+4>>2]=k[Ib+4>>2];k[f+8>>2]=k[Ib+8>>2];k[f+12>>2]=k[Ib+12>>2];k[f+16>>2]=k[Ib+16>>2];k[Sb>>2]=(k[Sb>>2]|0)+28}j=j+28|0}while((j|0)!=(n|0));h=k[L>>2]|0;do if(h|0){Ib=h+12|0;f=k[Ib>>2]|0;k[Ib>>2]=f+-1;if((f|0)!=1)break;j=k[L>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[ba>>2]|0;if(h|0)break;h=B1()|0;j=k[L>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[L>>2]=0}while(0);k[L>>2]=0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[b>>2]|0)>0){j=k[y>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[b>>2]|0))}h=k[A>>2]|0;if(!((h|0)==(z|0)|(h|0)==0))ggb(k[h+-4>>2]|0);h=k[O>>2]|0;do if(h|0){Ib=h+12|0;f=k[Ib>>2]|0;k[Ib>>2]=f+-1;if((f|0)!=1)break;j=k[O>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[$>>2]|0;if(h|0)break;h=B1()|0;j=k[O>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[O>>2]=0}while(0);k[O>>2]=0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[V>>2]|0)>0){j=k[J>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[V>>2]|0))}h=k[W>>2]|0;if(!((h|0)==(X|0)|(h|0)==0))ggb(k[h+-4>>2]|0);t=t+1|0}while((t|0)<(ga|0))}h=(k[Sb>>2]|0)-(k[d>>2]|0)|0;if(h|0){j=(h|0)/28|0;k[Qb>>2]=1124007936;X=Qb+4|0;h=Qb+8|0;V=Qb+40|0;vb=X;wb=vb+36|0;do{k[vb>>2]=0;vb=vb+4|0}while((vb|0)<(wb|0));k[V>>2]=h;Y=Qb+48|0;W=Qb+44|0;k[W>>2]=Y;k[Qb+52>>2]=0;k[Y>>2]=0;k[Jc>>2]=1124007936;M=Jc+4|0;L=Jc+32|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;k[M+16>>2]=0;k[M+20>>2]=0;k[M+24>>2]=0;k[L>>2]=Jc+8;U=Jc+40|0;O=Jc+36|0;k[O>>2]=U;k[Jc+44>>2]=0;k[U>>2]=0;k[Tb>>2]=1124007936;I=Tb+4|0;H=Tb+32|0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;k[I+16>>2]=0;k[I+20>>2]=0;k[I+24>>2]=0;k[H>>2]=Tb+8;K=Tb+40|0;J=Tb+36|0;k[J>>2]=K;k[Tb+44>>2]=0;k[K>>2]=0;k[Ec>>2]=1;k[Jb>>2]=j;v9(Tb,2,Ec,5);if(!fa){h=k[Nc>>2]|0;if(h&4095){k[Ec>>2]=0;h=Ec+4|0;k[h>>2]=0;j=ZT(60)|0;k[j>>2]=1;vb=j+4|0;k[Ec>>2]=vb;k[h>>2]=52;i[j+56>>0]=0;D=390429;wb=vb+52|0;do{i[vb>>0]=i[D>>0]|0;vb=vb+1|0;D=D+1|0}while((vb|0)<(wb|0));Y8(-215,Ec,390482,390350,134);k[h>>2]=0;k[Ec>>2]=0;Lb=k[j>>2]|0;k[j>>2]=Lb+-1;if((Lb|0)==1)ggb(k[j+-4>>2]|0);h=k[Nc>>2]|0}Lb=(k[Sb>>2]|0)-(k[d>>2]|0)|0;D=k[Nc+16>>2]|0;c=((k[Gc>>2]|0)>>>0)/((1212424721>>>(h<<2&28)&15)>>>0)|0;F=Ec+8|0;k[Ec>>2]=F;G=Ec+4|0;k[G>>2]=49;k[F>>2]=0;k[Ec+12>>2]=1;k[Ec+16>>2]=2;k[Ec+20>>2]=3;k[Ec+24>>2]=4;k[Ec+28>>2]=5;k[Ec+32>>2]=6;k[Ec+36>>2]=c;b=c+1|0;k[Ec+40>>2]=b;k[Ec+44>>2]=c+2;k[Ec+48>>2]=c+3;k[Ec+52>>2]=c+4;k[Ec+56>>2]=c+5;k[Ec+60>>2]=c+6;x=c<<1;k[Ec+64>>2]=x;k[Ec+68>>2]=x|1;k[Ec+72>>2]=x+2;k[Ec+76>>2]=x+3;k[Ec+80>>2]=x+4;k[Ec+84>>2]=x+5;k[Ec+88>>2]=x+6;x=c*3|0;k[Ec+92>>2]=x;k[Ec+96>>2]=x+1;k[Ec+100>>2]=x+2;k[Ec+104>>2]=x+3;k[Ec+108>>2]=x+4;k[Ec+112>>2]=x+5;k[Ec+116>>2]=x+6;x=c<<2;k[Ec+120>>2]=x;k[Ec+124>>2]=x|1;k[Ec+128>>2]=x|2;k[Ec+132>>2]=x|3;k[Ec+136>>2]=x+4;k[Ec+140>>2]=x+5;k[Ec+144>>2]=x+6;x=c*5|0;k[Ec+148>>2]=x;k[Ec+152>>2]=x+1;k[Ec+156>>2]=x+2;k[Ec+160>>2]=x+3;k[Ec+164>>2]=x+4;k[Ec+168>>2]=x+5;k[Ec+172>>2]=x+6;x=c*6|0;k[Ec+176>>2]=x;k[Ec+180>>2]=x|1;k[Ec+184>>2]=x+2;k[Ec+188>>2]=x+3;k[Ec+192>>2]=x+4;k[Ec+196>>2]=x+5;k[Ec+200>>2]=x+6;x=(Lb|0)/28|0;if(Lb|0){y=0-c|0;z=1-c|0;A=~c;B=c+-1|0;t=k[d>>2]|0;C=g;s=0;do{v=+o[t+(s*28|0)>>2];h=(o[u>>2]=v,k[u>>2]|0);do if((h&2130706432)>>>0<=1249902592){h=(h|0)<0;v=h?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=h?-0.0:0.0}while(0);j=~~v;v=+o[t+(s*28|0)+4>>2];h=(o[u>>2]=v,k[u>>2]|0);do if((h&2130706432)>>>0<=1249902592){h=(h|0)<0;v=h?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=h?-0.0:0.0}while(0);q=k[t+(s*28|0)+20>>2]|0;h=D+(aa(~~v+-3+(k[C+(q<<4)+4>>2]|0)|0,c)|0)+j+-3|0;q=h+(k[C+(q<<4)>>2]|0)|0;h=0;j=0;m=0;n=0;do{Kb=q+(k[Ec+8+(h<<2)>>2]|0)|0;f=l[Kb+z>>0]|0;Ib=l[Kb+A>>0]|0;Hb=l[Kb+b>>0]|0;Jb=l[Kb+B>>0]|0;Lb=f-Ib+((l[Kb+1>>0]|0)-(l[Kb+-1>>0]|0)<<1)+(Hb-Jb)|0;Kb=Hb-(Ib+f)+Jb+((l[Kb+c>>0]|0)-(l[Kb+y>>0]|0)<<1)|0;n=(aa(Lb,Lb)|0)+n|0;m=(aa(Kb,Kb)|0)+m|0;j=(aa(Kb,Lb)|0)+j|0;h=h+1|0}while((h|0)!=49);v=+(n|0);w=+(m|0);E=+(j|0);Mb=v+w;o[t+(s*28|0)+16>>2]=(v*w-E*E-Mb*(Mb*.03999999910593033))*3.847753306718862e-16;s=s+1|0}while(s>>>0<x>>>0)}h=k[Ec>>2]|0;if((h|0)!=(F|0)){if(h|0)ggb(h);k[Ec>>2]=F;k[G>>2]=264}k[Ec>>2]=0;b=Ec+4|0;k[b>>2]=0;k[Ec+8>>2]=0;wTa(Ec,aa(k[ma>>2]|0,ga)|0);if(ea){h=Ec+8|0;t=0;c=0;do{q=k[ma+(c<<2)>>2]|0;s=k[ia+(c<<2)>>2]|0;n=k[ka>>2]|0;m=k[Ic>>2]|0;j=(n-m|0)/28|0;do if(s>>>0>j>>>0){p9(Ic,s-j|0);m=k[Ic>>2]|0}else{if(s>>>0>=j>>>0)break;j=m+(s*28|0)|0;if((n|0)==(j|0))break;k[ka>>2]=n+(~(((n+-28-j|0)>>>0)/28|0)*28|0)}while(0);j=(k[d>>2]|0)+(t*28|0)|0;n=j+(s*28|0)|0;if(s|0)while(1){k[m>>2]=k[j>>2];k[m+4>>2]=k[j+4>>2];Lb=m+8|0;Kb=j+8|0;k[Lb>>2]=k[Kb>>2];k[Lb+4>>2]=k[Kb+4>>2];k[Lb+8>>2]=k[Kb+8>>2];k[Lb+12>>2]=k[Kb+12>>2];k[Lb+16>>2]=k[Kb+16>>2];j=j+28|0;if((j|0)==(n|0))break;else m=m+28|0}t=s+t|0;aXa(Ic,q);j=k[Ic>>2]|0;n=k[ka>>2]|0;if((j|0)!=(n|0))do{m=k[b>>2]|0;if((m|0)==(k[h>>2]|0))H6(Ec,j);else{k[m>>2]=k[j>>2];k[m+4>>2]=k[j+4>>2];Lb=m+8|0;Kb=j+8|0;k[Lb>>2]=k[Kb>>2];k[Lb+4>>2]=k[Kb+4>>2];k[Lb+8>>2]=k[Kb+8>>2];k[Lb+12>>2]=k[Kb+12>>2];k[Lb+16>>2]=k[Kb+16>>2];k[b>>2]=m+28}j=j+28|0}while((j|0)!=(n|0));c=c+1|0}while((c|0)<(ga|0))}else h=Ec+8|0;m=k[d>>2]|0;k[d>>2]=k[Ec>>2];k[Ec>>2]=m;j=k[Sb>>2]|0;k[Sb>>2]=k[b>>2];k[b>>2]=j;Kb=d+8|0;Lb=k[Kb>>2]|0;k[Kb>>2]=k[h>>2];k[h>>2]=Lb;h=m;if(m|0){if((j|0)!=(m|0))k[b>>2]=j+(~(((j+-28-m|0)>>>0)/28|0)*28|0);ggb(h)}}F=k[d>>2]|0;C=(k[Sb>>2]|0)-F|0;D=(C|0)/28|0;A=k[k[Dc>>2]>>2]|0;z=(A>>>0)/((1212424721>>>(k[Nc>>2]<<2&28)&15)>>>0)|0;do if(C|0){B=Nc+16|0;y=0-ja|0;h=(ha|0)<2;c:do if((ja|0)<(y|0)){if(h){h=0;while(1){o[F+(h*28|0)+12>>2]=0.0;h=h+1|0;if(h>>>0>=D>>>0)break c}}x=g;b=0;do{m=k[F+(b*28|0)+20>>2]|0;v=+o[F+(b*28|0)+4>>2];h=(o[u>>2]=v,k[u>>2]|0);do if((h&2130706432)>>>0<=1249902592){h=(h|0)<0;v=h?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=h?-0.0:0.0}while(0);j=(k[x+(m<<4)+4>>2]|0)+~~v|0;v=+o[F+(b*28|0)>>2];h=(o[u>>2]=v,k[u>>2]|0);do if((h&2130706432)>>>0<=1249902592){h=(h|0)<0;v=h?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=h?-0.0:0.0}while(0);t=(k[B>>2]|0)+(aa(j,A)|0)+((k[x+(m<<4)>>2]|0)+~~v)|0;c=0;s=1;j=0;while(1){n=k[la+(s<<2)>>2]|0;h=0-n|0;if((n|0)<(h|0))h=0;else{q=aa(s,z)|0;m=h;h=0;while(1){Lb=l[t+(m+q)>>0]|0;Kb=l[t+(m-q)>>0]|0;h=Lb+h-Kb|0;j=(aa(Kb+Lb|0,m)|0)+j|0;if((m|0)<(n|0))m=m+1|0;else break}}c=(aa(h,s)|0)+c|0;if((s|0)==(ja|0))break;else s=s+1|0}v=+P(+(+(j|0)));w=+P(+(+(c|0)));if(!(v>=w)){Mb=v/(w+2.220446049250313e-16);v=Mb*Mb;v=90.0-Mb*(v*(v*(8.914000511169434-v*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{Mb=w/(v+2.220446049250313e-16);v=Mb*Mb;v=Mb*(v*(v*(8.914000511169434-v*2.539724588394165)+-18.66744613647461)+57.283626556396484)}Mb=(j|0)<0?180.0-v:v;o[F+(b*28|0)+12>>2]=(c|0)<0?360.0-Mb:Mb;b=b+1|0}while(b>>>0<D>>>0)}else{x=g;if(h){n=0;while(1){m=k[F+(n*28|0)+20>>2]|0;v=+o[F+(n*28|0)+4>>2];h=(o[u>>2]=v,k[u>>2]|0);do if((h&2130706432)>>>0<=1249902592){h=(h|0)<0;v=h?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=h?-0.0:0.0}while(0);j=(k[x+(m<<4)+4>>2]|0)+~~v|0;v=+o[F+(n*28|0)>>2];h=(o[u>>2]=v,k[u>>2]|0);do if((h&2130706432)>>>0<=1249902592){h=(h|0)<0;v=h?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=h?-0.0:0.0}while(0);j=(k[B>>2]|0)+(aa(j,A)|0)+((k[x+(m<<4)>>2]|0)+~~v)|0;m=0;h=y;while(1){m=(aa(l[j+h>>0]|0,h)|0)+m|0;if((h|0)>=(ja|0))break;else h=h+1|0}v=+P(+(+(m|0)));if(!(v>=0.0)){Mb=v*4503599627370496.0;v=Mb*Mb;v=90.0-Mb*(v*(v*(8.914000511169434-v*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{Mb=0.0/(v+2.220446049250313e-16);v=Mb*Mb;v=Mb*(v*(v*(8.914000511169434-v*2.539724588394165)+-18.66744613647461)+57.283626556396484)}o[F+(n*28|0)+12>>2]=(m|0)<0?180.0-v:v;n=n+1|0;if(n>>>0>=D>>>0)break c}}else b=0;do{m=k[F+(b*28|0)+20>>2]|0;v=+o[F+(b*28|0)+4>>2];h=(o[u>>2]=v,k[u>>2]|0);do if((h&2130706432)>>>0<=1249902592){h=(h|0)<0;v=h?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=h?-0.0:0.0}while(0);j=(k[x+(m<<4)+4>>2]|0)+~~v|0;v=+o[F+(b*28|0)>>2];h=(o[u>>2]=v,k[u>>2]|0);do if((h&2130706432)>>>0<=1249902592){h=(h|0)<0;v=h?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=h?-0.0:0.0}while(0);t=(k[B>>2]|0)+(aa(j,A)|0)+((k[x+(m<<4)>>2]|0)+~~v)|0;h=0;j=y;while(1){h=(aa(l[t+j>>0]|0,j)|0)+h|0;if((j|0)<(ja|0))j=j+1|0;else{c=0;s=1;break}}while(1){n=k[la+(s<<2)>>2]|0;j=0-n|0;if((n|0)<(j|0))j=0;else{q=aa(s,z)|0;m=j;j=0;while(1){Lb=l[t+(m+q)>>0]|0;Kb=l[t+(m-q)>>0]|0;j=Lb+j-Kb|0;h=(aa(Kb+Lb|0,m)|0)+h|0;if((m|0)<(n|0))m=m+1|0;else break}}c=(aa(j,s)|0)+c|0;if((s|0)==(ja|0))break;else s=s+1|0}v=+P(+(+(h|0)));w=+P(+(+(c|0)));if(!(v>=w)){Mb=v/(w+2.220446049250313e-16);v=Mb*Mb;v=90.0-Mb*(v*(v*(8.914000511169434-v*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{Mb=w/(v+2.220446049250313e-16);v=Mb*Mb;v=Mb*(v*(v*(8.914000511169434-v*2.539724588394165)+-18.66744613647461)+57.283626556396484)}Mb=(h|0)<0?180.0-v:v;o[F+(b*28|0)+12>>2]=(c|0)<0?360.0-Mb:Mb;b=b+1|0}while(b>>>0<D>>>0)}while(0);if((C|0)>0)h=0;else break;do{Mb=+o[Hc+(k[F+(h*28|0)+20>>2]<<2)>>2];Lb=F+(h*28|0)|0;o[Lb>>2]=Mb*+o[Lb>>2];Lb=F+(h*28|0)+4|0;o[Lb>>2]=Mb*+o[Lb>>2];h=h+1|0}while((h|0)<(D|0))}while(0);m=Tb+24|0;h=k[m>>2]|0;do if(h|0){Kb=h+8|0;Lb=k[Kb>>2]|0;k[Kb>>2]=Lb+-1;if((Lb|0)!=1)break;Lb=k[m>>2]|0;Kb=k[Lb+4>>2]|0;jh[k[(k[Kb>>2]|0)+16>>2]&1023](Kb,Lb);k[m>>2]=0}while(0);if((k[I>>2]|0)>0){j=k[H>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[I>>2]|0))}k[m>>2]=0;h=k[J>>2]|0;if(!((h|0)==(K|0)|(h|0)==0))ggb(k[h+-4>>2]|0);m=Jc+24|0;h=k[m>>2]|0;do if(h|0){Kb=h+8|0;Lb=k[Kb>>2]|0;k[Kb>>2]=Lb+-1;if((Lb|0)!=1)break;Lb=k[m>>2]|0;Kb=k[Lb+4>>2]|0;jh[k[(k[Kb>>2]|0)+16>>2]&1023](Kb,Lb);k[m>>2]=0}while(0);if((k[M>>2]|0)>0){j=k[L>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[M>>2]|0))}k[m>>2]=0;h=k[O>>2]|0;if(!((h|0)==(U|0)|(h|0)==0))ggb(k[h+-4>>2]|0);m=Qb+36|0;h=k[m>>2]|0;do if(h|0){Kb=h+12|0;Lb=k[Kb>>2]|0;k[Kb>>2]=Lb+-1;if((Lb|0)!=1)break;j=k[m>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[Qb+32>>2]|0;if(h|0)break;h=B1()|0;j=k[m>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[m>>2]=0}while(0);k[m>>2]=0;Lb=Qb+16|0;k[Lb>>2]=0;k[Lb+4>>2]=0;k[Lb+8>>2]=0;k[Lb+12>>2]=0;if((k[X>>2]|0)>0){j=k[V>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[X>>2]|0))}h=k[W>>2]|0;if(!((h|0)==(Y|0)|(h|0)==0))ggb(k[h+-4>>2]|0)}if(ia|0)ggb(ia);h=k[Ic>>2]|0;j=h;if(h|0){m=k[ka>>2]|0;if((m|0)!=(h|0))k[ka>>2]=m+(~(((m+-28-j|0)>>>0)/28|0)*28|0);ggb(h)}if(la|0)ggb(la);if(!ma)break;ggb(ma)}while(0);do if(Ob){K=Xh[k[(k[a>>2]|0)+52>>2]&1023](a)|0;h=(k[Sb>>2]|0)-(k[d>>2]|0)|0;if(!h){b2(e);break}c2(e,(h|0)/28|0,K,0,-1,0,0);k[Ic>>2]=0;L=Ic+4|0;k[L>>2]=0;k[Ic+8>>2]=0;zpb(Qb|0,0,4096)|0;h=k[Pb>>2]|0;if((h|0)!=31){q=(h|0)/-2|0;Pb=((h|0)/2|0)+1|0;j=Pb-q|0;if((Pb|0)==(q|0)){h=0;do{k[Qb+(h<<3)>>2]=q;k[Qb+(h<<3)+4>>2]=q;h=h+1|0}while((h|0)!=512);z=Qb}else{h=0;m=882399033;n=0;while(1){Ob=Epb(m|0,0,-130063606,0)|0;Ob=kpb(Ob|0,N|0,n|0,0)|0;Pb=N;k[Qb+(h<<3)>>2]=((Ob>>>0)%(j>>>0)|0)+q;Ob=Epb(Ob|0,0,-130063606,0)|0;m=kpb(Ob|0,N|0,Pb|0,0)|0;k[Qb+(h<<3)+4>>2]=((m>>>0)%(j>>>0)|0)+q;h=h+1|0;if((h|0)==512){z=Qb;break}else n=N}}}else z=145012;G=a+28|0;h=k[G>>2]|0;if((h+-2|0)>>>0>=3){k[Ec>>2]=0;h=Ec+4|0;k[h>>2]=0;j=ZT(44)|0;k[j>>2]=1;vb=j+4|0;k[Ec>>2]=vb;k[h>>2]=38;i[j+42>>0]=0;D=390509;wb=vb+38|0;do{i[vb>>0]=i[D>>0]|0;vb=vb+1|0;D=D+1|0}while((vb|0)<(wb|0));Y8(-215,Ec,390333,390350,1142);k[h>>2]=0;k[Ec>>2]=0;Qb=k[j>>2]|0;k[j>>2]=Qb+-1;if((Qb|0)==1)ggb(k[j+-4>>2]|0);h=k[G>>2]|0}d:do if((h|0)==2){m=Ic+8|0;h=0;do{j=z+(h<<3)|0;n=k[L>>2]|0;if((n|0)==(k[m>>2]|0))Efa(Ic,j);else{k[n>>2]=k[j>>2];k[n+4>>2]=k[z+(h<<3)+4>>2];k[L>>2]=n+8}h=h+1|0}while((h|0)!=512)}else{n=Xh[k[(k[a>>2]|0)+52>>2]&1023](a)|0;x=n<<2;y=k[G>>2]|0;h=aa(y,x)|0;q=k[L>>2]|0;m=k[Ic>>2]|0;j=q-m>>3;do if(h>>>0>j>>>0)Uja(Ic,h-j|0);else{if(h>>>0>=j>>>0)break;h=m+(h<<3)|0;if((q|0)==(h|0))break;k[L>>2]=q+(~((q+-8-h|0)>>>3)<<3)}while(0);if(!((n|0)>0&(y|0)>0))break;c=k[Ic>>2]|0;s=0;j=305419896;h=0;e:while(1){b=aa(s,y)|0;t=0;do{if((t|0)>0){do{j=Epb(j|0,0,-130063606,0)|0;j=kpb(j|0,N|0,h|0,0)|0;h=N;n=j&511;q=k[z+(n<<3)>>2]|0;n=k[z+(n<<3)+4>>2]|0;m=0;do{a=m+b|0;if((k[c+(a<<3)>>2]|0)==(q|0)?(k[c+(a<<3)+4>>2]|0)==(n|0):0)break;m=m+1|0}while((m|0)<(t|0))}while((m|0)!=(t|0));m=q}else{if(t|0)break e;j=Epb(j|0,0,-130063606,0)|0;j=kpb(j|0,N|0,h|0,0)|0;m=j&511;n=k[z+(m<<3)+4>>2]|0;m=k[z+(m<<3)>>2]|0;h=N}a=t+b|0;k[c+(a<<3)>>2]=m;k[c+(a<<3)+4>>2]=n;t=t+1|0}while((t|0)!=(y|0));s=s+1|0;if((s|0)==(x|0))break d}while(1){}}while(0);if(Nb){m=Jc+8|0;n=Jc+12|0;q=Jc+4|0;s=Tb+4|0;t=s+4|0;c=Ub+4|0;b=Ec+36|0;x=Ec+16|0;y=Ec+4|0;z=Ec+40|0;A=Ec+44|0;B=Ec+48|0;C=g;D=Ec+32|0;F=0;do{I1(Ec,Nc,C+(F<<4)|0);k[m>>2]=0;k[n>>2]=0;k[Jc>>2]=16842752;k[q>>2]=Ec;h=t;k[h>>2]=0;k[h+4>>2]=0;k[Tb>>2]=33619968;k[s>>2]=Ec;k[Ub>>2]=7;k[c>>2]=7;uua(Jc,Tb,Ub,2.0,2.0,4);h=k[b>>2]|0;do if(h|0){Qb=h+12|0;a=k[Qb>>2]|0;k[Qb>>2]=a+-1;if((a|0)!=1)break;j=k[b>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[D>>2]|0;if(h|0)break;h=B1()|0;j=k[b>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[b>>2]=0}while(0);k[b>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[y>>2]|0)>0){j=k[z>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[y>>2]|0))}h=k[A>>2]|0;if(!((h|0)==(B|0)|(h|0)==0))ggb(k[h+-4>>2]|0);F=F+1|0}while((F|0)<(Rb|0))}do if((k[e>>2]&2031616|0)==65536){n=k[e+4>>2]|0;k[Jc>>2]=k[n>>2];c=Jc+4|0;h=n+4|0;k[c>>2]=k[h>>2];e=Jc+8|0;k[e>>2]=k[n+8>>2];k[Jc+12>>2]=k[n+12>>2];k[Jc+16>>2]=k[n+16>>2];k[Jc+20>>2]=k[n+20>>2];k[Jc+24>>2]=k[n+24>>2];k[Jc+28>>2]=k[n+28>>2];k[Jc+32>>2]=k[n+32>>2];j=k[n+36>>2]|0;k[Jc+36>>2]=j;m=Jc+40|0;k[m>>2]=e;e=Jc+48|0;s=Jc+44|0;k[s>>2]=e;k[Jc+52>>2]=0;k[e>>2]=0;if(j|0){e=j+12|0;k[e>>2]=(k[e>>2]|0)+1}if((k[h>>2]|0)<3){Ub=k[n+44>>2]|0;e=k[s>>2]|0;k[e>>2]=k[Ub>>2];k[e+4>>2]=k[Ub+4>>2];break}k[c>>2]=0;x1(Jc,k[h>>2]|0,0,0,0);if((k[c>>2]|0)<=0)break;t=k[n+40>>2]|0;q=k[m>>2]|0;m=k[n+44>>2]|0;j=k[s>>2]|0;h=0;do{k[q+(h<<2)>>2]=k[t+(h<<2)>>2];k[j+(h<<2)>>2]=k[m+(h<<2)>>2];h=h+1|0}while((h|0)<(k[c>>2]|0))}else Q1(Jc,e,-1);while(0);I=k[G>>2]|0;J=k[Gc>>2]|0;j=k[d>>2]|0;e=(k[Sb>>2]|0)-j|0;z=(e|0)/28|0;f:do if((e|0)>0){A=Nc+16|0;B=Jc+16|0;C=Jc+44|0;F=Ec+4|0;G=(K|0)>0;H=g;h=0;while(1){n=k[j+(h*28|0)+20>>2]|0;w=1.0/+o[Hc+(n<<2)>>2];Mb=+o[j+(h*28|0)+12>>2]*.01745329238474369;E=+S(+Mb);Mb=+T(+Mb);v=w*+o[j+(h*28|0)+4>>2];m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);m=(k[H+(n<<4)+4>>2]|0)+~~v|0;v=w*+o[j+(h*28|0)>>2];j=(o[u>>2]=v,k[u>>2]|0);do if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;v=j?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=j?-0.0:0.0}while(0);x=(k[A>>2]|0)+(aa(k[k[Dc>>2]>>2]|0,m)|0)+((k[H+(n<<4)>>2]|0)+~~v)|0;j=k[Ic>>2]|0;y=(k[B>>2]|0)+(aa(k[k[C>>2]>>2]|0,h)|0)|0;g:do switch(I|0){case 2:{if(G)t=0;else break g;while(1){Rc=+(k[j>>2]|0);w=+(k[j+4>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+8>>2]|0);w=+(k[j+12>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);s=x+(aa(~~v,J)|0)+n|0;s=(q&255)<(l[s>>0]|0)&1;Rc=+(k[j+16>>2]|0);w=+(k[j+20>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+24>>2]|0);w=+(k[j+28>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);m=x+(aa(~~v,J)|0)+n|0;s=((q&255)<(l[m>>0]|0)&1)<<1|s;Rc=+(k[j+32>>2]|0);w=+(k[j+36>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+40>>2]|0);w=+(k[j+44>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);m=x+(aa(~~v,J)|0)+n|0;s=s|((q&255)<(l[m>>0]|0)&1)<<2;Rc=+(k[j+48>>2]|0);w=+(k[j+52>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+56>>2]|0);w=+(k[j+60>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);m=x+(aa(~~v,J)|0)+n|0;s=s|((q&255)<(l[m>>0]|0)&1)<<3;Rc=+(k[j+64>>2]|0);w=+(k[j+68>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+72>>2]|0);w=+(k[j+76>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);m=x+(aa(~~v,J)|0)+n|0;s=s|((q&255)<(l[m>>0]|0)&1)<<4;Rc=+(k[j+80>>2]|0);w=+(k[j+84>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+88>>2]|0);w=+(k[j+92>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);m=x+(aa(~~v,J)|0)+n|0;s=s|((q&255)<(l[m>>0]|0)&1)<<5;Rc=+(k[j+96>>2]|0);w=+(k[j+100>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+104>>2]|0);w=+(k[j+108>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);m=x+(aa(~~v,J)|0)+n|0;s=s|((q&255)<(l[m>>0]|0)&1)<<6;Rc=+(k[j+112>>2]|0);w=+(k[j+116>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+120>>2]|0);w=+(k[j+124>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);e=x+(aa(~~v,J)|0)+n|0;i[y+t>>0]=s|((q&255)<(l[e>>0]|0)&1)<<7;t=t+1|0;if((t|0)==(K|0))break;else j=j+128|0}break}case 3:{if(G)c=0;else break g;while(1){Rc=+(k[j>>2]|0);w=+(k[j+4>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);s=x+(aa(~~v,J)|0)+n|0;s=i[s>>0]|0;Rc=+(k[j+8>>2]|0);w=+(k[j+12>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+16>>2]|0);w=+(k[j+20>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);t=x+(aa(~~v,J)|0)+n|0;t=i[t>>0]|0;t=(t&255)>(q&255)?((t&255)>(s&255)?2:0):(q&255)>(s&255)&1;Rc=+(k[j+24>>2]|0);w=+(k[j+28>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);s=x+(aa(~~v,J)|0)+n|0;s=i[s>>0]|0;Rc=+(k[j+32>>2]|0);w=+(k[j+36>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+40>>2]|0);w=+(k[j+44>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);m=x+(aa(~~v,J)|0)+n|0;m=i[m>>0]|0;t=((m&255)>(q&255)?((m&255)>(s&255)?2:0):(q&255)>(s&255)&1)<<2|t;Rc=+(k[j+48>>2]|0);w=+(k[j+52>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);s=x+(aa(~~v,J)|0)+n|0;s=i[s>>0]|0;Rc=+(k[j+56>>2]|0);w=+(k[j+60>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+64>>2]|0);w=+(k[j+68>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);m=x+(aa(~~v,J)|0)+n|0;m=i[m>>0]|0;t=t|((m&255)>(q&255)?((m&255)>(s&255)?2:0):(q&255)>(s&255)&1)<<4;Rc=+(k[j+72>>2]|0);w=+(k[j+76>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);s=x+(aa(~~v,J)|0)+n|0;s=i[s>>0]|0;Rc=+(k[j+80>>2]|0);w=+(k[j+84>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+88>>2]|0);w=+(k[j+92>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);e=x+(aa(~~v,J)|0)+n|0;e=i[e>>0]|0;i[y+c>>0]=t|((e&255)>(q&255)?((e&255)>(s&255)?2:0):(q&255)>(s&255)&1)<<6;c=c+1|0;if((c|0)==(K|0))break;else j=j+96|0}break}case 4:{if(G)b=0;else break g;while(1){Rc=+(k[j>>2]|0);w=+(k[j+4>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);t=x+(aa(~~v,J)|0)+n|0;t=i[t>>0]|0;Rc=+(k[j+8>>2]|0);w=+(k[j+12>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);s=x+(aa(~~v,J)|0)+n|0;s=i[s>>0]|0;Rc=+(k[j+16>>2]|0);w=+(k[j+20>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+24>>2]|0);w=+(k[j+28>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);e=x+(aa(~~v,J)|0)+n|0;e=i[e>>0]|0;m=(s&255)>(t&255);c=(e&255)>(q&255);c=((m?s:t)&255)>((c?e:q)&255)?m&1:c?3:2;Rc=+(k[j+32>>2]|0);w=+(k[j+36>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);t=x+(aa(~~v,J)|0)+n|0;t=i[t>>0]|0;Rc=+(k[j+40>>2]|0);w=+(k[j+44>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);s=x+(aa(~~v,J)|0)+n|0;s=i[s>>0]|0;Rc=+(k[j+48>>2]|0);w=+(k[j+52>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+56>>2]|0);w=+(k[j+60>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);Ub=x+(aa(~~v,J)|0)+n|0;Ub=i[Ub>>0]|0;e=(s&255)>(t&255);m=(Ub&255)>(q&255);c=(((e?s:t)&255)>((m?Ub:q)&255)?(e?4:0):m?12:8)|c;Rc=+(k[j+64>>2]|0);w=+(k[j+68>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);t=x+(aa(~~v,J)|0)+n|0;t=i[t>>0]|0;Rc=+(k[j+72>>2]|0);w=+(k[j+76>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);s=x+(aa(~~v,J)|0)+n|0;s=i[s>>0]|0;Rc=+(k[j+80>>2]|0);w=+(k[j+84>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+88>>2]|0);w=+(k[j+92>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);Ub=x+(aa(~~v,J)|0)+n|0;Ub=i[Ub>>0]|0;e=(s&255)>(t&255);m=(Ub&255)>(q&255);c=c|(((e?s:t)&255)>((m?Ub:q)&255)?(e?16:0):m?48:32);Rc=+(k[j+96>>2]|0);w=+(k[j+100>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);t=x+(aa(~~v,J)|0)+n|0;t=i[t>>0]|0;Rc=+(k[j+104>>2]|0);w=+(k[j+108>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);s=x+(aa(~~v,J)|0)+n|0;s=i[s>>0]|0;Rc=+(k[j+112>>2]|0);w=+(k[j+116>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);q=x+(aa(~~v,J)|0)+n|0;q=i[q>>0]|0;Rc=+(k[j+120>>2]|0);w=+(k[j+124>>2]|0);v=E*Rc-Mb*w;w=Mb*Rc+E*w;m=(o[u>>2]=v,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;v=m?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);n=~~v;m=(o[u>>2]=w,k[u>>2]|0);do if((m&2130706432)>>>0>1249902592)v=w;else{m=(m|0)<0;v=m?w+-8388608.0+8388608.0:w+8388608.0+-8388608.0;if(!(v==0.0))break;v=m?-0.0:0.0}while(0);Tb=x+(aa(~~v,J)|0)+n|0;Tb=i[Tb>>0]|0;Ub=(s&255)>(t&255);e=(Tb&255)>(q&255);i[y+b>>0]=c|(((Ub?s:t)&255)>((e?Tb:q)&255)?(Ub?64:0):e?192:128);b=b+1|0;if((b|0)==(K|0))break;else j=j+128|0}break}default:{k[Ec>>2]=0;k[F>>2]=0;j=ZT(44)|0;k[j>>2]=1;vb=j+4|0;k[Ec>>2]=vb;k[F>>2]=38;i[j+42>>0]=0;D=390548;wb=vb+38|0;do{i[vb>>0]=i[D>>0]|0;vb=vb+1|0;D=D+1|0}while((vb|0)<(wb|0));Y8(-201,Ec,390587,390350,342);k[F>>2]=0;k[Ec>>2]=0;e=k[j>>2]|0;k[j>>2]=e+-1;if((e|0)==1)ggb(k[j+-4>>2]|0)}}while(0);h=h+1|0;if((h|0)>=(z|0))break f;j=k[d>>2]|0}}while(0);m=Jc+36|0;h=k[m>>2]|0;do if(h|0){d=h+12|0;Ec=k[d>>2]|0;k[d>>2]=Ec+-1;if((Ec|0)!=1)break;j=k[m>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[Jc+32>>2]|0;if(h|0)break;h=B1()|0;j=k[m>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[m>>2]=0}while(0);k[m>>2]=0;Ec=Jc+16|0;j=Jc+4|0;k[Ec>>2]=0;k[Ec+4>>2]=0;k[Ec+8>>2]=0;k[Ec+12>>2]=0;if((k[j>>2]|0)>0){m=k[Jc+40>>2]|0;h=0;do{k[m+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[j>>2]|0))}h=k[Jc+44>>2]|0;if(!((h|0)==(Jc+48|0)|(h|0)==0))ggb(k[h+-4>>2]|0);h=k[Ic>>2]|0;j=h;if(h|0){m=k[L>>2]|0;if((m|0)!=(h|0))k[L>>2]=m+(~((m+-8-j|0)>>>3)<<3);ggb(h)}}while(0);h=k[Xb>>2]|0;do if(h|0){Ic=h+12|0;Jc=k[Ic>>2]|0;k[Ic>>2]=Jc+-1;if((Jc|0)!=1)break;j=k[Xb>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[Vb>>2]|0;if(h|0)break;h=B1()|0;j=k[Xb>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[Xb>>2]=0}while(0);k[Xb>>2]=0;k[Wb>>2]=0;k[Wb+4>>2]=0;k[Wb+8>>2]=0;k[Wb+12>>2]=0;if((k[Zb>>2]|0)>0){j=k[Yb>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[Zb>>2]|0))}h=k[_b>>2]|0;if(!((h|0)==($b|0)|(h|0)==0))ggb(k[h+-4>>2]|0);h=k[cc>>2]|0;do if(h|0){Ic=h+12|0;Jc=k[Ic>>2]|0;k[Ic>>2]=Jc+-1;if((Jc|0)!=1)break;j=k[cc>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[ac>>2]|0;if(h|0)break;h=B1()|0;j=k[cc>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[cc>>2]=0}while(0);k[cc>>2]=0;k[bc>>2]=0;k[bc+4>>2]=0;k[bc+8>>2]=0;k[bc+12>>2]=0;if((k[gc>>2]|0)>0){j=k[dc>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[gc>>2]|0))}h=k[ec>>2]|0;if(!((h|0)==(fc|0)|(h|0)==0))ggb(k[h+-4>>2]|0);m=Kc+24|0;h=k[m>>2]|0;do if(h|0){Jc=h+8|0;Kc=k[Jc>>2]|0;k[Jc>>2]=Kc+-1;if((Kc|0)!=1)break;Kc=k[m>>2]|0;Jc=k[Kc+4>>2]|0;jh[k[(k[Jc>>2]|0)+16>>2]&1023](Jc,Kc);k[m>>2]=0}while(0);if((k[nc>>2]|0)>0){j=k[kc>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[nc>>2]|0))}k[m>>2]=0;h=k[oc>>2]|0;if(!((h|0)==(pc|0)|(h|0)==0))ggb(k[h+-4>>2]|0);m=Lc+24|0;h=k[m>>2]|0;do if(h|0){Kc=h+8|0;Lc=k[Kc>>2]|0;k[Kc>>2]=Lc+-1;if((Lc|0)!=1)break;Lc=k[m>>2]|0;Kc=k[Lc+4>>2]|0;jh[k[(k[Kc>>2]|0)+16>>2]&1023](Kc,Lc);k[m>>2]=0}while(0);if((k[uc>>2]|0)>0){j=k[tc>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[uc>>2]|0))}k[m>>2]=0;h=k[vc>>2]|0;if(!((h|0)==(xc|0)|(h|0)==0))ggb(k[h+-4>>2]|0);m=Mc+36|0;h=k[m>>2]|0;do if(h|0){Kc=h+12|0;Lc=k[Kc>>2]|0;k[Kc>>2]=Lc+-1;if((Lc|0)!=1)break;j=k[m>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[Mc+32>>2]|0;if(h|0)break;h=B1()|0;j=k[m>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[m>>2]=0}while(0);k[m>>2]=0;Mc=Mc+16|0;k[Mc>>2]=0;k[Mc+4>>2]=0;k[Mc+8>>2]=0;k[Mc+12>>2]=0;if((k[zc>>2]|0)>0){j=k[yc>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[zc>>2]|0))}h=k[Ac>>2]|0;if(!((h|0)==(Bc|0)|(h|0)==0))ggb(k[h+-4>>2]|0);m=Nc+36|0;h=k[m>>2]|0;do if(!h)j=g;else{Lc=h+12|0;Mc=k[Lc>>2]|0;k[Lc>>2]=Mc+-1;if((Mc|0)!=1){j=g;break}j=k[m>>2]|0;if(j){h=k[j+4>>2]|0;do if(!h){h=k[Nc+32>>2]|0;if(h|0)break;h=B1()|0;j=k[m>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[m>>2]=0;j=g}while(0);k[m>>2]=0;Nc=Nc+16|0;k[Nc>>2]=0;k[Nc+4>>2]=0;k[Nc+8>>2]=0;k[Nc+12>>2]=0;if((k[Fc>>2]|0)>0){h=k[Cc>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[Fc>>2]|0))}g=k[Dc>>2]|0;if(!((g|0)==(Gc|0)|(g|0)==0))ggb(k[g+-4>>2]|0);if(Hc|0)ggb(Hc);if(mc|0)ggb(mc);if(j|0)ggb(j);g=k[ic>>2]|0;do if(g|0){Mc=g+12|0;Nc=k[Mc>>2]|0;k[Mc>>2]=Nc+-1;if((Nc|0)!=1)break;h=k[ic>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[hc>>2]|0;if(g|0)break;g=B1()|0;h=k[ic>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[ic>>2]=0}while(0);k[ic>>2]=0;k[sc>>2]=0;k[sc+4>>2]=0;k[sc+8>>2]=0;k[sc+12>>2]=0;if((k[jc>>2]|0)>0){h=k[Oc+40>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[jc>>2]|0))}g=k[Oc+44>>2]|0;if(!((g|0)==(Oc+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);g=k[rc>>2]|0;do if(g|0){Nc=g+12|0;Oc=k[Nc>>2]|0;k[Nc>>2]=Oc+-1;if((Oc|0)!=1)break;h=k[rc>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[lc>>2]|0;if(g|0)break;g=B1()|0;h=k[rc>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[rc>>2]=0}while(0);k[rc>>2]=0;k[qc>>2]=0;k[qc+4>>2]=0;k[qc+8>>2]=0;k[qc+12>>2]=0;if((k[wc>>2]|0)>0){h=k[Pc+40>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[wc>>2]|0))}g=k[Pc+44>>2]|0;if(!((g|0)==(Pc+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);r=Qc;return}function JYa(a){a=a|0;return 32}function KYa(a){a=a|0;return 0}function LYa(a){a=a|0;return 6}function MYa(a,b){a=a|0;b=b|0;k[a+4>>2]=b;return}function NYa(a){a=a|0;return k[a+4>>2]|0}function OYa(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function PYa(a){a=a|0;return +(+p[a+8>>3])}function QYa(a,b){a=a|0;b=b|0;k[a+16>>2]=b;return}function RYa(a){a=a|0;return k[a+16>>2]|0}function SYa(a,b){a=a|0;b=b|0;k[a+20>>2]=b;return}function TYa(a){a=a|0;return k[a+20>>2]|0}function UYa(a,b){a=a|0;b=b|0;k[a+24>>2]=b;return}function VYa(a){a=a|0;return k[a+24>>2]|0}function WYa(a,b){a=a|0;b=b|0;k[a+28>>2]=b;return}function XYa(a){a=a|0;return k[a+28>>2]|0}function YYa(a,b){a=a|0;b=b|0;k[a+32>>2]=b;return}function ZYa(a){a=a|0;return k[a+32>>2]|0}function _Ya(a,b){a=a|0;b=b|0;k[a+36>>2]=b;return}function $Ya(a){a=a|0;return k[a+36>>2]|0}function aZa(a,b){a=a|0;b=b|0;k[a+40>>2]=b;return}function bZa(a){a=a|0;return k[a+40>>2]|0}function cZa(a){a=a|0;ggb(a);return}function dZa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function eZa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=149136;d=a+68|0;b=k[d>>2]|0;k[a+72>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+44|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+40>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+24|0;c=a+12|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+48>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+52>>2]|0;if((b|0)==(a+56|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function fZa(a){a=a|0;eZa(a);ggb(a);return}function gZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0;m=r;r=r+16|0;j=m;h=j+4|0;g=ZT(12)|0;k[g>>2]=1;c=g+4|0;k[j>>2]=c;k[h>>2]=4;i[g+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,j)|0;c=k[j>>2]|0;k[h>>2]=0;k[j>>2]=0;if(c|0?(g=c+-4|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+68|0)|0;c=j+4|0;f=ZT(16)|0;k[f>>2]=1;e=f+4|0;k[j>>2]=e;k[c>>2]=11;i[f+15>>0]=0;f=390895;g=e+11|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));h=z6(b,j)|0;b=k[j>>2]|0;k[c>>2]=0;k[j>>2]=0;if(b|0?(f=b+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[b+-8>>2]|0);a=l[a+4>>0]|0;if(!(Xh[k[(k[h>>2]|0)+12>>2]&1023](h)|0)){r=m;return}d=h+32|0;if((k[d>>2]|0)==6){b=j+4|0;c=ZT(36)|0;k[c>>2]=1;e=c+4|0;k[j>>2]=e;k[b>>2]=30;i[c+34>>0]=0;f=401220;g=e+30|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-2,j,401251,401262,1064);k[b>>2]=0;k[j>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0)}if(!(k[h+16>>2]|0))b=0;else{b=k[h+12>>2]|0;b=(b|0)==0?1016759:b}p6(k[h+8>>2]|0,b,a);if(!(k[d>>2]&4)){r=m;return}k[d>>2]=6;r=m;return}function hZa(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;l=n;m=b+4|0;h=k6(k[b>>2]|0,k[m>>2]|0,401026)|0;k[l>>2]=0;j=l+4|0;k[j>>2]=0;J6(h,l,l);h=k[l>>2]|0;d=k[a+68>>2]|0;if((h|0)==(d|0)){k[j>>2]=0;k[l>>2]=0;if(h|0?(j=h+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[h+-8>>2]|0)}else{f=(h|0)==0?1016759:h;e=(d|0)==0?1016759:d;d=i[f>>0]|0;g=i[e>>0]|0;if(d<<24>>24==0?1:d<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;d=i[f>>0]|0;g=i[e>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=g<<24>>24));e=g}d=d<<24>>24==e<<24>>24;k[j>>2]=0;k[l>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!d){d=l+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[l>>2]=f;k[d>>2]=27;i[e+31>>0]=0;g=401031;h=f+27|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,l,401059,390826,88);k[d>>2]=0;k[l>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}}d=k6(k[b>>2]|0,k[m>>2]|0,390895)|0;if(!d){m=0;m=(m|0)!=0;a=a+4|0;m=m&1;i[a>>0]=m;r=n;return}switch(k[d>>2]&7){case 1:{m=k[d+8>>2]|0;m=(m|0)!=0;a=a+4|0;m=m&1;i[a>>0]=m;r=n;return}case 2:{c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;m=d&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}m=~~c;m=(m|0)!=0;a=a+4|0;m=m&1;i[a>>0]=m;r=n;return}default:{m=2147483647;m=(m|0)!=0;a=a+4|0;m=m&1;i[a>>0]=m;r=n;return}}}function iZa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0;rb=r;r=r+1344|0;ab=rb+1288|0;_a=rb+1232|0;ib=rb+1120|0;fb=rb+1064|0;Za=rb+1008|0;Ra=rb+224|0;Pa=rb+952|0;Ya=rb+936|0;Ta=rb+880|0;Qa=rb+824|0;Ka=rb;Na=rb+768|0;Oa=rb+712|0;qb=rb+656|0;pb=rb+600|0;ob=rb+584|0;nb=rb+572|0;mb=rb+560|0;lb=rb+504|0;t=rb+1176|0;kb=rb+448|0;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[qb>>2]=k[g>>2];m=qb+4|0;b=g+4|0;k[m>>2]=k[b>>2];jb=qb+8|0;k[jb>>2]=k[g+8>>2];k[qb+12>>2]=k[g+12>>2];k[qb+16>>2]=k[g+16>>2];k[qb+20>>2]=k[g+20>>2];k[qb+24>>2]=k[g+24>>2];k[qb+28>>2]=k[g+28>>2];k[qb+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[qb+36>>2]=e;f=qb+40|0;k[f>>2]=jb;jb=qb+48|0;j=qb+44|0;k[j>>2]=jb;k[qb+52>>2]=0;k[jb>>2]=0;if(e|0){jb=e+12|0;k[jb>>2]=(k[jb>>2]|0)+1}if((k[b>>2]|0)<3){hb=k[g+44>>2]|0;jb=k[j>>2]|0;k[jb>>2]=k[hb>>2];k[jb+4>>2]=k[hb+4>>2];break}k[m>>2]=0;x1(qb,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(qb,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[pb>>2]=k[h>>2];m=pb+4|0;b=h+4|0;k[m>>2]=k[b>>2];jb=pb+8|0;k[jb>>2]=k[h+8>>2];k[pb+12>>2]=k[h+12>>2];k[pb+16>>2]=k[h+16>>2];k[pb+20>>2]=k[h+20>>2];k[pb+24>>2]=k[h+24>>2];k[pb+28>>2]=k[h+28>>2];k[pb+32>>2]=k[h+32>>2];e=k[h+36>>2]|0;k[pb+36>>2]=e;f=pb+40|0;k[f>>2]=jb;jb=pb+48|0;j=pb+44|0;k[j>>2]=jb;k[pb+52>>2]=0;k[jb>>2]=0;if(e|0){jb=e+12|0;k[jb>>2]=(k[jb>>2]|0)+1}if((k[b>>2]|0)<3){hb=k[h+44>>2]|0;jb=k[j>>2]|0;k[jb>>2]=k[hb>>2];k[jb+4>>2]=k[hb+4>>2];break}k[m>>2]=0;x1(pb,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;e=k[j>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(pb,c,-1);while(0);if(!((((k[qb>>2]&4088|0)==8?(k[qb+12>>2]|0)>0:0)?(k[pb>>2]&4088|0)==8:0)?(k[pb+12>>2]|0)>0:0)){k[ab>>2]=0;b=ab+4|0;k[b>>2]=0;e=ZT(84)|0;k[e>>2]=1;La=e+4|0;k[ab>>2]=La;k[b>>2]=78;i[e+82>>0]=0;f=392822;Ma=La+78|0;do{i[La>>0]=i[f>>0]|0;La=La+1|0;f=f+1|0}while((La|0)<(Ma|0));Y8(-215,ab,392901,390826,187);k[b>>2]=0;k[ab>>2]=0;jb=k[e>>2]|0;k[e>>2]=jb+-1;if((jb|0)==1)ggb(k[e+-4>>2]|0)}l=d+4|0;if((k[l>>2]|0)-(k[d>>2]|0)>>4>>>0<=1){k[ab>>2]=0;b=ab+4|0;k[b>>2]=0;e=ZT(24)|0;k[e>>2]=1;La=e+4|0;k[ab>>2]=La;k[b>>2]=17;i[e+21>>0]=0;f=392924;Ma=La+17|0;do{i[La>>0]=i[f>>0]|0;La=La+1|0;f=f+1|0}while((La|0)<(Ma|0));Y8(-215,ab,392901,390826,188);k[b>>2]=0;k[ab>>2]=0;jb=k[e>>2]|0;k[e>>2]=jb+-1;if((jb|0)==1)ggb(k[e+-4>>2]|0)}if((k[qb>>2]&4095|0)!=5){jb=ab+4|0;hb=jb+4|0;k[hb>>2]=0;k[hb+4>>2]=0;k[ab>>2]=33619968;k[jb>>2]=qb;SW(qb,ab,5,1.0,0.0)}if((k[pb>>2]&4095|0)!=5){jb=ab+4|0;hb=jb+4|0;k[hb>>2]=0;k[hb+4>>2]=0;k[ab>>2]=33619968;k[jb>>2]=pb;SW(pb,ab,5,1.0,0.0)}k[ob>>2]=0;jb=ob+4|0;k[jb>>2]=0;k[ob+8>>2]=0;b=k[d>>2]|0;if((k[l>>2]|0)==(b|0)){q=ob;s=jb;f=0;b=0;e=0}else{g=qb+12|0;h=pb+12|0;j=ob+8|0;f=0;do{hb=b;b=hb+(f<<4)|0;do if((k[b>>2]|0)<(k[g>>2]|0)?(k[hb+(f<<4)+4>>2]|0)<(k[h>>2]|0):0){e=k[jb>>2]|0;if((e|0)==(k[j>>2]|0)){I6(ob,b);break}else{k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2];k[e+12>>2]=k[b+12>>2];k[jb>>2]=e+16;break}}while(0);f=f+1|0;b=k[d>>2]|0}while(f>>>0<(k[l>>2]|0)-b>>4>>>0);e=k[ob>>2]|0;q=ob;s=jb;f=e;b=k[jb>>2]|0}k[nb>>2]=0;hb=nb+4|0;k[hb>>2]=0;k[nb+8>>2]=0;k[mb>>2]=0;gb=mb+4|0;k[gb>>2]=0;k[mb+8>>2]=0;a:do if((b|0)!=(e|0)){l=qb+16|0;m=ab+4|0;c=nb+8|0;d=pb+16|0;n=_a+4|0;p=mb+8|0;b=0;e=f;h=0;j=0;while(1){g=k[e+(b<<4)>>2]|0;eb=k[l>>2]|0;f=k[eb+(g<<3)>>2]|0;k[ab>>2]=f;g=k[eb+(g<<3)+4>>2]|0;k[m>>2]=g;if((h|0)==(j|0))dga(nb,ab);else{k[h>>2]=f;k[h+4>>2]=g;k[hb>>2]=h+8}f=k[e+(b<<4)+4>>2]|0;g=k[d>>2]|0;e=k[g+(f<<3)>>2]|0;k[_a>>2]=e;f=k[g+(f<<3)+4>>2]|0;k[n>>2]=f;g=k[gb>>2]|0;if((g|0)==(k[p>>2]|0))dga(mb,_a);else{k[g>>2]=e;k[g+4>>2]=f;k[gb>>2]=g+8}b=b+1|0;e=k[q>>2]|0;if(b>>>0>=(k[s>>2]|0)-e>>4>>>0)break a;h=k[hb>>2]|0;j=k[c>>2]|0}}while(0);k[lb>>2]=1124007936;cb=lb+4|0;h=lb+8|0;bb=lb+40|0;La=cb;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[bb>>2]=h;eb=lb+48|0;db=lb+44|0;k[db>>2]=eb;k[lb+52>>2]=0;k[eb>>2]=0;k[ab+8>>2]=0;k[ab+12>>2]=0;k[ab>>2]=-2130509811;k[ab+4>>2]=nb;k[_a+8>>2]=0;k[_a+12>>2]=0;k[_a>>2]=-2130509811;k[_a+4>>2]=mb;j=a+4|0;F6a(t,ab,_a,(i[j>>0]|0)!=0);f=ib+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[ib>>2]=33619968;k[f>>2]=lb;SW(t,ib,5,1.0,0.0);f=t+36|0;b=k[f>>2]|0;if(b|0?(Xa=b+12|0,$a=k[Xa>>2]|0,k[Xa>>2]=$a+-1,($a|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[t+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;$a=t+16|0;e=t+4|0;k[$a>>2]=0;k[$a+4>>2]=0;k[$a+8>>2]=0;k[$a+12>>2]=0;if((k[e>>2]|0)>0){f=k[t+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[t+44>>2]|0;if(!((b|0)==(t+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);$a=lb+16|0;if(k[$a>>2]|0){g=k[cb>>2]|0;if((g|0)<3)b=aa(k[lb+12>>2]|0,k[h>>2]|0)|0;else{f=k[bb>>2]|0;e=0;b=1;do{b=aa(k[f+(e<<2)>>2]|0,b)|0;e=e+1|0}while((e|0)!=(g|0))}if(!b)u=73}else u=73;if((u|0)==73){e=i[j>>0]|0;k[kb>>2]=1124007936;Wa=kb+4|0;b=kb+8|0;Ua=kb+40|0;La=Wa;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[Ua>>2]=b;Xa=kb+48|0;Va=kb+44|0;k[Va>>2]=Xa;k[kb+52>>2]=0;k[Xa>>2]=0;k[ab>>2]=2;f=ab+4|0;k[f>>2]=3;G1(kb,2,ab,5);g=(k[hb>>2]|0)-(k[nb>>2]|0)|0;Sa=g>>2;if(!(e<<24>>24)){k[ib>>2]=1124007936;Ia=ib+4|0;b=ib+8|0;Ga=ib+40|0;La=Ia;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[Ga>>2]=b;Ja=ib+48|0;Ha=ib+44|0;k[Ha>>2]=Ja;k[ib+52>>2]=0;k[Ja>>2]=0;k[ab>>2]=Sa;k[f>>2]=4;G1(ib,2,ab,5);k[fb>>2]=1124007936;Ea=fb+4|0;b=fb+8|0;Ca=fb+40|0;La=Ea;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[Ca>>2]=b;Fa=fb+48|0;Da=fb+44|0;k[Da>>2]=Fa;k[fb+52>>2]=0;k[Fa>>2]=0;k[ab>>2]=Sa;k[f>>2]=1;G1(fb,2,ab,5);if((g|0)>0){h=Za+4|0;j=Za+8|0;l=Za+40|0;m=Za+48|0;c=Za+44|0;d=Za+52|0;n=Za+16|0;p=ab+4|0;q=_a+4|0;s=ab+4|0;t=_a+4|0;u=Ya+4|0;v=u+4|0;w=Ta+36|0;x=Ta+16|0;y=Ta+4|0;z=Ta+40|0;A=Ta+44|0;B=Ta+48|0;C=Na+36|0;D=Na+16|0;E=Na+4|0;F=Na+40|0;G=Na+44|0;H=Na+48|0;I=fb+16|0;J=Za+36|0;K=ab+4|0;L=_a+4|0;M=ab+4|0;N=_a+4|0;O=Ya+4|0;P=O+4|0;Q=Ta+36|0;R=Ta+16|0;S=Ta+4|0;T=Ta+40|0;U=Ta+44|0;V=Ta+48|0;W=Oa+36|0;X=Oa+16|0;Y=Oa+4|0;Z=Oa+40|0;_=Oa+44|0;$=Oa+48|0;ba=Ka+4|0;ca=Ka+8|0;da=Ka+12|0;ea=Ka+16|0;fa=Ka+48|0;ga=Ka+56|0;ha=Ka+52|0;ia=Ka+60|0;ja=Ka+64|0;ka=Ka+68|0;la=Ka+72|0;ma=Ka+104|0;na=Ka+112|0;oa=Ka+108|0;pa=Ka+116|0;qa=Ka+120|0;ra=Ka+124|0;sa=Ka+128|0;ta=Ka+160|0;ua=Ka+168|0;va=Ka+164|0;wa=ab+4|0;xa=Na+32|0;ya=Ta+32|0;za=Za+32|0;Aa=Oa+32|0;Ba=Ta+32|0;g=0;f=0;do{k[Ka>>2]=0;k[ba>>2]=0;k[ca>>2]=1124007936;La=da;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[fa>>2]=ea;k[ha>>2]=ga;k[ia>>2]=0;k[ga>>2]=0;k[ja>>2]=1124007936;La=ka;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[ma>>2]=la;k[oa>>2]=na;k[pa>>2]=0;k[na>>2]=0;k[qa>>2]=1124007936;La=ra;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[ta>>2]=sa;k[va>>2]=ua;La=ua;Ma=La+56|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[ab>>2]=4;k[wa>>2]=1;j1(Ka,48,ab,5);k[Za>>2]=1124007936;La=h;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[l>>2]=j;k[c>>2]=m;k[d>>2]=0;k[m>>2]=0;b=k[Ka>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,Ka,Za,-1);XN(Ka);b=k[nb>>2]|0;if(!(g&1)){Ra=k[n>>2]|0;k[Ra>>2]=k[b+(f<<3)>>2];k[Ra+4>>2]=k[b+(f<<3)+4>>2];o[Ra+8>>2]=1.0;k[ab>>2]=0;k[p>>2]=1;k[_a>>2]=-2147483648;k[q>>2]=2147483647;H1(Na,Za,ab,_a);k[ab>>2]=g;k[s>>2]=g+1;k[_a>>2]=-2147483648;k[t>>2]=2147483647;H1(Ta,ib,ab,_a);b=v;k[b>>2]=0;k[b+4>>2]=0;k[Ya>>2]=-1040121856;k[u>>2]=Ta;mY(Na,Ya);b=k[w>>2]|0;do if(b|0){Qa=b+12|0;Ra=k[Qa>>2]|0;k[Qa>>2]=Ra+-1;if((Ra|0)!=1)break;e=k[w>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ya>>2]|0;if(b|0)break;b=B1()|0;e=k[w>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[w>>2]=0}while(0);k[w>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[y>>2]|0)>0){e=k[z>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[y>>2]|0))}b=k[A>>2]|0;if(!((b|0)==(B|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[C>>2]|0;do if(b|0){Qa=b+12|0;Ra=k[Qa>>2]|0;k[Qa>>2]=Ra+-1;if((Ra|0)!=1)break;e=k[C>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[xa>>2]|0;if(b|0)break;b=B1()|0;e=k[C>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[C>>2]=0}while(0);k[C>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[E>>2]|0)>0){e=k[F>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[E>>2]|0))}b=k[G>>2]|0;if(!((b|0)==(H|0)|(b|0)==0))ggb(k[b+-4>>2]|0);Ra=(k[I>>2]|0)+(aa(k[k[Da>>2]>>2]|0,g)|0)|0;k[Ra>>2]=k[(k[mb>>2]|0)+(f<<3)>>2]}else{Ra=k[n>>2]|0;o[Ra>>2]=-+o[b+(f<<3)+4>>2];k[Ra+4>>2]=k[b+(f<<3)>>2];o[Ra+12>>2]=1.0;k[ab>>2]=0;k[K>>2]=1;k[_a>>2]=-2147483648;k[L>>2]=2147483647;H1(Oa,Za,ab,_a);k[ab>>2]=g;k[M>>2]=g+1;k[_a>>2]=-2147483648;k[N>>2]=2147483647;H1(Ta,ib,ab,_a);b=P;k[b>>2]=0;k[b+4>>2]=0;k[Ya>>2]=-1040121856;k[O>>2]=Ta;mY(Oa,Ya);b=k[Q>>2]|0;do if(b|0){Qa=b+12|0;Ra=k[Qa>>2]|0;k[Qa>>2]=Ra+-1;if((Ra|0)!=1)break;e=k[Q>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Ba>>2]|0;if(b|0)break;b=B1()|0;e=k[Q>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[Q>>2]=0}while(0);k[Q>>2]=0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[S>>2]|0)>0){e=k[T>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[S>>2]|0))}b=k[U>>2]|0;if(!((b|0)==(V|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[W>>2]|0;do if(b|0){Qa=b+12|0;Ra=k[Qa>>2]|0;k[Qa>>2]=Ra+-1;if((Ra|0)!=1)break;e=k[W>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Aa>>2]|0;if(b|0)break;b=B1()|0;e=k[W>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[W>>2]=0}while(0);k[W>>2]=0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[Y>>2]|0)>0){e=k[Z>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Y>>2]|0))}b=k[_>>2]|0;if(!((b|0)==($|0)|(b|0)==0))ggb(k[b+-4>>2]|0);Ra=(k[I>>2]|0)+(aa(k[k[Da>>2]>>2]|0,g)|0)|0;k[Ra>>2]=k[(k[mb>>2]|0)+(f<<3)+4>>2];f=f+1|0}b=k[J>>2]|0;do if(b|0){Qa=b+12|0;Ra=k[Qa>>2]|0;k[Qa>>2]=Ra+-1;if((Ra|0)!=1)break;e=k[J>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[za>>2]|0;if(b|0)break;b=B1()|0;e=k[J>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[J>>2]=0}while(0);k[J>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[h>>2]|0)>0){e=k[l>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[h>>2]|0))}b=k[c>>2]|0;if(!((b|0)==(m|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=g+1|0}while((g|0)<(Sa|0))}k[ab>>2]=1124007936;m=ab+4|0;b=ab+8|0;j=ab+40|0;La=m;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[j>>2]=b;l=ab+48|0;h=ab+44|0;k[h>>2]=l;k[ab+52>>2]=0;k[l>>2]=0;k[_a+8>>2]=0;k[_a+12>>2]=0;k[_a>>2]=16842752;k[_a+4>>2]=ib;k[Za+8>>2]=0;k[Za+12>>2]=0;k[Za>>2]=16842752;k[Za+4>>2]=fb;f=Ya+4|0;g=f+4|0;k[g>>2]=0;k[g+4>>2]=0;k[Ya>>2]=33619968;k[f>>2]=ab;NZ(_a,Za,Ya,1)|0;f=ab+16|0;_a=k[f>>2]|0;g=k[kb+16>>2]|0;k[g>>2]=k[_a>>2];b=k[k[h>>2]>>2]|0;Za=_a+b|0;k[g+4>>2]=k[Za>>2];k[g+8>>2]=k[_a+(b<<1)>>2];g=g+(k[k[Va>>2]>>2]|0)|0;o[g>>2]=-+o[Za>>2];k[g+4>>2]=k[_a>>2];k[g+8>>2]=k[_a+(b*3|0)>>2];g=ab+36|0;b=k[g>>2]|0;if(b|0?(Za=b+12|0,_a=k[Za>>2]|0,k[Za>>2]=_a+-1,(_a|0)==1):0){e=k[g>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ab+32>>2]|0;if(b|0)break;b=B1()|0;e=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[g>>2]=0}k[g>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[m>>2]|0)>0){e=k[j>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[h>>2]|0;if(!((b|0)==(l|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=fb+36|0;b=k[f>>2]|0;do if(b|0){_a=b+12|0;ab=k[_a>>2]|0;k[_a>>2]=ab+-1;if((ab|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[fb+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;fb=fb+16|0;k[fb>>2]=0;k[fb+4>>2]=0;k[fb+8>>2]=0;k[fb+12>>2]=0;if((k[Ea>>2]|0)>0){e=k[Ca>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ea>>2]|0))}b=k[Da>>2]|0;if(!((b|0)==(Fa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ib+36|0;b=k[f>>2]|0;do if(b|0){ab=b+12|0;fb=k[ab>>2]|0;k[ab>>2]=fb+-1;if((fb|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ib+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;ib=ib+16|0;k[ib>>2]=0;k[ib+4>>2]=0;k[ib+8>>2]=0;k[ib+12>>2]=0;if((k[Ia>>2]|0)>0){e=k[Ga>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ia>>2]|0))}b=k[Ha>>2]|0;if(!((b|0)==(Ja|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{k[ib>>2]=1124007936;Ja=ib+4|0;b=ib+8|0;Ha=ib+40|0;La=Ja;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[Ha>>2]=b;Ka=ib+48|0;Ia=ib+44|0;k[Ia>>2]=Ka;k[ib+52>>2]=0;k[Ka>>2]=0;k[ab>>2]=Sa;k[f>>2]=6;G1(ib,2,ab,5);k[fb>>2]=1124007936;Fa=fb+4|0;b=fb+8|0;Da=fb+40|0;La=Fa;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[Da>>2]=b;Ga=fb+48|0;Ea=fb+44|0;k[Ea>>2]=Ga;k[fb+52>>2]=0;k[Ga>>2]=0;k[ab>>2]=Sa;k[f>>2]=1;G1(fb,2,ab,5);if((g|0)>0){j=Za+4|0;l=Za+8|0;m=Za+40|0;c=Za+48|0;d=Za+44|0;n=Za+52|0;p=Za+16|0;q=ab+4|0;s=_a+4|0;t=ab+4|0;u=_a+4|0;v=Ya+4|0;w=v+4|0;x=Ta+36|0;y=Ta+16|0;z=Ta+4|0;A=Ta+40|0;B=Ta+44|0;C=Ta+48|0;D=Pa+36|0;E=Pa+16|0;F=Pa+4|0;G=Pa+40|0;H=Pa+44|0;I=Pa+48|0;J=fb+16|0;K=Za+36|0;L=ab+4|0;M=_a+4|0;N=ab+4|0;O=_a+4|0;P=Ya+4|0;Q=P+4|0;R=Ta+36|0;S=Ta+16|0;T=Ta+4|0;U=Ta+40|0;V=Ta+44|0;W=Ta+48|0;X=Qa+36|0;Y=Qa+16|0;Z=Qa+4|0;_=Qa+40|0;$=Qa+44|0;ba=Qa+48|0;ca=Ra+4|0;da=Ra+8|0;ea=Ra+12|0;fa=Ra+16|0;ga=Ra+48|0;ha=Ra+56|0;ia=Ra+52|0;ja=Ra+60|0;ka=Ra+64|0;la=Ra+68|0;ma=Ra+72|0;na=Ra+104|0;oa=Ra+112|0;pa=Ra+108|0;qa=Ra+116|0;ra=Ra+120|0;sa=Ra+124|0;ta=Ra+128|0;ua=Ra+160|0;va=Ra+168|0;wa=Ra+164|0;xa=ab+4|0;ya=Pa+32|0;za=Ta+32|0;Aa=Za+32|0;Ba=Qa+32|0;Ca=Ta+32|0;h=0;g=0;while(1){k[Ra>>2]=0;k[ca>>2]=0;k[da>>2]=1124007936;La=ea;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[ga>>2]=fa;k[ia>>2]=ha;k[ja>>2]=0;k[ha>>2]=0;k[ka>>2]=1124007936;La=la;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[na>>2]=ma;k[pa>>2]=oa;k[qa>>2]=0;k[oa>>2]=0;k[ra>>2]=1124007936;La=sa;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[ua>>2]=ta;k[wa>>2]=va;La=va;Ma=La+56|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[ab>>2]=6;k[xa>>2]=1;j1(Ra,48,ab,5);k[Za>>2]=1124007936;La=j;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[m>>2]=l;k[d>>2]=c;k[n>>2]=0;k[c>>2]=0;b=k[Ra>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,Ra,Za,-1);XN(Ra);b=k[nb>>2]|0;e=k[b+(g<<3)>>2]|0;f=k[p>>2]|0;if(!(h&1)){k[f>>2]=e;k[f+4>>2]=k[b+(g<<3)+4>>2];o[f+8>>2]=1.0;k[ab>>2]=0;k[q>>2]=1;k[_a>>2]=-2147483648;k[s>>2]=2147483647;H1(Pa,Za,ab,_a);k[ab>>2]=h;k[t>>2]=h+1;k[_a>>2]=-2147483648;k[u>>2]=2147483647;H1(Ta,ib,ab,_a);b=w;k[b>>2]=0;k[b+4>>2]=0;k[Ya>>2]=-1040121856;k[v>>2]=Ta;mY(Pa,Ya);b=k[x>>2]|0;do if(b|0){Na=b+12|0;Oa=k[Na>>2]|0;k[Na>>2]=Oa+-1;if((Oa|0)!=1)break;e=k[x>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[za>>2]|0;if(b|0)break;b=B1()|0;e=k[x>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[x>>2]=0}while(0);k[x>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[z>>2]|0)>0){e=k[A>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[B>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[D>>2]|0;do if(b|0){Na=b+12|0;Oa=k[Na>>2]|0;k[Na>>2]=Oa+-1;if((Oa|0)!=1)break;e=k[D>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ya>>2]|0;if(b|0)break;b=B1()|0;e=k[D>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[D>>2]=0}while(0);k[D>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[F>>2]|0)>0){e=k[G>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[F>>2]|0))}b=k[H>>2]|0;if(!((b|0)==(I|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=(k[J>>2]|0)+(aa(k[k[Ea>>2]>>2]|0,h)|0)|0;k[f>>2]=k[(k[mb>>2]|0)+(g<<3)>>2];f=g}else{k[f+12>>2]=e;k[f+16>>2]=k[b+(g<<3)+4>>2];o[f+20>>2]=1.0;k[ab>>2]=0;k[L>>2]=1;k[_a>>2]=-2147483648;k[M>>2]=2147483647;H1(Qa,Za,ab,_a);k[ab>>2]=h;k[N>>2]=h+1;k[_a>>2]=-2147483648;k[O>>2]=2147483647;H1(Ta,ib,ab,_a);b=Q;k[b>>2]=0;k[b+4>>2]=0;k[Ya>>2]=-1040121856;k[P>>2]=Ta;mY(Qa,Ya);b=k[R>>2]|0;do if(b|0){Na=b+12|0;Oa=k[Na>>2]|0;k[Na>>2]=Oa+-1;if((Oa|0)!=1)break;e=k[R>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Ca>>2]|0;if(b|0)break;b=B1()|0;e=k[R>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[R>>2]=0}while(0);k[R>>2]=0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[T>>2]|0)>0){e=k[U>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[T>>2]|0))}b=k[V>>2]|0;if(!((b|0)==(W|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[X>>2]|0;do if(b|0){Na=b+12|0;Oa=k[Na>>2]|0;k[Na>>2]=Oa+-1;if((Oa|0)!=1)break;e=k[X>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Ba>>2]|0;if(b|0)break;b=B1()|0;e=k[X>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[X>>2]=0}while(0);k[X>>2]=0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[Z>>2]|0)>0){e=k[_>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Z>>2]|0))}b=k[$>>2]|0;if(!((b|0)==(ba|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=(k[J>>2]|0)+(aa(k[k[Ea>>2]>>2]|0,h)|0)|0;k[f>>2]=k[(k[mb>>2]|0)+(g<<3)+4>>2];f=g+1|0}b=k[K>>2]|0;do if(b|0){Na=b+12|0;Oa=k[Na>>2]|0;k[Na>>2]=Oa+-1;if((Oa|0)!=1)break;e=k[K>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Aa>>2]|0;if(b|0)break;b=B1()|0;e=k[K>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[K>>2]=0}while(0);k[K>>2]=0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[j>>2]|0)>0){e=k[m>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[d>>2]|0;if(!((b|0)==(c|0)|(b|0)==0))ggb(k[b+-4>>2]|0);h=h+1|0;if((h|0)>=(Sa|0))break;else g=f}}k[ab>>2]=1124007936;l=ab+4|0;b=ab+8|0;h=ab+40|0;La=l;Ma=La+36|0;do{k[La>>2]=0;La=La+4|0}while((La|0)<(Ma|0));k[h>>2]=b;j=ab+48|0;g=ab+44|0;k[g>>2]=j;k[ab+52>>2]=0;k[j>>2]=0;k[_a+8>>2]=0;k[_a+12>>2]=0;k[_a>>2]=16842752;k[_a+4>>2]=ib;k[Za+8>>2]=0;k[Za+12>>2]=0;k[Za>>2]=16842752;k[Za+4>>2]=fb;f=Ya+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[Ya>>2]=33619968;k[f>>2]=ab;NZ(_a,Za,Ya,1)|0;_1(_a,ab,0,2);KG(kb,_a)|0;f=_a+36|0;b=k[f>>2]|0;if(b|0?(Ya=b+12|0,Za=k[Ya>>2]|0,k[Ya>>2]=Za+-1,(Za|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[_a+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Za=_a+16|0;e=_a+4|0;k[Za>>2]=0;k[Za+4>>2]=0;k[Za+8>>2]=0;k[Za+12>>2]=0;if((k[e>>2]|0)>0){f=k[_a+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[_a+44>>2]|0;if(!((b|0)==(_a+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ab+36|0;b=k[f>>2]|0;do if(b|0){Za=b+12|0;_a=k[Za>>2]|0;k[Za>>2]=_a+-1;if((_a|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ab+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;ab=ab+16|0;k[ab>>2]=0;k[ab+4>>2]=0;k[ab+8>>2]=0;k[ab+12>>2]=0;if((k[l>>2]|0)>0){e=k[h>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[g>>2]|0;if(!((b|0)==(j|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=fb+36|0;b=k[f>>2]|0;do if(b|0){_a=b+12|0;ab=k[_a>>2]|0;k[_a>>2]=ab+-1;if((ab|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[fb+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;fb=fb+16|0;k[fb>>2]=0;k[fb+4>>2]=0;k[fb+8>>2]=0;k[fb+12>>2]=0;if((k[Fa>>2]|0)>0){e=k[Da>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Fa>>2]|0))}b=k[Ea>>2]|0;if(!((b|0)==(Ga|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ib+36|0;b=k[f>>2]|0;do if(b|0){ab=b+12|0;fb=k[ab>>2]|0;k[ab>>2]=fb+-1;if((fb|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ib+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;ib=ib+16|0;k[ib>>2]=0;k[ib+4>>2]=0;k[ib+8>>2]=0;k[ib+12>>2]=0;if((k[Ja>>2]|0)>0){e=k[Ha>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ja>>2]|0))}b=k[Ia>>2]|0;if(!((b|0)==(Ka|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}KG(lb,kb)|0;f=kb+36|0;b=k[f>>2]|0;if(b|0?(fb=b+12|0,ib=k[fb>>2]|0,k[fb>>2]=ib+-1,(ib|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[kb+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;kb=kb+16|0;k[kb>>2]=0;k[kb+4>>2]=0;k[kb+8>>2]=0;k[kb+12>>2]=0;if((k[Wa>>2]|0)>0){e=k[Ua>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Wa>>2]|0))}b=k[Va>>2]|0;if(!((b|0)==(Xa|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}KG(a+8|0,lb)|0;f=lb+36|0;b=k[f>>2]|0;if(b|0?(kb=b+12|0,a=k[kb>>2]|0,k[kb>>2]=a+-1,(a|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[lb+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;k[$a>>2]=0;k[$a+4>>2]=0;k[$a+8>>2]=0;k[$a+12>>2]=0;if((k[cb>>2]|0)>0){e=k[bb>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[cb>>2]|0))}b=k[db>>2]|0;if(!((b|0)==(eb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[mb>>2]|0;e=b;if(b|0){f=k[gb>>2]|0;if((f|0)!=(b|0))k[gb>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(b)}b=k[nb>>2]|0;e=b;if(b|0){f=k[hb>>2]|0;if((f|0)!=(b|0))k[hb>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(b)}b=k[ob>>2]|0;e=b;if(b|0){f=k[jb>>2]|0;if((f|0)!=(b|0))k[jb>>2]=f+(~((f+-16-e|0)>>>4)<<4);ggb(b)}f=pb+36|0;b=k[f>>2]|0;do if(b|0){nb=b+12|0;ob=k[nb>>2]|0;k[nb>>2]=ob+-1;if((ob|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[pb+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;ob=pb+16|0;e=pb+4|0;k[ob>>2]=0;k[ob+4>>2]=0;k[ob+8>>2]=0;k[ob+12>>2]=0;if((k[e>>2]|0)>0){f=k[pb+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[pb+44>>2]|0;if(!((b|0)==(pb+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=qb+36|0;b=k[f>>2]|0;do if(b|0){ob=b+12|0;pb=k[ob>>2]|0;k[ob>>2]=pb+-1;if((pb|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[qb+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;pb=qb+16|0;e=qb+4|0;k[pb>>2]=0;k[pb+4>>2]=0;k[pb+8>>2]=0;k[pb+12>>2]=0;if((k[e>>2]|0)>0){f=k[qb+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[qb+44>>2]|0;if((b|0)==(qb+48|0)|(b|0)==0){r=rb;return}ggb(k[b+-4>>2]|0);r=rb;return}function jZa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=r;r=r+400|0;y=G+224|0;F=G+168|0;E=G+112|0;D=G+56|0;x=G;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[F>>2]=k[f>>2];l=F+4|0;b=f+4|0;k[l>>2]=k[b>>2];C=F+8|0;k[C>>2]=k[f+8>>2];k[F+12>>2]=k[f+12>>2];k[F+16>>2]=k[f+16>>2];k[F+20>>2]=k[f+20>>2];k[F+24>>2]=k[f+24>>2];k[F+28>>2]=k[f+28>>2];k[F+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[F+36>>2]=d;e=F+40|0;k[e>>2]=C;C=F+48|0;h=F+44|0;k[h>>2]=C;k[F+52>>2]=0;k[C>>2]=0;if(d|0){C=d+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[b>>2]|0)<3){C=k[f+44>>2]|0;b=k[h>>2]|0;k[b>>2]=k[C>>2];k[b+4>>2]=k[C+4>>2];b=F;break}k[l>>2]=0;x1(F,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0));b=F}else b=F}else{Q1(F,b,-1);b=F}while(0);if(!((k[b>>2]&4088|0)==8?(k[F+12>>2]|0)>0:0)){k[y>>2]=0;b=y+4|0;k[b>>2]=0;d=ZT(44)|0;k[d>>2]=1;f=d+4|0;k[y>>2]=f;k[b>>2]=37;i[d+41>>0]=0;e=392784;g=f+37|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,y,392764,390826,231);k[b>>2]=0;k[y>>2]=0;C=k[d>>2]|0;k[d>>2]=C+-1;if((C|0)==1)ggb(k[d+-4>>2]|0)}k[E>>2]=1124007936;B=E+4|0;b=E+8|0;z=E+40|0;f=B;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[z>>2]=b;C=E+48|0;A=E+44|0;k[A>>2]=C;k[E+52>>2]=0;k[C>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=F;v=D+4|0;u=v+4|0;k[u>>2]=0;k[u+4>>2]=0;k[D>>2]=33619968;k[v>>2]=E;k[x+8>>2]=0;k[x+12>>2]=0;k[x>>2]=16842752;k[x+4>>2]=a+8;F_(y,D,x);if(k[c>>2]&2031616|0){m=E+12|0;c2(c,1,k[m>>2]|0,13,-1,0,0);do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[y>>2]=k[f>>2];l=y+4|0;b=f+4|0;k[l>>2]=k[b>>2];v=y+8|0;k[v>>2]=k[f+8>>2];k[y+12>>2]=k[f+12>>2];k[y+16>>2]=k[f+16>>2];k[y+20>>2]=k[f+20>>2];k[y+24>>2]=k[f+24>>2];k[y+28>>2]=k[f+28>>2];k[y+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[y+36>>2]=d;e=y+40|0;k[e>>2]=v;v=y+48|0;h=y+44|0;k[h>>2]=v;k[y+52>>2]=0;k[v>>2]=0;if(d|0){v=d+12|0;k[v>>2]=(k[v>>2]|0)+1}if((k[b>>2]|0)<3){u=k[f+44>>2]|0;v=k[h>>2]|0;k[v>>2]=k[u>>2];k[v+4>>2]=k[u+4>>2];break}k[l>>2]=0;x1(y,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(y,c,-1);while(0);d=k[m>>2]|0;if((d|0)>0){e=k[y+16>>2]|0;f=k[E+16>>2]|0;b=0;do{k[e+(b<<3)>>2]=k[f+(b<<3)>>2];k[e+(b<<3)+4>>2]=k[f+(b<<3)+4>>2];b=b+1|0}while((b|0)!=(d|0))}e=y+36|0;b=k[e>>2]|0;if(b|0?(u=b+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[y+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;v=y+16|0;d=y+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[d>>2]|0)>0){e=k[y+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[y+44>>2]|0;if(!((b|0)==(y+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}k[D>>2]=1124007936;v=D+4|0;b=D+8|0;t=D+40|0;f=v;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[t>>2]=b;u=D+48|0;s=D+44|0;k[s>>2]=u;k[D+52>>2]=0;k[u>>2]=0;k[y>>2]=2;k[y+4>>2]=2;G1(D,2,y,5);b=k[a+24>>2]|0;q=D+16|0;c=k[q>>2]|0;k[c>>2]=k[b>>2];d=b+(k[k[a+52>>2]>>2]|0)|0;k[c+4>>2]=k[d>>2];c=c+(k[k[s>>2]>>2]|0)|0;k[c>>2]=k[b+4>>2];k[c+4>>2]=k[d+4>>2];k[x+8>>2]=0;k[x+12>>2]=0;k[x>>2]=16842752;k[x+4>>2]=D;nCa(y,x,2);k[x>>2]=k[y+56>>2];c=x+4|0;d=y+60|0;b=k[d>>2]|0;k[c>>2]=b;p=x+8|0;k[p>>2]=k[y+64>>2];k[x+12>>2]=k[y+68>>2];j=x+16|0;k[j>>2]=k[y+72>>2];k[x+20>>2]=k[y+76>>2];k[x+24>>2]=k[y+80>>2];k[x+28>>2]=k[y+84>>2];h=x+32|0;k[h>>2]=k[y+88>>2];l=x+36|0;e=k[y+92>>2]|0;k[l>>2]=e;m=x+40|0;k[m>>2]=p;p=x+48|0;n=x+44|0;k[n>>2]=p;k[x+52>>2]=0;k[p>>2]=0;if(e){b=e+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[d>>2]|0}if((b|0)>=3){k[c>>2]=0;x1(x,b,0,0,0);if((k[c>>2]|0)>0){d=k[y+96>>2]|0;e=k[m>>2]|0;f=k[y+100>>2]|0;g=k[n>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[g+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[c>>2]|0))}}else{g=k[y+100>>2]|0;x=k[n>>2]|0;k[x>>2]=k[g>>2];k[x+4>>2]=k[g+4>>2]}b=k[j>>2]|0;w=+_(+((+o[b>>2]+1.1754943508222875e-38)/(+o[b+(k[k[n>>2]>>2]|0)>>2]+1.1754943508222875e-38)));o[a+64>>2]=w;b=k[l>>2]|0;if(b|0?(x=b+12|0,a=k[x>>2]|0,k[x>>2]=a+-1,(a|0)==1):0){d=k[l>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[h>>2]|0;if(!b){b=B1()|0;d=k[l>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[l>>2]=0}k[l>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[c>>2]|0)>0){d=k[m>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[n>>2]|0;if(!((b|0)==(p|0)|(b|0)==0))ggb(k[b+-4>>2]|0);OZ(y);e=D+36|0;b=k[e>>2]|0;if(b|0?(a=b+12|0,y=k[a>>2]|0,k[a>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[D+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[v>>2]|0)>0){d=k[t>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[v>>2]|0))}b=k[s>>2]|0;if(!((b|0)==(u|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=E+36|0;b=k[e>>2]|0;if(b|0?(y=b+12|0,D=k[y>>2]|0,k[y>>2]=D+-1,(D|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[E+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;E=E+16|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[B>>2]|0))}b=k[A>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=F+36|0;b=k[e>>2]|0;if(b|0?(D=b+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[F+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;E=F+16|0;d=F+4|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[d>>2]|0)>0){e=k[F+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[F+44>>2]|0;if((b|0)==(F+48|0)|(b|0)==0){r=G;return +w}ggb(k[b+-4>>2]|0);r=G;return +w}function kZa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+80|0;p=t+64|0;q=t+56|0;s=t;m=a+8|0;if(k[a+24>>2]|0){j=k[a+12>>2]|0;if((j|0)<3)a=aa(k[a+20>>2]|0,k[a+16>>2]|0)|0;else{h=k[a+48>>2]|0;g=0;a=1;do{a=aa(k[h+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(j|0))}if(!a)l=7}else l=7;if((l|0)==7){a=p+4|0;g=ZT(24)|0;k[g>>2]=1;h=g+4|0;k[p>>2]=h;k[a>>2]=18;i[g+22>>0]=0;j=390807;l=h+18|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,p,392673,390826,104);k[a>>2]=0;k[p>>2]=0;o=k[g>>2]|0;k[g>>2]=o+-1;if((o|0)==1)ggb(k[g+-4>>2]|0)}k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=m;do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[s>>2]=k[h>>2];o=s+4|0;a=h+4|0;k[o>>2]=k[a>>2];n=s+8|0;k[n>>2]=k[h+8>>2];k[s+12>>2]=k[h+12>>2];k[s+16>>2]=k[h+16>>2];k[s+20>>2]=k[h+20>>2];k[s+24>>2]=k[h+24>>2];k[s+28>>2]=k[h+28>>2];k[s+32>>2]=k[h+32>>2];g=k[h+36>>2]|0;k[s+36>>2]=g;j=s+40|0;k[j>>2]=n;n=s+48|0;l=s+44|0;k[l>>2]=n;k[s+52>>2]=0;k[n>>2]=0;if(g|0){n=g+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[a>>2]|0)<3){n=k[h+44>>2]|0;o=k[l>>2]|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];break}k[o>>2]=0;x1(s,k[a>>2]|0,0,0,0);if((k[o>>2]|0)>0){m=k[h+40>>2]|0;n=k[j>>2]|0;h=k[h+44>>2]|0;g=k[l>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[m+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[o>>2]|0))}}else{Q1(s,b,-1);j=s+40|0}while(0);a=k[j>>2]|0;h=k[a>>2]|0;k[q>>2]=k[a+4>>2];k[q+4>>2]=h;hoa(b,c,p,q,d,e,f);h=s+36|0;a=k[h>>2]|0;if(a|0?(p=a+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[s+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;q=s+16|0;h=s+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[h>>2]|0)>0){g=k[j>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[s+44>>2]|0;if((a|0)==(s+48|0)|(a|0)==0){r=t;return}ggb(k[a+-4>>2]|0);r=t;return}function lZa(a,b){a=a|0;b=b|0;i[a+4>>0]=b&1;return}function mZa(a){a=a|0;return (i[a+4>>0]|0)!=0|0}function nZa(a){a=a|0;ggb(a);return}function oZa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function pZa(a){a=a|0;var b=0,c=0;k[a>>2]=149216;c=a+12|0;b=k[c>>2]|0;k[a+16>>2]=0;k[c>>2]=0;if(!b)return;a=b+-4|0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)!=1)return;ggb(k[b+-8>>2]|0);return}function qZa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=149216;c=a+12|0;b=k[c>>2]|0;k[a+16>>2]=0;k[c>>2]=0;if(!b){ggb(a);return}d=b+-4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function rZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;l=m;j=l+4|0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[l>>2]=c;k[j>>2]=4;i[h+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,l)|0;c=k[l>>2]|0;k[j>>2]=0;k[l>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);f=z6(b,a+12|0)|0;k[l>>2]=0;j=l+4|0;k[j>>2]=0;h=ZT(16)|0;k[h>>2]=1;b=h+4|0;k[l>>2]=b;k[j>>2]=8;i[h+12>>0]=0;h=b;i[h>>0]=100;i[h+1>>0]=105;i[h+2>>0]=115;i[h+3>>0]=116;b=b+4|0;i[b>>0]=97;i[b+1>>0]=110;i[b+2>>0]=99;i[b+3>>0]=101;f=z6(f,l)|0;b=k[l>>2]|0;k[j>>2]=0;k[l>>2]=0;if(b|0?(h=b+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;if(Xh[k[(k[f>>2]|0)+12>>2]&1023](f)|0){e=f+32|0;if((k[e>>2]|0)==6){b=l+4|0;c=ZT(36)|0;k[c>>2]=1;g=c+4|0;k[l>>2]=g;k[b>>2]=30;i[c+34>>0]=0;h=401220;j=g+30|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-2,l,401251,401262,1064);k[b>>2]=0;k[l>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0)}if(!(k[f+16>>2]|0))b=0;else{b=k[f+12>>2]|0;b=(b|0)==0?1016759:b}p6(k[f+8>>2]|0,b,k[d>>2]|0);if(k[e>>2]&4|0)k[e>>2]=6}j=l+4|0;h=ZT(12)|0;k[h>>2]=1;b=h+4|0;k[l>>2]=b;k[j>>2]=4;i[h+8>>0]=0;i[b>>0]=114;i[b+1>>0]=97;i[b+2>>0]=110;i[b+3>>0]=107;f=z6(f,l)|0;b=k[l>>2]|0;k[j>>2]=0;k[l>>2]=0;if(b|0?(h=b+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[b+-8>>2]|0);d=a+8|0;if(!(Xh[k[(k[f>>2]|0)+12>>2]&1023](f)|0)){r=m;return}e=f+32|0;if((k[e>>2]|0)==6){b=l+4|0;c=ZT(36)|0;k[c>>2]=1;g=c+4|0;k[l>>2]=g;k[b>>2]=30;i[c+34>>0]=0;h=401220;j=g+30|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-2,l,401251,401262,1064);k[b>>2]=0;k[l>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)==1)ggb(k[c+-4>>2]|0)}if(!(k[f+16>>2]|0))b=0;else{b=k[f+12>>2]|0;b=(b|0)==0?1016759:b}u6(k[f+8>>2]|0,b,+o[d>>2]);if(!(k[e>>2]&4)){r=m;return}k[e>>2]=6;r=m;return}function sZa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;l=n;m=b+4|0;h=k6(k[b>>2]|0,k[m>>2]|0,401026)|0;k[l>>2]=0;j=l+4|0;k[j>>2]=0;J6(h,l,l);h=k[l>>2]|0;c=k[a+12>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[l>>2]=0;if(h|0?(j=h+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[h+-8>>2]|0)}else{f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[l>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c){c=l+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[l>>2]=f;k[c>>2]=27;i[e+31>>0]=0;g=401031;h=f+27|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,l,401059,391100,87);k[c>>2]=0;k[l>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}}c=k6(k[b>>2]|0,k[m>>2]|0,391168)|0;a:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break a}case 2:break;default:{c=2147483647;break a}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+4>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,391177)|0;if(!c){d=0.0;a=a+8|0;o[a>>2]=d;r=n;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+8|0;o[a>>2]=d;r=n;return}case 2:{d=+p[c+8>>3];a=a+8|0;o[a>>2]=d;r=n;return}default:{d=1000000015047466219876688.0e6;a=a+8|0;o[a>>2]=d;r=n;return}}}function tZa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0.0,n=0,p=0,q=0,s=0,t=0.0;s=r;r=r+128|0;q=s+72|0;p=s+16|0;n=s;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[q>>2]=k[f>>2];l=q+4|0;b=f+4|0;k[l>>2]=k[b>>2];j=q+8|0;k[j>>2]=k[f+8>>2];k[q+12>>2]=k[f+12>>2];k[q+16>>2]=k[f+16>>2];k[q+20>>2]=k[f+20>>2];k[q+24>>2]=k[f+24>>2];k[q+28>>2]=k[f+28>>2];k[q+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[q+36>>2]=d;e=q+40|0;k[e>>2]=j;j=q+48|0;h=q+44|0;k[h>>2]=j;k[q+52>>2]=0;k[j>>2]=0;if(d|0){j=d+12|0;k[j>>2]=(k[j>>2]|0)+1}if((k[b>>2]|0)<3){j=k[f+44>>2]|0;l=k[h>>2]|0;k[l>>2]=k[j>>2];k[l+4>>2]=k[j+4>>2];break}k[l>>2]=0;x1(q,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(q,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[p>>2]=k[g>>2];l=p+4|0;d=g+4|0;k[l>>2]=k[d>>2];c=p+8|0;k[c>>2]=k[g+8>>2];k[p+12>>2]=k[g+12>>2];k[p+16>>2]=k[g+16>>2];k[p+20>>2]=k[g+20>>2];k[p+24>>2]=k[g+24>>2];k[p+28>>2]=k[g+28>>2];k[p+32>>2]=k[g+32>>2];b=k[g+36>>2]|0;k[p+36>>2]=b;e=p+40|0;k[e>>2]=c;c=p+48|0;h=p+44|0;k[h>>2]=c;k[p+52>>2]=0;k[c>>2]=0;if(b|0){c=b+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[d>>2]|0)<3){l=k[g+44>>2]|0;c=k[h>>2]|0;k[c>>2]=k[l>>2];k[c+4>>2]=k[l+4>>2];break}k[l>>2]=0;x1(p,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;f=k[e>>2]|0;e=k[g+44>>2]|0;d=k[h>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(p,c,-1);while(0);if((k[q>>2]&4095|0)!=5){c=n+4|0;l=c+4|0;k[l>>2]=0;k[l+4>>2]=0;k[n>>2]=33619968;k[c>>2]=q;SW(q,n,5,1.0,0.0)}if((k[p>>2]&4095|0)!=5){c=n+4|0;l=c+4|0;k[l>>2]=0;k[l+4>>2]=0;k[n>>2]=33619968;k[c>>2]=p;SW(p,n,5,1.0,0.0)}if(!((k[q>>2]&4088|0)==8?(k[q+12>>2]|0)>0:0)){k[n>>2]=0;b=n+4|0;k[b>>2]=0;d=ZT(44)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[b>>2]=37;i[d+41>>0]=0;f=392336;g=e+37|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,n,392374,391100,136);k[b>>2]=0;k[n>>2]=0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)==1)ggb(k[d+-4>>2]|0)}if(!((k[p>>2]&4088|0)==8?(k[p+12>>2]|0)>0:0)){k[n>>2]=0;b=n+4|0;k[b>>2]=0;d=ZT(44)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[b>>2]=37;i[d+41>>0]=0;f=392390;g=e+37|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,n,392374,391100,137);k[b>>2]=0;k[n>>2]=0;n=k[d>>2]|0;k[d>>2]=n+-1;if((n|0)==1)ggb(k[d+-4>>2]|0)}b=a+4|0;e=a+8|0;m=+yZa(q,p,k[b>>2]|0,+o[e>>2]);t=+yZa(p,q,k[b>>2]|0,+o[e>>2]);m=m<t?t:m;e=p+36|0;b=k[e>>2]|0;if(b|0?(a=b+12|0,n=k[a>>2]|0,k[a>>2]=n+-1,(n|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[p+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;n=p+16|0;d=p+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[d>>2]|0)>0){e=k[p+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[p+44>>2]|0;if(!((b|0)==(p+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=q+36|0;b=k[e>>2]|0;if(b|0?(n=b+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[q+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[q+44>>2]|0;if((b|0)==(q+48|0)|(b|0)==0){r=s;return +m}ggb(k[b+-4>>2]|0);r=s;return +m}function uZa(a,b){a=a|0;b=b|0;k[a+4>>2]=b;return}function vZa(a){a=a|0;return k[a+4>>2]|0}function wZa(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if(b>0.0&b<=1.0){j=a+8|0;o[j>>2]=b;r=g;return}d=c+4|0;e=ZT(48)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=43;i[e+47>>0]=0;h=391038;j=f+43|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-215,c,391082,391100,72);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);j=a+8|0;o[j>>2]=b;r=g;return}function xZa(a){a=a|0;return +(+o[a+8>>2])}function yZa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0;P=r;r=r+240|0;I=P;G=P+224|0;L=P+168|0;J=P+112|0;H=P+56|0;e=k[a+12>>2]|0;f=k[b+12>>2]|0;k[L>>2]=1124007936;M=L+4|0;E=L+8|0;K=L+40|0;g=M;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[K>>2]=E;O=L+48|0;N=L+44|0;k[N>>2]=O;k[L+52>>2]=0;k[O>>2]=0;k[I>>2]=e;D=I+4|0;k[D>>2]=f;G1(L,2,I,5);f=k[E>>2]|0;F=~~(+(f+-1|0)*d);if((f|0)>0){C=L+12|0;B=a+16|0;g=b+16|0;h=J+4|0;i=J+8|0;j=J+12|0;l=J+16|0;m=J+20|0;n=J+24|0;q=J+32|0;s=J+36|0;t=J+40|0;u=J+48|0;v=J+44|0;w=J+52|0;x=G+8|0;y=G+12|0;z=G+4|0;A=L+16|0;b=0;e=k[C>>2]|0;do{if((e|0)>0){a=0;do{f=k[B>>2]|0;e=k[g>>2]|0;S=+o[f+(b<<3)>>2];Q=+o[f+(b<<3)+4>>2];R=+o[e+(a<<3)>>2];d=+o[e+(a<<3)+4>>2];k[J>>2]=1124024325;k[h>>2]=2;k[i>>2]=2;k[j>>2]=1;k[l>>2]=0;k[m>>2]=0;k[n>>2]=0;k[q>>2]=0;k[s>>2]=0;k[t>>2]=i;k[v>>2]=u;k[w>>2]=0;k[u>>2]=0;k[I>>2]=2;k[D>>2]=1;G1(J,2,I,5);e=k[l>>2]|0;o[e>>2]=S-R;o[e+4>>2]=Q-d;k[x>>2]=0;k[y>>2]=0;k[G>>2]=16842752;k[z>>2]=J;d=+N7(G,c,49332);e=(k[A>>2]|0)+(aa(k[k[N>>2]>>2]|0,b)|0)+(a<<2)|0;o[e>>2]=d;e=k[s>>2]|0;if(e|0?(e=e+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){f=k[s>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[q>>2]|0;if(!e){e=B1()|0;f=k[s>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[s>>2]=0}k[s>>2]=0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[h>>2]|0)>0){f=k[t>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[h>>2]|0))}e=k[v>>2]|0;if(!((e|0)==(u|0)|(e|0)==0))ggb(k[e+-4>>2]|0);a=a+1|0;e=k[C>>2]|0}while((a|0)<(e|0));f=k[E>>2]|0}b=b+1|0}while((b|0)<(f|0))}k[J>>2]=1124007936;y=J+4|0;e=J+8|0;w=J+40|0;g=y;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[w>>2]=e;z=J+48|0;x=J+44|0;k[x>>2]=z;k[J+52>>2]=0;k[z>>2]=0;k[I>>2]=f;k[D>>2]=1;G1(J,2,I,5);if((k[E>>2]|0)>0){b=I+4|0;g=G+4|0;h=G+8|0;i=G+12|0;j=G+4|0;l=J+16|0;m=H+36|0;n=H+16|0;q=H+4|0;s=H+40|0;t=H+44|0;u=H+48|0;v=H+32|0;a=0;do{e=a;a=a+1|0;k[I>>2]=e;k[b>>2]=a;k[G>>2]=-2147483648;k[g>>2]=2147483647;H1(H,L,I,G);k[h>>2]=0;k[i>>2]=0;k[G>>2]=16842752;k[j>>2]=H;D7(G,I,0,0,0,49332);e=(k[l>>2]|0)+(aa(k[k[x>>2]>>2]|0,e)|0)|0;o[e>>2]=+p[I>>3];e=k[m>>2]|0;if(e|0?(c=e+12|0,D=k[c>>2]|0,k[c>>2]=D+-1,(D|0)==1):0){f=k[m>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[v>>2]|0;if(!e){e=B1()|0;f=k[m>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[m>>2]=0}k[m>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[q>>2]|0)>0){f=k[s>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[q>>2]|0))}e=k[t>>2]|0;if(!((e|0)==(u|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}while((a|0)<(k[E>>2]|0))}k[I>>2]=1124007936;j=I+4|0;e=I+8|0;i=I+40|0;g=j;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[i>>2]=e;h=I+48|0;g=I+44|0;k[g>>2]=h;k[I+52>>2]=0;k[h>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=J;b=H+4|0;a=b+4|0;k[a>>2]=0;k[a+4>>2]=0;k[H>>2]=33619968;k[b>>2]=I;G3(G,H,16);b=I+16|0;a=(k[b>>2]|0)+(aa(k[k[g>>2]>>2]|0,F)|0)|0;d=+o[a>>2];a=I+36|0;e=k[a>>2]|0;if(e|0?(G=e+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){f=k[a>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[I+32>>2]|0;if(!e){e=B1()|0;f=k[a>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[a>>2]=0}k[a>>2]=0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[j>>2]|0)>0){f=k[i>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[j>>2]|0))}e=k[g>>2]|0;if(!((e|0)==(h|0)|(e|0)==0))ggb(k[e+-4>>2]|0);a=J+36|0;e=k[a>>2]|0;if(e|0?(H=e+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){f=k[a>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[J+32>>2]|0;if(!e){e=B1()|0;f=k[a>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[a>>2]=0}k[a>>2]=0;J=J+16|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[y>>2]|0)>0){f=k[w>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[y>>2]|0))}e=k[x>>2]|0;if(!((e|0)==(z|0)|(e|0)==0))ggb(k[e+-4>>2]|0);a=L+36|0;e=k[a>>2]|0;if(e|0?(I=e+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){f=k[a>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[L+32>>2]|0;if(!e){e=B1()|0;f=k[a>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[a>>2]=0}k[a>>2]=0;L=L+16|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[M>>2]|0)>0){f=k[K>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[M>>2]|0))}e=k[N>>2]|0;if((e|0)==(O|0)|(e|0)==0){r=P;return +d}ggb(k[e+-4>>2]|0);r=P;return +d}function zZa(a){a=a|0;ggb(a);return}function AZa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function BZa(a){a=a|0;var b=0,c=0;k[a>>2]=149296;c=a+16|0;b=k[c>>2]|0;k[a+20>>2]=0;k[c>>2]=0;if(!b)return;a=b+-4|0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)!=1)return;ggb(k[b+-8>>2]|0);return}function CZa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=149296;c=a+16|0;b=k[c>>2]|0;k[a+20>>2]=0;k[c>>2]=0;if(!b){ggb(a);return}d=b+-4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function DZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;d=e;f=d+4|0;g=ZT(12)|0;k[g>>2]=1;c=g+4|0;k[d>>2]=c;k[f>>2]=4;i[g+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,d)|0;c=k[d>>2]|0;k[f>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+16|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=4;i[f+8>>0]=0;i[c>>0]=102;i[c+1>>0]=108;i[c+2>>0]=97;i[c+3>>0]=103;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=MZa(b,a+4|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=7;i[f+11>>0]=0;i[c>>0]=i[391411]|0;i[c+1>>0]=i[391412]|0;i[c+2>>0]=i[391413]|0;i[c+3>>0]=i[391414]|0;i[c+4>>0]=i[391415]|0;i[c+5>>0]=i[391416]|0;i[c+6>>0]=i[391417]|0;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=MZa(b,a+8|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=7;i[f+11>>0]=0;i[c>>0]=i[391419]|0;i[c+1>>0]=i[391420]|0;i[c+2>>0]=i[391421]|0;i[c+3>>0]=i[391422]|0;i[c+4>>0]=i[391423]|0;i[c+5>>0]=i[391424]|0;i[c+6>>0]=i[391425]|0;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(!c){g=a+12|0;NZa(b,g);r=e;return}f=c+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){g=a+12|0;NZa(b,g);r=e;return}ggb(k[c+-8>>2]|0);g=a+12|0;NZa(b,g);r=e;return}function EZa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;l=n;m=b+4|0;h=k6(k[b>>2]|0,k[m>>2]|0,401026)|0;k[l>>2]=0;j=l+4|0;k[j>>2]=0;J6(h,l,l);h=k[l>>2]|0;c=k[a+16>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[l>>2]=0;if(h|0?(j=h+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[h+-8>>2]|0)}else{f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[l>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c){c=l+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[l>>2]=f;k[c>>2]=27;i[e+31>>0]=0;g=401031;h=f+27|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,l,401059,391337,110);k[c>>2]=0;k[l>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}}c=k6(k[b>>2]|0,k[m>>2]|0,391406)|0;a:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break a}case 2:break;default:{c=2147483647;break a}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+4>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,391411)|0;b:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break b}case 2:break;default:{c=2147483647;break b}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+8>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,391419)|0;if(!c){d=0.0;a=a+12|0;o[a>>2]=d;r=n;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+12|0;o[a>>2]=d;r=n;return}case 2:{d=+p[c+8>>3];a=a+12|0;o[a>>2]=d;r=n;return}default:{d=1000000015047466219876688.0e6;a=a+12|0;o[a>>2]=d;r=n;return}}}function FZa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0.0;Ia=r;r=r+784|0;Ba=Ia+288|0;Ca=Ia+768|0;Ha=Ia+712|0;Ga=Ia+656|0;Fa=Ia+600|0;Ea=Ia+544|0;Da=Ia+488|0;xa=Ia+432|0;ya=Ia+376|0;za=Ia+320|0;F=Ia+256|0;G=Ia+224|0;Aa=Ia;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[Ha>>2]=k[g>>2];l=Ha+4|0;b=g+4|0;k[l>>2]=k[b>>2];wa=Ha+8|0;k[wa>>2]=k[g+8>>2];k[Ha+12>>2]=k[g+12>>2];k[Ha+16>>2]=k[g+16>>2];k[Ha+20>>2]=k[g+20>>2];k[Ha+24>>2]=k[g+24>>2];k[Ha+28>>2]=k[g+28>>2];k[Ha+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Ha+36>>2]=e;f=Ha+40|0;k[f>>2]=wa;wa=Ha+48|0;i=Ha+44|0;k[i>>2]=wa;k[Ha+52>>2]=0;k[wa>>2]=0;if(e|0){wa=e+12|0;k[wa>>2]=(k[wa>>2]|0)+1}if((k[b>>2]|0)<3){va=k[g+44>>2]|0;wa=k[i>>2]|0;k[wa>>2]=k[va>>2];k[wa+4>>2]=k[va+4>>2];break}k[l>>2]=0;x1(Ha,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(Ha,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){i=k[c+4>>2]|0;k[Ga>>2]=k[i>>2];c=Ga+4|0;f=i+4|0;k[c>>2]=k[f>>2];b=Ga+8|0;k[b>>2]=k[i+8>>2];k[Ga+12>>2]=k[i+12>>2];k[Ga+16>>2]=k[i+16>>2];k[Ga+20>>2]=k[i+20>>2];k[Ga+24>>2]=k[i+24>>2];k[Ga+28>>2]=k[i+28>>2];k[Ga+32>>2]=k[i+32>>2];e=k[i+36>>2]|0;k[Ga+36>>2]=e;g=Ga+40|0;k[g>>2]=b;wa=Ga+48|0;j=Ga+44|0;k[j>>2]=wa;k[Ga+52>>2]=0;k[wa>>2]=0;if(e|0){wa=e+12|0;k[wa>>2]=(k[wa>>2]|0)+1}if((k[f>>2]|0)<3){va=k[i+44>>2]|0;wa=k[j>>2]|0;k[wa>>2]=k[va>>2];k[wa+4>>2]=k[va+4>>2];break}k[c>>2]=0;x1(Ga,k[f>>2]|0,0,0,0);if((k[c>>2]|0)>0){l=k[i+40>>2]|0;h=k[g>>2]|0;g=k[i+44>>2]|0;f=k[j>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[c>>2]|0))}}else{Q1(Ga,c,-1);b=Ga+8|0}while(0);sa=k[Ha+8>>2]|0;wa=k[b>>2]|0;sa=((sa|0)<(wa|0)?wa:sa)+(k[a+8>>2]|0)|0;c2(d,sa,sa,5,-1,0,0);do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[Fa>>2]=k[g>>2];l=Fa+4|0;b=g+4|0;k[l>>2]=k[b>>2];wa=Fa+8|0;k[wa>>2]=k[g+8>>2];k[Fa+12>>2]=k[g+12>>2];k[Fa+16>>2]=k[g+16>>2];k[Fa+20>>2]=k[g+20>>2];k[Fa+24>>2]=k[g+24>>2];k[Fa+28>>2]=k[g+28>>2];k[Fa+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Fa+36>>2]=e;f=Fa+40|0;k[f>>2]=wa;wa=Fa+48|0;i=Fa+44|0;k[i>>2]=wa;k[Fa+52>>2]=0;k[wa>>2]=0;if(e|0){wa=e+12|0;k[wa>>2]=(k[wa>>2]|0)+1}if((k[b>>2]|0)<3){va=k[g+44>>2]|0;wa=k[i>>2]|0;k[wa>>2]=k[va>>2];k[wa+4>>2]=k[va+4>>2];break}k[l>>2]=0;x1(Fa,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(Fa,d,-1);while(0);k[Ea>>2]=1124007936;ua=Ea+4|0;ma=Ea+8|0;ta=Ea+40|0;e=ua;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[ta>>2]=ma;wa=Ea+48|0;va=Ea+44|0;k[va>>2]=wa;k[Ea+52>>2]=0;k[wa>>2]=0;pa=Ba+4|0;na=pa+4|0;k[na>>2]=0;k[na+4>>2]=0;k[Ba>>2]=33619968;k[pa>>2]=Ea;mY(Ha,Ba);k[Da>>2]=1124007936;pa=Da+4|0;na=Da+8|0;oa=Da+40|0;e=pa;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[oa>>2]=na;ra=Da+48|0;qa=Da+44|0;k[qa>>2]=ra;k[Da+52>>2]=0;k[ra>>2]=0;la=Ba+4|0;ka=la+4|0;k[ka>>2]=0;k[ka+4>>2]=0;k[Ba>>2]=33619968;k[la>>2]=Da;mY(Ga,Ba);if((k[ma>>2]|0)>0){g=Ba+4|0;h=Ca+4|0;i=Ba+4|0;j=Ca+4|0;l=ya+8|0;c=ya+12|0;d=ya+4|0;m=Ba+4|0;n=m+4|0;q=za+36|0;s=za+16|0;t=za+4|0;u=za+40|0;v=za+44|0;w=za+48|0;x=xa+36|0;y=xa+16|0;z=xa+4|0;A=xa+40|0;B=xa+44|0;C=xa+48|0;D=xa+32|0;E=za+32|0;f=0;do{b=f;f=f+1|0;k[Ba>>2]=b;k[g>>2]=f;k[Ca>>2]=-2147483648;k[h>>2]=2147483647;H1(xa,Ea,Ba,Ca);k[Ba>>2]=b;k[i>>2]=f;k[Ca>>2]=-2147483648;k[j>>2]=2147483647;H1(za,Ea,Ba,Ca);k[l>>2]=0;k[c>>2]=0;k[ya>>2]=16842752;k[d>>2]=za;g7(F,ya);Ja=+p[F>>3]+1.1920928955078125e-07;b=n;k[b>>2]=0;k[b+4>>2]=0;k[Ba>>2]=33619968;k[m>>2]=xa;SW(xa,Ba,-1,1.0/Ja,0.0);b=k[q>>2]|0;if(b|0?(ka=b+12|0,la=k[ka>>2]|0,k[ka>>2]=la+-1,(la|0)==1):0){e=k[q>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[E>>2]|0;if(!b){b=B1()|0;e=k[q>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[q>>2]=0}k[q>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[t>>2]|0)>0){e=k[u>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[v>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[x>>2]|0;if(b|0?(ka=b+12|0,la=k[ka>>2]|0,k[ka>>2]=la+-1,(la|0)==1):0){e=k[x>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D>>2]|0;if(!b){b=B1()|0;e=k[x>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[x>>2]=0}k[x>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[z>>2]|0)>0){e=k[A>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[B>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((f|0)<(k[ma>>2]|0))}if((k[na>>2]|0)>0){g=Ba+4|0;h=Ca+4|0;i=Ba+4|0;j=Ca+4|0;l=ya+8|0;c=ya+12|0;d=ya+4|0;m=Ba+4|0;n=m+4|0;q=za+36|0;s=za+16|0;t=za+4|0;u=za+40|0;v=za+44|0;w=za+48|0;x=xa+36|0;y=xa+16|0;z=xa+4|0;A=xa+40|0;B=xa+44|0;C=xa+48|0;D=xa+32|0;E=za+32|0;f=0;do{b=f;f=f+1|0;k[Ba>>2]=b;k[g>>2]=f;k[Ca>>2]=-2147483648;k[h>>2]=2147483647;H1(xa,Da,Ba,Ca);k[Ba>>2]=b;k[i>>2]=f;k[Ca>>2]=-2147483648;k[j>>2]=2147483647;H1(za,Da,Ba,Ca);k[l>>2]=0;k[c>>2]=0;k[ya>>2]=16842752;k[d>>2]=za;g7(G,ya);Ja=+p[G>>3]+1.1920928955078125e-07;b=n;k[b>>2]=0;k[b+4>>2]=0;k[Ba>>2]=33619968;k[m>>2]=xa;SW(xa,Ba,-1,1.0/Ja,0.0);b=k[q>>2]|0;if(b|0?(ka=b+12|0,la=k[ka>>2]|0,k[ka>>2]=la+-1,(la|0)==1):0){e=k[q>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[E>>2]|0;if(!b){b=B1()|0;e=k[q>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[q>>2]=0}k[q>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[t>>2]|0)>0){e=k[u>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[v>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[x>>2]|0;if(b|0?(ka=b+12|0,la=k[ka>>2]|0,k[ka>>2]=la+-1,(la|0)==1):0){e=k[x>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D>>2]|0;if(!b){b=B1()|0;e=k[x>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[x>>2]=0}k[x>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[z>>2]|0)>0){e=k[A>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[B>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((f|0)<(k[na>>2]|0))}if((sa|0)>0){J=Ba+4|0;K=Ca+4|0;L=Ba+4|0;M=Ca+4|0;N=xa+4|0;O=xa+8|0;P=xa+40|0;Q=xa+48|0;R=xa+44|0;S=xa+52|0;T=za+36|0;U=za+16|0;V=za+4|0;W=za+40|0;X=za+44|0;Y=za+48|0;Z=ya+36|0;_=ya+16|0;$=ya+4|0;ba=ya+40|0;ca=ya+44|0;da=ya+48|0;ea=Ba+8|0;fa=Ba+12|0;ga=Ba+4|0;ha=a+4|0;ia=Fa+16|0;ja=Fa+44|0;ka=xa+36|0;la=xa+16|0;j=a+12|0;l=Aa+4|0;c=Aa+8|0;d=Aa+12|0;m=Aa+16|0;n=Aa+48|0;q=Aa+56|0;s=Aa+52|0;t=Aa+60|0;u=Aa+64|0;v=Aa+68|0;w=Aa+72|0;x=Aa+104|0;y=Aa+112|0;z=Aa+108|0;A=Aa+116|0;B=Aa+120|0;C=Aa+124|0;D=Aa+128|0;E=Aa+160|0;F=Aa+168|0;G=Aa+164|0;a=xa+32|0;H=ya+32|0;I=za+32|0;h=0;do{i=h;h=h+1|0;b=0;do if((i|0)<(k[ma>>2]|0)?(b|0)<(k[na>>2]|0):0){k[Ba>>2]=i;k[J>>2]=h;k[Ca>>2]=-2147483648;k[K>>2]=2147483647;H1(ya,Ea,Ba,Ca);g=b+1|0;k[Ba>>2]=b;k[L>>2]=g;k[Ca>>2]=-2147483648;k[M>>2]=2147483647;H1(za,Da,Ba,Ca);k[Aa>>2]=0;k[l>>2]=0;k[c>>2]=1124007936;e=d;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[n>>2]=m;k[s>>2]=q;k[t>>2]=0;k[q>>2]=0;k[u>>2]=1124007936;e=v;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[x>>2]=w;k[z>>2]=y;k[A>>2]=0;k[y>>2]=0;k[B>>2]=1124007936;e=C;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[E>>2]=D;k[G>>2]=F;e=F;f=e+56|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;k[Ba+16>>2]=0;k[Ba+20>>2]=0;k[Ba+24>>2]=0;k[Ba+28>>2]=0;G0(Aa,ya,za,1.0,-1.0,Ba);k[xa>>2]=1124007936;e=N;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[P>>2]=O;k[R>>2]=Q;k[S>>2]=0;k[Q>>2]=0;e=k[Aa>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,Aa,xa,-1);XN(Aa);e=k[T>>2]|0;if(e|0?(e=e+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){f=k[T>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[I>>2]|0;if(!e){e=B1()|0;f=k[T>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[T>>2]=0}k[T>>2]=0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[V>>2]|0)>0){f=k[W>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[V>>2]|0))}e=k[X>>2]|0;if(!((e|0)==(Y|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[Z>>2]|0;if(e|0?(e=e+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){f=k[Z>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[H>>2]|0;if(e|0)break;e=B1()|0;f=k[Z>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[Z>>2]=0}k[Z>>2]=0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[$>>2]|0)>0){f=k[ba>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[$>>2]|0))}e=k[ca>>2]|0;if(!((e|0)==(da|0)|(e|0)==0))ggb(k[e+-4>>2]|0);k[ea>>2]=0;k[fa>>2]=0;k[Ba>>2]=16842752;k[ga>>2]=xa;Ja=+N7(Ba,k[ha>>2]|0,49332);b=(k[ia>>2]|0)+(aa(k[k[ja>>2]>>2]|0,i)|0)+(b<<2)|0;o[b>>2]=Ja;b=k[ka>>2]|0;if(b|0?(e=b+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){e=k[ka>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[a>>2]|0;if(b|0)break;b=B1()|0;e=k[ka>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[ka>>2]=0}k[ka>>2]=0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[N>>2]|0)>0){e=k[P>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[N>>2]|0))}b=k[R>>2]|0;if(!((b|0)==(Q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=g}else{g=(k[ia>>2]|0)+(aa(k[k[ja>>2]>>2]|0,i)|0)+(b<<2)|0;k[g>>2]=k[j>>2];b=b+1|0}while((b|0)<(sa|0))}while((h|0)<(sa|0))}f=Da+36|0;b=k[f>>2]|0;if(b|0?(Ba=b+12|0,Ca=k[Ba>>2]|0,k[Ba>>2]=Ca+-1,(Ca|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Da+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Da=Da+16|0;k[Da>>2]=0;k[Da+4>>2]=0;k[Da+8>>2]=0;k[Da+12>>2]=0;if((k[pa>>2]|0)>0){e=k[oa>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[pa>>2]|0))}b=k[qa>>2]|0;if(!((b|0)==(ra|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Ea+36|0;b=k[f>>2]|0;if(b|0?(Ca=b+12|0,Da=k[Ca>>2]|0,k[Ca>>2]=Da+-1,(Da|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Ea+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Ea=Ea+16|0;k[Ea>>2]=0;k[Ea+4>>2]=0;k[Ea+8>>2]=0;k[Ea+12>>2]=0;if((k[ua>>2]|0)>0){e=k[ta>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ua>>2]|0))}b=k[va>>2]|0;if(!((b|0)==(wa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Fa+36|0;b=k[f>>2]|0;if(b|0?(Da=b+12|0,Ea=k[Da>>2]|0,k[Da>>2]=Ea+-1,(Ea|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Fa+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Ea=Fa+16|0;e=Fa+4|0;k[Ea>>2]=0;k[Ea+4>>2]=0;k[Ea+8>>2]=0;k[Ea+12>>2]=0;if((k[e>>2]|0)>0){f=k[Fa+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Fa+44>>2]|0;if(!((b|0)==(Fa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Ga+36|0;b=k[f>>2]|0;if(b|0?(Ea=b+12|0,Fa=k[Ea>>2]|0,k[Ea>>2]=Fa+-1,(Fa|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Ga+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Fa=Ga+16|0;e=Ga+4|0;k[Fa>>2]=0;k[Fa+4>>2]=0;k[Fa+8>>2]=0;k[Fa+12>>2]=0;if((k[e>>2]|0)>0){f=k[Ga+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Ga+44>>2]|0;if(!((b|0)==(Ga+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Ha+36|0;b=k[f>>2]|0;do if(b|0){Fa=b+12|0;Ga=k[Fa>>2]|0;k[Fa>>2]=Ga+-1;if((Ga|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Ha+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;Ga=Ha+16|0;e=Ha+4|0;k[Ga>>2]=0;k[Ga+4>>2]=0;k[Ga+8>>2]=0;k[Ga+12>>2]=0;if((k[e>>2]|0)>0){f=k[Ha+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Ha+44>>2]|0;if((b|0)==(Ha+48|0)|(b|0)==0){r=Ia;return}ggb(k[b+-4>>2]|0);r=Ia;return}function GZa(a,b){a=a|0;b=b|0;k[a+8>>2]=b;return}function HZa(a){a=a|0;return k[a+8>>2]|0}function IZa(a,b){a=a|0;b=+b;o[a+12>>2]=b;return}function JZa(a){a=a|0;return +(+o[a+12>>2])}function KZa(a,b){a=a|0;b=b|0;k[a+4>>2]=b;return}function LZa(a){a=a|0;return k[a+4>>2]|0}function MZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function NZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+o[b>>2]);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function OZa(a){a=a|0;var b=0,c=0;k[a>>2]=149364;c=a+16|0;b=k[c>>2]|0;k[a+20>>2]=0;k[c>>2]=0;if(!b)return;a=b+-4|0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)!=1)return;ggb(k[b+-8>>2]|0);return}function PZa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=149364;c=a+16|0;b=k[c>>2]|0;k[a+20>>2]=0;k[c>>2]=0;if(!b){ggb(a);return}d=b+-4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function QZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;d=e;f=d+4|0;g=ZT(12)|0;k[g>>2]=1;c=g+4|0;k[d>>2]=c;k[f>>2]=4;i[g+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,d)|0;c=k[d>>2]|0;k[f>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+16|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=4;i[f+8>>0]=0;i[c>>0]=102;i[c+1>>0]=108;i[c+2>>0]=97;i[c+3>>0]=103;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=MZa(b,a+4|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=7;i[f+11>>0]=0;i[c>>0]=i[391411]|0;i[c+1>>0]=i[391412]|0;i[c+2>>0]=i[391413]|0;i[c+3>>0]=i[391414]|0;i[c+4>>0]=i[391415]|0;i[c+5>>0]=i[391416]|0;i[c+6>>0]=i[391417]|0;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=MZa(b,a+8|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=7;i[f+11>>0]=0;i[c>>0]=i[391419]|0;i[c+1>>0]=i[391420]|0;i[c+2>>0]=i[391421]|0;i[c+3>>0]=i[391422]|0;i[c+4>>0]=i[391423]|0;i[c+5>>0]=i[391424]|0;i[c+6>>0]=i[391425]|0;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(!c){g=a+12|0;NZa(b,g);r=e;return}f=c+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){g=a+12|0;NZa(b,g);r=e;return}ggb(k[c+-8>>2]|0);g=a+12|0;NZa(b,g);r=e;return}function RZa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;l=n;m=b+4|0;h=k6(k[b>>2]|0,k[m>>2]|0,401026)|0;k[l>>2]=0;j=l+4|0;k[j>>2]=0;J6(h,l,l);h=k[l>>2]|0;c=k[a+16>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[l>>2]=0;if(h|0?(j=h+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[h+-8>>2]|0)}else{f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[l>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c){c=l+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[l>>2]=f;k[c>>2]=27;i[e+31>>0]=0;g=401031;h=f+27|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,l,401059,391337,235);k[c>>2]=0;k[l>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}}c=k6(k[b>>2]|0,k[m>>2]|0,391406)|0;a:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break a}case 2:break;default:{c=2147483647;break a}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+4>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,391411)|0;b:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break b}case 2:break;default:{c=2147483647;break b}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+8>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,391419)|0;if(!c){d=0.0;a=a+12|0;o[a>>2]=d;r=n;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+12|0;o[a>>2]=d;r=n;return}case 2:{d=+p[c+8>>3];a=a+12|0;o[a>>2]=d;r=n;return}default:{d=1000000015047466219876688.0e6;a=a+12|0;o[a>>2]=d;r=n;return}}}function SZa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0.0,Pb=0;Nb=r;r=r+944|0;Gb=Nb+920|0;Hb=Nb+904|0;Mb=Nb+624|0;Lb=Nb+568|0;Kb=Nb+512|0;Jb=Nb+456|0;Ib=Nb+400|0;zb=Nb+344|0;Ab=Nb+288|0;F=Nb+256|0;G=Nb+224|0;Bb=Nb+848|0;Cb=Nb;Db=Nb+792|0;Eb=Nb+736|0;Fb=Nb+680|0;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[Mb>>2]=k[g>>2];l=Mb+4|0;b=g+4|0;k[l>>2]=k[b>>2];yb=Mb+8|0;k[yb>>2]=k[g+8>>2];k[Mb+12>>2]=k[g+12>>2];k[Mb+16>>2]=k[g+16>>2];k[Mb+20>>2]=k[g+20>>2];k[Mb+24>>2]=k[g+24>>2];k[Mb+28>>2]=k[g+28>>2];k[Mb+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Mb+36>>2]=e;f=Mb+40|0;k[f>>2]=yb;yb=Mb+48|0;i=Mb+44|0;k[i>>2]=yb;k[Mb+52>>2]=0;k[yb>>2]=0;if(e|0){yb=e+12|0;k[yb>>2]=(k[yb>>2]|0)+1}if((k[b>>2]|0)<3){xb=k[g+44>>2]|0;yb=k[i>>2]|0;k[yb>>2]=k[xb>>2];k[yb+4>>2]=k[xb+4>>2];break}k[l>>2]=0;x1(Mb,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(Mb,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){i=k[c+4>>2]|0;k[Lb>>2]=k[i>>2];c=Lb+4|0;f=i+4|0;k[c>>2]=k[f>>2];b=Lb+8|0;k[b>>2]=k[i+8>>2];k[Lb+12>>2]=k[i+12>>2];k[Lb+16>>2]=k[i+16>>2];k[Lb+20>>2]=k[i+20>>2];k[Lb+24>>2]=k[i+24>>2];k[Lb+28>>2]=k[i+28>>2];k[Lb+32>>2]=k[i+32>>2];e=k[i+36>>2]|0;k[Lb+36>>2]=e;g=Lb+40|0;k[g>>2]=b;yb=Lb+48|0;j=Lb+44|0;k[j>>2]=yb;k[Lb+52>>2]=0;k[yb>>2]=0;if(e|0){yb=e+12|0;k[yb>>2]=(k[yb>>2]|0)+1}if((k[f>>2]|0)<3){xb=k[i+44>>2]|0;yb=k[j>>2]|0;k[yb>>2]=k[xb>>2];k[yb+4>>2]=k[xb+4>>2];break}k[c>>2]=0;x1(Lb,k[f>>2]|0,0,0,0);if((k[c>>2]|0)>0){l=k[i+40>>2]|0;h=k[g>>2]|0;g=k[i+44>>2]|0;f=k[j>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[c>>2]|0))}}else{Q1(Lb,c,-1);b=Lb+8|0}while(0);ub=k[Mb+8>>2]|0;yb=k[b>>2]|0;ub=((ub|0)<(yb|0)?yb:ub)+(k[a+8>>2]|0)|0;c2(d,ub,ub,5,-1,0,0);do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[Kb>>2]=k[g>>2];l=Kb+4|0;b=g+4|0;k[l>>2]=k[b>>2];yb=Kb+8|0;k[yb>>2]=k[g+8>>2];k[Kb+12>>2]=k[g+12>>2];k[Kb+16>>2]=k[g+16>>2];k[Kb+20>>2]=k[g+20>>2];k[Kb+24>>2]=k[g+24>>2];k[Kb+28>>2]=k[g+28>>2];k[Kb+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Kb+36>>2]=e;f=Kb+40|0;k[f>>2]=yb;yb=Kb+48|0;i=Kb+44|0;k[i>>2]=yb;k[Kb+52>>2]=0;k[yb>>2]=0;if(e|0){yb=e+12|0;k[yb>>2]=(k[yb>>2]|0)+1}if((k[b>>2]|0)<3){xb=k[g+44>>2]|0;yb=k[i>>2]|0;k[yb>>2]=k[xb>>2];k[yb+4>>2]=k[xb+4>>2];break}k[l>>2]=0;x1(Kb,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(Kb,d,-1);while(0);k[Jb>>2]=1124007936;wb=Jb+4|0;ob=Jb+8|0;vb=Jb+40|0;f=wb;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[vb>>2]=ob;yb=Jb+48|0;xb=Jb+44|0;k[xb>>2]=yb;k[Jb+52>>2]=0;k[yb>>2]=0;rb=Gb+4|0;pb=rb+4|0;k[pb>>2]=0;k[pb+4>>2]=0;k[Gb>>2]=33619968;k[rb>>2]=Jb;mY(Mb,Gb);k[Ib>>2]=1124007936;rb=Ib+4|0;pb=Ib+8|0;qb=Ib+40|0;f=rb;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[qb>>2]=pb;tb=Ib+48|0;sb=Ib+44|0;k[sb>>2]=tb;k[Ib+52>>2]=0;k[tb>>2]=0;nb=Gb+4|0;mb=nb+4|0;k[mb>>2]=0;k[mb+4>>2]=0;k[Gb>>2]=33619968;k[nb>>2]=Ib;mY(Lb,Gb);if((k[ob>>2]|0)>0){g=Gb+4|0;h=Hb+4|0;i=Gb+4|0;j=Hb+4|0;l=Hb+8|0;c=Hb+12|0;d=Hb+4|0;m=Gb+4|0;n=m+4|0;q=Ab+36|0;s=Ab+16|0;t=Ab+4|0;u=Ab+40|0;v=Ab+44|0;w=Ab+48|0;x=zb+36|0;y=zb+16|0;z=zb+4|0;A=zb+40|0;B=zb+44|0;C=zb+48|0;D=zb+32|0;E=Ab+32|0;f=0;do{b=f;f=f+1|0;k[Gb>>2]=b;k[g>>2]=f;k[Hb>>2]=-2147483648;k[h>>2]=2147483647;H1(zb,Jb,Gb,Hb);k[Gb>>2]=b;k[i>>2]=f;k[Hb>>2]=-2147483648;k[j>>2]=2147483647;H1(Ab,Jb,Gb,Hb);k[l>>2]=0;k[c>>2]=0;k[Hb>>2]=16842752;k[d>>2]=zb;g7(F,Hb);Ob=+p[F>>3]+1.1920928955078125e-07;b=n;k[b>>2]=0;k[b+4>>2]=0;k[Gb>>2]=33619968;k[m>>2]=Ab;SW(Ab,Gb,-1,1.0/Ob,0.0);b=k[q>>2]|0;if(b|0?(mb=b+12|0,nb=k[mb>>2]|0,k[mb>>2]=nb+-1,(nb|0)==1):0){e=k[q>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[E>>2]|0;if(!b){b=B1()|0;e=k[q>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[q>>2]=0}k[q>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[t>>2]|0)>0){e=k[u>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[v>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[x>>2]|0;if(b|0?(mb=b+12|0,nb=k[mb>>2]|0,k[mb>>2]=nb+-1,(nb|0)==1):0){e=k[x>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D>>2]|0;if(!b){b=B1()|0;e=k[x>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[x>>2]=0}k[x>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[z>>2]|0)>0){e=k[A>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[B>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((f|0)<(k[ob>>2]|0))}if((k[pb>>2]|0)>0){g=Gb+4|0;h=Hb+4|0;i=Gb+4|0;j=Hb+4|0;l=Hb+8|0;c=Hb+12|0;d=Hb+4|0;m=Gb+4|0;n=m+4|0;q=Ab+36|0;s=Ab+16|0;t=Ab+4|0;u=Ab+40|0;v=Ab+44|0;w=Ab+48|0;x=zb+36|0;y=zb+16|0;z=zb+4|0;A=zb+40|0;B=zb+44|0;C=zb+48|0;D=zb+32|0;E=Ab+32|0;f=0;do{b=f;f=f+1|0;k[Gb>>2]=b;k[g>>2]=f;k[Hb>>2]=-2147483648;k[h>>2]=2147483647;H1(zb,Ib,Gb,Hb);k[Gb>>2]=b;k[i>>2]=f;k[Hb>>2]=-2147483648;k[j>>2]=2147483647;H1(Ab,Ib,Gb,Hb);k[l>>2]=0;k[c>>2]=0;k[Hb>>2]=16842752;k[d>>2]=zb;g7(G,Hb);Ob=+p[G>>3]+1.1920928955078125e-07;b=n;k[b>>2]=0;k[b+4>>2]=0;k[Gb>>2]=33619968;k[m>>2]=Ab;SW(Ab,Gb,-1,1.0/Ob,0.0);b=k[q>>2]|0;if(b|0?(mb=b+12|0,nb=k[mb>>2]|0,k[mb>>2]=nb+-1,(nb|0)==1):0){e=k[q>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[E>>2]|0;if(!b){b=B1()|0;e=k[q>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[q>>2]=0}k[q>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[t>>2]|0)>0){e=k[u>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[v>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[x>>2]|0;if(b|0?(mb=b+12|0,nb=k[mb>>2]|0,k[mb>>2]=nb+-1,(nb|0)==1):0){e=k[x>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D>>2]|0;if(!b){b=B1()|0;e=k[x>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[x>>2]=0}k[x>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[z>>2]|0)>0){e=k[A>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[B>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((f|0)<(k[pb>>2]|0))}if((ub|0)>0){ia=Jb+12|0;ja=zb+4|0;ka=zb+8|0;la=zb+40|0;ma=zb+48|0;na=zb+44|0;oa=zb+52|0;pa=Gb+4|0;qa=Ib+12|0;ra=Ab+4|0;sa=Ab+8|0;ta=Ab+40|0;ua=Ab+48|0;va=Ab+44|0;wa=Ab+52|0;xa=Gb+4|0;ya=Hb+4|0;za=Gb+4|0;Aa=Hb+4|0;Ba=Db+36|0;Ca=Db+16|0;Da=Db+4|0;Ea=Db+40|0;Fa=Db+44|0;Ga=Db+48|0;Ha=Bb+36|0;Ia=Bb+16|0;Ja=Bb+4|0;Ka=Bb+40|0;La=Bb+44|0;Ma=Bb+48|0;Na=Gb+4|0;Oa=Hb+4|0;Pa=Gb+4|0;Qa=Hb+4|0;Ra=Fb+36|0;Sa=Fb+16|0;Ta=Fb+4|0;Ua=Fb+40|0;Va=Fb+44|0;Wa=Fb+48|0;Xa=Eb+36|0;Ya=Eb+16|0;Za=Eb+4|0;_a=Eb+40|0;$a=Eb+44|0;ab=Eb+48|0;bb=Gb+8|0;cb=Gb+12|0;db=Gb+4|0;eb=Hb+8|0;fb=Hb+12|0;gb=Hb+4|0;hb=a+4|0;ib=Kb+16|0;jb=Kb+44|0;kb=Ab+36|0;lb=Ab+16|0;mb=zb+36|0;nb=zb+16|0;c=a+12|0;d=Cb+4|0;m=Cb+8|0;n=Cb+12|0;q=Cb+16|0;s=Cb+48|0;t=Cb+56|0;u=Cb+52|0;v=Cb+60|0;w=Cb+64|0;x=Cb+68|0;y=Cb+72|0;z=Cb+104|0;A=Cb+112|0;B=Cb+108|0;C=Cb+116|0;D=Cb+120|0;E=Cb+124|0;F=Cb+128|0;G=Cb+160|0;a=Cb+168|0;H=Cb+164|0;I=Cb+4|0;J=Cb+8|0;K=Cb+12|0;L=Cb+16|0;M=Cb+48|0;N=Cb+56|0;O=Cb+52|0;P=Cb+60|0;Q=Cb+64|0;R=Cb+68|0;S=Cb+72|0;T=Cb+104|0;U=Cb+112|0;V=Cb+108|0;W=Cb+116|0;X=Cb+120|0;Y=Cb+124|0;Z=Cb+128|0;_=Cb+160|0;$=Cb+168|0;ba=Cb+164|0;ca=zb+32|0;da=Ab+32|0;ea=Eb+32|0;fa=Fb+32|0;ga=Bb+32|0;ha=Db+32|0;j=0;do{l=j;j=j+1|0;b=0;do if((l|0)<(k[ob>>2]|0)?(b|0)<(k[pb>>2]|0):0){e=k[ia>>2]|0;k[zb>>2]=1124007936;f=ja;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[la>>2]=ka;k[na>>2]=ma;k[oa>>2]=0;k[ma>>2]=0;k[Gb>>2]=e;k[pa>>2]=2;G1(zb,2,Gb,5);e=k[qa>>2]|0;k[Ab>>2]=1124007936;f=ra;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[ta>>2]=sa;k[va>>2]=ua;k[wa>>2]=0;k[ua>>2]=0;k[Gb>>2]=e;k[pa>>2]=2;G1(Ab,2,Gb,5);k[Gb>>2]=-2147483648;k[xa>>2]=2147483647;k[Hb>>2]=0;k[ya>>2]=1;H1(Bb,zb,Gb,Hb);k[Gb>>2]=l;k[za>>2]=j;k[Hb>>2]=-2147483648;k[Aa>>2]=2147483647;H1(Db,Jb,Gb,Hb);k[Cb>>2]=0;k[d>>2]=0;k[m>>2]=1124007936;f=n;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[s>>2]=q;k[u>>2]=t;k[v>>2]=0;k[t>>2]=0;k[w>>2]=1124007936;f=x;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[z>>2]=y;k[B>>2]=A;k[C>>2]=0;k[A>>2]=0;k[D>>2]=1124007936;f=E;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[G>>2]=F;k[H>>2]=a;f=a;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));y0(Cb,Db,1.0);e=k[Cb>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,Cb,Bb,-1);XN(Cb);e=k[Ba>>2]|0;if(e|0?(h=e+12|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0){f=k[Ba>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[ha>>2]|0;if(!e){e=B1()|0;f=k[Ba>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[Ba>>2]=0}k[Ba>>2]=0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[Da>>2]|0)>0){f=k[Ea>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Da>>2]|0))}e=k[Fa>>2]|0;if(!((e|0)==(Ga|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[Ha>>2]|0;if(e|0?(h=e+12|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0){f=k[Ha>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[ga>>2]|0;if(e|0)break;e=B1()|0;f=k[Ha>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[Ha>>2]=0}k[Ha>>2]=0;k[Ia>>2]=0;k[Ia+4>>2]=0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;if((k[Ja>>2]|0)>0){f=k[Ka>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Ja>>2]|0))}e=k[La>>2]|0;if(!((e|0)==(Ma|0)|(e|0)==0))ggb(k[e+-4>>2]|0);k[Gb>>2]=-2147483648;k[Na>>2]=2147483647;k[Hb>>2]=0;k[Oa>>2]=1;H1(Eb,Ab,Gb,Hb);i=b+1|0;k[Gb>>2]=b;k[Pa>>2]=i;k[Hb>>2]=-2147483648;k[Qa>>2]=2147483647;H1(Fb,Ib,Gb,Hb);k[Cb>>2]=0;k[I>>2]=0;k[J>>2]=1124007936;f=K;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[M>>2]=L;k[O>>2]=N;k[P>>2]=0;k[N>>2]=0;k[Q>>2]=1124007936;f=R;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[T>>2]=S;k[V>>2]=U;k[W>>2]=0;k[U>>2]=0;k[X>>2]=1124007936;f=Y;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[_>>2]=Z;k[ba>>2]=$;f=$;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));y0(Cb,Fb,1.0);e=k[Cb>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,Cb,Eb,-1);XN(Cb);e=k[Ra>>2]|0;if(e|0?(g=e+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){f=k[Ra>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[fa>>2]|0;if(e|0)break;e=B1()|0;f=k[Ra>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[Ra>>2]=0}k[Ra>>2]=0;k[Sa>>2]=0;k[Sa+4>>2]=0;k[Sa+8>>2]=0;k[Sa+12>>2]=0;if((k[Ta>>2]|0)>0){f=k[Ua>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Ta>>2]|0))}e=k[Va>>2]|0;if(!((e|0)==(Wa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[Xa>>2]|0;do if(e|0){g=e+12|0;h=k[g>>2]|0;k[g>>2]=h+-1;if((h|0)!=1)break;f=k[Xa>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[ea>>2]|0;if(e|0)break;e=B1()|0;f=k[Xa>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[Xa>>2]=0}while(0);k[Xa>>2]=0;k[Ya>>2]=0;k[Ya+4>>2]=0;k[Ya+8>>2]=0;k[Ya+12>>2]=0;if((k[Za>>2]|0)>0){f=k[_a>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Za>>2]|0))}e=k[$a>>2]|0;if(!((e|0)==(ab|0)|(e|0)==0))ggb(k[e+-4>>2]|0);f=k[ka>>2]|0;if((f|0)>0){g=k[nb>>2]|0;h=k[k[na>>2]>>2]|0;e=0;do{Pb=g+(aa(h,e)|0)+4|0;o[Pb>>2]=+(e|0);e=e+1|0}while((e|0)!=(f|0))}f=k[sa>>2]|0;if((f|0)>0){g=k[lb>>2]|0;h=k[k[va>>2]>>2]|0;e=0;do{Pb=g+(aa(h,e)|0)+4|0;o[Pb>>2]=+(e|0);e=e+1|0}while((e|0)!=(f|0))}k[bb>>2]=0;k[cb>>2]=0;k[Gb>>2]=16842752;k[db>>2]=zb;k[eb>>2]=0;k[fb>>2]=0;k[Hb>>2]=16842752;k[gb>>2]=Ab;Ob=+be(Gb|0,Hb|0,k[hb>>2]|0,49332,0,49332);b=(k[ib>>2]|0)+(aa(k[k[jb>>2]>>2]|0,l)|0)+(b<<2)|0;o[b>>2]=Ob;b=k[kb>>2]|0;do if(b|0){h=b+12|0;Pb=k[h>>2]|0;k[h>>2]=Pb+-1;if((Pb|0)!=1)break;e=k[kb>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[da>>2]|0;if(b|0)break;b=B1()|0;e=k[kb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[kb>>2]=0}while(0);k[kb>>2]=0;k[lb>>2]=0;k[lb+4>>2]=0;k[lb+8>>2]=0;k[lb+12>>2]=0;if((k[ra>>2]|0)>0){e=k[ta>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ra>>2]|0))}b=k[va>>2]|0;if(!((b|0)==(ua|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[mb>>2]|0;do if(b|0){h=b+12|0;Pb=k[h>>2]|0;k[h>>2]=Pb+-1;if((Pb|0)!=1)break;e=k[mb>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ca>>2]|0;if(b|0)break;b=B1()|0;e=k[mb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[mb>>2]=0}while(0);k[mb>>2]=0;k[nb>>2]=0;k[nb+4>>2]=0;k[nb+8>>2]=0;k[nb+12>>2]=0;if((k[ja>>2]|0)>0){e=k[la>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ja>>2]|0))}b=k[na>>2]|0;if(!((b|0)==(ma|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=i}else{Pb=(k[ib>>2]|0)+(aa(k[k[jb>>2]>>2]|0,l)|0)+(b<<2)|0;k[Pb>>2]=k[c>>2];b=b+1|0}while((b|0)<(ub|0))}while((j|0)<(ub|0))}f=Ib+36|0;b=k[f>>2]|0;if(b|0?(Hb=b+12|0,Pb=k[Hb>>2]|0,k[Hb>>2]=Pb+-1,(Pb|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Ib+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Pb=Ib+16|0;k[Pb>>2]=0;k[Pb+4>>2]=0;k[Pb+8>>2]=0;k[Pb+12>>2]=0;if((k[rb>>2]|0)>0){e=k[qb>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[rb>>2]|0))}b=k[sb>>2]|0;if(!((b|0)==(tb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Jb+36|0;b=k[f>>2]|0;if(b|0?(Ib=b+12|0,Pb=k[Ib>>2]|0,k[Ib>>2]=Pb+-1,(Pb|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Jb+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Pb=Jb+16|0;k[Pb>>2]=0;k[Pb+4>>2]=0;k[Pb+8>>2]=0;k[Pb+12>>2]=0;if((k[wb>>2]|0)>0){e=k[vb>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[wb>>2]|0))}b=k[xb>>2]|0;if(!((b|0)==(yb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Kb+36|0;b=k[f>>2]|0;if(b|0?(Jb=b+12|0,Pb=k[Jb>>2]|0,k[Jb>>2]=Pb+-1,(Pb|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Kb+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Pb=Kb+16|0;e=Kb+4|0;k[Pb>>2]=0;k[Pb+4>>2]=0;k[Pb+8>>2]=0;k[Pb+12>>2]=0;if((k[e>>2]|0)>0){f=k[Kb+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Kb+44>>2]|0;if(!((b|0)==(Kb+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Lb+36|0;b=k[f>>2]|0;if(b|0?(Kb=b+12|0,Pb=k[Kb>>2]|0,k[Kb>>2]=Pb+-1,(Pb|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Lb+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Pb=Lb+16|0;e=Lb+4|0;k[Pb>>2]=0;k[Pb+4>>2]=0;k[Pb+8>>2]=0;k[Pb+12>>2]=0;if((k[e>>2]|0)>0){f=k[Lb+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Lb+44>>2]|0;if(!((b|0)==(Lb+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Mb+36|0;b=k[f>>2]|0;do if(b|0){Lb=b+12|0;Pb=k[Lb>>2]|0;k[Lb>>2]=Pb+-1;if((Pb|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Mb+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;Pb=Mb+16|0;e=Mb+4|0;k[Pb>>2]=0;k[Pb+4>>2]=0;k[Pb+8>>2]=0;k[Pb+12>>2]=0;if((k[e>>2]|0)>0){f=k[Mb+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Mb+44>>2]|0;if((b|0)==(Mb+48|0)|(b|0)==0){r=Nb;return}ggb(k[b+-4>>2]|0);r=Nb;return}function TZa(a,b){a=a|0;b=b|0;k[a+8>>2]=b;return}function UZa(a){a=a|0;return k[a+8>>2]|0}function VZa(a,b){a=a|0;b=+b;o[a+12>>2]=b;return}function WZa(a){a=a|0;return +(+o[a+12>>2])}function XZa(a,b){a=a|0;b=b|0;k[a+4>>2]=b;return}function YZa(a){a=a|0;return k[a+4>>2]|0}function ZZa(a){a=a|0;var b=0,c=0;k[a>>2]=149432;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b)return;a=b+-4|0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)!=1)return;ggb(k[b+-8>>2]|0);return}function _Za(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=149432;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b){ggb(a);return}d=b+-4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function $Za(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;d=e;f=d+4|0;g=ZT(12)|0;k[g>>2]=1;c=g+4|0;k[d>>2]=c;k[f>>2]=4;i[g+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,d)|0;c=k[d>>2]|0;k[f>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+4|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=7;i[f+11>>0]=0;i[c>>0]=i[391411]|0;i[c+1>>0]=i[391412]|0;i[c+2>>0]=i[391413]|0;i[c+3>>0]=i[391414]|0;i[c+4>>0]=i[391415]|0;i[c+5>>0]=i[391416]|0;i[c+6>>0]=i[391417]|0;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=MZa(b,a+12|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=7;i[f+11>>0]=0;i[c>>0]=i[391419]|0;i[c+1>>0]=i[391420]|0;i[c+2>>0]=i[391421]|0;i[c+3>>0]=i[391422]|0;i[c+4>>0]=i[391423]|0;i[c+5>>0]=i[391424]|0;i[c+6>>0]=i[391425]|0;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(!c){g=a+16|0;NZa(b,g);r=e;return}f=c+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){g=a+16|0;NZa(b,g);r=e;return}ggb(k[c+-8>>2]|0);g=a+16|0;NZa(b,g);r=e;return}function a_a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;l=n;m=b+4|0;h=k6(k[b>>2]|0,k[m>>2]|0,401026)|0;k[l>>2]=0;j=l+4|0;k[j>>2]=0;J6(h,l,l);h=k[l>>2]|0;c=k[a+4>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[l>>2]=0;if(h|0?(j=h+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[h+-8>>2]|0)}else{f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[l>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c){c=l+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[l>>2]=f;k[c>>2]=27;i[e+31>>0]=0;g=401031;h=f+27|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,l,401059,391337,360);k[c>>2]=0;k[l>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}}c=k6(k[b>>2]|0,k[m>>2]|0,391411)|0;a:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break a}case 2:break;default:{c=2147483647;break a}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+12>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,391419)|0;if(!c){d=0.0;a=a+16|0;o[a>>2]=d;r=n;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+16|0;o[a>>2]=d;r=n;return}case 2:{d=+p[c+8>>3];a=a+16|0;o[a>>2]=d;r=n;return}default:{d=1000000015047466219876688.0e6;a=a+16|0;o[a>>2]=d;r=n;return}}}function b_a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0.0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0.0,da=0.0,ea=0.0;ba=r;r=r+496|0;U=ba+472|0;V=ba+456|0;$=ba+400|0;_=ba+344|0;Z=ba+288|0;Y=ba+232|0;X=ba+176|0;P=ba+120|0;Q=ba+64|0;G=ba+32|0;R=ba;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[$>>2]=k[g>>2];l=$+4|0;b=g+4|0;k[l>>2]=k[b>>2];W=$+8|0;k[W>>2]=k[g+8>>2];k[$+12>>2]=k[g+12>>2];k[$+16>>2]=k[g+16>>2];k[$+20>>2]=k[g+20>>2];k[$+24>>2]=k[g+24>>2];k[$+28>>2]=k[g+28>>2];k[$+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[$+36>>2]=e;f=$+40|0;k[f>>2]=W;W=$+48|0;i=$+44|0;k[i>>2]=W;k[$+52>>2]=0;k[W>>2]=0;if(e|0){W=e+12|0;k[W>>2]=(k[W>>2]|0)+1}if((k[b>>2]|0)<3){T=k[g+44>>2]|0;W=k[i>>2]|0;k[W>>2]=k[T>>2];k[W+4>>2]=k[T+4>>2];break}k[l>>2]=0;x1($,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1($,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){i=k[c+4>>2]|0;k[_>>2]=k[i>>2];c=_+4|0;f=i+4|0;k[c>>2]=k[f>>2];b=_+8|0;k[b>>2]=k[i+8>>2];k[_+12>>2]=k[i+12>>2];k[_+16>>2]=k[i+16>>2];k[_+20>>2]=k[i+20>>2];k[_+24>>2]=k[i+24>>2];k[_+28>>2]=k[i+28>>2];k[_+32>>2]=k[i+32>>2];e=k[i+36>>2]|0;k[_+36>>2]=e;g=_+40|0;k[g>>2]=b;W=_+48|0;j=_+44|0;k[j>>2]=W;k[_+52>>2]=0;k[W>>2]=0;if(e|0){W=e+12|0;k[W>>2]=(k[W>>2]|0)+1}if((k[f>>2]|0)<3){T=k[i+44>>2]|0;W=k[j>>2]|0;k[W>>2]=k[T>>2];k[W+4>>2]=k[T+4>>2];break}k[c>>2]=0;x1(_,k[f>>2]|0,0,0,0);if((k[c>>2]|0)>0){l=k[i+40>>2]|0;h=k[g>>2]|0;g=k[i+44>>2]|0;f=k[j>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[c>>2]|0))}}else{Q1(_,c,-1);b=_+8|0}while(0);N=k[$+8>>2]|0;W=k[b>>2]|0;N=((N|0)<(W|0)?W:N)+(k[a+12>>2]|0)|0;c2(d,N,N,5,-1,0,0);do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[Z>>2]=k[g>>2];l=Z+4|0;b=g+4|0;k[l>>2]=k[b>>2];W=Z+8|0;k[W>>2]=k[g+8>>2];k[Z+12>>2]=k[g+12>>2];k[Z+16>>2]=k[g+16>>2];k[Z+20>>2]=k[g+20>>2];k[Z+24>>2]=k[g+24>>2];k[Z+28>>2]=k[g+28>>2];k[Z+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Z+36>>2]=e;f=Z+40|0;k[f>>2]=W;W=Z+48|0;i=Z+44|0;k[i>>2]=W;k[Z+52>>2]=0;k[W>>2]=0;if(e|0){W=e+12|0;k[W>>2]=(k[W>>2]|0)+1}if((k[b>>2]|0)<3){T=k[g+44>>2]|0;W=k[i>>2]|0;k[W>>2]=k[T>>2];k[W+4>>2]=k[T+4>>2];break}k[l>>2]=0;x1(Z,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(Z,d,-1);while(0);k[Y>>2]=1124007936;S=Y+4|0;H=Y+8|0;O=Y+40|0;b=S;e=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(e|0));k[O>>2]=H;W=Y+48|0;T=Y+44|0;k[T>>2]=W;k[Y+52>>2]=0;k[W>>2]=0;M=U+4|0;I=M+4|0;k[I>>2]=0;k[I+4>>2]=0;k[U>>2]=33619968;k[M>>2]=Y;mY($,U);k[X>>2]=1124007936;M=X+4|0;I=X+8|0;J=X+40|0;b=M;e=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(e|0));k[J>>2]=I;L=X+48|0;K=X+44|0;k[K>>2]=L;k[X+52>>2]=0;k[L>>2]=0;F=U+4|0;E=F+4|0;k[E>>2]=0;k[E+4>>2]=0;k[U>>2]=33619968;k[F>>2]=X;mY(_,U);if((k[H>>2]|0)>0){g=U+4|0;h=V+4|0;i=U+4|0;j=V+4|0;l=V+8|0;c=V+12|0;d=V+4|0;n=U+4|0;q=n+4|0;s=Q+36|0;t=Q+16|0;u=Q+4|0;v=Q+40|0;w=Q+44|0;x=Q+48|0;y=P+36|0;z=P+16|0;A=P+4|0;B=P+40|0;C=P+44|0;D=P+48|0;E=P+32|0;F=Q+32|0;f=0;do{b=f;f=f+1|0;k[U>>2]=b;k[g>>2]=f;k[V>>2]=-2147483648;k[h>>2]=2147483647;H1(P,Y,U,V);k[U>>2]=b;k[i>>2]=f;k[V>>2]=-2147483648;k[j>>2]=2147483647;H1(Q,Y,U,V);k[l>>2]=0;k[c>>2]=0;k[V>>2]=16842752;k[d>>2]=P;g7(G,V);m=+p[G>>3]+1.1920928955078125e-07;b=q;k[b>>2]=0;k[b+4>>2]=0;k[U>>2]=33619968;k[n>>2]=Q;SW(Q,U,-1,1.0/m,0.0);b=k[s>>2]|0;if(b|0?(b=b+12|0,e=k[b>>2]|0,k[b>>2]=e+-1,(e|0)==1):0){e=k[s>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[F>>2]|0;if(!b){b=B1()|0;e=k[s>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[s>>2]=0}k[s>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[u>>2]|0)>0){e=k[v>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[u>>2]|0))}b=k[w>>2]|0;if(!((b|0)==(x|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[y>>2]|0;if(b|0?(b=b+12|0,e=k[b>>2]|0,k[b>>2]=e+-1,(e|0)==1):0){e=k[y>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[E>>2]|0;if(!b){b=B1()|0;e=k[y>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[y>>2]=0}k[y>>2]=0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[A>>2]|0)>0){e=k[B>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[A>>2]|0))}b=k[C>>2]|0;if(!((b|0)==(D|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((f|0)<(k[H>>2]|0))}if((k[I>>2]|0)>0){g=U+4|0;h=V+4|0;i=U+4|0;j=V+4|0;l=V+8|0;c=V+12|0;d=V+4|0;n=U+4|0;q=n+4|0;s=Q+36|0;t=Q+16|0;u=Q+4|0;v=Q+40|0;w=Q+44|0;x=Q+48|0;y=P+36|0;z=P+16|0;A=P+4|0;B=P+40|0;C=P+44|0;D=P+48|0;E=P+32|0;F=Q+32|0;f=0;do{b=f;f=f+1|0;k[U>>2]=b;k[g>>2]=f;k[V>>2]=-2147483648;k[h>>2]=2147483647;H1(P,X,U,V);k[U>>2]=b;k[i>>2]=f;k[V>>2]=-2147483648;k[j>>2]=2147483647;H1(Q,X,U,V);k[l>>2]=0;k[c>>2]=0;k[V>>2]=16842752;k[d>>2]=P;g7(R,V);m=+p[R>>3]+1.1920928955078125e-07;b=q;k[b>>2]=0;k[b+4>>2]=0;k[U>>2]=33619968;k[n>>2]=Q;SW(Q,U,-1,1.0/m,0.0);b=k[s>>2]|0;if(b|0?(e=b+12|0,G=k[e>>2]|0,k[e>>2]=G+-1,(G|0)==1):0){e=k[s>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[F>>2]|0;if(!b){b=B1()|0;e=k[s>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[s>>2]=0}k[s>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[u>>2]|0)>0){e=k[v>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[u>>2]|0))}b=k[w>>2]|0;if(!((b|0)==(x|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[y>>2]|0;if(b|0?(e=b+12|0,G=k[e>>2]|0,k[e>>2]=G+-1,(G|0)==1):0){e=k[y>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[E>>2]|0;if(!b){b=B1()|0;e=k[y>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[y>>2]=0}k[y>>2]=0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[A>>2]|0)>0){e=k[B>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[A>>2]|0))}b=k[C>>2]|0;if(!((b|0)==(D|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((f|0)<(k[I>>2]|0))}if((N|0)>0){c=a+16|0;d=k[Z+16>>2]|0;n=k[Z+44>>2]|0;q=X+12|0;s=k[Y+16>>2]|0;t=k[T>>2]|0;u=k[X+16>>2]|0;v=k[K>>2]|0;j=k[H>>2]|0;i=0;do{l=(i|0)<(j|0);h=0;do{if(l&(h|0)<(k[I>>2]|0)){g=k[q>>2]|0;if((g|0)>0){e=s+(aa(k[t>>2]|0,i)|0)|0;f=u+(aa(k[v>>2]|0,h)|0)|0;b=0;m=0.0;do{da=+o[e+(b<<2)>>2];ca=+o[f+(b<<2)>>2];ea=da-ca;m=m+ea*ea/(da+ca+1.1920928955078125e-07);b=b+1|0}while((b|0)!=(g|0))}else m=0.0;V=d+(aa(k[n>>2]|0,i)|0)+(h<<2)|0;o[V>>2]=m*.5}else{V=d+(aa(k[n>>2]|0,i)|0)+(h<<2)|0;k[V>>2]=k[c>>2]}h=h+1|0}while((h|0)<(N|0));i=i+1|0}while((i|0)<(N|0))}f=X+36|0;b=k[f>>2]|0;if(b|0?(U=b+12|0,V=k[U>>2]|0,k[U>>2]=V+-1,(V|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[X+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;X=X+16|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[M>>2]|0)>0){e=k[J>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[M>>2]|0))}b=k[K>>2]|0;if(!((b|0)==(L|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Y+36|0;b=k[f>>2]|0;if(b|0?(V=b+12|0,X=k[V>>2]|0,k[V>>2]=X+-1,(X|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Y+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Y=Y+16|0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[S>>2]|0)>0){e=k[O>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[S>>2]|0))}b=k[T>>2]|0;if(!((b|0)==(W|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Z+36|0;b=k[f>>2]|0;if(b|0?(X=b+12|0,Y=k[X>>2]|0,k[X>>2]=Y+-1,(Y|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Z+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Y=Z+16|0;e=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[e>>2]|0)>0){f=k[Z+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Z+44>>2]|0;if(!((b|0)==(Z+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=_+36|0;b=k[f>>2]|0;if(b|0?(Y=b+12|0,Z=k[Y>>2]|0,k[Y>>2]=Z+-1,(Z|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[_+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Z=_+16|0;e=_+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[e>>2]|0)>0){f=k[_+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[_+44>>2]|0;if(!((b|0)==(_+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=$+36|0;b=k[f>>2]|0;do if(b|0){Z=b+12|0;_=k[Z>>2]|0;k[Z>>2]=_+-1;if((_|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[$+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;_=$+16|0;e=$+4|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[e>>2]|0)>0){f=k[$+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[$+44>>2]|0;if((b|0)==($+48|0)|(b|0)==0){r=ba;return}ggb(k[b+-4>>2]|0);r=ba;return}function c_a(a,b){a=a|0;b=b|0;k[a+12>>2]=b;return}function d_a(a){a=a|0;return k[a+12>>2]|0}function e_a(a,b){a=a|0;b=+b;o[a+16>>2]=b;return}function f_a(a){a=a|0;return +(+o[a+16>>2])}function g_a(a){a=a|0;var b=0,c=0;k[a>>2]=149492;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b)return;a=b+-4|0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)!=1)return;ggb(k[b+-8>>2]|0);return}function h_a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=149492;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b){ggb(a);return}d=b+-4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function i_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;d=e;f=d+4|0;g=ZT(12)|0;k[g>>2]=1;c=g+4|0;k[d>>2]=c;k[f>>2]=4;i[g+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,d)|0;c=k[d>>2]|0;k[f>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+4|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=7;i[f+11>>0]=0;i[c>>0]=i[391411]|0;i[c+1>>0]=i[391412]|0;i[c+2>>0]=i[391413]|0;i[c+3>>0]=i[391414]|0;i[c+4>>0]=i[391415]|0;i[c+5>>0]=i[391416]|0;i[c+6>>0]=i[391417]|0;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=MZa(b,a+12|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=7;i[f+11>>0]=0;i[c>>0]=i[391419]|0;i[c+1>>0]=i[391420]|0;i[c+2>>0]=i[391421]|0;i[c+3>>0]=i[391422]|0;i[c+4>>0]=i[391423]|0;i[c+5>>0]=i[391424]|0;i[c+6>>0]=i[391425]|0;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(!c){g=a+16|0;NZa(b,g);r=e;return}f=c+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){g=a+16|0;NZa(b,g);r=e;return}ggb(k[c+-8>>2]|0);g=a+16|0;NZa(b,g);r=e;return}function j_a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;l=n;m=b+4|0;h=k6(k[b>>2]|0,k[m>>2]|0,401026)|0;k[l>>2]=0;j=l+4|0;k[j>>2]=0;J6(h,l,l);h=k[l>>2]|0;c=k[a+4>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[l>>2]=0;if(h|0?(j=h+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[h+-8>>2]|0)}else{f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[l>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c){c=l+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[l>>2]=f;k[c>>2]=27;i[e+31>>0]=0;g=401031;h=f+27|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,l,401059,391337,476);k[c>>2]=0;k[l>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}}c=k6(k[b>>2]|0,k[m>>2]|0,391411)|0;a:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break a}case 2:break;default:{c=2147483647;break a}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+12>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,391419)|0;if(!c){d=0.0;a=a+16|0;o[a>>2]=d;r=n;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+16|0;o[a>>2]=d;r=n;return}case 2:{d=+p[c+8>>3];a=a+16|0;o[a>>2]=d;r=n;return}default:{d=1000000015047466219876688.0e6;a=a+16|0;o[a>>2]=d;r=n;return}}}function k_a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;nc=r;r=r+1040|0;fc=nc+976|0;gc=nc+920|0;hc=nc+64|0;mc=nc+640|0;lc=nc+584|0;kc=nc+528|0;jc=nc+472|0;ic=nc+416|0;_b=nc+360|0;F=nc+32|0;G=nc;$b=nc+304|0;ac=nc+864|0;bc=nc+808|0;cc=nc+752|0;dc=nc+696|0;ec=nc+288|0;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[mc>>2]=k[g>>2];l=mc+4|0;b=g+4|0;k[l>>2]=k[b>>2];Zb=mc+8|0;k[Zb>>2]=k[g+8>>2];k[mc+12>>2]=k[g+12>>2];k[mc+16>>2]=k[g+16>>2];k[mc+20>>2]=k[g+20>>2];k[mc+24>>2]=k[g+24>>2];k[mc+28>>2]=k[g+28>>2];k[mc+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[mc+36>>2]=e;f=mc+40|0;k[f>>2]=Zb;Zb=mc+48|0;i=mc+44|0;k[i>>2]=Zb;k[mc+52>>2]=0;k[Zb>>2]=0;if(e|0){Zb=e+12|0;k[Zb>>2]=(k[Zb>>2]|0)+1}if((k[b>>2]|0)<3){Yb=k[g+44>>2]|0;Zb=k[i>>2]|0;k[Zb>>2]=k[Yb>>2];k[Zb+4>>2]=k[Yb+4>>2];break}k[l>>2]=0;x1(mc,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(mc,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){i=k[c+4>>2]|0;k[lc>>2]=k[i>>2];c=lc+4|0;f=i+4|0;k[c>>2]=k[f>>2];b=lc+8|0;k[b>>2]=k[i+8>>2];k[lc+12>>2]=k[i+12>>2];k[lc+16>>2]=k[i+16>>2];k[lc+20>>2]=k[i+20>>2];k[lc+24>>2]=k[i+24>>2];k[lc+28>>2]=k[i+28>>2];k[lc+32>>2]=k[i+32>>2];e=k[i+36>>2]|0;k[lc+36>>2]=e;g=lc+40|0;k[g>>2]=b;Zb=lc+48|0;j=lc+44|0;k[j>>2]=Zb;k[lc+52>>2]=0;k[Zb>>2]=0;if(e|0){Zb=e+12|0;k[Zb>>2]=(k[Zb>>2]|0)+1}if((k[f>>2]|0)<3){Yb=k[i+44>>2]|0;Zb=k[j>>2]|0;k[Zb>>2]=k[Yb>>2];k[Zb+4>>2]=k[Yb+4>>2];break}k[c>>2]=0;x1(lc,k[f>>2]|0,0,0,0);if((k[c>>2]|0)>0){l=k[i+40>>2]|0;h=k[g>>2]|0;g=k[i+44>>2]|0;f=k[j>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[c>>2]|0))}}else{Q1(lc,c,-1);b=lc+8|0}while(0);Vb=k[mc+8>>2]|0;Zb=k[b>>2]|0;Vb=((Vb|0)<(Zb|0)?Zb:Vb)+(k[a+12>>2]|0)|0;c2(d,Vb,Vb,5,-1,0,0);do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[kc>>2]=k[g>>2];l=kc+4|0;b=g+4|0;k[l>>2]=k[b>>2];Zb=kc+8|0;k[Zb>>2]=k[g+8>>2];k[kc+12>>2]=k[g+12>>2];k[kc+16>>2]=k[g+16>>2];k[kc+20>>2]=k[g+20>>2];k[kc+24>>2]=k[g+24>>2];k[kc+28>>2]=k[g+28>>2];k[kc+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[kc+36>>2]=e;f=kc+40|0;k[f>>2]=Zb;Zb=kc+48|0;i=kc+44|0;k[i>>2]=Zb;k[kc+52>>2]=0;k[Zb>>2]=0;if(e|0){Zb=e+12|0;k[Zb>>2]=(k[Zb>>2]|0)+1}if((k[b>>2]|0)<3){Yb=k[g+44>>2]|0;Zb=k[i>>2]|0;k[Zb>>2]=k[Yb>>2];k[Zb+4>>2]=k[Yb+4>>2];break}k[l>>2]=0;x1(kc,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(kc,d,-1);while(0);k[jc>>2]=1124007936;Xb=jc+4|0;Pb=jc+8|0;Wb=jc+40|0;f=Xb;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Wb>>2]=Pb;Zb=jc+48|0;Yb=jc+44|0;k[Yb>>2]=Zb;k[jc+52>>2]=0;k[Zb>>2]=0;Sb=fc+4|0;Qb=Sb+4|0;k[Qb>>2]=0;k[Qb+4>>2]=0;k[fc>>2]=33619968;k[Sb>>2]=jc;mY(mc,fc);k[ic>>2]=1124007936;Sb=ic+4|0;Qb=ic+8|0;Rb=ic+40|0;f=Sb;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Rb>>2]=Qb;Ub=ic+48|0;Tb=ic+44|0;k[Tb>>2]=Ub;k[ic+52>>2]=0;k[Ub>>2]=0;Ob=fc+4|0;Nb=Ob+4|0;k[Nb>>2]=0;k[Nb+4>>2]=0;k[fc>>2]=33619968;k[Ob>>2]=ic;mY(lc,fc);if((k[Pb>>2]|0)>0){g=fc+4|0;h=gc+4|0;i=fc+4|0;j=gc+4|0;l=gc+8|0;c=gc+12|0;d=gc+4|0;m=fc+4|0;n=m+4|0;q=_b+36|0;s=_b+16|0;t=_b+4|0;u=_b+40|0;v=_b+44|0;w=_b+48|0;x=hc+36|0;y=hc+16|0;z=hc+4|0;A=hc+40|0;B=hc+44|0;C=hc+48|0;D=hc+32|0;E=_b+32|0;f=0;do{b=f;f=f+1|0;k[fc>>2]=b;k[g>>2]=f;k[gc>>2]=-2147483648;k[h>>2]=2147483647;H1(hc,jc,fc,gc);k[fc>>2]=b;k[i>>2]=f;k[gc>>2]=-2147483648;k[j>>2]=2147483647;H1(_b,jc,fc,gc);k[l>>2]=0;k[c>>2]=0;k[gc>>2]=16842752;k[d>>2]=hc;g7(F,gc);H=+p[F>>3]+1.1920928955078125e-07;b=n;k[b>>2]=0;k[b+4>>2]=0;k[fc>>2]=33619968;k[m>>2]=_b;SW(_b,fc,-1,1.0/H,0.0);b=k[q>>2]|0;if(b|0?(Nb=b+12|0,Ob=k[Nb>>2]|0,k[Nb>>2]=Ob+-1,(Ob|0)==1):0){e=k[q>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[E>>2]|0;if(!b){b=B1()|0;e=k[q>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[q>>2]=0}k[q>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[t>>2]|0)>0){e=k[u>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[v>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[x>>2]|0;if(b|0?(Nb=b+12|0,Ob=k[Nb>>2]|0,k[Nb>>2]=Ob+-1,(Ob|0)==1):0){e=k[x>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D>>2]|0;if(!b){b=B1()|0;e=k[x>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[x>>2]=0}k[x>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[z>>2]|0)>0){e=k[A>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[B>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((f|0)<(k[Pb>>2]|0))}if((k[Qb>>2]|0)>0){g=fc+4|0;h=gc+4|0;i=fc+4|0;j=gc+4|0;l=gc+8|0;c=gc+12|0;d=gc+4|0;m=fc+4|0;n=m+4|0;q=_b+36|0;s=_b+16|0;t=_b+4|0;u=_b+40|0;v=_b+44|0;w=_b+48|0;x=hc+36|0;y=hc+16|0;z=hc+4|0;A=hc+40|0;B=hc+44|0;C=hc+48|0;D=hc+32|0;E=_b+32|0;f=0;do{b=f;f=f+1|0;k[fc>>2]=b;k[g>>2]=f;k[gc>>2]=-2147483648;k[h>>2]=2147483647;H1(hc,ic,fc,gc);k[fc>>2]=b;k[i>>2]=f;k[gc>>2]=-2147483648;k[j>>2]=2147483647;H1(_b,ic,fc,gc);k[l>>2]=0;k[c>>2]=0;k[gc>>2]=16842752;k[d>>2]=hc;g7(G,gc);H=+p[G>>3]+1.1920928955078125e-07;b=n;k[b>>2]=0;k[b+4>>2]=0;k[fc>>2]=33619968;k[m>>2]=_b;SW(_b,fc,-1,1.0/H,0.0);b=k[q>>2]|0;if(b|0?(Nb=b+12|0,Ob=k[Nb>>2]|0,k[Nb>>2]=Ob+-1,(Ob|0)==1):0){e=k[q>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[E>>2]|0;if(!b){b=B1()|0;e=k[q>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[q>>2]=0}k[q>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[t>>2]|0)>0){e=k[u>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[v>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[x>>2]|0;if(b|0?(Nb=b+12|0,Ob=k[Nb>>2]|0,k[Nb>>2]=Ob+-1,(Ob|0)==1):0){e=k[x>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D>>2]|0;if(!b){b=B1()|0;e=k[x>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[x>>2]=0}k[x>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[z>>2]|0)>0){e=k[A>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[B>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}while((f|0)<(k[Qb>>2]|0))}if((Vb|0)>0){Na=jc+12|0;Oa=_b+4|0;Pa=_b+8|0;Qa=_b+40|0;Ra=_b+48|0;Sa=_b+44|0;Ta=_b+52|0;Ua=fc+4|0;Va=ic+12|0;Wa=$b+4|0;Xa=$b+8|0;Ya=$b+40|0;Za=$b+48|0;_a=$b+44|0;$a=$b+52|0;ab=fc+4|0;bb=gc+4|0;cb=fc+4|0;db=gc+4|0;eb=bc+36|0;fb=bc+16|0;gb=bc+4|0;hb=bc+40|0;ib=bc+44|0;jb=bc+48|0;kb=ac+36|0;lb=ac+16|0;mb=ac+4|0;nb=ac+40|0;ob=ac+44|0;pb=ac+48|0;qb=fc+4|0;rb=gc+4|0;sb=fc+4|0;tb=gc+4|0;ub=dc+36|0;vb=dc+16|0;wb=dc+4|0;xb=dc+40|0;yb=dc+44|0;zb=dc+48|0;Ab=cc+36|0;Bb=cc+16|0;Cb=cc+4|0;Db=cc+40|0;Eb=cc+44|0;Fb=cc+48|0;Gb=ec+8|0;Hb=ec+12|0;Ib=ec+4|0;Jb=kc+16|0;Kb=kc+44|0;Lb=$b+36|0;Mb=$b+16|0;Nb=_b+36|0;Ob=_b+16|0;d=a+16|0;m=hc+4|0;n=hc+8|0;q=hc+12|0;s=hc+16|0;t=hc+48|0;u=hc+56|0;v=hc+52|0;w=hc+60|0;x=hc+64|0;y=hc+68|0;z=hc+72|0;A=hc+104|0;B=hc+112|0;C=hc+108|0;D=hc+116|0;E=hc+120|0;F=hc+124|0;G=hc+128|0;a=hc+160|0;I=hc+168|0;J=hc+164|0;K=hc+4|0;L=hc+8|0;M=hc+12|0;N=hc+16|0;O=hc+48|0;P=hc+56|0;Q=hc+52|0;R=hc+60|0;S=hc+64|0;T=hc+68|0;U=hc+72|0;V=hc+104|0;W=hc+112|0;X=hc+108|0;Y=hc+116|0;Z=hc+120|0;_=hc+124|0;$=hc+128|0;ba=hc+160|0;ca=hc+168|0;da=hc+164|0;ea=fc+4|0;fa=fc+8|0;ga=fc+12|0;ha=fc+16|0;ia=fc+20|0;ja=fc+24|0;ka=fc+28|0;la=fc+32|0;ma=fc+36|0;na=fc+40|0;oa=fc+48|0;pa=fc+44|0;qa=fc+52|0;ra=gc+4|0;sa=gc+8|0;ta=gc+12|0;ua=gc+16|0;va=gc+20|0;wa=gc+24|0;xa=gc+28|0;ya=gc+32|0;za=gc+36|0;Aa=gc+40|0;Ba=gc+48|0;Ca=gc+44|0;Da=gc+52|0;Ea=hc+24|0;Fa=hc+152|0;Ga=hc+20|0;Ha=_b+32|0;Ia=$b+32|0;Ja=cc+32|0;Ka=dc+32|0;La=ac+32|0;Ma=bc+32|0;l=0;do{c=l;l=l+1|0;b=0;do if((c|0)<(k[Pb>>2]|0)?(b|0)<(k[Qb>>2]|0):0){e=k[Na>>2]|0;k[_b>>2]=1124007936;f=Oa;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Qa>>2]=Pa;k[Sa>>2]=Ra;k[Ta>>2]=0;k[Ra>>2]=0;k[fc>>2]=e;k[Ua>>2]=1;G1(_b,2,fc,5);e=k[Va>>2]|0;k[$b>>2]=1124007936;f=Wa;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Ya>>2]=Xa;k[_a>>2]=Za;k[$a>>2]=0;k[Za>>2]=0;k[fc>>2]=e;k[Ua>>2]=1;G1($b,2,fc,5);k[fc>>2]=-2147483648;k[ab>>2]=2147483647;k[gc>>2]=0;k[bb>>2]=1;H1(ac,_b,fc,gc);k[fc>>2]=c;k[cb>>2]=l;k[gc>>2]=-2147483648;k[db>>2]=2147483647;H1(bc,jc,fc,gc);k[hc>>2]=0;k[m>>2]=0;k[n>>2]=1124007936;f=q;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[t>>2]=s;k[v>>2]=u;k[w>>2]=0;k[u>>2]=0;k[x>>2]=1124007936;f=y;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[A>>2]=z;k[C>>2]=B;k[D>>2]=0;k[B>>2]=0;k[E>>2]=1124007936;f=F;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[a>>2]=G;k[J>>2]=I;f=I;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));y0(hc,bc,1.0);e=k[hc>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,hc,ac,-1);XN(hc);e=k[eb>>2]|0;if(e|0?(i=e+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){f=k[eb>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[Ma>>2]|0;if(!e){e=B1()|0;f=k[eb>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[eb>>2]=0}k[eb>>2]=0;k[fb>>2]=0;k[fb+4>>2]=0;k[fb+8>>2]=0;k[fb+12>>2]=0;if((k[gb>>2]|0)>0){f=k[hb>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[gb>>2]|0))}e=k[ib>>2]|0;if(!((e|0)==(jb|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[kb>>2]|0;if(e|0?(i=e+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){f=k[kb>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[La>>2]|0;if(e|0)break;e=B1()|0;f=k[kb>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[kb>>2]=0}k[kb>>2]=0;k[lb>>2]=0;k[lb+4>>2]=0;k[lb+8>>2]=0;k[lb+12>>2]=0;if((k[mb>>2]|0)>0){f=k[nb>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[mb>>2]|0))}e=k[ob>>2]|0;if(!((e|0)==(pb|0)|(e|0)==0))ggb(k[e+-4>>2]|0);k[fc>>2]=-2147483648;k[qb>>2]=2147483647;k[gc>>2]=0;k[rb>>2]=1;H1(cc,$b,fc,gc);j=b+1|0;k[fc>>2]=b;k[sb>>2]=j;k[gc>>2]=-2147483648;k[tb>>2]=2147483647;H1(dc,ic,fc,gc);k[hc>>2]=0;k[K>>2]=0;k[L>>2]=1124007936;f=M;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[O>>2]=N;k[Q>>2]=P;k[R>>2]=0;k[P>>2]=0;k[S>>2]=1124007936;f=T;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[V>>2]=U;k[X>>2]=W;k[Y>>2]=0;k[W>>2]=0;k[Z>>2]=1124007936;f=_;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[ba>>2]=$;k[da>>2]=ca;f=ca;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));y0(hc,dc,1.0);e=k[hc>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,hc,cc,-1);XN(hc);e=k[ub>>2]|0;if(e|0?(h=e+12|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0){f=k[ub>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[Ka>>2]|0;if(e|0)break;e=B1()|0;f=k[ub>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ub>>2]=0}k[ub>>2]=0;k[vb>>2]=0;k[vb+4>>2]=0;k[vb+8>>2]=0;k[vb+12>>2]=0;if((k[wb>>2]|0)>0){f=k[xb>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[wb>>2]|0))}e=k[yb>>2]|0;if(!((e|0)==(zb|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[Ab>>2]|0;do if(e|0){h=e+12|0;i=k[h>>2]|0;k[h>>2]=i+-1;if((i|0)!=1)break;f=k[Ab>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[Ja>>2]|0;if(e|0)break;e=B1()|0;f=k[Ab>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[Ab>>2]=0}while(0);k[Ab>>2]=0;k[Bb>>2]=0;k[Bb+4>>2]=0;k[Bb+8>>2]=0;k[Bb+12>>2]=0;if((k[Cb>>2]|0)>0){f=k[Db>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Cb>>2]|0))}e=k[Eb>>2]|0;if(!((e|0)==(Fb|0)|(e|0)==0))ggb(k[e+-4>>2]|0);k[Gb>>2]=0;k[Hb>>2]=0;k[ec>>2]=16842752;k[Ib>>2]=$b;k[fc>>2]=k[_b>>2];e=k[Oa>>2]|0;k[ea>>2]=e;k[fa>>2]=k[Pa>>2];k[ga>>2]=k[_b+12>>2];k[ha>>2]=k[Ob>>2];k[ia>>2]=k[_b+20>>2];k[ja>>2]=k[_b+24>>2];k[ka>>2]=k[_b+28>>2];k[la>>2]=k[Ha>>2];f=k[Nb>>2]|0;k[ma>>2]=f;k[na>>2]=fa;k[pa>>2]=oa;k[qa>>2]=0;k[oa>>2]=0;if(f){e=f+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[Oa>>2]|0}do if((e|0)<3){h=k[Sa>>2]|0;i=k[pa>>2]|0;k[i>>2]=k[h>>2];k[i+4>>2]=k[h+4>>2]}else{k[ea>>2]=0;x1(fc,e,0,0,0);if((k[ea>>2]|0)<=0)break;f=k[Qa>>2]|0;g=k[na>>2]|0;h=k[Sa>>2]|0;i=k[pa>>2]|0;e=0;do{k[g+(e<<2)>>2]=k[f+(e<<2)>>2];k[i+(e<<2)>>2]=k[h+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ea>>2]|0))}while(0);do if((k[ec>>2]&2031616|0)==65536){g=k[Ib>>2]|0;k[gc>>2]=k[g>>2];e=g+4|0;k[ra>>2]=k[e>>2];k[sa>>2]=k[g+8>>2];k[ta>>2]=k[g+12>>2];k[ua>>2]=k[g+16>>2];k[va>>2]=k[g+20>>2];k[wa>>2]=k[g+24>>2];k[xa>>2]=k[g+28>>2];k[ya>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[za>>2]=f;k[Aa>>2]=sa;k[Ca>>2]=Ba;k[Da>>2]=0;k[Ba>>2]=0;if(f|0){i=f+12|0;k[i>>2]=(k[i>>2]|0)+1}if((k[e>>2]|0)<3){h=k[g+44>>2]|0;i=k[Ca>>2]|0;k[i>>2]=k[h>>2];k[i+4>>2]=k[h+4>>2];break}k[ra>>2]=0;x1(gc,k[e>>2]|0,0,0,0);if((k[ra>>2]|0)<=0)break;h=k[g+40>>2]|0;i=k[Aa>>2]|0;f=k[g+44>>2]|0;g=k[Ca>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ra>>2]|0))}else Q1(gc,ec,-1);while(0);k[hc>>2]=0;k[hc+4>>2]=0;k[hc+8>>2]=0;k[hc+12>>2]=0;f=Ea;g=f+112|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Fa>>2]=0;k[Fa+4>>2]=0;k[Fa+8>>2]=0;k[Fa+12>>2]=0;k[Fa+16>>2]=0;k[Fa+20>>2]=0;k[Ga>>2]=500;H=+s$a(hc,fc,gc);B$a(hc);e=k[za>>2]|0;do if(e|0){h=e+12|0;i=k[h>>2]|0;k[h>>2]=i+-1;if((i|0)!=1)break;f=k[za>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[ya>>2]|0;if(e|0)break;e=B1()|0;f=k[za>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[za>>2]=0}while(0);k[za>>2]=0;k[ua>>2]=0;k[ua+4>>2]=0;k[ua+8>>2]=0;k[ua+12>>2]=0;if((k[ra>>2]|0)>0){f=k[Aa>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ra>>2]|0))}e=k[Ca>>2]|0;if(!((e|0)==(Ba|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[ma>>2]|0;do if(e|0){h=e+12|0;i=k[h>>2]|0;k[h>>2]=i+-1;if((i|0)!=1)break;f=k[ma>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[la>>2]|0;if(e|0)break;e=B1()|0;f=k[ma>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ma>>2]=0}while(0);k[ma>>2]=0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[ea>>2]|0)>0){f=k[na>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ea>>2]|0))}e=k[pa>>2]|0;if(!((e|0)==(oa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);b=(k[Jb>>2]|0)+(aa(k[k[Kb>>2]>>2]|0,c)|0)+(b<<2)|0;o[b>>2]=H;b=k[Lb>>2]|0;do if(b|0){h=b+12|0;i=k[h>>2]|0;k[h>>2]=i+-1;if((i|0)!=1)break;e=k[Lb>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Ia>>2]|0;if(b|0)break;b=B1()|0;e=k[Lb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[Lb>>2]=0}while(0);k[Lb>>2]=0;k[Mb>>2]=0;k[Mb+4>>2]=0;k[Mb+8>>2]=0;k[Mb+12>>2]=0;if((k[Wa>>2]|0)>0){e=k[Ya>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Wa>>2]|0))}b=k[_a>>2]|0;if(!((b|0)==(Za|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Nb>>2]|0;do if(b|0){h=b+12|0;i=k[h>>2]|0;k[h>>2]=i+-1;if((i|0)!=1)break;e=k[Nb>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Ha>>2]|0;if(b|0)break;b=B1()|0;e=k[Nb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[Nb>>2]=0}while(0);k[Nb>>2]=0;k[Ob>>2]=0;k[Ob+4>>2]=0;k[Ob+8>>2]=0;k[Ob+12>>2]=0;if((k[Oa>>2]|0)>0){e=k[Qa>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Oa>>2]|0))}b=k[Sa>>2]|0;if(!((b|0)==(Ra|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=j}else{j=(k[Jb>>2]|0)+(aa(k[k[Kb>>2]>>2]|0,c)|0)+(b<<2)|0;k[j>>2]=k[d>>2];b=b+1|0}while((b|0)<(Vb|0))}while((l|0)<(Vb|0))}f=ic+36|0;b=k[f>>2]|0;if(b|0?(gc=b+12|0,hc=k[gc>>2]|0,k[gc>>2]=hc+-1,(hc|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[ic+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;ic=ic+16|0;k[ic>>2]=0;k[ic+4>>2]=0;k[ic+8>>2]=0;k[ic+12>>2]=0;if((k[Sb>>2]|0)>0){e=k[Rb>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Sb>>2]|0))}b=k[Tb>>2]|0;if(!((b|0)==(Ub|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=jc+36|0;b=k[f>>2]|0;if(b|0?(hc=b+12|0,ic=k[hc>>2]|0,k[hc>>2]=ic+-1,(ic|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[jc+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;jc=jc+16|0;k[jc>>2]=0;k[jc+4>>2]=0;k[jc+8>>2]=0;k[jc+12>>2]=0;if((k[Xb>>2]|0)>0){e=k[Wb>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Xb>>2]|0))}b=k[Yb>>2]|0;if(!((b|0)==(Zb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=kc+36|0;b=k[f>>2]|0;if(b|0?(ic=b+12|0,jc=k[ic>>2]|0,k[ic>>2]=jc+-1,(jc|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[kc+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;jc=kc+16|0;e=kc+4|0;k[jc>>2]=0;k[jc+4>>2]=0;k[jc+8>>2]=0;k[jc+12>>2]=0;if((k[e>>2]|0)>0){f=k[kc+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[kc+44>>2]|0;if(!((b|0)==(kc+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=lc+36|0;b=k[f>>2]|0;if(b|0?(jc=b+12|0,kc=k[jc>>2]|0,k[jc>>2]=kc+-1,(kc|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[lc+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;kc=lc+16|0;e=lc+4|0;k[kc>>2]=0;k[kc+4>>2]=0;k[kc+8>>2]=0;k[kc+12>>2]=0;if((k[e>>2]|0)>0){f=k[lc+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[lc+44>>2]|0;if(!((b|0)==(lc+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=mc+36|0;b=k[f>>2]|0;do if(b|0){kc=b+12|0;lc=k[kc>>2]|0;k[kc>>2]=lc+-1;if((lc|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[mc+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;lc=mc+16|0;e=mc+4|0;k[lc>>2]=0;k[lc+4>>2]=0;k[lc+8>>2]=0;k[lc+12>>2]=0;if((k[e>>2]|0)>0){f=k[mc+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[mc+44>>2]|0;if((b|0)==(mc+48|0)|(b|0)==0){r=nc;return}ggb(k[b+-4>>2]|0);r=nc;return}function l_a(a,b){a=a|0;b=b|0;k[a+12>>2]=b;return}function m_a(a){a=a|0;return k[a+12>>2]|0}function n_a(a,b){a=a|0;b=+b;o[a+16>>2]=b;return}function o_a(a){a=a|0;return +(+o[a+16>>2])}function p_a(a){a=a|0;ggb(a);return}function q_a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function r_a(a){a=a|0;ggb(a);return}function s_a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function t_a(a){a=a|0;ggb(a);return}function u_a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function v_a(a){a=a|0;ggb(a);return}function w_a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function x_a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=149632;d=a+176|0;b=k[d>>2]|0;k[a+180>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+140|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+136>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+120|0;c=a+108|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+144>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+148>>2]|0;if(!((b|0)==(a+152|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+84|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+80>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+64|0;c=a+52|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+88>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+92>>2]|0;if(!((b|0)==(a+96|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=a+40|0;c=k[b>>2]|0;if(c|0?(e=c+4|0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+44>>2]=0;b=a+32|0;c=k[b>>2]|0;if(!c){k[b>>2]=0;e=a+36|0;k[e>>2]=0;return}d=c+4|0;e=k[d>>2]|0;k[d>>2]=e+-1;if((e|0)!=1){k[b>>2]=0;e=a+36|0;k[e>>2]=0;return}Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;e=a+36|0;k[e>>2]=0;return}function y_a(a){a=a|0;x_a(a);ggb(a);return}function z_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0;n=r;r=r+16|0;m=n;j=m+4|0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[m>>2]=c;k[j>>2]=4;i[h+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,m)|0;c=k[m>>2]|0;k[j>>2]=0;k[m>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+176|0)|0;k[m>>2]=0;j=m+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[m>>2]=c;k[j>>2]=5;i[h+9>>0]=0;i[c>>0]=i[392428]|0;i[c+1>>0]=i[392429]|0;i[c+2>>0]=i[392430]|0;i[c+3>>0]=i[392431]|0;i[c+4>>0]=i[392432]|0;b=z6(b,m)|0;c=k[m>>2]|0;k[j>>2]=0;k[m>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=b$a(b,a+8|0)|0;k[m>>2]=0;j=m+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[m>>2]=c;k[j>>2]=5;i[h+9>>0]=0;i[c>>0]=i[392434]|0;i[c+1>>0]=i[392435]|0;i[c+2>>0]=i[392436]|0;i[c+3>>0]=i[392437]|0;i[c+4>>0]=i[392438]|0;b=z6(b,m)|0;c=k[m>>2]|0;k[j>>2]=0;k[m>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=b$a(b,a+4|0)|0;k[m>>2]=0;j=m+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[m>>2]=c;k[j>>2]=5;i[h+9>>0]=0;i[c>>0]=i[392440]|0;i[c+1>>0]=i[392441]|0;i[c+2>>0]=i[392442]|0;i[c+3>>0]=i[392443]|0;i[c+4>>0]=i[392444]|0;b=z6(b,m)|0;c=k[m>>2]|0;k[j>>2]=0;k[m>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=b$a(b,a+28|0)|0;k[m>>2]=0;j=m+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[m>>2]=c;k[j>>2]=5;i[h+9>>0]=0;i[c>>0]=i[392476]|0;i[c+1>>0]=i[392477]|0;i[c+2>>0]=i[392478]|0;i[c+3>>0]=i[392479]|0;i[c+4>>0]=i[392480]|0;b=z6(b,m)|0;c=k[m>>2]|0;k[j>>2]=0;k[m>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=c$a(b,a+48|0)|0;k[m>>2]=0;j=m+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[m>>2]=c;k[j>>2]=5;i[h+9>>0]=0;i[c>>0]=i[392482]|0;i[c+1>>0]=i[392483]|0;i[c+2>>0]=i[392484]|0;i[c+3>>0]=i[392485]|0;i[c+4>>0]=i[392486]|0;b=z6(b,m)|0;c=k[m>>2]|0;k[j>>2]=0;k[m>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=c$a(b,a+104|0)|0;k[m>>2]=0;j=m+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[m>>2]=c;k[j>>2]=5;i[h+9>>0]=0;i[c>>0]=i[392446]|0;i[c+1>>0]=i[392447]|0;i[c+2>>0]=i[392448]|0;i[c+3>>0]=i[392449]|0;i[c+4>>0]=i[392450]|0;b=z6(b,m)|0;c=k[m>>2]|0;k[j>>2]=0;k[m>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=d$a(b,a+160|0)|0;k[m>>2]=0;j=m+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[m>>2]=c;k[j>>2]=5;i[h+9>>0]=0;i[c>>0]=i[392452]|0;i[c+1>>0]=i[392453]|0;i[c+2>>0]=i[392454]|0;i[c+3>>0]=i[392455]|0;i[c+4>>0]=i[392456]|0;b=z6(b,m)|0;c=k[m>>2]|0;k[j>>2]=0;k[m>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=d$a(b,a+168|0)|0;k[m>>2]=0;j=m+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[m>>2]=c;k[j>>2]=5;i[h+9>>0]=0;i[c>>0]=i[392458]|0;i[c+1>>0]=i[392459]|0;i[c+2>>0]=i[392460]|0;i[c+3>>0]=i[392461]|0;i[c+4>>0]=i[392462]|0;b=z6(b,m)|0;c=k[m>>2]|0;k[j>>2]=0;k[m>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);b=d$a(b,a+164|0)|0;k[m>>2]=0;j=m+4|0;k[j>>2]=0;h=ZT(12)|0;k[h>>2]=1;c=h+4|0;k[m>>2]=c;k[j>>2]=5;i[h+9>>0]=0;i[c>>0]=i[392464]|0;i[c+1>>0]=i[392465]|0;i[c+2>>0]=i[392466]|0;i[c+3>>0]=i[392467]|0;i[c+4>>0]=i[392468]|0;b=z6(b,m)|0;c=k[m>>2]|0;k[j>>2]=0;k[m>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);j=b$a(b,a+24|0)|0;h=m+4|0;g=ZT(12)|0;k[g>>2]=1;b=g+4|0;k[m>>2]=b;k[h>>2]=5;i[g+9>>0]=0;i[b>>0]=i[392488]|0;i[b+1>>0]=i[392489]|0;i[b+2>>0]=i[392490]|0;i[b+3>>0]=i[392491]|0;i[b+4>>0]=i[392492]|0;j=z6(j,m)|0;b=k[m>>2]|0;k[h>>2]=0;k[m>>2]=0;if(b|0?(g=b+-4|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[b+-8>>2]|0);g=a+20|0;if(Xh[k[(k[j>>2]|0)+12>>2]&1023](j)|0){h=j+32|0;if((k[h>>2]|0)==6){b=m+4|0;c=ZT(36)|0;k[c>>2]=1;d=c+4|0;k[m>>2]=d;k[b>>2]=30;i[c+34>>0]=0;e=401220;f=d+30|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-2,m,401251,401262,1064);k[b>>2]=0;k[m>>2]=0;f=k[c>>2]|0;k[c>>2]=f+-1;if((f|0)==1)ggb(k[c+-4>>2]|0)}if(!(k[j+16>>2]|0))b=0;else{b=k[j+12>>2]|0;b=(b|0)==0?1016759:b}p6(k[j+8>>2]|0,b,l[g>>0]|0);if(k[h>>2]&4|0)k[h>>2]=6}h=m+4|0;c=ZT(12)|0;k[c>>2]=1;b=c+4|0;k[m>>2]=b;k[h>>2]=5;i[c+9>>0]=0;i[b>>0]=i[392470]|0;i[b+1>>0]=i[392471]|0;i[b+2>>0]=i[392472]|0;i[b+3>>0]=i[392473]|0;i[b+4>>0]=i[392474]|0;b=z6(j,m)|0;c=k[m>>2]|0;k[h>>2]=0;k[m>>2]=0;if(!c){m=a+172|0;d$a(b,m)|0;r=n;return}j=c+-4|0;m=k[j>>2]|0;k[j>>2]=m+-1;if((m|0)!=1){m=a+172|0;d$a(b,m)|0;r=n;return}ggb(k[c+-8>>2]|0);m=a+172|0;d$a(b,m)|0;r=n;return}function A_a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;l=n;m=b+4|0;h=k6(k[b>>2]|0,k[m>>2]|0,401026)|0;k[l>>2]=0;j=l+4|0;k[j>>2]=0;J6(h,l,l);h=k[l>>2]|0;c=k[a+176>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[l>>2]=0;if(h|0?(j=h+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[h+-8>>2]|0)}else{f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[l>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c){c=l+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[l>>2]=f;k[c>>2]=27;i[e+31>>0]=0;g=401031;h=f+27|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,l,401059,392046,158);k[c>>2]=0;k[l>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}}c=k6(k[b>>2]|0,k[m>>2]|0,392428)|0;a:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break a}case 2:break;default:{c=2147483647;break a}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+8>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,392434)|0;b:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break b}case 2:break;default:{c=2147483647;break b}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+4>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,392440)|0;c:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break c}case 2:break;default:{c=2147483647;break c}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+28>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,392446)|0;d:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break d}case 2:{d=+p[c+8>>3];break d}default:{d=1000000015047466219876688.0e6;break d}}while(0);o[a+160>>2]=d;c=k6(k[b>>2]|0,k[m>>2]|0,392452)|0;e:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break e}case 2:{d=+p[c+8>>3];break e}default:{d=1000000015047466219876688.0e6;break e}}while(0);o[a+168>>2]=d;c=k6(k[b>>2]|0,k[m>>2]|0,392458)|0;f:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break f}case 2:{d=+p[c+8>>3];break f}default:{d=1000000015047466219876688.0e6;break f}}while(0);o[a+164>>2]=d;c=k6(k[b>>2]|0,k[m>>2]|0,392464)|0;g:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break g}case 2:break;default:{c=2147483647;break g}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+24>>2]=c;c=k6(k[b>>2]|0,k[m>>2]|0,392470)|0;if(!c){d=0.0;a=a+172|0;o[a>>2]=d;r=n;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+172|0;o[a>>2]=d;r=n;return}case 2:{d=+p[c+8>>3];a=a+172|0;o[a>>2]=d;r=n;return}default:{d=1000000015047466219876688.0e6;a=a+172|0;o[a>>2]=d;r=n;return}}}function B_a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0.0,q=0.0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0.0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0;yc=r;r=r+1568|0;Rb=yc+856|0;fc=yc+1504|0;ac=yc+800|0;Vb=yc+576|0;Gb=yc+560|0;Hb=yc+544|0;Ib=yc+1448|0;wb=yc+1392|0;xb=yc+1320|0;xc=yc+1264|0;wc=yc+1208|0;vc=yc+1152|0;uc=yc+1096|0;yb=yc+32|0;tc=yc+1040|0;zb=yc;oc=yc+984|0;jc=yc+968|0;ic=yc+956|0;hc=yc+944|0;gc=yc+888|0;Cb=yc+1384|0;Eb=yc+320|0;Db=yc+1376|0;Fb=yc+96|0;Qb=yc+64|0;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[xc>>2]=k[f>>2];m=xc+4|0;b=f+4|0;k[m>>2]=k[b>>2];sc=xc+8|0;k[sc>>2]=k[f+8>>2];k[xc+12>>2]=k[f+12>>2];k[xc+16>>2]=k[f+16>>2];k[xc+20>>2]=k[f+20>>2];k[xc+24>>2]=k[f+24>>2];k[xc+28>>2]=k[f+28>>2];k[xc+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[xc+36>>2]=d;e=xc+40|0;k[e>>2]=sc;sc=xc+48|0;h=xc+44|0;k[h>>2]=sc;k[xc+52>>2]=0;k[sc>>2]=0;if(d|0){sc=d+12|0;k[sc>>2]=(k[sc>>2]|0)+1}if((k[b>>2]|0)<3){rc=k[f+44>>2]|0;sc=k[h>>2]|0;k[sc>>2]=k[rc>>2];k[sc+4>>2]=k[rc+4>>2];break}k[m>>2]=0;x1(xc,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(xc,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[wc>>2]=k[f>>2];m=wc+4|0;b=f+4|0;k[m>>2]=k[b>>2];sc=wc+8|0;k[sc>>2]=k[f+8>>2];k[wc+12>>2]=k[f+12>>2];k[wc+16>>2]=k[f+16>>2];k[wc+20>>2]=k[f+20>>2];k[wc+24>>2]=k[f+24>>2];k[wc+28>>2]=k[f+28>>2];k[wc+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[wc+36>>2]=d;e=wc+40|0;k[e>>2]=sc;sc=wc+48|0;h=wc+44|0;k[h>>2]=sc;k[wc+52>>2]=0;k[sc>>2]=0;if(d|0){sc=d+12|0;k[sc>>2]=(k[sc>>2]|0)+1}if((k[b>>2]|0)<3){rc=k[f+44>>2]|0;sc=k[h>>2]|0;k[sc>>2]=k[rc>>2];k[sc+4>>2]=k[rc+4>>2];break}k[m>>2]=0;x1(wc,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(wc,c,-1);while(0);k[vc>>2]=1124007936;rc=vc+4|0;b=vc+8|0;pc=vc+40|0;h=rc;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[pc>>2]=b;sc=vc+48|0;qc=vc+44|0;k[qc>>2]=sc;k[vc+52>>2]=0;k[sc>>2]=0;k[uc>>2]=1124007936;mc=uc+4|0;b=uc+8|0;kc=uc+40|0;h=mc;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[kc>>2]=b;nc=uc+48|0;lc=uc+44|0;k[lc>>2]=nc;k[uc+52>>2]=0;k[nc>>2]=0;ec=Rb+4|0;dc=ec+4|0;k[dc>>2]=0;k[dc+4>>2]=0;k[Rb>>2]=33619968;k[ec>>2]=vc;SW(xc,Rb,5,1.0,0.0);if((k[uc>>2]&4095|0)==5){ec=Rb+4|0;dc=ec+4|0;k[dc>>2]=0;k[dc+4>>2]=0;k[Rb>>2]=33619968;k[ec>>2]=uc;mY(wc,Rb)}else{ec=Rb+4|0;dc=ec+4|0;k[dc>>2]=0;k[dc+4>>2]=0;k[Rb>>2]=33619968;k[ec>>2]=uc;SW(wc,Rb,5,1.0,0.0)}if(!((k[vc>>2]&4088|0)==8?(k[vc+12>>2]|0)>0:0)){k[Rb>>2]=0;b=Rb+4|0;k[b>>2]=0;d=ZT(44)|0;k[d>>2]=1;h=d+4|0;k[Rb>>2]=h;k[b>>2]=37;i[d+41>>0]=0;e=392336;m=h+37|0;do{i[h>>0]=i[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(m|0));Y8(-215,Rb,392374,392046,202);k[b>>2]=0;k[Rb>>2]=0;ec=k[d>>2]|0;k[d>>2]=ec+-1;if((ec|0)==1)ggb(k[d+-4>>2]|0)}if(!((k[uc>>2]&4088|0)==8?(k[uc+12>>2]|0)>0:0)){k[Rb>>2]=0;b=Rb+4|0;k[b>>2]=0;d=ZT(44)|0;k[d>>2]=1;h=d+4|0;k[Rb>>2]=h;k[b>>2]=37;i[d+41>>0]=0;e=392390;m=h+37|0;do{i[h>>0]=i[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(m|0));Y8(-215,Rb,392374,392046,203);k[b>>2]=0;k[Rb>>2]=0;ec=k[d>>2]|0;k[d>>2]=ec+-1;if((ec|0)==1)ggb(k[d+-4>>2]|0)}Jb=a+164|0;do if(+o[Jb>>2]!=0.0){if(k[a+64>>2]|0){e=k[a+52>>2]|0;if((e|0)<3)b=aa(k[a+60>>2]|0,k[a+56>>2]|0)|0;else{f=k[a+88>>2]|0;d=0;b=1;do{b=aa(k[f+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if(b|0?k[a+120>>2]|0:0){e=k[a+108>>2]|0;if((e|0)<3)b=aa(k[a+116>>2]|0,k[a+112>>2]|0)|0;else{f=k[a+144>>2]|0;d=0;b=1;do{b=aa(k[f+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if(b|0)break}}k[Rb>>2]=0;b=Rb+4|0;k[b>>2]=0;d=ZT(44)|0;k[d>>2]=1;h=d+4|0;k[Rb>>2]=h;k[b>>2]=38;i[d+42>>0]=0;e=392112;m=h+38|0;do{i[h>>0]=i[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(m|0));Y8(-215,Rb,392374,392046,206);k[b>>2]=0;k[Rb>>2]=0;ec=k[d>>2]|0;k[d>>2]=ec+-1;if((ec|0)==1)ggb(k[d+-4>>2]|0)}while(0);b=k[a+4>>2]|0;d=k[a+8>>2]|0;n=+o[a+12>>2];q=+o[a+16>>2];e=i[a+20>>0]|0;k[yb>>2]=b;k[yb+4>>2]=d;p[yb+8>>3]=n;p[yb+16>>3]=q;i[yb+24>>0]=e;k[tc>>2]=1124007936;cc=tc+4|0;ub=tc+8|0;bc=tc+40|0;h=cc;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[bc>>2]=ub;ec=tc+48|0;dc=tc+44|0;k[dc>>2]=ec;k[tc+52>>2]=0;k[ec>>2]=0;k[zb>>2]=b;k[zb+4>>2]=d;p[zb+8>>3]=n;p[zb+16>>3]=q;i[zb+24>>0]=e;k[oc>>2]=1124007936;Xb=oc+4|0;sb=oc+8|0;Wb=oc+40|0;h=Xb;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[Wb>>2]=sb;$b=oc+48|0;Yb=oc+44|0;k[Yb>>2]=$b;k[oc+52>>2]=0;k[$b>>2]=0;k[jc>>2]=0;Ub=jc+4|0;k[Ub>>2]=0;k[jc+8>>2]=0;k[ic>>2]=0;Tb=ic+4|0;k[Tb>>2]=0;k[ic+8>>2]=0;k[hc>>2]=0;Sb=hc+4|0;k[Sb>>2]=0;k[hc+8>>2]=0;tb=a+36|0;b=k[tb>>2]|0;if(!b)vb=0;else vb=Kob(b,6336,7176,0)|0;Ob=k[a+32>>2]|0;Pb=(Ob|0)==0;if(!Pb){Nb=Ob+4|0;k[Nb>>2]=(k[Nb>>2]|0)+1}k[gc>>2]=1124007936;Lb=gc+4|0;Bb=gc+8|0;Kb=gc+40|0;h=Lb;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[Kb>>2]=Bb;Nb=gc+48|0;Mb=gc+44|0;k[Mb>>2]=Nb;k[gc+52>>2]=0;k[Nb>>2]=0;N=a+28|0;a:do if((k[N>>2]|0)>0){O=yb+28|0;Q=(vb|0)==0;R=Rb+8|0;S=Rb+12|0;T=Rb+4|0;U=fc+8|0;V=fc+12|0;W=fc+4|0;X=Rb+8|0;Y=Rb+12|0;_=Rb+4|0;$=fc+4|0;ba=$+4|0;ca=Rb+4|0;da=ca+4|0;ea=a+48|0;fa=Rb+4|0;ga=fa+4|0;ha=a+104|0;ia=Rb+8|0;ja=Rb+12|0;ka=Rb+4|0;la=fc+4|0;ma=la+4|0;na=xb+4|0;oa=xb+8|0;pa=xb+40|0;qa=xb+48|0;ra=xb+44|0;sa=xb+52|0;ta=a+44|0;ua=Rb+8|0;va=Rb+12|0;wa=Rb+4|0;xa=fc+8|0;ya=fc+12|0;za=fc+4|0;Aa=ac+4|0;Ba=Aa+4|0;Ca=xb+16|0;Da=Rb+4|0;Ea=Rb+8|0;Fa=Rb+12|0;Ga=ac+8|0;Ha=Rb+4|0;Ia=fc+4|0;Ja=Hb+8|0;Ka=Hb+12|0;La=Hb+4|0;Ma=Ib+36|0;Na=Ib+16|0;Oa=Ib+4|0;Pa=Ib+40|0;Qa=Ib+44|0;Ra=Ib+48|0;Sa=Ib+32|0;Ta=ac+12|0;Ua=Rb+4|0;Va=fc+4|0;Wa=Ib+8|0;Xa=Ib+12|0;Ya=Ib+4|0;Za=wb+36|0;_a=wb+16|0;$a=wb+4|0;ab=wb+40|0;bb=wb+44|0;cb=wb+48|0;db=wb+32|0;eb=xb+12|0;fb=Rb+4|0;gb=Rb+8|0;hb=Rb+12|0;ib=jc+8|0;jb=ac+36|0;kb=ac+16|0;lb=ac+4|0;mb=ac+40|0;nb=ac+44|0;ob=ac+48|0;pb=xb+36|0;qb=xb+32|0;rb=ac+32|0;M=0;n=0.0;b:while(1){a$a(yb,vc,tc,ic,-1.0);L=+o[O>>2];a$a(zb,uc,oc,hc,L);L=L*L;b=k[jc>>2]|0;d=k[Ub>>2]|0;if((d|0)!=(b|0))k[Ub>>2]=d+(~((d+-16-b|0)>>>4)<<4);k[xb>>2]=1124007936;h=na;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[pa>>2]=oa;k[ra>>2]=qa;k[sa>>2]=0;k[qa>>2]=0;J=k[ta>>2]|0;K=k[(k[J>>2]|0)+32>>2]|0;k[ua>>2]=0;k[va>>2]=0;k[Rb>>2]=16842752;k[wa>>2]=tc;k[xa>>2]=0;k[ya>>2]=0;k[fc>>2]=16842752;k[za>>2]=oc;b=Ba;k[b>>2]=0;k[b+4>>2]=0;k[ac>>2]=33619968;k[Aa>>2]=xb;dh[K&255](J,Rb,fc,ac);J=k[ub>>2]|0;K=k[sb>>2]|0;b=k[oa>>2]|0;c:do if(b){if(b>>>0>1073741823){Ab=58;break b}e=b<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d;while(1){k[e>>2]=0;b=b+-1|0;if(!b)break;else e=e+4|0}b=k[oa>>2]|0;if(b){if(b>>>0>1073741823){Ab=67;break b}f=b<<2;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}f=e;while(1){k[f>>2]=0;b=b+-1|0;if(!b)break;else f=f+4|0}b=k[oa>>2]|0;if(b){if(b>>>0>1073741823){Ab=76;break b}g=b<<2;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}g=f;while(1){k[g>>2]=0;b=b+-1|0;if(!b)break;else g=g+4|0}b=k[oa>>2]|0;if(!b){h=0;q=0.0;b=0;F=0;G=0;H=0;I=0}else{if(b>>>0>1073741823){Ab=85;break b}h=b<<2;g=(h|0)==0?1:h;while(1){b=fgb(g)|0;if(b|0){A=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){A=0;break}Qh[b&7]()}zpb(A|0,0,h|0)|0;b=k[oa>>2]|0;if(!b){h=0;q=0.0;b=0;F=0;G=0;H=0;I=A;break}if(b>>>0>1073741823){Ab=92;break b}h=b<<2;g=(h|0)==0?1:h;while(1){b=fgb(g)|0;if(b|0){z=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){z=0;break}Qh[b&7]()}zpb(z|0,0,h|0)|0;b=k[oa>>2]|0;if(!b){h=0;q=0.0;b=0;F=0;G=0;H=z;I=A;break}if(b>>>0>1073741823){Ab=99;break b}h=b<<2;g=(h|0)==0?1:h;while(1){b=fgb(g)|0;if(b|0){y=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){y=0;break}Qh[b&7]()}zpb(y|0,0,h|0)|0;b=k[oa>>2]|0;if(!b){h=0;q=0.0;b=0;F=0;G=y;H=z;I=A;break}if(b>>>0>1073741823){Ab=106;break b}h=b<<2;g=(h|0)==0?1:h;while(1){b=fgb(g)|0;if(b|0){w=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){w=0;break}Qh[b&7]()}zpb(w|0,0,h|0)|0;b=k[oa>>2]|0;if(!b){h=0;q=0.0;b=0;F=w;G=y;H=z;I=A;break}if(b>>>0>1073741823){Ab=113;break b}h=b<<2;g=(h|0)==0?1:h;while(1){b=fgb(g)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}zpb(b|0,0,h|0)|0;g=k[oa>>2]|0;if((g|0)<=0){h=0;q=0.0;F=w;G=y;H=z;I=A;break}s=k[Ca>>2]|0;t=k[ra>>2]|0;c=g;v=g;do{m=c;c=c+-1|0;q=+o[s+(c<<2)>>2];if((v|0)>1){j=k[t>>2]|0;g=0;h=1;do{I=s+(aa(j,h)|0)+(c<<2)|0;C=+o[I>>2];I=C<q;g=I?h:g;q=I?C:q;h=h+1|0}while((h|0)!=(v|0))}else g=0;o[b+(c<<2)>>2]=q;H=f+(g<<2)|0;I=k[H>>2]|0;k[H>>2]=I+1;if(!I)k[z+(g<<2)>>2]=c;else g=-1;k[A+(c<<2)>>2]=g;v=k[oa>>2]|0}while((m|0)>1);if((v|0)<=0){h=0;F=w;G=y;H=z;I=A;break}s=k[Ca>>2]|0;t=k[ra>>2]|0;h=0;c=0;g=v;while(1){switch(k[f+(c<<2)>>2]|0){case 0:{k[d+(h<<2)>>2]=c;h=h+1|0;g=k[oa>>2]|0;break}case 1:{m=k[z+(c<<2)>>2]|0;if((g|0)>0){j=0;q=3402823466385288598117041.0e14;do{do if((j|0)!=(m|0)){I=s+(aa(k[t>>2]|0,c)|0)+(j<<2)|0;x=+o[I>>2]-+o[b+(j<<2)>>2];if(!(x<q))break;q=x}while(0);j=j+1|0}while((j|0)!=(g|0))}else q=3402823466385288598117041.0e14;I=b+(m<<2)|0;o[I>>2]=+o[I>>2]-q;break}default:{}}c=c+1|0;if((c|0)>=(g|0)){F=w;G=y;H=z;I=A;break c}}}}else{h=0;q=0.0;b=0;F=0;G=0;H=0;I=0;f=0}}else{h=0;q=0.0;b=0;F=0;G=0;H=0;I=0;f=0;e=0}}else{h=0;q=0.0;b=0;F=0;G=0;H=0;I=0;f=0;e=0;d=0}while(0);E=0;g=0;A=h;while(1){E=E+1|0;d:do if((A|0)>0){h=0;D=0;while(1){y=k[Ca>>2]|0;z=k[ra>>2]|0;e:while(1){w=d+(h<<2)|0;v=k[w>>2]|0;while(1){s=y+(aa(k[z>>2]|0,v)|0)|0;x=+o[s>>2]-+o[b>>2];t=k[oa>>2]|0;if((t|0)>1){C=3402823466385288598117041.0e14;c=0;m=1;while(1){B=+o[s+(m<<2)>>2]-+o[b+(m<<2)>>2];if(B<C){g=!(B>=x);C=g?x:B;x=g?B:x;j=g?m:c;g=g?c:m}else j=c;m=m+1|0;if((m|0)==(t|0))break;else c=j}}else{C=3402823466385288598117041.0e14;j=0}m=I+(j<<2)|0;c=k[m>>2]|0;s=+P(+(x-C))>1.000000013351432e-10;if(s){t=b+(j<<2)|0;o[t>>2]=+o[t>>2]-(C-x)}else{if((c|0)<=-1){Ab=145;break}c=k[I+(g<<2)>>2]|0;j=g}k[H+(v<<2)>>2]=j;k[I+(j<<2)>>2]=v;if((c|0)<=-1)break;if(!s)break e;k[w>>2]=c;v=c}if((Ab|0)==145){Ab=0;k[H+(v<<2)>>2]=j;k[m>>2]=v}h=h+1|0;if((h|0)>=(A|0)){j=D;break d}}h=h+1|0;j=D+1|0;k[d+(D<<2)>>2]=c;if((h|0)>=(A|0))break;else D=j}}else j=0;while(0);if((E|0)==2)break;else A=j}if((j|0)>0){D=k[Ca>>2]|0;E=k[ra>>2]|0;m=0;A=0;while(1){z=k[d+(A<<2)>>2]|0;g=k[oa>>2]|0;if((g|0)>0){x=+(z|0);g=0;do{s=D+(aa(k[E>>2]|0,z)|0)+(g<<2)|0;o[G+(g<<2)>>2]=+o[s>>2]-+o[b+(g<<2)>>2];o[F+(g<<2)>>2]=x;k[e+(g<<2)>>2]=g;g=g+1|0;s=k[oa>>2]|0}while((g|0)<(s|0));c=0;h=0;g=s}else{c=0;h=0}f:while(1){do if((c|0)==(h|0)){m=h+-1|0;y=h+1|0;s=e+(h<<2)|0;q=+o[G+(k[s>>2]<<2)>>2];if((y|0)<(g|0)){c=y;w=y;do{t=e+(w<<2)|0;v=k[t>>2]|0;x=+o[G+(v<<2)>>2];if(x<=q){g=x<q;c=g?h:c;zc=e+(c<<2)|0;k[t>>2]=k[zc>>2];k[zc>>2]=v;q=g?x:q;c=c+1|0;g=k[oa>>2]|0}w=w+1|0}while((w|0)<(g|0));t=g}else{c=y;t=g}if((h|0)>=(c|0)){h=y;g=t;break}while(1){g=k[e+(h<<2)>>2]|0;h=h+1|0;if((k[I+(g<<2)>>2]|0)<0)break f;if((h|0)>=(c|0)){h=y;g=t;break}}}else{s=e+(h<<2)|0;h=h+1|0}while(0);zc=k[s>>2]|0;y=k[I+(zc<<2)>>2]|0;t=k[E>>2]|0;w=D+(aa(t,y)|0)+(zc<<2)|0;B=+o[w>>2]-+o[b+(zc<<2)>>2]-q;if((c|0)>=(g|0))continue;C=+(y|0);s=c;w=g;while(1){v=e+(s<<2)|0;g=k[v>>2]|0;t=D+(aa(t,y)|0)+(g<<2)|0;x=+o[t>>2]-+o[b+(g<<2)>>2]-B;t=G+(g<<2)|0;if(x<+o[t>>2]){o[F+(g<<2)>>2]=C;if(x==q){if((k[I+(g<<2)>>2]|0)<0)break f;zc=e+(c<<2)|0;k[v>>2]=k[zc>>2];k[zc>>2]=g;c=c+1|0;g=k[oa>>2]|0}else g=w;o[t>>2]=x}else g=w;s=s+1|0;if((s|0)>=(g|0))continue f;w=g;t=k[E>>2]|0}}if((m|0)>=0){h=0;while(1){y=k[e+(h<<2)>>2]|0;zc=b+(y<<2)|0;o[zc>>2]=+o[zc>>2]+ +o[G+(y<<2)>>2]-q;if((h|0)==(m|0))break;else h=h+1|0}}do{zc=~~+o[F+(g<<2)>>2];k[I+(g<<2)>>2]=zc;y=H+(zc<<2)|0;w=g;g=k[y>>2]|0;k[y>>2]=w}while((zc|0)!=(z|0));A=A+1|0;if((A|0)==(j|0)){v=b;t=F;s=G;c=H;j=I;break}}}else{v=b;t=F;s=G;c=H;j=I}k[Rb>>2]=0;k[Da>>2]=0;k[Ea>>2]=J;k[Fa>>2]=K;I1(ac,xb,Rb);o[Vb>>2]=0.0;b=k[Ga>>2]|0;if((b|0)>0){h=0;do{k[Rb>>2]=h;h=h+1|0;k[Ha>>2]=h;k[fc>>2]=-2147483648;k[Ia>>2]=2147483647;H1(Ib,ac,Rb,fc);k[Ja>>2]=0;k[Ka>>2]=0;k[Hb>>2]=16842752;k[La>>2]=Ib;D7(Hb,Gb,0,0,0,49332);b=k[Ma>>2]|0;if(b|0?(I=b+12|0,zc=k[I>>2]|0,k[I>>2]=zc+-1,(zc|0)==1):0){g=k[Ma>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[Sa>>2]|0;if(b|0)break;b=B1()|0;g=k[Ma>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[Ma>>2]=0}k[Ma>>2]=0;k[Na>>2]=0;k[Na+4>>2]=0;k[Na+8>>2]=0;k[Na+12>>2]=0;if((k[Oa>>2]|0)>0){g=k[Pa>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Oa>>2]|0))}b=k[Qa>>2]|0;if(!((b|0)==(Ra|0)|(b|0)==0))ggb(k[b+-4>>2]|0);q=+o[Vb>>2]+ +p[Gb>>3];o[Vb>>2]=q;b=k[Ga>>2]|0}while((h|0)<(b|0))}else q=0.0;q=q/+(b|0);o[Vb>>2]=q;o[Gb>>2]=0.0;b=k[Ta>>2]|0;if((b|0)>0){h=0;do{k[Rb>>2]=-2147483648;k[Ua>>2]=2147483647;k[fc>>2]=h;h=h+1|0;k[Va>>2]=h;H1(wb,ac,Rb,fc);k[Wa>>2]=0;k[Xa>>2]=0;k[Ib>>2]=16842752;k[Ya>>2]=wb;D7(Ib,Hb,0,0,0,49332);b=k[Za>>2]|0;do if(b|0){I=b+12|0;zc=k[I>>2]|0;k[I>>2]=zc+-1;if((zc|0)!=1)break;g=k[Za>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[db>>2]|0;if(b|0)break;b=B1()|0;g=k[Za>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[Za>>2]=0}while(0);k[Za>>2]=0;k[_a>>2]=0;k[_a+4>>2]=0;k[_a+8>>2]=0;k[_a+12>>2]=0;if((k[$a>>2]|0)>0){g=k[ab>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[$a>>2]|0))}b=k[bb>>2]|0;if(!((b|0)==(cb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);q=+o[Gb>>2]+ +p[Hb>>3];o[Gb>>2]=q;b=k[Ta>>2]|0}while((h|0)<(b|0));x=q;q=+o[Vb>>2]}else x=0.0;C=x/+(b|0);o[Gb>>2]=C;m=k[(q<C?Gb:Vb)>>2]|0;if((k[eb>>2]|0)>0){b=0;do{zc=k[j+(b<<2)>>2]|0;g=(k[Ca>>2]|0)+(aa(k[k[ra>>2]>>2]|0,zc)|0)+(b<<2)|0;g=k[g>>2]|0;k[Rb>>2]=zc;k[fb>>2]=b;k[gb>>2]=-1;k[hb>>2]=g;g=k[Ub>>2]|0;if((g|0)==(k[ib>>2]|0))I6(jc,Rb);else{k[g>>2]=k[Rb>>2];k[g+4>>2]=k[Rb+4>>2];k[g+8>>2]=k[Rb+8>>2];k[g+12>>2]=k[Rb+12>>2];k[Ub>>2]=g+16}b=b+1|0}while((b|0)<(k[eb>>2]|0))}zHa(ic,J);b=k[Tb>>2]|0;g=k[ic>>2]|0;h=g;if((b|0)!=(g|0)){g=b-g>>2;b=0;do{k[h+(b<<2)>>2]=(k[c+(b<<2)>>2]|0)<(J|0)&1;b=b+1|0}while(b>>>0<g>>>0)}zHa(hc,K);b=k[Sb>>2]|0;g=k[hc>>2]|0;h=g;if((b|0)!=(g|0)){g=b-g>>2;b=0;do{k[h+(b<<2)>>2]=(k[j+(b<<2)>>2]|0)<(K|0)&1;b=b+1|0}while(b>>>0<g>>>0)}b=k[jb>>2]|0;do if(b|0){K=b+12|0;zc=k[K>>2]|0;k[K>>2]=zc+-1;if((zc|0)!=1)break;g=k[jb>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[rb>>2]|0;if(b|0)break;b=B1()|0;g=k[jb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[jb>>2]=0}while(0);k[jb>>2]=0;k[kb>>2]=0;k[kb+4>>2]=0;k[kb+8>>2]=0;k[kb+12>>2]=0;if((k[lb>>2]|0)>0){g=k[mb>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[lb>>2]|0))}b=k[nb>>2]|0;if(!((b|0)==(ob|0)|(b|0)==0))ggb(k[b+-4>>2]|0);if(v|0)ggb(v);if(t|0)ggb(t);if(s|0)ggb(s);if(c|0)ggb(c);if(j|0)ggb(j);if(f|0)ggb(f);if(e|0)ggb(e);if(d|0)ggb(d);b=k[pb>>2]|0;do if(b|0){K=b+12|0;zc=k[K>>2]|0;k[K>>2]=zc+-1;if((zc|0)!=1)break;d=k[pb>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[qb>>2]|0;if(b|0)break;b=B1()|0;d=k[pb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[pb>>2]=0}while(0);k[pb>>2]=0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[na>>2]|0)>0){d=k[pa>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[na>>2]|0))}b=k[ra>>2]|0;if(!((b|0)==(qa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);if(!Q)gh[k[(k[vb>>2]|0)+44>>2]&255](vb,L);zc=k[tb>>2]|0;K=k[(k[zc>>2]|0)+32>>2]|0;k[R>>2]=0;k[S>>2]=0;k[Rb>>2]=16842752;k[T>>2]=vc;k[U>>2]=0;k[V>>2]=0;k[fc>>2]=16842752;k[W>>2]=uc;dh[K&255](zc,Rb,fc,jc);zc=k[tb>>2]|0;K=k[(k[zc>>2]|0)+36>>2]|0;k[X>>2]=0;k[Y>>2]=0;k[Rb>>2]=16842752;k[_>>2]=vc;J=ba;k[J>>2]=0;k[J+4>>2]=0;k[fc>>2]=33619968;k[$>>2]=vc;n=n+ +Ug[K&31](zc,Rb,fc);if(+o[Jb>>2]!=0.0){do if(!M)if(Q){zc=da;k[zc>>2]=0;k[zc+4>>2]=0;k[Rb>>2]=33619968;k[ca>>2]=gc;mY(ea,Rb);break}else{zc=ga;k[zc>>2]=0;k[zc+4>>2]=0;k[Rb>>2]=33619968;k[fa>>2]=gc;mY(ha,Rb);break}while(0);zc=k[tb>>2]|0;K=k[(k[zc>>2]|0)+40>>2]|0;k[ia>>2]=0;k[ja>>2]=0;k[Rb>>2]=16842752;k[ka>>2]=gc;J=ma;k[J>>2]=0;k[J+4>>2]=0;k[fc>>2]=33619968;k[la>>2]=gc;k[ac>>2]=0;k[ac+4>>2]=0;k[ac+8>>2]=0;k[ac+12>>2]=0;k[ac+16>>2]=0;k[ac+20>>2]=0;k[ac+24>>2]=0;k[ac+28>>2]=0;Lg[K&255](zc,Rb,fc,1,0,ac)}M=M+1|0;if((M|0)>=(k[N>>2]|0)){Zb=n;_b=m;break a}}if((Ab|0)==58)ad(426534,426557,304,426811);else if((Ab|0)==67)ad(426534,426557,304,426811);else if((Ab|0)==76)ad(426534,426557,304,426811);else if((Ab|0)==85)ad(426534,426557,304,426811);else if((Ab|0)==92)ad(426534,426557,304,426811);else if((Ab|0)==99)ad(426534,426557,304,426811);else if((Ab|0)==106)ad(426534,426557,304,426811);else if((Ab|0)==113)ad(426534,426557,304,426811)}else{Zb=0.0;_b=0}while(0);k[fc>>2]=1124007936;J=fc+4|0;b=fc+8|0;H=fc+40|0;h=J;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[H>>2]=b;K=fc+48|0;I=fc+44|0;k[I>>2]=K;k[fc+52>>2]=0;k[K>>2]=0;k[ac>>2]=1124007936;E=ac+4|0;A=ac+8|0;D=ac+40|0;h=E;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[D>>2]=A;G=ac+48|0;F=ac+44|0;k[F>>2]=G;k[ac+52>>2]=0;k[G>>2]=0;n=+o[Jb>>2];if(n!=0.0){if(!vb){k[Rb+8>>2]=0;k[Rb+12>>2]=0;k[Rb>>2]=16842752;k[Rb+4>>2]=gc;b=Vb+4|0;e=b+4|0;k[e>>2]=0;k[e+4>>2]=0;k[Vb>>2]=33619968;k[b>>2]=gc;b=k[a+144>>2]|0;e=k[b>>2]|0;k[Db>>2]=k[b+4>>2];k[Db+4>>2]=e;Rla(Rb,Vb,Db,0.0,0.0,1);e=a+104|0;k[Fb>>2]=0;k[Fb+4>>2]=0;k[Fb+8>>2]=1124007936;b=Fb+16|0;d=Fb+48|0;h=Fb+12|0;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[d>>2]=b;b=Fb+56|0;k[Fb+52>>2]=b;k[Fb+60>>2]=0;k[b>>2]=0;k[Fb+64>>2]=1124007936;b=Fb+72|0;d=Fb+104|0;h=Fb+68|0;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[d>>2]=b;b=Fb+112|0;k[Fb+108>>2]=b;k[Fb+116>>2]=0;k[b>>2]=0;k[Fb+120>>2]=1124007936;b=Fb+128|0;d=Fb+160|0;h=Fb+124|0;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[d>>2]=b;h=Fb+168|0;k[Fb+164>>2]=h;m=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[Rb>>2]=0;k[Rb+4>>2]=0;k[Rb+8>>2]=0;k[Rb+12>>2]=0;k[Rb+16>>2]=0;k[Rb+20>>2]=0;k[Rb+24>>2]=0;k[Rb+28>>2]=0;G0(Fb,gc,e,1.0,-1.0,Rb);k[Vb>>2]=1124007936;j=Vb+4|0;b=Vb+8|0;g=Vb+40|0;h=j;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[g>>2]=b;h=Vb+48|0;f=Vb+44|0;k[f>>2]=h;k[Vb+52>>2]=0;k[h>>2]=0;e=k[Fb>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,Fb,Vb,-1);XN(Fb);k[Gb+8>>2]=0;k[Gb+12>>2]=0;k[Gb>>2]=16842752;k[Gb+4>>2]=Vb;k[Hb+8>>2]=0;k[Hb+12>>2]=0;k[Hb>>2]=16842752;k[Hb+4>>2]=Vb;e=Ib+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[Ib>>2]=33619968;k[e>>2]=ac;p[Rb>>3]=1.0;sU(Gb,Hb,Ib,49332,-1,40032,1,Rb);e=Vb+36|0;b=k[e>>2]|0;if(b|0?(Ib=b+12|0,zc=k[Ib>>2]|0,k[Ib>>2]=zc+-1,(zc|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Vb+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;zc=Vb+16|0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[j>>2]|0)>0){d=k[g>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[f>>2]|0;if(!((b|0)==(h|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{k[Rb+8>>2]=0;k[Rb+12>>2]=0;k[Rb>>2]=16842752;k[Rb+4>>2]=gc;b=Vb+4|0;e=b+4|0;k[e>>2]=0;k[e+4>>2]=0;k[Vb>>2]=33619968;k[b>>2]=gc;b=k[a+88>>2]|0;e=k[b>>2]|0;k[Cb>>2]=k[b+4>>2];k[Cb+4>>2]=e;Rla(Rb,Vb,Cb,0.0,0.0,1);e=a+48|0;k[Eb>>2]=0;k[Eb+4>>2]=0;k[Eb+8>>2]=1124007936;b=Eb+16|0;d=Eb+48|0;h=Eb+12|0;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[d>>2]=b;b=Eb+56|0;k[Eb+52>>2]=b;k[Eb+60>>2]=0;k[b>>2]=0;k[Eb+64>>2]=1124007936;b=Eb+72|0;d=Eb+104|0;h=Eb+68|0;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[d>>2]=b;b=Eb+112|0;k[Eb+108>>2]=b;k[Eb+116>>2]=0;k[b>>2]=0;k[Eb+120>>2]=1124007936;b=Eb+128|0;d=Eb+160|0;h=Eb+124|0;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[d>>2]=b;h=Eb+168|0;k[Eb+164>>2]=h;m=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[Rb>>2]=0;k[Rb+4>>2]=0;k[Rb+8>>2]=0;k[Rb+12>>2]=0;k[Rb+16>>2]=0;k[Rb+20>>2]=0;k[Rb+24>>2]=0;k[Rb+28>>2]=0;G0(Eb,gc,e,1.0,-1.0,Rb);k[Vb>>2]=1124007936;j=Vb+4|0;b=Vb+8|0;g=Vb+40|0;h=j;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[g>>2]=b;h=Vb+48|0;f=Vb+44|0;k[f>>2]=h;k[Vb+52>>2]=0;k[h>>2]=0;e=k[Eb>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,Eb,Vb,-1);XN(Eb);k[Gb+8>>2]=0;k[Gb+12>>2]=0;k[Gb>>2]=16842752;k[Gb+4>>2]=Vb;k[Hb+8>>2]=0;k[Hb+12>>2]=0;k[Hb>>2]=16842752;k[Hb+4>>2]=Vb;e=Ib+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[Ib>>2]=33619968;k[e>>2]=ac;p[Rb>>3]=1.0;sU(Gb,Hb,Ib,49332,-1,40032,1,Rb);e=Vb+36|0;b=k[e>>2]|0;if(b|0?(Ib=b+12|0,zc=k[Ib>>2]|0,k[Ib>>2]=zc+-1,(zc|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Vb+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;zc=Vb+16|0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[j>>2]|0)>0){d=k[g>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[f>>2]|0;if(!((b|0)==(h|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}e=k[Bb>>2]|0;f=k[gc+12>>2]|0;k[Vb>>2]=0;k[Vb+4>>2]=0;k[Vb+8>>2]=1124007936;b=Vb+16|0;d=Vb+48|0;h=Vb+12|0;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[d>>2]=b;b=Vb+56|0;k[Vb+52>>2]=b;k[Vb+60>>2]=0;k[b>>2]=0;k[Vb+64>>2]=1124007936;b=Vb+72|0;d=Vb+104|0;h=Vb+68|0;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[d>>2]=b;b=Vb+112|0;k[Vb+108>>2]=b;k[Vb+116>>2]=0;k[b>>2]=0;k[Vb+120>>2]=1124007936;b=Vb+128|0;d=Vb+160|0;h=Vb+124|0;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[d>>2]=b;h=Vb+168|0;k[Vb+164>>2]=h;m=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[Rb>>2]=f;k[Rb+4>>2]=e;j1(Vb,48,Rb,5);z=k[Vb>>2]|0;dh[k[(k[z>>2]|0)+12>>2]&255](z,Vb,fc,-1);XN(Vb);z=xc+12|0;j=k[z>>2]|0;if((j|0)>0){m=k[xc+16>>2]|0;c=k[A>>2]|0;f=ac+12|0;e=k[f>>2]|0;s=(e|0)>0;t=a+172|0;v=k[fc+16>>2]|0;w=k[I>>2]|0;if((c|0)>0){b=0;do{n=+o[m+(b<<3)>>2];q=+o[m+(b<<3)+4>>2];if(s){h=k[w>>2]|0;g=0;do{x=q-+(g|0);x=x*x;y=v+(aa(h,g)|0)|0;d=0;do{C=n-+(d|0);L=+o[t>>2];L=+Z(+(-(x+C*C)/(L*(L*2.0))))/(L*L*2.0*3.141592653589793);zc=y+(d<<2)|0;o[zc>>2]=+o[zc>>2]+L;d=d+1|0}while((d|0)!=(e|0));g=g+1|0}while((g|0)!=(c|0))}b=b+1|0}while((b|0)!=(j|0))}}else{e=ac+12|0;f=e;e=k[e>>2]|0}d=k[A>>2]|0;k[Vb>>2]=1124007936;y=Vb+4|0;b=Vb+8|0;v=Vb+40|0;h=y;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[v>>2]=b;w=Vb+48|0;t=Vb+44|0;k[t>>2]=w;k[Vb+52>>2]=0;k[w>>2]=0;k[Rb>>2]=d;k[Rb+4>>2]=e;G1(Vb,2,Rb,5);b=k[A>>2]|0;if((b|0)>0){m=ac+16|0;c=fc+16|0;s=Vb+16|0;h=k[f>>2]|0;j=(h|0)>0;g=0;do{if(j){d=k[c>>2]|0;e=(k[m>>2]|0)+(aa(k[k[F>>2]>>2]|0,g)|0)|0;f=(k[s>>2]|0)+(aa(k[k[t>>2]>>2]|0,g)|0)|0;b=0;do{zc=d+(aa(k[k[I>>2]>>2]|0,g)|0)+(b<<2)|0;o[f+(b<<2)>>2]=+(l[e+b>>0]|0)/255.0*+o[zc>>2];b=b+1|0}while((b|0)!=(h|0));b=k[A>>2]|0}g=g+1|0}while((g|0)<(b|0))}k[Rb+8>>2]=0;k[Rb+12>>2]=0;k[Rb>>2]=16842752;k[Rb+4>>2]=Vb;g7(Qb,Rb);n=+p[Qb>>3];f=k[z>>2]|0;e=Vb+36|0;b=k[e>>2]|0;if(b|0?(Rb=b+12|0,zc=k[Rb>>2]|0,k[Rb>>2]=zc+-1,(zc|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Vb+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;zc=Vb+16|0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[y>>2]|0)>0){d=k[v>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[y>>2]|0))}b=k[t>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=ac+36|0;q=n/+(f|0);f=b;n=+o[Jb>>2];b=k[b>>2]|0}else{q=0.0;f=ac+36|0;b=0}n=(k[u>>2]=_b,+o[u>>2])*+o[a+168>>2]+Zb*+o[a+160>>2]+q*n;if(b|0?(a=b+12|0,zc=k[a>>2]|0,k[a>>2]=zc+-1,(zc|0)==1):0){e=ac+36|0;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[ac+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[f>>2]=0;zc=ac+16|0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[E>>2]|0)>0){d=k[D>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[E>>2]|0))}b=k[F>>2]|0;if(!((b|0)==(G|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=fc+36|0;b=k[e>>2]|0;if(b|0?(ac=b+12|0,zc=k[ac>>2]|0,k[ac>>2]=zc+-1,(zc|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[fc+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;zc=fc+16|0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[J>>2]|0)>0){d=k[H>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[J>>2]|0))}b=k[I>>2]|0;if(!((b|0)==(K|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=gc+36|0;b=k[e>>2]|0;if(b|0?(fc=b+12|0,zc=k[fc>>2]|0,k[fc>>2]=zc+-1,(zc|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[gc+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;zc=gc+16|0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[Lb>>2]|0)>0){d=k[Kb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Lb>>2]|0))}b=k[Mb>>2]|0;if(!((b|0)==(Nb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=Ob;do if(!Pb){gc=b+4|0;zc=k[gc>>2]|0;k[gc>>2]=zc+-1;if((zc|0)!=1)break;Uh[k[(k[Ob>>2]|0)+8>>2]&2047](b)}while(0);b=k[hc>>2]|0;d=b;if(b|0){e=k[Sb>>2]|0;if((e|0)!=(b|0))k[Sb>>2]=e+(~((e+-4-d|0)>>>2)<<2);ggb(b)}b=k[ic>>2]|0;d=b;if(b|0){e=k[Tb>>2]|0;if((e|0)!=(b|0))k[Tb>>2]=e+(~((e+-4-d|0)>>>2)<<2);ggb(b)}b=k[jc>>2]|0;d=b;if(b|0){e=k[Ub>>2]|0;if((e|0)!=(b|0))k[Ub>>2]=e+(~((e+-16-d|0)>>>4)<<4);ggb(b)}e=oc+36|0;b=k[e>>2]|0;do if(b|0){jc=b+12|0;zc=k[jc>>2]|0;k[jc>>2]=zc+-1;if((zc|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[oc+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;zc=oc+16|0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[Xb>>2]|0)>0){d=k[Wb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Xb>>2]|0))}b=k[Yb>>2]|0;if(!((b|0)==($b|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=tc+36|0;b=k[e>>2]|0;do if(b|0){oc=b+12|0;zc=k[oc>>2]|0;k[oc>>2]=zc+-1;if((zc|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[tc+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;zc=tc+16|0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[cc>>2]|0)>0){d=k[bc>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[cc>>2]|0))}b=k[dc>>2]|0;if(!((b|0)==(ec|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=uc+36|0;b=k[e>>2]|0;do if(b|0){tc=b+12|0;zc=k[tc>>2]|0;k[tc>>2]=zc+-1;if((zc|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[uc+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;zc=uc+16|0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[mc>>2]|0)>0){d=k[kc>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[mc>>2]|0))}b=k[lc>>2]|0;if(!((b|0)==(nc|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=vc+36|0;b=k[e>>2]|0;do if(b|0){uc=b+12|0;zc=k[uc>>2]|0;k[uc>>2]=zc+-1;if((zc|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[vc+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;zc=vc+16|0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[rc>>2]|0)>0){d=k[pc>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[rc>>2]|0))}b=k[qc>>2]|0;if(!((b|0)==(sc|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=wc+36|0;b=k[e>>2]|0;do if(b|0){vc=b+12|0;zc=k[vc>>2]|0;k[vc>>2]=zc+-1;if((zc|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[wc+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;zc=wc+16|0;d=wc+4|0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[d>>2]|0)>0){e=k[wc+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[wc+44>>2]|0;if(!((b|0)==(wc+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=xc+36|0;b=k[e>>2]|0;do if(b|0){wc=b+12|0;zc=k[wc>>2]|0;k[wc>>2]=zc+-1;if((zc|0)!=1)break;d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[xc+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}while(0);k[e>>2]=0;zc=xc+16|0;d=xc+4|0;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;if((k[d>>2]|0)>0){e=k[xc+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[xc+44>>2]|0;if((b|0)==(xc+48|0)|(b|0)==0){r=yc;return +n}ggb(k[b+-4>>2]|0);r=yc;return +n}function C_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if((b|0)>0){j=a+4|0;k[j>>2]=b;r=g;return}d=c+4|0;e=ZT(20)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=15;i[e+19>>0]=0;h=392305;j=f+15|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-215,c,392321,392046,86);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);j=a+4|0;k[j>>2]=b;r=g;return}function D_a(a){a=a|0;return k[a+4>>2]|0}function E_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if((b|0)>0){j=a+8|0;k[j>>2]=b;r=g;return}d=c+4|0;e=ZT(20)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=14;i[e+18>>0]=0;h=392276;j=f+14|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-215,c,392291,392046,89);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);j=a+8|0;k[j>>2]=b;r=g;return}function F_a(a){a=a|0;return k[a+8>>2]|0}function G_a(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if(b>0.0){j=a+12|0;o[j>>2]=b;r=g;return}d=c+4|0;e=ZT(20)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=14;i[e+18>>0]=0;h=392246;j=f+14|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-215,c,392261,392046,92);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);j=a+12|0;o[j>>2]=b;r=g;return}function H_a(a){a=a|0;return +(+o[a+12>>2])}function I_a(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if(b>0.0){j=a+16|0;o[j>>2]=b;r=g;return}d=c+4|0;e=ZT(20)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=14;i[e+18>>0]=0;h=392216;j=f+14|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-215,c,392231,392046,95);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);j=a+16|0;o[j>>2]=b;r=g;return}function J_a(a){a=a|0;return +(+o[a+16>>2])}function K_a(a,b){a=a|0;b=b|0;i[a+20>>0]=b&1;return}function L_a(a){a=a|0;return (i[a+20>>0]|0)!=0|0}function M_a(a,b){a=a|0;b=+b;o[a+168>>2]=b;return}function N_a(a){a=a|0;return +(+o[a+168>>2])}function O_a(a,b){a=a|0;b=+b;o[a+164>>2]=b;return}function P_a(a){a=a|0;return +(+o[a+164>>2])}function Q_a(a,b){a=a|0;b=+b;o[a+160>>2]=b;return}function R_a(a){a=a|0;return +(+o[a+160>>2])}function S_a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+128|0;o=p+64|0;n=p+8|0;m=p;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[o>>2]=k[f>>2];l=o+4|0;b=f+4|0;k[l>>2]=k[b>>2];j=o+8|0;k[j>>2]=k[f+8>>2];k[o+12>>2]=k[f+12>>2];k[o+16>>2]=k[f+16>>2];k[o+20>>2]=k[f+20>>2];k[o+24>>2]=k[f+24>>2];k[o+28>>2]=k[f+28>>2];k[o+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[o+36>>2]=d;e=o+40|0;k[e>>2]=j;j=o+48|0;h=o+44|0;k[h>>2]=j;k[o+52>>2]=0;k[j>>2]=0;if(d|0){j=d+12|0;k[j>>2]=(k[j>>2]|0)+1}if((k[b>>2]|0)<3){j=k[f+44>>2]|0;l=k[h>>2]|0;k[l>>2]=k[j>>2];k[l+4>>2]=k[j+4>>2];break}k[l>>2]=0;x1(o,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(o,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[n>>2]=k[g>>2];l=n+4|0;d=g+4|0;k[l>>2]=k[d>>2];c=n+8|0;k[c>>2]=k[g+8>>2];k[n+12>>2]=k[g+12>>2];k[n+16>>2]=k[g+16>>2];k[n+20>>2]=k[g+20>>2];k[n+24>>2]=k[g+24>>2];k[n+28>>2]=k[g+28>>2];k[n+32>>2]=k[g+32>>2];b=k[g+36>>2]|0;k[n+36>>2]=b;e=n+40|0;k[e>>2]=c;c=n+48|0;h=n+44|0;k[h>>2]=c;k[n+52>>2]=0;k[c>>2]=0;if(b|0){c=b+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[d>>2]|0)<3){l=k[g+44>>2]|0;c=k[h>>2]|0;k[c>>2]=k[l>>2];k[c+4>>2]=k[l+4>>2];break}k[l>>2]=0;x1(n,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;f=k[e>>2]|0;e=k[g+44>>2]|0;d=k[h>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(n,c,-1);while(0);if(!((k[o>>2]&7|0)==0?!(k[n>>2]&7|0):0)){k[m>>2]=0;b=m+4|0;k[b>>2]=0;d=ZT(52)|0;k[d>>2]=1;e=d+4|0;k[m>>2]=e;k[b>>2]=44;i[d+48>>0]=0;f=392161;g=e+44|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,m,392206,392046,119);k[b>>2]=0;k[m>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0)}KG(a+48|0,o)|0;KG(a+104|0,n)|0;e=n+36|0;b=k[e>>2]|0;if(b|0?(a=b+12|0,m=k[a>>2]|0,k[a>>2]=m+-1,(m|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[n+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;m=n+16|0;d=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[d>>2]|0)>0){e=k[n+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[n+44>>2]|0;if(!((b|0)==(n+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=o+36|0;b=k[e>>2]|0;if(b|0?(m=b+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[o+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;n=o+16|0;d=o+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[d>>2]|0)>0){e=k[o+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[o+44>>2]|0;if((b|0)==(o+48|0)|(b|0)==0){r=p;return}ggb(k[b+-4>>2]|0);r=p;return}function T_a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+144|0;j=s+128|0;l=s+120|0;m=s+112|0;p=s+56|0;q=s;n=a+48|0;if(k[a+64>>2]|0){f=k[a+52>>2]|0;if((f|0)<3)d=aa(k[a+60>>2]|0,k[a+56>>2]|0)|0;else{g=k[a+88>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}if((d|0)!=0?(k[a+120>>2]|0)!=0:0){f=k[a+108>>2]|0;if((f|0)<3)d=aa(k[a+116>>2]|0,k[a+112>>2]|0)|0;else{g=k[a+144>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}if(!d)h=13}else h=13}else h=13;if((h|0)==13){d=j+4|0;e=ZT(44)|0;k[e>>2]=1;f=e+4|0;k[j>>2]=f;k[d>>2]=38;i[e+42>>0]=0;g=392112;h=f+38|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,j,392151,392046,126);k[d>>2]=0;k[j>>2]=0;o=k[e>>2]|0;k[e>>2]=o+-1;if((o|0)==1)ggb(k[e+-4>>2]|0)}j=k[a+88>>2]|0;o=k[j>>2]|0;k[l>>2]=k[j+4>>2];k[l+4>>2]=o;x2(b,l,k[n>>2]&4095,0);o=a+104|0;l=k[a+144>>2]|0;a=k[l>>2]|0;k[m>>2]=k[l+4>>2];k[m+4>>2]=a;x2(c,m,k[o>>2]&4095,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[p>>2]=k[h>>2];a=p+4|0;e=h+4|0;k[a>>2]=k[e>>2];m=p+8|0;k[m>>2]=k[h+8>>2];k[p+12>>2]=k[h+12>>2];k[p+16>>2]=k[h+16>>2];k[p+20>>2]=k[h+20>>2];k[p+24>>2]=k[h+24>>2];k[p+28>>2]=k[h+28>>2];k[p+32>>2]=k[h+32>>2];d=k[h+36>>2]|0;k[p+36>>2]=d;f=p+40|0;k[f>>2]=m;m=p+48|0;j=p+44|0;k[j>>2]=m;k[p+52>>2]=0;k[m>>2]=0;if(d|0){m=d+12|0;k[m>>2]=(k[m>>2]|0)+1}if((k[e>>2]|0)<3){b=k[h+44>>2]|0;m=k[j>>2]|0;k[m>>2]=k[b>>2];k[m+4>>2]=k[b+4>>2];break}k[a>>2]=0;x1(p,k[e>>2]|0,0,0,0);if((k[a>>2]|0)>0){l=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;e=k[j>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[a>>2]|0))}}else Q1(p,b,-1);while(0);KG(p,n)|0;f=p+36|0;d=k[f>>2]|0;if(d|0?(m=d+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[p+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;n=p+16|0;e=p+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[e>>2]|0)>0){f=k[p+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[p+44>>2]|0;if(!((d|0)==(p+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[q>>2]=k[g>>2];a=q+4|0;d=g+4|0;k[a>>2]=k[d>>2];p=q+8|0;k[p>>2]=k[g+8>>2];k[q+12>>2]=k[g+12>>2];k[q+16>>2]=k[g+16>>2];k[q+20>>2]=k[g+20>>2];k[q+24>>2]=k[g+24>>2];k[q+28>>2]=k[g+28>>2];k[q+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[q+36>>2]=e;f=q+40|0;k[f>>2]=p;p=q+48|0;j=q+44|0;k[j>>2]=p;k[q+52>>2]=0;k[p>>2]=0;if(e|0){p=e+12|0;k[p>>2]=(k[p>>2]|0)+1}if((k[d>>2]|0)<3){c=k[g+44>>2]|0;p=k[j>>2]|0;k[p>>2]=k[c>>2];k[p+4>>2]=k[c+4>>2];break}k[a>>2]=0;x1(q,k[d>>2]|0,0,0,0);if((k[a>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[a>>2]|0))}}else Q1(q,c,-1);while(0);KG(q,o)|0;f=q+36|0;d=k[f>>2]|0;if(d|0?(c=d+12|0,p=k[c>>2]|0,k[c>>2]=p+-1,(p|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[q+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;p=q+16|0;e=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[e>>2]|0)>0){f=k[q+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[q+44>>2]|0;if((d|0)==(q+48|0)|(d|0)==0){r=s;return}ggb(k[d+-4>>2]|0);r=s;return}function U_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if((b|0)>0){j=a+28|0;k[j>>2]=b;r=g;return}d=c+4|0;e=ZT(20)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=13;i[e+17>>0]=0;h=392018;j=f+13|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-215,c,392032,392046,133);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);j=a+28|0;k[j>>2]=b;r=g;return}function V_a(a){a=a|0;return k[a+28>>2]|0}function W_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=a+40|0;e=k[b>>2]|0;c=k[b+4>>2]|0;if(e|0){b=e+4|0;k[b>>2]=(k[b>>2]|0)+1}b=k[d>>2]|0;k[d>>2]=e;k[a+44>>2]=c;if(!b)return;d=b+4|0;e=k[d>>2]|0;k[d>>2]=e+-1;if((e|0)!=1)return;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);return}function X_a(a,b){a=a|0;b=b|0;var c=0;c=k[b+40>>2]|0;k[a>>2]=c;k[a+4>>2]=k[b+44>>2];if(!c)return;c=c+4|0;k[c>>2]=(k[c>>2]|0)+1;return}function Y_a(a,b){a=a|0;b=+b;o[a+172>>2]=b;return}function Z_a(a){a=a|0;return +(+o[a+172>>2])}function __a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=a+32|0;e=k[b>>2]|0;c=k[b+4>>2]|0;if(e|0){b=e+4|0;k[b>>2]=(k[b>>2]|0)+1}b=k[d>>2]|0;k[d>>2]=e;k[a+36>>2]=c;if(!b)return;d=b+4|0;e=k[d>>2]|0;k[d>>2]=e+-1;if((e|0)!=1)return;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);return}function $_a(a,b){a=a|0;b=b|0;var c=0;c=k[b+32>>2]|0;k[a>>2]=c;k[a+4>>2]=k[b+36>>2];if(!c)return;c=c+4|0;k[c>>2]=(k[c>>2]|0)+1;return}function a$a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,j=0,l=0,m=0.0,n=0,q=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;Ga=r;r=r+1088|0;ia=Ga+704|0;ja=Ga+480|0;ba=Ga+1024|0;_=Ga+1008|0;$=Ga+952|0;Z=Ga;ca=Ga+896|0;ya=Ga+840|0;n=Ga+256|0;xa=Ga+784|0;q=Ga+32|0;sa=Ga+772|0;la=Ga+760|0;k[ca>>2]=k[b>>2];Da=ca+4|0;g=b+4|0;f=k[g>>2]|0;k[Da>>2]=f;da=ca+8|0;k[da>>2]=k[b+8>>2];ha=ca+12|0;k[ha>>2]=k[b+12>>2];Aa=ca+16|0;k[Aa>>2]=k[b+16>>2];ea=ca+20|0;k[ea>>2]=k[b+20>>2];fa=ca+24|0;k[fa>>2]=k[b+24>>2];ga=ca+28|0;k[ga>>2]=k[b+28>>2];za=ca+32|0;k[za>>2]=k[b+32>>2];Ba=ca+36|0;h=k[b+36>>2]|0;k[Ba>>2]=h;Ca=ca+40|0;k[Ca>>2]=da;Fa=ca+48|0;Ea=ca+44|0;k[Ea>>2]=Fa;k[ca+52>>2]=0;k[Fa>>2]=0;if(h){f=h+12|0;k[f>>2]=(k[f>>2]|0)+1;f=k[g>>2]|0}if((f|0)>=3){k[Da>>2]=0;x1(ca,f,0,0,0);if((k[Da>>2]|0)>0){j=k[b+40>>2]|0;l=k[Ca>>2]|0;g=k[b+44>>2]|0;h=k[Ea>>2]|0;f=0;do{k[l+(f<<2)>>2]=k[j+(f<<2)>>2];k[h+(f<<2)>>2]=k[g+(f<<2)>>2];f=f+1|0}while((f|0)<(k[Da>>2]|0))}}else{va=k[b+44>>2]|0;wa=k[Ea>>2]|0;k[wa>>2]=k[va>>2];k[wa+4>>2]=k[va+4>>2]}h=k[ha>>2]|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=1124007936;f=n+16|0;g=n+48|0;l=n+12|0;b=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[g>>2]=f;f=n+56|0;k[n+52>>2]=f;k[n+60>>2]=0;k[f>>2]=0;k[n+64>>2]=1124007936;f=n+72|0;g=n+104|0;l=n+68|0;b=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[g>>2]=f;f=n+112|0;k[n+108>>2]=f;k[n+116>>2]=0;k[f>>2]=0;k[n+120>>2]=1124007936;f=n+128|0;g=n+160|0;l=n+124|0;b=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[g>>2]=f;l=n+168|0;k[n+164>>2]=l;b=l+56|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[ia>>2]=h;k[ia+4>>2]=h;j1(n,48,ia,5);k[ya>>2]=1124007936;ua=ya+4|0;v=ya+8|0;ta=ya+40|0;l=ua;b=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[ta>>2]=v;wa=ya+48|0;va=ya+44|0;k[va>>2]=wa;k[ya+52>>2]=0;k[wa>>2]=0;h=k[n>>2]|0;dh[k[(k[h>>2]|0)+12>>2]&255](h,n,ya,-1);XN(n);h=k[ha>>2]|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=1124007936;f=q+16|0;g=q+48|0;l=q+12|0;b=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[g>>2]=f;f=q+56|0;k[q+52>>2]=f;k[q+60>>2]=0;k[f>>2]=0;k[q+64>>2]=1124007936;f=q+72|0;g=q+104|0;l=q+68|0;b=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[g>>2]=f;f=q+112|0;k[q+108>>2]=f;k[q+116>>2]=0;k[f>>2]=0;k[q+120>>2]=1124007936;f=q+128|0;g=q+160|0;l=q+124|0;b=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[g>>2]=f;l=q+168|0;k[q+164>>2]=l;b=l+56|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[ia>>2]=h;k[ia+4>>2]=h;j1(q,48,ia,5);k[xa>>2]=1124007936;qa=xa+4|0;f=xa+8|0;oa=xa+40|0;l=qa;b=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[oa>>2]=f;ra=xa+48|0;pa=xa+44|0;k[pa>>2]=ra;k[xa+52>>2]=0;k[ra>>2]=0;na=k[q>>2]|0;dh[k[(k[na>>2]|0)+12>>2]&255](na,q,xa,-1);XN(q);k[sa>>2]=0;na=sa+4|0;k[na>>2]=0;k[sa+8>>2]=0;k[la>>2]=0;ma=la+4|0;k[ma>>2]=0;k[la+8>>2]=0;t=+Pfb(+p[a+8>>3]);u=+Pfb(+p[a+16>>3])-t;ka=a+4|0;g=k[ka>>2]|0;u=u/+(g+-1|0);a:do if((g|0)>0){l=sa+8|0;s=0.0;f=0;h=0;j=0;while(1){m=+R(10.0,+(t+s));p[ia>>3]=m;if((h|0)==(j|0)){Koa(sa,ia);g=k[ka>>2]|0}else{p[h>>3]=m;k[na>>2]=h+8}f=f+1|0;if((f|0)>=(g|0))break a;s=u+s;h=k[na>>2]|0;j=k[l>>2]|0}}while(0);g=k[a>>2]|0;s=6.283185307179586/+(g|0);p[ia>>3]=0.0;b:do if((g|0)>0){l=la+8|0;f=0;m=0.0;h=0;j=0;while(1){m=s+m;p[ia>>3]=m;if((h|0)==(j|0)){Koa(la,ia);g=k[a>>2]|0}else{p[h>>3]=m;k[ma>>2]=h+8}f=f+1|0;if((f|0)>=(g|0))break b;h=k[ma>>2]|0;j=k[l>>2]|0}}while(0);k[ja>>2]=k[ca>>2];V=ja+4|0;f=k[Da>>2]|0;k[V>>2]=f;X=ja+8|0;k[X>>2]=k[da>>2];O=ja+12|0;k[O>>2]=k[ha>>2];S=ja+16|0;k[S>>2]=k[Aa>>2];k[ja+20>>2]=k[ea>>2];k[ja+24>>2]=k[fa>>2];k[ja+28>>2]=k[ga>>2];Q=ja+32|0;k[Q>>2]=k[za>>2];T=ja+36|0;g=k[Ba>>2]|0;k[T>>2]=g;U=ja+40|0;k[U>>2]=X;X=ja+48|0;W=ja+44|0;k[W>>2]=X;k[ja+52>>2]=0;k[X>>2]=0;if(g){f=g+12|0;k[f>>2]=(k[f>>2]|0)+1;f=k[Da>>2]|0}if((f|0)>=3){k[V>>2]=0;x1(ja,f,0,0,0);if((k[V>>2]|0)>0){g=k[Ca>>2]|0;h=k[U>>2]|0;j=k[Ea>>2]|0;l=k[W>>2]|0;f=0;do{k[h+(f<<2)>>2]=k[g+(f<<2)>>2];k[l+(f<<2)>>2]=k[j+(f<<2)>>2];f=f+1|0}while((f|0)<(k[V>>2]|0))}}else{N=k[Ea>>2]|0;P=k[W>>2]|0;k[P>>2]=k[N>>2];k[P+4>>2]=k[N+4>>2]}g=k[v>>2]|0;h=k[ya+12>>2]|0;k[ba>>2]=1124007936;P=ba+4|0;f=ba+8|0;M=ba+40|0;l=P;b=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[M>>2]=f;N=ba+48|0;L=ba+44|0;k[L>>2]=N;k[ba+52>>2]=0;k[N>>2]=0;k[ia>>2]=g;K=ia+4|0;k[K>>2]=h;G1(ba,2,ia,0);f=k[O>>2]|0;if((f|0)>0){l=$+4|0;b=$+8|0;n=$+12|0;q=$+16|0;v=$+20|0;w=$+24|0;x=$+32|0;y=$+36|0;z=$+40|0;A=$+48|0;B=$+44|0;C=$+52|0;D=_+8|0;E=_+12|0;F=_+4|0;G=ya+16|0;H=e<0.0;I=d+4|0;J=ba+16|0;j=0;do{if((f|0)>0){h=0;do{f=k[S>>2]|0;m=+o[f+(j<<3)>>2];t=+o[f+(j<<3)+4>>2];s=+o[f+(h<<3)>>2];u=+o[f+(h<<3)+4>>2];k[$>>2]=1124024325;k[l>>2]=2;k[b>>2]=2;k[n>>2]=1;k[q>>2]=0;k[v>>2]=0;k[w>>2]=0;k[x>>2]=0;k[y>>2]=0;k[z>>2]=b;k[B>>2]=A;k[C>>2]=0;k[A>>2]=0;k[ia>>2]=2;k[K>>2]=1;G1($,2,ia,5);f=k[q>>2]|0;o[f>>2]=m-s;o[f+4>>2]=t-u;k[D>>2]=0;k[E>>2]=0;k[_>>2]=16842752;k[F>>2]=$;u=+N7(_,4,49332);f=(k[G>>2]|0)+(aa(k[k[va>>2]>>2]|0,j)|0)+(h<<2)|0;o[f>>2]=u;f=k[y>>2]|0;if(f|0?(f=f+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){g=k[y>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[x>>2]|0;if(!f){f=B1()|0;g=k[y>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[y>>2]=0}k[y>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[l>>2]|0)>0){g=k[z>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[l>>2]|0))}f=k[B>>2]|0;if(!((f|0)==(A|0)|(f|0)==0))ggb(k[f+-4>>2]|0);do if(H){g=k[d>>2]|0;f=g;if((k[I>>2]|0)==(g|0)){g=(k[J>>2]|0)+(aa(k[k[L>>2]>>2]|0,j)|0)+h|0;i[g>>0]=1;break}if(!(k[f+(h<<2)>>2]|0))f=0;else f=(k[f+(j<<2)>>2]|0)!=0;g=(k[J>>2]|0)+(aa(k[k[L>>2]>>2]|0,j)|0)+h|0;i[g>>0]=f&1}while(0);h=h+1|0;f=k[O>>2]|0}while((h|0)<(f|0))}j=j+1|0}while((j|0)<(f|0))}if(e<0.0){k[ia+8>>2]=0;k[ia+12>>2]=0;k[ia>>2]=16842752;k[ia+4>>2]=ya;k[_+8>>2]=0;k[_+12>>2]=0;k[_>>2]=16842752;k[_+4>>2]=ba;u7(Z,ia,_);e=+p[Z>>3];o[a+28>>2]=e}else o[a+28>>2]=e;h=ia+4|0;f=h+4|0;k[f>>2]=0;k[f+4>>2]=0;k[ia>>2]=33619968;k[h>>2]=ya;SW(ya,ia,-1,1.0/(e+1.1920928955078125e-07),0.0);h=ba+36|0;f=k[h>>2]|0;if(f|0?(_=f+12|0,$=k[_>>2]|0,k[_>>2]=$+-1,($|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[ba+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;ba=ba+16|0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[P>>2]|0)>0){g=k[M>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[P>>2]|0))}f=k[L>>2]|0;if(!((f|0)==(N|0)|(f|0)==0))ggb(k[f+-4>>2]|0);f=k[T>>2]|0;if(f|0?($=f+12|0,ba=k[$>>2]|0,k[$>>2]=ba+-1,(ba|0)==1):0){g=k[T>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[Q>>2]|0;if(!f){f=B1()|0;g=k[T>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[T>>2]=0}k[T>>2]=0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[V>>2]|0)>0){g=k[U>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[V>>2]|0))}f=k[W>>2]|0;if(!((f|0)==(X|0)|(f|0)==0))ggb(k[f+-4>>2]|0);k[ia>>2]=k[ca>>2];D=ia+4|0;f=k[Da>>2]|0;k[D>>2]=f;C=ia+8|0;k[C>>2]=k[da>>2];b=ia+12|0;k[b>>2]=k[ha>>2];B=ia+16|0;k[B>>2]=k[Aa>>2];k[ia+20>>2]=k[ea>>2];k[ia+24>>2]=k[fa>>2];k[ia+28>>2]=k[ga>>2];x=ia+32|0;k[x>>2]=k[za>>2];y=ia+36|0;g=k[Ba>>2]|0;k[y>>2]=g;z=ia+40|0;k[z>>2]=C;C=ia+48|0;A=ia+44|0;k[A>>2]=C;k[ia+52>>2]=0;k[C>>2]=0;if(g){f=g+12|0;k[f>>2]=(k[f>>2]|0)+1;f=k[Da>>2]|0}if((f|0)>=3){k[D>>2]=0;x1(ia,f,0,0,0);if((k[D>>2]|0)>0){g=k[Ca>>2]|0;h=k[z>>2]|0;j=k[Ea>>2]|0;l=k[A>>2]|0;f=0;do{k[h+(f<<2)>>2]=k[g+(f<<2)>>2];k[l+(f<<2)>>2]=k[j+(f<<2)>>2];f=f+1|0}while((f|0)<(k[D>>2]|0))}}else{fa=k[Ea>>2]|0;ga=k[A>>2]|0;k[ga>>2]=k[fa>>2];k[ga+4>>2]=k[fa+4>>2]}w=(i[a+24>>0]|0)==0;v=k[b>>2]|0;if(w){s=0.0;m=0.0}else{if((v|0)>0){g=k[B>>2]|0;f=0;e=0.0;m=0.0;do{e=e+ +o[g+(f<<3)>>2];m=m+ +o[g+(f<<3)+4>>2];f=f+1|0}while((f|0)!=(v|0))}else{e=0.0;m=0.0}u=+(v|0);s=e/u;m=m/u}if((v|0)>0){l=k[xa+16>>2]|0;b=k[pa>>2]|0;n=k[B>>2]|0;g=0;do{h=n+(g<<3)|0;j=n+(g<<3)+4|0;f=0;do{if((g|0)==(f|0)){ga=l+(aa(k[b>>2]|0,g)|0)+(g<<2)|0;o[ga>>2]=0.0}else{e=+Y(+(+o[j>>2]-+o[n+(f<<3)+4>>2]),+(+o[h>>2]-+o[n+(f<<3)>>2]));q=l+(aa(k[b>>2]|0,g)|0)+(f<<2)|0;o[q>>2]=e;if(!w){e=e-+Y(+(+o[j>>2]-m),+(+o[h>>2]-s));o[q>>2]=e}u=+Lfb(e+1.1920928955078125e-07,6.283185307179586)+3.141592653589793;o[q>>2]=u}f=f+1|0}while((f|0)!=(v|0));g=g+1|0}while((g|0)!=(v|0))}f=k[y>>2]|0;do if(f|0){fa=f+12|0;ga=k[fa>>2]|0;k[fa>>2]=ga+-1;if((ga|0)!=1)break;g=k[y>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[x>>2]|0;if(f|0)break;f=B1()|0;g=k[y>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[y>>2]=0}while(0);k[y>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[D>>2]|0)>0){g=k[z>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[D>>2]|0))}f=k[A>>2]|0;if(!((f|0)==(C|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=k[ha>>2]|0;j=aa(k[ka>>2]|0,k[a>>2]|0)|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=1124007936;f=ja+16|0;g=ja+48|0;l=ja+12|0;b=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[g>>2]=f;f=ja+56|0;k[ja+52>>2]=f;k[ja+60>>2]=0;k[f>>2]=0;k[ja+64>>2]=1124007936;f=ja+72|0;g=ja+104|0;l=ja+68|0;b=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[g>>2]=f;f=ja+112|0;k[ja+108>>2]=f;k[ja+116>>2]=0;k[f>>2]=0;k[ja+120>>2]=1124007936;f=ja+128|0;g=ja+160|0;l=ja+124|0;b=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[g>>2]=f;l=ja+168|0;k[ja+164>>2]=l;b=l+56|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(b|0));k[ia>>2]=j;k[ia+4>>2]=h;j1(ja,48,ia,5);D=k[ja>>2]|0;dh[k[(k[D>>2]|0)+12>>2]&255](D,ja,c,-1);XN(ja);D=k[ha>>2]|0;if((D|0)>0){z=k[d>>2]|0;A=((k[d+4>>2]|0)-z|0)>0;B=k[xa+16>>2]|0;C=k[pa>>2]|0;f=k[la>>2]|0;y=k[c+16>>2]|0;q=k[c+44>>2]|0;v=k[ya+16>>2]|0;w=k[va>>2]|0;x=k[sa>>2]|0;n=0;do{b=z+(n<<2)|0;if(A){l=0;do{c:do if((n|0)!=(l|0)){if(!(k[b>>2]|0))break;if(!(k[z+(l<<2)>>2]|0))break;h=k[ka>>2]|0;d:do if((h|0)>0){g=v+(aa(k[w>>2]|0,n)|0)+(l<<2)|0;e=+o[g>>2];g=0;while(1){if(e<+p[x+(g<<3)>>3])break d;g=g+1|0;if((g|0)>=(h|0)){g=-1;break}}}else g=-1;while(0);j=k[a>>2]|0;if((j|0)<=0)break;h=B+(aa(k[C>>2]|0,n)|0)+(l<<2)|0;e=+o[h>>2];h=0;while(1){if(e<+p[f+(h<<3)>>3])break;h=h+1|0;if((h|0)>=(j|0))break c}if(!((g|0)!=-1&(h|0)!=-1))break;c=(aa(j,g)|0)+h|0;c=y+(aa(k[q>>2]|0,n)|0)+(c<<2)|0;o[c>>2]=+o[c>>2]+1.0}while(0);l=l+1|0}while((l|0)!=(D|0))}else{l=0;do{e:do if((n|0)!=(l|0)){h=k[ka>>2]|0;f:do if((h|0)>0){g=v+(aa(k[w>>2]|0,n)|0)+(l<<2)|0;e=+o[g>>2];g=0;while(1){if(e<+p[x+(g<<3)>>3])break f;g=g+1|0;if((g|0)>=(h|0)){g=-1;break}}}else g=-1;while(0);j=k[a>>2]|0;if((j|0)<=0)break;h=B+(aa(k[C>>2]|0,n)|0)+(l<<2)|0;e=+o[h>>2];h=0;while(1){if(e<+p[f+(h<<3)>>3])break;h=h+1|0;if((h|0)>=(j|0))break e}if(!((g|0)!=-1&(h|0)!=-1))break;c=(aa(j,g)|0)+h|0;c=y+(aa(k[q>>2]|0,n)|0)+(c<<2)|0;o[c>>2]=+o[c>>2]+1.0}while(0);l=l+1|0}while((l|0)!=(D|0))}n=n+1|0}while((n|0)!=(D|0))}else f=k[la>>2]|0;g=f;if(f|0){h=k[ma>>2]|0;if((h|0)!=(f|0))k[ma>>2]=h+(~((h+-8-g|0)>>>3)<<3);ggb(f)}f=k[sa>>2]|0;g=f;if(f|0){h=k[na>>2]|0;if((h|0)!=(f|0))k[na>>2]=h+(~((h+-8-g|0)>>>3)<<3);ggb(f)}h=xa+36|0;f=k[h>>2]|0;do if(f|0){a=f+12|0;sa=k[a>>2]|0;k[a>>2]=sa+-1;if((sa|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[xa+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;xa=xa+16|0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[qa>>2]|0)>0){g=k[oa>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[qa>>2]|0))}f=k[pa>>2]|0;if(!((f|0)==(ra|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=ya+36|0;f=k[h>>2]|0;do if(f|0){sa=f+12|0;xa=k[sa>>2]|0;k[sa>>2]=xa+-1;if((xa|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[ya+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;ya=ya+16|0;k[ya>>2]=0;k[ya+4>>2]=0;k[ya+8>>2]=0;k[ya+12>>2]=0;if((k[ua>>2]|0)>0){g=k[ta>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[ua>>2]|0))}f=k[va>>2]|0;if(!((f|0)==(wa|0)|(f|0)==0))ggb(k[f+-4>>2]|0);f=k[Ba>>2]|0;do if(f|0){xa=f+12|0;ya=k[xa>>2]|0;k[xa>>2]=ya+-1;if((ya|0)!=1)break;g=k[Ba>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[za>>2]|0;if(f|0)break;f=B1()|0;g=k[Ba>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[Ba>>2]=0}while(0);k[Ba>>2]=0;k[Aa>>2]=0;k[Aa+4>>2]=0;k[Aa+8>>2]=0;k[Aa+12>>2]=0;if((k[Da>>2]|0)>0){g=k[Ca>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[Da>>2]|0))}f=k[Ea>>2]|0;if((f|0)==(Fa|0)|(f|0)==0){r=Ga;return}ggb(k[f+-4>>2]|0);r=Ga;return}function b$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function c$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;e=h;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=h;return a|0}f=a+32|0;if((k[f>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[e>>2]=g;k[c>>2]=30;i[d+34>>0]=0;j=401220;l=g+30|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}D6(a,a+12|0,b);if(!(k[f>>2]&4)){r=h;return a|0}k[f>>2]=6;r=h;return a|0}function d$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+o[b>>2]);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function e$a(a){a=a|0;ggb(a);return}function f$a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function g$a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=149800;d=a+132|0;b=k[d>>2]|0;k[a+136>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+112|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+108>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+92|0;c=a+80|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+116>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+120>>2]|0;if(!((b|0)==(a+124|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+56|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+52>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+36|0;c=a+24|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+60>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+64>>2]|0;if((b|0)==(a+68|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function h$a(a){a=a|0;g$a(a);ggb(a);return}function i$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;h=j+4|0;g=ZT(12)|0;k[g>>2]=1;c=g+4|0;k[j>>2]=c;k[h>>2]=4;i[g+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,j)|0;c=k[j>>2]|0;k[h>>2]=0;k[j>>2]=0;if(c|0?(g=c+-4|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+132|0)|0;c=j+4|0;f=ZT(20)|0;k[f>>2]=1;e=f+4|0;k[j>>2]=e;k[c>>2]=14;i[f+18>>0]=0;f=392942;g=e+14|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));h=z6(b,j)|0;b=k[j>>2]|0;k[c>>2]=0;k[j>>2]=0;if(b|0?(f=b+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[b+-8>>2]|0);a=a+8|0;if(!(Xh[k[(k[h>>2]|0)+12>>2]&1023](h)|0)){r=l;return}d=h+32|0;if((k[d>>2]|0)==6){b=j+4|0;c=ZT(36)|0;k[c>>2]=1;e=c+4|0;k[j>>2]=e;k[b>>2]=30;i[c+34>>0]=0;f=401220;g=e+30|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-2,j,401251,401262,1064);k[b>>2]=0;k[j>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0)}if(!(k[h+16>>2]|0))b=0;else{b=k[h+12>>2]|0;b=(b|0)==0?1016759:b}u6(k[h+8>>2]|0,b,+p[a>>3]);if(!(k[d>>2]&4)){r=l;return}k[d>>2]=6;r=l;return}function j$a(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;l=n;m=b+4|0;h=k6(k[b>>2]|0,k[m>>2]|0,401026)|0;k[l>>2]=0;j=l+4|0;k[j>>2]=0;J6(h,l,l);h=k[l>>2]|0;d=k[a+132>>2]|0;if((h|0)==(d|0)){k[j>>2]=0;k[l>>2]=0;if(h|0?(j=h+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[h+-8>>2]|0)}else{f=(h|0)==0?1016759:h;e=(d|0)==0?1016759:d;d=i[f>>0]|0;g=i[e>>0]|0;if(d<<24>>24==0?1:d<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;d=i[f>>0]|0;g=i[e>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=g<<24>>24));e=g}d=d<<24>>24==e<<24>>24;k[j>>2]=0;k[l>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!d){d=l+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[l>>2]=f;k[d>>2]=27;i[e+31>>0]=0;g=401031;h=f+27|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,l,401059,392683,90);k[d>>2]=0;k[l>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}}d=k6(k[b>>2]|0,k[m>>2]|0,392942)|0;if(!d){m=0;c=+(m|0);a=a+8|0;p[a>>3]=c;r=n;return}switch(k[d>>2]&7){case 1:{m=k[d+8>>2]|0;c=+(m|0);a=a+8|0;p[a>>3]=c;r=n;return}case 2:{c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;m=d&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}m=~~c;c=+(m|0);a=a+8|0;p[a>>3]=c;r=n;return}default:{m=2147483647;c=+(m|0);a=a+8|0;p[a>>3]=c;r=n;return}}}function k$a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0;la=r;r=r+1808|0;L=la+1752|0;ka=la+1696|0;ja=la+1640|0;ia=la+1624|0;ha=la+1568|0;ga=la+1512|0;fa=la+1456|0;da=la+1400|0;Z=la+1344|0;u=la+896|0;X=la+1288|0;S=la+1232|0;R=la+1176|0;z=la+672|0;G=la+1120|0;D=la+224|0;E=la+448|0;F=la;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[ka>>2]=k[g>>2];m=ka+4|0;b=g+4|0;k[m>>2]=k[b>>2];ea=ka+8|0;k[ea>>2]=k[g+8>>2];k[ka+12>>2]=k[g+12>>2];k[ka+16>>2]=k[g+16>>2];k[ka+20>>2]=k[g+20>>2];k[ka+24>>2]=k[g+24>>2];k[ka+28>>2]=k[g+28>>2];k[ka+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[ka+36>>2]=e;f=ka+40|0;k[f>>2]=ea;ea=ka+48|0;j=ka+44|0;k[j>>2]=ea;k[ka+52>>2]=0;k[ea>>2]=0;if(e|0){ea=e+12|0;k[ea>>2]=(k[ea>>2]|0)+1}if((k[b>>2]|0)<3){ca=k[g+44>>2]|0;ea=k[j>>2]|0;k[ea>>2]=k[ca>>2];k[ea+4>>2]=k[ca+4>>2];break}k[m>>2]=0;x1(ka,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(ka,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[ja>>2]=k[h>>2];m=ja+4|0;e=h+4|0;k[m>>2]=k[e>>2];ea=ja+8|0;k[ea>>2]=k[h+8>>2];k[ja+12>>2]=k[h+12>>2];k[ja+16>>2]=k[h+16>>2];k[ja+20>>2]=k[h+20>>2];k[ja+24>>2]=k[h+24>>2];k[ja+28>>2]=k[h+28>>2];k[ja+32>>2]=k[h+32>>2];b=k[h+36>>2]|0;k[ja+36>>2]=b;f=ja+40|0;k[f>>2]=ea;ea=ja+48|0;j=ja+44|0;k[j>>2]=ea;k[ja+52>>2]=0;k[ea>>2]=0;if(b|0){ea=b+12|0;k[ea>>2]=(k[ea>>2]|0)+1}if((k[e>>2]|0)<3){ca=k[h+44>>2]|0;ea=k[j>>2]|0;k[ea>>2]=k[ca>>2];k[ea+4>>2]=k[ca+4>>2];break}k[m>>2]=0;x1(ja,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;e=k[j>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(ja,c,-1);while(0);if(!((((k[ka>>2]&4088|0)==8?(k[ka+12>>2]|0)>0:0)?(k[ja>>2]&4088|0)==8:0)?(k[ja+12>>2]|0)>0:0)){k[L>>2]=0;b=L+4|0;k[b>>2]=0;e=ZT(84)|0;k[e>>2]=1;g=e+4|0;k[L>>2]=g;k[b>>2]=78;i[e+82>>0]=0;f=392822;h=g+78|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,L,392901,392683,193);k[b>>2]=0;k[L>>2]=0;ea=k[e>>2]|0;k[e>>2]=ea+-1;if((ea|0)==1)ggb(k[e+-4>>2]|0)}l=d+4|0;if((k[l>>2]|0)-(k[d>>2]|0)>>4>>>0<=1){k[L>>2]=0;b=L+4|0;k[b>>2]=0;e=ZT(24)|0;k[e>>2]=1;g=e+4|0;k[L>>2]=g;k[b>>2]=17;i[e+21>>0]=0;f=392924;h=g+17|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,L,392901,392683,194);k[b>>2]=0;k[L>>2]=0;ea=k[e>>2]|0;k[e>>2]=ea+-1;if((ea|0)==1)ggb(k[e+-4>>2]|0)}if((k[ka>>2]&4095|0)!=5){ea=L+4|0;ca=ea+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[L>>2]=33619968;k[ea>>2]=ka;SW(ka,L,5,1.0,0.0)}if((k[ja>>2]&4095|0)!=5){ea=L+4|0;ca=ea+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[L>>2]=33619968;k[ea>>2]=ja;SW(ja,L,5,1.0,0.0)}k[ia>>2]=0;ea=ia+4|0;k[ea>>2]=0;k[ia+8>>2]=0;b=k[d>>2]|0;if((k[l>>2]|0)==(b|0)){s=ia;t=ea;b=0;e=0}else{g=ka+12|0;h=ja+12|0;j=ia+8|0;f=0;do{ca=b;b=ca+(f<<4)|0;do if((k[b>>2]|0)<(k[g>>2]|0)?(k[ca+(f<<4)+4>>2]|0)<(k[h>>2]|0):0){e=k[ea>>2]|0;if((e|0)==(k[j>>2]|0)){I6(ia,b);break}else{k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2];k[e+12>>2]=k[b+12>>2];k[ea>>2]=e+16;break}}while(0);f=f+1|0;b=k[d>>2]|0}while(f>>>0<(k[l>>2]|0)-b>>4>>>0);s=ia;t=ea;b=k[ia>>2]|0;e=k[ea>>2]|0}e=e-b>>4;k[ha>>2]=1124007936;ba=ha+4|0;b=ha+8|0;Y=ha+40|0;g=ba;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Y>>2]=b;ca=ha+48|0;$=ha+44|0;k[$>>2]=ca;k[ha+52>>2]=0;k[ca>>2]=0;k[L>>2]=e;d=L+4|0;k[d>>2]=2;G1(ha,2,L,5);e=(k[t>>2]|0)-(k[s>>2]|0)>>4;k[ga>>2]=1124007936;V=ga+4|0;b=ga+8|0;T=ga+40|0;g=V;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[T>>2]=b;W=ga+48|0;U=ga+44|0;k[U>>2]=W;k[ga+52>>2]=0;k[W>>2]=0;k[L>>2]=e;k[d>>2]=2;G1(ga,2,L,5);f=k[s>>2]|0;Q=(k[t>>2]|0)-f|0;e=Q>>4;if((Q|0)>0){g=k[ka+16>>2]|0;h=k[ha+16>>2]|0;j=k[k[$>>2]>>2]|0;l=k[ja+16>>2]|0;m=k[ga+16>>2]|0;c=k[k[U>>2]>>2]|0;b=0;do{Q=k[f+(b<<4)>>2]|0;O=k[g+(Q<<3)+4>>2]|0;N=h+(aa(j,b)|0)|0;k[N>>2]=k[g+(Q<<3)>>2];k[N+4>>2]=O;N=k[f+(b<<4)+4>>2]|0;O=k[l+(N<<3)+4>>2]|0;Q=m+(aa(c,b)|0)|0;k[Q>>2]=k[l+(N<<3)>>2];k[Q+4>>2]=O;b=b+1|0}while((b|0)<(e|0))}e=L+4|0;O=e+4|0;k[O>>2]=0;k[O+4>>2]=0;k[L>>2]=33619968;k[e>>2]=a+76;mY(ha,L);e=(k[t>>2]|0)-(k[s>>2]|0)>>4;k[fa>>2]=1124007936;O=fa+4|0;b=fa+8|0;M=fa+40|0;g=O;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[M>>2]=b;Q=fa+48|0;N=fa+44|0;k[N>>2]=Q;k[fa+52>>2]=0;k[Q>>2]=0;k[L>>2]=e;k[d>>2]=e;G1(fa,2,L,5);e=(k[t>>2]|0)-(k[s>>2]|0)>>4;k[da>>2]=1124007936;J=da+4|0;b=da+8|0;H=da+40|0;g=J;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[H>>2]=b;K=da+48|0;I=da+44|0;k[I>>2]=K;k[da+52>>2]=0;k[K>>2]=0;k[L>>2]=e;k[d>>2]=3;G1(da,2,L,5);C=(k[t>>2]|0)-(k[s>>2]|0)|0;f=C>>4;if((C|0)>0){g=k[da+16>>2]|0;h=k[k[I>>2]>>2]|0;j=k[ha+16>>2]|0;l=k[k[$>>2]>>2]|0;m=a+8|0;c=k[fa+16>>2]|0;d=k[N>>2]|0;b=0;do{n=j+(aa(l,b)|0)|0;q=n+4|0;e=0;do{if((b|0)==(e|0)){C=c+(aa(k[d>>2]|0,b)|0)+(b<<2)|0;o[C>>2]=+p[m>>3]}else{C=j+(aa(l,e)|0)|0;na=+o[n>>2]-+o[C>>2];ma=+o[q>>2]-+o[C+4>>2];ma=na*na+ma*ma;ma=+_(+(ma+1.1920928955078125e-07))*ma;C=c+(aa(k[d>>2]|0,b)|0)+(e<<2)|0;o[C>>2]=ma}e=e+1|0}while((e|0)<(f|0));C=g+(aa(h,b)|0)|0;o[C>>2]=1.0;k[C+4>>2]=k[n>>2];k[C+8>>2]=k[q>>2];b=b+1|0}while((b|0)<(f|0))}f=f+3|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=1124007936;b=u+16|0;e=u+48|0;g=u+12|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[e>>2]=b;b=u+56|0;k[u+52>>2]=b;k[u+60>>2]=0;k[b>>2]=0;k[u+64>>2]=1124007936;b=u+72|0;e=u+104|0;g=u+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[e>>2]=b;b=u+112|0;k[u+108>>2]=b;k[u+116>>2]=0;k[b>>2]=0;k[u+120>>2]=1124007936;b=u+128|0;e=u+160|0;g=u+124|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[e>>2]=b;g=u+168|0;k[u+164>>2]=g;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[L>>2]=f;k[L+4>>2]=f;j1(u,48,L,5);k[Z>>2]=1124007936;B=Z+4|0;b=Z+8|0;y=Z+40|0;g=B;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[y>>2]=b;C=Z+48|0;A=Z+44|0;k[A>>2]=C;k[Z+52>>2]=0;k[C>>2]=0;f=k[u>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,u,Z,-1);XN(u);f=(k[t>>2]|0)-(k[s>>2]|0)>>4;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=f;k[L+12>>2]=f;I1(X,Z,L);f=L+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[L>>2]=33619968;k[f>>2]=X;mY(fa,L);f=(k[t>>2]|0)-(k[s>>2]|0)>>4;k[S>>2]=f;k[S+4>>2]=0;k[S+8>>2]=3;k[S+12>>2]=f;I1(L,Z,S);KG(X,L)|0;f=L+36|0;b=k[f>>2]|0;if(b|0?(w=b+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[L+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;x=L+16|0;e=L+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[e>>2]|0)>0){f=k[L+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[L+44>>2]|0;if(!((b|0)==(L+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);w=L+4|0;b=w+4|0;k[b>>2]=0;k[b+4>>2]=0;k[L>>2]=33619968;k[w>>2]=X;mY(da,L);k[S>>2]=1124007936;w=S+4|0;b=S+8|0;u=S+40|0;g=w;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[u>>2]=b;x=S+48|0;v=S+44|0;k[v>>2]=x;k[S+52>>2]=0;k[x>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=da;f=R+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[R>>2]=33619968;k[f>>2]=S;$1(L,R);f=(k[t>>2]|0)-(k[s>>2]|0)>>4;k[R>>2]=0;k[R+4>>2]=f;k[R+8>>2]=f;k[R+12>>2]=3;I1(L,Z,R);KG(X,L)|0;f=L+36|0;b=k[f>>2]|0;if(b|0?(n=b+12|0,q=k[n>>2]|0,k[n>>2]=q+-1,(q|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[L+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;q=L+16|0;e=L+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[e>>2]|0)>0){f=k[L+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[L+44>>2]|0;if(!((b|0)==(L+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=L+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[L>>2]=33619968;k[f>>2]=X;mY(S,L);f=((k[t>>2]|0)-(k[s>>2]|0)>>4)+3|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=1124007936;b=z+16|0;e=z+48|0;g=z+12|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[e>>2]=b;b=z+56|0;k[z+52>>2]=b;k[z+60>>2]=0;k[b>>2]=0;k[z+64>>2]=1124007936;b=z+72|0;e=z+104|0;g=z+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[e>>2]=b;b=z+112|0;k[z+108>>2]=b;k[z+116>>2]=0;k[b>>2]=0;k[z+120>>2]=1124007936;b=z+128|0;e=z+160|0;g=z+124|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[e>>2]=b;g=z+168|0;k[z+164>>2]=g;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[L>>2]=2;k[L+4>>2]=f;j1(z,48,L,5);k[R>>2]=1124007936;n=R+4|0;b=R+8|0;c=R+40|0;g=n;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[c>>2]=b;q=R+48|0;d=R+44|0;k[d>>2]=q;k[R+52>>2]=0;k[q>>2]=0;e=k[z>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,z,R,-1);XN(z);z=(k[t>>2]|0)-(k[s>>2]|0)|0;e=z>>4;if((z|0)>0){f=k[ga+16>>2]|0;g=k[k[U>>2]>>2]|0;h=k[R+16>>2]|0;j=k[k[d>>2]>>2]|0;b=0;do{t=f+(aa(g,b)|0)|0;z=h+(aa(j,b)|0)|0;k[z>>2]=k[t>>2];k[z+4>>2]=k[t+4>>2];b=b+1|0}while((b|0)<(e|0))}k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=Z;k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=R;b=a+20|0;e=D+4|0;g=e+4|0;k[g>>2]=0;k[g+4>>2]=0;k[D>>2]=33619968;k[e>>2]=b;NZ(L,G,D,0)|0;e=(k[a+28>>2]|0)+-3|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=2;k[G+12>>2]=e;I1(L,b,G);k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=1124007936;b=F+16|0;e=F+48|0;g=F+12|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[e>>2]=b;b=F+56|0;k[F+52>>2]=b;k[F+60>>2]=0;k[b>>2]=0;k[F+64>>2]=1124007936;b=F+72|0;e=F+104|0;g=F+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[e>>2]=b;b=F+112|0;k[F+108>>2]=b;k[F+116>>2]=0;k[b>>2]=0;k[F+120>>2]=1124007936;b=F+128|0;e=F+160|0;g=F+124|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[e>>2]=b;g=F+168|0;k[F+164>>2]=g;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));y0(F,L,1.0);d1(D,F,fa);d1(E,D,L);k[G>>2]=1124007936;m=G+4|0;b=G+8|0;j=G+40|0;g=m;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[j>>2]=b;l=G+48|0;h=G+44|0;k[h>>2]=l;k[G+52>>2]=0;k[l>>2]=0;g=k[E>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,E,G,-1);XN(E);XN(D);XN(F);g=G+16|0;f=k[g>>2]|0;na=+P(+(+o[f>>2]*+o[f+(k[k[h>>2]>>2]|0)+4>>2]));o[a+16>>2]=na;i[a+4>>0]=1;f=G+36|0;b=k[f>>2]|0;if(b|0?(F=b+12|0,a=k[F>>2]|0,k[F>>2]=a+-1,(a|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[G+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[m>>2]|0)>0){e=k[j>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[h>>2]|0;if(!((b|0)==(l|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=L+36|0;b=k[f>>2]|0;do if(b|0){a=b+12|0;G=k[a>>2]|0;k[a>>2]=G+-1;if((G|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[L+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;G=L+16|0;e=L+4|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[e>>2]|0)>0){f=k[L+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[L+44>>2]|0;if(!((b|0)==(L+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=R+36|0;b=k[f>>2]|0;do if(b|0){G=b+12|0;L=k[G>>2]|0;k[G>>2]=L+-1;if((L|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[R+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;R=R+16|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[n>>2]|0)>0){e=k[c>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[n>>2]|0))}b=k[d>>2]|0;if(!((b|0)==(q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=S+36|0;b=k[f>>2]|0;do if(b|0){L=b+12|0;R=k[L>>2]|0;k[L>>2]=R+-1;if((R|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[S+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;S=S+16|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[w>>2]|0)>0){e=k[u>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[w>>2]|0))}b=k[v>>2]|0;if(!((b|0)==(x|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=X+36|0;b=k[f>>2]|0;do if(b|0){R=b+12|0;S=k[R>>2]|0;k[R>>2]=S+-1;if((S|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[X+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;S=X+16|0;e=X+4|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[e>>2]|0)>0){f=k[X+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[X+44>>2]|0;if(!((b|0)==(X+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Z+36|0;b=k[f>>2]|0;do if(b|0){S=b+12|0;X=k[S>>2]|0;k[S>>2]=X+-1;if((X|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Z+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;Z=Z+16|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[B>>2]|0)>0){e=k[y>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[B>>2]|0))}b=k[A>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=da+36|0;b=k[f>>2]|0;do if(b|0){X=b+12|0;Z=k[X>>2]|0;k[X>>2]=Z+-1;if((Z|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[da+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;da=da+16|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[J>>2]|0)>0){e=k[H>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[J>>2]|0))}b=k[I>>2]|0;if(!((b|0)==(K|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=fa+36|0;b=k[f>>2]|0;do if(b|0){Z=b+12|0;da=k[Z>>2]|0;k[Z>>2]=da+-1;if((da|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[fa+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;fa=fa+16|0;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=0;k[fa+12>>2]=0;if((k[O>>2]|0)>0){e=k[M>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[O>>2]|0))}b=k[N>>2]|0;if(!((b|0)==(Q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ga+36|0;b=k[f>>2]|0;do if(b|0){da=b+12|0;fa=k[da>>2]|0;k[da>>2]=fa+-1;if((fa|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ga+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;ga=ga+16|0;k[ga>>2]=0;k[ga+4>>2]=0;k[ga+8>>2]=0;k[ga+12>>2]=0;if((k[V>>2]|0)>0){e=k[T>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[V>>2]|0))}b=k[U>>2]|0;if(!((b|0)==(W|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ha+36|0;b=k[f>>2]|0;do if(b|0){fa=b+12|0;ga=k[fa>>2]|0;k[fa>>2]=ga+-1;if((ga|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ha+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;ha=ha+16|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[ba>>2]|0)>0){e=k[Y>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ba>>2]|0))}b=k[$>>2]|0;if(!((b|0)==(ca|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=k[ia>>2]|0;b=f;if(f|0){e=k[ea>>2]|0;if((e|0)!=(f|0))k[ea>>2]=e+(~((e+-16-b|0)>>>4)<<4);ggb(f)}f=ja+36|0;b=k[f>>2]|0;do if(b|0){ha=b+12|0;ia=k[ha>>2]|0;k[ha>>2]=ia+-1;if((ia|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ja+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;ia=ja+16|0;e=ja+4|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[e>>2]|0)>0){f=k[ja+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[ja+44>>2]|0;if(!((b|0)==(ja+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=ka+36|0;b=k[f>>2]|0;do if(b|0){ia=b+12|0;ja=k[ia>>2]|0;k[ia>>2]=ja+-1;if((ja|0)!=1)break;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ka+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}while(0);k[f>>2]=0;ja=ka+16|0;e=ka+4|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[e>>2]|0)>0){f=k[ka+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[ka+44>>2]|0;if((b|0)==(ka+48|0)|(b|0)==0){r=la;return}ggb(k[b+-4>>2]|0);r=la;return}function l$a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0.0,n=0,p=0,q=0,s=0,t=0,u=0;t=r;r=r+128|0;s=t+64|0;q=t+8|0;p=t;if(!(i[a+4>>0]|0)){e=s+4|0;d=ZT(16)|0;k[d>>2]=1;f=d+4|0;k[s>>2]=f;k[e>>2]=11;i[d+15>>0]=0;g=392752;h=f+11|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,s,392764,392683,168);k[e>>2]=0;k[s>>2]=0;n=k[d>>2]|0;k[d>>2]=n+-1;if((n|0)==1)ggb(k[d+-4>>2]|0)}do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[s>>2]=k[f>>2];l=s+4|0;b=f+4|0;k[l>>2]=k[b>>2];n=s+8|0;k[n>>2]=k[f+8>>2];k[s+12>>2]=k[f+12>>2];k[s+16>>2]=k[f+16>>2];k[s+20>>2]=k[f+20>>2];k[s+24>>2]=k[f+24>>2];k[s+28>>2]=k[f+28>>2];k[s+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[s+36>>2]=d;e=s+40|0;k[e>>2]=n;n=s+48|0;h=s+44|0;k[h>>2]=n;k[s+52>>2]=0;k[n>>2]=0;if(d|0){n=d+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[b>>2]|0)<3){n=k[f+44>>2]|0;b=k[h>>2]|0;k[b>>2]=k[n>>2];k[b+4>>2]=k[n+4>>2];b=s;break}k[l>>2]=0;x1(s,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0));b=s}else b=s}else{Q1(s,b,-1);b=s}while(0);if(!((k[b>>2]&4088|0)==8?(k[s+12>>2]|0)>0:0)){k[q>>2]=0;b=q+4|0;k[b>>2]=0;d=ZT(44)|0;k[d>>2]=1;f=d+4|0;k[q>>2]=f;k[b>>2]=37;i[d+41>>0]=0;g=392784;h=f+37|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,q,392764,392683,170);k[b>>2]=0;k[q>>2]=0;n=k[d>>2]|0;k[d>>2]=n+-1;if((n|0)==1)ggb(k[d+-4>>2]|0)}if(k[c>>2]&2031616|0){n=s+12|0;c2(c,1,k[n>>2]|0,13,-1,0,0);do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[q>>2]=k[f>>2];l=q+4|0;b=f+4|0;k[l>>2]=k[b>>2];c=q+8|0;k[c>>2]=k[f+8>>2];k[q+12>>2]=k[f+12>>2];k[q+16>>2]=k[f+16>>2];k[q+20>>2]=k[f+20>>2];k[q+24>>2]=k[f+24>>2];k[q+28>>2]=k[f+28>>2];k[q+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[q+36>>2]=d;e=q+40|0;k[e>>2]=c;c=q+48|0;h=q+44|0;k[h>>2]=c;k[q+52>>2]=0;k[c>>2]=0;if(d|0){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[b>>2]|0)<3){l=k[f+44>>2]|0;c=k[h>>2]|0;k[c>>2]=k[l>>2];k[c+4>>2]=k[l+4>>2];break}k[l>>2]=0;x1(q,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(q,c,-1);while(0);if((k[n>>2]|0)>0){g=s+16|0;h=q+16|0;j=a+76|0;l=p+4|0;d=a+28|0;e=a+36|0;f=a+64|0;b=0;do{u=k[g>>2]|0;c=k[h>>2]|0;p$a(p,j,+o[u+(b<<3)>>2],+o[u+(b<<3)+4>>2],k[d>>2]|0,k[e>>2]|0,k[k[f>>2]>>2]|0);k[c+(b<<3)>>2]=k[p>>2];k[c+(b<<3)+4>>2]=k[l>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}e=q+36|0;b=k[e>>2]|0;if(b|0?(p=b+12|0,u=k[p>>2]|0,k[p>>2]=u+-1,(u|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[q+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;u=q+16|0;d=q+4|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[q+44>>2]|0;if(!((b|0)==(q+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}m=+o[a+16>>2];e=s+36|0;b=k[e>>2]|0;if(b|0?(q=b+12|0,u=k[q>>2]|0,k[q>>2]=u+-1,(u|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[s+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;u=s+16|0;d=s+4|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[d>>2]|0)>0){e=k[s+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[s+44>>2]|0;if((b|0)==(s+48|0)|(b|0)==0){r=t;return +m}ggb(k[b+-4>>2]|0);r=t;return +m}function m$a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+208|0;B=J+184|0;I=J+128|0;H=J+72|0;G=J+16|0;A=J;if(!(i[a+4>>0]|0)){g=B+4|0;h=ZT(24)|0;k[h>>2]=1;m=h+4|0;k[B>>2]=m;k[g>>2]=17;i[h+21>>0]=0;j=392655;n=m+17|0;do{i[m>>0]=i[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(n|0));Y8(-215,B,392673,392683,148);k[g>>2]=0;k[B>>2]=0;F=k[h>>2]|0;k[h>>2]=F+-1;if((F|0)==1)ggb(k[h+-4>>2]|0)}do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[I>>2]=k[l>>2];p=I+4|0;g=l+4|0;k[p>>2]=k[g>>2];s=I+8|0;k[s>>2]=k[l+8>>2];q=I+12|0;k[q>>2]=k[l+12>>2];k[I+16>>2]=k[l+16>>2];k[I+20>>2]=k[l+20>>2];k[I+24>>2]=k[l+24>>2];k[I+28>>2]=k[l+28>>2];k[I+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[I+36>>2]=h;j=I+40|0;k[j>>2]=s;F=I+48|0;n=I+44|0;k[n>>2]=F;k[I+52>>2]=0;k[F>>2]=0;if(h|0){F=h+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[g>>2]|0)<3){E=k[l+44>>2]|0;F=k[n>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2];break}k[p>>2]=0;x1(I,k[g>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[o+(g<<2)>>2];k[h+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[p>>2]|0))}}else{Q1(I,b,-1);q=I+12|0;s=I+8|0}while(0);h=k[s>>2]|0;j=k[q>>2]|0;k[H>>2]=1124007936;E=H+4|0;g=H+8|0;C=H+40|0;m=E;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[C>>2]=g;F=H+48|0;D=H+44|0;k[D>>2]=F;k[H+52>>2]=0;k[F>>2]=0;k[B>>2]=h;l=B+4|0;k[l>>2]=j;G1(H,2,B,5);j=k[s>>2]|0;h=k[q>>2]|0;k[G>>2]=1124007936;z=G+4|0;g=G+8|0;x=G+40|0;m=z;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[x>>2]=g;y=G+48|0;w=G+44|0;k[w>>2]=y;k[G+52>>2]=0;k[y>>2]=0;k[B>>2]=j;k[l>>2]=h;G1(G,2,B,5);g=k[s>>2]|0;if((g|0)>0){o=a+76|0;p=H+16|0;u=B+4|0;v=G+16|0;m=a+28|0;n=a+36|0;l=a+64|0;j=0;h=k[q>>2]|0;do{if((h|0)>0){t=+(j|0);g=0;do{p$a(B,o,+(g|0),t,k[m>>2]|0,k[n>>2]|0,k[k[l>>2]>>2]|0);h=(k[p>>2]|0)+(aa(k[k[D>>2]>>2]|0,j)|0)+(g<<2)|0;k[h>>2]=k[B>>2];h=(k[v>>2]|0)+(aa(k[k[w>>2]>>2]|0,j)|0)+(g<<2)|0;k[h>>2]=k[u>>2];g=g+1|0;h=k[q>>2]|0}while((g|0)<(h|0));g=k[s>>2]|0}j=j+1|0}while((j|0)<(g|0))}k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=H;k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=16842752;k[A+4>>2]=G;Jna(b,c,B,A,d,e,f);j=G+36|0;g=k[j>>2]|0;if(g|0?(f=g+12|0,B=k[f>>2]|0,k[f>>2]=B+-1,(B|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[G+32>>2]|0;if(!g){g=B1()|0;h=k[j>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;G=G+16|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[z>>2]|0)>0){h=k[x>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[z>>2]|0))}g=k[w>>2]|0;if(!((g|0)==(y|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=H+36|0;g=k[j>>2]|0;if(g|0?(B=g+12|0,G=k[B>>2]|0,k[B>>2]=G+-1,(G|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[H+32>>2]|0;if(!g){g=B1()|0;h=k[j>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;H=H+16|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[E>>2]|0)>0){h=k[C>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[E>>2]|0))}g=k[D>>2]|0;if(!((g|0)==(F|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=I+36|0;g=k[j>>2]|0;if(g|0?(G=g+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[I+32>>2]|0;if(!g){g=B1()|0;h=k[j>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;H=I+16|0;h=I+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[h>>2]|0)>0){j=k[I+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[I+44>>2]|0;if((g|0)==(I+48|0)|(g|0)==0){r=J;return}ggb(k[g+-4>>2]|0);r=J;return}function n$a(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function o$a(a){a=a|0;return +(+p[a+8>>3])}function p$a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,l=0.0,m=0,n=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0;o[a>>2]=0.0;s=a+4|0;o[s>>2]=0.0;n=f+(aa(e+-3|0,g)|0)|0;p=f+(aa(e+-2|0,g)|0)|0;m=f+(aa(e+-1|0,g)|0)|0;q=k[b+8>>2]|0;r=k[b+16>>2]|0;if((q|0)<=0){o[a>>2]=+o[n>>2]+ +o[p>>2]*c+ +o[m>>2]*d+0.0;d=+o[n+4>>2]+ +o[p+4>>2]*c+ +o[m+4>>2]*d+0.0;o[s>>2]=d;return}i=+o[n>>2];j=+o[m>>2];l=+o[p>>2]*c;b=k[k[b+44>>2]>>2]|0;h=0.0;e=0;do{u=f+(aa(e,g)|0)|0;w=r+(aa(b,e)|0)|0;v=+o[w>>2]-c;t=+o[w+4>>2]-d;t=v*v+t*t;h=h+ +o[u>>2]*(+_(+(t+1.1920928955078125e-07))*t);e=e+1|0}while((e|0)!=(q|0));o[a>>2]=i+l+j*d+h;l=+o[n+4>>2];j=+o[m+4>>2];i=+o[p+4>>2]*c;h=0.0;e=0;do{w=f+(aa(e,g)|0)+4|0;u=r+(aa(b,e)|0)|0;t=+o[u>>2]-c;v=+o[u+4>>2]-d;v=t*t+v*v;h=h+ +o[w>>2]*(+_(+(v+1.1920928955078125e-07))*v);e=e+1|0}while((e|0)!=(q|0));v=l+i+j*d+h;o[s>>2]=v;return}function q$a(a){a=a|0;ggb(a);return}function r$a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function s$a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,ba=0.0,ca=0.0,da=0,ea=0,fa=0;da=r;r=r+16|0;m=da;E=b+8|0;l=k[E>>2]|0;F=c+8|0;if(((l|0)==(k[F>>2]|0)?(j=k[b+12>>2]|0,(j|0)==(k[c+12>>2]|0)):0)?(k[b+16>>2]|0)!=0:0){g=k[b+4>>2]|0;if((g|0)<3)e=aa(j,l)|0;else{h=k[b+40>>2]|0;f=0;e=1;do{e=aa(k[h+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(g|0))}if((e|0)!=0?(k[c+16>>2]|0)!=0:0){h=k[c+4>>2]|0;if((h|0)<3)e=aa(j,l)|0;else{g=k[c+40>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e)e=l;else S=15}else S=15}else S=15;if((S|0)==15){e=m+4|0;f=ZT(92)|0;k[f>>2]=1;g=f+4|0;k[m>>2]=g;k[e>>2]=86;i[f+90>>0]=0;h=393116;j=g+86|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,m,393203,393212,63);k[e>>2]=0;k[m>>2]=0;X=k[f>>2]|0;k[f>>2]=X+-1;if((X|0)==1)ggb(k[f+-4>>2]|0);e=k[E>>2]|0}T=a+4|0;U=a+8|0;if(!(((k[T>>2]|0)==(e|0)?(k[U>>2]|0)==1:0)?!(k[a+12>>2]|0):0))S=21;do if((S|0)==21){k[T>>2]=e;k[U>>2]=1;k[a+12>>2]=0;if(!e){k[a>>2]=0;ca=-1.0;r=da;return +ca}k[a>>2]=2;v=a+24|0;l=a+28|0;h=k[l>>2]|0;g=k[v>>2]|0;f=(h-g|0)/12|0;if(e>>>0<=f>>>0){if(e>>>0<f>>>0?(n=g+(e*12|0)|0,(h|0)!=(n|0)):0)while(1){e=h+-12|0;k[l>>2]=e;g=k[e>>2]|0;j=g;if(g){e=h+-8|0;f=k[e>>2]|0;if((f|0)!=(g|0))k[e>>2]=f+(~(((f+-36-j|0)>>>0)/36|0)*36|0);ggb(g);e=k[l>>2]|0}if((e|0)==(n|0))break;else h=e}}else t$a(v,e-f|0);q=a+48|0;e=k[T>>2]|0;j=a+52|0;f=k[j>>2]|0;h=k[q>>2]|0;g=(f-h|0)/12|0;if(e>>>0<=g>>>0){if(e>>>0<g>>>0?(p=h+(e*12|0)|0,(f|0)!=(p|0)):0)while(1){e=f+-12|0;k[j>>2]=e;g=k[e>>2]|0;h=g;if(g){e=f+-8|0;f=k[e>>2]|0;if((f|0)!=(g|0))k[e>>2]=f+(~(((f+-20-h|0)>>>0)/20|0)*20|0);ggb(g);e=k[j>>2]|0}if((e|0)==(p|0))break;else f=e}}else u$a(q,e-g|0);n=a+36|0;e=k[T>>2]|0;l=a+40|0;h=k[l>>2]|0;g=k[n>>2]|0;f=(h-g|0)/12|0;if(e>>>0<=f>>>0){if(e>>>0<f>>>0?(t=g+(e*12|0)|0,(h|0)!=(t|0)):0)while(1){e=h+-12|0;k[l>>2]=e;g=k[e>>2]|0;j=g;if(g){e=h+-8|0;f=k[e>>2]|0;if((f|0)!=(g|0))k[e>>2]=f+(~(((f+-20-j|0)>>>0)/20|0)*20|0);ggb(g);e=k[l>>2]|0}if((e|0)==(t|0))break;else h=e}}else u$a(n,e-f|0);f=k[T>>2]|0;if((f|0)>0){m=0;do{g=k[v>>2]|0;e=g+(m*12|0)|0;f=k[U>>2]|0;g=g+(m*12|0)+4|0;l=k[g>>2]|0;j=k[e>>2]|0;h=(l-j|0)/36|0;if(f>>>0<=h>>>0){if(f>>>0<h>>>0?(w=j+(f*36|0)|0,(l|0)!=(w|0)):0)k[g>>2]=l+(~(((l+-36-w|0)>>>0)/36|0)*36|0)}else{x$a(e,f-h|0);f=k[U>>2]|0}g=k[q>>2]|0;e=g+(m*12|0)|0;g=g+(m*12|0)+4|0;l=k[g>>2]|0;j=k[e>>2]|0;h=(l-j|0)/20|0;if(f>>>0<=h>>>0){if(f>>>0<h>>>0?(x=j+(f*20|0)|0,(l|0)!=(x|0)):0)k[g>>2]=l+(~(((l+-20-x|0)>>>0)/20|0)*20|0)}else{y$a(e,f-h|0);f=k[U>>2]|0}g=k[n>>2]|0;e=g+(m*12|0)|0;g=g+(m*12|0)+4|0;l=k[g>>2]|0;j=k[e>>2]|0;h=(l-j|0)/20|0;if(f>>>0<=h>>>0){if(f>>>0<h>>>0?(y=j+(f*20|0)|0,(l|0)!=(y|0)):0)k[g>>2]=l+(~(((l+-20-y|0)>>>0)/20|0)*20|0)}else y$a(e,f-h|0);m=m+1|0;f=k[T>>2]|0}while((m|0)<(f|0))}g=a+108|0;e=k[U>>2]|0;h=aa(f<<2,e)|0|2;j=a+112|0;n=k[j>>2]|0;m=k[g>>2]|0;l=n-m>>2;if(h>>>0<=l>>>0){if(h>>>0<l>>>0?(z=m+(h<<2)|0,(n|0)!=(z|0)):0)k[j>>2]=n+(~((n+-4-z|0)>>>2)<<2)}else{v$a(g,h-l|0);f=k[T>>2]|0;e=k[U>>2]|0}g=a+120|0;h=(aa(e,f)|0)+2|0;j=a+124|0;n=k[j>>2]|0;m=k[g>>2]|0;l=n-m>>2;if(h>>>0<=l>>>0){if(h>>>0<l>>>0?(B=m+(h<<2)|0,(n|0)!=(B|0)):0)k[j>>2]=n+(~((n+-4-B|0)>>>2)<<2)}else{w$a(g,h-l|0);f=k[T>>2]|0;e=k[U>>2]|0}g=a+152|0;h=(aa(e,f)|0)+2|0;j=a+156|0;n=k[j>>2]|0;m=k[g>>2]|0;l=n-m>>2;if(h>>>0<=l>>>0){if(h>>>0<l>>>0?(C=m+(h<<2)|0,(n|0)!=(C|0)):0)k[j>>2]=n+(~((n+-4-C|0)>>>2)<<2)}else{v$a(g,h-l|0);f=k[T>>2]|0;e=k[U>>2]|0}l=a+164|0;e=(aa(e,f)|0)+2|0;f=a+168|0;j=k[f>>2]|0;g=k[l>>2]|0;h=j-g>>2;if(e>>>0>h>>>0){v$a(l,e-h|0);break}if(e>>>0<h>>>0?(D=g+(e<<2)|0,(j|0)!=(D|0)):0)k[f>>2]=j+(~((j+-4-D|0)>>>2)<<2)}while(0);l=k[E>>2]|0;f=l>>>0>1073741823?-1:l<<2;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0){X=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){X=0;break}Qh[e&7]()}f=k[F>>2]|0;f=f>>>0>1073741823?-1:f<<2;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0){W=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){W=0;break}Qh[e&7]()}if((l|0)>0){j=k[b+16>>2]|0;g=k[k[b+44>>2]>>2]|0;h=k[c+16>>2]|0;f=k[k[c+44>>2]>>2]|0;e=0;do{V=j+(aa(g,e)|0)|0;k[X+(e<<2)>>2]=k[V>>2];V=h+(aa(f,e)|0)|0;k[W+(e<<2)>>2]=k[V>>2];e=e+1|0}while((e|0)!=(l|0))}V=a+132|0;k[V>>2]=0;switch(k[a>>2]|0){case 2:{e=k[U>>2]|0;if((e|0)>0){t=a+24|0;v=a+36|0;w=a+48|0;g=0;j=W;h=X;f=k[T>>2]|0;do if((f|0)>0){m=k[t>>2]|0;n=k[v>>2]|0;q=g+1|0;p=k[w>>2]|0;l=0;f=h;e=j;while(1){R=k[m+(l*12|0)>>2]|0;k[R+(g*36|0)>>2]=l;k[R+(g*36|0)+4>>2]=g;h=f+4|0;j=e+4|0;o[R+(g*36|0)+12>>2]=+o[f>>2]-+o[e>>2];k[R+(g*36|0)+24>>2]=0;k[R+(g*36|0)+28>>2]=0;k[R+(g*36|0)+20>>2]=-1;f=R+(g*36|0)|0;S=k[n+(l*12|0)>>2]|0;k[S+(g*20|0)+8>>2]=f;e=k[U>>2]|0;k[S+(g*20|0)+12>>2]=R+(((q|0)%(e|0)|0)*36|0);o[S+(g*20|0)>>2]=0.0;k[S+(g*20|0)+4>>2]=1;k[S+(g*20|0)+16>>2]=0;S=k[p+(l*12|0)>>2]|0;k[S+(g*20|0)+8>>2]=f;l=l+1|0;f=k[T>>2]|0;k[S+(g*20|0)+12>>2]=(k[m+(((l|0)%(f|0)|0)*12|0)>>2]|0)+(g*36|0);o[S+(g*20|0)>>2]=0.0;k[S+(g*20|0)+4>>2]=1;k[S+(g*20|0)+16>>2]=0;if((l|0)>=(f|0)){g=q;break}else{f=h;e=j}}}else g=g+1|0;while((g|0)<(e|0));S=117}else S=117;break}case 3:{z=a+12|0;e=k[z>>2]|0;if((e|0)>0){B=a+60|0;C=a+84|0;D=a+72|0;E=a+96|0;y=0;f=X;h=W;g=k[U>>2]|0;do{x=y;y=y+1|0;if((g|0)>0){l=0;j=k[T>>2]|0;do if((j|0)>0){p=k[B>>2]|0;q=k[C>>2]|0;t=k[D>>2]|0;w=l+1|0;v=k[E>>2]|0;n=0;e=f;while(1){N=k[p+(n*12|0)>>2]|0;R=k[N+(l*12|0)>>2]|0;k[R+(x*36|0)>>2]=n;k[R+(x*36|0)+4>>2]=l;k[R+(x*36|0)+8>>2]=x;f=e+4|0;m=h+4|0;o[R+(x*36|0)+12>>2]=+o[e>>2]-+o[h>>2];k[R+(x*36|0)+24>>2]=0;k[R+(x*36|0)+28>>2]=0;k[R+(x*36|0)+20>>2]=-1;e=R+(x*36|0)|0;Q=k[(k[q+(n*12|0)>>2]|0)+(l*12|0)>>2]|0;k[Q+(x*20|0)+8>>2]=e;S=n;n=n+1|0;j=k[T>>2]|0;k[Q+(x*20|0)+12>>2]=(k[(k[p+(((n|0)%(j|0)|0)*12|0)>>2]|0)+(l*12|0)>>2]|0)+(x*36|0);o[Q+(x*20|0)>>2]=0.0;k[Q+(x*20|0)+4>>2]=1;k[Q+(x*20|0)+16>>2]=0;Q=k[(k[t+(S*12|0)>>2]|0)+(l*12|0)>>2]|0;k[Q+(x*20|0)+8>>2]=e;g=k[U>>2]|0;k[Q+(x*20|0)+12>>2]=(k[N+(((w|0)%(g|0)|0)*12|0)>>2]|0)+(x*36|0);o[Q+(x*20|0)>>2]=0.0;k[Q+(x*20|0)+4>>2]=1;k[Q+(x*20|0)+16>>2]=0;S=k[(k[v+(S*12|0)>>2]|0)+(l*12|0)>>2]|0;k[S+(x*20|0)+8>>2]=e;e=k[z>>2]|0;k[S+(x*20|0)+12>>2]=R+(((y|0)%(e|0)|0)*36|0);o[S+(x*20|0)>>2]=0.0;k[S+(x*20|0)+4>>2]=1;k[S+(x*20|0)+16>>2]=0;if((n|0)>=(j|0)){h=m;l=w;break}else{e=f;h=m}}}else l=l+1|0;while((l|0)<(g|0))}}while((y|0)<(e|0));S=117}else S=117;break}default:{e=k[T>>2]|0;if(!e)Vd();else S=193}}do if((S|0)==117){e=k[T>>2]|0;f=(e|0)==0;if((k[a>>2]|0)!=2){if(!f){S=193;break}Vd()}if(!f){if(e>>>0>357913941)ad(426534,426557,304,426811);h=e*12|0;g=(h|0)==0?1:h;while(1){f=fgb(g)|0;if(f|0){q=f;break}f=k[207666]|0;k[207666]=f+0;if(!f){q=0;break}Qh[f&7]()}f=q+(e*12|0)|0;zpb(q|0,0,h|0)|0;if((k[T>>2]|0)>0){p=a+24|0;n=0;g=k[U>>2]|0;do{e=q+(n*12|0)|0;h=q+(n*12|0)+4|0;m=k[h>>2]|0;l=k[e>>2]|0;j=m-l>>2;if(g>>>0<=j>>>0){if(g>>>0<j>>>0?(G=l+(g<<2)|0,(m|0)!=(G|0)):0)k[h>>2]=m+(~((m+-4-G|0)>>>2)<<2)}else{FEa(e,g-j|0);g=k[U>>2]|0}if((g|0)>0){h=k[(k[p>>2]|0)+(n*12|0)>>2]|0;j=k[q+(n*12|0)>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e*36|0)+12>>2];e=e+1|0}while((e|0)!=(g|0))}n=n+1|0}while((n|0)<(k[T>>2]|0));e=q}else{e=q;S=126}}else{e=0;f=0;S=126}if((S|0)==126)g=k[U>>2]|0;if(!g)Vd();if(g>>>0>1073741823)ad(426534,426557,304,426811);j=g<<2;h=(j|0)==0?1:j;while(1){g=fgb(h)|0;if(g|0){m=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){m=0;break}Qh[g&7]()}zpb(m|0,0,j|0)|0;g=k[U>>2]|0;q=k[T>>2]|0;o[m>>2]=0.0;a:do if((g|0)>1){p=g+-1|0;if((q|0)>0){j=0;g=0}else{g=0;while(1){g=g+1|0;k[m+(g<<2)>>2]=0;if((g|0)==(p|0))break a}}while(1){l=j;j=j+1|0;n=m+(j<<2)|0;k[n>>2]=g;h=0;d=(k[u>>2]=g,+o[u>>2]);do{d=d-+o[(k[e+(h*12|0)>>2]|0)+(l<<2)>>2];o[n>>2]=d;h=h+1|0}while((h|0)!=(q|0));if((j|0)>=(p|0))break;else g=(o[u>>2]=d,k[u>>2]|0)}}while(0);if(!q)Vd();if(q>>>0>1073741823)ad(426534,426557,304,426811);j=q<<2;h=(j|0)==0?1:j;while(1){g=fgb(h)|0;if(g|0){n=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){n=0;break}Qh[g&7]()}zpb(n|0,0,j|0)|0;g=k[T>>2]|0;v=k[U>>2]|0;o[n>>2]=0.0;C=(g|0)>1;b:do if(C){t=g+-1|0;if((v|0)>0){j=0;h=0}else{h=0;while(1){h=h+1|0;k[n+(h<<2)>>2]=0;if((h|0)==(t|0))break b}}while(1){q=j;j=j+1|0;p=n+(j<<2)|0;k[p>>2]=h;q=k[e+(q*12|0)>>2]|0;l=0;d=(k[u>>2]=h,+o[u>>2]);do{d=d-+o[q+(l<<2)>>2];o[p>>2]=d;l=l+1|0}while((l|0)!=(v|0));if((j|0)>=(t|0))break;else h=(o[u>>2]=d,k[u>>2]|0)}}while(0);z=a+16|0;k[z>>2]=0;B=v+-1|0;if((v|0)>1?(J=a+48|0,K=a+36|0,L=a+108|0,(g|0)>0):0){x=g+-1|0;v=0;h=e;j=0;do{w=v;v=v+1|0;y=m+(v<<2)|0;t=0;while(1){p=k[h+(t*12|0)>>2]|0;d=+o[p+(w<<2)>>2];do if((t|0)<(x|0)){O=+P(+(d+ +o[y>>2]));l=t+1|0;h=n+(l<<2)|0;if(O>+P(+(d+ +o[h>>2]))){p=k[(k[J>>2]|0)+(t*12|0)>>2]|0;Q=(k[(k[K>>2]|0)+(t*12|0)>>2]|0)+(w*20|0)|0;R=j+1|0;k[z>>2]=R;k[(k[L>>2]|0)+(j<<2)>>2]=Q;j=(k[e+(l*12|0)>>2]|0)+(w<<2)|0;o[j>>2]=d+ +o[j>>2];o[h>>2]=d+ +o[h>>2];j=R;h=e;break}else{q=k[(k[K>>2]|0)+(t*12|0)>>2]|0;h=(k[(k[J>>2]|0)+(t*12|0)>>2]|0)+(w*20|0)|0;p=j+1|0;k[z>>2]=p;k[(k[L>>2]|0)+(j<<2)>>2]=h;h=e;j=p;p=k[e+(t*12|0)>>2]|0;S=173;break}}else{l=t+1|0;q=k[(k[K>>2]|0)+(t*12|0)>>2]|0;S=173}while(0);if((S|0)==173){S=0;p=p+(v<<2)|0;o[p>>2]=d+ +o[p>>2];o[y>>2]=d+ +o[y>>2];p=q}R=p+(w*20|0)|0;k[(k[p+(w*20|0)+8>>2]|0)+28>>2]=R;O=+P(+d);o[R>>2]=O;k[p+(w*20|0)+4>>2]=d>0.0&1;if((l|0)<(g|0))t=l;else break}}while((v|0)!=(B|0))}if(C){l=k[a+48>>2]|0;h=g+-1|0;g=0;j=k[e>>2]|0;do{O=+o[j+(B<<2)>>2];R=k[l+(g*12|0)>>2]|0;Q=R+(B*20|0)|0;g=g+1|0;j=k[e+(g*12|0)>>2]|0;N=j+(B<<2)|0;o[N>>2]=O+ +o[N>>2];k[(k[R+(B*20|0)+8>>2]|0)+28>>2]=Q;A=+P(+O);o[Q>>2]=A;k[R+(B*20|0)+4>>2]=O>0.0&1}while((g|0)!=(h|0));l=e}else l=e;if(n|0)ggb(n);if(m|0)ggb(m);if(l|0){if((f|0)!=(l|0))do{e=f;f=f+-12|0;h=k[f>>2]|0;j=h;if(h|0){e=e+-8|0;g=k[e>>2]|0;if((g|0)!=(h|0))k[e>>2]=g+(~((g+-4-j|0)>>>2)<<2);ggb(h)}}while((f|0)!=(l|0));ggb(l)}}while(0);do if((S|0)==193){if(e>>>0>357913941)ad(426534,426557,304,426811);h=e*12|0;g=(h|0)==0?1:h;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}m=f+(e*12|0)|0;zpb(f|0,0,h|0)|0;z=a+12|0;B=a+60|0;y=0;g=k[U>>2]|0;c:while(1){v=f+(y*12|0)|0;x=f+(y*12|0)+4|0;p=k[x>>2]|0;e=k[v>>2]|0;q=(p-e|0)/12|0;h=e;j=p;do if(g>>>0>q>>>0){t=g-q|0;w=f+(y*12|0)+8|0;l=k[w>>2]|0;if(((l-p|0)/12|0)>>>0>=t>>>0){zpb(p|0,0,t*12|0)|0;k[x>>2]=j+(t*12|0);break}if(g>>>0>357913941){S=204;break c}S=(l-e|0)/12|0;n=S<<1;n=S>>>0<178956970?(n>>>0<g>>>0?g:n):357913941;if(!n)l=0;else{if(n>>>0>357913941){S=207;break c}g=n*12|0;g=(g|0)==0?1:g;while(1){e=fgb(g)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}l=e}e=l+(q*12|0)|0;g=e;n=l+(n*12|0)|0;zpb(e|0,0,t*12|0)|0;l=e+(t*12|0)|0;if((j|0)!=(h|0)){do{j=j+-12|0;BH(e+-12|0,j);e=g+-12|0;g=e}while((j|0)!=(h|0));p=k[v>>2]|0;h=k[x>>2]|0}k[v>>2]=g;k[x>>2]=l;k[w>>2]=n;n=p;if((h|0)!=(n|0))do{e=h;h=h+-12|0;j=k[h>>2]|0;l=j;if(j|0){e=e+-8|0;g=k[e>>2]|0;if((g|0)!=(j|0))k[e>>2]=g+(~((g+-4-l|0)>>>2)<<2);ggb(j)}}while((h|0)!=(n|0));if(p|0)ggb(p)}else if(g>>>0<q>>>0?(H=h+(g*12|0)|0,(j|0)!=(H|0)):0){g=j;while(1){e=g+-12|0;k[x>>2]=e;h=k[e>>2]|0;j=h;if(h){e=g+-8|0;g=k[e>>2]|0;if((g|0)!=(h|0))k[e>>2]=g+(~((g+-4-j|0)>>>2)<<2);ggb(h);e=k[x>>2]|0}if((e|0)==(H|0))break;else g=e}}while(0);e=k[U>>2]|0;if((e|0)>0){q=f+(y*12|0)|0;p=0;j=k[z>>2]|0;do{g=k[q>>2]|0;e=g+(p*12|0)|0;g=g+(p*12|0)+4|0;n=k[g>>2]|0;l=k[e>>2]|0;h=n-l>>2;if(j>>>0<=h>>>0){if(j>>>0<h>>>0?(I=l+(j<<2)|0,(n|0)!=(I|0)):0)k[g>>2]=n+(~((n+-4-I|0)>>>2)<<2)}else{FEa(e,j-h|0);j=k[z>>2]|0}if((j|0)>0){g=k[(k[(k[B>>2]|0)+(y*12|0)>>2]|0)+(p*12|0)>>2]|0;h=k[(k[q>>2]|0)+(p*12|0)>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e*36|0)+12>>2];e=e+1|0}while((e|0)!=(j|0))}p=p+1|0;g=k[U>>2]|0}while((p|0)<(g|0))}else g=e;y=y+1|0;e=k[T>>2]|0;if((y|0)>=(e|0)){S=243;break}}if((S|0)==204)ad(426534,426557,304,426811);else if((S|0)==207){da=te(4)|0;k[da>>2]=172664;Cf(da|0,28816,1287)}else if((S|0)==243){if(!e)Vd();if(e>>>0>1073741823)ad(426534,426557,304,426811);h=e<<2;g=(h|0)==0?1:h;while(1){e=fgb(g)|0;if(e|0){R=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){R=0;break}Qh[e&7]()}zpb(R|0,0,h|0)|0;e=k[T>>2]|0;o[R>>2]=0.0;v=k[U>>2]|0;d:do if((e|0)>1){t=e+-1|0;if((v|0)<=0){e=0;while(1){e=e+1|0;k[R+(e<<2)>>2]=0;if((e|0)==(t|0))break d}}p=k[a+12>>2]|0;q=(p|0)>0;n=0;e=0;do{g=n;n=n+1|0;l=R+(n<<2)|0;k[l>>2]=e;if(q){j=k[f+(g*12|0)>>2]|0;h=0;d=(k[u>>2]=e,+o[u>>2]);do{g=k[j+(h*12|0)>>2]|0;e=0;do{d=d-+o[g+(e<<2)>>2];o[l>>2]=d;e=e+1|0}while((e|0)!=(p|0));h=h+1|0}while((h|0)!=(v|0));e=(o[u>>2]=d,k[u>>2]|0)}}while((n|0)!=(t|0))}while(0);if(!v)Vd();if(v>>>0>1073741823)ad(426534,426557,304,426811);h=v<<2;g=(h|0)==0?1:h;while(1){e=fgb(g)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}zpb(e|0,0,h|0)|0;g=k[U>>2]|0;o[e>>2]=0.0;e:do if((g|0)>1){w=k[T>>2]|0;j=a+12|0;x=g+-1|0;if((w|0)<=0){g=0;while(1){g=g+1|0;k[e+(g<<2)>>2]=0;if((g|0)==(x|0)){Q=e;break e}}}t=k[j>>2]|0;v=(t|0)>0;q=0;g=0;do{l=q;q=q+1|0;p=e+(q<<2)|0;k[p>>2]=g;if(v){n=0;d=(k[u>>2]=g,+o[u>>2]);do{h=k[(k[f+(n*12|0)>>2]|0)+(l*12|0)>>2]|0;g=0;do{d=d-+o[h+(g<<2)>>2];o[p>>2]=d;g=g+1|0}while((g|0)!=(t|0));n=n+1|0}while((n|0)!=(w|0));g=(o[u>>2]=d,k[u>>2]|0)}}while((q|0)!=(x|0));Q=e}else{j=a+12|0;Q=e}while(0);e=k[j>>2]|0;if(!e)Vd();if(e>>>0>1073741823)ad(426534,426557,304,426811);h=e<<2;g=(h|0)==0?1:h;while(1){e=fgb(g)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}zpb(e|0,0,h|0)|0;x=k[j>>2]|0;o[e>>2]=0.0;f:do if((x|0)>1){t=k[T>>2]|0;w=x+-1|0;if((t|0)<=0){g=0;while(1){g=g+1|0;k[e+(g<<2)>>2]=0;if((g|0)==(w|0))break f}}q=k[U>>2]|0;v=(q|0)>0;p=0;g=0;do{j=p;p=p+1|0;n=e+(p<<2)|0;k[n>>2]=g;if(v){l=0;d=(k[u>>2]=g,+o[u>>2]);do{h=k[f+(l*12|0)>>2]|0;g=0;do{d=d-+o[(k[h+(g*12|0)>>2]|0)+(j<<2)>>2];o[n>>2]=d;g=g+1|0}while((g|0)!=(q|0));l=l+1|0}while((l|0)!=(t|0));g=(o[u>>2]=d,k[u>>2]|0)}}while((p|0)!=(w|0))}while(0);c=a+16|0;k[c>>2]=0;if((x|0)>0){G=k[U>>2]|0;H=(G|0)>0;I=a+84|0;J=a+72|0;K=a+108|0;L=a+96|0;M=x+-1|0;N=G+-1|0;h=0;g=0;while(1){if(H){z=k[T>>2]|0;B=(z|0)>0;C=h+1|0;D=(h|0)==(M|0);E=z+-1|0;F=(h|0)<(M|0);b=e+(C<<2)|0;y=0;while(1){p=y;y=y+1|0;g:do if(B){t=(p|0)==(N|0);v=(p|0)<(N|0);w=Q+(y<<2)|0;q=0;do{if(D&((q|0)==(E|0)&t))break g;n=f+(q*12|0)|0;O=+o[(k[(k[n>>2]|0)+(p*12|0)>>2]|0)+(h<<2)>>2];l=(q|0)<(E|0);if(l)s=+P(+(O+ +o[R+(q+1<<2)>>2]));else s=3402823466385288598117041.0e14;if(v)d=+P(+(O+ +o[w>>2]));else d=3402823466385288598117041.0e14;if(F)A=+P(+(O+ +o[b>>2]));else A=3402823466385288598117041.0e14;do if(!(s<d&s<A))if(d<A){j=(k[(k[(k[J>>2]|0)+(q*12|0)>>2]|0)+(p*12|0)>>2]|0)+(h*20|0)|0;if(l){ea=(k[(k[(k[I>>2]|0)+(q*12|0)>>2]|0)+(p*12|0)>>2]|0)+(h*20|0)|0;l=g+1|0;k[c>>2]=l;k[(k[K>>2]|0)+(g<<2)>>2]=ea;g=l}if(F){l=(k[(k[(k[L>>2]|0)+(q*12|0)>>2]|0)+(p*12|0)>>2]|0)+(h*20|0)|0;ea=g+1|0;k[c>>2]=ea;k[(k[K>>2]|0)+(g<<2)>>2]=l;g=ea}ea=(k[(k[n>>2]|0)+(y*12|0)>>2]|0)+(h<<2)|0;o[ea>>2]=O+ +o[ea>>2];o[w>>2]=O+ +o[w>>2];break}else{j=(k[(k[(k[L>>2]|0)+(q*12|0)>>2]|0)+(p*12|0)>>2]|0)+(h*20|0)|0;if(v){fa=(k[(k[(k[J>>2]|0)+(q*12|0)>>2]|0)+(p*12|0)>>2]|0)+(h*20|0)|0;ea=g+1|0;k[c>>2]=ea;k[(k[K>>2]|0)+(g<<2)>>2]=fa;g=ea}if(l){ea=(k[(k[(k[I>>2]|0)+(q*12|0)>>2]|0)+(p*12|0)>>2]|0)+(h*20|0)|0;fa=g+1|0;k[c>>2]=fa;k[(k[K>>2]|0)+(g<<2)>>2]=ea;g=fa}fa=(k[(k[n>>2]|0)+(p*12|0)>>2]|0)+(C<<2)|0;o[fa>>2]=O+ +o[fa>>2];o[b>>2]=O+ +o[b>>2];break}else{j=(k[(k[(k[I>>2]|0)+(q*12|0)>>2]|0)+(p*12|0)>>2]|0)+(h*20|0)|0;if(v){ea=(k[(k[(k[J>>2]|0)+(q*12|0)>>2]|0)+(p*12|0)>>2]|0)+(h*20|0)|0;fa=g+1|0;k[c>>2]=fa;k[(k[K>>2]|0)+(g<<2)>>2]=ea;g=fa}if(F){ea=(k[(k[(k[L>>2]|0)+(q*12|0)>>2]|0)+(p*12|0)>>2]|0)+(h*20|0)|0;fa=g+1|0;k[c>>2]=fa;k[(k[K>>2]|0)+(g<<2)>>2]=ea;g=fa}fa=q+1|0;ea=(k[(k[f+(fa*12|0)>>2]|0)+(p*12|0)>>2]|0)+(h<<2)|0;o[ea>>2]=O+ +o[ea>>2];fa=R+(fa<<2)|0;o[fa>>2]=O+ +o[fa>>2]}while(0);A=+P(+O);o[j>>2]=A;k[j+4>>2]=O>0.0&1;k[(k[j+8>>2]|0)+28>>2]=j;q=q+1|0}while((q|0)<(z|0))}while(0);if((y|0)==(G|0)){h=C;break}}}else h=h+1|0;if((h|0)>=(x|0)){n=f;break}}}else n=f;if(e|0)ggb(e);if(Q|0)ggb(Q);if(R|0)ggb(R);if(!n)break;if((m|0)!=(n|0))do{f=m;m=m+-12|0;e=k[m>>2]|0;if(e|0){l=f+-8|0;f=k[l>>2]|0;if((f|0)!=(e|0)){do{g=f+-12|0;k[l>>2]=g;h=k[g>>2]|0;j=h;if(!h)f=g;else{f=f+-8|0;g=k[f>>2]|0;if((g|0)!=(h|0))k[f>>2]=g+(~((g+-4-j|0)>>>2)<<2);ggb(h);f=k[l>>2]|0}}while((f|0)!=(e|0));e=k[m>>2]|0}ggb(e)}}while((m|0)!=(n|0));ggb(n);break}}while(0);l=k[T>>2]|0;f=~~(+(l|0)*.5+-.5);j=k[U>>2]|0;e=~~(+(j|0)*.5+-.5);g=a+12|0;Q=k[a>>2]|0;h=(Q|0)==2;if(h)e=(k[(k[a+24>>2]|0)+(f*12|0)>>2]|0)+(e*36|0)|0;else e=(k[(k[(k[a+60>>2]|0)+(f*12|0)>>2]|0)+(e*12|0)>>2]|0)+(~~(+(k[g>>2]|0)*.5+-.5)*36|0)|0;k[V>>2]=e;k[e+16>>2]=0;k[e+20>>2]=0;k[e+24>>2]=0;k[e+32>>2]=0;R=a+120|0;k[k[R>>2]>>2]=e;L=aa(j,l)|0;e=k[g>>2]|0;L=aa(L,(e|0)<1?1:e)|0;if((L|0)>1){M=a+24|0;N=a+60|0;K=h?4:6;J=j+-1|0;I=l+-1|0;E=e+-1|0;f=0;D=0;g=1;do{e=k[R>>2]|0;F=k[e+(D<<2)>>2]|0;D=D+1|0;b=k[F>>2]|0;c=k[F+4>>2]|0;G=k[F+8>>2]|0;H=F+28|0;h=k[H>>2]|0;if(h){f=k[h+12>>2]|0;k[f+24>>2]=F;k[f+32>>2]=h;k[e+(g<<2)>>2]=f;g=g+1|0}m=F+24|0;n=(c|0)>0;p=c+-1|0;q=(b|0)>0;t=b+-1|0;v=c+1|0;w=b+1|0;x=(G|0)>0;y=G+-1|0;z=G+1|0;B=(c|0)<(J|0);C=(b|0)<(I|0);l=(G|0)>=(E|0);j=0;do{h:do switch(Q|0){case 2:{if(n&(j|0)==0){f=(k[(k[M>>2]|0)+(b*12|0)>>2]|0)+(p*36|0)|0;S=387;break h}if(q&(j|0)==1){f=(k[(k[M>>2]|0)+(t*12|0)>>2]|0)+(c*36|0)|0;S=387;break h}switch(j|0){case 2:{if(!B)break h;f=(k[(k[M>>2]|0)+(b*12|0)>>2]|0)+(v*36|0)|0;S=387;break h}case 3:{if(!C)break h;f=(k[(k[M>>2]|0)+(w*12|0)>>2]|0)+(c*36|0)|0;S=387;break h}default:break h}}case 3:{if(n&(j|0)==0){f=(k[(k[(k[N>>2]|0)+(b*12|0)>>2]|0)+(p*12|0)>>2]|0)+(G*36|0)|0;S=387;break h}if((j|0)==1){if(!B)break h;f=(k[(k[(k[N>>2]|0)+(b*12|0)>>2]|0)+(v*12|0)>>2]|0)+(G*36|0)|0;S=387;break h}if(q&(j|0)==2){f=(k[(k[(k[N>>2]|0)+(t*12|0)>>2]|0)+(c*12|0)>>2]|0)+(G*36|0)|0;S=387;break h}if((j|0)==3){if(!C)break h;f=(k[(k[(k[N>>2]|0)+(w*12|0)>>2]|0)+(c*12|0)>>2]|0)+(G*36|0)|0;S=387;break h}if(x&(j|0)==4){f=(k[(k[(k[N>>2]|0)+(b*12|0)>>2]|0)+(c*12|0)>>2]|0)+(y*36|0)|0;S=387;break h}if(!((j|0)!=5|l)){f=(k[(k[(k[N>>2]|0)+(b*12|0)>>2]|0)+(c*12|0)>>2]|0)+(z*36|0)|0;S=387}break}default:S=387}while(0);do if((S|0)==387){S=0;if(((f|0)!=(k[m>>2]|0)?(Y=f+28|0,Z=k[Y>>2]|0,(Z|0)!=0):0)?(_=Z+12|0,(k[_>>2]|0)==(F|0)):0){k[f+24>>2]=F;k[f+32>>2]=Z;k[Y>>2]=0;e=g+1|0;k[(k[R>>2]|0)+(g<<2)>>2]=f;k[Z+8>>2]=F;k[_>>2]=f;fa=Z+4|0;k[fa>>2]=(k[fa>>2]|0)==0&1;if(!h){k[H>>2]=Z;h=Z;g=e;break}else{k[h+16>>2]=Z;h=Z;g=e;break}}}while(0);j=j+1|0}while((j|0)<(K|0))}while((g|0)<(L|0)&(D|0)<(g|0))}b=a+148|0;k[b>>2]=0;w=k[a+20>>2]|0;do if((w|0)>0){x=a+136|0;c=a+140|0;y=a+108|0;z=k[a+16>>2]|0;B=(z|0)>0;C=a+176|0;D=a+180|0;E=a+144|0;F=a+152|0;v=a+164|0;e=0;while(1){if(!e){k[k[R>>2]>>2]=k[V>>2];n=0;f=1;do{j=k[R>>2]|0;g=k[j+(n<<2)>>2]|0;n=n+1|0;h=k[g+28>>2]|0;if(h){m=g+20|0;l=g+16|0;fa=k[h+12>>2]|0;k[fa+20>>2]=(k[m>>2]|0)+1;k[fa+16>>2]=(k[h+4>>2]|0?-1:1)+(k[l>>2]|0);h=k[h+16>>2]|0;g=f+1|0;k[j+(f<<2)>>2]=fa;if(!h)f=g;else while(1){fa=k[R>>2]|0;ea=k[h+12>>2]|0;k[ea+20>>2]=(k[m>>2]|0)+1;k[ea+16>>2]=(k[h+4>>2]|0?-1:1)+(k[l>>2]|0);h=k[h+16>>2]|0;f=g+1|0;k[fa+(g<<2)>>2]=ea;if(!h)break;else g=f}}}while((n|0)<(f|0))}else{k[k[R>>2]>>2]=k[(k[x>>2]|0)+12>>2];n=0;f=1;do{j=k[R>>2]|0;g=k[j+(n<<2)>>2]|0;n=n+1|0;h=k[g+28>>2]|0;if(h){m=g+20|0;l=g+16|0;fa=k[h+12>>2]|0;k[fa+20>>2]=(k[m>>2]|0)+1;k[fa+16>>2]=(k[h+4>>2]|0?-1:1)+(k[l>>2]|0);h=k[h+16>>2]|0;g=f+1|0;k[j+(f<<2)>>2]=fa;if(!h)f=g;else while(1){fa=k[R>>2]|0;ea=k[h+12>>2]|0;k[ea+20>>2]=(k[m>>2]|0)+1;k[ea+16>>2]=(k[h+4>>2]|0?-1:1)+(k[l>>2]|0);h=k[h+16>>2]|0;f=g+1|0;k[fa+(g<<2)>>2]=ea;if(!h)break;else g=f}}}while((n|0)<(f|0))}k[x>>2]=0;if(!B){S=459;break}n=k[y>>2]|0;j=0;m=0;l=-1;while(1){g=k[n+(m<<2)>>2]|0;f=k[(k[g+8>>2]|0)+16>>2]|0;g=k[(k[g+12>>2]|0)+16>>2]|0;h=g+(1-f)|0;if((h|0)<(j|0))t=m;else{h=f+1-g|0;t=(h|0)<(j|0);h=t?h:j;t=t?m:l}m=m+1|0;if((m|0)==(z|0))break;else{j=h;l=t}}if((t|0)<=-1){S=459;break}m=k[n+(t<<2)>>2]|0;k[x>>2]=m;f=m+12|0;g=k[f>>2]|0;j=m+8|0;l=k[j>>2]|0;if((h|0)==(1-(k[g+16>>2]|0)+(k[l+16>>2]|0)|0)){k[j>>2]=g;k[f>>2]=l}else g=l;k[m+4>>2]=1;h=k[m+12>>2]|0;k[C>>2]=0;k[D>>2]=0;k[E>>2]=0;f=k[g+20>>2]|0;l=k[h+20>>2]|0;if((f|0)>(l|0)){d=3402823466385288598117041.0e14;j=0;do{f=k[g+32>>2]|0;fa=j;j=j+1|0;k[(k[F>>2]|0)+(fa<<2)>>2]=f;if((k[f+4>>2]|0)==0?($=+o[f>>2],$<d):0){k[E>>2]=f;d=$}g=k[g+24>>2]|0;f=k[g+20>>2]|0}while((f|0)>(l|0));k[C>>2]=j;m=f}else{d=3402823466385288598117041.0e14;j=0;m=f}if((l|0)>(m|0)){l=h;f=0;n=0;do{h=k[l+32>>2]|0;fa=n;n=n+1|0;k[(k[v>>2]|0)+(fa<<2)>>2]=h;if((k[h+4>>2]|0)!=0?(ba=+o[h>>2],ba<d):0){k[E>>2]=h;d=ba;f=1}l=k[l+24>>2]|0}while((k[l+20>>2]|0)>(m|0));k[D>>2]=n;h=l;l=n}else{f=0;l=0}if((h|0)==(g|0))h=l;else{m=h;do{h=k[g+32>>2]|0;fa=j;j=j+1|0;k[(k[F>>2]|0)+(fa<<2)>>2]=h;if((k[h+4>>2]|0)==0?(ca=+o[h>>2],ca<d):0){k[E>>2]=h;d=ca;f=0}g=k[g+24>>2]|0;h=k[m+32>>2]|0;fa=l;l=l+1|0;k[(k[v>>2]|0)+(fa<<2)>>2]=h;do if(k[h+4>>2]|0){s=+o[h>>2];if(!(s<d))break;k[E>>2]=h;d=s;f=1}while(0);m=k[m+24>>2]|0}while((m|0)!=(g|0));k[C>>2]=j;k[D>>2]=l;h=l}if(!f){fa=k[x>>2]|0;_=fa+8|0;a=k[_>>2]|0;ea=fa+12|0;k[_>>2]=k[ea>>2];k[ea>>2]=a;fa=fa+4|0;k[fa>>2]=(k[fa>>2]|0)==0&1}l=k[E>>2]|0;s=+o[l>>2];m=l;if((j|0)>0){g=k[F>>2]|0;d=-s;f=0;do{fa=k[g+(f<<2)>>2]|0;o[fa>>2]=+o[fa>>2]+((k[fa+4>>2]|0)==0?d:s);f=f+1|0}while((f|0)!=(j|0))}if((h|0)>0){g=k[v>>2]|0;d=-s;f=0;do{fa=k[g+(f<<2)>>2]|0;o[fa>>2]=+o[fa>>2]+((k[fa+4>>2]|0)==0?s:d);f=f+1|0}while((f|0)!=(h|0))}h=k[l+12>>2]|0;g=(k[l+8>>2]|0)+28|0;f=k[g>>2]|0;if((f|0)==(l|0))k[g>>2]=k[l+16>>2];else{do{g=f+16|0;f=k[g>>2]|0}while((f|0)!=(l|0));k[g>>2]=k[l+16>>2]}k[h+24>>2]=0;k[h+32>>2]=0;k[(k[y>>2]|0)+(t<<2)>>2]=m;n=k[x>>2]|0;p=k[n+8>>2]|0;q=k[n+12>>2]|0;o[n>>2]=s;f=p+28|0;k[n+16>>2]=k[f>>2];k[f>>2]=n;f=q;g=p;h=n;i:while(1){l=f;while(1){if(!l)break i;ea=l+24|0;j=k[ea>>2]|0;fa=l+32|0;m=k[fa>>2]|0;k[ea>>2]=g;k[fa>>2]=h;if(!j)l=0;else break}g=j+28|0;f=k[g>>2]|0;if((f|0)==(m|0)){f=m+16|0;k[g>>2]=k[f>>2]}else{do{g=f+16|0;f=k[g>>2]|0}while((f|0)!=(m|0));f=m+16|0;k[g>>2]=k[f>>2]}k[m+8>>2]=l;k[m+12>>2]=j;g=m+4|0;k[g>>2]=(k[g>>2]|0)==0&1;g=l+28|0;k[f>>2]=k[g>>2];k[g>>2]=m;f=j;g=l;h=m}k[q+16>>2]=(k[n+4>>2]|0?-1:1)+(k[p+16>>2]|0);k[q+20>>2]=(k[p+20>>2]|0)+1;e=e+1|0;k[b>>2]=e;if((e|0)>=(w|0)){S=460;break}}if((S|0)==459){k[c>>2]=-1;k[b>>2]=e+1;break}else if((S|0)==460){k[c>>2]=t;break}}while(0);ggb(X);ggb(W);k[k[R>>2]>>2]=k[V>>2];l=0;e=1;d=0.0;do{h=k[R>>2]|0;j=k[(k[h+(l<<2)>>2]|0)+28>>2]|0;l=l+1|0;if(j){d=d+ +o[j>>2];g=k[j+16>>2]|0;f=e+1|0;k[h+(e<<2)>>2]=k[j+12>>2];if(!g)e=f;else while(1){d=d+ +o[g>>2];fa=g;g=k[g+16>>2]|0;e=f+1|0;k[(k[R>>2]|0)+(f<<2)>>2]=k[fa+12>>2];if(!g)break;else f=e}}}while((l|0)<(e|0));r=da;return +d}function t$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+8|0;f=k[l>>2]|0;m=a+4|0;i=k[m>>2]|0;e=i;if(((f-i|0)/12|0)>>>0>=b>>>0){zpb(i|0,0,b*12|0)|0;k[m>>2]=e+(b*12|0);return}c=k[a>>2]|0;h=(i-c|0)/12|0;d=h+b|0;if(d>>>0>357913941)ad(426534,426557,304,426811);j=c;f=(f-c|0)/12|0;g=f<<1;g=f>>>0<178956970?(g>>>0<d>>>0?d:g):357913941;if(!g)f=0;else{if(g>>>0>357913941){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=g*12|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}f=c}c=f+(h*12|0)|0;d=c;g=f+(g*12|0)|0;zpb(c|0,0,b*12|0)|0;f=c+(b*12|0)|0;if((e|0)!=(j|0)){do{e=e+-12|0;A$a(c+-12|0,e);c=d+-12|0;d=c}while((e|0)!=(j|0));i=k[a>>2]|0;e=k[m>>2]|0}k[a>>2]=d;k[m>>2]=f;k[l>>2]=g;h=i;if((e|0)!=(h|0))do{c=e;e=e+-12|0;f=k[e>>2]|0;g=f;if(f|0){c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(f|0))k[c>>2]=d+(~(((d+-36-g|0)>>>0)/36|0)*36|0);ggb(f)}}while((e|0)!=(h|0));if(!i)return;ggb(i);return}function u$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+8|0;f=k[l>>2]|0;m=a+4|0;i=k[m>>2]|0;e=i;if(((f-i|0)/12|0)>>>0>=b>>>0){zpb(i|0,0,b*12|0)|0;k[m>>2]=e+(b*12|0);return}c=k[a>>2]|0;h=(i-c|0)/12|0;d=h+b|0;if(d>>>0>357913941)ad(426534,426557,304,426811);j=c;f=(f-c|0)/12|0;g=f<<1;g=f>>>0<178956970?(g>>>0<d>>>0?d:g):357913941;if(!g)f=0;else{if(g>>>0>357913941){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=g*12|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}f=c}c=f+(h*12|0)|0;d=c;g=f+(g*12|0)|0;zpb(c|0,0,b*12|0)|0;f=c+(b*12|0)|0;if((e|0)!=(j|0)){do{e=e+-12|0;z$a(c+-12|0,e);c=d+-12|0;d=c}while((e|0)!=(j|0));i=k[a>>2]|0;e=k[m>>2]|0}k[a>>2]=d;k[m>>2]=f;k[l>>2]=g;h=i;if((e|0)!=(h|0))do{c=e;e=e+-12|0;f=k[e>>2]|0;g=f;if(f|0){c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(f|0))k[c>>2]=d+(~(((d+-20-g|0)>>>0)/20|0)*20|0);ggb(f)}}while((e|0)!=(h|0));if(!i)return;ggb(i);return}function v$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+8|0;e=k[i>>2]|0;j=a+4|0;c=k[j>>2]|0;if(e-c>>2>>>0>=b>>>0){do{k[c>>2]=0;c=(k[j>>2]|0)+4|0;k[j>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=c-d>>2;c=f+b|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);g=e-d|0;h=g>>1;h=g>>2>>>0<536870911?(h>>>0<c>>>0?c:h):1073741823;if(!h)c=0;else{if(h>>>0>1073741823){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=h<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}g=c+(f<<2)|0;f=g;d=g;do{k[d>>2]=0;d=f+4|0;f=d;b=b+-1|0}while((b|0)!=0);d=k[a>>2]|0;e=(k[j>>2]|0)-d|0;b=g+(0-(e>>2)<<2)|0;if((e|0)>0)upb(b|0,d|0,e|0)|0;k[a>>2]=b;k[j>>2]=f;k[i>>2]=c+(h<<2);if(!d)return;ggb(d);return}function w$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+8|0;e=k[i>>2]|0;j=a+4|0;c=k[j>>2]|0;if(e-c>>2>>>0>=b>>>0){do{k[c>>2]=0;c=(k[j>>2]|0)+4|0;k[j>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=c-d>>2;c=f+b|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);g=e-d|0;h=g>>1;h=g>>2>>>0<536870911?(h>>>0<c>>>0?c:h):1073741823;if(!h)c=0;else{if(h>>>0>1073741823){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=h<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}g=c+(f<<2)|0;f=g;d=g;do{k[d>>2]=0;d=f+4|0;f=d;b=b+-1|0}while((b|0)!=0);d=k[a>>2]|0;e=(k[j>>2]|0)-d|0;b=g+(0-(e>>2)<<2)|0;if((e|0)>0)upb(b|0,d|0,e|0)|0;k[a>>2]=b;k[j>>2]=f;k[i>>2]=c+(h<<2);if(!d)return;ggb(d);return}function x$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+8|0;e=k[i>>2]|0;j=a+4|0;c=k[j>>2]|0;if(((e-c|0)/36|0)>>>0>=b>>>0){do{d=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));c=(k[j>>2]|0)+36|0;k[j>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=(c-d|0)/36|0;c=f+b|0;if(c>>>0>119304647)ad(426534,426557,304,426811);g=(e-d|0)/36|0;h=g<<1;h=g>>>0<59652323?(h>>>0<c>>>0?c:h):119304647;if(!h)g=0;else{if(h>>>0>119304647){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=h*36|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}g=c}f=g+(f*36|0)|0;c=f;e=f;do{d=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));c=e+36|0;e=c;b=b+-1|0}while((b|0)!=0);b=k[a>>2]|0;d=(k[j>>2]|0)-b|0;c=f+(((d|0)/-36|0)*36|0)|0;if((d|0)>0)upb(c|0,b|0,d|0)|0;k[a>>2]=c;k[j>>2]=e;k[i>>2]=g+(h*36|0);if(!b)return;ggb(b);return}function y$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+8|0;e=k[i>>2]|0;j=a+4|0;c=k[j>>2]|0;if(((e-c|0)/20|0)>>>0>=b>>>0){do{k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;k[c+16>>2]=0;c=(k[j>>2]|0)+20|0;k[j>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=(c-d|0)/20|0;c=f+b|0;if(c>>>0>214748364)ad(426534,426557,304,426811);g=(e-d|0)/20|0;h=g<<1;h=g>>>0<107374182?(h>>>0<c>>>0?c:h):214748364;if(!h)c=0;else{if(h>>>0>214748364){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=h*20|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}g=c+(f*20|0)|0;d=g;f=g;do{k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;d=f+20|0;f=d;b=b+-1|0}while((b|0)!=0);d=k[a>>2]|0;e=(k[j>>2]|0)-d|0;b=g+(((e|0)/-20|0)*20|0)|0;if((e|0)>0)upb(b|0,d|0,e|0)|0;k[a>>2]=b;k[j>>2]=f;k[i>>2]=c+(h*20|0);if(!d)return;ggb(d);return}function z$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;k[a>>2]=0;h=a+4|0;k[h>>2]=0;k[a+8>>2]=0;g=b+4|0;d=(k[g>>2]|0)-(k[b>>2]|0)|0;f=(d|0)/20|0;if(!d)return;if(f>>>0>214748364)ad(426534,426557,304,426811);while(1){c=fgb(d)|0;if(c|0){e=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){e=0;break}Qh[c&7]()}k[h>>2]=e;k[a>>2]=e;k[a+8>>2]=e+(f*20|0);d=k[b>>2]|0;c=(k[g>>2]|0)-d|0;if((c|0)<=0)return;upb(e|0,d|0,c|0)|0;k[h>>2]=e+(((c>>>0)/20|0)*20|0);return}function A$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;k[a>>2]=0;h=a+4|0;k[h>>2]=0;k[a+8>>2]=0;g=b+4|0;d=(k[g>>2]|0)-(k[b>>2]|0)|0;f=(d|0)/36|0;if(!d)return;if(f>>>0>119304647)ad(426534,426557,304,426811);while(1){c=fgb(d)|0;if(c|0){e=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){e=0;break}Qh[c&7]()}k[h>>2]=e;k[a>>2]=e;k[a+8>>2]=e+(f*36|0);d=k[b>>2]|0;c=(k[g>>2]|0)-d|0;if((c|0)<=0)return;upb(e|0,d|0,c|0)|0;k[h>>2]=e+(((c>>>0)/36|0)*36|0);return}function B$a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;b=k[a+164>>2]|0;c=b;if(b|0){d=a+168|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+152>>2]|0;c=b;if(b|0){d=a+156|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+108>>2]|0;c=b;if(b|0){d=a+112|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}j=a+96|0;b=k[j>>2]|0;if(b|0){l=a+100|0;c=k[l>>2]|0;if((c|0)!=(b|0)){do{h=c+-12|0;k[l>>2]=h;i=k[h>>2]|0;if(!i)c=h;else{g=c+-8|0;c=k[g>>2]|0;if((c|0)==(i|0))c=i;else{do{d=c+-12|0;k[g>>2]=d;e=k[d>>2]|0;f=e;if(!e)c=d;else{c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(e|0))k[c>>2]=d+(~(((d+-20-f|0)>>>0)/20|0)*20|0);ggb(e);c=k[g>>2]|0}}while((c|0)!=(i|0));c=k[h>>2]|0}ggb(c);c=k[l>>2]|0}}while((c|0)!=(b|0));b=k[j>>2]|0}ggb(b)}j=a+84|0;b=k[j>>2]|0;if(b|0){l=a+88|0;c=k[l>>2]|0;if((c|0)!=(b|0)){d=c;while(1){i=d+-12|0;k[l>>2]=i;c=k[i>>2]|0;if(!c)c=i;else{h=d+-8|0;d=k[h>>2]|0;if((d|0)!=(c|0)){do{e=d+-12|0;k[h>>2]=e;f=k[e>>2]|0;g=f;if(!f)d=e;else{d=d+-8|0;e=k[d>>2]|0;if((e|0)!=(f|0))k[d>>2]=e+(~(((e+-20-g|0)>>>0)/20|0)*20|0);ggb(f);d=k[h>>2]|0}}while((d|0)!=(c|0));c=k[i>>2]|0}ggb(c);c=k[l>>2]|0}if((c|0)==(b|0))break;else d=c}b=k[j>>2]|0}ggb(b)}j=a+72|0;b=k[j>>2]|0;if(b|0){l=a+76|0;c=k[l>>2]|0;if((c|0)!=(b|0)){do{h=c+-12|0;k[l>>2]=h;i=k[h>>2]|0;if(!i)c=h;else{g=c+-8|0;c=k[g>>2]|0;if((c|0)==(i|0))c=i;else{do{d=c+-12|0;k[g>>2]=d;e=k[d>>2]|0;f=e;if(!e)c=d;else{c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(e|0))k[c>>2]=d+(~(((d+-20-f|0)>>>0)/20|0)*20|0);ggb(e);c=k[g>>2]|0}}while((c|0)!=(i|0));c=k[h>>2]|0}ggb(c);c=k[l>>2]|0}}while((c|0)!=(b|0));b=k[j>>2]|0}ggb(b)}j=a+60|0;b=k[j>>2]|0;if(b|0){l=a+64|0;c=k[l>>2]|0;if((c|0)!=(b|0)){do{h=c+-12|0;k[l>>2]=h;i=k[h>>2]|0;if(!i)c=h;else{g=c+-8|0;c=k[g>>2]|0;if((c|0)==(i|0))c=i;else{do{d=c+-12|0;k[g>>2]=d;e=k[d>>2]|0;f=e;if(!e)c=d;else{c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(e|0))k[c>>2]=d+(~(((d+-36-f|0)>>>0)/36|0)*36|0);ggb(e);c=k[g>>2]|0}}while((c|0)!=(i|0));c=k[h>>2]|0}ggb(c);c=k[l>>2]|0}}while((c|0)!=(b|0));b=k[j>>2]|0}ggb(b)}g=a+48|0;b=k[g>>2]|0;if(b|0){h=a+52|0;c=k[h>>2]|0;if((c|0)!=(b|0)){do{d=c+-12|0;k[h>>2]=d;e=k[d>>2]|0;f=e;if(!e)c=d;else{c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(e|0))k[c>>2]=d+(~(((d+-20-f|0)>>>0)/20|0)*20|0);ggb(e);c=k[h>>2]|0}}while((c|0)!=(b|0));b=k[g>>2]|0}ggb(b)}g=a+36|0;b=k[g>>2]|0;if(b|0){h=a+40|0;c=k[h>>2]|0;if((c|0)!=(b|0)){do{d=c+-12|0;k[h>>2]=d;e=k[d>>2]|0;f=e;if(!e)c=d;else{c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(e|0))k[c>>2]=d+(~(((d+-20-f|0)>>>0)/20|0)*20|0);ggb(e);c=k[h>>2]|0}}while((c|0)!=(b|0));b=k[g>>2]|0}ggb(b)}h=a+24|0;b=k[h>>2]|0;if(!b)return;g=a+28|0;c=k[g>>2]|0;if((c|0)!=(b|0)){do{d=c+-12|0;k[g>>2]=d;e=k[d>>2]|0;f=e;if(!e)c=d;else{c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(e|0))k[c>>2]=d+(~(((d+-36-f|0)>>>0)/36|0)*36|0);ggb(e);c=k[g>>2]|0}}while((c|0)!=(b|0));b=k[h>>2]|0}ggb(b);return}function C$a(a){a=a|0;ggb(a);return}function D$a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function E$a(a){a=a|0;var b=0,c=0;k[a>>2]=149880;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b)return;a=b+-4|0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)!=1)return;ggb(k[b+-8>>2]|0);return}function F$a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=149880;c=a+4|0;b=k[c>>2]|0;k[a+8>>2]=0;k[c>>2]=0;if(!b){ggb(a);return}d=b+-4|0;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function G$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;f=g+4|0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=4;i[e+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+4|0)|0;f=g+4|0;e=ZT(16)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=8;i[e+12>>0]=0;e=c;i[e>>0]=109;i[e+1>>0]=97;i[e+2>>0]=120;i[e+3>>0]=95;c=c+4|0;i[c>>0]=98;i[c+1>>0]=105;i[c+2>>0]=116;i[c+3>>0]=115;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=U$a(b,a+12|0)|0;f=g+4|0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[f>>2]=13;i[d+17>>0]=0;d=393489;e=c+13|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=U$a(b,a+16|0)|0;f=g+4|0;e=ZT(8)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=3;i[e+7>>0]=0;i[c>>0]=i[393503]|0;i[c+1>>0]=i[393504]|0;i[c+2>>0]=i[393505]|0;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(!c){a=a+20|0;a=i[a>>0]|0;a=a&255;k[g>>2]=a;U$a(b,g)|0;r=h;return}e=c+-4|0;f=k[e>>2]|0;k[e>>2]=f+-1;if((f|0)!=1){a=a+20|0;a=i[a>>0]|0;a=a&255;k[g>>2]=a;U$a(b,g)|0;r=h;return}ggb(k[c+-8>>2]|0);a=a+20|0;a=i[a>>0]|0;a=a&255;k[g>>2]=a;U$a(b,g)|0;r=h;return}function H$a(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;m=o;n=b+4|0;d=k6(k[b>>2]|0,k[n>>2]|0,401026)|0;do if((d|0)!=0?(k[d>>2]&7|0)==3:0){k[m>>2]=0;j=m+4|0;k[j>>2]=0;J6(d,m,m);h=k[m>>2]|0;d=k[a+4>>2]|0;if((h|0)==(d|0)){k[j>>2]=0;k[m>>2]=0;if(h|0?(j=h+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[h+-8>>2]|0);break}f=(h|0)==0?1016759:h;e=(d|0)==0?1016759:d;d=i[f>>0]|0;g=i[e>>0]|0;if(d<<24>>24==0?1:d<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;d=i[f>>0]|0;g=i[e>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=g<<24>>24));e=g}d=d<<24>>24==e<<24>>24;k[j>>2]=0;k[m>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!d)l=14}else l=14;while(0);if((l|0)==14){d=m+4|0;e=ZT(40)|0;k[e>>2]=1;f=e+4|0;k[m>>2]=f;k[d>>2]=33;i[e+37>>0]=0;g=399944;h=f+33|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,m,401059,393415,196);k[d>>2]=0;k[m>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}d=k6(k[b>>2]|0,k[n>>2]|0,393480)|0;a:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break a}case 2:break;default:{d=2147483647;break a}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;m=d&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c}while(0);k[a+12>>2]=d;d=k6(k[b>>2]|0,k[n>>2]|0,393489)|0;b:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break b}case 2:break;default:{d=2147483647;break b}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;m=d&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c}while(0);k[a+16>>2]=d;d=k6(k[b>>2]|0,k[n>>2]|0,393503)|0;if(!d){n=0;n=(n|0)!=0;a=a+20|0;n=n&1;i[a>>0]=n;r=o;return}switch(k[d>>2]&7){case 1:{n=k[d+8>>2]|0;n=(n|0)!=0;a=a+20|0;n=n&1;i[a>>0]=n;r=o;return}case 2:{c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;n=d&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}n=~~c;n=(n|0)!=0;a=a+20|0;n=n&1;i[a>>0]=n;r=o;return}default:{n=2147483647;n=(n|0)!=0;a=a+20|0;n=n&1;i[a>>0]=n;r=o;return}}}function I$a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ph[k[(k[a>>2]|0)+36>>2]&511](a,b,c);return}function J$a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;ca=r;r=r+208|0;ba=ca+184|0;_=ca+128|0;V=ca+112|0;W=ca+56|0;X=ca+32|0;S=ca+16|0;T=ca;Q=ca+48|0;k[ba>>2]=0;R=ba+4|0;k[R>>2]=0;k[ba+8>>2]=0;B2(b,ba);W2a(ba);e=k[R>>2]|0;f=k[ba>>2]|0;P=(e-f|0)/56|0;g=f;Y1(c,P);P=P>>>1;d=g+(P*56|0)|0;KG((k[c>>2]|0)+(P*56|0)|0,d)|0;k[_>>2]=1124007936;$=_+4|0;b=_+8|0;Y=_+40|0;h=$;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[Y>>2]=b;aa=_+48|0;Z=_+44|0;k[Z>>2]=aa;k[_+52>>2]=0;k[aa>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;k[V>>2]=16842752;k[V+4>>2]=d;U=W+4|0;O=U+4|0;k[O>>2]=0;k[O+4>>2]=0;k[W>>2]=33619968;k[U>>2]=_;$aa(V,W,7,0);k[V>>2]=0;U=V+4|0;k[U>>2]=0;k[V+8>>2]=0;if((e|0)!=(f|0)){l=W+4|0;m=V+8|0;n=W+4|0;o=W+8|0;p=W+40|0;q=W+48|0;s=W+44|0;t=W+52|0;u=X+8|0;v=X+12|0;w=X+4|0;x=S+4|0;y=x+4|0;z=S+8|0;A=S+12|0;B=S+4|0;C=T+8|0;D=T+12|0;E=T+4|0;F=S+8|0;G=S+12|0;H=S+4|0;I=T+4|0;J=I+4|0;K=Q+4|0;L=X+4|0;M=W+36|0;N=W+16|0;O=W+32|0;e=0;b=f;d=g;while(1){if((e|0)==(P|0)){k[W>>2]=0;k[l>>2]=0;b=k[U>>2]|0;if((b|0)==(k[m>>2]|0))Efa(V,W);else{k[b>>2]=0;k[b+4>>2]=0;k[U>>2]=b+8}}else{k[W>>2]=1124007936;h=n;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[p>>2]=o;k[s>>2]=q;k[t>>2]=0;k[q>>2]=0;k[u>>2]=0;k[v>>2]=0;k[X>>2]=16842752;k[w>>2]=b+(e*56|0);b=y;k[b>>2]=0;k[b+4>>2]=0;k[S>>2]=33619968;k[x>>2]=W;$aa(X,S,7,0);b=k[(k[a>>2]|0)+40>>2]|0;k[z>>2]=0;k[A>>2]=0;k[S>>2]=16842752;k[B>>2]=_;k[C>>2]=0;k[D>>2]=0;k[T>>2]=16842752;k[E>>2]=W;dh[b&255](X,a,S,T);b=k[U>>2]|0;if((b|0)==(k[m>>2]|0))Efa(V,X);else{k[b>>2]=k[X>>2];k[b+4>>2]=k[L>>2];k[U>>2]=b+8}b=k[(k[a>>2]|0)+44>>2]|0;k[F>>2]=0;k[G>>2]=0;k[S>>2]=16842752;k[H>>2]=d+(e*56|0);j=(k[c>>2]|0)+(e*56|0)|0;h=J;k[h>>2]=0;k[h+4>>2]=0;k[T>>2]=33619968;k[I>>2]=j;k[Q>>2]=k[X>>2];k[K>>2]=k[L>>2];dh[b&255](a,S,T,Q);b=k[M>>2]|0;if(b|0?(h=b+12|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){d=k[M>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[O>>2]|0;if(!b){b=B1()|0;d=k[M>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[M>>2]=0}k[M>>2]=0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[n>>2]|0)>0){d=k[p>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[n>>2]|0))}b=k[s>>2]|0;if(!((b|0)==(q|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}b=e+1|0;d=k[ba>>2]|0;if(b>>>0<(((k[R>>2]|0)-d|0)/56|0)>>>0){e=b;b=d}else break}}if(i[a+20>>0]|0){b=k[U>>2]|0;d=k[V>>2]|0;j=d;if((b|0)==(d|0)){g=0;f=0;d=0;e=0}else{h=b-d>>3;g=0;b=0;f=0;d=0;e=0;do{S=k[j+(g<<3)>>2]|0;f=(S|0)>(f|0)?S:f;T=k[j+(g<<3)+4>>2]|0;e=(T|0)>(e|0)?T:e;b=(S|0)<(b|0)?S:b;d=(T|0)<(d|0)?T:d;g=g+1|0}while(g>>>0<h>>>0);g=b}h=k[c>>2]|0;b=k[h+40>>2]|0;x=c+4|0;if((k[x>>2]|0)!=(h|0)){s=(k[b+4>>2]|0)+g|0;g=(k[b>>2]|0)+d|0;u=(s|0)<(f|0)?s:f;v=(g|0)<(e|0)?g:e;w=X+4|0;s=((f|0)<(s|0)?s:f)-u|0;t=X+8|0;f=((e|0)<(g|0)?g:e)-v|0;g=X+12|0;j=W+36|0;l=W+16|0;m=W+4|0;n=W+40|0;o=W+44|0;p=W+48|0;q=W+32|0;e=0;b=h;do{b=b+(e*56|0)|0;k[X>>2]=u;k[w>>2]=v;k[t>>2]=s;k[g>>2]=f;I1(W,b,X);KG(b,W)|0;b=k[j>>2]|0;if(b|0?(S=b+12|0,T=k[S>>2]|0,k[S>>2]=T+-1,(T|0)==1):0){d=k[j>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[q>>2]|0;if(!b){b=B1()|0;d=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[j>>2]=0}k[j>>2]=0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[m>>2]|0)>0){d=k[n>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[o>>2]|0;if(!((b|0)==(p|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=e+1|0;b=k[c>>2]|0}while(e>>>0<(((k[x>>2]|0)-b|0)/56|0)>>>0)}}b=k[V>>2]|0;d=b;if(b|0){e=k[U>>2]|0;if((e|0)!=(b|0))k[U>>2]=e+(~((e+-8-d|0)>>>3)<<3);ggb(b)}e=_+36|0;b=k[e>>2]|0;if(b|0?(W=b+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[_+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;_=_+16|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[$>>2]|0)>0){d=k[Y>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[$>>2]|0))}b=k[Z>>2]|0;if((b|0)==(aa|0)|(b|0)==0){zF(ba);r=ca;return}ggb(k[b+-4>>2]|0);zF(ba);r=ca;return}function K$a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0;Rb=r;r=r+608|0;Lb=Rb+592|0;Qb=Rb+536|0;Pb=Rb+480|0;Mb=Rb+468|0;Nb=Rb+456|0;Ob=Rb+400|0;Ab=Rb+344|0;Bb=Rb+288|0;Cb=Rb+232|0;Db=Rb+168|0;Eb=Rb+104|0;Fb=Rb+48|0;Gb=Rb+32|0;Hb=Rb+224|0;Ib=Rb+160|0;Jb=Rb+16|0;Kb=Rb;do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[Qb>>2]=k[g>>2];m=Qb+4|0;c=g+4|0;k[m>>2]=k[c>>2];zb=Qb+8|0;k[zb>>2]=k[g+8>>2];k[Qb+12>>2]=k[g+12>>2];k[Qb+16>>2]=k[g+16>>2];k[Qb+20>>2]=k[g+20>>2];k[Qb+24>>2]=k[g+24>>2];k[Qb+28>>2]=k[g+28>>2];k[Qb+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Qb+36>>2]=e;f=Qb+40|0;k[f>>2]=zb;zb=Qb+48|0;j=Qb+44|0;k[j>>2]=zb;k[Qb+52>>2]=0;k[zb>>2]=0;if(e|0){zb=e+12|0;k[zb>>2]=(k[zb>>2]|0)+1}if((k[c>>2]|0)<3){yb=k[g+44>>2]|0;zb=k[j>>2]|0;k[zb>>2]=k[yb>>2];k[zb+4>>2]=k[yb+4>>2];break}k[m>>2]=0;x1(Qb,k[c>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;c=0;do{k[h+(c<<2)>>2]=k[l+(c<<2)>>2];k[e+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[m>>2]|0))}}else Q1(Qb,c,-1);while(0);do if((k[d>>2]&2031616|0)==65536){h=k[d+4>>2]|0;k[Pb>>2]=k[h>>2];m=Pb+4|0;e=h+4|0;k[m>>2]=k[e>>2];zb=Pb+8|0;k[zb>>2]=k[h+8>>2];k[Pb+12>>2]=k[h+12>>2];k[Pb+16>>2]=k[h+16>>2];k[Pb+20>>2]=k[h+20>>2];k[Pb+24>>2]=k[h+24>>2];k[Pb+28>>2]=k[h+28>>2];k[Pb+32>>2]=k[h+32>>2];c=k[h+36>>2]|0;k[Pb+36>>2]=c;f=Pb+40|0;k[f>>2]=zb;zb=Pb+48|0;j=Pb+44|0;k[j>>2]=zb;k[Pb+52>>2]=0;k[zb>>2]=0;if(c|0){zb=c+12|0;k[zb>>2]=(k[zb>>2]|0)+1}if((k[e>>2]|0)<3){yb=k[h+44>>2]|0;zb=k[j>>2]|0;k[zb>>2]=k[yb>>2];k[zb+4>>2]=k[yb+4>>2];break}k[m>>2]=0;x1(Pb,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;e=k[j>>2]|0;c=0;do{k[g+(c<<2)>>2]=k[l+(c<<2)>>2];k[e+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[m>>2]|0))}}else Q1(Pb,d,-1);while(0);zb=k[Qb>>2]|0;if(!((zb&4088|0)==0?!((k[Pb>>2]^zb)&4095|0):0)){k[Lb>>2]=0;c=Lb+4|0;k[c>>2]=0;e=ZT(56)|0;k[e>>2]=1;h=e+4|0;k[Lb>>2]=h;k[c>>2]=50;i[e+54>>0]=0;f=393349;m=h+50|0;do{i[h>>0]=i[f>>0]|0;h=h+1|0;f=f+1|0}while((h|0)<(m|0));Y8(-215,Lb,393400,393415,119);k[c>>2]=0;k[Lb>>2]=0;zb=k[e>>2]|0;k[e>>2]=zb+-1;if((zb|0)==1)ggb(k[e+-4>>2]|0)}c=k[Qb+8>>2]|0;o=k[Qb+12>>2]|0;c=~~(+_(+(+(((c|0)<(o|0)?o:c)|0)))/.6931471805599453)+-1|0;o=(k[b+12>>2]|0)+-1|0;c=(o|0)<(c|0)?o:c;k[Mb>>2]=0;k[Mb+4>>2]=0;k[Mb+8>>2]=0;k[Nb>>2]=0;k[Nb+4>>2]=0;k[Nb+8>>2]=0;T$a(Qb,Mb,c);T$a(Pb,Nb,c);k[a>>2]=0;o=a+4|0;k[o>>2]=0;if((c|0)>-1){p=Ob+4|0;q=Ob+8|0;s=Ob+40|0;t=Ob+48|0;u=Ob+44|0;v=Ob+52|0;w=Ab+4|0;x=Ab+8|0;y=Ab+40|0;z=Ab+48|0;A=Ab+44|0;B=Ab+52|0;C=Bb+4|0;D=Bb+8|0;E=Bb+40|0;F=Bb+48|0;G=Bb+44|0;H=Bb+52|0;I=Cb+4|0;J=Cb+8|0;K=Cb+40|0;L=Cb+48|0;M=Cb+44|0;N=Cb+52|0;O=Lb+8|0;P=Lb+12|0;Q=Lb+4|0;R=Db+4|0;S=R+4|0;T=Eb+4|0;U=T+4|0;V=Lb+8|0;W=Lb+12|0;X=Lb+4|0;Y=Db+4|0;Z=Y+4|0;$=Eb+4|0;ba=$+4|0;ca=Db+4|0;da=Db+8|0;ea=Db+40|0;fa=Db+48|0;ga=Db+44|0;ha=Db+52|0;ia=Eb+4|0;ja=Eb+8|0;ka=Eb+40|0;la=Eb+48|0;ma=Eb+44|0;na=Eb+52|0;oa=Fb+4|0;pa=Fb+8|0;qa=Fb+40|0;ra=Fb+48|0;sa=Fb+44|0;ta=Fb+52|0;ua=Lb+8|0;va=Lb+12|0;wa=Lb+4|0;xa=Gb+4|0;ya=xa+4|0;za=Hb+4|0;Aa=Lb+8|0;Ba=Lb+12|0;Ca=Lb+4|0;Da=Gb+4|0;Ea=Da+4|0;Fa=Ib+4|0;Ga=Gb+8|0;Ha=Gb+12|0;Ia=Gb+4|0;Ja=Jb+8|0;Ka=Jb+12|0;La=Jb+4|0;Ma=Kb+4|0;Na=Ma+4|0;Oa=Gb+8|0;Pa=Gb+12|0;Qa=Gb+4|0;Ra=Jb+8|0;Sa=Jb+12|0;Ta=Jb+4|0;Ua=Kb+4|0;Va=Ua+4|0;Wa=Gb+8|0;Xa=Gb+12|0;Ya=Gb+4|0;Za=Jb+8|0;_a=Jb+12|0;$a=Jb+4|0;ab=Kb+4|0;bb=ab+4|0;cb=Lb+8|0;db=Lb+12|0;eb=Lb+4|0;fb=Fb+36|0;gb=Fb+16|0;hb=Eb+36|0;ib=Eb+16|0;jb=Db+36|0;kb=Db+16|0;lb=Cb+36|0;mb=Cb+16|0;nb=Bb+36|0;ob=Bb+16|0;pb=Ab+36|0;qb=Ab+16|0;rb=Ob+36|0;sb=Ob+16|0;tb=Db+32|0;ub=Eb+32|0;vb=Fb+32|0;wb=Ob+32|0;xb=Ab+32|0;yb=Bb+32|0;zb=Cb+32|0;while(1){j=k[a>>2]<<1;k[a>>2]=j;l=k[o>>2]<<1;k[o>>2]=l;k[Ob>>2]=1124007936;h=p;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[s>>2]=q;k[u>>2]=t;k[v>>2]=0;k[t>>2]=0;k[Ab>>2]=1124007936;h=w;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[y>>2]=x;k[A>>2]=z;k[B>>2]=0;k[z>>2]=0;k[Bb>>2]=1124007936;h=C;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[E>>2]=D;k[G>>2]=F;k[H>>2]=0;k[F>>2]=0;k[Cb>>2]=1124007936;h=I;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[K>>2]=J;k[M>>2]=L;k[N>>2]=0;k[L>>2]=0;h=k[(k[b>>2]|0)+48>>2]|0;e=k[Mb>>2]|0;k[O>>2]=0;k[P>>2]=0;k[Lb>>2]=16842752;k[Q>>2]=e+(c*56|0);n=S;k[n>>2]=0;k[n+4>>2]=0;k[Db>>2]=33619968;k[R>>2]=Ob;n=U;k[n>>2]=0;k[n+4>>2]=0;k[Eb>>2]=33619968;k[T>>2]=Bb;dh[h&255](b,Lb,Db,Eb);h=k[(k[b>>2]|0)+48>>2]|0;n=(k[Nb>>2]|0)+(c*56|0)|0;k[V>>2]=0;k[W>>2]=0;k[Lb>>2]=16842752;k[X>>2]=n;n=Z;k[n>>2]=0;k[n+4>>2]=0;k[Db>>2]=33619968;k[Y>>2]=Ab;n=ba;k[n>>2]=0;k[n+4>>2]=0;k[Eb>>2]=33619968;k[$>>2]=Cb;dh[h&255](b,Lb,Db,Eb);h=k[e+(c*56|0)+4>>2]|0;if((h|0)<3){n=-1;e=aa(k[e+(c*56|0)+12>>2]|0,k[e+(c*56|0)+8>>2]|0)|0;g=j;f=l}else{g=k[e+(c*56|0)+40>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0));n=-1;g=j;f=l}while(1){d=-1;j=g;l=f;do{f=(k[a>>2]|0)+n|0;g=(k[o>>2]|0)+d|0;k[Db>>2]=1124007936;h=ca;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[ea>>2]=da;k[ga>>2]=fa;k[ha>>2]=0;k[fa>>2]=0;k[Eb>>2]=1124007936;h=ia;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[ka>>2]=ja;k[ma>>2]=la;k[na>>2]=0;k[la>>2]=0;k[Fb>>2]=1124007936;h=oa;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[qa>>2]=pa;k[sa>>2]=ra;k[ta>>2]=0;k[ra>>2]=0;m=k[(k[b>>2]|0)+44>>2]|0;k[ua>>2]=0;k[va>>2]=0;k[Lb>>2]=16842752;k[wa>>2]=Ab;h=ya;k[h>>2]=0;k[h+4>>2]=0;k[Gb>>2]=33619968;k[xa>>2]=Db;k[Hb>>2]=f;k[za>>2]=g;dh[m&255](b,Lb,Gb,Hb);m=k[(k[b>>2]|0)+44>>2]|0;k[Aa>>2]=0;k[Ba>>2]=0;k[Lb>>2]=16842752;k[Ca>>2]=Cb;h=Ea;k[h>>2]=0;k[h+4>>2]=0;k[Gb>>2]=33619968;k[Da>>2]=Eb;k[Ib>>2]=f;k[Fa>>2]=g;dh[m&255](b,Lb,Gb,Ib);k[Ga>>2]=0;k[Ha>>2]=0;k[Gb>>2]=16842752;k[Ia>>2]=Ob;k[Ja>>2]=0;k[Ka>>2]=0;k[Jb>>2]=16842752;k[La>>2]=Db;m=Na;k[m>>2]=0;k[m+4>>2]=0;k[Kb>>2]=33619968;k[Ma>>2]=Fb;k[Lb>>2]=101;aU(Gb,Jb,Kb,49332,Lb,1,11);k[Oa>>2]=0;k[Pa>>2]=0;k[Gb>>2]=16842752;k[Qa>>2]=Fb;k[Ra>>2]=0;k[Sa>>2]=0;k[Jb>>2]=16842752;k[Ta>>2]=Bb;m=Va;k[m>>2]=0;k[m+4>>2]=0;k[Kb>>2]=33619968;k[Ua>>2]=Fb;k[Lb>>2]=98;aU(Gb,Jb,Kb,49332,Lb,1,9);k[Wa>>2]=0;k[Xa>>2]=0;k[Gb>>2]=16842752;k[Ya>>2]=Fb;k[Za>>2]=0;k[_a>>2]=0;k[Jb>>2]=16842752;k[$a>>2]=Eb;m=bb;k[m>>2]=0;k[m+4>>2]=0;k[Kb>>2]=33619968;k[ab>>2]=Fb;k[Lb>>2]=98;aU(Gb,Jb,Kb,49332,Lb,1,9);k[cb>>2]=0;k[db>>2]=0;k[Lb>>2]=16842752;k[eb>>2]=Fb;m=o7(Lb)|0;h=(m|0)<(e|0);j=h?f:j;l=h?g:l;e=h?m:e;f=k[fb>>2]|0;if(f|0?(h=f+12|0,m=k[h>>2]|0,k[h>>2]=m+-1,(m|0)==1):0){g=k[fb>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[vb>>2]|0;if(!f){f=B1()|0;g=k[fb>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[fb>>2]=0}k[fb>>2]=0;k[gb>>2]=0;k[gb+4>>2]=0;k[gb+8>>2]=0;k[gb+12>>2]=0;if((k[oa>>2]|0)>0){g=k[qa>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[oa>>2]|0))}f=k[sa>>2]|0;if(!((f|0)==(ra|0)|(f|0)==0))ggb(k[f+-4>>2]|0);f=k[hb>>2]|0;if(f|0?(h=f+12|0,m=k[h>>2]|0,k[h>>2]=m+-1,(m|0)==1):0){g=k[hb>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[ub>>2]|0;if(!f){f=B1()|0;g=k[hb>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[hb>>2]=0}k[hb>>2]=0;k[ib>>2]=0;k[ib+4>>2]=0;k[ib+8>>2]=0;k[ib+12>>2]=0;if((k[ia>>2]|0)>0){g=k[ka>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[ia>>2]|0))}f=k[ma>>2]|0;if(!((f|0)==(la|0)|(f|0)==0))ggb(k[f+-4>>2]|0);f=k[jb>>2]|0;if(f|0?(h=f+12|0,m=k[h>>2]|0,k[h>>2]=m+-1,(m|0)==1):0){g=k[jb>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[tb>>2]|0;if(f|0)break;f=B1()|0;g=k[jb>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[jb>>2]=0}k[jb>>2]=0;k[kb>>2]=0;k[kb+4>>2]=0;k[kb+8>>2]=0;k[kb+12>>2]=0;if((k[ca>>2]|0)>0){g=k[ea>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[ca>>2]|0))}f=k[ga>>2]|0;if(!((f|0)==(fa|0)|(f|0)==0))ggb(k[f+-4>>2]|0);d=d+1|0}while((d|0)<2);n=n+1|0;if((n|0)>=2)break;else{g=j;f=l}}k[a>>2]=j;k[o>>2]=l;e=k[lb>>2]|0;if(e|0?(d=e+12|0,n=k[d>>2]|0,k[d>>2]=n+-1,(n|0)==1):0){f=k[lb>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[zb>>2]|0;if(!e){e=B1()|0;f=k[lb>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[lb>>2]=0}k[lb>>2]=0;k[mb>>2]=0;k[mb+4>>2]=0;k[mb+8>>2]=0;k[mb+12>>2]=0;if((k[I>>2]|0)>0){f=k[K>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[I>>2]|0))}e=k[M>>2]|0;if(!((e|0)==(L|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[nb>>2]|0;if(e|0?(d=e+12|0,n=k[d>>2]|0,k[d>>2]=n+-1,(n|0)==1):0){f=k[nb>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[yb>>2]|0;if(!e){e=B1()|0;f=k[nb>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[nb>>2]=0}k[nb>>2]=0;k[ob>>2]=0;k[ob+4>>2]=0;k[ob+8>>2]=0;k[ob+12>>2]=0;if((k[C>>2]|0)>0){f=k[E>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[C>>2]|0))}e=k[G>>2]|0;if(!((e|0)==(F|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[pb>>2]|0;if(e|0?(d=e+12|0,n=k[d>>2]|0,k[d>>2]=n+-1,(n|0)==1):0){f=k[pb>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[xb>>2]|0;if(e|0)break;e=B1()|0;f=k[pb>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[pb>>2]=0}k[pb>>2]=0;k[qb>>2]=0;k[qb+4>>2]=0;k[qb+8>>2]=0;k[qb+12>>2]=0;if((k[w>>2]|0)>0){f=k[y>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[w>>2]|0))}e=k[A>>2]|0;if(!((e|0)==(z|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[rb>>2]|0;if(e|0?(d=e+12|0,n=k[d>>2]|0,k[d>>2]=n+-1,(n|0)==1):0){f=k[rb>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[wb>>2]|0;if(e|0)break;e=B1()|0;f=k[rb>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[rb>>2]=0}k[rb>>2]=0;k[sb>>2]=0;k[sb+4>>2]=0;k[sb+8>>2]=0;k[sb+12>>2]=0;if((k[p>>2]|0)>0){f=k[s>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[p>>2]|0))}e=k[u>>2]|0;if(!((e|0)==(t|0)|(e|0)==0))ggb(k[e+-4>>2]|0);if((c|0)>0)c=c+-1|0;else break}}zF(Nb);zF(Mb);f=Pb+36|0;c=k[f>>2]|0;if(c|0?(Nb=c+12|0,Ob=k[Nb>>2]|0,k[Nb>>2]=Ob+-1,(Ob|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[Pb+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;Ob=Pb+16|0;e=Pb+4|0;k[Ob>>2]=0;k[Ob+4>>2]=0;k[Ob+8>>2]=0;k[Ob+12>>2]=0;if((k[e>>2]|0)>0){f=k[Pb+40>>2]|0;c=0;do{k[f+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[Pb+44>>2]|0;if(!((c|0)==(Pb+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=Qb+36|0;c=k[f>>2]|0;if(c|0?(Ob=c+12|0,Pb=k[Ob>>2]|0,k[Ob>>2]=Pb+-1,(Pb|0)==1):0){e=k[f>>2]|0;if(e|0){c=k[e+4>>2]|0;if(!c){c=k[Qb+32>>2]|0;if(!c){c=B1()|0;e=k[f>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,e)}k[f>>2]=0}k[f>>2]=0;Pb=Qb+16|0;e=Qb+4|0;k[Pb>>2]=0;k[Pb+4>>2]=0;k[Pb+8>>2]=0;k[Pb+12>>2]=0;if((k[e>>2]|0)>0){f=k[Qb+40>>2]|0;c=0;do{k[f+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[Qb+44>>2]|0;if((c|0)==(Qb+48|0)|(c|0)==0){r=Rb;return}ggb(k[c+-4>>2]|0);r=Rb;return}function L$a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+560|0;o=y+544|0;x=y+488|0;l=y+424|0;w=y+432|0;u=y+368|0;p=y;n=y+352|0;s=y+224|0;t=y+336|0;q=y+280|0;do if((k[b>>2]&2031616|0)==65536){e=k[b+4>>2]|0;k[x>>2]=k[e>>2];i=x+4|0;a=e+4|0;k[i>>2]=k[a>>2];v=x+8|0;k[v>>2]=k[e+8>>2];k[x+12>>2]=k[e+12>>2];k[x+16>>2]=k[e+16>>2];k[x+20>>2]=k[e+20>>2];k[x+24>>2]=k[e+24>>2];k[x+28>>2]=k[e+28>>2];k[x+32>>2]=k[e+32>>2];b=k[e+36>>2]|0;k[x+36>>2]=b;j=x+40|0;k[j>>2]=v;v=x+48|0;f=x+44|0;k[f>>2]=v;k[x+52>>2]=0;k[v>>2]=0;if(b|0){v=b+12|0;k[v>>2]=(k[v>>2]|0)+1}if((k[a>>2]|0)<3){v=k[e+44>>2]|0;m=k[f>>2]|0;k[m>>2]=k[v>>2];k[m+4>>2]=k[v+4>>2];m=x;v=j;break}k[i>>2]=0;x1(x,k[a>>2]|0,0,0,0);if((k[i>>2]|0)>0){g=k[e+40>>2]|0;h=k[j>>2]|0;e=k[e+44>>2]|0;b=k[f>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[i>>2]|0));m=x;v=j}else{m=x;v=j}}else{Q1(x,b,-1);m=x;v=x+40|0}while(0);i=k[v>>2]|0;j=k[i>>2]|0;k[l>>2]=k[i+4>>2];k[l+4>>2]=j;x2(c,l,k[m>>2]&4095,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[w>>2]=k[g>>2];j=w+4|0;b=g+4|0;k[j>>2]=k[b>>2];c=w+8|0;k[c>>2]=k[g+8>>2];k[w+12>>2]=k[g+12>>2];k[w+16>>2]=k[g+16>>2];k[w+20>>2]=k[g+20>>2];k[w+24>>2]=k[g+24>>2];k[w+28>>2]=k[g+28>>2];k[w+32>>2]=k[g+32>>2];a=k[g+36>>2]|0;k[w+36>>2]=a;e=w+40|0;k[e>>2]=c;c=w+48|0;h=w+44|0;k[h>>2]=c;k[w+52>>2]=0;k[c>>2]=0;if(a|0){c=a+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[b>>2]|0)<3){l=k[g+44>>2]|0;c=k[h>>2]|0;k[c>>2]=k[l>>2];k[c+4>>2]=k[l+4>>2];break}k[j>>2]=0;x1(w,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){i=k[g+40>>2]|0;f=k[e>>2]|0;e=k[g+44>>2]|0;b=k[h>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[i+(a<<2)>>2];k[b+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else Q1(w,c,-1);while(0);g=k[v>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;e=k[m>>2]&4095;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=1124007936;a=p+16|0;b=p+48|0;h=p+12|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[b>>2]=a;a=p+56|0;k[p+52>>2]=a;k[p+60>>2]=0;k[a>>2]=0;k[p+64>>2]=1124007936;a=p+72|0;b=p+104|0;h=p+68|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[b>>2]=a;a=p+112|0;k[p+108>>2]=a;k[p+116>>2]=0;k[a>>2]=0;k[p+120>>2]=1124007936;a=p+128|0;b=p+160|0;h=p+124|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[b>>2]=a;h=p+168|0;k[p+164>>2]=h;i=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[o>>2]=f;k[o+4>>2]=g;j1(p,48,o,e);k[u>>2]=1124007936;j=u+4|0;a=u+8|0;g=u+40|0;h=j;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[g>>2]=a;h=u+48|0;f=u+44|0;k[f>>2]=h;k[u+52>>2]=0;k[h>>2]=0;c=k[p>>2]|0;dh[k[(k[c>>2]|0)+12>>2]&255](c,p,u,-1);XN(p);c=k[d>>2]|0;p=0-c|0;a=(k[x+12>>2]|0)-((c|0)>-1?c:p)|0;m=k[d+4>>2]|0;d=0-m|0;e=(k[x+8>>2]|0)-((m|0)>-1?m:d)|0;k[o>>2]=(c|0)<0?0:c;k[o+4>>2]=(m|0)<0?0:m;k[o+8>>2]=a;k[o+12>>2]=e;k[n>>2]=(p|0)<0?0:p;k[n+4>>2]=(d|0)<0?0:d;k[n+8>>2]=a;k[n+12>>2]=e;I1(s,x,n);I1(q,u,o);e=t+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[t>>2]=-1040121856;k[e>>2]=q;mY(s,t);e=q+36|0;a=k[e>>2]|0;if(a|0?(p=a+12|0,d=k[p>>2]|0,k[p>>2]=d+-1,(d|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;d=q+16|0;b=q+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[b>>2]|0)>0){e=k[q+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[q+44>>2]|0;if(!((a|0)==(q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=s+36|0;a=k[e>>2]|0;if(a|0?(d=a+12|0,q=k[d>>2]|0,k[d>>2]=q+-1,(q|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[s+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;q=s+16|0;b=s+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[b>>2]|0)>0){e=k[s+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[s+44>>2]|0;if(!((a|0)==(s+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=t+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[t>>2]=33619968;k[e>>2]=w;mY(u,t);e=u+36|0;a=k[e>>2]|0;if(a|0?(s=a+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[u+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;u=u+16|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[j>>2]|0)>0){b=k[g>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[f>>2]|0;if(!((a|0)==(h|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=w+36|0;a=k[e>>2]|0;if(a|0?(t=a+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[w+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;u=w+16|0;b=w+4|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[b>>2]|0)>0){e=k[w+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[w+44>>2]|0;if(!((a|0)==(w+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=x+36|0;a=k[e>>2]|0;if(a|0?(u=a+12|0,w=k[u>>2]|0,k[u>>2]=w+-1,(w|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[x+32>>2]|0;if(a|0)break;a=B1()|0;b=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;w=x+16|0;e=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[e>>2]|0)>0){b=k[v>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[x+44>>2]|0;if((a|0)==(x+48|0)|(a|0)==0){r=y;return}ggb(k[a+-4>>2]|0);r=y;return}function M$a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;D=r;r=r+784|0;u=D+768|0;v=D+272|0;w=D+48|0;s=D+16|0;x=D+752|0;y=D;t=D+696|0;q=D+680|0;C=D+624|0;m=D+560|0;n=D+496|0;B=D+568|0;z=D+504|0;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[C>>2]=k[f>>2];j=C+4|0;b=f+4|0;k[j>>2]=k[b>>2];A=C+8|0;k[A>>2]=k[f+8>>2];k[C+12>>2]=k[f+12>>2];k[C+16>>2]=k[f+16>>2];k[C+20>>2]=k[f+20>>2];k[C+24>>2]=k[f+24>>2];k[C+28>>2]=k[f+28>>2];k[C+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[C+36>>2]=e;l=C+40|0;k[l>>2]=A;A=C+48|0;g=C+44|0;k[g>>2]=A;k[C+52>>2]=0;k[A>>2]=0;if(e|0){A=e+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[b>>2]|0)<3){j=k[f+44>>2]|0;A=k[g>>2]|0;k[A>>2]=k[j>>2];k[A+4>>2]=k[j+4>>2];A=l;break}k[j>>2]=0;x1(C,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[f+40>>2]|0;i=k[l>>2]|0;f=k[f+44>>2]|0;e=k[g>>2]|0;b=0;do{k[i+(b<<2)>>2]=k[h+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0));A=l}else A=l}else{Q1(C,b,-1);A=C+40|0}while(0);j=k[A>>2]|0;l=k[j>>2]|0;k[m>>2]=k[j+4>>2];k[m+4>>2]=l;x2(c,m,0,0);l=k[A>>2]|0;m=k[l>>2]|0;k[n>>2]=k[l+4>>2];k[n+4>>2]=m;x2(d,n,0,0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[B>>2]=k[h>>2];l=B+4|0;b=h+4|0;k[l>>2]=k[b>>2];c=B+8|0;k[c>>2]=k[h+8>>2];k[B+12>>2]=k[h+12>>2];k[B+16>>2]=k[h+16>>2];k[B+20>>2]=k[h+20>>2];k[B+24>>2]=k[h+24>>2];k[B+28>>2]=k[h+28>>2];k[B+32>>2]=k[h+32>>2];e=k[h+36>>2]|0;k[B+36>>2]=e;f=B+40|0;k[f>>2]=c;c=B+48|0;i=B+44|0;k[i>>2]=c;k[B+52>>2]=0;k[c>>2]=0;if(e|0){c=e+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[b>>2]|0)<3){n=k[h+44>>2]|0;c=k[i>>2]|0;k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];break}k[l>>2]=0;x1(B,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;e=k[i>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(B,c,-1);while(0);do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[z>>2]=k[g>>2];l=z+4|0;b=g+4|0;k[l>>2]=k[b>>2];d=z+8|0;k[d>>2]=k[g+8>>2];k[z+12>>2]=k[g+12>>2];k[z+16>>2]=k[g+16>>2];k[z+20>>2]=k[g+20>>2];k[z+24>>2]=k[g+24>>2];k[z+28>>2]=k[g+28>>2];k[z+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[z+36>>2]=e;f=z+40|0;k[f>>2]=d;d=z+48|0;i=z+44|0;k[i>>2]=d;k[z+52>>2]=0;k[d>>2]=0;if(e|0){d=e+12|0;k[d>>2]=(k[d>>2]|0)+1}if((k[b>>2]|0)<3){c=k[g+44>>2]|0;d=k[i>>2]|0;k[d>>2]=k[c>>2];k[d+4>>2]=k[c+4>>2];break}k[l>>2]=0;x1(z,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(z,d,-1);while(0);k[u>>2]=0;k[v>>2]=1124007936;n=v+4|0;b=v+8|0;l=v+40|0;f=n;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[l>>2]=b;c=v+48|0;m=v+44|0;k[m>>2]=c;k[v+52>>2]=0;k[c>>2]=0;k[w>>2]=256;j=s;k[j>>2]=0;k[j+4>>2]=1132462080;k[x>>2]=s;k[t>>2]=1124007936;j=t+4|0;b=t+8|0;h=t+40|0;f=j;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[h>>2]=b;i=t+48|0;g=t+44|0;k[g>>2]=i;k[t+52>>2]=0;k[i>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=t;f=q+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[q>>2]=33619968;k[f>>2]=v;yla(C,1,u,y,q,1,w,x,0);f=t+36|0;b=k[f>>2]|0;if(b|0?(d=b+12|0,q=k[d>>2]|0,k[d>>2]=q+-1,(q|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[t+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;q=t+16|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[j>>2]|0)>0){e=k[h>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[g>>2]|0;if(!((b|0)==(i|0)|(b|0)==0))ggb(k[b+-4>>2]|0);i=v+16|0;h=k[i>>2]|0;j=C+4|0;f=k[j>>2]|0;if((f|0)<3)b=aa(k[C+12>>2]|0,k[C+8>>2]|0)|0;else{g=k[C+40>>2]|0;e=0;b=1;do{b=aa(k[g+(e<<2)>>2]|0,b)|0;e=e+1|0}while((e|0)!=(f|0))}f=(b|0)/2|0;if((b|0)>1){e=0;b=0;do{e=~~+o[h+(b<<2)>>2]+e|0;b=b+1|0}while((b|0)<256&(e|0)<(f|0));g=b}else g=0;f=v+36|0;b=k[f>>2]|0;if(b|0?(d=b+12|0,q=k[d>>2]|0,k[d>>2]=q+-1,(q|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[v+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;if((k[n>>2]|0)>0){e=k[l>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[n>>2]|0))}b=k[m>>2]|0;if(!((b|0)==(c|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=16842752;k[u+4>>2]=C;E=+(g|0);p[w>>3]=E;k[v>>2]=-1056833530;k[v+4>>2]=w;k[v+8>>2]=1;k[v+12>>2]=1;b=s+4|0;e=b+4|0;k[e>>2]=0;k[e+4>>2]=0;k[s>>2]=33619968;k[b>>2]=B;oV(u,v,s,1);p[s>>3]=E;b=s+8|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;Y0(w,C,s);k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=1124007936;b=v+16|0;e=v+48|0;f=v+12|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=b;b=v+56|0;k[v+52>>2]=b;k[v+60>>2]=0;k[b>>2]=0;k[v+64>>2]=1124007936;b=v+72|0;e=v+104|0;f=v+68|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=b;b=v+112|0;k[v+108>>2]=b;k[v+116>>2]=0;k[b>>2]=0;k[v+120>>2]=1124007936;b=v+128|0;e=v+160|0;f=v+124|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=b;f=v+168|0;k[v+164>>2]=f;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=k[w>>2]|0;Ph[k[(k[f>>2]|0)+84>>2]&511](f,w,v);k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=-1056571392;k[u+4>>2]=v;p[y>>3]=+(k[a+16>>2]|0);k[x>>2]=-1056833530;k[x+4>>2]=y;k[x+8>>2]=1;k[x+12>>2]=1;f=t+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[t>>2]=33619968;k[f>>2]=z;oV(u,x,t,1);XN(v);XN(w);f=z+36|0;b=k[f>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[z+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;y=z+16|0;e=z+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[e>>2]|0)>0){f=k[z+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[z+44>>2]|0;if(!((b|0)==(z+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=B+36|0;b=k[f>>2]|0;if(b|0?(y=b+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[B+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;z=B+16|0;e=B+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[e>>2]|0)>0){f=k[B+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[B+44>>2]|0;if(!((b|0)==(B+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=C+36|0;b=k[f>>2]|0;if(b|0?(z=b+12|0,B=k[z>>2]|0,k[z>>2]=B+-1,(B|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[C+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;B=C+16|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[j>>2]|0)>0){e=k[A>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[C+44>>2]|0;if((b|0)==(C+48|0)|(b|0)==0){r=D;return}ggb(k[b+-4>>2]|0);r=D;return}function N$a(a){a=a|0;return k[a+12>>2]|0}function O$a(a,b){a=a|0;b=b|0;k[a+12>>2]=b;return}function P$a(a){a=a|0;return k[a+16>>2]|0}function Q$a(a,b){a=a|0;b=b|0;k[a+16>>2]=b;return}function R$a(a){a=a|0;return (i[a+20>>0]|0)!=0|0}function S$a(a,b){a=a|0;b=b|0;i[a+20>>0]=b&1;return}function T$a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+80|0;B=D+56|0;C=D;Y1(b,c+1|0);e=k[b>>2]|0;k[C>>2]=1124007936;j=C+4|0;d=C+8|0;h=C+40|0;f=j;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[h>>2]=d;g=C+48|0;f=C+44|0;k[f>>2]=g;k[C+52>>2]=0;k[g>>2]=0;d=B+4|0;A=d+4|0;k[A>>2]=0;k[A+4>>2]=0;k[B>>2]=33619968;k[d>>2]=C;mY(a,B);KG(e,C)|0;e=C+36|0;d=k[e>>2]|0;if(d|0?(z=d+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){a=k[e>>2]|0;if(a|0){d=k[a+4>>2]|0;if(!d){d=k[C+32>>2]|0;if(!d){d=B1()|0;a=k[e>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,a)}k[e>>2]=0}k[e>>2]=0;A=C+16|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[j>>2]|0)>0){a=k[h>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[f>>2]|0;if(!((d|0)==(g|0)|(d|0)==0))ggb(k[d+-4>>2]|0);if((c|0)<=0){r=D;return}q=C+4|0;s=C+8|0;t=C+40|0;u=C+48|0;v=C+44|0;w=C+52|0;x=B+4|0;y=C+36|0;z=C+16|0;A=C+32|0;p=0;do{o=k[b>>2]|0;n=p;p=p+1|0;d=o+(p*56|0)|0;a=(k[o+(n*56|0)+8>>2]|0)/2|0;h=o+(n*56|0)+12|0;e=(k[h>>2]|0)/2|0;k[C>>2]=1124007936;f=q;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[t>>2]=s;k[v>>2]=u;k[w>>2]=0;k[u>>2]=0;k[B>>2]=a;k[x>>2]=e;G1(C,2,B,0);KG(d,C)|0;d=k[y>>2]|0;if(d|0?(l=d+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){a=k[y>>2]|0;if(a|0){d=k[a+4>>2]|0;if(!d){d=k[A>>2]|0;if(!d){d=B1()|0;a=k[y>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,a)}k[y>>2]=0}k[y>>2]=0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[q>>2]|0)>0){a=k[t>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[q>>2]|0))}d=k[v>>2]|0;if(!((d|0)==(u|0)|(d|0)==0))ggb(k[d+-4>>2]|0);j=k[h>>2]<<1;l=o+(p*56|0)+8|0;a=k[l>>2]|0;if((a|0)>0){m=o+(p*56|0)+12|0;h=0;d=k[o+(p*56|0)+16>>2]|0;g=k[o+(n*56|0)+16>>2]|0;e=k[m>>2]|0;while(1){if((e|0)>0){a=g;f=0;while(1){i[d>>0]=i[a>>0]|0;d=d+1|0;f=f+1|0;e=k[m>>2]|0;if((f|0)>=(e|0))break;else a=a+2|0}a=k[l>>2]|0}h=h+1|0;if((h|0)>=(a|0))break;else g=g+j|0}}}while((p|0)!=(c|0));r=D;return}function U$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function V$a(a){a=a|0;ggb(a);return}function W$a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function X$a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=150004;d=a+60|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+56>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+40|0;c=a+28|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+64>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+68>>2]|0;if(!((b|0)==(a+72|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;d=b+-4|0;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;ggb(k[b+-8>>2]|0);return}function Y$a(a){a=a|0;X$a(a);ggb(a);return}function Z$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;d=e;f=d+4|0;g=ZT(12)|0;k[g>>2]=1;c=g+4|0;k[d>>2]=c;k[f>>2]=4;i[g+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,d)|0;c=k[d>>2]|0;k[f>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+4|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=7;i[f+11>>0]=0;i[c>>0]=i[393693]|0;i[c+1>>0]=i[393694]|0;i[c+2>>0]=i[393695]|0;i[c+3>>0]=i[393696]|0;i[c+4>>0]=i[393697]|0;i[c+5>>0]=i[393698]|0;i[c+6>>0]=i[393699]|0;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=g0a(b,a+12|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=6;i[f+10>>0]=0;i[c>>0]=i[393701]|0;i[c+1>>0]=i[393702]|0;i[c+2>>0]=i[393703]|0;i[c+3>>0]=i[393704]|0;i[c+4>>0]=i[393705]|0;i[c+5>>0]=i[393706]|0;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(c|0?(f=c+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[c+-8>>2]|0);b=h0a(b,a+16|0)|0;g=d+4|0;f=ZT(12)|0;k[f>>2]=1;c=f+4|0;k[d>>2]=c;k[g>>2]=6;i[f+10>>0]=0;i[c>>0]=i[393708]|0;i[c+1>>0]=i[393709]|0;i[c+2>>0]=i[393710]|0;i[c+3>>0]=i[393711]|0;i[c+4>>0]=i[393712]|0;i[c+5>>0]=i[393713]|0;b=z6(b,d)|0;c=k[d>>2]|0;k[g>>2]=0;k[d>>2]=0;if(!c){g=a+20|0;g=i[g>>0]|0;g=g&255;k[d>>2]=g;g0a(b,d)|0;r=e;return}f=c+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){g=a+20|0;g=i[g>>0]|0;g=g&255;k[d>>2]=g;g0a(b,d)|0;r=e;return}ggb(k[c+-8>>2]|0);g=a+20|0;g=i[g>>0]|0;g=g&255;k[d>>2]=g;g0a(b,d)|0;r=e;return}function _$a(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0;q=r;r=r+16|0;m=q;n=b+4|0;d=k6(k[b>>2]|0,k[n>>2]|0,401026)|0;do if((d|0)!=0?(k[d>>2]&7|0)==3:0){k[m>>2]=0;j=m+4|0;k[j>>2]=0;J6(d,m,m);h=k[m>>2]|0;d=k[a+4>>2]|0;if((h|0)==(d|0)){k[j>>2]=0;k[m>>2]=0;if(h|0?(j=h+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[h+-8>>2]|0);break}f=(h|0)==0?1016759:h;e=(d|0)==0?1016759:d;d=i[f>>0]|0;g=i[e>>0]|0;if(d<<24>>24==0?1:d<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;d=i[f>>0]|0;g=i[e>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=g<<24>>24));e=g}d=d<<24>>24==e<<24>>24;k[j>>2]=0;k[m>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!d)l=14}else l=14;while(0);if((l|0)==14){d=m+4|0;e=ZT(40)|0;k[e>>2]=1;f=e+4|0;k[m>>2]=f;k[d>>2]=33;i[e+37>>0]=0;g=399944;h=f+33|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,m,401059,393624,153);k[d>>2]=0;k[m>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}d=k6(k[b>>2]|0,k[n>>2]|0,393693)|0;a:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break a}case 2:break;default:{d=2147483647;break a}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;m=d&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c}while(0);k[a+12>>2]=d;d=k6(k[b>>2]|0,k[n>>2]|0,393701)|0;b:do if(!d)c=0.0;else switch(k[d>>2]&7){case 1:{c=+(k[d+8>>2]|0);break b}case 2:{c=+p[d+8>>3];break b}default:{c=1000000015047466219876688.0e6;break b}}while(0);o[a+16>>2]=c;d=k6(k[b>>2]|0,k[n>>2]|0,393708)|0;if(!d){n=0;n=(n|0)!=0;a=a+20|0;n=n&1;i[a>>0]=n;r=q;return}switch(k[d>>2]&7){case 1:{n=k[d+8>>2]|0;n=(n|0)!=0;a=a+20|0;n=n&1;i[a>>0]=n;r=q;return}case 2:{c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;n=d&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}n=~~c;n=(n|0)!=0;a=a+20|0;n=n&1;i[a>>0]=n;r=q;return}default:{n=2147483647;n=(n|0)!=0;a=a+20|0;n=n&1;i[a>>0]=n;r=q;return}}}function $$a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0;Ub=r;r=r+880|0;Hb=Ub+864|0;Kb=Ub+848|0;Sb=Ub+832|0;Tb=Ub+776|0;Rb=Ub+720|0;Pb=Ub+704|0;yb=Ub+632|0;zb=Ub+576|0;Ab=Ub+224|0;Bb=Ub+520|0;Cb=Ub;Db=Ub+464|0;Eb=Ub+448|0;Fb=Ub+648|0;k[Sb>>2]=0;Gb=Sb+4|0;k[Gb>>2]=0;k[Sb+8>>2]=0;B2(b,Sb);do if((k[d>>2]&2031616|0)==65536){f=k[d+4>>2]|0;k[Tb>>2]=k[f>>2];m=Tb+4|0;b=f+4|0;k[m>>2]=k[b>>2];Qb=Tb+8|0;k[Qb>>2]=k[f+8>>2];k[Tb+12>>2]=k[f+12>>2];k[Tb+16>>2]=k[f+16>>2];k[Tb+20>>2]=k[f+20>>2];k[Tb+24>>2]=k[f+24>>2];k[Tb+28>>2]=k[f+28>>2];k[Tb+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[Tb+36>>2]=d;e=Tb+40|0;k[e>>2]=Qb;Qb=Tb+48|0;h=Tb+44|0;k[h>>2]=Qb;k[Tb+52>>2]=0;k[Qb>>2]=0;if(d|0){Qb=d+12|0;k[Qb>>2]=(k[Qb>>2]|0)+1}if((k[b>>2]|0)<3){vb=k[f+44>>2]|0;Qb=k[h>>2]|0;k[Qb>>2]=k[vb>>2];k[Qb+4>>2]=k[vb+4>>2];Qb=m;break}k[m>>2]=0;x1(Tb,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0));Qb=m}else Qb=m}else{Q1(Tb,d,-1);Qb=Tb+4|0}while(0);g=((k[Gb>>2]|0)-(k[Sb>>2]|0)|0)/56|0;e=k[Qb>>2]|0;if((e|0)<3)b=aa(k[Tb+12>>2]|0,k[Tb+8>>2]|0)|0;else{f=k[Tb+40>>2]|0;d=0;b=1;do{b=aa(k[f+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if((g|0)!=(b|0)){k[Hb>>2]=0;b=Hb+4|0;k[b>>2]=0;d=ZT(36)|0;k[d>>2]=1;j=d+4|0;k[Hb>>2]=j;k[b>>2]=30;i[d+34>>0]=0;e=398993;m=j+30|0;do{i[j>>0]=i[e>>0]|0;j=j+1|0;e=e+1|0}while((j|0)<(m|0));Y8(-215,Hb,399869,393624,70);k[b>>2]=0;k[Hb>>2]=0;vb=k[d>>2]|0;k[d>>2]=vb+-1;if((vb|0)==1)ggb(k[d+-4>>2]|0)}W2a(Sb);b=k[k[Sb>>2]>>2]|0;if(b&7){k[Hb>>2]=0;b=Hb+4|0;k[b>>2]=0;d=ZT(32)|0;k[d>>2]=1;j=d+4|0;k[Hb>>2]=j;k[b>>2]=26;i[d+30>>0]=0;e=399089;m=j+26|0;do{i[j>>0]=i[e>>0]|0;j=j+1|0;e=e+1|0}while((j|0)<(m|0));Y8(-215,Hb,399869,393624,72);k[b>>2]=0;k[Hb>>2]=0;vb=k[d>>2]|0;k[d>>2]=vb+-1;if((vb|0)==1)ggb(k[d+-4>>2]|0);b=k[k[Sb>>2]>>2]|0}vb=b>>>3&511;f=vb+1|0;c2(c,256,1,(f<<3)+-3|0,-1,0,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[Rb>>2]=k[g>>2];c=Rb+4|0;b=g+4|0;k[c>>2]=k[b>>2];ub=Rb+8|0;k[ub>>2]=k[g+8>>2];k[Rb+12>>2]=k[g+12>>2];k[Rb+16>>2]=k[g+16>>2];k[Rb+20>>2]=k[g+20>>2];k[Rb+24>>2]=k[g+24>>2];k[Rb+28>>2]=k[g+28>>2];k[Rb+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[Rb+36>>2]=d;e=Rb+40|0;k[e>>2]=ub;ub=Rb+48|0;j=Rb+44|0;k[j>>2]=ub;k[Rb+52>>2]=0;k[ub>>2]=0;if(d|0){ub=d+12|0;k[ub>>2]=(k[ub>>2]|0)+1}if((k[b>>2]|0)<3){tb=k[g+44>>2]|0;ub=k[j>>2]|0;k[ub>>2]=k[tb>>2];k[ub+4>>2]=k[tb+4>>2];break}k[c>>2]=0;x1(Rb,k[b>>2]|0,0,0,0);if((k[c>>2]|0)>0){m=k[g+40>>2]|0;h=k[e>>2]|0;e=k[g+44>>2]|0;d=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[m+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[c>>2]|0))}}else Q1(Rb,c,-1);while(0);k[Pb>>2]=0;ub=Pb+4|0;k[ub>>2]=0;k[Pb+8>>2]=0;q=a+12|0;d=k[q>>2]|0;a:do if(!(i[a+20>>0]|0)){p=k[Sb>>2]|0;n=p+12|0;g=k[n>>2]|0;p=p+8|0;h=k[p>>2]|0;q=~~+Q(+(+(d|0)*+(g|0)/+(h|0)));e=(d|0)/(q|0)|0;g=(g|0)/(q|0)|0;h=(h|0)/(e|0)|0;if((q|0)>0?(s=(h|0)/2|0,t=Hb+4|0,u=Pb+8|0,(e|0)>0):0){d=0;j=(g|0)/2|0;while(1){if((j|0)>-1){b=0;m=s;while(1){if(((m|0)>-1?(j|0)<(k[n>>2]|0):0)?(m|0)<(k[p>>2]|0):0){k[Hb>>2]=j;k[t>>2]=m;c=k[ub>>2]|0;if((c|0)==(k[u>>2]|0))Efa(Pb,Hb);else{k[c>>2]=j;k[c+4>>2]=m;k[ub>>2]=c+8}}b=b+1|0;if((b|0)>=(e|0))break;else m=m+h|0}}d=d+1|0;if((d|0)>=(q|0))break;else j=j+g|0}}}else if((d|0)>0){m=Hb+4|0;c=Pb+8|0;p=k[Sb>>2]|0;n=p+12|0;p=p+8|0;b=0;h=0;j=0;while(1){g=428e3;g=Epb(k[g>>2]|0,k[g+4>>2]|0,1284865837,1481765933)|0;g=kpb(g|0,N|0,1,0)|0;sb=N;tb=ppb(g|0,sb|0,33)|0;e=k[n>>2]|0;sb=Epb(g|0,sb|0,1284865837,1481765933)|0;sb=kpb(sb|0,N|0,1,0)|0;g=N;rb=428e3;k[rb>>2]=sb;k[rb+4>>2]=g;g=ppb(sb|0,g|0,33)|0;e=(tb|0)%(e|0)|0;g=(g|0)%(k[p>>2]|0)|0;k[Hb>>2]=e;k[m>>2]=g;if((h|0)==(j|0)){Efa(Pb,Hb);d=k[q>>2]|0}else{k[h>>2]=e;k[h+4>>2]=g;k[ub>>2]=h+8}b=b+1|0;if((b|0)>=(d|0))break a;h=k[ub>>2]|0;j=k[c>>2]|0}}while(0);k[yb>>2]=0;h=yb+4|0;k[h>>2]=0;k[yb+8>>2]=0;d=f*56|0;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[h>>2]=b;k[yb>>2]=b;g=b+(f*56|0)|0;k[yb+8>>2]=g;while(1){k[b>>2]=1124007936;d=b+8|0;e=b+40|0;j=b+4|0;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[e>>2]=d;tb=b+48|0;k[b+44>>2]=tb;k[b+52>>2]=0;k[tb>>2]=0;f=f+-1|0;if(!f)break;else b=b+56|0}k[h>>2]=g;$a=zb+4|0;ab=zb+8|0;bb=zb+40|0;cb=zb+48|0;db=zb+44|0;eb=zb+52|0;fb=Bb+4|0;gb=Bb+8|0;hb=Bb+40|0;ib=Bb+48|0;jb=Bb+44|0;kb=Bb+52|0;lb=zb+16|0;mb=a+16|0;nb=a+24|0;ob=a+64|0;pb=a+40|0;qb=a+68|0;y=a+36|0;z=Db+4|0;A=Db+8|0;B=Db+40|0;C=Db+48|0;D=Db+44|0;E=Db+52|0;F=Hb+8|0;G=Hb+12|0;H=Hb+4|0;I=Kb+8|0;J=Kb+12|0;K=Kb+4|0;L=Eb+4|0;M=L+4|0;O=Hb+4|0;P=Kb+4|0;R=Hb+4|0;S=R+4|0;T=Fb+36|0;U=Fb+16|0;V=Fb+4|0;W=Fb+40|0;X=Fb+44|0;Y=Fb+48|0;Z=Db+36|0;$=Db+16|0;ba=Bb+36|0;ca=Bb+16|0;da=zb+36|0;rb=Tb+40|0;sb=Tb+16|0;tb=Tb+44|0;ea=Tb+12|0;fa=Ab+4|0;ga=Ab+8|0;ha=Ab+12|0;ia=Ab+16|0;ja=Ab+48|0;ka=Ab+56|0;la=Ab+52|0;ma=Ab+60|0;na=Ab+64|0;oa=Ab+68|0;pa=Ab+72|0;qa=Ab+104|0;ra=Ab+112|0;sa=Ab+108|0;ta=Ab+116|0;ua=Ab+120|0;va=Ab+124|0;wa=Ab+128|0;xa=Ab+160|0;ya=Ab+168|0;za=Ab+164|0;Aa=Hb+4|0;Ba=Cb+4|0;Ca=Cb+8|0;Da=Cb+12|0;Ea=Cb+16|0;Fa=Cb+48|0;Ga=Cb+56|0;Ha=Cb+52|0;Ia=Cb+60|0;Ja=Cb+64|0;Ka=Cb+68|0;La=Cb+72|0;Ma=Cb+104|0;Na=Cb+112|0;Oa=Cb+108|0;Pa=Cb+116|0;Qa=Cb+120|0;Ra=Cb+124|0;Sa=Cb+128|0;Ta=Cb+160|0;Ua=Cb+168|0;Va=Cb+164|0;Wa=Hb+4|0;Xa=zb+32|0;Ya=Bb+32|0;Za=Db+32|0;_a=Fb+32|0;x=0;while(1){f=k[ub>>2]|0;g=k[Pb>>2]|0;a=f-g>>3;d=k[Gb>>2]|0;w=k[Sb>>2]|0;b=(aa((d-w|0)/56|0,a)|0)+257|0;e=a+256|0;k[Ab>>2]=0;k[fa>>2]=0;k[ga>>2]=1124007936;j=ha;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[ja>>2]=ia;k[la>>2]=ka;k[ma>>2]=0;k[ka>>2]=0;k[na>>2]=1124007936;j=oa;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[qa>>2]=pa;k[sa>>2]=ra;k[ta>>2]=0;k[ra>>2]=0;k[ua>>2]=1124007936;j=va;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[xa>>2]=wa;k[za>>2]=ya;j=ya;m=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[Hb>>2]=e;k[Aa>>2]=b;j1(Ab,48,Hb,5);k[zb>>2]=1124007936;j=$a;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[bb>>2]=ab;k[db>>2]=cb;k[eb>>2]=0;k[cb>>2]=0;b=k[Ab>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,Ab,zb,-1);XN(Ab);b=k[ab>>2]|0;k[Cb>>2]=0;k[Ba>>2]=0;k[Ca>>2]=1124007936;j=Da;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[Fa>>2]=Ea;k[Ha>>2]=Ga;k[Ia>>2]=0;k[Ga>>2]=0;k[Ja>>2]=1124007936;j=Ka;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[Ma>>2]=La;k[Oa>>2]=Na;k[Pa>>2]=0;k[Na>>2]=0;k[Qa>>2]=1124007936;j=Ra;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[Ta>>2]=Sa;k[Va>>2]=Ua;j=Ua;m=j+56|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[Hb>>2]=1;k[Wa>>2]=b;j1(Cb,48,Hb,5);k[Bb>>2]=1124007936;j=fb;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[hb>>2]=gb;k[jb>>2]=ib;k[kb>>2]=0;k[ib>>2]=0;u=k[Cb>>2]|0;dh[k[(k[u>>2]|0)+12>>2]&255](u,Cb,Bb,-1);XN(Cb);u=g;if((f|0)==(g|0))b=0;else{t=w;s=0;b=0;do{if((d|0)==(w|0))d=w;else{n=s+256|0;m=k[u+(s<<3)+4>>2]|0;c=k[u+(s<<3)>>2]|0;p=(k[nb>>2]&16384|0)==0;q=(d-w|0)/56|0;j=0;do{h=(((aa(k[t+(j*56|0)+12>>2]|0,m)|0)+c|0)*3|0)+x|0;h=l[(k[t+(j*56|0)+16>>2]|0)+h>>0]|0;do if(p?(Ib=k[ob>>2]|0,(k[Ib>>2]|0)!=1):0){f=k[pb>>2]|0;e=k[qb>>2]|0;if((k[Ib+4>>2]|0)==1){e=f+(aa(k[e>>2]|0,h)|0)|0;break}else{g=k[y>>2]|0;Vb=(h|0)/(g|0)|0;g=h-(aa(Vb,g)|0)|0;e=f+(aa(k[e>>2]|0,Vb)|0)+(g<<2)|0;break}}else wb=66;while(0);if((wb|0)==66){wb=0;f=k[pb>>2]|0;e=f+(h<<2)|0}g=k[lb>>2]|0;Vb=g+(aa(k[k[db>>2]>>2]|0,b)|0)+(h<<2)|0;k[Vb>>2]=k[e>>2];do if(p?(Jb=k[ob>>2]|0,(k[Jb>>2]|0)!=1):0){f=k[pb>>2]|0;e=k[qb>>2]|0;if((k[Jb+4>>2]|0)==1){e=f+(aa(k[e>>2]|0,h)|0)|0;break}else{Vb=k[y>>2]|0;Wb=(h|0)/(Vb|0)|0;Vb=h-(aa(Wb,Vb)|0)|0;e=f+(aa(k[e>>2]|0,Wb)|0)+(Vb<<2)|0;break}}else wb=72;while(0);if((wb|0)==72){wb=0;e=f+(h<<2)|0}Wb=g+(aa(k[k[db>>2]>>2]|0,b)|0)+(n<<2)|0;o[Wb>>2]=-+o[e>>2];do if(p?(Lb=k[ob>>2]|0,(k[Lb>>2]|0)!=1):0){e=k[pb>>2]|0;f=k[qb>>2]|0;if((k[Lb+4>>2]|0)==1){e=e+(aa(k[f>>2]|0,h)|0)|0;break}else{Wb=k[y>>2]|0;Vb=(h|0)/(Wb|0)|0;Wb=h-(aa(Vb,Wb)|0)|0;e=e+(aa(k[f>>2]|0,Vb)|0)+(Wb<<2)|0;break}}else wb=78;while(0);if((wb|0)==78){wb=0;e=f+(h<<2)|0}v=+o[e>>2];do if((k[Tb>>2]&16384|0)==0?(Mb=k[rb>>2]|0,(k[Mb>>2]|0)!=1):0){e=k[sb>>2]|0;f=k[tb>>2]|0;if((k[Mb+4>>2]|0)==1){e=e+(aa(k[f>>2]|0,j)|0)|0;break}else{Wb=k[ea>>2]|0;Vb=(j|0)/(Wb|0)|0;Wb=j-(aa(Vb,Wb)|0)|0;e=e+(aa(k[f>>2]|0,Vb)|0)+(Wb<<2)|0;break}}else wb=84;while(0);if((wb|0)==84){wb=0;e=(k[sb>>2]|0)+(j<<2)|0}v=v*+_(+(+o[e>>2]));Wb=(k[ca>>2]|0)+(aa(k[k[jb>>2]>>2]|0,b)|0)|0;o[Wb>>2]=v;b=b+1|0;j=j+1|0}while(j>>>0<q>>>0)}s=s+1|0}while(s>>>0<a>>>0)}m=k[lb>>2]|0;c=k[k[db>>2]>>2]|0;n=m+(aa(c,b)|0)+512|0;o[n>>2]=1.0;n=(k[nb>>2]&16384|0)==0;j=0;do{b=b+1|0;v=+o[mb>>2];h=j;j=j+1|0;do if(n?(Nb=k[ob>>2]|0,(k[Nb>>2]|0)!=1):0){e=k[pb>>2]|0;d=k[qb>>2]|0;if((k[Nb+4>>2]|0)==1){d=e+(aa(k[d>>2]|0,j)|0)|0;break}else{Wb=k[y>>2]|0;Vb=(j|0)/(Wb|0)|0;Wb=j-(aa(Vb,Wb)|0)|0;d=e+(aa(k[d>>2]|0,Vb)|0)+(Wb<<2)|0;break}}else wb=91;while(0);if((wb|0)==91){e=k[pb>>2]|0;d=e+(j<<2)|0}g=m+(aa(c,b)|0)|0;o[g+(h<<2)>>2]=v*+o[d>>2];v=+o[mb>>2];if(n?(Ob=k[ob>>2]|0,(k[Ob>>2]|0)!=1):0){d=k[pb>>2]|0;e=k[qb>>2]|0;if((k[Ob+4>>2]|0)==1)d=d+(aa(k[e>>2]|0,j)|0)|0;else{Wb=k[y>>2]|0;Vb=(j|0)/(Wb|0)|0;Wb=j-(aa(Vb,Wb)|0)|0;d=d+(aa(k[e>>2]|0,Vb)|0)+(Wb<<2)|0}o[g+(j<<2)>>2]=v*-2.0*+o[d>>2];f=Ob;v=+o[mb>>2];wb=104}else wb=101;do if((wb|0)==101){wb=0;o[g+(j<<2)>>2]=v*-2.0*+o[e+(j<<2)>>2];v=+o[mb>>2];if(n?(xb=k[ob>>2]|0,(k[xb>>2]|0)!=1):0){f=xb;wb=104;break}d=e+(j<<2)|0}while(0);do if((wb|0)==104){wb=0;d=k[pb>>2]|0;e=k[qb>>2]|0;if((k[f+4>>2]|0)==1){d=d+(aa(k[e>>2]|0,j)|0)|0;break}else{Wb=k[y>>2]|0;Vb=(j|0)/(Wb|0)|0;Wb=j-(aa(Vb,Wb)|0)|0;d=d+(aa(k[e>>2]|0,Vb)|0)+(Wb<<2)|0;break}}while(0);o[g+(h+2<<2)>>2]=v*+o[d>>2]}while((j|0)!=254);k[Db>>2]=1124007936;j=z;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[B>>2]=A;k[D>>2]=C;k[E>>2]=0;k[C>>2]=0;k[F>>2]=0;k[G>>2]=0;k[Hb>>2]=16842752;k[H>>2]=zb;k[I>>2]=0;k[J>>2]=0;k[Kb>>2]=16842752;k[K>>2]=Bb;b=M;k[b>>2]=0;k[b+4>>2]=0;k[Eb>>2]=33619968;k[L>>2]=Db;NZ(Hb,Kb,Eb,1)|0;k[Hb>>2]=0;k[O>>2]=256;k[Kb>>2]=-2147483648;k[P>>2]=2147483647;H1(Fb,Db,Hb,Kb);b=(k[yb>>2]|0)+(x*56|0)|0;Wb=S;k[Wb>>2]=0;k[Wb+4>>2]=0;k[Hb>>2]=33619968;k[R>>2]=b;mY(Fb,Hb);b=k[T>>2]|0;if(b|0?(Vb=b+12|0,Wb=k[Vb>>2]|0,k[Vb>>2]=Wb+-1,(Wb|0)==1):0){d=k[T>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[_a>>2]|0;if(!b){b=B1()|0;d=k[T>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[T>>2]=0}k[T>>2]=0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[V>>2]|0)>0){d=k[W>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[V>>2]|0))}b=k[X>>2]|0;if(!((b|0)==(Y|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Z>>2]|0;if(b|0?(Vb=b+12|0,Wb=k[Vb>>2]|0,k[Vb>>2]=Wb+-1,(Wb|0)==1):0){d=k[Z>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Za>>2]|0;if(!b){b=B1()|0;d=k[Z>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[Z>>2]=0}k[Z>>2]=0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[z>>2]|0)>0){d=k[B>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[D>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[ba>>2]|0;if(b|0?(Vb=b+12|0,Wb=k[Vb>>2]|0,k[Vb>>2]=Wb+-1,(Wb|0)==1):0){d=k[ba>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Ya>>2]|0;if(b|0)break;b=B1()|0;d=k[ba>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[ba>>2]=0}k[ba>>2]=0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;if((k[fb>>2]|0)>0){d=k[hb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[fb>>2]|0))}b=k[jb>>2]|0;if(!((b|0)==(ib|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[da>>2]|0;if(b|0?(Vb=b+12|0,Wb=k[Vb>>2]|0,k[Vb>>2]=Wb+-1,(Wb|0)==1):0){d=k[da>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Xa>>2]|0;if(b|0)break;b=B1()|0;d=k[da>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[da>>2]=0}k[da>>2]=0;k[lb>>2]=0;k[lb+4>>2]=0;k[lb+8>>2]=0;k[lb+12>>2]=0;if((k[$a>>2]|0)>0){d=k[bb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[$a>>2]|0))}b=k[db>>2]|0;if(!((b|0)==(cb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);if((x|0)<(vb|0))x=x+1|0;else break}k[Kb+8>>2]=0;k[Kb+12>>2]=0;k[Kb>>2]=17104896;k[Kb+4>>2]=yb;d=zb+4|0;b=d+4|0;k[b>>2]=0;k[b+4>>2]=0;k[zb>>2]=33619968;k[d>>2]=Rb;k[Hb>>2]=0;d=Hb+4|0;k[d>>2]=0;k[Hb+8>>2]=0;B2(Kb,Hb);b=k[Hb>>2]|0;d=k[d>>2]|0;GV((b|0)==(d|0)?0:b,(d-b|0)/56|0,zb);zF(Hb);k[Hb+8>>2]=0;k[Hb+12>>2]=0;k[Hb>>2]=16842752;k[Hb+4>>2]=Rb;b=Kb+4|0;d=b+4|0;k[d>>2]=0;k[d+4>>2]=0;k[Kb>>2]=33619968;k[b>>2]=Rb;XZ(Hb,Kb);zF(yb);b=k[Pb>>2]|0;d=b;if(b|0){e=k[ub>>2]|0;if((e|0)!=(b|0))k[ub>>2]=e+(~((e+-8-d|0)>>>3)<<3);ggb(b)}e=Rb+36|0;b=k[e>>2]|0;if(b|0?(Vb=b+12|0,Wb=k[Vb>>2]|0,k[Vb>>2]=Wb+-1,(Wb|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Rb+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;Wb=Rb+16|0;d=Rb+4|0;k[Wb>>2]=0;k[Wb+4>>2]=0;k[Wb+8>>2]=0;k[Wb+12>>2]=0;if((k[d>>2]|0)>0){e=k[Rb+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[Rb+44>>2]|0;if(!((b|0)==(Rb+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=Tb+36|0;b=k[e>>2]|0;if(b|0?(Vb=b+12|0,Wb=k[Vb>>2]|0,k[Vb>>2]=Wb+-1,(Wb|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Tb+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;k[sb>>2]=0;k[sb+4>>2]=0;k[sb+8>>2]=0;k[sb+12>>2]=0;if((k[Qb>>2]|0)>0){d=k[rb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Qb>>2]|0))}b=k[tb>>2]|0;if((b|0)==(Tb+48|0)|(b|0)==0){zF(Sb);r=Ub;return}ggb(k[b+-4>>2]|0);zF(Sb);r=Ub;return}function a0a(a){a=a|0;return +(+o[a+16>>2])}function b0a(a,b){a=a|0;b=+b;o[a+16>>2]=b;return}function c0a(a){a=a|0;return k[a+12>>2]|0}function d0a(a,b){a=a|0;b=b|0;k[a+12>>2]=b;return}function e0a(a){a=a|0;return (i[a+20>>0]|0)!=0|0}function f0a(a,b){a=a|0;b=b|0;i[a+20>>0]=b&1;return}function g0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function h0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+o[b>>2]);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function i0a(a){a=a|0;ggb(a);return}function j0a(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function k0a(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=150092;d=a+112|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+108>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+92|0;c=a+80|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+116>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+120>>2]|0;if(!((b|0)==(a+124|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+56|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+52>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+36|0;c=a+24|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+60>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+64>>2]|0;if(!((b|0)==(a+68|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;d=b+-4|0;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;ggb(k[b+-8>>2]|0);return}function l0a(a){a=a|0;k0a(a);ggb(a);return}function m0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;f=g+4|0;e=ZT(12)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=4;i[e+8>>0]=0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=z6(b,a+4|0)|0;f=g+4|0;e=ZT(16)|0;k[e>>2]=1;c=e+4|0;k[g>>2]=c;k[f>>2]=8;i[e+12>>0]=0;e=c;i[e>>0]=109;i[e+1>>0]=97;i[e+2>>0]=120;i[e+3>>0]=95;c=c+4|0;i[c>>0]=105;i[c+1>>0]=116;i[c+2>>0]=101;i[c+3>>0]=114;b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(c|0?(e=c+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);b=g0a(b,a+12|0)|0;f=g+4|0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[f>>2]=9;i[d+13>>0]=0;d=393853;e=c+9|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));b=z6(b,g)|0;c=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(!c){g=a+16|0;h0a(b,g)|0;r=h;return}f=c+-4|0;g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1){g=a+16|0;h0a(b,g)|0;r=h;return}ggb(k[c+-8>>2]|0);g=a+16|0;h0a(b,g)|0;r=h;return}function n0a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0;q=r;r=r+16|0;m=q;n=b+4|0;c=k6(k[b>>2]|0,k[n>>2]|0,401026)|0;do if((c|0)!=0?(k[c>>2]&7|0)==3:0){k[m>>2]=0;j=m+4|0;k[j>>2]=0;J6(c,m,m);h=k[m>>2]|0;c=k[a+4>>2]|0;if((h|0)==(c|0)){k[j>>2]=0;k[m>>2]=0;if(h|0?(j=h+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[h+-8>>2]|0);break}f=(h|0)==0?1016759:h;e=(c|0)==0?1016759:c;c=i[f>>0]|0;g=i[e>>0]|0;if(c<<24>>24==0?1:c<<24>>24!=g<<24>>24)e=g;else{do{f=f+1|0;e=e+1|0;c=i[f>>0]|0;g=i[e>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=g<<24>>24));e=g}c=c<<24>>24==e<<24>>24;k[j>>2]=0;k[m>>2]=0;if(h|0?(g=h+-4|0,j=k[g>>2]|0,k[g>>2]=j+-1,(j|0)==1):0)ggb(k[h+-8>>2]|0);if(!c)l=14}else l=14;while(0);if((l|0)==14){c=m+4|0;e=ZT(40)|0;k[e>>2]=1;f=e+4|0;k[m>>2]=f;k[c>>2]=33;i[e+37>>0]=0;g=399944;h=f+33|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,m,401059,393624,261);k[c>>2]=0;k[m>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}c=k6(k[b>>2]|0,k[n>>2]|0,393844)|0;a:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break a}case 2:break;default:{c=2147483647;break a}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;m=c&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+12>>2]=c;c=k6(k[b>>2]|0,k[n>>2]|0,393853)|0;if(!c){d=0.0;a=a+16|0;o[a>>2]=d;r=q;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);a=a+16|0;o[a>>2]=d;r=q;return}case 2:{d=+p[c+8>>3];a=a+16|0;o[a>>2]=d;r=q;return}default:{d=1000000015047466219876688.0e6;a=a+16|0;o[a>>2]=d;r=q;return}}}function o0a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0.0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0;tc=r;r=r+1632|0;nc=tc+1184|0;rc=tc+1616|0;sc=tc+1560|0;qc=tc+1504|0;pc=tc+1448|0;n=tc+960|0;dc=tc+1440|0;ec=tc+480|0;fc=tc+1424|0;gc=tc+448|0;hc=tc+736|0;ic=tc+1408|0;jc=tc+224|0;kc=tc;lc=tc+704|0;k[rc>>2]=0;mc=rc+4|0;k[mc>>2]=0;k[rc+8>>2]=0;B2(b,rc);do if((k[d>>2]&2031616|0)==65536){f=k[d+4>>2]|0;k[sc>>2]=k[f>>2];m=sc+4|0;b=f+4|0;k[m>>2]=k[b>>2];cc=sc+8|0;k[cc>>2]=k[f+8>>2];k[sc+12>>2]=k[f+12>>2];k[sc+16>>2]=k[f+16>>2];k[sc+20>>2]=k[f+20>>2];k[sc+24>>2]=k[f+24>>2];k[sc+28>>2]=k[f+28>>2];k[sc+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[sc+36>>2]=d;e=sc+40|0;k[e>>2]=cc;cc=sc+48|0;h=sc+44|0;k[h>>2]=cc;k[sc+52>>2]=0;k[cc>>2]=0;if(d|0){cc=d+12|0;k[cc>>2]=(k[cc>>2]|0)+1}if((k[b>>2]|0)<3){bc=k[f+44>>2]|0;cc=k[h>>2]|0;k[cc>>2]=k[bc>>2];k[cc+4>>2]=k[bc+4>>2];break}k[m>>2]=0;x1(sc,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else{Q1(sc,d,-1);m=sc+4|0}while(0);g=((k[mc>>2]|0)-(k[rc>>2]|0)|0)/56|0;e=k[m>>2]|0;if((e|0)<3)b=aa(k[sc+12>>2]|0,k[sc+8>>2]|0)|0;else{f=k[sc+40>>2]|0;d=0;b=1;do{b=aa(k[f+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if((g|0)!=(b|0)){k[nc>>2]=0;b=nc+4|0;k[b>>2]=0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[nc>>2]=f;k[b>>2]=30;i[d+34>>0]=0;e=398993;g=f+30|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,nc,399869,393624,190);k[b>>2]=0;k[nc>>2]=0;cc=k[d>>2]|0;k[d>>2]=cc+-1;if((cc|0)==1)ggb(k[d+-4>>2]|0)}W2a(rc);b=k[k[rc>>2]>>2]|0;if(b&7){k[nc>>2]=0;b=nc+4|0;k[b>>2]=0;d=ZT(32)|0;k[d>>2]=1;f=d+4|0;k[nc>>2]=f;k[b>>2]=26;i[d+30>>0]=0;e=399089;g=f+26|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,nc,399869,393624,192);k[b>>2]=0;k[nc>>2]=0;cc=k[d>>2]|0;k[d>>2]=cc+-1;if((cc|0)==1)ggb(k[d+-4>>2]|0);b=k[k[rc>>2]>>2]|0}bc=(b>>>3&511)+1|0;cc=(bc<<3)+-3|0;c2(c,256,1,cc,-1,0,0);do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[qc>>2]=k[f>>2];c=qc+4|0;b=f+4|0;k[c>>2]=k[b>>2];ac=qc+8|0;k[ac>>2]=k[f+8>>2];k[qc+12>>2]=k[f+12>>2];k[qc+16>>2]=k[f+16>>2];k[qc+20>>2]=k[f+20>>2];k[qc+24>>2]=k[f+24>>2];k[qc+28>>2]=k[f+28>>2];k[qc+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[qc+36>>2]=d;e=qc+40|0;k[e>>2]=ac;ac=qc+48|0;h=qc+44|0;k[h>>2]=ac;k[qc+52>>2]=0;k[ac>>2]=0;if(d|0){ac=d+12|0;k[ac>>2]=(k[ac>>2]|0)+1}if((k[b>>2]|0)<3){$b=k[f+44>>2]|0;ac=k[h>>2]|0;k[ac>>2]=k[$b>>2];k[ac+4>>2]=k[$b+4>>2];break}k[c>>2]=0;x1(qc,k[b>>2]|0,0,0,0);if((k[c>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[c>>2]|0))}}else Q1(qc,c,-1);while(0);_2a(pc,3);f1(nc,pc,128.0);e=k[nc>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,nc,qc,-1);XN(nc);e=pc+36|0;b=k[e>>2]|0;if(b|0?($b=b+12|0,ac=k[$b>>2]|0,k[$b>>2]=ac+-1,(ac|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[pc+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;ac=pc+16|0;d=pc+4|0;k[ac>>2]=0;k[ac+4>>2]=0;k[ac+8>>2]=0;k[ac+12>>2]=0;if((k[d>>2]|0)>0){e=k[pc+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[pc+44>>2]|0;if(!((b|0)==(pc+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=1124007936;b=n+16|0;d=n+48|0;f=n+12|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=b;b=n+56|0;k[n+52>>2]=b;k[n+60>>2]=0;k[b>>2]=0;k[n+64>>2]=1124007936;b=n+72|0;d=n+104|0;f=n+68|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=b;b=n+112|0;k[n+108>>2]=b;k[n+116>>2]=0;k[b>>2]=0;k[n+120>>2]=1124007936;b=n+128|0;d=n+160|0;f=n+124|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=b;f=n+168|0;k[n+164>>2]=f;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[nc>>2]=1;k[nc+4>>2]=256;j1(n,48,nc,cc);k[pc>>2]=1124007936;$b=pc+4|0;b=pc+8|0;Zb=pc+40|0;f=$b;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Zb>>2]=b;ac=pc+48|0;_b=pc+44|0;k[_b>>2]=ac;k[pc+52>>2]=0;k[ac>>2]=0;b=k[n>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,n,pc,-1);XN(n);b=k[mc>>2]|0;d=k[rc>>2]|0;w=d;if((b|0)!=(d|0)){x=pc+16|0;y=pc+12|0;q=(b-d|0)/56|0;c=0;do{n=k[w+(c*56|0)+4>>2]|0;s=(n|0)<3;t=w+(c*56|0)+8|0;u=w+(c*56|0)+12|0;v=w+(c*56|0)+40|0;h=0;j=k[w+(c*56|0)+16>>2]|0;while(1){if(s)b=aa(k[u>>2]|0,k[t>>2]|0)|0;else{e=k[v>>2]|0;d=0;b=1;do{b=aa(k[e+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(n|0))}if(h>>>0<b>>>0){f=0;g=j}else break;while(1){b=l[g>>0]|0;do if((k[pc>>2]&16384|0)==0?(z=k[Zb>>2]|0,(k[z>>2]|0)!=1):0){d=k[x>>2]|0;e=k[_b>>2]|0;if((k[z+4>>2]|0)==1){b=d+(aa(k[e>>2]|0,b)|0)|0;break}else{Xb=k[y>>2]|0;Yb=(b|0)/(Xb|0)|0;b=b-(aa(Yb,Xb)|0)|0;b=d+(aa(k[e>>2]|0,Yb)|0)+(b*12|0)|0;break}}else oc=57;while(0);if((oc|0)==57){oc=0;b=(k[x>>2]|0)+(b*12|0)|0}Yb=b+(f<<2)|0;o[Yb>>2]=+o[Yb>>2]+1.0;f=f+1|0;if((f|0)==(bc|0))break;else g=g+1|0}h=h+1|0;j=j+bc|0}c=c+1|0}while(c>>>0<q>>>0)}g1(nc,pc);pb=k[nc>>2]|0;dh[k[(k[pb>>2]|0)+12>>2]&255](pb,nc,pc,-1);XN(nc);B3a(dc);pb=a+12|0;a:do if((k[pb>>2]|0)>0){qb=a+76|0;rb=dc+4|0;sb=nc+8|0;tb=nc+12|0;ub=nc+4|0;vb=ec+4|0;wb=vb+4|0;xb=fc+8|0;yb=fc+12|0;zb=fc+4|0;Ab=gc+8|0;Bb=gc+12|0;Cb=gc+4|0;Db=ec+4|0;Eb=ec+8|0;Fb=ec+40|0;Gb=ec+48|0;Hb=ec+44|0;Ib=ec+52|0;Jb=fc+8|0;Kb=fc+12|0;Lb=fc+4|0;Mb=ec+16|0;Nb=ec+12|0;Ob=ic+8|0;Pb=ic+12|0;Qb=ic+4|0;Rb=fc+8|0;Sb=fc+12|0;Tb=fc+4|0;Ub=+(bc|0);Vb=nc+4|0;Wb=Vb+4|0;Xb=a+16|0;Yb=ec+36|0;E=a+92|0;F=sc+40|0;G=sc+16|0;H=sc+44|0;I=sc+12|0;J=ec+4|0;K=ec+8|0;L=ec+12|0;M=ec+16|0;N=ec+48|0;O=ec+56|0;P=ec+52|0;Q=ec+60|0;R=ec+64|0;S=ec+68|0;T=ec+72|0;U=ec+104|0;V=ec+112|0;W=ec+108|0;X=ec+116|0;Y=ec+120|0;Z=ec+124|0;_=ec+128|0;$=ec+160|0;ba=ec+168|0;ca=ec+164|0;da=nc+4|0;ea=hc+4|0;fa=hc+8|0;ga=hc+12|0;ha=hc+16|0;ia=hc+48|0;ja=hc+56|0;ka=hc+52|0;la=hc+60|0;ma=hc+64|0;na=hc+68|0;oa=hc+72|0;pa=hc+104|0;qa=hc+112|0;ra=hc+108|0;sa=hc+116|0;ta=hc+120|0;ua=hc+124|0;va=hc+128|0;wa=hc+160|0;xa=hc+168|0;ya=hc+164|0;za=nc+4|0;Aa=kc+4|0;Ba=kc+8|0;Ca=kc+12|0;Da=kc+16|0;Ea=kc+48|0;Fa=kc+56|0;Ga=kc+52|0;Ha=kc+60|0;Ia=kc+64|0;Ja=kc+68|0;Ka=kc+72|0;La=kc+104|0;Ma=kc+112|0;Na=kc+108|0;Oa=kc+116|0;Pa=kc+120|0;Qa=kc+124|0;Ra=kc+128|0;Sa=kc+160|0;Ta=kc+168|0;Ua=kc+164|0;Va=jc+4|0;Wa=jc+8|0;Xa=jc+12|0;Ya=jc+16|0;Za=jc+48|0;_a=jc+56|0;$a=jc+52|0;ab=jc+60|0;bb=jc+64|0;cb=jc+68|0;db=jc+72|0;eb=jc+104|0;fb=jc+112|0;gb=jc+108|0;hb=jc+116|0;ib=jc+120|0;jb=jc+124|0;kb=jc+128|0;lb=jc+160|0;mb=jc+168|0;nb=jc+164|0;ob=ec+32|0;D=0;do{d=k[(k[rc>>2]|0)+40>>2]|0;b=k[d+4>>2]|0;d=k[d>>2]|0;k[ec>>2]=0;k[J>>2]=0;k[K>>2]=1124007936;f=L;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[N>>2]=M;k[P>>2]=O;k[Q>>2]=0;k[O>>2]=0;k[R>>2]=1124007936;f=S;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[U>>2]=T;k[W>>2]=V;k[X>>2]=0;k[V>>2]=0;k[Y>>2]=1124007936;f=Z;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[$>>2]=_;k[ca>>2]=ba;f=ba;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[nc>>2]=b;k[da>>2]=d;j1(ec,48,nc,cc);f=k[ec>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,ec,qb,-1);XN(ec);f=k[rb>>2]|0;g=k[(k[f>>2]|0)+32>>2]|0;k[sb>>2]=0;k[tb>>2]=0;k[nc>>2]=17104896;k[ub>>2]=rc;C=wb;k[C>>2]=0;k[C+4>>2]=0;k[ec>>2]=33619968;k[vb>>2]=qb;k[xb>>2]=0;k[yb>>2]=0;k[fc>>2]=16842752;k[zb>>2]=sc;k[Ab>>2]=0;k[Bb>>2]=0;k[gc>>2]=16842752;k[Cb>>2]=qc;eh[g&255](f,nc,ec,fc,gc);k[hc>>2]=0;k[ea>>2]=0;k[fa>>2]=1124007936;f=ga;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[ia>>2]=ha;k[ka>>2]=ja;k[la>>2]=0;k[ja>>2]=0;k[ma>>2]=1124007936;f=na;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[pa>>2]=oa;k[ra>>2]=qa;k[sa>>2]=0;k[qa>>2]=0;k[ta>>2]=1124007936;f=ua;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[wa>>2]=va;k[ya>>2]=xa;f=xa;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[nc>>2]=1;k[za>>2]=256;j1(hc,48,nc,21);k[ec>>2]=1124007936;f=Db;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Fb>>2]=Eb;k[Hb>>2]=Gb;k[Ib>>2]=0;k[Gb>>2]=0;b=k[hc>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,hc,ec,-1);XN(hc);b=k[mc>>2]|0;d=k[rc>>2]|0;C=d;if((b|0)!=(d|0)){a=k[E>>2]|0;v=(b-d|0)/56|0;t=0;do{u=k[C+(t*56|0)+4>>2]|0;w=(u|0)<3;x=C+(t*56|0)+8|0;y=C+(t*56|0)+12|0;z=C+(t*56|0)+40|0;n=0;q=a;s=k[C+(t*56|0)+16>>2]|0;while(1){if(w)b=aa(k[y>>2]|0,k[x>>2]|0)|0;else{e=k[z>>2]|0;d=0;b=1;do{b=aa(k[e+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(u|0))}if(n>>>0>=b>>>0)break;c=k[sc>>2]|0;g=0;h=q;j=s;while(1){do if(!(c&16384)){b=k[F>>2]|0;if((k[b>>2]|0)==1){oc=77;break}d=k[G>>2]|0;e=k[H>>2]|0;if((k[b+4>>2]|0)==1){b=d+(aa(k[e>>2]|0,t)|0)|0;break}else{b=k[I>>2]|0;f=(t|0)/(b|0)|0;b=t-(aa(f,b)|0)|0;b=d+(aa(k[e>>2]|0,f)|0)+(b<<2)|0;break}}else oc=77;while(0);if((oc|0)==77){oc=0;b=(k[G>>2]|0)+(t<<2)|0}A=+o[b>>2]*+o[h>>2];b=l[j>>0]|0;do if(!(k[ec>>2]&16384)){d=k[Fb>>2]|0;if((k[d>>2]|0)==1){oc=83;break}e=k[Mb>>2]|0;f=k[Hb>>2]|0;if((k[d+4>>2]|0)==1){b=e+(aa(k[f>>2]|0,b)|0)|0;break}else{uc=k[Nb>>2]|0;d=(b|0)/(uc|0)|0;b=b-(aa(d,uc)|0)|0;b=e+(aa(k[f>>2]|0,d)|0)+(b*12|0)|0;break}}else oc=83;while(0);if((oc|0)==83){oc=0;b=(k[Mb>>2]|0)+(b*12|0)|0}uc=b+(g<<2)|0;o[uc>>2]=A+ +o[uc>>2];g=g+1|0;if((g|0)==(bc|0))break;else{h=h+4|0;j=j+1|0}}n=n+1|0;q=q+(bc<<2)|0;s=s+bc|0}t=t+1|0}while(t>>>0<v>>>0)}k[Jb>>2]=0;k[Kb>>2]=0;k[fc>>2]=16842752;k[Lb>>2]=pc;i1(nc,ec,fc,1.0);g=k[nc>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,nc,ec,-1);XN(nc);g=k[Fb>>2]|0;h=g+4|0;j=(k[ec>>2]&16384|0)==0;f=0;do{do if(j?(k[g>>2]|0)!=1:0){d=k[Mb>>2]|0;b=k[Hb>>2]|0;if((k[h>>2]|0)==1){b=d+(k[b>>2]<<7)|0;break}else{uc=k[Nb>>2]|0;C=128/(uc|0)|0;uc=128-(aa(C,uc)|0)|0;b=d+(aa(k[b>>2]|0,C)|0)+(uc*12|0)|0;break}}else oc=92;while(0);if((oc|0)==92){oc=0;d=k[Mb>>2]|0;b=d+1536|0}A=+o[b+(f<<2)>>2];e=0;do{do if(j?(k[g>>2]|0)!=1:0){d=k[Mb>>2]|0;b=k[Hb>>2]|0;if((k[h>>2]|0)==1){b=d+(aa(k[b>>2]|0,e)|0)|0;break}else{uc=k[Nb>>2]|0;C=(e|0)/(uc|0)|0;uc=e-(aa(C,uc)|0)|0;b=d+(aa(k[b>>2]|0,C)|0)+(uc*12|0)|0;break}}else oc=100;while(0);if((oc|0)==100){oc=0;b=d+(e*12|0)|0}uc=b+(f<<2)|0;o[uc>>2]=+o[uc>>2]/A;e=e+1|0}while((e|0)!=256);f=f+1|0}while((f|0)!=3);k[kc>>2]=0;k[Aa>>2]=0;k[Ba>>2]=1124007936;f=Ca;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Ea>>2]=Da;k[Ga>>2]=Fa;k[Ha>>2]=0;k[Fa>>2]=0;k[Ia>>2]=1124007936;f=Ja;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[La>>2]=Ka;k[Na>>2]=Ma;k[Oa>>2]=0;k[Ma>>2]=0;k[Pa>>2]=1124007936;f=Qa;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Sa>>2]=Ra;k[Ua>>2]=Ta;f=Ta;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[nc>>2]=0;k[nc+4>>2]=0;k[nc+8>>2]=0;k[nc+12>>2]=0;k[nc+16>>2]=0;k[nc+20>>2]=0;k[nc+24>>2]=0;k[nc+28>>2]=0;G0(kc,ec,qc,1.0,-1.0,nc);k[jc>>2]=0;k[Va>>2]=0;k[Wa>>2]=1124007936;f=Xa;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Za>>2]=Ya;k[$a>>2]=_a;k[ab>>2]=0;k[_a>>2]=0;k[bb>>2]=1124007936;f=cb;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[eb>>2]=db;k[gb>>2]=fb;k[hb>>2]=0;k[fb>>2]=0;k[ib>>2]=1124007936;f=jb;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[lb>>2]=kb;k[nb>>2]=mb;f=mb;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));b=k[kc>>2]|0;Ph[k[(k[b>>2]|0)+84>>2]&511](b,kc,jc);k[Ob>>2]=0;k[Pb>>2]=0;k[ic>>2]=-1056571392;k[Qb>>2]=jc;g7(gc,ic);k[fc>>2]=-1056833530;k[Tb>>2]=gc;k[Rb>>2]=1;k[Sb>>2]=4;g7(lc,fc);A=+p[lc>>3]/Ub;XN(jc);XN(kc);b=Wb;k[b>>2]=0;k[b+4>>2]=0;k[nc>>2]=33619968;k[Vb>>2]=qc;mY(ec,nc);B=+o[Xb>>2];b=k[Yb>>2]|0;if(b|0?(C=b+12|0,uc=k[C>>2]|0,k[C>>2]=uc+-1,(uc|0)==1):0){d=k[Yb>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[ob>>2]|0;if(b|0)break;b=B1()|0;d=k[Yb>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[Yb>>2]=0}k[Yb>>2]=0;k[Mb>>2]=0;k[Mb+4>>2]=0;k[Mb+8>>2]=0;k[Mb+12>>2]=0;if((k[Db>>2]|0)>0){d=k[Fb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Db>>2]|0))}b=k[Hb>>2]|0;if(!((b|0)==(Gb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);D=D+1|0;if(A<B)break a}while((D|0)<(k[pb>>2]|0))}while(0);b=k[dc>>2]|0;if(b|0?(oc=b+4|0,uc=k[oc>>2]|0,k[oc>>2]=uc+-1,(uc|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);e=pc+36|0;b=k[e>>2]|0;if(b|0?(oc=b+12|0,uc=k[oc>>2]|0,k[oc>>2]=uc+-1,(uc|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[pc+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;uc=pc+16|0;k[uc>>2]=0;k[uc+4>>2]=0;k[uc+8>>2]=0;k[uc+12>>2]=0;if((k[$b>>2]|0)>0){d=k[Zb>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[$b>>2]|0))}b=k[_b>>2]|0;if(!((b|0)==(ac|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=qc+36|0;b=k[e>>2]|0;if(b|0?(pc=b+12|0,uc=k[pc>>2]|0,k[pc>>2]=uc+-1,(uc|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[qc+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;uc=qc+16|0;d=qc+4|0;k[uc>>2]=0;k[uc+4>>2]=0;k[uc+8>>2]=0;k[uc+12>>2]=0;if((k[d>>2]|0)>0){e=k[qc+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[qc+44>>2]|0;if(!((b|0)==(qc+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=sc+36|0;b=k[e>>2]|0;if(b|0?(qc=b+12|0,uc=k[qc>>2]|0,k[qc>>2]=uc+-1,(uc|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[sc+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;uc=sc+16|0;k[uc>>2]=0;k[uc+4>>2]=0;k[uc+8>>2]=0;k[uc+12>>2]=0;if((k[m>>2]|0)>0){d=k[sc+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[sc+44>>2]|0;if((b|0)==(sc+48|0)|(b|0)==0){zF(rc);r=tc;return}ggb(k[b+-4>>2]|0);zF(rc);r=tc;return}function p0a(a){a=a|0;return k[a+12>>2]|0}function q0a(a,b){a=a|0;b=b|0;k[a+12>>2]=b;return}function r0a(a){a=a|0;return +(+o[a+16>>2])}function s0a(a,b){a=a|0;b=+b;o[a+16>>2]=b;return}function t0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+76>>2];i=a+4|0;e=b+80|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+84>>2];k[a+12>>2]=k[b+88>>2];k[a+16>>2]=k[b+92>>2];k[a+20>>2]=k[b+96>>2];k[a+24>>2]=k[b+100>>2];k[a+28>>2]=k[b+104>>2];k[a+32>>2]=k[b+108>>2];d=k[b+112>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+120>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+116>>2]|0;a=k[g>>2]|0;e=k[b+120>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function u0a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0.0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=r;r=r+704|0;B=M+640|0;A=M+584|0;v=M+448|0;l=M+576|0;H=M+520|0;D=M+464|0;m=M+224|0;q=M;j=b+40|0;f=k[j>>2]|0;e=k[f>>2]|0;f=k[f+4>>2]|0;k[H>>2]=1124007936;K=H+4|0;d=H+8|0;I=H+40|0;h=K;n=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(n|0));k[I>>2]=d;L=H+48|0;J=H+44|0;k[J>>2]=L;k[H+52>>2]=0;k[L>>2]=0;k[B>>2]=e;g=B+4|0;k[g>>2]=f;G1(H,2,B,5);f=k[j>>2]|0;e=k[f>>2]|0;f=k[f+4>>2]|0;k[D>>2]=1124007936;F=D+4|0;d=D+8|0;C=D+40|0;h=F;n=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(n|0));k[C>>2]=d;G=D+48|0;E=D+44|0;k[E>>2]=G;k[D+52>>2]=0;k[G>>2]=0;k[B>>2]=e;k[g>>2]=f;G1(D,2,B,5);h=k[j>>2]|0;d=k[h+4>>2]|0;h=k[h>>2]|0;y=k[a+12>>2]|0;z=k[a+8>>2]|0;k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=b;x=A+4|0;w=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[A>>2]=33619968;k[x>>2]=H;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=16842752;k[v+4>>2]=a;k[l>>2]=y+-1+((y|0)/-2|0);k[l+4>>2]=z+-1+((z|0)/-2|0);fla(B,A,-1,v,l,0.0,0);if((h|0)>0){e=d+-1|0;f=k[H+16>>2]|0;g=k[k[J>>2]>>2]|0;d=0;do{z=f+(aa(d,g)|0)+(e<<2)|0;o[z>>2]=0.0;d=d+1|0}while((d|0)!=(h|0))}e=k[j>>2]|0;d=k[e+4>>2]|0;e=k[e>>2]|0;y=k[a+68>>2]|0;z=k[a+64>>2]|0;k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=b;x=A+4|0;w=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[A>>2]=33619968;k[x>>2]=D;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=16842752;k[v+4>>2]=a+56;k[l>>2]=y+-1+((y|0)/-2|0);k[l+4>>2]=z+-1+((z|0)/-2|0);fla(B,A,-1,v,l,0.0,0);if((d|0)>0)zpb((k[D+16>>2]|0)+(aa(k[k[E>>2]>>2]|0,e+-1|0)|0)|0,0,d<<2|0)|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=1124007936;d=m+16|0;e=m+48|0;h=m+12|0;n=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(n|0));k[e>>2]=d;d=m+56|0;k[m+52>>2]=d;k[m+60>>2]=0;k[d>>2]=0;k[m+64>>2]=1124007936;d=m+72|0;e=m+104|0;h=m+68|0;n=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(n|0));k[e>>2]=d;d=m+112|0;k[m+108>>2]=d;k[m+116>>2]=0;k[d>>2]=0;k[m+120>>2]=1124007936;d=m+128|0;e=m+160|0;h=m+124|0;n=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(n|0));k[e>>2]=d;h=m+168|0;k[m+164>>2]=h;n=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(n|0));y0(m,H,1.0);k[B>>2]=1124007936;y=B+4|0;d=B+8|0;w=B+40|0;h=y;n=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(n|0));k[w>>2]=d;z=B+48|0;x=B+44|0;k[x>>2]=z;k[B+52>>2]=0;k[z>>2]=0;d=k[m>>2]|0;dh[k[(k[d>>2]|0)+12>>2]&255](d,m,B,-1);XN(m);k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=1124007936;d=q+16|0;e=q+48|0;h=q+12|0;n=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(n|0));k[e>>2]=d;d=q+56|0;k[q+52>>2]=d;k[q+60>>2]=0;k[d>>2]=0;k[q+64>>2]=1124007936;d=q+72|0;e=q+104|0;h=q+68|0;n=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(n|0));k[e>>2]=d;d=q+112|0;k[q+108>>2]=d;k[q+116>>2]=0;k[d>>2]=0;k[q+120>>2]=1124007936;d=q+128|0;e=q+160|0;h=q+124|0;n=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(n|0));k[e>>2]=d;h=q+168|0;k[q+164>>2]=h;n=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(n|0));y0(q,D,1.0);k[A>>2]=1124007936;m=A+4|0;d=A+8|0;b=A+40|0;h=m;n=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(n|0));k[b>>2]=d;l=A+48|0;a=A+44|0;k[a>>2]=l;k[A+52>>2]=0;k[l>>2]=0;j=k[q>>2]|0;dh[k[(k[j>>2]|0)+12>>2]&255](j,q,A,-1);XN(q);j=k[w>>2]|0;h=k[j>>2]|0;j=k[j+4>>2]|0;if((h|0)>0?(s=B+16|0,t=c+4|0,u=c+8|0,(j|0)>0):0){e=0;do{d=0;do{f=(k[s>>2]|0)+(aa(k[k[x>>2]>>2]|0,e)|0)+(d<<2)|0;i=+o[f>>2];p[v>>3]=i;f=k[t>>2]|0;if((f|0)==(k[u>>2]|0))Koa(c,v);else{p[f>>3]=i;k[t>>2]=f+8}d=d+1|0}while((d|0)<(j|0));e=e+1|0}while((e|0)<(h|0));f=A+16|0;e=0;do{d=0;do{g=(k[f>>2]|0)+(aa(k[k[a>>2]>>2]|0,e)|0)+(d<<2)|0;i=+o[g>>2];p[v>>3]=i;g=k[t>>2]|0;if((g|0)==(k[u>>2]|0))Koa(c,v);else{p[g>>3]=i;k[t>>2]=g+8}d=d+1|0}while((d|0)<(j|0));e=e+1|0}while((e|0)<(h|0))}n=H+36|0;d=k[n>>2]|0;if(d|0?(c=d+12|0,v=k[c>>2]|0,k[c>>2]=v+-1,(v|0)==1):0){e=k[n>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[H+32>>2]|0;if(!d){d=B1()|0;e=k[n>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[n>>2]=0}k[n>>2]=0;j=H+16|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[K>>2]|0)>0){e=k[I>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[K>>2]|0))}h=D+36|0;d=k[h>>2]|0;if(d|0?(c=d+12|0,v=k[c>>2]|0,k[c>>2]=v+-1,(v|0)==1):0){e=k[h>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[D+32>>2]|0;if(!d){d=B1()|0;e=k[h>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[h>>2]=0}k[h>>2]=0;g=D+16|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[F>>2]|0)>0){e=k[C>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[F>>2]|0))}f=A+36|0;d=k[f>>2]|0;if(d|0?(c=d+12|0,v=k[c>>2]|0,k[c>>2]=v+-1,(v|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[A+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;A=A+16|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[m>>2]|0)>0){e=k[b>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[m>>2]|0))}d=k[a>>2]|0;if(!((d|0)==(l|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=B+36|0;d=k[f>>2]|0;if(d|0?(v=d+12|0,A=k[v>>2]|0,k[v>>2]=A+-1,(A|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[B+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;B=B+16|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[y>>2]|0)>0){e=k[w>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[y>>2]|0))}d=k[x>>2]|0;if(!((d|0)==(z|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[h>>2]|0;if(d|0?(A=d+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){e=k[h>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[D+32>>2]|0;if(d|0)break;d=B1()|0;e=k[h>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[h>>2]=0}k[h>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[F>>2]|0)>0){e=k[C>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[F>>2]|0))}d=k[E>>2]|0;if(!((d|0)==(G|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[n>>2]|0;if(d|0?(F=d+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){e=k[n>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[H+32>>2]|0;if(d|0)break;d=B1()|0;e=k[n>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[n>>2]=0}k[n>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[K>>2]|0)>0){e=k[I>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[K>>2]|0))}d=k[J>>2]|0;if((d|0)==(L|0)|(d|0)==0){r=M;return}ggb(k[d+-4>>2]|0);r=M;return}function v0a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0.0;pb=r;r=r+1728|0;Va=pb+784|0;Za=pb+1672|0;Ya=pb+1616|0;Wa=pb+560|0;Xa=pb+504|0;db=pb+56|0;cb=pb+1376|0;Ua=pb+1320|0;eb=pb+1264|0;Da=pb+1248|0;Ea=pb+40|0;Fa=pb+24|0;Ga=pb+8|0;ob=pb+1192|0;q=pb+1608|0;nb=pb+1136|0;u=pb+1600|0;lb=pb+1080|0;kb=pb+960|0;La=pb+904|0;ib=pb+888|0;fb=pb+876|0;J=pb+1544|0;ha=pb+1488|0;Ha=pb+864|0;Ia=pb+852|0;Ja=pb;Ka=pb+840|0;Ma=pb+280|0;Na=pb+1432|0;do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[ob>>2]=k[g>>2];m=ob+4|0;a=g+4|0;k[m>>2]=k[a>>2];mb=ob+8|0;k[mb>>2]=k[g+8>>2];k[ob+12>>2]=k[g+12>>2];k[ob+16>>2]=k[g+16>>2];k[ob+20>>2]=k[g+20>>2];k[ob+24>>2]=k[g+24>>2];k[ob+28>>2]=k[g+28>>2];k[ob+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[ob+36>>2]=f;n=ob+40|0;k[n>>2]=mb;mb=ob+48|0;h=ob+44|0;k[h>>2]=mb;k[ob+52>>2]=0;k[mb>>2]=0;if(f|0){mb=f+12|0;k[mb>>2]=(k[mb>>2]|0)+1}if((k[a>>2]|0)<3){jb=k[g+44>>2]|0;mb=k[h>>2]|0;k[mb>>2]=k[jb>>2];k[mb+4>>2]=k[jb+4>>2];mb=n;break}k[m>>2]=0;x1(ob,k[a>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[g+40>>2]|0;l=k[n>>2]|0;g=k[g+44>>2]|0;f=k[h>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[j+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0));mb=n}else mb=n}else{Q1(ob,a,-1);mb=ob+40|0}while(0);bb=k[mb>>2]|0;jb=k[bb>>2]|0;k[q>>2]=k[bb+4>>2];k[q+4>>2]=jb;x2(b,q,0,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[nb>>2]=k[h>>2];n=nb+4|0;a=h+4|0;k[n>>2]=k[a>>2];jb=nb+8|0;k[jb>>2]=k[h+8>>2];k[nb+12>>2]=k[h+12>>2];k[nb+16>>2]=k[h+16>>2];k[nb+20>>2]=k[h+20>>2];k[nb+24>>2]=k[h+24>>2];k[nb+28>>2]=k[h+28>>2];k[nb+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[nb+36>>2]=f;g=nb+40|0;k[g>>2]=jb;jb=nb+48|0;l=nb+44|0;k[l>>2]=jb;k[nb+52>>2]=0;k[jb>>2]=0;if(f|0){jb=f+12|0;k[jb>>2]=(k[jb>>2]|0)+1}if((k[a>>2]|0)<3){bb=k[h+44>>2]|0;jb=k[l>>2]|0;k[jb>>2]=k[bb>>2];k[jb+4>>2]=k[bb+4>>2];break}k[n>>2]=0;x1(nb,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(nb,b,-1);while(0);bb=k[mb>>2]|0;jb=k[bb>>2]|0;k[u>>2]=k[bb+4>>2];k[u+4>>2]=jb;x2(c,u,16,0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[lb>>2]=k[h>>2];n=lb+4|0;a=h+4|0;k[n>>2]=k[a>>2];jb=lb+8|0;k[jb>>2]=k[h+8>>2];k[lb+12>>2]=k[h+12>>2];k[lb+16>>2]=k[h+16>>2];k[lb+20>>2]=k[h+20>>2];k[lb+24>>2]=k[h+24>>2];k[lb+28>>2]=k[h+28>>2];k[lb+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[lb+36>>2]=f;g=lb+40|0;k[g>>2]=jb;jb=lb+48|0;l=lb+44|0;k[l>>2]=jb;k[lb+52>>2]=0;k[jb>>2]=0;if(f|0){jb=f+12|0;k[jb>>2]=(k[jb>>2]|0)+1}if((k[a>>2]|0)<3){bb=k[h+44>>2]|0;jb=k[l>>2]|0;k[jb>>2]=k[bb>>2];k[jb+4>>2]=k[bb+4>>2];break}k[n>>2]=0;x1(lb,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(lb,c,-1);while(0);jb=ob+16|0;if(k[jb>>2]|0){g=k[ob+4>>2]|0;if((g|0)<3)a=aa(k[ob+12>>2]|0,k[ob+8>>2]|0)|0;else{h=k[mb>>2]|0;f=0;a=1;do{a=aa(k[h+(f<<2)>>2]|0,a)|0;f=f+1|0}while((f|0)!=(g|0))}if(!((a|0)!=0?(k[ob>>2]&4088|0)==16:0))v=35}else v=35;if((v|0)==35){k[Va>>2]=0;a=Va+4|0;k[a>>2]=0;f=ZT(36)|0;k[f>>2]=1;l=f+4|0;k[Va>>2]=l;k[a>>2]=31;i[f+35>>0]=0;g=393893;K=l+31|0;do{i[l>>0]=i[g>>0]|0;l=l+1|0;g=g+1|0}while((l|0)<(K|0));Y8(-215,Va,393925,393933,62);k[a>>2]=0;k[Va>>2]=0;bb=k[f>>2]|0;k[f>>2]=bb+-1;if((bb|0)==1)ggb(k[f+-4>>2]|0)}k[kb>>2]=1124007936;a=kb+8|0;f=kb+40|0;l=kb+4|0;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[f>>2]=a;a=kb+48|0;k[kb+44>>2]=a;k[kb+52>>2]=0;k[a>>2]=0;k[kb+56>>2]=1124007936;a=kb+64|0;f=kb+96|0;l=kb+60|0;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[f>>2]=a;$a=kb+104|0;n=kb+100|0;k[n>>2]=$a;k[kb+108>>2]=0;k[$a>>2]=0;k[La>>2]=1124007936;$a=La+4|0;Ca=La+8|0;_a=La+40|0;l=$a;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[_a>>2]=Ca;bb=La+48|0;ab=La+44|0;k[ab>>2]=bb;k[La+52>>2]=0;k[bb>>2]=0;f=k[mb>>2]|0;g=k[f+4>>2]|0;f=k[f>>2]|0;k[Za>>2]=1124007936;m=Za+4|0;a=Za+8|0;j=Za+40|0;l=m;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[j>>2]=a;l=Za+48|0;h=Za+44|0;k[h>>2]=l;k[Za+52>>2]=0;k[l>>2]=0;k[Va>>2]=f;Oa=Va+4|0;k[Oa>>2]=g;G1(Za,2,Va,21);KG(La,Za)|0;g=Za+36|0;a=k[g>>2]|0;if(a|0?(Sa=a+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[Za+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;Ta=Za+16|0;k[Ta>>2]=0;k[Ta+4>>2]=0;k[Ta+8>>2]=0;k[Ta+12>>2]=0;if((k[m>>2]|0)>0){f=k[j>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[h>>2]|0;if(!((a|0)==(l|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Va+4|0;a=m+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Va>>2]=33619968;k[m>>2]=La;SW(ob,Va,21,.00392156862745098,0.0);k[Va>>2]=1124007936;m=Va+4|0;a=Va+8|0;j=Va+40|0;l=m;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[j>>2]=a;l=Va+48|0;h=Va+44|0;k[h>>2]=l;k[Va+52>>2]=0;k[l>>2]=0;k[db>>2]=1;ia=db+4|0;k[ia>>2]=2;G1(Va,2,db,5);KG(kb,Va)|0;g=Va+36|0;a=k[g>>2]|0;if(a|0?(Sa=a+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[Va+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;Ta=Va+16|0;k[Ta>>2]=0;k[Ta+4>>2]=0;k[Ta+8>>2]=0;k[Ta+12>>2]=0;if((k[m>>2]|0)>0){f=k[j>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[h>>2]|0;if(!((a|0)==(l|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[Va>>2]=1124007936;m=Va+4|0;a=Va+8|0;j=Va+40|0;l=m;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[j>>2]=a;l=Va+48|0;h=Va+44|0;k[h>>2]=l;k[Va+52>>2]=0;k[l>>2]=0;k[db>>2]=2;k[ia>>2]=1;G1(Va,2,db,5);KG(kb+56|0,Va)|0;g=Va+36|0;a=k[g>>2]|0;if(a|0?(Sa=a+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[Va+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;Ta=Va+16|0;k[Ta>>2]=0;k[Ta+4>>2]=0;k[Ta+8>>2]=0;k[Ta+12>>2]=0;if((k[m>>2]|0)>0){f=k[j>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[h>>2]|0;if(!((a|0)==(l|0)|(a|0)==0))ggb(k[a+-4>>2]|0);Ba=k[kb+16>>2]|0;o[Ba>>2]=1.0;o[Ba+4>>2]=-1.0;Ba=k[kb+72>>2]|0;o[Ba>>2]=1.0;o[Ba+(k[k[n>>2]>>2]|0)>>2]=-1.0;Ba=kb+112|0;k[Ba>>2]=2;wa=kb+116|0;o[wa>>2]=.019999999552965164;k[ib>>2]=0;Qa=ib+4|0;k[Qa>>2]=0;k[ib+8>>2]=0;k[fb>>2]=0;Pa=fb+4|0;k[Pa>>2]=0;k[fb+8>>2]=0;k[J>>2]=k[La>>2];ea=J+4|0;a=k[$a>>2]|0;k[ea>>2]=a;l=J+8|0;k[l>>2]=k[Ca>>2];m=J+12|0;xa=La+12|0;k[m>>2]=k[xa>>2];ba=J+16|0;Sa=La+16|0;k[ba>>2]=k[Sa>>2];n=J+20|0;ya=La+20|0;k[n>>2]=k[ya>>2];b=J+24|0;za=La+24|0;k[b>>2]=k[za>>2];q=J+28|0;Aa=La+28|0;k[q>>2]=k[Aa>>2];$=J+32|0;Ra=La+32|0;k[$>>2]=k[Ra>>2];ca=J+36|0;Ta=La+36|0;f=k[Ta>>2]|0;k[ca>>2]=f;da=J+40|0;k[da>>2]=l;ga=J+48|0;fa=J+44|0;k[fa>>2]=ga;k[J+52>>2]=0;k[ga>>2]=0;if(f){a=f+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[$a>>2]|0}if((a|0)>=3){k[ea>>2]=0;x1(J,a,0,0,0);if((k[ea>>2]|0)>0){f=k[_a>>2]|0;g=k[da>>2]|0;h=k[ab>>2]|0;j=k[fa>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[f+(a<<2)>>2];k[j+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[ea>>2]|0))}}else{ua=k[ab>>2]|0;va=k[fa>>2]|0;k[va>>2]=k[ua>>2];k[va+4>>2]=k[ua+4>>2]}g=k[da>>2]|0;a=k[g>>2]|0;g=k[g+4>>2]|0;f=g+a|0;if((f|0)>800){S=800.0/+(f|0);k[Va+8>>2]=0;k[Va+12>>2]=0;k[Va>>2]=16842752;k[Va+4>>2]=J;Y=Za+4|0;va=Y+4|0;k[va>>2]=0;k[va+4>>2]=0;k[Za>>2]=33619968;k[Y>>2]=J;k[cb>>2]=~~(+(a|0)*S+.5);k[cb+4>>2]=~~(+(g|0)*S+.5);Rla(Va,Za,cb,0.0,0.0,1);g=k[da>>2]|0;Y=k[g>>2]|0;g=k[g+4>>2]|0}else Y=a;k[Ua>>2]=k[J>>2];I=Ua+4|0;a=k[ea>>2]|0;k[I>>2]=a;H=Ua+8|0;k[H>>2]=k[l>>2];k[Ua+12>>2]=k[m>>2];G=Ua+16|0;k[G>>2]=k[ba>>2];k[Ua+20>>2]=k[n>>2];k[Ua+24>>2]=k[b>>2];k[Ua+28>>2]=k[q>>2];B=Ua+32|0;k[B>>2]=k[$>>2];C=Ua+36|0;f=k[ca>>2]|0;k[C>>2]=f;E=Ua+40|0;k[E>>2]=H;H=Ua+48|0;F=Ua+44|0;k[F>>2]=H;k[Ua+52>>2]=0;k[H>>2]=0;if(f){a=f+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[ea>>2]|0}if((a|0)>=3){k[I>>2]=0;x1(Ua,a,0,0,0);if((k[I>>2]|0)>0){f=k[da>>2]|0;h=k[E>>2]|0;j=k[fa>>2]|0;l=k[F>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[f+(a<<2)>>2];k[l+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[I>>2]|0))}}else{ua=k[fa>>2]|0;va=k[F>>2]|0;k[va>>2]=k[ua>>2];k[va+4>>2]=k[ua+4>>2]}h=k[E>>2]|0;f=k[h+4>>2]|0;h=k[h>>2]|0;k[Va>>2]=1124007936;A=Va+4|0;a=Va+8|0;x=Va+40|0;l=A;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[x>>2]=a;y=Va+48|0;w=Va+44|0;k[w>>2]=y;k[Va+52>>2]=0;k[y>>2]=0;k[db>>2]=h;k[ia>>2]=f;G1(Va,2,db,21);k[Za+8>>2]=0;k[Za+12>>2]=0;k[Za>>2]=16842752;k[Za+4>>2]=Ua;c=Ya+4|0;q=c+4|0;k[q>>2]=0;k[q+4>>2]=0;k[Ya>>2]=33619968;k[c>>2]=Va;$aa(Za,Ya,44,0);k[Za>>2]=0;k[Za+4>>2]=0;k[Za+8>>2]=0;k[Ya+8>>2]=0;k[Ya+12>>2]=0;k[Ya>>2]=16842752;k[Ya+4>>2]=Va;c=Wa+4|0;q=c+4|0;k[q>>2]=0;k[q+4>>2]=0;k[Wa>>2]=33882112;k[c>>2]=Za;FV(Ya,Wa);k[Ya>>2]=0;c=Ya+4|0;k[c>>2]=0;k[Ya+8>>2]=0;k[Wa>>2]=0;q=Wa+4|0;k[q>>2]=0;k[Wa+8>>2]=0;k[Xa>>2]=0;b=Xa+4|0;k[b>>2]=0;k[Xa+8>>2]=0;u0a(kb,k[Za>>2]|0,Ya);u0a(kb,(k[Za>>2]|0)+56|0,Wa);u0a(kb,(k[Za>>2]|0)+112|0,Xa);p[db>>3]=0.0;a=k[c>>2]|0;v=k[Ya>>2]|0;u=v;n=a;if((a|0)==(v|0))f=u;else{j=ib+8|0;l=k[Wa>>2]|0;m=k[Xa>>2]|0;h=0;f=u;do{z=+p[f+(h<<3)>>3];S=+p[l+(h<<3)>>3];s=+p[m+(h<<3)>>3];s=+Q(+(z*z+S*S+s*s))/100.0;p[db>>3]=s;f=k[Qa>>2]|0;if((f|0)==(k[j>>2]|0))Koa(ib,db);else{p[f>>3]=s;k[Qa>>2]=f+8}h=h+1|0;f=v}while(h>>>0<a-v>>3>>>0);a=v}if((n|0)==(f|0))m=n;else{m=n+(~((n+-8-a|0)>>>3)<<3)|0;k[c>>2]=m}l=k[Wa>>2]|0;a=k[q>>2]|0;if((a|0)==(l|0))j=l;else{j=a+(~((a+-8-l|0)>>>3)<<3)|0;k[q>>2]=j}h=k[Xa>>2]|0;a=k[b>>2]|0;f=h;if((a|0)==(h|0))a=h;else{a=a+(~((a+-8-f|0)>>>3)<<3)|0;k[b>>2]=a}if(h|0){if((a|0)!=(h|0))k[b>>2]=a+(~((a+-8-f|0)>>>3)<<3);ggb(h)}a=l;if(l|0){if((j|0)!=(l|0))k[q>>2]=j+(~((j+-8-a|0)>>>3)<<3);ggb(l)}a=v;if(v|0){if((m|0)!=(u|0))k[c>>2]=m+(~((m+-8-v|0)>>>3)<<3);ggb(a)}zF(Za);h=Va+36|0;a=k[h>>2]|0;do if(a|0){ua=a+12|0;va=k[ua>>2]|0;k[ua>>2]=va+-1;if((va|0)!=1)break;f=k[h>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[Va+32>>2]|0;if(a|0)break;a=B1()|0;f=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[h>>2]=0}while(0);k[h>>2]=0;va=Va+16|0;k[va>>2]=0;k[va+4>>2]=0;k[va+8>>2]=0;k[va+12>>2]=0;if((k[A>>2]|0)>0){f=k[x>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[w>>2]|0;if(!((a|0)==(y|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[C>>2]|0;do if(a|0){ua=a+12|0;va=k[ua>>2]|0;k[ua>>2]=va+-1;if((va|0)!=1)break;f=k[C>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[B>>2]|0;if(a|0)break;a=B1()|0;f=k[C>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[C>>2]=0}while(0);k[C>>2]=0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[I>>2]|0)>0){f=k[E>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[I>>2]|0))}a=k[F>>2]|0;if(!((a|0)==(H|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=k[da>>2]|0;f=k[h+4>>2]|0;h=k[h>>2]|0;k[Wa>>2]=1124007936;X=Wa+4|0;a=Wa+8|0;V=Wa+40|0;l=X;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[V>>2]=a;W=Wa+48|0;U=Wa+44|0;k[U>>2]=W;k[Wa+52>>2]=0;k[W>>2]=0;k[Va>>2]=h;k[Va+4>>2]=f;G1(Wa,2,Va,5);k[Xa>>2]=0;k[Xa+4>>2]=0;k[Xa+8>>2]=0;k[Va+8>>2]=0;k[Va+12>>2]=0;k[Va>>2]=16842752;k[Va+4>>2]=J;a=Za+4|0;va=a+4|0;k[va>>2]=0;k[va+4>>2]=0;k[Za>>2]=33882112;k[a>>2]=Xa;FV(Va,Za);a=k[Ba>>2]|0;a:do if((a|0)>=0){M=(Y|0)>0;N=(g|0)>0;O=Wa+16|0;P=Va+4|0;T=Va+8|0;f=0;m=0;L=0;b=0;q=0;n=0;l=0;j=0;h=0;b:while(1){if((a|0)>=0){z=+(L|0);K=0;while(1){if((a|0)>=0){J=K+L|0;t=+(K|0);I=0;c=q;F=l;E=h;while(1){va=J+I|0;if((va|0)<=(a|0)&(va|0)>0){k[Va>>2]=L;k[Za>>2]=K;k[Ya>>2]=I;l=n;do if((l|0)==(j|0)){q=(n-b|0)/12|0;a=q+1|0;if(a>>>0>357913941){v=155;break b}va=(j-b|0)/12|0;j=va<<1;j=va>>>0<178956970?(j>>>0<a>>>0?a:j):357913941;if(!j)a=0;else{if(j>>>0>357913941){v=158;break b}h=j*12|0;h=(h|0)==0?1:h;while(1){a=fgb(h)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}}w=a+(q*12|0)|0;y=a+(j*12|0)|0;k[w>>2]=0;k[a+(q*12|0)+4>>2]=0;k[a+(q*12|0)+8>>2]=0;x=w+12|0;v=b;if((l|0)==(v|0))a=w;else{q=l;u=0;a=w;while(1){h=a+-12|0;k[h>>2]=0;n=a+-8|0;k[n>>2]=0;k[a+-4>>2]=0;j=q+-8|0;q=q+-12|0;a=(k[j>>2]|0)-(k[q>>2]|0)>>2;do if(a|0){eQ(h,a);h=k[q>>2]|0;a=(k[j>>2]|0)-h|0;if((a|0)<=0)break;upb(k[n>>2]|0,h|0,a|0)|0;k[n>>2]=(k[n>>2]|0)+(a>>2<<2)}while(0);a=u+-1|0;if((q|0)==(v|0)){a=w+(a*12|0)|0;n=b;break}else{u=a;a=w+(a*12|0)|0}}}u=n;if((l|0)!=(u|0))do{h=l;l=l+-12|0;b=k[l>>2]|0;q=b;if(b|0){h=h+-8|0;j=k[h>>2]|0;if((j|0)!=(b|0))k[h>>2]=j+(~((j+-4-q|0)>>>2)<<2);ggb(b)}}while((l|0)!=(u|0));if(!n){G=a;n=x;H=y;break}ggb(n);G=a;n=x;H=y}else{k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;G=b;n=l+12|0;H=j}while(0);if(((n-G|0)/12|0)>>>0<=m>>>0){v=179;break b}h=G;j=h+(m*12|0)+4|0;a=k[j>>2]|0;l=h+(m*12|0)+8|0;if((a|0)==(k[l>>2]|0))Q4(h+(m*12|0)|0,Va);else{k[a>>2]=k[Va>>2];k[j>>2]=a+4}a=k[j>>2]|0;if((a|0)==(k[l>>2]|0))Q4(h+(m*12|0)|0,Za);else{k[a>>2]=k[Za>>2];k[j>>2]=a+4}a=k[j>>2]|0;if((a|0)==(k[l>>2]|0))Q4(h+(m*12|0)|0,Ya);else{k[a>>2]=k[Ya>>2];k[j>>2]=a+4}m=m+1|0;do if(M){a=k[Xa>>2]|0;s=+(I|0);C=k[O>>2]|0;if(!N)break;w=k[a+128>>2]|0;x=k[k[a+156>>2]>>2]|0;y=k[a+72>>2]|0;A=k[k[a+100>>2]>>2]|0;B=k[a+16>>2]|0;j=k[k[a+44>>2]>>2]|0;l=k[k[U>>2]>>2]|0;h=0;do{b=w+(aa(x,h)|0)|0;q=y+(aa(A,h)|0)|0;u=B+(aa(j,h)|0)|0;v=C+(aa(l,h)|0)|0;a=0;do{S=+R(+(+o[b+(a<<2)>>2]),+z);S=S*+R(+(+o[q+(a<<2)>>2]),+t);S=S*+R(+(+o[u+(a<<2)>>2]),+s);o[v+(a<<2)>>2]=S;a=a+1|0}while((a|0)!=(g|0));h=h+1|0}while((h|0)!=(Y|0))}while(0);k[Va>>2]=0;k[P>>2]=0;k[T>>2]=0;u0a(kb,Wa,Va);b=F;do if((b|0)==(E|0)){l=(F-c|0)/12|0;a=l+1|0;if(a>>>0>357913941){v=197;break b}va=(E-c|0)/12|0;j=va<<1;j=va>>>0<178956970?(j>>>0<a>>>0?a:j):357913941;if(!j)a=0;else{if(j>>>0>357913941){v=200;break b}h=j*12|0;h=(h|0)==0?1:h;while(1){a=fgb(h)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}}q=a+(l*12|0)|0;h=q;C=a+(j*12|0)|0;k[q>>2]=0;k[a+(l*12|0)+4>>2]=0;k[a+(l*12|0)+8>>2]=0;l=q+12|0;B=c;if((b|0)==(B|0)){a=h;c=F}else{A=b;a=h;do{v=q+-12|0;k[v>>2]=0;y=q+-8|0;k[y>>2]=0;k[q+-4>>2]=0;x=A+-8|0;A=A+-12|0;h=(k[x>>2]|0)-(k[A>>2]|0)|0;w=h>>3;do if(w|0){if(w>>>0>536870911){v=209;break b}j=(h|0)==0?1:h;while(1){h=fgb(j)|0;if(h|0){u=h;break}h=k[207666]|0;k[207666]=h+0;if(!h){u=0;break}Qh[h&7]()}k[y>>2]=u;k[v>>2]=u;k[q+-4>>2]=u+(w<<3);j=k[A>>2]|0;h=(k[x>>2]|0)-j|0;if((h|0)<=0)break;upb(u|0,j|0,h|0)|0;k[y>>2]=u+(h>>3<<3)}while(0);q=a+-12|0;a=q}while((A|0)!=(B|0))}v=c;if((b|0)!=(v|0))do{h=b;b=b+-12|0;q=k[b>>2]|0;u=q;if(q|0){h=h+-8|0;j=k[h>>2]|0;if((j|0)!=(q|0))k[h>>2]=j+(~((j+-8-u|0)>>>3)<<3);ggb(q)}}while((b|0)!=(v|0));if(!c){q=a;y=C;break}ggb(c);q=a;y=C}else{k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;q=c;l=b+12|0;y=E}while(0);a=k[P>>2]|0;h=k[Va>>2]|0;j=h;if((a|0)!=(h|0)){c=((l-q|0)/12|0)>>>0>f>>>0;x=q;v=x+(f*12|0)+4|0;w=x+(f*12|0)+8|0;x=x+(f*12|0)|0;u=0;do{if(!c){v=229;break b}a=h+(u<<3)|0;b=k[v>>2]|0;if((b|0)==(k[w>>2]|0)){Koa(x,a);h=k[Va>>2]|0;j=h}else{p[b>>3]=+p[a>>3];k[v>>2]=b+8}u=u+1|0;a=k[P>>2]|0}while(u>>>0<a-h>>3>>>0)}f=f+1|0;h=j;if(j|0){if((a|0)!=(j|0))k[P>>2]=a+(~((a+-8-h|0)>>>3)<<3);ggb(j)}b=G;j=H;h=y;a=k[Ba>>2]|0}else{q=c;l=F;h=E}if((I|0)<(a|0)){I=I+1|0;c=q;F=l;E=h}else break}}if((K|0)<(a|0))K=K+1|0;else break}}if((L|0)<(a|0))L=L+1|0;else{gb=b;hb=q;e=n;d=l;break a}}if((v|0)==155)ad(426534,426557,304,426811);else if((v|0)==158){pb=te(4)|0;k[pb>>2]=172664;Cf(pb|0,28816,1287)}else if((v|0)==179)ad(426635,426557,315,426658);else if((v|0)==197)ad(426534,426557,304,426811);else if((v|0)==200){pb=te(4)|0;k[pb>>2]=172664;Cf(pb|0,28816,1287)}else if((v|0)==209)ad(426534,426557,304,426811);else if((v|0)==229)ad(426635,426557,315,426658)}else{gb=0;hb=0;e=0;d=0}while(0);zF(Xa);g=Wa+36|0;a=k[g>>2]|0;do if(a|0){ua=a+12|0;va=k[ua>>2]|0;k[ua>>2]=va+-1;if((va|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[Wa+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;va=Wa+16|0;k[va>>2]=0;k[va+4>>2]=0;k[va+8>>2]=0;k[va+12>>2]=0;if((k[X>>2]|0)>0){f=k[V>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[X>>2]|0))}a=k[U>>2]|0;if(!((a|0)==(W|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[ca>>2]|0;do if(a|0){ua=a+12|0;va=k[ua>>2]|0;k[ua>>2]=va+-1;if((va|0)!=1)break;f=k[ca>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[$>>2]|0;if(a|0)break;a=B1()|0;f=k[ca>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[ca>>2]=0}while(0);k[ca>>2]=0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[ea>>2]|0)>0){f=k[da>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ea>>2]|0))}a=k[fa>>2]|0;if(!((a|0)==(ga|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[ha>>2]=k[La>>2];$=ha+4|0;a=k[$a>>2]|0;k[$>>2]=a;ca=ha+8|0;k[ca>>2]=k[Ca>>2];k[ha+12>>2]=k[xa>>2];W=ha+16|0;k[W>>2]=k[Sa>>2];k[ha+20>>2]=k[ya>>2];k[ha+24>>2]=k[za>>2];k[ha+28>>2]=k[Aa>>2];V=ha+32|0;k[V>>2]=k[Ra>>2];X=ha+36|0;f=k[Ta>>2]|0;k[X>>2]=f;Y=ha+40|0;k[Y>>2]=ca;ca=ha+48|0;ba=ha+44|0;k[ba>>2]=ca;k[ha+52>>2]=0;k[ca>>2]=0;if(f){a=f+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[$a>>2]|0}do if((a|0)<3){ua=k[ab>>2]|0;va=k[ba>>2]|0;k[va>>2]=k[ua>>2];k[va+4>>2]=k[ua+4>>2]}else{k[$>>2]=0;x1(ha,a,0,0,0);if((k[$>>2]|0)<=0)break;f=k[_a>>2]|0;g=k[Y>>2]|0;h=k[ab>>2]|0;j=k[ba>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[f+(a<<2)>>2];k[j+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[$>>2]|0))}while(0);g=k[Y>>2]|0;a=k[g>>2]|0;g=k[g+4>>2]|0;f=g+a|0;if((f|0)>800){S=800.0/+(f|0);k[Va+8>>2]=0;k[Va+12>>2]=0;k[Va>>2]=16842752;k[Va+4>>2]=ha;va=Za+4|0;ua=va+4|0;k[ua>>2]=0;k[ua+4>>2]=0;k[Za>>2]=33619968;k[va>>2]=ha;k[Ya>>2]=~~(+(a|0)*S+.5);k[Ya+4>>2]=~~(+(g|0)*S+.5);Rla(Va,Za,Ya,0.0,0.0,1);g=k[Y>>2]|0;a=k[g>>2]|0;g=k[g+4>>2]|0}k[Va>>2]=1124007936;U=Va+4|0;f=Va+8|0;P=Va+40|0;l=U;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[P>>2]=f;T=Va+48|0;O=Va+44|0;k[O>>2]=T;k[Va+52>>2]=0;k[T>>2]=0;k[db>>2]=a;k[ia>>2]=g;G1(Va,2,db,5);k[Za>>2]=0;k[Za+4>>2]=0;k[Za+8>>2]=0;k[Wa+8>>2]=0;k[Wa+12>>2]=0;k[Wa>>2]=16842752;k[Wa+4>>2]=ha;L=Xa+4|0;K=L+4|0;k[K>>2]=0;k[K+4>>2]=0;k[Xa>>2]=33882112;k[L>>2]=Za;FV(Wa,Xa);k[Wa>>2]=0;L=Wa+4|0;k[L>>2]=0;k[Wa+8>>2]=0;k[Xa>>2]=0;K=Xa+4|0;k[K>>2]=0;k[Xa+8>>2]=0;k[db>>2]=0;J=db+4|0;k[J>>2]=0;k[db+8>>2]=0;k[cb>>2]=0;I=cb+4|0;k[I>>2]=0;k[cb+8>>2]=0;k[Ua>>2]=0;H=Ua+4|0;k[H>>2]=0;k[Ua+8>>2]=0;k[eb>>2]=0;G=eb+4|0;k[G>>2]=0;k[eb+8>>2]=0;k[Da>>2]=0;F=Da+4|0;k[F>>2]=0;k[Da+8>>2]=0;k[Ea>>2]=0;E=Ea+4|0;k[E>>2]=0;k[Ea+8>>2]=0;k[Fa>>2]=0;C=Fa+4|0;k[C>>2]=0;k[Fa+8>>2]=0;u0a(kb,(k[Za>>2]|0)+112|0,Wa);u0a(kb,(k[Za>>2]|0)+56|0,Xa);u0a(kb,k[Za>>2]|0,db);x=k[L>>2]|0;M=k[Wa>>2]|0;N=M;B=x;do if((x|0)!=(M|0)){l=cb+8|0;m=Ua+8|0;n=eb+8|0;b=Da+8|0;q=Ea+8|0;u=Fa+8|0;c=k[Xa>>2]|0;v=k[db>>2]|0;w=x-M>>3;j=0;do{f=N+(j<<3)|0;if(+p[f>>3]>.05){p[Ga>>3]=1.0;a=k[I>>2]|0;if((a|0)==(k[l>>2]|0))Koa(cb,Ga);else{p[a>>3]=1.0;k[I>>2]=a+8}}else{p[Ga>>3]=0.0;a=k[I>>2]|0;if((a|0)==(k[l>>2]|0))Koa(cb,Ga);else{p[a>>3]=0.0;k[I>>2]=a+8}}g=c+(j<<3)|0;if(+p[g>>3]>.05){p[Ga>>3]=1.0;a=k[H>>2]|0;if((a|0)==(k[m>>2]|0))Koa(Ua,Ga);else{p[a>>3]=1.0;k[H>>2]=a+8}}else{p[Ga>>3]=0.0;a=k[H>>2]|0;if((a|0)==(k[m>>2]|0))Koa(Ua,Ga);else{p[a>>3]=0.0;k[H>>2]=a+8}}h=v+(j<<3)|0;if(+p[h>>3]>.05){p[Ga>>3]=1.0;a=k[G>>2]|0;if((a|0)==(k[n>>2]|0))Koa(eb,Ga);else{p[a>>3]=1.0;k[G>>2]=a+8}}else{p[Ga>>3]=0.0;a=k[G>>2]|0;if((a|0)==(k[n>>2]|0))Koa(eb,Ga);else{p[a>>3]=0.0;k[G>>2]=a+8}}if(+p[f>>3]<-.05){p[Ga>>3]=1.0;a=k[F>>2]|0;if((a|0)==(k[b>>2]|0))Koa(Da,Ga);else{p[a>>3]=1.0;k[F>>2]=a+8}}else{p[Ga>>3]=0.0;a=k[F>>2]|0;if((a|0)==(k[b>>2]|0))Koa(Da,Ga);else{p[a>>3]=0.0;k[F>>2]=a+8}}if(+p[g>>3]<-.05){p[Ga>>3]=1.0;a=k[E>>2]|0;if((a|0)==(k[q>>2]|0))Koa(Ea,Ga);else{p[a>>3]=1.0;k[E>>2]=a+8}}else{p[Ga>>3]=0.0;a=k[E>>2]|0;if((a|0)==(k[q>>2]|0))Koa(Ea,Ga);else{p[a>>3]=0.0;k[E>>2]=a+8}}if(+p[h>>3]<-.05){p[Ga>>3]=1.0;a=k[C>>2]|0;if((a|0)==(k[u>>2]|0))Koa(Fa,Ga);else{p[a>>3]=1.0;k[C>>2]=a+8}}else{p[Ga>>3]=0.0;a=k[C>>2]|0;if((a|0)==(k[u>>2]|0))Koa(Fa,Ga);else{p[a>>3]=0.0;k[C>>2]=a+8}}j=j+1|0}while(j>>>0<w>>>0);g=fb+8|0;h=k[cb>>2]|0;j=k[Ua>>2]|0;l=k[eb>>2]|0;f=0;do{s=+p[h+(f<<3)>>3]*+p[j+(f<<3)>>3]*+p[l+(f<<3)>>3];p[Ga>>3]=s;a=k[Pa>>2]|0;if((a|0)==(k[g>>2]|0))Koa(fb,Ga);else{p[a>>3]=s;k[Pa>>2]=a+8}f=f+1|0;m=x-M>>3}while(f>>>0<m>>>0);if((x|0)==(M|0))break;f=k[Da>>2]|0;g=k[Ea>>2]|0;h=k[Fa>>2]|0;j=k[fb>>2]|0;a=0;do{va=j+(a<<3)|0;p[va>>3]=+p[va>>3]-+p[f+(a<<3)>>3]*+p[g+(a<<3)>>3]*+p[h+(a<<3)>>3];a=a+1|0}while(a>>>0<m>>>0)}while(0);if((B|0)!=(N|0)){B=B+(~((B+-8-M|0)>>>3)<<3)|0;k[L>>2]=B}A=k[Xa>>2]|0;a=k[K>>2]|0;if((a|0)==(A|0))y=A;else{y=a+(~((a+-8-A|0)>>>3)<<3)|0;k[K>>2]=y}x=k[db>>2]|0;a=k[J>>2]|0;if((a|0)==(x|0))w=x;else{w=a+(~((a+-8-x|0)>>>3)<<3)|0;k[J>>2]=w}v=k[cb>>2]|0;a=k[I>>2]|0;if((a|0)==(v|0))c=v;else{c=a+(~((a+-8-v|0)>>>3)<<3)|0;k[I>>2]=c}u=k[Ua>>2]|0;a=k[H>>2]|0;if((a|0)==(u|0))q=u;else{q=a+(~((a+-8-u|0)>>>3)<<3)|0;k[H>>2]=q}b=k[eb>>2]|0;a=k[G>>2]|0;if((a|0)==(b|0))n=b;else{n=a+(~((a+-8-b|0)>>>3)<<3)|0;k[G>>2]=n}m=k[Da>>2]|0;a=k[F>>2]|0;if((a|0)==(m|0))l=m;else{l=a+(~((a+-8-m|0)>>>3)<<3)|0;k[F>>2]=l}j=k[Ea>>2]|0;a=k[E>>2]|0;if((a|0)==(j|0))h=j;else{h=a+(~((a+-8-j|0)>>>3)<<3)|0;k[E>>2]=h}g=k[Fa>>2]|0;a=k[C>>2]|0;f=g;if((a|0)==(g|0))a=g;else{a=a+(~((a+-8-f|0)>>>3)<<3)|0;k[C>>2]=a}if(g|0){if((a|0)!=(g|0))k[C>>2]=a+(~((a+-8-f|0)>>>3)<<3);ggb(g)}a=j;if(j|0){if((h|0)!=(j|0))k[E>>2]=h+(~((h+-8-a|0)>>>3)<<3);ggb(j)}a=m;if(m|0){if((l|0)!=(m|0))k[F>>2]=l+(~((l+-8-a|0)>>>3)<<3);ggb(m)}a=b;if(b|0){if((n|0)!=(b|0))k[G>>2]=n+(~((n+-8-a|0)>>>3)<<3);ggb(b)}a=u;if(u|0){if((q|0)!=(u|0))k[H>>2]=q+(~((q+-8-a|0)>>>3)<<3);ggb(u)}a=v;if(v|0){if((c|0)!=(v|0))k[I>>2]=c+(~((c+-8-a|0)>>>3)<<3);ggb(v)}a=x;if(x|0){if((w|0)!=(x|0))k[J>>2]=w+(~((w+-8-a|0)>>>3)<<3);ggb(x)}a=A;if(A|0){if((y|0)!=(A|0))k[K>>2]=y+(~((y+-8-a|0)>>>3)<<3);ggb(A)}a=M;if(M|0){if((B|0)!=(N|0))k[L>>2]=B+(~((B+-8-M|0)>>>3)<<3);ggb(a)}zF(Za);g=Va+36|0;a=k[g>>2]|0;do if(a|0){ua=a+12|0;va=k[ua>>2]|0;k[ua>>2]=va+-1;if((va|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[Va+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;va=Va+16|0;k[va>>2]=0;k[va+4>>2]=0;k[va+8>>2]=0;k[va+12>>2]=0;if((k[U>>2]|0)>0){f=k[P>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[U>>2]|0))}a=k[O>>2]|0;if(!((a|0)==(T|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[X>>2]|0;do if(a|0){ua=a+12|0;va=k[ua>>2]|0;k[ua>>2]=va+-1;if((va|0)!=1)break;f=k[X>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[V>>2]|0;if(a|0)break;a=B1()|0;f=k[X>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[X>>2]=0}while(0);k[X>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[$>>2]|0)>0){f=k[Y>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[$>>2]|0))}a=k[ba>>2]|0;if(!((a|0)==(ca|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=d-hb|0;x=(h|0)/12|0;va=hb;oa=va+4|0;f=hb;g=(k[oa>>2]|0)-(k[f>>2]|0)>>3;k[eb>>2]=1124007936;ta=eb+4|0;a=eb+8|0;ra=eb+40|0;l=ta;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[ra>>2]=a;ua=eb+48|0;sa=eb+44|0;k[sa>>2]=ua;k[eb+52>>2]=0;k[ua>>2]=0;k[Va>>2]=x;k[Oa>>2]=g;G1(eb,2,Va,5);f=(k[oa>>2]|0)-(k[f>>2]|0)|0;n=f>>3;k[Va>>2]=1124007936;I=Va+4|0;a=Va+8|0;G=Va+40|0;l=I;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[G>>2]=a;J=Va+48|0;H=Va+44|0;k[H>>2]=J;k[Va+52>>2]=0;k[J>>2]=0;k[db>>2]=x;k[ia>>2]=n;G1(Va,2,db,5);k[Za>>2]=1124007936;E=Za+4|0;a=Za+8|0;B=Za+40|0;l=E;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[B>>2]=a;F=Za+48|0;C=Za+44|0;k[C>>2]=F;k[Za+52>>2]=0;k[F>>2]=0;k[db>>2]=x;k[ia>>2]=x;G1(Za,2,db,5);m=(h|0)>0;do if(m){l=k[Va+16>>2]|0;if((f|0)<=0)break;g=k[k[H>>2]>>2]|0;f=0;do{h=k[va+(f*12|0)>>2]|0;j=l+(aa(g,f)|0)|0;a=0;do{o[j+(a<<2)>>2]=+p[h+(a<<3)>>3];a=a+1|0}while((a|0)<(n|0));f=f+1|0}while((f|0)<(x|0))}while(0);k[Wa>>2]=0;k[Wa+4>>2]=0;k[Wa+8>>2]=1124007936;a=Wa+16|0;f=Wa+48|0;l=Wa+12|0;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[f>>2]=a;a=Wa+56|0;k[Wa+52>>2]=a;k[Wa+60>>2]=0;k[a>>2]=0;k[Wa+64>>2]=1124007936;a=Wa+72|0;f=Wa+104|0;l=Wa+68|0;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[f>>2]=a;a=Wa+112|0;k[Wa+108>>2]=a;k[Wa+116>>2]=0;k[a>>2]=0;k[Wa+120>>2]=1124007936;a=Wa+128|0;f=Wa+160|0;l=Wa+124|0;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[f>>2]=a;l=Wa+168|0;k[Wa+164>>2]=l;K=l+56|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));y0(Wa,Va,1.0);k[Ya>>2]=1124007936;y=Ya+4|0;a=Ya+8|0;v=Ya+40|0;l=y;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[v>>2]=a;A=Ya+48|0;w=Ya+44|0;k[w>>2]=A;k[Ya+52>>2]=0;k[A>>2]=0;c=k[Wa>>2]|0;dh[k[(k[c>>2]|0)+12>>2]&255](c,Wa,Ya,-1);XN(Wa);k[Xa>>2]=1124007936;c=Xa+4|0;a=Xa+8|0;q=Xa+40|0;l=c;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[q>>2]=a;u=Xa+48|0;b=Xa+44|0;k[b>>2]=u;k[Xa+52>>2]=0;k[u>>2]=0;k[db>>2]=x;k[ia>>2]=n;G1(Xa,2,db,5);do if(m){g=k[ib>>2]|0;qa=(k[Qa>>2]|0)-g|0;j=qa>>3;l=k[Xa+16>>2]|0;if((qa|0)<=0)break;h=k[k[b>>2]>>2]|0;f=0;do{m=k[va+(f*12|0)>>2]|0;n=l+(aa(h,f)|0)|0;a=0;do{o[n+(a<<2)>>2]=+p[m+(a<<3)>>3]*+p[g+(a<<3)>>3];a=a+1|0}while((a|0)<(j|0));f=f+1|0}while((f|0)<(x|0))}while(0);a1(db,Va,Ya);g=k[db>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,db,Za,-1);XN(db);k[db+8>>2]=0;k[db+12>>2]=0;k[db>>2]=16842752;k[db+4>>2]=Za;k[cb+8>>2]=0;k[cb+12>>2]=0;k[cb>>2]=16842752;k[cb+4>>2]=Xa;g=Ua+4|0;a=g+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Ua>>2]=33619968;k[g>>2]=eb;NZ(db,cb,Ua,16)|0;g=Xa+36|0;a=k[g>>2]|0;do if(a|0){pa=a+12|0;qa=k[pa>>2]|0;k[pa>>2]=qa+-1;if((qa|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[Xa+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;qa=Xa+16|0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[qa+12>>2]=0;if((k[c>>2]|0)>0){f=k[q>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[b>>2]|0;if(!((a|0)==(u|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=Ya+36|0;a=k[g>>2]|0;do if(a|0){pa=a+12|0;qa=k[pa>>2]|0;k[pa>>2]=qa+-1;if((qa|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[Ya+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;qa=Ya+16|0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[qa+12>>2]=0;if((k[y>>2]|0)>0){f=k[v>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[y>>2]|0))}a=k[w>>2]|0;if(!((a|0)==(A|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=Za+36|0;a=k[g>>2]|0;do if(a|0){pa=a+12|0;qa=k[pa>>2]|0;k[pa>>2]=qa+-1;if((qa|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[Za+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;qa=Za+16|0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[qa+12>>2]=0;if((k[E>>2]|0)>0){f=k[B>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[E>>2]|0))}a=k[C>>2]|0;if(!((a|0)==(F|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=Va+36|0;a=k[g>>2]|0;do if(a|0){pa=a+12|0;qa=k[pa>>2]|0;k[pa>>2]=qa+-1;if((qa|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[Va+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;qa=Va+16|0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[qa+12>>2]=0;if((k[I>>2]|0)>0){f=k[G>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[I>>2]|0))}a=k[H>>2]|0;if(!((a|0)==(J|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[db>>2]=0;qa=db+4|0;k[qa>>2]=0;k[db+8>>2]=0;k[Za>>2]=0;c=Za+4|0;k[c>>2]=0;k[Za+8>>2]=0;p[Va>>3]=.33;g=Za+8|0;Koa(Za,Va);f=k[c>>2]|0;a=k[g>>2]|0;p[Va>>3]=.33;if((f|0)==(a|0)){Koa(Za,Va);f=k[c>>2]|0;a=k[g>>2]|0}else{p[f>>3]=.33;f=f+8|0;k[c>>2]=f}p[Va>>3]=.33;if((f|0)==(a|0))Koa(Za,Va);else{p[f>>3]=.33;k[c>>2]=f+8}k[Ya>>2]=0;q=Ya+4|0;k[q>>2]=0;k[Ya+8>>2]=0;u=(e|0)==(gb|0);if(u){a=0;f=0}else{l=Ya+8|0;m=k[Za>>2]|0;n=m+8|0;b=m+16|0;a=0;f=gb;g=0;h=0;j=e;while(1){pa=k[f+(a*12|0)>>2]|0;s=+(k[pa>>2]|0)*+p[m>>3]+0.0+ +(k[pa+4>>2]|0)*+p[n>>3]+ +(k[pa+8>>2]|0)*+p[b>>3];p[Va>>3]=s;if((g|0)==(h|0)){Koa(Ya,Va);f=gb;j=e}else{p[g>>3]=s;k[q>>2]=g+8}a=a+1|0;if(a>>>0>=((j-f|0)/12|0)>>>0)break;g=k[q>>2]|0;h=k[l>>2]|0}a=k[Ya>>2]|0;f=k[q>>2]|0}yGa(db,a,f);g=a;if(a|0){if((f|0)!=(a|0))k[q>>2]=f+(~((f+-8-g|0)>>>3)<<3);ggb(a)}k[Va>>2]=0;n=Va+4|0;k[n>>2]=0;k[Va+8>>2]=0;do if(u){g=0;h=0}else{m=Va+8|0;a=0;f=gb;h=0;j=0;l=e;while(1){g=k[f+(a*12|0)>>2]|0;g=(k[g+4>>2]|0)+(k[g>>2]|0)+(k[g+8>>2]|0)|0;k[Ya>>2]=g;if((h|0)==(j|0)){Q4(Va,Ya);f=gb;g=e}else{k[h>>2]=g;k[n>>2]=h+4;g=l}a=a+1|0;if(a>>>0>=((g-f|0)/12|0)>>>0)break;h=k[n>>2]|0;j=k[m>>2]|0;l=g}a=k[n>>2]|0;f=k[Va>>2]|0;h=f;j=a;if((a|0)==(f|0)){g=j;break}l=k[db>>2]|0;f=a-f>>2;a=0;do{g=l+(a<<3)|0;if((k[h+(a<<2)>>2]|0)!=1)p[g>>3]=+p[g>>3]*0.0;a=a+1|0}while(a>>>0<f>>>0);g=j}while(0);l=k[Za>>2]|0;a=k[c>>2]|0;if((a|0)==(l|0))j=l;else{j=a+(~((a+-8-l|0)>>>3)<<3)|0;k[c>>2]=j}f=h;if((g|0)==(h|0))a=h;else{a=g+(~((g+-4-f|0)>>>2)<<2)|0;k[n>>2]=a}if(h|0){if((a|0)!=(h|0))k[n>>2]=a+(~((a+-4-f|0)>>>2)<<2);ggb(h)}a=l;if(l|0){if((j|0)!=(l|0))k[c>>2]=j+(~((j+-8-a|0)>>>3)<<3);ggb(l)}A=Xa+4|0;B=Xa+8|0;C=cb+4|0;E=cb+8|0;F=Ua+4|0;G=Ua+8|0;H=Da+4|0;I=Da+8|0;J=Ga+4|0;K=Ga+8|0;L=Ha+4|0;M=Ha+8|0;N=Ia+4|0;O=Ia+8|0;P=Ka+4|0;T=Ka+8|0;U=Ka+8|0;pa=eb+16|0;V=Ha+8|0;W=Ia+8|0;X=Ga+8|0;Y=Xa+8|0;$=cb+8|0;ba=Ua+8|0;ca=Da+8|0;da=hb;ea=(d|0)==(hb|0);fa=Va+4|0;ga=Va+8|0;ha=Za+4|0;ia=Za+8|0;ja=Ya+4|0;ka=Ya+8|0;la=Za+8|0;ma=Ya+8|0;na=Va+8|0;s=D;z=0.0;y=0;while(1){S=z-s;if(!(+Q(+(S*S))>.0001))break;k[Xa>>2]=0;k[A>>2]=0;k[B>>2]=0;k[cb>>2]=0;k[C>>2]=0;k[E>>2]=0;k[Ua>>2]=0;k[F>>2]=0;k[G>>2]=0;k[Da>>2]=0;k[H>>2]=0;k[I>>2]=0;if((k[oa>>2]|0)!=(k[da>>2]|0)){h=0;do{if((d|0)==(hb|0))s=0.0;else{f=k[db>>2]|0;g=(d-hb|0)/12|0;a=0;s=0.0;do{s=s+ +p[(k[va+(a*12|0)>>2]|0)+(h<<3)>>3]*+p[f+(a<<3)>>3];a=a+1|0}while(a>>>0<g>>>0)}a=(k[ib>>2]|0)+(h<<3)|0;t=s-+p[a>>3];p[Va>>3]=t;f=k[F>>2]|0;if((f|0)==(k[ba>>2]|0))Koa(Ua,Va);else{p[f>>3]=t;k[F>>2]=f+8}s=s+ +p[a>>3];p[Va>>3]=s;a=k[H>>2]|0;if((a|0)==(k[ca>>2]|0))Koa(Da,Va);else{p[a>>3]=s;k[H>>2]=a+8}h=h+1|0}while(h>>>0<(k[oa>>2]|0)-(k[da>>2]|0)>>3>>>0)}p[Ea>>3]=0.0;p[Fa>>3]=0.0;a=k[Pa>>2]|0;j=k[fb>>2]|0;if((a|0)==(j|0)){u=0;c=0;w=0;x=0}else{l=k[Ua>>2]|0;m=k[Da>>2]|0;h=a-j>>3;a=0;f=0;g=0;while(1){x=j+(a<<3)|0;s=+p[l+(a<<3)>>3];t=+o[wa>>2];t=t*t;s=(+p[x>>3]+1.0)*.5*+Z(+(s*s*-.5/t));p[Ea>>3]=s;S=+p[m+(a<<3)>>3];t=(1.0-+p[x>>3])*.5*+Z(+(S*S*-.5/t));p[Fa>>3]=t;if((f|0)==(g|0))Koa(Xa,Ea);else{p[f>>3]=s;k[A>>2]=f+8}f=k[C>>2]|0;if((f|0)==(k[$>>2]|0))Koa(cb,Fa);else{p[f>>3]=t;k[C>>2]=f+8}a=a+1|0;if(a>>>0>=h>>>0)break;f=k[A>>2]|0;g=k[Y>>2]|0}w=k[A>>2]|0;x=k[Xa>>2]|0;u=w;c=x}k[Ga>>2]=0;k[J>>2]=0;k[K>>2]=0;k[Ha>>2]=0;k[L>>2]=0;k[M>>2]=0;n=c;c:do if((u|0)==(c|0)){k[Ia>>2]=0;k[N>>2]=0;k[O>>2]=0;q=0}else{v=k[cb>>2]|0;a=0;f=n;j=0;l=0;g=c;h=u;while(1){s=+p[f+(a<<3)>>3]+ +p[v+(a<<3)>>3];p[Va>>3]=s;if((j|0)==(l|0)){Koa(Ga,Va);g=c;h=u}else{p[j>>3]=s;k[J>>2]=j+8}a=a+1|0;if(a>>>0>=h-g>>3>>>0)break;f=g;j=k[J>>2]|0;l=k[X>>2]|0}a=k[J>>2]|0;f=k[Ga>>2]|0;b=f;k[Ia>>2]=0;k[N>>2]=0;k[O>>2]=0;q=a;if((a|0)!=(f|0)){g=a-f>>3;f=0;do{if(+p[b+(f<<3)>>3]==0.0){p[Va>>3]=1.0;a=k[N>>2]|0;if((a|0)==(k[W>>2]|0))Koa(Ia,Va);else{p[a>>3]=1.0;k[N>>2]=a+8}}else{p[Va>>3]=0.0;a=k[N>>2]|0;if((a|0)==(k[W>>2]|0))Koa(Ia,Va);else{p[a>>3]=0.0;k[N>>2]=a+8}}f=f+1|0}while(f>>>0<g>>>0);h=u;g=c}if((h|0)==(g|0))break;m=k[Ia>>2]|0;a=0;f=n;j=0;l=0;while(1){s=(+p[f+(a<<3)>>3]-+p[v+(a<<3)>>3])/(+p[b+(a<<3)>>3]+ +p[m+(a<<3)>>3]);p[Va>>3]=s;if((j|0)==(l|0)){Koa(Ha,Va);g=c;h=u}else{p[j>>3]=s;k[L>>2]=j+8}a=a+1|0;if(a>>>0>=h-g>>3>>>0)break c;f=g;j=k[L>>2]|0;l=k[V>>2]|0}}while(0);p[Ja>>3]=0.0;k[Ka>>2]=0;k[P>>2]=0;k[T>>2]=0;if(!ea){m=0;a=hb;f=d;do{p[Ja>>3]=0.0;g=k[a+4>>2]|0;h=k[a>>2]|0;if((g|0)==(h|0))s=0.0;else{j=(k[pa>>2]|0)+(aa(k[k[sa>>2]>>2]|0,m)|0)|0;l=k[Ha>>2]|0;h=g-h>>3;g=0;s=0.0;do{s=s+ +o[j+(g<<2)>>2]*+p[l+(g<<3)>>3];g=g+1|0}while(g>>>0<h>>>0);p[Ja>>3]=s}g=k[P>>2]|0;if((g|0)==(k[U>>2]|0)){Koa(Ka,Ja);a=hb;f=d}else{p[g>>3]=s;k[P>>2]=g+8}m=m+1|0}while(m>>>0<((f-a|0)/12|0)>>>0)}a=k[qa>>2]|0;f=k[db>>2]|0;h=f;if((a|0)!=(f|0)){g=k[Ka>>2]|0;f=a-f>>3;a=0;do{p[h+(a<<3)>>3]=+p[g+(a<<3)>>3];a=a+1|0}while(a>>>0<f>>>0)}k[Va>>2]=0;k[fa>>2]=0;k[ga>>2]=0;k[Za>>2]=0;k[ha>>2]=0;k[ia>>2]=0;k[Ya>>2]=0;k[ja>>2]=0;k[ka>>2]=0;a=k[oa>>2]|0;d:do if((a|0)==(k[da>>2]|0))g=a;else{g=0;do{if((d|0)==(hb|0))s=0.0;else{f=(d-hb|0)/12|0;a=0;s=0.0;do{s=s+ +p[(k[va+(a*12|0)>>2]|0)+(g<<3)>>3]*+p[h+(a<<3)>>3];a=a+1|0}while(a>>>0<f>>>0)}a=(k[ib>>2]|0)+(g<<3)|0;t=s-+p[a>>3];p[Wa>>3]=t;f=k[ha>>2]|0;if((f|0)==(k[la>>2]|0))Koa(Za,Wa);else{p[f>>3]=t;k[ha>>2]=f+8}s=s+ +p[a>>3];p[Wa>>3]=s;a=k[ja>>2]|0;if((a|0)==(k[ma>>2]|0))Koa(Ya,Wa);else{p[a>>3]=s;k[ja>>2]=a+8}g=g+1|0;f=k[oa>>2]|0;a=k[da>>2]|0}while(g>>>0<f-a>>3>>>0);if((f|0)==(a|0)){g=f;a=f;break}h=k[Za>>2]|0;j=k[Ya>>2]|0;f=0;a=0;g=0;while(1){t=+p[h+(f<<3)>>3];s=+o[wa>>2];t=+Z(+(-(t*t)/s));S=+p[j+(f<<3)>>3];s=-+_(+(t+ +Z(+(-(S*S)/s))));p[Wa>>3]=s;if((a|0)==(g|0))Koa(Va,Wa);else{p[a>>3]=s;k[fa>>2]=a+8}f=f+1|0;a=k[va+4>>2]|0;g=k[hb>>2]|0;if(f>>>0>=a-g>>3>>>0)break d;a=k[fa>>2]|0;g=k[na>>2]|0}}while(0);g=a-g>>3;if(!g){t=0.0;s=0.0}else{f=k[Va>>2]|0;t=0.0;a=0;do{t=t+ +p[f+(a<<3)>>3];a=a+1|0}while((a|0)!=(g|0));s=+(g>>>0)}s=t/s;a=k[Ya>>2]|0;f=a;if(a|0){g=k[ja>>2]|0;if((g|0)!=(a|0))k[ja>>2]=g+(~((g+-8-f|0)>>>3)<<3);ggb(a)}a=k[Za>>2]|0;f=a;if(a|0){g=k[ha>>2]|0;if((g|0)!=(a|0))k[ha>>2]=g+(~((g+-8-f|0)>>>3)<<3);ggb(a)}a=k[Va>>2]|0;f=a;if(a|0){g=k[fa>>2]|0;if((g|0)!=(a|0))k[fa>>2]=g+(~((g+-8-f|0)>>>3)<<3);ggb(a)}do if((y|0)>14){l=3;f=k[Ka>>2]|0;h=q;j=w}else{if((w|0)==(x|0))j=w;else{j=w+(~((w+-8-x|0)>>>3)<<3)|0;k[A>>2]=j}a=k[cb>>2]|0;f=k[C>>2]|0;if((f|0)!=(a|0))k[C>>2]=f+(~((f+-8-a|0)>>>3)<<3);a=k[Ua>>2]|0;f=k[F>>2]|0;if((f|0)!=(a|0))k[F>>2]=f+(~((f+-8-a|0)>>>3)<<3);a=k[Da>>2]|0;f=k[H>>2]|0;if((f|0)!=(a|0))k[H>>2]=f+(~((f+-8-a|0)>>>3)<<3);a=k[Ga>>2]|0;if((q|0)==(a|0))g=q;else{g=q+(~((q+-8-a|0)>>>3)<<3)|0;k[J>>2]=g}a=k[Ha>>2]|0;f=k[L>>2]|0;if((f|0)!=(a|0))k[L>>2]=f+(~((f+-8-a|0)>>>3)<<3);a=k[Ia>>2]|0;f=k[N>>2]|0;if((f|0)!=(a|0))k[N>>2]=f+(~((f+-8-a|0)>>>3)<<3);f=k[Ka>>2]|0;a=k[P>>2]|0;if((a|0)==(f|0)){l=0;h=g;break}k[P>>2]=a+(~((a+-8-f|0)>>>3)<<3);l=0;h=g}while(0);y=y+1|0;a=f;if(f|0){g=k[P>>2]|0;if((g|0)!=(f|0))k[P>>2]=g+(~((g+-8-a|0)>>>3)<<3);ggb(f)}a=k[Ia>>2]|0;f=a;if(a|0){g=k[N>>2]|0;if((g|0)!=(a|0))k[N>>2]=g+(~((g+-8-f|0)>>>3)<<3);ggb(a)}a=k[Ha>>2]|0;f=a;if(a|0){g=k[L>>2]|0;if((g|0)!=(a|0))k[L>>2]=g+(~((g+-8-f|0)>>>3)<<3);ggb(a)}a=k[Ga>>2]|0;f=a;if(a|0){if((h|0)!=(a|0))k[J>>2]=h+(~((h+-8-f|0)>>>3)<<3);ggb(a)}a=k[Da>>2]|0;f=a;if(a|0){g=k[H>>2]|0;if((g|0)!=(a|0))k[H>>2]=g+(~((g+-8-f|0)>>>3)<<3);ggb(a)}a=k[Ua>>2]|0;f=a;if(a|0){g=k[F>>2]|0;if((g|0)!=(a|0))k[F>>2]=g+(~((g+-8-f|0)>>>3)<<3);ggb(a)}a=k[cb>>2]|0;f=a;if(a|0){g=k[C>>2]|0;if((g|0)!=(a|0))k[C>>2]=g+(~((g+-8-f|0)>>>3)<<3);ggb(a)}a=x;if(x|0){if((j|0)!=(x|0))k[A>>2]=j+(~((j+-8-a|0)>>>3)<<3);ggb(x)}if(l|0)break;else{S=z;z=s;s=S}}h=k[_a>>2]|0;g=k[h+4>>2]|0;h=k[h>>2]|0;k[Ma>>2]=0;k[Ma+4>>2]=0;k[Ma+8>>2]=1124007936;a=Ma+16|0;f=Ma+48|0;l=Ma+12|0;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[f>>2]=a;a=Ma+56|0;k[Ma+52>>2]=a;k[Ma+60>>2]=0;k[a>>2]=0;k[Ma+64>>2]=1124007936;a=Ma+72|0;f=Ma+104|0;l=Ma+68|0;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[f>>2]=a;a=Ma+112|0;k[Ma+108>>2]=a;k[Ma+116>>2]=0;k[a>>2]=0;k[Ma+120>>2]=1124007936;a=Ma+128|0;f=Ma+160|0;l=Ma+124|0;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[f>>2]=a;l=Ma+168|0;k[Ma+164>>2]=l;K=l+56|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[Va>>2]=g;k[Va+4>>2]=h;j1(Ma,48,Va,5);k[cb>>2]=1124007936;fa=cb+4|0;a=cb+8|0;da=cb+40|0;l=fa;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[da>>2]=a;ga=cb+48|0;ea=cb+44|0;k[ea>>2]=ga;k[cb+52>>2]=0;k[ga>>2]=0;ca=k[Ma>>2]|0;dh[k[(k[ca>>2]|0)+12>>2]&255](ca,Ma,cb,-1);XN(Ma);k[Na>>2]=k[La>>2];ca=Na+4|0;a=k[$a>>2]|0;k[ca>>2]=a;ba=Na+8|0;k[ba>>2]=k[Ca>>2];k[Na+12>>2]=k[xa>>2];$=Na+16|0;k[$>>2]=k[Sa>>2];k[Na+20>>2]=k[ya>>2];k[Na+24>>2]=k[za>>2];k[Na+28>>2]=k[Aa>>2];V=Na+32|0;k[V>>2]=k[Ra>>2];W=Na+36|0;f=k[Ta>>2]|0;k[W>>2]=f;X=Na+40|0;k[X>>2]=ba;ba=Na+48|0;Y=Na+44|0;k[Y>>2]=ba;k[Na+52>>2]=0;k[ba>>2]=0;if(f){a=f+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[$a>>2]|0}do if((a|0)<3){La=k[ab>>2]|0;Ma=k[Y>>2]|0;k[Ma>>2]=k[La>>2];k[Ma+4>>2]=k[La+4>>2]}else{k[ca>>2]=0;x1(Na,a,0,0,0);if((k[ca>>2]|0)<=0)break;f=k[_a>>2]|0;g=k[X>>2]|0;h=k[ab>>2]|0;j=k[Y>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[f+(a<<2)>>2];k[j+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[ca>>2]|0))}while(0);U=k[X>>2]|0;T=k[U>>2]|0;U=k[U+4>>2]|0;k[Wa>>2]=0;k[Wa+4>>2]=0;k[Wa+8>>2]=0;k[Va+8>>2]=0;k[Va+12>>2]=0;k[Va>>2]=16842752;k[Va+4>>2]=Na;C=Za+4|0;Na=C+4|0;k[Na>>2]=0;k[Na+4>>2]=0;k[Za>>2]=33882112;k[C>>2]=Wa;FV(Va,Za);C=k[Ba>>2]|0;if((C|0)>=0){E=(T|0)>0;F=(U|0)>0;G=k[cb+16>>2]|0;H=k[ea>>2]|0;I=k[db>>2]|0;O=k[Wa>>2]|0;J=O+128|0;K=O+156|0;L=O+72|0;M=O+100|0;N=O+16|0;O=O+44|0;P=C+1|0;A=0;a=0;do{S=+(A|0);B=0;do{y=B+A|0;z=+(B|0);x=0;do{Na=y+x|0;if((Na|0)<=(C|0)&(Na|0)>0){do if(E){s=+(x|0);if(!F)break;h=k[H>>2]|0;t=+p[I+(a<<3)>>3];j=k[J>>2]|0;l=k[k[K>>2]>>2]|0;m=k[L>>2]|0;n=k[k[M>>2]>>2]|0;b=k[N>>2]|0;q=k[k[O>>2]>>2]|0;g=0;do{u=G+(aa(h,g)|0)|0;c=j+(aa(l,g)|0)|0;v=m+(aa(n,g)|0)|0;w=b+(aa(q,g)|0)|0;f=0;do{Na=u+(f<<2)|0;qb=t*+R(+(+o[c+(f<<2)>>2]),+S);qb=qb*+R(+(+o[v+(f<<2)>>2]),+z);qb=+o[Na>>2]+qb*+R(+(+o[w+(f<<2)>>2]),+s);o[Na>>2]=qb;f=f+1|0}while((f|0)!=(U|0));g=g+1|0}while((g|0)!=(T|0))}while(0);a=a+1|0}x=x+1|0}while((x|0)!=(P|0));B=B+1|0}while((B|0)!=(P|0));A=A+1|0}while((A|0)!=(P|0))}do if((T|0)>0){h=k[cb+16>>2]|0;if((U|0)<=0){t=-3402823466385288598117041.0e14;s=3402823466385288598117041.0e14;break}g=k[k[ea>>2]>>2]|0;f=0;t=-3402823466385288598117041.0e14;s=3402823466385288598117041.0e14;do{j=h+(aa(g,f)|0)|0;a=0;do{qb=+o[j+(a<<2)>>2];s=qb<s?qb:s;t=qb>t?qb:t;a=a+1|0}while((a|0)!=(U|0));f=f+1|0}while((f|0)!=(T|0))}else{t=-3402823466385288598117041.0e14;s=3402823466385288598117041.0e14}while(0);p[Xa>>3]=s;a=Xa+8|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;k[Va+8>>2]=0;k[Va+12>>2]=0;k[Va>>2]=16842752;k[Va+4>>2]=cb;k[Za>>2]=-1056833530;k[Za+4>>2]=Xa;k[Za+8>>2]=1;k[Za+12>>2]=4;a=Ya+4|0;Na=a+4|0;k[Na>>2]=0;k[Na+4>>2]=0;k[Ya>>2]=33619968;k[a>>2]=cb;sU(Va,Za,Ya,49332,-1,39968,0,0);a=Va+4|0;Na=a+4|0;k[Na>>2]=0;k[Na+4>>2]=0;k[Va>>2]=33619968;k[a>>2]=cb;SW(cb,Va,-1,1.0/(t-s),0.0);zF(Wa);a=k[W>>2]|0;do if(a|0){Ma=a+12|0;Na=k[Ma>>2]|0;k[Ma>>2]=Na+-1;if((Na|0)!=1)break;f=k[W>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[V>>2]|0;if(a|0)break;a=B1()|0;f=k[W>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[W>>2]=0}while(0);k[W>>2]=0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[ca>>2]|0)>0){f=k[X>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ca>>2]|0))}a=k[Y>>2]|0;if(!((a|0)==(ba|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=Va+4|0;f=g+4|0;k[f>>2]=0;k[f+4>>2]=0;k[Va>>2]=33619968;k[g>>2]=nb;SW(cb,Va,0,255.0,0.0);g=k[_a>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[Za>>2]=1124007936;q=Za+4|0;a=Za+8|0;n=Za+40|0;l=q;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[n>>2]=a;u=Za+48|0;b=Za+44|0;k[b>>2]=u;k[Za+52>>2]=0;k[u>>2]=0;k[Va>>2]=g;k[Oa>>2]=f;G1(Za,2,Va,16);g=k[_a>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[Ya>>2]=1124007936;m=Ya+4|0;a=Ya+8|0;j=Ya+40|0;l=m;K=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(K|0));k[j>>2]=a;l=Ya+48|0;h=Ya+44|0;k[h>>2]=l;k[Ya+52>>2]=0;k[l>>2]=0;k[Va>>2]=g;k[Oa>>2]=f;G1(Ya,2,Va,16);k[Va+8>>2]=0;k[Va+12>>2]=0;k[Va>>2]=16842752;k[Va+4>>2]=ob;g=Wa+4|0;a=g+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Wa>>2]=33619968;k[g>>2]=Za;$aa(Va,Wa,44,0);k[Wa>>2]=0;k[Wa+4>>2]=0;k[Wa+8>>2]=0;k[Va+8>>2]=0;k[Va+12>>2]=0;k[Va>>2]=16842752;k[Va+4>>2]=Za;g=Xa+4|0;a=g+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Xa>>2]=33882112;k[g>>2]=Wa;FV(Va,Xa);g=k[Wa>>2]|0;a=Va+4|0;Oa=a+4|0;k[Oa>>2]=0;k[Oa+4>>2]=0;k[Va>>2]=33619968;k[a>>2]=g;mY(nb,Va);k[Xa+8>>2]=0;k[Xa+12>>2]=0;k[Xa>>2]=17104896;k[Xa+4>>2]=Wa;a=Ua+4|0;g=a+4|0;k[g>>2]=0;k[g+4>>2]=0;k[Ua>>2]=33619968;k[a>>2]=Za;k[Va>>2]=0;a=Va+4|0;k[a>>2]=0;k[Va+8>>2]=0;B2(Xa,Va);g=k[Va>>2]|0;a=k[a>>2]|0;GV((g|0)==(a|0)?0:g,(a-g|0)/56|0,Ua);zF(Va);k[Va+8>>2]=0;k[Va+12>>2]=0;k[Va>>2]=16842752;k[Va+4>>2]=Za;g=Xa+4|0;a=g+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Xa>>2]=33619968;k[g>>2]=lb;$aa(Va,Xa,56,0);zF(Wa);g=Ya+36|0;a=k[g>>2]|0;do if(a|0){Wa=a+12|0;Xa=k[Wa>>2]|0;k[Wa>>2]=Xa+-1;if((Xa|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[Ya+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;Ya=Ya+16|0;k[Ya>>2]=0;k[Ya+4>>2]=0;k[Ya+8>>2]=0;k[Ya+12>>2]=0;if((k[m>>2]|0)>0){f=k[j>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[h>>2]|0;if(!((a|0)==(l|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=Za+36|0;a=k[g>>2]|0;do if(a|0){Xa=a+12|0;Ya=k[Xa>>2]|0;k[Xa>>2]=Ya+-1;if((Ya|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[Za+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;Za=Za+16|0;k[Za>>2]=0;k[Za+4>>2]=0;k[Za+8>>2]=0;k[Za+12>>2]=0;if((k[q>>2]|0)>0){f=k[n>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[q>>2]|0))}a=k[b>>2]|0;if(!((a|0)==(u|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=cb+36|0;a=k[g>>2]|0;do if(a|0){Ya=a+12|0;Za=k[Ya>>2]|0;k[Ya>>2]=Za+-1;if((Za|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[cb+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;cb=cb+16|0;k[cb>>2]=0;k[cb+4>>2]=0;k[cb+8>>2]=0;k[cb+12>>2]=0;if((k[fa>>2]|0)>0){f=k[da>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[fa>>2]|0))}a=k[ea>>2]|0;if(!((a|0)==(ga|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[db>>2]|0;f=a;if(a|0){g=k[qa>>2]|0;if((g|0)!=(a|0))k[qa>>2]=g+(~((g+-8-f|0)>>>3)<<3);ggb(a)}g=eb+36|0;a=k[g>>2]|0;do if(a|0){cb=a+12|0;db=k[cb>>2]|0;k[cb>>2]=db+-1;if((db|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[eb+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[ta>>2]|0)>0){f=k[ra>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ta>>2]|0))}a=k[sa>>2]|0;if(!((a|0)==(ua|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[fb>>2]|0;f=a;if(a|0){g=k[Pa>>2]|0;if((g|0)!=(a|0))k[Pa>>2]=g+(~((g+-8-f|0)>>>3)<<3);ggb(a)}j=gb;if(gb|0){if((e|0)!=(j|0))do{a=e;e=e+-12|0;g=k[e>>2]|0;h=g;if(g|0){a=a+-8|0;f=k[a>>2]|0;if((f|0)!=(g|0))k[a>>2]=f+(~((f+-4-h|0)>>>2)<<2);ggb(g)}}while((e|0)!=(j|0));ggb(gb)}if(hb|0){if((d|0)!=(va|0))do{e=d;d=d+-12|0;f=k[d>>2]|0;g=f;if(f|0){e=e+-8|0;a=k[e>>2]|0;if((a|0)!=(f|0))k[e>>2]=a+(~((a+-8-g|0)>>>3)<<3);ggb(f)}}while((d|0)!=(va|0));ggb(hb)}d=k[ib>>2]|0;e=d;if(d|0){a=k[Qa>>2]|0;if((a|0)!=(d|0))k[Qa>>2]=a+(~((a+-8-e|0)>>>3)<<3);ggb(d)}d=k[Ta>>2]|0;do if(d|0){hb=d+12|0;ib=k[hb>>2]|0;k[hb>>2]=ib+-1;if((ib|0)!=1)break;e=k[Ta>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[Ra>>2]|0;if(d|0)break;d=B1()|0;e=k[Ta>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[Ta>>2]=0}while(0);k[Ta>>2]=0;k[Sa>>2]=0;k[Sa+4>>2]=0;k[Sa+8>>2]=0;k[Sa+12>>2]=0;if((k[$a>>2]|0)>0){e=k[_a>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[$a>>2]|0))}d=k[ab>>2]|0;if(!((d|0)==(bb|0)|(d|0)==0))ggb(k[d+-4>>2]|0);w0a(kb);a=lb+36|0;d=k[a>>2]|0;do if(d|0){ib=d+12|0;kb=k[ib>>2]|0;k[ib>>2]=kb+-1;if((kb|0)!=1)break;e=k[a>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[lb+32>>2]|0;if(d|0)break;d=B1()|0;e=k[a>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[a>>2]=0}while(0);k[a>>2]=0;kb=lb+16|0;e=lb+4|0;k[kb>>2]=0;k[kb+4>>2]=0;k[kb+8>>2]=0;k[kb+12>>2]=0;if((k[e>>2]|0)>0){a=k[lb+40>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[lb+44>>2]|0;if(!((d|0)==(lb+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);a=nb+36|0;d=k[a>>2]|0;do if(d|0){kb=d+12|0;lb=k[kb>>2]|0;k[kb>>2]=lb+-1;if((lb|0)!=1)break;e=k[a>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[nb+32>>2]|0;if(d|0)break;d=B1()|0;e=k[a>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[a>>2]=0}while(0);k[a>>2]=0;lb=nb+16|0;e=nb+4|0;k[lb>>2]=0;k[lb+4>>2]=0;k[lb+8>>2]=0;k[lb+12>>2]=0;if((k[e>>2]|0)>0){a=k[nb+40>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[nb+44>>2]|0;if(!((d|0)==(nb+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);a=ob+36|0;d=k[a>>2]|0;do if(d|0){lb=d+12|0;nb=k[lb>>2]|0;k[lb>>2]=nb+-1;if((nb|0)!=1)break;e=k[a>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[ob+32>>2]|0;if(d|0)break;d=B1()|0;e=k[a>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[a>>2]=0}while(0);k[a>>2]=0;a=ob+4|0;k[jb>>2]=0;k[jb+4>>2]=0;k[jb+8>>2]=0;k[jb+12>>2]=0;if((k[a>>2]|0)>0){e=k[mb>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[a>>2]|0))}d=k[ob+44>>2]|0;if((d|0)==(ob+48|0)|(d|0)==0){r=pb;return}ggb(k[d+-4>>2]|0);r=pb;return}
function GFa(a){a=a|0;var b=0,c=0,d=0;b=k[a+308>>2]|0;c=a+312|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);b=k[a+320>>2]|0;c=a+324|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);b=k[a+332>>2]|0;c=a+336|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);d=a+232|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+228>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+212|0;c=a+200|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+236>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+288|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+284>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+268|0;d=a+256|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)<=0)return;c=k[a+292>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0));return}function HFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=r;r=r+48|0;j=M+8|0;h=M;L=M+32|0;p=M+24|0;K=M+16|0;m=M+12|0;o=a+136|0;n=a+152|0;do if(k[n>>2]|0){g=k[a+140>>2]|0;f=(g|0)<3;if(f)c=aa(k[a+148>>2]|0,k[a+144>>2]|0)|0;else{e=k[a+176>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(g|0))}if(c){if(f){s=aa(k[a+148>>2]|0,k[a+144>>2]|0)|0;break}e=k[a+176>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(g|0));s=c}else l=11}else l=11;while(0);if((l|0)==11)s=(k[a+8>>2]|0)==102&1;k[m>>2]=s;if(!(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)){c=L+4|0;d=ZT(76)|0;k[d>>2]=1;G=d+4|0;k[L>>2]=G;k[c>>2]=69;i[d+73>>0]=0;H=370002;I=G+69|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));Y8(-212,L,370627,368204,2038);k[c>>2]=0;k[L>>2]=0;J=k[d>>2]|0;k[d>>2]=J+-1;if((J|0)==1)ggb(k[d+-4>>2]|0)}f=k[a+8>>2]|0;e=k[a+12>>2]|0;switch(f|0){case 100:{k[p>>2]=0;H=p+4|0;k[H>>2]=0;I=ZT(12)|0;k[I>>2]=1;J=I+4|0;k[p>>2]=J;k[H>>2]=5;i[I+9>>0]=0;i[J>>0]=i[370396]|0;i[J+1>>0]=i[370397]|0;i[J+2>>0]=i[370398]|0;i[J+3>>0]=i[370399]|0;i[J+4>>0]=i[370400]|0;break}case 101:{k[p>>2]=0;H=p+4|0;k[H>>2]=0;I=ZT(12)|0;k[I>>2]=1;J=I+4|0;k[p>>2]=J;k[H>>2]=6;i[I+10>>0]=0;i[J>>0]=i[370402]|0;i[J+1>>0]=i[370403]|0;i[J+2>>0]=i[370404]|0;i[J+3>>0]=i[370405]|0;i[J+4>>0]=i[370406]|0;i[J+5>>0]=i[370407]|0;break}case 102:{k[p>>2]=0;I=p+4|0;k[I>>2]=0;H=ZT(16)|0;k[H>>2]=1;G=H+4|0;k[p>>2]=G;k[I>>2]=9;i[H+13>>0]=0;H=370409;I=G+9|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));break}case 103:{k[p>>2]=0;H=p+4|0;k[H>>2]=0;I=ZT(12)|0;k[I>>2]=1;J=I+4|0;k[p>>2]=J;k[H>>2]=7;i[I+11>>0]=0;i[J>>0]=i[370419]|0;i[J+1>>0]=i[370420]|0;i[J+2>>0]=i[370421]|0;i[J+3>>0]=i[370422]|0;i[J+4>>0]=i[370423]|0;i[J+5>>0]=i[370424]|0;i[J+6>>0]=i[370425]|0;break}case 104:{k[p>>2]=0;H=p+4|0;k[H>>2]=0;I=ZT(12)|0;k[I>>2]=1;J=I+4|0;k[p>>2]=J;k[H>>2]=6;i[I+10>>0]=0;i[J>>0]=i[370427]|0;i[J+1>>0]=i[370428]|0;i[J+2>>0]=i[370429]|0;i[J+3>>0]=i[370430]|0;i[J+4>>0]=i[370431]|0;i[J+5>>0]=i[370432]|0;break}default:{k[h>>2]=f;$8(p,370654,h)}}switch(e|0){case 0:{k[K>>2]=0;H=K+4|0;k[H>>2]=0;I=ZT(12)|0;k[I>>2]=1;J=I+4|0;k[K>>2]=J;k[H>>2]=6;i[I+10>>0]=0;i[J>>0]=i[370509]|0;i[J+1>>0]=i[370510]|0;i[J+2>>0]=i[370511]|0;i[J+3>>0]=i[370512]|0;i[J+4>>0]=i[370513]|0;i[J+5>>0]=i[370514]|0;break}case 1:{k[K>>2]=0;H=K+4|0;k[H>>2]=0;I=ZT(12)|0;k[I>>2]=1;J=I+4|0;k[K>>2]=J;k[H>>2]=4;i[I+8>>0]=0;i[J>>0]=80;i[J+1>>0]=79;i[J+2>>0]=76;i[J+3>>0]=89;break}case 2:{k[K>>2]=0;H=K+4|0;k[H>>2]=0;I=ZT(8)|0;k[I>>2]=1;J=I+4|0;k[K>>2]=J;k[H>>2]=3;i[I+7>>0]=0;i[J>>0]=i[370521]|0;i[J+1>>0]=i[370522]|0;i[J+2>>0]=i[370523]|0;break}case 3:{k[K>>2]=0;H=K+4|0;k[H>>2]=0;I=ZT(12)|0;k[I>>2]=1;J=I+4|0;k[K>>2]=J;k[H>>2]=7;i[I+11>>0]=0;i[J>>0]=i[370525]|0;i[J+1>>0]=i[370526]|0;i[J+2>>0]=i[370527]|0;i[J+3>>0]=i[370528]|0;i[J+4>>0]=i[370529]|0;i[J+5>>0]=i[370530]|0;i[J+6>>0]=i[370531]|0;break}case 4:{k[K>>2]=0;H=K+4|0;k[H>>2]=0;I=ZT(12)|0;k[I>>2]=1;J=I+4|0;k[K>>2]=J;k[H>>2]=4;i[I+8>>0]=0;i[J>>0]=67;i[J+1>>0]=72;i[J+2>>0]=73;i[J+3>>0]=50;break}case 5:{k[K>>2]=0;H=K+4|0;k[H>>2]=0;I=ZT(12)|0;k[I>>2]=1;J=I+4|0;k[K>>2]=J;k[H>>2]=5;i[I+9>>0]=0;i[J>>0]=i[370538]|0;i[J+1>>0]=i[370539]|0;i[J+2>>0]=i[370540]|0;i[J+3>>0]=i[370541]|0;i[J+4>>0]=i[370542]|0;break}default:{k[j>>2]=e;$8(K,370664,j)}}k[L>>2]=0;J=L+4|0;k[J>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[L>>2]=c;k[J>>2]=7;i[d+11>>0]=0;i[c>>0]=i[370388]|0;i[c+1>>0]=i[370389]|0;i[c+2>>0]=i[370390]|0;i[c+3>>0]=i[370391]|0;i[c+4>>0]=i[370392]|0;i[c+5>>0]=i[370393]|0;i[c+6>>0]=i[370394]|0;c=z6(b,L)|0;d=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);z6(c,p)|0;k[L>>2]=0;J=L+4|0;k[J>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[L>>2]=c;k[J>>2]=6;i[d+10>>0]=0;i[c>>0]=i[370474]|0;i[c+1>>0]=i[370475]|0;i[c+2>>0]=i[370476]|0;i[c+3>>0]=i[370477]|0;i[c+4>>0]=i[370478]|0;i[c+5>>0]=i[370479]|0;c=z6(b,L)|0;d=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);k[L>>2]=0;J=L+4|0;k[J>>2]=0;I=ZT(8)|0;k[I>>2]=1;d=I+4|0;k[L>>2]=d;k[J>>2]=1;i[I+5>>0]=0;i[d>>0]=123;c=z6(c,L)|0;d=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);k[L>>2]=0;J=L+4|0;k[J>>2]=0;I=ZT(12)|0;k[I>>2]=1;d=I+4|0;k[L>>2]=d;k[J>>2]=4;i[I+8>>0]=0;i[d>>0]=116;i[d+1>>0]=121;i[d+2>>0]=112;i[d+3>>0]=101;c=z6(c,L)|0;d=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);z6(c,K)|0;switch(e|0){case 1:{k[L>>2]=0;J=L+4|0;k[J>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[L>>2]=c;k[J>>2]=6;i[d+10>>0]=0;i[c>>0]=i[370587]|0;i[c+1>>0]=i[370588]|0;i[c+2>>0]=i[370589]|0;i[c+3>>0]=i[370590]|0;i[c+4>>0]=i[370591]|0;i[c+5>>0]=i[370592]|0;c=z6(b,L)|0;d=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);JGa(c,a+32|0)|0;l=48;break}case 0:break;default:l=48}if((l|0)==48){k[L>>2]=0;J=L+4|0;k[J>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[L>>2]=c;k[J>>2]=5;i[d+9>>0]=0;i[c>>0]=i[399978]|0;i[c+1>>0]=i[399979]|0;i[c+2>>0]=i[399980]|0;i[c+3>>0]=i[399981]|0;i[c+4>>0]=i[399982]|0;c=z6(b,L)|0;d=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);JGa(c,a+16|0)|0;if((e|2|0)==3){k[L>>2]=0;J=L+4|0;k[J>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[L>>2]=c;k[J>>2]=5;i[d+9>>0]=0;i[c>>0]=i[370594]|0;i[c+1>>0]=i[370595]|0;i[c+2>>0]=i[370596]|0;i[c+3>>0]=i[370597]|0;i[c+4>>0]=i[370598]|0;c=z6(b,L)|0;d=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);JGa(c,a+24|0)|0}}k[L>>2]=0;J=L+4|0;k[J>>2]=0;I=ZT(8)|0;k[I>>2]=1;c=I+4|0;k[L>>2]=c;k[J>>2]=1;i[I+5>>0]=0;i[c>>0]=125;z6(b,L)|0;c=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(c|0?(I=c+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[c+-8>>2]|0);e=(f|0)==103;switch(f|0){case 100:case 103:case 104:{k[L>>2]=0;J=L+4|0;k[J>>2]=0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[L>>2]=c;k[J>>2]=1;i[d+5>>0]=0;i[c>>0]=67;c=z6(b,L)|0;d=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);JGa(c,a+40|0)|0;switch(f|0){case 101:case 102:case 104:{l=64;break}case 103:{l=68;break}default:{}}break}case 101:case 102:{l=64;break}default:{}}if((l|0)==64){k[L>>2]=0;J=L+4|0;k[J>>2]=0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[L>>2]=c;k[J>>2]=2;i[d+6>>0]=0;i[c>>0]=110;i[c+1>>0]=117;c=z6(b,L)|0;d=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);JGa(c,a+48|0)|0;if(e)l=68}if((l|0)==68){k[L>>2]=0;J=L+4|0;k[J>>2]=0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[L>>2]=c;k[J>>2]=1;i[d+5>>0]=0;i[c>>0]=112;c=z6(b,L)|0;d=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);JGa(c,a+56|0)|0}k[L>>2]=0;e=L+4|0;k[e>>2]=0;H=ZT(20)|0;k[H>>2]=1;G=H+4|0;k[L>>2]=G;k[e>>2]=13;i[H+17>>0]=0;H=370605;I=G+13|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));c=z6(b,L)|0;d=k[L>>2]|0;k[e>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);k[L>>2]=0;J=L+4|0;k[J>>2]=0;H=ZT(8)|0;k[H>>2]=1;I=H+4|0;k[L>>2]=I;k[J>>2]=2;i[H+6>>0]=0;i[I>>0]=123;i[I+1>>0]=58;z6(c,L)|0;c=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(c|0?(I=c+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[c+-8>>2]|0);e=a+120|0;c=k[e>>2]|0;if(c&2){k[L>>2]=0;J=L+4|0;k[J>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[L>>2]=c;k[J>>2]=7;i[d+11>>0]=0;i[c>>0]=i[370619]|0;i[c+1>>0]=i[370620]|0;i[c+2>>0]=i[370621]|0;i[c+3>>0]=i[370622]|0;i[c+4>>0]=i[370623]|0;i[c+5>>0]=i[370624]|0;i[c+6>>0]=i[370625]|0;c=z6(b,L)|0;d=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);JGa(c,a+128|0)|0;c=k[e>>2]|0}if(c&1|0){k[L>>2]=0;e=L+4|0;k[e>>2]=0;H=ZT(16)|0;k[H>>2]=1;G=H+4|0;k[L>>2]=G;k[e>>2]=10;i[H+14>>0]=0;H=375191;I=G+10|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));c=z6(b,L)|0;d=k[L>>2]|0;k[e>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);HGa(c,a+124|0)|0}k[L>>2]=0;J=L+4|0;k[J>>2]=0;I=ZT(8)|0;k[I>>2]=1;c=I+4|0;k[L>>2]=c;k[J>>2]=1;i[I+5>>0]=0;i[c>>0]=125;z6(b,L)|0;c=k[L>>2]|0;k[J>>2]=0;k[L>>2]=0;if(c|0?(I=c+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[c+-8>>2]|0);c=k[K>>2]|0;k[K+4>>2]=0;k[K>>2]=0;if(c|0?(I=c+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[c+-8>>2]|0);c=k[p>>2]|0;k[p+4>>2]=0;k[p>>2]=0;if(c|0?(I=c+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[c+-8>>2]|0);k[L>>2]=0;e=L+4|0;k[e>>2]=0;H=ZT(16)|0;k[H>>2]=1;G=H+4|0;k[L>>2]=G;k[e>>2]=9;i[H+13>>0]=0;H=371497;I=G+9|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));c=z6(b,L)|0;d=k[L>>2]|0;k[e>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);HGa(c,a+192|0)|0;do if((s|0)>0){k[L>>2]=0;e=L+4|0;k[e>>2]=0;H=ZT(16)|0;k[H>>2]=1;G=H+4|0;k[L>>2]=G;k[e>>2]=11;i[H+15>>0]=0;H=369990;I=G+11|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));c=z6(b,L)|0;d=k[L>>2]|0;k[e>>2]=0;k[L>>2]=0;if(d|0?(I=d+-4|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0)ggb(k[d+-8>>2]|0);HGa(c,m)|0;do if(k[n>>2]|0){e=k[a+140>>2]|0;if((e|0)<3)c=aa(k[a+148>>2]|0,k[a+144>>2]|0)|0;else{f=k[a+176>>2]|0;d=0;c=1;do{c=aa(k[f+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(e|0))}if(!c)break;k[L>>2]=0;e=L+4|0;k[e>>2]=0;H=ZT(20)|0;k[H>>2]=1;G=H+4|0;k[L>>2]=G;k[e>>2]=12;i[H+16>>0]=0;H=371457;I=G+12|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));c=z6(b,L)|0;d=k[L>>2]|0;k[e>>2]=0;k[L>>2]=0;do if(d|0){I=d+-4|0;J=k[I>>2]|0;k[I>>2]=J+-1;if((J|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);IGa(c,o)}while(0);g=a+64|0;if(k[a+80>>2]|0){e=k[a+68>>2]|0;if((e|0)<3)c=aa(k[a+76>>2]|0,k[a+72>>2]|0)|0;else{f=k[a+104>>2]|0;d=0;c=1;do{c=aa(k[f+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(e|0))}if(!c)break;k[L>>2]=0;e=L+4|0;k[e>>2]=0;H=ZT(20)|0;k[H>>2]=1;G=H+4|0;k[L>>2]=G;k[e>>2]=13;i[H+17>>0]=0;H=370072;I=G+13|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));c=z6(b,L)|0;d=k[L>>2]|0;k[e>>2]=0;k[L>>2]=0;do if(d|0){I=d+-4|0;J=k[I>>2]|0;k[I>>2]=J+-1;if((J|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);IGa(c,g)}}while(0);J=k[a+204>>2]|0;k[p>>2]=J;k[L>>2]=0;I=L+4|0;k[I>>2]=0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[L>>2]=c;k[I>>2]=8;i[d+12>>0]=0;d=c;i[d>>0]=115;i[d+1>>0]=118;i[d+2>>0]=95;i[d+3>>0]=116;c=c+4|0;i[c>>0]=111;i[c+1>>0]=116;i[c+2>>0]=97;i[c+3>>0]=108;c=z6(b,L)|0;d=k[L>>2]|0;k[I>>2]=0;k[L>>2]=0;if(d|0?(H=d+-4|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0)ggb(k[d+-8>>2]|0);HGa(c,p)|0;k[L>>2]=0;e=L+4|0;k[e>>2]=0;H=ZT(20)|0;k[H>>2]=1;G=H+4|0;k[L>>2]=G;k[e>>2]=15;i[H+19>>0]=0;H=370130;I=G+15|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));c=z6(b,L)|0;d=k[L>>2]|0;k[e>>2]=0;k[L>>2]=0;if(d|0?(H=d+-4|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0)ggb(k[d+-8>>2]|0);k[L>>2]=0;I=L+4|0;k[I>>2]=0;G=ZT(8)|0;k[G>>2]=1;H=G+4|0;k[L>>2]=H;k[I>>2]=1;i[G+5>>0]=0;i[H>>0]=91;z6(c,L)|0;c=k[L>>2]|0;k[I>>2]=0;k[L>>2]=0;do if(c|0){H=c+-4|0;I=k[H>>2]|0;k[H>>2]=I+-1;if((I|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);if((J|0)>0){h=L+4|0;j=L+4|0;l=a+212|0;m=a+240|0;n=a+208|0;o=a+200|0;p=L+4|0;g=0;do{k[L>>2]=0;k[h>>2]=0;I=ZT(8)|0;k[I>>2]=1;c=I+4|0;k[L>>2]=c;k[h>>2]=2;i[I+6>>0]=0;i[c>>0]=91;i[c+1>>0]=58;z6(b,L)|0;c=k[L>>2]|0;k[h>>2]=0;k[L>>2]=0;do if(c|0){H=c+-4|0;I=k[H>>2]|0;k[H>>2]=I+-1;if((I|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);e=ZT(8)|0;k[e>>2]=1;c=e+4|0;k[L>>2]=c;k[j>>2]=1;i[e+5>>0]=0;i[c>>0]=102;c=k[m>>2]|0;f=(k[l>>2]|0)+(aa(k[c>>2]|0,g)|0)|0;d=k[o>>2]|0;if((d|0)>0)c=k[c+(d+-1<<2)>>2]|0;else c=0;A6(b,L,f,aa(c,k[n>>2]|0)|0);k[j>>2]=0;k[L>>2]=0;I=k[e>>2]|0;k[e>>2]=I+-1;if((I|0)==1)ggb(k[e+-4>>2]|0);k[L>>2]=0;k[p>>2]=0;I=ZT(8)|0;k[I>>2]=1;c=I+4|0;k[L>>2]=c;k[p>>2]=1;i[I+5>>0]=0;i[c>>0]=93;z6(b,L)|0;c=k[L>>2]|0;k[p>>2]=0;k[L>>2]=0;do if(c|0){H=c+-4|0;I=k[H>>2]|0;k[H>>2]=I+-1;if((I|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);g=g+1|0}while((g|0)<(J|0))}k[L>>2]=0;I=L+4|0;k[I>>2]=0;H=ZT(8)|0;k[H>>2]=1;c=H+4|0;k[L>>2]=c;k[I>>2]=1;i[H+5>>0]=0;i[c>>0]=93;z6(b,L)|0;c=k[L>>2]|0;k[I>>2]=0;k[L>>2]=0;do if(c|0){H=c+-4|0;I=k[H>>2]|0;k[H>>2]=I+-1;if((I|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);p=a+268|0;do if(k[p>>2]|0){q=a+256|0;e=k[q>>2]|0;if((e|0)<3)c=aa(k[a+264>>2]|0,k[a+260>>2]|0)|0;else{f=k[a+292>>2]|0;d=0;c=1;do{c=aa(k[f+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(e|0))}if(!c)break;o=k[a+260>>2]|0;k[K>>2]=o;k[L>>2]=0;e=L+4|0;k[e>>2]=0;H=ZT(28)|0;k[H>>2]=1;G=H+4|0;k[L>>2]=G;k[e>>2]=21;i[H+25>>0]=0;H=370178;I=G+21|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));c=z6(b,L)|0;d=k[L>>2]|0;k[e>>2]=0;k[L>>2]=0;do if(d|0){H=d+-4|0;I=k[H>>2]|0;k[H>>2]=I+-1;if((I|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);HGa(c,K)|0;k[L>>2]=0;e=L+4|0;k[e>>2]=0;H=ZT(36)|0;k[H>>2]=1;G=H+4|0;k[L>>2]=G;k[e>>2]=28;i[H+32>>0]=0;H=370200;I=G+28|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));c=z6(b,L)|0;d=k[L>>2]|0;k[e>>2]=0;k[L>>2]=0;do if(d|0){H=d+-4|0;I=k[H>>2]|0;k[H>>2]=I+-1;if((I|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[L>>2]=0;I=L+4|0;k[I>>2]=0;G=ZT(8)|0;k[G>>2]=1;H=G+4|0;k[L>>2]=H;k[I>>2]=1;i[G+5>>0]=0;i[H>>0]=91;z6(c,L)|0;c=k[L>>2]|0;k[I>>2]=0;k[L>>2]=0;do if(c|0){H=c+-4|0;I=k[H>>2]|0;k[H>>2]=I+-1;if((I|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);if((o|0)>0){h=L+4|0;j=L+4|0;l=a+296|0;m=a+264|0;n=L+4|0;g=0;do{k[L>>2]=0;k[h>>2]=0;I=ZT(8)|0;k[I>>2]=1;c=I+4|0;k[L>>2]=c;k[h>>2]=2;i[I+6>>0]=0;i[c>>0]=91;i[c+1>>0]=58;z6(b,L)|0;c=k[L>>2]|0;k[h>>2]=0;k[L>>2]=0;do if(c|0){H=c+-4|0;I=k[H>>2]|0;k[H>>2]=I+-1;if((I|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);e=ZT(8)|0;k[e>>2]=1;c=e+4|0;k[L>>2]=c;k[j>>2]=1;i[e+5>>0]=0;i[c>>0]=102;c=k[l>>2]|0;f=(k[p>>2]|0)+(aa(k[c>>2]|0,g)|0)|0;d=k[q>>2]|0;if((d|0)>0)c=k[c+(d+-1<<2)>>2]|0;else c=0;A6(b,L,f,aa(c,k[m>>2]|0)|0);k[j>>2]=0;k[L>>2]=0;I=k[e>>2]|0;k[e>>2]=I+-1;if((I|0)==1)ggb(k[e+-4>>2]|0);k[L>>2]=0;k[n>>2]=0;I=ZT(8)|0;k[I>>2]=1;c=I+4|0;k[L>>2]=c;k[n>>2]=1;i[I+5>>0]=0;i[c>>0]=93;z6(b,L)|0;c=k[L>>2]|0;k[n>>2]=0;k[L>>2]=0;do if(c|0){H=c+-4|0;I=k[H>>2]|0;k[H>>2]=I+-1;if((I|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);g=g+1|0}while((g|0)<(o|0))}k[L>>2]=0;I=L+4|0;k[I>>2]=0;H=ZT(8)|0;k[H>>2]=1;c=H+4|0;k[L>>2]=c;k[I>>2]=1;i[H+5>>0]=0;i[c>>0]=93;z6(b,L)|0;c=k[L>>2]|0;k[I>>2]=0;k[L>>2]=0;do if(c|0){H=c+-4|0;I=k[H>>2]|0;k[H>>2]=I+-1;if((I|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0)}while(0);D=a+308|0;E=a+312|0;f=(k[E>>2]|0)-(k[D>>2]|0)|0;F=f>>4;k[L>>2]=0;e=L+4|0;k[e>>2]=0;H=ZT(24)|0;k[H>>2]=1;G=H+4|0;k[L>>2]=G;k[e>>2]=18;i[H+22>>0]=0;H=370287;I=G+18|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));c=z6(b,L)|0;d=k[L>>2]|0;k[e>>2]=0;k[L>>2]=0;do if(d|0){H=d+-4|0;I=k[H>>2]|0;k[H>>2]=I+-1;if((I|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[L>>2]=0;I=L+4|0;k[I>>2]=0;G=ZT(8)|0;k[G>>2]=1;H=G+4|0;k[L>>2]=H;k[I>>2]=1;i[G+5>>0]=0;i[H>>0]=91;z6(c,L)|0;c=k[L>>2]|0;k[I>>2]=0;k[L>>2]=0;do if(c|0){H=c+-4|0;I=k[H>>2]|0;k[H>>2]=I+-1;if((I|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);if((f|0)>0){v=L+4|0;w=L+4|0;x=L+4|0;y=L+4|0;z=L+4|0;A=L+4|0;B=a+320|0;C=L+4|0;l=(s|0)>2;m=L+4|0;n=L+4|0;o=L+4|0;p=a+332|0;q=L+4|0;s=L+4|0;t=L+4|0;u=a+332|0;j=a+336|0;h=0;do{e=k[D>>2]|0;if((((k[E>>2]|0)-e>>4)+-1|0)>(h|0))c=k[e+(h+1<<4)+8>>2]|0;else c=(k[j>>2]|0)-(k[u>>2]|0)>>2;g=e+(h<<4)+8|0;f=c-(k[g>>2]|0)|0;k[K>>2]=f;k[L>>2]=0;k[v>>2]=0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[L>>2]=c;k[v>>2]=1;i[d+5>>0]=0;i[c>>0]=123;c=z6(b,L)|0;d=k[L>>2]|0;k[v>>2]=0;k[L>>2]=0;do if(d|0){I=d+-4|0;a=k[I>>2]|0;k[I>>2]=a+-1;if((a|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[L>>2]=0;k[w>>2]=0;a=ZT(16)|0;k[a>>2]=1;d=a+4|0;k[L>>2]=d;k[w>>2]=8;i[a+12>>0]=0;a=d;i[a>>0]=115;i[a+1>>0]=118;i[a+2>>0]=95;i[a+3>>0]=99;d=d+4|0;i[d>>0]=111;i[d+1>>0]=117;i[d+2>>0]=110;i[d+3>>0]=116;c=z6(c,L)|0;d=k[L>>2]|0;k[w>>2]=0;k[L>>2]=0;do if(d|0){I=d+-4|0;a=k[I>>2]|0;k[I>>2]=a+-1;if((a|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);c=HGa(c,K)|0;k[L>>2]=0;k[x>>2]=0;a=ZT(8)|0;k[a>>2]=1;d=a+4|0;k[L>>2]=d;k[x>>2]=3;i[a+7>>0]=0;i[d>>0]=i[370347]|0;i[d+1>>0]=i[370348]|0;i[d+2>>0]=i[370349]|0;c=z6(c,L)|0;d=k[L>>2]|0;k[x>>2]=0;k[L>>2]=0;do if(d|0){I=d+-4|0;a=k[I>>2]|0;k[I>>2]=a+-1;if((a|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);c=JGa(c,e+(h<<4)|0)|0;k[L>>2]=0;k[y>>2]=0;a=ZT(12)|0;k[a>>2]=1;d=a+4|0;k[L>>2]=d;k[y>>2]=5;i[a+9>>0]=0;i[d>>0]=i[370351]|0;i[d+1>>0]=i[370352]|0;i[d+2>>0]=i[370353]|0;i[d+3>>0]=i[370354]|0;i[d+4>>0]=i[370355]|0;c=z6(c,L)|0;d=k[L>>2]|0;k[y>>2]=0;k[L>>2]=0;do if(d|0){I=d+-4|0;a=k[I>>2]|0;k[I>>2]=a+-1;if((a|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[L>>2]=0;k[z>>2]=0;I=ZT(8)|0;k[I>>2]=1;a=I+4|0;k[L>>2]=a;k[z>>2]=2;i[I+6>>0]=0;i[a>>0]=91;i[a+1>>0]=58;z6(c,L)|0;c=k[L>>2]|0;k[z>>2]=0;k[L>>2]=0;do if(c|0){I=c+-4|0;a=k[I>>2]|0;k[I>>2]=a+-1;if((a|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);c=ZT(8)|0;k[c>>2]=1;a=c+4|0;k[L>>2]=a;k[A>>2]=1;i[c+5>>0]=0;i[a>>0]=100;A6(b,L,(k[B>>2]|0)+(k[g>>2]<<3)|0,f<<3);k[A>>2]=0;k[L>>2]=0;a=k[c>>2]|0;k[c>>2]=a+-1;if((a|0)==1)ggb(k[c+-4>>2]|0);k[L>>2]=0;k[C>>2]=0;a=ZT(8)|0;k[a>>2]=1;c=a+4|0;k[L>>2]=c;k[C>>2]=1;i[a+5>>0]=0;i[c>>0]=93;z6(b,L)|0;c=k[L>>2]|0;k[C>>2]=0;k[L>>2]=0;do if(c|0){I=c+-4|0;a=k[I>>2]|0;k[I>>2]=a+-1;if((a|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);do if(!l){if((f|0)==(J|0))break;c=ZT(28)|0;k[c>>2]=1;G=c+4|0;k[L>>2]=G;k[t>>2]=20;i[c+24>>0]=0;H=370633;I=G+20|0;do{i[G>>0]=i[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));Y8(-215,L,370627,368204,2102);k[t>>2]=0;k[L>>2]=0;a=k[c>>2]|0;k[c>>2]=a+-1;if((a|0)==1)ggb(k[c+-4>>2]|0)}else{k[L>>2]=0;k[m>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[L>>2]=c;k[m>>2]=5;i[d+9>>0]=0;i[c>>0]=i[370357]|0;i[c+1>>0]=i[370358]|0;i[c+2>>0]=i[370359]|0;i[c+3>>0]=i[370360]|0;i[c+4>>0]=i[370361]|0;c=z6(b,L)|0;d=k[L>>2]|0;k[m>>2]=0;k[L>>2]=0;do if(d|0){I=d+-4|0;a=k[I>>2]|0;k[I>>2]=a+-1;if((a|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[L>>2]=0;k[n>>2]=0;I=ZT(8)|0;k[I>>2]=1;a=I+4|0;k[L>>2]=a;k[n>>2]=2;i[I+6>>0]=0;i[a>>0]=91;i[a+1>>0]=58;z6(c,L)|0;c=k[L>>2]|0;k[n>>2]=0;k[L>>2]=0;do if(c|0){I=c+-4|0;a=k[I>>2]|0;k[I>>2]=a+-1;if((a|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);c=ZT(8)|0;k[c>>2]=1;a=c+4|0;k[L>>2]=a;k[o>>2]=1;i[c+5>>0]=0;i[a>>0]=105;A6(b,L,(k[p>>2]|0)+(k[g>>2]<<2)|0,f<<2);k[o>>2]=0;k[L>>2]=0;a=k[c>>2]|0;k[c>>2]=a+-1;if((a|0)==1)ggb(k[c+-4>>2]|0);k[L>>2]=0;k[q>>2]=0;a=ZT(8)|0;k[a>>2]=1;c=a+4|0;k[L>>2]=c;k[q>>2]=1;i[a+5>>0]=0;i[c>>0]=93;z6(b,L)|0;c=k[L>>2]|0;k[q>>2]=0;k[L>>2]=0;do if(c|0){I=c+-4|0;a=k[I>>2]|0;k[I>>2]=a+-1;if((a|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0)}while(0);k[L>>2]=0;k[s>>2]=0;a=ZT(8)|0;k[a>>2]=1;c=a+4|0;k[L>>2]=c;k[s>>2]=1;i[a+5>>0]=0;i[c>>0]=125;z6(b,L)|0;c=k[L>>2]|0;k[s>>2]=0;k[L>>2]=0;do if(c|0){I=c+-4|0;a=k[I>>2]|0;k[I>>2]=a+-1;if((a|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);h=h+1|0}while((h|0)<(F|0))}K=L+4|0;a=ZT(8)|0;k[a>>2]=1;c=a+4|0;k[L>>2]=c;k[K>>2]=1;i[a+5>>0]=0;i[c>>0]=93;z6(b,L)|0;c=k[L>>2]|0;k[K>>2]=0;k[L>>2]=0;if(!c){r=M;return}K=c+-4|0;L=k[K>>2]|0;k[K>>2]=L+-1;if((L|0)!=1){r=M;return}ggb(k[c+-8>>2]|0);r=M;return}function IFa(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0;da=r;r=r+288|0;Y=da+56|0;K=da+236|0;Z=da+192|0;_=da;$=da+184|0;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);k[Y+56>>2]=1124007936;H=Y+60|0;d=Y+64|0;F=Y+96|0;q=H;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[F>>2]=d;I=Y+104|0;G=Y+100|0;k[G>>2]=I;t=I;k[t>>2]=0;k[t+4>>2]=0;k[Y>>2]=100;t=Y+4|0;k[t>>2]=2;v=Y+24|0;p[v>>3]=0.0;w=Y+8|0;p[w>>3]=1.0;x=Y+16|0;p[x>>3]=0.0;y=Y+32|0;p[y>>3]=1.0;z=Y+40|0;B=Y+112|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;k[B>>2]=3;C=Y+116|0;k[C>>2]=1e3;D=Y+120|0;p[D>>3]=1.1920928955078125e-07;ca=b+4|0;X=(k6(k[b>>2]|0,k[ca>>2]|0,370379)|0)==0;d=k[b>>2]|0;e=k[ca>>2]|0;if(X)d=k6(d,e,370388)|0;else d=k6(d,e,370379)|0;k[K>>2]=0;E=K+4|0;k[E>>2]=0;J6(d,K,K);m=k[K>>2]|0;do if((m|0)!=370396){d=(m|0)==0?1016759:m;j=i[d>>0]|0;if(j<<24>>24==67){e=370396;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){m=100;break}}if((m|0)!=370402){l=j<<24>>24==78;if(l){e=370402;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){m=101;break}}if((m|0)!=370409){if(j<<24>>24==79){e=370409;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){m=102;break}}if((m|0)!=370419){if(j<<24>>24==69){e=370419;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){m=103;break}}if((m|0)==370427)m=104;else{if(l){g=370427;do{d=d+1|0;g=g+1|0;e=i[d>>0]|0;f=i[g>>0]|0}while(!(e<<24>>24==0?1:e<<24>>24!=f<<24>>24));if(e<<24>>24==f<<24>>24){m=104;break}}k[Z>>2]=0;d=Z+4|0;k[d>>2]=0;e=ZT(32)|0;k[e>>2]=1;q=e+4|0;k[Z>>2]=q;k[d>>2]=27;i[e+31>>0]=0;j=370434;s=q+27|0;do{i[q>>0]=i[j>>0]|0;q=q+1|0;j=j+1|0}while((q|0)<(s|0));Y8(-212,Z,370462,368204,2122);k[d>>2]=0;k[Z>>2]=0;X=k[e>>2]|0;k[e>>2]=X+-1;if((X|0)==1)ggb(k[e+-4>>2]|0);m=-1}}else m=103}else m=102}else m=101}else m=100;while(0);n=k[b>>2]|0;o=k6(n,k[ca>>2]|0,370474)|0;if(!o){k[Z>>2]=0;d=Z+4|0;k[d>>2]=0;e=ZT(32)|0;k[e>>2]=1;q=e+4|0;k[Z>>2]=q;k[d>>2]=27;i[e+31>>0]=0;j=370481;s=q+27|0;do{i[q>>0]=i[j>>0]|0;q=q+1|0;j=j+1|0}while((q|0)<(s|0));Y8(-212,Z,370462,368204,2126);k[d>>2]=0;k[Z>>2]=0;X=k[e>>2]|0;k[e>>2]=X+-1;if((X|0)==1)ggb(k[e+-4>>2]|0)}j=k6(n,o,389384)|0;k[Z>>2]=0;A=Z+4|0;k[A>>2]=0;J6(j,Z,Z);j=k[Z>>2]|0;do if((j|0)!=370509){d=(j|0)==0?1016759:j;l=i[d>>0]|0;if(l<<24>>24==76){e=370509;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){d=0;break}}if((j|0)!=370516){if(l<<24>>24==80){e=370516;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){d=1;break}}if((j|0)!=370521){if(l<<24>>24==82){e=370521;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){d=2;break}}if((j|0)!=370525){if(l<<24>>24==83){e=370525;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){d=3;break}}if((j|0)!=370533){if(l<<24>>24==67){e=370533;f=d;do{f=f+1|0;e=e+1|0;g=i[f>>0]|0;h=i[e>>0]|0}while(!(g<<24>>24==0?1:g<<24>>24!=h<<24>>24));if(g<<24>>24==h<<24>>24){d=4;break}}if((j|0)==370538)d=5;else{if(l<<24>>24==73){g=370538;do{d=d+1|0;g=g+1|0;e=i[d>>0]|0;f=i[g>>0]|0}while(!(e<<24>>24==0?1:e<<24>>24!=f<<24>>24));if(e<<24>>24==f<<24>>24){d=5;break}}k[_>>2]=0;d=_+4|0;k[d>>2]=0;e=ZT(48)|0;k[e>>2]=1;q=e+4|0;k[_>>2]=q;k[d>>2]=42;i[e+46>>0]=0;j=370544;s=q+42|0;do{i[q>>0]=i[j>>0]|0;q=q+1|0;j=j+1|0}while((q|0)<(s|0));Y8(-212,_,370462,368204,2138);k[d>>2]=0;k[_>>2]=0;X=k[e>>2]|0;k[e>>2]=X+-1;if((X|0)==1)ggb(k[e+-4>>2]|0);d=-1}}else d=4}else d=3}else d=2}else d=1}else d=0;while(0);k[Y>>2]=m;k[t>>2]=d;d=k6(n,o,370587)|0;a:do if(!d)c=0.0;else switch(k[d>>2]&7){case 1:{c=+(k[d+8>>2]|0);break a}case 2:{c=+p[d+8>>3];break a}default:{c=1.e+300;break a}}while(0);p[v>>3]=c;d=k6(n,o,399978)|0;b:do if(!d)c=0.0;else switch(k[d>>2]&7){case 1:{c=+(k[d+8>>2]|0);break b}case 2:{c=+p[d+8>>3];break b}default:{c=1.e+300;break b}}while(0);p[w>>3]=c;d=k6(n,o,370594)|0;c:do if(!d)c=0.0;else switch(k[d>>2]&7){case 1:{c=+(k[d+8>>2]|0);break c}case 2:{c=+p[d+8>>3];break c}default:{c=1.e+300;break c}}while(0);p[x>>3]=c;d=k6(k[b>>2]|0,k[ca>>2]|0,424444)|0;d:do if(!d)c=0.0;else switch(k[d>>2]&7){case 1:{c=+(k[d+8>>2]|0);break d}case 2:{c=+p[d+8>>3];break d}default:{c=1.e+300;break d}}while(0);p[y>>3]=c;d=k6(k[b>>2]|0,k[ca>>2]|0,370600)|0;e:do if(!d)c=0.0;else switch(k[d>>2]&7){case 1:{c=+(k[d+8>>2]|0);break e}case 2:{c=+p[d+8>>3];break e}default:{c=1.e+300;break e}}while(0);p[z>>3]=c;d=k6(k[b>>2]|0,k[ca>>2]|0,370603)|0;f:do if(!d)c=0.0;else switch(k[d>>2]&7){case 1:{c=+(k[d+8>>2]|0);break f}case 2:{c=+p[d+8>>3];break f}default:{c=1.e+300;break f}}while(0);p[Y+48>>3]=c;k[_>>2]=1124007936;l=_+4|0;d=_+8|0;h=_+40|0;q=l;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[h>>2]=d;j=_+48|0;g=_+44|0;k[g>>2]=j;k[_+52>>2]=0;k[j>>2]=0;m=Y+56|0;KG(m,_)|0;f=_+36|0;d=k[f>>2]|0;if(d|0?(W=d+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[_+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;X=_+16|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[l>>2]|0)>0){e=k[h>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[l>>2]|0))}d=k[g>>2]|0;if(!((d|0)==(j|0)|(d|0)==0))ggb(k[d+-4>>2]|0);e=k[b>>2]|0;f=k6(e,k[ca>>2]|0,370605)|0;if(!f){k[B>>2]=3;k[C>>2]=1e3;p[D>>3]=1.1920928955078125e-07}else{d=k6(e,f,370619)|0;g:do if(!d)c=0.0;else switch(k[d>>2]&7){case 1:{c=+(k[d+8>>2]|0);break g}case 2:{c=+p[d+8>>3];break g}default:{c=1.e+300;break g}}while(0);p[D>>3]=c;d=k6(e,f,375191)|0;h:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break h}case 2:break;default:{d=2147483647;break h}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;X=d&2146435072;do if(!(X>>>0>1126170624|(X|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(!(c==0.0))break;c=d?-0.0:0.0}while(0);d=~~c}while(0);k[C>>2]=d;k[B>>2]=(+p[D>>3]>0.0?2:0)|(d|0)>0}q=a+8|0;j=Y;s=q+56|0;do{k[q>>2]=k[j>>2];q=q+4|0;j=j+4|0}while((q|0)<(s|0));n=a+64|0;KG(n,m)|0;d=a+120|0;X=Y+112|0;k[d>>2]=k[X>>2];k[d+4>>2]=k[X+4>>2];k[d+8>>2]=k[X+8>>2];k[d+12>>2]=k[X+12>>2];vFa(a);d=k[Z>>2]|0;k[A>>2]=0;k[Z>>2]=0;if(d|0?(W=d+-4|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0)ggb(k[d+-8>>2]|0);d=k[K>>2]|0;k[E>>2]=0;k[K>>2]=0;if(d|0?(W=d+-4|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0)ggb(k[d+-8>>2]|0);f=Y+92|0;d=k[f>>2]|0;if(d|0?(W=d+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[Y+88>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;X=Y+72|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[H>>2]|0)>0){e=k[F>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[H>>2]|0))}d=k[G>>2]|0;if(!((d|0)==(I|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k6(k[b>>2]|0,k[ca>>2]|0,369981)|0;i:do if(!d)X=0;else{switch(k[d>>2]&7){case 1:{X=k[d+8>>2]|0;break i}case 2:break;default:{X=2147483647;break i}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;X=d&2146435072;do if(!(X>>>0>1126170624|(X|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(!(c==0.0))break;c=d?-0.0:0.0}while(0);X=~~c}while(0);d=k6(k[b>>2]|0,k[ca>>2]|0,371497)|0;j:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break j}case 2:break;default:{d=2147483647;break j}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;W=d&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(!(c==0.0))break;c=d?-0.0:0.0}while(0);d=~~c}while(0);J=a+192|0;k[J>>2]=d;d=k6(k[b>>2]|0,k[ca>>2]|0,369990)|0;k:do if(!d)W=0;else{switch(k[d>>2]&7){case 1:{W=k[d+8>>2]|0;break k}case 2:break;default:{W=2147483647;break k}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;W=d&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(!(c==0.0))break;c=d?-0.0:0.0}while(0);W=~~c}while(0);if(!((X|0)>=1?(k[J>>2]|0)>=1:0)){d=Y+4|0;e=ZT(76)|0;k[e>>2]=1;q=e+4|0;k[Y>>2]=q;k[d>>2]=69;i[e+73>>0]=0;j=370002;s=q+69|0;do{i[q>>0]=i[j>>0]|0;q=q+1|0;j=j+1|0}while((q|0)<(s|0));Y8(-212,Y,401059,368204,2178);k[d>>2]=0;k[Y>>2]=0;V=k[e>>2]|0;k[e>>2]=V+-1;if((V|0)==1)ggb(k[e+-4>>2]|0)}e=k[b>>2]|0;f=k6(e,k[ca>>2]|0,371457)|0;if(f|0){g=a+136|0;k[Y>>2]=1124007936;m=Y+4|0;d=Y+8|0;j=Y+40|0;q=m;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[j>>2]=d;l=Y+48|0;h=Y+44|0;k[h>>2]=l;k[Y+52>>2]=0;k[l>>2]=0;G6(e,f,g,Y);f=Y+36|0;d=k[f>>2]|0;do if(d|0){U=d+12|0;V=k[U>>2]|0;k[U>>2]=V+-1;if((V|0)!=1)break;e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[Y+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}while(0);k[f>>2]=0;V=Y+16|0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[m>>2]|0)>0){e=k[j>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[m>>2]|0))}d=k[h>>2]|0;if(!((d|0)==(l|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}e=k[b>>2]|0;f=k6(e,k[ca>>2]|0,370072)|0;if(f|0){k[Y>>2]=1124007936;l=Y+4|0;d=Y+8|0;h=Y+40|0;q=l;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[h>>2]=d;j=Y+48|0;g=Y+44|0;k[g>>2]=j;k[Y+52>>2]=0;k[j>>2]=0;G6(e,f,n,Y);f=Y+36|0;d=k[f>>2]|0;do if(d|0){U=d+12|0;V=k[U>>2]|0;k[U>>2]=V+-1;if((V|0)!=1)break;e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[Y+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}while(0);k[f>>2]=0;V=Y+16|0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[l>>2]|0)>0){e=k[h>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[l>>2]|0))}d=k[g>>2]|0;if(!((d|0)==(j|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}I=(W|0)>1;l:do if(I){do if(k[a+152>>2]|0){h=k[a+140>>2]|0;g=(h|0)<3;if(g)d=aa(k[a+148>>2]|0,k[a+144>>2]|0)|0;else{f=k[a+176>>2]|0;e=0;d=1;do{d=aa(k[f+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(h|0))}if(!d)break;if(g)d=aa(k[a+148>>2]|0,k[a+144>>2]|0)|0;else{f=k[a+176>>2]|0;e=0;d=1;do{d=aa(k[f+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(h|0))}if((d|0)==(W|0))break l}while(0);d=Y+4|0;e=ZT(48)|0;k[e>>2]=1;q=e+4|0;k[Y>>2]=q;k[d>>2]=43;i[e+47>>0]=0;j=370086;s=q+43|0;do{i[q>>0]=i[j>>0]|0;q=q+1|0;j=j+1|0}while((q|0)<(s|0));Y8(-212,Y,401059,368204,2188);k[d>>2]=0;k[Y>>2]=0;V=k[e>>2]|0;k[e>>2]=V+-1;if((V|0)==1)ggb(k[e+-4>>2]|0)}while(0);f=k[b>>2]|0;g=k6(f,k[ca>>2]|0,370130)|0;m:do if(!g){d=1;ba=204}else{d=k[g>>2]|0;switch(d&7){case 6:{d=k[(k[g+8>>2]|0)+60>>2]|0;break m}case 5:{d=k[(k[g+8>>2]|0)+24>>2]|0;break m}default:{d=(d&7|0)==0;ba=204;break m}}}while(0);if((ba|0)==204)d=d&1^1;if((d|0)!=(X|0)){d=Y+4|0;e=ZT(36)|0;k[e>>2]=1;q=e+4|0;k[Y>>2]=q;k[d>>2]=31;i[e+35>>0]=0;j=370146;s=q+31|0;do{i[q>>0]=i[j>>0]|0;q=q+1|0;j=j+1|0}while((q|0)<(s|0));Y8(-215,Y,401059,368204,2193);k[d>>2]=0;k[Y>>2]=0;V=k[e>>2]|0;k[e>>2]=V+-1;if((V|0)==1)ggb(k[e+-4>>2]|0)}d=a+196|0;e=k[J>>2]|0;F=a+200|0;do if((k[F>>2]|0)<3){if((k[a+204>>2]|0)!=(X|0)){ba=214;break}if((k[a+208>>2]|0)!=(e|0)){ba=214;break}if((k[d>>2]&4095|0)!=5){ba=214;break}if(!(k[a+212>>2]|0))ba=214}else ba=214;while(0);if((ba|0)==214){k[Y>>2]=X;k[Y+4>>2]=e;G1(d,2,Y,5)}do if((f|0)!=0&(g|0)!=0){d=k[g>>2]|0;e=d&7;if(!e){ba=224;break}k[K>>2]=f;k[K+4>>2]=g;if(!((e+-5|0)>>>0<2&(d&16|0)==0)){k[K+20>>2]=g;k[K+12>>2]=0;k[K+40>>2]=1;break}e=g+8|0;KY(k[e>>2]|0,K+8|0);d=k[g>>2]|0;switch(d&7){case 6:{d=k[(k[e>>2]|0)+60>>2]|0;break}case 5:{d=k[(k[e>>2]|0)+24>>2]|0;break}default:d=(d&7|0)!=0&1}k[K+40>>2]=d}else ba=224;while(0);if((ba|0)==224){k[K>>2]=0;k[K+4>>2]=0;k[K+20>>2]=0;k[K+40>>2]=0}V=(X|0)>0;if(V){o=K+20|0;q=Z+4|0;s=a+212|0;t=a+240|0;v=Y+4|0;w=Y+8|0;x=Y+40|0;y=Y+20|0;z=Y+12|0;A=K+40|0;B=K+12|0;C=K+28|0;D=K+16|0;E=K+24|0;n=0;do{f=k[K>>2]|0;g=k[o>>2]|0;j=ZT(8)|0;k[j>>2]=1;d=j+4|0;k[Z>>2]=d;k[q>>2]=1;i[j+5>>0]=0;i[d>>0]=102;d=k[t>>2]|0;l=(k[s>>2]|0)+(aa(k[d>>2]|0,n)|0)|0;m=k[J>>2]|0;e=k[F>>2]|0;if((e|0)>0)h=k[d+(e+-1<<2)>>2]|0;else h=0;do if((f|0)!=0&(g|0)!=0){d=k[g>>2]|0;e=d&7;if(!e){ba=238;break}k[Y>>2]=f;k[v>>2]=g;if(!((e+-5|0)>>>0<2&(d&16|0)==0)){k[y>>2]=g;k[z>>2]=0;k[x>>2]=1;break}e=g+8|0;KY(k[e>>2]|0,w);d=k[g>>2]|0;switch(d&7){case 6:{d=k[(k[e>>2]|0)+60>>2]|0;break}case 5:{d=k[(k[e>>2]|0)+24>>2]|0;break}default:d=(d&7|0)!=0&1}k[x>>2]=d}else ba=238;while(0);if((ba|0)==238){ba=0;k[Y>>2]=0;k[v>>2]=0;k[y>>2]=0;k[x>>2]=0}C6(Y,Z,l,aa(h,m)|0)|0;k[q>>2]=0;k[Z>>2]=0;U=k[j>>2]|0;k[j>>2]=U+-1;if((U|0)==1)ggb(k[j+-4>>2]|0);n=n+1|0;d=k[A>>2]|0;if(d|0){e=k[B>>2]|0;do if(e|0){U=(k[o>>2]|0)+(k[e+28>>2]|0)|0;k[o>>2]=U;if(U>>>0<(k[C>>2]|0)>>>0)break;U=k[(k[D>>2]|0)+4>>2]|0;k[D>>2]=U;S=k[U+16>>2]|0;k[o>>2]=S;T=k[e+28>>2]|0;U=k[U+12>>2]|0;k[E>>2]=S;U=S+(aa(T,U)|0)|0;k[C>>2]=U}while(0);k[A>>2]=d+-1}}while((n|0)<(X|0))}d=k6(k[b>>2]|0,k[ca>>2]|0,370178)|0;do if(d|0){switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;ba=254;break}case 2:{c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;ba=d&2146435072;do if(!(ba>>>0>1126170624|(ba|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(!(c==0.0))break;c=d?-0.0:0.0}while(0);d=~~c;ba=254;break}default:d=2147483647}if((ba|0)==254)if((d|0)<=0)break;g=k[b>>2]|0;h=k6(g,k[ca>>2]|0,370200)|0;n:do if(!h){e=1;ba=260}else{e=k[h>>2]|0;switch(e&7){case 6:{e=k[(k[h+8>>2]|0)+60>>2]|0;break n}case 5:{e=k[(k[h+8>>2]|0)+24>>2]|0;break n}default:{e=(e&7|0)==0;ba=260;break n}}}while(0);if((ba|0)==260)e=e&1^1;if((e|0)!=(d|0)){e=Y+4|0;f=ZT(64)|0;k[f>>2]=1;q=f+4|0;k[Y>>2]=q;k[e>>2]=57;i[f+61>>0]=0;j=370229;s=q+57|0;do{i[q>>0]=i[j>>0]|0;q=q+1|0;j=j+1|0}while((q|0)<(s|0));Y8(-215,Y,401059,368204,2209);k[e>>2]=0;k[Y>>2]=0;U=k[f>>2]|0;k[f>>2]=U+-1;if((U|0)==1)ggb(k[f+-4>>2]|0)}e=a+252|0;f=k[J>>2]|0;H=a+256|0;do if((k[H>>2]|0)<3){if((k[a+260>>2]|0)!=(d|0)){ba=270;break}if((k[a+264>>2]|0)!=(f|0)){ba=270;break}if((k[e>>2]&4095|0)!=5){ba=270;break}if(!(k[a+268>>2]|0))ba=270}else ba=270;while(0);if((ba|0)==270){k[Y>>2]=d;k[Y+4>>2]=f;G1(e,2,Y,5)}do if((g|0)!=0&(h|0)!=0){e=k[h>>2]|0;f=e&7;if(!f){ba=280;break}k[Z>>2]=g;k[Z+4>>2]=h;if(!((f+-5|0)>>>0<2&(e&16|0)==0)){t=Z+20|0;k[t>>2]=h;k[Z+12>>2]=0;s=Z+40|0;k[s>>2]=1;q=Z;break}f=h+8|0;KY(k[f>>2]|0,Z+8|0);e=k[h>>2]|0;switch(e&7){case 6:{e=k[(k[f>>2]|0)+60>>2]|0;break}case 5:{e=k[(k[f>>2]|0)+24>>2]|0;break}default:e=(e&7|0)!=0&1}s=Z+40|0;k[s>>2]=e;q=Z;t=Z+20|0}else ba=280;while(0);if((ba|0)==280){k[Z>>2]=0;k[Z+4>>2]=0;t=Z+20|0;k[t>>2]=0;s=Z+40|0;k[s>>2]=0;q=Z}v=_+4|0;w=a+268|0;x=a+296|0;y=Y+4|0;z=Y+8|0;A=Y+40|0;B=Y+20|0;C=Y+12|0;D=Z+12|0;E=Z+28|0;F=Z+16|0;G=Z+24|0;o=0;do{g=k[q>>2]|0;h=k[t>>2]|0;l=ZT(8)|0;k[l>>2]=1;e=l+4|0;k[_>>2]=e;k[v>>2]=1;i[l+5>>0]=0;i[e>>0]=102;e=k[x>>2]|0;m=(k[w>>2]|0)+(aa(k[e>>2]|0,o)|0)|0;n=k[J>>2]|0;f=k[H>>2]|0;if((f|0)>0)j=k[e+(f+-1<<2)>>2]|0;else j=0;do if((g|0)!=0&(h|0)!=0){e=k[h>>2]|0;f=e&7;if(!f){ba=293;break}k[Y>>2]=g;k[y>>2]=h;if(!((f+-5|0)>>>0<2&(e&16|0)==0)){k[B>>2]=h;k[C>>2]=0;k[A>>2]=1;break}f=h+8|0;KY(k[f>>2]|0,z);e=k[h>>2]|0;switch(e&7){case 6:{e=k[(k[f>>2]|0)+60>>2]|0;break}case 5:{e=k[(k[f>>2]|0)+24>>2]|0;break}default:e=(e&7|0)!=0&1}k[A>>2]=e}else ba=293;while(0);if((ba|0)==293){ba=0;k[Y>>2]=0;k[y>>2]=0;k[B>>2]=0;k[A>>2]=0}C6(Y,_,m,aa(j,n)|0)|0;k[v>>2]=0;k[_>>2]=0;U=k[l>>2]|0;k[l>>2]=U+-1;if((U|0)==1)ggb(k[l+-4>>2]|0);o=o+1|0;e=k[s>>2]|0;if(e|0){f=k[D>>2]|0;do if(f|0){U=(k[t>>2]|0)+(k[f+28>>2]|0)|0;k[t>>2]=U;if(U>>>0<(k[E>>2]|0)>>>0)break;U=k[(k[F>>2]|0)+4>>2]|0;k[F>>2]=U;S=k[U+16>>2]|0;k[t>>2]=S;T=k[f+28>>2]|0;U=k[U+12>>2]|0;k[G>>2]=S;U=S+(aa(T,U)|0)|0;k[E>>2]=U}while(0);k[s>>2]=e+-1}}while((o|0)<(d|0))}while(0);U=(aa(W+-1|0,W)|0)/2|0;U=I?U:1;f=k[b>>2]|0;g=k6(f,k[ca>>2]|0,370287)|0;o:do if(!g){d=1;ba=308}else{d=k[g>>2]|0;switch(d&7){case 6:{d=k[(k[g+8>>2]|0)+60>>2]|0;break o}case 5:{d=k[(k[g+8>>2]|0)+24>>2]|0;break o}default:{d=(d&7|0)==0;ba=308;break o}}}while(0);if((ba|0)==308)d=d&1^1;if((d|0)!=(U|0)){d=Y+4|0;e=ZT(36)|0;k[e>>2]=1;q=e+4|0;k[Y>>2]=q;k[d>>2]=31;i[e+35>>0]=0;j=370306;s=q+31|0;do{i[q>>0]=i[j>>0]|0;q=q+1|0;j=j+1|0}while((q|0)<(s|0));Y8(-215,Y,401059,368204,2223);k[d>>2]=0;k[Y>>2]=0;T=k[e>>2]|0;k[e>>2]=T+-1;if((T|0)==1)ggb(k[e+-4>>2]|0)}do if((f|0)!=0&(g|0)!=0){d=k[g>>2]|0;e=d&7;if(!e){ba=322;break}k[Z>>2]=f;k[Z+4>>2]=g;if(!((e+-5|0)>>>0<2&(d&16|0)==0)){k[Z+20>>2]=g;k[Z+12>>2]=0;k[Z+40>>2]=1;break}e=g+8|0;KY(k[e>>2]|0,Z+8|0);d=k[g>>2]|0;switch(d&7){case 6:{d=k[(k[e>>2]|0)+60>>2]|0;break}case 5:{d=k[(k[e>>2]|0)+24>>2]|0;break}default:d=(d&7|0)!=0&1}k[Z+40>>2]=d}else ba=322;while(0);if((ba|0)==322){k[Z>>2]=0;k[Z+4>>2]=0;k[Z+20>>2]=0;k[Z+40>>2]=0}if((U|0)>0){s=Z+20|0;t=_+8|0;v=a+332|0;w=a+336|0;x=a+320|0;y=a+324|0;z=$+4|0;A=(W|0)>2;B=$+4|0;C=a+312|0;D=a+316|0;E=a+308|0;F=Y+4|0;G=Y+8|0;H=Y+40|0;I=Y+20|0;J=Y+12|0;K=Y+4|0;L=Y+8|0;M=Y+40|0;N=Y+20|0;O=Y+12|0;P=Z+40|0;Q=Z+12|0;R=Z+28|0;S=Z+16|0;T=Z+24|0;q=0;do{o=k[Z>>2]|0;l=k[s>>2]|0;p[_>>3]=0.0;k[t>>2]=0;d=k6(o,l,370338)|0;p:do if(!d)n=0;else{switch(k[d>>2]&7){case 1:{n=k[d+8>>2]|0;break p}case 2:break;default:{n=2147483647;break p}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;n=d&2146435072;do if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(!(c==0.0))break;c=d?-0.0:0.0}while(0);n=~~c}while(0);m=(k[w>>2]|0)-(k[v>>2]|0)>>2;d=k6(o,l,370347)|0;q:do if(!d)c=0.0;else switch(k[d>>2]&7){case 1:{c=+(k[d+8>>2]|0);break q}case 2:{c=+p[d+8>>3];break q}default:{c=1.e+300;break q}}while(0);p[_>>3]=c;k[t>>2]=m;g=m+n|0;f=k[w>>2]|0;e=k[v>>2]|0;d=f-e>>2;do if(g>>>0>d>>>0)U1(v,g-d|0);else{if(g>>>0>=d>>>0)break;d=e+(g<<2)|0;if((f|0)==(d|0))break;k[w>>2]=f+(~((f+-4-d|0)>>>2)<<2)}while(0);f=k[y>>2]|0;e=k[x>>2]|0;d=f-e>>3;do if(g>>>0>d>>>0)Bla(x,g-d|0);else{if(g>>>0>=d>>>0)break;d=e+(g<<3)|0;if((f|0)==(d|0))break;k[y>>2]=f+(~((f+-8-d|0)>>>3)<<3)}while(0);f=k6(o,l,370351)|0;g=ZT(8)|0;k[g>>2]=1;h=g+4|0;k[$>>2]=h;k[z>>2]=1;i[g+5>>0]=0;i[h>>0]=100;h=k[x>>2]|0;j=(o|0)!=0;do if(j&(f|0)!=0){d=k[f>>2]|0;e=d&7;if(!e){ba=355;break}k[Y>>2]=o;k[F>>2]=f;if(!((e+-5|0)>>>0<2&(d&16|0)==0)){k[I>>2]=f;k[J>>2]=0;k[H>>2]=1;break}e=f+8|0;KY(k[e>>2]|0,G);d=k[f>>2]|0;switch(d&7){case 6:{d=k[(k[e>>2]|0)+60>>2]|0;break}case 5:{d=k[(k[e>>2]|0)+24>>2]|0;break}default:d=(d&7|0)!=0&1}k[H>>2]=d}else ba=355;while(0);if((ba|0)==355){ba=0;k[Y>>2]=0;k[F>>2]=0;k[I>>2]=0;k[H>>2]=0}C6(Y,$,h+(m<<3)|0,n<<3)|0;k[z>>2]=0;k[$>>2]=0;h=k[g>>2]|0;k[g>>2]=h+-1;if((h|0)==1)ggb(k[g+-4>>2]|0);if(A){f=k6(o,l,370357)|0;g=ZT(8)|0;k[g>>2]=1;h=g+4|0;k[$>>2]=h;k[B>>2]=1;i[g+5>>0]=0;i[h>>0]=105;h=k[v>>2]|0;do if(j&(f|0)!=0){d=k[f>>2]|0;e=d&7;if(!e){ba=368;break}k[Y>>2]=o;k[K>>2]=f;if(!((e+-5|0)>>>0<2&(d&16|0)==0)){k[N>>2]=f;k[O>>2]=0;k[M>>2]=1;break}e=f+8|0;KY(k[e>>2]|0,L);d=k[f>>2]|0;switch(d&7){case 6:{d=k[(k[e>>2]|0)+60>>2]|0;break}case 5:{d=k[(k[e>>2]|0)+24>>2]|0;break}default:d=(d&7|0)!=0&1}k[M>>2]=d}else ba=368;while(0);if((ba|0)==368){ba=0;k[Y>>2]=0;k[K>>2]=0;k[N>>2]=0;k[M>>2]=0}C6(Y,$,h+(m<<2)|0,n<<2)|0;k[B>>2]=0;k[$>>2]=0;o=k[g>>2]|0;k[g>>2]=o+-1;if((o|0)==1)ggb(k[g+-4>>2]|0)}d=k[C>>2]|0;if((d|0)==(k[D>>2]|0))nGa(E,_);else{k[d>>2]=k[_>>2];k[d+4>>2]=k[_+4>>2];k[d+8>>2]=k[_+8>>2];k[d+12>>2]=k[_+12>>2];k[C>>2]=(k[C>>2]|0)+16}q=q+1|0;d=k[P>>2]|0;if(d|0){e=k[Q>>2]|0;do if(e|0){o=(k[s>>2]|0)+(k[e+28>>2]|0)|0;k[s>>2]=o;if(o>>>0<(k[R>>2]|0)>>>0)break;o=k[(k[S>>2]|0)+4>>2]|0;k[S>>2]=o;m=k[o+16>>2]|0;k[s>>2]=m;n=k[e+28>>2]|0;o=k[o+12>>2]|0;k[T>>2]=m;o=m+(aa(n,o)|0)|0;k[R>>2]=o}while(0);k[P>>2]=d+-1}}while((q|0)<(U|0))}do if((W|0)<3){f=a+332|0;g=a+336|0;h=k[g>>2]|0;e=k[f>>2]|0;d=h-e>>2;do if(X>>>0>d>>>0)U1(f,X-d|0);else{if(X>>>0>=d>>>0)break;d=e+(X<<2)|0;if((h|0)==(d|0))break;k[g>>2]=h+(~((h+-4-d|0)>>>2)<<2)}while(0);if(!V)break;e=k[f>>2]|0;d=0;do{k[e+(d<<2)>>2]=d;d=d+1|0}while((d|0)!=(X|0))}while(0);d=k6(k[b>>2]|0,k[ca>>2]|0,370363)|0;if(!d){r=da;return}switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;ba=397;break}case 2:{c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;b=d&2146435072;do if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(!(c==0.0))break;c=d?-0.0:0.0}while(0);d=~~c;ba=397;break}default:{}}do if((ba|0)==397){if(d|0)break;r=da;return}while(0);qGa(a);r=da;return}function JFa(a,b){a=a|0;b=b|0;var c=0;c=ZT(20)|0;k[c>>2]=1;b=c+4|0;k[a>>2]=b;k[a+4>>2]=13;i[c+17>>0]=0;a=b;b=369967;c=a+13|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));return}function KFa(a){a=a|0;return k[a+192>>2]|0}function LFa(a){a=a|0;var b=0,c=0,d=0;if(!(k[a+212>>2]|0)){d=0;return d|0}d=k[a+200>>2]|0;if((d|0)<3)a=aa(k[a+208>>2]|0,k[a+204>>2]|0)|0;else{c=k[a+236>>2]|0;b=0;a=1;do{a=aa(k[c+(b<<2)>>2]|0,a)|0;b=b+1|0}while((b|0)!=(d|0))}d=(a|0)!=0;return d|0}function MFa(a){a=a|0;return ((k[a+8>>2]|0)+-100|0)>>>0<3|0}function NFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+176|0;s=t+112|0;p=t+56|0;l=t;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);vFa(a);d=k[a+8>>2]|0;g=b+4|0;q=k[g>>2]|0;eh[k[(k[q>>2]|0)+44>>2]&255](s,q,0,1,1);k[p>>2]=1124007936;q=p+4|0;f=p+8|0;m=p+40|0;c=q;b=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(b|0));k[m>>2]=f;o=p+48|0;n=p+44|0;k[n>>2]=o;k[p+52>>2]=0;k[o>>2]=0;if((d|1|0)==101){d=k[g>>2]|0;jh[k[(k[d>>2]|0)+52>>2]&1023](l,d);KG(p,l)|0;d=l+36|0;c=k[d>>2]|0;if(c|0?(b=c+12|0,e=k[b>>2]|0,k[b>>2]=e+-1,(e|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[l+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;e=l+16|0;b=l+4|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[b>>2]|0)>0){d=k[l+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[l+44>>2]|0;if(!((c|0)==(l+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);if(k[p+16>>2]|0){e=k[q>>2]|0;if((e|0)<3)c=aa(k[p+12>>2]|0,k[f>>2]|0)|0;else{d=k[m>>2]|0;b=0;c=1;do{c=aa(k[d+(b<<2)>>2]|0,c)|0;b=b+1|0}while((b|0)!=(e|0))}if(!c)j=21}else j=21;if((j|0)==21?(k[l>>2]=0,j=l+4|0,k[j>>2]=0,h=ZT(152)|0,k[h>>2]=1,f=h+4|0,k[l>>2]=f,k[j>>2]=146,i[h+150>>0]=0,upb(f|0,369820,146)|0,Y8(-5,l,389152,368204,1618),k[j>>2]=0,k[l>>2]=0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[h+-4>>2]|0);d=k[g>>2]|0;jh[k[(k[d>>2]|0)+120>>2]&1023](l,d);KG(a+136|0,l)|0;d=l+36|0;c=k[d>>2]|0;if(c|0?(h=c+12|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[l+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;j=l+16|0;b=l+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[b>>2]|0)>0){d=k[l+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[l+44>>2]|0;if(!((c|0)==(l+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}else{d=k[g>>2]|0;jh[k[(k[d>>2]|0)+48>>2]&1023](l,d);KG(p,l)|0;d=l+36|0;c=k[d>>2]|0;if(c|0?(h=c+12|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[l+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;j=l+16|0;b=l+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[b>>2]|0)>0){d=k[l+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[l+44>>2]|0;if(!((c|0)==(l+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}if(mGa(a,s,p)|0)e=1;else{Uh[k[(k[a>>2]|0)+8>>2]&2047](a);e=0}d=p+36|0;c=k[d>>2]|0;if(c|0?(l=c+12|0,a=k[l>>2]|0,k[l>>2]=a+-1,(a|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[p+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;p=p+16|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[q>>2]|0)>0){b=k[m>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[q>>2]|0))}c=k[n>>2]|0;if(!((c|0)==(o|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=s+36|0;c=k[d>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;q=s+16|0;b=s+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[b>>2]|0)>0){d=k[s+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[s+44>>2]|0;if((c|0)==(s+48|0)|(c|0)==0){r=t;return e|0}ggb(k[c+-4>>2]|0);r=t;return e|0}function OFa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+192|0;w=B+176|0;A=B+120|0;z=B+64|0;x=B+8|0;y=B;o[w>>2]=0.0;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[A>>2]=k[g>>2];m=A+4|0;b=g+4|0;k[m>>2]=k[b>>2];p=A+8|0;k[p>>2]=k[g+8>>2];n=A+12|0;k[n>>2]=k[g+12>>2];k[A+16>>2]=k[g+16>>2];k[A+20>>2]=k[g+20>>2];k[A+24>>2]=k[g+24>>2];k[A+28>>2]=k[g+28>>2];k[A+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[A+36>>2]=e;f=A+40|0;k[f>>2]=p;v=A+48|0;j=A+44|0;k[j>>2]=v;k[A+52>>2]=0;k[v>>2]=0;if(e|0){v=e+12|0;k[v>>2]=(k[v>>2]|0)+1}if((k[b>>2]|0)<3){e=k[g+44>>2]|0;f=k[j>>2]|0;k[f>>2]=k[e>>2];k[f+4>>2]=k[e+4>>2];f=n;e=p;break}k[m>>2]=0;x1(A,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0));f=n;e=p}else{f=n;e=p}}else{Q1(A,b,-1);f=A+12|0;e=A+8|0}while(0);k[z>>2]=1124007936;u=z+4|0;b=z+8|0;s=z+40|0;g=u;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[s>>2]=b;v=z+48|0;t=z+44|0;k[t>>2]=v;k[z+52>>2]=0;k[v>>2]=0;p=k[e>>2]|0;n=d&1;if(!((k[f>>2]|0)==(k[a+192>>2]|0)?(k[A>>2]&4095|0)==5:0)){k[x>>2]=0;b=x+4|0;k[b>>2]=0;e=ZT(60)|0;k[e>>2]=1;g=e+4|0;k[x>>2]=g;k[b>>2]=53;i[e+57>>0]=0;f=369637;h=g+53|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,x,372250,368204,1930);k[b>>2]=0;k[x>>2]=0;d=k[e>>2]|0;k[e>>2]=d+-1;if((d|0)==1)ggb(k[e+-4>>2]|0)}if(!(k[c>>2]&2031616)){if((p|0)!=1){k[x>>2]=0;b=x+4|0;k[b>>2]=0;e=ZT(20)|0;k[e>>2]=1;g=e+4|0;k[x>>2]=g;k[b>>2]=13;i[e+17>>0]=0;f=369691;h=g+13|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,x,372250,368204,1939);k[b>>2]=0;k[x>>2]=0;c=k[e>>2]|0;k[e>>2]=c+-1;if((c|0)==1)ggb(k[e+-4>>2]|0)}j=x+4|0;k[j>>2]=2;m=x+8|0;k[m>>2]=1;k[x+12>>2]=1;f=x+16|0;k[f>>2]=w;k[x+20>>2]=w;h=x+24|0;g=x+40|0;l=h+8|0;k[l>>2]=0;k[l+4>>2]=0;k[g>>2]=m;m=x+48|0;l=x+44|0;k[l>>2]=m;k[x>>2]=1124024325;k[m>>2]=4;k[x+52>>2]=4;b=w+4|0;k[x+28>>2]=b;k[h>>2]=b;KG(z,x)|0;h=x+36|0;b=k[h>>2]|0;if(b|0?(d=b+12|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0){e=k[h>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[x+32>>2]|0;if(!b){b=B1()|0;e=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[h>>2]=0}k[h>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[j>>2]|0)>0){e=k[g>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[l>>2]|0;if(!((b|0)==(m|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{c2(c,p,1,k[A>>2]&4095,-1,0,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[x>>2]=k[g>>2];m=x+4|0;b=g+4|0;k[m>>2]=k[b>>2];c=x+8|0;k[c>>2]=k[g+8>>2];k[x+12>>2]=k[g+12>>2];k[x+16>>2]=k[g+16>>2];k[x+20>>2]=k[g+20>>2];k[x+24>>2]=k[g+24>>2];k[x+28>>2]=k[g+28>>2];k[x+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[x+36>>2]=e;f=x+40|0;k[f>>2]=c;c=x+48|0;j=x+44|0;k[j>>2]=c;k[x+52>>2]=0;k[c>>2]=0;if(e|0){c=e+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[b>>2]|0)<3){d=k[g+44>>2]|0;c=k[j>>2]|0;k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];break}k[m>>2]=0;x1(x,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(x,c,-1);while(0);KG(z,x)|0;f=x+36|0;b=k[f>>2]|0;if(b|0?(d=b+12|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[x+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;c=x+16|0;e=x+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[e>>2]|0)>0){f=k[x+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[x+44>>2]|0;if(!((b|0)==(x+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}k[x>>2]=92828;k[x+4>>2]=a;k[x+12>>2]=z;k[x+8>>2]=A;i[x+16>>0]=n;if((p|0)<10){k[y>>2]=0;k[y+4>>2]=p;FGa(x,y)}else{k[y>>2]=0;k[y+4>>2]=p;FGa(x,y)}q=+o[w>>2];f=z+36|0;b=k[f>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[z+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;z=z+16|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[u>>2]|0)>0){e=k[s>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[u>>2]|0))}b=k[t>>2]|0;if(!((b|0)==(v|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=A+36|0;b=k[f>>2]|0;if(b|0?(y=b+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[A+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;z=A+16|0;e=A+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[e>>2]|0)>0){f=k[A+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[A+44>>2]|0;if((b|0)==(A+48|0)|(b|0)==0){r=B;return +q}ggb(k[b+-4>>2]|0);r=B;return +q}function PFa(a){a=a|0;return k[a+8>>2]|0}function QFa(a,b){a=a|0;b=b|0;k[a+8>>2]=b;return}function RFa(a){a=a|0;return +(+p[a+16>>3])}function SFa(a,b){a=a|0;b=+b;p[a+16>>3]=b;return}function TFa(a){a=a|0;return +(+p[a+24>>3])}function UFa(a,b){a=a|0;b=+b;p[a+24>>3]=b;return}function VFa(a){a=a|0;return +(+p[a+32>>3])}function WFa(a,b){a=a|0;b=+b;p[a+32>>3]=b;return}function XFa(a){a=a|0;return +(+p[a+40>>3])}function YFa(a,b){a=a|0;b=+b;p[a+40>>3]=b;return}function ZFa(a){a=a|0;return +(+p[a+48>>3])}function _Fa(a,b){a=a|0;b=+b;p[a+48>>3]=b;return}function $Fa(a){a=a|0;return +(+p[a+56>>3])}function aGa(a,b){a=a|0;b=+b;p[a+56>>3]=b;return}function bGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+64>>2];i=a+4|0;e=b+68|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+72>>2];k[a+12>>2]=k[b+76>>2];k[a+16>>2]=k[b+80>>2];k[a+20>>2]=k[b+84>>2];k[a+24>>2]=k[b+88>>2];k[a+28>>2]=k[b+92>>2];k[a+32>>2]=k[b+96>>2];d=k[b+100>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+108>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+104>>2]|0;a=k[g>>2]|0;e=k[b+108>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function cGa(a,b){a=a|0;b=b|0;KG(a+64|0,b)|0;return}function dGa(a,b){a=a|0;b=b|0;b=b+120|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];return}function eGa(a,b){a=a|0;b=b|0;a=a+120|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];return}function fGa(a){a=a|0;return k[a+12>>2]|0}function gGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;k[a+12>>2]=b;if((b|0)==-1)return;c=a+8|0;f=a+344|0;while(1){b=fgb(136)|0;if(b|0){e=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){e=0;break}Qh[b&7]()}wFa(e,c);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}c=b+4|0;k[c>>2]=1;k[b>>2]=92760;k[b+8>>2]=e;k[c>>2]=(k[c>>2]|0)+1;d=k[f>>2]|0;k[f>>2]=b;k[a+348>>2]=e;if(d|0?(f=d+4|0,a=k[f>>2]|0,k[f>>2]=a+-1,(a|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);a=k[c>>2]|0;k[c>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);return}function hGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;k[a+12>>2]=-1;d=a+344|0;e=k[b>>2]|0;c=k[b+4>>2]|0;if(e|0){b=e+4|0;k[b>>2]=(k[b>>2]|0)+1}b=k[d>>2]|0;k[d>>2]=e;k[a+348>>2]=c;if(!b)return;d=b+4|0;e=k[d>>2]|0;k[d>>2]=e+-1;if((e|0)!=1)return;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);return}function iGa(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0;Cb=r;r=r+624|0;mb=Cb+568|0;Bb=Cb+512|0;xb=Cb+456|0;vb=Cb+400|0;qb=Cb+328|0;hb=Cb;E=Cb+344|0;pb=Cb+272|0;ob=Cb+216|0;nb=Cb+160|0;ib=Cb+144|0;jb=Cb+128|0;vFa(a);kb=a+8|0;s=k[kb>>2]|0;if((s|0)==102){Bb=ci[k[(k[a>>2]|0)+44>>2]&255](a,b,0)|0;r=Cb;return Bb|0}Uh[k[(k[a>>2]|0)+8>>2]&2047](a);if((c|0)<=1){m=mb+4|0;n=ZT(16)|0;k[n>>2]=1;F=n+4|0;k[mb>>2]=F;k[m>>2]=11;i[n+15>>0]=0;q=368886;G=F+11|0;do{i[F>>0]=i[q>>0]|0;F=F+1|0;q=q+1|0}while((F|0)<(G|0));Y8(-215,mb,368898,368204,1649);k[m>>2]=0;k[mb>>2]=0;Ab=k[n>>2]|0;k[n>>2]=Ab+-1;if((Ab|0)==1)ggb(k[n+-4>>2]|0)}bb=d+16|0;if(!(+p[bb>>3]<=1.0))lGa(d);else{S=+p[a+40>>3];p[d+8>>3]=S;p[d>>3]=S;p[bb>>3]=10.0}cb=e+16|0;if(!(+p[cb>>3]<=1.0))lGa(e);else{S=+p[a+16>>3];p[e+8>>3]=S;p[e>>3]=S;p[cb>>3]=10.0}db=f+16|0;if(!(+p[db>>3]<=1.0))lGa(f);else{S=+p[a+56>>3];p[f+8>>3]=S;p[f>>3]=S;p[db>>3]=10.0}eb=g+16|0;if(!(+p[eb>>3]<=1.0))lGa(g);else{S=+p[a+48>>3];p[g+8>>3]=S;p[g>>3]=S;p[eb>>3]=10.0}fb=h+16|0;if(!(+p[fb>>3]<=1.0))lGa(h);else{S=+p[a+24>>3];p[h+8>>3]=S;p[h>>3]=S;p[fb>>3]=10.0}gb=j+16|0;if(!(+p[gb>>3]<=1.0))lGa(j);else{S=+p[a+32>>3];p[j+8>>3]=S;p[j>>3]=S;p[gb>>3]=10.0}m=k[a+12>>2]|0;a:do if((m|0)!=1){S=+p[a+32>>3];p[j+8>>3]=S;p[j>>3]=S;switch(m|0){case 3:break a;case 0:{S=+p[a+16>>3];p[e+8>>3]=S;p[e>>3]=S;break}default:{}}S=+p[a+24>>3];p[h+8>>3]=S;p[h>>3]=S}while(0);switch(s|0){case 101:{S=+p[a+40>>3];p[d+8>>3]=S;p[d>>3]=S;lb=32;break}case 100:case 103:{S=+p[a+48>>3];p[g+8>>3]=S;p[g>>3]=S;if((s|0)!=103)lb=32;break}default:lb=32}if((lb|0)==32){S=+p[a+56>>3];p[f+8>>3]=S;p[f>>3]=S}t=b+4|0;yb=k[t>>2]|0;eh[k[(k[yb>>2]|0)+44>>2]&255](Bb,yb,0,1,1);k[xb>>2]=1124007936;yb=xb+4|0;ab=xb+8|0;wb=xb+40|0;F=yb;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[wb>>2]=ab;Ab=xb+48|0;zb=xb+44|0;k[zb>>2]=Ab;k[xb+52>>2]=0;k[Ab>>2]=0;k[vb>>2]=1124007936;tb=vb+4|0;m=vb+8|0;rb=vb+40|0;F=tb;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[rb>>2]=m;ub=vb+48|0;sb=vb+44|0;k[sb>>2]=ub;k[vb+52>>2]=0;k[ub>>2]=0;$a=a+136|0;u=a+140|0;b=k[u>>2]|0;if((b|0)<3)q=aa(k[a+148>>2]|0,k[a+144>>2]|0)|0;else{q=k[a+176>>2]|0;n=0;m=1;do{m=aa(k[q+(n<<2)>>2]|0,m)|0;n=n+1|0}while((n|0)!=(b|0));q=m}if((s|1|0)==101){b=k[t>>2]|0;jh[k[(k[b>>2]|0)+52>>2]&1023](mb,b);KG(xb,mb)|0;b=mb+36|0;m=k[b>>2]|0;if(m|0?(Za=m+12|0,_a=k[Za>>2]|0,k[Za>>2]=_a+-1,(_a|0)==1):0){n=k[b>>2]|0;if(n|0){m=k[n+4>>2]|0;if(!m){m=k[mb+32>>2]|0;if(!m){m=B1()|0;n=k[b>>2]|0}}jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[b>>2]=0}k[b>>2]=0;_a=mb+16|0;n=mb+4|0;k[_a>>2]=0;k[_a+4>>2]=0;k[_a+8>>2]=0;k[_a+12>>2]=0;if((k[n>>2]|0)>0){b=k[mb+40>>2]|0;m=0;do{k[b+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[n>>2]|0))}m=k[mb+44>>2]|0;if(!((m|0)==(mb+48|0)|(m|0)==0))ggb(k[m+-4>>2]|0);b=k[t>>2]|0;jh[k[(k[b>>2]|0)+120>>2]&1023](mb,b);KG($a,mb)|0;b=mb+36|0;m=k[b>>2]|0;if(m|0?(Za=m+12|0,_a=k[Za>>2]|0,k[Za>>2]=_a+-1,(_a|0)==1):0){n=k[b>>2]|0;if(n|0){m=k[n+4>>2]|0;do if(!m){m=k[mb+32>>2]|0;if(m|0)break;m=B1()|0;n=k[b>>2]|0}while(0);jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[b>>2]=0}k[b>>2]=0;_a=mb+16|0;n=mb+4|0;k[_a>>2]=0;k[_a+4>>2]=0;k[_a+8>>2]=0;k[_a+12>>2]=0;if((k[n>>2]|0)>0){b=k[mb+40>>2]|0;m=0;do{k[b+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[n>>2]|0))}m=k[mb+44>>2]|0;if(!((m|0)==(mb+48|0)|(m|0)==0))ggb(k[m+-4>>2]|0);b=k[u>>2]|0;if((b|0)<3)D=aa(k[a+148>>2]|0,k[a+144>>2]|0)|0;else{q=k[a+176>>2]|0;n=0;m=1;do{m=aa(k[q+(n<<2)>>2]|0,m)|0;n=n+1|0}while((n|0)!=(b|0));D=m}k[qb>>2]=0;C=qb+4|0;k[C>>2]=0;k[qb+8>>2]=0;do if(D|0){U1(qb,D);if((D|0)<=0)break;n=k[qb>>2]|0;m=0;do{k[n+(m<<2)>>2]=m;m=m+1|0}while((m|0)!=(D|0))}while(0);KG(vb,$a)|0;k[E>>2]=1124024324;z=E+4|0;k[z>>2]=2;B=E+8|0;_a=k[C>>2]|0;m=k[qb>>2]|0;n=_a-m|0;k[B>>2]=n>>2;k[E+12>>2]=1;w=E+16|0;k[w>>2]=0;b=E+20|0;k[b>>2]=0;q=E+24|0;k[q>>2]=0;v=E+32|0;k[v>>2]=0;x=E+36|0;k[x>>2]=0;y=E+40|0;k[y>>2]=B;B=E+48|0;A=E+44|0;k[A>>2]=B;s=E+52|0;k[s>>2]=0;k[B>>2]=0;t=m;if((t|0)!=(_a|0)){k[s>>2]=4;k[B>>2]=4;k[w>>2]=t;k[b>>2]=t;_a=m+n|0;k[q>>2]=_a;k[E+28>>2]=_a}k[hb>>2]=1124007936;u=hb+4|0;m=hb+8|0;s=hb+40|0;F=u;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s>>2]=m;t=hb+48|0;q=hb+44|0;k[q>>2]=t;k[hb+52>>2]=0;k[t>>2]=0;b=mb+4|0;m=b+4|0;k[m>>2]=0;k[m+4>>2]=0;k[mb>>2]=33619968;k[b>>2]=hb;mY(E,mb);KG($a,hb)|0;b=hb+36|0;m=k[b>>2]|0;do if(m|0){Za=m+12|0;_a=k[Za>>2]|0;k[Za>>2]=_a+-1;if((_a|0)!=1)break;n=k[b>>2]|0;if(n|0){m=k[n+4>>2]|0;do if(!m){m=k[hb+32>>2]|0;if(m|0)break;m=B1()|0;n=k[b>>2]|0}while(0);jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[b>>2]=0}while(0);k[b>>2]=0;_a=hb+16|0;k[_a>>2]=0;k[_a+4>>2]=0;k[_a+8>>2]=0;k[_a+12>>2]=0;if((k[u>>2]|0)>0){n=k[s>>2]|0;m=0;do{k[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[u>>2]|0))}m=k[q>>2]|0;if(!((m|0)==(t|0)|(m|0)==0))ggb(k[m+-4>>2]|0);m=k[x>>2]|0;do if(m|0){Za=m+12|0;_a=k[Za>>2]|0;k[Za>>2]=_a+-1;if((_a|0)!=1)break;n=k[x>>2]|0;if(n|0){m=k[n+4>>2]|0;do if(!m){m=k[v>>2]|0;if(m|0)break;m=B1()|0;n=k[x>>2]|0}while(0);jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[x>>2]=0}while(0);k[x>>2]=0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[z>>2]|0)>0){n=k[y>>2]|0;m=0;do{k[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[z>>2]|0))}m=k[A>>2]|0;if(!((m|0)==(B|0)|(m|0)==0))ggb(k[m+-4>>2]|0);m=k[qb>>2]|0;n=m;if(m|0){b=k[C>>2]|0;if((b|0)!=(m|0))k[C>>2]=b+(~((b+-4-n|0)>>>2)<<2);ggb(m)}Ya=1;s=D}else{b=k[t>>2]|0;jh[k[(k[b>>2]|0)+48>>2]&1023](mb,b);KG(xb,mb)|0;b=mb+36|0;m=k[b>>2]|0;if(m|0?(Za=m+12|0,_a=k[Za>>2]|0,k[Za>>2]=_a+-1,(_a|0)==1):0){n=k[b>>2]|0;if(n|0){m=k[n+4>>2]|0;if(!m){m=k[mb+32>>2]|0;if(!m){m=B1()|0;n=k[b>>2]|0}}jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[b>>2]=0}k[b>>2]=0;_a=mb+16|0;n=mb+4|0;k[_a>>2]=0;k[_a+4>>2]=0;k[_a+8>>2]=0;k[_a+12>>2]=0;if((k[n>>2]|0)>0){b=k[mb+40>>2]|0;m=0;do{k[b+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[n>>2]|0))}m=k[mb+44>>2]|0;if(!((m|0)==(mb+48|0)|(m|0)==0))ggb(k[m+-4>>2]|0);Ya=0;s=q}if((k[Bb>>2]&4095|0)!=5){k[mb>>2]=0;m=mb+4|0;k[m>>2]=0;n=ZT(32)|0;k[n>>2]=1;F=n+4|0;k[mb>>2]=F;k[m>>2]=24;i[n+28>>0]=0;q=368908;G=F+24|0;do{i[F>>0]=i[q>>0]|0;F=F+1|0;q=q+1|0}while((F|0)<(G|0));Y8(-215,mb,368898,368204,1706);k[m>>2]=0;k[mb>>2]=0;_a=k[n>>2]|0;k[n>>2]=_a+-1;if((_a|0)==1)ggb(k[n+-4>>2]|0)}Xa=k[Bb+8>>2]|0;n=k[Bb+12>>2]|0;L=a+192|0;k[L>>2]=n;_a=Bb+4|0;m=k[_a>>2]|0;if((m|0)>0)m=k[(k[Bb+44>>2]|0)+(m+-1<<2)>>2]|0;else m=0;Wa=aa(m,n)|0;k[qb>>2]=0;Za=qb+4|0;k[Za>>2]=0;k[qb+8>>2]=0;if((Xa|0)!=0?(U1(qb,Xa),(Xa|0)>0):0){q=k[qb>>2]|0;m=0;do{k[q+(m<<2)>>2]=m;m=m+1|0}while((m|0)!=(Xa|0));b=0;n=-1;m=-1;do{Ta=Epb(n|0,0,-130063606,0)|0;Ta=kpb(Ta|0,N|0,m|0,0)|0;n=N;m=Epb(Ta|0,0,-130063606,0)|0;n=kpb(m|0,N|0,n|0,0)|0;m=N;Ta=q+(((Ta>>>0)%(Xa>>>0)|0)<<2)|0;Va=q+(((n>>>0)%(Xa>>>0)|0)<<2)|0;Ua=k[Ta>>2]|0;k[Ta>>2]=k[Va>>2];k[Va>>2]=Ua;b=b+1|0}while((b|0)!=(Xa|0));b=1}else{b=0;n=-1;m=-1}if(Ya&(s|0)==2&l){k[mb>>2]=0;J=mb+4|0;k[J>>2]=0;k[mb+8>>2]=0;k[hb>>2]=0;l=hb+4|0;k[l>>2]=0;k[hb+8>>2]=0;if(b){v=xb+16|0;w=xb+12|0;x=mb+8|0;y=hb+8|0;u=k[qb>>2]|0;t=0;do{z=u+(t<<2)|0;A=k[z>>2]|0;do if(!(k[xb>>2]&16384)){b=k[wb>>2]|0;if((k[b>>2]|0)==1){lb=136;break}q=k[v>>2]|0;s=k[zb>>2]|0;if((k[b+4>>2]|0)==1){b=q+(aa(k[s>>2]|0,A)|0)|0;break}else{b=k[w>>2]|0;Va=(A|0)/(b|0)|0;b=A-(aa(Va,b)|0)|0;b=q+(aa(k[s>>2]|0,Va)|0)+(b<<2)|0;break}}else lb=136;while(0);if((lb|0)==136){lb=0;b=(k[v>>2]|0)+(A<<2)|0}do if(!(k[b>>2]|0)){b=k[J>>2]|0;if((b|0)==(k[x>>2]|0)){Q4(mb,z);break}else{k[b>>2]=A;k[J>>2]=b+4;break}}else{b=k[l>>2]|0;if((b|0)==(k[y>>2]|0)){Q4(hb,z);break}else{k[b>>2]=A;k[l>>2]=b+4;break}}while(0);t=t+1|0}while((t|0)<(Xa|0));G=k[J>>2]|0;D=k[mb>>2]|0;F=k[l>>2]|0;E=k[hb>>2]|0;b=D;q=G;s=E;t=F}else{b=0;q=0;s=0;t=0;u=k[qb>>2]|0;D=0;E=0;F=0;G=0}C=q-b>>2;B=t-s>>2;b=k[Za>>2]|0;q=u;if((b|0)!=(u|0)){u=b+(~((b+-4-q|0)>>>2)<<2)|0;k[Za>>2]=u}if((c|0)>0){z=c>>>1;A=qb+8|0;v=0;b=0;w=0;s=u;t=q;q=u;while(1){v=v+1|0;x=((aa(v,C)|0)+z|0)/(c|0)|0;y=((aa(v,B)|0)+z|0)/(c|0)|0;t=q-t>>2;u=x-b+(y-w)|0;b:do if((x|0)>(b|0))while(1){q=D+(b<<2)|0;if((s|0)==(k[A>>2]|0))Q4(qb,q);else{k[s>>2]=k[q>>2];k[Za>>2]=s+4}b=b+1|0;if((b|0)>=(x|0))break b;s=k[Za>>2]|0}while(0);if((y|0)>(w|0)){b=w;do{q=E+(b<<2)|0;s=k[Za>>2]|0;if((s|0)==(k[A>>2]|0))Q4(qb,q);else{k[s>>2]=k[q>>2];k[Za>>2]=s+4}b=b+1|0}while((b|0)<(y|0))}if((u|0)>0){q=k[qb>>2]|0;b=0;do{Ta=Epb(n|0,0,-130063606,0)|0;Ta=kpb(Ta|0,N|0,m|0,0)|0;n=N;m=Epb(Ta|0,0,-130063606,0)|0;n=kpb(m|0,N|0,n|0,0)|0;m=N;Ta=q+(((Ta>>>0)%(u>>>0)|0)+t<<2)|0;Va=q+(((n>>>0)%(u>>>0)|0)+t<<2)|0;Ua=k[Ta>>2]|0;k[Ta>>2]=k[Va>>2];k[Va>>2]=Ua;b=b+1|0}while((b|0)!=(u|0))}if((v|0)>=(c|0))break;q=k[Za>>2]|0;b=x;w=y;s=q;t=k[qb>>2]|0}m=k[hb>>2]|0}else m=E;n=m;if(m|0){if((F|0)!=(m|0))k[l>>2]=F+(~((F+-4-n|0)>>>2)<<2);ggb(m)}m=k[mb>>2]|0;n=m;if(m|0){if((G|0)!=(m|0))k[J>>2]=G+(~((G+-4-n|0)>>>2)<<2);ggb(m)}}sa=(c|0)/2|0;ta=(Xa+sa|0)/(c|0)|0;ua=Xa-ta|0;F=hb;q=kb;G=F+56|0;do{k[F>>2]=k[q>>2];F=F+4|0;q=q+4|0}while((F|0)<(G|0));va=hb+56|0;wa=a+64|0;k[va>>2]=k[wa>>2];Qa=hb+60|0;n=a+68|0;m=k[n>>2]|0;k[Qa>>2]=m;Sa=hb+64|0;k[Sa>>2]=k[a+72>>2];k[hb+68>>2]=k[a+76>>2];Na=hb+72|0;k[Na>>2]=k[a+80>>2];k[hb+76>>2]=k[a+84>>2];k[hb+80>>2]=k[a+88>>2];k[hb+84>>2]=k[a+92>>2];Ma=hb+88|0;k[Ma>>2]=k[a+96>>2];Oa=hb+92|0;b=k[a+100>>2]|0;k[Oa>>2]=b;Pa=hb+96|0;k[Pa>>2]=Sa;Sa=hb+104|0;Ra=hb+100|0;k[Ra>>2]=Sa;k[hb+108>>2]=0;k[Sa>>2]=0;if(b){m=b+12|0;k[m>>2]=(k[m>>2]|0)+1;m=k[n>>2]|0}if((m|0)>=3){k[Qa>>2]=0;x1(va,m,0,0,0);if((k[Qa>>2]|0)>0){n=k[a+104>>2]|0;b=k[Pa>>2]|0;q=k[a+108>>2]|0;s=k[Ra>>2]|0;m=0;do{k[b+(m<<2)>>2]=k[n+(m<<2)>>2];k[s+(m<<2)>>2]=k[q+(m<<2)>>2];m=m+1|0}while((m|0)<(k[Qa>>2]|0))}}else{Ua=k[a+108>>2]|0;Va=k[Ra>>2]|0;k[Va>>2]=k[Ua>>2];k[Va+4>>2]=k[Ua+4>>2]}ma=hb+112|0;na=a+120|0;k[ma>>2]=k[na>>2];k[ma+4>>2]=k[na+4>>2];k[ma+8>>2]=k[na+8>>2];k[ma+12>>2]=k[na+12>>2];q=k[xb>>2]&4095;n=k[L>>2]|0;k[pb>>2]=1124007936;Ka=pb+4|0;m=pb+8|0;Ia=pb+40|0;F=Ka;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[Ia>>2]=m;La=pb+48|0;Ja=pb+44|0;k[Ja>>2]=La;k[pb+52>>2]=0;k[La>>2]=0;k[mb>>2]=ua;b=mb+4|0;k[b>>2]=n;G1(pb,2,mb,5);n=k[L>>2]|0;k[ob>>2]=1124007936;Fa=ob+4|0;m=ob+8|0;Da=ob+40|0;F=Fa;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[Da>>2]=m;Ga=ob+48|0;Ea=ob+44|0;k[Ea>>2]=Ga;k[ob+52>>2]=0;k[Ga>>2]=0;k[mb>>2]=ta;k[b>>2]=n;G1(ob,2,mb,5);k[nb>>2]=1124007936;Aa=nb+4|0;m=nb+8|0;ya=nb+40|0;F=Aa;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[ya>>2]=m;Ba=nb+48|0;za=nb+44|0;k[za>>2]=Ba;k[nb+52>>2]=0;k[Ba>>2]=0;k[mb>>2]=ua;k[b>>2]=1;G1(nb,2,mb,q);k[mb>>2]=1124007936;qa=mb+4|0;m=mb+8|0;oa=mb+40|0;F=qa;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[oa>>2]=m;ra=mb+48|0;pa=mb+44|0;k[pa>>2]=ra;k[mb+52>>2]=0;k[ra>>2]=0;S=+p[d>>3];l=a+40|0;J=a+16|0;L=a+56|0;T=a+48|0;U=a+24|0;V=a+32|0;W=(c|0)>0;X=j+8|0;Y=(ua|0)>0;Ha=pb+16|0;Ua=Bb+16|0;Va=Bb+44|0;Ta=xb+16|0;Z=xb+12|0;xa=nb+16|0;_=nb+12|0;$=(ta|0)>0;Ca=ob+16|0;ba=ib+8|0;ca=ib+12|0;da=ib+4|0;ea=jb+4|0;fa=ea+4|0;la=mb+16|0;ga=mb+12|0;ha=h+8|0;ia=g+8|0;ja=f+8|0;ka=e+8|0;D=d+8|0;E=k[qb>>2]|0;I=3402823466385288598117041.0e14;H=S;while(1){p[l>>3]=H;if(!(H==S)?!(H<+p[D>>3]):0)break;R=+p[e>>3];H=R;while(1){p[J>>3]=H;if(!(H==R)?!(H<+p[ka>>3]):0)break;Q=+p[f>>3];H=Q;while(1){p[L>>3]=H;if(!(H==Q)?!(H<+p[ja>>3]):0)break;P=+p[g>>3];H=P;while(1){p[T>>3]=H;if(!(H==P)?!(H<+p[ia>>3]):0)break;O=+p[h>>3];H=O;while(1){p[U>>3]=H;if(!(H==O)?!(H<+p[ha>>3]):0)break;M=+p[j>>3];H=M;while(1){p[V>>3]=H;if(!(H==M)?!(H<+p[X>>3]):0)break;vFa(a);if(W){H=0.0;C=0;do{v=((aa(C,Xa)|0)+sa|0)/(c|0)|0;if(Y){u=0;do{t=k[E+(((u+v|0)%(Xa|0)|0)<<2)>>2]|0;d=(k[Ha>>2]|0)+(aa(k[k[Ja>>2]>>2]|0,u)|0)|0;upb(d|0,(k[Ua>>2]|0)+(aa(k[k[Va>>2]>>2]|0,t)|0)|0,Wa|0)|0;do if(Ya){do if(!(k[xb>>2]&16384)){m=k[wb>>2]|0;if((k[m>>2]|0)==1){lb=209;break}n=k[Ta>>2]|0;b=k[zb>>2]|0;if((k[m+4>>2]|0)==1){m=n+(aa(k[b>>2]|0,t)|0)|0;break}else{m=k[Z>>2]|0;d=(t|0)/(m|0)|0;m=t-(aa(d,m)|0)|0;m=n+(aa(k[b>>2]|0,d)|0)+(m<<2)|0;break}}else lb=209;while(0);if((lb|0)==209){lb=0;m=(k[Ta>>2]|0)+(t<<2)|0}q=k[m>>2]|0;do if(!(k[nb>>2]&16384)){m=k[ya>>2]|0;if((k[m>>2]|0)==1){lb=215;break}n=k[xa>>2]|0;b=k[za>>2]|0;if((k[m+4>>2]|0)==1){m=n+(aa(k[b>>2]|0,u)|0)|0;break}else{m=k[_>>2]|0;d=(u|0)/(m|0)|0;m=u-(aa(d,m)|0)|0;m=n+(aa(k[b>>2]|0,d)|0)+(m<<2)|0;break}}else lb=215;while(0);if((lb|0)==215){lb=0;m=(k[xa>>2]|0)+(u<<2)|0}k[m>>2]=q}else{s=k[Ta>>2]|0;if(!s)break;b=k[yb>>2]|0;if((b|0)<3)m=aa(k[Z>>2]|0,k[ab>>2]|0)|0;else{q=k[wb>>2]|0;n=0;m=1;do{m=aa(k[q+(n<<2)>>2]|0,m)|0;n=n+1|0}while((n|0)!=(b|0))}if(!m)break;do if(!(k[xb>>2]&16384)){m=k[wb>>2]|0;if((k[m>>2]|0)==1){lb=228;break}n=k[zb>>2]|0;if((k[m+4>>2]|0)==1){m=s+(aa(k[n>>2]|0,t)|0)|0;break}else{m=k[Z>>2]|0;d=(t|0)/(m|0)|0;m=t-(aa(d,m)|0)|0;m=s+(aa(k[n>>2]|0,d)|0)+(m<<2)|0;break}}else lb=228;while(0);if((lb|0)==228){lb=0;m=s+(t<<2)|0}q=k[m>>2]|0;do if(!(k[nb>>2]&16384)){m=k[ya>>2]|0;if((k[m>>2]|0)==1){lb=234;break}n=k[xa>>2]|0;b=k[za>>2]|0;if((k[m+4>>2]|0)==1){m=n+(aa(k[b>>2]|0,u)|0)|0;break}else{m=k[_>>2]|0;d=(u|0)/(m|0)|0;m=u-(aa(d,m)|0)|0;m=n+(aa(k[b>>2]|0,d)|0)+(m<<2)|0;break}}else lb=234;while(0);if((lb|0)==234){lb=0;m=(k[xa>>2]|0)+(u<<2)|0}k[m>>2]=q}while(0);u=u+1|0}while((u|0)!=(ua|0))}c:do if(mGa(a,pb,nb)|0){if($){n=v+ua|0;m=0;do{d=(k[Ca>>2]|0)+(aa(k[k[Ea>>2]>>2]|0,m)|0)|0;upb(d|0,(k[Ua>>2]|0)+(aa(k[k[Va>>2]>>2]|0,k[E+(((n+m|0)%(Xa|0)|0)<<2)>>2]|0)|0)|0,Wa|0)|0;m=m+1|0}while((m|0)!=(ta|0))}d=k[(k[a>>2]|0)+56>>2]|0;k[ba>>2]=0;k[ca>>2]=0;k[ib>>2]=16842752;k[da>>2]=ob;G=fa;k[G>>2]=0;k[G+4>>2]=0;k[jb>>2]=33619968;k[ea>>2]=mb;+wh[d&31](a,ib,jb,0);if(!$)break;m=k[oa>>2]|0;q=m+4|0;B=k[la>>2]|0;s=k[pa>>2]|0;t=k[ga>>2]|0;u=v+ua|0;v=(k[xb>>2]&16384|0)==0;w=k[wb>>2]|0;x=w+4|0;y=k[Ta>>2]|0;z=k[zb>>2]|0;A=k[Z>>2]|0;if(k[mb>>2]&16384|0){n=0;while(1){K=+o[B+(n<<2)>>2];m=k[E+(((u+n|0)%(Xa|0)|0)<<2)>>2]|0;if(Ya){do if(v){if((k[w>>2]|0)==1){lb=271;break}if((k[x>>2]|0)==1){m=y+(aa(k[z>>2]|0,m)|0)|0;break}else{d=(m|0)/(A|0)|0;m=m-(aa(d,A)|0)|0;m=y+(aa(k[z>>2]|0,d)|0)+(m<<2)|0;break}}else lb=271;while(0);if((lb|0)==271){lb=0;m=y+(m<<2)|0}K=+(K!=+(k[m>>2]|0)&1)}else{do if(v){if((k[w>>2]|0)==1){lb=278;break}if((k[x>>2]|0)==1){m=y+(aa(k[z>>2]|0,m)|0)|0;break}else{d=(m|0)/(A|0)|0;m=m-(aa(d,A)|0)|0;m=y+(aa(k[z>>2]|0,d)|0)+(m<<2)|0;break}}else lb=278;while(0);if((lb|0)==278){lb=0;m=y+(m<<2)|0}K=K-+o[m>>2];K=K*K}H=H+K;n=n+1|0;if((n|0)==(ta|0))break c}}b=(k[m>>2]|0)==1;n=0;do{do if(!b)if((k[q>>2]|0)==1){m=B+(aa(k[s>>2]|0,n)|0)|0;break}else{d=(n|0)/(t|0)|0;m=n-(aa(d,t)|0)|0;m=B+(aa(k[s>>2]|0,d)|0)+(m<<2)|0;break}else m=B+(n<<2)|0;while(0);K=+o[m>>2];m=k[E+(((u+n|0)%(Xa|0)|0)<<2)>>2]|0;if(Ya){do if(v){if((k[w>>2]|0)==1){lb=265;break}if((k[x>>2]|0)==1){m=y+(aa(k[z>>2]|0,m)|0)|0;break}else{d=(m|0)/(A|0)|0;m=m-(aa(d,A)|0)|0;m=y+(aa(k[z>>2]|0,d)|0)+(m<<2)|0;break}}else lb=265;while(0);if((lb|0)==265){lb=0;m=y+(m<<2)|0}K=+(K!=+(k[m>>2]|0)&1)}else{do if(v){if((k[w>>2]|0)==1){lb=258;break}if((k[x>>2]|0)==1){m=y+(aa(k[z>>2]|0,m)|0)|0;break}else{d=(m|0)/(A|0)|0;m=m-(aa(d,A)|0)|0;m=y+(aa(k[z>>2]|0,d)|0)+(m<<2)|0;break}}else lb=258;while(0);if((lb|0)==258){lb=0;m=y+(m<<2)|0}K=K-+o[m>>2];K=K*K}H=H+K;n=n+1|0}while((n|0)!=(ta|0))}while(0);C=C+1|0}while((C|0)<(c|0))}else H=0.0;if(I>H){F=hb;q=kb;G=F+56|0;do{k[F>>2]=k[q>>2];F=F+4|0;q=q+4|0}while((F|0)<(G|0));KG(va,wa)|0;k[ma>>2]=k[na>>2];k[ma+4>>2]=k[na+4>>2];k[ma+8>>2]=k[na+8>>2];k[ma+12>>2]=k[na+12>>2];I=H}H=+p[X>>3];if(M==H){H=H+1.0;continue}else{H=+p[V>>3]*+p[gb>>3];continue}}H=+p[ha>>3];if(O==H){H=H+1.0;continue}else{H=+p[U>>3]*+p[fb>>3];continue}}H=+p[ia>>3];if(P==H){H=H+1.0;continue}else{H=+p[T>>3]*+p[eb>>3];continue}}H=+p[ja>>3];if(Q==H){H=H+1.0;continue}else{H=+p[L>>3]*+p[db>>3];continue}}H=+p[ka>>3];if(R==H){H=H+1.0;continue}else{H=+p[J>>3]*+p[cb>>3];continue}}H=+p[D>>3];if(S==H){H=H+1.0;continue}else{H=+p[l>>3]*+p[bb>>3];continue}}KG($a,vb)|0;F=kb;q=hb;G=F+56|0;do{k[F>>2]=k[q>>2];F=F+4|0;q=q+4|0}while((F|0)<(G|0));KG(wa,va)|0;k[na>>2]=k[ma>>2];k[na+4>>2]=k[ma+4>>2];k[na+8>>2]=k[ma+8>>2];k[na+12>>2]=k[ma+12>>2];vFa(a);q=mGa(a,Bb,xb)|0;b=mb+36|0;m=k[b>>2]|0;if(m|0?(j=m+12|0,lb=k[j>>2]|0,k[j>>2]=lb+-1,(lb|0)==1):0){n=k[b>>2]|0;if(n|0){m=k[n+4>>2]|0;do if(!m){m=k[mb+32>>2]|0;if(m|0)break;m=B1()|0;n=k[b>>2]|0}while(0);jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[b>>2]=0}k[b>>2]=0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[qa>>2]|0)>0){n=k[oa>>2]|0;m=0;do{k[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[qa>>2]|0))}m=k[pa>>2]|0;if(!((m|0)==(ra|0)|(m|0)==0))ggb(k[m+-4>>2]|0);b=nb+36|0;m=k[b>>2]|0;do if(m|0){lb=m+12|0;mb=k[lb>>2]|0;k[lb>>2]=mb+-1;if((mb|0)!=1)break;n=k[b>>2]|0;if(n|0){m=k[n+4>>2]|0;do if(!m){m=k[nb+32>>2]|0;if(m|0)break;m=B1()|0;n=k[b>>2]|0}while(0);jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[b>>2]=0}while(0);k[b>>2]=0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[Aa>>2]|0)>0){n=k[ya>>2]|0;m=0;do{k[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[Aa>>2]|0))}m=k[za>>2]|0;if(!((m|0)==(Ba|0)|(m|0)==0))ggb(k[m+-4>>2]|0);b=ob+36|0;m=k[b>>2]|0;do if(m|0){mb=m+12|0;nb=k[mb>>2]|0;k[mb>>2]=nb+-1;if((nb|0)!=1)break;n=k[b>>2]|0;if(n|0){m=k[n+4>>2]|0;do if(!m){m=k[ob+32>>2]|0;if(m|0)break;m=B1()|0;n=k[b>>2]|0}while(0);jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[b>>2]=0}while(0);k[b>>2]=0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[Fa>>2]|0)>0){n=k[Da>>2]|0;m=0;do{k[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[Fa>>2]|0))}m=k[Ea>>2]|0;if(!((m|0)==(Ga|0)|(m|0)==0))ggb(k[m+-4>>2]|0);b=pb+36|0;m=k[b>>2]|0;do if(m|0){nb=m+12|0;ob=k[nb>>2]|0;k[nb>>2]=ob+-1;if((ob|0)!=1)break;n=k[b>>2]|0;if(n|0){m=k[n+4>>2]|0;do if(!m){m=k[pb+32>>2]|0;if(m|0)break;m=B1()|0;n=k[b>>2]|0}while(0);jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[b>>2]=0}while(0);k[b>>2]=0;k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ha+8>>2]=0;k[Ha+12>>2]=0;if((k[Ka>>2]|0)>0){n=k[Ia>>2]|0;m=0;do{k[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[Ka>>2]|0))}m=k[Ja>>2]|0;if(!((m|0)==(La|0)|(m|0)==0))ggb(k[m+-4>>2]|0);m=k[Oa>>2]|0;do if(m|0){ob=m+12|0;pb=k[ob>>2]|0;k[ob>>2]=pb+-1;if((pb|0)!=1)break;n=k[Oa>>2]|0;if(n|0){m=k[n+4>>2]|0;do if(!m){m=k[Ma>>2]|0;if(m|0)break;m=B1()|0;n=k[Oa>>2]|0}while(0);jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[Oa>>2]=0}while(0);k[Oa>>2]=0;k[Na>>2]=0;k[Na+4>>2]=0;k[Na+8>>2]=0;k[Na+12>>2]=0;if((k[Qa>>2]|0)>0){n=k[Pa>>2]|0;m=0;do{k[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[Qa>>2]|0))}m=k[Ra>>2]|0;if(!((m|0)==(Sa|0)|(m|0)==0))ggb(k[m+-4>>2]|0);m=k[qb>>2]|0;n=m;if(m|0){b=k[Za>>2]|0;if((b|0)!=(m|0))k[Za>>2]=b+(~((b+-4-n|0)>>>2)<<2);ggb(m)}b=vb+36|0;m=k[b>>2]|0;do if(m|0){pb=m+12|0;qb=k[pb>>2]|0;k[pb>>2]=qb+-1;if((qb|0)!=1)break;n=k[b>>2]|0;if(n|0){m=k[n+4>>2]|0;do if(!m){m=k[vb+32>>2]|0;if(m|0)break;m=B1()|0;n=k[b>>2]|0}while(0);jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[b>>2]=0}while(0);k[b>>2]=0;vb=vb+16|0;k[vb>>2]=0;k[vb+4>>2]=0;k[vb+8>>2]=0;k[vb+12>>2]=0;if((k[tb>>2]|0)>0){n=k[rb>>2]|0;m=0;do{k[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[tb>>2]|0))}m=k[sb>>2]|0;if(!((m|0)==(ub|0)|(m|0)==0))ggb(k[m+-4>>2]|0);b=xb+36|0;m=k[b>>2]|0;do if(m|0){ub=m+12|0;vb=k[ub>>2]|0;k[ub>>2]=vb+-1;if((vb|0)!=1)break;n=k[b>>2]|0;if(n|0){m=k[n+4>>2]|0;do if(!m){m=k[xb+32>>2]|0;if(m|0)break;m=B1()|0;n=k[b>>2]|0}while(0);jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[b>>2]=0}while(0);k[b>>2]=0;k[Ta>>2]=0;k[Ta+4>>2]=0;k[Ta+8>>2]=0;k[Ta+12>>2]=0;if((k[yb>>2]|0)>0){n=k[wb>>2]|0;m=0;do{k[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[yb>>2]|0))}m=k[zb>>2]|0;if(!((m|0)==(Ab|0)|(m|0)==0))ggb(k[m+-4>>2]|0);b=Bb+36|0;m=k[b>>2]|0;do if(m|0){zb=m+12|0;Ab=k[zb>>2]|0;k[zb>>2]=Ab+-1;if((Ab|0)!=1)break;n=k[b>>2]|0;if(n|0){m=k[n+4>>2]|0;do if(!m){m=k[Bb+32>>2]|0;if(m|0)break;m=B1()|0;n=k[b>>2]|0}while(0);jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[b>>2]=0}while(0);k[b>>2]=0;k[Ua>>2]=0;k[Ua+4>>2]=0;k[Ua+8>>2]=0;k[Ua+12>>2]=0;if((k[_a>>2]|0)>0){n=k[Bb+40>>2]|0;m=0;do{k[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[_a>>2]|0))}m=k[Va>>2]|0;if(!((m|0)==(Bb+48|0)|(m|0)==0))ggb(k[m+-4>>2]|0);Bb=q;r=Cb;return Bb|0}function jGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+196>>2];i=a+4|0;e=b+200|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+204>>2];k[a+12>>2]=k[b+208>>2];k[a+16>>2]=k[b+212>>2];k[a+20>>2]=k[b+216>>2];k[a+24>>2]=k[b+220>>2];k[a+28>>2]=k[b+224>>2];k[a+32>>2]=k[b+228>>2];d=k[b+232>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+240>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+236>>2]|0;a=k[g>>2]|0;e=k[b+240>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function kGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;E=r;r=r+128|0;B=E+112|0;w=E+56|0;C=E;if((b|0)>-1?(f=k[a+312>>2]|0,e=k[a+308>>2]|0,(f-e>>4|0)>(b|0)):0){D=e;e=f}else{e=B+4|0;f=ZT(44)|0;k[f>>2]=1;h=f+4|0;k[B>>2]=h;k[e>>2]=39;i[f+43>>0]=0;u=368826;v=h+39|0;do{i[h>>0]=i[u>>0]|0;h=h+1|0;u=u+1|0}while((h|0)<(v|0));Y8(-215,B,368866,368204,1953);k[e>>2]=0;k[B>>2]=0;D=k[f>>2]|0;k[f>>2]=D+-1;if((D|0)==1)ggb(k[f+-4>>2]|0);D=k[a+308>>2]|0;e=k[a+312>>2]|0}if(((e-D>>4)+-1|0)>(b|0))e=k[D+(b+1<<4)+8>>2]|0;else e=(k[a+336>>2]|0)-(k[a+332>>2]|0)>>2;y=D+(b<<4)+8|0;s=k[y>>2]|0;z=e-s|0;e=(k[a+320>>2]|0)+(s<<3)|0;k[w>>2]=1124007942;s=w+4|0;k[s>>2]=2;l=w+8|0;k[l>>2]=1;g=w+12|0;k[g>>2]=z;o=w+16|0;k[o>>2]=e;j=w+20|0;k[j>>2]=e;m=w+24|0;n=w+28|0;q=w+40|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[q>>2]=l;x=w+48|0;t=w+44|0;k[t>>2]=x;k[w+52>>2]=0;k[x>>2]=0;A=(z|0)!=0;if(A&(e|0)==0){e=B+4|0;f=ZT(36)|0;k[f>>2]=1;h=f+4|0;k[B>>2]=h;k[e>>2]=28;i[f+32>>0]=0;u=390609;v=h+28|0;do{i[h>>0]=i[u>>0]|0;h=h+1|0;u=u+1|0}while((h|0)<(v|0));Y8(-215,B,390638,390642,410);k[e>>2]=0;k[B>>2]=0;v=k[f>>2]|0;k[f>>2]=v+-1;if((v|0)==1)ggb(k[f+-4>>2]|0);f=k[g>>2]|0;g=k[w>>2]|0;h=k[t>>2]|0;e=k[j>>2]|0}else{f=z;g=1124007942;h=x}v=f<<3;k[w>>2]=g|16384;k[h>>2]=v;k[h+4>>2]=8;g=e+(aa(k[l>>2]|0,v)|0)|0;k[n>>2]=g;k[m>>2]=g+(0-v)+v;mY(w,c);g=w+36|0;e=k[g>>2]|0;if(e|0?(u=e+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[w+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[s>>2]|0)>0){f=k[q>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[s>>2]|0))}e=k[t>>2]|0;if(!((e|0)==(x|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=(k[a+332>>2]|0)+(k[y>>2]<<2)|0;k[C>>2]=1124007940;q=C+4|0;k[q>>2]=2;l=C+8|0;k[l>>2]=1;g=C+12|0;k[g>>2]=z;c=C+16|0;k[c>>2]=e;j=C+20|0;k[j>>2]=e;m=C+24|0;n=C+28|0;o=C+40|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[o>>2]=l;t=C+48|0;s=C+44|0;k[s>>2]=t;k[C+52>>2]=0;k[t>>2]=0;if(A&(e|0)==0){e=B+4|0;f=ZT(36)|0;k[f>>2]=1;h=f+4|0;k[B>>2]=h;k[e>>2]=28;i[f+32>>0]=0;u=390609;v=h+28|0;do{i[h>>0]=i[u>>0]|0;h=h+1|0;u=u+1|0}while((h|0)<(v|0));Y8(-215,B,390638,390642,410);k[e>>2]=0;k[B>>2]=0;B=k[f>>2]|0;k[f>>2]=B+-1;if((B|0)==1)ggb(k[f+-4>>2]|0);f=k[g>>2]|0;g=k[C>>2]|16384;h=k[s>>2]|0;e=k[j>>2]|0}else{f=z;g=1124024324;h=t}B=f<<2;k[C>>2]=g;k[h>>2]=B;k[h+4>>2]=4;g=e+(aa(k[l>>2]|0,B)|0)|0;k[n>>2]=g;k[m>>2]=g+(0-B)+B;mY(C,d);g=C+36|0;e=k[g>>2]|0;if(e|0?(B=e+12|0,d=k[B>>2]|0,k[B>>2]=d+-1,(d|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[C+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[q>>2]|0)>0){f=k[o>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[q>>2]|0))}e=k[s>>2]|0;if((e|0)==(t|0)|(e|0)==0){b=D+(b<<4)|0;F=+p[b>>3];r=E;return +F}ggb(k[e+-4>>2]|0);b=D+(b<<4)|0;F=+p[b>>3];r=E;return +F}function lGa(a){a=a|0;var b=0.0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;h=j;b=+p[a>>3];if(b>+p[a+8>>3]){c=h+4|0;d=ZT(60)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=55;i[d+59>>0]=0;f=369495;g=e+55|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-5,h,369551,368204,98);k[c>>2]=0;k[h>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0);b=+p[a>>3]}if(b<2.220446049250313e-16){c=h+4|0;d=ZT(48)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=40;i[d+44>>0]=0;f=369566;g=e+40|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-5,h,369551,368204,100);k[c>>2]=0;k[h>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0)}if(!(+p[a+16>>3]<1.0000001192092896)){r=j;return}c=h+4|0;d=ZT(36)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=29;i[d+33>>0]=0;f=369607;g=e+29|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-5,h,369551,368204,102);k[c>>2]=0;k[h>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);r=j;return}function mGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0.0,m=0.0,n=0,q=0,s=0.0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0.0;Oa=r;r=r+1184|0;Ha=Oa+904|0;Ea=Oa+480|0;Ka=Oa+56|0;La=Oa+1108|0;Fa=Oa+16|0;Ja=Oa+1096|0;T=Oa+1120|0;Ia=Oa+1040|0;Aa=Oa+984|0;ua=Oa+972|0;ta=Oa+960|0;la=Oa;ma=a+8|0;n=k[ma>>2]|0;I=b+8|0;Ga=k[I>>2]|0;k[La>>2]=0;Na=La+4|0;k[Na>>2]=0;k[La+8>>2]=0;D=Fa;F=D+40|0;do{k[D>>2]=0;D=D+4|0}while((D|0)<(F|0));if((k[b>>2]&4095|0)!=5){k[Ha>>2]=0;d=Ha+4|0;k[d>>2]=0;e=ZT(32)|0;k[e>>2]=1;D=e+4|0;k[Ha>>2]=D;k[d>>2]=25;i[e+29>>0]=0;E=368933;F=D+25|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,Ha,368959,368204,1370);k[d>>2]=0;k[Ha>>2]=0;Da=k[e>>2]|0;k[e>>2]=Da+-1;if((Da|0)==1)ggb(k[e+-4>>2]|0)}Da=b+12|0;k[a+192>>2]=k[Da>>2];if((n+-102|0)>>>0<3){Q=a+308|0;d=k[Q>>2]|0;R=a+312|0;e=k[R>>2]|0;if((e|0)!=(d|0))k[R>>2]=e+(~((e+-16-d|0)>>>4)<<4);k[Ja>>2]=0;S=Ja+4|0;k[S>>2]=0;k[Ja+8>>2]=0;if(k[c+16>>2]|0){f=k[c+4>>2]|0;if((f|0)<3)d=aa(k[c+12>>2]|0,k[c+8>>2]|0)|0;else{g=k[c+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}if(d|0){Ca=Ha+4|0;Ba=Ca+4|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ha>>2]=-2113732603;k[Ca>>2]=Ja;SW(c,Ha,5,1.0,0.0)}}switch(n|0){case 102:{j=+p[a+48>>3];v=a+344|0;q=a+120|0;q=l[q>>0]|l[q+1>>0]<<8|l[q+2>>0]<<16|l[q+3>>0]<<24;t=a+124|0;t=l[t>>0]|l[t+1>>0]<<8|l[t+2>>0]<<16|l[t+3>>0]<<24;n=a+128|0;i[u>>0]=i[n>>0];i[u+1>>0]=i[n+1>>0];i[u+2>>0]=i[n+2>>0];i[u+3>>0]=i[n+3>>0];i[u+4>>0]=i[n+4>>0];i[u+5>>0]=i[n+5>>0];i[u+6>>0]=i[n+6>>0];i[u+7>>0]=i[n+7>>0];s=+p[u>>3];n=k[I>>2]|0;k[Ha>>2]=0;w=Ha+4|0;k[w>>2]=0;k[Ha+8>>2]=0;f=(n|0)==0;if(!f){if((n|0)<0)ad(426534,426557,304,426811);while(1){d=fgb(n)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[w>>2]=d;k[Ha>>2]=d;k[Ha+8>>2]=d+n;e=n;do{i[d>>0]=1;d=(k[w>>2]|0)+1|0;k[w>>2]=d;e=e+-1|0}while((e|0)!=0)}k[Ea>>2]=0;h=Ea+4|0;k[h>>2]=0;k[Ea+8>>2]=0;if(!f){if(n>>>0>536870911)ad(426534,426557,304,426811);e=n<<3;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[h>>2]=d;k[Ea>>2]=d;f=d+(n<<3)|0;k[Ea+8>>2]=f;e=n;while(1){p[d>>3]=0.0;e=e+-1|0;if(!e)break;else d=d+8|0}k[h>>2]=f}m=+(n|0)*j;p[u>>3]=m;d=k[u+4>>2]|0;Ca=d&2146435072;if(!(Ca>>>0>1126170624|(Ca|0)==1126170624&0>0)){d=(d|0)<0;j=d?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=d?-0.0:0.0}else j=m;g=~~j;f=k[Na>>2]|0;e=k[La>>2]|0;d=f-e>>3;if(n>>>0<=d>>>0){if(n>>>0<d>>>0?(y=e+(n<<3)|0,(f|0)!=(y|0)):0)k[Na>>2]=f+(~((f+-8-y|0)>>>3)<<3)}else Bla(La,n-d|0);if((n|0)>0){e=k[La>>2]|0;d=0;do{p[e+(d<<3)>>3]=+((d|0)<(g|0)&1);d=d+1|0}while((d|0)!=(n|0))}d=k[La>>2]|0;if((g|0)<(n|0))p[d+(g<<3)>>3]=m-+(g|0);else{Ca=g+-1|0;p[d+(Ca<<3)>>3]=m-+(Ca|0)}uGa(Ka,b,Ha,La,Ea,1.0,1.0,v,68,0,146,0,348,0,q,t,s);g=vGa(Ka,Fa)|0;wGa(Ka);d=k[Ea>>2]|0;e=d;if(d|0){f=k[h>>2]|0;if((f|0)!=(d|0))k[h>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(d)}d=k[Ha>>2]|0;if(d|0){if((k[w>>2]|0)!=(d|0))k[w>>2]=d;ggb(d)}if(g)Ma=128;else g=1;break}case 103:{j=+p[a+56>>3];s=+p[a+40>>3];t=a+344|0;n=a+120|0;n=l[n>>0]|l[n+1>>0]<<8|l[n+2>>0]<<16|l[n+3>>0]<<24;q=a+124|0;q=l[q>>0]|l[q+1>>0]<<8|l[q+2>>0]<<16|l[q+3>>0]<<24;v=a+128|0;i[u>>0]=i[v>>0];i[u+1>>0]=i[v+1>>0];i[u+2>>0]=i[v+2>>0];i[u+3>>0]=i[v+3>>0];i[u+4>>0]=i[v+4>>0];i[u+5>>0]=i[v+5>>0];i[u+6>>0]=i[v+6>>0];i[u+7>>0]=i[v+7>>0];m=+p[u>>3];v=k[I>>2]|0;g=v<<1;if(((k[S>>2]|0)-(k[Ja>>2]|0)>>2|0)!=(v|0)){k[Ha>>2]=0;d=Ha+4|0;k[d>>2]=0;e=ZT(36)|0;k[e>>2]=1;D=e+4|0;k[Ha>>2]=D;k[d>>2]=31;i[e+35>>0]=0;E=369436;F=D+31|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,Ha,369481,368204,1122);k[d>>2]=0;k[Ha>>2]=0;Ca=k[e>>2]|0;k[e>>2]=Ca+-1;if((Ca|0)==1)ggb(k[e+-4>>2]|0)}p[Ha>>3]=0.0;Zza(La,g,Ha);k[Ha>>2]=0;w=Ha+4|0;k[w>>2]=0;k[Ha+8>>2]=0;f=(v|0)==0;if(!f){if((v|0)<0)ad(426534,426557,304,426811);while(1){d=fgb(g)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[w>>2]=d;k[Ha>>2]=d;k[Ha+8>>2]=d+g;e=g;do{i[d>>0]=0;d=(k[w>>2]|0)+1|0;k[w>>2]=d;e=e+-1|0}while((e|0)!=0)}k[Ea>>2]=0;h=Ea+4|0;k[h>>2]=0;k[Ea+8>>2]=0;if(!f){if(g>>>0>536870911)ad(426534,426557,304,426811);f=v<<4;e=(f|0)==0?1:f;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[Ea>>2]=d;Ca=d+(g<<3)|0;k[Ea+8>>2]=Ca;zpb(d|0,0,f|0)|0;k[h>>2]=Ca;if((v|0)>0){d=0;do{p[(k[Ea>>2]|0)+(d<<3)>>3]=j-+o[(k[Ja>>2]|0)+(d<<2)>>2];i[(k[Ha>>2]|0)+d>>0]=1;Ca=d+v|0;p[(k[Ea>>2]|0)+(Ca<<3)>>3]=+o[(k[Ja>>2]|0)+(d<<2)>>2]+j;i[(k[Ha>>2]|0)+Ca>>0]=-1;d=d+1|0}while((d|0)!=(v|0));e=1}else e=0}else e=0;uGa(Ka,b,Ha,La,Ea,s,s,t,69,0,146,0,348,0,n,q,m);d=vGa(Ka,Fa)|0;if(d&e){e=k[La>>2]|0;d=0;do{Ca=e+(d<<3)|0;p[Ca>>3]=+p[Ca>>3]-+p[e+(d+v<<3)>>3];d=d+1|0}while((d|0)!=(v|0));g=1}else g=d;wGa(Ka);d=k[Ea>>2]|0;e=d;if(d|0){f=k[h>>2]|0;if((f|0)!=(d|0))k[h>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(d)}d=k[Ha>>2]|0;if(d|0){if((k[w>>2]|0)!=(d|0))k[w>>2]=d;ggb(d)}if(g)Ma=128;else g=1;break}case 104:{j=+p[a+48>>3];s=+p[a+40>>3];v=a+344|0;q=a+120|0;q=l[q>>0]|l[q+1>>0]<<8|l[q+2>>0]<<16|l[q+3>>0]<<24;t=a+124|0;t=l[t>>0]|l[t+1>>0]<<8|l[t+2>>0]<<16|l[t+3>>0]<<24;w=a+128|0;i[u>>0]=i[w>>0];i[u+1>>0]=i[w+1>>0];i[u+2>>0]=i[w+2>>0];i[u+3>>0]=i[w+3>>0];i[u+4>>0]=i[w+4>>0];i[u+5>>0]=i[w+5>>0];i[u+6>>0]=i[w+6>>0];i[u+7>>0]=i[w+7>>0];x=+p[u>>3];w=k[I>>2]|0;g=w<<1;j=j*s*+(w|0)*.5;if(((k[S>>2]|0)-(k[Ja>>2]|0)>>2|0)!=(w|0)){k[Ha>>2]=0;d=Ha+4|0;k[d>>2]=0;e=ZT(36)|0;k[e>>2]=1;D=e+4|0;k[Ha>>2]=D;k[d>>2]=31;i[e+35>>0]=0;E=369436;F=D+31|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,Ha,369468,368204,1162);k[d>>2]=0;k[Ha>>2]=0;Ca=k[e>>2]|0;k[e>>2]=Ca+-1;if((Ca|0)==1)ggb(k[e+-4>>2]|0)}f=k[Na>>2]|0;e=k[La>>2]|0;d=f-e>>3;if(g>>>0<=d>>>0){if(g>>>0<d>>>0?(h=e+(g<<3)|0,(f|0)!=(h|0)):0)k[Na>>2]=f+(~((f+-8-h|0)>>>3)<<3)}else Bla(La,g-d|0);k[Ha>>2]=0;n=Ha+4|0;k[n>>2]=0;k[Ha+8>>2]=0;f=(w|0)==0;if(!f){if((w|0)<0)ad(426534,426557,304,426811);while(1){d=fgb(g)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[n>>2]=d;k[Ha>>2]=d;k[Ha+8>>2]=d+g;e=g;do{i[d>>0]=0;d=(k[n>>2]|0)+1|0;k[n>>2]=d;e=e+-1|0}while((e|0)!=0)}k[Ea>>2]=0;h=Ea+4|0;k[h>>2]=0;k[Ea+8>>2]=0;if(!f){if(g>>>0>536870911)ad(426534,426557,304,426811);f=w<<4;e=(f|0)==0?1:f;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[Ea>>2]=d;Ca=d+(g<<3)|0;k[Ea+8>>2]=Ca;zpb(d|0,0,f|0)|0;k[h>>2]=Ca;if((w|0)>0){d=0;while(1){m=j>s?s:j;Ca=d+w|0;Ba=k[La>>2]|0;p[Ba+(Ca<<3)>>3]=m;p[Ba+(d<<3)>>3]=m;p[(k[Ea>>2]|0)+(d<<3)>>3]=-+o[(k[Ja>>2]|0)+(d<<2)>>2];i[(k[Ha>>2]|0)+d>>0]=1;p[(k[Ea>>2]|0)+(Ca<<3)>>3]=+o[(k[Ja>>2]|0)+(d<<2)>>2];i[(k[Ha>>2]|0)+Ca>>0]=-1;d=d+1|0;if((d|0)==(w|0)){e=1;break}else j=j-m}}else e=0}else e=0;uGa(Ka,b,Ha,La,Ea,1.0,1.0,v,69,0,147,0,349,0,q,t,x);d=vGa(Ka,Fa)|0;if(d&e){e=k[La>>2]|0;d=0;do{Ca=e+(d<<3)|0;p[Ca>>3]=+p[Ca>>3]-+p[e+(d+w<<3)>>3];d=d+1|0}while((d|0)!=(w|0));g=1}else g=d;wGa(Ka);d=k[Ea>>2]|0;e=d;if(d|0){f=k[h>>2]|0;if((f|0)!=(d|0))k[h>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(d)}d=k[Ha>>2]|0;if(d|0){if((k[n>>2]|0)!=(d|0))k[n>>2]=d;ggb(d)}if(g)Ma=128;else g=1;break}default:g=1}if((Ma|0)==128){n=(Ga|0)>0;if(n){f=k[La>>2]|0;d=0;e=0;do{x=+p[f+(d<<3)>>3];e=(x==x&0.0==0.0&x!=0.0&1)+e|0;d=d+1|0}while((d|0)!=(Ga|0));if(!e)Ma=132}else Ma=132;if((Ma|0)==132){k[Ha>>2]=0;d=Ha+4|0;k[d>>2]=0;e=ZT(20)|0;k[e>>2]=1;D=e+4|0;k[Ha>>2]=D;k[d>>2]=13;i[e+17>>0]=0;E=368968;F=D+13|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,Ha,368959,368204,1393);k[d>>2]=0;k[Ha>>2]=0;Ca=k[e>>2]|0;k[e>>2]=Ca+-1;if((Ca|0)==1)ggb(k[e+-4>>2]|0);e=0}P=a+196|0;d=k[Da>>2]|0;if(!(((((k[a+200>>2]|0)<3?(k[a+204>>2]|0)==(e|0):0)?(k[a+208>>2]|0)==(d|0):0)?(k[P>>2]&4095|0)==5:0)?(k[a+212>>2]|0)!=0:0)){k[Ha>>2]=e;k[Ha+4>>2]=d;G1(P,2,Ha,5)}O=a+320|0;d=a+324|0;h=k[d>>2]|0;g=k[O>>2]|0;f=h-g>>3;if(e>>>0<=f>>>0){if(e>>>0<f>>>0?(z=g+(e<<3)|0,(h|0)!=(z|0)):0)k[d>>2]=h+(~((h+-8-z|0)>>>3)<<3)}else Bla(O,e-f|0);N=a+332|0;d=a+336|0;h=k[d>>2]|0;g=k[N>>2]|0;f=h-g>>2;if(e>>>0<=f>>>0){if(e>>>0<f>>>0?(A=g+(e<<2)|0,(h|0)!=(A|0)):0)k[d>>2]=h+(~((h+-4-A|0)>>>2)<<2)}else U1(N,e-f|0);if(n){q=Ha+4|0;t=Ea+4|0;v=Ha+4|0;w=Ea+4|0;y=Ka+4|0;z=y+4|0;A=Ia+36|0;B=Ia+16|0;C=Ia+4|0;D=Ia+40|0;E=Ia+44|0;F=Ia+48|0;G=T+36|0;H=T+16|0;c=T+4|0;I=T+40|0;J=T+44|0;K=T+48|0;L=T+32|0;M=Ia+32|0;f=0;d=0;e=k[La>>2]|0;do{x=+p[e+(d<<3)>>3];if(x!=x|0.0!=0.0|x==0.0)d=d+1|0;else{n=d+1|0;k[Ha>>2]=d;k[q>>2]=n;k[Ea>>2]=-2147483648;k[t>>2]=2147483647;H1(T,b,Ha,Ea);h=f+1|0;k[Ha>>2]=f;k[v>>2]=h;k[Ea>>2]=-2147483648;k[w>>2]=2147483647;H1(Ia,P,Ha,Ea);e=z;k[e>>2]=0;k[e+4>>2]=0;k[Ka>>2]=-1040121856;k[y>>2]=Ia;mY(T,Ka);e=k[A>>2]|0;if(e|0?(Ca=e+12|0,Da=k[Ca>>2]|0,k[Ca>>2]=Da+-1,(Da|0)==1):0){g=k[A>>2]|0;if(g|0){e=k[g+4>>2]|0;do if(!e){e=k[M>>2]|0;if(e|0)break;e=B1()|0;g=k[A>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,g)}k[A>>2]=0}k[A>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[C>>2]|0)>0){g=k[D>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[C>>2]|0))}e=k[E>>2]|0;if(!((e|0)==(F|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[G>>2]|0;do if(e|0){Ca=e+12|0;Da=k[Ca>>2]|0;k[Ca>>2]=Da+-1;if((Da|0)!=1)break;g=k[G>>2]|0;if(g|0){e=k[g+4>>2]|0;do if(!e){e=k[L>>2]|0;if(e|0)break;e=B1()|0;g=k[G>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,g)}k[G>>2]=0}while(0);k[G>>2]=0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[c>>2]|0)>0){g=k[I>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[c>>2]|0))}e=k[J>>2]|0;if(!((e|0)==(K|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[La>>2]|0;p[(k[O>>2]|0)+(f<<3)>>3]=+p[e+(d<<3)>>3];k[(k[N>>2]|0)+(f<<2)>>2]=f;f=h;d=n}}while((d|0)<(Ga|0))}p[Ha>>3]=+p[Fa+8>>3];k[Ha+8>>2]=0;d=k[R>>2]|0;if((d|0)==(k[a+316>>2]|0))nGa(Q,Ha);else{k[d>>2]=k[Ha>>2];k[d+4>>2]=k[Ha+4>>2];k[d+8>>2]=k[Ha+8>>2];k[d+12>>2]=k[Ha+12>>2];k[R>>2]=(k[R>>2]|0)+16}g=0}d=k[Ja>>2]|0;e=d;if(d|0){f=k[S>>2]|0;if((f|0)!=(d|0))k[S>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(d)}if(!g)Ma=459;else f=0}else{f=k[a+140>>2]|0;if((f|0)<3)d=aa(k[a+148>>2]|0,k[a+144>>2]|0)|0;else{g=k[a+176>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}k[Ka>>2]=0;Ca=Ka+4|0;k[Ca>>2]=0;k[Ka+8>>2]=0;k[Ja>>2]=0;Ba=Ja+4|0;k[Ba>>2]=0;k[Ja+8>>2]=0;if(!Ga)ya=0;else{if(Ga>>>0>1073741823)ad(426534,426557,304,426811);g=Ga<<2;f=(g|0)==0?1:g;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}zpb(e|0,0,g|0)|0;ya=e}k[Ia>>2]=1124007936;wa=Ia+4|0;ia=Ia+8|0;va=Ia+40|0;D=wa;F=D+36|0;do{k[D>>2]=0;D=D+4|0}while((D|0)<(F|0));k[va>>2]=ia;za=Ia+48|0;xa=Ia+44|0;k[xa>>2]=za;k[Ia+52>>2]=0;k[za>>2]=0;k[Aa>>2]=1124007936;qa=Aa+4|0;ja=Aa+8|0;pa=Aa+40|0;D=qa;F=D+36|0;do{k[D>>2]=0;D=D+4|0}while((D|0)<(F|0));k[pa>>2]=ja;sa=Aa+48|0;ra=Aa+44|0;k[ra>>2]=sa;k[Aa+52>>2]=0;k[sa>>2]=0;k[ua>>2]=0;oa=ua+4|0;k[oa>>2]=0;k[ua+8>>2]=0;k[ta>>2]=0;na=ta+4|0;k[na>>2]=0;k[ta+8>>2]=0;ka=a+48|0;j=+p[ka>>3];g=(n|0)==100;H=(n|0)==101;if((n|1|0)!=101){k[Ha>>2]=0;e=Ha+4|0;k[e>>2]=0;f=ZT(44)|0;k[f>>2]=1;D=f+4|0;k[Ha>>2]=D;k[e>>2]=37;i[f+41>>0]=0;E=368982;F=D+37|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,Ha,368959,368204,1420);k[e>>2]=0;k[Ha>>2]=0;ha=k[f>>2]|0;k[f>>2]=ha+-1;if((ha|0)==1)ggb(k[f+-4>>2]|0)}if(g?(ha=k[a+80>>2]|0,v=ha,ha|0):0){h=a+68|0;n=k[h>>2]|0;if((n|0)<3)e=aa(k[a+76>>2]|0,k[a+72>>2]|0)|0;else{g=k[a+104>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(n|0))}if(e|0){k[Ha>>2]=k[a+64>>2];B=Ha+4|0;k[B>>2]=n;t=Ha+8|0;k[t>>2]=k[a+72>>2];q=Ha+12|0;k[q>>2]=k[a+76>>2];z=Ha+16|0;k[z>>2]=v;k[Ha+20>>2]=k[a+84>>2];k[Ha+24>>2]=k[a+88>>2];k[Ha+28>>2]=k[a+92>>2];v=Ha+32|0;k[v>>2]=k[a+96>>2];w=Ha+36|0;e=k[a+100>>2]|0;k[w>>2]=e;y=Ha+40|0;k[y>>2]=t;C=Ha+48|0;A=Ha+44|0;k[A>>2]=C;k[Ha+52>>2]=0;k[C>>2]=0;if(!e)e=n;else{e=e+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[h>>2]|0}if((e|0)>=3){k[B>>2]=0;x1(Ha,e,0,0,0);if((k[B>>2]|0)>0){f=k[a+104>>2]|0;g=k[y>>2]|0;h=k[a+108>>2]|0;n=k[A>>2]|0;e=0;do{k[g+(e<<2)>>2]=k[f+(e<<2)>>2];k[n+(e<<2)>>2]=k[h+(e<<2)>>2];e=e+1|0}while((e|0)<(k[B>>2]|0))}}else{ga=k[a+108>>2]|0;ha=k[A>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2]}f=k[q>>2]|0;e=k[t>>2]|0;if((f|0)==1|(e|0)==1){h=k[B>>2]|0;if((h|0)<3)e=aa(f,e)|0;else{g=k[y>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(!((e|0)==(d|0)?((k[Ha>>2]&4095)+-5|0)>>>0<2:0))Ma=229}else Ma=229;if((Ma|0)==229){k[Ea>>2]=0;e=Ea+4|0;k[e>>2]=0;f=ZT(112)|0;k[f>>2]=1;D=f+4|0;k[Ea>>2]=D;k[e>>2]=106;i[f+110>>0]=0;E=369020;F=D+106|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-5,Ea,368959,368204,1430);k[e>>2]=0;k[Ea>>2]=0;ha=k[f>>2]|0;k[f>>2]=ha+-1;if((ha|0)==1)ggb(k[f+-4>>2]|0)}e=Ea+4|0;ha=e+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[Ea>>2]=33619968;k[e>>2]=Aa;SW(Ha,Ea,6,+p[a+40>>3],0.0);e=k[w>>2]|0;if(e|0?(ga=e+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){f=k[w>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[v>>2]|0;if(e|0)break;e=B1()|0;f=k[w>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[w>>2]=0}k[w>>2]=0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[B>>2]|0)>0){f=k[y>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[B>>2]|0))}e=k[A>>2]|0;if(!((e|0)==(C|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}}ea=a+308|0;e=k[ea>>2]|0;fa=a+312|0;f=k[fa>>2]|0;if((f|0)!=(e|0))k[fa>>2]=f+(~((f+-16-e|0)>>>4)<<4);ca=a+320|0;e=k[ca>>2]|0;da=a+324|0;f=k[da>>2]|0;if((f|0)!=(e|0))k[da>>2]=f+(~((f+-8-e|0)>>>3)<<3);ha=a+332|0;e=k[ha>>2]|0;ga=a+336|0;f=k[ga>>2]|0;if((f|0)!=(e|0))k[ga>>2]=f+(~((f+-4-e|0)>>>2)<<2);t=k[I>>2]|0;if(!((k[c>>2]&16384|0)!=0?(y2(c,1,4,1)|0)==(t|0):0)){k[Ha>>2]=0;e=Ha+4|0;k[e>>2]=0;f=ZT(80)|0;k[f>>2]=1;D=f+4|0;k[Ha>>2]=D;k[e>>2]=74;i[f+78>>0]=0;E=369127;F=D+74|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,Ha,369202,368204,347);k[e>>2]=0;k[Ha>>2]=0;ba=k[f>>2]|0;k[f>>2]=ba+-1;if((ba|0)==1)ggb(k[f+-4>>2]|0)}g=k[Ba>>2]|0;f=k[Ja>>2]|0;e=g-f>>2;if(t>>>0<=e>>>0){if(t>>>0<e>>>0?(G=f+(t<<2)|0,(g|0)!=(G|0)):0)k[Ba>>2]=g+(~((g+-4-G|0)>>>2)<<2)}else{U1(Ja,t-e|0);f=k[Ja>>2]|0}g=(t|0)>0;if(g){e=0;do{k[f+(e<<2)>>2]=e;e=e+1|0}while((e|0)!=(t|0))}q=k[c+16>>2]|0;e=k[Ba>>2]|0;k[Ha>>2]=q;oGa(f,e,Ha);e=k[ua>>2]|0;f=k[oa>>2]|0;if((f|0)!=(e|0)){e=f+(~((f+-4-e|0)>>>2)<<2)|0;k[oa>>2]=e}k[Ha>>2]=0;n=ua+8|0;if((e|0)==(k[n>>2]|0))Q4(ua,Ha);else{k[e>>2]=0;k[oa>>2]=e+4}if(g){g=t+-1|0;h=k[Ja>>2]|0;e=0;do{if((e|0)!=(g|0)){f=e+1|0;if((k[q+(k[h+(e<<2)>>2]<<2)>>2]|0)==(k[q+(k[h+(f<<2)>>2]<<2)>>2]|0))e=f;else{e=f;Ma=273}}else{e=t;Ma=273}if((Ma|0)==273){Ma=0;k[Ha>>2]=e;f=k[oa>>2]|0;if((f|0)==(k[n>>2]|0))Q4(ua,Ha);else{k[f>>2]=e;k[oa>>2]=f+4}}}while((e|0)!=(t|0))}if((k[(k[ua>>2]|0)+(d<<2)>>2]|0)<1){k[Ha>>2]=0;e=Ha+4|0;k[e>>2]=0;f=ZT(120)|0;k[f>>2]=1;D=f+4|0;k[Ha>>2]=D;k[e>>2]=115;i[f+119>>0]=0;E=369223;F=D+115|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-5,Ha,368959,368204,1445);k[e>>2]=0;k[Ha>>2]=0;ba=k[f>>2]|0;k[f>>2]=ba+-1;if((ba|0)==1)ggb(k[f+-4>>2]|0)}t=(d|0)>0;a:do if(H&t){g=k[ua>>2]|0;f=0;n=k[g>>2]|0;while(1){f=f+1|0;h=n;n=k[g+(f<<2)>>2]|0;h=n-h|0;e=f;q=n;while(1){if((e|0)>=(d|0))break;e=e+1|0;ba=q;q=k[g+(e<<2)>>2]|0;ba=q-ba|0;if(j*+(ba+h|0)*.5>+(((ba|0)<(h|0)?ba:h)|0)){g=1;break a}}if((f|0)>=(d|0)){Ma=288;break}}}else Ma=288;while(0);b:do if((Ma|0)==288){e=k[b+4>>2]|0;if((e|0)>0)e=k[(k[b+44>>2]|0)+(e+-1<<2)>>2]|0;else e=0;ba=aa(e,k[Da>>2]|0)|0;c:do if(t){B=a+40|0;C=Ia+12|0;D=Ia+16|0;E=Ha+4|0;F=Aa+16|0;G=la+8|0;H=a+344|0;c=Fa+8|0;I=a+316|0;J=a+340|0;K=a+328|0;L=Aa+12|0;M=b+16|0;N=b+44|0;y=a+120|0;z=a+124|0;A=a+128|0;O=Ha+4|0;P=Ha+8|0;Q=Ha+8|0;R=Ha+4|0;S=Ha+8|0;T=Fa+32|0;U=Fa+16|0;V=Fa+24|0;W=Ha+8|0;w=0;d:while(1){X=w+1|0;if((X|0)<(d|0))q=X;else break c;while(1){$=k[ua>>2]|0;Y=k[$+(w<<2)>>2]|0;Z=(k[$+(X<<2)>>2]|0)-Y|0;v=k[$+(q<<2)>>2]|0;_=q+1|0;j=+p[B>>3];$=(k[$+(_<<2)>>2]|0)-v+Z|0;e=k[Da>>2]|0;f=k[b>>2]&4095;if(!(((k[wa>>2]|0)<3?(k[ia>>2]|0)==($|0):0)&(k[C>>2]|0)==(e|0)?!((k[D>>2]|0)==0?1:(k[Ia>>2]&4095|0)!=(f|0)):0)){k[Ha>>2]=$;k[E>>2]=e;G1(Ia,2,Ha,f)}g=k[Ca>>2]|0;f=k[Ka>>2]|0;e=g-f>>2;do if($>>>0>e>>>0)U1(Ka,$-e|0);else{if($>>>0>=e>>>0)break;e=f+($<<2)|0;if((g|0)==(e|0))break;k[Ca>>2]=g+(~((g+-4-e|0)>>>2)<<2)}while(0);g=k[na>>2]|0;f=k[ta>>2]|0;e=g-f|0;do if($>>>0>e>>>0)pGa(ta,$-e|0);else{if($>>>0>=e>>>0)break;e=f+$|0;if((g|0)==(e|0))break;k[na>>2]=e}while(0);t=($|0)>0;if(t){f=v-Z|0;g=k[Ja>>2]|0;h=k[Ka>>2]|0;e=0;do{n=(e|0)<(Z|0);Qa=(k[D>>2]|0)+(aa(k[k[xa>>2]>>2]|0,e)|0)|0;Pa=g+(e+(n?Y:f)<<2)|0;upb(Qa|0,(k[M>>2]|0)+(aa(k[k[N>>2]>>2]|0,k[Pa>>2]|0)|0)|0,ba|0)|0;k[h+(e<<2)>>2]=k[Pa>>2];i[(k[ta>>2]|0)+e>>0]=n?1:-1;e=e+1|0}while((e|0)!=($|0))}n=k[F>>2]|0;do if(!n)s=j;else{g=k[qa>>2]|0;if((g|0)<3)e=aa(k[L>>2]|0,k[ja>>2]|0)|0;else{h=k[pa>>2]|0;f=0;e=1;do{e=aa(k[h+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(g|0))}if(!e){s=j;break}do if(!(k[Aa>>2]&16384)){f=k[pa>>2]|0;if((k[f>>2]|0)==1){j=+p[n+(w<<3)>>3];Ma=323;break}e=k[ra>>2]|0;if((k[f+4>>2]|0)==1)e=n+(aa(k[e>>2]|0,w)|0)|0;else{Qa=k[L>>2]|0;Pa=(w|0)/(Qa|0)|0;Qa=w-(aa(Pa,Qa)|0)|0;e=n+(aa(k[e>>2]|0,Pa)|0)+(Qa<<3)|0}j=+p[e>>3];e=k[ra>>2]|0;if((k[f+4>>2]|0)==1){e=n+(aa(k[e>>2]|0,q)|0)|0;break}else{Qa=k[L>>2]|0;Pa=(q|0)/(Qa|0)|0;Qa=q-(aa(Pa,Qa)|0)|0;e=n+(aa(k[e>>2]|0,Pa)|0)+(Qa<<3)|0;break}}else{j=+p[n+(w<<3)>>3];Ma=323}while(0);if((Ma|0)==323){Ma=0;e=n+(q<<3)|0}s=+p[e>>3]}while(0);p[la>>3]=0.0;k[G>>2]=0;switch(k[ma>>2]|0){case 100:{h=l[y>>0]|l[y+1>>0]<<8|l[y+2>>0]<<16|l[y+3>>0]<<24;n=l[z>>0]|l[z+1>>0]<<8|l[z+2>>0]<<16|l[z+3>>0]<<24;i[u>>0]=i[A>>0];i[u+1>>0]=i[A+1>>0];i[u+2>>0]=i[A+2>>0];i[u+3>>0]=i[A+3>>0];i[u+4>>0]=i[A+4>>0];i[u+5>>0]=i[A+5>>0];i[u+6>>0]=i[A+6>>0];i[u+7>>0]=i[A+7>>0];m=+p[u>>3];q=k[ia>>2]|0;p[Ha>>3]=0.0;Zza(La,q,Ha);k[Ha>>2]=0;k[O>>2]=0;k[P>>2]=0;if(q|0){if(q>>>0>536870911){Ma=331;break d}f=q<<3;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[O>>2]=e;k[Ha>>2]=e;g=e+(q<<3)|0;k[Q>>2]=g;f=q;while(1){p[e>>3]=-1.0;f=f+-1|0;if(!f)break;else e=e+8|0}k[O>>2]=g}uGa(Ea,Ia,ta,La,Ha,j,s,H,70,0,146,0,348,0,h,n,m);do if(vGa(Ea,Fa)|0){if((q|0)<=0){e=1;break}f=k[ta>>2]|0;g=k[La>>2]|0;e=0;do{Qa=g+(e<<3)|0;p[Qa>>3]=+(i[f+e>>0]|0)*+p[Qa>>3];e=e+1|0}while((e|0)!=(q|0));e=1}else e=0;while(0);wGa(Ea);f=k[Ha>>2]|0;g=f;if(f|0){h=k[O>>2]|0;if((h|0)!=(f|0))k[O>>2]=h+(~((h+-8-g|0)>>>3)<<3);ggb(f)}if(!e){Ma=391;break d}break}case 101:{j=+p[ka>>3];h=l[y>>0]|l[y+1>>0]<<8|l[y+2>>0]<<16|l[y+3>>0]<<24;n=l[z>>0]|l[z+1>>0]<<8|l[z+2>>0]<<16|l[z+3>>0]<<24;i[u>>0]=i[A>>0];i[u+1>>0]=i[A+1>>0];i[u+2>>0]=i[A+2>>0];i[u+3>>0]=i[A+3>>0];i[u+4>>0]=i[A+4>>0];i[u+5>>0]=i[A+5>>0];i[u+6>>0]=i[A+6>>0];i[u+7>>0]=i[A+7>>0];x=+p[u>>3];q=k[ia>>2]|0;g=k[Na>>2]|0;f=k[La>>2]|0;e=g-f>>3;do if(q>>>0>e>>>0)Bla(La,q-e|0);else{if(q>>>0>=e>>>0)break;e=f+(q<<3)|0;if((g|0)==(e|0))break;k[Na>>2]=g+(~((g+-8-e|0)>>>3)<<3)}while(0);k[Ha>>2]=0;k[R>>2]=0;k[S>>2]=0;do if(!q)e=0;else{if(q>>>0>536870911){Ma=355;break d}f=q<<3;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[R>>2]=e;k[Ha>>2]=e;g=e+(q<<3)|0;k[W>>2]=g;f=q;while(1){p[e>>3]=0.0;f=f+-1|0;if(!f)break;else e=e+8|0}k[R>>2]=g;j=+(q|0)*j*.5;if((q|0)<=0){e=0;break}f=k[ta>>2]|0;e=0;m=j;do{if((i[f+e>>0]|0)>0){Ra=m<1.0?m:1.0;s=Ra;m=m-Ra}else{Ra=j<1.0?j:1.0;s=Ra;j=j-Ra}p[(k[La>>2]|0)+(e<<3)>>3]=s;e=e+1|0}while((e|0)!=(q|0));e=1}while(0);uGa(Ea,Ia,ta,La,Ha,1.0,1.0,H,70,0,147,0,349,0,h,n,x);if(vGa(Ea,Fa)|0){j=1.0/+p[T>>3];if(e){f=k[ta>>2]|0;g=k[La>>2]|0;e=0;do{Qa=g+(e<<3)|0;p[Qa>>3]=+p[Qa>>3]*(j*+(i[f+e>>0]|0));e=e+1|0}while((e|0)!=(q|0))}p[c>>3]=j*+p[c>>3];p[Fa>>3]=j*j*+p[Fa>>3];p[U>>3]=j;p[V>>3]=j;e=1}else e=0;wGa(Ea);f=k[Ha>>2]|0;g=f;if(f|0){h=k[R>>2]|0;if((h|0)!=(f|0))k[R>>2]=h+(~((h+-8-g|0)>>>3)<<3);ggb(f)}if(!e){Ma=391;break d}break}default:{Ma=391;break d}}p[la>>3]=+p[c>>3];k[G>>2]=(k[ga>>2]|0)-(k[ha>>2]|0)>>2;e=k[fa>>2]|0;if((e|0)==(k[I>>2]|0))nGa(ea,la);else{k[e>>2]=k[la>>2];k[e+4>>2]=k[la+4>>2];k[e+8>>2]=k[la+8>>2];k[e+12>>2]=k[la+12>>2];k[fa>>2]=(k[fa>>2]|0)+16}if(t){n=v-Z|0;h=0;do{e=k[La>>2]|0;Ra=+p[e+(h<<3)>>3];do if(!(Ra!=Ra|0.0!=0.0|Ra==0.0)){f=(k[Ja>>2]|0)+(h+((h|0)<(Z|0)?Y:n)<<2)|0;k[ya+(k[f>>2]<<2)>>2]=1;g=k[ga>>2]|0;if((g|0)==(k[J>>2]|0)){Q4(ha,f);e=k[La>>2]|0}else{k[g>>2]=k[f>>2];k[ga>>2]=g+4}e=e+(h<<3)|0;f=k[da>>2]|0;if((f|0)==(k[K>>2]|0)){Koa(ca,e);break}else{p[f>>3]=+p[e>>3];k[da>>2]=f+8;break}}while(0);h=h+1|0}while((h|0)<($|0))}if((_|0)<(d|0))q=_;else{w=X;continue d}}}if((Ma|0)==331)ad(426534,426557,304,426811);else if((Ma|0)==355)ad(426534,426557,304,426811);else if((Ma|0)==391){g=1;break b}}while(0);h=(Ga|0)>0;if(h){g=0;d=0;do{e=ya+(g<<2)|0;f=d+1|0;if(k[e>>2]|0){k[e>>2]=f;d=f}g=g+1|0}while((g|0)!=(Ga|0))}else d=0;g=a+196|0;e=k[Da>>2]|0;f=k[b>>2]&4095;do if((k[a+200>>2]|0)<3){if((k[a+204>>2]|0)!=(d|0)){Ma=401;break}if((k[a+208>>2]|0)!=(e|0)){Ma=401;break}if((k[g>>2]&4095|0)!=(f|0)){Ma=401;break}if(!(k[a+212>>2]|0))Ma=401}else Ma=401;while(0);if((Ma|0)==401){k[Ha>>2]=d;k[Ha+4>>2]=e;G1(g,2,Ha,f)}if(h){g=a+212|0;h=a+240|0;n=b+16|0;e=b+44|0;d=0;do{f=k[ya+(d<<2)>>2]|0;if(f|0){Qa=(k[g>>2]|0)+(aa(k[k[h>>2]>>2]|0,f+-1|0)|0)|0;upb(Qa|0,(k[n>>2]|0)+(aa(k[k[e>>2]>>2]|0,d)|0)|0,ba|0)|0}d=d+1|0}while((d|0)!=(Ga|0))}d=k[ha>>2]|0;Qa=(k[ga>>2]|0)-d|0;h=Qa>>2;if((Qa|0)<=0){g=0;break}n=Ha+4|0;g=0;f=ya;do{e=k[f+(k[d+(g<<2)>>2]<<2)>>2]|0;if((e|0)<=0){k[Ha>>2]=0;k[n>>2]=0;d=ZT(28)|0;k[d>>2]=1;D=d+4|0;k[Ha>>2]=D;k[n>>2]=23;i[d+27>>0]=0;E=369339;F=D+23|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,Ha,368959,368204,1541);k[n>>2]=0;k[Ha>>2]=0;Qa=k[d>>2]|0;k[d>>2]=Qa+-1;if((Qa|0)==1)ggb(k[d+-4>>2]|0);e=k[ha>>2]|0;d=e;e=k[ya+(k[e+(g<<2)>>2]<<2)>>2]|0;f=ya}k[d+(g<<2)>>2]=e+-1;g=g+1|0}while((g|0)<(h|0));g=0}while(0);d=k[ta>>2]|0;if(d|0){if((k[na>>2]|0)!=(d|0))k[na>>2]=d;ggb(d)}d=k[ua>>2]|0;e=d;if(d|0){f=k[oa>>2]|0;if((f|0)!=(d|0))k[oa>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(d)}f=Aa+36|0;d=k[f>>2]|0;do if(d|0){Pa=d+12|0;Qa=k[Pa>>2]|0;k[Pa>>2]=Qa+-1;if((Qa|0)!=1)break;e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[Aa+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}while(0);k[f>>2]=0;Qa=Aa+16|0;k[Qa>>2]=0;k[Qa+4>>2]=0;k[Qa+8>>2]=0;k[Qa+12>>2]=0;if((k[qa>>2]|0)>0){e=k[pa>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[qa>>2]|0))}d=k[ra>>2]|0;if(!((d|0)==(sa|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=Ia+36|0;d=k[f>>2]|0;do if(d|0){Pa=d+12|0;Qa=k[Pa>>2]|0;k[Pa>>2]=Qa+-1;if((Qa|0)!=1)break;e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[Ia+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}while(0);k[f>>2]=0;Qa=Ia+16|0;k[Qa>>2]=0;k[Qa+4>>2]=0;k[Qa+8>>2]=0;k[Qa+12>>2]=0;if((k[wa>>2]|0)>0){e=k[va>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[wa>>2]|0))}d=k[xa>>2]|0;if(!((d|0)==(za|0)|(d|0)==0))ggb(k[d+-4>>2]|0);if(ya|0)ggb(ya);d=k[Ja>>2]|0;e=d;if(d|0){f=k[Ba>>2]|0;if((f|0)!=(d|0))k[Ba>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(d)}d=k[Ka>>2]|0;e=d;if(d|0){f=k[Ca>>2]|0;if((f|0)!=(d|0))k[Ca>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(d)}if(!g)Ma=459;else f=0}if((Ma|0)==459){qGa(a);f=1}d=k[La>>2]|0;if(!d){r=Oa;return f|0}e=k[Na>>2]|0;if((e|0)!=(d|0))k[Na>>2]=e+(~((e+-8-d|0)>>>3)<<3);ggb(d);r=Oa;return f|0}function nGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>4;c=g+1|0;if(c>>>0>268435455)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>3;f=e>>4>>>0<134217727?(f>>>0<c>>>0?c:f):268435455;if(!f)c=0;else{if(f>>>0>268435455){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<4;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<4)|0;k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2];k[e+12>>2]=k[b+12>>2];d=e+(0-g<<4)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+16;k[l>>2]=c+(f<<4);if(!i)return;ggb(i);return}function oGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a:while(1){n=b;r=b+-4|0;while(1){s=a;b:while(1){m=s;a=n-m|0;d=a>>2;switch(d|0){case 2:{q=5;break a}case 3:{q=7;break a}case 4:{q=15;break a}case 5:{q=16;break a}case 1:case 0:{q=86;break a}default:{}}if((a|0)<124){q=22;break a}j=s+(((d|0)/2|0)<<2)|0;do if((a|0)>3996){h=(d|0)/4|0;i=s+(h<<2)|0;h=j+(h<<2)|0;a=BGa(s,i,j,h,k[c>>2]|0)|0;e=k[r>>2]|0;f=k[h>>2]|0;d=k[c>>2]|0;if((k[d+(e<<2)>>2]|0)<(k[d+(f<<2)>>2]|0)){k[h>>2]=e;k[r>>2]=f;e=a+1|0;f=k[h>>2]|0;g=k[j>>2]|0;if((k[d+(f<<2)>>2]|0)<(k[d+(g<<2)>>2]|0)){k[j>>2]=f;k[h>>2]=g;e=a+2|0;f=k[j>>2]|0;g=k[i>>2]|0;if((k[d+(f<<2)>>2]|0)<(k[d+(g<<2)>>2]|0)){k[i>>2]=f;k[j>>2]=g;e=k[i>>2]|0;f=k[s>>2]|0;if((k[d+(e<<2)>>2]|0)<(k[d+(f<<2)>>2]|0)){k[s>>2]=e;k[i>>2]=f;a=a+4|0}else a=a+3|0}else a=e}else a=e}}else{a=k[j>>2]|0;f=k[s>>2]|0;h=k[c>>2]|0;l=k[h+(a<<2)>>2]|0;g=h+(f<<2)|0;d=k[r>>2]|0;e=(k[h+(d<<2)>>2]|0)<(l|0);if((l|0)>=(k[g>>2]|0)){if(!e){a=0;d=h;break}k[j>>2]=d;k[r>>2]=a;a=k[j>>2]|0;d=k[s>>2]|0;if((k[h+(a<<2)>>2]|0)>=(k[h+(d<<2)>>2]|0)){a=1;d=h;break}k[s>>2]=a;k[j>>2]=d;a=2;d=h;break}if(e){k[s>>2]=d;k[r>>2]=f;a=1;d=h;break}k[s>>2]=a;k[j>>2]=f;a=k[r>>2]|0;if((k[h+(a<<2)>>2]|0)<(k[g>>2]|0)){k[j>>2]=a;k[r>>2]=f;a=2;d=h}else{a=1;d=h}}while(0);g=k[s>>2]|0;e=k[j>>2]|0;if((k[d+(g<<2)>>2]|0)<(k[d+(e<<2)>>2]|0)){d=r;break}h=k[c>>2]|0;e=h+(e<<2)|0;d=r;while(1){d=d+-4|0;if((s|0)==(d|0))break;f=k[d>>2]|0;if((k[h+(f<<2)>>2]|0)<(k[e>>2]|0)){q=68;break b}}a=s+4|0;f=k[r>>2]|0;e=k[h+(g<<2)>>2]|0;if((e|0)>=(k[h+(f<<2)>>2]|0)){if((a|0)==(r|0)){q=86;break a}while(1){d=k[a>>2]|0;if((e|0)<(k[h+(d<<2)>>2]|0))break;a=a+4|0;if((a|0)==(r|0)){q=86;break a}}k[a>>2]=f;k[r>>2]=d;a=a+4|0}if((a|0)==(r|0)){q=86;break a}i=k[c>>2]|0;d=r;while(1){h=k[i+(k[s>>2]<<2)>>2]|0;while(1){f=k[a>>2]|0;g=a+4|0;if((h|0)<(k[i+(f<<2)>>2]|0))break;else a=g}do{d=d+-4|0;e=k[d>>2]|0}while((h|0)<(k[i+(e<<2)>>2]|0));if(a>>>0>=d>>>0){s=a;continue b}k[a>>2]=e;k[d>>2]=f;a=g}}if((q|0)==68){q=0;k[s>>2]=f;k[d>>2]=g;a=a+1|0}e=s+4|0;c:do if(e>>>0<d>>>0){l=k[c>>2]|0;while(1){i=k[l+(k[j>>2]<<2)>>2]|0;while(1){g=k[e>>2]|0;h=e+4|0;if((k[l+(g<<2)>>2]|0)<(i|0))e=h;else break}do{d=d+-4|0;f=k[d>>2]|0}while((k[l+(f<<2)>>2]|0)>=(i|0));if(e>>>0>d>>>0){d=j;break c}k[e>>2]=f;k[d>>2]=g;j=(j|0)==(e|0)?d:j;e=h;a=a+1|0}}else d=j;while(0);if((e|0)!=(d|0)?(o=k[d>>2]|0,p=k[e>>2]|0,l=k[c>>2]|0,(k[l+(o<<2)>>2]|0)<(k[l+(p<<2)>>2]|0)):0){k[e>>2]=o;k[d>>2]=p;a=a+1|0}if(!a){d=CGa(s,e,c)|0;a=e+4|0;if(CGa(a,b,c)|0){q=85;break}if(d)continue}l=e;if((l-m|0)>=(n-l|0)){q=84;break}oGa(s,e,c);a=e+4|0}if((q|0)==84){q=0;oGa(e+4|0,b,c);a=s;b=e;continue}else if((q|0)==85){q=0;if(d){q=86;break}else{a=s;b=e;continue}}}if((q|0)==5){a=k[r>>2]|0;b=k[s>>2]|0;c=k[c>>2]|0;if((k[c+(a<<2)>>2]|0)>=(k[c+(b<<2)>>2]|0))return;k[s>>2]=a;k[r>>2]=b;return}else if((q|0)==7){h=s+4|0;d=k[h>>2]|0;f=k[s>>2]|0;g=k[c>>2]|0;c=k[g+(d<<2)>>2]|0;e=g+(f<<2)|0;a=k[r>>2]|0;b=(k[g+(a<<2)>>2]|0)<(c|0);if((c|0)>=(k[e>>2]|0)){if(!b)return;k[h>>2]=a;k[r>>2]=d;a=k[h>>2]|0;b=k[s>>2]|0;if((k[g+(a<<2)>>2]|0)>=(k[g+(b<<2)>>2]|0))return;k[s>>2]=a;k[h>>2]=b;return}if(b){k[s>>2]=a;k[r>>2]=f;return}k[s>>2]=d;k[h>>2]=f;a=k[r>>2]|0;if((k[g+(a<<2)>>2]|0)>=(k[e>>2]|0))return;k[h>>2]=a;k[r>>2]=f;return}else if((q|0)==15){BGa(s,s+4|0,s+8|0,r,k[c>>2]|0)|0;return}else if((q|0)==16){h=s+4|0;f=s+8|0;e=s+12|0;BGa(s,h,f,e,k[c>>2]|0)|0;a=k[r>>2]|0;b=k[e>>2]|0;g=k[c>>2]|0;if((k[g+(a<<2)>>2]|0)>=(k[g+(b<<2)>>2]|0))return;k[e>>2]=a;k[r>>2]=b;b=k[e>>2]|0;a=k[f>>2]|0;d=g+(b<<2)|0;if((k[d>>2]|0)>=(k[g+(a<<2)>>2]|0))return;k[f>>2]=b;k[e>>2]=a;a=k[h>>2]|0;if((k[d>>2]|0)>=(k[g+(a<<2)>>2]|0))return;k[h>>2]=b;k[f>>2]=a;a=k[s>>2]|0;if((k[d>>2]|0)>=(k[g+(a<<2)>>2]|0))return;k[s>>2]=b;k[h>>2]=a;return}else if((q|0)==22){a=s+8|0;d=s+4|0;e=k[d>>2]|0;f=k[s>>2]|0;i=k[c>>2]|0;r=k[i+(e<<2)>>2]|0;g=i+(f<<2)|0;h=k[a>>2]|0;i=i+(h<<2)|0;j=(k[i>>2]|0)<(r|0);do if((r|0)<(k[g>>2]|0)){if(j){k[s>>2]=h;k[a>>2]=f;e=f;break}k[s>>2]=e;k[d>>2]=f;if((k[i>>2]|0)<(k[g>>2]|0)){k[d>>2]=h;k[a>>2]=f;e=f}else e=h}else if(j){k[d>>2]=h;k[a>>2]=e;if((k[i>>2]|0)<(k[g>>2]|0)){k[s>>2]=h;k[d>>2]=f}}else e=h;while(0);d=s+12|0;if((d|0)==(b|0))return;j=k[c>>2]|0;while(1){i=k[d>>2]|0;h=j+(i<<2)|0;if((k[h>>2]|0)<(k[j+(e<<2)>>2]|0)){f=d;g=e;while(1){k[f>>2]=g;if((a|0)==(s|0)){a=s;break}e=a+-4|0;g=k[e>>2]|0;if((k[h>>2]|0)>=(k[j+(g<<2)>>2]|0))break;else{f=a;a=e}}k[a>>2]=i}a=d+4|0;if((a|0)==(b|0))break;e=k[d>>2]|0;c=d;d=a;a=c}return}else if((q|0)==86)return}function pGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;j=a+8|0;e=k[j>>2]|0;l=a+4|0;c=k[l>>2]|0;if((e-c|0)>>>0>=b>>>0){do{i[c>>0]=0;c=(k[l>>2]|0)+1|0;k[l>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=c-d|0;c=f+b|0;if((c|0)<0)ad(426534,426557,304,426811);g=e-d|0;h=g<<1;h=g>>>0<1073741823?(h>>>0<c>>>0?c:h):2147483647;a:do if(!h)c=0;else while(1){c=fgb(h)|0;if(c|0)break a;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break a}Qh[c&7]()}while(0);g=c+f|0;f=g;d=g;do{i[d>>0]=0;d=f+1|0;f=d;b=b+-1|0}while((b|0)!=0);d=k[a>>2]|0;e=(k[l>>2]|0)-d|0;b=g+(0-e)|0;if((e|0)>0)upb(b|0,d|0,e|0)|0;k[a>>2]=b;k[l>>2]=f;k[j>>2]=c+h;if(!d)return;ggb(d);return}function qGa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;V=r;r=r+1232|0;J=V+1096|0;U=V;T=V+1168|0;O=V+1152|0;if(k[a+12>>2]|0){r=V;return}P=a+308|0;Q=a+312|0;b=k[P>>2]|0;F=(k[Q>>2]|0)-b|0;H=F>>4;F=(F|0)>0;a:do if(F){g=H+-1|0;d=b;e=a+332|0;f=a+336|0;b=0;do{if((g|0)>(b|0))c=k[d+(b+1<<4)+8>>2]|0;else c=(k[f>>2]|0)-(k[e>>2]|0)>>2;if((c-(k[d+(b<<4)+8>>2]|0)|0)!=1)break a;b=b+1|0}while((b|0)<(H|0))}else b=0;while(0);if((b|0)==(H|0)){r=V;return}C=a+192|0;f=k[C>>2]|0;R=U+8|0;k[U>>2]=R;S=U+4|0;k[S>>2]=136;if(f>>>0>136){c=f>>>0>536870911?-1:f<<3;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[U>>2]=b}else b=R;k[S>>2]=f;k[T>>2]=1124007936;N=T+4|0;c=T+8|0;L=T+40|0;d=N;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[L>>2]=c;M=T+48|0;K=T+44|0;k[K>>2]=M;k[T+52>>2]=0;k[M>>2]=0;k[J>>2]=H;k[J+4>>2]=f;G1(T,2,J,5);k[O>>2]=0;I=O+4|0;k[I>>2]=0;k[O+8>>2]=0;if(F){t=T+16|0;u=a+332|0;v=a+320|0;w=a+212|0;x=a+240|0;y=J+8|0;z=O+8|0;B=a+332|0;A=a+336|0;q=0;do{m=(k[t>>2]|0)+(aa(k[k[K>>2]>>2]|0,q)|0)|0;zpb(b|0,0,k[C>>2]<<3|0)|0;l=k[P>>2]|0;n=l;if((((k[Q>>2]|0)-l>>4)+-1|0)>(q|0)){c=k[n+(q+1<<4)+8>>2]|0;d=k[u>>2]|0}else{d=k[B>>2]|0;c=(k[A>>2]|0)-d>>2}h=k[n+(q<<4)+8>>2]|0;l=c-h|0;g=d+(h<<2)|0;h=(k[v>>2]|0)+(h<<3)|0;if((l|0)>0){i=k[w>>2]|0;j=k[k[x>>2]>>2]|0;f=k[C>>2]|0;if((f|0)>0){c=0;do{e=i+(aa(j,k[g+(c<<2)>>2]|0)|0)|0;s=+p[h+(c<<3)>>3];d=0;do{E=b+(d<<3)|0;p[E>>3]=+p[E>>3]+s*+o[e+(d<<2)>>2];d=d+1|0}while((d|0)!=(f|0));c=c+1|0}while((c|0)!=(l|0));D=f;E=28}}else{D=k[C>>2]|0;E=28}if((E|0)==28?(E=0,(D|0)>0):0){c=0;do{o[m+(c<<2)>>2]=+p[b+(c<<3)>>3];c=c+1|0}while((c|0)!=(D|0))}p[J>>3]=+p[n+(q<<4)>>3];k[y>>2]=q;c=k[I>>2]|0;if((c|0)==(k[z>>2]|0))nGa(O,J);else{k[c>>2]=k[J>>2];k[c+4>>2]=k[J+4>>2];k[c+8>>2]=k[J+8>>2];k[c+12>>2]=k[J+12>>2];k[I>>2]=c+16}q=q+1|0}while((q|0)<(H|0));f=A;b=A;c=B;e=B}else{e=a+332|0;b=a+336|0;f=b;c=e}d=k[b>>2]|0;c=k[c>>2]|0;b=d-c>>2;if(H>>>0<=b>>>0){if(H>>>0<b>>>0?(G=c+(H<<2)|0,(d|0)!=(G|0)):0)k[f>>2]=d+(~((d+-4-G|0)>>>2)<<2)}else U1(e,H-b|0);if(F){c=k[a+332>>2]|0;b=0;do{k[c+(b<<2)>>2]=b;b=b+1|0}while((b|0)!=(H|0))}p[J>>3]=1.0;Zza(a+320|0,H,J);g=a+196|0;m=J+4|0;c=m+4|0;k[c>>2]=0;k[c+4>>2]=0;k[J>>2]=33619968;k[m>>2]=a+252;mY(g,J);k[J>>2]=k[g>>2];m=J+4|0;c=a+200|0;b=k[c>>2]|0;k[m>>2]=b;q=J+8|0;k[q>>2]=k[a+204>>2];k[J+12>>2]=k[a+208>>2];i=J+16|0;k[i>>2]=k[a+212>>2];k[J+20>>2]=k[a+216>>2];k[J+24>>2]=k[a+220>>2];k[J+28>>2]=k[a+224>>2];h=J+32|0;k[h>>2]=k[a+228>>2];j=J+36|0;d=k[a+232>>2]|0;k[j>>2]=d;l=J+40|0;k[l>>2]=q;q=J+48|0;n=J+44|0;k[n>>2]=q;k[J+52>>2]=0;k[q>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[c>>2]|0}if((b|0)>=3){k[m>>2]=0;x1(J,b,0,0,0);if((k[m>>2]|0)>0){c=k[a+236>>2]|0;d=k[l>>2]|0;e=k[a+240>>2]|0;f=k[n>>2]|0;b=0;do{k[d+(b<<2)>>2]=k[c+(b<<2)>>2];k[f+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else{G=k[a+240>>2]|0;H=k[n>>2]|0;k[H>>2]=k[G>>2];k[H+4>>2]=k[G+4>>2]}KG(g,T)|0;KG(T,J)|0;b=k[j>>2]|0;if(b|0?(H=b+12|0,J=k[H>>2]|0,k[H>>2]=J+-1,(J|0)==1):0){c=k[j>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[h>>2]|0;if(!b){b=B1()|0;c=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[j>>2]=0}k[j>>2]=0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;if((k[m>>2]|0)>0){c=k[l>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[n>>2]|0;if(!((b|0)==(q|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=k[P>>2]|0;k[P>>2]=k[O>>2];k[O>>2]=d;c=k[Q>>2]|0;k[Q>>2]=k[I>>2];k[I>>2]=c;P=a+316|0;b=O+8|0;Q=k[P>>2]|0;k[P>>2]=k[b>>2];k[b>>2]=Q;b=d;if(d|0){if((c|0)!=(d|0))k[I>>2]=c+(~((c+-16-d|0)>>>4)<<4);ggb(b)}d=T+36|0;b=k[d>>2]|0;if(b|0?(P=b+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[T+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;T=T+16|0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[N>>2]|0)>0){c=k[L>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[N>>2]|0))}b=k[K>>2]|0;if(!((b|0)==(M|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[U>>2]|0;if((b|0)!=(R|0)){if(b|0)ggb(b);k[U>>2]=R;k[S>>2]=136}r=V;return}function rGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;if(e)return c|0;f=k[a+296>>2]|0;e=k[a>>2]|0;d=(e|0)>0;if((i[f+b>>0]|0)>0){if(d)d=0;else return c|0;do{b=c+(d<<2)|0;o[b>>2]=+(i[f+d>>0]|0)*+o[b>>2];d=d+1|0}while((d|0)!=(e|0));return c|0}else{if(d)d=0;else return c|0;do{b=c+(d<<2)|0;o[b>>2]=+o[b>>2]*+(0-(i[f+d>>0]|0)|0);d=d+1|0}while((d|0)!=(e|0));return c|0}return 0}function sGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0,h=0.0,j=0,l=0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0.0;t=k[a+296>>2]|0;u=k[a+308>>2]|0;v=k[a+280>>2]|0;s=k[a+276>>2]|0;if((s|0)>0){r=0;e=-1797693134862315708145274.0e284;m=-1;l=-1;h=-1797693134862315708145274.0e284;j=-1;f=-1797693134862315708145274.0e284;g=-1;d=-1797693134862315708145274.0e284;do{o=i[u+r>>0]|0;n=o<<24>>24>0;q=+p[v+(r<<3)>>3];do if((i[t+r>>0]|0)>0){if(!n){w=-q;n=e<w;m=n?r:m;e=n?w:e;if(o<<24>>24<0)break}if(q>d){g=r;d=q}}else{if(!n){w=-q;n=f<w;f=n?w:f;j=n?r:j;if(o<<24>>24<0)break}if(q>h){l=r;h=q}}while(0);r=r+1|0}while((r|0)!=(s|0))}else{e=-1797693134862315708145274.0e284;m=-1;l=-1;h=-1797693134862315708145274.0e284;j=-1;f=-1797693134862315708145274.0e284;g=-1;d=-1797693134862315708145274.0e284}e=d+e;d=f+h;if((e<d?d:e)<+p[a+360>>3]){c=1;return c|0}a=e>d;k[b>>2]=a?m:j;k[c>>2]=a?g:l;c=0;return c|0}function tGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,j=0.0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0,u=0,v=0;s=k[a+296>>2]|0;t=k[a+308>>2]|0;u=k[a+280>>2]|0;r=k[a+276>>2]|0;if((r|0)>0){n=0;a=0;j=1797693134862315708145274.0e284;q=0;f=1797693134862315708145274.0e284;h=-1797693134862315708145274.0e284;d=-1797693134862315708145274.0e284;e=0.0;g=0.0;while(1){o=+p[u+(q<<3)>>3];l=i[t+q>>0]|0;m=l<<24>>24<0;do if((i[s+q>>0]|0)>0){if(m){j=j>o?o:j;o=g;break}if(!(l<<24>>24)){n=n+1|0;o=g+o;break}else{h=h<o?o:h;o=g;break}}else{if(m){f=f>o?o:f;o=g;break}if(!(l<<24>>24)){a=a+1|0;e=e+o;o=g;break}else{d=d<o?o:d;o=g;break}}while(0);q=q+1|0;if((q|0)==(r|0))break;else g=o}if((n|0)>0){g=d;d=o/+(n|0)}else v=16}else{a=0;j=1797693134862315708145274.0e284;f=1797693134862315708145274.0e284;h=-1797693134862315708145274.0e284;d=-1797693134862315708145274.0e284;e=0.0;v=16}if((v|0)==16){g=d;d=(h+j)*.5}if((a|0)>0){o=e/+(a|0);j=d-o;j=j*.5;p[b>>3]=j;o=d+o;o=o*.5;p[c>>3]=o;return}else{o=(g+f)*.5;j=d-o;j=j*.5;p[b>>3]=j;o=d+o;o=o*.5;p[c>>3]=o;return}}function uGa(a,b,c,d,e,f,g,h,j,l,m,n,o,q,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;q=q|0;s=s|0;t=t|0;u=+u;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;Z=r;r=r+16|0;Y=Z;x=a+16|0;k[x>>2]=1124007936;w=a+24|0;s=a+56|0;y=a+20|0;z=y+36|0;do{k[y>>2]=0;y=y+4|0}while((y|0)<(z|0));k[s>>2]=w;s=a+64|0;k[a+60>>2]=s;k[a+68>>2]=0;k[s>>2]=0;k[a+128>>2]=1124007936;s=a+136|0;v=a+168|0;y=a+132|0;z=y+36|0;do{k[y>>2]=0;y=y+4|0}while((y|0)<(z|0));k[v>>2]=s;T=a+176|0;k[a+172>>2]=T;k[T>>2]=0;k[T+4>>2]=0;k[a+72>>2]=100;k[a+76>>2]=2;p[a+96>>3]=0.0;p[a+80>>3]=1.0;p[a+88>>3]=0.0;p[a+104>>3]=1.0;T=a+112|0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;k[a+184>>2]=3;k[a+188>>2]=1e3;p[a+192>>3]=1.1920928955078125e-07;T=a+200|0;k[T>>2]=0;U=a+204|0;k[U>>2]=0;k[a+208>>2]=0;V=a+220|0;k[V>>2]=1124007936;W=a+224|0;X=a+228|0;s=a+260|0;y=W;z=y+36|0;do{k[y>>2]=0;y=y+4|0}while((y|0)<(z|0));k[s>>2]=X;H=a+268|0;k[a+264>>2]=H;k[a+272>>2]=0;k[H>>2]=0;H=a+280|0;I=a+284|0;B=a+296|0;C=a+300|0;J=a+308|0;K=a+312|0;E=a+320|0;O=a+332|0;F=a+392|0;G=a+396|0;D=a+292|0;Q=a+400|0;y=H;z=y+76|0;do{k[y>>2]=0;y=y+4|0}while((y|0)<(z|0));k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;k[F+16>>2]=0;k[F+20>>2]=0;k[F+24>>2]=0;k[F+28>>2]=0;KG(x,b)|0;k[a>>2]=k[w>>2];k[a+4>>2]=k[a+28>>2];do if((B|0)!=(c|0)){A=k[c>>2]|0;w=k[c+4>>2]|0;y=w;b=A;x=y-b|0;z=a+304|0;s=k[z>>2]|0;v=k[B>>2]|0;c=v;if(x>>>0<=(s-v|0)>>>0){v=(k[C>>2]|0)-v|0;x=x>>>0>v>>>0;w=x?A+v|0:w;v=w;s=v-b|0;if(s|0)wpb(c|0,A|0,s|0)|0;s=c+s|0;if(x){s=y-v|0;if((s|0)<=0)break;upb(k[C>>2]|0,w|0,s|0)|0;k[C>>2]=(k[C>>2]|0)+s;break}else{if((k[C>>2]|0)==(s|0))break;k[C>>2]=s;break}}if(v){if((k[C>>2]|0)!=(c|0))k[C>>2]=c;ggb(c);k[z>>2]=0;k[C>>2]=0;k[B>>2]=0;s=0}if((x|0)<0)ad(426534,426557,304,426811);w=s<<1;w=s>>>0<1073741823?(w>>>0<x>>>0?x:w):2147483647;if((w|0)<0)ad(426534,426557,304,426811);v=(w|0)==0?1:w;while(1){s=fgb(v)|0;if(s|0)break;s=k[207666]|0;k[207666]=s+0;if(!s){s=0;break}Qh[s&7]()}k[C>>2]=s;k[B>>2]=s;k[z>>2]=s+w;if((x|0)>0){upb(s|0,A|0,x|0)|0;k[C>>2]=s+x}}while(0);k[D>>2]=d;b=a+276|0;k[b>>2]=(k[d+4>>2]|0)-(k[d>>2]|0)>>3;if((E|0)!=(e|0))yGa(E,k[e>>2]|0,k[e+4>>2]|0);w=k[h>>2]|0;s=k[h+4>>2]|0;if(w|0){h=w+4|0;k[h>>2]=(k[h>>2]|0)+1}v=k[F>>2]|0;k[F>>2]=w;k[G>>2]=s;if(v|0?(e=v+4|0,h=k[e>>2]|0,k[e>>2]=h+-1,(h|0)==1):0)Uh[k[(k[v>>2]|0)+8>>2]&2047](v);p[a+376>>3]=g;p[a+384>>3]=f;p[a+360>>3]=u;k[a+368>>2]=t;v=k[b>>2]|0;x=k[I>>2]|0;w=k[H>>2]|0;s=x-w>>3;if(v>>>0<=s>>>0){if(v>>>0<s>>>0?(L=w+(v<<3)|0,(x|0)!=(L|0)):0)k[I>>2]=x+(~((x+-8-L|0)>>>3)<<3)}else{Bla(H,v-s|0);v=k[b>>2]|0}x=k[K>>2]|0;w=k[J>>2]|0;s=x-w|0;if(v>>>0<=s>>>0){if(v>>>0<s>>>0?(M=w+v|0,(x|0)!=(M|0)):0)k[K>>2]=M}else pGa(J,v-s|0);s=k[a>>2]|0;v=s<<1;w=a+336|0;c=k[w>>2]|0;b=k[O>>2]|0;x=c-b>>2;if(v>>>0<=x>>>0){if(v>>>0<x>>>0?(P=b+(v<<2)|0,(c|0)!=(P|0)):0)k[w>>2]=c+(~((c+-4-P|0)>>>2)<<2)}else{FEa(O,v-x|0);s=k[a>>2]|0}c=a+344|0;s=s<<1;v=a+348|0;b=k[v>>2]|0;x=k[c>>2]|0;w=b-x>>2;if(s>>>0<=w>>>0){if(s>>>0<w>>>0?(R=x+(s<<2)|0,(b|0)!=(R|0)):0)k[v>>2]=b+(~((b+-4-R|0)>>>2)<<2)}else FEa(c,s-w|0);k[Q>>2]=m;k[a+404>>2]=n;if(!((m|0)!=0|(n|0)!=0&(n&1|m|0)!=0)){k[Y>>2]=0;s=Y+4|0;k[s>>2]=0;v=ZT(36)|0;k[v>>2]=1;y=v+4|0;k[Y>>2]=y;k[s>>2]=28;i[v+32>>0]=0;w=369363;z=y+28|0;do{i[y>>0]=i[w>>0]|0;y=y+1|0;w=w+1|0}while((y|0)<(z|0));Y8(-215,Y,369392,368204,507);k[s>>2]=0;k[Y>>2]=0;R=k[v>>2]|0;k[v>>2]=R+-1;if((R|0)==1)ggb(k[v+-4>>2]|0)}k[a+408>>2]=o;k[a+412>>2]=q;if(!((o|0)!=0|(q|0)!=0&(q&1|o|0)!=0)){k[Y>>2]=0;s=Y+4|0;k[s>>2]=0;v=ZT(24)|0;k[v>>2]=1;y=v+4|0;k[Y>>2]=y;k[s>>2]=18;i[v+22>>0]=0;w=369399;z=y+18|0;do{i[y>>0]=i[w>>0]|0;y=y+1|0;w=w+1|0}while((y|0)<(z|0));Y8(-215,Y,369392,368204,510);k[s>>2]=0;k[Y>>2]=0;q=k[v>>2]|0;k[v>>2]=q+-1;if((q|0)==1)ggb(k[v+-4>>2]|0)}k[a+416>>2]=j;k[a+420>>2]=l;if(!((j|0)!=0|(l|0)!=0&(l&1|j|0)!=0)){k[Y>>2]=0;s=Y+4|0;k[s>>2]=0;v=ZT(24)|0;k[v>>2]=1;y=v+4|0;k[Y>>2]=y;k[s>>2]=17;i[v+21>>0]=0;w=369418;z=y+17|0;do{i[y>>0]=i[w>>0]|0;y=y+1|0;w=w+1|0}while((y|0)<(z|0));Y8(-215,Y,369392,368204,513);k[s>>2]=0;k[Y>>2]=0;l=k[v>>2]|0;k[v>>2]=l+-1;if((l|0)==1)ggb(k[v+-4>>2]|0)}s=k[a>>2]|0;v=((s|0)<0)<<31>>31;w=Epb(s|0,v|0,s|0,v|0)|0;w=ppb(w|0,N|0,2)|0;C=N;y=C>>>0<0|(C|0)==0&w>>>0<10485760;w=y?10485760:w;C=y?0:C;y=(C|0)>0|(C|0)==0&w>>>0>131072e3;A=kpb(s|0,v|0,-1,-1)|0;C=kpb(A|0,N|0,(y?131072e3:w)|0,(y?0:C)|0)|0;v=Bpb(C|0,N|0,s|0,v|0)|0;C=a+12|0;k[C>>2]=v;k[Y>>2]=1;v=k[((v|0)<1?Y:C)>>2]|0;v=(s|0)<(v|0)?s:v;k[C>>2]=v;k[a+8>>2]=0;y=k[T>>2]|0;w=k[U>>2]|0;A=y;if((w|0)==(y|0))c=y;else{w=w+(~(((w+-12-A|0)>>>0)/12|0)*12|0)|0;k[U>>2]=w;c=w}z=w;x=s+1|0;b=(c-A|0)/12|0;if(x>>>0<=b>>>0){if(x>>>0<b>>>0?(S=y+(x*12|0)|0,(c|0)!=(S|0)):0)k[U>>2]=c+(~(((c+-12-S|0)>>>0)/12|0)*12|0)}else{v=x-b|0;B=a+208|0;x=k[B>>2]|0;if(((x-z|0)/12|0)>>>0<v>>>0){b=(z-A|0)/12|0;s=b+v|0;if(s>>>0>357913941)ad(426534,426557,304,426811);S=(x-A|0)/12|0;y=S<<1;y=S>>>0<178956970?(y>>>0<s>>>0?s:y):357913941;if(!y)s=0;else{if(y>>>0>357913941){a=te(4)|0;k[a>>2]=172664;Cf(a|0,28816,1287)}w=y*12|0;w=(w|0)==0?1:w;while(1){s=fgb(w)|0;if(s|0)break;s=k[207666]|0;k[207666]=s+0;if(!s){s=0;break}Qh[s&7]()}}c=s+(b*12|0)|0;w=c;b=c;do{k[w>>2]=-1;k[w+4>>2]=0;k[w+8>>2]=0;w=b+12|0;b=w;v=v+-1|0}while((v|0)!=0);w=k[T>>2]|0;x=(k[U>>2]|0)-w|0;v=c+(((x|0)/-12|0)*12|0)|0;if((x|0)>0)upb(v|0,w|0,x|0)|0;k[T>>2]=v;k[U>>2]=b;k[B>>2]=s+(y*12|0);if(w|0)ggb(w)}else{s=w;do{k[s>>2]=-1;k[s+4>>2]=0;k[s+8>>2]=0;s=(k[U>>2]|0)+12|0;k[U>>2]=s;v=v+-1|0}while((v|0)!=0)}v=k[C>>2]|0;s=k[a>>2]|0}k[a+216>>2]=0;k[a+212>>2]=0;if(((((k[W>>2]|0)<3?(k[X>>2]|0)==(v|0):0)?(k[a+232>>2]|0)==(s|0):0)?(k[V>>2]&4095|0)==5:0)?k[a+236>>2]|0:0){r=Z;return}k[Y>>2]=v;k[Y+4>>2]=s;G1(V,2,Y,5);r=Z;return}function vGa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0,q=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0;O=r;r=r+16|0;H=O+8|0;N=O+4|0;I=O;J=k[a+296>>2]|0;M=k[a+292>>2]|0;c=k[M>>2]|0;if((k[M+4>>2]|0)==(c|0))ad(426635,426557,315,426658);G=k[a+308>>2]|0;L=k[a+280>>2]|0;M=k[a+320>>2]|0;k[N>>2]=0;K=a+276|0;if((k[K>>2]|0)>0){e=0;do{y=+p[c+(e<<3)>>3];i[G+e>>0]=!(y>=+p[a+376+(((i[J+e>>0]|0)>0&1)<<3)>>3])?(y<=0.0)<<31>>31:1;F=k[N>>2]|0;y=+p[M+(F<<3)>>3];p[L+(F<<3)>>3]=y;e=F+1|0;if(+P(+y)>1.e+200){c=0;v=51;break}k[N>>2]=e;f=k[K>>2]|0}while((e|0)<(f|0));if((v|0)==51){r=O;return c|0}k[N>>2]=0;if((f|0)>0){q=a+332|0;m=a+416|0;n=a+420|0;e=0;do{if((i[G+e>>0]|0)>=0){g=k[q>>2]|0;i[H>>0]=0;h=xGa(a,e,H)|0;f=k[m>>2]|0;F=k[n>>2]|0;j=a+(F>>1)|0;if(F&1)f=k[(k[j>>2]|0)+f>>2]|0;g=$g[f&127](j,e,h,g,(i[H>>0]|0)!=0)|0;e=k[N>>2]|0;d=+p[c+(e<<3)>>3];k[I>>2]=0;f=k[K>>2]|0;if((f|0)>0){h=0;do{F=L+(h<<3)|0;p[F>>3]=+p[F>>3]+d*+o[g+(h<<2)>>2];h=h+1|0}while((h|0)!=(f|0));k[I>>2]=f}}e=e+1|0;k[N>>2]=e}while((e|0)<(f|0));F=a}else v=7}else{k[N>>2]=0;v=7}if((v|0)==7){m=a+416|0;n=a+420|0;q=a+332|0;F=a}B=a+400|0;C=a+404|0;D=a+368|0;E=a+344|0;g=0;a:while(1){e=k[B>>2]|0;A=k[C>>2]|0;f=F+(A>>1)|0;if(A&1)e=k[(k[f>>2]|0)+e>>2]|0;if(ci[e&255](f,N,I)|0)break;A=g+1|0;if((g|0)>=(k[D>>2]|0))break;g=k[N>>2]|0;h=k[q>>2]|0;i[H>>0]=0;j=xGa(a,g,H)|0;e=k[m>>2]|0;z=k[n>>2]|0;f=F+(z>>1)|0;if(z&1)e=k[(k[f>>2]|0)+e>>2]|0;z=$g[e&127](f,g,j,h,(i[H>>0]|0)!=0)|0;f=k[I>>2]|0;g=k[E>>2]|0;i[H>>0]=0;h=xGa(a,f,H)|0;e=k[m>>2]|0;v=k[n>>2]|0;j=F+(v>>1)|0;if(v&1)e=k[(k[j>>2]|0)+e>>2]|0;v=$g[e&127](j,f,h,g,(i[H>>0]|0)!=0)|0;f=k[N>>2]|0;g=J+f|0;R=i[g>>0]|0;w=+p[a+376+((R<<24>>24>0&1)<<3)>>3];e=k[I>>2]|0;Q=i[J+e>>0]|0;d=+p[a+376+((Q<<24>>24>0&1)<<3)>>3];h=c+(f<<3)|0;x=+p[h>>3];j=c+(e<<3)|0;y=+p[j>>3];l=+o[z+(f<<2)>>2]+ +o[v+(e<<2)>>2];s=+o[z+(e<<2)>>2]*2.0;do if(R<<24>>24==Q<<24>>24){t=+P(+(l-s));t=(+p[L+(f<<3)>>3]-+p[L+(e<<3)>>3])/(t<=1.1920928955078125e-07?1.1920928955078125e-07:t);u=x+y;l=x-t;t=y+t;if(u>w&l>w){s=w;l=u-w}else{R=u<=w&t<0.0;s=R?u:l;l=R?0.0:t}if(u>d&l>d){t=u-d;break}else{R=u<=d&s<0.0;t=R?0.0:s;d=R?u:l;break}}else{s=+P(+(l+s));s=(-+p[L+(f<<3)>>3]-+p[L+(e<<3)>>3])/(s<=1.1920928955078125e-07?1.1920928955078125e-07:s);u=x-y;l=x+s;s=y+s;if(u>0.0&s<0.0){t=u;s=0.0}else{R=u<=0.0&l<0.0;t=R?0.0:l;s=R?-u:s}l=w-d;if(u>l&t>w){t=w;d=w-u;break}else{R=u<=l&s>d;t=R?d+u:t;d=R?d:s;break}}while(0);p[h>>3]=t;p[j>>3]=d;l=+p[h>>3];i[G+f>>0]=!(l>=+p[a+376+(((i[g>>0]|0)>0&1)<<3)>>3])?(l<=0.0)<<31>>31:1;f=k[I>>2]|0;l=+p[c+(f<<3)>>3];i[G+f>>0]=!(l>=+p[a+376+(((i[J+f>>0]|0)>0&1)<<3)>>3])?(l<=0.0)<<31>>31:1;l=t-x;d=d-y;f=k[K>>2]|0;if((f|0)>0)e=0;else{g=A;continue}while(1){R=L+(e<<3)|0;p[R>>3]=+p[R>>3]+(l*+o[z+(e<<2)>>2]+d*+o[v+(e<<2)>>2]);e=e+1|0;if((e|0)==(f|0)){g=A;continue a}}}e=k[a+408>>2]|0;R=k[a+412>>2]|0;f=F+(R>>1)|0;if(R&1)e=k[(k[f>>2]|0)+e>>2]|0;Ph[e&511](f,b+8|0,b+32|0);k[N>>2]=0;p[b>>3]=0.0;e=k[K>>2]|0;if((e|0)>0){f=0;d=0.0;do{d=d+ +p[c+(f<<3)>>3]*(+p[L+(f<<3)>>3]+ +p[M+(f<<3)>>3]);p[b>>3]=d;f=f+1|0}while((f|0)!=(e|0));k[N>>2]=e;d=d*.5}else d=0.0;p[b>>3]=d;p[b+16>>3]=+p[a+384>>3];p[b+24>>3]=+p[a+376>>3];R=1;r=O;return R|0}function wGa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+392|0;c=k[b>>2]|0;if(c|0?(d=c+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+396>>2]=0;b=k[a+344>>2]|0;c=b;if(b|0){d=a+348|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=k[a+332>>2]|0;e=d;if(d|0){b=a+336|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-4-e|0)>>>2)<<2);ggb(d)}d=k[a+320>>2]|0;e=d;if(d|0){b=a+324|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-e|0)>>>3)<<3);ggb(d)}b=k[a+308>>2]|0;if(b|0){c=a+312|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+296>>2]|0;if(b|0){c=a+300|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+280>>2]|0;c=b;if(b|0){d=a+284|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}d=a+256|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+252>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+236|0;c=a+224|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+260>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+264>>2]|0;if(!((b|0)==(a+268|0)|(b|0)==0))ggb(k[b+-4>>2]|0);c=k[a+200>>2]|0;d=c;if(c|0){e=a+204|0;b=k[e>>2]|0;if((b|0)!=(c|0))k[e>>2]=b+(~(((b+-12-d|0)>>>0)/12|0)*12|0);ggb(c)}d=a+164|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+160>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+144|0;c=a+132|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+168>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+172>>2]|0;if(!((b|0)==(a+176|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+52|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+48>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+32|0;c=a+20|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+56>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+60>>2]|0;if((b|0)==(a+64|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function xGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;e=k[a>>2]|0;d=b-((e|0)>(b|0)?0:e)|0;g=d+1|0;h=a+200|0;j=k[h>>2]|0;f=j+(g*12|0)|0;b=k[f>>2]|0;if(c|0)i[c>>0]=b>>>31&255^1;do if((b|0)>=0){d=k[j+(g*12|0)+8>>2]|0;c=j+(g*12|0)+4|0;b=k[c>>2]|0;if(!d)k[a+216>>2]=b;else{k[j+(d*12|0)+4>>2]=b;b=k[c>>2]|0}if(!b){k[a+212>>2]=d;break}else{k[j+(b*12|0)+8>>2]=d;break}}else{c=a+8|0;b=k[c>>2]|0;if((b|0)<(k[a+12>>2]|0)){k[f>>2]=b;k[c>>2]=b+1;c=a+216|0;if(!(k[c>>2]|0))k[c>>2]=g}else{l=a+216|0;b=k[l>>2]|0;c=j+(b*12|0)|0;k[f>>2]=k[c>>2];k[c>>2]=-1;c=j+(b*12|0)+4|0;m=k[c>>2]|0;k[j+(m*12|0)+8>>2]=0;k[l>>2]=m;k[c>>2]=0;k[j+(b*12|0)+8>>2]=0;b=k[f>>2]|0}n=k[a+396>>2]|0;c=k[a+32>>2]|0;l=c+(aa(k[k[a+60>>2]>>2]|0,d)|0)|0;m=(k[a+236>>2]|0)+(aa(k[k[a+264>>2]>>2]|0,b)|0)|0;Lg[k[(k[n>>2]|0)+36>>2]&255](n,e,k[a+4>>2]|0,c,l,m)}while(0);b=a+212|0;c=k[b>>2]|0;if(!c){n=j+(g*12|0)+8|0;k[n>>2]=c;n=j+(g*12|0)+4|0;k[n>>2]=0;k[b>>2]=g;n=k[f>>2]|0;m=a+236|0;m=k[m>>2]|0;l=a+264|0;l=k[l>>2]|0;l=k[l>>2]|0;n=aa(l,n)|0;n=m+n|0;return n|0}k[(k[h>>2]|0)+(c*12|0)+4>>2]=g;n=j+(g*12|0)+8|0;k[n>>2]=c;n=j+(g*12|0)+4|0;k[n>>2]=0;k[b>>2]=g;n=k[f>>2]|0;m=a+236|0;m=k[m>>2]|0;l=a+264|0;l=k[l>>2]|0;l=k[l>>2]|0;n=aa(l,n)|0;n=m+n|0;return n|0}function yGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;i=c;g=b;f=i-g|0;m=f>>3;h=a+8|0;d=k[h>>2]|0;l=k[a>>2]|0;j=l;if(m>>>0<=d-l>>3>>>0){h=a+4|0;a=(k[h>>2]|0)-l>>3;f=m>>>0>a>>>0;a=f?b+(a<<3)|0:c;e=a;d=e-g|0;c=d>>3;if(c|0)wpb(l|0,b|0,d|0)|0;c=j+(c<<3)|0;if(f){d=i-e|0;if((d|0)<=0)return;upb(k[h>>2]|0,a|0,d|0)|0;k[h>>2]=(k[h>>2]|0)+(d>>3<<3);return}else{d=k[h>>2]|0;if((d|0)==(c|0))return;k[h>>2]=d+(~((d+-8-c|0)>>>3)<<3);return}}e=l;if(l){d=a+4|0;c=k[d>>2]|0;if((c|0)!=(j|0))k[d>>2]=c+(~((c+-8-l|0)>>>3)<<3);ggb(e);k[h>>2]=0;k[d>>2]=0;k[a>>2]=0;d=0}if(m>>>0>536870911)ad(426534,426557,304,426811);e=d>>2;e=d>>3>>>0<268435455?(e>>>0<m>>>0?m:e):536870911;if(e>>>0>536870911)bob();c=e<<3;c=(c|0)==0?1:c;while(1){d=fgb(c)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}c=a+4|0;k[c>>2]=d;k[a>>2]=d;k[h>>2]=d+(e<<3);if((f|0)<=0)return;upb(d|0,b|0,f|0)|0;k[c>>2]=d+(m<<3);return}function zGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0,h=0,j=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0.0;o=k[a+296>>2]|0;q=k[a+308>>2]|0;r=k[a+280>>2]|0;n=k[a+276>>2]|0;if((n|0)>0){g=-1797693134862315708145274.0e284;f=-1;e=-1797693134862315708145274.0e284;d=-1;m=0}else{g=-1797693134862315708145274.0e284;q=-1;l=-1797693134862315708145274.0e284;r=-1;k[b>>2]=q;k[c>>2]=r;g=l+g;c=a+360|0;l=+p[c>>3];c=g<l;return c|0}do{j=i[q+m>>0]|0;h=j<<24>>24>0;l=+p[r+(m<<3)>>3];do if((i[o+m>>0]|0)>0){if(!h){s=-l;h=g<s;f=h?m:f;g=h?s:g;if(j<<24>>24<0)break}if(l>e){e=l;d=m}}else{if(!h){s=-l;h=e<s;d=h?m:d;e=h?s:e;if(j<<24>>24<0)break}if(l>g){g=l;f=m}}while(0);m=m+1|0}while((m|0)!=(n|0));k[b>>2]=f;k[c>>2]=d;l=e+g;c=a+360|0;s=+p[c>>3];c=l<s;return c|0}function AGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0,h=0,j=0.0,l=0,m=0,n=0,o=0,q=0;n=k[a+296>>2]|0;o=k[a+308>>2]|0;q=k[a+280>>2]|0;m=k[a+276>>2]|0;if((m|0)>0){l=0;e=1797693134862315708145274.0e284;d=-1797693134862315708145274.0e284;f=0.0;a=0;do{g=i[n+l>>0]|0;j=+(g<<24>>24)*+p[q+(l<<3)>>3];h=i[o+l>>0]|0;do if(h<<24>>24<0)if(g<<24>>24>0){e=e>j?j:e;break}else{d=d<j?j:d;break}else{if(!(h<<24>>24)){a=a+1|0;f=f+j;break}if(g<<24>>24<0){e=e>j?j:e;break}else{d=d<j?j:d;break}}while(0);l=l+1|0}while((l|0)!=(m|0));if((a|0)>0){j=f/+(a|0);p[b>>3]=j;p[c>>3]=0.0;return}}else{e=1797693134862315708145274.0e284;d=-1797693134862315708145274.0e284}j=(d+e)*.5;p[b>>3]=j;p[c>>3]=0.0;return}function BGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0;j=k[b>>2]|0;i=k[a>>2]|0;l=k[e+(j<<2)>>2]|0;h=e+(i<<2)|0;g=k[c>>2]|0;f=(k[e+(g<<2)>>2]|0)<(l|0);do if((l|0)<(k[h>>2]|0)){if(f){k[a>>2]=g;k[c>>2]=i;h=1;g=i;break}k[a>>2]=j;k[b>>2]=i;g=k[c>>2]|0;if((k[e+(g<<2)>>2]|0)<(k[h>>2]|0)){k[b>>2]=g;k[c>>2]=i;h=2;g=i}else h=1}else if(f){k[b>>2]=g;k[c>>2]=j;f=k[b>>2]|0;g=k[a>>2]|0;if((k[e+(f<<2)>>2]|0)<(k[e+(g<<2)>>2]|0)){k[a>>2]=f;k[b>>2]=g;h=2;g=k[c>>2]|0}else{h=1;g=j}}else h=0;while(0);f=k[d>>2]|0;if((k[e+(f<<2)>>2]|0)>=(k[e+(g<<2)>>2]|0)){l=h;return l|0}k[c>>2]=f;k[d>>2]=g;f=k[c>>2]|0;g=k[b>>2]|0;if((k[e+(f<<2)>>2]|0)>=(k[e+(g<<2)>>2]|0)){l=h+1|0;return l|0}k[b>>2]=f;k[c>>2]=g;f=k[b>>2]|0;g=k[a>>2]|0;if((k[e+(f<<2)>>2]|0)>=(k[e+(g<<2)>>2]|0)){l=h+2|0;return l|0}k[a>>2]=f;k[b>>2]=g;l=h+3|0;return l|0}function CGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=k[d>>2]|0;f=k[a>>2]|0;b=k[c>>2]|0;if((k[b+(e<<2)>>2]|0)>=(k[b+(f<<2)>>2]|0)){a=1;return a|0}k[a>>2]=e;k[d>>2]=f;a=1;return a|0}case 3:{l=a+4|0;h=b+-4|0;f=k[l>>2]|0;i=k[a>>2]|0;j=k[c>>2]|0;b=k[j+(f<<2)>>2]|0;g=j+(i<<2)|0;d=k[h>>2]|0;e=(k[j+(d<<2)>>2]|0)<(b|0);if((b|0)>=(k[g>>2]|0)){if(!e){a=1;return a|0}k[l>>2]=d;k[h>>2]=f;d=k[l>>2]|0;e=k[a>>2]|0;if((k[j+(d<<2)>>2]|0)>=(k[j+(e<<2)>>2]|0)){a=1;return a|0}k[a>>2]=d;k[l>>2]=e;a=1;return a|0}if(e){k[a>>2]=d;k[h>>2]=i;a=1;return a|0}k[a>>2]=f;k[l>>2]=i;d=k[h>>2]|0;if((k[j+(d<<2)>>2]|0)>=(k[g>>2]|0)){a=1;return a|0}k[l>>2]=d;k[h>>2]=i;a=1;return a|0}case 4:{BGa(a,a+4|0,a+8|0,b+-4|0,k[c>>2]|0)|0;a=1;return a|0}case 5:{j=a+4|0;i=a+8|0;g=a+12|0;d=b+-4|0;BGa(a,j,i,g,k[c>>2]|0)|0;e=k[d>>2]|0;f=k[g>>2]|0;h=k[c>>2]|0;if((k[h+(e<<2)>>2]|0)>=(k[h+(f<<2)>>2]|0)){a=1;return a|0}k[g>>2]=e;k[d>>2]=f;e=k[g>>2]|0;d=k[i>>2]|0;f=h+(e<<2)|0;if((k[f>>2]|0)>=(k[h+(d<<2)>>2]|0)){a=1;return a|0}k[i>>2]=e;k[g>>2]=d;d=k[j>>2]|0;if((k[f>>2]|0)>=(k[h+(d<<2)>>2]|0)){a=1;return a|0}k[j>>2]=e;k[i>>2]=d;d=k[a>>2]|0;if((k[f>>2]|0)>=(k[h+(d<<2)>>2]|0)){a=1;return a|0}k[a>>2]=e;k[j>>2]=d;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{d=a+8|0;e=a+4|0;f=k[e>>2]|0;g=k[a>>2]|0;j=k[c>>2]|0;m=k[j+(f<<2)>>2]|0;h=j+(g<<2)|0;i=k[d>>2]|0;j=j+(i<<2)|0;l=(k[j>>2]|0)<(m|0);do if((m|0)<(k[h>>2]|0)){if(l){k[a>>2]=i;k[d>>2]=g;f=g;break}k[a>>2]=f;k[e>>2]=g;if((k[j>>2]|0)<(k[h>>2]|0)){k[e>>2]=i;k[d>>2]=g;f=g}else f=i}else if(l){k[e>>2]=i;k[d>>2]=f;if((k[j>>2]|0)<(k[h>>2]|0)){k[a>>2]=i;k[e>>2]=g}}else f=i;while(0);e=a+12|0;a:do if((e|0)==(b|0)){e=1;d=0}else{c=k[c>>2]|0;l=e;e=0;while(1){j=k[l>>2]|0;i=c+(j<<2)|0;if((k[i>>2]|0)<(k[c+(f<<2)>>2]|0)){g=l;h=f;while(1){k[g>>2]=h;if((d|0)==(a|0)){d=a;break}f=d+-4|0;h=k[f>>2]|0;if((k[i>>2]|0)>=(k[c+(h<<2)>>2]|0))break;else{g=d;d=f}}k[d>>2]=j;e=e+1|0;d=l+4|0;if((e|0)==8){e=0;d=(d|0)==(b|0);break a}}else d=l+4|0;if((d|0)==(b|0)){e=1;d=0;break a}f=k[l>>2]|0;m=l;l=d;d=m}}while(0);m=d|e;return m|0}}return 0}function DGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0.0;g=k[a>>2]|0;e=d;f=d+(g<<2)|0;a=(g|0)>(b|0);if((g|0)<=0)return d|0;b=a?e:f;e=a?f:e;a=0;do{h=+o[c+(a<<2)>>2];o[b+(a<<2)>>2]=h;o[e+(a<<2)>>2]=-h;a=a+1|0}while((a|0)!=(g|0));return d|0}function EGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return c|0}function FGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;Q=r;r=r+1072|0;P=Q+8|0;m=Q;M=a+4|0;f=k[M>>2]|0;l=k[f+8>>2]|0;N=k[f+204>>2]|0;do if(k[f+152>>2]|0){j=k[f+140>>2]|0;g=(j|0)<3;if(g)c=aa(k[f+148>>2]|0,k[f+144>>2]|0)|0;else{e=k[f+176>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(j|0))}if(c){if(g){c=aa(k[f+148>>2]|0,k[f+144>>2]|0)|0;break}e=k[f+176>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(j|0))}else O=11}else O=11;while(0);if((O|0)==11)c=(l|0)==102&1;g=N+2+(c<<1)|0;K=P+8|0;k[P>>2]=K;L=P+4|0;k[L>>2]=264;if(g>>>0>264){e=g>>>0>1073741823?-1:g<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[P>>2]=d;J=d}else J=K;k[L>>2]=g;a:do if((l+-102|0)>>>0<3){c=k[b>>2]|0;l=b+4|0;if((c|0)<(k[l>>2]|0)){b=a+8|0;m=a+16|0;j=a+12|0;if((N|0)>0)g=c;else{g=c;while(1){I=k[b>>2]|0;I=(k[I+16>>2]|0)+(aa(k[k[I+44>>2]>>2]|0,g)|0)|0;H=k[f+348>>2]|0;Lg[k[(k[H>>2]|0)+36>>2]&255](H,N,k[f+192>>2]|0,k[f+212>>2]|0,I,J);f=k[M>>2]|0;h=+p[k[f+308>>2]>>3];if((k[f+8>>2]|0)==102?(i[m>>0]|0)==0:0)h=+(h<-0.0&1);else h=-h;c=k[j>>2]|0;do if((k[c>>2]&16384|0)==0?(n=k[c+40>>2]|0,(k[n>>2]|0)!=1):0){d=k[c+16>>2]|0;e=k[c+44>>2]|0;if((k[n+4>>2]|0)==1){c=d+(aa(k[e>>2]|0,g)|0)|0;break}else{c=k[c+12>>2]|0;I=(g|0)/(c|0)|0;c=g-(aa(I,c)|0)|0;c=d+(aa(k[e>>2]|0,I)|0)+(c<<2)|0;break}}else O=40;while(0);if((O|0)==40){O=0;c=(k[c+16>>2]|0)+(g<<2)|0}o[c>>2]=h;g=g+1|0;if((g|0)>=(k[l>>2]|0))break a}}do{d=k[b>>2]|0;d=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,g)|0)|0;c=k[f+348>>2]|0;Lg[k[(k[c>>2]|0)+36>>2]&255](c,N,k[f+192>>2]|0,k[f+212>>2]|0,d,J);f=k[M>>2]|0;d=k[f+320>>2]|0;c=0;h=-+p[k[f+308>>2]>>3];do{h=h+ +o[J+(c<<2)>>2]*+p[d+(c<<3)>>3];c=c+1|0}while((c|0)!=(N|0));if((k[f+8>>2]|0)==102?(i[m>>0]|0)==0:0)h=+(h>0.0&1);e=k[j>>2]|0;do if((k[e>>2]&16384|0)==0?(q=k[e+40>>2]|0,(k[q>>2]|0)!=1):0){c=k[e+16>>2]|0;d=k[e+44>>2]|0;if((k[q+4>>2]|0)==1){c=c+(aa(k[d>>2]|0,g)|0)|0;break}else{I=k[e+12>>2]|0;H=(g|0)/(I|0)|0;I=g-(aa(H,I)|0)|0;c=c+(aa(k[d>>2]|0,H)|0)+(I<<2)|0;break}}else O=30;while(0);if((O|0)==30){O=0;c=(k[e+16>>2]|0)+(g<<2)|0}o[c>>2]=h;g=g+1|0}while((g|0)<(k[l>>2]|0))}}else{if((l|1|0)!=101){k[m>>2]=0;c=m+4|0;k[c>>2]=0;d=ZT(80)|0;k[d>>2]=1;e=d+4|0;k[m>>2]=e;k[c>>2]=73;i[d+77>>0]=0;f=369705;g=e+73|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-5,m,369779,368204,1914);k[c>>2]=0;k[m>>2]=0;O=k[d>>2]|0;k[d>>2]=O+-1;if((O|0)==1)ggb(k[d+-4>>2]|0);break}G=J+(N<<2)|0;d=k[b>>2]|0;z=b+4|0;if((d|0)<(k[z>>2]|0)){A=a+8|0;B=c<<2;C=(c|0)>0;D=(c|0)>1;E=a+16|0;F=(c|0)==2;y=a+12|0;while(1){w=k[f+348>>2]|0;x=k[A>>2]|0;x=(k[x+16>>2]|0)+(aa(k[k[x+44>>2]>>2]|0,d)|0)|0;Lg[k[(k[w>>2]|0)+36>>2]&255](w,N,k[f+192>>2]|0,k[f+212>>2]|0,x,J);zpb(G|0,0,B|0)|0;if(C){e=0;h=0.0;w=0;x=c;do{x=x+-1|0;v=w;w=w+1|0;if((w|0)<(c|0)){t=k[M>>2]|0;a=k[t+308>>2]|0;n=((k[t+312>>2]|0)-a>>4)+-1|0;q=k[t+320>>2]|0;s=k[t+332>>2]|0;t=t+336|0;u=s;b=w;m=e;while(1){h=-+p[a+(m<<4)>>3];if((n|0)>(m|0))f=k[a+(m+1<<4)+8>>2]|0;else f=(k[t>>2]|0)-u>>2;l=k[a+(m<<4)+8>>2]|0;g=f-l|0;j=q+(l<<3)|0;l=s+(l<<2)|0;if((g|0)>0){f=0;do{h=h+ +p[j+(f<<3)>>3]*+o[J+(k[l+(f<<2)>>2]<<2)>>2];f=f+1|0}while((f|0)!=(g|0))}l=G+((h>0.0?v:b)<<2)|0;k[l>>2]=(k[l>>2]|0)+1;b=b+1|0;if((b|0)==(c|0))break;else m=m+1|0}e=e+x|0}}while((w|0)!=(c|0))}else h=0.0;if(D){e=0;f=1;do{e=(k[G+(f<<2)>>2]|0)>(k[G+(e<<2)>>2]|0)?f:e;f=f+1|0}while((f|0)!=(c|0))}else e=0;if(!(F&(i[E>>0]|0)!=0)){f=k[M>>2]|0;do if((k[f+136>>2]&16384|0)==0?(H=k[f+176>>2]|0,(k[H>>2]|0)!=1):0){g=k[f+152>>2]|0;j=k[f+180>>2]|0;if((k[H+4>>2]|0)==1){e=g+(aa(k[j>>2]|0,e)|0)|0;break}else{w=k[f+148>>2]|0;x=(e|0)/(w|0)|0;e=e-(aa(x,w)|0)|0;e=g+(aa(k[j>>2]|0,x)|0)+(e<<2)|0;break}}else O=65;while(0);if((O|0)==65){O=0;e=(k[f+152>>2]|0)+(e<<2)|0}h=+(k[e>>2]|0)}e=k[y>>2]|0;do if((k[e>>2]&16384|0)==0?(I=k[e+40>>2]|0,(k[I>>2]|0)!=1):0){f=k[e+16>>2]|0;g=k[e+44>>2]|0;if((k[I+4>>2]|0)==1){e=f+(aa(k[g>>2]|0,d)|0)|0;break}else{e=k[e+12>>2]|0;x=(d|0)/(e|0)|0;e=d-(aa(x,e)|0)|0;e=f+(aa(k[g>>2]|0,x)|0)+(e<<2)|0;break}}else O=72;while(0);if((O|0)==72){O=0;e=(k[e+16>>2]|0)+(d<<2)|0}o[e>>2]=h;d=d+1|0;if((d|0)>=(k[z>>2]|0))break a;f=k[M>>2]|0}}}while(0);c=k[P>>2]|0;if((c|0)==(K|0)){r=Q;return}if(c|0)ggb(c);k[P>>2]=K;k[L>>2]=264;r=Q;return}function GGa(a){a=a|0;ggb(a);return}function HGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function IGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;e=h;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=h;return}f=a+32|0;if((k[f>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[e>>2]=g;k[c>>2]=30;i[d+34>>0]=0;j=401220;l=g+30|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}D6(a,a+12|0,b);if(!(k[f>>2]&4)){r=h;return}k[f>>2]=6;r=h;return}function JGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+p[b>>3]);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function KGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;j=r;r=r+16|0;f=j;if(b|0?(g=Kob(b,5312,19632,0)|0,g|0):0){k[a>>2]=k[g+252>>2];h=a+4|0;d=g+256|0;b=k[d>>2]|0;k[h>>2]=b;l=a+8|0;k[l>>2]=k[g+260>>2];k[a+12>>2]=k[g+264>>2];k[a+16>>2]=k[g+268>>2];k[a+20>>2]=k[g+272>>2];k[a+24>>2]=k[g+276>>2];k[a+28>>2]=k[g+280>>2];k[a+32>>2]=k[g+284>>2];c=k[g+288>>2]|0;k[a+36>>2]=c;e=a+40|0;k[e>>2]=l;l=a+48|0;f=a+44|0;k[f>>2]=l;k[a+52>>2]=0;k[l>>2]=0;if(c){b=c+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[d>>2]|0}if((b|0)<3){h=k[g+296>>2]|0;l=k[f>>2]|0;k[l>>2]=k[h>>2];k[l+4>>2]=k[h+4>>2];r=j;return}k[h>>2]=0;x1(a,k[d>>2]|0,0,0,0);if((k[h>>2]|0)<=0){r=j;return}a=k[g+292>>2]|0;e=k[e>>2]|0;d=k[g+296>>2]|0;c=k[f>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[a+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0));r=j;return}b=f+4|0;c=ZT(32)|0;k[c>>2]=1;d=c+4|0;k[f>>2]=d;k[b>>2]=24;i[c+28>>0]=0;e=370692;a=d+24|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(a|0));Y8(-213,f,370717,368204,2268);k[b>>2]=0;k[f>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;ggb(k[c+-4>>2]|0)}function LGa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=92848;b=a+232|0;c=k[b>>2]|0;if(c|0?(d=c+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+236>>2]=0;b=k[a+216>>2]|0;c=b;if(b|0){d=a+220|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+204>>2]|0;c=b;if(b|0){d=a+208|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+192>>2]|0;c=b;if(b|0){d=a+196|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+180>>2]|0;c=b;if(b|0){d=a+184|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+168>>2]|0;c=b;if(b|0){d=a+172|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~(((e+-24-c|0)>>>0)/24|0)*24|0);ggb(b)}b=k[a+156>>2]|0;c=b;if(b|0){d=a+160|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-32-c|0)>>>5)<<5);ggb(b)}b=k[a+144>>2]|0;c=b;if(b|0){d=a+148|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+132>>2]|0;c=b;if(b|0){d=a+136|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}b=k[a+108>>2]|0;if(b|0){c=a+112|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+84>>2]|0;c=b;if(b|0){d=a+88|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+44|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+40>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+24|0;c=a+12|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+48>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+52>>2]|0;if((b|0)==(a+56|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function MGa(a){a=a|0;LGa(a);ggb(a);return}function NGa(a){a=a|0;var b=0,c=0,d=0,e=0;b=k[a+84>>2]|0;c=a+88|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);b=k[a+96>>2]|0;c=a+100|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);b=k[a+108>>2]|0;c=a+112|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;b=k[a+120>>2]|0;c=a+124|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);b=k[a+132>>2]|0;c=a+136|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);b=k[a+144>>2]|0;c=a+148|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);b=k[a+156>>2]|0;c=a+160|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-32-b|0)>>>5)<<5);b=k[a+168>>2]|0;c=a+172|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~(((d+-24-b|0)>>>0)/24|0)*24|0);b=k[a+180>>2]|0;c=a+184|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);b=k[a+192>>2]|0;c=a+196|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);b=a+232|0;c=k[b>>2]|0;if(!c){k[b>>2]=0;d=a+236|0;k[d>>2]=0;a=a+228|0;i[a>>0]=0;return}e=c+4|0;d=k[e>>2]|0;k[e>>2]=d+-1;if((d|0)!=1){k[b>>2]=0;e=a+236|0;k[e>>2]=0;e=a+228|0;i[e>>0]=0;return}Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;e=a+236|0;k[e>>2]=0;e=a+228|0;i[e>>0]=0;return}function OGa(a,b){a=a|0;b=b|0;jh[k[(k[a>>2]|0)+228>>2]&1023](a,b);Ph[k[(k[a>>2]|0)+240>>2]&511](a,b,k[k[a+144>>2]>>2]|0);return}function PGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;g=j+8|0;h=j;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);jh[k[(k[a>>2]|0)+244>>2]&1023](a,b);e=k[b>>2]|0;f=k6(e,k[b+4>>2]|0,371485)|0;k[g>>2]=e;k[g+4>>2]=f;if(f|0){h=k[a>>2]|0;h=h+256|0;h=k[h>>2]|0;Hh[h&511](a,g)|0;r=j;return}b=h+4|0;c=ZT(20)|0;k[c>>2]=1;d=c+4|0;k[h>>2]=d;k[b>>2]=15;i[c+19>>0]=0;e=372258;f=d+15|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,h,401059,370820,1934);k[b>>2]=0;k[h>>2]=0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0);h=k[a>>2]|0;h=h+256|0;h=k[h>>2]|0;Hh[h&511](a,g)|0;r=j;return}function QGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;Ph[k[(k[a>>2]|0)+152>>2]&511](a,b,c);e=a+236|0;b=(Hh[k[(k[a>>2]|0)+164>>2]&511](a,(k[e>>2]|0)+128|0)|0)>-1;c=a+232|0;d=k[c>>2]|0;if(d|0?(g=d+4|0,f=k[g>>2]|0,k[g>>2]=f+-1,(f|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);k[c>>2]=0;k[e>>2]=0;Uh[k[(k[a>>2]|0)+156>>2]&2047](a);return b|0}function RGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0.0,q=0.0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;U=r;r=r+240|0;O=U+184|0;P=U+176|0;T=U+120|0;S=U+64|0;Q=U+56|0;R=U;K=a+144|0;L=a+148|0;if((k[K>>2]|0)==(k[L>>2]|0)){e=O+4|0;f=ZT(20)|0;k[f>>2]=1;h=f+4|0;k[O>>2]=h;k[e>>2]=14;i[f+18>>0]=0;g=372235;j=h+14|0;do{i[h>>0]=i[g>>0]|0;h=h+1|0;g=g+1|0}while((h|0)<(j|0));Y8(-215,O,372250,370820,1496);k[e>>2]=0;k[O>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0)}do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[T>>2]=k[g>>2];m=T+4|0;b=g+4|0;k[m>>2]=k[b>>2];n=T+8|0;k[n>>2]=k[g+8>>2];k[T+12>>2]=k[g+12>>2];k[T+16>>2]=k[g+16>>2];k[T+20>>2]=k[g+20>>2];k[T+24>>2]=k[g+24>>2];k[T+28>>2]=k[g+28>>2];k[T+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[T+36>>2]=e;f=T+40|0;k[f>>2]=n;J=T+48|0;j=T+44|0;k[j>>2]=J;k[T+52>>2]=0;k[J>>2]=0;if(e|0){J=e+12|0;k[J>>2]=(k[J>>2]|0)+1}if((k[b>>2]|0)<3){J=k[g+44>>2]|0;e=k[j>>2]|0;k[e>>2]=k[J>>2];k[e+4>>2]=k[J+4>>2];e=n;break}k[m>>2]=0;x1(T,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0));e=n}else e=n}else{Q1(T,b,-1);e=T+8|0}while(0);k[S>>2]=1124007936;J=S+4|0;b=S+8|0;H=S+40|0;h=J;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[H>>2]=b;I=S+48|0;G=S+44|0;k[G>>2]=I;k[S+52>>2]=0;k[I>>2]=0;n=k[e>>2]|0;E=(k[c>>2]&2031616|0)!=0;b=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;if(b)F=1.0;else F=1.0/+((k[L>>2]|0)-(k[K>>2]|0)>>2|0);D=(d&768|0)==512&b;if(!E)if((n|0)>1){n=1;C=42}else C=41;else{c2(c,n,1,D?4:5,-1,0,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[O>>2]=k[g>>2];m=O+4|0;b=g+4|0;k[m>>2]=k[b>>2];C=O+8|0;k[C>>2]=k[g+8>>2];k[O+12>>2]=k[g+12>>2];k[O+16>>2]=k[g+16>>2];k[O+20>>2]=k[g+20>>2];k[O+24>>2]=k[g+24>>2];k[O+28>>2]=k[g+28>>2];k[O+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[O+36>>2]=e;f=O+40|0;k[f>>2]=C;C=O+48|0;j=O+44|0;k[j>>2]=C;k[O+52>>2]=0;k[C>>2]=0;if(e|0){C=e+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[b>>2]|0)<3){B=k[g+44>>2]|0;C=k[j>>2]|0;k[C>>2]=k[B>>2];k[C+4>>2]=k[B+4>>2];break}k[m>>2]=0;x1(O,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(O,c,-1);while(0);KG(S,O)|0;f=O+36|0;b=k[f>>2]|0;if(b|0?(B=b+12|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[O+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;C=O+16|0;e=O+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[e>>2]|0)>0){f=k[O+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[O+44>>2]|0;if(!((b|0)==(O+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);C=41}if((C|0)==41)if((n|0)>0)C=42;else p=0.0;if((C|0)==42){j=Q+4|0;l=O+4|0;m=P+4|0;c=R+36|0;t=R+16|0;v=R+4|0;w=R+40|0;x=R+44|0;y=R+48|0;z=S+16|0;A=S+12|0;B=R+32|0;h=0;p=0.0;do{b=k[(k[a>>2]|0)+220>>2]|0;g=(k[L>>2]|0)-(k[K>>2]|0)>>2;k[Q>>2]=0;k[j>>2]=g;g=h;h=h+1|0;k[O>>2]=g;k[l>>2]=h;k[P>>2]=-2147483648;k[m>>2]=2147483647;H1(R,T,O,P);s=F*+wh[b&31](a,Q,R,d);b=k[c>>2]|0;if(b|0?(e=b+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){e=k[c>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[B>>2]|0;if(!b){b=B1()|0;e=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[c>>2]=0}k[c>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){e=k[w>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[v>>2]|0))}b=k[x>>2]|0;if(!((b|0)==(y|0)|(b|0)==0))ggb(k[b+-4>>2]|0);do if(E){if(!D){do if((k[S>>2]&16384|0)==0?(M=k[H>>2]|0,(k[M>>2]|0)!=1):0){b=k[z>>2]|0;e=k[G>>2]|0;if((k[M+4>>2]|0)==1){b=b+(aa(k[e>>2]|0,g)|0)|0;break}else{f=k[A>>2]|0;V=(g|0)/(f|0)|0;f=g-(aa(V,f)|0)|0;b=b+(aa(k[e>>2]|0,V)|0)+(f<<2)|0;break}}else C=60;while(0);if((C|0)==60){C=0;b=(k[z>>2]|0)+(g<<2)|0}o[b>>2]=s;break}b=(o[u>>2]=s,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;q=b?s+-8388608.0+8388608.0:s+8388608.0+-8388608.0;if(q==0.0)q=b?-0.0:0.0}else q=s;f=~~q;do if((k[S>>2]&16384|0)==0?(N=k[H>>2]|0,(k[N>>2]|0)!=1):0){b=k[z>>2]|0;e=k[G>>2]|0;if((k[N+4>>2]|0)==1){b=b+(aa(k[e>>2]|0,g)|0)|0;break}else{V=k[A>>2]|0;W=(g|0)/(V|0)|0;V=g-(aa(W,V)|0)|0;b=b+(aa(k[e>>2]|0,W)|0)+(V<<2)|0;break}}else C=70;while(0);if((C|0)==70){C=0;b=(k[z>>2]|0)+(g<<2)|0}k[b>>2]=f}while(0);p=(g|0)==0?s:p}while((h|0)<(n|0))}f=S+36|0;b=k[f>>2]|0;if(b|0?(V=b+12|0,W=k[V>>2]|0,k[V>>2]=W+-1,(W|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[S+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;W=S+16|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[J>>2]|0)>0){e=k[H>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[J>>2]|0))}b=k[G>>2]|0;if(!((b|0)==(I|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=T+36|0;b=k[f>>2]|0;if(b|0?(V=b+12|0,W=k[V>>2]|0,k[V>>2]=W+-1,(W|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[T+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;W=T+16|0;e=T+4|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[e>>2]|0)>0){f=k[T+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[T+44>>2]|0;if((b|0)==(T+48|0)|(b|0)==0){r=U;return +p}ggb(k[b+-4>>2]|0);r=U;return +p}function SGa(a,b){a=a|0;b=b|0;var c=0;c=a+4|0;j[c>>1]=j[b>>1]|0;i[c+2>>0]=i[b+2>>0]|0;KG(a+8|0,b+4|0)|0;a=a+64|0;b=b+60|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];return}function TGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=r;r=r+640|0;E=F+576|0;D=F+520|0;n=F+464|0;o=F+408|0;q=F+352|0;B=F+128|0;t=F+296|0;v=F+240|0;x=F+184|0;C=F+16|0;A=F;w=F+72|0;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);m=a+232|0;while(1){c=fgb(144)|0;if(c|0){l=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){l=0;break}Qh[c&7]()}d=l+4|0;f=l+128|0;g=l+132|0;zpb(l|0,0,140)|0;e=k[b>>2]|0;u=b+4|0;b=k[u>>2]|0;if(e){c=e+4|0;k[c>>2]=(k[c>>2]|0)+1;c=k[l>>2]|0;k[l>>2]=e;k[d>>2]=b;if(c|0?(y=c+4|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c)}else{k[l>>2]=0;k[d>>2]=b}j=k[u>>2]|0;jh[k[(k[j>>2]|0)+96>>2]&1023](E,j);j=E+16|0;if(k[j>>2]|0){d=k[E+4>>2]|0;if((d|0)<3)c=aa(k[E+12>>2]|0,k[E+8>>2]|0)|0;else{e=k[E+40>>2]|0;b=0;c=1;do{c=aa(k[e+(b<<2)>>2]|0,c)|0;b=b+1|0}while((b|0)!=(d|0))}if(c){z=D+4|0;y=z+4|0;k[y>>2]=0;k[y+4>>2]=0;k[D>>2]=-2113732604;k[z>>2]=f;mY(E,D);Dgb(k[f>>2]|0,k[g>>2]|0)}else s=17}else s=17;if((s|0)==17){e=k[u>>2]|0;e=Xh[k[(k[e>>2]|0)+20>>2]&1023](e)|0;d=k[g>>2]|0;b=k[f>>2]|0;c=d-b>>2;if(e>>>0<=c>>>0){if(e>>>0<c>>>0?(h=b+(e<<2)|0,(d|0)!=(h|0)):0)k[g>>2]=d+(~((d+-4-h|0)>>>2)<<2)}else U1(f,e-c|0);if((e|0)>0){b=k[f>>2]|0;c=0;do{k[b+(c<<2)>>2]=c;c=c+1|0}while((c|0)!=(e|0))}}k[l+140>>2]=0;d=E+36|0;c=k[d>>2]|0;if(c|0?(y=c+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[E+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;d=E+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[d>>2]|0)>0){b=k[E+40>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[E+44>>2]|0;if(!((c|0)==(E+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}b=c+4|0;k[b>>2]=1;k[c>>2]=93116;k[c+8>>2]=l;k[b>>2]=(k[b>>2]|0)+1;d=k[m>>2]|0;k[m>>2]=c;z=a+236|0;k[z>>2]=l;if(d|0?(m=d+4|0,y=k[m>>2]|0,k[m>>2]=y+-1,(y|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);y=k[b>>2]|0;k[b>>2]=y+-1;if((y|0)==1)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);d=k[u>>2]|0;jh[k[(k[d>>2]|0)+88>>2]&1023](E,d);d=D+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[D>>2]=-2113732608;k[d>>2]=a+108;mY(E,D);d=k[u>>2]|0;jh[k[(k[d>>2]|0)+124>>2]&1023](n,d);d=D+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[D>>2]=-2113732596;k[d>>2]=a+120;mY(n,D);d=n+36|0;c=k[d>>2]|0;if(c|0?(m=c+12|0,y=k[m>>2]|0,k[m>>2]=y+-1,(y|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[n+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;y=n+16|0;b=n+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[b>>2]|0)>0){d=k[n+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[n+44>>2]|0;if(!((c|0)==(n+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=k[u>>2]|0;jh[k[(k[d>>2]|0)+128>>2]&1023](o,d);d=D+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[D>>2]=-2113732604;k[d>>2]=a+132;mY(o,D);d=o+36|0;c=k[d>>2]|0;if(c|0?(n=c+12|0,y=k[n>>2]|0,k[n>>2]=y+-1,(y|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[o+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;y=o+16|0;b=o+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[b>>2]|0)>0){d=k[o+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[o+44>>2]|0;if(!((c|0)==(o+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=k[u>>2]|0;jh[k[(k[d>>2]|0)+112>>2]&1023](q,d);d=D+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[D>>2]=-2113732603;k[d>>2]=a+204;mY(q,D);d=q+36|0;c=k[d>>2]|0;if(c|0?(o=c+12|0,y=k[o>>2]|0,k[o>>2]=y+-1,(y|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[q+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;y=q+16|0;b=q+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[b>>2]|0)>0){d=k[q+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);g=k[u>>2]|0;g=Xh[k[(k[g>>2]|0)+28>>2]&1023](g)|0;y=k[u>>2]|0;jh[k[(k[y>>2]|0)+84>>2]&1023](D,y);y=D+16|0;if(k[y>>2]|0){d=k[D+4>>2]|0;if((d|0)<3)c=aa(k[D+12>>2]|0,k[D+8>>2]|0)|0;else{e=k[D+40>>2]|0;b=0;c=1;do{c=aa(k[e+(b<<2)>>2]|0,c)|0;b=b+1|0}while((b|0)!=(d|0))}if(c){q=B+4|0;o=q+4|0;k[o>>2]=0;k[o+4>>2]=0;k[B>>2]=-2113732604;k[q>>2]=a+84;mY(D,B)}else s=93}else s=93;if((s|0)==93){d=a+84|0;e=a+88|0;f=k[e>>2]|0;b=k[d>>2]|0;c=f-b>>2;do if(g>>>0>c>>>0)U1(d,g-c|0);else{if(g>>>0>=c>>>0)break;c=b+(g<<2)|0;if((f|0)==(c|0))break;k[e>>2]=f+(~((f+-4-c|0)>>>2)<<2)}while(0);if((g|0)>0){b=k[d>>2]|0;c=0;do{k[b+(c<<2)>>2]=c;c=c+1|0}while((c|0)!=(g|0))}}Uh[k[(k[a>>2]|0)+160>>2]&2047](a);g=(k[z>>2]|0)+140|0;k[g>>2]=0;f=k[a+84>>2]|0;s=(k[a+88>>2]|0)-f|0;e=s>>2;if((s|0)>0){d=k[a+120>>2]|0;b=0;c=0;do{s=k[f+(b<<2)>>2]|0;s=(k[d+(s<<3)+4>>2]|0)-(k[d+(s<<3)>>2]|0)|0;c=(c|0)<(s|0)?s:c;k[g>>2]=c;b=b+1|0}while((b|0)<(e|0))}else c=0;c=(c+31|0)/32|0;k[g>>2]=(c|0)<1?1:c;c=k[u>>2]|0;jh[k[(k[c>>2]|0)+72>>2]&1023](t,c);c=(k[z>>2]|0)+92|0;d=B+4|0;s=d+4|0;k[s>>2]=0;k[s+4>>2]=0;k[B>>2]=-2113732602;k[d>>2]=c;mY(t,B);d=t+36|0;c=k[d>>2]|0;do if(c|0){q=c+12|0;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[t+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;s=t+16|0;b=t+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[b>>2]|0)>0){d=k[t+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[t+44>>2]|0;if(!((c|0)==(t+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);t=k[u>>2]|0;t=(Xh[k[(k[t>>2]|0)+92>>2]&1023](t)|0)==1;i[a+228>>0]=t&1;c=k[u>>2]|0;b=k[c>>2]|0;do if(t){jh[k[b+68>>2]&1023](v,c);c=(k[z>>2]|0)+104|0;d=B+4|0;w=d+4|0;k[w>>2]=0;k[w+4>>2]=0;k[B>>2]=-2113732604;k[d>>2]=c;mY(v,B);d=v+36|0;c=k[d>>2]|0;do if(c|0){t=c+12|0;w=k[t>>2]|0;k[t>>2]=w+-1;if((w|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[v+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;w=v+16|0;b=v+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[b>>2]|0)>0){d=k[v+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[v+44>>2]|0;if(!((c|0)==(v+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=k[u>>2]|0;jh[k[(k[e>>2]|0)+120>>2]&1023](x,e);e=a+192|0;d=B+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[B>>2]=-2113732604;k[d>>2]=e;mY(x,B);d=x+36|0;c=k[d>>2]|0;do if(c|0){v=c+12|0;w=k[v>>2]|0;k[v>>2]=w+-1;if((w|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[x+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;w=x+16|0;b=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[b>>2]|0)>0){d=k[x+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[x+44>>2]|0;if(!((c|0)==(x+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);m=(k[a+196>>2]|0)-(k[e>>2]|0)>>2;k[B>>2]=k[a+8>>2];t=B+4|0;b=a+12|0;c=k[b>>2]|0;k[t>>2]=c;g=B+8|0;k[g>>2]=k[a+16>>2];h=B+12|0;k[h>>2]=k[a+20>>2];o=B+16|0;k[o>>2]=k[a+24>>2];k[B+20>>2]=k[a+28>>2];k[B+24>>2]=k[a+32>>2];k[B+28>>2]=k[a+36>>2];n=B+32|0;k[n>>2]=k[a+40>>2];q=B+36|0;d=k[a+44>>2]|0;k[q>>2]=d;s=B+40|0;k[s>>2]=g;v=B+48|0;u=B+44|0;k[u>>2]=v;k[B+52>>2]=0;k[v>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[b>>2]|0}do if((c|0)<3){x=k[a+52>>2]|0;a=k[u>>2]|0;k[a>>2]=k[x>>2];k[a+4>>2]=k[x+4>>2]}else{k[t>>2]=0;x1(B,c,0,0,0);if((k[t>>2]|0)<=0)break;e=k[a+48>>2]|0;f=k[s>>2]|0;b=k[a+52>>2]|0;d=k[u>>2]|0;c=0;do{k[f+(c<<2)>>2]=k[e+(c<<2)>>2];k[d+(c<<2)>>2]=k[b+(c<<2)>>2];c=c+1|0}while((c|0)<(k[t>>2]|0))}while(0);do if(k[o>>2]|0){e=k[t>>2]|0;if((e|0)<3)c=aa(k[h>>2]|0,k[g>>2]|0)|0;else{d=k[s>>2]|0;b=0;c=1;do{c=aa(k[d+(b<<2)>>2]|0,c)|0;b=b+1|0}while((b|0)!=(e|0))}if(!c)break;if((k[B>>2]&20479|0)!=16390){k[C>>2]=1124007936;h=C+4|0;c=C+8|0;f=C+40|0;j=h;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[f>>2]=c;g=C+48|0;e=C+44|0;k[e>>2]=g;k[C+52>>2]=0;k[g>>2]=0;d=A+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[A>>2]=33619968;k[d>>2]=C;SW(B,A,6,1.0,0.0);KG(B,C)|0;d=C+36|0;c=k[d>>2]|0;do if(c|0){a=c+12|0;A=k[a>>2]|0;k[a>>2]=A+-1;if((A|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[C+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;A=C+16|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[h>>2]|0)>0){b=k[f>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[e>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}if((y2(B,1,6,1)|0)!=(m|0)){k[C>>2]=0;c=C+4|0;k[c>>2]=0;b=ZT(56)|0;k[b>>2]=1;j=b+4|0;k[C>>2]=j;k[c>>2]=48;i[b+52>>0]=0;h=372023;l=j+48|0;do{i[j>>0]=i[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(l|0));Y8(-215,C,372072,370820,186);k[c>>2]=0;k[C>>2]=0;B=k[b>>2]|0;k[b>>2]=B+-1;if((B|0)==1)ggb(k[b+-4>>2]|0)}B=k[z>>2]|0;c=(k[B+108>>2]|0)-(k[B+104>>2]|0)|0;f=c>>2;g=k[o>>2]|0;if(((k[B+96>>2]|0)-(k[B+92>>2]|0)>>3|0)!=(f|0)){k[C>>2]=0;b=C+4|0;k[b>>2]=0;d=ZT(48)|0;k[d>>2]=1;j=d+4|0;k[C>>2]=j;k[b>>2]=41;i[d+45>>0]=0;h=372086;l=j+41|0;do{i[j>>0]=i[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(l|0));Y8(-215,C,372072,370820,190);k[b>>2]=0;k[C>>2]=0;B=k[d>>2]|0;k[d>>2]=B+-1;if((B|0)==1)ggb(k[d+-4>>2]|0)}if((c|0)<=0)break;d=C+4|0;b=0;c=k[z>>2]|0;do{e=k[(k[c+104>>2]|0)+(b<<2)>>2]|0;if(!((e|0)>-1&(e|0)<(m|0))){k[C>>2]=0;k[d>>2]=0;c=ZT(32)|0;k[c>>2]=1;j=c+4|0;k[C>>2]=j;k[d>>2]=24;i[c+28>>0]=0;h=372128;l=j+24|0;do{i[j>>0]=i[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(l|0));Y8(-215,C,372072,370820,195);k[d>>2]=0;k[C>>2]=0;B=k[c>>2]|0;k[c>>2]=B+-1;if((B|0)==1)ggb(k[c+-4>>2]|0);c=k[z>>2]|0}B=(k[c+92>>2]|0)+(b<<3)|0;p[B>>3]=+p[g+(e<<3)>>3]*+p[B>>3];b=b+1|0}while((b|0)<(f|0))}while(0);c=k[q>>2]|0;do if(c|0){B=c+12|0;C=k[B>>2]|0;k[B>>2]=C+-1;if((C|0)!=1)break;b=k[q>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[n>>2]|0;if(c|0)break;c=B1()|0;b=k[q>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[q>>2]=0}while(0);k[q>>2]=0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[t>>2]|0)>0){b=k[s>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[t>>2]|0))}c=k[u>>2]|0;if(!((c|0)==(v|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}else{jh[k[b+64>>2]&1023](w,c);c=(k[z>>2]|0)+116|0;d=B+4|0;C=d+4|0;k[C>>2]=0;k[C+4>>2]=0;k[B>>2]=-2113732602;k[d>>2]=c;mY(w,B);d=w+36|0;c=k[d>>2]|0;do if(c|0){B=c+12|0;C=k[B>>2]|0;k[B>>2]=C+-1;if((C|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[w+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;C=w+16|0;b=w+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[b>>2]|0)>0){d=k[w+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[w+44>>2]|0;if((c|0)==(w+48|0)|(c|0)==0)break;ggb(k[c+-4>>2]|0)}while(0);d=D+36|0;c=k[d>>2]|0;do if(c|0){B=c+12|0;C=k[B>>2]|0;k[B>>2]=C+-1;if((C|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[D+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;d=D+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[d>>2]|0)>0){b=k[D+40>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[D+44>>2]|0;if(!((c|0)==(D+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=E+36|0;c=k[d>>2]|0;do if(c|0){C=c+12|0;D=k[C>>2]|0;k[C>>2]=D+-1;if((D|0)!=1)break;b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;do if(!c){c=k[E+32>>2]|0;if(c|0)break;c=B1()|0;b=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}while(0);k[d>>2]=0;D=E+16|0;b=E+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[b>>2]|0)>0){d=k[E+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[E+44>>2]|0;if((c|0)==(E+48|0)|(c|0)==0){r=F;return}ggb(k[c+-4>>2]|0);r=F;return}function UGa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+232|0;c=k[b>>2]|0;if(c|0?(e=c+4|0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+236>>2]=0;return}function VGa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;l=o;m=(k[a+112>>2]|0)-(k[a+108>>2]|0)|0;n=a+96|0;g=a+104|0;b=k[g>>2]|0;f=k[n>>2]|0;d=f;do if(b-f>>2>>>0<m>>>0){e=f;if(f){b=a+100|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-4-f|0)>>>2)<<2);ggb(e);k[g>>2]=0;k[b>>2]=0;k[n>>2]=0;b=0}if(m>>>0>1073741823)ad(426534,426557,304,426811);f=b>>1;f=b>>2>>>0<536870911?(f>>>0<m>>>0?m:f):1073741823;if(f>>>0>1073741823)bob();c=f<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0){d=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){d=0;break}Qh[b&7]()}e=a+100|0;k[e>>2]=d;k[n>>2]=d;k[g>>2]=d+(f<<2);b=m;c=d;while(1){k[c>>2]=-1;b=b+-1|0;if(!b)break;else c=c+4|0}k[e>>2]=d+(m<<2)}else{h=a+100|0;g=k[h>>2]|0;e=g-f>>2;f=m>>>0>e>>>0;b=f?e:m;if(b|0){c=d;while(1){k[c>>2]=-1;b=b+-1|0;if(!b)break;else c=c+4|0}}if(!f){b=d+(m<<2)|0;if((g|0)==(b|0))break;k[h>>2]=g+(~((g+-4-b|0)>>>2)<<2);break}c=m-e|0;b=c;e=g;while(1){k[e>>2]=-1;b=b+-1|0;if(!b)break;else e=e+4|0}k[h>>2]=g+(c<<2)}while(0);j=a+84|0;c=k[j>>2]|0;a=(k[a+88>>2]|0)-c|0;h=a>>2;if((a|0)<=0){r=o;return}a=l+4|0;e=-1;b=0;while(1){g=k[c+(b<<2)>>2]|0;if(!((g|0)>(e|0)&((g|0)>-1&(g|0)<(m|0)))){c=ZT(48)|0;k[c>>2]=1;d=c+4|0;k[l>>2]=d;k[a>>2]=40;i[c+44>>0]=0;e=371967;f=d+40|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,l,372008,370820,213);k[a>>2]=0;k[l>>2]=0;f=k[c>>2]|0;k[c>>2]=f+-1;if((f|0)==1)ggb(k[c+-4>>2]|0);d=k[n>>2]|0}k[d+(g<<2)>>2]=b;b=b+1|0;if((b|0)>=(h|0))break;e=g;c=k[j>>2]|0}r=o;return}function WGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;R=r;r=r+64|0;Q=R+56|0;M=R;O=R+32|0;m=k[a+68>>2]|0;P=a+236|0;l=k[P>>2]|0;f=l+8|0;g=l+12|0;h=k[f>>2]|0;j=(k[g>>2]|0)-h|0;e=(j|0)/104|0;m=e+((m|0)>0?1<<m:1024)|0;l=l+16|0;if((((k[l>>2]|0)-h|0)/104|0)>>>0<m>>>0){if(!m)c=0;else{if(m>>>0>41297762){R=te(4)|0;k[R>>2]=172664;Cf(R|0,28816,1287)}d=m*104|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}d=c+(e*104|0)|0;e=d+(((j|0)/-104|0)*104|0)|0;if((j|0)>0)upb(e|0,h|0,j|0)|0;k[f>>2]=e;k[g>>2]=d;k[l>>2]=c+(m*104|0);if(h|0)ggb(h)}c=k[P>>2]|0;h=c+20|0;j=c+28|0;l=k[h>>2]|0;if((((k[j>>2]|0)-l|0)/24|0)>>>0<m>>>0){f=c+24|0;g=(k[f>>2]|0)-l|0;e=(g|0)/24|0;if(!m)c=0;else{if(m>>>0>178956970){R=te(4)|0;k[R>>2]=172664;Cf(R|0,28816,1287)}d=m*24|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}d=c+(e*24|0)|0;e=d+(((g|0)/-24|0)*24|0)|0;if((g|0)>0)upb(e|0,l|0,g|0)|0;k[h>>2]=e;k[f>>2]=d;k[j>>2]=c+(m*24|0);if(l|0)ggb(l)}c=k[P>>2]|0;zHa(c+32|0,aa(k[c+140>>2]|0,m)|0);c=k[P>>2]|0;d=k[c+8>>2]|0;e=c+12|0;f=k[e>>2]|0;if((f|0)!=(d|0))k[e>>2]=f+(~(((f+-104-d|0)>>>0)/104|0)*104|0);d=k[c+20>>2]|0;e=c+24|0;f=k[e>>2]|0;if((f|0)!=(d|0))k[e>>2]=f+(~(((f+-24-d|0)>>>0)/24|0)*24|0);d=k[c+32>>2]|0;e=c+36|0;f=k[e>>2]|0;if((f|0)!=(d|0))k[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);d=k[a+76>>2]|0;do if((d|0)>0){h=c+44|0;j=aa(d,m)|0;d=c+48|0;g=k[d>>2]|0;f=k[h>>2]|0;e=g-f>>3;if(j>>>0<=e>>>0){if(j>>>0<e>>>0?(n=f+(j<<3)|0,(g|0)!=(n|0)):0)k[d>>2]=g+(~((g+-8-n|0)>>>3)<<3)}else{Bla(h,j-e|0);c=k[P>>2]|0}d=c+68|0;e=c+72|0;h=k[e>>2]|0;g=k[d>>2]|0;f=h-g>>3;if(j>>>0<=f>>>0){if(j>>>0<f>>>0?(o=g+(j<<3)|0,(h|0)!=(o|0)):0)k[e>>2]=h+(~((h+-8-o|0)>>>3)<<3)}else{Bla(d,j-f|0);c=k[P>>2]|0}g=c+56|0;c=c+60|0;f=k[c>>2]|0;d=k[g>>2]|0;e=f-d>>3;if(j>>>0>e>>>0){Bla(g,j-e|0);break}if(j>>>0<e>>>0?(q=d+(j<<3)|0,(f|0)!=(q|0)):0)k[c>>2]=f+(~((f+-8-q|0)>>>3)<<3)}while(0);c=ci[k[(k[a>>2]|0)+168>>2]&255](a,-1,b)|0;b=a+156|0;q=a+160|0;k[Q>>2]=(k[q>>2]|0)-(k[b>>2]|0)>>5;s=M+8|0;t=M+12|0;u=M+24|0;v=O+4|0;w=O+8|0;x=O+12|0;y=O+16|0;z=O+20|0;A=a+120|0;B=a+180|0;C=a+184|0;D=a+168|0;E=a+172|0;F=M+28|0;G=a+176|0;H=a+164|0;I=O+4|0;J=O+4|0;K=t+4|0;o=-1;e=0;a:while(1){d=k[P>>2]|0;n=k[d+8>>2]|0;k[K>>2]=-1;k[K+4>>2]=-1;k[K+8>>2]=-1;k[K+12>>2]=-1;k[t>>2]=o;k[s>>2]=k[n+(c*104|0)>>2];p[M>>3]=+p[n+(c*104|0)+16>>3];k[u>>2]=k[n+(c*104|0)+36>>2];f=k[n+(c*104|0)+40>>2]|0;if((f|0)>-1){m=k[d+20>>2]|0;k[x>>2]=-1;k[y>>2]=k[m+(f*24|0)+16>>2];k[w>>2]=k[m+(f*24|0)+8>>2];i[v>>0]=i[m+(f*24|0)+4>>0]|0;d=k[m+(f*24|0)>>2]|0;k[O>>2]=d;k[z>>2]=-1;m=m+(f*24|0)+20|0;if((k[m>>2]|0)>-1){f=k[A>>2]|0;d=(k[f+(d<<3)+4>>2]|0)+31-(k[f+(d<<3)>>2]|0)|0;f=(d|0)/32|0;l=k[C>>2]|0;j=k[B>>2]|0;g=l-j>>2;k[z>>2]=g;h=g+f|0;if(h>>>0<=g>>>0){if(h>>>0<g>>>0?(L=j+(h<<2)|0,(l|0)!=(L|0)):0)k[C>>2]=l+(~((l+-4-L|0)>>>2)<<2)}else U1(B,f);if((d|0)>31)upb((k[B>>2]|0)+(g<<2)|0,(k[(k[P>>2]|0)+32>>2]|0)+(k[m>>2]<<2)|0,f<<2|0)|0}d=k[E>>2]|0;k[F>>2]=(d-(k[D>>2]|0)|0)/24|0;if((d|0)==(k[G>>2]|0))tHa(D,O);else{m=d;k[m>>2]=k[O>>2];k[m+4>>2]=k[O+4>>2];k[m+8>>2]=k[O+8>>2];k[m+12>>2]=k[O+12>>2];k[m+16>>2]=k[O+16>>2];k[m+20>>2]=k[O+20>>2];k[E>>2]=(k[E>>2]|0)+24}}d=k[q>>2]|0;g=d-(k[b>>2]|0)>>5;if((d|0)==(k[H>>2]|0))sHa(b,M);else{m=d;k[m>>2]=k[M>>2];k[m+4>>2]=k[M+4>>2];k[m+8>>2]=k[M+8>>2];k[m+12>>2]=k[M+12>>2];k[m+16>>2]=k[M+16>>2];k[m+20>>2]=k[M+20>>2];k[m+24>>2]=k[M+24>>2];k[m+28>>2]=k[M+28>>2];k[q>>2]=(k[q>>2]|0)+32}do if((o|0)>-1){d=k[(k[P>>2]|0)+8>>2]|0;f=k[d+(c*104|0)+24>>2]|0;if((k[d+(f*104|0)+28>>2]|0)==(c|0)){k[(k[b>>2]|0)+(o<<5)+16>>2]=g;break}if((k[d+(f*104|0)+32>>2]|0)!=(c|0)){d=ZT(40)|0;k[d>>2]=1;f=d+4|0;k[O>>2]=f;k[I>>2]=33;i[d+37>>0]=0;j=371913;l=f+33|0;do{i[f>>0]=i[j>>0]|0;f=f+1|0;j=j+1|0}while((f|0)<(l|0));Y8(-215,O,371947,370820,312);k[I>>2]=0;k[O>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0)}k[(k[b>>2]|0)+(o<<5)+20>>2]=g}while(0);f=k[n+(c*104|0)+28>>2]|0;if((f|0)>-1?(N=e+1|0,(N|0)!=2147483647):0){d=g;e=N;c=f}else{d=k[n+(c*104|0)+24>>2]|0;if((d|0)<=-1)break;f=k[(k[P>>2]|0)+8>>2]|0;g=o;while(1){h=k[f+(d*104|0)+32>>2]|0;if((h|0)!=(c|0))break;c=k[f+(d*104|0)+24>>2]|0;if((c|0)>-1){o=d;d=c;g=k[(k[b>>2]|0)+(g<<5)+12>>2]|0;e=e+-1|0;c=o}else break a}if((h|0)>-1){d=g;c=h}else{c=ZT(16)|0;k[c>>2]=1;f=c+4|0;k[O>>2]=f;k[J>>2]=11;i[c+15>>0]=0;j=371955;l=f+11|0;do{i[f>>0]=i[j>>0]|0;f=f+1|0;j=j+1|0}while((f|0)<(l|0));Y8(-215,O,371947,370820,339);k[J>>2]=0;k[O>>2]=0;o=k[c>>2]|0;k[c>>2]=o+-1;if((o|0)==1)ggb(k[c+-4>>2]|0);d=g;c=h}}o=d}c=a+148|0;d=k[c>>2]|0;if((d|0)==(k[a+152>>2]|0)){Q4(a+144|0,Q);Q=k[Q>>2]|0;r=R;return Q|0}else{Q=k[Q>>2]|0;k[d>>2]=Q;k[c>>2]=d+4;r=R;return Q|0}return 0}function XGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;A=r;r=r+80|0;z=A;x=A+32|0;y=A+24|0;w=a+236|0;d=k[w>>2]|0;k[z>>2]=-1;k[z+4>>2]=-1;k[z+8>>2]=-1;k[z+12>>2]=-1;k[z+16>>2]=-1;q=x+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;k[q+16>>2]=0;k[q+20>>2]=0;k[q+24>>2]=0;k[q+28>>2]=0;q=d+12|0;e=k[q>>2]|0;s=d+16|0;n=k[s>>2]|0;f=n;if((e|0)==(n|0)){m=d+8|0;n=k[m>>2]|0;l=e-n|0;h=(l|0)/104|0;d=h+1|0;if(d>>>0>41297762)ad(426534,426557,304,426811);j=(f-n|0)/104|0;f=j<<1;f=j>>>0<20648881?(f>>>0<d>>>0?d:f):41297762;if(!f)d=0;else{if(f>>>0>41297762){A=te(4)|0;k[A>>2]=172664;Cf(A|0,28816,1287)}e=f*104|0;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}g=d+(h*104|0)|0;e=d+(f*104|0)|0;k[g>>2]=0;p[d+(h*104|0)+8>>3]=2147483647.0;p[d+(h*104|0)+16>>3]=0.0;f=d+(h*104|0)+24|0;k[f>>2]=k[z>>2];k[f+4>>2]=k[z+4>>2];k[f+8>>2]=k[z+8>>2];k[f+12>>2]=k[z+12>>2];k[f+16>>2]=k[z+16>>2];k[d+(h*104|0)+44>>2]=0;k[d+(h*104|0)+48>>2]=0;p[d+(h*104|0)+56>>3]=0.0;k[d+(h*104|0)+64>>2]=0;f=g+68|0;h=x;j=f+36|0;do{k[f>>2]=k[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(j|0));d=g+(((l|0)/-104|0)*104|0)|0;if((l|0)>0)upb(d|0,n|0,l|0)|0;k[m>>2]=d;k[q>>2]=g+104;k[s>>2]=e;if(n|0)ggb(n)}else{k[e>>2]=0;p[e+8>>3]=2147483647.0;p[e+16>>3]=0.0;f=e+24|0;k[f>>2]=k[z>>2];k[f+4>>2]=k[z+4>>2];k[f+8>>2]=k[z+8>>2];k[f+12>>2]=k[z+12>>2];k[f+16>>2]=k[z+16>>2];k[e+44>>2]=0;k[e+48>>2]=0;p[e+56>>3]=0.0;k[e+64>>2]=0;f=e+68|0;h=x;j=f+36|0;do{k[f>>2]=k[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(j|0));k[q>>2]=(k[q>>2]|0)+104}d=k[w>>2]|0;q=k[d+12>>2]|0;e=k[d+8>>2]|0;f=(q-e|0)/104|0;s=f+-1|0;k[q+-80>>2]=b;if((b|0)>-1)e=(k[e+(b*104|0)+48>>2]|0)+1|0;else e=0;n=q+-56|0;k[n>>2]=e;e=k[a+76>>2]|0;do if((e|0)>0){j=d+44|0;l=aa(e,f)|0;e=d+48|0;h=k[e>>2]|0;g=k[j>>2]|0;f=h-g>>3;if(l>>>0<=f>>>0){if(l>>>0<f>>>0?(t=g+(l<<3)|0,(h|0)!=(t|0)):0)k[e>>2]=h+(~((h+-8-t|0)>>>3)<<3)}else{Bla(j,l-f|0);d=k[w>>2]|0}e=d+68|0;f=d+72|0;j=k[f>>2]|0;h=k[e>>2]|0;g=j-h>>3;if(l>>>0<=g>>>0){if(l>>>0<g>>>0?(u=h+(l<<3)|0,(j|0)!=(u|0)):0)k[f>>2]=j+(~((j+-8-u|0)>>>3)<<3)}else{Bla(e,l-g|0);d=k[w>>2]|0}h=d+56|0;d=d+60|0;g=k[d>>2]|0;e=k[h>>2]|0;f=g-e>>3;if(l>>>0>f>>>0){Bla(h,l-f|0);break}if(l>>>0<f>>>0?(v=e+(l<<3)|0,(g|0)!=(v|0)):0)k[d>>2]=g+(~((g+-8-v|0)>>>3)<<3)}while(0);d=(k[c+4>>2]|0)-(k[c>>2]|0)|0;h=d>>2;k[q+-60>>2]=h;k[z>>2]=0;m=z+4|0;k[m>>2]=0;k[z+8>>2]=0;k[x>>2]=0;l=x+4|0;k[l>>2]=0;k[x+8>>2]=0;Ph[k[(k[a>>2]|0)+180>>2]&511](a,s,c);do if((h|0)>(k[a+72>>2]|0)?(k[n>>2]|0)<(k[a+68>>2]|0):0){if(!(i[a+228>>0]|0)){B=+Q(+(+p[q+-24>>3]));if(B<+o[a+80>>2])break}else{e=k[(k[w>>2]|0)+104>>2]|0;f=k[c>>2]|0;g=k[e+(k[f>>2]<<2)>>2]|0;a:do if((d|0)>4){d=1;do{if((k[e+(k[f+(d<<2)>>2]<<2)>>2]|0)!=(g|0))break a;d=d+1|0}while((d|0)<(h|0))}else d=1;while(0);if((d|0)==(h|0))break}v=Hh[k[(k[a>>2]|0)+176>>2]&511](a,c)|0;k[q+-64>>2]=v}while(0);d=k[q+-64>>2]|0;if((d|0)>-1){c=$g[k[(k[a>>2]|0)+204>>2]&127](a,d,c,z,x)|0;k[q+-68>>2]=c;if(i[a+4>>0]|0){k[y>>2]=0;d=y+4|0;k[d>>2]=0;e=ZT(48)|0;k[e>>2]=1;f=e+4|0;k[y>>2]=f;k[d>>2]=40;i[e+44>>0]=0;h=371799;j=f+40|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-213,y,371840,370820,402);k[d>>2]=0;k[y>>2]=0;c=k[e>>2]|0;k[e>>2]=c+-1;if((c|0)==1)ggb(k[e+-4>>2]|0)}c=ci[k[(k[a>>2]|0)+168>>2]&255](a,s,z)|0;a=ci[k[(k[a>>2]|0)+168>>2]&255](a,s,x)|0;w=k[(k[w>>2]|0)+8>>2]|0;k[w+(s*104|0)+28>>2]=c;k[w+(s*104|0)+32>>2]=a;if(!((c|0)>0&(a|0)>0)){k[y>>2]=0;d=y+4|0;k[d>>2]=0;e=ZT(60)|0;k[e>>2]=1;f=e+4|0;k[y>>2]=f;k[d>>2]=53;i[e+57>>0]=0;h=371859;j=f+53|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-215,y,371840,370820,408);k[d>>2]=0;k[y>>2]=0;y=k[e>>2]|0;k[e>>2]=y+-1;if((y|0)==1)ggb(k[e+-4>>2]|0)}}d=k[x>>2]|0;e=d;if(d|0){f=k[l>>2]|0;if((f|0)!=(d|0))k[l>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(d)}d=k[z>>2]|0;if(!d){r=A;return s|0}e=k[m>>2]|0;if((e|0)!=(d|0))k[m>>2]=e+(~((e+-4-d|0)>>>2)<<2);ggb(d);r=A;return s|0}function YGa(a){a=a|0;return a+84|0}function ZGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;aa=r;r=r+1104|0;$=aa+24|0;P=aa+1091|0;X=aa+1088|0;S=aa;R=Xh[k[(k[a>>2]|0)+172>>2]&1023](a)|0;f=(k[R+4>>2]|0)-(k[R>>2]|0)|0;Q=f>>2;Y=a+236|0;e=(k[Y>>2]|0)+140|0;d=k[e>>2]|0;g=d<<1;Z=$+8|0;k[$>>2]=Z;_=$+4|0;k[_>>2]=264;if(g>>>0>264){d=g>>>0>1073741823?-1:g<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[$>>2]=c;d=k[e>>2]|0}else c=Z;k[_>>2]=g;if((f|0)>0){N=a+108|0;O=a+228|0;J=S+4|0;n=S+5|0;x=S+8|0;B=S+12|0;F=S+16|0;K=S+4|0;p=S+5|0;y=S+8|0;C=S+12|0;G=S+16|0;L=S+4|0;v=S+5|0;z=S+8|0;D=S+12|0;H=S+16|0;M=S+4|0;w=S+5|0;A=S+8|0;E=S+12|0;I=S+16|0;m=0;j=0;l=c+(d<<2)|0;t=0.0;g=0;u=0.0;h=0;while(1){d=k[(k[R>>2]|0)+(m<<2)>>2]|0;e=(i[O>>0]|0)!=0;do if((i[(k[N>>2]|0)+d>>0]|0)==1)if(e){$h[k[(k[a>>2]|0)+192>>2]&7](S,a,d,b,0.0,c);d=k[S>>2]|0;f=i[J>>0]|0;i[P>>0]=i[n>>0]|0;i[P+1>>0]=i[n+1>>0]|0;i[P+2>>0]=i[n+2>>0]|0;q=+o[x>>2];e=k[B>>2]|0;s=+o[F>>2];break}else{$h[k[(k[a>>2]|0)+200>>2]&7](S,a,d,b,0.0,c);d=k[S>>2]|0;f=i[K>>0]|0;i[P>>0]=i[p>>0]|0;i[P+1>>0]=i[p+1>>0]|0;i[P+2>>0]=i[p+2>>0]|0;q=+o[y>>2];e=k[C>>2]|0;s=+o[G>>2];break}else if(e){kh[k[(k[a>>2]|0)+184>>2]&7](S,a,d,b,0.0);d=k[S>>2]|0;f=i[L>>0]|0;i[P>>0]=i[v>>0]|0;i[P+1>>0]=i[v+1>>0]|0;i[P+2>>0]=i[v+2>>0]|0;q=+o[z>>2];e=k[D>>2]|0;s=+o[H>>2];break}else{kh[k[(k[a>>2]|0)+196>>2]&7](S,a,d,b,0.0);d=k[S>>2]|0;f=i[M>>0]|0;i[P>>0]=i[w>>0]|0;i[P+1>>0]=i[w+1>>0]|0;i[P+2>>0]=i[w+2>>0]|0;q=+o[A>>2];e=k[E>>2]|0;s=+o[I>>2];break}while(0);if(q>t){i[X>>0]=i[P>>0]|0;i[X+1>>0]=i[P+1>>0]|0;i[X+2>>0]=i[P+2>>0]|0;W=d;d=c;c=l;V=e;U=f}else{W=j;d=l;q=t;V=g;s=u;U=h}m=m+1|0;if((m|0)>=(Q|0))break;else{j=W;l=d;t=q;g=V;u=s;h=U}}if(q>0.0){if((k[(k[a+96>>2]|0)+(W<<2)>>2]|W|0)<=-1){k[S>>2]=0;c=S+4|0;k[c>>2]=0;e=ZT(56)|0;k[e>>2]=1;f=e+4|0;k[S>>2]=f;k[c>>2]=50;i[e+54>>0]=0;g=371734;h=f+50|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,S,371785,370820,451);k[c>>2]=0;k[S>>2]=0;S=k[e>>2]|0;k[e>>2]=S+-1;if((S|0)==1)ggb(k[e+-4>>2]|0)}j=k[Y>>2]|0;h=j+32|0;j=j+36|0;g=k[j>>2]|0;f=k[h>>2]|0;p=g-f>>2;c=k[a+120>>2]|0;c=(k[c+(W<<3)+4>>2]|0)+31-(k[c+(W<<3)>>2]|0)|0;l=(c|0)/32|0;e=l+p|0;if(p>>>0>=e>>>0){if(p>>>0>e>>>0?(T=f+(e<<2)|0,(g|0)!=(T|0)):0)k[j>>2]=g+(~((g+-4-T|0)>>>2)<<2)}else U1(h,l);if((c|0)>31){e=k[Y>>2]|0;f=k[e+32>>2]|0;c=0;do{k[f+(c+p<<2)>>2]=k[d+(c<<2)>>2];c=c+1|0}while((c|0)<(l|0))}else e=k[Y>>2]|0;m=e+24|0;c=k[m>>2]|0;n=e+28|0;T=k[n>>2]|0;d=T;if((c|0)==(T|0)){j=e+20|0;l=k[j>>2]|0;h=c-l|0;g=(h|0)/24|0;c=g+1|0;if(c>>>0>178956970)ad(426534,426557,304,426811);T=(d-l|0)/24|0;f=T<<1;f=T>>>0<89478485?(f>>>0<c>>>0?c:f):178956970;if(!f)e=0;else{if(f>>>0>178956970){aa=te(4)|0;k[aa>>2]=172664;Cf(aa|0,28816,1287)}d=f*24|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=c}d=e+(g*24|0)|0;k[d>>2]=W;i[e+(g*24|0)+4>>0]=U;c=d+5|0;i[c>>0]=i[X>>0]|0;i[c+1>>0]=i[X+1>>0]|0;i[c+2>>0]=i[X+2>>0]|0;o[e+(g*24|0)+8>>2]=q;k[e+(g*24|0)+12>>2]=V;o[e+(g*24|0)+16>>2]=s;k[e+(g*24|0)+20>>2]=p;c=d+(((h|0)/-24|0)*24|0)|0;if((h|0)>0)upb(c|0,l|0,h|0)|0;k[j>>2]=c;k[m>>2]=d+24;k[n>>2]=e+(f*24|0);if(l|0)ggb(l)}else{k[c>>2]=W;i[c+4>>0]=U;W=c+5|0;i[W>>0]=i[X>>0]|0;i[W+1>>0]=i[X+1>>0]|0;i[W+2>>0]=i[X+2>>0]|0;o[c+8>>2]=q;k[c+12>>2]=V;o[c+16>>2]=s;k[c+20>>2]=p;k[m>>2]=(k[m>>2]|0)+24}c=k[Y>>2]|0;c=(((k[c+24>>2]|0)-(k[c+20>>2]|0)|0)/24|0)+-1|0}else c=-1}else c=-1;d=k[$>>2]|0;if((d|0)==(Z|0)){r=aa;return c|0}if(d|0)ggb(d);k[$>>2]=Z;k[_>>2]=264;r=aa;return c|0}function _Ga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0.0,g=0.0,h=0,j=0,l=0,m=0,n=0.0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0;I=r;r=r+1104|0;H=I;C=a+236|0;d=k[C>>2]|0;E=k[d+8>>2]|0;w=(k[c+4>>2]|0)-(k[c>>2]|0)|0;A=w>>2;D=k[a+76>>2]|0;y=a+192|0;v=(k[a+196>>2]|0)-(k[y>>2]|0)|0;B=v>>2;l=aa((B|0)<3?3:B,D+1|0)|0;F=H+8|0;k[H>>2]=F;G=H+4|0;k[G>>2]=136;if(l>>>0>136){j=l>>>0>536870911?-1:l<<3;j=(j|0)==0?1:j;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[H>>2]=h}k[G>>2]=l;z=(D|0)>0;do if(z){h=d+44|0;j=d+48|0;o=k[j>>2]|0;m=k[h>>2]|0;l=o-m>>3;t=l+D|0;if(l>>>0>=t>>>0){if(l>>>0>t>>>0?(q=m+(t<<3)|0,(o|0)!=(q|0)):0)k[j>>2]=o+(~((o+-8-q|0)>>>3)<<3)}else{Bla(h,D);d=k[C>>2]|0}h=d+56|0;j=d+60|0;o=k[j>>2]|0;m=k[h>>2]|0;l=o-m>>3;if(t>>>0<=l>>>0){if(t>>>0<l>>>0?(s=m+(t<<3)|0,(o|0)!=(s|0)):0)k[j>>2]=o+(~((o+-8-s|0)>>>3)<<3)}else{Bla(h,t-l|0);d=k[C>>2]|0}m=d+68|0;d=d+72|0;l=k[d>>2]|0;h=k[m>>2]|0;j=l-h>>3;if(t>>>0>j>>>0){Bla(m,t-j|0);break}if(t>>>0<j>>>0?(u=h+(t<<3)|0,(l|0)!=(u|0)):0)k[d>>2]=l+(~((l+-8-u|0)>>>3)<<3)}while(0);a:do if(i[a+228>>0]|0){t=k[H>>2]|0;a=t+(B<<3)|0;s=(v|0)>0;if(s)zpb(t|0,0,((B|0)>1?B:1)<<3|0)|0;if(!D)if((w|0)>0){h=k[c>>2]|0;l=k[C>>2]|0;j=k[l+92>>2]|0;l=k[l+104>>2]|0;d=0;do{c=k[h+(d<<2)>>2]|0;x=t+(k[l+(c<<2)>>2]<<3)|0;p[x>>3]=+p[j+(c<<3)>>3]+ +p[x>>3];d=d+1|0}while((d|0)<(A|0));x=32}else x=32;else{if(z&s){h=((B|0)>1?B:1)<<3;d=0;do{zpb(t+(B+(aa(B,d)|0)<<3)|0,0,h|0)|0;d=d+1|0}while((d|0)!=(D|0))}if((w|0)>0){h=k[c>>2]|0;m=k[C>>2]|0;j=k[m+80>>2]|0;l=k[m+104>>2]|0;m=k[m+92>>2]|0;d=0;do{w=k[h+(d<<2)>>2]|0;c=a+((k[l+(w<<2)>>2]|0)+(aa(k[j+(w<<2)>>2]|0,B)|0)<<3)|0;p[c>>3]=+p[m+(w<<3)>>3]+ +p[c>>3];d=d+1|0}while((d|0)<(A|0))}if(z)if(s){d=0;do{j=aa(d,B)|0;h=0;do{A=t+(h<<3)|0;p[A>>3]=+p[a+(h+j<<3)>>3]+ +p[A>>3];h=h+1|0}while((h|0)<(B|0));d=d+1|0}while((d|0)!=(D|0));x=32}else{e=-1.0;f=0.0;d=-1}else x=32}if((x|0)==32)if(s){e=-1.0;f=0.0;d=-1;h=0;do{n=+p[t+(h<<3)>>3];f=f+n;A=e<n;d=A?h:d;e=A?n:e;h=h+1|0}while((h|0)<(B|0))}else{e=-1.0;f=0.0;d=-1}k[E+(b*104|0)>>2]=d;p[E+(b*104|0)+16>>3]=+(k[(k[y>>2]|0)+(d<<2)>>2]|0);p[E+(b*104|0)+80>>3]=f-e;if(z){q=k[C>>2]|0;l=aa(D,b)|0;m=k[q+44>>2]|0;o=k[q+56>>2]|0;q=k[q+68>>2]|0;if(s)d=0;else{d=0;while(1){E=d+l|0;p[m+(E<<3)>>3]=2147483647.0;p[o+(E<<3)>>3]=1.0;p[q+(E<<3)>>3]=0.0;d=d+1|0;if((d|0)==(D|0))break a}}do{j=aa(d,B)|0;e=0.0;f=0.0;g=0.0;n=-1.0;h=0;do{K=+p[a+(h+j<<3)>>3];J=+p[t+(h<<3)>>3]-K;e=e+K;f=f+J;E=n<J;g=E?K:g;n=E?J:n;h=h+1|0}while((h|0)<(B|0));E=d+l|0;p[m+(E<<3)>>3]=2147483647.0;p[o+(E<<3)>>3]=f-n;p[q+(E<<3)>>3]=e-g;d=d+1|0}while((d|0)!=(D|0))}}else{if(!D)if((w|0)>0){l=k[c>>2]|0;j=k[C>>2]|0;h=k[j+92>>2]|0;j=k[j+116>>2]|0;g=0.0;f=0.0;e=0.0;d=0;do{D=k[l+(d<<2)>>2]|0;K=+p[h+(D<<3)>>3];J=+p[j+(D<<3)>>3];g=g+K*J;f=f+K*(J*J);e=e+K;d=d+1|0}while((d|0)<(A|0))}else{g=0.0;f=0.0;e=0.0}else{o=k[H>>2]|0;q=o+(D<<3)|0;s=q+(D<<3)|0;if(z){d=0;do{p[q+(d<<3)>>3]=0.0;p[o+(d<<3)>>3]=0.0;p[s+(d<<3)>>3]=0.0;d=d+1|0}while((d|0)!=(D|0))}if((w|0)>0){h=k[c>>2]|0;m=k[C>>2]|0;j=k[m+80>>2]|0;l=k[m+92>>2]|0;m=k[m+116>>2]|0;d=0;do{y=k[h+(d<<2)>>2]|0;B=k[j+(y<<2)>>2]|0;K=+p[l+(y<<3)>>3];J=+p[m+(y<<3)>>3];y=o+(B<<3)|0;p[y>>3]=+p[y>>3]+K*J;y=q+(B<<3)|0;p[y>>3]=K*(J*J)+ +p[y>>3];B=s+(B<<3)|0;p[B>>3]=K+ +p[B>>3];d=d+1|0}while((d|0)<(A|0))}if(z){g=0.0;f=0.0;e=0.0;d=0;do{g=g+ +p[o+(d<<3)>>3];f=f+ +p[q+(d<<3)>>3];e=e+ +p[s+(d<<3)>>3];d=d+1|0}while((d|0)!=(D|0));m=k[C>>2]|0;h=aa(D,b)|0;j=k[m+56>>2]|0;l=k[m+68>>2]|0;m=k[m+44>>2]|0;d=0;do{J=g-+p[o+(d<<3)>>3];n=f-+p[q+(d<<3)>>3];L=+p[s+(d<<3)>>3];M=e-L;K=(g-J)/(M<2.220446049250313e-16?2.220446049250313e-16:M);C=d+h|0;p[j+(C<<3)>>3]=f-n-M*(K*K);p[l+(C<<3)>>3]=K*(L*K)+(n-J*(K*2.0));p[m+(C<<3)>>3]=2147483647.0;d=d+1|0}while((d|0)!=(D|0))}else{g=0.0;f=0.0;e=0.0}}M=g/e;p[E+(b*104|0)+80>>3]=f-g*M;p[E+(b*104|0)+16>>3]=M}while(0);d=k[H>>2]|0;if((d|0)==(F|0)){r=I;return}if(d|0)ggb(d);k[H>>2]=F;k[G>>2]=136;r=I;return}function $Ga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0.0,j=0.0,l=0,m=0.0,n=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0;E=r;r=r+1056|0;s=E;D=E+16|0;A=k[d>>2]|0;q=(k[d+4>>2]|0)-A|0;u=q>>2;l=(k[b+196>>2]|0)-(k[b+192>>2]|0)|0;t=l>>2;g=(l<<2)+(q<<1)|0;B=D+8|0;k[D>>2]=B;C=D+4|0;k[C>>2]=1032;if(g>>>0>1032){while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[D>>2]=f}else f=B;k[C>>2]=g;g=k[b+236>>2]|0;v=k[g+104>>2]|0;w=k[g+92>>2]|0;x=f+(t<<3)|0;y=x+(t<<3)|0;z=y+(u<<2)|0;l=(l|0)>0;if(l){b=0;do{p[x+(b<<3)>>3]=0.0;p[f+(b<<3)>>3]=0.0;b=b+1|0}while((b|0)<(t|0))}g=k[g+4>>2]|0;b=k[(k[g>>2]|0)+104>>2]|0;k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=-2130509820;k[s+4>>2]=d;dh[b&255](g,c,s,y);if((q|0)>0){b=0;do{k[z+(b<<2)>>2]=b;q=k[A+(b<<2)>>2]|0;d=x+(k[v+(q<<2)>>2]<<3)|0;p[d>>3]=+p[w+(q<<3)>>3]+ +p[d>>3];b=b+1|0}while((b|0)<(u|0))}k[s>>2]=y;DHa(z,z+(u<<2)|0,s);if(l){h=0.0;j=0.0;b=0;do{n=+p[x+(b<<3)>>3];h=h+n;j=j+n*n;b=b+1|0}while((b|0)<(t|0))}else{h=0.0;j=0.0}l=u+-1|0;q=-1;m=0.0;n=0.0;b=0;a:while(1){while(1){if((b|0)>=(l|0))break a;t=k[z+(b<<2)>>2]|0;g=b+1|0;u=k[z+(g<<2)>>2]|0;s=k[A+(t<<2)>>2]|0;F=+p[w+(s<<3)>>3];I=F*F;m=m+F;h=h-F;s=k[v+(s<<2)>>2]|0;d=f+(s<<3)|0;H=+p[d>>3];s=x+(s<<3)|0;G=+p[s>>3];n=n+(I+F*(H*2.0));j=j-(F*(G*2.0)-I);p[d>>3]=F+H;p[s>>3]=G-F;if(+o[y+(t<<2)>>2]+2.384185791015625e-07<+o[y+(u<<2)>>2])break;else b=g}I=(h*n+m*j)/(m*h);u=e<I;q=u?b:q;e=u?I:e;b=g}k[a+12>>2]=0;k[a>>2]=0;f=a+4|0;i[f>>0]=0;b=a+16|0;o[b>>2]=0.0;g=a+8|0;o[g>>2]=0.0;k[a+20>>2]=-1;if((q|0)>-1){k[a>>2]=c;o[b>>2]=(+o[y+(k[z+(q<<2)>>2]<<2)>>2]+ +o[y+(k[z+(q+1<<2)>>2]<<2)>>2])*.5;i[f>>0]=0;o[g>>2]=e}f=k[D>>2]|0;if((f|0)==(B|0)){r=E;return}if(f|0)ggb(f);k[D>>2]=B;k[C>>2]=1032;r=E;return}function aHa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0,l=0,m=0,n=0,o=0,q=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;H=r;r=r+1104|0;F=H;j=f+c|0;G=F+8|0;k[F>>2]=G;E=F+4|0;k[E>>2]=136;if(j>>>0>136){h=j>>>0>536870911?-1:j<<3;h=(h|0)==0?1:h;while(1){a=fgb(h)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[F>>2]=a}else a=G;k[E>>2]=j;C=a+(c<<3)|0;D=(c|0)>0;if(D){o=(d|0)>0;if(!f){l=0;do{j=b+((aa(l,d)|0)<<3)|0;k[g+(l<<2)>>2]=0;if(o){h=0;i=0.0;do{i=i+ +p[j+(h<<3)>>3];h=h+1|0}while((h|0)!=(d|0))}else i=0.0;p[a+(l<<3)>>3]=i!=0.0?1.0/i:0.0;l=l+1|0}while((l|0)!=(c|0));l=0;j=-1;h=-1}else{n=0;j=-1;h=-1;do{m=b+((aa(n,d)|0)<<3)|0;if((n|0)<(f|0))l=n;else{l=Epb(j|0,0,-130063606,0)|0;l=kpb(l|0,N|0,h|0,0)|0;j=l;h=N;l=(l>>>0)%(f>>>0)|0}k[g+(n<<2)>>2]=l;if(o){l=0;i=0.0;do{i=i+ +p[m+(l<<3)>>3];l=l+1|0}while((l|0)!=(d|0))}else i=0.0;p[a+(n<<3)>>3]=i!=0.0?1.0/i:0.0;n=n+1|0}while((n|0)!=(c|0));l=0}while(1){z=Epb(j|0,0,-130063606,0)|0;z=kpb(z|0,N|0,h|0,0)|0;B=N;A=Epb(z|0,0,-130063606,0)|0;j=kpb(A|0,N|0,B|0,0)|0;z=g+(((z>>>0)%(c>>>0)|0)<<2)|0;B=g+(((j>>>0)%(c>>>0)|0)<<2)|0;A=k[z>>2]|0;k[z>>2]=k[B>>2];k[B>>2]=A;l=l+1|0;if((l|0)==(c|0))break;else h=N}}w=(f|0)>0;x=(d|0)>0;y=d<<3;z=f<<3;A=w&x;B=D&x;n=1;v=0;while(1){if(A){h=0;do{zpb(e+((aa(h,d)|0)<<3)|0,0,y|0)|0;h=h+1|0}while((h|0)!=(f|0))}if(B){j=0;do{l=b+((aa(j,d)|0)<<3)|0;m=e+((aa(k[g+(j<<2)>>2]|0,d)|0)<<3)|0;h=0;do{u=m+(h<<3)|0;p[u>>3]=+p[l+(h<<3)>>3]+ +p[u>>3];h=h+1|0}while((h|0)!=(d|0));j=j+1|0}while((j|0)!=(c|0))}if((v|0)==100|n^1)break;do if(w){if(x)j=0;else{zpb(C|0,0,z|0)|0;break}do{l=e+((aa(j,d)|0)<<3)|0;i=0.0;h=0;do{i=i+ +p[l+(h<<3)>>3];h=h+1|0}while((h|0)!=(d|0));p[C+(j<<3)>>3]=i!=0.0?1.0/i:0.0;j=j+1|0}while((j|0)!=(f|0))}while(0);if(D){h=0;u=0;do{o=b+((aa(u,d)|0)<<3)|0;t=+p[a+(u<<3)>>3];a:do if(w){if(x){j=-1;s=1797693134862315708145274.0e284;n=0}else{j=-1;i=1797693134862315708145274.0e284;l=0;while(1){m=i>0.0;j=m?l:j;l=l+1|0;if((l|0)==(f|0))break a;else i=m?0.0:i}}while(1){m=e+((aa(n,d)|0)<<3)|0;i=+p[C+(n<<3)>>3];q=0.0;l=0;do{I=t*+p[o+(l<<3)>>3]-i*+p[m+(l<<3)>>3];q=q+I*I;l=l+1|0}while((l|0)!=(d|0));l=s>q;j=l?n:j;n=n+1|0;if((n|0)==(f|0))break;else s=l?q:s}}else j=-1;while(0);o=g+(u<<2)|0;h=(j|0)==(k[o>>2]|0)?h:1;k[o>>2]=j;u=u+1|0}while((u|0)!=(c|0))}else h=0;v=v+1|0;if((v|0)>=101)break;else n=(h&1)!=0}a=k[F>>2]|0;if((a|0)==(G|0)){r=H;return}if(a|0)ggb(a);k[F>>2]=G;k[E>>2]=136;r=H;return}function bHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;var g=0,h=0,j=0,l=0.0,m=0,n=0,q=0.0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0;R=r;r=r+1120|0;Q=R;H=R+1096|0;M=b+120|0;A=k[M>>2]|0;z=k[A+(c<<3)+4>>2]|0;A=k[A+(c<<3)>>2]|0;N=z-A|0;B=(k[d+4>>2]|0)-(k[d>>2]|0)|0;E=B>>2;y=(k[b+196>>2]|0)-(k[b+192>>2]|0)|0;L=y>>2;h=aa(L,N+3|0)|0;C=(y|0)>8;if(C?(g=k[b+64>>2]|0,(N|0)>(g|0)):0)g=(aa((E|0)<(g|0)?E:g,L)|0)+N|0;else g=N;m=N+1+h+g|0;j=m+E|0;O=Q+8|0;k[Q>>2]=O;P=Q+4|0;k[P>>2]=136;if(j>>>0>136){h=j>>>0>536870911?-1:j<<3;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[Q>>2]=g;K=g}else K=O;k[P>>2]=j;I=K+(L<<3)|0;n=y>>1;h=I+(n<<3)|0;J=h+((aa(L,N)|0)<<3)|0;s=K+(m<<3)|0;x=b+236|0;t=k[(k[x>>2]|0)+4>>2]|0;m=k[(k[t>>2]|0)+108>>2]|0;k[H+8>>2]=0;k[H+12>>2]=0;k[H>>2]=-2130509820;k[H+4>>2]=d;dh[m&255](t,c,H,s);x=k[x>>2]|0;t=k[x+104>>2]|0;x=k[x+92>>2]|0;y=(y|0)>0;if((N|0)>-1&y){m=((L|0)>1?L:1)<<3;g=z+1-A|0;j=0;do{zpb(K+(n+(aa(L,j)|0)<<3)|0,0,m|0)|0;j=j+1|0}while((j|0)!=(g|0))}if((B|0)>0){j=k[d>>2]|0;g=0;do{B=k[j+(g<<2)>>2]|0;d=h+((aa(k[s+(g<<2)>>2]|0,L)|0)+(k[t+(B<<2)>>2]|0)<<3)|0;p[d>>3]=+p[x+(B<<3)>>3]+ +p[d>>3];g=g+1|0}while((g|0)<(E|0))}if(!C){j=J+(N<<3)|0;if((N|0)>0){g=0;do{k[j+(g<<2)>>2]=h+(g<<1<<3)+8;g=g+1|0}while((g|0)!=(N|0))}AHa(j,j+(N<<2)|0);if(y){x=N;y=0;g=0;s=N;F=23}else{x=N;y=0;d=0;s=N;B=0}}else{g=k[b+64>>2]|0;if((N|0)>(g|0)){m=(E|0)<(g|0)?E:g;F=J+(N<<3)|0;g=F+((aa(m,L)|0)<<3)|0;Eh[k[(k[b>>2]|0)+188>>2]&127](b,h,N,L,F,m,g);h=F}else{m=N;g=0}j=0;x=1<<m;y=1;s=m;F=23}a:do if((F|0)==23){t=H+4|0;if((s|0)>0)m=0;else{m=0;while(1){k[H>>2]=0;k[t>>2]=0;n=ZT(12)|0;k[n>>2]=1;G=n+4|0;k[H>>2]=G;k[t>>2]=7;i[n+11>>0]=0;i[G>>0]=i[371708]|0;i[G+1>>0]=i[371709]|0;i[G+2>>0]=i[371710]|0;i[G+3>>0]=i[371711]|0;i[G+4>>0]=i[371712]|0;i[G+5>>0]=i[371713]|0;i[G+6>>0]=i[371714]|0;Y8(-215,H,371716,370820,880);k[t>>2]=0;k[H>>2]=0;G=k[n>>2]|0;k[n>>2]=G+-1;if((G|0)==1)ggb(k[n+-4>>2]|0);p[I+(m<<3)>>3]=0.0;p[K+(m<<3)>>3]=0.0;m=m+1|0;if((m|0)>=(L|0)){d=g;B=1;break a}}}do{l=0.0;n=0;do{F=h+((aa(n,L)|0)+m<<3)|0;l=l+ +p[F>>3];n=n+1|0}while((n|0)!=(s|0));if(!(l>0.0)?(k[H>>2]=0,k[t>>2]=0,G=ZT(12)|0,k[G>>2]=1,F=G+4|0,k[H>>2]=F,k[t>>2]=7,i[G+11>>0]=0,i[F>>0]=i[371708]|0,i[F+1>>0]=i[371709]|0,i[F+2>>0]=i[371710]|0,i[F+3>>0]=i[371711]|0,i[F+4>>0]=i[371712]|0,i[F+5>>0]=i[371713]|0,i[F+6>>0]=i[371714]|0,Y8(-215,H,371716,370820,880),k[t>>2]=0,k[H>>2]=0,F=k[G>>2]|0,k[G>>2]=F+-1,(F|0)==1):0)ggb(k[G+-4>>2]|0);p[I+(m<<3)>>3]=l;p[K+(m<<3)>>3]=0.0;m=m+1|0}while((m|0)<(L|0));d=g;B=1}while(0);do if((s|0)>0){if(B){l=0.0;n=0}else{zpb(J|0,0,s<<3|0)|0;l=0.0;break}do{m=aa(n,L)|0;q=0.0;g=0;do{q=q+ +p[h+(g+m<<3)>>3];g=g+1|0}while((g|0)<(L|0));p[J+(n<<3)>>3]=q;l=l+q;n=n+1|0}while((n|0)!=(s|0))}else l=0.0;while(0);if((y|0)<(x|0)){z=(L|0)==2;A=h;q=0.0;s=0;m=-1;n=0;do{if(z)g=((k[j+(y<<2)>>2]|0)-A>>3|0)/2|0;else{H=y>>1^y;g=H^n;g=((g|0)>65535?-111:-127)+((o[u>>2]=+(g>>>16|g&65535|0),k[u>>2]|0)>>23)|0;s=(H|0)<(n|0)&1;n=H}t=h+((aa(g,L)|0)<<3)|0;D=+p[J+(g<<3)>>3];if(!(D<1.1920928955078125e-07)){if(!s){if(B){w=0.0;v=0.0;g=0;do{S=+p[t+(g<<3)>>3];G=K+(g<<3)|0;T=S+ +p[G>>3];H=I+(g<<3)|0;S=+p[H>>3]-S;v=v+T*T;w=w+S*S;p[G>>3]=T;p[H>>3]=S;g=g+1|0}while((g|0)<(L|0))}else{w=0.0;v=0.0}q=q+D;l=l-D}else{if(B){w=0.0;v=0.0;g=0;do{T=+p[t+(g<<3)>>3];G=K+(g<<3)|0;S=+p[G>>3]-T;H=I+(g<<3)|0;T=T+ +p[H>>3];v=v+S*S;w=w+T*T;p[G>>3]=S;p[H>>3]=T;g=g+1|0}while((g|0)<(L|0))}else{w=0.0;v=0.0}q=q-D;l=l+D}if(l>1.1920928955078125e-07&q>1.1920928955078125e-07){T=(l*v+w*q)/(l*q);H=e<T;m=H?y:m;e=H?T:e}}y=y+1|0}while((y|0)!=(x|0))}else m=-1;k[a+12>>2]=0;k[a>>2]=0;i[a+4>>0]=0;o[a+16>>2]=0.0;g=a+8|0;o[g>>2]=0.0;k[a+20>>2]=-1;b:do if((m|0)>-1){k[a>>2]=c;o[g>>2]=e;M=k[M>>2]|0;zpb(f|0,0,(((k[M+(c<<3)+4>>2]|0)+31-(k[M+(c<<3)>>2]|0)|0)/32|0)<<2|0)|0;if((L|0)==2){g=0;while(1){M=(k[j+(g<<2)>>2]|0)-h|0;N=f+(M>>9<<2)|0;k[N>>2]=1<<(M>>>4&31)|k[N>>2];if((g|0)==(m|0))break b;else g=g+1|0}}if((N|0)>0)if(!d){g=0;do{h=f+(g>>5<<2)|0;if(1<<g&m|0)k[h>>2]=k[h>>2]|1<<(g&31);g=g+1|0}while((g|0)!=(N|0))}else{g=0;do{h=f+(g>>5<<2)|0;if(1<<k[d+(g<<2)>>2]&m|0)k[h>>2]=k[h>>2]|1<<(g&31);g=g+1|0}while((g|0)!=(N|0))}}while(0);g=k[Q>>2]|0;if((g|0)==(O|0)){r=R;return}if(g|0)ggb(g);k[Q>>2]=O;k[P>>2]=136;r=R;return}function cHa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0.0,j=0.0,l=0,m=0,n=0.0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0;B=r;r=r+1056|0;t=B;A=B+16|0;g=b+236|0;l=k[g>>2]|0;x=k[l+92>>2]|0;m=(k[d+4>>2]|0)-(k[d>>2]|0)|0;s=m>>2;f=m<<1;y=A+8|0;k[A>>2]=y;z=A+4|0;k[z>>2]=1032;if(f>>>0>1032){while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[A>>2]=b;w=b}else w=y;k[z>>2]=f;v=w+(s<<2)|0;u=k[l+4>>2]|0;l=k[(k[u>>2]|0)+104>>2]|0;k[t+8>>2]=0;k[t+12>>2]=0;k[t>>2]=-2130509820;k[t+4>>2]=d;dh[l&255](u,c,t,w);u=k[(k[g>>2]|0)+116>>2]|0;if((m|0)>0){f=k[d>>2]|0;b=0;j=0.0;h=0.0;do{k[v+(b<<2)>>2]=b;m=k[f+(b<<2)>>2]|0;q=+p[x+(m<<3)>>3];h=h+q;j=j+q*+p[u+(m<<3)>>3];b=b+1|0}while((b|0)<(s|0))}else{j=0.0;h=0.0}k[t>>2]=w;DHa(v,v+(s<<2)|0,t);l=s+-1|0;g=k[d>>2]|0;m=-1;n=0.0;q=0.0;b=0;a:while(1){while(1){if((b|0)>=(l|0))break a;d=k[v+(b<<2)>>2]|0;f=b+1|0;t=k[g+(d<<2)>>2]|0;D=+p[x+(t<<3)>>3];C=D*+p[u+(t<<3)>>3];q=q+D;h=h-D;n=n+C;j=j-C;if(+o[w+(d<<2)>>2]+2.384185791015625e-07<+o[w+(k[v+(f<<2)>>2]<<2)>>2])break;else b=f}D=(h*(n*n)+q*(j*j))/(q*h);d=e<D;m=d?b:m;e=d?D:e;b=f}k[a+12>>2]=0;k[a>>2]=0;b=a+4|0;i[b>>0]=0;f=a+16|0;o[f>>2]=0.0;g=a+8|0;o[g>>2]=0.0;k[a+20>>2]=-1;if((m|0)>-1){k[a>>2]=c;o[f>>2]=(+o[w+(k[v+(m<<2)>>2]<<2)>>2]+ +o[w+(k[v+(m+1<<2)>>2]<<2)>>2])*.5;i[b>>0]=0;o[g>>2]=e}b=k[A>>2]|0;if((b|0)==(y|0)){r=B;return}if(b|0)ggb(b);k[A>>2]=y;k[z>>2]=1032;r=B;return}function dHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;var g=0,h=0,j=0.0,l=0.0,m=0.0,n=0.0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0;G=r;r=r+1120|0;F=G;t=G+1096|0;u=k[b+236>>2]|0;w=k[u+92>>2]|0;x=k[u+116>>2]|0;v=(k[d+4>>2]|0)-(k[d>>2]|0)|0;y=v>>2;C=b+120|0;z=k[C>>2]|0;z=(k[z+(c<<3)+4>>2]|0)-(k[z+(c<<3)>>2]|0)|0;h=y+3+(z*3|0)|0;D=F+8|0;k[F>>2]=D;E=F+4|0;k[E>>2]=136;if(h>>>0>136){g=h>>>0>536870911?-1:h<<3;g=(g|0)==0?1:g;while(1){b=fgb(g)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b}else b=D;k[E>>2]=h;g=b+8|0;A=g+(z<<3)+8|0;B=A+(z<<3)|0;s=B+(z<<2)|0;u=k[u+4>>2]|0;h=k[(k[u>>2]|0)+108>>2]|0;k[t+8>>2]=0;k[t+12>>2]=0;k[t>>2]=-2130509820;k[t+4>>2]=d;dh[h&255](u,c,t,s);if((z|0)>-1){b=-1;do{p[A+(b<<3)>>3]=0.0;p[g+(b<<3)>>3]=0.0;b=b+1|0}while((b|0)!=(z|0))}if((v|0)>0){h=k[d>>2]|0;b=0;do{d=k[s+(b<<2)>>2]|0;u=k[h+(b<<2)>>2]|0;q=+p[w+(u<<3)>>3];v=g+(d<<3)|0;p[v>>3]=+p[v>>3]+q*+p[x+(u<<3)>>3];d=A+(d<<3)|0;p[d>>3]=q+ +p[d>>3];b=b+1|0}while((b|0)<(y|0))}if((z|0)>0){j=0.0;m=0.0;b=0;do{q=+p[A+(b<<3)>>3];j=j+q;y=g+(b<<3)|0;n=+p[y>>3];m=m+n;x=+P(+q)>2.220446049250313e-16;p[y>>3]=x?n/q:0.0;k[B+(b<<2)>>2]=y;b=b+1|0}while((b|0)!=(z|0));AHa(B,s);b=0;do{y=g+(b<<3)|0;p[y>>3]=+p[A+(b<<3)>>3]*+p[y>>3];b=b+1|0}while((b|0)!=(z|0));u=z+-1|0;if((z|0)>1){t=g;l=0.0;q=0.0;s=0;h=-1;do{b=k[B+(s<<2)>>2]|0;n=+p[A+(b-t>>3<<3)>>3];if(n>1.1920928955078125e-07){H=+p[b>>3];q=q+H;l=l+n;m=m-H;j=j-n;if(l>1.1920928955078125e-07&j>1.1920928955078125e-07){H=(j*(q*q)+l*(m*m))/(l*j);z=e<H;e=z?H:e;h=z?s:h}}s=s+1|0}while((s|0)<(u|0))}else h=-1}else{AHa(B,s);h=-1}k[a+12>>2]=0;k[a>>2]=0;i[a+4>>0]=0;o[a+16>>2]=0.0;b=a+8|0;o[b>>2]=0.0;k[a+20>>2]=-1;if((h|0)>-1){k[a>>2]=c;o[b>>2]=e;b=k[C>>2]|0;zpb(f|0,0,(((k[b+(c<<3)+4>>2]|0)+31-(k[b+(c<<3)>>2]|0)|0)/32|0)<<2|0)|0;b=0;while(1){a=(k[B+(b<<2)>>2]|0)-g|0;c=f+(a>>8<<2)|0;k[c>>2]=1<<(a>>>3&31)|k[c>>2];if((b|0)==(h|0))break;else b=b+1|0}}b=k[F>>2]|0;if((b|0)==(D|0)){r=G;return}if(b|0)ggb(b);k[F>>2]=D;k[E>>2]=136;r=G;return}function eHa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,l=0.0,m=0,n=0,q=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+1088|0;v=C+1080|0;B=C+16|0;A=C;g=a+236|0;h=k[(k[g>>2]|0)+20>>2]|0;q=k[h+(b*24|0)>>2]|0;s=+o[h+(b*24|0)+16>>2];h=k[h+(b*24|0)+20>>2]|0;m=(k[c+4>>2]|0)-(k[c>>2]|0)|0;w=m>>2;zHa(d,w);zHa(e,w);b=k[d>>2]|0;x=d+4|0;f=k[x>>2]|0;if((f|0)!=(b|0))k[x>>2]=f+(~((f+-4-b|0)>>>2)<<2);b=k[e>>2]|0;u=e+4|0;f=k[u>>2]|0;if((f|0)!=(b|0))k[u>>2]=f+(~((f+-4-b|0)>>>2)<<2);y=B+8|0;k[B>>2]=y;z=B+4|0;k[z>>2]=264;if(w>>>0>264){f=w>>>0>1073741823?-1:w<<2;f=(f|0)==0?1:f;while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[B>>2]=b}else b=y;k[z>>2]=w;n=k[a+120>>2]|0;f=k[g>>2]|0;t=k[f+92>>2]|0;if((k[n+(q<<3)+4>>2]|0)>(k[n+(q<<3)>>2]|0)){n=(k[f+32>>2]|0)+(h<<2)|0;h=k[f+4>>2]|0;g=k[(k[h>>2]|0)+108>>2]|0;k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=-2130509820;k[A+4>>2]=c;dh[g&255](h,q,A,b);if((m|0)>0){h=e+8|0;m=d+8|0;g=0;l=0.0;j=0.0;do{a=k[(k[c>>2]|0)+(g<<2)>>2]|0;k[v>>2]=a;q=k[b+(g<<2)>>2]|0;if(!(1<<(q&31)&k[n+(q>>>5<<2)>>2])){f=k[u>>2]|0;if((f|0)==(k[h>>2]|0))Q4(e,v);else{k[f>>2]=a;k[u>>2]=f+4}j=j+ +p[t+(a<<3)>>3]}else{f=k[x>>2]|0;if((f|0)==(k[m>>2]|0))Q4(d,v);else{k[f>>2]=a;k[x>>2]=f+4}l=l+ +p[t+(a<<3)>>3]}g=g+1|0}while((g|0)<(w|0))}else{l=0.0;j=0.0}}else{n=k[f+4>>2]|0;h=k[(k[n>>2]|0)+104>>2]|0;k[A+8>>2]=0;k[A+12>>2]=0;k[A>>2]=-2130509820;k[A+4>>2]=c;dh[h&255](n,q,A,b);if((m|0)>0){h=e+8|0;m=d+8|0;l=0.0;j=0.0;g=0;do{a=k[(k[c>>2]|0)+(g<<2)>>2]|0;k[v>>2]=a;if(!(+o[b+(g<<2)>>2]<=s)){f=k[u>>2]|0;if((f|0)==(k[h>>2]|0))Q4(e,v);else{k[f>>2]=a;k[u>>2]=f+4}j=j+ +p[t+(a<<3)>>3]}else{f=k[x>>2]|0;if((f|0)==(k[m>>2]|0))Q4(d,v);else{k[f>>2]=a;k[x>>2]=f+4}l=l+ +p[t+(a<<3)>>3]}g=g+1|0}while((g|0)<(w|0))}else{l=0.0;j=0.0}}if(!(((k[x>>2]|0)-(k[d>>2]|0)>>2|0)<(w|0)?((k[u>>2]|0)-(k[e>>2]|0)>>2|0)<(w|0):0)){k[A>>2]=0;b=A+4|0;k[b>>2]=0;f=ZT(56)|0;k[f>>2]=1;a=f+4|0;k[A>>2]=a;k[b>>2]=49;i[f+53>>0]=0;g=371650;h=a+49|0;do{i[a>>0]=i[g>>0]|0;a=a+1|0;g=g+1|0}while((a|0)<(h|0));Y8(-215,A,371700,370820,1190);k[b>>2]=0;k[A>>2]=0;A=k[f>>2]|0;k[f>>2]=A+-1;if((A|0)==1)ggb(k[f+-4>>2]|0)}b=l>j?-1:1;f=k[B>>2]|0;if((f|0)==(y|0)){r=C;return b|0}if(f|0)ggb(f);k[B>>2]=y;k[z>>2]=264;r=C;return b|0}function fHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0.0,l=0.0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;D=r;r=r+80|0;h=D;B=D+64|0;A=D+8|0;k[B>>2]=0;C=B+4|0;k[C>>2]=0;k[B+8>>2]=0;u=k[a+76>>2]|0;s=a+236|0;q=k[(k[(k[s>>2]|0)+8>>2]|0)+(b*104|0)+44>>2]|0;if(!(i[a+5>>0]|0))t=0;else t=(i[a+228>>0]|0)!=0;c=B+8|0;v=0;while(1){l=+(v|0);f=+rg[k[(k[a>>2]|0)+212>>2]&1](a,b,l,-1);p[h>>3]=f;if(mi[k[(k[a>>2]|0)+216>>2]&1](a,b,l,-1,f)|0)break;d=k[C>>2]|0;if((d|0)==(k[c>>2]|0))Koa(B,h);else{p[d>>3]=f;k[C>>2]=d+8}v=v+1|0}if((v|0)>0){o=k[B>>2]|0;p[o>>3]=0.0;d=v+-1|0;if((d|0)>1){c=1;f=+p[o+8>>3];do{z=c;c=c+1|0;l=f;f=+p[o+(c<<3)>>3];l=+Q(+(l*f));p[o+(z<<3)>>3]=l}while((c|0)!=(d|0))}p[o+(d<<3)>>3]=8988465674311578540726371.0e283;k[A>>2]=1124007936;z=A+4|0;c=A+8|0;x=A+40|0;d=z;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[x>>2]=c;y=A+48|0;w=A+44|0;k[w>>2]=y;k[A+52>>2]=0;k[y>>2]=0;k[h>>2]=u;k[h+4>>2]=v;G1(A,2,h,6);a:do if((u|0)>0){n=A+16|0;h=0;do{c=0;m=0;do{l=+(m|0);f=+rg[k[(k[a>>2]|0)+212>>2]&1](a,b,l,h);e=mi[k[(k[a>>2]|0)+216>>2]&1](a,b,l,h,f)|0;f=e?1797693134862315708145274.0e284:f;b:do if((c|0)<(v|0)){e=k[n>>2]|0;d=k[w>>2]|0;do{if(+p[o+(c<<3)>>3]>f)break b;E=e+(aa(k[d>>2]|0,h)|0)+(c<<3)|0;p[E>>3]=+p[(k[(k[s>>2]|0)+8>>2]|0)+(b*104|0)+96>>3];c=c+1|0}while((c|0)<(v|0))}while(0);m=m+1|0}while((m|0)<(v|0));h=h+1|0}while((h|0)<(u|0));l=+(q|0);m=k[n>>2]|0;h=k[k[w>>2]>>2]|0;if(t){e=-1;g=0.0;f=0.0;d=0}else{e=-1;f=0.0;d=0;while(1){g=0.0;c=0;do{E=m+(aa(h,c)|0)+(d<<3)|0;g=g+ +p[E>>3];c=c+1|0}while((c|0)!=(u|0));if(!((d|0)==0|g<f)){if(g<f+0.0)e=d}else{e=d;f=g}d=d+1|0;if((d|0)==(v|0))break a}}do{j=0.0;c=0;do{E=m+(aa(h,c)|0)+(d<<3)|0;j=j+ +p[E>>3];c=c+1|0}while((c|0)!=(u|0));if(!((d|0)==0|j<f)){if(j<f+g)e=d}else{e=d;g=+Q(+(j*(l-j)));f=j}d=d+1|0}while((d|0)!=(v|0))}else{if(!t){e=-1;c=0;while(1){e=(c|0)==0?0:e;c=c+1|0;if((c|0)==(v|0))break a}}g=+(q|0)*0.0;e=-1;f=0.0;c=0;do{if(c){if(f+0.0>0.0)e=c}else{e=0;f=+Q(+g)}c=c+1|0}while((c|0)!=(v|0))}while(0);h=A+36|0;c=k[h>>2]|0;if(c|0?(v=c+12|0,E=k[v>>2]|0,k[v>>2]=E+-1,(E|0)==1):0){d=k[h>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[A+32>>2]|0;if(!c){c=B1()|0;d=k[h>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[h>>2]=0}k[h>>2]=0;E=A+16|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[z>>2]|0)>0){d=k[x>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[z>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(y|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}else e=-1;c=k[B>>2]|0;if(!c){r=D;return e|0}d=k[C>>2]|0;if((d|0)!=(c|0))k[C>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(c);r=D;return e|0}function gHa(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0.0,f=0,g=0.0,h=0.0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,r=0.0;q=k[a+76>>2]|0;n=k[a+236>>2]|0;o=k[n+8>>2]|0;j=(d|0)>-1;l=n+44|0;m=n+56|0;n=n+68|0;e=1797693134862315708145274.0e284;a:while(1){b:do if(j){f=k[l>>2]|0;while(1){i=f+((aa(b,q)|0)+d<<3)|0;if(+p[i>>3]<=c)break b;a=k[o+(b*104|0)+28>>2]|0;if((a|0)<0)break;else b=a}}else while(1){if(+p[o+(b*104|0)+8>>3]<=c)break b;a=k[o+(b*104|0)+28>>2]|0;if((a|0)<0)break;else b=a}while(0);k[o+(b*104|0)+64>>2]=1;g=+p[o+(b*104|0)+80>>3];a=o+(b*104|0)+88|0;p[a>>3]=g;f=o+(b*104|0)+96|0;p[f>>3]=0.0;if(j){i=(aa(b,q)|0)+d|0;g=+p[(k[m>>2]|0)+(i<<3)>>3];p[a>>3]=g;h=+p[(k[n>>2]|0)+(i<<3)>>3];p[f>>3]=h}else h=0.0;a=k[o+(b*104|0)+24>>2]|0;if((a|0)<=-1){a=17;break}c:do if(j){i=1;while(1){f=k[o+(a*104|0)+32>>2]|0;if((f|0)!=(b|0)){b=f;f=i;break c}b=o+(a*104|0)+64|0;i=(k[b>>2]|0)+i|0;k[b>>2]=i;b=o+(a*104|0)+88|0;g=g+ +p[b>>3];p[b>>3]=g;b=o+(a*104|0)+96|0;h=h+ +p[b>>3];p[b>>3]=h;b=(aa(a,q)|0)+d|0;r=(+p[(k[m>>2]|0)+(b<<3)>>3]-g)/+(i+-1|0);p[o+(a*104|0)+72>>3]=r;e=r<e?r:e;b=k[o+(a*104|0)+24>>2]|0;if((b|0)<=-1){a=17;break a}else{f=a;a=b;b=f}}}else{i=1;while(1){f=k[o+(a*104|0)+32>>2]|0;if((f|0)!=(b|0)){b=f;f=i;break c}b=o+(a*104|0)+64|0;i=(k[b>>2]|0)+i|0;k[b>>2]=i;b=o+(a*104|0)+88|0;g=g+ +p[b>>3];p[b>>3]=g;b=o+(a*104|0)+96|0;h=h+ +p[b>>3];p[b>>3]=h;r=(+p[o+(a*104|0)+80>>3]-g)/+(i+-1|0);p[o+(a*104|0)+72>>3]=r;e=r<e?r:e;b=k[o+(a*104|0)+24>>2]|0;if((b|0)<=-1){a=17;break a}else{f=a;a=b;b=f}}}while(0);k[o+(a*104|0)+64>>2]=f;p[o+(a*104|0)+88>>3]=g;p[o+(a*104|0)+96>>3]=h}if((a|0)==17)return +e;return +(0.0)}function hHa(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;m=k[a+76>>2]|0;i=k[a+236>>2]|0;j=k[i+8>>2]|0;if((k[j+(b*104|0)+28>>2]|0)<0){n=1;return n|0}e=e+1.1920928955078125e-07;if((d|0)<=-1){a=b;a:while(1){while(1){f=j+(a*104|0)+8|0;if(+p[f>>3]<=c){h=a;break}g=k[j+(a*104|0)+28>>2]|0;if((g|0)<0){h=a;break}if(!(+p[j+(a*104|0)+72>>3]<=e))a=g;else{n=15;break}}if((n|0)==15){n=0;p[f>>3]=c;if((a|0)==(b|0)){a=1;n=18;break}else h=a}while(1){f=k[j+(h*104|0)+24>>2]|0;if((f|0)<=-1){a=0;n=18;break a}a=k[j+(f*104|0)+32>>2]|0;if((a|0)==(h|0))h=f;else continue a}}if((n|0)==18)return a|0}h=k[i+44>>2]|0;a=b;b:while(1){while(1){f=h+((aa(a,m)|0)+d<<3)|0;if(+p[f>>3]<=c){l=a;break}g=k[j+(a*104|0)+28>>2]|0;if((g|0)<0){l=a;break}if(!(+p[j+(a*104|0)+72>>3]<=e))a=g;else{n=10;break}}if((n|0)==10){n=0;p[f>>3]=c;if((a|0)==(b|0)){a=1;n=18;break}else l=a}while(1){f=k[j+(l*104|0)+24>>2]|0;if((f|0)<=-1){a=0;n=18;break b}a=k[j+(f*104|0)+32>>2]|0;if((a|0)==(l|0))l=f;else continue b}}if((n|0)==18)return a|0;return 0}function iHa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0;ba=r;r=r+1072|0;$=ba+8|0;W=ba;if((k[c>>2]&4095|0)!=5){g=$+4|0;f=ZT(28)|0;k[f>>2]=1;q=f+4|0;k[$>>2]=q;k[g>>2]=23;i[f+27>>0]=0;s=371535;t=q+23|0;do{i[q>>0]=i[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(t|0));Y8(-215,$,371559,370820,1365);k[g>>2]=0;k[$>>2]=0;_=k[f>>2]|0;k[f>>2]=_+-1;if((_|0)==1)ggb(k[f+-4>>2]|0)}t=d&768;l=k[a+88>>2]|0;j=k[a+84>>2]|0;f=l-j>>2;if(!f)f=(k[a+112>>2]|0)-(k[a+108>>2]|0)|0;n=k[a+124>>2]|0;m=k[a+120>>2]|0;Y=a+192|0;s=a+196|0;V=(k[s>>2]|0)-(k[Y>>2]|0)|0;X=V>>2;q=(n-m|0)>0?f:0;h=q+1+X|0;Z=$+8|0;k[$>>2]=Z;_=$+4|0;k[_>>2]=264;if(h>>>0>264){g=h>>>0>1073741823?-1:h<<2;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[$>>2]=f;U=f}else U=Z;k[_>>2]=h;T=U+(X<<2)|0;if((d&6|0)!=0|(j|0)==(l|0))R=0;else R=k[a+96>>2]|0;S=k[a+108>>2]|0;N=(m|0)==(n|0)?0:m;P=k[a+132>>2]|0;P=(P|0)==(k[a+136>>2]|0)?0:P;Q=k[c+16>>2]|0;O=k[a+204>>2]|0;O=(O|0)==(k[a+208>>2]|0)?0:O;M=k[c>>2]&16384|0?1:(k[c+48>>2]|0)>>>2;if((q|0)>0)zpb(T|0,-1,q<<2|0)|0;switch(t&1023){case 0:{if((i[a+228>>0]|0)!=0?!(d&1|0?((k[s>>2]|0)-(k[Y>>2]|0)|0)==8:0):0)x=20;else{f=256;L=0}break}case 512:{x=20;break}default:{f=t;L=0}}if((x|0)==20)if((V|0)>0){zpb(U|0,0,((X|0)>1?X:1)<<2|0)|0;f=512;L=1}else{f=512;L=1}h=k[b>>2]|0;K=b+4|0;g=k[K>>2]|0;if((h|0)<(g|0)){C=a+144|0;D=a+156|0;E=a+168|0;F=(R|0)==0;G=(O|0)==0;H=(d&4|0)==0;I=W+4|0;J=W+4|0;B=a+180|0;A=(f|0)==256;n=k[D>>2]|0;e=0.0;f=-1;l=n;while(1){g=k[(k[C>>2]|0)+(h<<2)>>2]|0;j=k[n+(g<<5)+28>>2]|0;if((j|0)<0)j=n;else{m=l;while(1){z=k[E>>2]|0;a=k[z+(j*24|0)>>2]|0;a:do if(F){l=Q+((aa(a,M)|0)<<2)|0;w=+o[l>>2];l=w==3402823466385288598117041.0e14;q=O+(a<<2)|0;s=S+a|0;while(1){if(l){if(G){x=41;break a}v=+o[q>>2]}else v=w;if(!(i[s>>0]|0)){x=44;break a}if(H){l=a;x=46;break}}}else{l=k[R+(a<<2)>>2]|0;t=Q+((aa(l,M)|0)<<2)|0;w=+o[t>>2];t=w==3402823466385288598117041.0e14;if(G){q=S+a|0;while(1){if(t){x=41;break a}if(!(i[q>>0]|0)){v=w;x=44;break a}if(H){v=w;x=46;break a}}}q=O+(a<<2)|0;s=(i[S+a>>0]|0)==0;while(1){if(t)v=+o[q>>2];else v=w;if(s){x=44;break a}if(H){x=46;break}}}while(0);if((x|0)==41){g=(k[n+(g<<5)+24>>2]|0)<0?n+(g<<5)+16|0:n+(g<<5)+20|0;l=m}else if((x|0)==44){g=!(v<=+o[z+(j*24|0)+16>>2])?n+(g<<5)+20|0:n+(g<<5)+16|0;l=m}else if((x|0)==46){y=T+(l<<2)|0;l=k[y>>2]|0;if((l|0)<0){x=N+(a<<3)|0;c=k[x>>2]|0;m=k[N+(a<<3)+4>>2]|0;l=(o[u>>2]=v,k[u>>2]|0);if((l&2130706432)>>>0<=1249902592){l=(l|0)<0;w=l?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(w==0.0)w=l?-0.0:0.0}else w=v;a=~~w;if(+(a|0)!=v){k[W>>2]=0;k[I>>2]=0;l=ZT(56)|0;k[l>>2]=1;q=l+4|0;k[W>>2]=q;k[I>>2]=51;i[l+55>>0]=0;s=371572;t=q+51|0;do{i[q>>0]=i[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(t|0));Y8(-5,W,371559,370820,1443);k[I>>2]=0;k[W>>2]=0;t=k[l>>2]|0;k[l>>2]=t+-1;if((t|0)==1)ggb(k[l+-4>>2]|0);s=c;l=c}else{s=c;l=c}b:while(1){q=m;while(1){if((s|0)>=(q|0))break b;l=q+s>>1;m=k[P+(l<<2)>>2]|0;if((a|0)<(m|0))q=l;else break}if((a|0)<=(m|0))break;m=q;s=l+1|0}if(!((l|0)>-1?(a|0)==(k[P+(l<<2)>>2]|0):0)){k[W>>2]=0;k[J>>2]=0;m=ZT(32)|0;k[m>>2]=1;q=m+4|0;k[W>>2]=q;k[J>>2]=25;i[m+29>>0]=0;s=371624;t=q+25|0;do{i[q>>0]=i[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(t|0));Y8(-215,W,371559,370820,1456);k[J>>2]=0;k[W>>2]=0;a=k[m>>2]|0;k[m>>2]=a+-1;if((a|0)==1)ggb(k[m+-4>>2]|0)}l=l-(k[x>>2]|0)|0;k[y>>2]=l;m=k[D>>2]|0}g=(k[(k[B>>2]|0)+(k[z+(j*24|0)+20>>2]<<2)+(l>>>5<<2)>>2]&1<<(l&31)|0)==0?n+(g<<5)+20|0:n+(g<<5)+16|0;l=m;n=m}g=k[g>>2]|0;j=k[n+(g<<5)+28>>2]|0;if((j|0)<0){j=n;break}else m=l}}if(A)e=e+ +p[j+(g<<5)>>3];else{f=k[j+(g<<5)+8>>2]|0;z=U+(f<<2)|0;k[z>>2]=(k[z>>2]|0)+1}h=h+1|0;g=k[K>>2]|0;if((h|0)>=(g|0))break;else n=j}}else{e=0.0;f=-1}if(L){if((g-(k[b>>2]|0)|0)>1)if((V|0)>4){f=0;g=1;do{f=(k[U+(f<<2)>>2]|0)<(k[U+(g<<2)>>2]|0)?g:f;g=g+1|0}while((g|0)<(X|0))}else f=0;if(!(d&1))f=k[(k[Y>>2]|0)+(f<<2)>>2]|0;e=+(f|0)}f=k[$>>2]|0;if((f|0)==(Z|0)){r=ba;return +e}if(f|0)ggb(f);k[$>>2]=Z;k[_>>2]=264;r=ba;return +e}function jHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o;e=n+4|0;j=ZT(20)|0;k[j>>2]=1;h=j+4|0;k[n>>2]=h;k[e>>2]=14;i[j+18>>0]=0;j=370935;m=h+14|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[e>>2]=0;k[n>>2]=0;if(d|0?(j=d+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);k[n>>2]=l[a+4>>0];wHa(c,n);k[n>>2]=0;e=n+4|0;k[e>>2]=0;j=ZT(20)|0;k[j>>2]=1;h=j+4|0;k[n>>2]=h;k[e>>2]=14;i[j+18>>0]=0;j=370950;m=h+14|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[e>>2]=0;k[n>>2]=0;if(d|0?(j=d+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);k[n>>2]=k[a+64>>2];wHa(c,n);k[n>>2]=0;e=n+4|0;k[e>>2]=0;j=ZT(24)|0;k[j>>2]=1;h=j+4|0;k[n>>2]=h;k[e>>2]=19;i[j+23>>0]=0;j=371076;m=h+19|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[e>>2]=0;k[n>>2]=0;if(d|0?(j=d+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);k[n>>2]=k[a+80>>2];xHa(c,n);k[n>>2]=0;e=n+4|0;k[e>>2]=0;j=ZT(16)|0;k[j>>2]=1;h=j+4|0;k[n>>2]=h;k[e>>2]=9;i[j+13>>0]=0;j=371160;m=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[e>>2]=0;k[n>>2]=0;if(d|0?(j=d+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);k[n>>2]=k[a+68>>2];wHa(c,n);k[n>>2]=0;e=n+4|0;k[e>>2]=0;j=ZT(24)|0;k[j>>2]=1;h=j+4|0;k[n>>2]=h;k[e>>2]=16;i[j+20>>0]=0;j=371207;m=h+16|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[e>>2]=0;k[n>>2]=0;if(d|0?(j=d+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);k[n>>2]=k[a+72>>2];wHa(c,n);k[n>>2]=0;e=n+4|0;k[e>>2]=0;j=ZT(28)|0;k[j>>2]=1;h=j+4|0;k[n>>2]=h;k[e>>2]=22;i[j+26>>0]=0;j=371224;m=h+22|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[e>>2]=0;k[n>>2]=0;if(d|0?(j=d+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);m=a+76|0;k[n>>2]=k[m>>2];wHa(c,n);if((k[m>>2]|0)>1){k[n>>2]=0;e=n+4|0;k[e>>2]=0;j=ZT(20)|0;k[j>>2]=1;h=j+4|0;k[n>>2]=h;k[e>>2]=12;i[j+16>>0]=0;j=371365;m=h+12|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[e>>2]=0;k[n>>2]=0;if(d|0?(j=d+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);k[n>>2]=l[a+5>>0];wHa(c,n)}g=a+8|0;if(!(k[a+24>>2]|0)){r=o;return}f=k[a+12>>2]|0;if((f|0)<3)c=aa(k[a+20>>2]|0,k[a+16>>2]|0)|0;else{e=k[a+48>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0))}if(!c){r=o;return}a=n+4|0;c=ZT(12)|0;k[c>>2]=1;f=c+4|0;k[n>>2]=f;k[a>>2]=6;i[c+10>>0]=0;i[f>>0]=i[371378]|0;i[f+1>>0]=i[371379]|0;i[f+2>>0]=i[371380]|0;i[f+3>>0]=i[371381]|0;i[f+4>>0]=i[371382]|0;i[f+5>>0]=i[371383]|0;f=z6(b,n)|0;c=k[n>>2]|0;k[a>>2]=0;k[n>>2]=0;if(c|0?(a=c+-4|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0)ggb(k[c+-8>>2]|0);if(!(Xh[k[(k[f>>2]|0)+12>>2]&1023](f)|0)){r=o;return}c=f+32|0;if((k[c>>2]|0)==6){d=n+4|0;e=ZT(36)|0;k[e>>2]=1;h=e+4|0;k[n>>2]=h;k[d>>2]=30;i[e+34>>0]=0;j=401220;m=h+30|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));Y8(-2,n,401251,401262,1064);k[d>>2]=0;k[n>>2]=0;n=k[e>>2]|0;k[e>>2]=n+-1;if((n|0)==1)ggb(k[e+-4>>2]|0)}D6(f,f+12|0,g);if(!(k[c>>2]&4)){r=o;return}k[c>>2]=6;r=o;return}function kHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+32|0;v=w+16|0;t=w+24|0;u=w+8|0;h=w+4|0;j=w;d=v+4|0;p=ZT(20)|0;k[p>>2]=1;o=p+4|0;k[v>>2]=o;k[d>>2]=13;i[p+17>>0]=0;p=370905;q=o+13|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));g=z6(b,v)|0;c=k[v>>2]|0;k[d>>2]=0;k[v>>2]=0;if(c|0?(p=c+-4|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[c+-8>>2]|0);e=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;if(Xh[k[(k[g>>2]|0)+12>>2]&1023](g)|0){f=g+32|0;if((k[f>>2]|0)==6){c=v+4|0;d=ZT(36)|0;k[d>>2]=1;o=d+4|0;k[v>>2]=o;k[c>>2]=30;i[d+34>>0]=0;p=401220;q=o+30|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Y8(-2,v,401251,401262,1064);k[c>>2]=0;k[v>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[g+16>>2]|0))c=0;else{c=k[g+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[g+8>>2]|0,c,e&1);if(k[f>>2]&4|0)k[f>>2]=6}k[v>>2]=0;q=v+4|0;k[q>>2]=0;c=ZT(12)|0;k[c>>2]=1;d=c+4|0;k[v>>2]=d;k[q>>2]=7;i[c+11>>0]=0;i[d>>0]=i[371409]|0;i[d+1>>0]=i[371410]|0;i[d+2>>0]=i[371411]|0;i[d+3>>0]=i[371412]|0;i[d+4>>0]=i[371413]|0;i[d+5>>0]=i[371414]|0;i[d+6>>0]=i[371415]|0;d=z6(b,v)|0;c=k[v>>2]|0;k[q>>2]=0;k[v>>2]=0;if(c|0?(p=c+-4|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[c+-8>>2]|0);l=a+108|0;m=a+112|0;k[v>>2]=(k[m>>2]|0)-(k[l>>2]|0);wHa(d,v);k[v>>2]=0;e=v+4|0;k[e>>2]=0;p=ZT(16)|0;k[p>>2]=1;o=p+4|0;k[v>>2]=o;k[e>>2]=9;i[p+13>>0]=0;p=371497;q=o+9|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));c=z6(b,v)|0;d=k[v>>2]|0;k[e>>2]=0;k[v>>2]=0;if(d|0?(p=d+-4|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[d+-8>>2]|0);g=Xh[k[(k[a>>2]|0)+32>>2]&1023](a)|0;k[v>>2]=g;wHa(c,v);k[h>>2]=0;k[j>>2]=0;g=k[l>>2]|0;f=(k[m>>2]|0)-g|0;if((f|0)>0){e=0;c=0;d=0;do{if(!(i[g+e>>0]|0)){c=c+1|0;k[h>>2]=c}else{d=d+1|0;k[j>>2]=d}e=e+1|0}while((e|0)!=(f|0))}k[v>>2]=0;e=v+4|0;k[e>>2]=0;p=ZT(20)|0;k[p>>2]=1;o=p+4|0;k[v>>2]=o;k[e>>2]=13;i[p+17>>0]=0;p=371507;q=o+13|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));c=z6(b,v)|0;d=k[v>>2]|0;k[e>>2]=0;k[v>>2]=0;if(d|0?(p=d+-4|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[d+-8>>2]|0);wHa(c,h);k[v>>2]=0;e=v+4|0;k[e>>2]=0;p=ZT(20)|0;k[p>>2]=1;o=p+4|0;k[v>>2]=o;k[e>>2]=13;i[p+17>>0]=0;p=371521;q=o+13|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));c=z6(b,v)|0;d=k[v>>2]|0;k[e>>2]=0;k[v>>2]=0;if(d|0?(p=d+-4|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[d+-8>>2]|0);wHa(c,j);k[v>>2]=0;e=v+4|0;k[e>>2]=0;p=ZT(20)|0;k[p>>2]=1;o=p+4|0;k[v>>2]=o;k[e>>2]=15;i[p+19>>0]=0;p=370919;q=o+15|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));c=z6(b,v)|0;d=k[v>>2]|0;k[e>>2]=0;k[v>>2]=0;if(d|0?(p=d+-4|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[d+-8>>2]|0);k[v>>2]=0;q=v+4|0;k[q>>2]=0;o=ZT(8)|0;k[o>>2]=1;p=o+4|0;k[v>>2]=p;k[q>>2]=1;i[o+5>>0]=0;i[p>>0]=123;z6(c,v)|0;c=k[v>>2]|0;k[q>>2]=0;k[v>>2]=0;if(c|0?(p=c+-4|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[c+-8>>2]|0);jh[k[(k[a>>2]|0)+224>>2]&1023](a,b);k[v>>2]=0;q=v+4|0;k[q>>2]=0;p=ZT(8)|0;k[p>>2]=1;c=p+4|0;k[v>>2]=c;k[q>>2]=1;i[p+5>>0]=0;i[c>>0]=125;z6(b,v)|0;c=k[v>>2]|0;k[q>>2]=0;k[v>>2]=0;if(c|0?(p=c+-4|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[c+-8>>2]|0);f=a+84|0;if((k[f>>2]|0)!=(k[a+88>>2]|0)){k[v>>2]=0;e=v+4|0;k[e>>2]=0;p=ZT(20)|0;k[p>>2]=1;o=p+4|0;k[v>>2]=o;k[e>>2]=14;i[p+18>>0]=0;p=371470;q=o+14|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));c=z6(b,v)|0;d=k[v>>2]|0;k[e>>2]=0;k[v>>2]=0;if(d|0?(p=d+-4|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[d+-8>>2]|0);k[v>>2]=1;wHa(c,v);k[v>>2]=0;q=v+4|0;k[q>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[v>>2]=c;k[q>>2]=7;i[d+11>>0]=0;i[c>>0]=i[371385]|0;i[c+1>>0]=i[371386]|0;i[c+2>>0]=i[371387]|0;i[c+3>>0]=i[371388]|0;i[c+4>>0]=i[371389]|0;i[c+5>>0]=i[371390]|0;i[c+6>>0]=i[371391]|0;c=z6(b,v)|0;d=k[v>>2]|0;k[q>>2]=0;k[v>>2]=0;if(d|0?(p=d+-4|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[d+-8>>2]|0);yHa(c,f)}k[v>>2]=0;q=v+4|0;k[q>>2]=0;c=ZT(16)|0;k[c>>2]=1;j=c+4|0;k[v>>2]=j;k[q>>2]=8;i[c+12>>0]=0;c=j;i[c>>0]=118;i[c+1>>0]=97;i[c+2>>0]=114;i[c+3>>0]=95;j=j+4|0;i[j>>0]=116;i[j+1>>0]=121;i[j+2>>0]=112;i[j+3>>0]=101;j=z6(b,v)|0;c=k[v>>2]|0;k[q>>2]=0;k[v>>2]=0;if(c|0?(p=c+-4|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[c+-8>>2]|0);if(Xh[k[(k[j>>2]|0)+12>>2]&1023](j)|0){h=j+32|0;if((k[h>>2]|0)==6){c=v+4|0;d=ZT(36)|0;k[d>>2]=1;o=d+4|0;k[v>>2]=o;k[c>>2]=30;i[d+34>>0]=0;p=401220;q=o+30|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Y8(-2,v,401251,401262,1064);k[c>>2]=0;k[v>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}E6(u,j,k[j+12>>2]|0,k[j+16>>2]|0,13,0,0);i[t>>0]=49;i[t+1>>0]=117;i[t+2>>0]=0;k[v>>2]=0;g=v+4|0;k[g>>2]=0;f=t;a:do if(!(f&3)){c=t;s=59}else{e=t;d=49;c=f;while(1){if(!(d<<24>>24))break a;d=e+1|0;c=d;if(!(c&3)){c=d;s=59;break a}e=d;d=i[d>>0]|0}}while(0);if((s|0)==59){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}q=c-f|0;c=ZT(q+8&-4)|0;k[c>>2]=1;p=c+4|0;k[v>>2]=p;k[g>>2]=q;i[p+q>>0]=0;upb(p|0,t|0,q|0)|0;q=k[l>>2]|0;p=k[m>>2]|0;A6(j,v,(q|0)==(p|0)?0:q,p-q|0);k[g>>2]=0;k[v>>2]=0;q=k[c>>2]|0;k[c>>2]=q+-1;if((q|0)==1)ggb(k[c+-4>>2]|0);F6(u);if(k[h>>2]&4|0)k[h>>2]=6}l=a+120|0;m=a+124|0;do if((k[l>>2]|0)!=(k[m>>2]|0)){k[v>>2]=0;q=v+4|0;k[q>>2]=0;c=ZT(12)|0;k[c>>2]=1;n=c+4|0;k[v>>2]=n;k[q>>2]=7;i[c+11>>0]=0;i[n>>0]=i[371435]|0;i[n+1>>0]=i[371436]|0;i[n+2>>0]=i[371437]|0;i[n+3>>0]=i[371438]|0;i[n+4>>0]=i[371439]|0;i[n+5>>0]=i[371440]|0;i[n+6>>0]=i[371441]|0;n=z6(b,v)|0;c=k[v>>2]|0;k[q>>2]=0;k[v>>2]=0;if(c|0?(p=c+-4|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0)ggb(k[c+-8>>2]|0);if(Xh[k[(k[n>>2]|0)+12>>2]&1023](n)|0){j=n+32|0;if((k[j>>2]|0)==6){c=v+4|0;d=ZT(36)|0;k[d>>2]=1;o=d+4|0;k[v>>2]=o;k[c>>2]=30;i[d+34>>0]=0;p=401220;q=o+30|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Y8(-2,v,401251,401262,1064);k[c>>2]=0;k[v>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}E6(u,n,k[n+12>>2]|0,k[n+16>>2]|0,13,0,0);i[t>>0]=50;i[t+1>>0]=105;i[t+2>>0]=0;k[v>>2]=0;h=v+4|0;k[h>>2]=0;g=t;b:do if(!(g&3)){c=t;s=81}else{f=t;d=50;c=g;while(1){if(!(d<<24>>24))break b;c=f+1|0;e=c;if(!(e&3)){s=81;break b}f=c;d=i[c>>0]|0;c=e}}while(0);if((s|0)==81){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}s=c-g|0;c=ZT(s+8&-4)|0;k[c>>2]=1;q=c+4|0;k[v>>2]=q;k[h>>2]=s;i[q+s>>0]=0;upb(q|0,t|0,s|0)|0;t=k[l>>2]|0;s=k[m>>2]|0;A6(n,v,(t|0)==(s|0)?0:t,s-t|0);k[h>>2]=0;k[v>>2]=0;t=k[c>>2]|0;k[c>>2]=t+-1;if((t|0)==1)ggb(k[c+-4>>2]|0);F6(u);if(!(k[j>>2]&4))break;k[j>>2]=6}}while(0);c=a+132|0;if((k[c>>2]|0)!=(k[a+136>>2]|0)){k[v>>2]=0;u=v+4|0;k[u>>2]=0;e=ZT(12)|0;k[e>>2]=1;d=e+4|0;k[v>>2]=d;k[u>>2]=7;i[e+11>>0]=0;i[d>>0]=i[371417]|0;i[d+1>>0]=i[371418]|0;i[d+2>>0]=i[371419]|0;i[d+3>>0]=i[371420]|0;i[d+4>>0]=i[371421]|0;i[d+5>>0]=i[371422]|0;i[d+6>>0]=i[371423]|0;d=z6(b,v)|0;e=k[v>>2]|0;k[u>>2]=0;k[v>>2]=0;if(e|0?(t=e+-4|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0)ggb(k[e+-8>>2]|0);yHa(d,c)}e=a+192|0;if((k[e>>2]|0)!=(k[a+196>>2]|0)){k[v>>2]=0;f=v+4|0;k[f>>2]=0;p=ZT(20)|0;k[p>>2]=1;o=p+4|0;k[v>>2]=o;k[f>>2]=12;i[p+16>>0]=0;p=371457;q=o+12|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));c=z6(b,v)|0;d=k[v>>2]|0;k[f>>2]=0;k[v>>2]=0;if(d|0?(t=d+-4|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0)ggb(k[d+-8>>2]|0);yHa(c,e)}g=a+204|0;if((k[g>>2]|0)==(k[a+208>>2]|0)){r=w;return}k[v>>2]=0;d=v+4|0;k[d>>2]=0;p=ZT(20)|0;k[p>>2]=1;o=p+4|0;k[v>>2]=o;k[d>>2]=13;i[p+17>>0]=0;p=371443;q=o+13|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));f=z6(b,v)|0;c=k[v>>2]|0;k[d>>2]=0;k[v>>2]=0;if(c|0?(a=c+-4|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0)ggb(k[c+-8>>2]|0);if(!(Xh[k[(k[f>>2]|0)+12>>2]&1023](f)|0)){r=w;return}c=f+32|0;if((k[c>>2]|0)==6){d=v+4|0;e=ZT(36)|0;k[e>>2]=1;o=e+4|0;k[v>>2]=o;k[d>>2]=30;i[e+34>>0]=0;p=401220;q=o+30|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Y8(-2,v,401251,401262,1064);k[d>>2]=0;k[v>>2]=0;b=k[e>>2]|0;k[e>>2]=b+-1;if((b|0)==1)ggb(k[e+-4>>2]|0)}E6(v,f,k[f+12>>2]|0,k[f+16>>2]|0,13,0,0);GEa(f,g);F6(v);if(!(k[c>>2]&4)){r=w;return}k[c>>2]=6;r=w;return}function lHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;n=r;r=r+16|0;m=n+8|0;f=n+4|0;l=n;j=k[a+168>>2]|0;h=m+4|0;g=ZT(8)|0;k[g>>2]=1;d=g+4|0;k[m>>2]=d;k[h>>2]=2;i[g+6>>0]=0;i[d>>0]=123;i[d+1>>0]=58;z6(b,m)|0;d=k[m>>2]|0;k[h>>2]=0;k[m>>2]=0;if(d|0?(g=d+-4|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[d+-8>>2]|0);g=k[j+(c*24|0)>>2]|0;k[f>>2]=g;k[m>>2]=0;h=m+4|0;k[h>>2]=0;e=ZT(8)|0;k[e>>2]=1;d=e+4|0;k[m>>2]=d;k[h>>2]=3;i[e+7>>0]=0;i[d>>0]=i[370769]|0;i[d+1>>0]=i[370770]|0;i[d+2>>0]=i[370771]|0;d=z6(b,m)|0;e=k[m>>2]|0;k[h>>2]=0;k[m>>2]=0;if(e|0?(o=e+-4|0,h=k[o>>2]|0,k[o>>2]=h+-1,(h|0)==1):0)ggb(k[e+-8>>2]|0);wHa(d,f);k[m>>2]=0;o=m+4|0;k[o>>2]=0;e=ZT(12)|0;k[e>>2]=1;d=e+4|0;k[m>>2]=d;k[o>>2]=7;i[e+11>>0]=0;i[d>>0]=i[370897]|0;i[d+1>>0]=i[370898]|0;i[d+2>>0]=i[370899]|0;i[d+3>>0]=i[370900]|0;i[d+4>>0]=i[370901]|0;i[d+5>>0]=i[370902]|0;i[d+6>>0]=i[370903]|0;d=z6(b,m)|0;e=k[m>>2]|0;k[o>>2]=0;k[m>>2]=0;if(e|0?(h=e+-4|0,o=k[h>>2]|0,k[h>>2]=o+-1,(o|0)==1):0)ggb(k[e+-8>>2]|0);xHa(d,j+(c*24|0)+8|0);if((i[(k[a+108>>2]|0)+g>>0]|0)==1){h=k[a+120>>2]|0;h=(k[h+(g<<3)+4>>2]|0)-(k[h+(g<<3)>>2]|0)|0;a=(k[a+180>>2]|0)+(k[j+(c*24|0)+20>>2]<<2)|0;k[l>>2]=0;g=(h|0)>0;if(g){d=0;e=0;do{d=((k[a+(e>>5<<2)>>2]&1<<(e&31)|0)==0&1)+d|0;e=e+1|0}while((e|0)!=(h|0));k[l>>2]=h;if((d|0)>=2?(o=(h|0)/2|0,(d|0)>(((o|0)<3?o:3)|0)):0)f=(d|0)<=((h|0)/3|0|0)?-1:1;else f=-1}else f=-1;e=(aa(i[j+(c*24|0)+4>>0]|0?-1:1,f)|0)>0;k[m>>2]=0;o=m+4|0;k[o>>2]=0;d=e?2:6;j=ZT(d&4|8)|0;k[j>>2]=1;j=j+4|0;k[m>>2]=j;k[o>>2]=d;i[j+d>>0]=0;upb(k[m>>2]|0,(e?370881:370884)|0,d|0)|0;d=z6(b,m)|0;e=k[m>>2]|0;k[o>>2]=0;k[m>>2]=0;if(e|0?(j=e+-4|0,o=k[j>>2]|0,k[j>>2]=o+-1,(o|0)==1):0)ggb(k[e+-8>>2]|0);o=m+4|0;c=ZT(8)|0;k[c>>2]=1;j=c+4|0;k[m>>2]=j;k[o>>2]=2;i[c+6>>0]=0;i[j>>0]=91;i[j+1>>0]=58;z6(d,m)|0;d=k[m>>2]|0;k[o>>2]=0;k[m>>2]=0;if(d|0?(j=d+-4|0,o=k[j>>2]|0,k[j>>2]=o+-1,(o|0)==1):0)ggb(k[d+-8>>2]|0);k[l>>2]=0;if(g){d=0;do{if((aa((((k[a+(d>>5<<2)>>2]&1<<(d&31)|0)==0&1)<<1)+-1|0,f)|0)<0)wHa(b,l);d=d+1|0;k[l>>2]=d}while((d|0)!=(h|0))}o=m+4|0;l=ZT(8)|0;k[l>>2]=1;d=l+4|0;k[m>>2]=d;k[o>>2]=1;i[l+5>>0]=0;i[d>>0]=93;z6(b,m)|0;d=k[m>>2]|0;k[o>>2]=0;k[m>>2]=0;if(d|0?(l=d+-4|0,o=k[l>>2]|0,k[l>>2]=o+-1,(o|0)==1):0)ggb(k[d+-8>>2]|0)}else{o=m+4|0;e=(i[j+(c*24|0)+4>>0]|0)!=0;l=ZT(8)|0;k[l>>2]=1;d=l+4|0;k[m>>2]=d;k[o>>2]=2;i[l+6>>0]=0;e=e?29799:25964;i[d>>0]=e;i[d+1>>0]=e>>8;d=z6(b,m)|0;e=k[m>>2]|0;k[o>>2]=0;k[m>>2]=0;if(e|0?(l=e+-4|0,o=k[l>>2]|0,k[l>>2]=o+-1,(o|0)==1):0)ggb(k[e+-8>>2]|0);xHa(d,j+(c*24|0)+16|0)}o=m+4|0;l=ZT(8)|0;k[l>>2]=1;d=l+4|0;k[m>>2]=d;k[o>>2]=1;i[l+5>>0]=0;i[d>>0]=125;z6(b,m)|0;d=k[m>>2]|0;k[o>>2]=0;k[m>>2]=0;if(!d){r=n;return}m=d+-4|0;o=k[m>>2]|0;k[m>>2]=o+-1;if((o|0)!=1){r=n;return}ggb(k[d+-8>>2]|0);r=n;return}function mHa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0;q=r;r=r+16|0;o=q+8|0;f=q;k[f>>2]=d;n=k[a+156>>2]|0;m=o+4|0;l=ZT(8)|0;k[l>>2]=1;d=l+4|0;k[o>>2]=d;k[m>>2]=1;i[l+5>>0]=0;i[d>>0]=123;z6(b,o)|0;d=k[o>>2]|0;k[m>>2]=0;k[o>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);k[o>>2]=0;m=o+4|0;k[m>>2]=0;e=ZT(12)|0;k[e>>2]=1;d=e+4|0;k[o>>2]=d;k[m>>2]=5;i[e+9>>0]=0;i[d>>0]=i[371491]|0;i[d+1>>0]=i[371492]|0;i[d+2>>0]=i[371493]|0;i[d+3>>0]=i[371494]|0;i[d+4>>0]=i[371495]|0;d=z6(b,o)|0;e=k[o>>2]|0;k[m>>2]=0;k[o>>2]=0;if(e|0?(l=e+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[e+-8>>2]|0);wHa(d,f);k[o>>2]=0;l=o+4|0;k[l>>2]=0;d=ZT(12)|0;k[d>>2]=1;m=d+4|0;k[o>>2]=m;k[l>>2]=5;i[d+9>>0]=0;i[m>>0]=i[389389]|0;i[m+1>>0]=i[389390]|0;i[m+2>>0]=i[389391]|0;i[m+3>>0]=i[389392]|0;i[m+4>>0]=i[389393]|0;m=z6(b,o)|0;d=k[o>>2]|0;k[l>>2]=0;k[o>>2]=0;if(d|0?(j=d+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[d+-8>>2]|0);f=n+(c<<5)|0;if(Xh[k[(k[m>>2]|0)+12>>2]&1023](m)|0){g=m+32|0;if((k[g>>2]|0)==6){d=o+4|0;e=ZT(36)|0;k[e>>2]=1;h=e+4|0;k[o>>2]=h;k[d>>2]=30;i[e+34>>0]=0;j=401220;l=h+30|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-2,o,401251,401262,1064);k[d>>2]=0;k[o>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}if(!(k[m+16>>2]|0))d=0;else{d=k[m+12>>2]|0;d=(d|0)==0?1016759:d}u6(k[m+8>>2]|0,d,+p[f>>3]);if(k[g>>2]&4|0)k[g>>2]=6}if(i[a+228>>0]|0){k[o>>2]=0;f=o+4|0;k[f>>2]=0;j=ZT(20)|0;k[j>>2]=1;h=j+4|0;k[o>>2]=h;k[f>>2]=14;i[j+18>>0]=0;j=370747;l=h+14|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));d=z6(b,o)|0;e=k[o>>2]|0;k[f>>2]=0;k[o>>2]=0;if(e|0?(l=e+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[e+-8>>2]|0);wHa(d,n+(c<<5)+8|0)}f=n+(c<<5)+28|0;if((k[f>>2]|0)>-1){k[o>>2]=0;c=o+4|0;k[c>>2]=0;e=ZT(12)|0;k[e>>2]=1;d=e+4|0;k[o>>2]=d;k[c>>2]=6;i[e+10>>0]=0;i[d>>0]=i[370762]|0;i[d+1>>0]=i[370763]|0;i[d+2>>0]=i[370764]|0;i[d+3>>0]=i[370765]|0;i[d+4>>0]=i[370766]|0;i[d+5>>0]=i[370767]|0;d=z6(b,o)|0;e=k[o>>2]|0;k[c>>2]=0;k[o>>2]=0;if(e|0?(n=e+-4|0,c=k[n>>2]|0,k[n>>2]=c+-1,(c|0)==1):0)ggb(k[e+-8>>2]|0);c=o+4|0;m=ZT(8)|0;k[m>>2]=1;n=m+4|0;k[o>>2]=n;k[c>>2]=1;i[m+5>>0]=0;i[n>>0]=91;z6(d,o)|0;d=k[o>>2]|0;k[c>>2]=0;k[o>>2]=0;if(d|0?(n=d+-4|0,c=k[n>>2]|0,k[n>>2]=c+-1,(c|0)==1):0)ggb(k[d+-8>>2]|0);d=k[f>>2]|0;if((d|0)>-1){e=a+168|0;do{Ph[k[(k[a>>2]|0)+232>>2]&511](a,b,d);d=k[(k[e>>2]|0)+(d*24|0)+12>>2]|0}while((d|0)>-1)}a=o+4|0;c=ZT(8)|0;k[c>>2]=1;d=c+4|0;k[o>>2]=d;k[a>>2]=1;i[c+5>>0]=0;i[d>>0]=93;z6(b,o)|0;d=k[o>>2]|0;k[a>>2]=0;k[o>>2]=0;if(d|0?(c=d+-4|0,a=k[c>>2]|0,k[c>>2]=a+-1,(a|0)==1):0)ggb(k[d+-8>>2]|0)}a=o+4|0;c=ZT(8)|0;k[c>>2]=1;d=c+4|0;k[o>>2]=d;k[a>>2]=1;i[c+5>>0]=0;i[d>>0]=125;z6(b,o)|0;d=k[o>>2]|0;k[a>>2]=0;k[o>>2]=0;if(!d){r=q;return}b=d+-4|0;o=k[b>>2]|0;k[b>>2]=o+-1;if((o|0)!=1){r=q;return}ggb(k[d+-8>>2]|0);r=q;return}function nHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;h=j+4|0;e=ZT(12)|0;k[e>>2]=1;d=e+4|0;k[j>>2]=d;k[h>>2]=5;i[e+9>>0]=0;i[d>>0]=i[371485]|0;i[d+1>>0]=i[371486]|0;i[d+2>>0]=i[371487]|0;i[d+3>>0]=i[371488]|0;i[d+4>>0]=i[371489]|0;d=z6(b,j)|0;e=k[j>>2]|0;k[h>>2]=0;k[j>>2]=0;if(e|0?(g=e+-4|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[e+-8>>2]|0);h=j+4|0;f=ZT(8)|0;k[f>>2]=1;g=f+4|0;k[j>>2]=g;k[h>>2]=1;i[f+5>>0]=0;i[g>>0]=91;z6(d,j)|0;d=k[j>>2]|0;k[h>>2]=0;k[j>>2]=0;if(d|0?(g=d+-4|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[d+-8>>2]|0);h=a+156|0;e=0;d=c;a:while(1){while(1){dh[k[(k[a>>2]|0)+236>>2]&255](a,b,d,e);g=k[h>>2]|0;c=k[g+(d<<5)+16>>2]|0;if((c|0)<0)break;else{e=e+1|0;d=c}}c=k[g+(d<<5)+12>>2]|0;if((c|0)<=-1)break;while(1){f=k[g+(c<<5)+20>>2]|0;if((f|0)!=(d|0)){d=f;continue a}d=k[g+(c<<5)+12>>2]|0;if((d|0)>-1){f=c;c=d;e=e+-1|0;d=f}else break a}}a=j+4|0;h=ZT(8)|0;k[h>>2]=1;d=h+4|0;k[j>>2]=d;k[a>>2]=1;i[h+5>>0]=0;i[d>>0]=93;z6(b,j)|0;d=k[j>>2]|0;k[a>>2]=0;k[j>>2]=0;if(!d){r=l;return}b=d+-4|0;j=k[b>>2]|0;k[b>>2]=j+-1;if((j|0)!=1){r=l;return}ggb(k[d+-8>>2]|0);r=l;return}function oHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;Q=r;r=r+224|0;M=Q+168|0;L=Q+124|0;B=Q+80|0;P=Q;N=b+4|0;c=k6(k[b>>2]|0,k[N>>2]|0,370905)|0;a:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break a}case 2:break;default:{c=2147483647;break a}}f=+p[c+8>>3];p[u>>3]=f;c=k[u+4>>2]|0;K=c&2146435072;if(!(K>>>0>1126170624|(K|0)==1126170624&0>0)){c=(c|0)<0;f=c?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=c?-0.0:0.0}c=~~f}while(0);v=a+228|0;i[v>>0]=(c|0)!=0&1;n=k[b>>2]|0;h=k6(n,k[N>>2]|0,370919)|0;uHa(P);if(h|0){c=k6(n,h,370935)|0;b:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break b}case 2:break;default:{c=2147483647;break b}}f=+p[c+8>>3];p[u>>3]=f;c=k[u+4>>2]|0;K=c&2146435072;if(!(K>>>0>1126170624|(K|0)==1126170624&0>0)){c=(c|0)<0;f=c?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=c?-0.0:0.0}c=~~f}while(0);i[P>>0]=(c|0)!=0&1;c:do if(!(k6(n,h,370950)|0))c=16;else{c=k6(n,h,370950)|0;if(c){switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break}case 2:{f=+p[c+8>>3];p[u>>3]=f;c=k[u+4>>2]|0;K=c&2146435072;if(!(K>>>0>1126170624|(K|0)==1126170624&0>0)){c=(c|0)<0;f=c?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=c?-0.0:0.0}c=~~f;break}default:{c=2147483647;break c}}if((c|0)>=2)break}else c=0;k[M>>2]=0;d=M+4|0;k[d>>2]=0;e=ZT(36)|0;k[e>>2]=1;j=e+4|0;k[M>>2]=j;k[d>>2]=29;i[e+33>>0]=0;g=370965;m=j+29|0;do{i[j>>0]=i[g>>0]|0;j=j+1|0;g=g+1|0}while((j|0)<(m|0));Y8(-211,M,370995,371012,135);k[d>>2]=0;k[M>>2]=0;K=k[e>>2]|0;k[e>>2]=K+-1;if((K|0)==1)ggb(k[e+-4>>2]|0)}while(0);k[P+60>>2]=(c|0)>15?15:c;c=k6(n,h,371076)|0;d:do if(c){switch(k[c>>2]&7){case 1:{f=+(k[c+8>>2]|0);break}case 2:{f=+p[c+8>>3];break}default:{f=1000000015047466219876688.0e6;break d}}if(f<0.0){k[M>>2]=0;c=M+4|0;k[c>>2]=0;d=ZT(48)|0;k[d>>2]=1;j=d+4|0;k[M>>2]=j;k[c>>2]=41;i[d+45>>0]=0;g=371096;m=j+41|0;do{i[j>>0]=i[g>>0]|0;j=j+1|0;g=g+1|0}while((j|0)<(m|0));Y8(-211,M,371138,371012,161);k[c>>2]=0;k[M>>2]=0;K=k[d>>2]|0;k[d>>2]=K+-1;if((K|0)==1)ggb(k[d+-4>>2]|0)}}else f=0.0;while(0);o[P+76>>2]=f;c=k6(n,h,371160)|0;e:do if(c){switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break}case 2:{f=+p[c+8>>3];p[u>>3]=f;c=k[u+4>>2]|0;K=c&2146435072;if(!(K>>>0>1126170624|(K|0)==1126170624&0>0)){c=(c|0)<0;f=c?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=c?-0.0:0.0}c=~~f;break}default:{c=2147483647;break e}}if((c|0)<0){k[M>>2]=0;d=M+4|0;k[d>>2]=0;e=ZT(32)|0;k[e>>2]=1;j=e+4|0;k[M>>2]=j;k[d>>2]=24;i[e+28>>0]=0;g=371170;m=j+24|0;do{i[j>>0]=i[g>>0]|0;j=j+1|0;g=g+1|0}while((j|0)<(m|0));Y8(-211,M,371195,371012,141);k[d>>2]=0;k[M>>2]=0;K=k[e>>2]|0;k[e>>2]=K+-1;if((K|0)==1)ggb(k[e+-4>>2]|0)}}else c=0;while(0);k[P+64>>2]=(c|0)>25?25:c;c=k6(n,h,371207)|0;f:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break f}case 2:break;default:{c=2147483647;break f}}f=+p[c+8>>3];p[u>>3]=f;c=k[u+4>>2]|0;K=c&2146435072;if(!(K>>>0>1126170624|(K|0)==1126170624&0>0)){c=(c|0)<0;f=c?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=c?-0.0:0.0}c=~~f}while(0);k[P+68>>2]=(c|0)<1?1:c;c=k6(n,h,371224)|0;g:do if(c){switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break}case 2:{f=+p[c+8>>3];p[u>>3]=f;c=k[u+4>>2]|0;K=c&2146435072;if(!(K>>>0>1126170624|(K|0)==1126170624&0>0)){c=(c|0)<0;f=c?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=c?-0.0:0.0}c=~~f;break}default:{c=2147483647;break g}}if((c|0)<0){k[M>>2]=0;d=M+4|0;k[d>>2]=0;e=ZT(112)|0;k[e>>2]=1;j=e+4|0;k[M>>2]=j;k[d>>2]=106;i[e+110>>0]=0;g=371247;m=j+106|0;do{i[j>>0]=i[g>>0]|0;j=j+1|0;g=g+1|0}while((j|0)<(m|0));Y8(-211,M,371354,371012,153);k[d>>2]=0;k[M>>2]=0;K=k[e>>2]|0;k[e>>2]=K+-1;if((K|0)==1)ggb(k[e+-4>>2]|0)}}else c=0;while(0);K=(c|0)==1?0:c;k[P+72>>2]=K;if((K|0)>1){c=k6(n,h,371365)|0;h:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break h}case 2:break;default:{c=2147483647;break h}}f=+p[c+8>>3];p[u>>3]=f;c=k[u+4>>2]|0;K=c&2146435072;if(!(K>>>0>1126170624|(K|0)==1126170624&0>0)){c=(c|0)<0;f=c?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=c?-0.0:0.0}c=~~f}while(0);i[a+5>>0]=(c|0)!=0&1}d=k6(n,h,371378)|0;e=P+4|0;k[M>>2]=1124007936;l=M+4|0;c=M+8|0;h=M+40|0;j=l;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[h>>2]=c;j=M+48|0;g=M+44|0;k[g>>2]=j;k[M+52>>2]=0;k[j>>2]=0;G6(n,d,e,M);e=M+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,K=k[I>>2]|0,k[I>>2]=K+-1,(K|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[M+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;K=M+16|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[l>>2]|0)>0){d=k[h>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[l>>2]|0))}c=k[g>>2]|0;if(!((c|0)==(j|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}c=k[b>>2]|0;I=a+84|0;vHa(c,k6(c,k[N>>2]|0,371385)|0,I);c=k[b>>2]|0;e=k6(c,k[N>>2]|0,371393)|0;K=a+108|0;do if((c|0)!=0&(e|0)!=0?(q=k[e>>2]|0,s=q&7,(s|0)!=0):0){k[B>>2]=c;k[B+4>>2]=e;if(!((s+-5|0)>>>0<2&(q&16|0)==0)){k[B+20>>2]=e;k[B+12>>2]=0;k[B+40>>2]=1;c=1;break}d=e+8|0;KY(k[d>>2]|0,B+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[B+40>>2]=c}else J=97;while(0);if((J|0)==97){k[B>>2]=0;k[B+4>>2]=0;k[B+20>>2]=0;k[B+40>>2]=0;c=0}i[L>>0]=49;n=L+1|0;i[n>>0]=117;q=L+2|0;i[q>>0]=0;g=(c|0)<0?2147483647:c;F=a+112|0;e=k[F>>2]|0;d=k[K>>2]|0;c=e-d|0;if(g>>>0<=c>>>0){if(g>>>0<c>>>0?(t=d+g|0,(e|0)!=(t|0)):0)k[F>>2]=t}else T1(K,g-c|0);k[M>>2]=0;e=M+4|0;k[e>>2]=0;t=L;s=(t&3|0)==0;i:do if(s){c=L;J=106}else{d=L;c=t;while(1){if(!(i[d>>0]|0))break i;d=d+1|0;c=d;if(!(c&3)){c=d;J=106;break}}}while(0);if((J|0)==106){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}E=c-t|0;c=ZT(E+8&-4)|0;k[c>>2]=1;m=c+4|0;k[M>>2]=m;k[e>>2]=E;i[m+E>>0]=0;upb(m|0,L|0,E|0)|0;E=k[K>>2]|0;C6(B,M,(E|0)==(k[F>>2]|0)?0:E,g)|0;k[e>>2]=0;k[M>>2]=0;E=k[c>>2]|0;k[c>>2]=E+-1;if((E|0)==1)ggb(k[c+-4>>2]|0);c=k6(k[b>>2]|0,k[N>>2]|0,371402)|0;j:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break j}case 2:break;default:{c=2147483647;break j}}f=+p[c+8>>3];p[u>>3]=f;c=k[u+4>>2]|0;E=c&2146435072;if(!(E>>>0>1126170624|(E|0)==1126170624&0>0)){c=(c|0)<0;f=c?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=c?-0.0:0.0}c=~~f}while(0);m=(c|0)<3;c=k6(k[b>>2]|0,k[N>>2]|0,371409)|0;k:do if(!c)l=0;else{switch(k[c>>2]&7){case 1:{l=k[c+8>>2]|0;break k}case 2:break;default:{l=2147483647;break k}}f=+p[c+8>>3];p[u>>3]=f;c=k[u+4>>2]|0;E=c&2146435072;if(!(E>>>0>1126170624|(E|0)==1126170624&0>0)){c=(c|0)<0;f=c?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=c?-0.0:0.0}l=~~f}while(0);if(m?((k[F>>2]|0)-(k[K>>2]|0)|0)<=(l|0):0){d=l+1|0;if(!d){g=0;e=0;j=0}else{if((l|0)<-1)ad(426534,426557,304,426811);while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}g=c;h=c+d|0;e=g;do{i[c>>0]=0;c=e+1|0;e=c;d=d+-1|0}while((d|0)!=0);j=h}h=k[I>>2]|0;c=k[a+88>>2]|0;if((h|0)==(c|0)){c=k[K>>2]|0;d=(k[F>>2]|0)-c|0;if((d|0)>0?(x=g,i[x>>0]=i[c>>0]|0,(d|0)!=1):0){c=1;do{i[x+c>>0]=i[(k[K>>2]|0)+c>>0]|0;c=c+1|0}while((c|0)!=(d|0))}}else{c=c-h|0;d=c>>2;if((c|0)>0?(w=g,i[w+(k[h>>2]|0)>>0]=i[k[K>>2]>>0]|0,(c|0)>4):0){c=1;do{i[w+(k[(k[I>>2]|0)+(c<<2)>>2]|0)>>0]=i[(k[K>>2]|0)+c>>0]|0;c=c+1|0}while((c|0)<(d|0))}}i[g+l>>0]=i[v>>0]|0;c=k[K>>2]|0;k[K>>2]=g;k[F>>2]=e;k[a+116>>2]=j;if(c|0)ggb(c)}x=k[b>>2]|0;E=a+132|0;vHa(x,k6(x,k[N>>2]|0,371417)|0,E);if(m){q=a+120|0;c=k[q>>2]|0;s=a+124|0;d=k[s>>2]|0;if((d|0)!=(c|0))k[s>>2]=d+(~((d+-8-c|0)>>>3)<<3);A=a+192|0;c=k[A>>2]|0;C=a+196|0;d=k[C>>2]|0;if((d|0)!=(c|0))k[C>>2]=d+(~((d+-4-c|0)>>>2)<<2);k[M>>2]=0;D=M+4|0;k[D>>2]=0;k[M+8>>2]=0;c=k[b>>2]|0;vHa(c,k6(c,k[N>>2]|0,371425)|0,M);c=k[K>>2]|0;l=(k[F>>2]|0)+-1-c|0;l:do if(!l)z=0;else{m=L+4|0;n=a+128|0;d=0;e=0;j=0;while(1){k[L>>2]=0;k[m>>2]=0;if((i[c+j>>0]|0)==1){k[L>>2]=d;J=(k[(k[M>>2]|0)+(e<<2)>>2]|0)+d|0;k[m>>2]=J;h=J;g=e+1|0;e=J}else{h=d;g=e;d=0;e=0}c=k[s>>2]|0;if((c|0)==(k[n>>2]|0))RAa(q,L);else{k[c>>2]=d;k[c+4>>2]=e;k[s>>2]=c+8}c=j+1|0;if(c>>>0>=l>>>0){z=h;break l}d=h;e=g;j=c;c=k[K>>2]|0}}while(0);B=a+136|0;l=k[B>>2]|0;c=k[E>>2]|0;if(z>>>0<l-c>>2>>>0){g=k[C>>2]|0;x=c+(z<<2)|0;m=x;s=k[A>>2]|0;d=s;q=g-d|0;n=q>>2;y=s+(n<<2)|0;L=l-m|0;j=L>>2;w=l;t=g;do if((L|0)>0){v=a+200|0;e=k[v>>2]|0;if((j|0)<=(e-g>>2|0)){m=y;h=g-m|0;c=h>>2;if((j|0)>(c|0)){c=x+(c<<2)|0;g=c;if((c|0)==(w|0))c=t;else{e=w+-4|0;d=t;while(1){k[d>>2]=k[c>>2];c=c+4|0;if((c|0)==(w|0))break;else d=d+4|0}c=t+(((e-g|0)>>>2)+1<<2)|0;k[C>>2]=c}if((h|0)>0)l=g;else break}else c=t;h=c-(y+(j<<2))|0;j=h>>2;d=y+(j<<2)|0;if(d>>>0<t>>>0){g=t+(0-j<<2)+~m|0;e=c;while(1){k[e>>2]=k[d>>2];d=d+4|0;if(d>>>0>=t>>>0)break;else e=e+4|0}k[C>>2]=c+((g>>>2)+1<<2)}if(j|0)wpb(c+(0-j<<2)|0,y|0,h|0)|0;c=l-x|0;if(!c)break;wpb(y|0,x|0,c|0)|0;break}c=(g-d>>2)+j|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);j=e-d|0;e=j>>1;e=j>>2>>>0<536870911?(e>>>0<c>>>0?c:e):1073741823;j=y;if(!e)c=0;else{if(e>>>0>1073741823){Q=te(4)|0;k[Q>>2]=172664;Cf(Q|0,28816,1287)}d=e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}g=c+(n<<2)|0;h=c+(e<<2)|0;if((x|0)==(w|0))c=g;else{e=(w+-4-m|0)>>>2;c=x;d=g;while(1){k[d>>2]=k[c>>2];c=c+4|0;if((c|0)==(w|0))break;else d=d+4|0}c=g+(e+1<<2)|0}e=g+(0-n<<2)|0;if((q|0)>0)upb(e|0,s|0,q|0)|0;d=(k[C>>2]|0)-j|0;if((d|0)>0){upb(c|0,y|0,d|0)|0;c=c+(d>>2<<2)|0}k[A>>2]=e;k[C>>2]=c;k[v>>2]=h;if(!s)break;ggb(s)}while(0);c=(k[E>>2]|0)+(z<<2)|0;d=k[B>>2]|0;if((c|0)!=(d|0))k[B>>2]=d+(~((d+-4-c|0)>>>2)<<2)}c=k[M>>2]|0;d=c;if(c|0){e=k[D>>2]|0;if((e|0)!=(c|0))k[D>>2]=e+(~((e+-4-d|0)>>>2)<<2);ggb(c)}}else{c=k[b>>2]|0;e=k6(c,k[N>>2]|0,371435)|0;do if((c|0)!=0&(e|0)!=0?(y=k[e>>2]|0,z=y&7,(z|0)!=0):0){k[B>>2]=c;k[B+4>>2]=e;if(!((z+-5|0)>>>0<2&(y&16|0)==0)){k[B+20>>2]=e;k[B+12>>2]=0;k[B+40>>2]=1;c=1;break}d=e+8|0;KY(k[d>>2]|0,B+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[B+40>>2]=c}else J=214;while(0);if((J|0)==214){k[B>>2]=0;k[B+4>>2]=0;k[B+20>>2]=0;k[B+40>>2]=0;c=0}j=a+120|0;i[L>>0]=50;i[n>>0]=105;i[q>>0]=0;g=c>>>1;h=a+124|0;e=k[h>>2]|0;d=k[j>>2]|0;c=e-d>>3;if(g>>>0<=c>>>0){if(g>>>0<c>>>0?(A=d+(g<<3)|0,(e|0)!=(A|0)):0)k[h>>2]=e+(~((e+-8-A|0)>>>3)<<3)}else V1(j,g-c|0);k[M>>2]=0;e=M+4|0;k[e>>2]=0;m:do if(s){c=L;J=223}else{d=L;c=t;while(1){if(!(i[d>>0]|0))break m;d=d+1|0;c=d;if(!(c&3)){c=d;J=223;break}}}while(0);if((J|0)==223){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}E=c-t|0;c=ZT(E+8&-4)|0;k[c>>2]=1;A=c+4|0;k[M>>2]=A;k[e>>2]=E;i[A+E>>0]=0;upb(A|0,L|0,E|0)|0;E=k[j>>2]|0;C6(B,M,(E|0)==(k[h>>2]|0)?0:E,g<<3)|0;k[e>>2]=0;k[M>>2]=0;E=k[c>>2]|0;k[c>>2]=E+-1;if((E|0)==1)ggb(k[c+-4>>2]|0);c=k[b>>2]|0;e=k6(c,k[N>>2]|0,371443)|0;do if((c|0)!=0&(e|0)!=0?(C=k[e>>2]|0,D=C&7,(D|0)!=0):0){k[L>>2]=c;k[L+4>>2]=e;if(!((D+-5|0)>>>0<2&(C&16|0)==0)){k[L+20>>2]=e;k[L+12>>2]=0;k[L+40>>2]=1;break}d=e+8|0;KY(k[d>>2]|0,L+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[L+40>>2]=c}else J=239;while(0);if((J|0)==239){k[L>>2]=0;k[L+4>>2]=0;k[L+20>>2]=0;k[L+40>>2]=0}k[M>>2]=L;EEa(M,a+204|0);c=k[b>>2]|0;e=k6(c,k[N>>2]|0,371457)|0;do if((c|0)!=0&(e|0)!=0?(G=k[e>>2]|0,H=G&7,(H|0)!=0):0){k[L>>2]=c;k[L+4>>2]=e;if(!((H+-5|0)>>>0<2&(G&16|0)==0)){k[L+20>>2]=e;k[L+12>>2]=0;k[L+40>>2]=1;break}d=e+8|0;KY(k[d>>2]|0,L+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[L+40>>2]=c}else J=249;while(0);if((J|0)==249){k[L>>2]=0;k[L+4>>2]=0;k[L+20>>2]=0;k[L+40>>2]=0}k[M>>2]=L;gza(M,a+192|0)}c=k6(k[b>>2]|0,k[N>>2]|0,371470)|0;n:do if(c){switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break}case 2:{f=+p[c+8>>3];p[u>>3]=f;c=k[u+4>>2]|0;N=c&2146435072;if(!(N>>>0>1126170624|(N|0)==1126170624&0>0)){c=(c|0)<0;f=c?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=c?-0.0:0.0}c=~~f;break}default:{J=260;break n}}if(c)J=260;else J=259}else J=259;while(0);if((J|0)==259){c=k[I>>2]|0;d=k[a+88>>2]|0;if((c|0)==(d|0))J=260;else dQ(a+216|0,c,d)}if((J|0)==260){h=a+216|0;j=(k[F>>2]|0)-(k[K>>2]|0)|0;c=a+220|0;g=k[c>>2]|0;e=k[h>>2]|0;d=g-e>>2;if(j>>>0<=d>>>0){if(j>>>0<d>>>0?(O=e+(j<<2)|0,(g|0)!=(O|0)):0)k[c>>2]=g+(~((g+-4-O|0)>>>2)<<2)}else U1(h,j-d|0);if((j|0)>0){d=k[h>>2]|0;c=0;do{k[d+(c<<2)>>2]=c;c=c+1|0}while((c|0)!=(j|0))}}Uh[k[(k[a>>2]|0)+160>>2]&2047](a);jh[k[(k[a>>2]|0)+148>>2]&1023](a,P);e=P+40|0;c=k[e>>2]|0;if(c|0?(O=c+12|0,a=k[O>>2]|0,k[O>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[P+36>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;a=P+20|0;d=P+8|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[d>>2]|0)>0){e=k[P+44>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[P+48>>2]|0;if((c|0)==(P+52|0)|(c|0)==0){r=Q;return}ggb(k[c+-4>>2]|0);r=Q;return}function pHa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;D=r;r=r+80|0;C=D+48|0;x=D;k[C>>2]=0;z=C+4|0;i[z>>0]=0;B=C+8|0;o[B>>2]=0.0;k[C+12>>2]=-1;l=C+16|0;o[l>>2]=0.0;m=C+20|0;k[m>>2]=0;A=b+4|0;c=k6(k[b>>2]|0,k[A>>2]|0,370769)|0;a:do if(c){switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break}case 2:{d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;w=c&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d;break}default:{c=2147483647;n=9;break a}}if((c|0)>-1)n=9;else n=11}else{c=0;n=9}while(0);if((n|0)==9){e=k[a+108>>2]|0;if((c|0)>((k[a+112>>2]|0)-e|0))n=11}if((n|0)==11){e=x+4|0;f=ZT(44)|0;k[f>>2]=1;g=f+4|0;k[x>>2]=g;k[e>>2]=36;i[f+40>>0]=0;h=370773;j=g+36|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,x,370810,370820,1804);k[e>>2]=0;k[x>>2]=0;w=k[f>>2]|0;k[f>>2]=w+-1;if((w|0)==1)ggb(k[f+-4>>2]|0);e=k[a+108>>2]|0}c=k[(k[a+216>>2]|0)+(c<<2)>>2]|0;k[C>>2]=c;if((i[e+c>>0]|0)==1){v=k[a+120>>2]|0;v=(k[v+(c<<3)+4>>2]|0)+31-(k[v+(c<<3)>>2]|0)|0;w=(v|0)/32|0;h=a+180|0;j=a+184|0;f=k[j>>2]|0;e=k[h>>2]|0;c=f-e>>2;k[m>>2]=c;v=(v|0)>31;if(v){g=a+188|0;c=0;e=f;while(1){k[x>>2]=0;if((e|0)==(k[g>>2]|0))Q4(h,x);else{k[e>>2]=0;k[j>>2]=e+4}c=c+1|0;if((c|0)>=(w|0))break;e=k[j>>2]|0}e=k[h>>2]|0;c=k[m>>2]|0}t=e+(c<<2)|0;c=k[b>>2]|0;g=k6(c,k[A>>2]|0,370881)|0;if(!g){f=k[b>>2]|0;e=k6(f,k[A>>2]|0,370884)|0;i[z>>0]=1;c=(e|0)==0;if(c)n=45;else n=28}else{f=c;e=g;c=(g|0)==0;n=28}do if((n|0)==28){g=k[e>>2]|0;if((g&7|0)==1){switch(g&7){case 1:{c=k[e+8>>2]|0;break}case 2:{d=+p[e+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;s=c&2146435072;if(!(s>>>0>1126170624|(s|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d;break}default:c=2147483647}s=t+(c>>5<<2)|0;k[s>>2]=k[s>>2]|1<<(c&31);break}else g=c;if((f|0)!=0&(e|0)!=0?(q=k[e>>2]|0,s=q&7,(s|0)!=0):0){k[x>>2]=f;k[x+4>>2]=e;if(!((s+-5|0)>>>0<2&(q&16|0)==0)){k[x+20>>2]=e;k[x+12>>2]=0;k[x+40>>2]=1;if(g){c=1;n=50;break}else{n=46;break}}c=e+8|0;KY(k[c>>2]|0,x+8|0);f=k[e>>2]|0;switch(f&7){case 6:{c=k[(k[c>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[c>>2]|0)+24>>2]|0;break}default:c=(f&7|0)!=0&1}k[x+40>>2]=c;if(g){c=1;n=50}else n=46}else{c=g;n=45}}while(0);if((n|0)==45){k[x>>2]=0;k[x+4>>2]=0;k[x+20>>2]=0;k[x+40>>2]=0;if(c){c=1;n=50}else n=46}b:do if((n|0)==46){c=k[e>>2]|0;switch(c&7){case 6:{y=k[(k[e+8>>2]|0)+60>>2]|0;n=51;break b}case 5:{y=k[(k[e+8>>2]|0)+24>>2]|0;n=51;break b}default:{c=(c&7|0)==0;n=50;break b}}}while(0);if((n|0)==50){y=c&1^1;n=51}if((n|0)==51?(y|0)>0:0){l=x+20|0;m=x+40|0;n=x+12|0;q=x+28|0;s=x+16|0;j=x+24|0;g=k[l>>2]|0;h=0;c=g;while(1){c:do if(!c)e=0;else{switch(k[c>>2]&7){case 1:{e=k[c+8>>2]|0;break c}case 2:break;default:{e=2147483647;break c}}d=+p[c+8>>3];p[u>>3]=d;e=k[u+4>>2]|0;x=e&2146435072;if(!(x>>>0>1126170624|(x|0)==1126170624&0>0)){e=(e|0)<0;d=e?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=e?-0.0:0.0}e=~~d}while(0);f=t+(e>>5<<2)|0;k[f>>2]=k[f>>2]|1<<(e&31);h=h+1|0;f=k[m>>2]|0;if(!f)e=g;else{e=k[n>>2]|0;if(e){c=g+(k[e+28>>2]|0)|0;k[l>>2]=c;if(c>>>0<(k[q>>2]|0)>>>0)e=c;else{E=k[(k[s>>2]|0)+4>>2]|0;k[s>>2]=E;c=k[E+16>>2]|0;k[l>>2]=c;x=c;g=k[e+28>>2]|0;e=k[E+12>>2]|0;k[j>>2]=x;e=x+(aa(g,e)|0)|0;k[q>>2]=e;e=x}}else e=g;k[m>>2]=f+-1}if((h|0)==(y|0))break;else g=e}}if(i[z>>0]|0){if(v){c=0;do{E=t+(c<<2)|0;k[E>>2]=~k[E>>2];c=c+1|0}while((c|0)<(w|0))}i[z>>0]=0}}else{c=k6(k[b>>2]|0,k[A>>2]|0,370891)|0;if(!c){c=k6(k[b>>2]|0,k[A>>2]|0,370894)|0;i[z>>0]=1;if(!c)d=0.0;else n=73}else n=73;d:do if((n|0)==73)switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break d}case 2:{d=+p[c+8>>3];break d}default:{d=1000000015047466219876688.0e6;break d}}while(0);o[l>>2]=d}c=k6(k[b>>2]|0,k[A>>2]|0,370897)|0;e:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break e}case 2:{d=+p[c+8>>3];break e}default:{d=1000000015047466219876688.0e6;break e}}while(0);o[B>>2]=d;c=a+168|0;e=a+172|0;f=k[e>>2]|0;if((f|0)==(k[a+176>>2]|0)){tHa(c,C);C=k[e>>2]|0;E=k[c>>2]|0;E=C-E|0;E=(E|0)/24|0;E=E+-1|0;r=D;return E|0}else{k[f>>2]=k[C>>2];k[f+4>>2]=k[C+4>>2];k[f+8>>2]=k[C+8>>2];k[f+12>>2]=k[C+12>>2];k[f+16>>2]=k[C+16>>2];k[f+20>>2]=k[C+20>>2];C=(k[e>>2]|0)+24|0;k[e>>2]=C;E=k[c>>2]|0;E=C-E|0;E=(E|0)/24|0;E=E+-1|0;r=D;return E|0}return 0}function qHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;y=r;r=r+96|0;x=y;v=y+40|0;w=y+32|0;d=x+8|0;k[d>>2]=0;f=x+12|0;k[f>>2]=-1;k[f+4>>2]=-1;k[f+8>>2]=-1;k[f+12>>2]=-1;k[f+16>>2]=-1;f=b+4|0;c=k6(k[b>>2]|0,k[f>>2]|0,389389)|0;a:do if(!c)e=0.0;else switch(k[c>>2]&7){case 1:{e=+(k[c+8>>2]|0);break a}case 2:{e=+p[c+8>>3];break a}default:{e=1.e+300;break a}}while(0);p[x>>3]=e;if(i[a+228>>0]|0){c=k6(k[b>>2]|0,k[f>>2]|0,370747)|0;b:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break b}case 2:break;default:{c=2147483647;break b}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;t=c&2146435072;if(!(t>>>0>1126170624|(t|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}c=~~e}while(0);k[d>>2]=c}b=k[b>>2]|0;d=k6(b,k[f>>2]|0,370762)|0;if(d|0){c=k[d>>2]|0;switch(c&7){case 6:{t=k[(k[d+8>>2]|0)+60>>2]|0;break}case 5:{t=k[(k[d+8>>2]|0)+24>>2]|0;break}default:t=(c&7|0)!=0&1}do if((b|0)!=0?(g=k[d>>2]|0,h=g&7,(h|0)!=0):0){k[v>>2]=b;k[v+4>>2]=d;if(!((h+-5|0)>>>0<2&(g&16|0)==0)){k[v+20>>2]=d;k[v+12>>2]=0;k[v+40>>2]=1;break}b=d+8|0;KY(k[b>>2]|0,v+8|0);c=k[d>>2]|0;switch(c&7){case 6:{c=k[(k[b>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[b>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[v+40>>2]=c}else j=28;while(0);if((j|0)==28){k[v>>2]=0;k[v+4>>2]=0;k[v+20>>2]=0;k[v+40>>2]=0}c:do if((t|0)>0){j=v+20|0;l=w+4|0;m=x+28|0;n=a+168|0;o=v+40|0;q=v+12|0;s=v+28|0;g=v+16|0;h=v+24|0;d=0;f=-1;do{b=k[(k[a>>2]|0)+248>>2]|0;c=k[j>>2]|0;k[w>>2]=k[v>>2];k[l>>2]=c;c=f;f=Hh[b&511](a,w)|0;if((f|0)<0)break c;if((c|0)<0)k[m>>2]=f;else k[(k[n>>2]|0)+(c*24|0)+12>>2]=f;d=d+1|0;c=k[o>>2]|0;if(c|0){b=k[q>>2]|0;if(b|0?(z=(k[j>>2]|0)+(k[b+28>>2]|0)|0,k[j>>2]=z,z>>>0>=(k[s>>2]|0)>>>0):0){z=k[(k[g>>2]|0)+4>>2]|0;k[g>>2]=z;A=k[z+16>>2]|0;k[j>>2]=A;b=k[b+28>>2]|0;z=k[z+12>>2]|0;k[h>>2]=A;z=A+(aa(b,z)|0)|0;k[s>>2]=z}k[o>>2]=c+-1}}while((d|0)<(t|0))}while(0)}c=a+156|0;b=a+160|0;d=k[b>>2]|0;if((d|0)==(k[a+164>>2]|0)){sHa(c,x);z=k[b>>2]|0;A=k[c>>2]|0;A=z-A|0;A=A>>5;A=A+-1|0;r=y;return A|0}else{k[d>>2]=k[x>>2];k[d+4>>2]=k[x+4>>2];k[d+8>>2]=k[x+8>>2];k[d+12>>2]=k[x+12>>2];k[d+16>>2]=k[x+16>>2];k[d+20>>2]=k[x+20>>2];k[d+24>>2]=k[x+24>>2];k[d+28>>2]=k[x+28>>2];z=(k[b>>2]|0)+32|0;k[b>>2]=z;A=k[c>>2]|0;A=z-A|0;A=A>>5;A=A+-1|0;r=y;return A|0}return 0}function rHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;v=r;r=r+64|0;u=v+52|0;s=v+8|0;t=v;f=k[b+4>>2]|0;a:do if(!f){c=1;g=6}else{c=k[f>>2]|0;switch(c&7){case 6:{q=k[(k[f+8>>2]|0)+60>>2]|0;break a}case 5:{q=k[(k[f+8>>2]|0)+24>>2]|0;break a}default:{c=(c&7|0)==0;g=6;break a}}}while(0);if((g|0)==6)q=c&1^1;k[u>>2]=-1;c=k[b>>2]|0;do if((c|0)!=0&(f|0)!=0?(d=k[f>>2]|0,e=d&7,(e|0)!=0):0){k[s>>2]=c;k[s+4>>2]=f;if(!((e+-5|0)>>>0<2&(d&16|0)==0)){k[s+20>>2]=f;k[s+12>>2]=0;k[s+40>>2]=1;break}b=f+8|0;KY(k[b>>2]|0,s+8|0);c=k[f>>2]|0;switch(c&7){case 6:{c=k[(k[b>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[b>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[s+40>>2]=c}else g=16;while(0);if((g|0)==16){k[s>>2]=0;k[s+4>>2]=0;k[s+20>>2]=0;k[s+40>>2]=0}b:do if((q|0)>0){h=s+20|0;i=t+4|0;j=a+156|0;l=s+40|0;m=s+12|0;n=s+28|0;o=s+16|0;p=s+24|0;c=-1;g=0;d=-1;do{e=k[(k[a>>2]|0)+252>>2]|0;f=k[h>>2]|0;k[t>>2]=k[s>>2];k[i>>2]=f;e=Hh[e&511](a,t)|0;if((e|0)<0)break b;f=k[j>>2]|0;k[f+(e<<5)+12>>2]=c;do if((c|0)>=0){b=f+(c<<5)+16|0;if((k[b>>2]|0)<0){k[b>>2]=e;break}else{k[f+(c<<5)+20>>2]=e;break}}else{k[u>>2]=e;d=e}while(0);c:do if((k[f+(e<<5)+28>>2]|0)<=-1){if((c|0)>-1)do{if((k[f+(c<<5)+20>>2]|0)<=-1)break c;c=k[f+(c<<5)+12>>2]|0}while((c|0)>-1)}else c=e;while(0);g=g+1|0;b=k[l>>2]|0;if(b|0){e=k[m>>2]|0;if(e|0?(f=(k[h>>2]|0)+(k[e+28>>2]|0)|0,k[h>>2]=f,f>>>0>=(k[n>>2]|0)>>>0):0){f=k[(k[o>>2]|0)+4>>2]|0;k[o>>2]=f;w=k[f+16>>2]|0;k[h>>2]=w;e=k[e+28>>2]|0;f=k[f+12>>2]|0;k[p>>2]=w;f=w+(aa(e,f)|0)|0;k[n>>2]=f}k[l>>2]=b+-1}}while((g|0)<(q|0))}else d=-1;while(0);c=a+148|0;b=k[c>>2]|0;if((b|0)==(k[a+152>>2]|0)){Q4(a+144|0,u);r=v;return d|0}else{k[b>>2]=d;k[c>>2]=b+4;r=v;return d|0}return 0}function sHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>5;c=g+1|0;if(c>>>0>134217727)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>4;f=e>>5>>>0<67108863?(f>>>0<c>>>0?c:f):134217727;if(!f)c=0;else{if(f>>>0>134217727){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<5;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<5)|0;k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2];k[e+12>>2]=k[b+12>>2];k[e+16>>2]=k[b+16>>2];k[e+20>>2]=k[b+20>>2];k[e+24>>2]=k[b+24>>2];k[e+28>>2]=k[b+28>>2];d=e+(0-g<<5)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+32;k[l>>2]=c+(f<<5);if(!i)return;ggb(i);return}function tHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=a+4|0;h=k[a>>2]|0;i=(k[g>>2]|0)-h|0;e=(i|0)/24|0;c=e+1|0;if(c>>>0>178956970)ad(426534,426557,304,426811);j=a+8|0;d=((k[j>>2]|0)-h|0)/24|0;f=d<<1;f=d>>>0<89478485?(f>>>0<c>>>0?c:f):178956970;if(!f)c=0;else{if(f>>>0>178956970){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=f*24|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(e*24|0)|0;k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2];k[e+12>>2]=k[b+12>>2];k[e+16>>2]=k[b+16>>2];k[e+20>>2]=k[b+20>>2];d=e+(((i|0)/-24|0)*24|0)|0;if((i|0)>0)upb(d|0,h|0,i|0)|0;k[a>>2]=d;k[g>>2]=e+24;k[j>>2]=c+(f*24|0);if(!h)return;ggb(h);return}function uHa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+64|0;j=l;f=a+4|0;k[f>>2]=1124007936;b=a+12|0;c=a+44|0;d=a+8|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;h=a+52|0;k[a+48>>2]=h;k[a+56>>2]=0;k[h>>2]=0;k[a+64>>2]=2147483647;k[a+68>>2]=10;o[a+76>>2]=.009999999776482582;i[a>>0]=0;k[a+60>>2]=10;k[a+72>>2]=10;i[a+1>>0]=1;i[a+2>>0]=1;k[j>>2]=1124007936;h=j+4|0;a=j+8|0;g=j+40|0;d=h;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[g>>2]=a;e=j+48|0;d=j+44|0;k[d>>2]=e;k[j+52>>2]=0;k[e>>2]=0;KG(f,j)|0;c=j+36|0;a=k[c>>2]|0;if(a|0?(b=a+12|0,f=k[b>>2]|0,k[b>>2]=f+-1,(f|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[j+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;j=j+16|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[h>>2]|0)>0){b=k[g>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[d>>2]|0;if((a|0)==(e|0)|(a|0)==0){r=l;return}ggb(k[a+-4>>2]|0);r=l;return}function vHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+112|0;l=s+56|0;q=s;if(!b){r=s;return}d=k[b>>2]|0;switch(d&7){case 6:{k[q>>2]=1124007936;o=q+4|0;d=q+8|0;m=q+40|0;e=o;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[m>>2]=d;p=q+48|0;n=q+44|0;k[n>>2]=p;k[q+52>>2]=0;k[p>>2]=0;k[l>>2]=1124007936;j=l+4|0;d=l+8|0;h=l+40|0;e=j;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[h>>2]=d;i=l+48|0;g=l+44|0;k[g>>2]=i;k[l+52>>2]=0;k[i>>2]=0;G6(a,b,q,l);f=l+36|0;d=k[f>>2]|0;if(d|0?(a=d+12|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[l+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;b=l+16|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[j>>2]|0)>0){e=k[h>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[g>>2]|0;if(!((d|0)==(i|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=l+4|0;d=f+4|0;k[d>>2]=0;k[d+4>>2]=0;k[l>>2]=-2113732604;k[f>>2]=c;mY(q,l);f=q+36|0;d=k[f>>2]|0;if(d|0?(c=d+12|0,l=k[c>>2]|0,k[c>>2]=l+-1,(l|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[q+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;q=q+16|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[o>>2]|0)>0){e=k[m>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[o>>2]|0))}d=k[n>>2]|0;if(!((d|0)==(p|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=s;return}case 5:{do if(!a){k[q>>2]=0;k[q+4>>2]=0;k[q+20>>2]=0;k[q+40>>2]=0}else{k[q>>2]=a;k[q+4>>2]=b;if(d&16|0){k[q+20>>2]=b;k[q+12>>2]=0;k[q+40>>2]=1;break}e=b+8|0;KY(k[e>>2]|0,q+8|0);d=k[b>>2]|0;switch(d&7){case 6:{d=k[(k[e>>2]|0)+60>>2]|0;break}case 5:{d=k[(k[e>>2]|0)+24>>2]|0;break}default:d=(d&7|0)!=0&1}k[q+40>>2]=d}while(0);k[l>>2]=q;gza(l,c);r=s;return}default:{r=s;return}}}function wHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function xHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+o[b>>2]);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function yHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;e=h;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=h;return}f=a+32|0;if((k[f>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[e>>2]=g;k[c>>2]=30;i[d+34>>0]=0;j=401220;l=g+30|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}E6(e,a,k[a+12>>2]|0,k[a+16>>2]|0,13,0,0);hza(a,b);F6(e);if(!(k[f>>2]&4)){r=h;return}k[f>>2]=6;r=h;return}function zHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=a+8|0;i=k[a>>2]|0;if((k[h>>2]|0)-i>>2>>>0>=b>>>0)return;j=a+4|0;g=(k[j>>2]|0)-i|0;f=g>>2;if(!b)c=0;else{if(b>>>0>1073741823){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=b<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(f<<2)|0;d=e+(0-f<<2)|0;if((g|0)>0)upb(d|0,i|0,g|0)|0;k[a>>2]=d;k[j>>2]=e;k[h>>2]=c+(b<<2);if(!i)return;ggb(i);return}function AHa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0.0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0;a:while(1){m=b;r=b+-4|0;while(1){s=a;b:while(1){l=s;a=m-l|0;c=a>>2;switch(c|0){case 2:{q=5;break a}case 3:{q=7;break a}case 4:{q=15;break a}case 5:{q=27;break a}case 1:case 0:{q=85;break a}default:{}}if((a|0)<124){q=29;break a}j=s+(((c|0)/2|0)<<2)|0;do if((a|0)<=3996){c=k[j>>2]|0;f=k[s>>2]|0;g=+p[c>>3];d=+p[f>>3];e=k[r>>2]|0;a=+p[e>>3]<g;if(!(g<d)){if(!a){a=0;break}k[j>>2]=e;k[r>>2]=c;a=k[j>>2]|0;c=k[s>>2]|0;if(!(+p[a>>3]<+p[c>>3])){a=1;break}k[s>>2]=a;k[j>>2]=c;a=2;break}if(a){k[s>>2]=e;k[r>>2]=f;a=1;break}k[s>>2]=c;k[j>>2]=f;a=k[r>>2]|0;if(+p[a>>3]<d){k[j>>2]=a;k[r>>2]=f;a=2}else a=1}else{a=(c|0)/4|0;a=BHa(s,s+(a<<2)|0,j,j+(a<<2)|0,r)|0}while(0);e=k[s>>2]|0;g=+p[e>>3];d=+p[k[j>>2]>>3];if(g<d){c=r;break}else c=r;while(1){c=c+-4|0;if((s|0)==(c|0))break;f=k[c>>2]|0;if(+p[f>>3]<d){q=68;break b}}a=s+4|0;l=k[r>>2]|0;e=l;if(!(g<+p[l>>3])){if((a|0)==(r|0)){q=85;break a}while(1){c=k[a>>2]|0;if(g<+p[c>>3])break;a=a+4|0;if((a|0)==(r|0)){q=85;break a}}k[a>>2]=e;k[r>>2]=c;a=a+4|0}if((a|0)==(r|0)){q=85;break a}else c=r;while(1){d=+p[k[s>>2]>>3];while(1){f=k[a>>2]|0;h=a+4|0;if(d<+p[f>>3])break;else a=h}do{c=c+-4|0;e=k[c>>2]|0}while(d<+p[e>>3]);if(a>>>0>=c>>>0){s=a;continue b}k[a>>2]=e;k[c>>2]=f;a=h}}if((q|0)==68){q=0;k[s>>2]=f;k[c>>2]=e;a=a+1|0}e=s+4|0;c:do if(e>>>0<c>>>0)while(1){d=+p[k[j>>2]>>3];while(1){h=k[e>>2]|0;i=e+4|0;if(+p[h>>3]<d)e=i;else break}do{c=c+-4|0;f=k[c>>2]|0}while(!(+p[f>>3]<d));if(e>>>0>c>>>0){c=j;break c}k[e>>2]=f;k[c>>2]=h;j=(j|0)==(e|0)?c:j;e=i;a=a+1|0}else c=j;while(0);if((e|0)!=(c|0)?(n=k[c>>2]|0,o=k[e>>2]|0,+p[n>>3]<+p[o>>3]):0){k[e>>2]=n;k[c>>2]=o;a=a+1|0}if(!a){c=CHa(s,e)|0;a=e+4|0;if(CHa(a,b)|0){q=84;break}if(c)continue}j=e;if((j-l|0)>=(m-j|0)){q=83;break}AHa(s,e);a=e+4|0}if((q|0)==83){q=0;AHa(e+4|0,b);a=s;b=e;continue}else if((q|0)==84){q=0;if(c){q=85;break}else{a=s;b=e;continue}}}if((q|0)==5){a=k[r>>2]|0;b=k[s>>2]|0;if(!(+p[a>>3]<+p[b>>3]))return;k[s>>2]=a;k[r>>2]=b;return}else if((q|0)==7){f=s+4|0;b=k[f>>2]|0;e=k[s>>2]|0;g=+p[b>>3];d=+p[e>>3];c=k[r>>2]|0;a=+p[c>>3]<g;if(!(g<d)){if(!a)return;k[f>>2]=c;k[r>>2]=b;a=k[f>>2]|0;b=k[s>>2]|0;if(!(+p[a>>3]<+p[b>>3]))return;k[s>>2]=a;k[f>>2]=b;return}if(a){k[s>>2]=c;k[r>>2]=e;return}k[s>>2]=b;k[f>>2]=e;a=k[r>>2]|0;if(!(+p[a>>3]<d))return;k[f>>2]=a;k[r>>2]=e;return}else if((q|0)==15){l=s+4|0;j=s+8|0;c=k[l>>2]|0;a=k[s>>2]|0;t=+p[c>>3];d=+p[a>>3];e=k[j>>2]|0;g=+p[e>>3];f=g<t;b=c;h=e;i=a;do if(t<d){if(f){k[s>>2]=h;k[j>>2]=i;c=a;b=i;break}k[s>>2]=b;k[l>>2]=i;if(g<d){k[l>>2]=h;k[j>>2]=i;c=a;b=i}else{c=e;b=h}}else if(f){k[l>>2]=h;k[j>>2]=b;if(g<d){k[s>>2]=h;k[l>>2]=i}}else{c=e;b=h}while(0);a=k[r>>2]|0;if(!(+p[a>>3]<+p[c>>3]))return;k[j>>2]=a;k[r>>2]=b;a=k[j>>2]|0;b=k[l>>2]|0;d=+p[a>>3];if(!(d<+p[b>>3]))return;c=a;k[l>>2]=c;k[j>>2]=b;a=k[s>>2]|0;if(!(d<+p[a>>3]))return;k[s>>2]=c;k[l>>2]=a;return}else if((q|0)==27){BHa(s,s+4|0,s+8|0,s+12|0,r)|0;return}else if((q|0)==29){m=s+8|0;a=s+4|0;c=k[a>>2]|0;e=k[s>>2]|0;t=+p[c>>3];d=+p[e>>3];f=k[m>>2]|0;g=+p[f>>3];h=g<t;i=c;j=f;l=e;do if(t<d){if(h){k[s>>2]=j;k[m>>2]=l;c=e;break}k[s>>2]=i;k[a>>2]=l;if(g<d){k[a>>2]=j;k[m>>2]=l;c=e}else c=f}else if(h){k[a>>2]=j;k[m>>2]=i;if(g<d){k[s>>2]=j;k[a>>2]=l}}else c=f;while(0);a=s+12|0;if((a|0)==(b|0))return;else{f=a;a=m}while(1){e=k[f>>2]|0;d=+p[e>>3];if(d<+p[c>>3]){c=a;a=f;while(1){k[a>>2]=k[c>>2];if((c|0)==(s|0))break;a=c+-4|0;if(d<+p[k[a>>2]>>3]){r=c;c=a;a=r}else break}k[c>>2]=e}a=f+4|0;if((a|0)==(b|0))break;c=k[f>>2]|0;r=f;f=a;a=r}return}else if((q|0)==85)return}function BHa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0.0,j=0,l=0,m=0,n=0,o=0,q=0.0;j=k[b>>2]|0;l=k[a>>2]|0;q=+p[j>>3];i=+p[l>>3];h=k[c>>2]|0;f=+p[h>>3]<q;m=j;g=h;n=l;do if(q<i){if(f){k[a>>2]=g;k[c>>2]=n;o=1;h=l;g=n;break}k[a>>2]=m;k[b>>2]=n;f=k[c>>2]|0;g=f;if(+p[f>>3]<i){k[b>>2]=g;k[c>>2]=n;o=2;h=l;g=n}else{o=1;h=f}}else if(f){k[b>>2]=g;k[c>>2]=m;f=k[b>>2]|0;g=k[a>>2]|0;if(+p[f>>3]<+p[g>>3]){k[a>>2]=f;k[b>>2]=g;g=k[c>>2]|0;o=2;h=g}else{o=1;h=j;g=m}}else o=0;while(0);f=k[d>>2]|0;if(+p[f>>3]<+p[h>>3]){k[c>>2]=f;k[d>>2]=g;f=o+1|0;g=k[c>>2]|0;h=k[b>>2]|0;if(+p[g>>3]<+p[h>>3]){k[b>>2]=g;k[c>>2]=h;f=k[b>>2]|0;g=k[a>>2]|0;if(+p[f>>3]<+p[g>>3]){k[a>>2]=f;k[b>>2]=g;h=o+3|0}else h=o+2|0}else h=f}else h=o;f=k[e>>2]|0;g=k[d>>2]|0;if(!(+p[f>>3]<+p[g>>3])){b=h;return b|0}k[d>>2]=f;k[e>>2]=g;f=k[d>>2]|0;g=k[c>>2]|0;if(!(+p[f>>3]<+p[g>>3])){b=h+1|0;return b|0}k[c>>2]=f;k[d>>2]=g;f=k[c>>2]|0;g=k[b>>2]|0;if(!(+p[f>>3]<+p[g>>3])){b=h+2|0;return b|0}k[b>>2]=f;k[c>>2]=g;f=k[b>>2]|0;g=k[a>>2]|0;if(!(+p[f>>3]<+p[g>>3])){b=h+3|0;return b|0}k[a>>2]=f;k[b>>2]=g;b=h+4|0;return b|0}function CHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0,h=0,i=0,j=0.0,l=0,m=0,n=0,o=0,q=0.0;switch(b-a>>2|0){case 2:{c=b+-4|0;d=k[c>>2]|0;e=k[a>>2]|0;if(!(+p[d>>3]<+p[e>>3])){a=1;return a|0}k[a>>2]=d;k[c>>2]=e;a=1;return a|0}case 3:{i=a+4|0;g=b+-4|0;d=k[i>>2]|0;h=k[a>>2]|0;j=+p[d>>3];f=+p[h>>3];e=k[g>>2]|0;c=+p[e>>3]<j;if(!(j<f)){if(!c){a=1;return a|0}k[i>>2]=e;k[g>>2]=d;c=k[i>>2]|0;d=k[a>>2]|0;if(!(+p[c>>3]<+p[d>>3])){a=1;return a|0}k[a>>2]=c;k[i>>2]=d;a=1;return a|0}if(c){k[a>>2]=e;k[g>>2]=h;a=1;return a|0}k[a>>2]=d;k[i>>2]=h;c=k[g>>2]|0;if(!(+p[c>>3]<f)){a=1;return a|0}k[i>>2]=c;k[g>>2]=h;a=1;return a|0}case 4:{o=a+4|0;n=a+8|0;m=b+-4|0;e=k[o>>2]|0;c=k[a>>2]|0;q=+p[e>>3];f=+p[c>>3];g=k[n>>2]|0;j=+p[g>>3];h=j<q;d=e;i=g;l=c;do if(q<f){if(h){k[a>>2]=i;k[n>>2]=l;e=c;d=l;break}k[a>>2]=d;k[o>>2]=l;if(j<f){k[o>>2]=i;k[n>>2]=l;e=c;d=l}else{e=g;d=i}}else if(h){k[o>>2]=i;k[n>>2]=d;if(j<f){k[a>>2]=i;k[o>>2]=l}}else{e=g;d=i}while(0);c=k[m>>2]|0;if(!(+p[c>>3]<+p[e>>3])){a=1;return a|0}k[n>>2]=c;k[m>>2]=d;c=k[n>>2]|0;d=k[o>>2]|0;f=+p[c>>3];if(!(f<+p[d>>3])){a=1;return a|0}e=c;k[o>>2]=e;k[n>>2]=d;c=k[a>>2]|0;if(!(f<+p[c>>3])){a=1;return a|0}k[a>>2]=e;k[o>>2]=c;a=1;return a|0}case 5:{BHa(a,a+4|0,a+8|0,a+12|0,b+-4|0)|0;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{n=a+8|0;c=a+4|0;e=k[c>>2]|0;d=k[a>>2]|0;q=+p[e>>3];f=+p[d>>3];g=k[n>>2]|0;j=+p[g>>3];h=j<q;i=e;l=g;m=d;do if(q<f){if(h){k[a>>2]=l;k[n>>2]=m;e=d;break}k[a>>2]=i;k[c>>2]=m;if(j<f){k[c>>2]=l;k[n>>2]=m;e=d}else e=g}else if(h){k[c>>2]=l;k[n>>2]=i;if(j<f){k[a>>2]=l;k[c>>2]=m}}else e=g;while(0);c=a+12|0;a:do if((c|0)==(b|0)){d=1;c=0}else{h=c;d=0;c=n;while(1){g=k[h>>2]|0;f=+p[g>>3];if(f<+p[e>>3]){e=c;c=h;while(1){k[c>>2]=k[e>>2];if((e|0)==(a|0))break;c=e+-4|0;if(f<+p[k[c>>2]>>3]){o=e;e=c;c=o}else break}k[e>>2]=g;d=d+1|0;c=h+4|0;if((d|0)==8){d=0;c=(c|0)==(b|0);break a}}else c=h+4|0;if((c|0)==(b|0)){d=1;c=0;break a}e=k[h>>2]|0;o=h;h=c;c=o}}while(0);a=c|d;return a|0}}return 0}function DHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0.0,h=0,i=0.0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0;a:while(1){p=b;t=b+-4|0;while(1){u=a;b:while(1){n=u;a=p-n|0;d=a>>2;switch(d|0){case 2:{s=5;break a}case 3:{s=7;break a}case 4:{s=15;break a}case 5:{s=16;break a}case 1:case 0:{s=86;break a}default:{}}if((a|0)<124){s=22;break a}l=u+(((d|0)/2|0)<<2)|0;do if((a|0)>3996){j=(d|0)/4|0;m=u+(j<<2)|0;j=l+(j<<2)|0;a=EHa(u,m,l,j,k[c>>2]|0)|0;e=k[t>>2]|0;f=k[j>>2]|0;d=k[c>>2]|0;if(+o[d+(e<<2)>>2]<+o[d+(f<<2)>>2]){k[j>>2]=e;k[t>>2]=f;e=a+1|0;f=k[j>>2]|0;h=k[l>>2]|0;if(+o[d+(f<<2)>>2]<+o[d+(h<<2)>>2]){k[l>>2]=f;k[j>>2]=h;e=a+2|0;f=k[l>>2]|0;h=k[m>>2]|0;if(+o[d+(f<<2)>>2]<+o[d+(h<<2)>>2]){k[m>>2]=f;k[l>>2]=h;e=k[m>>2]|0;f=k[u>>2]|0;if(+o[d+(e<<2)>>2]<+o[d+(f<<2)>>2]){k[u>>2]=e;k[m>>2]=f;a=a+4|0}else a=a+3|0}else a=e}else a=e}}else{a=k[l>>2]|0;f=k[u>>2]|0;h=k[c>>2]|0;i=+o[h+(a<<2)>>2];g=+o[h+(f<<2)>>2];d=k[t>>2]|0;e=+o[h+(d<<2)>>2]<i;if(!(i<g)){if(!e){a=0;d=h;break}k[l>>2]=d;k[t>>2]=a;a=k[l>>2]|0;d=k[u>>2]|0;if(!(+o[h+(a<<2)>>2]<+o[h+(d<<2)>>2])){a=1;d=h;break}k[u>>2]=a;k[l>>2]=d;a=2;d=h;break}if(e){k[u>>2]=d;k[t>>2]=f;a=1;d=h;break}k[u>>2]=a;k[l>>2]=f;a=k[t>>2]|0;if(+o[h+(a<<2)>>2]<g){k[l>>2]=a;k[t>>2]=f;a=2;d=h}else{a=1;d=h}}while(0);h=k[u>>2]|0;e=k[l>>2]|0;if(+o[d+(h<<2)>>2]<+o[d+(e<<2)>>2]){d=t;break}j=k[c>>2]|0;e=j+(e<<2)|0;d=t;while(1){d=d+-4|0;if((u|0)==(d|0))break;f=k[d>>2]|0;if(+o[j+(f<<2)>>2]<+o[e>>2]){s=68;break b}}a=u+4|0;e=k[t>>2]|0;g=+o[j+(h<<2)>>2];if(!(g<+o[j+(e<<2)>>2])){if((a|0)==(t|0)){s=86;break a}while(1){d=k[a>>2]|0;if(g<+o[j+(d<<2)>>2])break;a=a+4|0;if((a|0)==(t|0)){s=86;break a}}k[a>>2]=e;k[t>>2]=d;a=a+4|0}if((a|0)==(t|0)){s=86;break a}j=k[c>>2]|0;d=t;while(1){g=+o[j+(k[u>>2]<<2)>>2];while(1){f=k[a>>2]|0;h=a+4|0;if(g<+o[j+(f<<2)>>2])break;else a=h}do{d=d+-4|0;e=k[d>>2]|0}while(g<+o[j+(e<<2)>>2]);if(a>>>0>=d>>>0){u=a;continue b}k[a>>2]=e;k[d>>2]=f;a=h}}if((s|0)==68){s=0;k[u>>2]=f;k[d>>2]=h;a=a+1|0}e=u+4|0;c:do if(e>>>0<d>>>0){m=k[c>>2]|0;while(1){g=+o[m+(k[l>>2]<<2)>>2];while(1){h=k[e>>2]|0;j=e+4|0;if(+o[m+(h<<2)>>2]<g)e=j;else break}do{d=d+-4|0;f=k[d>>2]|0}while(!(+o[m+(f<<2)>>2]<g));if(e>>>0>d>>>0){d=l;break c}k[e>>2]=f;k[d>>2]=h;l=(l|0)==(e|0)?d:l;e=j;a=a+1|0}}else d=l;while(0);if((e|0)!=(d|0)?(q=k[d>>2]|0,r=k[e>>2]|0,m=k[c>>2]|0,+o[m+(q<<2)>>2]<+o[m+(r<<2)>>2]):0){k[e>>2]=q;k[d>>2]=r;a=a+1|0}if(!a){d=FHa(u,e,c)|0;a=e+4|0;if(FHa(a,b,c)|0){s=85;break}if(d)continue}m=e;if((m-n|0)>=(p-m|0)){s=84;break}DHa(u,e,c);a=e+4|0}if((s|0)==84){s=0;DHa(e+4|0,b,c);a=u;b=e;continue}else if((s|0)==85){s=0;if(d){s=86;break}else{a=u;b=e;continue}}}if((s|0)==5){a=k[t>>2]|0;b=k[u>>2]|0;c=k[c>>2]|0;if(!(+o[c+(a<<2)>>2]<+o[c+(b<<2)>>2]))return;k[u>>2]=a;k[t>>2]=b;return}else if((s|0)==7){h=u+4|0;d=k[h>>2]|0;e=k[u>>2]|0;f=k[c>>2]|0;i=+o[f+(d<<2)>>2];g=+o[f+(e<<2)>>2];a=k[t>>2]|0;b=+o[f+(a<<2)>>2]<i;if(!(i<g)){if(!b)return;k[h>>2]=a;k[t>>2]=d;a=k[h>>2]|0;b=k[u>>2]|0;if(!(+o[f+(a<<2)>>2]<+o[f+(b<<2)>>2]))return;k[u>>2]=a;k[h>>2]=b;return}if(b){k[u>>2]=a;k[t>>2]=e;return}k[u>>2]=d;k[h>>2]=e;a=k[t>>2]|0;if(!(+o[f+(a<<2)>>2]<g))return;k[h>>2]=a;k[t>>2]=e;return}else if((s|0)==15){EHa(u,u+4|0,u+8|0,t,k[c>>2]|0)|0;return}else if((s|0)==16){h=u+4|0;e=u+8|0;d=u+12|0;EHa(u,h,e,d,k[c>>2]|0)|0;a=k[t>>2]|0;b=k[d>>2]|0;f=k[c>>2]|0;if(!(+o[f+(a<<2)>>2]<+o[f+(b<<2)>>2]))return;k[d>>2]=a;k[t>>2]=b;b=k[d>>2]|0;a=k[e>>2]|0;g=+o[f+(b<<2)>>2];if(!(g<+o[f+(a<<2)>>2]))return;k[e>>2]=b;k[d>>2]=a;a=k[h>>2]|0;if(!(g<+o[f+(a<<2)>>2]))return;k[h>>2]=b;k[e>>2]=a;a=k[u>>2]|0;if(!(g<+o[f+(a<<2)>>2]))return;k[u>>2]=b;k[h>>2]=a;return}else if((s|0)==22){a=u+8|0;d=u+4|0;e=k[d>>2]|0;f=k[u>>2]|0;j=k[c>>2]|0;v=+o[j+(e<<2)>>2];g=+o[j+(f<<2)>>2];h=k[a>>2]|0;i=+o[j+(h<<2)>>2];j=i<v;do if(v<g){if(j){k[u>>2]=h;k[a>>2]=f;e=f;break}k[u>>2]=e;k[d>>2]=f;if(i<g){k[d>>2]=h;k[a>>2]=f;e=f}else e=h}else if(j){k[d>>2]=h;k[a>>2]=e;if(i<g){k[u>>2]=h;k[d>>2]=f}}else e=h;while(0);d=u+12|0;if((d|0)==(b|0))return;j=k[c>>2]|0;while(1){h=k[d>>2]|0;g=+o[j+(h<<2)>>2];if(g<+o[j+(e<<2)>>2]){f=d;while(1){k[f>>2]=e;if((a|0)==(u|0)){a=u;break}f=a+-4|0;e=k[f>>2]|0;if(!(g<+o[j+(e<<2)>>2]))break;else{c=a;a=f;f=c}}k[a>>2]=h}a=d+4|0;if((a|0)==(b|0))break;e=k[d>>2]|0;c=d;d=a;a=c}return}else if((s|0)==86)return}function EHa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,i=0,j=0,l=0,m=0.0;j=k[b>>2]|0;i=k[a>>2]|0;m=+o[e+(j<<2)>>2];h=+o[e+(i<<2)>>2];g=k[c>>2]|0;f=+o[e+(g<<2)>>2]<m;do if(m<h){if(f){k[a>>2]=g;k[c>>2]=i;l=1;g=i;break}k[a>>2]=j;k[b>>2]=i;g=k[c>>2]|0;if(+o[e+(g<<2)>>2]<h){k[b>>2]=g;k[c>>2]=i;l=2;g=i}else l=1}else if(f){k[b>>2]=g;k[c>>2]=j;f=k[b>>2]|0;g=k[a>>2]|0;if(+o[e+(f<<2)>>2]<+o[e+(g<<2)>>2]){k[a>>2]=f;k[b>>2]=g;l=2;g=k[c>>2]|0}else{l=1;g=j}}else l=0;while(0);f=k[d>>2]|0;if(!(+o[e+(f<<2)>>2]<+o[e+(g<<2)>>2])){b=l;return b|0}k[c>>2]=f;k[d>>2]=g;f=k[c>>2]|0;g=k[b>>2]|0;if(!(+o[e+(f<<2)>>2]<+o[e+(g<<2)>>2])){b=l+1|0;return b|0}k[b>>2]=f;k[c>>2]=g;f=k[b>>2]|0;g=k[a>>2]|0;if(!(+o[e+(f<<2)>>2]<+o[e+(g<<2)>>2])){b=l+2|0;return b|0}k[a>>2]=f;k[b>>2]=g;b=l+3|0;return b|0}function FHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0.0,h=0,i=0,j=0.0,l=0,m=0,n=0.0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=k[d>>2]|0;f=k[a>>2]|0;b=k[c>>2]|0;if(!(+o[b+(e<<2)>>2]<+o[b+(f<<2)>>2])){a=1;return a|0}k[a>>2]=e;k[d>>2]=f;a=1;return a|0}case 3:{m=a+4|0;h=b+-4|0;f=k[m>>2]|0;i=k[a>>2]|0;l=k[c>>2]|0;j=+o[l+(f<<2)>>2];g=+o[l+(i<<2)>>2];d=k[h>>2]|0;e=+o[l+(d<<2)>>2]<j;if(!(j<g)){if(!e){a=1;return a|0}k[m>>2]=d;k[h>>2]=f;d=k[m>>2]|0;e=k[a>>2]|0;if(!(+o[l+(d<<2)>>2]<+o[l+(e<<2)>>2])){a=1;return a|0}k[a>>2]=d;k[m>>2]=e;a=1;return a|0}if(e){k[a>>2]=d;k[h>>2]=i;a=1;return a|0}k[a>>2]=f;k[m>>2]=i;d=k[h>>2]|0;if(!(+o[l+(d<<2)>>2]<g)){a=1;return a|0}k[m>>2]=d;k[h>>2]=i;a=1;return a|0}case 4:{EHa(a,a+4|0,a+8|0,b+-4|0,k[c>>2]|0)|0;a=1;return a|0}case 5:{m=a+4|0;l=a+8|0;h=a+12|0;d=b+-4|0;EHa(a,m,l,h,k[c>>2]|0)|0;e=k[d>>2]|0;f=k[h>>2]|0;i=k[c>>2]|0;if(!(+o[i+(e<<2)>>2]<+o[i+(f<<2)>>2])){a=1;return a|0}k[h>>2]=e;k[d>>2]=f;e=k[h>>2]|0;d=k[l>>2]|0;g=+o[i+(e<<2)>>2];if(!(g<+o[i+(d<<2)>>2])){a=1;return a|0}k[l>>2]=e;k[h>>2]=d;d=k[m>>2]|0;if(!(g<+o[i+(d<<2)>>2])){a=1;return a|0}k[m>>2]=e;k[l>>2]=d;d=k[a>>2]|0;if(!(g<+o[i+(d<<2)>>2])){a=1;return a|0}k[a>>2]=e;k[m>>2]=d;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{d=a+8|0;e=a+4|0;f=k[e>>2]|0;h=k[a>>2]|0;l=k[c>>2]|0;n=+o[l+(f<<2)>>2];g=+o[l+(h<<2)>>2];i=k[d>>2]|0;j=+o[l+(i<<2)>>2];l=j<n;do if(n<g){if(l){k[a>>2]=i;k[d>>2]=h;f=h;break}k[a>>2]=f;k[e>>2]=h;if(j<g){k[e>>2]=i;k[d>>2]=h;f=h}else f=i}else if(l){k[e>>2]=i;k[d>>2]=f;if(j<g){k[a>>2]=i;k[e>>2]=h}}else f=i;while(0);e=a+12|0;a:do if((e|0)==(b|0)){e=1;d=0}else{m=k[c>>2]|0;l=e;e=0;while(1){i=k[l>>2]|0;g=+o[m+(i<<2)>>2];if(g<+o[m+(f<<2)>>2]){h=l;while(1){k[h>>2]=f;if((d|0)==(a|0)){d=a;break}h=d+-4|0;f=k[h>>2]|0;if(!(g<+o[m+(f<<2)>>2]))break;else{c=d;d=h;h=c}}k[d>>2]=i;e=e+1|0;d=l+4|0;if((e|0)==8){e=0;d=(d|0)==(b|0);break a}}else d=l+4|0;if((d|0)==(b|0)){e=1;d=0;break a}f=k[l>>2]|0;c=l;l=d;d=c}}while(0);a=d|e;return a|0}}return 0}function GHa(a){a=a|0;ggb(a);return}function HHa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;f=k[a+8>>2]|0;if(!f){f=k[a>>2]|0;f=f+4|0;f=k[f>>2]|0;Uh[f&2047](a);return}b=k[f+128>>2]|0;c=b;if(b|0){d=f+132|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[f+116>>2]|0;c=b;if(b|0){d=f+120|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}b=k[f+104>>2]|0;c=b;if(b|0){d=f+108|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[f+92>>2]|0;c=b;if(b|0){d=f+96|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}b=k[f+80>>2]|0;c=b;if(b|0){d=f+84|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[f+68>>2]|0;c=b;if(b|0){d=f+72|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}b=k[f+56>>2]|0;c=b;if(b|0){d=f+60|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}b=k[f+44>>2]|0;c=b;if(b|0){d=f+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}b=k[f+32>>2]|0;c=b;if(b|0){d=f+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[f+20>>2]|0;c=b;if(b|0){d=f+24|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~(((e+-24-c|0)>>>0)/24|0)*24|0);ggb(b)}b=k[f+8>>2]|0;c=b;if(b|0){d=f+12|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~(((e+-104-c|0)>>>0)/104|0)*104|0);ggb(b)}b=k[f>>2]|0;if(b|0?(d=b+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ggb(f);f=k[a>>2]|0;f=f+4|0;f=k[f>>2]|0;Uh[f&2047](a);return}function IHa(a){a=a|0;var b=0,c=0,d=0;while(1){c=fgb(240)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;Qh[c&7]()}k[c>>2]=92848;uHa(c+4|0);k[c+232>>2]=0;k[c+236>>2]=0;zpb(c+84|0,0,144)|0;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=93136;k[b+8>>2]=c;k[a>>2]=b;k[a+4>>2]=c;k[d>>2]=(k[d>>2]|0)+1;c=k[d>>2]|0;k[d>>2]=c+-1;if((c|0)!=1)return;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);return}function JHa(a){a=a|0;ggb(a);return}function KHa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function LHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>4;c=g+1|0;if(c>>>0>268435455)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>3;f=e>>4>>>0<134217727?(f>>>0<c>>>0?c:f):268435455;if(!f)c=0;else{if(f>>>0>268435455){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<4;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<4)|0;k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2];k[e+12>>2]=k[b+12>>2];d=e+(0-g<<4)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+16;k[l>>2]=c+(f<<4);if(!i)return;ggb(i);return}function MHa(a){a=a|0;k[a>>2]=93156;THa(a);return}function NHa(a){a=a|0;k[a>>2]=93156;THa(a);ggb(a);return}function OHa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+96|0;t=x+16|0;s=x+8|0;q=x;w=x+80|0;v=x+24|0;Uh[k[(k[a>>2]|0)+28>>2]&2047](a);p=ZT(16)|0;k[p>>2]=1;g=p+4|0;i[p+13>>0]=0;h=g;j=373358;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));n=(k[c>>2]|0)+4|0;e=k[n>>2]|0;do if(e){m=n;a:while(1){l=e;while(1){e=k[l+16>>2]|0;if((e|0)==(g|0))break;f=(e|0)==0?1016759:e;e=i[f>>0]|0;if(e<<24>>24==97){j=g;do{f=f+1|0;j=j+1|0;e=i[f>>0]|0;h=i[j>>0]|0}while(!(e<<24>>24==0?1:e<<24>>24!=h<<24>>24));f=h}else f=97;if((e&255)>=(f&255))break;e=k[l+4>>2]|0;if(!e){j=m;break a}else l=e}e=k[l>>2]|0;if(!e){j=l;break}else m=l}if((j|0)!=(n|0)){e=k[j+16>>2]|0;if((g|0)!=(e|0)){e=(e|0)==0?1016759:e;f=i[e>>0]|0;if(f<<24>>24==97){h=e;do{g=g+1|0;h=h+1|0;e=i[g>>0]|0;f=i[h>>0]|0}while(!(e<<24>>24==0?1:e<<24>>24!=f<<24>>24))}else e=97;if((e&255)<(f&255)){e=0;break}}e=j+24|0;o=k[e>>2]|0;o=(Xh[k[(k[o>>2]|0)+28>>2]&1023](o)|0)+4|0;if((k[o>>2]|0)==198781){e=k[e>>2]|0;e=Hh[k[(k[e>>2]|0)+20>>2]&511](e,j+28|0)|0;e=k[e>>2]|0;break}else Cf(te(1)|0,19736,0)}else e=0}else e=0;while(0);o=a+8|0;k[o>>2]=e;n=k[p>>2]|0;k[p>>2]=n+-1;if((n|0)==1)ggb(k[p+-4>>2]|0);if((k[o>>2]|0)==254){o=k[(k[a>>2]|0)+24>>2]|0;p=ZT(16)|0;k[p>>2]=1;g=p+4|0;i[p+12>>0]=0;n=g;e=n;i[e>>0]=102;i[e+1>>0]=105;i[e+2>>0]=108;i[e+3>>0]=101;n=n+4|0;i[n>>0]=110;i[n+1>>0]=97;i[n+2>>0]=109;i[n+3>>0]=101;n=(k[c>>2]|0)+4|0;e=k[n>>2]|0;do if(e){m=n;b:while(1){l=e;while(1){e=k[l+16>>2]|0;if((e|0)==(g|0))break;f=(e|0)==0?1016759:e;e=i[f>>0]|0;if(e<<24>>24==102){j=g;do{f=f+1|0;j=j+1|0;e=i[f>>0]|0;h=i[j>>0]|0}while(!(e<<24>>24==0?1:e<<24>>24!=h<<24>>24));f=h}else f=102;if((e&255)>=(f&255))break;e=k[l+4>>2]|0;if(!e){j=m;break b}else l=e}e=k[l>>2]|0;if(!e){j=l;break}else m=l}if((j|0)!=(n|0)){e=k[j+16>>2]|0;if((g|0)!=(e|0)){e=(e|0)==0?1016759:e;f=i[e>>0]|0;if(f<<24>>24==102){h=e;do{g=g+1|0;h=h+1|0;e=i[g>>0]|0;f=i[h>>0]|0}while(!(e<<24>>24==0?1:e<<24>>24!=f<<24>>24))}else e=102;if((e&255)<(f&255)){u=33;break}}e=j+24|0;v=k[e>>2]|0;v=(Xh[k[(k[v>>2]|0)+28>>2]&1023](v)|0)+4|0;if((k[v>>2]|0)!=195498)Cf(te(1)|0,19736,0);v=k[e>>2]|0;v=Hh[k[(k[v>>2]|0)+20>>2]&511](v,j+28|0)|0;e=k[v>>2]|0;k[w>>2]=e;k[w+4>>2]=k[v+4>>2];if(e|0){v=e+-4|0;k[v>>2]=(k[v>>2]|0)+1}}else u=33}else u=33;while(0);if((u|0)==33){k[w>>2]=0;k[w+4>>2]=0}ci[o&255](a,b,w)|0;e=k[w>>2]|0;k[w+4>>2]=0;k[w>>2]=0;if(e|0?(v=e+-4|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0)ggb(k[e+-8>>2]|0);w=k[p>>2]|0;k[p>>2]=w+-1;if((w|0)==1)ggb(k[p+-4>>2]|0);r=x;return}do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[v>>2]=k[h>>2];n=v+4|0;e=h+4|0;k[n>>2]=k[e>>2];u=v+8|0;k[u>>2]=k[h+8>>2];k[v+12>>2]=k[h+12>>2];k[v+16>>2]=k[h+16>>2];k[v+20>>2]=k[h+20>>2];k[v+24>>2]=k[h+24>>2];k[v+28>>2]=k[h+28>>2];k[v+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[v+36>>2]=f;g=v+40|0;k[g>>2]=u;u=v+48|0;l=v+44|0;k[l>>2]=u;k[v+52>>2]=0;k[u>>2]=0;if(f|0){u=f+12|0;k[u>>2]=(k[u>>2]|0)+1}if((k[e>>2]|0)<3){u=k[h+44>>2]|0;e=k[l>>2]|0;k[e>>2]=k[u>>2];k[e+4>>2]=k[u+4>>2];e=v;break}k[n>>2]=0;x1(v,k[e>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[m+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[n>>2]|0));e=v}else e=v}else{Q1(v,b,-1);e=v}while(0);g=a+16|0;k[g>>2]=0;e=k[e>>2]|0;f=e&4095;k[a+12>>2]=f;u=(k[o>>2]|0)==6?9:d;k[a+4>>2]=u;switch(u|0){case 9:{if(f){k[q>>2]=f;$8(w,377448,q);Y8(-210,w,377457,372936,315);e=k[w>>2]|0;k[w+4>>2]=0;k[w>>2]=0;if(e|0?(u=e+-4|0,a=k[u>>2]|0,k[u>>2]=a+-1,(a|0)==1):0)ggb(k[e+-8>>2]|0);e=k[v>>2]|0}if(!(e&16384)){k[w>>2]=0;e=w+4|0;k[e>>2]=0;f=ZT(44)|0;k[f>>2]=1;h=f+4|0;k[w>>2]=h;k[e>>2]=36;i[f+40>>0]=0;j=377469;l=h+36|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,w,377457,372936,317);k[e>>2]=0;k[w>>2]=0;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)==1)ggb(k[f+-4>>2]|0)}u=k[v+16>>2]|0;a=k[v+12>>2]|0;k[w>>2]=k[v+8>>2];k[w+4>>2]=a;k[w+12>>2]=u;k[w+8>>2]=a;while(1){e=fgb(24)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}uOa(e,w,k[c>>2]|0);Uh[k[(k[e>>2]|0)+8>>2]&2047](e);k[g>>2]=e;break}case 1:{if((f|0)!=5){k[s>>2]=f;$8(w,377448,s);Y8(-210,w,377457,372936,315);e=k[w>>2]|0;k[w+4>>2]=0;k[w>>2]=0;if(e|0?(u=e+-4|0,a=k[u>>2]|0,k[u>>2]=a+-1,(a|0)==1):0)ggb(k[e+-8>>2]|0);e=k[v>>2]|0}if(!(e&16384)){k[w>>2]=0;e=w+4|0;k[e>>2]=0;f=ZT(44)|0;k[f>>2]=1;h=f+4|0;k[w>>2]=h;k[e>>2]=36;i[f+40>>0]=0;j=377469;l=h+36|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,w,377457,372936,317);k[e>>2]=0;k[w>>2]=0;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)==1)ggb(k[f+-4>>2]|0)}u=k[v+16>>2]|0;a=k[v+12>>2]|0;k[w>>2]=k[v+8>>2];k[w+4>>2]=a;k[w+12>>2]=u;k[w+8>>2]=a;while(1){e=fgb(24)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}LLa(e,w,k[c>>2]|0);Uh[k[(k[e>>2]|0)+8>>2]&2047](e);k[g>>2]=e;break}case 2:{if((f|0)!=5){k[t>>2]=f;$8(w,377448,t);Y8(-210,w,377457,372936,315);e=k[w>>2]|0;k[w+4>>2]=0;k[w>>2]=0;if(e|0?(u=e+-4|0,a=k[u>>2]|0,k[u>>2]=a+-1,(a|0)==1):0)ggb(k[e+-8>>2]|0);e=k[v>>2]|0}if(!(e&16384)){k[w>>2]=0;e=w+4|0;k[e>>2]=0;f=ZT(44)|0;k[f>>2]=1;h=f+4|0;k[w>>2]=h;k[e>>2]=36;i[f+40>>0]=0;j=377469;l=h+36|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,w,377457,372936,317);k[e>>2]=0;k[w>>2]=0;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)==1)ggb(k[f+-4>>2]|0)}u=k[v+16>>2]|0;a=k[v+12>>2]|0;k[w>>2]=k[v+8>>2];k[w+4>>2]=a;k[w+12>>2]=u;k[w+8>>2]=a;while(1){e=fgb(24)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}XHa(e,w,k[c>>2]|0);Uh[k[(k[e>>2]|0)+8>>2]&2047](e);k[g>>2]=e;break}default:{k[w>>2]=0;e=w+4|0;k[e>>2]=0;f=ZT(40)|0;k[f>>2]=1;h=f+4|0;k[w>>2]=h;k[e>>2]=33;i[f+37>>0]=0;j=372894;l=h+33|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,w,377442,372936,403);k[e>>2]=0;k[w>>2]=0;w=k[f>>2]|0;k[f>>2]=w+-1;if((w|0)==1)ggb(k[f+-4>>2]|0)}}g=v+36|0;e=k[g>>2]|0;if(e|0?(a=e+12|0,w=k[a>>2]|0,k[a>>2]=w+-1,(w|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[v+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;w=v+16|0;f=v+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[f>>2]|0)>0){g=k[v+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[v+44>>2]|0;if(!((e|0)==(v+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);r=x;return}function PHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=r;r=r+224|0;x=F+200|0;v=F+184|0;w=F+168|0;E=F+112|0;D=F+56|0;B=F;do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[E>>2]=k[j>>2];o=E+4|0;b=j+4|0;k[o>>2]=k[b>>2];p=E+8|0;k[p>>2]=k[j+8>>2];k[E+12>>2]=k[j+12>>2];k[E+16>>2]=k[j+16>>2];k[E+20>>2]=k[j+20>>2];k[E+24>>2]=k[j+24>>2];k[E+28>>2]=k[j+28>>2];k[E+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[E+36>>2]=g;h=E+40|0;k[h>>2]=p;C=E+48|0;m=E+44|0;k[m>>2]=C;k[E+52>>2]=0;k[C>>2]=0;if(g|0){C=g+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[b>>2]|0)<3){A=k[j+44>>2]|0;C=k[m>>2]|0;k[C>>2]=k[A>>2];k[C+4>>2]=k[A+4>>2];break}k[o>>2]=0;x1(E,k[b>>2]|0,0,0,0);if((k[o>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[n+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[o>>2]|0))}}else{Q1(E,b,-1);p=E+8|0}while(0);k[D>>2]=1124007936;z=D+4|0;n=D+8|0;y=D+40|0;l=z;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[y>>2]=n;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;k[B>>2]=1124007936;s=B+4|0;o=B+8|0;q=B+40|0;l=s;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[q>>2]=o;u=B+48|0;t=B+44|0;k[t>>2]=u;k[B+52>>2]=0;k[u>>2]=0;m=a+4|0;QPa(c,d,D,B,k[p>>2]|0,e,e,(k[m>>2]|0)==9?4:5);switch(k[m>>2]|0){case 9:{h=k[a+16>>2]|0;b=k[E>>2]|0;if(!(((b&4095|0)==0?(k[D>>2]&4095|0)==4:0)?(k[B>>2]&4095|0)==4:0)){k[x>>2]=0;b=x+4|0;k[b>>2]=0;g=ZT(80)|0;k[g>>2]=1;l=g+4|0;k[x>>2]=l;k[b>>2]=73;i[g+77>>0]=0;j=377256;m=l+73|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(m|0));Y8(-215,x,377428,372936,469);k[b>>2]=0;k[x>>2]=0;d=k[g>>2]|0;k[g>>2]=d+-1;if((d|0)==1)ggb(k[g+-4>>2]|0);b=k[E>>2]|0}if(!(((b&16384|0)!=0?(k[D>>2]&16384|0)!=0:0)?(k[B>>2]&16384|0)!=0:0)){k[x>>2]=0;b=x+4|0;k[b>>2]=0;g=ZT(76)|0;k[g>>2]=1;l=g+4|0;k[x>>2]=l;k[b>>2]=70;i[g+74>>0]=0;j=377347;m=l+70|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(m|0));Y8(-215,x,377428,372936,470);k[b>>2]=0;k[x>>2]=0;d=k[g>>2]|0;k[g>>2]=d+-1;if((d|0)==1)ggb(k[g+-4>>2]|0)}c=k[E+16>>2]|0;d=k[E+12>>2]|0;k[x>>2]=k[E+8>>2];k[x+4>>2]=d;k[x+12>>2]=c;k[x+8>>2]=d;d=k[D+16>>2]|0;c=k[D+12>>2]|0;k[v>>2]=k[n>>2];k[v+4>>2]=c;k[v+12>>2]=d;k[v+8>>2]=c;c=k[B+16>>2]|0;d=k[B+12>>2]|0;k[w>>2]=k[o>>2];k[w+4>>2]=d;k[w+12>>2]=c;k[w+8>>2]=d;Lg[k[(k[h>>2]|0)+12>>2]&255](h,x,v,w,e,k[f>>2]|0);break}case 1:{h=k[a+16>>2]|0;b=k[E>>2]|0;if(!(((b&4095|0)==5?(k[D>>2]&4095|0)==4:0)?(k[B>>2]&4095|0)==5:0)){k[x>>2]=0;b=x+4|0;k[b>>2]=0;g=ZT(80)|0;k[g>>2]=1;l=g+4|0;k[x>>2]=l;k[b>>2]=73;i[g+77>>0]=0;j=377256;m=l+73|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(m|0));Y8(-215,x,377428,372936,469);k[b>>2]=0;k[x>>2]=0;d=k[g>>2]|0;k[g>>2]=d+-1;if((d|0)==1)ggb(k[g+-4>>2]|0);b=k[E>>2]|0}if(!(((b&16384|0)!=0?(k[D>>2]&16384|0)!=0:0)?(k[B>>2]&16384|0)!=0:0)){k[x>>2]=0;b=x+4|0;k[b>>2]=0;g=ZT(76)|0;k[g>>2]=1;l=g+4|0;k[x>>2]=l;k[b>>2]=70;i[g+74>>0]=0;j=377347;m=l+70|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(m|0));Y8(-215,x,377428,372936,470);k[b>>2]=0;k[x>>2]=0;d=k[g>>2]|0;k[g>>2]=d+-1;if((d|0)==1)ggb(k[g+-4>>2]|0)}c=k[E+16>>2]|0;d=k[E+12>>2]|0;k[x>>2]=k[E+8>>2];k[x+4>>2]=d;k[x+12>>2]=c;k[x+8>>2]=d;d=k[D+16>>2]|0;c=k[D+12>>2]|0;k[v>>2]=k[n>>2];k[v+4>>2]=c;k[v+12>>2]=d;k[v+8>>2]=c;c=k[B+16>>2]|0;d=k[B+12>>2]|0;k[w>>2]=k[o>>2];k[w+4>>2]=d;k[w+12>>2]=c;k[w+8>>2]=d;Lg[k[(k[h>>2]|0)+12>>2]&255](h,x,v,w,e,k[f>>2]|0);break}case 2:{h=k[a+16>>2]|0;b=k[E>>2]|0;if(!(((b&4095|0)==5?(k[D>>2]&4095|0)==4:0)?(k[B>>2]&4095|0)==5:0)){k[x>>2]=0;b=x+4|0;k[b>>2]=0;g=ZT(80)|0;k[g>>2]=1;l=g+4|0;k[x>>2]=l;k[b>>2]=73;i[g+77>>0]=0;j=377256;m=l+73|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(m|0));Y8(-215,x,377428,372936,469);k[b>>2]=0;k[x>>2]=0;d=k[g>>2]|0;k[g>>2]=d+-1;if((d|0)==1)ggb(k[g+-4>>2]|0);b=k[E>>2]|0}if(!(((b&16384|0)!=0?(k[D>>2]&16384|0)!=0:0)?(k[B>>2]&16384|0)!=0:0)){k[x>>2]=0;b=x+4|0;k[b>>2]=0;g=ZT(76)|0;k[g>>2]=1;l=g+4|0;k[x>>2]=l;k[b>>2]=70;i[g+74>>0]=0;j=377347;m=l+70|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(m|0));Y8(-215,x,377428,372936,470);k[b>>2]=0;k[x>>2]=0;d=k[g>>2]|0;k[g>>2]=d+-1;if((d|0)==1)ggb(k[g+-4>>2]|0)}c=k[E+16>>2]|0;d=k[E+12>>2]|0;k[x>>2]=k[E+8>>2];k[x+4>>2]=d;k[x+12>>2]=c;k[x+8>>2]=d;d=k[D+16>>2]|0;c=k[D+12>>2]|0;k[v>>2]=k[n>>2];k[v+4>>2]=c;k[v+12>>2]=d;k[v+8>>2]=c;c=k[B+16>>2]|0;d=k[B+12>>2]|0;k[w>>2]=k[o>>2];k[w+4>>2]=d;k[w+12>>2]=c;k[w+8>>2]=d;Lg[k[(k[h>>2]|0)+12>>2]&255](h,x,v,w,e,k[f>>2]|0);break}default:{k[x>>2]=0;b=x+4|0;k[b>>2]=0;g=ZT(40)|0;k[g>>2]=1;l=g+4|0;k[x>>2]=l;k[b>>2]=33;i[g+37>>0]=0;j=372894;m=l+33|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(m|0));Y8(-5,x,377418,372936,588);k[b>>2]=0;k[x>>2]=0;x=k[g>>2]|0;k[g>>2]=x+-1;if((x|0)==1)ggb(k[g+-4>>2]|0)}}h=B+36|0;b=k[h>>2]|0;if(b|0?(w=b+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[B+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;B=B+16|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[s>>2]|0)>0){g=k[q>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[s>>2]|0))}b=k[t>>2]|0;if(!((b|0)==(u|0)|(b|0)==0))ggb(k[b+-4>>2]|0);h=D+36|0;b=k[h>>2]|0;if(b|0?(x=b+12|0,B=k[x>>2]|0,k[x>>2]=B+-1,(B|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[D+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[z>>2]|0)>0){g=k[y>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[A>>2]|0;if(!((b|0)==(C|0)|(b|0)==0))ggb(k[b+-4>>2]|0);h=E+36|0;b=k[h>>2]|0;if(b|0?(C=b+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[E+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;D=E+16|0;g=E+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[g>>2]|0)>0){h=k[E+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[E+44>>2]|0;if((b|0)==(E+48|0)|(b|0)==0){r=F;return}ggb(k[b+-4>>2]|0);r=F;return}function QHa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=r;r=r+224|0;z=H+200|0;u=H+184|0;w=H+168|0;G=H+112|0;F=H+56|0;B=H;do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[G>>2]=k[l>>2];p=G+4|0;b=l+4|0;k[p>>2]=k[b>>2];E=G+8|0;k[E>>2]=k[l+8>>2];k[G+12>>2]=k[l+12>>2];k[G+16>>2]=k[l+16>>2];k[G+20>>2]=k[l+20>>2];k[G+24>>2]=k[l+24>>2];k[G+28>>2]=k[l+28>>2];k[G+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[G+36>>2]=h;j=G+40|0;k[j>>2]=E;E=G+48|0;n=G+44|0;k[n>>2]=E;k[G+52>>2]=0;k[E>>2]=0;if(h|0){E=h+12|0;k[E>>2]=(k[E>>2]|0)+1}if((k[b>>2]|0)<3){D=k[l+44>>2]|0;E=k[n>>2]|0;k[E>>2]=k[D>>2];k[E+4>>2]=k[D+4>>2];break}k[p>>2]=0;x1(G,k[b>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[o+(b<<2)>>2];k[h+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0))}}else Q1(G,b,-1);while(0);k[F>>2]=1124007936;C=F+4|0;q=F+8|0;A=F+40|0;m=C;o=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(o|0));k[A>>2]=q;E=F+48|0;D=F+44|0;k[D>>2]=E;k[F+52>>2]=0;k[E>>2]=0;k[B>>2]=1124007936;v=B+4|0;s=B+8|0;t=B+40|0;m=v;o=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(o|0));k[t>>2]=s;y=B+48|0;x=B+44|0;k[x>>2]=y;k[B+52>>2]=0;k[y>>2]=0;l=a+4|0;j=(k[l>>2]|0)==9?4:5;if((f|0)<=0){k[z>>2]=0;b=z+4|0;k[b>>2]=0;h=ZT(20)|0;k[h>>2]=1;m=h+4|0;k[z>>2]=m;k[b>>2]=14;i[h+18>>0]=0;n=377178;o=m+14|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,z,377193,372936,598);k[b>>2]=0;k[z>>2]=0;p=k[h>>2]|0;k[h>>2]=p+-1;if((p|0)==1)ggb(k[h+-4>>2]|0)}p=G+8|0;QPa(c,d,F,B,k[p>>2]|0,f,2147483647,j);if((k[a+8>>2]|0)==6){k[z>>2]=0;b=z+4|0;k[b>>2]=0;h=ZT(56)|0;k[h>>2]=1;m=h+4|0;k[z>>2]=m;k[b>>2]=49;i[h+53>>0]=0;n=377206;o=m+49|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-213,z,377193,372936,602);k[b>>2]=0;k[z>>2]=0;f=k[h>>2]|0;k[h>>2]=f+-1;if((f|0)==1)ggb(k[h+-4>>2]|0)}switch(k[l>>2]|0){case 9:{j=k[a+16>>2]|0;b=k[G>>2]|0;if(!(((b&4095|0)==0?(k[F>>2]&4095|0)==4:0)?(k[B>>2]&4095|0)==4:0)){k[z>>2]=0;b=z+4|0;k[b>>2]=0;h=ZT(80)|0;k[h>>2]=1;m=h+4|0;k[z>>2]=m;k[b>>2]=73;i[h+77>>0]=0;n=377256;o=m+73|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,z,377330,372936,495);k[b>>2]=0;k[z>>2]=0;a=k[h>>2]|0;k[h>>2]=a+-1;if((a|0)==1)ggb(k[h+-4>>2]|0);b=k[G>>2]|0}if(!(((b&16384|0)!=0?(k[F>>2]&16384|0)!=0:0)?(k[B>>2]&16384|0)!=0:0)){k[z>>2]=0;b=z+4|0;k[b>>2]=0;h=ZT(76)|0;k[h>>2]=1;m=h+4|0;k[z>>2]=m;k[b>>2]=70;i[h+74>>0]=0;n=377347;o=m+70|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,z,377330,372936,496);k[b>>2]=0;k[z>>2]=0;a=k[h>>2]|0;k[h>>2]=a+-1;if((a|0)==1)ggb(k[h+-4>>2]|0)}l=k[G+16>>2]|0;a=k[G+12>>2]|0;k[z>>2]=k[p>>2];k[z+4>>2]=a;k[z+12>>2]=l;k[z+8>>2]=a;a=k[F+16>>2]|0;l=k[F+12>>2]|0;k[u>>2]=k[q>>2];k[u+4>>2]=l;k[u+12>>2]=a;k[u+8>>2]=l;q=k[B+16>>2]|0;l=k[B+12>>2]|0;k[w>>2]=k[s>>2];k[w+4>>2]=l;k[w+12>>2]=q;k[w+8>>2]=l;l=li[k[(k[j>>2]|0)+16>>2]&7](j,z,u,w,e,k[g>>2]|0)|0;break}case 1:{j=k[a+16>>2]|0;b=k[G>>2]|0;if(!(((b&4095|0)==5?(k[F>>2]&4095|0)==4:0)?(k[B>>2]&4095|0)==5:0)){k[z>>2]=0;b=z+4|0;k[b>>2]=0;h=ZT(80)|0;k[h>>2]=1;m=h+4|0;k[z>>2]=m;k[b>>2]=73;i[h+77>>0]=0;n=377256;o=m+73|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,z,377330,372936,495);k[b>>2]=0;k[z>>2]=0;a=k[h>>2]|0;k[h>>2]=a+-1;if((a|0)==1)ggb(k[h+-4>>2]|0);b=k[G>>2]|0}if(!(((b&16384|0)!=0?(k[F>>2]&16384|0)!=0:0)?(k[B>>2]&16384|0)!=0:0)){k[z>>2]=0;b=z+4|0;k[b>>2]=0;h=ZT(76)|0;k[h>>2]=1;m=h+4|0;k[z>>2]=m;k[b>>2]=70;i[h+74>>0]=0;n=377347;o=m+70|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,z,377330,372936,496);k[b>>2]=0;k[z>>2]=0;a=k[h>>2]|0;k[h>>2]=a+-1;if((a|0)==1)ggb(k[h+-4>>2]|0)}l=k[G+16>>2]|0;a=k[G+12>>2]|0;k[z>>2]=k[p>>2];k[z+4>>2]=a;k[z+12>>2]=l;k[z+8>>2]=a;a=k[F+16>>2]|0;l=k[F+12>>2]|0;k[u>>2]=k[q>>2];k[u+4>>2]=l;k[u+12>>2]=a;k[u+8>>2]=l;q=k[B+16>>2]|0;l=k[B+12>>2]|0;k[w>>2]=k[s>>2];k[w+4>>2]=l;k[w+12>>2]=q;k[w+8>>2]=l;l=li[k[(k[j>>2]|0)+16>>2]&7](j,z,u,w,e,k[g>>2]|0)|0;break}case 2:{j=k[a+16>>2]|0;b=k[G>>2]|0;if(!(((b&4095|0)==5?(k[F>>2]&4095|0)==4:0)?(k[B>>2]&4095|0)==5:0)){k[z>>2]=0;b=z+4|0;k[b>>2]=0;h=ZT(80)|0;k[h>>2]=1;m=h+4|0;k[z>>2]=m;k[b>>2]=73;i[h+77>>0]=0;n=377256;o=m+73|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,z,377330,372936,495);k[b>>2]=0;k[z>>2]=0;a=k[h>>2]|0;k[h>>2]=a+-1;if((a|0)==1)ggb(k[h+-4>>2]|0);b=k[G>>2]|0}if(!(((b&16384|0)!=0?(k[F>>2]&16384|0)!=0:0)?(k[B>>2]&16384|0)!=0:0)){k[z>>2]=0;b=z+4|0;k[b>>2]=0;h=ZT(76)|0;k[h>>2]=1;m=h+4|0;k[z>>2]=m;k[b>>2]=70;i[h+74>>0]=0;n=377347;o=m+70|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,z,377330,372936,496);k[b>>2]=0;k[z>>2]=0;a=k[h>>2]|0;k[h>>2]=a+-1;if((a|0)==1)ggb(k[h+-4>>2]|0)}l=k[G+16>>2]|0;a=k[G+12>>2]|0;k[z>>2]=k[p>>2];k[z+4>>2]=a;k[z+12>>2]=l;k[z+8>>2]=a;a=k[F+16>>2]|0;l=k[F+12>>2]|0;k[u>>2]=k[q>>2];k[u+4>>2]=l;k[u+12>>2]=a;k[u+8>>2]=l;q=k[B+16>>2]|0;l=k[B+12>>2]|0;k[w>>2]=k[s>>2];k[w+4>>2]=l;k[w+12>>2]=q;k[w+8>>2]=l;l=li[k[(k[j>>2]|0)+16>>2]&7](j,z,u,w,e,k[g>>2]|0)|0;break}default:{k[z>>2]=0;b=z+4|0;k[b>>2]=0;h=ZT(40)|0;k[h>>2]=1;m=h+4|0;k[z>>2]=m;k[b>>2]=33;i[h+37>>0]=0;n=372894;o=m+33|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-5,z,377193,372936,626);k[b>>2]=0;k[z>>2]=0;z=k[h>>2]|0;k[h>>2]=z+-1;if((z|0)==1)ggb(k[h+-4>>2]|0);l=-1}}j=B+36|0;b=k[j>>2]|0;if(b|0?(w=b+12|0,z=k[w>>2]|0,k[w>>2]=z+-1,(z|0)==1):0){h=k[j>>2]|0;if(h|0){b=k[h+4>>2]|0;if(!b){b=k[B+32>>2]|0;if(!b){b=B1()|0;h=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[j>>2]=0}k[j>>2]=0;B=B+16|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[v>>2]|0)>0){h=k[t>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[v>>2]|0))}b=k[x>>2]|0;if(!((b|0)==(y|0)|(b|0)==0))ggb(k[b+-4>>2]|0);j=F+36|0;b=k[j>>2]|0;if(b|0?(z=b+12|0,B=k[z>>2]|0,k[z>>2]=B+-1,(B|0)==1):0){h=k[j>>2]|0;if(h|0){b=k[h+4>>2]|0;if(!b){b=k[F+32>>2]|0;if(!b){b=B1()|0;h=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[j>>2]=0}k[j>>2]=0;F=F+16|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[C>>2]|0)>0){h=k[A>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[C>>2]|0))}b=k[D>>2]|0;if(!((b|0)==(E|0)|(b|0)==0))ggb(k[b+-4>>2]|0);j=G+36|0;b=k[j>>2]|0;if(b|0?(E=b+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){h=k[j>>2]|0;if(h|0){b=k[h+4>>2]|0;if(!b){b=k[G+32>>2]|0;if(!b){b=B1()|0;h=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,h)}k[j>>2]=0}k[j>>2]=0;F=G+16|0;h=G+4|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[h>>2]|0)>0){j=k[G+40>>2]|0;b=0;do{k[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[h>>2]|0))}b=k[G+44>>2]|0;if((b|0)==(G+48|0)|(b|0)==0){r=H;return l|0}ggb(k[b+-4>>2]|0);r=H;return l|0}function RHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+64|0;d=m;j=m+8|0;l=k[b>>2]|0;l=Ufb((l|0)==0?1016759:l,377117)|0;if(((l|0)==0?(c=k[b>>2]|0,k[d>>2]=(c|0)==0?1016759:c,$8(j,377120,d),Y8(-2,j,377166,372936,661),c=k[j>>2]|0,k[j+4>>2]=0,k[j>>2]=0,c|0):0)?(g=c+-4|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[c+-8>>2]|0);h=a+4|0;switch(k[h>>2]|0){case 9:{g=k[a+16>>2]|0;k[j+12>>2]=0;a=j;d=377069;e=a+12|0;do{i[a>>0]=i[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(e|0));b=j+16|0;a=j+23|0;e=a+9|0;do{i[a>>0]=0;a=a+1|0}while((a|0)<(e|0));i[b>>0]=i[377171]|0;i[b+1>>0]=i[377172]|0;i[b+2>>0]=i[377173]|0;i[b+3>>0]=i[377174]|0;i[b+4>>0]=i[377175]|0;i[b+5>>0]=i[377176]|0;i[b+6>>0]=i[377177]|0;k[j+32>>2]=4;f=Xh[k[(k[g>>2]|0)+40>>2]&1023](g)|0;k[j+36>>2]=f;f=Xh[k[(k[g>>2]|0)+28>>2]&1023](g)|0;k[j+40>>2]=f;f=Xh[k[(k[g>>2]|0)+32>>2]&1023](g)|0;k[j+44>>2]=f;f=l+76|0;d=l+16|0;b=k[d>>2]|0;c=(b|0)==0;a:do if((k[f>>2]|0)>-1){do if(c){b=l+74|0;e=i[b>>0]|0;i[b>>0]=e+255|e;b=k[l>>2]|0;if(!(b&8)){k[l+8>>2]=0;k[l+4>>2]=0;c=k[l+44>>2]|0;k[l+28>>2]=c;e=l+20|0;k[e>>2]=c;b=c+(k[l+48>>2]|0)|0;k[d>>2]=b;break}else{k[l>>2]=b|32;break a}}else{c=l+20|0;e=c;c=k[c>>2]|0}while(0);a=c;if((b-c|0)>>>0<48){ci[k[l+36>>2]&255](l,j,48)|0;break}b:do if((i[l+75>>0]|0)>-1){c=48;while(1){if(!c){d=48;c=j;b=a;break b}b=c+-1|0;if((i[j+b>>0]|0)==10)break;else c=b}if((ci[k[l+36>>2]&255](l,j,c)|0)>>>0<c>>>0)break a;d=48-c|0;c=j+c|0;b=k[e>>2]|0}else{d=48;c=j;b=a}while(0);upb(b|0,c|0,d|0)|0;k[e>>2]=(k[e>>2]|0)+d}else{do if(c){b=l+74|0;e=i[b>>0]|0;i[b>>0]=e+255|e;b=k[l>>2]|0;if(!(b&8)){k[l+8>>2]=0;k[l+4>>2]=0;c=k[l+44>>2]|0;k[l+28>>2]=c;e=l+20|0;k[e>>2]=c;b=c+(k[l+48>>2]|0)|0;k[d>>2]=b;break}else{k[l>>2]=b|32;break a}}else{c=l+20|0;e=c;c=k[c>>2]|0}while(0);a=c;if((b-c|0)>>>0<48){ci[k[l+36>>2]&255](l,j,48)|0;break}c:do if((i[l+75>>0]|0)>-1){c=48;while(1){if(!c){d=48;c=j;b=a;break c}b=c+-1|0;if((i[j+b>>0]|0)==10)break;else c=b}if((ci[k[l+36>>2]&255](l,j,c)|0)>>>0<c>>>0)break a;d=48-c|0;c=j+c|0;b=k[e>>2]|0}else{d=48;c=j;b=a}while(0);upb(b|0,c|0,d|0)|0;k[e>>2]=(k[e>>2]|0)+d}while(0);k[j>>2]=k[h>>2];d=l+16|0;c=k[d>>2]|0;b=(c|0)==0;d:do if((k[f>>2]|0)>-1){do if(b){b=l+74|0;h=i[b>>0]|0;i[b>>0]=h+255|h;b=k[l>>2]|0;if(!(b&8)){k[l+8>>2]=0;k[l+4>>2]=0;h=k[l+44>>2]|0;k[l+28>>2]=h;e=l+20|0;k[e>>2]=h;c=h+(k[l+48>>2]|0)|0;k[d>>2]=c;d=h;break}else{k[l>>2]=b|32;break d}}else{d=l+20|0;e=d;d=k[d>>2]|0}while(0);b=d;if((c-d|0)>>>0<4){ci[k[l+36>>2]&255](l,j,4)|0;break}e:do if((i[l+75>>0]|0)>-1){d=4;while(1){if(!d){a=4;c=j;break e}c=d+-1|0;if((i[j+c>>0]|0)==10)break;else d=c}if((ci[k[l+36>>2]&255](l,j,d)|0)>>>0<d>>>0)break d;a=4-d|0;c=j+d|0;b=k[e>>2]|0}else{a=4;c=j}while(0);upb(b|0,c|0,a|0)|0;k[e>>2]=(k[e>>2]|0)+a}else{do if(b){b=l+74|0;h=i[b>>0]|0;i[b>>0]=h+255|h;b=k[l>>2]|0;if(!(b&8)){k[l+8>>2]=0;k[l+4>>2]=0;h=k[l+44>>2]|0;k[l+28>>2]=h;e=l+20|0;k[e>>2]=h;c=h+(k[l+48>>2]|0)|0;k[d>>2]=c;d=h;break}else{k[l>>2]=b|32;break d}}else{d=l+20|0;e=d;d=k[d>>2]|0}while(0);b=d;if((c-d|0)>>>0<4){ci[k[l+36>>2]&255](l,j,4)|0;break}f:do if((i[l+75>>0]|0)>-1){d=4;while(1){if(!d){a=4;c=j;break f}c=d+-1|0;if((i[j+c>>0]|0)==10)break;else d=c}if((ci[k[l+36>>2]&255](l,j,d)|0)>>>0<d>>>0)break d;a=4-d|0;c=j+d|0;b=k[e>>2]|0}else{a=4;c=j}while(0);upb(b|0,c|0,a|0)|0;k[e>>2]=(k[e>>2]|0)+a}while(0);jh[k[(k[g>>2]|0)+20>>2]&1023](g,l);break}case 1:{g=k[a+16>>2]|0;k[j+12>>2]=0;a=j;d=377069;e=a+12|0;do{i[a>>0]=i[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(e|0));b=j+16|0;a=j+23|0;e=a+9|0;do{i[a>>0]=0;a=a+1|0}while((a|0)<(e|0));i[b>>0]=i[377171]|0;i[b+1>>0]=i[377172]|0;i[b+2>>0]=i[377173]|0;i[b+3>>0]=i[377174]|0;i[b+4>>0]=i[377175]|0;i[b+5>>0]=i[377176]|0;i[b+6>>0]=i[377177]|0;k[j+32>>2]=8;f=Xh[k[(k[g>>2]|0)+40>>2]&1023](g)|0;k[j+36>>2]=f;f=Xh[k[(k[g>>2]|0)+28>>2]&1023](g)|0;k[j+40>>2]=f;f=Xh[k[(k[g>>2]|0)+32>>2]&1023](g)|0;k[j+44>>2]=f;f=l+76|0;d=l+16|0;b=k[d>>2]|0;c=(b|0)==0;g:do if((k[f>>2]|0)>-1){do if(c){b=l+74|0;e=i[b>>0]|0;i[b>>0]=e+255|e;b=k[l>>2]|0;if(!(b&8)){k[l+8>>2]=0;k[l+4>>2]=0;c=k[l+44>>2]|0;k[l+28>>2]=c;e=l+20|0;k[e>>2]=c;b=c+(k[l+48>>2]|0)|0;k[d>>2]=b;break}else{k[l>>2]=b|32;break g}}else{c=l+20|0;e=c;c=k[c>>2]|0}while(0);a=c;if((b-c|0)>>>0<48){ci[k[l+36>>2]&255](l,j,48)|0;break}h:do if((i[l+75>>0]|0)>-1){c=48;while(1){if(!c){d=48;c=j;b=a;break h}b=c+-1|0;if((i[j+b>>0]|0)==10)break;else c=b}if((ci[k[l+36>>2]&255](l,j,c)|0)>>>0<c>>>0)break g;d=48-c|0;c=j+c|0;b=k[e>>2]|0}else{d=48;c=j;b=a}while(0);upb(b|0,c|0,d|0)|0;k[e>>2]=(k[e>>2]|0)+d}else{do if(c){b=l+74|0;e=i[b>>0]|0;i[b>>0]=e+255|e;b=k[l>>2]|0;if(!(b&8)){k[l+8>>2]=0;k[l+4>>2]=0;c=k[l+44>>2]|0;k[l+28>>2]=c;e=l+20|0;k[e>>2]=c;b=c+(k[l+48>>2]|0)|0;k[d>>2]=b;break}else{k[l>>2]=b|32;break g}}else{c=l+20|0;e=c;c=k[c>>2]|0}while(0);a=c;if((b-c|0)>>>0<48){ci[k[l+36>>2]&255](l,j,48)|0;break}i:do if((i[l+75>>0]|0)>-1){c=48;while(1){if(!c){d=48;c=j;b=a;break i}b=c+-1|0;if((i[j+b>>0]|0)==10)break;else c=b}if((ci[k[l+36>>2]&255](l,j,c)|0)>>>0<c>>>0)break g;d=48-c|0;c=j+c|0;b=k[e>>2]|0}else{d=48;c=j;b=a}while(0);upb(b|0,c|0,d|0)|0;k[e>>2]=(k[e>>2]|0)+d}while(0);k[j>>2]=k[h>>2];d=l+16|0;c=k[d>>2]|0;b=(c|0)==0;j:do if((k[f>>2]|0)>-1){do if(b){b=l+74|0;h=i[b>>0]|0;i[b>>0]=h+255|h;b=k[l>>2]|0;if(!(b&8)){k[l+8>>2]=0;k[l+4>>2]=0;h=k[l+44>>2]|0;k[l+28>>2]=h;e=l+20|0;k[e>>2]=h;c=h+(k[l+48>>2]|0)|0;k[d>>2]=c;d=h;break}else{k[l>>2]=b|32;break j}}else{d=l+20|0;e=d;d=k[d>>2]|0}while(0);b=d;if((c-d|0)>>>0<4){ci[k[l+36>>2]&255](l,j,4)|0;break}k:do if((i[l+75>>0]|0)>-1){d=4;while(1){if(!d){a=4;c=j;break k}c=d+-1|0;if((i[j+c>>0]|0)==10)break;else d=c}if((ci[k[l+36>>2]&255](l,j,d)|0)>>>0<d>>>0)break j;a=4-d|0;c=j+d|0;b=k[e>>2]|0}else{a=4;c=j}while(0);upb(b|0,c|0,a|0)|0;k[e>>2]=(k[e>>2]|0)+a}else{do if(b){b=l+74|0;h=i[b>>0]|0;i[b>>0]=h+255|h;b=k[l>>2]|0;if(!(b&8)){k[l+8>>2]=0;k[l+4>>2]=0;h=k[l+44>>2]|0;k[l+28>>2]=h;e=l+20|0;k[e>>2]=h;c=h+(k[l+48>>2]|0)|0;k[d>>2]=c;d=h;break}else{k[l>>2]=b|32;break j}}else{d=l+20|0;e=d;d=k[d>>2]|0}while(0);b=d;if((c-d|0)>>>0<4){ci[k[l+36>>2]&255](l,j,4)|0;break}l:do if((i[l+75>>0]|0)>-1){d=4;while(1){if(!d){a=4;c=j;break l}c=d+-1|0;if((i[j+c>>0]|0)==10)break;else d=c}if((ci[k[l+36>>2]&255](l,j,d)|0)>>>0<d>>>0)break j;a=4-d|0;c=j+d|0;b=k[e>>2]|0}else{a=4;c=j}while(0);upb(b|0,c|0,a|0)|0;k[e>>2]=(k[e>>2]|0)+a}while(0);jh[k[(k[g>>2]|0)+20>>2]&1023](g,l);break}case 2:{g=k[a+16>>2]|0;k[j+12>>2]=0;a=j;d=377069;e=a+12|0;do{i[a>>0]=i[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(e|0));b=j+16|0;a=j+23|0;e=a+9|0;do{i[a>>0]=0;a=a+1|0}while((a|0)<(e|0));i[b>>0]=i[377171]|0;i[b+1>>0]=i[377172]|0;i[b+2>>0]=i[377173]|0;i[b+3>>0]=i[377174]|0;i[b+4>>0]=i[377175]|0;i[b+5>>0]=i[377176]|0;i[b+6>>0]=i[377177]|0;k[j+32>>2]=8;f=Xh[k[(k[g>>2]|0)+40>>2]&1023](g)|0;k[j+36>>2]=f;f=Xh[k[(k[g>>2]|0)+28>>2]&1023](g)|0;k[j+40>>2]=f;f=Xh[k[(k[g>>2]|0)+32>>2]&1023](g)|0;k[j+44>>2]=f;f=l+76|0;d=l+16|0;b=k[d>>2]|0;c=(b|0)==0;m:do if((k[f>>2]|0)>-1){do if(c){b=l+74|0;e=i[b>>0]|0;i[b>>0]=e+255|e;b=k[l>>2]|0;if(!(b&8)){k[l+8>>2]=0;k[l+4>>2]=0;c=k[l+44>>2]|0;k[l+28>>2]=c;e=l+20|0;k[e>>2]=c;b=c+(k[l+48>>2]|0)|0;k[d>>2]=b;break}else{k[l>>2]=b|32;break m}}else{c=l+20|0;e=c;c=k[c>>2]|0}while(0);a=c;if((b-c|0)>>>0<48){ci[k[l+36>>2]&255](l,j,48)|0;break}n:do if((i[l+75>>0]|0)>-1){c=48;while(1){if(!c){d=48;c=j;b=a;break n}b=c+-1|0;if((i[j+b>>0]|0)==10)break;else c=b}if((ci[k[l+36>>2]&255](l,j,c)|0)>>>0<c>>>0)break m;d=48-c|0;c=j+c|0;b=k[e>>2]|0}else{d=48;c=j;b=a}while(0);upb(b|0,c|0,d|0)|0;k[e>>2]=(k[e>>2]|0)+d}else{do if(c){b=l+74|0;e=i[b>>0]|0;i[b>>0]=e+255|e;b=k[l>>2]|0;if(!(b&8)){k[l+8>>2]=0;k[l+4>>2]=0;c=k[l+44>>2]|0;k[l+28>>2]=c;e=l+20|0;k[e>>2]=c;b=c+(k[l+48>>2]|0)|0;k[d>>2]=b;break}else{k[l>>2]=b|32;break m}}else{c=l+20|0;e=c;c=k[c>>2]|0}while(0);a=c;if((b-c|0)>>>0<48){ci[k[l+36>>2]&255](l,j,48)|0;break}o:do if((i[l+75>>0]|0)>-1){c=48;while(1){if(!c){d=48;c=j;b=a;break o}b=c+-1|0;if((i[j+b>>0]|0)==10)break;else c=b}if((ci[k[l+36>>2]&255](l,j,c)|0)>>>0<c>>>0)break m;d=48-c|0;c=j+c|0;b=k[e>>2]|0}else{d=48;c=j;b=a}while(0);upb(b|0,c|0,d|0)|0;k[e>>2]=(k[e>>2]|0)+d}while(0);k[j>>2]=k[h>>2];d=l+16|0;c=k[d>>2]|0;b=(c|0)==0;p:do if((k[f>>2]|0)>-1){do if(b){b=l+74|0;h=i[b>>0]|0;i[b>>0]=h+255|h;b=k[l>>2]|0;if(!(b&8)){k[l+8>>2]=0;k[l+4>>2]=0;h=k[l+44>>2]|0;k[l+28>>2]=h;e=l+20|0;k[e>>2]=h;c=h+(k[l+48>>2]|0)|0;k[d>>2]=c;d=h;break}else{k[l>>2]=b|32;break p}}else{d=l+20|0;e=d;d=k[d>>2]|0}while(0);b=d;if((c-d|0)>>>0<4){ci[k[l+36>>2]&255](l,j,4)|0;break}q:do if((i[l+75>>0]|0)>-1){d=4;while(1){if(!d){a=4;c=j;break q}c=d+-1|0;if((i[j+c>>0]|0)==10)break;else d=c}if((ci[k[l+36>>2]&255](l,j,d)|0)>>>0<d>>>0)break p;a=4-d|0;c=j+d|0;b=k[e>>2]|0}else{a=4;c=j}while(0);upb(b|0,c|0,a|0)|0;k[e>>2]=(k[e>>2]|0)+a}else{do if(b){b=l+74|0;h=i[b>>0]|0;i[b>>0]=h+255|h;b=k[l>>2]|0;if(!(b&8)){k[l+8>>2]=0;k[l+4>>2]=0;h=k[l+44>>2]|0;k[l+28>>2]=h;e=l+20|0;k[e>>2]=h;c=h+(k[l+48>>2]|0)|0;k[d>>2]=c;d=h;break}else{k[l>>2]=b|32;break p}}else{d=l+20|0;e=d;d=k[d>>2]|0}while(0);b=d;if((c-d|0)>>>0<4){ci[k[l+36>>2]&255](l,j,4)|0;break}r:do if((i[l+75>>0]|0)>-1){d=4;while(1){if(!d){a=4;c=j;break r}c=d+-1|0;if((i[j+c>>0]|0)==10)break;else d=c}if((ci[k[l+36>>2]&255](l,j,d)|0)>>>0<d>>>0)break p;a=4-d|0;c=j+d|0;b=k[e>>2]|0}else{a=4;c=j}while(0);upb(b|0,c|0,a|0)|0;k[e>>2]=(k[e>>2]|0)+a}while(0);jh[k[(k[g>>2]|0)+20>>2]&1023](g,l);break}default:{Qfb(l)|0;b=j+4|0;c=ZT(40)|0;k[c>>2]=1;a=c+4|0;k[j>>2]=a;k[b>>2]=33;i[c+37>>0]=0;d=372894;e=a+33|0;do{i[a>>0]=i[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(e|0));Y8(-5,j,377166,372936,694);k[b>>2]=0;k[j>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)==1)ggb(k[c+-4>>2]|0);r=m;return}}Qfb(l)|0;r=m;return}function SHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+192|0;p=z+32|0;q=z+24|0;o=z;w=z+176|0;x=z+160|0;u=z+152|0;v=z+144|0;y=z+88|0;m=z+40|0;n=z+36|0;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[y>>2]=k[f>>2];l=y+4|0;b=f+4|0;k[l>>2]=k[b>>2];t=y+8|0;k[t>>2]=k[f+8>>2];k[y+12>>2]=k[f+12>>2];k[y+16>>2]=k[f+16>>2];k[y+20>>2]=k[f+20>>2];k[y+24>>2]=k[f+24>>2];k[y+28>>2]=k[f+28>>2];k[y+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[y+36>>2]=d;e=y+40|0;k[e>>2]=t;t=y+48|0;h=y+44|0;k[h>>2]=t;k[y+52>>2]=0;k[t>>2]=0;if(d|0){t=d+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[b>>2]|0)<3){s=k[f+44>>2]|0;t=k[h>>2]|0;k[t>>2]=k[s>>2];k[t+4>>2]=k[s+4>>2];break}k[l>>2]=0;x1(y,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(y,b,-1);while(0);Uh[k[(k[a>>2]|0)+28>>2]&2047](a);t=k[c>>2]|0;t=Ufb((t|0)==0?1016759:t,373005)|0;if(!t)b=0;else{UHa(m,t);s=a+8|0;k[s>>2]=k[m+36>>2];b=k[m+32>>2]|0;if((b|0)!=4)if(b)if((b|0)!=5)if((b|0)!=1)if((b|0)!=2)if((b|0)==8)j=5;else j=(b|0)==9?6:-1;else j=4;else j=3;else j=2;else j=1;else j=0;e=a+12|0;k[e>>2]=j;g=k[m+40>>2]|0;c=y+8|0;h=k[c>>2]|0;d=k[m+44>>2]|0;l=y+12|0;b=k[l>>2]|0;f=k[y>>2]|0;if((g|0)==(h|0)&(d|0)==(b|0))if((j|0)==(f&4095|0)){k[n>>2]=0;if((_fb(n,4,1,t)|0)!=1){z=te(44)|0;VHa(z,373124);Cf(z|0,19720,57)}b=k[n>>2]|0;k[a+4>>2]=b;d=k[e>>2]|0;a:do if((b|0)==9)if(!d){f=a+16|0;if((k[y>>2]&20479|0)!=16384){k[w>>2]=0;b=w+4|0;k[b>>2]=0;d=ZT(72)|0;k[d>>2]=1;g=d+4|0;k[w>>2]=g;k[b>>2]=65;i[d+69>>0]=0;h=373281;j=g+65|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,w,373347,372936,705);k[b>>2]=0;k[w>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}b=k[y+16>>2]|0;e=k[l>>2]|0;k[w>>2]=k[c>>2];k[w+4>>2]=e;k[w+12>>2]=b;k[w+8>>2]=e;k[x+4>>2]=0;k[x+8>>2]=0;e=x+4|0;k[x>>2]=e;k[u>>2]=0;b=u+4|0;k[b>>2]=0;d=ZT(16)|0;k[d>>2]=1;g=d+4|0;k[u>>2]=g;k[b>>2]=9;i[d+13>>0]=0;h=373358;j=g+9|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));q=WHa(x,u)|0;k[v>>2]=k[s>>2];p=k[q>>2]|0;s=q+4|0;jh[k[k[p>>2]>>2]&1023](p,s);k[q>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,v,s);k[b>>2]=0;k[u>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0);while(1){b=fgb(24)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}uOa(b,w,x);jh[k[(k[b>>2]|0)+24>>2]&1023](b,t);k[f>>2]=b;YHa(k[e>>2]|0);b=1;e=62}else e=26;else if((d|0)==5)switch(b|0){case 2:{f=a+16|0;if((k[y>>2]&20479|0)!=16389){k[w>>2]=0;b=w+4|0;k[b>>2]=0;d=ZT(72)|0;k[d>>2]=1;g=d+4|0;k[w>>2]=g;k[b>>2]=65;i[d+69>>0]=0;h=373281;j=g+65|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,w,373347,372936,705);k[b>>2]=0;k[w>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}b=k[y+16>>2]|0;e=k[l>>2]|0;k[w>>2]=k[c>>2];k[w+4>>2]=e;k[w+12>>2]=b;k[w+8>>2]=e;k[x+4>>2]=0;k[x+8>>2]=0;e=x+4|0;k[x>>2]=e;k[u>>2]=0;b=u+4|0;k[b>>2]=0;d=ZT(16)|0;k[d>>2]=1;g=d+4|0;k[u>>2]=g;k[b>>2]=9;i[d+13>>0]=0;h=373358;j=g+9|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));q=WHa(x,u)|0;k[v>>2]=k[s>>2];p=k[q>>2]|0;s=q+4|0;jh[k[k[p>>2]>>2]&1023](p,s);k[q>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,v,s);k[b>>2]=0;k[u>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0);while(1){b=fgb(24)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}XHa(b,w,x);jh[k[(k[b>>2]|0)+24>>2]&1023](b,t);k[f>>2]=b;YHa(k[e>>2]|0);b=1;e=62;break a}case 1:{f=a+16|0;if((k[y>>2]&20479|0)!=16389){k[w>>2]=0;b=w+4|0;k[b>>2]=0;d=ZT(72)|0;k[d>>2]=1;g=d+4|0;k[w>>2]=g;k[b>>2]=65;i[d+69>>0]=0;h=373281;j=g+65|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,w,373347,372936,705);k[b>>2]=0;k[w>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0)}b=k[y+16>>2]|0;e=k[l>>2]|0;k[w>>2]=k[c>>2];k[w+4>>2]=e;k[w+12>>2]=b;k[w+8>>2]=e;k[x+4>>2]=0;k[x+8>>2]=0;e=x+4|0;k[x>>2]=e;k[u>>2]=0;b=u+4|0;k[b>>2]=0;d=ZT(16)|0;k[d>>2]=1;g=d+4|0;k[u>>2]=g;k[b>>2]=9;i[d+13>>0]=0;h=373358;j=g+9|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));q=WHa(x,u)|0;k[v>>2]=k[s>>2];p=k[q>>2]|0;s=q+4|0;jh[k[k[p>>2]>>2]&1023](p,s);k[q>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,v,s);k[b>>2]=0;k[u>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0);while(1){b=fgb(24)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}LLa(b,w,x);jh[k[(k[b>>2]|0)+24>>2]&1023](b,t);k[f>>2]=b;YHa(k[e>>2]|0);b=1;e=62;break a}default:{k[p>>2]=b;Zfb(165912,373224,p)|0;b=0;e=62;break a}}else e=26;while(0);if((e|0)==26){b=k[s>>2]|0;k[q>>2]=d;k[q+4>>2]=b;Zfb(165912,373146,q)|0;Qfb(t)|0;b=0}else if((e|0)==62)Qfb(t)|0}else{b=d;e=20}else e=20;if((e|0)==20){k[o>>2]=g;k[o+4>>2]=d;k[o+8>>2]=j;k[o+12>>2]=h;k[o+16>>2]=b;k[o+20>>2]=f&4095;Zfb(165912,373008,o)|0;Qfb(t)|0;b=0}}f=y+36|0;d=k[f>>2]|0;if(d|0?(w=d+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[y+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;x=y+16|0;e=y+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[e>>2]|0)>0){f=k[y+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[y+44>>2]|0;if((d|0)==(y+48|0)|(d|0)==0){r=z;return b|0}ggb(k[d+-4>>2]|0);r=z;return b|0}function THa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;f=h;g=a+16|0;b=k[g>>2]|0;if(!b){r=h;return}switch(k[a+4>>2]|0){case 9:{Uh[k[(k[b>>2]|0)+4>>2]&2047](b);break}case 1:{Uh[k[(k[b>>2]|0)+4>>2]&2047](b);break}case 2:{Uh[k[(k[b>>2]|0)+4>>2]&2047](b);break}default:{a=f+4|0;b=ZT(40)|0;k[b>>2]=1;c=b+4|0;k[f>>2]=c;k[a>>2]=33;i[b+37>>0]=0;d=372894;e=c+33|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-5,f,372928,372936,456);k[a>>2]=0;k[f>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0)}}k[g>>2]=0;r=h;return}function UHa(a,b){a=a|0;b=b|0;var c=0,d=0;if((_fb(a,48,1,b)|0)!=1){d=te(44)|0;VHa(d,377037);Cf(d|0,19720,57)}if((i[a>>0]|0)==70){d=377069;do{a=a+1|0;d=d+1|0;c=i[a>>0]|0;b=i[d>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=b<<24>>24));if(c<<24>>24==b<<24>>24)return}d=te(44)|0;VHa(d,377081);Cf(d|0,19720,57)}function VHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+32|0;l=n+16|0;j=n+8|0;h=n;k[l>>2]=0;m=l+4|0;k[m>>2]=0;if(b|0){f=b;a:do if(!(f&3)){c=b;e=5}else{c=b;d=f;while(1){if(!(i[c>>0]|0)){c=d;break a}c=c+1|0;d=c;if(!(d&3)){e=5;break}}}while(0);if((e|0)==5){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}g=c-f|0;f=ZT(g+8&-4)|0;k[f>>2]=1;f=f+4|0;k[l>>2]=f;k[m>>2]=g;i[f+g>>0]=0;upb(f|0,b|0,g|0)|0}k[j>>2]=0;g=j+4|0;k[g>>2]=0;c=ZT(8)|0;k[c>>2]=1;c=c+4|0;k[j>>2]=c;k[g>>2]=0;i[c>>0]=0;k[h>>2]=0;c=h+4|0;k[c>>2]=0;d=ZT(88)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=82;i[d+86>>0]=0;b=374056;f=e+82|0;do{i[e>>0]=i[b>>0]|0;e=e+1|0;b=b+1|0}while((e|0)<(f|0));Z8(a,0,l,j,h,42);k[c>>2]=0;k[h>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);c=k[j>>2]|0;k[g>>2]=0;k[j>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);c=k[l>>2]|0;k[m>>2]=0;k[l>>2]=0;if(!c){k[a>>2]=93556;r=n;return}l=c+-4|0;m=k[l>>2]|0;k[l>>2]=m+-1;if((m|0)!=1){k[a>>2]=93556;r=n;return}ggb(k[c+-8>>2]|0);k[a>>2]=93556;r=n;return}function WHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+16|0;q=s;e=a+4|0;c=k[e>>2]|0;do if(c){n=k[b>>2]|0;m=(n|0)==0?1016759:n;d=k[c+16>>2]|0;if((n|0)==(d|0)){k[q>>2]=c;a=c;a=a+24|0;r=s;return a|0}o=i[m>>0]|0;p=o<<24>>24==0;while(1){e=(d|0)==0?1016759:d;d=i[e>>0]|0;l=o<<24>>24!=d<<24>>24;if(p|l){g=d;f=o}else{h=e;j=m;do{j=j+1|0;h=h+1|0;f=i[j>>0]|0;g=i[h>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=g<<24>>24))}if((f&255)<(g&255)){d=k[c>>2]|0;if(!d){e=9;break}else c=d}else{if(d<<24>>24==0|l)e=o;else{g=m;do{e=e+1|0;g=g+1|0;d=i[e>>0]|0;f=i[g>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24));e=f}if((d&255)>=(e&255)){e=17;break}f=c+4|0;d=k[f>>2]|0;if(!d){e=15;break}else c=d}d=k[c+16>>2]|0;if((n|0)==(d|0)){e=17;break}}if((e|0)==9){d=c;k[q>>2]=d;f=c;break}else if((e|0)==15){d=c;k[q>>2]=d;break}else if((e|0)==17){d=c;k[q>>2]=d;if(!c){f=q;break}a=c+24|0;r=s;return a|0}}else{d=e;k[q>>2]=d;f=e}while(0);while(1){e=fgb(32)|0;if(e|0)break;p=k[207666]|0;k[207666]=p+0;Qh[p&7]()}c=k[b>>2]|0;k[e+16>>2]=c;k[e+20>>2]=k[b+4>>2];if(!c)c=d;else{c=c+-4|0;k[c>>2]=(k[c>>2]|0)+1;c=k[q>>2]|0}k[e+24>>2]=428704;k[e+28>>2]=0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=c;k[f>>2]=e;c=k[k[a>>2]>>2]|0;if(!c)c=e;else{k[a>>2]=c;c=k[f>>2]|0}B4(k[a+4>>2]|0,c);a=a+8|0;k[a>>2]=(k[a>>2]|0)+1;a=e;a=a+24|0;r=s;return a|0}function XHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;v=r;r=r+96|0;p=v+48|0;q=v+32|0;s=v+24|0;o=v+16|0;t=v+8|0;u=v;k[a>>2]=93196;n=a+12|0;h=a+16|0;k[h>>2]=0;j=a+20|0;k[j>>2]=0;l=a+16|0;k[n>>2]=l;d=k[c>>2]|0;m=c+4|0;if((d|0)!=(m|0)){e=d;while(1){f=e+16|0;g=ZHa(n,l,p,f)|0;if(!(k[g>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){f=f+-4|0;k[f>>2]=(k[f>>2]|0)+1}x=d+24|0;k[x>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);w=k[e+24>>2]|0;k[x>>2]=w;Ph[k[(k[w>>2]|0)+8>>2]&511](w,e+28|0,f);f=k[p>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[n>>2]>>2]|0;if(f){k[n>>2]=f;d=k[g>>2]|0}B4(k[h>>2]|0,d);k[j>>2]=(k[j>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(m|0))break;else e=d}}k[o>>2]=0;e=o+4|0;k[e>>2]=0;f=ZT(16)|0;k[f>>2]=1;h=f+4|0;k[o>>2]=h;k[e>>2]=9;i[f+13>>0]=0;j=373358;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));d=_Ha(c,o)|0;k[e>>2]=0;k[o>>2]=0;x=k[f>>2]|0;k[f>>2]=x+-1;if((x|0)==1)ggb(k[f+-4>>2]|0);n=a+8|0;i[n>>0]=0;if((d|0)!=254){x=aIa(b,c)|0;k[a+4>>2]=x;r=v;return}k[u>>2]=0;m=u+4|0;k[m>>2]=0;g=ZT(16)|0;k[g>>2]=1;d=g+4|0;k[u>>2]=d;k[m>>2]=8;i[g+12>>0]=0;g=d;i[g>>0]=102;i[g+1>>0]=105;i[g+2>>0]=108;i[g+3>>0]=101;d=d+4|0;i[d>>0]=110;i[d+1>>0]=97;i[d+2>>0]=109;i[d+3>>0]=101;$Ha(t,c,u);d=k[t>>2]|0;g=Ufb((d|0)==0?1016759:d,373005)|0;if(!g)e=0;else{UHa(p,g);if((k[p+32>>2]|0)!=8){x=te(44)|0;VHa(x,375679);Cf(x|0,19720,57)}if((k[p+40>>2]|0)!=(k[b>>2]|0)){x=te(44)|0;VHa(x,375747);Cf(x|0,19720,57)}if((k[p+44>>2]|0)!=(k[b+4>>2]|0)){x=te(44)|0;VHa(x,375747);Cf(x|0,19720,57)}k[q+4>>2]=0;k[q+8>>2]=0;d=q+4|0;k[q>>2]=d;k[s>>2]=0;e=s+4|0;k[e>>2]=0;f=ZT(16)|0;k[f>>2]=1;h=f+4|0;k[s>>2]=h;k[e>>2]=9;i[f+13>>0]=0;j=373358;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));w=WHa(q,s)|0;c=k[w>>2]|0;x=w+4|0;jh[k[k[c>>2]>>2]&1023](c,x);k[w>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,p+36|0,x);k[e>>2]=0;k[s>>2]=0;x=k[f>>2]|0;k[f>>2]=x+-1;if((x|0)==1)ggb(k[f+-4>>2]|0);e=aIa(b,q)|0;jh[k[(k[e>>2]|0)+24>>2]&1023](e,g);Qfb(g)|0;YHa(k[d>>2]|0);d=k[t>>2]|0}k[a+4>>2]=e;k[t+4>>2]=0;k[t>>2]=0;if(d|0?(w=d+-4|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0)ggb(k[d+-8>>2]|0);d=k[u>>2]|0;k[m>>2]=0;k[u>>2]=0;if(d|0?(w=d+-4|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0)ggb(k[d+-8>>2]|0);i[n>>0]=1;r=v;return}function YHa(a){a=a|0;var b=0,c=0,d=0;if(!a)return;YHa(k[a>>2]|0);YHa(k[a+4>>2]|0);c=a+16|0;b=k[a+24>>2]|0;jh[k[k[b>>2]>>2]&1023](b,a+28|0);b=k[c>>2]|0;k[a+20>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);ggb(a);return}function ZHa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;p=a+4|0;e=b;do if((p|0)!=(b|0)){s=k[d>>2]|0;f=k[b+16>>2]|0;if((s|0)!=(f|0)){r=(s|0)==0?1016759:s;g=(f|0)==0?1016759:f;q=i[r>>0]|0;f=i[g>>0]|0;n=q<<24>>24!=f<<24>>24;o=q<<24>>24==0;if(o|n){j=f;h=q}else{l=g;m=r;do{m=m+1|0;l=l+1|0;h=i[m>>0]|0;j=i[l>>0]|0}while(!(h<<24>>24==0?1:h<<24>>24!=j<<24>>24))}if((h&255)<(j&255))break;if(f<<24>>24==0|n)g=q;else{j=r;do{g=g+1|0;j=j+1|0;f=i[g>>0]|0;h=i[j>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=h<<24>>24));g=h}if((f&255)<(g&255)){l=b+4|0;e=k[l>>2]|0;m=(e|0)==0;if(m){f=b;while(1){e=k[f+8>>2]|0;if((k[e>>2]|0)==(f|0))break;else f=e}}else while(1){f=k[e>>2]|0;if(!f)break;else e=f}do if((e|0)!=(p|0)){f=k[e+16>>2]|0;if((s|0)!=(f|0)){f=(f|0)==0?1016759:f;g=i[f>>0]|0;if(o|q<<24>>24!=g<<24>>24)f=q;else{h=r;do{h=h+1|0;f=f+1|0;j=i[h>>0]|0;g=i[f>>0]|0}while(!(j<<24>>24==0?1:j<<24>>24!=g<<24>>24));f=j}if((f&255)<(g&255))break}e=k[p>>2]|0;if(!e){k[c>>2]=p;c=p;return c|0}f=k[e+16>>2]|0;a:do if((s|0)!=(f|0)){while(1){g=(f|0)==0?1016759:f;f=i[g>>0]|0;n=q<<24>>24!=f<<24>>24;if(o|n){j=f;h=q}else{l=g;m=r;do{m=m+1|0;l=l+1|0;h=i[m>>0]|0;j=i[l>>0]|0}while(!(h<<24>>24==0?1:h<<24>>24!=j<<24>>24))}if((h&255)<(j&255)){f=k[e>>2]|0;if(!f){f=53;break}else e=f}else{if(f<<24>>24==0|n)g=q;else{j=r;do{g=g+1|0;j=j+1|0;f=i[g>>0]|0;h=i[j>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=h<<24>>24));g=h}if((f&255)>=(g&255))break a;g=e+4|0;f=k[g>>2]|0;if(!f){f=59;break}else e=f}f=k[e+16>>2]|0;if((s|0)==(f|0))break a}if((f|0)==53){k[c>>2]=e;c=e;return c|0}else if((f|0)==59){k[c>>2]=e;c=g;return c|0}}while(0);k[c>>2]=e;return c|0}while(0);if(m){k[c>>2]=b;c=l;return c|0}else{k[c>>2]=e;c=e;return c|0}}}k[c>>2]=e;return c|0}while(0);l=k[b>>2]|0;do if((k[a>>2]|0)!=(b|0)){if(!l){f=b;while(1){e=k[f+8>>2]|0;if((k[e>>2]|0)==(f|0))f=e;else break}}else{e=l;while(1){f=k[e+4>>2]|0;if(!f)break;else e=f}}f=k[e+16>>2]|0;o=k[d>>2]|0;if((f|0)!=(o|0)){h=(f|0)==0?1016759:f;g=(o|0)==0?1016759:o;f=i[h>>0]|0;j=i[g>>0]|0;if(f<<24>>24==0?1:f<<24>>24!=j<<24>>24)g=j;else{do{h=h+1|0;g=g+1|0;f=i[h>>0]|0;j=i[g>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=j<<24>>24));g=j}if((f&255)<(g&255))break}e=k[p>>2]|0;if(!e){k[c>>2]=p;c=p;return c|0}a=(o|0)==0?1016759:o;f=k[e+16>>2]|0;b:do if((o|0)!=(f|0)){d=i[a>>0]|0;b=d<<24>>24==0;while(1){g=(f|0)==0?1016759:f;f=i[g>>0]|0;n=d<<24>>24!=f<<24>>24;if(b|n){j=f;h=d}else{l=g;m=a;do{m=m+1|0;l=l+1|0;h=i[m>>0]|0;j=i[l>>0]|0}while(!(h<<24>>24==0?1:h<<24>>24!=j<<24>>24))}if((h&255)<(j&255)){f=k[e>>2]|0;if(!f){f=24;break}else e=f}else{if(f<<24>>24==0|n)g=d;else{j=a;do{g=g+1|0;j=j+1|0;f=i[g>>0]|0;h=i[j>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=h<<24>>24));g=h}if((f&255)>=(g&255))break b;g=e+4|0;f=k[g>>2]|0;if(!f){f=30;break}else e=f}f=k[e+16>>2]|0;if((o|0)==(f|0))break b}if((f|0)==24){k[c>>2]=e;c=e;return c|0}else if((f|0)==30){k[c>>2]=e;c=g;return c|0}}while(0);k[c>>2]=e;return c|0}while(0);if(!l){k[c>>2]=b;c=b;return c|0}else{s=e;k[c>>2]=s;c=s+4|0;return c|0}return 0}function _Ha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;m=r;r=r+16|0;n=m;j=a+4|0;a=k[j>>2]|0;do if(a|0){l=k[b>>2]|0;d=(l|0)==0?1016759:l;h=j;c=a;a:while(1){a=c;while(1){c=k[a+16>>2]|0;if((c|0)==(l|0))break;f=(c|0)==0?1016759:c;c=i[f>>0]|0;e=i[d>>0]|0;if(!(c<<24>>24==0?1:c<<24>>24!=e<<24>>24)){g=d;do{f=f+1|0;g=g+1|0;c=i[f>>0]|0;e=i[g>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=e<<24>>24))}if((c&255)>=(e&255))break;a=k[a+4>>2]|0;if(!a){f=h;break a}}c=k[a>>2]|0;if(!c){f=a;break}else h=a}if((f|0)!=(j|0)){a=k[f+16>>2]|0;if((l|0)!=(a|0)){c=(a|0)==0?1016759:a;a=i[d>>0]|0;e=i[c>>0]|0;if(a<<24>>24==0?1:a<<24>>24!=e<<24>>24)c=e;else{do{d=d+1|0;c=c+1|0;a=i[d>>0]|0;e=i[c>>0]|0}while(!(a<<24>>24==0?1:a<<24>>24!=e<<24>>24));c=e}if((a&255)<(c&255))break}a=f+24|0;n=k[a>>2]|0;n=(Xh[k[(k[n>>2]|0)+28>>2]&1023](n)|0)+4|0;if((k[n>>2]|0)==198781){n=k[a>>2]|0;n=Hh[k[(k[n>>2]|0)+20>>2]&511](n,f+28|0)|0;r=m;return k[n>>2]|0}else Cf(te(1)|0,19736,0)}}while(0);e=te(44)|0;j=ZT(24)|0;k[j>>2]=1;a=j+4|0;i[j+23>>0]=0;j=a;l=374010;m=j+19|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=b+4|0;f=k[c>>2]|0;g=f+19|0;d=ZT(f+27&-4)|0;k[d>>2]=1;h=d+4|0;i[h+g>>0]=0;j=h;l=a;m=j+19|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));upb(d+23|0,k[b>>2]|0,k[c>>2]|0)|0;j=ZT(32)|0;k[j>>2]=1;a=j+4|0;i[j+29>>0]=0;j=a;l=374030;m=j+25|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));k[n>>2]=0;m=n+4|0;k[m>>2]=0;l=f+44|0;j=ZT(f+52&-4)|0;k[j>>2]=1;j=j+4|0;k[n>>2]=j;k[m>>2]=l;i[j+l>>0]=0;upb(j|0,h|0,g|0)|0;j=j+g|0;l=a;m=j+25|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));FJa(e,n);Cf(e|0,19720,57);return 0}function $Ha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;n=r;r=r+16|0;o=n;l=b+4|0;b=k[l>>2]|0;do if(b|0){m=k[c>>2]|0;e=(m|0)==0?1016759:m;j=l;d=b;a:while(1){b=d;while(1){d=k[b+16>>2]|0;if((d|0)==(m|0))break;g=(d|0)==0?1016759:d;d=i[g>>0]|0;f=i[e>>0]|0;if(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24)){h=e;do{g=g+1|0;h=h+1|0;d=i[g>>0]|0;f=i[h>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24))}if((d&255)>=(f&255))break;b=k[b+4>>2]|0;if(!b){g=j;break a}}d=k[b>>2]|0;if(!d){g=b;break}else j=b}if((g|0)!=(l|0)){b=k[g+16>>2]|0;if((m|0)!=(b|0)){d=(b|0)==0?1016759:b;b=i[e>>0]|0;f=i[d>>0]|0;if(b<<24>>24==0?1:b<<24>>24!=f<<24>>24)d=f;else{do{e=e+1|0;d=d+1|0;b=i[e>>0]|0;f=i[d>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=f<<24>>24));d=f}if((b&255)<(d&255))break}b=g+24|0;o=k[b>>2]|0;o=(Xh[k[(k[o>>2]|0)+28>>2]&1023](o)|0)+4|0;if((k[o>>2]|0)!=195498)Cf(te(1)|0,19736,0);o=k[b>>2]|0;o=Hh[k[(k[o>>2]|0)+20>>2]&511](o,g+28|0)|0;b=k[o>>2]|0;k[a>>2]=b;k[a+4>>2]=k[o+4>>2];if(!b){r=n;return}o=b+-4|0;k[o>>2]=(k[o>>2]|0)+1;r=n;return}}while(0);f=te(44)|0;l=ZT(24)|0;k[l>>2]=1;b=l+4|0;i[l+23>>0]=0;l=b;m=374010;a=l+19|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(a|0));d=c+4|0;g=k[d>>2]|0;h=g+19|0;e=ZT(g+27&-4)|0;k[e>>2]=1;j=e+4|0;i[j+h>>0]=0;l=j;m=b;a=l+19|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(a|0));upb(e+23|0,k[c>>2]|0,k[d>>2]|0)|0;l=ZT(32)|0;k[l>>2]=1;b=l+4|0;i[l+29>>0]=0;l=b;m=374030;a=l+25|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(a|0));k[o>>2]=0;a=o+4|0;k[a>>2]=0;m=g+44|0;l=ZT(g+52&-4)|0;k[l>>2]=1;l=l+4|0;k[o>>2]=l;k[a>>2]=m;i[l+m>>0]=0;upb(l|0,j|0,h|0)|0;l=l+h|0;m=b;a=l+25|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(a|0));FJa(f,o);Cf(f|0,19720,57)}function aIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0.0;v=r;r=r+16|0;u=v+8|0;d=v;e=d+4|0;f=ZT(16)|0;k[f>>2]=1;q=f+4|0;k[d>>2]=q;k[e>>2]=9;i[f+13>>0]=0;p=373358;s=q+9|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));c=_Ha(b,d)|0;k[e>>2]=0;k[d>>2]=0;s=k[f>>2]|0;k[f>>2]=s+-1;if((s|0)==1)ggb(k[f+-4>>2]|0);switch(c|0){case 0:{while(1){c=fgb(36)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=93948;j=c+4|0;k[j>>2]=k[a>>2];k[j+4>>2]=k[a+4>>2];k[j+8>>2]=k[a+8>>2];k[j+12>>2]=k[a+12>>2];j=c+20|0;l=c+24|0;k[l>>2]=0;m=c+28|0;k[m>>2]=0;k[j>>2]=l;d=k[b>>2]|0;h=b+4|0;if((d|0)==(h|0)){u=c;r=v;return u|0}e=d;while(1){f=e+16|0;g=ZHa(j,l,u,f)|0;if(!(k[g>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){b=f+-4|0;k[b>>2]=(k[b>>2]|0)+1}a=d+24|0;k[a>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);b=k[e+24>>2]|0;k[a>>2]=b;Ph[k[(k[b>>2]|0)+8>>2]&511](b,e+28|0,f);f=k[u>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[j>>2]>>2]|0;if(f){k[j>>2]=f;d=k[g>>2]|0}B4(k[l>>2]|0,d);k[m>>2]=(k[m>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(h|0))break;else e=d}r=v;return c|0}case 4:{while(1){c=fgb(120)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=93860;n=c+4|0;k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];h=c+20|0;j=c+24|0;k[j>>2]=0;l=c+28|0;k[l>>2]=0;k[h>>2]=j;d=k[b>>2]|0;m=b+4|0;if((d|0)!=(m|0)){e=d;while(1){f=e+16|0;g=ZHa(h,j,u,f)|0;if(!(k[g>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){a=f+-4|0;k[a>>2]=(k[a>>2]|0)+1}s=d+24|0;k[s>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);a=k[e+24>>2]|0;k[s>>2]=a;Ph[k[(k[a>>2]|0)+8>>2]&511](a,e+28|0,f);f=k[u>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[h>>2]>>2]|0;if(f){k[h>>2]=f;d=k[g>>2]|0}B4(k[j>>2]|0,d);k[l>>2]=(k[l>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(m|0))break;else e=d}}j=c+40|0;h=c+44|0;k[c+80>>2]=0;k[c+84>>2]=0;k[c+88>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;k[j+20>>2]=0;k[j+24>>2]=0;k[c+104>>2]=8192;k[c+92>>2]=0;k[c+96>>2]=0;k[c+108>>2]=0;k[c+112>>2]=0;l=c+68|0;k[l>>2]=k[n>>2];d=c+72|0;k[d>>2]=k[c+8>>2];e=ZT(8)|0;k[e>>2]=1;f=e+4|0;i[e+7>>0]=0;i[f>>0]=i[375541]|0;i[f+1>>0]=i[375542]|0;i[f+2>>0]=i[375543]|0;k[u>>2]=-1;f=dIa(b,f,u)|0;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)==1)ggb(k[e+-4>>2]|0);if((f|0)>0)k[d>>2]=f;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;i[d+17>>0]=0;q=e;p=375545;s=q+13|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));k[u>>2]=10;a=dIa(b,e,u)|0;k[c+32>>2]=a;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)==1)ggb(k[d+-4>>2]|0);d=ZT(12)|0;k[d>>2]=1;a=d+4|0;i[d+11>>0]=0;i[a>>0]=i[375559]|0;i[a+1>>0]=i[375560]|0;i[a+2>>0]=i[375561]|0;i[a+3>>0]=i[375562]|0;i[a+4>>0]=i[375563]|0;i[a+5>>0]=i[375564]|0;i[a+6>>0]=i[375565]|0;i[u>>0]=1;u=(xIa(b,a,u)|0)&1;i[c+36>>0]=u;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0);d=k[l>>2]|0;g=k[h>>2]|0;f=k[j>>2]|0;e=g-f>>2;if(d>>>0<=e>>>0){if(d>>>0<e>>>0?(t=f+(d<<2)|0,(g|0)!=(t|0)):0)k[h>>2]=g+(~((g+-4-t|0)>>>2)<<2)}else{U1(j,d-e|0);d=k[l>>2]|0}if(!d){u=c;r=v;return u|0}e=k[j>>2]|0;d=0;do{k[e+(d<<2)>>2]=d;d=d+1|0}while(d>>>0<(k[l>>2]|0)>>>0);r=v;return c|0}case 1:{while(1){c=fgb(96)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}bIa(c,a,b);u=c;r=v;return u|0}case 2:{while(1){c=fgb(104)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}cIa(c,a,b);u=c;r=v;return u|0}case 3:{while(1){c=fgb(24)|0;if(c|0){m=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){m=0;break}Qh[c&7]()}k[m>>2]=93800;g=m+12|0;h=m+16|0;k[h>>2]=0;j=m+20|0;k[j>>2]=0;k[g>>2]=h;c=k[b>>2]|0;l=b+4|0;if((c|0)!=(l|0)){d=c;while(1){e=d+16|0;f=ZHa(g,h,u,e)|0;if(!(k[f>>2]|0)){while(1){c=fgb(32)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=k[e>>2]|0;k[c+16>>2]=e;k[c+20>>2]=k[d+20>>2];if(e|0){t=e+-4|0;k[t>>2]=(k[t>>2]|0)+1}s=c+24|0;k[s>>2]=428704;e=c+28|0;k[e>>2]=0;jh[k[k[107176]>>2]&1023](428704,e);t=k[d+24>>2]|0;k[s>>2]=t;Ph[k[(k[t>>2]|0)+8>>2]&511](t,d+28|0,e);e=k[u>>2]|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=e;k[f>>2]=c;e=k[k[g>>2]>>2]|0;if(e){k[g>>2]=e;c=k[f>>2]|0}B4(k[h>>2]|0,c);k[j>>2]=(k[j>>2]|0)+1}else d=c;c=k[d+4>>2]|0;if(!c)while(1){c=k[d+8>>2]|0;if((k[c>>2]|0)==(d|0))break;else d=c}else while(1){d=k[c>>2]|0;if(!d)break;else c=d}if((c|0)==(l|0))break;else d=c}}while(1){c=fgb(96)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}bIa(c,a,b);k[m+8>>2]=c;while(1){c=fgb(104)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}cIa(c,a,b);k[m+4>>2]=c;u=m;r=v;return u|0}case 255:{while(1){c=fgb(120)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=93496;d=c+12|0;k[d>>2]=0;k[c+16>>2]=0;k[c+8>>2]=d;rJa(c+20|0,32);d=c+84|0;q=c+32|0;s=q+48|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[d>>2]=k[a>>2];k[d+4>>2]=k[a+4>>2];k[d+8>>2]=k[a+8>>2];k[d+12>>2]=k[a+12>>2];d=ZT(24)|0;k[d>>2]=1;e=d+4|0;i[d+20>>0]=0;q=e;p=373946;s=q+16|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));o[u>>2]=.800000011920929;w=+sJa(b,e,u);o[c+100>>2]=w;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)==1)ggb(k[d+-4>>2]|0);d=ZT(20)|0;k[d>>2]=1;e=d+4|0;i[d+16>>0]=0;q=e;p=373963;s=q+12|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));o[u>>2]=.009999999776482582;w=+sJa(b,e,u);o[c+104>>2]=w;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)==1)ggb(k[d+-4>>2]|0);d=ZT(20)|0;k[d>>2]=1;e=d+4|0;i[d+17>>0]=0;q=e;p=373976;s=q+13|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));o[u>>2]=0.0;w=+sJa(b,e,u);o[c+108>>2]=w;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)==1)ggb(k[d+-4>>2]|0);d=ZT(20)|0;k[d>>2]=1;e=d+4|0;i[d+19>>0]=0;q=e;p=373990;s=q+15|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));o[u>>2]=.10000000149011612;w=+sJa(b,e,u);o[c+112>>2]=w;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0);k[c+4>>2]=0;u=c;r=v;return u|0}case 5:{while(1){c=fgb(104)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=93436;m=c+12|0;k[m>>2]=k[a>>2];k[m+4>>2]=k[a+4>>2];k[m+8>>2]=k[a+8>>2];k[m+12>>2]=k[a+12>>2];n=c+28|0;j=c+32|0;k[j>>2]=0;l=c+36|0;k[l>>2]=0;k[n>>2]=j;d=k[b>>2]|0;h=b+4|0;if((d|0)!=(h|0)){e=d;while(1){f=e+16|0;g=ZHa(n,j,u,f)|0;if(!(k[g>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){b=f+-4|0;k[b>>2]=(k[b>>2]|0)+1}a=d+24|0;k[a>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);b=k[e+24>>2]|0;k[a>>2]=b;Ph[k[(k[b>>2]|0)+8>>2]&511](b,e+28|0,f);f=k[u>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[n>>2]>>2]|0;if(f){k[n>>2]=f;d=k[g>>2]|0}B4(k[j>>2]|0,d);k[l>>2]=(k[l>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(h|0))break;else e=d}}h=c+48|0;k[h>>2]=0;j=c+52|0;k[j>>2]=0;k[c+72>>2]=8192;k[c+60>>2]=0;k[c+64>>2]=0;k[c+76>>2]=0;k[c+80>>2]=0;k[c+84>>2]=0;k[c+40>>2]=k[m>>2];k[c+44>>2]=k[c+16>>2];d=ZT(16)|0;k[d>>2]=1;e=d+4|0;i[d+13>>0]=0;q=e;p=373742;s=q+9|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));k[u>>2]=32;b=dIa(n,e,u)|0;k[c+88>>2]=b;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);e=ZT(20)|0;k[e>>2]=1;d=e+4|0;i[e+16>>0]=0;q=d;p=373752;s=q+12|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));k[u>>2]=0;b=WIa(n,d,u)|0;f=c+96|0;k[f>>2]=b;b=k[e>>2]|0;k[e>>2]=b+-1;if((b|0)==1)ggb(k[e+-4>>2]|0);d=ZT(12)|0;k[d>>2]=1;b=d+4|0;i[d+9>>0]=0;i[b>>0]=i[380533]|0;i[b+1>>0]=i[380534]|0;i[b+2>>0]=i[380535]|0;i[b+3>>0]=i[380536]|0;i[b+4>>0]=i[380537]|0;k[u>>2]=4;b=dIa(n,b,u)|0;g=c+92|0;k[g>>2]=b;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);d=ZT(16)|0;k[d>>2]=1;e=d+4|0;i[d+13>>0]=0;q=e;p=373765;s=q+9|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));k[u>>2]=100;b=dIa(n,e,u)|0;k[c+100>>2]=b;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);switch(k[f>>2]|0){case 0:{k[c+4>>2]=160;k[c+8>>2]=0;break}case 1:{k[c+4>>2]=161;k[c+8>>2]=0;break}case 2:{k[c+4>>2]=162;k[c+8>>2]=0;break}case 3:{k[c+4>>2]=163;k[c+8>>2]=0;break}default:{v=te(44)|0;VHa(v,373775);Cf(v|0,19720,57)}}d=ZT(12)|0;k[d>>2]=1;b=d+4|0;i[d+9>>0]=0;i[b>>0]=i[380533]|0;i[b+1>>0]=i[380534]|0;i[b+2>>0]=i[380535]|0;i[b+3>>0]=i[380536]|0;i[b+4>>0]=i[380537]|0;k[u>>2]=4;u=dIa(n,b,u)|0;k[g>>2]=u;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0);g=k[g>>2]|0;f=g>>>0>1073741823?-1:g<<2;f=(f|0)==0?1:f;while(1){d=fgb(f)|0;if(d|0){e=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){e=0;break}Qh[d&7]()}k[h>>2]=e;while(1){d=fgb(f)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[j>>2]=d;if((g|0)<=0){u=c;r=v;return u|0}k[e>>2]=0;k[k[j>>2]>>2]=0;if((g|0)==1){u=c;r=v;return u|0}else d=1;do{k[(k[h>>2]|0)+(d<<2)>>2]=0;k[(k[j>>2]|0)+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(g|0));r=v;return c|0}case 6:{while(1){c=fgb(76)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=93256;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;m=c+16|0;k[m>>2]=k[a>>2];k[m+4>>2]=k[a+4>>2];k[m+8>>2]=k[a+8>>2];k[m+12>>2]=k[a+12>>2];m=c+36|0;j=c+40|0;k[j>>2]=0;l=c+44|0;k[l>>2]=0;k[m>>2]=j;d=k[b>>2]|0;h=b+4|0;if((d|0)!=(h|0)){e=d;while(1){f=e+16|0;g=ZHa(m,j,u,f)|0;if(!(k[g>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){b=f+-4|0;k[b>>2]=(k[b>>2]|0)+1}a=d+24|0;k[a>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);b=k[e+24>>2]|0;k[a>>2]=b;Ph[k[(k[b>>2]|0)+8>>2]&511](b,e+28|0,f);f=k[u>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[m>>2]>>2]|0;if(f){k[m>>2]=f;d=k[g>>2]|0}B4(k[j>>2]|0,d);k[l>>2]=(k[l>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(h|0))break;else e=d}}g=c+60|0;k[g>>2]=0;k[c+64>>2]=0;k[c+68>>2]=0;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;i[d+16>>0]=0;q=e;p=373387;s=q+12|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));k[u>>2]=12;b=dIa(m,e,u)|0;k[c+48>>2]=b;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);d=ZT(16)|0;k[d>>2]=1;b=d+4|0;i[d+12>>0]=0;f=b;a=f;i[a>>0]=107;i[a+1>>0]=101;i[a+2>>0]=121;i[a+3>>0]=95;f=f+4|0;i[f>>0]=115;i[f+1>>0]=105;i[f+2>>0]=122;i[f+3>>0]=101;k[u>>2]=20;b=dIa(m,b,u)|0;f=c+52|0;k[f>>2]=b;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);e=ZT(24)|0;k[e>>2]=1;d=e+4|0;i[e+21>>0]=0;q=d;p=373400;s=q+17|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));k[u>>2]=2;u=dIa(m,d,u)|0;d=c+56|0;k[d>>2]=u;u=k[e>>2]|0;k[e>>2]=u+-1;if((u|0)==1)ggb(k[e+-4>>2]|0);k[c+32>>2]=k[c+20>>2];eIa(0,k[f>>2]|0,k[d>>2]|0,g);u=c;r=v;return u|0}default:{v=te(44)|0;VHa(v,373368);Cf(v|0,19720,57)}}return 0}function bIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;s=r;r=r+16|0;n=s;k[a>>2]=93624;q=a+8|0;k[q>>2]=0;p=a+12|0;k[p>>2]=0;k[a+16>>2]=0;l=a+20|0;k[l>>2]=k[b>>2];k[l+4>>2]=k[b+4>>2];k[l+8>>2]=k[b+8>>2];k[l+12>>2]=k[b+12>>2];m=a+36|0;j=a+40|0;k[j>>2]=0;g=a+44|0;k[g>>2]=0;h=a+40|0;k[m>>2]=h;b=k[c>>2]|0;f=c+4|0;if((b|0)!=(f|0)){c=b;while(1){d=c+16|0;e=ZHa(m,h,n,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}u=b+24|0;k[u>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);t=k[c+24>>2]|0;k[u>>2]=t;Ph[k[(k[t>>2]|0)+8>>2]&511](t,c+28|0,d);d=k[n>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[m>>2]>>2]|0;if(d){k[m>>2]=d;b=k[e>>2]|0}B4(k[j>>2]|0,b);k[g>>2]=(k[g>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}}k[a+80>>2]=8192;k[a+68>>2]=0;k[a+72>>2]=0;k[a+84>>2]=0;k[a+88>>2]=0;g=a+48|0;k[g>>2]=k[l>>2];f=a+52|0;k[f>>2]=k[a+24>>2];c=ZT(12)|0;k[c>>2]=1;u=c+4|0;i[c+9>>0]=0;i[u>>0]=i[380533]|0;i[u+1>>0]=i[380534]|0;i[u+2>>0]=i[380535]|0;i[u+3>>0]=i[380536]|0;i[u+4>>0]=i[380537]|0;k[n>>2]=4;u=dIa(m,u,n)|0;b=a+4|0;k[b>>2]=u;u=k[c>>2]|0;k[c>>2]=u+-1;if((u|0)==1)ggb(k[c+-4>>2]|0);c=k[b>>2]|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[a+64>>2]=b;b=k[g>>2]|0;e=k[p>>2]|0;d=k[q>>2]|0;c=e-d>>2;if(b>>>0<=c>>>0){if(b>>>0<c>>>0?(o=d+(b<<2)|0,(e|0)!=(o|0)):0)k[p>>2]=e+(~((e+-4-o|0)>>>2)<<2)}else{U1(q,b-c|0);b=k[g>>2]|0}if(b|0){c=k[q>>2]|0;b=0;do{k[c+(b<<2)>>2]=b;b=b+1|0}while(b>>>0<(k[g>>2]|0)>>>0)}c=k[f>>2]|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[a+56>>2]=b;while(1){b=fgb(c)|0;if(b|0){c=37;break}b=k[207666]|0;k[207666]=b+0;if(!b){b=0;c=37;break}Qh[b&7]()}if((c|0)==37){k[a+60>>2]=b;r=s;return}}function cIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0;q=r;r=r+16|0;p=q;k[a>>2]=93720;n=a+28|0;k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];k[n+8>>2]=k[b+8>>2];k[n+12>>2]=k[b+12>>2];h=a+44|0;j=a+48|0;k[j>>2]=0;l=a+52|0;k[l>>2]=0;m=a+48|0;k[h>>2]=m;b=k[c>>2]|0;g=c+4|0;if((b|0)!=(g|0)){d=b;while(1){e=d+16|0;f=ZHa(h,m,p,e)|0;if(!(k[f>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}e=k[e>>2]|0;k[b+16>>2]=e;k[b+20>>2]=k[d+20>>2];if(e|0){e=e+-4|0;k[e>>2]=(k[e>>2]|0)+1}t=b+24|0;k[t>>2]=428704;e=b+28|0;k[e>>2]=0;jh[k[k[107176]>>2]&1023](428704,e);s=k[d+24>>2]|0;k[t>>2]=s;Ph[k[(k[s>>2]|0)+8>>2]&511](s,d+28|0,e);e=k[p>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=e;k[f>>2]=b;e=k[k[h>>2]>>2]|0;if(e){k[h>>2]=e;b=k[f>>2]|0}B4(k[j>>2]|0,b);k[l>>2]=(k[l>>2]|0)+1}else d=b;b=k[d+4>>2]|0;if(!b)while(1){b=k[d+8>>2]|0;if((k[b>>2]|0)==(d|0))break;else d=b}else while(1){d=k[b>>2]|0;if(!d)break;else b=d}if((b|0)==(g|0))break;else d=b}}k[a+64>>2]=0;k[a+68>>2]=0;k[a+88>>2]=8192;k[a+76>>2]=0;k[a+80>>2]=0;k[a+92>>2]=0;k[a+96>>2]=0;k[a+100>>2]=0;k[a+56>>2]=k[n>>2];k[a+60>>2]=k[a+32>>2];b=ZT(16)|0;k[b>>2]=1;d=b+4|0;i[b+13>>0]=0;e=d;f=373742;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));k[p>>2]=32;t=dIa(c,d,p)|0;k[a+12>>2]=t;t=k[b>>2]|0;k[b>>2]=t+-1;if((t|0)==1)ggb(k[b+-4>>2]|0);d=ZT(16)|0;k[d>>2]=1;b=d+4|0;i[d+14>>0]=0;e=b;f=375191;g=e+10|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));k[p>>2]=11;t=dIa(c,b,p)|0;b=a+16|0;k[b>>2]=t;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0);if((k[b>>2]|0)<0)k[b>>2]=2147483647;d=ZT(20)|0;k[d>>2]=1;b=d+4|0;i[d+16>>0]=0;e=b;f=373752;g=e+12|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));k[p>>2]=0;t=WIa(c,b,p)|0;b=a+20|0;k[b>>2]=t;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0);switch(k[b>>2]|0){case 0:{k[a+4>>2]=164;k[a+8>>2]=0;t=a+24|0;o[t>>2]=.4000000059604645;r=q;return}case 1:{k[a+4>>2]=165;k[a+8>>2]=0;t=a+24|0;o[t>>2]=.4000000059604645;r=q;return}case 2:{k[a+4>>2]=166;k[a+8>>2]=0;t=a+24|0;o[t>>2]=.4000000059604645;r=q;return}default:{t=te(44)|0;VHa(t,373775);Cf(t|0,19720,57)}}}function dIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=a+4|0;a=k[l>>2]|0;if(!a){c=k[c>>2]|0;return c|0}e=(b|0)==0?1016759:b;j=l;d=a;a:while(1){a=d;while(1){d=k[a+16>>2]|0;if((d|0)==(b|0))break;g=(d|0)==0?1016759:d;d=i[g>>0]|0;f=i[e>>0]|0;if(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24)){h=e;do{g=g+1|0;h=h+1|0;d=i[g>>0]|0;f=i[h>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24))}if((d&255)>=(f&255))break;a=k[a+4>>2]|0;if(!a){g=j;break a}}d=k[a>>2]|0;if(!d){g=a;break}else j=a}if((g|0)==(l|0)){c=k[c>>2]|0;return c|0}a=k[g+16>>2]|0;if((a|0)!=(b|0)){d=(a|0)==0?1016759:a;a=i[e>>0]|0;f=i[d>>0]|0;if(a<<24>>24==0?1:a<<24>>24!=f<<24>>24)d=f;else{do{e=e+1|0;d=d+1|0;a=i[e>>0]|0;f=i[d>>0]|0}while(!(a<<24>>24==0?1:a<<24>>24!=f<<24>>24));d=f}if((a&255)<(d&255)){c=k[c>>2]|0;return c|0}}a=g+24|0;c=k[a>>2]|0;c=(Xh[k[(k[c>>2]|0)+28>>2]&1023](c)|0)+4|0;if((k[c>>2]|0)!=427578)Cf(te(1)|0,19736,0);c=k[a>>2]|0;c=Hh[k[(k[c>>2]|0)+20>>2]&511](c,g+28|0)|0;c=k[c>>2]|0;return c|0}function eIa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;h=r;r=r+16|0;e=h;k[e>>2]=a;f=d+4|0;g=k[f>>2]|0;if((g|0)==(k[d+8>>2]|0))P4(d,e);else{k[g>>2]=a;k[f>>2]=g+4}if(!((c|0)!=0&(b|0)>0)){r=h;return}c=c+-1|0;do{g=b;b=b+-1|0;eIa(1<<b|a,b,c,d)}while((g|0)>1);r=h;return}function fIa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=k[a+48>>2]|0;c=b;if(b|0){d=a+52|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+28>>2]|0;c=b;if(b|0){d=a+32|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}gIa(k[a+16>>2]|0);b=k[a>>2]|0;if(!b)return;g=a+4|0;c=k[g>>2]|0;if((c|0)!=(b|0)){do{d=c+-12|0;k[g>>2]=d;e=k[d>>2]|0;f=e;if(!e)c=d;else{c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(e|0))k[c>>2]=d+(~((d+-4-f|0)>>>2)<<2);ggb(e);c=k[g>>2]|0}}while((c|0)!=(b|0));b=k[a>>2]|0}ggb(b);return}function gIa(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;gIa(k[a>>2]|0);gIa(k[a+4>>2]|0);c=k[a+20>>2]|0;d=c;if(c|0){e=a+24|0;b=k[e>>2]|0;if((b|0)!=(c|0))k[e>>2]=b+(~((b+-4-d|0)>>>2)<<2);ggb(c)}ggb(a);return}function hIa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=93256;b=k[a+60>>2]|0;c=b;if(b|0){d=a+64|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}YHa(k[a+40>>2]|0);d=a+4|0;e=k[d>>2]|0;if(!e)return;b=a+8|0;while(1){c=k[b>>2]|0;if((c|0)==(e|0))break;a=c+-60|0;k[b>>2]=a;fIa(a)}ggb(k[d>>2]|0);return}function iIa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=93256;b=k[a+60>>2]|0;c=b;if(b|0){d=a+64|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}YHa(k[a+40>>2]|0);b=a+4|0;c=k[b>>2]|0;if(!c){ggb(a);return}d=a+8|0;while(1){e=k[d>>2]|0;if((e|0)==(c|0))break;e=e+-60|0;k[d>>2]=e;fIa(e)}ggb(k[b>>2]|0);ggb(a);return}function jIa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+64|0;h=l;i=a+4|0;j=a+48|0;d=k[j>>2]|0;g=a+8|0;b=k[g>>2]|0;c=k[i>>2]|0;e=(b-c|0)/60|0;if(d>>>0<=e>>>0){if(d>>>0<e>>>0?(f=c+(d*60|0)|0,(b|0)!=(f|0)):0)do{e=b+-60|0;k[g>>2]=e;fIa(e);b=k[g>>2]|0}while((b|0)!=(f|0))}else MIa(i,d-e|0);if(!(k[j>>2]|0)){r=l;return}d=a+16|0;b=0;do{a=(k[i>>2]|0)+(b*60|0)|0;NIa(h);OIa(a,h);fIa(h);e=k[d>>2]|0;if(e|0){c=0;do{PIa(a,c);c=c+1|0}while((c|0)!=(e|0))}QIa(a);b=b+1|0}while(b>>>0<(k[j>>2]|0)>>>0);r=l;return}function kIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;z=r;r=r+32|0;v=z;w=z+28|0;x=v+8|0;y=v+12|0;q=v+20|0;s=v+16|0;k[v>>2]=93396;k[v+24>>2]=e;t=v+4|0;k[q>>2]=0;k[y>>2]=s;k[s>>2]=0;o[x>>2]=3402823466385288598117041.0e14;i[t>>0]=0;if(!(k[b>>2]|0)){k[v>>2]=93356;y=k[s>>2]|0;wIa(y);r=z;return}u=c+12|0;l=c+8|0;m=b+12|0;n=b+8|0;p=d+12|0;j=d+8|0;if((e|0)<=0){c=0;d=0;while(1){wIa(d);k[q>>2]=0;k[y>>2]=s;k[s>>2]=0;o[x>>2]=3402823466385288598117041.0e14;i[t>>0]=0;d=(k[m>>2]|0)+((aa(k[n>>2]|0,c)|0)<<2)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,v,d,f);d=ZT(12)|0;k[d>>2]=1;g=d+4|0;i[d+10>>0]=0;i[g>>0]=i[373546]|0;i[g+1>>0]=i[373547]|0;i[g+2>>0]=i[373548]|0;i[g+3>>0]=i[373549]|0;i[g+4>>0]=i[373550]|0;i[g+5>>0]=i[373551]|0;i[w>>0]=1;g=xIa(f,g,w)|0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);d=k[v>>2]|0;if(g){g=(k[u>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0;h=(k[p>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;dh[k[d+28>>2]&255](v,g,h,e)}else{g=(k[u>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0;h=(k[p>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;dh[k[d+24>>2]&255](v,g,h,e)}c=c+1|0;if(c>>>0>=(k[b>>2]|0)>>>0)break;d=k[s>>2]|0}k[v>>2]=93356;y=k[s>>2]|0;wIa(y);r=z;return}h=e<<2;c=0;d=0;while(1){wIa(d);k[q>>2]=0;k[y>>2]=s;k[s>>2]=0;o[x>>2]=3402823466385288598117041.0e14;i[t>>0]=0;zpb((k[u>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0,-1,h|0)|0;d=e;g=(k[p>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;while(1){k[g>>2]=2139095039;if((d|0)>1){d=d+-1|0;g=g+4|0}else break}d=(k[m>>2]|0)+((aa(k[n>>2]|0,c)|0)<<2)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,v,d,f);d=ZT(12)|0;k[d>>2]=1;g=d+4|0;i[d+10>>0]=0;i[g>>0]=i[373546]|0;i[g+1>>0]=i[373547]|0;i[g+2>>0]=i[373548]|0;i[g+3>>0]=i[373549]|0;i[g+4>>0]=i[373550]|0;i[g+5>>0]=i[373551]|0;i[w>>0]=1;g=xIa(f,g,w)|0;A=k[d>>2]|0;k[d>>2]=A+-1;if((A|0)==1)ggb(k[d+-4>>2]|0);d=k[v>>2]|0;if(g){g=(k[u>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0;A=(k[p>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;dh[k[d+28>>2]&255](v,g,A,e)}else{g=(k[u>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0;A=(k[p>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;dh[k[d+24>>2]&255](v,g,A,e)}c=c+1|0;if(c>>>0>=(k[b>>2]|0)>>>0)break;d=k[s>>2]|0}k[v>>2]=93356;A=k[s>>2]|0;wIa(A);r=z;return}function lIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0;q=r;r=r+32|0;n=q;h=q+28|0;if((k[b>>2]|0)==1){p=k[c+4>>2]|0;g=(p|0)==0;m=g?0:k[c+12>>2]|0;g=g?0:k[d+12>>2]|0;o[n+8>>2]=3402823466385288598117041.0e14;j=n+20|0;l=n+16|0;k[n>>2]=93316;o[n+24>>2]=e;i[n+4>>0]=1;k[j>>2]=0;k[n+12>>2]=l;k[l>>2]=0;dh[k[(k[a>>2]|0)+48>>2]&255](a,n,k[b+12>>2]|0,f);do if((p|0)>0){c=ZT(12)|0;k[c>>2]=1;d=c+4|0;i[c+10>>0]=0;i[d>>0]=i[373546]|0;i[d+1>>0]=i[373547]|0;i[d+2>>0]=i[373548]|0;i[d+3>>0]=i[373549]|0;i[d+4>>0]=i[373550]|0;i[d+5>>0]=i[373551]|0;i[h>>0]=1;d=xIa(f,d,h)|0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0);c=k[n>>2]|0;if(d){dh[k[c+28>>2]&255](n,m,g,p);break}else{dh[k[c+24>>2]&255](n,m,g,p);break}}while(0);p=k[j>>2]|0;k[n>>2]=93356;wIa(k[l>>2]|0);r=q;return p|0}c=k[41482]|0;d=(c|0)==0;if((k[41497]|0)>-1){do if(d){c=i[165986]|0;i[165986]=c+255|c;c=k[41478]|0;if(!(c&8)){k[41480]=0;k[41479]=0;d=k[41489]|0;k[41485]=d;k[41483]=d;c=d+(k[41490]|0)|0;k[41482]=c;break}k[41478]=c|32;p=-1;r=q;return p|0}else d=k[41483]|0;while(0);if((c-d|0)>>>0<57){ci[k[165948>>2]&255](165912,373488,57)|0;p=-1;r=q;return p|0}do if((i[165987]|0)>-1)if((ci[k[165948>>2]&255](165912,373488,57)|0)>>>0<57){p=-1;r=q;return p|0}else{c=0;a=373545;d=k[41483]|0;break}else{c=57;a=373488}while(0);upb(d|0,a|0,c|0)|0;k[41483]=(k[41483]|0)+c;p=-1;r=q;return p|0}else{do if(d){c=i[165986]|0;i[165986]=c+255|c;c=k[41478]|0;if(!(c&8)){k[41480]=0;k[41479]=0;d=k[41489]|0;k[41485]=d;k[41483]=d;c=d+(k[41490]|0)|0;k[41482]=c;break}k[41478]=c|32;p=-1;r=q;return p|0}else d=k[41483]|0;while(0);if((c-d|0)>>>0<57){ci[k[165948>>2]&255](165912,373488,57)|0;p=-1;r=q;return p|0}do if((i[165987]|0)>-1)if((ci[k[165948>>2]&255](165912,373488,57)|0)>>>0<57){p=-1;r=q;return p|0}else{c=0;a=373545;d=k[41483]|0;break}else{c=57;a=373488}while(0);upb(d|0,a|0,c|0)|0;k[41483]=(k[41483]|0)+c;p=-1;r=q;return p|0}return 0}function mIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;h=a+48|0;j=b+76|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}b:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break b}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;f=k[b+44>>2]|0;k[b+28>>2]=f;g=b+20|0;k[g>>2]=f;d=f+(k[b+48>>2]|0)|0;k[e>>2]=d;e=f;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;d=c;g=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}c:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;d=h;break c}d=e+-1|0;if((i[h+d>>0]|0)==10)break;else e=d}if((ci[k[b+36>>2]&255](b,h,e)|0)>>>0<e>>>0)break a;f=4-e|0;d=h+e|0;c=k[g>>2]|0}else{f=4;d=h}while(0);upb(c|0,d|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f}while(0);h=a+52|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;d:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}e:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break e}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}f:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break f}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+56|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;g:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}h:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break h}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}i:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break i}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+16|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;j:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<16){ci[k[b+36>>2]&255](b,h,16)|0;break}k:do if((i[b+75>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=h;c=f;break k}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=16-d|0;d=h+d|0;c=k[g>>2]|0}else{e=16;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<16){ci[k[b+36>>2]&255](b,h,16)|0;break}l:do if((i[b+75>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=h;c=f;break l}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=16-d|0;d=h+d|0;c=k[g>>2]|0}else{e=16;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);d=k[a+28>>2]|0;e=(aa(k[a+20>>2]|0,k[h>>2]|0)|0)<<2;g=b+16|0;f=k[g>>2]|0;c=(f|0)==0;if((k[j>>2]|0)>-1){do if(c){c=b+74|0;j=i[c>>0]|0;i[c>>0]=j+255|j;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;j=k[b+44>>2]|0;k[b+28>>2]=j;h=b+20|0;k[h>>2]=j;f=j+(k[b+48>>2]|0)|0;k[g>>2]=f;g=j;break}k[b>>2]=c|32;return}else{g=b+20|0;h=g;g=k[g>>2]|0}while(0);c=g;if((f-g|0)>>>0<e>>>0){ci[k[b+36>>2]&255](b,d,e)|0;return}m:do if((i[b+75>>0]|0)>-1){g=e;while(1){if(!g)break m;f=g+-1|0;if((i[d+f>>0]|0)==10)break;else g=f}if((ci[k[b+36>>2]&255](b,d,g)|0)>>>0<g>>>0)return;else{e=e-g|0;d=d+g|0;c=k[h>>2]|0;break}}while(0);upb(c|0,d|0,e|0)|0;k[h>>2]=(k[h>>2]|0)+e;return}else{do if(c){c=b+74|0;j=i[c>>0]|0;i[c>>0]=j+255|j;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;j=k[b+44>>2]|0;k[b+28>>2]=j;h=b+20|0;k[h>>2]=j;f=j+(k[b+48>>2]|0)|0;k[g>>2]=f;g=j;break}k[b>>2]=c|32;return}else{g=b+20|0;h=g;g=k[g>>2]|0}while(0);c=g;if((f-g|0)>>>0<e>>>0){ci[k[b+36>>2]&255](b,d,e)|0;return}n:do if((i[b+75>>0]|0)>-1){g=e;while(1){if(!g)break n;f=g+-1|0;if((i[d+f>>0]|0)==10)break;else g=f}if((ci[k[b+36>>2]&255](b,d,g)|0)>>>0<g>>>0)return;else{e=e-g|0;d=d+g|0;c=k[h>>2]|0;break}}while(0);upb(c|0,d|0,e|0)|0;k[h>>2]=(k[h>>2]|0)+e;return}}function nIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o+8|0;d=o;e=a+48|0;if((_fb(e,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}f=a+52|0;if((_fb(f,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}m=a+56|0;if((_fb(m,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}vIa(b,a+16|0);Uh[k[(k[a>>2]|0)+8>>2]&2047](a);l=a+36|0;b=n+4|0;c=ZT(16)|0;k[c>>2]=1;g=c+4|0;k[n>>2]=g;k[b>>2]=9;i[c+13>>0]=0;h=373358;j=g+9|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));h=WHa(l,n)|0;g=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[d>>2]=g;g=k[h>>2]|0;j=h+4|0;jh[k[k[g>>2]>>2]&1023](g,j);k[h>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,d,j);k[b>>2]=0;k[n>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0);b=n+4|0;c=ZT(20)|0;k[c>>2]=1;g=c+4|0;k[n>>2]=g;k[b>>2]=12;i[c+16>>0]=0;h=373387;j=g+12|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));h=WHa(l,n)|0;g=k[h>>2]|0;j=h+4|0;jh[k[k[g>>2]>>2]&1023](g,j);k[h>>2]=428732;Ph[k[(k[107183]|0)+4>>2]&511](428732,e,j);k[b>>2]=0;k[n>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0);j=n+4|0;b=ZT(16)|0;k[b>>2]=1;g=b+4|0;k[n>>2]=g;k[j>>2]=8;i[b+12>>0]=0;e=g;i[e>>0]=107;i[e+1>>0]=101;i[e+2>>0]=121;i[e+3>>0]=95;g=g+4|0;i[g>>0]=115;i[g+1>>0]=105;i[g+2>>0]=122;i[g+3>>0]=101;g=WHa(l,n)|0;e=k[g>>2]|0;h=g+4|0;jh[k[k[e>>2]>>2]&1023](e,h);k[g>>2]=428732;Ph[k[(k[107183]|0)+4>>2]&511](428732,f,h);k[j>>2]=0;k[n>>2]=0;j=k[b>>2]|0;k[b>>2]=j+-1;if((j|0)==1)ggb(k[b+-4>>2]|0);b=n+4|0;c=ZT(24)|0;k[c>>2]=1;g=c+4|0;k[n>>2]=g;k[b>>2]=17;i[c+21>>0]=0;h=373400;j=g+17|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));j=WHa(l,n)|0;h=k[j>>2]|0;l=j+4|0;jh[k[k[h>>2]>>2]&1023](h,l);k[j>>2]=428732;Ph[k[(k[107183]|0)+4>>2]&511](428732,m,l);k[b>>2]=0;k[n>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)!=1){r=o;return}ggb(k[c+-4>>2]|0);r=o;return}function oIa(a){a=a|0;return k[a+16>>2]|0}function pIa(a){a=a|0;return k[a+32>>2]|0}function qIa(a){a=a|0;return k[a+16>>2]<<2|0}function rIa(a){a=a|0;return 6}function sIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+36>>2]|0;f=b+40|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function tIa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0;d=k[a+4>>2]|0;z=k[a+8>>2]|0;if((d|0)==(z|0))return;A=a+64|0;v=a+28|0;w=a+24|0;x=a+20|0;y=3-c|0;u=a+60|0;do{uIa();a=k[u>>2]|0;q=k[A>>2]|0;a:do if((a|0)!=(q|0)){r=d+24|0;s=d+28|0;t=d+16|0;p=a;while(1){a=k[p>>2]|0;h=a^1;switch(k[r>>2]|0){case 0:{a=(k[d>>2]|0)+(h*12|0)|0;if(a|0){n=a;D=24}break}case 1:{if(k[(k[s>>2]|0)+(a>>>5<<2)>>2]&1<<(h&31)|0){e=k[t>>2]|0;if(e){a=t;b:while(1){g=e;while(1){if((k[g+16>>2]|0)>>>0>=h>>>0)break;e=k[g+4>>2]|0;if(!e)break b;else g=e}e=k[g>>2]|0;if(!e){a=g;break}else a=g}if(!((a|0)!=(t|0)?(k[a+16>>2]|0)>>>0<=h>>>0:0))D=14}else D=14;if((D|0)==14)a=t;n=a+20|0;D=24}break}case 2:{e=k[t>>2]|0;if(e|0){a=t;c:while(1){g=e;while(1){if((k[g+16>>2]|0)>>>0>=h>>>0)break;e=k[g+4>>2]|0;if(!e)break c;else g=e}e=k[g>>2]|0;if(!e){a=g;break}else a=g}if((a|0)!=(t|0)?(k[a+16>>2]|0)>>>0<=h>>>0:0){n=a+20|0;D=24}}break}default:{}}if((D|0)==24?(D=0,B=k[n>>2]|0,C=k[n+4>>2]|0,B>>>0<C>>>0):0){l=B;do{m=k[l>>2]|0;a=(k[v>>2]|0)+((aa(k[w>>2]|0,m)|0)<<2)|0;j=c+(k[x>>2]<<2)|0;h=j+-12|0;i=((h>>>0<c>>>0?c:h)+12+y|0)>>>4<<2;e=a+(i<<2)|0;if(h>>>0>c>>>0){g=c;f=0.0;while(1){G=+P(+(+o[g>>2]-+o[a>>2]));F=+P(+(+o[g+4>>2]-+o[a+4>>2]));E=+P(+(+o[g+8>>2]-+o[a+8>>2]));f=f+(G+F+E+ +P(+(+o[g+12>>2]-+o[a+12>>2])));g=g+16|0;if(g>>>0>=h>>>0)break;else a=a+16|0}}else f=0.0;a=c+(i<<2)|0;if(a>>>0<j>>>0)while(1){f=f+ +P(+(+o[a>>2]-+o[e>>2]));a=a+4|0;if(a>>>0>=j>>>0)break;else e=e+4|0}$f[k[(k[b>>2]|0)+12>>2]&15](b,f,m);l=l+4|0}while(l>>>0<C>>>0)}p=p+4|0;if((p|0)==(q|0))break a}}while(0);d=d+60|0}while((d|0)!=(z|0));return}function uIa(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0;g=r;r=r+16|0;c=g;f=jS(828068,373451,36)|0;a=k[f+(k[(k[f>>2]|0)+-12>>2]|0)+28>>2]|0;e=a+4|0;k[e>>2]=(k[e>>2]|0)+1;e=Wib(828772)|0;e=k[(k[a+8>>2]|0)+(e<<2)>>2]|0;e=Hh[k[(k[e>>2]|0)+28>>2]&511](e,10)|0;b=a+4|0;d=k[b>>2]|0;k[b>>2]=d+-1;if(!d)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);a=k[(k[f>>2]|0)+-12>>2]|0;b=f+a|0;do if(!(k[b+16>>2]|0)){b=k[b+72>>2]|0;if((b|0)!=0?(k[b+(k[(k[b>>2]|0)+-12>>2]|0)+24>>2]|0)!=0:0){Qhb(c,b);if(i[c>>0]|0?(d=k[b+(k[(k[b>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[d>>2]|0)+24>>2]&1023](d)|0)==-1):0){d=b+(k[(k[b>>2]|0)+-12>>2]|0)+16|0;k[d>>2]=k[d>>2]|1}a=k[c+4>>2]|0;d=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;if((((k[d+24>>2]|0?(k[d+16>>2]|0)==0:0)?k[d+4>>2]&8192|0:0)?!(bd()|0):0)?(d=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[d>>2]|0)+24>>2]&1023](d)|0)==-1):0){d=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[d>>2]=k[d>>2]|1}a=k[(k[f>>2]|0)+-12>>2]|0}c=k[f+a+24>>2]|0;d=c;if(c){b=d+24|0;a=k[b>>2]|0;if((a|0)!=(k[d+28>>2]|0)){k[b>>2]=a+1;i[a>>0]=e;break}if((Hh[k[(k[c>>2]|0)+52>>2]&511](d,e&255)|0)!=-1)break;a=k[(k[f>>2]|0)+-12>>2]|0}e=f+a+16|0;k[e>>2]=k[e>>2]|1}while(0);e=f+(k[(k[f>>2]|0)+-12>>2]|0)|0;if((((k[e+24>>2]|0?(k[e+16>>2]|0)==0:0)?k[e+4>>2]&8192|0:0)?!(bd()|0):0)?(e=k[f+(k[(k[f>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[e>>2]|0)+24>>2]&1023](e)|0)==-1):0){e=f+(k[(k[f>>2]|0)+-12>>2]|0)+16|0;k[e>>2]=k[e>>2]|1}b=f+(k[(k[f>>2]|0)+-12>>2]|0)|0;a=k[b+24>>2]|0;if(!a){r=g;return}if(!(k[b+16>>2]|0)){b=k[b+72>>2]|0;if(b){Phb(b);a=k[f+(k[(k[f>>2]|0)+-12>>2]|0)+24>>2]|0}if((Xh[k[(k[a>>2]|0)+24>>2]&1023](a)|0)==-1){e=f+(k[(k[f>>2]|0)+-12>>2]|0)+16|0;k[e>>2]=k[e>>2]|1}}a=f+(k[(k[f>>2]|0)+-12>>2]|0)|0;if(!(k[a+24>>2]|0)){r=g;return}if(k[a+16>>2]|0){r=g;return}if(!(k[a+4>>2]&8192)){r=g;return}if(bd()|0){r=g;return}e=k[f+(k[(k[f>>2]|0)+-12>>2]|0)+24>>2]|0;if((Xh[k[(k[e>>2]|0)+24>>2]&1023](e)|0)!=-1){r=g;return}f=f+(k[(k[f>>2]|0)+-12>>2]|0)+16|0;k[f>>2]=k[f>>2]|1;r=g;return}function vIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if((_fb(b,16,1,a)|0)!=1){f=te(44)|0;VHa(f,373124);Cf(f|0,19720,57)}e=b+4|0;f=aa(k[e>>2]|0,k[b>>2]|0)|0;d=f>>>0>1073741823?-1:f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[b+12>>2]=c;f=_fb(c,4,f,a)|0;if((f|0)==(aa(k[e>>2]|0,k[b>>2]|0)|0))return;else{f=te(44)|0;VHa(f,373124);Cf(f|0,19720,57)}}function wIa(a){a=a|0;if(!a)return;else{wIa(k[a>>2]|0);wIa(k[a+4>>2]|0);ggb(a);return}}function xIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=a+4|0;a=k[l>>2]|0;if(!a){c=i[c>>0]|0;c=c<<24>>24!=0;return c|0}e=(b|0)==0?1016759:b;j=l;d=a;a:while(1){a=d;while(1){d=k[a+16>>2]|0;if((d|0)==(b|0))break;g=(d|0)==0?1016759:d;d=i[g>>0]|0;f=i[e>>0]|0;if(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24)){h=e;do{g=g+1|0;h=h+1|0;d=i[g>>0]|0;f=i[h>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24))}if((d&255)>=(f&255))break;a=k[a+4>>2]|0;if(!a){g=j;break a}}d=k[a>>2]|0;if(!d){g=a;break}else j=a}if((g|0)==(l|0)){c=i[c>>0]|0;c=c<<24>>24!=0;return c|0}a=k[g+16>>2]|0;if((a|0)!=(b|0)){d=(a|0)==0?1016759:a;a=i[e>>0]|0;f=i[d>>0]|0;if(a<<24>>24==0?1:a<<24>>24!=f<<24>>24)d=f;else{do{e=e+1|0;d=d+1|0;a=i[e>>0]|0;f=i[d>>0]|0}while(!(a<<24>>24==0?1:a<<24>>24!=f<<24>>24));d=f}if((a&255)<(d&255)){c=i[c>>0]|0;c=c<<24>>24!=0;return c|0}}a=g+24|0;c=k[a>>2]|0;c=(Xh[k[(k[c>>2]|0)+28>>2]&1023](c)|0)+4|0;if((k[c>>2]|0)!=427566)Cf(te(1)|0,19736,0);c=k[a>>2]|0;c=Hh[k[(k[c>>2]|0)+20>>2]&511](c,g+28|0)|0;c=i[c>>0]|0;c=c<<24>>24!=0;return c|0}function yIa(a){a=a|0;k[a>>2]=93356;wIa(k[a+16>>2]|0);return}function zIa(a){a=a|0;k[a>>2]=93356;wIa(k[a+16>>2]|0);ggb(a);return}function AIa(a){a=a|0;return (i[a+4>>0]|0)!=0|0}function BIa(a){a=a|0;return +(+o[a+8>>2])}function CIa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=k[a+12>>2]|0;g=a+16|0;if((d|0)<0){if((e|0)==(g|0))return;while(1){k[b>>2]=k[e+20>>2];k[c>>2]=k[e+16>>2];a=k[e+4>>2]|0;if(!a)while(1){a=k[e+8>>2]|0;if((k[a>>2]|0)==(e|0))break;else e=a}else while(1){e=k[a>>2]|0;if(!e)break;else a=e}if((a|0)==(g|0))break;else{b=b+4|0;c=c+4|0;e=a}}return}else{if(!((e|0)!=(g|0)&(d|0)!=0))return;f=0;while(1){k[b>>2]=k[e+20>>2];k[c>>2]=k[e+16>>2];a=k[e+4>>2]|0;if(!a){a=e;while(1){e=k[a+8>>2]|0;if((k[e>>2]|0)==(a|0))break;else a=e}}else{e=a;while(1){a=k[e>>2]|0;if(!a)break;else e=a}}f=f+1|0;if(!((e|0)!=(g|0)&(f|0)<(d|0)))break;else{c=c+4|0;b=b+4|0}}return}}function DIa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dh[k[(k[a>>2]|0)+24>>2]&255](a,b,c,d);return}function EIa(a){a=a|0;k[a>>2]=93356;wIa(k[a+16>>2]|0);ggb(a);return}function FIa(a){a=a|0;return 1}function GIa(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0.0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+16|0;i=l;if(!(+o[a+24>>2]>=b)){r=l;return}j=a+12|0;e=a+16|0;d=k[e>>2]|0;do if(d){while(1){e=d+16|0;f=+o[e>>2];if(!(f>b)?(h=f==b,!(h&(k[e+4>>2]|0)>>>0>c>>>0)):0){if(!(f<b)){if(!h){e=13;break}if((k[d+20>>2]|0)>>>0>=c>>>0){e=13;break}}g=d+4|0;e=k[g>>2]|0;if(!e){e=12;break}else d=e}else{e=k[d>>2]|0;if(!e){e=6;break}else d=e}}if((e|0)==6){k[i>>2]=d;h=d;g=d;break}else if((e|0)==12){k[i>>2]=d;h=d;break}else if((e|0)==13){k[i>>2]=d;h=d;g=i;break}}else{k[i>>2]=e;h=e;g=e}while(0);if(!(k[g>>2]|0)){while(1){d=fgb(24)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}o[d+16>>2]=b;k[d+20>>2]=c;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=h;k[g>>2]=d;e=k[k[j>>2]>>2]|0;if(e){k[j>>2]=e;d=k[g>>2]|0}B4(k[a+16>>2]|0,d);a=a+20|0;k[a>>2]=(k[a>>2]|0)+1}r=l;return}function HIa(a){a=a|0;return +(+o[a+24>>2])}function IIa(a){a=a|0;var b=0;b=a+16|0;wIa(k[b>>2]|0);k[a+20>>2]=0;k[a+12>>2]=b;k[b>>2]=0;return}function JIa(a){a=a|0;k[a>>2]=93356;wIa(k[a+16>>2]|0);ggb(a);return}function KIa(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,p=0.0,q=0,s=0,t=0,u=0;u=r;r=r+16|0;l=u;t=a+8|0;if(+o[t>>2]<=b){r=u;return}q=a+12|0;e=a+16|0;d=k[e>>2]|0;do if(d){while(1){f=d+16|0;h=+o[f>>2];if(!(h>b)?(j=h==b,!(j&(k[f+4>>2]|0)>>>0>c>>>0)):0){if(!(h<b)){if(!j){s=13;break}if((k[d+20>>2]|0)>>>0>=c>>>0){s=13;break}}g=d+4|0;f=k[g>>2]|0;if(!f){s=12;break}else d=f}else{f=k[d>>2]|0;if(!f){s=6;break}else d=f}}if((s|0)==6){k[l>>2]=d;f=d;g=d;break}else if((s|0)==12){k[l>>2]=d;f=d;break}else if((s|0)==13){k[l>>2]=d;f=d;g=l;break}}else{k[l>>2]=e;f=e;g=e}while(0);if(!(k[g>>2]|0)){while(1){d=fgb(24)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}o[d+16>>2]=b;k[d+20>>2]=c;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[q>>2]>>2]|0;if(f){k[q>>2]=f;d=k[g>>2]|0}B4(k[a+16>>2]|0,d);c=a+20|0;m=(k[c>>2]|0)+1|0;k[c>>2]=m}else m=k[a+20>>2]|0;d=a+4|0;f=k[a+24>>2]|0;if(!(i[d>>0]|0)){if((m|0)!=(f|0)){r=u;return}i[d>>0]=1;d=k[e>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))e=d;else break}else while(1){e=k[d+4>>2]|0;if(!e)break;else d=e}k[t>>2]=k[d+16>>2];r=u;return}if(m>>>0<=f>>>0){r=u;return}d=k[e>>2]|0;if(!d){g=e;while(1){f=k[g+8>>2]|0;if((k[f>>2]|0)==(g|0))g=f;else break}}else{f=d;while(1){g=k[f+4>>2]|0;if(!g)break;else f=g}}if(d){l=f+16|0;c=k[l+4>>2]|0;b=+o[l>>2];l=e;j=d;a:while(1){g=j;while(1){h=+o[g+16>>2];if(!(h<b)){if(!(h==b))break;if((k[g+20>>2]|0)>>>0>=c>>>0)break}g=k[g+4>>2]|0;if(!g)break a}j=k[g>>2]|0;if(!j){l=g;break}else l=g}do if((l|0)!=(e|0)?(c=l+16|0,n=k[c+4>>2]|0,p=+o[c>>2],!(b<p)):0){if(b==p?(k[f+20>>2]|0)>>>0<n>>>0:0)break;f=k[l+4>>2]|0;if(!f){g=l;while(1){f=k[g+8>>2]|0;if((k[f>>2]|0)==(g|0))break;else g=f}}else while(1){g=k[f>>2]|0;if(!g)break;else f=g}if((k[q>>2]|0)==(l|0))k[q>>2]=f;k[a+20>>2]=m+-1;bya(d,l);ggb(l);d=k[e>>2]|0}while(0);if(d)while(1){e=k[d+4>>2]|0;if(!e)break;else d=e}else s=48}else s=48;if((s|0)==48)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0)){e=d;s=48}else break}k[t>>2]=k[d+16>>2];r=u;return}function LIa(a){a=a|0;var b=0;b=a+16|0;wIa(k[b>>2]|0);k[a+20>>2]=0;k[a+12>>2]=b;k[b>>2]=0;o[a+8>>2]=3402823466385288598117041.0e14;i[a+4>>0]=0;return}function MIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+16|0;u=x;v=a+8|0;e=k[v>>2]|0;w=a+4|0;c=k[w>>2]|0;if(((e-c|0)/60|0)>>>0>=b>>>0){do{k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+16>>2]=0;k[c+20>>2]=0;k[c+12>>2]=c+16;k[c+28>>2]=0;k[c+32>>2]=0;k[c+36>>2]=0;k[c+48>>2]=0;k[c+52>>2]=0;k[c+56>>2]=0;c=(k[w>>2]|0)+60|0;k[w>>2]=c;b=b+-1|0}while((b|0)!=0);r=x;return}d=k[a>>2]|0;f=(c-d|0)/60|0;c=f+b|0;if(c>>>0>71582788)ad(426534,426557,304,426811);t=(e-d|0)/60|0;g=t<<1;g=t>>>0<35791394?(g>>>0<c>>>0?c:g):71582788;if(!g)c=0;else{if(g>>>0>71582788){x=te(4)|0;k[x>>2]=172664;Cf(x|0,28816,1287)}d=g*60|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}f=c+(f*60|0)|0;e=f;t=e;d=f;do{k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[d+12>>2]=d+16;k[d+28>>2]=0;k[d+32>>2]=0;k[d+36>>2]=0;k[d+48>>2]=0;k[d+52>>2]=0;k[d+56>>2]=0;d=t+60|0;t=d;b=b+-1|0}while((b|0)!=0);s=c+(g*60|0)|0;d=k[a>>2]|0;c=k[w>>2]|0;if((c|0)==(d|0)){c=d;b=e;d=c}else{b=e;do{l=c;c=c+-60|0;VIa(f+-60|0,c);m=f+-48|0;n=f+-44|0;k[n>>2]=0;o=f+-40|0;k[o>>2]=0;p=f+-44|0;k[m>>2]=p;e=k[l+-48>>2]|0;q=l+-44|0;if((e|0)!=(q|0)){g=e;i=e;while(1){h=i+16|0;j=UIa(m,p,u,h)|0;if(!(k[j>>2]|0)){while(1){e=fgb(32)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[e+16>>2]=k[h>>2];SIa(e+20|0,i+20|0);h=k[u>>2]|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=h;k[j>>2]=e;h=k[k[m>>2]>>2]|0;if(h){k[m>>2]=h;e=k[j>>2]|0}B4(k[n>>2]|0,e);k[o>>2]=(k[o>>2]|0)+1}e=k[g+4>>2]|0;if(!e)while(1){e=k[g+8>>2]|0;if((k[e>>2]|0)==(g|0))break;else g=e}else while(1){g=k[e>>2]|0;if(!g)break;else e=g}if((e|0)==(q|0))break;else{g=e;i=e}}}k[f+-36>>2]=k[l+-36>>2];SIa(f+-32|0,l+-32|0);k[f+-20>>2]=k[l+-20>>2];k[f+-16>>2]=k[l+-16>>2];SIa(f+-12|0,l+-12|0);f=b+-60|0;b=f}while((c|0)!=(d|0));d=k[a>>2]|0;c=k[w>>2]|0}k[a>>2]=b;k[w>>2]=t;k[v>>2]=s;b=d;while(1){if((c|0)==(b|0))break;c=c+-60|0;fIa(c)}if(!d){r=x;return}ggb(d);r=x;return}function NIa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;g=r;r=r+16|0;c=g;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;k[a+12>>2]=a+16;k[a+28>>2]=0;k[a+32>>2]=0;k[a+36>>2]=0;k[a+48>>2]=0;k[a+52>>2]=0;k[a+56>>2]=0;f=jS(828068,373451,36)|0;a=k[f+(k[(k[f>>2]|0)+-12>>2]|0)+28>>2]|0;e=a+4|0;k[e>>2]=(k[e>>2]|0)+1;e=Wib(828772)|0;e=k[(k[a+8>>2]|0)+(e<<2)>>2]|0;e=Hh[k[(k[e>>2]|0)+28>>2]&511](e,10)|0;b=a+4|0;d=k[b>>2]|0;k[b>>2]=d+-1;if(!d)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);a=k[(k[f>>2]|0)+-12>>2]|0;b=f+a|0;do if(!(k[b+16>>2]|0)){b=k[b+72>>2]|0;if((b|0)!=0?(k[b+(k[(k[b>>2]|0)+-12>>2]|0)+24>>2]|0)!=0:0){Qhb(c,b);if(i[c>>0]|0?(d=k[b+(k[(k[b>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[d>>2]|0)+24>>2]&1023](d)|0)==-1):0){d=b+(k[(k[b>>2]|0)+-12>>2]|0)+16|0;k[d>>2]=k[d>>2]|1}a=k[c+4>>2]|0;d=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;if((((k[d+24>>2]|0?(k[d+16>>2]|0)==0:0)?k[d+4>>2]&8192|0:0)?!(bd()|0):0)?(d=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[d>>2]|0)+24>>2]&1023](d)|0)==-1):0){d=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[d>>2]=k[d>>2]|1}a=k[(k[f>>2]|0)+-12>>2]|0}c=k[f+a+24>>2]|0;d=c;if(c){a=d+24|0;b=k[a>>2]|0;if((b|0)!=(k[d+28>>2]|0)){k[a>>2]=b+1;i[b>>0]=e;break}if((Hh[k[(k[c>>2]|0)+52>>2]&511](d,e&255)|0)!=-1)break;a=k[(k[f>>2]|0)+-12>>2]|0}e=f+a+16|0;k[e>>2]=k[e>>2]|1}while(0);e=f+(k[(k[f>>2]|0)+-12>>2]|0)|0;if((((k[e+24>>2]|0?(k[e+16>>2]|0)==0:0)?k[e+4>>2]&8192|0:0)?!(bd()|0):0)?(e=k[f+(k[(k[f>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[e>>2]|0)+24>>2]&1023](e)|0)==-1):0){e=f+(k[(k[f>>2]|0)+-12>>2]|0)+16|0;k[e>>2]=k[e>>2]|1}b=f+(k[(k[f>>2]|0)+-12>>2]|0)|0;a=k[b+24>>2]|0;if(!a){r=g;return}if(!(k[b+16>>2]|0)){b=k[b+72>>2]|0;if(b){Phb(b);a=k[f+(k[(k[f>>2]|0)+-12>>2]|0)+24>>2]|0}if((Xh[k[(k[a>>2]|0)+24>>2]&1023](a)|0)==-1){e=f+(k[(k[f>>2]|0)+-12>>2]|0)+16|0;k[e>>2]=k[e>>2]|1}}a=f+(k[(k[f>>2]|0)+-12>>2]|0)|0;if(!(k[a+24>>2]|0)){r=g;return}if(k[a+16>>2]|0){r=g;return}if(!(k[a+4>>2]&8192)){r=g;return}if(bd()|0){r=g;return}e=k[f+(k[(k[f>>2]|0)+-12>>2]|0)+24>>2]|0;if((Xh[k[(k[e>>2]|0)+24>>2]&1023](e)|0)!=-1){r=g;return}f=f+(k[(k[f>>2]|0)+-12>>2]|0)+16|0;k[f>>2]=k[f>>2]|1;r=g;return}function OIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+16|0;l=p;m=(a|0)==(b|0);if(m){k[a+40>>2]=k[b+40>>2];k[a+44>>2]=k[b+44>>2];r=p;return}TIa(a,k[b>>2]|0,k[b+4>>2]|0);n=a+12|0;o=a+16|0;gIa(k[o>>2]|0);h=a+20|0;k[h>>2]=0;k[n>>2]=o;k[o>>2]=0;c=k[b+12>>2]|0;i=b+16|0;if((c|0)==(i|0))k[a+24>>2]=k[b+24>>2];else{j=a+16|0;g=c;d=c;while(1){e=g+16|0;f=UIa(n,o,l,e)|0;if(!(k[f>>2]|0)){while(1){c=fgb(32)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;Qh[c&7]()}k[c+16>>2]=k[e>>2];SIa(c+20|0,g+20|0);e=k[l>>2]|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=e;k[f>>2]=c;e=k[k[n>>2]>>2]|0;if(e){k[n>>2]=e;c=k[f>>2]|0}B4(k[j>>2]|0,c);k[h>>2]=(k[h>>2]|0)+1}c=k[d+4>>2]|0;if(!c)while(1){c=k[d+8>>2]|0;if((k[c>>2]|0)==(d|0))break;else d=c}else while(1){d=k[c>>2]|0;if(!d)break;else c=d}if((c|0)==(i|0))break;else{g=c;d=c}}k[a+24>>2]=k[b+24>>2]}s4(a+28|0,k[b+28>>2]|0,k[b+32>>2]|0);k[a+40>>2]=k[b+40>>2];k[a+44>>2]=k[b+44>>2];if(m){r=p;return}s4(a+48|0,k[b+48>>2]|0,k[b+52>>2]|0);r=p;return}function PIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+16|0;i=l+4|0;j=l;k[j>>2]=b;uIa();switch(k[a+24>>2]|0){case 0:{c=k[a>>2]|0;d=c+16|0;e=k[d>>2]|0;if((e|0)==(k[c+20>>2]|0)){P4(c+12|0,j);r=l;return}else{k[e>>2]=b;k[d>>2]=e+4;r=l;return}}case 1:{g=k[a+28>>2]|0;k[g>>2]=k[g>>2]|2;g=a+12|0;d=a+16|0;c=k[d>>2]|0;do if(c){while(1){d=k[c+16>>2]|0;if(d>>>0>1){d=k[c>>2]|0;if(!d){h=8;break}else c=d}else{if(d|0){h=14;break}e=c+4|0;d=k[e>>2]|0;if(!d){h=12;break}else c=d}}if((h|0)==8){k[i>>2]=c;f=c;d=c;h=15;break}else if((h|0)==12){k[i>>2]=c;f=c;d=e;h=15;break}else if((h|0)==14){k[i>>2]=c;if(!c){f=c;d=i;h=15;break}else{e=c;break}}}else{k[i>>2]=d;f=d;h=15}while(0);if((h|0)==15){while(1){e=fgb(32)|0;if(e|0)break;i=k[207666]|0;k[207666]=i+0;Qh[i&7]()}k[e+16>>2]=1;k[e+20>>2]=0;k[e+24>>2]=0;k[e+28>>2]=0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=f;k[d>>2]=e;c=k[k[g>>2]>>2]|0;if(!c)c=e;else{k[g>>2]=c;c=k[d>>2]|0}B4(k[a+16>>2]|0,c);a=a+20|0;k[a>>2]=(k[a>>2]|0)+1}c=e+24|0;d=k[c>>2]|0;if((d|0)==(k[e+28>>2]|0)){P4(e+20|0,j);r=l;return}else{k[d>>2]=k[j>>2];k[c>>2]=d+4;r=l;return}}case 2:{g=a+12|0;d=a+16|0;c=k[d>>2]|0;do if(c){while(1){d=k[c+16>>2]|0;if(d>>>0>1){d=k[c>>2]|0;if(!d){h=27;break}else c=d}else{if(d|0){h=33;break}e=c+4|0;d=k[e>>2]|0;if(!d){h=31;break}else c=d}}if((h|0)==27){k[i>>2]=c;f=c;d=c;h=34;break}else if((h|0)==31){k[i>>2]=c;f=c;d=e;h=34;break}else if((h|0)==33){k[i>>2]=c;if(!c){f=c;d=i;h=34;break}else{e=c;break}}}else{k[i>>2]=d;f=d;h=34}while(0);if((h|0)==34){while(1){e=fgb(32)|0;if(e|0)break;i=k[207666]|0;k[207666]=i+0;Qh[i&7]()}k[e+16>>2]=1;k[e+20>>2]=0;k[e+24>>2]=0;k[e+28>>2]=0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=f;k[d>>2]=e;c=k[k[g>>2]>>2]|0;if(!c)c=e;else{k[g>>2]=c;c=k[d>>2]|0}B4(k[a+16>>2]|0,c);a=a+20|0;k[a>>2]=(k[a>>2]|0)+1}c=e+24|0;d=k[c>>2]|0;if((d|0)==(k[e+28>>2]|0)){P4(e+20|0,j);r=l;return}else{k[d>>2]=b;k[c>>2]=d+4;r=l;return}}default:{r=l;return}}}function QIa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;b=a+24|0;if(!(k[b>>2]|0))return;l=a+12|0;j=a+20|0;c=k[j>>2]|0;d=k[a+44>>2]|0;e=1<<d;if(c>>>0>e>>>1>>>0){k[b>>2]=0;g=a+4|0;d=k[g>>2]|0;c=k[a>>2]|0;b=(d-c|0)/12|0;if(e>>>0<=b>>>0){if(e>>>0<b>>>0?(h=c+(e*12|0)|0,(d|0)!=(h|0)):0)while(1){b=d+-12|0;k[g>>2]=b;e=k[b>>2]|0;f=e;if(e){b=d+-8|0;c=k[b>>2]|0;if((c|0)!=(e|0))k[b>>2]=c+(~((c+-4-f|0)>>>2)<<2);ggb(e);b=k[g>>2]|0}if((b|0)==(h|0))break;else d=b}}else RIa(a,e-b|0);c=k[l>>2]|0;f=a+16|0;b=c;if((b|0)!=(f|0))while(1){d=(k[a>>2]|0)+((k[b+16>>2]|0)*12|0)|0;e=b+20|0;if((d|0)!=(e|0))s4(d,k[e>>2]|0,k[b+24>>2]|0);b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}gIa(k[f>>2]|0);k[j>>2]=0;k[l>>2]=f;k[f>>2]=0;return}j=((k[a+4>>2]|0)-(k[a>>2]|0)|0)/12|0;if(!(d>>>0<33?1:((((c>>>0<j>>>0?j:c)*96|0)>>>0)/10|0)>>>0>=e>>>0)){k[b>>2]=2;c=k[a+28>>2]|0;b=(k[a+32>>2]|0)-c|0;if((b|0)<=0)return;a=b>>2;zpb(c|0,0,((((a|0)<1?a:1)^1073741823)+a<<2)+8|0)|0;return}k[b>>2]=1;j=a+28|0;k[a+40>>2]=e;d=(e>>>5)+1|0;h=a+32|0;b=k[h>>2]|0;c=k[j>>2]|0;e=b-c>>2;f=c;g=b;if(d>>>0<=e>>>0){if(d>>>0<e>>>0?(i=f+(d<<2)|0,(g|0)!=(i|0)):0){b=g+(~((g+-4-i|0)>>>2)<<2)|0;k[h>>2]=b}}else{r4(j,d-e|0);c=k[j>>2]|0;b=k[h>>2]|0}b=b-c|0;if((b|0)>0){i=b>>2;zpb(c|0,0,((((i|0)<1?i:1)^1073741823)+i<<2)+8|0)|0}c=k[l>>2]|0;e=a+16|0;b=c;if((b|0)==(e|0))return;d=k[j>>2]|0;while(1){a=k[b+16>>2]|0;b=d+(a>>>5<<2)|0;k[b>>2]=k[b>>2]|1<<(a&31);b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(e|0))break;else c=b}return}function RIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+8|0;f=k[l>>2]|0;m=a+4|0;i=k[m>>2]|0;e=i;if(((f-i|0)/12|0)>>>0>=b>>>0){zpb(i|0,0,b*12|0)|0;k[m>>2]=e+(b*12|0);return}c=k[a>>2]|0;h=(i-c|0)/12|0;d=h+b|0;if(d>>>0>357913941)ad(426534,426557,304,426811);j=c;f=(f-c|0)/12|0;g=f<<1;g=f>>>0<178956970?(g>>>0<d>>>0?d:g):357913941;if(!g)f=0;else{if(g>>>0>357913941){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=g*12|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}f=c}c=f+(h*12|0)|0;d=c;g=f+(g*12|0)|0;zpb(c|0,0,b*12|0)|0;f=c+(b*12|0)|0;if((e|0)!=(j|0)){do{e=e+-12|0;SIa(c+-12|0,e);c=d+-12|0;d=c}while((e|0)!=(j|0));i=k[a>>2]|0;e=k[m>>2]|0}k[a>>2]=d;k[m>>2]=f;k[l>>2]=g;h=i;if((e|0)!=(h|0))do{c=e;e=e+-12|0;f=k[e>>2]|0;g=f;if(f|0){c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(f|0))k[c>>2]=d+(~((d+-4-g|0)>>>2)<<2);ggb(f)}}while((e|0)!=(h|0));if(!i)return;ggb(i);return}function SIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;k[a>>2]=0;h=a+4|0;k[h>>2]=0;k[a+8>>2]=0;g=b+4|0;c=(k[g>>2]|0)-(k[b>>2]|0)|0;f=c>>2;if(!f)return;if(f>>>0>1073741823)ad(426534,426557,304,426811);d=(c|0)==0?1:c;while(1){c=fgb(d)|0;if(c|0){e=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){e=0;break}Qh[c&7]()}k[h>>2]=e;k[a>>2]=e;k[a+8>>2]=e+(f<<2);d=k[b>>2]|0;c=(k[g>>2]|0)-d|0;if((c|0)<=0)return;upb(e|0,d|0,c|0)|0;k[h>>2]=e+(c>>2<<2);return}function TIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=(c-b|0)/12|0;l=a+8|0;d=k[l>>2]|0;f=k[a>>2]|0;e=f;if(j>>>0<=((d-f|0)/12|0)>>>0){h=a+4|0;d=((k[h>>2]|0)-f|0)/12|0;g=j>>>0>d>>>0;d=b+(d*12|0)|0;f=g?d:c;if((f|0)!=(b|0))do{if((e|0)!=(b|0))s4(e,k[b>>2]|0,k[b+4>>2]|0);b=b+12|0;e=e+12|0}while((b|0)!=(f|0));if(g){if((f|0)==(c|0))return;b=k[h>>2]|0;do{SIa(b,d);d=d+12|0;b=(k[h>>2]|0)+12|0;k[h>>2]=b}while((d|0)!=(c|0));return}d=k[h>>2]|0;if((d|0)==(e|0))return;do{b=d+-12|0;k[h>>2]=b;f=k[b>>2]|0;g=f;if(!f)d=b;else{d=d+-8|0;b=k[d>>2]|0;if((b|0)!=(f|0))k[d>>2]=b+(~((b+-4-g|0)>>>2)<<2);ggb(f);d=k[h>>2]|0}}while((d|0)!=(e|0));return}if(f){i=a+4|0;d=k[i>>2]|0;if((d|0)==(e|0))d=f;else{f=d;while(1){d=f+-12|0;k[i>>2]=d;g=k[d>>2]|0;h=g;if(g){d=f+-8|0;f=k[d>>2]|0;if((f|0)!=(g|0))k[d>>2]=f+(~((f+-4-h|0)>>>2)<<2);ggb(g);d=k[i>>2]|0}if((d|0)==(e|0))break;else f=d}d=k[a>>2]|0}ggb(d);k[l>>2]=0;k[i>>2]=0;k[a>>2]=0;d=0}if(j>>>0>357913941)ad(426534,426557,304,426811);i=(d|0)/12|0;f=i<<1;f=i>>>0<178956970?(f>>>0<j>>>0?j:f):357913941;if(f>>>0>357913941)bob();e=f*12|0;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=a+4|0;k[e>>2]=d;k[a>>2]=d;k[l>>2]=d+(f*12|0);if((b|0)==(c|0))return;do{SIa(d,b);b=b+12|0;d=(k[e>>2]|0)+12|0;k[e>>2]=d}while((b|0)!=(c|0));return}function UIa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;h=a+4|0;e=b;if((h|0)!=(b|0)?(g=k[d>>2]|0,f=k[b+16>>2]|0,g>>>0>=f>>>0):0){if(f>>>0>=g>>>0){k[c>>2]=e;return c|0}a=b+4|0;e=k[a>>2]|0;d=(e|0)==0;if(d){f=b;while(1){e=k[f+8>>2]|0;if((k[e>>2]|0)==(f|0))break;else f=e}}else while(1){f=k[e>>2]|0;if(!f)break;else e=f}if((e|0)!=(h|0)?g>>>0>=(k[e+16>>2]|0)>>>0:0){e=k[h>>2]|0;if(!e){k[c>>2]=h;c=h;return c|0}while(1){f=k[e+16>>2]|0;if(g>>>0<f>>>0){f=k[e>>2]|0;if(!f){f=33;break}else e=f}else{if(f>>>0>=g>>>0){f=38;break}a=e+4|0;f=k[a>>2]|0;if(!f){f=37;break}else e=f}}if((f|0)==33){k[c>>2]=e;c=e;return c|0}else if((f|0)==37){k[c>>2]=e;c=a;return c|0}else if((f|0)==38){k[c>>2]=e;return c|0}}if(d){k[c>>2]=b;c=a;return c|0}else{k[c>>2]=e;c=e;return c|0}}g=k[b>>2]|0;if((k[a>>2]|0)!=(b|0)){if(!g){f=b;while(1){e=k[f+8>>2]|0;if((k[e>>2]|0)==(f|0))f=e;else break}}else{e=g;while(1){f=k[e+4>>2]|0;if(!f)break;else e=f}}d=k[d>>2]|0;if((k[e+16>>2]|0)>>>0>=d>>>0){e=k[h>>2]|0;if(!e){k[c>>2]=h;c=h;return c|0}while(1){f=k[e+16>>2]|0;if(d>>>0<f>>>0){f=k[e>>2]|0;if(!f){f=14;break}else e=f}else{if(f>>>0>=d>>>0){f=19;break}a=e+4|0;f=k[a>>2]|0;if(!f){f=18;break}else e=f}}if((f|0)==14){k[c>>2]=e;c=e;return c|0}else if((f|0)==18){k[c>>2]=e;c=a;return c|0}else if((f|0)==19){k[c>>2]=e;return c|0}}}if(!g){k[c>>2]=b;c=b;return c|0}else{h=e;k[c>>2]=h;c=h+4|0;return c|0}return 0}function VIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;k[a>>2]=0;g=a+4|0;k[g>>2]=0;k[a+8>>2]=0;f=b+4|0;d=(k[f>>2]|0)-(k[b>>2]|0)|0;e=(d|0)/12|0;if(!d)return;if(e>>>0>357913941)ad(426534,426557,304,426811);while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[g>>2]=c;k[a>>2]=c;k[a+8>>2]=c+(e*12|0);d=k[b>>2]|0;a=k[f>>2]|0;if((d|0)==(a|0))return;do{SIa(c,d);d=d+12|0;c=(k[g>>2]|0)+12|0;k[g>>2]=c}while((d|0)!=(a|0));return}function WIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=a+4|0;a=k[l>>2]|0;if(!a){c=k[c>>2]|0;return c|0}e=(b|0)==0?1016759:b;j=l;d=a;a:while(1){a=d;while(1){d=k[a+16>>2]|0;if((d|0)==(b|0))break;g=(d|0)==0?1016759:d;d=i[g>>0]|0;f=i[e>>0]|0;if(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24)){h=e;do{g=g+1|0;h=h+1|0;d=i[g>>0]|0;f=i[h>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24))}if((d&255)>=(f&255))break;a=k[a+4>>2]|0;if(!a){g=j;break a}}d=k[a>>2]|0;if(!d){g=a;break}else j=a}if((g|0)==(l|0)){c=k[c>>2]|0;return c|0}a=k[g+16>>2]|0;if((a|0)!=(b|0)){d=(a|0)==0?1016759:a;a=i[e>>0]|0;f=i[d>>0]|0;if(a<<24>>24==0?1:a<<24>>24!=f<<24>>24)d=f;else{do{e=e+1|0;d=d+1|0;a=i[e>>0]|0;f=i[d>>0]|0}while(!(a<<24>>24==0?1:a<<24>>24!=f<<24>>24));d=f}if((a&255)<(d&255)){c=k[c>>2]|0;return c|0}}a=g+24|0;c=k[a>>2]|0;c=(Xh[k[(k[c>>2]|0)+28>>2]&1023](c)|0)+4|0;if((k[c>>2]|0)!=207742)Cf(te(1)|0,19736,0);c=k[a>>2]|0;c=Hh[k[(k[c>>2]|0)+20>>2]&511](c,g+28|0)|0;c=k[c>>2]|0;return c|0}function XIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0;G=r;r=r+32|0;F=G;$Ia(F,d);a:do if((b|0)>0){E=F+16|0;g=k[F>>2]|0;C=a+24|0;D=a+20|0;B=a+16|0;A=k[F+12>>2]|0;a=k[E>>2]|0;d=0;b:while(1){y=e+(d<<2)|0;z=(d|0)>0;if((a|0)==(A|0)){l=23;break a}while(1){h=a;a=a+1|0;h=k[g+(h<<2)>>2]|0;if((h|0)<0){l=6;break b}h=k[c+(h<<2)>>2]|0;k[y>>2]=h;if(!z)break;w=k[C>>2]|0;x=k[D>>2]|0;p=w+((aa(x,h)|0)<<2)|0;t=p+(k[B>>2]<<2)|0;q=t+-12|0;u=((q>>>0<p>>>0?p:q)+12+(3-p)|0)>>>4<<2;v=p+(u<<2)|0;s=v>>>0<t>>>0;if(p>>>0>=q>>>0){if(s){m=0;h=0;do{i=w+((aa(k[e+(m<<2)>>2]|0,x)|0)<<2)+(u<<2)|0;j=0.0;l=v;while(1){s=l;l=l+4|0;j=j+ +P(+(+o[s>>2]-+o[i>>2]));if(l>>>0>=t>>>0)break;else i=i+4|0}h=j<1.0e-16?1:h;m=m+1|0}while((m|0)!=(d|0));i=h;l=19}}else{n=0;h=0;do{m=w+((aa(k[e+(n<<2)>>2]|0,x)|0)<<2)|0;i=p;l=m;j=0.0;while(1){J=+P(+(+o[i>>2]-+o[l>>2]));I=+P(+(+o[i+4>>2]-+o[l+4>>2]));H=+P(+(+o[i+8>>2]-+o[l+8>>2]));j=j+(J+I+H+ +P(+(+o[i+12>>2]-+o[l+12>>2])));i=i+16|0;if(i>>>0>=q>>>0)break;else l=l+16|0}if(s){l=m+(u<<2)|0;i=v;while(1){j=j+ +P(+(+o[i>>2]-+o[l>>2]));i=i+4|0;if(i>>>0>=t>>>0)break;else l=l+4|0}}h=j<1.0e-16?1:h;n=n+1|0}while((n|0)!=(d|0));i=h;l=19}if((l|0)==19?(l=0,(i&1)==0):0)break;if((a|0)==(A|0)){l=22;break b}}k[E>>2]=a;d=d+1|0;if((d|0)>=(b|0)){l=23;break a}}if((l|0)==6){k[E>>2]=a;k[f>>2]=d;break}else if((l|0)==22){k[E>>2]=A;l=23;break}}else{d=0;g=k[F>>2]|0;l=23}while(0);if((l|0)==23){k[f>>2]=d;if(!g){r=G;return}}d=F+4|0;a=k[d>>2]|0;if((a|0)!=(g|0))k[d>>2]=a+(~((a+-4-g|0)>>>2)<<2);ggb(g);r=G;return}function YIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0.0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,O=0.0;J=428e3;J=Epb(k[J>>2]|0,k[J+4>>2]|0,1284865837,1481765933)|0;J=kpb(J|0,N|0,1,0)|0;K=N;I=428e3;k[I>>2]=J;k[I+4>>2]=K;K=ppb(J|0,K|0,33)|0;k[e>>2]=k[c+(~~(+(d|0)*(+(K|0)*4.656612873077393e-10))<<2)>>2];if((b|0)<=1){e=1;k[f>>2]=e;return}I=(d|0)>0;J=a+24|0;K=a+20|0;H=a+16|0;a=1;while(1){if(!I){a=1;g=18;break}w=k[J>>2]|0;x=k[K>>2]|0;y=w+((aa(x,k[e>>2]|0)|0)<<2)|0;z=k[H>>2]|0;A=y+(z<<2)|0;B=A+-12|0;C=((B>>>0<y>>>0?y:B)+12+(3-y)|0)>>>4<<2;D=y>>>0<B>>>0;G=y+(C<<2)|0;E=G>>>0<A>>>0;F=(a|0)>1;t=0;u=0.0;v=-1;while(1){s=w+((aa(k[c+(t<<2)>>2]|0,x)|0)<<2)|0;l=s+(C<<2)|0;if(D){g=y;j=s;h=0.0;while(1){M=+P(+(+o[g>>2]-+o[j>>2]));L=+P(+(+o[g+4>>2]-+o[j+4>>2]));i=+P(+(+o[g+8>>2]-+o[j+8>>2]));h=h+(M+L+i+ +P(+(+o[g+12>>2]-+o[j+12>>2])));g=g+16|0;if(g>>>0>=B>>>0)break;else j=j+16|0}}else h=0.0;if(E){j=l;g=G;while(1){h=h+ +P(+(+o[g>>2]-+o[j>>2]));g=g+4|0;if(g>>>0>=A>>>0)break;else j=j+4|0}}if(F){r=1;do{p=w+((aa(x,k[e+(r<<2)>>2]|0)|0)<<2)|0;q=p+(z<<2)|0;m=q+-12|0;n=((m>>>0<p>>>0?p:m)+12+(3-p)|0)>>>4<<2;j=s+(n<<2)|0;if(p>>>0<m>>>0){g=p;l=s;i=0.0;while(1){O=+P(+(+o[g>>2]-+o[l>>2]));L=+P(+(+o[g+4>>2]-+o[l+4>>2]));M=+P(+(+o[g+8>>2]-+o[l+8>>2]));i=i+(O+L+M+ +P(+(+o[g+12>>2]-+o[l+12>>2])));g=g+16|0;if(g>>>0>=m>>>0)break;else l=l+16|0}}else i=0.0;g=p+(n<<2)|0;if(g>>>0<q>>>0)while(1){i=i+ +P(+(+o[g>>2]-+o[j>>2]));g=g+4|0;if(g>>>0>=q>>>0)break;else j=j+4|0}h=i<h?i:h;r=r+1|0}while((r|0)!=(a|0))}g=h>u;v=g?t:v;t=t+1|0;if((t|0)==(d|0))break;else u=g?h:u}if((v|0)==-1){g=18;break}k[e+(a<<2)>>2]=k[c+(v<<2)>>2];a=a+1|0;if((a|0)>=(b|0)){g=18;break}}if((g|0)==18){k[f>>2]=a;return}}function ZIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0.0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,O=0.0;K=r;r=r+16|0;J=K;h=d>>>0>1073741823?-1:d<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}y=428e3;y=Epb(k[y>>2]|0,k[y+4>>2]|0,1284865837,1481765933)|0;y=kpb(y|0,N|0,1,0)|0;z=N;h=428e3;k[h>>2]=y;k[h+4>>2]=z;h=ppb(y|0,z|0,33)|0;h=c+(~~(+(d|0)*(+(h|0)*4.656612873077393e-10))<<2)|0;k[e>>2]=k[h>>2];I=(d|0)>0;if(I){w=k[a+24>>2]|0;x=k[a+20>>2]|0;u=w+((aa(k[h>>2]|0,x)|0)<<2)|0;v=k[a+16>>2]|0;t=0;i=0.0;do{p=w+((aa(x,k[c+(t<<2)>>2]|0)|0)<<2)|0;s=p+(v<<2)|0;n=s+-12|0;q=((n>>>0<p>>>0?p:n)+12+(3-p)|0)>>>4<<2;l=u+(q<<2)|0;if(p>>>0<n>>>0){h=p;m=u;j=0.0;while(1){O=+P(+(+o[h>>2]-+o[m>>2]));M=+P(+(+o[h+4>>2]-+o[m+4>>2]));L=+P(+(+o[h+8>>2]-+o[m+8>>2]));j=j+(O+M+L+ +P(+(+o[h+12>>2]-+o[m+12>>2])));h=h+16|0;if(h>>>0>=n>>>0)break;else m=m+16|0}}else j=0.0;h=p+(q<<2)|0;if(h>>>0<s>>>0)while(1){j=j+ +P(+(+o[h>>2]-+o[l>>2]));h=h+4|0;if(h>>>0>=s>>>0)break;else l=l+4|0}O=j*j;o[g+(t<<2)>>2]=O;i=i+O;t=t+1|0}while((t|0)!=(d|0))}else i=0.0;if((b|0)<=1){J=1;k[f>>2]=J;ggb(g);r=K;return}E=d+-1|0;F=(d|0)>1;G=a+24|0;H=a+20|0;D=a+16|0;C=1;B=y;do{y=Epb(B|0,z|0,1284865837,1481765933)|0;B=kpb(y|0,N|0,1,0)|0;z=N;a:do if(F){y=ppb(B|0,z|0,33)|0;h=0;i=i*(+(y|0)*4.656612873077393e-10)+0.0;while(1){j=+o[g+(h<<2)>>2];if(i<=j)break;h=h+1|0;if((h|0)<(E|0))i=i-j;else break}if(!I){k[e+(C<<2)>>2]=k[c+(h<<2)>>2];i=0.0;break}y=k[G>>2]|0;w=k[H>>2]|0;l=k[c+(h<<2)>>2]|0;a=y+((aa(l,w)|0)<<2)|0;x=k[D>>2]|0;v=0;i=0.0;do{s=y+((aa(w,k[c+(v<<2)>>2]|0)|0)<<2)|0;u=s+(x<<2)|0;q=u+-12|0;t=((q>>>0<s>>>0?s:q)+12+(3-s)|0)>>>4<<2;n=a+(t<<2)|0;if(s>>>0<q>>>0){m=s;p=a;j=0.0;while(1){L=+P(+(+o[m>>2]-+o[p>>2]));M=+P(+(+o[m+4>>2]-+o[p+4>>2]));O=+P(+(+o[m+8>>2]-+o[p+8>>2]));j=j+(L+M+O+ +P(+(+o[m+12>>2]-+o[p+12>>2])));m=m+16|0;if(m>>>0>=q>>>0)break;else p=p+16|0}}else j=0.0;m=s+(t<<2)|0;if(m>>>0<u>>>0)while(1){j=j+ +P(+(+o[m>>2]-+o[n>>2]));m=m+4|0;if(m>>>0>=u>>>0)break;else n=n+4|0}O=j*j;M=+o[g+(v<<2)>>2];i=i+(M<O?M:O);v=v+1|0}while((v|0)!=(d|0));x=y;A=28}else{if(!I){k[e+(C<<2)>>2]=k[c>>2];i=0.0;break}x=k[G>>2]|0;v=k[H>>2]|0;l=k[c>>2]|0;w=x+((aa(l,v)|0)<<2)|0;a=k[D>>2]|0;u=0;i=0.0;h=l;while(1){q=x+((aa(v,h)|0)<<2)|0;t=q+(a<<2)|0;p=t+-12|0;s=((p>>>0<q>>>0?q:p)+12+(3-q)|0)>>>4<<2;m=w+(s<<2)|0;if(q>>>0<p>>>0){h=q;n=w;j=0.0;while(1){L=+P(+(+o[h>>2]-+o[n>>2]));M=+P(+(+o[h+4>>2]-+o[n+4>>2]));O=+P(+(+o[h+8>>2]-+o[n+8>>2]));j=j+(L+M+O+ +P(+(+o[h+12>>2]-+o[n+12>>2])));h=h+16|0;if(h>>>0>=p>>>0)break;else n=n+16|0}}else j=0.0;h=q+(s<<2)|0;if(h>>>0<t>>>0)while(1){j=j+ +P(+(+o[h>>2]-+o[m>>2]));h=h+4|0;if(h>>>0>=t>>>0)break;else m=m+4|0}O=j*j;M=+o[g+(u<<2)>>2];i=i+(M<O?M:O);h=u+1|0;if((h|0)==(d|0)){h=0;A=28;break a}u=h;h=k[c+(h<<2)>>2]|0}}while(0);if((A|0)==28){A=0;k[e+(C<<2)>>2]=l;if(I){w=k[H>>2]|0;u=x+((aa(k[c+(h<<2)>>2]|0,w)|0)<<2)|0;v=k[D>>2]|0;t=0;do{p=x+((aa(w,k[c+(t<<2)>>2]|0)|0)<<2)|0;s=p+(v<<2)|0;n=s+-12|0;q=((n>>>0<p>>>0?p:n)+12+(3-p)|0)>>>4<<2;l=u+(q<<2)|0;if(p>>>0<n>>>0){h=p;m=u;j=0.0;while(1){L=+P(+(+o[h>>2]-+o[m>>2]));M=+P(+(+o[h+4>>2]-+o[m+4>>2]));O=+P(+(+o[h+8>>2]-+o[m+8>>2]));j=j+(L+M+O+ +P(+(+o[h+12>>2]-+o[m+12>>2])));h=h+16|0;if(h>>>0>=n>>>0)break;else m=m+16|0}}else j=0.0;h=p+(q<<2)|0;if(h>>>0<s>>>0)while(1){j=j+ +P(+(+o[h>>2]-+o[l>>2]));h=h+4|0;if(h>>>0>=s>>>0)break;else l=l+4|0}O=j*j;o[J>>2]=O;y=g+(t<<2)|0;k[y>>2]=k[(+o[y>>2]<O?y:J)>>2];t=t+1|0}while((t|0)!=(d|0))}}C=C+1|0}while((C|0)!=(b|0));J=428e3;k[J>>2]=B;k[J+4>>2]=z;J=b;k[f>>2]=J;ggb(g);r=K;return}function _Ia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0.0,j=0.0,l=0,m=0,n=0,p=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0;I=r;r=r+16|0;H=I;h=d>>>0>1073741823?-1:d<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}G=428e3;G=Epb(k[G>>2]|0,k[G+4>>2]|0,1284865837,1481765933)|0;G=kpb(G|0,N|0,1,0)|0;h=N;F=428e3;k[F>>2]=G;k[F+4>>2]=h;h=ppb(G|0,h|0,33)|0;h=c+(~~(+(d|0)*(+(h|0)*4.656612873077393e-10))<<2)|0;k[e>>2]=k[h>>2];G=(d|0)>0;if(G){x=k[a+24>>2]|0;y=k[a+20>>2]|0;v=x+((aa(k[h>>2]|0,y)|0)<<2)|0;w=k[a+16>>2]|0;u=0;do{q=x+((aa(y,k[c+(u<<2)>>2]|0)|0)<<2)|0;t=q+(w<<2)|0;n=t+-12|0;s=((n>>>0<q>>>0?q:n)+12+(3-q)|0)>>>4<<2;l=v+(s<<2)|0;if(q>>>0<n>>>0){h=q;m=v;i=0.0;while(1){p=+P(+(+o[h>>2]-+o[m>>2]));z=+P(+(+o[h+4>>2]-+o[m+4>>2]));A=+P(+(+o[h+8>>2]-+o[m+8>>2]));i=i+(p+z+A+ +P(+(+o[h+12>>2]-+o[m+12>>2])));h=h+16|0;if(h>>>0>=n>>>0)break;else m=m+16|0}}else i=0.0;h=q+(s<<2)|0;if(h>>>0<t>>>0)while(1){i=i+ +P(+(+o[h>>2]-+o[l>>2]));h=h+4|0;if(h>>>0>=t>>>0)break;else l=l+4|0}o[g+(u<<2)>>2]=i;u=u+1|0}while((u|0)!=(d|0))}if((b|0)<=1){H=1;k[f>>2]=H;ggb(g);r=I;return}E=a+24|0;F=a+20|0;D=a+16|0;C=1;do{if(G){j=0.0;h=0;i=-1.0;B=0;do{z=+o[g+(B<<2)>>2];if(z>j*1.2999999523162842){x=k[E>>2]|0;w=k[F>>2]|0;a=x+((aa(k[c+(B<<2)>>2]|0,w)|0)<<2)|0;y=k[D>>2]|0;v=0;A=0.0;do{s=x+((aa(w,k[c+(v<<2)>>2]|0)|0)<<2)|0;u=s+(y<<2)|0;q=u+-12|0;t=((q>>>0<s>>>0?s:q)+12+(3-s)|0)>>>4<<2;m=a+(t<<2)|0;if(s>>>0<q>>>0){l=s;n=a;p=0.0;while(1){L=+P(+(+o[l>>2]-+o[n>>2]));K=+P(+(+o[l+4>>2]-+o[n+4>>2]));J=+P(+(+o[l+8>>2]-+o[n+8>>2]));p=p+(L+K+J+ +P(+(+o[l+12>>2]-+o[n+12>>2])));l=l+16|0;if(l>>>0>=q>>>0)break;else n=n+16|0}}else p=0.0;l=s+(t<<2)|0;if(l>>>0<u>>>0)while(1){p=p+ +P(+(+o[l>>2]-+o[m>>2]));l=l+4|0;if(l>>>0>=u>>>0)break;else m=m+4|0}L=+o[g+(v<<2)>>2];A=A+(L<p?L:p);v=v+1|0}while((v|0)!=(d|0));a=!(i<0.0)&!(A<=i);j=a?j:z;h=a?h:B;i=a?i:A}B=B+1|0}while((B|0)!=(d|0));x=c+(h<<2)|0;k[e+(C<<2)>>2]=k[x>>2];v=k[E>>2]|0;w=k[F>>2]|0;x=v+((aa(k[x>>2]|0,w)|0)<<2)|0;y=k[D>>2]|0;u=0;do{q=v+((aa(w,k[c+(u<<2)>>2]|0)|0)<<2)|0;t=q+(y<<2)|0;n=t+-12|0;s=((n>>>0<q>>>0?q:n)+12+(3-q)|0)>>>4<<2;l=x+(s<<2)|0;if(q>>>0<n>>>0){h=q;m=x;i=0.0;while(1){J=+P(+(+o[h>>2]-+o[m>>2]));K=+P(+(+o[h+4>>2]-+o[m+4>>2]));L=+P(+(+o[h+8>>2]-+o[m+8>>2]));i=i+(J+K+L+ +P(+(+o[h+12>>2]-+o[m+12>>2])));h=h+16|0;if(h>>>0>=n>>>0)break;else m=m+16|0}}else i=0.0;h=q+(s<<2)|0;if(h>>>0<t>>>0)while(1){i=i+ +P(+(+o[h>>2]-+o[l>>2]));h=h+4|0;if(h>>>0>=t>>>0)break;else l=l+4|0}o[H>>2]=i;B=g+(u<<2)|0;k[B>>2]=k[(+o[B>>2]<i?B:H)>>2];u=u+1|0}while((u|0)!=(d|0))}else k[e+(C<<2)>>2]=k[c>>2];C=C+1|0}while((C|0)!=(b|0));k[f>>2]=b;ggb(g);r=I;return}function $Ia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;k[a>>2]=0;e=a+4|0;k[e>>2]=0;k[a+8>>2]=0;if(b){U1(a,b);c=k[a>>2]|0;d=a+12|0;k[d>>2]=b;if((b|0)>0){b=0;do{k[c+(b<<2)>>2]=b;b=b+1|0}while((b|0)<(k[d>>2]|0))}}else{k[a+12>>2]=0;c=0}aJa(c,k[e>>2]|0);k[a+16>>2]=0;return}function aJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=b-a|0;if((c|0)<=4)return;mpb(827696)|0;k[206923]=1;f=b+-4|0;if(f>>>0>a>>>0){e=c>>2;do{c=e;e=e+-1|0;if(e|0){if(!c)b=Sgb()|0;else{b=32-(da(c|0)|0)|0;b=(((-1>>>(33-b|0)&c|0)==0)<<31>>31)+b|0;d=((b&31|0)!=0&1)+(b>>>5)|0;d=d>>>0>b>>>0?0:-1>>>(32-((b>>>0)/(d>>>0)|0)|0);do b=(Sgb()|0)&d;while(b>>>0>=c>>>0)}if(b|0){d=a+(b<<2)|0;c=k[a>>2]|0;k[a>>2]=k[d>>2];k[d>>2]=c}}a=a+4|0}while(a>>>0<f>>>0)}k[206923]=0;lpb(827696)|0;return}function bJa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;k[a>>2]=93436;f=a+52|0;d=k[f>>2]|0;a:do if(d|0?(e=a+92|0,c=k[e>>2]|0,(c|0)>0):0){b=0;while(1){d=k[d+(b<<2)>>2]|0;if(d){ggb(d);k[(k[f>>2]|0)+(b<<2)>>2]=0;c=k[e>>2]|0}b=b+1|0;if((b|0)>=(c|0))break a;d=k[f>>2]|0}}while(0);b=k[a+48>>2]|0;if(b|0)ggb(b);b=k[f>>2]|0;if(b|0)ggb(b);c=a+64|0;b=k[c>>2]|0;if(b|0)do{f=b;b=k[b>>2]|0;ggb(f);k[c>>2]=b}while((b|0)!=0);YHa(k[a+32>>2]|0);return}function cJa(a){a=a|0;bJa(a);ggb(a);return}function dJa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;p=a+88|0;if((k[p>>2]|0)<2){r=te(44)|0;VHa(r,373858);Cf(r|0,19720,57)}q=a+52|0;d=k[q>>2]|0;o=a+92|0;b=k[o>>2]|0;a:do if(d){if((b|0)>0)c=0;else return;while(1){d=k[d+(c<<2)>>2]|0;if(d){ggb(d);k[(k[q>>2]|0)+(c<<2)>>2]=0;b=k[o>>2]|0}c=c+1|0;if((c|0)>=(b|0))break a;d=k[q>>2]|0}}while(0);if((b|0)<=0)return;f=a+40|0;g=a+60|0;h=a+80|0;j=a+64|0;l=a+68|0;m=a+48|0;n=a+76|0;e=0;do{d=k[f>>2]|0;c=d>>>0>1073741823?-1:d<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[(k[q>>2]|0)+(e<<2)>>2]=b;if(!d)b=0;else{d=k[(k[q>>2]|0)+(e<<2)>>2]|0;c=0;do{k[d+(c<<2)>>2]=c;c=c+1|0;b=k[f>>2]|0}while(c>>>0<b>>>0)}d=k[g>>2]|0;do if((d|0)<32){k[h>>2]=(k[h>>2]|0)+d;c=fgb(8192)|0;if(c|0){k[c>>2]=k[j>>2];k[j>>2]=c;k[g>>2]=8188;c=c+4|0;k[l>>2]=c;d=8188;r=46;break}b=k[41482]|0;c=(b|0)==0;b:do if((k[41497]|0)>-1){do if(c){b=i[165986]|0;i[165986]=b+255|b;b=k[41478]|0;if(!(b&8)){k[41480]=0;k[41479]=0;c=k[41489]|0;k[41485]=c;k[41483]=c;b=c+(k[41490]|0)|0;k[41482]=b;break}else{k[41478]=b|32;break b}}else c=k[41483]|0;while(0);if((b-c|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27)break;b=0;d=373857;c=k[41483]|0}else{b=27;d=373830}upb(c|0,d|0,b|0)|0;k[41483]=(k[41483]|0)+b}else{do if(c){b=i[165986]|0;i[165986]=b+255|b;b=k[41478]|0;if(!(b&8)){k[41480]=0;k[41479]=0;c=k[41489]|0;k[41485]=c;k[41483]=c;b=c+(k[41490]|0)|0;k[41482]=b;break}else{k[41478]=b|32;break b}}else c=k[41483]|0;while(0);if((b-c|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27)break;b=0;d=373857;c=k[41483]|0}else{b=27;d=373830}upb(c|0,d|0,b|0)|0;k[41483]=(k[41483]|0)+b}while(0);c=0;b=k[f>>2]|0}else{c=k[l>>2]|0;r=46}while(0);if((r|0)==46){r=0;k[l>>2]=c+32;k[g>>2]=d+-32;k[n>>2]=(k[n>>2]|0)+32}k[(k[m>>2]|0)+(e<<2)>>2]=c;qJa(a,k[(k[m>>2]|0)+(e<<2)>>2]|0,k[(k[q>>2]|0)+(e<<2)>>2]|0,b,k[p>>2]|0,0);e=e+1|0}while((e|0)<(k[o>>2]|0));return}function eJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=r;r=r+32|0;x=y;u=y+28|0;v=x+8|0;w=x+12|0;m=x+20|0;n=x+16|0;k[x>>2]=93396;k[x+24>>2]=e;p=x+4|0;k[m>>2]=0;k[w>>2]=n;k[n>>2]=0;o[v>>2]=3402823466385288598117041.0e14;i[p>>0]=0;if(!(k[b>>2]|0)){w=0;k[x>>2]=93356;wIa(w);r=y;return}q=b+12|0;s=b+8|0;t=c+12|0;j=c+8|0;l=d+12|0;h=d+8|0;g=0;c=0;do{wIa(c);k[m>>2]=0;k[w>>2]=n;k[n>>2]=0;o[v>>2]=3402823466385288598117041.0e14;i[p>>0]=0;c=(k[q>>2]|0)+((aa(k[s>>2]|0,g)|0)<<2)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,x,c,f);c=ZT(12)|0;k[c>>2]=1;d=c+4|0;i[c+10>>0]=0;i[d>>0]=i[373546]|0;i[d+1>>0]=i[373547]|0;i[d+2>>0]=i[373548]|0;i[d+3>>0]=i[373549]|0;i[d+4>>0]=i[373550]|0;i[d+5>>0]=i[373551]|0;i[u>>0]=1;d=xIa(f,d,u)|0;z=k[c>>2]|0;k[c>>2]=z+-1;if((z|0)==1)ggb(k[c+-4>>2]|0);c=k[x>>2]|0;if(d){d=(k[t>>2]|0)+((aa(k[j>>2]|0,g)|0)<<2)|0;z=(k[l>>2]|0)+((aa(k[h>>2]|0,g)|0)<<2)|0;dh[k[c+28>>2]&255](x,d,z,e)}else{d=(k[t>>2]|0)+((aa(k[j>>2]|0,g)|0)<<2)|0;z=(k[l>>2]|0)+((aa(k[h>>2]|0,g)|0)<<2)|0;dh[k[c+24>>2]&255](x,d,z,e)}g=g+1|0;c=k[n>>2]|0}while(g>>>0<(k[b>>2]|0)>>>0);k[x>>2]=93356;wIa(c);r=y;return}function fJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=a+88|0;y=b+76|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;x=i[c>>0]|0;i[c>>0]=x+255|x;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}b:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break b}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;x=i[c>>0]|0;i[c>>0]=x+255|x;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;x=k[b+44>>2]|0;k[b+28>>2]=x;g=b+20|0;k[g>>2]=x;d=x+(k[b+48>>2]|0)|0;k[e>>2]=d;e=x;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;d=c;g=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}c:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;d=h;break c}d=e+-1|0;if((i[h+d>>0]|0)==10)break;else e=d}if((ci[k[b+36>>2]&255](b,h,e)|0)>>>0<e>>>0)break a;f=4-e|0;d=h+e|0;c=k[g>>2]|0}else{f=4;d=h}while(0);upb(c|0,d|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f}while(0);x=a+92|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;d:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,x,4)|0;break}e:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=x;c=f;break e}c=d+-1|0;if((i[x+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,x,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=x+d|0;c=k[g>>2]|0}else{e=4;d=x;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,x,4)|0;break}f:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=x;c=f;break f}c=d+-1|0;if((i[x+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,x,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=x+d|0;c=k[g>>2]|0}else{e=4;d=x;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+96|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;g:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}h:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break h}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}i:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break i}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+100|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;j:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}k:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break k}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}l:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break l}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+84|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;m:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break m}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}n:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break n}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break m;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break m}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}o:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break o}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break m;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);if((k[x>>2]|0)<=0)return;j=a+52|0;l=a+40|0;m=a+48|0;n=b+16|0;o=b+74|0;p=b+8|0;q=b+4|0;r=b+44|0;s=b+28|0;t=b+20|0;u=b+48|0;v=b+36|0;w=b+75|0;h=0;do{d=k[(k[j>>2]|0)+(h<<2)>>2]|0;g=k[l>>2]<<2;c=k[n>>2]|0;e=(c|0)==0;p:do if((k[y>>2]|0)>-1){do if(e){c=i[o>>0]|0;i[o>>0]=c+255|c;c=k[b>>2]|0;if(!(c&8)){k[p>>2]=0;k[q>>2]=0;f=k[r>>2]|0;k[s>>2]=f;k[t>>2]=f;e=f+(k[u>>2]|0)|0;k[n>>2]=e;break}else{k[b>>2]=c|32;break p}}else{e=c;f=k[t>>2]|0}while(0);c=f;if((e-f|0)>>>0<g>>>0){ci[k[v>>2]&255](b,d,g)|0;break}q:do if((i[w>>0]|0)>-1){f=g;while(1){if(!f){e=g;break q}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[v>>2]&255](b,d,f)|0)>>>0<f>>>0)break p;e=g-f|0;d=d+f|0;c=k[t>>2]|0}else e=g;while(0);upb(c|0,d|0,e|0)|0;k[t>>2]=(k[t>>2]|0)+e}else{do if(e){c=i[o>>0]|0;i[o>>0]=c+255|c;c=k[b>>2]|0;if(!(c&8)){k[p>>2]=0;k[q>>2]=0;f=k[r>>2]|0;k[s>>2]=f;k[t>>2]=f;e=f+(k[u>>2]|0)|0;k[n>>2]=e;break}else{k[b>>2]=c|32;break p}}else{e=c;f=k[t>>2]|0}while(0);c=f;if((e-f|0)>>>0<g>>>0){ci[k[v>>2]&255](b,d,g)|0;break}r:do if((i[w>>0]|0)>-1){f=g;while(1){if(!f){e=g;break r}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[v>>2]&255](b,d,f)|0)>>>0<f>>>0)break p;e=g-f|0;d=d+f|0;c=k[t>>2]|0}else e=g;while(0);upb(c|0,d|0,e|0)|0;k[t>>2]=(k[t>>2]|0)+e}while(0);pJa(a,b,k[(k[m>>2]|0)+(h<<2)>>2]|0,h);h=h+1|0}while((h|0)<(k[x>>2]|0));return}function gJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+16|0;s=t+8|0;q=t;o=a+52|0;d=k[o>>2]|0;a:do if(d|0?(f=a+92|0,e=k[f>>2]|0,(e|0)>0):0){c=0;while(1){d=k[d+(c<<2)>>2]|0;if(d){ggb(d);k[(k[o>>2]|0)+(c<<2)>>2]=0;e=k[f>>2]|0}c=c+1|0;if((c|0)>=(e|0))break a;d=k[o>>2]|0}}while(0);j=a+48|0;c=k[j>>2]|0;if(c|0)ggb(c);c=k[o>>2]|0;if(c|0)ggb(c);l=a+88|0;if((_fb(l,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}m=a+92|0;if((_fb(m,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}n=a+96|0;if((_fb(n,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}p=a+100|0;if((_fb(p,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}if((_fb(a+84|0,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}f=k[m>>2]|0;d=f>>>0>1073741823?-1:f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0){e=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){e=0;break}Qh[c&7]()}k[o>>2]=e;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[j>>2]=c;b:do if((f|0)>0){h=a+40|0;c=0;g=e;while(1){f=k[h>>2]|0;e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[g+(c<<2)>>2]=d;if((_fb(k[(k[o>>2]|0)+(c<<2)>>2]|0,4,f,b)|0)!=(f|0))break;oJa(a,b,(k[j>>2]|0)+(c<<2)|0,c);c=c+1|0;if((c|0)>=(k[m>>2]|0))break b;g=k[o>>2]|0}t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}while(0);h=a+28|0;c=s+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373358;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));o=WHa(h,s)|0;b=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[q>>2]=b;b=k[o>>2]|0;a=o+4|0;jh[k[k[b>>2]>>2]&1023](b,a);k[o>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,q,a);k[c>>2]=0;k[s>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0);c=s+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373742;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));a=WHa(h,s)|0;o=k[a>>2]|0;q=a+4|0;jh[k[k[o>>2]>>2]&1023](o,q);k[a>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,l,q);k[c>>2]=0;k[s>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0);q=s+4|0;c=ZT(12)|0;k[c>>2]=1;o=c+4|0;k[s>>2]=o;k[q>>2]=5;i[c+9>>0]=0;i[o>>0]=i[380533]|0;i[o+1>>0]=i[380534]|0;i[o+2>>0]=i[380535]|0;i[o+3>>0]=i[380536]|0;i[o+4>>0]=i[380537]|0;o=WHa(h,s)|0;b=k[o>>2]|0;a=o+4|0;jh[k[k[b>>2]>>2]&1023](b,a);k[o>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,m,a);k[q>>2]=0;k[s>>2]=0;q=k[c>>2]|0;k[c>>2]=q+-1;if((q|0)==1)ggb(k[c+-4>>2]|0);c=s+4|0;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[c>>2]=12;i[d+16>>0]=0;f=373752;g=e+12|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));a=WHa(h,s)|0;o=k[a>>2]|0;q=a+4|0;jh[k[k[o>>2]>>2]&1023](o,q);k[a>>2]=428728;Ph[k[(k[107182]|0)+4>>2]&511](428728,n,q);k[c>>2]=0;k[s>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0);c=s+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373765;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));a=WHa(h,s)|0;o=k[a>>2]|0;q=a+4|0;jh[k[k[o>>2]>>2]&1023](o,q);k[a>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,p,q);k[c>>2]=0;k[s>>2]=0;s=k[d>>2]|0;k[d>>2]=s+-1;if((s|0)!=1){r=t;return}ggb(k[d+-4>>2]|0);r=t;return}function hJa(a){a=a|0;return k[a+40>>2]|0}function iJa(a){a=a|0;return k[a+44>>2]|0}function jJa(a){a=a|0;return (k[a+80>>2]|0)+(k[a+76>>2]|0)+(k[a+84>>2]|0)|0}function kJa(a){a=a|0;return 5}function lJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+28>>2]|0;f=b+32|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function mJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+16|0;z=A+4|0;y=A;e=ZT(12)|0;k[e>>2]=1;u=e+4|0;i[e+10>>0]=0;i[u>>0]=i[373823]|0;i[u+1>>0]=i[373824]|0;i[u+2>>0]=i[373825]|0;i[u+3>>0]=i[373826]|0;i[u+4>>0]=i[373827]|0;i[u+5>>0]=i[373828]|0;k[z>>2]=32;u=dIa(d,u,z)|0;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)ggb(k[e+-4>>2]|0);while(1){d=fgb(20)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}f=a+40|0;g=k[f>>2]|0;k[s>>2]=0;t=s+4|0;k[t>>2]=0;h=s+8|0;k[h>>2]=0;k[s+12>>2]=g;if(g){if(g>>>0>536870911){A=te(4)|0;k[A>>2]=172664;Cf(A|0,28816,1287)}e=g<<3;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}q=d;k[s>>2]=q;k[t>>2]=q;k[h>>2]=d+(g<<3);g=k[f>>2]|0}q=s+16|0;k[q>>2]=0;k[z>>2]=0;f=z+4|0;k[f>>2]=0;h=z+8|0;k[h>>2]=0;if(g|0){if((g|0)<0)ad(426534,426557,304,426811);j=((g+-1|0)>>>5)+1|0;e=j<<2;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[z>>2]=d;k[h>>2]=j;k[f>>2]=g;p=g>>>5;zpb(d|0,0,p<<2|0)|0;e=g-(p<<5)|0;d=d+(p<<2)|0;if(e|0)k[d>>2]=k[d>>2]&~(-1>>>(32-e|0))}k[y>>2]=0;e=a+92|0;if((k[e>>2]|0)>0){f=a+48|0;d=0;do{nJa(a,k[(k[f>>2]|0)+(d<<2)>>2]|0,b,c,y,u,s,z);d=d+1|0}while((d|0)<(k[e>>2]|0))}while(1){if(!(k[q>>2]|0))break;n=k[s>>2]|0;p=k[n>>2]|0;d=k[t>>2]|0;m=d-n|0;e=m>>3;if(((m|0)>8?(v=d+-8|0,m=n,j=k[m>>2]|0,m=k[m+4>>2]|0,f=v,g=k[f+4>>2]|0,h=n,k[h>>2]=k[f>>2],k[h+4>>2]=g,v,k[v>>2]=j,k[v+4>>2]=m,v=e+-1|0,(e|0)!=2):0)?(m=e+-3|0,w=(m|0)/2|0,(m|0)>=-1):0){d=n+8|0;if((v|0)>2?+o[n+20>>2]<+o[n+12>>2]:0){e=2;d=n+16|0}else e=1;l=+o[n+4>>2];if(!(l<+o[d+4>>2])){m=k[n>>2]|0;j=n;while(1){h=j;j=d;f=j;g=k[f+4>>2]|0;k[h>>2]=k[f>>2];k[h+4>>2]=g;if((w|0)<(e|0))break;e=e<<1|1;g=n+(e<<3)|0;f=g;h=e+1|0;if((h|0)<(v|0)?(x=g+8|0,+o[x+4>>2]<+o[n+(e<<3)+4>>2]):0){e=h;f=x}if(l<+o[f+4>>2])break;else d=f}k[d>>2]=m;o[d+4>>2]=l}}k[t>>2]=(k[t>>2]|0)+-8;k[q>>2]=(k[q>>2]|0)+-1;if((k[y>>2]|0)>=(u|0)?Xh[k[(k[b>>2]|0)+8>>2]&1023](b)|0:0)break;nJa(a,p,b,c,y,u,s,z)}d=k[s>>2]|0;e=d;if(d|0){f=k[t>>2]|0;if((f|0)!=(d|0))k[t>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(d)}ggb(s);d=k[z>>2]|0;if(!d){r=A;return}ggb(d);r=A;return}function nJa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0.0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0.0,I=0.0,J=0.0;G=b+8|0;w=k[G>>2]|0;if(!w){if((k[e>>2]|0)>=(f|0)?Xh[k[(k[c>>2]|0)+8>>2]&1023](c)|0:0)return;z=b+4|0;i=k[z>>2]|0;if((i|0)<=0)return;w=b+12|0;x=a+24|0;y=a+20|0;v=a+44|0;u=0;b=k[h>>2]|0;do{r=k[(k[w>>2]|0)+(u<<2)>>2]|0;s=r>>>5;t=1<<(r&31);if(!(t&k[b+(s<<2)>>2])){n=(k[x>>2]|0)+((aa(k[y>>2]|0,r)|0)<<2)|0;q=n+(k[v>>2]<<2)|0;m=q+-12|0;p=((m>>>0<n>>>0?n:m)+12+(3-n)|0)>>>4<<2;i=d+(p<<2)|0;if(n>>>0<m>>>0){b=n;l=d;j=0.0;while(1){I=+P(+(+o[b>>2]-+o[l>>2]));H=+P(+(+o[b+4>>2]-+o[l+4>>2]));F=+P(+(+o[b+8>>2]-+o[l+8>>2]));j=j+(I+H+F+ +P(+(+o[b+12>>2]-+o[l+12>>2])));b=b+16|0;if(b>>>0>=m>>>0)break;else l=l+16|0}}else j=0.0;b=n+(p<<2)|0;if(b>>>0<q>>>0)while(1){j=j+ +P(+(+o[b>>2]-+o[i>>2]));b=b+4|0;if(b>>>0>=q>>>0)break;else i=i+4|0}$f[k[(k[c>>2]|0)+12>>2]&15](c,j,r);b=k[h>>2]|0;i=b+(s<<2)|0;k[i>>2]=k[i>>2]|t;k[e>>2]=(k[e>>2]|0)+1;i=k[z>>2]|0}u=u+1|0}while((u|0)<(i|0));return}z=a+88|0;x=k[z>>2]|0;i=x>>>0>1073741823?-1:x<<2;i=(i|0)==0?1:i;while(1){b=fgb(i)|0;if(b|0){y=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){y=0;break}Qh[b&7]()}s=k[a+24>>2]|0;t=k[a+20>>2]|0;b=s+((aa(t,k[k[w>>2]>>2]|0)|0)<<2)|0;u=d+(k[a+44>>2]<<2)|0;q=u+-12|0;v=((q>>>0<d>>>0?d:q)+12+(3-d)|0)>>>4<<2;l=b+(v<<2)|0;m=q>>>0>d>>>0;if(m){i=d;j=0.0;while(1){J=+P(+(+o[i>>2]-+o[b>>2]));H=+P(+(+o[i+4>>2]-+o[b+4>>2]));I=+P(+(+o[i+8>>2]-+o[b+8>>2]));j=j+(J+H+I+ +P(+(+o[i+12>>2]-+o[b+12>>2])));i=i+16|0;if(i>>>0>=q>>>0)break;else b=b+16|0}}else j=0.0;r=d+(v<<2)|0;p=r>>>0<u>>>0;if(p){i=l;b=r;while(1){j=j+ +P(+(+o[b>>2]-+o[i>>2]));b=b+4|0;if(b>>>0>=u>>>0)break;else i=i+4|0}}o[y>>2]=j;a:do if((x|0)>1){if(m){n=1;b=0}else{if(p){m=1;b=0}else{i=1;b=0;while(1){o[y+(i<<2)>>2]=0.0;b=+o[y+(b<<2)>>2]>0.0?i:b;i=i+1|0;if((i|0)==(x|0)){w=b;break a}}}while(1){i=s+((aa(t,k[k[w+(m<<2)>>2]>>2]|0)|0)<<2)+(v<<2)|0;j=0.0;l=r;while(1){q=l;l=l+4|0;j=j+ +P(+(+o[q>>2]-+o[i>>2]));if(l>>>0>=u>>>0)break;else i=i+4|0}o[y+(m<<2)>>2]=j;b=j<+o[y+(b<<2)>>2]?m:b;m=m+1|0;if((m|0)==(x|0)){w=b;break a}}}do{m=s+((aa(t,k[k[w+(n<<2)>>2]>>2]|0)|0)<<2)|0;i=d;l=m;j=0.0;while(1){H=+P(+(+o[i>>2]-+o[l>>2]));I=+P(+(+o[i+4>>2]-+o[l+4>>2]));J=+P(+(+o[i+8>>2]-+o[l+8>>2]));j=j+(H+I+J+ +P(+(+o[i+12>>2]-+o[l+12>>2])));i=i+16|0;if(i>>>0>=q>>>0)break;else l=l+16|0}if(p){l=m+(v<<2)|0;i=r;while(1){j=j+ +P(+(+o[i>>2]-+o[l>>2]));i=i+4|0;if(i>>>0>=u>>>0)break;else l=l+4|0}}o[y+(n<<2)>>2]=j;b=j<+o[y+(b<<2)>>2]?n:b;n=n+1|0}while((n|0)!=(x|0));w=b}else w=0;while(0);b:do if((x|0)>0){s=g+16|0;t=g+12|0;u=g+4|0;v=g+8|0;r=0;b=x;while(1){if((r|0)!=(w|0)?(A=k[y+(r<<2)>>2]|0,B=k[(k[G>>2]|0)+(r<<2)>>2]|0,(k[s>>2]|0)!=(k[t>>2]|0)):0){b=k[u>>2]|0;x=k[v>>2]|0;i=x;if((b|0)==(x|0)){q=k[g>>2]|0;p=b-q|0;n=p>>3;b=n+1|0;if(b>>>0>536870911){b=41;break}x=i-q|0;m=x>>2;m=x>>3>>>0<268435455?(m>>>0<b>>>0?b:m):536870911;if(!m)b=0;else{if(m>>>0>536870911){b=44;break}i=m<<3;i=(i|0)==0?1:i;while(1){b=fgb(i)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}}i=b+(n<<3)|0;l=i;k[l>>2]=B;k[l+4>>2]=A;l=i+8|0;i=i+(0-n<<3)|0;if((p|0)>0)upb(i|0,q|0,p|0)|0;k[g>>2]=i;k[u>>2]=l;k[v>>2]=b+(m<<3);if(q){ggb(q);l=k[u>>2]|0}}else{l=b;k[l>>2]=B;k[l+4>>2]=A;l=(k[u>>2]|0)+8|0;k[u>>2]=l}b=k[g>>2]|0;i=l-b|0;if((i|0)>8?(C=((i>>3)+-2|0)/2|0,D=b,x=l,E=x+-8|0,F=+o[x+-4>>2],F<+o[D+(C<<3)+4>>2]):0){m=k[E>>2]|0;l=E;b=C;while(1){x=l;l=D+(b<<3)|0;p=l;q=k[p+4>>2]|0;k[x>>2]=k[p>>2];k[x+4>>2]=q;if(!b){b=0;break}i=(b+-1|0)/2|0;if(!(F<+o[D+(i<<3)+4>>2]))break;else b=i}k[l>>2]=m;o[D+(b<<3)+4>>2]=F}k[s>>2]=(k[s>>2]|0)+1;b=k[z>>2]|0}r=r+1|0;if((r|0)>=(b|0))break b}if((b|0)==41)ad(426534,426557,304,426811);else if((b|0)==44){h=te(4)|0;k[h>>2]=172664;Cf(h|0,28816,1287)}}while(0);ggb(y);nJa(a,k[(k[G>>2]|0)+(w<<2)>>2]|0,c,d,e,f,g,h);return}function oJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;h=n;l=a+60|0;f=k[l>>2]|0;a:do if((f|0)<32){e=a+80|0;k[e>>2]=(k[e>>2]|0)+f;e=fgb(8192)|0;if(e|0){g=a+64|0;k[e>>2]=k[g>>2];k[g>>2]=e;k[l>>2]=8188;e=e+4|0;g=a+68|0;k[g>>2]=e;f=8156;m=28;break}e=k[41482]|0;f=(e|0)==0;if((k[41497]|0)>-1){do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;e=0;break a}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;e=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){e=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;e=0;break}else{do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;e=0;break a}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;e=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){e=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;e=0;break}}else{e=a+68|0;g=e;e=k[e>>2]|0;f=f+-32|0;m=28}while(0);if((m|0)==28){k[g>>2]=e+32;k[l>>2]=f;j=a+76|0;k[j>>2]=(k[j>>2]|0)+32}k[c>>2]=e;if((_fb(e,20,1,b)|0)!=1){n=te(44)|0;VHa(n,373124);Cf(n|0,19720,57)}if(!(k[(k[c>>2]|0)+8>>2]|0)){if((_fb(h,4,1,b)|0)!=1){n=te(44)|0;VHa(n,373124);Cf(n|0,19720,57)}k[(k[c>>2]|0)+12>>2]=(k[(k[a+52>>2]|0)+(d<<2)>>2]|0)+(k[h>>2]<<2);r=n;return}j=a+88|0;h=(k[j>>2]<<2)+15&-16;f=k[l>>2]|0;b:do if((h|0)>(f|0)){e=a+80|0;k[e>>2]=(k[e>>2]|0)+f;e=(h|4)+15|0;e=e>>>0>8192?e:8192;f=fgb(e)|0;if(f|0){m=a+64|0;k[f>>2]=k[m>>2];k[m>>2]=f;m=e+-4|0;k[l>>2]=m;e=f+4|0;g=a+68|0;k[g>>2]=e;f=m;m=62;break}e=k[41482]|0;f=(e|0)==0;if((k[41497]|0)>-1){do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;e=0;break b}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;e=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){e=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;e=0;break}else{do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;e=0;break b}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;e=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){e=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;e=0;break}}else{e=a+68|0;g=e;e=k[e>>2]|0;m=62}while(0);if((m|0)==62){k[g>>2]=e+h;k[l>>2]=f-h;m=a+76|0;k[m>>2]=(k[m>>2]|0)+h}k[(k[c>>2]|0)+8>>2]=e;if((k[j>>2]|0)>0)e=0;else{r=n;return}do{oJa(a,b,(k[(k[c>>2]|0)+8>>2]|0)+(e<<2)|0,d);e=e+1|0}while((e|0)<(k[j>>2]|0));r=n;return}function pJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;f=n;m=b+76|0;h=b+16|0;g=k[h>>2]|0;e=(g|0)==0;a:do if((k[m>>2]|0)>-1){do if(e){e=b+74|0;l=i[e>>0]|0;i[e>>0]=l+255|l;e=k[b>>2]|0;if(!(e&8)){k[b+8>>2]=0;k[b+4>>2]=0;e=k[b+44>>2]|0;k[b+28>>2]=e;l=b+20|0;k[l>>2]=e;g=e+(k[b+48>>2]|0)|0;k[h>>2]=g;break}else{k[b>>2]=e|32;break a}}else{e=b+20|0;l=e;e=k[e>>2]|0}while(0);j=e;if((g-e|0)>>>0<20){ci[k[b+36>>2]&255](b,c,20)|0;break}b:do if((i[b+75>>0]|0)>-1){g=20;while(1){if(!g){h=20;g=c;e=j;break b}e=g+-1|0;if((i[c+e>>0]|0)==10)break;else g=e}if((ci[k[b+36>>2]&255](b,c,g)|0)>>>0<g>>>0)break a;h=20-g|0;g=c+g|0;e=k[l>>2]|0}else{h=20;g=c;e=j}while(0);upb(e|0,g|0,h|0)|0;k[l>>2]=(k[l>>2]|0)+h}else{do if(e){e=b+74|0;l=i[e>>0]|0;i[e>>0]=l+255|l;e=k[b>>2]|0;if(!(e&8)){k[b+8>>2]=0;k[b+4>>2]=0;e=k[b+44>>2]|0;k[b+28>>2]=e;l=b+20|0;k[l>>2]=e;g=e+(k[b+48>>2]|0)|0;k[h>>2]=g;break}else{k[b>>2]=e|32;break a}}else{e=b+20|0;l=e;e=k[e>>2]|0}while(0);j=e;if((g-e|0)>>>0<20){ci[k[b+36>>2]&255](b,c,20)|0;break}c:do if((i[b+75>>0]|0)>-1){g=20;while(1){if(!g){h=20;g=c;e=j;break c}e=g+-1|0;if((i[c+e>>0]|0)==10)break;else g=e}if((ci[k[b+36>>2]&255](b,c,g)|0)>>>0<g>>>0)break a;h=20-g|0;g=c+g|0;e=k[l>>2]|0}else{h=20;g=c;e=j}while(0);upb(e|0,g|0,h|0)|0;k[l>>2]=(k[l>>2]|0)+h}while(0);g=c+8|0;e=k[g>>2]|0;if(e|0){f=a+88|0;if((k[f>>2]|0)<=0){r=n;return}pJa(a,b,k[e>>2]|0,d);if((k[f>>2]|0)>1)e=1;else{r=n;return}do{pJa(a,b,k[(k[g>>2]|0)+(e<<2)>>2]|0,d);e=e+1|0}while((e|0)<(k[f>>2]|0));r=n;return}k[f>>2]=(k[c+12>>2]|0)-(k[(k[a+52>>2]|0)+(d<<2)>>2]|0)>>2;h=b+16|0;g=k[h>>2]|0;e=(g|0)==0;d:do if((k[m>>2]|0)>-1){do if(e){e=b+74|0;m=i[e>>0]|0;i[e>>0]=m+255|m;e=k[b>>2]|0;if(!(e&8)){k[b+8>>2]=0;k[b+4>>2]=0;m=k[b+44>>2]|0;k[b+28>>2]=m;j=b+20|0;k[j>>2]=m;g=m+(k[b+48>>2]|0)|0;k[h>>2]=g;h=m;break}else{k[b>>2]=e|32;break d}}else{h=b+20|0;j=h;h=k[h>>2]|0}while(0);e=h;if((g-h|0)>>>0<4){ci[k[b+36>>2]&255](b,f,4)|0;break}e:do if((i[b+75>>0]|0)>-1){h=4;while(1){if(!h){g=4;break e}g=h+-1|0;if((i[f+g>>0]|0)==10)break;else h=g}if((ci[k[b+36>>2]&255](b,f,h)|0)>>>0<h>>>0)break d;g=4-h|0;f=f+h|0;e=k[j>>2]|0}else g=4;while(0);upb(e|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}else{do if(e){e=b+74|0;m=i[e>>0]|0;i[e>>0]=m+255|m;e=k[b>>2]|0;if(!(e&8)){k[b+8>>2]=0;k[b+4>>2]=0;m=k[b+44>>2]|0;k[b+28>>2]=m;j=b+20|0;k[j>>2]=m;g=m+(k[b+48>>2]|0)|0;k[h>>2]=g;h=m;break}else{k[b>>2]=e|32;break d}}else{h=b+20|0;j=h;h=k[h>>2]|0}while(0);e=h;if((g-h|0)>>>0<4){ci[k[b+36>>2]&255](b,f,4)|0;break}f:do if((i[b+75>>0]|0)>-1){h=4;while(1){if(!h){g=4;break f}g=h+-1|0;if((i[f+g>>0]|0)==10)break;else h=g}if((ci[k[b+36>>2]&255](b,f,h)|0)>>>0<h>>>0)break d;g=4-h|0;f=f+h|0;e=k[j>>2]|0}else g=4;while(0);upb(e|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}while(0);r=n;return}function qJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0.0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0;G=r;r=r+16|0;m=G;k[b+4>>2]=d;k[b+16>>2]=f;if((k[a+100>>2]|0)>(d|0)){k[b+12>>2]=c;Dgb(c,c+(d<<2)|0);k[b+8>>2]=0;r=G;return}if(!e)g=0;else{if(e>>>0>1073741823)ad(426534,426557,304,426811);j=e<<2;h=(j|0)==0?1:j;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}zpb(g|0,0,j|0)|0}if(!d)h=0;else{if(d>>>0>1073741823)ad(426534,426557,304,426811);l=d<<2;j=(l|0)==0?1:l;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}zpb(h|0,0,l|0)|0}j=k[a+4>>2]|0;E=k[a+8>>2]|0;l=a+(E>>1)|0;if(E&1)j=k[(k[l>>2]|0)+j>>2]|0;Lg[j&255](l,e,c,d,g,m);x=k[m>>2]|0;a:do if((x|0)>=(e|0)){E=(d|0)>0;if(E){y=k[a+24>>2]|0;z=a+20|0;A=a+44|0;B=(x|0)>1;w=0;do{j=k[z>>2]|0;C=y+((aa(j,k[c+(w<<2)>>2]|0)|0)<<2)|0;j=y+((aa(k[g>>2]|0,j)|0)<<2)|0;t=C+(k[A>>2]<<2)|0;n=t+-12|0;D=3-C|0;s=((n>>>0<C>>>0?C:n)+12+D|0)>>>4<<2;l=j+(s<<2)|0;if(C>>>0<n>>>0){m=C;p=0.0;while(1){I=+P(+(+o[m>>2]-+o[j>>2]));H=+P(+(+o[m+4>>2]-+o[j+4>>2]));q=+P(+(+o[m+8>>2]-+o[j+8>>2]));p=p+(I+H+q+ +P(+(+o[m+12>>2]-+o[j+12>>2])));m=m+16|0;if(m>>>0>=n>>>0)break;else j=j+16|0}}else p=0.0;j=C+(s<<2)|0;if(j>>>0<t>>>0)while(1){p=p+ +P(+(+o[j>>2]-+o[l>>2]));j=j+4|0;if(j>>>0>=t>>>0)break;else l=l+4|0}v=h+(w<<2)|0;k[v>>2]=0;if(B){u=1;do{j=y+((aa(k[z>>2]|0,k[g+(u<<2)>>2]|0)|0)<<2)|0;t=C+(k[A>>2]<<2)|0;n=t+-12|0;s=((n>>>0<C>>>0?C:n)+12+D|0)>>>4<<2;l=j+(s<<2)|0;if(C>>>0<n>>>0){m=C;q=0.0;while(1){J=+P(+(+o[m>>2]-+o[j>>2]));H=+P(+(+o[m+4>>2]-+o[j+4>>2]));I=+P(+(+o[m+8>>2]-+o[j+8>>2]));q=q+(J+H+I+ +P(+(+o[m+12>>2]-+o[j+12>>2])));m=m+16|0;if(m>>>0>=n>>>0)break;else j=j+16|0}}else q=0.0;j=C+(s<<2)|0;if(j>>>0<t>>>0)while(1){q=q+ +P(+(+o[j>>2]-+o[l>>2]));j=j+4|0;if(j>>>0>=t>>>0)break;else l=l+4|0}if(p>q){k[v>>2]=u;p=q}u=u+1|0}while((u|0)!=(x|0))}w=w+1|0}while((w|0)!=(d|0))}n=(e<<2)+15&-16;A=a+60|0;l=k[A>>2]|0;b:do if((n|0)>(l|0)){j=a+80|0;k[j>>2]=(k[j>>2]|0)+l;j=(n|4)+15|0;j=j>>>0>8192?j:8192;l=fgb(j)|0;if(l|0){F=a+64|0;k[l>>2]=k[F>>2];k[F>>2]=l;F=j+-4|0;k[A>>2]=F;j=l+4|0;m=a+68|0;k[m>>2]=j;l=F;F=66;break}j=k[41482]|0;l=(j|0)==0;if((k[41497]|0)>-1){do if(l){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;l=k[41489]|0;k[41485]=l;k[41483]=l;j=l+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break b}}else l=k[41483]|0;while(0);if((j-l|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;m=373857;l=k[41483]|0}else{j=27;m=373830}upb(l|0,m|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}else{do if(l){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;l=k[41489]|0;k[41485]=l;k[41483]=l;j=l+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break b}}else l=k[41483]|0;while(0);if((j-l|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;m=373857;l=k[41483]|0}else{j=27;m=373830}upb(l|0,m|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}}else{j=a+68|0;m=j;j=k[j>>2]|0;F=66}while(0);if((F|0)==66){k[m>>2]=j+n;k[A>>2]=l-n;D=a+76|0;k[D>>2]=(k[D>>2]|0)+n}z=b+8|0;k[z>>2]=j;if((e|0)>0){w=a+80|0;x=a+64|0;y=a+68|0;u=f+1|0;v=a+76|0;if(E){s=0;t=0}else{n=0;while(1){l=k[A>>2]|0;c:do if((l|0)<32){k[w>>2]=(k[w>>2]|0)+l;j=fgb(8192)|0;if(j|0){k[j>>2]=k[x>>2];k[x>>2]=j;k[A>>2]=8188;j=j+4|0;k[y>>2]=j;l=8188;F=129;break}j=k[41482]|0;l=(j|0)==0;if((k[41497]|0)>-1){do if(l){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;l=k[41489]|0;k[41485]=l;k[41483]=l;j=l+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break c}}else l=k[41483]|0;while(0);if((j-l|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;m=373857;l=k[41483]|0}else{j=27;m=373830}upb(l|0,m|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}else{do if(l){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;l=k[41489]|0;k[41485]=l;k[41483]=l;j=l+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break c}}else l=k[41483]|0;while(0);if((j-l|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;m=373857;l=k[41483]|0}else{j=27;m=373830}upb(l|0,m|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}}else{j=k[y>>2]|0;F=129}while(0);if((F|0)==129){F=0;k[y>>2]=j+32;k[A>>2]=l+-32;k[v>>2]=(k[v>>2]|0)+32}k[(k[z>>2]|0)+(n<<2)>>2]=j;d=(k[z>>2]|0)+(n<<2)|0;f=k[d>>2]|0;k[f>>2]=k[g+(n<<2)>>2];k[f+12>>2]=0;qJa(a,k[d>>2]|0,c,0,e,u);n=n+1|0;if((n|0)>=(e|0))break a}}while(1){m=0;j=t;while(1){l=h+(m<<2)|0;if((k[l>>2]|0)==(s|0)){b=c+(m<<2)|0;n=c+(j<<2)|0;f=k[b>>2]|0;k[b>>2]=k[n>>2];k[n>>2]=f;n=h+(j<<2)|0;f=k[l>>2]|0;k[l>>2]=k[n>>2];k[n>>2]=f;n=j+1|0}else n=j;m=m+1|0;if((m|0)==(d|0))break;else j=n}l=k[A>>2]|0;d:do if((l|0)<32){k[w>>2]=(k[w>>2]|0)+l;j=fgb(8192)|0;if(j|0){k[j>>2]=k[x>>2];k[x>>2]=j;k[A>>2]=8188;j=j+4|0;k[y>>2]=j;l=8188;F=73;break}j=k[41482]|0;l=(j|0)==0;if((k[41497]|0)>-1){do if(l){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;l=k[41489]|0;k[41485]=l;k[41483]=l;j=l+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break d}}else l=k[41483]|0;while(0);if((j-l|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;m=373857;l=k[41483]|0}else{j=27;m=373830}upb(l|0,m|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}else{do if(l){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;l=k[41489]|0;k[41485]=l;k[41483]=l;j=l+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break d}}else l=k[41483]|0;while(0);if((j-l|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;m=373857;l=k[41483]|0}else{j=27;m=373830}upb(l|0,m|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}}else{j=k[y>>2]|0;F=73}while(0);if((F|0)==73){F=0;k[y>>2]=j+32;k[A>>2]=l+-32;k[v>>2]=(k[v>>2]|0)+32}k[(k[z>>2]|0)+(s<<2)>>2]=j;f=(k[z>>2]|0)+(s<<2)|0;b=k[f>>2]|0;k[b>>2]=k[g+(s<<2)>>2];k[b+12>>2]=0;qJa(a,k[f>>2]|0,c+(t<<2)|0,n-t|0,e,u);s=s+1|0;if((s|0)>=(e|0))break;else t=n}}}else{k[b+12>>2]=c;Dgb(c,c+(d<<2)|0);k[b+8>>2]=0}while(0);if(h|0)ggb(h);if(!g){r=G;return}ggb(g);r=G;return}function rJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;f=r;r=r+32|0;j=f+4|0;c=f;d=f+16|0;e=f+8|0;k[j>>2]=b;o[c>>2]=0.0;i[d>>0]=1;k[a+4>>2]=0;k[a+8>>2]=0;k[a>>2]=a+4;k[e>>2]=0;g=e+4|0;k[g>>2]=0;b=ZT(12)|0;k[b>>2]=1;l=b+4|0;k[e>>2]=l;k[g>>2]=6;i[b+10>>0]=0;i[l>>0]=i[373823]|0;i[l+1>>0]=i[373824]|0;i[l+2>>0]=i[373825]|0;i[l+3>>0]=i[373826]|0;i[l+4>>0]=i[373827]|0;i[l+5>>0]=i[373828]|0;l=WHa(a,e)|0;m=k[l>>2]|0;h=l+4|0;jh[k[k[m>>2]>>2]&1023](m,h);k[l>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,j,h);k[g>>2]=0;k[e>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0);k[e>>2]=0;m=e+4|0;k[m>>2]=0;b=ZT(8)|0;k[b>>2]=1;j=b+4|0;k[e>>2]=j;k[m>>2]=3;i[b+7>>0]=0;i[j>>0]=i[374006]|0;i[j+1>>0]=i[374007]|0;i[j+2>>0]=i[374008]|0;j=WHa(a,e)|0;h=k[j>>2]|0;l=j+4|0;jh[k[k[h>>2]>>2]&1023](h,l);k[j>>2]=428716;Ph[k[(k[107179]|0)+4>>2]&511](428716,c,l);k[m>>2]=0;k[e>>2]=0;m=k[b>>2]|0;k[b>>2]=m+-1;if((m|0)==1)ggb(k[b+-4>>2]|0);k[e>>2]=0;m=e+4|0;k[m>>2]=0;b=ZT(12)|0;k[b>>2]=1;j=b+4|0;k[e>>2]=j;k[m>>2]=6;i[b+10>>0]=0;i[j>>0]=i[373546]|0;i[j+1>>0]=i[373547]|0;i[j+2>>0]=i[373548]|0;i[j+3>>0]=i[373549]|0;i[j+4>>0]=i[373550]|0;i[j+5>>0]=i[373551]|0;j=WHa(a,e)|0;h=k[j>>2]|0;l=j+4|0;jh[k[k[h>>2]>>2]&1023](h,l);k[j>>2]=428720;Ph[k[(k[107180]|0)+4>>2]&511](428720,d,l);k[m>>2]=0;k[e>>2]=0;m=k[b>>2]|0;k[b>>2]=m+-1;if((m|0)!=1){r=f;return}ggb(k[b+-4>>2]|0);r=f;return}function sJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0.0;l=a+4|0;a=k[l>>2]|0;if(!a){m=+o[c>>2];return +m}e=(b|0)==0?1016759:b;j=l;d=a;a:while(1){a=d;while(1){d=k[a+16>>2]|0;if((d|0)==(b|0))break;g=(d|0)==0?1016759:d;d=i[g>>0]|0;f=i[e>>0]|0;if(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24)){h=e;do{g=g+1|0;h=h+1|0;d=i[g>>0]|0;f=i[h>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=f<<24>>24))}if((d&255)>=(f&255))break;a=k[a+4>>2]|0;if(!a){g=j;break a}}d=k[a>>2]|0;if(!d){g=a;break}else j=a}if((g|0)==(l|0)){m=+o[c>>2];return +m}a=k[g+16>>2]|0;if((a|0)!=(b|0)){d=(a|0)==0?1016759:a;a=i[e>>0]|0;f=i[d>>0]|0;if(a<<24>>24==0?1:a<<24>>24!=f<<24>>24)d=f;else{do{e=e+1|0;d=d+1|0;a=i[e>>0]|0;f=i[d>>0]|0}while(!(a<<24>>24==0?1:a<<24>>24!=f<<24>>24));d=f}if((a&255)<(d&255)){m=+o[c>>2];return +m}}a=g+24|0;c=k[a>>2]|0;c=(Xh[k[(k[c>>2]|0)+28>>2]&1023](c)|0)+4|0;if((k[c>>2]|0)!=333970)Cf(te(1)|0,19736,0);c=k[a>>2]|0;c=Hh[k[(k[c>>2]|0)+20>>2]&511](c,g+28|0)|0;m=+o[c>>2];return +m}function tJa(a){a=a|0;var b=0,c=0;k[a>>2]=93496;b=a+4|0;c=k[b>>2]|0;if(c|0){Uh[k[(k[c>>2]|0)+4>>2]&2047](c);k[b>>2]=0}YHa(k[a+24>>2]|0);YHa(k[a+12>>2]|0);return}function uJa(a){a=a|0;var b=0,c=0;k[a>>2]=93496;b=a+4|0;c=k[b>>2]|0;if(c|0){Uh[k[(k[c>>2]|0)+4>>2]&2047](c);k[b>>2]=0}YHa(k[a+24>>2]|0);YHa(k[a+12>>2]|0);ggb(a);return}function vJa(a){a=a|0;var b=0,c=0.0,d=0,e=0.0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0;Na=r;r=r+768|0;La=Na+360|0;Ka=Na+352|0;Ja=Na+344|0;Ia=Na+336|0;Aa=Na+328|0;ya=Na+320|0;ua=Na+312|0;xa=Na+304|0;za=Na+296|0;Ha=Na+280|0;Ba=Na+264|0;va=Na+248|0;ra=Na+240|0;la=Na+224|0;ja=Na+208|0;$=Na+200|0;_=Na+176|0;Z=Na+168|0;Y=Na+160|0;ca=Na+64|0;ba=Na+32|0;q=Na+24|0;pa=Na;Q=Na+720|0;R=Na+616|0;S=Na+600|0;X=Na+580|0;T=Na+552|0;ma=Na+540|0;s=Na+512|0;Ga=Na+376|0;oa=Na+364|0;qa=Na+744|0;Ea=Na+732|0;Ma=Ga+56|0;Fa=Ga+4|0;k[Ga>>2]=49424;k[Ma>>2]=49444;k[Ga+80>>2]=Fa;k[Ga+72>>2]=0;k[Ga+76>>2]=0;k[Ga+60>>2]=4098;k[Ga+68>>2]=0;k[Ga+64>>2]=6;b=Ga+84|0;L=Ga+88|0;M=L+40|0;do{k[L>>2]=0;L=L+4|0}while((L|0)<(M|0));eob(b);k[Ga+128>>2]=0;k[Ga+132>>2]=-1;k[Ga>>2]=49464;k[Ma>>2]=49484;k[Fa>>2]=169272;Ca=Ga+8|0;eob(Ca);Da=Ga+12|0;k[Da>>2]=0;k[Da+4>>2]=0;k[Da+8>>2]=0;k[Da+12>>2]=0;k[Da+16>>2]=0;k[Da+20>>2]=0;k[Fa>>2]=49500;Da=Ga+36|0;k[Da>>2]=0;k[Da+4>>2]=0;k[Da+8>>2]=0;k[Da+12>>2]=0;k[Ga+52>>2]=16;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;C4(Fa,Q);if((i[Q+11>>0]|0)<0)ggb(k[Q>>2]|0);wa=a+8|0;k[ma>>2]=0;na=ma+4|0;k[na>>2]=0;k[ma+8>>2]=0;sa=a+84|0;ka=k[sa>>2]|0;b=~~(+o[a+112>>2]*+(ka>>>0));d=(b|0)/10|0;d=(d|0)>1e3?1e3:d;ta=a+100|0;h=+o[ta>>2];k[pa>>2]=ka;k[pa+4>>2]=b;k[pa+8>>2]=d;p[pa+16>>3]=h;IJa(374745,pa);if((d|0)<10){IJa(374842,q);TJa(pa);j=oa+4|0;k[j>>2]=0;l=oa+8|0;k[l>>2]=0;m=oa+4|0;k[oa>>2]=m;b=k[pa>>2]|0;n=pa+4|0;if((b|0)!=(n|0)){d=b;while(1){f=d+16|0;g=ZHa(oa,m,q,f)|0;if(!(k[g>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=k[f>>2]|0;k[b+16>>2]=f;k[b+20>>2]=k[d+20>>2];if(f|0){la=f+-4|0;k[la>>2]=(k[la>>2]|0)+1}ka=b+24|0;k[ka>>2]=428704;f=b+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);la=k[d+24>>2]|0;k[ka>>2]=la;Ph[k[(k[la>>2]|0)+8>>2]&511](la,d+28|0,f);f=k[q>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=f;k[g>>2]=b;f=k[k[oa>>2]>>2]|0;if(f){k[oa>>2]=f;b=k[g>>2]|0}B4(k[j>>2]|0,b);k[l>>2]=(k[l>>2]|0)+1}else d=b;b=k[d+4>>2]|0;if(!b)while(1){b=k[d+8>>2]|0;if((k[b>>2]|0)==(d|0))break;else d=b}else while(1){d=k[b>>2]|0;if(!d)break;else b=d}if((b|0)==(n|0))break;else d=b}}YHa(k[n>>2]|0)}else{W=a+32|0;JJa(pa,sa,b);k[W>>2]=k[pa>>2];k[W+4>>2]=k[pa+4>>2];k[W+8>>2]=k[pa+8>>2];k[W+12>>2]=k[pa+12>>2];V=a+48|0;UJa(pa,W,d);k[V>>2]=k[pa>>2];k[V+4>>2]=k[pa+4>>2];k[V+8>>2]=k[pa+8>>2];k[V+12>>2]=k[pa+12>>2];IJa(374878,ba);f=k[V>>2]|0;d=f>>>0>1073741823?-1:f<<2;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[a+64>>2]=f;j=a+68|0;k[j>>2]=1;l=a+72|0;k[l>>2]=1;ga=a+76|0;k[ga>>2]=b;he(ba|0,pa|0)|0;n=k[ba>>2]|0;n=Epb(n|0,((n|0)<0)<<31>>31|0,1e6,0)|0;m=k[ba+4>>2]|0;m=kpb(n|0,N|0,m|0,((m|0)<0)<<31>>31|0)|0;n=N;if(k[V>>2]|0){d=a+60|0;f=a+56|0;b=0;do{fa=(k[d>>2]|0)+((aa(k[f>>2]|0,b)|0)<<2)|0;ka=(k[ga>>2]|0)+((aa(k[l>>2]|0,b)|0)<<2)|0;KJa(W,fa,ka,k[j>>2]|0,0);b=b+1|0}while(b>>>0<(k[V>>2]|0)>>>0)}he(ba|0,pa|0)|0;f=k[ba>>2]|0;f=Epb(f|0,((f|0)<0)<<31>>31|0,1e6,0)|0;b=k[ba+4>>2]|0;b=kpb(f|0,N|0,b|0,((b|0)<0)<<31>>31|0)|0;f=s+16|0;k[s+20>>2]=0;k[s+24>>2]=0;ka=s+20|0;k[f>>2]=ka;o[s>>2]=(+(b>>>0)+4294967296.0*+(N|0)-(+(m>>>0)+4294967296.0*+(n|0)))/1.0e6+0.0;o[s+4>>2]=0.0;o[s+8>>2]=0.0;k[ba>>2]=0;b=ba+4|0;k[b>>2]=0;d=ZT(16)|0;k[d>>2]=1;L=d+4|0;k[ba>>2]=L;k[b>>2]=9;i[d+13>>0]=0;K=373358;M=L+9|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));da=WHa(f,ba)|0;k[pa>>2]=0;U=k[da>>2]|0;fa=da+4|0;jh[k[k[U>>2]>>2]&1023](U,fa);k[da>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,pa,fa);k[b>>2]=0;k[ba>>2]=0;fa=k[d>>2]|0;k[d>>2]=fa+-1;if((fa|0)==1)ggb(k[d+-4>>2]|0);b=k[na>>2]|0;U=ma+8|0;d=k[U>>2]|0;if((b|0)==(d|0)){WJa(ma,s);fa=na;s=U;f=k[na>>2]|0;d=k[U>>2]|0}else{VJa(b,s);f=b+28|0;k[na>>2]=f;fa=na;s=U}IJa(374906,ca);IJa(375148,Y);k[S>>2]=k[23419];k[S+4>>2]=k[23420];k[S+8>>2]=k[23421];k[S+12>>2]=k[23422];k[X>>2]=k[23423];k[X+4>>2]=k[23424];k[X+8>>2]=k[23425];k[X+12>>2]=k[23426];k[X+16>>2]=k[23427];q=k[ma>>2]|0;j=f-q|0;m=((j|0)/28|0)+20|0;b=q;if(((d-q|0)/28|0)>>>0<m>>>0){l=(f-q|0)/28|0;if(!m)d=0;else{if(m>>>0>153391689){Na=te(4)|0;k[Na>>2]=172664;Cf(Na|0,28816,1287)}j=j+560|0;j=(j|0)==0?1:j;while(1){d=fgb(j)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}l=d+(l*28|0)|0;n=l;m=d+(m*28|0)|0;if((f|0)==(b|0)){j=n;f=q}else{j=n;d=l;do{f=f+-28|0;VJa(d+-28|0,f);d=j+-28|0;j=d}while((f|0)!=(b|0));f=k[ma>>2]|0;b=k[na>>2]|0}k[ma>>2]=j;k[fa>>2]=n;k[s>>2]=m;d=f;if((b|0)!=(d|0))do{YHa(k[b+-8>>2]|0);b=b+-28|0}while((b|0)!=(d|0));if(f|0)ggb(f)}l=T+16|0;m=T+20|0;n=T+24|0;q=T+20|0;s=Y+4|0;t=Y+4|0;u=Y+4|0;v=Y+4|0;w=pa+4|0;x=Q+4|0;y=Y+4|0;z=Y+4|0;O=a+64|0;P=a+36|0;A=R+92|0;B=R+96|0;C=R+100|0;D=T+8|0;E=T+4|0;da=a+104|0;F=R+64|0;G=R+68|0;H=R+80|0;I=R+48|0;j=0;do{J=S+(j<<2)|0;f=0;do{k[m>>2]=0;k[n>>2]=0;k[l>>2]=q;k[Y>>2]=0;k[s>>2]=0;b=ZT(16)|0;k[b>>2]=1;L=b+4|0;k[Y>>2]=L;k[s>>2]=9;i[b+13>>0]=0;K=373358;M=L+9|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));L=WHa(l,Y)|0;k[ca>>2]=2;K=k[L>>2]|0;M=L+4|0;jh[k[k[K>>2]>>2]&1023](K,M);k[L>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,ca,M);k[s>>2]=0;k[Y>>2]=0;M=k[b>>2]|0;k[b>>2]=M+-1;if((M|0)==1)ggb(k[b+-4>>2]|0);k[Y>>2]=0;k[t>>2]=0;b=ZT(20)|0;k[b>>2]=1;L=b+4|0;k[Y>>2]=L;k[t>>2]=12;i[b+16>>0]=0;K=373752;M=L+12|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));L=WHa(l,Y)|0;k[ca>>2]=0;K=k[L>>2]|0;M=L+4|0;jh[k[k[K>>2]>>2]&1023](K,M);k[L>>2]=428728;Ph[k[(k[107182]|0)+4>>2]&511](428728,ca,M);k[t>>2]=0;k[Y>>2]=0;M=k[b>>2]|0;k[b>>2]=M+-1;if((M|0)==1)ggb(k[b+-4>>2]|0);k[Y>>2]=0;k[u>>2]=0;b=ZT(16)|0;k[b>>2]=1;L=b+4|0;k[Y>>2]=L;k[u>>2]=10;i[b+14>>0]=0;K=375191;M=L+10|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));L=WHa(l,Y)|0;K=k[L>>2]|0;M=L+4|0;jh[k[k[K>>2]>>2]&1023](K,M);k[L>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,J,M);k[u>>2]=0;k[Y>>2]=0;M=k[b>>2]|0;k[b>>2]=M+-1;if((M|0)==1)ggb(k[b+-4>>2]|0);k[Y>>2]=0;k[v>>2]=0;b=ZT(16)|0;k[b>>2]=1;L=b+4|0;k[Y>>2]=L;k[v>>2]=9;i[b+13>>0]=0;K=373742;M=L+9|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));L=WHa(l,Y)|0;K=k[L>>2]|0;M=L+4|0;jh[k[k[K>>2]>>2]&1023](K,M);k[L>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,X+(f<<2)|0,M);k[v>>2]=0;k[Y>>2]=0;M=k[b>>2]|0;k[b>>2]=M+-1;if((M|0)==1)ggb(k[b+-4>>2]|0);k[pa>>2]=0;k[w>>2]=0;K=ZT(16)|0;k[K>>2]=1;L=K+4|0;k[pa>>2]=L;k[w>>2]=10;i[K+14>>0]=0;K=375191;M=L+10|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));b=EJa(l,pa)|0;k[Q>>2]=0;k[x>>2]=0;d=ZT(16)|0;k[d>>2]=1;L=d+4|0;k[Q>>2]=L;k[x>>2]=9;i[d+13>>0]=0;K=373742;M=L+9|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));M=EJa(l,Q)|0;k[Z>>2]=b;k[Z+4>>2]=M;IJa(375202,Z);k[x>>2]=0;k[Q>>2]=0;M=k[d>>2]|0;k[d>>2]=M+-1;if((M|0)==1)ggb(k[d+-4>>2]|0);b=k[pa>>2]|0;k[w>>2]=0;k[pa>>2]=0;if(b|0?(L=b+-4|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0)ggb(k[b+-8>>2]|0);cIa(R,W,l);he(Y|0,ca|0)|0;b=k[Y>>2]|0;M=k[y>>2]|0;lKa(R);b=Epb(b|0,((b|0)<0)<<31>>31|0,1e6,0)|0;M=kpb(b|0,N|0,M|0,((M|0)<0)<<31>>31|0)|0;b=N;he(Y|0,ca|0)|0;K=k[Y>>2]|0;K=Epb(K|0,((K|0)<0)<<31>>31|0,1e6,0)|0;L=k[z>>2]|0;L=kpb(K|0,N|0,L|0,((L|0)<0)<<31>>31|0)|0;c=(+(L>>>0)+4294967296.0*+(N|0)-(+(M>>>0)+4294967296.0*+(b|0)))/1.0e6+0.0;e=+LJa(R,W,V,O,+o[ta>>2],ba,0);h=+((aa(k[W>>2]<<2,k[P>>2]|0)|0)>>>0);o[D>>2]=(h+ +((k[B>>2]|0)+(k[A>>2]|0)+(k[C>>2]|0)|0))/h;o[T>>2]=e;o[E>>2]=c;h=+o[da>>2];p[_>>3]=c;p[_+8>>3]=e;p[_+16>>3]=h;IJa(375260,_);k[R>>2]=93720;b=k[F>>2]|0;if(b|0)mKa(R,b);b=k[G>>2]|0;if(b|0)ggb(b);b=k[H>>2]|0;if(b|0)do{M=b;b=k[b>>2]|0;ggb(M);k[H>>2]=b}while((b|0)!=0);YHa(k[I>>2]|0);b=k[na>>2]|0;if((b|0)==(k[U>>2]|0))WJa(ma,T);else{VJa(b,T);k[na>>2]=b+28}YHa(k[q>>2]|0);f=f+1|0}while(f>>>0<5);j=j+1|0}while(j>>>0<4);IJa(374932,$);k[X>>2]=k[23399];k[X+4>>2]=k[23400];k[X+8>>2]=k[23401];k[X+12>>2]=k[23402];k[X+16>>2]=k[23403];l=ba+16|0;m=ba+20|0;n=ba+24|0;q=ba+20|0;s=$+4|0;t=$+4|0;u=Y+4|0;v=$+4|0;w=ca+4|0;x=ca+8|0;y=ca+12|0;z=ca+48|0;A=ca+64|0;B=$+4|0;C=ca+84|0;D=ca+88|0;E=ca+20|0;F=ba+8|0;G=ba+4|0;j=0;do{k[m>>2]=0;k[n>>2]=0;k[l>>2]=q;k[$>>2]=0;k[s>>2]=0;b=ZT(16)|0;k[b>>2]=1;L=b+4|0;k[$>>2]=L;k[s>>2]=9;i[b+13>>0]=0;K=373358;M=L+9|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));S=WHa(l,$)|0;k[_>>2]=1;R=k[S>>2]|0;T=S+4|0;jh[k[k[R>>2]>>2]&1023](R,T);k[S>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,_,T);k[s>>2]=0;k[$>>2]=0;T=k[b>>2]|0;k[b>>2]=T+-1;if((T|0)==1)ggb(k[b+-4>>2]|0);k[$>>2]=0;k[t>>2]=0;b=ZT(12)|0;k[b>>2]=1;S=b+4|0;k[$>>2]=S;k[t>>2]=5;i[b+9>>0]=0;i[S>>0]=i[380533]|0;i[S+1>>0]=i[380534]|0;i[S+2>>0]=i[380535]|0;i[S+3>>0]=i[380536]|0;i[S+4>>0]=i[380537]|0;S=WHa(l,$)|0;R=k[S>>2]|0;T=S+4|0;jh[k[k[R>>2]>>2]&1023](R,T);k[S>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,X+(j<<2)|0,T);k[t>>2]=0;k[$>>2]=0;T=k[b>>2]|0;k[b>>2]=T+-1;if((T|0)==1)ggb(k[b+-4>>2]|0);k[Y>>2]=0;k[u>>2]=0;b=ZT(12)|0;k[b>>2]=1;T=b+4|0;k[Y>>2]=T;k[u>>2]=5;i[b+9>>0]=0;i[T>>0]=i[380533]|0;i[T+1>>0]=i[380534]|0;i[T+2>>0]=i[380535]|0;i[T+3>>0]=i[380536]|0;i[T+4>>0]=i[380537]|0;T=EJa(l,Y)|0;k[ja>>2]=T;IJa(374976,ja);k[u>>2]=0;k[Y>>2]=0;T=k[b>>2]|0;k[b>>2]=T+-1;if((T|0)==1)ggb(k[b+-4>>2]|0);bIa(ca,W,l);he($|0,_|0)|0;f=k[$>>2]|0;f=Epb(f|0,((f|0)<0)<<31>>31|0,1e6,0)|0;d=k[v>>2]|0;d=kpb(f|0,N|0,d|0,((d|0)<0)<<31>>31|0)|0;f=N;if((k[w>>2]|0)>0){b=0;do{aJa(k[x>>2]|0,k[y>>2]|0);T=XJa(ca,k[x>>2]|0,k[z>>2]|0)|0;k[(k[A>>2]|0)+(b<<2)>>2]=T;b=b+1|0}while((b|0)<(k[w>>2]|0))}he($|0,_|0)|0;T=k[$>>2]|0;T=Epb(T|0,((T|0)<0)<<31>>31|0,1e6,0)|0;b=k[B>>2]|0;b=kpb(T|0,N|0,b|0,((b|0)<0)<<31>>31|0)|0;e=(+(b>>>0)+4294967296.0*+(N|0)-(+(d>>>0)+4294967296.0*+(f|0)))/1.0e6+0.0;h=+LJa(ca,W,V,O,+o[ta>>2],Z,0);c=+((aa(k[W>>2]<<2,k[P>>2]|0)|0)>>>0);o[F>>2]=(c+ +((k[D>>2]|0)+(k[C>>2]|0)+(k[E>>2]<<2)|0))/c;o[ba>>2]=h;o[G>>2]=e;p[la>>3]=e;p[la+8>>3]=h;IJa(375007,la);YJa(ca);b=k[na>>2]|0;if((b|0)==(k[U>>2]|0))WJa(ma,ba);else{VJa(b,ba);k[na>>2]=b+28}YHa(k[q>>2]|0);j=j+1|0}while(j>>>0<5);f=k[ma>>2]|0;h=+o[f>>2];d=k[fa>>2]|0;b=f;if((d|0)!=(b|0)){e=+o[da>>2];d=(d-b|0)/28|0;c=+o[f+4>>2]*e+h;c=c<h?c:h;if(d>>>0>1){b=1;do{Oa=+o[f+(b*28|0)+4>>2]*e+ +o[f+(b*28|0)>>2];c=Oa<c?Oa:c;b=b+1|0}while((b|0)!=(d|0))}}else c=h;e=h/c;m=ja+4|0;k[m>>2]=0;n=ja+8|0;k[n>>2]=0;q=ja+4|0;k[ja>>2]=q;b=k[f+16>>2]|0;l=f+20|0;if((b|0)!=(l|0)){d=b;while(1){f=d+16|0;j=ZHa(ja,q,la,f)|0;if(!(k[j>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=k[f>>2]|0;k[b+16>>2]=f;k[b+20>>2]=k[d+20>>2];if(f|0){ca=f+-4|0;k[ca>>2]=(k[ca>>2]|0)+1}ba=b+24|0;k[ba>>2]=428704;f=b+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);ca=k[d+24>>2]|0;k[ba>>2]=ca;Ph[k[(k[ca>>2]|0)+8>>2]&511](ca,d+28|0,f);f=k[la>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=f;k[j>>2]=b;f=k[k[ja>>2]>>2]|0;if(f){k[ja>>2]=f;b=k[j>>2]|0}B4(k[m>>2]|0,b);k[n>>2]=(k[n>>2]|0)+1}else d=b;b=k[d+4>>2]|0;if(!b)while(1){b=k[d+8>>2]|0;if((k[b>>2]|0)==(d|0))break;else d=b}else while(1){d=k[b>>2]|0;if(!d)break;else b=d}if((b|0)==(l|0))break;else d=b}}if(c>0.0?(ea=k[fa>>2]|0,g=k[ma>>2]|0,(ea|0)!=(g|0)):0){l=a+108|0;j=0;d=ea;while(1){f=g;h=(+o[f+(j*28|0)+4>>2]*+o[da>>2]+ +o[f+(j*28|0)>>2])/c+ +o[l>>2]*+o[f+(j*28|0)+8>>2];if(h<e){b=f+(j*28|0)+16|0;if((ja|0)!=(b|0)?(YHa(k[q>>2]|0),k[n>>2]=0,k[ja>>2]=q,k[q>>2]=0,ha=k[b>>2]|0,ia=f+(j*28|0)+20|0,(ha|0)!=(ia|0)):0){d=ha;b=ha;while(1){f=d+16|0;g=ZHa(ja,q,la,f)|0;if(!(k[g>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=k[f>>2]|0;k[b+16>>2]=f;k[b+20>>2]=k[d+20>>2];if(f|0){ea=f+-4|0;k[ea>>2]=(k[ea>>2]|0)+1}ca=b+24|0;k[ca>>2]=428704;f=b+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);ea=k[d+24>>2]|0;k[ca>>2]=ea;Ph[k[(k[ea>>2]|0)+8>>2]&511](ea,d+28|0,f);f=k[la>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=f;k[g>>2]=b;f=k[k[ja>>2]>>2]|0;if(f){k[ja>>2]=f;b=k[g>>2]|0}B4(k[m>>2]|0,b);k[n>>2]=(k[n>>2]|0)+1}else d=b;b=k[d+4>>2]|0;if(!b)while(1){b=k[d+8>>2]|0;if((k[b>>2]|0)==(d|0))break;else d=b}else while(1){d=k[b>>2]|0;if(!d)break;else b=d}if((b|0)==(ia|0))break;else d=b}e=h;b=k[ma>>2]|0;d=k[fa>>2]|0}else{e=h;b=g}}else b=g;j=j+1|0;if(j>>>0>=((d-b|0)/28|0)>>>0)break;else g=b}}b=k[ga>>2]|0;if(b|0)ggb(b);b=k[a+60>>2]|0;if(b|0)ggb(b);b=k[a+44>>2]|0;if(b|0)ggb(b);j=oa+4|0;k[j>>2]=0;l=oa+8|0;k[l>>2]=0;m=oa+4|0;k[oa>>2]=m;b=k[ja>>2]|0;if((b|0)!=(q|0)){d=b;while(1){f=d+16|0;g=ZHa(oa,m,la,f)|0;if(!(k[g>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=k[f>>2]|0;k[b+16>>2]=f;k[b+20>>2]=k[d+20>>2];if(f|0){ja=f+-4|0;k[ja>>2]=(k[ja>>2]|0)+1}ia=b+24|0;k[ia>>2]=428704;f=b+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);ja=k[d+24>>2]|0;k[ia>>2]=ja;Ph[k[(k[ja>>2]|0)+8>>2]&511](ja,d+28|0,f);f=k[la>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=f;k[g>>2]=b;f=k[k[oa>>2]>>2]|0;if(f){k[oa>>2]=f;b=k[g>>2]|0}B4(k[j>>2]|0,b);k[l>>2]=(k[l>>2]|0)+1}else d=b;b=k[d+4>>2]|0;if(!b)while(1){b=k[d+8>>2]|0;if((k[b>>2]|0)==(d|0))break;else d=b}else while(1){d=k[b>>2]|0;if(!d)break;else b=d}if((b|0)==(q|0))break;else d=b}}YHa(k[q>>2]|0);YHa(k[ka>>2]|0)}d=k[ma>>2]|0;if(d|0){b=k[na>>2]|0;if((b|0)!=(d|0))do{ma=b;b=b+-28|0;k[na>>2]=b;YHa(k[ma+-8>>2]|0)}while((b|0)!=(d|0));ggb(d)}if((wa|0)!=(oa|0)){m=a+12|0;YHa(k[m>>2]|0);n=a+16|0;k[n>>2]=0;k[wa>>2]=m;k[m>>2]=0;d=k[oa>>2]|0;b=oa+4|0;if((d|0)!=(b|0)){l=a+12|0;f=d;while(1){g=f+16|0;j=ZHa(wa,m,pa,g)|0;if(!(k[j>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}g=k[g>>2]|0;k[d+16>>2]=g;k[d+20>>2]=k[f+20>>2];if(g|0){oa=g+-4|0;k[oa>>2]=(k[oa>>2]|0)+1}na=d+24|0;k[na>>2]=428704;g=d+28|0;k[g>>2]=0;jh[k[k[107176]>>2]&1023](428704,g);oa=k[f+24>>2]|0;k[na>>2]=oa;Ph[k[(k[oa>>2]|0)+8>>2]&511](oa,f+28|0,g);g=k[pa>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=g;k[j>>2]=d;g=k[k[wa>>2]>>2]|0;if(g){k[wa>>2]=g;d=k[j>>2]|0}B4(k[l>>2]|0,d);k[n>>2]=(k[n>>2]|0)+1}else f=d;d=k[f+4>>2]|0;if(!d)while(1){d=k[f+8>>2]|0;if((k[d>>2]|0)==(f|0))break;else f=d}else while(1){f=k[d>>2]|0;if(!f)break;else d=f}if((d|0)==(b|0))break;else f=d}}}else b=oa+4|0;YHa(k[b>>2]|0);HJa(wa,Ga);IJa(374139,ra);IJa(374193,va);D4(qa,Fa);ra=qa+11|0;k[Ba>>2]=(i[ra>>0]|0)<0?k[qa>>2]|0:qa;IJa(418563,Ba);if((i[ra>>0]|0)<0)ggb(k[qa>>2]|0);IJa(374139,Ha);v=aIa(sa,wa)|0;t=a+4|0;k[t>>2]=v;Uh[k[(k[v>>2]|0)+8>>2]&2047](v);v=a+20|0;b=((k[sa>>2]|0)>>>0)/10|0;b=b>>>0>1e3?1e3:b;if((b|0)>0){JJa(Ba,sa,b);IJa(374236,za);f=k[Ba>>2]|0;d=f>>>0>1073741823?-1:f<<2;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[va>>2]=f;j=va+4|0;k[j>>2]=1;l=va+8|0;u=va+12|0;k[u>>2]=b;k[l>>2]=1;he(za|0,Ha|0)|0;n=k[za>>2]|0;n=Epb(n|0,((n|0)<0)<<31>>31|0,1e6,0)|0;m=k[za+4>>2]|0;m=kpb(n|0,N|0,m|0,((m|0)<0)<<31>>31|0)|0;n=N;a:do if(k[Ba>>2]|0){q=Ba+12|0;s=Ba+8|0;f=0;g=1;d=1;while(1){KJa(sa,(k[q>>2]|0)+((aa(k[s>>2]|0,f)|0)<<2)|0,b+((aa(g,f)|0)<<2)|0,d,1);b=f+1|0;if(b>>>0>=(k[Ba>>2]|0)>>>0)break a;f=b;g=k[l>>2]|0;b=k[u>>2]|0;d=k[j>>2]|0}}while(0);he(za|0,Ha|0)|0;qa=k[za>>2]|0;qa=Epb(qa|0,((qa|0)<0)<<31>>31|0,1e6,0)|0;ra=k[za+4>>2]|0;ra=kpb(qa|0,N|0,ra|0,((ra|0)<0)<<31>>31|0)|0;h=(+(ra>>>0)+4294967296.0*+(N|0)-(+(m>>>0)+4294967296.0*+(n|0)))/1.0e6+0.0;IJa(374260,xa);ra=k[t>>2]|0;if((Xh[k[(k[ra>>2]|0)+40>>2]&1023](ra)|0)==2){IJa(374289,ua);d=k[t>>2]|0;o[xa>>2]=0.0;b=d+24|0;o[b>>2]=0.0;e=+LJa(d,sa,Ba,va,+o[ta>>2],za,1);ua=k[za>>2]|0;o[xa>>2]=.20000000298023224;o[b>>2]=.20000000298023224;c=+LJa(d,sa,Ba,va,+o[ta>>2],za,1);qa=e==-1.0|c<e;ra=k[za>>2]|0;e=qa?c:e;o[xa>>2]=.4000000059604645;o[b>>2]=.4000000059604645;c=+LJa(d,sa,Ba,va,+o[ta>>2],za,1);oa=e==-1.0|c<e;pa=k[za>>2]|0;e=oa?c:e;o[xa>>2]=.6000000238418579;o[b>>2]=.6000000238418579;c=+LJa(d,sa,Ba,va,+o[ta>>2],za,1);ma=e==-1.0|c<e;na=k[za>>2]|0;e=ma?c:e;o[xa>>2]=.800000011920929;o[b>>2]=.800000011920929;c=+LJa(d,sa,Ba,va,+o[ta>>2],za,1);ka=e==-1.0|c<e;la=k[za>>2]|0;e=ka?c:e;o[xa>>2]=1.0;o[b>>2]=1.0;c=+LJa(d,sa,Ba,va,+o[ta>>2],za,1);d=e==-1.0|c<e;Oa=d?1.0:ka?.800000011920929:ma?.6000000238418579:oa?.4000000059604645:qa?.20000000298023224:0.0;va=d?k[za>>2]|0:ka?la:ma?na:oa?pa:qa?ra:ua;o[xa>>2]=Oa;k[za>>2]=va;o[b>>2]=Oa;p[ya>>3]=Oa;IJa(374341,ya);k[ya>>2]=0;va=ya+4|0;k[va>>2]=0;b=ZT(16)|0;k[b>>2]=1;ua=b+4|0;k[ya>>2]=ua;k[va>>2]=8;i[b+12>>0]=0;ta=ua;i[ta>>0]=99;i[ta+1>>0]=98;i[ta+2>>0]=95;i[ta+3>>0]=105;ua=ua+4|0;i[ua>>0]=110;i[ua+1>>0]=100;i[ua+2>>0]=101;i[ua+3>>0]=120;ua=WHa(wa,ya)|0;ta=k[ua>>2]|0;wa=ua+4|0;jh[k[k[ta>>2]>>2]&1023](ta,wa);k[ua>>2]=428716;Ph[k[(k[107179]|0)+4>>2]&511](428716,xa,wa);k[va>>2]=0;k[ya>>2]=0;ya=k[b>>2]|0;k[b>>2]=ya+-1;if((ya|0)==1)ggb(k[b+-4>>2]|0);c=d?c:e}else c=+LJa(k[t>>2]|0,sa,Ba,va,+o[ta>>2],za,1);k[Aa>>2]=k[za>>2];IJa(374363,Aa);k[Aa>>2]=0;ya=Aa+4|0;k[ya>>2]=0;b=ZT(12)|0;k[b>>2]=1;wa=b+4|0;k[Aa>>2]=wa;k[ya>>2]=6;i[b+10>>0]=0;i[wa>>0]=i[373823]|0;i[wa+1>>0]=i[373824]|0;i[wa+2>>0]=i[373825]|0;i[wa+3>>0]=i[373826]|0;i[wa+4>>0]=i[373827]|0;i[wa+5>>0]=i[373828]|0;wa=WHa(v,Aa)|0;va=k[wa>>2]|0;xa=wa+4|0;jh[k[k[va>>2]>>2]&1023](va,xa);k[wa>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,za,xa);k[ya>>2]=0;k[Aa>>2]=0;Aa=k[b>>2]|0;k[b>>2]=Aa+-1;if((Aa|0)==1)ggb(k[b+-4>>2]|0);b=k[u>>2]|0;if(b|0)ggb(b);b=k[Ba+12>>2]|0;if(b|0)ggb(b);c=h/c}else c=0.0;o[a+80>>2]=c;k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ha+8>>2]=0;C4(Fa,Ha);if((i[Ha+11>>0]|0)<0)ggb(k[Ha>>2]|0);HJa(v,Ga);IJa(374139,Ia);IJa(374216,Ja);D4(Ea,Fa);Ja=Ea+11|0;k[Ka>>2]=(i[Ja>>0]|0)<0?k[Ea>>2]|0:Ea;IJa(418563,Ka);if((i[Ja>>0]|0)<0)ggb(k[Ea>>2]|0);IJa(374139,La);k[Ga>>2]=49464;k[Ma>>2]=49484;k[Fa>>2]=49500;if((i[Da+11>>0]|0)<0)ggb(k[Da>>2]|0);k[Fa>>2]=169272;b=k[Ca>>2]|0;Ka=b+4|0;La=k[Ka>>2]|0;k[Ka>>2]=La+-1;if(La|0){Tgb(Ma);r=Na;return}Uh[k[(k[b>>2]|0)+8>>2]&2047](b);Tgb(Ma);r=Na;return}function wJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;d=n+8|0;m=n;j=a+4|0;l=k[j>>2]|0;l=Xh[k[(k[l>>2]|0)+40>>2]&1023](l)|0;k[d>>2]=l;l=b+76|0;f=b+16|0;c=k[f>>2]|0;e=(c|0)==0;a:do if((k[l>>2]|0)>-1){do if(e){c=b+74|0;h=i[c>>0]|0;i[c>>0]=h+255|h;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;e=k[b+44>>2]|0;k[b+28>>2]=e;h=b+20|0;k[h>>2]=e;c=e+(k[b+48>>2]|0)|0;k[f>>2]=c;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;h=e;e=k[e>>2]|0}while(0);g=e;if((c-e|0)>>>0<4){ci[k[b+36>>2]&255](b,d,4)|0;break}b:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;e=d;c=g;break b}c=e+-1|0;if((i[d+c>>0]|0)==10)break;else e=c}if((ci[k[b+36>>2]&255](b,d,e)|0)>>>0<e>>>0)break a;f=4-e|0;e=d+e|0;c=k[h>>2]|0}else{f=4;e=d;c=g}while(0);upb(c|0,e|0,f|0)|0;k[h>>2]=(k[h>>2]|0)+f}else{do if(e){c=b+74|0;h=i[c>>0]|0;i[c>>0]=h+255|h;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;e=k[b+44>>2]|0;k[b+28>>2]=e;h=b+20|0;k[h>>2]=e;c=e+(k[b+48>>2]|0)|0;k[f>>2]=c;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;h=e;e=k[e>>2]|0}while(0);g=e;if((c-e|0)>>>0<4){ci[k[b+36>>2]&255](b,d,4)|0;break}c:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;e=d;c=g;break c}c=e+-1|0;if((i[d+c>>0]|0)==10)break;else e=c}if((ci[k[b+36>>2]&255](b,d,e)|0)>>>0<e>>>0)break a;f=4-e|0;e=d+e|0;c=k[h>>2]|0}else{f=4;e=d;c=g}while(0);upb(c|0,e|0,f|0)|0;k[h>>2]=(k[h>>2]|0)+f}while(0);h=k[j>>2]|0;jh[k[(k[h>>2]|0)+20>>2]&1023](h,b);h=m+4|0;e=ZT(12)|0;k[e>>2]=1;f=e+4|0;k[m>>2]=f;k[h>>2]=6;i[e+10>>0]=0;i[f>>0]=i[373823]|0;i[f+1>>0]=i[373824]|0;i[f+2>>0]=i[373825]|0;i[f+3>>0]=i[373826]|0;i[f+4>>0]=i[373827]|0;i[f+5>>0]=i[373828]|0;f=EJa(a+20|0,m)|0;k[d>>2]=f;f=b+16|0;e=k[f>>2]|0;c=(e|0)==0;d:do if((k[l>>2]|0)>-1){do if(c){c=b+74|0;l=i[c>>0]|0;i[c>>0]=l+255|l;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;l=k[b+44>>2]|0;k[b+28>>2]=l;g=b+20|0;k[g>>2]=l;e=l+(k[b+48>>2]|0)|0;k[f>>2]=e;f=l;break}else{k[b>>2]=c|32;break d}}else{f=b+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<4){ci[k[b+36>>2]&255](b,d,4)|0;break}e:do if((i[b+75>>0]|0)>-1){f=4;while(1){if(!f){e=4;break e}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0)break d;e=4-f|0;d=d+f|0;c=k[g>>2]|0}else e=4;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(c){c=b+74|0;l=i[c>>0]|0;i[c>>0]=l+255|l;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;l=k[b+44>>2]|0;k[b+28>>2]=l;g=b+20|0;k[g>>2]=l;e=l+(k[b+48>>2]|0)|0;k[f>>2]=e;f=l;break}else{k[b>>2]=c|32;break d}}else{f=b+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<4){ci[k[b+36>>2]&255](b,d,4)|0;break}f:do if((i[b+75>>0]|0)>-1){f=4;while(1){if(!f){e=4;break f}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0)break d;e=4-f|0;d=d+f|0;c=k[g>>2]|0}else e=4;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);c=k[m>>2]|0;k[h>>2]=0;k[m>>2]=0;if(!c){r=n;return}b=c+-4|0;m=k[b>>2]|0;k[b>>2]=m+-1;if((m|0)!=1){r=n;return}ggb(k[c+-8>>2]|0);r=n;return}function xJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+32|0;e=o+28|0;f=o+16|0;m=o+8|0;n=o;if((_fb(e,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}k[f+4>>2]=0;k[f+8>>2]=0;l=f+4|0;k[f>>2]=l;k[m>>2]=0;c=m+4|0;k[c>>2]=0;d=ZT(16)|0;k[d>>2]=1;g=d+4|0;k[m>>2]=g;k[c>>2]=9;i[d+13>>0]=0;h=373358;j=g+9|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));h=WHa(f,m)|0;k[n>>2]=k[e>>2];g=k[h>>2]|0;j=h+4|0;jh[k[k[g>>2]>>2]&1023](g,j);k[h>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,n,j);k[c>>2]=0;k[m>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);j=aIa(a+84|0,f)|0;k[a+4>>2]=j;jh[k[(k[j>>2]|0)+24>>2]&1023](j,b);if((_fb(m,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}k[n>>2]=0;j=n+4|0;k[j>>2]=0;b=ZT(12)|0;k[b>>2]=1;h=b+4|0;k[n>>2]=h;k[j>>2]=6;i[b+10>>0]=0;i[h>>0]=i[373823]|0;i[h+1>>0]=i[373824]|0;i[h+2>>0]=i[373825]|0;i[h+3>>0]=i[373826]|0;i[h+4>>0]=i[373827]|0;i[h+5>>0]=i[373828]|0;h=WHa(a+20|0,n)|0;g=k[h>>2]|0;a=h+4|0;jh[k[k[g>>2]>>2]&1023](g,a);k[h>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,m,a);k[j>>2]=0;k[n>>2]=0;n=k[b>>2]|0;k[b>>2]=n+-1;if((n|0)!=1){n=k[l>>2]|0;YHa(n);r=o;return}ggb(k[b+-4>>2]|0);n=k[l>>2]|0;YHa(n);r=o;return}function yJa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+28>>2]&1023](a)|0}function zJa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+32>>2]&1023](a)|0}function AJa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0}function BJa(a){a=a|0;return 255}function CJa(a,b){a=a|0;b=b|0;b=k[b+4>>2]|0;jh[k[(k[b>>2]|0)+44>>2]&1023](a,b);return}function DJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;e=ZT(12)|0;k[e>>2]=1;f=e+4|0;i[e+10>>0]=0;i[f>>0]=i[373823]|0;i[f+1>>0]=i[373824]|0;i[f+2>>0]=i[373825]|0;i[f+3>>0]=i[373826]|0;i[f+4>>0]=i[373827]|0;i[f+5>>0]=i[373828]|0;k[g>>2]=-2;g=dIa(d,f,g)|0;f=k[e>>2]|0;k[e>>2]=f+-1;if((f|0)==1)ggb(k[e+-4>>2]|0);e=k[a+4>>2]|0;f=k[(k[e>>2]|0)+48>>2]|0;if((g|0)==-2){dh[f&255](e,b,c,a+20|0);r=h;return}else{dh[f&255](e,b,c,d);r=h;return}}function EJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;m=r;r=r+16|0;n=m;j=a+4|0;a=k[j>>2]|0;do if(a|0){l=k[b>>2]|0;d=(l|0)==0?1016759:l;h=j;c=a;a:while(1){a=c;while(1){c=k[a+16>>2]|0;if((c|0)==(l|0))break;f=(c|0)==0?1016759:c;c=i[f>>0]|0;e=i[d>>0]|0;if(!(c<<24>>24==0?1:c<<24>>24!=e<<24>>24)){g=d;do{f=f+1|0;g=g+1|0;c=i[f>>0]|0;e=i[g>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=e<<24>>24))}if((c&255)>=(e&255))break;a=k[a+4>>2]|0;if(!a){f=h;break a}}c=k[a>>2]|0;if(!c){f=a;break}else h=a}if((f|0)!=(j|0)){a=k[f+16>>2]|0;if((l|0)!=(a|0)){c=(a|0)==0?1016759:a;a=i[d>>0]|0;e=i[c>>0]|0;if(a<<24>>24==0?1:a<<24>>24!=e<<24>>24)c=e;else{do{d=d+1|0;c=c+1|0;a=i[d>>0]|0;e=i[c>>0]|0}while(!(a<<24>>24==0?1:a<<24>>24!=e<<24>>24));c=e}if((a&255)<(c&255))break}a=f+24|0;n=k[a>>2]|0;n=(Xh[k[(k[n>>2]|0)+28>>2]&1023](n)|0)+4|0;if((k[n>>2]|0)==427578){n=k[a>>2]|0;n=Hh[k[(k[n>>2]|0)+20>>2]&511](n,f+28|0)|0;r=m;return k[n>>2]|0}else Cf(te(1)|0,19736,0)}}while(0);e=te(44)|0;j=ZT(24)|0;k[j>>2]=1;a=j+4|0;i[j+23>>0]=0;j=a;l=374010;m=j+19|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=b+4|0;f=k[c>>2]|0;g=f+19|0;d=ZT(f+27&-4)|0;k[d>>2]=1;h=d+4|0;i[h+g>>0]=0;j=h;l=a;m=j+19|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));upb(d+23|0,k[b>>2]|0,k[c>>2]|0)|0;j=ZT(32)|0;k[j>>2]=1;a=j+4|0;i[j+29>>0]=0;j=a;l=374030;m=j+25|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));k[n>>2]=0;m=n+4|0;k[m>>2]=0;l=f+44|0;j=ZT(f+52&-4)|0;k[j>>2]=1;j=j+4|0;k[n>>2]=j;k[m>>2]=l;i[j+l>>0]=0;upb(j|0,h|0,g|0)|0;j=j+g|0;l=a;m=j+25|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));FJa(e,n);Cf(e|0,19720,57);return 0}function FJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;j=m+8|0;c=m;l=j+4|0;d=ZT(8)|0;k[d>>2]=1;d=d+4|0;k[j>>2]=d;k[l>>2]=0;i[d>>0]=0;k[c>>2]=0;d=c+4|0;k[d>>2]=0;e=ZT(88)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=82;i[e+86>>0]=0;g=374056;h=f+82|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Z8(a,0,b,j,c,44);k[d>>2]=0;k[c>>2]=0;h=k[e>>2]|0;k[e>>2]=h+-1;if((h|0)==1)ggb(k[e+-4>>2]|0);b=k[j>>2]|0;k[l>>2]=0;k[j>>2]=0;if(!b){k[a>>2]=93556;r=m;return}j=b+-4|0;l=k[j>>2]|0;k[j>>2]=l+-1;if((l|0)!=1){k[a>>2]=93556;r=m;return}ggb(k[b+-8>>2]|0);k[a>>2]=93556;r=m;return}function GJa(a){a=a|0;T8(a);ggb(a);return}function HJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;m=o;c=k[a>>2]|0;j=a+4|0;if((c|0)==(j|0)){r=o;return}l=m+4|0;while(1){e=k[c+16>>2]|0;e=(e|0)==0?1016759:e;f=e;a:do if(!(f&3)){a=e;n=6}else{d=e;a=f;while(1){if(!(i[d>>0]|0))break a;d=d+1|0;a=d;if(!(a&3)){a=d;n=6;break}}}while(0);if((n|0)==6){n=0;while(1){d=k[a>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))a=a+4|0;else break}if((d&255)<<24>>24)do a=a+1|0;while((i[a>>0]|0)!=0)}h=jS(jS(b,e,a-f|0)|0,374741,3)|0;a=k[c+24>>2]|0;Ph[k[(k[a>>2]|0)+32>>2]&511](a,h,c+28|0);a=k[h+(k[(k[h>>2]|0)+-12>>2]|0)+28>>2]|0;g=a+4|0;k[g>>2]=(k[g>>2]|0)+1;g=Wib(828772)|0;g=k[(k[a+8>>2]|0)+(g<<2)>>2]|0;g=Hh[k[(k[g>>2]|0)+28>>2]&511](g,10)|0;e=a+4|0;f=k[e>>2]|0;k[e>>2]=f+-1;if(!f)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);a=k[(k[h>>2]|0)+-12>>2]|0;d=h+a|0;do if(!(k[d+16>>2]|0)){d=k[d+72>>2]|0;if((d|0)!=0?(k[d+(k[(k[d>>2]|0)+-12>>2]|0)+24>>2]|0)!=0:0){Qhb(m,d);if(i[m>>0]|0?(f=k[d+(k[(k[d>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[f>>2]|0)+24>>2]&1023](f)|0)==-1):0){f=d+(k[(k[d>>2]|0)+-12>>2]|0)+16|0;k[f>>2]=k[f>>2]|1}a=k[l>>2]|0;f=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;if((((k[f+24>>2]|0?(k[f+16>>2]|0)==0:0)?k[f+4>>2]&8192|0:0)?!(bd()|0):0)?(f=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[f>>2]|0)+24>>2]&1023](f)|0)==-1):0){f=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[f>>2]=k[f>>2]|1}a=k[(k[h>>2]|0)+-12>>2]|0}e=k[h+a+24>>2]|0;f=e;if(e){a=f+24|0;d=k[a>>2]|0;if((d|0)!=(k[f+28>>2]|0)){k[a>>2]=d+1;i[d>>0]=g;break}if((Hh[k[(k[e>>2]|0)+52>>2]&511](f,g&255)|0)!=-1)break;a=k[(k[h>>2]|0)+-12>>2]|0}g=h+a+16|0;k[g>>2]=k[g>>2]|1}while(0);g=h+(k[(k[h>>2]|0)+-12>>2]|0)|0;if((((k[g+24>>2]|0?(k[g+16>>2]|0)==0:0)?k[g+4>>2]&8192|0:0)?!(bd()|0):0)?(g=k[h+(k[(k[h>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[g>>2]|0)+24>>2]&1023](g)|0)==-1):0){g=h+(k[(k[h>>2]|0)+-12>>2]|0)+16|0;k[g>>2]=k[g>>2]|1}d=h+(k[(k[h>>2]|0)+-12>>2]|0)|0;a=k[d+24>>2]|0;if(a|0){if(!(k[d+16>>2]|0)){d=k[d+72>>2]|0;if(d){Phb(d);a=k[h+(k[(k[h>>2]|0)+-12>>2]|0)+24>>2]|0}if((Xh[k[(k[a>>2]|0)+24>>2]&1023](a)|0)==-1){g=h+(k[(k[h>>2]|0)+-12>>2]|0)+16|0;k[g>>2]=k[g>>2]|1}}g=h+(k[(k[h>>2]|0)+-12>>2]|0)|0;if((((k[g+24>>2]|0?(k[g+16>>2]|0)==0:0)?k[g+4>>2]&8192|0:0)?!(bd()|0):0)?(g=k[h+(k[(k[h>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[g>>2]|0)+24>>2]&1023](g)|0)==-1):0){h=h+(k[(k[h>>2]|0)+-12>>2]|0)+16|0;k[h>>2]=k[h>>2]|1}}a=k[c+4>>2]|0;if(!a)while(1){a=k[c+8>>2]|0;if((k[a>>2]|0)==(c|0))break;else c=a}else while(1){c=k[a>>2]|0;if(!c)break;else a=c}if((a|0)==(j|0))break;else c=a}r=o;return}function IJa(a,b){a=a|0;b=b|0;var c=0,d=0;d=r;r=r+16|0;c=d;k[c>>2]=b;if(!(i[427784]|0)){i[427784]=1;k[206773]=165796;k[206774]=3;ud(1489,827092,x|0)|0}if((k[206774]|0)<4){r=d;return}mfb(k[206773]|0,a,c)|0;r=d;return}function JJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+32|0;o=p;$Ia(o,k[b>>2]|0);m=b+4|0;n=k[m>>2]|0;e=aa(n,c)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[a>>2]=c;k[a+4>>2]=n;k[a+12>>2]=d;k[a+8>>2]=n;if(!c)a=k[o>>2]|0;else{j=o+16|0;l=b+12|0;h=b+8|0;i=k[o+12>>2]|0;a=k[o>>2]|0;g=0;e=k[j>>2]|0;do{if((e|0)==(i|0)){b=-1;e=i}else{f=e+1|0;k[j>>2]=f;b=k[a+(e<<2)>>2]|0;e=f}f=k[m>>2]|0;if(f|0)wpb(d+((aa(n,g)|0)<<2)|0,(k[l>>2]|0)+((aa(k[h>>2]|0,b)|0)<<2)|0,f<<2|0)|0;g=g+1|0}while((g|0)!=(c|0))}if(!a){r=p;return}d=o+4|0;e=k[d>>2]|0;if((e|0)!=(a|0))k[d>>2]=e+(~((e+-4-a|0)>>>2)<<2);ggb(a);r=p;return}function KJa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0.0,j=0,l=0,m=0,n=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0;x=e+d|0;h=(x|0)==0;if(!h){if(x>>>0>1073741823)ad(426534,426557,304,426811);j=x<<2;g=(j|0)==0?1:j;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}zpb(f|0,0,j|0)|0;if(h)w=0;else{if(x>>>0>1073741823)ad(426534,426557,304,426811);j=x<<2;h=(j|0)==0?1:j;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}zpb(g|0,0,j|0)|0;w=g}}else{w=0;f=0}t=k[a+12>>2]|0;u=a+8|0;v=a+4|0;p=t+(k[v>>2]<<2)|0;l=p+-12|0;m=((l>>>0<t>>>0?t:l)+12+(3-t)|0)>>>4<<2;h=b+(m<<2)|0;if(t>>>0<l>>>0){g=t;j=b;i=0.0;while(1){z=+P(+(+o[g>>2]-+o[j>>2]));y=+P(+(+o[g+4>>2]-+o[j+4>>2]));n=+P(+(+o[g+8>>2]-+o[j+8>>2]));i=i+(z+y+n+ +P(+(+o[g+12>>2]-+o[j+12>>2])));g=g+16|0;if(g>>>0>=l>>>0)break;else j=j+16|0}}else i=0.0;g=t+(m<<2)|0;if(g>>>0<p>>>0)while(1){i=i+ +P(+(+o[g>>2]-+o[h>>2]));g=g+4|0;if(g>>>0>=p>>>0)break;else h=h+4|0}o[w>>2]=i;k[f>>2]=0;if((k[a>>2]|0)>>>0>1){s=1;r=1;while(1){m=t+((aa(k[u>>2]|0,s)|0)<<2)|0;q=m+(k[v>>2]<<2)|0;l=q+-12|0;p=((l>>>0<m>>>0?m:l)+12+(3-m)|0)>>>4<<2;h=b+(p<<2)|0;if(m>>>0<l>>>0){g=m;j=b;i=0.0;while(1){n=+P(+(+o[g>>2]-+o[j>>2]));y=+P(+(+o[g+4>>2]-+o[j+4>>2]));z=+P(+(+o[g+8>>2]-+o[j+8>>2]));i=i+(n+y+z+ +P(+(+o[g+12>>2]-+o[j+12>>2])));g=g+16|0;if(g>>>0>=l>>>0)break;else j=j+16|0}}else i=0.0;g=m+(p<<2)|0;if(g>>>0<q>>>0)while(1){i=i+ +P(+(+o[g>>2]-+o[h>>2]));g=g+4|0;if(g>>>0>=q>>>0)break;else h=h+4|0}if((r|0)>=(x|0)){g=r+-1|0;h=w+(g<<2)|0;if(i<+o[h>>2]){o[h>>2]=i;k[f+(g<<2)>>2]=s;h=r}else h=r}else{k[f+(r<<2)>>2]=s;o[w+(r<<2)>>2]=i;h=r+1|0}a:do if((h|0)>1){g=h;do{l=g;g=g+-1|0;j=w+(g<<2)|0;i=+o[j>>2];l=l+-2|0;m=w+(l<<2)|0;n=+o[m>>2];if(!(i<n))break a;o[j>>2]=n;o[m>>2]=i;p=f+(g<<2)|0;r=f+(l<<2)|0;q=k[p>>2]|0;k[p>>2]=k[r>>2];k[r>>2]=q}while((g|0)>1)}while(0);s=s+1|0;if(s>>>0>=(k[a>>2]|0)>>>0)break;else r=h}}if((d|0)>0){g=0;do{k[c+(g<<2)>>2]=k[f+(g+e<<2)>>2];g=g+1|0}while((g|0)!=(d|0));if(w)ggb(w)}else{ggb(w);if(!f)return}ggb(f);return}function LJa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;var h=0,i=0.0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+48|0;n=u+40|0;q=u+32|0;m=u+24|0;s=u+8|0;p=u;IJa(374395,p);IJa(374454,s);i=+MJa(a,b,c,d,1,s,p,g);if(i>e){IJa(374513,u+16|0);t=1;k[f>>2]=t;e=+o[s>>2];r=u;return +e}if(i<e){h=1;while(1){j=h<<1;i=+MJa(a,b,c,d,j,s,p,g);if(i<e)h=j;else{l=h;break}}}else{l=1;j=1}if(!(+P(+(i-e))>1.0000000474974513e-03)){IJa(374561,n);t=j;k[f>>2]=t;e=+o[s>>2];r=u;return +e}IJa(374536,m);h=(l+j|0)/2|0;i=+MJa(a,b,c,d,h,s,p,g);if(!(+P(+(i-e))>1.0000000474974513e-03)){t=h;k[f>>2]=t;e=+o[s>>2];r=u;return +e}while(1){n=i<e;j=n?j:h;l=n?h:l;h=(l+j|0)/2|0;if((h|0)==(l|0))break;i=+MJa(a,b,c,d,h,s,p,g);if(!(+P(+(i-e))>1.0000000474974513e-03)){t=11;break}}if((t|0)==11){k[f>>2]=h;e=+o[s>>2];r=u;return +e}IJa(374513,q);t=l;k[f>>2]=t;e=+o[s>>2];r=u;return +e}function MJa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,l=0,m=0,n=0,q=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0;da=r;r=r+112|0;ca=da+8|0;j=da;_=da+96|0;$=da+88|0;Z=da+64|0;ba=da+48|0;if(!(k[d+4>>2]|0)){k[j>>2]=0;k[j+4>>2]=1;IJa(374592,j);da=te(44)|0;VHa(da,374616);Cf(da|0,19720,57)}m=h+1|0;k[Z>>2]=93576;X=Z+12|0;k[X>>2]=m;Y=Z+16|0;k[Y>>2]=0;rJa(ba,e);n=(m|0)==0;if(!n){if(m>>>0>1073741823)ad(426534,426557,304,426811);q=m<<2;l=(q|0)==0?1:q;while(1){j=fgb(l)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}s=j;zpb(j|0,0,q|0)|0;if(n)j=0;else{if(m>>>0>1073741823)ad(426534,426557,304,426811);m=m<<2;l=(m|0)==0?1:m;while(1){j=fgb(l)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}zpb(j|0,0,m|0)|0}}else{j=0;s=0}Q=s+(h<<2)|0;R=Z+4|0;S=Z+8|0;T=Z+20|0;U=c+12|0;V=c+8|0;W=d+12|0;J=d+8|0;K=c+4|0;L=_+4|0;M=_+4|0;O=b+12|0;G=b+8|0;E=0;F=0.0;do{E=E+1|0;he(_|0,$|0)|0;I=k[_>>2]|0;I=Epb(I|0,((I|0)<0)<<31>>31|0,1e6,0)|0;H=k[L>>2]|0;H=kpb(I|0,N|0,H|0,((H|0)<0)<<31>>31|0)|0;I=N;if(!(k[c>>2]|0)){t=0.0;i=0.0}else{A=0;t=0.0;D=0;B=k[V>>2]|0;C=k[U>>2]|0;do{k[R>>2]=s;k[S>>2]=j;k[Y>>2]=0;o[T>>2]=3402823466385288598117041.0e14;o[j+((k[X>>2]|0)+-1<<2)>>2]=3402823466385288598117041.0e14;d=C+((aa(B,A)|0)<<2)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,Z,d,ba);d=(k[W>>2]|0)+((aa(k[J>>2]|0,A)|0)<<2)|0;v=k[Q>>2]|0;d=k[d>>2]|0;D=((v|0)==(d|0)&1)+D|0;C=k[U>>2]|0;B=k[V>>2]|0;l=C+((aa(B,A)|0)<<2)|0;z=k[K>>2]|0;w=k[O>>2]|0;x=k[G>>2]|0;d=w+((aa(x,d)|0)<<2)|0;u=d+(z<<2)|0;h=u+-12|0;b=((h>>>0<d>>>0?d:h)+12+(3-d)|0)>>>4<<2;n=l+(b<<2)|0;if(d>>>0<h>>>0){m=d;q=l;i=0.0;while(1){fa=+P(+(+o[m>>2]-+o[q>>2]));ea=+P(+(+o[m+4>>2]-+o[q+4>>2]));y=+P(+(+o[m+8>>2]-+o[q+8>>2]));i=i+(fa+ea+y+ +P(+(+o[m+12>>2]-+o[q+12>>2])));m=m+16|0;if(m>>>0>=h>>>0)break;else q=q+16|0}}else i=0.0;m=d+(b<<2)|0;if(m>>>0<u>>>0)while(1){i=i+ +P(+(+o[m>>2]-+o[n>>2]));m=m+4|0;if(m>>>0>=u>>>0){y=i;break}else n=n+4|0}else y=i;d=w+((aa(x,v)|0)<<2)|0;b=d+(z<<2)|0;q=b+-12|0;h=((q>>>0<d>>>0?d:q)+12+(3-d)|0)>>>4<<2;m=l+(h<<2)|0;if(d>>>0<q>>>0){n=d;i=0.0;while(1){ga=+P(+(+o[n>>2]-+o[l>>2]));ea=+P(+(+o[n+4>>2]-+o[l+4>>2]));fa=+P(+(+o[n+8>>2]-+o[l+8>>2]));i=i+(ga+ea+fa+ +P(+(+o[n+12>>2]-+o[l+12>>2])));n=n+16|0;if(n>>>0>=q>>>0)break;else l=l+16|0}}else i=0.0;l=d+(h<<2)|0;if(l>>>0<b>>>0)while(1){i=i+ +P(+(+o[l>>2]-+o[m>>2]));l=l+4|0;if(l>>>0>=b>>>0)break;else m=m+4|0}if(y==0.0&i==0.0)i=1.0;else i=i/y+0.0;t=t+i;A=A+1|0}while(A>>>0<(k[c>>2]|0)>>>0);i=+(D|0)}he(_|0,$|0)|0;C=k[_>>2]|0;C=Epb(C|0,((C|0)<0)<<31>>31|0,1e6,0)|0;D=k[M>>2]|0;D=kpb(C|0,N|0,D|0,((D|0)<0)<<31>>31|0)|0;F=F+(+(D>>>0)+4294967296.0*+(N|0)-(+(H>>>0)+4294967296.0*+(I|0)))/1.0e6}while(F<.2);o[f>>2]=F/+(E|0);$=k[c>>2]|0;ga=+($>>>0);i=i/ga;ga=t/ga;o[g>>2]=ga;fa=+o[f>>2];k[ca>>2]=e;p[ca+8>>3]=i;p[ca+16>>3]=fa;p[ca+24>>3]=fa*1.0e3/+($>>>0);p[ca+32>>3]=ga;IJa(374680,ca);if(j|0)ggb(j);if(!s){ca=ba+4|0;ca=k[ca>>2]|0;YHa(ca);r=da;return +i}ggb(s);ca=ba+4|0;ca=k[ca>>2]|0;YHa(ca);r=da;return +i}function NJa(a){a=a|0;return}function OJa(a){a=a|0;ggb(a);return}function PJa(a){a=a|0;return (k[a+16>>2]|0)==(k[a+12>>2]|0)|0}function QJa(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=a+20|0;if(+o[n>>2]<=b)return;i=a+16|0;d=k[i>>2]|0;l=a+8|0;m=d;while(1){if((m|0)<=0)break;e=m+-1|0;h=k[l>>2]|0;f=+o[h+(e<<2)>>2];if(!(f<=b))m=e;else{g=5;break}}a:do if((g|0)==5?f==b:0){g=k[a+4>>2]|0;while(1){if((k[g+(e<<2)>>2]|0)==(c|0))break;if((e|0)<=0)break a;e=e+-1|0;if(!(+o[h+(e<<2)>>2]==b))break a}return}while(0);j=a+12|0;if((d|0)<(k[j>>2]|0)){d=d+1|0;k[i>>2]=d}e=d+-1|0;h=k[l>>2]|0;g=k[a+4>>2]|0;if((e|0)>(m|0))while(1){d=d+-2|0;k[h+(e<<2)>>2]=k[h+(d<<2)>>2];k[g+(e<<2)>>2]=k[g+(d<<2)>>2];d=e+-1|0;if((d|0)>(m|0)){a=e;e=d;d=a}else break}o[h+(m<<2)>>2]=b;k[g+(m<<2)>>2]=c;k[n>>2]=k[h+((k[j>>2]|0)+-1<<2)>>2];return}function RJa(a){a=a|0;return +(+o[a+20>>2])}function SJa(a){a=a|0;a=k[a>>2]|0;if((a|0)==0|(a|0)==165796)return;Qfb(a)|0;return}function TJa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;b=g+8|0;c=g;k[a+4>>2]=0;k[a+8>>2]=0;k[a>>2]=a+4;k[b>>2]=0;d=b+4|0;k[d>>2]=0;e=ZT(16)|0;k[e>>2]=1;f=e+4|0;k[b>>2]=f;k[d>>2]=9;i[e+13>>0]=0;h=373358;j=f+9|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));h=WHa(a,b)|0;k[c>>2]=0;f=k[h>>2]|0;j=h+4|0;jh[k[k[f>>2]>>2]&1023](f,j);k[h>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,c,j);k[d>>2]=0;k[b>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)!=1){r=g;return}ggb(k[e+-4>>2]|0);r=g;return}function UJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;m=b+4|0;n=k[m>>2]|0;e=aa(n,c)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[a>>2]=c;k[a+4>>2]=n;k[a+12>>2]=d;k[a+8>>2]=n;if((c|0)<=0){p=k[b>>2]|0;p=p-c|0;k[b>>2]=p;return}a=b+12|0;f=b+8|0;h=428e3;e=0;g=k[h>>2]|0;h=k[h+4>>2]|0;do{q=+((k[b>>2]|0)-e|0);i=Epb(g|0,h|0,1284865837,1481765933)|0;g=kpb(i|0,N|0,1,0)|0;h=N;i=ppb(g|0,h|0,33)|0;i=~~(q*(+(i|0)*4.656612873077393e-10));j=k[m>>2]|0;if(j|0?(wpb(d+((aa(n,e)|0)<<2)|0,(k[a>>2]|0)+((aa(k[f>>2]|0,i)|0)<<2)|0,j<<2|0)|0,l=k[m>>2]|0,o=k[a>>2]|0,p=k[f>>2]|0,l|0):0)wpb(o+((aa(p,i)|0)<<2)|0,o+((aa((k[b>>2]|0)+~e|0,p)|0)<<2)|0,l<<2|0)|0;e=e+1|0}while((e|0)!=(c|0));p=428e3;k[p>>2]=g;k[p+4>>2]=h;p=k[b>>2]|0;p=p-c|0;k[b>>2]=p;return}function VJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];h=a+16|0;i=a+20|0;k[i>>2]=0;j=a+24|0;k[j>>2]=0;f=a+20|0;k[h>>2]=f;a=k[b+16>>2]|0;e=b+20|0;if((a|0)==(e|0)){r=l;return}b=a;while(1){c=b+16|0;d=ZHa(h,f,g,c)|0;if(!(k[d>>2]|0)){while(1){a=fgb(32)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;Qh[a&7]()}c=k[c>>2]|0;k[a+16>>2]=c;k[a+20>>2]=k[b+20>>2];if(c|0){c=c+-4|0;k[c>>2]=(k[c>>2]|0)+1}n=a+24|0;k[n>>2]=428704;c=a+28|0;k[c>>2]=0;jh[k[k[107176]>>2]&1023](428704,c);m=k[b+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,b+28|0,c);c=k[g>>2]|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=c;k[d>>2]=a;c=k[k[h>>2]>>2]|0;if(c){k[h>>2]=c;a=k[d>>2]|0}B4(k[i>>2]|0,a);k[j>>2]=(k[j>>2]|0)+1}else b=a;a=k[b+4>>2]|0;if(!a)while(1){a=k[b+8>>2]|0;if((k[a>>2]|0)==(b|0))break;else b=a}else while(1){b=k[a>>2]|0;if(!b)break;else a=b}if((a|0)==(e|0))break;else b=a}r=l;return}function WJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;h=a+4|0;c=k[a>>2]|0;e=((k[h>>2]|0)-c|0)/28|0;d=e+1|0;if(d>>>0>153391689)ad(426534,426557,304,426811);i=a+8|0;g=((k[i>>2]|0)-c|0)/28|0;f=g<<1;f=g>>>0<76695844?(f>>>0<d>>>0?d:f):153391689;if(!f)c=0;else{if(f>>>0>153391689){i=te(4)|0;k[i>>2]=172664;Cf(i|0,28816,1287)}d=f*28|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}d=c+(e*28|0)|0;e=d;g=c+(f*28|0)|0;VJa(d,b);b=d+28|0;f=k[a>>2]|0;c=k[h>>2]|0;if((c|0)==(f|0)){d=e;e=f;c=f}else{do{c=c+-28|0;VJa(d+-28|0,c);d=e+-28|0;e=d}while((c|0)!=(f|0));d=e;e=k[a>>2]|0;c=k[h>>2]|0}k[a>>2]=d;k[h>>2]=b;k[i>>2]=g;d=e;if((c|0)!=(d|0))do{YHa(k[c+-8>>2]|0);c=c+-28|0}while((c|0)!=(d|0));if(!e)return;ggb(e);return}function XJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+32|0;y=z;g=a+68|0;d=k[g>>2]|0;a:do if((d|0)<16){w=a+88|0;k[w>>2]=(k[w>>2]|0)+d;d=fgb(8192)|0;if(d|0){f=a+72|0;k[d>>2]=k[f>>2];k[f>>2]=d;k[g>>2]=8188;f=d+4|0;e=a+76|0;k[e>>2]=f;d=8172;x=28;break}d=k[41482]|0;e=(d|0)==0;if((k[41497]|0)>-1){do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;f=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;f=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){f=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;f=0;break}else{do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;f=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;f=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){f=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;f=0;break}}else{f=a+76|0;e=f;f=k[f>>2]|0;d=d+-16|0;x=28}while(0);if((x|0)==28){k[e>>2]=f+16;k[g>>2]=d;x=a+84|0;k[x>>2]=(k[x>>2]|0)+16}if((c|0)==1){k[f+12>>2]=0;k[f+8>>2]=0;k[f>>2]=k[b>>2];r=z;return f|0}w=a+56|0;d=a+52|0;zpb(k[w>>2]|0,0,k[d>>2]<<2|0)|0;s=a+60|0;zpb(k[s>>2]|0,0,k[d>>2]<<2|0)|0;v=(c|0)<101?c:101;p=(c|0)>0;if(p){m=k[a+32>>2]|0;n=k[a+28>>2]|0;e=k[d>>2]|0;if(!e)x=48;else{j=k[w>>2]|0;g=0;do{l=m+((aa(n,k[b+(g<<2)>>2]|0)|0)<<2)|0;d=0;do{x=j+(d<<2)|0;o[x>>2]=+o[l+(d<<2)>>2]+ +o[x>>2];d=d+1|0}while((d|0)!=(e|0));g=g+1|0}while((g|0)<(v|0));x=38}}else{e=k[d>>2]|0;x=38}do if((x|0)==38){if(!e){t=0;q=1}else{h=+(v|0);g=k[w>>2]|0;d=0;do{t=g+(d<<2)|0;o[t>>2]=+o[t>>2]/h;d=d+1|0}while((d|0)!=(e|0));t=e;q=0}if(p){m=k[a+32>>2]|0;n=k[a+28>>2]|0;if(q){x=48;break}l=k[w>>2]|0;g=k[s>>2]|0;e=0;do{j=m+((aa(n,k[b+(e<<2)>>2]|0)|0)<<2)|0;d=0;do{h=+o[j+(d<<2)>>2]-+o[l+(d<<2)>>2];s=g+(d<<2)|0;o[s>>2]=+o[s>>2]+h*h;d=d+1|0}while(d>>>0<t>>>0);e=e+1|0}while((e|0)<(v|0));p=g}else p=k[s>>2]|0;if(q)d=0;else{n=0;d=0;do{if((d|0)>=5){e=y+(d+-1<<2)|0;if(+o[p+(n<<2)>>2]>+o[p+(k[e>>2]<<2)>>2]){k[e>>2]=n;x=54}}else{k[y+(d<<2)>>2]=n;d=d+1|0;x=54}b:do if((x|0)==54){x=0;if((d|0)>1){e=d;do{l=e;e=e+-1|0;g=y+(e<<2)|0;j=k[g>>2]|0;l=y+(l+-2<<2)|0;m=k[l>>2]|0;if(!(+o[p+(j<<2)>>2]>+o[p+(m<<2)>>2]))break b;k[g>>2]=m;k[l>>2]=j}while((e|0)>1)}}while(0);n=n+1|0}while((n|0)!=(t|0))}}while(0);if((x|0)==48)d=0;q=428e3;q=Epb(k[q>>2]|0,k[q+4>>2]|0,1284865837,1481765933)|0;q=kpb(q|0,N|0,1,0)|0;v=N;p=428e3;k[p>>2]=q;k[p+4>>2]=v;v=ppb(q|0,v|0,33)|0;v=k[y+(~~(+(d|0)*(+(v|0)*4.656612873077393e-10))<<2)>>2]|0;q=k[(k[w>>2]|0)+(v<<2)>>2]|0;h=(k[u>>2]=q,+o[u>>2]);p=c+-1|0;s=a+32|0;t=a+28|0;n=p;d=0;c:while(1){d:do if((d|0)<=(n|0)){g=k[s>>2]|0;j=k[t>>2]|0;while(1){y=g+((aa(j,k[b+(d<<2)>>2]|0)|0)<<2)+(v<<2)|0;if(!(+o[y>>2]<h))break d;e=d+1|0;if((d|0)<(n|0))d=e;else{d=e;break}}}while(0);if((d|0)>(n|0)){e=d;break}l=k[s>>2]|0;m=k[t>>2]|0;e=n;while(1){g=b+(e<<2)|0;j=k[g>>2]|0;y=l+((aa(m,j)|0)<<2)+(v<<2)|0;if(!(+o[y>>2]>=h))break;if((d|0)<(e|0))e=e+-1|0;else{e=d;break c}}y=b+(d<<2)|0;n=k[y>>2]|0;k[y>>2]=j;k[g>>2]=n;n=e+-1|0;d=d+1|0}e:while(1){f:do if((e|0)<=(p|0)){j=k[s>>2]|0;l=k[t>>2]|0;while(1){y=j+((aa(l,k[b+(e<<2)>>2]|0)|0)<<2)+(v<<2)|0;if(!(+o[y>>2]<=h))break f;g=e+1|0;if((e|0)<(p|0))e=g;else{e=g;break}}}while(0);if((e|0)>(p|0))break;m=k[s>>2]|0;n=k[t>>2]|0;g=p;while(1){j=b+(g<<2)|0;l=k[j>>2]|0;y=m+((aa(n,l)|0)<<2)+(v<<2)|0;if(!(+o[y>>2]>h))break;if((e|0)<(g|0))g=g+-1|0;else break e}y=b+(e<<2)|0;p=k[y>>2]|0;k[y>>2]=l;k[j>>2]=p;p=g+-1|0;e=e+1|0}y=(c|0)/2|0;y=(d|0)==(c|0)|(e|0)==0?y:(d|0)>(y|0)?d:(e|0)<(y|0)?e:y;k[f>>2]=v;k[f+4>>2]=q;x=XJa(a,b,y)|0;k[f+8>>2]=x;c=XJa(a,b+(y<<2)|0,c-y|0)|0;k[f+12>>2]=c;r=z;return f|0}function YJa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=93624;b=k[a+64>>2]|0;if(b|0)ggb(b);b=k[a+56>>2]|0;if(b|0)ggb(b);b=k[a+60>>2]|0;if(b|0)ggb(b);c=a+72|0;b=k[c>>2]|0;if(b|0)do{d=b;b=k[b>>2]|0;ggb(d);k[c>>2]=b}while((b|0)!=0);YHa(k[a+40>>2]|0);d=k[a+8>>2]|0;if(!d)return;b=a+12|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-4-d|0)>>>2)<<2);ggb(d);return}function ZJa(a){a=a|0;YJa(a);ggb(a);return}function _Ja(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;c=a+4|0;if((k[c>>2]|0)<=0)return;d=a+8|0;e=a+12|0;f=a+48|0;g=a+64|0;b=0;do{aJa(k[d>>2]|0,k[e>>2]|0);h=XJa(a,k[d>>2]|0,k[f>>2]|0)|0;k[(k[g>>2]|0)+(b<<2)>>2]=h;b=b+1|0}while((b|0)<(k[c>>2]|0));return}function $Ja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=a+4|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[b+76>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}b:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break b}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}c:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break c}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);if((k[h>>2]|0)<=0)return;d=a+64|0;c=0;do{kKa(b,k[(k[d>>2]|0)+(c<<2)>>2]|0);c=c+1|0}while((c|0)<(k[h>>2]|0));return}function aKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;j=m+8|0;h=m;f=a+4|0;if((_fb(f,4,1,b)|0)!=1){m=te(44)|0;VHa(m,373124);Cf(m|0,19720,57)}l=a+64|0;c=k[l>>2]|0;if(c|0)ggb(c);e=k[f>>2]|0;d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[l>>2]=c;if((e|0)>0?(jKa(a,b,c),(k[f>>2]|0)>1):0){c=1;do{jKa(a,b,(k[l>>2]|0)+(c<<2)|0);c=c+1|0}while((c|0)<(k[f>>2]|0))}g=a+36|0;c=j+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=9;i[d+13>>0]=0;b=373358;f=e+9|0;do{i[e>>0]=i[b>>0]|0;e=e+1|0;b=b+1|0}while((e|0)<(f|0));f=WHa(g,j)|0;b=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[h>>2]=b;b=k[f>>2]|0;a=f+4|0;jh[k[k[b>>2]>>2]&1023](b,a);k[f>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,h,a);k[c>>2]=0;k[j>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);h=j+4|0;c=ZT(12)|0;k[c>>2]=1;f=c+4|0;k[j>>2]=f;k[h>>2]=5;i[c+9>>0]=0;i[f>>0]=i[380533]|0;i[f+1>>0]=i[380534]|0;i[f+2>>0]=i[380535]|0;i[f+3>>0]=i[380536]|0;i[f+4>>0]=i[380537]|0;g=WHa(g,j)|0;f=k[g>>2]|0;a=g+4|0;jh[k[k[f>>2]>>2]&1023](f,a);k[g>>2]=827100;Ph[k[(k[206775]|0)+4>>2]&511](827100,l,a);k[h>>2]=0;k[j>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)!=1){r=m;return}ggb(k[c+-4>>2]|0);r=m;return}function bKa(a){a=a|0;return k[a+48>>2]|0}function cKa(a){a=a|0;return k[a+52>>2]|0}function dKa(a){a=a|0;return (k[a+88>>2]|0)+(k[a+84>>2]|0)+(k[a+20>>2]<<2)|0}function eKa(a){a=a|0;return 1}function fKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+36>>2]|0;f=b+40|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}
function Vaa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0.0,i=0,l=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;O=r;r=r+16464|0;K=O+16440|0;L=O+16384|0;M=O;c=k[b>>2]|0;N=(k[a+108>>2]|0)>>>1;J=b+4|0;if((c|0)>=(k[J>>2]|0)){r=O;return}q=a+124|0;s=a+116|0;t=a+120|0;v=K+4|0;w=K+8|0;x=K+12|0;y=a+4|0;z=a+52|0;A=L+16|0;B=L+44|0;C=a+128|0;D=a+132|0;E=L+36|0;F=L+4|0;G=L+40|0;H=L+48|0;I=L+32|0;p=(k[a+76>>2]|0)+(aa(k[k[a+104>>2]>>2]|0,c)|0)|0;while(1){n=k[q>>2]|0;l=k[s>>2]|0;i=aa(l,(c|0)%(n|0)|0)|0;k[K>>2]=i;i=k[t>>2]|0;n=aa(i,(c|0)/(n|0)|0)|0;k[v>>2]=n;k[w>>2]=l;k[x>>2]=i;I1(L,y,K);zpb(M|0,0,16384)|0;n=(k[z>>2]|0)>>>1;e=k[A>>2]|0;a=i+-1|0;a:do if(i|0){f=l+-4|0;if((l|0)<4){f=(l|0)>0;while(1){if(f){b=0;do{i=M+((m[e+(b<<1)>>1]|0)>>>4<<2)|0;k[i>>2]=(k[i>>2]|0)+1;b=b+1|0}while((b|0)!=(l|0))}if(!a)break a;else{e=e+(n<<1)|0;a=a+-1|0}}}g=l&-4;i=(g|0)<(l|0);while(1){b=0;do{P=m[e+((b|1)<<1)>>1]|0;Q=M+((m[e+(b<<1)>>1]|0)>>>4<<2)|0;k[Q>>2]=(k[Q>>2]|0)+1;P=M+(P>>>4<<2)|0;k[P>>2]=(k[P>>2]|0)+1;P=m[e+((b|3)<<1)>>1]|0;Q=M+((m[e+((b|2)<<1)>>1]|0)>>>4<<2)|0;k[Q>>2]=(k[Q>>2]|0)+1;P=M+(P>>>4<<2)|0;k[P>>2]=(k[P>>2]|0)+1;b=b+4|0}while((b|0)<=(f|0));if(i){b=g;do{Q=M+((m[e+(b<<1)>>1]|0)>>>4<<2)|0;k[Q>>2]=(k[Q>>2]|0)+1;b=b+1|0}while((b|0)!=(l|0))}if(!a)break;else{e=e+(n<<1)|0;a=a+-1|0}}}while(0);g=k[C>>2]|0;if((g|0)>0){f=0;b=0;while(1){a=M+(f<<2)|0;e=k[a>>2]|0;if((e|0)>(g|0)){k[a>>2]=g;e=e+b-g|0}else e=b;f=f+1|0;if((f|0)==4096)break;else b=e}a=(e|0)/4096|0;b=0;do{Q=M+(b<<2)|0;k[Q>>2]=(k[Q>>2]|0)+a;b=b+1|0}while((b|0)!=4096);a=e-(a<<12)|0;if((a|0)>0){b=0;do{Q=M+(b<<2)|0;k[Q>>2]=(k[Q>>2]|0)+1;b=b+1|0}while((b|0)!=(a|0))}}h=+o[D>>2];a=0;e=0;do{a=(k[M+(e<<2)>>2]|0)+a|0;d=h*+(a|0);b=(o[u>>2]=d,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;d=b?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=b?-0.0:0.0}Q=~~d;j[p+(e<<1)>>1]=Q>>>0<65536?Q:(Q|0)>0?65535:0;e=e+1|0}while((e|0)!=4096);b=k[E>>2]|0;if(b|0?(P=b+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){a=k[E>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[I>>2]|0;if(!b){b=B1()|0;a=k[E>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[E>>2]=0}k[E>>2]=0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[F>>2]|0)>0){a=k[G>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[F>>2]|0))}b=k[B>>2]|0;if(!((b|0)==(H|0)|(b|0)==0))ggb(k[b+-4>>2]|0);c=c+1|0;if((c|0)>=(k[J>>2]|0))break;else p=p+(N<<1)|0}r=O;return}function Waa(a){a=a|0;ggb(a);return}function Xaa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Yaa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=51944;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Zaa(a){a=a|0;Yaa(a);ggb(a);return}function _aa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;N=r;r=r+1104|0;J=N+1080|0;K=N+1024|0;L=N;c=k[b>>2]|0;M=k[a+108>>2]|0;I=b+4|0;if((c|0)>=(k[I>>2]|0)){r=N;return}p=a+124|0;q=a+116|0;s=a+120|0;t=J+4|0;v=J+8|0;w=J+12|0;x=a+4|0;y=a+52|0;z=K+16|0;A=K+44|0;B=a+128|0;C=a+132|0;D=K+36|0;E=K+4|0;F=K+40|0;G=K+48|0;H=K+32|0;n=(k[a+76>>2]|0)+(aa(k[k[a+104>>2]>>2]|0,c)|0)|0;while(1){g=k[p>>2]|0;f=k[q>>2]|0;b=aa(f,(c|0)%(g|0)|0)|0;k[J>>2]=b;b=k[s>>2]|0;g=aa(b,(c|0)/(g|0)|0)|0;k[t>>2]=g;k[v>>2]=f;k[w>>2]=b;I1(K,x,J);zpb(L|0,0,1024)|0;g=k[y>>2]|0;if(b|0){h=(f|0)<4;j=f+-4|0;m=f&-4;e=k[z>>2]|0;while(1){b=b+-1|0;if(h)a=0;else{a=0;do{O=l[e+(a|1)>>0]|0;P=L+((l[e+a>>0]|0)<<2)|0;k[P>>2]=(k[P>>2]|0)+1;O=L+(O<<2)|0;k[O>>2]=(k[O>>2]|0)+1;O=l[e+(a|3)>>0]|0;P=L+((l[e+(a|2)>>0]|0)<<2)|0;k[P>>2]=(k[P>>2]|0)+1;O=L+(O<<2)|0;k[O>>2]=(k[O>>2]|0)+1;a=a+4|0}while((a|0)<=(j|0));a=m}if((a|0)<(f|0))do{P=L+((l[e+a>>0]|0)<<2)|0;k[P>>2]=(k[P>>2]|0)+1;a=a+1|0}while((a|0)!=(f|0));if(!b)break;else e=e+g|0}}g=k[B>>2]|0;if((g|0)>0){f=0;b=0;while(1){a=L+(f<<2)|0;e=k[a>>2]|0;if((e|0)>(g|0)){k[a>>2]=g;e=e+b-g|0}else e=b;f=f+1|0;if((f|0)==256)break;else b=e}a=(e|0)/256|0;b=0;do{P=L+(b<<2)|0;k[P>>2]=(k[P>>2]|0)+a;b=b+1|0}while((b|0)!=256);a=e-(a<<8)|0;if((a|0)>0){b=0;do{P=L+(b<<2)|0;k[P>>2]=(k[P>>2]|0)+1;b=b+1|0}while((b|0)!=(a|0));a=0;e=0}else{a=0;e=0}}else{a=0;e=0}do{a=(k[L+(e<<2)>>2]|0)+a|0;d=+o[C>>2]*+(a|0);b=(o[u>>2]=d,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;d=b?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=b?-0.0:0.0}P=~~d;i[n+e>>0]=P>>>0<256?P:(P|0)>0?255:0;e=e+1|0}while((e|0)!=256);b=k[D>>2]|0;if(b|0?(O=b+12|0,P=k[O>>2]|0,k[O>>2]=P+-1,(P|0)==1):0){a=k[D>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[H>>2]|0;if(!b){b=B1()|0;a=k[D>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[D>>2]=0}k[D>>2]=0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[E>>2]|0)>0){a=k[F>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[E>>2]|0))}b=k[A>>2]|0;if(!((b|0)==(G|0)|(b|0)==0))ggb(k[b+-4>>2]|0);c=c+1|0;if((c|0)>=(k[I>>2]|0))break;else n=n+M|0}r=N;return}function $aa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0.0,n=0,p=0,q=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;ta=r;r=r+3552|0;la=ta+16|0;ka=ta;ja=ta+464|0;sa=ta+176|0;ra=ta+120|0;J=ta+456|0;x=ta+448|0;H=ta+440|0;y=ta+432|0;z=ta+424|0;C=ta+416|0;A=ta+408|0;K=ta+400|0;P=ta+392|0;D=ta+384|0;L=ta+376|0;M=ta+368|0;Q=ta+360|0;N=ta+352|0;_=ta+72|0;R=ta+344|0;U=ta+336|0;T=ta+328|0;I=ta+320|0;X=ta+264|0;S=ta+256|0;V=ta+248|0;E=ta+240|0;F=ta+232|0;s=S1(a,-1)|0;G=s>>>3;w=G&511;ga=w+1|0;$=s&7;do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[sa>>2]=k[g>>2];n=sa+4|0;e=g+4|0;k[n>>2]=k[e>>2];qa=sa+8|0;k[qa>>2]=k[g+8>>2];k[sa+12>>2]=k[g+12>>2];k[sa+16>>2]=k[g+16>>2];k[sa+20>>2]=k[g+20>>2];k[sa+24>>2]=k[g+24>>2];k[sa+28>>2]=k[g+28>>2];k[sa+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[sa+36>>2]=f;p=sa+40|0;k[p>>2]=qa;qa=sa+48|0;h=sa+44|0;k[h>>2]=qa;k[sa+52>>2]=0;k[qa>>2]=0;if(f|0){qa=f+12|0;k[qa>>2]=(k[qa>>2]|0)+1}if((k[e>>2]|0)<3){pa=k[g+44>>2]|0;qa=k[h>>2]|0;k[qa>>2]=k[pa>>2];k[qa+4>>2]=k[pa+4>>2];qa=p;break}k[n>>2]=0;x1(sa,k[e>>2]|0,0,0,0);if((k[n>>2]|0)>0){j=k[g+40>>2]|0;l=k[p>>2]|0;g=k[g+44>>2]|0;f=k[h>>2]|0;e=0;do{k[l+(e<<2)>>2]=k[j+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[n>>2]|0));qa=p}else qa=p}else{Q1(sa,a,-1);qa=sa+40|0}while(0);k[ra>>2]=1124007936;na=ra+4|0;ha=ra+8|0;ma=ra+40|0;ba=na;ca=ba+36|0;do{k[ba>>2]=0;ba=ba+4|0}while((ba|0)<(ca|0));k[ma>>2]=ha;pa=ra+48|0;oa=ra+44|0;k[oa>>2]=pa;k[ra+52>>2]=0;k[pa>>2]=0;da=k[qa>>2]|0;ea=k[da+4>>2]|0;da=k[da>>2]|0;ia=($|0)==0;fa=($|0)==2;h=($|0)==5;g=s&255;switch(g&7){case 0:case 2:case 5:break;default:{k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(60)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=52;i[f+56>>0]=0;p=237483;ca=ba+52|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,7935);k[e>>2]=0;k[la>>2]=0;ca=k[f>>2]|0;k[f>>2]=ca+-1;if((ca|0)==1)ggb(k[f+-4>>2]|0)}}a:do switch(c|0){case 5:case 4:case 3:case 1:case 2:case 0:{if((G&510|0)!=2){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=20;i[f+24>>0]=0;p=237612;ca=ba+20|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,7943);k[e>>2]=0;k[la>>2]=0;ha=k[f>>2]|0;k[f>>2]=ha+-1;if((ha|0)==1)ggb(k[f+-4>>2]|0)}s=(c|0)==5|(c|2|0)==2?4:3;d=(c|1|0)==1?0:2;k[J>>2]=ea;k[J+4>>2]=da;x2(b,J,$|(s<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];c=la+8|0;k[c>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=c;c=la+48|0;l=la+44|0;k[l>>2]=c;k[la+52>>2]=0;k[c>>2]=0;if(f|0){c=f+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[e>>2]|0)<3){ha=k[h+44>>2]|0;c=k[l>>2]|0;k[c>>2]=k[ha>>2];k[c+4>>2]=k[ha+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ha=e+12|0,c=k[ha>>2]|0,k[ha>>2]=c+-1,(c|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;c=la+16|0;f=la+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);if(ia){k[ja>>2]=ga;k[ja+4>>2]=s;k[ja+8>>2]=d;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52104;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Uda(ka,la);break a}if(fa){k[ja>>2]=ga;k[ja+4>>2]=s;k[ja+8>>2]=d;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52124;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Sda(ka,la);break a}else{k[ja>>2]=ga;k[ja+4>>2]=s;k[ja+8>>2]=d;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52144;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Qda(ka,la);break a}}case 27:case 17:case 26:case 16:case 23:case 13:case 22:case 12:{if(!(ia&(G&510|0)==2)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(48)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=40;i[f+44>>0]=0;p=237633;ca=ba+40|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,7966);k[e>>2]=0;k[la>>2]=0;ia=k[f>>2]|0;k[f>>2]=ia+-1;if((ia|0)==1)ggb(k[f+-4>>2]|0)}k[x>>2]=ea;k[x+4>>2]=da;x2(b,x,8,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ia=la+8|0;k[ia>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ia;ia=la+48|0;l=la+44|0;k[l>>2]=ia;k[la+52>>2]=0;k[ia>>2]=0;if(f|0){ia=f+12|0;k[ia>>2]=(k[ia>>2]|0)+1}if((k[e>>2]|0)<3){ha=k[h+44>>2]|0;ia=k[l>>2]|0;k[ia>>2]=k[ha>>2];k[ia+4>>2]=k[ha+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ha=e+12|0,ia=k[ha>>2]|0,k[ha>>2]=ia+-1,(ia|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ia=la+16|0;f=la+4|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);switch(c|0){case 12:case 16:case 22:{f=0;break}default:f=(c|0)==26?0:2}switch(c|0){case 12:case 13:case 16:{e=6;break}default:e=(c|0)==17?6:5}k[ja>>2]=ga;k[ja+4>>2]=f;k[ja+8>>2]=e;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52164;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Oda(ka,la);break}case 29:case 19:case 28:case 18:case 25:case 15:case 24:case 14:{if((d|0)<1){e=c+-18|0;if(e>>>0<12)d=(3075>>>(e&4095)&1)+3|0;else d=3}if(!(ia&((ga|0)==2&(d+-3|0)>>>0<2))){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(60)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=52;i[f+56>>0]=0;p=237674;ca=ba+52|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,7987);k[e>>2]=0;k[la>>2]=0;ia=k[f>>2]|0;k[f>>2]=ia+-1;if((ia|0)==1)ggb(k[f+-4>>2]|0)}k[H>>2]=ea;k[H+4>>2]=da;x2(b,H,(d<<3)+-8|$,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ia=la+8|0;k[ia>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ia;ia=la+48|0;l=la+44|0;k[l>>2]=ia;k[la+52>>2]=0;k[ia>>2]=0;if(f|0){ia=f+12|0;k[ia>>2]=(k[ia>>2]|0)+1}if((k[e>>2]|0)<3){ha=k[h+44>>2]|0;ia=k[l>>2]|0;k[ia>>2]=k[ha>>2];k[ia+4>>2]=k[ha+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ha=e+12|0,ia=k[ha>>2]|0,k[ha>>2]=ia+-1,(ia|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ia=la+16|0;f=la+4|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);switch(c|0){case 14:case 18:case 24:{f=0;break}default:f=(c|0)==28?0:2}switch(c|0){case 14:case 15:case 18:{e=6;break}default:e=(c|0)==19?6:5}k[ja>>2]=d;k[ja+4>>2]=f;k[ja+8>>2]=e;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52184;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Mda(ka,la);break}case 11:case 7:case 10:case 6:{if((G&510|0)!=2){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=20;i[f+24>>0]=0;p=237612;ca=ba+20|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8e3);k[e>>2]=0;k[la>>2]=0;ha=k[f>>2]|0;k[f>>2]=ha+-1;if((ha|0)==1)ggb(k[f+-4>>2]|0)}k[y>>2]=ea;k[y+4>>2]=da;x2(b,y,$,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ha=la+8|0;k[ha>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ha;ha=la+48|0;l=la+44|0;k[l>>2]=ha;k[la+52>>2]=0;k[ha>>2]=0;if(f|0){ha=f+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[e>>2]|0)<3){ea=k[h+44>>2]|0;ha=k[l>>2]|0;k[ha>>2]=k[ea>>2];k[ha+4>>2]=k[ea+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ea=e+12|0,ha=k[ea>>2]|0,k[ea>>2]=ha+-1,(ha|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ha=la+16|0;f=la+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=(c|0)==6|(c|0)==10?0:2;if(ia){k[ja>>2]=ga;l=k[52216+((e^2)<<2)>>2]|0;j=k[52216+(e<<2)>>2]|0;e=0;f=0;g=8192;h=0;while(1){k[ja+4+(h<<2)>>2]=e;k[ja+4+(h+256<<2)>>2]=f;k[ja+4+(h+512<<2)>>2]=g;h=h+1|0;if((h|0)==256)break;else{e=e+l|0;f=f+9617|0;g=g+j|0}}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52204;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Kda(ka,la);break a}if(fa){k[ja>>2]=ga;e=ja+4|0;k[e>>2]=k[13054];k[e+4>>2]=k[13055];k[e+8>>2]=k[13056];switch(c|0){case 6:case 10:{k[e>>2]=1868;k[ja+12>>2]=4899;break}default:{}}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52236;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Ida(ka,la);break a}else{k[ja>>2]=ga;e=ja+4|0;k[e>>2]=k[13062];k[e+4>>2]=k[13063];k[e+8>>2]=k[13064];switch(c|0){case 6:case 10:{k[e>>2]=1038710997;k[ja+12>>2]=1050220167;break}default:{}}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52268;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Gda(ka,la);break a}}case 31:case 21:{if(!(ia&(ga|0)==2)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(32)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=26;i[f+30>>0]=0;p=237727;ca=ba+26|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8021);k[e>>2]=0;k[la>>2]=0;ia=k[f>>2]|0;k[f>>2]=ia+-1;if((ia|0)==1)ggb(k[f+-4>>2]|0)}k[z>>2]=ea;k[z+4>>2]=da;x2(b,z,0,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ia=la+8|0;k[ia>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ia;ia=la+48|0;l=la+44|0;k[l>>2]=ia;k[la+52>>2]=0;k[ia>>2]=0;if(f|0){ia=f+12|0;k[ia>>2]=(k[ia>>2]|0)+1}if((k[e>>2]|0)<3){ha=k[h+44>>2]|0;ia=k[l>>2]|0;k[ia>>2]=k[ha>>2];k[ia+4>>2]=k[ha+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ha=e+12|0,ia=k[ha>>2]|0,k[ha>>2]=ia+-1,(ia|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ia=la+16|0;f=la+4|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);k[ja>>2]=(c|0)==21?6:5;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52288;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Eda(ka,la);break}case 9:case 8:{d=(d|0)<1?((c|0)==9?4:3):d;if(!((d+-3|0)>>>0<2&(w|0)==0)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(40)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=34;i[f+38>>0]=0;p=244560;ca=ba+34|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8030);k[e>>2]=0;k[la>>2]=0;c=k[f>>2]|0;k[f>>2]=c+-1;if((c|0)==1)ggb(k[f+-4>>2]|0)}k[C>>2]=ea;k[C+4>>2]=da;x2(b,C,$|(d<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];c=la+8|0;k[c>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=c;c=la+48|0;l=la+44|0;k[l>>2]=c;k[la+52>>2]=0;k[c>>2]=0;if(f|0){c=f+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[e>>2]|0)<3){ha=k[h+44>>2]|0;c=k[l>>2]|0;k[c>>2]=k[ha>>2];k[c+4>>2]=k[ha+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ha=e+12|0,c=k[ha>>2]|0,k[ha>>2]=c+-1,(c|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;c=la+16|0;f=la+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);if(ia){k[ja>>2]=d;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52308;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Cda(ka,la);break a}if(fa){k[ja>>2]=d;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52328;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Ada(ka,la);break a}else{k[ja>>2]=d;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52348;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;yda(ka,la);break a}}case 30:case 20:{if(w|$|0){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(32)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=26;i[f+30>>0]=0;p=237754;ca=ba+26|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8049);k[e>>2]=0;k[la>>2]=0;ia=k[f>>2]|0;k[f>>2]=ia+-1;if((ia|0)==1)ggb(k[f+-4>>2]|0)}k[A>>2]=ea;k[A+4>>2]=da;x2(b,A,8,0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[la>>2]=k[j>>2];p=la+4|0;f=j+4|0;k[p>>2]=k[f>>2];ia=la+8|0;k[ia>>2]=k[j+8>>2];k[la+12>>2]=k[j+12>>2];k[la+16>>2]=k[j+16>>2];k[la+20>>2]=k[j+20>>2];k[la+24>>2]=k[j+24>>2];k[la+28>>2]=k[j+28>>2];k[la+32>>2]=k[j+32>>2];e=k[j+36>>2]|0;k[la+36>>2]=e;g=la+40|0;k[g>>2]=ia;ia=la+48|0;l=la+44|0;k[l>>2]=ia;k[la+52>>2]=0;k[ia>>2]=0;if(e|0){ia=e+12|0;k[ia>>2]=(k[ia>>2]|0)+1}if((k[f>>2]|0)<3){ha=k[j+44>>2]|0;ia=k[l>>2]|0;k[ia>>2]=k[ha>>2];k[ia+4>>2]=k[ha+4>>2];break}k[p>>2]=0;x1(la,k[f>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[j+40>>2]|0;h=k[g>>2]|0;g=k[j+44>>2]|0;f=k[l>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ha=e+12|0,ia=k[ha>>2]|0,k[ha>>2]=ia+-1,(ia|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ia=la+16|0;f=la+4|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);k[ja>>2]=(c|0)==20?6:5;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52368;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;wda(ka,la);break}case 83:case 82:case 37:case 36:{if((G&510|0)!=2){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=20;i[f+24>>0]=0;p=237612;ca=ba+20|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8059);k[e>>2]=0;k[la>>2]=0;ha=k[f>>2]|0;k[f>>2]=ha+-1;if((ha|0)==1)ggb(k[f+-4>>2]|0)}d=(c|0)==36|(c|0)==82?0:2;t=(c|1|0)==37;s=t?0:52380;k[K>>2]=ea;k[K+4>>2]=da;x2(b,K,$|16,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ha=la+8|0;k[ha>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ha;ha=la+48|0;l=la+44|0;k[l>>2]=ha;k[la+52>>2]=0;k[ha>>2]=0;if(f|0){ha=f+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[e>>2]|0)<3){ea=k[h+44>>2]|0;ha=k[l>>2]|0;k[ha>>2]=k[ea>>2];k[ha+4>>2]=k[ea+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ea=e+12|0,ha=k[ea>>2]|0,k[ea>>2]=ha+-1,(ha|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ha=la+16|0;f=la+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);if(ia){k[ja>>2]=ga;k[ja+4>>2]=d;e=ja+8|0;ia=t?52420:s;k[e>>2]=k[ia>>2];k[e+4>>2]=k[ia+4>>2];k[e+8>>2]=k[ia+8>>2];k[e+12>>2]=k[ia+12>>2];k[e+16>>2]=k[ia+16>>2];switch(c|0){case 36:case 82:{ia=ja+16|0;c=k[e>>2]|0;k[e>>2]=k[ia>>2];k[ia>>2]=c;break}default:{}}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52408;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;uda(ka,la);break a}if(fa){k[ja>>2]=ga;k[ja+4>>2]=d;e=ja+8|0;ia=t?52420:s;k[e>>2]=k[ia>>2];k[e+4>>2]=k[ia+4>>2];k[e+8>>2]=k[ia+8>>2];k[e+12>>2]=k[ia+12>>2];k[e+16>>2]=k[ia+16>>2];switch(c|0){case 36:case 82:{ia=ja+16|0;c=k[e>>2]|0;k[e>>2]=k[ia>>2];k[ia>>2]=c;break}default:{}}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52448;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;sda(ka,la);break a}else{k[ja>>2]=ga;k[ja+4>>2]=d;e=ja+8|0;ia=t?52460:52480;k[e>>2]=k[ia>>2];k[e+4>>2]=k[ia+4>>2];k[e+8>>2]=k[ia+8>>2];k[e+12>>2]=k[ia+12>>2];k[e+16>>2]=k[ia+16>>2];switch(c|0){case 36:case 82:{ia=ja+16|0;c=k[e>>2]|0;k[e>>2]=k[ia>>2];k[ia>>2]=c;break}default:{}}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52508;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;qda(ka,la);break a}}case 85:case 84:case 39:case 38:{v=(d|0)<1?3:d;if(!((v+-3|0)>>>0<2&(ga|0)==3)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(40)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=34;i[f+38>>0]=0;p=237781;ca=ba+34|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8088);k[e>>2]=0;k[la>>2]=0;ha=k[f>>2]|0;k[f>>2]=ha+-1;if((ha|0)==1)ggb(k[f+-4>>2]|0)}t=(c|0)==38|(c|0)==84?0:2;d=(c|1|0)==39;s=d?0:52520;k[P>>2]=ea;k[P+4>>2]=da;x2(b,P,$|(v<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];c=la+8|0;k[c>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=c;c=la+48|0;l=la+44|0;k[l>>2]=c;k[la+52>>2]=0;k[c>>2]=0;if(f|0){c=f+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[e>>2]|0)<3){ha=k[h+44>>2]|0;c=k[l>>2]|0;k[c>>2]=k[ha>>2];k[c+4>>2]=k[ha+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ha=e+12|0,c=k[ha>>2]|0,k[ha>>2]=c+-1,(c|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;c=la+16|0;f=la+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);if(ia){k[ja>>2]=v;k[ja+4>>2]=t;ia=ja+8|0;c=d?52556:s;k[ia>>2]=k[c>>2];k[ia+4>>2]=k[c+4>>2];k[ia+8>>2]=k[c+8>>2];k[ia+12>>2]=k[c+12>>2];ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52544;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;oda(ka,la);break a}if(fa){k[ja>>2]=v;k[ja+4>>2]=t;ia=ja+8|0;c=d?52556:s;k[ia>>2]=k[c>>2];k[ia+4>>2]=k[c+4>>2];k[ia+8>>2]=k[c+8>>2];k[ia+12>>2]=k[c+12>>2];ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52580;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;mda(ka,la);break a}else{k[ja>>2]=v;k[ja+4>>2]=t;ia=ja+8|0;c=d?52592:52608;k[ia>>2]=k[c>>2];k[ia+4>>2]=k[c+4>>2];k[ia+8>>2]=k[c+8>>2];k[ia+12>>2]=k[c+12>>2];ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52632;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;kda(ka,la);break a}}case 33:case 32:{if((G&510|0)!=2){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=20;i[f+24>>0]=0;p=237612;ca=ba+20|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8108);k[e>>2]=0;k[la>>2]=0;ha=k[f>>2]|0;k[f>>2]=ha+-1;if((ha|0)==1)ggb(k[f+-4>>2]|0)}d=(c|0)==32;k[D>>2]=ea;k[D+4>>2]=da;x2(b,D,$|16,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];c=la+8|0;k[c>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=c;c=la+48|0;l=la+44|0;k[l>>2]=c;k[la+52>>2]=0;k[c>>2]=0;if(f|0){c=f+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[e>>2]|0)<3){ha=k[h+44>>2]|0;c=k[l>>2]|0;k[c>>2]=k[ha>>2];k[c+4>>2]=k[ha+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ha=e+12|0,c=k[ha>>2]|0,k[ha>>2]=c+-1,(c|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;c=la+16|0;f=la+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);if(ia){k[ja>>2]=ga;e=ja+4|0;k[e>>2]=1689;k[ja+8>>2]=1465;f=ja+12|0;k[f>>2]=739;g=ja+16|0;k[g>>2]=871;k[ja+20>>2]=2929;h=ja+24|0;k[h>>2]=296;j=ja+28|0;k[j>>2]=79;k[ja+32>>2]=488;l=ja+36|0;k[l>>2]=3892;if(d){k[e>>2]=739;k[f>>2]=1689;k[g>>2]=296;k[h>>2]=871;k[j>>2]=3892;k[l>>2]=79}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52652;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;ida(ka,la);break a}if(fa){k[ja>>2]=ga;e=ja+4|0;k[e>>2]=1689;k[ja+8>>2]=1465;f=ja+12|0;k[f>>2]=739;g=ja+16|0;k[g>>2]=871;k[ja+20>>2]=2929;h=ja+24|0;k[h>>2]=296;j=ja+28|0;k[j>>2]=79;k[ja+32>>2]=488;l=ja+36|0;k[l>>2]=3892;if(d){k[e>>2]=739;k[f>>2]=1689;k[g>>2]=296;k[h>>2]=871;k[j>>2]=3892;k[l>>2]=79}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52672;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;gda(ka,la);break a}else{k[ja>>2]=ga;e=ja+4|0;ba=e;p=52684;ca=ba+36|0;do{k[ba>>2]=k[p>>2];ba=ba+4|0;p=p+4|0}while((ba|0)<(ca|0));if(d){k[e>>2]=1043906767;k[ja+12>>2]=1054027018;k[ja+16>>2]=1033096535;k[ja+24>>2]=1046070893;k[ja+28>>2]=1064518164;k[ja+36>>2]=1017012822}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52728;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;eda(ka,la);break a}}case 35:case 34:{s=(d|0)<1?3:d;if(!((s+-3|0)>>>0<2&(ga|0)==3)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(40)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=34;i[f+38>>0]=0;p=237781;ca=ba+34|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8124);k[e>>2]=0;k[la>>2]=0;ha=k[f>>2]|0;k[f>>2]=ha+-1;if((ha|0)==1)ggb(k[f+-4>>2]|0)}t=(c|0)==34;d=t?0:2;k[L>>2]=ea;k[L+4>>2]=da;x2(b,L,$|(s<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];c=la+8|0;k[c>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=c;c=la+48|0;l=la+44|0;k[l>>2]=c;k[la+52>>2]=0;k[c>>2]=0;if(f|0){c=f+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[e>>2]|0)<3){ha=k[h+44>>2]|0;c=k[l>>2]|0;k[c>>2]=k[ha>>2];k[c+4>>2]=k[ha+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ha=e+12|0,c=k[ha>>2]|0,k[ha>>2]=c+-1,(c|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;c=la+16|0;f=la+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);if(ia){k[ja>>2]=s;k[ja+4>>2]=d;e=ja+8|0;k[e>>2]=13273;f=ja+12|0;k[f>>2]=-6296;g=ja+16|0;k[g>>2]=-2042;k[ja+20>>2]=-3970;k[ja+24>>2]=7684;k[ja+28>>2]=170;h=ja+32|0;k[h>>2]=228;j=ja+36|0;k[j>>2]=-836;l=ja+40|0;k[l>>2]=4331;if(t){k[e>>2]=228;k[h>>2]=13273;k[f>>2]=-836;k[j>>2]=-6296;k[g>>2]=4331;k[l>>2]=-2042}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52748;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;cda(ka,la);break a}if(fa){k[ja>>2]=s;k[ja+4>>2]=d;e=ja+8|0;k[e>>2]=13273;f=ja+12|0;k[f>>2]=-6296;g=ja+16|0;k[g>>2]=-2042;k[ja+20>>2]=-3970;k[ja+24>>2]=7684;k[ja+28>>2]=170;h=ja+32|0;k[h>>2]=228;j=ja+36|0;k[j>>2]=-836;l=ja+40|0;k[l>>2]=4331;if(t){k[e>>2]=228;k[h>>2]=13273;k[f>>2]=-836;k[j>>2]=-6296;k[g>>2]=4331;k[l>>2]=-2042}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52768;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;ada(ka,la);break a}else{k[ja>>2]=s;k[ja+4>>2]=d;e=ja+8|0;ba=e;p=52780;ca=ba+36|0;do{k[ba>>2]=k[p>>2];ba=ba+4|0;p=p+4|0}while((ba|0)<(ca|0));if(t){k[e>>2]=1029959464;k[ja+32>>2]=1078944770;k[ja+12>>2]=-1101991770;k[ja+36>>2]=-1077624491;k[ja+16>>2]=1065833976;k[ja+40>>2]=-1090568197}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52824;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;_ca(ka,la);break a}}case 69:case 68:case 53:case 52:case 67:case 66:case 41:case 40:{if((G&510|0)==2)switch(g&7){case 0:case 5:break;default:B=377}else B=377;if((B|0)==377){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(68)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=61;i[f+65>>0]=0;p=237816;ca=ba+61|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8141);k[e>>2]=0;k[la>>2]=0;ha=k[f>>2]|0;k[f>>2]=ha+-1;if((ha|0)==1)ggb(k[f+-4>>2]|0)}e=c+-40|0;if(e>>>0<29)s=(335548417>>>(e&536870911)&1)<<1^2;else s=2;if(!h)if(e>>>0<14)d=12291>>>(e&16383)&1?180:256;else d=256;else d=360;k[M>>2]=ea;k[M+4>>2]=da;x2(b,M,$|16,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ha=la+8|0;k[ha>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ha;ha=la+48|0;l=la+44|0;k[l>>2]=ha;k[la+52>>2]=0;k[ha>>2]=0;if(f|0){ha=f+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[e>>2]|0)<3){fa=k[h+44>>2]|0;ha=k[l>>2]|0;k[ha>>2]=k[fa>>2];k[ha+4>>2]=k[fa+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(fa=e+12|0,ha=k[fa>>2]|0,k[fa>>2]=ha+-1,(ha|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ha=la+16|0;f=la+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);switch(c|0){case 40:case 41:case 66:case 67:break;default:if(ia){k[ja>>2]=ga;k[ja+4>>2]=3;k[ja+8>>2]=s;o[ja+12>>2]=+(d|0);ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52884;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Uca(ka,la);break a}else{k[ja>>2]=ga;k[ja+4>>2]=s;o[ja+8>>2]=+(d|0);ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52904;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Rca(ka,la);break a}}if(!ia){k[ja>>2]=ga;k[ja+4>>2]=s;o[ja+8>>2]=+(d|0);ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52864;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Wca(ka,la);break a}k[ja>>2]=ga;k[ja+4>>2]=s;k[ja+8>>2]=d;switch(d&511){case 256:case 180:break;default:{k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(36)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=30;i[f+34>>0]=0;p=237878;ca=ba+30|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237909,237545,4128);k[e>>2]=0;k[la>>2]=0;ia=k[f>>2]|0;k[f>>2]=ia+-1;if((ia|0)==1)ggb(k[f+-4>>2]|0)}}ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52844;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Yca(ka,la);break}case 73:case 72:case 61:case 60:case 71:case 70:case 55:case 54:{t=(d|0)<1?3:d;if((t+-3|0)>>>0<2&(ga|0)==3)switch(g&7){case 0:case 5:break;default:B=420}else B=420;if((B|0)==420){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(80)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=73;i[f+77>>0]=0;p=237919;ca=ba+73|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8176);k[e>>2]=0;k[la>>2]=0;ha=k[f>>2]|0;k[f>>2]=ha+-1;if((ha|0)==1)ggb(k[f+-4>>2]|0)}e=c+-54|0;if(e>>>0<19)s=(327745>>>(e&524287)&1)<<1^2;else s=2;if(!h)if(e>>>0<8)d=(-61&255)>>>(e&255)&1?180:255;else d=255;else d=360;k[Q>>2]=ea;k[Q+4>>2]=da;x2(b,Q,$|(t<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ha=la+8|0;k[ha>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ha;ha=la+48|0;l=la+44|0;k[l>>2]=ha;k[la+52>>2]=0;k[ha>>2]=0;if(f|0){ha=f+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[e>>2]|0)<3){ga=k[h+44>>2]|0;ha=k[l>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ga=e+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ha=la+16|0;f=la+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);switch(c|0){case 54:case 55:case 70:case 71:if(ia){k[ja>>2]=t;k[ja+4>>2]=3;k[ja+8>>2]=s;o[ja+12>>2]=6.0/+(d|0);ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52924;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Pca(ka,la);break a}else{k[ja>>2]=t;k[ja+4>>2]=s;o[ja+8>>2]=6.0/+(d|0);ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52944;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Mca(ka,la);break a}default:if(ia){k[ja>>2]=t;k[ja+4>>2]=3;k[ja+8>>2]=s;o[ja+12>>2]=6.0/+(d|0);ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52964;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Kca(ka,la);break a}else{k[ja>>2]=t;k[ja+4>>2]=s;o[ja+8>>2]=6.0/+(d|0);ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=52984;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Hca(ka,la);break a}}}case 77:case 76:case 51:case 50:case 75:case 74:case 45:case 44:{if((G&510|0)==2)switch(g&7){case 0:case 5:break;default:B=459}else B=459;if((B|0)==459){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(68)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=61;i[f+65>>0]=0;p=237816;ca=ba+61|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8206);k[e>>2]=0;k[la>>2]=0;ha=k[f>>2]|0;k[f>>2]=ha+-1;if((ha|0)==1)ggb(k[f+-4>>2]|0)}switch(c|0){case 76:case 44:case 50:case 74:{s=0;break}default:s=2}e=c+-44|0;if(e>>>0<8)d=((-61&255)>>>(e&255)&1)!=0;else d=0;k[N>>2]=ea;k[N+4>>2]=da;x2(b,N,$|16,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ha=la+8|0;k[ha>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ha;ha=la+48|0;l=la+44|0;k[l>>2]=ha;k[la+52>>2]=0;k[ha>>2]=0;if(f|0){ha=f+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[e>>2]|0)<3){fa=k[h+44>>2]|0;ha=k[l>>2]|0;k[ha>>2]=k[fa>>2];k[ha+4>>2]=k[fa+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(fa=e+12|0,ha=k[fa>>2]|0,k[fa>>2]=ha+-1,(ha|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ha=la+16|0;f=la+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);switch(c|0){case 44:case 45:case 74:case 75:break;default:if(ia){k[ja>>2]=ga;aba(ja+4|0,3,s,d);ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=53044;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Bca(ka,la);break a}else{aba(ja,ga,s,d);ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=53064;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;yca(ka,la);break a}}if(!ia){k[_>>2]=ga;i[_+40>>0]=d&1;k[la>>2]=3;bba();o[ja>>2]=1.0521265268325806;o[ja+4>>2]=1.0;o[ja+8>>2]=.9184810519218445;b:do if((k[la>>2]|0)>0){h=s^2;j=ka+4|0;g=0;m=1.0521265268325806;while(1){ia=g*3|0;o[_+4+(ia+h<<2)>>2]=+o[52684+(ia<<2)>>2]*m;f=ia+1|0;e=_+4+(f<<2)|0;o[e>>2]=+o[52684+(f<<2)>>2]*m;f=ia+2|0;o[_+4+(ia+s<<2)>>2]=+o[52684+(f<<2)>>2]*m;m=+o[_+4+(ia<<2)>>2];if(!(((m>=0.0?(q=+o[e>>2],q>=0.0):0)?(W=+o[_+4+(f<<2)>>2],W>=0.0):0)?m+q+W<1024.0:0)){k[ka>>2]=0;k[j>>2]=0;e=ZT(132)|0;k[e>>2]=1;ba=e+4|0;k[ka>>2]=ba;k[j>>2]=126;i[e+130>>0]=0;p=239978;ca=ba+126|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,ka,240105,237545,5168);k[j>>2]=0;k[ka>>2]=0;ia=k[e>>2]|0;k[e>>2]=ia+-1;if((ia|0)==1)ggb(k[e+-4>>2]|0)}e=g+1|0;if((e|0)>=(k[la>>2]|0))break b;g=e;m=+o[ja+(e<<2)>>2]}}while(0);ja=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ja;k[ka>>2]=53024;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=_;Dca(ka,la);break a}k[_>>2]=ga;i[_+40>>0]=d&1;bba();o[ja>>2]=4309.51025390625;o[ja+4>>2]=4096.0;o[ja+8>>2]=3762.098388671875;c:do if((k[13449]|0)>0){l=s^2;n=la+4|0;j=0;q=4309.51025390625;while(1){h=j*3|0;m=+o[52684+(h<<2)>>2]*q;e=(o[u>>2]=m,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;m=e?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=e?-0.0:0.0}k[_+4+(h+l<<2)>>2]=~~m;f=h+1|0;m=+o[52684+(f<<2)>>2]*q;e=(o[u>>2]=m,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;m=e?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=e?-0.0:0.0}g=_+4+(f<<2)|0;k[g>>2]=~~m;f=h+2|0;m=+o[52684+(f<<2)>>2]*q;e=(o[u>>2]=m,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;m=e?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=e?-0.0:0.0}k[_+4+(h+s<<2)>>2]=~~m;if(!((((k[_+4+(j<<2)>>2]|0)>-1?(Y=k[g>>2]|0,(Y|0)>-1):0)?(Z=k[_+4+(f<<2)>>2]|0,(Z|0)>-1):0)?(Z+Y+(k[_+4+(h<<2)>>2]|0)|0)<8192:0)){k[la>>2]=0;k[n>>2]=0;e=ZT(132)|0;k[e>>2]=1;ba=e+4|0;k[la>>2]=ba;k[n>>2]=126;i[e+130>>0]=0;p=240159;ca=ba+126|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,240286,237545,5101);k[n>>2]=0;k[la>>2]=0;ia=k[e>>2]|0;k[e>>2]=ia+-1;if((ia|0)==1)ggb(k[e+-4>>2]|0)}e=j+1|0;if((e|0)>=(k[13449]|0))break c;j=e;q=+o[ja+(e<<2)>>2]}}while(0);ja=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ja;k[ka>>2]=53004;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=_;Fca(ka,la);break}case 81:case 80:case 59:case 58:case 79:case 78:case 57:case 56:{t=(d|0)<1?3:d;if((t+-3|0)>>>0<2&(ga|0)==3)switch(g&7){case 0:case 5:break;default:B=528}else B=528;if((B|0)==528){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(80)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=73;i[f+77>>0]=0;p=237919;ca=ba+73|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8237);k[e>>2]=0;k[la>>2]=0;ha=k[f>>2]|0;k[f>>2]=ha+-1;if((ha|0)==1)ggb(k[f+-4>>2]|0)}e=c+-56|0;if(e>>>0<25)s=(20971525>>>(e&33554431)&1)<<1^2;else s=2;d=e>>>0<4;k[R>>2]=ea;k[R+4>>2]=da;x2(b,R,$|(t<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ha=la+8|0;k[ha>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ha;ha=la+48|0;l=la+44|0;k[l>>2]=ha;k[la+52>>2]=0;k[ha>>2]=0;if(f|0){ha=f+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[e>>2]|0)<3){ga=k[h+44>>2]|0;ha=k[l>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ga=e+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ha=la+16|0;f=la+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);switch(c|0){case 56:case 57:case 78:case 79:if(ia){k[ja>>2]=t;k[ja+4>>2]=3;i[ja+44>>0]=d&1;bba();c=(s^2)*3|0;ia=s*3|0;o[ja+8+(c<<2)>>2]=3.079932689666748;o[ja+20>>2]=-.921235203742981;o[ja+8+(ia<<2)>>2]=.052890975028276443;o[ja+8+((c|1)<<2)>>2]=-1.5371500253677368;o[ja+24>>2]=1.8759909868240356;o[ja+8+((ia|1)<<2)>>2]=-.20404300093650818;o[ja+8+(c+2<<2)>>2]=-.5427820086479187;o[ja+28>>2]=.04524426534771919;o[ja+8+(ia+2<<2)>>2]=1.1511516571044922;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=53084;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;vca(ka,la);break a}else{k[ja>>2]=t;i[ja+40>>0]=d&1;bba();c=(s^2)*3|0;ia=s*3|0;o[ja+4+(c<<2)>>2]=3.079932689666748;o[ja+16>>2]=-.921235203742981;o[ja+4+(ia<<2)>>2]=.052890975028276443;o[ja+4+((c|1)<<2)>>2]=-1.5371500253677368;o[ja+20>>2]=1.8759909868240356;o[ja+4+((ia|1)<<2)>>2]=-.20404300093650818;o[ja+4+(c+2<<2)>>2]=-.5427820086479187;o[ja+24>>2]=.04524426534771919;o[ja+4+(ia+2<<2)>>2]=1.1511516571044922;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=53104;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;sca(ka,la);break a}default:if(ia){k[ja>>2]=t;k[ja+4>>2]=3;i[ja+52>>0]=d&1;bba();c=(s^2)*3|0;ia=s*3|0;k[ja+8+(c<<2)>>2]=1078944770;k[ja+20>>2]=-1082646231;k[ja+8+(ia<<2)>>2]=1029959464;k[ja+8+(c+1<<2)>>2]=-1077624491;k[ja+24>>2]=1072701561;k[ja+8+(ia+1<<2)>>2]=-1101991770;k[ja+8+(c+2<<2)>>2]=-1090568197;k[ja+28>>2]=1026176672;k[ja+8+(ia+2<<2)>>2]=1065833976;o[ja+44>>2]=.1978394240140915;o[ja+48>>2]=.46834221482276917;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=53124;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;qca(ka,la);break a}else{k[ja>>2]=t;i[ja+48>>0]=d&1;bba();c=(s^2)*3|0;ia=s*3|0;k[ja+4+(c<<2)>>2]=1078944770;k[ja+16>>2]=-1082646231;k[ja+4+(ia<<2)>>2]=1029959464;k[ja+4+(c+1<<2)>>2]=-1077624491;k[ja+20>>2]=1072701561;k[ja+4+(ia+1<<2)>>2]=-1101991770;k[ja+4+(c+2<<2)>>2]=-1090568197;k[ja+24>>2]=1026176672;k[ja+4+(ia+2<<2)>>2]=1065833976;o[ja+40>>2]=.1978394240140915;o[ja+44>>2]=.46834221482276917;ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=53144;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;nca(ka,la);break a}}}case 138:case 137:case 136:case 135:case 65:case 64:case 63:case 62:case 49:case 48:case 47:case 46:case 89:case 88:case 87:case 86:{k[la+8>>2]=0;k[la+12>>2]=0;k[la>>2]=16842752;k[la+4>>2]=sa;Zea(la,b,c,d);break}case 94:case 95:case 96:case 97:case 90:case 91:case 92:case 93:{if((d|0)<1)t=(c+-94|0)>>>0<4?4:3;else t=d;switch(c|0){case 91:case 93:case 97:{v=0;break}default:v=(c|0)==95?0:20}e=c+-92|0;if(e>>>0<6)e=51>>>(e&63)&63;else e=0;s=e&1;if((t+-3|0)>>>0>=2){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=20;i[f+24>>0]=0;p=237993;ca=ba+20|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8281);k[e>>2]=0;k[la>>2]=0;ja=k[f>>2]|0;k[f>>2]=ja+-1;if((ja|0)==1)ggb(k[f+-4>>2]|0)}if(!((ea&1|0)==0?!((da|0)%3|0|$|0):0)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(64)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=57;i[f+61>>0]=0;p=238014;ca=ba+57|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8282);k[e>>2]=0;k[la>>2]=0;ja=k[f>>2]|0;k[f>>2]=ja+-1;if((ja|0)==1)ggb(k[f+-4>>2]|0)}d=(da<<1|0)/3|0;k[U>>2]=ea;k[U+4>>2]=d;x2(b,U,(t<<3)+-8|$,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ja=la+8|0;k[ja>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ja;ja=la+48|0;l=la+44|0;k[l>>2]=ja;k[la+52>>2]=0;k[ja>>2]=0;if(f|0){ja=f+12|0;k[ja>>2]=(k[ja>>2]|0)+1}if((k[e>>2]|0)<3){ia=k[h+44>>2]|0;ja=k[l>>2]|0;k[ja>>2]=k[ia>>2];k[ja+4>>2]=k[ia+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ia=e+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ja=la+16|0;f=la+4|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=k[sa+48>>2]|0;f=k[sa+16>>2]|0;e=f+(aa(g,d)|0)|0;switch(s|v+(t*100|0)|0){case 300:{k[la>>2]=53164;k[la+4>>2]=ra;k[la+8>>2]=f;k[la+12>>2]=e;e=k[ra+12>>2]|0;k[la+16>>2]=e;k[la+20>>2]=g;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;cba(la,ka)}else{ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;cba(la,ka)}break a}case 301:{k[la>>2]=53184;k[la+4>>2]=ra;k[la+8>>2]=f;k[la+12>>2]=e;e=k[ra+12>>2]|0;k[la+16>>2]=e;k[la+20>>2]=g;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;dba(la,ka)}else{ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;dba(la,ka)}break a}case 320:{k[la>>2]=53204;k[la+4>>2]=ra;k[la+8>>2]=f;k[la+12>>2]=e;e=k[ra+12>>2]|0;k[la+16>>2]=e;k[la+20>>2]=g;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;eba(la,ka)}else{ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;eba(la,ka)}break a}case 321:{k[la>>2]=53224;k[la+4>>2]=ra;k[la+8>>2]=f;k[la+12>>2]=e;e=k[ra+12>>2]|0;k[la+16>>2]=e;k[la+20>>2]=g;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;fba(la,ka)}else{ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;fba(la,ka)}break a}case 400:{k[la>>2]=53244;k[la+4>>2]=ra;k[la+8>>2]=f;k[la+12>>2]=e;e=k[ra+12>>2]|0;k[la+16>>2]=e;k[la+20>>2]=g;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;gba(la,ka)}else{ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;gba(la,ka)}break a}case 401:{k[la>>2]=53264;k[la+4>>2]=ra;k[la+8>>2]=f;k[la+12>>2]=e;e=k[ra+12>>2]|0;k[la+16>>2]=e;k[la+20>>2]=g;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;hba(la,ka)}else{ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;hba(la,ka)}break a}case 420:{k[la>>2]=53284;k[la+4>>2]=ra;k[la+8>>2]=f;k[la+12>>2]=e;e=k[ra+12>>2]|0;k[la+16>>2]=e;k[la+20>>2]=g;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;iba(la,ka)}else{ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;iba(la,ka)}break a}case 421:{k[la>>2]=53304;k[la+4>>2]=ra;k[la+8>>2]=f;k[la+12>>2]=e;e=k[ra+12>>2]|0;k[la+16>>2]=e;k[la+20>>2]=g;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;jba(la,ka)}else{ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;jba(la,ka)}break a}default:{k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(48)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=41;i[f+45>>0]=0;p=238072;ca=ba+41|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-206,la,237536,237545,8302);k[e>>2]=0;k[la>>2]=0;la=k[f>>2]|0;k[f>>2]=la+-1;if((la|0)==1)ggb(k[f+-4>>2]|0);break a}}}case 104:case 105:case 100:case 101:case 102:case 103:case 98:case 99:{if((d|0)<1)t=(c+-102|0)>>>0<4?4:3;else t=d;v=c+-99|0;v=v>>>0<7&(v&1|0)==0?0:2;e=c+-98|0;if(e>>>0<6)s=(51>>>(e&63)&1)!=0;else s=0;if((t+-3|0)>>>0>=2){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=20;i[f+24>>0]=0;p=237993;ca=ba+20|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8316);k[e>>2]=0;k[la>>2]=0;ja=k[f>>2]|0;k[f>>2]=ja+-1;if((ja|0)==1)ggb(k[f+-4>>2]|0)}if(!((ea&1|0)==0?!((da|0)%3|0|$|0):0)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(64)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=57;i[f+61>>0]=0;p=238014;ca=ba+57|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8317);k[e>>2]=0;k[la>>2]=0;ja=k[f>>2]|0;k[f>>2]=ja+-1;if((ja|0)==1)ggb(k[f+-4>>2]|0)}d=(da<<1|0)/3|0;k[T>>2]=ea;k[T+4>>2]=d;x2(b,T,(t<<3)+-8|$,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ja=la+8|0;k[ja>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ja;ja=la+48|0;l=la+44|0;k[l>>2]=ja;k[la+52>>2]=0;k[ja>>2]=0;if(f|0){ja=f+12|0;k[ja>>2]=(k[ja>>2]|0)+1}if((k[e>>2]|0)<3){ia=k[h+44>>2]|0;ja=k[l>>2]|0;k[ja>>2]=k[ia>>2];k[ja+4>>2]=k[ia+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ia=e+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ja=la+16|0;f=la+4|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);l=k[sa+48>>2]|0;g=k[sa+16>>2]|0;e=g+(aa(l,d)|0)|0;j=(d|0)%4|0;ja=g+(aa(l,d+((da|0)/6|0)|0)|0)+(aa((j|0)/2|0,(ea|0)/2|0)|0)|0;j=(j|0)==2&1;h=s?0:j;j=s?j:0;f=s?e:ja;e=s?ja:e;switch((t*10|0)+v|0){case 30:{k[la>>2]=53324;k[la+4>>2]=ra;k[la+8>>2]=g;k[la+12>>2]=e;k[la+16>>2]=f;e=k[ra+12>>2]|0;k[la+20>>2]=e;k[la+24>>2]=l;k[la+28>>2]=j;k[la+32>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;kba(la,ka)}else{ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;kba(la,ka)}break a}case 32:{k[la>>2]=53344;k[la+4>>2]=ra;k[la+8>>2]=g;k[la+12>>2]=e;k[la+16>>2]=f;e=k[ra+12>>2]|0;k[la+20>>2]=e;k[la+24>>2]=l;k[la+28>>2]=j;k[la+32>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;lba(la,ka)}else{ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;lba(la,ka)}break a}case 40:{k[la>>2]=53364;k[la+4>>2]=ra;k[la+8>>2]=g;k[la+12>>2]=e;k[la+16>>2]=f;e=k[ra+12>>2]|0;k[la+20>>2]=e;k[la+24>>2]=l;k[la+28>>2]=j;k[la+32>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;mba(la,ka)}else{ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;mba(la,ka)}break a}case 42:{k[la>>2]=53384;k[la+4>>2]=ra;k[la+8>>2]=g;k[la+12>>2]=e;k[la+16>>2]=f;e=k[ra+12>>2]|0;k[la+20>>2]=e;k[la+24>>2]=l;k[la+28>>2]=j;k[la+32>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;nba(la,ka)}else{ja=(k[ha>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;nba(la,ka)}break a}default:{k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(48)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=41;i[f+45>>0]=0;p=238072;ca=ba+41|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-206,la,237536,237545,8339);k[e>>2]=0;k[la>>2]=0;la=k[f>>2]|0;k[f>>2]=la+-1;if((la|0)==1)ggb(k[f+-4>>2]|0);break a}}}case 106:{g=(d|0)<1?1:d;if(((g|0)!=1?(k[la>>2]=0,ja=la+4|0,k[ja>>2]=0,ia=ZT(16)|0,k[ia>>2]=1,v=ia+4|0,k[la>>2]=v,k[ja>>2]=8,i[ia+12>>0]=0,v,ia=v,i[ia>>0]=100,i[ia+1>>0]=99,i[ia+2>>0]=110,i[ia+3>>0]=32,v=v+4|0,i[v>>0]=61,i[v+1>>0]=61,i[v+2>>0]=32,i[v+3>>0]=49,Y8(-215,la,237536,237545,8347),v=k[la>>2]|0,k[ja>>2]=0,k[la>>2]=0,v|0):0)?(ia=v+-4|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0)ggb(k[v+-8>>2]|0);if(!((ea&1|0)==0?!((da|0)%3|0|$|0):0)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(64)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=57;i[f+61>>0]=0;p=238014;ca=ba+57|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8348);k[e>>2]=0;k[la>>2]=0;ja=k[f>>2]|0;k[f>>2]=ja+-1;if((ja|0)==1)ggb(k[f+-4>>2]|0)}d=(da<<1|0)/3|0;k[I>>2]=ea;k[I+4>>2]=d;x2(b,I,$|(g<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ja=la+8|0;k[ja>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ja;ja=la+48|0;l=la+44|0;k[l>>2]=ja;k[la+52>>2]=0;k[ja>>2]=0;if(f|0){ja=f+12|0;k[ja>>2]=(k[ja>>2]|0)+1}if((k[e>>2]|0)<3){ia=k[h+44>>2]|0;ja=k[l>>2]|0;k[ja>>2]=k[ia>>2];k[ja+4>>2]=k[ia+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ia=e+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ja=la+16|0;f=la+4|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);k[la>>2]=-2147483648;k[la+4>>2]=2147483647;k[ka>>2]=0;k[ka+4>>2]=d;H1(X,sa,ka,la);g=la+4|0;e=g+4|0;k[e>>2]=0;k[e+4>>2]=0;k[la>>2]=33619968;k[g>>2]=ra;mY(X,la);g=X+36|0;e=k[g>>2]|0;if(e|0?(ka=e+12|0,la=k[ka>>2]|0,k[ka>>2]=la+-1,(la|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[X+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;la=X+16|0;f=X+4|0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[f>>2]|0)>0){g=k[X+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[X+44>>2]|0;if(!((e|0)==(X+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);break}case 130:case 129:case 128:case 127:case 134:case 133:case 132:case 131:{g=(d|0)<1?1:d;s=c+-128|0;s=s>>>0<7&(s&1|0)==0?0:2;switch(c|0){case 127:case 128:case 130:{d=10;break}default:d=(c|0)==129?10:20}if(!(ia&(G&510|0)==2)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(48)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=40;i[f+44>>0]=0;p=237633;ca=ba+40|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8363);k[e>>2]=0;k[la>>2]=0;ja=k[f>>2]|0;k[f>>2]=ja+-1;if((ja|0)==1)ggb(k[f+-4>>2]|0)}if(((g|0)!=1?(k[la>>2]=0,ja=la+4|0,k[ja>>2]=0,ia=ZT(16)|0,k[ia>>2]=1,O=ia+4|0,k[la>>2]=O,k[ja>>2]=8,i[ia+12>>0]=0,O,ia=O,i[ia>>0]=100,i[ia+1>>0]=99,i[ia+2>>0]=110,i[ia+3>>0]=32,O=O+4|0,i[O>>0]=61,i[O+1>>0]=61,i[O+2>>0]=32,i[O+3>>0]=49,Y8(-215,la,237536,237545,8364),O=k[la>>2]|0,k[ja>>2]=0,k[la>>2]=0,O|0):0)?(ia=O+-4|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0)ggb(k[O+-8>>2]|0);if((da|ea)&1|0){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(44)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=39;i[f+43>>0]=0;p=238114;ca=ba+39|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8365);k[e>>2]=0;k[la>>2]=0;ja=k[f>>2]|0;k[f>>2]=ja+-1;if((ja|0)==1)ggb(k[f+-4>>2]|0)}k[S>>2]=ea;k[S+4>>2]=((da|0)/2|0)*3;x2(b,S,$|(g<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ja=la+8|0;k[ja>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ja;ja=la+48|0;l=la+44|0;k[l>>2]=ja;k[la+52>>2]=0;k[ja>>2]=0;if(f|0){ja=f+12|0;k[ja>>2]=(k[ja>>2]|0)+1}if((k[e>>2]|0)<3){ia=k[h+44>>2]|0;ja=k[l>>2]|0;k[ja>>2]=k[ia>>2];k[ja+4>>2]=k[ia+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ia=e+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ja=la+16|0;f=la+4|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);switch(d+s&63){case 10:{k[la>>2]=53404;k[la+4>>2]=sa;k[la+8>>2]=ra;k[la+12>>2]=1;g=k[sa+4>>2]|0;if((g|0)<3)e=aa(k[sa+12>>2]|0,k[sa+8>>2]|0)|0;else{h=k[qa>>2]|0;f=0;e=1;do{e=aa(k[h+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(g|0))}if(e>>>0>76799){ja=(k[sa+8>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;oba(la,ka)}else{ja=(k[sa+8>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;oba(la,ka)}break a}case 12:{k[la>>2]=53424;k[la+4>>2]=sa;k[la+8>>2]=ra;k[la+12>>2]=1;g=k[sa+4>>2]|0;if((g|0)<3)e=aa(k[sa+12>>2]|0,k[sa+8>>2]|0)|0;else{h=k[qa>>2]|0;f=0;e=1;do{e=aa(k[h+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(g|0))}if(e>>>0>76799){ja=(k[sa+8>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;pba(la,ka)}else{ja=(k[sa+8>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;pba(la,ka)}break a}case 20:{k[la>>2]=53404;k[la+4>>2]=sa;k[la+8>>2]=ra;k[la+12>>2]=2;g=k[sa+4>>2]|0;if((g|0)<3)e=aa(k[sa+12>>2]|0,k[sa+8>>2]|0)|0;else{h=k[qa>>2]|0;f=0;e=1;do{e=aa(k[h+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(g|0))}if(e>>>0>76799){ja=(k[sa+8>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;oba(la,ka)}else{ja=(k[sa+8>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;oba(la,ka)}break a}case 22:{k[la>>2]=53424;k[la+4>>2]=sa;k[la+8>>2]=ra;k[la+12>>2]=2;g=k[sa+4>>2]|0;if((g|0)<3)e=aa(k[sa+12>>2]|0,k[sa+8>>2]|0)|0;else{h=k[qa>>2]|0;f=0;e=1;do{e=aa(k[h+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(g|0))}if(e>>>0>76799){ja=(k[sa+8>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;pba(la,ka)}else{ja=(k[sa+8>>2]|0)/2|0;k[ka>>2]=0;k[ka+4>>2]=ja;pba(la,ka)}break a}default:{k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(48)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=41;i[f+45>>0]=0;p=238072;ca=ba+41|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-206,la,237536,237545,8377);k[e>>2]=0;k[la>>2]=0;la=k[f>>2]|0;k[f>>2]=la+-1;if((la|0)==1)ggb(k[f+-4>>2]|0);break a}}}case 122:case 121:case 120:case 119:case 118:case 117:case 116:case 115:case 112:case 111:case 108:case 107:{if((d|0)<1){e=c+-111|0;if(e>>>0<12)d=(3843>>>(e&4095)&1)+3|0;else d=3}e=c+-108|0;if(e>>>0<15){f=(21777>>>(e&32767)&1)!=0;switch(c|0){case 108:case 111:{e=1;break}default:e=(c|0)==112}g=e&1;e=c+-117|0;if(e>>>0<6){v=f;t=(51>>>(e&63)&1)!=0;s=g}else{v=f;t=0;s=g}}else{v=0;t=0;s=1}if((d+-3|0)>>>0>=2){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=20;i[f+24>>0]=0;p=237993;ca=ba+20|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8394);k[e>>2]=0;k[la>>2]=0;ja=k[f>>2]|0;k[f>>2]=ja+-1;if((ja|0)==1)ggb(k[f+-4>>2]|0)}if(!(ia&(ga|0)==2)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(32)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=26;i[f+30>>0]=0;p=237727;ca=ba+26|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8395);k[e>>2]=0;k[la>>2]=0;ja=k[f>>2]|0;k[f>>2]=ja+-1;if((ja|0)==1)ggb(k[f+-4>>2]|0)}k[V>>2]=ea;k[V+4>>2]=da;x2(b,V,(d<<3)+-8|0,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];ja=la+8|0;k[ja>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=ja;ja=la+48|0;l=la+44|0;k[l>>2]=ja;k[la+52>>2]=0;k[ja>>2]=0;if(f|0){ja=f+12|0;k[ja>>2]=(k[ja>>2]|0)+1}if((k[e>>2]|0)<3){ia=k[h+44>>2]|0;ja=k[l>>2]|0;k[ja>>2]=k[ia>>2];k[ja+4>>2]=k[ia+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ia=e+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ja=la+16|0;f=la+4|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);do switch((v?0:200)+(d*1e3|0)+(t?10:0)|s|0){case 3e3:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53444;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;qba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;qba(la,ka)}break a}case 3001:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53464;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;rba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;rba(la,ka)}break a}case 3010:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53484;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;sba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;sba(la,ka)}break a}case 3011:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53504;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;tba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;tba(la,ka)}break a}case 3200:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53524;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;uba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;uba(la,ka)}break a}case 3201:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53544;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;vba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;vba(la,ka)}break a}case 3210:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53564;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;wba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;wba(la,ka)}break a}case 3211:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53584;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;xba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;xba(la,ka)}break a}case 4e3:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53604;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;yba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;yba(la,ka)}break a}case 4001:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53624;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;zba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;zba(la,ka)}break a}case 4010:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53644;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;Aba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;Aba(la,ka)}break a}case 4011:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53664;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;Bba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;Bba(la,ka)}break a}case 4200:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53684;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;Cba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;Cba(la,ka)}break a}case 4201:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53704;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;Dba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;Dba(la,ka)}break a}case 4210:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53724;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;Eba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;Eba(la,ka)}break a}case 4211:{h=k[sa+48>>2]|0;e=k[sa+16>>2]|0;k[la>>2]=53744;k[la+4>>2]=ra;k[la+8>>2]=e;e=k[ra+12>>2]|0;k[la+12>>2]=e;k[la+16>>2]=h;h=k[na>>2]|0;if((h|0)<3)e=aa(k[ha>>2]|0,e)|0;else{g=k[ma>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(h|0))}if(e>>>0>76799){ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;Fba(la,ka)}else{ja=k[ha>>2]|0;k[ka>>2]=0;k[ka+4>>2]=ja;Fba(la,ka)}break a}default:{k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(48)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=41;i[f+45>>0]=0;p=238072;ca=ba+41|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-206,la,237536,237545,8418);k[e>>2]=0;k[la>>2]=0;la=k[f>>2]|0;k[f>>2]=la+-1;if((la|0)==1)ggb(k[f+-4>>2]|0);break a}}while(0)}case 124:case 123:{if(((d|0)>=2?(k[la>>2]=0,ka=la+4|0,k[ka>>2]=0,ja=ZT(16)|0,k[ja>>2]=1,t=ja+4|0,k[la>>2]=t,k[ka>>2]=8,i[ja+12>>0]=0,t,ja=t,i[ja>>0]=100,i[ja+1>>0]=99,i[ja+2>>0]=110,i[ja+3>>0]=32,t=t+4|0,i[t>>0]=61,i[t+1>>0]=61,i[t+2>>0]=32,i[t+3>>0]=49,Y8(-215,la,237536,237545,8426),t=k[la>>2]|0,k[ka>>2]=0,k[la>>2]=0,t|0):0)?(ja=t+-4|0,ka=k[ja>>2]|0,k[ja>>2]=ka+-1,(ka|0)==1):0)ggb(k[t+-8>>2]|0);if(!(ia&(ga|0)==2)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(32)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=26;i[f+30>>0]=0;p=237727;ca=ba+26|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8427);k[e>>2]=0;k[la>>2]=0;la=k[f>>2]|0;k[f>>2]=la+-1;if((la|0)==1)ggb(k[f+-4>>2]|0)}g=sa+36|0;e=k[g>>2]|0;if(e|0?(ka=e+12|0,la=k[ka>>2]|0,k[ka>>2]=la+-1,(la|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[sa+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;la=sa+16|0;f=sa+4|0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[f>>2]|0)>0){g=k[qa>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}QV(a,b,(c|0)==123&1);break}case 125:{g=(d|0)<1?4:d;if(!((g|0)==4&(ga|0)==4)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=20;i[f+24>>0]=0;p=238154;ca=ba+20|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8436);k[e>>2]=0;k[la>>2]=0;c=k[f>>2]|0;k[f>>2]=c+-1;if((c|0)==1)ggb(k[f+-4>>2]|0)}k[E>>2]=ea;k[E+4>>2]=da;x2(b,E,$|(g<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];c=la+8|0;k[c>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=c;c=la+48|0;l=la+44|0;k[l>>2]=c;k[la+52>>2]=0;k[c>>2]=0;if(f|0){c=f+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[e>>2]|0)<3){ha=k[h+44>>2]|0;c=k[l>>2]|0;k[c>>2]=k[ha>>2];k[c+4>>2]=k[ha+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ha=e+12|0,c=k[ha>>2]|0,k[ha>>2]=c+-1,(c|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;c=la+16|0;f=la+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);if(ia){ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=53764;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Jba(ka,la);break a}k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=23;i[f+27>>0]=0;p=238175;ca=ba+23|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-5,la,237536,237545,8447);k[e>>2]=0;k[la>>2]=0;la=k[f>>2]|0;k[f>>2]=la+-1;if((la|0)==1)ggb(k[f+-4>>2]|0);break}case 126:{g=(d|0)<1?4:d;if(!((g|0)==4&(ga|0)==4)){k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=20;i[f+24>>0]=0;p=238154;ca=ba+20|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-215,la,237536,237545,8454);k[e>>2]=0;k[la>>2]=0;c=k[f>>2]|0;k[f>>2]=c+-1;if((c|0)==1)ggb(k[f+-4>>2]|0)}k[F>>2]=ea;k[F+4>>2]=da;x2(b,F,$|(g<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[la>>2]=k[h>>2];p=la+4|0;e=h+4|0;k[p>>2]=k[e>>2];c=la+8|0;k[c>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[la+36>>2]=f;g=la+40|0;k[g>>2]=c;c=la+48|0;l=la+44|0;k[l>>2]=c;k[la+52>>2]=0;k[c>>2]=0;if(f|0){c=f+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[e>>2]|0)<3){ha=k[h+44>>2]|0;c=k[l>>2]|0;k[c>>2]=k[ha>>2];k[c+4>>2]=k[ha+4>>2];break}k[p>>2]=0;x1(la,k[e>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[p>>2]|0))}}else Q1(la,b,-1);while(0);KG(ra,la)|0;g=la+36|0;e=k[g>>2]|0;if(e|0?(ha=e+12|0,c=k[ha>>2]|0,k[ha>>2]=c+-1,(c|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[la+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;c=la+16|0;f=la+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[f>>2]|0)>0){g=k[la+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[la+44>>2]|0;if(!((e|0)==(la+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);if(ia){ia=k[sa+8>>2]|0;k[la>>2]=0;k[la+4>>2]=ia;k[ka>>2]=53784;k[ka+4>>2]=sa;k[ka+8>>2]=ra;k[ka+12>>2]=ja;Hba(ka,la);break a}k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=23;i[f+27>>0]=0;p=238175;ca=ba+23|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-5,la,237536,237545,8463);k[e>>2]=0;k[la>>2]=0;la=k[f>>2]|0;k[f>>2]=la+-1;if((la|0)==1)ggb(k[f+-4>>2]|0);break}default:{k[la>>2]=0;e=la+4|0;k[e>>2]=0;f=ZT(48)|0;k[f>>2]=1;ba=f+4|0;k[la>>2]=ba;k[e>>2]=41;i[f+45>>0]=0;p=238072;ca=ba+41|0;do{i[ba>>0]=i[p>>0]|0;ba=ba+1|0;p=p+1|0}while((ba|0)<(ca|0));Y8(-206,la,237536,237545,8468);k[e>>2]=0;k[la>>2]=0;la=k[f>>2]|0;k[f>>2]=la+-1;if((la|0)==1)ggb(k[f+-4>>2]|0)}}while(0);g=ra+36|0;e=k[g>>2]|0;if(e|0?(ka=e+12|0,la=k[ka>>2]|0,k[ka>>2]=la+-1,(la|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[ra+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ra=ra+16|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[na>>2]|0)>0){f=k[ma>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[na>>2]|0))}e=k[oa>>2]|0;if(!((e|0)==(pa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=sa+36|0;e=k[g>>2]|0;if(e|0?(pa=e+12|0,ra=k[pa>>2]|0,k[pa>>2]=ra+-1,(ra|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[sa+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;ra=sa+16|0;g=sa+4|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[g>>2]|0)>0){f=k[qa>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[g>>2]|0))}e=k[sa+44>>2]|0;if((e|0)==(sa+48|0)|(e|0)==0){r=ta;return}ggb(k[e+-4>>2]|0);r=ta;return}function aba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;g=j+8|0;h=j;k[a>>2]=b;i[a+48>>0]=d&1;bba();k[g>>2]=0;if((k[g>>2]|0)>=3){h=a+40|0;o[h>>2]=.1978394240140915;h=a+44|0;o[h>>2]=.46834221482276917;r=j;return}f=h+4|0;if(!c){do{k[a+4+((k[g>>2]|0)*3<<2)>>2]=k[52684+((k[g>>2]|0)*3<<2)>>2];k[a+4+(((k[g>>2]|0)*3|0)+1<<2)>>2]=k[52684+(((k[g>>2]|0)*3|0)+1<<2)>>2];k[a+4+(((k[g>>2]|0)*3|0)+2<<2)>>2]=k[52684+(((k[g>>2]|0)*3|0)+2<<2)>>2];d=a+4+((k[g>>2]|0)*3<<2)|0;e=a+4+(((k[g>>2]|0)*3|0)+2<<2)|0;c=k[d>>2]|0;k[d>>2]=k[e>>2];k[e>>2]=c;if(!(((+o[a+4+((k[g>>2]|0)*3<<2)>>2]>=0.0?+o[a+4+(((k[g>>2]|0)*3|0)+1<<2)>>2]>=0.0:0)?+o[a+4+(((k[g>>2]|0)*3|0)+2<<2)>>2]>=0.0:0)?+o[a+4+((k[g>>2]|0)*3<<2)>>2]+ +o[a+4+(((k[g>>2]|0)*3|0)+1<<2)>>2]+ +o[a+4+(((k[g>>2]|0)*3|0)+2<<2)>>2]<1.5:0)){b=ZT(120)|0;k[b>>2]=1;d=b+4|0;k[h>>2]=d;k[f>>2]=114;i[b+118>>0]=0;c=239809;e=d+114|0;do{i[d>>0]=i[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(e|0));Y8(-215,h,239924,237545,5542);k[f>>2]=0;k[h>>2]=0;e=k[b>>2]|0;k[b>>2]=e+-1;if((e|0)==1)ggb(k[b+-4>>2]|0)}k[g>>2]=(k[g>>2]|0)+1}while((k[g>>2]|0)<3);h=a+40|0;o[h>>2]=.1978394240140915;h=a+44|0;o[h>>2]=.46834221482276917;r=j;return}else{do{k[a+4+((k[g>>2]|0)*3<<2)>>2]=k[52684+((k[g>>2]|0)*3<<2)>>2];k[a+4+(((k[g>>2]|0)*3|0)+1<<2)>>2]=k[52684+(((k[g>>2]|0)*3|0)+1<<2)>>2];k[a+4+(((k[g>>2]|0)*3|0)+2<<2)>>2]=k[52684+(((k[g>>2]|0)*3|0)+2<<2)>>2];if(!(((+o[a+4+((k[g>>2]|0)*3<<2)>>2]>=0.0?+o[a+4+(((k[g>>2]|0)*3|0)+1<<2)>>2]>=0.0:0)?+o[a+4+(((k[g>>2]|0)*3|0)+2<<2)>>2]>=0.0:0)?+o[a+4+((k[g>>2]|0)*3<<2)>>2]+ +o[a+4+(((k[g>>2]|0)*3|0)+1<<2)>>2]+ +o[a+4+(((k[g>>2]|0)*3|0)+2<<2)>>2]<1.5:0)){b=ZT(120)|0;k[b>>2]=1;d=b+4|0;k[h>>2]=d;k[f>>2]=114;i[b+118>>0]=0;c=239809;e=d+114|0;do{i[d>>0]=i[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(e|0));Y8(-215,h,239924,237545,5542);k[f>>2]=0;k[h>>2]=0;e=k[b>>2]|0;k[b>>2]=e+-1;if((e|0)==1)ggb(k[b+-4>>2]|0)}k[g>>2]=(k[g>>2]|0)+1}while((k[g>>2]|0)<3);h=a+40|0;o[h>>2]=.1978394240140915;h=a+44|0;o[h>>2]=.46834221482276917;r=j;return}}function bba(){var a=0.0,b=0,c=0,d=0,e=0.0,f=0.0,g=0,h=0,l=0,m=0,n=0;n=r;r=r+12304|0;h=n+8200|0;l=n+4100|0;m=n;if(i[1012627]|0){r=n;return}g=0;do{a=+(g|0)*.00146484375;if(a<.008856000378727913)a=a*7.7870001792907715+.13793103396892548;else{b=(o[u>>2]=a,k[u>>2]|0);c=(b>>>23&255)+-127|0;d=(c|0)%3|0;d=d+-3-(d>>31&-3)|0;a=(k[u>>2]=(d<<23)+1065353216|b&8388607,+o[u>>2]);a=b|0?(k[u>>2]=(((c-d|0)/3|0)<<23)+(b&-2147483648)+(o[u>>2]=(a*(a*(a*(a*45.2548339756803+192.2798368355061)+119.16548242855816)+13.432501390862399)+.16361612265857542)/(a*(a*(a*(a*14.808840932191346+151.97140510444356)+168.52544141015682)+33.99059413502156)+1.0),k[u>>2]|0),+o[u>>2]):0.0}o[h+(g<<2)>>2]=a;g=g+1|0}while((g|0)!=1025);wca(h,447136);b=0;do{e=+(b|0)*.0009765625;if(!(e<=.040449999272823334)){f=e;a=f;f=+R(+((f+.055)*.9478672985781991),2.4)}else{a=e;f=e*.07739938050508499}o[l+(b<<2)>>2]=f;if(!(a<=.0031308))a=+R(+a,.4166666666666667)*1.055+-.055;else a=e*12.920000076293945;o[m+(b<<2)>>2]=a;b=b+1|0}while((b|0)!=1025);wca(l,463520);wca(m,430752);c=0;do{a=+(c|0)*.003921568859368563;if(!(a<=.040449999272823334))a=+R(+((a+.055)*.9478672985781991),2.4);else a=a*.07739938050508499;a=a*2040.0;b=(o[u>>2]=a,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;a=b?a+-8388608.0+8388608.0:a+8388608.0+-8388608.0;if(a==0.0)a=b?-0.0:0.0}m=~~a;j[833168+(c<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;j[833680+(c<<1)>>1]=c<<3;c=c+1|0}while((c|0)!=256);g=0;do{a=+(g|0)*4.901961074210703e-04;if(a<.008856000378727913)a=a*7.7870001792907715+.13793103396892548;else{b=(o[u>>2]=a,k[u>>2]|0);c=(b>>>23&255)+-127|0;d=(c|0)%3|0;d=d+-3-(d>>31&-3)|0;a=(k[u>>2]=(d<<23)+1065353216|b&8388607,+o[u>>2]);a=b|0?(k[u>>2]=(((c-d|0)/3|0)<<23)+(b&-2147483648)+(o[u>>2]=(a*(a*(a*(a*45.2548339756803+192.2798368355061)+119.16548242855816)+13.432501390862399)+.16361612265857542)/(a*(a*(a*(a*14.808840932191346+151.97140510444356)+168.52544141015682)+33.99059413502156)+1.0),k[u>>2]|0),+o[u>>2]):0.0}a=a*32768.0;b=(o[u>>2]=a,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;a=b?a+-8388608.0+8388608.0:a+8388608.0+-8388608.0;if(a==0.0)a=b?-0.0:0.0}m=~~a;j[834192+(g<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;g=g+1|0}while((g|0)!=3072);i[1012627]=1;r=n;return}function cba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=k[b>>2]<<1;o=k[b+4>>2]<<1;p=a+20|0;b=k[p>>2]|0;d=aa(b,c)|0;if((c|0)>=(o|0))return;m=a+4|0;n=a+16|0;j=(k[a+12>>2]|0)+((d|0)/2|0)|0;h=c;g=(k[a+8>>2]|0)+d|0;c=k[n>>2]|0;while(1){a=k[m>>2]|0;d=k[a+16>>2]|0;a=k[k[a+44>>2]>>2]|0;f=g+b|0;if((c|0)>0){e=d+(aa(a,h)|0)|0;b=d+(aa(a,h|1)|0)|0;d=0;while(1){c=(l[j+d>>0]|0)+-128|0;a=d|1;q=(l[j+a>>0]|0)+-128|0;r=(aa(q,1673527)|0)+524288|0;q=(aa(c,-409993)|0)+524288+(aa(q,-852492)|0)|0;c=(aa(c,2116026)|0)+524288|0;s=(l[g+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e+2>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(l[g+a>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e+5>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+4>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e+3>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(l[f+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[b+2>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[b+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[b>>0]=s>>>0<256?s:(s|0)>0?255:0;a=(l[f+a>>0]|0)+-16|0;a=aa((a|0)>0?a:0,1220542)|0;r=a+r>>20;i[b+5>>0]=r>>>0<256?r:(r|0)>0?255:0;q=a+q>>20;i[b+4>>0]=q>>>0<256?q:(q|0)>0?255:0;c=a+c>>20;i[b+3>>0]=c>>>0<256?c:(c|0)>0?255:0;d=d+2|0;c=k[n>>2]|0;if((d|0)>=(c|0))break;else{e=e+6|0;b=b+6|0}}b=k[p>>2]|0}h=h+2|0;if((h|0)>=(o|0))break;else{j=j+b|0;g=g+(b<<1)|0}}return}function dba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=k[b>>2]<<1;o=k[b+4>>2]<<1;p=a+20|0;b=k[p>>2]|0;d=aa(b,c)|0;if((c|0)>=(o|0))return;m=a+4|0;n=a+16|0;j=(k[a+12>>2]|0)+((d|0)/2|0)|0;h=c;g=(k[a+8>>2]|0)+d|0;c=k[n>>2]|0;while(1){a=k[m>>2]|0;d=k[a+16>>2]|0;a=k[k[a+44>>2]>>2]|0;f=g+b|0;if((c|0)>0){e=d+(aa(a,h)|0)|0;b=d+(aa(a,h|1)|0)|0;d=0;while(1){a=d|1;c=(l[j+a>>0]|0)+-128|0;q=(l[j+d>>0]|0)+-128|0;r=(aa(q,1673527)|0)+524288|0;q=(aa(c,-409993)|0)+524288+(aa(q,-852492)|0)|0;c=(aa(c,2116026)|0)+524288|0;s=(l[g+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e+2>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(l[g+a>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e+5>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+4>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e+3>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(l[f+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[b+2>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[b+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[b>>0]=s>>>0<256?s:(s|0)>0?255:0;a=(l[f+a>>0]|0)+-16|0;a=aa((a|0)>0?a:0,1220542)|0;r=a+r>>20;i[b+5>>0]=r>>>0<256?r:(r|0)>0?255:0;q=a+q>>20;i[b+4>>0]=q>>>0<256?q:(q|0)>0?255:0;c=a+c>>20;i[b+3>>0]=c>>>0<256?c:(c|0)>0?255:0;d=d+2|0;c=k[n>>2]|0;if((d|0)>=(c|0))break;else{e=e+6|0;b=b+6|0}}b=k[p>>2]|0}h=h+2|0;if((h|0)>=(o|0))break;else{j=j+b|0;g=g+(b<<1)|0}}return}function eba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=k[b>>2]<<1;o=k[b+4>>2]<<1;p=a+20|0;b=k[p>>2]|0;d=aa(b,c)|0;if((c|0)>=(o|0))return;m=a+4|0;n=a+16|0;j=(k[a+12>>2]|0)+((d|0)/2|0)|0;h=c;g=(k[a+8>>2]|0)+d|0;c=k[n>>2]|0;while(1){a=k[m>>2]|0;d=k[a+16>>2]|0;a=k[k[a+44>>2]>>2]|0;f=g+b|0;if((c|0)>0){e=d+(aa(a,h)|0)|0;b=d+(aa(a,h|1)|0)|0;d=0;while(1){c=(l[j+d>>0]|0)+-128|0;a=d|1;q=(l[j+a>>0]|0)+-128|0;r=(aa(q,1673527)|0)+524288|0;q=(aa(c,-409993)|0)+524288+(aa(q,-852492)|0)|0;c=(aa(c,2116026)|0)+524288|0;s=(l[g+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(l[g+a>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e+3>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+4>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(l[f+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[b>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[b+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[b+2>>0]=s>>>0<256?s:(s|0)>0?255:0;a=(l[f+a>>0]|0)+-16|0;a=aa((a|0)>0?a:0,1220542)|0;r=a+r>>20;i[b+3>>0]=r>>>0<256?r:(r|0)>0?255:0;q=a+q>>20;i[b+4>>0]=q>>>0<256?q:(q|0)>0?255:0;c=a+c>>20;i[b+5>>0]=c>>>0<256?c:(c|0)>0?255:0;d=d+2|0;c=k[n>>2]|0;if((d|0)>=(c|0))break;else{e=e+6|0;b=b+6|0}}b=k[p>>2]|0}h=h+2|0;if((h|0)>=(o|0))break;else{j=j+b|0;g=g+(b<<1)|0}}return}function fba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=k[b>>2]<<1;o=k[b+4>>2]<<1;p=a+20|0;b=k[p>>2]|0;d=aa(b,c)|0;if((c|0)>=(o|0))return;m=a+4|0;n=a+16|0;j=(k[a+12>>2]|0)+((d|0)/2|0)|0;h=c;g=(k[a+8>>2]|0)+d|0;c=k[n>>2]|0;while(1){a=k[m>>2]|0;d=k[a+16>>2]|0;a=k[k[a+44>>2]>>2]|0;f=g+b|0;if((c|0)>0){e=d+(aa(a,h)|0)|0;b=d+(aa(a,h|1)|0)|0;d=0;while(1){a=d|1;c=(l[j+a>>0]|0)+-128|0;q=(l[j+d>>0]|0)+-128|0;r=(aa(q,1673527)|0)+524288|0;q=(aa(c,-409993)|0)+524288+(aa(q,-852492)|0)|0;c=(aa(c,2116026)|0)+524288|0;s=(l[g+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(l[g+a>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e+3>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+4>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(l[f+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[b>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[b+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[b+2>>0]=s>>>0<256?s:(s|0)>0?255:0;a=(l[f+a>>0]|0)+-16|0;a=aa((a|0)>0?a:0,1220542)|0;r=a+r>>20;i[b+3>>0]=r>>>0<256?r:(r|0)>0?255:0;q=a+q>>20;i[b+4>>0]=q>>>0<256?q:(q|0)>0?255:0;c=a+c>>20;i[b+5>>0]=c>>>0<256?c:(c|0)>0?255:0;d=d+2|0;c=k[n>>2]|0;if((d|0)>=(c|0))break;else{e=e+6|0;b=b+6|0}}b=k[p>>2]|0}h=h+2|0;if((h|0)>=(o|0))break;else{j=j+b|0;g=g+(b<<1)|0}}return}function gba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=k[b>>2]<<1;o=k[b+4>>2]<<1;p=a+20|0;b=k[p>>2]|0;d=aa(b,c)|0;if((c|0)>=(o|0))return;m=a+4|0;n=a+16|0;j=(k[a+12>>2]|0)+((d|0)/2|0)|0;h=c;g=(k[a+8>>2]|0)+d|0;c=k[n>>2]|0;while(1){a=k[m>>2]|0;d=k[a+16>>2]|0;a=k[k[a+44>>2]>>2]|0;f=g+b|0;if((c|0)>0){e=d+(aa(a,h)|0)|0;b=d+(aa(a,h|1)|0)|0;d=0;while(1){c=(l[j+d>>0]|0)+-128|0;a=d|1;q=(l[j+a>>0]|0)+-128|0;r=(aa(q,1673527)|0)+524288|0;q=(aa(c,-409993)|0)+524288+(aa(q,-852492)|0)|0;c=(aa(c,2116026)|0)+524288|0;s=(l[g+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e+2>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e>>0]=s>>>0<256?s:(s|0)>0?255:0;i[e+3>>0]=-1;s=(l[g+a>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e+6>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+5>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e+4>>0]=s>>>0<256?s:(s|0)>0?255:0;i[e+7>>0]=-1;s=(l[f+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[b+2>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[b+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[b>>0]=s>>>0<256?s:(s|0)>0?255:0;i[b+3>>0]=-1;a=(l[f+a>>0]|0)+-16|0;a=aa((a|0)>0?a:0,1220542)|0;r=a+r>>20;i[b+6>>0]=r>>>0<256?r:(r|0)>0?255:0;q=a+q>>20;i[b+5>>0]=q>>>0<256?q:(q|0)>0?255:0;c=a+c>>20;i[b+4>>0]=c>>>0<256?c:(c|0)>0?255:0;i[b+7>>0]=-1;d=d+2|0;c=k[n>>2]|0;if((d|0)>=(c|0))break;else{e=e+8|0;b=b+8|0}}b=k[p>>2]|0}h=h+2|0;if((h|0)>=(o|0))break;else{j=j+b|0;g=g+(b<<1)|0}}return}function hba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=k[b>>2]<<1;o=k[b+4>>2]<<1;p=a+20|0;b=k[p>>2]|0;d=aa(b,c)|0;if((c|0)>=(o|0))return;m=a+4|0;n=a+16|0;j=(k[a+12>>2]|0)+((d|0)/2|0)|0;h=c;g=(k[a+8>>2]|0)+d|0;c=k[n>>2]|0;while(1){a=k[m>>2]|0;d=k[a+16>>2]|0;a=k[k[a+44>>2]>>2]|0;f=g+b|0;if((c|0)>0){e=d+(aa(a,h)|0)|0;b=d+(aa(a,h|1)|0)|0;d=0;while(1){a=d|1;c=(l[j+a>>0]|0)+-128|0;q=(l[j+d>>0]|0)+-128|0;r=(aa(q,1673527)|0)+524288|0;q=(aa(c,-409993)|0)+524288+(aa(q,-852492)|0)|0;c=(aa(c,2116026)|0)+524288|0;s=(l[g+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e+2>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e>>0]=s>>>0<256?s:(s|0)>0?255:0;i[e+3>>0]=-1;s=(l[g+a>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e+6>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+5>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e+4>>0]=s>>>0<256?s:(s|0)>0?255:0;i[e+7>>0]=-1;s=(l[f+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[b+2>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[b+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[b>>0]=s>>>0<256?s:(s|0)>0?255:0;i[b+3>>0]=-1;a=(l[f+a>>0]|0)+-16|0;a=aa((a|0)>0?a:0,1220542)|0;r=a+r>>20;i[b+6>>0]=r>>>0<256?r:(r|0)>0?255:0;q=a+q>>20;i[b+5>>0]=q>>>0<256?q:(q|0)>0?255:0;c=a+c>>20;i[b+4>>0]=c>>>0<256?c:(c|0)>0?255:0;i[b+7>>0]=-1;d=d+2|0;c=k[n>>2]|0;if((d|0)>=(c|0))break;else{e=e+8|0;b=b+8|0}}b=k[p>>2]|0}h=h+2|0;if((h|0)>=(o|0))break;else{j=j+b|0;g=g+(b<<1)|0}}return}function iba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=k[b>>2]<<1;o=k[b+4>>2]<<1;p=a+20|0;b=k[p>>2]|0;d=aa(b,c)|0;if((c|0)>=(o|0))return;m=a+4|0;n=a+16|0;j=(k[a+12>>2]|0)+((d|0)/2|0)|0;h=c;g=(k[a+8>>2]|0)+d|0;c=k[n>>2]|0;while(1){a=k[m>>2]|0;d=k[a+16>>2]|0;a=k[k[a+44>>2]>>2]|0;f=g+b|0;if((c|0)>0){e=d+(aa(a,h)|0)|0;b=d+(aa(a,h|1)|0)|0;d=0;while(1){c=(l[j+d>>0]|0)+-128|0;a=d|1;q=(l[j+a>>0]|0)+-128|0;r=(aa(q,1673527)|0)+524288|0;q=(aa(c,-409993)|0)+524288+(aa(q,-852492)|0)|0;c=(aa(c,2116026)|0)+524288|0;s=(l[g+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e+2>>0]=s>>>0<256?s:(s|0)>0?255:0;i[e+3>>0]=-1;s=(l[g+a>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e+4>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+5>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e+6>>0]=s>>>0<256?s:(s|0)>0?255:0;i[e+7>>0]=-1;s=(l[f+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[b>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[b+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[b+2>>0]=s>>>0<256?s:(s|0)>0?255:0;i[b+3>>0]=-1;a=(l[f+a>>0]|0)+-16|0;a=aa((a|0)>0?a:0,1220542)|0;r=a+r>>20;i[b+4>>0]=r>>>0<256?r:(r|0)>0?255:0;q=a+q>>20;i[b+5>>0]=q>>>0<256?q:(q|0)>0?255:0;c=a+c>>20;i[b+6>>0]=c>>>0<256?c:(c|0)>0?255:0;i[b+7>>0]=-1;d=d+2|0;c=k[n>>2]|0;if((d|0)>=(c|0))break;else{e=e+8|0;b=b+8|0}}b=k[p>>2]|0}h=h+2|0;if((h|0)>=(o|0))break;else{j=j+b|0;g=g+(b<<1)|0}}return}function jba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=k[b>>2]<<1;o=k[b+4>>2]<<1;p=a+20|0;b=k[p>>2]|0;d=aa(b,c)|0;if((c|0)>=(o|0))return;m=a+4|0;n=a+16|0;j=(k[a+12>>2]|0)+((d|0)/2|0)|0;h=c;g=(k[a+8>>2]|0)+d|0;c=k[n>>2]|0;while(1){a=k[m>>2]|0;d=k[a+16>>2]|0;a=k[k[a+44>>2]>>2]|0;f=g+b|0;if((c|0)>0){e=d+(aa(a,h)|0)|0;b=d+(aa(a,h|1)|0)|0;d=0;while(1){a=d|1;c=(l[j+a>>0]|0)+-128|0;q=(l[j+d>>0]|0)+-128|0;r=(aa(q,1673527)|0)+524288|0;q=(aa(c,-409993)|0)+524288+(aa(q,-852492)|0)|0;c=(aa(c,2116026)|0)+524288|0;s=(l[g+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e+2>>0]=s>>>0<256?s:(s|0)>0?255:0;i[e+3>>0]=-1;s=(l[g+a>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[e+4>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[e+5>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[e+6>>0]=s>>>0<256?s:(s|0)>0?255:0;i[e+7>>0]=-1;s=(l[f+d>>0]|0)+-16|0;s=aa((s|0)>0?s:0,1220542)|0;t=s+r>>20;i[b>>0]=t>>>0<256?t:(t|0)>0?255:0;t=s+q>>20;i[b+1>>0]=t>>>0<256?t:(t|0)>0?255:0;s=s+c>>20;i[b+2>>0]=s>>>0<256?s:(s|0)>0?255:0;i[b+3>>0]=-1;a=(l[f+a>>0]|0)+-16|0;a=aa((a|0)>0?a:0,1220542)|0;r=a+r>>20;i[b+4>>0]=r>>>0<256?r:(r|0)>0?255:0;q=a+q>>20;i[b+5>>0]=q>>>0<256?q:(q|0)>0?255:0;c=a+c>>20;i[b+6>>0]=c>>>0<256?c:(c|0)>0?255:0;i[b+7>>0]=-1;d=d+2|0;c=k[n>>2]|0;if((d|0)>=(c|0))break;else{e=e+8|0;b=b+8|0}}b=k[p>>2]|0}h=h+2|0;if((h|0)>=(o|0))break;else{j=j+b|0;g=g+(b<<1)|0}}return}function kba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;v=r;r=r+16|0;u=v;p=k[b>>2]|0;m=p<<1;s=k[b+4>>2]<<1;t=a+20|0;c=k[t>>2]|0;d=(c|0)/2|0;k[u>>2]=d;q=a+24|0;b=k[q>>2]|0;k[u+4>>2]=b-d;d=k[a+28>>2]|0;f=k[a+32>>2]|0;h=(k[a+8>>2]|0)+(aa(b,m)|0)|0;g=aa((p|0)/2|0,b)|0;e=(k[a+12>>2]|0)+g|0;g=(k[a+16>>2]|0)+g|0;if(((p|0)%2|0|0)==1){n=d+1|0;j=f+1|0;e=e+(k[u+((d&1)<<2)>>2]|0)|0;g=g+(k[u+((f&1)<<2)>>2]|0)|0}else{n=d;j=f}if((m|0)>=(s|0)){r=v;return}p=a+4|0;o=n;while(1){f=k[p>>2]|0;d=k[f+16>>2]|0;f=k[k[f+44>>2]>>2]|0;n=h+b|0;if((c|0)>1){a=d+(aa(f,m)|0)|0;b=d+(aa(f,m|1)|0)|0;d=0;while(1){c=(l[e+d>>0]|0)+-128|0;w=(l[g+d>>0]|0)+-128|0;x=(aa(w,1673527)|0)+524288|0;w=(aa(c,-409993)|0)+524288+(aa(w,-852492)|0)|0;c=(aa(c,2116026)|0)+524288|0;y=d<<1;f=(l[h+y>>0]|0)+-16|0;f=aa((f|0)>0?f:0,1220542)|0;z=f+x>>20;i[a+2>>0]=z>>>0<256?z:(z|0)>0?255:0;z=f+w>>20;i[a+1>>0]=z>>>0<256?z:(z|0)>0?255:0;f=f+c>>20;i[a>>0]=f>>>0<256?f:(f|0)>0?255:0;f=y|1;z=(l[h+f>>0]|0)+-16|0;z=aa((z|0)>0?z:0,1220542)|0;A=z+x>>20;i[a+5>>0]=A>>>0<256?A:(A|0)>0?255:0;A=z+w>>20;i[a+4>>0]=A>>>0<256?A:(A|0)>0?255:0;z=z+c>>20;i[a+3>>0]=z>>>0<256?z:(z|0)>0?255:0;y=(l[n+y>>0]|0)+-16|0;y=aa((y|0)>0?y:0,1220542)|0;z=y+x>>20;i[b+2>>0]=z>>>0<256?z:(z|0)>0?255:0;z=y+w>>20;i[b+1>>0]=z>>>0<256?z:(z|0)>0?255:0;y=y+c>>20;i[b>>0]=y>>>0<256?y:(y|0)>0?255:0;f=(l[n+f>>0]|0)+-16|0;f=aa((f|0)>0?f:0,1220542)|0;x=f+x>>20;i[b+5>>0]=x>>>0<256?x:(x|0)>0?255:0;w=f+w>>20;i[b+4>>0]=w>>>0<256?w:(w|0)>0?255:0;c=f+c>>20;i[b+3>>0]=c>>>0<256?c:(c|0)>0?255:0;d=d+1|0;c=k[t>>2]|0;if((d|0)>=((c|0)/2|0|0))break;else{a=a+6|0;b=b+6|0}}b=k[q>>2]|0}m=m+2|0;g=g+(k[u+((j&1)<<2)>>2]|0)|0;if((m|0)>=(s|0))break;else{h=h+(b<<1)|0;j=j+1|0;e=e+(k[u+((o&1)<<2)>>2]|0)|0;o=o+1|0}}r=v;return}function lba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;v=r;r=r+16|0;u=v;p=k[b>>2]|0;m=p<<1;s=k[b+4>>2]<<1;t=a+20|0;c=k[t>>2]|0;d=(c|0)/2|0;k[u>>2]=d;q=a+24|0;b=k[q>>2]|0;k[u+4>>2]=b-d;d=k[a+28>>2]|0;f=k[a+32>>2]|0;h=(k[a+8>>2]|0)+(aa(b,m)|0)|0;g=aa((p|0)/2|0,b)|0;e=(k[a+12>>2]|0)+g|0;g=(k[a+16>>2]|0)+g|0;if(((p|0)%2|0|0)==1){n=d+1|0;j=f+1|0;e=e+(k[u+((d&1)<<2)>>2]|0)|0;g=g+(k[u+((f&1)<<2)>>2]|0)|0}else{n=d;j=f}if((m|0)>=(s|0)){r=v;return}p=a+4|0;o=n;while(1){f=k[p>>2]|0;d=k[f+16>>2]|0;f=k[k[f+44>>2]>>2]|0;n=h+b|0;if((c|0)>1){a=d+(aa(f,m)|0)|0;b=d+(aa(f,m|1)|0)|0;d=0;while(1){c=(l[e+d>>0]|0)+-128|0;w=(l[g+d>>0]|0)+-128|0;x=(aa(w,1673527)|0)+524288|0;w=(aa(c,-409993)|0)+524288+(aa(w,-852492)|0)|0;c=(aa(c,2116026)|0)+524288|0;y=d<<1;f=(l[h+y>>0]|0)+-16|0;f=aa((f|0)>0?f:0,1220542)|0;z=f+x>>20;i[a>>0]=z>>>0<256?z:(z|0)>0?255:0;z=f+w>>20;i[a+1>>0]=z>>>0<256?z:(z|0)>0?255:0;f=f+c>>20;i[a+2>>0]=f>>>0<256?f:(f|0)>0?255:0;f=y|1;z=(l[h+f>>0]|0)+-16|0;z=aa((z|0)>0?z:0,1220542)|0;A=z+x>>20;i[a+3>>0]=A>>>0<256?A:(A|0)>0?255:0;A=z+w>>20;i[a+4>>0]=A>>>0<256?A:(A|0)>0?255:0;z=z+c>>20;i[a+5>>0]=z>>>0<256?z:(z|0)>0?255:0;y=(l[n+y>>0]|0)+-16|0;y=aa((y|0)>0?y:0,1220542)|0;z=y+x>>20;i[b>>0]=z>>>0<256?z:(z|0)>0?255:0;z=y+w>>20;i[b+1>>0]=z>>>0<256?z:(z|0)>0?255:0;y=y+c>>20;i[b+2>>0]=y>>>0<256?y:(y|0)>0?255:0;f=(l[n+f>>0]|0)+-16|0;f=aa((f|0)>0?f:0,1220542)|0;x=f+x>>20;i[b+3>>0]=x>>>0<256?x:(x|0)>0?255:0;w=f+w>>20;i[b+4>>0]=w>>>0<256?w:(w|0)>0?255:0;c=f+c>>20;i[b+5>>0]=c>>>0<256?c:(c|0)>0?255:0;d=d+1|0;c=k[t>>2]|0;if((d|0)>=((c|0)/2|0|0))break;else{a=a+6|0;b=b+6|0}}b=k[q>>2]|0}m=m+2|0;g=g+(k[u+((j&1)<<2)>>2]|0)|0;if((m|0)>=(s|0))break;else{h=h+(b<<1)|0;j=j+1|0;e=e+(k[u+((o&1)<<2)>>2]|0)|0;o=o+1|0}}r=v;return}function mba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;v=r;r=r+16|0;u=v;p=k[b>>2]|0;m=p<<1;s=k[b+4>>2]<<1;t=a+20|0;c=k[t>>2]|0;d=(c|0)/2|0;k[u>>2]=d;q=a+24|0;b=k[q>>2]|0;k[u+4>>2]=b-d;d=k[a+28>>2]|0;f=k[a+32>>2]|0;h=(k[a+8>>2]|0)+(aa(b,m)|0)|0;g=aa((p|0)/2|0,b)|0;e=(k[a+12>>2]|0)+g|0;g=(k[a+16>>2]|0)+g|0;if(((p|0)%2|0|0)==1){n=d+1|0;j=f+1|0;e=e+(k[u+((d&1)<<2)>>2]|0)|0;g=g+(k[u+((f&1)<<2)>>2]|0)|0}else{n=d;j=f}if((m|0)>=(s|0)){r=v;return}p=a+4|0;o=n;while(1){f=k[p>>2]|0;d=k[f+16>>2]|0;f=k[k[f+44>>2]>>2]|0;n=h+b|0;if((c|0)>1){a=d+(aa(f,m)|0)|0;b=d+(aa(f,m|1)|0)|0;d=0;while(1){c=(l[e+d>>0]|0)+-128|0;w=(l[g+d>>0]|0)+-128|0;x=(aa(w,1673527)|0)+524288|0;w=(aa(c,-409993)|0)+524288+(aa(w,-852492)|0)|0;c=(aa(c,2116026)|0)+524288|0;y=d<<1;f=(l[h+y>>0]|0)+-16|0;f=aa((f|0)>0?f:0,1220542)|0;z=f+x>>20;i[a+2>>0]=z>>>0<256?z:(z|0)>0?255:0;z=f+w>>20;i[a+1>>0]=z>>>0<256?z:(z|0)>0?255:0;f=f+c>>20;i[a>>0]=f>>>0<256?f:(f|0)>0?255:0;i[a+3>>0]=-1;f=y|1;z=(l[h+f>>0]|0)+-16|0;z=aa((z|0)>0?z:0,1220542)|0;A=z+x>>20;i[a+6>>0]=A>>>0<256?A:(A|0)>0?255:0;A=z+w>>20;i[a+5>>0]=A>>>0<256?A:(A|0)>0?255:0;z=z+c>>20;i[a+4>>0]=z>>>0<256?z:(z|0)>0?255:0;i[a+7>>0]=-1;y=(l[n+y>>0]|0)+-16|0;y=aa((y|0)>0?y:0,1220542)|0;z=y+x>>20;i[b+2>>0]=z>>>0<256?z:(z|0)>0?255:0;z=y+w>>20;i[b+1>>0]=z>>>0<256?z:(z|0)>0?255:0;y=y+c>>20;i[b>>0]=y>>>0<256?y:(y|0)>0?255:0;i[b+3>>0]=-1;f=(l[n+f>>0]|0)+-16|0;f=aa((f|0)>0?f:0,1220542)|0;x=f+x>>20;i[b+6>>0]=x>>>0<256?x:(x|0)>0?255:0;w=f+w>>20;i[b+5>>0]=w>>>0<256?w:(w|0)>0?255:0;c=f+c>>20;i[b+4>>0]=c>>>0<256?c:(c|0)>0?255:0;i[b+7>>0]=-1;d=d+1|0;c=k[t>>2]|0;if((d|0)>=((c|0)/2|0|0))break;else{a=a+8|0;b=b+8|0}}b=k[q>>2]|0}m=m+2|0;g=g+(k[u+((j&1)<<2)>>2]|0)|0;if((m|0)>=(s|0))break;else{h=h+(b<<1)|0;j=j+1|0;e=e+(k[u+((o&1)<<2)>>2]|0)|0;o=o+1|0}}r=v;return}function nba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;v=r;r=r+16|0;u=v;p=k[b>>2]|0;m=p<<1;s=k[b+4>>2]<<1;t=a+20|0;c=k[t>>2]|0;d=(c|0)/2|0;k[u>>2]=d;q=a+24|0;b=k[q>>2]|0;k[u+4>>2]=b-d;d=k[a+28>>2]|0;f=k[a+32>>2]|0;h=(k[a+8>>2]|0)+(aa(b,m)|0)|0;g=aa((p|0)/2|0,b)|0;e=(k[a+12>>2]|0)+g|0;g=(k[a+16>>2]|0)+g|0;if(((p|0)%2|0|0)==1){n=d+1|0;j=f+1|0;e=e+(k[u+((d&1)<<2)>>2]|0)|0;g=g+(k[u+((f&1)<<2)>>2]|0)|0}else{n=d;j=f}if((m|0)>=(s|0)){r=v;return}p=a+4|0;o=n;while(1){f=k[p>>2]|0;d=k[f+16>>2]|0;f=k[k[f+44>>2]>>2]|0;n=h+b|0;if((c|0)>1){a=d+(aa(f,m)|0)|0;b=d+(aa(f,m|1)|0)|0;d=0;while(1){c=(l[e+d>>0]|0)+-128|0;w=(l[g+d>>0]|0)+-128|0;x=(aa(w,1673527)|0)+524288|0;w=(aa(c,-409993)|0)+524288+(aa(w,-852492)|0)|0;c=(aa(c,2116026)|0)+524288|0;y=d<<1;f=(l[h+y>>0]|0)+-16|0;f=aa((f|0)>0?f:0,1220542)|0;z=f+x>>20;i[a>>0]=z>>>0<256?z:(z|0)>0?255:0;z=f+w>>20;i[a+1>>0]=z>>>0<256?z:(z|0)>0?255:0;f=f+c>>20;i[a+2>>0]=f>>>0<256?f:(f|0)>0?255:0;i[a+3>>0]=-1;f=y|1;z=(l[h+f>>0]|0)+-16|0;z=aa((z|0)>0?z:0,1220542)|0;A=z+x>>20;i[a+4>>0]=A>>>0<256?A:(A|0)>0?255:0;A=z+w>>20;i[a+5>>0]=A>>>0<256?A:(A|0)>0?255:0;z=z+c>>20;i[a+6>>0]=z>>>0<256?z:(z|0)>0?255:0;i[a+7>>0]=-1;y=(l[n+y>>0]|0)+-16|0;y=aa((y|0)>0?y:0,1220542)|0;z=y+x>>20;i[b>>0]=z>>>0<256?z:(z|0)>0?255:0;z=y+w>>20;i[b+1>>0]=z>>>0<256?z:(z|0)>0?255:0;y=y+c>>20;i[b+2>>0]=y>>>0<256?y:(y|0)>0?255:0;i[b+3>>0]=-1;f=(l[n+f>>0]|0)+-16|0;f=aa((f|0)>0?f:0,1220542)|0;x=f+x>>20;i[b+4>>0]=x>>>0<256?x:(x|0)>0?255:0;w=f+w>>20;i[b+5>>0]=w>>>0<256?w:(w|0)>0?255:0;c=f+c>>20;i[b+6>>0]=c>>>0<256?c:(c|0)>0?255:0;i[b+7>>0]=-1;d=d+1|0;c=k[t>>2]|0;if((d|0)>=((c|0)/2|0|0))break;else{a=a+8|0;b=b+8|0}}b=k[q>>2]|0}m=m+2|0;g=g+(k[u+((j&1)<<2)>>2]|0)|0;if((m|0)>=(s|0))break;else{h=h+(b<<1)|0;j=j+1|0;e=e+(k[u+((o&1)<<2)>>2]|0)|0;o=o+1|0}}r=v;return}function oba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;x=a+4|0;g=k[x>>2]|0;c=k[g+12>>2]|0;y=k[g+8>>2]|0;d=(k[g>>2]|0)>>>3&511;w=d+1|0;e=k[b>>2]|0;s=b+4|0;f=k[s>>2]|0;if((e|0)>=(f|0))return;t=a+8|0;u=(c|0)/2|0;v=(y|0)/2|0;r=a+12|0;o=aa(w,c)|0;p=(o|0)>0;q=d+3|0;m=d+2|0;n=w<<1;b=e;a=g;while(1){j=b<<1;d=k[a+16>>2]|0;h=k[k[a+44>>2]>>2]|0;g=d+(aa(h,j)|0)|0;h=d+(aa(h,j|1)|0)|0;d=k[t>>2]|0;e=k[d+16>>2]|0;d=k[k[d+44>>2]>>2]|0;j=e+(aa(d,j)|0)|0;a=e+(aa(d,((b|0)/2|0)+y|0)|0)+(aa((b|0)%2|0,u)|0)|0;c=b+v|0;c=e+(aa(d,((c|0)/2|0)+y|0)|0)+(aa((c|0)%2|0,u)|0)|0;d=(k[r>>2]|0)==2;if(p){e=d?c:a;d=d?a:c;a=0;c=0;while(1){H=a+2|0;B=l[g+H>>0]|0;F=a|1;A=l[g+F>>0]|0;z=l[g+a>>0]|0;C=q+a|0;E=m+a|0;D=a+w|0;f=(B*269484|0)+17301504+(A*528482|0)+(z*102760|0)|0;G=((l[g+C>>0]|0)*269484|0)+17301504+((l[g+E>>0]|0)*528482|0)+((l[g+D>>0]|0)*102760|0)|0;F=((l[h+H>>0]|0)*269484|0)+17301504+((l[h+F>>0]|0)*528482|0)+((l[h+a>>0]|0)*102760|0)|0;D=((l[h+C>>0]|0)*269484|0)+17301504+((l[h+E>>0]|0)*528482|0)+((l[h+D>>0]|0)*102760|0)|0;E=f>>>20;C=c<<1;i[j+C>>0]=f>>>0<268435456?E:E|0?255:0;E=G>>>20;f=C|1;i[j+f>>0]=G>>>0<268435456?E:E|0?255:0;E=F>>>20;i[j+((k[(k[t>>2]|0)+48>>2]|0)+C)>>0]=F>>>0<268435456?E:E|0?255:0;C=D>>>20;i[j+(f+(k[(k[t>>2]|0)+48>>2]|0))>>0]=D>>>0<268435456?C:C|0?255:0;f=(B*460324|0)+134742016+(aa(A,-385875)|0)+(aa(z,-74448)|0)|0;z=(aa(B,-155188)|0)+134742016+(aa(A,-305135)|0)+(z*460324|0)>>20;i[e+c>>0]=z>>>0<256?z:(z|0)>0?255:0;f=f>>20;i[d+c>>0]=f>>>0<256?f:(f|0)>0?255:0;a=a+n|0;if((a|0)>=(o|0))break;else c=c+1|0}a=k[s>>2]|0}else a=f;b=b+1|0;if((b|0)>=(a|0))break;f=a;a=k[x>>2]|0}return}function pba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;x=a+4|0;g=k[x>>2]|0;c=k[g+12>>2]|0;y=k[g+8>>2]|0;d=(k[g>>2]|0)>>>3&511;w=d+1|0;e=k[b>>2]|0;s=b+4|0;f=k[s>>2]|0;if((e|0)>=(f|0))return;t=a+8|0;u=(c|0)/2|0;v=(y|0)/2|0;r=a+12|0;o=aa(w,c)|0;p=(o|0)>0;q=d+2|0;m=d+3|0;n=w<<1;b=e;a=g;while(1){j=b<<1;d=k[a+16>>2]|0;h=k[k[a+44>>2]>>2]|0;g=d+(aa(h,j)|0)|0;h=d+(aa(h,j|1)|0)|0;d=k[t>>2]|0;e=k[d+16>>2]|0;d=k[k[d+44>>2]>>2]|0;j=e+(aa(d,j)|0)|0;a=e+(aa(d,((b|0)/2|0)+y|0)|0)+(aa((b|0)%2|0,u)|0)|0;c=b+v|0;c=e+(aa(d,((c|0)/2|0)+y|0)|0)+(aa((c|0)%2|0,u)|0)|0;d=(k[r>>2]|0)==2;if(p){e=d?c:a;d=d?a:c;a=0;c=0;while(1){B=l[g+a>>0]|0;H=a|1;A=l[g+H>>0]|0;F=a+2|0;z=l[g+F>>0]|0;C=a+w|0;E=q+a|0;D=m+a|0;f=(B*269484|0)+17301504+(A*528482|0)+(z*102760|0)|0;G=((l[g+C>>0]|0)*269484|0)+17301504+((l[g+E>>0]|0)*528482|0)+((l[g+D>>0]|0)*102760|0)|0;F=((l[h+a>>0]|0)*269484|0)+17301504+((l[h+H>>0]|0)*528482|0)+((l[h+F>>0]|0)*102760|0)|0;D=((l[h+C>>0]|0)*269484|0)+17301504+((l[h+E>>0]|0)*528482|0)+((l[h+D>>0]|0)*102760|0)|0;E=f>>>20;C=c<<1;i[j+C>>0]=f>>>0<268435456?E:E|0?255:0;E=G>>>20;f=C|1;i[j+f>>0]=G>>>0<268435456?E:E|0?255:0;E=F>>>20;i[j+((k[(k[t>>2]|0)+48>>2]|0)+C)>>0]=F>>>0<268435456?E:E|0?255:0;C=D>>>20;i[j+(f+(k[(k[t>>2]|0)+48>>2]|0))>>0]=D>>>0<268435456?C:C|0?255:0;f=(B*460324|0)+134742016+(aa(A,-385875)|0)+(aa(z,-74448)|0)|0;z=(aa(B,-155188)|0)+134742016+(aa(A,-305135)|0)+(z*460324|0)>>20;i[e+c>>0]=z>>>0<256?z:(z|0)>0?255:0;f=f>>20;i[d+c>>0]=f>>>0<256?f:(f|0)>0?255:0;a=a+n|0;if((a|0)>=(o|0))break;else c=c+1|0}a=k[s>>2]|0}else a=f;b=b+1|0;if((b|0)>=(a|0))break;f=a;a=k[x>>2]|0}return}function qba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+(a|1)>>0]|0)+-128|0;n=(l[e+(a|3)>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+a>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b+2>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b>>0]=m>>>0<256?m:(m|0)>0?255:0;m=(l[e+(a|2)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+4>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+3>>0]=d>>>0<256?d:(d|0)>0?255:0;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+6|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function rba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+a>>0]|0)+-128|0;n=(l[e+(a|2)>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+(a|1)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b+2>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b>>0]=m>>>0<256?m:(m|0)>0?255:0;m=(l[e+(a|3)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+4>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+3>>0]=d>>>0<256?d:(d|0)>0?255:0;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+6|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function sba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+(a|3)>>0]|0)+-128|0;n=(l[e+(a|1)>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+a>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b+2>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b>>0]=m>>>0<256?m:(m|0)>0?255:0;m=(l[e+(a|2)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+4>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+3>>0]=d>>>0<256?d:(d|0)>0?255:0;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+6|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function tba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+(a|2)>>0]|0)+-128|0;n=(l[e+a>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+(a|1)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b+2>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b>>0]=m>>>0<256?m:(m|0)>0?255:0;m=(l[e+(a|3)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+4>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+3>>0]=d>>>0<256?d:(d|0)>0?255:0;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+6|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function uba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+(a|1)>>0]|0)+-128|0;n=(l[e+(a|3)>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+a>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b+2>>0]=m>>>0<256?m:(m|0)>0?255:0;m=(l[e+(a|2)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+4>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+5>>0]=d>>>0<256?d:(d|0)>0?255:0;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+6|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function vba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+a>>0]|0)+-128|0;n=(l[e+(a|2)>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+(a|1)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b+2>>0]=m>>>0<256?m:(m|0)>0?255:0;m=(l[e+(a|3)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+4>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+5>>0]=d>>>0<256?d:(d|0)>0?255:0;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+6|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function wba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+(a|3)>>0]|0)+-128|0;n=(l[e+(a|1)>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+a>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b+2>>0]=m>>>0<256?m:(m|0)>0?255:0;m=(l[e+(a|2)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+4>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+5>>0]=d>>>0<256?d:(d|0)>0?255:0;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+6|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function xba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+(a|2)>>0]|0)+-128|0;n=(l[e+a>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+(a|1)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b+2>>0]=m>>>0<256?m:(m|0)>0?255:0;m=(l[e+(a|3)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+4>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+5>>0]=d>>>0<256?d:(d|0)>0?255:0;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+6|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function yba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+(a|1)>>0]|0)+-128|0;n=(l[e+(a|3)>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+a>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b+2>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b>>0]=m>>>0<256?m:(m|0)>0?255:0;i[b+3>>0]=-1;m=(l[e+(a|2)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+6>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+5>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+4>>0]=d>>>0<256?d:(d|0)>0?255:0;i[b+7>>0]=-1;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+8|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function zba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+a>>0]|0)+-128|0;n=(l[e+(a|2)>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+(a|1)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b+2>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b>>0]=m>>>0<256?m:(m|0)>0?255:0;i[b+3>>0]=-1;m=(l[e+(a|3)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+6>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+5>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+4>>0]=d>>>0<256?d:(d|0)>0?255:0;i[b+7>>0]=-1;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+8|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function Aba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+(a|3)>>0]|0)+-128|0;n=(l[e+(a|1)>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+a>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b+2>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b>>0]=m>>>0<256?m:(m|0)>0?255:0;i[b+3>>0]=-1;m=(l[e+(a|2)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+6>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+5>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+4>>0]=d>>>0<256?d:(d|0)>0?255:0;i[b+7>>0]=-1;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+8|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function Bba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+(a|2)>>0]|0)+-128|0;n=(l[e+a>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+(a|1)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b+2>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b>>0]=m>>>0<256?m:(m|0)>0?255:0;i[b+3>>0]=-1;m=(l[e+(a|3)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+6>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+5>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+4>>0]=d>>>0<256?d:(d|0)>0?255:0;i[b+7>>0]=-1;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+8|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function Cba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+(a|1)>>0]|0)+-128|0;n=(l[e+(a|3)>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+a>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b+2>>0]=m>>>0<256?m:(m|0)>0?255:0;i[b+3>>0]=-1;m=(l[e+(a|2)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+4>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+5>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+6>>0]=d>>>0<256?d:(d|0)>0?255:0;i[b+7>>0]=-1;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+8|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function Dba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+a>>0]|0)+-128|0;n=(l[e+(a|2)>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+(a|1)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b+2>>0]=m>>>0<256?m:(m|0)>0?255:0;i[b+3>>0]=-1;m=(l[e+(a|3)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+4>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+5>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+6>>0]=d>>>0<256?d:(d|0)>0?255:0;i[b+7>>0]=-1;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+8|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function Eba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+(a|3)>>0]|0)+-128|0;n=(l[e+(a|1)>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+a>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b+2>>0]=m>>>0<256?m:(m|0)>0?255:0;i[b+3>>0]=-1;m=(l[e+(a|2)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+4>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+5>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+6>>0]=d>>>0<256?d:(d|0)>0?255:0;i[b+7>>0]=-1;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+8|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function Fba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;c=k[b>>2]|0;h=k[b+4>>2]|0;j=a+16|0;if((c|0)>=(h|0))return;b=k[j>>2]|0;e=(k[a+8>>2]|0)+(aa(b,c)|0)|0;g=a+4|0;f=a+12|0;d=k[f>>2]|0;while(1){a=k[g>>2]|0;if((d|0)>0){b=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,c)|0)|0;a=0;while(1){d=(l[e+(a|2)>>0]|0)+-128|0;n=(l[e+a>>0]|0)+-128|0;o=(aa(n,1673527)|0)+524288|0;n=(aa(d,-409993)|0)+524288+(aa(n,-852492)|0)|0;d=(aa(d,2116026)|0)+524288|0;m=(l[e+(a|1)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;p=m+o>>20;i[b>>0]=p>>>0<256?p:(p|0)>0?255:0;p=m+n>>20;i[b+1>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+d>>20;i[b+2>>0]=m>>>0<256?m:(m|0)>0?255:0;i[b+3>>0]=-1;m=(l[e+(a|3)>>0]|0)+-16|0;m=aa((m|0)>0?m:0,1220542)|0;o=m+o>>20;i[b+4>>0]=o>>>0<256?o:(o|0)>0?255:0;n=m+n>>20;i[b+5>>0]=n>>>0<256?n:(n|0)>0?255:0;d=m+d>>20;i[b+6>>0]=d>>>0<256?d:(d|0)>0?255:0;i[b+7>>0]=-1;a=a+4|0;d=k[f>>2]|0;if((a|0)>=(d<<1|0))break;else b=b+8|0}b=k[j>>2]|0}c=c+1|0;if((c|0)==(h|0))break;else e=e+b|0}return}function Gba(a){a=a|0;ggb(a);return}function Hba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0;p=a+4|0;e=k[p>>2]|0;c=k[b>>2]|0;o=a+8|0;d=k[o>>2]|0;n=b+4|0;a=k[n>>2]|0;if((c|0)>=(a|0))return;j=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;m=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,c)|0)|0;b=e;while(1){h=k[b+12>>2]|0;if((h|0)>0){b=j;d=0;e=m;while(1){g=i[e+3>>0]|0;a=g&255;if(!(g<<24>>24)){i[b>>0]=0;f=0;a=0}else{r=i[e+2>>0]|0;f=i[e+1>>0]|0;q=(g&255)>>>1&255;i[b>>0]=((((l[e>>0]|0)*255|0)+q|0)>>>0)/(a>>>0)|0;f=(((((f&255)*255|0)+q|0)>>>0)/(a>>>0)|0)&255;a=((((r&255)*255|0)+q|0)>>>0)/(a>>>0)|0}i[b+1>>0]=f;i[b+2>>0]=a;i[b+3>>0]=g;d=d+1|0;if((d|0)==(h|0))break;else{b=b+4|0;e=e+4|0}}b=k[p>>2]|0;d=k[o>>2]|0;a=k[n>>2]|0}c=c+1|0;if((c|0)>=(a|0))break;else{j=j+(k[d+48>>2]|0)|0;m=m+(k[b+48>>2]|0)|0}}return}function Iba(a){a=a|0;ggb(a);return}function Jba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0;n=a+4|0;d=k[n>>2]|0;c=k[b>>2]|0;m=a+8|0;e=k[m>>2]|0;j=b+4|0;a=k[j>>2]|0;if((c|0)>=(a|0))return;g=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,c)|0)|0;h=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;f=c;b=d;c=e;while(1){d=k[b+12>>2]|0;if((d|0)>0){a=g;b=0;c=h;while(1){q=i[c+1>>0]|0;o=i[c+2>>0]|0;e=i[c+3>>0]|0;p=e&255;r=((((aa(p,l[c>>0]|0)|0)+128|0)>>>0)/255|0)&255;i[a>>0]=r;q=((((aa(p,q&255)|0)+128|0)>>>0)/255|0)&255;i[a+1>>0]=q;o=((((aa(p,o&255)|0)+128|0)>>>0)/255|0)&255;i[a+2>>0]=o;i[a+3>>0]=e;b=b+1|0;if((b|0)==(d|0))break;else{a=a+4|0;c=c+4|0}}b=k[n>>2]|0;c=k[m>>2]|0;a=k[j>>2]|0}f=f+1|0;if((f|0)>=(a|0))break;else{g=g+(k[c+48>>2]|0)|0;h=h+(k[b+48>>2]|0)|0}}return}function Kba(a){a=a|0;ggb(a);return}function Lba(a){a=a|0;ggb(a);return}function Mba(a){a=a|0;ggb(a);return}function Nba(a){a=a|0;ggb(a);return}function Oba(a){a=a|0;ggb(a);return}function Pba(a){a=a|0;ggb(a);return}function Qba(a){a=a|0;ggb(a);return}function Rba(a){a=a|0;ggb(a);return}function Sba(a){a=a|0;ggb(a);return}function Tba(a){a=a|0;ggb(a);return}function Uba(a){a=a|0;ggb(a);return}function Vba(a){a=a|0;ggb(a);return}function Wba(a){a=a|0;ggb(a);return}function Xba(a){a=a|0;ggb(a);return}function Yba(a){a=a|0;ggb(a);return}function Zba(a){a=a|0;ggb(a);return}function _ba(a){a=a|0;ggb(a);return}function $ba(a){a=a|0;ggb(a);return}function aca(a){a=a|0;ggb(a);return}function bca(a){a=a|0;ggb(a);return}function cca(a){a=a|0;ggb(a);return}function dca(a){a=a|0;ggb(a);return}function eca(a){a=a|0;ggb(a);return}function fca(a){a=a|0;ggb(a);return}function gca(a){a=a|0;ggb(a);return}function hca(a){a=a|0;ggb(a);return}function ica(a){a=a|0;ggb(a);return}function jca(a){a=a|0;ggb(a);return}function kca(a){a=a|0;ggb(a);return}function lca(a){a=a|0;ggb(a);return}function mca(a){a=a|0;ggb(a);return}function nca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+4|0;g=k[i>>2]|0;f=k[b>>2]|0;j=a+8|0;c=k[j>>2]|0;h=b+4|0;if((f|0)>=(k[h>>2]|0))return;c=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,f)|0)|0;e=a+12|0;d=(k[g+16>>2]|0)+(aa(k[k[g+44>>2]>>2]|0,f)|0)|0;a=f;b=g;while(1){oca(k[e>>2]|0,d,c,k[b+12>>2]|0);a=a+1|0;b=k[i>>2]|0;if((a|0)>=(k[h>>2]|0))break;else{c=c+(k[(k[j>>2]|0)+48>>2]|0)|0;d=d+(k[b+48>>2]|0)|0}}return}function oca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,p=0,q=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;G=r;r=r+32|0;n=G+16|0;m=G+12|0;l=G+8|0;C=G+4|0;D=G;E=k[a>>2]|0;F=(i[a+48>>0]|0)!=0;p=F?430752:0;q=+o[a+4>>2];s=+o[a+8>>2];t=+o[a+12>>2];v=+o[a+16>>2];w=+o[a+20>>2];x=+o[a+24>>2];y=+o[a+28>>2];z=+o[a+32>>2];A=+o[a+36>>2];B=+o[a+40>>2];h=+o[a+44>>2];j=d*3|0;if((d|0)<=0){r=G;return}g=(E|0)==4;f=0;while(1){H=+o[b+(f<<2)>>2];L=(H+16.0)*.008620689623057842;L=L*(L*L);H=.07692307978868484/H;J=B+ +o[b+(f+1<<2)>>2]*H;H=h+H*+o[b+(f+2<<2)>>2];I=1.0/H;K=J*2.25*L*I;H=I*(L*(12.0-J*3.0-H*20.0)*.25);J=s*L+q*K+t*H;o[n>>2]=J;I=w*L+v*K+x*H;o[m>>2]=I;H=z*L+y*K+A*H;o[l>>2]=H;o[C>>2]=0.0;a=J<0.0?C:n;o[D>>2]=1.0;a=k[(+o[a>>2]>1.0?D:a)>>2]|0;k[n>>2]=a;o[C>>2]=0.0;d=I<0.0?C:m;o[D>>2]=1.0;d=k[(+o[d>>2]>1.0?D:d)>>2]|0;k[m>>2]=d;o[C>>2]=0.0;e=H<0.0?C:l;o[D>>2]=1.0;e=k[(+o[e>>2]>1.0?D:e)>>2]|0;k[l>>2]=e;if(F){L=(k[u>>2]=e,+o[u>>2]);K=(k[u>>2]=d,+o[u>>2]);J=(k[u>>2]=a,+o[u>>2])*1024.0;a=~~J;a=(a|0)<0?0:a;a=(a|0)>1023?1023:a;J=J-+(a|0);a=p+(a<<2<<2)|0;J=+o[a>>2]+J*(+o[a+4>>2]+J*(+o[a+8>>2]+ +o[a+12>>2]*J));a=(o[u>>2]=J,k[u>>2]|0);o[n>>2]=J;K=K*1024.0;e=~~K;e=(e|0)<0?0:e;e=(e|0)>1023?1023:e;K=K-+(e|0);e=p+(e<<2<<2)|0;o[m>>2]=+o[e>>2]+K*(+o[e+4>>2]+K*(+o[e+8>>2]+ +o[e+12>>2]*K));L=L*1024.0;e=~~L;e=(e|0)<0?0:e;e=(e|0)>1023?1023:e;L=L-+(e|0);e=p+(e<<2<<2)|0;o[l>>2]=+o[e>>2]+L*(+o[e+4>>2]+L*(+o[e+8>>2]+ +o[e+12>>2]*L))}k[c>>2]=a;k[c+4>>2]=k[m>>2];k[c+8>>2]=k[l>>2];if(g)o[c+12>>2]=1.0;f=f+3|0;if((f|0)>=(j|0))break;else c=c+(E<<2)|0}r=G;return}function pca(a){a=a|0;ggb(a);return}function qca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0,h=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;z=r;r=r+3072|0;w=z;x=a+4|0;c=k[x>>2]|0;d=k[b>>2]|0;y=a+8|0;e=k[y>>2]|0;v=b+4|0;b=k[v>>2]|0;if((d|0)>=(b|0)){r=z;return}q=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;t=a+12|0;s=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;a=e;while(1){e=k[t>>2]|0;n=k[c+12>>2]|0;p=k[e>>2]|0;if((n|0)>0){j=e+4|0;m=(p|0)==4;b=q;g=0;h=s;while(1){a=n-g|0;c=(a|0)>256?256:a;e=c*3|0;if((a|0)>0){a=0;do{o[w+(a<<2)>>2]=+(l[h+a>>0]|0)*.3921568691730499;A=a+1|0;o[w+(A<<2)>>2]=+(l[h+A>>0]|0)*1.388235330581665+-134.0;A=a+2|0;o[w+(A<<2)>>2]=+(l[h+A>>0]|0)*1.0274510383605957+-140.0;a=a+3|0}while((a|0)<(e|0));oca(j,w,w,c);if(m){c=0;do{f=+o[w+(c<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[w+(c+1<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b+1>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[w+(c+2<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}A=~~f;i[b+2>>0]=A>>>0<256?A:(A|0)>0?255:0;i[b+3>>0]=-1;c=c+3|0;b=b+4|0}while((c|0)<(e|0))}else{c=0;do{f=+o[w+(c<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[w+(c+1<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b+1>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[w+(c+2<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}A=~~f;i[b+2>>0]=A>>>0<256?A:(A|0)>0?255:0;c=c+3|0;b=b+p|0}while((c|0)<(e|0))}}else oca(j,w,w,c);g=g+256|0;if((g|0)>=(n|0))break;else h=h+768|0}c=k[x>>2]|0;a=k[y>>2]|0;b=k[v>>2]|0}d=d+1|0;if((d|0)>=(b|0))break;else{q=q+(k[a+48>>2]|0)|0;s=s+(k[c+48>>2]|0)|0}}r=z;return}function rca(a){a=a|0;ggb(a);return}function sca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+4|0;g=k[i>>2]|0;f=k[b>>2]|0;j=a+8|0;c=k[j>>2]|0;h=b+4|0;if((f|0)>=(k[h>>2]|0))return;c=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,f)|0)|0;e=a+12|0;d=(k[g+16>>2]|0)+(aa(k[k[g+44>>2]>>2]|0,f)|0)|0;a=f;b=g;while(1){tca(k[e>>2]|0,d,c,k[b+12>>2]|0);a=a+1|0;b=k[i>>2]|0;if((a|0)>=(k[h>>2]|0))break;else{c=c+(k[(k[j>>2]|0)+48>>2]|0)|0;d=d+(k[b+48>>2]|0)|0}}return}function tca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0.0,g=0.0,h=0.0,j=0,l=0.0,m=0.0,n=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0;u=k[a>>2]|0;v=(i[a+40>>0]|0)!=0;w=v?430752:0;l=+o[a+4>>2];m=+o[a+8>>2];n=+o[a+12>>2];p=+o[a+16>>2];q=+o[a+20>>2];r=+o[a+24>>2];s=+o[a+28>>2];t=+o[a+32>>2];h=+o[a+36>>2];j=d*3|0;if((d|0)<=0)return;d=(u|0)==4;a=0;while(1){e=+o[b+(a<<2)>>2];if(!(e<=7.999625205993652)){g=(e+16.0)/116.0;e=g;g=g*(g*g)}else{g=e/903.2999877929688;e=g*7.7870001792907715+.13793103396892548}f=+o[b+(a+1<<2)>>2]/500.0+e;e=e-+o[b+(a+2<<2)>>2]/200.0;if(!(f<=.2068927139043808))f=f*(f*f);else f=(f+-.13793103396892548)/7.7870001792907715;if(!(e<=.2068927139043808))e=e*(e*e);else e=(e+-.13793103396892548)/7.7870001792907715;y=m*g+l*f+n*e;x=q*g+p*f+r*e;f=t*g+s*f+h*e;e=y<0.0?0.0:y>1.0?1.0:y;g=x<0.0?0.0:x>1.0?1.0:x;f=f<0.0?0.0:f>1.0?1.0:f;if(v){e=e*1024.0;z=~~e;z=(z|0)<0?0:z;z=(z|0)>1023?1023:z;e=e-+(z|0);z=w+(z<<2<<2)|0;g=g*1024.0;A=~~g;A=(A|0)<0?0:A;A=(A|0)>1023?1023:A;g=g-+(A|0);A=w+(A<<2<<2)|0;f=f*1024.0;B=~~f;B=(B|0)<0?0:B;B=(B|0)>1023?1023:B;f=f-+(B|0);B=w+(B<<2<<2)|0;f=+o[B>>2]+f*(+o[B+4>>2]+f*(f*+o[B+12>>2]+ +o[B+8>>2]));g=+o[A>>2]+g*(+o[A+4>>2]+g*(g*+o[A+12>>2]+ +o[A+8>>2]));e=+o[z>>2]+e*(+o[z+4>>2]+e*(e*+o[z+12>>2]+ +o[z+8>>2]))}o[c>>2]=e;o[c+4>>2]=g;o[c+8>>2]=f;if(d)o[c+12>>2]=1.0;a=a+3|0;if((a|0)>=(j|0))break;else c=c+(u<<2)|0}return}function uca(a){a=a|0;ggb(a);return}function vca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0,h=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;z=r;r=r+3072|0;w=z;x=a+4|0;c=k[x>>2]|0;d=k[b>>2]|0;y=a+8|0;e=k[y>>2]|0;v=b+4|0;b=k[v>>2]|0;if((d|0)>=(b|0)){r=z;return}q=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;t=a+12|0;s=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;a=e;while(1){e=k[t>>2]|0;n=k[c+12>>2]|0;p=k[e>>2]|0;if((n|0)>0){j=e+4|0;m=(p|0)==4;b=q;g=0;h=s;while(1){a=n-g|0;c=(a|0)>256?256:a;e=c*3|0;if((a|0)>0){a=0;do{o[w+(a<<2)>>2]=+(l[h+a>>0]|0)*.3921568691730499;A=a+1|0;o[w+(A<<2)>>2]=+((l[h+A>>0]|0)+-128|0);A=a+2|0;o[w+(A<<2)>>2]=+((l[h+A>>0]|0)+-128|0);a=a+3|0}while((a|0)<(e|0));tca(j,w,w,c);if(m){c=0;do{f=+o[w+(c<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[w+(c+1<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b+1>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[w+(c+2<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}A=~~f;i[b+2>>0]=A>>>0<256?A:(A|0)>0?255:0;i[b+3>>0]=-1;c=c+3|0;b=b+4|0}while((c|0)<(e|0))}else{c=0;do{f=+o[w+(c<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[w+(c+1<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b+1>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[w+(c+2<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}A=~~f;i[b+2>>0]=A>>>0<256?A:(A|0)>0?255:0;c=c+3|0;b=b+p|0}while((c|0)<(e|0))}}else tca(j,w,w,c);g=g+256|0;if((g|0)>=(n|0))break;else h=h+768|0}c=k[x>>2]|0;a=k[y>>2]|0;b=k[v>>2]|0}d=d+1|0;if((d|0)>=(b|0))break;else{q=q+(k[a+48>>2]|0)|0;s=s+(k[c+48>>2]|0)|0}}r=z;return}function wca(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0.0,h=0.0,i=0,j=0.0;o[b+4>>2]=0.0;o[b>>2]=0.0;c=1;do{e=c;c=c+1|0;f=e+-1|0;d=(+o[a+(f<<2)>>2]+(+o[a+(c<<2)>>2]-+o[a+(e<<2)>>2]*2.0))*3.0;f=f<<2;g=1.0/(4.0-+o[b+(f<<2)>>2]);e=e<<2;o[b+(e<<2)>>2]=g;o[b+((e|1)<<2)>>2]=g*(d-+o[b+((f|1)<<2)>>2])}while((c|0)!=1023);d=0.0;c=1023;while(1){f=c<<2;e=b+((f|1)<<2)|0;i=b+(f<<2)|0;g=d;d=+o[e>>2]-d*+o[i>>2];j=+o[a+(c<<2)>>2];h=+o[a+(c+1<<2)>>2]-j-(g+d*2.0)*.3333333432674408;o[i>>2]=j;o[e>>2]=h;o[b+((f|2)<<2)>>2]=d;o[b+((f|3)<<2)>>2]=(g-d)*.3333333432674408;if((c|0)<=0)break;else c=c+-1|0}return}function xca(a){a=a|0;ggb(a);return}function yca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+4|0;g=k[i>>2]|0;f=k[b>>2]|0;j=a+8|0;c=k[j>>2]|0;h=b+4|0;if((f|0)>=(k[h>>2]|0))return;c=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,f)|0)|0;e=a+12|0;d=(k[g+16>>2]|0)+(aa(k[k[g+44>>2]>>2]|0,f)|0)|0;a=f;b=g;while(1){zca(k[e>>2]|0,d,c,k[b+12>>2]|0);a=a+1|0;b=k[i>>2]|0;if((a|0)>=(k[h>>2]|0))break;else{c=c+(k[(k[j>>2]|0)+48>>2]|0)|0;d=d+(k[b+48>>2]|0)|0}}return}function zca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0.0,g=0.0,h=0.0,j=0,l=0.0,m=0.0,n=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0;w=k[a>>2]|0;x=(i[a+48>>0]|0)!=0;y=x?463520:0;l=+o[a+4>>2];m=+o[a+8>>2];n=+o[a+12>>2];p=+o[a+16>>2];q=+o[a+20>>2];r=+o[a+24>>2];s=+o[a+28>>2];t=+o[a+32>>2];u=+o[a+36>>2];v=+o[a+40>>2]*13.0;h=+o[a+44>>2]*13.0;j=d*3|0;if((d|0)>0)a=0;else return;while(1){f=+o[b>>2];g=+o[b+4>>2];e=+o[b+8>>2];if(x){f=f*1024.0;A=~~f;A=(A|0)<0?0:A;A=(A|0)>1023?1023:A;f=f-+(A|0);A=y+(A<<2<<2)|0;g=g*1024.0;z=~~g;z=(z|0)<0?0:z;z=(z|0)>1023?1023:z;g=g-+(z|0);z=y+(z<<2<<2)|0;e=e*1024.0;d=~~e;d=(d|0)<0?0:d;d=(d|0)>1023?1023:d;e=e-+(d|0);d=y+(d<<2<<2)|0;f=+o[A>>2]+f*(+o[A+4>>2]+f*(f*+o[A+12>>2]+ +o[A+8>>2]));g=+o[z>>2]+g*(+o[z+4>>2]+g*(g*+o[z+12>>2]+ +o[z+8>>2]));e=+o[d>>2]+e*(+o[d+4>>2]+e*(e*+o[d+12>>2]+ +o[d+8>>2]))}D=n*e+(m*g+l*f);C=r*e+(q*g+p*f);B=C*682.6666870117188;A=~~B;A=(A|0)<0?0:A;A=(A|0)>1023?1023:A;B=B-+(A|0);A=447136+(A<<2<<2)|0;B=(+o[A>>2]+B*(+o[A+4>>2]+B*(+o[A+8>>2]+ +o[A+12>>2]*B)))*116.0+-16.0;g=(u*e+(t*g+s*f))*3.0+(D+C*15.0);g=52.0/(g<1.1920928955078125e-07?1.1920928955078125e-07:g);o[c+(a<<2)>>2]=B;o[c+(a+1<<2)>>2]=(D*g-v)*B;o[c+(a+2<<2)>>2]=(C*2.25*g-h)*B;a=a+3|0;if((a|0)>=(j|0))break;else b=b+(w<<2)|0}return}function Aca(a){a=a|0;ggb(a);return}function Bca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0,h=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+3072|0;w=z;x=a+4|0;c=k[x>>2]|0;d=k[b>>2]|0;y=a+8|0;e=k[y>>2]|0;v=b+4|0;b=k[v>>2]|0;if((d|0)>=(b|0)){r=z;return}q=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;t=a+12|0;s=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;a=e;while(1){e=k[t>>2]|0;n=k[c+12>>2]|0;p=k[e>>2]|0;if((n|0)>0){m=e+4|0;h=q;j=0;b=s;while(1){e=n-j|0;c=(e|0)>256?256:e;g=c*3|0;if((e|0)>0){a=0;do{o[w+(a<<2)>>2]=+(l[b>>0]|0)*.003921568859368563;o[w+(a+1<<2)>>2]=+(l[b+1>>0]|0)*.003921568859368563;o[w+(a+2<<2)>>2]=+(l[b+2>>0]|0)*.003921568859368563;a=a+3|0;b=b+p|0}while((a|0)<(g|0));zca(m,w,w,c);e=0;do{f=+o[w+(e<<2)>>2]*2.549999952316284;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}c=~~f;i[h+e>>0]=c>>>0<256?c:(c|0)>0?255:0;c=e+1|0;f=+o[w+(c<<2)>>2]*.7203390002250671+96.52542114257812;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[h+c>>0]=a>>>0<256?a:(a|0)>0?255:0;c=e+2|0;f=+o[w+(c<<2)>>2]*.9732824563980103+136.25953674316406;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[h+c>>0]=a>>>0<256?a:(a|0)>0?255:0;e=e+3|0}while((e|0)<(g|0))}else zca(m,w,w,c);j=j+256|0;if((j|0)>=(n|0))break;else h=h+768|0}c=k[x>>2]|0;a=k[y>>2]|0;b=k[v>>2]|0}d=d+1|0;if((d|0)>=(b|0))break;else{q=q+(k[a+48>>2]|0)|0;s=s+(k[c+48>>2]|0)|0}}r=z;return}function Cca(a){a=a|0;ggb(a);return}function Dca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0.0,j=0.0,l=0.0,m=0,n=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;D=a+4|0;e=k[D>>2]|0;c=k[b>>2]|0;E=a+8|0;d=k[E>>2]|0;C=k[b+4>>2]|0;if((c|0)>=(C|0))return;z=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;B=a+12|0;A=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,c)|0)|0;b=d;a=e;while(1){y=k[B>>2]|0;d=k[a+12>>2]|0;e=k[y>>2]|0;m=(i[y+40>>0]|0)!=0;n=m?463520:0;p=+o[y+4>>2];q=+o[y+8>>2];r=+o[y+12>>2];s=+o[y+16>>2];t=+o[y+20>>2];u=+o[y+24>>2];v=+o[y+28>>2];w=+o[y+32>>2];x=+o[y+36>>2];y=d*3|0;if((d|0)>0){a=0;d=A;while(1){f=+o[d>>2];if(!(f<0.0)){if(f>1.0)f=1.0}else f=0.0;g=+o[d+4>>2];if(!(g<0.0)){if(g>1.0)g=1.0}else g=0.0;h=+o[d+8>>2];if(!(h<0.0)){if(h>1.0)h=1.0}else h=0.0;if(m){f=f*1024.0;G=~~f;G=(G|0)<0?0:G;G=(G|0)>1023?1023:G;f=f-+(G|0);G=n+(G<<2<<2)|0;g=g*1024.0;F=~~g;F=(F|0)<0?0:F;F=(F|0)>1023?1023:F;g=g-+(F|0);F=n+(F<<2<<2)|0;h=h*1024.0;b=~~h;b=(b|0)<0?0:b;b=(b|0)>1023?1023:b;h=h-+(b|0);b=n+(b<<2<<2)|0;f=+o[G>>2]+f*(+o[G+4>>2]+f*(f*+o[G+12>>2]+ +o[G+8>>2]));g=+o[F>>2]+g*(+o[F+4>>2]+g*(g*+o[F+12>>2]+ +o[F+8>>2]));h=+o[b>>2]+h*(+o[b+4>>2]+h*(h*+o[b+12>>2]+ +o[b+8>>2]))}j=r*h+(q*g+p*f);l=u*h+(t*g+s*f);f=x*h+(w*g+v*f);if(j>.008856000378727913)h=+R(+j,.3333333432674408);else h=j*7.7870001792907715+.13793103396892548;b=l>.008856000378727913;if(b)g=+R(+l,.3333333432674408);else g=l*7.7870001792907715+.13793103396892548;if(f>.008856000378727913)f=+R(+f,.3333333432674408);else f=f*7.7870001792907715+.13793103396892548;o[z+(a<<2)>>2]=b?g*116.0+-16.0:l*903.2999877929688;o[z+(a+1<<2)>>2]=(h-g)*500.0;o[z+(a+2<<2)>>2]=(g-f)*200.0;a=a+3|0;if((a|0)>=(y|0))break;else d=d+(e<<2)|0}a=k[D>>2]|0;b=k[E>>2]|0}c=c+1|0;if((c|0)==(C|0))break;else{z=z+(k[b+48>>2]|0)|0;A=A+(k[a+48>>2]|0)|0}}return}function Eca(a){a=a|0;ggb(a);return}function Fca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;y=a+4|0;c=k[y>>2]|0;d=k[b>>2]|0;z=a+8|0;e=k[z>>2]|0;x=b+4|0;b=k[x>>2]|0;if((d|0)>=(b|0))return;u=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;w=a+12|0;v=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;a=e;while(1){r=k[w>>2]|0;A=k[c+12>>2]|0;t=i[r+40>>0]|0?833168:833680;e=k[r>>2]|0;f=k[r+4>>2]|0;g=k[r+8>>2]|0;h=k[r+12>>2]|0;j=k[r+16>>2]|0;n=k[r+20>>2]|0;o=k[r+24>>2]|0;p=k[r+28>>2]|0;q=k[r+32>>2]|0;r=k[r+36>>2]|0;s=A*3|0;if((A|0)>0){b=0;a=v;while(1){D=m[t+(l[a>>0]<<1)>>1]|0;B=m[t+(l[a+1>>0]<<1)>>1]|0;A=m[t+(l[a+2>>0]<<1)>>1]|0;c=834192+((aa(D,f)|0)+2048+(aa(B,g)|0)+(aa(A,h)|0)>>12<<1)|0;C=834192+((aa(D,j)|0)+2048+(aa(B,n)|0)+(aa(A,o)|0)>>12<<1)|0;C=m[C>>1]|0;A=834192+((aa(D,p)|0)+2048+(aa(B,q)|0)+(aa(A,r)|0)>>12<<1)|0;B=(C*296|0)+-1320550>>15;c=(((m[c>>1]|0)-C|0)*500|0)+4210688>>15;A=((C-(m[A>>1]|0)|0)*200|0)+4210688>>15;i[u+b>>0]=B>>>0<256?B:(B|0)>0?255:0;i[u+(b+1)>>0]=c>>>0<256?c:(c|0)>0?255:0;i[u+(b+2)>>0]=A>>>0<256?A:(A|0)>0?255:0;b=b+3|0;if((b|0)>=(s|0))break;else a=a+e|0}c=k[y>>2]|0;a=k[z>>2]|0;b=k[x>>2]|0}d=d+1|0;if((d|0)>=(b|0))break;else{u=u+(k[a+48>>2]|0)|0;v=v+(k[c+48>>2]|0)|0}}return}function Gca(a){a=a|0;ggb(a);return}function Hca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+4|0;g=k[i>>2]|0;f=k[b>>2]|0;j=a+8|0;c=k[j>>2]|0;h=b+4|0;if((f|0)>=(k[h>>2]|0))return;c=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,f)|0)|0;e=a+12|0;d=(k[g+16>>2]|0)+(aa(k[k[g+44>>2]>>2]|0,f)|0)|0;a=f;b=g;while(1){g=k[e>>2]|0;Ica(k[g>>2]|0,k[g+4>>2]|0,+o[g+8>>2],d,c,k[b+12>>2]|0);a=a+1|0;b=k[i>>2]|0;if((a|0)>=(k[h>>2]|0))break;else{c=c+(k[(k[j>>2]|0)+48>>2]|0)|0;d=d+(k[b+48>>2]|0)|0}}return}function Ica(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0.0,j=0.0,l=0.0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0;u=r;r=r+16|0;s=u;t=f*3|0;if((f|0)<=0){r=u;return}n=b^2;p=s+4|0;q=s+8|0;m=s+12|0;if((a|0)==4){f=0;while(1){h=+o[d+(f<<2)>>2];j=+o[d+(f+1<<2)>>2];g=+o[d+(f+2<<2)>>2];if(g==0.0){h=j;i=j;g=j}else{if(!(j<=.5))l=j+g-j*g;else l=j*(g+1.0);i=j*2.0-l;g=h*c;if(!(g<0.0)){if(g>=6.0)do g=g+-6.0;while(g>=6.0)}else do g=g+6.0;while(g<0.0);a=~~g;a=a-(+(a|0)>g&1)|0;h=g-+(a|0);o[s>>2]=l;o[p>>2]=i;g=l-i;o[q>>2]=i+g*(1.0-h);o[m>>2]=i+g*h;h=+o[s+(k[53800+(a*12|0)+8>>2]<<2)>>2];i=+o[s+(k[53800+(a*12|0)+4>>2]<<2)>>2];g=+o[s+(k[53800+(a*12|0)>>2]<<2)>>2]}o[e+(b<<2)>>2]=g;o[e+4>>2]=i;o[e+(n<<2)>>2]=h;o[e+12>>2]=1.0;f=f+3|0;if((f|0)>=(t|0))break;else e=e+16|0}r=u;return}else{f=0;while(1){h=+o[d+(f<<2)>>2];j=+o[d+(f+1<<2)>>2];g=+o[d+(f+2<<2)>>2];if(g==0.0){h=j;i=j;g=j}else{if(!(j<=.5))l=j+g-j*g;else l=j*(g+1.0);i=j*2.0-l;g=h*c;if(!(g<0.0)){if(g>=6.0)do g=g+-6.0;while(g>=6.0)}else do g=g+6.0;while(g<0.0);v=~~g;v=v-(+(v|0)>g&1)|0;h=g-+(v|0);o[s>>2]=l;o[p>>2]=i;g=l-i;o[q>>2]=i+g*(1.0-h);o[m>>2]=i+g*h;h=+o[s+(k[53800+(v*12|0)+8>>2]<<2)>>2];i=+o[s+(k[53800+(v*12|0)+4>>2]<<2)>>2];g=+o[s+(k[53800+(v*12|0)>>2]<<2)>>2]}o[e+(b<<2)>>2]=g;o[e+4>>2]=i;o[e+(n<<2)>>2]=h;f=f+3|0;if((f|0)>=(t|0))break;else e=e+(a<<2)|0}r=u;return}}function Jca(a){a=a|0;ggb(a);return}function Kca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0,h=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;B=r;r=r+3072|0;y=B;z=a+4|0;c=k[z>>2]|0;d=k[b>>2]|0;A=a+8|0;e=k[A>>2]|0;x=b+4|0;b=k[x>>2]|0;if((d|0)>=(b|0)){r=B;return}t=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;w=a+12|0;v=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;a=e;while(1){e=k[w>>2]|0;q=k[c+12>>2]|0;s=k[e>>2]|0;if((q|0)>0){p=(s|0)==4;m=e+4|0;n=e+8|0;j=e+12|0;b=t;g=0;h=v;while(1){a=q-g|0;c=(a|0)>256?256:a;e=c*3|0;if((a|0)>0){a=0;do{o[y+(a<<2)>>2]=+(l[h+a>>0]|0);C=a+1|0;o[y+(C<<2)>>2]=+(l[h+C>>0]|0)*.003921568859368563;C=a+2|0;o[y+(C<<2)>>2]=+(l[h+C>>0]|0)*.003921568859368563;a=a+3|0}while((a|0)<(e|0));Ica(k[m>>2]|0,k[n>>2]|0,+o[j>>2],y,y,c);if(p){c=0;do{f=+o[y+(c<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[y+(c+1<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b+1>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[y+(c+2<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}C=~~f;i[b+2>>0]=C>>>0<256?C:(C|0)>0?255:0;i[b+3>>0]=-1;c=c+3|0;b=b+4|0}while((c|0)<(e|0))}else{c=0;do{f=+o[y+(c<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[y+(c+1<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b+1>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[y+(c+2<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}C=~~f;i[b+2>>0]=C>>>0<256?C:(C|0)>0?255:0;c=c+3|0;b=b+s|0}while((c|0)<(e|0))}}else Ica(k[m>>2]|0,k[n>>2]|0,+o[j>>2],y,y,c);g=g+256|0;if((g|0)>=(q|0))break;else h=h+768|0}c=k[z>>2]|0;a=k[A>>2]|0;b=k[x>>2]|0}d=d+1|0;if((d|0)>=(b|0))break;else{t=t+(k[a+48>>2]|0)|0;v=v+(k[c+48>>2]|0)|0}}r=B;return}function Lca(a){a=a|0;ggb(a);return}function Mca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+4|0;g=k[i>>2]|0;f=k[b>>2]|0;j=a+8|0;c=k[j>>2]|0;h=b+4|0;if((f|0)>=(k[h>>2]|0))return;c=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,f)|0)|0;e=a+12|0;d=(k[g+16>>2]|0)+(aa(k[k[g+44>>2]>>2]|0,f)|0)|0;a=f;b=g;while(1){g=k[e>>2]|0;Nca(k[g>>2]|0,k[g+4>>2]|0,+o[g+8>>2],d,c,k[b+12>>2]|0);a=a+1|0;b=k[i>>2]|0;if((a|0)>=(k[h>>2]|0))break;else{c=c+(k[(k[j>>2]|0)+48>>2]|0)|0;d=d+(k[b+48>>2]|0)|0}}return}function Nca(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0.0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0;t=r;r=r+16|0;q=t;s=f*3|0;if((f|0)<=0){r=t;return}m=b^2;n=q+4|0;p=q+8|0;l=q+12|0;if((a|0)==4){f=0;while(1){h=+o[d+(f+1<<2)>>2];j=+o[d+(f+2<<2)>>2];if(h==0.0){h=j;i=j;g=j}else{g=+o[d+(f<<2)>>2]*c;if(!(g<0.0)){if(g>=6.0)do g=g+-6.0;while(g>=6.0)}else do g=g+6.0;while(g<0.0);a=~~g;a=a-(+(a|0)>g&1)|0;u=a>>>0>5;i=u?0.0:g-+(a|0);a=u?0:a;o[q>>2]=j;o[n>>2]=j*(1.0-h);o[p>>2]=j*(1.0-h*i);o[l>>2]=j*(1.0-h*(1.0-i));h=+o[q+(k[53800+(a*12|0)+8>>2]<<2)>>2];i=+o[q+(k[53800+(a*12|0)+4>>2]<<2)>>2];g=+o[q+(k[53800+(a*12|0)>>2]<<2)>>2]}o[e+(b<<2)>>2]=g;o[e+4>>2]=i;o[e+(m<<2)>>2]=h;o[e+12>>2]=1.0;f=f+3|0;if((f|0)>=(s|0))break;else e=e+16|0}r=t;return}else{f=0;while(1){h=+o[d+(f+1<<2)>>2];j=+o[d+(f+2<<2)>>2];if(h==0.0){h=j;i=j;g=j}else{g=+o[d+(f<<2)>>2]*c;if(!(g<0.0)){if(g>=6.0)do g=g+-6.0;while(g>=6.0)}else do g=g+6.0;while(g<0.0);u=~~g;u=u-(+(u|0)>g&1)|0;v=u>>>0>5;i=v?0.0:g-+(u|0);u=v?0:u;o[q>>2]=j;o[n>>2]=j*(1.0-h);o[p>>2]=j*(1.0-h*i);o[l>>2]=j*(1.0-h*(1.0-i));h=+o[q+(k[53800+(u*12|0)+8>>2]<<2)>>2];i=+o[q+(k[53800+(u*12|0)+4>>2]<<2)>>2];g=+o[q+(k[53800+(u*12|0)>>2]<<2)>>2]}o[e+(b<<2)>>2]=g;o[e+4>>2]=i;o[e+(m<<2)>>2]=h;f=f+3|0;if((f|0)>=(s|0))break;else e=e+(a<<2)|0}r=t;return}}function Oca(a){a=a|0;ggb(a);return}function Pca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0,h=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;B=r;r=r+3072|0;y=B;z=a+4|0;c=k[z>>2]|0;d=k[b>>2]|0;A=a+8|0;e=k[A>>2]|0;x=b+4|0;b=k[x>>2]|0;if((d|0)>=(b|0)){r=B;return}t=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;w=a+12|0;v=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;a=e;while(1){e=k[w>>2]|0;q=k[c+12>>2]|0;s=k[e>>2]|0;if((q|0)>0){p=(s|0)==4;m=e+4|0;n=e+8|0;j=e+12|0;b=t;g=0;h=v;while(1){a=q-g|0;c=(a|0)>256?256:a;e=c*3|0;if((a|0)>0){a=0;do{o[y+(a<<2)>>2]=+(l[h+a>>0]|0);C=a+1|0;o[y+(C<<2)>>2]=+(l[h+C>>0]|0)*.003921568859368563;C=a+2|0;o[y+(C<<2)>>2]=+(l[h+C>>0]|0)*.003921568859368563;a=a+3|0}while((a|0)<(e|0));Nca(k[m>>2]|0,k[n>>2]|0,+o[j>>2],y,y,c);if(p){c=0;do{f=+o[y+(c<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[y+(c+1<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b+1>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[y+(c+2<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}C=~~f;i[b+2>>0]=C>>>0<256?C:(C|0)>0?255:0;i[b+3>>0]=-1;c=c+3|0;b=b+4|0}while((c|0)<(e|0))}else{c=0;do{f=+o[y+(c<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[y+(c+1<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[b+1>>0]=a>>>0<256?a:(a|0)>0?255:0;f=+o[y+(c+2<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}C=~~f;i[b+2>>0]=C>>>0<256?C:(C|0)>0?255:0;c=c+3|0;b=b+s|0}while((c|0)<(e|0))}}else Nca(k[m>>2]|0,k[n>>2]|0,+o[j>>2],y,y,c);g=g+256|0;if((g|0)>=(q|0))break;else h=h+768|0}c=k[z>>2]|0;a=k[A>>2]|0;b=k[x>>2]|0}d=d+1|0;if((d|0)>=(b|0))break;else{t=t+(k[a+48>>2]|0)|0;v=v+(k[c+48>>2]|0)|0}}r=B;return}function Qca(a){a=a|0;ggb(a);return}function Rca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+4|0;g=k[i>>2]|0;f=k[b>>2]|0;j=a+8|0;c=k[j>>2]|0;h=b+4|0;if((f|0)>=(k[h>>2]|0))return;c=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,f)|0)|0;e=a+12|0;d=(k[g+16>>2]|0)+(aa(k[k[g+44>>2]>>2]|0,f)|0)|0;a=f;b=g;while(1){g=k[e>>2]|0;Sca(k[g>>2]|0,k[g+4>>2]|0,+o[g+8>>2],d,c,k[b+12>>2]|0);a=a+1|0;b=k[i>>2]|0;if((a|0)>=(k[h>>2]|0))break;else{c=c+(k[(k[j>>2]|0)+48>>2]|0)|0;d=d+(k[b+48>>2]|0)|0}}return}function Sca(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,p=0.0,q=0;p=c*2.7777778450399637e-03;q=f*3|0;if((f|0)<=0)return;n=b^2;f=0;while(1){l=+o[d+(b<<2)>>2];j=+o[d+4>>2];k=+o[d+(n<<2)>>2];i=k<j?j:k;i=i<l?l:i;c=k>j?j:k;c=c>l?l:c;h=i-c;g=i+c;m=g*.5;if(h>1.1920928955078125e-07){g=h/(m<.5?g:2.0-i-c);c=60.0/h;do if(!(i==k))if(i==j){c=(l-k)*c+120.0;break}else{c=(k-j)*c+240.0;break}else c=(j-l)*c;while(0);if(c<0.0)c=c+360.0}else{g=0.0;c=0.0}o[e+(f<<2)>>2]=p*c;o[e+(f+1<<2)>>2]=m;o[e+(f+2<<2)>>2]=g;f=f+3|0;if((f|0)>=(q|0))break;else d=d+(a<<2)|0}return}function Tca(a){a=a|0;ggb(a);return}function Uca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0,h=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+3072|0;y=B;z=a+4|0;c=k[z>>2]|0;d=k[b>>2]|0;A=a+8|0;e=k[A>>2]|0;x=b+4|0;b=k[x>>2]|0;if((d|0)>=(b|0)){r=B;return}t=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;w=a+12|0;v=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;a=e;while(1){e=k[w>>2]|0;q=k[c+12>>2]|0;s=k[e>>2]|0;if((q|0)>0){n=e+4|0;p=e+8|0;m=e+12|0;h=t;j=0;b=v;while(1){e=q-j|0;c=(e|0)>256?256:e;g=c*3|0;if((e|0)>0){a=0;do{o[y+(a<<2)>>2]=+(l[b>>0]|0)*.003921568859368563;o[y+(a+1<<2)>>2]=+(l[b+1>>0]|0)*.003921568859368563;o[y+(a+2<<2)>>2]=+(l[b+2>>0]|0)*.003921568859368563;a=a+3|0;b=b+s|0}while((a|0)<(g|0));Sca(k[n>>2]|0,k[p>>2]|0,+o[m>>2],y,y,c);e=0;do{f=+o[y+(e<<2)>>2];a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}c=~~f;i[h+e>>0]=c>>>0<256?c:(c|0)>0?255:0;c=e+1|0;f=+o[y+(c<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[h+c>>0]=a>>>0<256?a:(a|0)>0?255:0;c=e+2|0;f=+o[y+(c<<2)>>2]*255.0;a=(o[u>>2]=f,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}a=~~f;i[h+c>>0]=a>>>0<256?a:(a|0)>0?255:0;e=e+3|0}while((e|0)<(g|0))}else Sca(k[n>>2]|0,k[p>>2]|0,+o[m>>2],y,y,c);j=j+256|0;if((j|0)>=(q|0))break;else h=h+768|0}c=k[z>>2]|0;a=k[A>>2]|0;b=k[x>>2]|0}d=d+1|0;if((d|0)>=(b|0))break;else{t=t+(k[a+48>>2]|0)|0;v=v+(k[c+48>>2]|0)|0}}r=B;return}function Vca(a){a=a|0;ggb(a);return}function Wca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,l=0.0,m=0,n=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=a+4|0;d=k[u>>2]|0;c=k[b>>2]|0;v=a+8|0;e=k[v>>2]|0;t=k[b+4>>2]|0;if((c|0)>=(t|0))return;q=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,c)|0)|0;s=a+12|0;r=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;b=d;a=e;while(1){p=k[s>>2]|0;d=k[b+12>>2]|0;e=k[p+4>>2]|0;m=k[p>>2]|0;n=+o[p+8>>2]*2.7777778450399637e-03;p=d*3|0;if((d|0)>0){d=e^2;b=r;a=0;while(1){f=+o[b+(e<<2)>>2];g=+o[b+4>>2];h=+o[b+(d<<2)>>2];j=h<g?g:h;j=j<f?f:j;i=h>g?g:h;i=j-(i>f?f:i);l=i/(+P(+j)+1.1920928955078125e-07);i=60.0/(i+1.1920928955078125e-07);do if(!(j==h))if(j==g){f=(f-h)*i+120.0;break}else{f=(h-g)*i+240.0;break}else f=(g-f)*i;while(0);o[q+(a<<2)>>2]=n*(f<0.0?f+360.0:f);o[q+(a+1<<2)>>2]=l;o[q+(a+2<<2)>>2]=j;a=a+3|0;if((a|0)>=(p|0))break;else b=b+(m<<2)|0}b=k[u>>2]|0;a=k[v>>2]|0}c=c+1|0;if((c|0)==(t|0))break;else{q=q+(k[a+48>>2]|0)|0;r=r+(k[b+48>>2]|0)|0}}return}function Xca(a){a=a|0;ggb(a);return}function Yca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;t=a+4|0;e=k[t>>2]|0;d=k[b>>2]|0;v=a+8|0;c=k[v>>2]|0;s=b+4|0;if((d|0)>=(k[s>>2]|0))return;o=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;r=a+12|0;q=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){j=k[r>>2]|0;c=k[b+12>>2]|0;e=k[j+4>>2]|0;h=k[j>>2]|0;j=k[j+8>>2]|0;n=(j|0)==180?479904:480928;m=c*3|0;if(!(i[1012628]|0)){k[120232]=0;k[119976]=0;k[120488]=0;a=1;do{g=+(a|0);f=1044480.0/g;p[u>>3]=f;b=k[u+4>>2]|0;w=b&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){b=(b|0)<0;f=b?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=b?-0.0:0.0}k[481952+(a<<2)>>2]=~~f;g=g*6.0;f=737280.0/g;p[u>>3]=f;b=k[u+4>>2]|0;w=b&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){b=(b|0)<0;f=b?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=b?-0.0:0.0}k[479904+(a<<2)>>2]=~~f;f=1048576.0/g;p[u>>3]=f;b=k[u+4>>2]|0;w=b&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){b=(b|0)<0;f=b?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=b?-0.0:0.0}k[480928+(a<<2)>>2]=~~f;a=a+1|0}while((a|0)!=256);i[1012628]=1}if((c|0)>0){c=e^2;b=q;a=0;while(1){B=l[b+e>>0]|0;z=l[b+1>>0]|0;A=l[b+c>>0]|0;C=z-B|0;w=(l[352559+(C+256)>>0]|0)+B|0;w=w+(l[352559+((A|256)-w)>>0]|0)|0;y=B-(l[352559+((B|256)-z)>>0]|0)|0;y=(l[352559+(256-A+y)>>0]|0)-y+w|0;x=((aa(y,k[481952+(w<<2)>>2]|0)|0)+2048|0)>>>12;y=(aa((w|0)==(A|0)?C:(w|0)==(z|0)?B-A+(y<<1)|0:A-z+(y<<2)|0,k[n+(y<<2)>>2]|0)|0)+2048>>12;y=((y|0)<0?j:0)+y|0;i[o+a>>0]=y>>>0<256?y:(y|0)>0?255:0;i[o+(a+1)>>0]=x;i[o+(a+2)>>0]=w;a=a+3|0;if((a|0)>=(m|0))break;else b=b+h|0}}d=d+1|0;b=k[t>>2]|0;if((d|0)>=(k[s>>2]|0))break;else{o=o+(k[(k[v>>2]|0)+48>>2]|0)|0;q=q+(k[b+48>>2]|0)|0}}return}function Zca(a){a=a|0;ggb(a);return}function _ca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,l=0.0,m=0.0,n=0.0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;u=a+4|0;e=k[u>>2]|0;d=k[b>>2]|0;v=a+8|0;c=k[v>>2]|0;t=k[b+4>>2]|0;if((d|0)>=(t|0))return;q=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;s=a+12|0;r=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){e=k[s>>2]|0;a=k[b+12>>2]|0;c=k[e>>2]|0;f=+o[e+8>>2];g=+o[e+12>>2];h=+o[e+16>>2];i=+o[e+20>>2];j=+o[e+24>>2];l=+o[e+28>>2];m=+o[e+32>>2];n=+o[e+36>>2];p=+o[e+40>>2];e=a*3|0;if((a|0)>0)if((c|0)==4){b=0;a=q;while(1){y=+o[r+(b<<2)>>2];x=+o[r+(b+1<<2)>>2];w=+o[r+(b+2<<2)>>2];o[a>>2]=f*y+g*x+h*w;o[a+4>>2]=i*y+j*x+l*w;o[a+8>>2]=m*y+n*x+p*w;o[a+12>>2]=1.0;b=b+3|0;if((b|0)>=(e|0))break;else a=a+16|0}}else{b=0;a=q;while(1){w=+o[r+(b<<2)>>2];x=+o[r+(b+1<<2)>>2];y=+o[r+(b+2<<2)>>2];o[a>>2]=f*w+g*x+h*y;o[a+4>>2]=i*w+j*x+l*y;o[a+8>>2]=m*w+n*x+p*y;b=b+3|0;if((b|0)>=(e|0))break;else a=a+(c<<2)|0}}d=d+1|0;b=k[u>>2]|0;if((d|0)==(t|0))break;else{q=q+(k[(k[v>>2]|0)+48>>2]|0)|0;r=r+(k[b+48>>2]|0)|0}}return}function $ca(a){a=a|0;ggb(a);return}function ada(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;v=a+4|0;e=k[v>>2]|0;d=k[b>>2]|0;w=a+8|0;c=k[w>>2]|0;u=k[b+4>>2]|0;if((d|0)>=(u|0))return;r=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;t=a+12|0;s=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){p=k[t>>2]|0;a=k[b+12>>2]|0;c=k[p>>2]|0;e=k[p+8>>2]|0;f=k[p+12>>2]|0;g=k[p+16>>2]|0;h=k[p+20>>2]|0;i=k[p+24>>2]|0;l=k[p+28>>2]|0;n=k[p+32>>2]|0;o=k[p+36>>2]|0;p=k[p+40>>2]|0;q=a*3|0;if((a|0)>0)if((c|0)==4){b=0;a=r;while(1){A=m[s+(b<<1)>>1]|0;x=aa(A,e)|0;z=m[s+(b+1<<1)>>1]|0;y=aa(z,f)|0;c=m[s+(b+2<<1)>>1]|0;y=x+2048+y+(aa(c,g)|0)>>12;x=(aa(A,h)|0)+2048+(aa(z,i)|0)+(aa(c,l)|0)>>12;c=(aa(A,n)|0)+2048+(aa(z,o)|0)+(aa(c,p)|0)>>12;j[a>>1]=y>>>0<65536?y:(y|0)>0?65535:0;j[a+2>>1]=x>>>0<65536?x:(x|0)>0?65535:0;j[a+4>>1]=c>>>0<65536?c:(c|0)>0?65535:0;j[a+6>>1]=-1;b=b+3|0;if((b|0)>=(q|0))break;else a=a+8|0}}else{b=0;a=r;while(1){B=m[s+(b<<1)>>1]|0;z=aa(B,e)|0;x=m[s+(b+1<<1)>>1]|0;y=aa(x,f)|0;A=m[s+(b+2<<1)>>1]|0;y=z+2048+y+(aa(A,g)|0)>>12;z=(aa(B,h)|0)+2048+(aa(x,i)|0)+(aa(A,l)|0)>>12;A=(aa(B,n)|0)+2048+(aa(x,o)|0)+(aa(A,p)|0)>>12;j[a>>1]=y>>>0<65536?y:(y|0)>0?65535:0;j[a+2>>1]=z>>>0<65536?z:(z|0)>0?65535:0;j[a+4>>1]=A>>>0<65536?A:(A|0)>0?65535:0;b=b+3|0;if((b|0)>=(q|0))break;else a=a+(c<<1)|0}}d=d+1|0;b=k[v>>2]|0;if((d|0)==(u|0))break;else{r=r+(k[(k[w>>2]|0)+48>>2]|0)|0;s=s+(k[b+48>>2]|0)|0}}return}function bda(a){a=a|0;ggb(a);return}function cda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;v=a+4|0;e=k[v>>2]|0;d=k[b>>2]|0;w=a+8|0;c=k[w>>2]|0;u=b+4|0;if((d|0)>=(k[u>>2]|0))return;r=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;t=a+12|0;s=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){p=k[t>>2]|0;a=k[b+12>>2]|0;c=k[p>>2]|0;e=k[p+8>>2]|0;f=k[p+12>>2]|0;g=k[p+16>>2]|0;h=k[p+20>>2]|0;j=k[p+24>>2]|0;m=k[p+28>>2]|0;n=k[p+32>>2]|0;o=k[p+36>>2]|0;p=k[p+40>>2]|0;q=a*3|0;if((a|0)>0)if((c|0)==4){b=0;a=r;while(1){A=l[s+b>>0]|0;x=aa(A,e)|0;z=l[s+(b+1)>>0]|0;y=aa(z,f)|0;c=l[s+(b+2)>>0]|0;y=x+2048+y+(aa(c,g)|0)>>12;x=(aa(A,h)|0)+2048+(aa(z,j)|0)+(aa(c,m)|0)>>12;c=(aa(A,n)|0)+2048+(aa(z,o)|0)+(aa(c,p)|0)>>12;i[a>>0]=y>>>0<256?y:(y|0)>0?255:0;i[a+1>>0]=x>>>0<256?x:(x|0)>0?255:0;i[a+2>>0]=c>>>0<256?c:(c|0)>0?255:0;i[a+3>>0]=-1;b=b+3|0;if((b|0)>=(q|0))break;else a=a+4|0}}else{b=0;a=r;while(1){B=l[s+b>>0]|0;z=aa(B,e)|0;x=l[s+(b+1)>>0]|0;y=aa(x,f)|0;A=l[s+(b+2)>>0]|0;y=z+2048+y+(aa(A,g)|0)>>12;z=(aa(B,h)|0)+2048+(aa(x,j)|0)+(aa(A,m)|0)>>12;A=(aa(B,n)|0)+2048+(aa(x,o)|0)+(aa(A,p)|0)>>12;i[a>>0]=y>>>0<256?y:(y|0)>0?255:0;i[a+1>>0]=z>>>0<256?z:(z|0)>0?255:0;i[a+2>>0]=A>>>0<256?A:(A|0)>0?255:0;b=b+3|0;if((b|0)>=(q|0))break;else a=a+c|0}}d=d+1|0;b=k[v>>2]|0;if((d|0)>=(k[u>>2]|0))break;else{r=r+(k[(k[w>>2]|0)+48>>2]|0)|0;s=s+(k[b+48>>2]|0)|0}}return}function dda(a){a=a|0;ggb(a);return}function eda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,l=0.0,m=0.0,n=0.0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;u=a+4|0;d=k[u>>2]|0;c=k[b>>2]|0;v=a+8|0;e=k[v>>2]|0;t=k[b+4>>2]|0;if((c|0)>=(t|0))return;q=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,c)|0)|0;s=a+12|0;r=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;b=d;a=e;while(1){e=k[s>>2]|0;w=k[b+12>>2]|0;d=k[e>>2]|0;f=+o[e+4>>2];g=+o[e+8>>2];h=+o[e+12>>2];i=+o[e+16>>2];j=+o[e+20>>2];l=+o[e+24>>2];m=+o[e+28>>2];n=+o[e+32>>2];p=+o[e+36>>2];e=w*3|0;if((w|0)>0){b=0;a=r;while(1){z=+o[a>>2];y=+o[a+4>>2];x=+o[a+8>>2];o[q+(b<<2)>>2]=f*z+g*y+h*x;o[q+(b+1<<2)>>2]=i*z+j*y+l*x;o[q+(b+2<<2)>>2]=m*z+n*y+p*x;b=b+3|0;if((b|0)>=(e|0))break;else a=a+(d<<2)|0}b=k[u>>2]|0;a=k[v>>2]|0}c=c+1|0;if((c|0)==(t|0))break;else{q=q+(k[a+48>>2]|0)|0;r=r+(k[b+48>>2]|0)|0}}return}function fda(a){a=a|0;ggb(a);return}function gda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;v=a+4|0;e=k[v>>2]|0;c=k[b>>2]|0;w=a+8|0;d=k[w>>2]|0;u=k[b+4>>2]|0;if((c|0)>=(u|0))return;r=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;t=a+12|0;s=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,c)|0)|0;b=d;a=e;while(1){p=k[t>>2]|0;x=k[a+12>>2]|0;d=k[p>>2]|0;e=k[p+4>>2]|0;f=k[p+8>>2]|0;g=k[p+12>>2]|0;h=k[p+16>>2]|0;i=k[p+20>>2]|0;l=k[p+24>>2]|0;n=k[p+28>>2]|0;o=k[p+32>>2]|0;p=k[p+36>>2]|0;q=x*3|0;if((x|0)>0){b=0;a=s;while(1){B=m[a>>1]|0;y=aa(B,e)|0;A=m[a+2>>1]|0;z=aa(A,f)|0;x=m[a+4>>1]|0;z=y+2048+z+(aa(x,g)|0)>>12;y=(aa(B,h)|0)+2048+(aa(A,i)|0)+(aa(x,l)|0)>>12;x=(aa(B,n)|0)+2048+(aa(A,o)|0)+(aa(x,p)|0)>>12;j[r+(b<<1)>>1]=z>>>0<65536?z:(z|0)>0?65535:0;j[r+(b+1<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;j[r+(b+2<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;b=b+3|0;if((b|0)>=(q|0))break;else a=a+(d<<1)|0}a=k[v>>2]|0;b=k[w>>2]|0}c=c+1|0;if((c|0)==(u|0))break;else{r=r+(k[b+48>>2]|0)|0;s=s+(k[a+48>>2]|0)|0}}return}function hda(a){a=a|0;ggb(a);return}function ida(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;w=a+4|0;c=k[w>>2]|0;d=k[b>>2]|0;x=a+8|0;e=k[x>>2]|0;v=b+4|0;b=k[v>>2]|0;if((d|0)>=(b|0))return;s=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;u=a+12|0;t=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;a=e;while(1){q=k[u>>2]|0;y=k[c+12>>2]|0;e=k[q>>2]|0;f=k[q+4>>2]|0;g=k[q+8>>2]|0;h=k[q+12>>2]|0;j=k[q+16>>2]|0;m=k[q+20>>2]|0;n=k[q+24>>2]|0;o=k[q+28>>2]|0;p=k[q+32>>2]|0;q=k[q+36>>2]|0;r=y*3|0;if((y|0)>0){b=0;a=t;while(1){B=l[a>>0]|0;c=aa(B,f)|0;A=l[a+1>>0]|0;z=aa(A,g)|0;y=l[a+2>>0]|0;z=c+2048+z+(aa(y,h)|0)>>12;c=(aa(B,j)|0)+2048+(aa(A,m)|0)+(aa(y,n)|0)>>12;y=(aa(B,o)|0)+2048+(aa(A,p)|0)+(aa(y,q)|0)>>12;i[s+b>>0]=z>>>0<256?z:(z|0)>0?255:0;i[s+(b+1)>>0]=c>>>0<256?c:(c|0)>0?255:0;i[s+(b+2)>>0]=y>>>0<256?y:(y|0)>0?255:0;b=b+3|0;if((b|0)>=(r|0))break;else a=a+e|0}c=k[w>>2]|0;a=k[x>>2]|0;b=k[v>>2]|0}d=d+1|0;if((d|0)>=(b|0))break;else{s=s+(k[a+48>>2]|0)|0;t=t+(k[c+48>>2]|0)|0}}return}function jda(a){a=a|0;ggb(a);return}function kda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0.0,i=0.0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0;r=a+4|0;e=k[r>>2]|0;d=k[b>>2]|0;s=a+8|0;c=k[s>>2]|0;q=k[b+4>>2]|0;if((d|0)>=(q|0))return;m=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;p=a+12|0;n=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){j=k[p>>2]|0;l=k[b+12>>2]|0;c=k[j>>2]|0;e=k[j+4>>2]|0;f=+o[j+8>>2];g=+o[j+12>>2];h=+o[j+16>>2];i=+o[j+20>>2];j=l*3|0;if((l|0)>0){l=e^2;if((c|0)==4){b=0;a=m;while(1){u=+o[n+(b<<2)>>2];v=+o[n+(b+2<<2)>>2]+-.5;t=+o[n+(b+1<<2)>>2]+-.5;o[a+(e<<2)>>2]=u+i*v;o[a+4>>2]=g*t+(u+h*v);o[a+(l<<2)>>2]=u+f*t;o[a+12>>2]=1.0;b=b+3|0;if((b|0)>=(j|0))break;else a=a+16|0}}else{b=0;a=m;while(1){u=+o[n+(b<<2)>>2];t=+o[n+(b+2<<2)>>2]+-.5;v=+o[n+(b+1<<2)>>2]+-.5;o[a+(e<<2)>>2]=u+i*t;o[a+4>>2]=g*v+(u+h*t);o[a+(l<<2)>>2]=u+f*v;b=b+3|0;if((b|0)>=(j|0))break;else a=a+(c<<2)|0}}}d=d+1|0;b=k[r>>2]|0;if((d|0)==(q|0))break;else{m=m+(k[(k[s>>2]|0)+48>>2]|0)|0;n=n+(k[b+48>>2]|0)|0}}return}function lda(a){a=a|0;ggb(a);return}function mda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;s=a+4|0;e=k[s>>2]|0;d=k[b>>2]|0;t=a+8|0;c=k[t>>2]|0;r=k[b+4>>2]|0;if((d|0)>=(r|0))return;o=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;q=a+12|0;p=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){i=k[q>>2]|0;n=k[b+12>>2]|0;c=k[i>>2]|0;e=k[i+4>>2]|0;f=k[i+8>>2]|0;g=k[i+12>>2]|0;h=k[i+16>>2]|0;i=k[i+20>>2]|0;l=n*3|0;if((n|0)>0){n=e^2;if((c|0)==4){b=0;a=o;while(1){c=m[p+(b<<1)>>1]|0;u=(m[p+(b+2<<1)>>1]|0)+-32768|0;v=((aa(u,i)|0)+8192>>14)+c|0;w=(m[p+(b+1<<1)>>1]|0)+-32768|0;u=((aa(w,g)|0)+8192+(aa(u,h)|0)>>14)+c|0;c=((aa(w,f)|0)+8192>>14)+c|0;j[a+(e<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;j[a+2>>1]=u>>>0<65536?u:(u|0)>0?65535:0;j[a+(n<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;j[a+6>>1]=-1;b=b+3|0;if((b|0)>=(l|0))break;else a=a+8|0}}else{b=0;a=o;while(1){w=m[p+(b<<1)>>1]|0;v=(m[p+(b+2<<1)>>1]|0)+-32768|0;u=((aa(v,i)|0)+8192>>14)+w|0;x=(m[p+(b+1<<1)>>1]|0)+-32768|0;v=((aa(x,g)|0)+8192+(aa(v,h)|0)>>14)+w|0;w=((aa(x,f)|0)+8192>>14)+w|0;j[a+(e<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;j[a+2>>1]=v>>>0<65536?v:(v|0)>0?65535:0;j[a+(n<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;b=b+3|0;if((b|0)>=(l|0))break;else a=a+(c<<1)|0}}}d=d+1|0;b=k[s>>2]|0;if((d|0)==(r|0))break;else{o=o+(k[(k[t>>2]|0)+48>>2]|0)|0;p=p+(k[b+48>>2]|0)|0}}return}function nda(a){a=a|0;ggb(a);return}function oda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;s=a+4|0;e=k[s>>2]|0;d=k[b>>2]|0;t=a+8|0;c=k[t>>2]|0;r=b+4|0;if((d|0)>=(k[r>>2]|0))return;o=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;q=a+12|0;p=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){j=k[q>>2]|0;n=k[b+12>>2]|0;c=k[j>>2]|0;e=k[j+4>>2]|0;f=k[j+8>>2]|0;g=k[j+12>>2]|0;h=k[j+16>>2]|0;j=k[j+20>>2]|0;m=n*3|0;if((n|0)>0){n=e^2;if((c|0)==4){b=0;a=o;while(1){c=l[p+b>>0]|0;u=(l[p+(b+2)>>0]|0)+-128|0;v=((aa(u,j)|0)+8192>>14)+c|0;w=(l[p+(b+1)>>0]|0)+-128|0;u=((aa(w,g)|0)+8192+(aa(u,h)|0)>>14)+c|0;c=((aa(w,f)|0)+8192>>14)+c|0;i[a+e>>0]=v>>>0<256?v:(v|0)>0?255:0;i[a+1>>0]=u>>>0<256?u:(u|0)>0?255:0;i[a+n>>0]=c>>>0<256?c:(c|0)>0?255:0;i[a+3>>0]=-1;b=b+3|0;if((b|0)>=(m|0))break;else a=a+4|0}}else{b=0;a=o;while(1){w=l[p+b>>0]|0;v=(l[p+(b+2)>>0]|0)+-128|0;u=((aa(v,j)|0)+8192>>14)+w|0;x=(l[p+(b+1)>>0]|0)+-128|0;v=((aa(x,g)|0)+8192+(aa(v,h)|0)>>14)+w|0;w=((aa(x,f)|0)+8192>>14)+w|0;i[a+e>>0]=u>>>0<256?u:(u|0)>0?255:0;i[a+1>>0]=v>>>0<256?v:(v|0)>0?255:0;i[a+n>>0]=w>>>0<256?w:(w|0)>0?255:0;b=b+3|0;if((b|0)>=(m|0))break;else a=a+c|0}}}d=d+1|0;b=k[s>>2]|0;if((d|0)>=(k[r>>2]|0))break;else{o=o+(k[(k[t>>2]|0)+48>>2]|0)|0;p=p+(k[b+48>>2]|0)|0}}return}function pda(a){a=a|0;ggb(a);return}function qda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0.0,i=0.0,j=0.0,l=0.0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0;s=a+4|0;d=k[s>>2]|0;c=k[b>>2]|0;t=a+8|0;e=k[t>>2]|0;r=k[b+4>>2]|0;if((c|0)>=(r|0))return;n=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,c)|0)|0;q=a+12|0;p=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;b=d;a=e;while(1){m=k[q>>2]|0;d=k[b+12>>2]|0;e=k[m>>2]|0;f=k[m+4>>2]|0;g=+o[m+8>>2];h=+o[m+12>>2];i=+o[m+16>>2];j=+o[m+20>>2];l=+o[m+24>>2];m=d*3|0;if((d|0)>0){d=f^2;b=0;a=p;while(1){w=g*+o[a>>2]+h*+o[a+4>>2]+i*+o[a+8>>2];v=j*(+o[a+(d<<2)>>2]-w)+.5;u=l*(+o[a+(f<<2)>>2]-w)+.5;o[n+(b<<2)>>2]=w;o[n+(b+1<<2)>>2]=v;o[n+(b+2<<2)>>2]=u;b=b+3|0;if((b|0)>=(m|0))break;else a=a+(e<<2)|0}b=k[s>>2]|0;a=k[t>>2]|0}c=c+1|0;if((c|0)==(r|0))break;else{n=n+(k[a+48>>2]|0)|0;p=p+(k[b+48>>2]|0)|0}}return}function rda(a){a=a|0;ggb(a);return}function sda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;t=a+4|0;e=k[t>>2]|0;c=k[b>>2]|0;u=a+8|0;d=k[u>>2]|0;s=k[b+4>>2]|0;if((c|0)>=(s|0))return;p=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;r=a+12|0;q=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,c)|0)|0;b=d;a=e;while(1){n=k[r>>2]|0;d=k[a+12>>2]|0;e=k[n>>2]|0;f=k[n+4>>2]|0;g=k[n+8>>2]|0;h=k[n+12>>2]|0;i=k[n+16>>2]|0;l=k[n+20>>2]|0;n=k[n+24>>2]|0;o=d*3|0;if((d|0)>0){d=f^2;b=0;a=q;while(1){w=aa(m[a>>1]|0,g)|0;x=aa(m[a+2>>1]|0,h)|0;x=w+8192+x+(aa(m[a+4>>1]|0,i)|0)>>14;w=(aa((m[a+(d<<1)>>1]|0)-x|0,l)|0)+536879104>>14;v=(aa((m[a+(f<<1)>>1]|0)-x|0,n)|0)+536879104>>14;j[p+(b<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;j[p+(b+1<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;j[p+(b+2<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;b=b+3|0;if((b|0)>=(o|0))break;else a=a+(e<<1)|0}b=k[u>>2]|0;a=k[t>>2]|0}c=c+1|0;if((c|0)==(s|0))break;else{p=p+(k[b+48>>2]|0)|0;q=q+(k[a+48>>2]|0)|0}}return}function tda(a){a=a|0;ggb(a);return}function uda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;t=a+4|0;d=k[t>>2]|0;c=k[b>>2]|0;u=a+8|0;e=k[u>>2]|0;s=b+4|0;b=k[s>>2]|0;if((c|0)>=(b|0))return;p=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,c)|0)|0;r=a+12|0;q=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;a=e;while(1){n=k[r>>2]|0;v=k[d+12>>2]|0;e=k[n>>2]|0;f=k[n+4>>2]|0;g=k[n+8>>2]|0;h=k[n+12>>2]|0;j=k[n+16>>2]|0;m=k[n+20>>2]|0;n=k[n+24>>2]|0;o=v*3|0;if((v|0)>0){d=f^2;b=0;a=q;while(1){w=aa(l[a>>0]|0,g)|0;x=aa(l[a+1>>0]|0,h)|0;x=w+8192+x+(aa(l[a+2>>0]|0,j)|0)>>14;w=(aa((l[a+d>>0]|0)-x|0,m)|0)+2105344>>14;v=(aa((l[a+f>>0]|0)-x|0,n)|0)+2105344>>14;i[p+b>>0]=x>>>0<256?x:(x|0)>0?255:0;i[p+(b+1)>>0]=w>>>0<256?w:(w|0)>0?255:0;i[p+(b+2)>>0]=v>>>0<256?v:(v|0)>0?255:0;b=b+3|0;if((b|0)>=(o|0))break;else a=a+e|0}a=k[u>>2]|0;b=k[s>>2]|0;d=k[t>>2]|0}c=c+1|0;if((c|0)>=(b|0))break;else{p=p+(k[a+48>>2]|0)|0;q=q+(k[d+48>>2]|0)|0}}return}function vda(a){a=a|0;ggb(a);return}function wda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0;i=a+4|0;e=k[i>>2]|0;d=k[b>>2]|0;m=a+8|0;c=k[m>>2]|0;h=k[b+4>>2]|0;if((d|0)>=(h|0))return;c=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;g=a+12|0;f=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){a=k[b+12>>2]|0;b=(a|0)>0;if((k[k[g>>2]>>2]|0)==6){if(b){b=0;do{e=l[f+b>>0]|0;j[c+(b<<1)>>1]=e<<3&2016|e>>>3|e<<8&63488;b=b+1|0}while((b|0)!=(a|0))}}else if(b){b=0;do{e=(l[f+b>>0]|0)>>>3;j[c+(b<<1)>>1]=e<<5|e|e<<10;b=b+1|0}while((b|0)!=(a|0))}d=d+1|0;b=k[i>>2]|0;if((d|0)==(h|0))break;else{c=c+(k[(k[m>>2]|0)+48>>2]|0)|0;f=f+(k[b+48>>2]|0)|0}}return}function xda(a){a=a|0;ggb(a);return}function yda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+4|0;e=k[j>>2]|0;d=k[b>>2]|0;l=a+8|0;c=k[l>>2]|0;i=k[b+4>>2]|0;if((d|0)>=(i|0))return;f=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;h=a+12|0;g=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){c=k[b+12>>2]|0;b=(c|0)>0;if((k[k[h>>2]>>2]|0)==3){if(b){b=f;a=0;while(1){e=k[g+(a<<2)>>2]|0;k[b+8>>2]=e;k[b+4>>2]=e;k[b>>2]=e;a=a+1|0;if((a|0)==(c|0))break;else b=b+12|0}}}else if(b){b=0;a=f;while(1){e=k[g+(b<<2)>>2]|0;k[a+8>>2]=e;k[a+4>>2]=e;k[a>>2]=e;o[a+12>>2]=1.0;b=b+1|0;if((b|0)==(c|0))break;else a=a+16|0}}d=d+1|0;b=k[j>>2]|0;if((d|0)==(i|0))break;else{f=f+(k[(k[l>>2]|0)+48>>2]|0)|0;g=g+(k[b+48>>2]|0)|0}}return}function zda(a){a=a|0;ggb(a);return}function Ada(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0;l=a+4|0;e=k[l>>2]|0;d=k[b>>2]|0;m=a+8|0;c=k[m>>2]|0;i=k[b+4>>2]|0;if((d|0)>=(i|0))return;f=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;h=a+12|0;g=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){c=k[b+12>>2]|0;b=(c|0)>0;if((k[k[h>>2]>>2]|0)==3){if(b){b=f;a=0;while(1){e=j[g+(a<<1)>>1]|0;j[b+4>>1]=e;j[b+2>>1]=e;j[b>>1]=e;a=a+1|0;if((a|0)==(c|0))break;else b=b+6|0}}}else if(b){b=0;a=f;while(1){e=j[g+(b<<1)>>1]|0;j[a+4>>1]=e;j[a+2>>1]=e;j[a>>1]=e;j[a+6>>1]=-1;b=b+1|0;if((b|0)==(c|0))break;else a=a+8|0}}d=d+1|0;b=k[l>>2]|0;if((d|0)==(i|0))break;else{f=f+(k[(k[m>>2]|0)+48>>2]|0)|0;g=g+(k[b+48>>2]|0)|0}}return}function Bda(a){a=a|0;ggb(a);return}function Cda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;l=a+4|0;e=k[l>>2]|0;d=k[b>>2]|0;m=a+8|0;c=k[m>>2]|0;j=b+4|0;if((d|0)>=(k[j>>2]|0))return;f=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;h=a+12|0;g=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){c=k[b+12>>2]|0;b=(c|0)>0;if((k[k[h>>2]>>2]|0)==3){if(b){b=f;a=0;while(1){e=i[g+a>>0]|0;i[b+2>>0]=e;i[b+1>>0]=e;i[b>>0]=e;a=a+1|0;if((a|0)==(c|0))break;else b=b+3|0}}}else if(b){b=0;a=f;while(1){e=i[g+b>>0]|0;i[a+2>>0]=e;i[a+1>>0]=e;i[a>>0]=e;i[a+3>>0]=-1;b=b+1|0;if((b|0)==(c|0))break;else a=a+4|0}}d=d+1|0;b=k[l>>2]|0;if((d|0)>=(k[j>>2]|0))break;else{f=f+(k[(k[m>>2]|0)+48>>2]|0)|0;g=g+(k[b+48>>2]|0)|0}}return}function Dda(a){a=a|0;ggb(a);return}function Eda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;j=a+4|0;e=k[j>>2]|0;d=k[b>>2]|0;l=a+8|0;c=k[l>>2]|0;h=b+4|0;if((d|0)>=(k[h>>2]|0))return;c=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;g=a+12|0;f=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){a=k[b+12>>2]|0;b=(a|0)>0;if((k[k[g>>2]>>2]|0)==6){if(b){b=0;do{e=m[f+(b<<1)>>1]|0;i[c+b>>0]=(((e>>>3&252)*9617|0)+8192+((e<<3&248)*1868|0)+((e>>>8&248)*4899|0)|0)>>>14;b=b+1|0}while((b|0)!=(a|0))}}else if(b){b=0;do{e=m[f+(b<<1)>>1]|0;i[c+b>>0]=(((e>>>2&248)*9617|0)+8192+((e<<3&248)*1868|0)+((e>>>7&248)*4899|0)|0)>>>14;b=b+1|0}while((b|0)!=(a|0))}d=d+1|0;b=k[j>>2]|0;if((d|0)>=(k[h>>2]|0))break;else{c=c+(k[(k[l>>2]|0)+48>>2]|0)|0;f=f+(k[b+48>>2]|0)|0}}return}function Fda(a){a=a|0;ggb(a);return}function Gda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0.0,i=0,j=0,l=0,m=0,n=0,p=0,q=0;n=a+4|0;d=k[n>>2]|0;c=k[b>>2]|0;p=a+8|0;e=k[p>>2]|0;m=k[b+4>>2]|0;if((c|0)>=(m|0))return;i=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,c)|0)|0;l=a+12|0;j=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;b=d;a=e;while(1){q=k[l>>2]|0;d=k[b+12>>2]|0;e=k[q>>2]|0;f=+o[q+4>>2];g=+o[q+8>>2];h=+o[q+12>>2];if((d|0)>0){b=j;a=0;while(1){o[i+(a<<2)>>2]=f*+o[b>>2]+g*+o[b+4>>2]+h*+o[b+8>>2];a=a+1|0;if((a|0)==(d|0))break;else b=b+(e<<2)|0}b=k[n>>2]|0;a=k[p>>2]|0}c=c+1|0;if((c|0)==(m|0))break;else{i=i+(k[a+48>>2]|0)|0;j=j+(k[b+48>>2]|0)|0}}return}function Hda(a){a=a|0;ggb(a);return}function Ida(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0;p=a+4|0;d=k[p>>2]|0;c=k[b>>2]|0;q=a+8|0;e=k[q>>2]|0;o=k[b+4>>2]|0;if((c|0)>=(o|0))return;i=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,c)|0)|0;n=a+12|0;l=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;b=d;a=e;while(1){h=k[n>>2]|0;d=k[b+12>>2]|0;e=k[h>>2]|0;f=k[h+4>>2]|0;g=k[h+8>>2]|0;h=k[h+12>>2]|0;if((d|0)>0){b=l;a=0;while(1){s=aa(m[b>>1]|0,f)|0;r=aa(m[b+2>>1]|0,g)|0;r=(s+8192+r+(aa(m[b+4>>1]|0,h)|0)|0)>>>14&65535;j[i+(a<<1)>>1]=r;a=a+1|0;if((a|0)==(d|0))break;else b=b+(e<<1)|0}b=k[p>>2]|0;a=k[q>>2]|0}c=c+1|0;if((c|0)==(o|0))break;else{i=i+(k[a+48>>2]|0)|0;l=l+(k[b+48>>2]|0)|0}}return}function Jda(a){a=a|0;ggb(a);return}function Kda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;o=a+4|0;e=k[o>>2]|0;c=k[b>>2]|0;p=a+8|0;d=k[p>>2]|0;n=b+4|0;b=k[n>>2]|0;if((c|0)>=(b|0))return;h=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;m=a+12|0;j=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,c)|0)|0;a=e;while(1){e=k[m>>2]|0;f=k[a+12>>2]|0;g=k[e>>2]|0;if((f|0)>0){b=j;a=0;while(1){i[h+a>>0]=((k[e+4+((l[b+1>>0]|0|256)<<2)>>2]|0)+(k[e+4+((l[b>>0]|0)<<2)>>2]|0)+(k[e+4+((l[b+2>>0]|0|512)<<2)>>2]|0)|0)>>>14;a=a+1|0;if((a|0)==(f|0))break;else b=b+g|0}a=k[o>>2]|0;d=k[p>>2]|0;b=k[n>>2]|0}c=c+1|0;if((c|0)>=(b|0))break;else{h=h+(k[d+48>>2]|0)|0;j=j+(k[a+48>>2]|0)|0}}return}function Lda(a){a=a|0;ggb(a);return}function Mda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,n=0,o=0,p=0,q=0;o=a+4|0;e=k[o>>2]|0;d=k[b>>2]|0;p=a+8|0;c=k[p>>2]|0;n=b+4|0;if((d|0)>=(k[n>>2]|0))return;h=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;l=a+12|0;j=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){c=k[l>>2]|0;f=k[b+12>>2]|0;e=k[c>>2]|0;g=k[c+4>>2]|0;b=(f|0)>0;if((k[c+8>>2]|0)==6){if(b){c=g^2;if((e|0)==4){b=0;a=h;while(1){e=m[j+(b<<1)>>1]|0;i[a+g>>0]=e<<3;i[a+1>>0]=e>>>3&252;i[a+c>>0]=e>>>8&248;i[a+3>>0]=-1;b=b+1|0;if((b|0)==(f|0))break;else a=a+4|0}}else{b=0;a=h;while(1){q=m[j+(b<<1)>>1]|0;i[a+g>>0]=q<<3;i[a+1>>0]=q>>>3&252;i[a+c>>0]=q>>>8&248;b=b+1|0;if((b|0)==(f|0))break;else a=a+e|0}}}}else if(b){c=g^2;if((e|0)==4){b=0;a=h;while(1){q=m[j+(b<<1)>>1]|0;i[a+g>>0]=q<<3;i[a+1>>0]=q>>>2&248;i[a+c>>0]=q>>>7&248;i[a+3>>0]=q<<16>>31;b=b+1|0;if((b|0)==(f|0))break;else a=a+4|0}}else{b=0;a=h;while(1){q=m[j+(b<<1)>>1]|0;i[a+g>>0]=q<<3;i[a+1>>0]=q>>>2&248;i[a+c>>0]=q>>>7&248;b=b+1|0;if((b|0)==(f|0))break;else a=a+e|0}}}d=d+1|0;b=k[o>>2]|0;if((d|0)>=(k[n>>2]|0))break;else{h=h+(k[(k[p>>2]|0)+48>>2]|0)|0;j=j+(k[b+48>>2]|0)|0}}return}function Nda(a){a=a|0;ggb(a);return}function Oda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0;o=a+4|0;e=k[o>>2]|0;d=k[b>>2]|0;p=a+8|0;c=k[p>>2]|0;n=k[b+4>>2]|0;if((d|0)>=(n|0))return;g=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;m=a+12|0;h=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){c=k[m>>2]|0;e=k[b+12>>2]|0;f=k[c+4>>2]|0;b=(k[c>>2]|0)==3;a=(e|0)>0;do if((k[c+8>>2]|0)==6)if(b){if(!a)break;c=f^2;b=h;a=0;while(1){j[g+(a<<1)>>1]=l[b+1>>0]<<3&2016|(l[b+f>>0]|0)>>>3|l[b+c>>0]<<8&63488;a=a+1|0;if((a|0)==(e|0))break;else b=b+3|0}}else{if(!a)break;c=f^2;b=h;a=0;while(1){j[g+(a<<1)>>1]=l[b+1>>0]<<3&2016|(l[b+f>>0]|0)>>>3|l[b+c>>0]<<8&63488;a=a+1|0;if((a|0)==(e|0))break;else b=b+4|0}}else if(b){if(!a)break;c=f^2;b=h;a=0;while(1){j[g+(a<<1)>>1]=l[b+1>>0]<<2&992|(l[b+f>>0]|0)>>>3|l[b+c>>0]<<7&31744;a=a+1|0;if((a|0)==(e|0))break;else b=b+3|0}}else{if(!a)break;c=f^2;b=h;a=0;while(1){j[g+(a<<1)>>1]=l[b+1>>0]<<2&992|(l[b+f>>0]|0)>>>3|l[b+c>>0]<<7&31744|(i[b+3>>0]|0?32768:0);a=a+1|0;if((a|0)==(e|0))break;else b=b+4|0}}while(0);d=d+1|0;b=k[o>>2]|0;if((d|0)==(n|0))break;else{g=g+(k[(k[p>>2]|0)+48>>2]|0)|0;h=h+(k[b+48>>2]|0)|0}}return}function Pda(a){a=a|0;ggb(a);return}function Qda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0;m=a+4|0;e=k[m>>2]|0;d=k[b>>2]|0;n=a+8|0;c=k[n>>2]|0;l=k[b+4>>2]|0;if((d|0)>=(l|0))return;h=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;j=a+12|0;i=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){f=k[j>>2]|0;b=k[b+12>>2]|0;e=k[f>>2]|0;g=k[f+8>>2]|0;a:do if((k[f+4>>2]|0)==3){f=b*3|0;if((b|0)>0){c=g^2;b=0;a=i;while(1){q=k[a+4>>2]|0;p=k[a+(c<<2)>>2]|0;k[h+(b<<2)>>2]=k[a+(g<<2)>>2];k[h+(b+1<<2)>>2]=q;k[h+(b+2<<2)>>2]=p;b=b+3|0;if((b|0)>=(f|0))break;else a=a+(e<<2)|0}}}else{if((e|0)!=3){a=b<<2;if((b|0)>0)b=0;else break;while(1){f=k[i+(b<<2)>>2]|0;e=b|1;c=k[i+(e<<2)>>2]|0;g=b|2;q=b|3;p=k[i+(q<<2)>>2]|0;k[h+(b<<2)>>2]=k[i+(g<<2)>>2];k[h+(e<<2)>>2]=c;k[h+(g<<2)>>2]=f;k[h+(q<<2)>>2]=p;b=b+4|0;if((b|0)>=(a|0))break a}}e=b*3|0;if((b|0)>0){c=g^2;b=0;a=h;while(1){p=k[i+(b+1<<2)>>2]|0;q=k[i+(b+2<<2)>>2]|0;k[a+(g<<2)>>2]=k[i+(b<<2)>>2];k[a+4>>2]=p;k[a+(c<<2)>>2]=q;o[a+12>>2]=1.0;b=b+3|0;if((b|0)>=(e|0))break;else a=a+16|0}}}while(0);d=d+1|0;b=k[m>>2]|0;if((d|0)==(l|0))break;else{h=h+(k[(k[n>>2]|0)+48>>2]|0)|0;i=i+(k[b+48>>2]|0)|0}}return}function Rda(a){a=a|0;ggb(a);return}function Sda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0;n=a+4|0;e=k[n>>2]|0;d=k[b>>2]|0;o=a+8|0;c=k[o>>2]|0;m=k[b+4>>2]|0;if((d|0)>=(m|0))return;h=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;l=a+12|0;i=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){f=k[l>>2]|0;b=k[b+12>>2]|0;e=k[f>>2]|0;g=k[f+8>>2]|0;a:do if((k[f+4>>2]|0)==3){f=b*3|0;if((b|0)>0){c=g^2;b=0;a=i;while(1){q=j[a+2>>1]|0;p=j[a+(c<<1)>>1]|0;j[h+(b<<1)>>1]=j[a+(g<<1)>>1]|0;j[h+(b+1<<1)>>1]=q;j[h+(b+2<<1)>>1]=p;b=b+3|0;if((b|0)>=(f|0))break;else a=a+(e<<1)|0}}}else{if((e|0)!=3){a=b<<2;if((b|0)>0)b=0;else break;while(1){f=j[i+(b<<1)>>1]|0;e=b|1;c=j[i+(e<<1)>>1]|0;g=b|2;q=b|3;p=j[i+(q<<1)>>1]|0;j[h+(b<<1)>>1]=j[i+(g<<1)>>1]|0;j[h+(e<<1)>>1]=c;j[h+(g<<1)>>1]=f;j[h+(q<<1)>>1]=p;b=b+4|0;if((b|0)>=(a|0))break a}}e=b*3|0;if((b|0)>0){c=g^2;b=0;a=h;while(1){p=j[i+(b+1<<1)>>1]|0;q=j[i+(b+2<<1)>>1]|0;j[a+(g<<1)>>1]=j[i+(b<<1)>>1]|0;j[a+2>>1]=p;j[a+(c<<1)>>1]=q;j[a+6>>1]=-1;b=b+3|0;if((b|0)>=(e|0))break;else a=a+8|0}}}while(0);d=d+1|0;b=k[n>>2]|0;if((d|0)==(m|0))break;else{h=h+(k[(k[o>>2]|0)+48>>2]|0)|0;i=i+(k[b+48>>2]|0)|0}}return}function Tda(a){a=a|0;ggb(a);return}function Uda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;n=a+4|0;e=k[n>>2]|0;d=k[b>>2]|0;o=a+8|0;c=k[o>>2]|0;m=b+4|0;if((d|0)>=(k[m>>2]|0))return;h=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;l=a+12|0;j=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;b=e;while(1){f=k[l>>2]|0;b=k[b+12>>2]|0;e=k[f>>2]|0;g=k[f+8>>2]|0;a:do if((k[f+4>>2]|0)==3){f=b*3|0;if((b|0)>0){c=g^2;b=0;a=j;while(1){q=i[a+1>>0]|0;p=i[a+c>>0]|0;i[h+b>>0]=i[a+g>>0]|0;i[h+(b+1)>>0]=q;i[h+(b+2)>>0]=p;b=b+3|0;if((b|0)>=(f|0))break;else a=a+e|0}}}else{if((e|0)!=3){a=b<<2;if((b|0)>0)b=0;else break;while(1){f=i[j+b>>0]|0;e=b|1;c=i[j+e>>0]|0;g=b|2;q=b|3;p=i[j+q>>0]|0;i[h+b>>0]=i[j+g>>0]|0;i[h+e>>0]=c;i[h+g>>0]=f;i[h+q>>0]=p;b=b+4|0;if((b|0)>=(a|0))break a}}e=b*3|0;if((b|0)>0){c=g^2;b=h;a=0;while(1){p=i[j+(a+1)>>0]|0;q=i[j+(a+2)>>0]|0;i[b+g>>0]=i[j+a>>0]|0;i[b+1>>0]=p;i[b+c>>0]=q;i[b+3>>0]=-1;a=a+3|0;if((a|0)>=(e|0))break;else b=b+4|0}}}while(0);d=d+1|0;b=k[n>>2]|0;if((d|0)>=(k[m>>2]|0))break;else{h=h+(k[(k[o>>2]|0)+48>>2]|0)|0;j=j+(k[b+48>>2]|0)|0}}return}function Vda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+144|0;m=q+128|0;p=q+72|0;n=q+56|0;l=q;o=a+4|0;f=k[a+8>>2]|0;if((f|0)<3)a=aa(k[a+16>>2]|0,k[a+12>>2]|0)|0;else{e=k[a+44>>2]|0;d=0;a=1;do{a=aa(k[e+(d<<2)>>2]|0,a)|0;d=d+1|0}while((d|0)!=(f|0))}if((a|0)!=256){a=m+4|0;d=ZT(48)|0;k[d>>2]=1;f=d+4|0;k[m>>2]=f;k[a>>2]=41;i[d+45>>0]=0;e=241887;g=f+41|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,m,369779,241929,499);k[a>>2]=0;k[m>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[p>>2]=k[f>>2];j=p+4|0;a=f+4|0;k[j>>2]=k[a>>2];h=p+8|0;k[h>>2]=k[f+8>>2];k[p+12>>2]=k[f+12>>2];k[p+16>>2]=k[f+16>>2];k[p+20>>2]=k[f+20>>2];k[p+24>>2]=k[f+24>>2];k[p+28>>2]=k[f+28>>2];k[p+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[p+36>>2]=d;e=p+40|0;k[e>>2]=h;h=p+48|0;b=p+44|0;k[b>>2]=h;k[p+52>>2]=0;k[h>>2]=0;if(d|0){h=d+12|0;k[h>>2]=(k[h>>2]|0)+1}if((k[a>>2]|0)<3){j=k[f+44>>2]|0;a=k[b>>2]|0;k[a>>2]=k[j>>2];k[a+4>>2]=k[j+4>>2];a=p;break}k[j>>2]=0;x1(p,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[h+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0));a=p}else a=p}else{Q1(p,b,-1);a=p}while(0);a=k[a>>2]|0;switch(a&4095){case 16:case 0:{if((a&4095|0)==16){k[l>>2]=1124007936;h=l+4|0;a=l+8|0;b=l+40|0;f=h;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[b>>2]=a;g=l+48|0;f=l+44|0;k[f>>2]=g;k[l+52>>2]=0;k[g>>2]=0;e=m+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[m>>2]=33619968;k[e>>2]=l;mY(p,m);k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=l;e=m+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[m>>2]=33619968;k[e>>2]=p;$aa(n,m,6,0);e=l+36|0;a=k[e>>2]|0;if(a|0?(d=a+12|0,j=k[d>>2]|0,k[d>>2]=j+-1,(j|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;j=l+16|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[h>>2]|0)>0){d=k[b>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[f>>2]|0;if(!((a|0)==(g|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}k[l>>2]=1124007936;h=l+4|0;a=l+8|0;b=l+40|0;f=h;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[b>>2]=a;g=l+48|0;f=l+44|0;k[f>>2]=g;k[l+52>>2]=0;k[g>>2]=0;e=m+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[m>>2]=33619968;k[e>>2]=l;mY(p,m);k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=l;e=m+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[m>>2]=33619968;k[e>>2]=p;$aa(n,m,8,0);e=l+36|0;a=k[e>>2]|0;if(a|0?(d=a+12|0,j=k[d>>2]|0,k[d>>2]=j+-1,(j|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[h>>2]|0)>0){d=k[b>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[f>>2]|0;if(!((a|0)==(g|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=p;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=o;OX(m,n,c);break}default:mY(p,c)}e=p+36|0;a=k[e>>2]|0;if(a|0?(n=a+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[p+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;o=p+16|0;d=p+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[d>>2]|0)>0){e=k[p+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[p+44>>2]|0;if((a|0)==(p+48|0)|(a|0)==0){r=q;return}ggb(k[a+-4>>2]|0);r=q;return}function Wda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,n=0,q=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0;J=r;r=r+608|0;w=J+592|0;E=J+576|0;u=J+520|0;F=J+464|0;D=J+408|0;v=J+392|0;x=J;I=J+336|0;H=J+280|0;G=J+224|0;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[I>>2]=k[g>>2];s=I+4|0;b=g+4|0;k[s>>2]=k[b>>2];C=I+8|0;k[C>>2]=k[g+8>>2];k[I+12>>2]=k[g+12>>2];k[I+16>>2]=k[g+16>>2];k[I+20>>2]=k[g+20>>2];k[I+24>>2]=k[g+24>>2];k[I+28>>2]=k[g+28>>2];k[I+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[I+36>>2]=e;f=I+40|0;k[f>>2]=C;C=I+48|0;n=I+44|0;k[n>>2]=C;k[I+52>>2]=0;k[C>>2]=0;if(e|0){C=e+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[b>>2]|0)<3){B=k[g+44>>2]|0;C=k[n>>2]|0;k[C>>2]=k[B>>2];k[C+4>>2]=k[B+4>>2];break}k[s>>2]=0;x1(I,k[b>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[n>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[q+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[s>>2]|0))}}else Q1(I,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[H>>2]=k[h>>2];s=H+4|0;e=h+4|0;k[s>>2]=k[e>>2];C=H+8|0;k[C>>2]=k[h+8>>2];k[H+12>>2]=k[h+12>>2];k[H+16>>2]=k[h+16>>2];k[H+20>>2]=k[h+20>>2];k[H+24>>2]=k[h+24>>2];k[H+28>>2]=k[h+28>>2];k[H+32>>2]=k[h+32>>2];b=k[h+36>>2]|0;k[H+36>>2]=b;f=H+40|0;k[f>>2]=C;C=H+48|0;n=H+44|0;k[n>>2]=C;k[H+52>>2]=0;k[C>>2]=0;if(b|0){C=b+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[e>>2]|0)<3){B=k[h+44>>2]|0;C=k[n>>2]|0;k[C>>2]=k[B>>2];k[C+4>>2]=k[B+4>>2];break}k[s>>2]=0;x1(H,k[e>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;e=k[n>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[q+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[s>>2]|0))}}else Q1(H,c,-1);while(0);do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[G>>2]=k[g>>2];s=G+4|0;b=g+4|0;k[s>>2]=k[b>>2];C=G+8|0;k[C>>2]=k[g+8>>2];k[G+12>>2]=k[g+12>>2];k[G+16>>2]=k[g+16>>2];k[G+20>>2]=k[g+20>>2];k[G+24>>2]=k[g+24>>2];k[G+28>>2]=k[g+28>>2];k[G+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[G+36>>2]=e;f=G+40|0;k[f>>2]=C;C=G+48|0;n=G+44|0;k[n>>2]=C;k[G+52>>2]=0;k[C>>2]=0;if(e|0){C=e+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[b>>2]|0)<3){B=k[g+44>>2]|0;C=k[n>>2]|0;k[C>>2]=k[B>>2];k[C+4>>2]=k[B+4>>2];break}k[s>>2]=0;x1(G,k[b>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[n>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[q+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[s>>2]|0))}}else Q1(G,d,-1);while(0);C=k[I>>2]&4095;if(!((C|0)==(k[H>>2]&4095|0)?(C|0)==(k[G>>2]&4095|0):0)){k[w>>2]=0;b=w+4|0;k[b>>2]=0;e=ZT(56)|0;k[e>>2]=1;n=e+4|0;k[w>>2]=n;k[b>>2]=49;i[e+53>>0]=0;f=241999;q=n+49|0;do{i[n>>0]=i[f>>0]|0;n=n+1|0;f=f+1|0}while((n|0)<(q|0));Y8(-215,w,242049,241929,118);k[b>>2]=0;k[w>>2]=0;C=k[e>>2]|0;k[e>>2]=C+-1;if((C|0)==1)ggb(k[e+-4>>2]|0)}if(!(((k[I+12>>2]|0)==1?(k[I+8>>2]|0)==(k[H+8>>2]|0):0)?(k[H+12>>2]|0)==1:0)){k[w>>2]=0;b=w+4|0;k[b>>2]=0;e=ZT(64)|0;k[e>>2]=1;n=e+4|0;k[w>>2]=n;k[b>>2]=57;i[e+61>>0]=0;f=242057;q=n+57|0;do{i[n>>0]=i[f>>0]|0;n=n+1|0;f=f+1|0}while((n|0)<(q|0));Y8(-215,w,242049,241929,119);k[b>>2]=0;k[w>>2]=0;C=k[e>>2]|0;k[e>>2]=C+-1;if((C|0)==1)ggb(k[e+-4>>2]|0)}switch(k[I>>2]&4095){case 1:{B=k[G+8>>2]|0;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=I;Xda(u,F);k[E>>2]=0;C=E+4|0;k[C>>2]=0;k[E+8>>2]=0;f=w+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[w>>2]=-2113732604;k[f>>2]=E;mY(u,w);f=u+36|0;b=k[f>>2]|0;if(b|0?(z=b+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[u+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;A=u+16|0;e=u+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[e>>2]|0)>0){f=k[u+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[u+44>>2]|0;if(!((b|0)==(u+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=I;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=-2130509820;k[D+4>>2]=E;Yda(F,w,D);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=H;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=-2130509820;k[v+4>>2]=E;Yda(D,w,v);g=k[G+40>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;h=k[G>>2]&4095;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=1124007936;b=x+16|0;e=x+48|0;n=x+12|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+56|0;k[x+52>>2]=b;k[x+60>>2]=0;k[b>>2]=0;k[x+64>>2]=1124007936;b=x+72|0;e=x+104|0;n=x+68|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+112|0;k[x+108>>2]=b;k[x+116>>2]=0;k[b>>2]=0;k[x+120>>2]=1124007936;b=x+128|0;e=x+160|0;n=x+124|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;n=x+168|0;k[x+164>>2]=n;q=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[w>>2]=f;k[w+4>>2]=g;j1(x,48,w,h);k[a>>2]=1124007936;b=a+8|0;e=a+40|0;n=a+4|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;z=a+48|0;A=a+44|0;k[A>>2]=z;k[a+52>>2]=0;k[z>>2]=0;z=k[x>>2]|0;dh[k[(k[z>>2]|0)+12>>2]&255](z,x,a,-1);XN(x);if((B|0)>0){d=F+8|0;u=G+16|0;v=G+44|0;w=F+16|0;x=F+44|0;y=D+16|0;z=D+44|0;n=a+16|0;h=0;do{q=(k[u>>2]|0)+(aa(k[k[v>>2]>>2]|0,h)|0)|0;q=i[q>>0]|0;s=k[w>>2]|0;b=q<<24>>24<(i[s>>0]|0)?1:(k[d>>2]|0)+-1|0;c=k[k[x>>2]>>2]|0;e=s+(aa(b,c)|0)|0;e=q<<24>>24>(i[e>>0]|0)?b+-1|0:0;f=b-e|0;if((f|0)>1)while(1){a=f>>1;K=e+a|0;L=s+(aa(K,c)|0)|0;L=q<<24>>24>(i[L>>0]|0);e=L?K:e;g=L?b:K;f=L?b-K|0:a;if((f|0)<=1){b=g;break}else b=g}g=k[y>>2]|0;L=k[k[z>>2]>>2]|0;K=g+(aa(L,e)|0)|0;K=i[K>>0]|0;a=s+(aa(e,c)|0)|0;a=i[a>>0]|0;L=g+(aa(L,b)|0)|0;q=aa((i[L>>0]|0)-(K<<24>>24)|0,(q<<24>>24)-a|0)|0;c=s+(aa(b,c)|0)|0;L=(k[n>>2]|0)+(aa(k[k[A>>2]>>2]|0,h)|0)|0;i[L>>0]=((q|0)/((i[c>>0]|0)-a|0)|0)+(K&255)+(l[L>>0]|0);h=h+1|0}while((h|0)!=(B|0))}f=D+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=D+16|0;e=D+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[D+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[D+44>>2]|0;if(!((b|0)==(D+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=F+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[F+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=F+16|0;e=F+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[F+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[F+44>>2]|0;if(!((b|0)==(F+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[E>>2]|0;e=b;if(b|0){f=k[C>>2]|0;if((f|0)!=(b|0))k[C>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(b)}break}case 0:{B=k[G+8>>2]|0;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=I;Xda(u,F);k[E>>2]=0;C=E+4|0;k[C>>2]=0;k[E+8>>2]=0;f=w+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[w>>2]=-2113732604;k[f>>2]=E;mY(u,w);f=u+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[u+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=u+16|0;e=u+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[u+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[u+44>>2]|0;if(!((b|0)==(u+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=I;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=-2130509820;k[D+4>>2]=E;Yda(F,w,D);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=H;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=-2130509820;k[v+4>>2]=E;Yda(D,w,v);g=k[G+40>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;h=k[G>>2]&4095;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=1124007936;b=x+16|0;e=x+48|0;n=x+12|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+56|0;k[x+52>>2]=b;k[x+60>>2]=0;k[b>>2]=0;k[x+64>>2]=1124007936;b=x+72|0;e=x+104|0;n=x+68|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+112|0;k[x+108>>2]=b;k[x+116>>2]=0;k[b>>2]=0;k[x+120>>2]=1124007936;b=x+128|0;e=x+160|0;n=x+124|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;n=x+168|0;k[x+164>>2]=n;q=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[w>>2]=f;k[w+4>>2]=g;j1(x,48,w,h);k[a>>2]=1124007936;b=a+8|0;e=a+40|0;n=a+4|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;L=a+48|0;A=a+44|0;k[A>>2]=L;k[a+52>>2]=0;k[L>>2]=0;L=k[x>>2]|0;dh[k[(k[L>>2]|0)+12>>2]&255](L,x,a,-1);XN(x);if((B|0)>0){d=F+8|0;u=G+16|0;v=G+44|0;w=F+16|0;x=F+44|0;y=D+16|0;z=D+44|0;n=a+16|0;h=0;do{q=(k[u>>2]|0)+(aa(k[k[v>>2]>>2]|0,h)|0)|0;q=i[q>>0]|0;s=k[w>>2]|0;b=(q&255)<(l[s>>0]|0)?1:(k[d>>2]|0)+-1|0;c=k[k[x>>2]>>2]|0;e=s+(aa(b,c)|0)|0;e=(q&255)>(l[e>>0]|0)?b+-1|0:0;f=b-e|0;if((f|0)>1)while(1){L=f>>1;K=e+L|0;a=s+(aa(K,c)|0)|0;a=(q&255)>(l[a>>0]|0);e=a?K:e;g=a?b:K;f=a?b-K|0:L;if((f|0)<=1){b=g;break}else b=g}g=k[y>>2]|0;L=k[k[z>>2]>>2]|0;K=g+(aa(L,e)|0)|0;K=l[K>>0]|0;a=s+(aa(e,c)|0)|0;a=l[a>>0]|0;L=g+(aa(L,b)|0)|0;q=aa((l[L>>0]|0)-K|0,(q&255)-a|0)|0;c=s+(aa(b,c)|0)|0;L=(k[n>>2]|0)+(aa(k[k[A>>2]>>2]|0,h)|0)|0;i[L>>0]=((q|0)/((l[c>>0]|0)-a|0)|0)+K+(l[L>>0]|0);h=h+1|0}while((h|0)!=(B|0))}f=D+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=D+16|0;e=D+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[D+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[D+44>>2]|0;if(!((b|0)==(D+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=F+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[F+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=F+16|0;e=F+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[F+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[F+44>>2]|0;if(!((b|0)==(F+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[E>>2]|0;e=b;if(b|0){f=k[C>>2]|0;if((f|0)!=(b|0))k[C>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(b)}break}case 3:{z=k[G+8>>2]|0;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=I;Xda(u,F);k[E>>2]=0;A=E+4|0;k[A>>2]=0;k[E+8>>2]=0;f=w+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[w>>2]=-2113732604;k[f>>2]=E;mY(u,w);f=u+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[u+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=u+16|0;e=u+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[u+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[u+44>>2]|0;if(!((b|0)==(u+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=I;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=-2130509820;k[D+4>>2]=E;Yda(F,w,D);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=H;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=-2130509820;k[v+4>>2]=E;Yda(D,w,v);g=k[G+40>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;h=k[G>>2]&4095;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=1124007936;b=x+16|0;e=x+48|0;n=x+12|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+56|0;k[x+52>>2]=b;k[x+60>>2]=0;k[b>>2]=0;k[x+64>>2]=1124007936;b=x+72|0;e=x+104|0;n=x+68|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+112|0;k[x+108>>2]=b;k[x+116>>2]=0;k[b>>2]=0;k[x+120>>2]=1124007936;b=x+128|0;e=x+160|0;n=x+124|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;n=x+168|0;k[x+164>>2]=n;q=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[w>>2]=f;k[w+4>>2]=g;j1(x,48,w,h);k[a>>2]=1124007936;b=a+8|0;e=a+40|0;n=a+4|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;L=a+48|0;b=a+44|0;k[b>>2]=L;k[a+52>>2]=0;k[L>>2]=0;L=k[x>>2]|0;dh[k[(k[L>>2]|0)+12>>2]&255](L,x,a,-1);XN(x);if((z|0)>0){c=(k[F+8>>2]|0)+-1|0;d=k[G+16>>2]|0;u=k[k[G+44>>2]>>2]|0;v=k[F+16>>2]|0;w=k[k[F+44>>2]>>2]|0;x=k[D+16>>2]|0;y=k[k[D+44>>2]>>2]|0;s=k[a+16>>2]|0;n=k[k[b>>2]>>2]|0;h=0;do{q=d+(aa(h,u)|0)|0;q=j[q>>1]|0;b=q<<16>>16<(j[v>>1]|0)?1:c;e=v+(aa(b,w)|0)|0;e=q<<16>>16>(j[e>>1]|0)?b+-1|0:0;f=b-e|0;if((f|0)>1)while(1){L=f>>1;K=e+L|0;a=v+(aa(K,w)|0)|0;a=q<<16>>16>(j[a>>1]|0);e=a?K:e;g=a?b:K;f=a?b-K|0:L;if((f|0)<=1){b=g;break}else b=g}K=x+(aa(e,y)|0)|0;K=j[K>>1]|0;a=v+(aa(e,w)|0)|0;a=j[a>>1]|0;B=x+(aa(b,y)|0)|0;B=aa((j[B>>1]|0)-(K<<16>>16)|0,(q<<16>>16)-a|0)|0;C=v+(aa(b,w)|0)|0;L=s+(aa(h,n)|0)|0;j[L>>1]=((B|0)/((j[C>>1]|0)-a|0)|0)+(K&65535)+(m[L>>1]|0);h=h+1|0}while((h|0)!=(z|0))}f=D+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=D+16|0;e=D+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[D+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[D+44>>2]|0;if(!((b|0)==(D+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=F+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){b=k[f>>2]|0;if(b|0){e=k[b+4>>2]|0;do if(!e){e=k[F+32>>2]|0;if(e|0)break;e=B1()|0;b=k[f>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,b)}k[f>>2]=0}k[f>>2]=0;L=F+16|0;e=F+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[F+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[F+44>>2]|0;if(!((b|0)==(F+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[E>>2]|0;e=b;if(b|0){f=k[A>>2]|0;if((f|0)!=(b|0))k[A>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(b)}break}case 2:{z=k[G+8>>2]|0;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=I;Xda(u,F);k[E>>2]=0;A=E+4|0;k[A>>2]=0;k[E+8>>2]=0;f=w+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[w>>2]=-2113732604;k[f>>2]=E;mY(u,w);f=u+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[u+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=u+16|0;e=u+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[u+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[u+44>>2]|0;if(!((b|0)==(u+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=I;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=-2130509820;k[D+4>>2]=E;Yda(F,w,D);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=H;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=-2130509820;k[v+4>>2]=E;Yda(D,w,v);g=k[G+40>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;h=k[G>>2]&4095;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=1124007936;b=x+16|0;e=x+48|0;n=x+12|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+56|0;k[x+52>>2]=b;k[x+60>>2]=0;k[b>>2]=0;k[x+64>>2]=1124007936;b=x+72|0;e=x+104|0;n=x+68|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+112|0;k[x+108>>2]=b;k[x+116>>2]=0;k[b>>2]=0;k[x+120>>2]=1124007936;b=x+128|0;e=x+160|0;n=x+124|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;n=x+168|0;k[x+164>>2]=n;q=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[w>>2]=f;k[w+4>>2]=g;j1(x,48,w,h);k[a>>2]=1124007936;b=a+8|0;e=a+40|0;n=a+4|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;L=a+48|0;b=a+44|0;k[b>>2]=L;k[a+52>>2]=0;k[L>>2]=0;L=k[x>>2]|0;dh[k[(k[L>>2]|0)+12>>2]&255](L,x,a,-1);XN(x);if((z|0)>0){c=(k[F+8>>2]|0)+-1|0;d=k[G+16>>2]|0;u=k[k[G+44>>2]>>2]|0;v=k[F+16>>2]|0;w=k[k[F+44>>2]>>2]|0;x=k[D+16>>2]|0;y=k[k[D+44>>2]>>2]|0;s=k[a+16>>2]|0;n=k[k[b>>2]>>2]|0;h=0;do{q=d+(aa(h,u)|0)|0;q=j[q>>1]|0;b=(q&65535)<(m[v>>1]|0)?1:c;e=v+(aa(b,w)|0)|0;e=(q&65535)>(m[e>>1]|0)?b+-1|0:0;f=b-e|0;if((f|0)>1)while(1){L=f>>1;K=e+L|0;a=v+(aa(K,w)|0)|0;a=(q&65535)>(m[a>>1]|0);e=a?K:e;g=a?b:K;f=a?b-K|0:L;if((f|0)<=1){b=g;break}else b=g}K=x+(aa(e,y)|0)|0;K=m[K>>1]|0;a=v+(aa(e,w)|0)|0;a=m[a>>1]|0;B=x+(aa(b,y)|0)|0;B=aa((m[B>>1]|0)-K|0,(q&65535)-a|0)|0;C=v+(aa(b,w)|0)|0;L=s+(aa(h,n)|0)|0;j[L>>1]=((B|0)/((m[C>>1]|0)-a|0)|0)+K+(m[L>>1]|0);h=h+1|0}while((h|0)!=(z|0))}f=D+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=D+16|0;e=D+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[D+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[D+44>>2]|0;if(!((b|0)==(D+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=F+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[F+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=F+16|0;e=F+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[F+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[F+44>>2]|0;if(!((b|0)==(F+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[E>>2]|0;e=b;if(b|0){f=k[A>>2]|0;if((f|0)!=(b|0))k[A>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(b)}break}case 4:{A=k[G+8>>2]|0;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=I;Xda(u,F);k[E>>2]=0;B=E+4|0;k[B>>2]=0;k[E+8>>2]=0;f=w+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[w>>2]=-2113732604;k[f>>2]=E;mY(u,w);f=u+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[u+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=u+16|0;e=u+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[u+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[u+44>>2]|0;if(!((b|0)==(u+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=I;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=-2130509820;k[D+4>>2]=E;Yda(F,w,D);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=H;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=-2130509820;k[v+4>>2]=E;Yda(D,w,v);g=k[G+40>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;h=k[G>>2]&4095;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=1124007936;b=x+16|0;e=x+48|0;n=x+12|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+56|0;k[x+52>>2]=b;k[x+60>>2]=0;k[b>>2]=0;k[x+64>>2]=1124007936;b=x+72|0;e=x+104|0;n=x+68|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+112|0;k[x+108>>2]=b;k[x+116>>2]=0;k[b>>2]=0;k[x+120>>2]=1124007936;b=x+128|0;e=x+160|0;n=x+124|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;n=x+168|0;k[x+164>>2]=n;q=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[w>>2]=f;k[w+4>>2]=g;j1(x,48,w,h);k[a>>2]=1124007936;b=a+8|0;e=a+40|0;n=a+4|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;L=a+48|0;b=a+44|0;k[b>>2]=L;k[a+52>>2]=0;k[L>>2]=0;L=k[x>>2]|0;dh[k[(k[L>>2]|0)+12>>2]&255](L,x,a,-1);XN(x);if((A|0)>0){d=F+8|0;u=k[G+16>>2]|0;v=k[G+44>>2]|0;w=k[F+16>>2]|0;x=k[F+44>>2]|0;y=k[D+16>>2]|0;z=k[D+44>>2]|0;c=k[a+16>>2]|0;n=k[b>>2]|0;h=0;do{q=u+(aa(k[v>>2]|0,h)|0)|0;q=k[q>>2]|0;b=(q|0)<(k[w>>2]|0)?1:(k[d>>2]|0)+-1|0;s=k[x>>2]|0;e=w+(aa(b,s)|0)|0;e=(q|0)>(k[e>>2]|0)?b+-1|0:0;f=b-e|0;if((f|0)>1)while(1){L=f>>1;K=e+L|0;a=w+(aa(K,s)|0)|0;a=(q|0)>(k[a>>2]|0);e=a?K:e;g=a?b:K;f=a?b-K|0:L;if((f|0)<=1){b=g;break}else b=g}C=k[z>>2]|0;K=y+(aa(C,e)|0)|0;K=k[K>>2]|0;a=w+(aa(e,s)|0)|0;a=k[a>>2]|0;C=y+(aa(C,b)|0)|0;q=aa((k[C>>2]|0)-K|0,q-a|0)|0;C=w+(aa(b,s)|0)|0;L=c+(aa(k[n>>2]|0,h)|0)|0;k[L>>2]=((q|0)/((k[C>>2]|0)-a|0)|0)+K+(k[L>>2]|0);h=h+1|0}while((h|0)!=(A|0))}f=D+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=D+16|0;e=D+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[D+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[D+44>>2]|0;if(!((b|0)==(D+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=F+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[F+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=F+16|0;e=F+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[F+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[F+44>>2]|0;if(!((b|0)==(F+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[E>>2]|0;e=b;if(b|0){f=k[B>>2]|0;if((f|0)!=(b|0))k[B>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(b)}break}case 5:{y=k[G+8>>2]|0;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=I;Xda(u,F);k[E>>2]=0;z=E+4|0;k[z>>2]=0;k[E+8>>2]=0;f=w+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[w>>2]=-2113732604;k[f>>2]=E;mY(u,w);f=u+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[u+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=u+16|0;e=u+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[u+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[u+44>>2]|0;if(!((b|0)==(u+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=I;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=-2130509820;k[D+4>>2]=E;Yda(F,w,D);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=H;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=-2130509820;k[v+4>>2]=E;Yda(D,w,v);g=k[G+40>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;h=k[G>>2]&4095;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=1124007936;b=x+16|0;e=x+48|0;n=x+12|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+56|0;k[x+52>>2]=b;k[x+60>>2]=0;k[b>>2]=0;k[x+64>>2]=1124007936;b=x+72|0;e=x+104|0;n=x+68|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+112|0;k[x+108>>2]=b;k[x+116>>2]=0;k[b>>2]=0;k[x+120>>2]=1124007936;b=x+128|0;e=x+160|0;n=x+124|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;n=x+168|0;k[x+164>>2]=n;q=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[w>>2]=f;k[w+4>>2]=g;j1(x,48,w,h);k[a>>2]=1124007936;b=a+8|0;e=a+40|0;n=a+4|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;L=a+48|0;b=a+44|0;k[b>>2]=L;k[a+52>>2]=0;k[L>>2]=0;L=k[x>>2]|0;dh[k[(k[L>>2]|0)+12>>2]&255](L,x,a,-1);XN(x);if((y|0)>0){s=(k[F+8>>2]|0)+-1|0;c=k[G+16>>2]|0;d=k[k[G+44>>2]>>2]|0;u=k[F+16>>2]|0;v=k[k[F+44>>2]>>2]|0;w=k[D+16>>2]|0;x=k[k[D+44>>2]>>2]|0;q=k[a+16>>2]|0;n=k[k[b>>2]>>2]|0;h=0;do{b=c+(aa(h,d)|0)|0;t=+o[b>>2];b=t<+o[u>>2]?1:s;e=u+(aa(b,v)|0)|0;e=t>+o[e>>2]?b+-1|0:0;f=b-e|0;if((f|0)>1)while(1){L=f>>1;K=e+L|0;a=u+(aa(K,v)|0)|0;a=t>+o[a>>2];e=a?K:e;g=a?b:K;f=a?b-K|0:L;if((f|0)<=1){b=g;break}else b=g}a=w+(aa(e,x)|0)|0;N=+o[a>>2];a=u+(aa(e,v)|0)|0;M=+o[a>>2];a=w+(aa(b,x)|0)|0;K=u+(aa(b,v)|0)|0;L=q+(aa(h,n)|0)|0;o[L>>2]=+o[L>>2]+(N+(t-M)*(+o[a>>2]-N)/(+o[K>>2]-M));h=h+1|0}while((h|0)!=(y|0))}f=D+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=D+16|0;e=D+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[D+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[D+44>>2]|0;if(!((b|0)==(D+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=F+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[F+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=F+16|0;e=F+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[F+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[F+44>>2]|0;if(!((b|0)==(F+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[E>>2]|0;e=b;if(b|0){f=k[z>>2]|0;if((f|0)!=(b|0))k[z>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(b)}break}case 6:{y=k[G+8>>2]|0;k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=I;Xda(u,F);k[E>>2]=0;z=E+4|0;k[z>>2]=0;k[E+8>>2]=0;f=w+4|0;b=f+4|0;k[b>>2]=0;k[b+4>>2]=0;k[w>>2]=-2113732604;k[f>>2]=E;mY(u,w);f=u+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[u+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=u+16|0;e=u+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[u+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[u+44>>2]|0;if(!((b|0)==(u+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=I;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=-2130509820;k[D+4>>2]=E;Yda(F,w,D);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=H;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=-2130509820;k[v+4>>2]=E;Yda(D,w,v);g=k[G+40>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;h=k[G>>2]&4095;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=1124007936;b=x+16|0;e=x+48|0;n=x+12|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+56|0;k[x+52>>2]=b;k[x+60>>2]=0;k[b>>2]=0;k[x+64>>2]=1124007936;b=x+72|0;e=x+104|0;n=x+68|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;b=x+112|0;k[x+108>>2]=b;k[x+116>>2]=0;k[b>>2]=0;k[x+120>>2]=1124007936;b=x+128|0;e=x+160|0;n=x+124|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;n=x+168|0;k[x+164>>2]=n;q=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[w>>2]=f;k[w+4>>2]=g;j1(x,48,w,h);k[a>>2]=1124007936;b=a+8|0;e=a+40|0;n=a+4|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;L=a+48|0;b=a+44|0;k[b>>2]=L;k[a+52>>2]=0;k[L>>2]=0;L=k[x>>2]|0;dh[k[(k[L>>2]|0)+12>>2]&255](L,x,a,-1);XN(x);if((y|0)>0){s=(k[F+8>>2]|0)+-1|0;c=k[G+16>>2]|0;d=k[k[G+44>>2]>>2]|0;u=k[F+16>>2]|0;v=k[k[F+44>>2]>>2]|0;w=k[D+16>>2]|0;x=k[k[D+44>>2]>>2]|0;q=k[a+16>>2]|0;n=k[k[b>>2]>>2]|0;h=0;do{b=c+(aa(h,d)|0)|0;t=+p[b>>3];b=t<+p[u>>3]?1:s;e=u+(aa(b,v)|0)|0;e=t>+p[e>>3]?b+-1|0:0;f=b-e|0;if((f|0)>1)while(1){L=f>>1;K=e+L|0;a=u+(aa(K,v)|0)|0;a=t>+p[a>>3];e=a?K:e;g=a?b:K;f=a?b-K|0:L;if((f|0)<=1){b=g;break}else b=g}a=w+(aa(e,x)|0)|0;M=+p[a>>3];a=u+(aa(e,v)|0)|0;N=+p[a>>3];a=w+(aa(b,x)|0)|0;K=u+(aa(b,v)|0)|0;L=q+(aa(h,n)|0)|0;p[L>>3]=+p[L>>3]+(M+(t-N)*(+p[a>>3]-M)/(+p[K>>3]-N));h=h+1|0}while((h|0)!=(y|0))}f=D+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[D+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=D+16|0;e=D+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[D+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[D+44>>2]|0;if(!((b|0)==(D+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=F+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[F+32>>2]|0;if(b|0)break;b=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=F+16|0;e=F+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[F+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[F+44>>2]|0;if(!((b|0)==(F+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[E>>2]|0;e=b;if(b|0){f=k[z>>2]|0;if((f|0)!=(b|0))k[z>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(b)}break}default:{k[w>>2]=0;L=w+4|0;k[L>>2]=0;b=ZT(8)|0;k[b>>2]=1;K=b+4|0;k[w>>2]=K;k[L>>2]=0;i[K>>0]=0;Y8(-210,w,242049,241929,129);k[L>>2]=0;k[w>>2]=0;L=k[b>>2]|0;k[b>>2]=L+-1;if((L|0)==1)ggb(k[b+-4>>2]|0);k[a>>2]=1124007936;b=a+8|0;e=a+40|0;n=a+4|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[e>>2]=b;L=a+48|0;k[a+44>>2]=L;k[a+52>>2]=0;k[L>>2]=0}}f=G+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[G+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=G+16|0;e=G+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[G+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[G+44>>2]|0;if(!((b|0)==(G+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=H+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[H+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=H+16|0;e=H+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[H+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[H+44>>2]|0;if(!((b|0)==(H+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=I+36|0;b=k[f>>2]|0;if(b|0?(K=b+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[I+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;L=I+16|0;e=I+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[e>>2]|0)>0){f=k[I+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[I+44>>2]|0;if((b|0)==(I+48|0)|(b|0)==0){r=J;return}ggb(k[b+-4>>2]|0);r=J;return}function Xda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+144|0;p=q+88|0;m=q+72|0;o=q+16|0;n=q;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[p>>2]=k[f>>2];l=p+4|0;c=f+4|0;k[l>>2]=k[c>>2];b=p+8|0;k[b>>2]=k[f+8>>2];k[p+12>>2]=k[f+12>>2];k[p+16>>2]=k[f+16>>2];k[p+20>>2]=k[f+20>>2];k[p+24>>2]=k[f+24>>2];k[p+28>>2]=k[f+28>>2];k[p+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[p+36>>2]=d;e=p+40|0;k[e>>2]=b;j=p+48|0;h=p+44|0;k[h>>2]=j;k[p+52>>2]=0;k[j>>2]=0;if(d|0){j=d+12|0;k[j>>2]=(k[j>>2]|0)+1}if((k[c>>2]|0)<3){j=k[f+44>>2]|0;l=k[h>>2]|0;k[l>>2]=k[j>>2];k[l+4>>2]=k[j+4>>2];break}k[l>>2]=0;x1(p,k[c>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;c=0;do{k[g+(c<<2)>>2]=k[j+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[l>>2]|0))}}else{Q1(p,b,-1);b=p+8|0}while(0);if((k[b>>2]|0)!=1?(k[p+12>>2]|0)!=1:0){k[m>>2]=0;b=m+4|0;k[b>>2]=0;c=ZT(40)|0;k[c>>2]=1;e=c+4|0;k[m>>2]=e;k[b>>2]=35;i[c+39>>0]=0;d=242192;f=e+35|0;do{i[e>>0]=i[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(f|0));Y8(-5,m,242228,241929,67);k[b>>2]=0;k[m>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)==1)ggb(k[c+-4>>2]|0)}k[a>>2]=1124007936;b=a+8|0;c=a+40|0;e=a+4|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[c>>2]=b;d=a+48|0;k[a+44>>2]=d;k[a+52>>2]=0;k[d>>2]=0;_1(o,p,1,1);k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=o;d=n+4|0;b=d+4|0;k[b>>2]=0;k[b+4>>2]=0;k[n>>2]=33619968;k[d>>2]=a;O3(m,n,0);d=o+36|0;b=k[d>>2]|0;if(b|0?(m=b+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[o+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;n=o+16|0;c=o+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[c>>2]|0)>0){d=k[o+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[o+44>>2]|0;if(!((b|0)==(o+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=p+36|0;b=k[d>>2]|0;if(b|0?(n=b+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[p+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;o=p+16|0;c=p+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[c>>2]|0)>0){d=k[p+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[p+44>>2]|0;if((b|0)==(p+48|0)|(b|0)==0){r=q;return}ggb(k[b+-4>>2]|0);r=q;return}function Yda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+400|0;D=I+376|0;E=I+368|0;n=I+312|0;H=I+256|0;F=I+240|0;q=I+184|0;G=I+128|0;B=I+72|0;C=I+16|0;p=I;k[a>>2]=1124007936;d=a+8|0;e=a+40|0;f=a+4|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;o=a+48|0;k[a+44>>2]=o;k[a+52>>2]=0;k[o>>2]=0;o=p+4|0;A=o+4|0;k[A>>2]=0;k[A+4>>2]=0;k[p>>2]=33619968;k[o>>2]=a;do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[n>>2]=k[f>>2];l=n+4|0;d=f+4|0;k[l>>2]=k[d>>2];A=n+8|0;k[A>>2]=k[f+8>>2];k[n+12>>2]=k[f+12>>2];k[n+16>>2]=k[f+16>>2];k[n+20>>2]=k[f+20>>2];k[n+24>>2]=k[f+24>>2];k[n+28>>2]=k[f+28>>2];k[n+32>>2]=k[f+32>>2];m=n+36|0;e=k[f+36>>2]|0;k[m>>2]=e;a=n+40|0;k[a>>2]=A;A=n+48|0;h=n+44|0;k[h>>2]=A;k[n+52>>2]=0;k[A>>2]=0;if(e|0){A=e+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[d>>2]|0)<3){f=k[f+44>>2]|0;d=k[h>>2]|0;k[d>>2]=k[f>>2];k[d+4>>2]=k[f+4>>2];d=n;f=m;break}k[l>>2]=0;x1(n,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[a>>2]|0;a=k[f+44>>2]|0;e=k[h>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[a+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0));d=n;f=m}else{d=n;f=m}}else{Q1(n,c,-1);d=n;f=n+36|0}while(0);g=(k[d>>2]&4095|0)==4;d=k[f>>2]|0;if(d|0?(z=d+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){a=n+36|0;e=k[a>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[n+32>>2]|0;if(!d){d=B1()|0;e=k[a>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[a>>2]=0}k[f>>2]=0;A=n+16|0;e=n+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[e>>2]|0)>0){a=k[n+40>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[n+44>>2]|0;if(!((d|0)==(n+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);if(!g){k[D>>2]=0;d=D+4|0;k[d>>2]=0;e=ZT(60)|0;k[e>>2]=1;f=e+4|0;k[D>>2]=f;k[d>>2]=52;i[e+56>>0]=0;a=242115;g=f+52|0;do{i[f>>0]=i[a>>0]|0;f=f+1|0;a=a+1|0}while((f|0)<(g|0));Y8(-210,D,242168,241929,43);k[d>>2]=0;k[D>>2]=0;A=k[e>>2]|0;k[e>>2]=A+-1;if((A|0)==1)ggb(k[e+-4>>2]|0)}do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[H>>2]=k[f>>2];l=H+4|0;d=f+4|0;k[l>>2]=k[d>>2];A=H+8|0;k[A>>2]=k[f+8>>2];k[H+12>>2]=k[f+12>>2];k[H+16>>2]=k[f+16>>2];k[H+20>>2]=k[f+20>>2];k[H+24>>2]=k[f+24>>2];k[H+28>>2]=k[f+28>>2];k[H+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[H+36>>2]=e;a=H+40|0;k[a>>2]=A;A=H+48|0;h=H+44|0;k[h>>2]=A;k[H+52>>2]=0;k[A>>2]=0;if(e|0){A=e+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[d>>2]|0)<3){z=k[f+44>>2]|0;A=k[h>>2]|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];break}k[l>>2]=0;x1(H,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[a>>2]|0;a=k[f+44>>2]|0;e=k[h>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[a+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else Q1(H,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[q>>2]=k[f>>2];l=q+4|0;d=f+4|0;k[l>>2]=k[d>>2];A=q+8|0;k[A>>2]=k[f+8>>2];k[q+12>>2]=k[f+12>>2];k[q+16>>2]=k[f+16>>2];k[q+20>>2]=k[f+20>>2];k[q+24>>2]=k[f+24>>2];k[q+28>>2]=k[f+28>>2];k[q+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[q+36>>2]=e;a=q+40|0;k[a>>2]=A;A=q+48|0;h=q+44|0;k[h>>2]=A;k[q+52>>2]=0;k[A>>2]=0;if(e|0){A=e+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[d>>2]|0)<3){z=k[f+44>>2]|0;A=k[h>>2]|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];break}k[l>>2]=0;x1(q,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[a>>2]|0;a=k[f+44>>2]|0;e=k[h>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[a+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else Q1(q,c,-1);while(0);k[F>>2]=0;A=F+4|0;k[A>>2]=0;k[F+8>>2]=0;a=D+4|0;d=a+4|0;k[d>>2]=0;k[d+4>>2]=0;k[D>>2]=-2113732604;k[a>>2]=F;mY(q,D);a=q+36|0;d=k[a>>2]|0;if(d|0?(y=d+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){e=k[a>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[q+32>>2]|0;if(!d){d=B1()|0;e=k[a>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[a>>2]=0}k[a>>2]=0;z=q+16|0;e=q+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[e>>2]|0)>0){a=k[q+40>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[q+44>>2]|0;if(!((d|0)==(q+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);c2(p,k[H+8>>2]|0,k[H+12>>2]|0,k[H>>2]&4095,-1,0,0);do if((k[p>>2]&2031616|0)==65536){f=k[o>>2]|0;k[G>>2]=k[f>>2];l=G+4|0;d=f+4|0;k[l>>2]=k[d>>2];z=G+8|0;k[z>>2]=k[f+8>>2];k[G+12>>2]=k[f+12>>2];k[G+16>>2]=k[f+16>>2];k[G+20>>2]=k[f+20>>2];k[G+24>>2]=k[f+24>>2];k[G+28>>2]=k[f+28>>2];k[G+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[G+36>>2]=e;a=G+40|0;k[a>>2]=z;z=G+48|0;h=G+44|0;k[h>>2]=z;k[G+52>>2]=0;k[z>>2]=0;if(e|0){z=e+12|0;k[z>>2]=(k[z>>2]|0)+1}if((k[d>>2]|0)<3){y=k[f+44>>2]|0;z=k[h>>2]|0;k[z>>2]=k[y>>2];k[z+4>>2]=k[y+4>>2];break}k[l>>2]=0;x1(G,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[a>>2]|0;a=k[f+44>>2]|0;e=k[h>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[a+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else Q1(G,p,-1);while(0);d=k[F>>2]|0;if((k[A>>2]|0)!=(d|0)){f=D+4|0;g=E+4|0;h=D+4|0;j=E+4|0;l=D+4|0;m=l+4|0;n=C+36|0;b=C+16|0;c=C+4|0;o=C+40|0;p=C+44|0;q=C+48|0;s=B+36|0;t=B+16|0;u=B+4|0;v=B+40|0;w=B+44|0;x=B+48|0;y=B+32|0;z=C+32|0;a=0;do{d=k[d+(a<<2)>>2]|0;k[D>>2]=d;k[f>>2]=d+1;k[E>>2]=-2147483648;k[g>>2]=2147483647;H1(B,H,D,E);k[D>>2]=a;a=a+1|0;k[h>>2]=a;k[E>>2]=-2147483648;k[j>>2]=2147483647;H1(C,G,D,E);d=m;k[d>>2]=0;k[d+4>>2]=0;k[D>>2]=33619968;k[l>>2]=C;mY(B,D);d=k[n>>2]|0;if(d|0?(d=d+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){e=k[n>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[z>>2]|0;if(d|0)break;d=B1()|0;e=k[n>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[n>>2]=0}k[n>>2]=0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[c>>2]|0)>0){e=k[o>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[c>>2]|0))}d=k[p>>2]|0;if(!((d|0)==(q|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[s>>2]|0;if(d|0?(d=d+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){e=k[s>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[y>>2]|0;if(d|0)break;d=B1()|0;e=k[s>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[s>>2]=0}k[s>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[u>>2]|0)>0){e=k[v>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[u>>2]|0))}d=k[w>>2]|0;if(!((d|0)==(x|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[F>>2]|0}while(a>>>0<(k[A>>2]|0)-d>>2>>>0)}a=G+36|0;d=k[a>>2]|0;if(d|0?(D=d+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){e=k[a>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[G+32>>2]|0;if(!d){d=B1()|0;e=k[a>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[a>>2]=0}k[a>>2]=0;E=G+16|0;e=G+4|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[e>>2]|0)>0){a=k[G+40>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[G+44>>2]|0;if(!((d|0)==(G+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[F>>2]|0;e=d;if(d|0){a=k[A>>2]|0;if((a|0)!=(d|0))k[A>>2]=a+(~((a+-4-e|0)>>>2)<<2);ggb(d)}a=H+36|0;d=k[a>>2]|0;if(d|0?(F=d+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){e=k[a>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[H+32>>2]|0;if(d|0)break;d=B1()|0;e=k[a>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[a>>2]=0}k[a>>2]=0;G=H+16|0;e=H+4|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[e>>2]|0)>0){a=k[H+40>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[H+44>>2]|0;if((d|0)==(H+48|0)|(d|0)==0){r=I;return}ggb(k[d+-4>>2]|0);r=I;return}function Zda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1296|0;m=$+1280|0;f=$+1024|0;g=$+768|0;h=$+512|0;V=$+456|0;q=$+400|0;n=$+328|0;p=$+312|0;O=$+256|0;R=$+344|0;j=$+184|0;D=$+128|0;J=$+200|0;l=$+112|0;s=$;y=$+56|0;upb(f|0,55008,256)|0;upb(g|0,54240,256)|0;zpb(h|0,0,256)|0;k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;e=Z;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[m>>2]=64;k[m+4>>2]=1;G1(V,2,m,5);W=V+16|0;d=k[W>>2]|0;e=k[k[Y>>2]>>2]|0;c=0;do{U=d+(aa(c,e)|0)|0;o[U>>2]=+(c|0)*.01587301678955555+0.0;c=c+1|0}while((c|0)!=64);d=a+4|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=V;S=R+4|0;k[S>>2]=2;U=R+8|0;k[U>>2]=64;k[R+12>>2]=1;P=R+16|0;k[P>>2]=f;k[R+20>>2]=f;M=R+24|0;Q=R+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[Q>>2]=U;U=R+48|0;T=R+44|0;k[T>>2]=U;k[R>>2]=1124024325;k[U>>2]=4;k[R+52>>2]=4;k[R+28>>2]=f+256;k[M>>2]=f+256;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;e=M;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;G=m+4|0;I=G+4|0;k[I>>2]=0;k[I+4>>2]=0;k[m>>2]=33619968;k[G>>2]=O;mY(R,m);k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=O;G=J+4|0;k[G>>2]=2;I=J+8|0;k[I>>2]=64;k[J+12>>2]=1;E=J+16|0;k[E>>2]=g;k[J+20>>2]=g;B=J+24|0;F=J+40|0;H=B+8|0;k[H>>2]=0;k[H+4>>2]=0;k[F>>2]=I;I=J+48|0;H=J+44|0;k[H>>2]=I;k[J>>2]=1124024325;k[I>>2]=4;k[J+52>>2]=4;k[J+28>>2]=g+256;k[B>>2]=g+256;k[D>>2]=1124007936;B=D+4|0;c=D+8|0;z=D+40|0;e=B;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[z>>2]=c;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;v=m+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[v>>2]=D;mY(J,m);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=64;k[y+12>>2]=1;t=y+16|0;k[t>>2]=h;k[y+20>>2]=h;c=y+24|0;u=y+40|0;w=c+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=h+256;k[c>>2]=h+256;k[s>>2]=1124007936;h=s+4|0;c=s+8|0;f=s+40|0;e=h;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[f>>2]=c;g=s+48|0;a=s+44|0;k[a>>2]=g;k[s+52>>2]=0;k[g>>2]=0;e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=s;mY(y,m);k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=s;kea(q,n,p,j,l,b);KG(d,q)|0;e=q+36|0;c=k[e>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=s+36|0;c=k[e>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){d=k[f>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[a>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=y+36|0;c=k[e>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){d=k[u>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=D+36|0;c=k[e>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(C|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=J+36|0;c=k[e>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[G>>2]|0)>0){d=k[F>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[G>>2]|0))}c=k[H>>2]|0;if(!((c|0)==(I|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=O+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){d=k[K>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=R+36|0;c=k[e>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[R+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[S>>2]|0)>0){d=k[Q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=V+36|0;c=k[e>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){d=k[X>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function _da(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1296|0;m=$+1280|0;f=$+1024|0;g=$+768|0;h=$+512|0;V=$+456|0;q=$+400|0;n=$+328|0;p=$+312|0;O=$+256|0;R=$+344|0;j=$+184|0;D=$+128|0;J=$+200|0;l=$+112|0;s=$;y=$+56|0;upb(f|0,62284,256)|0;upb(g|0,62540,256)|0;upb(h|0,62796,256)|0;k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;e=Z;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[m>>2]=64;k[m+4>>2]=1;G1(V,2,m,5);W=V+16|0;d=k[W>>2]|0;e=k[k[Y>>2]>>2]|0;c=0;do{U=d+(aa(c,e)|0)|0;o[U>>2]=+(c|0)*.01587301678955555+0.0;c=c+1|0}while((c|0)!=64);d=a+4|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=V;S=R+4|0;k[S>>2]=2;U=R+8|0;k[U>>2]=64;k[R+12>>2]=1;P=R+16|0;k[P>>2]=f;k[R+20>>2]=f;M=R+24|0;Q=R+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[Q>>2]=U;U=R+48|0;T=R+44|0;k[T>>2]=U;k[R>>2]=1124024325;k[U>>2]=4;k[R+52>>2]=4;k[R+28>>2]=f+256;k[M>>2]=f+256;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;e=M;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;G=m+4|0;I=G+4|0;k[I>>2]=0;k[I+4>>2]=0;k[m>>2]=33619968;k[G>>2]=O;mY(R,m);k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=O;G=J+4|0;k[G>>2]=2;I=J+8|0;k[I>>2]=64;k[J+12>>2]=1;E=J+16|0;k[E>>2]=g;k[J+20>>2]=g;B=J+24|0;F=J+40|0;H=B+8|0;k[H>>2]=0;k[H+4>>2]=0;k[F>>2]=I;I=J+48|0;H=J+44|0;k[H>>2]=I;k[J>>2]=1124024325;k[I>>2]=4;k[J+52>>2]=4;k[J+28>>2]=g+256;k[B>>2]=g+256;k[D>>2]=1124007936;B=D+4|0;c=D+8|0;z=D+40|0;e=B;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[z>>2]=c;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;v=m+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[v>>2]=D;mY(J,m);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=64;k[y+12>>2]=1;t=y+16|0;k[t>>2]=h;k[y+20>>2]=h;c=y+24|0;u=y+40|0;w=c+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=h+256;k[c>>2]=h+256;k[s>>2]=1124007936;h=s+4|0;c=s+8|0;f=s+40|0;e=h;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[f>>2]=c;g=s+48|0;a=s+44|0;k[a>>2]=g;k[s+52>>2]=0;k[g>>2]=0;e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=s;mY(y,m);k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=s;kea(q,n,p,j,l,b);KG(d,q)|0;e=q+36|0;c=k[e>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=s+36|0;c=k[e>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){d=k[f>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[a>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=y+36|0;c=k[e>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){d=k[u>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=D+36|0;c=k[e>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(C|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=J+36|0;c=k[e>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[G>>2]|0)>0){d=k[F>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[G>>2]|0))}c=k[H>>2]|0;if(!((c|0)==(I|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=O+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){d=k[K>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=R+36|0;c=k[e>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[R+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[S>>2]|0)>0){d=k[Q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=V+36|0;c=k[e>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){d=k[X>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function $da(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1296|0;m=$+1280|0;f=$+1024|0;g=$+768|0;h=$+512|0;V=$+456|0;q=$+400|0;n=$+328|0;p=$+312|0;O=$+256|0;R=$+344|0;j=$+184|0;D=$+128|0;J=$+200|0;l=$+112|0;s=$;y=$+56|0;upb(f|0,54240,256)|0;upb(g|0,55264,256)|0;upb(h|0,55008,256)|0;k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;e=Z;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[m>>2]=64;k[m+4>>2]=1;G1(V,2,m,5);W=V+16|0;d=k[W>>2]|0;e=k[k[Y>>2]>>2]|0;c=0;do{U=d+(aa(c,e)|0)|0;o[U>>2]=+(c|0)*.01587301678955555+0.0;c=c+1|0}while((c|0)!=64);d=a+4|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=V;S=R+4|0;k[S>>2]=2;U=R+8|0;k[U>>2]=64;k[R+12>>2]=1;P=R+16|0;k[P>>2]=f;k[R+20>>2]=f;M=R+24|0;Q=R+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[Q>>2]=U;U=R+48|0;T=R+44|0;k[T>>2]=U;k[R>>2]=1124024325;k[U>>2]=4;k[R+52>>2]=4;k[R+28>>2]=f+256;k[M>>2]=f+256;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;e=M;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;G=m+4|0;I=G+4|0;k[I>>2]=0;k[I+4>>2]=0;k[m>>2]=33619968;k[G>>2]=O;mY(R,m);k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=O;G=J+4|0;k[G>>2]=2;I=J+8|0;k[I>>2]=64;k[J+12>>2]=1;E=J+16|0;k[E>>2]=g;k[J+20>>2]=g;B=J+24|0;F=J+40|0;H=B+8|0;k[H>>2]=0;k[H+4>>2]=0;k[F>>2]=I;I=J+48|0;H=J+44|0;k[H>>2]=I;k[J>>2]=1124024325;k[I>>2]=4;k[J+52>>2]=4;k[J+28>>2]=g+256;k[B>>2]=g+256;k[D>>2]=1124007936;B=D+4|0;c=D+8|0;z=D+40|0;e=B;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[z>>2]=c;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;v=m+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[v>>2]=D;mY(J,m);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=64;k[y+12>>2]=1;t=y+16|0;k[t>>2]=h;k[y+20>>2]=h;c=y+24|0;u=y+40|0;w=c+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=h+256;k[c>>2]=h+256;k[s>>2]=1124007936;h=s+4|0;c=s+8|0;f=s+40|0;e=h;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[f>>2]=c;g=s+48|0;a=s+44|0;k[a>>2]=g;k[s+52>>2]=0;k[g>>2]=0;e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=s;mY(y,m);k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=s;kea(q,n,p,j,l,b);KG(d,q)|0;e=q+36|0;c=k[e>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=s+36|0;c=k[e>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){d=k[f>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[a>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=y+36|0;c=k[e>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){d=k[u>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=D+36|0;c=k[e>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(C|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=J+36|0;c=k[e>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[G>>2]|0)>0){d=k[F>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[G>>2]|0))}c=k[H>>2]|0;if(!((c|0)==(I|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=O+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){d=k[K>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=R+36|0;c=k[e>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[R+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[S>>2]|0)>0){d=k[Q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=V+36|0;c=k[e>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){d=k[X>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function aea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1296|0;m=$+1280|0;f=$+1024|0;g=$+768|0;h=$+512|0;V=$+456|0;q=$+400|0;n=$+328|0;p=$+312|0;O=$+256|0;R=$+344|0;j=$+184|0;D=$+128|0;J=$+200|0;l=$+112|0;s=$;y=$+56|0;upb(f|0,61516,256)|0;upb(g|0,61772,256)|0;upb(h|0,62028,256)|0;k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;e=Z;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[m>>2]=64;k[m+4>>2]=1;G1(V,2,m,5);W=V+16|0;d=k[W>>2]|0;e=k[k[Y>>2]>>2]|0;c=0;do{U=d+(aa(c,e)|0)|0;o[U>>2]=+(c|0)*.01587301678955555+0.0;c=c+1|0}while((c|0)!=64);d=a+4|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=V;S=R+4|0;k[S>>2]=2;U=R+8|0;k[U>>2]=64;k[R+12>>2]=1;P=R+16|0;k[P>>2]=f;k[R+20>>2]=f;M=R+24|0;Q=R+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[Q>>2]=U;U=R+48|0;T=R+44|0;k[T>>2]=U;k[R>>2]=1124024325;k[U>>2]=4;k[R+52>>2]=4;k[R+28>>2]=f+256;k[M>>2]=f+256;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;e=M;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;G=m+4|0;I=G+4|0;k[I>>2]=0;k[I+4>>2]=0;k[m>>2]=33619968;k[G>>2]=O;mY(R,m);k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=O;G=J+4|0;k[G>>2]=2;I=J+8|0;k[I>>2]=64;k[J+12>>2]=1;E=J+16|0;k[E>>2]=g;k[J+20>>2]=g;B=J+24|0;F=J+40|0;H=B+8|0;k[H>>2]=0;k[H+4>>2]=0;k[F>>2]=I;I=J+48|0;H=J+44|0;k[H>>2]=I;k[J>>2]=1124024325;k[I>>2]=4;k[J+52>>2]=4;k[J+28>>2]=g+256;k[B>>2]=g+256;k[D>>2]=1124007936;B=D+4|0;c=D+8|0;z=D+40|0;e=B;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[z>>2]=c;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;v=m+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[v>>2]=D;mY(J,m);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=64;k[y+12>>2]=1;t=y+16|0;k[t>>2]=h;k[y+20>>2]=h;c=y+24|0;u=y+40|0;w=c+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=h+256;k[c>>2]=h+256;k[s>>2]=1124007936;h=s+4|0;c=s+8|0;f=s+40|0;e=h;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[f>>2]=c;g=s+48|0;a=s+44|0;k[a>>2]=g;k[s+52>>2]=0;k[g>>2]=0;e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=s;mY(y,m);k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=s;kea(q,n,p,j,l,b);KG(d,q)|0;e=q+36|0;c=k[e>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=s+36|0;c=k[e>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){d=k[f>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[a>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=y+36|0;c=k[e>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){d=k[u>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=D+36|0;c=k[e>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(C|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=J+36|0;c=k[e>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[G>>2]|0)>0){d=k[F>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[G>>2]|0))}c=k[H>>2]|0;if(!((c|0)==(I|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=O+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){d=k[K>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=R+36|0;c=k[e>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[R+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[S>>2]|0)>0){d=k[Q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=V+36|0;c=k[e>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){d=k[X>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function bea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1296|0;m=$+1280|0;f=$+1024|0;g=$+768|0;h=$+512|0;V=$+456|0;q=$+400|0;n=$+328|0;p=$+312|0;O=$+256|0;R=$+344|0;j=$+184|0;D=$+128|0;J=$+200|0;l=$+112|0;s=$;y=$+56|0;upb(f|0,60748,256)|0;upb(g|0,61004,256)|0;upb(h|0,61260,256)|0;k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;e=Z;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[m>>2]=64;k[m+4>>2]=1;G1(V,2,m,5);W=V+16|0;d=k[W>>2]|0;e=k[k[Y>>2]>>2]|0;c=0;do{U=d+(aa(c,e)|0)|0;o[U>>2]=+(c|0)*.01587301678955555+0.0;c=c+1|0}while((c|0)!=64);d=a+4|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=V;S=R+4|0;k[S>>2]=2;U=R+8|0;k[U>>2]=64;k[R+12>>2]=1;P=R+16|0;k[P>>2]=f;k[R+20>>2]=f;M=R+24|0;Q=R+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[Q>>2]=U;U=R+48|0;T=R+44|0;k[T>>2]=U;k[R>>2]=1124024325;k[U>>2]=4;k[R+52>>2]=4;k[R+28>>2]=f+256;k[M>>2]=f+256;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;e=M;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;G=m+4|0;I=G+4|0;k[I>>2]=0;k[I+4>>2]=0;k[m>>2]=33619968;k[G>>2]=O;mY(R,m);k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=O;G=J+4|0;k[G>>2]=2;I=J+8|0;k[I>>2]=64;k[J+12>>2]=1;E=J+16|0;k[E>>2]=g;k[J+20>>2]=g;B=J+24|0;F=J+40|0;H=B+8|0;k[H>>2]=0;k[H+4>>2]=0;k[F>>2]=I;I=J+48|0;H=J+44|0;k[H>>2]=I;k[J>>2]=1124024325;k[I>>2]=4;k[J+52>>2]=4;k[J+28>>2]=g+256;k[B>>2]=g+256;k[D>>2]=1124007936;B=D+4|0;c=D+8|0;z=D+40|0;e=B;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[z>>2]=c;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;v=m+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[v>>2]=D;mY(J,m);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=64;k[y+12>>2]=1;t=y+16|0;k[t>>2]=h;k[y+20>>2]=h;c=y+24|0;u=y+40|0;w=c+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=h+256;k[c>>2]=h+256;k[s>>2]=1124007936;h=s+4|0;c=s+8|0;f=s+40|0;e=h;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[f>>2]=c;g=s+48|0;a=s+44|0;k[a>>2]=g;k[s+52>>2]=0;k[g>>2]=0;e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=s;mY(y,m);k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=s;kea(q,n,p,j,l,b);KG(d,q)|0;e=q+36|0;c=k[e>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=s+36|0;c=k[e>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){d=k[f>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[a>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=y+36|0;c=k[e>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){d=k[u>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=D+36|0;c=k[e>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(C|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=J+36|0;c=k[e>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[G>>2]|0)>0){d=k[F>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[G>>2]|0))}c=k[H>>2]|0;if(!((c|0)==(I|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=O+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){d=k[K>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=R+36|0;c=k[e>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[R+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[S>>2]|0)>0){d=k[Q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=V+36|0;c=k[e>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){d=k[X>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function cea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+3600|0;m=$+3584|0;V=$+3528|0;f=$+2504|0;g=$+1480|0;h=$+456|0;q=$+400|0;n=$+328|0;p=$+312|0;O=$+256|0;R=$+344|0;j=$+184|0;D=$+128|0;J=$+200|0;l=$+112|0;s=$;y=$+56|0;k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;e=Z;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[m>>2]=256;k[m+4>>2]=1;G1(V,2,m,5);W=V+16|0;d=k[W>>2]|0;e=k[k[Y>>2]>>2]|0;c=0;do{U=d+(aa(c,e)|0)|0;o[U>>2]=+(c|0)*.003921568859368563+0.0;c=c+1|0}while((c|0)!=256);upb(f|0,57676,1024)|0;upb(g|0,58700,1024)|0;upb(h|0,59724,1024)|0;d=a+4|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=V;S=R+4|0;k[S>>2]=2;U=R+8|0;k[U>>2]=256;k[R+12>>2]=1;P=R+16|0;k[P>>2]=f;k[R+20>>2]=f;M=R+24|0;Q=R+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[Q>>2]=U;U=R+48|0;T=R+44|0;k[T>>2]=U;k[R>>2]=1124024325;k[U>>2]=4;k[R+52>>2]=4;k[R+28>>2]=f+1024;k[M>>2]=f+1024;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;e=M;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;G=m+4|0;I=G+4|0;k[I>>2]=0;k[I+4>>2]=0;k[m>>2]=33619968;k[G>>2]=O;mY(R,m);k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=O;G=J+4|0;k[G>>2]=2;I=J+8|0;k[I>>2]=256;k[J+12>>2]=1;E=J+16|0;k[E>>2]=g;k[J+20>>2]=g;B=J+24|0;F=J+40|0;H=B+8|0;k[H>>2]=0;k[H+4>>2]=0;k[F>>2]=I;I=J+48|0;H=J+44|0;k[H>>2]=I;k[J>>2]=1124024325;k[I>>2]=4;k[J+52>>2]=4;k[J+28>>2]=g+1024;k[B>>2]=g+1024;k[D>>2]=1124007936;B=D+4|0;c=D+8|0;z=D+40|0;e=B;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[z>>2]=c;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;v=m+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[v>>2]=D;mY(J,m);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=256;k[y+12>>2]=1;t=y+16|0;k[t>>2]=h;k[y+20>>2]=h;c=y+24|0;u=y+40|0;w=c+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=h+1024;k[c>>2]=h+1024;k[s>>2]=1124007936;h=s+4|0;c=s+8|0;f=s+40|0;e=h;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[f>>2]=c;g=s+48|0;a=s+44|0;k[a>>2]=g;k[s+52>>2]=0;k[g>>2]=0;e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=s;mY(y,m);k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=s;kea(q,n,p,j,l,b);KG(d,q)|0;e=q+36|0;c=k[e>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=s+36|0;c=k[e>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){d=k[f>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[a>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=y+36|0;c=k[e>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){d=k[u>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=D+36|0;c=k[e>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(C|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=J+36|0;c=k[e>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[G>>2]|0)>0){d=k[F>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[G>>2]|0))}c=k[H>>2]|0;if(!((c|0)==(I|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=O+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){d=k[K>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=R+36|0;c=k[e>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[R+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[S>>2]|0)>0){d=k[Q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=V+36|0;c=k[e>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){d=k[X>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function dea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1296|0;m=$+1280|0;f=$+1024|0;g=$+768|0;h=$+512|0;V=$+456|0;q=$+400|0;n=$+328|0;p=$+312|0;O=$+256|0;R=$+344|0;j=$+184|0;D=$+128|0;J=$+200|0;l=$+112|0;s=$;y=$+56|0;upb(f|0,57164,256)|0;upb(g|0,57420,256)|0;upb(h|0,54240,256)|0;k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;e=Z;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[m>>2]=64;k[m+4>>2]=1;G1(V,2,m,5);W=V+16|0;d=k[W>>2]|0;e=k[k[Y>>2]>>2]|0;c=0;do{U=d+(aa(c,e)|0)|0;o[U>>2]=+(c|0)*.01587301678955555+0.0;c=c+1|0}while((c|0)!=64);d=a+4|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=V;S=R+4|0;k[S>>2]=2;U=R+8|0;k[U>>2]=64;k[R+12>>2]=1;P=R+16|0;k[P>>2]=f;k[R+20>>2]=f;M=R+24|0;Q=R+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[Q>>2]=U;U=R+48|0;T=R+44|0;k[T>>2]=U;k[R>>2]=1124024325;k[U>>2]=4;k[R+52>>2]=4;k[R+28>>2]=f+256;k[M>>2]=f+256;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;e=M;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;G=m+4|0;I=G+4|0;k[I>>2]=0;k[I+4>>2]=0;k[m>>2]=33619968;k[G>>2]=O;mY(R,m);k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=O;G=J+4|0;k[G>>2]=2;I=J+8|0;k[I>>2]=64;k[J+12>>2]=1;E=J+16|0;k[E>>2]=g;k[J+20>>2]=g;B=J+24|0;F=J+40|0;H=B+8|0;k[H>>2]=0;k[H+4>>2]=0;k[F>>2]=I;I=J+48|0;H=J+44|0;k[H>>2]=I;k[J>>2]=1124024325;k[I>>2]=4;k[J+52>>2]=4;k[J+28>>2]=g+256;k[B>>2]=g+256;k[D>>2]=1124007936;B=D+4|0;c=D+8|0;z=D+40|0;e=B;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[z>>2]=c;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;v=m+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[v>>2]=D;mY(J,m);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=64;k[y+12>>2]=1;t=y+16|0;k[t>>2]=h;k[y+20>>2]=h;c=y+24|0;u=y+40|0;w=c+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=h+256;k[c>>2]=h+256;k[s>>2]=1124007936;h=s+4|0;c=s+8|0;f=s+40|0;e=h;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[f>>2]=c;g=s+48|0;a=s+44|0;k[a>>2]=g;k[s+52>>2]=0;k[g>>2]=0;e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=s;mY(y,m);k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=s;kea(q,n,p,j,l,b);KG(d,q)|0;e=q+36|0;c=k[e>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=s+36|0;c=k[e>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){d=k[f>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[a>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=y+36|0;c=k[e>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){d=k[u>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=D+36|0;c=k[e>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(C|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=J+36|0;c=k[e>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[G>>2]|0)>0){d=k[F>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[G>>2]|0))}c=k[H>>2]|0;if(!((c|0)==(I|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=O+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){d=k[K>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=R+36|0;c=k[e>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[R+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[S>>2]|0)>0){d=k[Q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=V+36|0;c=k[e>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){d=k[X>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function eea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+640|0;l=$+624|0;d=$+584|0;e=$+548|0;f=$+512|0;V=$+456|0;p=$+400|0;m=$+328|0;n=$+312|0;O=$+256|0;P=$+344|0;i=$+184|0;D=$+128|0;G=$+200|0;j=$+112|0;s=$;y=$+56|0;g=d;c=57056;h=g+36|0;do{k[g>>2]=k[c>>2];g=g+4|0;c=c+4|0}while((g|0)<(h|0));g=e;c=57092;h=g+36|0;do{k[g>>2]=k[c>>2];g=g+4|0;c=c+4|0}while((g|0)<(h|0));g=f;c=57128;h=g+36|0;do{k[g>>2]=k[c>>2];g=g+4|0;c=c+4|0}while((g|0)<(h|0));k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;g=Z;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[l>>2]=9;k[l+4>>2]=1;G1(V,2,l,5);W=V+16|0;U=k[W>>2]|0;S=k[k[Y>>2]>>2]|0;o[U>>2]=0.0;o[U+S>>2]=.125;o[U+(S<<1)>>2]=.25;o[U+(S*3|0)>>2]=.375;o[U+(S<<2)>>2]=.5;o[U+(S*5|0)>>2]=.625;o[U+(S*6|0)>>2]=.75;o[U+(S*7|0)>>2]=.875;o[U+(S<<3)>>2]=1.0;a=a+4|0;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=V;S=P+4|0;k[S>>2]=2;U=P+8|0;k[U>>2]=9;k[P+12>>2]=1;Q=P+16|0;k[Q>>2]=d;k[P+20>>2]=d;M=P+24|0;R=P+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[R>>2]=U;U=P+48|0;T=P+44|0;k[T>>2]=U;k[P>>2]=1124024325;k[U>>2]=4;k[P+52>>2]=4;k[P+28>>2]=d+36;k[M>>2]=d+36;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;g=M;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;H=l+4|0;J=H+4|0;k[J>>2]=0;k[J+4>>2]=0;k[l>>2]=33619968;k[H>>2]=O;mY(P,l);k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=O;H=G+4|0;k[H>>2]=2;J=G+8|0;k[J>>2]=9;k[G+12>>2]=1;E=G+16|0;k[E>>2]=e;k[G+20>>2]=e;C=G+24|0;F=G+40|0;I=C+8|0;k[I>>2]=0;k[I+4>>2]=0;k[F>>2]=J;J=G+48|0;I=G+44|0;k[I>>2]=J;k[G>>2]=1124024325;k[J>>2]=4;k[G+52>>2]=4;k[G+28>>2]=e+36;k[C>>2]=e+36;k[D>>2]=1124007936;C=D+4|0;c=D+8|0;z=D+40|0;g=C;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[z>>2]=c;B=D+48|0;A=D+44|0;k[A>>2]=B;k[D+52>>2]=0;k[B>>2]=0;v=l+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[l>>2]=33619968;k[v>>2]=D;mY(G,l);k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=9;k[y+12>>2]=1;t=y+16|0;k[t>>2]=f;k[y+20>>2]=f;q=y+24|0;u=y+40|0;w=q+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=f+36;k[q>>2]=f+36;k[s>>2]=1124007936;q=s+4|0;c=s+8|0;f=s+40|0;g=q;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[f>>2]=c;g=s+48|0;e=s+44|0;k[e>>2]=g;k[s+52>>2]=0;k[g>>2]=0;d=l+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[l>>2]=33619968;k[d>>2]=s;mY(y,l);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=s;kea(p,m,n,i,j,b);KG(a,p)|0;d=p+36|0;c=k[d>>2]|0;if(c|0?(m=c+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[p+32>>2]|0;if(!c){c=B1()|0;a=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;n=p+16|0;a=p+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[a>>2]|0)>0){d=k[p+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[a>>2]|0))}c=k[p+44>>2]|0;if(!((c|0)==(p+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=s+36|0;c=k[d>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;a=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[q>>2]|0)>0){a=k[f>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[q>>2]|0))}c=k[e>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=y+36|0;c=k[d>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;a=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){a=k[u>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=D+36|0;c=k[d>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;a=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[C>>2]|0)>0){a=k[z>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[C>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(B|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=G+36|0;c=k[d>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[G+32>>2]|0;if(!c){c=B1()|0;a=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[H>>2]|0)>0){a=k[F>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[H>>2]|0))}c=k[I>>2]|0;if(!((c|0)==(J|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=O+36|0;c=k[d>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;a=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){a=k[K>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=P+36|0;c=k[d>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;do if(!c){c=k[P+32>>2]|0;if(c|0)break;c=B1()|0;a=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}while(0);k[d>>2]=0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[S>>2]|0)>0){a=k[R>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=V+36|0;c=k[d>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;a=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}while(0);k[d>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){a=k[X>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function fea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1296|0;m=$+1280|0;f=$+1024|0;g=$+768|0;h=$+512|0;V=$+456|0;q=$+400|0;n=$+328|0;p=$+312|0;O=$+256|0;R=$+344|0;j=$+184|0;D=$+128|0;J=$+200|0;l=$+112|0;s=$;y=$+56|0;upb(f|0,56288,256)|0;upb(g|0,56544,256)|0;upb(h|0,56800,256)|0;k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;e=Z;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[m>>2]=64;k[m+4>>2]=1;G1(V,2,m,5);W=V+16|0;d=k[W>>2]|0;e=k[k[Y>>2]>>2]|0;c=0;do{U=d+(aa(c,e)|0)|0;o[U>>2]=+(c|0)*.01587301678955555+0.0;c=c+1|0}while((c|0)!=64);d=a+4|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=V;S=R+4|0;k[S>>2]=2;U=R+8|0;k[U>>2]=64;k[R+12>>2]=1;P=R+16|0;k[P>>2]=f;k[R+20>>2]=f;M=R+24|0;Q=R+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[Q>>2]=U;U=R+48|0;T=R+44|0;k[T>>2]=U;k[R>>2]=1124024325;k[U>>2]=4;k[R+52>>2]=4;k[R+28>>2]=f+256;k[M>>2]=f+256;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;e=M;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;G=m+4|0;I=G+4|0;k[I>>2]=0;k[I+4>>2]=0;k[m>>2]=33619968;k[G>>2]=O;mY(R,m);k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=O;G=J+4|0;k[G>>2]=2;I=J+8|0;k[I>>2]=64;k[J+12>>2]=1;E=J+16|0;k[E>>2]=g;k[J+20>>2]=g;B=J+24|0;F=J+40|0;H=B+8|0;k[H>>2]=0;k[H+4>>2]=0;k[F>>2]=I;I=J+48|0;H=J+44|0;k[H>>2]=I;k[J>>2]=1124024325;k[I>>2]=4;k[J+52>>2]=4;k[J+28>>2]=g+256;k[B>>2]=g+256;k[D>>2]=1124007936;B=D+4|0;c=D+8|0;z=D+40|0;e=B;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[z>>2]=c;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;v=m+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[v>>2]=D;mY(J,m);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=64;k[y+12>>2]=1;t=y+16|0;k[t>>2]=h;k[y+20>>2]=h;c=y+24|0;u=y+40|0;w=c+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=h+256;k[c>>2]=h+256;k[s>>2]=1124007936;h=s+4|0;c=s+8|0;f=s+40|0;e=h;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[f>>2]=c;g=s+48|0;a=s+44|0;k[a>>2]=g;k[s+52>>2]=0;k[g>>2]=0;e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=s;mY(y,m);k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=s;kea(q,n,p,j,l,b);KG(d,q)|0;e=q+36|0;c=k[e>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=s+36|0;c=k[e>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){d=k[f>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[a>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=y+36|0;c=k[e>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){d=k[u>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=D+36|0;c=k[e>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(C|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=J+36|0;c=k[e>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[G>>2]|0)>0){d=k[F>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[G>>2]|0))}c=k[H>>2]|0;if(!((c|0)==(I|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=O+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){d=k[K>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=R+36|0;c=k[e>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[R+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[S>>2]|0)>0){d=k[Q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=V+36|0;c=k[e>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){d=k[X>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function gea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1296|0;m=$+1280|0;f=$+1024|0;g=$+768|0;h=$+512|0;V=$+456|0;q=$+400|0;n=$+328|0;p=$+312|0;O=$+256|0;R=$+344|0;j=$+184|0;D=$+128|0;J=$+200|0;l=$+112|0;s=$;y=$+56|0;upb(f|0,55520,256)|0;upb(g|0,55776,256)|0;upb(h|0,56032,256)|0;k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;e=Z;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[m>>2]=64;k[m+4>>2]=1;G1(V,2,m,5);W=V+16|0;d=k[W>>2]|0;e=k[k[Y>>2]>>2]|0;c=0;do{U=d+(aa(c,e)|0)|0;o[U>>2]=+(c|0)*.01587301678955555+0.0;c=c+1|0}while((c|0)!=64);d=a+4|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=V;S=R+4|0;k[S>>2]=2;U=R+8|0;k[U>>2]=64;k[R+12>>2]=1;P=R+16|0;k[P>>2]=f;k[R+20>>2]=f;M=R+24|0;Q=R+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[Q>>2]=U;U=R+48|0;T=R+44|0;k[T>>2]=U;k[R>>2]=1124024325;k[U>>2]=4;k[R+52>>2]=4;k[R+28>>2]=f+256;k[M>>2]=f+256;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;e=M;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;G=m+4|0;I=G+4|0;k[I>>2]=0;k[I+4>>2]=0;k[m>>2]=33619968;k[G>>2]=O;mY(R,m);k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=O;G=J+4|0;k[G>>2]=2;I=J+8|0;k[I>>2]=64;k[J+12>>2]=1;E=J+16|0;k[E>>2]=g;k[J+20>>2]=g;B=J+24|0;F=J+40|0;H=B+8|0;k[H>>2]=0;k[H+4>>2]=0;k[F>>2]=I;I=J+48|0;H=J+44|0;k[H>>2]=I;k[J>>2]=1124024325;k[I>>2]=4;k[J+52>>2]=4;k[J+28>>2]=g+256;k[B>>2]=g+256;k[D>>2]=1124007936;B=D+4|0;c=D+8|0;z=D+40|0;e=B;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[z>>2]=c;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;v=m+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[v>>2]=D;mY(J,m);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=64;k[y+12>>2]=1;t=y+16|0;k[t>>2]=h;k[y+20>>2]=h;c=y+24|0;u=y+40|0;w=c+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=h+256;k[c>>2]=h+256;k[s>>2]=1124007936;h=s+4|0;c=s+8|0;f=s+40|0;e=h;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[f>>2]=c;g=s+48|0;a=s+44|0;k[a>>2]=g;k[s+52>>2]=0;k[g>>2]=0;e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=s;mY(y,m);k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=s;kea(q,n,p,j,l,b);KG(d,q)|0;e=q+36|0;c=k[e>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=s+36|0;c=k[e>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){d=k[f>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[a>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=y+36|0;c=k[e>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){d=k[u>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=D+36|0;c=k[e>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(C|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=J+36|0;c=k[e>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[G>>2]|0)>0){d=k[F>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[G>>2]|0))}c=k[H>>2]|0;if(!((c|0)==(I|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=O+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){d=k[K>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=R+36|0;c=k[e>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[R+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[S>>2]|0)>0){d=k[Q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=V+36|0;c=k[e>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){d=k[X>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function hea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1296|0;m=$+1280|0;f=$+1024|0;g=$+768|0;h=$+512|0;V=$+456|0;q=$+400|0;n=$+328|0;p=$+312|0;O=$+256|0;R=$+344|0;j=$+184|0;D=$+128|0;J=$+200|0;l=$+112|0;s=$;y=$+56|0;upb(f|0,55008,256)|0;upb(g|0,54240,256)|0;upb(h|0,55264,256)|0;k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;e=Z;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[m>>2]=64;k[m+4>>2]=1;G1(V,2,m,5);W=V+16|0;d=k[W>>2]|0;e=k[k[Y>>2]>>2]|0;c=0;do{U=d+(aa(c,e)|0)|0;o[U>>2]=+(c|0)*.01587301678955555+0.0;c=c+1|0}while((c|0)!=64);d=a+4|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=V;S=R+4|0;k[S>>2]=2;U=R+8|0;k[U>>2]=64;k[R+12>>2]=1;P=R+16|0;k[P>>2]=f;k[R+20>>2]=f;M=R+24|0;Q=R+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[Q>>2]=U;U=R+48|0;T=R+44|0;k[T>>2]=U;k[R>>2]=1124024325;k[U>>2]=4;k[R+52>>2]=4;k[R+28>>2]=f+256;k[M>>2]=f+256;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;e=M;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;G=m+4|0;I=G+4|0;k[I>>2]=0;k[I+4>>2]=0;k[m>>2]=33619968;k[G>>2]=O;mY(R,m);k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=O;G=J+4|0;k[G>>2]=2;I=J+8|0;k[I>>2]=64;k[J+12>>2]=1;E=J+16|0;k[E>>2]=g;k[J+20>>2]=g;B=J+24|0;F=J+40|0;H=B+8|0;k[H>>2]=0;k[H+4>>2]=0;k[F>>2]=I;I=J+48|0;H=J+44|0;k[H>>2]=I;k[J>>2]=1124024325;k[I>>2]=4;k[J+52>>2]=4;k[J+28>>2]=g+256;k[B>>2]=g+256;k[D>>2]=1124007936;B=D+4|0;c=D+8|0;z=D+40|0;e=B;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[z>>2]=c;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;v=m+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[v>>2]=D;mY(J,m);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=64;k[y+12>>2]=1;t=y+16|0;k[t>>2]=h;k[y+20>>2]=h;c=y+24|0;u=y+40|0;w=c+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=h+256;k[c>>2]=h+256;k[s>>2]=1124007936;h=s+4|0;c=s+8|0;f=s+40|0;e=h;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[f>>2]=c;g=s+48|0;a=s+44|0;k[a>>2]=g;k[s+52>>2]=0;k[g>>2]=0;e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=s;mY(y,m);k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=s;kea(q,n,p,j,l,b);KG(d,q)|0;e=q+36|0;c=k[e>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=s+36|0;c=k[e>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){d=k[f>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[a>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=y+36|0;c=k[e>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){d=k[u>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=D+36|0;c=k[e>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(C|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=J+36|0;c=k[e>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[G>>2]|0)>0){d=k[F>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[G>>2]|0))}c=k[H>>2]|0;if(!((c|0)==(I|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=O+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){d=k[K>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=R+36|0;c=k[e>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[R+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[S>>2]|0)>0){d=k[Q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=V+36|0;c=k[e>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){d=k[X>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function iea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+1296|0;m=$+1280|0;f=$+1024|0;g=$+768|0;h=$+512|0;V=$+456|0;q=$+400|0;n=$+328|0;p=$+312|0;O=$+256|0;R=$+344|0;j=$+184|0;D=$+128|0;J=$+200|0;l=$+112|0;s=$;y=$+56|0;upb(f|0,54240,256)|0;upb(g|0,54496,256)|0;upb(h|0,54752,256)|0;k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;e=Z;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[m>>2]=64;k[m+4>>2]=1;G1(V,2,m,5);W=V+16|0;d=k[W>>2]|0;e=k[k[Y>>2]>>2]|0;c=0;do{U=d+(aa(c,e)|0)|0;o[U>>2]=+(c|0)*.01587301678955555+0.0;c=c+1|0}while((c|0)!=64);d=a+4|0;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=V;S=R+4|0;k[S>>2]=2;U=R+8|0;k[U>>2]=64;k[R+12>>2]=1;P=R+16|0;k[P>>2]=f;k[R+20>>2]=f;M=R+24|0;Q=R+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[Q>>2]=U;U=R+48|0;T=R+44|0;k[T>>2]=U;k[R>>2]=1124024325;k[U>>2]=4;k[R+52>>2]=4;k[R+28>>2]=f+256;k[M>>2]=f+256;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;e=M;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;G=m+4|0;I=G+4|0;k[I>>2]=0;k[I+4>>2]=0;k[m>>2]=33619968;k[G>>2]=O;mY(R,m);k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=O;G=J+4|0;k[G>>2]=2;I=J+8|0;k[I>>2]=64;k[J+12>>2]=1;E=J+16|0;k[E>>2]=g;k[J+20>>2]=g;B=J+24|0;F=J+40|0;H=B+8|0;k[H>>2]=0;k[H+4>>2]=0;k[F>>2]=I;I=J+48|0;H=J+44|0;k[H>>2]=I;k[J>>2]=1124024325;k[I>>2]=4;k[J+52>>2]=4;k[J+28>>2]=g+256;k[B>>2]=g+256;k[D>>2]=1124007936;B=D+4|0;c=D+8|0;z=D+40|0;e=B;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[z>>2]=c;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;v=m+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[m>>2]=33619968;k[v>>2]=D;mY(J,m);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=64;k[y+12>>2]=1;t=y+16|0;k[t>>2]=h;k[y+20>>2]=h;c=y+24|0;u=y+40|0;w=c+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=h+256;k[c>>2]=h+256;k[s>>2]=1124007936;h=s+4|0;c=s+8|0;f=s+40|0;e=h;i=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(i|0));k[f>>2]=c;g=s+48|0;a=s+44|0;k[a>>2]=g;k[s+52>>2]=0;k[g>>2]=0;e=m+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[e>>2]=s;mY(y,m);k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=s;kea(q,n,p,j,l,b);KG(d,q)|0;e=q+36|0;c=k[e>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;p=q+16|0;d=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[d>>2]|0)>0){e=k[q+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=s+36|0;c=k[e>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){d=k[f>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[a>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=y+36|0;c=k[e>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){d=k[u>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=D+36|0;c=k[e>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(C|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=J+36|0;c=k[e>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[G>>2]|0)>0){d=k[F>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[G>>2]|0))}c=k[H>>2]|0;if(!((c|0)==(I|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=O+36|0;c=k[e>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){d=k[K>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=R+36|0;c=k[e>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[R+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[S>>2]|0)>0){d=k[Q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=V+36|0;c=k[e>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}while(0);k[e>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){d=k[X>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function jea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+672|0;l=$+648|0;d=$+600|0;e=$+556|0;f=$+512|0;V=$+456|0;p=$+400|0;m=$+328|0;n=$+312|0;O=$+256|0;P=$+344|0;i=$+184|0;D=$+128|0;G=$+200|0;j=$+112|0;s=$;y=$+56|0;g=d;h=g+44|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=e;c=54152;h=g+44|0;do{k[g>>2]=k[c>>2];g=g+4|0;c=c+4|0}while((g|0)<(h|0));g=f;c=54196;h=g+44|0;do{k[g>>2]=k[c>>2];g=g+4|0;c=c+4|0}while((g|0)<(h|0));k[V>>2]=1124007936;Z=V+4|0;c=V+8|0;X=V+40|0;g=Z;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[X>>2]=c;_=V+48|0;Y=V+44|0;k[Y>>2]=_;k[V+52>>2]=0;k[_>>2]=0;k[l>>2]=11;k[l+4>>2]=1;G1(V,2,l,5);W=V+16|0;U=k[W>>2]|0;S=k[k[Y>>2]>>2]|0;o[U>>2]=0.0;o[U+S>>2]=.10000000149011612;o[U+(S<<1)>>2]=.20000000298023224;o[U+(S*3|0)>>2]=.30000001192092896;o[U+(S<<2)>>2]=.4000000059604645;o[U+(S*5|0)>>2]=.5;o[U+(S*6|0)>>2]=.6000000238418579;o[U+(S*7|0)>>2]=.699999988079071;o[U+(S<<3)>>2]=.800000011920929;o[U+(S*9|0)>>2]=.9000000357627869;o[U+(S*10|0)>>2]=1.0;a=a+4|0;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=V;S=P+4|0;k[S>>2]=2;U=P+8|0;k[U>>2]=11;k[P+12>>2]=1;Q=P+16|0;k[Q>>2]=d;k[P+20>>2]=d;M=P+24|0;R=P+40|0;T=M+8|0;k[T>>2]=0;k[T+4>>2]=0;k[R>>2]=U;U=P+48|0;T=P+44|0;k[T>>2]=U;k[P>>2]=1124024325;k[U>>2]=4;k[P+52>>2]=4;k[P+28>>2]=d+44;k[M>>2]=d+44;k[O>>2]=1124007936;M=O+4|0;c=O+8|0;K=O+40|0;g=M;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[K>>2]=c;N=O+48|0;L=O+44|0;k[L>>2]=N;k[O+52>>2]=0;k[N>>2]=0;H=l+4|0;J=H+4|0;k[J>>2]=0;k[J+4>>2]=0;k[l>>2]=33619968;k[H>>2]=O;mY(P,l);k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=O;H=G+4|0;k[H>>2]=2;J=G+8|0;k[J>>2]=11;k[G+12>>2]=1;E=G+16|0;k[E>>2]=e;k[G+20>>2]=e;B=G+24|0;F=G+40|0;I=B+8|0;k[I>>2]=0;k[I+4>>2]=0;k[F>>2]=J;J=G+48|0;I=G+44|0;k[I>>2]=J;k[G>>2]=1124024325;k[J>>2]=4;k[G+52>>2]=4;k[G+28>>2]=e+44;k[B>>2]=e+44;k[D>>2]=1124007936;B=D+4|0;c=D+8|0;z=D+40|0;g=B;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[z>>2]=c;C=D+48|0;A=D+44|0;k[A>>2]=C;k[D+52>>2]=0;k[C>>2]=0;v=l+4|0;x=v+4|0;k[x>>2]=0;k[x+4>>2]=0;k[l>>2]=33619968;k[v>>2]=D;mY(G,l);k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=D;v=y+4|0;k[v>>2]=2;x=y+8|0;k[x>>2]=11;k[y+12>>2]=1;t=y+16|0;k[t>>2]=f;k[y+20>>2]=f;q=y+24|0;u=y+40|0;w=q+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=y+48|0;w=y+44|0;k[w>>2]=x;k[y>>2]=1124024325;k[x>>2]=4;k[y+52>>2]=4;k[y+28>>2]=f+44;k[q>>2]=f+44;k[s>>2]=1124007936;q=s+4|0;c=s+8|0;f=s+40|0;g=q;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[f>>2]=c;g=s+48|0;e=s+44|0;k[e>>2]=g;k[s+52>>2]=0;k[g>>2]=0;d=l+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[l>>2]=33619968;k[d>>2]=s;mY(y,l);k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=s;kea(p,m,n,i,j,b);KG(a,p)|0;d=p+36|0;c=k[d>>2]|0;if(c|0?(m=c+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[p+32>>2]|0;if(!c){c=B1()|0;a=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;n=p+16|0;a=p+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[a>>2]|0)>0){d=k[p+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[a>>2]|0))}c=k[p+44>>2]|0;if(!((c|0)==(p+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=s+36|0;c=k[d>>2]|0;if(c|0?(n=c+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[s+32>>2]|0;if(!c){c=B1()|0;a=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[q>>2]|0)>0){a=k[f>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[q>>2]|0))}c=k[e>>2]|0;if(!((c|0)==(g|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=y+36|0;c=k[d>>2]|0;if(c|0?(q=c+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;a=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){a=k[u>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[w>>2]|0;if(!((c|0)==(x|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=D+36|0;c=k[d>>2]|0;if(c|0?(x=c+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[D+32>>2]|0;if(!c){c=B1()|0;a=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[B>>2]|0)>0){a=k[z>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[B>>2]|0))}c=k[A>>2]|0;if(!((c|0)==(C|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=G+36|0;c=k[d>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;if(!c){c=k[G+32>>2]|0;if(!c){c=B1()|0;a=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[H>>2]|0)>0){a=k[F>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[H>>2]|0))}c=k[I>>2]|0;if(!((c|0)==(J|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=O+36|0;c=k[d>>2]|0;if(c|0?(I=c+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;do if(!c){c=k[O+32>>2]|0;if(c|0)break;c=B1()|0;a=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}k[d>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[M>>2]|0)>0){a=k[K>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[M>>2]|0))}c=k[L>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=P+36|0;c=k[d>>2]|0;do if(c|0){N=c+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;do if(!c){c=k[P+32>>2]|0;if(c|0)break;c=B1()|0;a=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}while(0);k[d>>2]=0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[S>>2]|0)>0){a=k[R>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[S>>2]|0))}c=k[T>>2]|0;if(!((c|0)==(U|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=V+36|0;c=k[d>>2]|0;do if(c|0){T=c+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;a=k[d>>2]|0;if(a|0){c=k[a+4>>2]|0;do if(!c){c=k[V+32>>2]|0;if(c|0)break;c=B1()|0;a=k[d>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,a)}k[d>>2]=0}while(0);k[d>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Z>>2]|0)>0){a=k[X>>2]|0;c=0;do{k[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Z>>2]|0))}c=k[Y>>2]|0;if((c|0)==(_|0)|(c|0)==0){r=$;return}ggb(k[c+-4>>2]|0);r=$;return}function kea(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+320|0;u=A+256|0;p=A+88|0;m=A+72|0;n=A+56|0;v=A;k[v>>2]=1124007936;y=v+4|0;g=v+8|0;w=v+40|0;i=y;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[w>>2]=g;z=v+48|0;x=v+44|0;k[x>>2]=z;k[v+52>>2]=0;k[z>>2]=0;k[u>>2]=f;k[u+4>>2]=1;G1(v,2,u,5);j=1.0/+(f+-1|0);if((f|0)>0){h=k[v+16>>2]|0;i=k[k[x>>2]>>2]|0;g=0;do{t=h+(aa(g,i)|0)|0;o[t>>2]=j*+(g|0)+0.0;g=g+1|0}while((g|0)!=(f|0))}k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=v;k[u>>2]=1124007936;s=u+4|0;g=u+8|0;f=u+40|0;i=s;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[f>>2]=g;t=u+48|0;q=u+44|0;k[q>>2]=t;k[u+52>>2]=0;k[t>>2]=0;k[a>>2]=1124007936;g=a+8|0;h=a+40|0;i=a+4|0;l=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(l|0));k[h>>2]=g;i=a+48|0;k[a+44>>2]=i;k[a+52>>2]=0;k[i>>2]=0;Wda(p,b,e,n);Wda(p+56|0,b,d,n);Wda(p+112|0,b,c,n);i=m+4|0;g=i+4|0;k[g>>2]=0;k[g+4>>2]=0;k[m>>2]=33619968;k[i>>2]=u;GV(p,3,m);i=m+4|0;g=i+4|0;k[g>>2]=0;k[g+4>>2]=0;k[m>>2]=33619968;k[i>>2]=a;SW(u,m,0,255.0,0.0);i=p+148|0;g=k[i>>2]|0;if(g|0?(m=g+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){h=k[i>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[p+144>>2]|0;if(!g){g=B1()|0;h=k[i>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[i>>2]=0}k[i>>2]=0;n=p+128|0;h=p+116|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[h>>2]|0)>0){i=k[p+152>>2]|0;g=0;do{k[i+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[p+156>>2]|0;if(!((g|0)==(p+160|0)|(g|0)==0))ggb(k[g+-4>>2]|0);i=p+92|0;g=k[i>>2]|0;if(g|0?(m=g+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){h=k[i>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[p+88>>2]|0;if(!g){g=B1()|0;h=k[i>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[i>>2]=0}k[i>>2]=0;n=p+72|0;h=p+60|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[h>>2]|0)>0){i=k[p+96>>2]|0;g=0;do{k[i+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[p+100>>2]|0;if(!((g|0)==(p+104|0)|(g|0)==0))ggb(k[g+-4>>2]|0);i=p+36|0;g=k[i>>2]|0;if(g|0?(m=g+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){h=k[i>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[p+32>>2]|0;if(!g){g=B1()|0;h=k[i>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[i>>2]=0}k[i>>2]=0;n=p+16|0;h=p+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[h>>2]|0)>0){i=k[p+40>>2]|0;g=0;do{k[i+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[p+44>>2]|0;if(!((g|0)==(p+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);i=u+36|0;g=k[i>>2]|0;if(g|0?(n=g+12|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0){h=k[i>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[u+32>>2]|0;if(!g){g=B1()|0;h=k[i>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[i>>2]=0}k[i>>2]=0;u=u+16|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[s>>2]|0)>0){h=k[f>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[s>>2]|0))}g=k[q>>2]|0;if(!((g|0)==(t|0)|(g|0)==0))ggb(k[g+-4>>2]|0);i=v+36|0;g=k[i>>2]|0;if(g|0?(t=g+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){h=k[i>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[v+32>>2]|0;if(g|0)break;g=B1()|0;h=k[i>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[i>>2]=0}k[i>>2]=0;v=v+16|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[y>>2]|0)>0){h=k[w>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[y>>2]|0))}g=k[x>>2]|0;if((g|0)==(z|0)|(g|0)==0){r=A;return}ggb(k[g+-4>>2]|0);r=A;return}function lea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function mea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function nea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function oea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function pea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function qea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function rea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function sea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function tea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function uea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function vea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function wea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function xea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function yea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function zea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=53900;d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Aea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+128|0;s=t+72|0;n=t+8|0;q=t+16|0;o=t;do if((k[a>>2]&2031616|0)==65536){f=k[a+4>>2]|0;k[s>>2]=k[f>>2];l=s+4|0;a=f+4|0;k[l>>2]=k[a>>2];p=s+8|0;k[p>>2]=k[f+8>>2];k[s+12>>2]=k[f+12>>2];k[s+16>>2]=k[f+16>>2];k[s+20>>2]=k[f+20>>2];k[s+24>>2]=k[f+24>>2];k[s+28>>2]=k[f+28>>2];k[s+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[s+36>>2]=e;m=s+40|0;k[m>>2]=p;p=s+48|0;g=s+44|0;k[g>>2]=p;k[s+52>>2]=0;k[p>>2]=0;if(e|0){p=e+12|0;k[p>>2]=(k[p>>2]|0)+1}if((k[a>>2]|0)<3){l=k[f+44>>2]|0;p=k[g>>2]|0;k[p>>2]=k[l>>2];k[p+4>>2]=k[l+4>>2];p=m;break}k[l>>2]=0;x1(s,k[a>>2]|0,0,0,0);if((k[l>>2]|0)>0){h=k[f+40>>2]|0;j=k[m>>2]|0;f=k[f+44>>2]|0;e=k[g>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[h+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[l>>2]|0));p=m}else p=m}else{Q1(s,a,-1);p=s+40|0}while(0);l=k[p>>2]|0;m=k[l>>2]|0;k[n>>2]=k[l+4>>2];k[n+4>>2]=m;x2(b,n,d&7,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[q>>2]=k[h>>2];m=q+4|0;e=h+4|0;k[m>>2]=k[e>>2];n=q+8|0;k[n>>2]=k[h+8>>2];k[q+12>>2]=k[h+12>>2];k[q+16>>2]=k[h+16>>2];k[q+20>>2]=k[h+20>>2];k[q+24>>2]=k[h+24>>2];k[q+28>>2]=k[h+28>>2];k[q+32>>2]=k[h+32>>2];a=k[h+36>>2]|0;k[q+36>>2]=a;f=q+40|0;k[f>>2]=n;n=q+48|0;j=q+44|0;k[j>>2]=n;k[q+52>>2]=0;k[n>>2]=0;if(a|0){n=a+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[e>>2]|0)<3){b=k[h+44>>2]|0;n=k[j>>2]|0;k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];break}k[m>>2]=0;x1(q,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;e=k[j>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[l+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0))}}else Q1(q,b,-1);while(0);switch(d|0){case 2:{g=Bea(s,q,c)|0;break}case 4:{g=Bea(s,q,c)|0;break}default:{k[o>>2]=0;a=o+4|0;k[a>>2]=0;e=ZT(44)|0;k[e>>2]=1;f=e+4|0;k[o>>2]=f;k[a>>2]=37;i[e+41>>0]=0;g=242588;h=f+37|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-210,o,242626,242646,377);k[a>>2]=0;k[o>>2]=0;o=k[e>>2]|0;k[e>>2]=o+-1;if((o|0)==1)ggb(k[e+-4>>2]|0);g=0}}f=q+36|0;a=k[f>>2]|0;if(a|0?(d=a+12|0,o=k[d>>2]|0,k[d>>2]=o+-1,(o|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;o=q+16|0;e=q+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[e>>2]|0)>0){f=k[q+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[q+44>>2]|0;if(!((a|0)==(q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=s+36|0;a=k[f>>2]|0;if(a|0?(o=a+12|0,q=k[o>>2]|0,k[o>>2]=q+-1,(q|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[s+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;q=s+16|0;f=s+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[f>>2]|0)>0){e=k[p>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[s+44>>2]|0;if((a|0)==(s+48|0)|(a|0)==0){r=t;return g|0}ggb(k[a+-4>>2]|0);r=t;return g|0}function Bea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=r;r=r+16|0;h=G;if(!((k[b>>2]&4088|0)==0?!(k[a>>2]&4088|0):0)){d=h+4|0;e=ZT(44)|0;k[e>>2]=1;n=e+4|0;k[h>>2]=n;k[d>>2]=38;i[e+42>>0]=0;o=242727;p=n+38|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,h,242766,242646,341);k[d>>2]=0;k[h>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0)}switch(c|0){case 4:case 8:break;default:{d=h+4|0;e=ZT(44)|0;k[e>>2]=1;n=e+4|0;k[h>>2]=n;k[d>>2]=38;i[e+42>>0]=0;o=246002;p=n+38|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,h,242766,242646,342);k[d>>2]=0;k[h>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0)}}d=k[b>>2]|0;if((k[a>>2]&6|1|0)!=1){e=h+4|0;f=ZT(40)|0;k[f>>2]=1;n=f+4|0;k[h>>2]=n;k[e>>2]=34;i[f+38>>0]=0;o=242791;p=n+34|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,h,242766,242646,349);k[e>>2]=0;k[h>>2]=0;F=k[f>>2]|0;k[f>>2]=F+-1;if((F|0)==1)ggb(k[f+-4>>2]|0)}switch(d&7){case 0:{g=b+8|0;if((k[g>>2]|0)!=(k[a+8>>2]|0)){d=h+4|0;e=ZT(24)|0;k[e>>2]=1;n=e+4|0;k[h>>2]=n;k[d>>2]=16;i[e+20>>0]=0;o=242855;p=n+16|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,h,369779,242646,193);k[d>>2]=0;k[h>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0)}f=b+12|0;if((k[f>>2]|0)!=(k[a+12>>2]|0)){d=h+4|0;e=ZT(24)|0;k[e>>2]=1;n=e+4|0;k[h>>2]=n;k[d>>2]=16;i[e+20>>0]=0;o=242872;p=n+16|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,h,369779,242646,194);k[d>>2]=0;k[h>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0)}y=(c|0)==8;switch(c|0){case 4:case 8:break;default:{d=h+4|0;e=ZT(44)|0;k[e>>2]=1;n=e+4|0;k[h>>2]=n;k[d>>2]=38;i[e+42>>0]=0;o=246002;p=n+38|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,h,369779,242646,195);k[d>>2]=0;k[h>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0)}}C=k[g>>2]|0;A=k[f>>2]|0;D=ZT(aa((((C+2|0)>>>0)/3|0)<<2,((A+2|0)>>>0)/3|0)|0)|0;i[D>>0]=0;if((C|0)>0){B=b+16|0;z=b+44|0;w=a+16|0;v=a+44|0;x=(A|0)==0;d=1;u=0;while(1){a=k[k[z>>2]>>2]|0;s=(k[B>>2]|0)+(aa(a,u)|0)|0;a=s+(0-a)|0;q=k[k[v>>2]>>2]|0;f=(k[w>>2]|0)+(aa(q,u)|0)|0;q=f+(0-q)|0;b=(u|0)>0;t=f+A|0;a:do if(y)if(x)c=d;else{p=0;while(1){do if(!(i[f>>0]|0))i[s+p>>0]=0;else{g=q+p|0;o=s+p|0;h=a+p|0;c=(p|0)>0;if(b&c)n=(i[g+-1>>0]|0)!=0;else n=0;if(b){e=(i[g>>0]|0)!=0;if((p+1|0)<(A|0))g=(i[g+1>>0]|0)!=0;else g=0}else{e=0;g=0}if(c)c=(i[f+-1>>0]|0)!=0;else c=0;if(e){i[o>>0]=i[h>>0]|0;break}if(!g){if(n){i[o>>0]=i[h+-1>>0]|0;break}if(c){i[o>>0]=i[o+-1>>0]|0;break}else{i[o>>0]=d;F=d&255;i[D+F>>0]=d;d=F+1&255;break}}e=i[h+1>>0]|0;if(n){g=i[h+-1>>0]|0;n=e;while(1){c=i[D+(n&255)>>0]|0;if((c&255)<(n&255))n=c;else break}if(e<<24>>24==g<<24>>24)g=n;else{c=g;while(1){h=i[D+(c&255)>>0]|0;if((h&255)<(c&255))c=h;else break}c=(n&255)>(c&255)?c:n;do{E=D+(g&255)|0;F=g;g=i[E>>0]|0;i[E>>0]=c}while((g&255)<(F&255));g=c}do{E=D+(e&255)|0;F=e;e=i[E>>0]|0;i[E>>0]=g}while((e&255)<(F&255));i[o>>0]=g;break}if(!c){i[o>>0]=e;break}g=i[o+-1>>0]|0;n=e;while(1){c=i[D+(n&255)>>0]|0;if((c&255)<(n&255))n=c;else break}if(e<<24>>24==g<<24>>24)g=n;else{c=g;while(1){h=i[D+(c&255)>>0]|0;if((h&255)<(c&255))c=h;else break}c=(n&255)>(c&255)?c:n;do{E=D+(g&255)|0;F=g;g=i[E>>0]|0;i[E>>0]=c}while((g&255)<(F&255));g=c}do{E=D+(e&255)|0;F=e;e=i[E>>0]|0;i[E>>0]=g}while((e&255)<(F&255));i[o>>0]=g}while(0);f=f+1|0;if((f|0)==(t|0)){c=d;break}else p=p+1|0}}else if(x)c=d;else{if(b)p=0;else{g=0;while(1){e=s+g|0;do if(!(i[f>>0]|0))i[e>>0]=0;else{if((g|0)>0?i[f+-1>>0]|0:0){i[e>>0]=i[e+-1>>0]|0;break}i[e>>0]=d;F=d&255;i[D+F>>0]=d;d=F+1&255}while(0);f=f+1|0;if((f|0)==(t|0)){c=d;break a}else g=g+1|0}}while(1){o=s+p|0;do if(!(i[f>>0]|0))i[o>>0]=0;else{g=a+p|0;if((p|0)>0)e=(i[f+-1>>0]|0)!=0;else e=0;if(!(i[q+p>>0]|0))if(e){i[o>>0]=i[o+-1>>0]|0;break}else{i[o>>0]=d;F=d&255;i[D+F>>0]=d;d=F+1&255;break}if(!e){i[o>>0]=i[g>>0]|0;break}e=i[o+-1>>0]|0;g=i[g>>0]|0;n=e;while(1){c=i[D+(n&255)>>0]|0;if((c&255)<(n&255))n=c;else break}if(e<<24>>24==g<<24>>24)g=n;else{c=g;while(1){h=i[D+(c&255)>>0]|0;if((h&255)<(c&255))c=h;else break}c=(n&255)>(c&255)?c:n;do{E=D+(g&255)|0;F=g;g=i[E>>0]|0;i[E>>0]=c}while((g&255)<(F&255));g=c}do{E=D+(e&255)|0;F=e;e=i[E>>0]|0;i[E>>0]=g}while((e&255)<(F&255));i[o>>0]=g}while(0);f=f+1|0;if((f|0)==(t|0)){c=d;break}else p=p+1|0}}while(0);u=u+1|0;if((u|0)==(C|0))break;else d=c}if((c&255)>1){d=1;g=1;do{e=D+g|0;f=l[e>>0]|0;if(f>>>0<g>>>0)i[e>>0]=i[D+f>>0]|0;else{i[e>>0]=d;d=(d&255)+1&255}g=g+1|0}while((g&255)<<24>>24!=c<<24>>24)}else d=1;f=0;do{e=(k[B>>2]|0)+(aa(k[k[z>>2]>>2]|0,f)|0)|0;g=e+A|0;if(!x)do{i[e>>0]=i[D+(l[e>>0]|0)>>0]|0;e=e+1|0}while((e|0)!=(g|0));f=f+1|0}while((f|0)!=(C|0))}else d=1;if(D|0)ggb(k[D+-4>>2]|0);F=d&255;r=G;return F|0}case 2:{g=b+8|0;if((k[g>>2]|0)!=(k[a+8>>2]|0)){d=h+4|0;e=ZT(24)|0;k[e>>2]=1;n=e+4|0;k[h>>2]=n;k[d>>2]=16;i[e+20>>0]=0;o=242855;p=n+16|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,h,369779,242646,193);k[d>>2]=0;k[h>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0)}f=b+12|0;if((k[f>>2]|0)!=(k[a+12>>2]|0)){d=h+4|0;e=ZT(24)|0;k[e>>2]=1;n=e+4|0;k[h>>2]=n;k[d>>2]=16;i[e+20>>0]=0;o=242872;p=n+16|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,h,369779,242646,194);k[d>>2]=0;k[h>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0)}B=(c|0)==8;switch(c|0){case 4:case 8:break;default:{d=h+4|0;e=ZT(44)|0;k[e>>2]=1;n=e+4|0;k[h>>2]=n;k[d>>2]=38;i[e+42>>0]=0;o=246002;p=n+38|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,h,369779,242646,195);k[d>>2]=0;k[h>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0)}}E=k[g>>2]|0;D=k[f>>2]|0;F=ZT(aa((((E+2|0)>>>0)/3|0)<<3,((D+2|0)>>>0)/3|0)|0)|0;j[F>>1]=0;if((E|0)>0){C=k[b+16>>2]|0;A=k[k[b+44>>2]>>2]|0;z=k[a+16>>2]|0;v=k[k[a+44>>2]>>2]|0;w=0-A|0;x=0-v|0;y=(D|0)==0;d=1;u=0;while(1){s=C+(aa(A,u)|0)|0;a=s+w|0;f=z+(aa(v,u)|0)|0;q=f+x|0;b=(u|0)>0;t=f+D|0;b:do if(B)if(y)c=d;else{p=0;while(1){do if(!(i[f>>0]|0))j[s+(p<<1)>>1]=0;else{g=q+p|0;o=s+(p<<1)|0;h=a+(p<<1)|0;c=(p|0)>0;if(b&c)n=(i[g+-1>>0]|0)!=0;else n=0;if(b){e=(i[g>>0]|0)!=0;if((p+1|0)<(D|0))g=(i[g+1>>0]|0)!=0;else g=0}else{e=0;g=0}if(c)c=(i[f+-1>>0]|0)!=0;else c=0;if(e){j[o>>1]=j[h>>1]|0;break}if(!g){if(n){j[o>>1]=j[h+-2>>1]|0;break}if(c){j[o>>1]=j[o+-2>>1]|0;break}else{j[o>>1]=d;o=d&65535;j[F+(o<<1)>>1]=d;d=o+1&65535;break}}e=j[h+2>>1]|0;if(n){g=j[h+-2>>1]|0;n=e;while(1){c=j[F+((n&65535)<<1)>>1]|0;if((c&65535)<(n&65535))n=c;else break}if(e<<16>>16==g<<16>>16)g=n;else{c=g;while(1){h=j[F+((c&65535)<<1)>>1]|0;if((h&65535)<(c&65535))c=h;else break}c=(n&65535)>(c&65535)?c:n;do{h=F+((g&65535)<<1)|0;n=g;g=j[h>>1]|0;j[h>>1]=c}while((g&65535)<(n&65535));g=c}do{h=F+((e&65535)<<1)|0;n=e;e=j[h>>1]|0;j[h>>1]=g}while((e&65535)<(n&65535));j[o>>1]=g;break}if(!c){j[o>>1]=e;break}g=j[o+-2>>1]|0;n=e;while(1){c=j[F+((n&65535)<<1)>>1]|0;if((c&65535)<(n&65535))n=c;else break}if(e<<16>>16==g<<16>>16)g=n;else{c=g;while(1){h=j[F+((c&65535)<<1)>>1]|0;if((h&65535)<(c&65535))c=h;else break}c=(n&65535)>(c&65535)?c:n;do{h=F+((g&65535)<<1)|0;n=g;g=j[h>>1]|0;j[h>>1]=c}while((g&65535)<(n&65535));g=c}do{h=F+((e&65535)<<1)|0;n=e;e=j[h>>1]|0;j[h>>1]=g}while((e&65535)<(n&65535));j[o>>1]=g}while(0);f=f+1|0;if((f|0)==(t|0)){c=d;break}else p=p+1|0}}else if(y)c=d;else{if(b)p=0;else{g=0;while(1){e=s+(g<<1)|0;do if(!(i[f>>0]|0))j[e>>1]=0;else{if((g|0)>0?i[f+-1>>0]|0:0){j[e>>1]=j[e+-2>>1]|0;break}j[e>>1]=d;q=d&65535;j[F+(q<<1)>>1]=d;d=q+1&65535}while(0);f=f+1|0;if((f|0)==(t|0)){c=d;break b}else g=g+1|0}}while(1){o=s+(p<<1)|0;do if(!(i[f>>0]|0))j[o>>1]=0;else{g=a+(p<<1)|0;if((p|0)>0)e=(i[f+-1>>0]|0)!=0;else e=0;if(!(i[q+p>>0]|0))if(e){j[o>>1]=j[o+-2>>1]|0;break}else{j[o>>1]=d;b=d&65535;j[F+(b<<1)>>1]=d;d=b+1&65535;break}if(!e){j[o>>1]=j[g>>1]|0;break}e=j[o+-2>>1]|0;g=j[g>>1]|0;n=e;while(1){c=j[F+((n&65535)<<1)>>1]|0;if((c&65535)<(n&65535))n=c;else break}if(e<<16>>16==g<<16>>16)g=n;else{c=g;while(1){h=j[F+((c&65535)<<1)>>1]|0;if((h&65535)<(c&65535))c=h;else break}c=(n&65535)>(c&65535)?c:n;do{n=F+((g&65535)<<1)|0;b=g;g=j[n>>1]|0;j[n>>1]=c}while((g&65535)<(b&65535));g=c}do{n=F+((e&65535)<<1)|0;b=e;e=j[n>>1]|0;j[n>>1]=g}while((e&65535)<(b&65535));j[o>>1]=g}while(0);f=f+1|0;if((f|0)==(t|0)){c=d;break}else p=p+1|0}}while(0);u=u+1|0;if((u|0)==(E|0))break;else d=c}if((c&65535)>1){d=1;g=1;do{e=F+(g<<1)|0;f=m[e>>1]|0;if(f>>>0<g>>>0)j[e>>1]=j[F+(f<<1)>>1]|0;else{j[e>>1]=d;d=(d&65535)+1&65535}g=g+1|0}while((g&65535)<<16>>16!=c<<16>>16)}else d=1;f=0;do{e=C+(aa(A,f)|0)|0;g=e+(D<<1)|0;if((e|0)!=(g|0))do{j[e>>1]=j[F+(m[e>>1]<<1)>>1]|0;e=e+2|0}while((e|0)!=(g|0));f=f+1|0}while((f|0)!=(E|0))}else d=1;if(F|0)ggb(k[F+-4>>2]|0);F=d&65535;r=G;return F|0}case 4:{g=b+8|0;if((k[g>>2]|0)!=(k[a+8>>2]|0)){d=h+4|0;e=ZT(24)|0;k[e>>2]=1;n=e+4|0;k[h>>2]=n;k[d>>2]=16;i[e+20>>0]=0;o=242855;p=n+16|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,h,369779,242646,193);k[d>>2]=0;k[h>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0)}f=b+12|0;if((k[f>>2]|0)!=(k[a+12>>2]|0)){d=h+4|0;e=ZT(24)|0;k[e>>2]=1;n=e+4|0;k[h>>2]=n;k[d>>2]=16;i[e+20>>0]=0;o=242872;p=n+16|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,h,369779,242646,194);k[d>>2]=0;k[h>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0)}z=(c|0)==8;switch(c|0){case 4:case 8:break;default:{d=h+4|0;e=ZT(44)|0;k[e>>2]=1;n=e+4|0;k[h>>2]=n;k[d>>2]=38;i[e+42>>0]=0;o=246002;p=n+38|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,h,369779,242646,195);k[d>>2]=0;k[h>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0)}}C=k[g>>2]|0;B=k[f>>2]|0;D=ZT(aa((((C+2|0)>>>0)/3|0)<<4,((B+2|0)>>>0)/3|0)|0)|0;k[D>>2]=0;if((C|0)>0){A=k[b+16>>2]|0;y=k[b+44>>2]|0;x=k[a+16>>2]|0;v=k[a+44>>2]|0;w=(B|0)==0;d=1;u=0;while(1){a=k[y>>2]|0;s=A+(aa(a,u)|0)|0;a=s+(0-a)|0;q=k[v>>2]|0;f=x+(aa(q,u)|0)|0;q=f+(0-q)|0;b=(u|0)>0;t=f+B|0;c:do if(z)if(w)c=d;else{p=0;while(1){do if(!(i[f>>0]|0))k[s+(p<<2)>>2]=0;else{g=q+p|0;o=s+(p<<2)|0;h=a+(p<<2)|0;c=(p|0)>0;if(b&c)n=(i[g+-1>>0]|0)!=0;else n=0;if(b){e=(i[g>>0]|0)!=0;if((p+1|0)<(B|0))g=(i[g+1>>0]|0)!=0;else g=0}else{e=0;g=0}if(c)c=(i[f+-1>>0]|0)!=0;else c=0;if(e){k[o>>2]=k[h>>2];break}if(!g){if(n){k[o>>2]=k[h+-4>>2];break}if(c){k[o>>2]=k[o+-4>>2];break}else{k[o>>2]=d;k[D+(d<<2)>>2]=d;d=d+1|0;break}}e=k[h+4>>2]|0;if(n){g=k[h+-4>>2]|0;n=e;while(1){c=k[D+(n<<2)>>2]|0;if((c|0)<(n|0))n=c;else break}if((e|0)==(g|0))g=n;else{c=g;while(1){h=k[D+(c<<2)>>2]|0;if((h|0)<(c|0))c=h;else break}c=(n|0)>(c|0)?c:n;do{E=D+(g<<2)|0;F=g;g=k[E>>2]|0;k[E>>2]=c}while((g|0)<(F|0));g=c}do{E=D+(e<<2)|0;F=e;e=k[E>>2]|0;k[E>>2]=g}while((e|0)<(F|0));k[o>>2]=g;break}if(!c){k[o>>2]=e;break}g=k[o+-4>>2]|0;n=e;while(1){c=k[D+(n<<2)>>2]|0;if((c|0)<(n|0))n=c;else break}if((e|0)==(g|0))g=n;else{c=g;while(1){h=k[D+(c<<2)>>2]|0;if((h|0)<(c|0))c=h;else break}c=(n|0)>(c|0)?c:n;do{E=D+(g<<2)|0;F=g;g=k[E>>2]|0;k[E>>2]=c}while((g|0)<(F|0));g=c}do{E=D+(e<<2)|0;F=e;e=k[E>>2]|0;k[E>>2]=g}while((e|0)<(F|0));k[o>>2]=g}while(0);f=f+1|0;if((f|0)==(t|0)){c=d;break}else p=p+1|0}}else if(w)c=d;else{if(b)p=0;else{g=0;while(1){e=s+(g<<2)|0;do if(!(i[f>>0]|0))k[e>>2]=0;else{if((g|0)>0?i[f+-1>>0]|0:0){k[e>>2]=k[e+-4>>2];break}k[e>>2]=d;k[D+(d<<2)>>2]=d;d=d+1|0}while(0);f=f+1|0;if((f|0)==(t|0)){c=d;break c}else g=g+1|0}}while(1){o=s+(p<<2)|0;do if(!(i[f>>0]|0))k[o>>2]=0;else{g=a+(p<<2)|0;if((p|0)>0)e=(i[f+-1>>0]|0)!=0;else e=0;if(!(i[q+p>>0]|0))if(e){k[o>>2]=k[o+-4>>2];break}else{k[o>>2]=d;k[D+(d<<2)>>2]=d;d=d+1|0;break}if(!e){k[o>>2]=k[g>>2];break}e=k[o+-4>>2]|0;g=k[g>>2]|0;n=e;while(1){c=k[D+(n<<2)>>2]|0;if((c|0)<(n|0))n=c;else break}if((e|0)==(g|0))g=n;else{c=g;while(1){h=k[D+(c<<2)>>2]|0;if((h|0)<(c|0))c=h;else break}c=(n|0)>(c|0)?c:n;do{E=D+(g<<2)|0;F=g;g=k[E>>2]|0;k[E>>2]=c}while((g|0)<(F|0));g=c}do{E=D+(e<<2)|0;F=e;e=k[E>>2]|0;k[E>>2]=g}while((e|0)<(F|0));k[o>>2]=g}while(0);f=f+1|0;if((f|0)==(t|0)){c=d;break}else p=p+1|0}}while(0);u=u+1|0;if((u|0)==(C|0))break;else d=c}if((c|0)>1){d=1;g=1;do{e=D+(g<<2)|0;f=k[e>>2]|0;if((f|0)<(g|0))k[e>>2]=k[D+(f<<2)>>2];else{k[e>>2]=d;d=d+1|0}g=g+1|0}while((g|0)!=(c|0))}else d=1;f=0;do{e=A+(aa(k[y>>2]|0,f)|0)|0;g=e+(B<<2)|0;if((e|0)!=(g|0))do{k[e>>2]=k[D+(k[e>>2]<<2)>>2];e=e+4|0}while((e|0)!=(g|0));f=f+1|0}while((f|0)!=(C|0))}else d=1;if(!D){F=d;r=G;return F|0}ggb(k[D+-4>>2]|0);F=d;r=G;return F|0}default:{d=h+4|0;e=ZT(36)|0;k[e>>2]=1;n=e+4|0;k[h>>2]=n;k[d>>2]=28;i[e+32>>0]=0;o=242826;p=n+28|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-210,h,242766,242646,361);k[d>>2]=0;k[h>>2]=0;F=k[e>>2]|0;k[e>>2]=F+-1;if((F|0)==1)ggb(k[e+-4>>2]|0);F=-1;r=G;return F|0}}return 0}function Cea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0;K=r;r=r+16|0;n=K;if(!((k[b>>2]&4088|0)==0?!(k[a>>2]&4088|0):0)){e=n+4|0;f=ZT(44)|0;k[f>>2]=1;o=f+4|0;k[n>>2]=o;k[e>>2]=38;i[f+42>>0]=0;q=242727;s=o+38|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,n,242766,242646,341);k[e>>2]=0;k[n>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0)}switch(c|0){case 4:case 8:break;default:{e=n+4|0;f=ZT(44)|0;k[f>>2]=1;o=f+4|0;k[n>>2]=o;k[e>>2]=38;i[f+42>>0]=0;q=246002;s=o+38|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,n,242766,242646,342);k[e>>2]=0;k[n>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0)}}e=k[b>>2]|0;if((k[a>>2]&6|1|0)!=1){f=n+4|0;g=ZT(40)|0;k[g>>2]=1;o=g+4|0;k[n>>2]=o;k[f>>2]=34;i[g+38>>0]=0;q=242791;s=o+34|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,n,242766,242646,349);k[f>>2]=0;k[n>>2]=0;J=k[g>>2]|0;k[g>>2]=J+-1;if((J|0)==1)ggb(k[g+-4>>2]|0)}switch(e&7){case 0:{h=b+8|0;if((k[h>>2]|0)!=(k[a+8>>2]|0)){e=n+4|0;f=ZT(24)|0;k[f>>2]=1;o=f+4|0;k[n>>2]=o;k[e>>2]=16;i[f+20>>0]=0;q=242855;s=o+16|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,n,369779,242646,193);k[e>>2]=0;k[n>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0)}g=b+12|0;if((k[g>>2]|0)!=(k[a+12>>2]|0)){e=n+4|0;f=ZT(24)|0;k[f>>2]=1;o=f+4|0;k[n>>2]=o;k[e>>2]=16;i[f+20>>0]=0;q=242872;s=o+16|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,n,369779,242646,194);k[e>>2]=0;k[n>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0)}z=(c|0)==8;switch(c|0){case 4:case 8:break;default:{e=n+4|0;f=ZT(44)|0;k[f>>2]=1;o=f+4|0;k[n>>2]=o;k[e>>2]=38;i[f+42>>0]=0;q=246002;s=o+38|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,n,369779,242646,195);k[e>>2]=0;k[n>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0)}}E=k[h>>2]|0;C=k[g>>2]|0;F=ZT(aa((((E+2|0)>>>0)/3|0)<<2,((C+2|0)>>>0)/3|0)|0)|0;i[F>>0]=0;if((E|0)>0){D=b+16|0;B=b+44|0;y=a+16|0;x=a+44|0;A=(C|0)==0;e=1;w=0;while(1){a=k[k[B>>2]>>2]|0;u=(k[D>>2]|0)+(aa(a,w)|0)|0;a=u+(0-a)|0;t=k[k[x>>2]>>2]|0;g=(k[y>>2]|0)+(aa(t,w)|0)|0;t=g+(0-t)|0;b=(w|0)>0;v=g+C|0;a:do if(z)if(A)c=e;else{s=0;while(1){do if(!(i[g>>0]|0))i[u+s>>0]=0;else{h=t+s|0;q=u+s|0;o=a+s|0;c=(s|0)>0;if(b&c)n=(i[h+-1>>0]|0)!=0;else n=0;if(b){f=(i[h>>0]|0)!=0;if((s+1|0)<(C|0))h=(i[h+1>>0]|0)!=0;else h=0}else{f=0;h=0}if(c)c=(i[g+-1>>0]|0)!=0;else c=0;if(f){i[q>>0]=i[o>>0]|0;break}if(!h){if(n){i[q>>0]=i[o+-1>>0]|0;break}if(c){i[q>>0]=i[q+-1>>0]|0;break}else{i[q>>0]=e;J=e&255;i[F+J>>0]=e;e=J+1&255;break}}f=i[o+1>>0]|0;if(n){h=i[o+-1>>0]|0;o=f;while(1){c=i[F+(o&255)>>0]|0;if((c&255)<(o&255))o=c;else break}if(f<<24>>24==h<<24>>24)h=o;else{c=h;while(1){n=i[F+(c&255)>>0]|0;if((n&255)<(c&255))c=n;else break}c=(o&255)>(c&255)?c:o;do{I=F+(h&255)|0;J=h;h=i[I>>0]|0;i[I>>0]=c}while((h&255)<(J&255));h=c}do{I=F+(f&255)|0;J=f;f=i[I>>0]|0;i[I>>0]=h}while((f&255)<(J&255));i[q>>0]=h;break}if(!c){i[q>>0]=f;break}h=i[q+-1>>0]|0;o=f;while(1){c=i[F+(o&255)>>0]|0;if((c&255)<(o&255))o=c;else break}if(f<<24>>24==h<<24>>24)h=o;else{c=h;while(1){n=i[F+(c&255)>>0]|0;if((n&255)<(c&255))c=n;else break}c=(o&255)>(c&255)?c:o;do{I=F+(h&255)|0;J=h;h=i[I>>0]|0;i[I>>0]=c}while((h&255)<(J&255));h=c}do{I=F+(f&255)|0;J=f;f=i[I>>0]|0;i[I>>0]=h}while((f&255)<(J&255));i[q>>0]=h}while(0);g=g+1|0;if((g|0)==(v|0)){c=e;break}else s=s+1|0}}else if(A)c=e;else{if(b)s=0;else{h=0;while(1){f=u+h|0;do if(!(i[g>>0]|0))i[f>>0]=0;else{if((h|0)>0?i[g+-1>>0]|0:0){i[f>>0]=i[f+-1>>0]|0;break}i[f>>0]=e;J=e&255;i[F+J>>0]=e;e=J+1&255}while(0);g=g+1|0;if((g|0)==(v|0)){c=e;break a}else h=h+1|0}}while(1){q=u+s|0;do if(!(i[g>>0]|0))i[q>>0]=0;else{h=a+s|0;if((s|0)>0)f=(i[g+-1>>0]|0)!=0;else f=0;if(!(i[t+s>>0]|0))if(f){i[q>>0]=i[q+-1>>0]|0;break}else{i[q>>0]=e;J=e&255;i[F+J>>0]=e;e=J+1&255;break}if(!f){i[q>>0]=i[h>>0]|0;break}f=i[q+-1>>0]|0;h=i[h>>0]|0;o=f;while(1){c=i[F+(o&255)>>0]|0;if((c&255)<(o&255))o=c;else break}if(f<<24>>24==h<<24>>24)h=o;else{c=h;while(1){n=i[F+(c&255)>>0]|0;if((n&255)<(c&255))c=n;else break}c=(o&255)>(c&255)?c:o;do{I=F+(h&255)|0;J=h;h=i[I>>0]|0;i[I>>0]=c}while((h&255)<(J&255));h=c}do{I=F+(f&255)|0;J=f;f=i[I>>0]|0;i[I>>0]=h}while((f&255)<(J&255));i[q>>0]=h}while(0);g=g+1|0;if((g|0)==(v|0)){c=e;break}else s=s+1|0}}while(0);w=w+1|0;if((w|0)==(E|0))break;else e=c}if((c&255)>1){g=1;h=1;do{e=F+h|0;f=l[e>>0]|0;if(f>>>0<h>>>0)i[e>>0]=i[F+f>>0]|0;else{i[e>>0]=g;g=(g&255)+1&255}h=h+1|0}while((h&255)<<24>>24!=c<<24>>24)}else g=1;Eea(d,g&255);c=d+20|0;n=d+48|0;o=d+120|0;h=0;do{e=(k[D>>2]|0)+(aa(k[k[B>>2]>>2]|0,h)|0)|0;q=e+C|0;if(!A){s=((h|0)<0)<<31>>31;f=0;while(1){J=i[F+(l[e>>0]|0)>>0]|0;i[e>>0]=J;J=J&255;I=(k[c>>2]|0)+(aa(k[k[n>>2]>>2]|0,J)|0)|0;H=k[I>>2]|0;k[I>>2]=(H|0)>(f|0)?f:H;H=I+8|0;G=k[H>>2]|0;k[H>>2]=(G|0)<(f|0)?f:G;H=I+4|0;G=k[H>>2]|0;k[H>>2]=(G|0)>(h|0)?h:G;H=I+12|0;G=k[H>>2]|0;k[H>>2]=(G|0)<(h|0)?h:G;I=I+16|0;k[I>>2]=(k[I>>2]|0)+1;I=k[o>>2]|0;H=I+(J<<4)|0;G=H;G=kpb(k[G>>2]|0,k[G+4>>2]|0,f|0,((f|0)<0)<<31>>31|0)|0;k[H>>2]=G;k[H+4>>2]=N;J=I+(J<<4)+8|0;I=J;I=kpb(k[I>>2]|0,k[I+4>>2]|0,h|0,s|0)|0;k[J>>2]=I;k[J+4>>2]=N;e=e+1|0;if((e|0)==(q|0))break;else f=f+1|0}}h=h+1|0}while((h|0)!=(E|0))}else{Eea(d,1);g=1}h=d+12|0;if((k[h>>2]|0)>0){c=k[d+20>>2]|0;n=k[d+48>>2]|0;o=k[d+120>>2]|0;q=k[d+80>>2]|0;f=k[d+108>>2]|0;e=0;do{J=c+(aa(k[n>>2]|0,e)|0)|0;d=J+8|0;k[d>>2]=(k[d>>2]|0)+1-(k[J>>2]|0);d=J+12|0;k[d>>2]=(k[d>>2]|0)+1-(k[J+4>>2]|0);d=q+(aa(k[f>>2]|0,e)|0)|0;L=+((k[J+16>>2]|0)>>>0);J=o+(e<<4)|0;p[d>>3]=(+((k[J>>2]|0)>>>0)+4294967296.0*+((k[J+4>>2]|0)>>>0))/L;J=o+(e<<4)+8|0;p[d+8>>3]=(+((k[J>>2]|0)>>>0)+4294967296.0*+((k[J+4>>2]|0)>>>0))/L;e=e+1|0}while((e|0)<(k[h>>2]|0))}if(F|0)ggb(k[F+-4>>2]|0);d=g&255;r=K;return d|0}case 2:{h=b+8|0;if((k[h>>2]|0)!=(k[a+8>>2]|0)){e=n+4|0;f=ZT(24)|0;k[f>>2]=1;o=f+4|0;k[n>>2]=o;k[e>>2]=16;i[f+20>>0]=0;q=242855;s=o+16|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,n,369779,242646,193);k[e>>2]=0;k[n>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0)}g=b+12|0;if((k[g>>2]|0)!=(k[a+12>>2]|0)){e=n+4|0;f=ZT(24)|0;k[f>>2]=1;o=f+4|0;k[n>>2]=o;k[e>>2]=16;i[f+20>>0]=0;q=242872;s=o+16|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,n,369779,242646,194);k[e>>2]=0;k[n>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0)}G=(c|0)==8;switch(c|0){case 4:case 8:break;default:{e=n+4|0;f=ZT(44)|0;k[f>>2]=1;o=f+4|0;k[n>>2]=o;k[e>>2]=38;i[f+42>>0]=0;q=246002;s=o+38|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,n,369779,242646,195);k[e>>2]=0;k[n>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0)}}I=k[h>>2]|0;H=k[g>>2]|0;J=ZT(aa((((I+2|0)>>>0)/3|0)<<3,((H+2|0)>>>0)/3|0)|0)|0;j[J>>1]=0;if((I|0)>0){E=b+16|0;F=b+44|0;B=k[E>>2]|0;C=k[k[F>>2]>>2]|0;D=k[a+16>>2]|0;x=k[k[a+44>>2]>>2]|0;y=0-C|0;z=0-x|0;A=(H|0)==0;e=1;w=0;while(1){u=B+(aa(C,w)|0)|0;a=u+y|0;g=D+(aa(x,w)|0)|0;t=g+z|0;b=(w|0)>0;v=g+H|0;b:do if(G)if(A)c=e;else{s=0;while(1){do if(!(i[g>>0]|0))j[u+(s<<1)>>1]=0;else{h=t+s|0;q=u+(s<<1)|0;o=a+(s<<1)|0;c=(s|0)>0;if(b&c)n=(i[h+-1>>0]|0)!=0;else n=0;if(b){f=(i[h>>0]|0)!=0;if((s+1|0)<(H|0))h=(i[h+1>>0]|0)!=0;else h=0}else{f=0;h=0}if(c)c=(i[g+-1>>0]|0)!=0;else c=0;if(f){j[q>>1]=j[o>>1]|0;break}if(!h){if(n){j[q>>1]=j[o+-2>>1]|0;break}if(c){j[q>>1]=j[q+-2>>1]|0;break}else{j[q>>1]=e;q=e&65535;j[J+(q<<1)>>1]=e;e=q+1&65535;break}}f=j[o+2>>1]|0;if(n){h=j[o+-2>>1]|0;o=f;while(1){c=j[J+((o&65535)<<1)>>1]|0;if((c&65535)<(o&65535))o=c;else break}if(f<<16>>16==h<<16>>16)h=o;else{c=h;while(1){n=j[J+((c&65535)<<1)>>1]|0;if((n&65535)<(c&65535))c=n;else break}c=(o&65535)>(c&65535)?c:o;do{n=J+((h&65535)<<1)|0;o=h;h=j[n>>1]|0;j[n>>1]=c}while((h&65535)<(o&65535));h=c}do{n=J+((f&65535)<<1)|0;o=f;f=j[n>>1]|0;j[n>>1]=h}while((f&65535)<(o&65535));j[q>>1]=h;break}if(!c){j[q>>1]=f;break}h=j[q+-2>>1]|0;o=f;while(1){c=j[J+((o&65535)<<1)>>1]|0;if((c&65535)<(o&65535))o=c;else break}if(f<<16>>16==h<<16>>16)h=o;else{c=h;while(1){n=j[J+((c&65535)<<1)>>1]|0;if((n&65535)<(c&65535))c=n;else break}c=(o&65535)>(c&65535)?c:o;do{n=J+((h&65535)<<1)|0;o=h;h=j[n>>1]|0;j[n>>1]=c}while((h&65535)<(o&65535));h=c}do{n=J+((f&65535)<<1)|0;o=f;f=j[n>>1]|0;j[n>>1]=h}while((f&65535)<(o&65535));j[q>>1]=h}while(0);g=g+1|0;if((g|0)==(v|0)){c=e;break}else s=s+1|0}}else if(A)c=e;else{if(b)s=0;else{h=0;while(1){f=u+(h<<1)|0;do if(!(i[g>>0]|0))j[f>>1]=0;else{if((h|0)>0?i[g+-1>>0]|0:0){j[f>>1]=j[f+-2>>1]|0;break}j[f>>1]=e;t=e&65535;j[J+(t<<1)>>1]=e;e=t+1&65535}while(0);g=g+1|0;if((g|0)==(v|0)){c=e;break b}else h=h+1|0}}while(1){q=u+(s<<1)|0;do if(!(i[g>>0]|0))j[q>>1]=0;else{h=a+(s<<1)|0;if((s|0)>0)f=(i[g+-1>>0]|0)!=0;else f=0;if(!(i[t+s>>0]|0))if(f){j[q>>1]=j[q+-2>>1]|0;break}else{j[q>>1]=e;b=e&65535;j[J+(b<<1)>>1]=e;e=b+1&65535;break}if(!f){j[q>>1]=j[h>>1]|0;break}f=j[q+-2>>1]|0;h=j[h>>1]|0;o=f;while(1){c=j[J+((o&65535)<<1)>>1]|0;if((c&65535)<(o&65535))o=c;else break}if(f<<16>>16==h<<16>>16)h=o;else{c=h;while(1){n=j[J+((c&65535)<<1)>>1]|0;if((n&65535)<(c&65535))c=n;else break}c=(o&65535)>(c&65535)?c:o;do{o=J+((h&65535)<<1)|0;b=h;h=j[o>>1]|0;j[o>>1]=c}while((h&65535)<(b&65535));h=c}do{o=J+((f&65535)<<1)|0;b=f;f=j[o>>1]|0;j[o>>1]=h}while((f&65535)<(b&65535));j[q>>1]=h}while(0);g=g+1|0;if((g|0)==(v|0)){c=e;break}else s=s+1|0}}while(0);w=w+1|0;if((w|0)==(I|0))break;else e=c}if((c&65535)>1){e=1;h=1;do{f=J+(h<<1)|0;g=m[f>>1]|0;if(g>>>0<h>>>0)j[f>>1]=j[J+(g<<1)>>1]|0;else{j[f>>1]=e;e=(e&65535)+1&65535}h=h+1|0}while((h&65535)<<16>>16!=c<<16>>16)}else e=1;Eea(d,e&65535);a=k[E>>2]|0;c=k[F>>2]|0;n=k[d+20>>2]|0;o=k[d+48>>2]|0;q=k[d+120>>2]|0;h=0;do{f=a+(aa(k[c>>2]|0,h)|0)|0;s=f+(H<<1)|0;if((f|0)!=(s|0)){b=((h|0)<0)<<31>>31;g=0;while(1){G=j[J+(m[f>>1]<<1)>>1]|0;j[f>>1]=G;G=G&65535;F=n+(aa(k[o>>2]|0,G)|0)|0;E=k[F>>2]|0;k[F>>2]=(E|0)>(g|0)?g:E;E=F+8|0;D=k[E>>2]|0;k[E>>2]=(D|0)<(g|0)?g:D;E=F+4|0;D=k[E>>2]|0;k[E>>2]=(D|0)>(h|0)?h:D;E=F+12|0;D=k[E>>2]|0;k[E>>2]=(D|0)<(h|0)?h:D;F=F+16|0;k[F>>2]=(k[F>>2]|0)+1;F=q+(G<<4)|0;E=F;E=kpb(k[E>>2]|0,k[E+4>>2]|0,g|0,((g|0)<0)<<31>>31|0)|0;k[F>>2]=E;k[F+4>>2]=N;G=q+(G<<4)+8|0;F=G;F=kpb(k[F>>2]|0,k[F+4>>2]|0,h|0,b|0)|0;k[G>>2]=F;k[G+4>>2]=N;f=f+2|0;if((f|0)==(s|0))break;else g=g+1|0}}h=h+1|0}while((h|0)!=(I|0));g=e}else{Eea(d,1);g=1}h=d+12|0;if((k[h>>2]|0)>0){c=k[d+20>>2]|0;n=k[d+48>>2]|0;o=k[d+120>>2]|0;q=k[d+80>>2]|0;f=k[d+108>>2]|0;e=0;do{I=c+(aa(k[n>>2]|0,e)|0)|0;d=I+8|0;k[d>>2]=(k[d>>2]|0)+1-(k[I>>2]|0);d=I+12|0;k[d>>2]=(k[d>>2]|0)+1-(k[I+4>>2]|0);d=q+(aa(k[f>>2]|0,e)|0)|0;L=+((k[I+16>>2]|0)>>>0);I=o+(e<<4)|0;p[d>>3]=(+((k[I>>2]|0)>>>0)+4294967296.0*+((k[I+4>>2]|0)>>>0))/L;I=o+(e<<4)+8|0;p[d+8>>3]=(+((k[I>>2]|0)>>>0)+4294967296.0*+((k[I+4>>2]|0)>>>0))/L;e=e+1|0}while((e|0)<(k[h>>2]|0))}if(J|0)ggb(k[J+-4>>2]|0);d=g&65535;r=K;return d|0}case 4:{h=b+8|0;if((k[h>>2]|0)!=(k[a+8>>2]|0)){e=n+4|0;f=ZT(24)|0;k[f>>2]=1;o=f+4|0;k[n>>2]=o;k[e>>2]=16;i[f+20>>0]=0;q=242855;s=o+16|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,n,369779,242646,193);k[e>>2]=0;k[n>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0)}g=b+12|0;if((k[g>>2]|0)!=(k[a+12>>2]|0)){e=n+4|0;f=ZT(24)|0;k[f>>2]=1;o=f+4|0;k[n>>2]=o;k[e>>2]=16;i[f+20>>0]=0;q=242872;s=o+16|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,n,369779,242646,194);k[e>>2]=0;k[n>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0)}E=(c|0)==8;switch(c|0){case 4:case 8:break;default:{e=n+4|0;f=ZT(44)|0;k[f>>2]=1;o=f+4|0;k[n>>2]=o;k[e>>2]=38;i[f+42>>0]=0;q=246002;s=o+38|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,n,369779,242646,195);k[e>>2]=0;k[n>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0)}}G=k[h>>2]|0;F=k[g>>2]|0;H=ZT(aa((((G+2|0)>>>0)/3|0)<<4,((F+2|0)>>>0)/3|0)|0)|0;k[H>>2]=0;if((G|0)>0){C=b+16|0;D=b+44|0;z=k[C>>2]|0;A=k[D>>2]|0;B=k[a+16>>2]|0;x=k[a+44>>2]|0;y=(F|0)==0;e=1;w=0;while(1){a=k[A>>2]|0;u=z+(aa(a,w)|0)|0;a=u+(0-a)|0;t=k[x>>2]|0;g=B+(aa(t,w)|0)|0;t=g+(0-t)|0;b=(w|0)>0;v=g+F|0;c:do if(E)if(y)c=e;else{s=0;while(1){do if(!(i[g>>0]|0))k[u+(s<<2)>>2]=0;else{h=t+s|0;q=u+(s<<2)|0;o=a+(s<<2)|0;c=(s|0)>0;if(b&c)n=(i[h+-1>>0]|0)!=0;else n=0;if(b){f=(i[h>>0]|0)!=0;if((s+1|0)<(F|0))h=(i[h+1>>0]|0)!=0;else h=0}else{f=0;h=0}if(c)c=(i[g+-1>>0]|0)!=0;else c=0;if(f){k[q>>2]=k[o>>2];break}if(!h){if(n){k[q>>2]=k[o+-4>>2];break}if(c){k[q>>2]=k[q+-4>>2];break}else{k[q>>2]=e;k[H+(e<<2)>>2]=e;e=e+1|0;break}}f=k[o+4>>2]|0;if(n){h=k[o+-4>>2]|0;o=f;while(1){c=k[H+(o<<2)>>2]|0;if((c|0)<(o|0))o=c;else break}if((f|0)==(h|0))h=o;else{c=h;while(1){n=k[H+(c<<2)>>2]|0;if((n|0)<(c|0))c=n;else break}c=(o|0)>(c|0)?c:o;do{I=H+(h<<2)|0;J=h;h=k[I>>2]|0;k[I>>2]=c}while((h|0)<(J|0));h=c}do{I=H+(f<<2)|0;J=f;f=k[I>>2]|0;k[I>>2]=h}while((f|0)<(J|0));k[q>>2]=h;break}if(!c){k[q>>2]=f;break}h=k[q+-4>>2]|0;o=f;while(1){c=k[H+(o<<2)>>2]|0;if((c|0)<(o|0))o=c;else break}if((f|0)==(h|0))h=o;else{c=h;while(1){n=k[H+(c<<2)>>2]|0;if((n|0)<(c|0))c=n;else break}c=(o|0)>(c|0)?c:o;do{I=H+(h<<2)|0;J=h;h=k[I>>2]|0;k[I>>2]=c}while((h|0)<(J|0));h=c}do{I=H+(f<<2)|0;J=f;f=k[I>>2]|0;k[I>>2]=h}while((f|0)<(J|0));k[q>>2]=h}while(0);g=g+1|0;if((g|0)==(v|0)){c=e;break}else s=s+1|0}}else if(y)c=e;else{if(b)s=0;else{h=0;while(1){f=u+(h<<2)|0;do if(!(i[g>>0]|0))k[f>>2]=0;else{if((h|0)>0?i[g+-1>>0]|0:0){k[f>>2]=k[f+-4>>2];break}k[f>>2]=e;k[H+(e<<2)>>2]=e;e=e+1|0}while(0);g=g+1|0;if((g|0)==(v|0)){c=e;break c}else h=h+1|0}}while(1){q=u+(s<<2)|0;do if(!(i[g>>0]|0))k[q>>2]=0;else{h=a+(s<<2)|0;if((s|0)>0)f=(i[g+-1>>0]|0)!=0;else f=0;if(!(i[t+s>>0]|0))if(f){k[q>>2]=k[q+-4>>2];break}else{k[q>>2]=e;k[H+(e<<2)>>2]=e;e=e+1|0;break}if(!f){k[q>>2]=k[h>>2];break}f=k[q+-4>>2]|0;h=k[h>>2]|0;o=f;while(1){c=k[H+(o<<2)>>2]|0;if((c|0)<(o|0))o=c;else break}if((f|0)==(h|0))h=o;else{c=h;while(1){n=k[H+(c<<2)>>2]|0;if((n|0)<(c|0))c=n;else break}c=(o|0)>(c|0)?c:o;do{I=H+(h<<2)|0;J=h;h=k[I>>2]|0;k[I>>2]=c}while((h|0)<(J|0));h=c}do{I=H+(f<<2)|0;J=f;f=k[I>>2]|0;k[I>>2]=h}while((f|0)<(J|0));k[q>>2]=h}while(0);g=g+1|0;if((g|0)==(v|0)){c=e;break}else s=s+1|0}}while(0);w=w+1|0;if((w|0)==(G|0))break;else e=c}if((c|0)>1){e=1;h=1;do{f=H+(h<<2)|0;g=k[f>>2]|0;if((g|0)<(h|0))k[f>>2]=k[H+(g<<2)>>2];else{k[f>>2]=e;e=e+1|0}h=h+1|0}while((h|0)!=(c|0))}else e=1;Eea(d,e);a=k[C>>2]|0;c=k[D>>2]|0;n=k[d+20>>2]|0;o=k[d+48>>2]|0;q=k[d+120>>2]|0;h=0;do{f=a+(aa(k[c>>2]|0,h)|0)|0;s=f+(F<<2)|0;if((f|0)!=(s|0)){b=((h|0)<0)<<31>>31;g=0;while(1){J=k[H+(k[f>>2]<<2)>>2]|0;k[f>>2]=J;I=n+(aa(k[o>>2]|0,J)|0)|0;E=k[I>>2]|0;k[I>>2]=(E|0)>(g|0)?g:E;E=I+8|0;D=k[E>>2]|0;k[E>>2]=(D|0)<(g|0)?g:D;E=I+4|0;D=k[E>>2]|0;k[E>>2]=(D|0)>(h|0)?h:D;E=I+12|0;D=k[E>>2]|0;k[E>>2]=(D|0)<(h|0)?h:D;I=I+16|0;k[I>>2]=(k[I>>2]|0)+1;I=q+(J<<4)|0;E=I;E=kpb(k[E>>2]|0,k[E+4>>2]|0,g|0,((g|0)<0)<<31>>31|0)|0;k[I>>2]=E;k[I+4>>2]=N;J=q+(J<<4)+8|0;I=J;I=kpb(k[I>>2]|0,k[I+4>>2]|0,h|0,b|0)|0;k[J>>2]=I;k[J+4>>2]=N;f=f+4|0;if((f|0)==(s|0))break;else g=g+1|0}}h=h+1|0}while((h|0)!=(G|0));g=e}else{Eea(d,1);g=1}h=d+12|0;if((k[h>>2]|0)>0){c=k[d+20>>2]|0;n=k[d+48>>2]|0;o=k[d+120>>2]|0;q=k[d+80>>2]|0;f=k[d+108>>2]|0;e=0;do{J=c+(aa(k[n>>2]|0,e)|0)|0;d=J+8|0;k[d>>2]=(k[d>>2]|0)+1-(k[J>>2]|0);d=J+12|0;k[d>>2]=(k[d>>2]|0)+1-(k[J+4>>2]|0);d=q+(aa(k[f>>2]|0,e)|0)|0;L=+((k[J+16>>2]|0)>>>0);J=o+(e<<4)|0;p[d>>3]=(+((k[J>>2]|0)>>>0)+4294967296.0*+((k[J+4>>2]|0)>>>0))/L;J=o+(e<<4)+8|0;p[d+8>>3]=(+((k[J>>2]|0)>>>0)+4294967296.0*+((k[J+4>>2]|0)>>>0))/L;e=e+1|0}while((e|0)<(k[h>>2]|0))}if(!H){d=g;r=K;return d|0}ggb(k[H+-4>>2]|0);d=g;r=K;return d|0}default:{e=n+4|0;f=ZT(36)|0;k[f>>2]=1;o=f+4|0;k[n>>2]=o;k[e>>2]=28;i[f+32>>0]=0;q=242826;s=o+28|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-210,n,242766,242646,361);k[e>>2]=0;k[n>>2]=0;d=k[f>>2]|0;k[f>>2]=d+-1;if((d|0)==1)ggb(k[f+-4>>2]|0);d=-1;r=K;return d|0}}return 0}function Dea(a){a=a|0;var b=0,c=0,d=0,e=0;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);ggb(b)}d=a+100|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+96>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+80|0;c=a+68|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+104>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+108>>2]|0;if(!((b|0)==(a+112|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+20|0;c=a+8|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Eea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+80|0;l=o+64|0;n=o;m=o+56|0;c=k[a>>2]|0;k[l>>2]=5;k[l+4>>2]=b;x2(c,l,4,0);l=a+4|0;c=k[a>>2]|0;do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[n>>2]=k[f>>2];j=n+4|0;c=f+4|0;k[j>>2]=k[c>>2];i=n+8|0;k[i>>2]=k[f+8>>2];k[n+12>>2]=k[f+12>>2];k[n+16>>2]=k[f+16>>2];k[n+20>>2]=k[f+20>>2];k[n+24>>2]=k[f+24>>2];k[n+28>>2]=k[f+28>>2];k[n+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[n+36>>2]=d;e=n+40|0;k[e>>2]=i;i=n+48|0;h=n+44|0;k[h>>2]=i;k[n+52>>2]=0;k[i>>2]=0;if(d|0){i=d+12|0;k[i>>2]=(k[i>>2]|0)+1}if((k[c>>2]|0)<3){i=k[f+44>>2]|0;j=k[h>>2]|0;k[j>>2]=k[i>>2];k[j+4>>2]=k[i+4>>2];break}k[j>>2]=0;x1(n,k[c>>2]|0,0,0,0);if((k[j>>2]|0)>0){i=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;c=0;do{k[g+(c<<2)>>2]=k[i+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[j>>2]|0))}}else Q1(n,c,-1);while(0);KG(l,n)|0;e=n+36|0;c=k[e>>2]|0;if(c|0?(j=c+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[n+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;l=n+16|0;e=n+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[e>>2]|0)>0){d=k[n+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[n+44>>2]|0;if(!((c|0)==(n+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=a+60|0;l=k[c>>2]|0;k[m>>2]=2;k[m+4>>2]=b;x2(l,m,6,0);l=a+64|0;c=k[c>>2]|0;do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[n>>2]=k[f>>2];j=n+4|0;c=f+4|0;k[j>>2]=k[c>>2];m=n+8|0;k[m>>2]=k[f+8>>2];k[n+12>>2]=k[f+12>>2];k[n+16>>2]=k[f+16>>2];k[n+20>>2]=k[f+20>>2];k[n+24>>2]=k[f+24>>2];k[n+28>>2]=k[f+28>>2];k[n+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[n+36>>2]=d;e=n+40|0;k[e>>2]=m;m=n+48|0;h=n+44|0;k[h>>2]=m;k[n+52>>2]=0;k[m>>2]=0;if(d|0){m=d+12|0;k[m>>2]=(k[m>>2]|0)+1}if((k[c>>2]|0)<3){j=k[f+44>>2]|0;m=k[h>>2]|0;k[m>>2]=k[j>>2];k[m+4>>2]=k[j+4>>2];break}k[j>>2]=0;x1(n,k[c>>2]|0,0,0,0);if((k[j>>2]|0)>0){i=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;c=0;do{k[g+(c<<2)>>2]=k[i+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[j>>2]|0))}}else Q1(n,c,-1);while(0);KG(l,n)|0;e=n+36|0;c=k[e>>2]|0;if(c|0?(l=c+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[n+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;m=n+16|0;d=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[d>>2]|0)>0){e=k[n+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[n+44>>2]|0;if(!((c|0)==(n+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);if((b|0)>0){d=k[a+20>>2]|0;e=k[a+48>>2]|0;c=0;do{m=d+(aa(k[e>>2]|0,c)|0)|0;k[m>>2]=2147483647;k[m+4>>2]=2147483647;k[m+8>>2]=-2147483648;k[m+12>>2]=-2147483648;k[m+16>>2]=0;c=c+1|0}while((c|0)!=(b|0))}l=a+120|0;m=a+124|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;c=k[m>>2]|0;f=k[l>>2]|0;g=c-f>>4;d=f;e=c;if(g>>>0>=b>>>0){if(g>>>0<=b>>>0){r=o;return}c=d+(b<<4)|0;if((e|0)==(c|0)){r=o;return}k[m>>2]=e+(~((e+-16-c|0)>>>4)<<4);r=o;return}d=b-g|0;j=a+128|0;e=k[j>>2]|0;if(e-c>>4>>>0>=d>>>0){do{k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];k[c+12>>2]=k[n+12>>2];c=(k[m>>2]|0)+16|0;k[m>>2]=c;d=d+-1|0}while((d|0)!=0);r=o;return}if(b>>>0>268435455)ad(426534,426557,304,426811);a=e-f|0;i=a>>3;i=a>>4>>>0<134217727?(i>>>0<b>>>0?b:i):268435455;if(!i)c=0;else{if(i>>>0>268435455){o=te(4)|0;k[o>>2]=172664;Cf(o|0,28816,1287)}e=i<<4;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}h=c+(g<<4)|0;e=h;g=h;do{k[e>>2]=k[n>>2];k[e+4>>2]=k[n+4>>2];k[e+8>>2]=k[n+8>>2];k[e+12>>2]=k[n+12>>2];e=g+16|0;g=e;d=d+-1|0}while((d|0)!=0);e=k[l>>2]|0;f=(k[m>>2]|0)-e|0;d=h+(0-(f>>4)<<4)|0;if((f|0)>0)upb(d|0,e|0,f|0)|0;k[l>>2]=d;k[m>>2]=g;k[j>>2]=c+(i<<4);if(!e){r=o;return}ggb(e);r=o;return}function Fea(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;d=h;if((a|0)==0?(g=d+4|0,b=ZT(8)|0,k[b>>2]=1,f=b+4|0,k[d>>2]=f,k[g>>2]=0,i[f>>0]=0,Y8(-27,d,243169,242941,1254),k[g>>2]=0,k[d>>2]=0,g=k[b>>2]|0,k[b>>2]=g+-1,(g|0)==1):0)ggb(k[b+-4>>2]|0);g=k[a>>2]|0;if(!g){a=0;r=h;return a|0}e=g+88|0;f=k[e>>2]|0;if(f|0){b=g+248|0;if(k[b>>2]|0){c=g+4|0;DY(k[c>>2]|0,d);if((k[d>>2]|0)==(k[g+32>>2]|0)?(k[d+4>>2]|0)==(k[g+36>>2]|0):0)EY(k[c>>2]|0,g+24|0);k[b>>2]=0}b=k[f+12>>2]|0;if(b|0)aZ(b,k[(k[f+8>>2]|0)+12>>2]|0,g+180|0);k[e>>2]=0}if((k[g>>2]|0)!=(k[g+4>>2]|0))BY(g);b=g+8|0;if(k[b>>2]|0)BY(b);b=k[g+200>>2]|0;c=k[a>>2]|0;if(c|0)ggb(k[c+-4>>2]|0);k[a>>2]=0;a=b;r=h;return a|0}function Gea(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0.0,be=0.0,ce=0.0,de=0.0;$d=r;r=r+1440|0;Xd=$d+1376|0;Yd=$d+184|0;Zd=$d+120|0;_d=$d+60|0;Wd=$d+32|0;Z=$d+4|0;Td=$d;k[Td>>2]=0;if(!c){h=Xd+4|0;j=ZT(32)|0;k[j>>2]=1;B=j+4|0;k[Xd>>2]=B;k[h>>2]=25;i[j+29>>0]=0;A=243187;C=B+25|0;do{i[B>>0]=i[A>>0]|0;B=B+1|0;A=A+1|0}while((B|0)<(C|0));Y8(-27,Xd,243213,242941,1666);k[h>>2]=0;k[Xd>>2]=0;Sd=k[j>>2]|0;k[j>>2]=Sd+-1;if((Sd|0)==1)ggb(k[j+-4>>2]|0)}k[c>>2]=0;if((e|0)==5){if(f|g|0){h=Xd+4|0;j=ZT(56)|0;k[j>>2]=1;B=j+4|0;k[Xd>>2]=B;k[h>>2]=51;i[j+55>>0]=0;A=243228;C=B+51|0;do{i[B>>0]=i[A>>0]|0;B=B+1|0;A=A+1|0}while((B|0)<(C|0));Y8(-211,Xd,243213,242941,1674);k[h>>2]=0;k[Xd>>2]=0;Vd=k[j>>2]|0;k[j>>2]=Vd+-1;if((Vd|0)==1)ggb(k[j+-4>>2]|0)}if(!b){k[Wd>>2]=0;h=Wd+4|0;k[h>>2]=0;j=ZT(28)|0;k[j>>2]=1;B=j+4|0;k[Wd>>2]=B;k[h>>2]=20;i[j+24>>0]=0;A=243280;C=B+20|0;do{i[B>>0]=i[A>>0]|0;B=B+1|0;A=A+1|0}while((B|0)<(C|0));Y8(-27,Wd,243301,242941,1335);k[h>>2]=0;k[Wd>>2]=0;Vd=k[j>>2]|0;k[j>>2]=Vd+-1;if((Vd|0)==1)ggb(k[j+-4>>2]|0)}Y=(c|0)!=0;if(!Y){k[Wd>>2]=0;h=Wd+4|0;k[h>>2]=0;j=ZT(32)|0;k[j>>2]=1;B=j+4|0;k[Wd>>2]=B;k[h>>2]=25;i[j+29>>0]=0;A=243187;C=B+25|0;do{i[B>>0]=i[A>>0]|0;B=B+1|0;A=A+1|0}while((B|0)<(C|0));Y8(-27,Wd,243301,242941,1338);k[h>>2]=0;k[Wd>>2]=0;Vd=k[j>>2]|0;k[j>>2]=Vd+-1;if((Vd|0)==1)ggb(k[j+-4>>2]|0)}n=AY(b)|0;if(!n)X=0;else{while(1){h=fgb(16)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[h+4>>2]=1;k[h>>2]=63124;k[h+8>>2]=n;X=h}d=AY(b)|0;if(!d)W=0;else{while(1){h=fgb(16)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[h+4>>2]=1;k[h>>2]=63124;k[h+8>>2]=d;W=h}m=G9(a,Wd,0,0)|0;if(k[m>>2]&4094|0){k[Z>>2]=0;h=Z+4|0;k[h>>2]=0;j=ZT(40)|0;k[j>>2]=1;B=j+4|0;k[Z>>2]=B;k[h>>2]=32;i[j+36>>0]=0;A=243327;C=B+32|0;do{i[B>>0]=i[A>>0]|0;B=B+1|0;A=A+1|0}while((B|0)<(C|0));Y8(-5,Z,243301,242941,1350);k[h>>2]=0;k[Z>>2]=0;Wd=k[j>>2]|0;k[j>>2]=Wd+-1;if((Wd|0)==1)ggb(k[j+-4>>2]|0)}t=k[m+16>>2]|0;I=k[m+4>>2]|0;H=k[m+20>>2]|0;G=k[m+24>>2]|0;s=HY(0,56,16,n)|0;NY(s,Zd);OY(0,56,4,d,Xd);OY(0,56,4,d,Yd);U=Zd+12|0;h=k[U>>2]|0;V=Zd+20|0;if(h>>>0>=(k[V>>2]|0)>>>0){PY(Zd);h=k[U>>2]|0}B=h;C=B+16|0;do{i[B>>0]=0;B=B+1|0}while((B|0)<(C|0));j=(k[U>>2]|0)+16|0;k[U>>2]=j;T=Zd+4|0;h=k[T>>2]|0;q=j+(0-(k[h+28>>2]|0))|0;F=(G|0)>0;if(F){a=Xd+12|0;p=Xd+20|0;j=0;h=q;do{a:do if((j|0)<(G|0))do{if(i[t+j>>0]|0)break a;j=j+1|0}while((j|0)<(G|0));while(0);if((j|0)==(G|0))break;m=k[U>>2]|0;if(m>>>0>=(k[V>>2]|0)>>>0){PY(Zd);m=k[U>>2]|0}i[m>>0]=0;i[m+1>>0]=0;i[m+2>>0]=0;i[m+3>>0]=0;d=m+4|0;i[d>>0]=0;i[d+1>>0]=0;i[d+2>>0]=0;i[d+3>>0]=0;d=m+8|0;i[d>>0]=j;i[d+1>>0]=j>>8;i[d+2>>0]=j>>16;i[d+3>>0]=j>>24;d=m+12|0;i[d>>0]=0;i[d+1>>0]=0;i[d+2>>0]=0;i[d+3>>0]=0;d=(k[U>>2]|0)+16|0;k[U>>2]=d;n=d+(0-(k[(k[T>>2]|0)+28>>2]|0))|0;k[h+4>>2]=n;b:do if((j|0)<(G|0))do{if(!(i[t+j>>0]|0))break b;j=j+1|0}while((j|0)<(G|0));while(0);m=j+-1|0;if(d>>>0<(k[V>>2]|0)>>>0)h=d;else{PY(Zd);h=k[U>>2]|0}i[h>>0]=0;i[h+1>>0]=0;i[h+2>>0]=0;i[h+3>>0]=0;Wd=h+4|0;i[Wd>>0]=0;i[Wd+1>>0]=0;i[Wd+2>>0]=0;i[Wd+3>>0]=0;Wd=h+8|0;i[Wd>>0]=m;i[Wd+1>>0]=m>>8;i[Wd+2>>0]=m>>16;i[Wd+3>>0]=m>>24;h=h+12|0;i[h>>0]=0;i[h+1>>0]=0;i[h+2>>0]=0;i[h+3>>0]=0;h=(k[U>>2]|0)+16|0;k[U>>2]=h;h=h+(0-(k[(k[T>>2]|0)+28>>2]|0))|0;m=n+4|0;k[m>>2]=h;k[n>>2]=h;h=k[a>>2]|0;if(h>>>0>=(k[p>>2]|0)>>>0){PY(Xd);h=k[a>>2]|0}i[h>>0]=n;i[h+1>>0]=n>>8;i[h+2>>0]=n>>16;i[h+3>>0]=n>>24;k[a>>2]=(k[a>>2]|0)+4;h=k[m>>2]|0}while((j|0)<(G|0));a=h;E=U;h=k[T>>2]|0;j=k[U>>2]|0}else{a=q;E=U}k[h+36>>2]=j;N=Zd+8|0;m=k[N>>2]|0;if(m|0){d=k[h+52>>2]|0;k[m+12>>2]=(j-(k[m+16>>2]|0)|0)/(k[h+28>>2]|0)|0;j=d;m=0;do{m=(k[j+12>>2]|0)+m|0;j=k[j+4>>2]|0}while((j|0)!=(d|0));k[h+24>>2]=m}j=k[q+4>>2]|0;z=s+24|0;m=k[z>>2]|0;h=m+-1|0;k[a+4>>2]=0;c:do if((H|0)>1){A=Xd+12|0;B=Xd+20|0;C=Yd+12|0;D=Yd+20|0;y=1;s=0;n=t;q=a;t=m;while(1){e=n+I|0;d:do if(F){n=q;m=0;while(1){e:do if((m|0)<(G|0))do{if(i[e+m>>0]|0)break e;m=m+1|0}while((m|0)<(G|0));while(0);if((m|0)==(G|0)){d=n;break d}d=k[U>>2]|0;if(d>>>0>=(k[V>>2]|0)>>>0){PY(Zd);d=k[U>>2]|0}i[d>>0]=0;i[d+1>>0]=0;i[d+2>>0]=0;i[d+3>>0]=0;a=d+4|0;i[a>>0]=0;i[a+1>>0]=0;i[a+2>>0]=0;i[a+3>>0]=0;a=d+8|0;i[a>>0]=m;i[a+1>>0]=m>>8;i[a+2>>0]=m>>16;i[a+3>>0]=m>>24;d=d+12|0;i[d>>0]=y;i[d+1>>0]=y>>8;i[d+2>>0]=y>>16;i[d+3>>0]=y>>24;d=(k[U>>2]|0)+16|0;k[U>>2]=d;a=d+(0-(k[(k[T>>2]|0)+28>>2]|0))|0;k[n+4>>2]=a;f:do if((m|0)<(G|0))do{if(!(i[e+m>>0]|0))break f;m=m+1|0}while((m|0)<(G|0));while(0);n=m+-1|0;if(d>>>0>=(k[V>>2]|0)>>>0){PY(Zd);d=k[U>>2]|0}i[d>>0]=0;i[d+1>>0]=0;i[d+2>>0]=0;i[d+3>>0]=0;Wd=d+4|0;i[Wd>>0]=0;i[Wd+1>>0]=0;i[Wd+2>>0]=0;i[Wd+3>>0]=0;Wd=d+8|0;i[Wd>>0]=n;i[Wd+1>>0]=n>>8;i[Wd+2>>0]=n>>16;i[Wd+3>>0]=n>>24;d=d+12|0;i[d>>0]=y;i[d+1>>0]=y>>8;i[d+2>>0]=y>>16;i[d+3>>0]=y>>24;d=(k[U>>2]|0)+16|0;k[U>>2]=d;d=d+(0-(k[(k[T>>2]|0)+28>>2]|0))|0;k[a+4>>2]=d;if((m|0)<(G|0))n=d;else break}}else d=q;while(0);a=k[T>>2]|0;m=k[E>>2]|0;k[a+36>>2]=m;n=k[N>>2]|0;if(n|0){p=k[a+52>>2]|0;k[n+12>>2]=(m-(k[n+16>>2]|0)|0)/(k[a+28>>2]|0)|0;m=p;n=0;do{n=(k[m+12>>2]|0)+n|0;m=k[m+4>>2]|0}while((m|0)!=(p|0));k[a+24>>2]=n}g=k[q+4>>2]|0;x=(k[z>>2]|0)-t|0;k[d+4>>2]=0;f=(h|0)/2|0;w=(x|0)/2|0;g:do if((h|0)>1&(x|0)>1){n=0;t=g;v=0;h=0;a=s;while(1){h:do switch(h|0){case 0:{q=k[j+4>>2]|0;h=k[q+8>>2]|0;s=t+4|0;p=k[s>>2]|0;m=k[p+8>>2]|0;if((h|0)<(m|0)){if((h|0)<((k[t+8>>2]|0)+-1|0)){k[q>>2]=j;h=0}else{k[t>>2]=j;h=1;a=q}n=n+1|0;s=t;j=k[q+4>>2]|0;m=v;break h}if((k[j+8>>2]|0)>(m+1|0)){k[t>>2]=p;h=k[A>>2]|0;if(h>>>0>=(k[B>>2]|0)>>>0){PY(Xd);h=k[A>>2]|0}i[h>>0]=t;i[h+1>>0]=t>>8;i[h+2>>0]=t>>16;i[h+3>>0]=t>>24;k[A>>2]=(k[A>>2]|0)+4;h=0;m=k[s>>2]|0}else{k[t>>2]=j;h=-1;a=p;m=p}s=k[m+4>>2]|0;m=v+1|0;break}case 1:{p=k[t+4>>2]|0;h=k[p+8>>2]|0;if((k[j+8>>2]|0)>(h+1|0)){k[a>>2]=p;s=k[p+4>>2]|0;m=v+1|0;h=0;break h}k[a>>2]=j;a=k[j+4>>2]|0;if((k[a+8>>2]|0)<(h|0)){n=n+1|0;s=t;j=k[a+4>>2]|0;m=v;h=1;break h}else{s=k[p+4>>2]|0;m=v+1|0;h=-1;a=p;break h}}case -1:{m=j+4|0;h=k[m>>2]|0;if((k[t+8>>2]|0)>((k[h+8>>2]|0)+1|0)){k[h>>2]=a;n=n+1|0;s=t;j=k[h+4>>2]|0;m=v;h=0;break h}h=k[C>>2]|0;if(h>>>0>=(k[D>>2]|0)>>>0){PY(Yd);h=k[C>>2]|0}i[h>>0]=t;i[h+1>>0]=t>>8;i[h+2>>0]=t>>16;i[h+3>>0]=t>>24;k[C>>2]=(k[C>>2]|0)+4;k[t>>2]=a;a=k[t+4>>2]|0;p=k[m>>2]|0;if((k[a+8>>2]|0)<(k[p+8>>2]|0)){s=k[a+4>>2]|0;m=v+1|0;h=-1;break h}else{n=n+1|0;s=t;j=k[p+4>>2]|0;m=v;h=1;a=p;break h}}default:{s=t;m=v}}while(0);if((m|0)<(w|0)&(n|0)<(f|0)){t=s;v=m}else{p=s;s=a;break g}}}else{n=0;p=g;m=0;h=0}while(0);if((m|0)<(w|0)){q=m;while(1){a=p+4|0;m=k[a>>2]|0;if(!h){k[p>>2]=m;h=k[A>>2]|0;if(h>>>0>=(k[B>>2]|0)>>>0){PY(Xd);h=k[A>>2]|0}i[h>>0]=p;i[h+1>>0]=p>>8;i[h+2>>0]=p>>16;i[h+3>>0]=p>>24;k[A>>2]=(k[A>>2]|0)+4;h=k[a>>2]|0}else{k[s>>2]=m;h=m}q=q+1|0;if((q|0)>=(w|0)){h=0;break}else{p=k[h+4>>2]|0;h=0}}}if((n|0)<(f|0))while(1){m=k[j+4>>2]|0;k[m>>2]=(h|0)==0?j:s;n=n+1|0;if((n|0)==(f|0))break;else{j=k[m+4>>2]|0;h=0}}h=y+1|0;if((h|0)>=(H|0)){j=g;h=x;break c}y=h;j=g;n=e;h=x;q=d;t=k[z>>2]|0}}while(0);d=(h|0)/2|0;if((h|0)>1){m=0;h=j;while(1){j=k[h+4>>2]|0;k[j>>2]=h;m=m+1|0;if((m|0)>=(d|0))break;else h=k[j+4>>2]|0}}z=k[Xd+4>>2]|0;n=Xd+12|0;a=k[n>>2]|0;k[z+36>>2]=a;h=k[Xd+8>>2]|0;m=(h|0)==0;if(!m){d=k[z+52>>2]|0;k[h+12>>2]=(a-(k[h+16>>2]|0)|0)/(k[z+28>>2]|0)|0;h=d;j=0;do{j=(k[h+12>>2]|0)+j|0;h=k[h+4>>2]|0}while((h|0)!=(d|0));k[z+24>>2]=j;if((!m?(J=k[z+44>>2]|0,J|0):0)?(K=(k[J+8>>2]|0)+(k[J+16>>2]|0)|0,L=J+20|0,M=z+32|0,(K+(0-(k[L>>2]|0))-(k[M>>2]|0)|0)>>>0<8):0){k[L>>2]=K-a&-8;k[M>>2]=a}}k[n>>2]=0;y=k[Yd+4>>2]|0;n=Yd+12|0;a=k[n>>2]|0;k[y+36>>2]=a;h=k[Yd+8>>2]|0;m=(h|0)==0;if(!m){d=k[y+52>>2]|0;k[h+12>>2]=(a-(k[h+16>>2]|0)|0)/(k[y+28>>2]|0)|0;h=d;j=0;do{j=(k[h+12>>2]|0)+j|0;h=k[h+4>>2]|0}while((h|0)!=(d|0));k[y+24>>2]=j;if((!m?(O=k[y+44>>2]|0,O|0):0)?(P=(k[O+8>>2]|0)+(k[O+16>>2]|0)|0,R=O+20|0,S=y+32|0,(P+(0-(k[R>>2]|0))-(k[S>>2]|0)|0)>>>0<8):0){k[R>>2]=P-a&-8;k[S>>2]=a}}k[n>>2]=0;f=_d+12|0;g=_d+20|0;x=_d+8|0;w=_d+4|0;e=_d+16|0;m=0;h=0;v=0;do{j=(v|0)==0;t=j?z:y;KY(t,_d);t=t+24|0;if((k[t>>2]|0)>0)if(j){s=0;do{Yd=k[f>>2]|0;d=l[Yd>>0]|l[Yd+1>>0]<<8|l[Yd+2>>0]<<16|l[Yd+3>>0]<<24;Yd=Yd+4|0;k[f>>2]=Yd;if(Yd>>>0>=(k[g>>2]|0)>>>0){Yd=k[(k[x>>2]|0)+4>>2]|0;k[x>>2]=Yd;Wd=k[Yd+16>>2]|0;k[f>>2]=Wd;Xd=k[(k[w>>2]|0)+28>>2]|0;Yd=k[Yd+12>>2]|0;k[e>>2]=Wd;Yd=Wd+(aa(Xd,Yd)|0)|0;k[g>>2]=Yd}do if(k[d>>2]|0){OY(20492,88,8,b,Zd);n=d;j=k[U>>2]|0;do{if(j>>>0>=(k[V>>2]|0)>>>0){PY(Zd);j=k[U>>2]|0}q=n+8|0;Xd=q;Xd=l[Xd>>0]|l[Xd+1>>0]<<8|l[Xd+2>>0]<<16|l[Xd+3>>0]<<24;q=q+4|0;q=l[q>>0]|l[q+1>>0]<<8|l[q+2>>0]<<16|l[q+3>>0]<<24;Yd=j;i[Yd>>0]=Xd;i[Yd+1>>0]=Xd>>8;i[Yd+2>>0]=Xd>>16;i[Yd+3>>0]=Xd>>24;j=j+4|0;i[j>>0]=q;i[j+1>>0]=q>>8;i[j+2>>0]=q>>16;i[j+3>>0]=q>>24;j=(k[U>>2]|0)+8|0;k[U>>2]=j;q=n;n=k[n>>2]|0;k[q>>2]=0;q=j}while((n|0)!=(d|0));p=k[T>>2]|0;k[p+36>>2]=q;j=k[N>>2]|0;n=(j|0)==0;do if(!n){a=k[p+52>>2]|0;k[j+12>>2]=(q-(k[j+16>>2]|0)|0)/(k[p+28>>2]|0)|0;j=a;d=0;do{d=(k[j+12>>2]|0)+d|0;j=k[j+4>>2]|0}while((j|0)!=(a|0));k[p+24>>2]=d;if(n)break;j=k[p+44>>2]|0;if(!j)break;n=(k[j+8>>2]|0)+(k[j+16>>2]|0)|0;j=j+20|0;d=p+32|0;if((n+(0-(k[j>>2]|0))-(k[d>>2]|0)|0)>>>0>=8)break;k[j>>2]=n-q&-8;k[d>>2]=q}while(0);k[U>>2]=0;csa(Z,p);if(!m){m=p;h=p;break}k[p+8>>2]=h;k[h+12>>2]=p;h=p}while(0);s=s+1|0}while((s|0)<(k[t>>2]|0))}else{s=0;do{Yd=k[f>>2]|0;d=l[Yd>>0]|l[Yd+1>>0]<<8|l[Yd+2>>0]<<16|l[Yd+3>>0]<<24;Yd=Yd+4|0;k[f>>2]=Yd;if(Yd>>>0>=(k[g>>2]|0)>>>0){Yd=k[(k[x>>2]|0)+4>>2]|0;k[x>>2]=Yd;Wd=k[Yd+16>>2]|0;k[f>>2]=Wd;Xd=k[(k[w>>2]|0)+28>>2]|0;Yd=k[Yd+12>>2]|0;k[e>>2]=Wd;Yd=Wd+(aa(Xd,Yd)|0)|0;k[g>>2]=Yd}do if(k[d>>2]|0){OY(20492,88,8,b,Zd);n=d;j=k[U>>2]|0;do{if(j>>>0>=(k[V>>2]|0)>>>0){PY(Zd);j=k[U>>2]|0}q=n+8|0;Xd=q;Xd=l[Xd>>0]|l[Xd+1>>0]<<8|l[Xd+2>>0]<<16|l[Xd+3>>0]<<24;q=q+4|0;q=l[q>>0]|l[q+1>>0]<<8|l[q+2>>0]<<16|l[q+3>>0]<<24;Yd=j;i[Yd>>0]=Xd;i[Yd+1>>0]=Xd>>8;i[Yd+2>>0]=Xd>>16;i[Yd+3>>0]=Xd>>24;j=j+4|0;i[j>>0]=q;i[j+1>>0]=q>>8;i[j+2>>0]=q>>16;i[j+3>>0]=q>>24;j=(k[U>>2]|0)+8|0;k[U>>2]=j;q=n;n=k[n>>2]|0;k[q>>2]=0;q=j}while((n|0)!=(d|0));p=k[T>>2]|0;k[p+36>>2]=q;j=k[N>>2]|0;n=(j|0)==0;do if(!n){a=k[p+52>>2]|0;k[j+12>>2]=(q-(k[j+16>>2]|0)|0)/(k[p+28>>2]|0)|0;j=a;d=0;do{d=(k[j+12>>2]|0)+d|0;j=k[j+4>>2]|0}while((j|0)!=(a|0));k[p+24>>2]=d;if(n)break;j=k[p+44>>2]|0;if(!j)break;n=(k[j+8>>2]|0)+(k[j+16>>2]|0)|0;j=j+20|0;d=p+32|0;if((n+(0-(k[j>>2]|0))-(k[d>>2]|0)|0)>>>0>=8)break;k[j>>2]=n-q&-8;k[d>>2]=q}while(0);k[U>>2]=0;csa(Z,p);k[p>>2]=k[p>>2]|32768;if(!m){m=p;h=p;break}k[p+8>>2]=h;k[h+12>>2]=p;h=p}while(0);s=s+1|0}while((s|0)<(k[t>>2]|0))}v=v+1|0}while((v|0)<2);if(Y)k[c>>2]=m;h=W;if(W|0?(Zd=h+4|0,_d=k[Zd>>2]|0,k[Zd>>2]=_d+-1,(_d|0)==1):0)Uh[k[(k[W>>2]|0)+8>>2]&2047](h);h=X;if(!X){r=$d;return}Zd=h+4|0;_d=k[Zd>>2]|0;k[Zd>>2]=_d+-1;if((_d|0)!=1){r=$d;return}Uh[k[(k[X>>2]|0)+8>>2]&2047](h);r=$d;return}if((b|0)==0?(k[Xd>>2]=0,Sd=Xd+4|0,k[Sd>>2]=0,m=ZT(8)|0,k[m>>2]=1,Rd=m+4|0,k[Xd>>2]=Rd,k[Sd>>2]=0,i[Rd>>0]=0,Y8(-27,Xd,243011,242941,187),k[Sd>>2]=0,k[Xd>>2]=0,Sd=k[m>>2]|0,k[m>>2]=Sd+-1,(Sd|0)==1):0)ggb(k[m+-4>>2]|0);x=G9(a,Z,0,0)|0;Rd=k[x>>2]|0;Sd=(Rd&4095|0)==4;w=(d|0)==2&Sd?4:d;if(!((Rd&4094|0)==0&(w|0)<4|Sd&(w|0)==4)){k[Xd>>2]=0;h=Xd+4|0;k[h>>2]=0;j=ZT(124)|0;k[j>>2]=1;B=j+4|0;k[Xd>>2]=B;k[h>>2]=119;i[j+123>>0]=0;A=243031;C=B+119|0;do{i[B>>0]=i[A>>0]|0;B=B+1|0;A=A+1|0}while((B|0)<(C|0));Y8(-210,Xd,243011,242941,198);k[h>>2]=0;k[Xd>>2]=0;Sd=k[j>>2]|0;k[j>>2]=Sd+-1;if((Sd|0)==1)ggb(k[j+-4>>2]|0)}q=k[x+24>>2]|0;j=k[x+20>>2]|0;v=k[x+4>>2]|0;s=k[x+16>>2]|0;if(e>>>0>4?(k[Xd>>2]=0,Sd=Xd+4|0,k[Sd>>2]=0,n=ZT(8)|0,k[n>>2]=1,Rd=n+4|0,k[Xd>>2]=Rd,k[Sd>>2]=0,i[Rd>>0]=0,Y8(-211,Xd,243011,242941,205),k[Sd>>2]=0,k[Xd>>2]=0,Sd=k[n>>2]|0,k[n>>2]=Sd+-1,(Sd|0)==1):0)ggb(k[n+-4>>2]|0);n=(e|0)==0;z=ZT(788)|0;a=z+4|0;zpb(z+8|0,0,780)|0;k[a>>2]=b;k[z>>2]=b;k[z+40>>2]=s;h=s+v|0;k[z+44>>2]=h;k[z+48>>2]=v;p=q+-1|0;k[z+52>>2]=p;t=j+-1|0;k[z+56>>2]=t;k[z+244>>2]=w;Sd=z+60|0;k[Sd>>2]=f;k[Sd+4>>2]=g;k[z+72>>2]=1;k[z+68>>2]=1;k[z+76>>2]=0;k[z+80>>2]=1;k[z+84>>2]=2;Sd=z+180|0;k[z+148>>2]=Sd;k[z+176>>2]=1;k[z+140>>2]=0;k[z+144>>2]=0;Rd=z+152|0;k[Rd>>2]=0;k[Rd+4>>2]=0;k[z+160>>2]=q;k[z+164>>2]=j;k[z+88>>2]=0;k[z+248>>2]=0;k[Sd>>2]=32768;j=z+236|0;k[j>>2]=e;k[z+240>>2]=e;if((e+-3|0)>>>0>=2){j=z+252|0;if(n)Sd=191;else{k[j>>2]=20492;k[z+256>>2]=88;k[z+260>>2]=8;k[z+268>>2]=88;d=e;m=z+264|0;Sd=193}}else{k[j>>2]=0;j=z+252|0;Sd=191}if((Sd|0)==191){k[j>>2]=20480;k[z+256>>2]=n?88:64;k[z+260>>2]=1;k[z+268>>2]=88;m=z+264|0;if(n){k[m>>2]=20480;k[z+272>>2]=1;d=0}else{d=0;Sd=193}}if((Sd|0)==193){k[m>>2]=20492;k[z+272>>2]=8}k[j>>2]=(d|0)==0?20480:20492;k[m>>2]=n?20480:20492;DY(b,z+16|0);if((e|0)>2){Rd=AY(k[a>>2]|0)|0;k[z>>2]=Rd}if((w|0)>1){Rd=AY(k[a>>2]|0)|0;k[z+8>>2]=Rd;Rd=WY(0,64,44,Rd)|0;k[z+12>>2]=Rd}d=k[x>>2]|0;d=(d>>>3&511)+1<<(47696>>>(d<<1&14)&3);Rd=aa(d,q)|0;zpb(s|0,0,Rd|0)|0;zpb(s+(aa(v,t)|0)|0,0,Rd|0)|0;if((t|0)>1?(y=aa(d,p)|0,(d|0)>0):0){m=1;while(1){j=0;do{i[h+(j+y)>>0]=0;i[h+j>>0]=0;j=j+1|0}while((j|0)!=(d|0));m=m+1|0;if((m|0)==(t|0))break;else h=h+v|0}}if((k[x>>2]&4095|0)!=4){M1(Xd,x,0,1,0,0);M1(Yd,x,0,1,0,0);k[Zd>>2]=k[Yd>>2];t=Zd+4|0;e=Yd+4|0;h=k[e>>2]|0;k[t>>2]=h;w=Zd+8|0;k[w>>2]=k[Yd+8>>2];k[Zd+12>>2]=k[Yd+12>>2];p=Zd+16|0;g=Yd+16|0;k[p>>2]=k[g>>2];k[Zd+20>>2]=k[Yd+20>>2];k[Zd+24>>2]=k[Yd+24>>2];k[Zd+28>>2]=k[Yd+28>>2];a=Zd+32|0;f=Yd+32|0;k[a>>2]=k[f>>2];q=Zd+36|0;x=Yd+36|0;j=k[x>>2]|0;k[q>>2]=j;s=Zd+40|0;k[s>>2]=w;w=Zd+48|0;v=Zd+44|0;k[v>>2]=w;k[Zd+52>>2]=0;k[w>>2]=0;if(j){h=j+12|0;k[h>>2]=(k[h>>2]|0)+1;h=k[e>>2]|0}if((h|0)>=3){k[t>>2]=0;x1(Zd,h,0,0,0);if((k[t>>2]|0)>0){j=k[Yd+40>>2]|0;m=k[s>>2]|0;d=k[Yd+44>>2]|0;n=k[v>>2]|0;h=0;do{k[m+(h<<2)>>2]=k[j+(h<<2)>>2];k[n+(h<<2)>>2]=k[d+(h<<2)>>2];h=h+1|0}while((h|0)<(k[t>>2]|0))}}else{Qd=k[Yd+44>>2]|0;Rd=k[v>>2]|0;k[Rd>>2]=k[Qd>>2];k[Rd+4>>2]=k[Qd+4>>2]}y=Xd+40|0;j=k[y>>2]|0;m=k[j+-4>>2]|0;n=Yd+40|0;d=k[n>>2]|0;i:do if((m|0)==(k[d+-4>>2]|0)){if((m|0)==2){if((k[j>>2]|0)!=(k[d>>2]|0)){Sd=220;break}if((k[j+4>>2]|0)!=(k[d+4>>2]|0)){Sd=220;break}}else if((m|0)>0){h=0;do{if((k[j+(h<<2)>>2]|0)!=(k[d+(h<<2)>>2]|0)){Sd=220;break i}h=h+1|0}while((h|0)<(m|0))}h=k[Xd>>2]|0;j=k[Yd>>2]|0;if(!(((j^h)&4088|0)==0?(Rd=j&7,(h&7|0)==(Rd|0)|(Rd|0)==0):0))Sd=220}else Sd=220;while(0);if((Sd|0)==220){k[_d>>2]=0;h=_d+4|0;k[h>>2]=0;j=ZT(120)|0;k[j>>2]=1;B=j+4|0;k[_d>>2]=B;k[h>>2]=112;i[j+116>>0]=0;A=354258;C=B+112|0;do{i[B>>0]=i[A>>0]|0;B=B+1|0;A=A+1|0}while((B|0)<(C|0));Y8(-215,_d,354371,353955,1355);k[h>>2]=0;k[_d>>2]=0;Rd=k[j>>2]|0;k[j>>2]=Rd+-1;if((Rd|0)==1)ggb(k[j+-4>>2]|0)}k[_d+8>>2]=0;k[_d+12>>2]=0;k[_d>>2]=16842752;k[_d+4>>2]=Xd;Rd=Wd+4|0;Qd=Rd+4|0;k[Qd>>2]=0;k[Qd+4>>2]=0;k[Wd>>2]=33619968;k[Rd>>2]=Yd;+Yua(_d,Wd,0.0,1.0,0);if((k[p>>2]|0)!=(k[g>>2]|0)){Rd=_d+4|0;Qd=Rd+4|0;k[Qd>>2]=0;k[Qd+4>>2]=0;k[_d>>2]=33619968;k[Rd>>2]=Zd;SW(Yd,_d,k[Zd>>2]&7,1.0,0.0)}h=k[q>>2]|0;if(h|0?(Qd=h+12|0,Rd=k[Qd>>2]|0,k[Qd>>2]=Rd+-1,(Rd|0)==1):0){j=k[q>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[a>>2]|0;if(h|0)break;h=B1()|0;j=k[q>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[q>>2]=0}k[q>>2]=0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[t>>2]|0)>0){j=k[s>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[t>>2]|0))}h=k[v>>2]|0;if(!((h|0)==(w|0)|(h|0)==0))ggb(k[h+-4>>2]|0);h=k[x>>2]|0;do if(h|0){Qd=h+12|0;Rd=k[Qd>>2]|0;k[Qd>>2]=Rd+-1;if((Rd|0)!=1)break;j=k[x>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[f>>2]|0;if(h|0)break;h=B1()|0;j=k[x>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[x>>2]=0}while(0);k[x>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[e>>2]|0)>0){j=k[n>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[e>>2]|0))}h=k[Yd+44>>2]|0;if(!((h|0)==(Yd+48|0)|(h|0)==0))ggb(k[h+-4>>2]|0);m=Xd+36|0;h=k[m>>2]|0;do if(h|0){Qd=h+12|0;Rd=k[Qd>>2]|0;k[Qd>>2]=Rd+-1;if((Rd|0)!=1)break;j=k[m>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[Xd+32>>2]|0;if(h|0)break;h=B1()|0;j=k[m>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[m>>2]=0}while(0);k[m>>2]=0;Rd=Xd+16|0;m=Xd+4|0;k[Rd>>2]=0;k[Rd+4>>2]=0;k[Rd+8>>2]=0;k[Rd+12>>2]=0;if((k[m>>2]|0)>0){j=k[y>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[m>>2]|0))}h=k[Xd+44>>2]|0;if(!((h|0)==(Xd+48|0)|(h|0)==0))ggb(k[h+-4>>2]|0)}k[Td>>2]=z;Rd=Xd+4|0;Ia=Zd+4|0;Ja=Zd+8|0;Ka=Zd+12|0;La=Zd+16|0;Ma=Zd+20|0;Na=Zd+24|0;Oa=Zd+28|0;Pa=Zd+32|0;Qa=Xd+12|0;Ra=Xd+20|0;Sa=Xd+12|0;Ta=Xd+20|0;Ua=Xd+12|0;Va=Xd+20|0;Wa=Xd+4|0;Xa=Xd+8|0;Ya=Yd+8|0;Za=Yd+12|0;_a=Yd+28|0;$a=Yd+32|0;ab=Yd+48|0;bb=Yd+52|0;cb=Yd+68|0;db=Yd+72|0;eb=Yd+88|0;fb=Yd+92|0;gb=Yd+108|0;hb=Yd+112|0;ib=Yd+128|0;jb=Yd+132|0;kb=Yd+148|0;lb=Yd+152|0;mb=Yd+168|0;nb=Yd+172|0;ob=Yd+188|0;pb=Yd+192|0;qb=Yd+208|0;rb=Yd+212|0;sb=Yd+228|0;tb=Yd+232|0;ub=Yd+248|0;vb=Yd+252|0;wb=Yd+268|0;xb=Yd+272|0;yb=Yd+288|0;zb=Yd+292|0;Ab=Yd+308|0;Bb=Yd+312|0;Cb=Yd+328|0;Db=Yd+332|0;Eb=Yd+348|0;Fb=Yd+352|0;Gb=Yd+368|0;Hb=Yd+372|0;Ib=Yd+388|0;Jb=Yd+392|0;Kb=Yd+408|0;Lb=Yd+412|0;Mb=Yd+428|0;Nb=Yd+432|0;Ob=Yd+448|0;Pb=Yd+452|0;Qb=Yd+468|0;Rb=Yd+472|0;Sb=Yd+488|0;Tb=Yd+492|0;Ub=Yd+508|0;Vb=Yd+512|0;Wb=Yd+528|0;Xb=Yd+532|0;Yb=Yd+548|0;Zb=Yd+552|0;_b=Yd+568|0;$b=Yd+572|0;ac=Yd+588|0;bc=Yd+592|0;cc=Yd+608|0;dc=Yd+612|0;ec=Yd+628|0;fc=Yd+632|0;gc=Yd+648|0;hc=Yd+652|0;ic=Yd+668|0;jc=Yd+672|0;kc=Yd+688|0;lc=Yd+692|0;mc=Yd+708|0;nc=Yd+712|0;oc=Yd+728|0;pc=Yd+732|0;qc=Yd+748|0;rc=Yd+752|0;sc=Yd+768|0;tc=Yd+772|0;uc=Yd+788|0;vc=Yd+792|0;wc=Yd+808|0;xc=Yd+812|0;yc=Yd+828|0;zc=Yd+832|0;Ac=Yd+848|0;Bc=Yd+852|0;Cc=Yd+868|0;Dc=Yd+872|0;Ec=Yd+888|0;Fc=Yd+892|0;Gc=Yd+908|0;Hc=Yd+912|0;Ic=Yd+928|0;Jc=Yd+932|0;Kc=Yd+948|0;Lc=Yd+952|0;Mc=Yd+968|0;Nc=Yd+972|0;Oc=Yd+988|0;Pc=Yd+992|0;Qc=Yd+1008|0;Rc=Yd+1012|0;Sc=Yd+1028|0;Tc=Yd+1032|0;Uc=Yd+1048|0;Vc=Yd+1052|0;Wc=Yd+1068|0;Xc=Yd+1072|0;Yc=Yd+1088|0;Zc=Yd+1092|0;_c=Yd+1108|0;$c=Yd+1112|0;ad=Yd+1128|0;bd=Yd+1132|0;cd=Yd+1148|0;dd=Yd+1152|0;ed=Yd+1168|0;fd=Yd+1172|0;gd=Yd+4|0;hd=Zd+4|0;id=_d+36|0;jd=_d+40|0;kd=Xd+4|0;ld=Wd+12|0;md=Wd+20|0;nd=Wd+4|0;od=Wd+8|0;pd=Xd+4|0;qd=_d+36|0;rd=_d+44|0;sd=_d+45|0;td=_d+46|0;ud=_d+47|0;vd=_d+48|0;wd=_d+49|0;xd=_d+53|0;yd=_d+54|0;zd=_d+55|0;Ad=_d+56|0;Bd=_d+57|0;Cd=_d+58|0;Dd=_d+59|0;Ed=Zd+16|0;Fd=_d+28|0;Gd=_d+12|0;Hd=_d+32|0;Id=_d+20|0;Jd=_d+8|0;Ha=_d+4|0;Kd=_d+16|0;Ld=Xd+4|0;Md=Xd+4|0;Nd=Xd+8|0;Od=Xd+4|0;Pd=Xd+8|0;Qd=Xd+4|0;Fa=z;j:while(1){if((Fa|0)==0?(k[Xd>>2]=0,k[Rd>>2]=0,Ud=ZT(8)|0,k[Ud>>2]=1,Ga=Ud+4|0,k[Xd>>2]=Ga,k[Rd>>2]=0,i[Ga>>0]=0,Y8(-27,Xd,243151,242941,992),k[Rd>>2]=0,k[Xd>>2]=0,Ga=k[Ud>>2]|0,k[Ud>>2]=Ga+-1,(Ga|0)==1):0)ggb(k[Ud+-4>>2]|0);Ga=Fa+88|0;m=k[Ga>>2]|0;if(m|0){h=Fa+248|0;if(k[h>>2]|0){j=Fa+4|0;DY(k[j>>2]|0,Xd);if((k[Xd>>2]|0)==(k[Fa+32>>2]|0)?(k[Qd>>2]|0)==(k[Fa+36>>2]|0):0)EY(k[j>>2]|0,Fa+24|0);k[h>>2]=0}h=k[m+12>>2]|0;if(h|0)aZ(h,k[(k[m+8>>2]|0)+12>>2]|0,Fa+180|0);k[Ga>>2]=0}ua=k[Fa+40>>2]|0;va=Fa+44|0;m=k[va>>2]|0;wa=k[Fa+48>>2]|0;xa=wa>>>2;ya=Fa+68|0;d=k[ya>>2]|0;za=Fa+72|0;n=k[za>>2]|0;Aa=k[Fa+52>>2]|0;Ba=k[Fa+56>>2]|0;Ca=k[Fa+244>>2]|0;sa=Fa+76|0;ta=Fa+80|0;Da=Fa+84|0;h=d+-1|0;Ea=(Ca|0)==4;if(Ea){ra=-1073741824;h=k[m+(h<<2)>>2]|0}else{ra=-2;h=i[m+h>>0]|0}if((n|0)>=(Ba|0))break;S=~ra;T=(Ca|0)==0;U=Fa+136|0;V=Fa+4|0;W=Fa+24|0;X=Fa+252|0;Y=Fa+256|0;Z=Fa+260|0;b=Fa+92|0;_=Fa+60|0;$=Fa+64|0;ba=Fa+236|0;ca=0-wa|0;da=1-wa|0;ea=~wa;fa=wa+-1|0;ga=wa+1|0;ha=Fa+240|0;ia=Fa+268|0;ja=Fa+12|0;ka=0-xa|0;la=1-xa|0;ma=~xa;na=xa+-1|0;oa=xa+1|0;pa=(Ca|0)<2;R=Ea?ua:0;qa=(R|0)!=0;j=k[Da>>2]|0;P=n;a=k[sa>>2]|0;L=k[ta>>2]|0;k:while(1){K=Ea?m:0;l:do if((d|0)<(Aa|0)){M=(K|0)!=0;N=aa(L,wa)|0;O=aa(L,xa)|0;n=0;q=a;while(1){a=(d|0)<(Aa|0);m:do if(M){if(!a){J=d;break}while(1){a=k[K+(d<<2)>>2]|0;if((a|0)!=(h|0)?(a^h)&S|0:0){n=a;J=d;break m}d=d+1|0;if((d|0)<(Aa|0))h=a;else{n=a;h=a;J=d;break}}}else{if(!a){J=d;break}while(1){n=i[m+d>>0]|0;if((n|0)!=(h|0)){J=d;break m}d=d+1|0;if((d|0)>=(Aa|0)){n=h;J=d;break}}}while(0);if((J|0)>=(Aa|0))break l;do if(M){d=h&ra;if(((h|0)==0|(d|0)!=0)&(n&ra|0)==0){I=0;a=q;Sd=301;break}if(!((n|h)&ra)){h=d;Sd=300}else{p=n;a=q}}else{if((h|0)==0&(n|0)==1){I=0;a=q;Sd=301;break}if((h|0)<1|(n|0)!=0){p=n;a=q;break}h=h&ra;Sd=300}while(0);if((Sd|0)==300){I=1;a=(h|0)==0?q:J+-1|0;Sd=301}n:do if((Sd|0)==301){Sd=0;o:do if(T){if(I|0){p=n;break n}if((i[ua+(a+N)>>0]|0)>0){p=n;break n}else{h=U;a=J;d=1}}else{e=J-I|0;if(pa){h=U;a=e;d=1;break}if(!I)switch(Ca|0){case 2:case 4:{h=U;a=e;d=0;break o}default:{}}if((a|0)<1){h=U;a=e;d=0;break}if(qa)h=k[R+(a+O<<2)>>2]|0;else h=i[ua+(a+N)>>0]|0;g=K+(a<<2)|0;x=m+a|0;f=k[Fa+276+((h&127)<<2)>>2]|0;h=0;p:do{do if((a-(k[f+16>>2]|0)|0)>>>0<(k[f+24>>2]|0)>>>0){if((L-(k[f+20>>2]|0)|0)>>>0>=(k[f+28>>2]|0)>>>0)break;if(!h){h=f;break}d=k[h+36>>2]|0;if(qa){d=R+((aa(d,xa)|0)<<2)|0;d=d+(k[h+32>>2]<<2)|0;q=k[h+40>>2]|0;v=k[d>>2]&1073741823;k[Zd>>2]=1;k[Ia>>2]=la;k[Ja>>2]=ka;k[Ka>>2]=ma;k[La>>2]=-1;k[Ma>>2]=na;k[Na>>2]=xa;k[Oa>>2]=oa;k[Pa>>2]=k[Zd>>2];k[Pa+4>>2]=k[Zd+4>>2];k[Pa+8>>2]=k[Zd+8>>2];k[Pa+12>>2]=k[Zd+12>>2];k[Pa+16>>2]=k[Zd+16>>2];k[Pa+20>>2]=k[Zd+20>>2];k[Pa+24>>2]=k[Zd+24>>2];k[Pa+28>>2]=k[Zd+28>>2];q=q|0?0:4;p=q;do{p=p+7&7;w=d+(k[Zd+(p<<2)>>2]<<2)|0;s=(p|0)==(q|0)}while(!(s|(k[w>>2]&1073741823|0)==(v|0)));q:do if(!s){t=d;while(1){while(1){q=p+1|0;s=t+(k[Zd+(q<<2)>>2]<<2)|0;if((k[s>>2]&1073741823|0)==(v|0))break;else p=q}if((t|0)==(g|0)){Sd=322;break p}if((t|0)==(w|0)&(s|0)==(d|0)){d=w;break q}t=s;p=p+5&7}}while(0);if((d|0)==(g|0))break p;else{h=f;break}}else{d=ua+(aa(d,wa)|0)|0;d=d+(k[h+32>>2]|0)|0;q=k[h+40>>2]|0;k[Zd>>2]=1;k[Ia>>2]=da;k[Ja>>2]=ca;k[Ka>>2]=ea;k[La>>2]=-1;k[Ma>>2]=fa;k[Na>>2]=wa;k[Oa>>2]=ga;k[Pa>>2]=k[Zd>>2];k[Pa+4>>2]=k[Zd+4>>2];k[Pa+8>>2]=k[Zd+8>>2];k[Pa+12>>2]=k[Zd+12>>2];k[Pa+16>>2]=k[Zd+16>>2];k[Pa+20>>2]=k[Zd+20>>2];k[Pa+24>>2]=k[Zd+24>>2];k[Pa+28>>2]=k[Zd+28>>2];q=q|0?0:4;p=q;do{p=p+7&7;v=d+(k[Zd+(p<<2)>>2]|0)|0;s=(p|0)==(q|0)}while(!((i[v>>0]|0)!=0|s));r:do if(!s){t=d;while(1){while(1){q=p+1|0;s=t+(k[Zd+(q<<2)>>2]|0)|0;if(!(i[s>>0]|0))p=q;else break}if((t|0)==(x|0)){Sd=332;break p}if((t|0)==(v|0)&(s|0)==(d|0)){d=v;break r}t=s;p=p+5&7}}while(0);if((d|0)==(x|0))break p;else{h=f;break}}}while(0);f=k[f+4>>2]|0}while((f|0)!=0);if((Sd|0)==322)Sd=0;else if((Sd|0)==332)Sd=0;if((k[h+40>>2]|0)==(I|0)){h=k[h+8>>2]|0;h=(h|0)==0?U:h}if(!(k[h+12>>2]|0)){p=n;break n}else{a=e;d=0}}while(0);DY(k[V>>2]|0,W);H=HY(k[X>>2]|0,k[Y>>2]|0,k[Z>>2]|0,k[Fa>>2]|0)|0;k[H>>2]=k[H>>2]|(I|0?32768:0);if(d){f=m+J+(0-I)|0;v=(k[_>>2]|0)+a|0;s=(k[$>>2]|0)+P|0;x=k[ba>>2]|0;k[Zd>>2]=1;k[Ia>>2]=da;k[Ja>>2]=ca;k[Ka>>2]=ea;k[La>>2]=-1;k[Ma>>2]=fa;k[Na>>2]=wa;k[Oa>>2]=ga;k[Pa>>2]=k[Zd>>2];k[Pa+4>>2]=k[Zd+4>>2];k[Pa+8>>2]=k[Zd+8>>2];k[Pa+12>>2]=k[Zd+12>>2];k[Pa+16>>2]=k[Zd+16>>2];k[Pa+20>>2]=k[Zd+20>>2];k[Pa+24>>2]=k[Zd+24>>2];k[Pa+28>>2]=k[Zd+28>>2];NY(H,Xd);d=(x|0)<1;if(d){Sd=H+56|0;k[Sd>>2]=v;k[Sd+4>>2]=s}p=(k[H>>2]|0)>>>13&4^4;n=p;do{n=n+7&7;g=f+(k[Zd+(n<<2)>>2]|0)|0;q=(n|0)==(p|0)}while(!((i[g>>0]|0)!=0|q));s:do if(q){i[f>>0]=-126;if((x|0)<=0){Sd=393;break}d=k[Qa>>2]|0;if(d>>>0>=(k[Ra>>2]|0)>>>0){PY(Xd);d=k[Qa>>2]|0}t=d;d=t;i[d>>0]=v;i[d+1>>0]=v>>8;i[d+2>>0]=v>>16;i[d+3>>0]=v>>24;t=t+4|0;i[t>>0]=s;i[t+1>>0]=s>>8;i[t+2>>0]=s>>16;i[t+3>>0]=s>>24;t=(k[Qa>>2]|0)+8|0;k[Qa>>2]=t;s=k[Wa>>2]|0;k[s+36>>2]=t;d=k[Xa>>2]|0;p=(d|0)==0;do if(!p){q=k[s+52>>2]|0;k[d+12>>2]=(t-(k[d+16>>2]|0)|0)/(k[s+28>>2]|0)|0;d=q;n=0;do{n=(k[d+12>>2]|0)+n|0;d=k[d+4>>2]|0}while((d|0)!=(q|0));k[s+24>>2]=n;if(p)break;d=k[s+44>>2]|0;if(!d)break;p=(k[d+8>>2]|0)+(k[d+16>>2]|0)|0;n=d+20|0;d=s+32|0;if((p+(0-(k[n>>2]|0))-(k[d>>2]|0)|0)>>>0>=8)break;k[n>>2]=p-t&-8;k[d>>2]=t}while(0);k[Qa>>2]=0;Sd=401}else{if(d){t=f;while(1){q=n;while(1){d=q+1|0;s=t+(k[Zd+(d<<2)>>2]|0)|0;if(!(i[s>>0]|0))q=d;else break}p=d&7;do if((p+-1|0)>>>0<n>>>0)i[t>>0]=-126;else{if((i[t>>0]|0)!=1)break;i[t>>0]=2}while(0);d=k[Qa>>2]|0;if(d>>>0>=(k[Ra>>2]|0)>>>0){PY(Xd);d=k[Qa>>2]|0}i[d>>0]=p;k[Qa>>2]=(k[Qa>>2]|0)+1;if((t|0)==(g|0)&(s|0)==(f|0)){Sd=393;break s}t=s;n=q+5&7}}if((x|0)==1){w=f;while(1){q=n;while(1){d=q+1|0;t=w+(k[Zd+(d<<2)>>2]|0)|0;if(!(i[t>>0]|0))q=d;else break}p=d&7;do if((p+-1|0)>>>0<n>>>0)i[w>>0]=-126;else{if((i[w>>0]|0)!=1)break;i[w>>0]=2}while(0);d=k[Qa>>2]|0;if(d>>>0>=(k[Ra>>2]|0)>>>0){PY(Xd);d=k[Qa>>2]|0}Sd=d;G=Sd;i[G>>0]=v;i[G+1>>0]=v>>8;i[G+2>>0]=v>>16;i[G+3>>0]=v>>24;Sd=Sd+4|0;i[Sd>>0]=s;i[Sd+1>>0]=s>>8;i[Sd+2>>0]=s>>16;i[Sd+3>>0]=s>>24;k[Qa>>2]=(k[Qa>>2]|0)+8;if((w|0)==(g|0)&(t|0)==(f|0)){Sd=393;break s}w=t;n=q+5&7;v=(k[63052+(p<<3)>>2]|0)+v|0;s=(k[63052+(p<<3)+4>>2]|0)+s|0}}w=f;d=n^4;while(1){q=n;while(1){p=q+1|0;t=w+(k[Zd+(p<<2)>>2]|0)|0;if(!(i[t>>0]|0))q=p;else break}p=p&7;do if((p+-1|0)>>>0<n>>>0)i[w>>0]=-126;else{if((i[w>>0]|0)!=1)break;i[w>>0]=2}while(0);if((p|0)!=(d|0)){d=k[Qa>>2]|0;if(d>>>0>=(k[Ra>>2]|0)>>>0){PY(Xd);d=k[Qa>>2]|0}Sd=d;i[Sd>>0]=v;i[Sd+1>>0]=v>>8;i[Sd+2>>0]=v>>16;i[Sd+3>>0]=v>>24;d=d+4|0;i[d>>0]=s;i[d+1>>0]=s>>8;i[d+2>>0]=s>>16;i[d+3>>0]=s>>24;k[Qa>>2]=(k[Qa>>2]|0)+8;d=p}if((w|0)==(g|0)&(t|0)==(f|0)){Sd=393;break s}w=t;n=q+5&7;v=(k[63052+(p<<3)>>2]|0)+v|0;s=(k[63052+(p<<3)+4>>2]|0)+s|0}}while(0);if((Sd|0)==393){Sd=0;s=k[Wa>>2]|0;t=k[Qa>>2]|0;k[s+36>>2]=t;d=k[Xa>>2]|0;p=(d|0)==0;do if(!p){q=k[s+52>>2]|0;k[d+12>>2]=(t-(k[d+16>>2]|0)|0)/(k[s+28>>2]|0)|0;d=q;n=0;do{n=(k[d+12>>2]|0)+n|0;d=k[d+4>>2]|0}while((d|0)!=(q|0));k[s+24>>2]=n;if(p)break;d=k[s+44>>2]|0;if(!d)break;p=(k[d+8>>2]|0)+(k[d+16>>2]|0)|0;n=d+20|0;d=s+32|0;if((p+(0-(k[n>>2]|0))-(k[d>>2]|0)|0)>>>0>=8)break;k[n>>2]=p-t&-8;k[d>>2]=t}while(0);k[Qa>>2]=0;if(x|0)Sd=401}if((Sd|0)==401){Sd=0;csa(Yd,H)}G=b}else{k[Yd>>2]=0;XY(k[ja>>2]|0,Yd);G=k[Yd>>2]|0;if(M){p=k[K+(a<<2)>>2]&127;A=K+(J<<2)+(0-I<<2)|0;w=(k[_>>2]|0)+a|0;f=(k[$>>2]|0)+P|0;F=k[ba>>2]|0;D=k[A>>2]|0;B=D&1073741823;C=B|1073741824;D=D|-1073741824;k[Zd>>2]=1;k[Ia>>2]=la;k[Ja>>2]=ka;k[Ka>>2]=ma;k[La>>2]=-1;k[Ma>>2]=na;k[Na>>2]=xa;k[Oa>>2]=oa;k[Pa>>2]=k[Zd>>2];k[Pa+4>>2]=k[Zd+4>>2];k[Pa+8>>2]=k[Zd+8>>2];k[Pa+12>>2]=k[Zd+12>>2];k[Pa+16>>2]=k[Zd+16>>2];k[Pa+20>>2]=k[Zd+20>>2];k[Pa+24>>2]=k[Zd+24>>2];k[Pa+28>>2]=k[Zd+28>>2];NY(H,Xd);q=(F|0)<1;if(q){E=H+56|0;k[E>>2]=w;k[E+4>>2]=f}d=(k[H>>2]|0)>>>13&4^4;s=d;do{s=s+7&7;E=A+(k[Zd+(s<<2)>>2]<<2)|0;n=(s|0)==(d|0)}while(!(n|(k[E>>2]&1073741823|0)==(B|0)));t:do if(!n){d=s^4;if(q){z=A;x=d;t=s;q=w;y=w;n=w;d=f;e=f;g=f;while(1){w=t;while(1){s=w+1|0;f=z+(k[Zd+(s<<2)>>2]<<2)|0;if((k[f>>2]&1073741823|0)==(B|0))break;else w=s}v=s&7;do if((v+-1|0)>>>0<t>>>0)k[z>>2]=D;else{if((k[z>>2]|0)!=(B|0))break;k[z>>2]=C}while(0);s=k[Sa>>2]|0;if(s>>>0>=(k[Ta>>2]|0)>>>0){PY(Xd);s=k[Sa>>2]|0}i[s>>0]=v;k[Sa>>2]=(k[Sa>>2]|0)+1;do if((v|0)!=(x|0)){x=(y|0)<(q|0);n=x?n:(y|0)>(n|0)?y:n;q=x?y:q;if((e|0)<(g|0)){g=e;break}d=(e|0)>(d|0)?e:d}while(0);if((z|0)==(E|0)&(f|0)==(A|0)){x=q;break t}z=f;x=v;t=w+5&7;y=(k[63052+(v<<3)>>2]|0)+y|0;e=(k[63052+(v<<3)+4>>2]|0)+e|0}}if((F|0)==1){z=A;x=d;t=s;q=w;y=w;n=w;d=f;e=f;g=f;while(1){w=t;while(1){s=w+1|0;f=z+(k[Zd+(s<<2)>>2]<<2)|0;if((k[f>>2]&1073741823|0)==(B|0))break;else w=s}v=s&7;do if((v+-1|0)>>>0<t>>>0)k[z>>2]=D;else{if((k[z>>2]|0)!=(B|0))break;k[z>>2]=C}while(0);s=k[Sa>>2]|0;if(s>>>0>=(k[Ta>>2]|0)>>>0){PY(Xd);s=k[Sa>>2]|0}t=s;s=t;i[s>>0]=y;i[s+1>>0]=y>>8;i[s+2>>0]=y>>16;i[s+3>>0]=y>>24;t=t+4|0;i[t>>0]=e;i[t+1>>0]=e>>8;i[t+2>>0]=e>>16;i[t+3>>0]=e>>24;k[Sa>>2]=(k[Sa>>2]|0)+8;do if((v|0)!=(x|0)){x=(y|0)<(q|0);n=x?n:(y|0)>(n|0)?y:n;q=x?y:q;if((e|0)<(g|0)){g=e;break}d=(e|0)>(d|0)?e:d}while(0);if((z|0)==(E|0)&(f|0)==(A|0)){x=q;break t}z=f;x=v;t=w+5&7;y=(k[63052+(v<<3)>>2]|0)+y|0;e=(k[63052+(v<<3)+4>>2]|0)+e|0}}else{z=A;v=d;t=s;q=w;y=w;n=w;d=f;e=f;g=f;while(1){f=t;while(1){s=f+1|0;x=z+(k[Zd+(s<<2)>>2]<<2)|0;if((k[x>>2]&1073741823|0)==(B|0))break;else f=s}w=s&7;do if((w+-1|0)>>>0<t>>>0)k[z>>2]=D;else{if((k[z>>2]|0)!=(B|0))break;k[z>>2]=C}while(0);do if((w|0)!=(v|0)){s=k[Sa>>2]|0;if(s>>>0>=(k[Ta>>2]|0)>>>0){PY(Xd);s=k[Sa>>2]|0}v=s;t=v;i[t>>0]=y;i[t+1>>0]=y>>8;i[t+2>>0]=y>>16;i[t+3>>0]=y>>24;v=v+4|0;i[v>>0]=e;i[v+1>>0]=e>>8;i[v+2>>0]=e>>16;i[v+3>>0]=e>>24;k[Sa>>2]=(k[Sa>>2]|0)+8;v=(y|0)<(q|0);n=v?n:(y|0)>(n|0)?y:n;q=v?y:q;if((e|0)<(g|0)){g=e;break}d=(e|0)>(d|0)?e:d}while(0);if((z|0)==(E|0)&(x|0)==(A|0)){x=q;break t}z=x;v=w;t=f+5&7;y=(k[63052+(w<<3)>>2]|0)+y|0;e=(k[63052+(w<<3)+4>>2]|0)+e|0}}}else{k[A>>2]=D;if((F|0)<=0){x=w;n=w;d=f;g=f;break}d=k[Sa>>2]|0;if(d>>>0>=(k[Ta>>2]|0)>>>0){PY(Xd);d=k[Sa>>2]|0}x=d;n=x;i[n>>0]=w;i[n+1>>0]=w>>8;i[n+2>>0]=w>>16;i[n+3>>0]=w>>24;x=x+4|0;i[x>>0]=f;i[x+1>>0]=f>>8;i[x+2>>0]=f>>16;i[x+3>>0]=f>>24;k[Sa>>2]=(k[Sa>>2]|0)+8;x=w;n=w;d=f;g=f}while(0);f=n+1-x|0;v=d+1-g|0;t=k[Md>>2]|0;w=k[Sa>>2]|0;k[t+36>>2]=w;d=k[Nd>>2]|0;q=(d|0)==0;do if(!q){s=k[t+52>>2]|0;k[d+12>>2]=(w-(k[d+16>>2]|0)|0)/(k[t+28>>2]|0)|0;d=s;n=0;do{n=(k[d+12>>2]|0)+n|0;d=k[d+4>>2]|0}while((d|0)!=(s|0));k[t+24>>2]=n;if(q)break;d=k[t+44>>2]|0;if(!d)break;q=(k[d+8>>2]|0)+(k[d+16>>2]|0)|0;n=d+20|0;d=t+32|0;if((q+(0-(k[n>>2]|0))-(k[d>>2]|0)|0)>>>0>=8)break;k[n>>2]=q-w&-8;k[d>>2]=w}while(0);k[Sa>>2]=0;if(F|0){k[H+56>>2]=x;k[H+60>>2]=g;k[H+64>>2]=f;k[H+68>>2]=v}d=G+16|0;k[d>>2]=x;n=G+20|0;k[n>>2]=g;k[G+24>>2]=f;k[G+28>>2]=v}else{E=j+1&127;E=((E|0)==0?3:0)+E|0;B=m+J+(0-I)|0;v=(k[_>>2]|0)+a|0;w=(k[$>>2]|0)+P|0;D=k[ba>>2]|0;k[Zd>>2]=1;k[Ia>>2]=da;k[Ja>>2]=ca;k[Ka>>2]=ea;k[La>>2]=-1;k[Ma>>2]=fa;k[Na>>2]=wa;k[Oa>>2]=ga;k[Pa>>2]=k[Zd>>2];k[Pa+4>>2]=k[Zd+4>>2];k[Pa+8>>2]=k[Zd+8>>2];k[Pa+12>>2]=k[Zd+12>>2];k[Pa+16>>2]=k[Zd+16>>2];k[Pa+20>>2]=k[Zd+20>>2];k[Pa+24>>2]=k[Zd+24>>2];k[Pa+28>>2]=k[Zd+28>>2];NY(H,Xd);p=(D|0)<1;if(p){F=H+56|0;k[F>>2]=v;k[F+4>>2]=w}d=(k[H>>2]|0)>>>13&4^4;q=d;do{q=q+7&7;C=B+(k[Zd+(q<<2)>>2]|0)|0;n=(q|0)==(d|0)}while(!((i[C>>0]|0)!=0|n));u:do if(!n){d=q^4;z=(j|128)&255;A=j&255;if(p){y=B;g=d;s=q;p=v;e=v;n=v;d=w;x=w;f=w;while(1){v=s;while(1){q=v+1|0;w=y+(k[Zd+(q<<2)>>2]|0)|0;if(!(i[w>>0]|0))v=q;else break}t=q&7;do if((t+-1|0)>>>0<s>>>0)i[y>>0]=z;else{if((i[y>>0]|0)!=1)break;i[y>>0]=A}while(0);q=k[Ua>>2]|0;if(q>>>0>=(k[Va>>2]|0)>>>0){PY(Xd);q=k[Ua>>2]|0}i[q>>0]=t;k[Ua>>2]=(k[Ua>>2]|0)+1;do if((t|0)!=(g|0)){F=(e|0)<(p|0);n=F?n:(e|0)>(n|0)?e:n;p=F?e:p;if((x|0)<(f|0)){f=x;break}d=(x|0)>(d|0)?x:d}while(0);if((y|0)==(C|0)&(w|0)==(B|0)){g=p;break u}y=w;g=t;s=v+5&7;e=(k[63052+(t<<3)>>2]|0)+e|0;x=(k[63052+(t<<3)+4>>2]|0)+x|0}}if((D|0)==1){y=B;g=d;s=q;p=v;e=v;n=v;d=w;x=w;f=w;while(1){v=s;while(1){q=v+1|0;w=y+(k[Zd+(q<<2)>>2]|0)|0;if(!(i[w>>0]|0))v=q;else break}t=q&7;do if((t+-1|0)>>>0<s>>>0)i[y>>0]=z;else{if((i[y>>0]|0)!=1)break;i[y>>0]=A}while(0);q=k[Ua>>2]|0;if(q>>>0>=(k[Va>>2]|0)>>>0){PY(Xd);q=k[Ua>>2]|0}F=q;s=F;i[s>>0]=e;i[s+1>>0]=e>>8;i[s+2>>0]=e>>16;i[s+3>>0]=e>>24;F=F+4|0;i[F>>0]=x;i[F+1>>0]=x>>8;i[F+2>>0]=x>>16;i[F+3>>0]=x>>24;k[Ua>>2]=(k[Ua>>2]|0)+8;do if((t|0)!=(g|0)){F=(e|0)<(p|0);n=F?n:(e|0)>(n|0)?e:n;p=F?e:p;if((x|0)<(f|0)){f=x;break}d=(x|0)>(d|0)?x:d}while(0);if((y|0)==(C|0)&(w|0)==(B|0)){g=p;break u}y=w;g=t;s=v+5&7;e=(k[63052+(t<<3)>>2]|0)+e|0;x=(k[63052+(t<<3)+4>>2]|0)+x|0}}else{y=B;t=d;s=q;p=v;e=v;n=v;d=w;x=w;f=w;while(1){w=s;while(1){q=w+1|0;g=y+(k[Zd+(q<<2)>>2]|0)|0;if(!(i[g>>0]|0))w=q;else break}v=q&7;do if((v+-1|0)>>>0<s>>>0)i[y>>0]=z;else{if((i[y>>0]|0)!=1)break;i[y>>0]=A}while(0);do if((v|0)!=(t|0)){q=k[Ua>>2]|0;if(q>>>0>=(k[Va>>2]|0)>>>0){PY(Xd);q=k[Ua>>2]|0}F=q;t=F;i[t>>0]=e;i[t+1>>0]=e>>8;i[t+2>>0]=e>>16;i[t+3>>0]=e>>24;F=F+4|0;i[F>>0]=x;i[F+1>>0]=x>>8;i[F+2>>0]=x>>16;i[F+3>>0]=x>>24;k[Ua>>2]=(k[Ua>>2]|0)+8;F=(e|0)<(p|0);n=F?n:(e|0)>(n|0)?e:n;p=F?e:p;if((x|0)<(f|0)){f=x;break}d=(x|0)>(d|0)?x:d}while(0);if((y|0)==(C|0)&(g|0)==(B|0)){g=p;break u}y=g;t=v;s=w+5&7;e=(k[63052+(v<<3)>>2]|0)+e|0;x=(k[63052+(v<<3)+4>>2]|0)+x|0}}}else{i[B>>0]=j|128;if((D|0)<=0){g=v;n=v;d=w;f=w;break}d=k[Ua>>2]|0;if(d>>>0>=(k[Va>>2]|0)>>>0){PY(Xd);d=k[Ua>>2]|0}g=d;n=g;i[n>>0]=v;i[n+1>>0]=v>>8;i[n+2>>0]=v>>16;i[n+3>>0]=v>>24;g=g+4|0;i[g>>0]=w;i[g+1>>0]=w>>8;i[g+2>>0]=w>>16;i[g+3>>0]=w>>24;k[Ua>>2]=(k[Ua>>2]|0)+8;g=v;n=v;d=w;f=w}while(0);w=n+1-g|0;t=d+1-f|0;s=k[Od>>2]|0;v=k[Ua>>2]|0;k[s+36>>2]=v;d=k[Pd>>2]|0;p=(d|0)==0;do if(!p){q=k[s+52>>2]|0;k[d+12>>2]=(v-(k[d+16>>2]|0)|0)/(k[s+28>>2]|0)|0;d=q;n=0;do{n=(k[d+12>>2]|0)+n|0;d=k[d+4>>2]|0}while((d|0)!=(q|0));k[s+24>>2]=n;if(p)break;d=k[s+44>>2]|0;if(!d)break;p=(k[d+8>>2]|0)+(k[d+16>>2]|0)|0;n=d+20|0;d=s+32|0;if((p+(0-(k[n>>2]|0))-(k[d>>2]|0)|0)>>>0>=8)break;k[n>>2]=p-v&-8;k[d>>2]=v}while(0);k[Ua>>2]=0;if(D|0){k[H+56>>2]=g;k[H+60>>2]=f;k[H+64>>2]=w;k[H+68>>2]=t}d=G+16|0;k[d>>2]=g;n=G+20|0;k[n>>2]=f;k[G+24>>2]=w;k[G+28>>2]=t;p=j;j=E}k[d>>2]=(k[d>>2]|0)-(k[_>>2]|0);k[n>>2]=(k[n>>2]|0)-(k[$>>2]|0);F=Fa+276+(p<<2)|0;k[G+4>>2]=k[F>>2];k[F>>2]=G}k[G+40>>2]=I;F=G+12|0;k[F>>2]=H;E=G+32|0;k[E>>2]=a;k[E+4>>2]=P;E=G+8|0;k[E>>2]=h;g=k[ha>>2]|0;if((k[ba>>2]|0)==(g|0)){n=h;d=H}else{s=k[ia>>2]|0;t=k[V>>2]|0;v=H+24|0;q=(k[v>>2]|0)+8|0;k[Ya>>2]=0;k[Za>>2]=0;k[_a>>2]=0;k[$a>>2]=0;k[ab>>2]=0;k[bb>>2]=0;k[cb>>2]=0;k[db>>2]=0;k[eb>>2]=0;k[fb>>2]=0;k[gb>>2]=0;k[hb>>2]=0;k[ib>>2]=0;k[jb>>2]=0;k[kb>>2]=0;k[lb>>2]=0;k[mb>>2]=0;k[nb>>2]=0;k[ob>>2]=0;k[pb>>2]=0;k[qb>>2]=0;k[rb>>2]=0;k[sb>>2]=0;k[tb>>2]=0;k[ub>>2]=0;k[vb>>2]=0;k[wb>>2]=0;k[xb>>2]=0;k[yb>>2]=0;k[zb>>2]=0;k[Ab>>2]=0;k[Bb>>2]=0;k[Cb>>2]=0;k[Db>>2]=0;k[Eb>>2]=0;k[Fb>>2]=0;k[Gb>>2]=0;k[Hb>>2]=0;k[Ib>>2]=0;k[Jb>>2]=0;k[Kb>>2]=0;k[Lb>>2]=0;k[Mb>>2]=0;k[Nb>>2]=0;k[Ob>>2]=0;k[Pb>>2]=0;k[Qb>>2]=0;k[Rb>>2]=0;k[Sb>>2]=0;k[Tb>>2]=0;k[Ub>>2]=0;k[Vb>>2]=0;k[Wb>>2]=0;k[Xb>>2]=0;k[Yb>>2]=0;k[Zb>>2]=0;k[_b>>2]=0;k[$b>>2]=0;k[ac>>2]=0;k[bc>>2]=0;k[cc>>2]=0;k[dc>>2]=0;k[ec>>2]=0;k[fc>>2]=0;k[gc>>2]=0;k[hc>>2]=0;k[ic>>2]=0;k[jc>>2]=0;k[kc>>2]=0;k[lc>>2]=0;k[mc>>2]=0;k[nc>>2]=0;k[oc>>2]=0;k[pc>>2]=0;k[qc>>2]=0;k[rc>>2]=0;k[sc>>2]=0;k[tc>>2]=0;k[uc>>2]=0;k[vc>>2]=0;k[wc>>2]=0;k[xc>>2]=0;k[yc>>2]=0;k[zc>>2]=0;k[Ac>>2]=0;k[Bc>>2]=0;k[Cc>>2]=0;k[Dc>>2]=0;k[Ec>>2]=0;k[Fc>>2]=0;k[Gc>>2]=0;k[Hc>>2]=0;k[Ic>>2]=0;k[Jc>>2]=0;k[Kc>>2]=0;k[Lc>>2]=0;k[Mc>>2]=0;k[Nc>>2]=0;k[Oc>>2]=0;k[Pc>>2]=0;k[Qc>>2]=0;k[Rc>>2]=0;k[Sc>>2]=0;k[Tc>>2]=0;k[Uc>>2]=0;k[Vc>>2]=0;k[Wc>>2]=0;k[Xc>>2]=0;k[Yc>>2]=0;k[Zc>>2]=0;k[_c>>2]=0;k[$c>>2]=0;k[ad>>2]=0;k[bd>>2]=0;k[cd>>2]=0;k[dd>>2]=0;k[ed>>2]=0;k[fd>>2]=0;k[Yd>>2]=Ya;k[gd>>2]=59;if(q>>>0>59){n=q>>>0>214748364?-1:q*20|0;n=(n|0)==0?1:n;while(1){d=fgb(n)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}n=d+(q*20|0)|0;p=d;do{k[p>>2]=0;k[p+4>>2]=0;p=p+20|0}while((p|0)!=(n|0));k[Yd>>2]=d;D=d}else D=Ya;k[gd>>2]=q;k[Zd>>2]=0;k[hd>>2]=0;f=k[v>>2]|0;k[id>>2]=0;k[jd>>2]=0;n=H+56|0;q=n;p=k[q>>2]|0;q=k[q+4>>2]|0;C=k[H>>2]|0;if(!((C&12288|0)==4096?!((C&16384|0)==0?1:(k[H+28>>2]|0)!=1):0)){k[Xd>>2]=0;k[kd>>2]=0;d=ZT(40)|0;k[d>>2]=1;B=d+4|0;k[Xd>>2]=B;k[kd>>2]=32;i[d+36>>0]=0;A=236234;C=B+32|0;do{i[B>>0]=i[A>>0]|0;B=B+1|0;A=A+1|0}while((B|0)<(C|0));Y8(-215,Xd,236267,236291,74);k[kd>>2]=0;k[Xd>>2]=0;C=k[d>>2]|0;k[d>>2]=C+-1;if((C|0)==1)ggb(k[d+-4>>2]|0)}if((s|0)<=87){k[Xd>>2]=0;k[Ld>>2]=0;d=ZT(44)|0;k[d>>2]=1;B=d+4|0;k[Xd>>2]=B;k[Ld>>2]=37;i[d+41>>0]=0;A=236359;C=B+37|0;do{i[B>>0]=i[A>>0]|0;B=B+1|0;A=A+1|0}while((B|0)<(C|0));Y8(-215,Xd,236267,236291,75);k[Ld>>2]=0;k[Xd>>2]=0;C=k[d>>2]|0;k[d>>2]=C+-1;if((C|0)==1)ggb(k[d+-4>>2]|0)}OY(k[H>>2]&-4096|12,s,8,t,Wd);do if(!(k[v>>2]|0)){d=k[ld>>2]|0;if(d>>>0>=(k[md>>2]|0)>>>0){PY(Wd);d=k[ld>>2]|0}t=d;d=t;i[d>>0]=p;i[d+1>>0]=p>>8;i[d+2>>0]=p>>16;i[d+3>>0]=p>>24;t=t+4|0;i[t>>0]=q;i[t+1>>0]=q>>8;i[t+2>>0]=q>>16;i[t+3>>0]=q>>24;t=(k[ld>>2]|0)+8|0;k[ld>>2]=t;d=k[nd>>2]|0;k[d+36>>2]=t;n=k[od>>2]|0;q=(n|0)==0;do if(!q){s=k[d+52>>2]|0;k[n+12>>2]=(t-(k[n+16>>2]|0)|0)/(k[d+28>>2]|0)|0;n=s;p=0;do{p=(k[n+12>>2]|0)+p|0;n=k[n+4>>2]|0}while((n|0)!=(s|0));k[d+24>>2]=p;if(q)break;n=k[d+44>>2]|0;if(!n)break;q=(k[n+8>>2]|0)+(k[n+16>>2]|0)|0;n=n+20|0;p=d+32|0;if((q+(0-(k[n>>2]|0))-(k[p>>2]|0)|0)>>>0>=8)break;k[n>>2]=q-t&-8;k[p>>2]=t}while(0);k[ld>>2]=0}else{if(!((k[H+28>>2]|0)==1?(k[H+4>>2]|0)>=64:0))Sd=559;if((Sd|0)==559?(Sd=0,k[Xd>>2]=0,k[pd>>2]=0,Vd=ZT(8)|0,k[Vd>>2]=1,C=Vd+4|0,k[Xd>>2]=C,k[pd>>2]=0,i[C>>0]=0,Y8(-201,Xd,242918,242941,62),k[pd>>2]=0,k[Xd>>2]=0,C=k[Vd>>2]|0,k[Vd>>2]=C+-1,(C|0)==1):0)ggb(k[Vd+-4>>2]|0);KY(H,_d);t=n;s=k[t>>2]|0;t=k[t+4>>2]|0;H=qd;k[H>>2]=s;k[H+4>>2]=t;i[rd>>0]=1;i[sd>>0]=0;i[td>>0]=1;i[ud>>0]=-1;i[vd>>0]=0;i[wd>>0]=-1;i[wd+1>>0]=-1>>8;i[wd+2>>0]=-1>>16;i[wd+3>>0]=-1>>24;i[xd>>0]=0;i[yd>>0]=-1;i[zd>>0]=1;i[Ad>>0]=0;i[Bd>>0]=1;i[Cd>>0]=1;i[Dd>>0]=1;k[Ed>>2]=0;v:do if((f|0)>0){w=(g|0)==1;if((g|0)<3){n=0;p=s;v=s}else{d=Zd;n=0;q=s;w=s;while(1){v=i[k[Fd>>2]>>0]|0;H=k[Gd>>2]|0;k[Fd>>2]=H;s=H;if(!H)p=i[Hd>>0]|0;else{p=i[s>>0]|0;i[Hd>>0]=p;H=s+1|0;k[Gd>>2]=H;if(H>>>0<(k[Id>>2]|0)>>>0)q=w;else{H=k[(k[Jd>>2]|0)+4>>2]|0;k[Jd>>2]=H;B=k[H+16>>2]|0;k[Gd>>2]=B;C=k[(k[Ha>>2]|0)+28>>2]|0;H=k[H+12>>2]|0;k[Kd>>2]=B;H=B+(aa(C,H)|0)|0;k[Id>>2]=H}H=p<<24>>24;k[qd>>2]=q+(i[_d+44+(H<<1)>>0]|0);k[jd>>2]=(k[jd>>2]|0)+(i[_d+44+(H<<1)+1>>0]|0)}H=(p<<24>>24)-v|0;q=k[51792+(H+7<<2)>>2]|0;p=D+(n*20|0)|0;if(H){k[d+16>>2]=p;d=p}k[D+(n*20|0)+12>>2]=q;H=D+(n*20|0)|0;k[H>>2]=w;k[H+4>>2]=t;n=n+1|0;if((n|0)>=(f|0)){A=n;break v}t=qd;w=k[t>>2]|0;q=w;t=k[t+4>>2]|0}}while(1){s=i[k[Fd>>2]>>0]|0;H=k[Gd>>2]|0;k[Fd>>2]=H;q=H;if(!H)d=i[Hd>>0]|0;else{d=i[q>>0]|0;i[Hd>>0]=d;H=q+1|0;k[Gd>>2]=H;if(H>>>0<(k[Id>>2]|0)>>>0)p=v;else{H=k[(k[Jd>>2]|0)+4>>2]|0;k[Jd>>2]=H;B=k[H+16>>2]|0;k[Gd>>2]=B;C=k[(k[Ha>>2]|0)+28>>2]|0;H=k[H+12>>2]|0;k[Kd>>2]=B;H=B+(aa(C,H)|0)|0;k[Id>>2]=H}H=d<<24>>24;k[qd>>2]=p+(i[_d+44+(H<<1)>>0]|0);k[jd>>2]=(k[jd>>2]|0)+(i[_d+44+(H<<1)+1>>0]|0)}if(w|d<<24>>24!=s<<24>>24){d=k[ld>>2]|0;if(d>>>0>=(k[md>>2]|0)>>>0){PY(Wd);d=k[ld>>2]|0}H=d;C=H;i[C>>0]=v;i[C+1>>0]=v>>8;i[C+2>>0]=v>>16;i[C+3>>0]=v>>24;H=H+4|0;i[H>>0]=t;i[H+1>>0]=t>>8;i[H+2>>0]=t>>16;i[H+3>>0]=t>>24;k[ld>>2]=(k[ld>>2]|0)+8}n=n+1|0;if((n|0)>=(f|0)){d=Zd;A=n;break v}t=qd;v=k[t>>2]|0;p=v;t=k[t+4>>2]|0}}else{d=Zd;A=0}while(0);if((g|0)<3){d=k[nd>>2]|0;t=k[ld>>2]|0;k[d+36>>2]=t;n=k[od>>2]|0;q=(n|0)==0;do if(!q){s=k[d+52>>2]|0;k[n+12>>2]=(t-(k[n+16>>2]|0)|0)/(k[d+28>>2]|0)|0;n=s;p=0;do{p=(k[n+12>>2]|0)+p|0;n=k[n+4>>2]|0}while((n|0)!=(s|0));k[d+24>>2]=p;if(q)break;n=k[d+44>>2]|0;if(!n)break;q=(k[n+8>>2]|0)+(k[n+16>>2]|0)|0;n=n+20|0;p=d+32|0;if((q+(0-(k[n>>2]|0))-(k[p>>2]|0)|0)>>>0>=8)break;k[n>>2]=q-t&-8;k[p>>2]=t}while(0);k[ld>>2]=0;break}k[d+16>>2]=0;v=k[Ed>>2]|0;z=D;y=(g|0)==4;e=v;do{f=(e-z|0)/20|0;x=e;g=k[x>>2]|0;x=k[x+4>>2]|0;d=1;n=0;p=0;while(1){t=f-d|0;t=((t|0)<0?A:0)+t|0;C=d+f|0;C=C-((C|0)>=(A|0)?A:0)|0;H=k[D+(t*20|0)>>2]|0;s=(k[D+(C*20|0)>>2]|0)-H|0;t=k[D+(t*20|0)+4>>2]|0;C=(k[D+(C*20|0)+4>>2]|0)-t|0;q=(aa(C,C)|0)+(aa(s,s)|0)|0;s=(aa(C,g-H|0)|0)-(aa(x-t|0,s)|0)|0;t=(o[u>>2]=+(n|0)*+(q|0)-+(p|0)*+(s|0),k[u>>2]|0);if((d|0)>1){if((p|0)>=(q|0))break;if((n|0)>0&(t|0)<1)break;if((n|0)<0&(t|0)>-1)break}d=d+1|0;n=s;p=q}w=d+-1|0;k[e+8>>2]=w;if(y){t=w;d=0;while(1){p=f-t|0;p=((p|0)<0?A:0)+p|0;s=t+f|0;s=s-((s|0)>=(A|0)?A:0)|0;n=(k[D+(p*20|0)>>2]|0)-g|0;p=(k[D+(p*20|0)+4>>2]|0)-x|0;q=(k[D+(s*20|0)>>2]|0)-g|0;s=(k[D+(s*20|0)+4>>2]|0)-x|0;if((p|n|0)==0|(s|q|0)==0)break;de=+(n|0);ce=+(p|0);be=+(q|0);ae=+(s|0);ae=+((aa(s,p)|0)+(aa(q,n)|0)|0)/+Q(+((de*de+ce*ce)*(be*be+ae*ae)))+1.1;n=(o[u>>2]=ae,k[u>>2]|0);if(!((t|0)>=(w|0)|(n|0)>(d|0)))break;if((t|0)>1){t=t+-1|0;d=n}else{d=n;break}}k[e+12>>2]=d}e=k[e+16>>2]|0}while((e|0)!=0);d=Zd;do{p=k[v+8>>2]>>1;q=v+12|0;s=k[q>>2]|0;t=(v-z|0)/20|0;w:do if((p|0)<1)d=v;else{n=1;while(1){H=t-n|0;if((k[D+((((H|0)<0?A:0)+H|0)*20|0)+12>>2]|0)>(s|0))break;H=n+t|0;if((k[D+((H-((H|0)>=(A|0)?A:0)|0)*20|0)+12>>2]|0)>(s|0))break;if((n|0)<(p|0))n=n+1|0;else{d=v;break w}}k[d+16>>2]=k[v+16>>2];k[q>>2]=0}while(0);v=k[v+16>>2]|0}while((v|0)!=0);d=Zd;p=k[Ed>>2]|0;do{do if((k[p+8>>2]|0)==1){n=p+12|0;C=k[n>>2]|0;B=p-z|0;e=(B|0)/20|0;H=e+1|0;if((C|0)>(k[D+((e+-1+((B|0)<20?A:0)|0)*20|0)+12>>2]|0)?(C|0)>(k[D+((H-((H|0)>=(A|0)?A:0)|0)*20|0)+12>>2]|0):0){d=p;break}k[d+16>>2]=k[p+16>>2];k[n>>2]=0}else d=p;while(0);p=k[p+16>>2]|0}while((p|0)!=0);x:do if(!y){do if(k[D+12>>2]|0){q=A+-1|0;if(!(k[D+(q*20|0)+12>>2]|0))break;y:do if((A|0)>1){d=1;do{if(!(k[D+(d*20|0)+12>>2]|0))break y;k[D+((d+-1|0)*20|0)+12>>2]=0;d=d+1|0}while((d|0)<(A|0))}else d=1;while(0);if((d|0)==(A|0))break x;d=d+-1|0;n=A+-2|0;z:do if((A|0)>2)while(1){if(!(k[D+(n*20|0)+12>>2]|0))break z;k[D+(n*20|0)+16>>2]=0;k[D+((n+1|0)*20|0)+12>>2]=0;p=n+-1|0;if((n|0)>1)n=p;else{n=p;break}}while(0);if((d|0)==0&(n+1|0)==(q|0)){d=((k[D+16>>2]|0)-z|0)/20|0;H=D+(A*20|0)|0;k[H>>2]=k[D>>2];k[H+4>>2]=k[D+4>>2];k[H+8>>2]=k[D+8>>2];k[H+12>>2]=k[D+12>>2];k[H+16>>2]=k[D+16>>2];k[D+(A*20|0)+16>>2]=0;k[D+(q*20|0)+16>>2]=H}k[Ed>>2]=D+(d*20|0)}while(0);d=Zd;n=1;q=Zd;v=k[Ed>>2]|0;while(1){t=v+16|0;H=k[t>>2]|0;s=H;do if(!H)Sd=634;else{if((s-v|0)!=20){Sd=634;break}n=n+1|0}while(0);A:do if((Sd|0)==634){Sd=0;if((n|0)<=1){d=v;n=1;break}if((n|0)!=2){k[(k[d+16>>2]|0)+16>>2]=v;d=v;n=1;break}n=k[q+12>>2]|0;p=k[v+12>>2]|0;do if((n|0)<=(p|0)){if((n|0)==(p|0)?(k[q+8>>2]|0)<=(k[v+8>>2]|0):0)break;k[d+16>>2]=v;d=v;n=1;break A}while(0);k[q+16>>2]=s;d=v;n=1}while(0);p=k[t>>2]|0;if(!p)break;else{q=v;v=p}}}while(0);n=k[Ed>>2]|0;d=k[ld>>2]|0;do{if(d>>>0>=(k[md>>2]|0)>>>0){PY(Wd);d=k[ld>>2]|0}t=n;D=t;D=l[D>>0]|l[D+1>>0]<<8|l[D+2>>0]<<16|l[D+3>>0]<<24;t=t+4|0;t=l[t>>0]|l[t+1>>0]<<8|l[t+2>>0]<<16|l[t+3>>0]<<24;H=d;i[H>>0]=D;i[H+1>>0]=D>>8;i[H+2>>0]=D>>16;i[H+3>>0]=D>>24;d=d+4|0;i[d>>0]=t;i[d+1>>0]=t>>8;i[d+2>>0]=t>>16;i[d+3>>0]=t>>24;d=(k[ld>>2]|0)+8|0;k[ld>>2]=d;n=k[n+16>>2]|0;t=d}while((n|0)!=0);d=k[nd>>2]|0;k[d+36>>2]=t;n=k[od>>2]|0;q=(n|0)==0;do if(!q){s=k[d+52>>2]|0;k[n+12>>2]=(t-(k[n+16>>2]|0)|0)/(k[d+28>>2]|0)|0;n=s;p=0;do{p=(k[n+12>>2]|0)+p|0;n=k[n+4>>2]|0}while((n|0)!=(s|0));k[d+24>>2]=p;if(q)break;n=k[d+44>>2]|0;if(!n)break;q=(k[n+8>>2]|0)+(k[n+16>>2]|0)|0;n=n+20|0;p=d+32|0;if((q+(0-(k[n>>2]|0))-(k[p>>2]|0)|0)>>>0>=8)break;k[n>>2]=q-t&-8;k[p>>2]=t}while(0);k[ld>>2]=0}while(0);n=k[Yd>>2]|0;if((n|0)!=(Ya|0)){if(n|0)ggb(n);k[Yd>>2]=Ya;k[gd>>2]=59}k[F>>2]=d;CY(k[Fa>>2]|0);n=k[E>>2]|0;d=k[F>>2]|0}k[d+16>>2]=k[n+12>>2];if(k[h+12>>2]|0)break k;k[F>>2]=0;h=k[Fa>>2]|0;if((h|0)==(k[V>>2]|0))EY(h,W);else CY(h);p=i[m+J>>0]|0}while(0);d=J+1|0;if((d|0)>=(Aa|0))break;else{n=p;h=p;q=p>>>0>1?J:a}}}while(0);n=P+1|0;if((n|0)<(Ba|0)){h=0;m=m+wa|0;d=1;P=n;a=0;L=n}else break j}DY(k[V>>2]|0,Fa+32|0);k[Ga>>2]=G;k[ya>>2]=J+1+(M?0-I|0:0);k[za>>2]=P;k[sa>>2]=a;k[ta>>2]=L;k[va>>2]=m;k[Da>>2]=j;if(!(k[F>>2]|0))break;Fa=k[Td>>2]|0}_d=Fea(Td)|0;k[c>>2]=_d;r=$d;return}function Hea(a){a=a|0;ggb(a);return}function Iea(a){a=a|0;var b=0,c=0;b=r;r=r+16|0;c=b;k[c>>2]=k[a+8>>2];BY(c);if(!a){r=b;return}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);r=b;return}function Jea(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=r;r=r+256|0;G=M+192|0;L=M+80|0;p=M+48|0;q=M+44|0;H=M+8|0;A=M;E=M+136|0;h=k[b>>2]&2031616;a:do if((h|0)>=327680)if((h|0)<720896)switch(h|0){case 327680:break a;default:{t=2;break a}}else switch(h|0){case 720896:break a;default:{t=2;break a}}else switch(h|0){case 262144:break;default:t=2}while(0);if((t|0)==2?(K=G+4|0,g=ZT(160)|0,k[g>>2]=1,J=g+4|0,k[G>>2]=J,k[K>>2]=155,i[g+159>>0]=0,upb(J|0,243428,155)|0,Y8(-215,G,243584,242941,1709),k[K>>2]=0,k[G>>2]=0,K=k[g>>2]|0,k[g>>2]=K+-1,(K|0)==1):0)ggb(k[g+-4>>2]|0);do if(!(G2(b)|0)){if(((S1(b,-1)|0)&4088|0)==8?((S1(b,-1)|0)&7|0)==4:0)break;g=G+4|0;h=ZT(84)|0;k[h>>2]=1;w=h+4|0;k[G>>2]=w;k[g>>2]=79;i[h+83>>0]=0;x=243597;y=w+79|0;do{i[w>>0]=i[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));Y8(-215,G,243584,242941,1711);k[g>>2]=0;k[G>>2]=0;K=k[h>>2]|0;k[h>>2]=K+-1;if((K|0)==1)ggb(k[h+-4>>2]|0)}while(0);do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[L>>2]=k[j>>2];o=L+4|0;g=j+4|0;k[o>>2]=k[g>>2];K=L+8|0;k[K>>2]=k[j+8>>2];k[L+12>>2]=k[j+12>>2];k[L+16>>2]=k[j+16>>2];k[L+20>>2]=k[j+20>>2];k[L+24>>2]=k[j+24>>2];k[L+28>>2]=k[j+28>>2];k[L+32>>2]=k[j+32>>2];h=k[j+36>>2]|0;k[L+36>>2]=h;a=L+40|0;k[a>>2]=K;K=L+48|0;m=L+44|0;k[m>>2]=K;k[L+52>>2]=0;k[K>>2]=0;if(h|0){K=h+12|0;k[K>>2]=(k[K>>2]|0)+1}if((k[g>>2]|0)<3){J=k[j+44>>2]|0;K=k[m>>2]|0;k[K>>2]=k[J>>2];k[K+4>>2]=k[J+4>>2];break}k[o>>2]=0;x1(L,k[g>>2]|0,0,0,0);if((k[o>>2]|0)>0){n=k[j+40>>2]|0;l=k[a>>2]|0;a=k[j+44>>2]|0;h=k[m>>2]|0;g=0;do{k[l+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[a+(g<<2)>>2];g=g+1|0}while((g|0)<(k[o>>2]|0))}}else Q1(L,a,-1);while(0);j=zY(0)|0;h=(j|0)==0;if(h)F=0;else{while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[g+4>>2]=1;k[g>>2]=63124;k[g+8>>2]=j;F=g}B=k[L+8>>2]|0;J=L+4|0;K=(k[J>>2]|0)==1?1:k[L+12>>2]|0;D=k[L>>2]|0;C=D&4095;I=L+16|0;z=k[I>>2]|0;y=aa((D>>>3&511)+1<<(47696>>>(C<<1&14)&3),K)|0;k[p>>2]=C|1111638016;C=p+4|0;k[C>>2]=y;k[p+8>>2]=0;k[p+12>>2]=0;k[p+16>>2]=z;k[p+20>>2]=B;k[p+24>>2]=K;K=L+44|0;k[C>>2]=k[k[K>>2]>>2];k[p>>2]=D&20479|1111621632;k[q>>2]=0;if(k[c>>2]&2031616|0)L2(c);Gea(p,j,q,d,e,k[f>>2]|0,k[f+4>>2]|0);a=k[q>>2]|0;if(a){if(h){k[G>>2]=0;g=G+4|0;k[g>>2]=0;h=ZT(28)|0;k[h>>2]=1;w=h+4|0;k[G>>2]=w;k[g>>2]=20;i[h+24>>0]=0;x=243280;y=w+20|0;do{i[w>>0]=i[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));Y8(-27,G,212777,211567,3345);k[g>>2]=0;k[G>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0)}B=HY(0,56,4,j)|0;l=a;g=0;while(1){h=k[l+20>>2]|0;if((h|0)!=0?(s=g+1|0,(s|0)!=2147483647):0)g=s;else{j=l;t=37}b:do if((t|0)==37){while(1){t=0;h=k[j+12>>2]|0;if(h|0)break;a=g+-1|0;if((g|0)<1){h=0;g=a;break b}else{j=k[j+16>>2]|0;g=a;t=37}}h=(j|0)==0?0:h}while(0);k[G>>2]=l;SY(B,G)|0;if(!h)break;else l=h}k[G>>2]=0;if(!B)C=0;else{if((k[B+28>>2]|0)!=4){k[G>>2]=0;g=G+4|0;k[g>>2]=0;h=ZT(44)|0;k[h>>2]=1;w=h+4|0;k[G>>2]=w;k[g>>2]=39;i[h+43>>0]=0;x=379582;y=w+39|0;do{i[w>>0]=i[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));Y8(-215,G,379622,379626,2942);k[g>>2]=0;k[G>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0)}C=k[B+24>>2]|0}k[G>>2]=C;j=G+4|0;k[j>>2]=1;P1(b,2,G,0,-1,1,0);KY(B,H);D=H+32|0;k[D>>2]=0;z=(C|0)>0;if(z){l=H+12|0;m=G+4|0;n=G+16|0;o=G+36|0;d=G+40|0;e=G+48|0;f=G+44|0;p=A+4|0;q=H+20|0;s=H+4|0;t=H+8|0;u=H+16|0;v=G+32|0;a=0;g=k[l>>2]|0;do{g=k[g>>2]|0;k[g+72>>2]=a;k[G>>2]=k[g+24>>2];k[j>>2]=1;P1(b,2,G,12,a,1,0);Q1(G,b,a);if(!(k[G>>2]&16384)){k[A>>2]=0;k[p>>2]=0;h=ZT(24)|0;k[h>>2]=1;w=h+4|0;k[A>>2]=w;k[p>>2]=17;i[h+21>>0]=0;x=243677;y=w+17|0;do{i[w>>0]=i[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));Y8(-215,A,243584,242941,1735);k[p>>2]=0;k[A>>2]=0;y=k[h>>2]|0;k[h>>2]=y+-1;if((y|0)==1)ggb(k[h+-4>>2]|0)}JY(g,k[n>>2]|0,0,1073741823);g=k[o>>2]|0;if(g|0?(x=g+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){h=k[o>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[v>>2]|0;if(g|0)break;g=B1()|0;h=k[o>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[o>>2]=0}k[o>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[m>>2]|0)>0){h=k[d>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[m>>2]|0))}g=k[f>>2]|0;if(!((g|0)==(e|0)|(g|0)==0))ggb(k[g+-4>>2]|0);a=a+1|0;g=(k[l>>2]|0)+4|0;k[l>>2]=g;if(g>>>0<(k[q>>2]|0)>>>0)h=k[s>>2]|0;else{y=k[(k[t>>2]|0)+4>>2]|0;k[t>>2]=y;g=k[y+16>>2]|0;k[l>>2]=g;w=g;h=k[s>>2]|0;x=k[h+28>>2]|0;y=k[y+12>>2]|0;k[u>>2]=w;y=w+(aa(x,y)|0)|0;k[q>>2]=y}y=(k[D>>2]|0)+1|0;k[D>>2]=y;k[D>>2]=(y|0)<(k[h+24>>2]<<1|0)?y:0}while((a|0)<(C|0))}if(k[c>>2]&2031616|0){k[G>>2]=1;k[j>>2]=C;P1(c,2,G,28,-1,1,0);do if((k[c>>2]&2031616|0)==65536){j=k[c+4>>2]|0;k[E>>2]=k[j>>2];n=E+4|0;g=j+4|0;k[n>>2]=k[g>>2];c=E+8|0;k[c>>2]=k[j+8>>2];k[E+12>>2]=k[j+12>>2];e=E+16|0;k[e>>2]=k[j+16>>2];k[E+20>>2]=k[j+20>>2];k[E+24>>2]=k[j+24>>2];k[E+28>>2]=k[j+28>>2];k[E+32>>2]=k[j+32>>2];d=E+36|0;h=k[j+36>>2]|0;k[d>>2]=h;a=E+40|0;k[a>>2]=c;c=E+48|0;o=E+44|0;k[o>>2]=c;k[E+52>>2]=0;k[c>>2]=0;if(h|0){c=h+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[g>>2]|0)<3){l=k[j+44>>2]|0;j=k[o>>2]|0;k[j>>2]=k[l>>2];k[j+4>>2]=k[l+4>>2];j=d;l=e;break}k[n>>2]=0;x1(E,k[g>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[j+40>>2]|0;l=k[a>>2]|0;h=k[j+44>>2]|0;a=k[o>>2]|0;g=0;do{k[l+(g<<2)>>2]=k[m+(g<<2)>>2];k[a+(g<<2)>>2]=k[h+(g<<2)>>2];g=g+1|0}while((g|0)<(k[n>>2]|0));j=d;l=e}else{j=d;l=e}}else{Q1(E,c,-1);o=E+44|0;j=E+36|0;l=E+16|0}while(0);p=k[l>>2]|0;g=k[j>>2]|0;if(g|0?(A=g+12|0,c=k[A>>2]|0,k[A>>2]=c+-1,(c|0)==1):0){a=E+36|0;h=k[a>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[E+32>>2]|0;if(g|0)break;g=B1()|0;h=k[a>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[a>>2]=0}k[j>>2]=0;a=E+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[a>>2]|0)>0){h=k[E+40>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[a>>2]|0))}g=k[o>>2]|0;if(!((g|0)==(E+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);KY(B,G);k[G+32>>2]=0;w=H;x=G;y=w+36|0;do{k[w>>2]=k[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));if(z){o=H+12|0;d=H+20|0;e=H+4|0;f=H+8|0;n=H+16|0;m=0;g=k[o>>2]|0;do{a=k[g>>2]|0;g=k[a+12>>2]|0;if(!g)l=-1;else l=k[g+72>>2]|0;g=k[a+8>>2]|0;if(!g)j=-1;else j=k[g+72>>2]|0;g=k[a+20>>2]|0;if(!g)h=-1;else h=k[g+72>>2]|0;g=k[a+16>>2]|0;if(!g)g=-1;else g=k[g+72>>2]|0;k[p+(m<<4)>>2]=l;k[p+(m<<4)+4>>2]=j;k[p+(m<<4)+8>>2]=h;k[p+(m<<4)+12>>2]=g;m=m+1|0;g=(k[o>>2]|0)+4|0;k[o>>2]=g;if(g>>>0<(k[d>>2]|0)>>>0)h=k[e>>2]|0;else{H=k[(k[f>>2]|0)+4>>2]|0;k[f>>2]=H;g=k[H+16>>2]|0;k[o>>2]=g;E=g;h=k[e>>2]|0;G=k[h+28>>2]|0;H=k[H+12>>2]|0;k[n>>2]=E;H=E+(aa(G,H)|0)|0;k[d>>2]=H}H=(k[D>>2]|0)+1|0;k[D>>2]=H;k[D>>2]=(H|0)<(k[h+24>>2]<<1|0)?H:0}while((m|0)!=(C|0))}}}else L2(b);if(F|0?(G=F+4|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0)Uh[k[(k[F>>2]|0)+8>>2]&2047](F);a=L+36|0;g=k[a>>2]|0;if(g|0?(G=g+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){h=k[a>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[L+32>>2]|0;if(!g){g=B1()|0;h=k[a>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[a>>2]=0}k[a>>2]=0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[J>>2]|0)>0){h=k[L+40>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[J>>2]|0))}g=k[K>>2]|0;if((g|0)==(L+48|0)|(g|0)==0){r=M;return}ggb(k[g+-4>>2]|0);r=M;return}function Kea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0;L=r;r=r+3360|0;K=L+3304|0;J=L+2240|0;I=L+1176|0;H=L+112|0;E=L;z=L+56|0;do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[K>>2]=k[g>>2];m=K+4|0;a=g+4|0;k[m>>2]=k[a>>2];G=K+8|0;k[G>>2]=k[g+8>>2];k[K+12>>2]=k[g+12>>2];k[K+16>>2]=k[g+16>>2];k[K+20>>2]=k[g+20>>2];k[K+24>>2]=k[g+24>>2];k[K+28>>2]=k[g+28>>2];k[K+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[K+36>>2]=e;f=K+40|0;k[f>>2]=G;G=K+48|0;j=K+44|0;k[j>>2]=G;k[K+52>>2]=0;k[G>>2]=0;if(e|0){G=e+12|0;k[G>>2]=(k[G>>2]|0)+1}if((k[a>>2]|0)<3){G=k[g+44>>2]|0;m=k[j>>2]|0;k[m>>2]=k[G>>2];k[m+4>>2]=k[G+4>>2];m=K;break}k[m>>2]=0;x1(K,k[a>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[l+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0));m=K}else m=K}else{Q1(K,a,-1);m=K}while(0);n=y2(K,2,-1,1)|0;x=k[m>>2]&7;if(!((n|0)>-1&(x|1|0)==5)){k[J>>2]=0;a=J+4|0;k[a>>2]=0;e=ZT(56)|0;k[e>>2]=1;h=e+4|0;k[J>>2]=h;k[a>>2]=50;i[e+54>>0]=0;j=243695;l=h+50|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,J,243746,243757,134);k[a>>2]=0;k[J>>2]=0;G=k[e>>2]|0;k[e>>2]=G+-1;if((G|0)==1)ggb(k[e+-4>>2]|0)}if(n){if((k[b>>2]|0)<0)v=(S1(b,-1)|0)!=4;else v=d;t=(x|0)==5;F=J+8|0;k[J>>2]=F;G=J+4|0;k[G>>2]=264;h=n>>>0>264;if(h){e=n>>>0>1073741823?-1:n<<2;e=(e|0)==0?1:e;while(1){a=fgb(e)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[J>>2]=a}else a=F;k[G>>2]=n;g=n+2|0;C=I+8|0;k[I>>2]=C;D=I+4|0;k[D>>2]=264;if(g>>>0>264){f=g>>>0>1073741823?-1:g<<2;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[I>>2]=e}else e=C;k[D>>2]=g;A=H+8|0;k[H>>2]=A;B=H+4|0;k[B>>2]=264;if(h){g=n>>>0>1073741823?-1:n<<2;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[H>>2]=f;y=f}else y=A;k[B>>2]=n;w=k[K+16>>2]|0;if(!(k[m>>2]&16384)){k[E>>2]=0;f=E+4|0;k[f>>2]=0;g=ZT(28)|0;k[g>>2]=1;h=g+4|0;k[E>>2]=h;k[f>>2]=21;i[g+25>>0]=0;j=243827;l=h+21|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,E,243746,243757,153);k[f>>2]=0;k[E>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}if((n|0)>0){f=0;do{k[a+(f<<2)>>2]=w+(f<<3);f=f+1|0}while((f|0)!=(n|0))}f=a+(n<<2)|0;if(t){Mea(a,f);if((n|0)>1){f=0;g=0;h=1;do{M=+o[(k[a+(h<<2)>>2]|0)+4>>2];f=+o[(k[a+(f<<2)>>2]|0)+4>>2]>M?h:f;g=+o[(k[a+(g<<2)>>2]|0)+4>>2]<M?h:g;h=h+1|0}while((h|0)!=(n|0))}else{f=0;g=0}}else{Lea(a,f);if((n|0)>1){f=0;g=0;h=1;do{s=k[(k[a+(h<<2)>>2]|0)+4>>2]|0;f=(k[(k[a+(f<<2)>>2]|0)+4>>2]|0)>(s|0)?h:f;g=(k[(k[a+(g<<2)>>2]|0)+4>>2]|0)<(s|0)?h:g;h=h+1|0}while((h|0)!=(n|0))}else{f=0;g=0}}p=k[a>>2]|0;q=n+-1|0;s=k[a+(q<<2)>>2]|0;if((k[p>>2]|0)==(k[s>>2]|0)?(k[p+4>>2]|0)==(k[s+4>>2]|0):0){k[y>>2]=0;d=1}else{s=e;if(t){j=Oea(a,0,g,e,-1,1)|0;p=e+(j<<2)|0;h=p;g=Oea(a,q,g,p,-1,-1)|0}else{j=Nea(a,0,g,e,-1,1)|0;p=e+(j<<2)|0;h=p;g=Nea(a,q,g,p,-1,-1)|0}m=h;n=c?s:m;p=c?j:g;m=c?m:s;d=c?g:j;l=p+-1|0;if((p|0)>1){h=n;j=w;g=0;do{k[y+(g<<2)>>2]=(k[a+(k[h+(g<<2)>>2]<<2)>>2]|0)-j>>3;g=g+1|0}while((g|0)!=(l|0))}else l=0;if((d|0)>1){h=w;j=d+l+-1|0;g=d;do{g=g+-1|0;N=l;l=l+1|0;k[y+(N<<2)>>2]=(k[a+(k[m+(g<<2)>>2]<<2)>>2]|0)-h>>3}while((l|0)!=(j|0));if((d|0)>2){l=j;n=k[m+4>>2]|0}else{l=j;u=61}}else u=61;if((u|0)==61)if((p|0)>2)n=k[n+(p+-2<<2)>>2]|0;else n=-1;if(t){g=Oea(a,0,f,e,1,-1)|0;N=e+(g<<2)|0;e=N;f=Oea(a,q,f,N,1,1)|0}else{g=Nea(a,0,f,e,1,-1)|0;N=e+(g<<2)|0;e=N;f=Nea(a,q,f,N,1,1)|0}h=e;j=c?h:s;d=c?f:g;h=c?s:h;e=c?g:f;do if((n|0)>-1){m=(d|0)>2;do if(m)f=k[j+4>>2]|0;else{if((d+e|0)<=2){f=-1;break}f=k[h+(2-d<<2)>>2]|0}while(0);if((f|0)!=(n|0)){if((f|0)<=-1){u=76;break}g=k[a+(f<<2)>>2]|0;f=k[a+(n<<2)>>2]|0;if((k[g>>2]|0)!=(k[f>>2]|0)){u=76;break}if((k[g+4>>2]|0)!=(k[f+4>>2]|0)){u=76;break}}e=(e|0)>2?2:e;if(m){n=2;d=1;u=77}else u=76}else u=76;while(0);if((u|0)==76)if((d|0)>1){n=d;d=d+-1|0;u=77}if((u|0)==77){m=w;f=l;g=0;while(1){k[y+(f<<2)>>2]=(k[a+(k[j+(g<<2)>>2]<<2)>>2]|0)-m>>3;g=g+1|0;if((g|0)==(d|0))break;else f=f+1|0}l=n+l+-1|0}if((e|0)>1){j=w;f=l;g=e;while(1){g=g+-1|0;k[y+(f<<2)>>2]=(k[a+(k[h+(g<<2)>>2]<<2)>>2]|0)-j>>3;if((g|0)<=1)break;else f=f+1|0}d=e+l+-1|0}else d=l}if(v){c2(b,d,1,x|8,-1,0,0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[E>>2]=k[g>>2];m=E+4|0;a=g+4|0;k[m>>2]=k[a>>2];N=E+8|0;k[N>>2]=k[g+8>>2];k[E+12>>2]=k[g+12>>2];k[E+16>>2]=k[g+16>>2];k[E+20>>2]=k[g+20>>2];k[E+24>>2]=k[g+24>>2];k[E+28>>2]=k[g+28>>2];k[E+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[E+36>>2]=e;f=E+40|0;k[f>>2]=N;N=E+48|0;j=E+44|0;k[j>>2]=N;k[E+52>>2]=0;k[N>>2]=0;if(e|0){N=e+12|0;k[N>>2]=(k[N>>2]|0)+1}if((k[a>>2]|0)<3){N=k[g+44>>2]|0;a=k[j>>2]|0;k[a>>2]=k[N>>2];k[a+4>>2]=k[N+4>>2];a=E;break}k[m>>2]=0;x1(E,k[a>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[l+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0));a=E}else a=E}else{Q1(E,b,-1);a=E}while(0);if(!(k[a>>2]&16384))f=k[k[E+44>>2]>>2]|0;else f=8;if((d|0)>0){e=k[E+16>>2]|0;a=0;do{N=e+(aa(a,f)|0)|0;z=k[y+(a<<2)>>2]|0;k[N>>2]=k[w+(z<<3)>>2];k[N+4>>2]=k[w+(z<<3)+4>>2];a=a+1|0}while((a|0)!=(d|0))}f=E+36|0;a=k[f>>2]|0;if(a|0?(z=a+12|0,N=k[z>>2]|0,k[z>>2]=N+-1,(N|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;do if(!a){a=k[E+32>>2]|0;if(a|0)break;a=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;N=E+16|0;e=E+4|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[e>>2]|0)>0){f=k[E+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[E+44>>2]|0;if(!((a|0)==(E+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else{j=z+4|0;k[j>>2]=2;m=z+8|0;k[m>>2]=d;k[z+12>>2]=1;g=z+16|0;k[g>>2]=y;k[z+20>>2]=y;f=z+24|0;h=z+40|0;l=f+8|0;k[l>>2]=0;k[l+4>>2]=0;k[h>>2]=m;m=z+48|0;l=z+44|0;k[l>>2]=m;k[z>>2]=1124024324;k[m>>2]=4;k[z+52>>2]=4;a=y+(d<<2)|0;k[z+28>>2]=a;k[f>>2]=a+-4+4;mY(z,b);f=z+36|0;a=k[f>>2]|0;if(a|0?(E=a+12|0,N=k[E>>2]|0,k[E>>2]=N+-1,(N|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;do if(!a){a=k[z+32>>2]|0;if(a|0)break;a=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[j>>2]|0)>0){e=k[h>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[l>>2]|0;if(!((a|0)==(m|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}a=k[H>>2]|0;if((a|0)!=(A|0)){if(a|0)ggb(a);k[H>>2]=A;k[B>>2]=264}a=k[I>>2]|0;if((a|0)!=(C|0)){if(a|0)ggb(a);k[I>>2]=C;k[D>>2]=264}a=k[J>>2]|0;if((a|0)!=(F|0)){if(a|0)ggb(a);k[J>>2]=F;k[G>>2]=264}}else b2(b);f=K+36|0;a=k[f>>2]|0;if(a|0?(J=a+12|0,N=k[J>>2]|0,k[J>>2]=N+-1,(N|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[K+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;N=K+16|0;e=K+4|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[e>>2]|0)>0){f=k[K+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[K+44>>2]|0;if((a|0)==(K+48|0)|(a|0)==0){r=L;return}ggb(k[a+-4>>2]|0);r=L;return}function Lea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a:while(1){p=b;r=b+-4|0;q=b+-8|0;while(1){b:while(1){o=a;c=p-o|0;d=c>>2;switch(d|0){case 2:{t=5;break a}case 3:{t=9;break a}case 4:{t=27;break a}case 5:{t=28;break a}case 1:case 0:{t=136;break a}default:{}}if((c|0)<124){t=30;break a}l=a+(((d|0)/2|0)<<2)|0;do if((c|0)>3996){c=(d|0)/4|0;c=Tea(a,a+(c<<2)|0,l,l+(c<<2)|0,r)|0}else{c=k[l>>2]|0;j=k[a>>2]|0;d=k[c>>2]|0;m=k[j>>2]|0;g=c;n=j;if((d|0)>=(m|0))if((d|0)==(m|0))i=(k[c+4>>2]|0)<(k[j+4>>2]|0);else i=0;else i=1;e=k[r>>2]|0;f=k[e>>2]|0;h=e;if((f|0)>=(d|0))if((f|0)==(d|0))c=(k[e+4>>2]|0)<(k[c+4>>2]|0);else c=0;else c=1;if(!i){if(!c){c=0;break}k[l>>2]=h;k[r>>2]=g;c=k[l>>2]|0;d=k[a>>2]|0;e=k[c>>2]|0;f=k[d>>2]|0;g=d;h=c;if((e|0)>=(f|0)){if((e|0)!=(f|0)){c=1;break}if((k[c+4>>2]|0)>=(k[d+4>>2]|0)){c=1;break}}k[a>>2]=h;k[l>>2]=g;c=2;break}if(c){k[a>>2]=h;k[r>>2]=n;c=1;break}k[a>>2]=g;k[l>>2]=n;c=k[r>>2]|0;d=k[c>>2]|0;e=c;if((d|0)>=(m|0)){if((d|0)!=(m|0)){c=1;break}if((k[c+4>>2]|0)>=(k[j+4>>2]|0)){c=1;break}}k[l>>2]=e;k[r>>2]=n;c=2}while(0);i=k[a>>2]|0;d=k[l>>2]|0;j=k[i>>2]|0;h=k[d>>2]|0;if((j|0)<(h|0)){d=r;break}if((j|0)==(h|0)?(k[i+4>>2]|0)<(k[d+4>>2]|0):0){d=r;break}if((a|0)!=(q|0)){g=d+4|0;d=q;do{e=k[d>>2]|0;f=k[e>>2]|0;if((f|0)<(h|0)){t=111;break b}if((f|0)==(h|0)?(k[e+4>>2]|0)<(k[g>>2]|0):0){t=111;break b}d=d+-4|0}while((a|0)!=(d|0))}c=a+4|0;d=k[r>>2]|0;e=k[d>>2]|0;g=d;do if((j|0)>=(e|0)){if((j|0)==(e|0)?(k[i+4>>2]|0)<(k[d+4>>2]|0):0)break;if((c|0)==(r|0)){t=136;break a}f=i+4|0;while(1){d=k[c>>2]|0;e=k[d>>2]|0;if((j|0)<(e|0))break;if((j|0)==(e|0)?(k[f>>2]|0)<(k[d+4>>2]|0):0)break;c=c+4|0;if((c|0)==(r|0)){t=136;break a}}k[c>>2]=g;k[r>>2]=d;c=c+4|0}while(0);if((c|0)==(r|0)){t=136;break a}else d=r;while(1){g=k[a>>2]|0;f=k[c>>2]|0;h=k[g>>2]|0;e=k[f>>2]|0;g=g+4|0;c:do if((h|0)>=(e|0))do{if((h|0)==(e|0)?(k[g>>2]|0)<(k[f+4>>2]|0):0)break c;c=c+4|0;f=k[c>>2]|0;e=k[f>>2]|0}while((h|0)>=(e|0));while(0);while(1){d=d+-4|0;e=k[d>>2]|0;f=k[e>>2]|0;if((h|0)<(f|0))continue;if((h|0)!=(f|0))break;if((k[g>>2]|0)>=(k[e+4>>2]|0))break}if(c>>>0>=d>>>0){a=c;continue b}o=k[c>>2]|0;k[c>>2]=e;k[d>>2]=o;c=c+4|0}}if((t|0)==111){t=0;k[a>>2]=e;k[d>>2]=i;c=c+1|0}e=a+4|0;d:do if(e>>>0<d>>>0)while(1){j=k[l>>2]|0;i=k[j>>2]|0;j=j+4|0;while(1){f=k[e>>2]|0;g=k[f>>2]|0;if((g|0)>=(i|0)){if((g|0)!=(i|0))break;if((k[f+4>>2]|0)>=(k[j>>2]|0))break}e=e+4|0}d=d+-4|0;h=k[d>>2]|0;g=k[h>>2]|0;e:do if((g|0)>=(i|0))do{if((g|0)==(i|0)?(k[h+4>>2]|0)<(k[j>>2]|0):0)break e;d=d+-4|0;h=k[d>>2]|0;g=k[h>>2]|0}while((g|0)>=(i|0));while(0);if(e>>>0>d>>>0)break d;k[e>>2]=k[d>>2];k[d>>2]=f;l=(l|0)==(e|0)?d:l;e=e+4|0;c=c+1|0}while(0);do if((e|0)!=(l|0)){d=k[l>>2]|0;f=k[e>>2]|0;g=k[d>>2]|0;h=k[f>>2]|0;i=f;j=d;if((g|0)>=(h|0)){if((g|0)!=(h|0))break;if((k[d+4>>2]|0)>=(k[f+4>>2]|0))break}k[e>>2]=j;k[l>>2]=i;c=c+1|0}while(0);if(!c){c=Uea(a,e)|0;d=e+4|0;if(Uea(d,b)|0){t=135;break}if(c){a=d;continue}}n=e;if((n-o|0)>=(p-n|0)){t=134;break}Lea(a,e);a=e+4|0}if((t|0)==134){t=0;Lea(e+4|0,b);b=e;continue}else if((t|0)==135){t=0;if(c){t=136;break}else{b=e;continue}}}if((t|0)==5){f=k[r>>2]|0;g=k[a>>2]|0;b=k[f>>2]|0;c=k[g>>2]|0;d=g;e=f;if((b|0)>=(c|0)){if((b|0)!=(c|0))return;if((k[f+4>>2]|0)>=(k[g+4>>2]|0))return}k[a>>2]=e;k[r>>2]=d;return}else if((t|0)==9){m=a+4|0;b=k[m>>2]|0;i=k[a>>2]|0;c=k[b>>2]|0;j=k[i>>2]|0;f=b;l=i;if((c|0)>=(j|0))if((c|0)==(j|0))g=(k[b+4>>2]|0)<(k[i+4>>2]|0);else g=0;else g=1;d=k[r>>2]|0;e=k[d>>2]|0;h=d;if((e|0)>=(c|0))if((e|0)==(c|0))b=(k[d+4>>2]|0)<(k[b+4>>2]|0);else b=0;else b=1;if(!g){if(!b)return;k[m>>2]=h;k[r>>2]=f;b=k[m>>2]|0;c=k[a>>2]|0;d=k[b>>2]|0;e=k[c>>2]|0;f=c;g=b;if((d|0)>=(e|0)){if((d|0)!=(e|0))return;if((k[b+4>>2]|0)>=(k[c+4>>2]|0))return}k[a>>2]=g;k[m>>2]=f;return}if(b){k[a>>2]=h;k[r>>2]=l;return}k[a>>2]=f;k[m>>2]=l;a=k[r>>2]|0;b=k[a>>2]|0;c=a;if((b|0)>=(j|0)){if((b|0)!=(j|0))return;if((k[a+4>>2]|0)>=(k[i+4>>2]|0))return}k[m>>2]=c;k[r>>2]=l;return}else if((t|0)==27){Sea(a,a+4|0,a+8|0,r)|0;return}else if((t|0)==28){Tea(a,a+4|0,a+8|0,a+12|0,r)|0;return}else if((t|0)==30){c=a+8|0;g=a+4|0;e=k[g>>2]|0;n=k[a>>2]|0;d=k[e>>2]|0;i=k[n>>2]|0;h=e;j=n;if((d|0)>=(i|0))if((d|0)==(i|0))f=(k[e+4>>2]|0)<(k[n+4>>2]|0);else f=0;else f=1;o=k[c>>2]|0;l=k[o>>2]|0;m=o;if((l|0)>=(d|0))if((l|0)==(d|0))d=(k[o+4>>2]|0)<(k[e+4>>2]|0);else d=0;else d=1;do if(!f)if(d){k[g>>2]=m;k[c>>2]=h;if((l|0)>=(i|0)){if((l|0)!=(i|0))break;if((k[o+4>>2]|0)>=(k[n+4>>2]|0))break}k[a>>2]=m;k[g>>2]=j}else{h=m;e=o}else{if(d){k[a>>2]=m;k[c>>2]=j;h=j;e=n;break}k[a>>2]=h;k[g>>2]=j;if((l|0)>=(i|0)){if((l|0)!=(i|0)){h=m;e=o;break}if((k[o+4>>2]|0)>=(k[n+4>>2]|0)){h=m;e=o;break}}k[g>>2]=m;k[c>>2]=j;h=j;e=n}while(0);d=a+12|0;if((d|0)==(b|0))return;while(1){f=k[d>>2]|0;j=k[f>>2]|0;g=k[e>>2]|0;l=f;if((j|0)>=(g|0)){if((j|0)==(g|0)?(s=f+4|0,(k[s>>2]|0)<(k[e+4>>2]|0)):0){i=s;t=53}}else{i=f+4|0;t=53}if((t|0)==53){t=0;k[d>>2]=h;f:do if((c|0)!=(a|0))while(1){e=c+-4|0;f=k[e>>2]|0;g=k[f>>2]|0;h=f;if((j|0)>=(g|0)){if((j|0)!=(g|0))break f;if((k[i>>2]|0)>=(k[f+4>>2]|0))break f}k[c>>2]=h;if((e|0)==(a|0)){c=e;break}else c=e}while(0);k[c>>2]=l}c=d+4|0;if((c|0)==(b|0))break;h=k[d>>2]|0;r=d;d=c;e=h;c=r}return}else if((t|0)==136)return}function Mea(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0,g=0,h=0,i=0,j=0,l=0.0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;a:while(1){q=b;s=b+-4|0;r=b+-8|0;while(1){b:while(1){p=a;c=q-p|0;f=c>>2;switch(f|0){case 2:{u=5;break a}case 3:{u=9;break a}case 4:{u=27;break a}case 5:{u=28;break a}case 1:case 0:{u=136;break a}default:{}}if((c|0)<124){u=30;break a}m=a+(((f|0)/2|0)<<2)|0;do if((c|0)>3996){c=(f|0)/4|0;c=Qea(a,a+(c<<2)|0,m,m+(c<<2)|0,s)|0}else{c=k[m>>2]|0;j=k[a>>2]|0;d=+o[c>>2];l=+o[j>>2];g=c;n=j;if(!(d<l))if(d==l)i=+o[c+4>>2]<+o[j+4>>2];else i=0;else i=1;f=k[s>>2]|0;e=+o[f>>2];h=f;if(!(e<d))if(e==d)c=+o[f+4>>2]<+o[c+4>>2];else c=0;else c=1;if(!i){if(!c){c=0;break}k[m>>2]=h;k[s>>2]=g;c=k[m>>2]|0;f=k[a>>2]|0;d=+o[c>>2];e=+o[f>>2];g=f;h=c;if(!(d<e)){if(!(d==e)){c=1;break}if(!(+o[c+4>>2]<+o[f+4>>2])){c=1;break}}k[a>>2]=h;k[m>>2]=g;c=2;break}if(c){k[a>>2]=h;k[s>>2]=n;c=1;break}k[a>>2]=g;k[m>>2]=n;c=k[s>>2]|0;d=+o[c>>2];f=c;if(!(d<l)){if(!(d==l)){c=1;break}if(!(+o[c+4>>2]<+o[j+4>>2])){c=1;break}}k[m>>2]=f;k[s>>2]=n;c=2}while(0);i=k[a>>2]|0;f=k[m>>2]|0;l=+o[i>>2];e=+o[f>>2];if(l<e){f=s;break}if(l==e?+o[i+4>>2]<+o[f+4>>2]:0){f=s;break}if((a|0)!=(r|0)){h=f+4|0;f=r;do{g=k[f>>2]|0;d=+o[g>>2];if(d<e){u=111;break b}if(d==e?+o[g+4>>2]<+o[h>>2]:0){u=111;break b}f=f+-4|0}while((a|0)!=(f|0))}c=a+4|0;f=k[s>>2]|0;d=+o[f>>2];h=f;do if(!(l<d)){if(l==d?+o[i+4>>2]<+o[f+4>>2]:0)break;if((c|0)==(s|0)){u=136;break a}g=i+4|0;while(1){f=k[c>>2]|0;d=+o[f>>2];if(l<d)break;if(l==d?+o[g>>2]<+o[f+4>>2]:0)break;c=c+4|0;if((c|0)==(s|0)){u=136;break a}}k[c>>2]=h;k[s>>2]=f;c=c+4|0}while(0);if((c|0)==(s|0)){u=136;break a}else f=s;while(1){h=k[a>>2]|0;g=k[c>>2]|0;e=+o[h>>2];d=+o[g>>2];h=h+4|0;c:do if(!(e<d))do{if(e==d?+o[h>>2]<+o[g+4>>2]:0)break c;c=c+4|0;g=k[c>>2]|0;d=+o[g>>2]}while(!(e<d));while(0);while(1){f=f+-4|0;g=k[f>>2]|0;d=+o[g>>2];if(e<d)continue;if(!(e==d))break;if(!(+o[h>>2]<+o[g+4>>2]))break}if(c>>>0>=f>>>0){a=c;continue b}p=k[c>>2]|0;k[c>>2]=g;k[f>>2]=p;c=c+4|0}}if((u|0)==111){u=0;k[a>>2]=g;k[f>>2]=i;c=c+1|0}g=a+4|0;d:do if(g>>>0<f>>>0)while(1){j=k[m>>2]|0;e=+o[j>>2];j=j+4|0;while(1){h=k[g>>2]|0;d=+o[h>>2];if(!(d<e)){if(!(d==e))break;if(!(+o[h+4>>2]<+o[j>>2]))break}g=g+4|0}f=f+-4|0;i=k[f>>2]|0;d=+o[i>>2];e:do if(!(d<e))do{if(d==e?+o[i+4>>2]<+o[j>>2]:0)break e;f=f+-4|0;i=k[f>>2]|0;d=+o[i>>2]}while(!(d<e));while(0);if(g>>>0>f>>>0)break d;k[g>>2]=k[f>>2];k[f>>2]=h;m=(m|0)==(g|0)?f:m;g=g+4|0;c=c+1|0}while(0);do if((g|0)!=(m|0)){f=k[m>>2]|0;h=k[g>>2]|0;d=+o[f>>2];e=+o[h>>2];i=h;j=f;if(!(d<e)){if(!(d==e))break;if(!(+o[f+4>>2]<+o[h+4>>2]))break}k[g>>2]=j;k[m>>2]=i;c=c+1|0}while(0);if(!c){c=Rea(a,g)|0;f=g+4|0;if(Rea(f,b)|0){u=135;break}if(c){a=f;continue}}n=g;if((n-p|0)>=(q-n|0)){u=134;break}Mea(a,g);a=g+4|0}if((u|0)==134){u=0;Mea(g+4|0,b);b=g;continue}else if((u|0)==135){u=0;if(c){u=136;break}else{b=g;continue}}}if((u|0)==5){f=k[s>>2]|0;g=k[a>>2]|0;d=+o[f>>2];e=+o[g>>2];b=g;c=f;if(!(d<e)){if(!(d==e))return;if(!(+o[f+4>>2]<+o[g+4>>2]))return}k[a>>2]=c;k[s>>2]=b;return}else if((u|0)==9){m=a+4|0;b=k[m>>2]|0;i=k[a>>2]|0;d=+o[b>>2];l=+o[i>>2];f=b;j=i;if(!(d<l))if(d==l)g=+o[b+4>>2]<+o[i+4>>2];else g=0;else g=1;c=k[s>>2]|0;e=+o[c>>2];h=c;if(!(e<d))if(e==d)b=+o[c+4>>2]<+o[b+4>>2];else b=0;else b=1;if(!g){if(!b)return;k[m>>2]=h;k[s>>2]=f;b=k[m>>2]|0;c=k[a>>2]|0;d=+o[b>>2];e=+o[c>>2];f=c;g=b;if(!(d<e)){if(!(d==e))return;if(!(+o[b+4>>2]<+o[c+4>>2]))return}k[a>>2]=g;k[m>>2]=f;return}if(b){k[a>>2]=h;k[s>>2]=j;return}k[a>>2]=f;k[m>>2]=j;a=k[s>>2]|0;d=+o[a>>2];b=a;if(!(d<l)){if(!(d==l))return;if(!(+o[a+4>>2]<+o[i+4>>2]))return}k[m>>2]=b;k[s>>2]=j;return}else if((u|0)==27){Pea(a,a+4|0,a+8|0,s)|0;return}else if((u|0)==28){Qea(a,a+4|0,a+8|0,a+12|0,s)|0;return}else if((u|0)==30){c=a+8|0;j=a+4|0;g=k[j>>2]|0;p=k[a>>2]|0;d=+o[g>>2];e=+o[p>>2];i=g;m=p;if(!(d<e))if(d==e)h=+o[g+4>>2]<+o[p+4>>2];else h=0;else h=1;q=k[c>>2]|0;l=+o[q>>2];n=q;if(!(l<d))if(l==d)f=+o[q+4>>2]<+o[g+4>>2];else f=0;else f=1;do if(!h)if(f){k[j>>2]=n;k[c>>2]=i;if(!(l<e)){if(!(l==e))break;if(!(+o[q+4>>2]<+o[p+4>>2]))break}k[a>>2]=n;k[j>>2]=m}else{i=n;g=q}else{if(f){k[a>>2]=n;k[c>>2]=m;i=m;g=p;break}k[a>>2]=i;k[j>>2]=m;if(!(l<e)){if(!(l==e)){i=n;g=q;break}if(!(+o[q+4>>2]<+o[p+4>>2])){i=n;g=q;break}}k[j>>2]=n;k[c>>2]=m;i=m;g=p}while(0);f=a+12|0;if((f|0)==(b|0))return;while(1){h=k[f>>2]|0;e=+o[h>>2];d=+o[g>>2];m=h;if(!(e<d)){if(e==d?(t=h+4|0,+o[t>>2]<+o[g+4>>2]):0){j=t;u=53}}else{j=h+4|0;u=53}if((u|0)==53){u=0;k[f>>2]=i;f:do if((c|0)!=(a|0))while(1){g=c+-4|0;h=k[g>>2]|0;d=+o[h>>2];i=h;if(!(e<d)){if(!(e==d))break f;if(!(+o[j>>2]<+o[h+4>>2]))break f}k[c>>2]=i;if((g|0)==(a|0)){c=g;break}else c=g}while(0);k[c>>2]=m}c=f+4|0;if((c|0)==(b|0))break;i=k[f>>2]|0;s=f;f=c;g=i;c=s}return}else if((u|0)==136)return}function Nea(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=(c|0)>(b|0)?1:-1;g=w+b|0;h=g+w|0;do if((b|0)!=(c|0)){u=k[a+(b<<2)>>2]|0;v=k[a+(c<<2)>>2]|0;if((k[u>>2]|0)==(k[v>>2]|0)?(k[u+4>>2]|0)==(k[v+4>>2]|0):0)break;k[d>>2]=b;u=d+4|0;k[u>>2]=g;v=d+8|0;k[v>>2]=h;t=w+c|0;a:do if((h|0)==(t|0))c=3;else{p=b;c=3;while(1){o=c+-1|0;r=d+(o<<2)|0;s=a+(p<<2)|0;m=k[a+(g<<2)>>2]|0;b:do if((p|0)!=(b|0)){n=m+4|0;i=h;while(1){h=k[n>>2]|0;j=k[a+(i<<2)>>2]|0;l=(k[j+4>>2]|0)-h|0;if((((l|0)>0&1)-(l>>>31)|0)!=(e|0))break;i=i+w|0;k[r>>2]=i;if((i|0)==(t|0))break a}m=k[m>>2]|0;n=k[s>>2]|0;r=m-(k[n>>2]|0)|0;n=h-(k[n+4>>2]|0)|0;s=(aa(n,(k[j>>2]|0)-m|0)|0)-(aa(r,l)|0)|0;if((n|r|0)==0?1:(((s|0)>0&1)-(s>>>31)|0)!=(f|0)){k[d+(c+-2<<2)>>2]=i;h=k[d+(c+-4<<2)>>2]|0;g=p;c=o}else{h=g;g=i;q=15}}else while(1){l=m+4|0;j=h;while(1){h=k[l>>2]|0;n=k[a+(j<<2)>>2]|0;i=(k[n+4>>2]|0)-h|0;if((((i|0)>0&1)-(i>>>31)|0)!=(e|0))break;h=j+w|0;k[r>>2]=h;if((h|0)==(t|0))break a;else j=h}q=k[m>>2]|0;o=k[s>>2]|0;p=q-(k[o>>2]|0)|0;o=h-(k[o+4>>2]|0)|0;q=(aa(o,(k[n>>2]|0)-q|0)|0)-(aa(p,i)|0)|0;if(!((o|p|0)==0?1:(((q|0)>0&1)-(q>>>31)|0)!=(f|0))){h=g;g=j;q=15;break b}k[u>>2]=j;h=j+w|0;k[v>>2]=h;if((h|0)==(t|0))break a;else{g=j;m=n}}while(0);if((q|0)==15){q=0;i=g+w|0;k[d+(c<<2)>>2]=i;c=c+1|0}if((i|0)==(t|0))break;else{p=h;h=i}}}while(0);w=c+-1|0;return w|0}while(0);k[d>>2]=b;w=1;return w|0}function Oea(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0.0,l=0,m=0.0,n=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0;x=(c|0)>(b|0)?1:-1;g=x+b|0;h=g+x|0;do if((b|0)!=(c|0)){v=k[a+(b<<2)>>2]|0;w=k[a+(c<<2)>>2]|0;if(+o[v>>2]==+o[w>>2]?+o[v+4>>2]==+o[w+4>>2]:0)break;k[d>>2]=b;v=d+4|0;k[v>>2]=g;w=d+8|0;k[w>>2]=h;u=x+c|0;a:do if((h|0)==(u|0))c=3;else{q=b;c=3;while(1){l=c+-1|0;s=d+(l<<2)|0;t=a+(q<<2)|0;n=k[a+(g<<2)>>2]|0;p=+o[n+4>>2];b:do if((q|0)==(b|0))while(1){i=h;while(1){l=k[a+(i<<2)>>2]|0;m=+o[l+4>>2];j=m-p;if(((j>0.0&1)-(j<0.0&1)|0)!=(e|0))break;h=i+x|0;k[s>>2]=h;if((h|0)==(u|0))break a;else i=h}z=+o[n>>2];r=k[t>>2]|0;y=z-+o[r>>2];p=p-+o[r+4>>2];j=(+o[l>>2]-z)*p-j*y;if(((j>0.0&1)-(j<0.0&1)|0)==(f|0)?y!=0.0|p!=0.0:0){h=g;g=i;r=16;break b}k[v>>2]=i;h=i+x|0;k[w>>2]=h;if((h|0)==(u|0))break a;else{g=i;p=m;n=l}}else{i=h;while(1){h=k[a+(i<<2)>>2]|0;j=+o[h+4>>2]-p;if(((j>0.0&1)-(j<0.0&1)|0)!=(e|0))break;i=i+x|0;k[s>>2]=i;if((i|0)==(u|0))break a}m=+o[n>>2];t=k[t>>2]|0;y=m-+o[t>>2];z=p-+o[t+4>>2];p=(+o[h>>2]-m)*z-j*y;if(((p>0.0&1)-(p<0.0&1)|0)==(f|0)?y!=0.0|z!=0.0:0){h=g;g=i;r=16;break}k[d+(c+-2<<2)>>2]=i;h=k[d+(c+-4<<2)>>2]|0;g=q;c=l}while(0);if((r|0)==16){r=0;i=g+x|0;k[d+(c<<2)>>2]=i;c=c+1|0}if((i|0)==(u|0))break;else{q=h;h=i}}}while(0);x=c+-1|0;return x|0}while(0);k[d>>2]=b;x=1;return x|0}function Pea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0.0,j=0,l=0,m=0.0,n=0,p=0,q=0,r=0;p=k[b>>2]|0;n=k[a>>2]|0;i=+o[p>>2];m=+o[n>>2];q=p;j=n;if(!(i<m))if(i==m)h=+o[p+4>>2]<+o[n+4>>2];else h=0;else h=1;f=k[c>>2]|0;e=+o[f>>2];l=f;if(!(e<i))if(e==i)g=+o[f+4>>2]<+o[p+4>>2];else g=0;else g=1;do if(!h)if(g){k[b>>2]=l;k[c>>2]=q;f=k[b>>2]|0;g=k[a>>2]|0;e=+o[f>>2];i=+o[g>>2];h=g;j=f;if(!(e<i)){if(!(e==i)){r=1;f=p;j=q;break}if(!(+o[f+4>>2]<+o[g+4>>2])){r=1;f=p;j=q;break}}k[a>>2]=j;k[b>>2]=h;j=k[c>>2]|0;r=2;f=j}else{r=0;j=l}else{if(g){k[a>>2]=l;k[c>>2]=j;r=1;f=n;break}k[a>>2]=q;k[b>>2]=j;f=k[c>>2]|0;e=+o[f>>2];g=f;if(!(e<m)){if(!(e==m)){r=1;j=g;break}if(!(+o[f+4>>2]<+o[n+4>>2])){r=1;j=g;break}}k[b>>2]=g;k[c>>2]=j;r=2;f=n}while(0);g=k[d>>2]|0;e=+o[g>>2];i=+o[f>>2];h=g;if(!(e<i)){if(!(e==i)){b=r;return b|0}if(!(+o[g+4>>2]<+o[f+4>>2])){b=r;return b|0}}k[c>>2]=h;k[d>>2]=j;f=r+1|0;g=k[c>>2]|0;h=k[b>>2]|0;e=+o[g>>2];i=+o[h>>2];j=h;l=g;if(!(e<i)){if(!(e==i)){b=f;return b|0}if(!(+o[g+4>>2]<+o[h+4>>2])){b=f;return b|0}}k[b>>2]=l;k[c>>2]=j;f=r+2|0;g=k[b>>2]|0;h=k[a>>2]|0;e=+o[g>>2];i=+o[h>>2];j=h;l=g;if(!(e<i)){if(!(e==i)){b=f;return b|0}if(!(+o[g+4>>2]<+o[h+4>>2])){b=f;return b|0}}k[a>>2]=l;k[b>>2]=j;b=r+3|0;return b|0}function Qea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,i=0.0,j=0,l=0,m=0;m=Pea(a,b,c,d)|0;j=k[e>>2]|0;l=k[d>>2]|0;h=+o[j>>2];i=+o[l>>2];f=l;g=j;if(!(h<i)){if(!(h==i))return m|0;if(!(+o[j+4>>2]<+o[l+4>>2]))return m|0}k[d>>2]=g;k[e>>2]=f;f=m+1|0;g=k[d>>2]|0;e=k[c>>2]|0;h=+o[g>>2];i=+o[e>>2];j=e;l=g;if(!(h<i)){if(!(h==i)){m=f;return m|0}if(!(+o[g+4>>2]<+o[e+4>>2])){m=f;return m|0}}k[c>>2]=l;k[d>>2]=j;f=m+2|0;g=k[c>>2]|0;e=k[b>>2]|0;h=+o[g>>2];i=+o[e>>2];j=e;l=g;if(!(h<i)){if(!(h==i)){m=f;return m|0}if(!(+o[g+4>>2]<+o[e+4>>2])){m=f;return m|0}}k[b>>2]=l;k[c>>2]=j;f=m+3|0;g=k[b>>2]|0;e=k[a>>2]|0;h=+o[g>>2];i=+o[e>>2];j=e;l=g;if(!(h<i)){if(!(h==i)){m=f;return m|0}if(!(+o[g+4>>2]<+o[e+4>>2])){m=f;return m|0}}k[a>>2]=l;k[b>>2]=j;m=m+4|0;return m|0}function Rea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0.0,g=0,h=0,i=0,j=0,l=0,m=0.0,n=0,p=0,q=0,r=0,s=0;switch(b-a>>2|0){case 2:{g=b+-4|0;h=k[g>>2]|0;i=k[a>>2]|0;f=+o[h>>2];e=+o[i>>2];c=i;d=h;if(!(f<e)){if(!(f==e)){a=1;return a|0}if(!(+o[h+4>>2]<+o[i+4>>2])){a=1;return a|0}}k[a>>2]=d;k[g>>2]=c;a=1;return a|0}case 3:{p=a+4|0;j=b+-4|0;c=k[p>>2]|0;l=k[a>>2]|0;e=+o[c>>2];m=+o[l>>2];h=c;n=l;if(!(e<m))if(e==m)g=+o[c+4>>2]<+o[l+4>>2];else g=0;else g=1;d=k[j>>2]|0;f=+o[d>>2];i=d;if(!(f<e))if(f==e)c=+o[d+4>>2]<+o[c+4>>2];else c=0;else c=1;if(!g){if(!c){a=1;return a|0}k[p>>2]=i;k[j>>2]=h;c=k[p>>2]|0;d=k[a>>2]|0;e=+o[c>>2];f=+o[d>>2];g=d;h=c;if(!(e<f)){if(!(e==f)){a=1;return a|0}if(!(+o[c+4>>2]<+o[d+4>>2])){a=1;return a|0}}k[a>>2]=h;k[p>>2]=g;a=1;return a|0}if(c){k[a>>2]=i;k[j>>2]=n;a=1;return a|0}k[a>>2]=h;k[p>>2]=n;c=k[j>>2]|0;e=+o[c>>2];d=c;if(!(e<m)){if(!(e==m)){a=1;return a|0}if(!(+o[c+4>>2]<+o[l+4>>2])){a=1;return a|0}}k[p>>2]=d;k[j>>2]=n;a=1;return a|0}case 4:{Pea(a,a+4|0,a+8|0,b+-4|0)|0;a=1;return a|0}case 5:{Qea(a,a+4|0,a+8|0,a+12|0,b+-4|0)|0;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{d=a+8|0;j=a+4|0;g=k[j>>2]|0;p=k[a>>2]|0;e=+o[g>>2];f=+o[p>>2];i=g;l=p;if(!(e<f))if(e==f)h=+o[g+4>>2]<+o[p+4>>2];else h=0;else h=1;q=k[d>>2]|0;m=+o[q>>2];n=q;if(!(m<e))if(m==e)c=+o[q+4>>2]<+o[g+4>>2];else c=0;else c=1;do if(!h)if(c){k[j>>2]=n;k[d>>2]=i;if(!(m<f)){if(!(m==f))break;if(!(+o[q+4>>2]<+o[p+4>>2]))break}k[a>>2]=n;k[j>>2]=l}else{i=n;g=q}else{if(c){k[a>>2]=n;k[d>>2]=l;i=l;g=p;break}k[a>>2]=i;k[j>>2]=l;if(!(m<f)){if(!(m==f)){i=n;g=q;break}if(!(+o[q+4>>2]<+o[p+4>>2])){i=n;g=q;break}}k[j>>2]=n;k[d>>2]=l;i=l;g=p}while(0);c=a+12|0;a:do if((c|0)==(b|0)){d=1;c=0}else{n=c;c=0;while(1){h=k[n>>2]|0;f=+o[h>>2];e=+o[g>>2];l=h;if(!(f<e)){if(f==e?(r=h+4|0,+o[r>>2]<+o[g+4>>2]):0){j=r;s=49}}else{j=h+4|0;s=49}if((s|0)==49){s=0;k[n>>2]=i;b:do if((d|0)!=(a|0))while(1){g=d+-4|0;h=k[g>>2]|0;e=+o[h>>2];i=h;if(!(f<e)){if(!(f==e))break b;if(!(+o[j>>2]<+o[h+4>>2]))break b}k[d>>2]=i;if((g|0)==(a|0)){d=g;break}else d=g}while(0);k[d>>2]=l;c=c+1|0;if((c|0)==8){d=0;c=(n+4|0)==(b|0);break a}}d=n+4|0;if((d|0)==(b|0)){d=1;c=0;break a}i=k[n>>2]|0;q=n;n=d;g=i;d=q}}while(0);a=c|d;return a|0}}return 0}function Sea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;n=k[b>>2]|0;m=k[a>>2]|0;g=k[n>>2]|0;l=k[m>>2]|0;o=n;j=m;if((g|0)>=(l|0))if((g|0)==(l|0))h=(k[n+4>>2]|0)<(k[m+4>>2]|0);else h=0;else h=1;f=k[c>>2]|0;e=k[f>>2]|0;i=f;if((e|0)>=(g|0))if((e|0)==(g|0))e=(k[f+4>>2]|0)<(k[n+4>>2]|0);else e=0;else e=1;do if(!h)if(e){k[b>>2]=i;k[c>>2]=o;e=k[b>>2]|0;f=k[a>>2]|0;g=k[e>>2]|0;h=k[f>>2]|0;i=f;j=e;if((g|0)>=(h|0)){if((g|0)!=(h|0)){p=1;f=n;j=o;break}if((k[e+4>>2]|0)>=(k[f+4>>2]|0)){p=1;f=n;j=o;break}}k[a>>2]=j;k[b>>2]=i;j=k[c>>2]|0;p=2;f=j}else{p=0;j=i}else{if(e){k[a>>2]=i;k[c>>2]=j;p=1;f=m;break}k[a>>2]=o;k[b>>2]=j;f=k[c>>2]|0;e=k[f>>2]|0;g=f;if((e|0)>=(l|0)){if((e|0)!=(l|0)){p=1;j=g;break}if((k[f+4>>2]|0)>=(k[m+4>>2]|0)){p=1;j=g;break}}k[b>>2]=g;k[c>>2]=j;p=2;f=m}while(0);e=k[d>>2]|0;g=k[e>>2]|0;h=k[f>>2]|0;i=e;if((g|0)>=(h|0)){if((g|0)!=(h|0)){b=p;return b|0}if((k[e+4>>2]|0)>=(k[f+4>>2]|0)){b=p;return b|0}}k[c>>2]=i;k[d>>2]=j;e=p+1|0;f=k[c>>2]|0;g=k[b>>2]|0;h=k[f>>2]|0;i=k[g>>2]|0;j=g;l=f;if((h|0)>=(i|0)){if((h|0)!=(i|0)){b=e;return b|0}if((k[f+4>>2]|0)>=(k[g+4>>2]|0)){b=e;return b|0}}k[b>>2]=l;k[c>>2]=j;e=p+2|0;f=k[b>>2]|0;g=k[a>>2]|0;h=k[f>>2]|0;i=k[g>>2]|0;j=g;l=f;if((h|0)>=(i|0)){if((h|0)!=(i|0)){b=e;return b|0}if((k[f+4>>2]|0)>=(k[g+4>>2]|0)){b=e;return b|0}}k[a>>2]=l;k[b>>2]=j;b=p+3|0;return b|0}function Tea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=Sea(a,b,c,d)|0;h=k[e>>2]|0;i=k[d>>2]|0;j=k[h>>2]|0;l=k[i>>2]|0;f=i;g=h;if((j|0)>=(l|0)){if((j|0)!=(l|0))return m|0;if((k[h+4>>2]|0)>=(k[i+4>>2]|0))return m|0}k[d>>2]=g;k[e>>2]=f;f=m+1|0;g=k[d>>2]|0;e=k[c>>2]|0;h=k[g>>2]|0;i=k[e>>2]|0;j=e;l=g;if((h|0)>=(i|0)){if((h|0)!=(i|0)){m=f;return m|0}if((k[g+4>>2]|0)>=(k[e+4>>2]|0)){m=f;return m|0}}k[c>>2]=l;k[d>>2]=j;f=m+2|0;g=k[c>>2]|0;e=k[b>>2]|0;h=k[g>>2]|0;i=k[e>>2]|0;j=e;l=g;if((h|0)>=(i|0)){if((h|0)!=(i|0)){m=f;return m|0}if((k[g+4>>2]|0)>=(k[e+4>>2]|0)){m=f;return m|0}}k[b>>2]=l;k[c>>2]=j;f=m+3|0;g=k[b>>2]|0;e=k[a>>2]|0;h=k[g>>2]|0;i=k[e>>2]|0;j=e;l=g;if((h|0)>=(i|0)){if((h|0)!=(i|0)){m=f;return m|0}if((k[g+4>>2]|0)>=(k[e+4>>2]|0)){m=f;return m|0}}k[a>>2]=l;k[b>>2]=j;m=m+4|0;return m|0}function Uea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;switch(b-a>>2|0){case 2:{f=b+-4|0;g=k[f>>2]|0;h=k[a>>2]|0;i=k[g>>2]|0;c=k[h>>2]|0;d=h;e=g;if((i|0)>=(c|0)){if((i|0)!=(c|0)){a=1;return a|0}if((k[g+4>>2]|0)>=(k[h+4>>2]|0)){a=1;return a|0}}k[a>>2]=e;k[f>>2]=d;a=1;return a|0}case 3:{o=a+4|0;j=b+-4|0;c=k[o>>2]|0;l=k[a>>2]|0;d=k[c>>2]|0;m=k[l>>2]|0;h=c;n=l;if((d|0)>=(m|0))if((d|0)==(m|0))g=(k[c+4>>2]|0)<(k[l+4>>2]|0);else g=0;else g=1;e=k[j>>2]|0;f=k[e>>2]|0;i=e;if((f|0)>=(d|0))if((f|0)==(d|0))c=(k[e+4>>2]|0)<(k[c+4>>2]|0);else c=0;else c=1;if(!g){if(!c){a=1;return a|0}k[o>>2]=i;k[j>>2]=h;c=k[o>>2]|0;d=k[a>>2]|0;e=k[c>>2]|0;f=k[d>>2]|0;g=d;h=c;if((e|0)>=(f|0)){if((e|0)!=(f|0)){a=1;return a|0}if((k[c+4>>2]|0)>=(k[d+4>>2]|0)){a=1;return a|0}}k[a>>2]=h;k[o>>2]=g;a=1;return a|0}if(c){k[a>>2]=i;k[j>>2]=n;a=1;return a|0}k[a>>2]=h;k[o>>2]=n;c=k[j>>2]|0;d=k[c>>2]|0;e=c;if((d|0)>=(m|0)){if((d|0)!=(m|0)){a=1;return a|0}if((k[c+4>>2]|0)>=(k[l+4>>2]|0)){a=1;return a|0}}k[o>>2]=e;k[j>>2]=n;a=1;return a|0}case 4:{Sea(a,a+4|0,a+8|0,b+-4|0)|0;a=1;return a|0}case 5:{Tea(a,a+4|0,a+8|0,a+12|0,b+-4|0)|0;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{d=a+8|0;g=a+4|0;e=k[g>>2]|0;n=k[a>>2]|0;c=k[e>>2]|0;i=k[n>>2]|0;h=e;j=n;if((c|0)>=(i|0))if((c|0)==(i|0))f=(k[e+4>>2]|0)<(k[n+4>>2]|0);else f=0;else f=1;o=k[d>>2]|0;l=k[o>>2]|0;m=o;if((l|0)>=(c|0))if((l|0)==(c|0))c=(k[o+4>>2]|0)<(k[e+4>>2]|0);else c=0;else c=1;do if(!f)if(c){k[g>>2]=m;k[d>>2]=h;if((l|0)>=(i|0)){if((l|0)!=(i|0))break;if((k[o+4>>2]|0)>=(k[n+4>>2]|0))break}k[a>>2]=m;k[g>>2]=j}else{h=m;e=o}else{if(c){k[a>>2]=m;k[d>>2]=j;h=j;e=n;break}k[a>>2]=h;k[g>>2]=j;if((l|0)>=(i|0)){if((l|0)!=(i|0)){h=m;e=o;break}if((k[o+4>>2]|0)>=(k[n+4>>2]|0)){h=m;e=o;break}}k[g>>2]=m;k[d>>2]=j;h=j;e=n}while(0);c=a+12|0;a:do if((c|0)==(b|0)){d=1;c=0}else{m=c;c=0;while(1){f=k[m>>2]|0;j=k[f>>2]|0;g=k[e>>2]|0;l=f;if((j|0)>=(g|0)){if((j|0)==(g|0)?(p=f+4|0,(k[p>>2]|0)<(k[e+4>>2]|0)):0){i=p;q=49}}else{i=f+4|0;q=49}if((q|0)==49){q=0;k[m>>2]=h;b:do if((d|0)!=(a|0))while(1){e=d+-4|0;f=k[e>>2]|0;g=k[f>>2]|0;h=f;if((j|0)>=(g|0)){if((j|0)!=(g|0))break b;if((k[i>>2]|0)>=(k[f+4>>2]|0))break b}k[d>>2]=h;if((e|0)==(a|0)){d=e;break}else d=e}while(0);k[d>>2]=l;c=c+1|0;if((c|0)==8){d=0;c=(m+4|0)==(b|0);break a}}d=m+4|0;if((d|0)==(b|0)){d=1;c=0;break a}h=k[m>>2]|0;o=m;m=d;e=h;d=o}}while(0);a=c|d;return a|0}}return 0}function Vea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+4|0;c=k[l>>2]|0;m=k[a>>2]|0;f=c-m>>4;d=f+1|0;if(d>>>0>268435455)ad(426534,426557,304,426811);j=m;h=c;i=a+8|0;g=(k[i>>2]|0)-m|0;e=g>>3;e=g>>4>>>0<134217727?(e>>>0<d>>>0?d:e):268435455;if(!e)d=0;else{if(e>>>0>268435455){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=e<<4;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c}c=d+(f<<4)|0;g=d+(e<<4)|0;k[c>>2]=k[b>>2];k[d+(f<<4)+4>>2]=k[b+4>>2];k[d+(f<<4)+8>>2]=k[b+8>>2];k[d+(f<<4)+12>>2]=k[b+12>>2];f=c+16|0;if((h|0)!=(j|0)){b=h+-16|0;d=h;e=c;while(1){h=d;d=d+-16|0;k[e+-16>>2]=k[d>>2];k[e+-12>>2]=k[h+-12>>2];k[e+-8>>2]=k[h+-8>>2];k[e+-4>>2]=k[h+-4>>2];if((d|0)==(j|0))break;else e=e+-16|0}c=c+(~((b-m|0)>>>4)<<4)|0}k[a>>2]=c;k[l>>2]=f;k[i>>2]=g;if(!m)return;ggb(m);return}function Wea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+128|0;q=s+64|0;n=s;p=s+8|0;do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[q>>2]=k[g>>2];l=q+4|0;a=g+4|0;k[l>>2]=k[a>>2];o=q+8|0;k[o>>2]=k[g+8>>2];k[q+12>>2]=k[g+12>>2];k[q+16>>2]=k[g+16>>2];k[q+20>>2]=k[g+20>>2];k[q+24>>2]=k[g+24>>2];k[q+28>>2]=k[g+28>>2];k[q+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[q+36>>2]=f;m=q+40|0;k[m>>2]=o;o=q+48|0;h=q+44|0;k[h>>2]=o;k[q+52>>2]=0;k[o>>2]=0;if(f|0){o=f+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[a>>2]|0)<3){l=k[g+44>>2]|0;o=k[h>>2]|0;k[o>>2]=k[l>>2];k[o+4>>2]=k[l+4>>2];o=m;break}k[l>>2]=0;x1(q,k[a>>2]|0,0,0,0);if((k[l>>2]|0)>0){i=k[g+40>>2]|0;j=k[m>>2]|0;g=k[g+44>>2]|0;f=k[h>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[i+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[l>>2]|0));o=m}else o=m}else{Q1(q,a,-1);o=q+40|0}while(0);l=k[o>>2]|0;m=k[l>>2]|0;k[n>>2]=k[l+4>>2];k[n+4>>2]=m;x2(b,n,5,0);do if((k[b>>2]&2031616|0)==65536){i=k[b+4>>2]|0;k[p>>2]=k[i>>2];m=p+4|0;f=i+4|0;k[m>>2]=k[f>>2];n=p+8|0;k[n>>2]=k[i+8>>2];k[p+12>>2]=k[i+12>>2];k[p+16>>2]=k[i+16>>2];k[p+20>>2]=k[i+20>>2];k[p+24>>2]=k[i+24>>2];k[p+28>>2]=k[i+28>>2];k[p+32>>2]=k[i+32>>2];a=k[i+36>>2]|0;k[p+36>>2]=a;g=p+40|0;k[g>>2]=n;n=p+48|0;j=p+44|0;k[j>>2]=n;k[p+52>>2]=0;k[n>>2]=0;if(a|0){n=a+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[f>>2]|0)<3){b=k[i+44>>2]|0;n=k[j>>2]|0;k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];break}k[m>>2]=0;x1(p,k[f>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[i+40>>2]|0;h=k[g>>2]|0;g=k[i+44>>2]|0;f=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[l+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0))}}else Q1(p,b,-1);while(0);Xea(q,p,c,d,0,0.0,e);g=p+36|0;a=k[g>>2]|0;if(a|0?(d=a+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[p+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;e=p+16|0;f=p+4|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[f>>2]|0)>0){g=k[p+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[p+44>>2]|0;if(!((a|0)==(p+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=q+36|0;a=k[g>>2]|0;if(a|0?(e=a+12|0,p=k[e>>2]|0,k[e>>2]=p+-1,(p|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;p=q+16|0;g=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[g>>2]|0)>0){f=k[o>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[q+44>>2]|0;if((a|0)==(q+48|0)|(a|0)==0){r=s;return}ggb(k[a+-4>>2]|0);r=s;return}function Xea(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;var h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0.0;$=r;r=r+224|0;G=$+200|0;_=$+144|0;V=$+88|0;O=$+24|0;D=$;E=$+80|0;F=$+16|0;Z=k[a>>2]|0;m=(d|0)>0;s=+(c|0)*(m?+(1<<d+-1|0):4.0);s=(d|0)<0?s*2.0:s;s=1.0/((Z&7|0)==0?s*255.0:s);switch(Z&4095){case 5:case 0:break;default:{h=G+4|0;j=ZT(52)|0;k[j>>2]=1;p=j+4|0;k[G>>2]=p;k[h>>2]=47;i[j+51>>0]=0;l=243967;q=p+47|0;do{i[p>>0]=i[l>>0]|0;p=p+1|0;l=l+1|0}while((p|0)<(q|0));Y8(-215,G,244015,244035,287);k[h>>2]=0;k[G>>2]=0;Z=k[j>>2]|0;k[j>>2]=Z+-1;if((Z|0)==1)ggb(k[j+-4>>2]|0)}}k[_>>2]=1124007936;Y=_+4|0;h=_+8|0;W=_+40|0;p=Y;q=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(q|0));k[W>>2]=h;Z=_+48|0;X=_+44|0;k[X>>2]=Z;k[_+52>>2]=0;k[Z>>2]=0;k[V>>2]=1124007936;T=V+4|0;h=V+8|0;R=V+40|0;p=T;q=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(q|0));k[R>>2]=h;U=V+48|0;S=V+44|0;k[S>>2]=U;k[V+52>>2]=0;k[U>>2]=0;if(m){k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=a;N=O+4|0;M=N+4|0;k[M>>2]=0;k[M+4>>2]=0;k[O>>2]=33619968;k[N>>2]=_;tfa(G,O,5,1,0,d,s,0.0,g);k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=a;N=O+4|0;M=N+4|0;k[M>>2]=0;k[M+4>>2]=0;k[O>>2]=33619968;k[N>>2]=V;tfa(G,O,5,0,1,d,s,0.0,g)}else{k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=a;N=O+4|0;M=N+4|0;k[M>>2]=0;k[M+4>>2]=0;k[O>>2]=33619968;k[N>>2]=_;ufa(G,O,5,1,0,s,0.0,g);k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=a;N=O+4|0;M=N+4|0;k[M>>2]=0;k[M+4>>2]=0;k[O>>2]=33619968;k[N>>2]=V;ufa(G,O,5,0,1,s,0.0,g)}n=k[a+40>>2]|0;d=k[n+4>>2]|0;n=k[n>>2]|0;k[O>>2]=1124007936;N=O+4|0;h=O+8|0;L=O+40|0;p=N;q=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(q|0));k[L>>2]=h;M=O+48|0;K=O+44|0;k[K>>2]=M;k[O+52>>2]=0;k[M>>2]=0;k[G>>2]=n;k[G+4>>2]=d;G1(O,2,G,21);if((n|0)>0?(H=k[O+16>>2]|0,I=k[k[K>>2]>>2]|0,t=k[_+16>>2]|0,A=k[k[X>>2]>>2]|0,B=k[V+16>>2]|0,C=k[k[S>>2]>>2]|0,(d|0)>0):0){h=0;do{l=H+(aa(I,h)|0)|0;a=t+(aa(A,h)|0)|0;m=B+(aa(C,h)|0)|0;j=0;do{y=+o[a+(j<<2)>>2];z=+o[m+(j<<2)>>2];q=j*3|0;o[l+(q<<2)>>2]=y*y;o[l+(q+1<<2)>>2]=y*z;o[l+(q+2<<2)>>2]=z*z;j=j+1|0}while((j|0)!=(d|0));h=h+1|0}while((h|0)!=(n|0))}k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=O;I=D+4|0;H=I+4|0;k[H>>2]=0;k[H+4>>2]=0;k[D>>2]=33619968;k[I>>2]=O;I=k[O>>2]&7;k[E>>2]=c;k[E+4>>2]=c;k[F>>2]=-1;k[F+4>>2]=-1;_ta(G,D,I,E,F,0,g);a:do switch(e|0){case 0:{t=k[b+16>>2]|0;l=k[b+44>>2]|0;j=k[L>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;if(k[O>>2]&16384){b=(k[b>>2]&16384|0)!=0;h=aa(b?j:1,h)|0;if(b)j=1;else J=16}else J=16;if((J|0)==16)if((j|0)<=0)break a;p=k[O+16>>2]|0;q=k[k[K>>2]>>2]|0;m=k[l>>2]|0;if((h|0)>0){a=0;do{d=p+(aa(a,q)|0)|0;n=t+(aa(a,m)|0)|0;l=0;do{J=l*3|0;w=+o[d+(J<<2)>>2]*.5;y=+o[d+(J+1<<2)>>2];x=+o[d+(J+2<<2)>>2]*.5;z=w-x;z=w+x-+Q(+(y*y+z*z));o[n+(l<<2)>>2]=z;l=l+1|0}while((l|0)!=(h|0));a=a+1|0}while((a|0)!=(j|0))}break}case 1:{t=k[b+16>>2]|0;l=k[b+44>>2]|0;j=k[L>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;if(k[O>>2]&16384){b=(k[b>>2]&16384|0)!=0;h=aa(b?j:1,h)|0;if(b)j=1;else J=23}else J=23;if((J|0)==23)if((j|0)<=0)break a;p=k[O+16>>2]|0;q=k[k[K>>2]>>2]|0;m=k[l>>2]|0;if((h|0)>0){a=0;do{d=p+(aa(a,q)|0)|0;n=t+(aa(a,m)|0)|0;l=0;do{J=l*3|0;w=+o[d+(J<<2)>>2];y=+o[d+(J+1<<2)>>2];x=+o[d+(J+2<<2)>>2];z=w+x;o[n+(l<<2)>>2]=w*x-y*y-z*(z*f);l=l+1|0}while((l|0)!=(h|0));a=a+1|0}while((a|0)!=(j|0))}break}case 2:{B=k[b+16>>2]|0;l=k[b+44>>2]|0;j=k[L>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;if(k[O>>2]&16384){b=(k[b>>2]&16384|0)!=0;h=aa(b?j:1,h)|0;if(b)j=1;else J=30}else J=30;if((J|0)==30)if((j|0)<=0)break a;t=k[O+16>>2]|0;A=k[k[K>>2]>>2]|0;d=k[l>>2]|0;n=(h|0)>0;m=0;do{p=t+(aa(m,A)|0)|0;q=B+(aa(m,d)|0)|0;if(n){a=0;do{J=a*3|0;v=+o[p+(J<<2)>>2];y=+o[p+(J+1<<2)>>2];s=y;x=+o[p+(J+2<<2)>>2];f=(v+x)*.5;z=v-x;z=+Q(+(s*s+z*z*.25));w=z+f;z=f-z;f=w-v;y=+P(+y);if(y+ +P(+f)<.0001){u=w-x;f=y+ +P(+u);if(f<.0001){ba=1.0/(f+1.1920928955078125e-07);f=s*ba;u=u*ba}else f=s}else u=s;ba=1.0/+Q(+(u*u+f*f+2.220446049250313e-16));l=a*6|0;o[q+(l<<2)>>2]=w;o[q+(l+2<<2)>>2]=u*ba;o[q+(l+3<<2)>>2]=f*ba;f=z-v;if(y+ +P(+f)<.0001){u=z-x;f=y+ +P(+u);if(f<.0001){ba=1.0/(f+1.1920928955078125e-07);f=s*ba;s=u*ba}else{f=s;s=u}}ba=1.0/+Q(+(s*s+f*f+2.220446049250313e-16));o[q+((l|1)<<2)>>2]=z;o[q+(l+4<<2)>>2]=s*ba;o[q+(l+5<<2)>>2]=f*ba;a=a+1|0}while((a|0)!=(h|0))}m=m+1|0}while((m|0)!=(j|0));break}default:{}}while(0);l=O+36|0;h=k[l>>2]|0;if(h|0?(b=h+12|0,J=k[b>>2]|0,k[b>>2]=J+-1,(J|0)==1):0){j=k[l>>2]|0;if(j|0){h=k[j+4>>2]|0;if(!h){h=k[O+32>>2]|0;if(!h){h=B1()|0;j=k[l>>2]|0}}jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[l>>2]=0}k[l>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[N>>2]|0)>0){j=k[L>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[N>>2]|0))}h=k[K>>2]|0;if(!((h|0)==(M|0)|(h|0)==0))ggb(k[h+-4>>2]|0);l=V+36|0;h=k[l>>2]|0;if(h|0?(N=h+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){j=k[l>>2]|0;if(j|0){h=k[j+4>>2]|0;if(!h){h=k[V+32>>2]|0;if(!h){h=B1()|0;j=k[l>>2]|0}}jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[l>>2]=0}k[l>>2]=0;V=V+16|0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[T>>2]|0)>0){j=k[R>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[T>>2]|0))}h=k[S>>2]|0;if(!((h|0)==(U|0)|(h|0)==0))ggb(k[h+-4>>2]|0);l=_+36|0;h=k[l>>2]|0;if(h|0?(U=h+12|0,V=k[U>>2]|0,k[U>>2]=V+-1,(V|0)==1):0){j=k[l>>2]|0;if(j|0){h=k[j+4>>2]|0;if(!h){h=k[_+32>>2]|0;if(!h){h=B1()|0;j=k[l>>2]|0}}jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[l>>2]=0}k[l>>2]=0;_=_+16|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[Y>>2]|0)>0){j=k[W>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[Y>>2]|0))}h=k[X>>2]|0;if((h|0)==(Z|0)|(h|0)==0){r=$;return}ggb(k[h+-4>>2]|0);r=$;return}
function UQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0.0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0;ca=r;r=r+192|0;V=ca+144|0;_=ca+100|0;$=ca+56|0;t=ca+48|0;ba=ca;k[t>>2]=k[c>>2];k[t+4>>2]=k[c+4>>2];EQa(a,0,t)|0;t=b+4|0;c=k[t>>2]|0;a:do if(!c){c=1;T=6}else{d=k[c>>2]|0;switch(d&7){case 6:{U=k[(k[c+8>>2]|0)+60>>2]|0;break a}case 5:{U=k[(k[c+8>>2]|0)+24>>2]|0;break a}default:{c=(d&7|0)==0;T=6;break a}}}while(0);if((T|0)==6)U=c&1^1;y=(U|0)==0;if(y?(S=V+4|0,e=ZT(12)|0,k[e>>2]=1,R=e+4|0,k[V>>2]=R,k[S>>2]=5,i[e+9>>0]=0,i[R>>0]=i[378685]|0,i[R+1>>0]=i[378686]|0,i[R+2>>0]=i[378687]|0,i[R+3>>0]=i[378688]|0,i[R+4>>0]=i[378689]|0,Y8(-215,V,401059,378394,570),k[S>>2]=0,k[V>>2]=0,S=k[e>>2]|0,k[e>>2]=S+-1,(S|0)==1):0)ggb(k[e+-4>>2]|0);f=a+356|0;v=a+360|0;if(!(k[v>>2]|0)){while(1){g=fgb(12)|0;if(g|0)break;S=k[207666]|0;k[207666]=S+0;Qh[S&7]()}k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=95244;k[c+8>>2]=g;k[d>>2]=(k[d>>2]|0)+1;e=k[f>>2]|0;k[f>>2]=c;k[v>>2]=g;if(e|0?(R=e+4|0,S=k[R>>2]|0,k[R>>2]=S+-1,(S|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);S=k[d>>2]|0;k[d>>2]=S+-1;if((S|0)==1)Uh[k[(k[c>>2]|0)+8>>2]&2047](c)}f=a+364|0;g=a+368|0;if(!(k[g>>2]|0)){while(1){h=fgb(12)|0;if(h|0)break;S=k[207666]|0;k[207666]=S+0;Qh[S&7]()}k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=95264;k[c+8>>2]=h;k[d>>2]=(k[d>>2]|0)+1;e=k[f>>2]|0;k[f>>2]=c;k[g>>2]=h;if(e|0?(R=e+4|0,S=k[R>>2]|0,k[R>>2]=S+-1,(S|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);S=k[d>>2]|0;k[d>>2]=S+-1;if((S|0)==1)Uh[k[(k[c>>2]|0)+8>>2]&2047](c)}f=a+372|0;g=a+376|0;if(!(k[g>>2]|0)){while(1){h=fgb(12)|0;if(h|0)break;S=k[207666]|0;k[207666]=S+0;Qh[S&7]()}k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=95264;k[c+8>>2]=h;k[d>>2]=(k[d>>2]|0)+1;e=k[f>>2]|0;k[f>>2]=c;k[g>>2]=h;if(e|0?(R=e+4|0,S=k[R>>2]|0,k[R>>2]=S+-1,(S|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);S=k[d>>2]|0;k[d>>2]=S+-1;if((S|0)==1)Uh[k[(k[c>>2]|0)+8>>2]&2047](c)}q=k[v>>2]|0;s=q+4|0;f=k[s>>2]|0;g=k[q>>2]|0;h=f-g>>6;d=g;c=f;b:do if(U>>>0>h>>>0){d=U-h|0;n=q+8|0;e=k[n>>2]|0;if(e-f>>6>>>0>=d>>>0)while(1){i[c>>0]=0;e=c+4|0;g=e+60|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(g|0));c=(k[s>>2]|0)+64|0;k[s>>2]=c;d=d+-1|0;if(!d)break b}if(U>>>0>67108863)ad(426534,426557,304,426811);S=e-g|0;f=S>>5;f=S>>6>>>0<33554431?(f>>>0<U>>>0?U:f):67108863;if(!f)c=0;else{if(f>>>0>67108863){ca=te(4)|0;k[ca>>2]=172664;Cf(ca|0,28816,1287)}e=f<<6;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}l=c+(h<<6)|0;h=l;j=h;e=l;do{i[e>>0]=0;e=e+4|0;g=e+60|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(g|0));e=j+64|0;j=e;d=d+-1|0}while((d|0)!=0);f=c+(f<<6)|0;g=k[q>>2]|0;c=k[s>>2]|0;if((c|0)==(g|0))c=h;else{e=c+-64|0;d=l;while(1){S=c;c=c+-64|0;i[d+-64>>0]=i[c>>0]|0;k[d+-60>>2]=k[S+-60>>2];k[d+-56>>2]=k[S+-56>>2];k[d+-52>>2]=k[S+-52>>2];k[d+-48>>2]=k[S+-48>>2];k[d+-44>>2]=k[S+-44>>2];k[d+-40>>2]=k[S+-40>>2];k[d+-36>>2]=k[S+-36>>2];k[d+-32>>2]=k[S+-32>>2];k[d+-28>>2]=k[S+-28>>2];k[d+-24>>2]=k[S+-24>>2];k[d+-20>>2]=k[S+-20>>2];k[d+-16>>2]=k[S+-16>>2];k[d+-12>>2]=k[S+-12>>2];k[d+-8>>2]=k[S+-8>>2];k[d+-4>>2]=k[S+-4>>2];if((c|0)==(g|0))break;else d=d+-64|0}c=l+(~((e-g|0)>>>6)<<6)|0}k[q>>2]=c;k[s>>2]=j;k[n>>2]=f;if(g|0)ggb(g)}else if(U>>>0<h>>>0?(j=d+(U<<6)|0,(c|0)!=(j|0)):0)k[s>>2]=c+(~((c+-64-j|0)>>>6)<<6);while(0);c=k[b>>2]|0;e=k[t>>2]|0;do if((c|0)!=0&(e|0)!=0?(w=k[e>>2]|0,x=w&7,(x|0)!=0):0){k[ba>>2]=c;k[ba+4>>2]=e;if(!((x+-5|0)>>>0<2&(w&16|0)==0)){k[ba+20>>2]=e;k[ba+12>>2]=0;k[ba+40>>2]=1;break}d=e+8|0;KY(k[d>>2]|0,ba+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[ba+40>>2]=c}else T=80;while(0);if((T|0)==80){k[ba>>2]=0;k[ba+4>>2]=0;k[ba+20>>2]=0;k[ba+40>>2]=0}S=a+380|0;i[S>>0]=0;R=k[v>>2]|0;k[a+16>>2]=0;k[a+20>>2]=0;f=a+276|0;c=k[f>>2]|0;if(c|0?(Q=c+8|0,T=k[Q>>2]|0,k[Q>>2]=T+-1,(T|0)==1):0){T=k[f>>2]|0;Q=k[T+4>>2]|0;jh[k[(k[Q>>2]|0)+16>>2]&1023](Q,T);k[f>>2]=0}d=a+256|0;if((k[d>>2]|0)>0){e=k[a+284>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}k[f>>2]=0;if(y){$=i[S>>0]|0;$=$<<24>>24!=0;$=$?3:2;_=a+40|0;k[_>>2]=$;_=a+8|0;_=k[_>>2]|0;_=_+-2|0;$=a+12|0;$=k[$>>2]|0;$=$+-2|0;ba=a+408|0;k[ba>>2]=1;ba=a+412|0;k[ba>>2]=1;ba=a+416|0;k[ba>>2]=_;ba=a+420|0;k[ba>>2]=$;ba=a+24|0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;r=ca;return 1}q=ba+20|0;s=V+4|0;b=V+8|0;t=V+40|0;v=V+20|0;w=V+12|0;x=_+4|0;y=_+20|0;z=_+40|0;A=$+20|0;B=$+4|0;C=$+8|0;D=$+40|0;E=$+12|0;F=V+28|0;G=V+16|0;H=V+24|0;I=$+28|0;J=$+16|0;K=$+24|0;L=ba+40|0;M=ba+12|0;N=ba+28|0;O=ba+16|0;P=ba+24|0;n=0;Q=k[R>>2]|0;do{T=k[ba>>2]|0;l=k[q>>2]|0;j=T;e=k6(j,l,380573)|0;if((T|0)!=0&(e|0)!=0?(W=k[e>>2]|0,X=W&7,(X|0)!=0):0){k[V>>2]=j;k[s>>2]=e;if((X+-5|0)>>>0<2&(W&16|0)==0){c=e+8|0;KY(k[c>>2]|0,b);d=k[e>>2]|0;switch(d&7){case 6:{c=k[(k[c>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[c>>2]|0)+24>>2]|0;break}default:c=(d&7|0)!=0&1}k[t>>2]=c}else{k[v>>2]=e;k[w>>2]=0;k[t>>2]=1}T=100}else{k[V>>2]=0;k[s>>2]=0;k[v>>2]=0;k[t>>2]=0;if(!e){c=1;T=104}else T=100}c:do if((T|0)==100){T=0;c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[e+8>>2]|0)+60>>2]|0;break c}case 5:{c=k[(k[e+8>>2]|0)+24>>2]|0;break c}default:{c=(c&7|0)==0;T=104;break c}}}while(0);if((T|0)==104){T=0;c=c&1^1}B6(_,j,e,c);e=Q+(n<<6)+4|0;g=e+60|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(g|0));h=0;while(1){c=k[V>>2]|0;if((((c|0)==(k[_>>2]|0)?(k[s>>2]|0)==(k[x>>2]|0):0)?(k[v>>2]|0)==(k[y>>2]|0):0)?(k[t>>2]|0)==(k[z>>2]|0):0)break;e=k[v>>2]|0;d:do if((c|0)!=0&(e|0)!=0?(Y=k[e>>2]|0,Z=Y&7,(Z|0)!=0):0){k[$>>2]=c;k[B>>2]=e;if((Z+-5|0)>>>0<2&(Y&16|0)==0){d=e+8|0;KY(k[d>>2]|0,C);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[D>>2]=c;e=k[A>>2]|0;d=Q+(n<<6)+4+(h*20|0)|0;if(!e){f=0;g=e;c=e;break}else{c=e;g=e}}else{k[A>>2]=e;k[E>>2]=0;k[D>>2]=1;c=e;d=Q+(n<<6)+4+(h*20|0)|0;g=e}switch(k[c>>2]&7){case 1:{f=k[c+8>>2]|0;break d}case 2:break;default:{f=2147483647;break d}}m=+p[c+8>>3];p[u>>3]=m;e=k[u+4>>2]|0;f=e&2146435072;do if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){e=(e|0)<0;m=e?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(!(m==0.0))break;m=e?-0.0:0.0}while(0);f=~~m}else T=118;while(0);if((T|0)==118){T=0;k[$>>2]=0;k[B>>2]=0;k[A>>2]=0;k[D>>2]=0;f=0;d=Q+(n<<6)+4+(h*20|0)|0;g=0;c=0}k[d>>2]=f;e=k[D>>2]|0;if(e){d=k[E>>2]|0;if(d){c=g+(k[d+28>>2]|0)|0;k[A>>2]=c;if(c>>>0<(k[I>>2]|0)>>>0)d=c;else{da=k[(k[J>>2]|0)+4>>2]|0;k[J>>2]=da;c=k[da+16>>2]|0;k[A>>2]=c;g=c;f=k[d+28>>2]|0;d=k[da+12>>2]|0;k[K>>2]=g;d=g+(aa(f,d)|0)|0;k[I>>2]=d;d=g}}else d=g;k[D>>2]=e+-1;g=d}d=Q+(n<<6)+4+(h*20|0)+4|0;e:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break e}case 2:break;default:{c=2147483647;break e}}m=+p[c+8>>3];p[u>>3]=m;c=k[u+4>>2]|0;da=c&2146435072;do if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){c=(c|0)<0;m=c?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(!(m==0.0))break;m=c?-0.0:0.0}while(0);c=~~m}while(0);k[d>>2]=c;c=k[D>>2]|0;if(c|0){d=k[E>>2]|0;do if(d|0){da=g+(k[d+28>>2]|0)|0;k[A>>2]=da;if(da>>>0<(k[I>>2]|0)>>>0)break;da=k[(k[J>>2]|0)+4>>2]|0;k[J>>2]=da;f=k[da+16>>2]|0;k[A>>2]=f;g=k[d+28>>2]|0;da=k[da+12>>2]|0;k[K>>2]=f;da=f+(aa(g,da)|0)|0;k[I>>2]=da}while(0);k[D>>2]=c+-1}d=Q+(n<<6)+4+(h*20|0)+8|0;e=k[A>>2]|0;f:do if(!e)c=0;else{switch(k[e>>2]&7){case 1:{c=k[e+8>>2]|0;break f}case 2:break;default:{c=2147483647;break f}}m=+p[e+8>>3];p[u>>3]=m;c=k[u+4>>2]|0;da=c&2146435072;do if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){c=(c|0)<0;m=c?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(!(m==0.0))break;m=c?-0.0:0.0}while(0);c=~~m}while(0);k[d>>2]=c;c=k[D>>2]|0;if(c|0){d=k[E>>2]|0;do if(d|0){da=e+(k[d+28>>2]|0)|0;k[A>>2]=da;if(da>>>0<(k[I>>2]|0)>>>0)break;da=k[(k[J>>2]|0)+4>>2]|0;k[J>>2]=da;f=k[da+16>>2]|0;k[A>>2]=f;g=k[d+28>>2]|0;da=k[da+12>>2]|0;k[K>>2]=f;da=f+(aa(g,da)|0)|0;k[I>>2]=da}while(0);k[D>>2]=c+-1}d=Q+(n<<6)+4+(h*20|0)+12|0;e=k[A>>2]|0;g:do if(!e)c=0;else{switch(k[e>>2]&7){case 1:{c=k[e+8>>2]|0;break g}case 2:break;default:{c=2147483647;break g}}m=+p[e+8>>3];p[u>>3]=m;c=k[u+4>>2]|0;da=c&2146435072;do if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){c=(c|0)<0;m=c?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(!(m==0.0))break;m=c?-0.0:0.0}while(0);c=~~m}while(0);k[d>>2]=c;c=k[D>>2]|0;if(!c)d=0;else{d=k[E>>2]|0;do if(d|0){da=e+(k[d+28>>2]|0)|0;k[A>>2]=da;if(da>>>0<(k[I>>2]|0)>>>0)break;da=k[(k[J>>2]|0)+4>>2]|0;k[J>>2]=da;f=k[da+16>>2]|0;k[A>>2]=f;g=k[d+28>>2]|0;da=k[da+12>>2]|0;k[K>>2]=f;da=f+(aa(g,da)|0)|0;k[I>>2]=da}while(0);d=c+-1|0;k[D>>2]=d}c=Q+(n<<6)+4+(h*20|0)+16|0;e=k[A>>2]|0;h:do if(!e)m=0.0;else switch(k[e>>2]&7){case 1:{m=+(k[e+8>>2]|0);break h}case 2:{m=+p[e+8>>3];break h}default:{m=1000000015047466219876688.0e6;break h}}while(0);o[c>>2]=m;if(d|0){c=k[E>>2]|0;do if(c|0){da=e+(k[c+28>>2]|0)|0;k[A>>2]=da;if(da>>>0<(k[I>>2]|0)>>>0)break;da=k[(k[J>>2]|0)+4>>2]|0;k[J>>2]=da;f=k[da+16>>2]|0;k[A>>2]=f;g=k[c+28>>2]|0;da=k[da+12>>2]|0;k[K>>2]=f;da=f+(aa(g,da)|0)|0;k[I>>2]=da}while(0);k[D>>2]=d+-1}c=k[t>>2]|0;if(c|0){d=k[w>>2]|0;do if(d|0){da=(k[v>>2]|0)+(k[d+28>>2]|0)|0;k[v>>2]=da;if(da>>>0<(k[F>>2]|0)>>>0)break;da=k[(k[G>>2]|0)+4>>2]|0;k[G>>2]=da;f=k[da+16>>2]|0;k[v>>2]=f;g=k[d+28>>2]|0;da=k[da+12>>2]|0;k[H>>2]=f;da=f+(aa(g,da)|0)|0;k[F>>2]=da}while(0);k[t>>2]=c+-1}h=h+1|0}c=k6(j,l,380579)|0;i:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break i}case 2:break;default:{c=2147483647;break i}}m=+p[c+8>>3];p[u>>3]=m;c=k[u+4>>2]|0;da=c&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){c=(c|0)<0;m=c?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=c?-0.0:0.0}c=~~m}while(0);i[Q+(n<<6)>>0]=(c|0)!=0&1;Q=k[R>>2]|0;if(i[Q+(n<<6)>>0]|0)i[S>>0]=1;n=n+1|0;c=k[L>>2]|0;if(c|0){d=k[M>>2]|0;if(d|0?(da=(k[q>>2]|0)+(k[d+28>>2]|0)|0,k[q>>2]=da,da>>>0>=(k[N>>2]|0)>>>0):0){da=k[(k[O>>2]|0)+4>>2]|0;k[O>>2]=da;l=k[da+16>>2]|0;k[q>>2]=l;T=k[d+28>>2]|0;da=k[da+12>>2]|0;k[P>>2]=l;da=l+(aa(T,da)|0)|0;k[N>>2]=da}k[L>>2]=c+-1}}while((n|0)!=(U|0));ba=i[S>>0]|0;ba=ba<<24>>24!=0;ba=ba?3:2;$=a+40|0;k[$>>2]=ba;$=a+8|0;$=k[$>>2]|0;$=$+-2|0;ba=a+12|0;ba=k[ba>>2]|0;ba=ba+-2|0;da=a+408|0;k[da>>2]=1;da=a+412|0;k[da>>2]=1;da=a+416|0;k[da>>2]=$;da=a+420|0;k[da>>2]=ba;da=a+24|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;r=ca;return 1}function VQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;while(1){c=fgb(436)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[d+24>>2]=0;k[c+44>>2]=1124007936;d=c+52|0;e=c+84|0;f=c+48|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=c+92|0;k[c+88>>2]=d;k[c+96>>2]=0;k[d>>2]=0;k[c+100>>2]=1124007936;d=c+108|0;e=c+140|0;f=c+104|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;h=c+148|0;k[c+144>>2]=h;k[c+152>>2]=0;k[h>>2]=0;k[c+156>>2]=1124007936;h=c+160|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[c+188>>2]=c+164;h=c+196|0;k[c+192>>2]=h;k[c+200>>2]=0;k[h>>2]=0;k[c+204>>2]=1124007936;h=c+208|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[c+236>>2]=c+212;h=c+244|0;k[c+240>>2]=h;k[c+248>>2]=0;k[h>>2]=0;k[c+252>>2]=1124007936;h=c+256|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[c+284>>2]=c+260;h=c+292|0;k[c+288>>2]=h;k[c+296>>2]=0;k[h>>2]=0;k[c+300>>2]=1124007936;h=c+304|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[c+332>>2]=c+308;h=c+340|0;k[c+336>>2]=h;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[c>>2]=95164;h=c+356|0;d=c+24|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;f=c+392|0;g=f+40|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=4;k[c+28>>2]=2;k[c+32>>2]=0;k[c+36>>2]=0;k[c+40>>2]=0;k[c+384>>2]=0;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}i=d+4|0;k[i>>2]=1;k[d>>2]=95224;k[d+8>>2]=c;dRa(c,b);e=k[b+356>>2]|0;f=k[b+360>>2]|0;if(e|0){g=e+4|0;k[g>>2]=(k[g>>2]|0)+1}g=k[h>>2]|0;k[h>>2]=e;k[c+360>>2]=f;if(g|0?(f=g+4|0,h=k[f>>2]|0,k[f>>2]=h+-1,(h|0)==1):0)Uh[k[(k[g>>2]|0)+8>>2]&2047](g);e=c+364|0;f=k[b+364>>2]|0;g=k[b+368>>2]|0;if(f|0){h=f+4|0;k[h>>2]=(k[h>>2]|0)+1}h=k[e>>2]|0;k[e>>2]=f;k[c+368>>2]=g;if(h|0?(f=h+4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)Uh[k[(k[h>>2]|0)+8>>2]&2047](h);h=c+372|0;e=k[b+372>>2]|0;f=k[b+376>>2]|0;if(e|0){g=e+4|0;k[g>>2]=(k[g>>2]|0)+1}g=k[h>>2]|0;k[h>>2]=e;k[c+376>>2]=f;if(g|0?(f=g+4|0,h=k[f>>2]|0,k[f>>2]=h+-1,(h|0)==1):0)Uh[k[(k[g>>2]|0)+8>>2]&2047](g);h=c+380|0;g=b+380|0;k[h>>2]=k[g>>2];k[h+4>>2]=k[g+4>>2];k[h+8>>2]=k[g+8>>2];k[h+12>>2]=k[g+12>>2];k[h+16>>2]=k[g+16>>2];k[h+20>>2]=k[g+20>>2];k[h+24>>2]=k[g+24>>2];k[c+408>>2]=k[b+408>>2];k[c+412>>2]=k[b+412>>2];k[c+416>>2]=k[b+416>>2];k[c+420>>2]=k[b+420>>2];h=c+424|0;b=b+424|0;k[h>>2]=k[b>>2];k[h+4>>2]=k[b+4>>2];k[h+8>>2]=k[b+8>>2];k[a>>2]=d;k[a+4>>2]=c;k[i>>2]=(k[i>>2]|0)+1;b=k[i>>2]|0;k[i>>2]=b+-1;if((b|0)!=1)return;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);return}function WQa(a){a=a|0;return 0}function XQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0,g=0,h=0,i=0;f=cRa(a,c)|0;g=k[b>>2]|0;if((g|0)<0){a=0;return a|0}c=k[b+4>>2]|0;if((c|0)<0){a=0;return a|0}if(((k[a+8>>2]|0)+g|0)>=(k[f+4>>2]|0)){a=0;return a|0}if(((k[a+12>>2]|0)+c|0)>=(k[f+8>>2]|0)){a=0;return a|0}i=(k[a+60>>2]|0)+(aa(k[k[a+88>>2]>>2]|0,c)|0)+(g<<2)|0;i=i+(k[f+12>>2]<<2)|0;k[a+424>>2]=i;f=i+(k[a+388>>2]<<2)|0;h=k[a+392>>2]|0;c=k[a+396>>2]|0;b=k[a+400>>2]|0;g=k[a+404>>2]|0;d=+(aa(k[a+420>>2]|0,k[a+416>>2]|0)|0);e=+((k[i+(h<<2)>>2]|0)-(k[i+(c<<2)>>2]|0)-(k[i+(b<<2)>>2]|0)+(k[i+(g<<2)>>2]|0)|0);e=+(((k[f+(h<<2)>>2]|0)-(k[f+(c<<2)>>2]|0)-(k[f+(b<<2)>>2]|0)+(k[f+(g<<2)>>2]|0)|0)>>>0)*d-e*e;if(e>0.0){e=1.0/+Q(+e);o[a+432>>2]=e;i=d*e<.1;return i|0}else{o[a+432>>2]=1.0;i=0;return i|0}return 0}function YQa(a,b){a=a|0;b=b|0;return +(+bRa(a,b))}function ZQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+240|0;y=z+184|0;x=z+128|0;w=z+72|0;v=z+56|0;t=z+24|0;u=z;h=z+48|0;p=z+40|0;q=z+16|0;s=k[a+352>>2]|0;d=k[s>>2]|0;if((((k[s+4>>2]|0)-d|0)/20|0)>>>0<=b>>>0)ad(426635,426557,315,426658);s=a+380|0;j=a+16|0;m=k[j>>2]|0;n=(aa(k[a+20>>2]|0,m)|0)<<l[s>>0];o=a+388|0;k[o>>2]=n;if((k[c>>2]&2031616|0)==655360){f=k[d+(b*20|0)+12>>2]|0;e=(f|0)%(m|0)|0;f=(f|0)/(m|0)|0;g=a+204|0;h=d+(b*20|0)+4|0;p=k[h>>2]|0;d=d+(b*20|0)+8|0;q=k[d>>2]|0;k[x>>2]=e;k[x+4>>2]=f;k[x+8>>2]=p;k[x+12>>2]=q;u9(y,g,x);q=k[h>>2]|0;b=k[d>>2]|0;k[w>>2]=e;k[w+4>>2]=((n|0)/(m|0)|0)+f;k[w+8>>2]=q;k[w+12>>2]=b;u9(x,g,w);k[x>>2]=k[x>>2]&-8|4;do if(!(i[s>>0]|0)){g=x+24|0;u=k[g>>2]|0;t=w+4|0;a=t+4|0;k[a>>2]=0;k[a+4>>2]=0;k[w>>2]=34209792;k[t>>2]=y;t=v+4|0;a=t+4|0;k[a>>2]=0;k[a+4>>2]=0;k[v>>2]=34209792;k[t>>2]=x;Iua(c,w,v,49332,4,4);if(((k[g>>2]|0)==(u|0)?(v=k[x+32>>2]|0,(k[v>>2]|0)==(k[d>>2]|0)?(k[v+4>>2]|0)==(k[h>>2]|0):0):0)?(k[x>>2]&4095|0)==4:0)break;k[w>>2]=0;d=w+4|0;k[d>>2]=0;e=ZT(68)|0;k[e>>2]=1;f=e+4|0;k[w>>2]=f;k[d>>2]=61;i[e+65>>0]=0;h=378316;j=f+61|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-215,w,378378,378394,642);k[d>>2]=0;k[w>>2]=0;w=k[e>>2]|0;k[e>>2]=w+-1;if((w|0)==1)ggb(k[e+-4>>2]|0)}else{s=((k[a+384>>2]|0)/(k[j>>2]|0)|0)+f|0;a=k[h>>2]|0;d=k[d>>2]|0;k[v>>2]=e;k[v+4>>2]=s;k[v+8>>2]=a;k[v+12>>2]=d;u9(w,g,v);g=v+4|0;d=g+4|0;k[d>>2]=0;k[d+4>>2]=0;k[v>>2]=34209792;k[g>>2]=y;g=t+4|0;d=g+4|0;k[d>>2]=0;k[d+4>>2]=0;k[t>>2]=34209792;k[g>>2]=x;g=u+4|0;d=g+4|0;k[d>>2]=0;k[d+4>>2]=0;k[u>>2]=34209792;k[g>>2]=w;Iua(c,v,t,u,4,4);g=w+24|0;d=k[g>>2]|0;if(d|0?(c=d+8|0,v=k[c>>2]|0,k[c>>2]=v+-1,(v|0)==1):0){v=k[g>>2]|0;c=k[v+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,v);k[g>>2]=0}f=w+4|0;if((k[f>>2]|0)>0){e=k[w+32>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[f>>2]|0))}k[g>>2]=0;d=k[w+36>>2]|0;if(!((d|0)==(w+40|0)|(d|0)==0))ggb(k[d+-4>>2]|0);g=x+24|0}while(0);d=k[g>>2]|0;if(d|0?(v=d+8|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){w=k[g>>2]|0;v=k[w+4>>2]|0;jh[k[(k[v>>2]|0)+16>>2]&1023](v,w);k[g>>2]=0}e=x+4|0;if((k[e>>2]|0)>0){f=k[x+32>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}k[g>>2]=0;d=k[x+36>>2]|0;if(!((d|0)==(x+40|0)|(d|0)==0))ggb(k[d+-4>>2]|0);g=y+24|0;d=k[g>>2]|0;if(d|0?(w=d+8|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){x=k[g>>2]|0;w=k[x+4>>2]|0;jh[k[(k[w>>2]|0)+16>>2]&1023](w,x);k[g>>2]=0}e=y+4|0;if((k[e>>2]|0)>0){f=k[y+32>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}k[g>>2]=0;d=k[y+36>>2]|0;if(!((d|0)==(y+40|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=z;return}e=d+(b*20|0)+4|0;k[h>>2]=k[e>>2];f=d+(b*20|0)+8|0;k[h+4>>2]=k[f>>2];g=a+92|0;YN(y,h,4,(k[a+60>>2]|0)+(k[d+(b*20|0)+12>>2]<<2)|0,k[g>>2]|0);k[p>>2]=k[e>>2];k[p+4>>2]=k[f>>2];h=y+16|0;j=y+44|0;YN(x,p,4,(k[h>>2]|0)+(k[o>>2]<<2)|0,k[g>>2]|0);if(i[s>>0]|0){k[q>>2]=k[e>>2];k[q+4>>2]=k[f>>2];YN(w,q,4,(k[h>>2]|0)+(k[a+384>>2]<<2)|0,k[g>>2]|0);f=v+4|0;d=f+4|0;k[d>>2]=0;k[d+4>>2]=0;k[v>>2]=33619968;k[f>>2]=y;f=t+4|0;d=f+4|0;k[d>>2]=0;k[d+4>>2]=0;k[t>>2]=33619968;k[f>>2]=x;f=u+4|0;d=f+4|0;k[d>>2]=0;k[d+4>>2]=0;k[u>>2]=33619968;k[f>>2]=w;Iua(c,v,t,u,4,4);f=w+36|0;d=k[f>>2]|0;if(d|0?(c=d+12|0,v=k[c>>2]|0,k[c>>2]=v+-1,(v|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[w+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;v=w+16|0;e=w+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[e>>2]|0)>0){f=k[w+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[w+44>>2]|0;if(!((d|0)==(w+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}else{u=w+4|0;t=u+4|0;k[t>>2]=0;k[t+4>>2]=0;k[w>>2]=33619968;k[u>>2]=y;u=v+4|0;t=u+4|0;k[t>>2]=0;k[t+4>>2]=0;k[v>>2]=33619968;k[u>>2]=x;Iua(c,w,v,49332,4,4)}f=x+36|0;d=k[f>>2]|0;if(d|0?(v=d+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[x+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;w=x+16|0;e=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[e>>2]|0)>0){f=k[x+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[x+44>>2]|0;if(!((d|0)==(x+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=y+36|0;d=k[f>>2]|0;if(d|0?(w=d+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[y+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;f=y+4|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[f>>2]|0)>0){e=k[y+40>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[f>>2]|0))}d=k[j>>2]|0;if(!((d|0)==(y+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=z;return}function _Qa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+80|0;t=v+56|0;u=v;n=k[a+16>>2]|0;if(i[a+380>>0]|0){s=aa(k[a+20>>2]|0,n)|0;k[a+384>>2]=s}c=k[a+408>>2]|0;o=k[a+412>>2]|0;d=aa(o,n)|0;k[a+392>>2]=d+c;p=(k[a+416>>2]|0)+c|0;k[a+396>>2]=p+d;o=aa((k[a+420>>2]|0)+o|0,n)|0;k[a+400>>2]=o+c;k[a+404>>2]=p+o;o=k[a+360>>2]|0;p=(k[o+4>>2]|0)-(k[o>>2]|0)>>6;c=a+368|0;d=k[c>>2]|0;e=d+4|0;h=k[e>>2]|0;b=k[d>>2]|0;f=h-b>>6;g=b;if(p>>>0<=f>>>0){if(p>>>0<f>>>0?(j=g+(p<<6)|0,(h|0)!=(j|0)):0)k[e>>2]=h+(~((h+-64-j|0)>>>6)<<6)}else{$Qa(d,p-f|0);b=k[k[c>>2]>>2]|0}c=a+428|0;k[c>>2]=b;g=(p|0)==0;if(!g?(l=a+384|0,aRa(b,k[o>>2]|0,n,k[l>>2]|0),(p|0)!=1):0){b=1;do{aRa((k[c>>2]|0)+(b<<6)|0,(k[o>>2]|0)+(b<<6)|0,n,k[l>>2]|0);b=b+1|0}while((b|0)!=(p|0))}h=a+376|0;b=k[h>>2]|0;c=b+4|0;f=k[c>>2]|0;e=k[b>>2]|0;d=f-e>>6;if(p>>>0<=d>>>0){if(p>>>0<d>>>0?(m=e+(p<<6)|0,(f|0)!=(m|0)):0)k[c>>2]=f+(~((f+-64-m|0)>>>6)<<6)}else{$Qa(b,p-d|0);b=k[h>>2]|0}a:do if(g)q=b;else{e=a+32|0;f=a+384|0;d=0;while(1){c=k[b>>2]|0;if((k[b+4>>2]|0)-c>>6>>>0<=d>>>0)break;b=k[e>>2]|0;aRa(c+(d<<6)|0,(k[o>>2]|0)+(d<<6)|0,(b|0)>0?b:n,k[f>>2]|0);d=d+1|0;b=k[h>>2]|0;if((d|0)==(p|0)){q=b;break a}}ad(426635,426557,315,426658)}while(0);s=a+252|0;c=k[q>>2]|0;f=q+4|0;b=k[f>>2]|0;if((c|0)==(b|0)){e=a+276|0;b=k[e>>2]|0;if(b|0?(o=b+8|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0){p=k[e>>2]|0;o=k[p+4>>2]|0;jh[k[(k[o>>2]|0)+16>>2]&1023](o,p);k[e>>2]=0}d=a+256|0;if((k[d>>2]|0)>0){c=k[a+284>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}k[e>>2]=0;c=k[q>>2]|0;b=k[f>>2]|0}d=b-c|0;b=c;k[u>>2]=1124007936;p=u+4|0;k[p>>2]=2;j=u+8|0;k[j>>2]=1;g=u+12|0;k[g>>2]=d;n=u+16|0;k[n>>2]=b;h=u+20|0;k[h>>2]=b;l=u+24|0;m=u+28|0;o=u+40|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;k[o>>2]=j;q=u+48|0;a=u+44|0;k[a>>2]=q;k[u+52>>2]=0;k[q>>2]=0;if((c|0)==0&(d|0)!=0){b=t+4|0;c=ZT(36)|0;k[c>>2]=1;d=c+4|0;k[t>>2]=d;k[b>>2]=28;i[c+32>>0]=0;e=390609;f=d+28|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,t,390638,390642,410);k[b>>2]=0;k[t>>2]=0;f=k[c>>2]|0;k[c>>2]=f+-1;if((f|0)==1)ggb(k[c+-4>>2]|0);e=k[u>>2]|16384;d=k[g>>2]|0;c=k[a>>2]|0;b=k[h>>2]|0}else{e=1124024320;c=q}k[u>>2]=e;k[c>>2]=d;k[c+4>>2]=1;b=b+(aa(k[j>>2]|0,d)|0)|0;k[m>>2]=b;k[l>>2]=b+(0-d)+d;d=t+4|0;b=d+4|0;k[b>>2]=0;k[b+4>>2]=0;k[t>>2]=34209792;k[d>>2]=s;mY(u,t);d=u+36|0;b=k[d>>2]|0;if(b|0?(s=b+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[u+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[p>>2]|0)>0){c=k[o>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[p>>2]|0))}b=k[a>>2]|0;if((b|0)==(q|0)|(b|0)==0){r=v;return}ggb(k[b+-4>>2]|0);r=v;return}function $Qa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+8|0;e=k[i>>2]|0;j=a+4|0;c=k[j>>2]|0;if(e-c>>6>>>0>=b>>>0){do{d=c+60|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));c=(k[j>>2]|0)+64|0;k[j>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=c-d>>6;c=f+b|0;if(c>>>0>67108863)ad(426534,426557,304,426811);g=e-d|0;h=g>>5;h=g>>6>>>0<33554431?(h>>>0<c>>>0?c:h):67108863;if(!h)g=0;else{if(h>>>0>67108863){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=h<<6;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}g=c}f=g+(f<<6)|0;c=f;e=f;do{d=c+60|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));c=e+64|0;e=c;b=b+-1|0}while((b|0)!=0);b=k[a>>2]|0;d=(k[j>>2]|0)-b|0;c=f+(0-(d>>6)<<6)|0;if((d|0)>0)upb(c|0,b|0,d|0)|0;k[a>>2]=c;k[j>>2]=e;k[i>>2]=g+(h<<6);if(!b)return;ggb(b);return}function aRa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;k[a+48>>2]=k[b+20>>2];h=b+24|0;k[a+52>>2]=k[b+40>>2];e=b+44|0;k[a+56>>2]=k[b+60>>2];f=b+4|0;g=k[f>>2]|0;if(!(i[b>>0]|0)){d=b+8|0;j=(aa(k[d>>2]|0,c)|0)+g|0;k[a>>2]=j;j=b+12|0;g=(k[j>>2]|0)+(k[f>>2]|0)+(aa(k[d>>2]|0,c)|0)|0;k[a+4>>2]=g;g=b+16|0;l=(aa((k[g>>2]|0)+(k[d>>2]|0)|0,c)|0)+(k[f>>2]|0)|0;k[a+8>>2]=l;d=(k[j>>2]|0)+(k[f>>2]|0)+(aa((k[g>>2]|0)+(k[d>>2]|0)|0,c)|0)|0;k[a+12>>2]=d;d=b+28|0;f=(aa(k[d>>2]|0,c)|0)+(k[h>>2]|0)|0;k[a+16>>2]=f;f=b+32|0;g=(k[f>>2]|0)+(k[h>>2]|0)+(aa(k[d>>2]|0,c)|0)|0;k[a+20>>2]=g;g=b+36|0;j=(aa((k[g>>2]|0)+(k[d>>2]|0)|0,c)|0)+(k[h>>2]|0)|0;k[a+24>>2]=j;d=(k[f>>2]|0)+(k[h>>2]|0)+(aa((k[g>>2]|0)+(k[d>>2]|0)|0,c)|0)|0;k[a+28>>2]=d;d=b+48|0;g=(aa(k[d>>2]|0,c)|0)+(k[e>>2]|0)|0;k[a+32>>2]=g;g=b+52|0;h=(k[g>>2]|0)+(k[e>>2]|0)+(aa(k[d>>2]|0,c)|0)|0;k[a+36>>2]=h;h=b+56|0;f=(aa((k[h>>2]|0)+(k[d>>2]|0)|0,c)|0)+(k[e>>2]|0)|0;k[a+40>>2]=f;d=(k[g>>2]|0)+(k[e>>2]|0)+(aa((k[h>>2]|0)+(k[d>>2]|0)|0,c)|0)|0;h=a+44|0;k[h>>2]=d;return}else{j=b+8|0;l=g+d+(aa(k[j>>2]|0,c)|0)|0;k[a>>2]=l;l=b+16|0;g=k[l>>2]|0;g=(k[f>>2]|0)+d-g+(aa((k[j>>2]|0)+g|0,c)|0)|0;k[a+4>>2]=g;g=b+12|0;m=k[g>>2]|0;m=(k[f>>2]|0)+d+m+(aa((k[j>>2]|0)+m|0,c)|0)|0;k[a+8>>2]=m;g=k[g>>2]|0;l=k[l>>2]|0;j=(k[f>>2]|0)+d+g-l+(aa(l+g+(k[j>>2]|0)|0,c)|0)|0;k[a+12>>2]=j;j=b+28|0;g=(k[h>>2]|0)+d+(aa(k[j>>2]|0,c)|0)|0;k[a+16>>2]=g;g=b+36|0;l=k[g>>2]|0;l=(k[h>>2]|0)+d-l+(aa((k[j>>2]|0)+l|0,c)|0)|0;k[a+20>>2]=l;l=b+32|0;f=k[l>>2]|0;f=(k[h>>2]|0)+d+f+(aa((k[j>>2]|0)+f|0,c)|0)|0;k[a+24>>2]=f;l=k[l>>2]|0;g=k[g>>2]|0;j=(k[h>>2]|0)+d+l-g+(aa(g+l+(k[j>>2]|0)|0,c)|0)|0;k[a+28>>2]=j;j=b+48|0;h=(k[e>>2]|0)+d+(aa(k[j>>2]|0,c)|0)|0;k[a+32>>2]=h;h=b+56|0;l=k[h>>2]|0;l=(k[e>>2]|0)+d-l+(aa((k[j>>2]|0)+l|0,c)|0)|0;k[a+36>>2]=l;l=b+52|0;g=k[l>>2]|0;g=(k[e>>2]|0)+d+g+(aa((k[j>>2]|0)+g|0,c)|0)|0;k[a+40>>2]=g;l=k[l>>2]|0;h=k[h>>2]|0;j=(k[e>>2]|0)+d+l-h+(aa(h+l+(k[j>>2]|0)|0,c)|0)|0;l=a+44|0;k[l>>2]=j;return}}function bRa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0.0;c=k[a+428>>2]|0;d=k[a+424>>2]|0;e=+o[c+(b<<6)+48>>2]*+((k[d+(k[c+(b<<6)>>2]<<2)>>2]|0)-(k[d+(k[c+(b<<6)+4>>2]<<2)>>2]|0)-(k[d+(k[c+(b<<6)+8>>2]<<2)>>2]|0)+(k[d+(k[c+(b<<6)+12>>2]<<2)>>2]|0)|0)+ +o[c+(b<<6)+52>>2]*+((k[d+(k[c+(b<<6)+16>>2]<<2)>>2]|0)-(k[d+(k[c+(b<<6)+20>>2]<<2)>>2]|0)-(k[d+(k[c+(b<<6)+24>>2]<<2)>>2]|0)+(k[d+(k[c+(b<<6)+28>>2]<<2)>>2]|0)|0);f=+o[c+(b<<6)+56>>2];if(!(f!=0.0)){d=a+432|0;f=+o[d>>2];f=e*f;return +f}e=e+f*+((k[d+(k[c+(b<<6)+32>>2]<<2)>>2]|0)-(k[d+(k[c+(b<<6)+36>>2]<<2)>>2]|0)-(k[d+(k[c+(b<<6)+40>>2]<<2)>>2]|0)+(k[d+(k[c+(b<<6)+44>>2]<<2)>>2]|0)|0);d=a+432|0;f=+o[d>>2];f=e*f;return +f}function cRa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;h=j;if(!((b|0)>-1?(d=k[a+352>>2]|0,c=k[d+4>>2]|0,d=k[d>>2]|0,((c-d|0)/20|0|0)>(b|0)):0)){c=h+4|0;d=ZT(56)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=50;i[d+54>>0]=0;f=378471;g=e+50|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,h,378522,378535,46);k[c>>2]=0;k[h>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);c=k[a+352>>2]|0;d=k[c>>2]|0;c=k[c+4>>2]|0}if(((c-d|0)/20|0)>>>0>b>>>0){r=j;return d+(b*20|0)|0}else ad(426635,426557,315,426658);return 0}function dRa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];k[a+20>>2]=k[b+20>>2];k[a+24>>2]=k[b+24>>2];k[a+28>>2]=k[b+28>>2];k[a+32>>2]=k[b+32>>2];k[a+36>>2]=k[b+36>>2];k[a+40>>2]=k[b+40>>2];KG(a+44|0,b+44|0)|0;KG(a+100|0,b+100|0)|0;D2(a+156|0,b+156|0);D2(a+204|0,b+204|0);D2(a+252|0,b+252|0);D2(a+300|0,b+300|0);d=a+348|0;e=k[b+348>>2]|0;b=k[b+352>>2]|0;if(e|0){c=e+4|0;k[c>>2]=(k[c>>2]|0)+1}c=k[d>>2]|0;k[d>>2]=e;k[a+352>>2]=b;if(!c)return;d=c+4|0;e=k[d>>2]|0;k[d>>2]=e+-1;if((e|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function eRa(a){a=a|0;ggb(a);return}function fRa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function gRa(a){a=a|0;ggb(a);return}function hRa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=k[a+8>>2]|0;if(b|0){c=k[b>>2]|0;d=c;if(c|0){e=b+4|0;f=k[e>>2]|0;if((f|0)!=(c|0))k[e>>2]=f+(~((f+-64-d|0)>>>6)<<6);ggb(c)}ggb(b)}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function iRa(a){a=a|0;ggb(a);return}function jRa(a){a=a|0;var b=0,c=0,d=0,e=0;b=k[a+8>>2]|0;if(b|0){c=k[b>>2]|0;if(c|0){d=b+4|0;e=k[d>>2]|0;if((e|0)!=(c|0))k[d>>2]=e+(~((e+-64-c|0)>>>6)<<6);ggb(c)}ggb(b)}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function kRa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=95284;b=a+372|0;c=k[b>>2]|0;if(c|0?(e=c+4|0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+376>>2]=0;b=a+364|0;c=k[b>>2]|0;if(c|0?(d=c+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+368>>2]=0;b=a+356|0;c=k[b>>2]|0;if(c|0?(d=c+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+360>>2]=0;CQa(a);return}function lRa(a){a=a|0;kRa(a);ggb(a);return}function mRa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0.0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;M=r;r=r+144|0;J=M+100|0;f=M+48|0;K=M+56|0;L=M;k[f>>2]=k[c>>2];k[f+4>>2]=k[c+4>>2];EQa(a,0,f)|0;f=a+356|0;v=a+360|0;if(!(k[v>>2]|0)){while(1){g=fgb(12)|0;if(g|0)break;F=k[207666]|0;k[207666]=F+0;Qh[F&7]()}k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=95364;k[c+8>>2]=g;k[d>>2]=(k[d>>2]|0)+1;e=k[f>>2]|0;k[f>>2]=c;k[v>>2]=g;if(e|0?(E=e+4|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);F=k[d>>2]|0;k[d>>2]=F+-1;if((F|0)==1)Uh[k[(k[c>>2]|0)+8>>2]&2047](c)}f=a+364|0;g=a+368|0;if(!(k[g>>2]|0)){while(1){h=fgb(12)|0;if(h|0)break;F=k[207666]|0;k[207666]=F+0;Qh[F&7]()}k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=95384;k[c+8>>2]=h;k[d>>2]=(k[d>>2]|0)+1;e=k[f>>2]|0;k[f>>2]=c;k[g>>2]=h;if(e|0?(E=e+4|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);F=k[d>>2]|0;k[d>>2]=F+-1;if((F|0)==1)Uh[k[(k[c>>2]|0)+8>>2]&2047](c)}f=a+372|0;g=a+376|0;if(!(k[g>>2]|0)){while(1){h=fgb(12)|0;if(h|0)break;F=k[207666]|0;k[207666]=F+0;Qh[F&7]()}k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=95384;k[c+8>>2]=h;k[d>>2]=(k[d>>2]|0)+1;e=k[f>>2]|0;k[f>>2]=c;k[g>>2]=h;if(e|0?(E=e+4|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);F=k[d>>2]|0;k[d>>2]=F+-1;if((F|0)==1)Uh[k[(k[c>>2]|0)+8>>2]&2047](c)}o=k[v>>2]|0;q=b+4|0;c=k[q>>2]|0;a:do if(!c){c=1;G=42}else{d=k[c>>2]|0;switch(d&7){case 6:{g=k[(k[c+8>>2]|0)+60>>2]|0;break a}case 5:{g=k[(k[c+8>>2]|0)+24>>2]|0;break a}default:{c=(d&7|0)==0;G=42;break a}}}while(0);if((G|0)==42)g=c&1^1;n=o+4|0;c=k[n>>2]|0;f=k[o>>2]|0;h=c-f>>4;d=f;e=c;b:do if(g>>>0>h>>>0){d=g-h|0;m=o+8|0;e=k[m>>2]|0;if(e-c>>4>>>0>=d>>>0)while(1){k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;c=(k[n>>2]|0)+16|0;k[n>>2]=c;d=d+-1|0;if(!d)break b}if(g>>>0>268435455)ad(426534,426557,304,426811);G=e-f|0;f=G>>3;f=G>>4>>>0<134217727?(f>>>0<g>>>0?g:f):268435455;if(!f)c=0;else{if(f>>>0>268435455){M=te(4)|0;k[M>>2]=172664;Cf(M|0,28816,1287)}e=f<<4;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}j=c+(h<<4)|0;h=j;e=j;i=h;do{k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;e=i+16|0;i=e;d=d+-1|0}while((d|0)!=0);f=c+(f<<4)|0;g=k[o>>2]|0;c=k[n>>2]|0;if((c|0)==(g|0))c=h;else{e=c+-16|0;d=j;while(1){G=c;c=c+-16|0;k[d+-16>>2]=k[c>>2];k[d+-12>>2]=k[G+-12>>2];k[d+-8>>2]=k[G+-8>>2];k[d+-4>>2]=k[G+-4>>2];if((c|0)==(g|0))break;else d=d+-16|0}c=j+(~((e-g|0)>>>4)<<4)|0}k[o>>2]=c;k[n>>2]=i;k[m>>2]=f;if(g|0)ggb(g)}else if(g>>>0<h>>>0?(i=d+(g<<4)|0,(e|0)!=(i|0)):0)k[n>>2]=e+(~((e+-16-i|0)>>>4)<<4);while(0);k[a+380>>2]=0;c=k[b>>2]|0;e=k[q>>2]|0;do if((c|0)!=0&(e|0)!=0?(s=k[e>>2]|0,t=s&7,(t|0)!=0):0){k[K>>2]=c;k[K+4>>2]=e;if(!((t+-5|0)>>>0<2&(s&16|0)==0)){k[K+20>>2]=e;k[K+12>>2]=0;k[K+40>>2]=1;d=c;G=79;break}d=e+8|0;KY(k[d>>2]|0,K+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[K+40>>2]=c;e=k[q>>2]|0;c=k[b>>2]|0;G=78}else G=77;while(0);if((G|0)==77){k[K>>2]=0;k[K+4>>2]=0;k[K+20>>2]=0;k[K+40>>2]=0;G=78}if((G|0)==78)if(!e){g=1;G=83}else{d=c;G=79}c:do if((G|0)==79){c=k[e>>2]|0;switch(c&7){case 6:{f=e;c=k[(k[e+8>>2]|0)+60>>2]|0;break c}case 5:{f=e;c=k[(k[e+8>>2]|0)+24>>2]|0;break c}default:{g=(c&7|0)==0;c=d;G=83;break c}}}while(0);if((G|0)==83){d=c;f=e;c=g&1^1}B6(L,d,f,c);j=k[v>>2]|0;m=K+40|0;n=K+4|0;o=L+4|0;q=K+20|0;s=L+20|0;t=L+40|0;b=J+4|0;v=J+8|0;w=J+40|0;x=J+20|0;y=J+12|0;z=K+12|0;A=K+28|0;B=K+16|0;C=K+24|0;D=J+28|0;E=J+16|0;F=J+24|0;i=0;while(1){c=k[K>>2]|0;if((((c|0)==(k[L>>2]|0)?(k[n>>2]|0)==(k[o>>2]|0):0)?(k[q>>2]|0)==(k[s>>2]|0):0)?(k[m>>2]|0)==(k[t>>2]|0):0)break;h=k[j>>2]|0;e=k6(c,k[q>>2]|0,379272)|0;d:do if((c|0)!=0&(e|0)!=0?(H=k[e>>2]|0,I=H&7,(I|0)!=0):0){k[J>>2]=c;k[b>>2]=e;if((I+-5|0)>>>0<2&(H&16|0)==0){d=e+8|0;KY(k[d>>2]|0,v);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[w>>2]=c;e=k[x>>2]|0;d=h+(i<<4)|0;if(!e){f=0;g=e;c=e;break}else{c=e;g=e}}else{k[x>>2]=e;k[y>>2]=0;k[w>>2]=1;c=e;d=h+(i<<4)|0;g=e}switch(k[c>>2]&7){case 1:{f=k[c+8>>2]|0;break d}case 2:break;default:{f=2147483647;break d}}l=+p[c+8>>3];p[u>>3]=l;e=k[u+4>>2]|0;f=e&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){e=(e|0)<0;l=e?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=e?-0.0:0.0}f=~~l}else G=97;while(0);if((G|0)==97){G=0;k[J>>2]=0;k[b>>2]=0;k[x>>2]=0;k[w>>2]=0;f=0;d=h+(i<<4)|0;g=0;c=0}k[d>>2]=f;e=k[w>>2]|0;if(e){d=k[y>>2]|0;if(d){c=g+(k[d+28>>2]|0)|0;k[x>>2]=c;if(c>>>0<(k[D>>2]|0)>>>0)d=c;else{N=k[(k[E>>2]|0)+4>>2]|0;k[E>>2]=N;c=k[N+16>>2]|0;k[x>>2]=c;g=c;f=k[d+28>>2]|0;d=k[N+12>>2]|0;k[F>>2]=g;d=g+(aa(f,d)|0)|0;k[D>>2]=d;d=g}}else d=g;k[w>>2]=e+-1;g=d}d=h+(i<<4)+4|0;e:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break e}case 2:break;default:{c=2147483647;break e}}l=+p[c+8>>3];p[u>>3]=l;c=k[u+4>>2]|0;N=c&2146435072;if(!(N>>>0>1126170624|(N|0)==1126170624&0>0)){c=(c|0)<0;l=c?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=c?-0.0:0.0}c=~~l}while(0);k[d>>2]=c;c=k[w>>2]|0;if(c|0){d=k[y>>2]|0;if(d|0?(N=g+(k[d+28>>2]|0)|0,k[x>>2]=N,N>>>0>=(k[D>>2]|0)>>>0):0){N=k[(k[E>>2]|0)+4>>2]|0;k[E>>2]=N;f=k[N+16>>2]|0;k[x>>2]=f;g=k[d+28>>2]|0;N=k[N+12>>2]|0;k[F>>2]=f;N=f+(aa(g,N)|0)|0;k[D>>2]=N}k[w>>2]=c+-1}d=h+(i<<4)+8|0;e=k[x>>2]|0;f:do if(!e)c=0;else{switch(k[e>>2]&7){case 1:{c=k[e+8>>2]|0;break f}case 2:break;default:{c=2147483647;break f}}l=+p[e+8>>3];p[u>>3]=l;c=k[u+4>>2]|0;N=c&2146435072;if(!(N>>>0>1126170624|(N|0)==1126170624&0>0)){c=(c|0)<0;l=c?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=c?-0.0:0.0}c=~~l}while(0);k[d>>2]=c;c=k[w>>2]|0;if(c|0){d=k[y>>2]|0;if(d|0?(N=e+(k[d+28>>2]|0)|0,k[x>>2]=N,N>>>0>=(k[D>>2]|0)>>>0):0){N=k[(k[E>>2]|0)+4>>2]|0;k[E>>2]=N;f=k[N+16>>2]|0;k[x>>2]=f;g=k[d+28>>2]|0;N=k[N+12>>2]|0;k[F>>2]=f;N=f+(aa(g,N)|0)|0;k[D>>2]=N}k[w>>2]=c+-1}d=h+(i<<4)+12|0;e=k[x>>2]|0;g:do if(!e)c=0;else{switch(k[e>>2]&7){case 1:{c=k[e+8>>2]|0;break g}case 2:break;default:{c=2147483647;break g}}l=+p[e+8>>3];p[u>>3]=l;c=k[u+4>>2]|0;N=c&2146435072;if(!(N>>>0>1126170624|(N|0)==1126170624&0>0)){c=(c|0)<0;l=c?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=c?-0.0:0.0}c=~~l}while(0);k[d>>2]=c;c=k[w>>2]|0;if(c|0){d=k[y>>2]|0;if(d|0?(N=e+(k[d+28>>2]|0)|0,k[x>>2]=N,N>>>0>=(k[D>>2]|0)>>>0):0){N=k[(k[E>>2]|0)+4>>2]|0;k[E>>2]=N;g=k[N+16>>2]|0;k[x>>2]=g;h=k[d+28>>2]|0;N=k[N+12>>2]|0;k[F>>2]=g;N=g+(aa(h,N)|0)|0;k[D>>2]=N}k[w>>2]=c+-1}c=k[m>>2]|0;if(c|0){d=k[z>>2]|0;do if(d|0){N=(k[q>>2]|0)+(k[d+28>>2]|0)|0;k[q>>2]=N;if(N>>>0<(k[A>>2]|0)>>>0)break;N=k[(k[B>>2]|0)+4>>2]|0;k[B>>2]=N;g=k[N+16>>2]|0;k[q>>2]=g;h=k[d+28>>2]|0;N=k[N+12>>2]|0;k[C>>2]=g;N=g+(aa(h,N)|0)|0;k[A>>2]=N}while(0);k[m>>2]=c+-1}i=i+1|0}k[a+40>>2]=1;N=a+24|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;r=M;return 1}function nRa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;while(1){c=fgb(388)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}tRa(c);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}i=d+4|0;k[i>>2]=1;k[d>>2]=95344;k[d+8>>2]=c;j=d;l=c;dRa(c,b);e=c+356|0;f=k[b+356>>2]|0;g=k[b+360>>2]|0;if(f|0){h=f+4|0;k[h>>2]=(k[h>>2]|0)+1}h=k[e>>2]|0;k[e>>2]=f;k[c+360>>2]=g;if(h|0?(f=h+4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)Uh[k[(k[h>>2]|0)+8>>2]&2047](h);e=c+364|0;f=k[b+364>>2]|0;g=k[b+368>>2]|0;if(f|0){h=f+4|0;k[h>>2]=(k[h>>2]|0)+1}h=k[e>>2]|0;k[e>>2]=f;k[c+368>>2]=g;if(h|0?(f=h+4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)Uh[k[(k[h>>2]|0)+8>>2]&2047](h);e=c+372|0;f=k[b+372>>2]|0;g=k[b+376>>2]|0;if(f|0){h=f+4|0;k[h>>2]=(k[h>>2]|0)+1}h=k[e>>2]|0;k[e>>2]=f;k[c+376>>2]=g;if(h|0?(f=h+4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)Uh[k[(k[h>>2]|0)+8>>2]&2047](h);g=b+380|0;h=k[g+4>>2]|0;b=c+380|0;k[b>>2]=k[g>>2];k[b+4>>2]=h;k[a>>2]=j;k[a+4>>2]=l;k[i>>2]=(k[i>>2]|0)+1;b=k[i>>2]|0;k[i>>2]=b+-1;if((b|0)!=1)return;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);return}function oRa(a){a=a|0;return 1}function pRa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;if(!((c|0)>-1?(e=k[a+352>>2]|0,d=k[e+4>>2]|0,e=k[e>>2]|0,((d-e|0)/20|0|0)>(c|0)):0)){d=j+4|0;e=ZT(56)|0;k[e>>2]=1;f=e+4|0;k[j>>2]=f;k[d>>2]=50;i[e+54>>0]=0;g=378471;h=f+50|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,j,378952,378394,847);k[d>>2]=0;k[j>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);d=k[a+352>>2]|0;e=k[d>>2]|0;d=k[d+4>>2]|0}if(((d-e|0)/20|0)>>>0<=c>>>0)ad(426635,426557,315,426658);f=k[b>>2]|0;if((f|0)<0){c=0;r=l;return c|0}d=k[b+4>>2]|0;if((d|0)<0){c=0;r=l;return c|0}if(((k[a+8>>2]|0)+f|0)>=(k[e+(c*20|0)+4>>2]|0)){c=0;r=l;return c|0}if(((k[a+12>>2]|0)+d|0)>=(k[e+(c*20|0)+8>>2]|0)){c=0;r=l;return c|0}b=(k[a+60>>2]|0)+(aa(k[k[a+88>>2]>>2]|0,d)|0)+(f<<2)|0;k[a+384>>2]=b+(k[e+(c*20|0)+12>>2]<<2);c=1;r=l;return c|0}function qRa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;c=k[a+380>>2]|0;d=k[a+384>>2]|0;i=k[d+(k[c+(b<<6)+20>>2]<<2)>>2]|0;o=k[d+(k[c+(b<<6)+24>>2]<<2)>>2]|0;f=k[d+(k[c+(b<<6)+36>>2]<<2)>>2]|0;l=k[d+(k[c+(b<<6)+40>>2]<<2)>>2]|0;a=i-o-f+l|0;q=k[d+(k[c+(b<<6)+4>>2]<<2)>>2]|0;h=k[d+(k[c+(b<<6)+16>>2]<<2)>>2]|0;p=k[d+(k[c+(b<<6)+8>>2]<<2)>>2]|0;n=k[d+(k[c+(b<<6)+28>>2]<<2)>>2]|0;m=k[d+(k[c+(b<<6)+44>>2]<<2)>>2]|0;j=k[d+(k[c+(b<<6)+56>>2]<<2)>>2]|0;g=k[d+(k[c+(b<<6)+52>>2]<<2)>>2]|0;e=k[d+(k[c+(b<<6)+32>>2]<<2)>>2]|0;return ((o-i+q-p|0)>=(a|0)?64:0)|(((k[d+(k[c+(b<<6)>>2]<<2)>>2]|0)+i-q-h|0)>=(a|0)?128:0)|((p-o-(k[d+(k[c+(b<<6)+12>>2]<<2)>>2]|0)+n|0)>=(a|0)?32:0)|((o-l-n+m|0)>=(a|0)?16:0)|((l-m-j+(k[d+(k[c+(b<<6)+60>>2]<<2)>>2]|0)|0)>=(a|0)?8:0)|((f-l+j-g|0)>=(a|0)?4:0)|(f-i+h-e|0)>=(a|0)|((g-f+e-(k[d+(k[c+(b<<6)+48>>2]<<2)>>2]|0)|0)>=(a|0)?2:0)|0}function rRa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=r;r=r+80|0;g=h+24|0;e=h+8|0;f=h;i=k[a+352>>2]|0;d=k[i>>2]|0;if((((k[i+4>>2]|0)-d|0)/20|0)>>>0<=b>>>0)ad(426635,426557,315,426658);if((k[c>>2]&2031616|0)==655360){j=k[d+(b*20|0)+12>>2]|0;f=k[a+16>>2]|0;i=k[d+(b*20|0)+4>>2]|0;d=k[d+(b*20|0)+8>>2]|0;k[e>>2]=(j|0)%(f|0)|0;k[e+4>>2]=(j|0)/(f|0)|0;k[e+8>>2]=i;k[e+12>>2]=d;u9(g,a+204|0,e);d=e+4|0;i=d+4|0;k[i>>2]=0;k[i+4>>2]=0;k[e>>2]=34209792;k[d>>2]=g;Iua(c,e,49332,49332,4,-1);c=g+24|0;d=k[c>>2]|0;if(d|0?(i=d+8|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){j=k[c>>2]|0;i=k[j+4>>2]|0;jh[k[(k[i>>2]|0)+16>>2]&1023](i,j);k[c>>2]=0}a=g+4|0;if((k[a>>2]|0)>0){b=k[g+32>>2]|0;d=0;do{k[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[a>>2]|0))}k[c>>2]=0;d=k[g+36>>2]|0;if(!((d|0)==(g+40|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=h;return}k[f>>2]=k[d+(b*20|0)+4>>2];k[f+4>>2]=k[d+(b*20|0)+8>>2];YN(g,f,4,(k[a+60>>2]|0)+(k[d+(b*20|0)+12>>2]<<2)|0,k[a+92>>2]|0);b=e+4|0;d=b+4|0;k[d>>2]=0;k[d+4>>2]=0;k[e>>2]=33619968;k[b>>2]=g;Iua(c,e,49332,49332,4,-1);b=g+36|0;d=k[b>>2]|0;if(d|0?(i=d+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){d=k[b>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[g+32>>2]|0;if(!a){a=B1()|0;d=k[b>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[b>>2]=0}k[b>>2]=0;j=g+16|0;a=g+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[a>>2]|0)>0){b=k[g+40>>2]|0;d=0;do{k[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[a>>2]|0))}d=k[g+44>>2]|0;if(!((d|0)==(g+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=h;return}function sRa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+80|0;u=w+56|0;v=w;t=k[a+16>>2]|0;q=k[a+360>>2]|0;s=(k[q+4>>2]|0)-(k[q>>2]|0)>>4;n=a+368|0;g=k[n>>2]|0;p=g+4|0;f=k[p>>2]|0;b=k[g>>2]|0;j=f-b>>6;c=b;d=f;if(s>>>0<=j>>>0){if(s>>>0<j>>>0?(e=c+(s<<6)|0,(d|0)!=(e|0)):0)k[p>>2]=d+(~((d+-64-e|0)>>>6)<<6)}else{c=s-j|0;m=g+8|0;d=k[m>>2]|0;if(d-f>>6>>>0<c>>>0){if(s>>>0>67108863)ad(426534,426557,304,426811);o=d-b|0;l=o>>5;l=o>>6>>>0<33554431?(l>>>0<s>>>0?s:l):67108863;if(!l)h=0;else{if(l>>>0>67108863){w=te(4)|0;k[w>>2]=172664;Cf(w|0,28816,1287)}d=l<<6;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}h=b}f=h+(j<<6)|0;b=f;e=f;do{o=b+64|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(o|0));b=e+64|0;e=b;c=c+-1|0}while((c|0)!=0);c=k[g>>2]|0;d=(k[p>>2]|0)-c|0;b=f+(0-(d>>6)<<6)|0;if((d|0)>0)upb(b|0,c|0,d|0)|0;k[g>>2]=b;k[p>>2]=e;k[m>>2]=h+(l<<6);if(c|0)ggb(c)}else{b=f;do{o=b+64|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(o|0));b=(k[p>>2]|0)+64|0;k[p>>2]=b;c=c+-1|0}while((c|0)!=0)}b=k[n>>2]|0;g=b;b=k[b>>2]|0}k[a+380>>2]=b;if(s|0){d=k[q>>2]|0;c=0;do{o=k[d+(c<<4)>>2]|0;j=k[d+(c<<4)+4>>2]|0;m=k[d+(c<<4)+8>>2]|0;p=k[d+(c<<4)+12>>2]|0;h=aa(j,t)|0;k[b+(c<<6)>>2]=h+o;q=m+o|0;k[b+(c<<6)+4>>2]=q+h;n=aa(p+j|0,t)|0;k[b+(c<<6)+16>>2]=n+o;k[b+(c<<6)+20>>2]=n+q;l=(m<<1)+o|0;k[b+(c<<6)+8>>2]=l+h;m=l+m|0;k[b+(c<<6)+12>>2]=m+h;k[b+(c<<6)+24>>2]=n+l;k[b+(c<<6)+28>>2]=m+n;j=(p<<1)+j|0;n=aa(j,t)|0;k[b+(c<<6)+40>>2]=n+l;k[b+(c<<6)+44>>2]=n+m;p=aa(j+p|0,t)|0;k[b+(c<<6)+56>>2]=p+l;k[b+(c<<6)+60>>2]=p+m;k[b+(c<<6)+32>>2]=n+o;k[b+(c<<6)+36>>2]=n+q;k[b+(c<<6)+48>>2]=p+o;k[b+(c<<6)+52>>2]=p+q;c=c+1|0}while((c|0)!=(s|0))}t=a+252|0;c=k[g>>2]|0;f=g+4|0;b=k[f>>2]|0;if((c|0)==(b|0)){e=a+276|0;b=k[e>>2]|0;if(b|0?(q=b+8|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){s=k[e>>2]|0;q=k[s+4>>2]|0;jh[k[(k[q>>2]|0)+16>>2]&1023](q,s);k[e>>2]=0}d=a+256|0;if((k[d>>2]|0)>0){c=k[a+284>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}k[e>>2]=0;c=k[g>>2]|0;b=k[f>>2]|0}d=b-c|0;b=c;k[v>>2]=1124007936;p=v+4|0;k[p>>2]=2;h=v+8|0;k[h>>2]=1;f=v+12|0;k[f>>2]=d;m=v+16|0;k[m>>2]=b;g=v+20|0;k[g>>2]=b;j=v+24|0;l=v+28|0;n=v+40|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[n>>2]=h;s=v+48|0;q=v+44|0;k[q>>2]=s;k[v+52>>2]=0;k[s>>2]=0;if((c|0)==0&(d|0)!=0){c=u+4|0;d=ZT(36)|0;k[d>>2]=1;b=d+4|0;k[u>>2]=b;k[c>>2]=28;i[d+32>>0]=0;e=390609;o=b+28|0;do{i[b>>0]=i[e>>0]|0;b=b+1|0;e=e+1|0}while((b|0)<(o|0));Y8(-215,u,390638,390642,410);k[c>>2]=0;k[u>>2]=0;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)==1)ggb(k[d+-4>>2]|0);e=k[v>>2]|16384;d=k[f>>2]|0;c=k[q>>2]|0;b=k[g>>2]|0}else{e=1124024320;c=s}k[v>>2]=e;k[c>>2]=d;k[c+4>>2]=1;b=b+(aa(k[h>>2]|0,d)|0)|0;k[l>>2]=b;k[j>>2]=b+(0-d)+d;d=u+4|0;b=d+4|0;k[b>>2]=0;k[b+4>>2]=0;k[u>>2]=34209792;k[d>>2]=t;mY(v,u);d=v+36|0;b=k[d>>2]|0;if(b|0?(a=b+12|0,u=k[a>>2]|0,k[a>>2]=u+-1,(u|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[v+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[p>>2]|0)>0){c=k[n>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[p>>2]|0))}b=k[q>>2]|0;if((b|0)==(s|0)|(b|0)==0){r=w;return}ggb(k[b+-4>>2]|0);r=w;return}function tRa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;b=a+8|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;k[b+24>>2]=0;k[b+28>>2]=0;k[a+44>>2]=1124007936;b=a+52|0;c=a+84|0;d=a+48|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;b=a+92|0;k[a+88>>2]=b;k[a+96>>2]=0;k[b>>2]=0;k[a+100>>2]=1124007936;b=a+108|0;c=a+140|0;d=a+104|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;f=a+148|0;k[a+144>>2]=f;k[a+152>>2]=0;k[f>>2]=0;k[a+156>>2]=1124007936;f=a+160|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[a+188>>2]=a+164;f=a+196|0;k[a+192>>2]=f;k[a+200>>2]=0;k[f>>2]=0;k[a+204>>2]=1124007936;f=a+208|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[a+236>>2]=a+212;f=a+244|0;k[a+240>>2]=f;k[a+248>>2]=0;k[f>>2]=0;k[a+252>>2]=1124007936;f=a+256|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[a+284>>2]=a+260;f=a+292|0;k[a+288>>2]=f;k[a+296>>2]=0;k[f>>2]=0;k[a+300>>2]=1124007936;f=a+304|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[a+332>>2]=a+308;f=a+340|0;k[a+336>>2]=f;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[a>>2]=95284;f=a+356|0;g=a+360|0;h=a+364|0;i=a+368|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;while(1){b=fgb(12)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=95364;k[c+8>>2]=b;k[d>>2]=(k[d>>2]|0)+1;e=k[f>>2]|0;k[f>>2]=c;k[g>>2]=b;if(e|0?(f=e+4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);while(1){b=fgb(12)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=95384;k[c+8>>2]=b;k[d>>2]=(k[d>>2]|0)+1;e=k[h>>2]|0;k[h>>2]=c;k[i>>2]=b;if(e|0?(h=e+4|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);i=k[d>>2]|0;k[d>>2]=i+-1;if((i|0)==1)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);while(1){b=fgb(12)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=95144;k[c+8>>2]=b;i=a+348|0;k[d>>2]=(k[d>>2]|0)+1;e=k[i>>2]|0;k[i>>2]=c;k[a+352>>2]=b;if(e|0?(i=e+4|0,a=k[i>>2]|0,k[i>>2]=a+-1,(a|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function uRa(a){a=a|0;ggb(a);return}function vRa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function wRa(a){a=a|0;ggb(a);return}function xRa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=k[a+8>>2]|0;if(b|0){c=k[b>>2]|0;d=c;if(c|0){e=b+4|0;f=k[e>>2]|0;if((f|0)!=(c|0))k[e>>2]=f+(~((f+-64-d|0)>>>6)<<6);ggb(c)}ggb(b)}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function yRa(a){a=a|0;ggb(a);return}function zRa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=k[a+8>>2]|0;if(b|0){c=k[b>>2]|0;d=c;if(c|0){e=b+4|0;f=k[e>>2]|0;if((f|0)!=(c|0))k[e>>2]=f+(~((f+-16-d|0)>>>4)<<4);ggb(c)}ggb(b)}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function ARa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=95404;b=a+416|0;d=(k[b>>2]|0)+28|0;e=k[d>>2]|0;k[d>>2]=e+-1;if((e|0)==1?(c=k[b>>2]|0,c|0):0){rf(c|0)|0;ggb(c)}k[b>>2]=0;e=a+392|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=a+372|0;if((k[c>>2]|0)>0){d=k[a+400>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[a+404>>2]|0;if(!((b|0)==(a+408|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=a+344|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=a+324|0;if((k[c>>2]|0)>0){d=k[a+352>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[a+356>>2]|0;if(!((b|0)==(a+360|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=a+296|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=a+276|0;if((k[c>>2]|0)>0){d=k[a+304>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[a+308>>2]|0;if(!((b|0)==(a+312|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=a+248|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=a+228|0;if((k[c>>2]|0)>0){d=k[a+256>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[a+260>>2]|0;if(!((b|0)==(a+264|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=a+200|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=a+180|0;if((k[c>>2]|0)>0){d=k[a+208>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[a+212>>2]|0;if(!((b|0)==(a+216|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=a+152|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=a+132|0;if((k[c>>2]|0)>0){d=k[a+160>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[a+164>>2]|0;if(!((b|0)==(a+168|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=a+120|0;c=k[b>>2]|0;do if(c|0){d=c+4|0;e=k[d>>2]|0;k[d>>2]=e+-1;if((e|0)!=1)break;Uh[k[(k[c>>2]|0)+8>>2]&2047](c)}while(0);k[b>>2]=0;k[a+124>>2]=0;b=a+112|0;c=k[b>>2]|0;do if(c|0){d=c+4|0;e=k[d>>2]|0;k[d>>2]=e+-1;if((e|0)!=1)break;Uh[k[(k[c>>2]|0)+8>>2]&2047](c)}while(0);k[b>>2]=0;k[a+116>>2]=0;b=a+104|0;c=k[b>>2]|0;if(!c){k[b>>2]=0;e=a+108|0;k[e>>2]=0;a=a+4|0;XRa(a);return}d=c+4|0;e=k[d>>2]|0;k[d>>2]=e+-1;if((e|0)!=1){k[b>>2]=0;e=a+108|0;k[e>>2]=0;a=a+4|0;XRa(a);return}Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;e=a+108|0;k[e>>2]=0;a=a+4|0;XRa(a);return}function BRa(a){a=a|0;ARa(a);ggb(a);return}function CRa(a,b){a=a|0;b=b|0;YRa(a,b)|0;return}function DRa(a){a=a|0;if(k[a+116>>2]|0){a=0;return a|0}a=(k[a+32>>2]|0)==(k[a+36>>2]|0);return a|0}function ERa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+240|0;x=B+132|0;w=B+88|0;u=B+44|0;z=B+8|0;v=B;A=a+112|0;c=k[A>>2]|0;if(c|0?(t=c+4|0,y=k[t>>2]|0,k[t>>2]=y+-1,(y|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[A>>2]=0;y=a+116|0;k[y>>2]=0;c=a+4|0;k[x+8>>2]=0;k[x+4>>2]=0;k[x>>2]=0;g=x+16|0;h=g+84|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[c>>2]=k[x>>2];k[c+4>>2]=k[x+4>>2];k[c+8>>2]=k[x+8>>2];k[c+12>>2]=k[x+12>>2];k[c+16>>2]=k[x+16>>2];k[a+24>>2]=0;k[a+28>>2]=0;do if((c|0)!=(x|0)){c=k[a+32>>2]|0;d=a+36|0;e=k[d>>2]|0;if((e|0)!=(c|0))k[d>>2]=e+(~(((e+-12-c|0)>>>0)/12|0)*12|0);c=k[a+44>>2]|0;d=a+48|0;e=k[d>>2]|0;if((e|0)!=(c|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);c=k[a+56>>2]|0;d=a+60|0;e=k[d>>2]|0;if((e|0)!=(c|0))k[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);zH(a+68|0,0,0);dQ(a+80|0,k[x+76>>2]|0,k[x+80>>2]|0);f=a+92|0;p=k[x+88>>2]|0;d=k[x+92>>2]|0;l=d;h=p;g=l-h|0;o=g>>4;j=a+100|0;c=k[j>>2]|0;m=k[f>>2]|0;n=m;if(o>>>0<=c-m>>4>>>0){j=a+96|0;f=(k[j>>2]|0)-m>>4;g=o>>>0>f>>>0;f=g?p+(f<<4)|0:d;e=f;c=e-h|0;d=c>>4;if(d|0)wpb(m|0,p|0,c|0)|0;d=n+(d<<4)|0;if(g){c=l-e|0;if((c|0)<=0)break;upb(k[j>>2]|0,f|0,c|0)|0;k[j>>2]=(k[j>>2]|0)+(c>>4<<4);break}else{c=k[j>>2]|0;if((c|0)==(d|0))break;k[j>>2]=c+(~((c+-16-d|0)>>>4)<<4);break}}e=m;if(m){c=a+96|0;d=k[c>>2]|0;if((d|0)!=(n|0))k[c>>2]=d+(~((d+-16-m|0)>>>4)<<4);ggb(e);k[j>>2]=0;k[c>>2]=0;k[f>>2]=0;c=0}if(o>>>0>268435455)ad(426534,426557,304,426811);e=c>>3;e=c>>4>>>0<134217727?(e>>>0<o>>>0?o:e):268435455;if(e>>>0>268435455)bob();d=e<<4;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=a+96|0;k[d>>2]=c;k[f>>2]=c;k[j>>2]=c+(e<<4);if((g|0)>0){upb(c|0,p|0,g|0)|0;k[d>>2]=c+(o<<4)}}while(0);XRa(x);c=a+104|0;d=k[c>>2]|0;if(d|0?(p=d+4|0,t=k[p>>2]|0,k[p>>2]=t+-1,(t|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);k[c>>2]=0;k[a+108>>2]=0;k[x>>2]=0;c=x+4|0;k[c>>2]=0;x6(z,b,0,x);k[c>>2]=0;k[x>>2]=0;c=k[z+8>>2]|0;g=z+8|0;if(!c){A=0;T4(z);r=B;return A|0}if(!(i[c+272>>0]|0)){A=0;T4(z);r=B;return A|0}y6(x,z);e=k[x>>2]|0;f=k[x+4>>2]|0;if((e|0)!=0&(f|0)!=0?(q=k[f>>2]|0,s=q&7,(s|0)!=0):0){k[w>>2]=e;k[w+4>>2]=f;if((s+-5|0)>>>0<2&(q&16|0)==0){c=f+8|0;KY(k[c>>2]|0,w+8|0);d=k[f>>2]|0;switch(d&7){case 6:{c=k[(k[c>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[c>>2]|0)+24>>2]|0;break}default:c=(d&7|0)!=0&1}k[w+40>>2]=c}else{k[w+20>>2]=f;k[w+12>>2]=0;k[w+40>>2]=1}t=49}else{k[w>>2]=0;k[w+4>>2]=0;k[w+20>>2]=0;k[w+40>>2]=0;if(!f){c=1;t=53}else t=49}a:do if((t|0)==49){c=k[f>>2]|0;switch(c&7){case 6:{c=k[(k[f+8>>2]|0)+60>>2]|0;break a}case 5:{c=k[(k[f+8>>2]|0)+24>>2]|0;break a}default:{c=(c&7|0)==0;t=53;break a}}}while(0);if((t|0)==53)c=c&1^1;B6(u,e,f,c);s=k[w>>2]|0;c=s;if((((s|0)==(k[u>>2]|0)?(k[w+4>>2]|0)==(k[u+4>>2]|0):0)?(k[w+20>>2]|0)==(k[u+20>>2]|0):0)?(k[w+40>>2]|0)==(k[u+40>>2]|0):0){k[v>>2]=0;k[v+4>>2]=0}else{u=k[w+20>>2]|0;k[v>>2]=c;k[v+4>>2]=u}if(YRa(a,v)|0){A=1;T4(z);r=B;return A|0}c=z+4|0;d=k[c>>2]|0;if(d|0?(u=d+4|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);k[c>>2]=0;k[g>>2]=0;c=k[z+20>>2]|0;d=z+24|0;if((k[d>>2]|0)!=(c|0))k[d>>2]=c;k[z+32>>2]=0;c=k[b>>2]|0;c=a5((c|0)==0?1016759:c,0,0)|0;k[x>>2]=49564;e=x+4|0;s=x+8|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;k[e+16>>2]=0;k[e+20>>2]=0;k[e+24>>2]=0;b:do if(c){while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d+4>>2]=1;k[d>>2]=49596;k[d+8>>2]=c;k[e>>2]=d;k[s>>2]=c;k[x+32>>2]=6;if(i[c+272>>0]|0){e=k[c+32>>2]|0;d=k[e+24>>2]|0;if((d|0)>0){m=w+12|0;n=w+20|0;o=w+8|0;l=w+4|0;p=w+16|0;q=c+32|0;j=0;g=d;c:do{if(g>>>0<=j>>>0){d=j-((j|0)>=(g|0)?g:0)|0;if(d>>>0<g>>>0)t=75;else d=0}else{d=j;t=75}if((t|0)==75){t=0;f=k[e+52>>2]|0;do if((d<<1|0)>(g|0)){do{f=k[f>>2]|0;g=g-(k[f+12>>2]|0)|0}while((d|0)<(g|0));d=d-g|0}else{g=k[f+12>>2]|0;if((d|0)<(g|0))break;do{f=k[f+4>>2]|0;d=d-g|0;g=k[f+12>>2]|0}while((d|0)>=(g|0))}while(0);d=(k[f+16>>2]|0)+(aa(k[e+28>>2]|0,d)|0)|0}d:do if((k[d>>2]&7|0)==6){d=k[d+8>>2]|0;KY(d,w);h=k[d+24>>2]|0;if((h|0)>0){g=d+28|0;f=(k[l>>2]|0)+28|0;e=0;d=k[m>>2]|0;while(1){if((k[d>>2]|0)>-1)break;d=d+(k[g>>2]|0)|0;k[m>>2]=d;if(d>>>0>=(k[n>>2]|0)>>>0){b=k[(k[o>>2]|0)+4>>2]|0;k[o>>2]=b;d=k[b+16>>2]|0;k[m>>2]=d;v=k[f>>2]|0;b=k[b+12>>2]|0;k[p>>2]=d;b=d+(aa(v,b)|0)|0;k[n>>2]=b}e=e+1|0;if((e|0)>=(h|0)){f=0;d=0;break d}}f=8}else{f=0;d=0}}else f=1;while(0);switch(f&15){case 8:break c;case 0:break;default:{t=92;break c}}j=j+1|0;e=k[q>>2]|0;g=k[e+24>>2]|0}while((j|0)<(g|0));if((t|0)==92?f|0:0){e=0;break}if(!d)t=94}else t=94;if((t|0)==94){k[w>>2]=0;c=w+4|0;k[c>>2]=0;d=ZT(52)|0;k[d>>2]=1;g=d+4|0;k[w>>2]=g;k[c>>2]=44;i[d+48>>0]=0;f=228930;h=g+44|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-204,w,228975,221854,5081);k[c>>2]=0;k[w>>2]=0;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);d=0;c=k[s>>2]|0}e=s6(c,d)|0;if(e){c=k[e>>2]&-65536;if((c|0)<1117323264)switch(c|0){case 1117257728:break;default:break b}else switch(c|0){case 1117323264:break;default:break b}k[w>>2]=0;c=w+4|0;k[c>>2]=0;d=ZT(84)|0;k[d>>2]=1;g=d+4|0;k[w>>2]=g;k[c>>2]=78;i[d+82>>0]=0;f=228982;h=g+78|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-27,w,228975,221854,5089);k[c>>2]=0;k[w>>2]=0;w=k[d>>2]|0;k[d>>2]=w+-1;if((w|0)==1)ggb(k[d+-4>>2]|0)}else e=0}else e=0}else{k[e>>2]=0;k[s>>2]=0;k[x+32>>2]=0;e=0}while(0);T4(x);if(!e)c=0;else{while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c+4>>2]=1;k[c>>2]=95504;k[c+8>>2]=e}d=k[A>>2]|0;k[A>>2]=c;k[y>>2]=e;if(d|0?(x=d+4|0,A=k[x>>2]|0,k[x>>2]=A+-1,(A|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);A=(k[y>>2]|0)!=0;T4(z);r=B;return A|0}function FRa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;m=r;r=r+48|0;j=m+28|0;n=m+16|0;p=m+8|0;o=m;k[j>>2]=0;l=j+4|0;k[l>>2]=0;k[j+8>>2]=0;k[n>>2]=0;i=n+4|0;k[i>>2]=0;k[n+8>>2]=0;q=k[(k[a>>2]|0)+44>>2]|0;k[p>>2]=k[g>>2];k[p+4>>2]=k[g+4>>2];k[o>>2]=k[h>>2];k[o+4>>2]=k[h+4>>2];Oh[q&3](a,b,c,j,n,d,e,f,p,o,0);a=k[n>>2]|0;b=a;if(a|0){c=k[i>>2]|0;if((c|0)!=(a|0))k[i>>2]=c+(~((c+-8-b|0)>>>3)<<3);ggb(a)}a=k[j>>2]|0;if(!a){r=m;return}b=k[l>>2]|0;if((b|0)!=(a|0))k[l>>2]=b+(~((b+-4-a|0)>>>2)<<2);ggb(a);r=m;return}function GRa(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=r;r=r+144|0;E=F+80|0;D=F+68|0;C=F+56|0;y=F+32|0;z=F+48|0;w=F+24|0;x=F+16|0;t=F+8|0;u=F;do if((k[b>>2]&2031616|0)==65536){n=k[b+4>>2]|0;k[E>>2]=k[n>>2];s=E+4|0;b=n+4|0;k[s>>2]=k[b>>2];A=E+8|0;k[A>>2]=k[n+8>>2];k[E+12>>2]=k[n+12>>2];k[E+16>>2]=k[n+16>>2];k[E+20>>2]=k[n+20>>2];k[E+24>>2]=k[n+24>>2];k[E+28>>2]=k[n+28>>2];k[E+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[E+36>>2]=l;m=E+40|0;k[m>>2]=A;A=E+48|0;p=E+44|0;k[p>>2]=A;k[E+52>>2]=0;k[A>>2]=0;if(l|0){A=l+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[b>>2]|0)<3){v=k[n+44>>2]|0;A=k[p>>2]|0;k[A>>2]=k[v>>2];k[A+4>>2]=k[v+4>>2];break}k[s>>2]=0;x1(E,k[b>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[n+40>>2]|0;o=k[m>>2]|0;m=k[n+44>>2]|0;l=k[p>>2]|0;b=0;do{k[o+(b<<2)>>2]=k[q+(b<<2)>>2];k[l+(b<<2)>>2]=k[m+(b<<2)>>2];b=b+1|0}while((b|0)<(k[s>>2]|0))}}else Q1(E,b,-1);while(0);if(!(e>1.0?!(k[E>>2]&7|0):0)){k[D>>2]=0;b=D+4|0;k[b>>2]=0;l=ZT(48)|0;k[l>>2]=1;m=l+4|0;k[D>>2]=m;k[b>>2]=41;i[l+45>>0]=0;n=379706;o=m+41|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,D,379340,378394,1367);k[b>>2]=0;k[D>>2]=0;A=k[l>>2]|0;k[l>>2]=A+-1;if((A|0)==1)ggb(k[l+-4>>2]|0)}if(!(Xh[k[(k[a>>2]|0)+20>>2]&1023](a)|0)){k[D>>2]=0;A=D+4|0;k[A>>2]=0;k[D+8>>2]=0;k[C>>2]=0;v=C+4|0;k[v>>2]=0;k[C+8>>2]=0;if(Xh[k[(k[a>>2]|0)+48>>2]&1023](a)|0){k[y>>2]=0;t=y+4|0;k[t>>2]=0;k[y+8>>2]=0;b=k[a+112>>2]|0;k[z>>2]=b;l=z+4|0;k[l>>2]=k[a+116>>2];if(b|0){a=b+4|0;k[a>>2]=(k[a>>2]|0)+1}k[w>>2]=k[h>>2];k[w+4>>2]=k[h+4>>2];k[x>>2]=k[j>>2];k[x+4>>2]=k[j+4>>2];ORa(E,z,c,D,C,y,e,f,g,w,x,0);b=k[z>>2]|0;if(b|0?(h=b+4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);k[z>>2]=0;k[l>>2]=0;s=k[t>>2]|0;q=k[y>>2]|0;m=(s-q|0)/20|0;n=d+4|0;p=k[n>>2]|0;b=k[d>>2]|0;o=p-b>>2;l=q;if(m>>>0<=o>>>0){if(m>>>0<o>>>0?(B=b+(m<<2)|0,(p|0)!=(B|0)):0)k[n>>2]=p+(~((p+-4-B|0)>>>2)<<2)}else{U1(d,m-o|0);b=k[d>>2]|0}m=(l|0)==(s|0);if(!m)while(1){k[b>>2]=k[l+16>>2];l=l+20|0;if((l|0)==(s|0))break;else b=b+4|0}b=q;if(q|0){if(!m)k[t>>2]=s+(~(((s+-20-q|0)>>>0)/20|0)*20|0);ggb(b)}}else{k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=E;k[t>>2]=k[h>>2];k[t+4>>2]=k[h+4>>2];k[u>>2]=k[j>>2];k[u+4>>2]=k[j+4>>2];PRa(a,y,c,D,C,e,t,u,0);QRa(c,f,.2,d,0)}b=k[C>>2]|0;l=b;if(b|0){m=k[v>>2]|0;if((m|0)!=(b|0))k[v>>2]=m+(~((m+-8-l|0)>>>3)<<3);ggb(b)}b=k[D>>2]|0;l=b;if(b|0){m=k[A>>2]|0;if((m|0)!=(b|0))k[A>>2]=m+(~((m+-4-l|0)>>>2)<<2);ggb(b)}}m=E+36|0;b=k[m>>2]|0;if(b|0?(C=b+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){l=k[m>>2]|0;if(l|0){b=k[l+4>>2]|0;if(!b){b=k[E+32>>2]|0;if(!b){b=B1()|0;l=k[m>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,l)}k[m>>2]=0}k[m>>2]=0;D=E+16|0;l=E+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[l>>2]|0)>0){m=k[E+40>>2]|0;b=0;do{k[m+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[E+44>>2]|0;if((b|0)==(E+48|0)|(b|0)==0){r=F;return}ggb(k[b+-4>>2]|0);r=F;return}function HRa(a,b,c,d,e,f,g,h,j,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+112|0;z=A+56|0;x=A+32|0;y=A+48|0;v=A+24|0;w=A+16|0;n=A+8|0;o=A;if(!(f>1.0?!((S1(b,-1)|0)&7|0):0)){p=z+4|0;q=ZT(48)|0;k[q>>2]=1;s=q+4|0;k[z>>2]=s;k[p>>2]=42;i[q+46>>0]=0;t=379297;u=s+42|0;do{i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(u|0));Y8(-215,z,379340,378394,1323);k[p>>2]=0;k[z>>2]=0;u=k[q>>2]|0;k[q>>2]=u+-1;if((u|0)==1)ggb(k[q+-4>>2]|0)}if(Xh[k[(k[a>>2]|0)+20>>2]&1023](a)|0){r=A;return}if(!(Xh[k[(k[a>>2]|0)+48>>2]&1023](a)|0)){k[n>>2]=k[j>>2];k[n+4>>2]=k[j+4>>2];k[o>>2]=k[l>>2];k[o+4>>2]=k[l+4>>2];PRa(a,b,c,d,e,f,n,o,m);if(m){QRa(c,g,.2,d,e);r=A;return}else{QRa(c,g,.2,0,0);r=A;return}}do if((k[b>>2]&2031616|0)==65536){p=k[b+4>>2]|0;k[z>>2]=k[p>>2];u=z+4|0;b=p+4|0;k[u>>2]=k[b>>2];t=z+8|0;k[t>>2]=k[p+8>>2];k[z+12>>2]=k[p+12>>2];k[z+16>>2]=k[p+16>>2];k[z+20>>2]=k[p+20>>2];k[z+24>>2]=k[p+24>>2];k[z+28>>2]=k[p+28>>2];k[z+32>>2]=k[p+32>>2];n=k[p+36>>2]|0;k[z+36>>2]=n;o=z+40|0;k[o>>2]=t;t=z+48|0;s=z+44|0;k[s>>2]=t;k[z+52>>2]=0;k[t>>2]=0;if(n|0){t=n+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[b>>2]|0)<3){t=k[p+44>>2]|0;u=k[s>>2]|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];break}k[u>>2]=0;x1(z,k[b>>2]|0,0,0,0);if((k[u>>2]|0)>0){t=k[p+40>>2]|0;q=k[o>>2]|0;o=k[p+44>>2]|0;n=k[s>>2]|0;b=0;do{k[q+(b<<2)>>2]=k[t+(b<<2)>>2];k[n+(b<<2)>>2]=k[o+(b<<2)>>2];b=b+1|0}while((b|0)<(k[u>>2]|0))}}else Q1(z,b,-1);while(0);k[x>>2]=0;p=x+4|0;k[p>>2]=0;k[x+8>>2]=0;b=k[a+112>>2]|0;k[y>>2]=b;n=y+4|0;k[n>>2]=k[a+116>>2];if(b|0){a=b+4|0;k[a>>2]=(k[a>>2]|0)+1}k[v>>2]=k[j>>2];k[v+4>>2]=k[j+4>>2];k[w>>2]=k[l>>2];k[w+4>>2]=k[l+4>>2];ORa(z,y,c,d,e,x,f,g,h,v,w,m);b=k[y>>2]|0;if(b|0?(j=b+4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);k[y>>2]=0;k[n>>2]=0;b=k[x>>2]|0;n=b;if(b|0){o=k[p>>2]|0;if((o|0)!=(b|0))k[p>>2]=o+(~(((o+-20-n|0)>>>0)/20|0)*20|0);ggb(b)}o=z+36|0;b=k[o>>2]|0;if(b|0?(x=b+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){n=k[o>>2]|0;if(n|0){b=k[n+4>>2]|0;if(!b){b=k[z+32>>2]|0;if(!b){b=B1()|0;n=k[o>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,n)}k[o>>2]=0}k[o>>2]=0;y=z+16|0;n=z+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[n>>2]|0)>0){o=k[z+40>>2]|0;b=0;do{k[o+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[n>>2]|0))}b=k[z+44>>2]|0;if(!((b|0)==(z+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);r=A;return}function IRa(a){a=a|0;return (k[a+116>>2]|0)!=0|0}function JRa(a,b){a=a|0;b=b|0;k[a>>2]=k[b+24>>2];k[a+4>>2]=k[b+28>>2];return}function KRa(a){a=a|0;a=k[a+108>>2]|0;return Xh[k[(k[a>>2]|0)+16>>2]&1023](a)|0}function LRa(a){a=a|0;return k[a+116>>2]|0}function MRa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=a+120|0;e=k[b>>2]|0;c=k[b+4>>2]|0;if(e|0){b=e+4|0;k[b>>2]=(k[b>>2]|0)+1}b=k[d>>2]|0;k[d>>2]=e;k[a+124>>2]=c;if(!b)return;d=b+4|0;e=k[d>>2]|0;k[d>>2]=e+-1;if((e|0)!=1)return;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);return}function NRa(a,b){a=a|0;b=b|0;var c=0;c=k[b+120>>2]|0;k[a>>2]=c;k[a+4>>2]=k[b+124>>2];if(!c)return;c=c+4|0;k[c>>2]=(k[c>>2]|0)+1;return}function ORa(a,b,c,d,e,f,g,h,j,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;w=r;r=r+48|0;t=w;p=w+8|0;q=zY(0)|0;if(!q)v=0;else{while(1){o=fgb(16)|0;if(o|0)break;o=k[207666]|0;k[207666]=o+0;if(!o){o=0;break}Qh[o&7]()}k[o+4>>2]=1;k[o>>2]=63124;k[o+8>>2]=q;v=o}z=k[a+8>>2]|0;y=(k[a+4>>2]|0)==1?1:k[a+12>>2]|0;o=k[a>>2]|0;x=o&4095;A=k[a+16>>2]|0;B=aa((o>>>3&511)+1<<(47696>>>(x<<1&14)&3),y)|0;k[p>>2]=x|1111638016;x=p+4|0;k[x>>2]=B;k[p+8>>2]=0;k[p+12>>2]=0;k[p+16>>2]=A;k[p+20>>2]=z;k[p+24>>2]=y;k[x>>2]=k[k[a+44>>2]>>2];k[p>>2]=o&20479|1111621632;h=ASa(p,k[b+4>>2]|0,q,d,e,g,h,j,k[l>>2]|0,k[l+4>>2]|0,k[m>>2]|0,k[m+4>>2]|0,n)|0;if(!h)e=0;else{if((k[h+28>>2]|0)!=20){k[t>>2]=0;o=t+4|0;k[o>>2]=0;a=ZT(44)|0;k[a>>2]=1;b=a+4|0;k[t>>2]=b;k[o>>2]=39;i[a+43>>0]=0;m=379582;n=b+39|0;do{i[b>>0]=i[m>>0]|0;b=b+1|0;m=m+1|0}while((b|0)<(n|0));Y8(-215,t,379622,379626,2942);k[o>>2]=0;k[t>>2]=0;B=k[a>>2]|0;k[a>>2]=B+-1;if((B|0)==1)ggb(k[a+-4>>2]|0)}e=k[h+24>>2]|0}j=f+4|0;o=k[j>>2]|0;m=k[f>>2]|0;n=(o-m|0)/20|0;a=m;b=o;a:do if(e>>>0>n>>>0){a=e-n|0;d=f+8|0;b=k[d>>2]|0;if(((b-o|0)/20|0)>>>0>=a>>>0)while(1){k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;k[o+16>>2]=0;o=(k[j>>2]|0)+20|0;k[j>>2]=o;a=a+-1|0;if(!a)break a}if(e>>>0>214748364)ad(426534,426557,304,426811);B=(b-m|0)/20|0;q=B<<1;q=B>>>0<107374182?(q>>>0<e>>>0?e:q):214748364;if(!q)o=0;else{if(q>>>0>214748364){B=te(4)|0;k[B>>2]=172664;Cf(B|0,28816,1287)}b=q*20|0;b=(b|0)==0?1:b;while(1){o=fgb(b)|0;if(o|0)break;o=k[207666]|0;k[207666]=o+0;if(!o){o=0;break}Qh[o&7]()}}p=o+(n*20|0)|0;b=p;n=p;do{k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;b=n+20|0;n=b;a=a+-1|0}while((a|0)!=0);b=k[f>>2]|0;m=(k[j>>2]|0)-b|0;a=p+(((m|0)/-20|0)*20|0)|0;if((m|0)>0)upb(a|0,b|0,m|0)|0;k[f>>2]=a;k[j>>2]=n;k[d>>2]=o+(q*20|0);if(b|0)ggb(b)}else if(e>>>0<n>>>0?(s=a+(e*20|0)|0,(b|0)!=(s|0)):0)k[j>>2]=b+(~(((b+-20-s|0)>>>0)/20|0)*20|0);while(0);if((h|0)!=0&(e|0)!=0){B=k[f>>2]|0;A=t;k[A>>2]=0;k[A+4>>2]=1073741823;JY(h,B,0,1073741823)}b=k[j>>2]|0;a=k[f>>2]|0;m=(b-a|0)/20|0;n=c+4|0;q=k[n>>2]|0;o=k[c>>2]|0;p=q-o>>4;if(m>>>0<=p>>>0){if(m>>>0<p>>>0?(u=o+(m<<4)|0,(q|0)!=(u|0)):0)k[n>>2]=q+(~((q+-16-u|0)>>>4)<<4)}else{WRa(c,m-p|0);a=k[f>>2]|0;b=k[j>>2]|0;o=k[c>>2]|0}if((a|0)!=(b|0))while(1){z=k[a+4>>2]|0;A=k[a+8>>2]|0;B=k[a+12>>2]|0;k[o>>2]=k[a>>2];k[o+4>>2]=z;k[o+8>>2]=A;k[o+12>>2]=B;a=a+20|0;if((a|0)==(b|0))break;else o=o+16|0}if(!v){r=w;return}A=v+4|0;B=k[A>>2]|0;k[A>>2]=B+-1;if((B|0)!=1){r=w;return}Uh[k[(k[v>>2]|0)+8>>2]&2047](v);r=w;return}function PRa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0,n=0.0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=r;r=r+1376|0;A=P+1368|0;K=P+1312|0;D=P+1296|0;J=P+1240|0;I=P+1184|0;H=P+120|0;F=P+8|0;G=P;R1(A,b,-1);k[K>>2]=1124007936;N=K+4|0;j=K+8|0;L=K+40|0;x=N;y=x+36|0;do{k[x>>2]=0;x=x+4|0}while((x|0)<(y|0));k[L>>2]=j;O=K+48|0;M=K+44|0;k[M>>2]=O;k[K+52>>2]=0;k[O>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;j=k[c>>2]|0;l=c+4|0;m=k[l>>2]|0;if((m|0)!=(j|0))k[l>>2]=m+(~((m+-16-j|0)>>>4)<<4);j=k[d>>2]|0;l=d+4|0;m=k[l>>2]|0;if((m|0)!=(j|0))k[l>>2]=m+(~((m+-4-j|0)>>>2)<<2);j=k[e>>2]|0;l=e+4|0;m=k[l>>2]|0;if((m|0)!=(j|0))k[l>>2]=m+(~((m+-8-j|0)>>>3)<<3);w=h+4|0;if(!((k[w>>2]|0)!=0?(k[h>>2]|0)!=0:0)){k[h>>2]=k[A>>2];k[w>>2]=k[A+4>>2]}do if(!((S1(b,-1)|0)&4088)){if((k[b>>2]&2031616|0)!=65536){E=J+4|0;C=E+4|0;k[C>>2]=0;k[C+4>>2]=0;k[J>>2]=33619968;k[E>>2]=K;I2(b,J);break}q=k[b+4>>2]|0;k[J>>2]=k[q>>2];v=J+4|0;j=q+4|0;k[v>>2]=k[j>>2];E=J+8|0;k[E>>2]=k[q+8>>2];k[J+12>>2]=k[q+12>>2];k[J+16>>2]=k[q+16>>2];k[J+20>>2]=k[q+20>>2];k[J+24>>2]=k[q+24>>2];k[J+28>>2]=k[q+28>>2];k[J+32>>2]=k[q+32>>2];l=k[q+36>>2]|0;k[J+36>>2]=l;m=J+40|0;k[m>>2]=E;E=J+48|0;s=J+44|0;k[s>>2]=E;k[J+52>>2]=0;k[E>>2]=0;if(l|0){E=l+12|0;k[E>>2]=(k[E>>2]|0)+1}if((k[j>>2]|0)>=3){k[v>>2]=0;x1(J,k[j>>2]|0,0,0,0);if((k[v>>2]|0)>0){t=k[q+40>>2]|0;b=k[m>>2]|0;m=k[q+44>>2]|0;l=k[s>>2]|0;j=0;do{k[b+(j<<2)>>2]=k[t+(j<<2)>>2];k[l+(j<<2)>>2]=k[m+(j<<2)>>2];j=j+1|0}while((j|0)<(k[v>>2]|0))}}else{C=k[q+44>>2]|0;E=k[s>>2]|0;k[E>>2]=k[C>>2];k[E+4>>2]=k[C+4>>2]}KG(K,J)|0;m=J+36|0;j=k[m>>2]|0;if(j|0?(C=j+12|0,E=k[C>>2]|0,k[C>>2]=E+-1,(E|0)==1):0){l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;if(!j){j=k[J+32>>2]|0;if(!j){j=B1()|0;l=k[m>>2]|0}}jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}k[m>>2]=0;E=J+16|0;l=J+4|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[l>>2]|0)>0){m=k[J+40>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[J+44>>2]|0;if(!((j|0)==(J+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0)}else{E=J+4|0;C=E+4|0;k[C>>2]=0;k[C+4>>2]=0;k[J>>2]=33619968;k[E>>2]=K;$aa(b,J,6,0)}while(0);k[D>>2]=16842752;t=D+4|0;k[t>>2]=K;k[D+8>>2]=0;k[D+12>>2]=0;k[J>>2]=0;E=J+4|0;k[E>>2]=0;k[J+8>>2]=0;s=J+8|0;while(1){j=fgb(4096)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}m=j;k[J>>2]=m;k[E>>2]=m;k[s>>2]=j+4096;m=I+4|0;b=A+4|0;q=g+4|0;z=1.0;while(1){jh[k[(k[a>>2]|0)+52>>2]&1023](I,a);n=z*+(k[I>>2]|0);p[u>>3]=n;j=k[u+4>>2]|0;C=j&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){j=(j|0)<0;n=j?n+-4503599627370496.0+4503599627370496.0:n+4503599627370496.0+-4503599627370496.0;if(n==0.0)n=j?-0.0:0.0}l=~~n;n=z*+(k[m>>2]|0);p[u>>3]=n;j=k[u+4>>2]|0;C=j&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){j=(j|0)<0;n=j?n+-4503599627370496.0+4503599627370496.0:n+4503599627370496.0+-4503599627370496.0;if(n==0.0)n=j?-0.0:0.0}j=~~n;if((l|0)>(k[h>>2]|0))break;if(((j|0)>(k[w>>2]|0)?1:(l|0)>(k[A>>2]|0))|(j|0)>(k[b>>2]|0))break;if((l|0)>=(k[g>>2]|0)?(j|0)>=(k[q>>2]|0):0){n=z;o[H>>2]=n;j=k[E>>2]|0;if((j|0)==(k[s>>2]|0))MAa(J,H);else{o[j>>2]=n;k[E>>2]=j+4}}z=z*f}j=k[J>>2]|0;if((k[E>>2]|0)!=(j|0)){g=a+108|0;C=k[g>>2]|0;if(ci[k[(k[C>>2]|0)+20>>2]&255](C,D,J)|0){B=k[g>>2]|0;Uh[k[(k[B>>2]|0)+32>>2]&2047](B);k[I>>2]=1124007936;B=I+4|0;j=I+8|0;h=I+40|0;x=B;y=x+36|0;do{k[x>>2]=0;x=x+4|0}while((x|0)<(y|0));k[h>>2]=j;C=I+48|0;A=I+44|0;k[A>>2]=C;k[I+52>>2]=0;k[C>>2]=0;w=k[a+124>>2]|0;if(w|0){x=k[(k[w>>2]|0)+8>>2]|0;do if((k[D>>2]&2031616|0)==65536){b=k[t>>2]|0;k[F>>2]=k[b>>2];v=F+4|0;j=b+4|0;k[v>>2]=k[j>>2];D=F+8|0;k[D>>2]=k[b+8>>2];k[F+12>>2]=k[b+12>>2];k[F+16>>2]=k[b+16>>2];k[F+20>>2]=k[b+20>>2];k[F+24>>2]=k[b+24>>2];k[F+28>>2]=k[b+28>>2];k[F+32>>2]=k[b+32>>2];l=k[b+36>>2]|0;k[F+36>>2]=l;m=F+40|0;k[m>>2]=D;D=F+48|0;s=F+44|0;k[s>>2]=D;k[F+52>>2]=0;k[D>>2]=0;if(l|0){D=l+12|0;k[D>>2]=(k[D>>2]|0)+1}if((k[j>>2]|0)<3){y=k[b+44>>2]|0;D=k[s>>2]|0;k[D>>2]=k[y>>2];k[D+4>>2]=k[y+4>>2];break}k[v>>2]=0;x1(F,k[j>>2]|0,0,0,0);if((k[v>>2]|0)>0){t=k[b+40>>2]|0;q=k[m>>2]|0;m=k[b+44>>2]|0;l=k[s>>2]|0;j=0;do{k[q+(j<<2)>>2]=k[t+(j<<2)>>2];k[l+(j<<2)>>2]=k[m+(j<<2)>>2];j=j+1|0}while((j|0)<(k[v>>2]|0))}}else Q1(F,D,-1);while(0);Ph[x&511](H,w,F);KG(I,H)|0;m=H+36|0;j=k[m>>2]|0;if(j|0?(y=j+12|0,D=k[y>>2]|0,k[y>>2]=D+-1,(D|0)==1):0){l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;if(!j){j=k[H+32>>2]|0;if(!j){j=B1()|0;l=k[m>>2]|0}}jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}k[m>>2]=0;D=H+16|0;l=H+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[l>>2]|0)>0){m=k[H+40>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[H+44>>2]|0;if(!((j|0)==(H+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);m=F+36|0;j=k[m>>2]|0;if(j|0?(y=j+12|0,D=k[y>>2]|0,k[y>>2]=D+-1,(D|0)==1):0){l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[F+32>>2]|0;if(j|0)break;j=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}k[m>>2]=0;D=F+16|0;l=F+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[l>>2]|0)>0){m=k[F+40>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[F+44>>2]|0;if(!((j|0)==(F+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0)}t=(k[E>>2]|0)-(k[J>>2]|0)>>2;v=H+8|0;k[H>>2]=v;w=H+4|0;k[w>>2]=264;if(t>>>0>264){l=t>>>0>1073741823?-1:t<<2;l=(l|0)==0?1:l;while(1){j=fgb(l)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}k[H>>2]=j}else j=v;k[w>>2]=t;q=cRa(k[g>>2]|0,0)|0;m=a+28|0;s=(k[q+4>>2]|0)-(k[a+24>>2]|0)|0;f=+(((s|0)<0?0:s)|0)*.03125;s=~~f;s=(+(s|0)<f&1)+s|0;if(t|0){b=s+-1|0;l=0;do{g=(k[q+(l*20|0)+8>>2]|0)-(k[m>>2]|0)|0;D=k[q+(l*20|0)+16>>2]|0;g=(b+((((g|0)<0?0:g)|0)/(D|0)|0)|0)/(s|0)|0;D=aa((g|0)<1?1:g,D)|0;k[j+(l<<2)>>2]=D;l=l+1|0}while((l|0)!=(t|0))}k[F>>2]=95484;k[F+36>>2]=0;k[F+40>>2]=0;k[F+44>>2]=0;l=F+48|0;k[l>>2]=1124007936;m=F+56|0;b=F+88|0;x=F+52|0;y=x+36|0;do{k[x>>2]=0;x=x+4|0}while((x|0)<(y|0));k[b>>2]=m;D=F+96|0;k[F+92>>2]=D;k[F+100>>2]=0;k[D>>2]=0;k[F+4>>2]=a;k[F+12>>2]=t;k[F+16>>2]=s;k[F+20>>2]=q;k[F+24>>2]=j;k[F+8>>2]=c;k[F+28>>2]=i?d:0;k[F+32>>2]=i?e:0;KG(l,I)|0;k[F+104>>2]=a+416;k[G>>2]=0;k[G+4>>2]=s;jh[k[(k[F>>2]|0)+8>>2]&1023](F,G);TRa(F);j=k[H>>2]|0;if((j|0)!=(v|0)){if(j|0)ggb(j);k[H>>2]=v;k[w>>2]=264}m=I+36|0;j=k[m>>2]|0;if(j|0?(i=j+12|0,H=k[i>>2]|0,k[i>>2]=H+-1,(H|0)==1):0){l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[I+32>>2]|0;if(j|0)break;j=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}k[m>>2]=0;I=I+16|0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[B>>2]|0)>0){l=k[h>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[B>>2]|0))}j=k[A>>2]|0;if(!((j|0)==(C|0)|(j|0)==0))ggb(k[j+-4>>2]|0)}j=k[J>>2]|0}l=j;if(j|0){m=k[E>>2]|0;if((m|0)!=(j|0))k[E>>2]=m+(~((m+-4-l|0)>>>2)<<2);ggb(j)}m=K+36|0;j=k[m>>2]|0;if(j|0?(I=j+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;if(!j){j=k[K+32>>2]|0;if(!j){j=B1()|0;l=k[m>>2]|0}}jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}k[m>>2]=0;K=K+16|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[N>>2]|0)>0){l=k[L>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[N>>2]|0))}j=k[M>>2]|0;if((j|0)==(O|0)|(j|0)==0){r=P;return}ggb(k[j+-4>>2]|0);r=P;return}function QRa(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0.0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;$=r;r=r+48|0;m=$+32|0;W=$+16|0;X=$+12|0;Y=$;Z=$+8|0;if((b|0)>=1?(V=a+4|0,(k[a>>2]|0)!=(k[V>>2]|0)):0){k[m>>2]=0;_=m+4|0;k[_>>2]=0;k[m+8>>2]=0;U=RRa(a,m,c)|0;l=(U|0)==0;if(!l){if(U>>>0>268435455)ad(426534,426557,304,426811);h=U<<4;g=(h|0)==0?1:h;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}zpb(f|0,0,h|0)|0;if(!l){if(U>>>0>1073741823)ad(426534,426557,304,426811);h=U<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}h=U;i=g;while(1){k[i>>2]=0;h=h+-1|0;if(!h)break;else i=i+4|0}if(!l){if(U>>>0>1073741823)ad(426534,426557,304,426811);i=U<<2;i=(i|0)==0?1:i;while(1){h=fgb(i)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}i=U;j=h;while(1){k[j>>2]=0;i=i+-1|0;if(!i)break;else j=j+4|0}if(l)i=0;else{j=U<<3;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}j=U;l=i;while(1){p[l>>3]=2.2250738585072014e-308;j=j+-1|0;if(!j)break;else l=l+8|0}}}else{i=0;h=0}}else{i=0;h=0;g=0}}else{i=0;h=0;g=0;f=0}T=k[_>>2]|0;R=k[m>>2]|0;m=T-R|0;v=m>>2;m=(m|0)>0;S=R;if(m){l=k[a>>2]|0;j=0;do{Q=k[S+(j<<2)>>2]|0;P=f+(Q<<4)|0;k[P>>2]=(k[P>>2]|0)+(k[l+(j<<4)>>2]|0);P=f+(Q<<4)+4|0;k[P>>2]=(k[P>>2]|0)+(k[l+(j<<4)+4>>2]|0);P=f+(Q<<4)+8|0;k[P>>2]=(k[P>>2]|0)+(k[l+(j<<4)+8>>2]|0);P=f+(Q<<4)+12|0;k[P>>2]=(k[P>>2]|0)+(k[l+(j<<4)+12>>2]|0);Q=g+(Q<<2)|0;k[Q>>2]=(k[Q>>2]|0)+1;j=j+1|0}while((j|0)<(v|0))}P=(e|0)!=0;Q=(d|0)!=0;if(Q&P?(x=k[d>>2]|0,(x|0)!=(k[d+4>>2]|0)):0){t=k[e>>2]|0;j=(t|0)==(k[e+4>>2]|0);if(j|m^1)C=j;else{j=0;do{l=k[S+(j<<2)>>2]|0;m=k[x+(j<<2)>>2]|0;n=h+(l<<2)|0;q=k[n>>2]|0;if((m|0)<=(q|0)){if((m|0)==(q|0)?(s=+p[t+(j<<3)>>3],y=i+(l<<3)|0,s>+p[y>>3]):0)p[y>>3]=s}else{k[n>>2]=m;p[i+(l<<3)>>3]=+p[t+(j<<3)>>3]}j=j+1|0}while((j|0)<(v|0));C=0}}else C=1;B=(U|0)>0;if(B){v=0;do{x=f+(v<<4)|0;y=f+(v<<4)+4|0;l=k[y>>2]|0;z=f+(v<<4)+8|0;m=k[z>>2]|0;A=f+(v<<4)+12|0;q=k[A>>2]|0;w=1.0/+(k[g+(v<<2)>>2]|0);s=+(k[x>>2]|0)*w;j=(o[u>>2]=s,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;s=j?s+-8388608.0+8388608.0:s+8388608.0+-8388608.0;if(s==0.0)s=j?-0.0:0.0}t=~~s;s=+(l|0)*w;j=(o[u>>2]=s,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;s=j?s+-8388608.0+8388608.0:s+8388608.0+-8388608.0;if(s==0.0)s=j?-0.0:0.0}n=~~s;s=+(m|0)*w;j=(o[u>>2]=s,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;s=j?s+-8388608.0+8388608.0:s+8388608.0+-8388608.0;if(s==0.0)s=j?-0.0:0.0}l=~~s;s=+(q|0)*w;j=(o[u>>2]=s,k[u>>2]|0);if((j&2130706432)>>>0<=1249902592){j=(j|0)<0;s=j?s+-8388608.0+8388608.0:s+8388608.0+-8388608.0;if(s==0.0)s=j?-0.0:0.0}k[x>>2]=t;k[y>>2]=n;k[z>>2]=l;k[A>>2]=~~s;v=v+1|0}while((v|0)!=(U|0))}j=k[a>>2]|0;l=k[V>>2]|0;if((l|0)!=(j|0))k[V>>2]=l+(~((l+-16-j|0)>>>4)<<4);if(Q?(D=k[d>>2]|0,E=d+4|0,F=k[E>>2]|0,(F|0)!=(D|0)):0)k[E>>2]=F+(~((F+-4-D|0)>>>2)<<2);if(P?(G=k[e>>2]|0,H=e+4|0,I=k[H>>2]|0,(I|0)!=(G|0)):0)k[H>>2]=I+(~((I+-8-G|0)>>>3)<<3);if(B){L=W+4|0;M=W+8|0;N=W+12|0;O=a+8|0;F=C?X:Z;H=d+4|0;I=d+8|0;J=e+4|0;K=e+8|0;G=0;do{B=k[f+(G<<4)>>2]|0;k[W>>2]=B;C=k[f+(G<<4)+4>>2]|0;k[L>>2]=C;D=k[f+(G<<4)+8>>2]|0;k[M>>2]=D;E=k[f+(G<<4)+12>>2]|0;k[N>>2]=E;j=k[g+(G<<2)>>2]|0;k[X>>2]=j;w=+p[i+(G<<3)>>3];p[Y>>3]=w;k[Z>>2]=k[h+(G<<2)>>2];do if((j|0)>(b|0)){z=D+B|0;A=E+C|0;y=(j|0)>3?j:3;a:do if((j|0)<3){j=0;do{do if((j|0)!=(G|0)?(k[g+(j<<2)>>2]|0)>(b|0):0){n=k[f+(j<<4)>>2]|0;q=k[f+(j<<4)+4>>2]|0;t=k[f+(j<<4)+8>>2]|0;v=k[f+(j<<4)+12>>2]|0;s=+(t|0)*c;p[u>>3]=s;l=k[u+4>>2]|0;y=l&2146435072;do if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){l=(l|0)<0;s=l?s+-4503599627370496.0+4503599627370496.0:s+4503599627370496.0+-4503599627370496.0;if(!(s==0.0))break;s=l?-0.0:0.0}while(0);m=~~s;s=+(v|0)*c;p[u>>3]=s;l=k[u+4>>2]|0;y=l&2146435072;do if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){l=(l|0)<0;s=l?s+-4503599627370496.0+4503599627370496.0:s+4503599627370496.0+-4503599627370496.0;if(!(s==0.0))break;s=l?-0.0:0.0}while(0);l=~~s;if((B|0)<(n-m|0)|(C|0)<(q-l|0))break;if((z|0)>(t+n+m|0))break;if((A|0)<=(v+q+l|0))break a}while(0);j=j+1|0}while((j|0)<(U|0))}else{j=0;do{n=k[g+(j<<2)>>2]|0;do if((j|0)!=(G|0)&(n|0)>(b|0)){q=k[f+(j<<4)>>2]|0;t=k[f+(j<<4)+4>>2]|0;v=k[f+(j<<4)+8>>2]|0;x=k[f+(j<<4)+12>>2]|0;s=+(v|0)*c;p[u>>3]=s;l=k[u+4>>2]|0;m=l&2146435072;do if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){l=(l|0)<0;s=l?s+-4503599627370496.0+4503599627370496.0:s+4503599627370496.0+-4503599627370496.0;if(!(s==0.0))break;s=l?-0.0:0.0}while(0);m=~~s;s=+(x|0)*c;p[u>>3]=s;l=k[u+4>>2]|0;aa=l&2146435072;do if(!(aa>>>0>1126170624|(aa|0)==1126170624&0>0)){l=(l|0)<0;s=l?s+-4503599627370496.0+4503599627370496.0:s+4503599627370496.0+-4503599627370496.0;if(!(s==0.0))break;s=l?-0.0:0.0}while(0);l=~~s;if((B|0)<(q-m|0)|(C|0)<(t-l|0))break;if((z|0)>(v+q+m|0))break;if((n|0)>(y|0)?(A|0)<=(x+t+l|0):0)break a}while(0);j=j+1|0}while((j|0)<(U|0))}while(0);if((j|0)==(U|0)){j=k[V>>2]|0;if((j|0)==(k[O>>2]|0))SRa(a,W);else{k[j>>2]=B;k[j+4>>2]=C;k[j+8>>2]=D;k[j+12>>2]=E;k[V>>2]=j+16}do if(Q){j=k[H>>2]|0;if((j|0)==(k[I>>2]|0)){Q4(d,F);break}else{k[j>>2]=k[F>>2];k[H>>2]=j+4;break}}while(0);if(P){j=k[J>>2]|0;if((j|0)==(k[K>>2]|0)){Koa(e,Y);break}else{p[j>>3]=w;k[J>>2]=j+8;break}}}}while(0);G=G+1|0}while((G|0)<(U|0))}if(i|0)ggb(i);if(h|0)ggb(h);if(g|0)ggb(g);if(f|0)ggb(f);f=R;if(R|0){if((T|0)!=(S|0))k[_>>2]=T+(~((T+-4-R|0)>>>2)<<2);ggb(f)}r=$;return}if(!d){r=$;return}j=(k[a+4>>2]|0)-(k[a>>2]|0)>>4;f=d+4|0;i=k[f>>2]|0;h=k[d>>2]|0;g=i-h>>2;if(j>>>0<=g>>>0){if(j>>>0<g>>>0?(l=h+(j<<2)|0,(i|0)!=(l|0)):0)k[f>>2]=i+(~((i+-4-l|0)>>>2)<<2)}else U1(d,j-g|0);if(!j){r=$;return}g=k[d>>2]|0;f=0;do{k[g+(f<<2)>>2]=1;f=f+1|0}while((f|0)!=(j|0));r=$;return}function RRa(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;K=r;r=r+16|0;v=K;u=k[a>>2]|0;f=(k[a+4>>2]|0)-u|0;J=f>>4;a=f>>3;if(!a){I=0;H=0}else{if(a>>>0>1073741823)ad(426534,426557,304,426811);e=f>>1;d=(e|0)==0?1:e;while(1){a=fgb(d)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}zpb(a|0,0,e|0)|0;I=a;H=a}t=(f|0)>0;if(t){a=0;do{k[H+(a<<3)>>2]=-1;k[H+(a<<3)+4>>2]=0;a=a+1|0}while((a|0)<(J|0));s=v+4|0;q=0;do{d=q;while(1){a=k[H+(d<<3)>>2]|0;if((a|0)>-1)d=a;else break}l=u+(q<<4)+8|0;m=u+(q<<4)+12|0;n=u+(q<<4)|0;o=u+(q<<4)+4|0;p=H+(q<<3)|0;j=0;a=d;do{if(((((q|0)!=(j|0)?(w=k[u+(j<<4)+8>>2]|0,x=k[l>>2]|0,y=k[u+(j<<4)+12>>2]|0,z=k[m>>2]|0,A=+(((z|0)>(y|0)?y:z)+((x|0)>(w|0)?w:x)|0)*c*.5,B=k[n>>2]|0,C=k[u+(j<<4)>>2]|0,h=B-C|0,+(((h|0)>-1?h:0-h|0)|0)<=A):0)?(D=k[o>>2]|0,E=k[u+(j<<4)+4>>2]|0,h=D-E|0,+(((h|0)>-1?h:0-h|0)|0)<=A):0)?(h=x-w+B-C|0,F=z-y+D-E|0,+(((h|0)>-1?h:0-h|0)|0)<=A):0)?+(((F|0)>-1?F:0-F|0)|0)<=A:0){g=j;while(1){h=H+(g<<3)|0;d=k[h>>2]|0;if((d|0)>-1)g=d;else break}if((g|0)!=(a|0)){d=k[H+(a<<3)+4>>2]|0;e=H+(g<<3)+4|0;f=k[e>>2]|0;if((d|0)>(f|0))k[h>>2]=a;else{k[H+(a<<3)>>2]=g;k[e>>2]=f+((d|0)==(f|0)&1);a=g}if((k[H+(a<<3)>>2]|0)>=0){k[v>>2]=0;k[s>>2]=0;d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[v>>2]=e;k[s>>2]=23;i[d+27>>0]=0;f=379357;g=e+23|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,v,379381,379391,488);k[s>>2]=0;k[v>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}e=H+(j<<3)|0;d=k[e>>2]|0;if((d|0)>-1)do{k[e>>2]=a;e=H+(d<<3)|0;d=k[e>>2]|0}while((d|0)>-1);d=k[p>>2]|0;if((d|0)>-1){e=p;do{k[e>>2]=a;e=H+(d<<3)|0;d=k[e>>2]|0}while((d|0)>-1)}}}j=j+1|0}while((j|0)<(J|0));q=q+1|0}while((q|0)<(J|0))}a=b+4|0;f=k[a>>2]|0;e=k[b>>2]|0;d=f-e>>2;if(J>>>0<=d>>>0){if(J>>>0<d>>>0?(G=e+(J<<2)|0,(f|0)!=(G|0)):0)k[a>>2]=f+(~((f+-4-G|0)>>>2)<<2)}else U1(b,J-d|0);if(t){g=k[b>>2]|0;a=0;f=0;do{d=f;while(1){e=k[H+(d<<3)>>2]|0;if((e|0)>-1)d=e;else break}e=H+(d<<3)+4|0;d=k[e>>2]|0;if((d|0)>-1){d=~a;k[e>>2]=d;a=a+1|0}k[g+(f<<2)>>2]=~d;f=f+1|0}while((f|0)<(J|0))}else a=0;if(!I){r=K;return a|0}ggb(I);r=K;return a|0}function SRa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+4|0;c=k[l>>2]|0;m=k[a>>2]|0;f=c-m>>4;d=f+1|0;if(d>>>0>268435455)ad(426534,426557,304,426811);j=m;h=c;i=a+8|0;g=(k[i>>2]|0)-m|0;e=g>>3;e=g>>4>>>0<134217727?(e>>>0<d>>>0?d:e):268435455;if(!e)d=0;else{if(e>>>0>268435455){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=e<<4;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c}c=d+(f<<4)|0;g=d+(e<<4)|0;k[c>>2]=k[b>>2];k[d+(f<<4)+4>>2]=k[b+4>>2];k[d+(f<<4)+8>>2]=k[b+8>>2];k[d+(f<<4)+12>>2]=k[b+12>>2];f=c+16|0;if((h|0)!=(j|0)){b=h+-16|0;d=h;e=c;while(1){h=d;d=d+-16|0;k[e+-16>>2]=k[d>>2];k[e+-12>>2]=k[h+-12>>2];k[e+-8>>2]=k[h+-8>>2];k[e+-4>>2]=k[h+-4>>2];if((d|0)==(j|0))break;else e=e+-16|0}c=c+(~((b-m|0)>>>4)<<4)|0}k[a>>2]=c;k[l>>2]=f;k[i>>2]=g;if(!m)return;ggb(m);return}function TRa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=95484;d=a+84|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+80>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+64|0;c=a+52|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+88>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+92>>2]|0;if(!((b|0)==(a+96|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=k[a+36>>2]|0;if(!d)return;b=a+40|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-4-d|0)>>>2)<<2);ggb(d);return}function URa(a){a=a|0;TRa(a);ggb(a);return}function VRa(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0;ra=r;r=r+48|0;Z=ra+24|0;ia=ra+16|0;oa=ra+8|0;pa=ra;qa=a+4|0;X=k[(k[qa>>2]|0)+108>>2]|0;jh[k[(k[X>>2]|0)+12>>2]&1023](oa,X);p[pa>>3]=0.0;X=k[qa>>2]|0;W=k[X+24>>2]|0;X=k[X+28>>2]|0;Y=a+12|0;d=k[Y>>2]|0;if((d|0)>0){_=a+20|0;$=a+24|0;ba=b+4|0;ca=+(W|0);da=+(X|0);ea=a+28|0;fa=a+104|0;ga=a+8|0;ha=Z+4|0;ja=Z+8|0;ka=Z+12|0;la=Z+4|0;ma=Z+8|0;na=Z+12|0;R=a+32|0;S=oa+4|0;T=ia+4|0;U=Z+4|0;V=Z+4|0;Q=0;c=0.0;do{a=k[_>>2]|0;O=+o[a+(Q*20|0)>>2];P=k[a+(Q*20|0)+16>>2]|0;M=k[(k[$>>2]|0)+(Q<<2)>>2]|0;f=aa(k[b>>2]|0,M)|0;N=(k[a+(Q*20|0)+4>>2]|0)-W|0;N=(N|0)<0?0:N;a=(k[a+(Q*20|0)+8>>2]|0)-X|0;a=(a|0)<0?0:a;M=aa(k[ba>>2]|0,M)|0;M=(a|0)<(M|0)?a:M;e=ca*O;a=(o[u>>2]=e,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;e=a?e+-8388608.0+8388608.0:e+8388608.0+-8388608.0;if(e==0.0)e=a?-0.0:0.0}L=~~e;e=da*O;a=(o[u>>2]=e,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;e=a?e+-8388608.0+8388608.0:e+8388608.0+-8388608.0;if(e==0.0)e=a?-0.0:0.0}K=~~e;if((f|0)<(M|0)){J=(N|0)>0;I=f;do{if(J){G=O*+(I|0);D=(o[u>>2]=G,k[u>>2]|0);H=(D&2130706432)>>>0>1249902592;D=(D|0)<0;C=D?G+-8388608.0+8388608.0:G+8388608.0+-8388608.0;E=C==0.0;F=D?-0.0:0.0;D=0;do{B=k[qa>>2]|0;A=k[S>>2]|0;z=k[(k[A>>2]|0)+24>>2]|0;k[ia>>2]=D;k[T>>2]=I;a:do if(ci[z&255](A,ia,Q)|0){a=k[B+8>>2]|0;d=(a|0)==0;if((k[B+20>>2]|0)!=1){if(d){n=k[B+32>>2]|0;A=(k[B+36>>2]|0)-n|0;q=(A|0)/12|0;s=k[S>>2]|0;t=k[B+68>>2]|0;v=k[B+56>>2]|0;m=k[B+44>>2]|0;if((A|0)>0){d=0;a=0;l=0}else{a=1;break}while(1){h=k[n+(l*12|0)+4>>2]|0;if((h|0)>0){j=k[n+(l*12|0)>>2]|0;g=0;c=0.0;do{f=0;do{B=f+d|0;e=+bRa(s,k[v+(B<<4)>>2]|0);f=k[(e<+o[v+(B<<4)+4>>2]?v+(B<<4)+8|0:v+(B<<4)+12|0)>>2]|0}while((f|0)>0);c=c+ +o[t+(a-f<<2)>>2];B=k[m+(j+g<<2)>>2]|0;d=B+d|0;a=a+1+B|0;g=g+1|0}while((g|0)!=(h|0))}else c=0.0;if(c<+o[n+(l*12|0)+8>>2]){a=0-l|0;break}l=l+1|0;if((l|0)>=(q|0)){a=1;break}}p[pa>>3]=c;break}if((a|0)!=1){a=-2;break}v=k[B+32>>2]|0;s=(k[B+36>>2]|0)-v|0;w=(s|0)/12|0;a=k[S>>2]|0;x=((k[B+12>>2]|0)+31|0)/32|0;y=k[B+80>>2]|0;z=k[B+68>>2]|0;A=k[B+56>>2]|0;t=k[B+44>>2]|0;if((s|0)<=0){a=1;break}s=a+380|0;n=a+384|0;f=0;a=0;q=0;while(1){h=k[v+(q*12|0)+4>>2]|0;if((h|0)>0){j=k[v+(q*12|0)>>2]|0;l=k[s>>2]|0;m=k[n>>2]|0;g=0;c=0.0;do{d=0;do{B=d+f|0;ua=k[A+(B<<4)>>2]|0;za=k[m+(k[l+(ua<<6)+20>>2]<<2)>>2]|0;Ea=k[m+(k[l+(ua<<6)+24>>2]<<2)>>2]|0;wa=k[m+(k[l+(ua<<6)+36>>2]<<2)>>2]|0;Ba=k[m+(k[l+(ua<<6)+40>>2]<<2)>>2]|0;ta=za-Ea-wa+Ba|0;Fa=k[m+(k[l+(ua<<6)+4>>2]<<2)>>2]|0;ya=k[m+(k[l+(ua<<6)+16>>2]<<2)>>2]|0;sa=k[m+(k[l+(ua<<6)+8>>2]<<2)>>2]|0;Da=k[m+(k[l+(ua<<6)+28>>2]<<2)>>2]|0;Ca=k[m+(k[l+(ua<<6)+44>>2]<<2)>>2]|0;Aa=k[m+(k[l+(ua<<6)+56>>2]<<2)>>2]|0;xa=k[m+(k[l+(ua<<6)+52>>2]<<2)>>2]|0;va=k[m+(k[l+(ua<<6)+32>>2]<<2)>>2]|0;sa=y+((aa(B,x)|0)<<2)+((((Ea-za+Fa-sa|0)>=(ta|0)?2:0)|(((k[m+(k[l+(ua<<6)>>2]<<2)>>2]|0)+za-Fa-ya|0)>=(ta|0)?4:0)|(sa-Ea-(k[m+(k[l+(ua<<6)+12>>2]<<2)>>2]|0)+Da|0)>=(ta|0))<<2)|0;d=k[((1<<(((Ba-Ca-Aa+(k[m+(k[l+(ua<<6)+60>>2]<<2)>>2]|0)|0)>=(ta|0)?8:0)|((Ea-Ba-Da+Ca|0)>=(ta|0)?16:0)|((wa-Ba+Aa-xa|0)>=(ta|0)?4:0)|(wa-za+ya-va|0)>=(ta|0)|((xa-wa+va-(k[m+(k[l+(ua<<6)+48>>2]<<2)>>2]|0)|0)>=(ta|0)?2:0))&k[sa>>2]|0)==0?A+(B<<4)+12|0:A+(B<<4)+8|0)>>2]|0}while((d|0)>0);c=c+ +o[z+(a-d<<2)>>2];Fa=k[t+(j+g<<2)>>2]|0;f=Fa+f|0;a=a+1+Fa|0;g=g+1|0}while((g|0)!=(h|0))}else c=0.0;d=q+1|0;if(c<+o[v+(q*12|0)+8>>2]){f=67;break}if((d|0)<(w|0))q=d;else{f=68;break}}if((f|0)==67){p[pa>>3]=c;a=0-q|0;break}else if((f|0)==68){p[pa>>3]=c;a=1;break}}if(d){d=B+92|0;a=k[d>>2]|0;if((a|0)==(k[B+96>>2]|0)){k[Z>>2]=0;k[U>>2]=0;a=ZT(36)|0;k[a>>2]=1;f=a+4|0;k[Z>>2]=f;k[U>>2]=28;i[a+32>>0]=0;g=379477;h=f+28|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,Z,379530,378535,574);k[U>>2]=0;k[Z>>2]=0;Fa=k[a>>2]|0;k[a>>2]=Fa+-1;if((Fa|0)==1)ggb(k[a+-4>>2]|0);a=k[d>>2]|0}j=k[S>>2]|0;l=k[B+32>>2]|0;Fa=(k[B+36>>2]|0)-l|0;h=(Fa|0)/12|0;b:do if((Fa|0)>0){d=0;while(1){g=k[l+(d*12|0)+4>>2]|0;if((g|0)>0){f=0;c=0.0;do{e=+bRa(j,k[a+(f<<4)>>2]|0);c=c+ +o[(e<+o[a+(f<<4)+4>>2]?a+(f<<4)+8|0:a+(f<<4)+12|0)>>2];f=f+1|0}while((f|0)!=(g|0))}else c=0.0;if(c<+o[l+(d*12|0)+8>>2])break;d=d+1|0;if((d|0)<(h|0))a=a+(g<<4)|0;else break b}p[pa>>3]=c;a=0-d|0;break a}else c=0.0;while(0);p[pa>>3]=c;a=1;break}if((a|0)==1){d=B+92|0;if((k[d>>2]|0)==(k[B+96>>2]|0)){k[Z>>2]=0;k[V>>2]=0;a=ZT(36)|0;k[a>>2]=1;f=a+4|0;k[Z>>2]=f;k[V>>2]=28;i[a+32>>0]=0;g=379477;h=f+28|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,Z,379506,378535,611);k[V>>2]=0;k[Z>>2]=0;Fa=k[a>>2]|0;k[a>>2]=Fa+-1;if((Fa|0)==1)ggb(k[a+-4>>2]|0)}s=k[B+32>>2]|0;Fa=(k[B+36>>2]|0)-s|0;n=(Fa|0)/12|0;a=k[S>>2]|0;q=((k[B+12>>2]|0)+31|0)/32|0;c:do if((Fa|0)>0){t=a+380|0;m=a+384|0;l=k[B+80>>2]|0;h=k[d>>2]|0;a=0;while(1){j=k[s+(a*12|0)+4>>2]|0;if((j|0)>0){f=k[t>>2]|0;g=k[m>>2]|0;d=0;c=0.0;do{Da=k[h+(d<<4)>>2]|0;ya=k[g+(k[f+(Da<<6)+20>>2]<<2)>>2]|0;ta=k[g+(k[f+(Da<<6)+24>>2]<<2)>>2]|0;Ba=k[g+(k[f+(Da<<6)+36>>2]<<2)>>2]|0;wa=k[g+(k[f+(Da<<6)+40>>2]<<2)>>2]|0;Ea=ya-ta-Ba+wa|0;sa=k[g+(k[f+(Da<<6)+4>>2]<<2)>>2]|0;za=k[g+(k[f+(Da<<6)+16>>2]<<2)>>2]|0;Fa=k[g+(k[f+(Da<<6)+8>>2]<<2)>>2]|0;ua=k[g+(k[f+(Da<<6)+28>>2]<<2)>>2]|0;va=k[g+(k[f+(Da<<6)+44>>2]<<2)>>2]|0;xa=k[g+(k[f+(Da<<6)+56>>2]<<2)>>2]|0;Aa=k[g+(k[f+(Da<<6)+52>>2]<<2)>>2]|0;Ca=k[g+(k[f+(Da<<6)+32>>2]<<2)>>2]|0;Fa=l+((aa(d,q)|0)<<2)+((((ta-ya+sa-Fa|0)>=(Ea|0)?2:0)|(((k[g+(k[f+(Da<<6)>>2]<<2)>>2]|0)+ya-sa-za|0)>=(Ea|0)?4:0)|(Fa-ta-(k[g+(k[f+(Da<<6)+12>>2]<<2)>>2]|0)+ua|0)>=(Ea|0))<<2)|0;c=c+ +o[((1<<(((wa-va-xa+(k[g+(k[f+(Da<<6)+60>>2]<<2)>>2]|0)|0)>=(Ea|0)?8:0)|((ta-wa-ua+va|0)>=(Ea|0)?16:0)|((Ba-wa+xa-Aa|0)>=(Ea|0)?4:0)|(Ba-ya+za-Ca|0)>=(Ea|0)|((Aa-Ba+Ca-(k[g+(k[f+(Da<<6)+48>>2]<<2)>>2]|0)|0)>=(Ea|0)?2:0))&k[Fa>>2]|0)==0?h+(d<<4)+12|0:h+(d<<4)+8|0)>>2];d=d+1|0}while((d|0)!=(j|0))}else c=0.0;if(c<+o[s+(a*12|0)+8>>2])break;l=l+((aa(j,q)|0)<<2)|0;a=a+1|0;if((a|0)>=(n|0))break c;else h=h+(j<<4)|0}p[pa>>3]=c;a=0-a|0;break a}else c=0.0;while(0);p[pa>>3]=c;a=1}else a=-2}else a=-1;while(0);if(!(k[ea>>2]|0)){if((a|0)>0){mpb(k[k[fa>>2]>>2]|0)|0;j=k[ga>>2]|0;e=O*+(D|0);d=(o[u>>2]=e,k[u>>2]|0);if((d&2130706432)>>>0<=1249902592){d=(d|0)<0;e=d?e+-8388608.0+8388608.0:e+8388608.0+-8388608.0;if(e==0.0)e=d?-0.0:0.0}d=~~e;f=~~(H|E^1?(H?G:C):F);k[Z>>2]=d;k[ha>>2]=f;k[ja>>2]=L;k[ka>>2]=K;g=j+4|0;h=k[g>>2]|0;if((h|0)==(k[j+8>>2]|0))SRa(j,Z);else{k[h>>2]=d;k[h+4>>2]=f;k[h+8>>2]=L;k[h+12>>2]=K;k[g>>2]=h+16}lpb(k[k[fa>>2]>>2]|0)|0}}else{if((a|0)==1){a=k[qa>>2]|0;a=((k[a+36>>2]|0)-(k[a+32>>2]|0)|0)/-12|0}l=0-a|0;if((a|0)<1){mpb(k[k[fa>>2]>>2]|0)|0;j=k[ga>>2]|0;e=O*+(D|0);d=(o[u>>2]=e,k[u>>2]|0);if((d&2130706432)>>>0<=1249902592){d=(d|0)<0;e=d?e+-8388608.0+8388608.0:e+8388608.0+-8388608.0;if(e==0.0)e=d?-0.0:0.0}d=~~e;f=~~(H|E^1?(H?G:C):F);k[Z>>2]=d;k[la>>2]=f;k[ma>>2]=L;k[na>>2]=K;g=j+4|0;h=k[g>>2]|0;if((h|0)==(k[j+8>>2]|0))SRa(j,Z);else{k[h>>2]=d;k[h+4>>2]=f;k[h+8>>2]=L;k[h+12>>2]=K;k[g>>2]=h+16}d=k[ea>>2]|0;k[Z>>2]=l;f=d+4|0;g=k[f>>2]|0;if((g|0)==(k[d+8>>2]|0))Q4(d,Z);else{k[g>>2]=l;k[f>>2]=g+4}d=k[R>>2]|0;f=d+4|0;g=k[f>>2]|0;if((g|0)==(k[d+8>>2]|0))Koa(d,pa);else{p[g>>3]=c;k[f>>2]=g+8}lpb(k[k[fa>>2]>>2]|0)|0}}D=D+P+((a|0)==0?P:0)|0}while((D|0)<(N|0))}I=I+P|0}while((I|0)<(M|0));d=k[Y>>2]|0}Q=Q+1|0}while((Q|0)<(d|0))}a=k[oa>>2]|0;if(!a){r=ra;return}Ea=a+4|0;Fa=k[Ea>>2]|0;k[Ea>>2]=Fa+-1;if((Fa|0)!=1){r=ra;return}Uh[k[(k[a>>2]|0)+8>>2]&2047](a);r=ra;return}function WRa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+8|0;e=k[j>>2]|0;l=a+4|0;c=k[l>>2]|0;if(e-c>>4>>>0>=b>>>0){do{k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;c=(k[l>>2]|0)+16|0;k[l>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=c-d>>4;c=f+b|0;if(c>>>0>268435455)ad(426534,426557,304,426811);i=e-d|0;e=i>>3;e=i>>4>>>0<134217727?(e>>>0<c>>>0?c:e):268435455;if(!e)c=0;else{if(e>>>0>268435455){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=e<<4;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}i=c+(f<<4)|0;g=i;d=i;h=g;do{k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;d=h+16|0;h=d;b=b+-1|0}while((b|0)!=0);e=c+(e<<4)|0;f=k[a>>2]|0;c=k[l>>2]|0;if((c|0)==(f|0))c=g;else{d=c+-16|0;b=i;while(1){g=c;c=c+-16|0;k[b+-16>>2]=k[c>>2];k[b+-12>>2]=k[g+-12>>2];k[b+-8>>2]=k[g+-8>>2];k[b+-4>>2]=k[g+-4>>2];if((c|0)==(f|0))break;else b=b+-16|0}c=i+(~((d-f|0)>>>4)<<4)|0}k[a>>2]=c;k[l>>2]=h;k[j>>2]=e;if(!f)return;ggb(f);return}function XRa(a){a=a|0;var b=0,c=0,d=0,e=0;b=k[a+88>>2]|0;c=b;if(b|0){d=a+92|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);ggb(b)}b=k[a+76>>2]|0;c=b;if(b|0){d=a+80|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+64>>2]|0;c=b;if(b|0){d=a+68|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+52>>2]|0;c=b;if(b|0){d=a+56|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);ggb(b)}b=k[a+40>>2]|0;c=b;if(b|0){d=a+44|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=k[a+28>>2]|0;if(!d)return;b=a+32|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~(((c+-12-d|0)>>>0)/12|0)*12|0);ggb(d);return}function YRa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;Sa=r;r=r+384|0;Ra=Sa+368|0;Na=Sa+360|0;Fa=Sa+316|0;Ga=Sa+272|0;Ha=Sa+228|0;Ia=Sa+184|0;Ja=Sa+140|0;Ka=Sa+96|0;Da=Sa+44|0;Ea=Sa;Qa=Sa+88|0;h=a+248|0;c=k[h>>2]|0;if(c|0?(Ma=c+8|0,Pa=k[Ma>>2]|0,k[Ma>>2]=Pa+-1,(Pa|0)==1):0){Pa=k[h>>2]|0;Ma=k[Pa+4>>2]|0;jh[k[(k[Ma>>2]|0)+16>>2]&1023](Ma,Pa);k[h>>2]=0}e=a+228|0;if((k[e>>2]|0)>0){f=k[a+256>>2]|0;c=0;do{k[f+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}k[h>>2]=0;h=a+296|0;c=k[h>>2]|0;if(c|0?(Ma=c+8|0,Pa=k[Ma>>2]|0,k[Ma>>2]=Pa+-1,(Pa|0)==1):0){Pa=k[h>>2]|0;Ma=k[Pa+4>>2]|0;jh[k[(k[Ma>>2]|0)+16>>2]&1023](Ma,Pa);k[h>>2]=0}e=a+276|0;if((k[e>>2]|0)>0){f=k[a+304>>2]|0;c=0;do{k[f+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}k[h>>2]=0;h=a+344|0;c=k[h>>2]|0;if(c|0?(Ma=c+8|0,Pa=k[Ma>>2]|0,k[Ma>>2]=Pa+-1,(Pa|0)==1):0){Pa=k[h>>2]|0;Ma=k[Pa+4>>2]|0;jh[k[(k[Ma>>2]|0)+16>>2]&1023](Ma,Pa);k[h>>2]=0}e=a+324|0;if((k[e>>2]|0)>0){f=k[a+352>>2]|0;c=0;do{k[f+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}k[h>>2]=0;Pa=b+4|0;c=k6(k[b>>2]|0,k[Pa>>2]|0,380206)|0;k[Ra>>2]=0;Ma=Ra+4|0;k[Ma>>2]=0;J6(c,Ra,Ra);c=k[Ra>>2]|0;if((c|0)!=380216){e=(c|0)==0?1016759:c;if((i[e>>0]|0)==66){j=380216;do{e=e+1|0;j=j+1|0;f=i[e>>0]|0;h=i[j>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=h<<24>>24));if(f<<24>>24==h<<24>>24)Oa=23;else d=0}else d=0}else Oa=23;if((Oa|0)==23){k[a+4>>2]=0;c=k6(k[b>>2]|0,k[Pa>>2]|0,380222)|0;k[Na>>2]=0;La=Na+4|0;k[La>>2]=0;J6(c,Na,Na);c=k[Na>>2]|0;a:do if((c|0)==379836)Oa=27;else{e=(c|0)==0?1016759:c;m=i[e>>0]|0;n=m<<24>>24==72;if(n){f=379836;h=e;do{h=h+1|0;f=f+1|0;j=i[h>>0]|0;l=i[f>>0]|0}while(!(j<<24>>24==0?1:j<<24>>24!=l<<24>>24));if(j<<24>>24==l<<24>>24){Oa=27;break}}do if((c|0)!=379841){if(m<<24>>24==76){f=379841;h=e;do{h=h+1|0;f=f+1|0;j=i[h>>0]|0;l=i[f>>0]|0}while(!(j<<24>>24==0?1:j<<24>>24!=l<<24>>24));if(j<<24>>24==l<<24>>24)break}if((c|0)!=379845){if(n)j=379845;else{d=0;break a}do{e=e+1|0;j=j+1|0;f=i[e>>0]|0;h=i[j>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=h<<24>>24));if(f<<24>>24!=h<<24>>24){d=0;break a}}k[a+8>>2]=2;k[Fa>>2]=0;c=Fa+4|0;k[c>>2]=0;e=ZT(40)|0;k[e>>2]=1;h=e+4|0;k[Fa>>2]=h;k[c>>2]=35;i[e+39>>0]=0;f=379849;j=h+35|0;do{i[h>>0]=i[f>>0]|0;h=h+1|0;f=f+1|0}while((h|0)<(j|0));Y8(-213,Fa,401059,378394,1415);k[c>>2]=0;k[Fa>>2]=0;Oa=k[e>>2]|0;k[e>>2]=Oa+-1;if((Oa|0)==1)ggb(k[e+-4>>2]|0);Oa=40;break a}while(0);k[a+8>>2]=1;Oa=40}while(0);if((Oa|0)==27){k[a+8>>2]=0;Oa=40}if((Oa|0)==40){c=k6(k[b>>2]|0,k[Pa>>2]|0,380241)|0;b:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break b}case 2:break;default:{c=2147483647;break b}}g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;Ca=c&2146435072;if(!(Ca>>>0>1126170624|(Ca|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}c=~~g}while(0);e=a+24|0;k[e>>2]=c;c=k6(k[b>>2]|0,k[Pa>>2]|0,380234)|0;do if(c){switch(k[c>>2]&7){case 1:{q=k[c+8>>2]|0;Oa=56;break}case 2:{g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;Oa=c&2146435072;if(!(Oa>>>0>1126170624|(Oa|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}q=~~g;Oa=56;break}default:k[a+28>>2]=2147483647}if((Oa|0)==56?(k[a+28>>2]=q,(q|0)<=0):0){Oa=58;break}if((k[e>>2]|0)<=0)Oa=58}else{k[a+28>>2]=0;Oa=58}while(0);if((Oa|0)==58){k[Fa>>2]=0;c=Fa+4|0;k[c>>2]=0;e=ZT(52)|0;k[e>>2]=1;h=e+4|0;k[Fa>>2]=h;k[c>>2]=47;i[e+51>>0]=0;f=379885;j=h+47|0;do{i[h>>0]=i[f>>0]|0;h=h+1|0;f=f+1|0}while((h|0)<(j|0));Y8(-215,Fa,401059,378394,1422);k[c>>2]=0;k[Fa>>2]=0;Ca=k[e>>2]|0;k[e>>2]=Ca+-1;if((Ca|0)==1)ggb(k[e+-4>>2]|0)}c=k[b>>2]|0;e=k6(c,k[Pa>>2]|0,380272)|0;if(e){c=k6(c,e,380286)|0;c:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break c}case 2:break;default:{c=2147483647;break c}}g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;Ca=c&2146435072;if(!(Ca>>>0>1126170624|(Ca|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}c=~~g}while(0);k[a+12>>2]=c;ya=(c+31|0)/32|0;wa=(c|0)>0;xa=wa?ya+3|0:4;q=k[b>>2]|0;s=k6(q,k[Pa>>2]|0,380517)|0;if(s){Ca=a+32|0;n=(s|0)==0;c=k[s>>2]|0;switch(c&7){case 6:{j=k[(k[s+8>>2]|0)+60>>2]|0;break}case 5:{j=k[(k[s+8>>2]|0)+24>>2]|0;break}default:j=(c&7|0)!=0&1}va=a+40|0;h=k[Ca>>2]|0;do if((((k[va>>2]|0)-h|0)/12|0)>>>0<j>>>0){l=a+36|0;m=(k[l>>2]|0)-h|0;f=(m|0)/12|0;if(!j)c=0;else{if(j>>>0>357913941){Sa=te(4)|0;k[Sa>>2]=172664;Cf(Sa|0,28816,1287)}e=j*12|0;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(f*12|0)|0;f=e+(((m|0)/-12|0)*12|0)|0;if((m|0)>0)upb(f|0,h|0,m|0)|0;k[Ca>>2]=f;k[l>>2]=e;k[va>>2]=c+(j*12|0);if(!h)break;ggb(h)}while(0);ta=a+44|0;c=k[ta>>2]|0;ua=a+48|0;e=k[ua>>2]|0;if((e|0)!=(c|0))k[ua>>2]=e+(~((e+-4-c|0)>>>2)<<2);Ba=a+56|0;c=k[Ba>>2]|0;sa=a+60|0;e=k[sa>>2]|0;if((e|0)!=(c|0))k[sa>>2]=e+(~((e+-16-c|0)>>>4)<<4);za=a+92|0;c=k[za>>2]|0;Aa=a+96|0;e=k[Aa>>2]|0;if((e|0)!=(c|0))k[Aa>>2]=e+(~((e+-16-c|0)>>>4)<<4);do if((q|0)!=0&(s|0)!=0){c=k[s>>2]|0;e=c&7;if(!e){Oa=102;break}k[Fa>>2]=q;k[Fa+4>>2]=s;if(!((e+-5|0)>>>0<2&(c&16|0)==0)){k[Fa+20>>2]=s;k[Fa+12>>2]=0;k[Fa+40>>2]=1;break}c=s+8|0;KY(k[c>>2]|0,Fa+8|0);e=k[s>>2]|0;switch(e&7){case 6:{c=k[(k[c>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[c>>2]|0)+24>>2]|0;break}default:c=(e&7|0)!=0&1}k[Fa+40>>2]=c}else Oa=102;while(0);if((Oa|0)==102){k[Fa>>2]=0;k[Fa+4>>2]=0;k[Fa+20>>2]=0;k[Fa+40>>2]=0}d:do if(n){c=1;Oa=108}else{c=k[s>>2]|0;switch(c&7){case 6:{c=k[(k[s+8>>2]|0)+60>>2]|0;break d}case 5:{c=k[(k[s+8>>2]|0)+24>>2]|0;break d}default:{c=(c&7|0)==0;Oa=108;break d}}}while(0);if((Oa|0)==108)c=c&1^1;B6(Ga,q,s,c);x=a+16|0;k[x>>2]=2147483647;y=a+20|0;k[y>>2]=0;z=Fa+4|0;A=Ga+4|0;B=Fa+20|0;C=Ga+20|0;D=Fa+40|0;E=Ga+40|0;ra=a+36|0;F=Ha+4|0;G=Ia+4|0;H=Ha+20|0;I=Ia+20|0;J=Ha+40|0;K=Ia+40|0;L=a+52|0;M=a+68|0;N=a+72|0;O=a+80|0;P=a+84|0;Q=Ja+4|0;R=Ka+4|0;S=Ja+20|0;T=Ka+20|0;U=Ja+40|0;V=Ka+40|0;W=a+64|0;X=a+88|0;Y=a+76|0;Z=Ha+8|0;_=Ha+12|0;$=Ja+8|0;ba=Ja+12|0;ca=Ja+28|0;da=Ja+16|0;ea=Ja+24|0;fa=Da+4|0;ga=Da+8|0;ha=Da+40|0;ia=Da+20|0;ja=Da+12|0;ka=Ha+28|0;la=Ha+16|0;ma=Ha+24|0;na=Fa+12|0;oa=Fa+28|0;pa=Fa+16|0;qa=Fa+24|0;w=0;e:while(1){v=k[Fa>>2]|0;do if((v|0)==(k[Ga>>2]|0)){if((k[z>>2]|0)!=(k[A>>2]|0))break;if((k[B>>2]|0)!=(k[C>>2]|0))break;if((k[D>>2]|0)==(k[E>>2]|0)){Oa=366;break e}}while(0);e=k[B>>2]|0;c=k6(v,e,380298)|0;f:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break f}case 2:{g=+p[c+8>>3];break f}default:{g=1000000015047466219876688.0e6;break f}}while(0);g=g+-9.999999747378752e-06;t=k6(v,e,380313)|0;if(!t){d=0;break}s=(t|0)==0;c=k[t>>2]|0;switch(c&7){case 6:{m=k[(k[t+8>>2]|0)+60>>2]|0;break}case 5:{m=k[(k[t+8>>2]|0)+24>>2]|0;break}default:m=(c&7|0)!=0&1}l=(k[ua>>2]|0)-(k[ta>>2]|0)>>2;c=k[ra>>2]|0;q=k[va>>2]|0;e=q;do if((c|0)==(q|0)){q=k[Ca>>2]|0;n=c-q|0;j=(n|0)/12|0;c=j+1|0;if(c>>>0>357913941){Oa=126;break e}f=(e-q|0)/12|0;h=f<<1;h=f>>>0<178956970?(h>>>0<c>>>0?c:h):357913941;if(!h)f=0;else{if(h>>>0>357913941){Oa=129;break e}e=h*12|0;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}f=c}e=f+(j*12|0)|0;k[e>>2]=l;k[f+(j*12|0)+4>>2]=m;o[f+(j*12|0)+8>>2]=g;c=e+(((n|0)/-12|0)*12|0)|0;if((n|0)>0)upb(c|0,q|0,n|0)|0;k[Ca>>2]=c;k[ra>>2]=e+12;k[va>>2]=f+(h*12|0);if(!q)break;ggb(q)}else{k[c>>2]=l;k[c+4>>2]=m;o[c+8>>2]=g;k[ra>>2]=(k[ra>>2]|0)+12}while(0);j=k[Ca>>2]|0;j=(k[j+(w*12|0)+4>>2]|0)+(k[j+(w*12|0)>>2]|0)|0;l=k[ta>>2]|0;do if((k[L>>2]|0)-l>>2>>>0<j>>>0){m=(k[ua>>2]|0)-l|0;h=m>>2;if(!j)c=0;else{if(j>>>0>1073741823){Oa=142;break e}e=j<<2;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}f=c+(h<<2)|0;e=f+(0-h<<2)|0;if((m|0)>0)upb(e|0,l|0,m|0)|0;k[ta>>2]=e;k[ua>>2]=f;k[L>>2]=c+(j<<2);if(!l)break;ggb(l)}while(0);do if((v|0)!=0&(t|0)!=0){c=k[t>>2]|0;e=c&7;if(!e){Oa=161;break}k[Ha>>2]=v;k[F>>2]=t;if(!((e+-5|0)>>>0<2&(c&16|0)==0)){k[H>>2]=t;k[_>>2]=0;k[J>>2]=1;break}c=t+8|0;KY(k[c>>2]|0,Z);e=k[t>>2]|0;switch(e&7){case 6:{c=k[(k[c>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[c>>2]|0)+24>>2]|0;break}default:c=(e&7|0)!=0&1}k[J>>2]=c}else Oa=161;while(0);if((Oa|0)==161){Oa=0;k[Ha>>2]=0;k[F>>2]=0;k[H>>2]=0;k[J>>2]=0}g:do if(s){c=1;Oa=167}else{c=k[t>>2]|0;switch(c&7){case 6:{c=k[(k[t+8>>2]|0)+60>>2]|0;break g}case 5:{c=k[(k[t+8>>2]|0)+24>>2]|0;break g}default:{c=(c&7|0)==0;Oa=167;break g}}}while(0);if((Oa|0)==167){Oa=0;c=c&1^1}B6(Ia,v,t,c);h:while(1){t=k[Ha>>2]|0;do if((t|0)==(k[Ia>>2]|0)){if((k[F>>2]|0)!=(k[G>>2]|0))break;if((k[H>>2]|0)!=(k[I>>2]|0))break;if((k[J>>2]|0)==(k[K>>2]|0))break h}while(0);v=k[H>>2]|0;q=k6(t,v,380329)|0;v=k6(t,v,380343)|0;if((q|0)==0|(v|0)==0){Oa=360;break e}c=k[q>>2]|0;switch(c&7){case 6:{c=k[(k[q+8>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[q+8>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}n=(c|0)/(xa|0)|0;c=k[x>>2]|0;k[x>>2]=(n|0)<(c|0)?n:c;c=k[y>>2]|0;k[y>>2]=(c|0)<(n|0)?n:c;c=k[ua>>2]|0;s=k[L>>2]|0;e=s;do if((c|0)==(s|0)){m=k[ta>>2]|0;l=c-m|0;j=l>>2;c=j+1|0;if(c>>>0>1073741823){Oa=181;break e}s=e-m|0;h=s>>1;h=s>>2>>>0<536870911?(h>>>0<c>>>0?c:h):1073741823;if(!h)c=0;else{if(h>>>0>1073741823){Oa=184;break e}e=h<<2;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}f=c+(j<<2)|0;k[f>>2]=n;e=f+(0-j<<2)|0;if((l|0)>0)upb(e|0,m|0,l|0)|0;k[ta>>2]=e;k[ua>>2]=f+4;k[L>>2]=c+(h<<2);if(!m)break;ggb(m)}else{k[c>>2]=n;k[ua>>2]=c+4}while(0);j=k[Ba>>2]|0;l=(k[sa>>2]|0)-j|0;h=l>>4;m=h+n|0;do if((k[W>>2]|0)-j>>4>>>0<m>>>0){if(!m)c=0;else{if(m>>>0>268435455){Oa=197;break e}e=m<<4;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}f=c+(h<<4)|0;e=f+(0-h<<4)|0;if((l|0)>0)upb(e|0,j|0,l|0)|0;k[Ba>>2]=e;k[sa>>2]=f;k[W>>2]=c+(m<<4);if(!j)break;ggb(j)}while(0);c=k[v>>2]|0;switch(c&7){case 6:{c=k[(k[v+8>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[v+8>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}l=k[M>>2]|0;m=(k[N>>2]|0)-l|0;h=m>>2;j=h+c|0;do if((k[Y>>2]|0)-l>>2>>>0<j>>>0){if(!j)c=0;else{if(j>>>0>1073741823){Oa=214;break e}e=j<<2;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}f=c+(h<<2)|0;e=f+(0-h<<2)|0;if((m|0)>0)upb(e|0,l|0,m|0)|0;k[M>>2]=e;k[N>>2]=f;k[Y>>2]=c+(j<<2);if(!l)break;ggb(l)}while(0);if(wa)zHa(O,((k[P>>2]|0)-(k[O>>2]|0)>>2)+(aa(n,ya)|0)|0);do if(!t)Oa=235;else{c=k[q>>2]|0;e=c&7;if(!e){Oa=235;break}k[Ja>>2]=t;k[Q>>2]=q;if(!((e+-5|0)>>>0<2&(c&16|0)==0)){k[S>>2]=q;k[ba>>2]=0;k[U>>2]=1;break}c=q+8|0;KY(k[c>>2]|0,$);e=k[q>>2]|0;switch(e&7){case 6:{c=k[(k[c>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[c>>2]|0)+24>>2]|0;break}default:c=(e&7|0)!=0&1}k[U>>2]=c}while(0);if((Oa|0)==235){Oa=0;k[Ja>>2]=0;k[Q>>2]=0;k[S>>2]=0;k[U>>2]=0}c=k[q>>2]|0;switch(c&7){case 6:{c=k[(k[q+8>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[q+8>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}B6(Ka,t,q,c);i:while(1){do if((k[Ja>>2]|0)==(k[Ka>>2]|0)){if((k[Q>>2]|0)!=(k[R>>2]|0)){Oa=245;break}c=k[S>>2]|0;if((c|0)!=(k[T>>2]|0))break;if((k[U>>2]|0)==(k[V>>2]|0))break i;else Oa=245}else Oa=245;while(0);if((Oa|0)==245){Oa=0;c=k[S>>2]|0}j:do if(!c)s=0;else{switch(k[c>>2]&7){case 1:{s=k[c+8>>2]|0;break j}case 2:break;default:{s=2147483647;break j}}g=+p[c+8>>3];p[u>>3]=g;e=k[u+4>>2]|0;s=e&2146435072;do if(!(s>>>0>1126170624|(s|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(!(g==0.0))break;g=e?-0.0:0.0}while(0);s=~~g}while(0);f=k[U>>2]|0;if(!f){j=0;h=c;f=c}else{e=k[ba>>2]|0;do if(!e)e=c;else{c=c+(k[e+28>>2]|0)|0;k[S>>2]=c;if(c>>>0<(k[ca>>2]|0)>>>0){e=c;break}m=k[(k[da>>2]|0)+4>>2]|0;k[da>>2]=m;c=k[m+16>>2]|0;k[S>>2]=c;q=c;n=k[e+28>>2]|0;e=k[m+12>>2]|0;k[ea>>2]=q;e=q+(aa(n,e)|0)|0;k[ca>>2]=e;e=q}while(0);j=f+-1|0;k[U>>2]=j;h=c;f=e}k:do if(!h)q=0;else{switch(k[h>>2]&7){case 1:{q=k[h+8>>2]|0;break k}case 2:break;default:{q=2147483647;break k}}g=+p[h+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;q=c&2146435072;do if(!(q>>>0>1126170624|(q|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(!(g==0.0))break;g=c?-0.0:0.0}while(0);q=~~g}while(0);if(!j){j=0;c=h;h=f}else{e=k[ba>>2]|0;do if(!e){e=f;c=h}else{c=f+(k[e+28>>2]|0)|0;k[S>>2]=c;if(c>>>0<(k[ca>>2]|0)>>>0){e=c;break}l=k[(k[da>>2]|0)+4>>2]|0;k[da>>2]=l;c=k[l+16>>2]|0;k[S>>2]=c;n=c;m=k[e+28>>2]|0;e=k[l+12>>2]|0;k[ea>>2]=n;e=n+(aa(m,e)|0)|0;k[ca>>2]=e;e=n}while(0);j=j+-1|0;k[U>>2]=j;h=e}l:do if(!c)n=0;else{switch(k[c>>2]&7){case 1:{n=k[c+8>>2]|0;break l}case 2:break;default:{n=2147483647;break l}}g=+p[c+8>>3];p[u>>3]=g;e=k[u+4>>2]|0;n=e&2146435072;do if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(!(g==0.0))break;g=e?-0.0:0.0}while(0);n=~~g}while(0);if(!j){f=0;e=h}else{e=k[ba>>2]|0;do if(!e)e=h;else{c=h+(k[e+28>>2]|0)|0;k[S>>2]=c;if(c>>>0<(k[ca>>2]|0)>>>0){e=c;break}h=k[(k[da>>2]|0)+4>>2]|0;k[da>>2]=h;c=k[h+16>>2]|0;k[S>>2]=c;m=c;l=k[e+28>>2]|0;e=k[h+12>>2]|0;k[ea>>2]=m;e=m+(aa(l,e)|0)|0;k[ca>>2]=e;e=m}while(0);f=j+-1|0;k[U>>2]=f}m:do if(wa){f=0;while(1){if((f|0)>=(ya|0)){g=0.0;break m}c=k[S>>2]|0;n:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break n}case 2:break;default:{c=2147483647;break n}}g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;m=c&2146435072;do if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(!(g==0.0))break;g=c?-0.0:0.0}while(0);c=~~g}while(0);k[Da>>2]=c;e=k[P>>2]|0;if((e|0)==(k[X>>2]|0))Q4(O,Da);else{k[e>>2]=c;k[P>>2]=e+4}c=f+1|0;e=k[U>>2]|0;if(!e){f=c;continue}f=k[ba>>2]|0;do if(f|0){m=(k[S>>2]|0)+(k[f+28>>2]|0)|0;k[S>>2]=m;if(m>>>0<(k[ca>>2]|0)>>>0)break;m=k[(k[da>>2]|0)+4>>2]|0;k[da>>2]=m;j=k[m+16>>2]|0;k[S>>2]=j;l=k[f+28>>2]|0;m=k[m+12>>2]|0;k[ea>>2]=j;m=j+(aa(l,m)|0)|0;k[ca>>2]=m}while(0);k[U>>2]=e+-1;f=c}}else{o:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break o}case 2:{g=+p[c+8>>3];break o}default:{g=1000000015047466219876688.0e6;break o}}while(0);if(!f)break;c=k[ba>>2]|0;do if(c|0){m=e+(k[c+28>>2]|0)|0;k[S>>2]=m;if(m>>>0<(k[ca>>2]|0)>>>0)break;m=k[(k[da>>2]|0)+4>>2]|0;k[da>>2]=m;j=k[m+16>>2]|0;k[S>>2]=j;l=k[c+28>>2]|0;m=k[m+12>>2]|0;k[ea>>2]=j;m=j+(aa(l,m)|0)|0;k[ca>>2]=m}while(0);k[U>>2]=f+-1}while(0);c=k[sa>>2]|0;e=k[W>>2]|0;if((c|0)!=(e|0)){k[c>>2]=n;o[c+4>>2]=g;k[c+8>>2]=s;k[c+12>>2]=q;k[sa>>2]=(k[sa>>2]|0)+16;continue}m=k[Ba>>2]|0;l=c-m|0;j=l>>4;c=j+1|0;if(c>>>0>268435455){Oa=311;break e}f=e-m|0;h=f>>3;h=f>>4>>>0<134217727?(h>>>0<c>>>0?c:h):268435455;if(!h)f=0;else{if(h>>>0>268435455){Oa=314;break e}e=h<<4;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}f=c}e=f+(j<<4)|0;k[e>>2]=n;o[f+(j<<4)+4>>2]=g;k[f+(j<<4)+8>>2]=s;k[f+(j<<4)+12>>2]=q;c=e+(0-j<<4)|0;if((l|0)>0)upb(c|0,m|0,l|0)|0;k[Ba>>2]=c;k[sa>>2]=e+16;k[W>>2]=f+(h<<4);if(!m)continue;ggb(m)}do if(!t)Oa=333;else{c=k[v>>2]|0;e=c&7;if(!e){Oa=333;break}k[Da>>2]=t;k[fa>>2]=v;if(!((e+-5|0)>>>0<2&(c&16|0)==0)){k[ia>>2]=v;k[ja>>2]=0;k[ha>>2]=1;break}c=v+8|0;KY(k[c>>2]|0,ga);e=k[v>>2]|0;switch(e&7){case 6:{c=k[(k[c>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[c>>2]|0)+24>>2]|0;break}default:c=(e&7|0)!=0&1}k[ha>>2]=c}while(0);if((Oa|0)==333){Oa=0;k[Da>>2]=0;k[fa>>2]=0;k[ia>>2]=0;k[ha>>2]=0}h=Ja;f=Da;j=h+44|0;do{k[h>>2]=k[f>>2];h=h+4|0;f=f+4|0}while((h|0)<(j|0));c=k[v>>2]|0;switch(c&7){case 6:{c=k[(k[v+8>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[v+8>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}B6(Ea,t,v,c);h=Ka;f=Ea;j=h+44|0;do{k[h>>2]=k[f>>2];h=h+4|0;f=f+4|0}while((h|0)<(j|0));p:while(1){do if((k[Ja>>2]|0)==(k[Ka>>2]|0)){if((k[Q>>2]|0)!=(k[R>>2]|0))break;if((k[S>>2]|0)!=(k[T>>2]|0))break;if((k[U>>2]|0)==(k[V>>2]|0))break p}while(0);c=k[S>>2]|0;q:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break q}case 2:{g=+p[c+8>>3];break q}default:{g=1000000015047466219876688.0e6;break q}}while(0);o[Da>>2]=g;c=k[N>>2]|0;if((c|0)==(k[Y>>2]|0))MAa(M,Da);else{o[c>>2]=g;k[N>>2]=c+4}c=k[U>>2]|0;if(!c)continue;e=k[ba>>2]|0;do if(e|0){v=(k[S>>2]|0)+(k[e+28>>2]|0)|0;k[S>>2]=v;if(v>>>0<(k[ca>>2]|0)>>>0)break;v=k[(k[da>>2]|0)+4>>2]|0;k[da>>2]=v;s=k[v+16>>2]|0;k[S>>2]=s;t=k[e+28>>2]|0;v=k[v+12>>2]|0;k[ea>>2]=s;v=s+(aa(t,v)|0)|0;k[ca>>2]=v}while(0);k[U>>2]=c+-1}c=k[J>>2]|0;if(!c)continue;e=k[_>>2]|0;do if(e|0){v=(k[H>>2]|0)+(k[e+28>>2]|0)|0;k[H>>2]=v;if(v>>>0<(k[ka>>2]|0)>>>0)break;v=k[(k[la>>2]|0)+4>>2]|0;k[la>>2]=v;s=k[v+16>>2]|0;k[H>>2]=s;t=k[e+28>>2]|0;v=k[v+12>>2]|0;k[ma>>2]=s;v=s+(aa(t,v)|0)|0;k[ka>>2]=v}while(0);k[J>>2]=c+-1}c=w+1|0;e=k[D>>2]|0;if(!e){w=c;continue}f=k[na>>2]|0;do if(f|0){w=(k[B>>2]|0)+(k[f+28>>2]|0)|0;k[B>>2]=w;if(w>>>0<(k[oa>>2]|0)>>>0)break;w=k[(k[pa>>2]|0)+4>>2]|0;k[pa>>2]=w;t=k[w+16>>2]|0;k[B>>2]=t;v=k[f+28>>2]|0;w=k[w+12>>2]|0;k[qa>>2]=t;w=t+(aa(v,w)|0)|0;k[oa>>2]=w}while(0);k[D>>2]=e+-1;w=c}r:switch(Oa|0){case 126:{ad(426534,426557,304,426811);break}case 129:{Sa=te(4)|0;k[Sa>>2]=172664;Cf(Sa|0,28816,1287)}case 142:{Sa=te(4)|0;k[Sa>>2]=172664;Cf(Sa|0,28816,1287)}case 181:{ad(426534,426557,304,426811);break}case 184:{Sa=te(4)|0;k[Sa>>2]=172664;Cf(Sa|0,28816,1287)}case 197:{Sa=te(4)|0;k[Sa>>2]=172664;Cf(Sa|0,28816,1287)}case 214:{Sa=te(4)|0;k[Sa>>2]=172664;Cf(Sa|0,28816,1287)}case 311:{ad(426534,426557,304,426811);break}case 314:{Sa=te(4)|0;k[Sa>>2]=172664;Cf(Sa|0,28816,1287)}case 360:{d=0;break}case 366:{if((k[y>>2]|0)!=1){d=1;break}e=k[Ca>>2]|0;Ka=(k[ra>>2]|0)-e|0;A=(Ka|0)/12|0;if(!Ka){d=1;break}B=a+68|0;C=a+100|0;c=0;f=0;h=0;s:while(1){z=k[e+(c*12|0)+4>>2]|0;if((z|0)>0){y=0;e=h;do{s=k[Ba>>2]|0;q=k[s+(e<<4)>>2]|0;s=k[s+(e<<4)+4>>2]|0;v=k[B>>2]|0;t=k[v+(f<<2)>>2]|0;v=k[v+(f+1<<2)>>2]|0;h=k[Aa>>2]|0;Ka=k[C>>2]|0;j=Ka;do if((h|0)==(Ka|0)){x=k[za>>2]|0;w=h-x|0;n=w>>4;h=n+1|0;if(h>>>0>268435455){Oa=375;break s}Ka=j-x|0;m=Ka>>3;m=Ka>>4>>>0<134217727?(m>>>0<h>>>0?h:m):268435455;if(!m)l=0;else{if(m>>>0>268435455){Oa=378;break s}j=m<<4;j=(j|0)==0?1:j;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}l=h}j=l+(n<<4)|0;k[j>>2]=q;k[l+(n<<4)+4>>2]=s;k[l+(n<<4)+8>>2]=t;k[l+(n<<4)+12>>2]=v;h=j+(0-n<<4)|0;if((w|0)>0)upb(h|0,x|0,w|0)|0;k[za>>2]=h;k[Aa>>2]=j+16;k[C>>2]=l+(m<<4);if(!x)break;ggb(x)}else{k[h>>2]=q;k[h+4>>2]=s;k[h+8>>2]=t;k[h+12>>2]=v;k[Aa>>2]=(k[Aa>>2]|0)+16}while(0);y=y+1|0;e=e+1|0;f=f+2|0}while((y|0)<(z|0))}else e=h;c=c+1|0;if(c>>>0>=A>>>0){d=1;break r}h=e;e=k[Ca>>2]|0}if((Oa|0)==375)ad(426534,426557,304,426811);else if((Oa|0)==378){Sa=te(4)|0;k[Sa>>2]=172664;Cf(Sa|0,28816,1287)}break}}}else d=0}else d=0;c=k[Na>>2]|0}k[La>>2]=0;k[Na>>2]=0;if(c|0?(La=c+-4|0,Na=k[La>>2]|0,k[La>>2]=Na+-1,(Na|0)==1):0)ggb(k[c+-8>>2]|0);c=k[Ra>>2]|0}k[Ma>>2]=0;k[Ra>>2]=0;if(c|0?(Ma=c+-4|0,Na=k[Ma>>2]|0,k[Ma>>2]=Na+-1,(Na|0)==1):0)ggb(k[c+-8>>2]|0);if(!d){Ra=0;r=Sa;return Ra|0}f=a+104|0;switch(k[a+8>>2]|0){case 0:{while(1){c=fgb(436)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[d+24>>2]=0;k[c+44>>2]=1124007936;d=c+52|0;e=c+84|0;h=c+48|0;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[e>>2]=d;d=c+92|0;k[c+88>>2]=d;k[c+96>>2]=0;k[d>>2]=0;k[c+100>>2]=1124007936;d=c+108|0;e=c+140|0;h=c+104|0;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[e>>2]=d;h=c+148|0;k[c+144>>2]=h;k[c+152>>2]=0;k[h>>2]=0;k[c+156>>2]=1124007936;h=c+160|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[c+188>>2]=c+164;h=c+196|0;k[c+192>>2]=h;k[c+200>>2]=0;k[h>>2]=0;k[c+204>>2]=1124007936;h=c+208|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[c+236>>2]=c+212;h=c+244|0;k[c+240>>2]=h;k[c+248>>2]=0;k[h>>2]=0;k[c+252>>2]=1124007936;h=c+256|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[c+284>>2]=c+260;h=c+292|0;k[c+288>>2]=h;k[c+296>>2]=0;k[h>>2]=0;k[c+300>>2]=1124007936;h=c+304|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[c+332>>2]=c+308;h=c+340|0;k[c+336>>2]=h;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[c>>2]=95164;h=c+356|0;d=c+24|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;h=c+392|0;j=h+40|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[d>>2]=4;k[c+28>>2]=2;k[c+32>>2]=0;k[c+36>>2]=0;k[c+40>>2]=0;k[c+384>>2]=0;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d+4>>2]=1;k[d>>2]=95224;k[d+8>>2]=c;Oa=416;break}case 1:{while(1){c=fgb(388)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}tRa(c);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d+4>>2]=1;k[d>>2]=95344;k[d+8>>2]=c;Oa=416;break}default:{d=0;c=0}}if((Oa|0)==416)if(d){Oa=d+4|0;k[Oa>>2]=(k[Oa>>2]|0)+1}e=k[f>>2]|0;k[f>>2]=d;f=a+108|0;k[f>>2]=c;if(e|0?(Na=e+4|0,Oa=k[Na>>2]|0,k[Na>>2]=Oa+-1,(Oa|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);c=d;if(d|0?(Na=c+4|0,Oa=k[Na>>2]|0,k[Na>>2]=Oa+-1,(Oa|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](c);Oa=k[b>>2]|0;b=k6(Oa,k[Pa>>2]|0,379827)|0;k[Ra>>2]=Oa;k[Ra+4>>2]=b;if(!b)c=0;else{c=k[f>>2]|0;b=k[(k[c>>2]|0)+8>>2]|0;k[Qa>>2]=k[a+24>>2];k[Qa+4>>2]=k[a+28>>2];c=ci[b&255](c,Ra,Qa)|0}Ra=c;r=Sa;return Ra|0}function ZRa(a){a=a|0;ggb(a);return}function _Ra(a){a=a|0;var b=0,c=0;b=r;r=r+16|0;c=b;k[c>>2]=k[a+8>>2];rSa(c);if(!a){r=b;return}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);r=b;return}function $Ra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+8|0;e=k[i>>2]|0;j=a+4|0;c=k[j>>2]|0;if(((e-c|0)/24|0)>>>0>=b>>>0){do{k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;k[c+16>>2]=0;k[c+20>>2]=0;c=(k[j>>2]|0)+24|0;k[j>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=(c-d|0)/24|0;c=f+b|0;if(c>>>0>178956970)ad(426534,426557,304,426811);h=(e-d|0)/24|0;e=h<<1;e=h>>>0<89478485?(e>>>0<c>>>0?c:e):178956970;if(!e)c=0;else{if(e>>>0>178956970){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=e*24|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}g=c+(f*24|0)|0;f=g;d=g;h=f;do{k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;d=h+24|0;h=d;b=b+-1|0}while((b|0)!=0);d=c+(e*24|0)|0;e=k[a>>2]|0;b=k[j>>2]|0;if((b|0)==(e|0))c=f;else{c=g;do{g=b;b=b+-24|0;p[c+-24>>3]=+p[b>>3];p[c+-16>>3]=+p[g+-16>>3];p[c+-8>>3]=+p[g+-8>>3];c=c+-24|0}while((b|0)!=(e|0))}k[a>>2]=c;k[j>>2]=h;k[i>>2]=d;if(!e)return;ggb(e);return}function aSa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,l=0.0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0;u=a+8|0;v=a+16|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;d=k[b+4>>2]|0;e=k[b>>2]|0;w=e;if((d|0)==(e|0)){o=0.0;t=0.0;r=0.0;n=0.0;q=0.0;s=0.0;o=n/o;p[a>>3]=o;r=q/r;p[u>>3]=r;t=s/t;p[v>>3]=t;return}o=+p[c>>3];q=+p[c+8>>3];r=+p[b+24>>3];s=+p[b+32>>3];t=+p[b+40>>3];n=+p[c+16>>3]/t;m=k[b+12>>2]|0;b=(d-e|0)/24|0;c=0;f=0.0;g=0.0;h=0.0;i=0.0;j=0.0;l=0.0;do{A=+p[w+(c*24|0)+16>>3];y=+Z(+A);z=r*y;y=s*y;C=+p[w+(c*24|0)>>3]/z;B=+p[w+(c*24|0)+8>>3]/y;A=A/t;D=C-o/z;x=B-q/y;E=A-n;x=+p[m+(c<<3)>>3]*+Z(+((E*E+(D*D+x*x))*-.5))/+Q(+(t+(z+y)));i=i+C*x;j=B*x+j;l=A*x+l;f=f+x/z;h=h+x/y;g=g+x/t;c=c+1|0}while(c>>>0<b>>>0);p[a>>3]=i;p[u>>3]=j;p[v>>3]=l;A=f;E=g;C=h;z=i;B=j;D=l;A=z/A;p[a>>3]=A;C=B/C;p[u>>3]=C;E=D/E;p[v>>3]=E;return}function bSa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=95404;k[a+12>>2]=0;k[a+8>>2]=0;k[a+4>>2]=0;b=a+128|0;c=a+20|0;d=c+108|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));k[b>>2]=1124007936;d=a+132|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[d+24>>2]=0;k[a+160>>2]=a+136;d=a+168|0;k[a+164>>2]=d;k[a+172>>2]=0;k[d>>2]=0;k[a+176>>2]=1124007936;d=a+180|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[d+24>>2]=0;k[a+208>>2]=a+184;d=a+216|0;k[a+212>>2]=d;k[a+220>>2]=0;k[d>>2]=0;k[a+224>>2]=1124007936;d=a+228|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[d+24>>2]=0;k[a+256>>2]=a+232;d=a+264|0;k[a+260>>2]=d;k[a+268>>2]=0;k[d>>2]=0;k[a+272>>2]=1124007936;d=a+276|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[d+24>>2]=0;k[a+304>>2]=a+280;d=a+312|0;k[a+308>>2]=d;k[a+316>>2]=0;k[d>>2]=0;k[a+320>>2]=1124007936;d=a+324|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[d+24>>2]=0;k[a+352>>2]=a+328;d=a+360|0;k[a+356>>2]=d;k[a+364>>2]=0;k[d>>2]=0;k[a+368>>2]=1124007936;d=a+372|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[d+24>>2]=0;k[a+400>>2]=a+376;d=a+408|0;k[a+404>>2]=d;k[a+412>>2]=0;k[d>>2]=0;m9(a+416|0);return}function cSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;while(1){c=fgb(420)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}bSa(c);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=95524;k[d+8>>2]=c;k[e>>2]=(k[e>>2]|0)+1;f=k[a>>2]|0;k[a>>2]=d;g=a+4|0;k[g>>2]=c;if(f|0?(h=f+4|0,c=k[h>>2]|0,k[h>>2]=c+-1,(c|0)==1):0)Uh[k[(k[f>>2]|0)+8>>2]&2047](f);h=k[e>>2]|0;k[e>>2]=h+-1;if((h|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);h=k[g>>2]|0;if(Hh[k[(k[h>>2]|0)+32>>2]&511](h,b)|0){c=k[g>>2]|0;if(!c){h=0;return h|0}h=(Xh[k[(k[c>>2]|0)+20>>2]&1023](c)|0)^1;return h|0}c=k[a>>2]|0;if(c|0?(b=c+4|0,h=k[b>>2]|0,k[b>>2]=h+-1,(h|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[a>>2]=0;k[g>>2]=0;h=0;return h|0}function dSa(a){a=a|0;ggb(a);return}function eSa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function fSa(a){a=a|0;a=k[a+4>>2]|0;if(!a){a=1;return a|0}a=Xh[k[(k[a>>2]|0)+20>>2]&1023](a)|0;return a|0}function gSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;while(1){c=fgb(420)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}bSa(c);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=d+4|0;k[f>>2]=1;k[d>>2]=95524;k[d+8>>2]=c;e=YRa(c,b)|0;if(e){k[f>>2]=(k[f>>2]|0)+1;k[f>>2]=(k[f>>2]|0)+1;b=k[a>>2]|0;k[a>>2]=d;k[a+4>>2]=c;if(b|0?(c=b+4|0,a=k[c>>2]|0,k[c>>2]=a+-1,(a|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d)}else{c=k[a>>2]|0;if(c|0?(g=c+4|0,b=k[g>>2]|0,k[g>>2]=b+-1,(b|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[a>>2]=0;k[a+4>>2]=0}g=k[f>>2]|0;k[f>>2]=g+-1;if((g|0)!=1)return e|0;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);return e|0}function hSa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;A=r;r=r+16|0;h=A;v=c+4|0;t=(k[v>>2]|0)-(k[c>>2]|0)>>4;w=(d|0)!=0;if(w?((k[d+4>>2]|0)-(k[d>>2]|0)>>2|0)!=(t|0):0){f=h+4|0;g=ZT(20)|0;k[g>>2]=1;j=g+4|0;k[h>>2]=j;k[f>>2]=14;i[g+18>>0]=0;l=380072;m=j+14|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,h,380087,378394,1602);k[f>>2]=0;k[h>>2]=0;x=k[g>>2]|0;k[g>>2]=x+-1;if((x|0)==1)ggb(k[g+-4>>2]|0)}x=(e|0)!=0;if(x?((k[e+4>>2]|0)-(k[e>>2]|0)>>3|0)!=(t|0):0){f=h+4|0;g=ZT(20)|0;k[g>>2]=1;j=g+4|0;k[h>>2]=j;k[f>>2]=14;i[g+18>>0]=0;l=380099;m=j+14|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,h,380087,378394,1606);k[f>>2]=0;k[h>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}a:do if(t){q=d+4|0;s=e+4|0;o=k[c>>2]|0;n=0;f=0;while(1){j=k[o+(n<<4)>>2]|0;g=(j|0)>0?j:0;l=k[o+(n<<4)+4>>2]|0;h=(l|0)>0?l:0;j=(k[o+(n<<4)+8>>2]|0)+j|0;j=((j|0)<(a|0)?j:a)-g|0;l=(k[o+(n<<4)+12>>2]|0)+l|0;l=((l|0)<(b|0)?l:b)-h|0;C=(j|0)<1;B=(l|0)<1;m=C|B;if((aa(l,j)|0)>0&((C|B)^1)){k[o+(f<<4)>>2]=m?0:g;k[o+(f<<4)+4>>2]=m?0:h;k[o+(f<<4)+8>>2]=m?0:j;k[o+(f<<4)+12>>2]=m?0:l;if(n>>>0>f>>>0){if(w){g=k[d>>2]|0;h=(k[q>>2]|0)-g>>2;if(h>>>0<=n>>>0){f=17;break}if(h>>>0<=f>>>0){f=19;break}k[g+(f<<2)>>2]=k[g+(n<<2)>>2]}if(x){g=k[e>>2]|0;h=(k[s>>2]|0)-g>>3;if(h>>>0<=n>>>0){f=23;break}if(h>>>0<=f>>>0){f=25;break}p[g+(f<<3)>>3]=+p[g+(n<<3)>>3]}}f=f+1|0}n=n+1|0;if((n|0)==(t|0)){z=f;break a}}if((f|0)==17)ad(426635,426557,315,426658);else if((f|0)==19)ad(426635,426557,315,426658);else if((f|0)==23)ad(426635,426557,315,426658);else if((f|0)==25)ad(426635,426557,315,426658)}else z=0;while(0);if(z>>>0>=t>>>0){r=A;return}h=k[v>>2]|0;g=k[c>>2]|0;f=h-g>>4;if(z>>>0<=f>>>0){if(z>>>0<f>>>0?(u=g+(z<<4)|0,(h|0)!=(u|0)):0)k[v>>2]=h+(~((h+-16-u|0)>>>4)<<4)}else WRa(c,z-f|0);do if(w){f=d+4|0;j=k[f>>2]|0;g=k[d>>2]|0;h=j-g>>2;if(z>>>0>h>>>0){U1(d,z-h|0);break}if(z>>>0<h>>>0?(y=g+(z<<2)|0,(j|0)!=(y|0)):0)k[f>>2]=j+(~((j+-4-y|0)>>>2)<<2)}while(0);if(!x){r=A;return}h=e+4|0;j=k[h>>2]|0;f=k[e>>2]|0;g=j-f>>3;if(z>>>0>g>>>0){Bla(e,z-g|0);r=A;return}if(z>>>0>=g>>>0){r=A;return}f=f+(z<<3)|0;if((j|0)==(f|0)){r=A;return}k[h>>2]=j+(~((j+-8-f|0)>>>3)<<3);r=A;return}function iSa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;d=r;r=r+16|0;c=d;b=a+4|0;a=k[b>>2]|0;if(a|0?!(Xh[k[(k[a>>2]|0)+20>>2]&1023](a)|0):0){c=k[b>>2]|0;b=k[c>>2]|0;b=b+48|0;b=k[b>>2]|0;c=Xh[b&1023](c)|0;r=d;return c|0}e=c+4|0;a=ZT(16)|0;k[a>>2]=1;f=a+4|0;k[c>>2]=f;k[e>>2]=8;i[a+12>>0]=0;g=f;i[g>>0]=33;i[g+1>>0]=101;i[g+2>>0]=109;i[g+3>>0]=112;f=f+4|0;i[f>>0]=116;i[f+1>>0]=121;i[f+2>>0]=40;i[f+3>>0]=41;Y8(-215,c,380114,378394,1675);k[e>>2]=0;k[c>>2]=0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)==1)ggb(k[a+-4>>2]|0);g=k[b>>2]|0;f=k[g>>2]|0;f=f+48|0;f=k[f>>2]|0;g=Xh[f&1023](g)|0;r=d;return g|0}function jSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;e=r;r=r+16|0;d=e;c=b+4|0;b=k[c>>2]|0;if(b|0?!(Xh[k[(k[b>>2]|0)+20>>2]&1023](b)|0):0){d=k[c>>2]|0;c=k[d>>2]|0;c=c+52|0;c=k[c>>2]|0;jh[c&1023](a,d);r=e;return}f=d+4|0;b=ZT(16)|0;k[b>>2]=1;g=b+4|0;k[d>>2]=g;k[f>>2]=8;i[b+12>>0]=0;h=g;i[h>>0]=33;i[h+1>>0]=101;i[h+2>>0]=109;i[h+3>>0]=112;g=g+4|0;i[g>>0]=116;i[g+1>>0]=121;i[g+2>>0]=40;i[g+3>>0]=41;Y8(-215,d,380133,378394,1681);k[f>>2]=0;k[d>>2]=0;d=k[b>>2]|0;k[b>>2]=d+-1;if((d|0)==1)ggb(k[b+-4>>2]|0);h=k[c>>2]|0;g=k[h>>2]|0;g=g+52|0;g=k[g>>2]|0;jh[g&1023](a,h);r=e;return}function kSa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;d=r;r=r+16|0;c=d;b=a+4|0;a=k[b>>2]|0;if(a|0?!(Xh[k[(k[a>>2]|0)+20>>2]&1023](a)|0):0){c=k[b>>2]|0;b=k[c>>2]|0;b=b+56|0;b=k[b>>2]|0;c=Xh[b&1023](c)|0;r=d;return c|0}e=c+4|0;a=ZT(16)|0;k[a>>2]=1;f=a+4|0;k[c>>2]=f;k[e>>2]=8;i[a+12>>0]=0;g=f;i[g>>0]=33;i[g+1>>0]=101;i[g+2>>0]=109;i[g+3>>0]=112;f=f+4|0;i[f>>0]=116;i[f+1>>0]=121;i[f+2>>0]=40;i[f+3>>0]=41;Y8(-215,c,380155,378394,1687);k[e>>2]=0;k[c>>2]=0;c=k[a>>2]|0;k[a>>2]=c+-1;if((c|0)==1)ggb(k[a+-4>>2]|0);g=k[b>>2]|0;f=k[g>>2]|0;f=f+56|0;f=k[f>>2]|0;g=Xh[f&1023](g)|0;r=d;return g|0}function lSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;Ka=r;r=r+256|0;Ja=Ka+8|0;Ia=Ka;Da=Ka+184|0;wa=Ka+140|0;Fa=Ka+96|0;Ga=Ka+60|0;Ha=Ka+24|0;Ca=Ka+20|0;xa=Ka+16|0;ya=Ka+12|0;k[Da>>2]=0;Ba=Da+4|0;k[Ba>>2]=0;x6(Ga,a,0,Da);k[Ba>>2]=0;k[Da>>2]=0;Ba=k[Ga+8>>2]|0;if((Ba|0)!=0?(i[Ba+272>>0]|0)!=0:0){y6(Da,Ga);e=k[Da>>2]|0;f=k[Da+4>>2]|0;if((e|0)!=0&(f|0)!=0?(c=k[f>>2]|0,d=c&7,(d|0)!=0):0){k[wa>>2]=e;k[wa+4>>2]=f;if((d+-5|0)>>>0<2&(c&16|0)==0){a=f+8|0;KY(k[a>>2]|0,wa+8|0);c=k[f>>2]|0;switch(c&7){case 6:{a=k[(k[a>>2]|0)+60>>2]|0;break}case 5:{a=k[(k[a>>2]|0)+24>>2]|0;break}default:a=(c&7|0)!=0&1}k[wa+40>>2]=a}else{k[wa+20>>2]=f;k[wa+12>>2]=0;k[wa+40>>2]=1}Ba=14}else{k[wa>>2]=0;k[wa+4>>2]=0;k[wa+20>>2]=0;k[wa+40>>2]=0;if(!f){a=1;Ba=18}else Ba=14}a:do if((Ba|0)==14){a=k[f>>2]|0;switch(a&7){case 6:{a=k[(k[f+8>>2]|0)+60>>2]|0;break a}case 5:{a=k[(k[f+8>>2]|0)+24>>2]|0;break a}default:{a=(a&7|0)==0;Ba=18;break a}}}while(0);if((Ba|0)==18)a=a&1^1;B6(Fa,e,f,a);za=k[wa>>2]|0;a=za;if((((za|0)==(k[Fa>>2]|0)?(k[wa+4>>2]|0)==(k[Fa+4>>2]|0):0)?(k[wa+20>>2]|0)==(k[Fa+20>>2]|0):0)?(k[wa+40>>2]|0)==(k[Fa+40>>2]|0):0){a=0;c=0}else c=k[wa+20>>2]|0;l=a;j=k6(l,c,380512)|0;if(j){k[wa>>2]=0;va=wa+4|0;k[va>>2]=0;d=j;if((k[j>>2]&7|0)==5){h=k[j+8>>2]|0;e=k[h+24>>2]|0;if(!e)d=0;else{d=k[h+52>>2]|0;if((e|0)>=0){f=k[d+12>>2]|0;if((f|0)>0)e=0;else{e=0;do{d=k[d+4>>2]|0;e=e-f|0;f=k[d+12>>2]|0}while((e|0)>=(f|0))}}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((e|0)>0);e=0-e|0}d=(k[d+16>>2]|0)+(aa(k[h+28>>2]|0,e)|0)|0}}e=d;b:do if(!d)d=0;else{switch(k[e>>2]&7){case 1:{d=k[e+8>>2]|0;break b}case 2:break;default:{d=2147483647;break b}}g=+p[e+8>>3];p[u>>3]=g;d=k[u+4>>2]|0;za=d&2146435072;if(!(za>>>0>1126170624|(za|0)==1126170624&0>0)){d=(d|0)<0;g=d?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=d?-0.0:0.0}d=~~g}while(0);k[wa>>2]=d;c:do if((k[j>>2]&7|0)==5){h=k[j+8>>2]|0;f=k[h+24>>2]|0;if(f>>>0<=1){d=1-f|0;if(d>>>0<f>>>0)Ba=44;else d=0}else{d=1;Ba=44}if((Ba|0)==44){e=k[h+52>>2]|0;if((d<<1|0)<=(f|0)){f=k[e+12>>2]|0;if((d|0)>=(f|0))do{e=k[e+4>>2]|0;d=d-f|0;f=k[e+12>>2]|0}while((d|0)>=(f|0))}else{do{e=k[e>>2]|0;f=f-(k[e+12>>2]|0)|0}while((d|0)<(f|0));d=d-f|0}d=(k[e+16>>2]|0)+(aa(k[h+28>>2]|0,d)|0)|0}if(d){switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break c}case 2:break;default:{d=2147483647;break c}}g=+p[d+8>>3];p[u>>3]=g;d=k[u+4>>2]|0;za=d&2146435072;if(!(za>>>0>1126170624|(za|0)==1126170624&0>0)){d=(d|0)<0;g=d?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=d?-0.0:0.0}d=~~g}else d=0}else d=0;while(0);k[va>>2]=d;sa=k6(l,c,380517)|0;ta=(sa|0)==0;d:do if(ta){c=1;Ba=62}else{c=k[sa>>2]|0;switch(c&7){case 6:{za=k[(k[sa+8>>2]|0)+60>>2]|0;break d}case 5:{za=k[(k[sa+8>>2]|0)+24>>2]|0;break d}default:{c=(c&7|0)==0;Ba=62;break d}}}while(0);if((Ba|0)==62)za=c&1^1;k[Fa>>2]=0;e=Fa+4|0;k[e>>2]=0;k[Fa+8>>2]=0;e:do if(za){if(za>>>0>178956970)ad(426534,426557,304,426811);f=za*24|0;d=(f|0)==0?1:f;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[Fa>>2]=c;k[Fa+8>>2]=c+(za*24|0);zpb(c|0,0,f|0)|0;k[e>>2]=c+f;$=Da+4|0;ba=Da+4|0;ca=Da+8|0;da=Da+12|0;ea=Da+16|0;fa=Da+20|0;ga=Da+24|0;ha=Da+28|0;ia=Da+32|0;ja=Da+36|0;ka=Da+40|0;la=Da+44|0;ma=Da+48|0;na=Da+52|0;oa=Da+56|0;pa=Da+60|0;qa=sa;ra=sa+8|0;_=0;A=0;d=0;B=0;f:while(1){if(!ta?(k[sa>>2]&7|0)==5:0){h=k[ra>>2]|0;f=k[h+24>>2]|0;if(f>>>0<=_>>>0){c=_-((_|0)>=(f|0)?f:0)|0;if(c>>>0<f>>>0)Ba=75;else c=0}else{c=_;Ba=75}if((Ba|0)==75){Ba=0;e=k[h+52>>2]|0;do if((c<<1|0)>(f|0)){do{e=k[e>>2]|0;f=f-(k[e+12>>2]|0)|0}while((c|0)<(f|0));c=c-f|0}else{f=k[e+12>>2]|0;if((c|0)<(f|0))break;do{e=k[e+4>>2]|0;c=c-f|0;f=k[e+12>>2]|0}while((c|0)>=(f|0))}while(0);c=(k[e+16>>2]|0)+(aa(k[h+28>>2]|0,c)|0)|0}Z=a}else{c=(_|0)==0;Z=c?a:0;c=c?qa:0}j=k[Fa>>2]|0;f=Z;e=k6(f,c,380626)|0;g:do if(!e)g=0.0;else switch(k[e>>2]&7){case 1:{g=+(k[e+8>>2]|0);break g}case 2:{g=+p[e+8>>3];break g}default:{g=1.e+300;break g}}while(0);p[j+(_*24|0)>>3]=g;X=k6(f,c,380533)|0;Y=(X|0)==0;h:do if(Y){c=1;Ba=92}else{c=k[X>>2]|0;switch(c&7){case 6:{W=k[(k[X+8>>2]|0)+60>>2]|0;break h}case 5:{W=k[(k[X+8>>2]|0)+24>>2]|0;break h}default:{c=(c&7|0)==0;Ba=92;break h}}}while(0);if((Ba|0)==92){Ba=0;W=c&1^1}V=j+(_*24|0)+8|0;z=j+(_*24|0)+12|0;c=k[z>>2]|0;h=k[V>>2]|0;l=(c-h|0)/24|0;e=h;f=c;i:do if(W>>>0<=l>>>0){if(W>>>0<l>>>0){m=e+(W*24|0)|0;if((f|0)==(m|0))break;else l=f;do{c=l+-24|0;k[z>>2]=c;e=k[l+-12>>2]|0;f=e;if(e|0){h=l+-8|0;j=k[h>>2]|0;if((j|0)!=(e|0))k[h>>2]=j+(~((j+-4-f|0)>>>2)<<2);ggb(e)}f=k[c>>2]|0;h=f;if(f|0){c=l+-20|0;e=k[c>>2]|0;if((e|0)!=(f|0))k[c>>2]=e+(~((e+-16-h|0)>>>4)<<4);ggb(f)}l=k[z>>2]|0}while((l|0)!=(m|0))}}else{e=W-l|0;y=j+(_*24|0)+16|0;f=k[y>>2]|0;if(((f-c|0)/24|0)>>>0>=e>>>0)while(1){k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;k[c+16>>2]=0;k[c+20>>2]=0;c=(k[z>>2]|0)+24|0;k[z>>2]=c;e=e+-1|0;if(!e)break i}if(W>>>0>178956970){Ba=98;break f}U=(f-h|0)/24|0;j=U<<1;j=U>>>0<89478485?(j>>>0<W>>>0?W:j):178956970;if(!j)c=0;else{if(j>>>0>178956970){Ba=101;break f}f=j*24|0;f=(f|0)==0?1:f;while(1){c=fgb(f)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}l=c+(l*24|0)|0;h=l;f=l;x=h;do{k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;f=x+24|0;x=f;e=e+-1|0}while((e|0)!=0);w=c+(j*24|0)|0;v=k[V>>2]|0;c=k[z>>2]|0;if((c|0)==(v|0)){c=h;n=v;e=v}else{do{m=l+-24|0;s=c;c=c+-24|0;k[m>>2]=0;t=l+-20|0;k[t>>2]=0;k[l+-16>>2]=0;q=s+-20|0;e=(k[q>>2]|0)-(k[c>>2]|0)|0;n=e>>4;do if(n|0){if(n>>>0>268435455){Ba=113;break f}f=(e|0)==0?1:e;while(1){e=fgb(f)|0;if(e|0){j=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){j=0;break}Qh[e&7]()}k[t>>2]=j;k[m>>2]=j;k[l+-16>>2]=j+(n<<4);f=k[c>>2]|0;e=(k[q>>2]|0)-f|0;if((e|0)<=0)break;upb(j|0,f|0,e|0)|0;k[t>>2]=j+(e>>4<<4)}while(0);BH(l+-12|0,s+-12|0);l=h+-24|0;h=l}while((c|0)!=(v|0));c=h;n=k[V>>2]|0;e=k[z>>2]|0}k[V>>2]=c;k[z>>2]=x;k[y>>2]=w;m=n;if((e|0)!=(m|0)){l=e;do{j=l;l=l+-24|0;c=k[j+-12>>2]|0;e=c;if(c|0){f=j+-8|0;h=k[f>>2]|0;if((h|0)!=(c|0))k[f>>2]=h+(~((h+-4-e|0)>>>2)<<2);ggb(c)}f=k[l>>2]|0;h=f;if(f|0){c=j+-20|0;e=k[c>>2]|0;if((e|0)!=(f|0))k[c>>2]=e+(~((e+-16-h|0)>>>4)<<4);ggb(f)}}while((l|0)!=(m|0))}if(!n)break;ggb(n)}while(0);if((W|0)>0){T=X;U=X+8|0;S=0;e=A;c=B;do{n=k[V>>2]|0;do if(Y)Ba=158;else{if((k[X>>2]&7|0)!=5){Ba=158;break}l=k[U>>2]|0;j=k[l+24>>2]|0;if(j>>>0<=S>>>0){f=S-((S|0)>=(j|0)?j:0)|0;if(f>>>0<j>>>0)Ba=151;else h=0}else{f=S;Ba=151}if((Ba|0)==151){h=k[l+52>>2]|0;do if((f<<1|0)>(j|0)){do{h=k[h>>2]|0;j=j-(k[h+12>>2]|0)|0}while((f|0)<(j|0));f=f-j|0}else{j=k[h+12>>2]|0;if((f|0)<(j|0))break;do{h=k[h+4>>2]|0;f=f-j|0;j=k[h+12>>2]|0}while((f|0)>=(j|0))}while(0);h=(k[h+16>>2]|0)+(aa(k[l+28>>2]|0,f)|0)|0}f=Z;Ba=159}while(0);if((Ba|0)==158){Ba=(S|0)==0;f=Ba?Z:0;if(Ba){h=T;Ba=159}else{h=0;l=1;m=0;j=1;Ba=164}}j:do if((Ba|0)==159){Ba=0;m=h;l=(h|0)==0;if(l){j=1;Ba=164;break}j=k[m>>2]|0;switch(j&7){case 6:{R=k[(k[m+8>>2]|0)+60>>2]|0;break j}case 5:{R=k[(k[m+8>>2]|0)+24>>2]|0;break j}default:{j=(j&7|0)==0;Ba=164;break j}}}while(0);if((Ba|0)==164){Ba=0;R=j&1^1}if((R|0)>0){I=n+(S*24|0)+4|0;M=n+(S*24|0)+8|0;N=n+(S*24|0)|0;O=n+(S*24|0)+12|0;Q=n+(S*24|0)+16|0;G=n+(S*24|0)+20|0;H=m+8|0;F=0;do{do if(l)Ba=178;else{if((k[m>>2]&7|0)!=5){Ba=178;break}s=k[H>>2]|0;q=k[s+24>>2]|0;if(q>>>0<=F>>>0){j=F-((F|0)>=(q|0)?q:0)|0;if(j>>>0<q>>>0)Ba=171;else j=0}else{j=F;Ba=171}if((Ba|0)==171){Ba=0;n=k[s+52>>2]|0;do if((j<<1|0)>(q|0)){do{n=k[n>>2]|0;q=q-(k[n+12>>2]|0)|0}while((j|0)<(q|0));j=j-q|0}else{q=k[n+12>>2]|0;if((j|0)<(q|0))break;do{n=k[n+4>>2]|0;j=j-q|0;q=k[n+12>>2]|0}while((j|0)>=(q|0))}while(0);j=(k[n+16>>2]|0)+(aa(k[s+28>>2]|0,j)|0)|0}n=f}while(0);if((Ba|0)==178){Ba=0;j=(F|0)==0;n=j?f:0;j=j?h:0}s=k6(n,j,380565)|0;i[Da>>0]=0;K=$;L=K+60|0;do{k[K>>2]=0;K=K+4|0}while((K|0)<(L|0));E=d-e>>6;q=k6(n,s,380579)|0;k:do if(!q)q=0;else{switch(k[q>>2]&7){case 1:{q=k[q+8>>2]|0;break k}case 2:break;default:{q=2147483647;break k}}g=+p[q+8>>3];p[u>>3]=g;q=k[u+4>>2]|0;L=q&2146435072;do if(!(L>>>0>1126170624|(L|0)==1126170624&0>0)){q=(q|0)<0;g=q?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(!(g==0.0))break;g=q?-0.0:0.0}while(0);q=~~g}while(0);i[Da>>0]=(q|0)!=0&1;C=k6(n,s,380573)|0;D=(C|0)==0;l:do if(D){q=1;Ba=191}else{q=k[C>>2]|0;switch(q&7){case 6:{z=k[(k[C+8>>2]|0)+60>>2]|0;break l}case 5:{z=k[(k[C+8>>2]|0)+24>>2]|0;break l}default:{q=(q&7|0)==0;Ba=191;break l}}}while(0);if((Ba|0)==191){Ba=0;z=q&1^1}if((z|0)>0){A=C;B=C+8|0;y=0;do{do if(D)Ba=205;else{if((k[C>>2]&7|0)!=5){Ba=205;break}v=k[B>>2]|0;t=k[v+24>>2]|0;if(t>>>0<=y>>>0){q=y-((y|0)>=(t|0)?t:0)|0;if(q>>>0<t>>>0)Ba=198;else q=0}else{q=y;Ba=198}if((Ba|0)==198){s=k[v+52>>2]|0;do if((q<<1|0)>(t|0)){do{s=k[s>>2]|0;t=t-(k[s+12>>2]|0)|0}while((q|0)<(t|0));q=q-t|0}else{t=k[s+12>>2]|0;if((q|0)<(t|0))break;do{s=k[s+4>>2]|0;q=q-t|0;t=k[s+12>>2]|0}while((q|0)>=(t|0))}while(0);q=(k[s+16>>2]|0)+(aa(k[v+28>>2]|0,q)|0)|0}Ba=206}while(0);if((Ba|0)==205)if(!y){q=A;Ba=206}else Ba=216;m:do if((Ba|0)==206){x=q;s=(q|0)==0;if(s){Ba=216;break}if((k[x>>2]&7|0)==5){w=k[x+8>>2]|0;t=k[w+24>>2]|0;if(!t)q=0;else{q=k[w+52>>2]|0;do if((t|0)<0){do{q=k[q>>2]|0;t=t-(k[q+12>>2]|0)|0}while((t|0)>0);t=0-t|0}else{v=k[q+12>>2]|0;if((v|0)>0){t=0;break}else t=0;do{q=k[q+4>>2]|0;t=t-v|0;v=k[q+12>>2]|0}while((t|0)>=(v|0))}while(0);q=(k[q+16>>2]|0)+(aa(k[w+28>>2]|0,t)|0)|0}if(!q){q=x;t=0;Ba=224}else{t=x;Ba=218}}else{t=x;Ba=218}n:do if((Ba|0)==218){Ba=0;switch(k[q>>2]&7){case 1:{k[Da+4+(y*20|0)>>2]=k[q+8>>2];if(s){Ba=235;break m}else{x=s;q=t;break n}}case 2:break;default:{q=t;t=2147483647;Ba=224;break n}}g=+p[q+8>>3];p[u>>3]=g;q=k[u+4>>2]|0;L=q&2146435072;do if(!(L>>>0>1126170624|(L|0)==1126170624&0>0)){q=(q|0)<0;g=q?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(!(g==0.0))break;g=q?-0.0:0.0}while(0);k[Da+4+(y*20|0)>>2]=~~g;if(s){Ba=235;break m}else{x=s;q=t}}while(0);if((Ba|0)==224){Ba=0;k[Da+4+(y*20|0)>>2]=t;if(s){Ba=235;break}else x=s}o:do if((k[q>>2]&7|0)==5){w=k[q+8>>2]|0;v=k[w+24>>2]|0;if(v>>>0<=1){s=1-v|0;if(s>>>0<v>>>0)Ba=229;else s=0}else{s=1;Ba=229}if((Ba|0)==229){Ba=0;t=k[w+52>>2]|0;do if((s<<1|0)>(v|0)){do{t=k[t>>2]|0;v=v-(k[t+12>>2]|0)|0}while((s|0)<(v|0));s=s-v|0}else{v=k[t+12>>2]|0;if((s|0)<(v|0))break;do{t=k[t+4>>2]|0;s=s-v|0;v=k[t+12>>2]|0}while((s|0)>=(v|0))}while(0);s=(k[t+16>>2]|0)+(aa(k[w+28>>2]|0,s)|0)|0}p:do if(s){switch(k[s>>2]&7){case 1:{k[Da+4+(y*20|0)+4>>2]=k[s+8>>2];if(x){Ba=254;break m}else break o}case 2:break;default:{s=x;t=2147483647;break p}}g=+p[s+8>>3];p[u>>3]=g;s=k[u+4>>2]|0;L=s&2146435072;do if(!(L>>>0>1126170624|(L|0)==1126170624&0>0)){s=(s|0)<0;g=s?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(!(g==0.0))break;g=s?-0.0:0.0}while(0);k[Da+4+(y*20|0)+4>>2]=~~g;if(x){Ba=254;break m}else break o}else{s=x;t=0}while(0);k[Da+4+(y*20|0)+4>>2]=t;if(s){Ba=254;break m}else x=s}else k[Da+4+(y*20|0)+4>>2]=0;while(0);q:do if((k[q>>2]&7|0)==5){w=k[q+8>>2]|0;v=k[w+24>>2]|0;if(v>>>0<=2){s=2-v|0;if(s>>>0<v>>>0)Ba=248;else s=0}else{s=2;Ba=248}if((Ba|0)==248){Ba=0;t=k[w+52>>2]|0;do if((s<<1|0)>(v|0)){do{t=k[t>>2]|0;v=v-(k[t+12>>2]|0)|0}while((s|0)<(v|0));s=s-v|0}else{v=k[t+12>>2]|0;if((s|0)<(v|0))break;do{t=k[t+4>>2]|0;s=s-v|0;v=k[t+12>>2]|0}while((s|0)>=(v|0))}while(0);s=(k[t+16>>2]|0)+(aa(k[w+28>>2]|0,s)|0)|0}r:do if(s){switch(k[s>>2]&7){case 1:{k[Da+4+(y*20|0)+8>>2]=k[s+8>>2];if(x){Ba=273;break m}else break q}case 2:break;default:{s=x;t=2147483647;break r}}g=+p[s+8>>3];p[u>>3]=g;s=k[u+4>>2]|0;L=s&2146435072;do if(!(L>>>0>1126170624|(L|0)==1126170624&0>0)){s=(s|0)<0;g=s?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(!(g==0.0))break;g=s?-0.0:0.0}while(0);k[Da+4+(y*20|0)+8>>2]=~~g;if(x){Ba=273;break m}else break q}else{s=x;t=0}while(0);k[Da+4+(y*20|0)+8>>2]=t;if(s){Ba=273;break m}else x=s}else k[Da+4+(y*20|0)+8>>2]=0;while(0);s:do if((k[q>>2]&7|0)==5){w=k[q+8>>2]|0;v=k[w+24>>2]|0;if(v>>>0<=3){s=3-v|0;if(s>>>0<v>>>0)Ba=267;else s=0}else{s=3;Ba=267}if((Ba|0)==267){Ba=0;t=k[w+52>>2]|0;do if((s<<1|0)>(v|0)){do{t=k[t>>2]|0;v=v-(k[t+12>>2]|0)|0}while((s|0)<(v|0));s=s-v|0}else{v=k[t+12>>2]|0;if((s|0)<(v|0))break;do{t=k[t+4>>2]|0;s=s-v|0;v=k[t+12>>2]|0}while((s|0)>=(v|0))}while(0);s=(k[t+16>>2]|0)+(aa(k[w+28>>2]|0,s)|0)|0}t:do if(s){switch(k[s>>2]&7){case 1:{k[Da+4+(y*20|0)+12>>2]=k[s+8>>2];if(x){g=0.0;break m}else break s}case 2:break;default:{s=x;t=2147483647;break t}}g=+p[s+8>>3];p[u>>3]=g;s=k[u+4>>2]|0;L=s&2146435072;do if(!(L>>>0>1126170624|(L|0)==1126170624&0>0)){s=(s|0)<0;g=s?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(!(g==0.0))break;g=s?-0.0:0.0}while(0);k[Da+4+(y*20|0)+12>>2]=~~g;if(x){g=0.0;break m}else break s}else{s=x;t=0}while(0);k[Da+4+(y*20|0)+12>>2]=t;if(s){g=0.0;break m}}else k[Da+4+(y*20|0)+12>>2]=0;while(0);if((k[q>>2]&7|0)!=5){g=0.0;break}v=k[q+8>>2]|0;t=k[v+24>>2]|0;if(t>>>0<=4){q=4-t|0;if(q>>>0<t>>>0)Ba=285;else q=0}else{q=4;Ba=285}if((Ba|0)==285){Ba=0;s=k[v+52>>2]|0;do if((q<<1|0)>(t|0)){do{s=k[s>>2]|0;t=t-(k[s+12>>2]|0)|0}while((q|0)<(t|0));q=q-t|0}else{t=k[s+12>>2]|0;if((q|0)<(t|0))break;do{s=k[s+4>>2]|0;q=q-t|0;t=k[s+12>>2]|0}while((q|0)>=(t|0))}while(0);q=(k[s+16>>2]|0)+(aa(k[v+28>>2]|0,q)|0)|0}if(!q){g=0.0;break}switch(k[q>>2]&7){case 1:{g=+(k[q+8>>2]|0);break m}case 2:{g=+p[q+8>>3];break m}default:{g=1000000015047466219876688.0e6;break m}}}while(0);if((Ba|0)==216){k[Da+4+(y*20|0)>>2]=0;Ba=235}if((Ba|0)==235){k[Da+4+(y*20|0)+4>>2]=0;Ba=254}if((Ba|0)==254){k[Da+4+(y*20|0)+8>>2]=0;Ba=273}if((Ba|0)==273){Ba=0;k[Da+4+(y*20|0)+12>>2]=0;g=0.0}o[Da+4+(y*20|0)+16>>2]=g;y=y+1|0}while((y|0)!=(z|0))}s=d;do if((s|0)==(c|0)){d=E+1|0;if(d>>>0>67108863){Ba=299;break f}w=e;L=c-e|0;t=L>>5;t=L>>6>>>0<33554431?(t>>>0<d>>>0?d:t):67108863;if(!t)d=0;else{if(t>>>0>67108863){Ba=302;break f}d=t<<6;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c}q=d+(E<<6)|0;c=d+(t<<6)|0;i[q>>0]=i[Da>>0]|0;k[d+(E<<6)+4>>2]=k[ba>>2];k[d+(E<<6)+8>>2]=k[ca>>2];k[d+(E<<6)+12>>2]=k[da>>2];k[d+(E<<6)+16>>2]=k[ea>>2];k[d+(E<<6)+20>>2]=k[fa>>2];k[d+(E<<6)+24>>2]=k[ga>>2];k[d+(E<<6)+28>>2]=k[ha>>2];k[d+(E<<6)+32>>2]=k[ia>>2];k[d+(E<<6)+36>>2]=k[ja>>2];k[d+(E<<6)+40>>2]=k[ka>>2];k[d+(E<<6)+44>>2]=k[la>>2];k[d+(E<<6)+48>>2]=k[ma>>2];k[d+(E<<6)+52>>2]=k[na>>2];k[d+(E<<6)+56>>2]=k[oa>>2];k[d+(E<<6)+60>>2]=k[pa>>2];d=q+64|0;if((s|0)!=(w|0)){v=s+-64|0;t=q;while(1){L=s;s=s+-64|0;i[t+-64>>0]=i[s>>0]|0;k[t+-60>>2]=k[L+-60>>2];k[t+-56>>2]=k[L+-56>>2];k[t+-52>>2]=k[L+-52>>2];k[t+-48>>2]=k[L+-48>>2];k[t+-44>>2]=k[L+-44>>2];k[t+-40>>2]=k[L+-40>>2];k[t+-36>>2]=k[L+-36>>2];k[t+-32>>2]=k[L+-32>>2];k[t+-28>>2]=k[L+-28>>2];k[t+-24>>2]=k[L+-24>>2];k[t+-20>>2]=k[L+-20>>2];k[t+-16>>2]=k[L+-16>>2];k[t+-12>>2]=k[L+-12>>2];k[t+-8>>2]=k[L+-8>>2];k[t+-4>>2]=k[L+-4>>2];if((s|0)==(w|0))break;else t=t+-64|0}q=q+(~((v-e|0)>>>6)<<6)|0}if(!e){e=q;break}ggb(w);e=q}else{i[s>>0]=i[Da>>0]|0;k[s+4>>2]=k[ba>>2];k[s+8>>2]=k[ca>>2];k[s+12>>2]=k[da>>2];k[s+16>>2]=k[ea>>2];k[s+20>>2]=k[fa>>2];k[s+24>>2]=k[ga>>2];k[s+28>>2]=k[ha>>2];k[s+32>>2]=k[ia>>2];k[s+36>>2]=k[ja>>2];k[s+40>>2]=k[ka>>2];k[s+44>>2]=k[la>>2];k[s+48>>2]=k[ma>>2];k[s+52>>2]=k[na>>2];k[s+56>>2]=k[oa>>2];k[s+60>>2]=k[pa>>2];d=s+64|0}while(0);q=k6(n,j,393853)|0;u:do if(!q)J=0.0;else switch(k[q>>2]&7){case 1:{J=+(k[q+8>>2]|0);break u}case 2:{J=+p[q+8>>3];break u}default:{J=1000000015047466219876688.0e6;break u}}while(0);q=k6(n,j,380596)|0;v:do if(!q){q=k6(n,j,380586)|0;if(!q){t=0;break}switch(k[q>>2]&7){case 1:{t=k[q+8>>2]|0;break v}case 2:break;default:{t=2147483647;break v}}g=+p[q+8>>3];p[u>>3]=g;q=k[u+4>>2]|0;L=q&2146435072;do if(!(L>>>0>1126170624|(L|0)==1126170624&0>0)){q=(q|0)<0;g=q?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(!(g==0.0))break;g=q?-0.0:0.0}while(0);t=~~g}else{s=k[Q>>2]|0;t=0-(s-(k[O>>2]|0)>>2)|0;v=s;switch(k[q>>2]&7){case 1:{g=+(k[q+8>>2]|0);break}case 2:{g=+p[q+8>>3];break}default:g=1000000015047466219876688.0e6}o[Ha>>2]=g;if((v|0)==(k[G>>2]|0))MAa(O,Ha);else{o[s>>2]=g;k[Q>>2]=v+4}}while(0);s=k6(n,j,380616)|0;w:do if(!s){j=k6(n,j,380605)|0;if(!j){n=0;break}switch(k[j>>2]&7){case 1:{n=k[j+8>>2]|0;break w}case 2:break;default:{n=2147483647;break w}}g=+p[j+8>>3];p[u>>3]=g;j=k[u+4>>2]|0;L=j&2146435072;do if(!(L>>>0>1126170624|(L|0)==1126170624&0>0)){j=(j|0)<0;g=j?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(!(g==0.0))break;g=j?-0.0:0.0}while(0);n=~~g}else{j=k[Q>>2]|0;n=0-(j-(k[O>>2]|0)>>2)|0;q=j;switch(k[s>>2]&7){case 1:{g=+(k[s+8>>2]|0);break}case 2:{g=+p[s+8>>3];break}default:g=1000000015047466219876688.0e6}o[Ha>>2]=g;if((q|0)==(k[G>>2]|0))MAa(O,Ha);else{o[j>>2]=g;k[Q>>2]=q+4}}while(0);j=k[I>>2]|0;L=k[M>>2]|0;q=L;do if((j|0)==(L|0)){y=k[N>>2]|0;x=j-y|0;w=x>>4;j=w+1|0;if(j>>>0>268435455){Ba=351;break f}L=q-y|0;v=L>>3;v=L>>4>>>0<134217727?(v>>>0<j>>>0?j:v):268435455;if(!v)s=0;else{if(v>>>0>268435455){Ba=354;break f}q=v<<4;q=(q|0)==0?1:q;while(1){j=fgb(q)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}s=j}q=s+(w<<4)|0;k[q>>2]=E;k[s+(w<<4)+4>>2]=t;k[s+(w<<4)+8>>2]=n;o[s+(w<<4)+12>>2]=J;j=q+(0-w<<4)|0;if((x|0)>0)upb(j|0,y|0,x|0)|0;k[N>>2]=j;k[I>>2]=q+16;k[M>>2]=s+(v<<4);if(!y)break;ggb(y)}else{k[j>>2]=E;k[j+4>>2]=t;k[j+8>>2]=n;o[j+12>>2]=J;k[I>>2]=(k[I>>2]|0)+16}while(0);F=F+1|0}while((F|0)<(R|0))}S=S+1|0}while((S|0)<(W|0))}else{e=A;c=B}_=_+1|0;if((_|0)>=(za|0)){Ea=e;ua=d;Aa=1;break e}else{A=e;B=c}}if((Ba|0)==98)ad(426534,426557,304,426811);else if((Ba|0)==101){Ka=te(4)|0;k[Ka>>2]=172664;Cf(Ka|0,28816,1287)}else if((Ba|0)==113)ad(426534,426557,304,426811);else if((Ba|0)==299)ad(426534,426557,304,426811);else if((Ba|0)==302){Ka=te(4)|0;k[Ka>>2]=172664;Cf(Ka|0,28816,1287)}else if((Ba|0)==351)ad(426534,426557,304,426811);else if((Ba|0)==354){Ka=te(4)|0;k[Ka>>2]=172664;Cf(Ka|0,28816,1287)}}else{Ea=0;ua=0;Aa=0}while(0);k[Da>>2]=0;ta=Da+4|0;k[ta>>2]=0;x6(Ha,b,1,Da);k[ta>>2]=0;k[Da>>2]=0;ta=k[Ha+8>>2]|0;if((ta|0)!=0?(i[ta+272>>0]|0)!=0:0){M=ua-Ea|0;N=M>>6;if(Aa){d=k[Fa>>2]|0;a=0;c=0;do{ua=((k[d+(c*24|0)+12>>2]|0)-(k[d+(c*24|0)+8>>2]|0)|0)/24|0;a=(a|0)<(ua|0)?ua:a;c=c+1|0}while((c|0)!=(za|0));e=a}else e=0;k[Da>>2]=0;ua=Da+4|0;k[ua>>2]=0;a=ZT(12)|0;k[a>>2]=1;c=a+4|0;k[Da>>2]=c;k[ua>>2]=7;i[a+11>>0]=0;i[c>>0]=i[380170]|0;i[c+1>>0]=i[380171]|0;i[c+2>>0]=i[380172]|0;i[c+3>>0]=i[380173]|0;i[c+4>>0]=i[380174]|0;i[c+5>>0]=i[380175]|0;i[c+6>>0]=i[380176]|0;c=z6(Ha,Da)|0;a=k[Da>>2]|0;k[ua>>2]=0;k[Da>>2]=0;if(a|0?(ta=a+-4|0,ua=k[ta>>2]|0,k[ta>>2]=ua+-1,(ua|0)==1):0)ggb(k[a+-8>>2]|0);k[Da>>2]=0;d=Da+4|0;k[d>>2]=0;m=ZT(32)|0;k[m>>2]=1;K=m+4|0;k[Da>>2]=K;k[d>>2]=27;i[m+31>>0]=0;m=380178;L=K+27|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));c=z6(c,Da)|0;a=k[Da>>2]|0;k[d>>2]=0;k[Da>>2]=0;if(a|0?(ta=a+-4|0,ua=k[ta>>2]|0,k[ta>>2]=ua+-1,(ua|0)==1):0)ggb(k[a+-8>>2]|0);k[Da>>2]=0;d=Da+4|0;k[d>>2]=0;m=ZT(16)|0;k[m>>2]=1;K=m+4|0;k[Da>>2]=K;k[d>>2]=9;i[m+13>>0]=0;m=380206;L=K+9|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));a=z6(c,Da)|0;c=k[Da>>2]|0;k[d>>2]=0;k[Da>>2]=0;if(c|0?(ta=c+-4|0,ua=k[ta>>2]|0,k[ta>>2]=ua+-1,(ua|0)==1):0)ggb(k[c+-8>>2]|0);k[Da>>2]=0;ua=Da+4|0;k[ua>>2]=0;ta=ZT(12)|0;k[ta>>2]=1;c=ta+4|0;k[Da>>2]=c;k[ua>>2]=5;i[ta+9>>0]=0;i[c>>0]=i[380216]|0;i[c+1>>0]=i[380217]|0;i[c+2>>0]=i[380218]|0;i[c+3>>0]=i[380219]|0;i[c+4>>0]=i[380220]|0;c=z6(a,Da)|0;a=k[Da>>2]|0;k[ua>>2]=0;k[Da>>2]=0;do if(a|0){ta=a+-4|0;ua=k[ta>>2]|0;k[ta>>2]=ua+-1;if((ua|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);k[Da>>2]=0;d=Da+4|0;k[d>>2]=0;m=ZT(16)|0;k[m>>2]=1;K=m+4|0;k[Da>>2]=K;k[d>>2]=11;i[m+15>>0]=0;m=380222;L=K+11|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));a=z6(c,Da)|0;c=k[Da>>2]|0;k[d>>2]=0;k[Da>>2]=0;do if(c|0){ta=c+-4|0;ua=k[ta>>2]|0;k[ta>>2]=ua+-1;if((ua|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;ua=Da+4|0;k[ua>>2]=0;ta=ZT(12)|0;k[ta>>2]=1;c=ta+4|0;k[Da>>2]=c;k[ua>>2]=4;i[ta+8>>0]=0;i[c>>0]=72;i[c+1>>0]=65;i[c+2>>0]=65;i[c+3>>0]=82;a=z6(a,Da)|0;c=k[Da>>2]|0;k[ua>>2]=0;k[Da>>2]=0;do if(c|0){ta=c+-4|0;ua=k[ta>>2]|0;k[ta>>2]=ua+-1;if((ua|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;ua=Da+4|0;k[ua>>2]=0;ta=ZT(12)|0;k[ta>>2]=1;c=ta+4|0;k[Da>>2]=c;k[ua>>2]=6;i[ta+10>>0]=0;i[c>>0]=i[380234]|0;i[c+1>>0]=i[380235]|0;i[c+2>>0]=i[380236]|0;i[c+3>>0]=i[380237]|0;i[c+4>>0]=i[380238]|0;i[c+5>>0]=i[380239]|0;a=z6(a,Da)|0;c=k[Da>>2]|0;k[ua>>2]=0;k[Da>>2]=0;do if(c|0){ta=c+-4|0;ua=k[ta>>2]|0;k[ta>>2]=ua+-1;if((ua|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);a=nSa(a,wa)|0;k[Da>>2]=0;wa=Da+4|0;k[wa>>2]=0;ua=ZT(12)|0;k[ua>>2]=1;c=ua+4|0;k[Da>>2]=c;k[wa>>2]=5;i[ua+9>>0]=0;i[c>>0]=i[380241]|0;i[c+1>>0]=i[380242]|0;i[c+2>>0]=i[380243]|0;i[c+3>>0]=i[380244]|0;i[c+4>>0]=i[380245]|0;a=z6(a,Da)|0;c=k[Da>>2]|0;k[wa>>2]=0;k[Da>>2]=0;do if(c|0){ua=c+-4|0;wa=k[ua>>2]|0;k[ua>>2]=wa+-1;if((wa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);a=nSa(a,va)|0;k[Da>>2]=0;d=Da+4|0;k[d>>2]=0;m=ZT(16)|0;k[m>>2]=1;K=m+4|0;k[Da>>2]=K;k[d>>2]=11;i[m+15>>0]=0;m=380247;L=K+11|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));a=z6(a,Da)|0;c=k[Da>>2]|0;k[d>>2]=0;k[Da>>2]=0;do if(c|0){va=c+-4|0;wa=k[va>>2]|0;k[va>>2]=wa+-1;if((wa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;wa=Da+4|0;k[wa>>2]=0;va=ZT(8)|0;k[va>>2]=1;c=va+4|0;k[Da>>2]=c;k[wa>>2]=1;i[va+5>>0]=0;i[c>>0]=123;c=z6(a,Da)|0;a=k[Da>>2]|0;k[wa>>2]=0;k[Da>>2]=0;do if(a|0){va=a+-4|0;wa=k[va>>2]|0;k[va>>2]=wa+-1;if((wa|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);k[Da>>2]=0;d=Da+4|0;k[d>>2]=0;m=ZT(20)|0;k[m>>2]=1;K=m+4|0;k[Da>>2]=K;k[d>>2]=12;i[m+16>>0]=0;m=380259;L=K+12|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));a=z6(c,Da)|0;c=k[Da>>2]|0;k[d>>2]=0;k[Da>>2]=0;do if(c|0){va=c+-4|0;wa=k[va>>2]|0;k[va>>2]=wa+-1;if((wa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Ca>>2]=e;c=nSa(a,Ca)|0;k[Da>>2]=0;wa=Da+4|0;k[wa>>2]=0;va=ZT(8)|0;k[va>>2]=1;a=va+4|0;k[Da>>2]=a;k[wa>>2]=1;i[va+5>>0]=0;i[a>>0]=125;c=z6(c,Da)|0;a=k[Da>>2]|0;k[wa>>2]=0;k[Da>>2]=0;do if(a|0){va=a+-4|0;wa=k[va>>2]|0;k[va>>2]=wa+-1;if((wa|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);k[Da>>2]=0;d=Da+4|0;k[d>>2]=0;m=ZT(20)|0;k[m>>2]=1;K=m+4|0;k[Da>>2]=K;k[d>>2]=13;i[m+17>>0]=0;m=380272;L=K+13|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));a=z6(c,Da)|0;c=k[Da>>2]|0;k[d>>2]=0;k[Da>>2]=0;do if(c|0){va=c+-4|0;wa=k[va>>2]|0;k[va>>2]=wa+-1;if((wa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;wa=Da+4|0;k[wa>>2]=0;va=ZT(8)|0;k[va>>2]=1;c=va+4|0;k[Da>>2]=c;k[wa>>2]=1;i[va+5>>0]=0;i[c>>0]=123;c=z6(a,Da)|0;a=k[Da>>2]|0;k[wa>>2]=0;k[Da>>2]=0;do if(a|0){va=a+-4|0;wa=k[va>>2]|0;k[va>>2]=wa+-1;if((wa|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);k[Da>>2]=0;d=Da+4|0;k[d>>2]=0;m=ZT(16)|0;k[m>>2]=1;K=m+4|0;k[Da>>2]=K;k[d>>2]=11;i[m+15>>0]=0;m=380286;L=K+11|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));a=z6(c,Da)|0;c=k[Da>>2]|0;k[d>>2]=0;k[Da>>2]=0;do if(c|0){va=c+-4|0;wa=k[va>>2]|0;k[va>>2]=wa+-1;if((wa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[xa>>2]=0;a=nSa(a,xa)|0;k[Da>>2]=0;xa=Da+4|0;k[xa>>2]=0;wa=ZT(8)|0;k[wa>>2]=1;c=wa+4|0;k[Da>>2]=c;k[xa>>2]=1;i[wa+5>>0]=0;i[c>>0]=125;a=z6(a,Da)|0;c=k[Da>>2]|0;k[xa>>2]=0;k[Da>>2]=0;do if(c|0){wa=c+-4|0;xa=k[wa>>2]|0;k[wa>>2]=xa+-1;if((xa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;xa=Da+4|0;k[xa>>2]=0;wa=ZT(16)|0;k[wa>>2]=1;c=wa+4|0;k[Da>>2]=c;k[xa>>2]=8;i[wa+12>>0]=0;wa=c;i[wa>>0]=115;i[wa+1>>0]=116;i[wa+2>>0]=97;i[wa+3>>0]=103;c=c+4|0;i[c>>0]=101;i[c+1>>0]=78;i[c+2>>0]=117;i[c+3>>0]=109;a=z6(a,Da)|0;c=k[Da>>2]|0;k[xa>>2]=0;k[Da>>2]=0;do if(c|0){wa=c+-4|0;xa=k[wa>>2]|0;k[wa>>2]=xa+-1;if((xa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[ya>>2]=za;a=nSa(a,ya)|0;k[Da>>2]=0;ya=Da+4|0;k[ya>>2]=0;xa=ZT(12)|0;k[xa>>2]=1;c=xa+4|0;k[Da>>2]=c;k[ya>>2]=6;i[xa+10>>0]=0;i[c>>0]=i[380517]|0;i[c+1>>0]=i[380518]|0;i[c+2>>0]=i[380519]|0;i[c+3>>0]=i[380520]|0;i[c+4>>0]=i[380521]|0;i[c+5>>0]=i[380522]|0;a=z6(a,Da)|0;c=k[Da>>2]|0;k[ya>>2]=0;k[Da>>2]=0;do if(c|0){xa=c+-4|0;ya=k[xa>>2]|0;k[xa>>2]=ya+-1;if((ya|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;ya=Da+4|0;k[ya>>2]=0;wa=ZT(8)|0;k[wa>>2]=1;xa=wa+4|0;k[Da>>2]=xa;k[ya>>2]=1;i[wa+5>>0]=0;i[xa>>0]=91;z6(a,Da)|0;a=k[Da>>2]|0;k[ya>>2]=0;k[Da>>2]=0;do if(a|0){xa=a+-4|0;ya=k[xa>>2]|0;k[xa>>2]=ya+-1;if((ya|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);if(Aa){s=Da+4|0;t=Da+4|0;v=Da+4|0;w=Da+4|0;x=Da+4|0;y=Da+4|0;z=Da+4|0;A=Da+4|0;B=Da+4|0;C=Da+4|0;D=Da+4|0;E=Da+4|0;F=Da+4|0;G=Da+4|0;H=Da+4|0;I=Da+4|0;q=0;do{f=k[Fa>>2]|0;f=(k[f+(q*24|0)+12>>2]|0)-(k[f+(q*24|0)+8>>2]|0)|0;n=(f|0)/24|0;k[Da>>2]=0;k[s>>2]=0;a=ZT(8)|0;k[a>>2]=1;c=a+4|0;k[Da>>2]=c;k[s>>2]=1;i[a+5>>0]=0;i[c>>0]=123;c=z6(Ha,Da)|0;a=k[Da>>2]|0;k[s>>2]=0;k[Da>>2]=0;do if(a|0){ya=a+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);k[Da>>2]=0;k[t>>2]=0;m=ZT(20)|0;k[m>>2]=1;K=m+4|0;k[Da>>2]=K;k[t>>2]=12;i[m+16>>0]=0;m=380259;L=K+12|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));a=z6(c,Da)|0;c=k[Da>>2]|0;k[t>>2]=0;k[Da>>2]=0;do if(c|0){ya=c+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Ca>>2]=n;a=nSa(a,Ca)|0;k[Da>>2]=0;k[v>>2]=0;m=ZT(20)|0;k[m>>2]=1;K=m+4|0;k[Da>>2]=K;k[v>>2]=14;i[m+18>>0]=0;m=380298;L=K+14|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));e=z6(a,Da)|0;a=k[Da>>2]|0;k[v>>2]=0;k[Da>>2]=0;do if(a|0){ya=a+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);c=(k[Fa>>2]|0)+(q*24|0)|0;do if(Xh[k[(k[e>>2]|0)+12>>2]&1023](e)|0){d=e+32|0;if((k[d>>2]|0)==6){k[Da>>2]=0;k[w>>2]=0;a=ZT(36)|0;k[a>>2]=1;K=a+4|0;k[Da>>2]=K;k[w>>2]=30;i[a+34>>0]=0;m=401220;L=K+30|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));Y8(-2,Da,401251,401262,1064);k[w>>2]=0;k[Da>>2]=0;Aa=k[a>>2]|0;k[a>>2]=Aa+-1;if((Aa|0)==1)ggb(k[a+-4>>2]|0)}if(!(k[e+16>>2]|0))a=0;else{a=k[e+12>>2]|0;a=(a|0)==0?1016759:a}u6(k[e+8>>2]|0,a,+p[c>>3]);if(!(k[d>>2]&4))break;k[d>>2]=6}while(0);k[Da>>2]=0;k[x>>2]=0;m=ZT(20)|0;k[m>>2]=1;K=m+4|0;k[Da>>2]=K;k[x>>2]=15;i[m+19>>0]=0;m=380313;L=K+15|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));a=z6(e,Da)|0;c=k[Da>>2]|0;k[x>>2]=0;k[Da>>2]=0;do if(c|0){ya=c+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;k[y>>2]=0;ya=ZT(8)|0;k[ya>>2]=1;Aa=ya+4|0;k[Da>>2]=Aa;k[y>>2]=1;i[ya+5>>0]=0;i[Aa>>0]=91;z6(a,Da)|0;a=k[Da>>2]|0;k[y>>2]=0;k[Da>>2]=0;do if(a|0){ya=a+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);if((f|0)>0){l=0;do{e=k[(k[Fa>>2]|0)+(q*24|0)+8>>2]|0;f=e+(l*24|0)|0;k[Da>>2]=0;k[z>>2]=0;a=ZT(8)|0;k[a>>2]=1;c=a+4|0;k[Da>>2]=c;k[z>>2]=1;i[a+5>>0]=0;i[c>>0]=123;c=z6(Ha,Da)|0;a=k[Da>>2]|0;k[z>>2]=0;k[Da>>2]=0;do if(a|0){ya=a+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);k[Da>>2]=0;k[A>>2]=0;m=ZT(20)|0;k[m>>2]=1;K=m+4|0;k[Da>>2]=K;k[A>>2]=13;i[m+17>>0]=0;m=380329;L=K+13|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));a=z6(c,Da)|0;c=k[Da>>2]|0;k[A>>2]=0;k[Da>>2]=0;do if(c|0){ya=c+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;k[B>>2]=0;ya=ZT(8)|0;k[ya>>2]=1;Aa=ya+4|0;k[Da>>2]=Aa;k[B>>2]=1;i[ya+5>>0]=0;i[Aa>>0]=91;z6(a,Da)|0;a=k[Da>>2]|0;k[B>>2]=0;k[Da>>2]=0;do if(a|0){ya=a+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);c=k[f>>2]|0;Aa=(k[e+(l*24|0)+4>>2]|0)-c|0;d=Aa>>4;j=e+(l*24|0)+12|0;e=(k[e+(l*24|0)+16>>2]|0)-(k[j>>2]|0)|0;h=e>>2;x:do if((Aa|0)>0){a=0;while(1){Aa=nSa(Ha,c+(a<<4)+4|0)|0;Aa=nSa(Aa,(k[f>>2]|0)+(a<<4)+8|0)|0;Aa=nSa(Aa,(k[f>>2]|0)+(a<<4)|0)|0;oSa(Aa,(k[f>>2]|0)+(a<<4)+12|0)|0;a=a+1|0;if((a|0)>=(d|0))break x;c=k[f>>2]|0}}while(0);k[Da>>2]=0;k[C>>2]=0;a=ZT(8)|0;k[a>>2]=1;c=a+4|0;k[Da>>2]=c;k[C>>2]=1;i[a+5>>0]=0;i[c>>0]=93;c=z6(Ha,Da)|0;a=k[Da>>2]|0;k[C>>2]=0;k[Da>>2]=0;do if(a|0){ya=a+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);k[Da>>2]=0;k[D>>2]=0;m=ZT(16)|0;k[m>>2]=1;K=m+4|0;k[Da>>2]=K;k[D>>2]=10;i[m+14>>0]=0;m=380343;L=K+10|0;do{i[K>>0]=i[m>>0]|0;K=K+1|0;m=m+1|0}while((K|0)<(L|0));a=z6(c,Da)|0;c=k[Da>>2]|0;k[D>>2]=0;k[Da>>2]=0;do if(c|0){ya=c+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;k[E>>2]=0;ya=ZT(8)|0;k[ya>>2]=1;Aa=ya+4|0;k[Da>>2]=Aa;k[E>>2]=1;i[ya+5>>0]=0;i[Aa>>0]=91;z6(a,Da)|0;a=k[Da>>2]|0;k[E>>2]=0;k[Da>>2]=0;do if(a|0){ya=a+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);if((e|0)>0){a=0;do{oSa(Ha,(k[j>>2]|0)+(a<<2)|0)|0;a=a+1|0}while((a|0)<(h|0))}k[Da>>2]=0;k[F>>2]=0;c=ZT(8)|0;k[c>>2]=1;a=c+4|0;k[Da>>2]=a;k[F>>2]=1;i[c+5>>0]=0;i[a>>0]=93;a=z6(Ha,Da)|0;c=k[Da>>2]|0;k[F>>2]=0;k[Da>>2]=0;do if(c|0){ya=c+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;k[I>>2]=0;ya=ZT(8)|0;k[ya>>2]=1;Aa=ya+4|0;k[Da>>2]=Aa;k[I>>2]=1;i[ya+5>>0]=0;i[Aa>>0]=125;z6(a,Da)|0;a=k[Da>>2]|0;k[I>>2]=0;k[Da>>2]=0;do if(a|0){ya=a+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);l=l+1|0}while((l|0)<(n|0))}k[Da>>2]=0;k[G>>2]=0;c=ZT(8)|0;k[c>>2]=1;a=c+4|0;k[Da>>2]=a;k[G>>2]=1;i[c+5>>0]=0;i[a>>0]=93;a=z6(Ha,Da)|0;c=k[Da>>2]|0;k[G>>2]=0;k[Da>>2]=0;do if(c|0){ya=c+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;k[H>>2]=0;ya=ZT(8)|0;k[ya>>2]=1;Aa=ya+4|0;k[Da>>2]=Aa;k[H>>2]=1;i[ya+5>>0]=0;i[Aa>>0]=125;z6(a,Da)|0;a=k[Da>>2]|0;k[H>>2]=0;k[Da>>2]=0;do if(a|0){ya=a+-4|0;Aa=k[ya>>2]|0;k[ya>>2]=Aa+-1;if((Aa|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);q=q+1|0}while((q|0)<(za|0))}k[Da>>2]=0;Ca=Da+4|0;k[Ca>>2]=0;c=ZT(8)|0;k[c>>2]=1;a=c+4|0;k[Da>>2]=a;k[Ca>>2]=1;i[c+5>>0]=0;i[a>>0]=93;a=z6(Ha,Da)|0;c=k[Da>>2]|0;k[Ca>>2]=0;k[Da>>2]=0;do if(c|0){Aa=c+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;Ca=Da+4|0;k[Ca>>2]=0;Aa=ZT(16)|0;k[Aa>>2]=1;c=Aa+4|0;k[Da>>2]=c;k[Ca>>2]=8;i[Aa+12>>0]=0;Aa=c;i[Aa>>0]=102;i[Aa+1>>0]=101;i[Aa+2>>0]=97;i[Aa+3>>0]=116;c=c+4|0;i[c>>0]=117;i[c+1>>0]=114;i[c+2>>0]=101;i[c+3>>0]=115;a=z6(a,Da)|0;c=k[Da>>2]|0;k[Ca>>2]=0;k[Da>>2]=0;do if(c|0){Aa=c+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;Ca=Da+4|0;k[Ca>>2]=0;za=ZT(8)|0;k[za>>2]=1;Aa=za+4|0;k[Da>>2]=Aa;k[Ca>>2]=1;i[za+5>>0]=0;i[Aa>>0]=91;z6(a,Da)|0;a=k[Da>>2]|0;k[Ca>>2]=0;k[Da>>2]=0;do if(a|0){Aa=a+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);if((M|0)>0){f=Da+4|0;h=Da+4|0;j=Da+4|0;l=Da+4|0;m=Da+4|0;n=Da+4|0;q=Da+4|0;s=Da+4|0;t=Da+4|0;v=Da+4|0;w=Da+4|0;x=Da+4|0;y=Ea;e=0;do{k[Da>>2]=0;k[f>>2]=0;c=ZT(8)|0;k[c>>2]=1;a=c+4|0;k[Da>>2]=a;k[f>>2]=1;i[c+5>>0]=0;i[a>>0]=123;a=z6(Ha,Da)|0;c=k[Da>>2]|0;k[f>>2]=0;k[Da>>2]=0;do if(c|0){Aa=c+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;k[h>>2]=0;Ca=ZT(12)|0;k[Ca>>2]=1;c=Ca+4|0;k[Da>>2]=c;k[h>>2]=5;i[Ca+9>>0]=0;i[c>>0]=i[380573]|0;i[c+1>>0]=i[380574]|0;i[c+2>>0]=i[380575]|0;i[c+3>>0]=i[380576]|0;i[c+4>>0]=i[380577]|0;a=z6(a,Da)|0;c=k[Da>>2]|0;k[h>>2]=0;k[Da>>2]=0;do if(c|0){Aa=c+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;k[j>>2]=0;Aa=ZT(8)|0;k[Aa>>2]=1;Ca=Aa+4|0;k[Da>>2]=Ca;k[j>>2]=1;i[Aa+5>>0]=0;i[Ca>>0]=91;z6(a,Da)|0;a=k[Da>>2]|0;k[j>>2]=0;k[Da>>2]=0;do if(a|0){Aa=a+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);k[Da>>2]=0;k[l>>2]=0;c=ZT(8)|0;k[c>>2]=1;a=c+4|0;k[Da>>2]=a;k[l>>2]=1;i[c+5>>0]=0;i[a>>0]=91;a=z6(Ha,Da)|0;c=k[Da>>2]|0;k[l>>2]=0;k[Da>>2]=0;do if(c|0){Aa=c+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);a=oSa(nSa(nSa(nSa(nSa(a,y+(e<<6)+4|0)|0,y+(e<<6)+8|0)|0,y+(e<<6)+12|0)|0,y+(e<<6)+16|0)|0,y+(e<<6)+20|0)|0;k[Da>>2]=0;k[m>>2]=0;Aa=ZT(8)|0;k[Aa>>2]=1;Ca=Aa+4|0;k[Da>>2]=Ca;k[m>>2]=1;i[Aa+5>>0]=0;i[Ca>>0]=93;z6(a,Da)|0;a=k[Da>>2]|0;k[m>>2]=0;k[Da>>2]=0;do if(a|0){Aa=a+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);k[Da>>2]=0;k[n>>2]=0;c=ZT(8)|0;k[c>>2]=1;a=c+4|0;k[Da>>2]=a;k[n>>2]=1;i[c+5>>0]=0;i[a>>0]=91;a=z6(Ha,Da)|0;c=k[Da>>2]|0;k[n>>2]=0;k[Da>>2]=0;do if(c|0){Aa=c+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);a=oSa(nSa(nSa(nSa(nSa(a,y+(e<<6)+24|0)|0,y+(e<<6)+28|0)|0,y+(e<<6)+32|0)|0,y+(e<<6)+36|0)|0,y+(e<<6)+40|0)|0;k[Da>>2]=0;k[q>>2]=0;Aa=ZT(8)|0;k[Aa>>2]=1;Ca=Aa+4|0;k[Da>>2]=Ca;k[q>>2]=1;i[Aa+5>>0]=0;i[Ca>>0]=93;z6(a,Da)|0;a=k[Da>>2]|0;k[q>>2]=0;k[Da>>2]=0;do if(a|0){Aa=a+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);a=y+(e<<6)+60|0;if(!(+P(+(+o[a>>2]))<1.1920928955078125e-07)){k[Da>>2]=0;k[w>>2]=0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[Da>>2]=c;k[w>>2]=1;i[d+5>>0]=0;i[c>>0]=91;c=z6(Ha,Da)|0;d=k[Da>>2]|0;k[w>>2]=0;k[Da>>2]=0;do if(d|0){Aa=d+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);a=oSa(nSa(nSa(nSa(nSa(c,y+(e<<6)+44|0)|0,y+(e<<6)+48|0)|0,y+(e<<6)+52|0)|0,y+(e<<6)+56|0)|0,a)|0;k[Da>>2]=0;k[x>>2]=0;Aa=ZT(8)|0;k[Aa>>2]=1;Ca=Aa+4|0;k[Da>>2]=Ca;k[x>>2]=1;i[Aa+5>>0]=0;i[Ca>>0]=93;z6(a,Da)|0;a=k[Da>>2]|0;k[x>>2]=0;k[Da>>2]=0;do if(a|0){Aa=a+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0)}k[Da>>2]=0;k[s>>2]=0;Ca=ZT(8)|0;k[Ca>>2]=1;a=Ca+4|0;k[Da>>2]=a;k[s>>2]=1;i[Ca+5>>0]=0;i[a>>0]=93;z6(Ha,Da)|0;a=k[Da>>2]|0;k[s>>2]=0;k[Da>>2]=0;do if(a|0){Aa=a+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);if(i[y+(e<<6)>>0]|0){k[Da>>2]=0;k[v>>2]=0;c=ZT(12)|0;k[c>>2]=1;a=c+4|0;k[Da>>2]=a;k[v>>2]=6;i[c+10>>0]=0;i[a>>0]=i[380579]|0;i[a+1>>0]=i[380580]|0;i[a+2>>0]=i[380581]|0;i[a+3>>0]=i[380582]|0;i[a+4>>0]=i[380583]|0;i[a+5>>0]=i[380584]|0;a=z6(Ha,Da)|0;c=k[Da>>2]|0;k[v>>2]=0;k[Da>>2]=0;do if(c|0){Aa=c+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=1;nSa(a,Da)|0}k[Da>>2]=0;k[t>>2]=0;Ca=ZT(8)|0;k[Ca>>2]=1;a=Ca+4|0;k[Da>>2]=a;k[t>>2]=1;i[Ca+5>>0]=0;i[a>>0]=125;z6(Ha,Da)|0;a=k[Da>>2]|0;k[t>>2]=0;k[Da>>2]=0;do if(a|0){Aa=a+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);e=e+1|0}while((e|0)<(N|0))}k[Da>>2]=0;Ca=Da+4|0;k[Ca>>2]=0;c=ZT(8)|0;k[c>>2]=1;a=c+4|0;k[Da>>2]=a;k[Ca>>2]=1;i[c+5>>0]=0;i[a>>0]=93;a=z6(Ha,Da)|0;c=k[Da>>2]|0;k[Ca>>2]=0;k[Da>>2]=0;do if(c|0){Aa=c+-4|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[Da>>2]=0;Ca=Da+4|0;k[Ca>>2]=0;za=ZT(8)|0;k[za>>2]=1;Aa=za+4|0;k[Da>>2]=Aa;k[Ca>>2]=1;i[za+5>>0]=0;i[Aa>>0]=125;z6(a,Da)|0;a=k[Da>>2]|0;k[Ca>>2]=0;k[Da>>2]=0;do if(a|0){Ca=a+-4|0;Da=k[Ca>>2]|0;k[Ca>>2]=Da+-1;if((Da|0)!=1)break;ggb(k[a+-8>>2]|0)}while(0);a=1}else a=0;T4(Ha);mSa(Fa);if(Ea|0)ggb(Ea);T4(Ga);if(a){Ja=a;r=Ka;return Ja|0}else f=a}else Ba=556}else Ba=556;if((Ba|0)==556){T4(Ga);f=0}if(!(k[b+4>>2]|0)){Ja=f;r=Ka;return Ja|0}e=k[b>>2]|0;e=(e|0)==0?1016759:e;k[Ia>>2]=e;d=_d(10,Ia|0)|0;do if(d>>>0<=4294963200)if(!d){Ja=f;r=Ka;return Ja|0}else{a=k[206783]|0;break}else{a=k[206783]|0;if(!a)c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=0-d}while(0);if(!a)a=827176;else{a=(Fpb()|0)+64|0;a=k[a>>2]|0}if((k[a>>2]|0)!=21){Ja=f;r=Ka;return Ja|0}k[Ja>>2]=e;c=_e(40,Ja|0)|0;if(c>>>0<=4294963200){Ja=f;r=Ka;return Ja|0}if(!(k[206783]|0))a=827176;else{a=(Fpb()|0)+64|0;a=k[a>>2]|0}k[a>>2]=0-c;Ja=f;r=Ka;return Ja|0}function mSa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;b=k[a>>2]|0;if(!b)return;m=a+4|0;c=k[m>>2]|0;if((c|0)!=(b|0)){d=c;while(1){c=d+-24|0;k[m>>2]=c;j=d+-16|0;l=k[j>>2]|0;if(l){i=d+-12|0;c=k[i>>2]|0;if((c|0)==(l|0))c=l;else{do{d=c+-24|0;k[i>>2]=d;e=k[c+-12>>2]|0;f=e;if(e|0){g=c+-8|0;h=k[g>>2]|0;if((h|0)!=(e|0))k[g>>2]=h+(~((h+-4-f|0)>>>2)<<2);ggb(e)}e=k[d>>2]|0;f=e;if(e|0){c=c+-20|0;d=k[c>>2]|0;if((d|0)!=(e|0))k[c>>2]=d+(~((d+-16-f|0)>>>4)<<4);ggb(e)}c=k[i>>2]|0}while((c|0)!=(l|0));c=k[j>>2]|0}ggb(c);c=k[m>>2]|0}if((c|0)==(b|0))break;else d=c}b=k[a>>2]|0}ggb(b);return}function nSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function oSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+o[b>>2]);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function pSa(){var a=0,b=0;a=r;r=r+48|0;b=a;k[b>>2]=0;k[b+4>>2]=40;k[b+16>>2]=380354;k[b+12>>2]=0;k[b+8>>2]=0;k[b+20>>2]=792;k[b+24>>2]=1490;k[b+36>>2]=793;k[b+28>>2]=273;k[b+32>>2]=208;N5(b);k[206778]=k[107193];ud(1449,827112,x|0)|0;r=a;return}function qSa(a){a=a|0;if(!a)a=0;else a=(k[a>>2]&-65536|0)==1112539136;return a&1|0}function rSa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;if(!a)return;f=k[a>>2]|0;if(!f)return;g=f+4|0;if((k[g>>2]|0)>0){h=f+32|0;e=0;do{b=k[h>>2]|0;c=b+(e*24|0)+8|0;if((k[b+(e*24|0)>>2]|0)>0){d=0;do{c=k[(k[c>>2]|0)+(d*24|0)+4>>2]|0;if(c){ggb(k[c+-4>>2]|0);b=k[h>>2]|0}k[(k[b+(e*24|0)+8>>2]|0)+(d*24|0)+4>>2]=0;d=d+1|0;b=k[h>>2]|0;c=b+(e*24|0)+8|0}while((d|0)<(k[b+(e*24|0)>>2]|0))}c=k[c>>2]|0;if(c){ggb(k[c+-4>>2]|0);b=k[h>>2]|0}k[b+(e*24|0)+8>>2]=0;e=e+1|0}while((e|0)<(k[g>>2]|0))}b=f+36|0;c=k[b>>2]|0;if(c|0){ggb(k[c+-4>>2]|0);k[b>>2]=0}b=k[a>>2]|0;if(b|0)ggb(k[b+-4>>2]|0);k[a>>2]=0;return}function sSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0;wb=r;r=r+752|0;bb=wb+352|0;ab=wb+344|0;$a=wb+336|0;_a=wb+328|0;Za=wb+312|0;ub=wb+296|0;tb=wb+280|0;sb=wb+264|0;rb=wb+248|0;pb=wb+232|0;ob=wb+216|0;nb=wb+200|0;mb=wb+184|0;lb=wb+168|0;kb=wb+152|0;jb=wb+136|0;ib=wb+120|0;gb=wb+104|0;fb=wb+88|0;eb=wb+72|0;db=wb+56|0;cb=wb+40|0;qb=wb+24|0;hb=wb+16|0;Ya=wb+8|0;Xa=wb;Ka=wb+496|0;s=wb+464|0;Pa=wb+432|0;Sa=wb+400|0;Va=wb+368|0;Wa=wb+360|0;f=k6(a,b,380517)|0;if(!((f|0)!=0?(k[f>>2]&7|0)==5:0)){d=Pa+4|0;e=ZT(24)|0;k[e>>2]=1;h=e+4|0;k[Pa>>2]=h;k[d>>2]=19;i[e+23>>0]=0;l=380654;m=h+19|0;do{i[h>>0]=i[l>>0]|0;h=h+1|0;l=l+1|0}while((h|0)<(m|0));Y8(-2,Pa,380674,380444,2070);k[d>>2]=0;k[Pa>>2]=0;Ga=k[e>>2]|0;k[e>>2]=Ga+-1;if((Ga|0)==1)ggb(k[e+-4>>2]|0)}q=f+8|0;Fa=k[(k[q>>2]|0)+24>>2]|0;Ga=vSa(Fa)|0;f=k6(a,b,380512)|0;if(((f|0)!=0?(k[f>>2]&7|0)==5:0)?(g=f+8|0,j=k[g>>2]|0,(k[j+24>>2]|0)==2):0){h=j;f=2;d=k[j+52>>2]|0;vb=13}else{d=Pa+4|0;e=ZT(40)|0;k[e>>2]=1;h=e+4|0;k[Pa>>2]=h;k[d>>2]=34;i[e+38>>0]=0;l=380696;m=h+34|0;do{i[h>>0]=i[l>>0]|0;h=h+1|0;l=l+1|0}while((h|0)<(m|0));Y8(-2,Pa,380674,380444,2078);k[d>>2]=0;k[Pa>>2]=0;Ea=k[e>>2]|0;k[e>>2]=Ea+-1;if((Ea|0)==1)ggb(k[e+-4>>2]|0);g=f+8|0;h=k[g>>2]|0;f=k[h+24>>2]|0;d=k[h+52>>2]|0;if((f|0)<0){e=f;do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((e|0)>0);b=0-e|0;e=h}else vb=13}if((vb|0)==13){e=k[d+12>>2]|0;if((e|0)>0){b=0;e=h}else{b=0;do{d=k[d+4>>2]|0;b=b-e|0;e=k[d+12>>2]|0}while((b|0)>=(e|0));e=h}}b=(k[d+16>>2]|0)+(aa(k[e+28>>2]|0,b)|0)|0;if((k[b>>2]&7|0)==1?(n=k[b+8>>2]|0,(n|0)>=1):0){d=n;b=e}else{d=Pa+4|0;e=ZT(56)|0;k[e>>2]=1;h=e+4|0;k[Pa>>2]=h;k[d>>2]=49;i[e+53>>0]=0;l=380731;m=h+49|0;do{i[h>>0]=i[l>>0]|0;h=h+1|0;l=l+1|0}while((h|0)<(m|0));Y8(-2,Pa,380674,380444,2081);k[d>>2]=0;k[Pa>>2]=0;Ea=k[e>>2]|0;k[e>>2]=Ea+-1;if((Ea|0)==1)ggb(k[e+-4>>2]|0);Ea=k[g>>2]|0;d=k[b+8>>2]|0;f=k[Ea+24>>2]|0;b=Ea}Ea=Ga+8|0;k[Ea>>2]=d;d=f>>>0>1?1:1-f|0;e=k[b+52>>2]|0;if((d<<1|0)<=(f|0)){f=k[e+12>>2]|0;if((d|0)>=(f|0))do{e=k[e+4>>2]|0;d=d-f|0;f=k[e+12>>2]|0}while((d|0)>=(f|0))}else{do{e=k[e>>2]|0;f=f-(k[e+12>>2]|0)|0}while((d|0)<(f|0));d=d-f|0}e=(k[e+16>>2]|0)+(aa(k[b+28>>2]|0,d)|0)|0;if(!((k[e>>2]&7|0)==1?(c=k[e+8>>2]|0,(c|0)>=1):0)){c=Pa+4|0;d=ZT(56)|0;k[d>>2]=1;h=d+4|0;k[Pa>>2]=h;k[c>>2]=50;i[d+54>>0]=0;l=380781;m=h+50|0;do{i[h>>0]=i[l>>0]|0;h=h+1|0;l=l+1|0}while((h|0)<(m|0));Y8(-2,Pa,380674,380444,2085);k[c>>2]=0;k[Pa>>2]=0;Da=k[d>>2]|0;k[d>>2]=Da+-1;if((Da|0)==1)ggb(k[d+-4>>2]|0);c=k[e+8>>2]|0}Da=Ga+12|0;k[Da>>2]=c;KY(k[q>>2]|0,s);if((Fa|0)<=0){r=wb;return Ga|0}R=s+12|0;S=Sa+4|0;T=Ga+32|0;U=Sa+4|0;V=Sa+4|0;W=Sa+4|0;X=s+20|0;Y=Ga+4|0;Z=Pa+12|0;_=Va+4|0;$=Pa+20|0;ba=Va+4|0;ca=Sa+12|0;da=Wa+4|0;ea=Wa+4|0;fa=Wa+4|0;ga=Wa+4|0;ha=Wa+4|0;ia=Wa+4|0;ja=Wa+4|0;ka=Wa+4|0;la=Wa+4|0;ma=Wa+4|0;na=Sa+20|0;oa=Wa+4|0;pa=Wa+4|0;qa=Va+12|0;ra=Wa+4|0;sa=Wa+4|0;ta=Wa+4|0;ua=Wa+4|0;va=Va+20|0;wa=Wa+4|0;xa=Wa+4|0;ya=Wa+4|0;za=Sa+4|0;Aa=Ka;Ba=(Aa&3|0)==0;Ca=s+8|0;Q=s+4|0;J=s+16|0;K=Pa+8|0;H=Pa+4|0;L=Pa+16|0;M=Sa+8|0;I=Sa+4|0;N=Sa+16|0;O=Va+8|0;G=Va+4|0;P=Va+16|0;F=0;c=k[R>>2]|0;do{if((k[c>>2]&7|0)!=6){k[Xa>>2]=F;Cfb(Ka,380832,Xa);k[Sa>>2]=0;k[za>>2]=0;a:do if(Ba){d=Ka;vb=38}else{e=Ka;d=Aa;while(1){if(!(i[e>>0]|0))break a;e=e+1|0;d=e;if(!(d&3)){d=e;vb=38;break}}}while(0);if((vb|0)==38){vb=0;while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}E=d-Aa|0;d=ZT(E+8&-4)|0;k[d>>2]=1;D=d+4|0;k[Sa>>2]=D;k[za>>2]=E;i[D+E>>0]=0;upb(D|0,Ka|0,E|0)|0;Y8(-2,Sa,380674,380444,2099);k[za>>2]=0;k[Sa>>2]=0;E=k[d>>2]|0;k[d>>2]=E+-1;if((E|0)==1)ggb(k[d+-4>>2]|0)}f=k6(a,c,380533)|0;if(((f|0)!=0?(k[f>>2]&7|0)==5:0)?(La=f+8|0,Ma=k[(k[La>>2]|0)+24>>2]|0,(Ma|0)>=1):0){E=La;d=Ma}else{k[Ya>>2]=F;Cfb(Ka,380849,Ya);k[Sa>>2]=0;k[S>>2]=0;b:do if(Ba){d=Ka;vb=52}else{e=Ka;d=Aa;while(1){if(!(i[e>>0]|0))break b;e=e+1|0;d=e;if(!(d&3)){d=e;vb=52;break}}}while(0);if((vb|0)==52){vb=0;while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}E=d-Aa|0;d=ZT(E+8&-4)|0;k[d>>2]=1;D=d+4|0;k[Sa>>2]=D;k[S>>2]=E;i[D+E>>0]=0;upb(D|0,Ka|0,E|0)|0;Y8(-2,Sa,380674,380444,2107);k[S>>2]=0;k[Sa>>2]=0;E=k[d>>2]|0;k[d>>2]=E+-1;if((E|0)==1)ggb(k[d+-4>>2]|0);d=f+8|0;E=d;d=k[(k[d>>2]|0)+24>>2]|0}b=ZT(d*24|0)|0;g=k[T>>2]|0;k[g+(F*24|0)+8>>2]=b;d=k[E>>2]|0;e=k[d+24>>2]|0;if((e|0)>0){f=0;do{k[b+(f*24|0)+4>>2]=0;f=f+1|0;d=k[E>>2]|0;e=k[d+24>>2]|0}while((f|0)<(e|0))}k[g+(F*24|0)>>2]=e;KY(d,Pa);if((k[(k[E>>2]|0)+24>>2]|0)>0){D=0;d=k[Z>>2]|0;do{b=k[(k[T>>2]|0)+(F*24|0)+8>>2]|0;if((k[d>>2]&7|0)==5?(Na=d+8|0,Oa=k[(k[Na>>2]|0)+24>>2]|0,(Oa|0)>=1):0){B=Na;d=Oa}else{k[hb>>2]=F;k[hb+4>>2]=D;Cfb(Ka,380896,hb);k[Va>>2]=0;k[_>>2]=0;c:do if(Ba){e=Ka;vb=69}else{f=Ka;e=Aa;while(1){if(!(i[f>>0]|0))break c;f=f+1|0;e=f;if(!(e&3)){e=f;vb=69;break}}}while(0);if((vb|0)==69){vb=0;while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}C=e-Aa|0;e=ZT(C+8&-4)|0;k[e>>2]=1;B=e+4|0;k[Va>>2]=B;k[_>>2]=C;i[B+C>>0]=0;upb(B|0,Ka|0,C|0)|0;Y8(-2,Va,380674,380444,2133);k[_>>2]=0;k[Va>>2]=0;C=k[e>>2]|0;k[e>>2]=C+-1;if((C|0)==1)ggb(k[e+-4>>2]|0);d=d+8|0;B=d;d=k[(k[d>>2]|0)+24>>2]|0}C=b+(D*24|0)|0;k[C>>2]=d;u=ZT(d*80|4)|0;x=b+(D*24|0)+4|0;k[x>>2]=u;v=k[C>>2]|0;u=u+(v<<6)|0;y=b+(D*24|0)+8|0;k[y>>2]=u;u=u+(v<<2)|0;z=b+(D*24|0)+12|0;k[z>>2]=u;u=u+(v<<2)|0;A=b+(D*24|0)+16|0;k[A>>2]=u;w=b+(D*24|0)+20|0;k[w>>2]=u+(v<<2);KY(k[B>>2]|0,Sa);if((k[(k[B>>2]|0)+24>>2]|0)>0){v=0;d=0;e=k[ca>>2]|0;do{if((k[e>>2]&7|0)!=6){k[qb>>2]=v;k[qb+4>>2]=F;k[qb+8>>2]=D;Cfb(Ka,380951,qb);k[Wa>>2]=0;k[ya>>2]=0;d:do if(Ba){f=Ka;vb=83}else{b=Ka;f=Aa;while(1){if(!(i[b>>0]|0))break d;b=b+1|0;f=b;if(!(f&3)){f=b;vb=83;break}}}while(0);if((vb|0)==83){vb=0;while(1){b=k[f>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))f=f+4|0;else break}if((b&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}u=f-Aa|0;f=ZT(u+8&-4)|0;k[f>>2]=1;t=f+4|0;k[Wa>>2]=t;k[ya>>2]=u;i[t+u>>0]=0;upb(t|0,Ka|0,u|0)|0;Y8(-2,Wa,380674,380444,2161);k[ya>>2]=0;k[Wa>>2]=0;u=k[f>>2]|0;k[f>>2]=u+-1;if((u|0)==1)ggb(k[f+-4>>2]|0)}u=k6(a,e,380565)|0;if(!((u|0)!=0?(k[u>>2]&7|0)==6:0)){k[cb>>2]=F;k[cb+4>>2]=D;k[cb+8>>2]=v;Cfb(Ka,381004,cb);k[Wa>>2]=0;k[da>>2]=0;e:do if(Ba){f=Ka;vb=96}else{b=Ka;f=Aa;while(1){if(!(i[b>>0]|0))break e;b=b+1|0;f=b;if(!(f&3)){f=b;vb=96;break}}}while(0);if((vb|0)==96){vb=0;while(1){b=k[f>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))f=f+4|0;else break}if((b&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}t=f-Aa|0;f=ZT(t+8&-4)|0;k[f>>2]=1;s=f+4|0;k[Wa>>2]=s;k[da>>2]=t;i[s+t>>0]=0;upb(s|0,Ka|0,t|0)|0;Y8(-2,Wa,380674,380444,2168);k[da>>2]=0;k[Wa>>2]=0;t=k[f>>2]|0;k[f>>2]=t+-1;if((t|0)==1)ggb(k[f+-4>>2]|0)}g=k6(a,u,380573)|0;do if(g){if((k[g>>2]&7|0)!=5){vb=107;break}b=g+8|0;f=k[b>>2]|0;if(((k[f+24>>2]|0)+-1|0)>>>0>2)vb=107}else vb=107;while(0);if((vb|0)==107){vb=0;k[db>>2]=F;k[db+4>>2]=D;k[db+8>>2]=v;Cfb(Ka,381066,db);k[Wa>>2]=0;k[ea>>2]=0;f:do if(Ba){f=Ka;vb=110}else{b=Ka;f=Aa;while(1){if(!(i[b>>0]|0))break f;b=b+1|0;f=b;if(!(f&3)){f=b;vb=110;break}}}while(0);if((vb|0)==110){vb=0;while(1){b=k[f>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))f=f+4|0;else break}if((b&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}t=f-Aa|0;f=ZT(t+8&-4)|0;k[f>>2]=1;s=f+4|0;k[Wa>>2]=s;k[ea>>2]=t;i[s+t>>0]=0;upb(s|0,Ka|0,t|0)|0;Y8(-2,Wa,380674,380444,2177);k[ea>>2]=0;k[Wa>>2]=0;t=k[f>>2]|0;k[f>>2]=t+-1;if((t|0)==1)ggb(k[f+-4>>2]|0);f=g+8|0;b=f;f=k[f>>2]|0}KY(f,Va);f=k[(k[b>>2]|0)+24>>2]|0;if((f|0)>0){t=0;g=k[qa>>2]|0;do{if((k[g>>2]&7|0)==5?(Qa=g+8|0,Ra=k[Qa>>2]|0,(k[Ra+24>>2]|0)==5):0){q=Qa;l=Ra}else{k[eb>>2]=t;k[eb+4>>2]=F;k[eb+8>>2]=D;k[eb+12>>2]=v;Cfb(Ka,381131,eb);k[Wa>>2]=0;k[xa>>2]=0;g:do if(Ba){f=Ka;vb=126}else{h=Ka;f=Aa;while(1){if(!(i[h>>0]|0))break g;h=h+1|0;f=h;if(!(f&3)){f=h;vb=126;break}}}while(0);if((vb|0)==126){vb=0;while(1){h=k[f>>2]|0;if(!((h&-2139062144^-2139062144)&h+-16843009))f=f+4|0;else break}if((h&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}s=f-Aa|0;f=ZT(s+8&-4)|0;k[f>>2]=1;q=f+4|0;k[Wa>>2]=q;k[xa>>2]=s;i[q+s>>0]=0;upb(q|0,Ka|0,s|0)|0;Y8(-2,Wa,380674,380444,2190);k[xa>>2]=0;k[Wa>>2]=0;s=k[f>>2]|0;k[f>>2]=s+-1;if((s|0)==1)ggb(k[f+-4>>2]|0);l=g+8|0;q=l;l=k[l>>2]|0}j=k[l+52>>2]|0;do if(!j)vb=137;else{if(!(k[j+12>>2]|0)){vb=137;break}h=k[j+16>>2]|0}while(0);do if((vb|0)==137){vb=0;f=k[l+24>>2]|0;if(!f){h=0;break}do if((f|0)<0){g=j;do{g=k[g>>2]|0;f=f-(k[g+12>>2]|0)|0}while((f|0)>0);f=0-f|0}else{h=k[j+12>>2]|0;if((h|0)>0){g=j;f=0;break}else{g=j;f=0}do{g=k[g+4>>2]|0;f=f-h|0;h=k[g+12>>2]|0}while((f|0)>=(h|0))}while(0);h=(k[g+16>>2]|0)+(aa(k[l+28>>2]|0,f)|0)|0}while(0);if((k[h>>2]&7|0)==1?(Ta=k[h+8>>2]|0,(Ta|0)>=0):0)s=Ta;else{k[fb>>2]=F;k[fb+4>>2]=D;k[fb+8>>2]=v;k[fb+12>>2]=t;Cfb(Ka,381193,fb);k[Wa>>2]=0;k[ra>>2]=0;h:do if(Ba){f=Ka;vb=149}else{g=Ka;f=Aa;while(1){if(!(i[g>>0]|0))break h;g=g+1|0;f=g;if(!(f&3)){f=g;vb=149;break}}}while(0);if((vb|0)==149){vb=0;while(1){g=k[f>>2]|0;if(!((g&-2139062144^-2139062144)&g+-16843009))f=f+4|0;else break}if((g&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}s=f-Aa|0;f=ZT(s+8&-4)|0;k[f>>2]=1;n=f+4|0;k[Wa>>2]=n;k[ra>>2]=s;i[n+s>>0]=0;upb(n|0,Ka|0,s|0)|0;Y8(-2,Wa,380674,380444,2198);k[ra>>2]=0;k[Wa>>2]=0;s=k[f>>2]|0;k[f>>2]=s+-1;if((s|0)==1)ggb(k[f+-4>>2]|0);l=k[q>>2]|0;j=k[l+52>>2]|0;s=k[h+8>>2]|0}do if(!j)vb=160;else{if((k[j+12>>2]|0)>>>0<=1){vb=160;break}h=(k[j+16>>2]|0)+16|0}while(0);do if((vb|0)==160){vb=0;g=k[l+24>>2]|0;if(g>>>0<=1){f=1-g|0;if(f>>>0>=g>>>0){h=0;break}}else f=1;do if((f<<1|0)>(g|0)){h=g;g=j;do{g=k[g>>2]|0;h=h-(k[g+12>>2]|0)|0}while((f|0)<(h|0));f=f-h|0}else{h=k[j+12>>2]|0;if((f|0)<(h|0)){g=j;break}else g=j;do{g=k[g+4>>2]|0;f=f-h|0;h=k[g+12>>2]|0}while((f|0)>=(h|0))}while(0);h=(k[g+16>>2]|0)+(aa(k[l+28>>2]|0,f)|0)|0}while(0);if((k[h>>2]&7|0)==1?(Ua=k[h+8>>2]|0,(Ua|0)>=0):0)n=Ua;else{k[gb>>2]=F;k[gb+4>>2]=D;k[gb+8>>2]=v;k[gb+12>>2]=t;Cfb(Ka,381274,gb);k[Wa>>2]=0;k[sa>>2]=0;i:do if(Ba){f=Ka;vb=173}else{g=Ka;f=Aa;while(1){if(!(i[g>>0]|0))break i;g=g+1|0;f=g;if(!(f&3)){f=g;vb=173;break}}}while(0);if((vb|0)==173){vb=0;while(1){g=k[f>>2]|0;if(!((g&-2139062144^-2139062144)&g+-16843009))f=f+4|0;else break}if((g&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}n=f-Aa|0;f=ZT(n+8&-4)|0;k[f>>2]=1;m=f+4|0;k[Wa>>2]=m;k[sa>>2]=n;i[m+n>>0]=0;upb(m|0,Ka|0,n|0)|0;Y8(-2,Wa,380674,380444,2206);k[sa>>2]=0;k[Wa>>2]=0;n=k[f>>2]|0;k[f>>2]=n+-1;if((n|0)==1)ggb(k[f+-4>>2]|0);l=k[q>>2]|0;j=k[l+52>>2]|0;n=k[h+8>>2]|0}do if(!j)vb=184;else{if((k[j+12>>2]|0)>>>0<=2){vb=184;break}h=(k[j+16>>2]|0)+32|0}while(0);do if((vb|0)==184){vb=0;g=k[l+24>>2]|0;if(g>>>0<=2){f=2-g|0;if(f>>>0>=g>>>0){h=0;break}}else f=2;do if((f<<1|0)>(g|0)){h=g;g=j;do{g=k[g>>2]|0;h=h-(k[g+12>>2]|0)|0}while((f|0)<(h|0));f=f-h|0}else{h=k[j+12>>2]|0;if((f|0)<(h|0)){g=j;break}else g=j;do{g=k[g+4>>2]|0;f=f-h|0;h=k[g+12>>2]|0}while((f|0)>=(h|0))}while(0);h=(k[g+16>>2]|0)+(aa(k[l+28>>2]|0,f)|0)|0}while(0);do if((k[h>>2]&7|0)==1){f=k[h+8>>2]|0;if((f|0)<1){vb=195;break}if((f+s|0)<=(k[Ea>>2]|0)){g=j;m=f}else vb=195}else vb=195;while(0);if((vb|0)==195){vb=0;k[ib>>2]=F;k[ib+4>>2]=D;k[ib+8>>2]=v;k[ib+12>>2]=t;Cfb(Ka,381355,ib);k[Wa>>2]=0;k[ta>>2]=0;j:do if(Ba){f=Ka;vb=198}else{g=Ka;f=Aa;while(1){if(!(i[g>>0]|0))break j;g=g+1|0;f=g;if(!(f&3)){f=g;vb=198;break}}}while(0);if((vb|0)==198){vb=0;while(1){g=k[f>>2]|0;if(!((g&-2139062144^-2139062144)&g+-16843009))f=f+4|0;else break}if((g&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}m=f-Aa|0;f=ZT(m+8&-4)|0;k[f>>2]=1;l=f+4|0;k[Wa>>2]=l;k[ta>>2]=m;i[l+m>>0]=0;upb(l|0,Ka|0,m|0)|0;Y8(-2,Wa,380674,380444,2216);k[ta>>2]=0;k[Wa>>2]=0;m=k[f>>2]|0;k[f>>2]=m+-1;if((m|0)==1)ggb(k[f+-4>>2]|0);l=k[q>>2]|0;g=k[l+52>>2]|0;m=k[h+8>>2]|0}do if(!g)vb=209;else{if((k[g+12>>2]|0)>>>0<=3){vb=209;break}h=(k[g+16>>2]|0)+48|0}while(0);do if((vb|0)==209){vb=0;h=k[l+24>>2]|0;if(h>>>0<=3){f=3-h|0;if(f>>>0>=h>>>0){h=0;break}}else f=3;do if((f<<1|0)>(h|0)){j=h;h=g;do{h=k[h>>2]|0;j=j-(k[h+12>>2]|0)|0}while((f|0)<(j|0));f=f-j|0}else{j=k[g+12>>2]|0;if((f|0)<(j|0)){h=g;break}else h=g;do{h=k[h+4>>2]|0;f=f-j|0;j=k[h+12>>2]|0}while((f|0)>=(j|0))}while(0);h=(k[h+16>>2]|0)+(aa(k[l+28>>2]|0,f)|0)|0}while(0);do if((k[h>>2]&7|0)==1){f=k[h+8>>2]|0;if((f|0)<1){vb=220;break}if((f+n|0)<=(k[Da>>2]|0))j=f;else vb=220}else vb=220;while(0);if((vb|0)==220){vb=0;k[jb>>2]=F;k[jb+4>>2]=D;k[jb+8>>2]=v;k[jb+12>>2]=t;Cfb(Ka,381470,jb);k[Wa>>2]=0;k[ua>>2]=0;k:do if(Ba){f=Ka;vb=223}else{g=Ka;f=Aa;while(1){if(!(i[g>>0]|0))break k;g=g+1|0;f=g;if(!(f&3)){f=g;vb=223;break}}}while(0);if((vb|0)==223){vb=0;while(1){g=k[f>>2]|0;if(!((g&-2139062144^-2139062144)&g+-16843009))f=f+4|0;else break}if((g&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}l=f-Aa|0;f=ZT(l+8&-4)|0;k[f>>2]=1;j=f+4|0;k[Wa>>2]=j;k[ua>>2]=l;i[j+l>>0]=0;upb(j|0,Ka|0,l|0)|0;Y8(-2,Wa,380674,380444,2226);k[ua>>2]=0;k[Wa>>2]=0;l=k[f>>2]|0;k[f>>2]=l+-1;if((l|0)==1)ggb(k[f+-4>>2]|0);l=k[q>>2]|0;g=k[l+52>>2]|0;j=k[h+8>>2]|0}do if(!g)vb=234;else{if((k[g+12>>2]|0)>>>0<=4){vb=234;break}h=(k[g+16>>2]|0)+64|0}while(0);do if((vb|0)==234){vb=0;h=k[l+24>>2]|0;if(h>>>0<=4){f=4-h|0;if(f>>>0>=h>>>0){h=0;break}}else f=4;do if((f<<1|0)>(h|0)){do{g=k[g>>2]|0;h=h-(k[g+12>>2]|0)|0}while((f|0)<(h|0));f=f-h|0}else{h=k[g+12>>2]|0;if((f|0)<(h|0))break;do{g=k[g+4>>2]|0;f=f-h|0;h=k[g+12>>2]|0}while((f|0)>=(h|0))}while(0);h=(k[g+16>>2]|0)+(aa(k[l+28>>2]|0,f)|0)|0}while(0);if((k[h>>2]&7|0)!=2){k[kb>>2]=F;k[kb+4>>2]=D;k[kb+8>>2]=v;k[kb+12>>2]=t;Cfb(Ka,381588,kb);k[Wa>>2]=0;k[wa>>2]=0;l:do if(Ba){f=Ka;vb=246}else{g=Ka;f=Aa;while(1){if(!(i[g>>0]|0))break l;g=g+1|0;f=g;if(!(f&3)){f=g;vb=246;break}}}while(0);if((vb|0)==246){vb=0;while(1){g=k[f>>2]|0;if(!((g&-2139062144^-2139062144)&g+-16843009))f=f+4|0;else break}if((g&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}q=f-Aa|0;f=ZT(q+8&-4)|0;k[f>>2]=1;l=f+4|0;k[Wa>>2]=l;k[wa>>2]=q;i[l+q>>0]=0;upb(l|0,Ka|0,q|0)|0;Y8(-2,Wa,380674,380444,2234);k[wa>>2]=0;k[Wa>>2]=0;q=k[f>>2]|0;k[f>>2]=q+-1;if((q|0)==1)ggb(k[f+-4>>2]|0)}f=k[x>>2]|0;o[f+(v<<6)+4+(t*20|0)+16>>2]=+p[h+8>>3];k[f+(v<<6)+4+(t*20|0)>>2]=s;k[f+(v<<6)+4+(t*20|0)+4>>2]=n;k[f+(v<<6)+4+(t*20|0)+8>>2]=m;k[f+(v<<6)+4+(t*20|0)+12>>2]=j;f=(k[qa>>2]|0)+16|0;k[qa>>2]=f;if(f>>>0<(k[va>>2]|0)>>>0)g=f;else{s=k[(k[O>>2]|0)+4>>2]|0;k[O>>2]=s;g=k[s+16>>2]|0;k[qa>>2]=g;n=g;q=k[(k[G>>2]|0)+28>>2]|0;s=k[s+12>>2]|0;k[P>>2]=n;s=n+(aa(q,s)|0)|0;k[va>>2]=s}t=t+1|0;f=k[(k[b>>2]|0)+24>>2]|0}while((t|0)<(f|0));if((f|0)<3)vb=257}else vb=257;if((vb|0)==257)while(1){vb=0;t=(k[x>>2]|0)+(v<<6)+4+(f*20|0)|0;f=f+1|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;k[t+16>>2]=0;if((f|0)==3)break;else vb=257}g=k6(a,u,380579)|0;if(!((g|0)!=0?(k[g>>2]&7|0)==1:0)){k[lb>>2]=F;k[lb+4>>2]=D;k[lb+8>>2]=v;Cfb(Ka,381654,lb);k[Wa>>2]=0;k[fa>>2]=0;m:do if(Ba){f=Ka;vb=263}else{b=Ka;f=Aa;while(1){if(!(i[b>>0]|0))break m;b=b+1|0;f=b;if(!(f&3)){f=b;vb=263;break}}}while(0);if((vb|0)==263){vb=0;while(1){b=k[f>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))f=f+4|0;else break}if((b&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}u=f-Aa|0;f=ZT(u+8&-4)|0;k[f>>2]=1;t=f+4|0;k[Wa>>2]=t;k[fa>>2]=u;i[t+u>>0]=0;upb(t|0,Ka|0,u|0)|0;Y8(-2,Wa,380674,380444,2253);k[fa>>2]=0;k[Wa>>2]=0;u=k[f>>2]|0;k[f>>2]=u+-1;if((u|0)==1)ggb(k[f+-4>>2]|0)}k[(k[x>>2]|0)+(v<<6)>>2]=(k[g+8>>2]|0)!=0&1;g=k6(a,e,393853)|0;if(!((g|0)!=0?(k[g>>2]&7|0)==2:0)){k[mb>>2]=F;k[mb+4>>2]=D;k[mb+8>>2]=v;Cfb(Ka,381706,mb);k[Wa>>2]=0;k[ga>>2]=0;n:do if(Ba){f=Ka;vb=276}else{b=Ka;f=Aa;while(1){if(!(i[b>>0]|0))break n;b=b+1|0;f=b;if(!(f&3)){f=b;vb=276;break}}}while(0);if((vb|0)==276){vb=0;while(1){b=k[f>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))f=f+4|0;else break}if((b&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}u=f-Aa|0;f=ZT(u+8&-4)|0;k[f>>2]=1;t=f+4|0;k[Wa>>2]=t;k[ga>>2]=u;i[t+u>>0]=0;upb(t|0,Ka|0,u|0)|0;Y8(-2,Wa,380674,380444,2261);k[ga>>2]=0;k[Wa>>2]=0;u=k[f>>2]|0;k[f>>2]=u+-1;if((u|0)==1)ggb(k[f+-4>>2]|0)}o[(k[y>>2]|0)+(v<<2)>>2]=+p[g+8>>3];g=k6(a,e,380586)|0;if(!g){g=k6(a,e,380596)|0;if(!g){k[ob>>2]=F;k[ob+4>>2]=D;k[ob+8>>2]=v;Cfb(Ka,381832,ob);k[Wa>>2]=0;k[ha>>2]=0;o:do if(Ba){f=Ka;vb=304}else{b=Ka;f=Aa;while(1){if(!(i[b>>0]|0))break o;b=b+1|0;f=b;if(!(f&3)){f=b;vb=304;break}}}while(0);if((vb|0)==304){vb=0;while(1){b=k[f>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))f=f+4|0;else break}if((b&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}u=f-Aa|0;f=ZT(u+8&-4)|0;k[f>>2]=1;t=f+4|0;k[Wa>>2]=t;k[ha>>2]=u;i[t+u>>0]=0;upb(t|0,Ka|0,u|0)|0;Y8(-2,Wa,380674,380444,2284);k[ha>>2]=0;k[Wa>>2]=0;u=k[f>>2]|0;k[f>>2]=u+-1;if((u|0)==1)ggb(k[f+-4>>2]|0)}if((k[g>>2]&7|0)!=2){k[pb>>2]=F;k[pb+4>>2]=D;k[pb+8>>2]=v;Cfb(Ka,381904,pb);k[Wa>>2]=0;k[ja>>2]=0;p:do if(Ba){f=Ka;vb=316}else{b=Ka;f=Aa;while(1){if(!(i[b>>0]|0))break p;b=b+1|0;f=b;if(!(f&3)){f=b;vb=316;break}}}while(0);if((vb|0)==316){vb=0;while(1){b=k[f>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))f=f+4|0;else break}if((b&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}u=f-Aa|0;f=ZT(u+8&-4)|0;k[f>>2]=1;t=f+4|0;k[Wa>>2]=t;k[ja>>2]=u;i[t+u>>0]=0;upb(t|0,Ka|0,u|0)|0;Y8(-2,Wa,380674,380444,2290);k[ja>>2]=0;k[Wa>>2]=0;u=k[f>>2]|0;k[f>>2]=u+-1;if((u|0)==1)ggb(k[f+-4>>2]|0)}if((d|0)>(k[C>>2]|0)){k[rb>>2]=F;k[rb+4>>2]=D;k[rb+8>>2]=v;Cfb(Ka,381965,rb);k[Wa>>2]=0;k[ia>>2]=0;q:do if(Ba){f=Ka;vb=328}else{b=Ka;f=Aa;while(1){if(!(i[b>>0]|0))break q;b=b+1|0;f=b;if(!(f&3)){f=b;vb=328;break}}}while(0);if((vb|0)==328){vb=0;while(1){b=k[f>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))f=f+4|0;else break}if((b&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}u=f-Aa|0;f=ZT(u+8&-4)|0;k[f>>2]=1;t=f+4|0;k[Wa>>2]=t;k[ia>>2]=u;i[t+u>>0]=0;upb(t|0,Ka|0,u|0)|0;Y8(-2,Wa,380674,380444,2297);k[ia>>2]=0;k[Wa>>2]=0;u=k[f>>2]|0;k[f>>2]=u+-1;if((u|0)==1)ggb(k[f+-4>>2]|0)}k[(k[z>>2]|0)+(v<<2)>>2]=0-d;o[(k[w>>2]|0)+(d<<2)>>2]=+p[g+8>>3];d=d+1|0}else{do if((k[g>>2]&7|0)==1){f=k[g+8>>2]|0;if((f|0)<=(v|0)){vb=288;break}if((f|0)>=(k[(k[B>>2]|0)+24>>2]|0))vb=288}else vb=288;while(0);if((vb|0)==288){vb=0;k[nb>>2]=F;k[nb+4>>2]=D;k[nb+8>>2]=v;Cfb(Ka,381766,nb);k[Wa>>2]=0;k[pa>>2]=0;r:do if(Ba){f=Ka;vb=291}else{b=Ka;f=Aa;while(1){if(!(i[b>>0]|0))break r;b=b+1|0;f=b;if(!(f&3)){f=b;vb=291;break}}}while(0);if((vb|0)==291){vb=0;while(1){b=k[f>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))f=f+4|0;else break}if((b&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}u=f-Aa|0;f=ZT(u+8&-4)|0;k[f>>2]=1;t=f+4|0;k[Wa>>2]=t;k[pa>>2]=u;i[t+u>>0]=0;upb(t|0,Ka|0,u|0)|0;Y8(-2,Wa,380674,380444,2272);k[pa>>2]=0;k[Wa>>2]=0;u=k[f>>2]|0;k[f>>2]=u+-1;if((u|0)==1)ggb(k[f+-4>>2]|0);f=k[g+8>>2]|0}k[(k[z>>2]|0)+(v<<2)>>2]=f}b=k6(a,e,380605)|0;if(!b){b=k6(a,e,380616)|0;if(!b){k[tb>>2]=F;k[tb+4>>2]=D;k[tb+8>>2]=v;Cfb(Ka,382104,tb);k[Wa>>2]=0;k[ka>>2]=0;s:do if(Ba){e=Ka;vb=357}else{f=Ka;e=Aa;while(1){if(!(i[f>>0]|0))break s;f=f+1|0;e=f;if(!(e&3)){e=f;vb=357;break}}}while(0);if((vb|0)==357){vb=0;while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}u=e-Aa|0;e=ZT(u+8&-4)|0;k[e>>2]=1;t=e+4|0;k[Wa>>2]=t;k[ka>>2]=u;i[t+u>>0]=0;upb(t|0,Ka|0,u|0)|0;Y8(-2,Wa,380674,380444,2322);k[ka>>2]=0;k[Wa>>2]=0;u=k[e>>2]|0;k[e>>2]=u+-1;if((u|0)==1)ggb(k[e+-4>>2]|0)}if((k[b>>2]&7|0)!=2){k[ub>>2]=F;k[ub+4>>2]=D;k[ub+8>>2]=v;Cfb(Ka,382178,ub);k[Wa>>2]=0;k[ma>>2]=0;t:do if(Ba){e=Ka;vb=369}else{f=Ka;e=Aa;while(1){if(!(i[f>>0]|0))break t;f=f+1|0;e=f;if(!(e&3)){e=f;vb=369;break}}}while(0);if((vb|0)==369){vb=0;while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}u=e-Aa|0;e=ZT(u+8&-4)|0;k[e>>2]=1;t=e+4|0;k[Wa>>2]=t;k[ma>>2]=u;i[t+u>>0]=0;upb(t|0,Ka|0,u|0)|0;Y8(-2,Wa,380674,380444,2328);k[ma>>2]=0;k[Wa>>2]=0;u=k[e>>2]|0;k[e>>2]=u+-1;if((u|0)==1)ggb(k[e+-4>>2]|0)}if((d|0)>(k[C>>2]|0)){k[Za>>2]=F;k[Za+4>>2]=D;k[Za+8>>2]=v;Cfb(Ka,381965,Za);k[Wa>>2]=0;k[la>>2]=0;u:do if(Ba){e=Ka;vb=381}else{f=Ka;e=Aa;while(1){if(!(i[f>>0]|0))break u;f=f+1|0;e=f;if(!(e&3)){e=f;vb=381;break}}}while(0);if((vb|0)==381){vb=0;while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}u=e-Aa|0;e=ZT(u+8&-4)|0;k[e>>2]=1;t=e+4|0;k[Wa>>2]=t;k[la>>2]=u;i[t+u>>0]=0;upb(t|0,Ka|0,u|0)|0;Y8(-2,Wa,380674,380444,2335);k[la>>2]=0;k[Wa>>2]=0;u=k[e>>2]|0;k[e>>2]=u+-1;if((u|0)==1)ggb(k[e+-4>>2]|0)}k[(k[A>>2]|0)+(v<<2)>>2]=0-d;o[(k[w>>2]|0)+(d<<2)>>2]=+p[b+8>>3];d=d+1|0}else{do if((k[b>>2]&7|0)==1){e=k[b+8>>2]|0;if((e|0)<=(v|0)){vb=341;break}if((e|0)>=(k[(k[B>>2]|0)+24>>2]|0))vb=341}else vb=341;while(0);if((vb|0)==341){vb=0;k[sb>>2]=F;k[sb+4>>2]=D;k[sb+8>>2]=v;Cfb(Ka,382037,sb);k[Wa>>2]=0;k[oa>>2]=0;v:do if(Ba){e=Ka;vb=344}else{f=Ka;e=Aa;while(1){if(!(i[f>>0]|0))break v;f=f+1|0;e=f;if(!(e&3)){e=f;vb=344;break}}}while(0);if((vb|0)==344){vb=0;while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}u=e-Aa|0;e=ZT(u+8&-4)|0;k[e>>2]=1;t=e+4|0;k[Wa>>2]=t;k[oa>>2]=u;i[t+u>>0]=0;upb(t|0,Ka|0,u|0)|0;Y8(-2,Wa,380674,380444,2310);k[oa>>2]=0;k[Wa>>2]=0;u=k[e>>2]|0;k[e>>2]=u+-1;if((u|0)==1)ggb(k[e+-4>>2]|0);e=k[b+8>>2]|0}k[(k[A>>2]|0)+(v<<2)>>2]=e}e=(k[ca>>2]|0)+16|0;k[ca>>2]=e;if(e>>>0>=(k[na>>2]|0)>>>0){u=k[(k[M>>2]|0)+4>>2]|0;k[M>>2]=u;e=k[u+16>>2]|0;k[ca>>2]=e;s=e;t=k[(k[I>>2]|0)+28>>2]|0;u=k[u+12>>2]|0;k[N>>2]=s;u=s+(aa(t,u)|0)|0;k[na>>2]=u}v=v+1|0}while((v|0)<(k[(k[B>>2]|0)+24>>2]|0))}else d=0;if((d|0)!=((k[C>>2]|0)+1|0)){k[_a>>2]=F;k[_a+4>>2]=D;Cfb(Ka,382240,_a);k[Va>>2]=0;k[ba>>2]=0;w:do if(Ba){d=Ka;vb=397}else{e=Ka;d=Aa;while(1){if(!(i[e>>0]|0))break w;e=e+1|0;d=e;if(!(d&3)){d=e;vb=397;break}}}while(0);if((vb|0)==397){vb=0;while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}C=d-Aa|0;d=ZT(C+8&-4)|0;k[d>>2]=1;B=d+4|0;k[Va>>2]=B;k[ba>>2]=C;i[B+C>>0]=0;upb(B|0,Ka|0,C|0)|0;Y8(-2,Va,380674,380444,2347);k[ba>>2]=0;k[Va>>2]=0;C=k[d>>2]|0;k[d>>2]=C+-1;if((C|0)==1)ggb(k[d+-4>>2]|0)}d=(k[Z>>2]|0)+16|0;k[Z>>2]=d;if(d>>>0>=(k[$>>2]|0)>>>0){C=k[(k[K>>2]|0)+4>>2]|0;k[K>>2]=C;d=k[C+16>>2]|0;k[Z>>2]=d;A=d;B=k[(k[H>>2]|0)+28>>2]|0;C=k[C+12>>2]|0;k[L>>2]=A;C=A+(aa(B,C)|0)|0;k[$>>2]=C}D=D+1|0}while((D|0)<(k[(k[E>>2]|0)+24>>2]|0))}f=k6(a,c,380626)|0;if(!((f|0)!=0?(k[f>>2]&7|0)==2:0)){k[$a>>2]=F;Cfb(Ka,382302,$a);k[Sa>>2]=0;k[U>>2]=0;x:do if(Ba){d=Ka;vb=413}else{e=Ka;d=Aa;while(1){if(!(i[e>>0]|0))break x;e=e+1|0;d=e;if(!(d&3)){d=e;vb=413;break}}}while(0);if((vb|0)==413){vb=0;while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}E=d-Aa|0;d=ZT(E+8&-4)|0;k[d>>2]=1;D=d+4|0;k[Sa>>2]=D;k[U>>2]=E;i[D+E>>0]=0;upb(D|0,Ka|0,E|0)|0;Y8(-2,Sa,380674,380444,2357);k[U>>2]=0;k[Sa>>2]=0;E=k[d>>2]|0;k[d>>2]=E+-1;if((E|0)==1)ggb(k[d+-4>>2]|0)}o[(k[T>>2]|0)+(F*24|0)+4>>2]=+p[f+8>>3];f=k6(a,c,380642)|0;if((((f|0)!=0?(k[f>>2]&7|0)==1:0)?(Ha=k[f+8>>2]|0,(Ha|0)>=-1):0)?(Ha|0)<(k[Y>>2]|0):0)f=Ha;else{k[ab>>2]=F;Cfb(Ka,382350,ab);k[Sa>>2]=0;k[V>>2]=0;y:do if(Ba){d=Ka;vb=428}else{e=Ka;d=Aa;while(1){if(!(i[e>>0]|0))break y;e=e+1|0;d=e;if(!(d&3)){d=e;vb=428;break}}}while(0);if((vb|0)==428){vb=0;while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}E=d-Aa|0;d=ZT(E+8&-4)|0;k[d>>2]=1;D=d+4|0;k[Sa>>2]=D;k[V>>2]=E;i[D+E>>0]=0;upb(D|0,Ka|0,E|0)|0;Y8(-2,Sa,380674,380444,2369);k[V>>2]=0;k[Sa>>2]=0;E=k[d>>2]|0;k[d>>2]=E+-1;if((E|0)==1)ggb(k[d+-4>>2]|0);f=k[f+8>>2]|0}e=k6(a,c,380649)|0;if((((e|0)!=0?(k[e>>2]&7|0)==1:0)?(Ia=k[e+8>>2]|0,(Ia|0)>=-1):0)?(Ia|0)<(k[Y>>2]|0):0)d=Ia;else{k[bb>>2]=F;Cfb(Ka,382392,bb);k[Sa>>2]=0;k[W>>2]=0;z:do if(Ba){c=Ka;vb=443}else{d=Ka;c=Aa;while(1){if(!(i[d>>0]|0))break z;d=d+1|0;c=d;if(!(c&3)){c=d;vb=443;break}}}while(0);if((vb|0)==443){vb=0;while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}E=c-Aa|0;c=ZT(E+8&-4)|0;k[c>>2]=1;D=c+4|0;k[Sa>>2]=D;k[W>>2]=E;i[D+E>>0]=0;upb(D|0,Ka|0,E|0)|0;Y8(-2,Sa,380674,380444,2377);k[W>>2]=0;k[Sa>>2]=0;E=k[c>>2]|0;k[c>>2]=E+-1;if((E|0)==1)ggb(k[c+-4>>2]|0);d=k[e+8>>2]|0}c=k[T>>2]|0;k[c+(F*24|0)+20>>2]=f;k[c+(F*24|0)+12>>2]=d;k[c+(F*24|0)+16>>2]=-1;if((f|0)!=-1?(Ja=c+(f*24|0)+16|0,(k[Ja>>2]|0)==-1):0)k[Ja>>2]=F;c=(k[R>>2]|0)+16|0;k[R>>2]=c;if(c>>>0>=(k[X>>2]|0)>>>0){E=k[(k[Ca>>2]|0)+4>>2]|0;k[Ca>>2]=E;c=k[E+16>>2]|0;k[R>>2]=c;C=c;D=k[(k[Q>>2]|0)+28>>2]|0;E=k[E+12>>2]|0;k[J>>2]=C;E=C+(aa(D,E)|0)|0;k[X>>2]=E}F=F+1|0}while((F|0)<(Fa|0));r=wb;return Ga|0}function tSa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;y=r;r=r+288|0;x=y+16|0;w=y+8|0;v=y;u=y+24|0;g6(a,b,6,380354);g6(a,380512,13,0);p6(a,0,k[c+8>>2]|0);p6(a,0,k[c+12>>2]|0);_4(a);g6(a,380517,5,0);t=c+4|0;if((k[t>>2]|0)<=0){_4(a);_4(a);r=y;return}s=c+32|0;q=0;do{g6(a,0,6,0);k[v>>2]=q;Cfb(u,380524,v);v6(a,u);g6(a,380533,5,0);d=k[s>>2]|0;if((k[d+(q*24|0)>>2]|0)>0){p=0;do{d=k[d+(q*24|0)+8>>2]|0;g6(a,0,5,0);k[w>>2]=p;Cfb(u,380539,w);v6(a,u);h=d+(p*24|0)|0;if((k[h>>2]|0)>0){j=d+(p*24|0)+4|0;l=d+(p*24|0)+8|0;m=d+(p*24|0)+12|0;n=d+(p*24|0)+16|0;g=d+(p*24|0)+20|0;f=0;do{e=k[j>>2]|0;g6(a,0,6,0);if(!f){d=u;b=380555;c=d+10|0;do{i[d>>0]=i[b>>0]|0;d=d+1|0;b=b+1|0}while((d|0)<(c|0))}else{k[x>>2]=f;Cfb(u,380547,x)}v6(a,u);g6(a,380565,6,0);g6(a,380573,5,0);d=e+(f<<6)+12|0;if((k[d>>2]|0?(g6(a,0,13,0),p6(a,0,k[e+(f<<6)+4>>2]|0),p6(a,0,k[e+(f<<6)+8>>2]|0),p6(a,0,k[d>>2]|0),p6(a,0,k[e+(f<<6)+16>>2]|0),u6(a,0,+o[e+(f<<6)+20>>2]),_4(a),A=e+(f<<6)+32|0,k[A>>2]|0):0)?(g6(a,0,13,0),p6(a,0,k[e+(f<<6)+24>>2]|0),p6(a,0,k[e+(f<<6)+28>>2]|0),p6(a,0,k[A>>2]|0),p6(a,0,k[e+(f<<6)+36>>2]|0),u6(a,0,+o[e+(f<<6)+40>>2]),_4(a),z=e+(f<<6)+52|0,k[z>>2]|0):0){g6(a,0,13,0);p6(a,0,k[e+(f<<6)+44>>2]|0);p6(a,0,k[e+(f<<6)+48>>2]|0);p6(a,0,k[z>>2]|0);p6(a,0,k[e+(f<<6)+56>>2]|0);u6(a,0,+o[e+(f<<6)+60>>2]);_4(a)}_4(a);p6(a,380579,k[e+(f<<6)>>2]|0);_4(a);u6(a,393853,+o[(k[l>>2]|0)+(f<<2)>>2]);d=k[(k[m>>2]|0)+(f<<2)>>2]|0;if((d|0)>0)p6(a,380586,d);else u6(a,380596,+o[(k[g>>2]|0)+(0-d<<2)>>2]);d=k[(k[n>>2]|0)+(f<<2)>>2]|0;if((d|0)>0)p6(a,380605,d);else u6(a,380616,+o[(k[g>>2]|0)+(0-d<<2)>>2]);_4(a);f=f+1|0}while((f|0)<(k[h>>2]|0))}_4(a);p=p+1|0;d=k[s>>2]|0}while((p|0)<(k[d+(q*24|0)>>2]|0))}_4(a);u6(a,380626,+o[(k[s>>2]|0)+(q*24|0)+4>>2]);p6(a,380642,k[(k[s>>2]|0)+(q*24|0)+20>>2]|0);p6(a,380649,k[(k[s>>2]|0)+(q*24|0)+12>>2]|0);_4(a);q=q+1|0}while((q|0)<(k[t>>2]|0));_4(a);_4(a);r=y;return}function uSa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;v=k[a+4>>2]|0;w=vSa(v)|0;s=a+8|0;t=k[s+4>>2]|0;u=w+8|0;k[u>>2]=k[s>>2];k[u+4>>2]=t;if((v|0)<=0)return w|0;t=a+32|0;u=w+32|0;s=0;a=k[u>>2]|0;do{d=k[t>>2]|0;k[a+(s*24|0)+20>>2]=k[d+(s*24|0)+20>>2];k[a+(s*24|0)+12>>2]=k[d+(s*24|0)+12>>2];k[a+(s*24|0)+16>>2]=k[d+(s*24|0)+16>>2];k[a+(s*24|0)+4>>2]=k[d+(s*24|0)+4>>2];k[a+(s*24|0)>>2]=0;d=ZT((k[d+(s*24|0)>>2]|0)*24|0)|0;a=k[u>>2]|0;k[a+(s*24|0)+8>>2]=d;c=k[t>>2]|0;b=k[c+(s*24|0)>>2]|0;k[a+(s*24|0)>>2]=b;a:do if((b|0)>0){a=0;do{k[d+(a*24|0)+4>>2]=0;a=a+1|0}while((a|0)!=(b|0));b=0;while(1){e=k[c+(s*24|0)+8>>2]|0;f=k[e+(b*24|0)>>2]|0;n=d+(b*24|0)|0;k[n>>2]=f;f=ZT(f*80|4)|0;o=d+(b*24|0)+4|0;k[o>>2]=f;c=k[n>>2]|0;a=f+(c<<6)|0;p=d+(b*24|0)+8|0;k[p>>2]=a;a=a+(c<<2)|0;q=d+(b*24|0)+12|0;k[q>>2]=a;a=a+(c<<2)|0;r=d+(b*24|0)+16|0;k[r>>2]=a;a=a+(c<<2)|0;m=d+(b*24|0)+20|0;k[m>>2]=a;b:do if((c|0)>0){h=e+(b*24|0)+4|0;i=e+(b*24|0)+8|0;j=e+(b*24|0)+12|0;l=e+(b*24|0)+16|0;g=e+(b*24|0)+20|0;e=0;a=f;while(1){a=a+(e<<6)|0;c=(k[h>>2]|0)+(e<<6)|0;d=a+64|0;do{k[a>>2]=k[c>>2];a=a+4|0;c=c+4|0}while((a|0)<(d|0));k[(k[p>>2]|0)+(e<<2)>>2]=k[(k[i>>2]|0)+(e<<2)>>2];k[(k[q>>2]|0)+(e<<2)>>2]=k[(k[j>>2]|0)+(e<<2)>>2];k[(k[r>>2]|0)+(e<<2)>>2]=k[(k[l>>2]|0)+(e<<2)>>2];c=k[g>>2]|0;a=k[m>>2]|0;k[a+(e<<2)>>2]=k[c+(e<<2)>>2];e=e+1|0;d=k[n>>2]|0;if((e|0)>=(d|0))break b;a=k[o>>2]|0}}else{d=c;c=k[e+(b*24|0)+20>>2]|0}while(0);k[a+(d<<2)>>2]=k[c+(d<<2)>>2];b=b+1|0;a=k[u>>2]|0;if((b|0)>=(k[a+(s*24|0)>>2]|0))break a;c=k[t>>2]|0;d=k[a+(s*24|0)+8>>2]|0}}while(0);s=s+1|0}while((s|0)!=(v|0));return w|0}function vSa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;b=g;c=(a*24|0)+40|0;if((a|0)<1){d=b+4|0;e=ZT(40)|0;k[e>>2]=1;f=e+4|0;k[b>>2]=f;k[d>>2]=35;i[e+39>>0]=0;h=380377;j=f+35|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,b,380413,380444,143);k[d>>2]=0;k[b>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0)}j=ZT(c)|0;zpb(j|0,0,c|0)|0;k[j+32>>2]=j+40;k[j>>2]=1112539136;k[j+4>>2]=a;r=g;return j|0}function wSa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0.0,g=0,h=0,j=0,l=0,m=0,n=0,q=0.0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0;da=r;r=r+144|0;l=da+112|0;m=da+84|0;s=da+56|0;n=da+52|0;t=da+48|0;ca=da;k[n>>2]=0;k[t>>2]=0;g=(a|0)!=0;if(!(g?(k[a>>2]&-65536|0)==1112539136:0)){g=g?-5:-27;h=ca+4|0;j=ZT(32)|0;k[j>>2]=1;y=j+4|0;k[ca>>2]=y;k[h>>2]=26;i[j+30>>0]=0;v=382432;z=y+26|0;do{i[y>>0]=i[v>>0]|0;y=y+1|0;v=v+1|0}while((y|0)<(z|0));Y8(g,ca,382459,380444,444);k[h>>2]=0;k[ca>>2]=0;$=k[j>>2]|0;k[j>>2]=$+-1;if(($|0)==1)ggb(k[j+-4>>2]|0)}if(e<=0.0){g=ca+4|0;h=ZT(28)|0;k[h>>2]=1;y=h+4|0;k[ca>>2]=y;k[g>>2]=22;i[h+26>>0]=0;v=382495;z=y+22|0;do{i[y>>0]=i[v>>0]|0;y=y+1|0;v=v+1|0}while((y|0)<(z|0));Y8(-211,ca,382459,380444,447);k[g>>2]=0;k[ca>>2]=0;$=k[h>>2]|0;k[h>>2]=$+-1;if(($|0)==1)ggb(k[h+-4>>2]|0)}x=G9(b,l,n,0)|0;m=G9(c,m,t,0)|0;if(k[t>>2]|k[n>>2]|0){g=ca+4|0;h=ZT(28)|0;k[h>>2]=1;y=h+4|0;k[ca>>2]=y;k[g>>2]=20;i[h+24>>0]=0;v=382518;z=y+20|0;do{i[y>>0]=i[v>>0]|0;y=y+1|0;v=v+1|0}while((y|0)<(z|0));Y8(-24,ca,382459,380444,453);k[g>>2]=0;k[ca>>2]=0;$=k[h>>2]|0;k[h>>2]=$+-1;if(($|0)==1)ggb(k[h+-4>>2]|0)}l=x+20|0;if(!((k[l>>2]|0)==(k[m+20>>2]|0)?(k[x+24>>2]|0)==(k[m+24>>2]|0):0)){g=ca+4|0;h=ZT(48)|0;k[h>>2]=1;y=h+4|0;k[ca>>2]=y;k[g>>2]=43;i[h+47>>0]=0;v=382539;z=y+43|0;do{i[y>>0]=i[v>>0]|0;y=y+1|0;v=v+1|0}while((y|0)<(z|0));Y8(-209,ca,382459,380444,456);k[g>>2]=0;k[ca>>2]=0;$=k[h>>2]|0;k[h>>2]=$+-1;if(($|0)==1)ggb(k[h+-4>>2]|0)}if(!((k[m>>2]&4095|0)==6?(k[x>>2]&4095|0)==4:0)){g=ca+4|0;h=ZT(84)|0;k[h>>2]=1;y=h+4|0;k[ca>>2]=y;k[g>>2]=77;i[h+81>>0]=0;v=382583;z=y+77|0;do{i[y>>0]=i[v>>0]|0;y=y+1|0;v=v+1|0}while((y|0)<(z|0));Y8(-210,ca,382459,380444,461);k[g>>2]=0;k[ca>>2]=0;$=k[h>>2]|0;k[h>>2]=$+-1;if(($|0)==1)ggb(k[h+-4>>2]|0)}g=a+36|0;h=k[g>>2]|0;if(!h){xSa(a);h=k[g>>2]|0}if(!(k[h+8>>2]|0))b=x+4|0;else{d=G9(d,s,t,0)|0;if((k[d>>2]&4095|0)!=4){g=ca+4|0;j=ZT(84)|0;k[j>>2]=1;y=j+4|0;k[ca>>2]=y;k[g>>2]=77;i[j+81>>0]=0;v=382583;z=y+77|0;do{i[y>>0]=i[v>>0]|0;y=y+1|0;v=v+1|0}while((y|0)<(z|0));Y8(-210,ca,382459,380444,474);k[g>>2]=0;k[ca>>2]=0;$=k[j>>2]|0;k[j>>2]=$+-1;if(($|0)==1)ggb(k[j+-4>>2]|0)}b=x+4|0;if((k[b>>2]|0)!=(k[d+4>>2]|0)){g=ca+4|0;j=ZT(68)|0;k[j>>2]=1;y=j+4|0;k[ca>>2]=y;k[g>>2]=62;i[j+66>>0]=0;v=382661;z=y+62|0;do{i[y>>0]=i[v>>0]|0;y=y+1|0;v=v+1|0}while((y|0)<(z|0));Y8(-209,ca,382459,380444,478);k[g>>2]=0;k[ca>>2]=0;$=k[j>>2]|0;k[j>>2]=$+-1;if(($|0)==1)ggb(k[j+-4>>2]|0)}if(!((k[l>>2]|0)==(k[d+20>>2]|0)?(k[x+24>>2]|0)==(k[d+24>>2]|0):0)){g=ca+4|0;j=ZT(48)|0;k[j>>2]=1;y=j+4|0;k[ca>>2]=y;k[g>>2]=43;i[j+47>>0]=0;v=382539;z=y+43|0;do{i[y>>0]=i[v>>0]|0;y=y+1|0;v=v+1|0}while((y|0)<(z|0));Y8(-209,ca,382459,380444,481);k[g>>2]=0;k[ca>>2]=0;$=k[j>>2]|0;k[j>>2]=$+-1;if(($|0)==1)ggb(k[j+-4>>2]|0)}$=h+80|0;k[$>>2]=k[d>>2];k[$+4>>2]=k[d+4>>2];k[$+8>>2]=k[d+8>>2];k[$+12>>2]=k[d+12>>2];k[$+16>>2]=k[d+16>>2];k[$+20>>2]=k[d+20>>2];k[$+24>>2]=k[d+24>>2]}p[a+24>>3]=e;j=a+8|0;f=+(k[j>>2]|0)*e;p[u>>3]=f;g=k[u+4>>2]|0;$=g&2146435072;if(!($>>>0>1126170624|($|0)==1126170624&0>0)){g=(g|0)<0;f=g?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=g?-0.0:0.0}k[a+16>>2]=~~f;c=a+12|0;f=+(k[c>>2]|0)*e;p[u>>3]=f;g=k[u+4>>2]|0;$=g&2146435072;if(!($>>>0>1126170624|($|0)==1126170624&0>0)){g=(g|0)<0;f=g?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=g?-0.0:0.0}k[a+20>>2]=~~f;g=h+24|0;k[g>>2]=k[x>>2];k[g+4>>2]=k[x+4>>2];k[g+8>>2]=k[x+8>>2];k[g+12>>2]=k[x+12>>2];k[g+16>>2]=k[x+16>>2];k[g+20>>2]=k[x+20>>2];k[g+24>>2]=k[x+24>>2];g=h+52|0;k[g>>2]=k[m>>2];k[g+4>>2]=k[m+4>>2];k[g+8>>2]=k[m+8>>2];k[g+12>>2]=k[m+12>>2];k[g+16>>2]=k[m+16>>2];k[g+20>>2]=k[m+20>>2];k[g+24>>2]=k[m+24>>2];p[u>>3]=e;g=k[u+4>>2]|0;$=g&2146435072;if(!($>>>0>1126170624|($|0)==1126170624&0>0)){g=(g|0)<0;f=g?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=g?-0.0:0.0}else f=e;l=~~f;f=+((k[j>>2]|0)+-2|0)*e;p[u>>3]=f;g=k[u+4>>2]|0;$=g&2146435072;if(!($>>>0>1126170624|($|0)==1126170624&0>0)){g=(g|0)<0;f=g?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=g?-0.0:0.0}j=~~f;f=+((k[c>>2]|0)+-2|0)*e;p[u>>3]=f;g=k[u+4>>2]|0;$=g&2146435072;if(!($>>>0>1126170624|($|0)==1126170624&0>0)){g=(g|0)<0;f=g?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(f==0.0)f=g?-0.0:0.0}Y=~~f;ba=1.0/+(aa(Y,j)|0);p[h+16>>3]=ba;$=x+16|0;_=k[b>>2]|0;V=aa(_,l)|0;U=l<<2;k[h+128>>2]=(k[$>>2]|0)+V+U;Z=j+l|0;X=Z<<2;k[h+132>>2]=(k[$>>2]|0)+V+X;Y=Y+l|0;V=aa(_,Y)|0;k[h+136>>2]=(k[$>>2]|0)+V+U;k[h+140>>2]=(k[$>>2]|0)+V+X;X=m+16|0;V=k[m+4>>2]|0;U=aa(V,l)|0;W=l<<3;k[h+112>>2]=(k[X>>2]|0)+U+W;Z=Z<<3;k[h+116>>2]=(k[X>>2]|0)+U+Z;Y=aa(V,Y)|0;k[h+120>>2]=(k[X>>2]|0)+Y+W;k[h+124>>2]=(k[X>>2]|0)+Y+Z;Z=k[a+4>>2]|0;if((Z|0)<=0){r=da;return}U=a+32|0;V=ca+4|0;W=ca+8|0;X=ca+12|0;Y=d+16|0;T=d+4|0;G=k[h+108>>2]|0;J=ca+16|0;K=ca+24|0;L=ca+28|0;M=ca+20|0;N=ca+32|0;O=ca+40|0;P=ca+44|0;Q=ca+36|0;D=0;do{R=k[G+(D*28|0)>>2]|0;if((R|0)>0){H=k[G+(D*28|0)+8>>2]|0;F=0;do{if((k[H+(F*12|0)>>2]|0)>0){I=k[(k[(k[U>>2]|0)+(D*24|0)+8>>2]|0)+(F*24|0)+4>>2]|0;E=0;do{S=k[H+(F*12|0)+4>>2]|0;y=ca;z=y+48|0;do{k[y>>2]=0;y=y+4|0}while((y|0)<(z|0));do if(!(k[S+(E*72|0)>>2]|0)){g=-1;h=-1;C=0;j=0;b=0;d=0;l=0}else{j=I+(E<<6)+4|0;k[ca>>2]=k[j>>2];k[ca+4>>2]=k[j+4>>2];k[ca+8>>2]=k[j+8>>2];k[ca+12>>2]=k[j+12>>2];j=k[W>>2]|0;h=j+-1|0;d=k[ca>>2]|0;b=k[X>>2]|0;g=b+-1|0;l=k[V>>2]|0;if(!(k[S+(E*72|0)+20>>2]|0)){C=1;break}C=I+(E<<6)+24|0;k[J>>2]=k[C>>2];k[J+4>>2]=k[C+4>>2];k[J+8>>2]=k[C+8>>2];k[J+12>>2]=k[C+12>>2];C=(k[K>>2]|0)+-1|0;h=(h>>>0>=C>>>0?C^h:0)^h;C=(k[J>>2]|0)-d+-1|0;h=(h>>>0>=C>>>0?h^C:0)^h;C=(k[L>>2]|0)+-1|0;g=(g>>>0>=C>>>0?C^g:0)^g;C=(k[M>>2]|0)-l+-1|0;g=(g>>>0>=C>>>0?g^C:0)^g;if(!(k[S+(E*72|0)+40>>2]|0)){C=2;break}C=I+(E<<6)+44|0;k[N>>2]=k[C>>2];k[N+4>>2]=k[C+4>>2];k[N+8>>2]=k[C+8>>2];k[N+12>>2]=k[C+12>>2];C=(k[O>>2]|0)+-1|0;h=(h>>>0>=C>>>0?C^h:0)^h;C=(k[N>>2]|0)-d+-1|0;B=(k[P>>2]|0)+-1|0;g=(g>>>0>=B>>>0?B^g:0)^g;B=(k[Q>>2]|0)-l+-1|0;g=(g>>>0>=B>>>0?g^B:0)^g;h=(h>>>0>=C>>>0?h^C:0)^h;C=3}while(0);B=h+1|0;a=g+1|0;h=(j|0)/(B|0)|0;m=(b|0)/(a|0)|0;if((h|0)<1){f=+(j|0)*e;p[u>>3]=f;g=k[u+4>>2]|0;z=g&2146435072;do if(!(z>>>0>1126170624|(z|0)==1126170624&0>0)){g=(g|0)<0;f=g?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(!(f==0.0))break;f=g?-0.0:0.0}while(0);h=(~~f|0)/(h|0)|0;f=+(d|0)*e;p[u>>3]=f;g=k[u+4>>2]|0;z=g&2146435072;do if(!(z>>>0>1126170624|(z|0)==1126170624&0>0)){g=(g|0)<0;f=g?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(!(f==0.0))break;f=g?-0.0:0.0}while(0);z=~~f;c=1}else{z=0;c=0;h=0}if((m|0)<1){f=+(b|0)*e;p[u>>3]=f;g=k[u+4>>2]|0;y=g&2146435072;do if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){g=(g|0)<0;f=g?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(!(f==0.0))break;f=g?-0.0:0.0}while(0);b=(~~f|0)/(m|0)|0;f=+(l|0)*e;p[u>>3]=f;g=k[u+4>>2]|0;y=g&2146435072;do if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){g=(g|0)<0;f=g?f+-4503599627370496.0+4503599627370496.0:f+4503599627370496.0+-4503599627370496.0;if(!(f==0.0))break;f=g?-0.0:0.0}while(0);y=~~f;g=1}else{y=0;g=0;b=0}a:do if(!C){q=0.0;f=0.0}else{x=(c|0)==0;t=(g|0)==0;v=(k[I+(E<<6)>>2]|0)!=0;A=ba*(v?.5:1.0);q=0.0;f=0.0;s=0;g=d;while(1){if(x){w=+(g|0)*e;p[u>>3]=w;g=k[u+4>>2]|0;n=g&2146435072;do if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){g=(g|0)<0;w=g?w+-4503599627370496.0+4503599627370496.0:w+4503599627370496.0+-4503599627370496.0;if(!(w==0.0))break;w=g?-0.0:0.0}while(0);c=~~w;w=+(j|0)*e;p[u>>3]=w;g=k[u+4>>2]|0;n=g&2146435072;do if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){g=(g|0)<0;w=g?w+-4503599627370496.0+4503599627370496.0:w+4503599627370496.0+-4503599627370496.0;if(!(w==0.0))break;w=g?-0.0:0.0}while(0);n=~~w}else{c=((aa(g-d|0,h)|0)/(B|0)|0)+z|0;n=(aa(j,h)|0)/(B|0)|0}g=k[ca+(s<<4)+4>>2]|0;m=k[ca+(s<<4)+12>>2]|0;if(t){w=+(g|0)*e;p[u>>3]=w;g=k[u+4>>2]|0;j=g&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){g=(g|0)<0;w=g?w+-4503599627370496.0+4503599627370496.0:w+4503599627370496.0+-4503599627370496.0;if(!(w==0.0))break;w=g?-0.0:0.0}while(0);j=~~w;w=+(m|0)*e;p[u>>3]=w;g=k[u+4>>2]|0;m=g&2146435072;do if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){g=(g|0)<0;w=g?w+-4503599627370496.0+4503599627370496.0:w+4503599627370496.0+-4503599627370496.0;if(!(w==0.0))break;w=g?-0.0:0.0}while(0);g=j;j=~~w}else{g=((aa(g-l|0,b)|0)/(a|0)|0)+y|0;j=(aa(m,b)|0)/(a|0)|0}if(v){m=k[T>>2]|0;fa=g+n|0;ea=c+n|0;ga=(k[Y>>2]|0)+(aa(m,fa)|0)+(ea<<2)|0;k[S+(E*72|0)+(s*20|0)+8>>2]=ga;ea=(k[Y>>2]|0)+(aa(m,fa+j|0)|0)+(ea-j<<2)|0;k[S+(E*72|0)+(s*20|0)+12>>2]=ea;ea=(k[Y>>2]|0)+(aa(m,g)|0)+(c<<2)|0;k[S+(E*72|0)+(s*20|0)>>2]=ea;m=(k[Y>>2]|0)+(aa(m,g+j|0)|0)+(c-j<<2)|0;k[S+(E*72|0)+(s*20|0)+4>>2]=m}else{fa=aa(_,g)|0;ea=c<<2;k[S+(E*72|0)+(s*20|0)>>2]=(k[$>>2]|0)+fa+ea;ga=c+n<<2;k[S+(E*72|0)+(s*20|0)+4>>2]=(k[$>>2]|0)+fa+ga;fa=aa(_,g+j|0)|0;k[S+(E*72|0)+(s*20|0)+8>>2]=(k[$>>2]|0)+fa+ea;k[S+(E*72|0)+(s*20|0)+12>>2]=(k[$>>2]|0)+fa+ga}w=A*+o[I+(E<<6)+4+(s*20|0)+16>>2];o[S+(E*72|0)+(s*20|0)+16>>2]=w;if(!s)q=+(aa(j,n)|0);else f=f+ +(j|0)*(+(n|0)*w);j=s+1|0;if((j|0)==(C|0))break a;s=j;g=k[ca+(j<<4)>>2]|0;j=k[ca+(j<<4)+8>>2]|0}}while(0);o[S+(E*72|0)+16>>2]=-f/q;E=E+1|0}while((E|0)<(k[H+(F*12|0)>>2]|0))}F=F+1|0}while((F|0)!=(R|0))}D=D+1|0}while((D|0)!=(Z|0));r=da;return}function xSa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+1040|0;E=J+8|0;D=J;A=J+32|0;B=J+24|0;b=(a|0)!=0;if(!(b?(k[a>>2]&-65536|0)==1112539136:0)){b=b?-5:-27;c=B+4|0;d=ZT(32)|0;k[d>>2]=1;w=d+4|0;k[B>>2]=w;k[c>>2]=26;i[d+30>>0]=0;f=382432;x=w+26|0;do{i[w>>0]=i[f>>0]|0;w=w+1|0;f=f+1|0}while((w|0)<(x|0));Y8(b,B,382724,380444,203);k[c>>2]=0;k[B>>2]=0;I=k[d>>2]|0;k[d>>2]=I+-1;if((I|0)==1)ggb(k[d+-4>>2]|0)}I=a+36|0;if(k[I>>2]|0){b=B+4|0;c=ZT(44)|0;k[c>>2]=1;w=c+4|0;k[B>>2]=w;k[b>>2]=36;i[c+40>>0]=0;f=382758;x=w+36|0;do{i[w>>0]=i[f>>0]|0;w=w+1|0;f=f+1|0}while((w|0)<(x|0));Y8(-2,B,382724,380444,206);k[b>>2]=0;k[B>>2]=0;H=k[c>>2]|0;k[c>>2]=H+-1;if((H|0)==1)ggb(k[c+-4>>2]|0)}H=a+32|0;if((k[H>>2]|0)==0?(G=B+4|0,e=ZT(8)|0,k[e>>2]=1,z=e+4|0,k[B>>2]=z,k[G>>2]=0,i[z>>0]=0,Y8(-27,B,382724,380444,209),k[G>>2]=0,k[B>>2]=0,G=k[e>>2]|0,k[e>>2]=G+-1,(G|0)==1):0)ggb(k[e+-4>>2]|0);G=a+4|0;if((k[G>>2]|0)<1){b=B+4|0;c=ZT(40)|0;k[c>>2]=1;w=c+4|0;k[B>>2]=w;k[b>>2]=33;i[c+37>>0]=0;f=382795;x=w+33|0;do{i[w>>0]=i[f>>0]|0;w=w+1|0;f=f+1|0}while((w|0)<(x|0));Y8(-211,B,382724,380444,212);k[b>>2]=0;k[B>>2]=0;z=k[c>>2]|0;k[c>>2]=z+-1;if((z|0)==1)ggb(k[c+-4>>2]|0);b=k[G>>2]|0;c=a+8|0;if((b|0)>0){z=k[c>>2]|0;u=k[c+4>>2]|0;F=19}else{a=0;c=0;e=0}}else{u=a+8|0;z=k[u>>2]|0;u=k[u+4>>2]|0;F=19}if((F|0)==19){v=B+4|0;w=B+4|0;x=A;y=(x&3|0)==0;a=0;c=0;e=0;t=0;do{s=k[H>>2]|0;f=s+(t*24|0)|0;s=s+(t*24|0)+8|0;if((k[s>>2]|0)!=0?(C=k[f>>2]|0,(C|0)>=1):0){q=f;a=C+a|0;F=34}else{k[D>>2]=t;Cfb(A,382829,D);k[B>>2]=0;k[v>>2]=0;a:do if(y){b=A;F=26}else{d=A;b=x;while(1){if(!(i[d>>0]|0))break a;d=d+1|0;b=d;if(!(b&3)){b=d;F=26;break}}}while(0);if((F|0)==26){F=0;while(1){d=k[b>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))b=b+4|0;else break}if((d&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}q=b-x|0;b=ZT(q+8&-4)|0;k[b>>2]=1;p=b+4|0;k[B>>2]=p;k[v>>2]=q;i[p+q>>0]=0;upb(p|0,A|0,q|0)|0;Y8(-2,B,382724,380444,227);k[v>>2]=0;k[B>>2]=0;q=k[b>>2]|0;k[b>>2]=q+-1;if((q|0)==1)ggb(k[b+-4>>2]|0);q=k[f>>2]|0;a=q+a|0;if((q|0)>0){q=f;F=34}}if((F|0)==34){F=0;p=0;do{b=k[s>>2]|0;n=b+(p*24|0)|0;m=k[n>>2]|0;c=m+c|0;if((m|0)>0){m=b+(p*24|0)+4|0;l=0;do{j=0;do{b=k[m>>2]|0;h=k[b+(l<<6)+4+(j*20|0)+8>>2]|0;b:do if(h){d=k[b+(l<<6)+4+(j*20|0)>>2]|0;g=k[b+(l<<6)+4+(j*20|0)+4>>2]|0;f=k[b+(l<<6)+4+(j*20|0)+12>>2]|0;b=(k[b+(l<<6)>>2]|0)!=0;e=b&1|e;do if(!((d+h|0)>(z|0)|(g|h|f|0)<0)){if(!b)if((d|0)<0|(f+g|0)>(u|0))break;else break b;if((d|0)>=(f|0)?(g+h+f|0)<=(u|0):0)break b}while(0);k[E>>2]=j;k[E+4>>2]=p;k[E+8>>2]=t;Cfb(A,382927,E);k[B>>2]=0;k[w>>2]=0;c:do if(y){b=A;F=47}else{d=A;b=x;while(1){if(!(i[d>>0]|0))break c;d=d+1|0;b=d;if(!(b&3)){b=d;F=47;break}}}while(0);if((F|0)==47){F=0;while(1){d=k[b>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))b=b+4|0;else break}if((d&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}h=b-x|0;b=ZT(h+8&-4)|0;k[b>>2]=1;g=b+4|0;k[B>>2]=g;k[w>>2]=h;i[g+h>>0]=0;upb(g|0,A|0,h|0)|0;Y8(-27,B,382724,380444,259);k[w>>2]=0;k[B>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0)}while(0);j=j+1|0}while((j|0)<3);l=l+1|0}while((l|0)<(k[n>>2]|0))}p=p+1|0}while((p|0)<(k[q>>2]|0))}t=t+1|0;b=k[G>>2]|0}while((t|0)<(b|0))}z=ZT((c*72|0)+152+(a*12|0)+(a+c<<2)+(b*28|0)|0)|0;zpb(z|0,0,152)|0;f=k[G>>2]|0;k[z>>2]=f;d=z+152|0;A=z+108|0;k[A>>2]=d;b=d+(f*28|0)|0;B=z+4|0;k[B>>2]=1;k[z+8>>2]=e;y=z+12|0;k[y>>2]=0;if((f|0)<=0){k[I>>2]=z;r=J;return}g=b;c=b+(a*12|0)|0;b=0;a=0;e=f;while(1){f=k[H>>2]|0;s=f+(b*24|0)|0;F=k[s>>2]|0;k[d+(b*28|0)>>2]=F;o[d+(b*28|0)+4>>2]=+o[f+(b*24|0)+4>>2]+-9.999999747378752e-05;t=d+(b*28|0)+8|0;k[t>>2]=g;u=d+(b*28|0)+12|0;k[u>>2]=1;v=g+(F*12|0)|0;E=k[f+(b*24|0)+20>>2]|0;k[d+(b*28|0)+24>>2]=(E|0)==-1?0:d+(E*28|0)|0;E=k[f+(b*24|0)+12>>2]|0;E=(E|0)==-1?0:d+(E*28|0)|0;k[d+(b*28|0)+16>>2]=E;D=k[f+(b*24|0)+16>>2]|0;k[d+(b*28|0)+20>>2]=(D|0)==-1?0:d+(D*28|0)|0;k[y>>2]=(E|0)!=0|a;if((F|0)>0){q=f+(b*24|0)+8|0;d=0;e=g;while(1){l=k[q>>2]|0;p=k[l+(d*24|0)>>2]|0;m=c+(p*72|0)|0;k[e+(d*12|0)>>2]=p;n=e+(d*12|0)+4|0;k[n>>2]=c;k[e+(d*12|0)+8>>2]=m;d:do if((p|0)>0){a=l+(d*24|0)+4|0;g=l+(d*24|0)+8|0;h=l+(d*24|0)+12|0;j=l+(d*24|0)+16|0;f=0;while(1){e=k[a>>2]|0;w=c+(f*72|0)|0;x=w+72|0;do{k[w>>2]=-1;w=w+4|0}while((w|0)<(x|0));k[c+(f*72|0)+60>>2]=k[(k[g>>2]|0)+(f<<2)>>2];k[c+(f*72|0)+64>>2]=k[(k[h>>2]|0)+(f<<2)>>2];k[c+(f*72|0)+68>>2]=k[(k[j>>2]|0)+(f<<2)>>2];if((!(+P(+(+o[e+(f<<6)+60>>2]))<2.220446049250313e-16)?(k[e+(f<<6)+52>>2]|0)!=0:0)?(k[e+(f<<6)+56>>2]|0)!=0:0)k[u>>2]=0;else{F=c+(f*72|0)+40|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;k[F+16>>2]=0}c=f+1|0;if((c|0)==(p|0))break d;f=c;c=k[n>>2]|0}}while(0);upb(m|0,k[l+(d*24|0)+20>>2]|0,(p<<2)+4|0)|0;c=m+(p<<2)+4+3&-4;k[B>>2]=k[B>>2]&(p|0)==1;d=d+1|0;if((d|0)>=(k[s>>2]|0))break;e=k[t>>2]|0}e=k[G>>2]|0}b=b+1|0;if((b|0)>=(e|0))break;g=v;d=k[A>>2]|0;a=k[y>>2]|0}k[I>>2]=z;r=J;return}function ySa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0,q=0,s=0,t=0.0,u=0,v=0;v=r;r=r+16|0;q=v;f=(a|0)!=0;if(!(f?(k[a>>2]&-65536|0)==1112539136:0)){f=f?-5:-27;g=q+4|0;h=ZT(28)|0;k[h>>2]=1;j=h+4|0;k[q>>2]=j;k[g>>2]=23;i[h+27>>0]=0;m=383045;n=j+23|0;do{i[j>>0]=i[m>>0]|0;j=j+1|0;m=m+1|0}while((j|0)<(n|0));Y8(f,q,383069,380444,843);k[g>>2]=0;k[q>>2]=0;u=k[h>>2]|0;k[h>>2]=u+-1;if((u|0)==1)ggb(k[h+-4>>2]|0)}s=k[a+36>>2]|0;if(!s){f=q+4|0;g=ZT(84)|0;k[g>>2]=1;j=g+4|0;k[q>>2]=j;k[f>>2]=76;i[g+80>>0]=0;m=383099;n=j+76|0;do{i[j>>0]=i[m>>0]|0;j=j+1|0;m=m+1|0}while((j|0)<(n|0));Y8(-27,q,383069,380444,848);k[f>>2]=0;k[q>>2]=0;u=k[g>>2]|0;k[g>>2]=u+-1;if((u|0)==1)ggb(k[g+-4>>2]|0)}if((c|b|0)<0){d=-1;r=v;return d|0}if(((k[a+16>>2]|0)+b|0)>=(k[s+48>>2]|0)){d=-1;r=v;return d|0}if(((k[a+20>>2]|0)+c|0)>=(k[s+44>>2]|0)){d=-1;r=v;return d|0}u=(aa((k[s+28>>2]|0)>>>2,c)|0)+b|0;c=(aa((k[s+56>>2]|0)>>>3,c)|0)+b|0;t=+p[s+16>>3];e=t*+((k[(k[s+128>>2]|0)+(u<<2)>>2]|0)-(k[(k[s+132>>2]|0)+(u<<2)>>2]|0)-(k[(k[s+136>>2]|0)+(u<<2)>>2]|0)+(k[(k[s+140>>2]|0)+(u<<2)>>2]|0)|0);e=t*(+p[(k[s+112>>2]|0)+(c<<3)>>3]-+p[(k[s+116>>2]|0)+(c<<3)>>3]-+p[(k[s+120>>2]|0)+(c<<3)>>3]+ +p[(k[s+124>>2]|0)+(c<<3)>>3])-e*e;if(!(e>=0.0))t=1.0;else t=+Q(+e);if(k[s+12>>2]|0){f=k[s+108>>2]|0;if(!f){d=1;r=v;return d|0}a:while(1){p[d>>3]=0.0;j=k[f>>2]|0;if((j|0)>0){h=k[f+8>>2]|0;g=0;e=0.0;do{e=+zSa(h+(g*12|0)|0,t,u)+e;p[d>>3]=e;g=g+1|0}while((g|0)!=(j|0))}else e=0.0;if(e>=+o[f+4>>2]){f=k[f+20>>2]|0;if(!f){f=1;g=47;break}else continue}while(1){g=k[f+16>>2]|0;if(g|0){f=g;continue a}f=k[f+24>>2]|0;if(!f){f=0;g=47;break a}}}if((g|0)==47){r=v;return f|0}}q=k[s>>2]|0;n=(q|0)>0;if(!(k[s+4>>2]|0)){if(!n){d=1;r=v;return d|0}m=k[s+108>>2]|0;j=0;while(1){p[d>>3]=0.0;h=k[m+(j*28|0)>>2]|0;if((h|0)>0){g=k[m+(j*28|0)+8>>2]|0;f=0;e=0.0;do{e=+zSa(g+(f*12|0)|0,t,u)+e;p[d>>3]=e;f=f+1|0}while((f|0)!=(h|0))}else e=0.0;if(e<+o[m+(j*28|0)+4>>2]){f=0-j|0;g=47;break}j=j+1|0;if((j|0)>=(q|0)){f=1;g=47;break}}if((g|0)==47){r=v;return f|0}}if(!n){d=1;r=v;return d|0}n=k[s+108>>2]|0;a=0;while(1){m=k[n+(a*28|0)>>2]|0;f=(m|0)>0;if(!(k[n+(a*28|0)+12>>2]|0))if(f){j=k[n+(a*28|0)+8>>2]|0;h=0;e=0.0;do{g=k[j+(h*12|0)+4>>2]|0;l=+o[g+16>>2]*+((k[(k[g>>2]|0)+(u<<2)>>2]|0)-(k[(k[g+4>>2]|0)+(u<<2)>>2]|0)-(k[(k[g+8>>2]|0)+(u<<2)>>2]|0)+(k[(k[g+12>>2]|0)+(u<<2)>>2]|0)|0)+ +o[g+36>>2]*+((k[(k[g+20>>2]|0)+(u<<2)>>2]|0)-(k[(k[g+24>>2]|0)+(u<<2)>>2]|0)-(k[(k[g+28>>2]|0)+(u<<2)>>2]|0)+(k[(k[g+32>>2]|0)+(u<<2)>>2]|0)|0);f=k[g+40>>2]|0;if(f)l=l+ +o[g+56>>2]*+((k[f+(u<<2)>>2]|0)-(k[(k[g+44>>2]|0)+(u<<2)>>2]|0)-(k[(k[g+48>>2]|0)+(u<<2)>>2]|0)+(k[(k[g+52>>2]|0)+(u<<2)>>2]|0)|0);e=e+ +o[(k[j+(h*12|0)+8>>2]|0)+((l>=t*+o[g+60>>2]&1)<<2)>>2];h=h+1|0}while((h|0)!=(m|0))}else e=0.0;else if(f){g=k[n+(a*28|0)+8>>2]|0;f=0;e=0.0;do{s=k[g+(f*12|0)+4>>2]|0;e=e+ +o[(k[g+(f*12|0)+8>>2]|0)+((+o[s+16>>2]*+((k[(k[s>>2]|0)+(u<<2)>>2]|0)-(k[(k[s+4>>2]|0)+(u<<2)>>2]|0)-(k[(k[s+8>>2]|0)+(u<<2)>>2]|0)+(k[(k[s+12>>2]|0)+(u<<2)>>2]|0)|0)+ +o[s+36>>2]*+((k[(k[s+20>>2]|0)+(u<<2)>>2]|0)-(k[(k[s+24>>2]|0)+(u<<2)>>2]|0)-(k[(k[s+28>>2]|0)+(u<<2)>>2]|0)+(k[(k[s+32>>2]|0)+(u<<2)>>2]|0)|0)>=t*+o[s+60>>2]&1)<<2)>>2];f=f+1|0}while((f|0)!=(m|0))}else e=0.0;if(e<+o[n+(a*28|0)+4>>2]){g=39;break}f=a+1|0;if((f|0)<(q|0))a=f;else{g=46;break}}if((g|0)==39){p[d>>3]=e;d=0-a|0;r=v;return d|0}else if((g|0)==46){p[d>>3]=e;d=1;r=v;return d|0}return 0}function zSa(a,b,c){a=a|0;b=+b;c=c|0;var d=0.0,e=0,f=0,g=0;g=k[a+4>>2]|0;f=0;do{d=+o[g+(f*72|0)+16>>2]*+((k[(k[g+(f*72|0)>>2]|0)+(c<<2)>>2]|0)-(k[(k[g+(f*72|0)+4>>2]|0)+(c<<2)>>2]|0)-(k[(k[g+(f*72|0)+8>>2]|0)+(c<<2)>>2]|0)+(k[(k[g+(f*72|0)+12>>2]|0)+(c<<2)>>2]|0)|0)+ +o[g+(f*72|0)+36>>2]*+((k[(k[g+(f*72|0)+20>>2]|0)+(c<<2)>>2]|0)-(k[(k[g+(f*72|0)+24>>2]|0)+(c<<2)>>2]|0)-(k[(k[g+(f*72|0)+28>>2]|0)+(c<<2)>>2]|0)+(k[(k[g+(f*72|0)+32>>2]|0)+(c<<2)>>2]|0)|0);e=k[g+(f*72|0)+40>>2]|0;if(e)d=d+ +o[g+(f*72|0)+56>>2]*+((k[e+(c<<2)>>2]|0)-(k[(k[g+(f*72|0)+44>>2]|0)+(c<<2)>>2]|0)-(k[(k[g+(f*72|0)+48>>2]|0)+(c<<2)>>2]|0)+(k[(k[g+(f*72|0)+52>>2]|0)+(c<<2)>>2]|0)|0);f=k[(d<+o[g+(f*72|0)+60>>2]*b?g+(f*72|0)+64|0:g+(f*72|0)+68|0)>>2]|0}while((f|0)>0);return +(+o[(k[a+8>>2]|0)+(0-f<<2)>>2])}function ASa(a,b,c,d,e,f,g,h,j,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;var q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0;Ic=r;r=r+704|0;Cc=Ic+640|0;nc=Ic+584|0;oc=Ic+528|0;pc=Ic;dc=Ic+472|0;v=Ic+444|0;Fc=Ic+432|0;Dc=Ic+420|0;Ac=Ic+408|0;w=Ic+404|0;Bc=Ic+400|0;ec=Ic+372|0;fc=Ic+344|0;gc=Ic+316|0;hc=Ic+288|0;ic=Ic+260|0;jc=Ic+232|0;kc=Ic+176|0;k[Fc>>2]=0;Hc=Fc+4|0;k[Hc>>2]=0;k[Fc+8>>2]=0;k[Dc>>2]=0;Gc=Dc+4|0;k[Gc>>2]=0;k[Dc+8>>2]=0;k[Ac>>2]=0;Ec=Ac+4|0;k[Ec>>2]=0;k[Ac+8>>2]=0;qa=(h&1|0)!=0;rc=h&4;tc=(rc|0)!=0;L=(h&8|0)!=0;m9(Bc);q=(b|0)!=0;if(!(q?(k[b>>2]&-65536|0)==1112539136:0)){k[Cc>>2]=0;s=Cc+4|0;k[s>>2]=0;t=ZT(32)|0;k[t>>2]=1;P=t+4|0;k[Cc>>2]=P;k[s>>2]=26;i[t+30>>0]=0;O=383176;Q=P+26|0;do{i[P>>0]=i[O>>0]|0;P=P+1|0;O=O+1|0}while((P|0)<(Q|0));Y8(q?-5:-27,Cc,383203,380444,1520);k[s>>2]=0;k[Cc>>2]=0;yc=k[t>>2]|0;k[t>>2]=yc+-1;if((yc|0)==1)ggb(k[t+-4>>2]|0)}if(!c){k[Cc>>2]=0;q=Cc+4|0;k[q>>2]=0;s=ZT(28)|0;k[s>>2]=1;P=s+4|0;k[Cc>>2]=P;k[q>>2]=20;i[s+24>>0]=0;O=383229;Q=P+20|0;do{i[P>>0]=i[O>>0]|0;P=P+1|0;O=O+1|0}while((P|0)<(Q|0));Y8(-27,Cc,383203,380444,1523);k[q>>2]=0;k[Cc>>2]=0;yc=k[s>>2]|0;k[s>>2]=yc+-1;if((yc|0)==1)ggb(k[s+-4>>2]|0)}v=G9(a,v,w,0)|0;if(k[w>>2]|0){k[Cc>>2]=0;q=Cc+4|0;k[q>>2]=0;s=ZT(28)|0;k[s>>2]=1;P=s+4|0;k[Cc>>2]=P;k[q>>2]=20;i[s+24>>0]=0;O=382518;Q=P+20|0;do{i[P>>0]=i[O>>0]|0;P=P+1|0;O=O+1|0}while((P|0)<(Q|0));Y8(-24,Cc,383203,380444,1527);k[q>>2]=0;k[Cc>>2]=0;yc=k[s>>2]|0;k[s>>2]=yc+-1;if((yc|0)==1)ggb(k[s+-4>>2]|0)}if(k[v>>2]&7|0){k[Cc>>2]=0;q=Cc+4|0;k[q>>2]=0;s=ZT(36)|0;k[s>>2]=1;P=s+4|0;k[Cc>>2]=P;k[q>>2]=31;i[s+35>>0]=0;O=383250;Q=P+31|0;do{i[P>>0]=i[O>>0]|0;P=P+1|0;O=O+1|0}while((P|0)<(Q|0));Y8(-210,Cc,383203,380444,1530);k[q>>2]=0;k[Cc>>2]=0;yc=k[s>>2]|0;k[s>>2]=yc+-1;if((yc|0)==1)ggb(k[s+-4>>2]|0)}if(f<=1.0){k[Cc>>2]=0;q=Cc+4|0;k[q>>2]=0;s=ZT(32)|0;k[s>>2]=1;P=s+4|0;k[Cc>>2]=P;k[q>>2]=24;i[s+28>>0]=0;O=383282;Q=P+24|0;do{i[P>>0]=i[O>>0]|0;P=P+1|0;O=O+1|0}while((P|0)<(Q|0));Y8(-211,Cc,383203,380444,1533);k[q>>2]=0;k[Cc>>2]=0;yc=k[s>>2]|0;k[s>>2]=yc+-1;if((yc|0)==1)ggb(k[s+-4>>2]|0)}lc=(n|0)==0|(m|0)==0;t=v+20|0;yc=k[t>>2]|0;a=v+24|0;ta=k[a>>2]|0;mc=lc?ta:m;lc=lc?yc:n;ta=y9(yc,ta,0)|0;z9(ta);if(!ta)yc=0;else{while(1){q=fgb(16)|0;if(q|0)break;q=k[207666]|0;k[207666]=q+0;if(!q){q=0;break}Qh[q&7]()}k[q+4>>2]=1;k[q>>2]=85876;k[q+8>>2]=ta;yc=q}ra=y9((k[t>>2]|0)+1|0,(k[a>>2]|0)+1|0,4)|0;z9(ra);if(!ra)xc=0;else{while(1){q=fgb(16)|0;if(q|0)break;q=k[207666]|0;k[207666]=q+0;if(!q){q=0;break}Qh[q&7]()}k[q+4>>2]=1;k[q>>2]=85876;k[q+8>>2]=ra;xc=q}sa=y9((k[t>>2]|0)+1|0,(k[a>>2]|0)+1|0,6)|0;z9(sa);if(!sa)wc=0;else{while(1){q=fgb(16)|0;if(q|0)break;q=k[207666]|0;k[207666]=q+0;if(!q){q=0;break}Qh[q&7]()}k[q+4>>2]=1;k[q>>2]=85876;k[q+8>>2]=sa;wc=q}s=b+36|0;q=k[s>>2]|0;if(!q){xSa(b);q=k[s>>2]|0}if(!(k[q+8>>2]|0)){uc=0;K=0}else{s=y9((k[t>>2]|0)+1|0,(k[a>>2]|0)+1|0,4)|0;z9(s);if(!s)q=0;else{while(1){q=fgb(16)|0;if(q|0)break;q=k[207666]|0;k[207666]=q+0;if(!q){q=0;break}Qh[q&7]()}k[q+4>>2]=1;k[q>>2]=85876;k[q+8>>2]=s}uc=q;K=s}vc=HY(0,56,20,c)|0;if(k[v>>2]&4088){M1(Cc,v,0,1,0,0);M1(nc,ta,0,1,0,0);k[oc>>2]=k[nc>>2];x=oc+4|0;I=nc+4|0;q=k[I>>2]|0;k[x>>2]=q;z=oc+8|0;k[z>>2]=k[nc+8>>2];k[oc+12>>2]=k[nc+12>>2];m=oc+16|0;G=nc+16|0;k[m>>2]=k[G>>2];k[oc+20>>2]=k[nc+20>>2];k[oc+24>>2]=k[nc+24>>2];k[oc+28>>2]=k[nc+28>>2];w=oc+32|0;A=nc+32|0;k[w>>2]=k[A>>2];n=oc+36|0;H=nc+36|0;s=k[H>>2]|0;k[n>>2]=s;c=oc+40|0;k[c>>2]=z;z=oc+48|0;y=oc+44|0;k[y>>2]=z;k[oc+52>>2]=0;k[z>>2]=0;if(s){q=s+12|0;k[q>>2]=(k[q>>2]|0)+1;q=k[I>>2]|0}if((q|0)>=3){k[x>>2]=0;x1(oc,q,0,0,0);if((k[x>>2]|0)>0){s=k[nc+40>>2]|0;t=k[c>>2]|0;a=k[nc+44>>2]|0;v=k[y>>2]|0;q=0;do{k[t+(q<<2)>>2]=k[s+(q<<2)>>2];k[v+(q<<2)>>2]=k[a+(q<<2)>>2];q=q+1|0}while((q|0)<(k[x>>2]|0))}}else{bc=k[nc+44>>2]|0;cc=k[y>>2]|0;k[cc>>2]=k[bc>>2];k[cc+4>>2]=k[bc+4>>2]}q=k[oc>>2]|0;if((q^k[Cc>>2])&7){k[pc>>2]=0;q=pc+4|0;k[q>>2]=0;s=ZT(32)|0;k[s>>2]=1;P=s+4|0;k[pc>>2]=P;k[q>>2]=26;i[s+30>>0]=0;O=241827;Q=P+26|0;do{i[P>>0]=i[O>>0]|0;P=P+1|0;O=O+1|0}while((P|0)<(Q|0));Y8(-215,pc,241854,237545,8476);k[q>>2]=0;k[pc>>2]=0;cc=k[s>>2]|0;k[s>>2]=cc+-1;if((cc|0)==1)ggb(k[s+-4>>2]|0);q=k[oc>>2]|0}k[pc+8>>2]=0;k[pc+12>>2]=0;k[pc>>2]=16842752;k[pc+4>>2]=Cc;cc=dc+4|0;bc=cc+4|0;k[bc>>2]=0;k[bc+4>>2]=0;k[dc>>2]=33619968;k[cc>>2]=oc;$aa(pc,dc,6,(q>>>3&511)+1|0);if((k[m>>2]|0)!=(k[G>>2]|0)){k[pc>>2]=0;q=pc+4|0;k[q>>2]=0;s=ZT(28)|0;k[s>>2]=1;P=s+4|0;k[pc>>2]=P;k[q>>2]=21;i[s+25>>0]=0;O=241865;Q=P+21|0;do{i[P>>0]=i[O>>0]|0;P=P+1|0;O=O+1|0}while((P|0)<(Q|0));Y8(-215,pc,241854,237545,8479);k[q>>2]=0;k[pc>>2]=0;cc=k[s>>2]|0;k[s>>2]=cc+-1;if((cc|0)==1)ggb(k[s+-4>>2]|0)}q=k[n>>2]|0;if(q|0?(bc=q+12|0,cc=k[bc>>2]|0,k[bc>>2]=cc+-1,(cc|0)==1):0){s=k[n>>2]|0;if(s|0){q=k[s+4>>2]|0;do if(!q){q=k[w>>2]|0;if(q|0)break;q=B1()|0;s=k[n>>2]|0}while(0);jh[k[(k[q>>2]|0)+24>>2]&1023](q,s)}k[n>>2]=0}k[n>>2]=0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[x>>2]|0)>0){s=k[c>>2]|0;q=0;do{k[s+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(k[x>>2]|0))}q=k[y>>2]|0;if(!((q|0)==(z|0)|(q|0)==0))ggb(k[q+-4>>2]|0);q=k[H>>2]|0;do if(q|0){bc=q+12|0;cc=k[bc>>2]|0;k[bc>>2]=cc+-1;if((cc|0)!=1)break;s=k[H>>2]|0;if(s|0){q=k[s+4>>2]|0;do if(!q){q=k[A>>2]|0;if(q|0)break;q=B1()|0;s=k[H>>2]|0}while(0);jh[k[(k[q>>2]|0)+24>>2]&1023](q,s)}k[H>>2]=0}while(0);k[H>>2]=0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[I>>2]|0)>0){s=k[nc+40>>2]|0;q=0;do{k[s+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(k[I>>2]|0))}q=k[nc+44>>2]|0;if(!((q|0)==(nc+48|0)|(q|0)==0))ggb(k[q+-4>>2]|0);t=Cc+36|0;q=k[t>>2]|0;do if(q|0){bc=q+12|0;cc=k[bc>>2]|0;k[bc>>2]=cc+-1;if((cc|0)!=1)break;s=k[t>>2]|0;if(s|0){q=k[s+4>>2]|0;do if(!q){q=k[Cc+32>>2]|0;if(q|0)break;q=B1()|0;s=k[t>>2]|0}while(0);jh[k[(k[q>>2]|0)+24>>2]&1023](q,s)}k[t>>2]=0}while(0);k[t>>2]=0;cc=Cc+16|0;s=Cc+4|0;k[cc>>2]=0;k[cc+4>>2]=0;k[cc+8>>2]=0;k[cc+12>>2]=0;if((k[s>>2]|0)>0){t=k[Cc+40>>2]|0;q=0;do{k[t+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(k[s>>2]|0))}q=k[Cc+44>>2]|0;if(!((q|0)==(Cc+48|0)|(q|0)==0))ggb(k[q+-4>>2]|0);v=ta}a:do if((h&6|0)==2){$b=k[b+8>>2]|0;ac=k[b+12>>2]|0;bc=v+20|0;cc=v+24|0;s=y9((k[bc>>2]|0)+1|0,(k[cc>>2]|0)+1|0,0)|0;z9(s);if(!s)G=0;else{while(1){q=fgb(16)|0;if(q|0)break;q=k[207666]|0;k[207666]=q+0;if(!q){q=0;break}Qh[q&7]()}k[q+4>>2]=1;k[q>>2]=85876;k[q+8>>2]=s;G=q}D=+($b|0);E=+(ac|0);Zb=$b+-2|0;_b=ac+-2|0;Yb=s+16|0;Sb=ec+4|0;Tb=ec+8|0;Ub=ec+12|0;Vb=ec+16|0;Wb=ec+20|0;Xb=ec+24|0;Rb=ra+16|0;Lb=fc+4|0;Mb=fc+8|0;Nb=fc+12|0;Ob=fc+16|0;Pb=fc+20|0;Qb=fc+24|0;Jb=sa+16|0;yb=gc+4|0;Ab=gc+8|0;Cb=gc+12|0;Eb=gc+16|0;Gb=gc+20|0;Ib=gc+24|0;Kb=(K|0)==0;xb=hc+4|0;zb=hc+8|0;Bb=hc+12|0;Db=hc+16|0;Fb=hc+20|0;Hb=hc+24|0;Za=ta+16|0;Ta=jc+4|0;Ua=jc+8|0;Va=jc+12|0;Wa=jc+16|0;Xa=jc+20|0;Ya=jc+24|0;_a=oc+4|0;$a=kc+36|0;ab=kc+16|0;bb=kc+4|0;cb=kc+40|0;db=kc+44|0;eb=kc+48|0;fb=dc+36|0;gb=dc+16|0;hb=dc+4|0;ib=dc+40|0;jb=dc+44|0;kb=dc+48|0;lb=nc+36|0;mb=nc+16|0;nb=nc+4|0;ob=nc+40|0;pb=nc+44|0;qb=nc+48|0;rb=Cc+36|0;sb=Cc+16|0;tb=Cc+4|0;ub=Cc+40|0;vb=Cc+44|0;wb=Cc+48|0;I=K+16|0;c=ic+4|0;x=ic+8|0;y=ic+12|0;z=ic+16|0;A=ic+20|0;H=ic+24|0;h=oc+8|0;K=oc+12|0;L=oc+4|0;R=pc+4|0;S=R+4|0;T=nc+40|0;U=dc+4|0;V=nc+12|0;W=Cc+12|0;X=nc+8|0;Y=Cc+8|0;Z=nc+36|0;_=nc+16|0;$=nc+4|0;ba=nc+44|0;ca=nc+48|0;da=Cc+36|0;ea=Cc+16|0;fa=Cc+4|0;ga=Cc+40|0;ha=Cc+44|0;ia=Cc+48|0;ja=pc+24|0;ka=pc+28|0;la=pc+32|0;ma=pc+64|0;na=pc+72|0;oa=pc+68|0;pa=pc+76|0;qa=pc+80|0;ra=pc+84|0;sa=pc+88|0;ta=pc+120|0;ua=pc+128|0;va=pc+124|0;wa=pc+132|0;xa=pc+144|0;ya=pc+4|0;za=pc+8|0;Aa=pc+16|0;Ba=pc+136|0;Ca=pc+140|0;Da=pc+148|0;Ea=pc+152|0;Fa=pc+156|0;Ga=pc+160|0;Ha=o?d:0;Ia=pc+164|0;Ja=o?e:0;Ka=pc+168|0;La=pc+172|0;Ma=Cc+32|0;Na=nc+32|0;Oa=dc+32|0;Pa=kc+32|0;Qa=Cc+32|0;Ra=nc+32|0;Sa=oc+4|0;C=1.0;while(1){B=D*C;p[u>>3]=B;q=k[u+4>>2]|0;Q=q&2146435072;if(!(Q>>>0>1126170624|(Q|0)==1126170624&0>0)){q=(q|0)<0;B=q?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(B==0.0)B=q?-0.0:0.0}w=~~B;B=E*C;p[u>>3]=B;q=k[u+4>>2]|0;Q=q&2146435072;if(!(Q>>>0>1126170624|(Q|0)==1126170624&0>0)){q=(q|0)<0;B=q?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(B==0.0)B=q?-0.0:0.0}t=~~B;B=+(k[cc>>2]|0)/C;p[u>>3]=B;q=k[u+4>>2]|0;Q=q&2146435072;if(!(Q>>>0>1126170624|(Q|0)==1126170624&0>0)){q=(q|0)<0;B=q?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(B==0.0)B=q?-0.0:0.0}s=~~B;B=+(k[bc>>2]|0)/C;p[u>>3]=B;q=k[u+4>>2]|0;Q=q&2146435072;do if(!(Q>>>0>1126170624|(Q|0)==1126170624&0>0)){q=(q|0)<0;B=q?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(!(B==0.0))break;B=q?-0.0:0.0}while(0);q=~~B;Q=s-$b|0;m=Q+1|0;n=q-ac|0;a=n+1|0;if((Q|0)<0){q=214;break}if((n|0)<0){q=213;break}if((w|0)>(mc|0)){q=216;break}if((t|0)>(lc|0)){q=215;break}if(!((w|0)<(j|0)|(t|0)<(l|0))){t=k[Yb>>2]|0;k[ec>>2]=1111638016;k[Sb>>2]=s;k[Tb>>2]=0;k[Ub>>2]=0;k[Vb>>2]=t;k[Wb>>2]=q;k[Xb>>2]=s;t=q+1|0;q=s+1|0;Q=k[Rb>>2]|0;s=q<<2;k[fc>>2]=1111638020;k[Lb>>2]=s;k[Mb>>2]=0;k[Nb>>2]=0;k[Ob>>2]=Q;k[Pb>>2]=t;k[Qb>>2]=q;Q=k[Jb>>2]|0;k[gc>>2]=1111638022;k[yb>>2]=q<<3;k[Ab>>2]=0;k[Cb>>2]=0;k[Eb>>2]=Q;k[Gb>>2]=t;k[Ib>>2]=q;if(Kb)t=0;else{Q=k[I>>2]|0;k[ic>>2]=1111638020;k[c>>2]=s;k[x>>2]=0;k[y>>2]=0;k[z>>2]=Q;k[A>>2]=t;k[H>>2]=q;t=ic}k[hc>>2]=1111638021;k[xb>>2]=m<<2;k[zb>>2]=0;k[Bb>>2]=0;k[Db>>2]=0;k[Fb>>2]=a;k[Hb>>2]=m;Q=k[Za>>2]|0;k[jc>>2]=1111638016;k[Ta>>2]=m;k[Ua>>2]=0;k[Va>>2]=0;k[Wa>>2]=Q;k[Xa>>2]=a;k[Ya>>2]=m;M1(Cc,v,0,1,0,0);M1(nc,ec,0,1,0,0);if((k[nc>>2]^k[Cc>>2])&4095|0){k[oc>>2]=0;k[Sa>>2]=0;q=ZT(32)|0;k[q>>2]=1;P=q+4|0;k[oc>>2]=P;k[Sa>>2]=24;i[q+28>>0]=0;O=339349;Q=P+24|0;do{i[P>>0]=i[O>>0]|0;P=P+1|0;O=O+1|0}while((P|0)<(Q|0));Y8(-215,oc,339374,335515,6368);k[Sa>>2]=0;k[oc>>2]=0;Q=k[q>>2]|0;k[q>>2]=Q+-1;if((Q|0)==1)ggb(k[q+-4>>2]|0)}k[h>>2]=0;k[K>>2]=0;k[oc>>2]=16842752;k[L>>2]=Cc;Q=S;k[Q>>2]=0;k[Q+4>>2]=0;k[pc>>2]=33619968;k[R>>2]=nc;Q=k[T>>2]|0;q=k[Q>>2]|0;k[dc>>2]=k[Q+4>>2];k[U>>2]=q;Rla(oc,pc,dc,+(k[V>>2]|0)/+(k[W>>2]|0),+(k[X>>2]|0)/+(k[Y>>2]|0),1);q=k[Z>>2]|0;do if(q|0){P=q+12|0;Q=k[P>>2]|0;k[P>>2]=Q+-1;if((Q|0)!=1)break;s=k[Z>>2]|0;if(s|0){q=k[s+4>>2]|0;do if(!q){q=k[Ra>>2]|0;if(q|0)break;q=B1()|0;s=k[Z>>2]|0}while(0);jh[k[(k[q>>2]|0)+24>>2]&1023](q,s)}k[Z>>2]=0}while(0);k[Z>>2]=0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[$>>2]|0)>0){s=k[T>>2]|0;q=0;do{k[s+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(k[$>>2]|0))}q=k[ba>>2]|0;if(!((q|0)==(ca|0)|(q|0)==0))ggb(k[q+-4>>2]|0);q=k[da>>2]|0;do if(q|0){P=q+12|0;Q=k[P>>2]|0;k[P>>2]=Q+-1;if((Q|0)!=1)break;s=k[da>>2]|0;if(s|0){q=k[s+4>>2]|0;do if(!q){q=k[Qa>>2]|0;if(q|0)break;q=B1()|0;s=k[da>>2]|0}while(0);jh[k[(k[q>>2]|0)+24>>2]&1023](q,s)}k[da>>2]=0}while(0);k[da>>2]=0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[fa>>2]|0)>0){s=k[ga>>2]|0;q=0;do{k[s+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(k[fa>>2]|0))}q=k[ha>>2]|0;if(!((q|0)==(ia|0)|(q|0)==0))ggb(k[q+-4>>2]|0);Vua(ec,fc,gc,t);q=C>2.0?1:2;P=((aa((m|0)/(q|0)|0,n+q|0)|0)/(q|0)|0)+500|0;P=(P|0)<1e3?1:(P|0)/1e3|0;P=(P|0)>100?100:P;wSa(b,fc,gc,t,1.0);M1(Cc,hc,0,1,0,0);M1(nc,jc,0,1,0,0);k[oc>>2]=0;k[_a>>2]=P;P=q+-1+((P+n|0)/(P|0)|0)|0;q=P-((P|0)%(q|0)|0)|0;M1(dc,fc,0,1,0,0);M1(kc,gc,0,1,0,0);k[pc>>2]=95564;k[ja>>2]=1124007936;P=ka;Q=P+36|0;do{k[P>>2]=0;P=P+4|0}while((P|0)<(Q|0));k[ma>>2]=la;k[oa>>2]=na;k[pa>>2]=0;k[na>>2]=0;k[qa>>2]=1124007936;P=ra;Q=P+36|0;do{k[P>>2]=0;P=P+4|0}while((P|0)<(Q|0));k[ta>>2]=sa;k[va>>2]=ua;k[wa>>2]=0;k[ua>>2]=0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;k[ya>>2]=b;k[za>>2]=q;p[Aa>>3]=C;KG(ja,dc)|0;KG(qa,kc)|0;k[Ba>>2]=Cc;k[Ca>>2]=nc;k[xa>>2]=1;k[Da>>2]=1;k[Ea>>2]=Zb;k[Fa>>2]=_b;k[Ga>>2]=Fc;k[Ia>>2]=Ha;k[Ka>>2]=Ja;k[La>>2]=Bc;jh[k[(k[pc>>2]|0)+8>>2]&1023](pc,oc);BSa(pc);q=k[$a>>2]|0;do if(q|0){P=q+12|0;Q=k[P>>2]|0;k[P>>2]=Q+-1;if((Q|0)!=1)break;s=k[$a>>2]|0;if(s|0){q=k[s+4>>2]|0;do if(!q){q=k[Pa>>2]|0;if(q|0)break;q=B1()|0;s=k[$a>>2]|0}while(0);jh[k[(k[q>>2]|0)+24>>2]&1023](q,s)}k[$a>>2]=0}while(0);k[$a>>2]=0;k[ab>>2]=0;k[ab+4>>2]=0;k[ab+8>>2]=0;k[ab+12>>2]=0;if((k[bb>>2]|0)>0){s=k[cb>>2]|0;q=0;do{k[s+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(k[bb>>2]|0))}q=k[db>>2]|0;if(!((q|0)==(eb|0)|(q|0)==0))ggb(k[q+-4>>2]|0);q=k[fb>>2]|0;do if(q|0){P=q+12|0;Q=k[P>>2]|0;k[P>>2]=Q+-1;if((Q|0)!=1)break;s=k[fb>>2]|0;if(s|0){q=k[s+4>>2]|0;do if(!q){q=k[Oa>>2]|0;if(q|0)break;q=B1()|0;s=k[fb>>2]|0}while(0);jh[k[(k[q>>2]|0)+24>>2]&1023](q,s)}k[fb>>2]=0}while(0);k[fb>>2]=0;k[gb>>2]=0;k[gb+4>>2]=0;k[gb+8>>2]=0;k[gb+12>>2]=0;if((k[hb>>2]|0)>0){s=k[ib>>2]|0;q=0;do{k[s+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(k[hb>>2]|0))}q=k[jb>>2]|0;if(!((q|0)==(kb|0)|(q|0)==0))ggb(k[q+-4>>2]|0);q=k[lb>>2]|0;do if(q|0){P=q+12|0;Q=k[P>>2]|0;k[P>>2]=Q+-1;if((Q|0)!=1)break;s=k[lb>>2]|0;if(s|0){q=k[s+4>>2]|0;do if(!q){q=k[Na>>2]|0;if(q|0)break;q=B1()|0;s=k[lb>>2]|0}while(0);jh[k[(k[q>>2]|0)+24>>2]&1023](q,s)}k[lb>>2]=0}while(0);k[lb>>2]=0;k[mb>>2]=0;k[mb+4>>2]=0;k[mb+8>>2]=0;k[mb+12>>2]=0;if((k[nb>>2]|0)>0){s=k[ob>>2]|0;q=0;do{k[s+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(k[nb>>2]|0))}q=k[pb>>2]|0;if(!((q|0)==(qb|0)|(q|0)==0))ggb(k[q+-4>>2]|0);q=k[rb>>2]|0;do if(q|0){P=q+12|0;Q=k[P>>2]|0;k[P>>2]=Q+-1;if((Q|0)!=1)break;s=k[rb>>2]|0;if(s|0){q=k[s+4>>2]|0;do if(!q){q=k[Ma>>2]|0;if(q|0)break;q=B1()|0;s=k[rb>>2]|0}while(0);jh[k[(k[q>>2]|0)+24>>2]&1023](q,s)}k[rb>>2]=0}while(0);k[rb>>2]=0;k[sb>>2]=0;k[sb+4>>2]=0;k[sb+8>>2]=0;k[sb+12>>2]=0;if((k[tb>>2]|0)>0){s=k[ub>>2]|0;q=0;do{k[s+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(k[tb>>2]|0))}q=k[vb>>2]|0;if(!((q|0)==(wb|0)|(q|0)==0))ggb(k[q+-4>>2]|0)}C=C*f}if((q|0)==213){H=0;break}else if((q|0)==214){H=0;break}else if((q|0)==215){H=0;break}else if((q|0)==216){H=0;break}}else{Vua(v,ra,sa,K);if(qa){s=v+24|0;t=y9((k[v+20>>2]|0)+1|0,(k[s>>2]|0)+1|0,4)|0;z9(t);if(!t)q=0;else{while(1){q=fgb(16)|0;if(q|0)break;q=k[207666]|0;k[207666]=q+0;if(!q){q=0;break}Qh[q&7]()}k[q+4>>2]=1;k[q>>2]=85876;k[q+8>>2]=t}waa(v,ta,0.0,50.0);Vua(ta,t,0,0)}else{s=v+24|0;q=0;t=0}pa=b+8|0;w=k[pa>>2]|0;C=+(w|0);m=k[s>>2]|0;D=+(m+-10|0);b:do if(C<D){E=+(k[b+12>>2]|0);F=+((k[v+20>>2]|0)+-10|0);a=0;B=1.0;do{if(!(B*E<F))break b;a=a+1|0;B=B*f}while(B*C<D)}else{a=0;B=1.0}while(0);if(tc){N=1.0/f;f=N;B=N*B}else B=1.0;if((a|0)>0){oa=b+12|0;na=v+20|0;Q=t;P=Q+16|0;Q=Q+4|0;R=Cc+4|0;S=Cc+8|0;T=Cc+12|0;U=ra+16|0;V=ra+4|0;W=nc+4|0;X=nc+8|0;Y=nc+12|0;Z=oc+4|0;_=pc+20|0;$=pc+24|0;ba=pc+28|0;ca=pc+4|0;da=pc+8|0;ea=pc+16|0;fa=pc+36|0;ga=pc+40|0;ha=pc+44|0;ia=pc+48|0;O=(g|0)<1?1:g;ja=Fc+8|0;ka=oc+4|0;la=oc+8|0;ma=oc+12|0;N=L?.6:.4;M=B;A=0;G=0;H=0;I=0;y=l;t=w;v=m;x=j;while(1){h=a+-1|0;J=M>2.0?M:2.0;B=M*+(t|0);p[u>>3]=B;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;B=t?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(!(B==0.0))break;B=t?-0.0:0.0}while(0);c=~~B;B=M*+(k[oa>>2]|0);p[u>>3]=B;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;B=t?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(!(B==0.0))break;B=t?-0.0:0.0}while(0);n=~~B;k[Cc>>2]=0;k[Cc+4>>2]=0;k[Cc+8>>2]=0;k[Cc+12>>2]=0;k[nc>>2]=0;k[nc+4>>2]=0;k[nc+8>>2]=0;k[nc+12>>2]=0;B=+(v-c|0)/J;p[u>>3]=B;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;B=t?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(!(B==0.0))break;B=t?-0.0:0.0}while(0);C=+((k[na>>2]|0)-n|0)/J;p[u>>3]=C;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;C=t?C+-4503599627370496.0+4503599627370496.0:C+4503599627370496.0+-4503599627370496.0;if(!(C==0.0))break;C=t?-0.0:0.0}while(0);do if((c|0)<(x|0)|(n|0)<(y|0))if(tc){G=0;H=q;break a}else{c=A;n=G;m=H;v=I;t=y;w=x}else{if((c|0)>(mc|0)|(n|0)>(lc|0))if(tc){c=A;n=G;m=H;v=I;t=y;w=x;break}else{G=0;H=q;break a}wSa(b,ra,sa,K,M);yY(ta);if(qa){E=+(c|0);D=E*.15;p[u>>3]=D;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;D=t?D+-4503599627370496.0+4503599627370496.0:D+4503599627370496.0+-4503599627370496.0;if(!(D==0.0))break;D=t?-0.0:0.0}while(0);m=~~D;F=+(n|0);D=F*.15;p[u>>3]=D;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;D=t?D+-4503599627370496.0+4503599627370496.0:D+4503599627370496.0+-4503599627370496.0;if(!(D==0.0))break;D=t?-0.0:0.0}while(0);w=~~D;D=E*.7;p[u>>3]=D;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;D=t?D+-4503599627370496.0+4503599627370496.0:D+4503599627370496.0+-4503599627370496.0;if(!(D==0.0))break;D=t?-0.0:0.0}while(0);v=~~D;D=F*.7;p[u>>3]=D;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;D=t?D+-4503599627370496.0+4503599627370496.0:D+4503599627370496.0+-4503599627370496.0;if(!(D==0.0))break;D=t?-0.0:0.0}while(0);l=k[P>>2]|0;kc=k[Q>>2]|0;j=l+(aa(kc,w)|0)+(m<<2)|0;k[Cc>>2]=j;k[R>>2]=j+(v<<2);j=~~D+w|0;kc=l+(aa(kc,j)|0)+(m<<2)|0;k[S>>2]=kc;k[T>>2]=kc+(v<<2);kc=k[U>>2]|0;l=k[V>>2]|0;jc=kc+(aa(l,w)|0)+(m<<2)|0;k[nc>>2]=jc;k[W>>2]=jc+(v<<2);j=kc+(aa(l,j)|0)+(m<<2)|0;k[X>>2]=j;k[Y>>2]=j+(v<<2)}m=aa(I,H)|0;do if((m|0)>0){B=+(G|0)/J;p[u>>3]=B;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;B=t?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(!(B==0.0))break;B=t?-0.0:0.0}while(0);v=~~B;C=+(I+G-n|0)/J;p[u>>3]=C;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;C=t?C+-4503599627370496.0+4503599627370496.0:C+4503599627370496.0+-4503599627370496.0;if(!(C==0.0))break;C=t?-0.0:0.0}while(0);B=+(A|0)/J;p[u>>3]=B;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;B=t?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(!(B==0.0))break;B=t?-0.0:0.0}while(0);t=~~B;B=+(H+A-c|0)/J;p[u>>3]=B;w=k[u+4>>2]|0;j=w&2146435072;if(j>>>0>1126170624|(j|0)==1126170624&0>0)break;w=(w|0)<0;B=w?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(!(B==0.0))break;B=w?-0.0:0.0}else{v=0;t=0}while(0);k[oc>>2]=v;k[Z>>2]=~~C;j=k[V>>2]|0;k[pc>>2]=95544;k[ca>>2]=b;k[_>>2]=c;k[$>>2]=n;l=ba;k[l>>2]=t;k[l+4>>2]=~~B;p[da>>3]=J;k[ea>>2]=j;k[fa>>2]=Cc;k[ga>>2]=nc;k[ha>>2]=Fc;k[ia>>2]=Bc;DSa(pc,oc);if(!tc){c=A;n=G;m=H;v=I;t=y;w=x;break}t=k[Fc>>2]|0;w=k[Hc>>2]|0;if((t|0)==(w|0)){c=A;n=G;m=H;v=I;t=y;w=x;break}if(m|0){c=A;n=G;m=H;v=I;t=y;w=x;break}v=w-t>>4;c=k[Gc>>2]|0;n=k[Dc>>2]|0;m=c-n>>4;do if(v>>>0>m>>>0){WRa(Dc,v-m|0);t=k[Fc>>2]|0;w=k[Hc>>2]|0}else{if(v>>>0>=m>>>0)break;v=n+(v<<4)|0;if((c|0)==(v|0))break;k[Gc>>2]=c+(~((c+-16-v|0)>>>4)<<4)}while(0);if((t|0)!=(w|0)){v=k[Dc>>2]|0;while(1){k[v>>2]=k[t>>2];k[v+4>>2]=k[t+4>>2];k[v+8>>2]=k[t+8>>2];k[v+12>>2]=k[t+12>>2];t=t+16|0;if((t|0)==(w|0))break;else v=v+16|0}}QRa(Dc,O,.2,0,0);z=k[Dc>>2]|0;t=k[Gc>>2]|0;if((z|0)==(t|0)){c=A;n=G;m=H;v=I;t=y;w=x;break}y=t-z>>4;k[oc>>2]=0;k[oc+4>>2]=0;k[oc+8>>2]=0;k[oc+12>>2]=0;if(!y){w=0;v=0;x=0;m=0}else{x=0;c=0;n=0;v=0;w=0;while(1){t=k[z+(x<<4)+8>>2]|0;m=k[z+(x<<4)+12>>2]|0;if((aa(m,t)|0)>(aa(n,c)|0)){w=k[z+(x<<4)>>2]|0;k[oc>>2]=w;v=k[z+(x<<4)+4>>2]|0;k[ka>>2]=v;k[la>>2]=t;k[ma>>2]=m}else{m=n;t=c}x=x+1|0;if((x|0)==(y|0)){x=t;break}else{c=t;n=m}}}t=k[Hc>>2]|0;if((t|0)==(k[ja>>2]|0))SRa(Fc,oc);else{k[t>>2]=w;k[t+4>>2]=v;k[t+8>>2]=x;k[t+12>>2]=m;k[Hc>>2]=t+16}C=+(x|0);B=C*.2;p[u>>3]=B;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;B=t?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(!(B==0.0))break;B=t?-0.0:0.0}while(0);n=~~B;D=+(m|0);B=D*.2;p[u>>3]=B;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;B=t?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(!(B==0.0))break;B=t?-0.0:0.0}while(0);t=~~B;c=w-n|0;c=(c|0)<0?0:c;y=v-t|0;y=(y|0)<0?0:y;x=(n<<1)+x|0;v=(k[s>>2]|0)+-1-c|0;x=(v|0)<(x|0)?v:x;v=(t<<1)+m|0;t=(k[na>>2]|0)+-1-y|0;v=(t|0)<(v|0)?t:v;B=N*C;p[u>>3]=B;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;B=t?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(!(B==0.0))break;B=t?-0.0:0.0}while(0);w=~~B;B=N*D;p[u>>3]=B;t=k[u+4>>2]|0;j=t&2146435072;do if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){t=(t|0)<0;B=t?B+-4503599627370496.0+4503599627370496.0:B+4503599627370496.0+-4503599627370496.0;if(!(B==0.0))break;B=t?-0.0:0.0}while(0);n=y;m=x;t=~~B}while(0);if((a|0)<=1){G=0;H=q;break a}M=M*f;a=h;A=c;G=n;H=m;I=v;y=t;t=k[pa>>2]|0;v=k[s>>2]|0;x=w}}else{G=0;H=q}}while(0);t=k[Hc>>2]|0;q=k[Fc>>2]|0;s=t-q>>4;w=k[Gc>>2]|0;v=k[Dc>>2]|0;a=w-v>>4;if(s>>>0<=a>>>0){if(s>>>0<a>>>0?(qc=v+(s<<4)|0,(w|0)!=(qc|0)):0)k[Gc>>2]=w+(~((w+-16-qc|0)>>>4)<<4)}else{WRa(Dc,s-a|0);q=k[Fc>>2]|0;t=k[Hc>>2]|0}if((q|0)!=(t|0)){s=k[Dc>>2]|0;while(1){k[s>>2]=k[q>>2];k[s+4>>2]=k[q+4>>2];k[s+8>>2]=k[q+8>>2];k[s+12>>2]=k[q+12>>2];q=q+16|0;if((q|0)==(t|0))break;else s=s+16|0}}do if(!(rc|g)){q=(k[Gc>>2]|0)-(k[Dc>>2]|0)>>4;k[Cc>>2]=0;a=k[Ec>>2]|0;t=k[Ac>>2]|0;s=a-t>>2;if(q>>>0<=s>>>0){if(q>>>0<s>>>0?(sc=t+(q<<2)|0,(a|0)!=(sc|0)):0)k[Ec>>2]=a+(~((a+-4-sc|0)>>>2)<<2)}else YR(Ac,q-s|0,Cc)}else if(o){QRa(Dc,g,.2,d,e);break}else{QRa(Dc,(g|0)<1?1:g,.2,Ac,0);break}while(0);s=k[Gc>>2]|0;A=k[Dc>>2]|0;q=(s|0)==(A|0);if(tc){z=A;if(!q){m=Cc+4|0;n=Cc+8|0;c=Cc+12|0;x=Cc+16|0;k[Cc>>2]=0;k[Cc+4>>2]=0;k[Cc+8>>2]=0;k[Cc+12>>2]=0;k[Cc+16>>2]=0;y=k[Ac>>2]|0;w=s-A>>4;v=0;a=0;t=0;while(1){q=k[z+(v<<4)+8>>2]|0;s=k[z+(v<<4)+12>>2]|0;if((aa(s,q)|0)>(aa(t,a)|0)){tc=k[z+(v<<4)+4>>2]|0;k[Cc>>2]=k[z+(v<<4)>>2];k[m>>2]=tc;k[n>>2]=q;k[c>>2]=s;k[x>>2]=k[y+(v<<2)>>2]}else{s=t;q=a}v=v+1|0;if(v>>>0>=w>>>0)break;else{a=q;t=s}}SY(vc,Cc)|0}}else if(!q){a=Cc+4|0;v=Cc+8|0;w=Cc+12|0;m=Cc+16|0;t=s-A>>4;s=0;do{o=A;k[Cc>>2]=0;k[Cc+4>>2]=0;k[Cc+8>>2]=0;k[Cc+12>>2]=0;sc=k[o+(s<<4)+4>>2]|0;tc=k[o+(s<<4)+8>>2]|0;q=k[o+(s<<4)+12>>2]|0;k[Cc>>2]=k[o+(s<<4)>>2];k[a>>2]=sc;k[v>>2]=tc;k[w>>2]=q;q=k[Ac>>2]|0;if((q|0)==(k[Ec>>2]|0))q=0;else q=k[q+(s<<2)>>2]|0;k[m>>2]=q;SY(vc,Cc)|0;s=s+1|0}while(s>>>0<t>>>0)}tc=(k[Bc>>2]|0)+28|0;Cc=k[tc>>2]|0;k[tc>>2]=Cc+-1;if((Cc|0)==1?(zc=k[Bc>>2]|0,zc|0):0){rf(zc|0)|0;ggb(zc)}q=k[Ac>>2]|0;s=q;if(q|0){t=k[Ec>>2]|0;if((t|0)!=(q|0))k[Ec>>2]=t+(~((t+-4-s|0)>>>2)<<2);ggb(q)}q=k[Dc>>2]|0;s=q;if(q|0){t=k[Gc>>2]|0;if((t|0)!=(q|0))k[Gc>>2]=t+(~((t+-16-s|0)>>>4)<<4);ggb(q)}q=k[Fc>>2]|0;s=q;if(q|0){t=k[Hc>>2]|0;if((t|0)!=(q|0))k[Hc>>2]=t+(~((t+-16-s|0)>>>4)<<4);ggb(q)}q=G;do if(G|0){Gc=q+4|0;Hc=k[Gc>>2]|0;k[Gc>>2]=Hc+-1;if((Hc|0)!=1)break;Uh[k[(k[G>>2]|0)+8>>2]&2047](q)}while(0);q=H;do if(H|0){Gc=q+4|0;Hc=k[Gc>>2]|0;k[Gc>>2]=Hc+-1;if((Hc|0)!=1)break;Uh[k[(k[H>>2]|0)+8>>2]&2047](q)}while(0);q=wc;do if(wc|0){Gc=q+4|0;Hc=k[Gc>>2]|0;k[Gc>>2]=Hc+-1;if((Hc|0)!=1)break;Uh[k[(k[wc>>2]|0)+8>>2]&2047](q)}while(0);q=uc;do if(uc|0){Gc=q+4|0;Hc=k[Gc>>2]|0;k[Gc>>2]=Hc+-1;if((Hc|0)!=1)break;Uh[k[(k[uc>>2]|0)+8>>2]&2047](q)}while(0);q=xc;do if(xc|0){Gc=q+4|0;Hc=k[Gc>>2]|0;k[Gc>>2]=Hc+-1;if((Hc|0)!=1)break;Uh[k[(k[xc>>2]|0)+8>>2]&2047](q)}while(0);q=yc;if(!yc){r=Ic;return vc|0}Gc=q+4|0;Hc=k[Gc>>2]|0;k[Gc>>2]=Hc+-1;if((Hc|0)!=1){r=Ic;return vc|0}Uh[k[(k[yc>>2]|0)+8>>2]&2047](q);r=Ic;return vc|0}function BSa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=95564;d=a+116|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+112>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+96|0;c=a+84|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+120>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+124>>2]|0;if(!((b|0)==(a+128|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+60|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+56>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+40|0;c=a+28|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+64>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+68>>2]|0;if((b|0)==(a+72|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function CSa(a){a=a|0;ggb(a);return}function DSa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,i=0,j=0,l=0.0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;O=r;r=r+16|0;N=O;c=k[b>>2]|0;L=k[b+4>>2]|0;x=k[a+36>>2]|0;M=k[x>>2]|0;v=k[x+4>>2]|0;w=k[x+8>>2]|0;x=k[x+12>>2]|0;B=k[a+40>>2]|0;y=k[B>>2]|0;z=k[B+4>>2]|0;A=k[B+8>>2]|0;B=k[B+12>>2]|0;C=(M|0)==0;D=(k[a+16>>2]|0)>>>2;if((c|0)>=(L|0)){r=O;return}E=a+8|0;F=a+28|0;G=a+32|0;H=a+4|0;I=a+48|0;J=a+44|0;K=a+20|0;o=a+24|0;q=N+4|0;s=N+8|0;t=N+12|0;b=k[G>>2]|0;do{l=+p[E>>3];d=+(c|0)*l;p[u>>3]=d;a=k[u+4>>2]|0;n=a&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){a=(a|0)<0;d=a?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=a?-0.0:0.0}n=~~d;a=k[F>>2]|0;a:do if((a|0)<(b|0)){m=aa(n,D)|0;if(C){d=l;while(1){d=+(a|0)*d;p[u>>3]=d;b=k[u+4>>2]|0;m=b&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){b=(b|0)<0;d=b?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=b?-0.0:0.0}b=~~d;e=ySa(k[H>>2]|0,b,n,N)|0;if((e|0)>0){mpb(k[k[I>>2]>>2]|0)|0;f=k[J>>2]|0;g=k[K>>2]|0;h=k[o>>2]|0;k[N>>2]=b;k[q>>2]=n;k[s>>2]=g;k[t>>2]=h;i=f+4|0;j=k[i>>2]|0;if((j|0)==(k[f+8>>2]|0))SRa(f,N);else{k[j>>2]=b;k[j+4>>2]=n;k[j+8>>2]=g;k[j+12>>2]=h;k[i>>2]=j+16}lpb(k[k[I>>2]>>2]|0)|0}a=(e|0?1:2)+a|0;b=k[G>>2]|0;if((a|0)>=(b|0))break a;d=+p[E>>3]}}else d=l;while(1){d=+(a|0)*d;p[u>>3]=d;e=k[u+4>>2]|0;j=e&2146435072;if(!(j>>>0>1126170624|(j|0)==1126170624&0>0)){e=(e|0)<0;d=e?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=e?-0.0:0.0}j=~~d;i=j+m|0;if(((k[M+(i<<2)>>2]|0)-(k[v+(i<<2)>>2]|0)-(k[w+(i<<2)>>2]|0)+(k[x+(i<<2)>>2]|0)|0)<100?1:((k[y+(i<<2)>>2]|0)-(k[z+(i<<2)>>2]|0)-(k[A+(i<<2)>>2]|0)+(k[B+(i<<2)>>2]|0)|0)<20)e=2;else{b=ySa(k[H>>2]|0,j,n,N)|0;if((b|0)>0){mpb(k[k[I>>2]>>2]|0)|0;e=k[J>>2]|0;f=k[K>>2]|0;g=k[o>>2]|0;k[N>>2]=j;k[q>>2]=n;k[s>>2]=f;k[t>>2]=g;h=e+4|0;i=k[h>>2]|0;if((i|0)==(k[e+8>>2]|0))SRa(e,N);else{k[i>>2]=j;k[i+4>>2]=n;k[i+8>>2]=f;k[i+12>>2]=g;k[h>>2]=i+16}lpb(k[k[I>>2]>>2]|0)|0}e=b|0?1:2;b=k[G>>2]|0}a=e+a|0;if((a|0)>=(b|0))break a;d=+p[E>>3]}}while(0);c=c+1|0}while((c|0)!=(L|0));r=O;return}function ESa(a){a=a|0;BSa(a);ggb(a);return}function FSa(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0.0,h=0,i=0,j=0,l=0.0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+32|0;G=J;H=J+8|0;I=a+4|0;e=k[I>>2]|0;f=k[e+8>>2]|0;e=k[e+12>>2]|0;F=a+16|0;g=+p[F>>3];c=+(f|0)*g;p[u>>3]=c;d=k[u+4>>2]|0;E=d&2146435072;if(!(E>>>0>1126170624|(E|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}E=~~c;c=+(e|0)*g;p[u>>3]=c;d=k[u+4>>2]|0;D=d&2146435072;if(!(D>>>0>1126170624|(D|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}D=~~c;C=k[a+8>>2]|0;h=aa(C,k[b>>2]|0)|0;C=aa(k[b+4>>2]|0,C)|0;B=(k[a+32>>2]|0)+~e|0;C=(B|0)<(C|0)?B:C;if((C|0)<=(h|0)){r=J;return}d=k[a+36>>2]|0;if((d|0)<=(f+1|0)){r=J;return}B=d+~f|0;n=g>2.0?1:2;o=(B|0)>0;q=a+164|0;s=a+172|0;t=a+160|0;v=H+4|0;w=H+8|0;x=H+12|0;y=H+4|0;z=H+8|0;A=H+12|0;m=a+168|0;do{if(o){l=+(h|0);j=0;do{d=ySa(k[I>>2]|0,j,h,G)|0;if(!(k[q>>2]|0)){if((d|0)>0){mpb(k[k[s>>2]>>2]|0)|0;a=k[t>>2]|0;g=+p[F>>3];c=+(j|0)*g;p[u>>3]=c;d=k[u+4>>2]|0;i=d&2146435072;if(!(i>>>0>1126170624|(i|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}f=~~c;c=l*g;p[u>>3]=c;d=k[u+4>>2]|0;i=d&2146435072;if(!(i>>>0>1126170624|(i|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c;k[H>>2]=f;k[v>>2]=d;k[w>>2]=E;k[x>>2]=D;b=a+4|0;e=k[b>>2]|0;if((e|0)==(k[a+8>>2]|0))SRa(a,H);else{k[e>>2]=f;k[e+4>>2]=d;k[e+8>>2]=E;k[e+12>>2]=D;k[b>>2]=e+16}lpb(k[k[s>>2]>>2]|0)|0}}else{a=k[(k[I>>2]|0)+4>>2]|0;i=(d|0)==1?0-a|0:d;if((a+i|0)<4){mpb(k[k[s>>2]>>2]|0)|0;a=k[t>>2]|0;g=+p[F>>3];c=+(j|0)*g;p[u>>3]=c;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}f=~~c;c=l*g;p[u>>3]=c;d=k[u+4>>2]|0;e=d&2146435072;if(!(e>>>0>1126170624|(e|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c;k[H>>2]=f;k[y>>2]=d;k[z>>2]=E;k[A>>2]=D;b=a+4|0;e=k[b>>2]|0;if((e|0)==(k[a+8>>2]|0))SRa(a,H);else{k[e>>2]=f;k[e+4>>2]=d;k[e+8>>2]=E;k[e+12>>2]=D;k[b>>2]=e+16}f=k[q>>2]|0;d=0-i|0;k[H>>2]=d;b=f+4|0;e=k[b>>2]|0;if((e|0)==(k[f+8>>2]|0))Q4(f,H);else{k[e>>2]=d;k[b>>2]=e+4}d=k[m>>2]|0;b=d+4|0;e=k[b>>2]|0;if((e|0)==(k[d+8>>2]|0))Koa(d,G);else{p[e>>3]=+p[G>>3];k[b>>2]=e+8}lpb(k[k[s>>2]>>2]|0)|0}}j=j+n|0}while((j|0)<(B|0))}h=h+n|0}while((h|0)<(C|0));r=J;return}function GSa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=95584;d=a+304|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+300>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+284|0;c=a+272|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+308>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+312>>2]|0;if(!((b|0)==(a+316|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+248|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+244>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+228|0;c=a+216|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+252>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+256>>2]|0;if(!((b|0)==(a+260|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+192|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+188>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+172|0;d=a+160|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+196>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+200>>2]|0;if(!((b|0)==(a+204|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+136|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+132>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+116|0;c=a+104|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+140>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+144>>2]|0;if(!((b|0)==(a+148|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+16>>2]|0;c=b;if(b|0){d=a+20|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~(((e+-12-c|0)>>>0)/12|0)*12|0);ggb(b)}d=k[a+4>>2]|0;if(!d)return;b=a+8|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~(((c+-44-d|0)>>>0)/44|0)*44|0);ggb(d);return}function HSa(a){a=a|0;GSa(a);ggb(a);return}function ISa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0.0,l=0,m=0.0,n=0,q=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,_=0,$=0;$=r;r=r+2208|0;y=$+1136|0;J=$+1072|0;U=$+1064|0;_=$+1080|0;t=$;s=a+324|0;k[s>>2]=b;h=a+52|0;k[h>>2]=k[g>>2];l=a+56|0;k[l>>2]=k[g+4>>2];S=a+28|0;i[S>>0]=f&1;K=k[(k[b>>2]|0)+52>>2]|0;k[J>>2]=k[d>>2];L=d+4|0;k[J+4>>2]=k[L>>2];k[U>>2]=k[e>>2];k[U+4>>2]=k[e+4>>2];Lg[K&255](b,c,a+212|0,a+268|0,J,U);L=k[L>>2]|0;k[a+92>>2]=k[d>>2];k[a+96>>2]=L;L=k[s>>2]|0;U=k[L+4>>2]|0;k[a+44>>2]=U;b=k[L+8>>2]|0;k[a+48>>2]=b;J=k[L+12>>2]|0;K=k[L+16>>2]|0;W=k[L+20>>2]|0;X=k[L+24>>2]|0;H=k[L+28>>2]|0;I=k[L+32>>2]|0;L=k[L+36>>2]|0;O=aa(K,J)|0;T=a+60|0;k[T>>2]=((U-J|0)/(W|0)|0)+1;U=a+64|0;k[U>>2]=((b-K|0)/(X|0)|0)+1;V=(J|0)/(H|0)|0;e=(K|0)/(I|0)|0;M=a+68|0;k[M>>2]=V;N=a+72|0;k[N>>2]=e;e=aa(aa(V,L)|0,e)|0;V=a+76|0;k[V>>2]=e;if(i[S>>0]|0){f=(((k[a+224>>2]|0)-J|0)/(k[h>>2]|0)|0)+1|0;d=((b|0)/(k[l>>2]|0)|0)+1|0;c=a+100|0;b=aa(f,e)|0;if(!(((((k[a+104>>2]|0)<3?(k[a+108>>2]|0)==(d|0):0)?(k[a+112>>2]|0)==(b|0):0)?(k[c>>2]&4095|0)==5:0)?(k[a+116>>2]|0)!=0:0)){k[y>>2]=d;k[y+4>>2]=b;G1(c,2,y,5)}b=a+156|0;if(!(((((k[a+160>>2]|0)<3?(k[a+164>>2]|0)==(d|0):0)?(k[a+168>>2]|0)==(f|0):0)?(k[b>>2]&4095|0)==0:0)?(k[a+172>>2]|0)!=0:0)){k[y>>2]=d;k[y+4>>2]=f;G1(b,2,y,0)}b=k[a+108>>2]|0;c=a+32|0;d=a+36|0;g=k[d>>2]|0;f=k[c>>2]|0;e=g-f>>2;if(b>>>0<=e>>>0){if(b>>>0<e>>>0?(n=f+(b<<2)|0,(g|0)!=(n|0)):0)k[d>>2]=g+(~((g+-4-n|0)>>>2)<<2)}else U1(c,b-e|0);if(b|0)zpb(k[c>>2]|0,-1,b<<2|0)|0}k[_>>2]=1124007936;R=_+4|0;b=_+8|0;P=_+40|0;n=R;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[P>>2]=b;S=_+48|0;Q=_+44|0;k[Q>>2]=S;k[_+52>>2]=0;k[S>>2]=0;k[y>>2]=K;k[y+4>>2]=J;G1(_,2,y,5);b=k[s>>2]|0;j=+p[b+48>>3];if(!(j>=0.0))j=+((k[b+16>>2]|0)+(k[b+12>>2]|0)|0)*.125;u=j;u=1.0/(u*u*2.0);q=y+8|0;k[y>>2]=q;s=y+4|0;k[s>>2]=264;if(K>>>0>264){c=K>>>0>1073741823?-1:K<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[y>>2]=b}else b=q;k[s>>2]=K;l=t+8|0;k[t>>2]=l;n=t+4|0;k[n>>2]=264;if(J>>>0>264){d=J>>>0>1073741823?-1:J<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[t>>2]=c}else c=l;k[n>>2]=J;j=+(K|0)*.5;m=+(J|0)*.5;F=(K|0)>0;if(F){d=0;do{z=+(d|0)-j;o[b+(d<<2)>>2]=z*z;d=d+1|0}while((d|0)!=(K|0))}E=(J|0)>0;if(E){d=0;do{z=+(d|0)-m;o[c+(d<<2)>>2]=z*z;d=d+1|0}while((d|0)!=(J|0))}if(F?(x=k[_+16>>2]|0,E):0){f=k[k[Q>>2]>>2]|0;e=0;do{g=b+(e<<2)|0;h=x+(aa(f,e)|0)|0;d=0;do{z=+Z(+-(u*(+o[g>>2]+ +o[c+(d<<2)>>2])));o[h+(d<<2)>>2]=z;d=d+1|0}while((d|0)!=(J|0));e=e+1|0}while((e|0)!=(K|0))}if((c|0)!=(l|0)){ggb(c);b=k[y>>2]|0;k[t>>2]=l;k[n>>2]=264}if((b|0)!=(q|0)){if(b|0)ggb(b);k[y>>2]=q;k[s>>2]=264}G=a+16|0;d=aa(k[U>>2]|0,k[T>>2]|0)|0;n=a+20|0;e=k[n>>2]|0;q=k[G>>2]|0;f=(e-q|0)/12|0;h=q;c=e;do if(d>>>0>f>>>0){g=d-f|0;l=a+24|0;b=k[l>>2]|0;if(((b-e|0)/12|0)>>>0>=g>>>0){zpb(e|0,0,g*12|0)|0;k[n>>2]=c+(g*12|0);break}if(d>>>0>357913941)ad(426534,426557,304,426811);D=(b-q|0)/12|0;e=D<<1;e=D>>>0<178956970?(e>>>0<d>>>0?d:e):357913941;if(!e)d=0;else{if(e>>>0>357913941){$=te(4)|0;k[$>>2]=172664;Cf($|0,28816,1287)}d=e*12|0;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b}b=d+(f*12|0)|0;e=d+(e*12|0)|0;zpb(b|0,0,g*12|0)|0;d=b+(g*12|0)|0;if((c|0)!=(h|0))do{D=c;c=c+-12|0;k[b+-12>>2]=k[c>>2];k[b+-8>>2]=k[D+-8>>2];k[b+-4>>2]=k[D+-4>>2];b=b+-12|0}while((c|0)!=(h|0));k[G>>2]=b;k[n>>2]=d;k[l>>2]=e;if(q|0)ggb(q)}else if(d>>>0<f>>>0?(A=h+(d*12|0)|0,(c|0)!=(A|0)):0)k[n>>2]=c+(~(((c+-12-A|0)>>>0)/12|0)*12|0);while(0);D=a+4|0;e=O*3|0;s=a+8|0;b=k[s>>2]|0;f=k[D>>2]|0;g=(b-f|0)/44|0;c=f;d=b;a:do if(e>>>0>g>>>0){c=e-g|0;l=a+12|0;d=k[l>>2]|0;if(((d-b|0)/44|0)>>>0>=c>>>0)while(1){n=b;q=n+44|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));b=(k[s>>2]|0)+44|0;k[s>>2]=b;c=c+-1|0;if(!c)break a}if(e>>>0>97612893)ad(426534,426557,304,426811);C=(d-f|0)/44|0;h=C<<1;h=C>>>0<48806446?(h>>>0<e>>>0?e:h):97612893;if(!h)b=0;else{if(h>>>0>97612893){$=te(4)|0;k[$>>2]=172664;Cf($|0,28816,1287)}d=h*44|0;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}}g=b+(g*44|0)|0;d=g;f=g;do{n=d;q=n+44|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));d=f+44|0;f=d;c=c+-1|0}while((c|0)!=0);d=k[D>>2]|0;e=(k[s>>2]|0)-d|0;c=g+(((e|0)/-44|0)*44|0)|0;if((e|0)>0)upb(c|0,d|0,e|0)|0;k[D>>2]=c;k[s>>2]=f;k[l>>2]=b+(h*44|0);if(d|0)ggb(d)}else if(e>>>0<g>>>0?(B=c+(e*44|0)|0,(d|0)!=(B|0)):0)k[s>>2]=d+(~(((d+-44-B|0)>>>0)/44|0)*44|0);while(0);B=a+88|0;k[B>>2]=0;C=a+84|0;k[C>>2]=0;A=a+80|0;k[A>>2]=0;if(E){z=+(H|0);w=+(I|0);x=O<<1;y=a+224|0;l=a+280|0;n=k[_+16>>2]|0;q=k[Q>>2]|0;g=0;do{if(F){u=(+(g|0)+.5)/z+-.5;s=~~u;s=s-(+(s|0)>u&1)|0;t=s+1|0;u=u-+(s|0);v=1.0-u;h=0;do{m=(+(h|0)+.5)/w+-.5;e=~~m;e=e-(+(e|0)>m&1)|0;f=e+1|0;m=m-+(e|0);a=k[M>>2]|0;b=s>>>0<a>>>0;do if(b&t>>>0<a>>>0){b=k[N>>2]|0;c=e>>>0<b>>>0;if(c&f>>>0<b>>>0){a=k[B>>2]|0;k[B>>2]=a+1;a=a+x|0;I=k[D>>2]|0;b=aa((aa(b,s)|0)+e|0,L)|0;k[I+(a*44|0)+8>>2]=b;j=1.0-m;o[I+(a*44|0)+24>>2]=v*j;b=aa((aa(k[N>>2]|0,t)|0)+e|0,L)|0;k[I+(a*44|0)+12>>2]=b;o[I+(a*44|0)+28>>2]=u*j;b=aa((aa(k[N>>2]|0,s)|0)+f|0,L)|0;k[I+(a*44|0)+16>>2]=b;o[I+(a*44|0)+32>>2]=v*m;b=aa((aa(k[N>>2]|0,t)|0)+f|0,L)|0;k[I+(a*44|0)+20>>2]=b;o[I+(a*44|0)+36>>2]=u*m;b=I+(a*44|0)|0;break}else{a=k[C>>2]|0;k[C>>2]=a+1;a=a+O|0;I=k[D>>2]|0;m=c?1.0-m:m;H=c?e:f;b=aa(H+(aa(b,s)|0)|0,L)|0;k[I+(a*44|0)+8>>2]=b;o[I+(a*44|0)+24>>2]=v*m;b=aa((aa(k[N>>2]|0,t)|0)+H|0,L)|0;k[I+(a*44|0)+12>>2]=b;o[I+(a*44|0)+28>>2]=u*m;k[I+(a*44|0)+20>>2]=0;k[I+(a*44|0)+16>>2]=0;o[I+(a*44|0)+36>>2]=0.0;o[I+(a*44|0)+32>>2]=0.0;b=I+(a*44|0)|0;break}}else{j=b?v:u;b=b?s:t;c=k[N>>2]|0;d=e>>>0<c>>>0;if(d&f>>>0<c>>>0){a=k[C>>2]|0;k[C>>2]=a+1;a=a+O|0;I=k[D>>2]|0;H=aa((aa(c,b)|0)+e|0,L)|0;k[I+(a*44|0)+8>>2]=H;o[I+(a*44|0)+24>>2]=(1.0-m)*j;b=aa((aa(k[N>>2]|0,b)|0)+f|0,L)|0;k[I+(a*44|0)+12>>2]=b;o[I+(a*44|0)+28>>2]=m*j;k[I+(a*44|0)+20>>2]=0;k[I+(a*44|0)+16>>2]=0;o[I+(a*44|0)+36>>2]=0.0;o[I+(a*44|0)+32>>2]=0.0;b=I+(a*44|0)|0;break}else{a=k[A>>2]|0;k[A>>2]=a+1;I=k[D>>2]|0;b=aa((d?e:f)+(aa(c,b)|0)|0,L)|0;k[I+(a*44|0)+8>>2]=b;o[I+(a*44|0)+24>>2]=j*(d?1.0-m:m);k[I+(a*44|0)+20>>2]=0;k[I+(a*44|0)+16>>2]=0;k[I+(a*44|0)+12>>2]=0;o[I+(a*44|0)+36>>2]=0.0;o[I+(a*44|0)+32>>2]=0.0;o[I+(a*44|0)+28>>2]=0.0;b=I+(a*44|0)|0;break}}while(0);a=(aa(k[y>>2]|0,h)|0)+g<<1;k[b>>2]=a;a=(aa(k[l>>2]|0,h)|0)+g<<1;k[b+4>>2]=a;a=n+(aa(k[q>>2]|0,h)|0)+(g<<2)|0;k[b+40>>2]=k[a>>2];h=h+1|0}while((h|0)!=(K|0))}g=g+1|0}while((g|0)!=(J|0));b=k[C>>2]|0;if((b|0)>0){c=0;do{b=k[D>>2]|0;n=b+(((k[A>>2]|0)+c|0)*44|0)|0;b=b+((c+O|0)*44|0)|0;q=n+44|0;do{k[n>>2]=k[b>>2];n=n+4|0;b=b+4|0}while((n|0)<(q|0));c=c+1|0;b=k[C>>2]|0}while((c|0)<(b|0));d=b}else d=b}else d=0;b=k[B>>2]|0;c=k[A>>2]|0;if((b|0)>0){e=O<<1;b=k[D>>2]|0;n=b+((c+d|0)*44|0)|0;b=b+(e*44|0)|0;q=n+44|0;do{k[n>>2]=k[b>>2];n=n+4|0;b=b+4|0}while((n|0)<(q|0));b=k[B>>2]|0;c=k[A>>2]|0;if((b|0)>1){d=1;do{b=k[D>>2]|0;n=b+((c+d+(k[C>>2]|0)|0)*44|0)|0;b=b+((d+e|0)*44|0)|0;q=n+44|0;do{k[n>>2]=k[b>>2];n=n+4|0;b=b+4|0}while((n|0)<(q|0));d=d+1|0;b=k[B>>2]|0;c=k[A>>2]|0}while((d|0)<(b|0))}d=k[C>>2]|0}h=d+c|0;k[C>>2]=h;k[B>>2]=b+h;h=k[T>>2]|0;if((h|0)>0?(Y=k[U>>2]|0,(Y|0)>0):0){g=k[G>>2]|0;d=k[V>>2]|0;c=0;do{e=aa(c,W)|0;f=aa(Y,c)|0;b=0;do{V=f+b|0;U=aa(d,V)|0;k[g+(V*12|0)>>2]=U;U=aa(b,X)|0;k[g+(V*12|0)+4>>2]=e;k[g+(V*12|0)+8>>2]=U;b=b+1|0}while((b|0)!=(Y|0));c=c+1|0}while((c|0)!=(h|0))}d=_+36|0;b=k[d>>2]|0;if(b|0?(X=b+12|0,Y=k[X>>2]|0,k[X>>2]=Y+-1,(Y|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[_+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;_=_+16|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[R>>2]|0)>0){c=k[P>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[R>>2]|0))}b=k[Q>>2]|0;if((b|0)==(S|0)|(b|0)==0){r=$;return}ggb(k[b+-4>>2]|0);r=$;return}function JSa(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0,l=0,m=0,n=0,q=0,s=0.0,t=0,v=0,w=0,x=0;q=r;r=r+16|0;l=q+4|0;m=q;n=k[a+76>>2]|0;j=n+-4|0;d=0;c=0.0;e=0.0;f=0.0;g=0.0;do{i=+o[b+(d<<2)>>2];c=c+i*i;i=+o[b+((d|1)<<2)>>2];e=e+i*i;i=+o[b+((d|2)<<2)>>2];f=f+i*i;i=+o[b+((d|3)<<2)>>2];g=g+i*i;d=d+4|0}while(d>>>0<=j>>>0);c=g+f+(e+c);if(d>>>0<n>>>0)do{i=+o[b+(d<<2)>>2];c=c+i*i;d=d+1|0}while((d|0)!=(n|0));i=1.0/(+(n>>>0)*.10000000149011612+ +Q(+c));h=+p[(k[a+324>>2]|0)+64>>3];o[l>>2]=h;d=0;c=0.0;e=0.0;f=0.0;g=0.0;do{x=b+(d<<2)|0;s=i*+o[x>>2];o[m>>2]=s;w=k[(h<s?l:m)>>2]|0;k[x>>2]=w;x=b+((d|1)<<2)|0;s=i*+o[x>>2];o[m>>2]=s;v=k[(h<s?l:m)>>2]|0;k[x>>2]=v;x=b+((d|2)<<2)|0;s=i*+o[x>>2];o[m>>2]=s;t=k[(h<s?l:m)>>2]|0;k[x>>2]=t;x=b+((d|3)<<2)|0;s=i*+o[x>>2];o[m>>2]=s;a=k[(h<s?l:m)>>2]|0;k[x>>2]=a;s=(k[u>>2]=w,+o[u>>2]);c=c+s*s;s=(k[u>>2]=v,+o[u>>2]);e=e+s*s;s=(k[u>>2]=t,+o[u>>2]);f=f+s*s;s=(k[u>>2]=a,+o[u>>2]);g=g+s*s;d=d+4|0}while(d>>>0<=j>>>0);c=g+f+(e+c);if(d>>>0<n>>>0)do{w=b+(d<<2)|0;s=i*+o[w>>2];o[m>>2]=s;x=k[(h<s?l:m)>>2]|0;k[w>>2]=x;s=(k[u>>2]=x,+o[u>>2]);c=c+s*s;d=d+1|0}while((d|0)!=(n|0));c=1.0/(+Q(+c)+1.0000000474974513e-03);if(!n){r=q;return}else d=0;do{x=b+(d<<2)|0;o[x>>2]=c*+o[x>>2];d=d+1|0}while((d|0)!=(n|0));r=q;return}function KSa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=95608;e=a+112|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=a+92|0;if((k[c>>2]|0)>0){d=k[a+120>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[a+124>>2]|0;if(!((b|0)==(a+128|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=k[a+76>>2]|0;if(!d)return;b=a+80|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-4-d|0)>>>2)<<2);ggb(d);return}function LSa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=95608;e=a+112|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=a+92|0;if((k[c>>2]|0)>0){d=k[a+120>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[a+124>>2]|0;if(!((b|0)==(a+128|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[a+76>>2]|0;if(!b){ggb(a);return}c=a+80|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);ggb(b);ggb(a);return}function MSa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+128|0;y=A+112|0;m=A+56|0;z=A;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[m>>2]=k[g>>2];l=m+4|0;b=g+4|0;k[l>>2]=k[b>>2];v=m+8|0;k[v>>2]=k[g+8>>2];k[m+12>>2]=k[g+12>>2];k[m+16>>2]=k[g+16>>2];k[m+20>>2]=k[g+20>>2];k[m+24>>2]=k[g+24>>2];k[m+28>>2]=k[g+28>>2];k[m+32>>2]=k[g+32>>2];c=k[g+36>>2]|0;k[m+36>>2]=c;e=m+40|0;k[e>>2]=v;v=m+48|0;h=m+44|0;k[h>>2]=v;k[m+52>>2]=0;k[v>>2]=0;if(c|0){v=c+12|0;k[v>>2]=(k[v>>2]|0)+1}if((k[b>>2]|0)<3){u=k[g+44>>2]|0;v=k[h>>2]|0;k[v>>2]=k[u>>2];k[v+4>>2]=k[u+4>>2];break}k[l>>2]=0;x1(m,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;f=k[e>>2]|0;e=k[g+44>>2]|0;c=k[h>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[j+(b<<2)>>2];k[c+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(m,b,-1);while(0);v=a+76|0;e=y+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[y>>2]=-2113732603;k[e>>2]=v;SW(m,y,5,1.0,0.0);e=m+36|0;b=k[e>>2]|0;if(b|0?(t=b+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[m+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;u=m+16|0;c=m+4|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[c>>2]|0)>0){e=k[m+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[m+44>>2]|0;if(!((b|0)==(m+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);p=a+80|0;t=(k[p>>2]|0)-(k[v>>2]|0)>>2;u=cTa(a)|0;if(!((t|0)==(u+1|0)|((t|0)==0|(t|0)==(u|0)))){b=y+4|0;c=ZT(24)|0;k[c>>2]=1;f=c+4|0;k[y>>2]=f;k[b>>2]=19;i[c+23>>0]=0;e=384205;g=f+19|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,y,384225,383507,117);k[b>>2]=0;k[y>>2]=0;u=k[c>>2]|0;k[c>>2]=u+-1;if((u|0)==1)ggb(k[c+-4>>2]|0)}c=(k[p>>2]|0)-(k[v>>2]|0)>>2;k[z>>2]=1124007936;u=z+4|0;b=z+8|0;s=z+40|0;f=u;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[s>>2]=b;t=z+48|0;q=z+44|0;k[q>>2]=t;k[z+52>>2]=0;k[t>>2]=0;k[y>>2]=1;k[y+4>>2]=c;G1(z,2,y,5);m=k[a+12>>2]|0;n=k[a+16>>2]|0;g=aa(aa((m|0)/(k[a+28>>2]|0)|0,k[a+36>>2]|0)|0,(n|0)/(k[a+32>>2]|0)|0)|0;h=k[a+20>>2]|0;j=k[a+24>>2]|0;h=((k[a+4>>2]|0)-m+h|0)/(h|0)|0;j=((k[a+8>>2]|0)-n+j|0)/(j|0)|0;if((j|0)>0?(w=k[z+16>>2]|0,x=(g|0)==0,(h|0)>0):0){f=k[v>>2]|0;c=0;do{l=aa(c,h)|0;if(!x){e=0;do{m=f+((aa((aa(e,j)|0)+c|0,g)|0)<<2)|0;n=w+((aa(e+l|0,g)|0)<<2)|0;b=0;do{k[n+(b<<2)>>2]=k[m+(b<<2)>>2];b=b+1|0}while((b|0)!=(g|0));e=e+1|0}while((e|0)!=(h|0))}c=c+1|0}while((c|0)!=(j|0))}c=cTa(a)|0;b=k[v>>2]|0;if((k[p>>2]|0)-b>>2>>>0>c>>>0)d=+o[b+(c<<2)>>2];else d=0.0;o[a+136>>2]=d;e=y+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[y>>2]=34209792;k[e>>2]=a+88;mY(z,y);e=z+36|0;b=k[e>>2]|0;if(b|0?(a=b+12|0,y=k[a>>2]|0,k[a>>2]=y+-1,(y|0)==1):0){c=k[e>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[z+32>>2]|0;if(!b){b=B1()|0;c=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[e>>2]=0}k[e>>2]=0;z=z+16|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[u>>2]|0)>0){c=k[s>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[u>>2]|0))}b=k[q>>2]|0;if((b|0)==(t|0)|(b|0)==0){r=A;return}ggb(k[b+-4>>2]|0);r=A;return}function NSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=r;r=r+144|0;E=F+88|0;D=F+44|0;B=F;C=b+4|0;c=k[C>>2]|0;if(!c){E=0;r=F;return E|0}if((k[c>>2]&7|0)!=6){E=0;r=F;return E|0}d=k[b>>2]|0;h=k6(d,c,384053)|0;if((d|0)!=0&(h|0)!=0?(f=k[h>>2]|0,g=f&7,(g|0)!=0):0){k[B>>2]=d;k[B+4>>2]=h;if((g+-5|0)>>>0<2&(f&16|0)==0){d=h+8|0;KY(k[d>>2]|0,B+8|0);c=k[h>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[B+40>>2]=c;d=B+20|0;l=k[d>>2]|0;f=a+4|0;if(!l){h=d;j=d;g=0;m=l;d=l}else{g=d;j=d;m=l;A=13}}else{j=B+20|0;k[j>>2]=h;k[B+12>>2]=0;k[B+40>>2]=1;c=1;g=j;m=h;f=a+4|0;l=h;A=13}a:do if((A|0)==13){switch(k[m>>2]&7){case 1:{h=g;g=k[m+8>>2]|0;d=l;break a}case 2:break;default:{h=g;g=2147483647;d=l;break a}}e=+p[m+8>>3];p[u>>3]=e;d=k[u+4>>2]|0;n=d&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){d=(d|0)<0;e=d?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=d?-0.0:0.0}h=g;g=~~e;d=l}while(0);k[f>>2]=g;l=B+40|0;if(!c){n=0;g=l;c=m}else{g=k[B+12>>2]|0;if(g){f=d+(k[g+28>>2]|0)|0;k[j>>2]=f;d=B+28|0;if(f>>>0<(k[d>>2]|0)>>>0)d=f;else{f=B+16|0;m=k[(k[f>>2]|0)+4>>2]|0;k[f>>2]=m;f=k[m+16>>2]|0;k[j>>2]=f;n=f;g=k[g+28>>2]|0;m=k[m+12>>2]|0;k[B+24>>2]=n;m=n+(aa(g,m)|0)|0;k[d>>2]=m;d=n}}else f=m;n=c+-1|0;k[l>>2]=n;g=l;c=f}m=a+8|0;b:do if(!c){l=n;f=0;c=m}else{switch(k[c>>2]&7){case 1:{l=n;f=k[c+8>>2]|0;c=m;break b}case 2:break;default:{l=n;f=2147483647;c=m;break b}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;l=c&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}l=n;f=~~e;c=m}while(0);k[c>>2]=f;if(!l){m=h;l=g}else{c=k[B+12>>2]|0;if(c|0?(n=d+(k[c+28>>2]|0)|0,k[j>>2]=n,o=B+28|0,n>>>0>=(k[o>>2]|0)>>>0):0){f=B+16|0;n=k[(k[f>>2]|0)+4>>2]|0;k[f>>2]=n;f=k[n+16>>2]|0;k[j>>2]=f;m=k[c+28>>2]|0;n=k[n+12>>2]|0;k[B+24>>2]=f;n=f+(aa(m,n)|0)|0;k[o>>2]=n}k[g>>2]=l+-1;m=h;l=g}}else{k[B>>2]=0;k[B+4>>2]=0;j=B+20|0;k[j>>2]=0;k[B+40>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;m=j;l=B+40|0}c=k[b>>2]|0;f=k6(c,k[C>>2]|0,384061)|0;do if((c|0)!=0&(f|0)!=0?(q=k[f>>2]|0,s=q&7,(s|0)!=0):0){k[E>>2]=c;k[E+4>>2]=f;if(!((s+-5|0)>>>0<2&(q&16|0)==0)){k[E+20>>2]=f;k[E+12>>2]=0;k[E+40>>2]=1;break}d=f+8|0;KY(k[d>>2]|0,E+8|0);c=k[f>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[E+40>>2]=c}else A=45;while(0);if((A|0)==45){k[E>>2]=0;k[E+4>>2]=0;k[E+20>>2]=0;k[E+40>>2]=0}f=B;g=E;h=f+44|0;do{k[f>>2]=k[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));d=a+12|0;f=k[m>>2]|0;c:do if(!f)c=0;else{switch(k[f>>2]&7){case 1:{c=k[f+8>>2]|0;break c}case 2:break;default:{c=2147483647;break c}}e=+p[f+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;s=c&2146435072;if(!(s>>>0>1126170624|(s|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}c=~~e}while(0);k[d>>2]=c;g=k[l>>2]|0;if(!g){h=0;c=f;d=f;g=l}else{d=k[B+12>>2]|0;if(d){f=f+(k[d+28>>2]|0)|0;k[j>>2]=f;c=B+28|0;if(f>>>0<(k[c>>2]|0)>>>0){d=f;c=f}else{s=B+16|0;n=k[(k[s>>2]|0)+4>>2]|0;k[s>>2]=n;s=k[n+16>>2]|0;k[j>>2]=s;q=s;o=k[d+28>>2]|0;d=k[n+12>>2]|0;k[B+24>>2]=q;d=q+(aa(o,d)|0)|0;k[c>>2]=d;d=q;c=s}}else{d=f;c=f}h=g+-1|0;k[l>>2]=h;g=l}f=a+16|0;d:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break d}case 2:break;default:{c=2147483647;break d}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;s=c&2146435072;if(!(s>>>0>1126170624|(s|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}c=~~e}while(0);k[f>>2]=c;if(!h)l=g;else{c=k[B+12>>2]|0;if(c|0?(s=d+(k[c+28>>2]|0)|0,k[j>>2]=s,t=B+28|0,s>>>0>=(k[t>>2]|0)>>>0):0){o=B+16|0;s=k[(k[o>>2]|0)+4>>2]|0;k[o>>2]=s;o=k[s+16>>2]|0;k[j>>2]=o;q=k[c+28>>2]|0;s=k[s+12>>2]|0;k[B+24>>2]=o;s=o+(aa(q,s)|0)|0;k[t>>2]=s}k[g>>2]=h+-1;l=g}c=k[b>>2]|0;f=k6(c,k[C>>2]|0,384071)|0;do if((c|0)!=0&(f|0)!=0?(v=k[f>>2]|0,w=v&7,(w|0)!=0):0){k[E>>2]=c;k[E+4>>2]=f;if(!((w+-5|0)>>>0<2&(v&16|0)==0)){k[E+20>>2]=f;k[E+12>>2]=0;k[E+40>>2]=1;break}d=f+8|0;KY(k[d>>2]|0,E+8|0);c=k[f>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[E+40>>2]=c}else A=79;while(0);if((A|0)==79){k[E>>2]=0;k[E+4>>2]=0;k[E+20>>2]=0;k[E+40>>2]=0}f=B;g=E;h=f+44|0;do{k[f>>2]=k[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));d=a+20|0;f=k[m>>2]|0;e:do if(!f)c=0;else{switch(k[f>>2]&7){case 1:{c=k[f+8>>2]|0;break e}case 2:break;default:{c=2147483647;break e}}e=+p[f+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;w=c&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}c=~~e}while(0);k[d>>2]=c;g=k[l>>2]|0;if(!g){h=0;c=f;d=f;g=l}else{d=k[B+12>>2]|0;if(d){f=f+(k[d+28>>2]|0)|0;k[j>>2]=f;c=B+28|0;if(f>>>0<(k[c>>2]|0)>>>0){d=f;c=f}else{w=B+16|0;s=k[(k[w>>2]|0)+4>>2]|0;k[w>>2]=s;w=k[s+16>>2]|0;k[j>>2]=w;v=w;t=k[d+28>>2]|0;d=k[s+12>>2]|0;k[B+24>>2]=v;d=v+(aa(t,d)|0)|0;k[c>>2]=d;d=v;c=w}}else{d=f;c=f}h=g+-1|0;k[l>>2]=h;g=l}f=a+24|0;f:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break f}case 2:break;default:{c=2147483647;break f}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;w=c&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}c=~~e}while(0);k[f>>2]=c;if(!h)l=g;else{c=k[B+12>>2]|0;if(c|0?(w=d+(k[c+28>>2]|0)|0,k[j>>2]=w,x=B+28|0,w>>>0>=(k[x>>2]|0)>>>0):0){t=B+16|0;w=k[(k[t>>2]|0)+4>>2]|0;k[t>>2]=w;t=k[w+16>>2]|0;k[j>>2]=t;v=k[c+28>>2]|0;w=k[w+12>>2]|0;k[B+24>>2]=t;w=t+(aa(v,w)|0)|0;k[x>>2]=w}k[g>>2]=h+-1;l=g}c=k[b>>2]|0;f=k6(c,k[C>>2]|0,384187)|0;do if((c|0)!=0&(f|0)!=0?(y=k[f>>2]|0,z=y&7,(z|0)!=0):0){k[E>>2]=c;k[E+4>>2]=f;if(!((z+-5|0)>>>0<2&(y&16|0)==0)){k[E+20>>2]=f;k[E+12>>2]=0;k[E+40>>2]=1;break}d=f+8|0;KY(k[d>>2]|0,E+8|0);c=k[f>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[E+40>>2]=c}else A=113;while(0);if((A|0)==113){k[E>>2]=0;k[E+4>>2]=0;k[E+20>>2]=0;k[E+40>>2]=0}f=B;g=E;h=f+44|0;do{k[f>>2]=k[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));d=a+28|0;f=k[m>>2]|0;g:do if(!f)c=0;else{switch(k[f>>2]&7){case 1:{c=k[f+8>>2]|0;break g}case 2:break;default:{c=2147483647;break g}}e=+p[f+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;A=c&2146435072;if(!(A>>>0>1126170624|(A|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}c=~~e}while(0);k[d>>2]=c;g=k[l>>2]|0;if(!g){h=0;c=f;g=l}else{d=k[B+12>>2]|0;if(d){f=f+(k[d+28>>2]|0)|0;k[j>>2]=f;c=B+28|0;if(f>>>0<(k[c>>2]|0)>>>0){d=f;c=f}else{A=B+16|0;x=k[(k[A>>2]|0)+4>>2]|0;k[A>>2]=x;A=k[x+16>>2]|0;k[j>>2]=A;z=A;y=k[d+28>>2]|0;d=k[x+12>>2]|0;k[B+24>>2]=z;d=z+(aa(y,d)|0)|0;k[c>>2]=d;d=z;c=A}}else{d=f;c=f}h=g+-1|0;k[l>>2]=h;f=d;g=l}d=a+32|0;h:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break h}case 2:break;default:{c=2147483647;break h}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;A=c&2146435072;do if(!(A>>>0>1126170624|(A|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(!(e==0.0))break;e=c?-0.0:0.0}while(0);c=~~e}while(0);k[d>>2]=c;if(h|0){d=k[B+12>>2]|0;do if(d|0){A=f+(k[d+28>>2]|0)|0;k[j>>2]=A;c=B+28|0;if(A>>>0<(k[c>>2]|0)>>>0)break;y=B+16|0;A=k[(k[y>>2]|0)+4>>2]|0;k[y>>2]=A;y=k[A+16>>2]|0;k[j>>2]=y;z=k[d+28>>2]|0;A=k[A+12>>2]|0;k[B+24>>2]=y;B=y+(aa(z,A)|0)|0;k[c>>2]=B}while(0);k[g>>2]=h+-1}c=k6(k[b>>2]|0,k[C>>2]|0,384083)|0;d=a+36|0;i:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break i}case 2:break;default:{c=2147483647;break i}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;B=c&2146435072;do if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(!(e==0.0))break;e=c?-0.0:0.0}while(0);c=~~e}while(0);k[d>>2]=c;c=k6(k[b>>2]|0,k[C>>2]|0,384089)|0;d=a+40|0;j:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break j}case 2:break;default:{c=2147483647;break j}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;B=c&2146435072;do if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(!(e==0.0))break;e=c?-0.0:0.0}while(0);c=~~e}while(0);k[d>>2]=c;c=k6(k[b>>2]|0,k[C>>2]|0,384196)|0;d=a+48|0;k:do if(!c)e=0.0;else switch(k[c>>2]&7){case 1:{e=+(k[c+8>>2]|0);break k}case 2:{e=+p[c+8>>3];break k}default:{e=1.e+300;break k}}while(0);p[d>>3]=e;c=k6(k[b>>2]|0,k[C>>2]|0,384103)|0;d=a+56|0;l:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break l}case 2:break;default:{c=2147483647;break l}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;B=c&2146435072;do if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(!(e==0.0))break;e=c?-0.0:0.0}while(0);c=~~e}while(0);k[d>>2]=c;c=k6(k[b>>2]|0,k[C>>2]|0,384121)|0;d=a+64|0;m:do if(!c)e=0.0;else switch(k[c>>2]&7){case 1:{e=+(k[c+8>>2]|0);break m}case 2:{e=+p[c+8>>3];break m}default:{e=1.e+300;break m}}while(0);p[d>>3]=e;c=k6(k[b>>2]|0,k[C>>2]|0,384136)|0;d=a+72|0;n:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break n}case 2:break;default:{c=2147483647;break n}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;B=c&2146435072;do if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(!(e==0.0))break;e=c?-0.0:0.0}while(0);c=~~e}while(0);i[d>>0]=(c|0)!=0&1;c=k6(k[b>>2]|0,k[C>>2]|0,384152)|0;d=a+140|0;o:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break o}case 2:break;default:{c=2147483647;break o}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;B=c&2146435072;do if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(!(e==0.0))break;e=c?-0.0:0.0}while(0);c=~~e}while(0);k[d>>2]=c;if(!(k6(k[b>>2]|0,k[C>>2]|0,384160)|0))i[a+144>>0]=0;else{c=k6(k[b>>2]|0,k[C>>2]|0,384160)|0;d=a+144|0;p:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break p}case 2:break;default:{c=2147483647;break p}}e=+p[c+8>>3];p[u>>3]=e;c=k[u+4>>2]|0;B=c&2146435072;do if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(!(e==0.0))break;e=c?-0.0:0.0}while(0);c=~~e}while(0);i[d>>0]=(c|0)!=0&1}d=k[b>>2]|0;f=k6(d,k[C>>2]|0,384175)|0;do if(f|0){c=k[f>>2]|0;if((c&7|0)!=5)break;g=a+76|0;do if(!d){k[D>>2]=0;k[D+4>>2]=0;k[D+20>>2]=0;k[D+40>>2]=0}else{k[D>>2]=d;k[D+4>>2]=f;if(c&16|0){k[D+20>>2]=f;k[D+12>>2]=0;k[D+40>>2]=1;break}d=f+8|0;KY(k[d>>2]|0,D+8|0);c=k[f>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[D+40>>2]=c}while(0);k[E>>2]=D;EEa(E,g);C=(k[a+80>>2]|0)-(k[g>>2]|0)>>2;D=cTa(a)|0;if((C|0)==(D+1|0)|((C|0)==0|(C|0)==(D|0)))break;c=E+4|0;d=ZT(24)|0;k[d>>2]=1;f=d+4|0;k[E>>2]=f;k[c>>2]=19;i[d+23>>0]=0;g=384205;h=f+19|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,E,401059,383507,167);k[c>>2]=0;k[E>>2]=0;E=k[d>>2]|0;k[d>>2]=E+-1;if((E|0)==1)ggb(k[d+-4>>2]|0)}while(0);E=1;r=F;return E|0}function OSa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o+8|0;g=o;if(k[c+4>>2]|0)z6(b,c)|0;k[n>>2]=0;f=n+4|0;k[f>>2]=0;l=ZT(32)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[f>>2]=27;i[l+31>>0]=0;l=384025;m=j+27|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[f>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);k[n>>2]=0;m=n+4|0;k[m>>2]=0;l=ZT(12)|0;k[l>>2]=1;d=l+4|0;k[n>>2]=d;k[m>>2]=7;i[l+11>>0]=0;i[d>>0]=i[384053]|0;i[d+1>>0]=i[384054]|0;i[d+2>>0]=i[384055]|0;i[d+3>>0]=i[384056]|0;i[d+4>>0]=i[384057]|0;i[d+5>>0]=i[384058]|0;i[d+6>>0]=i[384059]|0;c=z6(c,n)|0;d=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);c=hTa(c,a+4|0)|0;k[n>>2]=0;f=n+4|0;k[f>>2]=0;l=ZT(16)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[f>>2]=9;i[l+13>>0]=0;l=384061;m=j+9|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=z6(c,n)|0;d=k[n>>2]|0;k[f>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);c=hTa(c,a+12|0)|0;k[n>>2]=0;f=n+4|0;k[f>>2]=0;l=ZT(16)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[f>>2]=11;i[l+15>>0]=0;l=384071;m=j+11|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=z6(c,n)|0;d=k[n>>2]|0;k[f>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);c=hTa(c,a+20|0)|0;k[n>>2]=0;m=n+4|0;k[m>>2]=0;l=ZT(16)|0;k[l>>2]=1;d=l+4|0;k[n>>2]=d;k[m>>2]=8;i[l+12>>0]=0;l=d;i[l>>0]=99;i[l+1>>0]=101;i[l+2>>0]=108;i[l+3>>0]=108;d=d+4|0;i[d>>0]=83;i[d+1>>0]=105;i[d+2>>0]=122;i[d+3>>0]=101;c=z6(c,n)|0;d=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);c=hTa(c,a+28|0)|0;k[n>>2]=0;m=n+4|0;k[m>>2]=0;l=ZT(12)|0;k[l>>2]=1;d=l+4|0;k[n>>2]=d;k[m>>2]=5;i[l+9>>0]=0;i[d>>0]=i[384083]|0;i[d+1>>0]=i[384084]|0;i[d+2>>0]=i[384085]|0;i[d+3>>0]=i[384086]|0;i[d+4>>0]=i[384087]|0;c=z6(c,n)|0;d=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);c=iTa(c,a+36|0)|0;k[n>>2]=0;f=n+4|0;k[f>>2]=0;l=ZT(20)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[f>>2]=13;i[l+17>>0]=0;l=384089;m=j+13|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=z6(c,n)|0;d=k[n>>2]|0;k[f>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);d=iTa(c,a+40|0)|0;k[n>>2]=0;m=n+4|0;k[m>>2]=0;l=ZT(16)|0;k[l>>2]=1;c=l+4|0;k[n>>2]=c;k[m>>2]=8;i[l+12>>0]=0;l=c;i[l>>0]=119;i[l+1>>0]=105;i[l+2>>0]=110;i[l+3>>0]=83;c=c+4|0;i[c>>0]=105;i[c+1>>0]=103;i[c+2>>0]=109;i[c+3>>0]=97;d=z6(d,n)|0;c=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(c|0?(l=c+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);e=+p[a+48>>3];if(!(e>=0.0))e=+((k[a+16>>2]|0)+(k[a+12>>2]|0)|0)*.125;p[g>>3]=e;c=jTa(d,g)|0;k[n>>2]=0;f=n+4|0;k[f>>2]=0;l=ZT(24)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[f>>2]=17;i[l+21>>0]=0;l=384103;m=j+17|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=z6(c,n)|0;d=k[n>>2]|0;k[f>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);c=iTa(c,a+56|0)|0;k[n>>2]=0;f=n+4|0;k[f>>2]=0;l=ZT(20)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[f>>2]=14;i[l+18>>0]=0;l=384121;m=j+14|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=z6(c,n)|0;d=k[n>>2]|0;k[f>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);c=jTa(c,a+64|0)|0;k[n>>2]=0;f=n+4|0;k[f>>2]=0;l=ZT(20)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[f>>2]=15;i[l+19>>0]=0;l=384136;m=j+15|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=z6(c,n)|0;d=k[n>>2]|0;k[f>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);c=kTa(c,a+72|0)|0;k[n>>2]=0;m=n+4|0;k[m>>2]=0;l=ZT(12)|0;k[l>>2]=1;d=l+4|0;k[n>>2]=d;k[m>>2]=7;i[l+11>>0]=0;i[d>>0]=i[384152]|0;i[d+1>>0]=i[384153]|0;i[d+2>>0]=i[384154]|0;i[d+3>>0]=i[384155]|0;i[d+4>>0]=i[384156]|0;i[d+5>>0]=i[384157]|0;i[d+6>>0]=i[384158]|0;c=z6(c,n)|0;d=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);c=iTa(c,a+140|0)|0;k[n>>2]=0;f=n+4|0;k[f>>2]=0;l=ZT(20)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[f>>2]=14;i[l+18>>0]=0;l=384160;m=j+14|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));c=z6(c,n)|0;d=k[n>>2]|0;k[f>>2]=0;k[n>>2]=0;if(d|0?(l=d+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);kTa(c,a+144|0)|0;h=a+76|0;do if((k[h>>2]|0)!=(k[a+80>>2]|0)){k[n>>2]=0;d=n+4|0;k[d>>2]=0;l=ZT(16)|0;k[l>>2]=1;j=l+4|0;k[n>>2]=j;k[d>>2]=11;i[l+15>>0]=0;l=384175;m=j+11|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));g=z6(b,n)|0;c=k[n>>2]|0;k[d>>2]=0;k[n>>2]=0;if(c|0?(m=c+-4|0,a=k[m>>2]|0,k[m>>2]=a+-1,(a|0)==1):0)ggb(k[c+-8>>2]|0);if(Xh[k[(k[g>>2]|0)+12>>2]&1023](g)|0){c=g+32|0;if((k[c>>2]|0)==6){d=n+4|0;f=ZT(36)|0;k[f>>2]=1;j=f+4|0;k[n>>2]=j;k[d>>2]=30;i[f+34>>0]=0;l=401220;m=j+30|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-2,n,401251,401262,1064);k[d>>2]=0;k[n>>2]=0;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)==1)ggb(k[f+-4>>2]|0)}E6(n,g,k[g+12>>2]|0,k[g+16>>2]|0,13,0,0);GEa(g,h);F6(n);if(!(k[c>>2]&4))break;k[c>>2]=6}}while(0);a=n+4|0;m=ZT(8)|0;k[m>>2]=1;c=m+4|0;k[n>>2]=c;k[a>>2]=1;i[m+5>>0]=0;i[c>>0]=125;z6(b,n)|0;c=k[n>>2]|0;k[a>>2]=0;k[n>>2]=0;if(!c){r=o;return}b=c+-4|0;n=k[b>>2]|0;k[b>>2]=n+-1;if((n|0)!=1){r=o;return}ggb(k[c+-8>>2]|0);r=o;return}function PSa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=r;r=r+144|0;d=m+136|0;h=m+88|0;i=m+44|0;j=m+8|0;l=m;k[d>>2]=0;g=d+4|0;k[g>>2]=0;x6(j,b,0,d);k[g>>2]=0;k[d>>2]=0;if(k[c+4>>2]|0){h=k[j+8>>2]|0;i=k[c>>2]|0;i=k6(h,0,(i|0)==0?1016759:i)|0;k[l>>2]=h;k[l+4>>2]=i;i=k[a>>2]|0;i=i+12|0;i=k[i>>2]|0;l=Hh[i&511](a,l)|0;T4(j);r=m;return l|0}y6(d,j);g=k[d>>2]|0;d=k[d+4>>2]|0;if((g|0)!=0&(d|0)!=0?(e=k[d>>2]|0,f=e&7,(f|0)!=0):0){k[h>>2]=g;k[h+4>>2]=d;if((f+-5|0)>>>0<2&(e&16|0)==0){b=d+8|0;KY(k[b>>2]|0,h+8|0);c=k[d>>2]|0;switch(c&7){case 6:{b=k[(k[b>>2]|0)+60>>2]|0;break}case 5:{b=k[(k[b>>2]|0)+24>>2]|0;break}default:b=(c&7|0)!=0&1}k[h+40>>2]=b}else{k[h+20>>2]=d;k[h+12>>2]=0;k[h+40>>2]=1}c=14}else{k[h>>2]=0;k[h+4>>2]=0;k[h+20>>2]=0;k[h+40>>2]=0;if(!d){b=1;c=18}else c=14}a:do if((c|0)==14){b=k[d>>2]|0;switch(b&7){case 6:{b=k[(k[d+8>>2]|0)+60>>2]|0;break a}case 5:{b=k[(k[d+8>>2]|0)+24>>2]|0;break a}default:{b=(b&7|0)==0;c=18;break a}}}while(0);if((c|0)==18)b=b&1^1;B6(i,g,d,b);g=k[h>>2]|0;b=g;if((((g|0)==(k[i>>2]|0)?(k[h+4>>2]|0)==(k[i+4>>2]|0):0)?(k[h+20>>2]|0)==(k[i+20>>2]|0):0)?(k[h+40>>2]|0)==(k[i+40>>2]|0):0){k[l>>2]=0;k[l+4>>2]=0}else{i=k[h+20>>2]|0;k[l>>2]=b;k[l+4>>2]=i}i=k[a>>2]|0;i=i+12|0;i=k[i>>2]|0;l=Hh[i&511](a,l)|0;T4(j);r=m;return l|0}function QSa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;u=r;r=r+1104|0;p=u+56|0;l=u+48|0;s=u+8|0;t=u;k[p>>2]=0;q=p+4|0;k[q>>2]=0;x6(s,b,1,p);k[q>>2]=0;k[p>>2]=0;q=k[(k[a>>2]|0)+16>>2]|0;d=k[c+4>>2]|0;if(!d){j=k[b>>2]|0;j=(j|0)==0?1016759:j;d=k[b+4>>2]|0;g=j+d|0;d=d+1|0;n=p+8|0;k[p>>2]=n;o=p+4|0;k[o>>2]=1032;if(d>>>0>1032){while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[p>>2]=c}else c=n;k[o>>2]=d;d=g+-1|0;a:do if(d>>>0>=j>>>0){h=g;b:while(1){g=d;d=h;c:while(1){switch(i[g>>0]|0){case 58:case 47:case 92:break b;case 46:{d=i[h>>0]|0;if(!(d<<24>>24))break c;else{e=h;f=3;b=228682}while(1){f=f+-1|0;v=i[b>>0]|0;if(!(d<<24>>24==v<<24>>24&((f|0)!=0&v<<24>>24!=0)))break;e=e+1|0;b=b+1|0;d=i[e>>0]|0;if(!(d<<24>>24)){d=0;break}}if(d<<24>>24==(i[b>>0]|0))break c;break}default:{}}d=g+-1|0;if(d>>>0<j>>>0){d=g;break b}else{v=g;g=d;d=v}}d=g+-1|0;if(d>>>0<j>>>0){m=19;break a}else h=g}if((d|0)==(h|0)){g=h;m=19}}else m=19;while(0);if((m|0)==19){k[l>>2]=0;c=l+4|0;k[c>>2]=0;d=ZT(24)|0;k[d>>2]=1;b=d+4|0;k[l>>2]=b;k[c>>2]=16;i[d+20>>0]=0;e=228686;f=b+16|0;do{i[b>>0]=i[e>>0]|0;b=b+1|0;e=e+1|0}while((b|0)<(f|0));Y8(-5,l,228703,221854,134);k[c>>2]=0;k[l>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0);h=g;d=g;c=k[p>>2]|0}v=i[d>>0]|0;if(!(((v&-33)+-65&255)<26|v<<24>>24==95)){i[c>>0]=95;c=c+1|0}if(d>>>0<h>>>0)while(1){b=i[d>>0]|0;d=d+1|0;if((b+-48&255)<10|(b+-97&255)<26)e=1;else e=(b+-65&255)<26;f=c+1|0;i[c>>0]=b<<24>>24==95|(b<<24>>24==45|e)?b:95;if((d|0)==(h|0)){c=f;break}else c=f}i[c>>0]=0;g=k[p>>2]|0;f=i[g>>0]|0;if(f<<24>>24==95){c=225442;d=g;do{d=d+1|0;c=c+1|0;b=i[d>>0]|0;e=i[c>>0]|0}while(!(b<<24>>24==0?1:b<<24>>24!=e<<24>>24));if(b<<24>>24==e<<24>>24){d=g;m=d;i[m>>0]=117;i[m+1>>0]=110;i[m+2>>0]=110;i[m+3>>0]=97;d=d+4|0;i[d>>0]=109;i[d+1>>0]=101;i[d+2>>0]=100;i[d+3>>0]=0;k[t>>2]=0;k[t+4>>2]=0;d=117;m=33}else m=32}else m=32;if((m|0)==32){k[t>>2]=0;k[t+4>>2]=0;if(!g)m=45;else{d=f;m=33}}if((m|0)==33){e=g;d:do if(!(e&3)){c=g;m=37}else{b=g;c=e;while(1){if(!(d<<24>>24))break d;d=b+1|0;c=d;if(!(c&3)){c=d;m=37;break d}b=d;d=i[d>>0]|0}}while(0);if((m|0)==37){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}c=c-e|0;v=ZT(c+8&-4)|0;k[v>>2]=1;v=v+4|0;k[t>>2]=v;k[t+4>>2]=c;i[v+c>>0]=0;upb(v|0,g|0,c|0)|0;c=k[p>>2]|0;if((c|0)!=(n|0))if(!c)m=45;else{ggb(c);m=45}}if((m|0)==45){k[p>>2]=n;k[o>>2]=1032}}else{c=k[c>>2]|0;k[t>>2]=c;k[t+4>>2]=d;if(c|0){v=c+-4|0;k[v>>2]=(k[v>>2]|0)+1}}Ph[q&511](a,s,t);c=k[t>>2]|0;k[t+4>>2]=0;k[t>>2]=0;if(!c){T4(s);r=u;return}t=c+-4|0;v=k[t>>2]|0;k[t>>2]=v+-1;if((v|0)!=1){T4(s);r=u;return}ggb(k[c+-8>>2]|0);T4(s);r=u;return}function RSa(a,b){a=a|0;b=b|0;var c=0,d=0;k[b+4>>2]=k[a+4>>2];k[b+8>>2]=k[a+8>>2];k[b+12>>2]=k[a+12>>2];k[b+16>>2]=k[a+16>>2];k[b+20>>2]=k[a+20>>2];k[b+24>>2]=k[a+24>>2];k[b+28>>2]=k[a+28>>2];k[b+32>>2]=k[a+32>>2];k[b+36>>2]=k[a+36>>2];k[b+40>>2]=k[a+40>>2];p[b+48>>3]=+p[a+48>>3];k[b+56>>2]=k[a+56>>2];p[b+64>>3]=+p[a+64>>3];i[b+72>>0]=i[a+72>>0]|0;if((b|0)==(a|0)){d=a+140|0;d=k[d>>2]|0;c=b+140|0;k[c>>2]=d;a=a+144|0;a=i[a>>0]|0;b=b+144|0;i[b>>0]=a;return}zH(b+76|0,k[a+76>>2]|0,k[a+80>>2]|0);d=a+140|0;d=k[d>>2]|0;c=b+140|0;k[c>>2]=d;c=a+144|0;c=i[c>>0]|0;d=b+144|0;i[d>>0]=c;return}function SSa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+416|0;q=J+400|0;l=J+392|0;I=J+336|0;G=J+8|0;w=J;g=k[d>>2]|0;x=d+4|0;h=k[x>>2]|0;if(!(h|g)){g=k[a+28>>2]|0;k[d>>2]=g;h=k[a+32>>2]|0;k[x>>2]=h}j=k[a+20>>2]|0;u=(g|0)<(j|0);i=u?j:g;j=u?g:j;if((j|0)>0){g=i;i=j;while(1){g=(g|0)%(i|0)|0;if((g|0)>0){u=i;i=g;g=u}else break}}u=k[a+24>>2]|0;t=(h|0)<(u|0);g=t?u:h;h=t?h:u;if((h|0)>0)while(1){g=(g|0)%(h|0)|0;if((g|0)>0){u=h;h=g;g=u}else{g=h;break}}k[q>>2]=i;o=q+4|0;k[o>>2]=g;R1(l,b,-1);s=f+4|0;p=(k[s>>2]|0)-(k[f>>2]|0)>>3;t=k[e>>2]|0;u=k[q>>2]|0;u=u+-1+((t|0)<0?0:t)&0-u;k[e>>2]=u;t=e+4|0;n=k[t>>2]|0;o=k[o>>2]|0;o=o+-1+((n|0)<0?0:n)&0-o;k[t>>2]=o;u=(u<<1)+(k[l>>2]|0)|0;o=(o<<1)+(k[l+4>>2]|0)|0;do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[I>>2]=k[l>>2];n=I+4|0;g=l+4|0;k[n>>2]=k[g>>2];b=I+8|0;k[b>>2]=k[l+8>>2];k[I+12>>2]=k[l+12>>2];k[I+16>>2]=k[l+16>>2];k[I+20>>2]=k[l+20>>2];k[I+24>>2]=k[l+24>>2];k[I+28>>2]=k[l+28>>2];k[I+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[I+36>>2]=h;i=I+40|0;k[i>>2]=b;b=I+48|0;m=I+44|0;k[m>>2]=b;k[I+52>>2]=0;k[b>>2]=0;if(h|0){b=h+12|0;k[b>>2]=(k[b>>2]|0)+1}if((k[g>>2]|0)<3){b=k[l+44>>2]|0;n=k[m>>2]|0;k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];break}k[n>>2]=0;x1(I,k[g>>2]|0,0,0,0);if((k[n>>2]|0)>0){b=k[l+40>>2]|0;j=k[i>>2]|0;i=k[l+44>>2]|0;h=k[m>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[b+(g<<2)>>2];k[h+(g<<2)>>2]=k[i+(g<<2)>>2];g=g+1|0}while((g|0)<(k[n>>2]|0))}}else Q1(I,b,-1);while(0);n=(p|0)==0;bTa(G,a,I,e,e,n,q);if(n)p=aa(((o-(k[G+48>>2]|0)|0)/(k[x>>2]|0)|0)+1|0,((u-(k[G+44>>2]|0)|0)/(k[d>>2]|0)|0)+1|0)|0;n=k[G+16>>2]|0;o=aa(k[G+64>>2]|0,k[G+60>>2]|0)|0;g=k[G+76>>2]|0;q=cTa(a)|0;h=aa(q,p)|0;i=c+4|0;b=k[i>>2]|0;l=k[c>>2]|0;j=b-l>>2;if(h>>>0<=j>>>0){if(h>>>0<j>>>0?(v=l+(h<<2)|0,(b|0)!=(v|0)):0)k[i>>2]=b+(~((b+-4-v|0)>>>2)<<2)}else FEa(c,h-j|0);if(p|0?(y=G+44|0,z=I+12|0,A=a+4|0,B=I+8|0,C=a+8|0,D=w+4|0,E=g<<2,(o|0)>0):0){b=0;do{m=aa(b,q)|0;m=(k[c>>2]|0)+(m<<2)|0;g=k[f>>2]|0;if((g|0)!=(k[s>>2]|0)){h=k[g+(b<<3)>>2]|0;g=k[g+(b<<3)+4>>2]|0;v=k[e>>2]|0;if((((h|0)>=(0-v|0)?(h|0)<=((k[z>>2]|0)+v-(k[A>>2]|0)|0):0)?(F=k[t>>2]|0,(g|0)>=(0-F|0)):0)?(g|0)<=((k[B>>2]|0)+F-(k[C>>2]|0)|0):0)H=35}else{h=k[d>>2]|0;H=((u-(k[y>>2]|0)|0)/(h|0)|0)+1|0;g=(b|0)/(H|0)|0;h=aa(b-(aa(H,g)|0)|0,h)|0;g=aa(k[x>>2]|0,g)|0;h=h-(k[e>>2]|0)|0;g=g-(k[t>>2]|0)|0;H=35}if((H|0)==35){H=0;i=0;do{l=(k[n+(i*12|0)+8>>2]|0)+g|0;j=m+(k[n+(i*12|0)>>2]<<2)|0;k[w>>2]=(k[n+(i*12|0)+4>>2]|0)+h;k[D>>2]=l;l=dTa(G,w,j)|0;if((l|0)!=(j|0))upb(j|0,l|0,E|0)|0;i=i+1|0}while((i|0)<(o|0))}b=b+1|0}while(b>>>0<p>>>0)}GSa(G);i=I+36|0;g=k[i>>2]|0;if(g|0?(G=g+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){h=k[i>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[I+32>>2]|0;if(!g){g=B1()|0;h=k[i>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[i>>2]=0}k[i>>2]=0;H=I+16|0;h=I+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[h>>2]|0)>0){i=k[I+40>>2]|0;g=0;do{k[i+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[I+44>>2]|0;if((g|0)==(I+48|0)|(g|0)==0){r=J;return}ggb(k[g+-4>>2]|0);r=J;return}function TSa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;da=r;r=r+368|0;ba=da+352|0;ca=da+24|0;X=da+16|0;Y=da;Z=da+8|0;j=k[c>>2]|0;_=c+4|0;l=k[_>>2]|0;if((l|0)!=(j|0))k[_>>2]=l+(~((l+-8-j|0)>>>3)<<3);j=k[d>>2]|0;W=d+4|0;l=k[W>>2]|0;if((l|0)!=(j|0))k[W>>2]=l+(~((l+-8-j|0)>>>3)<<3);T=a+76|0;s=a+80|0;if((k[T>>2]|0)==(k[s>>2]|0)){r=da;return}j=k[f>>2]|0;U=f+4|0;l=k[U>>2]|0;if(!(l|j)){j=k[a+28>>2]|0;k[f>>2]=j;l=k[a+32>>2]|0;k[U>>2]=l}n=k[a+20>>2]|0;S=(j|0)<(n|0);m=S?n:j;n=S?j:n;if((n|0)>0){j=m;m=n;while(1){j=(j|0)%(m|0)|0;if((j|0)>0){S=m;m=j;j=S}else break}}S=k[a+24>>2]|0;R=(l|0)<(S|0);j=R?S:l;l=R?l:S;if((l|0)>0)while(1){j=(j|0)%(l|0)|0;if((j|0)>0){S=l;l=j;j=S}else{j=l;break}}k[ba>>2]=m;R=ba+4|0;k[R>>2]=j;S=h+4|0;n=(k[S>>2]|0)-(k[h>>2]|0)>>3;O=k[g>>2]|0;O=m+-1+((O|0)<0?0:O)&0-m;k[g>>2]=O;Q=g+4|0;N=k[Q>>2]|0;j=j+-1+((N|0)<0?0:N)&0-j;k[Q>>2]=j;N=b+12|0;O=(O<<1)+(k[N>>2]|0)|0;P=b+8|0;l=k[P>>2]|0;M=(n|0)==0;bTa(ca,a,b,g,g,M,ba);if(M)n=aa((((j<<1)+l-(k[ca+48>>2]|0)|0)/(k[U>>2]|0)|0)+1|0,((O-(k[ca+44>>2]|0)|0)/(k[f>>2]|0)|0)+1|0)|0;K=k[ca+16>>2]|0;L=aa(k[ca+64>>2]|0,k[ca+60>>2]|0)|0;M=k[ca+76>>2]|0;j=cTa(a)|0;l=k[T>>2]|0;if((k[s>>2]|0)-l>>2>>>0>j>>>0)J=+o[l+(j<<2)>>2];else J=0.0;if(!M)j=0;else{if(M>>>0>1073741823)ad(426534,426557,304,426811);m=M<<2;l=(m|0)==0?1:m;while(1){j=fgb(l)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}zpb(j|0,0,m|0)|0}if(n|0){z=X+4|0;A=ca+44|0;B=Y+4|0;C=(L|0)>0;D=Z+4|0;E=M+-4|0;F=(M|0)<4;G=c+8|0;H=d+8|0;I=a+4|0;v=a+8|0;w=M&-4;x=(M|0)>0;y=(w|0)<(M|0);u=0;do{k[X>>2]=0;k[z>>2]=0;l=k[h>>2]|0;do if((l|0)!=(k[S>>2]|0)){a=k[l+(u<<3)>>2]|0;k[X>>2]=a;l=k[l+(u<<3)+4>>2]|0;k[z>>2]=l;t=k[g>>2]|0;if((((a|0)>=(0-t|0)?(a|0)<=((k[N>>2]|0)+t-(k[I>>2]|0)|0):0)?($=k[Q>>2]|0,(l|0)>=(0-$|0)):0)?(l|0)<=((k[P>>2]|0)+$-(k[v>>2]|0)|0):0)V=38}else{t=k[f>>2]|0;a=((O-(k[A>>2]|0)|0)/(t|0)|0)+1|0;V=(u|0)/(a|0)|0;t=aa(u-(aa(a,V)|0)|0,t)|0;V=aa(k[U>>2]|0,V)|0;t=t-(k[g>>2]|0)|0;V=V-(k[Q>>2]|0)|0;k[X>>2]=t;k[z>>2]=V;if(((t|0)%(k[ba>>2]|0)|0|0)==0?((V|0)%(k[R>>2]|0)|0|0)==0:0){V=38;break}k[Y>>2]=0;k[B>>2]=0;l=ZT(72)|0;k[l>>2]=1;m=l+4|0;k[Y>>2]=m;k[B>>2]=65;i[l+69>>0]=0;b=383959;s=m+65|0;do{i[m>>0]=i[b>>0]|0;m=m+1|0;b=b+1|0}while((m|0)<(s|0));Y8(-215,Y,386843,383507,1509);k[B>>2]=0;k[Y>>2]=0;V=k[l>>2]|0;k[l>>2]=V+-1;if((V|0)==1)ggb(k[l+-4>>2]|0);V=38}while(0);if((V|0)==38){V=0;p[Y>>3]=J;l=k[T>>2]|0;a:do if(C){a=k[X>>2]|0;t=k[z>>2]|0;if(F){s=0;q=J;while(1){b=(k[K+(s*12|0)+8>>2]|0)+t|0;k[Z>>2]=(k[K+(s*12|0)+4>>2]|0)+a;k[D>>2]=b;b=dTa(ca,Z,j)|0;if(x){m=0;do{q=q+ +o[b+(m<<2)>>2]*+o[l+(m<<2)>>2];m=m+1|0}while((m|0)!=(M|0));p[Y>>3]=q}s=s+1|0;if((s|0)>=(L|0))break a;else l=l+(M<<2)|0}}else{s=0;q=J}while(1){b=(k[K+(s*12|0)+8>>2]|0)+t|0;k[Z>>2]=(k[K+(s*12|0)+4>>2]|0)+a;k[D>>2]=b;b=dTa(ca,Z,j)|0;m=0;do{ga=m|1;fa=m|2;ea=m|3;q=q+(+o[b+(m<<2)>>2]*+o[l+(m<<2)>>2]+ +o[b+(ga<<2)>>2]*+o[l+(ga<<2)>>2]+ +o[b+(fa<<2)>>2]*+o[l+(fa<<2)>>2]+ +o[b+(ea<<2)>>2]*+o[l+(ea<<2)>>2]);m=m+4|0}while((m|0)<=(E|0));p[Y>>3]=q;if(y){m=w;do{q=q+ +o[b+(m<<2)>>2]*+o[l+(m<<2)>>2];m=m+1|0}while((m|0)!=(M|0));p[Y>>3]=q}s=s+1|0;if((s|0)>=(L|0))break;else l=l+(M<<2)|0}}else q=J;while(0);do if(q>=e){l=k[_>>2]|0;if((l|0)==(k[G>>2]|0))Efa(c,X);else{k[l>>2]=k[X>>2];k[l+4>>2]=k[z>>2];k[_>>2]=l+8}l=k[W>>2]|0;if((l|0)==(k[H>>2]|0)){Koa(d,Y);break}else{p[l>>3]=q;k[W>>2]=l+8;break}}while(0)}u=u+1|0}while(u>>>0<n>>>0)}if(j|0)ggb(j);GSa(ca);r=da;return}function USa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0,n=0;i=r;r=r+32|0;j=i+16|0;m=i+8|0;l=i;k[j>>2]=0;h=j+4|0;k[h>>2]=0;k[j+8>>2]=0;n=k[(k[a>>2]|0)+36>>2]|0;k[m>>2]=k[e>>2];k[m+4>>2]=k[e+4>>2];k[l>>2]=k[f>>2];k[l+4>>2]=k[f+4>>2];Of[n&3](a,b,c,j,d,m,l,g);a=k[j>>2]|0;if(!a){r=i;return}b=k[h>>2]|0;if((b|0)!=(a|0))k[h>>2]=b+(~((b+-8-a|0)>>>3)<<3);ggb(a);r=i;return}function VSa(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;j=+j;l=l|0;var m=0,n=0,o=0,q=0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0;ua=r;r=r+416|0;W=ua+248|0;X=ua+224|0;fa=ua+208|0;U=ua+120|0;q=ua+112|0;ha=ua+400|0;sa=ua+388|0;ra=ua+376|0;qa=ua+364|0;pa=ua+352|0;ma=ua+340|0;na=ua+336|0;oa=ua+280|0;B=ua+272|0;ka=ua;p[q>>3]=1.0;R1(ha,b,-1);k[sa>>2]=0;ta=sa+4|0;k[ta>>2]=0;k[sa+8>>2]=0;s=a+140|0;a:do if((k[s>>2]|0)>0){t=sa+8|0;w=a+4|0;x=ha+4|0;y=a+8|0;if(!(h<=1.0)){n=0;o=0;z=1.0;m=0}else{Koa(sa,q);m=0;break}while(1){if((n|0)==(o|0))Koa(sa,q);else{p[n>>3]=z;k[ta>>2]=n+8}v=+(k[ha>>2]|0)/z;p[u>>3]=v;n=k[u+4>>2]|0;ja=n&2146435072;if(!(ja>>>0>1126170624|(ja|0)==1126170624&0>0)){n=(n|0)<0;v=n?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(v==0.0)v=n?-0.0:0.0}if((~~v|0)<(k[w>>2]|0))break a;v=+(k[x>>2]|0)/z;p[u>>3]=v;n=k[u+4>>2]|0;ja=n&2146435072;if(!(ja>>>0>1126170624|(ja|0)==1126170624&0>0)){n=(n|0)<0;v=n?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(v==0.0)v=n?-0.0:0.0}if((~~v|0)<(k[y>>2]|0))break a;v=z*h;p[q>>3]=v;m=m+1|0;if((m|0)>=(k[s>>2]|0))break a;n=k[ta>>2]|0;o=k[t>>2]|0;z=v}}else m=0;while(0);m=(m|0)<1?1:m;q=k[ta>>2]|0;o=k[sa>>2]|0;n=q-o>>3;if(m>>>0<=n>>>0){if(m>>>0<n>>>0?(A=o+(m<<3)|0,(q|0)!=(A|0)):0)k[ta>>2]=q+(~((q+-8-A|0)>>>3)<<3)}else Bla(sa,m-n|0);y=f+4|0;if(!(k[y>>2]|k[f>>2])){k[f>>2]=k[a+20>>2];k[y>>2]=k[a+24>>2]}k[ra>>2]=0;ja=ra+4|0;k[ja>>2]=0;k[ra+8>>2]=0;k[qa>>2]=0;ia=qa+4|0;k[ia>>2]=0;k[qa+8>>2]=0;k[pa>>2]=0;ga=pa+4|0;k[ga>>2]=0;k[pa+8>>2]=0;k[ma>>2]=0;ea=ma+4|0;k[ea>>2]=0;k[ma+8>>2]=0;m9(na);do if((k[b>>2]&2031616|0)==65536){q=k[b+4>>2]|0;k[oa>>2]=k[q>>2];x=oa+4|0;m=q+4|0;k[x>>2]=k[m>>2];da=oa+8|0;k[da>>2]=k[q+8>>2];k[oa+12>>2]=k[q+12>>2];k[oa+16>>2]=k[q+16>>2];k[oa+20>>2]=k[q+20>>2];k[oa+24>>2]=k[q+24>>2];k[oa+28>>2]=k[q+28>>2];k[oa+32>>2]=k[q+32>>2];n=k[q+36>>2]|0;k[oa+36>>2]=n;o=oa+40|0;k[o>>2]=da;da=oa+48|0;t=oa+44|0;k[t>>2]=da;k[oa+52>>2]=0;k[da>>2]=0;if(n|0){da=n+12|0;k[da>>2]=(k[da>>2]|0)+1}if((k[m>>2]|0)<3){ca=k[q+44>>2]|0;da=k[t>>2]|0;k[da>>2]=k[ca>>2];k[da+4>>2]=k[ca+4>>2];break}k[x>>2]=0;x1(oa,k[m>>2]|0,0,0,0);if((k[x>>2]|0)>0){w=k[q+40>>2]|0;s=k[o>>2]|0;o=k[q+44>>2]|0;n=k[t>>2]|0;m=0;do{k[s+(m<<2)>>2]=k[w+(m<<2)>>2];k[n+(m<<2)>>2]=k[o+(m<<2)>>2];m=m+1|0}while((m|0)<(k[x>>2]|0))}}else Q1(oa,b,-1);while(0);n=k[sa>>2]|0;o=(k[ta>>2]|0)-n>>3;k[B>>2]=0;k[B+4>>2]=o;k[ka>>2]=95700;o=ka+8|0;k[o>>2]=1124007936;ca=ka+12|0;m=ka+16|0;aa=ka+48|0;q=ca;w=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(w|0));k[aa>>2]=m;da=ka+56|0;ba=ka+52|0;k[ba>>2]=da;k[ka+60>>2]=0;k[da>>2]=0;m=ka+72|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[ka+4>>2]=a;KG(o,oa)|0;p[ka+64>>3]=e;k[m>>2]=k[f>>2];k[ka+76>>2]=k[y>>2];k[ka+80>>2]=k[g>>2];k[ka+84>>2]=k[g+4>>2];k[ka+88>>2]=n;k[ka+92>>2]=ra;k[ka+96>>2]=pa;k[ka+100>>2]=qa;k[ka+104>>2]=na;jh[k[(k[ka>>2]|0)+8>>2]&1023](ka,B);m=k[qa>>2]|0;o=k[ia>>2]|0;if((m|0)!=(o|0)){q=ma+8|0;do{n=k[ea>>2]|0;if((n|0)==(k[q>>2]|0))Koa(ma,m);else{p[n>>3]=+p[m>>3];k[ea>>2]=n+8}m=m+8|0}while((m|0)!=(o|0))}m=k[c>>2]|0;$=c+4|0;n=k[$>>2]|0;if((n|0)!=(m|0)){m=n+(~((n+-16-m|0)>>>4)<<4)|0;k[$>>2]=m}n=k[ra>>2]|0;o=k[ja>>2]|0;b:do if((n|0)!=(o|0)){q=c+8|0;while(1){if((m|0)==(k[q>>2]|0))SRa(c,n);else{k[m>>2]=k[n>>2];k[m+4>>2]=k[n+4>>2];k[m+8>>2]=k[n+8>>2];k[m+12>>2]=k[n+12>>2];k[$>>2]=m+16}n=n+16|0;if((n|0)==(o|0))break b;m=k[$>>2]|0}}while(0);m=k[d>>2]|0;Y=d+4|0;n=k[Y>>2]|0;if((n|0)!=(m|0)){m=n+(~((n+-8-m|0)>>>3)<<3)|0;k[Y>>2]=m}n=k[pa>>2]|0;o=k[ga>>2]|0;c:do if((n|0)!=(o|0)){q=d+8|0;while(1){if((m|0)==(k[q>>2]|0))Koa(d,n);else{p[m>>3]=+p[n>>3];k[Y>>2]=m+8}m=n+8|0;if((m|0)==(o|0))break c;n=m;m=k[Y>>2]|0}}while(0);do if(!l){T=~~j;if((T|0)>=1?(F=k[c>>2]|0,G=k[$>>2]|0,(F|0)!=(G|0)):0){if((G-F>>4|0)!=((k[Y>>2]|0)-(k[d>>2]|0)>>3|0)){k[W>>2]=0;m=W+4|0;k[m>>2]=0;n=ZT(40)|0;k[n>>2]=1;q=n+4|0;k[W>>2]=q;k[m>>2]=33;i[n+37>>0]=0;o=383891;w=q+33|0;do{i[q>>0]=i[o>>0]|0;q=q+1|0;o=o+1|0}while((q|0)<(w|0));Y8(-215,W,383925,383507,3534);k[m>>2]=0;k[W>>2]=0;V=k[n>>2]|0;k[n>>2]=V+-1;if((V|0)==1)ggb(k[n+-4>>2]|0)}k[W>>2]=0;S=W+4|0;k[S>>2]=0;k[W+8>>2]=0;R=RRa(c,W,.2)|0;t=(R|0)==0;if(!t){if(R>>>0>134217727)ad(426534,426557,304,426811);o=R<<5;n=(o|0)==0?1:o;while(1){m=fgb(n)|0;if(m|0)break;m=k[207666]|0;k[207666]=m+0;if(!m){m=0;break}Qh[m&7]()}zpb(m|0,0,o|0)|0;if(!t){q=R<<2;o=(q|0)==0?1:q;while(1){n=fgb(o)|0;if(n|0){s=n;break}n=k[207666]|0;k[207666]=n+0;if(!n){s=0;break}Qh[n&7]()}zpb(s|0,0,q|0)|0;if(t){n=0;P=s}else{o=R<<3;o=(o|0)==0?1:o;while(1){n=fgb(o)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}o=R;q=n;while(1){p[q>>3]=-1797693134862315708145274.0e284;o=o+-1|0;if(!o){P=s;break}else q=q+8|0}}}else{n=0;P=0}}else{n=0;P=0;m=0}O=k[S>>2]|0;M=k[W>>2]|0;W=O-M|0;t=W>>2;N=M;if((W|0)>0){q=k[c>>2]|0;s=k[d>>2]|0;o=0;do{W=k[N+(o<<2)>>2]|0;V=m+(W<<5)|0;p[V>>3]=+(k[q+(o<<4)>>2]|0)+ +p[V>>3];V=m+(W<<5)+8|0;p[V>>3]=+(k[q+(o<<4)+4>>2]|0)+ +p[V>>3];V=m+(W<<5)+16|0;p[V>>3]=+(k[q+(o<<4)+8>>2]|0)+ +p[V>>3];V=m+(W<<5)+24|0;p[V>>3]=+(k[q+(o<<4)+12>>2]|0)+ +p[V>>3];V=n+(W<<3)|0;j=+p[V>>3];E=+p[s+(o<<3)>>3];p[V>>3]=j<E?E:j;W=P+(W<<2)|0;k[W>>2]=(k[W>>2]|0)+1;o=o+1|0}while((o|0)<(t|0))}s=(R|0)>0;if(s){o=0;do{L=m+(o<<5)|0;U=m+(o<<5)+8|0;V=m+(o<<5)+16|0;W=m+(o<<5)+24|0;C=1.0/+(k[P+(o<<2)>>2]|0);D=+p[U>>3]*C;E=+p[V>>3]*C;j=+p[W>>3]*C;p[L>>3]=+p[L>>3]*C;p[U>>3]=D;p[V>>3]=E;p[W>>3]=j;o=o+1|0}while((o|0)!=(R|0))}o=k[c>>2]|0;q=k[$>>2]|0;if((q|0)!=(o|0))k[$>>2]=q+(~((q+-16-o|0)>>>4)<<4);o=k[d>>2]|0;q=k[Y>>2]|0;if((q|0)!=(o|0))k[Y>>2]=q+(~((q+-8-o|0)>>>3)<<3);if(s){I=X+4|0;J=X+8|0;K=X+12|0;L=c+8|0;H=d+8|0;G=0;do{v=+p[m+(G<<5)>>3];p[u>>3]=v;o=k[u+4>>2]|0;W=o&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){o=(o|0)<0;v=o?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=o?-0.0:0.0}while(0);F=~~v;v=+p[m+(G<<5)+8>>3];p[u>>3]=v;o=k[u+4>>2]|0;W=o&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){o=(o|0)<0;v=o?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=o?-0.0:0.0}while(0);a=~~v;v=+p[m+(G<<5)+16>>3];p[u>>3]=v;o=k[u+4>>2]|0;W=o&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){o=(o|0)<0;v=o?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=o?-0.0:0.0}while(0);l=~~v;v=+p[m+(G<<5)+24>>3];p[u>>3]=v;o=k[u+4>>2]|0;W=o&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){o=(o|0)<0;v=o?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=o?-0.0:0.0}while(0);g=~~v;k[X>>2]=F;k[I>>2]=a;k[J>>2]=l;k[K>>2]=g;o=k[P+(G<<2)>>2]|0;z=+p[n+(G<<3)>>3];p[fa>>3]=z;do if((o|0)>(T|0)){B=l+F|0;f=g+a|0;b=(o|0)>3?o:3;d:do if((o|0)<3){o=0;do{do if((o|0)!=(G|0)?(k[P+(o<<2)>>2]|0)>(T|0):0){v=+p[m+(o<<5)>>3];p[u>>3]=v;q=k[u+4>>2]|0;W=q&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){q=(q|0)<0;v=q?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=q?-0.0:0.0}while(0);y=~~v;v=+p[m+(o<<5)+8>>3];p[u>>3]=v;q=k[u+4>>2]|0;W=q&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){q=(q|0)<0;v=q?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=q?-0.0:0.0}while(0);x=~~v;v=+p[m+(o<<5)+16>>3];p[u>>3]=v;q=k[u+4>>2]|0;W=q&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){q=(q|0)<0;v=q?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=q?-0.0:0.0}while(0);w=~~v;v=+p[m+(o<<5)+24>>3];p[u>>3]=v;q=k[u+4>>2]|0;W=q&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){q=(q|0)<0;v=q?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=q?-0.0:0.0}while(0);t=~~v;v=+(w|0)*.2;p[u>>3]=v;q=k[u+4>>2]|0;W=q&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){q=(q|0)<0;v=q?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=q?-0.0:0.0}while(0);s=~~v;v=+(t|0)*.2;p[u>>3]=v;q=k[u+4>>2]|0;W=q&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){q=(q|0)<0;v=q?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=q?-0.0:0.0}while(0);q=~~v;if((F|0)<(y-s|0)|(a|0)<(x-q|0))break;if((B|0)>(w+y+s|0))break;if((f|0)<=(t+x+q|0))break d}while(0);o=o+1|0}while((o|0)<(R|0))}else{o=0;do{A=k[P+(o<<2)>>2]|0;do if((o|0)!=(G|0)&(A|0)>(T|0)){v=+p[m+(o<<5)>>3];p[u>>3]=v;q=k[u+4>>2]|0;W=q&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){q=(q|0)<0;v=q?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=q?-0.0:0.0}while(0);y=~~v;v=+p[m+(o<<5)+8>>3];p[u>>3]=v;q=k[u+4>>2]|0;W=q&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){q=(q|0)<0;v=q?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=q?-0.0:0.0}while(0);x=~~v;v=+p[m+(o<<5)+16>>3];p[u>>3]=v;q=k[u+4>>2]|0;W=q&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){q=(q|0)<0;v=q?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=q?-0.0:0.0}while(0);w=~~v;v=+p[m+(o<<5)+24>>3];p[u>>3]=v;q=k[u+4>>2]|0;W=q&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){q=(q|0)<0;v=q?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=q?-0.0:0.0}while(0);t=~~v;v=+(w|0)*.2;p[u>>3]=v;q=k[u+4>>2]|0;W=q&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){q=(q|0)<0;v=q?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=q?-0.0:0.0}while(0);s=~~v;v=+(t|0)*.2;p[u>>3]=v;q=k[u+4>>2]|0;W=q&2146435072;do if(!(W>>>0>1126170624|(W|0)==1126170624&0>0)){q=(q|0)<0;v=q?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(!(v==0.0))break;v=q?-0.0:0.0}while(0);q=~~v;if((F|0)<(y-s|0)|(a|0)<(x-q|0))break;if((B|0)>(w+y+s|0))break;if((A|0)>(b|0)?(f|0)<=(t+x+q|0):0)break d}while(0);o=o+1|0}while((o|0)<(R|0))}while(0);if((o|0)!=(R|0))break;o=k[$>>2]|0;if((o|0)==(k[L>>2]|0))SRa(c,X);else{k[o>>2]=F;k[o+4>>2]=a;k[o+8>>2]=l;k[o+12>>2]=g;k[$>>2]=o+16}o=k[Y>>2]|0;if((o|0)==(k[H>>2]|0)){Koa(d,fa);break}else{p[o>>3]=z;k[Y>>2]=o+8;break}}while(0);G=G+1|0}while((G|0)<(R|0))}if(n|0)ggb(n);if(P|0)ggb(P);if(m|0)ggb(m);m=M;if(M|0){if((O|0)!=(N|0))k[S>>2]=O+(~((O+-4-M|0)>>>2)<<2);ggb(m)}}}else{N=k[a+4>>2]|0;O=k[a+8>>2]|0;f=k[$>>2]|0;A=k[c>>2]|0;w=f-A|0;b=w>>4;q=(b|0)==0;B=A;if(!q){if(b>>>0>178956970)ad(426534,426557,304,426811);o=b*24|0;n=(o|0)==0?1:o;while(1){m=fgb(n)|0;if(m|0)break;m=k[207666]|0;k[207666]=m+0;if(!m){m=0;break}Qh[m&7]()}s=m;zpb(m|0,0,o|0)|0;t=m+o|0;if(q){R=0;g=0}else{q=w>>1;o=(q|0)==0?1:q;while(1){n=fgb(o)|0;if(n|0)break;n=k[207666]|0;k[207666]=n+0;if(!n){n=0;break}Qh[n&7]()}zpb(n|0,0,q|0)|0;R=n;g=n+(b<<3)|0}}else{R=0;s=0;g=0;t=0;m=0}k[fa>>2]=0;P=fa+4|0;k[P>>2]=0;k[fa+8>>2]=0;if((w|0)>0){x=k[d>>2]|0;y=k[ma>>2]|0;w=0;do{p[R+(w<<3)>>3]=+p[x+(w<<3)>>3];o=(k[B+(w<<4)+12>>2]|0)+(k[B+(w<<4)+4>>2]<<1)|0;v=+((k[B+(w<<4)+8>>2]|0)+(k[B+(w<<4)>>2]<<1)|0)*.5;p[u>>3]=v;n=k[u+4>>2]|0;M=n&2146435072;if(!(M>>>0>1126170624|(M|0)==1126170624&0>0)){n=(n|0)<0;v=n?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(v==0.0)v=n?-0.0:0.0}q=~~v;v=+(o|0)*.5;p[u>>3]=v;n=k[u+4>>2]|0;M=n&2146435072;if(!(M>>>0>1126170624|(M|0)==1126170624&0>0)){n=(n|0)<0;v=n?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(v==0.0)v=n?-0.0:0.0}E=+_(+(+p[y+(w<<3)>>3]));p[m+(w*24|0)>>3]=+(q|0);p[m+(w*24|0)+8>>3]=+(~~v|0);p[m+(w*24|0)+16>>3]=E;w=w+1|0}while((w|0)<(b|0))}if((f|0)!=(B|0))k[$>>2]=f+(~((f+-16-A|0)>>>4)<<4);m=k[d>>2]|0;n=k[Y>>2]|0;if((n|0)!=(m|0))k[Y>>2]=n+(~((n+-8-m|0)>>>3)<<3);M=U+4|0;m=U+12|0;L=U+16|0;l=U+52|0;K=U+56|0;a=U+64|0;I=U+68|0;q=U;w=q+40|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(w|0));k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;k[l+16>>2]=0;k[l+20>>2]=0;F=U+24|0;p[F>>3]=8.0;G=U+32|0;p[G>>3]=16.0;H=U+40|0;p[H>>3]=.26236426446749106;yGa(m,R,g);n=s;A=t;x=(t-s|0)/24|0;y=U+8|0;m=k[y>>2]|0;q=k[U>>2]|0;o=q;do if(x>>>0<=((m-q|0)/24|0)>>>0){m=k[M>>2]|0;q=(m-q|0)/24|0;w=x>>>0>q>>>0;x=n+(q*24|0)|0;q=w?x:A;if((q|0)==(n|0))n=o;else{do{p[o>>3]=+p[n>>3];p[o+8>>3]=+p[n+8>>3];p[o+16>>3]=+p[n+16>>3];n=n+24|0;o=o+24|0}while((n|0)!=(q|0));n=o}if(!w){if((m|0)==(n|0))break;k[M>>2]=m+(~(((m+-24-n|0)>>>0)/24|0)*24|0);break}if((q|0)!=(A|0)){n=x;do{p[m>>3]=+p[n>>3];p[m+8>>3]=+p[n+8>>3];p[m+16>>3]=+p[n+16>>3];n=n+24|0;m=m+24|0}while((n|0)!=(A|0));k[M>>2]=m}}else{w=q;if(q){m=k[M>>2]|0;if((m|0)!=(o|0))k[M>>2]=m+(~(((m+-24-q|0)>>>0)/24|0)*24|0);ggb(w);k[y>>2]=0;k[M>>2]=0;k[U>>2]=0;m=0}if(x>>>0>178956970)ad(426534,426557,304,426811);g=(m|0)/24|0;q=g<<1;q=g>>>0<89478485?(q>>>0<x>>>0?x:q):178956970;if(q>>>0>178956970)bob();o=q*24|0;o=(o|0)==0?1:o;while(1){m=fgb(o)|0;if(m|0)break;m=k[207666]|0;k[207666]=m+0;if(!m){m=0;break}Qh[m&7]()}k[M>>2]=m;k[U>>2]=m;k[y>>2]=m+(q*24|0);if((n|0)==(A|0))break;do{p[m>>3]=+p[n>>3];p[m+8>>3]=+p[n+8>>3];p[m+16>>3]=+p[n+16>>3];n=n+24|0;m=m+24|0}while((n|0)!=(A|0));k[M>>2]=m}while(0);n=(t-s|0)/24|0;m=U+48|0;k[m>>2]=n;t=k[K>>2]|0;q=k[l>>2]|0;o=(t-q|0)/24|0;if(n>>>0<=o>>>0){if(n>>>0<o>>>0?(J=q+(n*24|0)|0,(t|0)!=(J|0)):0)k[K>>2]=t+(~(((t+-24-J|0)>>>0)/24|0)*24|0)}else{$Ra(l,n-o|0);n=k[m>>2]|0}q=k[I>>2]|0;o=k[a>>2]|0;m=(q-o|0)/24|0;do if(n>>>0<=m>>>0){if(n>>>0<m>>>0){m=o+(n*24|0)|0;if((q|0)==(m|0))break;k[I>>2]=q+(~(((q+-24-m|0)>>>0)/24|0)*24|0)}}else $Ra(a,n-m|0);while(0);t=U+76|0;k[t>>2]=100;w=U+80|0;p[w>>3]=1.0e-05;m=k[U>>2]|0;if((k[M>>2]|0)!=(m|0)){x=W+8|0;y=W+16|0;A=W+8|0;b=W+16|0;B=X+8|0;f=X+16|0;q=0;n=k[l>>2]|0;do{aSa(W,U,m+(q*24|0)|0);p[n+(q*24|0)>>3]=+p[W>>3];p[n+(q*24|0)+8>>3]=+p[x>>3];p[n+(q*24|0)+16>>3]=+p[y>>3];o=k[a>>2]|0;n=k[l>>2]|0;v=+p[n+(q*24|0)>>3];h=+p[n+(q*24|0)+8>>3];z=+p[n+(q*24|0)+16>>3];k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;k[W+16>>2]=0;k[W+20>>2]=0;if((k[t>>2]|0)>0){m=0;do{p[W>>3]=v;p[A>>3]=h;p[b>>3]=z;aSa(X,U,W);E=v;v=+p[X>>3];e=h;h=+p[B>>3];C=z;z=+p[f>>3];D=+Z(+C);E=(E-v)/(+p[F>>3]*D);D=(e-h)/(+p[G>>3]*D);C=(C-z)/+p[H>>3];m=m+1|0}while((m|0)<(k[t>>2]|0)?!(C*C+(D*D+E*E)<=+p[w>>3]):0);n=k[l>>2]|0}p[o+(q*24|0)>>3]=v;p[o+(q*24|0)+8>>3]=h;p[o+(q*24|0)+16>>3]=z;m=k[U>>2]|0;D=+p[m+(q*24|0)+8>>3];E=+p[m+(q*24|0)+16>>3];J=n+(q*24|0)|0;p[J>>3]=+p[J>>3]-+p[m+(q*24|0)>>3];J=n+(q*24|0)+8|0;p[J>>3]=+p[J>>3]-D;J=n+(q*24|0)+16|0;p[J>>3]=+p[J>>3]-E;q=q+1|0}while(q>>>0<(((k[M>>2]|0)-m|0)/24|0)>>>0)}m=k[I>>2]|0;n=k[a>>2]|0;e:do if((m|0)!=(n|0)){B=0;b=0;t=0;q=0;o=m;f:while(1){x=n;A=b;y=t;g:do if((t|0)==(b|0))S=136;else{v=+p[F>>3];z=+p[G>>3];h=+p[H>>3];w=(t-b|0)/24|0;e=+p[x+(B*24|0)>>3];C=+p[x+(B*24|0)+8>>3];D=+p[x+(B*24|0)+16>>3];m=0;while(1){wa=+p[A+(m*24|0)+16>>3];va=+Z(+wa);E=(+p[A+(m*24|0)>>3]-e)/(v*va);va=(+p[A+(m*24|0)+8>>3]-C)/(z*va);wa=(wa-D)/h;m=m+1|0;if(wa*wa+(va*va+E*E)<1.0){m=b;break g}if(m>>>0>=w>>>0){S=136;break}}}while(0);do if((S|0)==136){S=0;w=x+(B*24|0)|0;if((y|0)!=(q|0)){p[y>>3]=+p[w>>3];p[y+8>>3]=+p[x+(B*24|0)+8>>3];p[y+16>>3]=+p[x+(B*24|0)+16>>3];m=b;t=y+24|0;break}t=(t-b|0)/24|0;m=t+1|0;if(m>>>0>178956970){S=139;break f}X=(q-b|0)/24|0;o=X<<1;o=X>>>0<89478485?(o>>>0<m>>>0?m:o):178956970;if(!o)n=0;else{if(o>>>0>178956970){S=142;break f}n=o*24|0;n=(n|0)==0?1:n;while(1){m=fgb(n)|0;if(m|0)break;m=k[207666]|0;k[207666]=m+0;if(!m){m=0;break}Qh[m&7]()}n=m}m=n+(t*24|0)|0;q=n+(o*24|0)|0;p[m>>3]=+p[w>>3];p[n+(t*24|0)+8>>3]=+p[x+(B*24|0)+8>>3];p[n+(t*24|0)+16>>3]=+p[x+(B*24|0)+16>>3];t=m+24|0;if((y|0)!=(A|0)){n=y;do{X=n;n=n+-24|0;p[m+-24>>3]=+p[n>>3];p[m+-16>>3]=+p[X+-16>>3];p[m+-8>>3]=+p[X+-8>>3];m=m+-24|0}while((n|0)!=(A|0))}if(b|0)ggb(b);n=k[a>>2]|0;o=k[I>>2]|0}while(0);B=B+1|0;if(B>>>0>=((o-n|0)/24|0)>>>0){V=m;T=t;break e}else b=m}if((S|0)==139)ad(426534,426557,304,426811);else if((S|0)==142){ua=te(4)|0;k[ua>>2]=172664;Cf(ua|0,28816,1287)}}else{V=0;T=0}while(0);l=(T-V|0)/24|0;o=k[P>>2]|0;n=k[fa>>2]|0;m=o-n>>3;a=V;do if(l>>>0>m>>>0)Bla(fa,l-m|0);else{if(l>>>0>=m>>>0)break;m=n+(l<<3)|0;if((o|0)==(m|0))break;k[P>>2]=o+(~((o+-8-m|0)>>>3)<<3)}while(0);o=(T|0)==(V|0);do if(!o){n=k[M>>2]|0;y=k[U>>2]|0;q=(n|0)==(y|0);t=y;w=k[fa>>2]|0;x=k[U+12>>2]|0;y=(n-y|0)/24|0;n=0;do{if(q)v=0.0;else{C=+p[F>>3];D=+p[G>>3];E=+p[H>>3];z=+p[a+(n*24|0)>>3];h=+p[a+(n*24|0)+8>>3];e=+p[a+(n*24|0)+16>>3];v=0.0;m=0;do{xa=+p[t+(m*24|0)+16>>3];wa=+Z(+xa);va=C*wa;wa=D*wa;za=(+p[t+(m*24|0)>>3]-z)/va;ya=(+p[t+(m*24|0)+8>>3]-h)/wa;xa=(xa-e)/E;v=v+ +p[x+(m<<3)>>3]*+Z(+((za*za+ya*ya+xa*xa)*-.5))/+Q(+(E+(va+wa)));m=m+1|0}while(m>>>0<y>>>0)}p[w+(n<<3)>>3]=v;n=n+1|0}while(n>>>0<l>>>0);if(o)break;A=W+4|0;b=W+8|0;B=W+12|0;f=c+8|0;g=d+8|0;z=+(N|0);v=+(O|0);x=k[fa>>2]|0;w=0;do{za=+Z(+(+p[a+(w*24|0)+16>>3]));m=~~(z*za);n=~~(v*za);o=~~(+p[a+(w*24|0)>>3]-+((m|0)/2|0|0));q=~~(+p[a+(w*24|0)+8>>3]-+((n|0)/2|0|0));k[W>>2]=o;k[A>>2]=q;k[b>>2]=m;k[B>>2]=n;y=x+(w<<3)|0;do if(+p[y>>3]>j){t=k[$>>2]|0;if((t|0)==(k[f>>2]|0))SRa(c,W);else{k[t>>2]=o;k[t+4>>2]=q;k[t+8>>2]=m;k[t+12>>2]=n;k[$>>2]=t+16}m=k[Y>>2]|0;if((m|0)==(k[g>>2]|0)){Koa(d,y);break}else{p[m>>3]=+p[y>>3];k[Y>>2]=m+8;break}}while(0);w=w+1|0}while(w>>>0<l>>>0)}while(0);m=k[U+64>>2]|0;n=m;if(m|0){o=k[I>>2]|0;if((o|0)!=(m|0))k[I>>2]=o+(~(((o+-24-n|0)>>>0)/24|0)*24|0);ggb(m)}m=k[U+52>>2]|0;n=m;if(m|0){o=k[K>>2]|0;if((o|0)!=(m|0))k[K>>2]=o+(~(((o+-24-n|0)>>>0)/24|0)*24|0);ggb(m)}m=k[U+12>>2]|0;n=m;if(m|0){o=k[L>>2]|0;if((o|0)!=(m|0))k[L>>2]=o+(~((o+-8-n|0)>>>3)<<3);ggb(m)}m=k[U>>2]|0;n=m;if(m|0){o=k[M>>2]|0;if((o|0)!=(m|0))k[M>>2]=o+(~(((o+-24-n|0)>>>0)/24|0)*24|0);ggb(m)}m=k[fa>>2]|0;n=m;if(m|0){o=k[P>>2]|0;if((o|0)!=(m|0))k[P>>2]=o+(~((o+-8-n|0)>>>3)<<3);ggb(m)}if(R|0)ggb(R);if(V|0)ggb(V);if(!s)break;ggb(s)}while(0);hSa(k[ha>>2]|0,k[ha+4>>2]|0,c,0,d);k[ka>>2]=95700;o=ka+44|0;m=k[o>>2]|0;if(m|0?(c=m+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){n=k[o>>2]|0;if(n|0){m=k[n+4>>2]|0;if(!m){m=k[ka+40>>2]|0;if(!m){m=B1()|0;n=k[o>>2]|0}}jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[o>>2]=0}k[o>>2]=0;ka=ka+24|0;k[ka>>2]=0;k[ka+4>>2]=0;k[ka+8>>2]=0;k[ka+12>>2]=0;if((k[ca>>2]|0)>0){n=k[aa>>2]|0;m=0;do{k[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[ca>>2]|0))}m=k[ba>>2]|0;if(!((m|0)==(da|0)|(m|0)==0))ggb(k[m+-4>>2]|0);o=oa+36|0;m=k[o>>2]|0;if(m|0?(d=m+12|0,ka=k[d>>2]|0,k[d>>2]=ka+-1,(ka|0)==1):0){n=k[o>>2]|0;if(n|0){m=k[n+4>>2]|0;do if(!m){m=k[oa+32>>2]|0;if(m|0)break;m=B1()|0;n=k[o>>2]|0}while(0);jh[k[(k[m>>2]|0)+24>>2]&1023](m,n)}k[o>>2]=0}k[o>>2]=0;ka=oa+16|0;n=oa+4|0;k[ka>>2]=0;k[ka+4>>2]=0;k[ka+8>>2]=0;k[ka+12>>2]=0;if((k[n>>2]|0)>0){o=k[oa+40>>2]|0;m=0;do{k[o+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(k[n>>2]|0))}m=k[oa+44>>2]|0;if(!((m|0)==(oa+48|0)|(m|0)==0))ggb(k[m+-4>>2]|0);ka=(k[na>>2]|0)+28|0;oa=k[ka>>2]|0;k[ka>>2]=oa+-1;if((oa|0)==1?(la=k[na>>2]|0,la|0):0){rf(la|0)|0;ggb(la)}m=k[ma>>2]|0;n=m;if(m|0){o=k[ea>>2]|0;if((o|0)!=(m|0))k[ea>>2]=o+(~((o+-8-n|0)>>>3)<<3);ggb(m)}m=k[pa>>2]|0;n=m;if(m|0){o=k[ga>>2]|0;if((o|0)!=(m|0))k[ga>>2]=o+(~((o+-8-n|0)>>>3)<<3);ggb(m)}m=k[qa>>2]|0;n=m;if(m|0){o=k[ia>>2]|0;if((o|0)!=(m|0))k[ia>>2]=o+(~((o+-8-n|0)>>>3)<<3);ggb(m)}m=k[ra>>2]|0;n=m;if(m|0){o=k[ja>>2]|0;if((o|0)!=(m|0))k[ja>>2]=o+(~((o+-16-n|0)>>>4)<<4);ggb(m)}m=k[sa>>2]|0;if(!m){r=ua;return}n=k[ta>>2]|0;if((n|0)!=(m|0))k[ta>>2]=n+(~((n+-8-m|0)>>>3)<<3);ggb(m);r=ua;return}function WSa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=+g;h=+h;i=i|0;var j=0,l=0,m=0,n=0,o=0,p=0;l=r;r=r+32|0;m=l+16|0;o=l+8|0;n=l;k[m>>2]=0;j=m+4|0;k[j>>2]=0;k[m+8>>2]=0;p=k[(k[a>>2]|0)+44>>2]|0;k[o>>2]=k[e>>2];k[o+4>>2]=k[e+4>>2];k[n>>2]=k[f>>2];k[n+4>>2]=k[f+4>>2];jg[p&3](a,b,c,m,d,o,n,g,h,i);a=k[m>>2]|0;if(!a){r=l;return}b=k[j>>2]|0;if((b|0)!=(a|0))k[j>>2]=b+(~((b+-8-a|0)>>>3)<<3);ggb(a);r=l;return}function XSa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,p=0,q=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0;Ja=r;r=r+2496|0;ua=Ja+2472|0;m=Ja+2464|0;j=Ja+2456|0;Fa=Ja+2400|0;Ca=Ja+1336|0;Ba=Ja+272|0;za=Ja+216|0;xa=Ja+160|0;wa=Ja+104|0;va=Ja+48|0;ra=Ja+32|0;sa=Ja+16|0;ta=Ja;switch(k[b>>2]&4095){case 16:case 0:break;default:{g=ua+4|0;h=ZT(52)|0;k[h>>2]=1;U=h+4|0;k[ua>>2]=U;k[g>>2]=44;i[h+48>>0]=0;M=383797;V=U+44|0;do{i[U>>0]=i[M>>0]|0;U=U+1|0;M=M+1|0}while((U|0)<(V|0));Y8(-215,ua,383842,383507,228);k[g>>2]=0;k[ua>>2]=0;Ia=k[h>>2]|0;k[h>>2]=Ia+-1;if((Ia|0)==1)ggb(k[h+-4>>2]|0)}}t=k[b+12>>2]|0;u=k[e>>2]|0;v=k[f>>2]|0;qa=u+t+v|0;z=k[b+8>>2]|0;B=e+4|0;A=k[B>>2]|0;y=k[f+4>>2]|0;pa=A+z+y|0;if(!(((((k[c+4>>2]|0)<3?(k[c+8>>2]|0)==(pa|0):0)?(k[c+12>>2]|0)==(qa|0):0)?(k[c>>2]&4095|0)==13:0)?(k[c+16>>2]|0)!=0:0)){k[ua>>2]=pa;k[ua+4>>2]=qa;G1(c,2,ua,13)}if(((((k[d+4>>2]|0)<3?(k[d+8>>2]|0)==(pa|0):0)?(k[d+12>>2]|0)==(qa|0):0)?(k[d>>2]&4095|0)==8:0)?(k[d+16>>2]|0)!=0:0){h=ua;f=ua+4|0}else{k[ua>>2]=pa;f=ua+4|0;k[f>>2]=qa;G1(d,2,ua,8);h=ua}k[m>>2]=0;x=m+4|0;k[x>>2]=0;k[j>>2]=0;w=j+4|0;k[w>>2]=0;N1(b,m,j);D=(k[b>>2]|0)>>>3&511;k[Fa>>2]=1124007936;Ha=Fa+4|0;g=Fa+8|0;Ea=Fa+40|0;U=Ha;V=U+36|0;do{k[U>>2]=0;U=U+4|0}while((U|0)<(V|0));k[Ea>>2]=g;Ia=Fa+48|0;Ga=Fa+44|0;k[Ga>>2]=Ia;k[Fa+52>>2]=0;k[Ia>>2]=0;k[h>>2]=1;k[f>>2]=256;G1(Fa,2,h,5);Da=Fa+16|0;oa=k[Da>>2]|0;if(!(i[a+72>>0]|0)){g=0;do{o[oa+(g<<2)>>2]=+(g|0);g=g+1|0}while((g|0)!=256)}else{g=0;do{s=+Q(+(+(g|0)));o[oa+(g<<2)>>2]=s;g=g+1|0}while((g|0)!=256)}f=qa+4+pa|0;Aa=Ca+8|0;k[Ca>>2]=Aa;ya=Ca+4|0;k[ya>>2]=264;if(f>>>0>264){h=f>>>0>1073741823?-1:f<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[Ca>>2]=g;C=g}else C=Aa;k[ya>>2]=f;ha=C+4|0;ia=ha+(qa<<2)+8|0;if((qa|0)>=-1){q=k[j>>2]|0;m=k[m>>2]|0;n=(m|0)==1;p=m<<1;j=u+t+v|0;f=-1;while(1){g=f-(k[e>>2]|0)+q|0;h=g>>>0<m>>>0;if(h|n)g=h?g:0;else do g=(g|0)<0?0-g|0:-2-g+p|0;while(g>>>0>=m>>>0);k[ha+(f<<2)>>2]=g-q;if((f|0)==(j|0))break;else f=f+1|0}}if((pa|0)>=-1){q=k[w>>2]|0;m=k[x>>2]|0;n=(m|0)==1;p=m<<1;j=A+z+y|0;f=-1;while(1){g=f-(k[B>>2]|0)+q|0;h=g>>>0<m>>>0;if(h|n)g=h?g:0;else do g=(g|0)<0?0-g|0:-2-g+p|0;while(g>>>0>=m>>>0);k[ia+(f<<2)>>2]=g-q;if((f|0)==(j|0))break;else f=f+1|0}}f=qa<<2;ma=Ba+8|0;k[Ba>>2]=ma;na=Ba+4|0;k[na>>2]=264;if(f>>>0>264){h=f>>>0>1073741823?-1:f<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[Ba>>2]=g}else g=ma;k[na>>2]=f;ja=za+4|0;k[ja>>2]=2;la=za+8|0;k[la>>2]=1;k[za+12>>2]=qa;fa=za+16|0;k[fa>>2]=g;k[za+20>>2]=g;h=za+24|0;ga=za+40|0;ka=h+8|0;k[ka>>2]=0;k[ka+4>>2]=0;k[ga>>2]=la;la=za+48|0;ka=za+44|0;k[ka>>2]=la;u=(qa|0)!=0;k[za>>2]=1124024325;k[la>>2]=f;k[za+52>>2]=4;ca=g+(qa<<2)|0;k[za+28>>2]=ca;k[h>>2]=ca+(0-f)+f;h=g+(qa<<2)|0;k[xa>>2]=1124007941;ca=xa+4|0;k[ca>>2]=2;p=xa+8|0;k[p>>2]=1;j=xa+12|0;k[j>>2]=qa;$=xa+16|0;k[$>>2]=h;n=xa+20|0;k[n>>2]=h;q=xa+24|0;t=xa+28|0;ba=xa+40|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;k[ba>>2]=p;ea=xa+48|0;da=xa+44|0;k[da>>2]=ea;k[xa+52>>2]=0;k[ea>>2]=0;if(u&(h|0)==0){k[ua>>2]=0;h=ua+4|0;k[h>>2]=0;f=ZT(36)|0;k[f>>2]=1;U=f+4|0;k[ua>>2]=U;k[h>>2]=28;i[f+32>>0]=0;M=390609;V=U+28|0;do{i[U>>0]=i[M>>0]|0;U=U+1|0;M=M+1|0}while((U|0)<(V|0));Y8(-215,ua,390638,390642,410);k[h>>2]=0;k[ua>>2]=0;_=k[f>>2]|0;k[f>>2]=_+-1;if((_|0)==1)ggb(k[f+-4>>2]|0);f=k[j>>2]|0;j=k[xa>>2]|0;m=k[da>>2]|0;h=k[n>>2]|0}else{f=qa;j=1124007941;m=ea}T=f<<2;k[xa>>2]=j|16384;k[m>>2]=T;k[m+4>>2]=4;h=h+(aa(k[p>>2]|0,T)|0)|0;k[t>>2]=h;k[q>>2]=h+(0-T)+T;T=qa<<1;h=g+(T<<2)|0;k[wa>>2]=1124007941;Y=wa+4|0;k[Y>>2]=2;p=wa+8|0;k[p>>2]=1;j=wa+12|0;k[j>>2]=qa;W=wa+16|0;k[W>>2]=h;n=wa+20|0;k[n>>2]=h;q=wa+24|0;t=wa+28|0;X=wa+40|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;k[X>>2]=p;_=wa+48|0;Z=wa+44|0;k[Z>>2]=_;k[wa+52>>2]=0;k[_>>2]=0;if(u&(h|0)==0){k[ua>>2]=0;h=ua+4|0;k[h>>2]=0;f=ZT(36)|0;k[f>>2]=1;U=f+4|0;k[ua>>2]=U;k[h>>2]=28;i[f+32>>0]=0;M=390609;V=U+28|0;do{i[U>>0]=i[M>>0]|0;U=U+1|0;M=M+1|0}while((U|0)<(V|0));Y8(-215,ua,390638,390642,410);k[h>>2]=0;k[ua>>2]=0;V=k[f>>2]|0;k[f>>2]=V+-1;if((V|0)==1)ggb(k[f+-4>>2]|0);f=k[j>>2]|0;j=k[wa>>2]|0;m=k[Z>>2]|0;h=k[n>>2]|0}else{f=qa;j=1124007941;m=_}L=f<<2;k[wa>>2]=j|16384;k[m>>2]=L;k[m+4>>2]=4;h=h+(aa(k[p>>2]|0,L)|0)|0;k[t>>2]=h;k[q>>2]=h+(0-L)+L;L=qa*3|0;h=g+(L<<2)|0;k[va>>2]=1124007941;P=va+4|0;k[P>>2]=2;p=va+8|0;k[p>>2]=1;j=va+12|0;k[j>>2]=qa;N=va+16|0;k[N>>2]=h;n=va+20|0;k[n>>2]=h;q=va+24|0;t=va+28|0;O=va+40|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;k[O>>2]=p;S=va+48|0;R=va+44|0;k[R>>2]=S;k[va+52>>2]=0;k[S>>2]=0;if(u&(h|0)==0){k[ua>>2]=0;h=ua+4|0;k[h>>2]=0;f=ZT(36)|0;k[f>>2]=1;U=f+4|0;k[ua>>2]=U;k[h>>2]=28;i[f+32>>0]=0;M=390609;V=U+28|0;do{i[U>>0]=i[M>>0]|0;U=U+1|0;M=M+1|0}while((U|0)<(V|0));Y8(-215,ua,390638,390642,410);k[h>>2]=0;k[ua>>2]=0;V=k[f>>2]|0;k[f>>2]=V+-1;if((V|0)==1)ggb(k[f+-4>>2]|0);f=k[j>>2]|0;j=k[va>>2]|0;m=k[R>>2]|0;h=k[n>>2]|0}else{f=qa;j=1124007941;m=S}V=f<<2;k[va>>2]=j|16384;k[m>>2]=V;k[m+4>>2]=4;U=h+(aa(k[p>>2]|0,V)|0)|0;k[t>>2]=U;k[q>>2]=U+(0-V)+V;if((D|0)==2&(qa|0)>-2){f=qa+1|0;h=0;while(1){V=C+(h<<2)|0;k[V>>2]=(k[V>>2]|0)*3;if((h|0)==(f|0))break;else h=h+1|0}}K=a+36|0;s=+(k[K>>2]|0);if(!(i[a+144>>0]|0))s=s/3.141592653589793;else s=s/6.283185307179586;if((pa|0)>0){I=b+16|0;J=b+44|0;G=b+48|0;H=c+16|0;E=c+44|0;F=d+16|0;d=d+44|0;t=(D|0)==0;u=ua+8|0;v=ua+12|0;w=ua+4|0;x=ra+8|0;e=ra+12|0;y=ra+4|0;z=sa+4|0;A=z+4|0;B=ta+4|0;C=B+4|0;a=(qa|0)>0;b=ua+4|0;q=0;do{c=k[I>>2]|0;j=c+(aa(k[k[J>>2]>>2]|0,k[ia+(q<<2)>>2]|0)|0)|0;n=k[G>>2]|0;m=c+(aa(k[ia+(q+-1<<2)>>2]|0,n)|0)|0;D=q;q=q+1|0;n=c+(aa(k[ia+(q<<2)>>2]|0,n)|0)|0;c=(k[H>>2]|0)+(aa(k[k[E>>2]>>2]|0,D)|0)|0;D=(k[F>>2]|0)+(aa(k[k[d>>2]>>2]|0,D)|0)|0;if(t){if(a){h=0;f=k[ha>>2]|0;do{V=h;h=h+1|0;U=f;f=k[ha+(h<<2)>>2]|0;o[g+(V<<2)>>2]=+o[oa+(l[j+f>>0]<<2)>>2]-+o[oa+(l[j+(k[ha+(V+-1<<2)>>2]|0)>>0]<<2)>>2];o[g+(V+qa<<2)>>2]=+o[oa+(l[n+U>>0]<<2)>>2]-+o[oa+(l[m+U>>0]<<2)>>2]}while((h|0)!=(qa|0))}}else if(a){h=0;f=k[ha>>2]|0;do{V=h;h=h+1|0;M=f;f=k[ha+(h<<2)>>2]|0;Sa=j+f|0;p=j+(k[ha+(V+-1<<2)>>2]|0)|0;Na=+o[oa+(l[Sa+2>>0]<<2)>>2]-+o[oa+(l[p+2>>0]<<2)>>2];U=M+2|0;Ka=+o[oa+(l[n+U>>0]<<2)>>2]-+o[oa+(l[m+U>>0]<<2)>>2];Qa=Na*Na+Ka*Ka;Oa=+o[oa+(l[Sa+1>>0]<<2)>>2]-+o[oa+(l[p+1>>0]<<2)>>2];U=M+1|0;La=+o[oa+(l[n+U>>0]<<2)>>2]-+o[oa+(l[m+U>>0]<<2)>>2];Ra=Oa*Oa+La*La;U=Qa<Ra;Pa=+o[oa+(l[Sa>>0]<<2)>>2]-+o[oa+(l[p>>0]<<2)>>2];Ma=+o[oa+(l[n+M>>0]<<2)>>2]-+o[oa+(l[m+M>>0]<<2)>>2];M=(U?Ra:Qa)<Pa*Pa+Ma*Ma;o[g+(V<<2)>>2]=M?Pa:U?Oa:Na;o[g+(V+qa<<2)>>2]=M?Ma:U?La:Ka}while((h|0)!=(qa|0))}k[u>>2]=0;k[v>>2]=0;k[ua>>2]=16842752;k[w>>2]=za;k[x>>2]=0;k[e>>2]=0;k[ra>>2]=16842752;k[y>>2]=xa;Sa=A;k[Sa>>2]=0;k[Sa+4>>2]=0;k[sa>>2]=33619968;k[z>>2]=wa;Sa=C;k[Sa>>2]=0;k[Sa+4>>2]=0;k[ta>>2]=33619968;k[B>>2]=va;WZ(ua,ra,sa,ta,0);if(a){m=0;do{Qa=+o[g+(m+T<<2)>>2];Ra=s*+o[g+(m+L<<2)>>2]+-.5;h=~~Ra;h=h-(+(h|0)>Ra&1)|0;Ra=Ra-+(h|0);n=m<<1;o[c+(n<<2)>>2]=Qa*(1.0-Ra);p=n|1;o[c+(p<<2)>>2]=Qa*Ra;f=k[K>>2]|0;if((h|0)<0)j=h+f|0;else j=h-((h|0)<(f|0)?0:f)|0;if(j>>>0>=f>>>0){k[ua>>2]=0;k[b>>2]=0;h=ZT(40)|0;k[h>>2]=1;U=h+4|0;k[ua>>2]=U;k[b>>2]=32;i[h+36>>0]=0;M=383858;V=U+32|0;do{i[U>>0]=i[M>>0]|0;U=U+1|0;M=M+1|0}while((U|0)<(V|0));Y8(-215,ua,383842,383507,466);k[b>>2]=0;k[ua>>2]=0;Sa=k[h>>2]|0;k[h>>2]=Sa+-1;if((Sa|0)==1)ggb(k[h+-4>>2]|0)}i[D+n>>0]=j;Sa=j+1|0;i[D+p>>0]=(Sa|0)<(k[K>>2]|0)?Sa&255:0;m=m+1|0}while((m|0)<(qa|0))}}while((q|0)<(pa|0))}f=va+36|0;g=k[f>>2]|0;if(g|0?(ua=g+12|0,Sa=k[ua>>2]|0,k[ua>>2]=Sa+-1,(Sa|0)==1):0){h=k[f>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[va+32>>2]|0;if(g|0)break;g=B1()|0;h=k[f>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[f>>2]=0}k[f>>2]=0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[P>>2]|0)>0){h=k[O>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[P>>2]|0))}g=k[R>>2]|0;if(!((g|0)==(S|0)|(g|0)==0))ggb(k[g+-4>>2]|0);f=wa+36|0;g=k[f>>2]|0;if(g|0?(va=g+12|0,Sa=k[va>>2]|0,k[va>>2]=Sa+-1,(Sa|0)==1):0){h=k[f>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[wa+32>>2]|0;if(g|0)break;g=B1()|0;h=k[f>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[f>>2]=0}k[f>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Y>>2]|0)>0){h=k[X>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[Y>>2]|0))}g=k[Z>>2]|0;if(!((g|0)==(_|0)|(g|0)==0))ggb(k[g+-4>>2]|0);f=xa+36|0;g=k[f>>2]|0;do if(g|0){wa=g+12|0;Sa=k[wa>>2]|0;k[wa>>2]=Sa+-1;if((Sa|0)!=1)break;h=k[f>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[xa+32>>2]|0;if(g|0)break;g=B1()|0;h=k[f>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[f>>2]=0}while(0);k[f>>2]=0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[ca>>2]|0)>0){h=k[ba>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[ca>>2]|0))}g=k[da>>2]|0;if(!((g|0)==(ea|0)|(g|0)==0))ggb(k[g+-4>>2]|0);f=za+36|0;g=k[f>>2]|0;do if(g|0){xa=g+12|0;Sa=k[xa>>2]|0;k[xa>>2]=Sa+-1;if((Sa|0)!=1)break;h=k[f>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[za+32>>2]|0;if(g|0)break;g=B1()|0;h=k[f>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[f>>2]=0}while(0);k[f>>2]=0;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=0;k[fa+12>>2]=0;if((k[ja>>2]|0)>0){h=k[ga>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[ja>>2]|0))}g=k[ka>>2]|0;if(!((g|0)==(la|0)|(g|0)==0))ggb(k[g+-4>>2]|0);g=k[Ba>>2]|0;if((g|0)!=(ma|0)){if(g|0)ggb(g);k[Ba>>2]=ma;k[na>>2]=264}g=k[Ca>>2]|0;if((g|0)!=(Aa|0)){if(g|0)ggb(g);k[Ca>>2]=Aa;k[ya>>2]=264}f=Fa+36|0;g=k[f>>2]|0;do if(g|0){Ca=g+12|0;Sa=k[Ca>>2]|0;k[Ca>>2]=Sa+-1;if((Sa|0)!=1)break;h=k[f>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Fa+32>>2]|0;if(g|0)break;g=B1()|0;h=k[f>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[f>>2]=0}while(0);k[f>>2]=0;k[Da>>2]=0;k[Da+4>>2]=0;k[Da+8>>2]=0;k[Da+12>>2]=0;if((k[Ha>>2]|0)>0){h=k[Ea>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[Ha>>2]|0))}g=k[Ga>>2]|0;if((g|0)==(Ia|0)|(g|0)==0){r=Ja;return}ggb(k[g+-4>>2]|0);r=Ja;return}function YSa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0,q=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;U=r;r=r+368|0;u=U+352|0;T=U+24|0;O=U+16|0;P=U;Q=U+8|0;i=k[d>>2]|0;R=d+4|0;j=k[R>>2]|0;if((j|0)!=(i|0))k[R>>2]=j+(~((j+-8-i|0)>>>3)<<3);i=k[e>>2]|0;N=e+4|0;j=k[N>>2]|0;if((j|0)!=(i|0))k[N>>2]=j+(~((j+-8-i|0)>>>3)<<3);M=a+76|0;v=a+80|0;if((k[M>>2]|0)==(k[v>>2]|0)){r=U;return}K=k[c>>2]|0;L=k[c+4>>2]|0;n=L;q=K;if((K|0)==(L|0)){r=U;return}i=k[g>>2]|0;t=g+4|0;j=k[t>>2]|0;if(!(j|i)){i=k[a+28>>2]|0;k[g>>2]=i;j=k[a+32>>2]|0;k[t>>2]=j}m=k[a+20>>2]|0;L=(i|0)<(m|0);l=L?m:i;m=L?i:m;if((m|0)>0){i=l;l=m;while(1){i=(i|0)%(l|0)|0;if((i|0)>0){L=l;l=i;i=L}else break}}L=k[a+24>>2]|0;K=(j|0)<(L|0);i=K?L:j;j=K?j:L;if((j|0)>0)while(1){i=(i|0)%(j|0)|0;if((i|0)>0){L=j;j=i;i=L}else{i=j;break}}k[u>>2]=l;k[u+4>>2]=i;n=n-q>>3;m=k[h>>2]|0;m=l+-1+((m|0)<0?0:m)&0-l;k[h>>2]=m;L=h+4|0;J=k[L>>2]|0;i=i+-1+((J|0)<0?0:J)&0-i;k[L>>2]=i;J=b+12|0;j=k[J>>2]|0;K=b+8|0;l=k[K>>2]|0;bTa(T,a,b,h,h,1,u);if(!n)n=aa((((i<<1)+l-(k[T+48>>2]|0)|0)/(k[t>>2]|0)|0)+1|0,(((m<<1)+j-(k[T+44>>2]|0)|0)/(k[g>>2]|0)|0)+1|0)|0;G=k[T+16>>2]|0;H=aa(k[T+64>>2]|0,k[T+60>>2]|0)|0;I=k[T+76>>2]|0;i=cTa(a)|0;j=k[M>>2]|0;if((k[v>>2]|0)-j>>2>>>0>i>>>0)F=+o[j+(i<<2)>>2];else F=0.0;if(!I)i=0;else{if(I>>>0>1073741823)ad(426534,426557,304,426811);l=I<<2;j=(l|0)==0?1:l;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}zpb(i|0,0,l|0)|0}if(n|0){C=O+4|0;D=e+8|0;E=a+4|0;u=a+8|0;v=(H|0)>0;a=Q+4|0;w=I+-4|0;x=(I|0)<4;y=d+8|0;z=I&-4;A=(I|0)>0;B=(z|0)<(I|0);g=0;do{b=k[c>>2]|0;t=k[b+(g<<3)>>2]|0;k[O>>2]=t;b=k[b+(g<<3)+4>>2]|0;k[C>>2]=b;q=k[h>>2]|0;if((((t|0)>=(0-q|0)?(t|0)<=((k[J>>2]|0)+q-(k[E>>2]|0)|0):0)?(S=k[L>>2]|0,(b|0)>=(0-S|0)):0)?(b|0)<=((k[K>>2]|0)+S-(k[u>>2]|0)|0):0){p[P>>3]=F;j=k[M>>2]|0;a:do if(v){if(x){l=0;s=F;while(1){q=(k[G+(l*12|0)+8>>2]|0)+b|0;k[Q>>2]=(k[G+(l*12|0)+4>>2]|0)+t;k[a>>2]=q;q=dTa(T,Q,i)|0;if(A){m=0;do{s=s+ +o[q+(m<<2)>>2]*+o[j+(m<<2)>>2];m=m+1|0}while((m|0)!=(I|0));p[P>>3]=s}l=l+1|0;if((l|0)>=(H|0))break a;j=j+(I<<2)|0}}else{l=0;s=F}while(1){q=(k[G+(l*12|0)+8>>2]|0)+b|0;k[Q>>2]=(k[G+(l*12|0)+4>>2]|0)+t;k[a>>2]=q;q=dTa(T,Q,i)|0;m=0;do{X=m|1;W=m|2;V=m|3;s=s+(+o[q+(m<<2)>>2]*+o[j+(m<<2)>>2]+ +o[q+(X<<2)>>2]*+o[j+(X<<2)>>2]+ +o[q+(W<<2)>>2]*+o[j+(W<<2)>>2]+ +o[q+(V<<2)>>2]*+o[j+(V<<2)>>2]);m=m+4|0}while((m|0)<=(w|0));p[P>>3]=s;if(B){m=z;do{s=s+ +o[q+(m<<2)>>2]*+o[j+(m<<2)>>2];m=m+1|0}while((m|0)!=(I|0));p[P>>3]=s}l=l+1|0;if((l|0)>=(H|0))break a;j=j+(I<<2)|0}}else s=F;while(0);j=k[N>>2]|0;if((j|0)==(k[D>>2]|0))Koa(e,P);else{p[j>>3]=s;k[N>>2]=j+8}do if(s>=f){j=k[R>>2]|0;if((j|0)==(k[y>>2]|0)){Efa(d,O);break}else{k[j>>2]=t;k[j+4>>2]=b;k[R>>2]=j+8;break}}while(0)}else{p[P>>3]=-10.0;j=k[N>>2]|0;if((j|0)==(k[D>>2]|0))Koa(e,P);else{p[j>>3]=-10.0;k[N>>2]=j+8}}g=g+1|0}while(g>>>0<n>>>0)}if(i|0)ggb(i);GSa(T);r=U;return}function ZSa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+128|0;v=y+108|0;w=y+104|0;l=y+96|0;q=y;k[v>>2]=0;x=v+4|0;k[x>>2]=0;k[v+8>>2]=0;m9(w);j=(k[d+4>>2]|0)-(k[d>>2]|0)>>5;k[l>>2]=0;k[l+4>>2]=j;k[q>>2]=95680;j=q+8|0;k[j>>2]=1124007936;s=q+12|0;g=q+16|0;n=q+48|0;h=s;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[n>>2]=g;o=q+56|0;m=q+52|0;k[m>>2]=o;k[q+60>>2]=0;k[o>>2]=0;g=q+76|0;k[g>>2]=0;i=q+80|0;k[i>>2]=0;k[q+4>>2]=a;KG(j,b)|0;p[q+64>>3]=e;k[g>>2]=8;k[i>>2]=8;k[q+72>>2]=d;k[q+84>>2]=v;k[q+88>>2]=w;jh[k[(k[q>>2]|0)+8>>2]&1023](q,l);k[q>>2]=95680;i=q+44|0;g=k[i>>2]|0;if(g|0?(d=g+12|0,l=k[d>>2]|0,k[d>>2]=l+-1,(l|0)==1):0){h=k[i>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[q+40>>2]|0;if(!g){g=B1()|0;h=k[i>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[i>>2]=0}k[i>>2]=0;q=q+24|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[s>>2]|0)>0){h=k[n>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[s>>2]|0))}g=k[m>>2]|0;if(!((g|0)==(o|0)|(g|0)==0))ggb(k[g+-4>>2]|0);i=k[x>>2]|0;g=k[v>>2]|0;h=i-g>>4;a=c+4|0;d=k[a>>2]|0;j=k[c>>2]|0;b=d-j>>4;if(h>>>0<=b>>>0){if(h>>>0<b>>>0?(t=j+(h<<4)|0,(d|0)!=(t|0)):0)k[a>>2]=d+(~((d+-16-t|0)>>>4)<<4)}else{WRa(c,h-b|0);g=k[v>>2]|0;i=k[x>>2]|0}if((g|0)!=(i|0)){h=k[c>>2]|0;while(1){k[h>>2]=k[g>>2];k[h+4>>2]=k[g+4>>2];k[h+8>>2]=k[g+8>>2];k[h+12>>2]=k[g+12>>2];g=g+16|0;if((g|0)==(i|0))break;else h=h+16|0}}QRa(c,f,.2,0,0);c=(k[w>>2]|0)+28|0;f=k[c>>2]|0;k[c>>2]=f+-1;if((f|0)==1?(u=k[w>>2]|0,u|0):0){rf(u|0)|0;ggb(u)}g=k[v>>2]|0;if(!g){r=y;return}h=k[x>>2]|0;if((h|0)!=(g|0))k[x>>2]=h+(~((h+-16-g|0)>>>4)<<4);ggb(g);r=y;return}function _Sa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=95680;d=a+44|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+40>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+24|0;c=a+12|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+48>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+52>>2]|0;if((b|0)==(a+56|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function $Sa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=95680;d=a+44|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+40>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+24|0;c=a+12|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+48>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+52>>2]|0;if((b|0)==(a+56|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function aTa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0.0,i=0,j=0,l=0,m=0,n=0.0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;ua=r;r=r+240|0;ia=ua+224|0;sa=ua+168|0;ja=ua+104|0;ka=ua+160|0;la=ua+48|0;ma=ua+40|0;na=ua+24|0;oa=ua+16|0;ga=ua+8|0;ha=ua;i=k[b>>2]|0;ba=k[b+4>>2]|0;ca=a+8|0;da=a+20|0;ea=a+72|0;n=+p[k[k[ea>>2]>>2]>>3];h=+(k[da>>2]|0)/n;e=~~h;e=(+(e|0)<h&1)+e|0;fa=a+16|0;n=+(k[fa>>2]|0)/n;f=~~n;f=(+(f|0)<n&1)+f|0;g=k[ca>>2]&4095;k[sa>>2]=1124007936;ta=sa+4|0;b=sa+8|0;qa=sa+40|0;c=ta;d=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));k[qa>>2]=b;ra=sa+48|0;pa=sa+44|0;k[pa>>2]=ra;k[sa+52>>2]=0;k[ra>>2]=0;k[ia>>2]=f;k[ia+4>>2]=e;G1(sa,2,ia,g);k[ia>>2]=0;aa=ia+4|0;k[aa>>2]=0;k[ia+8>>2]=0;if((i|0)<(ba|0)){D=ka+4|0;E=sa+16|0;F=a+48|0;G=ma+4|0;H=a+24|0;I=a+56|0;J=la+36|0;K=la+16|0;L=la+4|0;M=la+40|0;N=la+44|0;O=la+48|0;P=a+4|0;Q=a+64|0;R=ga+4|0;S=a+76|0;T=ha+4|0;U=a+80|0;V=a+88|0;W=ja+36|0;X=ja+16|0;Y=ja+4|0;Z=ja+40|0;_=ja+44|0;$=ja+48|0;o=a+84|0;q=la+4|0;s=la+8|0;t=la+12|0;v=la+8|0;w=la+12|0;x=la+4|0;y=na+4|0;z=y+4|0;A=oa+4|0;B=la+32|0;C=ja+32|0;do{n=+p[(k[k[ea>>2]>>2]|0)+(i<<5)>>3];h=+(k[da>>2]|0)/n;p[u>>3]=h;b=k[u+4>>2]|0;m=b&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}c=~~h;h=+(k[fa>>2]|0)/n;p[u>>3]=h;b=k[u+4>>2]|0;m=b&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;k[ka>>2]=c;k[D>>2]=b;YN(ja,ka,k[ca>>2]&4095,k[E>>2]|0,0);m=k[F>>2]|0;if((b|0)==(k[m>>2]|0)?(c|0)==(k[m+4>>2]|0):0){k[ma>>2]=c;k[G>>2]=b;YN(la,ma,k[ca>>2]&4095,k[H>>2]|0,k[I>>2]|0);KG(ja,la)|0;b=k[J>>2]|0;if(b|0?(l=b+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){c=k[J>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[B>>2]|0;if(!b){b=B1()|0;c=k[J>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[J>>2]=0}k[J>>2]=0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[L>>2]|0)>0){c=k[M>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[L>>2]|0))}b=k[N>>2]|0;if(!((b|0)==(O|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{k[v>>2]=0;k[w>>2]=0;k[la>>2]=16842752;k[x>>2]=ca;m=z;k[m>>2]=0;k[m+4>>2]=0;k[na>>2]=33619968;k[y>>2]=ja;k[oa>>2]=c;k[A>>2]=b;Rla(la,na,oa,0.0,0.0,1)}b=k[P>>2]|0;m=k[(k[b>>2]|0)+56>>2]|0;c=k[k[ea>>2]>>2]|0;h=+p[Q>>3];k[ga>>2]=0;k[R>>2]=0;k[ha>>2]=k[S>>2];k[T>>2]=k[U>>2];Bh[m&3](b,ja,c+(i<<5)+8|0,ia,c+(i<<5)+20|0,h,ga,ha);c=k[P>>2]|0;h=n*+(k[c+4>>2]|0);p[u>>3]=h;b=k[u+4>>2]|0;m=b&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}m=~~h;h=n*+(k[c+8>>2]|0);p[u>>3]=h;b=k[u+4>>2]|0;l=b&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}l=~~h;mpb(k[k[V>>2]>>2]|0)|0;c=k[aa>>2]|0;b=k[ia>>2]|0;if((c|0)!=(b|0)){j=0;do{e=b;a=k[o>>2]|0;h=n*+(k[e+(j<<3)>>2]|0);p[u>>3]=h;d=k[u+4>>2]|0;g=d&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){d=(d|0)<0;h=d?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=d?-0.0:0.0}g=~~h;h=n*+(k[e+(j<<3)+4>>2]|0);p[u>>3]=h;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;h=d?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=d?-0.0:0.0}d=~~h;k[la>>2]=g;k[q>>2]=d;k[s>>2]=m;k[t>>2]=l;e=a+4|0;f=k[e>>2]|0;if((f|0)==(k[a+8>>2]|0)){SRa(a,la);b=k[ia>>2]|0;c=k[aa>>2]|0}else{k[f>>2]=g;k[f+4>>2]=d;k[f+8>>2]=m;k[f+12>>2]=l;k[e>>2]=f+16}j=j+1|0}while(j>>>0<c-b>>3>>>0)}lpb(k[k[V>>2]>>2]|0)|0;b=k[W>>2]|0;if(b|0?(l=b+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){c=k[W>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[C>>2]|0;if(!b){b=B1()|0;c=k[W>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[W>>2]=0}k[W>>2]=0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[Y>>2]|0)>0){c=k[Z>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Y>>2]|0))}b=k[_>>2]|0;if(!((b|0)==($|0)|(b|0)==0))ggb(k[b+-4>>2]|0);i=i+1|0}while((i|0)<(ba|0));b=k[ia>>2]|0;c=b;if(b|0){d=k[aa>>2]|0;if((d|0)!=(b|0))k[aa>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(b)}}d=sa+36|0;b=k[d>>2]|0;if(b|0?(na=b+12|0,oa=k[na>>2]|0,k[na>>2]=oa+-1,(oa|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[sa+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;sa=sa+16|0;k[sa>>2]=0;k[sa+4>>2]=0;k[sa+8>>2]=0;k[sa+12>>2]=0;if((k[ta>>2]|0)>0){c=k[qa>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ta>>2]|0))}b=k[pa>>2]|0;if((b|0)==(ra|0)|(b|0)==0){r=ua;return}ggb(k[b+-4>>2]|0);r=ua;return}function bTa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0,n=0,o=0;k[a>>2]=95584;l=a+4|0;m=a+32|0;k[a+92>>2]=0;k[a+96>>2]=0;h=a+100|0;i=a+108|0;j=a+140|0;n=a+104|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;k[l+16>>2]=0;k[l+20>>2]=0;n=m;o=n+44|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[j>>2]=i;i=a+148|0;k[a+144>>2]=i;k[a+152>>2]=0;k[i>>2]=0;k[h>>2]=1124007941;h=a+156|0;i=a+164|0;j=a+196|0;n=a+160|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[j>>2]=i;i=a+204|0;k[a+200>>2]=i;k[a+208>>2]=0;k[i>>2]=0;k[h>>2]=1124007936;k[a+212>>2]=1124007936;h=a+220|0;i=a+252|0;n=a+216|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[i>>2]=h;h=a+260|0;k[a+256>>2]=h;k[a+264>>2]=0;k[h>>2]=0;k[a+268>>2]=1124007936;h=a+276|0;i=a+308|0;n=a+272|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[i>>2]=h;o=a+316|0;k[a+312>>2]=o;k[a+320>>2]=0;k[o>>2]=0;ISa(a,b,c,d,e,f,g);return}function cTa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+16|0;n=q;o=a+12|0;b=k[o>>2]|0;p=a+28|0;if(!(((b|0)%(k[p>>2]|0)|0|0)==0?((k[a+16>>2]|0)%(k[a+32>>2]|0)|0|0)==0:0)){b=n+4|0;c=ZT(88)|0;k[c>>2]=1;d=c+4|0;k[n>>2]=d;k[b>>2]=80;i[c+84>>0]=0;e=383574;f=d+80|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,n,383655,383507,90);k[b>>2]=0;k[n>>2]=0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0);b=k[o>>2]|0}g=a+4|0;c=k[g>>2]|0;h=a+20|0;d=k[h>>2]|0;if(((c-b|0)%(d|0)|0|0)==0?(j=k[a+8>>2]|0,l=k[a+16>>2]|0,m=k[a+24>>2]|0,((j-l|0)%(m|0)|0|0)==0):0){h=b;g=c;o=d;n=m;m=a+36|0;m=k[m>>2]|0;p=k[p>>2]|0;p=(h|0)/(p|0)|0;m=aa(p,m)|0;p=a+32|0;p=k[p>>2]|0;p=(l|0)/(p|0)|0;p=aa(m,p)|0;a=g-h|0;o=(a|0)/(o|0)|0;o=o+1|0;o=aa(p,o)|0;p=j-l|0;p=(p|0)/(n|0)|0;p=p+1|0;p=aa(o,p)|0;r=q;return p|0}b=n+4|0;c=ZT(128)|0;k[c>>2]=1;d=c+4|0;k[n>>2]=d;k[b>>2]=123;i[c+127>>0]=0;e=383673;f=d+123|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,n,383655,383507,92);k[b>>2]=0;k[n>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)==1)ggb(k[c+-4>>2]|0);j=k[o>>2]|0;m=k[a+16>>2]|0;g=k[g>>2]|0;o=k[h>>2]|0;l=k[a+8>>2]|0;n=k[a+24>>2]|0;h=a+36|0;h=k[h>>2]|0;p=k[p>>2]|0;p=(j|0)/(p|0)|0;h=aa(p,h)|0;p=a+32|0;p=k[p>>2]|0;p=(m|0)/(p|0)|0;p=aa(h,p)|0;a=g-j|0;o=(a|0)/(o|0)|0;o=o+1|0;o=aa(p,o)|0;p=l-m|0;p=(p|0)/(n|0)|0;p=p+1|0;p=aa(o,p)|0;r=q;return p|0}function dTa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,p=0,q=0,s=0.0,t=0.0,u=0,v=0.0,w=0.0;q=r;r=r+96|0;j=q;m=q+88|0;n=q+32|0;f=k[a+96>>2]|0;d=(k[b>>2]|0)+(k[a+92>>2]|0)|0;k[b>>2]=d;p=b+4|0;f=(k[p>>2]|0)+f|0;k[p>>2]=f;do if(i[a+28>>0]|0){h=a+52|0;c=k[h>>2]|0;if(!(((d|0)%(c|0)|0|0)==0?(e=k[a+56>>2]|0,((f|0)%(e|0)|0|0)==0):0)){c=j+4|0;d=ZT(68)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=63;i[d+67>>0]=0;f=383434;g=e+63|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,j,383498,383507,776);k[c>>2]=0;k[j>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0);c=k[h>>2]|0;d=k[b>>2]|0;e=k[a+56>>2]|0;f=k[p>>2]|0}h=(d|0)/(c|0)|0;g=((f|0)/(e|0)|0|0)%(k[a+108>>2]|0)|0;c=a+32|0;if((f|0)!=(k[(k[c>>2]|0)+(g<<2)>>2]|0)){k[j>>2]=g;k[j+4>>2]=g+1;k[m>>2]=-2147483648;k[m+4>>2]=2147483647;H1(n,a+156|0,j,m);k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;k[j+20>>2]=0;k[j+24>>2]=0;k[j+28>>2]=0;oY(n,j);k[(k[c>>2]|0)+(g<<2)>>2]=k[p>>2];e=n+36|0;c=k[e>>2]|0;if(c|0?(j=c+12|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[n+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;m=n+16|0;d=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[d>>2]|0)>0){e=k[n+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[n+44>>2]|0;if(!((c|0)==(n+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}e=a+76|0;d=aa(k[e>>2]|0,h)|0;d=(k[a+116>>2]|0)+(aa(k[k[a+144>>2]>>2]|0,g)|0)+(d<<2)|0;c=(k[a+172>>2]|0)+(aa(k[k[a+200>>2]>>2]|0,g)|0)+h|0;if(!(i[c>>0]|0)){i[c>>0]=1;m=d;f=k[p>>2]|0;d=k[b>>2]|0;break}else{a=d;r=q;return a|0}}else{m=c;e=a+76|0}while(0);c=k[a+80>>2]|0;g=k[a+84>>2]|0;j=k[a+88>>2]|0;b=d<<1;h=(k[a+228>>2]|0)+(aa(k[k[a+256>>2]>>2]|0,f)|0)+(b<<2)|0;f=(k[a+284>>2]|0)+(aa(k[k[a+312>>2]>>2]|0,f)|0)+b|0;zpb(m|0,0,k[e>>2]<<2|0)|0;e=k[a+4>>2]|0;if((c|0)>0){d=0;do{n=h+(k[e+(d*44|0)>>2]<<2)|0;t=+o[e+(d*44|0)+40>>2]*+o[e+(d*44|0)+24>>2];b=f+(k[e+(d*44|0)+4>>2]|0)|0;u=m+(k[e+(d*44|0)+8>>2]<<2)|0;p=u+(l[b>>0]<<2)|0;b=u+(l[b+1>>0]<<2)|0;s=+o[b>>2]+t*+o[n+4>>2];o[p>>2]=+o[p>>2]+t*+o[n>>2];o[b>>2]=s;d=d+1|0}while((d|0)!=(c|0))}else c=0;if((c|0)<(g|0)){do{u=h+(k[e+(c*44|0)>>2]<<2)|0;v=+o[u>>2];t=+o[u+4>>2];u=f+(k[e+(c*44|0)+4>>2]|0)|0;b=l[u>>0]|0;u=l[u+1>>0]|0;p=m+(k[e+(c*44|0)+8>>2]<<2)|0;n=e+(c*44|0)+40|0;w=+o[n>>2]*+o[e+(c*44|0)+24>>2];d=p+(b<<2)|0;p=p+(u<<2)|0;s=+o[p>>2]+t*w;o[d>>2]=+o[d>>2]+v*w;o[p>>2]=s;p=m+(k[e+(c*44|0)+12>>2]<<2)|0;s=+o[n>>2]*+o[e+(c*44|0)+28>>2];b=p+(b<<2)|0;u=p+(u<<2)|0;t=+o[u>>2]+t*s;o[b>>2]=+o[b>>2]+v*s;o[u>>2]=t;c=c+1|0}while((c|0)!=(g|0));c=g}if((c|0)<(j|0))do{u=h+(k[e+(c*44|0)>>2]<<2)|0;t=+o[u>>2];w=+o[u+4>>2];u=f+(k[e+(c*44|0)+4>>2]|0)|0;b=l[u>>0]|0;u=l[u+1>>0]|0;p=m+(k[e+(c*44|0)+8>>2]<<2)|0;n=e+(c*44|0)+40|0;s=+o[n>>2]*+o[e+(c*44|0)+24>>2];g=p+(b<<2)|0;p=p+(u<<2)|0;v=+o[p>>2]+w*s;o[g>>2]=+o[g>>2]+t*s;o[p>>2]=v;p=m+(k[e+(c*44|0)+12>>2]<<2)|0;v=+o[n>>2]*+o[e+(c*44|0)+28>>2];g=p+(b<<2)|0;p=p+(u<<2)|0;s=+o[p>>2]+w*v;o[g>>2]=+o[g>>2]+t*v;o[p>>2]=s;p=m+(k[e+(c*44|0)+16>>2]<<2)|0;s=+o[n>>2]*+o[e+(c*44|0)+32>>2];g=p+(b<<2)|0;p=p+(u<<2)|0;v=+o[p>>2]+w*s;o[g>>2]=+o[g>>2]+t*s;o[p>>2]=v;p=m+(k[e+(c*44|0)+20>>2]<<2)|0;v=+o[n>>2]*+o[e+(c*44|0)+36>>2];b=p+(b<<2)|0;u=p+(u<<2)|0;w=+o[u>>2]+w*v;o[b>>2]=+o[b>>2]+t*v;o[u>>2]=w;c=c+1|0}while((c|0)!=(j|0));jh[k[(k[a>>2]|0)+12>>2]&1023](a,m);u=m;r=q;return u|0}function eTa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=95700;d=a+44|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+40>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+24|0;c=a+12|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+48>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+52>>2]|0;if((b|0)==(a+56|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function fTa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=95700;d=a+44|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+40>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+24|0;c=a+12|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+48>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+52>>2]|0;if((b|0)==(a+56|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function gTa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0,i=0.0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;Ba=r;r=r+272|0;va=Ba+248|0;za=Ba+192|0;pa=Ba+176|0;qa=Ba;ra=Ba+112|0;sa=Ba+168|0;ta=Ba+56|0;ua=Ba+48|0;la=Ba+32|0;ma=Ba+24|0;na=Ba+16|0;oa=Ba+8|0;j=k[b>>2]|0;ha=k[b+4>>2]|0;do if((j|0)<=0)if((ha|0)>1){e=+p[(k[a+88>>2]|0)+(j+1<<3)>>3];break}else{Aa=k[a+20>>2]|0;ya=k[a+16>>2]|0;e=+(((Aa|0)<(ya|0)?ya:Aa)|0);break}else e=+p[(k[a+88>>2]|0)+(j<<3)>>3];while(0);ia=a+8|0;ja=a+20|0;i=+(k[ja>>2]|0)/e;h=~~i;h=(+(h|0)<i&1)+h|0;ka=a+16|0;i=+(k[ka>>2]|0)/e;f=~~i;f=(+(f|0)<i&1)+f|0;g=k[ia>>2]&4095;k[za>>2]=1124007936;Aa=za+4|0;b=za+8|0;xa=za+40|0;c=Aa;d=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));k[xa>>2]=b;ya=za+48|0;wa=za+44|0;k[wa>>2]=ya;k[za+52>>2]=0;k[ya>>2]=0;k[va>>2]=f;k[va+4>>2]=h;G1(za,2,va,g);k[va>>2]=0;ga=va+4|0;k[ga>>2]=0;k[va+8>>2]=0;k[pa>>2]=0;fa=pa+4|0;k[fa>>2]=0;k[pa+8>>2]=0;if((j|0)<(ha|0)){C=a+88|0;D=sa+4|0;E=za+16|0;F=a+48|0;G=ua+4|0;H=a+24|0;I=a+56|0;J=ta+36|0;K=ta+16|0;L=ta+4|0;M=ta+40|0;N=ta+44|0;O=ta+48|0;P=a+4|0;Q=a+64|0;R=a+72|0;S=na+4|0;T=a+76|0;U=a+80|0;V=oa+4|0;W=a+84|0;X=ta+4|0;Y=ta+8|0;Z=a+104|0;_=a+96|0;$=ra+36|0;aa=ra+16|0;ba=ra+4|0;ca=ra+40|0;da=ra+44|0;ea=ra+48|0;y=a+92|0;z=ta+4|0;A=ta+8|0;B=ta+12|0;m=a+100|0;n=ta+8|0;o=ta+12|0;q=ta+4|0;s=la+4|0;t=s+4|0;v=ma+4|0;w=ta+32|0;x=ra+32|0;do{i=+p[(k[C>>2]|0)+(j<<3)>>3];p[qa>>3]=i;e=+(k[ja>>2]|0)/i;p[u>>3]=e;b=k[u+4>>2]|0;l=b&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){b=(b|0)<0;e=b?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=b?-0.0:0.0}c=~~e;e=+(k[ka>>2]|0)/i;p[u>>3]=e;b=k[u+4>>2]|0;l=b&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){b=(b|0)<0;e=b?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=b?-0.0:0.0}b=~~e;k[sa>>2]=c;k[D>>2]=b;YN(ra,sa,k[ia>>2]&4095,k[E>>2]|0,0);l=k[F>>2]|0;if((b|0)==(k[l>>2]|0)?(c|0)==(k[l+4>>2]|0):0){k[ua>>2]=c;k[G>>2]=b;YN(ta,ua,k[ia>>2]&4095,k[H>>2]|0,k[I>>2]|0);KG(ra,ta)|0;b=k[J>>2]|0;if(b|0?(a=b+12|0,l=k[a>>2]|0,k[a>>2]=l+-1,(l|0)==1):0){c=k[J>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[w>>2]|0;if(!b){b=B1()|0;c=k[J>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[J>>2]=0}k[J>>2]=0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[L>>2]|0)>0){c=k[M>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[L>>2]|0))}b=k[N>>2]|0;if(!((b|0)==(O|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{k[n>>2]=0;k[o>>2]=0;k[ta>>2]=16842752;k[q>>2]=ia;l=t;k[l>>2]=0;k[l+4>>2]=0;k[la>>2]=33619968;k[s>>2]=ra;k[ma>>2]=c;k[v>>2]=b;Rla(ta,la,ma,0.0,0.0,1)}b=k[P>>2]|0;c=k[(k[b>>2]|0)+36>>2]|0;i=+p[Q>>3];k[na>>2]=k[R>>2];k[S>>2]=k[T>>2];k[oa>>2]=k[U>>2];k[V>>2]=k[W>>2];k[ta>>2]=0;k[X>>2]=0;k[Y>>2]=0;Of[c&3](b,ra,va,pa,i,na,oa,ta);b=k[ta>>2]|0;c=b;if(b|0){d=k[X>>2]|0;if((d|0)!=(b|0))k[X>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(b)}c=k[P>>2]|0;i=+p[qa>>3];e=+(k[c+4>>2]|0)*i;p[u>>3]=e;b=k[u+4>>2]|0;l=b&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){b=(b|0)<0;e=b?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=b?-0.0:0.0}l=~~e;e=i*+(k[c+8>>2]|0);p[u>>3]=e;b=k[u+4>>2]|0;a=b&2146435072;if(!(a>>>0>1126170624|(a|0)==1126170624&0>0)){b=(b|0)<0;e=b?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=b?-0.0:0.0}a=~~e;mpb(k[k[Z>>2]>>2]|0)|0;b=k[va>>2]|0;if((k[ga>>2]|0)!=(b|0)){h=0;do{g=k[y>>2]|0;e=+(k[b+(h<<3)>>2]|0)*i;p[u>>3]=e;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;e=c?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=c?-0.0:0.0}f=~~e;e=i*+(k[b+(h<<3)+4>>2]|0);p[u>>3]=e;b=k[u+4>>2]|0;d=b&2146435072;if(!(d>>>0>1126170624|(d|0)==1126170624&0>0)){b=(b|0)<0;e=b?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=b?-0.0:0.0}b=~~e;k[ta>>2]=f;k[z>>2]=b;k[A>>2]=l;k[B>>2]=a;c=g+4|0;d=k[c>>2]|0;if((d|0)==(k[g+8>>2]|0))SRa(g,ta);else{k[d>>2]=f;k[d+4>>2]=b;k[d+8>>2]=l;k[d+12>>2]=a;k[c>>2]=d+16}b=k[m>>2]|0;do if(b|0){c=b+4|0;d=k[c>>2]|0;if((d|0)==(k[b+8>>2]|0)){Koa(b,qa);break}else{p[d>>3]=i;k[c>>2]=d+8;break}}while(0);h=h+1|0;b=k[va>>2]|0}while(h>>>0<(k[ga>>2]|0)-b>>3>>>0)}lpb(k[k[Z>>2]>>2]|0)|0;if(k[_>>2]|0?(k[pa>>2]|0)!=(k[fa>>2]|0):0){mpb(k[k[Z>>2]>>2]|0)|0;c=k[ga>>2]|0;b=k[va>>2]|0;if((c|0)!=(b|0)){a=0;do{d=k[_>>2]|0;f=(k[pa>>2]|0)+(a<<3)|0;g=d+4|0;h=k[g>>2]|0;if((h|0)==(k[d+8>>2]|0)){Koa(d,f);b=k[va>>2]|0;c=k[ga>>2]|0}else{p[h>>3]=+p[f>>3];k[g>>2]=h+8}a=a+1|0}while(a>>>0<c-b>>3>>>0)}lpb(k[k[Z>>2]>>2]|0)|0}b=k[$>>2]|0;if(b|0?(a=b+12|0,l=k[a>>2]|0,k[a>>2]=l+-1,(l|0)==1):0){c=k[$>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[x>>2]|0;if(!b){b=B1()|0;c=k[$>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[$>>2]=0}k[$>>2]=0;k[aa>>2]=0;k[aa+4>>2]=0;k[aa+8>>2]=0;k[aa+12>>2]=0;if((k[ba>>2]|0)>0){c=k[ca>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ba>>2]|0))}b=k[da>>2]|0;if(!((b|0)==(ea|0)|(b|0)==0))ggb(k[b+-4>>2]|0);j=j+1|0}while((j|0)<(ha|0));b=k[pa>>2]|0;c=b;if(b|0){d=k[fa>>2]|0;if((d|0)!=(b|0))k[fa>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(b)}}b=k[va>>2]|0;c=b;if(b|0){d=k[ga>>2]|0;if((d|0)!=(b|0))k[ga>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(b)}d=za+36|0;b=k[d>>2]|0;if(b|0?(ua=b+12|0,va=k[ua>>2]|0,k[ua>>2]=va+-1,(va|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[za+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;za=za+16|0;k[za>>2]=0;k[za+4>>2]=0;k[za+8>>2]=0;k[za+12>>2]=0;if((k[Aa>>2]|0)>0){c=k[xa>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Aa>>2]|0))}b=k[wa>>2]|0;if((b|0)==(ya|0)|(b|0)==0){r=Ba;return}ggb(k[b+-4>>2]|0);r=Ba;return}function hTa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;e=h;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=h;return a|0}f=a+32|0;if((k[f>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[e>>2]=g;k[c>>2]=30;i[d+34>>0]=0;j=401220;l=g+30|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}E6(e,a,k[a+12>>2]|0,k[a+16>>2]|0,13,0,0);p6(k[a+8>>2]|0,0,k[b>>2]|0);p6(k[a+8>>2]|0,0,k[b+4>>2]|0);F6(e);if(!(k[f>>2]&4)){r=h;return a|0}k[f>>2]=6;r=h;return a|0}function iTa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function jTa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+p[b>>3]);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function kTa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0;m=r;r=r+16|0;e=m;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=m;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,l[b>>0]|0);if(!(k[j>>2]&4)){r=m;return a|0}k[j>>2]=6;r=m;return a|0}function lTa(){var a=0,b=0;a=r;r=r+48|0;b=a;k[b>>2]=0;k[b+4>>2]=40;k[b+16>>2]=384261;k[b+12>>2]=0;k[b+8>>2]=0;k[b+20>>2]=794;k[b+24>>2]=1491;k[b+36>>2]=795;k[b+28>>2]=274;k[b+32>>2]=209;N5(b);k[206779]=k[107193];ud(1449,827116,x|0)|0;r=a;return}function mTa(a){a=a|0;var b=0,c=0;if(i[427816]|0){b=k[106956]|0;a=k[a>>2]|0;a=(b|0)==(a|0);a=a&1;return a|0}i[427816]=1;k[106956]=95608;k[106957]=64;k[106958]=128;k[106959]=16;k[106960]=16;k[106961]=8;k[106962]=8;k[106963]=8;k[106964]=8;k[106965]=9;k[106966]=1;p[53484]=-1.0;k[106970]=0;p[53486]=.2;i[427896]=1;k[106975]=0;k[106976]=0;k[106977]=0;k[106978]=1124007936;k[106979]=0;k[106980]=0;k[106981]=0;k[106982]=0;k[106983]=0;k[106984]=0;k[106985]=0;k[106986]=427920;k[106987]=427952;k[106989]=0;k[106988]=0;o[106990]=-1.0;k[106991]=64;i[427968]=0;ud(923,427824,x|0)|0;c=k[106956]|0;b=k[a>>2]|0;b=(c|0)==(b|0);b=b&1;return b|0}function nTa(a){a=a|0;var b=0;if(!a)return;b=k[a>>2]|0;if(!b)return;Uh[k[(k[b>>2]|0)+4>>2]&2047](b);k[a>>2]=0;return}function oTa(a,b){a=a|0;b=b|0;var c=0,d=0;d=r;r=r+16|0;c=d;k[c>>2]=a;k[c+4>>2]=b;while(1){a=fgb(152)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=95608;k[a+4>>2]=64;k[a+8>>2]=128;k[a+12>>2]=16;k[a+16>>2]=16;k[a+20>>2]=8;k[a+24>>2]=8;k[a+28>>2]=8;k[a+32>>2]=8;k[a+36>>2]=9;k[a+40>>2]=1;p[a+48>>3]=-1.0;k[a+56>>2]=0;p[a+64>>3]=.2;i[a+72>>0]=1;k[a+76>>2]=0;k[a+80>>2]=0;k[a+84>>2]=0;k[a+88>>2]=1124007936;b=a+92|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;k[b+24>>2]=0;k[a+120>>2]=a+96;b=a+128|0;k[a+124>>2]=b;k[a+132>>2]=0;k[b>>2]=0;o[a+136>>2]=-1.0;k[a+140>>2]=64;i[a+144>>0]=0;if(NSa(a,c)|0){c=a;r=d;return c|0}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);c=0;r=d;return c|0}function pTa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+48|0;j=m+8|0;l=m;if(!((a|0)!=0&(c|0)!=0)){r=m;return}k[j>>2]=49564;f=j+4|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[j+8>>2]=a;k[j+32>>2]=6;f=k[(k[c>>2]|0)+16>>2]|0;k[l>>2]=0;h=l+4|0;k[h>>2]=0;if(b|0){g=b;a:do if(!(g&3)){d=b;e=6}else{d=b;a=g;while(1){if(!(i[d>>0]|0)){d=a;break a}d=d+1|0;a=d;if(!(a&3)){e=6;break}}}while(0);if((e|0)==6){while(1){a=k[d>>2]|0;if(!((a&-2139062144^-2139062144)&a+-16843009))d=d+4|0;else break}if((a&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}g=d-g|0;e=ZT(g+8&-4)|0;k[e>>2]=1;e=e+4|0;k[l>>2]=e;k[h>>2]=g;i[e+g>>0]=0;upb(k[l>>2]|0,b|0,g|0)|0}Ph[f&511](c,j,l);d=k[l>>2]|0;k[h>>2]=0;k[l>>2]=0;if(d|0?(c=d+-4|0,l=k[c>>2]|0,k[c>>2]=l+-1,(l|0)==1):0)ggb(k[d+-8>>2]|0);T4(j);r=m;return}function qTa(a){a=a|0;var b=0,c=0;if(!a){a=0;return a|0}while(1){b=fgb(152)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=95608;c=b+4|0;k[b+76>>2]=0;k[b+80>>2]=0;k[b+84>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;k[c+16>>2]=0;k[c+20>>2]=0;k[c+24>>2]=0;k[c+28>>2]=0;k[b+88>>2]=1124007936;c=b+92|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;k[c+16>>2]=0;k[c+20>>2]=0;k[c+24>>2]=0;k[b+120>>2]=b+96;c=b+128|0;k[b+124>>2]=c;k[b+132>>2]=0;k[c>>2]=0;jh[k[(k[a>>2]|0)+28>>2]&1023](a,b);a=b;return a|0}function rTa(a){a=a|0;var b=0.0;b=+p[a+48>>3];if(b>=0.0)return +b;b=+((k[a+16>>2]|0)+(k[a+12>>2]|0)|0)*.125;return +b}function sTa(a){a=a|0;var b=0;b=(k[a+80>>2]|0)-(k[a+76>>2]|0)>>2;a=cTa(a)|0;if((b|0)==0|(b|0)==(a|0)){b=1;return b|0}b=(b|0)==(a+1|0);return b|0}function tTa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=0;d=a+4|0;k[d>>2]=0;k[a+8>>2]=0;while(1){b=fgb(15124)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[d>>2]=b;k[a>>2]=b;c=b+15124|0;k[a+8>>2]=c;a=95712;while(1){k[b>>2]=k[a>>2];a=a+4|0;if((a|0)==110836)break;else b=b+4|0}k[d>>2]=c;return}function uTa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=0;d=a+4|0;k[d>>2]=0;k[a+8>>2]=0;while(1){b=fgb(7924)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[d>>2]=b;k[a>>2]=b;c=b+7924|0;k[a+8>>2]=c;a=110836;while(1){k[b>>2]=k[a>>2];a=a+4|0;if((a|0)==118760)break;else b=b+4|0}k[d>>2]=c;return}function vTa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,p=0,q=0.0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;V=r;r=r+288|0;O=V+224|0;R=V+168|0;s=V+56|0;P=V+112|0;t=V;k[R>>2]=1124007936;T=R+4|0;v=R+8|0;Q=R+40|0;f=T;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[Q>>2]=v;U=R+48|0;S=R+44|0;k[S>>2]=U;k[R+52>>2]=0;k[U>>2]=0;do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[s>>2]=k[h>>2];n=s+4|0;e=h+4|0;k[n>>2]=k[e>>2];N=s+8|0;k[N>>2]=k[h+8>>2];k[s+12>>2]=k[h+12>>2];k[s+16>>2]=k[h+16>>2];k[s+20>>2]=k[h+20>>2];k[s+24>>2]=k[h+24>>2];k[s+28>>2]=k[h+28>>2];k[s+32>>2]=k[h+32>>2];p=s+36|0;f=k[h+36>>2]|0;k[p>>2]=f;g=s+40|0;k[g>>2]=N;N=s+48|0;j=s+44|0;k[j>>2]=N;k[s+52>>2]=0;k[N>>2]=0;if(f|0){N=f+12|0;k[N>>2]=(k[N>>2]|0)+1}if((k[e>>2]|0)<3){e=k[h+44>>2]|0;h=k[j>>2]|0;k[h>>2]=k[e>>2];k[h+4>>2]=k[e+4>>2];h=p;e=s;break}k[n>>2]=0;x1(s,k[e>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;i=k[g>>2]|0;g=k[h+44>>2]|0;f=k[j>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[m+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[n>>2]|0));h=p;e=s}else{h=p;e=s}}else{Q1(s,a,-1);h=s+36|0;e=s}while(0);i=(k[e>>2]&16384|0)==0;e=k[h>>2]|0;if(e|0?(M=e+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){g=s+36|0;e=k[g>>2]|0;if(e|0){f=k[e+4>>2]|0;if(!f){f=k[s+32>>2]|0;if(!f){f=B1()|0;e=k[g>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,e)}k[g>>2]=0}k[h>>2]=0;N=s+16|0;f=s+4|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[f>>2]|0)>0){g=k[s+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[s+44>>2]|0;if(!((e|0)==(s+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);if(i){do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[t>>2]=k[h>>2];n=t+4|0;e=h+4|0;k[n>>2]=k[e>>2];N=t+8|0;k[N>>2]=k[h+8>>2];k[t+12>>2]=k[h+12>>2];k[t+16>>2]=k[h+16>>2];k[t+20>>2]=k[h+20>>2];k[t+24>>2]=k[h+24>>2];k[t+28>>2]=k[h+28>>2];k[t+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[t+36>>2]=f;g=t+40|0;k[g>>2]=N;N=t+48|0;j=t+44|0;k[j>>2]=N;k[t+52>>2]=0;k[N>>2]=0;if(f|0){N=f+12|0;k[N>>2]=(k[N>>2]|0)+1}if((k[e>>2]|0)<3){M=k[h+44>>2]|0;N=k[j>>2]|0;k[N>>2]=k[M>>2];k[N+4>>2]=k[M+4>>2];break}k[n>>2]=0;x1(t,k[e>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;i=k[g>>2]|0;g=k[h+44>>2]|0;f=k[j>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[m+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[n>>2]|0))}}else Q1(t,a,-1);while(0);k[P>>2]=1124007936;m=P+4|0;e=P+8|0;i=P+40|0;f=m;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[i>>2]=e;j=P+48|0;h=P+44|0;k[h>>2]=j;k[P+52>>2]=0;k[j>>2]=0;g=O+4|0;e=g+4|0;k[e>>2]=0;k[e+4>>2]=0;k[O>>2]=33619968;k[g>>2]=P;mY(t,O);KG(R,P)|0;g=P+36|0;e=k[g>>2]|0;if(e|0?(M=e+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[P+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;N=P+16|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[m>>2]|0)>0){f=k[i>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[m>>2]|0))}e=k[h>>2]|0;if(!((e|0)==(j|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=t+36|0;e=k[g>>2]|0;if(e|0?(M=e+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[t+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;N=t+16|0;f=t+4|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[f>>2]|0)>0){g=k[t+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[t+44>>2]|0;if(!((e|0)==(t+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}else{do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[O>>2]=k[h>>2];n=O+4|0;e=h+4|0;k[n>>2]=k[e>>2];N=O+8|0;k[N>>2]=k[h+8>>2];k[O+12>>2]=k[h+12>>2];k[O+16>>2]=k[h+16>>2];k[O+20>>2]=k[h+20>>2];k[O+24>>2]=k[h+24>>2];k[O+28>>2]=k[h+28>>2];k[O+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[O+36>>2]=f;g=O+40|0;k[g>>2]=N;N=O+48|0;j=O+44|0;k[j>>2]=N;k[O+52>>2]=0;k[N>>2]=0;if(f|0){N=f+12|0;k[N>>2]=(k[N>>2]|0)+1}if((k[e>>2]|0)<3){M=k[h+44>>2]|0;N=k[j>>2]|0;k[N>>2]=k[M>>2];k[N+4>>2]=k[M+4>>2];break}k[n>>2]=0;x1(O,k[e>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;i=k[g>>2]|0;g=k[h+44>>2]|0;f=k[j>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[m+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[n>>2]|0))}}else Q1(O,a,-1);while(0);KG(R,O)|0;g=O+36|0;e=k[g>>2]|0;if(e|0?(M=e+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[O+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;N=O+16|0;f=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[f>>2]|0)>0){g=k[O+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[O+44>>2]|0;if(!((e|0)==(O+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}switch(d|0){case 0:{I=0;J=127796;K=124372;break}case 1:{I=2;J=126220;K=122796;break}case 2:{I=1;J=124836;K=121512;break}default:{I=2;J=118760;K=118760}}L=k[R+12>>2]|0;M=b+8|0;f=k[b>>2]|0;h=((k[M>>2]|0)-f|0)/28|0;N=-2-I+L|0;g=I+1|0;G=(k[v>>2]|0)-g|0;H=b+4|0;F=k[H>>2]|0;e=F;if(!((F|0)==(f|0)|(e|0)==(f|0)))k[H>>2]=e+(~(((e+-28-f|0)>>>0)/28|0)*28|0);ITa(O,k[U>>2]|0,d);a:do if((g|0)<(G|0)){t=R+16|0;v=P+4|0;d=P+8|0;w=P+12|0;x=P+16|0;y=P+20|0;z=P+24|0;A=P+4|0;B=P+8|0;C=P+12|0;D=P+16|0;E=P+20|0;F=P+24|0;e=h;f=0;b:while(1){s=aa(g,L)|0;u=+(g|0);h=I;c:while(1){i=k[t>>2]|0;a=i+s|0;j=h;d:while(1){h=j+1|0;if((j|0)>=(N|0))break c;m=a+h|0;p=l[m>>0]|0;n=p+c|0;p=p-c|0;j=k[J>>2]|0;if(j>>>0>65535)do{W=l[m+(k[O+(j>>>28<<2)>>2]|0)>>0]|0;j=k[J+(((((j&4096|0)==0?(W|0)>(n|0):(W|0)<(p|0))?j>>>16:j)&4095)<<2)>>2]|0}while(j>>>0>65535);j=(j&255)+-252|0;if(j>>>0>=4){j=98;break}switch((-13400&65535)>>>((j&65535)<<2&65535)&7){case 0:{j=h;break}case 4:{j=121;break d}case 3:{j=98;break d}case 2:{j=104;break d}default:{j=153;break b}}}e:while(1)if((j|0)==98){p=i+s|0;while(1){n=h+1|0;if((h|0)>=(N|0))break c;i=p+n|0;m=l[i>>0]|0;j=m+c|0;m=m-c|0;h=k[K>>2]|0;if(h>>>0>65535)do{W=l[i+(k[O+(h>>>28<<2)>>2]|0)>>0]|0;h=k[K+(((((h&4096|0)==0?(W|0)>(j|0):(W|0)<(m|0))?h>>>16:h)&4095)<<2)>>2]|0}while(h>>>0>65535);h=(h&255)+-252|0;if(h>>>0>=4){h=n;j=104;continue e}switch((-13400&65535)>>>((h&65535)<<2&65535)&7){case 0:{h=n;continue c}case 4:{h=n;j=121;continue e}case 2:{h=n;j=104;continue e}case 3:{h=n;break}default:{j=153;break b}}}}else if((j|0)==104){j=0;if((f|0)==(e|0)){j=105;break}else break}else if((j|0)==121){do if((f|0)==(e|0)){if(f|0){e=f<<1;wTa(b,e);break}e=k[b>>2]|0;a=e;if((((k[M>>2]|0)-e|0)/28|0)>>>0<512){m=k[H>>2]|0;j=m;while(1){i=fgb(14336)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}m=i+(((m-e|0)/28|0)*28|0)|0;p=m;n=i+14336|0;if((j|0)==(a|0))i=p;else{i=p;e=m;do{m=j;j=j+-28|0;k[e+-28>>2]=k[j>>2];k[e+-24>>2]=k[m+-24>>2];W=e+-20|0;m=m+-20|0;k[W>>2]=k[m>>2];k[W+4>>2]=k[m+4>>2];k[W+8>>2]=k[m+8>>2];k[W+12>>2]=k[m+12>>2];k[W+16>>2]=k[m+16>>2];e=i+-28|0;i=e}while((j|0)!=(a|0));e=k[b>>2]|0}k[b>>2]=i;k[H>>2]=p;k[M>>2]=n;if(e){ggb(e);e=512}else e=512}else e=512}while(0);q=+(h|0);o[P>>2]=q;o[v>>2]=u;o[d>>2]=1.0;o[w>>2]=-1.0;o[x>>2]=0.0;k[y>>2]=0;k[z>>2]=-1;i=k[H>>2]|0;if((i|0)==(k[M>>2]|0))H6(b,P);else{o[i>>2]=q;o[i+4>>2]=u;W=i+8|0;k[W>>2]=k[d>>2];k[W+4>>2]=k[d+4>>2];k[W+8>>2]=k[d+8>>2];k[W+12>>2]=k[d+12>>2];k[W+16>>2]=k[d+16>>2];k[H>>2]=(k[H>>2]|0)+28}f=f+1|0;i=k[t>>2]|0;j=98;continue}do if((j|0)==105){if(f|0){e=f<<1;wTa(b,e);break}e=k[b>>2]|0;a=e;if((((k[M>>2]|0)-e|0)/28|0)>>>0<512){m=k[H>>2]|0;j=m;while(1){i=fgb(14336)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}m=i+(((m-e|0)/28|0)*28|0)|0;p=m;n=i+14336|0;if((j|0)==(a|0))i=p;else{i=p;e=m;do{m=j;j=j+-28|0;k[e+-28>>2]=k[j>>2];k[e+-24>>2]=k[m+-24>>2];W=e+-20|0;m=m+-20|0;k[W>>2]=k[m>>2];k[W+4>>2]=k[m+4>>2];k[W+8>>2]=k[m+8>>2];k[W+12>>2]=k[m+12>>2];k[W+16>>2]=k[m+16>>2];e=i+-28|0;i=e}while((j|0)!=(a|0));e=k[b>>2]|0}k[b>>2]=i;k[H>>2]=p;k[M>>2]=n;if(e){ggb(e);e=512}else e=512}else e=512}while(0);q=+(h|0);o[P>>2]=q;o[A>>2]=u;o[B>>2]=1.0;o[C>>2]=-1.0;o[D>>2]=0.0;k[E>>2]=0;k[F>>2]=-1;i=k[H>>2]|0;if((i|0)==(k[M>>2]|0))H6(b,P);else{o[i>>2]=q;o[i+4>>2]=u;W=i+8|0;k[W>>2]=k[B>>2];k[W+4>>2]=k[B+4>>2];k[W+8>>2]=k[B+8>>2];k[W+12>>2]=k[B+12>>2];k[W+16>>2]=k[B+16>>2];k[H>>2]=(k[H>>2]|0)+28}f=f+1|0}g=g+1|0;if((g|0)>=(G|0))break a}}while(0);g=R+36|0;e=k[g>>2]|0;if(e|0?(P=e+12|0,W=k[P>>2]|0,k[P>>2]=W+-1,(W|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[R+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;W=R+16|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[T>>2]|0)>0){f=k[Q>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[T>>2]|0))}e=k[S>>2]|0;if((e|0)==(U|0)|(e|0)==0){r=V;return}ggb(k[e+-4>>2]|0);r=V;return}function wTa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+8|0;c=k[a>>2]|0;i=c;if((((k[j>>2]|0)-c|0)/28|0)>>>0>=b>>>0)return;l=a+4|0;e=k[l>>2]|0;g=(e-c|0)/28|0;if(!b)d=0;else{if(b>>>0>153391689){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}f=b*28|0;f=(f|0)==0?1:f;while(1){d=fgb(f)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}f=d+(g*28|0)|0;h=f;g=d+(b*28|0)|0;if((e|0)==(i|0))d=h;else{d=h;c=f;do{f=e;e=e+-28|0;k[c+-28>>2]=k[e>>2];k[c+-24>>2]=k[f+-24>>2];b=c+-20|0;f=f+-20|0;k[b>>2]=k[f>>2];k[b+4>>2]=k[f+4>>2];k[b+8>>2]=k[f+8>>2];k[b+12>>2]=k[f+12>>2];k[b+16>>2]=k[f+16>>2];c=d+-28|0;d=c}while((e|0)!=(i|0));c=k[a>>2]|0}k[a>>2]=d;k[l>>2]=h;k[j>>2]=g;if(!c)return;ggb(c);return}function xTa(a){a=a|0;ggb(a);return}function yTa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function zTa(a){a=a|0;return}function ATa(a){a=a|0;ggb(a);return}function BTa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,p=0.0,q=0.0,s=0.0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;T=r;r=r+336|0;L=T+16|0;K=T+272|0;D=T+208|0;E=T+192|0;S=T+136|0;R=T+80|0;N=T+32|0;t=T;do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[S>>2]=k[g>>2];n=S+4|0;d=g+4|0;k[n>>2]=k[d>>2];Q=S+8|0;k[Q>>2]=k[g+8>>2];k[S+12>>2]=k[g+12>>2];k[S+16>>2]=k[g+16>>2];k[S+20>>2]=k[g+20>>2];k[S+24>>2]=k[g+24>>2];k[S+28>>2]=k[g+28>>2];k[S+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[S+36>>2]=e;f=S+40|0;k[f>>2]=Q;Q=S+48|0;j=S+44|0;k[j>>2]=Q;k[S+52>>2]=0;k[Q>>2]=0;if(e|0){Q=e+12|0;k[Q>>2]=(k[Q>>2]|0)+1}if((k[d>>2]|0)<3){P=k[g+44>>2]|0;Q=k[j>>2]|0;k[Q>>2]=k[P>>2];k[Q+4>>2]=k[P+4>>2];break}k[n>>2]=0;x1(S,k[d>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[m+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[n>>2]|0))}}else Q1(S,d,-1);while(0);k[R>>2]=1124007936;Q=R+4|0;d=R+8|0;O=R+40|0;e=Q;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[O>>2]=d;P=R+48|0;M=R+44|0;k[M>>2]=P;k[R+52>>2]=0;k[P>>2]=0;k[N>>2]=1124007936;H=N+4|0;G=N+32|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;k[H+16>>2]=0;k[H+20>>2]=0;k[H+24>>2]=0;k[G>>2]=N+8;J=N+40|0;I=N+36|0;k[I>>2]=J;k[N+44>>2]=0;k[J>>2]=0;d=b;g=k[d>>2]|0;d=k[d+4>>2]|0;e=t;k[e>>2]=g;k[e+4>>2]=d;e=t+8|0;k[e>>2]=k[b+8>>2];f=t+12|0;k[f>>2]=k[b+12>>2];if(S1(b,-1)|0){F=(k[b>>2]&2031616|0)==655360;d=L+4|0;C=d+4|0;k[C>>2]=0;k[C+4>>2]=0;if(F){k[L>>2]=34209792;k[d>>2]=N}else{k[L>>2]=33619968;k[d>>2]=R}$aa(b,L,6,0);d=L;g=k[d>>2]|0;d=k[d+4>>2]|0;F=t;k[F>>2]=g;k[F+4>>2]=d;k[e>>2]=k[L+8>>2];k[f>>2]=k[L+12>>2]}B=k[a+4>>2]|0;C=(i[a+8>>0]|0)==0;v=k[a+12>>2]|0;k[L>>2]=0;F=L+4|0;k[F>>2]=0;k[L+8>>2]=0;switch(v|0){case 0:{vTa(t,L,B,0);break}case 1:{vTa(t,L,B,1);break}case 2:{vTa(t,L,B,2);break}case 3:{vTa(t,L,B,3);break}default:{}}do if((g&2031616|0)==65536){k[K>>2]=k[d>>2];m=K+4|0;e=d+4|0;k[m>>2]=k[e>>2];n=K+8|0;k[n>>2]=k[d+8>>2];k[K+12>>2]=k[d+12>>2];k[K+16>>2]=k[d+16>>2];k[K+20>>2]=k[d+20>>2];k[K+24>>2]=k[d+24>>2];k[K+28>>2]=k[d+28>>2];k[K+32>>2]=k[d+32>>2];f=k[d+36>>2]|0;k[K+36>>2]=f;g=K+40|0;k[g>>2]=n;n=K+48|0;h=K+44|0;k[h>>2]=n;k[K+52>>2]=0;k[n>>2]=0;if(f|0){A=f+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[e>>2]|0)<3){z=k[d+44>>2]|0;A=k[h>>2]|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];break}k[m>>2]=0;x1(K,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[d+40>>2]|0;g=k[g>>2]|0;f=k[d+44>>2]|0;e=k[h>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else{Q1(K,t,-1);n=K+48|0}while(0);ITa(D,k[n>>2]|0,v);e=k[L>>2]|0;A=e;y=k[F>>2]|0;a:do if((e|0)==(y|0))a=e;else{u=K+16|0;x=K+44|0;z=B+255|0;if(!v){v=k[u>>2]|0;b=k[k[x>>2]>>2]|0;a=e;while(1){t=v+(aa(b,~~+o[a+4>>2])|0)+~~+o[a>>2]|0;u=l[t>>0]|0;m=B;d=z;f=255;while(1){j=(d|0)/2|0;g=j+u|0;h=u-j|0;d=65574;while(1){x=l[t+(k[D+(d>>>28<<2)>>2]|0)>>0]|0;x=((d&4096|0)==0?(x|0)>(g|0):(x|0)<(h|0))?d>>>16:d;d=x&4095;if((x&4094|0)==108)break;else d=k[128776+(d<<2)>>2]|0}d=(d|0)==108;f=d?j:f;d=d?m:j;if((d|0)==(f|0)|(d|0)==(f+-1|0))break;else{m=d;d=d+f|0}}o[a+16>>2]=+(d|0);a=a+28|0;if((a|0)==(y|0)){a=y;break a}}}else t=e;while(1){switch(v|0){case 3:{b=(k[u>>2]|0)+(aa(k[k[x>>2]>>2]|0,~~+o[t+4>>2])|0)+~~+o[t>>2]|0;a=l[b>>0]|0;m=B;d=z;f=255;while(1){j=(d|0)/2|0;g=j+a|0;h=a-j|0;d=65848;while(1){U=l[b+(k[D+(d>>>28<<2)>>2]|0)>>0]|0;U=((d&4096|0)==0?(U|0)>(g|0):(U|0)<(h|0))?d>>>16:d;d=U&4095;if((U&4094|0)==684)break;else d=k[138248+(d<<2)>>2]|0}d=(d|0)==502|(d|0)==684;f=d?j:f;d=d?m:j;if((d|0)==(f|0)|(d|0)==(f+-1|0))break;else{m=d;d=d+f|0}}o[t+16>>2]=+(d|0);break}case 1:{b=(k[u>>2]|0)+(aa(k[k[x>>2]>>2]|0,~~+o[t+4>>2])|0)+~~+o[t>>2]|0;a=l[b>>0]|0;m=B;d=z;f=255;while(1){j=(d|0)/2|0;g=j+a|0;h=a-j|0;d=65717;while(1){U=l[b+(k[D+(d>>>28<<2)>>2]|0)>>0]|0;U=((d&4096|0)==0?(U|0)>(g|0):(U|0)<(h|0))?d>>>16:d;d=U&4095;if((U&4094|0)==390)break;else d=k[129216+(d<<2)>>2]|0}d=(d|0)==390;f=d?j:f;d=d?m:j;if((d|0)==(f|0)|(d|0)==(f+-1|0))break;else{m=d;d=d+f|0}}o[t+16>>2]=+(d|0);break}case 2:{b=(k[u>>2]|0)+(aa(k[k[x>>2]>>2]|0,~~+o[t+4>>2])|0)+~~+o[t>>2]|0;a=l[b>>0]|0;m=B;d=z;f=255;while(1){j=(d|0)/2|0;d=j+a|0;g=a-j|0;h=66347;do{U=l[b+(k[D+(h>>>28<<2)>>2]|0)>>0]|0;h=k[130784+(((((h&4096|0)==0?(U|0)>(d|0):(U|0)<(g|0))?h>>>16:h)&4095)<<2)>>2]|0}while(h>>>0>65535);d=(h&255|0)==254;f=d?j:f;d=d?m:j;if((d|0)==(f|0)|(d|0)==(f+-1|0))break;else{m=d;d=d+f|0}}o[t+16>>2]=+(d|0);break}default:{}}t=t+28|0;if((t|0)==(y|0)){a=y;break a}}}while(0);b:do if(C){if((L|0)!=(c|0)){m=(a-A|0)/28|0;b=c+8|0;d=k[b>>2]|0;j=k[c>>2]|0;f=j;if(m>>>0<=((d-j|0)/28|0)>>>0){b=c+4|0;d=((k[b>>2]|0)-j|0)/28|0;h=m>>>0>d>>>0;d=e+(d*28|0)|0;g=h?d:a;if((g|0)==(e|0))e=f;else{do{k[f>>2]=k[e>>2];k[f+4>>2]=k[e+4>>2];U=f+8|0;E=e+8|0;k[U>>2]=k[E>>2];k[U+4>>2]=k[E+4>>2];k[U+8>>2]=k[E+8>>2];k[U+12>>2]=k[E+12>>2];k[U+16>>2]=k[E+16>>2];e=e+28|0;f=f+28|0}while((e|0)!=(g|0));e=f}if(!h){d=k[b>>2]|0;if((d|0)==(e|0))break;k[b>>2]=d+(~(((d+-28-e|0)>>>0)/28|0)*28|0);break}if((g|0)==(a|0))break;e=k[b>>2]|0;while(1){k[e>>2]=k[d>>2];k[e+4>>2]=k[d+4>>2];U=e+8|0;E=d+8|0;k[U>>2]=k[E>>2];k[U+4>>2]=k[E+4>>2];k[U+8>>2]=k[E+8>>2];k[U+12>>2]=k[E+12>>2];k[U+16>>2]=k[E+16>>2];d=d+28|0;e=(k[b>>2]|0)+28|0;k[b>>2]=e;if((d|0)==(a|0))break b}}h=j;if(j){d=c+4|0;g=k[d>>2]|0;if((g|0)!=(f|0))k[d>>2]=g+(~(((g+-28-j|0)>>>0)/28|0)*28|0);ggb(h);k[b>>2]=0;k[d>>2]=0;k[c>>2]=0;d=0}if(m>>>0>153391689)ad(426534,426557,304,426811);U=(d|0)/28|0;g=U<<1;g=U>>>0<76695844?(g>>>0<m>>>0?m:g):153391689;if(g>>>0>153391689)bob();f=g*28|0;f=(f|0)==0?1:f;while(1){d=fgb(f)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=c+4|0;k[f>>2]=d;k[c>>2]=d;k[b>>2]=d+(g*28|0);if((e|0)!=(a|0))do{k[d>>2]=k[e>>2];k[d+4>>2]=k[e+4>>2];U=d+8|0;E=e+8|0;k[U>>2]=k[E>>2];k[U+4>>2]=k[E+4>>2];k[U+8>>2]=k[E+8>>2];k[U+12>>2]=k[E+12>>2];k[U+16>>2]=k[E+16>>2];e=e+28|0;d=(k[f>>2]|0)+28|0;k[f>>2]=d}while((e|0)!=(a|0))}}else{U=a-A|0;y=(U|0)/28|0;k[E>>2]=0;z=E+4|0;k[z>>2]=0;k[E+8>>2]=0;if(U|0){U1(E,y);d=k[E>>2]|0;zpb(d|0,-1,(y>>>0>1?y:1)<<2|0)|0;x=k[L>>2]|0;a=0;f=0;t=0;u=0;v=0;e=A;while(1){w=+o[e+4>>2];U=+((u+1|0)>>>0)<w;u=U?t:u;f=U?a:f;U=+(t>>>0)!=w;t=U?~~w>>>0:t;a=U?v:a;do if(+((u+1|0)>>>0)==w){p=+o[x+(f*28|0)>>2];s=+o[e>>2];c:do if(p<s){q=+(u>>>0);do{if(!(+o[x+(f*28|0)+4>>2]==q))break c;f=f+1|0;p=+o[x+(f*28|0)>>2]}while(p<s)}while(0);if(!((f|0)==(v|0)|p!=s)){g=f;while(1){h=d+(g<<2)|0;j=k[h>>2]|0;if((j|0)==-1)break;else g=j}if(+o[x+(v*28|0)+16>>2]<+o[x+(g*28|0)+16>>2]){k[d+(v<<2)>>2]=g;break}else{k[h>>2]=v;break}}}while(0);g=v+-1|0;do if((v|0?+o[x+(g*28|0)+4>>2]==w:0)?+o[x+(g*28|0)>>2]+1.0==+o[e>>2]:0){m=d+(v<<2)|0;b=k[m>>2]|0;while(1){h=d+(g<<2)|0;j=k[h>>2]|0;if((j|0)==-1)break;else g=j}if((b|0)==-1){if((g|0)==(v|0))break;if(+o[x+(v*28|0)+16>>2]<+o[x+(g*28|0)+16>>2]){k[m>>2]=g;break}else{k[h>>2]=v;break}}else{if((g|0)==(b|0))break;if(+o[x+(b*28|0)+16>>2]<+o[x+(g*28|0)+16>>2]){k[d+(b<<2)>>2]=g;k[m>>2]=g;break}else{k[h>>2]=b;k[m>>2]=b;break}}}while(0);v=v+1|0;if(v>>>0>=y>>>0)break;else e=e+28|0}f=c+4|0;g=c+8|0;e=0;do{do if((k[d+(e<<2)>>2]|0)==-1){h=k[L>>2]|0;j=h+(e*28|0)|0;m=k[f>>2]|0;if((m|0)==(k[g>>2]|0)){H6(c,j);break}else{k[m>>2]=k[j>>2];k[m+4>>2]=k[h+(e*28|0)+4>>2];U=m+8|0;E=h+(e*28|0)+8|0;k[U>>2]=k[E>>2];k[U+4>>2]=k[E+4>>2];k[U+8>>2]=k[E+8>>2];k[U+12>>2]=k[E+12>>2];k[U+16>>2]=k[E+16>>2];k[f>>2]=(k[f>>2]|0)+28;break}}while(0);e=e+1|0}while(e>>>0<y>>>0);e=d;if(d|0){f=k[z>>2]|0;if((f|0)!=(d|0))k[z>>2]=f+(~((f+-4-e|0)>>>2)<<2);ggb(d)}}}while(0);f=K+36|0;d=k[f>>2]|0;if(d|0?(E=d+12|0,U=k[E>>2]|0,k[E>>2]=U+-1,(U|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[K+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;U=K+16|0;e=K+4|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[e>>2]|0)>0){f=k[K+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[K+44>>2]|0;if(!((d|0)==(n|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[L>>2]|0;e=d;if(d|0){f=k[F>>2]|0;if((f|0)!=(d|0))k[F>>2]=f+(~(((f+-28-e|0)>>>0)/28|0)*28|0);ggb(d)}dXa(c,S);f=N+24|0;d=k[f>>2]|0;if(d|0?(c=d+8|0,U=k[c>>2]|0,k[c>>2]=U+-1,(U|0)==1):0){U=k[f>>2]|0;c=k[U+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,U);k[f>>2]=0}if((k[H>>2]|0)>0){e=k[G>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[H>>2]|0))}k[f>>2]=0;d=k[I>>2]|0;if(!((d|0)==(J|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=R+36|0;d=k[f>>2]|0;if(d|0?(c=d+12|0,U=k[c>>2]|0,k[c>>2]=U+-1,(U|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[R+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;U=R+16|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[Q>>2]|0)>0){e=k[O>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Q>>2]|0))}d=k[M>>2]|0;if(!((d|0)==(P|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=S+36|0;d=k[f>>2]|0;if(d|0?(R=d+12|0,U=k[R>>2]|0,k[R>>2]=U+-1,(U|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[S+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;U=S+16|0;e=S+4|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[e>>2]|0)>0){f=k[S+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[S+44>>2]|0;if((d|0)==(S+48|0)|(d|0)==0){r=T;return}ggb(k[d+-4>>2]|0);r=T;return}function CTa(a,b){a=a|0;b=b|0;k[a+4>>2]=b;return}function DTa(a){a=a|0;return k[a+4>>2]|0}function ETa(a,b){a=a|0;b=b|0;i[a+8>>0]=b&1;return}function FTa(a){a=a|0;return (i[a+8>>0]|0)!=0|0}function GTa(a,b){a=a|0;b=b|0;k[a+12>>2]=b;return}function HTa(a){a=a|0;return k[a+12>>2]|0}function ITa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;if((c|0)!=3)if((c|0)!=1)if((c|0)==2)c=128680;else c=(c|0)==0?128392:0;else c=128584;else c=128456;if(!((a|0)!=0&(c|0)!=0)){d=j+4|0;e=ZT(24)|0;k[e>>2]=1;f=e+4|0;k[j>>2]=f;k[d>>2]=16;i[e+20>>0]=0;g=386554;h=f+16|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,j,384406,384423,85);k[d>>2]=0;k[j>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0)}j=(aa(k[c+4>>2]|0,b)|0)+(k[c>>2]|0)|0;k[a>>2]=j;j=(aa(k[c+12>>2]|0,b)|0)+(k[c+8>>2]|0)|0;k[a+4>>2]=j;j=(aa(k[c+20>>2]|0,b)|0)+(k[c+16>>2]|0)|0;k[a+8>>2]=j;j=(aa(k[c+28>>2]|0,b)|0)+(k[c+24>>2]|0)|0;k[a+12>>2]=j;j=(aa(k[c+36>>2]|0,b)|0)+(k[c+32>>2]|0)|0;k[a+16>>2]=j;j=(aa(k[c+44>>2]|0,b)|0)+(k[c+40>>2]|0)|0;k[a+20>>2]=j;j=(aa(k[c+52>>2]|0,b)|0)+(k[c+48>>2]|0)|0;k[a+24>>2]=j;j=(aa(k[c+60>>2]|0,b)|0)+(k[c+56>>2]|0)|0;k[a+28>>2]=j;j=(aa(k[c+68>>2]|0,b)|0)+(k[c+64>>2]|0)|0;k[a+32>>2]=j;j=(aa(k[c+76>>2]|0,b)|0)+(k[c+72>>2]|0)|0;k[a+36>>2]=j;j=(aa(k[c+84>>2]|0,b)|0)+(k[c+80>>2]|0)|0;k[a+40>>2]=j;j=(aa(k[c+92>>2]|0,b)|0)+(k[c+88>>2]|0)|0;k[a+44>>2]=j;j=(aa(k[c+100>>2]|0,b)|0)+(k[c+96>>2]|0)|0;k[a+48>>2]=j;j=(aa(k[c+108>>2]|0,b)|0)+(k[c+104>>2]|0)|0;k[a+52>>2]=j;j=(aa(k[c+116>>2]|0,b)|0)+(k[c+112>>2]|0)|0;k[a+56>>2]=j;j=(aa(k[c+124>>2]|0,b)|0)+(k[c+120>>2]|0)|0;k[a+60>>2]=j;r=l;return}function JTa(a){a=a|0;ggb(a);return}function KTa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function LTa(a){a=a|0;return}function MTa(a){a=a|0;ggb(a);return}function NTa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;m=n;e=m+4|0;j=ZT(16)|0;k[j>>2]=1;h=j+4|0;k[m>>2]=h;k[e>>2]=10;i[j+14>>0]=0;j=384639;l=h+10|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));c=z6(b,m)|0;d=k[m>>2]|0;k[e>>2]=0;k[m>>2]=0;if(d|0?(j=d+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[d+-8>>2]|0);hUa(c,a+4|0);k[m>>2]=0;e=m+4|0;k[e>>2]=0;j=ZT(24)|0;k[j>>2]=1;h=j+4|0;k[m>>2]=h;k[e>>2]=19;i[j+23>>0]=0;j=384650;l=h+19|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));c=z6(b,m)|0;d=k[m>>2]|0;k[e>>2]=0;k[m>>2]=0;if(d|0?(j=d+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[d+-8>>2]|0);hUa(c,a+8|0);k[m>>2]=0;e=m+4|0;k[e>>2]=0;j=ZT(20)|0;k[j>>2]=1;h=j+4|0;k[m>>2]=h;k[e>>2]=15;i[j+19>>0]=0;j=384670;l=h+15|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));c=z6(b,m)|0;d=k[m>>2]|0;k[e>>2]=0;k[m>>2]=0;if(d|0?(j=d+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[d+-8>>2]|0);hUa(c,a+12|0);k[m>>2]=0;d=m+4|0;k[d>>2]=0;j=ZT(16)|0;k[j>>2]=1;h=j+4|0;k[m>>2]=h;k[d>>2]=9;i[j+13>>0]=0;j=393853;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));g=z6(b,m)|0;c=k[m>>2]|0;k[d>>2]=0;k[m>>2]=0;if(c|0?(j=c+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[c+-8>>2]|0);e=a+16|0;if(Xh[k[(k[g>>2]|0)+12>>2]&1023](g)|0){f=g+32|0;if((k[f>>2]|0)==6){c=m+4|0;d=ZT(36)|0;k[d>>2]=1;h=d+4|0;k[m>>2]=h;k[c>>2]=30;i[d+34>>0]=0;j=401220;l=h+30|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-2,m,401251,401262,1064);k[c>>2]=0;k[m>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[g+16>>2]|0))c=0;else{c=k[g+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[g+8>>2]|0,c,+o[e>>2]);if(k[f>>2]&4|0)k[f>>2]=6}l=m+4|0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[m>>2]=c;k[l>>2]=7;i[d+11>>0]=0;i[c>>0]=i[387236]|0;i[c+1>>0]=i[387237]|0;i[c+2>>0]=i[387238]|0;i[c+3>>0]=i[387239]|0;i[c+4>>0]=i[387240]|0;i[c+5>>0]=i[387241]|0;i[c+6>>0]=i[387242]|0;c=z6(b,m)|0;d=k[m>>2]|0;k[l>>2]=0;k[m>>2]=0;if(d|0?(j=d+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[d+-8>>2]|0);hUa(c,a+20|0);e=m+4|0;j=ZT(16)|0;k[j>>2]=1;h=j+4|0;k[m>>2]=h;k[e>>2]=9;i[j+13>>0]=0;j=387244;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));c=z6(b,m)|0;d=k[m>>2]|0;k[e>>2]=0;k[m>>2]=0;if(d|0?(j=d+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[d+-8>>2]|0);hUa(c,a+24|0);e=m+4|0;j=ZT(16)|0;k[j>>2]=1;h=j+4|0;k[m>>2]=h;k[e>>2]=11;i[j+15>>0]=0;j=387254;l=h+11|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));c=z6(b,m)|0;d=k[m>>2]|0;k[e>>2]=0;k[m>>2]=0;if(!d){m=a+28|0;hUa(c,m);r=n;return}b=d+-4|0;m=k[b>>2]|0;k[b>>2]=m+-1;if((m|0)!=1){m=a+28|0;hUa(c,m);r=n;return}ggb(k[d+-8>>2]|0);m=a+28|0;hUa(c,m);r=n;return}function OTa(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0;e=b+4|0;d=k6(k[b>>2]|0,k[e>>2]|0,384639)|0;a:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break a}case 2:break;default:{d=2147483647;break a}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c}while(0);k[a+4>>2]=d;d=k6(k[b>>2]|0,k[e>>2]|0,384650)|0;b:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break b}case 2:break;default:{d=2147483647;break b}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c}while(0);k[a+8>>2]=d;d=k6(k[b>>2]|0,k[e>>2]|0,384670)|0;c:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break c}case 2:break;default:{d=2147483647;break c}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c}while(0);k[a+12>>2]=d;d=k6(k[b>>2]|0,k[e>>2]|0,393853)|0;d:do if(!d)c=0.0;else switch(k[d>>2]&7){case 1:{c=+(k[d+8>>2]|0);break d}case 2:{c=+p[d+8>>3];break d}default:{c=1000000015047466219876688.0e6;break d}}while(0);o[a+16>>2]=c;d=k6(k[b>>2]|0,k[e>>2]|0,387236)|0;e:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break e}case 2:break;default:{d=2147483647;break e}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c}while(0);k[a+20>>2]=d;d=k6(k[b>>2]|0,k[e>>2]|0,387244)|0;f:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break f}case 2:break;default:{d=2147483647;break f}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c}while(0);k[a+24>>2]=d;d=k6(k[b>>2]|0,k[e>>2]|0,387254)|0;if(!d){e=0;f=a+28|0;k[f>>2]=e;return}switch(k[d>>2]&7){case 1:{e=k[d+8>>2]|0;f=a+28|0;k[f>>2]=e;return}case 2:{c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}e=~~c;f=a+28|0;k[f>>2]=e;return}default:{e=2147483647;f=a+28|0;k[f>>2]=e;return}}}function PTa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0.0,N=0,O=0,R=0,S=0,T=0.0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0.0;Gb=r;r=r+1360|0;Db=Gb+1304|0;wb=Gb+448|0;sb=Gb+1248|0;ub=Gb+1192|0;rb=Gb+224|0;tb=Gb+1136|0;t=Gb;Fb=Gb+1080|0;Eb=Gb+1024|0;s=Gb+952|0;Cb=Gb+672|0;do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[Fb>>2]=k[l>>2];q=Fb+4|0;g=l+4|0;k[q>>2]=k[g>>2];Bb=Fb+8|0;k[Bb>>2]=k[l+8>>2];k[Fb+12>>2]=k[l+12>>2];k[Fb+16>>2]=k[l+16>>2];k[Fb+20>>2]=k[l+20>>2];k[Fb+24>>2]=k[l+24>>2];k[Fb+28>>2]=k[l+28>>2];k[Fb+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[Fb+36>>2]=h;j=Fb+40|0;k[j>>2]=Bb;Bb=Fb+48|0;n=Fb+44|0;k[n>>2]=Bb;k[Fb+52>>2]=0;k[Bb>>2]=0;if(h|0){Bb=h+12|0;k[Bb>>2]=(k[Bb>>2]|0)+1}if((k[g>>2]|0)<3){Bb=k[l+44>>2]|0;g=k[n>>2]|0;k[g>>2]=k[Bb>>2];k[g+4>>2]=k[Bb+4>>2];g=Fb;break}k[q>>2]=0;x1(Fb,k[g>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[p+(g<<2)>>2];k[h+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0));g=Fb}else g=Fb}else{Q1(Fb,b,-1);g=Fb}while(0);h=k[g>>2]|0;if(h&4088){h=Db+4|0;Bb=h+4|0;k[Bb>>2]=0;k[Bb+4>>2]=0;k[Db>>2]=33619968;k[h>>2]=Fb;$aa(b,Db,6,0);h=k[g>>2]|0}k[Eb>>2]=1124007936;zb=Eb+4|0;g=Eb+8|0;yb=Eb+40|0;p=zb;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[yb>>2]=g;Bb=Eb+48|0;Ab=Eb+44|0;k[Ab>>2]=Bb;k[Eb+52>>2]=0;k[Bb>>2]=0;switch(h&7){case 5:{KG(Eb,Fb)|0;break}case 0:{xb=Db+4|0;vb=xb+4|0;k[vb>>2]=0;k[vb+4>>2]=0;k[Db>>2]=33619968;k[xb>>2]=Eb;SW(Fb,Db,5,.00392156862745098,0.0);break}case 2:{xb=Db+4|0;vb=xb+4|0;k[vb>>2]=0;k[vb+4>>2]=0;k[Db>>2]=33619968;k[xb>>2]=Eb;SW(Fb,Db,5,1.5259021896696422e-05,0.0);break}default:{}}xb=Eb+16|0;if(k[xb>>2]|0){l=k[zb>>2]|0;if((l|0)<3)g=aa(k[Eb+12>>2]|0,k[g>>2]|0)|0;else{j=k[yb>>2]|0;h=0;g=1;do{g=aa(k[j+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(l|0))}if(!g)pb=22}else pb=22;if((pb|0)==22){k[Db>>2]=0;g=Db+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;p=h+4|0;k[Db>>2]=p;k[g>>2]=17;i[h+21>>0]=0;m=387036;nb=p+17|0;do{i[p>>0]=i[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(nb|0));Y8(-215,Db,390333,384569,182);k[g>>2]=0;k[Db>>2]=0;vb=k[h>>2]|0;k[h>>2]=vb+-1;if((vb|0)==1)ggb(k[h+-4>>2]|0)}o[s+16>>2]=1.600000023841858;o[s+20>>2]=1.5;o[s+24>>2]=1.0;o[s+36>>2]=9.999999747378752e-06;k[s+52>>2]=10;o[s+56>>2]=1.0000000474974513e-03;o[s+60>>2]=.699999988079071;k[s+64>>2]=300;k[s+40>>2]=k[a+4>>2];k[s+48>>2]=k[a+8>>2];k[s+44>>2]=k[a+12>>2];k[s+8>>2]=k[Fb+12>>2];k[s+12>>2]=k[Fb+8>>2];k[s+32>>2]=k[a+16>>2];k[s>>2]=k[a+20>>2];k[s+4>>2]=k[a+24>>2];k[s+28>>2]=k[a+28>>2];rWa(Cb,s);vb=Cb+68|0;qb=Cb+72|0;g=k[vb>>2]|0;if((k[qb>>2]|0)==(g|0)){k[Db>>2]=0;g=Db+4|0;k[g>>2]=0;h=ZT(28)|0;k[h>>2]=1;p=h+4|0;k[Db>>2]=p;k[g>>2]=21;i[h+25>>0]=0;m=387809;nb=p+21|0;do{i[p>>0]=i[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(nb|0));Y8(-215,Db,387831,387323,102);k[g>>2]=0;k[Db>>2]=0;nb=k[h>>2]|0;k[h>>2]=nb+-1;if((nb|0)==1)ggb(k[h+-4>>2]|0);cb=vb;g=k[vb>>2]|0}else cb=vb;l=Db+4|0;j=l+4|0;k[j>>2]=0;k[j+4>>2]=0;k[Db>>2]=33619968;k[l>>2]=g+280;mY(Eb,Db);g=(k[cb>>2]|0)+280|0;T=+o[Cb+16>>2];l=~~+$(+(((T+-.800000011920929)/.30000001192092896+1.0)*2.0));l=(l&1^1)+l|0;k[Db+8>>2]=0;k[Db+12>>2]=0;k[Db>>2]=16842752;k[Db+4>>2]=g;j=wb+4|0;h=j+4|0;k[h>>2]=0;k[h+4>>2]=0;k[wb>>2]=33619968;k[j>>2]=g;k[sb>>2]=l;k[sb+4>>2]=l;uua(Db,wb,sb,T,T,1);l=k[cb>>2]|0;j=Db+4|0;g=j+4|0;k[g>>2]=0;k[g+4>>2]=0;k[Db>>2]=33619968;k[j>>2]=l+336;mY(l+280|0,Db);l=k[cb>>2]|0;j=k[l+288>>2]|0;l=k[l+292>>2]|0;k[rb>>2]=0;k[rb+4>>2]=0;k[rb+8>>2]=1124007936;g=rb+16|0;h=rb+48|0;p=rb+12|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;g=rb+56|0;k[rb+52>>2]=g;k[rb+60>>2]=0;k[g>>2]=0;k[rb+64>>2]=1124007936;g=rb+72|0;h=rb+104|0;p=rb+68|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;g=rb+112|0;k[rb+108>>2]=g;k[rb+116>>2]=0;k[g>>2]=0;k[rb+120>>2]=1124007936;g=rb+128|0;h=rb+160|0;p=rb+124|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;p=rb+168|0;k[rb+164>>2]=p;nb=p+56|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[Db>>2]=l;k[Db+4>>2]=j;j1(rb,48,Db,5);k[ub>>2]=1124007936;fb=ub+4|0;g=ub+8|0;db=ub+40|0;p=fb;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[db>>2]=g;gb=ub+48|0;eb=ub+44|0;k[eb>>2]=gb;k[ub+52>>2]=0;k[gb>>2]=0;l=k[rb>>2]|0;dh[k[(k[l>>2]|0)+12>>2]&255](l,rb,ub,-1);XN(rb);l=k[cb>>2]|0;j=k[l+288>>2]|0;l=k[l+292>>2]|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=1124007936;g=t+16|0;h=t+48|0;p=t+12|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;g=t+56|0;k[t+52>>2]=g;k[t+60>>2]=0;k[g>>2]=0;k[t+64>>2]=1124007936;g=t+72|0;h=t+104|0;p=t+68|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;g=t+112|0;k[t+108>>2]=g;k[t+116>>2]=0;k[g>>2]=0;k[t+120>>2]=1124007936;g=t+128|0;h=t+160|0;p=t+124|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;p=t+168|0;k[t+164>>2]=p;nb=p+56|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[Db>>2]=l;k[Db+4>>2]=j;j1(t,48,Db,5);k[tb>>2]=1124007936;ab=tb+4|0;g=tb+8|0;_a=tb+40|0;p=ab;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[_a>>2]=g;bb=tb+48|0;$a=tb+44|0;k[$a>>2]=bb;k[tb+52>>2]=0;k[bb>>2]=0;s=k[t>>2]|0;dh[k[(k[s>>2]|0)+12>>2]&255](s,t,tb,-1);XN(t);T=+XWa(Eb,+o[Cb+60>>2],1.0,k[Cb+64>>2]|0);s=Cb+56|0;o[s>>2]=T;g=k[vb>>2]|0;a:do if((((k[qb>>2]|0)-g|0)/468|0)>>>0>1){t=Cb+28|0;u=Db+4|0;v=Cb+100|0;x=Cb+88|0;y=Db+4|0;z=y+4|0;A=Db+8|0;B=Db+12|0;D=Db+4|0;E=wb+4|0;J=E+4|0;K=sb+4|0;L=wb+4|0;N=wb+8|0;O=wb+12|0;R=wb+16|0;S=wb+48|0;U=wb+56|0;V=wb+52|0;W=wb+60|0;X=wb+64|0;Y=wb+68|0;Z=wb+72|0;_=wb+104|0;ba=wb+112|0;ca=wb+108|0;da=wb+116|0;ea=wb+120|0;fa=wb+124|0;ga=wb+128|0;ha=wb+160|0;ia=wb+168|0;ja=wb+164|0;ka=Db+4|0;la=wb+4|0;ma=wb+8|0;na=wb+12|0;oa=wb+16|0;pa=wb+48|0;qa=wb+56|0;ra=wb+52|0;sa=wb+60|0;ta=wb+64|0;ua=wb+68|0;va=wb+72|0;wa=wb+104|0;xa=wb+112|0;ya=wb+108|0;za=wb+116|0;Aa=wb+120|0;Ba=wb+124|0;Ca=wb+128|0;Da=wb+160|0;Ea=wb+168|0;Fa=wb+164|0;Ga=Db+4|0;Ha=Db+4|0;Ia=Db+4|0;Ja=Db+8|0;Ka=Db+12|0;La=Db+4|0;Ma=wb+4|0;Na=Ma+4|0;Oa=sb+4|0;Pa=Db+8|0;Qa=Db+12|0;Ra=Db+4|0;Sa=wb+4|0;Ta=Sa+4|0;Ua=Db+8|0;Va=Db+12|0;Wa=Db+4|0;Xa=wb+4|0;Ya=Xa+4|0;Za=ub+16|0;b=1;while(1){q=b+-1|0;j=g+(q*468|0)+280|0;if((k[g+(b*468|0)+456>>2]|0)>(k[g+(q*468|0)+456>>2]|0)){l=g+(b*468|0)+280|0;if(((k[g+(q*468|0)+292>>2]|0)/2|0|0)!=(k[g+(b*468|0)+292>>2]|0)){k[Db>>2]=0;k[Ia>>2]=0;h=ZT(32)|0;k[h>>2]=1;p=h+4|0;k[Db>>2]=p;k[Ia>>2]=24;i[h+28>>0]=0;m=388175;nb=p+24|0;do{i[p>>0]=i[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(nb|0));Y8(-215,Db,388200,388217,477);k[Ia>>2]=0;k[Db>>2]=0;nb=k[h>>2]|0;k[h>>2]=nb+-1;if((nb|0)==1)ggb(k[h+-4>>2]|0)}if(((k[g+(q*468|0)+288>>2]|0)/2|0|0)!=(k[g+(b*468|0)+288>>2]|0)){k[Db>>2]=0;k[Ha>>2]=0;h=ZT(32)|0;k[h>>2]=1;p=h+4|0;k[Db>>2]=p;k[Ha>>2]=24;i[h+28>>0]=0;m=388308;nb=p+24|0;do{i[p>>0]=i[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(nb|0));Y8(-215,Db,388200,388217,478);k[Ha>>2]=0;k[Db>>2]=0;nb=k[h>>2]|0;k[h>>2]=nb+-1;if((nb|0)==1)ggb(k[h+-4>>2]|0)}k[A>>2]=0;k[B>>2]=0;k[Db>>2]=16842752;k[D>>2]=j;h=J;k[h>>2]=0;k[h+4>>2]=0;k[wb>>2]=33619968;k[E>>2]=l;g=k[g+(b*468|0)+320>>2]|0;h=k[g>>2]|0;k[sb>>2]=k[g+4>>2];k[K>>2]=h;Rla(Db,wb,sb,0.0,0.0,3);o[s>>2]=+o[s>>2]*.75;h=k[cb>>2]|0;g=k[h+(b*468|0)+288>>2]|0;h=k[h+(b*468|0)+292>>2]|0;k[wb>>2]=0;k[L>>2]=0;k[N>>2]=1124007936;p=O;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[S>>2]=R;k[V>>2]=U;k[W>>2]=0;k[U>>2]=0;k[X>>2]=1124007936;p=Y;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[_>>2]=Z;k[ca>>2]=ba;k[da>>2]=0;k[ba>>2]=0;k[ea>>2]=1124007936;p=fa;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[ha>>2]=ga;k[ja>>2]=ia;p=ia;nb=p+56|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[Db>>2]=h;k[ka>>2]=g;j1(wb,48,Db,5);h=k[wb>>2]|0;dh[k[(k[h>>2]|0)+12>>2]&255](h,wb,ub,-1);XN(wb);h=k[cb>>2]|0;g=k[h+(b*468|0)+288>>2]|0;h=k[h+(b*468|0)+292>>2]|0;k[wb>>2]=0;k[la>>2]=0;k[ma>>2]=1124007936;p=na;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[pa>>2]=oa;k[ra>>2]=qa;k[sa>>2]=0;k[qa>>2]=0;k[ta>>2]=1124007936;p=ua;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[wa>>2]=va;k[ya>>2]=xa;k[za>>2]=0;k[xa>>2]=0;k[Aa>>2]=1124007936;p=Ba;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[Da>>2]=Ca;k[Fa>>2]=Ea;p=Ea;nb=p+56|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[Db>>2]=h;k[Ga>>2]=g;j1(wb,48,Db,5);nb=k[wb>>2]|0;dh[k[(k[nb>>2]|0)+12>>2]&255](nb,wb,tb,-1);XN(wb)}else{nb=z;k[nb>>2]=0;k[nb+4>>2]=0;k[Db>>2]=33619968;k[y>>2]=g+(b*468|0)+280;mY(j,Db)}g=k[cb>>2]|0;k[Ja>>2]=0;k[Ka>>2]=0;k[Db>>2]=16842752;k[La>>2]=g+(b*468|0)+280;nb=Na;k[nb>>2]=0;k[nb+4>>2]=0;k[wb>>2]=33619968;k[Ma>>2]=g+(b*468|0)+336;k[sb>>2]=5;k[Oa>>2]=5;uua(Db,wb,sb,1.0,1.0,1);g=k[cb>>2]|0;k[Pa>>2]=0;k[Qa>>2]=0;k[Db>>2]=16842752;k[Ra>>2]=g+(b*468|0)+336;nb=Ta;k[nb>>2]=0;k[nb+4>>2]=0;k[wb>>2]=33619968;k[Sa>>2]=g+(b*468|0);ufa(Db,wb,5,1,0,1.0,0.0,4);g=k[cb>>2]|0;k[Ua>>2]=0;k[Va>>2]=0;k[Db>>2]=16842752;k[Wa>>2]=g+(b*468|0)+336;nb=Ya;k[nb>>2]=0;k[nb+4>>2]=0;k[wb>>2]=33619968;k[Xa>>2]=g+(b*468|0)+56;ufa(Db,wb,5,0,1,1.0,0.0,4);g=k[t>>2]|0;switch(g|0){case 0:{nb=k[cb>>2]|0;UWa(nb+(b*468|0)|0,nb+(b*468|0)+56|0,ub,+o[s>>2]);break}case 1:{nb=k[cb>>2]|0;VWa(nb+(b*468|0)|0,nb+(b*468|0)+56|0,ub,+o[s>>2]);break}case 2:{nb=k[cb>>2]|0;WWa(nb+(b*468|0)|0,nb+(b*468|0)+56|0,ub,+o[s>>2]);break}case 3:{g=k[cb>>2]|0;w=+o[s>>2];p=k[g+(b*468|0)+40>>2]|0;n=k[p+4>>2]|0;p=k[p>>2]|0;w=1.0/(w*w);if((p|0)>0?(hb=k[g+(b*468|0)+16>>2]|0,ib=k[k[g+(b*468|0)+44>>2]>>2]|0,jb=k[g+(b*468|0)+72>>2]|0,kb=k[k[g+(b*468|0)+100>>2]>>2]|0,lb=k[Za>>2]|0,mb=k[k[eb>>2]>>2]|0,(n|0)>0):0){h=0;do{j=hb+(aa(ib,h)|0)|0;l=jb+(aa(kb,h)|0)|0;m=lb+(aa(mb,h)|0)|0;g=0;do{M=+o[j+(g<<2)>>2];T=+o[l+(g<<2)>>2];T=1.0/+Q(+(w*(M*M+T*T)+1.0));o[m+(g<<2)>>2]=T;g=g+1|0}while((g|0)!=(n|0));h=h+1|0}while((h|0)!=(p|0))}break}default:{k[Db>>2]=0;k[u>>2]=0;h=ZT(36)|0;k[h>>2]=1;p=h+4|0;k[Db>>2]=p;k[u>>2]=28;i[h+32>>0]=0;m=387406;nb=p+28|0;do{i[p>>0]=i[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(nb|0));Y8(g,Db,387831,387323,152);k[u>>2]=0;k[Db>>2]=0;nb=k[h>>2]|0;k[h>>2]=nb+-1;if((nb|0)==1)ggb(k[h+-4>>2]|0)}}if((k[(k[v>>2]|0)+(q<<2)>>2]|0)>0){g=0;do{ZWa((k[cb>>2]|0)+(b*468|0)+280|0,ub,tb,+o[(k[(k[x>>2]|0)+(q*12|0)>>2]|0)+(g<<2)>>2]);g=g+1|0}while((g|0)<(k[(k[v>>2]|0)+(q<<2)>>2]|0))}b=b+1|0;g=k[vb>>2]|0;if(b>>>0>=(((k[qb>>2]|0)-g|0)/468|0)>>>0)break a}}while(0);j=tb+36|0;g=k[j>>2]|0;if(g|0?(mb=g+12|0,nb=k[mb>>2]|0,k[mb>>2]=nb+-1,(nb|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[tb+32>>2]|0;if(!g){g=B1()|0;h=k[j>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;nb=tb+16|0;k[nb>>2]=0;k[nb+4>>2]=0;k[nb+8>>2]=0;k[nb+12>>2]=0;if((k[ab>>2]|0)>0){h=k[_a>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[ab>>2]|0))}g=k[$a>>2]|0;if(!((g|0)==(bb|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=ub+36|0;g=k[j>>2]|0;if(g|0?(mb=g+12|0,nb=k[mb>>2]|0,k[mb>>2]=nb+-1,(nb|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[ub+32>>2]|0;if(!g){g=B1()|0;h=k[j>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;nb=ub+16|0;k[nb>>2]=0;k[nb+4>>2]=0;k[nb+8>>2]=0;k[nb+12>>2]=0;if((k[fb>>2]|0)>0){h=k[db>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[fb>>2]|0))}g=k[eb>>2]|0;if(!((g|0)==(gb|0)|(g|0)==0))ggb(k[g+-4>>2]|0);if(!f){g=k[d>>2]|0;W=d+4|0;h=k[W>>2]|0;if((h|0)!=(g|0))k[W>>2]=h+(~(((h+-28-g|0)>>>0)/28|0)*28|0);p=((k[qb>>2]|0)-(k[vb>>2]|0)|0)/468|0;k[Db>>2]=0;k[Db+4>>2]=p;k[wb>>2]=142284;k[wb+4>>2]=vb;p=wb+8|0;m=Cb;nb=p+68|0;do{k[p>>2]=k[m>>2];p=p+4|0;m=m+4|0}while((p|0)<(nb|0));xWa(wb,Db);g=k[qb>>2]|0;E=k[vb>>2]|0;D=(g|0)==(E|0);B=E;if(!D){l=(g-E|0)/468|0;j=0;do{m=k[B+(j*468|0)+400>>2]|0;if((m|0)>0?(ob=k[B+(j*468|0)+404>>2]|0,(ob|0)>0):0){n=k[B+(j*468|0)+128>>2]|0;p=k[k[B+(j*468|0)+156>>2]>>2]|0;q=k[B+(j*468|0)+184>>2]|0;b=k[k[B+(j*468|0)+212>>2]>>2]|0;s=k[B+(j*468|0)+240>>2]|0;t=k[k[B+(j*468|0)+268>>2]>>2]|0;u=k[B+(j*468|0)+408>>2]|0;v=k[k[B+(j*468|0)+436>>2]>>2]|0;g=0;do{x=n+(aa(p,g)|0)|0;y=q+(aa(b,g)|0)|0;z=s+(aa(t,g)|0)|0;A=u+(aa(v,g)|0)|0;h=0;do{T=+o[y+(h<<2)>>2];o[A+(h<<2)>>2]=+o[x+(h<<2)>>2]*+o[z+(h<<2)>>2]-T*T;h=h+1|0}while((h|0)!=(ob|0));g=g+1|0}while((g|0)!=(m|0))}j=j+1|0}while(j>>>0<l>>>0)}o[Db>>2]=0.0;N=Db+4|0;o[N>>2]=0.0;O=Db+8|0;o[O>>2]=0.0;o[Db+12>>2]=-1.0;R=Db+16|0;o[R>>2]=0.0;S=Db+20|0;k[S>>2]=0;U=Db+24|0;k[U>>2]=-1;k[wb>>2]=0;V=wb+4|0;k[V>>2]=0;k[wb+8>>2]=0;g=k[Cb+40>>2]|0;switch(g|0){case 5:case 4:{T=14.142135620117188;break}case 2:{pb=98;break}default:if((g|0)==3)pb=98;else T=0.0}if((pb|0)==98)T=16.970561981201172;if(!D){D=Cb+32|0;J=Cb+36|0;K=Cb+20|0;L=wb+8|0;h=0;g=E;B=0;do{l=g;j=k[l+(B*468|0)+408>>2]|0;b:do if(((k[l+(B*468|0)+400>>2]|0)+-1|0)>1){n=k[k[l+(B*468|0)+436>>2]>>2]|0;A=B+-1|0;y=1;z=j+n|0;x=j;m=j;while(1){u=y+1|0;v=m+(aa(n,u)|0)|0;j=k[l+(B*468|0)+404>>2]|0;if((j+-1|0)>1){M=+(y|0);g=1;t=j;while(1){ob=m+(aa(n,y)|0)+(g<<2)|0;w=+o[ob>>2];c:do if(!(w>+o[D>>2]?!(w>=+o[J>>2]):1)){j=g+-1|0;if(!(w>+o[z+(j<<2)>>2]))break;m=g+1|0;if(!(w>+o[z+(m<<2)>>2]))break;if(!(w>+o[x+(j<<2)>>2]))break;if(!(w>+o[x+(g<<2)>>2]))break;if(!(w>+o[x+(m<<2)>>2]))break;if(!(w>+o[v+(j<<2)>>2]))break;if(!(w>+o[v+(g<<2)>>2]))break;if(!(w>+o[v+(m<<2)>>2]))break;I=+P(+w);o[R>>2]=I;w=+o[l+(B*468|0)+452>>2]*+o[K>>2];o[O>>2]=w;m=k[l+(B*468|0)+456>>2]|0;k[S>>2]=m;k[U>>2]=B;d:do if((m|0)>0){j=1;n=2;do{while(1){if(!(m&1))break;j=aa(j,n)|0;if((m|0)>1)m=m+-1|0;else break d}m=m>>>1;n=aa(n,n)|0}while((m|0)!=0)}else j=1;while(0);H=+(j|0);p=~~(w/H+.5);G=+(g|0);o[Db>>2]=G;o[N>>2]=M;q=k[V>>2]|0;j=k[wb>>2]|0;b=j;s=q;e:do if((q|0)!=(j|0)){C=H*G;F=H*M;w=w*w;n=(q-j|0)/28|0;m=0;while(1){ob=k[b+(m*28|0)+24>>2]|0;if((A|0)==(ob|0)|(B|0)==(ob|0)?(Ib=C-+o[b+(m*28|0)>>2],Hb=F-+o[b+(m*28|0)+4>>2],Ib*Ib+Hb*Hb<=w):0)break;j=m+1|0;if(j>>>0<n>>>0)m=j;else{j=0;break e}}if(I>+o[b+(m*28|0)+16>>2]){j=1;h=m}else break c}else j=0;while(0);w=T*+(p|0);if((~~(G-w+.5)|0)<1)break;if((~~(M-w+.5)|0)<1?1:(~~(w+G+.5)+1|0)>=(t|0))break;if((~~(w+M+.5)+1|0)>=(k[l+(B*468|0)+400>>2]|0))break;C=H*G;o[Db>>2]=C;w=H*M;o[N>>2]=w;if(j){o[b+(h*28|0)>>2]=C;o[b+(h*28|0)+4>>2]=w;ob=b+(h*28|0)+8|0;k[ob>>2]=k[O>>2];k[ob+4>>2]=k[O+4>>2];k[ob+8>>2]=k[O+8>>2];k[ob+12>>2]=k[O+12>>2];k[ob+16>>2]=k[O+16>>2];break}if((s|0)==(k[L>>2]|0)){H6(wb,Db);break}else{o[q>>2]=C;o[s+4>>2]=w;ob=s+8|0;k[ob>>2]=k[O>>2];k[ob+4>>2]=k[O+4>>2];k[ob+8>>2]=k[O+8>>2];k[ob+12>>2]=k[O+12>>2];k[ob+16>>2]=k[O+16>>2];k[V>>2]=s+28;break}}while(0);g=g+1|0;l=k[vb>>2]|0;j=k[l+(B*468|0)+404>>2]|0;if((g|0)>=(j+-1|0))break;n=k[k[l+(B*468|0)+436>>2]>>2]|0;m=k[l+(B*468|0)+408>>2]|0;t=j}g=l}if((u|0)>=((k[l+(B*468|0)+400>>2]|0)+-1|0))break b;x=z;y=u;z=v;n=k[k[l+(B*468|0)+436>>2]>>2]|0;m=k[l+(B*468|0)+408>>2]|0}}while(0);B=B+1|0}while(B>>>0<(((k[qb>>2]|0)-g|0)/468|0)>>>0);g=k[V>>2]|0;u=k[wb>>2]|0;v=u;if((g|0)!=(u|0)){s=d+8|0;q=0;do{t=v+(q*28|0)|0;b=q;q=q+1|0;j=(g-u|0)/28|0;f:do if(q>>>0<j>>>0){l=(k[v+(b*28|0)+24>>2]|0)+1|0;m=v+(b*28|0)+4|0;n=v+(b*28|0)+8|0;p=v+(b*28|0)+16|0;h=q;while(1){do if((l|0)==(k[v+(h*28|0)+24>>2]|0)){T=+o[t>>2]-+o[v+(h*28|0)>>2];Hb=+o[m>>2]-+o[v+(h*28|0)+4>>2];Ib=+o[n>>2];if(!(T*T+Hb*Hb<=Ib*Ib))break;if(+o[p>>2]<+o[v+(h*28|0)+16>>2])break f}while(0);h=h+1|0;if(h>>>0>=j>>>0){pb=151;break}}}else pb=151;while(0);do if((pb|0)==151){pb=0;h=k[W>>2]|0;if((h|0)==(k[s>>2]|0)){H6(d,t);break}else{k[h>>2]=k[t>>2];k[h+4>>2]=k[v+(b*28|0)+4>>2];ob=h+8|0;f=v+(b*28|0)+8|0;k[ob>>2]=k[f>>2];k[ob+4>>2]=k[f+4>>2];k[ob+8>>2]=k[f+8>>2];k[ob+12>>2]=k[f+12>>2];k[ob+16>>2]=k[f+16>>2];k[W>>2]=(k[W>>2]|0)+28;break}}while(0)}while(q>>>0<((g-u|0)/28|0)>>>0)}h=u;if(u|0){if((g|0)!=(v|0))k[V>>2]=g+(~(((g+-28-u|0)>>>0)/28|0)*28|0);ggb(h)}}b=Db+4|0;s=Db+8|0;t=Db+12|0;k[Db>>2]=0;k[Db+4>>2]=0;k[Db+8>>2]=0;k[Db+12>>2]=0;o[wb>>2]=0.0;u=wb+4|0;o[u>>2]=0.0;o[sb>>2]=0.0;v=sb+4|0;o[v>>2]=0.0;g=k[d>>2]|0;if((k[W>>2]|0)!=(g|0)){x=Cb+68|0;y=ub+8|0;z=ub+12|0;A=ub+4|0;B=rb+8|0;D=rb+12|0;E=rb+4|0;J=tb+4|0;K=tb+8|0;L=tb+12|0;j=0;do{l=k[g+(j*28|0)+20>>2]|0;g:do if((l|0)>0){h=1;m=2;do{while(1){if(!(l&1))break;h=aa(h,m)|0;if((l|0)>1)l=l+-1|0;else break g}l=l>>>1;m=aa(m,m)|0}while((l|0)!=0)}else h=1;while(0);T=+(h|0);h=~~(+o[g+(j*28|0)>>2]/T+.5);l=~~(+o[g+(j*28|0)+4>>2]/T+.5);f=k[g+(j*28|0)+24>>2]|0;nb=k[x>>2]|0;mb=k[nb+(f*468|0)+408>>2]|0;f=k[k[nb+(f*468|0)+436>>2]>>2]|0;nb=mb+(aa(f,l)|0)+(h<<2)|0;T=+o[nb+4>>2];Hb=+o[nb+-4>>2];ob=mb+(aa(f,l+1|0)|0)+(h<<2)|0;Ib=+o[ob>>2];f=mb+(aa(f,l+-1|0)|0)+(h<<2)|0;w=+o[f>>2];I=+o[nb>>2]*2.0;M=(+o[ob+4>>2]+ +o[f+-4>>2])*.25-(+o[f+4>>2]+ +o[ob+-4>>2])*.25;o[Db>>2]=T+Hb-I;o[t>>2]=Ib+w-I;o[s>>2]=M;o[b>>2]=M;o[wb>>2]=-((T-Hb)*.5);o[u>>2]=-((Ib-w)*.5);k[ub>>2]=-1056833531;k[A>>2]=Db;k[y>>2]=2;k[z>>2]=2;k[rb>>2]=-1056833531;k[E>>2]=wb;k[B>>2]=1;k[D>>2]=2;k[tb>>2]=-1040056315;k[J>>2]=sb;k[K>>2]=1;k[L>>2]=2;NZ(ub,rb,tb,0)|0;w=+o[sb>>2];do if(!(+P(+w)<=1.0))pb=170;else{if(!(+P(+(+o[v>>2]))<=1.0)){pb=170;break}C=+(h|0)+w;p=k[d>>2]|0;q=p+(j*28|0)|0;o[q>>2]=C;w=+(l|0)+ +o[v>>2];n=p+(j*28|0)+4|0;o[n>>2]=w;l=k[(k[x>>2]|0)+((k[p+(j*28|0)+24>>2]|0)*468|0)+456>>2]|0;g=p;h:do if((l|0)>0){h=1;m=2;do{while(1){if(!(l&1))break;h=aa(h,m)|0;if((l|0)>1)l=l+-1|0;else break h}l=l>>>1;m=aa(m,m)|0}while((l|0)!=0)}else h=1;while(0);Ib=+(h|0);o[q>>2]=Ib*C;o[n>>2]=Ib*w;o[p+(j*28|0)+12>>2]=0.0;h=p+(j*28|0)+8|0;o[h>>2]=+o[h>>2]*2.0;h=k[W>>2]|0}while(0);if((pb|0)==170){pb=0;h=(k[d>>2]|0)+(j*28|0)|0;g=h+28|0;l=k[W>>2]|0;if((g|0)!=(l|0)){do{k[h>>2]=k[g>>2];k[h+4>>2]=k[g+4>>2];ob=h+8|0;f=g+8|0;k[ob>>2]=k[f>>2];k[ob+4>>2]=k[f+4>>2];k[ob+8>>2]=k[f+8>>2];k[ob+12>>2]=k[f+12>>2];k[ob+16>>2]=k[f+16>>2];g=g+28|0;h=h+28|0}while((g|0)!=(l|0));g=k[W>>2]|0;if((g|0)!=(h|0))pb=173}else pb=173;if((pb|0)==173){pb=0;h=g+(~(((g+-28-h|0)>>>0)/28|0)*28|0)|0;k[W>>2]=h}j=j+-1|0;g=k[d>>2]|0}j=j+1|0}while(j>>>0<((h-g|0)/28|0)>>>0)}}if(!(G2(c)|0)){do if((k[c>>2]&2031616|0)==65536){l=k[c+4>>2]|0;k[Db>>2]=k[l>>2];q=Db+4|0;g=l+4|0;k[q>>2]=k[g>>2];pb=Db+8|0;k[pb>>2]=k[l+8>>2];k[Db+12>>2]=k[l+12>>2];k[Db+16>>2]=k[l+16>>2];k[Db+20>>2]=k[l+20>>2];k[Db+24>>2]=k[l+24>>2];k[Db+28>>2]=k[l+28>>2];k[Db+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[Db+36>>2]=h;j=Db+40|0;k[j>>2]=pb;pb=Db+48|0;n=Db+44|0;k[n>>2]=pb;k[Db+52>>2]=0;k[pb>>2]=0;if(h|0){pb=h+12|0;k[pb>>2]=(k[pb>>2]|0)+1}if((k[g>>2]|0)<3){c=k[l+44>>2]|0;pb=k[n>>2]|0;k[pb>>2]=k[c>>2];k[pb+4>>2]=k[c+4>>2];break}k[q>>2]=0;x1(Db,k[g>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[p+(g<<2)>>2];k[h+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else Q1(Db,c,-1);while(0);dXa(d,Db);j=Db+36|0;g=k[j>>2]|0;if(g|0?(c=g+12|0,pb=k[c>>2]|0,k[c>>2]=pb+-1,(pb|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Db+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;pb=Db+16|0;h=Db+4|0;k[pb>>2]=0;k[pb+4>>2]=0;k[pb+8>>2]=0;k[pb+12>>2]=0;if((k[h>>2]|0)>0){j=k[Db+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Db+44>>2]|0;if(!((g|0)==(Db+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0)}do if(k[e>>2]&2031616|0){X=J2(e,-1)|0;n=d+4|0;g=k[n>>2]|0;h=k[d>>2]|0;if((g|0)==(h|0))h=g;else{l=Db+4|0;j=0;do{e=k[h+(j*28|0)+24>>2]|0;if(!((e|0)>-1?(e|0)<(((k[qb>>2]|0)-(k[vb>>2]|0)|0)/468|0|0):0)){k[Db>>2]=0;k[l>>2]=0;g=ZT(84)|0;k[g>>2]=1;p=g+4|0;k[Db>>2]=p;k[l>>2]=79;i[g+83>>0]=0;m=388013;nb=p+79|0;do{i[p>>0]=i[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(nb|0));Y8(-215,Db,387476,387323,712);k[l>>2]=0;k[Db>>2]=0;e=k[g>>2]|0;k[g>>2]=e+-1;if((e|0)==1)ggb(k[g+-4>>2]|0);h=k[d>>2]|0;g=k[n>>2]|0}j=j+1|0}while(j>>>0<((g-h|0)/28|0)>>>0)}m=Cb+40|0;do if((k[m>>2]|0)>=4){j=k[Cb+44>>2]|0;if(!j){j=(g-h|0)/28|0;l=~~+$(+(+((k[Cb+48>>2]|0)*162|0)*.125));k[wb>>2]=0;k[wb+4>>2]=0;k[wb+8>>2]=1124007936;g=wb+16|0;h=wb+48|0;p=wb+12|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;g=wb+56|0;k[wb+52>>2]=g;k[wb+60>>2]=0;k[g>>2]=0;k[wb+64>>2]=1124007936;g=wb+72|0;h=wb+104|0;p=wb+68|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;g=wb+112|0;k[wb+108>>2]=g;k[wb+116>>2]=0;k[g>>2]=0;k[wb+120>>2]=1124007936;g=wb+128|0;h=wb+160|0;p=wb+124|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;p=wb+168|0;k[wb+164>>2]=p;nb=p+56|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[Db>>2]=l;k[Db+4>>2]=j;j1(wb,48,Db,0);e=k[wb>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,wb,X,-1);XN(wb);break}else{l=(g-h|0)/28|0;j=~~+$(+(+(j|0)*.125));k[wb>>2]=0;k[wb+4>>2]=0;k[wb+8>>2]=1124007936;g=wb+16|0;h=wb+48|0;p=wb+12|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;g=wb+56|0;k[wb+52>>2]=g;k[wb+60>>2]=0;k[g>>2]=0;k[wb+64>>2]=1124007936;g=wb+72|0;h=wb+104|0;p=wb+68|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;g=wb+112|0;k[wb+108>>2]=g;k[wb+116>>2]=0;k[g>>2]=0;k[wb+120>>2]=1124007936;g=wb+128|0;h=wb+160|0;p=wb+124|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;p=wb+168|0;k[wb+164>>2]=p;nb=p+56|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[Db>>2]=j;k[Db+4>>2]=l;j1(wb,48,Db,0);e=k[wb>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,wb,X,-1);XN(wb);break}}else{j=(g-h|0)/28|0;k[wb>>2]=0;k[wb+4>>2]=0;k[wb+8>>2]=1124007936;g=wb+16|0;h=wb+48|0;p=wb+12|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;g=wb+56|0;k[wb+52>>2]=g;k[wb+60>>2]=0;k[g>>2]=0;k[wb+64>>2]=1124007936;g=wb+72|0;h=wb+104|0;p=wb+68|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;g=wb+112|0;k[wb+108>>2]=g;k[wb+116>>2]=0;k[g>>2]=0;k[wb+120>>2]=1124007936;g=wb+128|0;h=wb+160|0;p=wb+124|0;nb=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[h>>2]=g;p=wb+168|0;k[wb+164>>2]=p;nb=p+56|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(nb|0));k[Db>>2]=64;k[Db+4>>2]=j;j1(wb,48,Db,5);e=k[wb>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,wb,X,-1);XN(wb)}while(0);i:do switch(k[m>>2]|0){case 2:{ub=((k[n>>2]|0)-(k[d>>2]|0)|0)/28|0;k[Db>>2]=0;k[Db+4>>2]=ub;k[wb>>2]=142304;k[wb+4>>2]=d;k[wb+8>>2]=X;k[wb+12>>2]=vb;MWa(wb,Db);break}case 3:{ub=((k[n>>2]|0)-(k[d>>2]|0)|0)/28|0;k[Db>>2]=0;k[Db+4>>2]=ub;k[wb>>2]=142324;k[wb+4>>2]=d;k[wb+8>>2]=X;k[wb+12>>2]=vb;KWa(wb,Db);break}case 4:{if(!(k[Cb+44>>2]|0)){ub=((k[n>>2]|0)-(k[d>>2]|0)|0)/28|0;k[Db>>2]=0;k[Db+4>>2]=ub;k[wb>>2]=142344;k[wb+4>>2]=d;k[wb+8>>2]=X;k[wb+12>>2]=vb;k[wb+16>>2]=Cb;IWa(wb,Db);break i}U=((k[n>>2]|0)-(k[d>>2]|0)|0)/28|0;k[Db>>2]=0;k[Db+4>>2]=U;k[sb>>2]=k[Cb+112>>2];U=sb+4|0;h=Cb+116|0;g=k[h>>2]|0;k[U>>2]=g;n=sb+8|0;k[n>>2]=k[Cb+120>>2];q=sb+12|0;k[q>>2]=k[Cb+124>>2];O=sb+16|0;k[O>>2]=k[Cb+128>>2];b=sb+20|0;k[b>>2]=k[Cb+132>>2];s=sb+24|0;k[s>>2]=k[Cb+136>>2];t=sb+28|0;k[t>>2]=k[Cb+140>>2];N=sb+32|0;k[N>>2]=k[Cb+144>>2];R=sb+36|0;j=k[Cb+148>>2]|0;k[R>>2]=j;S=sb+40|0;k[S>>2]=n;W=sb+48|0;V=sb+44|0;k[V>>2]=W;k[sb+52>>2]=0;k[W>>2]=0;if(j){g=j+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}do if((g|0)<3){rb=k[Cb+156>>2]|0;tb=k[V>>2]|0;k[tb>>2]=k[rb>>2];k[tb+4>>2]=k[rb+4>>2]}else{k[U>>2]=0;x1(sb,g,0,0,0);if((k[U>>2]|0)<=0)break;h=k[Cb+152>>2]|0;j=k[S>>2]|0;l=k[Cb+156>>2]|0;m=k[V>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[h+(g<<2)>>2];k[m+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[U>>2]|0))}while(0);k[ub>>2]=k[Cb+168>>2];J=ub+4|0;h=Cb+172|0;g=k[h>>2]|0;k[J>>2]=g;u=ub+8|0;k[u>>2]=k[Cb+176>>2];v=ub+12|0;k[v>>2]=k[Cb+180>>2];B=ub+16|0;k[B>>2]=k[Cb+184>>2];x=ub+20|0;k[x>>2]=k[Cb+188>>2];y=ub+24|0;k[y>>2]=k[Cb+192>>2];z=ub+28|0;k[z>>2]=k[Cb+196>>2];A=ub+32|0;k[A>>2]=k[Cb+200>>2];D=ub+36|0;j=k[Cb+204>>2]|0;k[D>>2]=j;E=ub+40|0;k[E>>2]=u;L=ub+48|0;K=ub+44|0;k[K>>2]=L;k[ub+52>>2]=0;k[L>>2]=0;if(j){g=j+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}do if((g|0)<3){rb=k[Cb+212>>2]|0;tb=k[K>>2]|0;k[tb>>2]=k[rb>>2];k[tb+4>>2]=k[rb+4>>2]}else{k[J>>2]=0;x1(ub,g,0,0,0);if((k[J>>2]|0)<=0)break;h=k[Cb+208>>2]|0;j=k[E>>2]|0;l=k[Cb+212>>2]|0;m=k[K>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[h+(g<<2)>>2];k[m+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[J>>2]|0))}while(0);k[wb>>2]=142652;k[wb+4>>2]=d;k[wb+8>>2]=X;k[wb+12>>2]=vb;k[wb+16>>2]=Cb;l=wb+20|0;k[l>>2]=k[sb>>2];p=wb+24|0;g=k[U>>2]|0;k[p>>2]=g;d=wb+28|0;k[d>>2]=k[n>>2];k[wb+32>>2]=k[q>>2];k[wb+36>>2]=k[O>>2];k[wb+40>>2]=k[b>>2];k[wb+44>>2]=k[s>>2];k[wb+48>>2]=k[t>>2];k[wb+52>>2]=k[N>>2];h=k[R>>2]|0;k[wb+56>>2]=h;j=wb+60|0;k[j>>2]=d;d=wb+68|0;n=wb+64|0;k[n>>2]=d;k[wb+72>>2]=0;k[d>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[U>>2]|0}do if((g|0)<3){vb=k[V>>2]|0;d=k[n>>2]|0;k[d>>2]=k[vb>>2];k[d+4>>2]=k[vb+4>>2]}else{k[p>>2]=0;x1(l,g,0,0,0);if((k[p>>2]|0)<=0)break;m=k[S>>2]|0;j=k[j>>2]|0;l=k[V>>2]|0;h=k[n>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[m+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[p>>2]|0))}while(0);l=wb+76|0;k[l>>2]=k[ub>>2];p=wb+80|0;g=k[J>>2]|0;k[p>>2]=g;d=wb+84|0;k[d>>2]=k[u>>2];k[wb+88>>2]=k[v>>2];k[wb+92>>2]=k[B>>2];k[wb+96>>2]=k[x>>2];k[wb+100>>2]=k[y>>2];k[wb+104>>2]=k[z>>2];k[wb+108>>2]=k[A>>2];h=k[D>>2]|0;k[wb+112>>2]=h;j=wb+116|0;k[j>>2]=d;d=wb+124|0;n=wb+120|0;k[n>>2]=d;k[wb+128>>2]=0;k[d>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[J>>2]|0}do if((g|0)<3){vb=k[K>>2]|0;d=k[n>>2]|0;k[d>>2]=k[vb>>2];k[d+4>>2]=k[vb+4>>2]}else{k[p>>2]=0;x1(l,g,0,0,0);if((k[p>>2]|0)<=0)break;m=k[E>>2]|0;j=k[j>>2]|0;l=k[K>>2]|0;h=k[n>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[m+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[p>>2]|0))}while(0);jh[k[(k[wb>>2]|0)+8>>2]&1023](wb,Db);yWa(wb);g=k[D>>2]|0;do if(g|0){d=g+12|0;wb=k[d>>2]|0;k[d>>2]=wb+-1;if((wb|0)!=1)break;h=k[D>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[A>>2]|0;if(g|0)break;g=B1()|0;h=k[D>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[D>>2]=0}while(0);k[D>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[J>>2]|0)>0){h=k[E>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[J>>2]|0))}g=k[K>>2]|0;if(!((g|0)==(L|0)|(g|0)==0))ggb(k[g+-4>>2]|0);g=k[R>>2]|0;do if(g|0){d=g+12|0;wb=k[d>>2]|0;k[d>>2]=wb+-1;if((wb|0)!=1)break;h=k[R>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[N>>2]|0;if(g|0)break;g=B1()|0;h=k[R>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[R>>2]=0}while(0);k[R>>2]=0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[U>>2]|0)>0){h=k[S>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[U>>2]|0))}g=k[V>>2]|0;if(!((g|0)==(W|0)|(g|0)==0))ggb(k[g+-4>>2]|0);break}case 5:{if(!(k[Cb+44>>2]|0)){ub=((k[n>>2]|0)-(k[d>>2]|0)|0)/28|0;k[Db>>2]=0;k[Db+4>>2]=ub;k[wb>>2]=142364;k[wb+4>>2]=d;k[wb+8>>2]=X;k[wb+12>>2]=vb;k[wb+16>>2]=Cb;EWa(wb,Db);break i}U=((k[n>>2]|0)-(k[d>>2]|0)|0)/28|0;k[Db>>2]=0;k[Db+4>>2]=U;k[rb>>2]=k[Cb+112>>2];U=rb+4|0;h=Cb+116|0;g=k[h>>2]|0;k[U>>2]=g;n=rb+8|0;k[n>>2]=k[Cb+120>>2];q=rb+12|0;k[q>>2]=k[Cb+124>>2];O=rb+16|0;k[O>>2]=k[Cb+128>>2];b=rb+20|0;k[b>>2]=k[Cb+132>>2];s=rb+24|0;k[s>>2]=k[Cb+136>>2];t=rb+28|0;k[t>>2]=k[Cb+140>>2];N=rb+32|0;k[N>>2]=k[Cb+144>>2];R=rb+36|0;j=k[Cb+148>>2]|0;k[R>>2]=j;S=rb+40|0;k[S>>2]=n;W=rb+48|0;V=rb+44|0;k[V>>2]=W;k[rb+52>>2]=0;k[W>>2]=0;if(j){g=j+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}do if((g|0)<3){sb=k[Cb+156>>2]|0;ub=k[V>>2]|0;k[ub>>2]=k[sb>>2];k[ub+4>>2]=k[sb+4>>2]}else{k[U>>2]=0;x1(rb,g,0,0,0);if((k[U>>2]|0)<=0)break;h=k[Cb+152>>2]|0;j=k[S>>2]|0;l=k[Cb+156>>2]|0;m=k[V>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[h+(g<<2)>>2];k[m+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[U>>2]|0))}while(0);k[tb>>2]=k[Cb+168>>2];J=tb+4|0;h=Cb+172|0;g=k[h>>2]|0;k[J>>2]=g;u=tb+8|0;k[u>>2]=k[Cb+176>>2];v=tb+12|0;k[v>>2]=k[Cb+180>>2];B=tb+16|0;k[B>>2]=k[Cb+184>>2];x=tb+20|0;k[x>>2]=k[Cb+188>>2];y=tb+24|0;k[y>>2]=k[Cb+192>>2];z=tb+28|0;k[z>>2]=k[Cb+196>>2];A=tb+32|0;k[A>>2]=k[Cb+200>>2];D=tb+36|0;j=k[Cb+204>>2]|0;k[D>>2]=j;E=tb+40|0;k[E>>2]=u;L=tb+48|0;K=tb+44|0;k[K>>2]=L;k[tb+52>>2]=0;k[L>>2]=0;if(j){g=j+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}do if((g|0)<3){sb=k[Cb+212>>2]|0;ub=k[K>>2]|0;k[ub>>2]=k[sb>>2];k[ub+4>>2]=k[sb+4>>2]}else{k[J>>2]=0;x1(tb,g,0,0,0);if((k[J>>2]|0)<=0)break;h=k[Cb+208>>2]|0;j=k[E>>2]|0;l=k[Cb+212>>2]|0;m=k[K>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[h+(g<<2)>>2];k[m+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[J>>2]|0))}while(0);k[wb>>2]=142384;k[wb+4>>2]=d;k[wb+8>>2]=X;k[wb+12>>2]=vb;k[wb+16>>2]=Cb;l=wb+20|0;k[l>>2]=k[rb>>2];p=wb+24|0;g=k[U>>2]|0;k[p>>2]=g;d=wb+28|0;k[d>>2]=k[n>>2];k[wb+32>>2]=k[q>>2];k[wb+36>>2]=k[O>>2];k[wb+40>>2]=k[b>>2];k[wb+44>>2]=k[s>>2];k[wb+48>>2]=k[t>>2];k[wb+52>>2]=k[N>>2];h=k[R>>2]|0;k[wb+56>>2]=h;j=wb+60|0;k[j>>2]=d;d=wb+68|0;n=wb+64|0;k[n>>2]=d;k[wb+72>>2]=0;k[d>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[U>>2]|0}do if((g|0)<3){vb=k[V>>2]|0;d=k[n>>2]|0;k[d>>2]=k[vb>>2];k[d+4>>2]=k[vb+4>>2]}else{k[p>>2]=0;x1(l,g,0,0,0);if((k[p>>2]|0)<=0)break;m=k[S>>2]|0;j=k[j>>2]|0;l=k[V>>2]|0;h=k[n>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[m+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[p>>2]|0))}while(0);l=wb+76|0;k[l>>2]=k[tb>>2];p=wb+80|0;g=k[J>>2]|0;k[p>>2]=g;d=wb+84|0;k[d>>2]=k[u>>2];k[wb+88>>2]=k[v>>2];k[wb+92>>2]=k[B>>2];k[wb+96>>2]=k[x>>2];k[wb+100>>2]=k[y>>2];k[wb+104>>2]=k[z>>2];k[wb+108>>2]=k[A>>2];h=k[D>>2]|0;k[wb+112>>2]=h;j=wb+116|0;k[j>>2]=d;d=wb+124|0;n=wb+120|0;k[n>>2]=d;k[wb+128>>2]=0;k[d>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[J>>2]|0}do if((g|0)<3){vb=k[K>>2]|0;d=k[n>>2]|0;k[d>>2]=k[vb>>2];k[d+4>>2]=k[vb+4>>2]}else{k[p>>2]=0;x1(l,g,0,0,0);if((k[p>>2]|0)<=0)break;m=k[E>>2]|0;j=k[j>>2]|0;l=k[K>>2]|0;h=k[n>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[m+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[p>>2]|0))}while(0);jh[k[(k[wb>>2]|0)+8>>2]&1023](wb,Db);zWa(wb);g=k[D>>2]|0;do if(g|0){d=g+12|0;wb=k[d>>2]|0;k[d>>2]=wb+-1;if((wb|0)!=1)break;h=k[D>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[A>>2]|0;if(g|0)break;g=B1()|0;h=k[D>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[D>>2]=0}while(0);k[D>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[J>>2]|0)>0){h=k[E>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[J>>2]|0))}g=k[K>>2]|0;if(!((g|0)==(L|0)|(g|0)==0))ggb(k[g+-4>>2]|0);g=k[R>>2]|0;do if(g|0){d=g+12|0;wb=k[d>>2]|0;k[d>>2]=wb+-1;if((wb|0)!=1)break;h=k[R>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[N>>2]|0;if(g|0)break;g=B1()|0;h=k[R>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[R>>2]=0}while(0);k[R>>2]=0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[U>>2]|0)>0){h=k[S>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[U>>2]|0))}g=k[V>>2]|0;if(!((g|0)==(W|0)|(g|0)==0))ggb(k[g+-4>>2]|0);break}default:{}}while(0);g=X+8|0;if(k[g>>2]|0){wb=k[X+12>>2]|0;if((wb|0)!=(Xh[k[(k[a>>2]|0)+52>>2]&1023](a)|0)){k[Db>>2]=0;h=Db+4|0;k[h>>2]=0;j=ZT(52)|0;k[j>>2]=1;p=j+4|0;k[Db>>2]=p;k[h>>2]=45;i[j+49>>0]=0;m=387123;nb=p+45|0;do{i[p>>0]=i[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(nb|0));Y8(-215,Db,390333,384569,213);k[h>>2]=0;k[Db>>2]=0;wb=k[j>>2]|0;k[j>>2]=wb+-1;if((wb|0)==1)ggb(k[j+-4>>2]|0)}if(k[g>>2]|0){wb=k[X>>2]|0;if((wb&4095|0)==(Xh[k[(k[a>>2]|0)+56>>2]&1023](a)|0))break;k[Db>>2]=0;g=Db+4|0;k[g>>2]=0;h=ZT(56)|0;k[h>>2]=1;p=h+4|0;k[Db>>2]=p;k[g>>2]=49;i[h+53>>0]=0;m=387169;nb=p+49|0;do{i[p>>0]=i[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(nb|0));Y8(-215,Db,390333,384569,214);k[g>>2]=0;k[Db>>2]=0;Db=k[h>>2]|0;k[h>>2]=Db+-1;if((Db|0)==1)ggb(k[h+-4>>2]|0)}}}while(0);fUa(Cb);j=Eb+36|0;g=k[j>>2]|0;if(g|0?(Cb=g+12|0,Db=k[Cb>>2]|0,k[Cb>>2]=Db+-1,(Db|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Eb+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;k[xb>>2]=0;k[xb+4>>2]=0;k[xb+8>>2]=0;k[xb+12>>2]=0;if((k[zb>>2]|0)>0){h=k[yb>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[zb>>2]|0))}g=k[Ab>>2]|0;if(!((g|0)==(Bb|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=Fb+36|0;g=k[j>>2]|0;if(g|0?(Db=g+12|0,Eb=k[Db>>2]|0,k[Db>>2]=Eb+-1,(Eb|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Fb+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;Eb=Fb+16|0;h=Fb+4|0;k[Eb>>2]=0;k[Eb+4>>2]=0;k[Eb+8>>2]=0;k[Eb+12>>2]=0;if((k[h>>2]|0)>0){j=k[Fb+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Fb+44>>2]|0;if((g|0)==(Fb+48|0)|(g|0)==0){r=Gb;return}ggb(k[g+-4>>2]|0);r=Gb;return}function QTa(a){a=a|0;var b=0;switch(k[a+4>>2]|0){case 4:case 5:{b=k[a+12>>2]|0;if(!b){b=~~+$(+(+((k[a+8>>2]|0)*162|0)*.125));return b|0}else{b=~~+$(+(+(b|0)*.125));return b|0}}case 2:case 3:{b=64;return b|0}default:{b=-1;return b|0}}return 0}function RTa(a){a=a|0;switch(k[a+4>>2]|0){case 2:case 3:{a=5;break}case 4:case 5:{a=0;break}default:a=-1}return a|0}function STa(a){a=a|0;switch(k[a+4>>2]|0){case 2:case 3:{a=4;break}case 4:case 5:{a=6;break}default:a=-1}return a|0}function TTa(a,b){a=a|0;b=b|0;k[a+4>>2]=b;return}function UTa(a){a=a|0;return k[a+4>>2]|0}function VTa(a,b){a=a|0;b=b|0;k[a+12>>2]=b;return}function WTa(a){a=a|0;return k[a+12>>2]|0}function XTa(a,b){a=a|0;b=b|0;k[a+8>>2]=b;return}function YTa(a){a=a|0;return k[a+8>>2]|0}function ZTa(a,b){a=a|0;b=+b;o[a+16>>2]=b;return}function _Ta(a){a=a|0;return +(+o[a+16>>2])}function $Ta(a,b){a=a|0;b=b|0;k[a+20>>2]=b;return}function aUa(a){a=a|0;return k[a+20>>2]|0}function bUa(a,b){a=a|0;b=b|0;k[a+24>>2]=b;return}function cUa(a){a=a|0;return k[a+24>>2]|0}function dUa(a,b){a=a|0;b=b|0;k[a+28>>2]=b;return}function eUa(a){a=a|0;return k[a+28>>2]|0}function fUa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;d=a+260|0;b=k[d>>2]|0;if(b|0?(g=b+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+256>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;h=a+240|0;c=a+228|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+264>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+268>>2]|0;if(!((b|0)==(a+272|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+204|0;b=k[d>>2]|0;if(b|0?(g=b+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+200>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;h=a+184|0;c=a+172|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+208>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+212>>2]|0;if(!((b|0)==(a+216|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+148|0;b=k[d>>2]|0;if(b|0?(g=b+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+144>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;h=a+128|0;d=a+116|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+152>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+156>>2]|0;if(!((b|0)==(a+160|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[a+100>>2]|0;c=b;if(b|0){d=a+104|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}g=a+88|0;b=k[g>>2]|0;if(b|0){h=a+92|0;c=k[h>>2]|0;if((c|0)!=(b|0)){do{d=c+-12|0;k[h>>2]=d;e=k[d>>2]|0;f=e;if(!e)c=d;else{c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(e|0))k[c>>2]=d+(~((d+-4-f|0)>>>2)<<2);ggb(e);c=k[h>>2]|0}}while((c|0)!=(b|0));b=k[g>>2]|0}ggb(b)}d=a+68|0;e=k[d>>2]|0;if(!e)return;b=a+72|0;while(1){c=k[b>>2]|0;if((c|0)==(e|0))break;a=c+-468|0;k[b>>2]=a;gUa(a)}ggb(k[d>>2]|0);return}function gUa(a){a=a|0;var b=0,c=0,d=0;d=a+428|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+424>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+408|0;c=a+396|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+432>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+436>>2]|0;if(!((b|0)==(a+440|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+372|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+368>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+352|0;c=a+340|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+376>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+380>>2]|0;if(!((b|0)==(a+384|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+316|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+312>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+296|0;d=a+284|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+320>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+324>>2]|0;if(!((b|0)==(a+328|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+260|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+256>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+240|0;c=a+228|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+264>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+268>>2]|0;if(!((b|0)==(a+272|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+204|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+200>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+184|0;c=a+172|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+208>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+212>>2]|0;if(!((b|0)==(a+216|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+148|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+144>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+128|0;c=a+116|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+152>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+156>>2]|0;if(!((b|0)==(a+160|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+92|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+88>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+72|0;c=a+60|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+96>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+100>>2]|0;if(!((b|0)==(a+104|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+36|0;b=k[d>>2]|0;do if(b|0){b=b+12|0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=a+16|0;c=a+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+44>>2]|0;if((b|0)==(a+48|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function hUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function iUa(a){a=a|0;k[a>>2]=141180;zF(a+4|0);return}function jUa(a){a=a|0;k[a>>2]=141180;zF(a+4|0);ggb(a);return}function kUa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;f=k[a+4>>2]|0;e=a+8|0;a=k[e>>2]|0;if((a|0)==(f|0))return;do{k[e>>2]=a+-56;d=a+-20|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+-24>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+-40|0;c=a+-52|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+-16>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+-12>>2]|0;if(!((b|0)==(a+-8|0)|(b|0)==0))ggb(k[b+-4>>2]|0);a=k[e>>2]|0}while((a|0)!=(f|0));return}function lUa(a){a=a|0;k[a>>2]=141180;zF(a+4|0);ggb(a);return}function mUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=r;r=r+144|0;B=G+120|0;C=G+112|0;F=G+56|0;D=G;E=b+4|0;e=k[E>>2]|0;f=b+8|0;c=k[f>>2]|0;if((e|0)==(c|0)){c=B+4|0;d=ZT(28)|0;k[d>>2]=1;h=d+4|0;k[B>>2]=h;k[c>>2]=20;i[d+24>>0]=0;e=384722;j=h+20|0;do{i[h>>0]=i[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(j|0));Y8(-215,B,384743,384751,92);k[c>>2]=0;k[B>>2]=0;A=k[d>>2]|0;k[d>>2]=A+-1;if((A|0)==1)ggb(k[d+-4>>2]|0);y=k[E>>2]|0;z=E;A=f;c=k[f>>2]|0;d=y;f=y}else{z=E;A=f;d=e;f=e}if((c|0)==(d|0))c=0;else{e=(c-f|0)/56|0;d=0;c=0;do{c=(k[f+(d*56|0)+8>>2]|0)+c|0;d=d+1|0}while(d>>>0<e>>>0)}g=k[f+12>>2]|0;e=k[f>>2]&4095;k[F>>2]=1124007936;y=F+4|0;d=F+8|0;w=F+40|0;h=y;j=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(j|0));k[w>>2]=d;x=F+48|0;v=F+44|0;k[v>>2]=x;k[F+52>>2]=0;k[x>>2]=0;k[B>>2]=c;k[B+4>>2]=g;G1(F,2,B,e);c=k[z>>2]|0;if((k[A>>2]|0)!=(c|0)){h=B+4|0;j=C+4|0;l=B+4|0;m=l+4|0;n=D+36|0;o=D+16|0;p=D+4|0;q=D+40|0;s=D+44|0;t=D+48|0;u=D+32|0;f=0;g=0;while(1){e=(k[c+(f*56|0)+8>>2]|0)+g|0;k[B>>2]=g;k[h>>2]=e;k[C>>2]=-2147483648;k[j>>2]=2147483647;H1(D,F,B,C);e=(k[E>>2]|0)+(f*56|0)|0;c=m;k[c>>2]=0;k[c+4>>2]=0;k[B>>2]=33619968;k[l>>2]=D;mY(e,B);e=k[(k[E>>2]|0)+(f*56|0)+8>>2]|0;c=k[n>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[n>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[u>>2]|0;if(!c){c=B1()|0;d=k[n>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[n>>2]=0}k[n>>2]=0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[p>>2]|0)>0){d=k[q>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[p>>2]|0))}c=k[s>>2]|0;if(!((c|0)==(t|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=f+1|0;c=k[z>>2]|0;if(f>>>0>=(((k[A>>2]|0)-c|0)/56|0)>>>0)break;else g=e+g|0}}Ph[k[(k[b>>2]|0)+16>>2]&511](a,b,F);e=F+36|0;c=k[e>>2]|0;if(c|0?(D=c+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[F+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;F=F+16|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[y>>2]|0)>0){d=k[w>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[y>>2]|0))}c=k[v>>2]|0;if((c|0)==(x|0)|(c|0)==0){r=G;return}ggb(k[c+-4>>2]|0);r=G;return}function nUa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0;s=r;r=r+112|0;l=s+48|0;f=s+32|0;g=s+16|0;h=s;k[l>>2]=1124007936;q=l+4|0;d=l+8|0;m=l+40|0;i=q;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[m>>2]=d;o=l+48|0;n=l+44|0;k[n>>2]=o;k[l+52>>2]=0;k[o>>2]=0;k[a>>2]=1124007936;d=a+8|0;e=a+40|0;i=a+4|0;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[e>>2]=d;i=a+48|0;k[a+44>>2]=i;k[a+52>>2]=0;k[i>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=c;i=k[b+20>>2]|0;j=g+4|0;d=j+4|0;k[d>>2]=0;k[d+4>>2]=0;k[g>>2]=50397184;k[j>>2]=l;j=k[b+40>>2]|0;d=k[b+44>>2]|0;c=h+4|0;e=c+4|0;k[e>>2]=0;k[e+4>>2]=0;k[h>>2]=33619968;k[c>>2]=a;+xZ(f,i,g,k[b+24>>2]|0,k[b+28>>2]|0,+p[b+32>>3],j,d,h);a=l+36|0;d=k[a>>2]|0;if(d|0?(i=d+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){e=k[a>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[l+32>>2]|0;if(!d){d=B1()|0;e=k[a>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[a>>2]=0}k[a>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[q>>2]|0)>0){e=k[m>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[q>>2]|0))}d=k[n>>2]|0;if((d|0)==(o|0)|(d|0)==0){r=s;return}ggb(k[d+-4>>2]|0);r=s;return}function oUa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=141236;b=a+68|0;c=k[b>>2]|0;if(c|0?(e=c+4|0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+72>>2]=0;b=a+60|0;c=k[b>>2]|0;if(c|0?(d=c+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+64>>2]=0;d=a+40|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+20|0;c=a+8|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function pUa(a){a=a|0;oUa(a);ggb(a);return}function qUa(a){a=a|0;return a+4|0}function rUa(a){a=a|0;if((k[a+4>>2]|0)==(k[a+8>>2]|0)){a=0;return a|0}a=k[a+16>>2]|0;return a|0}function sUa(a){a=a|0;return a+4|0}function tUa(a){a=a|0;var b=0,c=0,d=0,e=0;if(!(k[a+20>>2]|0)){a=0;return a|0}d=k[a+8>>2]|0;if((d|0)<3)b=aa(k[a+16>>2]|0,k[a+12>>2]|0)|0;else{e=k[a+44>>2]|0;c=0;b=1;do{b=aa(k[e+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(d|0))}if(!b){a=0;return a|0}a=k[a+12>>2]|0;return a|0}function uUa(a){a=a|0;return 5}function vUa(a){a=a|0;return}function wUa(a){a=a|0;ggb(a);return}function xUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;e=g+4|0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=13;i[d+17>>0]=0;d=385149;f=c+13|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);EUa(c,a+4|0);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=12;i[d+16>>0]=0;d=385163;f=c+12|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);EUa(c,a+8|0);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=12;i[d+16>>0]=0;d=385176;f=c+12|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);EUa(c,a+12|0);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(24)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=16;i[d+20>>0]=0;d=385189;f=c+16|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);k[g>>2]=k[a+16>>2];FUa(c,g);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(24)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=19;i[d+23>>0]=0;d=385206;f=c+19|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);EUa(c,a+20|0);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=13;i[d+17>>0]=0;d=385226;f=c+13|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);k[g>>2]=l[a+24>>0];FUa(c,g);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=9;i[d+13>>0]=0;d=385240;f=c+9|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);k[g>>2]=l[a+25>>0];FUa(c,g);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=12;i[d+16>>0]=0;d=385250;f=c+12|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);k[g>>2]=l[a+26>>0];FUa(c,g);k[g>>2]=0;f=g+4|0;k[f>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[f>>2]=7;i[d+11>>0]=0;i[c>>0]=i[385263]|0;i[c+1>>0]=i[385264]|0;i[c+2>>0]=i[385265]|0;i[c+3>>0]=i[385266]|0;i[c+4>>0]=i[385267]|0;i[c+5>>0]=i[385268]|0;i[c+6>>0]=i[385269]|0;c=z6(b,g)|0;d=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);EUa(c,a+28|0);k[g>>2]=0;f=g+4|0;k[f>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[f>>2]=7;i[d+11>>0]=0;i[c>>0]=i[385271]|0;i[c+1>>0]=i[385272]|0;i[c+2>>0]=i[385273]|0;i[c+3>>0]=i[385274]|0;i[c+4>>0]=i[385275]|0;i[c+5>>0]=i[385276]|0;i[c+6>>0]=i[385277]|0;c=z6(b,g)|0;d=k[g>>2]|0;k[f>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);EUa(c,a+32|0);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(24)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=19;i[d+23>>0]=0;d=385279;f=c+19|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);k[g>>2]=l[a+36>>0];FUa(c,g);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=14;i[d+18>>0]=0;d=385299;f=c+14|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);EUa(c,a+40|0);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=14;i[d+18>>0]=0;d=385314;f=c+14|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);EUa(c,a+44|0);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=15;i[d+19>>0]=0;d=385329;f=c+15|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);k[g>>2]=l[a+48>>0];FUa(c,g);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=15;i[d+19>>0]=0;d=385345;f=c+15|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);EUa(c,a+52|0);k[g>>2]=0;e=g+4|0;k[e>>2]=0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=15;i[d+19>>0]=0;d=385361;f=c+15|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);EUa(c,a+56|0);e=g+4|0;d=ZT(24)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=17;i[d+21>>0]=0;d=385377;f=c+17|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);k[g>>2]=l[a+60>>0];FUa(c,g);e=g+4|0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=12;i[d+16>>0]=0;d=385395;f=c+12|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(d|0?(e=d+-4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);EUa(c,a+64|0);e=g+4|0;d=ZT(20)|0;k[d>>2]=1;c=d+4|0;k[g>>2]=c;k[e>>2]=12;i[d+16>>0]=0;d=385408;f=c+12|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(f|0));c=z6(b,g)|0;d=k[g>>2]|0;k[e>>2]=0;k[g>>2]=0;if(!d){g=a+68|0;EUa(c,g);r=h;return}b=d+-4|0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)!=1){g=a+68|0;EUa(c,g);r=h;return}ggb(k[d+-8>>2]|0);g=a+68|0;EUa(c,g);r=h;return}function yUa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0;e=b+4|0;c=k6(k[b>>2]|0,k[e>>2]|0,385149)|0;a:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break a}case 2:{d=+p[c+8>>3];break a}default:{d=1000000015047466219876688.0e6;break a}}while(0);o[a+4>>2]=d;c=k6(k[b>>2]|0,k[e>>2]|0,385163)|0;b:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break b}case 2:{d=+p[c+8>>3];break b}default:{d=1000000015047466219876688.0e6;break b}}while(0);o[a+8>>2]=d;c=k6(k[b>>2]|0,k[e>>2]|0,385176)|0;c:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break c}case 2:{d=+p[c+8>>3];break c}default:{d=1000000015047466219876688.0e6;break c}}while(0);o[a+12>>2]=d;c=k6(k[b>>2]|0,k[e>>2]|0,385189)|0;d:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break d}case 2:break;default:{c=2147483647;break d}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);k[a+16>>2]=c;c=k6(k[b>>2]|0,k[e>>2]|0,385206)|0;e:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break e}case 2:{d=+p[c+8>>3];break e}default:{d=1000000015047466219876688.0e6;break e}}while(0);o[a+20>>2]=d;c=k6(k[b>>2]|0,k[e>>2]|0,385226)|0;f:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break f}case 2:break;default:{c=2147483647;break f}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);i[a+24>>0]=(c|0)!=0&1;c=k6(k[b>>2]|0,k[e>>2]|0,385240)|0;g:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break g}case 2:break;default:{c=2147483647;break g}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);i[a+25>>0]=c;c=k6(k[b>>2]|0,k[e>>2]|0,385250)|0;h:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break h}case 2:break;default:{c=2147483647;break h}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);i[a+26>>0]=(c|0)!=0&1;c=k6(k[b>>2]|0,k[e>>2]|0,385263)|0;i:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break i}case 2:{d=+p[c+8>>3];break i}default:{d=1000000015047466219876688.0e6;break i}}while(0);o[a+28>>2]=d;c=k6(k[b>>2]|0,k[e>>2]|0,385271)|0;j:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break j}case 2:{d=+p[c+8>>3];break j}default:{d=1000000015047466219876688.0e6;break j}}while(0);o[a+32>>2]=d;c=k6(k[b>>2]|0,k[e>>2]|0,385279)|0;k:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break k}case 2:break;default:{c=2147483647;break k}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);i[a+36>>0]=(c|0)!=0&1;c=k6(k[b>>2]|0,k[e>>2]|0,385299)|0;l:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break l}case 2:{d=+p[c+8>>3];break l}default:{d=1000000015047466219876688.0e6;break l}}while(0);o[a+40>>2]=d;c=k6(k[b>>2]|0,k[e>>2]|0,385314)|0;m:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break m}case 2:{d=+p[c+8>>3];break m}default:{d=1000000015047466219876688.0e6;break m}}while(0);o[a+44>>2]=d;c=k6(k[b>>2]|0,k[e>>2]|0,385329)|0;n:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break n}case 2:break;default:{c=2147483647;break n}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}c=~~d}while(0);i[a+48>>0]=(c|0)!=0&1;c=k6(k[b>>2]|0,k[e>>2]|0,385345)|0;o:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break o}case 2:{d=+p[c+8>>3];break o}default:{d=1000000015047466219876688.0e6;break o}}while(0);o[a+52>>2]=d;c=k6(k[b>>2]|0,k[e>>2]|0,385361)|0;p:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break p}case 2:{d=+p[c+8>>3];break p}default:{d=1000000015047466219876688.0e6;break p}}while(0);o[a+56>>2]=d;c=k6(k[b>>2]|0,k[e>>2]|0,385377)|0;q:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break q}case 2:break;default:{c=2147483647;break q}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;f=c&2146435072;do if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(!(d==0.0))break;d=c?-0.0:0.0}while(0);c=~~d}while(0);i[a+60>>0]=(c|0)!=0&1;c=k6(k[b>>2]|0,k[e>>2]|0,385395)|0;r:do if(!c)d=0.0;else switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);break r}case 2:{d=+p[c+8>>3];break r}default:{d=1000000015047466219876688.0e6;break r}}while(0);o[a+64>>2]=d;c=k6(k[b>>2]|0,k[e>>2]|0,385408)|0;if(!c){d=0.0;f=a+68|0;o[f>>2]=d;return}switch(k[c>>2]&7){case 1:{d=+(k[c+8>>2]|0);f=a+68|0;o[f>>2]=d;return}case 2:{d=+p[c+8>>3];f=a+68|0;o[f>>2]=d;return}default:{d=1000000015047466219876688.0e6;f=a+68|0;o[f>>2]=d;return}}}function zUa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0.0,n=0.0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0;pa=r;r=r+224|0;oa=pa+160|0;fa=pa+104|0;ja=pa+48|0;ca=pa+32|0;da=pa+16|0;ea=pa;d=k[c>>2]|0;ia=c+4|0;e=k[ia>>2]|0;if((e|0)!=(d|0))k[ia>>2]=e+(~(((e+-28-d|0)>>>0)/28|0)*28|0);k[oa>>2]=1124007936;ma=oa+4|0;d=oa+8|0;ka=oa+40|0;f=ma;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[ka>>2]=d;na=oa+48|0;la=oa+44|0;k[la>>2]=na;k[oa+52>>2]=0;k[na>>2]=0;if(((S1(b,-1)|0)&4088|0)!=16){do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[fa>>2]=k[f>>2];l=fa+4|0;d=f+4|0;k[l>>2]=k[d>>2];ha=fa+8|0;k[ha>>2]=k[f+8>>2];k[fa+12>>2]=k[f+12>>2];k[fa+16>>2]=k[f+16>>2];k[fa+20>>2]=k[f+20>>2];k[fa+24>>2]=k[f+24>>2];k[fa+28>>2]=k[f+28>>2];k[fa+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[fa+36>>2]=e;b=fa+40|0;k[b>>2]=ha;ha=fa+48|0;h=fa+44|0;k[h>>2]=ha;k[fa+52>>2]=0;k[ha>>2]=0;if(e|0){ha=e+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[d>>2]|0)<3){ba=k[f+44>>2]|0;ha=k[h>>2]|0;k[ha>>2]=k[ba>>2];k[ha+4>>2]=k[ba+4>>2];break}k[l>>2]=0;x1(fa,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[b>>2]|0;b=k[f+44>>2]|0;e=k[h>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[b+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else Q1(fa,b,-1);while(0);KG(oa,fa)|0;b=fa+36|0;d=k[b>>2]|0;if(d|0?(ba=d+12|0,ha=k[ba>>2]|0,k[ba>>2]=ha+-1,(ha|0)==1):0){e=k[b>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[fa+32>>2]|0;if(!d){d=B1()|0;e=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[b>>2]=0}k[b>>2]=0;ha=fa+16|0;e=fa+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[e>>2]|0)>0){b=k[fa+40>>2]|0;d=0;do{k[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[fa+44>>2]|0;if(!((d|0)==(fa+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}else{ha=fa+4|0;ba=ha+4|0;k[ba>>2]=0;k[ba+4>>2]=0;k[fa>>2]=33619968;k[ha>>2]=oa;$aa(b,fa,6,0)}if(k[oa>>2]&4095|0){k[fa>>2]=0;d=fa+4|0;k[d>>2]=0;e=ZT(48)|0;k[e>>2]=1;f=e+4|0;k[fa>>2]=f;k[d>>2]=41;i[e+45>>0]=0;b=385030;g=f+41|0;do{i[f>>0]=i[b>>0]|0;f=f+1|0;b=b+1|0}while((f|0)<(g|0));Y8(-210,fa,386843,385072,315);k[d>>2]=0;k[fa>>2]=0;ha=k[e>>2]|0;k[e>>2]=ha+-1;if((ha|0)==1)ggb(k[e+-4>>2]|0)}k[fa>>2]=0;ha=fa+4|0;k[ha>>2]=0;k[fa+8>>2]=0;m=+o[a+8>>2];v=a+12|0;if(m<+o[v>>2]){w=ja+4|0;x=ja+8|0;y=ja+40|0;z=ja+48|0;A=ja+44|0;B=ja+52|0;E=ca+8|0;F=ca+12|0;G=ca+4|0;H=da+4|0;I=H+4|0;J=ca+4|0;K=ca+8|0;L=da+8|0;M=da+12|0;N=da+4|0;O=ea+8|0;P=ea+12|0;R=ea+4|0;S=da+4|0;T=da+8|0;U=ja+36|0;V=ja+16|0;W=a+4|0;X=fa+8|0;Y=ea+4|0;Z=ea+8|0;_=ea+8|0;$=da+8|0;aa=a+20|0;ba=ja+32|0;do{k[ja>>2]=1124007936;f=w;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[y>>2]=x;k[A>>2]=z;k[B>>2]=0;k[z>>2]=0;k[E>>2]=0;k[F>>2]=0;k[ca>>2]=16842752;k[G>>2]=oa;d=I;k[d>>2]=0;k[d+4>>2]=0;k[da>>2]=33619968;k[H>>2]=ja;+Yua(ca,da,m,255.0,0);k[ca>>2]=0;k[J>>2]=0;k[K>>2]=0;d=k[(k[a>>2]|0)+64>>2]|0;k[L>>2]=0;k[M>>2]=0;k[da>>2]=16842752;k[N>>2]=oa;k[O>>2]=0;k[P>>2]=0;k[ea>>2]=16842752;k[R>>2]=ja;dh[d&255](a,da,ea,ca);k[da>>2]=0;k[S>>2]=0;k[T>>2]=0;d=k[ca>>2]|0;if((k[J>>2]|0)!=(d|0)){u=0;do{e=k[ha>>2]|0;b=k[fa>>2]|0;l=b;a:do if((e|0)==(b|0))ga=51;else{C=+p[d+(u<<5)>>3];D=+p[d+(u<<5)+8>>3];q=+o[aa>>2];s=d+(u<<5)+16|0;g=(e-b|0)/12|0;t=0;while(1){h=l+(t*12|0)|0;j=l+(t*12|0)+4|0;e=k[j>>2]|0;b=k[h>>2]|0;f=e-b>>5>>>1;qa=+p[b+(f<<5)>>3]-C;n=+p[b+(f<<5)+8>>3]-D;n=+Q(+(qa*qa+n*n));if(!(n>=q))break;if(!(n>=+p[b+(f<<5)+16>>3]))break;if(!(n>=+p[s>>3]))break;e=t+1|0;if(e>>>0<g>>>0)t=e;else{ga=51;break a}}if((e|0)==(k[l+(t*12|0)+8>>2]|0)){BUa(h,d+(u<<5)|0);e=k[fa>>2]|0;d=e;e=k[e+(t*12|0)+4>>2]|0}else{p[e>>3]=C;p[e+8>>3]=D;e=e+16|0;k[e>>2]=k[s>>2];k[e+4>>2]=k[s+4>>2];k[e+8>>2]=k[s+8>>2];k[e+12>>2]=k[s+12>>2];e=(k[j>>2]|0)+32|0;k[j>>2]=e;d=l}b=k[d+(t*12|0)>>2]|0;d=e-b>>5;e=d+-1|0;b:do if(!e)d=b+(e<<5)|0;else{h=(k[fa>>2]|0)+(t*12|0)|0;f=b;g=k[h>>2]|0;while(1){b=d+-2|0;d=g+(e<<5)|0;if(!(+p[f+(e<<5)+16>>3]<+p[f+(b<<5)+16>>3]))break b;p[d>>3]=+p[g+(b<<5)>>3];p[g+(e<<5)+8>>3]=+p[g+(b<<5)+8>>3];d=g+(e<<5)+16|0;t=g+(b<<5)+16|0;k[d>>2]=k[t>>2];k[d+4>>2]=k[t+4>>2];k[d+8>>2]=k[t+8>>2];k[d+12>>2]=k[t+12>>2];d=e+-1|0;g=k[h>>2]|0;if(!d){d=g;break}else{t=e;e=d;f=g;d=t}}}while(0);t=k[ca>>2]|0;p[d>>3]=+p[t+(u<<5)>>3];p[d+8>>3]=+p[t+(u<<5)+8>>3];d=d+16|0;s=t+(u<<5)+16|0;k[d>>2]=k[s>>2];k[d+4>>2]=k[s+4>>2];k[d+8>>2]=k[s+8>>2];k[d+12>>2]=k[s+12>>2];d=t}while(0);if((ga|0)==51){ga=0;k[ea>>2]=0;k[Y>>2]=0;k[Z>>2]=0;while(1){e=fgb(32)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[ea>>2]=e;t=e+32|0;k[_>>2]=t;s=d+(u<<5)+16|0;p[e>>3]=+p[d+(u<<5)>>3];p[e+8>>3]=+p[d+(u<<5)+8>>3];d=e+16|0;k[d>>2]=k[s>>2];k[d+4>>2]=k[s+4>>2];k[d+8>>2]=k[s+8>>2];k[d+12>>2]=k[s+12>>2];k[Y>>2]=t;d=k[S>>2]|0;if((d|0)==(k[$>>2]|0))DUa(da,ea);else{CUa(d,ea);k[S>>2]=d+12}if(e|0){k[Y>>2]=e;ggb(e)}d=k[ca>>2]|0}u=u+1|0}while(u>>>0<(k[J>>2]|0)-d>>5>>>0);h=k[da>>2]|0;d=k[S>>2]|0;e=(h|0)==(d|0);if(!e){f=h;do{b=k[ha>>2]|0;if((b|0)==(k[X>>2]|0))DUa(fa,f);else{CUa(b,f);k[ha>>2]=b+12}f=f+12|0}while((f|0)!=(d|0))}if(h|0){if(!e){do{e=d;d=d+-12|0;f=k[d>>2]|0;g=f;if(f|0){e=e+-8|0;b=k[e>>2]|0;if((b|0)!=(f|0))k[e>>2]=b+(~((b+-32-g|0)>>>5)<<5);ggb(f)}}while((d|0)!=(h|0));k[S>>2]=h}ggb(h)}}d=k[ca>>2]|0;e=d;if(d|0){b=k[J>>2]|0;if((b|0)!=(d|0))k[J>>2]=b+(~((b+-32-e|0)>>>5)<<5);ggb(d)}d=k[U>>2]|0;if(d|0?(t=d+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){e=k[U>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[ba>>2]|0;if(!d){d=B1()|0;e=k[U>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[U>>2]=0}k[U>>2]=0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[w>>2]|0)>0){e=k[y>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[w>>2]|0))}d=k[A>>2]|0;if(!((d|0)==(z|0)|(d|0)==0))ggb(k[d+-4>>2]|0);m=m+ +o[W>>2]}while(m<+o[v>>2]);e=k[ha>>2]|0;d=k[fa>>2]|0;A=d;B=d;if((e|0)!=(d|0)){l=a+16|0;s=ja+4|0;t=ja+8|0;u=ja+12|0;v=ja+16|0;w=ja+20|0;x=ja+24|0;y=c+8|0;z=(e-d|0)/12|0;j=0;do{b=k[A+(j*12|0)+4>>2]|0;f=k[A+(j*12|0)>>2]|0;g=b-f>>5;h=f;if(g>>>0>=(k[l>>2]|0)>>>0){if((b|0)==(f|0)){q=0.0;m=0.0;n=0.0}else{b=0;q=0.0;m=0.0;n=0.0;do{qa=+p[h+(b<<5)+24>>3];m=m+qa*+p[h+(b<<5)>>3];n=n+qa*+p[h+(b<<5)+8>>3];q=q+qa;b=b+1|0}while(b>>>0<g>>>0)}qa=1.0/q;q=m*qa;m=n*qa;qa=+p[h+(g>>>1<<5)+16>>3]*2.0;o[ja>>2]=q;o[s>>2]=m;o[t>>2]=qa;o[u>>2]=-1.0;o[v>>2]=0.0;k[w>>2]=0;k[x>>2]=-1;b=k[ia>>2]|0;if((b|0)==(k[y>>2]|0))H6(c,ja);else{o[b>>2]=q;o[b+4>>2]=m;a=b+8|0;k[a>>2]=k[t>>2];k[a+4>>2]=k[t+4>>2];k[a+8>>2]=k[t+8>>2];k[a+12>>2]=k[t+12>>2];k[a+16>>2]=k[t+16>>2];k[ia>>2]=(k[ia>>2]|0)+28}}j=j+1|0}while(j>>>0<z>>>0)}if(d|0){if((e|0)!=(A|0)){do{d=e;e=e+-12|0;f=k[e>>2]|0;g=f;if(f|0){d=d+-8|0;b=k[d>>2]|0;if((b|0)!=(f|0))k[d>>2]=b+(~((b+-32-g|0)>>>5)<<5);ggb(f)}}while((e|0)!=(A|0));k[ha>>2]=A;d=B}ggb(d)}}b=oa+36|0;d=k[b>>2]|0;if(d|0?(ja=d+12|0,c=k[ja>>2]|0,k[ja>>2]=c+-1,(c|0)==1):0){e=k[b>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[oa+32>>2]|0;if(!d){d=B1()|0;e=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[b>>2]=0}k[b>>2]=0;oa=oa+16|0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[ma>>2]|0)>0){e=k[ka>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[ma>>2]|0))}d=k[la>>2]|0;if((d|0)==(na|0)|(d|0)==0){r=pa;return}ggb(k[d+-4>>2]|0);r=pa;return}
function gW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,l=0,m=0,n=0,o=0;i=k[g>>2]|0;g=k[g+4>>2]|0;l=b>>>1;f=f>>>1;d=g+-1|0;if(!g)return;if((i|0)<4){if((i|0)>0)h=e;else return;while(1){c=0;do{e=j[a+(c<<1)>>1]|0;j[h+(c<<1)>>1]=(e|0)<0?0:e;c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<1)|0;a=a+(l<<1)|0;d=d+-1|0}}return}g=i+-4|0;b=((g|0)>3?g:3)+4&-4;if((b|0)<(i|0))h=e;else{h=e;while(1){c=0;do{i=j[a+(c<<1)>>1]|0;b=c|1;m=j[a+(b<<1)>>1]|0;j[h+(c<<1)>>1]=(i|0)<0?0:i;j[h+(b<<1)>>1]=(m|0)<0?0:m;b=c|2;m=j[a+(b<<1)>>1]|0;i=c|3;e=j[a+(i<<1)>>1]|0;j[h+(b<<1)>>1]=(m|0)<0?0:m;j[h+(i<<1)>>1]=(e|0)<0?0:e;c=c+4|0}while((c|0)<=(g|0));if(!d)break;else{h=h+(f<<1)|0;a=a+(l<<1)|0;d=d+-1|0}}return}while(1){c=0;do{m=j[a+(c<<1)>>1]|0;n=c|1;o=j[a+(n<<1)>>1]|0;j[h+(c<<1)>>1]=(m|0)<0?0:m;j[h+(n<<1)>>1]=(o|0)<0?0:o;n=c|2;o=j[a+(n<<1)>>1]|0;m=c|3;e=j[a+(m<<1)>>1]|0;j[h+(n<<1)>>1]=(o|0)<0?0:o;j[h+(m<<1)>>1]=(e|0)<0?0:e;c=c+4|0}while((c|0)<=(g|0));c=b;do{o=j[a+(c<<1)>>1]|0;j[h+(c<<1)>>1]=(o|0)<0?0:o;c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<1)|0;a=a+(l<<1)|0;d=d+-1|0}}return}function hW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,l=0,m=0,n=0,o=0,p=0;n=k[g>>2]|0;d=k[g+4>>2]|0;m=b>>>2;l=f>>>1;if(!d)return;b=n+-4|0;f=((b|0)>3?b:3)+4&-4;if((n|0)<4){b=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(b){c=0;do{a=k[h+(c<<2)>>2]|0;j[g+(c<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(l<<1)|0;h=h+(m<<2)|0}}return}i=(f|0)<(n|0);g=e;h=a;while(1){c=0;do{a=k[h+(c<<2)>>2]|0;o=c|1;p=k[h+(o<<2)>>2]|0;j[g+(c<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;j[g+(o<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;o=c|2;p=k[h+(o<<2)>>2]|0;a=c|3;e=k[h+(a<<2)>>2]|0;j[g+(o<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;j[g+(a<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(i){c=f;do{p=k[h+(c<<2)>>2]|0;j[g+(c<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(l<<1)|0;h=h+(m<<2)|0}}return}function iW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0,n=0,p=0,q=0;m=k[g>>2]|0;n=k[g+4>>2]|0;q=b>>>2;p=f>>>1;h=n+-1|0;if(!n)return;if((m|0)<4){if((m|0)>0){g=e;b=a}else return;while(1){d=0;do{i=+o[b+(d<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}n=~~i;j[g+(d<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;d=d+1|0}while((d|0)!=(m|0));if(!h)break;else{g=g+(p<<1)|0;b=b+(q<<2)|0;h=h+-1|0}}return}n=m+-4|0;l=((n|0)>3?n:3)+4&-4;if((l|0)>=(m|0)){while(1){f=0;do{i=+o[a+(f<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;b=f|1;i=+o[a+(b<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}g=~~i;j[e+(f<<1)>>1]=d;j[e+(b<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=f|2;i=+o[a+(g<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;b=f|3;i=+o[a+(b<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}m=~~i;j[e+(g<<1)>>1]=d;j[e+(b<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;f=f+4|0}while((f|0)<=(n|0));if(!h)break;else{e=e+(p<<1)|0;a=a+(q<<2)|0;h=h+-1|0}}return}while(1){f=0;do{i=+o[a+(f<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;b=f|1;i=+o[a+(b<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}g=~~i;j[e+(f<<1)>>1]=d;j[e+(b<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=f|2;i=+o[a+(g<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;b=f|3;i=+o[a+(b<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}c=~~i;j[e+(g<<1)>>1]=d;j[e+(b<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;f=f+4|0}while((f|0)<=(n|0));d=l;do{i=+o[a+(d<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}f=~~i;j[e+(d<<1)>>1]=f>>>0<65536?f:(f|0)>0?65535:0;d=d+1|0}while((d|0)!=(m|0));if(!h)break;else{e=e+(p<<1)|0;a=a+(q<<2)|0;h=h+-1|0}}return}function jW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0,n=0,o=0,q=0,r=0;m=k[g>>2]|0;n=k[g+4>>2]|0;q=b>>>3;o=f>>>1;h=n+-1|0;if(!n)return;if((m|0)<4){if((m|0)>0){g=e;b=a}else return;while(1){d=0;do{i=+p[b+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;n=c&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}n=~~i;j[g+(d<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;d=d+1|0}while((d|0)!=(m|0));if(!h)break;else{g=g+(o<<1)|0;b=b+(q<<3)|0;h=h+-1|0}}return}n=m+-4|0;l=((n|0)>3?n:3)+4&-4;if((l|0)>=(m|0)){while(1){f=0;do{i=+p[a+(f<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;m=c&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;b=f|1;i=+p[a+(b<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;m=c&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}g=~~i;j[e+(f<<1)>>1]=d;j[e+(b<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=f|2;i=+p[a+(g<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;m=c&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;b=f|3;i=+p[a+(b<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;m=c&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}m=~~i;j[e+(g<<1)>>1]=d;j[e+(b<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;f=f+4|0}while((f|0)<=(n|0));if(!h)break;else{e=e+(o<<1)|0;a=a+(q<<3)|0;h=h+-1|0}}return}while(1){f=0;do{i=+p[a+(f<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;g=c&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;b=f|1;i=+p[a+(b<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;g=c&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}g=~~i;j[e+(f<<1)>>1]=d;j[e+(b<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=f|2;i=+p[a+(g<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;b=f|3;i=+p[a+(b<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;r=c&2146435072;if(!(r>>>0>1126170624|(r|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}r=~~i;j[e+(g<<1)>>1]=d;j[e+(b<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;f=f+4|0}while((f|0)<=(n|0));d=l;do{i=+p[a+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;r=c&2146435072;if(!(r>>>0>1126170624|(r|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}r=~~i;j[e+(d<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d=d+1|0}while((d|0)!=(m|0));if(!h)break;else{e=e+(o<<1)|0;a=a+(q<<3)|0;h=h+-1|0}}return}function kW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,m=0,n=0,o=0,p=0;o=k[g>>2]|0;d=k[g+4>>2]|0;n=f>>>1;if(!d)return;f=o+-4|0;if((o|0)<4){f=(o|0)>0;g=e;h=a;while(1){d=d+-1|0;if(f){c=0;do{j[g+(c<<1)>>1]=l[h+c>>0]|0;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+(n<<1)|0;h=h+b|0}}return}i=o&-4;m=(i|0)<(o|0);g=e;h=a;while(1){c=0;do{p=c|1;a=l[h+p>>0]|0;j[g+(c<<1)>>1]=l[h+c>>0]|0;j[g+(p<<1)>>1]=a;p=c|2;a=c|3;e=l[h+a>>0]|0;j[g+(p<<1)>>1]=l[h+p>>0]|0;j[g+(a<<1)>>1]=e;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(m){c=i;do{j[g+(c<<1)>>1]=l[h+c>>0]|0;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+(n<<1)|0;h=h+b|0}}return}function lW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0,m=0,n=0,o=0,p=0;o=k[g>>2]|0;d=k[g+4>>2]|0;n=f>>>1;if(!d)return;f=o+-4|0;if((o|0)<4){f=(o|0)>0;g=e;h=a;while(1){d=d+-1|0;if(f){c=0;do{j[g+(c<<1)>>1]=i[h+c>>0]|0;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+(n<<1)|0;h=h+b|0}}return}l=o&-4;m=(l|0)<(o|0);g=e;h=a;while(1){c=0;do{p=c|1;a=i[h+p>>0]|0;j[g+(c<<1)>>1]=i[h+c>>0]|0;j[g+(p<<1)>>1]=a;p=c|2;a=c|3;e=i[h+a>>0]|0;j[g+(p<<1)>>1]=i[h+p>>0]|0;j[g+(a<<1)>>1]=e;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(m){c=l;do{j[g+(c<<1)>>1]=i[h+c>>0]|0;c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{g=g+(n<<1)|0;h=h+b|0}}return}function mW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,l=0,n=0,o=0,p=0;i=k[g>>2]|0;g=k[g+4>>2]|0;l=b>>>1;f=f>>>1;d=g+-1|0;if(!g)return;if((i|0)<4){if((i|0)>0)h=e;else return;while(1){c=0;do{e=m[a+(c<<1)>>1]|0;j[h+(c<<1)>>1]=e>>>0>32767?32767:e;c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<1)|0;a=a+(l<<1)|0;d=d+-1|0}}return}g=i+-4|0;b=((g|0)>3?g:3)+4&-4;if((b|0)<(i|0))h=e;else{h=e;while(1){c=0;do{i=m[a+(c<<1)>>1]|0;b=c|1;n=m[a+(b<<1)>>1]|0;j[h+(c<<1)>>1]=i>>>0>32767?32767:i;j[h+(b<<1)>>1]=n>>>0>32767?32767:n;b=c|2;n=m[a+(b<<1)>>1]|0;i=c|3;e=m[a+(i<<1)>>1]|0;j[h+(b<<1)>>1]=n>>>0>32767?32767:n;j[h+(i<<1)>>1]=e>>>0>32767?32767:e;c=c+4|0}while((c|0)<=(g|0));if(!d)break;else{h=h+(f<<1)|0;a=a+(l<<1)|0;d=d+-1|0}}return}while(1){c=0;do{n=m[a+(c<<1)>>1]|0;o=c|1;p=m[a+(o<<1)>>1]|0;j[h+(c<<1)>>1]=n>>>0>32767?32767:n;j[h+(o<<1)>>1]=p>>>0>32767?32767:p;o=c|2;p=m[a+(o<<1)>>1]|0;n=c|3;e=m[a+(n<<1)>>1]|0;j[h+(o<<1)>>1]=p>>>0>32767?32767:p;j[h+(n<<1)>>1]=e>>>0>32767?32767:e;c=c+4|0}while((c|0)<=(g|0));c=b;do{p=m[a+(c<<1)>>1]|0;j[h+(c<<1)>>1]=p>>>0>32767?32767:p;c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<1)|0;a=a+(l<<1)|0;d=d+-1|0}}return}function nW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,l=0,m=0,n=0,o=0,p=0;n=k[g>>2]|0;d=k[g+4>>2]|0;m=b>>>2;l=f>>>1;if(!d)return;b=n+-4|0;f=((b|0)>3?b:3)+4&-4;if((n|0)<4){b=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(b){c=0;do{a=k[h+(c<<2)>>2]|0;j[g+(c<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(l<<1)|0;h=h+(m<<2)|0}}return}i=(f|0)<(n|0);g=e;h=a;while(1){c=0;do{a=k[h+(c<<2)>>2]|0;o=c|1;p=k[h+(o<<2)>>2]|0;j[g+(c<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;j[g+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;o=c|2;p=k[h+(o<<2)>>2]|0;a=c|3;e=k[h+(a<<2)>>2]|0;j[g+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;j[g+(a<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(i){c=f;do{p=k[h+(c<<2)>>2]|0;j[g+(c<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(l<<1)|0;h=h+(m<<2)|0}}return}function oW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0;m=k[g>>2]|0;c=k[g+4>>2]|0;l=b>>>2;b=f>>>1;if((m|0)>0&(c|0)!=0){g=a;h=c}else return;while(1){d=0;do{i=+o[g+(d<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}a=~~i;j[e+(d<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d=d+1|0}while((d|0)!=(m|0));h=h+-1|0;if(!h)break;else{e=e+(b<<1)|0;g=g+(l<<2)|0}}return}function pW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;r=k[g>>2]|0;n=k[g+4>>2]|0;q=b>>>3;o=f>>>1;h=n+-1|0;if(!n)return;if((r|0)<4){if((r|0)>0){g=e;b=a}else return;while(1){d=0;do{i=+p[b+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;n=c&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}n=~~i;j[g+(d<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;d=d+1|0}while((d|0)!=(r|0));if(!h)break;else{g=g+(o<<1)|0;b=b+(q<<3)|0;h=h+-1|0}}return}l=r+-4|0;m=((l|0)>3?l:3)+4&-4;n=(m|0)<(r|0);while(1){f=0;do{i=+p[a+(f<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;g=c&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;b=f|1;i=+p[a+(b<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;g=c&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}g=~~i;j[e+(f<<1)>>1]=d;j[e+(b<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=f|2;i=+p[a+(g<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;b=f|3;i=+p[a+(b<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;s=c&2146435072;if(!(s>>>0>1126170624|(s|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}s=~~i;j[e+(g<<1)>>1]=d;j[e+(b<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;f=f+4|0}while((f|0)<=(l|0));if(n){d=m;do{i=+p[a+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;s=c&2146435072;if(!(s>>>0>1126170624|(s|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}s=~~i;j[e+(d<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d=d+1|0}while((d|0)!=(r|0))}if(!h)break;else{e=e+(o<<1)|0;a=a+(q<<3)|0;h=h+-1|0}}return}function qW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,m=0,n=0,o=0;n=k[g>>2]|0;d=k[g+4>>2]|0;m=f>>>2;if(!d)return;f=n+-4|0;if((n|0)<4){f=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(f){c=0;do{k[g+(c<<2)>>2]=l[h+c>>0];c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(m<<2)|0;h=h+b|0}}return}i=n&-4;j=(i|0)<(n|0);g=e;h=a;while(1){c=0;do{o=c|1;a=l[h+o>>0]|0;k[g+(c<<2)>>2]=l[h+c>>0];k[g+(o<<2)>>2]=a;o=c|2;a=c|3;e=l[h+a>>0]|0;k[g+(o<<2)>>2]=l[h+o>>0];k[g+(a<<2)>>2]=e;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(j){c=i;do{k[g+(c<<2)>>2]=l[h+c>>0];c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(m<<2)|0;h=h+b|0}}return}function rW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0;n=k[g>>2]|0;d=k[g+4>>2]|0;m=f>>>2;if(!d)return;f=n+-4|0;if((n|0)<4){f=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(f){c=0;do{k[g+(c<<2)>>2]=i[h+c>>0];c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(m<<2)|0;h=h+b|0}}return}j=n&-4;l=(j|0)<(n|0);g=e;h=a;while(1){c=0;do{o=c|1;a=i[h+o>>0]|0;k[g+(c<<2)>>2]=i[h+c>>0];k[g+(o<<2)>>2]=a;o=c|2;a=c|3;e=i[h+a>>0]|0;k[g+(o<<2)>>2]=i[h+o>>0];k[g+(a<<2)>>2]=e;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(l){c=j;do{k[g+(c<<2)>>2]=i[h+c>>0];c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(m<<2)|0;h=h+b|0}}return}function sW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,n=0,o=0;n=k[g>>2]|0;d=k[g+4>>2]|0;l=b>>>1;j=f>>>2;if(!d)return;b=n+-4|0;if((n|0)<4){b=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(b){c=0;do{k[g+(c<<2)>>2]=m[h+(c<<1)>>1];c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(j<<2)|0;h=h+(l<<1)|0}}return}f=n&-4;i=(f|0)<(n|0);g=e;h=a;while(1){c=0;do{o=c|1;a=m[h+(o<<1)>>1]|0;k[g+(c<<2)>>2]=m[h+(c<<1)>>1];k[g+(o<<2)>>2]=a;o=c|2;a=c|3;e=m[h+(a<<1)>>1]|0;k[g+(o<<2)>>2]=m[h+(o<<1)>>1];k[g+(a<<2)>>2]=e;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(i){c=f;do{k[g+(c<<2)>>2]=m[h+(c<<1)>>1];c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(j<<2)|0;h=h+(l<<1)|0}}return}function tW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,l=0,m=0,n=0,o=0;n=k[g>>2]|0;d=k[g+4>>2]|0;m=b>>>1;l=f>>>2;if(!d)return;b=n+-4|0;if((n|0)<4){b=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(b){c=0;do{k[g+(c<<2)>>2]=j[h+(c<<1)>>1];c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(l<<2)|0;h=h+(m<<1)|0}}return}f=n&-4;i=(f|0)<(n|0);g=e;h=a;while(1){c=0;do{o=c|1;a=j[h+(o<<1)>>1]|0;k[g+(c<<2)>>2]=j[h+(c<<1)>>1];k[g+(o<<2)>>2]=a;o=c|2;a=c|3;e=j[h+(a<<1)>>1]|0;k[g+(o<<2)>>2]=j[h+(o<<1)>>1];k[g+(a<<2)>>2]=e;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(i){c=f;do{k[g+(c<<2)>>2]=j[h+(c<<1)>>1];c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(l<<2)|0;h=h+(m<<1)|0}}return}function uW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;c=k[g+4>>2]|0;b=b>>>2;h=f>>>2;if(!c)return;d=k[g>>2]<<2;while(1){c=c+-1|0;upb(e|0,a|0,d|0)|0;if(!c)break;else{a=a+(b<<2)|0;e=e+(h<<2)|0}}return}function vW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,l=0,m=0,n=0,p=0,q=0;q=k[g>>2]|0;h=k[g+4>>2]|0;p=b>>>2;n=f>>>2;if(!h)return;j=q+-4|0;if((q|0)<4){f=(q|0)>0;b=e;g=a;while(1){h=h+-1|0;if(f){d=0;do{i=+o[g+(d<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[b+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(q|0))}if(!h)break;else{b=b+(n<<2)|0;g=g+(p<<2)|0}}return}l=q&-4;m=(l|0)<(q|0);while(1){f=0;do{i=+o[a+(f<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;g=f|1;i=+o[a+(g<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[e+(f<<2)>>2]=d;k[e+(g<<2)>>2]=~~i;b=f|2;i=+o[a+(b<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;g=f|3;i=+o[a+(g<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[e+(b<<2)>>2]=d;k[e+(g<<2)>>2]=~~i;f=f+4|0}while((f|0)<=(j|0));h=h+-1|0;if(m){d=l;do{i=+o[a+(d<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[e+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(q|0))}if(!h)break;else{e=e+(n<<2)|0;a=a+(p<<2)|0}}return}function wW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,l=0,m=0,n=0,o=0,q=0,r=0;q=k[g>>2]|0;h=k[g+4>>2]|0;o=b>>>3;n=f>>>2;if(!h)return;j=q+-4|0;if((q|0)<4){f=(q|0)>0;b=e;g=a;while(1){h=h+-1|0;if(f){d=0;do{i=+p[g+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;m=c&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}k[b+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(q|0))}if(!h)break;else{b=b+(n<<2)|0;g=g+(o<<3)|0}}return}l=q&-4;m=(l|0)<(q|0);while(1){f=0;do{i=+p[a+(f<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;g=f|1;i=+p[a+(g<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}k[e+(f<<2)>>2]=d;k[e+(g<<2)>>2]=~~i;b=f|2;i=+p[a+(b<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;g=c&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}g=~~i;d=f|3;i=+p[a+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;r=c&2146435072;if(!(r>>>0>1126170624|(r|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}k[e+(b<<2)>>2]=g;k[e+(d<<2)>>2]=~~i;f=f+4|0}while((f|0)<=(j|0));h=h+-1|0;if(m){d=l;do{i=+p[a+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;r=c&2146435072;if(!(r>>>0>1126170624|(r|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}k[e+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(q|0))}if(!h)break;else{e=e+(n<<2)|0;a=a+(o<<3)|0}}return}function xW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,m=0,n=0,p=0.0;n=k[g>>2]|0;d=k[g+4>>2]|0;m=f>>>2;if(!d)return;f=n+-4|0;if((n|0)<4){f=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(f){c=0;do{o[g+(c<<2)>>2]=+(l[h+c>>0]|0);c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(m<<2)|0;h=h+b|0}}return}i=n&-4;j=(i|0)<(n|0);g=e;h=a;while(1){c=0;do{e=c|1;p=+(l[h+e>>0]|0);o[g+(c<<2)>>2]=+(l[h+c>>0]|0);o[g+(e<<2)>>2]=p;e=c|2;a=c|3;p=+(l[h+a>>0]|0);o[g+(e<<2)>>2]=+(l[h+e>>0]|0);o[g+(a<<2)>>2]=p;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(j){c=i;do{o[g+(c<<2)>>2]=+(l[h+c>>0]|0);c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(m<<2)|0;h=h+b|0}}return}function yW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,p=0.0;n=k[g>>2]|0;d=k[g+4>>2]|0;m=f>>>2;if(!d)return;f=n+-4|0;if((n|0)<4){f=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(f){c=0;do{o[g+(c<<2)>>2]=+(i[h+c>>0]|0);c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(m<<2)|0;h=h+b|0}}return}j=n&-4;l=(j|0)<(n|0);g=e;h=a;while(1){c=0;do{e=c|1;p=+(i[h+e>>0]|0);o[g+(c<<2)>>2]=+(i[h+c>>0]|0);o[g+(e<<2)>>2]=p;e=c|2;a=c|3;p=+(i[h+a>>0]|0);o[g+(e<<2)>>2]=+(i[h+e>>0]|0);o[g+(a<<2)>>2]=p;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(l){c=j;do{o[g+(c<<2)>>2]=+(i[h+c>>0]|0);c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(m<<2)|0;h=h+b|0}}return}function zW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0.0,n=0;i=k[g>>2]|0;g=k[g+4>>2]|0;j=b>>>1;f=f>>>2;d=g+-1|0;if(!g)return;if((i|0)<4){if((i|0)>0)h=e;else return;while(1){c=0;do{o[h+(c<<2)>>2]=+(m[a+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<2)|0;a=a+(j<<1)|0;d=d+-1|0}}return}g=i+-4|0;b=((g|0)>3?g:3)+4&-4;if((b|0)<(i|0))h=e;else{h=e;while(1){c=0;do{e=c|1;l=+(m[a+(e<<1)>>1]|0);o[h+(c<<2)>>2]=+(m[a+(c<<1)>>1]|0);o[h+(e<<2)>>2]=l;e=c|2;i=c|3;l=+(m[a+(i<<1)>>1]|0);o[h+(e<<2)>>2]=+(m[a+(e<<1)>>1]|0);o[h+(i<<2)>>2]=l;c=c+4|0}while((c|0)<=(g|0));if(!d)break;else{h=h+(f<<2)|0;a=a+(j<<1)|0;d=d+-1|0}}return}while(1){c=0;do{n=c|1;l=+(m[a+(n<<1)>>1]|0);o[h+(c<<2)>>2]=+(m[a+(c<<1)>>1]|0);o[h+(n<<2)>>2]=l;n=c|2;e=c|3;l=+(m[a+(e<<1)>>1]|0);o[h+(n<<2)>>2]=+(m[a+(n<<1)>>1]|0);o[h+(e<<2)>>2]=l;c=c+4|0}while((c|0)<=(g|0));c=b;do{o[h+(c<<2)>>2]=+(m[a+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<2)|0;a=a+(j<<1)|0;d=d+-1|0}}return}function AW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,l=0,m=0.0,n=0;i=k[g>>2]|0;g=k[g+4>>2]|0;l=b>>>1;f=f>>>2;d=g+-1|0;if(!g)return;if((i|0)<4){if((i|0)>0)h=e;else return;while(1){c=0;do{o[h+(c<<2)>>2]=+(j[a+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<2)|0;a=a+(l<<1)|0;d=d+-1|0}}return}g=i+-4|0;b=((g|0)>3?g:3)+4&-4;if((b|0)<(i|0))h=e;else{h=e;while(1){c=0;do{e=c|1;m=+(j[a+(e<<1)>>1]|0);o[h+(c<<2)>>2]=+(j[a+(c<<1)>>1]|0);o[h+(e<<2)>>2]=m;e=c|2;i=c|3;m=+(j[a+(i<<1)>>1]|0);o[h+(e<<2)>>2]=+(j[a+(e<<1)>>1]|0);o[h+(i<<2)>>2]=m;c=c+4|0}while((c|0)<=(g|0));if(!d)break;else{h=h+(f<<2)|0;a=a+(l<<1)|0;d=d+-1|0}}return}while(1){c=0;do{n=c|1;m=+(j[a+(n<<1)>>1]|0);o[h+(c<<2)>>2]=+(j[a+(c<<1)>>1]|0);o[h+(n<<2)>>2]=m;n=c|2;e=c|3;m=+(j[a+(e<<1)>>1]|0);o[h+(n<<2)>>2]=+(j[a+(n<<1)>>1]|0);o[h+(e<<2)>>2]=m;c=c+4|0}while((c|0)<=(g|0));c=b;do{o[h+(c<<2)>>2]=+(j[a+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<2)|0;a=a+(l<<1)|0;d=d+-1|0}}return}function BW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0.0;m=k[g>>2]|0;d=k[g+4>>2]|0;l=b>>>2;j=f>>>2;if(!d)return;b=m+-4|0;f=((b|0)>3?b:3)+4&-4;if((m|0)<4){b=(m|0)>0;g=e;h=a;while(1){d=d+-1|0;if(b){c=0;do{o[g+(c<<2)>>2]=+(k[h+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(m|0))}if(!d)break;else{g=g+(j<<2)|0;h=h+(l<<2)|0}}return}i=(f|0)<(m|0);g=e;h=a;while(1){c=0;do{e=c|1;n=+(k[h+(e<<2)>>2]|0);o[g+(c<<2)>>2]=+(k[h+(c<<2)>>2]|0);o[g+(e<<2)>>2]=n;e=c|2;a=c|3;n=+(k[h+(a<<2)>>2]|0);o[g+(e<<2)>>2]=+(k[h+(e<<2)>>2]|0);o[g+(a<<2)>>2]=n;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(i){c=f;do{o[g+(c<<2)>>2]=+(k[h+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(m|0))}if(!d)break;else{g=g+(j<<2)|0;h=h+(l<<2)|0}}return}function CW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0.0,m=0;i=k[g>>2]|0;g=k[g+4>>2]|0;j=b>>>3;f=f>>>2;d=g+-1|0;if(!g)return;if((i|0)<4){if((i|0)>0)h=e;else return;while(1){c=0;do{o[h+(c<<2)>>2]=+p[a+(c<<3)>>3];c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<2)|0;a=a+(j<<3)|0;d=d+-1|0}}return}g=i+-4|0;b=((g|0)>3?g:3)+4&-4;if((b|0)<(i|0))h=e;else{h=e;while(1){c=0;do{e=c|1;l=+p[a+(e<<3)>>3];o[h+(c<<2)>>2]=+p[a+(c<<3)>>3];o[h+(e<<2)>>2]=l;e=c|2;i=c|3;l=+p[a+(i<<3)>>3];o[h+(e<<2)>>2]=+p[a+(e<<3)>>3];o[h+(i<<2)>>2]=l;c=c+4|0}while((c|0)<=(g|0));if(!d)break;else{h=h+(f<<2)|0;a=a+(j<<3)|0;d=d+-1|0}}return}while(1){c=0;do{m=c|1;l=+p[a+(m<<3)>>3];o[h+(c<<2)>>2]=+p[a+(c<<3)>>3];o[h+(m<<2)>>2]=l;m=c|2;e=c|3;l=+p[a+(e<<3)>>3];o[h+(m<<2)>>2]=+p[a+(m<<3)>>3];o[h+(e<<2)>>2]=l;c=c+4|0}while((c|0)<=(g|0));c=b;do{o[h+(c<<2)>>2]=+p[a+(c<<3)>>3];c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<2)|0;a=a+(j<<3)|0;d=d+-1|0}}return}function DW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,m=0,n=0,o=0.0;n=k[g>>2]|0;d=k[g+4>>2]|0;m=f>>>3;if(!d)return;f=n+-4|0;if((n|0)<4){f=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(f){c=0;do{p[g+(c<<3)>>3]=+(l[h+c>>0]|0);c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(m<<3)|0;h=h+b|0}}return}i=n&-4;j=(i|0)<(n|0);g=e;h=a;while(1){c=0;do{e=c|1;o=+(l[h+e>>0]|0);p[g+(c<<3)>>3]=+(l[h+c>>0]|0);p[g+(e<<3)>>3]=o;e=c|2;a=c|3;o=+(l[h+a>>0]|0);p[g+(e<<3)>>3]=+(l[h+e>>0]|0);p[g+(a<<3)>>3]=o;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(j){c=i;do{p[g+(c<<3)>>3]=+(l[h+c>>0]|0);c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(m<<3)|0;h=h+b|0}}return}function EW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0.0;n=k[g>>2]|0;d=k[g+4>>2]|0;m=f>>>3;if(!d)return;f=n+-4|0;if((n|0)<4){f=(n|0)>0;g=e;h=a;while(1){d=d+-1|0;if(f){c=0;do{p[g+(c<<3)>>3]=+(i[h+c>>0]|0);c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(m<<3)|0;h=h+b|0}}return}j=n&-4;l=(j|0)<(n|0);g=e;h=a;while(1){c=0;do{e=c|1;o=+(i[h+e>>0]|0);p[g+(c<<3)>>3]=+(i[h+c>>0]|0);p[g+(e<<3)>>3]=o;e=c|2;a=c|3;o=+(i[h+a>>0]|0);p[g+(e<<3)>>3]=+(i[h+e>>0]|0);p[g+(a<<3)>>3]=o;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(l){c=j;do{p[g+(c<<3)>>3]=+(i[h+c>>0]|0);c=c+1|0}while((c|0)!=(n|0))}if(!d)break;else{g=g+(m<<3)|0;h=h+b|0}}return}function FW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0.0,n=0;i=k[g>>2]|0;g=k[g+4>>2]|0;j=b>>>1;f=f>>>3;d=g+-1|0;if(!g)return;if((i|0)<4){if((i|0)>0)h=e;else return;while(1){c=0;do{p[h+(c<<3)>>3]=+(m[a+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<3)|0;a=a+(j<<1)|0;d=d+-1|0}}return}g=i+-4|0;b=((g|0)>3?g:3)+4&-4;if((b|0)<(i|0))h=e;else{h=e;while(1){c=0;do{e=c|1;l=+(m[a+(e<<1)>>1]|0);p[h+(c<<3)>>3]=+(m[a+(c<<1)>>1]|0);p[h+(e<<3)>>3]=l;e=c|2;i=c|3;l=+(m[a+(i<<1)>>1]|0);p[h+(e<<3)>>3]=+(m[a+(e<<1)>>1]|0);p[h+(i<<3)>>3]=l;c=c+4|0}while((c|0)<=(g|0));if(!d)break;else{h=h+(f<<3)|0;a=a+(j<<1)|0;d=d+-1|0}}return}while(1){c=0;do{n=c|1;l=+(m[a+(n<<1)>>1]|0);p[h+(c<<3)>>3]=+(m[a+(c<<1)>>1]|0);p[h+(n<<3)>>3]=l;n=c|2;e=c|3;l=+(m[a+(e<<1)>>1]|0);p[h+(n<<3)>>3]=+(m[a+(n<<1)>>1]|0);p[h+(e<<3)>>3]=l;c=c+4|0}while((c|0)<=(g|0));c=b;do{p[h+(c<<3)>>3]=+(m[a+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<3)|0;a=a+(j<<1)|0;d=d+-1|0}}return}function GW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,l=0,m=0.0,n=0;i=k[g>>2]|0;g=k[g+4>>2]|0;l=b>>>1;f=f>>>3;d=g+-1|0;if(!g)return;if((i|0)<4){if((i|0)>0)h=e;else return;while(1){c=0;do{p[h+(c<<3)>>3]=+(j[a+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<3)|0;a=a+(l<<1)|0;d=d+-1|0}}return}g=i+-4|0;b=((g|0)>3?g:3)+4&-4;if((b|0)<(i|0))h=e;else{h=e;while(1){c=0;do{e=c|1;m=+(j[a+(e<<1)>>1]|0);p[h+(c<<3)>>3]=+(j[a+(c<<1)>>1]|0);p[h+(e<<3)>>3]=m;e=c|2;i=c|3;m=+(j[a+(i<<1)>>1]|0);p[h+(e<<3)>>3]=+(j[a+(e<<1)>>1]|0);p[h+(i<<3)>>3]=m;c=c+4|0}while((c|0)<=(g|0));if(!d)break;else{h=h+(f<<3)|0;a=a+(l<<1)|0;d=d+-1|0}}return}while(1){c=0;do{n=c|1;m=+(j[a+(n<<1)>>1]|0);p[h+(c<<3)>>3]=+(j[a+(c<<1)>>1]|0);p[h+(n<<3)>>3]=m;n=c|2;e=c|3;m=+(j[a+(e<<1)>>1]|0);p[h+(n<<3)>>3]=+(j[a+(n<<1)>>1]|0);p[h+(e<<3)>>3]=m;c=c+4|0}while((c|0)<=(g|0));c=b;do{p[h+(c<<3)>>3]=+(j[a+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<3)|0;a=a+(l<<1)|0;d=d+-1|0}}return}function HW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0.0;m=k[g>>2]|0;d=k[g+4>>2]|0;l=b>>>2;j=f>>>3;if(!d)return;b=m+-4|0;f=((b|0)>3?b:3)+4&-4;if((m|0)<4){b=(m|0)>0;g=e;h=a;while(1){d=d+-1|0;if(b){c=0;do{p[g+(c<<3)>>3]=+(k[h+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(m|0))}if(!d)break;else{g=g+(j<<3)|0;h=h+(l<<2)|0}}return}i=(f|0)<(m|0);g=e;h=a;while(1){c=0;do{e=c|1;n=+(k[h+(e<<2)>>2]|0);p[g+(c<<3)>>3]=+(k[h+(c<<2)>>2]|0);p[g+(e<<3)>>3]=n;e=c|2;a=c|3;n=+(k[h+(a<<2)>>2]|0);p[g+(e<<3)>>3]=+(k[h+(e<<2)>>2]|0);p[g+(a<<3)>>3]=n;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(i){c=f;do{p[g+(c<<3)>>3]=+(k[h+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(m|0))}if(!d)break;else{g=g+(j<<3)|0;h=h+(l<<2)|0}}return}function IW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0.0,m=0;i=k[g>>2]|0;g=k[g+4>>2]|0;j=b>>>2;f=f>>>3;d=g+-1|0;if(!g)return;if((i|0)<4){if((i|0)>0)h=e;else return;while(1){c=0;do{p[h+(c<<3)>>3]=+o[a+(c<<2)>>2];c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<3)|0;a=a+(j<<2)|0;d=d+-1|0}}return}g=i+-4|0;b=((g|0)>3?g:3)+4&-4;if((b|0)<(i|0))h=e;else{h=e;while(1){c=0;do{e=c|1;l=+o[a+(e<<2)>>2];p[h+(c<<3)>>3]=+o[a+(c<<2)>>2];p[h+(e<<3)>>3]=l;e=c|2;i=c|3;l=+o[a+(i<<2)>>2];p[h+(e<<3)>>3]=+o[a+(e<<2)>>2];p[h+(i<<3)>>3]=l;c=c+4|0}while((c|0)<=(g|0));if(!d)break;else{h=h+(f<<3)|0;a=a+(j<<2)|0;d=d+-1|0}}return}while(1){c=0;do{m=c|1;l=+o[a+(m<<2)>>2];p[h+(c<<3)>>3]=+o[a+(c<<2)>>2];p[h+(m<<3)>>3]=l;m=c|2;e=c|3;l=+o[a+(e<<2)>>2];p[h+(m<<3)>>3]=+o[a+(m<<2)>>2];p[h+(e<<3)>>3]=l;c=c+4|0}while((c|0)<=(g|0));c=b;do{p[h+(c<<3)>>3]=+o[a+(c<<2)>>2];c=c+1|0}while((c|0)!=(i|0));if(!d)break;else{h=h+(f<<3)|0;a=a+(j<<2)|0;d=d+-1|0}}return}function JW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;c=k[g+4>>2]|0;b=b>>>3;h=f>>>3;if(!c)return;d=k[g>>2]<<3;while(1){c=c+-1|0;upb(e|0,a|0,d|0)|0;if(!c)break;else{a=a+(b<<3)|0;e=e+(h<<3)|0}}return}function KW(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+208|0;z=A+144|0;w=A;y=A+88|0;q=A+72|0;u=A+64|0;v=A+56|0;s=A+24|0;t=A+16|0;do if((k[a>>2]&2031616|0)==65536){f=k[a+4>>2]|0;k[z>>2]=k[f>>2];l=z+4|0;a=f+4|0;k[l>>2]=k[a>>2];x=z+8|0;k[x>>2]=k[f+8>>2];k[z+12>>2]=k[f+12>>2];k[z+16>>2]=k[f+16>>2];k[z+20>>2]=k[f+20>>2];k[z+24>>2]=k[f+24>>2];k[z+28>>2]=k[f+28>>2];k[z+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[z+36>>2]=e;m=z+40|0;k[m>>2]=x;x=z+48|0;g=z+44|0;k[g>>2]=x;k[z+52>>2]=0;k[x>>2]=0;if(e|0){x=e+12|0;k[x>>2]=(k[x>>2]|0)+1}if((k[a>>2]|0)<3){n=k[f+44>>2]|0;x=k[g>>2]|0;k[x>>2]=k[n>>2];k[x+4>>2]=k[n+4>>2];x=l;n=z;break}k[l>>2]=0;x1(z,k[a>>2]|0,0,0,0);if((k[l>>2]|0)>0){h=k[f+40>>2]|0;j=k[m>>2]|0;f=k[f+44>>2]|0;e=k[g>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[h+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[l>>2]|0));x=l;n=z}else{x=l;n=z}}else{Q1(z,a,-1);x=z+4|0;m=z+40|0;n=z}while(0);o=((k[n>>2]|0)>>>3&511)+1|0;p[w>>3]=c;p[w+8>>3]=d;P1(b,k[x>>2]|0,k[m>>2]|0,(o<<3)+-8|0,-1,0,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[y>>2]=k[h>>2];b=y+4|0;e=h+4|0;k[b>>2]=k[e>>2];l=y+8|0;k[l>>2]=k[h+8>>2];k[y+12>>2]=k[h+12>>2];k[y+16>>2]=k[h+16>>2];k[y+20>>2]=k[h+20>>2];k[y+24>>2]=k[h+24>>2];k[y+28>>2]=k[h+28>>2];k[y+32>>2]=k[h+32>>2];a=k[h+36>>2]|0;k[y+36>>2]=a;f=y+40|0;k[f>>2]=l;l=y+48|0;j=y+44|0;k[j>>2]=l;k[y+52>>2]=0;k[l>>2]=0;if(a|0){l=a+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[e>>2]|0)<3){l=k[h+44>>2]|0;b=k[j>>2]|0;k[b>>2]=k[l>>2];k[b+4>>2]=k[l+4>>2];break}k[b>>2]=0;x1(y,k[e>>2]|0,0,0,0);if((k[b>>2]|0)>0){l=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;e=k[j>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[l+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[b>>2]|0))}}else Q1(y,b,-1);while(0);b=k[n>>2]&7;j=k[40576+(b<<2)>>2]|0;if((b|0)==7){k[q>>2]=0;a=q+4|0;k[a>>2]=0;e=ZT(16)|0;k[e>>2]=1;f=e+4|0;k[q>>2]=f;k[a>>2]=9;i[e+13>>0]=0;g=335726;h=f+9|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,q,210533,209965,4788);k[a>>2]=0;k[q>>2]=0;b=k[e>>2]|0;k[e>>2]=b+-1;if((b|0)==1)ggb(k[e+-4>>2]|0)}if((k[x>>2]|0)<3){t=k[n>>2]|0;v=k[y>>2]|0;f=k[z+12>>2]|0;a=k[z+8>>2]|0;e=Epb(f|0,((f|0)<0)<<31>>31|0,o|0,0)|0;e=Epb(e|0,N|0,a|0,((a|0)<0)<<31>>31|0)|0;if((t&16384&v|0)!=0?(e|0)==(e|0)&(((e|0)<0)<<31>>31|0)==(N|0):0)a=1;else e=aa(f,o)|0;q=k[z+16>>2]|0;s=k[z+48>>2]|0;t=k[y+16>>2]|0;v=k[y+48>>2]|0;k[u>>2]=e;k[u+4>>2]=a;sh[j&255](q,s,0,0,t,v,u,w)}else{k[q>>2]=z;k[q+4>>2]=y;k[q+8>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[s+16>>2]=0;k[s+20>>2]=0;k[s+24>>2]=0;k[s+28>>2]=0;z1(s,q,0,v,-1);e=aa(k[s+20>>2]|0,o)|0;f=s+16|0;g=v+4|0;h=t+4|0;a=0;while(1){if(a>>>0>=(k[f>>2]|0)>>>0)break;q=k[v>>2]|0;u=k[g>>2]|0;k[t>>2]=e;k[h>>2]=1;sh[j&255](q,0,0,0,u,0,t,w);A1(s);a=a+1|0}}f=y+36|0;a=k[f>>2]|0;if(a|0?(v=a+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;w=y+16|0;e=y+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[e>>2]|0)>0){f=k[y+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[y+44>>2]|0;if(!((a|0)==(y+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=z+36|0;a=k[f>>2]|0;if(a|0?(w=a+12|0,y=k[w>>2]|0,k[w>>2]=y+-1,(y|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[z+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;y=z+16|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[x>>2]|0)>0){e=k[m>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[x>>2]|0))}a=k[z+44>>2]|0;if((a|0)==(z+48|0)|(a|0)==0){r=A;return}ggb(k[a+-4>>2]|0);r=A;return}function LW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,m=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];if(!g)return;q=w+-4|0;if((w|0)<4){m=(w|0)>0;h=a;while(1){g=g+-1|0;if(m){d=0;do{j=+P(+(t+v*+(l[h+d>>0]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}s=~~j;i[e+d>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+f|0;h=h+b|0}}return}r=w&-4;s=(r|0)<(w|0);while(1){n=0;do{j=+P(+(t+v*+(l[a+n>>0]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=n|1;j=+P(+(t+v*+(l[a+h>>0]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}m=~~j;i[e+n>>0]=d;i[e+h>>0]=m>>>0<256?m:(m|0)>0?255:0;m=n|2;j=+P(+(t+v*+(l[a+m>>0]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=n|3;j=+P(+(t+v*+(l[a+h>>0]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+m>>0]=d;i[e+h>>0]=c>>>0<256?c:(c|0)>0?255:0;n=n+4|0}while((n|0)<=(q|0));g=g+-1|0;if(s){d=r;do{j=+P(+(t+v*+(l[a+d>>0]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}n=~~j;i[e+d>>0]=n>>>0<256?n:(n|0)>0?255:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+f|0;a=a+b|0}}return}function MW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];if(!g)return;n=v+-4|0;if((v|0)<4){l=(v|0)>0;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=+P(+(s+t*+(i[h+d>>0]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}r=~~j;i[e+d>>0]=r>>>0<256?r:(r|0)>0?255:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+f|0;h=h+b|0}}return}q=v&-4;r=(q|0)<(v|0);while(1){m=0;do{j=+P(+(s+t*+(i[a+m>>0]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=m|1;j=+P(+(s+t*+(i[a+h>>0]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+m>>0]=d;i[e+h>>0]=l>>>0<256?l:(l|0)>0?255:0;l=m|2;j=+P(+(s+t*+(i[a+l>>0]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=m|3;j=+P(+(s+t*+(i[a+h>>0]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+l>>0]=d;i[e+h>>0]=c>>>0<256?c:(c|0)>0?255:0;m=m+4|0}while((m|0)<=(n|0));g=g+-1|0;if(r){d=q;do{j=+P(+(s+t*+(i[a+d>>0]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}m=~~j;i[e+d>>0]=m>>>0<256?m:(m|0)>0?255:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+f|0;a=a+b|0}}return}function NW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];s=b>>>1;if(!g)return;n=w+-4|0;if((w|0)<4){l=(w|0)>0;b=e;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=+P(+(t+v*+(m[h+(d<<1)>>1]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}r=~~j;i[b+d>>0]=r>>>0<256?r:(r|0)>0?255:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{b=b+f|0;h=h+(s<<1)|0}}return}q=w&-4;r=(q|0)<(w|0);while(1){l=0;do{j=+P(+(t+v*+(m[a+(l<<1)>>1]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=l|1;j=+P(+(t+v*+(m[a+(h<<1)>>1]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+h>>0]=b>>>0<256?b:(b|0)>0?255:0;b=l|2;j=+P(+(t+v*+(m[a+(b<<1)>>1]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=l|3;j=+P(+(t+v*+(m[a+(h<<1)>>1]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+b>>0]=d;i[e+h>>0]=c>>>0<256?c:(c|0)>0?255:0;l=l+4|0}while((l|0)<=(n|0));g=g+-1|0;if(r){d=q;do{j=+P(+(t+v*+(m[a+(d<<1)>>1]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+d>>0]=l>>>0<256?l:(l|0)>0?255:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+f|0;a=a+(s<<1)|0}}return}function OW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0.0,m=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];s=b>>>1;if(!g)return;n=w+-4|0;if((w|0)<4){m=(w|0)>0;b=e;h=a;while(1){g=g+-1|0;if(m){d=0;do{l=+P(+(t+v*+(j[h+(d<<1)>>1]|0)));c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}r=~~l;i[b+d>>0]=r>>>0<256?r:(r|0)>0?255:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{b=b+f|0;h=h+(s<<1)|0}}return}q=w&-4;r=(q|0)<(w|0);while(1){m=0;do{l=+P(+(t+v*+(j[a+(m<<1)>>1]|0)));c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}d=~~l;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=m|1;l=+P(+(t+v*+(j[a+(h<<1)>>1]|0)));c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}b=~~l;i[e+m>>0]=d;i[e+h>>0]=b>>>0<256?b:(b|0)>0?255:0;b=m|2;l=+P(+(t+v*+(j[a+(b<<1)>>1]|0)));c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}d=~~l;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=m|3;l=+P(+(t+v*+(j[a+(h<<1)>>1]|0)));c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}c=~~l;i[e+b>>0]=d;i[e+h>>0]=c>>>0<256?c:(c|0)>0?255:0;m=m+4|0}while((m|0)<=(n|0));g=g+-1|0;if(r){d=q;do{l=+P(+(t+v*+(j[a+(d<<1)>>1]|0)));c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}m=~~l;i[e+d>>0]=m>>>0<256?m:(m|0)>0?255:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+f|0;a=a+(s<<1)|0}}return}function PW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=b>>>2;if(!g)return;m=v+-4|0;if((v|0)<4){l=(v|0)>0;b=e;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=+P(+(s+t*+(k[h+(d<<2)>>2]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}q=~~j;i[b+d>>0]=q>>>0<256?q:(q|0)>0?255:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{b=b+f|0;h=h+(r<<2)|0}}return}n=v&-4;q=(n|0)<(v|0);while(1){l=0;do{j=+P(+(s+t*+(k[a+(l<<2)>>2]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=l|1;j=+P(+(s+t*+(k[a+(h<<2)>>2]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+h>>0]=b>>>0<256?b:(b|0)>0?255:0;b=l|2;j=+P(+(s+t*+(k[a+(b<<2)>>2]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=l|3;j=+P(+(s+t*+(k[a+(h<<2)>>2]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+b>>0]=d;i[e+h>>0]=c>>>0<256?c:(c|0)>0?255:0;l=l+4|0}while((l|0)<=(m|0));g=g+-1|0;if(q){d=n;do{j=+P(+(s+t*+(k[a+(d<<2)>>2]|0)));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+d>>0]=l>>>0<256?l:(l|0)>0?255:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+f|0;a=a+(r<<2)|0}}return}function QW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=b>>>2;if(!g)return;m=v+-4|0;if((v|0)<4){l=(v|0)>0;b=e;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=+P(+(s+t*+o[h+(d<<2)>>2]));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}q=~~j;i[b+d>>0]=q>>>0<256?q:(q|0)>0?255:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{b=b+f|0;h=h+(r<<2)|0}}return}n=v&-4;q=(n|0)<(v|0);while(1){l=0;do{j=+P(+(s+t*+o[a+(l<<2)>>2]));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=l|1;j=+P(+(s+t*+o[a+(h<<2)>>2]));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+h>>0]=b>>>0<256?b:(b|0)>0?255:0;b=l|2;j=+P(+(s+t*+o[a+(b<<2)>>2]));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=l|3;j=+P(+(s+t*+o[a+(h<<2)>>2]));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+b>>0]=d;i[e+h>>0]=c>>>0<256?c:(c|0)>0?255:0;l=l+4|0}while((l|0)<=(m|0));g=g+-1|0;if(q){d=n;do{j=+P(+(s+t*+o[a+(d<<2)>>2]));c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+d>>0]=l>>>0<256?l:(l|0)>0?255:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+f|0;a=a+(r<<2)|0}}return}function RW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,o=0,q=0.0,r=0,s=0.0,t=0,v=0;t=k[g>>2]|0;g=k[g+4>>2]|0;r=b>>>3;if(!g)return;s=+p[h>>3];q=+p[h+8>>3];m=t+-4|0;if((t|0)<4){l=(t|0)>0;h=e;b=a;while(1){g=g+-1|0;if(l){d=0;do{j=+P(+(q+s*+p[b+(d<<3)>>3]));p[u>>3]=j;c=k[u+4>>2]|0;o=c&2146435072;if(!(o>>>0>1126170624|(o|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}o=~~j;i[h+d>>0]=o>>>0<256?o:(o|0)>0?255:0;d=d+1|0}while((d|0)!=(t|0))}if(!g)break;else{h=h+f|0;b=b+(r<<3)|0}}return}n=t&-4;o=(n|0)<(t|0);while(1){l=0;do{j=+P(+(q+s*+p[a+(l<<3)>>3]));p[u>>3]=j;c=k[u+4>>2]|0;h=c&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;b=l|1;j=+P(+(q+s*+p[a+(b<<3)>>3]));p[u>>3]=j;c=k[u+4>>2]|0;h=c&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}h=~~j;i[e+l>>0]=d;i[e+b>>0]=h>>>0<256?h:(h|0)>0?255:0;h=l|2;j=+P(+(q+s*+p[a+(h<<3)>>3]));p[u>>3]=j;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;b=l|3;j=+P(+(q+s*+p[a+(b<<3)>>3]));p[u>>3]=j;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}v=~~j;i[e+h>>0]=d;i[e+b>>0]=v>>>0<256?v:(v|0)>0?255:0;l=l+4|0}while((l|0)<=(m|0));g=g+-1|0;if(o){d=n;do{j=+P(+(q+s*+p[a+(d<<3)>>3]));p[u>>3]=j;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}v=~~j;i[e+d>>0]=v>>>0<256?v:(v|0)>0?255:0;d=d+1|0}while((d|0)!=(t|0))}if(!g)break;else{e=e+f|0;a=a+(r<<3)|0}}return}function SW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=r;r=r+208|0;C=M+152|0;D=M;E=M+96|0;t=M+88|0;A=M+80|0;v=M+64|0;x=M+56|0;y=M+24|0;z=M+16|0;if(+P(+(d+-1.0))<2.220446049250313e-16)o=+P(+e)<2.220446049250313e-16;else o=0;do if((c|0)<0)if((k[b>>2]|0)<0){s=S1(b,-1)|0;n=a;c=k[a>>2]|0;break}else{c=k[a>>2]|0;s=c&4095;n=a;break}else{L=k[a>>2]|0;s=L&4088|c&7;n=a;c=L}while(0);l=c&7;m=s&7;if(!((l|0)!=(m|0)|o^1)){mY(a,b);r=M;return}k[C>>2]=c;J=C+4|0;q=a+4|0;c=k[q>>2]|0;k[J>>2]=c;w=C+8|0;k[w>>2]=k[a+8>>2];u=C+12|0;k[u>>2]=k[a+12>>2];G=C+16|0;k[G>>2]=k[a+16>>2];k[C+20>>2]=k[a+20>>2];k[C+24>>2]=k[a+24>>2];k[C+28>>2]=k[a+28>>2];F=C+32|0;k[F>>2]=k[a+32>>2];H=C+36|0;f=k[a+36>>2]|0;k[H>>2]=f;I=C+40|0;k[I>>2]=w;L=C+48|0;K=C+44|0;k[K>>2]=L;k[C+52>>2]=0;k[L>>2]=0;if(f){c=f+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[q>>2]|0}if((c|0)>=3){k[J>>2]=0;x1(C,c,0,0,0);if((k[J>>2]|0)>0){f=k[a+40>>2]|0;g=k[I>>2]|0;h=k[a+44>>2]|0;j=k[K>>2]|0;c=0;do{k[g+(c<<2)>>2]=k[f+(c<<2)>>2];k[j+(c<<2)>>2]=k[h+(c<<2)>>2];c=c+1|0}while((c|0)<(k[J>>2]|0))}}else{j=k[a+44>>2]|0;B=k[K>>2]|0;k[B>>2]=k[j>>2];k[B+4>>2]=k[j+4>>2]}B=k[(o?40320:40608)+(m<<5)+(l<<2)>>2]|0;p[D>>3]=d;p[D+8>>3]=e;o=((k[n>>2]|0)>>>3&511)+1|0;if(!B){k[E>>2]=0;c=E+4|0;k[c>>2]=0;f=ZT(16)|0;k[f>>2]=1;g=f+4|0;k[E>>2]=g;k[c>>2]=9;i[f+13>>0]=0;h=335726;j=g+9|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,E,210549,209965,4828);k[c>>2]=0;k[E>>2]=0;n=k[f>>2]|0;k[f>>2]=n+-1;if((n|0)==1)ggb(k[f+-4>>2]|0)}f=k[q>>2]|0;c=k[a+40>>2]|0;if((f|0)<3){z=k[c>>2]|0;k[t>>2]=k[c+4>>2];k[t+4>>2]=z;x2(b,t,s,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[E>>2]=k[h>>2];n=E+4|0;c=h+4|0;k[n>>2]=k[c>>2];z=E+8|0;k[z>>2]=k[h+8>>2];k[E+12>>2]=k[h+12>>2];k[E+16>>2]=k[h+16>>2];k[E+20>>2]=k[h+20>>2];k[E+24>>2]=k[h+24>>2];k[E+28>>2]=k[h+28>>2];k[E+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[E+36>>2]=f;g=E+40|0;k[g>>2]=z;z=E+48|0;l=E+44|0;k[l>>2]=z;k[E+52>>2]=0;k[z>>2]=0;if(f|0){z=f+12|0;k[z>>2]=(k[z>>2]|0)+1}if((k[c>>2]|0)<3){z=k[h+44>>2]|0;c=k[l>>2]|0;k[c>>2]=k[z>>2];k[c+4>>2]=k[z+4>>2];c=E;break}k[n>>2]=0;x1(E,k[c>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;c=0;do{k[j+(c<<2)>>2]=k[m+(c<<2)>>2];k[f+(c<<2)>>2]=k[g+(c<<2)>>2];c=c+1|0}while((c|0)<(k[n>>2]|0));c=E}else c=E}else{Q1(E,b,-1);c=E}while(0);z=k[C>>2]|0;C=k[c>>2]|0;g=k[u>>2]|0;c=k[w>>2]|0;f=Epb(g|0,((g|0)<0)<<31>>31|0,o|0,0)|0;f=Epb(f|0,N|0,c|0,((c|0)<0)<<31>>31|0)|0;if((z&16384&C|0)!=0?(f|0)==(f|0)&(((f|0)<0)<<31>>31|0)==(N|0):0)c=1;else f=aa(g,o)|0;y=k[G>>2]|0;z=k[L>>2]|0;h=E+16|0;C=k[h>>2]|0;j=E+48|0;g=k[j>>2]|0;k[A>>2]=f;k[A+4>>2]=c;sh[B&255](y,z,0,0,C,g,A,D);g=E+36|0;c=k[g>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){f=k[g>>2]|0;if(f|0){c=k[f+4>>2]|0;if(!c){c=k[E+32>>2]|0;if(!c){c=B1()|0;f=k[g>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,f)}k[g>>2]=0}k[g>>2]=0;g=E+4|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[g>>2]|0)>0){f=k[E+40>>2]|0;c=0;do{k[f+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[g>>2]|0))}c=k[E+44>>2]|0;if(!((c|0)==(j|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}else{P1(b,f,c,s,-1,0,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[E>>2]=k[h>>2];n=E+4|0;c=h+4|0;k[n>>2]=k[c>>2];A=E+8|0;k[A>>2]=k[h+8>>2];k[E+12>>2]=k[h+12>>2];k[E+16>>2]=k[h+16>>2];k[E+20>>2]=k[h+20>>2];k[E+24>>2]=k[h+24>>2];k[E+28>>2]=k[h+28>>2];k[E+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[E+36>>2]=f;g=E+40|0;k[g>>2]=A;A=E+48|0;l=E+44|0;k[l>>2]=A;k[E+52>>2]=0;k[A>>2]=0;if(f|0){A=f+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[c>>2]|0)<3){w=k[h+44>>2]|0;A=k[l>>2]|0;k[A>>2]=k[w>>2];k[A+4>>2]=k[w+4>>2];break}k[n>>2]=0;x1(E,k[c>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;c=0;do{k[j+(c<<2)>>2]=k[m+(c<<2)>>2];k[f+(c<<2)>>2]=k[g+(c<<2)>>2];c=c+1|0}while((c|0)<(k[n>>2]|0))}}else Q1(E,b,-1);while(0);k[v>>2]=C;k[v+4>>2]=E;k[v+8>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;k[y+16>>2]=0;k[y+20>>2]=0;k[y+24>>2]=0;k[y+28>>2]=0;z1(y,v,0,x,-1);f=aa(k[y+20>>2]|0,o)|0;g=y+16|0;h=x+4|0;j=z+4|0;c=0;while(1){if(c>>>0>=(k[g>>2]|0)>>>0)break;A=k[x>>2]|0;C=k[h>>2]|0;k[z>>2]=f;k[j>>2]=1;sh[B&255](A,1,0,0,C,1,z,D);A1(y);c=c+1|0}g=E+36|0;c=k[g>>2]|0;if(c|0?(C=c+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){f=k[g>>2]|0;if(f|0){c=k[f+4>>2]|0;if(!c){c=k[E+32>>2]|0;if(!c){c=B1()|0;f=k[g>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,f)}k[g>>2]=0}k[g>>2]=0;D=E+16|0;f=E+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[f>>2]|0)>0){g=k[E+40>>2]|0;c=0;do{k[g+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[f>>2]|0))}c=k[E+44>>2]|0;if(!((c|0)==(E+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}c=k[H>>2]|0;if(c|0?(D=c+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){f=k[H>>2]|0;if(f|0){c=k[f+4>>2]|0;if(!c){c=k[F>>2]|0;if(!c){c=B1()|0;f=k[H>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,f)}k[H>>2]=0}k[H>>2]=0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[J>>2]|0)>0){f=k[I>>2]|0;c=0;do{k[f+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[J>>2]|0))}c=k[K>>2]|0;if(!((c|0)==(L|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=M;return}function TW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,m=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];if(!g)return;q=w+-4|0;if((w|0)<4){m=(w|0)>0;h=a;while(1){g=g+-1|0;if(m){d=0;do{j=t+v*+(l[h+d>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}s=~~j;i[e+d>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+f|0;h=h+b|0}}return}r=w&-4;s=(r|0)<(w|0);while(1){n=0;do{j=t+v*+(l[a+n>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=n|1;j=t+v*+(l[a+h>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}m=~~j;i[e+n>>0]=d;i[e+h>>0]=m>>>0<256?m:(m|0)>0?255:0;m=n|2;j=t+v*+(l[a+m>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=n|3;j=t+v*+(l[a+h>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+m>>0]=d;i[e+h>>0]=c>>>0<256?c:(c|0)>0?255:0;n=n+4|0}while((n|0)<=(q|0));g=g+-1|0;if(s){d=r;do{j=t+v*+(l[a+d>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}n=~~j;i[e+d>>0]=n>>>0<256?n:(n|0)>0?255:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+f|0;a=a+b|0}}return}function UW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];if(!g)return;n=v+-4|0;if((v|0)<4){l=(v|0)>0;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=s+t*+(i[h+d>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}r=~~j;i[e+d>>0]=r>>>0<256?r:(r|0)>0?255:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+f|0;h=h+b|0}}return}q=v&-4;r=(q|0)<(v|0);while(1){m=0;do{j=s+t*+(i[a+m>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=m|1;j=s+t*+(i[a+h>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+m>>0]=d;i[e+h>>0]=l>>>0<256?l:(l|0)>0?255:0;l=m|2;j=s+t*+(i[a+l>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=m|3;j=s+t*+(i[a+h>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+l>>0]=d;i[e+h>>0]=c>>>0<256?c:(c|0)>0?255:0;m=m+4|0}while((m|0)<=(n|0));g=g+-1|0;if(r){d=q;do{j=s+t*+(i[a+d>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}m=~~j;i[e+d>>0]=m>>>0<256?m:(m|0)>0?255:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+f|0;a=a+b|0}}return}function VW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];s=b>>>1;if(!g)return;n=w+-4|0;if((w|0)<4){l=(w|0)>0;b=e;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=t+v*+(m[h+(d<<1)>>1]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}r=~~j;i[b+d>>0]=r>>>0<256?r:(r|0)>0?255:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{b=b+f|0;h=h+(s<<1)|0}}return}q=w&-4;r=(q|0)<(w|0);while(1){l=0;do{j=t+v*+(m[a+(l<<1)>>1]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=l|1;j=t+v*+(m[a+(h<<1)>>1]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+h>>0]=b>>>0<256?b:(b|0)>0?255:0;b=l|2;j=t+v*+(m[a+(b<<1)>>1]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=l|3;j=t+v*+(m[a+(h<<1)>>1]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+b>>0]=d;i[e+h>>0]=c>>>0<256?c:(c|0)>0?255:0;l=l+4|0}while((l|0)<=(n|0));g=g+-1|0;if(r){d=q;do{j=t+v*+(m[a+(d<<1)>>1]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+d>>0]=l>>>0<256?l:(l|0)>0?255:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+f|0;a=a+(s<<1)|0}}return}function WW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0.0,m=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];s=b>>>1;if(!g)return;n=w+-4|0;if((w|0)<4){m=(w|0)>0;b=e;h=a;while(1){g=g+-1|0;if(m){d=0;do{l=t+v*+(j[h+(d<<1)>>1]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}r=~~l;i[b+d>>0]=r>>>0<256?r:(r|0)>0?255:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{b=b+f|0;h=h+(s<<1)|0}}return}q=w&-4;r=(q|0)<(w|0);while(1){m=0;do{l=t+v*+(j[a+(m<<1)>>1]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}d=~~l;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=m|1;l=t+v*+(j[a+(h<<1)>>1]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}b=~~l;i[e+m>>0]=d;i[e+h>>0]=b>>>0<256?b:(b|0)>0?255:0;b=m|2;l=t+v*+(j[a+(b<<1)>>1]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}d=~~l;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=m|3;l=t+v*+(j[a+(h<<1)>>1]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}c=~~l;i[e+b>>0]=d;i[e+h>>0]=c>>>0<256?c:(c|0)>0?255:0;m=m+4|0}while((m|0)<=(n|0));g=g+-1|0;if(r){d=q;do{l=t+v*+(j[a+(d<<1)>>1]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}m=~~l;i[e+d>>0]=m>>>0<256?m:(m|0)>0?255:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+f|0;a=a+(s<<1)|0}}return}function XW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=b>>>2;if(!g)return;m=v+-4|0;if((v|0)<4){l=(v|0)>0;b=e;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=s+t*+(k[h+(d<<2)>>2]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}q=~~j;i[b+d>>0]=q>>>0<256?q:(q|0)>0?255:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{b=b+f|0;h=h+(r<<2)|0}}return}n=v&-4;q=(n|0)<(v|0);while(1){l=0;do{j=s+t*+(k[a+(l<<2)>>2]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=l|1;j=s+t*+(k[a+(h<<2)>>2]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+h>>0]=b>>>0<256?b:(b|0)>0?255:0;b=l|2;j=s+t*+(k[a+(b<<2)>>2]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=l|3;j=s+t*+(k[a+(h<<2)>>2]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+b>>0]=d;i[e+h>>0]=c>>>0<256?c:(c|0)>0?255:0;l=l+4|0}while((l|0)<=(m|0));g=g+-1|0;if(q){d=n;do{j=s+t*+(k[a+(d<<2)>>2]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+d>>0]=l>>>0<256?l:(l|0)>0?255:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+f|0;a=a+(r<<2)|0}}return}function YW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=b>>>2;if(!g)return;m=v+-4|0;if((v|0)<4){l=(v|0)>0;b=e;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=s+t*+o[h+(d<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}q=~~j;i[b+d>>0]=q>>>0<256?q:(q|0)>0?255:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{b=b+f|0;h=h+(r<<2)|0}}return}n=v&-4;q=(n|0)<(v|0);while(1){l=0;do{j=s+t*+o[a+(l<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=l|1;j=s+t*+o[a+(h<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+h>>0]=b>>>0<256?b:(b|0)>0?255:0;b=l|2;j=s+t*+o[a+(b<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;h=l|3;j=s+t*+o[a+(h<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+b>>0]=d;i[e+h>>0]=c>>>0<256?c:(c|0)>0?255:0;l=l+4|0}while((l|0)<=(m|0));g=g+-1|0;if(q){d=n;do{j=s+t*+o[a+(d<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+d>>0]=l>>>0<256?l:(l|0)>0?255:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+f|0;a=a+(r<<2)|0}}return}function ZW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,o=0,q=0.0,r=0,s=0.0,t=0,v=0;t=k[g>>2]|0;g=k[g+4>>2]|0;r=b>>>3;if(!g)return;s=+p[h>>3];q=+p[h+8>>3];m=t+-4|0;if((t|0)<4){l=(t|0)>0;h=e;b=a;while(1){g=g+-1|0;if(l){d=0;do{j=q+s*+p[b+(d<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;o=c&2146435072;if(!(o>>>0>1126170624|(o|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}o=~~j;i[h+d>>0]=o>>>0<256?o:(o|0)>0?255:0;d=d+1|0}while((d|0)!=(t|0))}if(!g)break;else{h=h+f|0;b=b+(r<<3)|0}}return}n=t&-4;o=(n|0)<(t|0);while(1){l=0;do{j=q+s*+p[a+(l<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;h=c&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;b=l|1;j=q+s*+p[a+(b<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;h=c&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}h=~~j;i[e+l>>0]=d;i[e+b>>0]=h>>>0<256?h:(h|0)>0?255:0;h=l|2;j=q+s*+p[a+(h<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=(d>>>0<256?d:(d|0)>0?255:0)&255;b=l|3;j=q+s*+p[a+(b<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}v=~~j;i[e+h>>0]=d;i[e+b>>0]=v>>>0<256?v:(v|0)>0?255:0;l=l+4|0}while((l|0)<=(m|0));g=g+-1|0;if(o){d=n;do{j=q+s*+p[a+(d<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}v=~~j;i[e+d>>0]=v>>>0<256?v:(v|0)>0?255:0;d=d+1|0}while((d|0)!=(t|0))}if(!g)break;else{e=e+f|0;a=a+(r<<3)|0}}return}function _W(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,m=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];if(!g)return;q=w+-4|0;if((w|0)<4){m=(w|0)>0;h=a;while(1){g=g+-1|0;if(m){d=0;do{j=t+v*+(l[h+d>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}s=~~j;i[e+d>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+f|0;h=h+b|0}}return}r=w&-4;s=(r|0)<(w|0);while(1){n=0;do{j=t+v*+(l[a+n>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;h=n|1;j=t+v*+(l[a+h>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}m=~~j;i[e+n>>0]=d;i[e+h>>0]=(m+128|0)>>>0<256?m:(m|0)>0?127:128;m=n|2;j=t+v*+(l[a+m>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;h=n|3;j=t+v*+(l[a+h>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+m>>0]=d;i[e+h>>0]=(c+128|0)>>>0<256?c:(c|0)>0?127:128;n=n+4|0}while((n|0)<=(q|0));g=g+-1|0;if(s){d=r;do{j=t+v*+(l[a+d>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}n=~~j;i[e+d>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+f|0;a=a+b|0}}return}function $W(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];if(!g)return;n=v+-4|0;if((v|0)<4){l=(v|0)>0;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=s+t*+(i[h+d>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}r=~~j;i[e+d>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+f|0;h=h+b|0}}return}q=v&-4;r=(q|0)<(v|0);while(1){m=0;do{j=s+t*+(i[a+m>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;h=m|1;j=s+t*+(i[a+h>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+m>>0]=d;i[e+h>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;l=m|2;j=s+t*+(i[a+l>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;h=m|3;j=s+t*+(i[a+h>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+l>>0]=d;i[e+h>>0]=(c+128|0)>>>0<256?c:(c|0)>0?127:128;m=m+4|0}while((m|0)<=(n|0));g=g+-1|0;if(r){d=q;do{j=s+t*+(i[a+d>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}m=~~j;i[e+d>>0]=(m+128|0)>>>0<256?m:(m|0)>0?127:128;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+f|0;a=a+b|0}}return}function aX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];s=b>>>1;if(!g)return;n=w+-4|0;if((w|0)<4){l=(w|0)>0;b=e;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=t+v*+(m[h+(d<<1)>>1]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}r=~~j;i[b+d>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{b=b+f|0;h=h+(s<<1)|0}}return}q=w&-4;r=(q|0)<(w|0);while(1){l=0;do{j=t+v*+(m[a+(l<<1)>>1]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;h=l|1;j=t+v*+(m[a+(h<<1)>>1]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+h>>0]=(b+128|0)>>>0<256?b:(b|0)>0?127:128;b=l|2;j=t+v*+(m[a+(b<<1)>>1]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;h=l|3;j=t+v*+(m[a+(h<<1)>>1]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+b>>0]=d;i[e+h>>0]=(c+128|0)>>>0<256?c:(c|0)>0?127:128;l=l+4|0}while((l|0)<=(n|0));g=g+-1|0;if(r){d=q;do{j=t+v*+(m[a+(d<<1)>>1]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+d>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+f|0;a=a+(s<<1)|0}}return}function bX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0.0,m=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];s=b>>>1;if(!g)return;n=w+-4|0;if((w|0)<4){m=(w|0)>0;b=e;h=a;while(1){g=g+-1|0;if(m){d=0;do{l=t+v*+(j[h+(d<<1)>>1]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}r=~~l;i[b+d>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{b=b+f|0;h=h+(s<<1)|0}}return}q=w&-4;r=(q|0)<(w|0);while(1){m=0;do{l=t+v*+(j[a+(m<<1)>>1]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}d=~~l;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;h=m|1;l=t+v*+(j[a+(h<<1)>>1]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}b=~~l;i[e+m>>0]=d;i[e+h>>0]=(b+128|0)>>>0<256?b:(b|0)>0?127:128;b=m|2;l=t+v*+(j[a+(b<<1)>>1]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}d=~~l;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;h=m|3;l=t+v*+(j[a+(h<<1)>>1]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}c=~~l;i[e+b>>0]=d;i[e+h>>0]=(c+128|0)>>>0<256?c:(c|0)>0?127:128;m=m+4|0}while((m|0)<=(n|0));g=g+-1|0;if(r){d=q;do{l=t+v*+(j[a+(d<<1)>>1]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}m=~~l;i[e+d>>0]=(m+128|0)>>>0<256?m:(m|0)>0?127:128;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+f|0;a=a+(s<<1)|0}}return}function cX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=b>>>2;if(!g)return;m=v+-4|0;if((v|0)<4){l=(v|0)>0;b=e;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=s+t*+(k[h+(d<<2)>>2]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}q=~~j;i[b+d>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{b=b+f|0;h=h+(r<<2)|0}}return}n=v&-4;q=(n|0)<(v|0);while(1){l=0;do{j=s+t*+(k[a+(l<<2)>>2]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;h=l|1;j=s+t*+(k[a+(h<<2)>>2]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+h>>0]=(b+128|0)>>>0<256?b:(b|0)>0?127:128;b=l|2;j=s+t*+(k[a+(b<<2)>>2]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;h=l|3;j=s+t*+(k[a+(h<<2)>>2]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+b>>0]=d;i[e+h>>0]=(c+128|0)>>>0<256?c:(c|0)>0?127:128;l=l+4|0}while((l|0)<=(m|0));g=g+-1|0;if(q){d=n;do{j=s+t*+(k[a+(d<<2)>>2]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+d>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+f|0;a=a+(r<<2)|0}}return}function dX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=b>>>2;if(!g)return;m=v+-4|0;if((v|0)<4){l=(v|0)>0;b=e;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=s+t*+o[h+(d<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}q=~~j;i[b+d>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{b=b+f|0;h=h+(r<<2)|0}}return}n=v&-4;q=(n|0)<(v|0);while(1){l=0;do{j=s+t*+o[a+(l<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;h=l|1;j=s+t*+o[a+(h<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}b=~~j;i[e+l>>0]=d;i[e+h>>0]=(b+128|0)>>>0<256?b:(b|0)>0?127:128;b=l|2;j=s+t*+o[a+(b<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;h=l|3;j=s+t*+o[a+(h<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}c=~~j;i[e+b>>0]=d;i[e+h>>0]=(c+128|0)>>>0<256?c:(c|0)>0?127:128;l=l+4|0}while((l|0)<=(m|0));g=g+-1|0;if(q){d=n;do{j=s+t*+o[a+(d<<2)>>2];c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}l=~~j;i[e+d>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+f|0;a=a+(r<<2)|0}}return}function eX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,o=0,q=0.0,r=0,s=0.0,t=0,v=0;t=k[g>>2]|0;g=k[g+4>>2]|0;r=b>>>3;if(!g)return;s=+p[h>>3];q=+p[h+8>>3];m=t+-4|0;if((t|0)<4){l=(t|0)>0;h=e;b=a;while(1){g=g+-1|0;if(l){d=0;do{j=q+s*+p[b+(d<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;o=c&2146435072;if(!(o>>>0>1126170624|(o|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}o=~~j;i[h+d>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;d=d+1|0}while((d|0)!=(t|0))}if(!g)break;else{h=h+f|0;b=b+(r<<3)|0}}return}n=t&-4;o=(n|0)<(t|0);while(1){l=0;do{j=q+s*+p[a+(l<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;h=c&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;b=l|1;j=q+s*+p[a+(b<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;h=c&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}h=~~j;i[e+l>>0]=d;i[e+b>>0]=(h+128|0)>>>0<256?h:(h|0)>0?127:128;h=l|2;j=q+s*+p[a+(h<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;d=((d+128|0)>>>0<256?d:(d|0)>0?127:128)&255;b=l|3;j=q+s*+p[a+(b<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}v=~~j;i[e+h>>0]=d;i[e+b>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;l=l+4|0}while((l|0)<=(m|0));g=g+-1|0;if(o){d=n;do{j=q+s*+p[a+(d<<3)>>3];p[u>>3]=j;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;j=c?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=c?-0.0:0.0}v=~~j;i[e+d>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;d=d+1|0}while((d|0)!=(t|0))}if(!g)break;else{e=e+f|0;a=a+(r<<3)|0}}return}function fX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,m=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];s=f>>>1;if(!g)return;n=w+-4|0;if((w|0)<4){m=(w|0)>0;f=e;h=a;while(1){g=g+-1|0;if(m){d=0;do{i=t+v*+(l[h+d>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}r=~~i;j[f+(d<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{f=f+(s<<1)|0;h=h+b|0}}return}q=w&-4;r=(q|0)<(w|0);while(1){m=0;do{i=t+v*+(l[a+m>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;h=m|1;i=t+v*+(l[a+h>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}f=~~i;j[e+(m<<1)>>1]=d;j[e+(h<<1)>>1]=f>>>0<65536?f:(f|0)>0?65535:0;f=m|2;i=t+v*+(l[a+f>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;h=m|3;i=t+v*+(l[a+h>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}c=~~i;j[e+(f<<1)>>1]=d;j[e+(h<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;m=m+4|0}while((m|0)<=(n|0));g=g+-1|0;if(r){d=q;do{i=t+v*+(l[a+d>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}m=~~i;j[e+(d<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+(s<<1)|0;a=a+b|0}}return}function gX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0.0,m=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];s=f>>>1;if(!g)return;n=w+-4|0;if((w|0)<4){m=(w|0)>0;f=e;h=a;while(1){g=g+-1|0;if(m){d=0;do{l=t+v*+(i[h+d>>0]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}r=~~l;j[f+(d<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{f=f+(s<<1)|0;h=h+b|0}}return}q=w&-4;r=(q|0)<(w|0);while(1){m=0;do{l=t+v*+(i[a+m>>0]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}d=~~l;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;h=m|1;l=t+v*+(i[a+h>>0]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}f=~~l;j[e+(m<<1)>>1]=d;j[e+(h<<1)>>1]=f>>>0<65536?f:(f|0)>0?65535:0;f=m|2;l=t+v*+(i[a+f>>0]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}d=~~l;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;h=m|3;l=t+v*+(i[a+h>>0]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}c=~~l;j[e+(f<<1)>>1]=d;j[e+(h<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;m=m+4|0}while((m|0)<=(n|0));g=g+-1|0;if(r){d=q;do{l=t+v*+(i[a+d>>0]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}m=~~l;j[e+(d<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+(s<<1)|0;a=a+b|0}}return}function hX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;q=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];s=b>>>1;r=f>>>1;g=q+-1|0;if(!q)return;if((w|0)<4){if((w|0)>0){b=e;h=a}else return;while(1){d=0;do{i=t+v*+(m[h+(d<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}q=~~i;j[b+(d<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d=d+1|0}while((d|0)!=(w|0));if(!g)break;else{b=b+(r<<1)|0;h=h+(s<<1)|0;g=g+-1|0}}return}l=w+-4|0;n=((l|0)>3?l:3)+4&-4;q=(n|0)<(w|0);while(1){f=0;do{i=t+v*+(m[a+(f<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;h=f|1;i=t+v*+(m[a+(h<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}b=~~i;j[e+(f<<1)>>1]=d;j[e+(h<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=f|2;i=t+v*+(m[a+(b<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;h=f|3;i=t+v*+(m[a+(h<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}c=~~i;j[e+(b<<1)>>1]=d;j[e+(h<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;f=f+4|0}while((f|0)<=(l|0));if(q){d=n;do{i=t+v*+(m[a+(d<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}f=~~i;j[e+(d<<1)>>1]=f>>>0<65536?f:(f|0)>0?65535:0;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+(r<<1)|0;a=a+(s<<1)|0;g=g+-1|0}}return}function iX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;n=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=b>>>1;q=f>>>1;g=n+-1|0;if(!n)return;if((v|0)<4){if((v|0)>0){b=e;h=a}else return;while(1){d=0;do{i=s+t*+(j[h+(d<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}n=~~i;j[b+(d<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;d=d+1|0}while((d|0)!=(v|0));if(!g)break;else{b=b+(q<<1)|0;h=h+(r<<1)|0;g=g+-1|0}}return}l=v+-4|0;m=((l|0)>3?l:3)+4&-4;n=(m|0)<(v|0);while(1){f=0;do{i=s+t*+(j[a+(f<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;h=f|1;i=s+t*+(j[a+(h<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}b=~~i;j[e+(f<<1)>>1]=d;j[e+(h<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=f|2;i=s+t*+(j[a+(b<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;h=f|3;i=s+t*+(j[a+(h<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}c=~~i;j[e+(b<<1)>>1]=d;j[e+(h<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;f=f+4|0}while((f|0)<=(l|0));if(n){d=m;do{i=s+t*+(j[a+(d<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}f=~~i;j[e+(d<<1)>>1]=f>>>0<65536?f:(f|0)>0?65535:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+(q<<1)|0;a=a+(r<<1)|0;g=g+-1|0}}return}function jX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=b>>>2;q=f>>>1;if(!g)return;l=v+-4|0;m=((l|0)>3?l:3)+4&-4;if((v|0)<4){f=(v|0)>0;b=e;h=a;while(1){g=g+-1|0;if(f){d=0;do{i=s+t*+(k[h+(d<<2)>>2]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}n=~~i;j[b+(d<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{b=b+(q<<1)|0;h=h+(r<<2)|0}}return}n=(m|0)<(v|0);while(1){f=0;do{i=s+t*+(k[a+(f<<2)>>2]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;h=f|1;i=s+t*+(k[a+(h<<2)>>2]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}b=~~i;j[e+(f<<1)>>1]=d;j[e+(h<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=f|2;i=s+t*+(k[a+(b<<2)>>2]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;h=f|3;i=s+t*+(k[a+(h<<2)>>2]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}c=~~i;j[e+(b<<1)>>1]=d;j[e+(h<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;f=f+4|0}while((f|0)<=(l|0));g=g+-1|0;if(n){d=m;do{i=s+t*+(k[a+(d<<2)>>2]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}f=~~i;j[e+(d<<1)>>1]=f>>>0<65536?f:(f|0)>0?65535:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+(q<<1)|0;a=a+(r<<2)|0}}return}function kX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;n=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=b>>>2;q=f>>>1;g=n+-1|0;if(!n)return;if((v|0)<4){if((v|0)>0){b=e;h=a}else return;while(1){d=0;do{i=s+t*+o[h+(d<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}n=~~i;j[b+(d<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;d=d+1|0}while((d|0)!=(v|0));if(!g)break;else{b=b+(q<<1)|0;h=h+(r<<2)|0;g=g+-1|0}}return}l=v+-4|0;m=((l|0)>3?l:3)+4&-4;n=(m|0)<(v|0);while(1){f=0;do{i=s+t*+o[a+(f<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;h=f|1;i=s+t*+o[a+(h<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}b=~~i;j[e+(f<<1)>>1]=d;j[e+(h<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=f|2;i=s+t*+o[a+(b<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;h=f|3;i=s+t*+o[a+(h<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}c=~~i;j[e+(b<<1)>>1]=d;j[e+(h<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;f=f+4|0}while((f|0)<=(l|0));if(n){d=m;do{i=s+t*+o[a+(d<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}f=~~i;j[e+(d<<1)>>1]=f>>>0<65536?f:(f|0)>0?65535:0;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+(q<<1)|0;a=a+(r<<2)|0;g=g+-1|0}}return}function lX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0,n=0,o=0.0,q=0,r=0.0,s=0,t=0,v=0;t=k[g>>2]|0;n=k[g+4>>2]|0;s=b>>>3;q=f>>>1;b=n+-1|0;if(!n)return;r=+p[h>>3];o=+p[h+8>>3];if((t|0)<4){if((t|0)>0){f=e;g=a}else return;while(1){d=0;do{i=o+r*+p[g+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;n=c&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}n=~~i;j[f+(d<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;d=d+1|0}while((d|0)!=(t|0));if(!b)break;else{f=f+(q<<1)|0;g=g+(s<<3)|0;b=b+-1|0}}return}l=t+-4|0;m=((l|0)>3?l:3)+4&-4;n=(m|0)<(t|0);while(1){h=0;do{i=o+r*+p[a+(h<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;g=h|1;i=o+r*+p[a+(g<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}f=~~i;j[e+(h<<1)>>1]=d;j[e+(g<<1)>>1]=f>>>0<65536?f:(f|0)>0?65535:0;f=h|2;i=o+r*+p[a+(f<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;g=c&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=(d>>>0<65536?d:(d|0)>0?65535:0)&65535;g=h|3;i=o+r*+p[a+(g<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}v=~~i;j[e+(f<<1)>>1]=d;j[e+(g<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;h=h+4|0}while((h|0)<=(l|0));if(n){d=m;do{i=o+r*+p[a+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}v=~~i;j[e+(d<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;d=d+1|0}while((d|0)!=(t|0))}if(!b)break;else{e=e+(q<<1)|0;a=a+(s<<3)|0;b=b+-1|0}}return}function mX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,m=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];s=f>>>1;if(!g)return;n=w+-4|0;if((w|0)<4){m=(w|0)>0;f=e;h=a;while(1){g=g+-1|0;if(m){d=0;do{i=t+v*+(l[h+d>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}r=~~i;j[f+(d<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{f=f+(s<<1)|0;h=h+b|0}}return}q=w&-4;r=(q|0)<(w|0);while(1){m=0;do{i=t+v*+(l[a+m>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;h=m|1;i=t+v*+(l[a+h>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}f=~~i;j[e+(m<<1)>>1]=d;j[e+(h<<1)>>1]=(f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768;f=m|2;i=t+v*+(l[a+f>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;h=m|3;i=t+v*+(l[a+h>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}c=~~i;j[e+(f<<1)>>1]=d;j[e+(h<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;m=m+4|0}while((m|0)<=(n|0));g=g+-1|0;if(r){d=q;do{i=t+v*+(l[a+d>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}m=~~i;j[e+(d<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+(s<<1)|0;a=a+b|0}}return}function nX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0.0,m=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;g=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];s=f>>>1;if(!g)return;n=w+-4|0;if((w|0)<4){m=(w|0)>0;f=e;h=a;while(1){g=g+-1|0;if(m){d=0;do{l=t+v*+(i[h+d>>0]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}r=~~l;j[f+(d<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{f=f+(s<<1)|0;h=h+b|0}}return}q=w&-4;r=(q|0)<(w|0);while(1){m=0;do{l=t+v*+(i[a+m>>0]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}d=~~l;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;h=m|1;l=t+v*+(i[a+h>>0]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}f=~~l;j[e+(m<<1)>>1]=d;j[e+(h<<1)>>1]=(f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768;f=m|2;l=t+v*+(i[a+f>>0]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}d=~~l;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;h=m|3;l=t+v*+(i[a+h>>0]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}c=~~l;j[e+(f<<1)>>1]=d;j[e+(h<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;m=m+4|0}while((m|0)<=(n|0));g=g+-1|0;if(r){d=q;do{l=t+v*+(i[a+d>>0]|0);c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}m=~~l;j[e+(d<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+(s<<1)|0;a=a+b|0}}return}function oX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,n=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0;w=k[g>>2]|0;q=k[g+4>>2]|0;v=+p[h>>3];t=+p[h+8>>3];s=b>>>1;r=f>>>1;g=q+-1|0;if(!q)return;if((w|0)<4){if((w|0)>0){b=e;h=a}else return;while(1){d=0;do{i=t+v*+(m[h+(d<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}q=~~i;j[b+(d<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;d=d+1|0}while((d|0)!=(w|0));if(!g)break;else{b=b+(r<<1)|0;h=h+(s<<1)|0;g=g+-1|0}}return}l=w+-4|0;n=((l|0)>3?l:3)+4&-4;q=(n|0)<(w|0);while(1){f=0;do{i=t+v*+(m[a+(f<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;h=f|1;i=t+v*+(m[a+(h<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}b=~~i;j[e+(f<<1)>>1]=d;j[e+(h<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=f|2;i=t+v*+(m[a+(b<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;h=f|3;i=t+v*+(m[a+(h<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}c=~~i;j[e+(b<<1)>>1]=d;j[e+(h<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;f=f+4|0}while((f|0)<=(l|0));if(q){d=n;do{i=t+v*+(m[a+(d<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}f=~~i;j[e+(d<<1)>>1]=(f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768;d=d+1|0}while((d|0)!=(w|0))}if(!g)break;else{e=e+(r<<1)|0;a=a+(s<<1)|0;g=g+-1|0}}return}function pX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0.0,n=0.0,q=0;q=k[g>>2]|0;c=k[g+4>>2]|0;n=+p[h>>3];m=+p[h+8>>3];l=b>>>1;b=f>>>1;if((q|0)>0&(c|0)!=0){h=e;g=c}else return;while(1){d=0;do{i=m+n*+(j[a+(d<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}e=~~i;j[h+(d<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;d=d+1|0}while((d|0)!=(q|0));g=g+-1|0;if(!g)break;else{a=a+(l<<1)|0;h=h+(b<<1)|0}}return}function qX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=b>>>2;q=f>>>1;if(!g)return;l=v+-4|0;m=((l|0)>3?l:3)+4&-4;if((v|0)<4){f=(v|0)>0;b=e;h=a;while(1){g=g+-1|0;if(f){d=0;do{i=s+t*+(k[h+(d<<2)>>2]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}n=~~i;j[b+(d<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{b=b+(q<<1)|0;h=h+(r<<2)|0}}return}n=(m|0)<(v|0);while(1){f=0;do{i=s+t*+(k[a+(f<<2)>>2]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;h=f|1;i=s+t*+(k[a+(h<<2)>>2]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}b=~~i;j[e+(f<<1)>>1]=d;j[e+(h<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=f|2;i=s+t*+(k[a+(b<<2)>>2]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;h=f|3;i=s+t*+(k[a+(h<<2)>>2]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}c=~~i;j[e+(b<<1)>>1]=d;j[e+(h<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;f=f+4|0}while((f|0)<=(l|0));g=g+-1|0;if(n){d=m;do{i=s+t*+(k[a+(d<<2)>>2]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}f=~~i;j[e+(d<<1)>>1]=(f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+(q<<1)|0;a=a+(r<<2)|0}}return}function rX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;n=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=b>>>2;q=f>>>1;g=n+-1|0;if(!n)return;if((v|0)<4){if((v|0)>0){b=e;h=a}else return;while(1){d=0;do{i=s+t*+o[h+(d<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}n=~~i;j[b+(d<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;d=d+1|0}while((d|0)!=(v|0));if(!g)break;else{b=b+(q<<1)|0;h=h+(r<<2)|0;g=g+-1|0}}return}l=v+-4|0;m=((l|0)>3?l:3)+4&-4;n=(m|0)<(v|0);while(1){f=0;do{i=s+t*+o[a+(f<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;h=f|1;i=s+t*+o[a+(h<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}b=~~i;j[e+(f<<1)>>1]=d;j[e+(h<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=f|2;i=s+t*+o[a+(b<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;h=f|3;i=s+t*+o[a+(h<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}c=~~i;j[e+(b<<1)>>1]=d;j[e+(h<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;f=f+4|0}while((f|0)<=(l|0));if(n){d=m;do{i=s+t*+o[a+(d<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}f=~~i;j[e+(d<<1)>>1]=(f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+(q<<1)|0;a=a+(r<<2)|0;g=g+-1|0}}return}function sX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0,n=0,o=0.0,q=0,r=0.0,s=0,t=0,v=0;t=k[g>>2]|0;n=k[g+4>>2]|0;s=b>>>3;q=f>>>1;b=n+-1|0;if(!n)return;r=+p[h>>3];o=+p[h+8>>3];if((t|0)<4){if((t|0)>0){f=e;g=a}else return;while(1){d=0;do{i=o+r*+p[g+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;n=c&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}n=~~i;j[f+(d<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;d=d+1|0}while((d|0)!=(t|0));if(!b)break;else{f=f+(q<<1)|0;g=g+(s<<3)|0;b=b+-1|0}}return}l=t+-4|0;m=((l|0)>3?l:3)+4&-4;n=(m|0)<(t|0);while(1){h=0;do{i=o+r*+p[a+(h<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;g=h|1;i=o+r*+p[a+(g<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}f=~~i;j[e+(h<<1)>>1]=d;j[e+(g<<1)>>1]=(f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768;f=h|2;i=o+r*+p[a+(f<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;g=c&2146435072;if(!(g>>>0>1126170624|(g|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;d=((d+32768|0)>>>0<65536?d:(d|0)>0?32767:32768)&65535;g=h|3;i=o+r*+p[a+(g<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}v=~~i;j[e+(f<<1)>>1]=d;j[e+(g<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;h=h+4|0}while((h|0)<=(l|0));if(n){d=m;do{i=o+r*+p[a+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;v=c&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}v=~~i;j[e+(d<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d=d+1|0}while((d|0)!=(t|0))}if(!b)break;else{e=e+(q<<1)|0;a=a+(s<<3)|0;b=b+-1|0}}return}function tX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=f>>>2;if(!g)return;m=v+-4|0;if((v|0)<4){j=(v|0)>0;f=e;h=a;while(1){g=g+-1|0;if(j){d=0;do{i=s+t*+(l[h+d>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[f+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{f=f+(r<<2)|0;h=h+b|0}}return}n=v&-4;q=(n|0)<(v|0);while(1){j=0;do{i=s+t*+(l[a+j>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;h=j|1;i=s+t*+(l[a+h>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[e+(j<<2)>>2]=d;k[e+(h<<2)>>2]=~~i;f=j|2;i=s+t*+(l[a+f>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;h=j|3;i=s+t*+(l[a+h>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[e+(f<<2)>>2]=d;k[e+(h<<2)>>2]=~~i;j=j+4|0}while((j|0)<=(m|0));g=g+-1|0;if(q){d=n;do{i=s+t*+(l[a+d>>0]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[e+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+(r<<2)|0;a=a+b|0}}return}function uX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0.0,l=0,m=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=f>>>2;if(!g)return;m=v+-4|0;if((v|0)<4){l=(v|0)>0;f=e;h=a;while(1){g=g+-1|0;if(l){d=0;do{j=s+t*+(i[h+d>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}k[f+(d<<2)>>2]=~~j;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{f=f+(r<<2)|0;h=h+b|0}}return}n=v&-4;q=(n|0)<(v|0);while(1){l=0;do{j=s+t*+(i[a+l>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;h=l|1;j=s+t*+(i[a+h>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}k[e+(l<<2)>>2]=d;k[e+(h<<2)>>2]=~~j;f=l|2;j=s+t*+(i[a+f>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}d=~~j;h=l|3;j=s+t*+(i[a+h>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}k[e+(f<<2)>>2]=d;k[e+(h<<2)>>2]=~~j;l=l+4|0}while((l|0)<=(m|0));g=g+-1|0;if(q){d=n;do{j=s+t*+(i[a+d>>0]|0);c=(o[u>>2]=j,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;j=c?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=c?-0.0:0.0}k[e+(d<<2)>>2]=~~j;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+(r<<2)|0;a=a+b|0}}return}function vX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,l=0,n=0,q=0,r=0,s=0.0,t=0.0,v=0;v=k[g>>2]|0;g=k[g+4>>2]|0;t=+p[h>>3];s=+p[h+8>>3];r=b>>>1;q=f>>>2;if(!g)return;j=v+-4|0;if((v|0)<4){f=(v|0)>0;b=e;h=a;while(1){g=g+-1|0;if(f){d=0;do{i=s+t*+(m[h+(d<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[b+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{b=b+(q<<2)|0;h=h+(r<<1)|0}}return}l=v&-4;n=(l|0)<(v|0);while(1){f=0;do{i=s+t*+(m[a+(f<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;h=f|1;i=s+t*+(m[a+(h<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[e+(f<<2)>>2]=d;k[e+(h<<2)>>2]=~~i;b=f|2;i=s+t*+(m[a+(b<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;h=f|3;i=s+t*+(m[a+(h<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[e+(b<<2)>>2]=d;k[e+(h<<2)>>2]=~~i;f=f+4|0}while((f|0)<=(j|0));g=g+-1|0;if(n){d=l;do{i=s+t*+(m[a+(d<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[e+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(v|0))}if(!g)break;else{e=e+(q<<2)|0;a=a+(r<<1)|0}}return}function wX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,l=0,m=0.0,n=0.0,q=0;q=k[g>>2]|0;c=k[g+4>>2]|0;n=+p[h>>3];m=+p[h+8>>3];l=b>>>1;b=f>>>2;if((c|0)!=0&(q|0)>0){h=e;g=c}else return;while(1){d=0;do{i=m+n*+(j[a+(d<<1)>>1]|0);c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[h+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(q|0));g=g+-1|0;if(!g)break;else{a=a+(l<<1)|0;h=h+(b<<2)|0}}return}function xX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0,t=0;s=k[g>>2]|0;g=k[g+4>>2]|0;r=+p[h>>3];q=+p[h+8>>3];o=b>>>2;n=f>>>2;if(!g)return;j=s+-4|0;if((s|0)<4){f=(s|0)>0;b=e;h=a;while(1){g=g+-1|0;if(f){d=0;do{i=q+r*+(k[h+(d<<2)>>2]|0);p[u>>3]=i;c=k[u+4>>2]|0;m=c&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}k[b+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(s|0))}if(!g)break;else{b=b+(n<<2)|0;h=h+(o<<2)|0}}return}l=s&-4;m=(l|0)<(s|0);while(1){f=0;do{i=q+r*+(k[a+(f<<2)>>2]|0);p[u>>3]=i;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;h=f|1;i=q+r*+(k[a+(h<<2)>>2]|0);p[u>>3]=i;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}k[e+(f<<2)>>2]=d;k[e+(h<<2)>>2]=~~i;b=f|2;i=q+r*+(k[a+(b<<2)>>2]|0);p[u>>3]=i;c=k[u+4>>2]|0;h=c&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;h=f|3;i=q+r*+(k[a+(h<<2)>>2]|0);p[u>>3]=i;c=k[u+4>>2]|0;t=c&2146435072;if(!(t>>>0>1126170624|(t|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}k[e+(b<<2)>>2]=d;k[e+(h<<2)>>2]=~~i;f=f+4|0}while((f|0)<=(j|0));g=g+-1|0;if(m){d=l;do{i=q+r*+(k[a+(d<<2)>>2]|0);p[u>>3]=i;c=k[u+4>>2]|0;t=c&2146435072;if(!(t>>>0>1126170624|(t|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}k[e+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(s|0))}if(!g)break;else{e=e+(n<<2)|0;a=a+(o<<2)|0}}return}function yX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,l=0,m=0,n=0,q=0,r=0.0,s=0.0,t=0;t=k[g>>2]|0;g=k[g+4>>2]|0;s=+p[h>>3];r=+p[h+8>>3];q=b>>>2;n=f>>>2;if(!g)return;j=t+-4|0;if((t|0)<4){f=(t|0)>0;b=e;h=a;while(1){g=g+-1|0;if(f){d=0;do{i=r+s*+o[h+(d<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[b+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(t|0))}if(!g)break;else{b=b+(n<<2)|0;h=h+(q<<2)|0}}return}l=t&-4;m=(l|0)<(t|0);while(1){f=0;do{i=r+s*+o[a+(f<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;h=f|1;i=r+s*+o[a+(h<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[e+(f<<2)>>2]=d;k[e+(h<<2)>>2]=~~i;b=f|2;i=r+s*+o[a+(b<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;h=f|3;i=r+s*+o[a+(h<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[e+(b<<2)>>2]=d;k[e+(h<<2)>>2]=~~i;f=f+4|0}while((f|0)<=(j|0));g=g+-1|0;if(m){d=l;do{i=r+s*+o[a+(d<<2)>>2];c=(o[u>>2]=i,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;i=c?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=c?-0.0:0.0}k[e+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(t|0))}if(!g)break;else{e=e+(n<<2)|0;a=a+(q<<2)|0}}return}function zX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0,t=0;s=k[g>>2]|0;g=k[g+4>>2]|0;r=+p[h>>3];q=+p[h+8>>3];o=b>>>3;n=f>>>2;if(!g)return;j=s+-4|0;if((s|0)<4){f=(s|0)>0;b=e;h=a;while(1){g=g+-1|0;if(f){d=0;do{i=q+r*+p[h+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;m=c&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}k[b+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(s|0))}if(!g)break;else{b=b+(n<<2)|0;h=h+(o<<3)|0}}return}l=s&-4;m=(l|0)<(s|0);while(1){f=0;do{i=q+r*+p[a+(f<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;h=f|1;i=q+r*+p[a+(h<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;b=c&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}k[e+(f<<2)>>2]=d;k[e+(h<<2)>>2]=~~i;b=f|2;i=q+r*+p[a+(b<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;h=c&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}d=~~i;h=f|3;i=q+r*+p[a+(h<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;t=c&2146435072;if(!(t>>>0>1126170624|(t|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}k[e+(b<<2)>>2]=d;k[e+(h<<2)>>2]=~~i;f=f+4|0}while((f|0)<=(j|0));g=g+-1|0;if(m){d=l;do{i=q+r*+p[a+(d<<3)>>3];p[u>>3]=i;c=k[u+4>>2]|0;t=c&2146435072;if(!(t>>>0>1126170624|(t|0)==1126170624&0>0)){c=(c|0)<0;i=c?i+-4503599627370496.0+4503599627370496.0:i+4503599627370496.0+-4503599627370496.0;if(i==0.0)i=c?-0.0:0.0}k[e+(d<<2)>>2]=~~i;d=d+1|0}while((d|0)!=(s|0))}if(!g)break;else{e=e+(n<<2)|0;a=a+(o<<3)|0}}return}function AX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,m=0,n=0.0,q=0.0,r=0,s=0.0;r=k[g>>2]|0;d=k[g+4>>2]|0;q=+p[h>>3];n=+p[h+8>>3];m=f>>>2;if(!d)return;f=r+-4|0;if((r|0)<4){f=(r|0)>0;h=e;g=a;while(1){d=d+-1|0;if(f){c=0;do{o[h+(c<<2)>>2]=n+q*+(l[g+c>>0]|0);c=c+1|0}while((c|0)!=(r|0))}if(!d)break;else{h=h+(m<<2)|0;g=g+b|0}}return}i=r&-4;j=(i|0)<(r|0);h=e;g=a;while(1){c=0;do{e=c|1;s=n+q*+(l[g+e>>0]|0);o[h+(c<<2)>>2]=n+q*+(l[g+c>>0]|0);o[h+(e<<2)>>2]=s;e=c|2;a=c|3;s=n+q*+(l[g+a>>0]|0);o[h+(e<<2)>>2]=n+q*+(l[g+e>>0]|0);o[h+(a<<2)>>2]=s;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(j){c=i;do{o[h+(c<<2)>>2]=n+q*+(l[g+c>>0]|0);c=c+1|0}while((c|0)!=(r|0))}if(!d)break;else{h=h+(m<<2)|0;g=g+b|0}}return}function BX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0.0,q=0.0,r=0,s=0.0;r=k[g>>2]|0;d=k[g+4>>2]|0;q=+p[h>>3];n=+p[h+8>>3];m=f>>>2;if(!d)return;f=r+-4|0;if((r|0)<4){f=(r|0)>0;h=e;g=a;while(1){d=d+-1|0;if(f){c=0;do{o[h+(c<<2)>>2]=n+q*+(i[g+c>>0]|0);c=c+1|0}while((c|0)!=(r|0))}if(!d)break;else{h=h+(m<<2)|0;g=g+b|0}}return}j=r&-4;l=(j|0)<(r|0);h=e;g=a;while(1){c=0;do{e=c|1;s=n+q*+(i[g+e>>0]|0);o[h+(c<<2)>>2]=n+q*+(i[g+c>>0]|0);o[h+(e<<2)>>2]=s;e=c|2;a=c|3;s=n+q*+(i[g+a>>0]|0);o[h+(e<<2)>>2]=n+q*+(i[g+e>>0]|0);o[h+(a<<2)>>2]=s;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(l){c=j;do{o[h+(c<<2)>>2]=n+q*+(i[g+c>>0]|0);c=c+1|0}while((c|0)!=(r|0))}if(!d)break;else{h=h+(m<<2)|0;g=g+b|0}}return}function CX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,n=0.0,q=0.0,r=0.0;j=k[g>>2]|0;g=k[g+4>>2]|0;q=+p[h>>3];n=+p[h+8>>3];l=b>>>1;i=f>>>2;d=g+-1|0;if(!g)return;if((j|0)<4){if((j|0)>0){h=e;g=a}else return;while(1){c=0;do{o[h+(c<<2)>>2]=n+q*+(m[g+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(j|0));if(!d)break;else{h=h+(i<<2)|0;g=g+(l<<1)|0;d=d+-1|0}}return}f=j+-4|0;b=((f|0)>3?f:3)+4&-4;if((b|0)<(j|0)){h=e;g=a}else{h=e;g=a;while(1){c=0;do{a=c|1;r=n+q*+(m[g+(a<<1)>>1]|0);o[h+(c<<2)>>2]=n+q*+(m[g+(c<<1)>>1]|0);o[h+(a<<2)>>2]=r;a=c|2;j=c|3;r=n+q*+(m[g+(j<<1)>>1]|0);o[h+(a<<2)>>2]=n+q*+(m[g+(a<<1)>>1]|0);o[h+(j<<2)>>2]=r;c=c+4|0}while((c|0)<=(f|0));if(!d)break;else{h=h+(i<<2)|0;g=g+(l<<1)|0;d=d+-1|0}}return}while(1){c=0;do{e=c|1;r=n+q*+(m[g+(e<<1)>>1]|0);o[h+(c<<2)>>2]=n+q*+(m[g+(c<<1)>>1]|0);o[h+(e<<2)>>2]=r;e=c|2;a=c|3;r=n+q*+(m[g+(a<<1)>>1]|0);o[h+(e<<2)>>2]=n+q*+(m[g+(e<<1)>>1]|0);o[h+(a<<2)>>2]=r;c=c+4|0}while((c|0)<=(f|0));c=b;do{o[h+(c<<2)>>2]=n+q*+(m[g+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(j|0));if(!d)break;else{h=h+(i<<2)|0;g=g+(l<<1)|0;d=d+-1|0}}return}function DX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,l=0,m=0,n=0.0,q=0.0,r=0.0;l=k[g>>2]|0;g=k[g+4>>2]|0;q=+p[h>>3];n=+p[h+8>>3];m=b>>>1;i=f>>>2;d=g+-1|0;if(!g)return;if((l|0)<4){if((l|0)>0){h=e;g=a}else return;while(1){c=0;do{o[h+(c<<2)>>2]=n+q*+(j[g+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(l|0));if(!d)break;else{h=h+(i<<2)|0;g=g+(m<<1)|0;d=d+-1|0}}return}f=l+-4|0;b=((f|0)>3?f:3)+4&-4;if((b|0)<(l|0)){h=e;g=a}else{h=e;g=a;while(1){c=0;do{a=c|1;r=n+q*+(j[g+(a<<1)>>1]|0);o[h+(c<<2)>>2]=n+q*+(j[g+(c<<1)>>1]|0);o[h+(a<<2)>>2]=r;a=c|2;l=c|3;r=n+q*+(j[g+(l<<1)>>1]|0);o[h+(a<<2)>>2]=n+q*+(j[g+(a<<1)>>1]|0);o[h+(l<<2)>>2]=r;c=c+4|0}while((c|0)<=(f|0));if(!d)break;else{h=h+(i<<2)|0;g=g+(m<<1)|0;d=d+-1|0}}return}while(1){c=0;do{e=c|1;r=n+q*+(j[g+(e<<1)>>1]|0);o[h+(c<<2)>>2]=n+q*+(j[g+(c<<1)>>1]|0);o[h+(e<<2)>>2]=r;e=c|2;a=c|3;r=n+q*+(j[g+(a<<1)>>1]|0);o[h+(e<<2)>>2]=n+q*+(j[g+(e<<1)>>1]|0);o[h+(a<<2)>>2]=r;c=c+4|0}while((c|0)<=(f|0));c=b;do{o[h+(c<<2)>>2]=n+q*+(j[g+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(l|0));if(!d)break;else{h=h+(i<<2)|0;g=g+(m<<1)|0;d=d+-1|0}}return}function EX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0.0,n=0.0,q=0,r=0.0;q=k[g>>2]|0;d=k[g+4>>2]|0;n=+p[h>>3];m=+p[h+8>>3];l=b>>>2;j=f>>>2;if(!d)return;b=q+-4|0;f=((b|0)>3?b:3)+4&-4;if((q|0)<4){b=(q|0)>0;h=e;g=a;while(1){d=d+-1|0;if(b){c=0;do{o[h+(c<<2)>>2]=m+n*+(k[g+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(q|0))}if(!d)break;else{h=h+(j<<2)|0;g=g+(l<<2)|0}}return}i=(f|0)<(q|0);h=e;g=a;while(1){c=0;do{e=c|1;r=m+n*+(k[g+(e<<2)>>2]|0);o[h+(c<<2)>>2]=m+n*+(k[g+(c<<2)>>2]|0);o[h+(e<<2)>>2]=r;e=c|2;a=c|3;r=m+n*+(k[g+(a<<2)>>2]|0);o[h+(e<<2)>>2]=m+n*+(k[g+(e<<2)>>2]|0);o[h+(a<<2)>>2]=r;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(i){c=f;do{o[h+(c<<2)>>2]=m+n*+(k[g+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(q|0))}if(!d)break;else{h=h+(j<<2)|0;g=g+(l<<2)|0}}return}function FX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0.0,n=0.0,q=0.0;j=k[g>>2]|0;g=k[g+4>>2]|0;n=+p[h>>3];m=+p[h+8>>3];l=b>>>2;i=f>>>2;d=g+-1|0;if(!g)return;if((j|0)<4){if((j|0)>0){h=e;g=a}else return;while(1){c=0;do{o[h+(c<<2)>>2]=m+n*+o[g+(c<<2)>>2];c=c+1|0}while((c|0)!=(j|0));if(!d)break;else{h=h+(i<<2)|0;g=g+(l<<2)|0;d=d+-1|0}}return}f=j+-4|0;b=((f|0)>3?f:3)+4&-4;if((b|0)<(j|0)){h=e;g=a}else{h=e;g=a;while(1){c=0;do{a=c|1;q=m+n*+o[g+(a<<2)>>2];o[h+(c<<2)>>2]=m+n*+o[g+(c<<2)>>2];o[h+(a<<2)>>2]=q;a=c|2;j=c|3;q=m+n*+o[g+(j<<2)>>2];o[h+(a<<2)>>2]=m+n*+o[g+(a<<2)>>2];o[h+(j<<2)>>2]=q;c=c+4|0}while((c|0)<=(f|0));if(!d)break;else{h=h+(i<<2)|0;g=g+(l<<2)|0;d=d+-1|0}}return}while(1){c=0;do{e=c|1;q=m+n*+o[g+(e<<2)>>2];o[h+(c<<2)>>2]=m+n*+o[g+(c<<2)>>2];o[h+(e<<2)>>2]=q;e=c|2;a=c|3;q=m+n*+o[g+(a<<2)>>2];o[h+(e<<2)>>2]=m+n*+o[g+(e<<2)>>2];o[h+(a<<2)>>2]=q;c=c+4|0}while((c|0)<=(f|0));c=b;do{o[h+(c<<2)>>2]=m+n*+o[g+(c<<2)>>2];c=c+1|0}while((c|0)!=(j|0));if(!d)break;else{h=h+(i<<2)|0;g=g+(l<<2)|0;d=d+-1|0}}return}function GX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0.0,n=0.0,q=0.0;j=k[g>>2]|0;g=k[g+4>>2]|0;n=+p[h>>3];m=+p[h+8>>3];l=b>>>3;i=f>>>2;d=g+-1|0;if(!g)return;if((j|0)<4){if((j|0)>0){h=e;g=a}else return;while(1){c=0;do{o[h+(c<<2)>>2]=m+n*+p[g+(c<<3)>>3];c=c+1|0}while((c|0)!=(j|0));if(!d)break;else{h=h+(i<<2)|0;g=g+(l<<3)|0;d=d+-1|0}}return}f=j+-4|0;b=((f|0)>3?f:3)+4&-4;if((b|0)<(j|0)){h=e;g=a}else{h=e;g=a;while(1){c=0;do{a=c|1;q=m+n*+p[g+(a<<3)>>3];o[h+(c<<2)>>2]=m+n*+p[g+(c<<3)>>3];o[h+(a<<2)>>2]=q;a=c|2;j=c|3;q=m+n*+p[g+(j<<3)>>3];o[h+(a<<2)>>2]=m+n*+p[g+(a<<3)>>3];o[h+(j<<2)>>2]=q;c=c+4|0}while((c|0)<=(f|0));if(!d)break;else{h=h+(i<<2)|0;g=g+(l<<3)|0;d=d+-1|0}}return}while(1){c=0;do{e=c|1;q=m+n*+p[g+(e<<3)>>3];o[h+(c<<2)>>2]=m+n*+p[g+(c<<3)>>3];o[h+(e<<2)>>2]=q;e=c|2;a=c|3;q=m+n*+p[g+(a<<3)>>3];o[h+(e<<2)>>2]=m+n*+p[g+(e<<3)>>3];o[h+(a<<2)>>2]=q;c=c+4|0}while((c|0)<=(f|0));c=b;do{o[h+(c<<2)>>2]=m+n*+p[g+(c<<3)>>3];c=c+1|0}while((c|0)!=(j|0));if(!d)break;else{h=h+(i<<2)|0;g=g+(l<<3)|0;d=d+-1|0}}return}function HX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,m=0,n=0.0,o=0.0,q=0,r=0.0;q=k[g>>2]|0;d=k[g+4>>2]|0;o=+p[h>>3];n=+p[h+8>>3];m=f>>>3;if(!d)return;f=q+-4|0;if((q|0)<4){f=(q|0)>0;h=e;g=a;while(1){d=d+-1|0;if(f){c=0;do{p[h+(c<<3)>>3]=n+o*+(l[g+c>>0]|0);c=c+1|0}while((c|0)!=(q|0))}if(!d)break;else{h=h+(m<<3)|0;g=g+b|0}}return}i=q&-4;j=(i|0)<(q|0);h=e;g=a;while(1){c=0;do{e=c|1;r=n+o*+(l[g+e>>0]|0);p[h+(c<<3)>>3]=n+o*+(l[g+c>>0]|0);p[h+(e<<3)>>3]=r;e=c|2;a=c|3;r=n+o*+(l[g+a>>0]|0);p[h+(e<<3)>>3]=n+o*+(l[g+e>>0]|0);p[h+(a<<3)>>3]=r;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(j){c=i;do{p[h+(c<<3)>>3]=n+o*+(l[g+c>>0]|0);c=c+1|0}while((c|0)!=(q|0))}if(!d)break;else{h=h+(m<<3)|0;g=g+b|0}}return}function IX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0;q=k[g>>2]|0;d=k[g+4>>2]|0;o=+p[h>>3];n=+p[h+8>>3];m=f>>>3;if(!d)return;f=q+-4|0;if((q|0)<4){f=(q|0)>0;h=e;g=a;while(1){d=d+-1|0;if(f){c=0;do{p[h+(c<<3)>>3]=n+o*+(i[g+c>>0]|0);c=c+1|0}while((c|0)!=(q|0))}if(!d)break;else{h=h+(m<<3)|0;g=g+b|0}}return}j=q&-4;l=(j|0)<(q|0);h=e;g=a;while(1){c=0;do{e=c|1;r=n+o*+(i[g+e>>0]|0);p[h+(c<<3)>>3]=n+o*+(i[g+c>>0]|0);p[h+(e<<3)>>3]=r;e=c|2;a=c|3;r=n+o*+(i[g+a>>0]|0);p[h+(e<<3)>>3]=n+o*+(i[g+e>>0]|0);p[h+(a<<3)>>3]=r;c=c+4|0}while((c|0)<=(f|0));d=d+-1|0;if(l){c=j;do{p[h+(c<<3)>>3]=n+o*+(i[g+c>>0]|0);c=c+1|0}while((c|0)!=(q|0))}if(!d)break;else{h=h+(m<<3)|0;g=g+b|0}}return}function JX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,n=0.0,o=0.0,q=0.0;j=k[g>>2]|0;g=k[g+4>>2]|0;o=+p[h>>3];n=+p[h+8>>3];l=b>>>1;i=f>>>3;d=g+-1|0;if(!g)return;if((j|0)<4){if((j|0)>0){h=e;g=a}else return;while(1){c=0;do{p[h+(c<<3)>>3]=n+o*+(m[g+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(j|0));if(!d)break;else{h=h+(i<<3)|0;g=g+(l<<1)|0;d=d+-1|0}}return}f=j+-4|0;b=((f|0)>3?f:3)+4&-4;if((b|0)<(j|0)){h=e;g=a}else{h=e;g=a;while(1){c=0;do{a=c|1;q=n+o*+(m[g+(a<<1)>>1]|0);p[h+(c<<3)>>3]=n+o*+(m[g+(c<<1)>>1]|0);p[h+(a<<3)>>3]=q;a=c|2;j=c|3;q=n+o*+(m[g+(j<<1)>>1]|0);p[h+(a<<3)>>3]=n+o*+(m[g+(a<<1)>>1]|0);p[h+(j<<3)>>3]=q;c=c+4|0}while((c|0)<=(f|0));if(!d)break;else{h=h+(i<<3)|0;g=g+(l<<1)|0;d=d+-1|0}}return}while(1){c=0;do{e=c|1;q=n+o*+(m[g+(e<<1)>>1]|0);p[h+(c<<3)>>3]=n+o*+(m[g+(c<<1)>>1]|0);p[h+(e<<3)>>3]=q;e=c|2;a=c|3;q=n+o*+(m[g+(a<<1)>>1]|0);p[h+(e<<3)>>3]=n+o*+(m[g+(e<<1)>>1]|0);p[h+(a<<3)>>3]=q;c=c+4|0}while((c|0)<=(f|0));c=b;do{p[h+(c<<3)>>3]=n+o*+(m[g+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(j|0));if(!d)break;else{h=h+(i<<3)|0;g=g+(l<<1)|0;d=d+-1|0}}return}function KX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,l=0,m=0,n=0.0,o=0.0,q=0.0;l=k[g>>2]|0;g=k[g+4>>2]|0;o=+p[h>>3];n=+p[h+8>>3];m=b>>>1;i=f>>>3;d=g+-1|0;if(!g)return;if((l|0)<4){if((l|0)>0){h=e;g=a}else return;while(1){c=0;do{p[h+(c<<3)>>3]=n+o*+(j[g+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(l|0));if(!d)break;else{h=h+(i<<3)|0;g=g+(m<<1)|0;d=d+-1|0}}return}f=l+-4|0;b=((f|0)>3?f:3)+4&-4;if((b|0)<(l|0)){h=e;g=a}else{h=e;g=a;while(1){c=0;do{a=c|1;q=n+o*+(j[g+(a<<1)>>1]|0);p[h+(c<<3)>>3]=n+o*+(j[g+(c<<1)>>1]|0);p[h+(a<<3)>>3]=q;a=c|2;l=c|3;q=n+o*+(j[g+(l<<1)>>1]|0);p[h+(a<<3)>>3]=n+o*+(j[g+(a<<1)>>1]|0);p[h+(l<<3)>>3]=q;c=c+4|0}while((c|0)<=(f|0));if(!d)break;else{h=h+(i<<3)|0;g=g+(m<<1)|0;d=d+-1|0}}return}while(1){c=0;do{e=c|1;q=n+o*+(j[g+(e<<1)>>1]|0);p[h+(c<<3)>>3]=n+o*+(j[g+(c<<1)>>1]|0);p[h+(e<<3)>>3]=q;e=c|2;a=c|3;q=n+o*+(j[g+(a<<1)>>1]|0);p[h+(e<<3)>>3]=n+o*+(j[g+(e<<1)>>1]|0);p[h+(a<<3)>>3]=q;c=c+4|0}while((c|0)<=(f|0));c=b;do{p[h+(c<<3)>>3]=n+o*+(j[g+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(l|0));if(!d)break;else{h=h+(i<<3)|0;g=g+(m<<1)|0;d=d+-1|0}}return}function LX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0.0,n=0.0,o=0,q=0.0;o=k[g>>2]|0;d=k[g+4>>2]|0;n=+p[h>>3];m=+p[h+8>>3];l=b>>>2;j=f>>>3;if(!d)return;b=o+-4|0;f=((b|0)>3?b:3)+4&-4;if((o|0)<4){b=(o|0)>0;h=e;g=a;while(1){d=d+-1|0;if(b){c=0;do{p[h+(c<<3)>>3]=m+n*+(k[g+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{h=h+(j<<3)|0;g=g+(l<<2)|0}}return}i=(f|0)<(o|0);h=e;g=a;while(1){c=0;do{e=c|1;q=m+n*+(k[g+(e<<2)>>2]|0);p[h+(c<<3)>>3]=m+n*+(k[g+(c<<2)>>2]|0);p[h+(e<<3)>>3]=q;e=c|2;a=c|3;q=m+n*+(k[g+(a<<2)>>2]|0);p[h+(e<<3)>>3]=m+n*+(k[g+(e<<2)>>2]|0);p[h+(a<<3)>>3]=q;c=c+4|0}while((c|0)<=(b|0));d=d+-1|0;if(i){c=f;do{p[h+(c<<3)>>3]=m+n*+(k[g+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(o|0))}if(!d)break;else{h=h+(j<<3)|0;g=g+(l<<2)|0}}return}function MX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0.0,n=0.0,q=0.0;j=k[g>>2]|0;g=k[g+4>>2]|0;n=+p[h>>3];m=+p[h+8>>3];l=b>>>2;i=f>>>3;d=g+-1|0;if(!g)return;if((j|0)<4){if((j|0)>0){h=e;g=a}else return;while(1){c=0;do{p[h+(c<<3)>>3]=m+n*+o[g+(c<<2)>>2];c=c+1|0}while((c|0)!=(j|0));if(!d)break;else{h=h+(i<<3)|0;g=g+(l<<2)|0;d=d+-1|0}}return}f=j+-4|0;b=((f|0)>3?f:3)+4&-4;if((b|0)<(j|0)){h=e;g=a}else{h=e;g=a;while(1){c=0;do{a=c|1;q=m+n*+o[g+(a<<2)>>2];p[h+(c<<3)>>3]=m+n*+o[g+(c<<2)>>2];p[h+(a<<3)>>3]=q;a=c|2;j=c|3;q=m+n*+o[g+(j<<2)>>2];p[h+(a<<3)>>3]=m+n*+o[g+(a<<2)>>2];p[h+(j<<3)>>3]=q;c=c+4|0}while((c|0)<=(f|0));if(!d)break;else{h=h+(i<<3)|0;g=g+(l<<2)|0;d=d+-1|0}}return}while(1){c=0;do{e=c|1;q=m+n*+o[g+(e<<2)>>2];p[h+(c<<3)>>3]=m+n*+o[g+(c<<2)>>2];p[h+(e<<3)>>3]=q;e=c|2;a=c|3;q=m+n*+o[g+(a<<2)>>2];p[h+(e<<3)>>3]=m+n*+o[g+(e<<2)>>2];p[h+(a<<3)>>3]=q;c=c+4|0}while((c|0)<=(f|0));c=b;do{p[h+(c<<3)>>3]=m+n*+o[g+(c<<2)>>2];c=c+1|0}while((c|0)!=(j|0));if(!d)break;else{h=h+(i<<3)|0;g=g+(l<<2)|0;d=d+-1|0}}return}function NX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0.0,n=0.0,o=0.0;j=k[g>>2]|0;g=k[g+4>>2]|0;n=+p[h>>3];m=+p[h+8>>3];l=b>>>3;i=f>>>3;d=g+-1|0;if(!g)return;if((j|0)<4){if((j|0)>0){h=e;g=a}else return;while(1){c=0;do{p[h+(c<<3)>>3]=m+n*+p[g+(c<<3)>>3];c=c+1|0}while((c|0)!=(j|0));if(!d)break;else{h=h+(i<<3)|0;g=g+(l<<3)|0;d=d+-1|0}}return}f=j+-4|0;b=((f|0)>3?f:3)+4&-4;if((b|0)<(j|0)){h=e;g=a}else{h=e;g=a;while(1){c=0;do{a=c|1;o=m+n*+p[g+(a<<3)>>3];p[h+(c<<3)>>3]=m+n*+p[g+(c<<3)>>3];p[h+(a<<3)>>3]=o;a=c|2;j=c|3;o=m+n*+p[g+(j<<3)>>3];p[h+(a<<3)>>3]=m+n*+p[g+(a<<3)>>3];p[h+(j<<3)>>3]=o;c=c+4|0}while((c|0)<=(f|0));if(!d)break;else{h=h+(i<<3)|0;g=g+(l<<3)|0;d=d+-1|0}}return}while(1){c=0;do{e=c|1;o=m+n*+p[g+(e<<3)>>3];p[h+(c<<3)>>3]=m+n*+p[g+(c<<3)>>3];p[h+(e<<3)>>3]=o;e=c|2;a=c|3;o=m+n*+p[g+(a<<3)>>3];p[h+(e<<3)>>3]=m+n*+p[g+(e<<3)>>3];p[h+(a<<3)>>3]=o;c=c+4|0}while((c|0)<=(f|0));c=b;do{p[h+(c<<3)>>3]=m+n*+p[g+(c<<3)>>3];c=c+1|0}while((c|0)!=(j|0));if(!d)break;else{h=h+(i<<3)|0;g=g+(l<<3)|0;d=d+-1|0}}return}function OX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+224|0;y=z+168|0;x=z+112|0;w=z+56|0;o=z+40|0;s=z+32|0;t=z;p=((S1(a,-1)|0)>>>3&511)+1|0;d=(S1(a,-1)|0)&6;v=(S1(b,-1)|0)>>>3&511;q=v+1|0;if(!(((q|0)==(p|0)|(v|0)==0?(F2(b)|0)==256:0)?(d|1|0)==1&(H2(b)|0):0)){d=y+4|0;e=ZT(116)|0;k[e>>2]=1;f=e+4|0;k[y>>2]=f;k[d>>2]=111;i[e+115>>0]=0;g=210559;h=f+111|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,y,210671,209965,5195);k[d>>2]=0;k[y>>2]=0;v=k[e>>2]|0;k[e>>2]=v+-1;if((v|0)==1)ggb(k[e+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[y>>2]=k[g>>2];m=y+4|0;d=g+4|0;k[m>>2]=k[d>>2];v=y+8|0;k[v>>2]=k[g+8>>2];k[y+12>>2]=k[g+12>>2];k[y+16>>2]=k[g+16>>2];k[y+20>>2]=k[g+20>>2];k[y+24>>2]=k[g+24>>2];k[y+28>>2]=k[g+28>>2];k[y+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[y+36>>2]=e;f=y+40|0;k[f>>2]=v;v=y+48|0;j=y+44|0;k[j>>2]=v;k[y+52>>2]=0;k[v>>2]=0;if(e|0){v=e+12|0;k[v>>2]=(k[v>>2]|0)+1}if((k[d>>2]|0)<3){u=k[g+44>>2]|0;v=k[j>>2]|0;k[v>>2]=k[u>>2];k[v+4>>2]=k[u+4>>2];break}k[m>>2]=0;x1(y,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else Q1(y,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[x>>2]=k[g>>2];m=x+4|0;d=g+4|0;k[m>>2]=k[d>>2];v=x+8|0;k[v>>2]=k[g+8>>2];k[x+12>>2]=k[g+12>>2];k[x+16>>2]=k[g+16>>2];k[x+20>>2]=k[g+20>>2];k[x+24>>2]=k[g+24>>2];k[x+28>>2]=k[g+28>>2];k[x+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[x+36>>2]=e;f=x+40|0;k[f>>2]=v;v=x+48|0;j=x+44|0;k[j>>2]=v;k[x+52>>2]=0;k[v>>2]=0;if(e|0){v=e+12|0;k[v>>2]=(k[v>>2]|0)+1}if((k[d>>2]|0)<3){u=k[g+44>>2]|0;v=k[j>>2]|0;k[v>>2]=k[u>>2];k[v+4>>2]=k[u+4>>2];break}k[m>>2]=0;x1(x,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else Q1(x,b,-1);while(0);v=y+4|0;l=k[v>>2]|0;u=y+40|0;m=k[u>>2]|0;P1(c,l,m,(S1(b,-1)|0)&7|(p<<3)+-8,-1,0,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[w>>2]=k[g>>2];m=w+4|0;d=g+4|0;k[m>>2]=k[d>>2];c=w+8|0;k[c>>2]=k[g+8>>2];k[w+12>>2]=k[g+12>>2];k[w+16>>2]=k[g+16>>2];k[w+20>>2]=k[g+20>>2];k[w+24>>2]=k[g+24>>2];k[w+28>>2]=k[g+28>>2];k[w+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[w+36>>2]=e;f=w+40|0;k[f>>2]=c;c=w+48|0;j=w+44|0;k[j>>2]=c;k[w+52>>2]=0;k[c>>2]=0;if(e|0){c=e+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[d>>2]|0)<3){b=k[g+44>>2]|0;c=k[j>>2]|0;k[c>>2]=k[b>>2];k[c+4>>2]=k[b+4>>2];break}k[m>>2]=0;x1(w,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else Q1(w,c,-1);while(0);if((a2(a)|0)<3){i[o>>0]=0;while(1){d=fgb(24)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d>>2]=40872;k[d+4>>2]=o;k[d+8>>2]=y;k[d+12>>2]=x;k[d+16>>2]=w;f=k[x>>2]&7;k[d+20>>2]=k[40884+(f<<2)>>2];f=(f|0)!=7;i[o>>0]=f&1;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}l=e+4|0;k[l>>2]=1;k[e>>2]=40924;k[e+8>>2]=d;if(f){f=k[w+8>>2]|0;k[s>>2]=0;k[s+4>>2]=f;j=k[w+4>>2]|0;if((j|0)<3)f=aa(k[w+12>>2]|0,f)|0;else{h=k[w+40>>2]|0;g=0;f=1;do{f=aa(k[h+(g<<2)>>2]|0,f)|0;g=g+1|0}while((g|0)!=(j|0))}if(f>>>0>262143)jh[k[(k[d>>2]|0)+8>>2]&1023](d,s);else PX(d,s);if(i[o>>0]|0)d=1;else n=53}else n=53;if((n|0)==53)d=0;a=k[l>>2]|0;k[l>>2]=a+-1;if((a|0)==1)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);if(!d){d=x;n=57}}else{d=x;n=57}if((n|0)==57){n=k[d>>2]&7;j=k[40884+(n<<2)>>2]|0;if((n|0)==7){k[o>>2]=0;d=o+4|0;k[d>>2]=0;e=ZT(16)|0;k[e>>2]=1;f=e+4|0;k[o>>2]=f;k[d>>2]=9;i[e+13>>0]=0;g=335726;h=f+9|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,o,210671,209965,5230);k[d>>2]=0;k[o>>2]=0;n=k[e>>2]|0;k[e>>2]=n+-1;if((n|0)==1)ggb(k[e+-4>>2]|0)}k[o>>2]=y;k[o+4>>2]=w;k[o+8>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;k[t+16>>2]=0;k[t+20>>2]=0;k[t+24>>2]=0;k[t+28>>2]=0;z1(t,o,0,s,-1);e=k[t+20>>2]|0;f=t+16|0;g=x+16|0;h=s+4|0;d=0;while(1){if(d>>>0>=(k[f>>2]|0)>>>0)break;Lg[j&255](k[s>>2]|0,k[g>>2]|0,k[h>>2]|0,e,p,q);A1(t);d=d+1|0}}f=w+36|0;d=k[f>>2]|0;if(d|0?(s=d+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[w+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;t=w+16|0;e=w+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[e>>2]|0)>0){f=k[w+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[w+44>>2]|0;if(!((d|0)==(w+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=x+36|0;d=k[f>>2]|0;if(d|0?(t=d+12|0,w=k[t>>2]|0,k[t>>2]=w+-1,(w|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[x+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;w=x+16|0;e=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[e>>2]|0)>0){f=k[x+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[x+44>>2]|0;if(!((d|0)==(x+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=y+36|0;d=k[f>>2]|0;if(d|0?(w=d+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[y+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;x=y+16|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[v>>2]|0)>0){e=k[u>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[v>>2]|0))}d=k[y+44>>2]|0;if((d|0)==(y+48|0)|(d|0)==0){r=z;return}ggb(k[d+-4>>2]|0);r=z;return}function PX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=r;r=r+176|0;g=n+152|0;i=n+144|0;m=n+88|0;l=n+32|0;j=n;f=k[b>>2]|0;e=k[b+4>>2]|0;d=k[a+8>>2]|0;k[g>>2]=f;k[g+4>>2]=e;k[i>>2]=-2147483648;k[i+4>>2]=2147483647;H1(m,d,g,i);d=k[a+16>>2]|0;k[g>>2]=f;k[g+4>>2]=e;k[i>>2]=-2147483648;k[i+4>>2]=2147483647;H1(l,d,g,i);d=((k[m>>2]|0)>>>3&511)+1|0;e=a+12|0;f=((k[k[e>>2]>>2]|0)>>>3&511)+1|0;k[g>>2]=m;k[g+4>>2]=l;k[g+8>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;k[j+20>>2]=0;k[j+24>>2]=0;k[j+28>>2]=0;z1(j,g,0,i,-1);g=k[j+20>>2]|0;h=j+16|0;a=a+20|0;c=i+4|0;b=0;while(1){if(b>>>0>=(k[h>>2]|0)>>>0)break;Lg[k[a>>2]&255](k[i>>2]|0,k[(k[e>>2]|0)+16>>2]|0,k[c>>2]|0,g,d,f);A1(j);b=b+1|0}c=l+36|0;b=k[c>>2]|0;if(b|0?(i=b+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){a=k[c>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[l+32>>2]|0;if(!b){b=B1()|0;a=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[c>>2]=0}k[c>>2]=0;j=l+16|0;a=l+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[a>>2]|0)>0){c=k[l+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[l+44>>2]|0;if(!((b|0)==(l+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);c=m+36|0;b=k[c>>2]|0;if(b|0?(j=b+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){a=k[c>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[m+32>>2]|0;if(!b){b=B1()|0;a=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[c>>2]=0}k[c>>2]=0;l=m+16|0;a=m+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[a>>2]|0)>0){c=k[m+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[m+44>>2]|0;if((b|0)==(m+48|0)|(b|0)==0){r=n;return}ggb(k[b+-4>>2]|0);r=n;return}function QX(a){a=a|0;return}function RX(a){a=a|0;ggb(a);return}function SX(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function TX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=aa(e,d)|0;d=(g|0)>0;if((f|0)==1){if(d)d=0;else return;do{i[c+d>>0]=i[b+(l[a+d>>0]|0)>>0]|0;d=d+1|0}while((d|0)!=(g|0));return}if(!d)return;if((e|0)>0)d=0;else{d=0;do d=d+e|0;while((d|0)<(g|0));return}do{f=0;do{h=f+d|0;j=b+((aa(l[a+h>>0]|0,e)|0)+f)|0;i[c+h>>0]=i[j>>0]|0;f=f+1|0}while((f|0)!=(e|0));d=d+e|0}while((d|0)<(g|0));return}function UX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=aa(e,d)|0;d=(g|0)>0;if((f|0)==1){if(d)d=0;else return;do{i[c+d>>0]=i[b+(l[a+d>>0]|0)>>0]|0;d=d+1|0}while((d|0)!=(g|0));return}if(!d)return;if((e|0)>0)d=0;else{d=0;do d=d+e|0;while((d|0)<(g|0));return}do{f=0;do{h=f+d|0;j=b+((aa(l[a+h>>0]|0,e)|0)+f)|0;i[c+h>>0]=i[j>>0]|0;f=f+1|0}while((f|0)!=(e|0));d=d+e|0}while((d|0)<(g|0));return}function VX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=aa(e,d)|0;d=(g|0)>0;if((f|0)==1){if(d)d=0;else return;do{j[c+(d<<1)>>1]=j[b+((l[a+d>>0]|0)<<1)>>1]|0;d=d+1|0}while((d|0)!=(g|0));return}if(!d)return;if((e|0)>0)d=0;else{d=0;do d=d+e|0;while((d|0)<(g|0));return}do{f=0;do{h=f+d|0;i=b+((aa(l[a+h>>0]|0,e)|0)+f<<1)|0;j[c+(h<<1)>>1]=j[i>>1]|0;f=f+1|0}while((f|0)!=(e|0));d=d+e|0}while((d|0)<(g|0));return}function WX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=aa(e,d)|0;d=(g|0)>0;if((f|0)==1){if(d)d=0;else return;do{j[c+(d<<1)>>1]=j[b+((l[a+d>>0]|0)<<1)>>1]|0;d=d+1|0}while((d|0)!=(g|0));return}if(!d)return;if((e|0)>0)d=0;else{d=0;do d=d+e|0;while((d|0)<(g|0));return}do{f=0;do{h=f+d|0;i=b+((aa(l[a+h>>0]|0,e)|0)+f<<1)|0;j[c+(h<<1)>>1]=j[i>>1]|0;f=f+1|0}while((f|0)!=(e|0));d=d+e|0}while((d|0)<(g|0));return}function XX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=aa(e,d)|0;d=(g|0)>0;if((f|0)==1){if(d)d=0;else return;do{k[c+(d<<2)>>2]=k[b+((l[a+d>>0]|0)<<2)>>2];d=d+1|0}while((d|0)!=(g|0));return}if(!d)return;if((e|0)>0)d=0;else{d=0;do d=d+e|0;while((d|0)<(g|0));return}do{f=0;do{h=f+d|0;i=b+((aa(l[a+h>>0]|0,e)|0)+f<<2)|0;k[c+(h<<2)>>2]=k[i>>2];f=f+1|0}while((f|0)!=(e|0));d=d+e|0}while((d|0)<(g|0));return}function YX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=aa(e,d)|0;d=(g|0)>0;if((f|0)==1){if(d)d=0;else return;do{k[c+(d<<2)>>2]=k[b+((l[a+d>>0]|0)<<2)>>2];d=d+1|0}while((d|0)!=(g|0));return}if(!d)return;if((e|0)>0)d=0;else{d=0;do d=d+e|0;while((d|0)<(g|0));return}do{f=0;do{h=f+d|0;i=b+((aa(l[a+h>>0]|0,e)|0)+f<<2)|0;k[c+(h<<2)>>2]=k[i>>2];f=f+1|0}while((f|0)!=(e|0));d=d+e|0}while((d|0)<(g|0));return}function ZX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=aa(e,d)|0;d=(g|0)>0;if((f|0)==1){if(d)d=0;else return;do{p[c+(d<<3)>>3]=+p[b+((l[a+d>>0]|0)<<3)>>3];d=d+1|0}while((d|0)!=(g|0));return}if(!d)return;if((e|0)>0)d=0;else{d=0;do d=d+e|0;while((d|0)<(g|0));return}do{f=0;do{h=f+d|0;i=b+((aa(l[a+h>>0]|0,e)|0)+f<<3)|0;p[c+(h<<3)>>3]=+p[i>>3];f=f+1|0}while((f|0)!=(e|0));d=d+e|0}while((d|0)<(g|0));return}function _X(a){a=a|0;ggb(a);return}function $X(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;v=r;r=r+192|0;u=v+56|0;t=v;s=v+128|0;q=v+112|0;switch(e|0){case 32:{p[u>>3]=0.0;p[t>>3]=0.0;x=c>d?d:c;L7(a,u,t,0,0,g);w=+p[u>>3];y=+p[t>>3]-w;d=((c<d?d:c)-x)*(y>2.220446049250313e-16?1.0/y:0.0);c=d;d=x-w*d;break}case 1:case 2:case 4:{d=+N7(a,e,g);c=d>2.220446049250313e-16?c/d:0.0;d=0.0;break}default:{e=u+4|0;h=ZT(36)|0;k[h>>2]=1;l=h+4|0;k[u>>2]=l;k[e>>2]=29;i[h+33>>0]=0;j=210796;m=l+29|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(m|0));Y8(-5,u,210826,209965,5353);k[e>>2]=0;k[u>>2]=0;o=k[h>>2]|0;k[h>>2]=o+-1;if((o|0)==1)ggb(k[h+-4>>2]|0);c=1.0;d=0.0}}e=S1(a,-1)|0;h=e&4088;if((f|0)<0)if((k[b>>2]|0)<0){o=(S1(b,-1)|0)&7;e=b}else{o=e&7;e=b}else{o=f;e=b}K2(e,a,o&7|h);do if((k[a>>2]&2031616|0)==65536){m=k[a+4>>2]|0;k[u>>2]=k[m>>2];n=u+4|0;e=m+4|0;k[n>>2]=k[e>>2];f=u+8|0;k[f>>2]=k[m+8>>2];k[u+12>>2]=k[m+12>>2];k[u+16>>2]=k[m+16>>2];k[u+20>>2]=k[m+20>>2];k[u+24>>2]=k[m+24>>2];k[u+28>>2]=k[m+28>>2];k[u+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[u+36>>2]=h;j=u+40|0;k[j>>2]=f;f=u+48|0;a=u+44|0;k[a>>2]=f;k[u+52>>2]=0;k[f>>2]=0;if(h|0){f=h+12|0;k[f>>2]=(k[f>>2]|0)+1}if((k[e>>2]|0)<3){f=k[m+44>>2]|0;n=k[a>>2]|0;k[n>>2]=k[f>>2];k[n+4>>2]=k[f+4>>2];break}k[n>>2]=0;x1(u,k[e>>2]|0,0,0,0);if((k[n>>2]|0)>0){f=k[m+40>>2]|0;l=k[j>>2]|0;j=k[m+44>>2]|0;h=k[a>>2]|0;e=0;do{k[l+(e<<2)>>2]=k[f+(e<<2)>>2];k[h+(e<<2)>>2]=k[j+(e<<2)>>2];e=e+1|0}while((e|0)<(k[n>>2]|0))}}else Q1(u,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[t>>2]=k[l>>2];n=t+4|0;e=l+4|0;k[n>>2]=k[e>>2];b=t+8|0;k[b>>2]=k[l+8>>2];k[t+12>>2]=k[l+12>>2];k[t+16>>2]=k[l+16>>2];k[t+20>>2]=k[l+20>>2];k[t+24>>2]=k[l+24>>2];k[t+28>>2]=k[l+28>>2];k[t+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[t+36>>2]=h;j=t+40|0;k[j>>2]=b;b=t+48|0;f=t+44|0;k[f>>2]=b;k[t+52>>2]=0;k[b>>2]=0;if(h|0){b=h+12|0;k[b>>2]=(k[b>>2]|0)+1}if((k[e>>2]|0)<3){n=k[l+44>>2]|0;b=k[f>>2]|0;k[b>>2]=k[n>>2];k[b+4>>2]=k[n+4>>2];break}k[n>>2]=0;x1(t,k[e>>2]|0,0,0,0);if((k[n>>2]|0)>0){a=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[f>>2]|0;e=0;do{k[m+(e<<2)>>2]=k[a+(e<<2)>>2];k[h+(e<<2)>>2]=k[j+(e<<2)>>2];e=e+1|0}while((e|0)<(k[n>>2]|0))}}else Q1(t,b,-1);while(0);if(!(G2(g)|0)){k[s>>2]=1124007936;a=s+4|0;e=s+8|0;f=s+40|0;l=a;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[f>>2]=e;m=s+48|0;l=s+44|0;k[l>>2]=m;k[s+52>>2]=0;k[m>>2]=0;j=q+4|0;e=j+4|0;k[e>>2]=0;k[e+4>>2]=0;k[q>>2]=33619968;k[j>>2]=s;SW(u,q,o,c,d);j=q+4|0;e=j+4|0;k[e>>2]=0;k[e+4>>2]=0;k[q>>2]=33619968;k[j>>2]=t;nY(s,q,g);j=s+36|0;e=k[j>>2]|0;if(e|0?(q=e+12|0,g=k[q>>2]|0,k[q>>2]=g+-1,(g|0)==1):0){h=k[j>>2]|0;if(h|0){e=k[h+4>>2]|0;if(!e){e=k[s+32>>2]|0;if(!e){e=B1()|0;h=k[j>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,h)}k[j>>2]=0}k[j>>2]=0;s=s+16|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[a>>2]|0)>0){h=k[f>>2]|0;e=0;do{k[h+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[a>>2]|0))}e=k[l>>2]|0;if(!((e|0)==(m|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}else{g=s+4|0;q=g+4|0;k[q>>2]=0;k[q+4>>2]=0;k[s>>2]=33619968;k[g>>2]=t;SW(u,s,o,c,d)}j=t+36|0;e=k[j>>2]|0;if(e|0?(g=e+12|0,s=k[g>>2]|0,k[g>>2]=s+-1,(s|0)==1):0){h=k[j>>2]|0;if(h|0){e=k[h+4>>2]|0;if(!e){e=k[t+32>>2]|0;if(!e){e=B1()|0;h=k[j>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,h)}k[j>>2]=0}k[j>>2]=0;s=t+16|0;h=t+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){j=k[t+40>>2]|0;e=0;do{k[j+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[h>>2]|0))}e=k[t+44>>2]|0;if(!((e|0)==(t+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);j=u+36|0;e=k[j>>2]|0;if(e|0?(s=e+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){h=k[j>>2]|0;if(h|0){e=k[h+4>>2]|0;if(!e){e=k[u+32>>2]|0;if(!e){e=B1()|0;h=k[j>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,h)}k[j>>2]=0}k[j>>2]=0;t=u+16|0;h=u+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[h>>2]|0)>0){j=k[u+40>>2]|0;e=0;do{k[j+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[h>>2]|0))}e=k[u+44>>2]|0;if((e|0)==(u+48|0)|(e|0)==0){r=v;return}ggb(k[e+-4>>2]|0);r=v;return}function aY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+128|0;l=m+72|0;h=m+16|0;f=m;M1(l,a,0,1,0,0);M1(h,b,0,1,0,0);j=l+40|0;c=k[j>>2]|0;d=k[c+-4>>2]|0;g=h+40|0;b=k[g>>2]|0;a:do if((d|0)==(k[b+-4>>2]|0)){if((d|0)==2){if((k[c>>2]|0)!=(k[b>>2]|0)){e=9;break}if((k[c+4>>2]|0)!=(k[b+4>>2]|0)){e=9;break}}else if((d|0)>0){a=0;do{if((k[c+(a<<2)>>2]|0)!=(k[b+(a<<2)>>2]|0)){e=9;break a}a=a+1|0}while((a|0)<(d|0))}a=k[h>>2]|0;if((a^k[l>>2])&4088)e=9}else e=9;while(0);if((e|0)==9){k[f>>2]=0;a=f+4|0;k[a>>2]=0;b=ZT(64)|0;k[b>>2]=1;c=b+4|0;k[f>>2]=c;k[a>>2]=56;i[b+60>>0]=0;d=210836;e=c+56|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,f,210893,209965,5475);k[a>>2]=0;k[f>>2]=0;e=k[b>>2]|0;k[b>>2]=e+-1;if((e|0)==1)ggb(k[b+-4>>2]|0);a=k[h>>2]|0}c=f+4|0;e=c+4|0;k[e>>2]=0;k[e+4>>2]=0;k[f>>2]=33619968;k[c>>2]=h;SW(l,f,a&4095,1.0,0.0);c=h+36|0;a=k[c>>2]|0;if(a|0?(e=a+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[h+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;f=h+16|0;c=h+4|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[c>>2]|0)>0){b=k[g>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[h+44>>2]|0;if(!((a|0)==(h+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=l+36|0;a=k[c>>2]|0;if(a|0?(g=a+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;h=l+16|0;c=l+4|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[c>>2]|0)>0){b=k[j>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[l+44>>2]|0;if((a|0)==(l+48|0)|(a|0)==0){r=m;return}ggb(k[a+-4>>2]|0);r=m;return}function bY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;j=k[g>>2]|0;g=k[g+4>>2]|0;if(!((g|0)!=0&(j|0)>0))return;while(1){h=0;do{if(i[c+h>>0]|0)i[e+h>>0]=i[a+h>>0]|0;h=h+1|0}while((h|0)!=(j|0));g=g+-1|0;if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}function cY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0;l=k[g>>2]|0;g=k[g+4>>2]|0;if(!((g|0)!=0&(l|0)>0))return;while(1){h=0;do{if(i[c+h>>0]|0)j[e+(h<<1)>>1]=j[a+(h<<1)>>1]|0;h=h+1|0}while((h|0)!=(l|0));g=g+-1|0;if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}function dY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0;o=k[g>>2]|0;g=k[g+4>>2]|0;if(!g)return;l=o+-4|0;if((o|0)<4){j=(o|0)>0;while(1){g=g+-1|0;if(j){h=0;do{if(i[c+h>>0]|0){n=e+(h*3|0)|0;m=a+(h*3|0)|0;i[n>>0]=i[m>>0]|0;i[n+1>>0]=i[m+1>>0]|0;i[n+2>>0]=i[m+2>>0]|0}h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}m=o&-4;n=(m|0)<(o|0);while(1){j=0;do{if(i[c+j>>0]|0){h=e+(j*3|0)|0;p=a+(j*3|0)|0;i[h>>0]=i[p>>0]|0;i[h+1>>0]=i[p+1>>0]|0;i[h+2>>0]=i[p+2>>0]|0}h=j|1;if(i[c+h>>0]|0){p=e+(h*3|0)|0;h=a+(h*3|0)|0;i[p>>0]=i[h>>0]|0;i[p+1>>0]=i[h+1>>0]|0;i[p+2>>0]=i[h+2>>0]|0}h=j|2;if(i[c+h>>0]|0){p=e+(h*3|0)|0;h=a+(h*3|0)|0;i[p>>0]=i[h>>0]|0;i[p+1>>0]=i[h+1>>0]|0;i[p+2>>0]=i[h+2>>0]|0}h=j|3;if(i[c+h>>0]|0){p=e+(h*3|0)|0;h=a+(h*3|0)|0;i[p>>0]=i[h>>0]|0;i[p+1>>0]=i[h+1>>0]|0;i[p+2>>0]=i[h+2>>0]|0}j=j+4|0}while((j|0)<=(l|0));g=g+-1|0;if(n){h=m;do{if(i[c+h>>0]|0){p=e+(h*3|0)|0;j=a+(h*3|0)|0;i[p>>0]=i[j>>0]|0;i[p+1>>0]=i[j+1>>0]|0;i[p+2>>0]=i[j+2>>0]|0}h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}function eY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0;o=k[g>>2]|0;g=k[g+4>>2]|0;if(!g)return;l=o+-4|0;if((o|0)<4){j=(o|0)>0;while(1){g=g+-1|0;if(j){h=0;do{if(i[c+h>>0]|0)k[e+(h<<2)>>2]=k[a+(h<<2)>>2];h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}m=o&-4;n=(m|0)<(o|0);while(1){j=0;do{if(i[c+j>>0]|0)k[e+(j<<2)>>2]=k[a+(j<<2)>>2];h=j|1;if(i[c+h>>0]|0)k[e+(h<<2)>>2]=k[a+(h<<2)>>2];h=j|2;if(i[c+h>>0]|0)k[e+(h<<2)>>2]=k[a+(h<<2)>>2];h=j|3;if(i[c+h>>0]|0)k[e+(h<<2)>>2]=k[a+(h<<2)>>2];j=j+4|0}while((j|0)<=(l|0));g=g+-1|0;if(n){h=m;do{if(i[c+h>>0]|0)k[e+(h<<2)>>2]=k[a+(h<<2)>>2];h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}function fY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0,m=0,n=0,o=0,p=0,q=0;p=k[g>>2]|0;g=k[g+4>>2]|0;if(!g)return;m=p+-4|0;if((p|0)<4){l=(p|0)>0;while(1){g=g+-1|0;if(l){h=0;do{if(i[c+h>>0]|0){o=e+(h*6|0)|0;n=a+(h*6|0)|0;j[o>>1]=j[n>>1]|0;j[o+2>>1]=j[n+2>>1]|0;j[o+4>>1]=j[n+4>>1]|0}h=h+1|0}while((h|0)!=(p|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}n=p&-4;o=(n|0)<(p|0);while(1){l=0;do{if(i[c+l>>0]|0){h=e+(l*6|0)|0;q=a+(l*6|0)|0;j[h>>1]=j[q>>1]|0;j[h+2>>1]=j[q+2>>1]|0;j[h+4>>1]=j[q+4>>1]|0}h=l|1;if(i[c+h>>0]|0){q=e+(h*6|0)|0;h=a+(h*6|0)|0;j[q>>1]=j[h>>1]|0;j[q+2>>1]=j[h+2>>1]|0;j[q+4>>1]=j[h+4>>1]|0}h=l|2;if(i[c+h>>0]|0){q=e+(h*6|0)|0;h=a+(h*6|0)|0;j[q>>1]=j[h>>1]|0;j[q+2>>1]=j[h+2>>1]|0;j[q+4>>1]=j[h+4>>1]|0}h=l|3;if(i[c+h>>0]|0){q=e+(h*6|0)|0;h=a+(h*6|0)|0;j[q>>1]=j[h>>1]|0;j[q+2>>1]=j[h+2>>1]|0;j[q+4>>1]=j[h+4>>1]|0}l=l+4|0}while((l|0)<=(m|0));g=g+-1|0;if(o){h=n;do{if(i[c+h>>0]|0){q=e+(h*6|0)|0;l=a+(h*6|0)|0;j[q>>1]=j[l>>1]|0;j[q+2>>1]=j[l+2>>1]|0;j[q+4>>1]=j[l+4>>1]|0}h=h+1|0}while((h|0)!=(p|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}function gY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;o=k[g>>2]|0;g=k[g+4>>2]|0;if(!g)return;l=o+-4|0;if((o|0)<4){j=(o|0)>0;while(1){g=g+-1|0;if(j){h=0;do{if(i[c+h>>0]|0){l=a+(h<<3)|0;m=k[l+4>>2]|0;n=e+(h<<3)|0;k[n>>2]=k[l>>2];k[n+4>>2]=m}h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}m=o&-4;n=(m|0)<(o|0);while(1){j=0;do{if(i[c+j>>0]|0){q=a+(j<<3)|0;p=k[q+4>>2]|0;h=e+(j<<3)|0;k[h>>2]=k[q>>2];k[h+4>>2]=p}h=j|1;if(i[c+h>>0]|0){r=a+(h<<3)|0;p=k[r+4>>2]|0;q=e+(h<<3)|0;k[q>>2]=k[r>>2];k[q+4>>2]=p}h=j|2;if(i[c+h>>0]|0){p=a+(h<<3)|0;q=k[p+4>>2]|0;r=e+(h<<3)|0;k[r>>2]=k[p>>2];k[r+4>>2]=q}h=j|3;if(i[c+h>>0]|0){p=a+(h<<3)|0;q=k[p+4>>2]|0;r=e+(h<<3)|0;k[r>>2]=k[p>>2];k[r+4>>2]=q}j=j+4|0}while((j|0)<=(l|0));g=g+-1|0;if(n){h=m;do{if(i[c+h>>0]|0){p=a+(h<<3)|0;q=k[p+4>>2]|0;r=e+(h<<3)|0;k[r>>2]=k[p>>2];k[r+4>>2]=q}h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}function hY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0;o=k[g>>2]|0;g=k[g+4>>2]|0;if(!g)return;l=o+-4|0;if((o|0)<4){j=(o|0)>0;while(1){g=g+-1|0;if(j){h=0;do{if(i[c+h>>0]|0){n=e+(h*12|0)|0;m=a+(h*12|0)|0;k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];k[n+8>>2]=k[m+8>>2]}h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}m=o&-4;n=(m|0)<(o|0);while(1){j=0;do{if(i[c+j>>0]|0){h=e+(j*12|0)|0;p=a+(j*12|0)|0;k[h>>2]=k[p>>2];k[h+4>>2]=k[p+4>>2];k[h+8>>2]=k[p+8>>2]}h=j|1;if(i[c+h>>0]|0){p=e+(h*12|0)|0;h=a+(h*12|0)|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2]}h=j|2;if(i[c+h>>0]|0){p=e+(h*12|0)|0;h=a+(h*12|0)|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2]}h=j|3;if(i[c+h>>0]|0){p=e+(h*12|0)|0;h=a+(h*12|0)|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2]}j=j+4|0}while((j|0)<=(l|0));g=g+-1|0;if(n){h=m;do{if(i[c+h>>0]|0){p=e+(h*12|0)|0;j=a+(h*12|0)|0;k[p>>2]=k[j>>2];k[p+4>>2]=k[j+4>>2];k[p+8>>2]=k[j+8>>2]}h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}function iY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0;o=k[g>>2]|0;g=k[g+4>>2]|0;if(!g)return;l=o+-4|0;if((o|0)<4){j=(o|0)>0;while(1){g=g+-1|0;if(j){h=0;do{if(i[c+h>>0]|0){n=e+(h<<4)|0;m=a+(h<<4)|0;k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];k[n+8>>2]=k[m+8>>2];k[n+12>>2]=k[m+12>>2]}h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}m=o&-4;n=(m|0)<(o|0);while(1){j=0;do{if(i[c+j>>0]|0){h=e+(j<<4)|0;p=a+(j<<4)|0;k[h>>2]=k[p>>2];k[h+4>>2]=k[p+4>>2];k[h+8>>2]=k[p+8>>2];k[h+12>>2]=k[p+12>>2]}h=j|1;if(i[c+h>>0]|0){p=e+(h<<4)|0;h=a+(h<<4)|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2];k[p+12>>2]=k[h+12>>2]}h=j|2;if(i[c+h>>0]|0){p=e+(h<<4)|0;h=a+(h<<4)|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2];k[p+12>>2]=k[h+12>>2]}h=j|3;if(i[c+h>>0]|0){p=e+(h<<4)|0;h=a+(h<<4)|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2];k[p+12>>2]=k[h+12>>2]}j=j+4|0}while((j|0)<=(l|0));g=g+-1|0;if(n){h=m;do{if(i[c+h>>0]|0){p=e+(h<<4)|0;j=a+(h<<4)|0;k[p>>2]=k[j>>2];k[p+4>>2]=k[j+4>>2];k[p+8>>2]=k[j+8>>2];k[p+12>>2]=k[j+12>>2]}h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}function jY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0;o=k[g>>2]|0;g=k[g+4>>2]|0;if(!g)return;l=o+-4|0;if((o|0)<4){j=(o|0)>0;while(1){g=g+-1|0;if(j){h=0;do{if(i[c+h>>0]|0){n=e+(h*24|0)|0;m=a+(h*24|0)|0;k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];k[n+8>>2]=k[m+8>>2];k[n+12>>2]=k[m+12>>2];k[n+16>>2]=k[m+16>>2];k[n+20>>2]=k[m+20>>2]}h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}m=o&-4;n=(m|0)<(o|0);while(1){j=0;do{if(i[c+j>>0]|0){h=e+(j*24|0)|0;p=a+(j*24|0)|0;k[h>>2]=k[p>>2];k[h+4>>2]=k[p+4>>2];k[h+8>>2]=k[p+8>>2];k[h+12>>2]=k[p+12>>2];k[h+16>>2]=k[p+16>>2];k[h+20>>2]=k[p+20>>2]}h=j|1;if(i[c+h>>0]|0){p=e+(h*24|0)|0;h=a+(h*24|0)|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2];k[p+12>>2]=k[h+12>>2];k[p+16>>2]=k[h+16>>2];k[p+20>>2]=k[h+20>>2]}h=j|2;if(i[c+h>>0]|0){p=e+(h*24|0)|0;h=a+(h*24|0)|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2];k[p+12>>2]=k[h+12>>2];k[p+16>>2]=k[h+16>>2];k[p+20>>2]=k[h+20>>2]}h=j|3;if(i[c+h>>0]|0){p=e+(h*24|0)|0;h=a+(h*24|0)|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2];k[p+12>>2]=k[h+12>>2];k[p+16>>2]=k[h+16>>2];k[p+20>>2]=k[h+20>>2]}j=j+4|0}while((j|0)<=(l|0));g=g+-1|0;if(n){h=m;do{if(i[c+h>>0]|0){p=e+(h*24|0)|0;j=a+(h*24|0)|0;k[p>>2]=k[j>>2];k[p+4>>2]=k[j+4>>2];k[p+8>>2]=k[j+8>>2];k[p+12>>2]=k[j+12>>2];k[p+16>>2]=k[j+16>>2];k[p+20>>2]=k[j+20>>2]}h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}function kY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0;o=k[g>>2]|0;g=k[g+4>>2]|0;if(!g)return;l=o+-4|0;if((o|0)<4){j=(o|0)>0;while(1){g=g+-1|0;if(j){h=0;do{if(i[c+h>>0]|0){n=e+(h<<5)|0;m=a+(h<<5)|0;k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];k[n+8>>2]=k[m+8>>2];k[n+12>>2]=k[m+12>>2];k[n+16>>2]=k[m+16>>2];k[n+20>>2]=k[m+20>>2];k[n+24>>2]=k[m+24>>2];k[n+28>>2]=k[m+28>>2]}h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}m=o&-4;n=(m|0)<(o|0);while(1){j=0;do{if(i[c+j>>0]|0){h=e+(j<<5)|0;p=a+(j<<5)|0;k[h>>2]=k[p>>2];k[h+4>>2]=k[p+4>>2];k[h+8>>2]=k[p+8>>2];k[h+12>>2]=k[p+12>>2];k[h+16>>2]=k[p+16>>2];k[h+20>>2]=k[p+20>>2];k[h+24>>2]=k[p+24>>2];k[h+28>>2]=k[p+28>>2]}h=j|1;if(i[c+h>>0]|0){p=e+(h<<5)|0;h=a+(h<<5)|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2];k[p+12>>2]=k[h+12>>2];k[p+16>>2]=k[h+16>>2];k[p+20>>2]=k[h+20>>2];k[p+24>>2]=k[h+24>>2];k[p+28>>2]=k[h+28>>2]}h=j|2;if(i[c+h>>0]|0){p=e+(h<<5)|0;h=a+(h<<5)|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2];k[p+12>>2]=k[h+12>>2];k[p+16>>2]=k[h+16>>2];k[p+20>>2]=k[h+20>>2];k[p+24>>2]=k[h+24>>2];k[p+28>>2]=k[h+28>>2]}h=j|3;if(i[c+h>>0]|0){p=e+(h<<5)|0;h=a+(h<<5)|0;k[p>>2]=k[h>>2];k[p+4>>2]=k[h+4>>2];k[p+8>>2]=k[h+8>>2];k[p+12>>2]=k[h+12>>2];k[p+16>>2]=k[h+16>>2];k[p+20>>2]=k[h+20>>2];k[p+24>>2]=k[h+24>>2];k[p+28>>2]=k[h+28>>2]}j=j+4|0}while((j|0)<=(l|0));g=g+-1|0;if(n){h=m;do{if(i[c+h>>0]|0){p=e+(h<<5)|0;j=a+(h<<5)|0;k[p>>2]=k[j>>2];k[p+4>>2]=k[j+4>>2];k[p+8>>2]=k[j+8>>2];k[p+12>>2]=k[j+12>>2];k[p+16>>2]=k[j+16>>2];k[p+20>>2]=k[j+20>>2];k[p+24>>2]=k[j+24>>2];k[p+28>>2]=k[j+28>>2]}h=h+1|0}while((h|0)!=(o|0))}if(!g)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}function lY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0;n=k[h>>2]|0;o=g+4|0;m=k[o>>2]|0;j=m+-1|0;k[o>>2]=j;if(!m)return;if(!n){k[o>>2]=-1;return}h=k[g>>2]|0;while(1){if((h|0)>0){j=e;l=a;m=0;while(1){if(i[c+m>>0]|0){h=0;do{i[j+h>>0]=i[l+h>>0]|0;h=h+1|0}while((h|0)!=(n|0));h=k[g>>2]|0}m=m+1|0;if((m|0)>=(h|0))break;else{j=j+n|0;l=l+n|0}}l=k[o>>2]|0}else l=j;j=l+-1|0;k[o>>2]=j;if(!l)break;else{a=a+b|0;c=c+d|0;e=e+f|0}}return}function mY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+352|0;w=x+288|0;v=x+160|0;p=x+32|0;o=x;h=S1(b,-1)|0;l=k[b>>2]|0;if((l|0)<0?(d=k[a>>2]|0,(h|0)!=(d&4095|0)):0){if((d^h)&4088|0){c=w+4|0;d=ZT(36)|0;k[d>>2]=1;e=d+4|0;k[w>>2]=e;k[c>>2]=30;i[d+34>>0]=0;f=233512;g=e+30|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,w,233543,210908,257);k[c>>2]=0;k[w>>2]=0;w=k[d>>2]|0;k[d>>2]=w+-1;if((w|0)==1)ggb(k[d+-4>>2]|0)}SW(a,b,h,1.0,0.0);r=x;return}u=a+16|0;if(k[u>>2]|0){t=a+4|0;j=k[t>>2]|0;h=(j|0)<3;if(h)d=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{g=k[a+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(j|0))}if(d|0){if((l&2031616|0)==655360){c=a+40|0;P1(b,j,k[c>>2]|0,k[a>>2]&4095,-1,0,0);A2(w,b);l=k[t>>2]|0;if((l|0)<=0)if(!l){c=-1;e=0}else{e=0;s=19}else{e=k[(k[a+44>>2]|0)+(l+-1<<2)>>2]|0;s=19}if((s|0)==19){d=k[c>>2]|0;c=0;do{k[v+(c<<2)>>2]=k[d+(c<<2)>>2];c=c+1|0}while(c>>>0<l>>>0);c=l+-1|0}j=v+(c<<2)|0;g=aa(k[j>>2]|0,e)|0;k[j>>2]=g;j=w+4|0;g=k[j>>2]|0;if((g|0)>0){h=w+36|0;c=k[h>>2]|0;d=0;f=k[w+28>>2]|0;do{t=k[c+(d<<2)>>2]|0;s=(f>>>0)/(t>>>0)|0;k[p+(d<<2)>>2]=s;f=f-(aa(s,t)|0)|0;d=d+1|0}while((d|0)!=(g|0))}else{c=w+36|0;h=c;c=k[c>>2]|0}t=p+(l+-1<<2)|0;e=aa(k[t>>2]|0,e)|0;k[t>>2]=e;e=w+24|0;t=k[e>>2]|0;s=k[t+4>>2]|0;sh[k[(k[s>>2]|0)+32>>2]&255](s,t,k[u>>2]|0,l,v,p,c,k[a+44>>2]|0);c=k[e>>2]|0;if(c|0?(v=c+8|0,a=k[v>>2]|0,k[v>>2]=a+-1,(a|0)==1):0){a=k[e>>2]|0;v=k[a+4>>2]|0;jh[k[(k[v>>2]|0)+16>>2]&1023](v,a);k[e>>2]=0}if((k[j>>2]|0)>0){d=k[w+32>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[j>>2]|0))}k[e>>2]=0;c=k[h>>2]|0;if(!((c|0)==(w+40|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=x;return}if(!h){n=a+40|0;P1(b,j,k[n>>2]|0,k[a>>2]&4095,-1,0,0);do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[w>>2]=k[f>>2];l=w+4|0;c=f+4|0;k[l>>2]=k[c>>2];s=w+8|0;k[s>>2]=k[f+8>>2];k[w+12>>2]=k[f+12>>2];m=w+16|0;k[m>>2]=k[f+16>>2];k[w+20>>2]=k[f+20>>2];k[w+24>>2]=k[f+24>>2];k[w+28>>2]=k[f+28>>2];k[w+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[w+36>>2]=d;e=w+40|0;k[e>>2]=s;s=w+48|0;h=w+44|0;k[h>>2]=s;k[w+52>>2]=0;k[s>>2]=0;if(d|0){s=d+12|0;k[s>>2]=(k[s>>2]|0)+1}if((k[c>>2]|0)<3){q=k[f+44>>2]|0;s=k[h>>2]|0;k[s>>2]=k[q>>2];k[s+4>>2]=k[q+4>>2];break}k[l>>2]=0;x1(w,k[c>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;c=0;do{k[g+(c<<2)>>2]=k[j+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[l>>2]|0))}}else{Q1(w,b,-1);m=w+16|0}while(0);if((k[u>>2]|0)!=(k[m>>2]|0)){f=k[t>>2]|0;if((f|0)<3)c=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{e=k[n>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0))}if(c|0){k[v>>2]=a;k[v+4>>2]=w;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;k[o+16>>2]=0;k[o+20>>2]=0;k[o+24>>2]=0;k[o+28>>2]=0;z1(o,v,0,p,2);c=k[t>>2]|0;if((c|0)>0)c=k[(k[a+44>>2]|0)+(c+-1<<2)>>2]|0;else c=0;d=aa(c,k[o+20>>2]|0)|0;e=o+16|0;f=p+4|0;c=0;while(1){if(c>>>0>=(k[e>>2]|0)>>>0)break;upb(k[f>>2]|0,k[p>>2]|0,d|0)|0;A1(o);c=c+1|0}}}e=w+36|0;c=k[e>>2]|0;if(c|0?(v=c+12|0,a=k[v>>2]|0,k[v>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[w+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=w+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[e>>2]|0)>0){d=k[w+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[w+44>>2]|0;if(!((c|0)==(w+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=x;return}q=a+8|0;p=a+12|0;c2(b,k[q>>2]|0,k[p>>2]|0,k[a>>2]&4095,-1,0,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[w>>2]=k[h>>2];n=w+4|0;d=h+4|0;k[n>>2]=k[d>>2];m=w+8|0;k[m>>2]=k[h+8>>2];k[w+12>>2]=k[h+12>>2];o=w+16|0;k[o>>2]=k[h+16>>2];k[w+20>>2]=k[h+20>>2];k[w+24>>2]=k[h+24>>2];k[w+28>>2]=k[h+28>>2];k[w+32>>2]=k[h+32>>2];e=k[h+36>>2]|0;k[w+36>>2]=e;g=w+40|0;k[g>>2]=m;m=w+48|0;l=w+44|0;k[l>>2]=m;k[w+52>>2]=0;k[m>>2]=0;if(e|0){m=e+12|0;k[m>>2]=(k[m>>2]|0)+1}if((k[d>>2]|0)<3){m=k[h+44>>2]|0;n=k[l>>2]|0;k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];break}k[n>>2]=0;x1(w,k[d>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;e=k[l>>2]|0;d=0;do{k[j+(d<<2)>>2]=k[m+(d<<2)>>2];k[e+(d<<2)>>2]=k[g+(d<<2)>>2];d=d+1|0}while((d|0)<(k[n>>2]|0))}}else{Q1(w,b,-1);o=w+16|0}while(0);g=k[u>>2]|0;e=k[o>>2]|0;if(((g|0)!=(e|0)?(c=k[q>>2]|0,(c|0)>0):0)?(f=k[p>>2]|0,(f|0)>0):0){d=k[b>>2]&2031616;if((d|0)<786432)switch(d|0){case 196608:{s=49;break}default:j=g}else switch(d|0){case 786432:{s=49;break}default:j=g}if((s|0)==49){e=k[w+4>>2]|0;if((e|0)<3)c=aa(k[w+12>>2]|0,k[w+8>>2]|0)|0;else{f=k[w+40>>2]|0;d=0;c=1;do{c=aa(k[f+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(e|0))}_1(v,w,0,c);KG(w,v)|0;e=v+36|0;c=k[e>>2]|0;if(c|0?(b=c+12|0,s=k[b>>2]|0,k[b>>2]=s+-1,(s|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[v+32>>2]|0;if(c|0)break;c=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;s=v+16|0;d=v+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[d>>2]|0)>0){e=k[v+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[v+44>>2]|0;if(!((c|0)==(v+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=k[p>>2]|0;c=k[q>>2]|0;e=k[o>>2]|0;j=k[u>>2]|0}u=k[a>>2]|0;v=k[w>>2]|0;d=Epb(c|0,((c|0)<0)<<31>>31|0,f|0,((f|0)<0)<<31>>31|0)|0;if((u&16384&v|0)!=0?(d|0)==(d|0)&(((d|0)<0)<<31>>31|0)==(N|0):0){f=d;c=1}d=k[t>>2]|0;if((d|0)>0)d=k[(k[a+44>>2]|0)+(d+-1<<2)>>2]|0;else d=0;h=aa(d,f)|0;if(c|0){f=a+48|0;g=w+48|0;d=j;while(1){c=c+-1|0;upb(e|0,d|0,h|0)|0;if(!c)break;else{e=e+(k[g>>2]|0)|0;d=d+(k[f>>2]|0)|0}}}}e=w+36|0;c=k[e>>2]|0;if(c|0?(v=c+12|0,a=k[v>>2]|0,k[v>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[w+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=w+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[e>>2]|0)>0){d=k[w+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[w+44>>2]|0;if(!((c|0)==(w+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=x;return}}b2(b);r=x;return}function nY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+272|0;B=C+216|0;z=C+208|0;p=C+152|0;A=C+96|0;u=C;y=C+88|0;x=C+72|0;v=C+32|0;w=C+64|0;do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[B>>2]=k[f>>2];l=B+4|0;c=f+4|0;k[l>>2]=k[c>>2];t=B+8|0;k[t>>2]=k[f+8>>2];k[B+12>>2]=k[f+12>>2];m=B+16|0;k[m>>2]=k[f+16>>2];k[B+20>>2]=k[f+20>>2];k[B+24>>2]=k[f+24>>2];k[B+28>>2]=k[f+28>>2];k[B+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[B+36>>2]=d;e=B+40|0;k[e>>2]=t;t=B+48|0;h=B+44|0;k[h>>2]=t;k[B+52>>2]=0;k[t>>2]=0;if(d|0){t=d+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[c>>2]|0)<3){s=k[f+44>>2]|0;t=k[h>>2]|0;k[t>>2]=k[s>>2];k[t+4>>2]=k[s+4>>2];break}k[l>>2]=0;x1(B,k[c>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;c=0;do{k[g+(c<<2)>>2]=k[j+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[l>>2]|0))}}else{Q1(B,c,-1);m=B+16|0}while(0);if(k[m>>2]|0){t=k[B>>2]|0;c=t>>>3&511;s=c+1|0;if(!((t&7|0)==0?((c|0)==0?1:(c|0)==((k[a>>2]|0)>>>3&511|0)):0)){k[z>>2]=0;d=z+4|0;k[d>>2]=0;e=ZT(56)|0;k[e>>2]=1;f=e+4|0;k[z>>2]=f;k[d>>2]=48;i[e+52>>0]=0;g=210971;h=f+48|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,z,233543,210908,344);k[d>>2]=0;k[z>>2]=0;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)ggb(k[e+-4>>2]|0)}if(!c){c=k[a+4>>2]|0;if((c|0)>0){c=k[(k[a+44>>2]|0)+(c+-1<<2)>>2]|0;k[z>>2]=c;if(c>>>0<33)n=22;else t=140}else{c=0;n=20}}else{c=1212424721>>>(k[a>>2]<<2&28)&15;n=20}if((n|0)==20){k[z>>2]=c;n=22}if((n|0)==22){t=k[40936+(c<<2)>>2]|0;t=(t|0)==0?140:t}do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[p>>2]=k[g>>2];n=p+4|0;c=g+4|0;k[n>>2]=k[c>>2];q=p+8|0;k[q>>2]=k[g+8>>2];k[p+12>>2]=k[g+12>>2];o=p+16|0;k[o>>2]=k[g+16>>2];k[p+20>>2]=k[g+20>>2];k[p+24>>2]=k[g+24>>2];k[p+28>>2]=k[g+28>>2];k[p+32>>2]=k[g+32>>2];f=p+36|0;d=k[g+36>>2]|0;k[f>>2]=d;e=p+40|0;k[e>>2]=q;q=p+48|0;j=p+44|0;k[j>>2]=q;k[p+52>>2]=0;k[q>>2]=0;if(d|0){q=d+12|0;k[q>>2]=(k[q>>2]|0)+1}if((k[c>>2]|0)<3){q=k[g+44>>2]|0;g=k[j>>2]|0;k[g>>2]=k[q>>2];k[g+4>>2]=k[q+4>>2];g=o;break}k[n>>2]=0;x1(p,k[c>>2]|0,0,0,0);if((k[n>>2]|0)>0){l=k[g+40>>2]|0;h=k[e>>2]|0;e=k[g+44>>2]|0;d=k[j>>2]|0;c=0;do{k[h+(c<<2)>>2]=k[l+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[n>>2]|0));g=o}else g=o}else{Q1(p,b,-1);g=p+16|0;f=p+36|0}while(0);q=k[g>>2]|0;c=k[f>>2]|0;if(c|0?(n=c+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){e=p+36|0;d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[p+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[f>>2]=0;e=p+4|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[e>>2]|0)>0){d=k[p+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[p+44>>2]|0;if(!((c|0)==(p+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);o=a+4|0;p=a+40|0;P1(b,k[o>>2]|0,k[p>>2]|0,k[a>>2]&4095,-1,0,0);do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[A>>2]=k[f>>2];l=A+4|0;c=f+4|0;k[l>>2]=k[c>>2];b=A+8|0;k[b>>2]=k[f+8>>2];k[A+12>>2]=k[f+12>>2];n=A+16|0;k[n>>2]=k[f+16>>2];k[A+20>>2]=k[f+20>>2];k[A+24>>2]=k[f+24>>2];k[A+28>>2]=k[f+28>>2];k[A+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[A+36>>2]=d;e=A+40|0;k[e>>2]=b;b=A+48|0;h=A+44|0;k[h>>2]=b;k[A+52>>2]=0;k[b>>2]=0;if(d|0){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1}if((k[c>>2]|0)<3){l=k[f+44>>2]|0;b=k[h>>2]|0;k[b>>2]=k[l>>2];k[b+4>>2]=k[l+4>>2];break}k[l>>2]=0;x1(A,k[c>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;c=0;do{k[g+(c<<2)>>2]=k[j+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[l>>2]|0))}}else{Q1(A,b,-1);n=A+16|0}while(0);if((k[n>>2]|0)!=(q|0)){k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;k[u+16>>2]=0;k[u+20>>2]=0;k[u+24>>2]=0;k[u+28>>2]=0;oY(A,u)}if((k[o>>2]|0)<3){w=k[p>>2]|0;x=k[B+40>>2]|0;if(!((k[w>>2]|0)==(k[x>>2]|0)?(k[w+4>>2]|0)==(k[x+4>>2]|0):0)){k[u>>2]=0;c=u+4|0;k[c>>2]=0;d=ZT(28)|0;k[d>>2]=1;f=d+4|0;k[u>>2]=f;k[c>>2]=21;i[d+25>>0]=0;g=211020;h=f+21|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,u,233543,210908,359);k[c>>2]=0;k[u>>2]=0;x=k[d>>2]|0;k[d>>2]=x+-1;if((x|0)==1)ggb(k[d+-4>>2]|0)}v=k[a>>2]|0;w=k[A>>2]|0;x=k[B>>2]|0;e=k[a+12>>2]|0;c=k[a+8>>2]|0;d=Epb(e|0,((e|0)<0)<<31>>31|0,s|0,0)|0;d=Epb(d|0,N|0,c|0,((c|0)<0)<<31>>31|0)|0;if((v&16384&w&x|0)!=0?(d|0)==(d|0)&(((d|0)<0)<<31>>31|0)==(N|0):0)c=1;else d=aa(e,s)|0;s=k[a+16>>2]|0;u=k[a+48>>2]|0;v=k[m>>2]|0;w=k[B+48>>2]|0;x=k[n>>2]|0;a=k[A+48>>2]|0;k[y>>2]=d;k[y+4>>2]=c;sh[t&255](s,u,v,w,x,a,y,z)}else{k[u>>2]=a;k[u+4>>2]=A;k[u+8>>2]=B;k[u+12>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;k[v+16>>2]=0;k[v+20>>2]=0;k[v+24>>2]=0;k[v+28>>2]=0;z1(v,u,0,x,-1);d=aa(k[v+20>>2]|0,s)|0;e=v+16|0;f=x+8|0;g=x+4|0;h=w+4|0;c=0;while(1){if(c>>>0>=(k[e>>2]|0)>>>0)break;u=k[x>>2]|0;a=k[f>>2]|0;y=k[g>>2]|0;k[w>>2]=d;k[h>>2]=1;sh[t&255](u,0,a,0,y,0,w,z);A1(v);c=c+1|0}}e=A+36|0;c=k[e>>2]|0;if(c|0?(y=c+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[A+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=A+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[e>>2]|0)>0){d=k[A+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[A+44>>2]|0;if(!((c|0)==(A+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}else mY(a,b);e=B+36|0;c=k[e>>2]|0;if(c|0?(z=c+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[B+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=B+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[e>>2]|0)>0){d=k[B+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[B+44>>2]|0;if((c|0)==(B+48|0)|(c|0)==0){r=C;return}ggb(k[c+-4>>2]|0);r=C;return}function oY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+144|0;c=j+132|0;h=j+128|0;i=j+96|0;e=j;k[c>>2]=a;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;k[i+16>>2]=0;k[i+20>>2]=0;k[i+24>>2]=0;k[i+28>>2]=0;z1(i,c,0,h,1);c=k[a+4>>2]|0;if((c|0)>0)c=k[(k[a+44>>2]|0)+(c+-1<<2)>>2]|0;else c=0;g=aa(c,k[i+20>>2]|0)|0;f=b;if((((k[f>>2]|0)==0&(k[f+4>>2]|0)==0?(f=b+8|0,(k[f>>2]|0)==0&(k[f+4>>2]|0)==0):0)?(f=b+16|0,(k[f>>2]|0)==0&(k[f+4>>2]|0)==0):0)?(f=b+24|0,(k[f>>2]|0)==0&(k[f+4>>2]|0)==0):0){b=i+16|0;if(!(k[b>>2]|0)){r=j;return}else c=0;do{zpb(k[h>>2]|0,0,g|0)|0;c=c+1|0;A1(i)}while(c>>>0<(k[b>>2]|0)>>>0);r=j;return}f=i+16|0;d=k[f>>2]|0;if(!d){r=j;return}z2(b,e,k[a>>2]&4095,12);b=(1212424721>>>(k[a>>2]<<2&28)&15)*12|0;if(g|0){c=0;do{l=g-c|0;upb((k[h>>2]|0)+c|0,e|0,(b>>>0>l>>>0?l:b)|0)|0;c=c+b|0}while(g>>>0>c>>>0)}if(d>>>0<=1){r=j;return}b=a+16|0;c=1;do{A1(i);upb(k[h>>2]|0,k[b>>2]|0,g|0)|0;c=c+1|0}while(c>>>0<(k[f>>2]|0)>>>0);r=j;return}function pY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=r;r=r+1232|0;G=H+1168|0;F=H+1112|0;B=H+1104|0;x=H+1088|0;C=H;D=H+1048|0;E=H+8|0;A=H+1080|0;if(!(k[a+16>>2]|0)){r=H;return}v=a+4|0;f=k[v>>2]|0;if((f|0)<3)d=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{g=k[a+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}if(!d){r=H;return}do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[G>>2]=k[g>>2];l=G+4|0;d=g+4|0;k[l>>2]=k[d>>2];z=G+8|0;k[z>>2]=k[g+8>>2];k[G+12>>2]=k[g+12>>2];k[G+16>>2]=k[g+16>>2];k[G+20>>2]=k[g+20>>2];k[G+24>>2]=k[g+24>>2];k[G+28>>2]=k[g+28>>2];k[G+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[G+36>>2]=e;f=G+40|0;k[f>>2]=z;z=G+48|0;h=G+44|0;k[h>>2]=z;k[G+52>>2]=0;k[z>>2]=0;if(e|0){z=e+12|0;k[z>>2]=(k[z>>2]|0)+1}if((k[d>>2]|0)<3){w=k[g+44>>2]|0;z=k[h>>2]|0;k[z>>2]=k[w>>2];k[z+4>>2]=k[w+4>>2];break}k[l>>2]=0;x1(G,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;b=k[f>>2]|0;f=k[g+44>>2]|0;e=k[h>>2]|0;d=0;do{k[b+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else Q1(G,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[F>>2]=k[g>>2];l=F+4|0;d=g+4|0;k[l>>2]=k[d>>2];z=F+8|0;k[z>>2]=k[g+8>>2];k[F+12>>2]=k[g+12>>2];k[F+16>>2]=k[g+16>>2];k[F+20>>2]=k[g+20>>2];k[F+24>>2]=k[g+24>>2];k[F+28>>2]=k[g+28>>2];k[F+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[F+36>>2]=e;f=F+40|0;k[f>>2]=z;z=F+48|0;h=F+44|0;k[h>>2]=z;k[F+52>>2]=0;k[z>>2]=0;if(e|0){z=e+12|0;k[z>>2]=(k[z>>2]|0)+1}if((k[d>>2]|0)<3){w=k[g+44>>2]|0;z=k[h>>2]|0;k[z>>2]=k[w>>2];k[z+4>>2]=k[w+4>>2];break}k[l>>2]=0;x1(F,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;b=k[f>>2]|0;f=k[g+44>>2]|0;e=k[h>>2]|0;d=0;do{k[b+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else Q1(F,c,-1);while(0);d=k[a>>2]|0;z=G+4|0;if(((k[z>>2]|0)<=2?(m=k[G>>2]|0,(m&16384|0)!=0):0)?(o=k[G+40>>2]|0,n=k[o+4>>2]|0,o=k[o>>2]|0,p=(n|0)==1,q=(o|0)==1,p|q):0){d=(d>>>3&511)+1|0;if(!((n|0)==(d|0)&q|p&(q|(o|0)==(d|0))))if(!(p&(o|0)==4?d>>>0<5&(m&4095|0)==6:0))y=31}else y=31;if((y|0)==31){k[B>>2]=0;d=B+4|0;k[d>>2]=0;e=ZT(68)|0;k[e>>2]=1;f=e+4|0;k[B>>2]=f;k[d>>2]=60;i[e+64>>0]=0;g=211042;b=f+60|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(b|0));Y8(-215,B,220161,210908,529);k[d>>2]=0;k[B>>2]=0;w=k[e>>2]|0;k[e>>2]=w+-1;if((w|0)==1)ggb(k[e+-4>>2]|0)}w=F+16|0;a:do if(k[w>>2]|0){f=k[F+4>>2]|0;if((f|0)<3)d=aa(k[F+12>>2]|0,k[F+8>>2]|0)|0;else{g=k[F+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}if(d|0){b:do if((k[F>>2]&4095|0)==0?(s=k[a+40>>2]|0,t=k[s+-4>>2]|0,u=k[F+40>>2]|0,(t|0)==(k[u+-4>>2]|0)):0){if((t|0)==2){if((k[s>>2]|0)!=(k[u>>2]|0))break;if((k[s+4>>2]|0)==(k[u+4>>2]|0))break a;else break}if((t|0)>0)d=0;else break a;while(1){if((k[s+(d<<2)>>2]|0)!=(k[u+(d<<2)>>2]|0))break b;d=d+1|0;if((d|0)>=(t|0))break a}}while(0);k[B>>2]=0;d=B+4|0;k[d>>2]=0;e=ZT(64)|0;k[e>>2]=1;f=e+4|0;k[B>>2]=f;k[d>>2]=59;i[e+63>>0]=0;g=211103;b=f+59|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(b|0));Y8(-215,B,220161,210908,530);k[d>>2]=0;k[B>>2]=0;u=k[e>>2]|0;k[e>>2]=u+-1;if((u|0)==1)ggb(k[e+-4>>2]|0)}}while(0);d=k[v>>2]|0;if((d|0)>0){d=k[(k[a+44>>2]|0)+(d+-1<<2)>>2]|0;k[B>>2]=d;if(d>>>0<33){d=40936+(d<<2)|0;y=54}else s=140}else{k[B>>2]=0;d=40936;y=54}if((y|0)==54){s=k[d>>2]|0;s=(s|0)==0?140:s}k[x>>2]=a;if(k[w>>2]|0){f=k[F+4>>2]|0;if((f|0)<3)d=aa(k[F+12>>2]|0,k[F+8>>2]|0)|0;else{g=k[F+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}e=x+4|0;if(!d){d=e;y=62}else{f=F;d=e}}else{d=x+4|0;y=62}if((y|0)==62)f=0;k[d>>2]=f;k[x+8>>2]=0;o=C;k[o>>2]=0;k[o+4>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;z1(D,x,0,C,-1);o=k[D+20>>2]|0;e=k[B>>2]|0;n=((e+1023|0)>>>0)/(e>>>0)|0;n=(n|0)<(o|0)?n:o;e=(aa(n,e)|0)+32|0;p=E+8|0;k[E>>2]=p;q=E+4|0;k[q>>2]=1032;if(e>>>0>1032){while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[E>>2]=d}else d=p;k[q>>2]=e;c=d+7&-8;_T(G,k[a>>2]&4095,c,n);m=D+16|0;g=C+4|0;b=A+4|0;c:do if((o|0)>0){e=0;while(1){if(e>>>0>=(k[m>>2]|0)>>>0)break c;d=0;l=k[C>>2]|0;do{f=o-d|0;f=(f|0)<(n|0)?f:n;h=aa(k[B>>2]|0,f)|0;j=k[g>>2]|0;if(!j)upb(l|0,c|0,h|0)|0;else{k[A>>2]=f;k[b>>2]=1;sh[s&255](c,0,j,0,l,0,A,B);k[g>>2]=(k[g>>2]|0)+f}l=(k[C>>2]|0)+h|0;k[C>>2]=l;d=d+n|0}while((o|0)>(d|0));A1(D);e=e+1|0}}else{d=0;while(1){if(d>>>0>=(k[m>>2]|0)>>>0)break c;A1(D);d=d+1|0}}while(0);d=k[E>>2]|0;if((d|0)!=(p|0)){if(d|0)ggb(d);k[E>>2]=p;k[q>>2]=1032}f=F+36|0;d=k[f>>2]|0;if(d|0?(D=d+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[F+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;f=F+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[f>>2]|0)>0){e=k[F+40>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[f>>2]|0))}d=k[F+44>>2]|0;if(!((d|0)==(F+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=G+36|0;d=k[f>>2]|0;if(d|0?(E=d+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[G+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;F=G+16|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[z>>2]|0)>0){e=k[G+40>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[z>>2]|0))}d=k[G+44>>2]|0;if(!((d|0)==(G+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=H;return}function qY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;H=r;r=r+144|0;p=H+136|0;G=H+72|0;q=H+128|0;F=H+16|0;s=H+8|0;E=H;if((a2(a)|0)>=3){d=p+4|0;e=ZT(24)|0;k[e>>2]=1;f=e+4|0;k[p>>2]=f;k[d>>2]=16;i[e+20>>0]=0;g=220423;h=f+16|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,p,211163,210908,778);k[d>>2]=0;k[p>>2]=0;C=k[e>>2]|0;k[e>>2]=C+-1;if((C|0)==1)ggb(k[e+-4>>2]|0)}R1(p,a,-1);d=k[p>>2]|0;if((c|0)<0)c=(k[p+4>>2]|0)==1?1:(d|0)==1?0:c;d=(d|0)==1;if((!((c|0)>0&d)?(m=p+4|0,j=(k[m>>2]|0)==1,!((c|0)==0&j)):0)?(D=(c|0)<0,!(D&d&j)):0){do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[G>>2]=k[g>>2];l=G+4|0;d=g+4|0;k[l>>2]=k[d>>2];C=G+8|0;k[C>>2]=k[g+8>>2];k[G+12>>2]=k[g+12>>2];k[G+16>>2]=k[g+16>>2];k[G+20>>2]=k[g+20>>2];k[G+24>>2]=k[g+24>>2];k[G+28>>2]=k[g+28>>2];k[G+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[G+36>>2]=e;f=G+40|0;k[f>>2]=C;C=G+48|0;a=G+44|0;k[a>>2]=C;k[G+52>>2]=0;k[C>>2]=0;if(e|0){C=e+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[d>>2]|0)<3){C=k[g+44>>2]|0;d=k[a>>2]|0;k[d>>2]=k[C>>2];k[d+4>>2]=k[C+4>>2];d=G;break}k[l>>2]=0;x1(G,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[a>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0));d=G}else d=G}else{Q1(G,a,-1);d=G}while(0);n=k[d>>2]|0;o=n&4095;k[q>>2]=k[p>>2];k[q+4>>2]=k[m>>2];x2(b,q,o,0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[F>>2]=k[g>>2];j=F+4|0;d=g+4|0;k[j>>2]=k[d>>2];m=F+8|0;k[m>>2]=k[g+8>>2];k[F+12>>2]=k[g+12>>2];l=F+16|0;k[l>>2]=k[g+16>>2];k[F+20>>2]=k[g+20>>2];k[F+24>>2]=k[g+24>>2];k[F+28>>2]=k[g+28>>2];k[F+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[F+36>>2]=e;f=F+40|0;k[f>>2]=m;m=F+48|0;b=F+44|0;k[b>>2]=m;k[F+52>>2]=0;k[m>>2]=0;if(e|0){C=e+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[d>>2]|0)<3){B=k[g+44>>2]|0;C=k[b>>2]|0;k[C>>2]=k[B>>2];k[C+4>>2]=k[B+4>>2];break}k[j>>2]=0;x1(F,k[d>>2]|0,0,0,0);if((k[j>>2]|0)>0){a=k[g+40>>2]|0;h=k[f>>2]|0;e=k[g+44>>2]|0;f=k[b>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[a+(d<<2)>>2];k[f+(d<<2)>>2]=k[e+(d<<2)>>2];d=d+1|0}while((d|0)<(k[j>>2]|0))}}else{Q1(F,b,-1);l=F+16|0;b=F+44|0;m=F+48|0}while(0);w=(n>>>3&511)+1<<(47696>>>(o<<1&14)&3);z=G+16|0;o=k[z>>2]|0;B=G+44|0;C=G+48|0;x=k[C>>2]|0;p=k[l>>2]|0;y=k[m>>2]|0;A=G+40|0;f=k[A>>2]|0;d=k[f+4>>2]|0;f=k[f>>2]|0;a:do if((c|0)<1){e=f+-1|0;v=aa(d,w)|0;if((f|0)>0){g=p+(aa(e,y)|0)|0;d=o+(aa(e,x)|0)|0;s=0-x|0;t=0-y|0;u=v+-4|0;n=v+-16|0;q=(f+1|0)/2|0;if((v|0)<16){a=v&-4;j=(v|0)<4;c=d;h=0;f=o;e=p;while(1){if(((e|f|c|g)&3|0)!=0|j)d=0;else{d=0;do{p=k[f+d>>2]|0;k[e+d>>2]=k[c+d>>2];k[g+d>>2]=p;d=d+4|0}while((d|0)<=(u|0));d=a}if((d|0)<(v|0))do{p=i[f+d>>0]|0;i[e+d>>0]=i[c+d>>0]|0;i[g+d>>0]=p;d=d+1|0}while((d|0)!=(v|0));h=h+1|0;if((h|0)>=(q|0))break a;else{c=c+s|0;g=g+t|0;f=f+x|0;e=e+y|0}}}a=v&-16;j=(a|0)>(u|0);c=d;h=0;f=o;e=p;while(1){if(!((e|f|c|g)&3)){d=0;do{o=f+d|0;K=k[o>>2]|0;J=c+d|0;I=e+d|0;k[I>>2]=k[J>>2];p=g+d|0;k[p>>2]=K;K=k[o+4>>2]|0;k[I+4>>2]=k[J+4>>2];k[p+4>>2]=K;K=k[o+8>>2]|0;k[I+8>>2]=k[J+8>>2];k[p+8>>2]=K;o=k[o+12>>2]|0;k[I+12>>2]=k[J+12>>2];k[p+12>>2]=o;d=d+16|0}while((d|0)<=(n|0));if(j)d=a;else{d=a;do{K=k[f+d>>2]|0;k[e+d>>2]=k[c+d>>2];k[g+d>>2]=K;d=d+4|0}while((d|0)<=(u|0))}}else d=0;if((d|0)<(v|0))do{K=i[f+d>>0]|0;i[e+d>>0]=i[c+d>>0]|0;i[g+d>>0]=K;d=d+1|0}while((d|0)!=(v|0));h=h+1|0;if((h|0)>=(q|0))break;else{c=c+s|0;g=g+t|0;f=f+x|0;e=e+y|0}}}}else{k[s>>2]=d;k[s+4>>2]=f;rY(o,x,p,y,s,w)}while(0);if(D){J=k[l>>2]|0;K=k[m>>2]|0;D=k[F+40>>2]|0;I=k[D>>2]|0;k[E>>2]=k[D+4>>2];k[E+4>>2]=I;rY(J,K,J,K,E,w)}f=F+36|0;d=k[f>>2]|0;if(d|0?(J=d+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[F+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;f=F+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[f>>2]|0)>0){e=k[F+40>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[f>>2]|0))}d=k[b>>2]|0;if(!((d|0)==(m|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=G+36|0;d=k[f>>2]|0;if(d|0?(J=d+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[G+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;f=G+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[f>>2]|0)>0){e=k[A>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[f>>2]|0))}d=k[B>>2]|0;if(!((d|0)==(C|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=H;return}I2(a,b);r=H;return}function rY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;t=r;r=r+1072|0;s=t;g=k[e>>2]|0;o=aa((g+1|0)/2|0,f)|0;j=aa(g,f)|0;p=s+8|0;k[s>>2]=p;q=s+4|0;k[q>>2]=264;if(j>>>0>264){h=j>>>0>1073741823?-1:j<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[s>>2]=g;h=k[e>>2]|0}else{h=g;g=p}k[q>>2]=j;if(!((h|0)<1|(f|0)==0)){n=(f|0)==1;m=0;do{j=~m;l=aa(m,f)|0;h=aa(h+j|0,f)|0;k[g+(l<<2)>>2]=h;if(!n){h=1;do{u=(aa((k[e>>2]|0)+j|0,f)|0)+h|0;k[g+(h+l<<2)>>2]=u;h=h+1|0}while((h|0)!=(f|0))}m=m+1|0;h=k[e>>2]|0}while((m|0)<(h|0))}j=e+4|0;u=k[j>>2]|0;k[j>>2]=u+-1;do if(u){if((o|0)<=0){k[j>>2]=-1;break}while(1){h=0;do{u=k[g+(h<<2)>>2]|0;f=i[a+h>>0]|0;i[c+h>>0]=i[a+u>>0]|0;i[c+u>>0]=f;h=h+1|0}while((h|0)!=(o|0));u=k[j>>2]|0;k[j>>2]=u+-1;if(!u)break;else{c=c+d|0;a=a+b|0}}g=k[s>>2]|0}while(0);if((g|0)==(p|0)){r=t;return}if(g|0)ggb(g);k[s>>2]=p;k[q>>2]=264;r=t;return}function sY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+128|0;q=w+112|0;v=w+56|0;u=w;if((a2(a)|0)>=3){g=q+4|0;f=ZT(24)|0;k[f>>2]=1;h=f+4|0;k[q>>2]=h;k[g>>2]=16;i[f+20>>0]=0;j=220423;l=h+16|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,q,211168,210908,848);k[g>>2]=0;k[q>>2]=0;p=k[f>>2]|0;k[f>>2]=p+-1;if((p|0)==1)ggb(k[f+-4>>2]|0)}if(!((b|0)>0&(c|0)>0)){f=q+4|0;g=ZT(24)|0;k[g>>2]=1;h=g+4|0;k[q>>2]=h;k[f>>2]=16;i[g+20>>0]=0;j=211175;l=h+16|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,q,211168,210908,849);k[f>>2]=0;k[q>>2]=0;p=k[g>>2]|0;k[g>>2]=p+-1;if((p|0)==1)ggb(k[g+-4>>2]|0)}R1(q,a,-1);p=q+4|0;n=aa(k[p>>2]|0,b)|0;o=aa(k[q>>2]|0,c)|0;c2(d,n,o,S1(a,-1)|0,-1,0,0);do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[v>>2]=k[j>>2];c=v+4|0;f=j+4|0;k[c>>2]=k[f>>2];o=v+8|0;k[o>>2]=k[j+8>>2];k[v+12>>2]=k[j+12>>2];k[v+16>>2]=k[j+16>>2];k[v+20>>2]=k[j+20>>2];k[v+24>>2]=k[j+24>>2];k[v+28>>2]=k[j+28>>2];k[v+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[v+36>>2]=g;h=v+40|0;k[h>>2]=o;o=v+48|0;a=v+44|0;k[a>>2]=o;k[v+52>>2]=0;k[o>>2]=0;if(g|0){o=g+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[f>>2]|0)<3){n=k[j+44>>2]|0;o=k[a>>2]|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];break}k[c>>2]=0;x1(v,k[f>>2]|0,0,0,0);if((k[c>>2]|0)>0){b=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[a>>2]|0;f=0;do{k[l+(f<<2)>>2]=k[b+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[c>>2]|0))}}else Q1(v,a,-1);while(0);do if((k[d>>2]&2031616|0)==65536){h=k[d+4>>2]|0;k[u>>2]=k[h>>2];b=u+4|0;f=h+4|0;k[b>>2]=k[f>>2];o=u+8|0;k[o>>2]=k[h+8>>2];k[u+12>>2]=k[h+12>>2];k[u+16>>2]=k[h+16>>2];k[u+20>>2]=k[h+20>>2];k[u+24>>2]=k[h+24>>2];k[u+28>>2]=k[h+28>>2];k[u+32>>2]=k[h+32>>2];g=k[h+36>>2]|0;k[u+36>>2]=g;c=u+40|0;k[c>>2]=o;o=u+48|0;j=u+44|0;k[j>>2]=o;k[u+52>>2]=0;k[o>>2]=0;if(g|0){o=g+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[f>>2]|0)<3){n=k[h+44>>2]|0;o=k[j>>2]|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];break}k[b>>2]=0;x1(u,k[f>>2]|0,0,0,0);if((k[b>>2]|0)>0){l=k[h+40>>2]|0;a=k[c>>2]|0;h=k[h+44>>2]|0;g=k[j>>2]|0;f=0;do{k[a+(f<<2)>>2]=k[l+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[b>>2]|0))}}else{Q1(u,d,-1);c=u+40|0}while(0);n=k[c>>2]|0;g=k[n+4>>2]|0;n=k[n>>2]|0;o=v+4|0;f=k[o>>2]|0;if((f|0)>0)f=k[(k[v+44>>2]|0)+(f+-1<<2)>>2]|0;else f=0;h=aa(k[q>>2]|0,f)|0;k[q>>2]=h;m=aa(f,g)|0;f=k[p>>2]|0;if((f|0)>0){l=u+16|0;a=u+44|0;b=v+16|0;d=v+44|0;if((m|0)>0){g=0;f=h;while(1){h=0;j=f;do{f=(k[l>>2]|0)+(aa(k[k[a>>2]>>2]|0,g)|0)+h|0;upb(f|0,(k[b>>2]|0)+(aa(k[k[d>>2]>>2]|0,g)|0)|0,j|0)|0;j=k[q>>2]|0;h=j+h|0}while((h|0)<(m|0));g=g+1|0;f=k[p>>2]|0;if((g|0)<(f|0))f=j;else break}}else g=f}else g=0;if((g|0)<(n|0)?(s=u+16|0,t=u+44|0,q=k[s>>2]|0,e=k[k[t>>2]>>2]|0,upb(q+(aa(e,g)|0)|0,q+(aa(g-f|0,e)|0)|0,m|0)|0,e=g+1|0,(e|0)!=(n|0)):0)do{d=k[s>>2]|0;q=k[k[t>>2]>>2]|0;upb(d+(aa(q,e)|0)|0,d+(aa(e-(k[p>>2]|0)|0,q)|0)|0,m|0)|0;e=e+1|0}while((e|0)!=(n|0));g=u+36|0;e=k[g>>2]|0;if(e|0?(s=e+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[u+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;t=u+16|0;g=u+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[g>>2]|0)>0){f=k[c>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[g>>2]|0))}e=k[u+44>>2]|0;if(!((e|0)==(u+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=v+36|0;e=k[g>>2]|0;if(e|0?(t=e+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[v+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;u=v+16|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[o>>2]|0)>0){f=k[v+40>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[o>>2]|0))}e=k[v+44>>2]|0;if((e|0)==(v+48|0)|(e|0)==0){r=w;return}ggb(k[e+-4>>2]|0);r=w;return}function tY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+96|0;j=q+32|0;g=q+16|0;h=q;if((c|0)==1&(d|0)==1){k[a>>2]=k[b>>2];i=a+4|0;f=b+4|0;e=k[f>>2]|0;k[i>>2]=e;p=a+8|0;k[p>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];k[a+20>>2]=k[b+20>>2];k[a+24>>2]=k[b+24>>2];k[a+28>>2]=k[b+28>>2];k[a+32>>2]=k[b+32>>2];c=k[b+36>>2]|0;k[a+36>>2]=c;d=a+40|0;k[d>>2]=p;p=a+48|0;h=a+44|0;k[h>>2]=p;k[a+52>>2]=0;k[p>>2]=0;if(c){e=c+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[f>>2]|0}if((e|0)<3){o=k[b+44>>2]|0;p=k[h>>2]|0;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];r=q;return}k[i>>2]=0;x1(a,e,0,0,0);if((k[i>>2]|0)<=0){r=q;return}g=k[b+40>>2]|0;d=k[d>>2]|0;c=k[b+44>>2]|0;f=k[h>>2]|0;e=0;do{k[d+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[c+(e<<2)>>2];e=e+1|0}while((e|0)<(k[i>>2]|0));r=q;return}k[j>>2]=1124007936;p=j+4|0;i=j+8|0;m=j+40|0;e=p;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[m>>2]=i;o=j+48|0;n=j+44|0;k[n>>2]=o;k[j+52>>2]=0;k[o>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b;b=h+4|0;e=b+4|0;k[e>>2]=0;k[e+4>>2]=0;k[h>>2]=33619968;k[b>>2]=j;sY(g,c,d,h);k[a>>2]=k[j>>2];b=a+4|0;e=k[p>>2]|0;k[b>>2]=e;g=a+8|0;k[g>>2]=k[i>>2];k[a+12>>2]=k[j+12>>2];l=j+16|0;k[a+16>>2]=k[l>>2];k[a+20>>2]=k[j+20>>2];k[a+24>>2]=k[j+24>>2];k[a+28>>2]=k[j+28>>2];i=j+32|0;k[a+32>>2]=k[i>>2];j=j+36|0;f=k[j>>2]|0;k[a+36>>2]=f;c=a+40|0;k[c>>2]=g;g=a+48|0;h=a+44|0;k[h>>2]=g;k[a+52>>2]=0;k[g>>2]=0;if(f){e=f+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[p>>2]|0}if((e|0)>=3){k[b>>2]=0;x1(a,e,0,0,0);if((k[b>>2]|0)>0){g=k[m>>2]|0;c=k[c>>2]|0;d=k[n>>2]|0;f=k[h>>2]|0;e=0;do{k[c+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[d+(e<<2)>>2];e=e+1|0}while((e|0)<(k[b>>2]|0))}}else{b=k[n>>2]|0;a=k[h>>2]|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2]}e=k[j>>2]|0;if(e|0?(b=e+12|0,a=k[b>>2]|0,k[b>>2]=a+-1,(a|0)==1):0){f=k[j>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[i>>2]|0;if(!e){e=B1()|0;f=k[j>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[j>>2]=0}k[j>>2]=0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[p>>2]|0)>0){f=k[m>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[p>>2]|0))}e=k[n>>2]|0;if(!((e|0)==(o|0)|(e|0)==0))ggb(k[e+-4>>2]|0);r=q;return}function uY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;if(a>>>0<b>>>0){g=a;r=h;return g|0}if((c|0)==1){g=(a|0)<0?0:b+-1|0;r=h;return g|0}e=(c|0)==4;switch(c|0){case 2:case 4:{d=e&1;if((b|0)==1){g=0;r=h;return g|0}f=b<<1;c=(e<<31>>31)+-1|0;do a=(a|0)<0?d+~a|0:c-a+f|0;while(a>>>0>=b>>>0);r=h;return a|0}case 3:{if((b|0)<=0?(f=g+4|0,d=ZT(12)|0,k[d>>2]=1,e=d+4|0,k[g>>2]=e,k[f>>2]=7,i[d+11>>0]=0,i[e>>0]=i[211192]|0,i[e+1>>0]=i[211193]|0,i[e+2>>0]=i[211194]|0,i[e+3>>0]=i[211195]|0,i[e+4>>0]=i[211196]|0,i[e+5>>0]=i[211197]|0,i[e+6>>0]=i[211198]|0,Y8(-215,g,211200,210908,919),k[f>>2]=0,k[g>>2]=0,g=k[d>>2]|0,k[d>>2]=g+-1,(g|0)==1):0)ggb(k[d+-4>>2]|0);c=a-b|0;if((a|0)<0)a=~c+a+((c+1|0)%(b|0)|0)|0;if((a|0)<(b|0)){g=a;r=h;return g|0}g=(a|0)%(b|0)|0;r=h;return g|0}case 0:{g=-1;r=h;return g|0}default:{c=g+4|0;d=ZT(36)|0;k[d>>2]=1;e=d+4|0;k[g>>2]=e;k[c>>2]=31;i[d+35>>0]=0;f=211218;b=e+31|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(b|0));Y8(-5,g,211200,210908,928);k[c>>2]=0;k[g>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0);g=a;r=h;return g|0}}return 0}function vY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0;G=r;r=r+2272|0;D=G+1208|0;F=G+1152|0;E=G+1096|0;C=G;if((d|c|e|f|0)<=-1){j=D+4|0;l=ZT(56)|0;k[l>>2]=1;m=l+4|0;k[D>>2]=m;k[j>>2]=50;i[l+54>>0]=0;o=211250;q=m+50|0;do{i[m>>0]=i[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));Y8(-215,D,211301,210908,1128);k[j>>2]=0;k[D>>2]=0;B=k[l>>2]|0;k[l>>2]=B+-1;if((B|0)==1)ggb(k[l+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){m=k[a+4>>2]|0;k[F>>2]=k[m>>2];s=F+4|0;a=m+4|0;k[s>>2]=k[a>>2];B=F+8|0;k[B>>2]=k[m+8>>2];k[F+12>>2]=k[m+12>>2];k[F+16>>2]=k[m+16>>2];k[F+20>>2]=k[m+20>>2];k[F+24>>2]=k[m+24>>2];k[F+28>>2]=k[m+28>>2];k[F+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[F+36>>2]=j;l=F+40|0;k[l>>2]=B;B=F+48|0;o=F+44|0;k[o>>2]=B;k[F+52>>2]=0;k[B>>2]=0;if(j|0){B=j+12|0;k[B>>2]=(k[B>>2]|0)+1}if((k[a>>2]|0)<3){B=k[m+44>>2]|0;t=k[o>>2]|0;k[t>>2]=k[B>>2];k[t+4>>2]=k[B+4>>2];t=F;break}k[s>>2]=0;x1(F,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[q+(a<<2)>>2];k[j+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0));t=F}else t=F}else{Q1(F,a,-1);t=F}while(0);l=k[t>>2]|0;if((g&16|0)==0&(l&32768|0)!=0){k[D>>2]=0;B=D+4|0;k[B>>2]=0;k[E>>2]=0;z=E+4|0;k[z>>2]=0;N1(F,D,E);z=k[z>>2]|0;y=(z|0)>(c|0)?c:z;a=F+8|0;z=(k[B>>2]|0)-(k[a>>2]|0)-z|0;z=(z|0)>(d|0)?d:z;B=k[E>>2]|0;A=(B|0)>(e|0)?e:B;j=F+12|0;B=(k[D>>2]|0)-(k[j>>2]|0)-B|0;B=(B|0)>(f|0)?f:B;O1(F,y,z,A,B);c=c-y|0;d=d-z|0;e=e-A|0;f=f-B|0}else{a=F+8|0;j=F+12|0}c2(b,c+d+(k[a>>2]|0)|0,e+f+(k[j>>2]|0)|0,l&4095,-1,0,0);do if((k[b>>2]&2031616|0)==65536){m=k[b+4>>2]|0;k[E>>2]=k[m>>2];s=E+4|0;a=m+4|0;k[s>>2]=k[a>>2];B=E+8|0;k[B>>2]=k[m+8>>2];k[E+12>>2]=k[m+12>>2];k[E+16>>2]=k[m+16>>2];k[E+20>>2]=k[m+20>>2];k[E+24>>2]=k[m+24>>2];k[E+28>>2]=k[m+28>>2];k[E+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[E+36>>2]=j;l=E+40|0;k[l>>2]=B;B=E+48|0;o=E+44|0;k[o>>2]=B;k[E+52>>2]=0;k[B>>2]=0;if(j|0){B=j+12|0;k[B>>2]=(k[B>>2]|0)+1}if((k[a>>2]|0)<3){A=k[m+44>>2]|0;B=k[o>>2]|0;k[B>>2]=k[A>>2];k[B+4>>2]=k[A+4>>2];break}k[s>>2]=0;x1(E,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[q+(a<<2)>>2];k[j+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else Q1(E,b,-1);while(0);do if(e|f|d|c){B=g&-17;if(!B){m=k[t>>2]|0;n=(m>>>3&511)+1|0;z=C+8|0;k[C>>2]=z;A=C+4|0;k[A>>2]=136;if(n>>>0<=136){k[A>>2]=n;if(n>>>0>4){a=z;u=105}else{l=n;j=m;a=z}}else{j=n<<3;while(1){a=fgb(j)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[C>>2]=a;k[A>>2]=n;u=105}do if((u|0)==105){H=+p[h>>3];if((H==+p[h+8>>3]?H==+p[h+16>>3]:0)?H==+p[h+24>>3]:0){l=1;j=m;break}k[D>>2]=0;a=D+4|0;k[a>>2]=0;j=ZT(76)|0;k[j>>2]=1;m=j+4|0;k[D>>2]=m;k[a>>2]=68;i[j+72>>0]=0;o=211316;q=m+68|0;do{i[m>>0]=i[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));Y8(-215,D,211301,210908,1289);k[a>>2]=0;k[D>>2]=0;B=k[j>>2]|0;k[j>>2]=B+-1;if((B|0)==1)ggb(k[j+-4>>2]|0);l=1;j=k[t>>2]|0;a=k[C>>2]|0}while(0);z2(h,a,j&7|(l<<3)+-8,n);b=k[F+16>>2]|0;u=k[F+48>>2]|0;v=k[F+40>>2]|0;o=k[v+4>>2]|0;v=k[v>>2]|0;d=k[E+16>>2]|0;w=k[E+48>>2]|0;j=k[E+40>>2]|0;q=k[j+4>>2]|0;j=k[j>>2]|0;a=k[F+4>>2]|0;if((a|0)>0)f=k[(k[F+44>>2]|0)+(a+-1<<2)>>2]|0;else f=0;n=k[C>>2]|0;h=aa(f,q)|0;x=D+8|0;k[D>>2]=x;y=D+4|0;k[y>>2]=1032;if(h>>>0>1032){while(1){a=fgb(h)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[D>>2]=a;g=a}else g=x;k[y>>2]=h;m=q-(o+e)|0;t=j-c-v|0;if((q|0)>0&(f|0)>0){j=0;do{l=aa(j,f)|0;a=0;do{i[g+(a+l)>>0]=i[n+a>>0]|0;a=a+1|0}while((a|0)!=(f|0));j=j+1|0}while((j|0)!=(q|0))}s=aa(f,o)|0;q=aa(f,e)|0;n=aa(f,m)|0;o=d+(aa(w,c)|0)|0;if((v|0)>0){m=0-q|0;a=b;j=o+q|0;l=0;while(1){if((j|0)!=(a|0))upb(j|0,a|0,s|0)|0;upb(j+m|0,g|0,q|0)|0;upb(j+s|0,g|0,n|0)|0;l=l+1|0;if((l|0)==(v|0))break;else{a=a+u|0;j=j+w|0}}}if((c|0)>0){a=0;do{upb(o+(aa(a-c|0,w)|0)|0,g|0,h|0)|0;a=a+1|0}while((a|0)!=(c|0))}if((t|0)>0){a=0;do{upb(o+(aa(a+v|0,w)|0)|0,g|0,h|0)|0;a=a+1|0}while((a|0)!=(t|0))}a=k[D>>2]|0;if((a|0)!=(x|0)){if(a|0)ggb(a);k[D>>2]=x;k[y>>2]=1032}a=k[C>>2]|0;if((a|0)!=(z|0)){if(a|0)ggb(a);k[C>>2]=z;k[A>>2]=136}break}t=k[F+16>>2]|0;w=k[F+48>>2]|0;z=k[F+40>>2]|0;q=k[z+4>>2]|0;z=k[z>>2]|0;d=k[E+16>>2]|0;A=k[E+48>>2]|0;n=k[E+40>>2]|0;f=k[n+4>>2]|0;n=k[n>>2]|0;a=k[F+4>>2]|0;if((a|0)>0)a=k[(k[F+44>>2]|0)+(a+-1<<2)>>2]|0;else a=0;b=((t|w|A|d|a)&3|0)==0;v=b?4:1;s=b?(a|0)/4|0:a;l=f-q|0;m=aa(s,l)|0;x=D+8|0;k[D>>2]=x;y=D+4|0;k[y>>2]=264;if(m>>>0>264){j=m>>>0>1073741823?-1:m<<2;j=(j|0)==0?1:j;while(1){a=fgb(j)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[D>>2]=a;u=a}else u=x;k[y>>2]=m;o=l-e|0;h=n-c-z|0;a:do if((e|0)>0){if((s|0)>0)j=0;else{a=0;while(1){uY(a-e|0,q,B)|0;a=a+1|0;if((a|0)>=(e|0))break a}}do{l=aa(uY(j-e|0,q,B)|0,s)|0;m=aa(j,s)|0;a=0;do{k[u+(a+m<<2)>>2]=a+l;a=a+1|0}while((a|0)!=(s|0));j=j+1|0}while((j|0)<(e|0))}while(0);b:do if((o|0)>0){if((s|0)>0)a=0;else{a=0;while(1){uY(a+q|0,q,B)|0;a=a+1|0;if((a|0)>=(o|0))break b}}do{l=aa(uY(a+q|0,q,B)|0,s)|0;m=aa(a+e|0,s)|0;j=0;do{k[u+(j+m<<2)>>2]=j+l;j=j+1|0}while((j|0)!=(s|0));a=a+1|0}while((a|0)<(o|0))}while(0);q=aa(s,q)|0;g=aa(s,f)|0;f=aa(s,e)|0;o=aa(s,o)|0;d=d+(aa(A,c)|0)|0;l=d+(aa(f,v)|0)|0;c:do if((z|0)>0){a=(f|0)>0;n=(o|0)>0;s=aa(q,v)|0;if(b){if(a){j=t;m=0;while(1){if((l|0)!=(j|0))upb(l|0,j|0,s|0)|0;a=0;do{k[l+(a-f<<2)>>2]=k[j+(k[u+(a<<2)>>2]<<2)>>2];a=a+1|0}while((a|0)!=(f|0));if(n){a=0;do{k[l+(a+q<<2)>>2]=k[j+(k[u+(a+f<<2)>>2]<<2)>>2];a=a+1|0}while((a|0)!=(o|0))}m=m+1|0;if((m|0)==(z|0))break c;else{l=l+A|0;j=j+w|0}}}if(n){a=t;m=0}else{a=t;j=0;while(1){if((l|0)!=(a|0))upb(l|0,a|0,s|0)|0;j=j+1|0;if((j|0)==(z|0))break c;else{l=l+A|0;a=a+w|0}}}while(1){if((l|0)!=(a|0))upb(l|0,a|0,s|0)|0;j=0;do{k[l+(j+q<<2)>>2]=k[a+(k[u+(j+f<<2)>>2]<<2)>>2];j=j+1|0}while((j|0)!=(o|0));m=m+1|0;if((m|0)==(z|0))break c;else{l=l+A|0;a=a+w|0}}}if(!a){if(n){a=t;j=0}else{a=t;j=0;while(1){if((l|0)!=(a|0))upb(l|0,a|0,s|0)|0;j=j+1|0;if((j|0)==(z|0))break c;else{l=l+A|0;a=a+w|0}}}while(1){if((l|0)==(a|0))m=0;else{upb(l|0,a|0,s|0)|0;m=0}do{i[l+(m+q)>>0]=i[a+(k[u+(m+f<<2)>>2]|0)>>0]|0;m=m+1|0}while((m|0)!=(o|0));j=j+1|0;if((j|0)==(z|0))break c;else{l=l+A|0;a=a+w|0}}}if(n){j=t;m=0}else{a=t;j=0;while(1){if((l|0)==(a|0))m=0;else{upb(l|0,a|0,s|0)|0;m=0}do{i[l+(m-f)>>0]=i[a+(k[u+(m<<2)>>2]|0)>>0]|0;m=m+1|0}while((m|0)!=(f|0));j=j+1|0;if((j|0)==(z|0))break c;else{l=l+A|0;a=a+w|0}}}while(1){if((l|0)==(j|0))a=0;else{upb(l|0,j|0,s|0)|0;a=0}do{i[l+(a-f)>>0]=i[j+(k[u+(a<<2)>>2]|0)>>0]|0;a=a+1|0}while((a|0)!=(f|0));a=0;do{i[l+(a+q)>>0]=i[j+(k[u+(a+f<<2)>>2]|0)>>0]|0;a=a+1|0}while((a|0)!=(o|0));m=m+1|0;if((m|0)==(z|0))break;else{l=l+A|0;j=j+w|0}}}while(0);j=aa(g,v)|0;if((c|0)>0){a=0;do{C=a-c|0;upb(d+(aa(C,A)|0)|0,d+(aa(uY(C,z,B)|0,A)|0)|0,j|0)|0;a=a+1|0}while((a|0)<(c|0))}if((h|0)>0){a=0;do{C=a+z|0;upb(d+(aa(C,A)|0)|0,d+(aa(uY(C,z,B)|0,A)|0)|0,j|0)|0;a=a+1|0}while((a|0)<(h|0))}a=k[D>>2]|0;if((a|0)!=(x|0)){if(a|0)ggb(a);k[D>>2]=x;k[y>>2]=264}}else{if((k[F+16>>2]|0)==(k[E+16>>2]|0)?(k[F+48>>2]|0)==(k[E+48>>2]|0):0)break;C=D+4|0;B=C+4|0;k[B>>2]=0;k[B+4>>2]=0;k[D>>2]=33619968;k[C>>2]=E;mY(F,D)}while(0);l=E+36|0;a=k[l>>2]|0;if(a|0?(C=a+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;if(!a){a=k[E+32>>2]|0;if(!a){a=B1()|0;j=k[l>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}k[l>>2]=0;D=E+16|0;j=E+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[j>>2]|0)>0){l=k[E+40>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[E+44>>2]|0;if(!((a|0)==(E+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);l=F+36|0;a=k[l>>2]|0;if(a|0?(D=a+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){j=k[l>>2]|0;if(j|0){a=k[j+4>>2]|0;if(!a){a=k[F+32>>2]|0;if(!a){a=B1()|0;j=k[l>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[l>>2]=0}k[l>>2]=0;E=F+16|0;j=F+4|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[j>>2]|0)>0){l=k[F+40>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[F+44>>2]|0;if((a|0)==(F+48|0)|(a|0)==0){r=G;return}ggb(k[a+-4>>2]|0);r=G;return}function wY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=r;r=r+128|0;x=y+72|0;w=y+16|0;o=y;h=(a|0)!=0;if((h?(b|0?(k[a>>2]&-65536|0)==1111752704:0):0)?(k[b>>2]&-65536|0)==1111752704:0){t=a+4|0;k[b+4>>2]=k[t>>2];upb(b+36|0,a+36|0,k[t>>2]<<2|0)|0;k[b+28>>2]=k[a+28>>2];k[b+32>>2]=k[a+32>>2];t=b+16|0;u=k[t>>2]|0;VY(u);k[u+56>>2]=0;k[u+60>>2]=0;u=b+24|0;c=k[u>>2]|0;e=b+20|0;if((k[(k[a+16>>2]|0)+60>>2]|0)<(c*3|0)){s=e;d=c;c=k[e>>2]|0}else{c=k[e>>2]|0;if(c|0)ggb(k[c+-4>>2]|0);k[e>>2]=0;c=k[a+24>>2]|0;k[u>>2]=c;c=ZT(c<<2)|0;k[e>>2]=c;s=e;d=k[u>>2]|0}zpb(c|0,0,d<<2|0)|0;c=K9(a,w)|0;a:do if(c|0){a=w+4|0;p=w+8|0;q=x+4|0;while(1){e=k[t>>2]|0;o=e+56|0;d=k[o>>2]|0;if(!d){if(!e){d=ZT(8)|0;k[d>>2]=1;b=d+4|0;k[x>>2]=b;k[q>>2]=0;i[b>>0]=0;Y8(-27,x,212600,211567,2507);k[q>>2]=0;k[x>>2]=0;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);d=k[o>>2]|0;if(!d)v=17}else v=17;if((v|0)==17){v=0;l=e+24|0;f=k[l>>2]|0;m=k[e+28>>2]|0;QY(e);n=e+36|0;d=k[n>>2]|0;k[o>>2]=d;g=d+m|0;j=k[e+32>>2]|0;b=j;if(g>>>0>j>>>0)g=d;else{h=d;while(1){k[h>>2]=f|-2147483648;k[h+4>>2]=g;f=f+1|0;h=g+m|0;if(h>>>0>j>>>0)break;else{z=g;g=h;h=z}}}k[g+(0-m)+4>>2]=0;z=(k[k[e+52>>2]>>2]|0)+12|0;k[z>>2]=f-(k[l>>2]|0)+(k[z>>2]|0);k[l>>2]=f;k[n>>2]=b}k[o>>2]=k[d+4>>2];k[d>>2]=k[d>>2]&67108863;e=e+60|0;k[e>>2]=(k[e>>2]|0)+1;e=k[t>>2]|0}else{k[o>>2]=k[d+4>>2];k[d>>2]=k[d>>2]&67108863;z=e+60|0;k[z>>2]=(k[z>>2]|0)+1}z=(k[u>>2]|0)+-1&k[c>>2];upb(d|0,c|0,k[e+28>>2]|0)|0;c=(k[s>>2]|0)+(z<<2)|0;k[d+4>>2]=k[c>>2];k[c>>2]=d;c=k[(k[a>>2]|0)+4>>2]|0;if(!c){d=(k[p>>2]|0)+1|0;k[p>>2]=d;c=k[w>>2]|0;f=k[c+24>>2]|0;if((d|0)>=(f|0))break a;e=k[c+20>>2]|0;while(1){c=k[e+(d<<2)>>2]|0;if(c|0)break;c=d+1|0;if((c|0)<(f|0))d=c;else break a}k[p>>2]=d}k[a>>2]=c}}while(0);r=y;return}M1(x,a,0,1,1,0);M1(w,b,0,1,1,0);b:do if(((k[w>>2]^k[x>>2])&7|0)==0?(d=k[x+40>>2]|0,e=k[d+-4>>2]|0,f=k[w+40>>2]|0,(e|0)==(k[f+-4>>2]|0)):0){if((e|0)==2){if((k[d>>2]|0)!=(k[f>>2]|0)){v=37;break}if((k[d+4>>2]|0)==(k[f+4>>2]|0))break;else{v=37;break}}if((e|0)>0){c=0;do{if((k[d+(c<<2)>>2]|0)!=(k[f+(c<<2)>>2]|0)){v=37;break b}c=c+1|0}while((c|0)<(e|0))}}else v=37;while(0);if((v|0)==37){k[o>>2]=0;c=o+4|0;k[c>>2]=0;d=ZT(56)|0;k[d>>2]=1;l=d+4|0;k[o>>2]=l;k[c>>2]=50;i[d+54>>0]=0;m=211392;n=l+50|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,o,211385,210908,1339);k[c>>2]=0;k[o>>2]=0;z=k[d>>2]|0;k[d>>2]=z+-1;if((z|0)==1)ggb(k[d+-4>>2]|0)}if(((h?(k[a>>2]|0)==112:0)?(k[a+68>>2]|0)!=0:0)?(g=k[a+48>>2]|0,(g|0)!=0):0)f=k[g>>2]|0;else f=0;if((((b|0)!=0?(k[b>>2]|0)==112:0)?(k[b+68>>2]|0)!=0:0)?(j=k[b+48>>2]|0,(j|0)!=0):0)e=k[j>>2]|0;else e=0;c=(e|0)==0;if(!(e|f)){if((k[w>>2]^k[x>>2])&4088|0){k[o>>2]=0;c=o+4|0;k[c>>2]=0;d=ZT(40)|0;k[d>>2]=1;l=d+4|0;k[o>>2]=l;k[c>>2]=32;i[d+36>>0]=0;m=211516;n=l+32|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,o,211385,210908,1357);k[c>>2]=0;k[o>>2]=0;z=k[d>>2]|0;k[d>>2]=z+-1;if((z|0)==1)ggb(k[d+-4>>2]|0)}z=o+4|0;v=z+4|0;k[v>>2]=0;k[v+4>>2]=0;k[o>>2]=33619968;k[z>>2]=w;mY(x,o)}else{if((f|0)==0?(k[x>>2]&4088|0)!=0:0)v=55;else v=53;if(((v|0)==53?c:0)?k[w>>2]&4088|0:0)v=55;if((v|0)==55){k[o>>2]=0;c=o+4|0;k[c>>2]=0;d=ZT(80)|0;k[d>>2]=1;l=d+4|0;k[o>>2]=l;k[c>>2]=72;i[d+76>>0]=0;m=211443;n=l+72|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,o,211385,210908,1350);k[c>>2]=0;k[o>>2]=0;z=k[d>>2]|0;k[d>>2]=z+-1;if((z|0)==1)ggb(k[d+-4>>2]|0)}z=f+-1|0;k[o>>2]=(z|0)<0?0:z;z=e+-1|0;k[o+4>>2]=(z|0)<0?0:z;HV(x,1,w,1,o,1)}e=w+36|0;c=k[e>>2]|0;if(c|0?(v=c+12|0,z=k[v>>2]|0,k[v>>2]=z+-1,(z|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[w+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;z=w+16|0;d=w+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[d>>2]|0)>0){e=k[w+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[w+44>>2]|0;if(!((c|0)==(w+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=x+36|0;c=k[e>>2]|0;if(c|0?(w=c+12|0,z=k[w>>2]|0,k[w>>2]=z+-1,(z|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[x+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;z=x+16|0;d=x+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[d>>2]|0)>0){e=k[x+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[x+44>>2]|0;if(!((c|0)==(x+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=y;return}function xY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0.0,l=0.0,m=0.0;i=r;r=r+192|0;h=i+136|0;d=i+32|0;e=i;f=i+120|0;g=i+64|0;M1(h,a,0,1,0,0);if(c){m=+p[b+8>>3];l=+p[b+16>>3];j=+p[b+24>>3];p[e>>3]=+p[b>>3];p[e+8>>3]=m;p[e+16>>3]=l;p[e+24>>3]=j;k[d>>2]=-1056833530;k[d+4>>2]=e;k[d+8>>2]=1;k[d+12>>2]=4;M1(g,c,0,1,0,0);k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=g;pY(h,d,f);c=g+36|0;a=k[c>>2]|0;if(a|0?(e=a+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[g+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;f=g+16|0;b=g+4|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[b>>2]|0)>0){c=k[g+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[g+44>>2]|0;if(!((a|0)==(g+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else{j=+p[b+8>>3];l=+p[b+16>>3];m=+p[b+24>>3];p[d>>3]=+p[b>>3];p[d+8>>3]=j;p[d+16>>3]=l;p[d+24>>3]=m;oY(h,d)}c=h+36|0;a=k[c>>2]|0;if(a|0?(f=a+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[h+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;g=h+16|0;b=h+4|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[b>>2]|0)>0){c=k[h+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[h+44>>2]|0;if((a|0)==(h+48|0)|(a|0)==0){r=i;return}ggb(k[a+-4>>2]|0);r=i;return}function yY(a){a=a|0;var b=0,c=0,d=0,e=0;e=r;r=r+96|0;d=e+32|0;b=e;if(a|0?(k[a>>2]&-65536|0)==1111752704:0){b=k[a+16>>2]|0;VY(b);k[b+56>>2]=0;k[b+60>>2]=0;b=k[a+20>>2]|0;if(!b){r=e;return}zpb(b|0,0,k[a+24>>2]<<2|0)|0;r=e;return}M1(d,a,0,1,0,0);k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;k[b+24>>2]=0;k[b+28>>2]=0;oY(d,b);c=d+36|0;b=k[c>>2]|0;if(b|0?(b=b+12|0,a=k[b>>2]|0,k[b>>2]=a+-1,(a|0)==1):0){a=k[c>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[d+32>>2]|0;if(!b){b=B1()|0;a=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[c>>2]=0}k[c>>2]=0;c=d+16|0;a=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[a>>2]|0)>0){c=k[d+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[d+44>>2]|0;if(!((b|0)==(d+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);r=e;return}function zY(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;b=e;c=ZT(24)|0;if((c|0)==0?(f=b+4|0,d=ZT(8)|0,k[d>>2]=1,g=d+4|0,k[b>>2]=g,k[f>>2]=0,i[g>>0]=0,Y8(-27,b,211549,211567,92),k[f>>2]=0,k[b>>2]=0,b=k[d>>2]|0,k[d>>2]=b+-1,(b|0)==1):0)ggb(k[d+-4>>2]|0);g=c+4|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g+16>>2]=0;k[c>>2]=1116274688;k[c+16>>2]=(a|0)<1?65408:a+7&-8;r=e;return c|0}function AY(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;d=r;r=r+16|0;b=d;if((a|0)==0?(e=b+4|0,c=ZT(8)|0,k[c>>2]=1,f=c+4|0,k[b>>2]=f,k[e>>2]=0,i[f>>0]=0,Y8(-27,b,211637,211567,121),k[e>>2]=0,k[b>>2]=0,b=k[c>>2]|0,k[c>>2]=b+-1,(b|0)==1):0)ggb(k[c+-4>>2]|0);f=zY(k[a+16>>2]|0)|0;k[f+12>>2]=a;r=d;return f|0}function BY(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;b=n;if((a|0)==0?(m=b+4|0,c=ZT(8)|0,k[c>>2]=1,l=c+4|0,k[b>>2]=l,k[m>>2]=0,i[l>>0]=0,Y8(-27,b,211661,211567,183),k[m>>2]=0,k[b>>2]=0,m=k[c>>2]|0,k[c>>2]=m+-1,(m|0)==1):0)ggb(k[c+-4>>2]|0);m=k[a>>2]|0;k[a>>2]=0;if(!m){r=n;return}g=m+12|0;a=k[g>>2]|0;if(!a)c=0;else c=k[a+8>>2]|0;h=m+4|0;b=k[h>>2]|0;if(!b){k[h>>2]=0;k[m+8>>2]=0;k[m+20>>2]=0}else{j=m+16|0;l=m+20|0;a:while(1){e=b+4|0;d=k[e>>2]|0;if(!a)while(1){ggb(k[b+-4>>2]|0);if(!d)break a;a=k[g>>2]|0;e=d+4|0;b=k[e>>2]|0;if(!a){f=d;d=b;b=f}else{f=d;break}}else{f=b;b=d}if(!c){k[a+8>>2]=f;k[a+4>>2]=f;k[e>>2]=0;k[f>>2]=0;k[l>>2]=(k[j>>2]|0)+-8}else{k[f>>2]=c;c=c+4|0;d=k[c>>2]|0;k[e>>2]=d;if(d|0)k[d>>2]=f;k[c>>2]=f}if(!b)break;else c=f}k[h>>2]=0;k[m+8>>2]=0;k[l>>2]=0}ggb(k[m+-4>>2]|0);r=n;return}function CY(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;b=n;if((a|0)==0?(m=b+4|0,c=ZT(8)|0,k[c>>2]=1,l=c+4|0,k[b>>2]=l,k[m>>2]=0,i[l>>0]=0,Y8(-27,b,211681,211567,200),k[m>>2]=0,k[b>>2]=0,m=k[c>>2]|0,k[c>>2]=m+-1,(m|0)==1):0)ggb(k[c+-4>>2]|0);c=k[a+12>>2]|0;m=a+4|0;if(!c){m=k[m>>2]|0;k[a+8>>2]=m;if(!m)b=0;else b=(k[a+16>>2]|0)+-8|0;k[a+20>>2]=b;r=n;return}d=k[m>>2]|0;if(!d)b=a+20|0;else{j=c+8|0;l=a+16|0;b=a+20|0;h=c+4|0;c=k[j>>2]|0;while(1){f=d+4|0;g=k[f>>2]|0;if(!c){k[j>>2]=d;k[h>>2]=d;k[f>>2]=0;k[d>>2]=0;k[b>>2]=(k[l>>2]|0)+-8}else{k[d>>2]=c;c=c+4|0;e=k[c>>2]|0;k[f>>2]=e;if(e|0)k[e>>2]=d;k[c>>2]=d}if(!g)break;else{c=d;d=g}}}k[m>>2]=0;k[a+8>>2]=0;k[b>>2]=0;r=n;return}function DY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;c=e;if(!((a|0)!=0&(b|0)!=0)?(f=c+4|0,d=ZT(8)|0,k[d>>2]=1,g=d+4|0,k[c>>2]=g,k[f>>2]=0,i[g>>0]=0,Y8(-27,c,211699,211567,276),k[f>>2]=0,k[c>>2]=0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[d+-4>>2]|0);k[b>>2]=k[a+8>>2];k[b+4>>2]=k[a+20>>2];r=e;return}function EY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;e=g;if(!((a|0)!=0&(b|0)!=0)?(f=e+4|0,c=ZT(8)|0,k[c>>2]=1,d=c+4|0,k[e>>2]=d,k[f>>2]=0,i[d>>0]=0,Y8(-27,e,211719,211567,288),k[f>>2]=0,k[e>>2]=0,f=k[c>>2]|0,k[c>>2]=f+-1,(f|0)==1):0)ggb(k[c+-4>>2]|0);d=b+4|0;c=k[d>>2]|0;f=a+16|0;if((c|0)>(k[f>>2]|0)){h=e+4|0;c=ZT(8)|0;k[c>>2]=1;j=c+4|0;k[e>>2]=j;k[h>>2]=0;i[j>>0]=0;Y8(-201,e,211719,211567,290);k[h>>2]=0;k[e>>2]=0;e=k[c>>2]|0;k[c>>2]=e+-1;if((e|0)==1)ggb(k[c+-4>>2]|0);e=k[d>>2]|0}else e=c;j=k[b>>2]|0;c=a+8|0;k[c>>2]=j;d=a+20|0;k[d>>2]=e;if(j|0){r=g;return}j=k[a+4>>2]|0;k[c>>2]=j;if(!j)c=0;else c=(k[f>>2]|0)+-8|0;k[d>>2]=c;r=g;return}function FY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;l=m;if(!a){c=l+4|0;d=ZT(28)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[c>>2]=20;i[d+24>>0]=0;h=243280;j=g+20|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-27,l,211742,211567,327);k[c>>2]=0;k[l>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}if((b|0)<0){c=l+4|0;d=ZT(40)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[c>>2]=35;i[d+39>>0]=0;h=211760;j=g+35|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-211,l,211742,211567,330);k[c>>2]=0;k[l>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}e=a+20|0;c=k[e>>2]|0;f=a+16|0;if(c>>>0>=b>>>0){j=c;l=a+8|0;l=k[l>>2]|0;a=k[f>>2]|0;a=l+a|0;l=0-j|0;l=a+l|0;b=j-b|0;b=b&-8;k[e>>2]=b;r=m;return l|0}if(((k[f>>2]|0)+-8&-8)>>>0<b>>>0){c=l+4|0;d=ZT(44)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[c>>2]=37;i[d+41>>0]=0;h=211796;j=g+37|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-211,l,211742,211567,338);k[c>>2]=0;k[l>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}GY(a);j=k[e>>2]|0;l=a+8|0;l=k[l>>2]|0;a=k[f>>2]|0;a=l+a|0;l=0-j|0;l=a+l|0;b=j-b|0;b=b&-8;k[e>>2]=b;r=m;return l|0}function GY(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;g=j;if((a|0)==0?(h=g+4|0,c=ZT(8)|0,k[c>>2]=1,f=c+4|0,k[g>>2]=f,k[h>>2]=0,i[f>>0]=0,Y8(-27,g,211834,211567,218),k[h>>2]=0,k[g>>2]=0,h=k[c>>2]|0,k[c>>2]=h+-1,(h|0)==1):0)ggb(k[c+-4>>2]|0);h=a+8|0;c=k[h>>2]|0;if(!((c|0)!=0?(b=k[c+4>>2]|0,(b|0)!=0):0))d=7;do if((d|0)==7){d=k[a+12>>2]|0;if(!d)b=ZT(k[a+16>>2]|0)|0;else{e=d+8|0;k[g>>2]=k[e>>2];f=d+20|0;k[g+4>>2]=k[f>>2];GY(d);b=k[e>>2]|0;EY(d,g);c=k[e>>2]|0;g=c;if((b|0)!=(c|0)){f=b+4|0;k[c+4>>2]=k[f>>2];c=k[f>>2]|0;if(c|0)k[c>>2]=g}else{k[d+4>>2]=0;k[e>>2]=0;k[f>>2]=0}}k[b+4>>2]=0;c=k[h>>2]|0;k[b>>2]=c;if(!c){k[a+4>>2]=b;k[h>>2]=b;h=a+16|0;h=k[h>>2]|0;h=h+-8|0;a=a+20|0;k[a>>2]=h;r=j;return}else{k[c+4>>2]=b;if(b|0)break;h=a+16|0;h=k[h>>2]|0;h=h+-8|0;a=a+20|0;k[a>>2]=h;r=j;return}}while(0);k[h>>2]=b;h=a+16|0;h=k[h>>2]|0;h=h+-8|0;a=a+20|0;k[a>>2]=h;r=j;return}function HY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;if((d|0)==0?(h=j+4|0,f=ZT(8)|0,k[f>>2]=1,g=f+4|0,k[j>>2]=g,k[h>>2]=0,i[g>>0]=0,Y8(-27,j,211852,211567,377),k[h>>2]=0,k[j>>2]=0,h=k[f>>2]|0,k[f>>2]=h+-1,(h|0)==1):0)ggb(k[f+-4>>2]|0);if(b>>>0<56|(c|0)==0?(h=j+4|0,e=ZT(8)|0,k[e>>2]=1,g=e+4|0,k[j>>2]=g,k[h>>2]=0,i[g>>0]=0,Y8(-201,j,211852,211567,379),k[h>>2]=0,k[j>>2]=0,h=k[e>>2]|0,k[e>>2]=h+-1,(h|0)==1):0)ggb(k[e+-4>>2]|0);h=FY(d,b)|0;zpb(h|0,0,b|0)|0;k[h+4>>2]=b;k[h>>2]=a&65535|1117323264;e=(a>>>3&511)+1<<(47696>>>(a<<1&14)&3);a:do if(e|0){switch(a&4095){case 0:case 7:break a;default:{}}if((e|0)!=(c|0)){e=j+4|0;f=ZT(116)|0;k[f>>2]=1;b=f+4|0;k[j>>2]=b;k[e>>2]=110;i[f+114>>0]=0;a=211864;g=b+110|0;do{i[b>>0]=i[a>>0]|0;b=b+1|0;a=a+1|0}while((b|0)<(g|0));Y8(-201,j,211852,211567,395);k[e>>2]=0;k[j>>2]=0;j=k[f>>2]|0;k[f>>2]=j+-1;if((j|0)==1)ggb(k[f+-4>>2]|0)}}while(0);k[h+28>>2]=c;k[h+44>>2]=d;IY(h,1024/(c>>>0)|0);r=l;return h|0}function IY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;if(!((a|0)!=0?(k[a+44>>2]|0)!=0:0))e=3;if((e|0)==3?(f=g+4|0,d=ZT(8)|0,k[d>>2]=1,e=d+4|0,k[g>>2]=e,k[f>>2]=0,i[e>>0]=0,Y8(-27,g,211975,211567,415),k[f>>2]=0,k[g>>2]=0,f=k[d>>2]|0,k[d>>2]=f+-1,(f|0)==1):0)ggb(k[d+-4>>2]|0);if((b|0)<0?(f=g+4|0,c=ZT(8)|0,k[c>>2]=1,e=c+4|0,k[g>>2]=e,k[f>>2]=0,i[e>>0]=0,Y8(-211,g,211975,211567,417),k[f>>2]=0,k[g>>2]=0,f=k[c>>2]|0,k[c>>2]=f+-1,(f|0)==1):0)ggb(k[c+-4>>2]|0);c=(k[(k[a+44>>2]|0)+16>>2]|0)+-28&-8;d=k[a+28>>2]|0;if(!b){b=1024/(d|0)|0;b=(b|0)<1?1:b}if((aa(b,d)|0)<=(c|0)){f=b;g=a+40|0;k[g>>2]=f;r=h;return}b=(c|0)/(d|0)|0;if(b|0){f=b;g=a+40|0;k[g>>2]=f;r=h;return}b=g+4|0;c=ZT(68)|0;k[c>>2]=1;d=c+4|0;k[g>>2]=d;k[b>>2]=60;i[c+64>>0]=0;e=211993;f=d+60|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-211,g,211975,211567,433);k[b>>2]=0;k[g>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)==1)ggb(k[c+-4>>2]|0);f=0;g=a+40|0;k[g>>2]=f;r=h;return}function JY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+48|0;g=m+8|0;e=m;if(!((a|0)!=0&(b|0)!=0)?(l=e+4|0,f=ZT(8)|0,k[f>>2]=1,j=f+4|0,k[e>>2]=j,k[l>>2]=0,i[j>>0]=0,Y8(-27,e,212086,211567,551),k[l>>2]=0,k[e>>2]=0,l=k[f>>2]|0,k[f>>2]=l+-1,(l|0)==1):0)ggb(k[f+-4>>2]|0);l=k[a+28>>2]|0;f=k[a+24>>2]|0;if((d|0)==(c|0))e=0;else e=d-c+((c|0)<0?0-f|0:0)+((d|0)<1?f:0)|0;while(1)if((e|0)<0)e=e+f|0;else break;e=aa((e|0)>(f|0)?f:e,l)|0;if(!e){r=m;return}KY(a,g);LY(g,c,0);h=g+20|0;j=g+12|0;g=g+8|0;a=e;f=b;d=k[j>>2]|0;c=k[h>>2]|0;while(1){e=c-d|0;e=(e|0)>(a|0)?a:e;upb(f|0,d|0,e|0)|0;b=k[(k[g>>2]|0)+4>>2]|0;k[g>>2]=b;d=k[b+16>>2]|0;k[j>>2]=d;c=d+(aa(k[b+12>>2]|0,l)|0)|0;k[h>>2]=c;a=a-e|0;if((a|0)<=0)break;else f=f+e|0}r=m;return}function KY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;d=e;if(!((b|0)!=0?(c=b+4|0,k[c>>2]=0,k[c+4>>2]=0,k[c+8>>2]=0,k[c+12>>2]=0,k[c+16>>2]=0,(a|0)!=0):0)){f=d+4|0;c=ZT(8)|0;k[c>>2]=1;g=c+4|0;k[d>>2]=g;k[f>>2]=0;i[g>>0]=0;Y8(-27,d,212120,211567,945);k[f>>2]=0;k[d>>2]=0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)==1)ggb(k[c+-4>>2]|0);c=b+4|0}k[b>>2]=32;k[c>>2]=a;c=k[a+52>>2]|0;if(!c){g=b+8|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g+16>>2]=0;k[g+20>>2]=0;r=e;return}else{d=k[c>>2]|0;f=c+16|0;k[b+12>>2]=k[f>>2];g=a+28|0;a=(k[d+16>>2]|0)+(aa((k[d+12>>2]|0)+-1|0,k[g>>2]|0)|0)|0;k[b+28>>2]=a;k[b+24>>2]=k[c+8>>2];k[b+8>>2]=c;f=k[f>>2]|0;k[b+16>>2]=f;g=f+(aa(k[g>>2]|0,k[c+12>>2]|0)|0)|0;k[b+20>>2]=g;r=e;return}}function LY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;h=n;if((a|0)!=0?(d=a+4|0,e=k[d>>2]|0,(e|0)!=0):0)g=d;else{m=h+4|0;d=ZT(8)|0;k[d>>2]=1;l=d+4|0;k[h>>2]=l;k[m>>2]=0;i[l>>0]=0;Y8(-27,h,212102,211567,1045);k[m>>2]=0;k[h>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0);e=a+4|0;g=e;e=k[e>>2]|0}d=k[e+24>>2]|0;m=k[e+28>>2]|0;if(c|0){l=a+12|0;f=k[l>>2]|0;d=aa(m,b)|0;j=a+8|0;e=k[j>>2]|0;b=f+d|0;if((d|0)>0){h=a+20|0;g=k[h>>2]|0;if(b>>>0>=g>>>0){c=f;b=g;do{d=d+c-b|0;e=k[e+4>>2]|0;c=k[e+16>>2]|0;g=aa(k[e+12>>2]|0,m)|0;b=c+g|0}while((d|0)>=(g|0));k[j>>2]=e;k[a+16>>2]=c;k[h>>2]=b;b=c+d|0}}else{h=a+16|0;c=k[h>>2]|0;if(b>>>0<c>>>0){g=f;do{d=d+g-c|0;e=k[e>>2]|0;f=k[e+16>>2]|0;c=f;g=c+(aa(k[e+12>>2]|0,m)|0)|0;b=g+d|0}while(b>>>0<c>>>0);k[h>>2]=f;k[j>>2]=e;k[a+20>>2]=g}}k[l>>2]=b;r=n;return}if((b|0)>=0){if((d|0)<=(b|0)){b=b-d|0;if((b|0)>=(d|0)){l=h+4|0;e=ZT(8)|0;k[e>>2]=1;j=e+4|0;k[h>>2]=j;k[l>>2]=0;i[j>>0]=0;Y8(-211,h,212102,211567,1062);k[l>>2]=0;k[h>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}}}else{if((b|0)<(0-d|0)?(l=h+4|0,f=ZT(8)|0,k[f>>2]=1,j=f+4|0,k[h>>2]=j,k[l>>2]=0,i[j>>0]=0,Y8(-211,h,212102,211567,1055),k[l>>2]=0,k[h>>2]=0,l=k[f>>2]|0,k[f>>2]=l+-1,(l|0)==1):0)ggb(k[f+-4>>2]|0);b=d+b|0}e=k[(k[g>>2]|0)+52>>2]|0;c=k[e+12>>2]|0;a:do if((b|0)>=(c|0)){if((b<<1|0)<=(d|0))while(1){e=k[e+4>>2]|0;b=b-c|0;c=k[e+12>>2]|0;if((b|0)<(c|0))break a}do{e=k[e>>2]|0;c=k[e+12>>2]|0;d=d-c|0}while((b|0)<(d|0));b=b-d|0}while(0);d=k[e+16>>2]|0;b=d+(aa(b,m)|0)|0;k[a+12>>2]=b;b=a+8|0;if((k[b>>2]|0)==(e|0)){r=n;return}k[b>>2]=e;k[a+16>>2]=d;m=d+(aa(c,m)|0)|0;k[a+20>>2]=m;r=n;return}function MY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0;n=r;r=r+16|0;m=n;if((b|0)<56|(c|0)<1|(e|0)<0?(o=m+4|0,h=ZT(8)|0,k[h>>2]=1,p=h+4|0,k[m>>2]=p,k[o>>2]=0,i[p>>0]=0,Y8(-201,m,212135,211567,590),k[o>>2]=0,k[m>>2]=0,o=k[h>>2]|0,k[h>>2]=o+-1,(o|0)==1):0)ggb(k[h+-4>>2]|0);if(!((f|0)!=0?!((e|0)>0&((d|0)==0|(g|0)==0)):0))l=7;if((l|0)==7?(p=m+4|0,j=ZT(8)|0,k[j>>2]=1,o=j+4|0,k[m>>2]=o,k[p>>2]=0,i[o>>0]=0,Y8(-27,m,212135,211567,593),k[p>>2]=0,k[m>>2]=0,p=k[j>>2]|0,k[j>>2]=p+-1,(p|0)==1):0)ggb(k[j+-4>>2]|0);zpb(f|0,0,b|0)|0;k[f+4>>2]=b;k[f>>2]=a&65535|1117323264;p=(a>>>3&511)+1<<(47696>>>(a<<1&14)&3);if(!((p|0)==(c|0)|((a&4095|0)==0|(p|0)==0))){a=m+4|0;b=ZT(112)|0;k[b>>2]=1;h=b+4|0;k[m>>2]=h;k[a>>2]=106;i[b+110>>0]=0;j=212159;l=h+106|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-201,m,212135,211567,607);k[a>>2]=0;k[m>>2]=0;p=k[b>>2]|0;k[b>>2]=p+-1;if((p|0)==1)ggb(k[b+-4>>2]|0)}k[f+28>>2]=c;k[f+24>>2]=e;p=d+(aa(e,c)|0)|0;k[f+36>>2]=p;k[f+32>>2]=p;if((e|0)<=0){r=n;return f|0}k[f+52>>2]=g;k[g+4>>2]=g;k[g>>2]=g;k[g+8>>2]=0;k[g+12>>2]=e;k[g+16>>2]=d;r=n;return f|0}function NY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;c=e;if(!((a|0)!=0&(b|0)!=0)?(f=c+4|0,d=ZT(8)|0,k[d>>2]=1,g=d+4|0,k[c>>2]=g,k[f>>2]=0,i[g>>0]=0,Y8(-27,c,212266,211567,820),k[f>>2]=0,k[c>>2]=0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[d+-4>>2]|0);c=b+4|0;g=c+4|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[b>>2]=24;k[c>>2]=a;c=k[a+52>>2]|0;if(!c)c=0;else c=k[c>>2]|0;k[b+8>>2]=c;k[b+12>>2]=k[a+36>>2];k[b+20>>2]=k[a+32>>2];r=e;return}function OY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;f=h;if((d|0)!=0&(e|0)!=0){g=HY(a,b,c,d)|0;NY(g,e);r=h;return}j=f+4|0;g=ZT(8)|0;k[g>>2]=1;l=g+4|0;k[f>>2]=l;k[j>>2]=0;i[l>>0]=0;Y8(-27,f,212285,211567,838);k[j>>2]=0;k[f>>2]=0;f=k[g>>2]|0;k[g>>2]=f+-1;if((f|0)==1)ggb(k[g+-4>>2]|0);l=HY(a,b,c,d)|0;NY(l,e);r=h;return}function PY(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;c=l;if(!((a|0)!=0?(b=k[a+4>>2]|0,(b|0)!=0):0)){j=c+4|0;b=ZT(8)|0;k[b>>2]=1;h=b+4|0;k[c>>2]=h;k[j>>2]=0;i[h>>0]=0;Y8(-27,c,212301,211567,912);k[j>>2]=0;k[c>>2]=0;j=k[b>>2]|0;k[b>>2]=j+-1;if((j|0)==1)ggb(k[b+-4>>2]|0);b=k[a+4>>2]|0}f=a+12|0;c=k[f>>2]|0;g=b+36|0;k[g>>2]=c;h=a+8|0;d=k[h>>2]|0;e=b+52|0;if(!d){QY(b);j=k[e>>2]|0;j=k[j>>2]|0;k[h>>2]=j;j=k[g>>2]|0;k[f>>2]=j;j=b+32|0;j=k[j>>2]|0;a=a+20|0;k[a>>2]=j;r=l;return}j=k[e>>2]|0;k[d+12>>2]=(c-(k[d+16>>2]|0)|0)/(k[b+28>>2]|0)|0;c=j;d=0;do{d=(k[c+12>>2]|0)+d|0;c=k[c+4>>2]|0}while((c|0)!=(j|0));k[b+24>>2]=d;QY(b);j=k[e>>2]|0;j=k[j>>2]|0;k[h>>2]=j;j=k[g>>2]|0;k[f>>2]=j;j=b+32|0;j=k[j>>2]|0;a=a+20|0;k[a>>2]=j;r=l;return}function QY(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;g=n;if((a|0)==0?(m=g+4|0,b=ZT(8)|0,k[b>>2]=1,l=b+4|0,k[g>>2]=l,k[m>>2]=0,i[l>>0]=0,Y8(-27,g,212318,211567,637),k[m>>2]=0,k[g>>2]=0,m=k[b>>2]|0,k[b>>2]=m+-1,(m|0)==1):0)ggb(k[b+-4>>2]|0);b=a+48|0;c=k[b>>2]|0;if(!c){h=a+28|0;j=k[h>>2]|0;l=k[a+40>>2]|0;m=k[a+44>>2]|0;if((k[a+24>>2]|0)>=(l<<2|0))IY(a,l<<1);if(!m){b=g+4|0;c=ZT(44)|0;k[c>>2]=1;d=c+4|0;k[g>>2]=d;k[b>>2]=37;i[c+41>>0]=0;e=212329;f=d+37|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-27,g,212318,211567,650);k[b>>2]=0;k[g>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)==1)ggb(k[c+-4>>2]|0)}b=(k[m+8>>2]|0)+(k[m+16>>2]|0)|0;c=m+20|0;f=k[c>>2]|0;d=a+32|0;e=k[d>>2]|0;if((b+(0-f)-e|0)>>>0<8?(f|0)>=(k[h>>2]|0):0){a=(f|0)/(j|0)|0;a=e+(aa((a|0)>(l|0)?l:a,j)|0)|0;k[d>>2]=a;k[c>>2]=b-a&-8;r=n;return}b=(aa(l,j)|0)+24|0;do if((f|0)<(b|0))if((f|0)<((aa((l|0)>5?(l|0)/3|0:1,j)|0)+32|0)){GY(m);break}else{b=f-((f+-24|0)%(k[h>>2]|0)|0)|0;break}while(0);c=FY(m,b)|0;k[c+16>>2]=c+20+7&-8;k[c+12>>2]=b+-24;k[c+4>>2]=0;k[c>>2]=0}else k[b>>2]=k[c+4>>2];b=a+52|0;d=k[b>>2]|0;if(!d){k[b>>2]=c;k[c+4>>2]=c;k[c>>2]=c;b=c}else{k[c>>2]=k[d>>2];k[c+4>>2]=d;k[d>>2]=c;b=k[c>>2]|0;k[b+4>>2]=c}m=k[c+16>>2]|0;k[a+36>>2]=m;d=c+12|0;k[a+32>>2]=m+(k[d>>2]|0);if((c|0)==(b|0))b=0;else b=(k[b+12>>2]|0)+(k[b+8>>2]|0)|0;k[c+8>>2]=b;k[d>>2]=0;r=n;return}function RY(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;f=r;r=r+16|0;b=f;if(!((a|0)!=0?(k[a+12>>2]|0)!=0:0))d=3;if((d|0)==3?(d=b+4|0,c=ZT(8)|0,k[c>>2]=1,g=c+4|0,k[b>>2]=g,k[d>>2]=0,i[g>>0]=0,Y8(-27,b,212367,211567,1020),k[d>>2]=0,k[b>>2]=0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[c+-4>>2]|0);b=k[(k[a+4>>2]|0)+28>>2]|0;if((b|0)<33?(e=b+-1|0,-2147450741>>>e&1|0):0){e=(k[a+12>>2]|0)-(k[a+16>>2]|0)>>i[212054+e>>0];d=a+8|0;d=k[d>>2]|0;d=d+8|0;d=k[d>>2]|0;g=a+24|0;g=k[g>>2]|0;e=d+e|0;g=e-g|0;r=f;return g|0}e=((k[a+12>>2]|0)-(k[a+16>>2]|0)|0)/(b|0)|0;d=a+8|0;d=k[d>>2]|0;d=d+8|0;d=k[d>>2]|0;g=a+24|0;g=k[g>>2]|0;e=d+e|0;g=e-g|0;r=f;return g|0}function SY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=r;r=r+16|0;c=f;if((a|0)==0?(e=c+4|0,d=ZT(8)|0,k[d>>2]=1,g=d+4|0,k[c>>2]=g,k[e>>2]=0,i[g>>0]=0,Y8(-27,c,212385,211567,1138),k[e>>2]=0,k[c>>2]=0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)ggb(k[d+-4>>2]|0);d=k[a+28>>2]|0;e=a+36|0;c=k[e>>2]|0;if(c>>>0>=(k[a+32>>2]|0)>>>0){QY(a);c=k[e>>2]|0}if(b|0)upb(c|0,b|0,d|0)|0;g=(k[k[a+52>>2]>>2]|0)+12|0;k[g>>2]=(k[g>>2]|0)+1;g=a+24|0;k[g>>2]=(k[g>>2]|0)+1;k[e>>2]=c+d;r=f;return c|0}function TY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;e=n;if((a|0)==0?(m=e+4|0,c=ZT(8)|0,k[c>>2]=1,l=c+4|0,k[e>>2]=l,k[m>>2]=0,i[l>>0]=0,Y8(-27,e,212395,211567,1169),k[m>>2]=0,k[e>>2]=0,m=k[c>>2]|0,k[c>>2]=m+-1,(m|0)==1):0)ggb(k[c+-4>>2]|0);m=a+24|0;if((k[m>>2]|0)<1?(l=e+4|0,d=ZT(8)|0,k[d>>2]=1,j=d+4|0,k[e>>2]=j,k[l>>2]=0,i[j>>0]=0,Y8(-201,e,212395,211567,1171),k[l>>2]=0,k[e>>2]=0,l=k[d>>2]|0,k[d>>2]=l+-1,(l|0)==1):0)ggb(k[d+-4>>2]|0);h=a+28|0;c=k[h>>2]|0;j=a+36|0;l=(k[j>>2]|0)+(0-c)|0;k[j>>2]=l;if(b|0)upb(b|0,l|0,c|0)|0;k[j>>2]=l;k[m>>2]=(k[m>>2]|0)+-1;d=a+52|0;c=k[d>>2]|0;e=k[c>>2]|0;b=e+12|0;g=(k[b>>2]|0)+-1|0;k[b>>2]=g;if(g|0){r=n;return}f=a+32|0;g=k[f>>2]|0;if((c|0)==(e|0)){l=c+16|0;h=(aa(k[h>>2]|0,k[c+8>>2]|0)|0)+(g-(k[l>>2]|0))|0;k[c+12>>2]=h;k[l>>2]=g+(0-h);k[d>>2]=0;k[f>>2]=0;k[j>>2]=0;k[m>>2]=0}else{k[b>>2]=g-l;m=k[e>>2]|0;c=(k[m+16>>2]|0)+(aa(k[h>>2]|0,k[m+12>>2]|0)|0)|0;k[j>>2]=c;k[f>>2]=c;c=e+4|0;k[m+4>>2]=k[c>>2];k[k[c>>2]>>2]=m;c=e}a=a+48|0;k[c+4>>2]=k[a>>2];k[a>>2]=c;r=n;return}function UY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;f=n;if(!a){d=f+4|0;e=ZT(28)|0;k[e>>2]=1;g=e+4|0;k[f>>2]=g;k[d>>2]=21;i[e+25>>0]=0;h=212404;j=g+21|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-27,f,212426,211567,1459);k[d>>2]=0;k[f>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}if((c|0)<0){d=f+4|0;e=ZT(44)|0;k[e>>2]=1;g=e+4|0;k[f>>2]=g;k[d>>2]=38;i[e+42>>0]=0;h=212441;j=g+38|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-201,f,212426,211567,1461);k[d>>2]=0;k[f>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}g=k[a+28>>2]|0;if((c|0)<=0){r=n;return}h=a+32|0;j=a+36|0;l=a+52|0;m=a+24|0;d=c;while(1){e=k[j>>2]|0;f=((k[h>>2]|0)-e|0)/(g|0)|0;f=(f|0)>(d|0)?d:f;if((f|0)>0){c=(k[k[l>>2]>>2]|0)+12|0;k[c>>2]=(k[c>>2]|0)+f;k[m>>2]=(k[m>>2]|0)+f;d=d-f|0;f=aa(f,g)|0;if(!b)b=0;else{upb(e|0,b|0,f|0)|0;b=b+f|0;e=k[j>>2]|0}k[j>>2]=e+f;if((d|0)<=0)break}QY(a)}r=n;return}function VY(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;p=r;r=r+16|0;h=p;if(!a){o=h+4|0;b=ZT(8)|0;k[b>>2]=1;n=b+4|0;k[h>>2]=n;k[o>>2]=0;i[n>>0]=0;Y8(-27,h,212494,211567,1596);k[o>>2]=0;k[h>>2]=0;o=k[b>>2]|0;k[b>>2]=o+-1;if((o|0)==1)ggb(k[b+-4>>2]|0);b=k[6]|0;c=h+4|0;d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=21;i[d+25>>0]=0;f=212404;g=e+21|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-27,h,212480,211567,1528);k[c>>2]=0;k[h>>2]=0;o=k[d>>2]|0;k[d>>2]=o+-1;if((o|0)==1)ggb(k[d+-4>>2]|0)}else b=k[a+24>>2]|0;if((b|0)<0){c=h+4|0;d=ZT(44)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=38;i[d+42>>0]=0;f=212441;g=e+38|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-201,h,212480,211567,1530);k[c>>2]=0;k[h>>2]=0;o=k[d>>2]|0;k[d>>2]=o+-1;if((o|0)==1)ggb(k[d+-4>>2]|0)}o=a+24|0;d=k[o>>2]|0;b=(d|0)<(b|0)?d:b;if((b|0)<=0){r=p;return}j=a+52|0;l=a+36|0;m=a+32|0;n=a+48|0;a=k[a+28>>2]|0;c=k[j>>2]|0;e=k[l>>2]|0;do{h=k[c>>2]|0;g=h+12|0;q=k[g>>2]|0;f=(q|0)>(b|0)?b:q;q=q-f|0;k[g>>2]=q;d=d-f|0;b=b-f|0;e=e+(0-(aa(a,f)|0))|0;k[l>>2]=e;f=e;if(!q){e=k[m>>2]|0;if((c|0)==(h|0)){f=c+16|0;d=(aa(a,k[c+8>>2]|0)|0)+(e-(k[f>>2]|0))|0;k[g>>2]=d;k[f>>2]=e+(0-d);k[j>>2]=0;k[m>>2]=0;k[l>>2]=0;f=c+4|0;e=0;d=0;c=0}else{k[g>>2]=e-f;q=k[h>>2]|0;e=(k[q+16>>2]|0)+(aa(a,k[q+12>>2]|0)|0)|0;k[l>>2]=e;k[m>>2]=e;f=h+4|0;k[q+4>>2]=k[f>>2];k[k[f>>2]>>2]=q}k[f>>2]=k[n>>2];k[n>>2]=h}}while((b|0)>0);k[o>>2]=d;r=p;return}function WY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;f=g;if((d|0)==0?(h=f+4|0,e=ZT(8)|0,k[e>>2]=1,j=e+4|0,k[f>>2]=j,k[h>>2]=0,i[j>>0]=0,Y8(-27,f,212588,211567,2486),k[h>>2]=0,k[f>>2]=0,h=k[e>>2]|0,k[e>>2]=h+-1,(h|0)==1):0)ggb(k[e+-4>>2]|0);if((b|0)>63&(c|0)>7&(c&3|0)==0){j=HY(a,b,c,d)|0;h=k[j>>2]|0;h=h&65535;h=h|1117257728;k[j>>2]=h;r=g;return j|0}j=f+4|0;e=ZT(8)|0;k[e>>2]=1;h=e+4|0;k[f>>2]=h;k[j>>2]=0;i[h>>0]=0;Y8(-201,f,212588,211567,2490);k[j>>2]=0;k[f>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);j=HY(a,b,c,d)|0;h=k[j>>2]|0;h=h&65535;h=h|1117257728;k[j>>2]=h;r=g;return j|0}function XY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;o=r;r=r+16|0;c=o;if((a|0)==0?(n=c+4|0,d=ZT(8)|0,k[d>>2]=1,m=d+4|0,k[c>>2]=m,k[n>>2]=0,i[m>>0]=0,Y8(-27,c,212600,211567,2507),k[n>>2]=0,k[c>>2]=0,n=k[d>>2]|0,k[d>>2]=n+-1,(n|0)==1):0)ggb(k[d+-4>>2]|0);n=a+56|0;c=k[n>>2]|0;if(!c){h=a+24|0;d=k[h>>2]|0;j=k[a+28>>2]|0;QY(a);l=a+36|0;c=k[l>>2]|0;k[n>>2]=c;e=c+j|0;g=k[a+32>>2]|0;m=g;if(e>>>0>g>>>0)e=c;else{f=c;while(1){k[f>>2]=d|-2147483648;k[f+4>>2]=e;d=d+1|0;f=e+j|0;if(f>>>0>g>>>0)break;else{p=e;e=f;f=p}}}k[e+(0-j)+4>>2]=0;p=(k[k[a+52>>2]>>2]|0)+12|0;k[p>>2]=d-(k[h>>2]|0)+(k[p>>2]|0);k[h>>2]=d;k[l>>2]=m}k[n>>2]=k[c+4>>2];k[c>>2]=k[c>>2]&67108863;p=a+60|0;k[p>>2]=(k[p>>2]|0)+1;if(!b){r=o;return}k[b>>2]=c;r=o;return}function YY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;g=h;if((c|0)<8|((b|0)<68|(d|0)<24)?(j=g+4|0,f=ZT(8)|0,k[f>>2]=1,l=f+4|0,k[g>>2]=l,k[j>>2]=0,i[l>>0]=0,Y8(-201,g,212609,211567,2585),k[j>>2]=0,k[g>>2]=0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[f+-4>>2]|0);l=WY(a,b,c,e)|0;j=WY(0,64,d,e)|0;k[l+64>>2]=j;r=h;return l|0}function ZY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;q=r;r=r+16|0;d=q;if((a|0)==0?(o=d+4|0,e=ZT(8)|0,k[e>>2]=1,n=e+4|0,k[d>>2]=n,k[o>>2]=0,i[n>>0]=0,Y8(-27,d,212623,211567,2619),k[o>>2]=0,k[d>>2]=0,o=k[e>>2]|0,k[e>>2]=o+-1,(o|0)==1):0)ggb(k[e+-4>>2]|0);o=a+56|0;d=k[o>>2]|0;if(!d){j=a+24|0;e=k[j>>2]|0;l=k[a+28>>2]|0;QY(a);m=a+36|0;d=k[m>>2]|0;k[o>>2]=d;f=d+l|0;h=k[a+32>>2]|0;n=h;if(f>>>0>h>>>0)f=d;else{g=d;while(1){k[g>>2]=e|-2147483648;k[g+4>>2]=f;e=e+1|0;g=f+l|0;if(g>>>0>h>>>0)break;else{s=f;f=g;g=s}}}k[f+(0-l)+4>>2]=0;s=(k[k[a+52>>2]>>2]|0)+12|0;k[s>>2]=e-(k[j>>2]|0)+(k[s>>2]|0);k[j>>2]=e;k[m>>2]=n;k[o>>2]=k[d+4>>2];k[d>>2]=k[d>>2]&67108863;s=a+60|0;k[s>>2]=(k[s>>2]|0)+1;if(!d)d=0;else p=10}else{k[o>>2]=k[d+4>>2];k[d>>2]=k[d>>2]&67108863;p=a+60|0;k[p>>2]=(k[p>>2]|0)+1;p=10}if((p|0)==10){if(b|0)upb(d+8|0,b+8|0,(k[a+28>>2]|0)+-8|0)|0;k[d+4>>2]=0}if(!c){r=q;return}k[c>>2]=d;r=q;return}function _Y(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+16|0;n=v;if(!a){f=n+4|0;g=ZT(28)|0;k[g>>2]=1;j=g+4|0;k[n>>2]=j;k[f>>2]=21;i[g+25>>0]=0;l=212658;m=j+21|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-27,n,212680,211567,2761);k[f>>2]=0;k[n>>2]=0;u=k[g>>2]|0;k[g>>2]=u+-1;if((u|0)==1)ggb(k[g+-4>>2]|0)}if(!(k[a>>2]&16384)){s=(k[b>>2]&67108863)>>>0>(k[c>>2]&67108863)>>>0;u=s?c:b;c=s?b:c}else u=b;l=(c|0)!=0;if(!((a|0)!=0&(u|0)!=0&l)?(s=n+4|0,h=ZT(8)|0,k[h>>2]=1,q=h+4|0,k[n>>2]=q,k[s>>2]=0,i[q>>0]=0,Y8(-27,n,212637,211567,2704),k[s>>2]=0,k[n>>2]=0,s=k[h>>2]|0,k[h>>2]=s+-1,(s|0)==1):0)ggb(k[h+-4>>2]|0);j=(u|0)==(c|0);do if(!j){if(!(k[a>>2]&16384)){h=(k[u>>2]&67108863)>>>0>(k[c>>2]&67108863)>>>0;b=h?c:u;h=h?u:c}else{b=u;h=c}f=k[b+4>>2]|0;if(f|0){while(1){g=k[f+20>>2]|0;if((g|0)==(h|0))break;f=k[f+8+(((b|0)==(g|0)&1)<<2)>>2]|0;if(!f){t=19;break}}if((t|0)==19)if(j){t=20;break}else break;if(!e){e=0;r=v;return e|0}k[e>>2]=f;e=0;r=v;return e|0}}else t=20;while(0);if((t|0)==20){f=l?-5:-27;g=n+4|0;b=ZT(48)|0;k[b>>2]=1;j=b+4|0;k[n>>2]=j;k[g>>2]=41;i[b+45>>0]=0;l=212700;m=j+41|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(f,n,212680,211567,2781);k[g>>2]=0;k[n>>2]=0;s=k[b>>2]|0;k[b>>2]=s+-1;if((s|0)==1)ggb(k[b+-4>>2]|0)}s=a+64|0;p=k[s>>2]|0;q=p+56|0;b=k[q>>2]|0;if(!b){if(!p){a=n+4|0;f=ZT(8)|0;k[f>>2]=1;m=f+4|0;k[n>>2]=m;k[a>>2]=0;i[m>>0]=0;Y8(-27,n,212600,211567,2507);k[a>>2]=0;k[n>>2]=0;n=k[f>>2]|0;k[f>>2]=n+-1;if((n|0)==1)ggb(k[f+-4>>2]|0);b=k[q>>2]|0;if(!b)t=29}else t=29;if((t|0)==29){l=p+24|0;f=k[l>>2]|0;m=k[p+28>>2]|0;QY(p);a=p+36|0;b=k[a>>2]|0;k[q>>2]=b;g=b+m|0;j=k[p+32>>2]|0;n=j;if(g>>>0>j>>>0)g=b;else{h=b;while(1){k[h>>2]=f|-2147483648;k[h+4>>2]=g;f=f+1|0;h=g+m|0;if(h>>>0>j>>>0)break;else{t=g;g=h;h=t}}}k[g+(0-m)+4>>2]=0;t=(k[k[p+52>>2]>>2]|0)+12|0;k[t>>2]=f-(k[l>>2]|0)+(k[t>>2]|0);k[l>>2]=f;k[a>>2]=n}k[q>>2]=k[b+4>>2];k[b>>2]=k[b>>2]&67108863;t=p+60|0;k[t>>2]=(k[t>>2]|0)+1}else{k[q>>2]=k[b+4>>2];k[b>>2]=k[b>>2]&67108863;t=p+60|0;k[t>>2]=(k[t>>2]|0)+1}k[b+16>>2]=u;k[b+20>>2]=c;f=u+4|0;k[b+8>>2]=k[f>>2];g=c+4|0;k[b+12>>2]=k[g>>2];k[g>>2]=b;k[f>>2]=b;f=(k[(k[s>>2]|0)+28>>2]|0)+-24|0;g=(f|0)>0;if(!d){if(g)zpb(b+24|0,0,f|0)|0;o[b+4>>2]=1.0}else{if(g)upb(b+24|0,d+24|0,f|0)|0;k[b+4>>2]=k[d+4>>2]}if(!e){e=1;r=v;return e|0}k[e>>2]=b;e=1;r=v;return e|0}function $Y(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=r;r=r+16|0;e=f;if(!((a|0)!=0&(b|0)!=0)?(g=e+4|0,d=ZT(8)|0,k[d>>2]=1,h=d+4|0,k[e>>2]=h,k[g>>2]=0,i[h>>0]=0,Y8(-27,e,212793,211567,3442),k[g>>2]=0,k[e>>2]=0,g=k[d>>2]|0,k[d>>2]=g+-1,(g|0)==1):0)ggb(k[d+-4>>2]|0);if((c|0)>=0){k[a>>2]=b;h=a+4|0;k[h>>2]=0;h=a+8|0;k[h>>2]=c;r=f;return}h=e+4|0;d=ZT(8)|0;k[d>>2]=1;g=d+4|0;k[e>>2]=g;k[h>>2]=0;i[g>>0]=0;Y8(-211,e,212793,211567,3445);k[h>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);k[a>>2]=b;h=a+4|0;k[h>>2]=0;h=a+8|0;k[h>>2]=c;r=f;return}function aZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=r;r=r+16|0;d=f;if(!((a|0)!=0&(b|0)!=0)?(g=d+4|0,e=ZT(8)|0,k[e>>2]=1,h=e+4|0,k[d>>2]=h,k[g>>2]=0,i[h>>0]=0,Y8(-27,d,212816,211567,3391),k[g>>2]=0,k[d>>2]=0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)ggb(k[e+-4>>2]|0);k[a+16>>2]=(b|0)!=(c|0)?b:0;b=b+20|0;c=k[b>>2]|0;k[a+12>>2]=c;if(!c){k[b>>2]=a;r=f;return}k[c+8>>2]=a;k[b>>2]=a;r=f;return}function bZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;ua=r;r=r+1376|0;ta=ua+336|0;qa=ua+280|0;la=ua+224|0;ma=ua+88|0;oa=ua+32|0;z=ua+24|0;x=ua+8|0;y=ua;A=ua+16|0;ra=ta+8|0;k[ta>>2]=ra;sa=ta+4|0;k[sa>>2]=1032;do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[qa>>2]=k[g>>2];m=qa+4|0;a=g+4|0;k[m>>2]=k[a>>2];n=qa+8|0;k[n>>2]=k[g+8>>2];o=qa+12|0;k[o>>2]=k[g+12>>2];p=qa+16|0;k[p>>2]=k[g+16>>2];q=qa+20|0;k[q>>2]=k[g+20>>2];s=qa+24|0;k[s>>2]=k[g+24>>2];t=qa+28|0;k[t>>2]=k[g+28>>2];u=qa+32|0;k[u>>2]=k[g+32>>2];v=qa+36|0;e=k[g+36>>2]|0;k[v>>2]=e;f=qa+40|0;k[f>>2]=n;pa=qa+48|0;j=qa+44|0;k[j>>2]=pa;k[qa+52>>2]=0;k[pa>>2]=0;if(e|0){pa=e+12|0;k[pa>>2]=(k[pa>>2]|0)+1}if((k[a>>2]|0)<3){l=k[g+44>>2]|0;pa=k[j>>2]|0;k[pa>>2]=k[l>>2];k[pa+4>>2]=k[l+4>>2];pa=p;l=p;j=q;h=s;e=t;f=u;na=v;g=v;a=qa;break}k[m>>2]=0;x1(qa,k[a>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[l+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0));pa=p;l=p;j=q;h=s;e=t;f=u;na=v;g=v;a=qa}else{pa=p;l=p;j=q;h=s;e=t;f=u;na=v;g=v;a=qa}}else{Q1(qa,a,-1);l=qa+16|0;g=qa+36|0;m=qa+4|0;n=qa+8|0;o=qa+12|0;pa=l;j=qa+20|0;h=qa+24|0;e=qa+28|0;f=qa+32|0;na=g;a=qa}while(0);k[la>>2]=k[a>>2];ja=la+4|0;a=k[m>>2]|0;k[ja>>2]=a;ca=la+8|0;k[ca>>2]=k[n>>2];ba=la+12|0;k[ba>>2]=k[o>>2];ia=la+16|0;k[ia>>2]=k[l>>2];k[la+20>>2]=k[j>>2];k[la+24>>2]=k[h>>2];k[la+28>>2]=k[e>>2];da=la+32|0;k[da>>2]=k[f>>2];fa=la+36|0;e=k[g>>2]|0;k[fa>>2]=e;ea=la+40|0;k[ea>>2]=ca;ha=la+48|0;ga=la+44|0;k[ga>>2]=ha;k[la+52>>2]=0;k[ha>>2]=0;if(e){a=e+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[m>>2]|0}if((a|0)>=3){k[ja>>2]=0;x1(la,k[qa+4>>2]|0,0,0,0);if((k[ja>>2]|0)>0){e=k[qa+40>>2]|0;f=k[ea>>2]|0;g=k[qa+44>>2]|0;h=k[ga>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[e+(a<<2)>>2];k[h+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[ja>>2]|0))}}else{_=k[qa+44>>2]|0;$=k[ga>>2]|0;k[$>>2]=k[_>>2];k[$+4>>2]=k[_+4>>2]}a=k[la>>2]|0;if(a&4088)if(!(c&1))$=0;else $=(c&32|0)!=0;else $=1;j=a&4095;p=a&7;q=1212424721>>>(a<<2&28)&15;_=q<<1;switch(a&4095){case 5:case 6:case 13:case 14:break;default:{k[oa>>2]=0;a=oa+4|0;k[a>>2]=0;e=ZT(84)|0;k[e>>2]=1;f=e+4|0;k[oa>>2]=f;k[a>>2]=76;i[e+80>>0]=0;g=212837;h=f+76|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,oa,212914,212918,2504);k[a>>2]=0;k[oa>>2]=0;Z=k[e>>2]|0;k[e>>2]=Z+-1;if((Z|0)==1)ggb(k[e+-4>>2]|0);a=k[la>>2]|0}}Y=c&1;Z=(Y|0)!=0;a=a>>>3&511;if(Z)if((c&32|0)==0|(a|0)!=1)X=29;else{V=k[ea>>2]|0;W=k[V>>2]|0;k[x>>2]=k[V+4>>2];k[x+4>>2]=W;x2(b,x,p,0)}else if((c&16|0)==0|(a|0)!=0)X=29;else{V=k[ea>>2]|0;W=k[V>>2]|0;k[z>>2]=k[V+4>>2];k[z+4>>2]=W;x2(b,z,p|8,0)}if((X|0)==29){V=k[ea>>2]|0;W=k[V>>2]|0;k[y>>2]=k[V+4>>2];k[y+4>>2]=W;x2(b,y,j,0)}do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[oa>>2]=k[g>>2];n=oa+4|0;a=g+4|0;k[n>>2]=k[a>>2];W=oa+8|0;k[W>>2]=k[g+8>>2];k[oa+12>>2]=k[g+12>>2];k[oa+16>>2]=k[g+16>>2];k[oa+20>>2]=k[g+20>>2];k[oa+24>>2]=k[g+24>>2];k[oa+28>>2]=k[g+28>>2];k[oa+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[oa+36>>2]=e;f=oa+40|0;k[f>>2]=W;W=oa+48|0;j=oa+44|0;k[j>>2]=W;k[oa+52>>2]=0;k[W>>2]=0;if(e|0){W=e+12|0;k[W>>2]=(k[W>>2]|0)+1}if((k[a>>2]|0)<3){V=k[g+44>>2]|0;W=k[j>>2]|0;k[W>>2]=k[V>>2];k[W+4>>2]=k[V+4>>2];break}k[n>>2]=0;x1(oa,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[l+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(oa,b,-1);while(0);T=$?q:_;if((d|0)>0&(k[ba>>2]|0)==1?(k[A>>2]=0,W=A+4|0,k[W>>2]=0,B=ZT(196)|0,k[B>>2]=1,V=B+4|0,k[A>>2]=V,k[W>>2]=190,i[B+194>>0]=0,upb(V|0,212980,190)|0,Y8(-213,A,212914,212918,2574),k[W>>2]=0,k[A>>2]=0,W=k[B>>2]|0,k[B>>2]=W+-1,(W|0)==1):0)ggb(k[B+-4>>2]|0);S=(c&4|0)!=0;do if((k[ca>>2]|0)>1&(S^1)){a=k[ba>>2]|0;if((a|0)==1){if(k[la>>2]&16384|0?k[oa>>2]&16384|0:0){a=0;break}}else if(!(Z&$&(a|0)>1)){a=0;break}a=1}else a=0;while(0);O=oa+12|0;P=oa+8|0;Q=_+4|0;V=oa+16|0;R=Z&$;H=(p|0)==6?3:0;J=41068+(H<<2)|0;K=T>>>2;N=T&255;L=q>>>1;M=_&255;W=oa+48|0;I=q<<2;G=(c&2|0)==0;H=41068+(H+($?Y+1|0:0)<<2)|0;U=oa+44|0;F=Z^1;l=d;e=0;a:while(1){while(1){p=(a|0)==0;if(p){E=Z?k[O>>2]|0:k[ba>>2]|0;y=k[ca>>2]|0;D=S|(E|0)!=1;E=D?E:Z?k[P>>2]|0:y;s=$&(E&1|0)!=0&1;n=0;y=D?y:1}else{E=k[P>>2]|0;s=0;n=aa(I,E)|0;y=Z?k[O>>2]|0:k[o>>2]|0}q=(E|0)==0;do if(!q){if((E|0)<6){k[ma>>2]=E;e=1;break}e=(E+-1^E)+1>>1;if((e|0)>1){k[ma>>2]=e;if((e|0)!=(E|0)?(ka=(E>>>0)/(e>>>0)|0,(ka|0)>1):0){f=3;h=ka;j=1;X=60}else e=1}else{f=3;h=E;j=0;X=60}b:do if((X|0)==60){c:while(1){X=0;while(1){g=(h|0)/(f|0)|0;if((aa(g,f)|0)==(h|0))break;e=f+2|0;if((aa(e,e)|0)>(h|0))break c;else f=e}e=j+1|0;k[ma+(j<<2)>>2]=f;if((g|0)>1){h=g;j=e;X=60}else break b}k[ma+(j<<2)>>2]=h;e=j+1|0}while(0);f=k[ma>>2]&1^1;g=(f+e|0)/2|0;if((f|0)<(g|0)){h=e+-1+f|0;do{d=ma+(f<<2)|0;C=k[d>>2]|0;D=ma+(h-f<<2)|0;k[d>>2]=k[D>>2];k[D>>2]=C;f=f+1|0}while((f|0)!=(g|0))}}while(0);D=k[ma>>2]|0;j=(D|0)==(k[ma+(e+-1<<2)>>2]|0);C=n+(aa(E,Q)|0)|0;D=k[ma+(((e|0)>1&(D&1|0)==0&1)<<2)>>2]|0;f=aa(D+1|0,_)|0;f=C+((D|0)>5&(D&1|0)!=0?f:0)|0;do if(p)if((k[ia>>2]|0)==(k[V>>2]|0))if((s|0)!=0|j^1){X=73;break}else{n=0;break}else if(!s){n=0;break}else{X=73;break}else if((a|0)!=1|j)n=0;else X=73;while(0);if((X|0)==73){X=0;n=1;f=f+(aa(E,_)|0)|0}g=k[ta>>2]|0;h=f+32|0;if((k[sa>>2]|0)>>>0<h>>>0){if((g|0)!=(ra|0)){if(g|0)ggb(g);k[ta>>2]=ra;k[sa>>2]=1032}if(h>>>0>1032){while(1){f=fgb(h)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[ta>>2]=f;k[sa>>2]=h}else f=ra}else{k[sa>>2]=h;f=g}v=aa(E,_)|0;D=f+v|0;C=E<<2;b=D+C+15&-16;t=b;if(R&(j^1)|q^1)cZ(E,e,ma,D,_,f,R&p&1);if(p)break;g=k[ia>>2]|0;u=k[V>>2]|0;d=t+v|0;B=d+v|0;c=(n|0)==0;z=c?B:B+v|0;A=c?t:d;B=c?d:B;c=k[J>>2]|0;h=R&(k[ba>>2]|0)>1;if(h|G){w=1.0;a=h?0:a}else w=1.0/+(aa(y,E)|0);if($){q=(y&1|0)==0;s=(y+1|0)/2|0;d:do if(Z){h=b;p=(k[ha>>2]|0)>>>2;if(k[la>>2]&4088|0){e:do switch(M&31){case 4:{if((E|0)>0){j=g;n=0}else break e;while(1){k[h>>2]=k[j>>2];n=n+1|0;if((n|0)==(E|0))break;else{j=j+(p<<2)|0;h=h+(L<<2)|0}}break}case 8:{if((E|0)>0){j=g;n=0}else break e;while(1){X=k[j+4>>2]|0;k[h>>2]=k[j>>2];k[h+4>>2]=X;n=n+1|0;if((n|0)==(E|0))break;else{j=j+(p<<2)|0;h=h+(L<<2)|0}}break}case 16:{if((E|0)>0){j=g;n=0}else break e;while(1){X=k[j+4>>2]|0;k[h>>2]=k[j>>2];k[h+4>>2]=X;X=k[j+12>>2]|0;k[h+8>>2]=k[j+8>>2];k[h+12>>2]=X;n=n+1|0;if((n|0)==(E|0))break;else{j=j+(p<<2)|0;h=h+(L<<2)|0}}break}default:{}}while(0);f:do if(q){h=g+(aa(s,_)|0)|0;p=(k[ha>>2]|0)>>>2;switch(M&31){case 4:{if((E|0)>0){j=0;n=d}else break f;while(1){k[n>>2]=k[h>>2];j=j+1|0;if((j|0)==(E|0))break;else{h=h+(p<<2)|0;n=n+(L<<2)|0}}break}case 8:{if((E|0)>0){j=0;n=d}else break f;while(1){X=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=X;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(p<<2)|0;n=n+(L<<2)|0}}break}case 16:{if((E|0)>0){j=0;n=d}else break f;while(1){X=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=X;X=k[h+12>>2]|0;k[n+8>>2]=k[h+8>>2];k[n+12>>2]=X;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(p<<2)|0;n=n+(L<<2)|0}}break}default:break f}}while(0);g=g+_|0;X=162;break}g:do switch(N&31){case 4:{if((E|0)>0){j=g;n=0}else break g;while(1){k[h>>2]=k[j>>2];n=n+1|0;if((n|0)==(E|0))break;else{j=j+(p<<2)|0;h=h+(K<<2)|0}}break}case 8:{if((E|0)>0){j=g;n=0}else break g;while(1){X=k[j+4>>2]|0;k[h>>2]=k[j>>2];k[h+4>>2]=X;n=n+1|0;if((n|0)==(E|0))break;else{j=j+(p<<2)|0;h=h+(K<<2)|0}}break}case 16:{if((E|0)>0){j=g;n=0}else break g;while(1){X=k[j+4>>2]|0;k[h>>2]=k[j>>2];k[h+4>>2]=X;X=k[j+12>>2]|0;k[h+8>>2]=k[j+8>>2];k[h+12>>2]=X;n=n+1|0;if((n|0)==(E|0))break;else{j=j+(p<<2)|0;h=h+(K<<2)|0}}break}default:{}}while(0);eZ(t,E,T);if(q){h=g+(aa(y+-1|0,T)|0)|0;p=(k[ha>>2]|0)>>>2;h:do switch(N&31){case 4:{if((E|0)>0){j=0;n=d}else break h;while(1){k[n>>2]=k[h>>2];j=j+1|0;if((j|0)==(E|0))break;else{h=h+(p<<2)|0;n=n+(K<<2)|0}}break}case 8:{if((E|0)>0){j=0;n=d}else break h;while(1){X=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=X;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(p<<2)|0;n=n+(K<<2)|0}}break}case 16:{if((E|0)>0){j=0;n=d}else break h;while(1){X=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=X;X=k[h+12>>2]|0;k[n+8>>2]=k[h+8>>2];k[n+12>>2]=X;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(p<<2)|0;n=n+(K<<2)|0}}break}default:{}}while(0);eZ(d,E,T)}g=g+T|0;X=162}else{zpb(t|0,0,v|0)|0;h=b;p=(k[ha>>2]|0)>>>2;i:do switch(N&31){case 4:{if((E|0)>0){j=g;n=0}else break i;while(1){k[h>>2]=k[j>>2];n=n+1|0;if((n|0)==(E|0))break;else{j=j+(p<<2)|0;h=h+(L<<2)|0}}break}case 8:{if((E|0)>0){j=g;n=0}else break i;while(1){x=k[j+4>>2]|0;k[h>>2]=k[j>>2];k[h+4>>2]=x;n=n+1|0;if((n|0)==(E|0))break;else{j=j+(p<<2)|0;h=h+(L<<2)|0}}break}case 16:{if((E|0)>0){j=g;n=0}else break i;while(1){x=k[j+4>>2]|0;k[h>>2]=k[j>>2];k[h+4>>2]=x;x=k[j+12>>2]|0;k[h+8>>2]=k[j+8>>2];k[h+12>>2]=x;n=n+1|0;if((n|0)==(E|0))break;else{j=j+(p<<2)|0;h=h+(L<<2)|0}}break}default:{}}while(0);g=g+(aa(((k[oa>>2]|0)>>>3&511)+1|0,T)|0)|0;if(!q)break;zpb(d|0,0,v|0)|0;h=g+(aa(y+-2|0,T)|0)|0;p=(k[ha>>2]|0)>>>2;switch(N&31){case 4:{if((E|0)>0){j=0;n=d}else{X=163;break d}while(1){k[n>>2]=k[h>>2];j=j+1|0;if((j|0)==(E|0)){X=162;break}else{h=h+(p<<2)|0;n=n+(L<<2)|0}}break}case 8:{if((E|0)>0){j=0;n=d}else{X=163;break d}while(1){X=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=X;j=j+1|0;if((j|0)==(E|0)){X=162;break}else{h=h+(p<<2)|0;n=n+(L<<2)|0}}break}case 16:{if((E|0)>0){j=0;n=d}else{X=163;break d}while(1){X=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=X;X=k[h+12>>2]|0;k[n+8>>2]=k[h+8>>2];k[n+12>>2]=X;j=j+1|0;if((j|0)==(E|0)){X=162;break}else{h=h+(p<<2)|0;n=n+(L<<2)|0}}break}default:{X=163;break d}}}while(0);if((X|0)==162){X=0;if(q)X=163}if((X|0)==163){X=0;Xg[c&7](d,B,E,e,ma,D,f,E,0,z,Y,w)}Xg[c&7](t,A,E,e,ma,D,f,E,0,z,Y,w);j:do if(!(k[oa>>2]&4088))if(Z){p=(k[W>>2]|0)>>>2;k:do switch(N&31){case 4:{if((E|0)>0){h=A;j=0;n=u}else break k;while(1){k[n>>2]=k[h>>2];j=j+1|0;if((j|0)==(E|0))break;else{h=h+(L<<2)|0;n=n+(p<<2)|0}}break}case 8:{if((E|0)>0){h=A;j=0;n=u}else break k;while(1){x=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=x;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(L<<2)|0;n=n+(p<<2)|0}}break}case 16:{if((E|0)>0){h=A;j=0;n=u}else break k;while(1){x=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=x;x=k[h+12>>2]|0;k[n+8>>2]=k[h+8>>2];k[n+12>>2]=x;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(L<<2)|0;n=n+(p<<2)|0}}break}default:{}}while(0);if(!q){h=T;break}h=u+(aa(y+-1|0,T)|0)|0;p=(k[W>>2]|0)>>>2;switch(N&31){case 4:{if((E|0)>0){j=B;n=0}else{h=4;break j}while(1){k[h>>2]=k[j>>2];n=n+1|0;if((n|0)==(E|0)){h=T;break}else{j=j+(L<<2)|0;h=h+(p<<2)|0}}break}case 8:{if((E|0)>0){j=B;n=0}else{h=8;break j}while(1){y=k[j+4>>2]|0;k[h>>2]=k[j>>2];k[h+4>>2]=y;n=n+1|0;if((n|0)==(E|0)){h=T;break}else{j=j+(L<<2)|0;h=h+(p<<2)|0}}break}case 16:{if((E|0)>0){j=B;n=0}else{h=16;break j}while(1){y=k[j+4>>2]|0;k[h>>2]=k[j>>2];k[h+4>>2]=y;y=k[j+12>>2]|0;k[h+8>>2]=k[j+8>>2];k[h+12>>2]=y;n=n+1|0;if((n|0)==(E|0)){h=T;break}else{j=j+(L<<2)|0;h=h+(p<<2)|0}}break}default:{h=T;break j}}}else{h=A+T|0;upb(h|0,A|0,T|0)|0;p=(k[W>>2]|0)>>>2;l:do switch(N&31){case 4:{if((E|0)>0){j=0;n=u}else break l;while(1){k[n>>2]=k[h>>2];j=j+1|0;if((j|0)==(E|0))break;else{h=h+(K<<2)|0;n=n+(p<<2)|0}}break}case 8:{if((E|0)>0){j=0;n=u}else break l;while(1){x=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=x;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(K<<2)|0;n=n+(p<<2)|0}}break}case 16:{if((E|0)>0){j=0;n=u}else break l;while(1){x=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=x;x=k[h+12>>2]|0;k[n+8>>2]=k[h+8>>2];k[n+12>>2]=x;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(K<<2)|0;n=n+(p<<2)|0}}break}default:{}}while(0);if(!q){h=T;break}j=B+T|0;upb(j|0,B|0,T|0)|0;h=u+(aa(y+-1|0,T)|0)|0;p=(k[W>>2]|0)>>>2;switch(N&31){case 4:{if((E|0)>0)n=0;else{h=4;break j}while(1){k[h>>2]=k[j>>2];n=n+1|0;if((n|0)==(E|0)){h=T;break}else{j=j+(K<<2)|0;h=h+(p<<2)|0}}break}case 8:{if((E|0)>0)n=0;else{h=8;break j}while(1){y=k[j+4>>2]|0;k[h>>2]=k[j>>2];k[h+4>>2]=y;n=n+1|0;if((n|0)==(E|0)){h=T;break}else{j=j+(K<<2)|0;h=h+(p<<2)|0}}break}case 16:{if((E|0)>0)n=0;else{h=16;break j}while(1){y=k[j+4>>2]|0;k[h>>2]=k[j>>2];k[h+4>>2]=y;y=k[j+12>>2]|0;k[h+8>>2]=k[j+8>>2];k[h+12>>2]=y;n=n+1|0;if((n|0)==(E|0)){h=T;break}else{j=j+(K<<2)|0;h=h+(p<<2)|0}}break}default:{h=T;break j}}}else{p=(k[W>>2]|0)>>>2;m:do switch(M&31){case 4:{if((E|0)>0){h=A;j=0;n=u}else break m;while(1){k[n>>2]=k[h>>2];j=j+1|0;if((j|0)==(E|0))break;else{h=h+(L<<2)|0;n=n+(p<<2)|0}}break}case 8:{if((E|0)>0){h=A;j=0;n=u}else break m;while(1){y=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=y;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(L<<2)|0;n=n+(p<<2)|0}}break}case 16:{if((E|0)>0){h=A;j=0;n=u}else break m;while(1){y=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=y;y=k[h+12>>2]|0;k[n+8>>2]=k[h+8>>2];k[n+12>>2]=y;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(L<<2)|0;n=n+(p<<2)|0}}break}default:{}}while(0);if(!q){h=_;break}h=u+(aa(s,_)|0)|0;p=(k[W>>2]|0)>>>2;switch(M&31){case 4:{if((E|0)>0){j=B;n=0}else{h=4;break j}while(1){k[h>>2]=k[j>>2];n=n+1|0;if((n|0)==(E|0)){h=_;break}else{j=j+(L<<2)|0;h=h+(p<<2)|0}}break}case 8:{if((E|0)>0){j=B;n=0}else{h=8;break j}while(1){y=k[j+4>>2]|0;k[h>>2]=k[j>>2];k[h+4>>2]=y;n=n+1|0;if((n|0)==(E|0)){h=_;break}else{j=j+(L<<2)|0;h=h+(p<<2)|0}}break}case 16:{if((E|0)>0){j=B;n=0}else{h=16;break j}while(1){y=k[j+4>>2]|0;k[h>>2]=k[j>>2];k[h+4>>2]=y;y=k[j+12>>2]|0;k[h+8>>2]=k[j+8>>2];k[h+12>>2]=y;n=n+1|0;if((n|0)==(E|0)){h=_;break}else{j=j+(L<<2)|0;h=h+(p<<2)|0}}break}default:{h=_;break j}}}while(0);y=s;j=1;h=u+h|0}else{j=0;h=u}if((j|0)<(y|0)){v=b;b=(E|0)>0;x=E<<1;u=h;s=j;while(1){q=(s+1|0)<(y|0);p=(k[ha>>2]|0)>>>2;n:do if(q){o:do switch(M&31){case 4:{if(b){h=g;j=0}else break o;while(1){n=k[h+4>>2]|0;k[v+(j<<2)>>2]=k[h>>2];k[d+(j<<2)>>2]=n;j=j+1|0;if((j|0)==(E|0))break;else h=h+(p<<2)|0}break}case 8:{if(b){h=g;j=0}else break o;while(1){va=k[h+4>>2]|0;k[v+(j<<2)>>2]=k[h>>2];n=j|1;k[v+(n<<2)>>2]=va;va=k[h+12>>2]|0;k[d+(j<<2)>>2]=k[h+8>>2];k[d+(n<<2)>>2]=va;j=j+2|0;if((j|0)>=(x|0))break;else h=h+(p<<2)|0}break}case 16:{if(b){h=0;j=g}else break o;while(1){xa=k[j+4>>2]|0;k[v+(h<<2)>>2]=k[j>>2];n=h|1;k[v+(n<<2)>>2]=xa;xa=k[j+12>>2]|0;wa=h|2;k[v+(wa<<2)>>2]=k[j+8>>2];va=h|3;k[v+(va<<2)>>2]=xa;xa=k[j+20>>2]|0;k[d+(h<<2)>>2]=k[j+16>>2];k[d+(n<<2)>>2]=xa;n=k[j+28>>2]|0;k[d+(wa<<2)>>2]=k[j+24>>2];k[d+(va<<2)>>2]=n;h=h+4|0;if((h|0)>=(C|0))break;else j=j+(p<<2)|0}break}default:{}}while(0);Xg[c&7](d,B,E,e,ma,D,f,E,0,z,Y,w)}else switch(M&31){case 4:{if(b){h=g;j=0;n=v}else break n;while(1){k[n>>2]=k[h>>2];j=j+1|0;if((j|0)==(E|0))break;else{h=h+(p<<2)|0;n=n+(L<<2)|0}}break}case 8:{if(b){h=g;j=0;n=v}else break n;while(1){xa=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=xa;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(p<<2)|0;n=n+(L<<2)|0}}break}case 16:{if(b){h=g;j=0;n=v}else break n;while(1){xa=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=xa;xa=k[h+12>>2]|0;k[n+8>>2]=k[h+8>>2];k[n+12>>2]=xa;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(p<<2)|0;n=n+(L<<2)|0}}break}default:break n}while(0);Xg[c&7](t,A,E,e,ma,D,f,E,0,z,Y,w);p=(k[W>>2]|0)>>>2;p:do if(q)switch(M&31){case 4:{if(b){h=0;j=u}else break p;while(1){xa=k[B+(h<<2)>>2]|0;k[j>>2]=k[A+(h<<2)>>2];k[j+4>>2]=xa;h=h+1|0;if((h|0)==(E|0))break;else j=j+(p<<2)|0}break}case 8:{if(b){h=0;j=u}else break p;while(1){xa=h|1;wa=k[A+(xa<<2)>>2]|0;k[j>>2]=k[A+(h<<2)>>2];k[j+4>>2]=wa;xa=k[B+(xa<<2)>>2]|0;k[j+8>>2]=k[B+(h<<2)>>2];k[j+12>>2]=xa;h=h+2|0;if((h|0)>=(x|0))break;else j=j+(p<<2)|0}break}case 16:{if(b){h=u;j=0}else break p;while(1){va=j|1;wa=k[A+(va<<2)>>2]|0;k[h>>2]=k[A+(j<<2)>>2];k[h+4>>2]=wa;wa=j|2;xa=j|3;q=k[A+(xa<<2)>>2]|0;k[h+8>>2]=k[A+(wa<<2)>>2];k[h+12>>2]=q;va=k[B+(va<<2)>>2]|0;k[h+16>>2]=k[B+(j<<2)>>2];k[h+20>>2]=va;xa=k[B+(xa<<2)>>2]|0;k[h+24>>2]=k[B+(wa<<2)>>2];k[h+28>>2]=xa;j=j+4|0;if((j|0)>=(C|0))break;else h=h+(p<<2)|0}break}default:break p}else switch(M&31){case 4:{if(b){h=A;j=0;n=u}else break p;while(1){k[n>>2]=k[h>>2];j=j+1|0;if((j|0)==(E|0))break;else{h=h+(L<<2)|0;n=n+(p<<2)|0}}break}case 8:{if(b){h=A;j=0;n=u}else break p;while(1){xa=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=xa;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(L<<2)|0;n=n+(p<<2)|0}}break}case 16:{if(b){h=A;j=0;n=u}else break p;while(1){xa=k[h+4>>2]|0;k[n>>2]=k[h>>2];k[n+4>>2]=xa;xa=k[h+12>>2]|0;k[n+8>>2]=k[h+8>>2];k[n+12>>2]=xa;j=j+1|0;if((j|0)==(E|0))break;else{h=h+(L<<2)|0;n=n+(p<<2)|0}}break}default:break p}while(0);s=s+2|0;if((s|0)>=(y|0))break;else{u=u+I|0;g=g+I|0}}}if(a|0){X=247;break a}KG(la,oa)|0;a=0}g=aa(E,T)|0;h=((k[oa>>2]^k[la>>2])&4088|0)!=0;u=(h?512:0)|Y;if(n){a=t+v|0;if(!s){j=0;s=t;t=a}else{j=(E|0)>1&F?(h?0:T):0;s=t;t=a}}else{j=0;s=0}if(Z|h^1)q=g;else q=(E&1|0?T:_)+g|0;n=k[H>>2]|0;a=R|(S|(y|0)<2);if(G|a^1){w=1.0;p=a&1^1}else{w=1.0/+(aa(S?1:y,E)|0);p=0}l=(l|0)<1|(l|0)>(y|0)?y:l;q:do if((l|0)>0){if(!s){a=0;while(1){wa=(k[ia>>2]|0)+(aa(k[k[ga>>2]>>2]|0,a)|0)|0;xa=(k[V>>2]|0)+(aa(k[k[U>>2]>>2]|0,a)|0)|0;Xg[n&7](wa,xa,E,e,ma,D,f,E,0,t,u,w);a=a+1|0;if((a|0)>=(l|0))break q}}h=s+j|0;a=0;do{xa=(k[ia>>2]|0)+(aa(k[k[ga>>2]>>2]|0,a)|0)|0;g=(k[V>>2]|0)+(aa(k[k[U>>2]>>2]|0,a)|0)|0;Xg[n&7](xa,s,E,e,ma,D,f,E,0,t,u,w);if((s|0)!=(g|0))upb(g|0,h|0,q|0)|0;a=a+1|0}while((a|0)<(l|0))}else a=0;while(0);if((a|0)<(y|0))do{zpb((k[V>>2]|0)+(aa(k[k[U>>2]>>2]|0,a)|0)|0,0,q|0)|0;a=a+1|0}while((a|0)!=(y|0));if((p|0)!=1){X=105;break}KG(la,oa)|0;a=1}if((X|0)==105){if($&F?(k[oa>>2]&4088|0)==8:0)dZ(oa,l,1)}else if(((X|0)==247?$&F:0)?((E|0)>1?(k[oa>>2]&4088|0)==8:0):0)dZ(oa,E,2);f=oa+36|0;a=k[f>>2]|0;if(a|0?(wa=a+12|0,xa=k[wa>>2]|0,k[wa>>2]=xa+-1,(xa|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[oa+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;f=oa+4|0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[f>>2]|0)>0){e=k[oa+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[U>>2]|0;if(!((a|0)==(W|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[fa>>2]|0;if(a|0?(wa=a+12|0,xa=k[wa>>2]|0,k[wa>>2]=xa+-1,(xa|0)==1):0){e=k[fa>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[da>>2]|0;if(!a){a=B1()|0;e=k[fa>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[fa>>2]=0}k[fa>>2]=0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[ja>>2]|0)>0){e=k[ea>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ja>>2]|0))}a=k[ga>>2]|0;if(!((a|0)==(ha|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[na>>2]|0;if(a|0?(wa=a+12|0,xa=k[wa>>2]|0,k[wa>>2]=xa+-1,(xa|0)==1):0){f=qa+36|0;e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;do if(!a){a=k[qa+32>>2]|0;if(a|0)break;a=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[na>>2]=0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[m>>2]|0)>0){e=k[qa+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[qa+44>>2]|0;if(!((a|0)==(qa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[ta>>2]|0;if((a|0)==(ra|0)){r=ua;return}if(a|0)ggb(a);k[ta>>2]=ra;k[sa>>2]=1032;r=ua;return}function cZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0.0,m=0.0,n=0.0,q=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;D=r;r=r+272|0;C=D+136|0;A=D;z=k[c>>2]|0;do if((a|0)<6){k[d>>2]=0;i=a+-1|0;k[d+(i<<2)>>2]=i;if((a|0)==4){k[d+4>>2]=2;k[d+8>>2]=1;h=2;break}if((i|0)>1){h=1;do{k[d+(h<<2)>>2]=h;h=h+1|0}while((h|0)!=(i|0))}if((a|0)!=5){r=D;return}if((e|0)==16){p[f>>3]=1.0;p[f+8>>3]=0.0;r=D;return}else{k[f>>2]=1065353216;k[f+4>>2]=0;r=D;return}}else{k[A+(b<<2)>>2]=1;k[C+(b<<2)>>2]=0;if((b|0)>0){zpb(C|0,0,b<<2|0)|0;h=0;do{x=b-h|0;B=x+-1|0;x=aa(k[c+(B<<2)>>2]|0,k[A+(x<<2)>>2]|0)|0;k[A+(B<<2)>>2]=x;h=h+1|0}while((h|0)!=(b|0))}if(!g)B=d;else B=(z|0)==(k[c+(b+-1<<2)>>2]|0)?d:f;a:do if(!(z&1)){w=k[A+4>>2]|0;g=aa(w,z)|0;h=0;while(1)if(1<<h>>>0<z>>>0)h=h+1|0;else break;x=g>>1;v=g>>2;do if((z|0)>=3)if((z|0)<257){s=10-h|0;u=z+-4|0;if((z|0)<4)break;else g=0;do{F=aa((l[416179+(g>>2)>>0]|0)>>>s,w)|0;k[B+(g<<2)>>2]=F;E=F+x|0;k[B+((g|1)<<2)>>2]=E;k[B+((g|2)<<2)>>2]=F+v;k[B+((g|3)<<2)>>2]=E+v;g=g+4|0}while((g|0)<=(u|0))}else{s=34-h|0;g=0;do{E=aa(((l[416179+(g>>>10&255)>>0]|0)<<16|(l[416179+(g>>>2&255)>>0]|0)<<24|(l[416179+(g>>>18&255)>>0]|0)<<8|(l[416179+(g>>26)>>0]|0))>>>s,w)|0;k[B+(g<<2)>>2]=E;F=E+x|0;k[B+((g|1)<<2)>>2]=F;k[B+((g|2)<<2)>>2]=E+v;k[B+((g|3)<<2)>>2]=F+v;g=g+4|0}while((g|0)<(z|0))}else{k[B>>2]=0;k[B+4>>2]=x}while(0);x=C+4|0;s=(k[x>>2]|0)+1|0;k[x>>2]=s;if((b|0)>1?(y=k[A+8>>2]|0,(z|0)<(a|0)):0){w=c+4|0;if((z|0)>0){g=y;u=z;b:while(1){s=0;do{k[B+(s+u<<2)>>2]=(k[B+(s<<2)>>2]|0)+g;s=s+1|0}while((s|0)!=(z|0));u=u+z|0;if((u|0)>=(a|0))break a;g=y+g|0;F=(k[x>>2]|0)+1|0;k[x>>2]=F;if((F|0)<(k[w>>2]|0))continue;else{v=1;s=x}while(1){k[s>>2]=0;g=(k[A+(v+2<<2)>>2]|0)+g-(k[A+(v<<2)>>2]|0)|0;v=v+1|0;s=C+(v<<2)|0;F=(k[s>>2]|0)+1|0;k[s>>2]=F;if((F|0)<(k[c+(v<<2)>>2]|0))continue b}}}g=z<<1;if((g|0)<(a|0)){v=k[w>>2]|0;while(1){F=s+1|0;k[x>>2]=F;if((F|0)>=(v|0)){s=1;u=x;do{k[u>>2]=0;s=s+1|0;u=C+(s<<2)|0;F=(k[u>>2]|0)+1|0;k[u>>2]=F}while((F|0)>=(k[c+(s<<2)>>2]|0))}g=g+z|0;if((g|0)>=(a|0))break a;s=k[x>>2]|0}}}}else{k[B>>2]=0;if((a|0)>1){v=k[A+4>>2]|0;h=0;u=1;do{h=v+h|0;F=(k[C>>2]|0)+1|0;k[C>>2]=F;if((F|0)>=(k[c>>2]|0)){s=0;g=C;do{k[g>>2]=0;h=(k[A+(s+2<<2)>>2]|0)+h-(k[A+(s<<2)>>2]|0)|0;s=s+1|0;g=C+(s<<2)|0;F=(k[g>>2]|0)+1|0;k[g>>2]=F}while((F|0)>=(k[c+(s<<2)>>2]|0))}k[B+(u<<2)>>2]=h;u=u+1|0}while((u|0)!=(a|0));h=0}else h=0}while(0);if((B|0)!=(d|0)?(k[d>>2]=0,i=a&1,(i|0)<(a|0)):0)do{E=i+1|0;F=k[B+(E<<2)>>2]|0;k[d+(k[B+(i<<2)>>2]<<2)>>2]=i;k[d+(F<<2)>>2]=E;i=i+2|0}while((i|0)<(a|0))}while(0);if(!(a+-1&a)){t=+p[10592+(h<<4)>>3];q=-+p[10592+(h<<4)+8>>3]}else{q=+T(+(-6.283185307179586/+(a|0)));t=+Q(+(1.0-q*q))}i=(a+1|0)/2|0;if((e|0)==16){p[f>>3]=1.0;p[f+8>>3]=0.0;if(!(a&1)){p[f+(i<<4)>>3]=-1.0;p[f+(i<<4)+8>>3]=0.0}if((a|0)>2){h=1;j=t;m=q}else{r=D;return}while(1){p[f+(h<<4)>>3]=j;p[f+(h<<4)+8>>3]=m;F=a-h|0;p[f+(F<<4)>>3]=j;p[f+(F<<4)+8>>3]=-m;n=t*m+q*j;h=h+1|0;if((h|0)>=(i|0))break;else{j=t*j-q*m;m=n}}r=D;return}else{o[f>>2]=1.0;o[f+4>>2]=0.0;if(!(a&1)){o[f+(i<<3)>>2]=-1.0;o[f+(i<<3)+4>>2]=0.0}if((a|0)>2){h=1;j=t;m=q}else{r=D;return}while(1){G=j;o[f+(h<<3)>>2]=G;n=m;o[f+(h<<3)+4>>2]=n;F=a-h|0;o[f+(F<<3)>>2]=G;o[f+(F<<3)+4>>2]=-n;n=t*m+q*j;h=h+1|0;if((h|0)>=(i|0))break;else{j=t*j-q*m;m=n}}r=D;return}}function dZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;j=k[a+12>>2]|0;i=k[a+16>>2]|0;if((1212424721>>>(k[a>>2]<<2&28)&15|0)==4){h=(k[a+48>>2]|0)>>>2;if((b|0)<=0)return;e=(c|0)==1;f=(j+1|0)/2|0;if((j|0)>2)c=0;else return;do{g=i+((aa(c,h)|0)<<2)|0;a=i+((aa(b-c|0,h)|0)<<2)|0;a=e|(c|0)==0|(c<<1|0)==(b|0)?g:a;d=1;do{m=d<<1;l=j-d<<1;k[g+(l<<2)>>2]=k[a+(m<<2)>>2];o[g+((l|1)<<2)>>2]=-+o[a+((m|1)<<2)>>2];d=d+1|0}while((d|0)<(f|0));c=c+1|0}while((c|0)!=(b|0));return}else{h=(k[a+48>>2]|0)>>>3;if((b|0)<=0)return;e=(c|0)==1;f=(j+1|0)/2|0;if((j|0)>2)c=0;else return;do{g=i+((aa(c,h)|0)<<3)|0;d=i+((aa(b-c|0,h)|0)<<3)|0;d=e|(c|0)==0|(c<<1|0)==(b|0)?g:d;a=1;do{l=a<<1;m=j-a<<1;p[g+(m<<3)>>3]=+p[d+(l<<3)>>3];p[g+((m|1)<<3)>>3]=-+p[d+((l|1)<<3)>>3];a=a+1|0}while((a|0)<(f|0));c=c+1|0}while((c|0)!=(b|0));return}}function eZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;if((c|0)==4){d=b+1|0;e=(d|0)/2|0;if((b|0)>2){c=1;do{g=c<<1;f=b-c<<1;k[a+(f<<2)>>2]=k[a+(g+-1<<2)>>2];o[a+((f|1)<<2)>>2]=-+o[a+(g<<2)>>2];c=c+1|0}while((c|0)<(e|0))}if(!(b&1)){g=b+-1|0;k[a+(b<<2)>>2]=k[a+(g<<2)>>2];o[a+(d<<2)>>2]=0.0;b=g}if((b|0)>1)do{g=b;b=b+-1|0;k[a+(g<<2)>>2]=k[a+(b<<2)>>2]}while((b|0)>1);o[a+4>>2]=0.0;return}else{e=b+1|0;d=(e|0)/2|0;if((b|0)>2){c=1;do{f=c<<1;g=b-c<<1;p[a+(g<<3)>>3]=+p[a+(f+-1<<3)>>3];p[a+((g|1)<<3)>>3]=-+p[a+(f<<3)>>3];c=c+1|0}while((c|0)<(d|0))}c=b+-1|0;if(!(b&1)){p[a+(b<<3)>>3]=+p[a+(c<<3)>>3];p[a+(e<<3)>>3]=0.0;b=c}if((b|0)>1)do{g=b;b=b+-1|0;p[a+(g<<3)>>3]=+p[a+(b<<3)>>3]}while((b|0)>1);p[a+8>>3]=0.0;return}}function fZ(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;pZ(a,b,c,d,e,f,g,h,j,k,l);return}function gZ(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;qZ(a,b,c,d,e,f,g,h,j,k,l);return}function hZ(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;oZ(a,b,c,d,e,f,g,h,j,k,l);return}function iZ(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;mZ(a,b,c,d,e,f,g,h,j,k,l);return}function jZ(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;nZ(a,b,c,d,e,f,g,h,j,k,l);return}function kZ(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;lZ(a,b,c,d,e,f,g,h,j,k,l);return}function lZ(a,b,c,d,e,f,g,h,i,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;l=+l;var m=0,n=0.0,o=0.0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0;u=(j&512|0)!=0;s=c+1>>1;if(u){r=a+8|0;t=+p[r>>3];p[r>>3]=+p[a>>3];a=r}else t=0.0;a:do switch(c|0){case 1:{p[b>>3]=+p[a>>3]*l;break}case 2:{n=+p[a>>3];o=+p[a+8>>3];p[b+8>>3]=(n-o)*l;p[b>>3]=(n+o)*l;break}default:{if(c&1|0){m=a+-8|0;p[b>>3]=+p[a>>3];p[b+8>>3]=0.0;if((s|0)>1){j=1;do{q=k[f+(j<<2)>>2]|0;r=k[f+(c-j<<2)>>2]|0;n=+p[m+(j<<4)>>3];o=+p[m+(j<<4)+8>>3];p[b+(q<<4)>>3]=n;p[b+(q<<4)+8>>3]=-o;p[b+(r<<4)>>3]=n;p[b+(r<<4)+8>>3]=o;j=j+1|0}while((j|0)!=(s|0))}mZ(b,b,c,d,e,f,g,h,i,256,1.0);p[b>>3]=+p[b>>3]*l;if((c|0)>1)j=1;else break a;while(1){i=j<<1;o=+p[b+(i+2<<3)>>3]*l;p[b+(j<<3)>>3]=+p[b+(i<<3)>>3]*l;p[b+(j+1<<3)>>3]=o;j=j+2|0;if((j|0)>=(c|0))break a}}r=(a|0)==(b|0);n=+p[a+8>>3];o=+p[a>>3];v=+p[a+(c+-1<<3)>>3];p[b>>3]=o+v;p[b+8>>3]=v-o;j=g+16|0;do if((s|0)>2)if(r){m=2;q=g;while(1){w=c-m|0;B=+p[b+(w+-1<<3)>>3];z=n+B;A=b+(m<<3)|0;C=+p[A>>3];x=b+(w<<3)|0;D=+p[x>>3];o=C-D;B=n-B;D=C+D;C=+p[j>>3];y=+p[q+24>>3];v=B*C+D*y;y=D*C-B*y;q=b+((m|1)<<3)|0;n=+p[q>>3];p[A>>3]=z-y;p[q>>3]=-o-v;p[x>>3]=z+y;p[b+(w+1<<3)>>3]=o-v;m=m+2|0;if((m|0)>=(s|0))break;else{q=j;j=j+16|0}}j=s+1&-2;break}else{m=2;q=g;while(1){A=c-m|0;y=+p[a+(A+-1<<3)>>3];z=n+y;v=+p[a+(m<<3)>>3];o=+p[a+(A<<3)>>3];C=v-o;y=n-y;o=v+o;v=+p[j>>3];B=+p[q+24>>3];D=y*v+o*B;B=o*v-y*B;n=+p[a+((m|1)<<3)>>3];A=m>>1;x=k[f+(A<<2)>>2]|0;p[b+(x<<3)>>3]=z-B;p[b+(x+1<<3)>>3]=-C-D;A=k[f+(s-A<<2)>>2]|0;p[b+(A<<3)>>3]=z+B;p[b+(A+1<<3)>>3]=C-D;m=m+2|0;if((m|0)>=(s|0))break;else{q=j;j=j+16|0}}j=s+1&-2;break}else j=2;while(0);do if((j|0)<=(s|0)){n=n*2.0;o=+p[a+(s<<3)>>3]*2.0;if(r){p[b+(s<<3)>>3]=n;p[b+(s+1<<3)>>3]=o;break}else{A=k[f+(s<<2)>>2]<<1;p[b+(A<<3)>>3]=n;p[b+((A|1)<<3)>>3]=o;break}}while(0);A=k[e>>2]>>1;k[e>>2]=A;A=(A|0)==1&1;mZ(b,b,s,d-A|0,e+(A<<2)|0,f,g,h,i,r?0:256,1.0);k[e>>2]=k[e>>2]<<1;if((c|0)>0){j=0;do{x=b+(j<<3)|0;A=b+((j|1)<<3)|0;D=-(+p[A>>3]*l);p[x>>3]=+p[x>>3]*l;p[A>>3]=D;j=j+2|0}while((j|0)<(c|0))}}}while(0);if(!u)return;p[a>>3]=t;return}function mZ(a,b,c,d,e,f,g,h,j,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;m=+m;var n=0.0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0;S=r;r=r+16|0;t=S;R=l&1;if((h|0)!=(c|0))if((c<<1|0)==(h|0))w=2;else w=(h|0)/(c|0)|0;else w=1;do if((b|0)==(a|0)){a:do if(!(l&256)){if((k[e>>2]|0)!=(k[e+(d+-1<<2)>>2]|0)){l=t+4|0;o=ZT(32)|0;k[o>>2]=1;q=o+4|0;k[t>>2]=q;k[l>>2]=27;i[o+31>>0]=0;a=213171;s=q+27|0;do{i[q>>0]=i[a>>0]|0;q=q+1|0;a=a+1|0}while((q|0)<(s|0));Y8(-215,t,213199,212918,614);k[l>>2]=0;k[t>>2]=0;P=k[o>>2]|0;k[o>>2]=P+-1;if((P|0)==1)ggb(k[o+-4>>2]|0)}if((d|0)!=1){if((c|0)>0)l=0;else break;while(1){o=k[f>>2]|0;if((o|0)>(l|0)){O=b+(l<<4)|0;E=+p[O>>3];F=+p[b+(l<<4)+8>>3];P=b+(o<<4)|0;k[O>>2]=k[P>>2];k[O+4>>2]=k[P+4>>2];k[O+8>>2]=k[P+8>>2];k[O+12>>2]=k[P+12>>2];p[P>>3]=E;p[b+(o<<4)+8>>3]=F}l=l+1|0;if((l|0)==(c|0))break a;else f=f+(w<<2)|0}}if((c&3|0)==0?(u=(c|0)/2|0,v=b+(u<<4)|0,(c|0)>1):0){a=w<<1;l=0;while(1){o=k[f>>2]|0;q=l|1;O=b+(q<<4)|0;E=+p[O>>3];F=+p[b+(q<<4)+8>>3];P=v+(o<<4)|0;k[O>>2]=k[P>>2];k[O+4>>2]=k[P+4>>2];k[O+8>>2]=k[P+8>>2];k[O+12>>2]=k[P+12>>2];p[P>>3]=E;p[P+8>>3]=F;if((o|0)>(l|0)){P=b+(l<<4)|0;F=+p[P>>3];E=+p[b+(l<<4)+8>>3];O=b+(o<<4)|0;k[P>>2]=k[O>>2];k[P+4>>2]=k[O+4>>2];k[P+8>>2]=k[O+8>>2];k[P+12>>2]=k[O+12>>2];p[O>>3]=F;p[b+(o<<4)+8>>3]=E;O=v+(q<<4)|0;E=+p[O>>3];F=+p[O+8>>3];P=v+(o+1<<4)|0;k[O>>2]=k[P>>2];k[O+4>>2]=k[P+4>>2];k[O+8>>2]=k[P+8>>2];k[O+12>>2]=k[P+12>>2];p[P>>3]=E;p[P+8>>3]=F}l=l+2|0;if((l|0)>=(u|0))break;else f=f+(a<<2)|0}}}while(0);if(R|0){l=c+-2|0;if((c|0)<2)f=0;else{f=0;do{O=b+(f<<4)+8|0;P=b+((f|1)<<4)+8|0;F=-+p[P>>3];p[O>>3]=-+p[O>>3];p[P>>3]=F;f=f+2|0}while((f|0)<=(l|0));f=c&-2}l=b+(c+-1<<4)+8|0;if((f|0)<(c|0))p[l>>3]=-+p[l>>3]}}else{q=c+-2|0;l=(c|0)<2;if(!R){if(l)f=0;else{o=w<<1;l=0;while(1){O=k[f+(w<<2)>>2]|0;P=b+(l<<4)|0;N=a+(k[f>>2]<<4)|0;k[P>>2]=k[N>>2];k[P+4>>2]=k[N+4>>2];k[P+8>>2]=k[N+8>>2];k[P+12>>2]=k[N+12>>2];P=b+((l|1)<<4)|0;O=a+(O<<4)|0;k[P>>2]=k[O>>2];k[P+4>>2]=k[O+4>>2];k[P+8>>2]=k[O+8>>2];k[P+12>>2]=k[O+12>>2];l=l+2|0;if((l|0)>(q|0))break;else f=f+(o<<2)|0}f=c&-2}l=c+-1|0;if((f|0)>=(c|0))break;O=a+(l<<4)|0;P=b+(l<<4)|0;k[P>>2]=k[O>>2];k[P+4>>2]=k[O+4>>2];k[P+8>>2]=k[O+8>>2];k[P+12>>2]=k[O+12>>2];break}else{if(l)f=0;else{o=w<<1;l=0;while(1){P=k[f>>2]|0;O=k[f+(w<<2)>>2]|0;F=-+p[a+(P<<4)+8>>3];p[b+(l<<4)>>3]=+p[a+(P<<4)>>3];p[b+(l<<4)+8>>3]=F;F=-+p[a+(O<<4)+8>>3];P=l|1;p[b+(P<<4)>>3]=+p[a+(O<<4)>>3];p[b+(P<<4)+8>>3]=F;l=l+2|0;if((l|0)>(q|0))break;else f=f+(o<<2)|0}f=c&-2}if((f|0)>=(c|0))break;P=c+-1|0;F=-+p[a+(P<<4)+8>>3];p[b+(f<<4)>>3]=+p[a+(P<<4)>>3];p[b+(f<<4)+8>>3]=F;break}}while(0);y=k[e>>2]|0;z=y&1;if(!z){if((y|0)>3){w=(c|0)>0;v=1;l=h;f=4;while(1){l=(l|0)/4|0;if(w){s=v<<1;t=(v|0)>1;a=0;do{u=b+(a<<4)|0;K=u+(s<<4)|0;F=+p[K>>3];L=K+8|0;V=+p[L>>3];O=K+(v<<4)|0;W=+p[O>>3];P=O+8|0;D=+p[P>>3];T=F+W;B=V+D;D=V-D;F=W-F;W=+p[u>>3];J=b+(a<<4)+8|0;V=+p[J>>3];M=u+(v<<4)|0;C=+p[M>>3];N=M+8|0;E=+p[N>>3];U=W+C;A=V+E;C=W-C;E=V-E;p[u>>3]=T+U;p[J>>3]=B+A;p[K>>3]=U-T;p[L>>3]=A-B;p[M>>3]=D+C;p[N>>3]=F+E;p[O>>3]=C-D;p[P>>3]=E-F;if(t){o=l;q=1;while(1){I=u+(q<<4)|0;K=I+(s<<4)|0;M=I+(v<<4)|0;A=+p[M>>3];L=o<<1;W=+p[g+(L<<4)>>3];N=M+8|0;C=+p[N>>3];V=+p[g+(L<<4)+8>>3];T=A*W-C*V;V=W*C+A*V;A=+p[K>>3];C=+p[g+(o<<4)+8>>3];L=K+8|0;W=+p[L>>3];D=+p[g+(o<<4)>>3];B=A*C+W*D;W=A*D-C*W;O=K+(v<<4)|0;C=+p[O>>3];J=o*3|0;D=+p[g+(J<<4)+8>>3];P=O+8|0;A=+p[P>>3];F=+p[g+(J<<4)>>3];U=C*D+A*F;A=C*F-D*A;D=W+A;F=B+U;U=B-U;W=A-W;A=+p[I>>3];J=I+8|0;B=+p[J>>3];C=T+A;E=V+B;T=A-T;V=B-V;p[I>>3]=C+D;p[J>>3]=E+F;p[K>>3]=C-D;p[L>>3]=E-F;p[M>>3]=T+U;p[N>>3]=V+W;p[O>>3]=T-U;p[P>>3]=V-W;q=q+1|0;if((q|0)==(v|0))break;else o=o+l|0}}a=a+f|0}while((a|0)<(c|0))}o=f<<2;if((o|0)>(y|0))break;else{v=f;f=o}}}else{f=1;l=h}if((f|0)<(y|0)){u=(c|0)>0;while(1){t=f<<1;l=(l|0)/2|0;b:do if(u){if((f|0)>1)a=0;else{o=0;while(1){M=b+(o<<4)|0;T=+p[M>>3];O=M+(f<<4)|0;U=+p[O>>3];N=b+(o<<4)+8|0;V=+p[N>>3];P=O+8|0;W=+p[P>>3];p[M>>3]=T+U;p[N>>3]=V+W;p[O>>3]=T-U;p[P>>3]=V-W;o=o+t|0;if((o|0)>=(c|0))break b}}do{s=b+(a<<4)|0;T=+p[s>>3];q=s+(f<<4)|0;U=+p[q>>3];P=b+(a<<4)+8|0;V=+p[P>>3];o=q+8|0;W=+p[o>>3];p[s>>3]=T+U;p[P>>3]=V+W;p[q>>3]=T-U;p[o>>3]=V-W;o=l;q=1;while(1){M=s+(q<<4)|0;O=M+(f<<4)|0;T=+p[O>>3];F=+p[g+(o<<4)>>3];P=O+8|0;V=+p[P>>3];W=+p[g+(o<<4)+8>>3];U=T*F-V*W;W=F*V+T*W;T=+p[M>>3];N=M+8|0;V=+p[N>>3];p[M>>3]=T+U;p[N>>3]=V+W;p[O>>3]=T-U;p[P>>3]=V-W;q=q+1|0;if((q|0)==(f|0))break;else o=o+l|0}a=a+t|0}while((a|0)<(c|0))}while(0);if((t|0)<(y|0))f=t;else{o=t;break}}}else o=f}else{o=1;l=h}f=z^1;c:do if((f|0)<(d|0)){P=(c|0)>0;O=o;while(1){H=k[e+(f<<2)>>2]|0;N=O;O=aa(H,O)|0;l=(l|0)/(H|0)|0;d:do switch(H|0){case 3:{if(P){t=N<<1;if((N|0)>1)a=0;else{o=0;while(1){H=b+(o<<4)|0;J=H+(N<<4)|0;W=+p[J>>3];L=H+(t<<4)|0;D=+p[L>>3];T=W+D;K=J+8|0;C=+p[K>>3];M=L+8|0;U=+p[M>>3];V=C+U;E=+p[H>>3];I=b+(o<<4)+8|0;F=+p[I>>3];U=(C-U)*.8660254037844386;W=(D-W)*.8660254037844386;p[H>>3]=T+E;p[I>>3]=V+F;T=E-T*.5;V=F-V*.5;p[J>>3]=T+U;p[K>>3]=W+V;p[L>>3]=T-U;p[M>>3]=V-W;o=o+O|0;if((o|0)>=(c|0))break d}}do{s=b+(a<<4)|0;L=s+(N<<4)|0;W=+p[L>>3];q=s+(t<<4)|0;D=+p[q>>3];T=W+D;M=L+8|0;C=+p[M>>3];o=q+8|0;U=+p[o>>3];V=C+U;E=+p[s>>3];K=b+(a<<4)+8|0;F=+p[K>>3];U=(C-U)*.8660254037844386;W=(D-W)*.8660254037844386;p[s>>3]=T+E;p[K>>3]=V+F;T=E-T*.5;V=F-V*.5;p[L>>3]=T+U;p[M>>3]=W+V;p[q>>3]=T-U;p[o>>3]=V-W;o=l;q=1;while(1){H=s+(q<<4)|0;J=H+(N<<4)|0;T=+p[J>>3];V=+p[g+(o<<4)>>3];K=J+8|0;D=+p[K>>3];F=+p[g+(o<<4)+8>>3];W=T*V-D*F;F=V*D+T*F;L=H+(t<<4)|0;T=+p[L>>3];I=o<<1;D=+p[g+(I<<4)>>3];M=L+8|0;V=+p[M>>3];U=+p[g+(I<<4)+8>>3];E=T*D-V*U;U=D*V+T*U;T=W+E;V=F+U;U=(F-U)*.8660254037844386;W=(E-W)*.8660254037844386;E=+p[H>>3];I=H+8|0;F=+p[I>>3];p[H>>3]=E+T;p[I>>3]=F+V;T=E-T*.5;V=F-V*.5;p[J>>3]=U+T;p[K>>3]=W+V;p[L>>3]=T-U;p[M>>3]=V-W;q=q+1|0;if((q|0)==(N|0))break;else o=o+l|0}a=a+O|0}while((a|0)<(c|0))}break}case 5:{if(P){s=(N|0)>0;t=N<<1;a=0;do{if(s){u=b+(a<<4)|0;o=0;q=0;while(1){w=u+(q<<4)|0;J=w+(t<<4)|0;H=J+(t<<4)|0;z=w+(N<<4)|0;F=+p[z>>3];E=+p[g+(o<<4)>>3];G=z+8|0;A=+p[G>>3];T=+p[g+(o<<4)+8>>3];V=F*E-A*T;T=E*A+F*T;F=+p[H>>3];L=o<<2;A=+p[g+(L<<4)>>3];I=H+8|0;E=+p[I>>3];U=+p[g+(L<<4)+8>>3];W=F*A-E*U;U=A*E+F*U;F=V+W;E=T+U;W=V-W;U=T-U;L=J+(N<<4)|0;T=+p[L>>3];y=o*3|0;V=+p[g+(y<<4)>>3];M=L+8|0;A=+p[M>>3];Y=+p[g+(y<<4)+8>>3];X=T*V-A*Y;Y=V*A+T*Y;T=+p[J>>3];y=o<<1;A=+p[g+(y<<4)>>3];K=J+8|0;V=+p[K>>3];D=+p[g+(y<<4)+8>>3];C=T*A-V*D;D=A*V+T*D;T=X+C;V=Y+D;C=X-C;D=Y-D;Y=+p[w>>3];y=w+8|0;X=+p[y>>3];A=F+T;B=E+V;p[w>>3]=Y+A;p[y>>3]=X+B;A=Y-A*.25;B=X-B*.25;T=(F-T)*.5590169943749475;V=(E-V)*.5590169943749475;E=(U+D)*.9510565162951535;F=(W+C)*-.9510565162951535;U=E-U*.36327126400268045;W=W*.36327126400268045+F;D=E-D*1.5388417685876268;F=C*1.5388417685876268+F;C=T+A;E=V+B;T=A-T;V=B-V;p[z>>3]=D+C;p[G>>3]=F+E;p[H>>3]=C-D;p[I>>3]=E-F;p[J>>3]=U+T;p[K>>3]=W+V;p[L>>3]=T-U;p[M>>3]=V-W;q=q+1|0;if((q|0)==(N|0))break;else o=o+l|0}}a=a+O|0}while((a|0)<(c|0))}break}default:{o=H+-1|0;I=(o|0)/2|0;J=(h|0)/(H|0)|0;K=j+(I<<4)|0;if(P){L=(N|0)>0;M=(H|0)<3;y=(o|0)>1;w=0;do{if(L){z=b+(w<<4)|0;u=0;v=0;while(1){G=z+(u<<4)|0;E=+p[G>>3];t=G+8|0;F=+p[t>>3];if(!u){if(!M){o=N;q=1;n=E;x=F;while(1){s=G+(o<<4)|0;W=+p[s>>3];Q=G+(O-o<<4)|0;X=+p[Q>>3];T=W+X;U=+p[s+8>>3];V=+p[Q+8>>3];Y=U+V;n=n+T;x=x+Y;Q=q+-1|0;p[j+(Q<<4)>>3]=T;p[j+(Q<<4)+8>>3]=U-V;Q=K+(Q<<4)|0;p[Q>>3]=W-X;p[Q+8>>3]=Y;if((q|0)<(I|0)){o=o+N|0;q=q+1|0}else{Q=82;break}}}}else{s=g+((aa(v,H)|0)<<4)|0;if(!M){o=v;q=N;a=1;n=E;x=F;while(1){Z=G+(q<<4)|0;T=+p[Z>>3];Y=+p[g+(o<<4)>>3];D=+p[Z+8>>3];U=+p[g+(o<<4)+8>>3];W=T*Y-D*U;U=Y*D+T*U;Z=G+(O-q<<4)|0;T=+p[Z>>3];Q=s+(0-o<<4)|0;D=+p[Q>>3];Y=+p[Z+8>>3];V=+p[Q+8>>3];X=T*D-Y*V;V=D*Y+T*V;T=W+X;Y=U+V;n=n+T;x=x+Y;Q=a+-1|0;p[j+(Q<<4)>>3]=T;p[j+(Q<<4)+8>>3]=U-V;Q=K+(Q<<4)|0;p[Q>>3]=W-X;p[Q+8>>3]=Y;if((a|0)<(I|0)){o=o+v|0;q=q+N|0;a=a+1|0}else{Q=82;break}}}}e:do if((Q|0)==82?(Q=0,p[G>>3]=n,p[t>>3]=x,!M):0){if(y){a=N;s=1}else{o=N;q=1;while(1){Z=G+(o<<4)|0;p[Z>>3]=E;p[Z+8>>3]=F;Z=G+(O-o<<4)|0;p[Z>>3]=E;p[Z+8>>3]=F;if((q|0)<(I|0)){o=o+N|0;q=q+1|0}else break e}}while(1){t=aa(s,J)|0;q=0;o=t;A=E;B=E;C=F;D=F;while(1){X=+p[g+(o<<4)>>3];V=X*+p[j+(q<<4)>>3];Y=+p[g+(o<<4)+8>>3];W=Y*+p[j+(q<<4)+8>>3];Z=K+(q<<4)|0;X=X*+p[Z+8>>3];Y=Y*+p[Z>>3];A=A+(V+W);B=B+(V-W);C=C+(X-Y);D=D+(X+Y);o=o+t|0;q=q+1|0;if((q|0)>=(I|0))break;else o=o-((o|0)>=(h|0)?h:0)|0}Z=G+(a<<4)|0;p[Z>>3]=B;p[Z+8>>3]=D;Z=G+(O-a<<4)|0;p[Z>>3]=A;p[Z+8>>3]=C;if((s|0)<(I|0)){a=a+N|0;s=s+1|0}else break}}while(0);u=u+1|0;if((u|0)==(N|0))break;else v=v+l|0}}w=w+O|0}while((w|0)<(c|0))}}}while(0);f=f+1|0;if((f|0)==(d|0))break c}}while(0);f=(R|0)==0;if(m!=1.0){n=f?m:-m;if((c|0)>0)f=0;else{r=S;return}do{j=b+(f<<4)|0;Z=b+(f<<4)+8|0;Y=n*+p[Z>>3];p[j>>3]=+p[j>>3]*m;p[Z>>3]=Y;f=f+1|0}while((f|0)!=(c|0));r=S;return}if(f){r=S;return}l=c+-2|0;if((c|0)<2)l=0;else{f=0;do{j=b+(f<<4)+8|0;Z=b+((f|1)<<4)+8|0;Y=-+p[Z>>3];p[j>>3]=-+p[j>>3];p[Z>>3]=Y;f=f+2|0}while((f|0)<=(l|0));l=c&-2}f=b+(c+-1<<4)+8|0;if((l|0)>=(c|0)){r=S;return}p[f>>3]=-+p[f>>3];r=S;return}function nZ(a,b,c,d,e,f,g,h,i,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;l=+l;var m=0.0,n=0,o=0,q=0.0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;n=j&512;t=(n|0)!=0;n=n>>>9;o=c>>1;b=b+(n<<3)|0;u=(c|0)==1;do if(!u){if((c|0)==2){q=+p[a>>3];r=+p[a+8>>3];p[b+8>>3]=(q-r)*l;p[b>>3]=(q+r)*l;s=15;break}j=c&1;if(!j){r=l*.5;n=k[e>>2]>>1;k[e>>2]=n;n=(n|0)==1&1;mZ(a,b,o,d-n|0,e+(n<<2)|0,f,g,h,i,0,1.0);k[e>>2]=k[e>>2]<<1;q=+p[b>>3];n=b+8|0;v=+p[n>>3];p[b>>3]=(q+v)*l;v=(q-v)*l;p[n>>3]=v;n=b+(o<<3)|0;q=+p[n>>3];s=b+(c+-1<<3)|0;m=+p[s>>3];p[s>>3]=v;if((o|0)>2){j=2;do{f=g;g=g+16|0;v=+p[b+((j|1)<<3)>>3];B=r*(m+v);h=c-j|0;s=b+(h<<3)|0;z=+p[s>>3];i=b+(j<<3)|0;y=+p[i>>3];w=r*(z-y);y=r*(z+y);v=r*(v-m);z=+p[g>>3];A=+p[f+24>>3];x=B*z-w*A;w=B*A+z*w;h=b+(h+-1<<3)|0;m=+p[h>>3];p[b+(j+-1<<3)>>3]=y+x;p[h>>3]=y-x;p[i>>3]=v+w;p[s>>3]=w-v;j=j+2|0}while((j|0)<(o|0));j=o+1&-2}else j=2;if((j|0)>(o|0)){s=15;break}p[b+(o+-1<<3)>>3]=q*l;p[n>>3]=-(m*l);s=15;break}else{b=b+(0-n<<3)|0;p[b>>3]=+p[a>>3]*l;o=b+8|0;p[o>>3]=0.0;if((c|0)>1){n=1;do{C=n+1|0;B=+p[a+(k[f+(C<<2)>>2]<<3)>>3]*l;p[b+(n<<4)>>3]=+p[a+(k[f+(n<<2)>>2]<<3)>>3]*l;p[b+(n<<4)+8>>3]=0.0;p[b+(C<<4)>>3]=B;p[b+(C<<4)+8>>3]=0.0;n=n+2|0}while((n|0)<(c|0))}mZ(b,b,c,d,e,f,g,h,i,256,1.0);if(t)break;p[o>>3]=+p[b>>3];return}}else{p[b>>3]=+p[a>>3]*l;s=15}while(0);do if((s|0)==15)if(t){j=c&1;break}else return;while(0);if(!(u|(j|0)==0))return;p[b+-8>>3]=+p[b>>3];p[b>>3]=0.0;if((c|0)<=1)return;p[b+(c<<3)>>3]=0.0;return}function oZ(a,b,c,d,e,f,g,h,i,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;l=+l;var m=0,n=0.0,p=0.0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0;u=(j&512|0)!=0;t=c+1>>1;if(u){r=a+4|0;s=+o[r>>2];k[r>>2]=k[a>>2];a=r}else s=0.0;a:do switch(c|0){case 1:{o[b>>2]=l*+o[a>>2];break}case 2:{n=+o[a>>2];p=+o[a+4>>2];o[b+4>>2]=l*(n-p);o[b>>2]=l*(n+p);break}default:{if(c&1|0){m=a+-4|0;k[b>>2]=k[a>>2];o[b+4>>2]=0.0;if((t|0)>1){j=1;do{v=k[f+(j<<2)>>2]|0;r=k[f+(c-j<<2)>>2]|0;q=k[m+(j<<3)>>2]|0;p=+o[m+(j<<3)+4>>2];k[b+(v<<3)>>2]=q;o[b+(v<<3)+4>>2]=-p;k[b+(r<<3)>>2]=q;o[b+(r<<3)+4>>2]=p;j=j+1|0}while((j|0)!=(t|0))}pZ(b,b,c,d,e,f,g,h,i,256,1.0);o[b>>2]=l*+o[b>>2];if((c|0)>1)j=1;else break a;while(1){v=j<<1;p=l*+o[b+(v+2<<2)>>2];o[b+(j<<2)>>2]=l*+o[b+(v<<2)>>2];o[b+(j+1<<2)>>2]=p;j=j+2|0;if((j|0)>=(c|0))break a}}r=(a|0)==(b|0);n=+o[a+4>>2];p=+o[a>>2];w=+o[a+(c+-1<<2)>>2];o[b>>2]=p+w;o[b+4>>2]=w-p;j=g+8|0;do if((t|0)>2)if(r){m=2;q=g;while(1){v=c-m|0;B=+o[b+(v+-1<<2)>>2];z=n+B;A=b+(m<<2)|0;C=+o[A>>2];x=b+(v<<2)|0;D=+o[x>>2];p=C-D;B=n-B;D=C+D;C=+o[j>>2];y=+o[q+12>>2];w=B*C+D*y;y=D*C-B*y;q=b+((m|1)<<2)|0;n=+o[q>>2];o[A>>2]=z-y;o[q>>2]=-p-w;o[x>>2]=z+y;o[b+(v+1<<2)>>2]=p-w;m=m+2|0;if((m|0)>=(t|0))break;else{q=j;j=j+8|0}}j=t+1&-2;break}else{m=2;q=g;while(1){A=c-m|0;y=+o[a+(A+-1<<2)>>2];z=n+y;w=+o[a+(m<<2)>>2];p=+o[a+(A<<2)>>2];C=w-p;y=n-y;p=w+p;w=+o[j>>2];B=+o[q+12>>2];D=y*w+p*B;B=p*w-y*B;n=+o[a+((m|1)<<2)>>2];A=m>>1;x=k[f+(A<<2)>>2]|0;o[b+(x<<2)>>2]=z-B;o[b+(x+1<<2)>>2]=-C-D;A=k[f+(t-A<<2)>>2]|0;o[b+(A<<2)>>2]=z+B;o[b+(A+1<<2)>>2]=C-D;m=m+2|0;if((m|0)>=(t|0))break;else{q=j;j=j+8|0}}j=t+1&-2;break}else j=2;while(0);do if((j|0)<=(t|0)){n=n*2.0;p=+o[a+(t<<2)>>2]*2.0;if(r){o[b+(t<<2)>>2]=n;o[b+(t+1<<2)>>2]=p;break}else{A=k[f+(t<<2)>>2]<<1;o[b+(A<<2)>>2]=n;o[b+((A|1)<<2)>>2]=p;break}}while(0);A=k[e>>2]>>1;k[e>>2]=A;A=(A|0)==1&1;pZ(b,b,t,d-A|0,e+(A<<2)|0,f,g,h,i,r?0:256,1.0);k[e>>2]=k[e>>2]<<1;if((c|0)>0){j=0;do{x=b+(j<<2)|0;A=b+((j|1)<<2)|0;D=-(l*+o[A>>2]);o[x>>2]=l*+o[x>>2];o[A>>2]=D;j=j+2|0}while((j|0)<(c|0))}}}while(0);if(!u)return;o[a>>2]=s;return}function pZ(a,b,c,d,e,f,g,h,j,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;m=+m;var n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0;S=r;r=r+16|0;s=S;Q=l&1;R=m;if((h|0)!=(c|0))if((c<<1|0)==(h|0))v=2;else v=(h|0)/(c|0)|0;else v=1;do if((b|0)==(a|0)){a:do if(!(l&256)){if((k[e>>2]|0)!=(k[e+(d+-1<<2)>>2]|0)){l=s+4|0;n=ZT(32)|0;k[n>>2]=1;p=n+4|0;k[s>>2]=p;k[l>>2]=27;i[n+31>>0]=0;a=213171;q=p+27|0;do{i[p>>0]=i[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));Y8(-215,s,213199,212918,614);k[l>>2]=0;k[s>>2]=0;N=k[n>>2]|0;k[n>>2]=N+-1;if((N|0)==1)ggb(k[n+-4>>2]|0)}if((d|0)!=1){if((c|0)>0)l=0;else break;while(1){n=k[f>>2]|0;if((n|0)>(l|0)){K=b+(l<<3)|0;L=k[K>>2]|0;N=k[b+(l<<3)+4>>2]|0;M=b+(n<<3)|0;I=M;J=k[I+4>>2]|0;k[K>>2]=k[I>>2];k[K+4>>2]=J;k[M>>2]=L;k[b+(n<<3)+4>>2]=N}l=l+1|0;if((l|0)==(c|0))break a;else f=f+(v<<2)|0}}if((c&3|0)==0?(t=(c|0)/2|0,u=b+(t<<3)|0,(c|0)>1):0){a=v<<1;l=0;while(1){n=k[f>>2]|0;p=l|1;K=b+(p<<3)|0;L=k[K>>2]|0;M=k[b+(p<<3)+4>>2]|0;N=u+(n<<3)|0;I=N;J=k[I+4>>2]|0;k[K>>2]=k[I>>2];k[K+4>>2]=J;k[N>>2]=L;k[N+4>>2]=M;if((n|0)>(l|0)){N=b+(l<<3)|0;M=k[N>>2]|0;K=k[b+(l<<3)+4>>2]|0;L=b+(n<<3)|0;J=L;I=k[J+4>>2]|0;k[N>>2]=k[J>>2];k[N+4>>2]=I;k[L>>2]=M;k[b+(n<<3)+4>>2]=K;K=u+(p<<3)|0;L=k[K>>2]|0;M=k[K+4>>2]|0;N=u+(n+1<<3)|0;I=N;J=k[I+4>>2]|0;k[K>>2]=k[I>>2];k[K+4>>2]=J;k[N>>2]=L;k[N+4>>2]=M}l=l+2|0;if((l|0)>=(t|0))break;else f=f+(a<<2)|0}}}while(0);if(Q|0){l=c+-2|0;if((c|0)<2)f=0;else{f=0;do{M=b+(f<<3)+4|0;N=b+((f|1)<<3)+4|0;D=-+o[N>>2];o[M>>2]=-+o[M>>2];o[N>>2]=D;f=f+2|0}while((f|0)<=(l|0));f=c&-2}l=b+(c+-1<<3)+4|0;if((f|0)<(c|0))o[l>>2]=-+o[l>>2]}}else{p=c+-2|0;l=(c|0)<2;if(!Q){if(l)f=0;else{n=v<<1;l=0;while(1){L=k[f+(v<<2)>>2]|0;K=a+(k[f>>2]<<3)|0;N=k[K+4>>2]|0;M=b+(l<<3)|0;k[M>>2]=k[K>>2];k[M+4>>2]=N;L=a+(L<<3)|0;M=k[L+4>>2]|0;N=b+((l|1)<<3)|0;k[N>>2]=k[L>>2];k[N+4>>2]=M;l=l+2|0;if((l|0)>(p|0))break;else f=f+(n<<2)|0}f=c&-2}l=c+-1|0;if((f|0)>=(c|0))break;L=a+(l<<3)|0;M=k[L+4>>2]|0;N=b+(l<<3)|0;k[N>>2]=k[L>>2];k[N+4>>2]=M;break}else{if(l)f=0;else{n=v<<1;l=0;while(1){N=k[f>>2]|0;M=k[f+(v<<2)>>2]|0;D=-+o[a+(N<<3)+4>>2];k[b+(l<<3)>>2]=k[a+(N<<3)>>2];o[b+(l<<3)+4>>2]=D;D=-+o[a+(M<<3)+4>>2];N=l|1;k[b+(N<<3)>>2]=k[a+(M<<3)>>2];o[b+(N<<3)+4>>2]=D;l=l+2|0;if((l|0)>(p|0))break;else f=f+(n<<2)|0}f=c&-2}if((f|0)>=(c|0))break;N=c+-1|0;D=-+o[a+(N<<3)+4>>2];k[b+(f<<3)>>2]=k[a+(N<<3)>>2];o[b+(f<<3)+4>>2]=D;break}}while(0);x=k[e>>2]|0;y=x&1;if(!y){if((x|0)>3){v=(c|0)>0;f=h;u=1;l=4;while(1){f=(f|0)/4|0;if(v){q=u<<1;s=(u|0)>1;a=0;do{t=b+(a<<3)|0;I=t+(q<<3)|0;D=+o[I>>2];J=I+4|0;V=+o[J>>2];M=I+(u<<3)|0;W=+o[M>>2];N=M+4|0;B=+o[N>>2];T=D+W;z=V+B;B=V-B;D=W-D;W=+o[t>>2];H=b+(a<<3)+4|0;V=+o[H>>2];K=t+(u<<3)|0;A=+o[K>>2];L=K+4|0;C=+o[L>>2];U=W+A;m=V+C;A=W-A;C=V-C;o[t>>2]=T+U;o[H>>2]=z+m;o[I>>2]=U-T;o[J>>2]=m-z;o[K>>2]=B+A;o[L>>2]=D+C;o[M>>2]=A-B;o[N>>2]=C-D;if(s){n=f;p=1;while(1){G=t+(p<<3)|0;I=G+(q<<3)|0;K=G+(u<<3)|0;m=+o[K>>2];J=n<<1;W=+o[g+(J<<3)>>2];L=K+4|0;A=+o[L>>2];V=+o[g+(J<<3)+4>>2];T=m*W-A*V;V=W*A+m*V;m=+o[I>>2];A=+o[g+(n<<3)+4>>2];J=I+4|0;W=+o[J>>2];B=+o[g+(n<<3)>>2];z=m*A+W*B;W=m*B-A*W;M=I+(u<<3)|0;A=+o[M>>2];H=n*3|0;B=+o[g+(H<<3)+4>>2];N=M+4|0;m=+o[N>>2];D=+o[g+(H<<3)>>2];U=A*B+m*D;m=A*D-B*m;B=W+m;D=z+U;U=z-U;W=m-W;m=+o[G>>2];H=G+4|0;z=+o[H>>2];A=T+m;C=V+z;T=m-T;V=z-V;o[G>>2]=A+B;o[H>>2]=C+D;o[I>>2]=A-B;o[J>>2]=C-D;o[K>>2]=T+U;o[L>>2]=V+W;o[M>>2]=T-U;o[N>>2]=V-W;p=p+1|0;if((p|0)==(u|0))break;else n=n+f|0}}a=a+l|0}while((a|0)<(c|0))}n=l<<2;if((n|0)>(x|0))break;else{u=l;l=n}}}else{l=1;f=h}if((l|0)<(x|0)){t=(c|0)>0;while(1){s=l<<1;f=(f|0)/2|0;b:do if(t){if((l|0)>1)a=0;else{n=0;while(1){K=b+(n<<3)|0;T=+o[K>>2];M=K+(l<<3)|0;U=+o[M>>2];L=b+(n<<3)+4|0;V=+o[L>>2];N=M+4|0;W=+o[N>>2];o[K>>2]=T+U;o[L>>2]=V+W;o[M>>2]=T-U;o[N>>2]=V-W;n=n+s|0;if((n|0)>=(c|0))break b}}do{q=b+(a<<3)|0;T=+o[q>>2];p=q+(l<<3)|0;U=+o[p>>2];N=b+(a<<3)+4|0;V=+o[N>>2];n=p+4|0;W=+o[n>>2];o[q>>2]=T+U;o[N>>2]=V+W;o[p>>2]=T-U;o[n>>2]=V-W;n=f;p=1;while(1){K=q+(p<<3)|0;M=K+(l<<3)|0;T=+o[M>>2];D=+o[g+(n<<3)>>2];N=M+4|0;V=+o[N>>2];W=+o[g+(n<<3)+4>>2];U=T*D-V*W;W=D*V+T*W;T=+o[K>>2];L=K+4|0;V=+o[L>>2];o[K>>2]=T+U;o[L>>2]=V+W;o[M>>2]=T-U;o[N>>2]=V-W;p=p+1|0;if((p|0)==(l|0))break;else n=n+f|0}a=a+s|0}while((a|0)<(c|0))}while(0);if((s|0)<(x|0))l=s;else{n=s;l=f;break}}}else{n=l;l=f}}else{n=1;l=h}f=y^1;c:do if((f|0)<(d|0)){N=(c|0)>0;L=n;while(1){F=k[e+(f<<2)>>2]|0;M=L;L=aa(F,L)|0;l=(l|0)/(F|0)|0;d:do switch(F|0){case 3:{if(N){s=M<<1;if((M|0)>1)a=0;else{n=0;while(1){F=b+(n<<3)|0;H=F+(M<<3)|0;W=+o[H>>2];J=F+(s<<3)|0;B=+o[J>>2];T=W+B;I=H+4|0;A=+o[I>>2];K=J+4|0;U=+o[K>>2];V=A+U;C=+o[F>>2];G=b+(n<<3)+4|0;D=+o[G>>2];U=(A-U)*.8660253882408142;W=(B-W)*.8660253882408142;o[F>>2]=T+C;o[G>>2]=V+D;T=C-T*.5;V=D-V*.5;o[H>>2]=T+U;o[I>>2]=W+V;o[J>>2]=T-U;o[K>>2]=V-W;n=n+L|0;if((n|0)>=(c|0))break d}}do{q=b+(a<<3)|0;J=q+(M<<3)|0;W=+o[J>>2];p=q+(s<<3)|0;B=+o[p>>2];T=W+B;K=J+4|0;A=+o[K>>2];n=p+4|0;U=+o[n>>2];V=A+U;C=+o[q>>2];I=b+(a<<3)+4|0;D=+o[I>>2];U=(A-U)*.8660253882408142;W=(B-W)*.8660253882408142;o[q>>2]=T+C;o[I>>2]=V+D;T=C-T*.5;V=D-V*.5;o[J>>2]=T+U;o[K>>2]=W+V;o[p>>2]=T-U;o[n>>2]=V-W;n=l;p=1;while(1){F=q+(p<<3)|0;H=F+(M<<3)|0;T=+o[H>>2];V=+o[g+(n<<3)>>2];I=H+4|0;B=+o[I>>2];D=+o[g+(n<<3)+4>>2];W=T*V-B*D;D=V*B+T*D;J=F+(s<<3)|0;T=+o[J>>2];G=n<<1;B=+o[g+(G<<3)>>2];K=J+4|0;V=+o[K>>2];U=+o[g+(G<<3)+4>>2];C=T*B-V*U;U=B*V+T*U;T=W+C;V=D+U;U=(D-U)*.8660253882408142;W=(C-W)*.8660253882408142;C=+o[F>>2];G=F+4|0;D=+o[G>>2];o[F>>2]=C+T;o[G>>2]=D+V;T=C-T*.5;V=D-V*.5;o[H>>2]=U+T;o[I>>2]=W+V;o[J>>2]=T-U;o[K>>2]=V-W;p=p+1|0;if((p|0)==(M|0))break;else n=n+l|0}a=a+L|0}while((a|0)<(c|0))}break}case 5:{if(N){q=(M|0)>0;s=M<<1;a=0;do{if(q){t=b+(a<<3)|0;n=0;p=0;while(1){v=t+(p<<3)|0;H=v+(s<<3)|0;F=H+(s<<3)|0;y=v+(M<<3)|0;D=+o[y>>2];C=+o[g+(n<<3)>>2];E=y+4|0;m=+o[E>>2];T=+o[g+(n<<3)+4>>2];V=D*C-m*T;T=C*m+D*T;D=+o[F>>2];J=n<<2;m=+o[g+(J<<3)>>2];G=F+4|0;C=+o[G>>2];U=+o[g+(J<<3)+4>>2];W=D*m-C*U;U=m*C+D*U;D=V+W;C=T+U;W=V-W;U=T-U;J=H+(M<<3)|0;T=+o[J>>2];x=n*3|0;V=+o[g+(x<<3)>>2];K=J+4|0;m=+o[K>>2];Y=+o[g+(x<<3)+4>>2];X=T*V-m*Y;Y=V*m+T*Y;T=+o[H>>2];x=n<<1;m=+o[g+(x<<3)>>2];I=H+4|0;V=+o[I>>2];B=+o[g+(x<<3)+4>>2];A=T*m-V*B;B=m*V+T*B;T=X+A;V=Y+B;A=X-A;B=Y-B;Y=+o[v>>2];x=v+4|0;X=+o[x>>2];m=D+T;z=C+V;o[v>>2]=Y+m;o[x>>2]=X+z;m=Y-m*.25;z=X-z*.25;T=(D-T)*.55901700258255;V=(C-V)*.55901700258255;C=(U+B)*.9510565400123596;D=(W+A)*-.9510565400123596;U=C-U*.3632712662220001;W=W*.3632712662220001+D;B=C-B*1.538841724395752;D=A*1.538841724395752+D;A=T+m;C=V+z;T=m-T;V=z-V;o[y>>2]=B+A;o[E>>2]=D+C;o[F>>2]=A-B;o[G>>2]=C-D;o[H>>2]=U+T;o[I>>2]=W+V;o[J>>2]=T-U;o[K>>2]=V-W;p=p+1|0;if((p|0)==(M|0))break;else n=n+l|0}}a=a+L|0}while((a|0)<(c|0))}break}default:{n=F+-1|0;G=(n|0)/2|0;H=(h|0)/(F|0)|0;I=j+(G<<3)|0;if(N){J=(M|0)>0;K=(F|0)<3;x=(n|0)>1;v=0;do{if(J){y=b+(v<<3)|0;t=0;u=0;while(1){E=y+(t<<3)|0;C=+o[E>>2];s=E+4|0;D=+o[s>>2];if(!t){if(!K){n=M;p=1;m=C;w=D;while(1){q=E+(n<<3)|0;W=+o[q>>2];O=E+(L-n<<3)|0;X=+o[O>>2];T=W+X;U=+o[q+4>>2];V=+o[O+4>>2];Y=U+V;m=m+T;w=w+Y;O=p+-1|0;o[j+(O<<3)>>2]=T;o[j+(O<<3)+4>>2]=U-V;O=I+(O<<3)|0;o[O>>2]=W-X;o[O+4>>2]=Y;if((p|0)<(G|0)){n=n+M|0;p=p+1|0}else{P=m;O=82;break}}}}else{q=g+((aa(u,F)|0)<<3)|0;if(!K){n=u;p=M;a=1;m=C;w=D;while(1){Z=E+(p<<3)|0;T=+o[Z>>2];Y=+o[g+(n<<3)>>2];P=+o[Z+4>>2];U=+o[g+(n<<3)+4>>2];W=T*Y-P*U;U=Y*P+T*U;Z=E+(L-p<<3)|0;T=+o[Z>>2];O=q+(0-n<<3)|0;P=+o[O>>2];Y=+o[Z+4>>2];V=+o[O+4>>2];X=T*P-Y*V;V=P*Y+T*V;T=W+X;Y=U+V;m=m+T;w=w+Y;O=a+-1|0;o[j+(O<<3)>>2]=T;o[j+(O<<3)+4>>2]=U-V;O=I+(O<<3)|0;o[O>>2]=W-X;o[O+4>>2]=Y;if((a|0)<(G|0)){n=n+u|0;p=p+M|0;a=a+1|0}else{P=m;O=82;break}}}}e:do if((O|0)==82?(O=0,o[E>>2]=P,o[s>>2]=w,!K):0){if(x){a=M;q=1}else{n=M;p=1;while(1){Z=E+(n<<3)|0;o[Z>>2]=C;o[Z+4>>2]=D;Z=E+(L-n<<3)|0;o[Z>>2]=C;o[Z+4>>2]=D;if((p|0)<(G|0)){n=n+M|0;p=p+1|0}else break e}}while(1){s=aa(q,H)|0;p=0;n=s;m=C;z=C;A=D;B=D;while(1){X=+o[g+(n<<3)>>2];V=X*+o[j+(p<<3)>>2];Y=+o[g+(n<<3)+4>>2];W=Y*+o[j+(p<<3)+4>>2];Z=I+(p<<3)|0;X=X*+o[Z+4>>2];Y=Y*+o[Z>>2];m=m+(V+W);z=z+(V-W);A=A+(X-Y);B=B+(X+Y);n=n+s|0;p=p+1|0;if((p|0)>=(G|0))break;else n=n-((n|0)>=(h|0)?h:0)|0}Z=E+(a<<3)|0;o[Z>>2]=z;o[Z+4>>2]=B;Z=E+(L-a<<3)|0;o[Z>>2]=m;o[Z+4>>2]=A;if((q|0)<(G|0)){a=a+M|0;q=q+1|0}else break}}while(0);t=t+1|0;if((t|0)==(M|0))break;else u=u+l|0}}v=v+L|0}while((v|0)<(c|0))}}}while(0);f=f+1|0;if((f|0)==(d|0))break c}}while(0);f=(Q|0)==0;if(R!=1.0){m=f?R:-R;if((c|0)>0)f=0;else{r=S;return}do{j=b+(f<<3)|0;Z=b+(f<<3)+4|0;Y=m*+o[Z>>2];o[j>>2]=R*+o[j>>2];o[Z>>2]=Y;f=f+1|0}while((f|0)!=(c|0));r=S;return}if(f){r=S;return}l=c+-2|0;if((c|0)<2)l=0;else{f=0;do{j=b+(f<<3)+4|0;Z=b+((f|1)<<3)+4|0;Y=-+o[Z>>2];o[j>>2]=-+o[j>>2];o[Z>>2]=Y;f=f+2|0}while((f|0)<=(l|0));l=c&-2}f=b+(c+-1<<3)+4|0;if((l|0)>=(c|0)){r=S;return}o[f>>2]=-+o[f>>2];r=S;return}function qZ(a,b,c,d,e,f,g,h,i,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;l=+l;var m=0,n=0,p=0.0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;m=j&512;t=(m|0)!=0;m=m>>>9;s=l;n=c>>1;b=b+(m<<2)|0;u=(c|0)==1;do if(!u){if((c|0)==2){p=+o[a>>2];q=+o[a+4>>2];o[b+4>>2]=s*(p-q);o[b>>2]=s*(p+q);r=15;break}j=c&1;if(!j){q=s*.5;m=k[e>>2]>>1;k[e>>2]=m;m=(m|0)==1&1;pZ(a,b,n,d-m|0,e+(m<<2)|0,f,g,h,i,0,1.0);k[e>>2]=k[e>>2]<<1;p=+o[b>>2];m=b+4|0;v=+o[m>>2];o[b>>2]=s*(p+v);v=s*(p-v);o[m>>2]=v;m=b+(n<<2)|0;p=+o[m>>2];r=b+(c+-1<<2)|0;l=+o[r>>2];o[r>>2]=v;if((n|0)>2){j=2;do{f=g;g=g+8|0;v=+o[b+((j|1)<<2)>>2];B=q*(l+v);h=c-j|0;r=b+(h<<2)|0;z=+o[r>>2];i=b+(j<<2)|0;y=+o[i>>2];w=q*(z-y);y=q*(z+y);v=q*(v-l);z=+o[g>>2];A=+o[f+12>>2];x=B*z-w*A;w=B*A+z*w;h=b+(h+-1<<2)|0;l=+o[h>>2];o[b+(j+-1<<2)>>2]=y+x;o[h>>2]=y-x;o[i>>2]=v+w;o[r>>2]=w-v;j=j+2|0}while((j|0)<(n|0));j=n+1&-2}else j=2;if((j|0)>(n|0)){r=15;break}o[b+(n+-1<<2)>>2]=s*p;o[m>>2]=-(s*l);r=15;break}else{b=b+(0-m<<2)|0;o[b>>2]=s*+o[a>>2];n=b+4|0;o[n>>2]=0.0;if((c|0)>1){m=1;do{C=m+1|0;B=s*+o[a+(k[f+(C<<2)>>2]<<2)>>2];o[b+(m<<3)>>2]=s*+o[a+(k[f+(m<<2)>>2]<<2)>>2];o[b+(m<<3)+4>>2]=0.0;o[b+(C<<3)>>2]=B;o[b+(C<<3)+4>>2]=0.0;m=m+2|0}while((m|0)<(c|0))}pZ(b,b,c,d,e,f,g,h,i,256,1.0);if(t)break;k[n>>2]=k[b>>2];return}}else{o[b>>2]=s*+o[a>>2];r=15}while(0);do if((r|0)==15)if(t){j=c&1;break}else return;while(0);if(!(u|(j|0)==0))return;k[b+-4>>2]=k[b>>2];o[b>>2]=0.0;if((c|0)<=1)return;o[b+(c<<2)>>2]=0.0;return}function rZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0;M=r;r=r+176|0;L=M+112|0;K=M+56|0;J=M;do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[L>>2]=k[h>>2];n=L+4|0;a=h+4|0;k[n>>2]=k[a>>2];I=L+8|0;k[I>>2]=k[h+8>>2];k[L+12>>2]=k[h+12>>2];k[L+16>>2]=k[h+16>>2];k[L+20>>2]=k[h+20>>2];k[L+24>>2]=k[h+24>>2];k[L+28>>2]=k[h+28>>2];k[L+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[L+36>>2]=f;g=L+40|0;k[g>>2]=I;I=L+48|0;l=L+44|0;k[l>>2]=I;k[L+52>>2]=0;k[I>>2]=0;if(f|0){I=f+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[a>>2]|0)<3){H=k[h+44>>2]|0;I=k[l>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2];break}k[n>>2]=0;x1(L,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(L,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[K>>2]=k[j>>2];n=K+4|0;f=j+4|0;k[n>>2]=k[f>>2];I=K+8|0;k[I>>2]=k[j+8>>2];k[K+12>>2]=k[j+12>>2];k[K+16>>2]=k[j+16>>2];k[K+20>>2]=k[j+20>>2];k[K+24>>2]=k[j+24>>2];k[K+28>>2]=k[j+28>>2];k[K+32>>2]=k[j+32>>2];a=k[j+36>>2]|0;k[K+36>>2]=a;g=K+40|0;k[g>>2]=I;I=K+48|0;l=K+44|0;k[l>>2]=I;k[K+52>>2]=0;k[I>>2]=0;if(a|0){I=a+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[f>>2]|0)<3){I=k[j+44>>2]|0;q=k[l>>2]|0;k[q>>2]=k[I>>2];k[q+4>>2]=k[I+4>>2];q=K;break}k[n>>2]=0;x1(K,k[f>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[j+40>>2]|0;h=k[g>>2]|0;g=k[j+44>>2]|0;f=k[l>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0));q=K}else q=K}else{Q1(K,b,-1);q=K}while(0);a=k[L>>2]|0;w=a&7;u=a>>>3&511;v=u+1|0;h=a&4095;j=L+8|0;t=k[j>>2]|0;l=L+12|0;s=k[l>>2]|0;if(!((h|0)==(k[q>>2]&4095|0)?(H=k[L+40>>2]|0,I=k[K+40>>2]|0,(k[H>>2]|0)==(k[I>>2]|0)?(k[H+4>>2]|0)==(k[I+4>>2]|0):0):0)){k[J>>2]=0;f=J+4|0;k[f>>2]=0;g=ZT(56)|0;k[g>>2]=1;m=g+4|0;k[J>>2]=m;k[f>>2]=49;i[g+53>>0]=0;n=213203;b=m+49|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(b|0));Y8(-215,J,213253,212918,2956);k[f>>2]=0;k[J>>2]=0;I=k[g>>2]|0;k[g>>2]=I+-1;if((I|0)==1)ggb(k[g+-4>>2]|0)}switch(a&4095){case 5:case 6:case 13:case 14:break;default:{k[J>>2]=0;a=J+4|0;k[a>>2]=0;f=ZT(84)|0;k[f>>2]=1;m=f+4|0;k[J>>2]=m;k[a>>2]=76;i[f+80>>0]=0;n=212837;b=m+76|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(b|0));Y8(-215,J,213253,212918,2957);k[a>>2]=0;k[J>>2]=0;I=k[f>>2]|0;k[f>>2]=I+-1;if((I|0)==1)ggb(k[f+-4>>2]|0)}}c2(c,k[j>>2]|0,k[l>>2]|0,h,-1,0,0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[J>>2]=k[h>>2];n=J+4|0;a=h+4|0;k[n>>2]=k[a>>2];I=J+8|0;k[I>>2]=k[h+8>>2];k[J+12>>2]=k[h+12>>2];k[J+16>>2]=k[h+16>>2];k[J+20>>2]=k[h+20>>2];k[J+24>>2]=k[h+24>>2];k[J+28>>2]=k[h+28>>2];k[J+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[J+36>>2]=f;g=J+40|0;k[g>>2]=I;I=J+48|0;l=J+44|0;k[l>>2]=I;k[J+52>>2]=0;k[I>>2]=0;if(f|0){I=f+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[a>>2]|0)<3){H=k[h+44>>2]|0;I=k[l>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2];break}k[n>>2]=0;x1(J,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(J,c,-1);while(0);a=(d&4|0)!=0;if(!(a|(t|0)==1))if(((s|0)==1?(k[L>>2]&16384|0)!=0:0)?(k[q>>2]&16384|0)!=0:0)E=(k[J>>2]&16384|0)!=0;else E=0;else E=1;l=E^1;C=a|l;m=s+(C?0:t+-1|0)|0;C=C?t:1;D=(u|0)==0;H=D&1;f=(m|0)%2|0;F=(f|0)==0;G=(aa(m,v)|0)-((f|u|0)==0&1)|0;I=L+16|0;j=k[I>>2]|0;a:do if((w|0)==5){h=k[K+16>>2]|0;g=k[J+16>>2]|0;z=(k[L+48>>2]|0)>>>2;A=(k[K+48>>2]|0)>>>2;B=(k[J+48>>2]|0)>>>2;if(D&l){t=f|0?1:2;u=m+-1|0;v=(C&1|0)==0;f=C+-1|0;w=aa(B,f)|0;c=aa(A,f)|0;d=aa(z,f)|0;x=C+-2|0;y=(x|0)<1;s=1-m|0;q=0;do{b=(q|0)==1;l=b?g+(u<<2)|0:g;m=b?h+(u<<2)|0:h;n=b?j+(u<<2)|0:j;o[l>>2]=+o[n>>2]*+o[m>>2];if(v)o[l+(w<<2)>>2]=+o[n+(d<<2)>>2]*+o[m+(c<<2)>>2];if(e){if(!y){a=1;do{N=n+((aa(a,z)|0)<<2)|0;P=+o[N>>2];N=m+((aa(a,A)|0)<<2)|0;R=+o[N>>2];N=a+1|0;S=n+((aa(N,z)|0)<<2)|0;Q=+o[S>>2];S=m+((aa(N,A)|0)<<2)|0;O=+o[S>>2];S=l+((aa(a,B)|0)<<2)|0;o[S>>2]=P*R+Q*O;N=l+((aa(N,B)|0)<<2)|0;o[N>>2]=R*Q-P*O;a=a+2|0}while((a|0)<=(x|0))}}else if(!y){a=1;do{S=n+((aa(a,z)|0)<<2)|0;Q=+o[S>>2];S=m+((aa(a,A)|0)<<2)|0;O=+o[S>>2];S=a+1|0;N=n+((aa(S,z)|0)<<2)|0;P=+o[N>>2];N=m+((aa(S,A)|0)<<2)|0;R=+o[N>>2];N=l+((aa(a,B)|0)<<2)|0;o[N>>2]=Q*O-P*R;S=l+((aa(S,B)|0)<<2)|0;o[S>>2]=O*P+Q*R;a=a+2|0}while((a|0)<=(x|0))}g=b?l+(s<<2)|0:g;h=b?m+(s<<2)|0:h;j=b?n+(s<<2)|0:j;q=q+1|0}while((q|0)<(t|0))}else f=C+-1|0;if(C|0){l=(H|0)<(G|0);if(!(D&E))while(1){if(e){if(l){a=H;do{Q=+o[j+(a<<2)>>2];O=+o[h+(a<<2)>>2];S=a+1|0;P=+o[j+(S<<2)>>2];R=+o[h+(S<<2)>>2];o[g+(a<<2)>>2]=Q*O+P*R;o[g+(S<<2)>>2]=O*P-Q*R;a=a+2|0}while((a|0)<(G|0))}}else if(l){a=H;do{Q=+o[j+(a<<2)>>2];O=+o[h+(a<<2)>>2];S=a+1|0;P=+o[j+(S<<2)>>2];R=+o[h+(S<<2)>>2];o[g+(a<<2)>>2]=Q*O-P*R;o[g+(S<<2)>>2]=O*P+Q*R;a=a+2|0}while((a|0)<(G|0))}if(!f)break a;else{j=j+(z<<2)|0;h=h+(A<<2)|0;g=g+(B<<2)|0;f=f+-1|0}}while(1){o[g>>2]=+o[j>>2]*+o[h>>2];if(F)o[g+(G<<2)>>2]=+o[j+(G<<2)>>2]*+o[h+(G<<2)>>2];if(e){if(l){a=H;do{Q=+o[j+(a<<2)>>2];O=+o[h+(a<<2)>>2];S=a+1|0;P=+o[j+(S<<2)>>2];R=+o[h+(S<<2)>>2];o[g+(a<<2)>>2]=Q*O+P*R;o[g+(S<<2)>>2]=O*P-Q*R;a=a+2|0}while((a|0)<(G|0))}}else if(l){a=H;do{Q=+o[j+(a<<2)>>2];O=+o[h+(a<<2)>>2];S=a+1|0;P=+o[j+(S<<2)>>2];R=+o[h+(S<<2)>>2];o[g+(a<<2)>>2]=Q*O-P*R;o[g+(S<<2)>>2]=O*P+Q*R;a=a+2|0}while((a|0)<(G|0))}if(!f)break;else{j=j+(z<<2)|0;h=h+(A<<2)|0;g=g+(B<<2)|0;f=f+-1|0}}}}else{h=k[K+16>>2]|0;a=k[J+16>>2]|0;y=(k[L+48>>2]|0)>>>3;z=(k[K+48>>2]|0)>>>3;A=(k[J+48>>2]|0)>>>3;if(D&l){w=f|0?1:2;c=m+-1|0;f=C+-1|0;s=aa(A,f)|0;t=aa(z,f)|0;u=aa(y,f)|0;d=C+-2|0;x=(d|0)<1;v=1-m|0;if(!(C&1)){g=j;q=0;do{b=(q|0)==1;l=b?g+(c<<3)|0:g;m=b?h+(c<<3)|0:h;n=b?a+(c<<3)|0:a;p[n>>3]=+p[l>>3]*+p[m>>3];p[n+(s<<3)>>3]=+p[l+(u<<3)>>3]*+p[m+(t<<3)>>3];if(e){if(!x){j=1;do{S=l+((aa(j,y)|0)<<3)|0;Q=+p[S>>3];S=m+((aa(j,z)|0)<<3)|0;O=+p[S>>3];S=j+1|0;N=l+((aa(S,y)|0)<<3)|0;P=+p[N>>3];N=m+((aa(S,z)|0)<<3)|0;R=+p[N>>3];N=n+((aa(j,A)|0)<<3)|0;p[N>>3]=Q*O+P*R;S=n+((aa(S,A)|0)<<3)|0;p[S>>3]=O*P-Q*R;j=j+2|0}while((j|0)<=(d|0))}}else if(!x){j=1;do{S=l+((aa(j,y)|0)<<3)|0;Q=+p[S>>3];S=m+((aa(j,z)|0)<<3)|0;O=+p[S>>3];S=j+1|0;N=l+((aa(S,y)|0)<<3)|0;P=+p[N>>3];N=m+((aa(S,z)|0)<<3)|0;R=+p[N>>3];N=n+((aa(j,A)|0)<<3)|0;p[N>>3]=Q*O-P*R;S=n+((aa(S,A)|0)<<3)|0;p[S>>3]=O*P+Q*R;j=j+2|0}while((j|0)<=(d|0))}g=b?l+(v<<3)|0:g;h=b?m+(v<<3)|0:h;a=b?n+(v<<3)|0:a;q=q+1|0}while((q|0)<(w|0))}else{g=j;q=0;do{b=(q|0)==1;l=b?g+(c<<3)|0:g;m=b?h+(c<<3)|0:h;n=b?a+(c<<3)|0:a;p[n>>3]=+p[l>>3]*+p[m>>3];if(e){if(!x){j=1;do{S=l+((aa(j,y)|0)<<3)|0;Q=+p[S>>3];S=m+((aa(j,z)|0)<<3)|0;O=+p[S>>3];S=j+1|0;N=l+((aa(S,y)|0)<<3)|0;P=+p[N>>3];N=m+((aa(S,z)|0)<<3)|0;R=+p[N>>3];N=n+((aa(j,A)|0)<<3)|0;p[N>>3]=Q*O+P*R;S=n+((aa(S,A)|0)<<3)|0;p[S>>3]=O*P-Q*R;j=j+2|0}while((j|0)<=(d|0))}}else if(!x){j=1;do{S=l+((aa(j,y)|0)<<3)|0;Q=+p[S>>3];S=m+((aa(j,z)|0)<<3)|0;O=+p[S>>3];S=j+1|0;N=l+((aa(S,y)|0)<<3)|0;P=+p[N>>3];N=m+((aa(S,z)|0)<<3)|0;R=+p[N>>3];N=n+((aa(j,A)|0)<<3)|0;p[N>>3]=Q*O-P*R;S=n+((aa(S,A)|0)<<3)|0;p[S>>3]=O*P+Q*R;j=j+2|0}while((j|0)<=(d|0))}g=b?l+(v<<3)|0:g;h=b?m+(v<<3)|0:h;a=b?n+(v<<3)|0:a;q=q+1|0}while((q|0)<(w|0))}}else{g=j;f=C+-1|0}if(C|0){l=(H|0)<(G|0);if(D&E)j=a;else{j=a;while(1){if(e){if(l){a=H;do{Q=+p[g+(a<<3)>>3];O=+p[h+(a<<3)>>3];S=a+1|0;P=+p[g+(S<<3)>>3];R=+p[h+(S<<3)>>3];p[j+(a<<3)>>3]=Q*O+P*R;p[j+(S<<3)>>3]=O*P-Q*R;a=a+2|0}while((a|0)<(G|0))}}else if(l){a=H;do{Q=+p[g+(a<<3)>>3];O=+p[h+(a<<3)>>3];S=a+1|0;P=+p[g+(S<<3)>>3];R=+p[h+(S<<3)>>3];p[j+(a<<3)>>3]=Q*O-P*R;p[j+(S<<3)>>3]=O*P+Q*R;a=a+2|0}while((a|0)<(G|0))}if(!f)break a;else{j=j+(A<<3)|0;h=h+(z<<3)|0;g=g+(y<<3)|0;f=f+-1|0}}}while(1){p[j>>3]=+p[g>>3]*+p[h>>3];if(F)p[j+(G<<3)>>3]=+p[g+(G<<3)>>3]*+p[h+(G<<3)>>3];if(e){if(l){a=H;do{Q=+p[g+(a<<3)>>3];O=+p[h+(a<<3)>>3];S=a+1|0;P=+p[g+(S<<3)>>3];R=+p[h+(S<<3)>>3];p[j+(a<<3)>>3]=Q*O+P*R;p[j+(S<<3)>>3]=O*P-Q*R;a=a+2|0}while((a|0)<(G|0))}}else if(l){a=H;do{Q=+p[g+(a<<3)>>3];O=+p[h+(a<<3)>>3];S=a+1|0;P=+p[g+(S<<3)>>3];R=+p[h+(S<<3)>>3];p[j+(a<<3)>>3]=Q*O-P*R;p[j+(S<<3)>>3]=O*P+Q*R;a=a+2|0}while((a|0)<(G|0))}if(!f)break;else{j=j+(A<<3)|0;h=h+(z<<3)|0;g=g+(y<<3)|0;f=f+-1|0}}}}while(0);g=J+36|0;a=k[g>>2]|0;if(a|0?(N=a+12|0,S=k[N>>2]|0,k[N>>2]=S+-1,(S|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[J+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;S=J+16|0;f=J+4|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[f>>2]|0)>0){g=k[J+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[J+44>>2]|0;if(!((a|0)==(J+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=K+36|0;a=k[g>>2]|0;if(a|0?(N=a+12|0,S=k[N>>2]|0,k[N>>2]=S+-1,(S|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[K+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;S=K+16|0;f=K+4|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[f>>2]|0)>0){g=k[K+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[K+44>>2]|0;if(!((a|0)==(K+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=L+36|0;a=k[g>>2]|0;if(a|0?(N=a+12|0,S=k[N>>2]|0,k[N>>2]=S+-1,(S|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[L+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;g=L+4|0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[g>>2]|0)>0){f=k[L+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[L+44>>2]|0;if((a|0)==(L+48|0)|(a|0)==0){r=M;return}ggb(k[a+-4>>2]|0);r=M;return}function sZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;qa=r;r=r+1360|0;pa=qa+1296|0;ha=qa+1240|0;ia=qa+1104|0;na=qa+64|0;ma=qa+8|0;ja=qa;ka=c&1;C=(ka|0)==0;do if((k[a>>2]&2031616|0)==65536){f=k[a+4>>2]|0;k[pa>>2]=k[f>>2];l=pa+4|0;a=f+4|0;k[l>>2]=k[a>>2];m=pa+8|0;k[m>>2]=k[f+8>>2];n=pa+12|0;k[n>>2]=k[f+12>>2];q=pa+16|0;k[q>>2]=k[f+16>>2];s=pa+20|0;k[s>>2]=k[f+20>>2];t=pa+24|0;k[t>>2]=k[f+24>>2];u=pa+28|0;k[u>>2]=k[f+28>>2];v=pa+32|0;k[v>>2]=k[f+32>>2];w=pa+36|0;d=k[f+36>>2]|0;k[w>>2]=d;e=pa+40|0;k[e>>2]=m;oa=pa+48|0;h=pa+44|0;k[h>>2]=oa;k[pa+52>>2]=0;k[oa>>2]=0;if(d|0){oa=d+12|0;k[oa>>2]=(k[oa>>2]|0)+1}if((k[a>>2]|0)<3){j=k[f+44>>2]|0;oa=k[h>>2]|0;k[oa>>2]=k[j>>2];k[oa+4>>2]=k[j+4>>2];oa=q;j=q;h=s;g=t;d=u;e=v;la=w;f=w;a=pa;break}k[l>>2]=0;x1(pa,k[a>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[j+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[l>>2]|0));oa=q;j=q;h=s;g=t;d=u;e=v;la=w;f=w;a=pa}else{oa=q;j=q;h=s;g=t;d=u;e=v;la=w;f=w;a=pa}}else{Q1(pa,a,-1);j=pa+16|0;f=pa+36|0;l=pa+4|0;m=pa+8|0;n=pa+12|0;oa=j;h=pa+20|0;g=pa+24|0;d=pa+28|0;e=pa+32|0;la=f;a=pa}while(0);k[ha>>2]=k[a>>2];fa=ha+4|0;a=k[l>>2]|0;k[fa>>2]=a;Y=ha+8|0;k[Y>>2]=k[m>>2];X=ha+12|0;k[X>>2]=k[n>>2];ea=ha+16|0;k[ea>>2]=k[j>>2];k[ha+20>>2]=k[h>>2];k[ha+24>>2]=k[g>>2];k[ha+28>>2]=k[d>>2];Z=ha+32|0;k[Z>>2]=k[e>>2];$=ha+36|0;d=k[f>>2]|0;k[$>>2]=d;_=ha+40|0;k[_>>2]=Y;ca=ha+48|0;ba=ha+44|0;k[ba>>2]=ca;k[ha+52>>2]=0;k[ca>>2]=0;if(d){a=d+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[l>>2]|0}do if((a|0)<3){da=k[pa+44>>2]|0;a=k[ba>>2]|0;k[a>>2]=k[da>>2];k[a+4>>2]=k[da+4>>2];a=k[fa>>2]|0;da=18}else{k[fa>>2]=0;x1(ha,k[pa+4>>2]|0,0,0,0);if((k[fa>>2]|0)<=0){e=k[ha>>2]|0;U=0;d=e&4095;e=e&7;break}e=k[pa+40>>2]|0;f=k[_>>2]|0;g=k[pa+44>>2]|0;h=k[ba>>2]|0;d=0;do{k[f+(d<<2)>>2]=k[e+(d<<2)>>2];k[h+(d<<2)>>2]=k[g+(d<<2)>>2];d=d+1|0;a=k[fa>>2]|0}while((d|0)<(a|0));da=18}while(0);if((da|0)==18){e=k[ha>>2]|0;d=e&4095;e=e&7;if((a|0)>0)U=k[(k[ba>>2]|0)+(a+-1<<2)>>2]|0;else U=0}S=U<<1;V=na+8|0;k[na>>2]=V;W=na+4|0;k[W>>2]=1032;if((d+-5|0)>>>0>=2){k[ma>>2]=0;a=ma+4|0;k[a>>2]=0;f=ZT(44)|0;k[f>>2]=1;g=f+4|0;k[ma>>2]=g;k[a>>2]=36;i[f+40>>0]=0;h=347219;j=g+36|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,ma,213266,212918,3603);k[a>>2]=0;k[ma>>2]=0;R=k[f>>2]|0;k[f>>2]=R+-1;if((R|0)==1)ggb(k[f+-4>>2]|0)}c2(b,k[Y>>2]|0,k[X>>2]|0,d,-1,0,0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[ma>>2]=k[g>>2];n=ma+4|0;a=g+4|0;k[n>>2]=k[a>>2];R=ma+8|0;k[R>>2]=k[g+8>>2];k[ma+12>>2]=k[g+12>>2];k[ma+16>>2]=k[g+16>>2];k[ma+20>>2]=k[g+20>>2];k[ma+24>>2]=k[g+24>>2];k[ma+28>>2]=k[g+28>>2];k[ma+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[ma+36>>2]=d;f=ma+40|0;k[f>>2]=R;R=ma+48|0;j=ma+44|0;k[j>>2]=R;k[ma+52>>2]=0;k[R>>2]=0;if(d|0){R=d+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[a>>2]|0)<3){P=k[g+44>>2]|0;R=k[j>>2]|0;k[R>>2]=k[P>>2];k[R+4>>2]=k[P+4>>2];break}k[n>>2]=0;x1(ma,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;d=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[m+(a<<2)>>2];k[d+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(ma,b,-1);while(0);O=k[41092+((((e|0)==6&1)<<1|ka)<<2)>>2]|0;N=(c&4|0)!=0;do if(N|(k[Y>>2]|0)==1){M=0;a=0}else{a=(k[X>>2]|0)==1;if((a?k[ha>>2]&16384|0:0)?k[ma>>2]&16384|0:0){M=0;a=0;break}M=1;a=a&1}while(0);P=ma+16|0;R=ma+48|0;J=S+4|0;K=S+32|0;L=(S|0)==16;F=C?2.0:1.0;G=ja+4|0;H=ma+8|0;I=ma+12|0;n=0;e=0;h=0;f=0;j=0;m=0;d=0;g=0;while(1){D=k[ea>>2]|0;E=k[P>>2]|0;if(!a){C=k[X>>2]|0;t=k[Y>>2]|0;s=(C|0)==1;u=U;v=k[R>>2]|0;w=U;b=k[ca>>2]|0;c=s?(N?t:1):t;C=s?(N?C:t):C}else{u=k[R>>2]|0;v=U;w=k[ca>>2]|0;b=U;c=k[I>>2]|0;C=k[H>>2]|0}a:do if((C|0)!=(n|0)){if(!((C|0)<2|(C&1|0)==0)){k[ja>>2]=0;k[G>>2]=0;d=ZT(40)|0;k[d>>2]=1;g=d+4|0;k[ja>>2]=g;k[G>>2]=34;i[d+38>>0]=0;h=213270;j=g+34|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-213,ja,213266,212918,3655);k[G>>2]=0;k[ja>>2]=0;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0)}t=aa(C,U)|0;m=aa(((C|0)/2|0)+1|0,S)|0;j=aa(C,J)|0;if((C|0)>=6){d=(C+-1^C)+1>>1;if((d|0)>1){k[ia>>2]=d;if((d|0)!=(C|0)?(ga=(C>>>0)/(d>>>0)|0,(ga|0)>1):0){d=3;f=ga;h=1;da=52}else g=1}else{d=3;f=C;h=0;da=52}b:do if((da|0)==52){c:while(1){da=0;while(1){e=(f|0)/(d|0)|0;if((aa(e,d)|0)==(f|0))break;d=d+2|0;if((aa(d,d)|0)>(f|0))break c}g=h+1|0;k[ia+(h<<2)>>2]=d;if((e|0)>1){f=e;h=g;da=52}else break b}k[ia+(h<<2)>>2]=f;g=h+1|0}while(0);d=k[ia>>2]|0;e=d&1^1;h=(e+g|0)/2|0;if((e|0)<(h|0)){f=g+-1+e|0;d=e;do{n=ia+(d<<2)|0;q=k[n>>2]|0;s=ia+(f-d<<2)|0;k[n>>2]=k[s>>2];k[s>>2]=q;d=d+1|0}while((d|0)!=(h|0));d=k[ia>>2]|0}}else{k[ia>>2]=C;g=1;d=C}q=(d|0)==(k[ia+(g+-1<<2)>>2]|0);s=k[ia+(((g|0)>1&(d&1|0)==0&1)<<2)>>2]|0;e=aa(s+1|0,S)|0;e=K+j+t+m+(q?0:t)+((s|0)>5&(s&1|0)!=0?e:0)|0;if((k[W>>2]|0)>>>0<e>>>0){d=k[na>>2]|0;if((d|0)!=(V|0)){if(d|0)ggb(d);k[na>>2]=V;k[W>>2]=1032}if(e>>>0>1032){while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[na>>2]=d;k[W>>2]=e}}else k[W>>2]=e;j=k[na>>2]|0;h=j+(aa(C,S)|0)|0;n=h+(C<<2)+15&-16;f=n;cZ(C,g,ia,h,S,j,ka);s=f+m|0;e=s+t|0;m=q?s:e;e=q?e:e+t|0;if((C|0)!=1){if(!(C+-1&C)){d=0;while(1)if(1<<d>>>0<C>>>0)d=d+1|0;else break;t=d+2|0;x=+p[11104+(d<<3)>>3];A=+p[10592+(t<<4)>>3];B=-+p[10592+(t<<4)+8>>3]}else{x=1.0/+(C<<1|0);B=+T(+(x*-3.141592653589793));x=+Q(+x);A=+Q(+(1.0-B*B))}x=F*x;q=C>>1;if(L){if((q|0)<0){n=C;q=s;break}else{d=0;y=0.0}while(1){p[n+(d<<4)>>3]=x;p[n+(d<<4)+8>>3]=y;z=A*y+B*x;if((d|0)==(q|0)){n=C;q=s;break a}else{d=d+1|0;x=A*x-B*y;y=z}}}if((q|0)<0){n=C;q=s}else{d=0;y=0.0;while(1){o[n+(d<<3)>>2]=x;o[n+(d<<3)+4>>2]=y;z=A*y+B*x;if((d|0)==(q|0)){n=C;q=s;break}else{d=d+1|0;x=A*x-B*y;y=z}}}}else{n=1;q=s}}else q=d;while(0);if((c|0)>0){d=0;do{s=D+(aa(d,b)|0)|0;t=E+(aa(d,v)|0)|0;ji[O&7](s,w,q,m,t,u,C,g,ia,h,j,f,0,e);d=d+1|0}while((d|0)<(c|0))}KG(ha,ma)|0;if((a|0)<(M|0)){d=q;a=a+1|0}else break}e=ma+36|0;a=k[e>>2]|0;if(a|0?(ja=a+12|0,ka=k[ja>>2]|0,k[ja>>2]=ka+-1,(ka|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[ma+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;e=ma+4|0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[e>>2]|0)>0){d=k[ma+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[ma+44>>2]|0;if(!((a|0)==(R|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[na>>2]|0;if((a|0)!=(V|0)){if(a|0)ggb(a);k[na>>2]=V;k[W>>2]=1032}a=k[$>>2]|0;if(a|0?(ma=a+12|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){d=k[$>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[Z>>2]|0;if(!a){a=B1()|0;d=k[$>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[$>>2]=0}k[$>>2]=0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[fa>>2]|0)>0){d=k[_>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[fa>>2]|0))}a=k[ba>>2]|0;if(!((a|0)==(ca|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[la>>2]|0;if(a|0?(ma=a+12|0,na=k[ma>>2]|0,k[ma>>2]=na+-1,(na|0)==1):0){e=pa+36|0;d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;do if(!a){a=k[pa+32>>2]|0;if(a|0)break;a=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[la>>2]=0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[l>>2]|0)>0){d=k[pa+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[pa+44>>2]|0;if((a|0)==(pa+48|0)|(a|0)==0){r=qa;return}ggb(k[a+-4>>2]|0);r=qa;return}function tZ(a,b,c,d,e,f,g,h,i,j,l,m,n,p){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;l=l|0;m=m|0;n=n|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0;u=g>>1;r=b>>>2;s=f>>>2;t=g+-1|0;q=e+((aa(t,s)|0)<<2)|0;if((g|0)==1){k[e>>2]=k[a>>2];return}if((u|0)>0){f=r<<1;n=a;b=0;while(1){k[c+(b<<2)>>2]=k[n>>2];k[c+(t-b<<2)>>2]=k[n+(r<<2)>>2];b=b+1|0;if((b|0)==(u|0))break;else n=n+(f<<2)|0}}qZ(c,d,g,h,i,j,l,g,p,0,1.0);o[e>>2]=+o[d>>2]*+o[m>>2]*.7071067690849304;n=e+(s<<2)|0;if((u|0)>1){a=0-s|0;b=1;f=m;while(1){i=f;f=f+8|0;w=+o[f>>2];j=b<<1;y=+o[d+(j+-1<<2)>>2];x=+o[i+12>>2];v=+o[d+(j<<2)>>2];o[n>>2]=w*y-x*v;o[q>>2]=-(y*x)-w*v;b=b+1|0;if((b|0)==(u|0))break;else{q=q+(a<<2)|0;n=n+(s<<2)|0}}n=e+((aa(u,s)|0)<<2)|0;m=m+(u+-1<<3)|0}o[n>>2]=+o[d+(t<<2)>>2]*+o[m+8>>2];return}function uZ(a,b,c,d,e,f,g,h,i,j,l,m,n,p){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;l=l|0;m=m|0;n=n|0;p=p|0;var q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;w=g>>1;t=b>>>2;u=f>>>2;v=g+-1|0;q=+o[a>>2];if((g|0)==1){o[e>>2]=q;return}o[c>>2]=q*2.0*+o[m>>2]*.7071067690849304;b=a+(t<<2)|0;if((w|0)>1){s=0-t|0;f=a+((aa(v,t)|0)<<2)|0;r=1;n=m;while(1){x=n;n=n+8|0;y=+o[n>>2];A=+o[b>>2];z=+o[x+12>>2];q=+o[f>>2];x=r<<1;o[c+(x+-1<<2)>>2]=y*A-z*q;o[c+(x<<2)>>2]=-(A*z)-y*q;r=r+1|0;if((r|0)==(w|0))break;else{f=f+(s<<2)|0;b=b+(t<<2)|0}}b=a+((aa(w,t)|0)<<2)|0;n=m+(w+-1<<3)|0}else n=m;o[c+(v<<2)>>2]=+o[b>>2]*2.0*+o[n+8>>2];oZ(c,d,g,h,i,j,l,g,p,0,1.0);if((w|0)<=0)return;b=u<<1;n=0;while(1){k[e>>2]=k[d+(n<<2)>>2];k[e+(u<<2)>>2]=k[d+(v-n<<2)>>2];n=n+1|0;if((n|0)==(w|0))break;else e=e+(b<<2)|0}return}function vZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0;t=g>>1;q=b>>>3;r=f>>>3;s=g+-1|0;o=e+((aa(s,r)|0)<<3)|0;if((g|0)==1){p[e>>3]=+p[a>>3];return}if((t|0)>0){f=q<<1;m=a;b=0;while(1){p[c+(b<<3)>>3]=+p[m>>3];p[c+(s-b<<3)>>3]=+p[m+(q<<3)>>3];b=b+1|0;if((b|0)==(t|0))break;else m=m+(f<<3)|0}}nZ(c,d,g,h,i,j,k,g,n,0,1.0);p[e>>3]=+p[d>>3]*+p[l>>3]*.7071067811865476;m=e+(r<<3)|0;if((t|0)>1){a=0-r|0;b=1;f=l;while(1){i=f;f=f+16|0;v=+p[f>>3];j=b<<1;x=+p[d+(j+-1<<3)>>3];w=+p[i+24>>3];u=+p[d+(j<<3)>>3];p[m>>3]=v*x-w*u;p[o>>3]=-(x*w)-v*u;b=b+1|0;if((b|0)==(t|0))break;else{o=o+(a<<3)|0;m=m+(r<<3)|0}}m=e+((aa(t,r)|0)<<3)|0;l=l+(t+-1<<4)|0}p[m>>3]=+p[d+(s<<3)>>3]*+p[l+16>>3];return}function wZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;v=g>>1;s=b>>>3;t=f>>>3;u=g+-1|0;o=+p[a>>3];if((g|0)==1){p[e>>3]=o;return}p[c>>3]=o*2.0*+p[l>>3]*.7071067811865476;b=a+(s<<3)|0;if((v|0)>1){r=0-s|0;f=a+((aa(u,s)|0)<<3)|0;q=1;m=l;while(1){w=m;m=m+16|0;x=+p[m>>3];z=+p[b>>3];y=+p[w+24>>3];o=+p[f>>3];w=q<<1;p[c+(w+-1<<3)>>3]=x*z-y*o;p[c+(w<<3)>>3]=-(z*y)-x*o;q=q+1|0;if((q|0)==(v|0))break;else{f=f+(r<<3)|0;b=b+(s<<3)|0}}b=a+((aa(v,s)|0)<<3)|0;m=l+(v+-1<<4)|0}else m=l;p[c+(u<<3)>>3]=+p[b>>3]*2.0*+p[m+16>>3];lZ(c,d,g,h,i,j,k,g,n,0,1.0);if((v|0)<=0)return;b=t<<1;m=0;while(1){p[e>>3]=+p[d+(m<<3)>>3];p[e+(t<<3)>>3]=+p[d+(u-m<<3)>>3];m=m+1|0;if((m|0)==(v|0))break;else e=e+(b<<3)|0}return}function xZ(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0.0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0.0,Sb=0;Sb=r;r=r+512|0;Bb=Sb;Cb=Sb+448|0;Qb=Sb+392|0;Pb=Sb+336|0;Lb=Sb+280|0;Kb=Sb+224|0;Fb=Sb+168|0;Eb=Sb+112|0;Db=Sb+56|0;Ab=Sb+32|0;do if((k[a>>2]&2031616|0)==65536){s=k[a+4>>2]|0;k[Qb>>2]=k[s>>2];x=Qb+4|0;m=s+4|0;k[x>>2]=k[m>>2];a=Qb+8|0;k[a>>2]=k[s+8>>2];l=Qb+12|0;k[l>>2]=k[s+12>>2];k[Qb+16>>2]=k[s+16>>2];k[Qb+20>>2]=k[s+20>>2];k[Qb+24>>2]=k[s+24>>2];k[Qb+28>>2]=k[s+28>>2];k[Qb+32>>2]=k[s+32>>2];n=k[s+36>>2]|0;k[Qb+36>>2]=n;q=Qb+40|0;k[q>>2]=a;Ob=Qb+48|0;v=Qb+44|0;k[v>>2]=Ob;k[Qb+52>>2]=0;k[Ob>>2]=0;if(n|0){Ob=n+12|0;k[Ob>>2]=(k[Ob>>2]|0)+1}if((k[m>>2]|0)<3){Ob=k[s+44>>2]|0;m=k[v>>2]|0;k[m>>2]=k[Ob>>2];k[m+4>>2]=k[Ob+4>>2];m=Qb;break}k[x>>2]=0;x1(Qb,k[m>>2]|0,0,0,0);if((k[x>>2]|0)>0){w=k[s+40>>2]|0;t=k[q>>2]|0;q=k[s+44>>2]|0;n=k[v>>2]|0;m=0;do{k[t+(m<<2)>>2]=k[w+(m<<2)>>2];k[n+(m<<2)>>2]=k[q+(m<<2)>>2];m=m+1|0}while((m|0)<(k[x>>2]|0));m=Qb}else m=Qb}else{Q1(Qb,a,-1);l=Qb+12|0;m=Qb;x=Qb+4|0;a=Qb+8|0}while(0);wb=k[a>>2]|0;n=(wb|0)==1;F=k[l>>2]|0;wb=n?F:wb;F=n?1:F;D=k[m>>2]|0;E=(D>>>3&511)+1|0;ub=aa(E,F)|0;D=D&7;G=(g|0)<1;vb=(b|0)>0;if(!(vb&((k[x>>2]|0)<3&(D|0)==5))){k[Bb>>2]=0;a=Bb+4|0;k[a>>2]=0;l=ZT(48)|0;k[l>>2]=1;t=l+4|0;k[Bb>>2]=t;k[a>>2]=42;i[l+46>>0]=0;s=213305;v=t+42|0;do{i[t>>0]=i[s>>0]|0;t=t+1|0;s=s+1|0}while((t|0)<(v|0));Y8(-215,Bb,213348,213355,230);k[a>>2]=0;k[Bb>>2]=0;Ob=k[l>>2]|0;k[l>>2]=Ob+-1;if((Ob|0)==1)ggb(k[l+-4>>2]|0)}if((wb|0)<(b|0)?(k[Bb>>2]=0,Ob=Bb+4|0,k[Ob>>2]=0,y=ZT(12)|0,k[y>>2]=1,Nb=y+4|0,k[Bb>>2]=Nb,k[Ob>>2]=6,i[y+10>>0]=0,i[Nb>>0]=i[213420]|0,i[Nb+1>>0]=i[213421]|0,i[Nb+2>>0]=i[213422]|0,i[Nb+3>>0]=i[213423]|0,i[Nb+4>>0]=i[213424]|0,i[Nb+5>>0]=i[213425]|0,Y8(-215,Bb,213348,213355,231),k[Ob>>2]=0,k[Bb>>2]=0,Ob=k[y>>2]|0,k[y>>2]=Ob+-1,(Ob|0)==1):0)ggb(k[y+-4>>2]|0);Mb=Qb+16|0;Nb=Qb+44|0;Ob=Qb+48|0;JN(Pb,wb,ub,5,k[Mb>>2]|0,n?ub<<2:k[Ob>>2]|0);k[Bb>>2]=wb;k[Bb+4>>2]=1;P1(c,2,Bb,4,-1,1,0);k[Lb>>2]=1124007936;Hb=Lb+4|0;z=Lb+8|0;Gb=Lb+40|0;t=Hb;v=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(v|0));k[Gb>>2]=z;Jb=Lb+48|0;Ib=Lb+44|0;k[Ib>>2]=Jb;k[Lb+52>>2]=0;k[Jb>>2]=0;do if((k[c>>2]&2031616|0)==65536){s=k[c+4>>2]|0;k[Kb>>2]=k[s>>2];y=Kb+4|0;m=s+4|0;k[y>>2]=k[m>>2];l=Kb+8|0;k[l>>2]=k[s+8>>2];a=Kb+12|0;k[a>>2]=k[s+12>>2];k[Kb+16>>2]=k[s+16>>2];k[Kb+20>>2]=k[s+20>>2];k[Kb+24>>2]=k[s+24>>2];k[Kb+28>>2]=k[s+28>>2];k[Kb+32>>2]=k[s+32>>2];n=k[s+36>>2]|0;k[Kb+36>>2]=n;q=Kb+40|0;k[q>>2]=l;zb=Kb+48|0;v=Kb+44|0;k[v>>2]=zb;k[Kb+52>>2]=0;k[zb>>2]=0;if(n|0){zb=n+12|0;k[zb>>2]=(k[zb>>2]|0)+1}if((k[m>>2]|0)<3){yb=k[s+44>>2]|0;zb=k[v>>2]|0;k[zb>>2]=k[yb>>2];k[zb+4>>2]=k[yb+4>>2];break}k[y>>2]=0;x1(Kb,k[m>>2]|0,0,0,0);if((k[y>>2]|0)>0){w=k[s+40>>2]|0;t=k[q>>2]|0;q=k[s+44>>2]|0;n=k[v>>2]|0;m=0;do{k[t+(m<<2)>>2]=k[w+(m<<2)>>2];k[n+(m<<2)>>2]=k[q+(m<<2)>>2];m=m+1|0}while((m|0)<(k[y>>2]|0))}}else{Q1(Kb,c,-1);l=Kb+8|0;a=Kb+12|0}while(0);lb=(h&1|0)!=0;n=k[a>>2]|0;m=(n|0)==1;a=k[l>>2]|0;do if(lb){if(!m)if((a|0)==1){a=1;kb=30}else kb=32;else kb=30;if((kb|0)==30)if(!((aa(a,n)|0)==(wb|0)?(k[Kb>>2]&20479|0)==16388:0))kb=32;if((kb|0)==32?(k[Bb>>2]=0,zb=Bb+4|0,k[zb>>2]=0,A=ZT(160)|0,k[A>>2]=1,yb=A+4|0,k[Bb>>2]=yb,k[zb>>2]=152,i[A+156>>0]=0,upb(yb|0,213427,152)|0,Y8(-215,Bb,213348,213355,243),k[zb>>2]=0,k[Bb>>2]=0,zb=k[A>>2]|0,k[A>>2]=zb+-1,(zb|0)==1):0)ggb(k[A+-4>>2]|0);zb=Bb+4|0;yb=zb+4|0;k[yb>>2]=0;k[yb+4>>2]=0;k[Bb>>2]=33619968;k[zb>>2]=Lb;mY(Kb,Bb)}else{if(!m)if((a|0)==1){a=1;kb=38}else kb=43;else kb=38;do if((kb|0)==38){if((aa(a,n)|0)==(wb|0)?(B=k[Kb>>2]|0,(B&20479|0)==16388):0){a=B;break}if(((k[Kb+4>>2]|0)<3&((a|0)==(wb|0)&m)?(C=k[Kb>>2]|0,(C&4095|0)==4):0)?(k[Kb+16>>2]|0)!=0:0)a=C;else kb=43}while(0);if((kb|0)==43){k[Bb>>2]=wb;k[Bb+4>>2]=1;G1(Kb,2,Bb,4);a=k[Kb>>2]|0}m=k[Kb+40>>2]|0;l=k[m+4>>2]|0;m=k[m>>2]|0;a=a&4095;if(((((k[Hb>>2]|0)<3?(k[z>>2]|0)==(m|0):0)?(k[Lb+12>>2]|0)==(l|0):0)?(k[Lb>>2]&4095|0)==(a|0):0)?k[Lb+16>>2]|0:0)break;k[Bb>>2]=m;k[Bb+4>>2]=l;G1(Lb,2,Bb,a)}while(0);zb=Lb+16|0;ab=k[zb>>2]|0;k[Fb>>2]=1124007936;rb=Fb+4|0;bb=Fb+8|0;qb=Fb+40|0;t=rb;v=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(v|0));k[qb>>2]=bb;tb=Fb+48|0;sb=Fb+44|0;k[sb>>2]=tb;cb=Fb+52|0;k[cb>>2]=0;k[tb>>2]=0;k[Bb>>2]=b;db=Bb+4|0;k[db>>2]=ub;G1(Fb,2,Bb,D);k[Eb>>2]=1124007936;nb=Eb+4|0;eb=Eb+8|0;mb=Eb+40|0;t=nb;v=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(v|0));k[mb>>2]=eb;pb=Eb+48|0;ob=Eb+44|0;k[ob>>2]=pb;fb=Eb+52|0;k[fb>>2]=0;k[pb>>2]=0;k[Bb>>2]=b;k[db>>2]=ub;G1(Eb,2,Bb,D);k[Db>>2]=1124007936;ib=Db+4|0;a=Db+8|0;gb=Db+40|0;t=ib;v=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(v|0));k[gb>>2]=a;jb=Db+48|0;hb=Db+44|0;k[hb>>2]=jb;k[Db+52>>2]=0;k[jb>>2]=0;k[Bb>>2]=1;k[db>>2]=ub;G1(Db,2,Bb,D);$a=(b|0)==0;if($a)a=0;else{if(b>>>0>1073741823)ad(426534,426557,304,426811);m=b<<2;l=(m|0)==0?1:m;while(1){a=fgb(l)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}zpb(a|0,0,m|0)|0}if(!ub){_a=0;n=0;s=0}else{if(ub>>>0>536870911)ad(426534,426557,304,426811);m=ub<<3;m=(m|0)==0?1:m;while(1){l=fgb(m)|0;if(l|0){q=l;break}l=k[207666]|0;k[207666]=l+0;if(!l){q=0;break}Qh[l&7]()}n=q+((aa(F,E)|0)<<3)|0;l=ub;m=q;while(1){yb=m;k[yb>>2]=0;k[yb+4>>2]=0;l=l+-1|0;if(!l)break;else m=m+8|0}_a=q;s=q}Za=n9(c9()|0)|0;Ya=(d&2|0)==0?1.1920928955078125e-07:f<0.0?0.0:f;Ya=Ya*Ya;if(!(d&1))l=100;else{l=(e|0)<2?2:e;l=(l|0)>100?100:l}Va=(b|0)==1;Xa=Va?2:l;Va=Va|G?1:g;xb=Pb+16|0;m=k[xb>>2]|0;yb=Pb+44|0;Wa=(ub|0)>0;if(Wa){l=0;do{Ua=k[m+(l<<2)>>2]|0;k[s+(l<<3)>>2]=Ua;k[s+(l<<3)+4>>2]=Ua;l=l+1|0}while((l|0)!=(ub|0))}if((wb|0)>1?(L=k[xb>>2]|0,M=k[k[yb>>2]>>2]|0,Wa):0){l=1;do{q=L+(aa(M,l)|0)|0;m=0;do{Ta=k[q+(m<<2)>>2]|0;k[Bb>>2]=Ta;Ua=s+(m<<3)|0;T=(k[u>>2]=Ta,+o[u>>2]);k[Ua>>2]=k[(T<+o[Ua>>2]?Bb:Ua)>>2];Ua=s+(m<<3)+4|0;k[Ua>>2]=k[(+o[Ua>>2]<T?Bb:Ua)>>2];m=m+1|0}while((m|0)!=(ub|0));l=l+1|0}while((l|0)!=(wb|0))}a:do if((Va|0)>0){X=(h&2|0)==0;Y=Fb+16|0;Z=Pb+12|0;_=Pb+8|0;$=Pb+48|0;ba=(b|0)>1;ca=Bb+4|0;da=Cb+4|0;ea=Cb+8|0;fa=Cb+12|0;ga=Cb+16|0;ha=Cb+20|0;ia=Cb+24|0;ja=Cb+4|0;ka=Cb+8|0;la=Cb+40|0;ma=Cb+48|0;na=Cb+44|0;oa=Cb+52|0;pa=Cb+16|0;qa=Bb+4|0;ra=Ab+4|0;sa=Ab+8|0;ta=Ab+12|0;ua=Ab+16|0;va=(wb|0)>0;wa=Cb+36|0;V=lb^1;xa=ub+-4|0;ya=(ub|0)<4;za=Db+16|0;Aa=Bb+4|0;Ba=Eb+16|0;Ca=Bb+4|0;Da=Bb+4|0;Ea=Da+4|0;Fa=b<<2;Ga=ub&-4;W=(wb|0)<1;Ha=(Ga|0)<(ub|0);Ia=Fb+12|0;Ja=Eb+12|0;Ka=Fb+20|0;La=Eb+20|0;Ma=Fb+24|0;Na=Eb+24|0;Oa=Fb+28|0;Pa=Eb+28|0;Qa=Fb+32|0;Ra=Eb+32|0;Sa=Fb+36|0;Ta=Eb+36|0;Ua=Cb+32|0;P=n-_a>>3;Q=1.0/+(P>>>0);R=(P|0)==0;S=_a;T=Q*2.0+1.0;U=b>>>0>1073741823;M=(Fa|0)==0?1:Fa;f=1797693134862315708145274.0e284;H=0.0;h=0;b:while(1){L=lb&(h|0)<1;g=0;I=1797693134862315708145274.0e284;while(1){m=k[Fb>>2]|0;k[Fb>>2]=k[Eb>>2];k[Eb>>2]=m;m=k[rb>>2]|0;k[rb>>2]=k[nb>>2];k[nb>>2]=m;m=k[bb>>2]|0;k[bb>>2]=k[eb>>2];k[eb>>2]=m;m=k[Ia>>2]|0;k[Ia>>2]=k[Ja>>2];k[Ja>>2]=m;m=k[Y>>2]|0;v=k[Ba>>2]|0;k[Y>>2]=v;k[Ba>>2]=m;m=k[Ka>>2]|0;k[Ka>>2]=k[La>>2];k[La>>2]=m;m=k[Ma>>2]|0;k[Ma>>2]=k[Na>>2];k[Na>>2]=m;m=k[Oa>>2]|0;k[Oa>>2]=k[Pa>>2];k[Pa>>2]=m;m=k[Qa>>2]|0;k[Qa>>2]=k[Ra>>2];k[Ra>>2]=m;m=k[Sa>>2]|0;k[Sa>>2]=k[Ta>>2];k[Ta>>2]=m;m=k[qb>>2]|0;k[qb>>2]=k[mb>>2];k[mb>>2]=m;m=k[sb>>2]|0;l=k[ob>>2]|0;k[sb>>2]=l;k[ob>>2]=m;e=k[tb>>2]|0;k[tb>>2]=k[pb>>2];k[pb>>2]=e;e=k[cb>>2]|0;k[cb>>2]=k[fb>>2];k[fb>>2]=e;if((l|0)==(pb|0)){k[sb>>2]=tb;k[qb>>2]=bb;l=tb}if((m|0)==(tb|0)){k[ob>>2]=pb;k[mb>>2]=eb}c:do if((g|0)!=0|L){if(!((g|h|0)!=0|V|W)){l=0;do{if((k[ab+(l<<2)>>2]|0)>>>0>=b>>>0){k[Bb>>2]=0;k[Ca>>2]=0;m=ZT(40)|0;k[m>>2]=1;t=m+4|0;k[Bb>>2]=t;k[Ca>>2]=33;i[m+37>>0]=0;s=213580;v=t+33|0;do{i[t>>0]=i[s>>0]|0;t=t+1|0;s=s+1|0}while((t|0)<(v|0));Y8(-215,Bb,213348,213355,319);k[Ca>>2]=0;k[Bb>>2]=0;e=k[m>>2]|0;k[m>>2]=e+-1;if((e|0)==1)ggb(k[m+-4>>2]|0)}l=l+1|0}while((l|0)<(wb|0))};k[Bb>>2]=0;k[Bb+4>>2]=0;k[Bb+8>>2]=0;k[Bb+12>>2]=0;k[Bb+16>>2]=0;k[Bb+20>>2]=0;k[Bb+24>>2]=0;k[Bb+28>>2]=0;oY(Fb,Bb);if(vb)zpb(a|0,0,Fa|0)|0;d:do if(va){t=k[xb>>2]|0;v=k[yb>>2]|0;w=k[Y>>2]|0;y=k[sb>>2]|0;if(ya){l=0;while(1){n=t+(aa(k[v>>2]|0,l)|0)|0;q=k[ab+(l<<2)>>2]|0;s=w+(aa(k[y>>2]|0,q)|0)|0;if(Wa){m=0;do{e=s+(m<<2)|0;o[e>>2]=+o[n+(m<<2)>>2]+ +o[e>>2];m=m+1|0}while((m|0)!=(ub|0))}e=a+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+1;l=l+1|0;if((l|0)==(wb|0))break d}}else m=0;do{n=t+(aa(k[v>>2]|0,m)|0)|0;q=k[ab+(m<<2)>>2]|0;s=w+(aa(k[y>>2]|0,q)|0)|0;l=0;do{d=s+(l<<2)|0;F=l|1;G=s+(F<<2)|0;O=+o[G>>2]+ +o[n+(F<<2)>>2];o[d>>2]=+o[d>>2]+ +o[n+(l<<2)>>2];o[G>>2]=O;G=l|2;d=s+(G<<2)|0;F=l|3;e=s+(F<<2)|0;O=+o[e>>2]+ +o[n+(F<<2)>>2];o[d>>2]=+o[d>>2]+ +o[n+(G<<2)>>2];o[e>>2]=O;l=l+4|0}while((l|0)<=(xa|0));if(Ha){l=Ga;do{e=s+(l<<2)|0;o[e>>2]=+o[n+(l<<2)>>2]+ +o[e>>2];l=l+1|0}while((l|0)!=(ub|0))}e=a+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+1;m=m+1|0}while((m|0)!=(wb|0))}while(0);F=(g|0)>0;I=F?0.0:I;if(!vb)break;A=k[Y>>2]|0;B=k[sb>>2]|0;C=k[za>>2]|0;D=k[xb>>2]|0;E=k[yb>>2]|0;z=0;do{c=a+(z<<2)|0;do if(!(k[c>>2]|0)){if(ba){m=1;l=0;do{l=(k[a+(l<<2)>>2]|0)<(k[a+(m<<2)>>2]|0)?m:l;m=m+1|0}while((m|0)!=(b|0))}else l=0;y=k[B>>2]|0;w=A+(aa(y,z)|0)|0;y=A+(aa(y,l)|0)|0;t=a+(l<<2)|0;v=k[t>>2]|0;J=1.0/+(v|0);if(Wa){m=0;do{o[C+(m<<2)>>2]=J*+o[y+(m<<2)>>2];m=m+1|0}while((m|0)!=(ub|0))}e:do if(va){if(Wa){m=-1;J=0.0;s=0}else{m=-1;n=0;while(1){m=(k[ab+(n<<2)>>2]|0)==(l|0)?n:m;n=n+1|0;if((n|0)==(wb|0)){l=m;break e}}}do{if((k[ab+(s<<2)>>2]|0)==(l|0)){q=D+(aa(k[E>>2]|0,s)|0)|0;n=0;K=0.0;do{O=+o[q+(n<<2)>>2]-+o[C+(n<<2)>>2];K=K+O*O;n=n+1|0}while((n|0)!=(ub|0));O=K;e=!(J<=O);m=e?m:s;J=e?J:O}s=s+1|0}while((s|0)!=(wb|0));l=m}else l=-1;while(0);k[t>>2]=v+-1;k[c>>2]=(k[c>>2]|0)+1;k[ab+(l<<2)>>2]=z;m=D+(aa(k[E>>2]|0,l)|0)|0;if(Wa)l=0;else break;do{d=m+(l<<2)|0;e=y+(l<<2)|0;o[e>>2]=+o[e>>2]-+o[d>>2];e=w+(l<<2)|0;o[e>>2]=+o[d>>2]+ +o[e>>2];l=l+1|0}while((l|0)!=(ub|0))}while(0);z=z+1|0}while((z|0)!=(b|0));if(Wa)q=0;else{m=0;while(1){if(!(k[a+(m<<2)>>2]|0)){k[Bb>>2]=0;k[Aa>>2]=0;l=ZT(24)|0;k[l>>2]=1;t=l+4|0;k[Bb>>2]=t;k[Aa>>2]=16;i[l+20>>0]=0;s=213614;v=t+16|0;do{i[t>>0]=i[s>>0]|0;t=t+1|0;s=s+1|0}while((t|0)<(v|0));Y8(-215,Bb,213348,213355,411);k[Aa>>2]=0;k[Bb>>2]=0;e=k[l>>2]|0;k[l>>2]=e+-1;if((e|0)==1)ggb(k[l+-4>>2]|0)}I=F&I<0.0?0.0:I;m=m+1|0;if((m|0)>=(b|0))break c}}do{n=(k[Y>>2]|0)+(aa(k[k[sb>>2]>>2]|0,q)|0)|0;m=a+(q<<2)|0;l=k[m>>2]|0;if(!l){k[Bb>>2]=0;k[Aa>>2]=0;l=ZT(24)|0;k[l>>2]=1;t=l+4|0;k[Bb>>2]=t;k[Aa>>2]=16;i[l+20>>0]=0;s=213614;v=t+16|0;do{i[t>>0]=i[s>>0]|0;t=t+1|0;s=s+1|0}while((t|0)<(v|0));Y8(-215,Bb,213348,213355,411);k[Aa>>2]=0;k[Bb>>2]=0;e=k[l>>2]|0;k[l>>2]=e+-1;if((e|0)==1)ggb(k[l+-4>>2]|0);l=k[m>>2]|0}J=1.0/+(l|0);l=0;do{e=n+(l<<2)|0;o[e>>2]=J*+o[e>>2];l=l+1|0}while((l|0)!=(ub|0));if(F){m=(k[Ba>>2]|0)+(aa(k[k[ob>>2]>>2]|0,q)|0)|0;J=0.0;l=0;do{O=+o[n+(l<<2)>>2]-+o[m+(l<<2)>>2];J=J+O*O;l=l+1|0}while((l|0)!=(ub|0));I=I<J?J:I}q=q+1|0}while((q|0)<(b|0))}else{if(X){if(!vb)break;s=k[l>>2]|0;if(R)break;m=Za;q=0;l=k[m>>2]|0;m=k[m+4>>2]|0;do{t=v+(aa(s,q)|0)|0;n=0;do{e=Epb(l|0,0,-130063606,0)|0;l=kpb(e|0,N|0,m|0,0)|0;m=N;O=+o[S+(n<<3)>>2];o[t+(n<<2)>>2]=O+(+o[S+(n<<3)+4>>2]-O)*(T*(+(l>>>0)*2.3283064365386963e-10)-Q);n=n+1|0}while((n|0)!=(P|0));q=q+1|0}while((q|0)!=(b|0));e=Za;k[e>>2]=l;k[e+4>>2]=m;break}G=k[Z>>2]|0;F=k[_>>2]|0;d=k[xb>>2]|0;e=(k[$>>2]|0)>>>2;if($a)l=0;else{if(U){kb=91;break b}while(1){l=fgb(M)|0;if(l|0)break;l=k[207666]|0;k[207666]=l+0;if(!l){l=0;break}Qh[l&7]()}zpb(l|0,0,Fa|0)|0}if(!F)m=0;else{if((F*3|0)>>>0>1073741823){kb=98;break b}q=F*12|0;n=(q|0)==0?1:q;while(1){m=fgb(n)|0;if(m|0)break;m=k[207666]|0;k[207666]=m+0;if(!m){m=0;break}Qh[m&7]()}zpb(m|0,0,q|0)|0}y=m;v=m+(F<<2)|0;w=v;v=v+(F<<2)|0;E=Za;n=k[E+4>>2]|0;E=Epb(k[E>>2]|0,0,-130063606,0)|0;n=kpb(E|0,N|0,n|0,0)|0;E=Za;k[E>>2]=n;k[E+4>>2]=N;n=(n>>>0)%(F>>>0)|0;k[l>>2]=n;E=(F|0)>0;do if(E){t=d+((aa(n,e)|0)<<2)|0;if((G|0)>0){J=0.0;s=0}else{zpb(m|0,0,F<<2|0)|0;J=0.0;break}do{q=d+((aa(s,e)|0)<<2)|0;n=0;K=0.0;do{O=+o[q+(n<<2)>>2]-+o[t+(n<<2)>>2];K=K+O*O;n=n+1|0}while((n|0)!=(G|0));o[m+(s<<2)>>2]=K;J=J+K;s=s+1|0}while((s|0)!=(F|0))}else J=0.0;while(0);if(ba){C=F+-1|0;D=(F|0)>1;B=1;while(1){A=y;do if(D){z=0;s=-1;O=1797693134862315708145274.0e284;c=v;n=w;while(1){w=Za;q=k[w+4>>2]|0;w=Epb(k[w>>2]|0,0,-130063606,0)|0;q=kpb(w|0,N|0,q|0,0)|0;w=N;v=Epb(q|0,0,-130063606,0)|0;w=kpb(v|0,N|0,w|0,0)|0;v=Za;k[v>>2]=w;k[v+4>>2]=N;K=J*((+(w>>>0)+4294967296.0*+(q>>>0))*5.421010862427522e-20);q=0;do{K=K-+o[A+(q<<2)>>2];if(K<=0.0)break;q=q+1|0}while((q|0)<(C|0));k[Bb>>2]=0;k[ca>>2]=F;v=c;t=aa(q,e)|0;k[Cb>>2]=47720;k[da>>2]=v;k[ea>>2]=d;k[fa>>2]=A;k[ga>>2]=G;k[ha>>2]=e;k[ia>>2]=t;BZ(Cb,Bb);K=0.0;t=0;do{K=K+ +o[v+(t<<2)>>2];t=t+1|0}while((t|0)!=(F|0));if(K<O){s=q;q=n;n=c}else{K=O;q=c}z=z+1|0;if((z|0)>=3){J=K;break}else{O=K;c=q}}}else{z=Za;q=k[z+4>>2]|0;z=Epb(k[z>>2]|0,0,-130063606,0)|0;q=kpb(z|0,N|0,q|0,0)|0;z=N;q=Epb(q|0,0,-130063606,0)|0;z=kpb(q|0,N|0,z|0,0)|0;q=Za;k[q>>2]=z;k[q+4>>2]=N;k[Bb>>2]=0;k[ca>>2]=F;q=v;k[Cb>>2]=47720;k[da>>2]=q;k[ea>>2]=d;k[fa>>2]=A;k[ga>>2]=G;k[ha>>2]=e;k[ia>>2]=0;BZ(Cb,Bb);if(E){J=0.0;n=0;do{J=J+ +o[q+(n<<2)>>2];n=n+1|0}while((n|0)!=(F|0));if(J<1797693134862315708145274.0e284)kb=129;else{s=-1;J=1797693134862315708145274.0e284;c=v;v=w}}else{J=0.0;kb=129}if((kb|0)==129){kb=0;s=0;c=w}z=Za;q=k[z+4>>2]|0;z=Epb(k[z>>2]|0,0,-130063606,0)|0;q=kpb(z|0,N|0,q|0,0)|0;z=N;q=Epb(q|0,0,-130063606,0)|0;z=kpb(q|0,N|0,z|0,0)|0;q=Za;k[q>>2]=z;k[q+4>>2]=N;k[Bb>>2]=0;k[ca>>2]=F;q=c;k[Cb>>2]=47720;k[da>>2]=q;k[ea>>2]=d;k[fa>>2]=A;k[ga>>2]=G;k[ha>>2]=e;k[ia>>2]=0;BZ(Cb,Bb);if(E){K=0.0;n=0;do{K=K+ +o[q+(n<<2)>>2];n=n+1|0}while((n|0)!=(F|0))}else K=0.0;if(K<J){t=0;n=v;v=c}else{t=s;K=J;n=c}z=Za;s=k[z+4>>2]|0;z=Epb(k[z>>2]|0,0,-130063606,0)|0;s=kpb(z|0,N|0,s|0,0)|0;z=N;s=Epb(s|0,0,-130063606,0)|0;z=kpb(s|0,N|0,z|0,0)|0;s=Za;k[s>>2]=z;k[s+4>>2]=N;k[Bb>>2]=0;k[ca>>2]=F;s=n;k[Cb>>2]=47720;k[da>>2]=s;k[ea>>2]=d;k[fa>>2]=A;k[ga>>2]=G;k[ha>>2]=e;k[ia>>2]=0;BZ(Cb,Bb);if(E){J=0.0;q=0;do{J=J+ +o[s+(q<<2)>>2];q=q+1|0}while((q|0)!=(F|0))}else J=0.0;if(!(J<K)){s=t;J=K;q=n;n=v;break}s=0;q=v}while(0);k[l+(B<<2)>>2]=s;B=B+1|0;if((B|0)>=(b|0))break;else{w=y;v=q;y=n}}}do if(vb){s=k[Y>>2]|0;t=k[k[sb>>2]>>2]|0;if((G|0)>0)q=0;else break;do{v=d+((aa(k[l+(q<<2)>>2]|0,e)|0)<<2)|0;w=s+(aa(q,t)|0)|0;n=0;do{k[w+(n<<2)>>2]=k[v+(n<<2)>>2];n=n+1|0}while((n|0)!=(G|0));q=q+1|0}while((q|0)!=(b|0))}while(0);if(m|0)ggb(m);if(!l)break;ggb(l)}while(0);n=g+1|0;if(!((n|0)!=(Xa|0)&!(I<=Ya)))break;k[Cb>>2]=1124007936;t=ja;v=t+36|0;do{k[t>>2]=0;t=t+4|0}while((t|0)<(v|0));k[la>>2]=ka;k[na>>2]=ma;k[oa>>2]=0;k[ma>>2]=0;k[Bb>>2]=1;k[db>>2]=wb;G1(Cb,2,Bb,6);m=k[pa>>2]|0;k[Bb>>2]=0;k[qa>>2]=wb;k[Ab>>2]=47740;k[ra>>2]=m;k[sa>>2]=ab;k[ta>>2]=Pb;k[ua>>2]=Fb;zZ(Ab,Bb);if(va){H=0.0;l=0;do{H=H+ +p[m+(l<<3)>>3];l=l+1|0}while((l|0)!=(wb|0))}else H=0.0;l=k[wa>>2]|0;do if(l|0){e=l+12|0;g=k[e>>2]|0;k[e>>2]=g+-1;if((g|0)!=1)break;m=k[wa>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[Ua>>2]|0;if(l|0)break;l=B1()|0;m=k[wa>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[wa>>2]=0}while(0);k[wa>>2]=0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[ja>>2]|0)>0){m=k[la>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[ja>>2]|0))}l=k[na>>2]|0;if(!((l|0)==(ma|0)|(l|0)==0))ggb(k[l+-4>>2]|0);g=n}if(H<f){if(k[j>>2]&2031616|0)mY(Fb,j);L=Ea;k[L>>2]=0;k[L+4>>2]=0;k[Bb>>2]=33619968;k[Da>>2]=Kb;mY(Lb,Bb);f=H}h=h+1|0;if((h|0)>=(Va|0)){Rb=f;break a}}if((kb|0)==91)ad(426534,426557,304,426811);else if((kb|0)==98)ad(426534,426557,304,426811)}else Rb=1797693134862315708145274.0e284;while(0);if(_a|0)ggb(_a);if(a|0)ggb(a);m=Db+36|0;a=k[m>>2]|0;if(a|0?(Bb=a+12|0,Cb=k[Bb>>2]|0,k[Bb>>2]=Cb+-1,(Cb|0)==1):0){l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Db+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}k[m>>2]=0;Db=Db+16|0;k[Db>>2]=0;k[Db+4>>2]=0;k[Db+8>>2]=0;k[Db+12>>2]=0;if((k[ib>>2]|0)>0){l=k[gb>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[ib>>2]|0))}a=k[hb>>2]|0;if(!((a|0)==(jb|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Eb+36|0;a=k[m>>2]|0;if(a|0?(Cb=a+12|0,Db=k[Cb>>2]|0,k[Cb>>2]=Db+-1,(Db|0)==1):0){l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Eb+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}k[m>>2]=0;Eb=Eb+16|0;k[Eb>>2]=0;k[Eb+4>>2]=0;k[Eb+8>>2]=0;k[Eb+12>>2]=0;if((k[nb>>2]|0)>0){l=k[mb>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[nb>>2]|0))}a=k[ob>>2]|0;if(!((a|0)==(pb|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Fb+36|0;a=k[m>>2]|0;do if(a|0){Db=a+12|0;Eb=k[Db>>2]|0;k[Db>>2]=Eb+-1;if((Eb|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Fb+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;Fb=Fb+16|0;k[Fb>>2]=0;k[Fb+4>>2]=0;k[Fb+8>>2]=0;k[Fb+12>>2]=0;if((k[rb>>2]|0)>0){l=k[qb>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[rb>>2]|0))}a=k[sb>>2]|0;if(!((a|0)==(tb|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Kb+36|0;a=k[m>>2]|0;do if(a|0){Eb=a+12|0;Fb=k[Eb>>2]|0;k[Eb>>2]=Fb+-1;if((Fb|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Kb+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;Fb=Kb+16|0;l=Kb+4|0;k[Fb>>2]=0;k[Fb+4>>2]=0;k[Fb+8>>2]=0;k[Fb+12>>2]=0;if((k[l>>2]|0)>0){m=k[Kb+40>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[Kb+44>>2]|0;if(!((a|0)==(Kb+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Lb+36|0;a=k[m>>2]|0;do if(a|0){Fb=a+12|0;Kb=k[Fb>>2]|0;k[Fb>>2]=Kb+-1;if((Kb|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Lb+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;k[zb>>2]=0;k[zb+4>>2]=0;k[zb+8>>2]=0;k[zb+12>>2]=0;if((k[Hb>>2]|0)>0){l=k[Gb>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Hb>>2]|0))}a=k[Ib>>2]|0;if(!((a|0)==(Jb|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Pb+36|0;a=k[m>>2]|0;do if(a|0){Kb=a+12|0;Lb=k[Kb>>2]|0;k[Kb>>2]=Lb+-1;if((Lb|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Pb+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;m=Pb+4|0;k[xb>>2]=0;k[xb+4>>2]=0;k[xb+8>>2]=0;k[xb+12>>2]=0;if((k[m>>2]|0)>0){l=k[Pb+40>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[yb>>2]|0;if(!((a|0)==(Pb+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Qb+36|0;a=k[m>>2]|0;do if(a|0){Lb=a+12|0;Pb=k[Lb>>2]|0;k[Lb>>2]=Pb+-1;if((Pb|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Qb+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;k[Mb>>2]=0;k[Mb+4>>2]=0;k[Mb+8>>2]=0;k[Mb+12>>2]=0;if((k[x>>2]|0)>0){l=k[Qb+40>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[x>>2]|0))}a=k[Nb>>2]|0;if((a|0)==(Ob|0)|(a|0)==0){r=Sb;return +Rb}ggb(k[a+-4>>2]|0);r=Sb;return +Rb}function yZ(a){a=a|0;ggb(a);return}function zZ(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,r=0,s=0,t=0,u=0,v=0.0;d=k[b>>2]|0;u=k[b+4>>2]|0;r=a+16|0;e=k[r>>2]|0;s=k[e+8>>2]|0;l=k[e+12>>2]|0;if((d|0)>=(u|0))return;m=a+12|0;n=(l|0)>0;t=k[a+4>>2]|0;q=k[a+8>>2]|0;if((s|0)>0){b=d;a=e}else{b=d;do{p[t+(b<<3)>>3]=1797693134862315708145274.0e284;k[q+(b<<2)>>2]=0;b=b+1|0}while((b|0)!=(u|0));return}while(1){i=k[m>>2]|0;i=(k[i+16>>2]|0)+(aa(k[k[i+44>>2]>>2]|0,b)|0)|0;j=k[a+16>>2]|0;h=k[k[a+44>>2]>>2]|0;if(n){g=0;c=1797693134862315708145274.0e284;a=0;do{e=j+(aa(h,g)|0)|0;d=0;f=0.0;do{v=+o[i+(d<<2)>>2]-+o[e+(d<<2)>>2];f=f+v*v;d=d+1|0}while((d|0)!=(l|0));v=f;e=c>v;a=e?g:a;c=e?v:c;g=g+1|0}while((g|0)!=(s|0))}else{d=0;c=1797693134862315708145274.0e284;a=0;do{j=c>0.0;a=j?d:a;c=j?0.0:c;d=d+1|0}while((d|0)!=(s|0))}p[t+(b<<3)>>3]=c;k[q+(b<<2)>>2]=a;b=b+1|0;if((b|0)==(u|0))break;a=k[r>>2]|0}return}function AZ(a){a=a|0;ggb(a);return}function BZ(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0.0;n=r;r=r+16|0;m=n;c=k[b>>2]|0;l=k[b+4>>2]|0;if((c|0)>=(l|0)){r=n;return}i=k[a+8>>2]|0;e=k[a+20>>2]|0;f=i+(k[a+24>>2]<<2)|0;g=k[a+16>>2]|0;j=k[a+12>>2]|0;h=k[a+4>>2]|0;if((g|0)<=0){b=c;do{o[m>>2]=0.0;i=j+(b<<2)|0;k[h+(b<<2)>>2]=k[(+o[i>>2]<0.0?i:m)>>2];b=b+1|0}while((b|0)!=(l|0));r=n;return}do{a=i+((aa(e,c)|0)<<2)|0;b=0;d=0.0;do{p=+o[a+(b<<2)>>2]-+o[f+(b<<2)>>2];d=d+p*p;b=b+1|0}while((b|0)!=(g|0));o[m>>2]=d;a=j+(c<<2)|0;k[h+(c<<2)>>2]=k[(+o[a>>2]<d?a:m)>>2];c=c+1|0}while((c|0)!=(l|0));r=n;return}function CZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0.0,h=0.0,j=0,l=0.0,m=0.0,n=0.0,q=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;W=r;r=r+2384|0;V=W+2328|0;U=W+1288|0;T=W+88|0;S=W+1232|0;R=W+32|0;O=W;L=W+1216|0;J=W+1200|0;K=W+1184|0;N=W+1128|0;do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[V>>2]=k[j>>2];C=V+4|0;a=j+4|0;k[C>>2]=k[a>>2];Q=V+8|0;k[Q>>2]=k[j+8>>2];k[V+12>>2]=k[j+12>>2];k[V+16>>2]=k[j+16>>2];k[V+20>>2]=k[j+20>>2];k[V+24>>2]=k[j+24>>2];k[V+28>>2]=k[j+28>>2];k[V+32>>2]=k[j+32>>2];d=k[j+36>>2]|0;k[V+36>>2]=d;e=V+40|0;k[e>>2]=Q;Q=V+48|0;A=V+44|0;k[A>>2]=Q;k[V+52>>2]=0;k[Q>>2]=0;if(d|0){Q=d+12|0;k[Q>>2]=(k[Q>>2]|0)+1}if((k[a>>2]|0)<3){Q=k[j+44>>2]|0;a=k[A>>2]|0;k[a>>2]=k[Q>>2];k[a+4>>2]=k[Q+4>>2];a=V;break}k[C>>2]=0;x1(V,k[a>>2]|0,0,0,0);if((k[C>>2]|0)>0){B=k[j+40>>2]|0;z=k[e>>2]|0;e=k[j+44>>2]|0;d=k[A>>2]|0;a=0;do{k[z+(a<<2)>>2]=k[B+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[C>>2]|0));a=V}else a=V}else{Q1(V,a,-1);a=V}while(0);a=k[a>>2]|0;I=a&4095;P=(I|0)==5;F=(I|0)==6;if((I+-5|0)>>>0>=2){k[U>>2]=0;d=U+4|0;k[d>>2]=0;e=ZT(40)|0;k[e>>2]=1;A=e+4|0;k[U>>2]=A;k[d>>2]=32;i[e+36>>0]=0;j=403298;C=A+32|0;do{i[A>>0]=i[j>>0]|0;A=A+1|0;j=j+1|0}while((A|0)<(C|0));Y8(-215,U,213842,213718,798);k[d>>2]=0;k[U>>2]=0;Q=k[e>>2]|0;k[e>>2]=Q+-1;if((Q|0)==1)ggb(k[e+-4>>2]|0)}G=(a>>>3&511)+1<<(47696>>>(I<<1&14)&3);z=k[V+8>>2]|0;Q=k[V+12>>2]|0;do if((c|0)==1){j=(Q|0)<(z|0)?Q:z;e=aa(j,z)|0;d=(aa(e+j+(aa(j,Q)|0)|0,G)|0)+8|0;H=U+8|0;k[U>>2]=H;M=U+4|0;k[M>>2]=1032;if(d>>>0>1032){while(1){a=fgb(d)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[U>>2]=a}else a=H;k[M>>2]=d;JN(T,z,j,I,G+-1+a&0-G,0);c=T+16|0;F=T+44|0;JN(S,j,1,I,(k[c>>2]|0)+(aa(e,G)|0)|0,0);D=S+16|0;E=S+44|0;JN(R,j,Q,I,(k[D>>2]|0)+(aa(j,G)|0)|0,0);k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=V;B=L+4|0;a=B+4|0;k[a>>2]=0;k[a+4>>2]=0;k[L>>2]=33619968;k[B>>2]=S;B=J+4|0;a=B+4|0;k[a>>2]=0;k[a+4>>2]=0;k[J>>2]=33619968;k[B>>2]=T;B=K+4|0;a=B+4|0;k[a>>2]=0;k[a+4>>2]=0;k[K>>2]=33619968;k[B>>2]=R;DZ(O,L,J,K,0);k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=S;k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=T;k[J+8>>2]=0;k[J+12>>2]=0;k[J>>2]=16842752;k[J+4>>2]=R;k[N>>2]=1124007936;B=N+4|0;a=N+8|0;z=N+40|0;A=B;C=A+36|0;do{k[A>>2]=0;A=A+4|0}while((A|0)<(C|0));k[z>>2]=a;A=N+48|0;j=N+44|0;k[j>>2]=A;k[N+52>>2]=0;k[A>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;k[K>>2]=16842752;k[K+4>>2]=N;EZ(O,L,J,K,b);e=N+36|0;a=k[e>>2]|0;if(a|0?(b=a+12|0,O=k[b>>2]|0,k[b>>2]=O+-1,(O|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[N+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;O=N+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[B>>2]|0))}a=k[j>>2]|0;if(!((a|0)==(A|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[D>>2]|0;if(P){f=+o[a>>2];if(!(f>=1.1920928955078125e-07))f=0.0;else f=+o[a+(Q+-1<<2)>>2]/f}else{f=+p[a>>3];if(!(f>=2.220446049250313e-16))f=0.0;else f=+p[a+(Q+-1<<3)>>3]/f}e=R+36|0;a=k[e>>2]|0;if(a|0?(P=a+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[R+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;Q=R+16|0;d=R+4|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[d>>2]|0)>0){e=k[R+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[R+44>>2]|0;if(!((a|0)==(R+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=S+36|0;a=k[e>>2]|0;if(a|0?(Q=a+12|0,R=k[Q>>2]|0,k[Q>>2]=R+-1,(R|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[S+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;e=S+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[e>>2]|0)>0){d=k[S+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[E>>2]|0;if(!((a|0)==(S+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=T+36|0;a=k[e>>2]|0;if(a|0?(R=a+12|0,S=k[R>>2]|0,k[R>>2]=S+-1,(S|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;do if(!a){a=k[T+32>>2]|0;if(a|0)break;a=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;e=T+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[e>>2]|0)>0){d=k[T+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[F>>2]|0;if(!((a|0)==(T+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[U>>2]|0;if((a|0)!=(H|0)){if(a|0)ggb(a);k[U>>2]=H;k[M>>2]=1032}}else{if((z|0)!=(Q|0)?(k[U>>2]=0,M=U+4|0,k[M>>2]=0,D=ZT(12)|0,k[D>>2]=1,E=D+4|0,k[U>>2]=E,k[M>>2]=6,i[D+10>>0]=0,i[E>>0]=i[213849]|0,i[E+1>>0]=i[213850]|0,i[E+2>>0]=i[213851]|0,i[E+3>>0]=i[213852]|0,i[E+4>>0]=i[213853]|0,i[E+5>>0]=i[213854]|0,Y8(-215,U,213842,213718,822),k[M>>2]=0,k[U>>2]=0,M=k[D>>2]|0,k[D>>2]=M+-1,(M|0)==1):0)ggb(k[D+-4>>2]|0);if((c|0)==2){e=aa(Q,Q)|0;d=(aa((e<<1)+Q|0,G)|0)+8|0;H=U+8|0;k[U>>2]=H;M=U+4|0;k[M>>2]=1032;if(d>>>0>1032){while(1){a=fgb(d)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[U>>2]=a}else a=H;k[M>>2]=d;JN(T,Q,Q,I,G+-1+a&0-G,0);c=T+16|0;F=T+44|0;JN(S,Q,1,I,(k[c>>2]|0)+(aa(e,G)|0)|0,0);D=S+16|0;E=S+44|0;JN(R,Q,Q,I,(k[D>>2]|0)+(aa(Q,G)|0)|0,0);k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=V;B=L+4|0;a=B+4|0;k[a>>2]=0;k[a+4>>2]=0;k[L>>2]=33619968;k[B>>2]=S;B=J+4|0;a=B+4|0;k[a>>2]=0;k[a+4>>2]=0;k[J>>2]=33619968;k[B>>2]=R;FZ(O,L,J);k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=R;B=L+4|0;a=B+4|0;k[a>>2]=0;k[a+4>>2]=0;k[L>>2]=33619968;k[B>>2]=T;$1(O,L);k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=S;k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=T;k[J+8>>2]=0;k[J+12>>2]=0;k[J>>2]=16842752;k[J+4>>2]=R;k[N>>2]=1124007936;B=N+4|0;a=N+8|0;z=N+40|0;A=B;C=A+36|0;do{k[A>>2]=0;A=A+4|0}while((A|0)<(C|0));k[z>>2]=a;A=N+48|0;j=N+44|0;k[j>>2]=A;k[N+52>>2]=0;k[A>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;k[K>>2]=16842752;k[K+4>>2]=N;EZ(O,L,J,K,b);e=N+36|0;a=k[e>>2]|0;if(a|0?(b=a+12|0,O=k[b>>2]|0,k[b>>2]=O+-1,(O|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[N+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;O=N+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[B>>2]|0)>0){d=k[z>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[B>>2]|0))}a=k[j>>2]|0;if(!((a|0)==(A|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[D>>2]|0;if(P){f=+o[a>>2];if(!(f>=1.1920928955078125e-07))f=0.0;else f=+o[a+(Q+-1<<2)>>2]/f}else{f=+p[a>>3];if(!(f>=2.220446049250313e-16))f=0.0;else f=+p[a+(Q+-1<<3)>>3]/f}e=R+36|0;a=k[e>>2]|0;if(a|0?(P=a+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[R+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;Q=R+16|0;d=R+4|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[d>>2]|0)>0){e=k[R+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[R+44>>2]|0;if(!((a|0)==(R+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=S+36|0;a=k[e>>2]|0;if(a|0?(Q=a+12|0,R=k[Q>>2]|0,k[Q>>2]=R+-1,(R|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;do if(!a){a=k[S+32>>2]|0;if(a|0)break;a=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;e=S+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[e>>2]|0)>0){d=k[S+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[E>>2]|0;if(!((a|0)==(S+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=T+36|0;a=k[e>>2]|0;do if(a|0){R=a+12|0;S=k[R>>2]|0;k[R>>2]=S+-1;if((S|0)!=1)break;d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;do if(!a){a=k[T+32>>2]|0;if(a|0)break;a=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}while(0);k[e>>2]=0;e=T+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[e>>2]|0)>0){d=k[T+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[F>>2]|0;if(!((a|0)==(T+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[U>>2]|0;if((a|0)!=(H|0)){if(a|0)ggb(a);k[U>>2]=H;k[M>>2]=1032}break}D=(c|0)==0;E=(c|0)==3;switch(c|0){case 0:case 3:break;default:{k[U>>2]=0;a=U+4|0;k[a>>2]=0;d=ZT(56)|0;k[d>>2]=1;A=d+4|0;k[U>>2]=A;k[a>>2]=48;i[d+52>>0]=0;j=213856;C=A+48|0;do{i[A>>0]=i[j>>0]|0;A=A+1|0;j=j+1|0}while((A|0)<(C|0));Y8(-215,U,213842,213718,842);k[a>>2]=0;k[U>>2]=0;N=k[d>>2]|0;k[d>>2]=N+-1;if((N|0)==1)ggb(k[d+-4>>2]|0)}}c2(b,Q,Q,I,-1,0,0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[U>>2]=k[j>>2];C=U+4|0;a=j+4|0;k[C>>2]=k[a>>2];N=U+8|0;k[N>>2]=k[j+8>>2];k[U+12>>2]=k[j+12>>2];k[U+16>>2]=k[j+16>>2];k[U+20>>2]=k[j+20>>2];k[U+24>>2]=k[j+24>>2];k[U+28>>2]=k[j+28>>2];k[U+32>>2]=k[j+32>>2];d=k[j+36>>2]|0;k[U+36>>2]=d;e=U+40|0;k[e>>2]=N;N=U+48|0;A=U+44|0;k[A>>2]=N;k[U+52>>2]=0;k[N>>2]=0;if(d|0){N=d+12|0;k[N>>2]=(k[N>>2]|0)+1}if((k[a>>2]|0)<3){M=k[j+44>>2]|0;N=k[A>>2]|0;k[N>>2]=k[M>>2];k[N+4>>2]=k[M+4>>2];break}k[C>>2]=0;x1(U,k[a>>2]|0,0,0,0);if((k[C>>2]|0)>0){B=k[j+40>>2]|0;z=k[e>>2]|0;e=k[j+44>>2]|0;d=k[A>>2]|0;a=0;do{k[z+(a<<2)>>2]=k[B+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[C>>2]|0))}}else Q1(U,b,-1);while(0);a:do if((Q|0)<4){e=k[V+16>>2]|0;z=k[U+16>>2]|0;a=k[V+48>>2]|0;j=k[U+48>>2]|0;b:do switch(Q|0){case 2:if(P){h=+o[e>>2];d=e+a|0;g=+o[d+4>>2];a=e+4|0;f=h*g-+o[a>>2]*+o[d>>2];if(!(f!=0.0))break b;x=1.0/f;j=z+j|0;o[j+4>>2]=h*x;o[z>>2]=g*x;y=x*-+o[d>>2];o[z+4>>2]=x*-+o[a>>2];o[j>>2]=y;j=1;break a}else{h=+p[e>>3];d=e+a|0;g=+p[d+8>>3];a=e+8|0;f=h*g-+p[a>>3]*+p[d>>3];if(!(f!=0.0))break b;x=1.0/f;j=z+j|0;p[j+8>>3]=h*x;p[z>>3]=g*x;y=-(x*+p[d>>3]);p[z+8>>3]=-(x*+p[a>>3]);p[j>>3]=y;j=1;break a}case 3:if(P){x=+o[e>>2];R=e+a|0;y=+o[R+4>>2];S=e+(a<<1)|0;l=+o[S+8>>2];m=+o[R+8>>2];n=+o[S+4>>2];q=y*l-m*n;s=+o[e+4>>2];t=+o[R>>2];u=l*t;v=+o[S>>2];w=m*v;f=+o[e+8>>2];g=n*t-y*v;h=f*g+(x*q-s*(u-w));if(!(h!=0.0))break b;h=1.0/h;o[z>>2]=q*h;o[z+4>>2]=(n*f-l*s)*h;o[z+8>>2]=(m*s-y*f)*h;T=z+j|0;o[T>>2]=(w-u)*h;o[T+4>>2]=(x*l-v*f)*h;o[T+8>>2]=(t*f-x*m)*h;j=z+(j<<1)|0;o[j>>2]=g*h;o[j+4>>2]=(s*v-x*n)*h;o[j+8>>2]=(x*y-s*t)*h;j=1;break a}else{x=+p[e>>3];R=e+a|0;y=+p[R+8>>3];S=e+(a<<1)|0;l=+p[S+16>>3];m=+p[R+16>>3];n=+p[S+8>>3];q=y*l-m*n;s=+p[e+8>>3];t=+p[R>>3];u=l*t;v=+p[S>>3];w=m*v;f=+p[e+16>>3];g=n*t-y*v;h=f*g+(x*q-s*(u-w));if(!(h!=0.0))break b;h=1.0/h;p[z>>3]=q*h;p[z+8>>3]=(n*f-l*s)*h;p[z+16>>3]=(m*s-y*f)*h;T=z+j|0;p[T>>3]=(w-u)*h;p[T+8>>3]=(x*l-v*f)*h;p[T+16>>3]=(t*f-x*m)*h;j=z+(j<<1)|0;p[j>>3]=g*h;p[j+8>>3]=(s*v-x*n)*h;p[j+16>>3]=(x*y-s*t)*h;j=1;break a}default:if(P){f=+o[e>>2];if(!(f!=0.0))break b;o[z>>2]=1.0/f;j=1;break a}else{f=+p[e>>3];if(!(f!=0.0))break b;p[z>>3]=1.0/f;j=1;break a}}while(0);k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;k[T+16>>2]=0;k[T+20>>2]=0;k[T+24>>2]=0;k[T+28>>2]=0;oY(U,T);j=0}else{d=aa(aa(Q,G)|0,Q)|0;z=T+8|0;k[T>>2]=z;A=T+4|0;k[A>>2]=1032;if(d>>>0>1032){while(1){a=fgb(d)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[T>>2]=a}else a=z;k[A>>2]=d;JN(S,Q,Q,I,a,0);N=R+4|0;M=N+4|0;k[M>>2]=0;k[M+4>>2]=0;k[R>>2]=33619968;k[N>>2]=S;mY(V,R);N=R+4|0;M=N+4|0;k[M>>2]=0;k[M+4>>2]=0;k[R>>2]=50397184;k[N>>2]=U;p[O>>3]=1.0;N=O+8|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;k[N+16>>2]=0;k[N+20>>2]=0;R2(R,O);do if(D&P)if(!(t4(k[S+16>>2]|0,k[S+48>>2]|0,Q,k[U+16>>2]|0,k[U+48>>2]|0,Q)|0))H=197;else j=1;else{if(D&F)if(!(u4(k[S+16>>2]|0,k[S+48>>2]|0,Q,k[U+16>>2]|0,k[U+48>>2]|0,Q)|0)){H=197;break}else{j=1;break}a=k[S+16>>2]|0;if(E&P)if(v4(a,k[S+48>>2]|0,Q,k[U+16>>2]|0,k[U+48>>2]|0,Q)|0){j=1;break}else{H=197;break}else if(w4(a,k[S+48>>2]|0,Q,k[U+16>>2]|0,k[U+48>>2]|0,Q)|0){j=1;break}else{H=197;break}}while(0);if((H|0)==197){k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;k[R+16>>2]=0;k[R+20>>2]=0;k[R+24>>2]=0;k[R+28>>2]=0;oY(U,R);j=0}e=S+36|0;a=k[e>>2]|0;if(a|0?(Q=a+12|0,R=k[Q>>2]|0,k[Q>>2]=R+-1,(R|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[S+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;R=S+16|0;d=S+4|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[d>>2]|0)>0){e=k[S+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[S+44>>2]|0;if(!((a|0)==(S+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[T>>2]|0;if((a|0)!=(z|0)){if(a|0)ggb(a);k[T>>2]=z;k[A>>2]=1032}}while(0);e=U+36|0;a=k[e>>2]|0;if(a|0?(S=a+12|0,T=k[S>>2]|0,k[S>>2]=T+-1,(T|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[U+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;T=U+16|0;d=U+4|0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[d>>2]|0)>0){e=k[U+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[U+44>>2]|0;if(!((a|0)==(U+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=+(j&1)}while(0);e=V+36|0;a=k[e>>2]|0;if(a|0?(T=a+12|0,U=k[T>>2]|0,k[T>>2]=U+-1,(U|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[V+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;U=V+16|0;d=V+4|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[d>>2]|0)>0){e=k[V+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[V+44>>2]|0;if((a|0)==(V+48|0)|(a|0)==0){r=W;return +f}ggb(k[a+-4>>2]|0);r=W;return +f}function DZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+1392|0;H=I+1336|0;G=I+296|0;F=I+240|0;E=I+184|0;C=I+128|0;z=I+72|0;y=I;x=I+56|0;do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[H>>2]=k[l>>2];p=H+4|0;g=l+4|0;k[p>>2]=k[g>>2];a=H+8|0;k[a>>2]=k[l+8>>2];f=H+12|0;k[f>>2]=k[l+12>>2];k[H+16>>2]=k[l+16>>2];k[H+20>>2]=k[l+20>>2];k[H+24>>2]=k[l+24>>2];k[H+28>>2]=k[l+28>>2];k[H+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[H+36>>2]=h;j=H+40|0;k[j>>2]=a;D=H+48|0;n=H+44|0;k[n>>2]=D;k[H+52>>2]=0;k[D>>2]=0;if(h|0){D=h+12|0;k[D>>2]=(k[D>>2]|0)+1}if((k[g>>2]|0)<3){D=k[l+44>>2]|0;g=k[n>>2]|0;k[g>>2]=k[D>>2];k[g+4>>2]=k[D+4>>2];g=H;break}k[p>>2]=0;x1(H,k[g>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[o+(g<<2)>>2];k[h+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[p>>2]|0));g=H}else g=H}else{Q1(H,a,-1);f=H+12|0;g=H;a=H+8|0}while(0);l=k[a>>2]|0;j=k[f>>2]|0;o=k[g>>2]&4095;if(!(k[c>>2]&2031616))a=(k[d>>2]&2031616|0)!=0;else a=1;w=(o|0)==5;if((o+-5|0)>>>0>=2){k[G>>2]=0;f=G+4|0;k[f>>2]=0;g=ZT(40)|0;k[g>>2]=1;m=g+4|0;k[G>>2]=m;k[f>>2]=32;i[g+36>>0]=0;h=403298;n=m+32|0;do{i[m>>0]=i[h>>0]|0;m=m+1|0;h=h+1|0}while((m|0)<(n|0));Y8(-215,G,214197,213718,1368);k[f>>2]=0;k[G>>2]=0;D=k[g>>2]|0;k[g>>2]=D+-1;if((D|0)==1)ggb(k[g+-4>>2]|0)}if(!(e&2)){t=(l|0)<(j|0);B=t?j:l;D=t?l:j;u=a;v=D;q=B;e=e&4|0?B:D}else{b2(c);b2(d);t=(l|0)<(j|0);e=t?l:j;u=0;v=e;q=t?j:l}D=H+4|0;a=k[D>>2]|0;if((a|0)>0)a=k[(k[H+44>>2]|0)+(a+-1<<2)>>2]|0;else a=0;h=(aa(a,q)|0)+15&-16;j=aa(a,v)|0;l=j+15&-16;f=aa(h,e)|0;g=j+32+(aa(l,v)|0)+f|0;A=G+8|0;k[G>>2]=A;B=G+4|0;k[B>>2]=1032;if(g>>>0>1032){while(1){a=fgb(g)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[G>>2]=a}else a=A;k[B>>2]=g;s=a+15&-16;JN(F,v,q,o,s,h);f=s+f|0;JN(E,v,1,o,f,0);JN(C,e,q,o,s,h);k[z>>2]=1124007936;s=z+4|0;a=z+8|0;p=z+40|0;m=s;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[p>>2]=a;n=z+48|0;m=z+44|0;k[m>>2]=n;k[z+52>>2]=0;k[n>>2]=0;if(u){JN(y,v,v,o,f+j+15&-16,l);KG(z,y)|0;g=y+36|0;a=k[g>>2]|0;if(a|0?(l=a+12|0,o=k[l>>2]|0,k[l>>2]=o+-1,(o|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;o=y+16|0;f=y+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[f>>2]|0)>0){g=k[y+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[y+44>>2]|0;if(!((a|0)==(y+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}if((e|0)>(v|0)){k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;k[y+16>>2]=0;k[y+20>>2]=0;k[y+24>>2]=0;k[y+28>>2]=0;oY(C,y)}if(t){x=y+4|0;o=x+4|0;k[o>>2]=0;k[o+4>>2]=0;k[y>>2]=33619968;k[x>>2]=F;mY(H,y)}else{k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=H;o=x+4|0;l=o+4|0;k[l>>2]=0;k[l+4>>2]=0;k[x>>2]=33619968;k[o>>2]=F;$1(y,x)}j=F+16|0;a=k[j>>2]|0;h=C+48|0;f=k[h>>2]|0;if(w){w=k[z+16>>2]|0;x=u?e:0;LZ(a,f,k[E+16>>2]|0,w,k[n>>2]|0,q,v,(w|0)==0?0:(x|0)<0?v:x)}else{w=k[z+16>>2]|0;x=u?e:0;MZ(a,f,k[E+16>>2]|0,w,k[n>>2]|0,q,v,(w|0)==0?0:(x|0)<0?v:x)}mY(E,b);do if(u){a=(k[c>>2]&2031616|0)==0;if(t){if(!a){k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=z;$1(y,c)}if(!(k[d>>2]&2031616))break;mY(C,d);break}else{if(!a){k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=C;$1(y,c)}if(!(k[d>>2]&2031616))break;mY(z,d);break}}while(0);g=z+36|0;a=k[g>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[z+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;z=z+16|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[s>>2]|0)>0){f=k[p>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[s>>2]|0))}a=k[m>>2]|0;if(!((a|0)==(n|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=C+36|0;a=k[g>>2]|0;if(a|0?(d=a+12|0,z=k[d>>2]|0,k[d>>2]=z+-1,(z|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[C+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;z=C+16|0;f=C+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[f>>2]|0)>0){g=k[C+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[C+44>>2]|0;if(!((a|0)==(h|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=E+36|0;a=k[g>>2]|0;if(a|0?(z=a+12|0,C=k[z>>2]|0,k[z>>2]=C+-1,(C|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[E+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;C=E+16|0;f=E+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[f>>2]|0)>0){g=k[E+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[E+44>>2]|0;if(!((a|0)==(E+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=F+36|0;a=k[g>>2]|0;do if(a|0){C=a+12|0;E=k[C>>2]|0;k[C>>2]=E+-1;if((E|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[F+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;g=F+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[g>>2]|0)>0){f=k[F+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[F+44>>2]|0;if(!((a|0)==(F+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[G>>2]|0;if((a|0)!=(A|0)){if(a|0)ggb(a);k[G>>2]=A;k[B>>2]=1032}g=H+36|0;a=k[g>>2]|0;do if(a|0){F=a+12|0;G=k[F>>2]|0;k[F>>2]=G+-1;if((G|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[H+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;G=H+16|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[D>>2]|0)>0){f=k[H+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[D>>2]|0))}a=k[H+44>>2]|0;if((a|0)==(H+48|0)|(a|0)==0){r=I;return}ggb(k[a+-4>>2]|0);r=I;return}function EZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=r;r=r+1328|0;D=E+1272|0;C=E+1216|0;B=E+1160|0;A=E+1104|0;z=E+64|0;y=E+8|0;w=E;do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[D>>2]=k[h>>2];n=D+4|0;a=h+4|0;k[n>>2]=k[a>>2];x=D+8|0;k[x>>2]=k[h+8>>2];k[D+12>>2]=k[h+12>>2];k[D+16>>2]=k[h+16>>2];k[D+20>>2]=k[h+20>>2];k[D+24>>2]=k[h+24>>2];k[D+28>>2]=k[h+28>>2];k[D+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[D+36>>2]=f;g=D+40|0;k[g>>2]=x;x=D+48|0;l=D+44|0;k[l>>2]=x;k[D+52>>2]=0;k[x>>2]=0;if(f|0){x=f+12|0;k[x>>2]=(k[x>>2]|0)+1}if((k[a>>2]|0)<3){t=k[h+44>>2]|0;x=k[l>>2]|0;k[x>>2]=k[t>>2];k[x+4>>2]=k[t+4>>2];break}k[n>>2]=0;x1(D,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(D,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[C>>2]=k[j>>2];n=C+4|0;f=j+4|0;k[n>>2]=k[f>>2];x=C+8|0;k[x>>2]=k[j+8>>2];k[C+12>>2]=k[j+12>>2];k[C+16>>2]=k[j+16>>2];k[C+20>>2]=k[j+20>>2];k[C+24>>2]=k[j+24>>2];k[C+28>>2]=k[j+28>>2];k[C+32>>2]=k[j+32>>2];a=k[j+36>>2]|0;k[C+36>>2]=a;g=C+40|0;k[g>>2]=x;x=C+48|0;l=C+44|0;k[l>>2]=x;k[C+52>>2]=0;k[x>>2]=0;if(a|0){x=a+12|0;k[x>>2]=(k[x>>2]|0)+1}if((k[f>>2]|0)<3){t=k[j+44>>2]|0;x=k[l>>2]|0;k[x>>2]=k[t>>2];k[x+4>>2]=k[t+4>>2];break}k[n>>2]=0;x1(C,k[f>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[j+40>>2]|0;h=k[g>>2]|0;g=k[j+44>>2]|0;f=k[l>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(C,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[B>>2]=k[h>>2];n=B+4|0;a=h+4|0;k[n>>2]=k[a>>2];x=B+8|0;k[x>>2]=k[h+8>>2];k[B+12>>2]=k[h+12>>2];k[B+16>>2]=k[h+16>>2];k[B+20>>2]=k[h+20>>2];k[B+24>>2]=k[h+24>>2];k[B+28>>2]=k[h+28>>2];k[B+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[B+36>>2]=f;g=B+40|0;k[g>>2]=x;x=B+48|0;l=B+44|0;k[l>>2]=x;k[B+52>>2]=0;k[x>>2]=0;if(f|0){x=f+12|0;k[x>>2]=(k[x>>2]|0)+1}if((k[a>>2]|0)<3){t=k[h+44>>2]|0;x=k[l>>2]|0;k[x>>2]=k[t>>2];k[x+4>>2]=k[t+4>>2];break}k[n>>2]=0;x1(B,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(B,c,-1);while(0);do if((k[d>>2]&2031616|0)==65536){h=k[d+4>>2]|0;k[A>>2]=k[h>>2];n=A+4|0;a=h+4|0;k[n>>2]=k[a>>2];x=A+8|0;k[x>>2]=k[h+8>>2];k[A+12>>2]=k[h+12>>2];k[A+16>>2]=k[h+16>>2];k[A+20>>2]=k[h+20>>2];k[A+24>>2]=k[h+24>>2];k[A+28>>2]=k[h+28>>2];k[A+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[A+36>>2]=f;g=A+40|0;k[g>>2]=x;x=A+48|0;l=A+44|0;k[l>>2]=x;k[A+52>>2]=0;k[x>>2]=0;if(f|0){x=f+12|0;k[x>>2]=(k[x>>2]|0)+1}if((k[a>>2]|0)<3){t=k[h+44>>2]|0;x=k[l>>2]|0;k[x>>2]=k[t>>2];k[x+4>>2]=k[t+4>>2];break}k[n>>2]=0;x1(A,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(A,d,-1);while(0);p=k[D>>2]|0;n=p&4095;x=D+4|0;a=k[x>>2]|0;if((a|0)>0)a=k[(k[D+44>>2]|0)+(a+-1<<2)>>2]|0;else a=0;c=k[C+8>>2]|0;d=k[B+12>>2]|0;t=A+16|0;o=k[t>>2]|0?k[A+12>>2]|0:c;m=(d|0)<(c|0)?d:c;if((k[D+8>>2]|0)!=1)a=((k[D+12>>2]|0)==1?0:a)+(k[D+48>>2]|0)|0;g=(o<<3)+16|0;q=z+8|0;k[z>>2]=q;s=z+4|0;k[s>>2]=1032;if(g>>>0>1032){while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[z>>2]=f}k[s>>2]=g;if(!(((((n|0)==(k[C>>2]&4095|0)?(n|0)==(k[B>>2]&4095|0):0)?(k[C+16>>2]|0)!=0:0)?(k[B+16>>2]|0)!=0:0)?(k[D+16>>2]|0)!=0:0)){k[y>>2]=0;f=y+4|0;k[f>>2]=0;g=ZT(84)|0;k[g>>2]=1;h=g+4|0;k[y>>2]=h;k[f>>2]=76;i[g+80>>0]=0;j=213932;l=h+76|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,y,214009,213718,1452);k[f>>2]=0;k[y>>2]=0;b=k[g>>2]|0;k[g>>2]=b+-1;if((b|0)==1)ggb(k[g+-4>>2]|0)}f=k[C+12>>2]|0;if((f|0)>=(m|0)?(u=k[B+8>>2]|0,(u|0)>=(m|0)):0){b=k[D+40>>2]|0;l=k[b+4>>2]|0;b=k[b>>2]|0;if((!((l|0)==(m|0)&(b|0)==1)?!((l|0)==1&(b|0)==(m|0)):0)?!((l|0)==(u|0)&(b|0)==(f|0)):0)v=59}else v=59;if((v|0)==59){k[y>>2]=0;f=y+4|0;k[f>>2]=0;g=ZT(128)|0;k[g>>2]=1;h=g+4|0;k[y>>2]=h;k[f>>2]=122;i[g+126>>0]=0;j=214019;l=h+122|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,y,214009,213718,1454);k[f>>2]=0;k[y>>2]=0;v=k[g>>2]|0;k[g>>2]=v+-1;if((v|0)==1)ggb(k[g+-4>>2]|0)}do if(k[t>>2]|0){if((k[A>>2]&4095|0)==(n|0)?(k[A+8>>2]|0)==(c|0):0)break;k[y>>2]=0;f=y+4|0;k[f>>2]=0;g=ZT(60)|0;k[g>>2]=1;h=g+4|0;k[y>>2]=h;k[f>>2]=54;i[g+58>>0]=0;j=214142;l=h+54|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,y,214009,213718,1455);k[f>>2]=0;k[y>>2]=0;v=k[g>>2]|0;k[g>>2]=v+-1;if((v|0)==1)ggb(k[g+-4>>2]|0)}while(0);c2(e,d,o,n,-1,0,0);do if((k[e>>2]&2031616|0)==65536){j=k[e+4>>2]|0;k[y>>2]=k[j>>2];b=y+4|0;f=j+4|0;k[b>>2]=k[f>>2];e=y+8|0;k[e>>2]=k[j+8>>2];k[y+12>>2]=k[j+12>>2];k[y+16>>2]=k[j+16>>2];k[y+20>>2]=k[j+20>>2];k[y+24>>2]=k[j+24>>2];k[y+28>>2]=k[j+28>>2];k[y+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[y+36>>2]=g;h=y+40|0;k[h>>2]=e;e=y+48|0;m=y+44|0;k[m>>2]=e;k[y+52>>2]=0;k[e>>2]=0;if(g|0){e=g+12|0;k[e>>2]=(k[e>>2]|0)+1}if((k[f>>2]|0)<3){v=k[j+44>>2]|0;e=k[m>>2]|0;k[e>>2]=k[v>>2];k[e+4>>2]=k[v+4>>2];break}k[b>>2]=0;x1(y,k[f>>2]|0,0,0,0);if((k[b>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;f=0;do{k[l+(f<<2)>>2]=k[n+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[b>>2]|0))}}else Q1(y,e,-1);while(0);switch(p&4095){case 5:{IZ(c,d,k[D+16>>2]|0,a,k[C+16>>2]|0,k[C+48>>2]|0,0,k[B+16>>2]|0,k[B+48>>2]|0,k[t>>2]|0,k[A+48>>2]|0,o,k[y+16>>2]|0,k[y+48>>2]|0,k[z>>2]|0);break}case 6:{JZ(c,d,k[D+16>>2]|0,a,k[C+16>>2]|0,k[C+48>>2]|0,0,k[B+16>>2]|0,k[B+48>>2]|0,k[t>>2]|0,k[A+48>>2]|0,o,k[y+16>>2]|0,k[y+48>>2]|0,k[z>>2]|0);break}default:{k[w>>2]=0;e=w+4|0;k[e>>2]=0;a=ZT(8)|0;k[a>>2]=1;v=a+4|0;k[w>>2]=v;k[e>>2]=0;i[v>>0]=0;Y8(-210,w,214009,213718,1468);k[e>>2]=0;k[w>>2]=0;w=k[a>>2]|0;k[a>>2]=w+-1;if((w|0)==1)ggb(k[a+-4>>2]|0)}}g=y+36|0;a=k[g>>2]|0;if(a|0?(e=a+12|0,w=k[e>>2]|0,k[e>>2]=w+-1,(w|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;w=y+16|0;f=y+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[f>>2]|0)>0){g=k[y+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[y+44>>2]|0;if(!((a|0)==(y+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[z>>2]|0;if((a|0)!=(q|0)){if(a|0)ggb(a);k[z>>2]=q;k[s>>2]=1032}g=A+36|0;a=k[g>>2]|0;if(a|0?(y=a+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[A+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;g=A+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[g>>2]|0)>0){f=k[A+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[A+44>>2]|0;if(!((a|0)==(A+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=B+36|0;a=k[g>>2]|0;do if(a|0){z=a+12|0;A=k[z>>2]|0;k[z>>2]=A+-1;if((A|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[B+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;A=B+16|0;f=B+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[f>>2]|0)>0){g=k[B+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[B+44>>2]|0;if(!((a|0)==(B+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=C+36|0;a=k[g>>2]|0;do if(a|0){A=a+12|0;B=k[A>>2]|0;k[A>>2]=B+-1;if((B|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[C+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;B=C+16|0;f=C+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[f>>2]|0)>0){g=k[C+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[C+44>>2]|0;if(!((a|0)==(C+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=D+36|0;a=k[g>>2]|0;do if(a|0){B=a+12|0;C=k[B>>2]|0;k[B>>2]=C+-1;if((C|0)!=1)break;f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[D+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}while(0);k[g>>2]=0;C=D+16|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[x>>2]|0)>0){f=k[D+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[x>>2]|0))}a=k[D+44>>2]|0;if((a|0)==(D+48|0)|(a|0)==0){r=E;return}ggb(k[a+-4>>2]|0);r=E;return}function FZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+1280|0;z=A+1224|0;y=A+1168|0;x=A+128|0;w=A+72|0;v=A+16|0;p=A;do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[z>>2]=k[h>>2];n=z+4|0;a=h+4|0;k[n>>2]=k[a>>2];d=z+8|0;k[d>>2]=k[h+8>>2];e=z+12|0;k[e>>2]=k[h+12>>2];k[z+16>>2]=k[h+16>>2];k[z+20>>2]=k[h+20>>2];k[z+24>>2]=k[h+24>>2];k[z+28>>2]=k[h+28>>2];k[z+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[z+36>>2]=f;g=z+40|0;k[g>>2]=d;u=z+48|0;l=z+44|0;k[l>>2]=u;k[z+52>>2]=0;k[u>>2]=0;if(f|0){u=f+12|0;k[u>>2]=(k[u>>2]|0)+1}if((k[a>>2]|0)<3){u=k[h+44>>2]|0;a=k[l>>2]|0;k[a>>2]=k[u>>2];k[a+4>>2]=k[u+4>>2];a=z;break}k[n>>2]=0;x1(z,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0));a=z}else a=z}else{Q1(z,a,-1);d=z+8|0;e=z+12|0;a=z}while(0);m=k[a>>2]&4095;o=k[d>>2]|0;if((o|0)!=(k[e>>2]|0)){k[y>>2]=0;a=y+4|0;k[a>>2]=0;d=ZT(28)|0;k[d>>2]=1;f=d+4|0;k[y>>2]=f;k[a>>2]=20;i[d+24>>0]=0;e=213905;g=f+20|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,y,213926,213718,1332);k[a>>2]=0;k[y>>2]=0;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0)}n=(m|0)==5;if((m+-5|0)>>>0>=2){k[y>>2]=0;a=y+4|0;k[a>>2]=0;d=ZT(40)|0;k[d>>2]=1;f=d+4|0;k[y>>2]=f;k[a>>2]=32;i[d+36>>0]=0;e=403298;g=f+32|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,y,213926,213718,1333);k[a>>2]=0;k[y>>2]=0;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0)}k[y>>2]=1124007936;u=y+4|0;a=y+8|0;s=y+40|0;f=u;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[s>>2]=a;t=y+48|0;q=y+44|0;k[q>>2]=t;k[y+52>>2]=0;k[t>>2]=0;if(k[c>>2]&2031616|0){c2(c,o,o,m,-1,0,0);do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[x>>2]=k[f>>2];l=x+4|0;a=f+4|0;k[l>>2]=k[a>>2];c=x+8|0;k[c>>2]=k[f+8>>2];k[x+12>>2]=k[f+12>>2];k[x+16>>2]=k[f+16>>2];k[x+20>>2]=k[f+20>>2];k[x+24>>2]=k[f+24>>2];k[x+28>>2]=k[f+28>>2];k[x+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[x+36>>2]=d;e=x+40|0;k[e>>2]=c;c=x+48|0;h=x+44|0;k[h>>2]=c;k[x+52>>2]=0;k[c>>2]=0;if(d|0){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[a>>2]|0)<3){l=k[f+44>>2]|0;c=k[h>>2]|0;k[c>>2]=k[l>>2];k[c+4>>2]=k[l+4>>2];break}k[l>>2]=0;x1(x,k[a>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[j+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[l>>2]|0))}}else Q1(x,c,-1);while(0);KG(y,x)|0;e=x+36|0;a=k[e>>2]|0;if(a|0?(l=a+12|0,c=k[l>>2]|0,k[l>>2]=c+-1,(c|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[x+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;c=x+16|0;d=x+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){e=k[x+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[x+44>>2]|0;if(!((a|0)==(x+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}c=z+4|0;a=k[c>>2]|0;if((a|0)>0)a=k[(k[z+44>>2]|0)+(a+-1<<2)>>2]|0;else a=0;e=aa(a,o)|0;f=e+15&-16;g=aa(f,o)|0;d=(aa(o*5|0,a)|0)+32+g|0;j=x+8|0;k[x>>2]=j;l=x+4|0;k[l>>2]=1032;if(d>>>0>1032){while(1){a=fgb(d)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[x>>2]=a}else a=j;k[l>>2]=d;a=a+15&-16;JN(w,o,o,m,a,f);JN(v,o,1,m,a+g|0,0);f=a+(g+e)|0;g=p+4|0;a=g+4|0;k[a>>2]=0;k[a+4>>2]=0;k[p>>2]=33619968;k[g>>2]=w;mY(z,p);g=w+16|0;a=k[g>>2]|0;h=w+48|0;d=k[h>>2]|0;e=k[t>>2]|0;if(n)GZ(a,d,k[v+16>>2]|0,k[y+16>>2]|0,e,o,f);else HZ(a,d,k[v+16>>2]|0,k[y+16>>2]|0,e,o,f);mY(v,b);e=v+36|0;a=k[e>>2]|0;if(a|0?(p=a+12|0,b=k[p>>2]|0,k[p>>2]=b+-1,(b|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[v+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;b=v+16|0;d=v+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[d>>2]|0)>0){e=k[v+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[v+44>>2]|0;if(!((a|0)==(v+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=w+36|0;a=k[e>>2]|0;if(a|0?(b=a+12|0,v=k[b>>2]|0,k[b>>2]=v+-1,(v|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[w+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;e=w+4|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[e>>2]|0)>0){d=k[w+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[w+44>>2]|0;if(!((a|0)==(h|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[x>>2]|0;if((a|0)!=(j|0)){if(a|0)ggb(a);k[x>>2]=j;k[l>>2]=1032}e=y+36|0;a=k[e>>2]|0;if(a|0?(w=a+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;do if(!a){a=k[y+32>>2]|0;if(a|0)break;a=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;y=y+16|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[u>>2]|0)>0){d=k[s>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[u>>2]|0))}a=k[q>>2]|0;if(!((a|0)==(t|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=z+36|0;a=k[e>>2]|0;if(a|0?(x=a+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;do if(!a){a=k[z+32>>2]|0;if(a|0)break;a=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;y=z+16|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[c>>2]|0)>0){d=k[z+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[z+44>>2]|0;if((a|0)==(z+48|0)|(a|0)==0){r=A;return}ggb(k[a+-4>>2]|0);r=A;return}function GZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0.0,m=0.0,n=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;B=b>>>2;C=(d|0)!=0;if(C){e=e>>>2;if((f|0)>0){h=f<<2;b=0;do{D=aa(e,b)|0;zpb(d+(D<<2)|0,0,h|0)|0;o[d+(D+b<<2)>>2]=1.0;b=b+1|0}while((b|0)!=(f|0))}}A=aa(f*30|0,f)|0;y=g+3&-4;z=y+(f<<2)|0;if((f|0)<=0)return;r=B+1|0;D=f+-1|0;j=0;do{x=a+((aa(j,r)|0)<<2)|0;k[c+(j<<2)>>2]=k[x>>2];if((j|0)<(D|0)){h=j+1|0;i=aa(j,B)|0;g=j+2|0;if((g|0)<(f|0)){b=h;m=+P(+(+o[a+(i+h<<2)>>2]));while(1){l=+P(+(+o[a+(g+i<<2)>>2]));h=m<l;b=h?g:b;g=g+1|0;if((g|0)==(f|0))break;else m=h?l:m}}else b=h;k[y+(j<<2)>>2]=b}if((j|0)>0){if((j|0)==1)b=0;else{b=0;l=+P(+(+o[a+(j<<2)>>2]));h=1;while(1){g=a+((aa(h,B)|0)+j<<2)|0;m=+P(+(+o[g>>2]));g=l<m;b=g?h:b;h=h+1|0;if((h|0)>=(j|0))break;else l=g?m:l}}k[z+(j<<2)>>2]=b}j=j+1|0}while((j|0)!=(f|0));b=(f|0)>1;a:do if(!(b&(A|0)>0)){if(!b)return}else{w=(D|0)>1;x=(f|0)<1|C^1;v=0;do{b=k[y>>2]|0;l=+P(+(+o[a+(b<<2)>>2]));if(w){h=0;b=1;do{u=aa(b,B)|0;q=+P(+(+o[a+((k[y+(b<<2)>>2]|0)+u<<2)>>2]));u=l<q;l=u?q:l;h=u?b:h;b=b+1|0}while((b|0)!=(D|0));u=k[y+(h<<2)>>2]|0;g=1}else{u=b;h=0;g=1}while(1){t=k[z+(g<<2)>>2]|0;b=a+((aa(t,B)|0)+g<<2)|0;m=+P(+(+o[b>>2]));b=l<m;u=b?g:u;h=b?t:h;g=g+1|0;if((g|0)==(f|0))break;else l=b?m:l}t=aa(h,B)|0;b=a+(t+u<<2)|0;p=+o[b>>2];n=+P(+p);if(n<=1.1920928955078125e-07)break a;g=c+(u<<2)|0;i=c+(h<<2)|0;q=(+o[g>>2]-+o[i>>2])*.5;m=+P(+q);if(!(n>m))if(q!=q|0.0!=0.0|q==0.0)l=0.0;else{l=n/m;l=m*+Q(+(l*l+1.0))}else{l=m/n;l=n*+Q(+(l*l+1.0))}m=m+l;l=+P(+m);if(!(n>l))if(m!=m|0.0!=0.0|m==0.0)l=0.0;else{n=n/l;l=l*+Q(+(n*n+1.0))}else{l=l/n;l=n*+Q(+(l*l+1.0))}n=m/l;l=p/l;p=p*(p/m);r=q<0.0;q=r?-p:p;l=r?-l:l;o[b>>2]=0.0;o[i>>2]=+o[i>>2]-q;o[g>>2]=q+ +o[g>>2];r=(h|0)>0;if(r){b=0;do{s=aa(b,B)|0;j=a+(s+h<<2)|0;p=+o[j>>2];s=a+(s+u<<2)|0;q=+o[s>>2];o[j>>2]=n*p-l*q;o[s>>2]=l*p+n*q;b=b+1|0}while((b|0)!=(h|0))}j=h+1|0;if((j|0)<(u|0)){b=j;do{i=a+(b+t<<2)|0;p=+o[i>>2];s=a+((aa(b,B)|0)+u<<2)|0;q=+o[s>>2];o[i>>2]=n*p-l*q;o[s>>2]=l*p+n*q;b=b+1|0}while((b|0)!=(u|0))}s=u+1|0;if((s|0)<(f|0)){g=aa(u,B)|0;b=s;do{E=a+(b+t<<2)|0;p=+o[E>>2];i=a+(b+g<<2)|0;q=+o[i>>2];o[E>>2]=n*p-l*q;o[i>>2]=l*p+n*q;b=b+1|0}while((b|0)!=(f|0))}if(!x){g=aa(h,e)|0;i=aa(u,e)|0;b=0;do{F=d+(b+g<<2)|0;p=+o[F>>2];E=d+(b+i<<2)|0;q=+o[E>>2];o[F>>2]=n*p-l*q;o[E>>2]=l*p+n*q;b=b+1|0}while((b|0)!=(f|0))}if((h|0)<(D|0)){g=h+2|0;if((g|0)<(f|0)){b=j;m=+P(+(+o[a+(t+j<<2)>>2]));while(1){l=+P(+(+o[a+(g+t<<2)>>2]));i=m<l;b=i?g:b;g=g+1|0;if((g|0)==(f|0))break;else m=i?l:m}}else b=j;k[y+(h<<2)>>2]=b}if(r){if((h|0)==1)b=0;else{l=+P(+(+o[a+(h<<2)>>2]));g=1;b=0;while(1){i=a+((aa(g,B)|0)+h<<2)|0;m=+P(+(+o[i>>2]));i=l<m;b=i?g:b;g=g+1|0;if((g|0)>=(h|0))break;else l=i?m:l}}k[z+(h<<2)>>2]=b}if((u|0)<(D|0)){i=aa(u,B)|0;h=u+2|0;if((h|0)<(f|0)){b=s;m=+P(+(+o[a+(i+s<<2)>>2]));while(1){l=+P(+(+o[a+(h+i<<2)>>2]));g=m<l;b=g?h:b;h=h+1|0;if((h|0)==(f|0))break;else m=g?l:m}}else b=s;k[y+(u<<2)>>2]=b}if((u|0)>0){if((u|0)==1)b=0;else{l=+P(+(+o[a+(u<<2)>>2]));h=1;b=0;while(1){g=a+((aa(h,B)|0)+u<<2)|0;m=+P(+(+o[g>>2]));g=l<m;b=g?h:b;h=h+1|0;if((h|0)>=(u|0))break;else l=g?m:l}}k[z+(u<<2)>>2]=b}v=v+1|0}while((v|0)<(A|0))}while(0);if(C)j=0;else{h=0;do{g=h;h=h+1|0;if((h|0)<(f|0)){e=h;b=g;do{b=+o[c+(b<<2)>>2]<+o[c+(e<<2)>>2]?e:b;e=e+1|0}while((e|0)!=(f|0))}else b=g;if((g|0)!=(b|0)){d=c+(b<<2)|0;F=c+(g<<2)|0;E=k[d>>2]|0;k[d>>2]=k[F>>2];k[F>>2]=E}}while((h|0)!=(D|0));return}do{i=j;j=j+1|0;if((j|0)<(f|0)){h=j;b=i;do{b=+o[c+(b<<2)>>2]<+o[c+(h<<2)>>2]?h:b;h=h+1|0}while((h|0)!=(f|0))}else b=i;if((i|0)!=(b|0)){F=c+(b<<2)|0;g=c+(i<<2)|0;h=k[F>>2]|0;k[F>>2]=k[g>>2];k[g>>2]=h;g=aa(b,e)|0;h=aa(i,e)|0;b=0;do{a=d+(b+g<<2)|0;F=d+(b+h<<2)|0;E=k[a>>2]|0;k[a>>2]=k[F>>2];k[F>>2]=E;b=b+1|0}while((b|0)!=(f|0))}}while((j|0)!=(D|0));return}function HZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;B=b>>>3;C=(d|0)!=0;if(C){e=e>>>3;if((f|0)>0){h=f<<3;b=0;do{D=aa(e,b)|0;zpb(d+(D<<3)|0,0,h|0)|0;p[d+(D+b<<3)>>3]=1.0;b=b+1|0}while((b|0)!=(f|0))}}A=aa(f*30|0,f)|0;y=g+3&-4;z=y+(f<<2)|0;if((f|0)<=0)return;r=B+1|0;D=f+-1|0;j=0;do{x=a+((aa(j,r)|0)<<3)|0;p[c+(j<<3)>>3]=+p[x>>3];if((j|0)<(D|0)){h=j+1|0;i=aa(j,B)|0;g=j+2|0;if((g|0)<(f|0)){b=h;m=+P(+(+p[a+(i+h<<3)>>3]));while(1){l=+P(+(+p[a+(g+i<<3)>>3]));h=m<l;b=h?g:b;g=g+1|0;if((g|0)==(f|0))break;else m=h?l:m}}else b=h;k[y+(j<<2)>>2]=b}if((j|0)>0){if((j|0)==1)b=0;else{b=0;l=+P(+(+p[a+(j<<3)>>3]));h=1;while(1){g=a+((aa(h,B)|0)+j<<3)|0;m=+P(+(+p[g>>3]));g=l<m;b=g?h:b;h=h+1|0;if((h|0)>=(j|0))break;else l=g?m:l}}k[z+(j<<2)>>2]=b}j=j+1|0}while((j|0)!=(f|0));b=(f|0)>1;a:do if(!(b&(A|0)>0)){if(!b)return}else{w=(D|0)>1;x=(f|0)<1|C^1;v=0;do{b=k[y>>2]|0;l=+P(+(+p[a+(b<<3)>>3]));if(w){h=0;b=1;do{u=aa(b,B)|0;q=+P(+(+p[a+((k[y+(b<<2)>>2]|0)+u<<3)>>3]));u=l<q;l=u?q:l;h=u?b:h;b=b+1|0}while((b|0)!=(D|0));u=k[y+(h<<2)>>2]|0;g=1}else{u=b;h=0;g=1}while(1){t=k[z+(g<<2)>>2]|0;b=a+((aa(t,B)|0)+g<<3)|0;m=+P(+(+p[b>>3]));b=l<m;u=b?g:u;h=b?t:h;g=g+1|0;if((g|0)==(f|0))break;else l=b?m:l}t=aa(h,B)|0;b=a+(t+u<<3)|0;o=+p[b>>3];n=+P(+o);if(n<=2.220446049250313e-16)break a;g=c+(u<<3)|0;i=c+(h<<3)|0;q=(+p[g>>3]-+p[i>>3])*.5;m=+P(+q);if(!(n>m))if(q!=q|0.0!=0.0|q==0.0)l=0.0;else{l=n/m;l=m*+Q(+(l*l+1.0))}else{l=m/n;l=n*+Q(+(l*l+1.0))}m=m+l;l=+P(+m);if(!(n>l))if(m!=m|0.0!=0.0|m==0.0)l=0.0;else{n=n/l;l=l*+Q(+(n*n+1.0))}else{l=l/n;l=n*+Q(+(l*l+1.0))}n=m/l;l=o/l;o=o*(o/m);r=q<0.0;q=r?-o:o;l=r?-l:l;p[b>>3]=0.0;p[i>>3]=+p[i>>3]-q;p[g>>3]=q+ +p[g>>3];r=(h|0)>0;if(r){b=0;do{s=aa(b,B)|0;j=a+(s+h<<3)|0;o=+p[j>>3];s=a+(s+u<<3)|0;q=+p[s>>3];p[j>>3]=n*o-l*q;p[s>>3]=l*o+n*q;b=b+1|0}while((b|0)!=(h|0))}j=h+1|0;if((j|0)<(u|0)){b=j;do{i=a+(b+t<<3)|0;o=+p[i>>3];s=a+((aa(b,B)|0)+u<<3)|0;q=+p[s>>3];p[i>>3]=n*o-l*q;p[s>>3]=l*o+n*q;b=b+1|0}while((b|0)!=(u|0))}s=u+1|0;if((s|0)<(f|0)){g=aa(u,B)|0;b=s;do{E=a+(b+t<<3)|0;o=+p[E>>3];i=a+(b+g<<3)|0;q=+p[i>>3];p[E>>3]=n*o-l*q;p[i>>3]=l*o+n*q;b=b+1|0}while((b|0)!=(f|0))}if(!x){g=aa(h,e)|0;i=aa(u,e)|0;b=0;do{F=d+(b+g<<3)|0;o=+p[F>>3];E=d+(b+i<<3)|0;q=+p[E>>3];p[F>>3]=n*o-l*q;p[E>>3]=l*o+n*q;b=b+1|0}while((b|0)!=(f|0))}if((h|0)<(D|0)){g=h+2|0;if((g|0)<(f|0)){b=j;m=+P(+(+p[a+(t+j<<3)>>3]));while(1){l=+P(+(+p[a+(g+t<<3)>>3]));i=m<l;b=i?g:b;g=g+1|0;if((g|0)==(f|0))break;else m=i?l:m}}else b=j;k[y+(h<<2)>>2]=b}if(r){if((h|0)==1)b=0;else{l=+P(+(+p[a+(h<<3)>>3]));g=1;b=0;while(1){i=a+((aa(g,B)|0)+h<<3)|0;m=+P(+(+p[i>>3]));i=l<m;b=i?g:b;g=g+1|0;if((g|0)>=(h|0))break;else l=i?m:l}}k[z+(h<<2)>>2]=b}if((u|0)<(D|0)){i=aa(u,B)|0;h=u+2|0;if((h|0)<(f|0)){b=s;m=+P(+(+p[a+(i+s<<3)>>3]));while(1){l=+P(+(+p[a+(h+i<<3)>>3]));g=m<l;b=g?h:b;h=h+1|0;if((h|0)==(f|0))break;else m=g?l:m}}else b=s;k[y+(u<<2)>>2]=b}if((u|0)>0){if((u|0)==1)b=0;else{l=+P(+(+p[a+(u<<3)>>3]));h=1;b=0;while(1){g=a+((aa(h,B)|0)+u<<3)|0;m=+P(+(+p[g>>3]));g=l<m;b=g?h:b;h=h+1|0;if((h|0)>=(u|0))break;else l=g?m:l}}k[z+(u<<2)>>2]=b}v=v+1|0}while((v|0)<(A|0))}while(0);if(C)j=0;else{h=0;do{g=h;h=h+1|0;if((h|0)<(f|0)){e=h;b=g;do{b=+p[c+(b<<3)>>3]<+p[c+(e<<3)>>3]?e:b;e=e+1|0}while((e|0)!=(f|0))}else b=g;if((g|0)!=(b|0)){E=c+(b<<3)|0;F=c+(g<<3)|0;q=+p[E>>3];p[E>>3]=+p[F>>3];p[F>>3]=q}}while((h|0)!=(D|0));return}do{i=j;j=j+1|0;if((j|0)<(f|0)){h=j;b=i;do{b=+p[c+(b<<3)>>3]<+p[c+(h<<3)>>3]?h:b;h=h+1|0}while((h|0)!=(f|0))}else b=i;if((i|0)!=(b|0)){h=c+(b<<3)|0;g=c+(i<<3)|0;q=+p[h>>3];p[h>>3]=+p[g>>3];p[g>>3]=q;g=aa(b,e)|0;h=aa(i,e)|0;b=0;do{E=d+(b+g<<3)|0;F=d+(b+h<<3)|0;q=+p[E>>3];p[E>>3]=+p[F>>3];p[F>>3]=q;b=b+1|0}while((b|0)!=(f|0))}}while((j|0)!=(D|0));return}function IZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n,q){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;q=q|0;var r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0;J=(d|0)==0?1:d>>>2;B=f>>>2;I=i>>>2;H=k>>>2;G=n>>>2;E=q+7&-8;D=E;F=g?B:1;B=g?1:B;A=(b|0)<(a|0)?b:a;C=(j|0)!=0;x=C?l:a;y=(b|0)>0;z=(x|0)>0;if(y&z){f=x<<2;d=0;do{zpb(m+((aa(d,G)|0)<<2)|0,0,f|0)|0;d=d+1|0}while((d|0)!=(b|0))}if((A|0)>0){r=0.0;d=0}else return;do{w=c+((aa(d,J)|0)<<2)|0;r=r+ +o[w>>2];d=d+1|0}while((d|0)<(A|0));t=r*4.440892098500626e-16;n=(x|0)==1;q=(a|0)>0;g=x+-4|0;l=(x|0)<4;u=x&-4;v=(u|0)<(x|0);w=x<<3;k=0;while(1){i=c+((aa(k,J)|0)<<2)|0;r=+o[i>>2];a:do if(!(+P(+r)<=t)){s=1.0/r;if(n){if(C)if(q){r=0.0;d=0;do{f=e+((aa(d,B)|0)<<2)|0;i=j+((aa(d,H)|0)<<2)|0;r=r+ +o[f>>2]*+o[i>>2];d=d+1|0}while((d|0)!=(a|0))}else r=0.0;else r=+o[e>>2];r=s*r;if(y)d=0;else break;while(1){i=m+((aa(d,G)|0)<<2)|0;o[i>>2]=+o[i>>2]+r*+o[h+(d<<2)>>2];d=d+1|0;if((d|0)==(b|0))break a}}b:do if(C){if(z)zpb(E|0,0,w|0)|0;c:do if(q){if(l){if(z){d=j;f=0}else break b;while(1){i=e+((aa(f,B)|0)<<2)|0;r=+o[i>>2];i=0;do{K=D+(i<<3)|0;p[K>>3]=+p[K>>3]+r*+o[d+(i<<2)>>2];i=i+1|0}while((i|0)!=(x|0));f=f+1|0;if((f|0)==(a|0))break c;else d=d+(H<<2)|0}}if(v){f=j;i=0}else{d=j;i=0;while(1){f=e+((aa(i,B)|0)<<2)|0;r=+o[f>>2];f=0;do{M=D+(f<<3)|0;O=f|1;N=D+(O<<3)|0;L=+p[N>>3]+r*+o[d+(O<<2)>>2];p[M>>3]=+p[M>>3]+r*+o[d+(f<<2)>>2];p[N>>3]=L;N=f|2;M=D+(N<<3)|0;O=f|3;K=D+(O<<3)|0;L=+p[K>>3]+r*+o[d+(O<<2)>>2];p[M>>3]=+p[M>>3]+r*+o[d+(N<<2)>>2];p[K>>3]=L;f=f+4|0}while((f|0)<=(g|0));i=i+1|0;if((i|0)==(a|0))break c;else d=d+(H<<2)|0}}while(1){d=e+((aa(i,B)|0)<<2)|0;r=+o[d>>2];d=0;do{N=D+(d<<3)|0;K=d|1;M=D+(K<<3)|0;L=+p[M>>3]+r*+o[f+(K<<2)>>2];p[N>>3]=+p[N>>3]+r*+o[f+(d<<2)>>2];p[M>>3]=L;M=d|2;N=D+(M<<3)|0;K=d|3;O=D+(K<<3)|0;L=+p[O>>3]+r*+o[f+(K<<2)>>2];p[N>>3]=+p[N>>3]+r*+o[f+(M<<2)>>2];p[O>>3]=L;d=d+4|0}while((d|0)<=(g|0));d=u;do{O=D+(d<<3)|0;p[O>>3]=+p[O>>3]+r*+o[f+(d<<2)>>2];d=d+1|0}while((d|0)!=(x|0));i=i+1|0;if((i|0)==(a|0))break;else f=f+(H<<2)|0}}while(0);if(z){d=0;do{O=D+(d<<3)|0;p[O>>3]=s*+p[O>>3];d=d+1|0}while((d|0)!=(x|0))}}else if(z){d=0;do{O=e+((aa(d,B)|0)<<2)|0;p[D+(d<<3)>>3]=s*+o[O>>2];d=d+1|0}while((d|0)!=(x|0))}while(0);if(y){if(l){if(z){d=m;f=0}else break;while(1){r=+o[h+(f<<2)>>2];i=0;do{O=d+(i<<2)|0;o[O>>2]=+o[O>>2]+r*+p[D+(i<<3)>>3];i=i+1|0}while((i|0)!=(x|0));f=f+1|0;if((f|0)==(b|0))break a;else d=d+(G<<2)|0}}if(v){f=m;i=0}else{d=m;i=0;while(1){r=+o[h+(i<<2)>>2];f=0;do{N=d+(f<<2)|0;K=f|1;M=d+(K<<2)|0;L=+o[M>>2]+r*+p[D+(K<<3)>>3];o[N>>2]=+o[N>>2]+r*+p[D+(f<<3)>>3];o[M>>2]=L;M=f|2;N=d+(M<<2)|0;K=f|3;O=d+(K<<2)|0;L=+o[O>>2]+r*+p[D+(K<<3)>>3];o[N>>2]=+o[N>>2]+r*+p[D+(M<<3)>>3];o[O>>2]=L;f=f+4|0}while((f|0)<=(g|0));i=i+1|0;if((i|0)==(b|0))break a;else d=d+(G<<2)|0}}while(1){r=+o[h+(i<<2)>>2];d=0;do{N=f+(d<<2)|0;K=d|1;M=f+(K<<2)|0;L=+o[M>>2]+r*+p[D+(K<<3)>>3];o[N>>2]=+o[N>>2]+r*+p[D+(d<<3)>>3];o[M>>2]=L;M=d|2;N=f+(M<<2)|0;K=d|3;O=f+(K<<2)|0;L=+o[O>>2]+r*+p[D+(K<<3)>>3];o[N>>2]=+o[N>>2]+r*+p[D+(M<<3)>>3];o[O>>2]=L;d=d+4|0}while((d|0)<=(g|0));d=u;do{O=f+(d<<2)|0;o[O>>2]=+o[O>>2]+r*+p[D+(d<<3)>>3];d=d+1|0}while((d|0)!=(x|0));i=i+1|0;if((i|0)==(b|0))break;else f=f+(G<<2)|0}}}while(0);k=k+1|0;if((k|0)>=(A|0))break;else{e=e+(F<<2)|0;h=h+(I<<2)|0}}return}function JZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var q=0.0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=(d|0)==0?1:d>>>3;w=f>>>3;D=i>>>3;C=k>>>3;B=n>>>3;z=o+7&-8;y=z;A=g?w:1;w=g?1:w;v=(b|0)<(a|0)?b:a;x=(j|0)!=0;l=x?l:a;t=(b|0)>0;u=(l|0)>0;if(t&u){f=l<<3;d=0;do{zpb(m+((aa(d,B)|0)<<3)|0,0,f|0)|0;d=d+1|0}while((d|0)!=(b|0))}if((v|0)>0){q=0.0;d=0}else return;do{g=c+((aa(d,E)|0)<<3)|0;q=q+ +p[g>>3];d=d+1|0}while((d|0)<(v|0));s=q*4.440892098500626e-16;n=(l|0)==1;o=(a|0)>0;g=l<<3;k=e;f=h;i=0;while(1){h=c+((aa(i,E)|0)<<3)|0;q=+p[h>>3];a:do if(!(+P(+q)<=s)){r=1.0/q;if(n){if(x)if(o){q=0.0;d=0;do{e=k+((aa(d,w)|0)<<3)|0;h=j+((aa(d,C)|0)<<3)|0;q=q+ +p[e>>3]*+p[h>>3];d=d+1|0}while((d|0)!=(a|0))}else q=0.0;else q=+p[k>>3];q=r*q;if(t)d=0;else break;while(1){h=m+((aa(d,B)|0)<<3)|0;p[h>>3]=+p[h>>3]+q*+p[f+(d<<3)>>3];d=d+1|0;if((d|0)==(b|0))break a}}do if(!x){if(u){d=0;do{h=k+((aa(d,w)|0)<<3)|0;p[y+(d<<3)>>3]=r*+p[h>>3];d=d+1|0}while((d|0)!=(l|0))}}else{if(!u){KZ(a,l,j,C,k,w,y,0);break}zpb(z|0,0,g|0)|0;KZ(a,l,j,C,k,w,y,0);d=0;do{h=y+(d<<3)|0;p[h>>3]=r*+p[h>>3];d=d+1|0}while((d|0)!=(l|0))}while(0);KZ(b,l,y,0,f,1,m,B)}while(0);i=i+1|0;if((i|0)>=(v|0))break;else{k=k+(A<<3)|0;f=f+(D<<3)|0}}return}function KZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0;if((a|0)<=0)return;n=b+-4|0;if((b|0)<4){l=(b|0)>0;j=g;k=0;while(1){n=e+((aa(k,f)|0)<<3)|0;i=+p[n>>3];if(l){g=0;do{n=j+(g<<3)|0;p[n>>3]=+p[n>>3]+i*+p[c+(g<<3)>>3];g=g+1|0}while((g|0)!=(b|0))}k=k+1|0;if((k|0)==(a|0))break;else{j=j+(h<<3)|0;c=c+(d<<3)|0}}return}l=b&-4;m=(l|0)<(b|0);k=0;while(1){j=e+((aa(k,f)|0)<<3)|0;i=+p[j>>3];j=0;do{r=g+(j<<3)|0;t=j|1;s=g+(t<<3)|0;q=+p[s>>3]+i*+p[c+(t<<3)>>3];p[r>>3]=+p[r>>3]+i*+p[c+(j<<3)>>3];p[s>>3]=q;s=j|2;r=g+(s<<3)|0;t=j|3;o=g+(t<<3)|0;q=+p[o>>3]+i*+p[c+(t<<3)>>3];p[r>>3]=+p[r>>3]+i*+p[c+(s<<3)>>3];p[o>>3]=q;j=j+4|0}while((j|0)<=(n|0));if(m){j=l;do{t=g+(j<<3)|0;p[t>>3]=+p[t>>3]+i*+p[c+(j<<3)>>3];j=j+1|0}while((j|0)!=(b|0))}k=k+1|0;if((k|0)==(a|0))break;else{g=g+(h<<3)|0;c=c+(d<<3)|0}}return}function LZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0.0,m=0.0,n=0,q=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,O=0,R=0,S=0.0,T=0,U=0.0;R=r;r=r+1104|0;M=R;O=M+8|0;k[M>>2]=O;L=M+4|0;k[L>>2]=136;if(g>>>0>136){j=g>>>0>536870911?-1:g<<3;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}k[M>>2]=i;J=i}else J=O;k[L>>2]=g;E=(f|0)<30?30:f;I=b>>>2;G=e>>>2;D=(g|0)>0;a:do if(D){q=(d|0)==0;s=g<<2;if((f|0)>0)i=0;else{i=0;while(1){j=aa(G,i)|0;p[J+(i<<3)>>3]=0.0;if(!q){zpb(d+(j<<2)|0,0,s|0)|0;o[d+(j+i<<2)>>2]=1.0}i=i+1|0;if((i|0)==(g|0))break a}}do{b=aa(G,i)|0;n=d+(b<<2)|0;e=aa(i,I)|0;j=0;l=0.0;do{w=+o[a+(j+e<<2)>>2];l=l+w*w;j=j+1|0}while((j|0)!=(f|0));p[J+(i<<3)>>3]=l;if(!q){zpb(n|0,0,s|0)|0;o[d+(b+i<<2)>>2]=1.0}i=i+1|0}while((i|0)!=(g|0))}while(0);b:do if((E|0)>0){z=g+-1|0;A=(g|0)>1;B=(f|0)>0;C=(d|0)==0;x=0;do{if(A){i=0;y=0}else break b;do{j=y;y=y+1|0;if((y|0)<(g|0)){s=a+((aa(j,I)|0)<<2)|0;t=J+(j<<3)|0;q=d+((aa(j,G)|0)<<2)|0;n=y;do{b=a+((aa(n,I)|0)<<2)|0;m=+p[t>>3];e=J+(n<<3)|0;u=+p[e>>3];if(B){l=0.0;j=0;do{l=l+ +o[s+(j<<2)>>2]*+o[b+(j<<2)>>2];j=j+1|0}while((j|0)!=(f|0))}else l=0.0;if(!(+P(+l)<=+Q(+(m*u))*2.384185791015625e-07)){v=l*2.0;u=m-u;l=+P(+v);m=+P(+u);if(!(l>m))if(u!=u|0.0!=0.0|u==0.0)l=0.0;else{l=l/m;l=m*+Q(+(l*l+1.0))}else{w=m/l;l=l*+Q(+(w*w+1.0))}if(u<0.0){u=+Q(+((l-u)*.5/l));w=v/(l*u*2.0)}else{u=+Q(+((u+l)/(l*2.0)));w=u;u=v/(l*u*2.0)}if(B){m=0.0;l=0.0;i=0;do{T=s+(i<<2)|0;v=+o[T>>2];j=b+(i<<2)|0;U=+o[j>>2];S=w*v+u*U;v=w*U-u*v;o[T>>2]=S;o[j>>2]=v;m=m+S*S;l=l+v*v;i=i+1|0}while((i|0)!=(f|0))}else{m=0.0;l=0.0}p[t>>3]=m;p[e>>3]=l;if(!C?(F=d+((aa(n,G)|0)<<2)|0,D):0){i=0;do{e=q+(i<<2)|0;U=+o[e>>2];T=F+(i<<2)|0;S=+o[T>>2];o[e>>2]=w*U+u*S;o[T>>2]=w*S-u*U;i=i+1|0}while((i|0)!=(g|0));i=1}else i=1}n=n+1|0}while((n|0)!=(g|0))}}while((y|0)!=(z|0));x=x+1|0}while(i&(x|0)<(E|0))}while(0);if(D){s=(f|0)>0;if(s){i=0;do{b=aa(i,I)|0;l=0.0;j=0;do{U=+o[a+(j+b<<2)>>2];l=l+U*U;j=j+1|0}while((j|0)!=(f|0));U=+Q(+l);p[J+(i<<3)>>3]=U;i=i+1|0}while((i|0)!=(g|0))}else zpb(J|0,0,g<<3|0)|0;t=g+-1|0;c:do if((g|0)>1){if(!d){b=0;while(1){e=b;b=b+1|0;if((b|0)<(g|0)){i=e;j=b;do{i=+p[J+(i<<3)>>3]<+p[J+(j<<3)>>3]?j:i;j=j+1|0}while((j|0)!=(g|0))}else i=e;if((e|0)!=(i|0)){G=J+(e<<3)|0;T=J+(i<<3)|0;U=+p[G>>3];p[G>>3]=+p[T>>3];p[T>>3]=U}if((b|0)==(t|0)){i=0;break c}}}else q=0;do{n=q;q=q+1|0;if((q|0)<(g|0)){i=n;j=q;do{i=+p[J+(i<<3)>>3]<+p[J+(j<<3)>>3]?j:i;j=j+1|0}while((j|0)!=(g|0))}else i=n;if((n|0)!=(i|0)){F=J+(n<<3)|0;T=J+(i<<3)|0;U=+p[F>>3];p[F>>3]=+p[T>>3];p[T>>3]=U;if(s){b=aa(n,I)|0;e=aa(i,I)|0;j=0;do{E=a+(j+b<<2)|0;T=a+(j+e<<2)|0;F=k[E>>2]|0;k[E>>2]=k[T>>2];k[T>>2]=F;j=j+1|0}while((j|0)!=(f|0))}b=aa(n,G)|0;j=aa(i,G)|0;i=0;do{E=d+(i+b<<2)|0;T=d+(i+j<<2)|0;F=k[E>>2]|0;k[E>>2]=k[T>>2];k[T>>2]=F;i=i+1|0}while((i|0)!=(g|0))}}while((q|0)!=(t|0));i=0}else i=0;while(0);do{o[c+(i<<2)>>2]=+p[J+(i<<3)>>3];i=i+1|0}while((i|0)!=(g|0))}if((d|0)!=0&(h|0)>0){x=(f|0)>0;u=1.0/+(f|0);v=-u;j=305419896;i=0;y=0;while(1){if((y|0)<(g|0)?(K=+p[J+(y<<3)>>3],!(K<=1.1754943508222875e-38)):0){l=K;e=j;b=i}else{s=aa(y,I)|0;t=(y|0)>0;q=0;while(1){if(x){b=0;do{j=Epb(j|0,0,-130063606,0)|0;j=kpb(j|0,N|0,i|0,0)|0;i=N;o[a+(b+s<<2)>>2]=(j&256|0)!=0|0!=0?u:v;b=b+1|0}while((b|0)!=(f|0))}if(t)if(x){n=0;do{e=aa(n,I)|0;b=0;m=0.0;do{m=m+ +o[a+(b+s<<2)>>2]*+o[a+(b+e<<2)>>2];b=b+1|0}while((b|0)!=(f|0));l=0.0;b=0;do{T=a+(b+s<<2)|0;U=+o[T>>2]-m*+o[a+(b+e<<2)>>2];o[T>>2]=U;l=l+ +P(+U);b=b+1|0}while((b|0)!=(f|0));l=l>2.384185791015625e-05?1.0/l:0.0;b=0;do{T=a+(b+s<<2)|0;o[T>>2]=l*+o[T>>2];b=b+1|0}while((b|0)!=(f|0));n=n+1|0}while((n|0)!=(y|0));if(x){n=0;do{e=aa(n,I)|0;b=0;m=0.0;do{m=m+ +o[a+(b+s<<2)>>2]*+o[a+(b+e<<2)>>2];b=b+1|0}while((b|0)!=(f|0));l=0.0;b=0;do{T=a+(b+s<<2)|0;U=+o[T>>2]-m*+o[a+(b+e<<2)>>2];o[T>>2]=U;l=l+ +P(+U);b=b+1|0}while((b|0)!=(f|0));l=l>2.384185791015625e-05?1.0/l:0.0;b=0;do{T=a+(b+s<<2)|0;o[T>>2]=l*+o[T>>2];b=b+1|0}while((b|0)!=(f|0));n=n+1|0}while((n|0)!=(y|0));H=96}else l=0.0}else l=0.0;else H=96;if((H|0)==96){H=0;if(x){b=0;l=0.0;do{U=+o[a+(b+s<<2)>>2];l=l+U*U;b=b+1|0}while((b|0)!=(f|0))}else l=0.0}l=+Q(+l);if(!(l<=1.1754943508222875e-38)|(q|0)>98){e=j;b=i;break}else q=q+1|0}}l=l>1.1754943508222875e-38?1.0/l:0.0;if(x){j=aa(y,I)|0;i=0;do{T=a+(i+j<<2)|0;o[T>>2]=l*+o[T>>2];i=i+1|0}while((i|0)!=(f|0))}y=y+1|0;if((y|0)==(h|0))break;else{j=e;i=b}}}i=k[M>>2]|0;if((i|0)==(O|0)){r=R;return}if(i|0)ggb(i);k[M>>2]=O;k[L>>2]=136;r=R;return}function MZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0.0,m=0.0,n=0,o=0,q=0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,O=0,R=0.0,S=0,T=0.0;O=r;r=r+1104|0;L=O;M=L+8|0;k[L>>2]=M;K=L+4|0;k[K>>2]=136;if(g>>>0>136){j=g>>>0>536870911?-1:g<<3;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}k[L>>2]=i;I=i}else I=M;k[K>>2]=g;D=(f|0)<30?30:f;H=b>>>3;F=e>>>3;C=(g|0)>0;a:do if(C){b=(d|0)==0;q=g<<3;if((f|0)<=0)if(b){zpb(I|0,0,q|0)|0;break}else{i=0;while(1){B=aa(F,i)|0;p[I+(i<<3)>>3]=0.0;zpb(d+(B<<3)|0,0,q|0)|0;p[d+(B+i<<3)>>3]=1.0;i=i+1|0;if((i|0)==(g|0))break a}}else i=0;do{e=aa(F,i)|0;o=d+(e<<3)|0;n=aa(i,H)|0;j=0;l=0.0;do{v=+p[a+(j+n<<3)>>3];l=l+v*v;j=j+1|0}while((j|0)!=(f|0));p[I+(i<<3)>>3]=l;if(!b){zpb(o|0,0,q|0)|0;p[d+(e+i<<3)>>3]=1.0}i=i+1|0}while((i|0)!=(g|0))}while(0);b:do if((D|0)>0){y=g+-1|0;z=(g|0)>1;A=(f|0)>0;B=(d|0)==0;w=0;do{if(z){i=0;x=0}else break b;do{j=x;x=x+1|0;if((x|0)<(g|0)){q=a+((aa(j,H)|0)<<3)|0;s=I+(j<<3)|0;o=d+((aa(j,F)|0)<<3)|0;n=x;do{b=a+((aa(n,H)|0)<<3)|0;m=+p[s>>3];e=I+(n<<3)|0;t=+p[e>>3];if(A){l=0.0;j=0;do{l=l+ +p[q+(j<<3)>>3]*+p[b+(j<<3)>>3];j=j+1|0}while((j|0)!=(f|0))}else l=0.0;if(!(+P(+l)<=+Q(+(m*t))*2.220446049250313e-15)){u=l*2.0;t=m-t;l=+P(+u);m=+P(+t);if(!(l>m))if(t!=t|0.0!=0.0|t==0.0)l=0.0;else{l=l/m;l=m*+Q(+(l*l+1.0))}else{v=m/l;l=l*+Q(+(v*v+1.0))}if(t<0.0){t=+Q(+((l-t)*.5/l));v=u/(l*t*2.0)}else{t=+Q(+((t+l)/(l*2.0)));v=t;t=u/(l*t*2.0)}if(A){m=0.0;l=0.0;i=0;do{S=q+(i<<3)|0;u=+p[S>>3];j=b+(i<<3)|0;T=+p[j>>3];R=v*u+t*T;u=v*T-t*u;p[S>>3]=R;p[j>>3]=u;m=m+R*R;l=l+u*u;i=i+1|0}while((i|0)!=(f|0))}else{m=0.0;l=0.0}p[s>>3]=m;p[e>>3]=l;if(!B?(E=d+((aa(n,F)|0)<<3)|0,C):0){i=0;do{e=o+(i<<3)|0;T=+p[e>>3];S=E+(i<<3)|0;R=+p[S>>3];p[e>>3]=v*T+t*R;p[S>>3]=v*R-t*T;i=i+1|0}while((i|0)!=(g|0));i=1}else i=1}n=n+1|0}while((n|0)!=(g|0))}}while((x|0)!=(y|0));w=w+1|0}while(i&(w|0)<(D|0))}while(0);if(C){q=(f|0)>0;if(q){i=0;do{b=aa(i,H)|0;l=0.0;j=0;do{T=+p[a+(j+b<<3)>>3];l=l+T*T;j=j+1|0}while((j|0)!=(f|0));T=+Q(+l);p[I+(i<<3)>>3]=T;i=i+1|0}while((i|0)!=(g|0))}else zpb(I|0,0,g<<3|0)|0;s=g+-1|0;c:do if((g|0)>1){if(!d){b=0;while(1){e=b;b=b+1|0;if((b|0)<(g|0)){i=e;j=b;do{i=+p[I+(i<<3)>>3]<+p[I+(j<<3)>>3]?j:i;j=j+1|0}while((j|0)!=(g|0))}else i=e;if((e|0)!=(i|0)){F=I+(e<<3)|0;S=I+(i<<3)|0;T=+p[F>>3];p[F>>3]=+p[S>>3];p[S>>3]=T}if((b|0)==(s|0)){i=0;break c}}}else o=0;do{n=o;o=o+1|0;if((o|0)<(g|0)){i=n;j=o;do{i=+p[I+(i<<3)>>3]<+p[I+(j<<3)>>3]?j:i;j=j+1|0}while((j|0)!=(g|0))}else i=n;if((n|0)!=(i|0)){E=I+(n<<3)|0;S=I+(i<<3)|0;T=+p[E>>3];p[E>>3]=+p[S>>3];p[S>>3]=T;if(q){b=aa(n,H)|0;e=aa(i,H)|0;j=0;do{E=a+(j+b<<3)|0;S=a+(j+e<<3)|0;T=+p[E>>3];p[E>>3]=+p[S>>3];p[S>>3]=T;j=j+1|0}while((j|0)!=(f|0))}b=aa(n,F)|0;j=aa(i,F)|0;i=0;do{E=d+(i+b<<3)|0;S=d+(i+j<<3)|0;T=+p[E>>3];p[E>>3]=+p[S>>3];p[S>>3]=T;i=i+1|0}while((i|0)!=(g|0))}}while((o|0)!=(s|0));i=0}else i=0;while(0);do{p[c+(i<<3)>>3]=+p[I+(i<<3)>>3];i=i+1|0}while((i|0)!=(g|0))}if((d|0)!=0&(h|0)>0){w=(f|0)>0;t=1.0/+(f|0);u=-t;j=305419896;i=0;x=0;while(1){if((x|0)<(g|0)?(J=+p[I+(x<<3)>>3],!(J<=2.2250738585072014e-308)):0){l=J;e=j;b=i}else{q=aa(x,H)|0;s=(x|0)>0;o=0;while(1){if(w){b=0;do{j=Epb(j|0,0,-130063606,0)|0;j=kpb(j|0,N|0,i|0,0)|0;i=N;p[a+(b+q<<3)>>3]=(j&256|0)!=0|0!=0?t:u;b=b+1|0}while((b|0)!=(f|0))}if(s)if(w){n=0;do{e=aa(n,H)|0;b=0;m=0.0;do{m=m+ +p[a+(b+q<<3)>>3]*+p[a+(b+e<<3)>>3];b=b+1|0}while((b|0)!=(f|0));l=0.0;b=0;do{S=a+(b+q<<3)|0;T=+p[S>>3]-m*+p[a+(b+e<<3)>>3];p[S>>3]=T;l=l+ +P(+T);b=b+1|0}while((b|0)!=(f|0));l=l>2.220446049250313e-13?1.0/l:0.0;b=0;do{S=a+(b+q<<3)|0;p[S>>3]=l*+p[S>>3];b=b+1|0}while((b|0)!=(f|0));n=n+1|0}while((n|0)!=(x|0));if(w){n=0;do{e=aa(n,H)|0;b=0;m=0.0;do{m=m+ +p[a+(b+q<<3)>>3]*+p[a+(b+e<<3)>>3];b=b+1|0}while((b|0)!=(f|0));l=0.0;b=0;do{S=a+(b+q<<3)|0;T=+p[S>>3]-m*+p[a+(b+e<<3)>>3];p[S>>3]=T;l=l+ +P(+T);b=b+1|0}while((b|0)!=(f|0));l=l>2.220446049250313e-13?1.0/l:0.0;b=0;do{S=a+(b+q<<3)|0;p[S>>3]=l*+p[S>>3];b=b+1|0}while((b|0)!=(f|0));n=n+1|0}while((n|0)!=(x|0));G=96}else l=0.0}else l=0.0;else G=96;if((G|0)==96){G=0;if(w){b=0;l=0.0;do{T=+p[a+(b+q<<3)>>3];l=l+T*T;b=b+1|0}while((b|0)!=(f|0))}else l=0.0}l=+Q(+l);if(!(l<=2.2250738585072014e-308)|(o|0)>98){e=j;b=i;break}else o=o+1|0}}l=l>2.2250738585072014e-308?1.0/l:0.0;if(w){j=aa(x,H)|0;i=0;do{S=a+(i+j<<3)|0;p[S>>3]=l*+p[S>>3];i=i+1|0}while((i|0)!=(f|0))}x=x+1|0;if((x|0)==(h|0))break;else{j=e;i=b}}}i=k[L>>2]|0;if((i|0)==(M|0)){r=O;return}if(i|0)ggb(i);k[L>>2]=M;k[K>>2]=136;r=O;return}function NZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0,j=0,l=0.0,m=0.0,n=0,q=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0;ma=r;r=r+1616|0;la=ma+1560|0;ka=ma+1504|0;ja=ma+464|0;R=ma+408|0;ha=ma+352|0;ga=ma+296|0;fa=ma;W=ma+240|0;V=ma+184|0;N=ma+128|0;O=ma+72|0;M=ma+56|0;do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[la>>2]=k[h>>2];u=la+4|0;a=h+4|0;k[u>>2]=k[a>>2];ea=la+8|0;k[ea>>2]=k[h+8>>2];k[la+12>>2]=k[h+12>>2];k[la+16>>2]=k[h+16>>2];k[la+20>>2]=k[h+20>>2];k[la+24>>2]=k[h+24>>2];k[la+28>>2]=k[h+28>>2];k[la+32>>2]=k[h+32>>2];e=k[h+36>>2]|0;k[la+36>>2]=e;f=la+40|0;k[f>>2]=ea;ea=la+48|0;n=la+44|0;k[n>>2]=ea;k[la+52>>2]=0;k[ea>>2]=0;if(e|0){ea=e+12|0;k[ea>>2]=(k[ea>>2]|0)+1}if((k[a>>2]|0)<3){da=k[h+44>>2]|0;ea=k[n>>2]|0;k[ea>>2]=k[da>>2];k[ea+4>>2]=k[da+4>>2];break}k[u>>2]=0;x1(la,k[a>>2]|0,0,0,0);if((k[u>>2]|0)>0){t=k[h+40>>2]|0;j=k[f>>2]|0;f=k[h+44>>2]|0;e=k[n>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[t+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[u>>2]|0))}}else Q1(la,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[ka>>2]=k[j>>2];u=ka+4|0;e=j+4|0;k[u>>2]=k[e>>2];ea=ka+8|0;k[ea>>2]=k[j+8>>2];k[ka+12>>2]=k[j+12>>2];k[ka+16>>2]=k[j+16>>2];k[ka+20>>2]=k[j+20>>2];k[ka+24>>2]=k[j+24>>2];k[ka+28>>2]=k[j+28>>2];k[ka+32>>2]=k[j+32>>2];a=k[j+36>>2]|0;k[ka+36>>2]=a;f=ka+40|0;k[f>>2]=ea;ea=ka+48|0;n=ka+44|0;k[n>>2]=ea;k[ka+52>>2]=0;k[ea>>2]=0;if(a|0){ea=a+12|0;k[ea>>2]=(k[ea>>2]|0)+1}if((k[e>>2]|0)<3){ea=k[j+44>>2]|0;t=k[n>>2]|0;k[t>>2]=k[ea>>2];k[t+4>>2]=k[ea+4>>2];t=ka;break}k[u>>2]=0;x1(ka,k[e>>2]|0,0,0,0);if((k[u>>2]|0)>0){t=k[j+40>>2]|0;h=k[f>>2]|0;f=k[j+44>>2]|0;e=k[n>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[t+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[u>>2]|0));t=ka}else t=ka}else{Q1(ka,b,-1);t=ka}while(0);n=k[la>>2]|0;U=n&4095;f=d>>>4;if(!((U+-5|0)>>>0<2?(U|0)==(k[t>>2]&4095|0):0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;e=ZT(64)|0;k[e>>2]=1;H=e+4|0;k[ja>>2]=H;k[a>>2]=58;i[e+62>>0]=0;u=214209;I=H+58|0;do{i[H>>0]=i[u>>0]|0;H=H+1|0;u=u+1|0}while((H|0)<(I|0));Y8(-215,ja,214268,213718,1057);k[a>>2]=0;k[ja>>2]=0;ea=k[e>>2]|0;k[e>>2]=ea+-1;if((ea|0)==1)ggb(k[e+-4>>2]|0)}j=d&-17;a:do switch(d|0){case 0:case 3:case 16:case 19:{a=f&1;e=(a|0)==0;if(e?(k[la+8>>2]|0)!=(k[la+12>>2]|0):0){k[ja>>2]=0;f=ja+4|0;k[f>>2]=0;h=ZT(92)|0;k[h>>2]=1;H=h+4|0;k[ja>>2]=H;k[f>>2]=87;i[h+91>>0]=0;u=214274;I=H+87|0;do{i[H>>0]=i[u>>0]|0;H=H+1|0;u=u+1|0}while((H|0)<(I|0));Y8(-215,ja,214268,213718,1061);k[f>>2]=0;k[ja>>2]=0;ea=k[h>>2]|0;k[h>>2]=ea+-1;if((ea|0)==1)ggb(k[h+-4>>2]|0)}switch(d|0){case 0:case 3:case 16:case 19:break;default:{ia=75;break a}}if(e){E=la+8|0;a=k[E>>2]|0;if(((a|0)<4?(a|0)==(k[la+12>>2]|0):0)?(k[ka+12>>2]|0)==1:0){c2(c,a,1,k[la>>2]&4095,-1,0,0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[ja>>2]=k[h>>2];t=ja+4|0;a=h+4|0;k[t>>2]=k[a>>2];d=ja+8|0;k[d>>2]=k[h+8>>2];k[ja+12>>2]=k[h+12>>2];u=ja+16|0;k[u>>2]=k[h+16>>2];k[ja+20>>2]=k[h+20>>2];k[ja+24>>2]=k[h+24>>2];k[ja+28>>2]=k[h+28>>2];k[ja+32>>2]=k[h+32>>2];e=k[h+36>>2]|0;k[ja+36>>2]=e;f=ja+40|0;k[f>>2]=d;d=ja+48|0;b=ja+44|0;k[b>>2]=d;k[ja+52>>2]=0;k[d>>2]=0;if(e|0){ha=e+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[a>>2]|0)<3){ga=k[h+44>>2]|0;ha=k[b>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2];break}k[t>>2]=0;x1(ja,k[a>>2]|0,0,0,0);if((k[t>>2]|0)>0){n=k[h+40>>2]|0;j=k[f>>2]|0;e=k[h+44>>2]|0;f=k[b>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[n+(a<<2)>>2];k[f+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[t>>2]|0))}}else{Q1(ja,c,-1);u=ja+16|0;b=ja+44|0;d=ja+48|0}while(0);h=k[la+16>>2]|0;t=k[ka+16>>2]|0;F=k[u>>2]|0;f=k[la+48>>2]|0;j=k[ka+48>>2]|0;n=k[d>>2]|0;e=k[E>>2]|0;do if((e|0)==2)if((U|0)==5){s=+o[h>>2];ha=h+f|0;q=+o[ha+4>>2];g=+o[h+4>>2];l=+o[ha>>2];m=s*q-g*l;if(!(m!=0.0)){h=0;break}B=1.0/m;C=+o[t>>2];D=+o[t+j>>2];o[F+n>>2]=B*(s*D-l*C);o[F>>2]=B*(q*C-g*D);h=1;break}else{s=+p[h>>3];ha=h+f|0;q=+p[ha+8>>3];g=+p[h+8>>3];l=+p[ha>>3];m=s*q-g*l;if(!(m!=0.0)){h=0;break}B=1.0/m;C=+p[t>>3];D=+p[t+j>>3];p[F+n>>3]=B*(s*D-l*C);p[F>>3]=B*(q*C-g*D);h=1;break}else{a=(U|0)==5;if((e|0)==3)if(a){C=+o[h>>2];ga=h+f|0;D=+o[ga+4>>2];ha=h+(f<<1)|0;q=+o[ha+8>>2];s=q;v=+o[ga+8>>2];w=+o[ha+4>>2];x=D*s-v*w;y=+o[h+4>>2];z=+o[ga>>2];A=+o[ha>>2];B=s*z-v*A;g=+o[h+8>>2];l=w*z-D*A;m=g*l+(C*x-y*B);if(!(m!=0.0)){h=0;break}na=1.0/m;m=+o[t>>2];pa=+o[t+j>>2];qa=pa;ra=+o[t+(j<<1)>>2];oa=v*ra;w=w*qa;v=D*ra;D=z*ra-A*qa;o[F>>2]=na*(g*(w-v)+(x*m-y*(s*qa-oa)));o[F+n>>2]=na*(g*D+(C*(q*pa-oa)-B*m));o[F+(n<<1)>>2]=na*(l*m+(C*(v-w)-y*D));h=1;break}else{C=+p[h>>3];ga=h+f|0;D=+p[ga+8>>3];ha=h+(f<<1)|0;q=+p[ha+16>>3];s=+p[ga+16>>3];v=+p[ha+8>>3];w=D*q-s*v;x=+p[h+8>>3];y=+p[ga>>3];z=q*y;A=+p[ha>>3];B=s*A;g=+p[h+16>>3];l=v*y-D*A;m=g*l+(C*w-x*(z-B));if(!(m!=0.0)){h=0;break}oa=1.0/m;pa=+p[t>>3];qa=+p[t+j>>3];ra=+p[t+(j<<1)>>3];p[F>>3]=oa*(w*pa+(v*g-q*x)*qa+(s*x-D*g)*ra);p[F+n>>3]=oa*((B-z)*pa+(C*q-A*g)*qa+(y*g-C*s)*ra);p[F+(n<<1)>>3]=oa*(l*pa+(x*A-C*v)*qa+(C*D-x*y)*ra);h=1;break}else if(a){g=+o[h>>2];if(!(g!=0.0)){h=0;break}o[F>>2]=+o[t>>2]/g;h=1;break}else{g=+p[h>>3];if(!(g!=0.0)){h=0;break}p[F>>3]=+p[t>>3]/g;h=1;break}}while(0);f=ja+36|0;a=k[f>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[ja+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;f=ja+4|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[f>>2]|0)>0){e=k[ja+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[b>>2]|0;if(!((a|0)==(d|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=h;h=ka+36|0}else{a=0;ia=75}}else ia=75;break}default:{a=f&1;ia=75}}while(0);if((ia|0)==75){G=(j|0)==4?1:j;J=k[la+8>>2]|0;b=la+12|0;S=k[b>>2]|0;T=k[ka+12>>2]|0;P=(n>>>3&511)+1<<(47696>>>(U<<1&14)&3);K=aa(S,P)|0;Q=K+15&-16;E=(G|0)==1;F=(a|0)==0;L=(aa(J,P)|0)+15&-16;L=F&E?L:Q;da=ja+8|0;k[ja>>2]=da;ea=ja+4|0;k[ea>>2]=1032;k[R>>2]=k[t>>2];$=R+4|0;f=ka+4|0;e=k[f>>2]|0;k[$>>2]=e;ca=R+8|0;k[ca>>2]=k[ka+8>>2];u=R+12|0;k[u>>2]=T;Y=R+16|0;k[Y>>2]=k[ka+16>>2];k[R+20>>2]=k[ka+20>>2];k[R+24>>2]=k[ka+24>>2];k[R+28>>2]=k[ka+28>>2];X=R+32|0;k[X>>2]=k[ka+32>>2];Z=R+36|0;h=ka+36|0;j=k[h>>2]|0;k[Z>>2]=j;_=R+40|0;k[_>>2]=ca;ca=R+48|0;ba=R+44|0;k[ba>>2]=ca;k[R+52>>2]=0;k[ca>>2]=0;if(j){e=j+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[f>>2]|0}if((e|0)>=3){k[$>>2]=0;x1(R,e,0,0,0);if((k[$>>2]|0)>0){f=k[ka+40>>2]|0;j=k[_>>2]|0;n=k[ka+44>>2]|0;t=k[ba>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[f+(e<<2)>>2];k[t+(e<<2)>>2]=k[n+(e<<2)>>2];e=e+1|0}while((e|0)<(k[$>>2]|0))}}else{H=k[ka+44>>2]|0;I=k[ba>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2]}c2(c,k[b>>2]|0,k[u>>2]|0,k[la>>2]&4095,-1,0,0);do if((k[c>>2]&2031616|0)==65536){n=k[c+4>>2]|0;k[ha>>2]=k[n>>2];d=ha+4|0;e=n+4|0;k[d>>2]=k[e>>2];c=ha+8|0;k[c>>2]=k[n+8>>2];k[ha+12>>2]=k[n+12>>2];k[ha+16>>2]=k[n+16>>2];k[ha+20>>2]=k[n+20>>2];k[ha+24>>2]=k[n+24>>2];k[ha+28>>2]=k[n+28>>2];k[ha+32>>2]=k[n+32>>2];f=k[n+36>>2]|0;k[ha+36>>2]=f;j=ha+40|0;k[j>>2]=c;c=ha+48|0;u=ha+44|0;k[u>>2]=c;k[ha+52>>2]=0;k[c>>2]=0;if(f|0){c=f+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[e>>2]|0)<3){I=k[n+44>>2]|0;c=k[u>>2]|0;k[c>>2]=k[I>>2];k[c+4>>2]=k[I+4>>2];break}k[d>>2]=0;x1(ha,k[e>>2]|0,0,0,0);if((k[d>>2]|0)>0){b=k[n+40>>2]|0;t=k[j>>2]|0;j=k[n+44>>2]|0;f=k[u>>2]|0;e=0;do{k[t+(e<<2)>>2]=k[b+(e<<2)>>2];k[f+(e<<2)>>2]=k[j+(e<<2)>>2];e=e+1|0}while((e|0)<(k[d>>2]|0))}}else Q1(ha,c,-1);while(0);if((J|0)<(S|0)){k[ga>>2]=0;e=ga+4|0;k[e>>2]=0;f=ZT(64)|0;k[f>>2]=1;H=f+4|0;k[ga>>2]=H;k[e>>2]=58;i[f+62>>0]=0;u=214362;I=H+58|0;do{i[H>>0]=i[u>>0]|0;H=H+1|0;u=u+1|0}while((H|0)<(I|0));Y8(-5,ga,214268,213718,1210);k[e>>2]=0;k[ga>>2]=0;c=k[f>>2]|0;k[f>>2]=c+-1;if((c|0)==1)ggb(k[f+-4>>2]|0)}if((J|0)==(S|0)){t=0;c=J}else{t=(a|0)!=0;c=F?J:S;G=F?G:E?2:G}j=(G|0)==1;u=aa(t|j?S:J,L)|0;f=aa(K,T)|0;a=(t?f+32|0:32)+u|0;d=(G|0)==2;if((G+-1|0)>>>0<2)a=(T<<3)+32+a+(aa(Q+(P*5|0)|0,S)|0)|0;if((k[ea>>2]|0)>>>0<a>>>0){e=k[ja>>2]|0;if((e|0)!=(da|0)){if(e|0)ggb(e);k[ja>>2]=da;k[ea>>2]=1032}e=da;if(a>>>0>1032){while(1){e=fgb(a)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[ja>>2]=e;k[ea>>2]=a;a=e}else a=e}else{k[ea>>2]=a;a=k[ja>>2]|0}n=a+15&-16;JN(ga,c,S,U,n,L);b:do if(t){k[fa+8>>2]=0;k[fa+12>>2]=0;k[fa>>2]=16842752;k[fa+4>>2]=la;a=W+4|0;L=a+4|0;k[L>>2]=0;k[L+4>>2]=0;k[W>>2]=33619968;k[a>>2]=ga;__(fa,W,1,49332,1.0,-1);a=n+u|0;switch(G|0){case 0:case 3:{k[fa+8>>2]=0;k[fa+12>>2]=0;k[fa>>2]=16842752;k[fa+4>>2]=la;k[W+8>>2]=0;k[W+12>>2]=0;k[W>>2]=16842752;k[W+4>>2]=R;k[N>>2]=1124007936;b=N+4|0;e=N+8|0;t=N+40|0;H=b;I=H+36|0;do{k[H>>2]=0;H=H+4|0}while((H|0)<(I|0));k[t>>2]=e;u=N+48|0;n=N+44|0;k[n>>2]=u;k[N+52>>2]=0;k[u>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;k[V>>2]=16842752;k[V+4>>2]=N;j=O+4|0;e=j+4|0;k[e>>2]=0;k[e+4>>2]=0;k[O>>2]=33619968;k[j>>2]=ha;s_(fa,W,1.0,V,0.0,O,1);j=N+36|0;e=k[j>>2]|0;if(e|0?(O=e+12|0,R=k[O>>2]|0,k[O>>2]=R+-1,(R|0)==1):0){f=k[j>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[N+32>>2]|0;if(e|0)break;e=B1()|0;f=k[j>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[j>>2]=0}k[j>>2]=0;R=N+16|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[b>>2]|0)>0){f=k[t>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[b>>2]|0))}e=k[n>>2]|0;if(!((e|0)==(u|0)|(e|0)==0))ggb(k[e+-4>>2]|0);break b}default:{}}JN(fa,S,T,U,a,0);a=a+f|0;k[W+8>>2]=0;k[W+12>>2]=0;k[W>>2]=16842752;k[W+4>>2]=la;k[V+8>>2]=0;k[V+12>>2]=0;k[V>>2]=16842752;k[V+4>>2]=R;k[O>>2]=1124007936;b=O+4|0;e=O+8|0;t=O+40|0;H=b;I=H+36|0;do{k[H>>2]=0;H=H+4|0}while((H|0)<(I|0));k[t>>2]=e;u=O+48|0;n=O+44|0;k[n>>2]=u;k[O+52>>2]=0;k[u>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;k[N>>2]=16842752;k[N+4>>2]=O;j=M+4|0;e=j+4|0;k[e>>2]=0;k[e+4>>2]=0;k[M>>2]=33619968;k[j>>2]=fa;s_(W,V,1.0,N,0.0,M,1);j=O+36|0;e=k[j>>2]|0;if(e|0?(M=e+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){f=k[j>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[O+32>>2]|0;if(e|0)break;e=B1()|0;f=k[j>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[j>>2]=0}k[j>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[b>>2]|0)>0){f=k[t>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[b>>2]|0))}e=k[n>>2]|0;if(!((e|0)==(u|0)|(e|0)==0))ggb(k[e+-4>>2]|0);KG(R,fa)|0;j=fa+36|0;e=k[j>>2]|0;if(e|0?(O=e+12|0,R=k[O>>2]|0,k[O>>2]=R+-1,(R|0)==1):0){f=k[j>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[fa+32>>2]|0;if(e|0)break;e=B1()|0;f=k[j>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[j>>2]=0}k[j>>2]=0;R=fa+16|0;f=fa+4|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[f>>2]|0)>0){j=k[fa+40>>2]|0;e=0;do{k[j+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[fa+44>>2]|0;if(!((e|0)==(fa+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}else{if(j){JN(fa,S,c,U,n,L);KG(ga,fa)|0;f=fa+36|0;a=k[f>>2]|0;if(a|0?(N=a+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;do if(!a){a=k[fa+32>>2]|0;if(a|0)break;a=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;O=fa+16|0;e=fa+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[e>>2]|0)>0){f=k[fa+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[fa+44>>2]|0;if(!((a|0)==(fa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);k[fa+8>>2]=0;k[fa+12>>2]=0;k[fa>>2]=16842752;k[fa+4>>2]=la;O=W+4|0;N=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[W>>2]=33619968;k[O>>2]=ga;$1(fa,W)}else{O=fa+4|0;N=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[fa>>2]=33619968;k[O>>2]=ga;mY(la,fa)}a=n+u|0;switch(G|0){case 0:case 3:break;default:break b}O=fa+4|0;N=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[fa>>2]=33619968;k[O>>2]=ha;mY(R,fa)}while(0);c:do switch(G|0){case 0:{a=k[ga+16>>2]|0;if((U|0)==5)if(!(t4(a,k[ga+48>>2]|0,S,k[ha+16>>2]|0,k[ha+48>>2]|0,T)|0)){ia=230;break c}else{j=1;break c}else if(!(u4(a,k[ga+48>>2]|0,S,k[ha+16>>2]|0,k[ha+48>>2]|0,T)|0)){ia=230;break c}else{j=1;break c}}case 3:{a=k[ga+16>>2]|0;if((U|0)==5)if(v4(a,k[ga+48>>2]|0,S,k[ha+16>>2]|0,k[ha+48>>2]|0,T)|0){j=1;break c}else{ia=230;break c}else if(w4(a,k[ga+48>>2]|0,S,k[ha+16>>2]|0,k[ha+48>>2]|0,T)|0){j=1;break c}else{ia=230;break c}}default:{e=a+15&-16;JN(fa,S,S,U,e,Q);JN(W,S,1,U,e+(aa(Q,S)|0)|0,0);k[V>>2]=1124007936;G=V+4|0;a=V+8|0;E=V+40|0;H=G;I=H+36|0;do{k[H>>2]=0;H=H+4|0}while((H|0)<(I|0));k[E>>2]=a;F=V+48|0;b=V+44|0;k[b>>2]=F;k[V+52>>2]=0;k[F>>2]=0;u=e+(aa(Q+P|0,S)|0)|0;t=(U|0)==5;a=k[ga+16>>2]|0;e=k[ga+48>>2]|0;H=fa+48|0;f=k[H>>2]|0;if(d){if(t)GZ(a,e,k[W+16>>2]|0,k[fa+16>>2]|0,f,S,u);else HZ(a,e,k[W+16>>2]|0,k[fa+16>>2]|0,f,S,u);KG(V,fa)|0}else{if(t){U=k[fa+16>>2]|0;LZ(a,e,k[W+16>>2]|0,U,f,c,S,(U|0)==0?0:S)}else{U=k[fa+16>>2]|0;MZ(a,e,k[W+16>>2]|0,U,f,c,S,(U|0)==0?0:S)}KG(V,ga)|0}d=W+16|0;a=k[d>>2]|0;e=k[F>>2]|0;f=k[H>>2]|0;j=k[ca>>2]|0;n=k[ha+48>>2]|0;if(t)IZ(c,S,a,0,k[V+16>>2]|0,e,1,k[fa+16>>2]|0,f,k[Y>>2]|0,j,T,k[ha+16>>2]|0,n,u);else JZ(c,S,a,0,k[V+16>>2]|0,e,1,k[fa+16>>2]|0,f,k[Y>>2]|0,j,T,k[ha+16>>2]|0,n,u);f=V+36|0;a=k[f>>2]|0;if(a|0?(T=a+12|0,U=k[T>>2]|0,k[T>>2]=U+-1,(U|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;do if(!a){a=k[V+32>>2]|0;if(a|0)break;a=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;V=V+16|0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[G>>2]|0)>0){e=k[E>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[G>>2]|0))}a=k[b>>2]|0;if(!((a|0)==(F|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=W+36|0;a=k[f>>2]|0;do if(a|0){U=a+12|0;V=k[U>>2]|0;k[U>>2]=V+-1;if((V|0)!=1)break;e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;do if(!a){a=k[W+32>>2]|0;if(a|0)break;a=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}while(0);k[f>>2]=0;f=W+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[f>>2]|0)>0){e=k[W+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[W+44>>2]|0;if(!((a|0)==(W+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=fa+36|0;a=k[f>>2]|0;do if(a|0){V=a+12|0;W=k[V>>2]|0;k[V>>2]=W+-1;if((W|0)!=1)break;e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;do if(!a){a=k[fa+32>>2]|0;if(a|0)break;a=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}while(0);k[f>>2]=0;W=fa+16|0;e=fa+4|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[e>>2]|0)>0){f=k[fa+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[fa+44>>2]|0;if(!((a|0)==(H|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=1}}while(0);if((ia|0)==230){k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=0;k[fa+12>>2]=0;k[fa+16>>2]=0;k[fa+20>>2]=0;k[fa+24>>2]=0;k[fa+28>>2]=0;oY(ha,fa);j=0}f=ga+36|0;a=k[f>>2]|0;if(a|0?(fa=a+12|0,ia=k[fa>>2]|0,k[fa>>2]=ia+-1,(ia|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[ga+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;ia=ga+16|0;e=ga+4|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[e>>2]|0)>0){f=k[ga+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[ga+44>>2]|0;if(!((a|0)==(ga+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=ha+36|0;a=k[f>>2]|0;if(a|0?(ga=a+12|0,ia=k[ga>>2]|0,k[ga>>2]=ia+-1,(ia|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;do if(!a){a=k[ha+32>>2]|0;if(a|0)break;a=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;ia=ha+16|0;e=ha+4|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[e>>2]|0)>0){f=k[ha+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[ha+44>>2]|0;if(!((a|0)==(ha+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[Z>>2]|0;do if(a|0){ha=a+12|0;ia=k[ha>>2]|0;k[ha>>2]=ia+-1;if((ia|0)!=1)break;e=k[Z>>2]|0;if(e|0){a=k[e+4>>2]|0;do if(!a){a=k[X>>2]|0;if(a|0)break;a=B1()|0;e=k[Z>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[Z>>2]=0}while(0);k[Z>>2]=0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[$>>2]|0)>0){e=k[_>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[$>>2]|0))}a=k[ba>>2]|0;if(!((a|0)==(ca|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[ja>>2]|0;if((a|0)!=(da|0)){if(a|0)ggb(a);k[ja>>2]=da;k[ea>>2]=1032}}a=k[h>>2]|0;if(a|0?(ia=a+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){f=ka+36|0;e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[ka+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[h>>2]=0;ja=ka+16|0;e=ka+4|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[e>>2]|0)>0){f=k[ka+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[ka+44>>2]|0;if(!((a|0)==(ka+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=la+36|0;a=k[f>>2]|0;if(a|0?(ja=a+12|0,ka=k[ja>>2]|0,k[ja>>2]=ka+-1,(ka|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[la+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;ka=la+16|0;e=la+4|0;k[ka>>2]=0;k[ka+4>>2]=0;k[ka+8>>2]=0;k[ka+12>>2]=0;if((k[e>>2]|0)>0){f=k[la+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[la+44>>2]|0;if((a|0)==(la+48|0)|(a|0)==0){r=ma;return j|0}ggb(k[a+-4>>2]|0);r=ma;return j|0}function OZ(a){a=a|0;var b=0,c=0,d=0;d=a+148|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+144>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+128|0;c=a+116|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+152>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+156>>2]|0;if(!((b|0)==(a+160|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+92|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+88>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+72|0;c=a+60|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+96>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+100>>2]|0;if(!((b|0)==(a+104|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+36|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+16|0;d=a+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+44>>2]|0;if((b|0)==(a+48|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function PZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0;o=r;r=r+64|0;n=o;if((c|0)<0&(d|0)>255){n=1;r=o;return n|0}if((d|0)<(c|0)|((c|0)>255|(d|0)<0)){k[b>>2]=0;k[b+4>>2]=0;n=0;r=o;return n|0}_1(n,a,1,0);i=k[n+8>>2]|0;a:do if((i|0)>0?(j=k[n+12>>2]|0,m=k[n+16>>2]|0,(j|0)>0):0){h=k[k[n+44>>2]>>2]|0;e=0;b:while(1){g=m+(aa(h,e)|0)|0;f=0;do{p=l[g+f>>0]|0;if((p|0)<(c|0)|(p|0)>(d|0))break b;f=f+1|0}while((f|0)<(j|0));e=e+1|0;if((e|0)>=(i|0)){h=1;break a}}k[b+4>>2]=e;k[b>>2]=(f|0)/(((k[a>>2]|0)>>>3&511)+1|0)|0;h=0}else h=1;while(0);g=n+36|0;e=k[g>>2]|0;if(e|0?(d=e+12|0,p=k[d>>2]|0,k[d>>2]=p+-1,(p|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[n+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;p=n+16|0;f=n+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[f>>2]|0)>0){g=k[n+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[n+44>>2]|0;if(!((e|0)==(n+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);p=h;r=o;return p|0}function QZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;o=r;r=r+64|0;n=o;if((c|0)<-128&(d|0)>127){n=1;r=o;return n|0}if((d|0)<(c|0)|((c|0)>127|(d|0)<-128)){k[b>>2]=0;k[b+4>>2]=0;n=0;r=o;return n|0}_1(n,a,1,0);j=k[n+8>>2]|0;a:do if((j|0)>0?(l=k[n+12>>2]|0,m=k[n+16>>2]|0,(l|0)>0):0){h=k[k[n+44>>2]>>2]|0;e=0;b:while(1){g=m+(aa(h,e)|0)|0;f=0;do{p=i[g+f>>0]|0;if((p|0)<(c|0)|(p|0)>(d|0))break b;f=f+1|0}while((f|0)<(l|0));e=e+1|0;if((e|0)>=(j|0)){h=1;break a}}k[b+4>>2]=e;k[b>>2]=(f|0)/(((k[a>>2]|0)>>>3&511)+1|0)|0;h=0}else h=1;while(0);g=n+36|0;e=k[g>>2]|0;if(e|0?(d=e+12|0,p=k[d>>2]|0,k[d>>2]=p+-1,(p|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[n+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;p=n+16|0;f=n+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[f>>2]|0)>0){g=k[n+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[n+44>>2]|0;if(!((e|0)==(n+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);p=h;r=o;return p|0}function RZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,n=0,o=0,p=0;o=r;r=r+64|0;n=o;if((c|0)<0&(d|0)>65535){n=1;r=o;return n|0}if((d|0)<(c|0)|((c|0)>65535|(d|0)<0)){k[b>>2]=0;k[b+4>>2]=0;n=0;r=o;return n|0}_1(n,a,1,0);i=k[n+8>>2]|0;a:do if((i|0)>0?(j=k[n+12>>2]|0,l=k[n+16>>2]|0,(j|0)>0):0){h=k[k[n+44>>2]>>2]|0;e=0;b:while(1){g=l+(aa(h,e)|0)|0;f=0;do{p=m[g+(f<<1)>>1]|0;if((p|0)<(c|0)|(p|0)>(d|0))break b;f=f+1|0}while((f|0)<(j|0));e=e+1|0;if((e|0)>=(i|0)){h=1;break a}}k[b+4>>2]=e;k[b>>2]=(f|0)/(((k[a>>2]|0)>>>3&511)+1|0)|0;h=0}else h=1;while(0);g=n+36|0;e=k[g>>2]|0;if(e|0?(d=e+12|0,p=k[d>>2]|0,k[d>>2]=p+-1,(p|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[n+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;p=n+16|0;f=n+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[f>>2]|0)>0){g=k[n+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[n+44>>2]|0;if(!((e|0)==(n+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);p=h;r=o;return p|0}function SZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0;o=r;r=r+64|0;n=o;if((c|0)<-32768&(d|0)>32767){n=1;r=o;return n|0}if((d|0)<(c|0)|((c|0)>32767|(d|0)<-32768)){k[b>>2]=0;k[b+4>>2]=0;n=0;r=o;return n|0}_1(n,a,1,0);i=k[n+8>>2]|0;a:do if((i|0)>0?(l=k[n+12>>2]|0,m=k[n+16>>2]|0,(l|0)>0):0){h=k[k[n+44>>2]>>2]|0;e=0;b:while(1){g=m+(aa(h,e)|0)|0;f=0;do{p=j[g+(f<<1)>>1]|0;if((p|0)<(c|0)|(p|0)>(d|0))break b;f=f+1|0}while((f|0)<(l|0));e=e+1|0;if((e|0)>=(i|0)){h=1;break a}}k[b+4>>2]=e;k[b>>2]=(f|0)/(((k[a>>2]|0)>>>3&511)+1|0)|0;h=0}else h=1;while(0);g=n+36|0;e=k[g>>2]|0;if(e|0?(d=e+12|0,p=k[d>>2]|0,k[d>>2]=p+-1,(p|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[n+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;p=n+16|0;f=n+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[f>>2]|0)>0){g=k[n+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[n+44>>2]|0;if(!((e|0)==(n+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);p=h;r=o;return p|0}function TZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;n=r;r=r+64|0;m=n;if((d|0)<(c|0)){k[b>>2]=0;k[b+4>>2]=0;m=0;r=n;return m|0}_1(m,a,1,0);l=k[m+8>>2]|0;a:do if((l|0)>0?(i=k[m+12>>2]|0,j=k[m+16>>2]|0,(i|0)>0):0){h=k[k[m+44>>2]>>2]|0;e=0;b:while(1){g=j+(aa(h,e)|0)|0;f=0;do{o=k[g+(f<<2)>>2]|0;if((o|0)<(c|0)|(o|0)>(d|0))break b;f=f+1|0}while((f|0)<(i|0));e=e+1|0;if((e|0)>=(l|0)){h=1;break a}}k[b+4>>2]=e;k[b>>2]=(f|0)/(((k[a>>2]|0)>>>3&511)+1|0)|0;h=0}else h=1;while(0);g=m+36|0;e=k[g>>2]|0;if(e|0?(l=e+12|0,o=k[l>>2]|0,k[l>>2]=o+-1,(o|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[m+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;o=m+16|0;f=m+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[f>>2]|0)>0){g=k[m+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[m+44>>2]|0;if(!((e|0)==(m+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);o=h;r=n;return o|0}function UZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0;z=r;r=r+240|0;y=z+176|0;x=z+120|0;w=z+64|0;n=z+48|0;u=z+32|0;v=z;d=S1(a,-1)|0;q=(S1(a,-1)|0)&7;m=((S1(a,-1)|0)>>>3&511)+1|0;R1(y,a,-1);R1(x,b,-1);do if((k[y>>2]|0)==(k[x>>2]|0)?(k[y+4>>2]|0)==(k[x+4>>2]|0):0)if((d|0)==(S1(b,-1)|0)?(q+-5|0)>>>0<2:0)break;else{e=6;break}else e=6;while(0);if((e|0)==6){d=y+4|0;e=ZT(96)|0;k[e>>2]=1;f=e+4|0;k[y>>2]=f;k[d>>2]=89;i[e+93>>0]=0;g=214421;h=f+89|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,y,214511,214521,174);k[d>>2]=0;k[y>>2]=0;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)ggb(k[e+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[y>>2]=k[g>>2];l=y+4|0;d=g+4|0;k[l>>2]=k[d>>2];t=y+8|0;k[t>>2]=k[g+8>>2];k[y+12>>2]=k[g+12>>2];k[y+16>>2]=k[g+16>>2];k[y+20>>2]=k[g+20>>2];k[y+24>>2]=k[g+24>>2];k[y+28>>2]=k[g+28>>2];k[y+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[y+36>>2]=e;f=y+40|0;k[f>>2]=t;t=y+48|0;a=y+44|0;k[a>>2]=t;k[y+52>>2]=0;k[t>>2]=0;if(e|0){t=e+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[d>>2]|0)<3){s=k[g+44>>2]|0;t=k[a>>2]|0;k[t>>2]=k[s>>2];k[t+4>>2]=k[s+4>>2];break}k[l>>2]=0;x1(y,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[a>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else Q1(y,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[x>>2]=k[g>>2];l=x+4|0;d=g+4|0;k[l>>2]=k[d>>2];t=x+8|0;k[t>>2]=k[g+8>>2];k[x+12>>2]=k[g+12>>2];k[x+16>>2]=k[g+16>>2];k[x+20>>2]=k[g+20>>2];k[x+24>>2]=k[g+24>>2];k[x+28>>2]=k[g+28>>2];k[x+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[x+36>>2]=e;f=x+40|0;k[f>>2]=t;t=x+48|0;a=x+44|0;k[a>>2]=t;k[x+52>>2]=0;k[t>>2]=0;if(e|0){t=e+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[d>>2]|0)<3){s=k[g+44>>2]|0;t=k[a>>2]|0;k[t>>2]=k[s>>2];k[t+4>>2]=k[s+4>>2];break}k[l>>2]=0;x1(x,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[a>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else Q1(x,b,-1);while(0);t=y+4|0;s=y+40|0;P1(c,k[t>>2]|0,k[s>>2]|0,k[y>>2]&4095,-1,0,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[w>>2]=k[g>>2];l=w+4|0;d=g+4|0;k[l>>2]=k[d>>2];c=w+8|0;k[c>>2]=k[g+8>>2];k[w+12>>2]=k[g+12>>2];k[w+16>>2]=k[g+16>>2];k[w+20>>2]=k[g+20>>2];k[w+24>>2]=k[g+24>>2];k[w+28>>2]=k[g+28>>2];k[w+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[w+36>>2]=e;f=w+40|0;k[f>>2]=c;c=w+48|0;a=w+44|0;k[a>>2]=c;k[w+52>>2]=0;k[c>>2]=0;if(e|0){c=e+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[d>>2]|0)<3){b=k[g+44>>2]|0;c=k[a>>2]|0;k[c>>2]=k[b>>2];k[c+4>>2]=k[b+4>>2];break}k[l>>2]=0;x1(w,k[d>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[a>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else Q1(w,c,-1);while(0);k[n>>2]=y;k[n+4>>2]=x;k[n+8>>2]=w;k[n+12>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;k[v+16>>2]=0;k[v+20>>2]=0;k[v+24>>2]=0;k[v+28>>2]=0;z1(v,n,0,u,-1);a=aa(k[v+20>>2]|0,m)|0;j=v+16|0;l=u+4|0;b=u+8|0;c=(a|0)>0;a:do if((q|0)==5){e=0;while(1){if(e>>>0>=(k[j>>2]|0)>>>0)break a;f=k[u>>2]|0;g=k[l>>2]|0;h=k[b>>2]|0;if(c){d=0;do{B=+o[f+(d<<2)>>2];A=+o[g+(d<<2)>>2];A=+Q(+(B*B+A*A));o[h+(d<<2)>>2]=A;d=d+1|0}while((d|0)!=(a|0))}A1(v);e=e+1|0}}else{e=0;while(1){if(e>>>0>=(k[j>>2]|0)>>>0)break a;f=k[u>>2]|0;g=k[l>>2]|0;h=k[b>>2]|0;if(c){d=0;do{A=+p[f+(d<<3)>>3];B=+p[g+(d<<3)>>3];B=+Q(+(A*A+B*B));p[h+(d<<3)>>3]=B;d=d+1|0}while((d|0)!=(a|0))}A1(v);e=e+1|0}}while(0);f=w+36|0;d=k[f>>2]|0;if(d|0?(u=d+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[w+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;v=w+16|0;e=w+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[e>>2]|0)>0){f=k[w+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[w+44>>2]|0;if(!((d|0)==(w+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=x+36|0;d=k[f>>2]|0;if(d|0?(v=d+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[x+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;w=x+16|0;e=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[e>>2]|0)>0){f=k[x+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[x+44>>2]|0;if(!((d|0)==(x+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=y+36|0;d=k[f>>2]|0;if(d|0?(w=d+12|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[y+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;x=y+16|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[t>>2]|0)>0){e=k[s>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[t>>2]|0))}d=k[y+44>>2]|0;if((d|0)==(y+48|0)|(d|0)==0){r=z;return}ggb(k[d+-4>>2]|0);r=z;return}function VZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0.0,q=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0;S=r;r=r+1296|0;R=S+1240|0;Q=S+1184|0;O=S+1128|0;v=S+1112|0;K=S+1096|0;L=S+1064|0;M=S;u=S1(a,-1)|0;E=(S1(a,-1)|0)&7;w=(S1(a,-1)|0)>>>3&511;x=w+1|0;R1(R,a,-1);R1(Q,b,-1);do if((k[R>>2]|0)==(k[Q>>2]|0)?(k[R+4>>2]|0)==(k[Q+4>>2]|0):0)if((u|0)==(S1(b,-1)|0)?(E+-5|0)>>>0<2:0)break;else{e=6;break}else e=6;while(0);if((e|0)==6){e=R+4|0;f=ZT(96)|0;k[f>>2]=1;g=f+4|0;k[R>>2]=g;k[e>>2]=89;i[f+93>>0]=0;h=214421;j=g+89|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,R,214589,214521,209);k[e>>2]=0;k[R>>2]=0;N=k[f>>2]|0;k[f>>2]=N+-1;if((N|0)==1)ggb(k[f+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[R>>2]=k[h>>2];m=R+4|0;e=h+4|0;k[m>>2]=k[e>>2];N=R+8|0;k[N>>2]=k[h+8>>2];k[R+12>>2]=k[h+12>>2];k[R+16>>2]=k[h+16>>2];k[R+20>>2]=k[h+20>>2];k[R+24>>2]=k[h+24>>2];k[R+28>>2]=k[h+28>>2];k[R+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[R+36>>2]=f;g=R+40|0;k[g>>2]=N;N=R+48|0;a=R+44|0;k[a>>2]=N;k[R+52>>2]=0;k[N>>2]=0;if(f|0){N=f+12|0;k[N>>2]=(k[N>>2]|0)+1}if((k[e>>2]|0)<3){J=k[h+44>>2]|0;N=k[a>>2]|0;k[N>>2]=k[J>>2];k[N+4>>2]=k[J+4>>2];break}k[m>>2]=0;x1(R,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[a>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else Q1(R,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[Q>>2]=k[h>>2];m=Q+4|0;e=h+4|0;k[m>>2]=k[e>>2];N=Q+8|0;k[N>>2]=k[h+8>>2];k[Q+12>>2]=k[h+12>>2];k[Q+16>>2]=k[h+16>>2];k[Q+20>>2]=k[h+20>>2];k[Q+24>>2]=k[h+24>>2];k[Q+28>>2]=k[h+28>>2];k[Q+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[Q+36>>2]=f;g=Q+40|0;k[g>>2]=N;N=Q+48|0;a=Q+44|0;k[a>>2]=N;k[Q+52>>2]=0;k[N>>2]=0;if(f|0){N=f+12|0;k[N>>2]=(k[N>>2]|0)+1}if((k[e>>2]|0)<3){J=k[h+44>>2]|0;N=k[a>>2]|0;k[N>>2]=k[J>>2];k[N+4>>2]=k[J+4>>2];break}k[m>>2]=0;x1(Q,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[a>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else Q1(Q,b,-1);while(0);N=R+4|0;J=R+40|0;P1(c,k[N>>2]|0,k[J>>2]|0,u,-1,0,0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[O>>2]=k[h>>2];m=O+4|0;e=h+4|0;k[m>>2]=k[e>>2];I=O+8|0;k[I>>2]=k[h+8>>2];k[O+12>>2]=k[h+12>>2];k[O+16>>2]=k[h+16>>2];k[O+20>>2]=k[h+20>>2];k[O+24>>2]=k[h+24>>2];k[O+28>>2]=k[h+28>>2];k[O+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[O+36>>2]=f;g=O+40|0;k[g>>2]=I;I=O+48|0;a=O+44|0;k[a>>2]=I;k[O+52>>2]=0;k[I>>2]=0;if(f|0){I=f+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[e>>2]|0)<3){H=k[h+44>>2]|0;I=k[a>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2];break}k[m>>2]=0;x1(O,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[a>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else Q1(O,c,-1);while(0);k[v>>2]=R;k[v+4>>2]=Q;k[v+8>>2]=O;k[v+12>>2]=0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;k[L+16>>2]=0;k[L+20>>2]=0;k[L+24>>2]=0;k[L+28>>2]=0;z1(L,v,0,K,-1);H=M+8|0;k[M>>2]=H;I=M+4|0;k[I>>2]=264;F=aa(k[L+20>>2]|0,x)|0;G=1212424721>>>(k[R>>2]<<2&28)&15;if((E|0)==6){h=w|1024;h=h-((h>>>0)%(x>>>0)|0)|0;h=(h|0)<(F|0)?h:F;g=h<<1;if(g>>>0>264){f=g>>>0>1073741823?-1:g<<2;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[M>>2]=e}else e=H;k[I>>2]=g;C=h;D=e;z=e+(h<<2)|0}else{C=F;D=0;z=0}A=L+16|0;B=(F|0)>0;v=(E|0)==5;w=K+4|0;x=K+8|0;y=d?1.0:.01745329238474369;c=0;while(1){if(c>>>0>=(k[A>>2]|0)>>>0)break;do if(B){if(v){j=k[K>>2]|0;a=k[w>>2]|0;h=k[x>>2]|0;e=0;l=j;m=a;b=h;while(1){g=F-e|0;g=(C|0)<(g|0)?C:g;if((g|0)>0){f=0;do{s=+o[l+(f<<2)>>2];t=+o[m+(f<<2)>>2];n=+P(+s);q=+P(+t);if(!(n>=q)){q=n/(q+2.220446049250313e-16);n=q*q;n=90.0-q*(n*(n*(8.914000511169434-n*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{q=q/(n+2.220446049250313e-16);n=q*q;n=q*(n*(n*(8.914000511169434-n*2.539724588394165)+-18.66744613647461)+57.283626556396484)}s=s<0.0?180.0-n:n;o[b+(f<<2)>>2]=y*(t<0.0?360.0-s:s);f=f+1|0}while((f|0)!=(g|0))}d=aa(g,G)|0;f=j+d|0;g=a+d|0;h=h+d|0;e=e+C|0;if((F|0)>(e|0)){l=f;m=g;b=h;j=f;a=g}else break}k[K>>2]=f;k[w>>2]=g;k[x>>2]=h;break}l=k[K>>2]|0;m=k[w>>2]|0;b=k[x>>2]|0;e=0;j=l;a=m;u=b;while(1){h=F-e|0;h=(C|0)<(h|0)?C:h;if((h|0)>0){f=0;do{o[D+(f<<2)>>2]=+p[j+(f<<3)>>3];o[z+(f<<2)>>2]=+p[a+(f<<3)>>3];f=f+1|0}while((f|0)<(h|0));f=0;do{g=D+(f<<2)|0;s=+o[g>>2];t=+o[z+(f<<2)>>2];n=+P(+s);q=+P(+t);if(!(n>=q)){q=n/(q+2.220446049250313e-16);n=q*q;n=90.0-q*(n*(n*(8.914000511169434-n*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{q=q/(n+2.220446049250313e-16);n=q*q;n=q*(n*(n*(8.914000511169434-n*2.539724588394165)+-18.66744613647461)+57.283626556396484)}s=s<0.0?180.0-n:n;o[g>>2]=y*(t<0.0?360.0-s:s);f=f+1|0}while((f|0)!=(h|0));f=0;do{p[u+(f<<3)>>3]=+o[D+(f<<2)>>2];f=f+1|0}while((f|0)<(h|0))}h=aa(h,G)|0;f=l+h|0;g=m+h|0;h=b+h|0;e=e+C|0;if((F|0)>(e|0)){j=f;a=g;u=h;l=f;m=g;b=h}else break}k[K>>2]=f;k[w>>2]=g;k[x>>2]=h}while(0);A1(L);c=c+1|0}e=k[M>>2]|0;if((e|0)!=(H|0)){if(e|0)ggb(e);k[M>>2]=H;k[I>>2]=264}g=O+36|0;e=k[g>>2]|0;if(e|0?(L=e+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[O+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;M=O+16|0;f=O+4|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[f>>2]|0)>0){g=k[O+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[O+44>>2]|0;if(!((e|0)==(O+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=Q+36|0;e=k[g>>2]|0;if(e|0?(M=e+12|0,O=k[M>>2]|0,k[M>>2]=O+-1,(O|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[Q+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;O=Q+16|0;f=Q+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[f>>2]|0)>0){g=k[Q+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[Q+44>>2]|0;if(!((e|0)==(Q+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=R+36|0;e=k[g>>2]|0;if(e|0?(O=e+12|0,Q=k[O>>2]|0,k[O>>2]=Q+-1,(Q|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[R+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;Q=R+16|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[N>>2]|0)>0){f=k[J>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[N>>2]|0))}e=k[R+44>>2]|0;if((e|0)==(R+48|0)|(e|0)==0){r=S;return}ggb(k[e+-4>>2]|0);r=S;return}function WZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;X=r;r=r+1360|0;W=X+1304|0;V=X+1248|0;U=X+1192|0;S=X+1136|0;A=X+1112|0;M=X+1096|0;N=X+1064|0;O=X;do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[W>>2]=k[h>>2];n=W+4|0;a=h+4|0;k[n>>2]=k[a>>2];T=W+8|0;k[T>>2]=k[h+8>>2];k[W+12>>2]=k[h+12>>2];k[W+16>>2]=k[h+16>>2];k[W+20>>2]=k[h+20>>2];k[W+24>>2]=k[h+24>>2];k[W+28>>2]=k[h+28>>2];k[W+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[W+36>>2]=f;g=W+40|0;k[g>>2]=T;T=W+48|0;l=W+44|0;k[l>>2]=T;k[W+52>>2]=0;k[T>>2]=0;if(f|0){T=f+12|0;k[T>>2]=(k[T>>2]|0)+1}if((k[a>>2]|0)<3){R=k[h+44>>2]|0;T=k[l>>2]|0;k[T>>2]=k[R>>2];k[T+4>>2]=k[R+4>>2];break}k[n>>2]=0;x1(W,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(W,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[V>>2]=k[g>>2];n=V+4|0;f=g+4|0;k[n>>2]=k[f>>2];T=V+8|0;k[T>>2]=k[g+8>>2];k[V+12>>2]=k[g+12>>2];k[V+16>>2]=k[g+16>>2];k[V+20>>2]=k[g+20>>2];k[V+24>>2]=k[g+24>>2];k[V+28>>2]=k[g+28>>2];k[V+32>>2]=k[g+32>>2];a=k[g+36>>2]|0;k[V+36>>2]=a;m=V+40|0;k[m>>2]=T;T=V+48|0;h=V+44|0;k[h>>2]=T;k[V+52>>2]=0;k[T>>2]=0;if(a|0){T=a+12|0;k[T>>2]=(k[T>>2]|0)+1}if((k[f>>2]|0)<3){R=k[g+44>>2]|0;T=k[h>>2]|0;k[T>>2]=k[R>>2];k[T+4>>2]=k[R+4>>2];break}k[n>>2]=0;x1(V,k[f>>2]|0,0,0,0);if((k[n>>2]|0)>0){j=k[g+40>>2]|0;l=k[m>>2]|0;g=k[g+44>>2]|0;f=k[h>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[j+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else{Q1(V,b,-1);m=V+40|0}while(0);w=k[W>>2]|0;l=w&4095;y=w&7;w=w>>>3&511;x=w+1|0;T=W+40|0;a=k[T>>2]|0;g=k[a+-4>>2]|0;h=k[m>>2]|0;a:do if((g|0)==(k[h+-4>>2]|0)){if((g|0)==2){if((k[a>>2]|0)!=(k[h>>2]|0)){v=27;break}if((k[a+4>>2]|0)!=(k[h+4>>2]|0)){v=27;break}}else if((g|0)>0){f=0;do{if((k[a+(f<<2)>>2]|0)!=(k[h+(f<<2)>>2]|0)){v=27;break a}f=f+1|0}while((f|0)<(g|0))}if(!((y+-5|0)>>>0<2?(l|0)==(k[V>>2]&4095|0):0))v=27}else v=27;while(0);if((v|0)==27){k[U>>2]=0;a=U+4|0;k[a>>2]=0;f=ZT(84)|0;k[f>>2]=1;g=f+4|0;k[U>>2]=g;k[a>>2]=76;i[f+80>>0]=0;h=214595;j=g+76|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,U,214672,214521,348);k[a>>2]=0;k[U>>2]=0;R=k[f>>2]|0;k[f>>2]=R+-1;if((R|0)==1)ggb(k[f+-4>>2]|0);a=k[T>>2]|0}R=W+4|0;P1(c,k[R>>2]|0,a,l,-1,0,0);P1(d,k[R>>2]|0,k[T>>2]|0,l,-1,0,0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[U>>2]=k[h>>2];b=U+4|0;a=h+4|0;k[b>>2]=k[a>>2];L=U+8|0;k[L>>2]=k[h+8>>2];k[U+12>>2]=k[h+12>>2];k[U+16>>2]=k[h+16>>2];k[U+20>>2]=k[h+20>>2];k[U+24>>2]=k[h+24>>2];k[U+28>>2]=k[h+28>>2];k[U+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[U+36>>2]=f;g=U+40|0;k[g>>2]=L;L=U+48|0;l=U+44|0;k[l>>2]=L;k[U+52>>2]=0;k[L>>2]=0;if(f|0){L=f+12|0;k[L>>2]=(k[L>>2]|0)+1}if((k[a>>2]|0)<3){K=k[h+44>>2]|0;L=k[l>>2]|0;k[L>>2]=k[K>>2];k[L+4>>2]=k[K+4>>2];break}k[b>>2]=0;x1(U,k[a>>2]|0,0,0,0);if((k[b>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[n+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[b>>2]|0))}}else Q1(U,c,-1);while(0);do if((k[d>>2]&2031616|0)==65536){h=k[d+4>>2]|0;k[S>>2]=k[h>>2];b=S+4|0;a=h+4|0;k[b>>2]=k[a>>2];L=S+8|0;k[L>>2]=k[h+8>>2];k[S+12>>2]=k[h+12>>2];k[S+16>>2]=k[h+16>>2];k[S+20>>2]=k[h+20>>2];k[S+24>>2]=k[h+24>>2];k[S+28>>2]=k[h+28>>2];k[S+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[S+36>>2]=f;g=S+40|0;k[g>>2]=L;L=S+48|0;l=S+44|0;k[l>>2]=L;k[S+52>>2]=0;k[L>>2]=0;if(f|0){L=f+12|0;k[L>>2]=(k[L>>2]|0)+1}if((k[a>>2]|0)<3){K=k[h+44>>2]|0;L=k[l>>2]|0;k[L>>2]=k[K>>2];k[L+4>>2]=k[K+4>>2];break}k[b>>2]=0;x1(S,k[a>>2]|0,0,0,0);if((k[b>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[n+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[b>>2]|0))}}else Q1(S,d,-1);while(0);k[A>>2]=W;k[A+4>>2]=V;k[A+8>>2]=U;k[A+12>>2]=S;k[A+16>>2]=0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;k[N+16>>2]=0;k[N+20>>2]=0;k[N+24>>2]=0;k[N+28>>2]=0;z1(N,A,0,M,-1);K=O+8|0;k[O>>2]=K;L=O+4|0;k[L>>2]=264;J=aa(k[N+20>>2]|0,x)|0;H=w|1024;H=H-((H>>>0)%(x>>>0)|0)|0;H=(H|0)<(J|0)?H:J;I=1212424721>>>(k[W>>2]<<2&28)&15;if((y|0)==6){g=H<<1;if(g>>>0>264){f=g>>>0>1073741823?-1:g<<2;f=(f|0)==0?1:f;while(1){a=fgb(f)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[O>>2]=a}else a=K;k[L>>2]=g;G=a;D=a+(H<<2)|0}else{G=0;D=0}E=N+16|0;F=(J|0)>0;y=(y|0)==5;A=M+4|0;B=M+8|0;C=M+12|0;z=e?1.0:.01745329238474369;d=0;while(1){if(d>>>0>=(k[E>>2]|0)>>>0)break;do if(F){if(y){n=k[M>>2]|0;b=k[A>>2]|0;h=k[B>>2]|0;j=k[C>>2]|0;a=0;v=n;c=b;l=h;w=j;while(1){g=J-a|0;g=(H|0)<(g|0)?H:g;if((g|0)>0){f=0;do{t=+o[v+(f<<2)>>2];u=+o[c+(f<<2)>>2];u=+Q(+(t*t+u*u));o[l+(f<<2)>>2]=u;f=f+1|0}while((f|0)!=(g|0));f=0;do{t=+o[v+(f<<2)>>2];u=+o[c+(f<<2)>>2];q=+P(+t);s=+P(+u);if(!(q>=s)){s=q/(s+2.220446049250313e-16);q=s*s;q=90.0-s*(q*(q*(8.914000511169434-q*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{s=s/(q+2.220446049250313e-16);q=s*s;q=s*(q*(q*(8.914000511169434-q*2.539724588394165)+-18.66744613647461)+57.283626556396484)}t=t<0.0?180.0-q:q;o[w+(f<<2)>>2]=z*(u<0.0?360.0-t:t);f=f+1|0}while((f|0)!=(g|0))}e=aa(g,I)|0;f=n+e|0;g=b+e|0;h=h+e|0;j=j+e|0;a=a+H|0;if((J|0)>(a|0)){v=f;c=g;l=h;w=j;n=f;b=g}else break}k[M>>2]=f;k[A>>2]=g;k[B>>2]=h;k[C>>2]=j;break}v=k[M>>2]|0;c=k[A>>2]|0;j=k[C>>2]|0;w=k[B>>2]|0;a=0;n=v;b=c;l=w;x=j;while(1){h=J-a|0;h=(H|0)<(h|0)?H:h;if((h|0)>0){f=0;do{t=+p[n+(f<<3)>>3];u=+p[b+(f<<3)>>3];u=+Q(+(t*t+u*u));p[l+(f<<3)>>3]=u;f=f+1|0}while((f|0)!=(h|0));f=0;do{o[G+(f<<2)>>2]=+p[n+(f<<3)>>3];o[D+(f<<2)>>2]=+p[b+(f<<3)>>3];f=f+1|0}while((f|0)<(h|0));f=0;do{g=G+(f<<2)|0;t=+o[g>>2];u=+o[D+(f<<2)>>2];q=+P(+t);s=+P(+u);if(!(q>=s)){s=q/(s+2.220446049250313e-16);q=s*s;q=90.0-s*(q*(q*(8.914000511169434-q*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{s=s/(q+2.220446049250313e-16);q=s*s;q=s*(q*(q*(8.914000511169434-q*2.539724588394165)+-18.66744613647461)+57.283626556396484)}t=t<0.0?180.0-q:q;o[g>>2]=z*(u<0.0?360.0-t:t);f=f+1|0}while((f|0)!=(h|0));f=0;do{p[x+(f<<3)>>3]=+o[G+(f<<2)>>2];f=f+1|0}while((f|0)<(h|0))}e=aa(h,I)|0;f=v+e|0;g=c+e|0;h=w+e|0;j=j+e|0;a=a+H|0;if((J|0)>(a|0)){n=f;b=g;l=h;x=j;v=f;c=g;w=h}else break}k[M>>2]=f;k[A>>2]=g;k[B>>2]=h;k[C>>2]=j}while(0);A1(N);d=d+1|0}a=k[O>>2]|0;if((a|0)!=(K|0)){if(a|0)ggb(a);k[O>>2]=K;k[L>>2]=264}g=S+36|0;a=k[g>>2]|0;if(a|0?(N=a+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[S+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;O=S+16|0;f=S+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[f>>2]|0)>0){g=k[S+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[S+44>>2]|0;if(!((a|0)==(S+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=U+36|0;a=k[g>>2]|0;if(a|0?(O=a+12|0,S=k[O>>2]|0,k[O>>2]=S+-1,(S|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[U+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;S=U+16|0;f=U+4|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[f>>2]|0)>0){g=k[U+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[U+44>>2]|0;if(!((a|0)==(U+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=V+36|0;a=k[g>>2]|0;if(a|0?(S=a+12|0,U=k[S>>2]|0,k[S>>2]=U+-1,(U|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[V+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;U=V+16|0;g=V+4|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[g>>2]|0)>0){f=k[m>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[V+44>>2]|0;if(!((a|0)==(V+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=W+36|0;a=k[g>>2]|0;if(a|0?(U=a+12|0,V=k[U>>2]|0,k[U>>2]=V+-1,(V|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[W+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;V=W+16|0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[R>>2]|0)>0){f=k[T>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[R>>2]|0))}a=k[W+44>>2]|0;if((a|0)==(W+48|0)|(a|0)==0){r=X;return}ggb(k[a+-4>>2]|0);r=X;return}function XZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+176|0;v=w+112|0;u=w+56|0;n=w+40|0;p=w+32|0;q=w;l=S1(a,-1)|0;t=(S1(a,-1)|0)&7;m=((S1(a,-1)|0)>>>3&511)+1|0;o=(t|0)==5;if((t+-5|0)>>>0>=2){c=v+4|0;d=ZT(40)|0;k[d>>2]=1;e=d+4|0;k[v>>2]=e;k[c>>2]=34;i[d+38>>0]=0;f=215803;g=e+34|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,v,214812,214521,791);k[c>>2]=0;k[v>>2]=0;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){d=k[a+4>>2]|0;k[v>>2]=k[d>>2];j=v+4|0;a=d+4|0;k[j>>2]=k[a>>2];t=v+8|0;k[t>>2]=k[d+8>>2];k[v+12>>2]=k[d+12>>2];k[v+16>>2]=k[d+16>>2];k[v+20>>2]=k[d+20>>2];k[v+24>>2]=k[d+24>>2];k[v+28>>2]=k[d+28>>2];k[v+32>>2]=k[d+32>>2];c=k[d+36>>2]|0;k[v+36>>2]=c;h=v+40|0;k[h>>2]=t;t=v+48|0;e=v+44|0;k[e>>2]=t;k[v+52>>2]=0;k[t>>2]=0;if(c|0){t=c+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[a>>2]|0)<3){t=k[d+44>>2]|0;s=k[e>>2]|0;k[s>>2]=k[t>>2];k[s+4>>2]=k[t+4>>2];s=h;t=j;break}k[j>>2]=0;x1(v,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){f=k[d+40>>2]|0;g=k[h>>2]|0;d=k[d+44>>2]|0;c=k[e>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[f+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0));s=h;t=j}else{s=h;t=j}}else{Q1(v,a,-1);s=v+40|0;t=v+4|0}while(0);P1(b,k[t>>2]|0,k[s>>2]|0,l,-1,0,0);do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[u>>2]=k[f>>2];j=u+4|0;a=f+4|0;k[j>>2]=k[a>>2];l=u+8|0;k[l>>2]=k[f+8>>2];k[u+12>>2]=k[f+12>>2];k[u+16>>2]=k[f+16>>2];k[u+20>>2]=k[f+20>>2];k[u+24>>2]=k[f+24>>2];k[u+28>>2]=k[f+28>>2];k[u+32>>2]=k[f+32>>2];c=k[f+36>>2]|0;k[u+36>>2]=c;d=u+40|0;k[d>>2]=l;l=u+48|0;g=u+44|0;k[g>>2]=l;k[u+52>>2]=0;k[l>>2]=0;if(c|0){l=c+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[a>>2]|0)<3){b=k[f+44>>2]|0;l=k[g>>2]|0;k[l>>2]=k[b>>2];k[l+4>>2]=k[b+4>>2];break}k[j>>2]=0;x1(u,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[f+40>>2]|0;e=k[d>>2]|0;d=k[f+44>>2]|0;c=k[g>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[h+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else Q1(u,b,-1);while(0);k[n>>2]=v;k[n+4>>2]=u;k[n+8>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;k[q+16>>2]=0;k[q+20>>2]=0;k[q+24>>2]=0;k[q+28>>2]=0;z1(q,n,0,p,-1);c=aa(k[q+20>>2]|0,m)|0;d=q+16|0;e=p+4|0;a:do if(o){a=0;while(1){if(a>>>0>=(k[d>>2]|0)>>>0)break a;o_(k[p>>2]|0,k[e>>2]|0,c);A1(q);a=a+1|0}}else{a=0;while(1){if(a>>>0>=(k[d>>2]|0)>>>0)break a;p_(k[p>>2]|0,k[e>>2]|0,c);A1(q);a=a+1|0}}while(0);d=u+36|0;a=k[d>>2]|0;if(a|0?(p=a+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[u+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;q=u+16|0;c=u+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[c>>2]|0)>0){d=k[u+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[u+44>>2]|0;if(!((a|0)==(u+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=v+36|0;a=k[d>>2]|0;if(a|0?(q=a+12|0,u=k[q>>2]|0,k[q>>2]=u+-1,(u|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[v+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;u=v+16|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[t>>2]|0)>0){c=k[s>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[t>>2]|0))}a=k[v+44>>2]|0;if((a|0)==(v+48|0)|(a|0)==0){r=w;return}ggb(k[a+-4>>2]|0);r=w;return}function YZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+176|0;v=w+112|0;u=w+56|0;n=w+40|0;p=w+32|0;q=w;l=S1(a,-1)|0;t=(S1(a,-1)|0)&7;m=((S1(a,-1)|0)>>>3&511)+1|0;o=(t|0)==5;if((t+-5|0)>>>0>=2){c=v+4|0;d=ZT(40)|0;k[d>>2]=1;e=d+4|0;k[v>>2]=e;k[c>>2]=34;i[d+38>>0]=0;f=215803;g=e+34|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,v,214816,214521,858);k[c>>2]=0;k[v>>2]=0;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){d=k[a+4>>2]|0;k[v>>2]=k[d>>2];j=v+4|0;a=d+4|0;k[j>>2]=k[a>>2];t=v+8|0;k[t>>2]=k[d+8>>2];k[v+12>>2]=k[d+12>>2];k[v+16>>2]=k[d+16>>2];k[v+20>>2]=k[d+20>>2];k[v+24>>2]=k[d+24>>2];k[v+28>>2]=k[d+28>>2];k[v+32>>2]=k[d+32>>2];c=k[d+36>>2]|0;k[v+36>>2]=c;h=v+40|0;k[h>>2]=t;t=v+48|0;e=v+44|0;k[e>>2]=t;k[v+52>>2]=0;k[t>>2]=0;if(c|0){t=c+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[a>>2]|0)<3){t=k[d+44>>2]|0;s=k[e>>2]|0;k[s>>2]=k[t>>2];k[s+4>>2]=k[t+4>>2];s=h;t=j;break}k[j>>2]=0;x1(v,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){f=k[d+40>>2]|0;g=k[h>>2]|0;d=k[d+44>>2]|0;c=k[e>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[f+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0));s=h;t=j}else{s=h;t=j}}else{Q1(v,a,-1);s=v+40|0;t=v+4|0}while(0);P1(b,k[t>>2]|0,k[s>>2]|0,l,-1,0,0);do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[u>>2]=k[f>>2];j=u+4|0;a=f+4|0;k[j>>2]=k[a>>2];l=u+8|0;k[l>>2]=k[f+8>>2];k[u+12>>2]=k[f+12>>2];k[u+16>>2]=k[f+16>>2];k[u+20>>2]=k[f+20>>2];k[u+24>>2]=k[f+24>>2];k[u+28>>2]=k[f+28>>2];k[u+32>>2]=k[f+32>>2];c=k[f+36>>2]|0;k[u+36>>2]=c;d=u+40|0;k[d>>2]=l;l=u+48|0;g=u+44|0;k[g>>2]=l;k[u+52>>2]=0;k[l>>2]=0;if(c|0){l=c+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[a>>2]|0)<3){b=k[f+44>>2]|0;l=k[g>>2]|0;k[l>>2]=k[b>>2];k[l+4>>2]=k[b+4>>2];break}k[j>>2]=0;x1(u,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[f+40>>2]|0;e=k[d>>2]|0;d=k[f+44>>2]|0;c=k[g>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[h+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else Q1(u,b,-1);while(0);k[n>>2]=v;k[n+4>>2]=u;k[n+8>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;k[q+16>>2]=0;k[q+20>>2]=0;k[q+24>>2]=0;k[q+28>>2]=0;z1(q,n,0,p,-1);c=aa(k[q+20>>2]|0,m)|0;d=q+16|0;e=p+4|0;a:do if(o){a=0;while(1){if(a>>>0>=(k[d>>2]|0)>>>0)break a;q_(k[p>>2]|0,k[e>>2]|0,c);A1(q);a=a+1|0}}else{a=0;while(1){if(a>>>0>=(k[d>>2]|0)>>>0)break a;r_(k[p>>2]|0,k[e>>2]|0,c);A1(q);a=a+1|0}}while(0);d=u+36|0;a=k[d>>2]|0;if(a|0?(p=a+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[u+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;q=u+16|0;c=u+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[c>>2]|0)>0){d=k[u+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[u+44>>2]|0;if(!((a|0)==(u+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=v+36|0;a=k[d>>2]|0;if(a|0?(q=a+12|0,u=k[q>>2]|0,k[q>>2]=u+-1,(u|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[v+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;u=v+16|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[t>>2]|0)>0){c=k[s>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[t>>2]|0))}a=k[v+44>>2]|0;if((a|0)==(v+48|0)|(a|0)==0){r=w;return}ggb(k[a+-4>>2]|0);r=w;return}function ZZ(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0.0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;N=r;r=r+1216|0;M=N+56|0;L=N;s=N+1192|0;H=N+1184|0;I=N+1152|0;G=N+112|0;n=S1(a,-1)|0;E=n&7;t=n>>>3&511;v=t+1|0;p[u>>3]=b;d=k[u+4>>2]|0;K=d&2146435072;if(!(K>>>0>1126170624|(K|0)==1126170624&0>0)){d=(d|0)<0;g=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=d?-0.0:0.0}else g=b;w=~~g;q=+P(+(+(w|0)-b))<2.220446049250313e-16;a:do if(!q){if((E+-5|0)>>>0>=2){d=M+4|0;e=ZT(40)|0;k[e>>2]=1;h=e+4|0;k[M>>2]=h;k[d>>2]=34;i[e+38>>0]=0;j=215803;l=h+34|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,M,214820,214521,1394);k[d>>2]=0;k[M>>2]=0;K=k[e>>2]|0;k[e>>2]=K+-1;if((K|0)==1)ggb(k[e+-4>>2]|0)}}else switch(w|0){case 0:{K2(c,a,n);p[L>>3]=1.0;p[L+8>>3]=1.0;p[L+16>>3]=1.0;p[L+24>>3]=1.0;k[M>>2]=-1056833530;k[M+4>>2]=L;k[M+8>>2]=1;k[M+12>>2]=4;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;N2(c,M,s);r=N;return}case 1:{I2(a,c);r=N;return}case 2:{p[M>>3]=1.0;sU(a,a,c,49332,-1,40032,1,M);r=N;return}default:break a}while(0);do if((k[a>>2]&2031616|0)==65536){a=k[a+4>>2]|0;k[M>>2]=k[a>>2];m=M+4|0;d=a+4|0;k[m>>2]=k[d>>2];K=M+8|0;k[K>>2]=k[a+8>>2];k[M+12>>2]=k[a+12>>2];k[M+16>>2]=k[a+16>>2];k[M+20>>2]=k[a+20>>2];k[M+24>>2]=k[a+24>>2];k[M+28>>2]=k[a+28>>2];k[M+32>>2]=k[a+32>>2];e=k[a+36>>2]|0;k[M+36>>2]=e;l=M+40|0;k[l>>2]=K;K=M+48|0;j=M+44|0;k[j>>2]=K;k[M+52>>2]=0;k[K>>2]=0;if(e|0){K=e+12|0;k[K>>2]=(k[K>>2]|0)+1}if((k[d>>2]|0)<3){K=k[a+44>>2]|0;J=k[j>>2]|0;k[J>>2]=k[K>>2];k[J+4>>2]=k[K+4>>2];J=l;K=m;break}k[m>>2]=0;x1(M,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){f=k[a+40>>2]|0;h=k[l>>2]|0;a=k[a+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[f+(d<<2)>>2];k[e+(d<<2)>>2]=k[a+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0));J=l;K=m}else{J=l;K=m}}else{Q1(M,a,-1);J=M+40|0;K=M+4|0}while(0);P1(c,k[K>>2]|0,k[J>>2]|0,n,-1,0,0);do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[L>>2]=k[f>>2];m=L+4|0;d=f+4|0;k[m>>2]=k[d>>2];F=L+8|0;k[F>>2]=k[f+8>>2];k[L+12>>2]=k[f+12>>2];k[L+16>>2]=k[f+16>>2];k[L+20>>2]=k[f+20>>2];k[L+24>>2]=k[f+24>>2];k[L+28>>2]=k[f+28>>2];k[L+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[L+36>>2]=e;a=L+40|0;k[a>>2]=F;F=L+48|0;j=L+44|0;k[j>>2]=F;k[L+52>>2]=0;k[F>>2]=0;if(e|0){F=e+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[d>>2]|0)<3){B=k[f+44>>2]|0;F=k[j>>2]|0;k[F>>2]=k[B>>2];k[F+4>>2]=k[B+4>>2];break}k[m>>2]=0;x1(L,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[f+40>>2]|0;h=k[a>>2]|0;a=k[f+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[a+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else Q1(L,c,-1);while(0);k[s>>2]=M;k[s+4>>2]=L;k[s+8>>2]=0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;k[I+16>>2]=0;k[I+20>>2]=0;k[I+24>>2]=0;k[I+28>>2]=0;z1(I,s,0,H,-1);F=aa(k[I+20>>2]|0,v)|0;b:do if(!q){if(+P(+(+P(+b)+-.5))<2.220446049250313e-16){e=(E|0)==5;e=b<0.0?(e?290:289):e?292:291;a=I+16|0;f=H+4|0;d=0;while(1){if(d>>>0>=(k[a>>2]|0)>>>0)break b;Ph[e&511](k[H>>2]|0,k[f>>2]|0,F);A1(I);d=d+1|0}}y=t|1024;y=y-((y>>>0)%(v>>>0)|0)|0;y=(y|0)<(F|0)?y:F;z=1212424721>>>(k[M>>2]<<2&28)&15;A=G+8|0;k[G>>2]=A;B=G+4|0;k[B>>2]=1032;if((k[M+16>>2]|0)==(k[L+16>>2]|0)){e=aa(z,y)|0;if(e>>>0>1032){while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[G>>2]=d}else d=A;k[B>>2]=e;x=d;t=d}else{x=0;t=0}v=I+16|0;w=(F|0)>0;m=(E|0)==5;c=(t|0)!=0;n=H+4|0;q=b<0.0;s=(x|0)!=0;j=0;while(1){if(j>>>0>=(k[v>>2]|0)>>>0)break;if(w){h=0;do{l=F-h|0;l=(y|0)<(l|0)?y:l;c:do if(m){a=k[H>>2]|0;d=c?t:a;f=k[n>>2]|0;if((d|0)!=(a|0))upb(d|0,a|0,aa(l,z)|0)|0;q_(d,f,l);if((l|0)>0)d=0;else{o_(f,f,l);break}do{E=f+(d<<2)|0;o[E>>2]=+o[E>>2]*b;d=d+1|0}while((d|0)<(l|0));o_(f,f,l);if(q)d=0;else{d=0;while(1){if(+o[a+(d<<2)>>2]<0.0)o[f+(d<<2)>>2]=C;d=d+1|0;if((d|0)>=(l|0))break c}}do{g=+o[a+(d<<2)>>2];do if(g<=0.0){e=f+(d<<2)|0;if(g==0.0){o[e>>2]=D;break}else{o[e>>2]=C;break}}while(0);d=d+1|0}while((d|0)<(l|0))}else{a=k[H>>2]|0;d=s?x:a;f=k[n>>2]|0;if((d|0)!=(a|0))upb(d|0,a|0,aa(l,z)|0)|0;r_(d,f,l);if((l|0)>0)d=0;else{p_(f,f,l);break}do{E=f+(d<<3)|0;p[E>>3]=+p[E>>3]*b;d=d+1|0}while((d|0)<(l|0));p_(f,f,l);if(q)d=0;else{d=0;while(1){if(+p[a+(d<<3)>>3]<0.0)p[f+(d<<3)>>3]=C;d=d+1|0;if((d|0)>=(l|0))break c}}do{g=+p[a+(d<<3)>>3];do if(g<=0.0){e=f+(d<<3)|0;if(g==0.0){p[e>>3]=D;break}else{p[e>>3]=C;break}}while(0);d=d+1|0}while((d|0)<(l|0))}while(0);E=aa(l,z)|0;k[H>>2]=(k[H>>2]|0)+E;k[n>>2]=(k[n>>2]|0)+E;h=h+y|0}while((F|0)>(h|0))}A1(I);j=j+1|0}d=k[G>>2]|0;if((d|0)!=(A|0)){if(d|0)ggb(d);k[G>>2]=A;k[B>>2]=1032}}else{f=k[47772+(E<<2)>>2]|0;if((E|0)==7){k[G>>2]=0;d=G+4|0;k[d>>2]=0;e=ZT(16)|0;k[e>>2]=1;h=e+4|0;k[G>>2]=h;k[d>>2]=9;i[e+13>>0]=0;j=335726;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,G,214820,214521,1410);k[d>>2]=0;k[G>>2]=0;G=k[e>>2]|0;k[e>>2]=G+-1;if((G|0)==1)ggb(k[e+-4>>2]|0)}e=I+16|0;a=H+4|0;d=0;while(1){if(d>>>0>=(k[e>>2]|0)>>>0)break b;dh[f&255](k[H>>2]|0,k[a>>2]|0,F,w);A1(I);d=d+1|0}}while(0);a=L+36|0;d=k[a>>2]|0;if(d|0?(H=d+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){e=k[a>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[L+32>>2]|0;if(!d){d=B1()|0;e=k[a>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[a>>2]=0}k[a>>2]=0;I=L+16|0;e=L+4|0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[e>>2]|0)>0){a=k[L+40>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[L+44>>2]|0;if(!((d|0)==(L+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);a=M+36|0;d=k[a>>2]|0;if(d|0?(I=d+12|0,L=k[I>>2]|0,k[I>>2]=L+-1,(L|0)==1):0){e=k[a>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[M+32>>2]|0;if(!d){d=B1()|0;e=k[a>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[a>>2]=0}k[a>>2]=0;L=M+16|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[K>>2]|0)>0){e=k[J>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[K>>2]|0))}d=k[M+44>>2]|0;if(!((d|0)==(M+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);r=N;return}function _Z(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=1.0/+Q(+(+o[a+(d<<2)>>2]));o[b+(d<<2)>>2]=e;d=d+1|0}while((d|0)!=(c|0));return}function $Z(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=1.0/+Q(+(+p[a+(d<<3)>>3]));p[b+(d<<3)>>3]=e;d=d+1|0}while((d|0)!=(c|0));return}function a_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+Q(+(+o[a+(d<<2)>>2]));o[b+(d<<2)>>2]=e;d=d+1|0}while((d|0)!=(c|0));return}function b_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+Q(+(+p[a+(d<<3)>>3]));p[b+(d<<3)>>3]=e;d=d+1|0}while((d|0)!=(c|0));return}function c_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;g=j;if((d|0)<0){h=(d|0)==-1;i[g>>0]=h?0:h<<31>>31;d=d<<1&2;f=(d^2)+-1|0;i[g+1>>0]=f>>>0<256?f:(d|0)==0?255:0;i[g+2>>0]=-1;i[g+3>>0]=1;i[g+4>>0]=h&1;if((c|0)>0){f=0;do{e=i[a+f>>0]|0;if((e&255)<3)e=i[g+((e&255)+2)>>0]|0;else e=0;i[b+f>>0]=e;f=f+1|0}while((f|0)!=(c|0))}r=j;return}if((c|0)<=0){r=j;return}if((d|0)>1)g=0;else{e=0;do{i[b+e>>0]=i[a+e>>0]|0;e=e+1|0}while((e|0)!=(c|0));r=j;return}do{e=l[a+g>>0]|0;f=1;h=d;do{f=aa((h&1|0)==0?1:e,f)|0;e=aa(e,e)|0;h=h>>1}while((h|0)>1);h=aa(f,e)|0;i[b+g>>0]=h>>>0>255?255:h;g=g+1|0}while((g|0)!=(c|0));r=j;return}
function AUa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,l=0,m=0,n=0,q=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0;Rb=r;r=r+560|0;Kb=Rb+248|0;Qb=Rb+496|0;Pb=Rb+440|0;Ob=Rb+424|0;Nb=Rb+368|0;Lb=Rb+56|0;Gb=Rb+352|0;Hb=Rb;Ib=Rb+296|0;Jb=Rb+280|0;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[Qb>>2]=k[g>>2];n=Qb+4|0;b=g+4|0;k[n>>2]=k[b>>2];Fb=Qb+8|0;k[Fb>>2]=k[g+8>>2];k[Qb+12>>2]=k[g+12>>2];k[Qb+16>>2]=k[g+16>>2];k[Qb+20>>2]=k[g+20>>2];k[Qb+24>>2]=k[g+24>>2];k[Qb+28>>2]=k[g+28>>2];k[Qb+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Qb+36>>2]=e;f=Qb+40|0;k[f>>2]=Fb;Fb=Qb+48|0;l=Qb+44|0;k[l>>2]=Fb;k[Qb+52>>2]=0;k[Fb>>2]=0;if(e|0){Fb=e+12|0;k[Fb>>2]=(k[Fb>>2]|0)+1}if((k[b>>2]|0)<3){Eb=k[g+44>>2]|0;Fb=k[l>>2]|0;k[Fb>>2]=k[Eb>>2];k[Fb+4>>2]=k[Eb+4>>2];break}k[n>>2]=0;x1(Qb,k[b>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[l>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[m+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else Q1(Qb,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[Pb>>2]=k[h>>2];n=Pb+4|0;e=h+4|0;k[n>>2]=k[e>>2];Fb=Pb+8|0;k[Fb>>2]=k[h+8>>2];k[Pb+12>>2]=k[h+12>>2];k[Pb+16>>2]=k[h+16>>2];k[Pb+20>>2]=k[h+20>>2];k[Pb+24>>2]=k[h+24>>2];k[Pb+28>>2]=k[h+28>>2];k[Pb+32>>2]=k[h+32>>2];b=k[h+36>>2]|0;k[Pb+36>>2]=b;f=Pb+40|0;k[f>>2]=Fb;Fb=Pb+48|0;l=Pb+44|0;k[l>>2]=Fb;k[Pb+52>>2]=0;k[Fb>>2]=0;if(b|0){Fb=b+12|0;k[Fb>>2]=(k[Fb>>2]|0)+1}if((k[e>>2]|0)<3){Eb=k[h+44>>2]|0;Fb=k[l>>2]|0;k[Fb>>2]=k[Eb>>2];k[Fb+4>>2]=k[Eb+4>>2];break}k[n>>2]=0;x1(Pb,k[e>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;g=k[f>>2]|0;f=k[h+44>>2]|0;e=k[l>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[m+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[n>>2]|0))}}else Q1(Pb,c,-1);while(0);b=k[d>>2]|0;Ab=d+4|0;e=k[Ab>>2]|0;if((e|0)!=(b|0))k[Ab>>2]=e+(~((e+-32-b|0)>>>5)<<5);k[Ob>>2]=0;Fb=Ob+4|0;k[Fb>>2]=0;k[Ob+8>>2]=0;k[Nb>>2]=1124007936;Eb=Nb+4|0;b=Nb+8|0;Cb=Nb+40|0;e=Eb;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[Cb>>2]=b;Db=Nb+48|0;Bb=Nb+44|0;k[Bb>>2]=Db;k[Nb+52>>2]=0;k[Db>>2]=0;zb=Kb+4|0;yb=zb+4|0;k[yb>>2]=0;k[yb+4>>2]=0;k[Kb>>2]=33619968;k[zb>>2]=Nb;mY(Pb,Kb);zb=Lb+4|0;yb=zb+4|0;k[yb>>2]=0;k[yb+4>>2]=0;k[Lb>>2]=50397184;k[zb>>2]=Nb;zb=Gb+4|0;yb=zb+4|0;k[yb>>2]=0;k[yb+4>>2]=0;k[Gb>>2]=-2113667060;k[zb>>2]=Ob;k[Kb>>2]=0;k[Kb+4>>2]=0;Jea(Lb,Gb,49332,1,1,Kb);if((k[Fb>>2]|0)!=(k[Ob>>2]|0)){c=Kb+24|0;y=Hb+4|0;z=Hb+8|0;A=Hb+12|0;B=Hb+16|0;C=Hb+20|0;D=Hb+24|0;E=Hb+32|0;F=Hb+36|0;G=Hb+40|0;H=Hb+48|0;I=Hb+44|0;J=Hb+52|0;K=Gb+8|0;L=Gb+12|0;M=Gb+4|0;N=a+26|0;O=a+36|0;P=a+48|0;R=a+60|0;S=Lb+8|0;T=Lb+16|0;U=Kb+8|0;V=a+24|0;W=Gb+4|0;X=Gb+8|0;Y=Kb+16|0;Z=d+8|0;_=Gb+8|0;$=Pb+16|0;ba=Pb+44|0;ca=Gb+4|0;da=Gb+8|0;ea=Ib+4|0;fa=Ib+8|0;ga=Ib+12|0;ha=Ib+16|0;ia=Ib+20|0;ja=Ib+24|0;ka=Ib+32|0;la=Ib+36|0;ma=Ib+40|0;na=Ib+48|0;oa=Ib+44|0;pa=Ib+52|0;qa=Hb+8|0;ra=Hb+12|0;sa=Hb+4|0;ta=Jb+4|0;ua=ta+4|0;va=Ib+4|0;wa=Ib+8|0;xa=Ib+12|0;ya=Ib+16|0;za=Ib+20|0;Aa=Ib+24|0;Ba=Ib+32|0;Ca=Ib+36|0;Da=Ib+40|0;Ea=Ib+48|0;Fa=Ib+44|0;Ga=Ib+52|0;Ha=Hb+8|0;Ia=Hb+12|0;Ja=Hb+4|0;Ka=Ib+4|0;La=Ib+8|0;Ma=Ib+12|0;Na=Ib+16|0;Oa=Ib+20|0;Pa=Ib+24|0;Qa=Ib+32|0;Ra=Ib+36|0;Sa=Ib+40|0;Ta=Ib+48|0;Ua=Ib+44|0;Va=Ib+52|0;Wa=Hb+8|0;Xa=Hb+12|0;Ya=Hb+4|0;Za=a+64|0;_a=a+68|0;$a=Ib+28|0;ab=Ib+28|0;bb=Ib+28|0;cb=Lb+88|0;db=Lb+80|0;eb=Lb+96|0;fb=a+52|0;gb=a+56|0;hb=Hb+4|0;ib=Hb+8|0;jb=Hb+12|0;kb=Hb+16|0;lb=Hb+20|0;mb=Hb+24|0;nb=Hb+32|0;ob=Hb+36|0;pb=Hb+40|0;qb=Hb+48|0;rb=Hb+44|0;sb=Hb+52|0;tb=Gb+8|0;ub=Gb+12|0;vb=Gb+4|0;wb=a+40|0;xb=a+44|0;yb=Hb+28|0;zb=a+28|0;m=a+32|0;n=Hb+28|0;l=0;b=k[Ob>>2]|0;do{k[Kb>>2]=0;k[Kb+4>>2]=0;k[Kb+8>>2]=0;k[Kb+12>>2]=0;p[c>>3]=1.0;k[Hb>>2]=1124024332;k[y>>2]=2;a=k[b+(l*12|0)+4>>2]|0;b=k[b+(l*12|0)>>2]|0;e=a-b|0;k[z>>2]=e>>3;k[A>>2]=1;k[B>>2]=0;k[C>>2]=0;k[D>>2]=0;k[E>>2]=0;k[F>>2]=0;k[G>>2]=z;k[I>>2]=H;k[J>>2]=0;k[H>>2]=0;f=b;if((f|0)!=(a|0)){k[J>>2]=8;k[H>>2]=8;k[B>>2]=f;k[C>>2]=f;a=b+e|0;k[D>>2]=a;k[n>>2]=a}k[K>>2]=0;k[L>>2]=0;k[Gb>>2]=16842752;k[M>>2]=Hb;$oa(Lb,Gb,0);b=k[F>>2]|0;if(b|0?(h=b+12|0,a=k[h>>2]|0,k[h>>2]=a+-1,(a|0)==1):0){e=k[F>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[E>>2]|0;if(!b){b=B1()|0;e=k[F>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[F>>2]=0}k[F>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[y>>2]|0)>0){e=k[G>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[y>>2]|0))}b=k[I>>2]|0;if(!((b|0)==(H|0)|(b|0)==0))ggb(k[b+-4>>2]|0);if(i[N>>0]|0){x=+p[Lb>>3];if(!(x<+o[zb>>2])?!(x>=+o[m>>2]):0)Mb=54}else Mb=54;do if((Mb|0)==54){Mb=0;if(i[O>>0]|0){s=+p[Lb>>3];b=k[Ob>>2]|0;k[Hb>>2]=1124024332;k[hb>>2]=2;a=k[b+(l*12|0)+4>>2]|0;b=k[b+(l*12|0)>>2]|0;e=a-b|0;k[ib>>2]=e>>3;k[jb>>2]=1;k[kb>>2]=0;k[lb>>2]=0;k[mb>>2]=0;k[nb>>2]=0;k[ob>>2]=0;k[pb>>2]=ib;k[rb>>2]=qb;k[sb>>2]=0;k[qb>>2]=0;f=b;if((f|0)!=(a|0)){k[sb>>2]=8;k[qb>>2]=8;k[kb>>2]=f;k[lb>>2]=f;a=b+e|0;k[mb>>2]=a;k[yb>>2]=a}k[tb>>2]=0;k[ub>>2]=0;k[Gb>>2]=16842752;k[vb>>2]=Hb;q=+Yra(Gb,1);b=k[ob>>2]|0;if(b|0?(h=b+12|0,a=k[h>>2]|0,k[h>>2]=a+-1,(a|0)==1):0){e=k[ob>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[nb>>2]|0;if(b|0)break;b=B1()|0;e=k[ob>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[ob>>2]=0}k[ob>>2]=0;k[kb>>2]=0;k[kb+4>>2]=0;k[kb+8>>2]=0;k[kb+12>>2]=0;if((k[hb>>2]|0)>0){e=k[pb>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[hb>>2]|0))}b=k[rb>>2]|0;if(!((b|0)==(qb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);q=s*12.566370614359172/(q*q);if(q<+o[wb>>2])break;if(q>=+o[xb>>2])break}if(i[P>>0]|0){q=+p[cb>>3];s=q*2.0;t=+p[db>>3];v=+p[eb>>3];w=t-v;x=+Q(+(s*s+w*w));if(x>.01){v=(t+v)*.5;w=w*.5*(w/x);q=q*(s/x);q=(v-w-q)/(q+(v+w))}else q=1.0;if(q<+o[fb>>2])break;if(q>=+o[gb>>2])break;p[c>>3]=q*q}if(i[R>>0]|0){k[Gb>>2]=0;k[ca>>2]=0;k[da>>2]=0;b=k[Ob>>2]|0;k[Ib>>2]=1124024332;k[ea>>2]=2;a=k[b+(l*12|0)+4>>2]|0;b=k[b+(l*12|0)>>2]|0;e=a-b|0;k[fa>>2]=e>>3;k[ga>>2]=1;k[ha>>2]=0;k[ia>>2]=0;k[ja>>2]=0;k[ka>>2]=0;k[la>>2]=0;k[ma>>2]=fa;k[oa>>2]=na;k[pa>>2]=0;k[na>>2]=0;f=b;if((f|0)!=(a|0)){k[pa>>2]=8;k[na>>2]=8;k[ha>>2]=f;k[ia>>2]=f;a=b+e|0;k[ja>>2]=a;k[bb>>2]=a}k[qa>>2]=0;k[ra>>2]=0;k[Hb>>2]=16842752;k[sa>>2]=Ib;b=ua;k[b>>2]=0;k[b+4>>2]=0;k[Jb>>2]=-2113732596;k[ta>>2]=Gb;Kea(Hb,Jb,0,1);b=k[la>>2]|0;if(b|0?(h=b+12|0,a=k[h>>2]|0,k[h>>2]=a+-1,(a|0)==1):0){e=k[la>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[ka>>2]|0;if(b|0)break;b=B1()|0;e=k[la>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[la>>2]=0}k[la>>2]=0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[ea>>2]|0)>0){e=k[ma>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ea>>2]|0))}b=k[oa>>2]|0;if(!((b|0)==(na|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Ob>>2]|0;k[Ib>>2]=1124024332;k[va>>2]=2;a=k[b+(l*12|0)+4>>2]|0;b=k[b+(l*12|0)>>2]|0;e=a-b|0;k[wa>>2]=e>>3;k[xa>>2]=1;k[ya>>2]=0;k[za>>2]=0;k[Aa>>2]=0;k[Ba>>2]=0;k[Ca>>2]=0;k[Da>>2]=wa;k[Fa>>2]=Ea;k[Ga>>2]=0;k[Ea>>2]=0;f=b;if((f|0)!=(a|0)){k[Ga>>2]=8;k[Ea>>2]=8;k[ya>>2]=f;k[za>>2]=f;a=b+e|0;k[Aa>>2]=a;k[ab>>2]=a}k[Ha>>2]=0;k[Ia>>2]=0;k[Hb>>2]=16842752;k[Ja>>2]=Ib;s=+Zra(Hb,0);b=k[Ca>>2]|0;do if(b|0){h=b+12|0;a=k[h>>2]|0;k[h>>2]=a+-1;if((a|0)!=1)break;e=k[Ca>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Ba>>2]|0;if(b|0)break;b=B1()|0;e=k[Ca>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[Ca>>2]=0}while(0);k[Ca>>2]=0;k[ya>>2]=0;k[ya+4>>2]=0;k[ya+8>>2]=0;k[ya+12>>2]=0;if((k[va>>2]|0)>0){e=k[Da>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[va>>2]|0))}b=k[Fa>>2]|0;if(!((b|0)==(Ea|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[Ib>>2]=1124024332;k[Ka>>2]=2;a=k[ca>>2]|0;b=k[Gb>>2]|0;e=a-b|0;k[La>>2]=e>>3;k[Ma>>2]=1;k[Na>>2]=0;k[Oa>>2]=0;k[Pa>>2]=0;k[Qa>>2]=0;k[Ra>>2]=0;k[Sa>>2]=La;k[Ua>>2]=Ta;k[Va>>2]=0;k[Ta>>2]=0;f=b;if((f|0)!=(a|0)){k[Va>>2]=8;k[Ta>>2]=8;k[Na>>2]=f;k[Oa>>2]=f;a=b+e|0;k[Pa>>2]=a;k[$a>>2]=a}k[Wa>>2]=0;k[Xa>>2]=0;k[Hb>>2]=16842752;k[Ya>>2]=Ib;q=+Zra(Hb,0);b=k[Ra>>2]|0;do if(b|0){h=b+12|0;a=k[h>>2]|0;k[h>>2]=a+-1;if((a|0)!=1)break;e=k[Ra>>2]|0;if(e|0){b=k[e+4>>2]|0;do if(!b){b=k[Qa>>2]|0;if(b|0)break;b=B1()|0;e=k[Ra>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[Ra>>2]=0}while(0);k[Ra>>2]=0;k[Na>>2]=0;k[Na+4>>2]=0;k[Na+8>>2]=0;k[Na+12>>2]=0;if((k[Ka>>2]|0)>0){e=k[Sa>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ka>>2]|0))}b=k[Ua>>2]|0;if(!((b|0)==(Ta|0)|(b|0)==0))ggb(k[b+-4>>2]|0);q=s/q;do if(q<+o[Za>>2])b=4;else{if(q>=+o[_a>>2]){b=4;break}b=0}while(0);e=k[Gb>>2]|0;f=e;if(e|0){g=k[ca>>2]|0;if((g|0)!=(e|0))k[ca>>2]=g+(~((g+-8-f|0)>>>3)<<3);ggb(e)}if(b|0)break}q=+p[Lb>>3];if(!(q==0.0)){t=+p[S>>3]/q;s=+p[T>>3]/q;p[Kb>>3]=t;p[U>>3]=s;b=j[V>>1]|0;if((b&255)<<24>>24){f=(b&65535)>>>8&255;p[u>>3]=s;b=k[u+4>>2]|0;a=b&2146435072;do if(a>>>0>1126170624|(a|0)==1126170624&0>0)q=s;else{b=(b|0)<0;q=b?s+-4503599627370496.0+4503599627370496.0:s+4503599627370496.0+-4503599627370496.0;if(!(q==0.0))break;q=b?-0.0:0.0}while(0);e=~~q;p[u>>3]=t;b=k[u+4>>2]|0;a=b&2146435072;do if(a>>>0>1126170624|(a|0)==1126170624&0>0)q=t;else{b=(b|0)<0;q=b?t+-4503599627370496.0+4503599627370496.0:t+4503599627370496.0+-4503599627370496.0;if(!(q==0.0))break;q=b?-0.0:0.0}while(0);a=(k[$>>2]|0)+(aa(k[k[ba>>2]>>2]|0,e)|0)+~~q|0;if((i[a>>0]|0)!=f<<24>>24)break}k[Gb>>2]=0;k[W>>2]=0;k[X>>2]=0;b=k[Ob>>2]|0;if((k[b+(l*12|0)+4>>2]|0)==(k[b+(l*12|0)>>2]|0)){b=0;e=0;h=0;g=0}else{e=0;f=0;g=0;while(1){a=k[b+(l*12|0)>>2]|0;x=t-+(k[a+(e<<3)>>2]|0);q=s-+(k[a+(e<<3)+4>>2]|0);q=+Q(+(x*x+q*q));p[Hb>>3]=q;if((f|0)==(g|0)){Koa(Gb,Hb);b=k[Ob>>2]|0}else{p[f>>3]=q;k[W>>2]=f+8}e=e+1|0;if(e>>>0>=(k[b+(l*12|0)+4>>2]|0)-(k[b+(l*12|0)>>2]|0)>>3>>>0)break;f=k[W>>2]|0;g=k[_>>2]|0}h=k[Gb>>2]|0;g=k[W>>2]|0;b=h;e=g}Ngb(b,e);f=g-h>>3;e=h;p[Y>>3]=(+p[e+((f+-1|0)>>>1<<3)>>3]+ +p[e+(f>>>1<<3)>>3])*.5;f=h;b=g;if(h|0){if((b|0)!=(e|0))k[W>>2]=b+(~((b+-8-h|0)>>>3)<<3);ggb(f)}b=k[Ab>>2]|0;if((b|0)==(k[Z>>2]|0)){BUa(d,Kb);break}else{p[b>>3]=t;p[b+8>>3]=s;a=b+16|0;k[a>>2]=k[Y>>2];k[a+4>>2]=k[Y+4>>2];k[a+8>>2]=k[Y+8>>2];k[a+12>>2]=k[Y+12>>2];k[Ab>>2]=(k[Ab>>2]|0)+32;break}}}while(0);l=l+1|0;b=k[Ob>>2]|0}while(l>>>0<(((k[Fb>>2]|0)-b|0)/12|0)>>>0)}f=Nb+36|0;b=k[f>>2]|0;if(b|0?(Lb=b+12|0,Mb=k[Lb>>2]|0,k[Lb>>2]=Mb+-1,(Mb|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Nb+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Nb=Nb+16|0;k[Nb>>2]=0;k[Nb+4>>2]=0;k[Nb+8>>2]=0;k[Nb+12>>2]=0;if((k[Eb>>2]|0)>0){e=k[Cb>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Eb>>2]|0))}b=k[Bb>>2]|0;if(!((b|0)==(Db|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Ob>>2]|0;if(b|0){e=k[Fb>>2]|0;if((e|0)!=(b|0)){do{f=e+-12|0;k[Fb>>2]=f;g=k[f>>2]|0;h=g;if(!g)e=f;else{e=e+-8|0;f=k[e>>2]|0;if((f|0)!=(g|0))k[e>>2]=f+(~((f+-8-h|0)>>>3)<<3);ggb(g);e=k[Fb>>2]|0}}while((e|0)!=(b|0));b=k[Ob>>2]|0}ggb(b)}f=Pb+36|0;b=k[f>>2]|0;if(b|0?(Nb=b+12|0,Ob=k[Nb>>2]|0,k[Nb>>2]=Ob+-1,(Ob|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Pb+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Ob=Pb+16|0;e=Pb+4|0;k[Ob>>2]=0;k[Ob+4>>2]=0;k[Ob+8>>2]=0;k[Ob+12>>2]=0;if((k[e>>2]|0)>0){f=k[Pb+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Pb+44>>2]|0;if(!((b|0)==(Pb+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=Qb+36|0;b=k[f>>2]|0;if(b|0?(Ob=b+12|0,Pb=k[Ob>>2]|0,k[Ob>>2]=Pb+-1,(Pb|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[Qb+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;Pb=Qb+16|0;e=Qb+4|0;k[Pb>>2]=0;k[Pb+4>>2]=0;k[Pb+8>>2]=0;k[Pb+12>>2]=0;if((k[e>>2]|0)>0){f=k[Qb+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Qb+44>>2]|0;if((b|0)==(Qb+48|0)|(b|0)==0){r=Rb;return}ggb(k[b+-4>>2]|0);r=Rb;return}function BUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=a+4|0;c=k[n>>2]|0;d=k[a>>2]|0;i=c-d>>5;e=i+1|0;if(e>>>0>134217727)ad(426534,426557,304,426811);l=d;j=c;m=a+8|0;h=(k[m>>2]|0)-d|0;f=h>>4;f=h>>5>>>0<67108863?(f>>>0<e>>>0?e:f):134217727;if(!f)e=0;else{if(f>>>0>134217727){n=te(4)|0;k[n>>2]=172664;Cf(n|0,28816,1287)}e=f<<5;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d}g=e+(i<<5)|0;d=g;h=e+(f<<5)|0;p[g>>3]=+p[b>>3];p[e+(i<<5)+8>>3]=+p[b+8>>3];f=e+(i<<5)+16|0;i=b+16|0;k[f>>2]=k[i>>2];k[f+4>>2]=k[i+4>>2];k[f+8>>2]=k[i+8>>2];k[f+12>>2]=k[i+12>>2];f=g+32|0;if((j|0)!=(l|0)){e=j;c=g;do{i=e;e=e+-32|0;p[c+-32>>3]=+p[e>>3];p[c+-24>>3]=+p[i+-24>>3];j=c+-16|0;i=i+-16|0;k[j>>2]=k[i>>2];k[j+4>>2]=k[i+4>>2];k[j+8>>2]=k[i+8>>2];k[j+12>>2]=k[i+12>>2];c=d+-32|0;d=c}while((e|0)!=(l|0));c=k[a>>2]|0}k[a>>2]=d;k[n>>2]=f;k[m>>2]=h;if(!c)return;ggb(c);return}function CUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;k[a>>2]=0;g=a+4|0;k[g>>2]=0;k[a+8>>2]=0;f=b+4|0;c=(k[f>>2]|0)-(k[b>>2]|0)|0;e=c>>5;if(!e)return;if(e>>>0>134217727)ad(426534,426557,304,426811);d=(c|0)==0?1:c;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[g>>2]=c;k[a>>2]=c;k[a+8>>2]=c+(e<<5);d=k[b>>2]|0;a=k[f>>2]|0;if((d|0)==(a|0))return;do{p[c>>3]=+p[d>>3];p[c+8>>3]=+p[d+8>>3];f=c+16|0;e=d+16|0;k[f>>2]=k[e>>2];k[f+4>>2]=k[e+4>>2];k[f+8>>2]=k[e+8>>2];k[f+12>>2]=k[e+12>>2];d=d+32|0;c=(k[g>>2]|0)+32|0;k[g>>2]=c}while((d|0)!=(a|0));return}function DUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+4|0;c=k[a>>2]|0;e=((k[i>>2]|0)-c|0)/12|0;d=e+1|0;if(d>>>0>357913941)ad(426534,426557,304,426811);j=a+8|0;h=((k[j>>2]|0)-c|0)/12|0;f=h<<1;f=h>>>0<178956970?(f>>>0<d>>>0?d:f):357913941;if(!f)c=0;else{if(f>>>0>357913941){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=f*12|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}d=c+(e*12|0)|0;e=d;g=c+(f*12|0)|0;CUa(d,b);b=d+12|0;f=k[a>>2]|0;c=k[i>>2]|0;if((c|0)==(f|0)){c=e;h=f;e=f}else{do{c=c+-12|0;CUa(d+-12|0,c);d=e+-12|0;e=d}while((c|0)!=(f|0));c=e;h=k[a>>2]|0;e=k[i>>2]|0}k[a>>2]=c;k[i>>2]=b;k[j>>2]=g;g=h;if((e|0)!=(g|0))do{c=e;e=e+-12|0;f=k[e>>2]|0;b=f;if(f|0){c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(f|0))k[c>>2]=d+(~((d+-32-b|0)>>>5)<<5);ggb(f)}}while((e|0)!=(g|0));if(!h)return;ggb(h);return}function EUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+o[b>>2]);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function FUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function GUa(a){a=a|0;ggb(a);return}function HUa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function IUa(a){a=a|0;_Ua(a);return}function JUa(a){a=a|0;_Ua(a);ggb(a);return}function KUa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0.0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;W=r;r=r+1184|0;T=W+848|0;S=W+56|0;R=W+520|0;D=W+464|0;C=W;B=W+408|0;A=W+392|0;V=W+336|0;U=W+280|0;P=(k[e>>2]&2031616|0)!=0;do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[V>>2]=k[l>>2];t=V+4|0;g=l+4|0;k[t>>2]=k[g>>2];O=V+8|0;k[O>>2]=k[l+8>>2];k[V+12>>2]=k[l+12>>2];k[V+16>>2]=k[l+16>>2];k[V+20>>2]=k[l+20>>2];k[V+24>>2]=k[l+24>>2];k[V+28>>2]=k[l+28>>2];k[V+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[V+36>>2]=h;j=V+40|0;k[j>>2]=O;O=V+48|0;n=V+44|0;k[n>>2]=O;k[V+52>>2]=0;k[O>>2]=0;if(h|0){O=h+12|0;k[O>>2]=(k[O>>2]|0)+1}if((k[g>>2]|0)<3){N=k[l+44>>2]|0;O=k[n>>2]|0;k[O>>2]=k[N>>2];k[O+4>>2]=k[N+4>>2];break}k[t>>2]=0;x1(V,k[g>>2]|0,0,0,0);if((k[t>>2]|0)>0){q=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[q+(g<<2)>>2];k[h+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[t>>2]|0))}}else Q1(V,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){m=k[c+4>>2]|0;k[U>>2]=k[m>>2];t=U+4|0;h=m+4|0;k[t>>2]=k[h>>2];O=U+8|0;k[O>>2]=k[m+8>>2];k[U+12>>2]=k[m+12>>2];k[U+16>>2]=k[m+16>>2];k[U+20>>2]=k[m+20>>2];k[U+24>>2]=k[m+24>>2];k[U+28>>2]=k[m+28>>2];k[U+32>>2]=k[m+32>>2];g=k[m+36>>2]|0;k[U+36>>2]=g;j=U+40|0;k[j>>2]=O;O=U+48|0;n=U+44|0;k[n>>2]=O;k[U+52>>2]=0;k[O>>2]=0;if(g|0){O=g+12|0;k[O>>2]=(k[O>>2]|0)+1}if((k[h>>2]|0)<3){N=k[m+44>>2]|0;O=k[n>>2]|0;k[O>>2]=k[N>>2];k[O+4>>2]=k[N+4>>2];break}k[t>>2]=0;x1(U,k[h>>2]|0,0,0,0);if((k[t>>2]|0)>0){q=k[m+40>>2]|0;l=k[j>>2]|0;j=k[m+44>>2]|0;h=k[n>>2]|0;g=0;do{k[l+(g<<2)>>2]=k[q+(g<<2)>>2];k[h+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[t>>2]|0))}}else Q1(U,c,-1);while(0);if(k[V>>2]&4095|0){k[T+8>>2]=0;k[T+12>>2]=0;k[T>>2]=16842752;k[T+4>>2]=V;O=S+4|0;N=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[S>>2]=33619968;k[O>>2]=V;$aa(T,S,6,0)}if(!f){do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[C>>2]=k[l>>2];t=C+4|0;g=l+4|0;k[t>>2]=k[g>>2];O=C+8|0;k[O>>2]=k[l+8>>2];k[C+12>>2]=k[l+12>>2];k[C+16>>2]=k[l+16>>2];k[C+20>>2]=k[l+20>>2];k[C+24>>2]=k[l+24>>2];k[C+28>>2]=k[l+28>>2];k[C+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[C+36>>2]=h;j=C+40|0;k[j>>2]=O;O=C+48|0;n=C+44|0;k[n>>2]=O;k[C+52>>2]=0;k[O>>2]=0;if(h|0){O=h+12|0;k[O>>2]=(k[O>>2]|0)+1}if((k[g>>2]|0)<3){N=k[l+44>>2]|0;O=k[n>>2]|0;k[O>>2]=k[N>>2];k[O+4>>2]=k[N+4>>2];break}k[t>>2]=0;x1(C,k[g>>2]|0,0,0,0);if((k[t>>2]|0)>0){q=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[q+(g<<2)>>2];k[h+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[t>>2]|0))}}else Q1(C,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){l=k[c+4>>2]|0;k[B>>2]=k[l>>2];t=B+4|0;g=l+4|0;k[t>>2]=k[g>>2];O=B+8|0;k[O>>2]=k[l+8>>2];k[B+12>>2]=k[l+12>>2];k[B+16>>2]=k[l+16>>2];k[B+20>>2]=k[l+20>>2];k[B+24>>2]=k[l+24>>2];k[B+28>>2]=k[l+28>>2];k[B+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[B+36>>2]=h;j=B+40|0;k[j>>2]=O;O=B+48|0;n=B+44|0;k[n>>2]=O;k[B+52>>2]=0;k[O>>2]=0;if(h|0){O=h+12|0;k[O>>2]=(k[O>>2]|0)+1}if((k[g>>2]|0)<3){N=k[l+44>>2]|0;O=k[n>>2]|0;k[O>>2]=k[N>>2];k[O+4>>2]=k[N+4>>2];break}k[t>>2]=0;x1(B,k[g>>2]|0,0,0,0);if((k[t>>2]|0)>0){q=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[q+(g<<2)>>2];k[h+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[t>>2]|0))}}else Q1(B,c,-1);while(0);if(k[C>>2]&4095|0){O=T+4|0;N=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[T>>2]=33619968;k[O>>2]=C;$aa(b,T,6,0)}y=k[a+8>>2]|0;k[A+4>>2]=0;z=A+8|0;k[z>>2]=0;k[A+12>>2]=0;k[A>>2]=(y|0)==0?1:y<<1;y=A+4|0;k[D>>2]=1124007936;v=D+4|0;j=D+8|0;b=D+40|0;f=v;c=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(c|0));k[b>>2]=j;x=D+48|0;w=D+44|0;k[w>>2]=x;k[D+52>>2]=0;k[x>>2]=0;g=T+4|0;h=g+4|0;k[h>>2]=0;k[h+4>>2]=0;k[T>>2]=33619968;k[g>>2]=D;mY(C,T);k[R>>2]=1124007936;g=R+8|0;h=R+40|0;f=R+4|0;c=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(c|0));k[h>>2]=g;t=R+48|0;k[R+44>>2]=t;k[R+52>>2]=0;k[t>>2]=0;m=R+56|0;g=R+64|0;h=R+96|0;f=R+60|0;c=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(c|0));k[h>>2]=g;n=R+104|0;k[R+100>>2]=n;k[R+108>>2]=0;k[n>>2]=0;k[m>>2]=1124007936;n=R+120|0;k[n>>2]=0;q=R+124|0;k[q>>2]=0;KG(R,D)|0;j=k[j>>2]|0;l=k[D+12>>2]|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=1124007936;g=S+16|0;h=S+48|0;f=S+12|0;c=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(c|0));k[h>>2]=g;g=S+56|0;k[S+52>>2]=g;k[S+60>>2]=0;k[g>>2]=0;k[S+64>>2]=1124007936;g=S+72|0;h=S+104|0;f=S+68|0;c=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(c|0));k[h>>2]=g;g=S+112|0;k[S+108>>2]=g;k[S+116>>2]=0;k[g>>2]=0;k[S+120>>2]=1124007936;g=S+128|0;h=S+160|0;f=S+124|0;c=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(c|0));k[h>>2]=g;f=S+168|0;k[S+164>>2]=f;c=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(c|0));k[T>>2]=l;k[T+4>>2]=j;j1(S,48,T,0);O=k[S>>2]|0;dh[k[(k[O>>2]|0)+12>>2]&255](O,S,m,0);XN(S);o[R+112>>2]=1.0;o[R+116>>2]=0.0;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[g>>2]=128284;k[g+4>>2]=1;i[g+8>>0]=0;k[g+12>>2]=3;while(1){h=fgb(16)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}N=h+4|0;k[N>>2]=1;k[h>>2]=128380;k[h+8>>2]=g;l=h;k[N>>2]=(k[N>>2]|0)+1;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1){if(h|0)Q=53}else{Uh[k[(k[h>>2]|0)+8>>2]&2047](h);Q=53}if((Q|0)==53){O=h+4|0;k[O>>2]=(k[O>>2]|0)+1}j=k[n>>2]|0;k[n>>2]=l;k[q>>2]=g;if(j|0?(N=j+4|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0)Uh[k[(k[j>>2]|0)+8>>2]&2047](j);if(h|0?(N=h+4|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0)Uh[k[(k[h>>2]|0)+8>>2]&2047](h);ITa(R+128|0,k[t>>2]|0,0);ITa(R+228|0,k[t>>2]|0,3);g=k[z>>2]|0;l=A+12|0;if((g|0)==(k[l>>2]|0))YUa(y,R);else{XUa(g,R);k[z>>2]=g+328}QUa(R);j=D+36|0;g=k[j>>2]|0;if(g|0?(N=g+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[D+32>>2]|0;if(!g){g=B1()|0;h=k[j>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;O=D+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[v>>2]|0)>0){h=k[b>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[v>>2]|0))}g=k[w>>2]|0;if(!((g|0)==(x|0)|(g|0)==0))ggb(k[g+-4>>2]|0);if((k[A>>2]|0)>1){g=k[z>>2]|0;ZUa(T,g+-328|0,1);if((g|0)==(k[l>>2]|0))YUa(y,T);else{XUa(g,T);k[z>>2]=g+328}QUa(T);h=k[A>>2]|0;if((h|0)>2){j=2;do{ZUa(T,(k[y>>2]|0)+((j+-2|0)*328|0)|0,0);g=k[z>>2]|0;if((g|0)==(k[l>>2]|0))YUa(y,T);else{XUa(g,T);k[z>>2]=g+328}QUa(T);ZUa(T,(k[y>>2]|0)+((j+-1|0)*328|0)|0,0);g=k[z>>2]|0;if((g|0)==(k[l>>2]|0))YUa(y,T);else{XUa(g,T);k[z>>2]=g+328}QUa(T);j=j+2&255}while((j|0)<(h|0))}}PUa(A,k[a+4>>2]|0,d);dXa(d,B);g=k[A+4>>2]|0;if(g|0){h=k[z>>2]|0;while(1){if((h|0)==(g|0))break;O=h+-328|0;k[z>>2]=O;QUa(O);h=O}ggb(g)}j=B+36|0;g=k[j>>2]|0;if(g|0?(N=g+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[B+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;O=B+16|0;h=B+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[h>>2]|0)>0){j=k[B+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[B+44>>2]|0;if(!((g|0)==(B+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=C+36|0;g=k[j>>2]|0;do if(g|0){N=g+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[C+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;O=C+16|0;h=C+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[h>>2]|0)>0){j=k[C+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[C+44>>2]|0;if(!((g|0)==(C+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0)}w=d+4|0;g=(k[w>>2]|0)-(k[d>>2]|0)|0;h=(g|0)/28|0;k[T>>2]=0;O=T+4|0;k[O>>2]=0;k[T+8>>2]=0;g=(g|0)==0;if(!g)U1(T,h);if(!(i[427976]|0)){i[427976]=1;o[206780]=4.906890869140625}if(!g){n=k[T>>2]|0;j=k[d>>2]|0;c=a+24|0;b=V+12|0;v=V+8|0;q=0;t=n;f=j;while(1){g=~~(64.0/+o[206780]*(+_(+(+o[j+(q*28|0)+8>>2]/7.200000286102295))/.6931471824645996)+.5);g=(g|0)<0?0:g;g=g>>>0>63?63:g;k[n+(q<<2)>>2]=g;g=k[(k[c>>2]|0)+(g<<2)>>2]|0;s=+(g|0);u=+o[j+(q*28|0)>>2];if((u<s?0:!(u>=+((k[b>>2]|0)-g|0)))?(u=+o[j+(q*28|0)+4>>2],!(u<s?1:u>=+((k[v>>2]|0)-g|0))):0){g=q;l=t;m=f}else{j=f+(q*28|0)|0;g=j+28|0;l=k[w>>2]|0;if((g|0)!=(l|0)){do{k[j>>2]=k[g>>2];k[j+4>>2]=k[g+4>>2];N=j+8|0;M=g+8|0;k[N>>2]=k[M>>2];k[N+4>>2]=k[M+4>>2];k[N+8>>2]=k[M+8>>2];k[N+12>>2]=k[M+12>>2];k[N+16>>2]=k[M+16>>2];g=g+28|0;j=j+28|0}while((g|0)!=(l|0));g=k[w>>2]|0;if((g|0)!=(j|0))Q=132}else Q=132;if((Q|0)==132){Q=0;k[w>>2]=g+(~(((g+-28-j|0)>>>0)/28|0)*28|0)}m=t+(q<<2)|0;g=m+4|0;j=k[O>>2]|0;l=j-g|0;n=l>>2;if(n){wpb(m|0,g|0,l|0)|0;j=k[O>>2]|0}g=m+(n<<2)|0;if((j|0)!=(g|0))k[O>>2]=j+(~((j+-4-g|0)>>>2)<<2);m=(q|0)==0;j=k[d>>2]|0;n=k[T>>2]|0;h=h+-1|0;g=q+-1|0;l=m?n:t;m=m?j:f}q=g+1|0;if(q>>>0>=h>>>0)break;else{t=l;f=m}}}k[S>>2]=1124007936;M=S+4|0;g=S+8|0;K=S+40|0;f=M;c=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(c|0));k[K>>2]=g;N=S+48|0;L=S+44|0;k[L>>2]=N;k[S+52>>2]=0;k[N>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;k[R>>2]=16842752;k[R+4>>2]=V;F=D+4|0;j=F+4|0;k[j>>2]=0;k[j+4>>2]=0;k[D>>2]=33619968;k[F>>2]=S;Iua(R,D,49332,49332,-1,-1);F=a+16|0;j=k[F>>2]|0;j=j>>>0>1073741823?-1:j<<2;j=(j|0)==0?1:j;while(1){g=fgb(j)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[R>>2]=1124007936;J=R+4|0;j=R+8|0;H=R+40|0;f=J;c=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(c|0));k[H>>2]=j;I=R+48|0;G=R+44|0;k[G>>2]=I;k[R+52>>2]=0;k[I>>2]=0;if(P){c2(e,h,k[a+28>>2]|0,0,-1,0,0);do if((k[e>>2]&2031616|0)==65536){n=k[e+4>>2]|0;k[D>>2]=k[n>>2];c=D+4|0;j=n+4|0;k[c>>2]=k[j>>2];E=D+8|0;k[E>>2]=k[n+8>>2];k[D+12>>2]=k[n+12>>2];k[D+16>>2]=k[n+16>>2];k[D+20>>2]=k[n+20>>2];k[D+24>>2]=k[n+24>>2];k[D+28>>2]=k[n+28>>2];k[D+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[D+36>>2]=l;m=D+40|0;k[m>>2]=E;E=D+48|0;t=D+44|0;k[t>>2]=E;k[D+52>>2]=0;k[E>>2]=0;if(l|0){E=l+12|0;k[E>>2]=(k[E>>2]|0)+1}if((k[j>>2]|0)<3){e=k[n+44>>2]|0;E=k[t>>2]|0;k[E>>2]=k[e>>2];k[E+4>>2]=k[e+4>>2];break}k[c>>2]=0;x1(D,k[j>>2]|0,0,0,0);if((k[c>>2]|0)>0){f=k[n+40>>2]|0;q=k[m>>2]|0;m=k[n+44>>2]|0;l=k[t>>2]|0;j=0;do{k[q+(j<<2)>>2]=k[f+(j<<2)>>2];k[l+(j<<2)>>2]=k[m+(j<<2)>>2];j=j+1|0}while((j|0)<(k[c>>2]|0))}}else Q1(D,e,-1);while(0);KG(R,D)|0;m=D+36|0;j=k[m>>2]|0;if(j|0?(e=j+12|0,E=k[e>>2]|0,k[e>>2]=E+-1,(E|0)==1):0){l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;if(!j){j=k[D+32>>2]|0;if(!j){j=B1()|0;l=k[m>>2]|0}}jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}k[m>>2]=0;E=D+16|0;l=D+4|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[l>>2]|0)>0){m=k[D+40>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[D+44>>2]|0;if(!((j|0)==(D+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0);p[C>>3]=0.0;k[D>>2]=-1056833530;k[D+4>>2]=C;k[D+8>>2]=1;k[D+12>>2]=1;pY(R,D,49332)}E=R+16|0;if(h|0){z=a+40|0;A=a+48|0;B=a+28|0;e=a+44|0;C=a+52|0;y=P^1;D=k[T>>2]|0;x=a+12|0;w=k[d>>2]|0;j=k[E>>2]|0;v=0;do{b=D+(v<<2)|0;f=w+(v*28|0)|0;c=w+(v*28|0)+4|0;l=k[F>>2]|0;if(!l)t=0;else{s=+o[f>>2];u=+o[c>>2];m=0;n=g;while(1){l=OUa(k[x>>2]|0,l,V,S,s,u,k[b>>2]|0,0,m)|0;k[n>>2]=l;m=m+1|0;l=k[F>>2]|0;if(m>>>0>=l>>>0){t=l;break}else n=n+4|0}}l=k[e>>2]|0;d=k[C>>2]|0;q=l+(d<<4)|0;if((d|0)>0){n=l;m=0;l=0;do{d=(k[g+(k[n>>2]<<2)>>2]|0)-(k[g+(k[n+4>>2]<<2)>>2]|0)|0;a=(aa(d,k[n+8>>2]|0)|0)/1024|0;l=a+l|0;m=((aa(k[n+12>>2]|0,d)|0)/1024|0)+m|0;n=n+16|0}while(n>>>0<q>>>0)}else{m=0;l=0}s=+Y(+(+(m|0)),+(+(l|0)))/3.141592653589793*180.0;m=w+(v*28|0)+12|0;s=s<0.0&y?s+360.0:s;o[m>>2]=s;if(P){if(!(s==-1.0)){l=~~(s/360.0*1024.0+.5);l=(l|0)<0?l+1024|0:l;l=(l|0)>1023?l+-1024|0:l;if(s<0.0)Q=177}else{l=0;s=-1.0;Q=177}if((Q|0)==177){Q=0;o[m>>2]=s+360.0}if(t|0){u=+o[f>>2];s=+o[c>>2];n=0;q=g;m=t;while(1){d=OUa(k[x>>2]|0,m,V,S,u,s,k[b>>2]|0,l,n)|0;k[q>>2]=d;n=n+1|0;m=k[F>>2]|0;if(n>>>0>=m>>>0)break;else q=q+4|0}}l=k[z>>2]|0;d=k[A>>2]|0;t=l+(d<<3)|0;if((d|0)>0){q=j;m=0;while(1){if((k[g+(k[l>>2]<<2)>>2]|0)>(k[g+(k[l+4>>2]<<2)>>2]|0))k[q>>2]=k[q>>2]|1<<m;m=m+1|0;n=(m|0)==32;l=l+8|0;if(l>>>0>=t>>>0)break;else{q=n?q+4|0:q;m=n?0:m}}}j=j+(k[B>>2]|0)|0}v=v+1|0}while((v|0)!=(h|0))}ggb(g);j=R+36|0;g=k[j>>2]|0;if(g|0?(P=g+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[R+32>>2]|0;if(!g){g=B1()|0;h=k[j>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[J>>2]|0)>0){h=k[H>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[J>>2]|0))}g=k[G>>2]|0;if(!((g|0)==(I|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=S+36|0;g=k[j>>2]|0;if(g|0?(Q=g+12|0,R=k[Q>>2]|0,k[Q>>2]=R+-1,(R|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[S+32>>2]|0;if(!g){g=B1()|0;h=k[j>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;S=S+16|0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[M>>2]|0)>0){h=k[K>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[M>>2]|0))}g=k[L>>2]|0;if(!((g|0)==(N|0)|(g|0)==0))ggb(k[g+-4>>2]|0);g=k[T>>2]|0;h=g;if(g|0){j=k[O>>2]|0;if((j|0)!=(g|0))k[O>>2]=j+(~((j+-4-h|0)>>>2)<<2);ggb(g)}j=U+36|0;g=k[j>>2]|0;if(g|0?(S=g+12|0,T=k[S>>2]|0,k[S>>2]=T+-1,(T|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[U+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;T=U+16|0;h=U+4|0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[h>>2]|0)>0){j=k[U+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[U+44>>2]|0;if(!((g|0)==(U+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=V+36|0;g=k[j>>2]|0;do if(g|0){T=g+12|0;U=k[T>>2]|0;k[T>>2]=U+-1;if((U|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[V+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;U=V+16|0;h=V+4|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[h>>2]|0)>0){j=k[V+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[V+44>>2]|0;if((g|0)==(V+48|0)|(g|0)==0){r=W;return}ggb(k[g+-4>>2]|0);r=W;return}function LUa(a){a=a|0;return k[a+28>>2]|0}function MUa(a){a=a|0;return 0}function NUa(a){a=a|0;return 6}function OUa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;var j=0.0,m=0.0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0;A=(aa((g<<10)+h|0,b)|0)+i|0;m=+o[a+(A*12|0)>>2]+e;j=+o[a+(A*12|0)+4>>2]+f;b=~~m;g=~~j;f=+o[a+(A*12|0)+8>>2];e=f*(f*4.0);if(f<.5){x=~~((m-+(b|0))*1024.0);A=~~((j-+(g|0))*1024.0);w=1024-x|0;u=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,g)|0)+b|0;v=k[c+48>>2]|0;z=aa(l[u>>0]|0,w)|0;y=aa(l[u+1>>0]|0,x)|0;x=aa(l[u+v>>0]|0,x)|0;A=((aa((aa(l[u+(v+1)>>0]|0,w)|0)+x|0,A)|0)+512+(aa(y+z|0,1024-A|0)|0)|0)/1024|0;return A|0}w=~~(4194304.0/e);B=+(w|0);A=~~(e*B*.0009765625);s=k[c+12>>2]|0;a=s+1|0;C=m-f;e=m+f;m=j-f;f=j+f;h=~~(C+.5);i=~~(m+.5);x=~~(e+.5);r=~~(f+.5);j=+(h|0)-C+.5;m=+(i|0)-m+.5;e=e-+(x|0)+.5;f=f-+(r|0)+.5;x=x-h|0;b=x+-1|0;q=1-x|0;r=r-i+-1|0;p=~~(B*(e*m));z=~~(B*(e*f));v=~~(B*(j*f));t=~~(B*j);n=~~(B*m);u=~~(B*e);y=~~(B*f);c=(k[c+16>>2]|0)+h+(aa(s,i)|0)|0;g=aa(l[c>>0]|0,~~(B*(j*m)))|0;if((b+r|0)>2){D=c+x|0;F=aa(l[D>>0]|0,p)|0;D=D+((aa(s,r)|0)+1)|0;E=aa(l[D>>0]|0,z)|0;D=aa(l[D+(0-x)>>0]|0,v)|0;c=(k[d+16>>2]|0)+(h<<2)+((aa(a,i)|0)<<2)+4|0;d=c+(b<<2)|0;h=d+(a<<2)|0;p=k[h>>2]|0;h=h+4|0;z=aa(a,r)|0;i=h+(z<<2)|0;x=i+-4|0;r=k[x>>2]|0;a=x+(a<<2)|0;q=a+(q<<2)|0;x=q+(~s<<2)|0;v=k[x>>2]|0;x=x+-4|0;z=x+(0-z<<2)|0;b=k[z+4>>2]|0;b=g+((A|0)/2|0)+F+E+D+(aa(p-(k[h>>2]|0)+(k[i>>2]|0)-r|0,u)|0)+(aa((k[a>>2]|0)-r-(k[q>>2]|0)+v|0,y)|0)+(aa((k[c>>2]|0)-(k[d>>2]|0)+p-b|0,n)|0)+(aa(r-p-v+b|0,w)|0)+(aa(v-(k[x>>2]|0)+(k[z>>2]|0)-b|0,t)|0)|0}else{h=c+1|0;a=c+x|0;d=(x|0)>1;b=l[h>>0]|0;if(d)while(1){g=(aa(b,n)|0)+g|0;i=h+1|0;b=l[i>>0]|0;if(i>>>0<a>>>0)h=i;else break}else h=c;g=(aa(b,p)|0)+g|0;n=q+-1+s|0;i=h+1+n|0;F=aa(s,r)|0;c=i+F|0;b=l[i>>0]|0;if((F|0)>0)do{h=(aa(b,t)|0)+g|0;g=i+1|0;a=i+x|0;b=l[g>>0]|0;if(d){i=g;g=h;while(1){g=(aa(b,w)|0)+g|0;h=i+1|0;b=l[h>>0]|0;if(h>>>0<a>>>0)i=h;else break}}else g=h;g=(aa(b,u)|0)+g|0;i=i+1+n|0;b=l[i>>0]|0}while(i>>>0<c>>>0);g=(aa(b,v)|0)+g|0;h=i+1|0;i=i+x|0;b=l[h>>0]|0;if(d)do{g=(aa(b,y)|0)+g|0;h=h+1|0;b=l[h>>0]|0}while(h>>>0<i>>>0);b=g+((A|0)/2|0)+(aa(b,z)|0)|0}F=(b|0)/(A|0)|0;return F|0}function PUa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0.0,p=0,q=0.0,s=0,t=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0.0,Ja=0.0;Ha=r;r=r+112|0;za=Ha+80|0;Aa=Ha+76|0;Ba=Ha+48|0;Ca=Ha+44|0;Da=Ha+32|0;Ea=Ha+28|0;Fa=Ha;ya=c+4|0;e=k[ya>>2]|0;m=k[c>>2]|0;p=m;f=e;if(!((e|0)==(m|0)|(f|0)==(p|0))){e=f+(~(((f+-28-m|0)>>>0)/28|0)*28|0)|0;k[ya>>2]=e}xa=c+8|0;if((((k[xa>>2]|0)-m|0)/28|0)>>>0<2e3){g=(e-m|0)/28|0;while(1){f=fgb(56e3)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}g=f+(g*28|0)|0;j=g;h=f+56e3|0;if((e|0)==(p|0)){f=j;e=m}else{f=j;do{va=e;e=e+-28|0;k[g+-28>>2]=k[e>>2];k[g+-24>>2]=k[va+-24>>2];wa=g+-20|0;va=va+-20|0;k[wa>>2]=k[va>>2];k[wa+4>>2]=k[va+4>>2];k[wa+8>>2]=k[va+8>>2];k[wa+12>>2]=k[va+12>>2];k[wa+16>>2]=k[va+16>>2];g=f+-28|0;f=g}while((e|0)!=(p|0));e=k[c>>2]|0}k[c>>2]=f;k[ya>>2]=j;k[xa>>2]=h;if(e|0)ggb(e)}ua=+(b|0);va=~~ua;k[Da>>2]=0;wa=Da+4|0;k[wa>>2]=0;k[Da+8>>2]=0;e=k[a>>2]|0;a:do if((e|0)!=0?(RUa(Da,e),(k[a>>2]|0)>0):0){z=a+4|0;C=k[Da>>2]|0;s=za+8|0;t=za+12|0;v=za+4|0;A=C;b=0;do{e=k[z>>2]|0;j=C+(b*12|0)|0;f=e+(b*328|0)+124|0;ta=k[f>>2]|0;jh[k[(k[ta>>2]|0)+64>>2]&1023](ta,va);f=k[f>>2]|0;ta=k[(k[f>>2]|0)+32>>2]|0;k[s>>2]=0;k[t>>2]=0;k[za>>2]=16842752;k[v>>2]=e+(b*328|0);dh[ta&255](f,za,j,49332);f=k[j>>2]|0;ta=(k[C+(b*12|0)+4>>2]|0)-f|0;m=(ta|0)/28|0;b:do if(ta|0){p=e+(b*328|0)+72|0;h=e+(b*328|0)+100|0;e=0;while(1){n=+o[f+(e*28|0)+16>>2];g=(o[u>>2]=n,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;n=g?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=g?-0.0:0.0}sa=~~n;ta=(k[p>>2]|0)+(aa(k[k[h>>2]>>2]|0,~~+o[f+(e*28|0)+4>>2])|0)+~~+o[f+(e*28|0)>>2]|0;i[ta>>0]=sa>>>0<256?sa:(sa|0)>0?255:0;e=e+1|0;if(e>>>0>=m>>>0)break b;f=k[j>>2]|0}}while(0);b=b+1|0;e=k[a>>2]|0}while((b|0)<(e|0));if((e|0)==1){ta=(k[C+4>>2]|0)-(k[C>>2]|0)|0;v=(ta|0)/28|0;if(!ta){d=C;Ga=C;break}h=Ba+4|0;j=Ba+8|0;m=Ba+12|0;p=Ba+16|0;b=Ba+20|0;s=Ba+24|0;t=k[wa>>2]|0;g=0;while(1){if((t|0)==(A|0))break;f=k[C>>2]|0;e=f+(g*28|0)|0;f=f+(g*28|0)+4|0;if(SUa(k[z>>2]|0,0,~~+o[e>>2],~~+o[f>>2])|0){ta=k[z>>2]|0;la=TUa(ta,+o[e>>2]+-1.0,+o[f>>2]+-1.0,1)|0;oa=TUa(ta,+o[e>>2],+o[f>>2]+-1.0,1)|0;ra=TUa(ta,+o[e>>2]+1.0,+o[f>>2]+-1.0,1)|0;sa=TUa(ta,+o[e>>2]+1.0,+o[f>>2],1)|0;pa=TUa(ta,+o[e>>2],+o[f>>2],1)|0;ma=TUa(ta,+o[e>>2]+-1.0,+o[f>>2],1)|0;na=TUa(ta,+o[e>>2]+-1.0,+o[f>>2]+1.0,1)|0;qa=TUa(ta,+o[e>>2],+o[f>>2]+1.0,1)|0;Y=+UUa(la,ma,na,oa,pa,qa,ra,sa,TUa(ta,+o[e>>2]+1.0,+o[f>>2]+1.0,1)|0,za,Aa);q=+o[e>>2]+ +o[za>>2];n=+o[f>>2]+ +o[Aa>>2];o[Ba>>2]=q;o[h>>2]=n;o[j>>2]=12.0;o[m>>2]=-1.0;o[p>>2]=Y;k[b>>2]=0;k[s>>2]=-1;e=k[ya>>2]|0;if((e|0)==(k[xa>>2]|0))H6(c,Ba);else{o[e>>2]=q;o[e+4>>2]=n;ta=e+8|0;k[ta>>2]=k[j>>2];k[ta+4>>2]=k[j+4>>2];k[ta+8>>2]=k[j+8>>2];k[ta+12>>2]=k[j+12>>2];k[ta+16>>2]=k[j+16>>2];k[ya>>2]=(k[ya>>2]|0)+28}}g=g+1|0;if(g>>>0>=v>>>0){d=C;e=C;E=524;break a}}ad(426635,426557,315,426658)}else D=e;if((D|0)>0){ga=a+4|0;ha=Fa+4|0;ia=Fa+8|0;ja=Fa+12|0;ka=Fa+16|0;la=Fa+20|0;ma=Fa+24|0;na=za+4|0;oa=za+8|0;pa=za+12|0;qa=za+16|0;ra=za+20|0;sa=za+24|0;ta=za+4|0;n=0.0;fa=0;f=0;e=0;m=D;c:while(1){j=k[ga>>2]|0;t=j+(fa*328|0)|0;v=k[Da>>2]|0;g=(k[v+(fa*12|0)+4>>2]|0)-(k[v+(fa*12|0)>>2]|0)|0;ea=(g|0)/28|0;g=(g|0)!=0;h=v;d:do if((fa|0)==(m+-1|0)){if(g){s=j+(fa*328|0)+112|0;p=j+(fa*328|0)+116|0;b=k[wa>>2]|0;m=0;do{if(((b-h|0)/12|0)>>>0<=fa>>>0){E=44;break c}j=k[v+(fa*12|0)>>2]|0;g=j+(m*28|0)|0;j=j+(m*28|0)+4|0;if(SUa(k[ga>>2]|0,fa,~~+o[g>>2],~~+o[j>>2])|0?(P=+o[g>>2],Y=+o[j>>2],+VUa(a,fa,~~P,~~Y,TUa(t,P,Y,va)|0,za,Aa,Ba),i[za>>0]|0):0){W=TUa(t,+o[g>>2]+-1.0,+o[j>>2]+-1.0,1)|0;_=TUa(t,+o[g>>2],+o[j>>2]+-1.0,1)|0;ca=TUa(t,+o[g>>2]+1.0,+o[j>>2]+-1.0,1)|0;da=TUa(t,+o[g>>2]+1.0,+o[j>>2],1)|0;$=TUa(t,+o[g>>2],+o[j>>2],1)|0;X=TUa(t,+o[g>>2]+-1.0,+o[j>>2],1)|0;Z=TUa(t,+o[g>>2]+-1.0,+o[j>>2]+1.0,1)|0;ba=TUa(t,+o[g>>2],+o[j>>2]+1.0,1)|0;Y=+UUa(W,X,Z,_,$,ba,ca,da,TUa(t,+o[g>>2]+1.0,+o[j>>2]+1.0,1)|0,Ca,Ea);P=+o[s>>2];q=+o[p>>2];w=(+o[g>>2]+ +o[Ca>>2])*P+q;q=q+P*(+o[j>>2]+ +o[Ea>>2]);o[Fa>>2]=w;o[ha>>2]=q;o[ia>>2]=P*12.0;o[ja>>2]=-1.0;o[ka>>2]=Y;k[la>>2]=fa;k[ma>>2]=-1;g=k[ya>>2]|0;if((g|0)==(k[xa>>2]|0))H6(c,Fa);else{o[g>>2]=w;o[g+4>>2]=q;da=g+8|0;k[da>>2]=k[ia>>2];k[da+4>>2]=k[ia+4>>2];k[da+8>>2]=k[ia+8>>2];k[da+12>>2]=k[ia+12>>2];k[da+16>>2]=k[ia+16>>2];k[ya>>2]=(k[ya>>2]|0)+28}}m=m+1|0}while(m>>>0<ea>>>0)}}else if(g){ba=fa+1|0;ca=(fa&1|0)==0;da=(fa|0)==0;g=0;while(1){if((((k[wa>>2]|0)-h|0)/12|0)>>>0<=fa>>>0){E=54;break c}j=k[h+(fa*12|0)>>2]|0;h=j+(g*28|0)|0;j=j+(g*28|0)+4|0;if(SUa(k[ga>>2]|0,fa,~~+o[h>>2],~~+o[j>>2])|0){_=~~+o[h>>2];$=~~+o[j>>2];i[Ea>>0]=1;Z=k[ga>>2]|0;X=(_|0)<3;W=($|0)<3;V=X|W;if((!V?((k[Z+(fa*328|0)+12>>2]|0)+-3|0)>(_|0):0)?((k[Z+(fa*328|0)+8>>2]|0)+-3|0)>($|0):0){z=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,$)|0)+_|0;h=i[z>>0]|0;if((h&255)<=2){t=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,$)|0)+_|0;v=l[t>>0]|0;s=0;h=255;j=255;while(1){b=(h|0)/2|0;m=b+v|0;p=v-b|0;h=65848;while(1){U=l[t+(k[Z+(fa*328|0)+228+(h>>>28<<2)>>2]|0)>>0]|0;U=((h&4096|0)==0?(U|0)>(m|0):(U|0)<(p|0))?h>>>16:h;h=U&4095;if((U&4094|0)==684)break;else h=k[138248+(h<<2)>>2]|0}h=(h|0)==502|(h|0)==684;j=h?b:j;h=h?s:b;if((h|0)==(j|0)|(h|0)==(j+-1|0))break;else{s=h;h=h+j|0}}h=(h&255|0)==0?0:h&255;i[z>>0]=h}U=h&255}else U=0;i[Ea>>0]=0;if((ba|0)>=(k[a>>2]|0)){k[za>>2]=0;k[ta>>2]=0;h=ZT(24)|0;k[h>>2]=1;j=h+4|0;k[za>>2]=j;k[ta>>2]=19;i[h+23>>0]=0;m=385533;p=j+19|0;do{i[j>>0]=i[m>>0]|0;j=j+1|0;m=m+1|0}while((j|0)<(p|0));Y8(-215,za,385553,385570,1419);k[ta>>2]=0;k[za>>2]=0;T=k[h>>2]|0;k[h>>2]=T+-1;if((T|0)==1)ggb(k[h+-4>>2]|0)}T=k[ga>>2]|0;Q=T+(ba*328|0)|0;if(ca){R=_<<2;S=$<<2;y=+(R+-3|0)/6.0;B=+(R|1|0)/6.0;w=+(S+-3|0)/6.0;P=+(S|1|0)/6.0}else{R=_*6|0;S=$*6|0;y=+(R+-4|0)*.125;B=+(R+2|0)*.125;w=+(S+-4|0)*.125;P=+(S+2|0)*.125}h=~~y;m=h+1|0;p=~~w;b=p+1|0;x=+(TUa(Q,y,w,1)|0);o[za>>2]=x;Y=+(U|0);e:do if(x>Y){B=0.0;x=0.0;w=0.0}else{R=~~B;N=(h|0)<(R|0);if(N){h=m;j=m;while(1){q=+(TUa(Q,+(j|0),w,1)|0);if(q>Y){B=0.0;x=0.0;w=0.0;break e}if(q>+o[za>>2]){o[za>>2]=q;h=j}if((j|0)<(R|0))j=j+1|0;else break}}else h=m;q=+(TUa(Q,B,w,1)|0);if(q>Y){B=0.0;x=0.0;w=0.0;break}if(q>+o[za>>2]){o[za>>2]=q;h=R}O=~~P;if((p|0)<(O|0)){G=~~(y+1.0);H=T+(ba*328|0)+12|0;I=T+(ba*328|0)+8|0;J=T+(ba*328|0)+72|0;K=T+(ba*328|0)+100|0;L=T+(ba*328|0)+16|0;M=T+(ba*328|0)+44|0;j=b;F=b;while(1){x=+(F|0);w=+(TUa(Q,y,x,1)|0);if(w>Y){B=0.0;x=0.0;w=0.0;break e}q=+o[za>>2];if(w>q){o[za>>2]=w;q=w;j=F;h=G}f:do if(N){if((F|0)<3){p=m;while(1){if(q<0.0){o[za>>2]=0.0;q=0.0;j=F;h=p}if((p|0)<(R|0))p=p+1|0;else break f}}else E=m;while(1){do if((E|0)<3)p=0;else{if(((k[H>>2]|0)+-3|0)<=(E|0)){p=0;break}if(((k[I>>2]|0)+-3|0)<=(F|0)){p=0;break}D=(k[J>>2]|0)+(aa(k[k[K>>2]>>2]|0,F)|0)+E|0;p=i[D>>0]|0;if((p&255)<=2){A=(k[L>>2]|0)+(aa(k[k[M>>2]>>2]|0,F)|0)+E|0;C=l[A>>0]|0;z=0;p=255;b=255;while(1){v=(p|0)/2|0;s=v+C|0;t=C-v|0;p=65848;while(1){S=l[A+(k[T+(ba*328|0)+228+(p>>>28<<2)>>2]|0)>>0]|0;S=((p&4096|0)==0?(S|0)>(s|0):(S|0)<(t|0))?p>>>16:p;p=S&4095;if((S&4094|0)==684)break;else p=k[138248+(p<<2)>>2]|0}p=(p|0)==502|(p|0)==684;b=p?v:b;p=p?z:v;if((p|0)==(b|0)|(p|0)==(b+-1|0))break;else{z=p;p=p+b|0}}p=(p&255|0)==0?0:p&255;i[D>>0]=p}p=p&255}while(0);q=+(p|0);if(q>Y){B=0.0;x=0.0;w=0.0;break e}if(q>+o[za>>2]){o[za>>2]=q;j=F;h=E}if((E|0)<(R|0))E=E+1|0;else break}}while(0);q=+(TUa(Q,B,x,1)|0);if(q>Y){B=0.0;x=0.0;w=0.0;break e}if(q>+o[za>>2]){o[za>>2]=q;j=F;h=R}if((F|0)<(O|0))F=F+1|0;else break}}else j=b;q=+(TUa(Q,y,P,1)|0);if(q>+o[za>>2]){o[za>>2]=q;h=~~(y+1.0);j=O}if(N)while(1){q=+(TUa(Q,+(m|0),P,1)|0);if(q>+o[za>>2]){o[za>>2]=q;h=m;j=O}if((m|0)<(R|0))m=m+1|0;else break}q=+(TUa(Q,B,P,1)|0);if(q>+o[za>>2]){o[za>>2]=q;j=O}else R=h;M=R+-1|0;D=j+-1|0;J=(R|0)<4;C=(j|0)<4;do if(C|J)S=0;else{if(((k[T+(ba*328|0)+12>>2]|0)+-3|0)<(R|0)){S=0;break}if(((k[T+(ba*328|0)+8>>2]|0)+-3|0)<(j|0)){S=0;break}A=(k[T+(ba*328|0)+72>>2]|0)+(aa(k[k[T+(ba*328|0)+100>>2]>>2]|0,D)|0)+M|0;h=i[A>>0]|0;if((h&255)<=2){v=(k[T+(ba*328|0)+16>>2]|0)+(aa(k[k[T+(ba*328|0)+44>>2]>>2]|0,D)|0)+M|0;z=l[v>>0]|0;t=0;h=255;m=255;while(1){s=(h|0)/2|0;p=s+z|0;b=z-s|0;h=65848;while(1){S=l[v+(k[T+(ba*328|0)+228+(h>>>28<<2)>>2]|0)>>0]|0;S=((h&4096|0)==0?(S|0)>(p|0):(S|0)<(b|0))?h>>>16:h;h=S&4095;if((S&4094|0)==684)break;else h=k[138248+(h<<2)>>2]|0}h=(h|0)==502|(h|0)==684;m=h?s:m;h=h?t:s;if((h|0)==(m|0)|(h|0)==(m+-1|0))break;else{t=h;h=h+m|0}}h=(h&255|0)==0?0:h&255;i[A>>0]=h}S=h&255}while(0);L=(R|0)<3;do if(C|L)Q=0;else{if(((k[T+(ba*328|0)+12>>2]|0)+-3|0)<=(R|0)){Q=0;break}if(((k[T+(ba*328|0)+8>>2]|0)+-3|0)<(j|0)){Q=0;break}A=(k[T+(ba*328|0)+72>>2]|0)+(aa(k[k[T+(ba*328|0)+100>>2]>>2]|0,D)|0)+R|0;h=i[A>>0]|0;if((h&255)<=2){v=(k[T+(ba*328|0)+16>>2]|0)+(aa(k[k[T+(ba*328|0)+44>>2]>>2]|0,D)|0)+R|0;z=l[v>>0]|0;t=0;h=255;m=255;while(1){s=(h|0)/2|0;p=s+z|0;b=z-s|0;h=65848;while(1){Q=l[v+(k[T+(ba*328|0)+228+(h>>>28<<2)>>2]|0)>>0]|0;Q=((h&4096|0)==0?(Q|0)>(p|0):(Q|0)<(b|0))?h>>>16:h;h=Q&4095;if((Q&4094|0)==684)break;else h=k[138248+(h<<2)>>2]|0}h=(h|0)==502|(h|0)==684;m=h?s:m;h=h?t:s;if((h|0)==(m|0)|(h|0)==(m+-1|0))break;else{t=h;h=h+m|0}}h=(h&255|0)==0?0:h&255;i[A>>0]=h}Q=h&255}while(0);O=R+1|0;N=(O|0)<3;do if(C|N)K=0;else{if(((k[T+(ba*328|0)+12>>2]|0)+-3|0)<=(O|0)){K=0;break}if(((k[T+(ba*328|0)+8>>2]|0)+-3|0)<(j|0)){K=0;break}A=(k[T+(ba*328|0)+72>>2]|0)+(aa(k[k[T+(ba*328|0)+100>>2]>>2]|0,D)|0)+O|0;h=i[A>>0]|0;if((h&255)<=2){v=(k[T+(ba*328|0)+16>>2]|0)+(aa(k[k[T+(ba*328|0)+44>>2]>>2]|0,D)|0)+O|0;z=l[v>>0]|0;t=0;h=255;m=255;while(1){s=(h|0)/2|0;p=s+z|0;b=z-s|0;h=65848;while(1){K=l[v+(k[T+(ba*328|0)+228+(h>>>28<<2)>>2]|0)>>0]|0;K=((h&4096|0)==0?(K|0)>(p|0):(K|0)<(b|0))?h>>>16:h;h=K&4095;if((K&4094|0)==684)break;else h=k[138248+(h<<2)>>2]|0}h=(h|0)==502|(h|0)==684;m=h?s:m;h=h?t:s;if((h|0)==(m|0)|(h|0)==(m+-1|0))break;else{t=h;h=h+m|0}}h=(h&255|0)==0?0:h&255;i[A>>0]=h}K=h&255}while(0);C=(j|0)<3;do if(C|N)I=0;else{if(((k[T+(ba*328|0)+12>>2]|0)+-3|0)<=(O|0)){I=0;break}if(((k[T+(ba*328|0)+8>>2]|0)+-3|0)<=(j|0)){I=0;break}A=(k[T+(ba*328|0)+72>>2]|0)+(aa(k[k[T+(ba*328|0)+100>>2]>>2]|0,j)|0)+O|0;h=i[A>>0]|0;if((h&255)<=2){v=(k[T+(ba*328|0)+16>>2]|0)+(aa(k[k[T+(ba*328|0)+44>>2]>>2]|0,j)|0)+O|0;z=l[v>>0]|0;t=0;h=255;m=255;while(1){s=(h|0)/2|0;p=s+z|0;b=z-s|0;h=65848;while(1){I=l[v+(k[T+(ba*328|0)+228+(h>>>28<<2)>>2]|0)>>0]|0;I=((h&4096|0)==0?(I|0)>(p|0):(I|0)<(b|0))?h>>>16:h;h=I&4095;if((I&4094|0)==684)break;else h=k[138248+(h<<2)>>2]|0}h=(h|0)==502|(h|0)==684;m=h?s:m;h=h?t:s;if((h|0)==(m|0)|(h|0)==(m+-1|0))break;else{t=h;h=h+m|0}}h=(h&255|0)==0?0:h&255;i[A>>0]=h}I=h&255}while(0);do if(C|L)H=0;else{if(((k[T+(ba*328|0)+12>>2]|0)+-3|0)<=(R|0)){H=0;break}if(((k[T+(ba*328|0)+8>>2]|0)+-3|0)<=(j|0)){H=0;break}A=(k[T+(ba*328|0)+72>>2]|0)+(aa(k[k[T+(ba*328|0)+100>>2]>>2]|0,j)|0)+R|0;h=i[A>>0]|0;if((h&255)<=2){v=(k[T+(ba*328|0)+16>>2]|0)+(aa(k[k[T+(ba*328|0)+44>>2]>>2]|0,j)|0)+R|0;z=l[v>>0]|0;t=0;h=255;m=255;while(1){s=(h|0)/2|0;p=s+z|0;b=z-s|0;h=65848;while(1){H=l[v+(k[T+(ba*328|0)+228+(h>>>28<<2)>>2]|0)>>0]|0;H=((h&4096|0)==0?(H|0)>(p|0):(H|0)<(b|0))?h>>>16:h;h=H&4095;if((H&4094|0)==684)break;else h=k[138248+(h<<2)>>2]|0}h=(h|0)==502|(h|0)==684;m=h?s:m;h=h?t:s;if((h|0)==(m|0)|(h|0)==(m+-1|0))break;else{t=h;h=h+m|0}}h=(h&255|0)==0?0:h&255;i[A>>0]=h}H=h&255}while(0);do if(C|J)G=0;else{if(((k[T+(ba*328|0)+12>>2]|0)+-3|0)<(R|0)){G=0;break}if(((k[T+(ba*328|0)+8>>2]|0)+-3|0)<=(j|0)){G=0;break}A=(k[T+(ba*328|0)+72>>2]|0)+(aa(k[k[T+(ba*328|0)+100>>2]>>2]|0,j)|0)+M|0;h=i[A>>0]|0;if((h&255)<=2){v=(k[T+(ba*328|0)+16>>2]|0)+(aa(k[k[T+(ba*328|0)+44>>2]>>2]|0,j)|0)+M|0;z=l[v>>0]|0;t=0;h=255;m=255;while(1){s=(h|0)/2|0;p=s+z|0;b=z-s|0;h=65848;while(1){G=l[v+(k[T+(ba*328|0)+228+(h>>>28<<2)>>2]|0)>>0]|0;G=((h&4096|0)==0?(G|0)>(p|0):(G|0)<(b|0))?h>>>16:h;h=G&4095;if((G&4094|0)==684)break;else h=k[138248+(h<<2)>>2]|0}h=(h|0)==502|(h|0)==684;m=h?s:m;h=h?t:s;if((h|0)==(m|0)|(h|0)==(m+-1|0))break;else{t=h;h=h+m|0}}h=(h&255|0)==0?0:h&255;i[A>>0]=h}G=h&255}while(0);F=j+1|0;E=(F|0)<3;do if(J|E)D=0;else{if(((k[T+(ba*328|0)+12>>2]|0)+-3|0)<(R|0)){D=0;break}if(((k[T+(ba*328|0)+8>>2]|0)+-3|0)<=(F|0)){D=0;break}A=(k[T+(ba*328|0)+72>>2]|0)+(aa(k[k[T+(ba*328|0)+100>>2]>>2]|0,F)|0)+M|0;h=i[A>>0]|0;if((h&255)<=2){v=(k[T+(ba*328|0)+16>>2]|0)+(aa(k[k[T+(ba*328|0)+44>>2]>>2]|0,F)|0)+M|0;z=l[v>>0]|0;t=0;h=255;m=255;while(1){s=(h|0)/2|0;p=s+z|0;b=z-s|0;h=65848;while(1){M=l[v+(k[T+(ba*328|0)+228+(h>>>28<<2)>>2]|0)>>0]|0;M=((h&4096|0)==0?(M|0)>(p|0):(M|0)<(b|0))?h>>>16:h;h=M&4095;if((M&4094|0)==684)break;else h=k[138248+(h<<2)>>2]|0}h=(h|0)==502|(h|0)==684;m=h?s:m;h=h?t:s;if((h|0)==(m|0)|(h|0)==(m+-1|0))break;else{t=h;h=h+m|0}}h=(h&255|0)==0?0:h&255;i[A>>0]=h}D=h&255}while(0);do if(L|E)C=0;else{if(((k[T+(ba*328|0)+12>>2]|0)+-3|0)<=(R|0)){C=0;break}if(((k[T+(ba*328|0)+8>>2]|0)+-3|0)<=(F|0)){C=0;break}A=(k[T+(ba*328|0)+72>>2]|0)+(aa(k[k[T+(ba*328|0)+100>>2]>>2]|0,F)|0)+R|0;h=i[A>>0]|0;if((h&255)<=2){v=(k[T+(ba*328|0)+16>>2]|0)+(aa(k[k[T+(ba*328|0)+44>>2]>>2]|0,F)|0)+R|0;z=l[v>>0]|0;t=0;h=255;m=255;while(1){s=(h|0)/2|0;p=s+z|0;b=z-s|0;h=65848;while(1){M=l[v+(k[T+(ba*328|0)+228+(h>>>28<<2)>>2]|0)>>0]|0;M=((h&4096|0)==0?(M|0)>(p|0):(M|0)<(b|0))?h>>>16:h;h=M&4095;if((M&4094|0)==684)break;else h=k[138248+(h<<2)>>2]|0}h=(h|0)==502|(h|0)==684;m=h?s:m;h=h?t:s;if((h|0)==(m|0)|(h|0)==(m+-1|0))break;else{t=h;h=h+m|0}}h=(h&255|0)==0?0:h&255;i[A>>0]=h}C=h&255}while(0);do if(E|N)h=0;else{if(((k[T+(ba*328|0)+12>>2]|0)+-3|0)<=(O|0)){h=0;break}if(((k[T+(ba*328|0)+8>>2]|0)+-3|0)<=(F|0)){h=0;break}A=(k[T+(ba*328|0)+72>>2]|0)+(aa(k[k[T+(ba*328|0)+100>>2]>>2]|0,F)|0)+O|0;h=i[A>>0]|0;if((h&255)<=2){v=(k[T+(ba*328|0)+16>>2]|0)+(aa(k[k[T+(ba*328|0)+44>>2]>>2]|0,F)|0)+O|0;z=l[v>>0]|0;t=0;h=255;m=255;while(1){s=(h|0)/2|0;p=s+z|0;b=z-s|0;h=65848;while(1){O=l[v+(k[T+(ba*328|0)+228+(h>>>28<<2)>>2]|0)>>0]|0;O=((h&4096|0)==0?(O|0)>(p|0):(O|0)<(b|0))?h>>>16:h;h=O&4095;if((O&4094|0)==684)break;else h=k[138248+(h<<2)>>2]|0}h=(h|0)==502|(h|0)==684;m=h?s:m;h=h?t:s;if((h|0)==(m|0)|(h|0)==(m+-1|0))break;else{t=h;h=h+m|0}}h=(h&255|0)==0?0:h&255;i[A>>0]=h}h=h&255}while(0);y=+UUa(S,G,D,Q,H,C,K,I,h,Aa,Ba);o[Ca>>2]=y;q=+(R|0)+ +o[Aa>>2];w=+(j|0)+ +o[Ba>>2];if(ca){x=(q*6.0+1.0)*.25-+(_|0);q=(w*6.0+1.0)*.25-+($|0)}else{x=(q*8.0+1.0)/6.0-+(_|0);q=(w*8.0+1.0)/6.0-+($|0)}do if(x>1.0){j=1;x=1.0}else{if(!(x<-1.0)){j=0;break}j=1;x=-1.0}while(0);do if(q>1.0){i[Ea>>0]=1;q=1.0;h=za}else{h=q<-1.0;i[Ea>>0]=1;if(h|j){q=h?-1.0:q;h=za;break}h=y<+o[za>>2]?za:Ca}while(0);B=q;w=+o[h>>2]}while(0);h=i[Ea>>0]|0;g:do if(h<<24>>24){if(ca){do if(!da){q=+VUa(a,fa,_,$,U,Ea,za,Aa);h=i[Ea>>0]|0;if(!(h<<24>>24))break g;else{n=q;L=_+-1|0;A=$+-1|0;break}}else{O=k[ga>>2]|0;Q=_+-1|0;A=$+-1|0;do if(V)N=0;else{if(((k[O+12>>2]|0)+-2|0)<(_|0)){N=0;break}if(((k[O+8>>2]|0)+-2|0)<($|0)){N=0;break}s=(k[O+16>>2]|0)+(aa(k[k[O+44>>2]>>2]|0,A)|0)+Q|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65574;while(1){U=l[s+(k[O+128+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==108)break;else e=k[128776+(e<<2)>>2]|0}e=(e|0)==108;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}N=(e|0)>0?e:0}while(0);I=(_|0)<2;do if(I|W)M=0;else{if(((k[O+12>>2]|0)+-2|0)<=(_|0)){M=0;break}if(((k[O+8>>2]|0)+-2|0)<($|0)){M=0;break}s=(k[O+16>>2]|0)+(aa(k[k[O+44>>2]>>2]|0,A)|0)+_|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65574;while(1){U=l[s+(k[O+128+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==108)break;else e=k[128776+(e<<2)>>2]|0}e=(e|0)==108;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}M=(e|0)>0?e:0}while(0);v=(M|0)<(N|0)?N:M;J=_+1|0;K=(J|0)<2;do if(K|W)L=0;else{if(((k[O+12>>2]|0)+-2|0)<=(J|0)){L=0;break}if(((k[O+8>>2]|0)+-2|0)<($|0)){L=0;break}s=(k[O+16>>2]|0)+(aa(k[k[O+44>>2]>>2]|0,A)|0)+J|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65574;while(1){U=l[s+(k[O+128+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==108)break;else e=k[128776+(e<<2)>>2]|0}e=(e|0)==108;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}L=(e|0)>0?e:0}while(0);v=(L|0)<(v|0)?v:L;z=($|0)<2;do if(K|z)H=0;else{if(((k[O+12>>2]|0)+-2|0)<=(J|0)){H=0;break}if(((k[O+8>>2]|0)+-2|0)<=($|0)){H=0;break}s=(k[O+16>>2]|0)+(aa(k[k[O+44>>2]>>2]|0,$)|0)+J|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65574;while(1){U=l[s+(k[O+128+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==108)break;else e=k[128776+(e<<2)>>2]|0}e=(e|0)==108;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}H=(e|0)>0?e:0}while(0);v=(H|0)<(v|0)?v:H;do if(I|z)G=0;else{if(((k[O+12>>2]|0)+-2|0)<=(_|0)){G=0;break}if(((k[O+8>>2]|0)+-2|0)<=($|0)){G=0;break}s=(k[O+16>>2]|0)+(aa(k[k[O+44>>2]>>2]|0,$)|0)+_|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65574;while(1){U=l[s+(k[O+128+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==108)break;else e=k[128776+(e<<2)>>2]|0}e=(e|0)==108;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}G=(e|0)>0?e:0}while(0);v=(G|0)<(v|0)?v:G;do if(X|z)F=0;else{if(((k[O+12>>2]|0)+-2|0)<(_|0)){F=0;break}if(((k[O+8>>2]|0)+-2|0)<=($|0)){F=0;break}s=(k[O+16>>2]|0)+(aa(k[k[O+44>>2]>>2]|0,$)|0)+Q|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65574;while(1){U=l[s+(k[O+128+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==108)break;else e=k[128776+(e<<2)>>2]|0}e=(e|0)==108;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}F=(e|0)>0?e:0}while(0);v=(F|0)<(v|0)?v:F;C=$+1|0;D=(C|0)<2;do if(X|D)E=0;else{if(((k[O+12>>2]|0)+-2|0)<(_|0)){E=0;break}if(((k[O+8>>2]|0)+-2|0)<=(C|0)){E=0;break}s=(k[O+16>>2]|0)+(aa(k[k[O+44>>2]>>2]|0,C)|0)+Q|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65574;while(1){U=l[s+(k[O+128+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==108)break;else e=k[128776+(e<<2)>>2]|0}e=(e|0)==108;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}E=(e|0)>0?e:0}while(0);v=(E|0)<(v|0)?v:E;do if(I|D)z=0;else{if(((k[O+12>>2]|0)+-2|0)<=(_|0)){z=0;break}if(((k[O+8>>2]|0)+-2|0)<=(C|0)){z=0;break}s=(k[O+16>>2]|0)+(aa(k[k[O+44>>2]>>2]|0,C)|0)+_|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65574;while(1){U=l[s+(k[O+128+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==108)break;else e=k[128776+(e<<2)>>2]|0}e=(e|0)==108;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}z=(e|0)>0?e:0}while(0);v=(z|0)<(v|0)?v:z;do if(K|D)e=0;else{if(((k[O+12>>2]|0)+-2|0)<=(J|0)){e=0;break}if(((k[O+8>>2]|0)+-2|0)<=(C|0)){e=0;break}s=(k[O+16>>2]|0)+(aa(k[k[O+44>>2]>>2]|0,C)|0)+J|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65574;while(1){U=l[s+(k[O+128+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==108)break;else e=k[128776+(e<<2)>>2]|0}e=(e|0)==108;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e|0)>0?e:0}while(0);+UUa(N,F,E,M,G,z,L,H,e,za,Aa);n=+(((e|0)<(v|0)?v:e)|0);L=Q}while(0);H=(_|0)<4;z=($|0)<4;do if(H|z)N=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<(_|0)){N=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<($|0)){N=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,A)|0)+L|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,A)|0)+L|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){U=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}N=e&255}while(0);do if(X|z)M=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<=(_|0)){M=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<($|0)){M=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,A)|0)+_|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,A)|0)+_|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){U=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}M=e&255}while(0);K=_+1|0;J=(K|0)<3;do if(J|z)I=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<=(K|0)){I=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<($|0)){I=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,A)|0)+K|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,A)|0)+K|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){U=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}I=e&255}while(0);do if(J|W)G=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<=(K|0)){G=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<=($|0)){G=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,$)|0)+K|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,$)|0)+K|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){U=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}G=e&255}while(0);do if(V)F=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<=(_|0)){F=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<=($|0)){F=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,$)|0)+_|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,$)|0)+_|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){V=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;V=((e&4096|0)==0?(V|0)>(j|0):(V|0)<(m|0))?e>>>16:e;e=V&4095;if((V&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}F=e&255}while(0);do if(H|W)E=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<(_|0)){E=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<=($|0)){E=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,$)|0)+L|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,$)|0)+L|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){W=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;W=((e&4096|0)==0?(W|0)>(j|0):(W|0)<(m|0))?e>>>16:e;e=W&4095;if((W&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}E=e&255}while(0);D=$+1|0;C=(D|0)<3;do if(H|C)A=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<(_|0)){A=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<=(D|0)){A=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,D)|0)+L|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,D)|0)+L|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){W=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;W=((e&4096|0)==0?(W|0)>(j|0):(W|0)<(m|0))?e>>>16:e;e=W&4095;if((W&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}A=e&255}while(0);do if(X|C)z=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<=(_|0)){z=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<=(D|0)){z=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,D)|0)+_|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,D)|0)+_|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){X=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;X=((e&4096|0)==0?(X|0)>(j|0):(X|0)<(m|0))?e>>>16:e;e=X&4095;if((X&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}z=e&255}while(0);do if(J|C)e=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<=(K|0)){e=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<=(D|0)){e=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,D)|0)+K|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,D)|0)+K|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){X=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;X=((e&4096|0)==0?(X|0)>(j|0):(X|0)<(m|0))?e>>>16:e;e=X&4095;if((X&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}e=e&255}while(0);q=+UUa(N,E,A,M,F,z,I,G,e,Ba,Ca);q=Y<q?q:Y;f=~~(n*1024.0+.5);j=~~(q*1024.0+.5);m=~~(w*1024.0+.5);do if(da){e=(f<<1)-(j<<2)+(m<<1)|0;if((e|0)>-1){if(!(!(q>=n)|!(q>=w))){n=q;q=1.0;E=407;break}if(!(!(n>=w)|!(n>=q))){q=.699999988079071;E=407;break}if(!(!(w>=n)|!(w>=q))){q=1.5;n=w;E=405;break}}n=+((aa(f,-5)|0)+(aa(m,-3)|0)+(j<<3)|0);q=-n/+(e<<1|0);do if(q<.699999988079071)q=.699999988079071;else{if(!(q>1.5))break;q=1.5}while(0);n=(n*q+(+(((f-j|0)*3|0)+m|0)+q*(+(e|0)*q)))*.0009765625;E=404}else{e=(f<<4)+(m<<3)+(aa(j,-24)|0)|0;if((e|0)>-1){if(!(!(q>=n)|!(q>=w))){n=q;q=1.0;E=408;break}if(!(!(n>=w)|!(n>=q))){q=.75;E=408;break}if(!(!(w>=n)|!(w>=q))){q=1.5;n=w;E=405;break}}n=+((aa(f,-40)|0)+(aa(m,-14)|0)+(j*54|0)|0);q=-n/+(e<<1|0);do if(q<.75)q=.75;else{if(!(q>1.5))break;q=1.5}while(0);n=(n*q+(+((f*24|0)+(m*6|0)+(aa(j,-27)|0)|0)+q*(+(e|0)*q)))/3072.0;E=404}while(0);do if((E|0)==404){if(q>1.0){E=405;break}if(da)E=407;else E=408}while(0);if((E|0)==405){P=(1.5-q)*2.0;Y=1.0-P;Ia=+o[Z+(fa*328|0)+112>>2];Ja=+o[Z+(fa*328|0)+116>>2];y=Ia;w=Ja+Ia*(+($|0)+(P*+o[Ca>>2]+Y*B));x=Ja+Ia*(+(_|0)+(P*+o[Ba>>2]+Y*x))}else if((E|0)==407){Ja=(q+-.5)*2.0;x=1.0-Ja;y=+o[Z+112>>2];w=+($|0)+(Ja*+o[Ca>>2]+x*+o[Aa>>2]);x=+(_|0)+(Ja*+o[Ba>>2]+x*+o[za>>2])}else if((E|0)==408){Ja=(q+-.75)*4.0;x=1.0-Ja;Ia=+o[Z+(fa*328|0)+112>>2];Y=+o[Z+(fa*328|0)+116>>2];y=Ia;w=Y+Ia*(+($|0)+(Ja*+o[Ca>>2]+x*+o[Aa>>2]));x=Y+Ia*(+(_|0)+(Ja*+o[Ba>>2]+x*+o[za>>2]))}B=n;n=y}else{q=+VUa(a,fa,_,$,U,Ea,za,Aa);h=i[Ea>>0]|0;if(!(h<<24>>24))break;J=_+-1|0;A=$+-1|0;H=(_|0)<4;z=($|0)<4;do if(H|z)N=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<(_|0)){N=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<($|0)){N=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,A)|0)+J|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,A)|0)+J|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){U=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}N=e&255}while(0);do if(X|z)M=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<=(_|0)){M=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<($|0)){M=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,A)|0)+_|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,A)|0)+_|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){U=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}M=e&255}while(0);L=_+1|0;K=(L|0)<3;do if(K|z)I=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<=(L|0)){I=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<($|0)){I=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,A)|0)+L|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,A)|0)+L|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){U=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}I=e&255}while(0);do if(K|W)G=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<=(L|0)){G=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<=($|0)){G=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,$)|0)+L|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,$)|0)+L|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){U=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;U=((e&4096|0)==0?(U|0)>(j|0):(U|0)<(m|0))?e>>>16:e;e=U&4095;if((U&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}G=e&255}while(0);do if(V)F=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<=(_|0)){F=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<=($|0)){F=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,$)|0)+_|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,$)|0)+_|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){V=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;V=((e&4096|0)==0?(V|0)>(j|0):(V|0)<(m|0))?e>>>16:e;e=V&4095;if((V&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}F=e&255}while(0);do if(H|W)E=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<(_|0)){E=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<=($|0)){E=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,$)|0)+J|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,$)|0)+J|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){W=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;W=((e&4096|0)==0?(W|0)>(j|0):(W|0)<(m|0))?e>>>16:e;e=W&4095;if((W&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}E=e&255}while(0);D=$+1|0;C=(D|0)<3;do if(H|C)A=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<(_|0)){A=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<=(D|0)){A=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,D)|0)+J|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,D)|0)+J|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){W=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;W=((e&4096|0)==0?(W|0)>(j|0):(W|0)<(m|0))?e>>>16:e;e=W&4095;if((W&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}A=e&255}while(0);do if(X|C)z=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<=(_|0)){z=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<=(D|0)){z=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,D)|0)+_|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,D)|0)+_|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){X=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;X=((e&4096|0)==0?(X|0)>(j|0):(X|0)<(m|0))?e>>>16:e;e=X&4095;if((X&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}z=e&255}while(0);do if(K|C)e=0;else{if(((k[Z+(fa*328|0)+12>>2]|0)+-3|0)<=(L|0)){e=0;break}if(((k[Z+(fa*328|0)+8>>2]|0)+-3|0)<=(D|0)){e=0;break}v=(k[Z+(fa*328|0)+72>>2]|0)+(aa(k[k[Z+(fa*328|0)+100>>2]>>2]|0,D)|0)+L|0;e=i[v>>0]|0;if((e&255)<=2){s=(k[Z+(fa*328|0)+16>>2]|0)+(aa(k[k[Z+(fa*328|0)+44>>2]>>2]|0,D)|0)+L|0;t=l[s>>0]|0;b=0;e=255;f=255;while(1){p=(e|0)/2|0;j=p+t|0;m=t-p|0;e=65848;while(1){X=l[s+(k[Z+(fa*328|0)+228+(e>>>28<<2)>>2]|0)>>0]|0;X=((e&4096|0)==0?(X|0)>(j|0):(X|0)<(m|0))?e>>>16:e;e=X&4095;if((X&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?p:f;e=e?b:p;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{b=e;e=e+f|0}}e=(e&255|0)==0?0:e&255;i[v>>0]=e}e=e&255}while(0);n=+UUa(N,E,A,M,F,z,I,G,e,Ba,Ca);n=Y<n?n:Y;e=~~(q*1024.0+.5);f=~~(n*1024.0+.5);j=~~(w*1024.0+.5);m=(aa(f,-18)|0)+((e+j|0)*9|0)|0;h:do if((m|0)>-1){do if(!(n>=q)|!(n>=w)){if(!(!(q>=w)|!(q>=n))){w=.6666666865348816;n=q;break}if(!(w>=q)|!(w>=n)){E=506;break h}else{n=w;q=1.3333333730697632;w=4.0;E=511;break h}}else w=1.0;while(0);q=w;w=w*3.0;E=512}else E=506;while(0);if((E|0)==506){n=+((aa(e,-21)|0)+(aa(j,-15)|0)+(f*36|0)|0);q=-n/+(m<<1|0);do if(q<.6666666865348816)q=.6666666865348816;else{if(!(q>1.3333333730697632))break;q=1.3333333730697632}while(0);n=(n*q+(+((e*12|0)+(j*6|0)-(f<<4)|0)+q*(+(m|0)*q)))*.00048828125;w=q*3.0;if(q>1.0)E=511;else E=512}if((E|0)==511){Ja=4.0-w;w=1.0-Ja;Ia=+o[Z+(fa*328|0)+112>>2];Y=+o[Z+(fa*328|0)+116>>2];x=Y+Ia*(+(_|0)+(Ja*+o[Ba>>2]+w*x));y=Ia;w=Y+Ia*(+($|0)+(Ja*+o[Ca>>2]+w*B))}else if((E|0)==512){Ja=w+-2.0;w=1.0-Ja;Ia=+o[Z+(fa*328|0)+112>>2];Y=+o[Z+(fa*328|0)+116>>2];x=Y+Ia*(+(_|0)+(Ja*+o[Ba>>2]+w*+o[za>>2]));y=Ia;w=Y+Ia*(+($|0)+(Ja*+o[Ca>>2]+w*+o[Aa>>2]))}B=n;n=y}f=(o[u>>2]=w,k[u>>2]|0);e=(o[u>>2]=x,k[u>>2]|0);n=n*q;if(!(B>ua&h<<24>>24!=0))break;k[za>>2]=e;k[na>>2]=f;o[oa>>2]=n*12.0;o[pa>>2]=-1.0;o[qa>>2]=B;k[ra>>2]=fa;k[sa>>2]=-1;h=k[ya>>2]|0;if((h|0)==(k[xa>>2]|0))H6(c,za);else{k[h>>2]=e;k[h+4>>2]=f;$=h+8|0;k[$>>2]=k[oa>>2];k[$+4>>2]=k[oa+4>>2];k[$+8>>2]=k[oa+8>>2];k[$+12>>2]=k[oa+12>>2];k[$+16>>2]=k[oa+16>>2];k[ya>>2]=(k[ya>>2]|0)+28}}while(0)}g=g+1|0;if(g>>>0>=ea>>>0)break d;h=k[Da>>2]|0}}while(0);fa=fa+1|0;m=k[a>>2]|0;if((fa|0)>=(m|0)){E=37;break a}}if((E|0)==44)ad(426635,426557,315,426658);else if((E|0)==54)ad(426635,426557,315,426658)}else E=37}else E=37;while(0);if((E|0)==37){e=k[Da>>2]|0;d=e;E=524}if((E|0)==524)if(!e){r=Ha;return}else Ga=e;e=k[wa>>2]|0;if((e|0)==(Ga|0))d=Ga;else{do{f=e;e=e+-12|0;h=k[e>>2]|0;j=h;if(h|0){f=f+-8|0;g=k[f>>2]|0;if((g|0)!=(h|0))k[f>>2]=g+(~(((g+-28-j|0)>>>0)/28|0)*28|0);ggb(h)}}while((e|0)!=(Ga|0));k[wa>>2]=Ga}ggb(d);r=Ha;return}function QUa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+120|0;c=k[b>>2]|0;if(c|0?(e=c+4|0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+124>>2]=0;d=a+92|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+88>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+72|0;c=a+60|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+96>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+100>>2]|0;if(!((b|0)==(a+104|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+36|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+16|0;c=a+4|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+44>>2]|0;if((b|0)==(a+48|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function RUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+8|0;f=k[l>>2]|0;m=a+4|0;i=k[m>>2]|0;e=i;if(((f-i|0)/12|0)>>>0>=b>>>0){zpb(i|0,0,b*12|0)|0;k[m>>2]=e+(b*12|0);return}c=k[a>>2]|0;h=(i-c|0)/12|0;d=h+b|0;if(d>>>0>357913941)ad(426534,426557,304,426811);j=c;f=(f-c|0)/12|0;g=f<<1;g=f>>>0<178956970?(g>>>0<d>>>0?d:g):357913941;if(!g)f=0;else{if(g>>>0>357913941){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=g*12|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}f=c}c=f+(h*12|0)|0;d=c;g=f+(g*12|0)|0;zpb(c|0,0,b*12|0)|0;f=c+(b*12|0)|0;if((e|0)!=(j|0)){do{e=e+-12|0;WUa(c+-12|0,e);c=d+-12|0;d=c}while((e|0)!=(j|0));i=k[a>>2]|0;e=k[m>>2]|0}k[a>>2]=d;k[m>>2]=f;k[l>>2]=g;h=i;if((e|0)!=(h|0))do{c=e;e=e+-12|0;f=k[e>>2]|0;g=f;if(f|0){c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(f|0))k[c>>2]=d+(~(((d+-28-g|0)>>>0)/28|0)*28|0);ggb(f)}}while((e|0)!=(h|0));if(!i)return;ggb(i);return}function SUa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=r;r=r+16|0;w=E+4|0;x=E;D=k[a+(b*328|0)+68>>2]|0;C=a+(b*328|0)+72|0;a=(k[C>>2]|0)+(aa(D,d)|0)+c|0;o=i[a>>0]|0;a=a+-1|0;g=i[a>>0]|0;A=o&255;B=g&255;if((o&255)<(g&255)){D=0;r=E;return D|0}a=a+2|0;h=i[a>>0]|0;z=h&255;if((o&255)<(h&255)){D=0;r=E;return D|0}a=a+~D|0;e=i[a>>0]|0;v=e&255;if((o&255)<(e&255)){D=0;r=E;return D|0}b=D<<1;a=a+b|0;m=i[a>>0]|0;u=m&255;if((o&255)<(m&255)){D=0;r=E;return D|0}a=a+-1|0;j=i[a>>0]|0;t=j&255;if((o&255)<(j&255)){D=0;r=E;return D|0}a=a+2|0;n=i[a>>0]|0;s=n&255;if((o&255)<(n&255)){D=0;r=E;return D|0}a=a+(0-b)|0;f=i[a>>0]|0;q=f&255;if((o&255)<(f&255)){D=0;r=E;return D|0}a=i[a+-2>>0]|0;p=a&255;if((o&255)<(a&255)){D=0;r=E;return D|0}k[w>>2]=0;y=w+4|0;k[y>>2]=0;k[w+8>>2]=0;if(o<<24>>24==a<<24>>24){k[x>>2]=-1;Q4(w,x);a=k[y>>2]|0;b=k[w+8>>2]|0;k[x>>2]=-1;if((a|0)==(b|0))Q4(w,x);else{k[a>>2]=-1;k[y>>2]=a+4}}if(o<<24>>24==e<<24>>24){k[x>>2]=0;b=k[y>>2]|0;e=w+8|0;a=k[e>>2]|0;if((b|0)==(a|0)){Q4(w,x);b=k[y>>2]|0;a=k[e>>2]|0}else{k[b>>2]=0;b=b+4|0;k[y>>2]=b}k[x>>2]=-1;if((b|0)==(a|0))Q4(w,x);else{k[b>>2]=-1;k[y>>2]=b+4}}if(o<<24>>24==f<<24>>24){k[x>>2]=1;b=k[y>>2]|0;e=w+8|0;a=k[e>>2]|0;if((b|0)==(a|0)){Q4(w,x);b=k[y>>2]|0;a=k[e>>2]|0}else{k[b>>2]=1;b=b+4|0;k[y>>2]=b}k[x>>2]=-1;if((b|0)==(a|0))Q4(w,x);else{k[b>>2]=-1;k[y>>2]=b+4}}if(o<<24>>24==g<<24>>24){k[x>>2]=-1;b=k[y>>2]|0;e=w+8|0;a=k[e>>2]|0;if((b|0)==(a|0)){Q4(w,x);b=k[y>>2]|0;a=k[e>>2]|0}else{k[b>>2]=-1;b=b+4|0;k[y>>2]=b}k[x>>2]=0;if((b|0)==(a|0))Q4(w,x);else{k[b>>2]=0;k[y>>2]=b+4}}if(o<<24>>24==h<<24>>24){k[x>>2]=1;b=k[y>>2]|0;e=w+8|0;a=k[e>>2]|0;if((b|0)==(a|0)){Q4(w,x);b=k[y>>2]|0;a=k[e>>2]|0}else{k[b>>2]=1;b=b+4|0;k[y>>2]=b}k[x>>2]=0;if((b|0)==(a|0))Q4(w,x);else{k[b>>2]=0;k[y>>2]=b+4}}if(o<<24>>24==j<<24>>24){k[x>>2]=-1;b=k[y>>2]|0;e=w+8|0;a=k[e>>2]|0;if((b|0)==(a|0)){Q4(w,x);b=k[y>>2]|0;a=k[e>>2]|0}else{k[b>>2]=-1;b=b+4|0;k[y>>2]=b}k[x>>2]=1;if((b|0)==(a|0))Q4(w,x);else{k[b>>2]=1;k[y>>2]=b+4}}if(o<<24>>24==m<<24>>24){k[x>>2]=0;b=k[y>>2]|0;e=w+8|0;a=k[e>>2]|0;if((b|0)==(a|0)){Q4(w,x);b=k[y>>2]|0;a=k[e>>2]|0}else{k[b>>2]=0;b=b+4|0;k[y>>2]=b}k[x>>2]=1;if((b|0)==(a|0))Q4(w,x);else{k[b>>2]=1;k[y>>2]=b+4}}if(o<<24>>24==n<<24>>24){k[x>>2]=1;b=k[y>>2]|0;e=w+8|0;a=k[e>>2]|0;if((b|0)==(a|0)){Q4(w,x);b=k[y>>2]|0;a=k[e>>2]|0}else{k[b>>2]=1;b=b+4|0;k[y>>2]=b}k[x>>2]=1;if((b|0)==(a|0))Q4(w,x);else{k[b>>2]=1;k[y>>2]=b+4}}m=k[y>>2]|0;h=k[w>>2]|0;g=m-h>>2;j=h;a:do if(!g)a=1;else{f=(z+B+v+u<<1)+(A<<2)+t+s+q+p|0;e=k[C>>2]|0;b=d+-1|0;a=0;while(1){w=e+(aa(b+(k[j+((a|1)<<2)>>2]|0)|0,D)|0)+c|0;w=w+(k[j+(a<<2)>>2]|0)+-1|0;B=w+1|0;v=B+1|0;A=v+D|0;x=A+-1|0;C=x+-1|0;z=C+D|0;d=z+1|0;a=a+2|0;if(((l[v>>0]|0)+(l[w>>0]|0)+((l[x>>0]|0)<<2)+(l[z>>0]|0)+(l[d+1>>0]|0)+((l[A>>0]|0)+(l[B>>0]|0)+(l[C>>0]|0)+(l[d>>0]|0)<<1)|0)>(f|0)){a=0;break a}if(a>>>0>=g>>>0){a=1;break}}}while(0);b=h;if(h|0){if((m|0)!=(j|0))k[y>>2]=m+(~((m+-4-h|0)>>>2)<<2);ggb(b)}D=a;r=E;return D|0}function TUa(a,b,c,d){a=a|0;b=+b;c=+c;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;y=~~b;A=b-+(y|0);u=1.0-A;t=~~c;z=c-+(t|0);q=1.0-z;c=u*q;v=(y|0)<3;r=(t|0)<3;if((!(v|r)?((k[a+12>>2]|0)+-3|0)>(y|0):0)?((k[a+8>>2]|0)+-3|0)>(t|0):0){p=(k[a+72>>2]|0)+(aa(k[k[a+100>>2]>>2]|0,t)|0)+y|0;e=i[p>>0]|0;if((e&255)<=2){n=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,t)|0)+y|0;o=l[n>>0]|0;m=d+-1|0;e=d+254|0;f=255;while(1){j=(e|0)/2|0;g=j+o|0;h=o-j|0;e=65848;while(1){x=l[n+(k[a+228+(e>>>28<<2)>>2]|0)>>0]|0;x=((e&4096|0)==0?(x|0)>(g|0):(x|0)<(h|0))?e>>>16:e;e=x&4095;if((x&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?j:f;e=e?m:j;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{m=e;e=e+f|0}}e=(e&255|0)<(d|0)?0:e&255;i[p>>0]=e}b=+(e&255)}else b=0.0;s=c*b;c=A*q;x=y+1|0;w=(x|0)<3;if((!(w|r)?((k[a+12>>2]|0)+-3|0)>(x|0):0)?((k[a+8>>2]|0)+-3|0)>(t|0):0){p=(k[a+72>>2]|0)+(aa(k[k[a+100>>2]>>2]|0,t)|0)+x|0;e=i[p>>0]|0;if((e&255)<=2){n=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,t)|0)+x|0;o=l[n>>0]|0;m=d+-1|0;e=d+254|0;f=255;while(1){j=(e|0)/2|0;g=j+o|0;h=o-j|0;e=65848;while(1){r=l[n+(k[a+228+(e>>>28<<2)>>2]|0)>>0]|0;r=((e&4096|0)==0?(r|0)>(g|0):(r|0)<(h|0))?e>>>16:e;e=r&4095;if((r&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?j:f;e=e?m:j;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{m=e;e=e+f|0}}e=(e&255|0)<(d|0)?0:e&255;i[p>>0]=e}b=+(e&255)}else b=0.0;q=s+c*b;c=u*z;t=t+1|0;r=(t|0)<3;if((!(v|r)?((k[a+12>>2]|0)+-3|0)>(y|0):0)?((k[a+8>>2]|0)+-3|0)>(t|0):0){p=(k[a+72>>2]|0)+(aa(k[k[a+100>>2]>>2]|0,t)|0)+y|0;e=i[p>>0]|0;if((e&255)<=2){n=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,t)|0)+y|0;o=l[n>>0]|0;m=d+-1|0;e=d+254|0;f=255;while(1){j=(e|0)/2|0;g=j+o|0;h=o-j|0;e=65848;while(1){y=l[n+(k[a+228+(e>>>28<<2)>>2]|0)>>0]|0;y=((e&4096|0)==0?(y|0)>(g|0):(y|0)<(h|0))?e>>>16:e;e=y&4095;if((y&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?j:f;e=e?m:j;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{m=e;e=e+f|0}}e=(e&255|0)<(d|0)?0:e&255;i[p>>0]=e}b=+(e&255)}else b=0.0;c=q+c*b;b=A*z;if(w|r){A=0.0;A=b*A;A=c+A;d=~~A&255;d=d&255;return d|0}if(((k[a+12>>2]|0)+-3|0)<=(x|0)){A=0.0;A=b*A;A=c+A;d=~~A&255;d=d&255;return d|0}if(((k[a+8>>2]|0)+-3|0)<=(t|0)){A=0.0;A=b*A;A=c+A;d=~~A&255;d=d&255;return d|0}p=(k[a+72>>2]|0)+(aa(k[k[a+100>>2]>>2]|0,t)|0)+x|0;e=i[p>>0]|0;if((e&255)<=2){n=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,t)|0)+x|0;o=l[n>>0]|0;m=d+-1|0;e=d+254|0;f=255;while(1){j=(e|0)/2|0;g=j+o|0;h=o-j|0;e=65848;while(1){y=l[n+(k[a+228+(e>>>28<<2)>>2]|0)>>0]|0;y=((e&4096|0)==0?(y|0)>(g|0):(y|0)<(h|0))?e>>>16:e;e=y&4095;if((y&4094|0)==684)break;else e=k[138248+(e<<2)>>2]|0}e=(e|0)==502|(e|0)==684;f=e?j:f;e=e?m:j;if((e|0)==(f|0)|(e|0)==(f+-1|0))break;else{m=e;e=e+f|0}}e=(e&255|0)<(d|0)?0:e&255;i[p>>0]=e}A=+(e&255);A=b*A;A=c+A;d=~~A&255;d=d&255;return d|0}function UUa(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0.0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;x=c+a|0;q=x-(e<<1)+g+i|0;w=f+d|0;r=b-(w<<1)+h+q|0;v=r*3|0;q=w-(h+b<<1)+q|0;w=q*3|0;s=c-g|0;u=s+a-i|0;t=aa(b-h+u|0,-3)|0;u=aa(d-f-(s<<1)+u|0,-3)|0;s=a-c-g+i<<2;e=0-((aa(e,-5)|0)+(x-(d+b+f+h<<1))+g+i)<<1;a=(aa(r*12|0,w)|0)-(aa(s,s)|0)|0;if(!a){o[j>>2]=0.0;o[k>>2]=0.0;p=+(e|0)/18.0;return +p}if(!((r|0)<0&(a|0)>0)){a=t+s+u|0;o[j>>2]=1.0;o[k>>2]=1.0;c=u-t-s|0;if((c|0)>(a|0)){o[j>>2]=-1.0;o[k>>2]=1.0;a=c}c=t-u-s|0;if((c|0)>(a|0)){o[j>>2]=1.0;o[k>>2]=-1.0;a=c}c=s-t-u|0;if((c|0)>(a|0)){o[j>>2]=-1.0;o[k>>2]=-1.0;a=c}p=+(w+v+e+a|0)/18.0;return +p}b=q*6|0;m=+(0-a|0);l=+((aa(b,t)|0)-(aa(u,s)|0)|0)/m;o[j>>2]=l;d=r*6|0;m=+((aa(d,u)|0)-(aa(t,s)|0)|0)/m;o[k>>2]=m;l=+o[j>>2];do if(l>1.0){c=m>1.0;a=m<-1.0;l=-+(u+s|0)/+(b|0);if(!(l>1.0))if(l<-1.0)if(c){l=-1.0;m=1.0;b=21}else{l=-1.0;m=1.0;b=24}else{m=1.0;b=20}else{l=1.0;m=1.0;b=20}}else{c=m>1.0;a=m<-1.0;if(l<-1.0){l=-+(u-s|0)/+(b|0);if(l>1.0){l=1.0;m=-1.0;b=20;break}if(!(l<-1.0)){m=-1.0;b=20;break}if(c){l=-1.0;m=-1.0;b=21;break}else{l=-1.0;m=-1.0;b=24;break}}else{if(a|c){l=0.0;m=0.0;b=20;break}p=(+(e|0)+(m*(+(s|0)*l)+(+(u|0)*m+(+(t|0)*l+(m*(+(w|0)*m)+l*(+(v|0)*l))))))/18.0;return +p}}while(0);if((b|0)==20)if(c)b=21;else b=24;if((b|0)==21){n=-+(t+s|0)/+(d|0);if(!(n>1.0))if(n<-1.0){p=1.0;n=-1.0}else p=1.0;else{p=1.0;n=1.0}}else if((b|0)==24)if(a){n=-+(t-s|0)/+(d|0);if(!(n>1.0))if(n<-1.0){p=-1.0;n=-1.0}else p=-1.0;else{p=-1.0;n=1.0}}else{p=0.0;n=0.0}z=+(v|0);y=+(w|0);A=+(t|0);B=+(u|0);C=+(s|0);D=+(e|0);l=(D+(C*m*l+(B*l+(A*m+(m*(z*m)+l*(y*l))))))/18.0;p=(D+(C*n*p+(B*p+(A*n+(n*(z*n)+p*(y*p))))))/18.0;x=l>p;n=x?m:n;o[j>>2]=n;o[k>>2]=n;p=x?l:p;return +p}function VUa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,m=0.0,n=0.0,p=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;oa=r;r=r+32|0;j=oa+16|0;la=oa+8|0;ka=oa+4|0;na=oa;i[f>>0]=0;ma=(b&1|0)==0;if(ma){ia=c<<3;ja=d<<3;ea=+((ia|1)+-4|0)/6.0;ga=+(ia|5|0)/6.0;n=+((ja|1)+-4|0)/6.0;ha=+(ja|5|0)/6.0}else{ia=c*6|1;ja=d*6|1;ea=+(ia+-3|0)*.25;ga=+(ia+3|0)*.25;n=+(ja+-3|0)*.25;ha=+(ja+3|0)*.25}if((b|0)<=0){q=j+4|0;s=ZT(16)|0;k[s>>2]=1;t=s+4|0;k[j>>2]=t;k[q>>2]=9;i[s+13>>0]=0;u=385640;v=t+9|0;do{i[t>>0]=i[u>>0]|0;t=t+1|0;u=u+1|0}while((t|0)<(v|0));Y8(-215,j,385650,385570,1615);k[q>>2]=0;k[j>>2]=0;ja=k[s>>2]|0;k[s>>2]=ja+-1;if((ja|0)==1)ggb(k[s+-4>>2]|0)}ja=b+-1|0;ia=k[a+4>>2]|0;fa=ia+(ja*328|0)|0;b=~~ea;ca=b+1|0;s=~~n;t=s+1|0;p=+(TUa(fa,ea,n,1)|0);o[j>>2]=p;$=+(e|0);if(p>$){ha=0.0;r=oa;return +ha}N=~~ga;ba=(b|0)<(N|0);a:do if(ba){b=ca;q=ca;while(1){m=+(TUa(fa,+(q|0),n,1)|0);if(m>$){m=0.0;break}if(m>+o[j>>2]){o[j>>2]=m;b=q}if((q|0)<(N|0))q=q+1|0;else break a}r=oa;return +m}else b=ca;while(0);m=+(TUa(fa,ga,n,1)|0);if(m>$){ha=0.0;r=oa;return +ha}if(m>+o[j>>2]){o[j>>2]=m;b=N}da=~~ha;b:do if((s|0)<(da|0)){U=~~(ea+1.0);V=ia+(ja*328|0)+12|0;W=ia+(ja*328|0)+8|0;X=ia+(ja*328|0)+72|0;Y=ia+(ja*328|0)+100|0;Z=ia+(ja*328|0)+16|0;_=ia+(ja*328|0)+44|0;q=t;T=t;c:while(1){p=+(T|0);m=+(TUa(fa,ea,p,1)|0);if(m>$){m=0.0;s=316;break}if(m>+o[j>>2]){o[j>>2]=m;q=T;b=U}if(ba){O=(T|0)<3;P=T+1|0;Q=(P|0)<3;R=T+-1|0;S=(T|0)<4;M=ca;while(1){A=(M|0)<3;if((!(O|A)?((k[V>>2]|0)+-3|0)>(M|0):0)?((k[W>>2]|0)+-3|0)>(T|0):0){y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,T)|0)+M|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,T)|0)+M|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){L=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;L=((s&4096|0)==0?(L|0)>(u|0):(L|0)<(v|0))?s>>>16:s;s=L&4095;if((L&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}s=s&255}else s=0;n=+(s|0);if(n>$){m=0.0;s=316;break c}m=+o[j>>2];if(n==m){G=M+-1|0;F=(M|0)<4;do if(O|F)z=0;else{if(((k[V>>2]|0)+-3|0)<(M|0)){z=0;break}if(((k[W>>2]|0)+-3|0)<=(T|0)){z=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,T)|0)+G|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,T)|0)+G|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){L=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;L=((s&4096|0)==0?(L|0)>(u|0):(L|0)<(v|0))?s>>>16:s;s=L&4095;if((L&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}z=s&255}while(0);E=M+1|0;D=(E|0)<3;do if(O|D)s=0;else{if(((k[V>>2]|0)+-3|0)<=(E|0)){s=0;break}if(((k[W>>2]|0)+-3|0)<=(T|0)){s=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,T)|0)+E|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,T)|0)+E|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){L=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;L=((s&4096|0)==0?(L|0)>(u|0):(L|0)<(v|0))?s>>>16:s;s=L&4095;if((L&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}s=s&255}while(0);z=s+z|0;do if(Q|A)s=0;else{if(((k[V>>2]|0)+-3|0)<=(M|0)){s=0;break}if(((k[W>>2]|0)+-3|0)<=(P|0)){s=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,P)|0)+M|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,P)|0)+M|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){L=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;L=((s&4096|0)==0?(L|0)>(u|0):(L|0)<(v|0))?s>>>16:s;s=L&4095;if((L&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}s=s&255}while(0);z=z+s|0;do if(S|A)s=0;else{if(((k[V>>2]|0)+-3|0)<=(M|0)){s=0;break}if(((k[W>>2]|0)+-3|0)<(T|0)){s=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,R)|0)+M|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,R)|0)+M|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){L=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;L=((s&4096|0)==0?(L|0)>(u|0):(L|0)<(v|0))?s>>>16:s;s=L&4095;if((L&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}s=s&255}while(0);C=z+s<<1;do if(Q|D)B=0;else{if(((k[V>>2]|0)+-3|0)<=(E|0)){B=0;break}if(((k[W>>2]|0)+-3|0)<=(P|0)){B=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,P)|0)+E|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,P)|0)+E|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){L=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;L=((s&4096|0)==0?(L|0)>(u|0):(L|0)<(v|0))?s>>>16:s;s=L&4095;if((L&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}B=s&255}while(0);do if(Q|F)A=0;else{if(((k[V>>2]|0)+-3|0)<(M|0)){A=0;break}if(((k[W>>2]|0)+-3|0)<=(P|0)){A=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,P)|0)+G|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,P)|0)+G|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){L=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;L=((s&4096|0)==0?(L|0)>(u|0):(L|0)<(v|0))?s>>>16:s;s=L&4095;if((L&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}A=s&255}while(0);do if(S|D)z=0;else{if(((k[V>>2]|0)+-3|0)<=(E|0)){z=0;break}if(((k[W>>2]|0)+-3|0)<(T|0)){z=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,R)|0)+E|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,R)|0)+E|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){L=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;L=((s&4096|0)==0?(L|0)>(u|0):(L|0)<(v|0))?s>>>16:s;s=L&4095;if((L&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}z=s&255}while(0);do if(S|F)s=0;else{if(((k[V>>2]|0)+-3|0)<(M|0)){s=0;break}if(((k[W>>2]|0)+-3|0)<(T|0)){s=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,R)|0)+G|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,R)|0)+G|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){L=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;L=((s&4096|0)==0?(L|0)>(u|0):(L|0)<(v|0))?s>>>16:s;s=L&4095;if((L&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}s=s&255}while(0);L=B+C+A+z+s|0;K=b+-1|0;J=(b|0)<4;z=(q|0)<3;do if(z|J)A=0;else{if(((k[V>>2]|0)+-3|0)<(b|0)){A=0;break}if(((k[W>>2]|0)+-3|0)<=(q|0)){A=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,q)|0)+K|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,q)|0)+K|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){I=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;I=((s&4096|0)==0?(I|0)>(u|0):(I|0)<(v|0))?s>>>16:s;s=I&4095;if((I&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}A=s&255}while(0);I=b+1|0;H=(I|0)<3;do if(z|H)s=0;else{if(((k[V>>2]|0)+-3|0)<=(I|0)){s=0;break}if(((k[W>>2]|0)+-3|0)<=(q|0)){s=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,q)|0)+I|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,q)|0)+I|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){G=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;G=((s&4096|0)==0?(G|0)>(u|0):(G|0)<(v|0))?s>>>16:s;s=G&4095;if((G&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}s=s&255}while(0);z=s+A|0;D=q+1|0;A=(b|0)<3;C=(D|0)<3;do if(A|C)s=0;else{if(((k[V>>2]|0)+-3|0)<=(b|0)){s=0;break}if(((k[W>>2]|0)+-3|0)<=(D|0)){s=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,D)|0)+b|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,D)|0)+b|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){G=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;G=((s&4096|0)==0?(G|0)>(u|0):(G|0)<(v|0))?s>>>16:s;s=G&4095;if((G&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}s=s&255}while(0);z=z+s|0;G=q+-1|0;F=(q|0)<4;do if(F|A)s=0;else{if(((k[V>>2]|0)+-3|0)<=(b|0)){s=0;break}if(((k[W>>2]|0)+-3|0)<(q|0)){s=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,G)|0)+b|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,G)|0)+b|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){E=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;E=((s&4096|0)==0?(E|0)>(u|0):(E|0)<(v|0))?s>>>16:s;s=E&4095;if((E&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}s=s&255}while(0);E=z+s<<1;do if(C|H)B=0;else{if(((k[V>>2]|0)+-3|0)<=(I|0)){B=0;break}if(((k[W>>2]|0)+-3|0)<=(D|0)){B=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,D)|0)+I|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,D)|0)+I|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){B=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;B=((s&4096|0)==0?(B|0)>(u|0):(B|0)<(v|0))?s>>>16:s;s=B&4095;if((B&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}B=s&255}while(0);do if(J|C)A=0;else{if(((k[V>>2]|0)+-3|0)<(b|0)){A=0;break}if(((k[W>>2]|0)+-3|0)<=(D|0)){A=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,D)|0)+K|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,D)|0)+K|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){D=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;D=((s&4096|0)==0?(D|0)>(u|0):(D|0)<(v|0))?s>>>16:s;s=D&4095;if((D&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}A=s&255}while(0);do if(F|H)z=0;else{if(((k[V>>2]|0)+-3|0)<=(I|0)){z=0;break}if(((k[W>>2]|0)+-3|0)<(q|0)){z=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,G)|0)+I|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,G)|0)+I|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){I=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;I=((s&4096|0)==0?(I|0)>(u|0):(I|0)<(v|0))?s>>>16:s;s=I&4095;if((I&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}z=s&255}while(0);do if(F|J)s=0;else{if(((k[V>>2]|0)+-3|0)<(b|0)){s=0;break}if(((k[W>>2]|0)+-3|0)<(q|0)){s=0;break}y=(k[X>>2]|0)+(aa(k[k[Y>>2]>>2]|0,G)|0)+K|0;s=i[y>>0]|0;if((s&255)<=2){w=(k[Z>>2]|0)+(aa(k[k[_>>2]>>2]|0,G)|0)+K|0;x=l[w>>0]|0;e=0;s=255;t=255;while(1){a=(s|0)/2|0;u=a+x|0;v=x-a|0;s=65848;while(1){K=l[w+(k[ia+(ja*328|0)+228+(s>>>28<<2)>>2]|0)>>0]|0;K=((s&4096|0)==0?(K|0)>(u|0):(K|0)<(v|0))?s>>>16:s;s=K&4095;if((K&4094|0)==684)break;else s=k[138248+(s<<2)>>2]|0}s=(s|0)==502|(s|0)==684;t=s?a:t;s=s?e:a;if((s|0)==(t|0)|(s|0)==(t+-1|0))break;else{e=s;s=s+t|0}}s=(s&255|0)==0?0:s&255;i[y>>0]=s}s=s&255}while(0);L=(L|0)>(B+E+A+z+s|0);m=+o[j>>2];q=L?T:q;b=L?M:b}if(n>m){o[j>>2]=n;q=T;b=M}if((M|0)<(N|0))M=M+1|0;else break}}m=+(TUa(fa,ga,p,1)|0);if(m>$){m=0.0;s=316;break}if(m>+o[j>>2]){o[j>>2]=m;q=T;b=N}if((T|0)<(da|0))T=T+1|0;else break b}if((s|0)==316){r=oa;return +m}}else q=t;while(0);m=+(TUa(fa,ea,ha,1)|0);if(m>+o[j>>2]){o[j>>2]=m;b=~~(ea+1.0);q=da}if(ba){s=ca;while(1){m=+(TUa(fa,+(s|0),ha,1)|0);if(m>+o[j>>2]){o[j>>2]=m;q=da;b=s}if((s|0)<(N|0))s=s+1|0;else break}}m=+(TUa(fa,ga,ha,1)|0);if(m>+o[j>>2]){o[j>>2]=m;q=da}else N=b;I=N+-1|0;z=q+-1|0;F=(N|0)<4;y=(q|0)<4;if((!(y|F)?((k[ia+(ja*328|0)+12>>2]|0)+-3|0)>=(N|0):0)?((k[ia+(ja*328|0)+8>>2]|0)+-3|0)>=(q|0):0){x=(k[ia+(ja*328|0)+72>>2]|0)+(aa(k[k[ia+(ja*328|0)+100>>2]>>2]|0,z)|0)+I|0;b=i[x>>0]|0;if((b&255)<=2){e=(k[ia+(ja*328|0)+16>>2]|0)+(aa(k[k[ia+(ja*328|0)+44>>2]>>2]|0,z)|0)+I|0;w=l[e>>0]|0;a=0;b=255;s=255;while(1){v=(b|0)/2|0;t=v+w|0;u=w-v|0;b=65848;while(1){fa=l[e+(k[ia+(ja*328|0)+228+(b>>>28<<2)>>2]|0)>>0]|0;fa=((b&4096|0)==0?(fa|0)>(t|0):(fa|0)<(u|0))?b>>>16:b;b=fa&4095;if((fa&4094|0)==684)break;else b=k[138248+(b<<2)>>2]|0}b=(b|0)==502|(b|0)==684;s=b?v:s;b=b?a:v;if((b|0)==(s|0)|(b|0)==(s+-1|0))break;else{a=b;b=b+s|0}}b=(b&255|0)==0?0:b&255;i[x>>0]=b}M=b&255}else M=0;H=(N|0)<3;if((!(y|H)?((k[ia+(ja*328|0)+12>>2]|0)+-3|0)>(N|0):0)?((k[ia+(ja*328|0)+8>>2]|0)+-3|0)>=(q|0):0){x=(k[ia+(ja*328|0)+72>>2]|0)+(aa(k[k[ia+(ja*328|0)+100>>2]>>2]|0,z)|0)+N|0;b=i[x>>0]|0;if((b&255)<=2){e=(k[ia+(ja*328|0)+16>>2]|0)+(aa(k[k[ia+(ja*328|0)+44>>2]>>2]|0,z)|0)+N|0;w=l[e>>0]|0;a=0;b=255;s=255;while(1){v=(b|0)/2|0;t=v+w|0;u=w-v|0;b=65848;while(1){fa=l[e+(k[ia+(ja*328|0)+228+(b>>>28<<2)>>2]|0)>>0]|0;fa=((b&4096|0)==0?(fa|0)>(t|0):(fa|0)<(u|0))?b>>>16:b;b=fa&4095;if((fa&4094|0)==684)break;else b=k[138248+(b<<2)>>2]|0}b=(b|0)==502|(b|0)==684;s=b?v:s;b=b?a:v;if((b|0)==(s|0)|(b|0)==(s+-1|0))break;else{a=b;b=b+s|0}}b=(b&255|0)==0?0:b&255;i[x>>0]=b}L=b&255}else L=0;K=N+1|0;J=(K|0)<3;if((!(y|J)?((k[ia+(ja*328|0)+12>>2]|0)+-3|0)>(K|0):0)?((k[ia+(ja*328|0)+8>>2]|0)+-3|0)>=(q|0):0){x=(k[ia+(ja*328|0)+72>>2]|0)+(aa(k[k[ia+(ja*328|0)+100>>2]>>2]|0,z)|0)+K|0;b=i[x>>0]|0;if((b&255)<=2){e=(k[ia+(ja*328|0)+16>>2]|0)+(aa(k[k[ia+(ja*328|0)+44>>2]>>2]|0,z)|0)+K|0;w=l[e>>0]|0;a=0;b=255;s=255;while(1){v=(b|0)/2|0;t=v+w|0;u=w-v|0;b=65848;while(1){fa=l[e+(k[ia+(ja*328|0)+228+(b>>>28<<2)>>2]|0)>>0]|0;fa=((b&4096|0)==0?(fa|0)>(t|0):(fa|0)<(u|0))?b>>>16:b;b=fa&4095;if((fa&4094|0)==684)break;else b=k[138248+(b<<2)>>2]|0}b=(b|0)==502|(b|0)==684;s=b?v:s;b=b?a:v;if((b|0)==(s|0)|(b|0)==(s+-1|0))break;else{a=b;b=b+s|0}}b=(b&255|0)==0?0:b&255;i[x>>0]=b}G=b&255}else G=0;y=(q|0)<3;if((!(y|J)?((k[ia+(ja*328|0)+12>>2]|0)+-3|0)>(K|0):0)?((k[ia+(ja*328|0)+8>>2]|0)+-3|0)>(q|0):0){x=(k[ia+(ja*328|0)+72>>2]|0)+(aa(k[k[ia+(ja*328|0)+100>>2]>>2]|0,q)|0)+K|0;b=i[x>>0]|0;if((b&255)<=2){e=(k[ia+(ja*328|0)+16>>2]|0)+(aa(k[k[ia+(ja*328|0)+44>>2]>>2]|0,q)|0)+K|0;w=l[e>>0]|0;a=0;b=255;s=255;while(1){v=(b|0)/2|0;t=v+w|0;u=w-v|0;b=65848;while(1){fa=l[e+(k[ia+(ja*328|0)+228+(b>>>28<<2)>>2]|0)>>0]|0;fa=((b&4096|0)==0?(fa|0)>(t|0):(fa|0)<(u|0))?b>>>16:b;b=fa&4095;if((fa&4094|0)==684)break;else b=k[138248+(b<<2)>>2]|0}b=(b|0)==502|(b|0)==684;s=b?v:s;b=b?a:v;if((b|0)==(s|0)|(b|0)==(s+-1|0))break;else{a=b;b=b+s|0}}b=(b&255|0)==0?0:b&255;i[x>>0]=b}E=b&255}else E=0;if((!(y|H)?((k[ia+(ja*328|0)+12>>2]|0)+-3|0)>(N|0):0)?((k[ia+(ja*328|0)+8>>2]|0)+-3|0)>(q|0):0){x=(k[ia+(ja*328|0)+72>>2]|0)+(aa(k[k[ia+(ja*328|0)+100>>2]>>2]|0,q)|0)+N|0;b=i[x>>0]|0;if((b&255)<=2){e=(k[ia+(ja*328|0)+16>>2]|0)+(aa(k[k[ia+(ja*328|0)+44>>2]>>2]|0,q)|0)+N|0;w=l[e>>0]|0;a=0;b=255;s=255;while(1){v=(b|0)/2|0;t=v+w|0;u=w-v|0;b=65848;while(1){fa=l[e+(k[ia+(ja*328|0)+228+(b>>>28<<2)>>2]|0)>>0]|0;fa=((b&4096|0)==0?(fa|0)>(t|0):(fa|0)<(u|0))?b>>>16:b;b=fa&4095;if((fa&4094|0)==684)break;else b=k[138248+(b<<2)>>2]|0}b=(b|0)==502|(b|0)==684;s=b?v:s;b=b?a:v;if((b|0)==(s|0)|(b|0)==(s+-1|0))break;else{a=b;b=b+s|0}}b=(b&255|0)==0?0:b&255;i[x>>0]=b}D=b&255}else D=0;if((!(y|F)?((k[ia+(ja*328|0)+12>>2]|0)+-3|0)>=(N|0):0)?((k[ia+(ja*328|0)+8>>2]|0)+-3|0)>(q|0):0){x=(k[ia+(ja*328|0)+72>>2]|0)+(aa(k[k[ia+(ja*328|0)+100>>2]>>2]|0,q)|0)+I|0;b=i[x>>0]|0;if((b&255)<=2){e=(k[ia+(ja*328|0)+16>>2]|0)+(aa(k[k[ia+(ja*328|0)+44>>2]>>2]|0,q)|0)+I|0;w=l[e>>0]|0;a=0;b=255;s=255;while(1){v=(b|0)/2|0;t=v+w|0;u=w-v|0;b=65848;while(1){fa=l[e+(k[ia+(ja*328|0)+228+(b>>>28<<2)>>2]|0)>>0]|0;fa=((b&4096|0)==0?(fa|0)>(t|0):(fa|0)<(u|0))?b>>>16:b;b=fa&4095;if((fa&4094|0)==684)break;else b=k[138248+(b<<2)>>2]|0}b=(b|0)==502|(b|0)==684;s=b?v:s;b=b?a:v;if((b|0)==(s|0)|(b|0)==(s+-1|0))break;else{a=b;b=b+s|0}}b=(b&255|0)==0?0:b&255;i[x>>0]=b}C=b&255}else C=0;B=q+1|0;A=(B|0)<3;if((!(F|A)?((k[ia+(ja*328|0)+12>>2]|0)+-3|0)>=(N|0):0)?((k[ia+(ja*328|0)+8>>2]|0)+-3|0)>(B|0):0){x=(k[ia+(ja*328|0)+72>>2]|0)+(aa(k[k[ia+(ja*328|0)+100>>2]>>2]|0,B)|0)+I|0;b=i[x>>0]|0;if((b&255)<=2){e=(k[ia+(ja*328|0)+16>>2]|0)+(aa(k[k[ia+(ja*328|0)+44>>2]>>2]|0,B)|0)+I|0;w=l[e>>0]|0;a=0;b=255;s=255;while(1){v=(b|0)/2|0;t=v+w|0;u=w-v|0;b=65848;while(1){fa=l[e+(k[ia+(ja*328|0)+228+(b>>>28<<2)>>2]|0)>>0]|0;fa=((b&4096|0)==0?(fa|0)>(t|0):(fa|0)<(u|0))?b>>>16:b;b=fa&4095;if((fa&4094|0)==684)break;else b=k[138248+(b<<2)>>2]|0}b=(b|0)==502|(b|0)==684;s=b?v:s;b=b?a:v;if((b|0)==(s|0)|(b|0)==(s+-1|0))break;else{a=b;b=b+s|0}}b=(b&255|0)==0?0:b&255;i[x>>0]=b}z=b&255}else z=0;do if(!(H|A)?((k[ia+(ja*328|0)+12>>2]|0)+-3|0)>(N|0):0){if(((k[ia+(ja*328|0)+8>>2]|0)+-3|0)<=(B|0)){y=0;break}x=(k[ia+(ja*328|0)+72>>2]|0)+(aa(k[k[ia+(ja*328|0)+100>>2]>>2]|0,B)|0)+N|0;b=i[x>>0]|0;if((b&255)<=2){e=(k[ia+(ja*328|0)+16>>2]|0)+(aa(k[k[ia+(ja*328|0)+44>>2]>>2]|0,B)|0)+N|0;w=l[e>>0]|0;a=0;b=255;s=255;while(1){v=(b|0)/2|0;t=v+w|0;u=w-v|0;b=65848;while(1){fa=l[e+(k[ia+(ja*328|0)+228+(b>>>28<<2)>>2]|0)>>0]|0;fa=((b&4096|0)==0?(fa|0)>(t|0):(fa|0)<(u|0))?b>>>16:b;b=fa&4095;if((fa&4094|0)==684)break;else b=k[138248+(b<<2)>>2]|0}b=(b|0)==502|(b|0)==684;s=b?v:s;b=b?a:v;if((b|0)==(s|0)|(b|0)==(s+-1|0))break;else{a=b;b=b+s|0}}b=(b&255|0)==0?0:b&255;i[x>>0]=b}y=b&255}else y=0;while(0);do if(A|J)b=0;else{if(((k[ia+(ja*328|0)+12>>2]|0)+-3|0)<=(K|0)){b=0;break}if(((k[ia+(ja*328|0)+8>>2]|0)+-3|0)<=(B|0)){b=0;break}x=(k[ia+(ja*328|0)+72>>2]|0)+(aa(k[k[ia+(ja*328|0)+100>>2]>>2]|0,B)|0)+K|0;b=i[x>>0]|0;if((b&255)<=2){e=(k[ia+(ja*328|0)+16>>2]|0)+(aa(k[k[ia+(ja*328|0)+44>>2]>>2]|0,B)|0)+K|0;w=l[e>>0]|0;a=0;b=255;s=255;while(1){v=(b|0)/2|0;t=v+w|0;u=w-v|0;b=65848;while(1){fa=l[e+(k[ia+(ja*328|0)+228+(b>>>28<<2)>>2]|0)>>0]|0;fa=((b&4096|0)==0?(fa|0)>(t|0):(fa|0)<(u|0))?b>>>16:b;b=fa&4095;if((fa&4094|0)==684)break;else b=k[138248+(b<<2)>>2]|0}b=(b|0)==502|(b|0)==684;s=b?v:s;b=b?a:v;if((b|0)==(s|0)|(b|0)==(s+-1|0))break;else{a=b;b=b+s|0}}b=(b&255|0)==0?0:b&255;i[x>>0]=b}b=b&255}while(0);p=+UUa(M,C,z,L,D,y,G,E,b,la,ka);o[na>>2]=p;n=+(q|0)+ +o[ka>>2];m=+(N|0)+ +o[la>>2];if(ma){o[g>>2]=(m*6.0+1.0)*.125-+(c|0);m=(n*6.0+1.0)*.125-+(d|0)}else{o[g>>2]=(m*4.0+-1.0)/6.0-+(c|0);m=(n*4.0+-1.0)/6.0-+(d|0)}o[h>>2]=m;m=+o[g>>2];do if(m>1.0){o[g>>2]=1.0;b=0}else{if(!(m<-1.0)){b=1;break}o[g>>2]=-1.0;b=0}while(0);m=+o[h>>2];do if(m>1.0){o[h>>2]=1.0;i[f>>0]=1}else{if(m<-1.0){o[h>>2]=-1.0;i[f>>0]=1;break}i[f>>0]=1;if(!b)break;j=p<+o[j>>2]?j:na}while(0);ha=+o[j>>2];r=oa;return +ha}function WUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;k[a>>2]=0;g=a+4|0;k[g>>2]=0;k[a+8>>2]=0;f=b+4|0;d=(k[f>>2]|0)-(k[b>>2]|0)|0;e=(d|0)/28|0;if(!d)return;if(e>>>0>153391689)ad(426534,426557,304,426811);while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[g>>2]=c;k[a>>2]=c;k[a+8>>2]=c+(e*28|0);d=k[b>>2]|0;a=k[f>>2]|0;if((d|0)==(a|0))return;do{k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];f=c+8|0;e=d+8|0;k[f>>2]=k[e>>2];k[f+4>>2]=k[e+4>>2];k[f+8>>2]=k[e+8>>2];k[f+12>>2]=k[e+12>>2];k[f+16>>2]=k[e+16>>2];d=d+28|0;c=(k[g>>2]|0)+28|0;k[g>>2]=c}while((d|0)!=(a|0));return}function XUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b>>2];i=a+4|0;d=b+4|0;k[i>>2]=k[d>>2];h=a+8|0;k[h>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];k[a+20>>2]=k[b+20>>2];k[a+24>>2]=k[b+24>>2];k[a+28>>2]=k[b+28>>2];k[a+32>>2]=k[b+32>>2];c=k[b+36>>2]|0;k[a+36>>2]=c;e=a+40|0;k[e>>2]=h;h=a+48|0;g=a+44|0;k[g>>2]=h;k[a+52>>2]=0;k[h>>2]=0;if(c|0){h=c+12|0;k[h>>2]=(k[h>>2]|0)+1}if((k[d>>2]|0)>=3){k[i>>2]=0;x1(a,k[d>>2]|0,0,0,0);if((k[i>>2]|0)>0){h=k[b+40>>2]|0;e=k[e>>2]|0;f=k[b+44>>2]|0;d=k[g>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[h+(c<<2)>>2];k[d+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{h=k[b+44>>2]|0;i=k[g>>2]|0;k[i>>2]=k[h>>2];k[i+4>>2]=k[h+4>>2]}c=a+56|0;k[c>>2]=k[b+56>>2];i=a+60|0;d=b+60|0;k[i>>2]=k[d>>2];g=a+64|0;k[g>>2]=k[b+64>>2];k[a+68>>2]=k[b+68>>2];k[a+72>>2]=k[b+72>>2];k[a+76>>2]=k[b+76>>2];k[a+80>>2]=k[b+80>>2];k[a+84>>2]=k[b+84>>2];k[a+88>>2]=k[b+88>>2];e=k[b+92>>2]|0;k[a+92>>2]=e;f=a+96|0;k[f>>2]=g;g=a+104|0;h=a+100|0;k[h>>2]=g;k[a+108>>2]=0;k[g>>2]=0;if(e|0){g=e+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[d>>2]|0)>=3){k[i>>2]=0;x1(c,k[d>>2]|0,0,0,0);if((k[i>>2]|0)>0){g=k[b+96>>2]|0;e=k[f>>2]|0;f=k[b+100>>2]|0;d=k[h>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{g=k[b+100>>2]|0;i=k[h>>2]|0;k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2]}h=b+112|0;i=k[h+4>>2]|0;c=a+112|0;k[c>>2]=k[h>>2];k[c+4>>2]=i;c=k[b+120>>2]|0;k[a+120>>2]=c;k[a+124>>2]=k[b+124>>2];if(!c){a=a+128|0;b=b+128|0;upb(a|0,b|0,200)|0;return}i=c+4|0;k[i>>2]=(k[i>>2]|0)+1;a=a+128|0;b=b+128|0;upb(a|0,b|0,200)|0;return}function YUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;h=a+4|0;c=k[a>>2]|0;e=((k[h>>2]|0)-c|0)/328|0;d=e+1|0;if(d>>>0>13094412)ad(426534,426557,304,426811);i=a+8|0;g=((k[i>>2]|0)-c|0)/328|0;f=g<<1;f=g>>>0<6547206?(f>>>0<d>>>0?d:f):13094412;if(!f)c=0;else{if(f>>>0>13094412){i=te(4)|0;k[i>>2]=172664;Cf(i|0,28816,1287)}d=f*328|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(e*328|0)|0;d=e;g=c+(f*328|0)|0;XUa(e,b);b=e+328|0;f=k[a>>2]|0;c=k[h>>2]|0;if((c|0)==(f|0)){c=f;e=c}else{do{c=c+-328|0;XUa(e+-328|0,c);e=d+-328|0;d=e}while((c|0)!=(f|0));e=k[a>>2]|0;c=k[h>>2]|0}k[a>>2]=d;k[h>>2]=b;k[i>>2]=g;d=e;while(1){if((c|0)==(d|0))break;c=c+-328|0;QUa(c)}if(!e)return;ggb(e);return}function ZUa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;x=r;r=r+256|0;q=x+232|0;s=x;h=x+224|0;k[a>>2]=1124007936;l=a+8|0;j=a+40|0;m=a+4|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[j>>2]=l;w=a+48|0;k[a+44>>2]=w;k[a+52>>2]=0;k[w>>2]=0;p=a+56|0;d=a+64|0;e=a+96|0;m=a+60|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[e>>2]=d;t=a+104|0;k[a+100>>2]=t;k[a+108>>2]=0;k[t>>2]=0;k[p>>2]=1124007936;t=a+120|0;k[t>>2]=0;u=a+124|0;k[u>>2]=0;f=b+8|0;d=k[f>>2]|0;if(!c){n=b+12|0;m=(k[n>>2]|0)/2|0;k[q>>2]=(d|0)/2|0;k[q+4>>2]=m;G1(a,2,q,0);d=a+12|0;if(((k[n>>2]|0)/2|0|0)!=(k[d>>2]|0)){k[q>>2]=0;e=q+4|0;k[e>>2]=0;c=ZT(36)|0;k[c>>2]=1;m=c+4|0;k[q>>2]=m;k[e>>2]=30;i[c+34>>0]=0;g=385756;n=m+30|0;do{i[m>>0]=i[g>>0]|0;m=m+1|0;g=g+1|0}while((m|0)<(n|0));Y8(-215,q,385787,385570,2292);k[e>>2]=0;k[q>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)==1)ggb(k[c+-4>>2]|0)}if(((k[f>>2]|0)/2|0|0)!=(k[l>>2]|0)){k[q>>2]=0;e=q+4|0;k[e>>2]=0;c=ZT(36)|0;k[c>>2]=1;m=c+4|0;k[q>>2]=m;k[e>>2]=30;i[c+34>>0]=0;g=385798;n=m+30|0;do{i[m>>0]=i[g>>0]|0;m=m+1|0;g=g+1|0}while((m|0)<(n|0));Y8(-215,q,385787,385570,2293);k[e>>2]=0;k[q>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)==1)ggb(k[c+-4>>2]|0)}k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=b;m=s+4|0;n=m+4|0;k[n>>2]=0;k[n+4>>2]=0;k[s>>2]=33619968;k[m>>2]=a;m=k[j>>2]|0;n=k[m>>2]|0;k[h>>2]=k[m+4>>2];k[h+4>>2]=n;Rla(q,s,h,0.0,0.0,3);y=+o[b+112>>2]*2.0;o[a+112>>2]=y;o[a+116>>2]=y*.5+-.5}else{n=b+12|0;m=((k[n>>2]|0)/3|0)<<1;k[q>>2]=((d|0)/3|0)<<1;k[q+4>>2]=m;G1(a,2,q,0);d=a+12|0;if((((k[n>>2]|0)/3|0)<<1|0)!=(k[d>>2]|0)){k[q>>2]=0;e=q+4|0;k[e>>2]=0;c=ZT(44)|0;k[c>>2]=1;m=c+4|0;k[q>>2]=m;k[e>>2]=36;i[c+40>>0]=0;g=385667;n=m+36|0;do{i[m>>0]=i[g>>0]|0;m=m+1|0;g=g+1|0}while((m|0)<(n|0));Y8(-215,q,385704,385570,2303);k[e>>2]=0;k[q>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)==1)ggb(k[c+-4>>2]|0)}if((((k[f>>2]|0)/3|0)<<1|0)!=(k[l>>2]|0)){k[q>>2]=0;e=q+4|0;k[e>>2]=0;c=ZT(44)|0;k[c>>2]=1;m=c+4|0;k[q>>2]=m;k[e>>2]=36;i[c+40>>0]=0;g=385719;n=m+36|0;do{i[m>>0]=i[g>>0]|0;m=m+1|0;g=g+1|0}while((m|0)<(n|0));Y8(-215,q,385704,385570,2304);k[e>>2]=0;k[q>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)==1)ggb(k[c+-4>>2]|0)}k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=b;m=s+4|0;n=m+4|0;k[n>>2]=0;k[n+4>>2]=0;k[s>>2]=33619968;k[m>>2]=a;m=k[j>>2]|0;n=k[m>>2]|0;k[h>>2]=k[m+4>>2];k[h+4>>2]=n;Rla(q,s,h,0.0,0.0,3);y=+o[b+112>>2]*1.5;o[a+112>>2]=y;o[a+116>>2]=y*.5+-.5}f=k[l>>2]|0;c=k[d>>2]|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=1124007936;d=s+16|0;e=s+48|0;m=s+12|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[e>>2]=d;d=s+56|0;k[s+52>>2]=d;k[s+60>>2]=0;k[d>>2]=0;k[s+64>>2]=1124007936;d=s+72|0;e=s+104|0;m=s+68|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[e>>2]=d;d=s+112|0;k[s+108>>2]=d;k[s+116>>2]=0;k[d>>2]=0;k[s+120>>2]=1124007936;d=s+128|0;e=s+160|0;m=s+124|0;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[e>>2]=d;m=s+168|0;k[s+164>>2]=m;n=m+56|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[q>>2]=c;k[q+4>>2]=f;j1(s,48,q,0);q=k[s>>2]|0;dh[k[(k[q>>2]|0)+12>>2]&255](q,s,p,0);XN(s);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d>>2]=128284;k[d+4>>2]=1;i[d+8>>0]=0;k[d+12>>2]=3;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}q=e+4|0;k[q>>2]=1;k[e>>2]=128380;k[e+8>>2]=d;f=e;k[q>>2]=(k[q>>2]|0)+1;s=k[q>>2]|0;k[q>>2]=s+-1;if((s|0)!=1){if(e|0)v=31}else{Uh[k[(k[e>>2]|0)+8>>2]&2047](e);v=31}if((v|0)==31){v=e+4|0;k[v>>2]=(k[v>>2]|0)+1}c=k[t>>2]|0;k[t>>2]=f;k[u>>2]=d;if(c|0?(u=c+4|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);if(!e){u=a+128|0;v=k[w>>2]|0;ITa(u,v,0);a=a+228|0;w=k[w>>2]|0;ITa(a,w,3);r=x;return}u=e+4|0;v=k[u>>2]|0;k[u>>2]=v+-1;if((v|0)!=1){u=a+128|0;v=k[w>>2]|0;ITa(u,v,0);a=a+228|0;w=k[w>>2]|0;ITa(a,w,3);r=x;return}Uh[k[(k[e>>2]|0)+8>>2]&2047](e);u=a+128|0;v=k[w>>2]|0;ITa(u,v,0);a=a+228|0;w=k[w>>2]|0;ITa(a,w,3);r=x;return}function _Ua(a){a=a|0;var b=0;k[a>>2]=141412;b=k[a+12>>2]|0;if(b|0)ggb(b);b=k[a+40>>2]|0;if(b|0)ggb(b);b=k[a+44>>2]|0;if(b|0)ggb(b);b=k[a+20>>2]|0;if(b|0)ggb(b);b=k[a+24>>2]|0;if(!b)return;ggb(b);return}function $Ua(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,l=0,m=0.0,n=0,q=0,s=0,t=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0;P=r;r=r+32|0;L=P+8|0;M=P;k[L>>2]=0;O=L+4|0;k[O>>2]=0;k[L+8>>2]=0;g=f+4|0;h=(k[g>>2]|0)-(k[f>>2]|0)>>2;if(h|0?(eQ(L,h),j=k[f>>2]|0,l=(k[g>>2]|0)-j|0,(l|0)>0):0){K=k[O>>2]|0;upb(K|0,j|0,l|0)|0;k[O>>2]=K+(l>>2<<2)}I=a+32|0;o[I>>2]=d;H=a+36|0;o[H>>2]=e;j=(k[b+4>>2]|0)-(k[b>>2]|0)|0;F=j>>2;if(!((F|0)!=0?(F|0)==((k[c+4>>2]|0)-(k[c>>2]|0)>>2|0):0)){k[M>>2]=0;g=M+4|0;k[g>>2]=0;h=ZT(72)|0;k[h>>2]=1;l=h+4|0;k[M>>2]=l;k[g>>2]=64;i[h+68>>0]=0;f=385847;n=l+64|0;do{i[l>>0]=i[f>>0]|0;l=l+1|0;f=f+1|0}while((l|0)<(n|0));Y8(-215,M,385912,385570,334);k[g>>2]=0;k[M>>2]=0;K=k[h>>2]|0;k[h>>2]=K+-1;if((K|0)==1)ggb(k[h+-4>>2]|0)}K=a+16|0;k[K>>2]=0;E=(j|0)>0;if(E){j=k[c>>2]|0;h=0;g=0;do{g=g+(k[j+(h<<2)>>2]|0)|0;k[K>>2]=g;h=h+1|0}while((h|0)<(F|0))}else g=0;h=g<<16;h=h>>>0>357913941?-1:h*12|0;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}J=a+12|0;k[J>>2]=g;if(!(i[427984]|0)){i[427984]=1;o[206781]=4.906890869140625}if(!(i[427992]|0)){i[427992]=1;o[206782]=+o[206781]*.015625}while(1){h=fgb(256)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[a+20>>2]=h;while(1){j=fgb(256)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}k[a+24>>2]=j;D=0;do{d=+(D>>>0)*+o[206782];e=d;p[u>>3]=e;l=k[u+4>>2]|0;f=l&2147483647;do if(f>>>0>1083174911){l=(l|0)>-1|(l|0)==-1&(k[u>>2]|0)>>>0>4294967295;if(l&f>>>0>1083179007){d=e*8988465674311579538646525.0e283;break}if(f>>>0<=2146435071)if(!(d<=-1075.0)|l){G=40;break}else{d=0.0;break}else{d=-1.0/e;break}}else if(f>>>0<1016070144)d=e+1.0;else G=40;while(0);if((G|0)==40){G=0;d=e+26388279066624.0;p[u>>3]=d;C=(k[u>>2]|0)+128|0;f=C&-256;l=(f|0)/256|0;C=C<<1&510;w=+p[23184+(C<<3)>>3];d=e-(d+-26388279066624.0)-+p[23184+((C|1)<<3)>>3];d=w+w*d*(d*(d*(d*(d*1.3333559164630223e-03+.009618129842126066)+.0555041086648214)+.2402265069591)+.6931471805599453);if((f|0)>262143){d=d*8988465674311579538646525.0e283;f=l+-1023|0;l=l+-2046|0;if((f|0)>1023){d=d*8988465674311579538646525.0e283;l=(l|0)>1023?1023:l}else l=f}else if((f|0)<-261887){d=d*2.2250738585072014e-308;f=l+1022|0;l=l+2044|0;if((f|0)<-1022){d=d*2.2250738585072014e-308;l=(l|0)<-1022?-1022:l}else l=f}B=Apb(l+1023|0,0,52)|0;C=N;k[u>>2]=B;k[u+4>>2]=C;d=d*+p[u>>3]}z=h+(D<<2)|0;o[z>>2]=d;A=j+(D<<2)|0;k[A>>2]=0;B=k[c>>2]|0;C=k[b>>2]|0;y=0;l=0;do{m=+(y>>>0)*2.0*3.141592653589793*.0009765625;if(E){x=0;do{s=B+(x<<2)|0;f=k[s>>2]|0;if((f|0)>0){v=C+(x<<2)|0;e=+o[v>>2];if(!x){q=0;n=f;do{w=m+ +(q|0)*2.0*3.141592653589793/+(n|0);d=+S(+w)*(d*e);o[g>>2]=d;w=+T(+w)*(+o[z>>2]*+o[v>>2]);o[g+4>>2]=w;w=+o[z>>2]*1.2999999523162842*.5;o[g+8>>2]=w;d=+o[z>>2];e=+o[v>>2];w=d*e+w;f=~~w;f=f+1+(+(f|0)<w&1)|0;if(l>>>0<f>>>0){k[A>>2]=f;n=k[s>>2]|0;l=f}g=g+12|0;q=q+1|0}while((q|0)<(n|0))}else{q=0;n=f;do{w=+(n|0);t=m+ +(q|0)*2.0*3.141592653589793/w;d=+S(+t)*(d*e);o[g>>2]=d;d=+T(+t)*(+o[z>>2]*+o[v>>2]);o[g+4>>2]=d;w=+o[z>>2]*1.2999999523162842*+o[v>>2]*+T(+(3.141592653589793/w));o[g+8>>2]=w;d=+o[z>>2];e=+o[v>>2];w=d*e+w;f=~~w;f=f+1+(+(f|0)<w&1)|0;if(l>>>0<f>>>0){k[A>>2]=f;n=k[s>>2]|0;l=f}g=g+12|0;q=q+1|0}while((q|0)<(n|0))}}x=x+1|0}while((x|0)<(F|0))}y=y+1|0}while((y|0)!=1024);D=D+1|0}while((D|0)!=64);f=k[K>>2]|0;f=(aa(f+-1|0,f)|0)>>>1;h=f>>>0>536870911?-1:f<<3;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}A=a+40|0;k[A>>2]=g;h=f>>>0>268435455?-1:f<<4;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}y=a+44|0;k[y>>2]=g;z=a+48|0;k[z>>2]=0;x=a+52|0;k[x>>2]=0;g=k[O>>2]|0;l=k[L>>2]|0;j=g-l>>2;h=l;if(!j){if(f){U1(L,f);h=k[L>>2]|0;l=h;g=k[O>>2]|0}j=g-l>>2;if(!j)j=0;else{g=0;do{k[h+(g<<2)>>2]=g;g=g+1|0}while((g|0)!=(j|0))}}w=+o[H>>2];w=w*w;t=+o[I>>2];t=t*t;if((k[K>>2]|0)>>>0>1){v=M+4|0;s=1;l=h;g=h;while(1){if(!s)h=l;else{q=0;h=l;do{I=k[J>>2]|0;d=+o[I+(q*12|0)>>2]-+o[I+(s*12|0)>>2];e=+o[I+(q*12|0)+4>>2]-+o[I+(s*12|0)+4>>2];m=d*d+e*e;if(!(m>w)){if(m<t){l=k[z>>2]|0;if(l>>>0>=j>>>0){k[M>>2]=0;k[v>>2]=0;g=ZT(28)|0;k[g>>2]=1;l=g+4|0;k[M>>2]=l;k[v>>2]=23;i[g+27>>0]=0;f=385927;n=l+23|0;do{i[l>>0]=i[f>>0]|0;l=l+1|0;f=f+1|0}while((l|0)<(n|0));Y8(-215,M,385912,385570,434);k[v>>2]=0;k[M>>2]=0;I=k[g>>2]|0;k[g>>2]=I+-1;if((I|0)==1)ggb(k[g+-4>>2]|0);h=k[L>>2]|0;g=h;l=k[z>>2]|0}I=k[g+(l<<2)>>2]|0;H=k[A>>2]|0;k[H+(I<<3)+4>>2]=q;k[H+(I<<3)>>2]=s;k[z>>2]=l+1}}else{I=k[x>>2]|0;H=k[y>>2]|0;k[H+(I<<4)+8>>2]=~~(d/m*2048.0+.5);k[H+(I<<4)+12>>2]=~~(e/m*2048.0+.5);k[H+(I<<4)>>2]=s;k[H+(I<<4)+4>>2]=q;k[x>>2]=I+1}q=q+1|0}while(q>>>0<s>>>0)}s=s+1|0;if(s>>>0>=(k[K>>2]|0)>>>0)break;else l=h}}M=~~+$(+(+((k[z>>2]|0)>>>0)*.0078125))<<4;k[a+28>>2]=M;if(!h){r=P;return}g=k[O>>2]|0;if((g|0)!=(h|0))k[O>>2]=g+(~((g+-4-h|0)>>>2)<<2);ggb(h);r=P;return}function aVa(a){a=a|0;ggb(a);return}function bVa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function cVa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0;s=r;r=r+32|0;q=s;do if(!(e&1)){if((S1(a,-1)|0)==16){I2(a,c);break}if(!(S1(a,-1)|0)){$aa(a,c,8,0);break}a=q+4|0;f=ZT(36)|0;k[f>>2]=1;g=f+4|0;k[q>>2]=g;k[a>>2]=31;i[f+35>>0]=0;h=386021;j=g+31|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,q,386053,386067,106);k[a>>2]=0;k[q>>2]=0;o=k[f>>2]|0;k[f>>2]=o+-1;if((o|0)==1)ggb(k[f+-4>>2]|0)}while(0);o=n9(c9()|0)|0;if((+p[d>>3]==-1.0?+p[d+8>>3]==-1.0:0)?+p[d+16>>3]==-1.0:0)n=+p[d+24>>3]==-1.0;else n=0;if(G2(c)|0){a=q+4|0;f=ZT(24)|0;k[f>>2]=1;g=f+4|0;k[q>>2]=g;k[a>>2]=17;i[f+21>>0]=0;h=386136;j=g+17|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,q,386053,386067,113);k[a>>2]=0;k[q>>2]=0;m=k[f>>2]|0;k[f>>2]=m+-1;if((m|0)==1)ggb(k[f+-4>>2]|0)}a=k[b>>2]|0;j=k[b+4>>2]|0;if((a|0)==(j|0)){r=s;return}b=q+8|0;l=q+16|0;m=q+24|0;f=d+8|0;g=d+16|0;h=d+24|0;if(n){do{n=o;h=k[n+4>>2]|0;n=Epb(k[n>>2]|0,0,-130063606,0)|0;h=kpb(n|0,N|0,h|0,0)|0;n=N;d=Epb(h|0,0,-130063606,0)|0;n=kpb(d|0,N|0,n|0,0)|0;d=N;g=Epb(n|0,0,-130063606,0)|0;d=kpb(g|0,N|0,d|0,0)|0;g=o;k[g>>2]=d;k[g+4>>2]=N;p[q>>3]=+((h&255)>>>0);p[b>>3]=+((n&255)>>>0);p[l>>3]=+((d&255)>>>0);p[m>>3]=0.0;dVa(c,a,q,e);a=a+28|0}while((a|0)!=(j|0));r=s;return}else{do{p[q>>3]=+p[d>>3];p[b>>3]=+p[f>>3];p[l>>3]=+p[g>>3];p[m>>3]=+p[h>>3];dVa(c,a,q,e);a=a+28|0}while((a|0)!=(j|0));r=s;return}}function dVa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,j=0.0,l=0,m=0,n=0,p=0.0,q=0,s=0,t=0,v=0,w=0;w=r;r=r+48|0;h=w+32|0;s=w+24|0;t=w+16|0;v=w+8|0;q=w;if(G2(a)|0){f=h+4|0;g=ZT(20)|0;k[g>>2]=1;l=g+4|0;k[h>>2]=l;k[f>>2]=12;i[g+16>>0]=0;m=386154;n=l+12|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,h,386167,386067,55);k[f>>2]=0;k[h>>2]=0;n=k[g>>2]|0;k[g>>2]=n+-1;if((n|0)==1)ggb(k[g+-4>>2]|0)}e=+o[b>>2]*16.0;f=(o[u>>2]=e,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;e=f?e+-8388608.0+8388608.0:e+8388608.0+-8388608.0;if(e==0.0)e=f?-0.0:0.0}l=~~e;e=+o[b+4>>2]*16.0;f=(o[u>>2]=e,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;e=f?e+-8388608.0+8388608.0:e+8388608.0+-8388608.0;if(e==0.0)e=f?-0.0:0.0}h=~~e;if(!(d&4)){k[q>>2]=l;k[q+4>>2]=h;Zfa(a,q,48,c,1,16,4);r=w;return}e=+o[b+8>>2]*.5*16.0;f=(o[u>>2]=e,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;e=f?e+-8388608.0+8388608.0:e+8388608.0+-8388608.0;if(e==0.0)e=f?-0.0:0.0}f=~~e;k[s>>2]=l;k[s+4>>2]=h;Zfa(a,s,f,c,1,16,4);e=+o[b+12>>2];if(!(e!=-1.0)){r=w;return}p=e*3.1415927410125732/180.0;j=+(f|0);e=j*+S(+p);f=(o[u>>2]=e,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;e=f?e+-8388608.0+8388608.0:e+8388608.0+-8388608.0;if(e==0.0)e=f?-0.0:0.0}g=~~e;e=j*+T(+p);f=(o[u>>2]=e,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;e=f?e+-8388608.0+8388608.0:e+8388608.0+-8388608.0;if(e==0.0)e=f?-0.0:0.0}k[t>>2]=l;k[t+4>>2]=h;k[v>>2]=g+l;k[v+4>>2]=~~e+h;Gfa(a,t,v,c,1,16,4);r=w;return}function eVa(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+224|0;F=J+168|0;w=J+160|0;x=J+152|0;D=J;C=J+88|0;l=J+144|0;y=J+72|0;z=J+56|0;k[F>>2]=1124007936;G=F+4|0;v=F+8|0;E=F+40|0;n=G;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[E>>2]=v;I=F+48|0;H=F+44|0;k[H>>2]=I;k[F+52>>2]=0;k[I>>2]=0;R1(w,a,-1);R1(x,c,-1);t=(k[x>>2]|0)+(k[w>>2]|0)|0;A=w+4|0;u=k[A>>2]|0;B=x+4|0;s=k[B>>2]|0;u=(u|0)<(s|0)?s:u;do if(!(j&1)){k[l>>2]=t;k[l+4>>2]=u;x2(e,l,(S1(a,-1)|0)&7|16,0);do if((k[e>>2]&2031616|0)==65536){n=k[e+4>>2]|0;k[D>>2]=k[n>>2];s=D+4|0;l=n+4|0;k[s>>2]=k[l>>2];v=D+8|0;k[v>>2]=k[n+8>>2];k[D+12>>2]=k[n+12>>2];k[D+16>>2]=k[n+16>>2];k[D+20>>2]=k[n+20>>2];k[D+24>>2]=k[n+24>>2];k[D+28>>2]=k[n+28>>2];k[D+32>>2]=k[n+32>>2];e=k[n+36>>2]|0;k[D+36>>2]=e;m=D+40|0;k[m>>2]=v;v=D+48|0;p=D+44|0;k[p>>2]=v;k[D+52>>2]=0;k[v>>2]=0;if(e|0){v=e+12|0;k[v>>2]=(k[v>>2]|0)+1}if((k[l>>2]|0)<3){u=k[n+44>>2]|0;v=k[p>>2]|0;k[v>>2]=k[u>>2];k[v+4>>2]=k[u+4>>2];break}k[s>>2]=0;x1(D,k[l>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[n+40>>2]|0;o=k[m>>2]|0;m=k[n+44>>2]|0;e=k[p>>2]|0;l=0;do{k[o+(l<<2)>>2]=k[q+(l<<2)>>2];k[e+(l<<2)>>2]=k[m+(l<<2)>>2];l=l+1|0}while((l|0)<(k[s>>2]|0))}}else Q1(D,e,-1);while(0);KG(F,D)|0;m=D+36|0;l=k[m>>2]|0;if(l|0?(u=l+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){e=k[m>>2]|0;if(e|0){l=k[e+4>>2]|0;if(!l){l=k[D+32>>2]|0;if(!l){l=B1()|0;e=k[m>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,e)}k[m>>2]=0}k[m>>2]=0;v=D+16|0;e=D+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[e>>2]|0)>0){m=k[D+40>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[e>>2]|0))}l=k[D+44>>2]|0;if(!((l|0)==(D+48|0)|(l|0)==0))ggb(k[l+-4>>2]|0);k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;oY(F,D);l=k[w>>2]|0;m=k[A>>2]|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=l;k[C+12>>2]=m;I1(D,F,C);KG(f,D)|0;m=D+36|0;l=k[m>>2]|0;if(l|0?(u=l+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){e=k[m>>2]|0;if(e|0){l=k[e+4>>2]|0;if(!l){l=k[D+32>>2]|0;if(!l){l=B1()|0;e=k[m>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,e)}k[m>>2]=0}k[m>>2]=0;v=D+16|0;e=D+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[e>>2]|0)>0){m=k[D+40>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[e>>2]|0))}l=k[D+44>>2]|0;if(!((l|0)==(D+48|0)|(l|0)==0))ggb(k[l+-4>>2]|0);l=k[x>>2]|0;m=k[B>>2]|0;k[C>>2]=k[w>>2];k[C+4>>2]=0;k[C+8>>2]=l;k[C+12>>2]=m;I1(D,F,C);KG(g,D)|0;m=D+36|0;l=k[m>>2]|0;if(l|0?(u=l+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){e=k[m>>2]|0;if(e|0){l=k[e+4>>2]|0;if(!l){l=k[D+32>>2]|0;if(!l){l=B1()|0;e=k[m>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,e)}k[m>>2]=0}k[m>>2]=0;v=D+16|0;e=D+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[e>>2]|0)>0){m=k[D+40>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[e>>2]|0))}l=k[D+44>>2]|0;if(!((l|0)==(D+48|0)|(l|0)==0))ggb(k[l+-4>>2]|0);if(!(S1(a,-1)|0)){v=D+4|0;u=v+4|0;k[u>>2]=0;k[u+4>>2]=0;k[D>>2]=33619968;k[v>>2]=f;$aa(a,D,8,0)}else{v=D+4|0;u=v+4|0;k[u>>2]=0;k[u+4>>2]=0;k[D>>2]=33619968;k[v>>2]=f;I2(a,D)}if(!(S1(c,-1)|0)){f=D+4|0;a=f+4|0;k[a>>2]=0;k[a+4>>2]=0;k[D>>2]=33619968;k[f>>2]=g;$aa(c,D,8,0);break}else{f=D+4|0;a=f+4|0;k[a>>2]=0;k[a+4>>2]=0;k[D>>2]=33619968;k[f>>2]=g;I2(c,D);break}}else{do if((k[e>>2]&2031616|0)==65536){n=k[e+4>>2]|0;k[D>>2]=k[n>>2];s=D+4|0;l=n+4|0;k[s>>2]=k[l>>2];c=D+8|0;k[c>>2]=k[n+8>>2];k[D+12>>2]=k[n+12>>2];k[D+16>>2]=k[n+16>>2];k[D+20>>2]=k[n+20>>2];k[D+24>>2]=k[n+24>>2];k[D+28>>2]=k[n+28>>2];k[D+32>>2]=k[n+32>>2];e=k[n+36>>2]|0;k[D+36>>2]=e;m=D+40|0;k[m>>2]=c;c=D+48|0;p=D+44|0;k[p>>2]=c;k[D+52>>2]=0;k[c>>2]=0;if(e|0){c=e+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[l>>2]|0)<3){a=k[n+44>>2]|0;c=k[p>>2]|0;k[c>>2]=k[a>>2];k[c+4>>2]=k[a+4>>2];break}k[s>>2]=0;x1(D,k[l>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[n+40>>2]|0;o=k[m>>2]|0;m=k[n+44>>2]|0;e=k[p>>2]|0;l=0;do{k[o+(l<<2)>>2]=k[q+(l<<2)>>2];k[e+(l<<2)>>2]=k[m+(l<<2)>>2];l=l+1|0}while((l|0)<(k[s>>2]|0))}}else Q1(D,e,-1);while(0);KG(F,D)|0;m=D+36|0;l=k[m>>2]|0;if(l|0?(a=l+12|0,c=k[a>>2]|0,k[a>>2]=c+-1,(c|0)==1):0){e=k[m>>2]|0;if(e|0){l=k[e+4>>2]|0;if(!l){l=k[D+32>>2]|0;if(!l){l=B1()|0;e=k[m>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,e)}k[m>>2]=0}k[m>>2]=0;c=D+16|0;e=D+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[e>>2]|0)>0){m=k[D+40>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[e>>2]|0))}l=k[D+44>>2]|0;if(!((l|0)==(D+48|0)|(l|0)==0))ggb(k[l+-4>>2]|0);if((u|0)>(k[v>>2]|0)?1:(t|0)>(k[F+12>>2]|0)){k[D>>2]=0;l=D+4|0;k[l>>2]=0;e=ZT(68)|0;k[e>>2]=1;n=e+4|0;k[D>>2]=n;k[l>>2]=61;i[e+65>>0]=0;m=386348;o=n+61|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(o|0));Y8(-201,D,386410,386067,135);k[l>>2]=0;k[D>>2]=0;c=k[e>>2]|0;k[e>>2]=c+-1;if((c|0)==1)ggb(k[e+-4>>2]|0)}l=k[w>>2]|0;m=k[A>>2]|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=l;k[C+12>>2]=m;I1(D,F,C);KG(f,D)|0;m=D+36|0;l=k[m>>2]|0;if(l|0?(c=l+12|0,f=k[c>>2]|0,k[c>>2]=f+-1,(f|0)==1):0){e=k[m>>2]|0;if(e|0){l=k[e+4>>2]|0;if(!l){l=k[D+32>>2]|0;if(!l){l=B1()|0;e=k[m>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,e)}k[m>>2]=0}k[m>>2]=0;f=D+16|0;e=D+4|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[e>>2]|0)>0){m=k[D+40>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[e>>2]|0))}l=k[D+44>>2]|0;if(!((l|0)==(D+48|0)|(l|0)==0))ggb(k[l+-4>>2]|0);l=k[x>>2]|0;m=k[B>>2]|0;k[C>>2]=k[w>>2];k[C+4>>2]=0;k[C+8>>2]=l;k[C+12>>2]=m;I1(D,F,C);KG(g,D)|0;m=D+36|0;l=k[m>>2]|0;if(l|0?(f=l+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){e=k[m>>2]|0;if(e|0){l=k[e+4>>2]|0;if(!l){l=k[D+32>>2]|0;if(!l){l=B1()|0;e=k[m>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,e)}k[m>>2]=0}k[m>>2]=0;g=D+16|0;e=D+4|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[e>>2]|0)>0){m=k[D+40>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[e>>2]|0))}l=k[D+44>>2]|0;if(!((l|0)==(D+48|0)|(l|0)==0))ggb(k[l+-4>>2]|0)}while(0);if(!(j&2)){l=k[w>>2]|0;m=k[A>>2]|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=l;k[C+12>>2]=m;I1(D,F,C);k[C+8>>2]=0;k[C+12>>2]=0;k[C>>2]=16842752;k[C+4>>2]=D;m=y+4|0;l=m+4|0;k[l>>2]=0;k[l+4>>2]=0;k[y>>2]=50397184;k[m>>2]=D;m=j|1;cVa(C,b,y,h,m);j=k[x>>2]|0;l=k[B>>2]|0;k[y>>2]=k[w>>2];k[y+4>>2]=0;k[y+8>>2]=j;k[y+12>>2]=l;I1(C,F,y);k[y+8>>2]=0;k[y+12>>2]=0;k[y>>2]=16842752;k[y+4>>2]=C;l=z+4|0;j=l+4|0;k[j>>2]=0;k[j+4>>2]=0;k[z>>2]=50397184;k[l>>2]=C;cVa(y,d,z,h,m);m=C+36|0;l=k[m>>2]|0;if(l|0?(h=l+12|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){e=k[m>>2]|0;if(e|0){l=k[e+4>>2]|0;if(!l){l=k[C+32>>2]|0;if(!l){l=B1()|0;e=k[m>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,e)}k[m>>2]=0}k[m>>2]=0;j=C+16|0;e=C+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[e>>2]|0)>0){m=k[C+40>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[e>>2]|0))}l=k[C+44>>2]|0;if(!((l|0)==(C+48|0)|(l|0)==0))ggb(k[l+-4>>2]|0);m=D+36|0;l=k[m>>2]|0;if(l|0?(j=l+12|0,C=k[j>>2]|0,k[j>>2]=C+-1,(C|0)==1):0){e=k[m>>2]|0;if(e|0){l=k[e+4>>2]|0;if(!l){l=k[D+32>>2]|0;if(!l){l=B1()|0;e=k[m>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,e)}k[m>>2]=0}k[m>>2]=0;C=D+16|0;e=D+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[e>>2]|0)>0){m=k[D+40>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[e>>2]|0))}l=k[D+44>>2]|0;if(!((l|0)==(D+48|0)|(l|0)==0))ggb(k[l+-4>>2]|0)}m=F+36|0;l=k[m>>2]|0;if(l|0?(C=l+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){e=k[m>>2]|0;if(e|0){l=k[e+4>>2]|0;if(!l){l=k[F+32>>2]|0;if(!l){l=B1()|0;e=k[m>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,e)}k[m>>2]=0}k[m>>2]=0;F=F+16|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[G>>2]|0)>0){e=k[E>>2]|0;l=0;do{k[e+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[G>>2]|0))}l=k[H>>2]|0;if((l|0)==(I|0)|(l|0)==0){r=J;return}ggb(k[l+-4>>2]|0);r=J;return}function fVa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,l=0.0,m=0.0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;x=r;r=r+64|0;w=x;q=x+56|0;s=x+48|0;t=x+40|0;v=x+32|0;i=n9(c9()|0)|0;m=+p[f>>3];h=+p[f+8>>3];l=+p[f+16>>3];if(m==-1.0&h==-1.0)if(l==-1.0){j=+p[f+24>>3];if(j==-1.0){y=i;z=k[y+4>>2]|0;y=Epb(k[y>>2]|0,0,-130063606,0)|0;z=kpb(y|0,N|0,z|0,0)|0;y=N;f=Epb(z|0,0,-130063606,0)|0;y=kpb(f|0,N|0,y|0,0)|0;f=N;A=Epb(y|0,0,-130063606,0)|0;f=kpb(A|0,N|0,f|0,0)|0;k[i>>2]=f;k[i+4>>2]=N;p[w>>3]=+((z&255)>>>0);p[w+8>>3]=+((y&255)>>>0);p[w+16>>3]=+((f&255)>>>0);p[w+24>>3]=0.0}else{h=-1.0;l=-1.0;n=6}}else{h=-1.0;n=3}else n=3;if((n|0)==3){j=+p[f+24>>3];n=6}if((n|0)==6){p[w>>3]=m;p[w+8>>3]=h;p[w+16>>3]=l;p[w+24>>3]=j}dVa(b,d,w,g);dVa(c,e,w,g);h=+o[d>>2];j=+o[d+4>>2];l=+o[e>>2];m=+o[e+4>>2];R1(q,b,-1);l=l+ +(k[q>>2]|0);R1(s,a,-1);B=+((k[s>>2]|0)+-1|0);l=B<l?B:l;h=h*16.0;i=(o[u>>2]=h,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;h=i?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=i?-0.0:0.0}f=~~h;h=j*16.0;i=(o[u>>2]=h,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;h=i?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=i?-0.0:0.0}k[t>>2]=f;k[t+4>>2]=~~h;h=l*16.0;i=(o[u>>2]=h,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;h=i?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=i?-0.0:0.0}f=~~h;h=m*16.0;i=(o[u>>2]=h,k[u>>2]|0);if((i&2130706432)>>>0>1249902592){B=h;z=~~B;k[v>>2]=f;A=v+4|0;k[A>>2]=z;Gfa(a,t,v,w,1,16,4);r=x;return}i=(i|0)<0;h=i?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(!(h==0.0)){B=h;z=~~B;k[v>>2]=f;A=v+4|0;k[A>>2]=z;Gfa(a,t,v,w,1,16,4);r=x;return}B=i?-0.0:0.0;z=~~B;k[v>>2]=f;A=v+4|0;k[A>>2]=z;Gfa(a,t,v,w,1,16,4);r=x;return}function gVa(a){a=a|0;ggb(a);return}function hVa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function iVa(a){a=a|0;return}function jVa(a){a=a|0;ggb(a);return}function kVa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,p=0.0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0;Ta=r;r=r+1936|0;La=Ta+16|0;Ga=Ta+384|0;Ca=Ta+356|0;Da=Ta+256|0;Ea=Ta+1424|0;Fa=Ta+244|0;Ba=Ta+232|0;Sa=Ta+176|0;Ra=Ta+120|0;Na=Ta+72|0;s=Ta;do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[Sa>>2]=k[g>>2];n=Sa+4|0;d=g+4|0;k[n>>2]=k[d>>2];Qa=Sa+8|0;k[Qa>>2]=k[g+8>>2];k[Sa+12>>2]=k[g+12>>2];k[Sa+16>>2]=k[g+16>>2];k[Sa+20>>2]=k[g+20>>2];k[Sa+24>>2]=k[g+24>>2];k[Sa+28>>2]=k[g+28>>2];k[Sa+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Sa+36>>2]=e;f=Sa+40|0;k[f>>2]=Qa;Qa=Sa+48|0;j=Sa+44|0;k[j>>2]=Qa;k[Sa+52>>2]=0;k[Qa>>2]=0;if(e|0){Qa=e+12|0;k[Qa>>2]=(k[Qa>>2]|0)+1}if((k[d>>2]|0)<3){Pa=k[g+44>>2]|0;Qa=k[j>>2]|0;k[Qa>>2]=k[Pa>>2];k[Qa+4>>2]=k[Pa+4>>2];break}k[n>>2]=0;x1(Sa,k[d>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[m+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[n>>2]|0))}}else Q1(Sa,d,-1);while(0);k[Ra>>2]=1124007936;Qa=Ra+4|0;d=Ra+8|0;Oa=Ra+40|0;e=Qa;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[Oa>>2]=d;Pa=Ra+48|0;Ma=Ra+44|0;k[Ma>>2]=Pa;k[Ra+52>>2]=0;k[Pa>>2]=0;k[Na>>2]=1124007936;Ia=Na+4|0;Ha=Na+32|0;k[Ia>>2]=0;k[Ia+4>>2]=0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;k[Ia+16>>2]=0;k[Ia+20>>2]=0;k[Ia+24>>2]=0;k[Ha>>2]=Na+8;Ka=Na+40|0;Ja=Na+36|0;k[Ja>>2]=Ka;k[Na+44>>2]=0;k[Ka>>2]=0;d=b;e=k[d>>2]|0;d=k[d+4>>2]|0;f=s;k[f>>2]=e;k[f+4>>2]=d;f=s+8|0;k[f>>2]=k[b+8>>2];g=s+12|0;k[g>>2]=k[b+12>>2];if(S1(b,-1)|0){Aa=(k[b>>2]&2031616|0)==655360;d=La+4|0;Z=d+4|0;k[Z>>2]=0;k[Z+4>>2]=0;if(Aa){k[La>>2]=34209792;k[d>>2]=Na}else{k[La>>2]=33619968;k[d>>2]=Ra}$aa(b,La,6,0);d=La;e=k[d>>2]|0;d=k[d+4>>2]|0;Aa=s;k[Aa>>2]=e;k[Aa+4>>2]=d;k[f>>2]=k[La+8>>2];k[g>>2]=k[La+12>>2]}b=d;t=k[a+4>>2]|0;Aa=(i[a+8>>0]|0)!=0;switch(k[a+12>>2]|0){case 0:{do if((e&2031616|0)==65536){k[La>>2]=k[b>>2];m=La+4|0;d=b+4|0;k[m>>2]=k[d>>2];n=La+8|0;k[n>>2]=k[b+8>>2];k[La+12>>2]=k[b+12>>2];k[La+16>>2]=k[b+16>>2];k[La+20>>2]=k[b+20>>2];k[La+24>>2]=k[b+24>>2];k[La+28>>2]=k[b+28>>2];k[La+32>>2]=k[b+32>>2];e=k[b+36>>2]|0;k[La+36>>2]=e;f=La+40|0;k[f>>2]=n;n=La+48|0;h=La+44|0;k[h>>2]=n;k[La+52>>2]=0;k[n>>2]=0;if(e|0){ma=e+12|0;k[ma>>2]=(k[ma>>2]|0)+1}if((k[d>>2]|0)<3){la=k[b+44>>2]|0;ma=k[h>>2]|0;k[ma>>2]=k[la>>2];k[ma+4>>2]=k[la+4>>2];break}k[m>>2]=0;x1(La,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[b+40>>2]|0;g=k[f>>2]|0;f=k[b+44>>2]|0;e=k[h>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else{Q1(La,s,-1);n=La+48|0}while(0);rVa(Da,k[n>>2]|0,8);d=k[c>>2]|0;ca=c+4|0;e=k[ca>>2]|0;if((e|0)!=(d|0))k[ca>>2]=e+(~(((e+-28-d|0)>>>0)/28|0)*28|0);ba=(t|0)<0?0:t;ba=(ba|0)>255?255:ba;e=0-ba|0;d=-255;do{i[Ea+(d+255)>>0]=(d|0)<(e|0)?1:(d|0)>(ba|0)?2:0;d=d+1|0}while((d|0)!=256);Z=La+12|0;f=k[Z>>2]|0;e=(f*15|0)+368|0;_=Ga+8|0;k[Ga>>2]=_;$=Ga+4|0;k[$>>2]=1032;if(e>>>0>1032){while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[Ga>>2]=d}else d=_;k[$>>2]=e;k[Fa>>2]=d;Y=d+f|0;k[Fa+4>>2]=Y;Y=Y+f|0;k[Fa+8>>2]=Y;Y=(Y+f+3&-4)+4|0;k[Ba>>2]=Y;Y=Y+(f<<2)+4|0;k[Ba+4>>2]=Y;k[Ba+8>>2]=Y+(f<<2)+4;zpb(d|0,0,f*3|0)|0;Y=La+8|0;if(((k[Y>>2]|0)+-2|0)>3){A=La+16|0;B=La+44|0;C=Da+32|0;D=Da+8|0;E=Da+40|0;F=Da+16|0;G=Da+48|0;H=Da+24|0;I=Da+56|0;J=Da+4|0;K=Da+36|0;L=Da+12|0;M=Da+44|0;N=Da+20|0;O=Da+52|0;P=Da+28|0;Q=Da+60|0;R=Ca+4|0;S=Ca+8|0;T=Ca+12|0;U=Ca+16|0;V=Ca+20|0;W=Ca+24|0;X=c+8|0;d=3;e=f;while(1){f=k[A>>2]|0;g=k[k[B>>2]>>2]|0;y=(d+-3|0)%3|0;z=k[Fa+(y<<2)>>2]|0;y=k[Ba+(y<<2)>>2]|0;zpb(z|0,0,e|0)|0;if((d|0)<((k[Y>>2]|0)+-3|0)?((k[Z>>2]|0)+-3|0)>3:0){x=3;w=f+(aa(g,d)|0)+3|0;e=0;while(1){v=l[w>>0]|0;g=Ea+(0-v)+255|0;j=l[w+(k[Da>>2]|0)>>0]|0;a=l[w+(k[C>>2]|0)>>0]|0;f=i[g+a>>0]|i[g+j>>0];a:do if(f<<24>>24!=0?(na=l[w+(k[D>>2]|0)>>0]|0,oa=l[w+(k[E>>2]|0)>>0]|0,pa=l[w+(k[F>>2]|0)>>0]|0,qa=l[w+(k[G>>2]|0)>>0]|0,ra=l[w+(k[H>>2]|0)>>0]|0,sa=(i[g+oa>>0]|i[g+na>>0])&f&(i[g+qa>>0]|i[g+pa>>0])&(i[g+(l[w+(k[I>>2]|0)>>0]|0)>>0]|i[g+ra>>0]),sa<<24>>24!=0):0){f=l[w+(k[J>>2]|0)>>0]|0;s=l[w+(k[K>>2]|0)>>0]|0;h=l[w+(k[L>>2]|0)>>0]|0;t=l[w+(k[M>>2]|0)>>0]|0;m=l[w+(k[N>>2]|0)>>0]|0;b=l[w+(k[P>>2]|0)>>0]|0;u=(i[g+s>>0]|i[g+f>>0])&sa&(i[g+t>>0]|i[g+h>>0])&(i[g+(l[w+(k[O>>2]|0)>>0]|0)>>0]|i[g+m>>0])&(i[g+(l[w+(k[Q>>2]|0)>>0]|0)>>0]|i[g+b>>0])&255;b:do if(u&1){g=v-ba|0;f=(h|0)<(g|0)?((na|0)<(g|0)?((f|0)<(g|0)?((j|0)<(g|0)?4:3):2):1):0;if((pa|0)<(g|0)){if(f>>>0<=3){f=f+1|0;za=91}}else{f=0;za=91}do if((za|0)==91){za=0;if((m|0)<(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if((ra|0)<(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if((b|0)<(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if((a|0)<(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if((s|0)<(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if((oa|0)<(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if((t|0)>=(g|0))break b;if((f|0)>3)break;if(!((qa|0)<(g|0)&(f|0)==3))break b}while(0);f=e+1|0;k[y+(e<<2)>>2]=x;if(Aa){e=(uVa(w,Da,ba)|0)&255;i[z+x>>0]=e;e=f}else e=f}while(0);if(u&2){g=ba+v|0;f=(l[w+(k[L>>2]|0)>>0]|0)>(g|0)?((l[w+(k[D>>2]|0)>>0]|0)>(g|0)?((l[w+(k[J>>2]|0)>>0]|0)>(g|0)?((l[w+(k[Da>>2]|0)>>0]|0)>(g|0)?4:3):2):1):0;if((l[w+(k[F>>2]|0)>>0]|0)>(g|0)){if(f>>>0<=3){f=f+1|0;za=107}}else{f=0;za=107}do if((za|0)==107){za=0;if((l[w+(k[N>>2]|0)>>0]|0)>(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if((l[w+(k[H>>2]|0)>>0]|0)>(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if((l[w+(k[P>>2]|0)>>0]|0)>(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if((l[w+(k[C>>2]|0)>>0]|0)>(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if((l[w+(k[K>>2]|0)>>0]|0)>(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if((l[w+(k[E>>2]|0)>>0]|0)>(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if((l[w+(k[M>>2]|0)>>0]|0)>(g|0))if((f|0)>3)break;else f=f+1|0;else f=0;if(!((f|0)>3?(l[w+(k[G>>2]|0)>>0]|0)>(g|0):0))break a}while(0);f=e+1|0;k[y+(e<<2)>>2]=x;if(Aa){e=(uVa(w,Da,ba)|0)&255;i[z+x>>0]=e;e=f}else e=f}}while(0);x=x+1|0;if((x|0)>=((k[Z>>2]|0)+-3|0))break;else w=w+1|0}}else e=0;k[y+-4>>2]=e;c:do if((d|0)!=3?(ta=d+-1|0,wa=(ta|0)%3|0,ua=k[Fa+(wa<<2)>>2]|0,va=k[Fa+(((d+-2|0)%3|0)<<2)>>2]|0,wa=k[Ba+(wa<<2)>>2]|0,xa=k[wa+-4>>2]|0,(xa|0)>0):0){q=+(ta|0);if(Aa)h=0;else{e=0;while(1){f=k[wa+(e<<2)>>2]|0;p=+(f|0);Ua=+(l[ua+f>>0]|0);o[Ca>>2]=p;o[R>>2]=q;o[S>>2]=7.0;o[T>>2]=-1.0;o[U>>2]=Ua;k[V>>2]=0;k[W>>2]=-1;f=k[ca>>2]|0;if((f|0)==(k[X>>2]|0))H6(c,Ca);else{o[f>>2]=p;o[f+4>>2]=q;ma=f+8|0;k[ma>>2]=k[S>>2];k[ma+4>>2]=k[S+4>>2];k[ma+8>>2]=k[S+8>>2];k[ma+12>>2]=k[S+12>>2];k[ma+16>>2]=k[S+16>>2];k[ca>>2]=(k[ca>>2]|0)+28}e=e+1|0;if((e|0)>=(xa|0))break c}}do{e=k[wa+(h<<2)>>2]|0;g=i[ua+e>>0]|0;f=e+1|0;do if((((g&255)>(l[ua+f>>0]|0)?(ya=e+-1|0,(g&255)>(l[ua+ya>>0]|0)):0)?(g&255)>(l[va+ya>>0]|0):0)?(g&255)>(l[va+e>>0]|0):0){if((g&255)<=(l[va+f>>0]|0))break;if((g&255)<=(l[z+ya>>0]|0))break;if((g&255)<=(l[z+e>>0]|0))break;if((g&255)<=(l[z+f>>0]|0))break;p=+(e|0);o[Ca>>2]=p;o[R>>2]=q;o[S>>2]=7.0;o[T>>2]=-1.0;o[U>>2]=+(g&255);k[V>>2]=0;k[W>>2]=-1;e=k[ca>>2]|0;if((e|0)==(k[X>>2]|0))H6(c,Ca);else{o[e>>2]=p;o[e+4>>2]=q;ma=e+8|0;k[ma>>2]=k[S>>2];k[ma+4>>2]=k[S+4>>2];k[ma+8>>2]=k[S+8>>2];k[ma+12>>2]=k[S+12>>2];k[ma+16>>2]=k[S+16>>2];k[ca>>2]=(k[ca>>2]|0)+28}}while(0);h=h+1|0}while((h|0)<(xa|0))}while(0);d=d+1|0;if((d|0)>=((k[Y>>2]|0)+-2|0))break;e=k[Z>>2]|0}d=k[Ga>>2]|0}if((d|0)!=(_|0)){if(d|0)ggb(d);k[Ga>>2]=_;k[$>>2]=1032}f=La+36|0;d=k[f>>2]|0;if(d|0?(Fa=d+12|0,Ga=k[Fa>>2]|0,k[Fa>>2]=Ga+-1,(Ga|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[La+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;Ga=La+16|0;e=La+4|0;k[Ga>>2]=0;k[Ga+4>>2]=0;k[Ga+8>>2]=0;k[Ga+12>>2]=0;if((k[e>>2]|0)>0){f=k[La+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[La+44>>2]|0;if(!((d|0)==(n|0)|(d|0)==0))ggb(k[d+-4>>2]|0);break}case 1:{do if((e&2031616|0)==65536){k[La>>2]=k[b>>2];m=La+4|0;d=b+4|0;k[m>>2]=k[d>>2];n=La+8|0;k[n>>2]=k[b+8>>2];k[La+12>>2]=k[b+12>>2];k[La+16>>2]=k[b+16>>2];k[La+20>>2]=k[b+20>>2];k[La+24>>2]=k[b+24>>2];k[La+28>>2]=k[b+28>>2];k[La+32>>2]=k[b+32>>2];e=k[b+36>>2]|0;k[La+36>>2]=e;f=La+40|0;k[f>>2]=n;n=La+48|0;h=La+44|0;k[h>>2]=n;k[La+52>>2]=0;k[n>>2]=0;if(e|0){za=e+12|0;k[za>>2]=(k[za>>2]|0)+1}if((k[d>>2]|0)<3){ya=k[b+44>>2]|0;za=k[h>>2]|0;k[za>>2]=k[ya>>2];k[za+4>>2]=k[ya+4>>2];break}k[m>>2]=0;x1(La,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[b+40>>2]|0;g=k[f>>2]|0;f=k[b+44>>2]|0;e=k[h>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else{Q1(La,s,-1);n=La+48|0}while(0);rVa(Da,k[n>>2]|0,12);d=k[c>>2]|0;Z=c+4|0;e=k[Z>>2]|0;if((e|0)!=(d|0))k[Z>>2]=e+(~(((e+-28-d|0)>>>0)/28|0)*28|0);Y=(t|0)<0?0:t;Y=(Y|0)>255?255:Y;e=0-Y|0;d=-255;do{i[Ea+(d+255)>>0]=(d|0)<(e|0)?1:(d|0)>(Y|0)?2:0;d=d+1|0}while((d|0)!=256);V=La+12|0;f=k[V>>2]|0;e=(f*15|0)+368|0;W=Ga+8|0;k[Ga>>2]=W;X=Ga+4|0;k[X>>2]=1032;if(e>>>0>1032){while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[Ga>>2]=d}else d=W;k[X>>2]=e;k[Fa>>2]=d;U=d+f|0;k[Fa+4>>2]=U;U=U+f|0;k[Fa+8>>2]=U;U=(U+f+3&-4)+4|0;k[Ba>>2]=U;U=U+(f<<2)+4|0;k[Ba+4>>2]=U;k[Ba+8>>2]=U+(f<<2)+4;zpb(d|0,0,f*3|0)|0;U=La+8|0;if(((k[U>>2]|0)+-2|0)>3){w=La+16|0;x=La+44|0;y=Da+32|0;z=Da+8|0;A=Da+40|0;B=Da+16|0;C=Da+48|0;D=Da+24|0;E=Da+56|0;F=Da+4|0;G=Da+36|0;H=Da+12|0;I=Da+44|0;J=Da+20|0;K=Da+52|0;L=Da+28|0;M=Da+60|0;N=Ca+4|0;O=Ca+8|0;P=Ca+12|0;Q=Ca+16|0;R=Ca+20|0;S=Ca+24|0;T=c+8|0;d=3;e=f;while(1){f=k[w>>2]|0;g=k[k[x>>2]>>2]|0;u=(d+-3|0)%3|0;v=k[Fa+(u<<2)>>2]|0;u=k[Ba+(u<<2)>>2]|0;zpb(v|0,0,e|0)|0;if((d|0)<((k[U>>2]|0)+-3|0)?((k[V>>2]|0)+-3|0)>3:0){t=3;s=f+(aa(g,d)|0)+3|0;e=0;while(1){a=l[s>>0]|0;f=Ea+(0-a)+255|0;h=i[s+(k[Da>>2]|0)>>0]|0;g=i[f+(l[s+(k[y>>2]|0)>>0]|0)>>0]|i[f+(h&255)>>0];d:do if(g<<24>>24!=0?(ma=(i[f+(l[s+(k[A>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[z>>2]|0)>>0]|0)>>0])&g&(i[f+(l[s+(k[C>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[B>>2]|0)>>0]|0)>>0])&(i[f+(l[s+(k[E>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[D>>2]|0)>>0]|0)>>0]),ma<<24>>24!=0):0){b=(i[f+(l[s+(k[G>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[F>>2]|0)>>0]|0)>>0])&ma&(i[f+(l[s+(k[I>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[H>>2]|0)>>0]|0)>>0])&(i[f+(l[s+(k[K>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[J>>2]|0)>>0]|0)>>0])&(i[f+(l[s+(k[M>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[L>>2]|0)>>0]|0)>>0])&255;e:do if(b&1){m=a-Y|0;j=0;f=0;g=h;while(1){if((g&255|0)<(m|0))if((f|0)>5)break;else f=f+1|0;else f=0;g=j+1|0;if((g|0)>=19)break e;j=g;g=i[s+(k[Da+(g<<2)>>2]|0)>>0]|0}f=e+1|0;k[u+(e<<2)>>2]=t;if(Aa){e=(tVa(s,Da,Y)|0)&255;i[v+t>>0]=e;e=f}else e=f}while(0);if(b&2){h=Y+a|0;f=0;g=0;while(1){if((l[s+(k[Da+(g<<2)>>2]|0)>>0]|0)>(h|0))if((f|0)>5)break;else f=f+1|0;else f=0;g=g+1|0;if((g|0)>=19)break d}f=e+1|0;k[u+(e<<2)>>2]=t;if(Aa){e=(tVa(s,Da,Y)|0)&255;i[v+t>>0]=e;e=f}else e=f}}while(0);t=t+1|0;if((t|0)>=((k[V>>2]|0)+-3|0))break;else s=s+1|0}}else e=0;k[u+-4>>2]=e;f:do if((d|0)!=3?(_=d+-1|0,ca=(_|0)%3|0,$=k[Fa+(ca<<2)>>2]|0,ba=k[Fa+(((d+-2|0)%3|0)<<2)>>2]|0,ca=k[Ba+(ca<<2)>>2]|0,da=k[ca+-4>>2]|0,(da|0)>0):0){q=+(_|0);if(Aa)h=0;else{e=0;while(1){f=k[ca+(e<<2)>>2]|0;p=+(f|0);Ua=+(l[$+f>>0]|0);o[Ca>>2]=p;o[N>>2]=q;o[O>>2]=7.0;o[P>>2]=-1.0;o[Q>>2]=Ua;k[R>>2]=0;k[S>>2]=-1;f=k[Z>>2]|0;if((f|0)==(k[T>>2]|0))H6(c,Ca);else{o[f>>2]=p;o[f+4>>2]=q;za=f+8|0;k[za>>2]=k[O>>2];k[za+4>>2]=k[O+4>>2];k[za+8>>2]=k[O+8>>2];k[za+12>>2]=k[O+12>>2];k[za+16>>2]=k[O+16>>2];k[Z>>2]=(k[Z>>2]|0)+28}e=e+1|0;if((e|0)>=(da|0))break f}}do{e=k[ca+(h<<2)>>2]|0;g=i[$+e>>0]|0;f=e+1|0;do if((((g&255)>(l[$+f>>0]|0)?(ea=e+-1|0,(g&255)>(l[$+ea>>0]|0)):0)?(g&255)>(l[ba+ea>>0]|0):0)?(g&255)>(l[ba+e>>0]|0):0){if((g&255)<=(l[ba+f>>0]|0))break;if((g&255)<=(l[v+ea>>0]|0))break;if((g&255)<=(l[v+e>>0]|0))break;if((g&255)<=(l[v+f>>0]|0))break;p=+(e|0);o[Ca>>2]=p;o[N>>2]=q;o[O>>2]=7.0;o[P>>2]=-1.0;o[Q>>2]=+(g&255);k[R>>2]=0;k[S>>2]=-1;e=k[Z>>2]|0;if((e|0)==(k[T>>2]|0))H6(c,Ca);else{o[e>>2]=p;o[e+4>>2]=q;za=e+8|0;k[za>>2]=k[O>>2];k[za+4>>2]=k[O+4>>2];k[za+8>>2]=k[O+8>>2];k[za+12>>2]=k[O+12>>2];k[za+16>>2]=k[O+16>>2];k[Z>>2]=(k[Z>>2]|0)+28}}while(0);h=h+1|0}while((h|0)<(da|0))}while(0);d=d+1|0;if((d|0)>=((k[U>>2]|0)+-2|0))break;e=k[V>>2]|0}d=k[Ga>>2]|0}if((d|0)!=(W|0)){if(d|0)ggb(d);k[Ga>>2]=W;k[X>>2]=1032}f=La+36|0;d=k[f>>2]|0;if(d|0?(Fa=d+12|0,Ga=k[Fa>>2]|0,k[Fa>>2]=Ga+-1,(Ga|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[La+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;Ga=La+16|0;e=La+4|0;k[Ga>>2]=0;k[Ga+4>>2]=0;k[Ga+8>>2]=0;k[Ga+12>>2]=0;if((k[e>>2]|0)>0){f=k[La+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[La+44>>2]|0;if(!((d|0)==(n|0)|(d|0)==0))ggb(k[d+-4>>2]|0);break}case 2:{do if((e&2031616|0)==65536){k[La>>2]=k[b>>2];m=La+4|0;d=b+4|0;k[m>>2]=k[d>>2];n=La+8|0;k[n>>2]=k[b+8>>2];k[La+12>>2]=k[b+12>>2];k[La+16>>2]=k[b+16>>2];k[La+20>>2]=k[b+20>>2];k[La+24>>2]=k[b+24>>2];k[La+28>>2]=k[b+28>>2];k[La+32>>2]=k[b+32>>2];e=k[b+36>>2]|0;k[La+36>>2]=e;f=La+40|0;k[f>>2]=n;n=La+48|0;h=La+44|0;k[h>>2]=n;k[La+52>>2]=0;k[n>>2]=0;if(e|0){za=e+12|0;k[za>>2]=(k[za>>2]|0)+1}if((k[d>>2]|0)<3){ya=k[b+44>>2]|0;za=k[h>>2]|0;k[za>>2]=k[ya>>2];k[za+4>>2]=k[ya+4>>2];break}k[m>>2]=0;x1(La,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[b+40>>2]|0;g=k[f>>2]|0;f=k[b+44>>2]|0;e=k[h>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else{Q1(La,s,-1);n=La+48|0}while(0);rVa(Da,k[n>>2]|0,16);d=k[c>>2]|0;Z=c+4|0;e=k[Z>>2]|0;if((e|0)!=(d|0))k[Z>>2]=e+(~(((e+-28-d|0)>>>0)/28|0)*28|0);Y=(t|0)<0?0:t;Y=(Y|0)>255?255:Y;e=0-Y|0;d=-255;do{i[Ea+(d+255)>>0]=(d|0)<(e|0)?1:(d|0)>(Y|0)?2:0;d=d+1|0}while((d|0)!=256);V=La+12|0;f=k[V>>2]|0;e=(f*15|0)+368|0;W=Ga+8|0;k[Ga>>2]=W;X=Ga+4|0;k[X>>2]=1032;if(e>>>0>1032){while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[Ga>>2]=d}else d=W;k[X>>2]=e;k[Fa>>2]=d;U=d+f|0;k[Fa+4>>2]=U;U=U+f|0;k[Fa+8>>2]=U;U=(U+f+3&-4)+4|0;k[Ba>>2]=U;U=U+(f<<2)+4|0;k[Ba+4>>2]=U;k[Ba+8>>2]=U+(f<<2)+4;zpb(d|0,0,f*3|0)|0;U=La+8|0;if(((k[U>>2]|0)+-2|0)>3){w=La+16|0;x=La+44|0;y=Da+32|0;z=Da+8|0;A=Da+40|0;B=Da+16|0;C=Da+48|0;D=Da+24|0;E=Da+56|0;F=Da+4|0;G=Da+36|0;H=Da+12|0;I=Da+44|0;J=Da+20|0;K=Da+52|0;L=Da+28|0;M=Da+60|0;N=Ca+4|0;O=Ca+8|0;P=Ca+12|0;Q=Ca+16|0;R=Ca+20|0;S=Ca+24|0;T=c+8|0;d=3;e=f;while(1){f=k[w>>2]|0;g=k[k[x>>2]>>2]|0;u=(d+-3|0)%3|0;v=k[Fa+(u<<2)>>2]|0;u=k[Ba+(u<<2)>>2]|0;zpb(v|0,0,e|0)|0;if((d|0)<((k[U>>2]|0)+-3|0)?((k[V>>2]|0)+-3|0)>3:0){t=3;s=f+(aa(g,d)|0)+3|0;e=0;while(1){a=l[s>>0]|0;f=Ea+(0-a)+255|0;h=i[s+(k[Da>>2]|0)>>0]|0;g=i[f+(l[s+(k[y>>2]|0)>>0]|0)>>0]|i[f+(h&255)>>0];g:do if(g<<24>>24!=0?(fa=(i[f+(l[s+(k[A>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[z>>2]|0)>>0]|0)>>0])&g&(i[f+(l[s+(k[C>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[B>>2]|0)>>0]|0)>>0])&(i[f+(l[s+(k[E>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[D>>2]|0)>>0]|0)>>0]),fa<<24>>24!=0):0){b=(i[f+(l[s+(k[G>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[F>>2]|0)>>0]|0)>>0])&fa&(i[f+(l[s+(k[I>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[H>>2]|0)>>0]|0)>>0])&(i[f+(l[s+(k[K>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[J>>2]|0)>>0]|0)>>0])&(i[f+(l[s+(k[M>>2]|0)>>0]|0)>>0]|i[f+(l[s+(k[L>>2]|0)>>0]|0)>>0])&255;h:do if(b&1){m=a-Y|0;j=0;f=0;g=h;while(1){if((g&255|0)<(m|0))if((f|0)>7)break;else f=f+1|0;else f=0;g=j+1|0;if((g|0)>=25)break h;j=g;g=i[s+(k[Da+(g<<2)>>2]|0)>>0]|0}f=e+1|0;k[u+(e<<2)>>2]=t;if(Aa){e=(sVa(s,Da,Y)|0)&255;i[v+t>>0]=e;e=f}else e=f}while(0);if(b&2){h=Y+a|0;f=0;g=0;while(1){if((l[s+(k[Da+(g<<2)>>2]|0)>>0]|0)>(h|0))if((f|0)>7)break;else f=f+1|0;else f=0;g=g+1|0;if((g|0)>=25)break g}f=e+1|0;k[u+(e<<2)>>2]=t;if(Aa){e=(sVa(s,Da,Y)|0)&255;i[v+t>>0]=e;e=f}else e=f}}while(0);t=t+1|0;if((t|0)>=((k[V>>2]|0)+-3|0))break;else s=s+1|0}}else e=0;k[u+-4>>2]=e;i:do if((d|0)!=3?(ga=d+-1|0,ja=(ga|0)%3|0,ha=k[Fa+(ja<<2)>>2]|0,ia=k[Fa+(((d+-2|0)%3|0)<<2)>>2]|0,ja=k[Ba+(ja<<2)>>2]|0,ka=k[ja+-4>>2]|0,(ka|0)>0):0){q=+(ga|0);if(Aa)h=0;else{e=0;while(1){f=k[ja+(e<<2)>>2]|0;p=+(f|0);Ua=+(l[ha+f>>0]|0);o[Ca>>2]=p;o[N>>2]=q;o[O>>2]=7.0;o[P>>2]=-1.0;o[Q>>2]=Ua;k[R>>2]=0;k[S>>2]=-1;f=k[Z>>2]|0;if((f|0)==(k[T>>2]|0))H6(c,Ca);else{o[f>>2]=p;o[f+4>>2]=q;za=f+8|0;k[za>>2]=k[O>>2];k[za+4>>2]=k[O+4>>2];k[za+8>>2]=k[O+8>>2];k[za+12>>2]=k[O+12>>2];k[za+16>>2]=k[O+16>>2];k[Z>>2]=(k[Z>>2]|0)+28}e=e+1|0;if((e|0)>=(ka|0))break i}}do{e=k[ja+(h<<2)>>2]|0;g=i[ha+e>>0]|0;f=e+1|0;do if((((g&255)>(l[ha+f>>0]|0)?(la=e+-1|0,(g&255)>(l[ha+la>>0]|0)):0)?(g&255)>(l[ia+la>>0]|0):0)?(g&255)>(l[ia+e>>0]|0):0){if((g&255)<=(l[ia+f>>0]|0))break;if((g&255)<=(l[v+la>>0]|0))break;if((g&255)<=(l[v+e>>0]|0))break;if((g&255)<=(l[v+f>>0]|0))break;p=+(e|0);o[Ca>>2]=p;o[N>>2]=q;o[O>>2]=7.0;o[P>>2]=-1.0;o[Q>>2]=+(g&255);k[R>>2]=0;k[S>>2]=-1;e=k[Z>>2]|0;if((e|0)==(k[T>>2]|0))H6(c,Ca);else{o[e>>2]=p;o[e+4>>2]=q;za=e+8|0;k[za>>2]=k[O>>2];k[za+4>>2]=k[O+4>>2];k[za+8>>2]=k[O+8>>2];k[za+12>>2]=k[O+12>>2];k[za+16>>2]=k[O+16>>2];k[Z>>2]=(k[Z>>2]|0)+28}}while(0);h=h+1|0}while((h|0)<(ka|0))}while(0);d=d+1|0;if((d|0)>=((k[U>>2]|0)+-2|0))break;e=k[V>>2]|0}d=k[Ga>>2]|0}if((d|0)!=(W|0)){if(d|0)ggb(d);k[Ga>>2]=W;k[X>>2]=1032}f=La+36|0;d=k[f>>2]|0;if(d|0?(Fa=d+12|0,Ga=k[Fa>>2]|0,k[Fa>>2]=Ga+-1,(Ga|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[La+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;Ga=La+16|0;e=La+4|0;k[Ga>>2]=0;k[Ga+4>>2]=0;k[Ga+8>>2]=0;k[Ga+12>>2]=0;if((k[e>>2]|0)>0){f=k[La+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[La+44>>2]|0;if(!((d|0)==(n|0)|(d|0)==0))ggb(k[d+-4>>2]|0);break}default:{}}dXa(c,Sa);f=Na+24|0;d=k[f>>2]|0;if(d|0?(Na=d+8|0,c=k[Na>>2]|0,k[Na>>2]=c+-1,(c|0)==1):0){c=k[f>>2]|0;Na=k[c+4>>2]|0;jh[k[(k[Na>>2]|0)+16>>2]&1023](Na,c);k[f>>2]=0}if((k[Ia>>2]|0)>0){e=k[Ha>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Ia>>2]|0))}k[f>>2]=0;d=k[Ja>>2]|0;if(!((d|0)==(Ka|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=Ra+36|0;d=k[f>>2]|0;if(d|0?(Na=d+12|0,c=k[Na>>2]|0,k[Na>>2]=c+-1,(c|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[Ra+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;Ra=Ra+16|0;k[Ra>>2]=0;k[Ra+4>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;if((k[Qa>>2]|0)>0){e=k[Oa>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Qa>>2]|0))}d=k[Ma>>2]|0;if(!((d|0)==(Pa|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=Sa+36|0;d=k[f>>2]|0;if(d|0?(Qa=d+12|0,Ra=k[Qa>>2]|0,k[Qa>>2]=Ra+-1,(Ra|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[Sa+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;Ra=Sa+16|0;e=Sa+4|0;k[Ra>>2]=0;k[Ra+4>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;if((k[e>>2]|0)>0){f=k[Sa+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[Sa+44>>2]|0;if((d|0)==(Sa+48|0)|(d|0)==0){r=Ta;return}ggb(k[d+-4>>2]|0);r=Ta;return}function lVa(a,b){a=a|0;b=b|0;k[a+4>>2]=b;return}function mVa(a){a=a|0;return k[a+4>>2]|0}function nVa(a,b){a=a|0;b=b|0;i[a+8>>0]=b&1;return}function oVa(a){a=a|0;return (i[a+8>>0]|0)!=0|0}function pVa(a,b){a=a|0;b=b|0;k[a+12>>2]=b;return}function qVa(a){a=a|0;return k[a+12>>2]|0}function rVa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;f=m;if((c|0)!=16)if((c|0)==12)l=141836;else l=(c|0)==8?141644:0;else l=141708;if(!((a|0)!=0&(l|0)!=0)){d=f+4|0;e=ZT(24)|0;k[e>>2]=1;g=e+4|0;k[f>>2]=g;k[d>>2]=16;i[e+20>>0]=0;h=386554;j=g+16|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,f,386571,386583,74);k[d>>2]=0;k[f>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0)}if((c|0)>0){d=0;do{j=(aa(k[l+(d<<3)+4>>2]|0,b)|0)+(k[l+(d<<3)>>2]|0)|0;k[a+(d<<2)>>2]=j;d=d+1|0}while((d|0)!=(c|0));if((c|0)<25)d=c;else{r=m;return}}else d=0;do{k[a+(d<<2)>>2]=k[a+(d-c<<2)>>2];d=d+1|0}while((d|0)!=25);r=m;return}function sVa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=r;r=r+64|0;g=h;e=l[a>>0]|0;d=0;do{j[g+(d<<1)>>1]=e-(l[a+(k[b+(d<<2)>>2]|0)>>0]|0);d=d+1|0}while((d|0)!=25);b=0;do{a=j[g+((b|1)<<1)>>1]|0;d=b;b=b+2|0;f=j[g+(b<<1)>>1]|0;a=(f|0)<(a|0)?f:a;f=j[g+(d+3<<1)>>1]|0;a=(f|0)<(a|0)?f:a;if((a|0)>(c|0)){f=j[g+(d+4<<1)>>1]|0;f=(f|0)<(a|0)?f:a;e=j[g+(d+5<<1)>>1]|0;f=(e|0)<(f|0)?e:f;e=j[g+(d+6<<1)>>1]|0;f=(e|0)<(f|0)?e:f;e=j[g+(d+7<<1)>>1]|0;f=(e|0)<(f|0)?e:f;e=j[g+(d+8<<1)>>1]|0;f=(e|0)<(f|0)?e:f;e=j[g+(d<<1)>>1]|0;e=(e|0)<(f|0)?e:f;c=(c|0)<(e|0)?e:c;e=j[g+(d+9<<1)>>1]|0;f=(e|0)<(f|0)?e:f;c=(c|0)<(f|0)?f:c}}while((b|0)<16);c=0-c|0;b=0;e=j[g+4>>1]|0;f=j[g+6>>1]|0;do{a=j[g+((b|1)<<1)>>1]|0;d=b;b=b+2|0;i=e<<16>>16;a=(a|0)<(i|0)?i:a;i=f<<16>>16;a=(a|0)<(i|0)?i:a;e=j[g+(d+4<<1)>>1]|0;i=e<<16>>16;a=(a|0)<(i|0)?i:a;f=j[g+(d+5<<1)>>1]|0;i=f<<16>>16;a=(a|0)<(i|0)?i:a;if((a|0)<(c|0)){i=j[g+(d+6<<1)>>1]|0;i=(a|0)<(i|0)?i:a;a=j[g+(d+7<<1)>>1]|0;i=(i|0)<(a|0)?a:i;a=j[g+(d+8<<1)>>1]|0;i=(i|0)<(a|0)?a:i;a=j[g+(d<<1)>>1]|0;a=(i|0)<(a|0)?a:i;c=(a|0)<(c|0)?a:c;a=j[g+(d+9<<1)>>1]|0;i=(i|0)<(a|0)?a:i;c=(i|0)<(c|0)?i:c}}while((b|0)<16);r=h;return ~c|0}function tVa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;g=r;r=r+48|0;f=g;e=l[a>>0]|0;d=0;do{j[f+(d<<1)>>1]=e-(l[a+(k[b+(d<<2)>>2]|0)>>0]|0);d=d+1|0}while((d|0)!=19);b=0;do{a=j[f+((b|1)<<1)>>1]|0;d=b;b=b+2|0;e=j[f+(b<<1)>>1]|0;a=(e|0)<(a|0)?e:a;if((a|0)>(c|0)){e=j[f+(d+3<<1)>>1]|0;e=(e|0)<(a|0)?e:a;a=j[f+(d+4<<1)>>1]|0;e=(a|0)<(e|0)?a:e;a=j[f+(d+5<<1)>>1]|0;e=(a|0)<(e|0)?a:e;a=j[f+(d+6<<1)>>1]|0;e=(a|0)<(e|0)?a:e;a=j[f+(d<<1)>>1]|0;a=(a|0)<(e|0)?a:e;c=(c|0)<(a|0)?a:c;a=j[f+(d+7<<1)>>1]|0;e=(a|0)<(e|0)?a:e;c=(c|0)<(e|0)?e:c}}while((b|0)<12);c=0-c|0;b=0;e=j[f+4>>1]|0;do{a=j[f+((b|1)<<1)>>1]|0;d=b;b=b+2|0;h=e<<16>>16;a=(a|0)<(h|0)?h:a;h=j[f+(d+3<<1)>>1]|0;a=(a|0)<(h|0)?h:a;e=j[f+(d+4<<1)>>1]|0;h=e<<16>>16;a=(a|0)<(h|0)?h:a;if((a|0)<(c|0)){h=j[f+(d+5<<1)>>1]|0;h=(a|0)<(h|0)?h:a;a=j[f+(d+6<<1)>>1]|0;h=(h|0)<(a|0)?a:h;a=j[f+(d<<1)>>1]|0;a=(h|0)<(a|0)?a:h;c=(a|0)<(c|0)?a:c;a=j[f+(d+7<<1)>>1]|0;h=(h|0)<(a|0)?a:h;c=(h|0)<(c|0)?h:c}}while((b|0)<12);r=g;return ~c|0}function uVa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0;q=l[a>>0]|0;e=q-(l[a+(k[b>>2]|0)>>0]|0)|0;d=q-(l[a+(k[b+4>>2]|0)>>0]|0)|0;g=q-(l[a+(k[b+8>>2]|0)>>0]|0)|0;f=q-(l[a+(k[b+12>>2]|0)>>0]|0)|0;i=q-(l[a+(k[b+16>>2]|0)>>0]|0)|0;h=q-(l[a+(k[b+20>>2]|0)>>0]|0)|0;o=q-(l[a+(k[b+24>>2]|0)>>0]|0)|0;j=q-(l[a+(k[b+28>>2]|0)>>0]|0)|0;m=q-(l[a+(k[b+32>>2]|0)>>0]|0)|0;n=q-(l[a+(k[b+36>>2]|0)>>0]|0)|0;p=q-(l[a+(k[b+40>>2]|0)>>0]|0)|0;b=q-(l[a+(k[b+44>>2]|0)>>0]|0)|0;a=(g|0)<(d|0)?g:d;if((a|0)>(c|0)){q=(f|0)<(a|0)?f:a;q=(i|0)<(q|0)?i:q;a=(e|0)<(q|0)?e:q;c=(a|0)>(c|0)?a:c;q=(h|0)<(q|0)?h:q;c=(c|0)<(q|0)?q:c}a=(i|0)<(f|0)?i:f;if((a|0)>(c|0)){q=(h|0)<(a|0)?h:a;q=(o|0)<(q|0)?o:q;a=(g|0)<(q|0)?g:q;c=(c|0)<(a|0)?a:c;q=(j|0)<(q|0)?j:q;c=(c|0)<(q|0)?q:c}a=(o|0)<(h|0)?o:h;if((a|0)>(c|0)){q=(j|0)<(a|0)?j:a;q=(m|0)<(q|0)?m:q;a=(i|0)<(q|0)?i:q;c=(c|0)<(a|0)?a:c;q=(n|0)<(q|0)?n:q;c=(c|0)<(q|0)?q:c}a=(m|0)<(j|0)?m:j;if((a|0)>(c|0)){q=(n|0)<(a|0)?n:a;q=(p|0)<(q|0)?p:q;a=(o|0)<(q|0)?o:q;c=(c|0)<(a|0)?a:c;q=(b|0)<(q|0)?b:q;c=(c|0)<(q|0)?q:c}a=0-c|0;c=(d|0)<(g|0)?g:d;c=(c|0)<(f|0)?f:c;if((c|0)<(a|0)){q=(c|0)<(i|0)?i:c;e=(q|0)<(e|0)?e:q;a=(e|0)<(a|0)?e:a;q=(q|0)<(h|0)?h:q;a=(q|0)<(a|0)?q:a}c=(f|0)<(i|0)?i:f;c=(c|0)<(h|0)?h:c;if((c|0)<(a|0)){q=(c|0)<(o|0)?o:c;g=(q|0)<(g|0)?g:q;a=(g|0)<(a|0)?g:a;q=(q|0)<(j|0)?j:q;a=(q|0)<(a|0)?q:a}c=(h|0)<(o|0)?o:h;c=(c|0)<(j|0)?j:c;if((c|0)<(a|0)){q=(c|0)<(m|0)?m:c;i=(q|0)<(i|0)?i:q;a=(i|0)<(a|0)?i:a;q=(q|0)<(n|0)?n:q;a=(q|0)<(a|0)?q:a}c=(j|0)<(m|0)?m:j;c=(c|0)<(n|0)?n:c;if((c|0)>=(a|0)){q=a;q=~q;return q|0}p=(c|0)<(p|0)?p:c;q=(p|0)<(o|0)?o:p;q=(q|0)<(a|0)?q:a;p=(p|0)<(b|0)?b:p;q=(p|0)<(q|0)?p:q;q=~q;return q|0}function vVa(a){a=a|0;return 1}function wVa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(!(G2(b)|0)){Lg[k[(k[a>>2]|0)+48>>2]&255](a,b,d,c,49332,0);return}d=k[c>>2]|0;a=c+4|0;b=k[a>>2]|0;if((b|0)==(d|0))return;k[a>>2]=b+(~(((b+-28-d|0)>>>0)/28|0)*28|0);return}function xVa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;N=r;r=r+112|0;I=N+100|0;J=N+88|0;K=N+72|0;L=N+56|0;M=N;k[I>>2]=0;j=I+4|0;k[j>>2]=0;k[I+8>>2]=0;k[J>>2]=0;H=J+4|0;k[H>>2]=0;k[J+8>>2]=0;B2(b,I);j=(k[j>>2]|0)-(k[I>>2]|0)|0;G=(j|0)/56|0;if(!(G2(d)|0)?(B2(d,J),(((k[H>>2]|0)-(k[J>>2]|0)|0)/56|0|0)!=(G|0)):0){k[K>>2]=0;b=K+4|0;k[b>>2]=0;d=ZT(28)|0;k[d>>2]=1;f=d+4|0;k[K>>2]=f;k[b>>2]=23;i[d+27>>0]=0;e=386819;g=f+23|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,K,386843,386658,84);k[b>>2]=0;k[K>>2]=0;F=k[d>>2]|0;k[d>>2]=F+-1;if((F|0)==1)ggb(k[d+-4>>2]|0)}h=c+4|0;e=k[h>>2]|0;d=k[c>>2]|0;b=(e-d|0)/12|0;if(G>>>0<=b>>>0){if(G>>>0<b>>>0?(l=d+(G*12|0)|0,(e|0)!=(l|0)):0)while(1){b=e+-12|0;k[h>>2]=b;f=k[b>>2]|0;g=f;if(f){b=e+-8|0;d=k[b>>2]|0;if((d|0)!=(f|0))k[b>>2]=d+(~(((d+-28-g|0)>>>0)/28|0)*28|0);ggb(f);b=k[h>>2]|0}if((b|0)==(l|0))break;else e=b}}else RUa(c,G-b|0);if(!j){zF(J);zF(I);r=N;return}m=K+8|0;n=K+12|0;o=K+4|0;p=M+4|0;q=M+8|0;s=M+40|0;t=M+48|0;u=M+44|0;v=M+52|0;w=L+8|0;x=L+12|0;y=L+4|0;z=M+36|0;A=M+16|0;B=M+12|0;C=M+20|0;D=M+24|0;E=M+28|0;F=M+32|0;l=0;do{h=k[(k[a>>2]|0)+32>>2]|0;j=(k[I>>2]|0)+(l*56|0)|0;k[m>>2]=0;k[n>>2]=0;k[K>>2]=16842752;k[o>>2]=j;j=(k[c>>2]|0)+(l*12|0)|0;e=k[J>>2]|0;do if((e|0)!=(k[H>>2]|0)){k[M>>2]=k[e+(l*56|0)>>2];d=e+(l*56|0)+4|0;k[p>>2]=k[d>>2];k[q>>2]=k[e+(l*56|0)+8>>2];k[B>>2]=k[e+(l*56|0)+12>>2];k[A>>2]=k[e+(l*56|0)+16>>2];k[C>>2]=k[e+(l*56|0)+20>>2];k[D>>2]=k[e+(l*56|0)+24>>2];k[E>>2]=k[e+(l*56|0)+28>>2];k[F>>2]=k[e+(l*56|0)+32>>2];b=k[e+(l*56|0)+36>>2]|0;k[z>>2]=b;k[s>>2]=q;k[u>>2]=t;k[v>>2]=0;k[t>>2]=0;if(b|0){g=b+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[d>>2]|0)<3){f=k[e+(l*56|0)+44>>2]|0;g=k[u>>2]|0;k[g>>2]=k[f>>2];k[g+4>>2]=k[f+4>>2];break}k[p>>2]=0;x1(M,k[d>>2]|0,0,0,0);if((k[p>>2]|0)>0){f=k[e+(l*56|0)+40>>2]|0;g=k[s>>2]|0;d=k[e+(l*56|0)+44>>2]|0;e=k[u>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[f+(b<<2)>>2];k[e+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[p>>2]|0))}}else{k[M>>2]=1124007936;f=p;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[s>>2]=q;k[u>>2]=t;k[v>>2]=0;k[t>>2]=0}while(0);k[w>>2]=0;k[x>>2]=0;k[L>>2]=16842752;k[y>>2]=M;dh[h&255](a,K,j,L);b=k[z>>2]|0;if(b|0?(h=b+12|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){d=k[z>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[F>>2]|0;if(!b){b=B1()|0;d=k[z>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[z>>2]=0}k[z>>2]=0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[p>>2]|0)>0){d=k[s>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[p>>2]|0))}b=k[u>>2]|0;if(!((b|0)==(t|0)|(b|0)==0))ggb(k[b+-4>>2]|0);l=l+1|0}while(l>>>0<G>>>0);zF(J);zF(I);r=N;return}function yVa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(G2(b)|0){b2(d);return}else{Lg[k[(k[a>>2]|0)+48>>2]&255](a,b,49332,c,d,1);return}}function zVa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;q=r;r=r+48|0;n=q+32|0;o=q+16|0;p=q;if(!(k[d>>2]&2031616)){r=q;return}k[n>>2]=0;j=n+4|0;k[j>>2]=0;k[n+8>>2]=0;B2(b,n);j=(k[j>>2]|0)-(k[n>>2]|0)|0;m=(j|0)/56|0;if((((k[c+4>>2]|0)-(k[c>>2]|0)|0)/12|0|0)!=(m|0)){k[o>>2]=0;b=o+4|0;k[b>>2]=0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[o>>2]=f;k[b>>2]=27;i[e+31>>0]=0;g=386732;h=f+27|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,o,386760,386658,125);k[b>>2]=0;k[o>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}if((k[d>>2]&2031616|0)!=327680){k[o>>2]=0;b=o+4|0;k[b>>2]=0;e=ZT(56)|0;k[e>>2]=1;f=e+4|0;k[o>>2]=f;k[b>>2]=50;i[e+54>>0]=0;g=386768;h=f+50|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,o,386760,386658,126);k[b>>2]=0;k[o>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}l=k[d+4>>2]|0;Y1(l,m);if(j|0){e=o+8|0;f=o+12|0;g=o+4|0;h=p+4|0;j=h+4|0;d=k[n>>2]|0;b=0;do{t=k[(k[a>>2]|0)+40>>2]|0;k[e>>2]=0;k[f>>2]=0;k[o>>2]=16842752;k[g>>2]=d+(b*56|0);s=(k[c>>2]|0)+(b*12|0)|0;u=(k[l>>2]|0)+(b*56|0)|0;v=j;k[v>>2]=0;k[v+4>>2]=0;k[p>>2]=33619968;k[h>>2]=u;dh[t&255](a,o,s,p);b=b+1|0}while(b>>>0<m>>>0)}zF(n);r=q;return}function AVa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;b=r;r=r+16|0;f=b;e=f+4|0;a=ZT(8)|0;k[a>>2]=1;d=a+4|0;k[f>>2]=d;k[e>>2]=0;i[d>>0]=0;Y8(-213,f,390333,386658,144);k[e>>2]=0;k[f>>2]=0;f=k[a>>2]|0;k[a>>2]=f+-1;if((f|0)!=1){r=b;return}ggb(k[a+-4>>2]|0);r=b;return}function BVa(a){a=a|0;return 0}function CVa(a){a=a|0;return 5}function DVa(a){a=a|0;a=(Xh[k[(k[a>>2]|0)+56>>2]&1023](a)|0)==0;return (a?6:4)|0}function EVa(a){a=a|0;ggb(a);return}function FVa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function GVa(a){a=a|0;return}function HVa(a){a=a|0;ggb(a);return}function IVa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;H=r;r=r+160|0;F=H+144|0;D=H+88|0;B=H+32|0;C=H+16|0;z=H;k[F>>2]=0;G=F+4|0;k[G>>2]=0;k[F+8>>2]=0;e=k[b>>2]&2031616;if((e|0)==655360){k[D>>2]=1124007936;j=D+4|0;h=D+32|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;k[j+20>>2]=0;k[j+24>>2]=0;k[h>>2]=D+8;m=D+40|0;l=D+36|0;k[l>>2]=m;k[D+44>>2]=0;k[m>>2]=0;if(!(S1(b,-1)|0)){A2(B,b);D2(D,B);g=B+24|0;e=k[g>>2]|0;if(e|0?(z=e+8|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){A=k[g>>2]|0;z=k[A+4>>2]|0;jh[k[(k[z>>2]|0)+16>>2]&1023](z,A);k[g>>2]=0}b=B+4|0;if((k[b>>2]|0)>0){f=k[B+32>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[b>>2]|0))}k[g>>2]=0;e=k[B+36>>2]|0;if(!((e|0)==(B+40|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}else{A=B+4|0;z=A+4|0;k[z>>2]=0;k[z+4>>2]=0;k[B>>2]=34209792;k[A>>2]=D;$aa(b,B,6,0)}k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=17432576;k[B+4>>2]=D;f=C+4|0;e=f+4|0;k[e>>2]=0;k[e+4>>2]=0;k[C>>2]=-2113732595;k[f>>2]=F;aga(B,C,k[a+4>>2]|0,+p[a+8>>3],+p[a+16>>3],d,k[a+24>>2]|0,(i[a+28>>0]|0)!=0,+p[a+32>>3]);f=D+24|0;e=k[f>>2]|0;if(e|0?(C=e+8|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){D=k[f>>2]|0;C=k[D+4>>2]|0;jh[k[(k[C>>2]|0)+16>>2]&1023](C,D);k[f>>2]=0}if((k[j>>2]|0)>0){b=k[h>>2]|0;e=0;do{k[b+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[j>>2]|0))}k[f>>2]=0;e=k[l>>2]|0;if(!((e|0)==(m|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}else{do if((e|0)==65536){g=k[b+4>>2]|0;k[D>>2]=k[g>>2];t=D+4|0;e=g+4|0;k[t>>2]=k[e>>2];u=D+8|0;k[u>>2]=k[g+8>>2];v=D+12|0;k[v>>2]=k[g+12>>2];w=D+16|0;k[w>>2]=k[g+16>>2];x=D+20|0;k[x>>2]=k[g+20>>2];m=D+24|0;k[m>>2]=k[g+24>>2];n=D+28|0;k[n>>2]=k[g+28>>2];q=D+32|0;k[q>>2]=k[g+32>>2];s=D+36|0;b=k[g+36>>2]|0;k[s>>2]=b;f=D+40|0;k[f>>2]=u;A=D+48|0;j=D+44|0;k[j>>2]=A;k[D+52>>2]=0;k[A>>2]=0;if(b|0){A=b+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[e>>2]|0)<3){h=k[g+44>>2]|0;A=k[j>>2]|0;k[A>>2]=k[h>>2];k[A+4>>2]=k[h+4>>2];A=s;j=s;h=u;f=v;y=w;g=w;b=x;s=D;break}k[t>>2]=0;x1(D,k[e>>2]|0,0,0,0);if((k[t>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;b=k[j>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[l+(e<<2)>>2];k[b+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[t>>2]|0));A=s;j=s;h=u;f=v;y=w;g=w;b=x;s=D}else{A=s;j=s;h=u;f=v;y=w;g=w;b=x;s=D}}else{Q1(D,b,-1);g=D+16|0;j=D+36|0;m=D+24|0;n=D+28|0;q=D+32|0;A=j;t=D+4|0;h=D+8|0;f=D+12|0;y=g;b=D+20|0;s=D}while(0);k[B>>2]=k[s>>2];v=B+4|0;e=k[t>>2]|0;k[v>>2]=e;x=B+8|0;k[x>>2]=k[h>>2];k[B+12>>2]=k[f>>2];u=B+16|0;k[u>>2]=k[g>>2];k[B+20>>2]=k[b>>2];k[B+24>>2]=k[m>>2];k[B+28>>2]=k[n>>2];l=B+32|0;k[l>>2]=k[q>>2];m=B+36|0;b=k[j>>2]|0;k[m>>2]=b;j=B+40|0;k[j>>2]=x;q=B+48|0;n=B+44|0;k[n>>2]=q;k[B+52>>2]=0;k[q>>2]=0;if(b){e=b+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[t>>2]|0}if((e|0)>=3){k[v>>2]=0;x1(B,k[D+4>>2]|0,0,0,0);if((k[v>>2]|0)>0){b=k[D+40>>2]|0;f=k[j>>2]|0;g=k[D+44>>2]|0;h=k[n>>2]|0;e=0;do{k[f+(e<<2)>>2]=k[b+(e<<2)>>2];k[h+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[v>>2]|0))}}else{w=k[D+44>>2]|0;x=k[n>>2]|0;k[x>>2]=k[w>>2];k[x+4>>2]=k[w+4>>2]}if(k[s>>2]&4095|0){k[C+8>>2]=0;k[C+12>>2]=0;k[C>>2]=16842752;k[C+4>>2]=D;x=z+4|0;w=x+4|0;k[w>>2]=0;k[w+4>>2]=0;k[z>>2]=33619968;k[x>>2]=B;$aa(C,z,6,0)}k[C+8>>2]=0;k[C+12>>2]=0;k[C>>2]=16842752;k[C+4>>2]=B;e=z+4|0;B=e+4|0;k[B>>2]=0;k[B+4>>2]=0;k[z>>2]=-2113732595;k[e>>2]=F;aga(C,z,k[a+4>>2]|0,+p[a+8>>3],+p[a+16>>3],d,k[a+24>>2]|0,(i[a+28>>0]|0)!=0,+p[a+32>>3]);e=k[m>>2]|0;if(e|0?(B=e+12|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0){b=k[m>>2]|0;if(b|0){e=k[b+4>>2]|0;if(!e){e=k[l>>2]|0;if(!e){e=B1()|0;b=k[m>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,b)}k[m>>2]=0}k[m>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[v>>2]|0)>0){b=k[j>>2]|0;e=0;do{k[b+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[v>>2]|0))}e=k[n>>2]|0;if(!((e|0)==(q|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[A>>2]|0;if(e|0?(B=e+12|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0){f=D+36|0;b=k[f>>2]|0;if(b|0){e=k[b+4>>2]|0;if(!e){e=k[D+32>>2]|0;if(!e){e=B1()|0;b=k[f>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,b)}k[f>>2]=0}k[A>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[t>>2]|0)>0){b=k[D+40>>2]|0;e=0;do{k[b+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[t>>2]|0))}e=k[D+44>>2]|0;if(!((e|0)==(D+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}m=k[G>>2]|0;b=k[F>>2]|0;e=m-b>>3;f=c+4|0;l=k[f>>2]|0;j=k[c>>2]|0;g=(l-j|0)/28|0;h=b;if(e>>>0<=g>>>0)if(e>>>0<g>>>0?(E=j+(e*28|0)|0,(l|0)!=(E|0)):0){k[f>>2]=l+(~(((l+-28-E|0)>>>0)/28|0)*28|0);j=m}else j=m;else{p9(c,e-g|0);h=k[F>>2]|0;b=h;j=k[G>>2]|0}e=b;if((e|0)!=(j|0)){g=a+24|0;f=k[c>>2]|0;while(1){c=k[e+4>>2]|0;I=+(k[g>>2]|0);k[f>>2]=k[b>>2];k[f+4>>2]=c;o[f+8>>2]=I;o[f+12>>2]=-1.0;o[f+16>>2]=0.0;k[f+20>>2]=0;k[f+24>>2]=-1;e=e+8|0;if((e|0)==(j|0))break;else{f=f+28|0;b=e}}}if(!h){r=H;return}if((j|0)!=(h|0))k[G>>2]=j+(~((j+-8-h|0)>>>3)<<3);ggb(h);r=H;return}function JVa(a,b){a=a|0;b=b|0;k[a+4>>2]=b;return}function KVa(a){a=a|0;return k[a+4>>2]|0}function LVa(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function MVa(a){a=a|0;return +(+p[a+8>>3])}function NVa(a,b){a=a|0;b=+b;p[a+16>>3]=b;return}function OVa(a){a=a|0;return +(+p[a+16>>3])}function PVa(a,b){a=a|0;b=b|0;k[a+24>>2]=b;return}function QVa(a){a=a|0;return k[a+24>>2]|0}function RVa(a,b){a=a|0;b=b|0;i[a+28>>0]=b&1;return}function SVa(a){a=a|0;return (i[a+28>>0]|0)!=0|0}function TVa(a,b){a=a|0;b=+b;p[a+32>>3]=b;return}function UVa(a){a=a|0;return +(+p[a+32>>3])}function VVa(a){a=a|0;ggb(a);return}function WVa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function XVa(a){a=a|0;return}function YVa(a){a=a|0;ggb(a);return}function ZVa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,p=0;p=r;r=r+16|0;n=p;m=n+4|0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[n>>2]=c;k[m>>2]=8;i[d+12>>0]=0;d=c;i[d>>0]=101;i[d+1>>0]=120;i[d+2>>0]=116;i[d+3>>0]=101;c=c+4|0;i[c>>0]=110;i[c+1>>0]=100;i[c+2>>0]=101;i[c+3>>0]=100;c=z6(b,n)|0;d=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(d|0?(j=d+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);k[n>>2]=l[a+4>>0];qWa(c,n);k[n>>2]=0;m=n+4|0;k[m>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[n>>2]=c;k[m>>2]=7;i[d+11>>0]=0;i[c>>0]=i[387228]|0;i[c+1>>0]=i[387229]|0;i[c+2>>0]=i[387230]|0;i[c+3>>0]=i[387231]|0;i[c+4>>0]=i[387232]|0;i[c+5>>0]=i[387233]|0;i[c+6>>0]=i[387234]|0;c=z6(b,n)|0;d=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(d|0?(j=d+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);k[n>>2]=l[a+5>>0];qWa(c,n);k[n>>2]=0;d=n+4|0;k[d>>2]=0;j=ZT(16)|0;k[j>>2]=1;h=j+4|0;k[n>>2]=h;k[d>>2]=9;i[j+13>>0]=0;j=393853;m=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));g=z6(b,n)|0;c=k[n>>2]|0;k[d>>2]=0;k[n>>2]=0;if(c|0?(j=c+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);e=a+8|0;if(Xh[k[(k[g>>2]|0)+12>>2]&1023](g)|0){f=g+32|0;if((k[f>>2]|0)==6){c=n+4|0;d=ZT(36)|0;k[d>>2]=1;h=d+4|0;k[n>>2]=h;k[c>>2]=30;i[d+34>>0]=0;j=401220;m=h+30|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));Y8(-2,n,401251,401262,1064);k[c>>2]=0;k[n>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[g+16>>2]|0))c=0;else{c=k[g+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[g+8>>2]|0,c,+o[e>>2]);if(k[f>>2]&4|0)k[f>>2]=6}m=n+4|0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[n>>2]=c;k[m>>2]=7;i[d+11>>0]=0;i[c>>0]=i[387236]|0;i[c+1>>0]=i[387237]|0;i[c+2>>0]=i[387238]|0;i[c+3>>0]=i[387239]|0;i[c+4>>0]=i[387240]|0;i[c+5>>0]=i[387241]|0;i[c+6>>0]=i[387242]|0;c=z6(b,n)|0;d=k[n>>2]|0;k[m>>2]=0;k[n>>2]=0;if(d|0?(j=d+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);qWa(c,a+12|0);e=n+4|0;j=ZT(16)|0;k[j>>2]=1;h=j+4|0;k[n>>2]=h;k[e>>2]=9;i[j+13>>0]=0;j=387244;m=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[e>>2]=0;k[n>>2]=0;if(d|0?(j=d+-4|0,m=k[j>>2]|0,k[j>>2]=m+-1,(m|0)==1):0)ggb(k[d+-8>>2]|0);qWa(c,a+16|0);e=n+4|0;j=ZT(16)|0;k[j>>2]=1;h=j+4|0;k[n>>2]=h;k[e>>2]=11;i[j+15>>0]=0;j=387254;m=h+11|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));c=z6(b,n)|0;d=k[n>>2]|0;k[e>>2]=0;k[n>>2]=0;if(!d){n=a+20|0;qWa(c,n);r=p;return}b=d+-4|0;n=k[b>>2]|0;k[b>>2]=n+-1;if((n|0)!=1){n=a+20|0;qWa(c,n);r=p;return}ggb(k[d+-8>>2]|0);n=a+20|0;qWa(c,n);r=p;return}function _Va(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0;e=b+4|0;d=k6(k[b>>2]|0,k[e>>2]|0,387219)|0;a:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break a}case 2:break;default:{d=2147483647;break a}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c}while(0);i[a+4>>0]=(d|0)!=0&1;d=k6(k[b>>2]|0,k[e>>2]|0,387228)|0;b:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break b}case 2:break;default:{d=2147483647;break b}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c}while(0);i[a+5>>0]=(d|0)!=0&1;d=k6(k[b>>2]|0,k[e>>2]|0,393853)|0;c:do if(!d)c=0.0;else switch(k[d>>2]&7){case 1:{c=+(k[d+8>>2]|0);break c}case 2:{c=+p[d+8>>3];break c}default:{c=1000000015047466219876688.0e6;break c}}while(0);o[a+8>>2]=c;d=k6(k[b>>2]|0,k[e>>2]|0,387236)|0;d:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break d}case 2:break;default:{d=2147483647;break d}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c}while(0);k[a+12>>2]=d;d=k6(k[b>>2]|0,k[e>>2]|0,387244)|0;e:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break e}case 2:break;default:{d=2147483647;break e}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}d=~~c}while(0);k[a+16>>2]=d;d=k6(k[b>>2]|0,k[e>>2]|0,387254)|0;if(!d){e=0;f=a+20|0;k[f>>2]=e;return}switch(k[d>>2]&7){case 1:{e=k[d+8>>2]|0;f=a+20|0;k[f>>2]=e;return}case 2:{c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}e=~~c;f=a+20|0;k[f>>2]=e;return}default:{e=2147483647;f=a+20|0;k[f>>2]=e;return}}}function $Va(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0.0,re=0.0,se=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0.0,Se=0.0,Te=0.0,Ue=0.0,Ve=0.0;Qe=r;r=r+1568|0;Ne=Qe+1504|0;Ie=Qe+672|0;ue=Qe+448|0;De=Qe+1448|0;ve=Qe+224|0;Ce=Qe+1392|0;we=Qe;ze=Qe+1376|0;Ae=Qe+1360|0;Pe=Qe+1304|0;Oe=Qe+1248|0;Me=Qe+1144|0;do if((k[b>>2]&2031616|0)==65536){m=k[b+4>>2]|0;k[Pe>>2]=k[m>>2];t=Pe+4|0;g=m+4|0;k[t>>2]=k[g>>2];Le=Pe+8|0;k[Le>>2]=k[m+8>>2];k[Pe+12>>2]=k[m+12>>2];k[Pe+16>>2]=k[m+16>>2];k[Pe+20>>2]=k[m+20>>2];k[Pe+24>>2]=k[m+24>>2];k[Pe+28>>2]=k[m+28>>2];k[Pe+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[Pe+36>>2]=h;l=Pe+40|0;k[l>>2]=Le;Le=Pe+48|0;q=Pe+44|0;k[q>>2]=Le;k[Pe+52>>2]=0;k[Le>>2]=0;if(h|0){Le=h+12|0;k[Le>>2]=(k[Le>>2]|0)+1}if((k[g>>2]|0)<3){Le=k[m+44>>2]|0;g=k[q>>2]|0;k[g>>2]=k[Le>>2];k[g+4>>2]=k[Le+4>>2];g=Pe;break}k[t>>2]=0;x1(Pe,k[g>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;h=k[q>>2]|0;g=0;do{k[n+(g<<2)>>2]=k[s+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[t>>2]|0));g=Pe}else g=Pe}else{Q1(Pe,b,-1);g=Pe}while(0);h=k[g>>2]|0;if(h&4088){h=Ne+4|0;Le=h+4|0;k[Le>>2]=0;k[Le+4>>2]=0;k[Ne>>2]=33619968;k[h>>2]=Pe;$aa(b,Ne,6,0);h=k[g>>2]|0}k[Oe>>2]=1124007936;Je=Oe+4|0;g=Oe+8|0;He=Oe+40|0;he=Je;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[He>>2]=g;Le=Oe+48|0;Ke=Oe+44|0;k[Ke>>2]=Le;k[Oe+52>>2]=0;k[Le>>2]=0;switch(h&7){case 5:{KG(Oe,Pe)|0;break}case 0:{Ge=Ne+4|0;Fe=Ge+4|0;k[Fe>>2]=0;k[Fe+4>>2]=0;k[Ne>>2]=33619968;k[Ge>>2]=Oe;SW(Pe,Ne,5,.00392156862745098,0.0);break}case 2:{Ge=Ne+4|0;Fe=Ge+4|0;k[Fe>>2]=0;k[Fe+4>>2]=0;k[Ne>>2]=33619968;k[Ge>>2]=Oe;SW(Pe,Ne,5,1.5259021896696422e-05,0.0);break}default:{}}Ge=Oe+16|0;if(k[Ge>>2]|0){m=k[Je>>2]|0;if((m|0)<3)g=aa(k[Oe+12>>2]|0,k[g>>2]|0)|0;else{l=k[He>>2]|0;h=0;g=1;do{g=aa(k[l+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(m|0))}if(!g)Be=22}else Be=22;if((Be|0)==22){k[Ne>>2]=0;g=Ne+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;he=h+4|0;k[Ne>>2]=he;k[g>>2]=17;i[h+21>>0]=0;s=387036;ie=he+17|0;do{i[he>>0]=i[s>>0]|0;he=he+1|0;s=s+1|0}while((he|0)<(ie|0));Y8(-215,Ne,390333,387054,125);k[g>>2]=0;k[Ne>>2]=0;Fe=k[h>>2]|0;k[h>>2]=Fe+-1;if((Fe|0)==1)ggb(k[h+-4>>2]|0)}je=k[Pe+12>>2]|0;fe=k[Pe+8>>2]|0;Fe=j[a+4>>1]|0;ge=k[a+8>>2]|0;ie=k[a+12>>2]|0;g=k[a+16>>2]|0;k[Me>>2]=k[a+20>>2];xe=Me+4|0;o[xe>>2]=1.600000023841858;n=Me+8|0;k[n>>2]=ie;ye=Me+12|0;k[ye>>2]=g;ke=Me+16|0;k[ke>>2]=je;je=Me+20|0;k[je>>2]=fe;fe=Me+24|0;o[fe>>2]=1.0;k[Me+28>>2]=ge;ge=Me+32|0;o[ge>>2]=.009999999776482582;de=Me+36|0;o[de>>2]=.699999988079071;ee=Me+40|0;k[ee>>2]=300;i[Me+44>>0]=(Fe&65535)>>>8;Ee=Me+45|0;i[Ee>>0]=Fe;Fe=Me+48|0;_d=Me+52|0;ne=Me+60|0;oe=Me+64|0;$d=Me+80|0;ae=Me+84|0;be=Me+96|0;ce=Me+76|0;k[Fe>>2]=0;k[Fe+4>>2]=0;k[Fe+8>>2]=0;k[Fe+12>>2]=0;k[Fe+16>>2]=0;k[Fe+20>>2]=0;k[Fe+24>>2]=0;k[$d>>2]=0;k[$d+4>>2]=0;k[$d+8>>2]=0;k[$d+12>>2]=0;k[$d+16>>2]=0;k[$d+20>>2]=0;i[ce>>0]=1;if((ie|0)>0){q=Ie+4|0;s=Ie+8|0;t=Ie+40|0;b=Ie+48|0;v=Ie+44|0;w=Ie+52|0;x=Ie+56|0;y=Ie+60|0;z=Ie+64|0;A=Ie+96|0;B=Ie+104|0;D=Ie+100|0;E=Ie+108|0;G=Ie+112|0;H=Ie+116|0;I=Ie+120|0;J=Ie+152|0;K=Ie+160|0;L=Ie+156|0;M=Ie+164|0;O=Ie+168|0;Q=Ie+172|0;R=Ie+176|0;S=Ie+208|0;T=Ie+216|0;U=Ie+212|0;V=Ie+220|0;X=Ie+224|0;Y=Ie+228|0;Z=Ie+232|0;_=Ie+264|0;ba=Ie+272|0;ca=Ie+268|0;da=Ie+276|0;ea=Ie+280|0;fa=Ie+284|0;ga=Ie+288|0;ha=Ie+320|0;ia=Ie+328|0;ja=Ie+324|0;ka=Ie+332|0;la=Ie+336|0;ma=Ie+340|0;na=Ie+344|0;oa=Ie+376|0;pa=Ie+384|0;qa=Ie+380|0;ra=Ie+388|0;sa=Ie+392|0;ta=Ie+396|0;ua=Ie+400|0;va=Ie+432|0;wa=Ie+440|0;xa=Ie+436|0;ya=Ie+56|0;za=Ie+112|0;Aa=Ie+168|0;Ba=Ie+224|0;Ca=Ie+280|0;Da=Ie+336|0;Ea=Ie+392|0;Fa=Ie+452|0;Ga=Ie+448|0;Ha=Ie+464|0;Ia=Ie+456|0;Ja=Ie+460|0;Ka=Me+56|0;La=ue+4|0;Ma=ue+8|0;Na=ue+12|0;Oa=ue+16|0;Pa=ue+48|0;Qa=ue+56|0;Ra=ue+52|0;Sa=ue+60|0;Ta=ue+64|0;Ua=ue+68|0;Va=ue+72|0;Wa=ue+104|0;Xa=ue+112|0;Ya=ue+108|0;Za=ue+116|0;_a=ue+120|0;$a=ue+124|0;ab=ue+128|0;bb=ue+160|0;cb=ue+168|0;db=ue+164|0;eb=Ne+4|0;fb=ue+4|0;gb=ue+8|0;hb=ue+12|0;ib=ue+16|0;jb=ue+48|0;kb=ue+56|0;lb=ue+52|0;mb=ue+60|0;nb=ue+64|0;ob=ue+68|0;pb=ue+72|0;qb=ue+104|0;rb=ue+112|0;sb=ue+108|0;tb=ue+116|0;ub=ue+120|0;vb=ue+124|0;wb=ue+128|0;xb=ue+160|0;yb=ue+168|0;zb=ue+164|0;Ab=Ne+4|0;Bb=ue+4|0;Cb=ue+8|0;Db=ue+12|0;Eb=ue+16|0;Fb=ue+48|0;Gb=ue+56|0;Hb=ue+52|0;Ib=ue+60|0;Jb=ue+64|0;Kb=ue+68|0;Lb=ue+72|0;Mb=ue+104|0;Nb=ue+112|0;Ob=ue+108|0;Pb=ue+116|0;Qb=ue+120|0;Rb=ue+124|0;Sb=ue+128|0;Tb=ue+160|0;Ub=ue+168|0;Vb=ue+164|0;Wb=Ne+4|0;Xb=ue+4|0;Yb=ue+8|0;Zb=ue+12|0;_b=ue+16|0;$b=ue+48|0;ac=ue+56|0;bc=ue+52|0;cc=ue+60|0;dc=ue+64|0;ec=ue+68|0;fc=ue+72|0;gc=ue+104|0;hc=ue+112|0;ic=ue+108|0;jc=ue+116|0;kc=ue+120|0;lc=ue+124|0;mc=ue+128|0;nc=ue+160|0;oc=ue+168|0;pc=ue+164|0;qc=Ne+4|0;rc=ue+4|0;sc=ue+8|0;tc=ue+12|0;uc=ue+16|0;vc=ue+48|0;wc=ue+56|0;xc=ue+52|0;yc=ue+60|0;zc=ue+64|0;Ac=ue+68|0;Bc=ue+72|0;Cc=ue+104|0;Dc=ue+112|0;Ec=ue+108|0;Fc=ue+116|0;Gc=ue+120|0;Hc=ue+124|0;Ic=ue+128|0;Jc=ue+160|0;Kc=ue+168|0;Lc=ue+164|0;Mc=Ne+4|0;Nc=ue+4|0;Oc=ue+8|0;Pc=ue+12|0;Qc=ue+16|0;Rc=ue+48|0;Sc=ue+56|0;Tc=ue+52|0;Uc=ue+60|0;Vc=ue+64|0;Wc=ue+68|0;Xc=ue+72|0;Yc=ue+104|0;Zc=ue+112|0;_c=ue+108|0;$c=ue+116|0;bd=ue+120|0;cd=ue+124|0;dd=ue+128|0;ed=ue+160|0;fd=ue+168|0;gd=ue+164|0;hd=Ne+4|0;id=ue+4|0;jd=ue+8|0;kd=ue+12|0;ld=ue+16|0;md=ue+48|0;nd=ue+56|0;od=ue+52|0;pd=ue+60|0;qd=ue+64|0;rd=ue+68|0;sd=ue+72|0;td=ue+104|0;ud=ue+112|0;vd=ue+108|0;wd=ue+116|0;xd=ue+120|0;yd=ue+124|0;zd=ue+128|0;Ad=ue+160|0;Bd=ue+168|0;Cd=ue+164|0;Dd=Ne+4|0;Ed=ue+4|0;Fd=ue+8|0;Gd=ue+12|0;Hd=ue+16|0;Id=ue+48|0;Jd=ue+56|0;Kd=ue+52|0;Ld=ue+60|0;Md=ue+64|0;Nd=ue+68|0;Od=ue+72|0;Pd=ue+104|0;Qd=ue+112|0;Rd=ue+108|0;Sd=ue+116|0;Td=ue+120|0;Ud=ue+124|0;Vd=ue+128|0;Wd=ue+160|0;Xd=ue+168|0;Yd=ue+164|0;Zd=Ne+4|0;m=0;do{if((g|0)>0){W=+(m|0);l=0;do{k[Ie>>2]=1124007936;he=q;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[t>>2]=s;k[v>>2]=b;k[w>>2]=0;k[b>>2]=0;k[x>>2]=1124007936;he=y;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[A>>2]=z;k[D>>2]=B;k[E>>2]=0;k[B>>2]=0;k[G>>2]=1124007936;he=H;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[J>>2]=I;k[L>>2]=K;k[M>>2]=0;k[K>>2]=0;k[O>>2]=1124007936;he=Q;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[S>>2]=R;k[U>>2]=T;k[V>>2]=0;k[T>>2]=0;k[X>>2]=1124007936;he=Y;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[_>>2]=Z;k[ca>>2]=ba;k[da>>2]=0;k[ba>>2]=0;k[ea>>2]=1124007936;he=fa;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[ha>>2]=ga;k[ja>>2]=ia;k[ka>>2]=0;k[ia>>2]=0;k[la>>2]=1124007936;he=ma;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[oa>>2]=na;k[qa>>2]=pa;k[ra>>2]=0;k[pa>>2]=0;k[sa>>2]=1124007936;he=ta;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[va>>2]=ua;k[xa>>2]=wa;k[wa>>2]=0;k[wa+4>>2]=0;k[wa+8>>2]=0;k[wa+12>>2]=0;k[wa+16>>2]=0;k[wa+20>>2]=0;k[wa+24>>2]=0;g=k[je>>2]|0;h=k[ke>>2]|0;k[ue>>2]=0;k[La>>2]=0;k[Ma>>2]=1124007936;he=Na;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Pa>>2]=Oa;k[Ra>>2]=Qa;k[Sa>>2]=0;k[Qa>>2]=0;k[Ta>>2]=1124007936;he=Ua;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Wa>>2]=Va;k[Ya>>2]=Xa;k[Za>>2]=0;k[Xa>>2]=0;k[_a>>2]=1124007936;he=$a;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[bb>>2]=ab;k[db>>2]=cb;he=cb;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=h;k[eb>>2]=g;j1(ue,48,Ne,5);g=k[ue>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,ue,Ie,-1);XN(ue);g=k[je>>2]|0;h=k[ke>>2]|0;k[ue>>2]=0;k[fb>>2]=0;k[gb>>2]=1124007936;he=hb;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[jb>>2]=ib;k[lb>>2]=kb;k[mb>>2]=0;k[kb>>2]=0;k[nb>>2]=1124007936;he=ob;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[qb>>2]=pb;k[sb>>2]=rb;k[tb>>2]=0;k[rb>>2]=0;k[ub>>2]=1124007936;he=vb;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[xb>>2]=wb;k[zb>>2]=yb;he=yb;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=h;k[Ab>>2]=g;j1(ue,48,Ne,5);g=k[ue>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,ue,ya,-1);XN(ue);g=k[je>>2]|0;h=k[ke>>2]|0;k[ue>>2]=0;k[Bb>>2]=0;k[Cb>>2]=1124007936;he=Db;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Fb>>2]=Eb;k[Hb>>2]=Gb;k[Ib>>2]=0;k[Gb>>2]=0;k[Jb>>2]=1124007936;he=Kb;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Mb>>2]=Lb;k[Ob>>2]=Nb;k[Pb>>2]=0;k[Nb>>2]=0;k[Qb>>2]=1124007936;he=Rb;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Tb>>2]=Sb;k[Vb>>2]=Ub;he=Ub;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=h;k[Wb>>2]=g;j1(ue,48,Ne,5);g=k[ue>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,ue,za,-1);XN(ue);g=k[je>>2]|0;h=k[ke>>2]|0;k[ue>>2]=0;k[Xb>>2]=0;k[Yb>>2]=1124007936;he=Zb;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[$b>>2]=_b;k[bc>>2]=ac;k[cc>>2]=0;k[ac>>2]=0;k[dc>>2]=1124007936;he=ec;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[gc>>2]=fc;k[ic>>2]=hc;k[jc>>2]=0;k[hc>>2]=0;k[kc>>2]=1124007936;he=lc;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[nc>>2]=mc;k[pc>>2]=oc;he=oc;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=h;k[qc>>2]=g;j1(ue,48,Ne,5);g=k[ue>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,ue,Aa,-1);XN(ue);g=k[je>>2]|0;h=k[ke>>2]|0;k[ue>>2]=0;k[rc>>2]=0;k[sc>>2]=1124007936;he=tc;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[vc>>2]=uc;k[xc>>2]=wc;k[yc>>2]=0;k[wc>>2]=0;k[zc>>2]=1124007936;he=Ac;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Cc>>2]=Bc;k[Ec>>2]=Dc;k[Fc>>2]=0;k[Dc>>2]=0;k[Gc>>2]=1124007936;he=Hc;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Jc>>2]=Ic;k[Lc>>2]=Kc;he=Kc;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=h;k[Mc>>2]=g;j1(ue,48,Ne,5);g=k[ue>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,ue,Ba,-1);XN(ue);g=k[je>>2]|0;h=k[ke>>2]|0;k[ue>>2]=0;k[Nc>>2]=0;k[Oc>>2]=1124007936;he=Pc;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Rc>>2]=Qc;k[Tc>>2]=Sc;k[Uc>>2]=0;k[Sc>>2]=0;k[Vc>>2]=1124007936;he=Wc;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Yc>>2]=Xc;k[_c>>2]=Zc;k[$c>>2]=0;k[Zc>>2]=0;k[bd>>2]=1124007936;he=cd;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[ed>>2]=dd;k[gd>>2]=fd;he=fd;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=h;k[hd>>2]=g;j1(ue,48,Ne,5);g=k[ue>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,ue,Ca,-1);XN(ue);g=k[je>>2]|0;h=k[ke>>2]|0;k[ue>>2]=0;k[id>>2]=0;k[jd>>2]=1124007936;he=kd;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[md>>2]=ld;k[od>>2]=nd;k[pd>>2]=0;k[nd>>2]=0;k[qd>>2]=1124007936;he=rd;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[td>>2]=sd;k[vd>>2]=ud;k[wd>>2]=0;k[ud>>2]=0;k[xd>>2]=1124007936;he=yd;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ad>>2]=zd;k[Cd>>2]=Bd;he=Bd;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=h;k[Dd>>2]=g;j1(ue,48,Ne,5);g=k[ue>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,ue,Da,-1);XN(ue);g=k[je>>2]|0;h=k[ke>>2]|0;k[ue>>2]=0;k[Ed>>2]=0;k[Fd>>2]=1124007936;he=Gd;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Id>>2]=Hd;k[Kd>>2]=Jd;k[Ld>>2]=0;k[Jd>>2]=0;k[Md>>2]=1124007936;he=Nd;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Pd>>2]=Od;k[Rd>>2]=Qd;k[Sd>>2]=0;k[Qd>>2]=0;k[Td>>2]=1124007936;he=Ud;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Wd>>2]=Vd;k[Yd>>2]=Xd;he=Xd;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=h;k[Zd>>2]=g;j1(ue,48,Ne,5);g=k[ue>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,ue,Ea,-1);XN(ue);F=+o[xe>>2];C=W+ +(l|0)/+(k[ye>>2]|0);g=(o[u>>2]=C,k[u>>2]|0);h=g&2147483647;do if(h>>>0>1123811328)if(!(g>>>0>1124073471&(g|0)>-1))if((g|0)<0&g>>>0>3272998911){C=0.0;break}else{Be=40;break}else{C=C*1701411834604692317316873.0e14;break}else if(h>>>0<855638017)C=C+1.0;else Be=40;while(0);if((Be|0)==40){Be=0;Re=C+786432.0;h=(o[u>>2]=Re,k[u>>2]|0)+8|0;he=Apb((h>>>4)+1023|0,0,52)|0;ie=N;Re=C-(Re+-786432.0);Se=+p[27280+((h&15)<<3)>>3];C=Re*Se;k[u>>2]=he;k[u+4>>2]=ie;C=+p[u>>3]*(Se+(Re*.24022650718688965+.6931471824645996)*C+(Re*.009618354961276054+.055505409836769104)*(Re*Re*C))}Se=F*C;o[Fa>>2]=Se;o[Ga>>2]=Se*Se*.5;k[Ha>>2]=~~(Se+.5);k[Ia>>2]=m;k[Ja>>2]=l;g=k[_d>>2]|0;if((g|0)==(k[Ka>>2]|0))tWa(Fe,Ie);else{sWa(g,Ie);k[_d>>2]=(k[_d>>2]|0)+468}gUa(Ie);l=l+1|0;g=k[ye>>2]|0}while((l|0)<(g|0))}m=m+1|0}while((m|0)<(k[n>>2]|0));X=_d;Y=Fe;g=k[Fe>>2]|0;h=k[_d>>2]|0}else{X=_d;Y=Fe;g=0;h=0}if(((h-g|0)/468|0)>>>0>1){n=Ie+4|0;q=Ie+8|0;s=Me+100|0;t=Me+92|0;b=Me+88|0;v=Me+72|0;m=1;do{k[Ne>>2]=0;k[Ie>>2]=0;k[n>>2]=0;k[q>>2]=0;Se=+o[g+(m*468|0)+448>>2]-+o[g+((m+-1|0)*468|0)+448>>2];o[ue>>2]=.25;g=TWa(Se,1,ue,ce,Ie)|0;k[Ne>>2]=g;h=k[be>>2]|0;if((h|0)==(k[s>>2]|0))Q4(t,Ne);else{k[h>>2]=g;k[be>>2]=h+4}g=k[ae>>2]|0;if((g|0)==(k[b>>2]|0))uWa($d,Ie);else{BH(g,Ie);k[ae>>2]=(k[ae>>2]|0)+12}k[v>>2]=(k[v>>2]|0)+1;g=k[Ie>>2]|0;h=g;if(g|0){l=k[n>>2]|0;if((l|0)!=(g|0))k[n>>2]=l+(~((l+-4-h|0)>>>2)<<2);ggb(g)}m=m+1|0;h=k[X>>2]|0;g=k[Y>>2]|0}while(m>>>0<((h-g|0)/468|0)>>>0)}if((h|0)==(g|0)){k[Ne>>2]=0;g=Ne+4|0;k[g>>2]=0;h=ZT(28)|0;k[h>>2]=1;he=h+4|0;k[Ne>>2]=he;k[g>>2]=21;i[h+25>>0]=0;s=387809;ie=he+21|0;do{i[he>>0]=i[s>>0]|0;he=he+1|0;s=s+1|0}while((he|0)<(ie|0));Y8(-215,Ne,387831,387860,100);k[g>>2]=0;k[Ne>>2]=0;ie=k[h>>2]|0;k[h>>2]=ie+-1;if((ie|0)==1)ggb(k[h+-4>>2]|0);g=k[Fe>>2]|0}l=Ne+4|0;m=l+4|0;k[m>>2]=0;k[m+4>>2]=0;k[Ne>>2]=33619968;k[l>>2]=g+280;mY(Oe,Ne);l=(k[Fe>>2]|0)+280|0;Se=+o[xe>>2];g=~~+$(+(((Se+-.800000011920929)/.30000001192092896+1.0)*2.0));g=(g&1^1)+g|0;k[Ne+8>>2]=0;k[Ne+12>>2]=0;k[Ne>>2]=16842752;k[Ne+4>>2]=l;m=Ie+4|0;h=m+4|0;k[h>>2]=0;k[h+4>>2]=0;k[Ie>>2]=33619968;k[m>>2]=l;k[ue>>2]=g;k[ue+4>>2]=g;uua(Ne,Ie,ue,Se,Se,1);g=k[Fe>>2]|0;Se=+o[fe>>2];m=~~+$(+(((Se+-.800000011920929)/.30000001192092896+1.0)*2.0));m=(m&1^1)+m|0;k[Ne+8>>2]=0;k[Ne+12>>2]=0;k[Ne>>2]=16842752;k[Ne+4>>2]=g+280;l=Ie+4|0;h=l+4|0;k[h>>2]=0;k[h+4>>2]=0;k[Ie>>2]=33619968;k[l>>2]=g+336;k[ue>>2]=m;k[ue+4>>2]=m;uua(Ne,Ie,ue,Se,Se,1);Se=+XWa((k[Fe>>2]|0)+280|0,+o[de>>2],+o[fe>>2],k[ee>>2]|0);o[ge>>2]=Se;m=k[Fe>>2]|0;l=k[m+288>>2]|0;m=k[m+292>>2]|0;k[ve>>2]=0;k[ve+4>>2]=0;k[ve+8>>2]=1124007936;g=ve+16|0;h=ve+48|0;he=ve+12|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=ve+56|0;k[ve+52>>2]=g;k[ve+60>>2]=0;k[g>>2]=0;k[ve+64>>2]=1124007936;g=ve+72|0;h=ve+104|0;he=ve+68|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=ve+112|0;k[ve+108>>2]=g;k[ve+116>>2]=0;k[g>>2]=0;k[ve+120>>2]=1124007936;g=ve+128|0;h=ve+160|0;he=ve+124|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;he=ve+168|0;k[ve+164>>2]=he;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=m;k[Ne+4>>2]=l;j1(ve,48,Ne,5);k[De>>2]=1124007936;T=De+4|0;g=De+8|0;R=De+40|0;he=T;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[R>>2]=g;U=De+48|0;S=De+44|0;k[S>>2]=U;k[De+52>>2]=0;k[U>>2]=0;m=k[ve>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,ve,De,-1);XN(ve);m=k[Fe>>2]|0;l=k[m+288>>2]|0;m=k[m+292>>2]|0;k[we>>2]=0;k[we+4>>2]=0;k[we+8>>2]=1124007936;g=we+16|0;h=we+48|0;he=we+12|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=we+56|0;k[we+52>>2]=g;k[we+60>>2]=0;k[g>>2]=0;k[we+64>>2]=1124007936;g=we+72|0;h=we+104|0;he=we+68|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=we+112|0;k[we+108>>2]=g;k[we+116>>2]=0;k[g>>2]=0;k[we+120>>2]=1124007936;g=we+128|0;h=we+160|0;he=we+124|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;he=we+168|0;k[we+164>>2]=he;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=m;k[Ne+4>>2]=l;j1(we,48,Ne,5);k[Ce>>2]=1124007936;Q=Ce+4|0;g=Ce+8|0;M=Ce+40|0;he=Q;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[M>>2]=g;O=Ce+48|0;L=Ce+44|0;k[L>>2]=O;k[Ce+52>>2]=0;k[O>>2]=0;g=k[we>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,we,Ce,-1);XN(we);g=k[Y>>2]|0;a:do if((((k[X>>2]|0)-g|0)/468|0)>>>0>1){m=Ne+4|0;n=m+4|0;q=Ne+8|0;s=Ne+12|0;t=Ne+4|0;b=Ie+4|0;v=b+4|0;w=Ne+8|0;x=Ne+12|0;y=Ne+4|0;z=Ie+4|0;A=z+4|0;B=Me+92|0;D=Me+80|0;E=Ne+8|0;G=Ne+12|0;H=Ne+4|0;I=Ie+4|0;J=I+4|0;K=ue+4|0;l=1;while(1){he=g;h=l+-1|0;ie=n;k[ie>>2]=0;k[ie+4>>2]=0;k[Ne>>2]=33619968;k[m>>2]=he+(l*468|0)+280;mY(he+(h*468|0)+280|0,Ne);he=k[Fe>>2]|0;Se=+o[fe>>2];ie=~~+$(+(((Se+-.800000011920929)/.30000001192092896+1.0)*2.0));ie=(ie&1^1)+ie|0;k[E>>2]=0;k[G>>2]=0;k[Ne>>2]=16842752;k[H>>2]=he+(h*468|0)+280;ee=J;k[ee>>2]=0;k[ee+4>>2]=0;k[Ie>>2]=33619968;k[I>>2]=he+(l*468|0)+336;k[ue>>2]=ie;k[K>>2]=ie;uua(Ne,Ie,ue,Se,Se,1);ie=k[Fe>>2]|0;k[q>>2]=0;k[s>>2]=0;k[Ne>>2]=16842752;k[t>>2]=ie+(l*468|0)+336;he=v;k[he>>2]=0;k[he+4>>2]=0;k[Ie>>2]=33619968;k[b>>2]=ie+(l*468|0);ufa(Ne,Ie,5,1,0,1.0,0.0,4);ie=k[Fe>>2]|0;k[w>>2]=0;k[x>>2]=0;k[Ne>>2]=16842752;k[y>>2]=ie+(l*468|0)+336;he=A;k[he>>2]=0;k[he+4>>2]=0;k[Ie>>2]=33619968;k[z>>2]=ie+(l*468|0)+56;ufa(Ne,Ie,5,0,1,1.0,0.0,4);switch(k[Me>>2]|0){case 0:{ie=k[Fe>>2]|0;UWa(ie+(l*468|0)|0,ie+(l*468|0)+56|0,De,+o[ge>>2]);break}case 1:{ie=k[Fe>>2]|0;VWa(ie+(l*468|0)|0,ie+(l*468|0)+56|0,De,+o[ge>>2]);break}case 2:{ie=k[Fe>>2]|0;WWa(ie+(l*468|0)|0,ie+(l*468|0)+56|0,De,+o[ge>>2]);break}default:{}}if((k[(k[B>>2]|0)+(h<<2)>>2]|0)>0){g=0;do{ZWa((k[Fe>>2]|0)+(l*468|0)+280|0,De,Ce,+o[(k[(k[D>>2]|0)+(h*12|0)>>2]|0)+(g<<2)>>2]);g=g+1|0}while((g|0)<(k[(k[B>>2]|0)+(h<<2)>>2]|0))}l=l+1|0;g=k[Y>>2]|0;if(l>>>0>=(((k[X>>2]|0)-g|0)/468|0)>>>0)break a}}while(0);l=Ce+36|0;g=k[l>>2]|0;if(g|0?(he=g+12|0,ie=k[he>>2]|0,k[he>>2]=ie+-1,(ie|0)==1):0){h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[Ce+32>>2]|0;if(!g){g=B1()|0;h=k[l>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}k[l>>2]=0;ie=Ce+16|0;k[ie>>2]=0;k[ie+4>>2]=0;k[ie+8>>2]=0;k[ie+12>>2]=0;if((k[Q>>2]|0)>0){h=k[M>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[Q>>2]|0))}g=k[L>>2]|0;if(!((g|0)==(O|0)|(g|0)==0))ggb(k[g+-4>>2]|0);l=De+36|0;g=k[l>>2]|0;if(g|0?(he=g+12|0,ie=k[he>>2]|0,k[he>>2]=ie+-1,(ie|0)==1):0){h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[De+32>>2]|0;if(!g){g=B1()|0;h=k[l>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}k[l>>2]=0;ie=De+16|0;k[ie>>2]=0;k[ie+4>>2]=0;k[ie+8>>2]=0;k[ie+12>>2]=0;if((k[T>>2]|0)>0){h=k[R>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[T>>2]|0))}g=k[S>>2]|0;if(!((g|0)==(U|0)|(g|0)==0))ggb(k[g+-4>>2]|0);if(!f){g=k[d>>2]|0;V=d+4|0;h=k[V>>2]|0;if((h|0)!=(g|0))k[V>>2]=h+(~(((h+-28-g|0)>>>0)/28|0)*28|0);g=((k[X>>2]|0)-(k[Y>>2]|0)|0)/468|0;k[Ne>>2]=0;k[Ne+4>>2]=g;k[Ie>>2]=142672;k[Ie+4>>2]=Fe;OWa(Ie,Ne);g=k[X>>2]|0;h=k[Y>>2]|0;G=h;if((g|0)!=(h|0)){E=k[je>>2]|0;D=(g-h|0)/468|0;x=k[ke>>2]|0;h=0;do{if(!((E|0)<1|(x|0)<1)){m=k[G+(h*468|0)+128>>2]|0;n=k[k[G+(h*468|0)+156>>2]>>2]|0;q=k[G+(h*468|0)+184>>2]|0;s=k[k[G+(h*468|0)+212>>2]>>2]|0;t=k[G+(h*468|0)+240>>2]|0;b=k[k[G+(h*468|0)+268>>2]>>2]|0;v=k[G+(h*468|0)+408>>2]|0;w=k[k[G+(h*468|0)+436>>2]>>2]|0;g=0;do{y=m+(aa(n,g)|0)|0;z=q+(aa(s,g)|0)|0;A=t+(aa(b,g)|0)|0;B=v+(aa(w,g)|0)|0;l=0;do{Se=+o[z+(l<<2)>>2];o[B+(l<<2)>>2]=+o[y+(l<<2)>>2]*+o[A+(l<<2)>>2]-Se*Se;l=l+1|0}while((l|0)!=(x|0));g=g+1|0}while((g|0)!=(E|0))}h=h+1|0}while(h>>>0<D>>>0)}g=k[oe>>2]|0;f=k[ne>>2]|0;h=f;if((g|0)!=(f|0)){l=0;do{f=h+(l*12|0)|0;g=k[f>>2]|0;k[f>>2]=0;k[h+(l*12|0)+4>>2]=0;k[h+(l*12|0)+8>>2]=0;if(g|0)ggb(g);l=l+1|0;g=k[oe>>2]|0;f=k[ne>>2]|0;h=f}while(l>>>0<((g-f|0)/12|0)>>>0)}l=g;if((l|0)!=(h|0))while(1){g=l+-12|0;k[oe>>2]=g;m=k[g>>2]|0;n=m;if(m){g=l+-8|0;l=k[g>>2]|0;if((l|0)!=(m|0))k[g>>2]=l+(~(((l+-28-n|0)>>>0)/28|0)*28|0);ggb(m);g=k[oe>>2]|0}if((g|0)==(h|0))break;else l=g}k[Ne>>2]=0;y=Ne+4|0;k[y>>2]=0;k[Ne+8>>2]=0;l=k[X>>2]|0;m=k[Y>>2]|0;b:do if((((l-m|0)/468|0)+-1|0)>>>0>1){b=Me+68|0;t=1;c:while(1){f=k[b>>2]|0;l=f;do if((h|0)==(f|0)){h=k[ne>>2]|0;n=(g-h|0)/12|0;g=n+1|0;if(g>>>0>357913941){Be=124;break c}f=(l-h|0)/12|0;m=f<<1;m=f>>>0<178956970?(m>>>0<g>>>0?g:m):357913941;if(!m)g=0;else{if(m>>>0>357913941){Be=127;break c}h=m*12|0;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}}h=g+(n*12|0)|0;l=h;q=g+(m*12|0)|0;WUa(h,Ne);n=h+12|0;m=k[ne>>2]|0;g=k[oe>>2]|0;if((g|0)==(m|0)){g=l;s=m;h=m}else{do{g=g+-12|0;WUa(h+-12|0,g);h=l+-12|0;l=h}while((g|0)!=(m|0));g=l;s=k[ne>>2]|0;h=k[oe>>2]|0}k[ne>>2]=g;k[oe>>2]=n;k[b>>2]=q;q=s;if((h|0)!=(q|0))do{g=h;h=h+-12|0;m=k[h>>2]|0;n=m;if(m|0){g=g+-8|0;l=k[g>>2]|0;if((l|0)!=(m|0))k[g>>2]=l+(~(((l+-28-n|0)>>>0)/28|0)*28|0);ggb(m)}}while((h|0)!=(q|0));if(!s)break;ggb(s)}else{WUa(h,Ne);k[oe>>2]=(k[oe>>2]|0)+12}while(0);g=t+1|0;h=k[X>>2]|0;l=k[Y>>2]|0;if(g>>>0>=(((h-l|0)/468|0)+-1|0)>>>0){le=l;me=h;break b}f=k[oe>>2]|0;t=g;h=f;g=f}if((Be|0)==124)ad(426534,426557,304,426811);else if((Be|0)==127){Qe=te(4)|0;k[Qe>>2]=172664;Cf(Qe|0,28816,1287)}}else{le=m;me=l}while(0);k[Ie>>2]=1;k[Ie+4>>2]=((me-le|0)/468|0)+-1;k[ue>>2]=142692;k[ue+4>>2]=Fe;k[ue+8>>2]=ne;he=ue+12|0;s=Me;ie=he+48|0;do{k[he>>2]=k[s>>2];he=he+4|0;s=s+4|0}while((he|0)<(ie|0));QWa(ue,Ie);h=k[oe>>2]|0;g=k[ne>>2]|0;if((h-g|0)>0){x=d+8|0;w=0;do{l=g;v=w;w=w+1|0;if(((k[l+(v*12|0)+4>>2]|0)-(k[l+(v*12|0)>>2]|0)|0)>0){b=v+2|0;t=0;g=l;do{q=k[V>>2]|0;n=k[d>>2]|0;h=q-n|0;s=q;d:do if((h|0)>0){m=(h|0)/28|0;g=g+(v*12|0)|0;l=(k[Fe>>2]|0)+(w*468|0)+464|0;h=0;while(1){me=k[n+(h*28|0)+24>>2]|0;if((me|0)==(v|0)|((me|0)==(w|0)|(me|0)==(b|0))?(pe=k[g>>2]|0,qe=+o[pe+(t*28|0)>>2],Re=qe-+o[n+(h*28|0)>>2],re=+o[pe+(t*28|0)+4>>2],se=n+(h*28|0)+4|0,Se=re-+o[se>>2],me=k[l>>2]|0,Re*Re+Se*Se<+(aa(me,me)|0)):0)break;h=h+1|0;if((h|0)>=(m|0)){Be=163;break d}}if(!(+o[pe+(t*28|0)+16>>2]>+o[n+(h*28|0)+16>>2]))break;o[n+(h*28|0)>>2]=qe;o[se>>2]=re;me=n+(h*28|0)+8|0;le=pe+(t*28|0)+8|0;k[me>>2]=k[le>>2];k[me+4>>2]=k[le+4>>2];k[me+8>>2]=k[le+8>>2];k[me+12>>2]=k[le+12>>2];k[me+16>>2]=k[le+16>>2]}else{g=g+(v*12|0)|0;Be=163}while(0);do if((Be|0)==163){Be=0;g=k[g>>2]|0;h=g+(t*28|0)|0;if((s|0)==(k[x>>2]|0)){H6(d,h);break}else{k[q>>2]=k[h>>2];k[s+4>>2]=k[g+(t*28|0)+4>>2];me=s+8|0;le=g+(t*28|0)+8|0;k[me>>2]=k[le>>2];k[me+4>>2]=k[le+4>>2];k[me+8>>2]=k[le+8>>2];k[me+12>>2]=k[le+12>>2];k[me+16>>2]=k[le+16>>2];k[V>>2]=(k[V>>2]|0)+28;break}}while(0);t=t+1|0;g=k[ne>>2]|0}while((t|0)<(((k[g+(v*12|0)+4>>2]|0)-(k[g+(v*12|0)>>2]|0)|0)/28|0|0));h=k[oe>>2]|0}}while((w|0)<((h-g|0)/12|0|0))}g=k[Ne>>2]|0;h=g;if(g|0){l=k[y>>2]|0;if((l|0)!=(g|0))k[y>>2]=l+(~(((l+-28-h|0)>>>0)/28|0)*28|0);ggb(g)}k[ue>>2]=0;k[ue+4>>2]=0;k[ue+8>>2]=1124007936;g=ue+16|0;h=ue+48|0;he=ue+12|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=ue+56|0;k[ue+52>>2]=g;k[ue+60>>2]=0;k[g>>2]=0;k[ue+64>>2]=1124007936;g=ue+72|0;h=ue+104|0;he=ue+68|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=ue+112|0;k[ue+108>>2]=g;k[ue+116>>2]=0;k[g>>2]=0;k[ue+120>>2]=1124007936;g=ue+128|0;h=ue+160|0;he=ue+124|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;he=ue+168|0;k[ue+164>>2]=he;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=3;k[Ne+4>>2]=3;j1(ue,48,Ne,5);k[Ie>>2]=1124007936;T=Ie+4|0;g=Ie+8|0;R=Ie+40|0;he=T;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[R>>2]=g;U=Ie+48|0;S=Ie+44|0;k[S>>2]=U;k[Ie+52>>2]=0;k[U>>2]=0;g=k[ue>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,ue,Ie,-1);XN(ue);k[ve>>2]=0;k[ve+4>>2]=0;k[ve+8>>2]=1124007936;g=ve+16|0;h=ve+48|0;he=ve+12|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=ve+56|0;k[ve+52>>2]=g;k[ve+60>>2]=0;k[g>>2]=0;k[ve+64>>2]=1124007936;g=ve+72|0;h=ve+104|0;he=ve+68|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=ve+112|0;k[ve+108>>2]=g;k[ve+116>>2]=0;k[g>>2]=0;k[ve+120>>2]=1124007936;g=ve+128|0;h=ve+160|0;he=ve+124|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;he=ve+168|0;k[ve+164>>2]=he;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=1;k[Ne+4>>2]=3;j1(ve,48,Ne,5);k[De>>2]=1124007936;O=De+4|0;g=De+8|0;L=De+40|0;he=O;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[L>>2]=g;Q=De+48|0;M=De+44|0;k[M>>2]=Q;k[De+52>>2]=0;k[Q>>2]=0;g=k[ve>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,ve,De,-1);XN(ve);k[we>>2]=0;k[we+4>>2]=0;k[we+8>>2]=1124007936;g=we+16|0;h=we+48|0;he=we+12|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=we+56|0;k[we+52>>2]=g;k[we+60>>2]=0;k[g>>2]=0;k[we+64>>2]=1124007936;g=we+72|0;h=we+104|0;he=we+68|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=we+112|0;k[we+108>>2]=g;k[we+116>>2]=0;k[g>>2]=0;k[we+120>>2]=1124007936;g=we+128|0;h=we+160|0;he=we+124|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;he=we+168|0;k[we+164>>2]=he;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=1;k[Ne+4>>2]=3;j1(we,48,Ne,5);k[Ce>>2]=1124007936;K=Ce+4|0;g=Ce+8|0;I=Ce+40|0;he=K;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[I>>2]=g;J=Ce+48|0;H=Ce+44|0;k[H>>2]=J;k[Ce+52>>2]=0;k[J>>2]=0;h=k[we>>2]|0;dh[k[(k[h>>2]|0)+12>>2]&255](h,we,Ce,-1);XN(we);h=(k[V>>2]|0)-(k[d>>2]|0)|0;do if(!h){b=0;t=0;l=0}else{if(((h|0)/28|0)>>>0>153391689)ad(426534,426557,304,426811);while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}G=g;h=k[d>>2]|0;m=k[V>>2]|0;if((h|0)==(m|0)){b=G;t=G;l=G;break}t=G;l=g;do{k[l>>2]=k[h>>2];k[l+4>>2]=k[h+4>>2];we=l+8|0;ve=h+8|0;k[we>>2]=k[ve>>2];k[we+4>>2]=k[ve+4>>2];k[we+8>>2]=k[ve+8>>2];k[we+12>>2]=k[ve+12>>2];k[we+16>>2]=k[ve+16>>2];h=h+28|0;l=t+28|0;t=l}while((h|0)!=(m|0));if((l|0)==(g|0)){b=G;t=G;l=G;break}q=Me+48|0;s=Ie+16|0;b=De+16|0;v=Ne+8|0;w=Ne+12|0;x=Ne+4|0;y=ze+8|0;z=ze+12|0;A=ze+4|0;B=Ae+4|0;D=B+4|0;E=Ce+16|0;n=0;l=G;do{pe=l;ve=~~+o[pe+(n*28|0)>>2];ue=~~+o[pe+(n*28|0)+4>>2];pe=k[pe+(n*28|0)+24>>2]|0;je=k[q>>2]|0;ne=k[je+(pe*468|0)+408>>2]|0;f=k[k[je+(pe*468|0)+436>>2]>>2]|0;ke=ne+(aa(f,ue)|0)+(ve<<2)|0;W=+o[ke+4>>2];qe=+o[ke+-4>>2];se=ue+1|0;le=ne+(aa(f,se)|0)+(ve<<2)|0;re=+o[le>>2];h=ue+-1|0;f=ne+(aa(f,h)|0)+(ve<<2)|0;Re=+o[f>>2];ne=pe+1|0;me=k[je+(ne*468|0)+408>>2]|0;ne=k[k[je+(ne*468|0)+436>>2]>>2]|0;we=me+(aa(ne,ue)|0)+(ve<<2)|0;Se=+o[we>>2];pe=pe+-1|0;oe=k[je+(pe*468|0)+408>>2]|0;pe=k[k[je+(pe*468|0)+436>>2]>>2]|0;ue=oe+(aa(pe,ue)|0)+(ve<<2)|0;C=+o[ue>>2];Ve=+o[ke>>2]*2.0;Ue=(+o[le+4>>2]+ +o[f+-4>>2])*.25-(+o[f+4>>2]+ +o[le+-4>>2])*.25;Te=(+o[we+4>>2]+ +o[ue+-4>>2])*.25-(+o[we+-4>>2]+ +o[ue+4>>2])*.25;ue=me+(aa(ne,se)|0)+(ve<<2)|0;we=oe+(aa(pe,h)|0)+(ve<<2)|0;h=me+(aa(ne,h)|0)+(ve<<2)|0;ve=oe+(aa(pe,se)|0)+(ve<<2)|0;F=(+o[ue>>2]+ +o[we>>2])*.25-(+o[h>>2]+ +o[ve>>2])*.25;ve=k[s>>2]|0;o[ve>>2]=W+qe-Ve;h=k[k[S>>2]>>2]|0;we=ve+h|0;o[we+4>>2]=re+Re-Ve;h=ve+(h<<1)|0;o[h+8>>2]=Se+C-Ve;o[we>>2]=Ue;o[ve+4>>2]=Ue;o[h>>2]=Te;o[ve+8>>2]=Te;o[h+4>>2]=F;o[we+8>>2]=F;we=k[b>>2]|0;o[we>>2]=-((W-qe)*.5);h=k[k[M>>2]>>2]|0;o[we+h>>2]=-((re-Re)*.5);o[we+(h<<1)>>2]=-((Se-C)*.5);k[v>>2]=0;k[w>>2]=0;k[Ne>>2]=16842752;k[x>>2]=Ie;k[y>>2]=0;k[z>>2]=0;k[ze>>2]=16842752;k[A>>2]=De;h=D;k[h>>2]=0;k[h+4>>2]=0;k[Ae>>2]=33619968;k[B>>2]=Ce;NZ(Ne,ze,Ae,0)|0;h=k[E>>2]|0;C=+o[h>>2];do if(!(+P(+C)<=1.0))Be=194;else{l=k[k[H>>2]>>2]|0;m=h+l|0;if(!(+P(+(+o[m>>2]))<=1.0)){Be=194;break}h=h+(l<<1)|0;if(!(+P(+(+o[h>>2]))<=1.0)){Be=194;break}l=g+(n*28|0)|0;o[l>>2]=C+ +o[l>>2];l=g+(n*28|0)+4|0;o[l>>2]=+o[m>>2]+ +o[l>>2];m=g+(n*28|0)+12|0;C=+(k[g+(n*28|0)+20>>2]|0)+(+o[m>>2]+ +o[h>>2])/+(k[ye>>2]|0);F=+o[xe>>2]*2.0;h=(o[u>>2]=C,k[u>>2]|0);l=h&2147483647;do if(l>>>0>1123811328)if(!(h>>>0>1124073471&(h|0)>-1))if((h|0)<0&h>>>0>3272998911){C=0.0;break}else{Be=192;break}else{C=C*1701411834604692317316873.0e14;break}else{if(l>>>0>=855638017){Be=192;break}C=C+1.0}while(0);if((Be|0)==192){Be=0;Ve=C+786432.0;ue=(o[u>>2]=Ve,k[u>>2]|0)+8|0;ve=Apb((ue>>>4)+1023|0,0,52)|0;we=N;Ve=C-(Ve+-786432.0);Ue=+p[27280+((ue&15)<<3)>>3];C=Ve*Ue;k[u>>2]=ve;k[u+4>>2]=we;C=+p[u>>3]*(Ue+(Ve*.24022650718688965+.6931471824645996)*C+(Ve*.009618354961276054+.055505409836769104)*(Ve*Ve*C))}o[g+(n*28|0)+8>>2]=F*C;o[m>>2]=0.0}while(0);if((Be|0)==194){Be=0;o[g+(n*28|0)+16>>2]=-1.0}l=g;n=n+1|0}while(n>>>0<((t-l|0)/28|0)>>>0);b=G}while(0);g=k[d>>2]|0;h=k[V>>2]|0;if((h|0)!=(g|0))k[V>>2]=h+(~(((h+-28-g|0)>>>0)/28|0)*28|0);g=l;if((t|0)!=(l|0)){s=d+8|0;q=0;n=t;while(1){h=g+(q*28|0)|0;do if(+o[g+(q*28|0)+16>>2]!=-1.0){m=k[V>>2]|0;if((m|0)==(k[s>>2]|0)){H6(d,h);l=b;h=t;break}else{k[m>>2]=k[h>>2];k[m+4>>2]=k[g+(q*28|0)+4>>2];h=m+8|0;Be=g+(q*28|0)+8|0;k[h>>2]=k[Be>>2];k[h+4>>2]=k[Be+4>>2];k[h+8>>2]=k[Be+8>>2];k[h+12>>2]=k[Be+12>>2];k[h+16>>2]=k[Be+16>>2];k[V>>2]=(k[V>>2]|0)+28;h=n;break}}else h=n;while(0);q=q+1|0;g=l;if(q>>>0>=((h-l|0)/28|0)>>>0)break;else n=h}}if(g|0)ggb(g);l=Ce+36|0;g=k[l>>2]|0;do if(g|0){Ae=g+12|0;Be=k[Ae>>2]|0;k[Ae>>2]=Be+-1;if((Be|0)!=1)break;h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Ce+32>>2]|0;if(g|0)break;g=B1()|0;h=k[l>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}while(0);k[l>>2]=0;Ce=Ce+16|0;k[Ce>>2]=0;k[Ce+4>>2]=0;k[Ce+8>>2]=0;k[Ce+12>>2]=0;if((k[K>>2]|0)>0){h=k[I>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[K>>2]|0))}g=k[H>>2]|0;if(!((g|0)==(J|0)|(g|0)==0))ggb(k[g+-4>>2]|0);l=De+36|0;g=k[l>>2]|0;do if(g|0){Be=g+12|0;Ce=k[Be>>2]|0;k[Be>>2]=Ce+-1;if((Ce|0)!=1)break;h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[De+32>>2]|0;if(g|0)break;g=B1()|0;h=k[l>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}while(0);k[l>>2]=0;De=De+16|0;k[De>>2]=0;k[De+4>>2]=0;k[De+8>>2]=0;k[De+12>>2]=0;if((k[O>>2]|0)>0){h=k[L>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[O>>2]|0))}g=k[M>>2]|0;if(!((g|0)==(Q|0)|(g|0)==0))ggb(k[g+-4>>2]|0);l=Ie+36|0;g=k[l>>2]|0;do if(g|0){Ce=g+12|0;De=k[Ce>>2]|0;k[Ce>>2]=De+-1;if((De|0)!=1)break;h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Ie+32>>2]|0;if(g|0)break;g=B1()|0;h=k[l>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}while(0);k[l>>2]=0;De=Ie+16|0;k[De>>2]=0;k[De+4>>2]=0;k[De+8>>2]=0;k[De+12>>2]=0;if((k[T>>2]|0)>0){h=k[R>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[T>>2]|0))}g=k[S>>2]|0;if(!((g|0)==(U|0)|(g|0)==0))ggb(k[g+-4>>2]|0)}if(!(G2(c)|0)){do if((k[c>>2]&2031616|0)==65536){m=k[c+4>>2]|0;k[Ne>>2]=k[m>>2];t=Ne+4|0;g=m+4|0;k[t>>2]=k[g>>2];c=Ne+8|0;k[c>>2]=k[m+8>>2];k[Ne+12>>2]=k[m+12>>2];k[Ne+16>>2]=k[m+16>>2];k[Ne+20>>2]=k[m+20>>2];k[Ne+24>>2]=k[m+24>>2];k[Ne+28>>2]=k[m+28>>2];k[Ne+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[Ne+36>>2]=h;l=Ne+40|0;k[l>>2]=c;c=Ne+48|0;q=Ne+44|0;k[q>>2]=c;k[Ne+52>>2]=0;k[c>>2]=0;if(h|0){c=h+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[g>>2]|0)<3){De=k[m+44>>2]|0;c=k[q>>2]|0;k[c>>2]=k[De>>2];k[c+4>>2]=k[De+4>>2];break}k[t>>2]=0;x1(Ne,k[g>>2]|0,0,0,0);if((k[t>>2]|0)<=0)break;s=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;h=k[q>>2]|0;g=0;do{k[n+(g<<2)>>2]=k[s+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[t>>2]|0))}else Q1(Ne,c,-1);while(0);dXa(d,Ne);l=Ne+36|0;g=k[l>>2]|0;if(g|0?(De=g+12|0,c=k[De>>2]|0,k[De>>2]=c+-1,(c|0)==1):0){h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Ne+32>>2]|0;if(g|0)break;g=B1()|0;h=k[l>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}k[l>>2]=0;c=Ne+16|0;h=Ne+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[h>>2]|0)>0){l=k[Ne+40>>2]|0;g=0;do{k[l+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Ne+44>>2]|0;if(!((g|0)==(Ne+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0)}do if(k[e>>2]&2031616|0){q=J2(e,-1)|0;n=d+4|0;g=k[n>>2]|0;h=k[d>>2]|0;if((g|0)==(h|0))h=g;else{m=Ne+4|0;l=0;do{e=k[h+(l*28|0)+24>>2]|0;if(!((e|0)>-1?(e|0)<(((k[X>>2]|0)-(k[Y>>2]|0)|0)/468|0|0):0)){k[Ne>>2]=0;k[m>>2]=0;g=ZT(84)|0;k[g>>2]=1;he=g+4|0;k[Ne>>2]=he;k[m>>2]=79;i[g+83>>0]=0;s=388013;ie=he+79|0;do{i[he>>0]=i[s>>0]|0;he=he+1|0;s=s+1|0}while((he|0)<(ie|0));Y8(-215,Ne,388093,387860,556);k[m>>2]=0;k[Ne>>2]=0;e=k[g>>2]|0;k[g>>2]=e+-1;if((e|0)==1)ggb(k[g+-4>>2]|0);h=k[d>>2]|0;g=k[n>>2]|0}l=l+1|0}while(l>>>0<((g-h|0)/28|0)>>>0)}if(!(i[Ee>>0]|0)){l=(g-h|0)/28|0;k[Ie>>2]=0;k[Ie+4>>2]=0;k[Ie+8>>2]=1124007936;g=Ie+16|0;h=Ie+48|0;he=Ie+12|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=Ie+56|0;k[Ie+52>>2]=g;k[Ie+60>>2]=0;k[g>>2]=0;k[Ie+64>>2]=1124007936;g=Ie+72|0;h=Ie+104|0;he=Ie+68|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=Ie+112|0;k[Ie+108>>2]=g;k[Ie+116>>2]=0;k[g>>2]=0;k[Ie+120>>2]=1124007936;g=Ie+128|0;h=Ie+160|0;he=Ie+124|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;he=Ie+168|0;k[Ie+164>>2]=he;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=64;k[Ne+4>>2]=l;j1(Ie,48,Ne,5);e=k[Ie>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,Ie,q,-1);XN(Ie)}else{l=(g-h|0)/28|0;k[Ie>>2]=0;k[Ie+4>>2]=0;k[Ie+8>>2]=1124007936;g=Ie+16|0;h=Ie+48|0;he=Ie+12|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=Ie+56|0;k[Ie+52>>2]=g;k[Ie+60>>2]=0;k[g>>2]=0;k[Ie+64>>2]=1124007936;g=Ie+72|0;h=Ie+104|0;he=Ie+68|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;g=Ie+112|0;k[Ie+108>>2]=g;k[Ie+116>>2]=0;k[g>>2]=0;k[Ie+120>>2]=1124007936;g=Ie+128|0;h=Ie+160|0;he=Ie+124|0;ie=he+36|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[h>>2]=g;he=Ie+168|0;k[Ie+164>>2]=he;ie=he+56|0;do{k[he>>2]=0;he=he+4|0}while((he|0)<(ie|0));k[Ne>>2]=128;k[Ne+4>>2]=l;j1(Ie,48,Ne,5);e=k[Ie>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,Ie,q,-1);XN(Ie)}he=((k[n>>2]|0)-(k[d>>2]|0)|0)/28|0;k[Ne>>2]=0;k[Ne+4>>2]=he;k[Ie>>2]=142712;k[Ie+4>>2]=d;k[Ie+8>>2]=q;k[Ie+12>>2]=Fe;he=Ie+16|0;s=Me;ie=he+48|0;do{k[he>>2]=k[s>>2];he=he+4|0;s=s+4|0}while((he|0)<(ie|0));SWa(Ie,Ne);g=q+8|0;if(k[g>>2]|0){Ie=k[q+12>>2]|0;if((Ie|0)!=(Xh[k[(k[a>>2]|0)+52>>2]&1023](a)|0)){k[Ne>>2]=0;h=Ne+4|0;k[h>>2]=0;l=ZT(52)|0;k[l>>2]=1;he=l+4|0;k[Ne>>2]=he;k[h>>2]=45;i[l+49>>0]=0;s=387123;ie=he+45|0;do{i[he>>0]=i[s>>0]|0;he=he+1|0;s=s+1|0}while((he|0)<(ie|0));Y8(-215,Ne,390333,387054,155);k[h>>2]=0;k[Ne>>2]=0;Ie=k[l>>2]|0;k[l>>2]=Ie+-1;if((Ie|0)==1)ggb(k[l+-4>>2]|0)}if(!(k[g>>2]|0))break;Ie=k[q>>2]|0;if((Ie&4095|0)==(Xh[k[(k[a>>2]|0)+56>>2]&1023](a)|0))break;k[Ne>>2]=0;g=Ne+4|0;k[g>>2]=0;h=ZT(56)|0;k[h>>2]=1;he=h+4|0;k[Ne>>2]=he;k[g>>2]=49;i[h+53>>0]=0;s=387169;ie=he+49|0;do{i[he>>0]=i[s>>0]|0;he=he+1|0;s=s+1|0}while((he|0)<(ie|0));Y8(-215,Ne,390333,387054,156);k[g>>2]=0;k[Ne>>2]=0;Ne=k[h>>2]|0;k[h>>2]=Ne+-1;if((Ne|0)==1)ggb(k[h+-4>>2]|0)}}while(0);pWa(Me);l=Oe+36|0;g=k[l>>2]|0;if(g|0?(Me=g+12|0,Ne=k[Me>>2]|0,k[Me>>2]=Ne+-1,(Ne|0)==1):0){h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Oe+32>>2]|0;if(g|0)break;g=B1()|0;h=k[l>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}k[l>>2]=0;k[Ge>>2]=0;k[Ge+4>>2]=0;k[Ge+8>>2]=0;k[Ge+12>>2]=0;if((k[Je>>2]|0)>0){h=k[He>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[Je>>2]|0))}g=k[Ke>>2]|0;if(!((g|0)==(Le|0)|(g|0)==0))ggb(k[g+-4>>2]|0);l=Pe+36|0;g=k[l>>2]|0;do if(g|0){Ne=g+12|0;Oe=k[Ne>>2]|0;k[Ne>>2]=Oe+-1;if((Oe|0)!=1)break;h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[Pe+32>>2]|0;if(g|0)break;g=B1()|0;h=k[l>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}while(0);k[l>>2]=0;Oe=Pe+16|0;h=Pe+4|0;k[Oe>>2]=0;k[Oe+4>>2]=0;k[Oe+8>>2]=0;k[Oe+12>>2]=0;if((k[h>>2]|0)>0){l=k[Pe+40>>2]|0;g=0;do{k[l+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[Pe+44>>2]|0;if((g|0)==(Pe+48|0)|(g|0)==0){r=Qe;return}ggb(k[g+-4>>2]|0);r=Qe;return}function aWa(a){a=a|0;return (i[a+4>>0]|0?128:64)|0}function bWa(a){a=a|0;return 5}function cWa(a){a=a|0;return 4}function dWa(a,b){a=a|0;b=b|0;i[a+4>>0]=b&1;return}function eWa(a){a=a|0;return (i[a+4>>0]|0)!=0|0}function fWa(a,b){a=a|0;b=b|0;i[a+5>>0]=b&1;return}function gWa(a){a=a|0;return (i[a+5>>0]|0)!=0|0}function hWa(a,b){a=a|0;b=+b;o[a+8>>2]=b;return}function iWa(a){a=a|0;return +(+o[a+8>>2])}function jWa(a,b){a=a|0;b=b|0;k[a+12>>2]=b;return}function kWa(a){a=a|0;return k[a+12>>2]|0}function lWa(a,b){a=a|0;b=b|0;k[a+16>>2]=b;return}function mWa(a){a=a|0;return k[a+16>>2]|0}function nWa(a,b){a=a|0;b=b|0;k[a+20>>2]=b;return}function oWa(a){a=a|0;return k[a+20>>2]|0}function pWa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;b=k[a+92>>2]|0;c=b;if(b|0){d=a+96|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}g=a+80|0;b=k[g>>2]|0;if(b|0){h=a+84|0;c=k[h>>2]|0;if((c|0)!=(b|0)){do{d=c+-12|0;k[h>>2]=d;e=k[d>>2]|0;f=e;if(!e)c=d;else{c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(e|0))k[c>>2]=d+(~((d+-4-f|0)>>>2)<<2);ggb(e);c=k[h>>2]|0}}while((c|0)!=(b|0));b=k[g>>2]|0}ggb(b)}g=a+60|0;b=k[g>>2]|0;if(b|0){h=a+64|0;c=k[h>>2]|0;if((c|0)!=(b|0)){do{d=c+-12|0;k[h>>2]=d;e=k[d>>2]|0;f=e;if(!e)c=d;else{c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(e|0))k[c>>2]=d+(~(((d+-28-f|0)>>>0)/28|0)*28|0);ggb(e);c=k[h>>2]|0}}while((c|0)!=(b|0));b=k[g>>2]|0}ggb(b)}d=a+48|0;e=k[d>>2]|0;if(!e)return;b=a+52|0;while(1){c=k[b>>2]|0;if((c|0)==(e|0))break;a=c+-468|0;k[b>>2]=a;gUa(a)}ggb(k[d>>2]|0);return}function qWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function rWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0.0,me=0.0;ke=r;r=r+1184|0;he=ke+224|0;ie=ke+704|0;je=ke;Pa=ke+648|0;Oa=ke+592|0;La=ke+536|0;Da=ke+480|0;sa=ke+424|0;ra=ke+368|0;ya=ke+312|0;Ka=ke+256|0;_d=a;Zd=_d+68|0;do{k[_d>>2]=k[b>>2];_d=_d+4|0;b=b+4|0}while((_d|0)<(Zd|0));ce=a+68|0;k[ce>>2]=0;de=a+72|0;k[de>>2]=0;k[a+76>>2]=0;ee=a+88|0;fe=a+92|0;ge=a+104|0;ta=a+112|0;k[ee>>2]=0;k[ee+4>>2]=0;k[ee+8>>2]=0;k[ee+12>>2]=0;k[ee+16>>2]=0;k[ee+20>>2]=0;k[ta>>2]=1124007936;b=a+120|0;c=a+152|0;_d=a+116|0;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[c>>2]=b;Aa=a+160|0;k[a+156>>2]=Aa;k[a+164>>2]=0;k[Aa>>2]=0;Aa=a+168|0;k[Aa>>2]=1124007936;b=a+176|0;c=a+208|0;_d=a+172|0;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[c>>2]=b;b=a+216|0;k[a+212>>2]=b;k[a+220>>2]=0;k[b>>2]=0;k[a+224>>2]=1124007936;b=a+232|0;c=a+264|0;_d=a+228|0;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[c>>2]=b;ae=a+272|0;k[a+268>>2]=ae;k[a+276>>2]=0;k[ae>>2]=0;ae=a+80|0;k[ae>>2]=0;be=a+84|0;i[be>>0]=1;ua=k[a+44>>2]|0;if((ua|0)>0?(k[a+40>>2]|0)>3:0){y=k[a+52>>2]|0;qa=k[a+48>>2]|0;if((qa*162|0)<(ua|0)){k[he>>2]=0;c=he+4|0;k[c>>2]=0;d=ZT(20)|0;k[d>>2]=1;_d=d+4|0;k[he>>2]=_d;k[c>>2]=12;i[d+16>>0]=0;b=387282;Zd=_d+12|0;do{i[_d>>0]=i[b>>0]|0;_d=_d+1|0;b=b+1|0}while((_d|0)<(Zd|0));Y8(-215,he,387295,387323,1628);k[c>>2]=0;k[he>>2]=0;_d=k[d>>2]|0;k[d>>2]=_d+-1;if((_d|0)==1)ggb(k[d+-4>>2]|0)}k[je>>2]=1124007936;Sa=je+4|0;pa=je+8|0;Qa=je+40|0;_d=Sa;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Qa>>2]=pa;Ua=je+48|0;Ta=je+44|0;k[Ta>>2]=Ua;k[je+52>>2]=0;k[Ua>>2]=0;k[he>>2]=162;z=he+4|0;k[z>>2]=5;G1(je,2,he,4);q=+(y|0)*2.0;Ra=je+16|0;s=k[Ra>>2]|0;t=k[Ta>>2]|0;b=0;n=0;v=5;w=3;x=4;while(1){j=n+2|0;l=aa(j,j)|0;m=~~+$(+(q/+(j|0)));a:do if(l){c=0;h=w;while(1){f=c+1|0;if((f|0)>=(l|0))break a;g=(aa((c|0)%(j|0)|0,m)|0)-y|0;e=(aa((c|0)/(j|0)|0,m)|0)-y|0;c=f;d=b;while(1){_d=s+(aa(k[t>>2]|0,d)|0)|0;k[_d>>2]=n;_d=s+(aa(k[t>>2]|0,d)|0)+4|0;k[_d>>2]=g;_d=s+(aa(k[t>>2]|0,d)|0)+8|0;k[_d>>2]=e;_d=(aa((c|0)%(j|0)|0,m)|0)-y|0;Zd=s+(aa(k[t>>2]|0,d)|0)+12|0;k[Zd>>2]=_d;Zd=(aa((c|0)/(j|0)|0,m)|0)-y|0;_d=s+(aa(k[t>>2]|0,d)|0)+16|0;k[_d>>2]=Zd;c=c+1|0;if((c|0)==(x|0))break;else d=d+1|0}c=f;b=b+h|0;h=h+-1|0}}while(0);n=n+1|0;w=w+v|0;x=x+v|0;if((n|0)==3)break;else v=v+2|0}oa=428e3;k[oa>>2]=1023;k[oa+4>>2]=0;oa=~~+$(+(+(ua|0)/+(qa|0)));c=aa(oa,qa)|0;k[Pa>>2]=1124007936;Ia=Pa+4|0;b=Pa+8|0;Ga=Pa+40|0;_d=Ia;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Ga>>2]=b;Ja=Pa+48|0;Ha=Pa+44|0;k[Ha>>2]=Ja;k[Pa+52>>2]=0;k[Ja>>2]=0;k[he>>2]=c;k[z>>2]=2;G1(Pa,2,he,4);p[he>>3]=1.0e3;Ea=he+8|0;k[Ea>>2]=0;k[Ea+4>>2]=0;k[Ea+8>>2]=0;k[Ea+12>>2]=0;k[Ea+16>>2]=0;k[Ea+20>>2]=0;oY(Pa,he);k[Oa>>2]=1124007936;Ea=Oa+4|0;b=Oa+8|0;Ba=Oa+40|0;_d=Ea;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Ba>>2]=b;Fa=Oa+48|0;Ca=Oa+44|0;k[Ca>>2]=Fa;k[Oa+52>>2]=0;k[Fa>>2]=0;k[he>>2]=29;k[z>>2]=3;G1(Oa,2,he,4);k[ie>>2]=1124007936;h=ie+4|0;b=ie+8|0;e=ie+40|0;_d=h;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[e>>2]=b;g=ie+48|0;f=ie+44|0;k[f>>2]=g;k[ie+52>>2]=0;k[g>>2]=0;wa=he+4|0;na=wa+4|0;k[na>>2]=0;k[na+4>>2]=0;k[he>>2]=33619968;k[wa>>2]=ie;mY(je,he);wa=La+4|0;na=La+8|0;va=La+40|0;_d=wa;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[va>>2]=na;za=La+48|0;xa=La+44|0;k[xa>>2]=za;k[La+52>>2]=0;k[za>>2]=0;k[La>>2]=1124007940;vWa(La,ie)|0;d=ie+36|0;b=k[d>>2]|0;if(b|0?(Zd=b+12|0,_d=k[Zd>>2]|0,k[Zd>>2]=_d+-1,(_d|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[ie+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;_d=ie+16|0;k[_d>>2]=0;k[_d+4>>2]=0;k[_d+8>>2]=0;k[_d+12>>2]=0;if((k[h>>2]|0)>0){c=k[e>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[h>>2]|0))}b=k[f>>2]|0;if(!((b|0)==(g|0)|(b|0)==0))ggb(k[b+-4>>2]|0);p[he>>3]=-1.0;_d=he+8|0;k[_d>>2]=0;k[_d+4>>2]=0;k[_d+8>>2]=0;k[_d+12>>2]=0;k[_d+16>>2]=0;k[_d+20>>2]=0;oY(Oa,he);if((oa|0)>0){x=he+4|0;y=ie+4|0;z=Da+4|0;A=sa+4|0;B=Da+8|0;C=sa+8|0;D=Da+12|0;E=sa+12|0;F=Da+16|0;G=sa+16|0;H=Da+20|0;I=sa+20|0;J=Da+24|0;K=sa+24|0;L=Da+28|0;M=sa+28|0;O=Da+32|0;P=sa+32|0;Q=Da+36|0;R=sa+36|0;S=Da+40|0;T=Da+48|0;U=Da+44|0;V=Da+52|0;W=sa+44|0;X=sa+40|0;Y=sa+48|0;Z=he+4|0;_=ie+4|0;ba=he+4|0;ca=ba+4|0;da=ra+36|0;ea=ra+16|0;fa=ra+4|0;ga=ra+40|0;ha=ra+44|0;ia=ra+48|0;ja=La+16|0;ka=Oa+16|0;la=Pa+16|0;ma=ra+32|0;w=0;b=0;do{_d=428e3;_d=Epb(k[_d>>2]|0,k[_d+4>>2]|0,1284865837,1481765933)|0;_d=kpb(_d|0,N|0,1,0)|0;v=N;Zd=428e3;k[Zd>>2]=_d;k[Zd+4>>2]=v;v=ppb(_d|0,v|0,33)|0;v=(w|0)<6?w:(v|0)%((k[pa>>2]|0)-w|0)|0;b:do if((b|0)>0){n=k[ka>>2]|0;d=k[Ca>>2]|0;e=k[d>>2]|0;m=k[ja>>2]|0;c=k[xa>>2]|0;g=k[c>>2]|0;l=m+(aa(g,v)|0)|0;h=k[l>>2]|0;j=l+4|0;l=l+8|0;f=0;while(1){_d=n+(aa(e,f)|0)|0;if(((k[_d>>2]|0)==(h|0)?(k[_d+4>>2]|0)==(k[j>>2]|0):0)?(k[_d+8>>2]|0)==(k[l>>2]|0):0)break;f=f+1|0;if((f|0)>=(b|0)){h=m;f=n;$d=38;break b}}_d=aa(f,qa)|0;h=aa(w,qa)|0;t=k[la>>2]|0;s=k[Ha>>2]|0;Zd=t+(aa(k[s>>2]|0,h)|0)|0;k[Zd>>2]=_d;Zd=t+(aa(k[s>>2]|0,h+1|0)|0)|0;k[Zd>>2]=_d+1;h=t+(aa(k[s>>2]|0,h+2|0)|0)|0;k[h>>2]=_d+2;h=m}else{c=k[xa>>2]|0;d=k[Ca>>2]|0;g=k[c>>2]|0;h=k[ja>>2]|0;e=k[d>>2]|0;f=k[ka>>2]|0;$d=38}while(0);if(($d|0)==38){$d=0;n=h+(aa(g,v)|0)|0;_d=f+(aa(e,b)|0)|0;k[_d>>2]=k[n>>2];_d=h+(aa(k[c>>2]|0,v)|0)+4|0;n=f+(aa(k[d>>2]|0,b)|0)+4|0;k[n>>2]=k[_d>>2];n=h+(aa(k[c>>2]|0,v)|0)+8|0;_d=f+(aa(k[d>>2]|0,b)|0)+8|0;k[_d>>2]=k[n>>2];_d=aa(b,qa)|0;n=aa(w,qa)|0;t=k[la>>2]|0;s=k[Ha>>2]|0;Zd=t+(aa(k[s>>2]|0,n)|0)|0;k[Zd>>2]=_d;Zd=t+(aa(k[s>>2]|0,n+1|0)|0)|0;k[Zd>>2]=_d+1;n=t+(aa(k[s>>2]|0,n+2|0)|0)|0;k[n>>2]=_d+2;b=b+1|0;n=f}c:do if((b|0)>0){e=k[d>>2]|0;f=k[c>>2]|0;m=h+(aa(f,v)|0)|0;j=k[m>>2]|0;l=m+12|0;m=m+16|0;g=0;while(1){_d=n+(aa(e,g)|0)|0;if(((k[_d>>2]|0)==(j|0)?(k[_d+4>>2]|0)==(k[l>>2]|0):0)?(k[_d+8>>2]|0)==(k[m>>2]|0):0)break;g=g+1|0;if((g|0)>=(b|0)){$d=47;break c}}Zd=aa(g,qa)|0;_d=aa(w,qa)|0;Yd=t+(aa(k[s>>2]|0,_d)|0)+4|0;k[Yd>>2]=Zd;Yd=t+(aa(k[s>>2]|0,_d+1|0)|0)+4|0;k[Yd>>2]=Zd+1;_d=t+(aa(k[s>>2]|0,_d+2|0)|0)+4|0;k[_d>>2]=Zd+2}else{f=k[c>>2]|0;e=k[d>>2]|0;$d=47}while(0);if(($d|0)==47){$d=0;_d=h+(aa(f,v)|0)|0;Zd=n+(aa(e,b)|0)|0;k[Zd>>2]=k[_d>>2];Zd=h+(aa(k[c>>2]|0,v)|0)+12|0;_d=n+(aa(k[d>>2]|0,b)|0)+4|0;k[_d>>2]=k[Zd>>2];_d=h+(aa(k[c>>2]|0,v)|0)+16|0;Zd=n+(aa(k[d>>2]|0,b)|0)+8|0;k[Zd>>2]=k[_d>>2];Zd=aa(b,qa)|0;_d=aa(w,qa)|0;Yd=t+(aa(k[s>>2]|0,_d)|0)+4|0;k[Yd>>2]=Zd;Yd=t+(aa(k[s>>2]|0,_d+1|0)|0)+4|0;k[Yd>>2]=Zd+1;_d=t+(aa(k[s>>2]|0,_d+2|0)|0)+4|0;k[_d>>2]=Zd+2;b=b+1|0}k[he>>2]=v;k[x>>2]=v+1;k[ie>>2]=-2147483648;k[y>>2]=2147483647;H1(sa,La,he,ie);k[Da>>2]=k[sa>>2];c=k[A>>2]|0;k[z>>2]=c;k[B>>2]=k[C>>2];k[D>>2]=k[E>>2];k[F>>2]=k[G>>2];k[H>>2]=k[I>>2];k[J>>2]=k[K>>2];k[L>>2]=k[M>>2];k[O>>2]=k[P>>2];d=k[R>>2]|0;k[Q>>2]=d;k[S>>2]=B;k[U>>2]=T;k[V>>2]=0;k[T>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[A>>2]|0}if((c|0)>=3){k[z>>2]=0;x1(Da,c,0,0,0);if((k[z>>2]|0)>0){d=k[X>>2]|0;e=k[S>>2]|0;f=k[W>>2]|0;g=k[U>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[d+(c<<2)>>2];k[g+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[z>>2]|0))}}else{Zd=k[W>>2]|0;_d=k[U>>2]|0;k[_d>>2]=k[Zd>>2];k[_d+4>>2]=k[Zd+4>>2]}c=k[R>>2]|0;if(c|0?(Zd=c+12|0,_d=k[Zd>>2]|0,k[Zd>>2]=_d+-1,(_d|0)==1):0){d=k[R>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[P>>2]|0;if(c|0)break;c=B1()|0;d=k[R>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[R>>2]=0}k[R>>2]=0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[A>>2]|0)>0){d=k[X>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[A>>2]|0))}c=k[W>>2]|0;if(!((c|0)==(Y|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=(k[na>>2]|0)-w|0;k[he>>2]=c+-1;k[Z>>2]=c;k[ie>>2]=-2147483648;k[_>>2]=2147483647;H1(ra,La,he,ie);c=ca;k[c>>2]=0;k[c+4>>2]=0;k[he>>2]=33619968;k[ba>>2]=Da;mY(ra,he);c=k[da>>2]|0;if(c|0?(Zd=c+12|0,_d=k[Zd>>2]|0,k[Zd>>2]=_d+-1,(_d|0)==1):0){d=k[da>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[ma>>2]|0;if(c|0)break;c=B1()|0;d=k[da>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[da>>2]=0}k[da>>2]=0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[fa>>2]|0)>0){d=k[ga>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[fa>>2]|0))}c=k[ha>>2]|0;if(!((c|0)==(ia|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[Q>>2]|0;do if(c|0){Zd=c+12|0;_d=k[Zd>>2]|0;k[Zd>>2]=_d+-1;if((_d|0)!=1)break;d=k[Q>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[O>>2]|0;if(c|0)break;c=B1()|0;d=k[Q>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[Q>>2]=0}while(0);k[Q>>2]=0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[z>>2]|0)>0){d=k[S>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[z>>2]|0))}c=k[U>>2]|0;if(!((c|0)==(T|0)|(c|0)==0))ggb(k[c+-4>>2]|0);w=w+1|0}while((w|0)<(oa|0))}else b=0;k[he>>2]=0;k[he+4>>2]=b;k[ie>>2]=-2147483648;k[ie+4>>2]=2147483647;H1(ya,Oa,he,ie);k[Da>>2]=1124007936;h=Da+4|0;b=Da+8|0;f=Da+40|0;_d=h;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[f>>2]=b;g=Da+48|0;e=Da+44|0;k[e>>2]=g;k[Da+52>>2]=0;k[g>>2]=0;d=he+4|0;b=d+4|0;k[b>>2]=0;k[b+4>>2]=0;k[he>>2]=33619968;k[d>>2]=Da;mY(ya,he);KG(ta,Da)|0;d=Da+36|0;b=k[d>>2]|0;if(b|0?(Zd=b+12|0,_d=k[Zd>>2]|0,k[Zd>>2]=_d+-1,(_d|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[Da+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;_d=Da+16|0;k[_d>>2]=0;k[_d+4>>2]=0;k[_d+8>>2]=0;k[_d+12>>2]=0;if((k[h>>2]|0)>0){c=k[f>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[h>>2]|0))}b=k[e>>2]|0;if(!((b|0)==(g|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=ya+36|0;b=k[d>>2]|0;if(b|0?(Zd=b+12|0,_d=k[Zd>>2]|0,k[Zd>>2]=_d+-1,(_d|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[ya+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;_d=ya+16|0;c=ya+4|0;k[_d>>2]=0;k[_d+4>>2]=0;k[_d+8>>2]=0;k[_d+12>>2]=0;if((k[c>>2]|0)>0){d=k[ya+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[ya+44>>2]|0;if(!((b|0)==(ya+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);k[he>>2]=0;k[he+4>>2]=ua;k[ie>>2]=-2147483648;k[ie+4>>2]=2147483647;H1(Ka,Pa,he,ie);k[Da>>2]=1124007936;h=Da+4|0;b=Da+8|0;f=Da+40|0;_d=h;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[f>>2]=b;g=Da+48|0;e=Da+44|0;k[e>>2]=g;k[Da+52>>2]=0;k[g>>2]=0;d=he+4|0;b=d+4|0;k[b>>2]=0;k[b+4>>2]=0;k[he>>2]=33619968;k[d>>2]=Da;mY(Ka,he);KG(Aa,Da)|0;d=Da+36|0;b=k[d>>2]|0;if(b|0?(Zd=b+12|0,_d=k[Zd>>2]|0,k[Zd>>2]=_d+-1,(_d|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Da+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;_d=Da+16|0;k[_d>>2]=0;k[_d+4>>2]=0;k[_d+8>>2]=0;k[_d+12>>2]=0;if((k[h>>2]|0)>0){c=k[f>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[h>>2]|0))}b=k[e>>2]|0;if(!((b|0)==(g|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=Ka+36|0;b=k[d>>2]|0;if(b|0?(Zd=b+12|0,_d=k[Zd>>2]|0,k[Zd>>2]=_d+-1,(_d|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Ka+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;_d=Ka+16|0;c=Ka+4|0;k[_d>>2]=0;k[_d+4>>2]=0;k[_d+8>>2]=0;k[_d+12>>2]=0;if((k[c>>2]|0)>0){d=k[Ka+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[Ka+44>>2]|0;if(!((b|0)==(Ka+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=La+36|0;b=k[d>>2]|0;do if(b|0){Zd=b+12|0;_d=k[Zd>>2]|0;k[Zd>>2]=_d+-1;if((_d|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[La+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;_d=La+16|0;k[_d>>2]=0;k[_d+4>>2]=0;k[_d+8>>2]=0;k[_d+12>>2]=0;if((k[wa>>2]|0)>0){c=k[va>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[wa>>2]|0))}b=k[xa>>2]|0;if(!((b|0)==(za|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=Oa+36|0;b=k[d>>2]|0;do if(b|0){Zd=b+12|0;_d=k[Zd>>2]|0;k[Zd>>2]=_d+-1;if((_d|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Oa+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;_d=Oa+16|0;k[_d>>2]=0;k[_d+4>>2]=0;k[_d+8>>2]=0;k[_d+12>>2]=0;if((k[Ea>>2]|0)>0){c=k[Ba>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ea>>2]|0))}b=k[Ca>>2]|0;if(!((b|0)==(Fa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=Pa+36|0;b=k[d>>2]|0;do if(b|0){Zd=b+12|0;_d=k[Zd>>2]|0;k[Zd>>2]=_d+-1;if((_d|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[Pa+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;_d=Pa+16|0;k[_d>>2]=0;k[_d+4>>2]=0;k[_d+8>>2]=0;k[_d+12>>2]=0;if((k[Ia>>2]|0)>0){c=k[Ga>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ia>>2]|0))}b=k[Ha>>2]|0;if(!((b|0)==(Ja|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=je+36|0;b=k[d>>2]|0;do if(b|0){Zd=b+12|0;_d=k[Zd>>2]|0;k[Zd>>2]=_d+-1;if((_d|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[je+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;k[Ra>>2]=0;k[Ra+4>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;if((k[Sa>>2]|0)>0){c=k[Qa>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Sa>>2]|0))}b=k[Ta>>2]|0;if(!((b|0)==(Ua|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}d:do if((k[a>>2]|0)>0){Gb=a+12|0;Hb=a+8|0;Ib=a+4|0;Jb=ie+4|0;Kb=ie+8|0;Lb=ie+40|0;Mb=ie+48|0;Nb=ie+44|0;Ob=ie+52|0;Pb=ie+56|0;Qb=ie+60|0;Rb=ie+64|0;Sb=ie+96|0;Tb=ie+104|0;Ub=ie+100|0;Vb=ie+108|0;Wb=ie+112|0;Xb=ie+116|0;Yb=ie+120|0;Zb=ie+152|0;_b=ie+160|0;$b=ie+156|0;ac=ie+164|0;bc=ie+168|0;cc=ie+172|0;dc=ie+176|0;ec=ie+208|0;fc=ie+216|0;gc=ie+212|0;hc=ie+220|0;ic=ie+224|0;jc=ie+228|0;kc=ie+232|0;lc=ie+264|0;mc=ie+272|0;nc=ie+268|0;oc=ie+276|0;pc=ie+280|0;qc=ie+284|0;rc=ie+288|0;sc=ie+320|0;tc=ie+328|0;uc=ie+324|0;vc=ie+332|0;wc=ie+336|0;xc=ie+340|0;yc=ie+344|0;zc=ie+376|0;Ac=ie+384|0;Bc=ie+380|0;Cc=ie+388|0;Dc=ie+392|0;Ec=ie+396|0;Fc=ie+400|0;Gc=ie+432|0;Hc=ie+440|0;Ic=ie+436|0;Jc=ie+56|0;Kc=ie+112|0;Lc=ie+168|0;Mc=ie+224|0;Nc=ie+280|0;Oc=ie+392|0;Pc=ie+336|0;Qc=a+16|0;Rc=ie+452|0;Sc=ie+464|0;Tc=ie+448|0;Uc=ie+456|0;Vc=ie+460|0;Wc=a+76|0;Xc=je+4|0;Yc=je+8|0;Zc=je+12|0;_c=je+16|0;$c=je+48|0;ad=je+56|0;bd=je+52|0;cd=je+60|0;dd=je+64|0;ed=je+68|0;fd=je+72|0;gd=je+104|0;hd=je+112|0;id=je+108|0;jd=je+116|0;kd=je+120|0;ld=je+124|0;md=je+128|0;nd=je+160|0;od=je+168|0;pd=je+164|0;qd=he+4|0;rd=je+4|0;sd=je+8|0;td=je+12|0;ud=je+16|0;vd=je+48|0;wd=je+56|0;xd=je+52|0;yd=je+60|0;zd=je+64|0;Ad=je+68|0;Bd=je+72|0;Cd=je+104|0;Dd=je+112|0;Ed=je+108|0;Fd=je+116|0;Gd=je+120|0;Hd=je+124|0;Id=je+128|0;Jd=je+160|0;Kd=je+168|0;Ld=je+164|0;Md=he+4|0;Nd=je+4|0;Od=je+8|0;Pd=je+12|0;Qd=je+16|0;Rd=je+48|0;Sd=je+56|0;Td=je+52|0;Ud=je+60|0;Vd=je+64|0;Wd=je+68|0;Xd=je+72|0;Yd=je+104|0;j=je+112|0;l=je+108|0;m=je+116|0;n=je+120|0;s=je+124|0;t=je+128|0;v=je+160|0;w=je+168|0;x=je+164|0;y=he+4|0;z=je+4|0;A=je+8|0;B=je+12|0;C=je+16|0;D=je+48|0;E=je+56|0;F=je+52|0;G=je+60|0;H=je+64|0;I=je+68|0;J=je+72|0;K=je+104|0;L=je+112|0;M=je+108|0;O=je+116|0;P=je+120|0;Q=je+124|0;R=je+128|0;S=je+160|0;T=je+168|0;U=je+164|0;V=he+4|0;W=je+4|0;X=je+8|0;Y=je+12|0;Z=je+16|0;_=je+48|0;ba=je+56|0;ca=je+52|0;da=je+60|0;ea=je+64|0;fa=je+68|0;ga=je+72|0;ha=je+104|0;ia=je+112|0;ja=je+108|0;ka=je+116|0;la=je+120|0;ma=je+124|0;na=je+128|0;oa=je+160|0;pa=je+168|0;qa=je+164|0;ra=he+4|0;sa=je+4|0;ta=je+8|0;ua=je+12|0;va=je+16|0;wa=je+48|0;xa=je+56|0;ya=je+52|0;za=je+60|0;Aa=je+64|0;Ba=je+68|0;Ca=je+72|0;Da=je+104|0;Ea=je+112|0;Fa=je+108|0;Ga=je+116|0;Ha=je+120|0;Ia=je+124|0;Ja=je+128|0;Ka=je+160|0;La=je+168|0;Oa=je+164|0;Pa=he+4|0;Qa=je+4|0;Ra=je+8|0;Sa=je+12|0;Ta=je+16|0;Ua=je+48|0;Va=je+56|0;Wa=je+52|0;Xa=je+60|0;Ya=je+64|0;Za=je+68|0;_a=je+72|0;$a=je+104|0;ab=je+112|0;bb=je+108|0;cb=je+116|0;db=je+120|0;eb=je+124|0;fb=je+128|0;gb=je+160|0;hb=je+168|0;ib=je+164|0;jb=he+4|0;kb=je+4|0;lb=je+8|0;mb=je+12|0;nb=je+16|0;ob=je+48|0;pb=je+56|0;qb=je+52|0;rb=je+60|0;sb=je+64|0;tb=je+68|0;ub=je+72|0;vb=je+104|0;wb=je+112|0;xb=je+108|0;yb=je+116|0;zb=je+120|0;Ab=je+124|0;Bb=je+128|0;Cb=je+160|0;Db=je+168|0;Eb=je+164|0;Fb=he+4|0;h=1;b=0;while(1){Na=1.0/+(h|0);f=~~(Na*+(k[Gb>>2]|0));g=~~(Na*+(k[Hb>>2]|0));if((b|0)!=0&((f|0)<40|(g|0)<80))break;if((k[Ib>>2]|0)>0){Na=+(b|0);e=0;do{k[ie>>2]=1124007936;_d=Jb;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Lb>>2]=Kb;k[Nb>>2]=Mb;k[Ob>>2]=0;k[Mb>>2]=0;k[Pb>>2]=1124007936;_d=Qb;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Sb>>2]=Rb;k[Ub>>2]=Tb;k[Vb>>2]=0;k[Tb>>2]=0;k[Wb>>2]=1124007936;_d=Xb;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Zb>>2]=Yb;k[$b>>2]=_b;k[ac>>2]=0;k[_b>>2]=0;k[bc>>2]=1124007936;_d=cc;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[ec>>2]=dc;k[gc>>2]=fc;k[hc>>2]=0;k[fc>>2]=0;k[ic>>2]=1124007936;_d=jc;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[lc>>2]=kc;k[nc>>2]=mc;k[oc>>2]=0;k[mc>>2]=0;k[pc>>2]=1124007936;_d=qc;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[sc>>2]=rc;k[uc>>2]=tc;k[vc>>2]=0;k[tc>>2]=0;k[wc>>2]=1124007936;_d=xc;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[zc>>2]=yc;k[Bc>>2]=Ac;k[Cc>>2]=0;k[Ac>>2]=0;k[Dc>>2]=1124007936;_d=Ec;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Gc>>2]=Fc;k[Ic>>2]=Hc;k[Hc>>2]=0;k[Hc+4>>2]=0;k[Hc+8>>2]=0;k[Hc+12>>2]=0;k[Hc+16>>2]=0;k[Hc+20>>2]=0;k[Hc+24>>2]=0;k[je>>2]=0;k[Xc>>2]=0;k[Yc>>2]=1124007936;_d=Zc;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[$c>>2]=_c;k[bd>>2]=ad;k[cd>>2]=0;k[ad>>2]=0;k[dd>>2]=1124007936;_d=ed;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[gd>>2]=fd;k[id>>2]=hd;k[jd>>2]=0;k[hd>>2]=0;k[kd>>2]=1124007936;_d=ld;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[nd>>2]=md;k[pd>>2]=od;_d=od;Zd=_d+56|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[he>>2]=g;k[qd>>2]=f;j1(je,48,he,5);_d=k[je>>2]|0;dh[k[(k[_d>>2]|0)+12>>2]&255](_d,je,ie,-1);XN(je);k[je>>2]=0;k[rd>>2]=0;k[sd>>2]=1124007936;_d=td;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[vd>>2]=ud;k[xd>>2]=wd;k[yd>>2]=0;k[wd>>2]=0;k[zd>>2]=1124007936;_d=Ad;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Cd>>2]=Bd;k[Ed>>2]=Dd;k[Fd>>2]=0;k[Dd>>2]=0;k[Gd>>2]=1124007936;_d=Hd;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Jd>>2]=Id;k[Ld>>2]=Kd;_d=Kd;Zd=_d+56|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[he>>2]=g;k[Md>>2]=f;j1(je,48,he,5);_d=k[je>>2]|0;dh[k[(k[_d>>2]|0)+12>>2]&255](_d,je,Jc,-1);XN(je);k[je>>2]=0;k[Nd>>2]=0;k[Od>>2]=1124007936;_d=Pd;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Rd>>2]=Qd;k[Td>>2]=Sd;k[Ud>>2]=0;k[Sd>>2]=0;k[Vd>>2]=1124007936;_d=Wd;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Yd>>2]=Xd;k[l>>2]=j;k[m>>2]=0;k[j>>2]=0;k[n>>2]=1124007936;_d=s;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[v>>2]=t;k[x>>2]=w;_d=w;Zd=_d+56|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[he>>2]=g;k[y>>2]=f;j1(je,48,he,5);_d=k[je>>2]|0;dh[k[(k[_d>>2]|0)+12>>2]&255](_d,je,Kc,-1);XN(je);k[je>>2]=0;k[z>>2]=0;k[A>>2]=1124007936;_d=B;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[D>>2]=C;k[F>>2]=E;k[G>>2]=0;k[E>>2]=0;k[H>>2]=1124007936;_d=I;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[K>>2]=J;k[M>>2]=L;k[O>>2]=0;k[L>>2]=0;k[P>>2]=1124007936;_d=Q;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[S>>2]=R;k[U>>2]=T;_d=T;Zd=_d+56|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[he>>2]=g;k[V>>2]=f;j1(je,48,he,5);_d=k[je>>2]|0;dh[k[(k[_d>>2]|0)+12>>2]&255](_d,je,Lc,-1);XN(je);k[je>>2]=0;k[W>>2]=0;k[X>>2]=1124007936;_d=Y;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[_>>2]=Z;k[ca>>2]=ba;k[da>>2]=0;k[ba>>2]=0;k[ea>>2]=1124007936;_d=fa;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[ha>>2]=ga;k[ja>>2]=ia;k[ka>>2]=0;k[ia>>2]=0;k[la>>2]=1124007936;_d=ma;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[oa>>2]=na;k[qa>>2]=pa;_d=pa;Zd=_d+56|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[he>>2]=g;k[ra>>2]=f;j1(je,48,he,5);_d=k[je>>2]|0;dh[k[(k[_d>>2]|0)+12>>2]&255](_d,je,Mc,-1);XN(je);k[je>>2]=0;k[sa>>2]=0;k[ta>>2]=1124007936;_d=ua;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[wa>>2]=va;k[ya>>2]=xa;k[za>>2]=0;k[xa>>2]=0;k[Aa>>2]=1124007936;_d=Ba;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Da>>2]=Ca;k[Fa>>2]=Ea;k[Ga>>2]=0;k[Ea>>2]=0;k[Ha>>2]=1124007936;_d=Ia;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Ka>>2]=Ja;k[Oa>>2]=La;_d=La;Zd=_d+56|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[he>>2]=g;k[Pa>>2]=f;j1(je,48,he,5);_d=k[je>>2]|0;dh[k[(k[_d>>2]|0)+12>>2]&255](_d,je,Nc,-1);XN(je);k[je>>2]=0;k[Qa>>2]=0;k[Ra>>2]=1124007936;_d=Sa;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Ua>>2]=Ta;k[Wa>>2]=Va;k[Xa>>2]=0;k[Va>>2]=0;k[Ya>>2]=1124007936;_d=Za;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[$a>>2]=_a;k[bb>>2]=ab;k[cb>>2]=0;k[ab>>2]=0;k[db>>2]=1124007936;_d=eb;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[gb>>2]=fb;k[ib>>2]=hb;_d=hb;Zd=_d+56|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[he>>2]=g;k[jb>>2]=f;j1(je,48,he,5);_d=k[je>>2]|0;dh[k[(k[_d>>2]|0)+12>>2]&255](_d,je,Oc,-1);XN(je);k[je>>2]=0;k[kb>>2]=0;k[lb>>2]=1124007936;_d=mb;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[ob>>2]=nb;k[qb>>2]=pb;k[rb>>2]=0;k[pb>>2]=0;k[sb>>2]=1124007936;_d=tb;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[vb>>2]=ub;k[xb>>2]=wb;k[yb>>2]=0;k[wb>>2]=0;k[zb>>2]=1124007936;_d=Ab;Zd=_d+36|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[Cb>>2]=Bb;k[Eb>>2]=Db;_d=Db;Zd=_d+56|0;do{k[_d>>2]=0;_d=_d+4|0}while((_d|0)<(Zd|0));k[he>>2]=g;k[Fb>>2]=f;j1(je,48,he,5);c=k[je>>2]|0;dh[k[(k[c>>2]|0)+12>>2]&255](c,je,Pc,-1);XN(je);Ma=+o[Qc>>2];q=Na+ +(e|0)/+(k[Ib>>2]|0);c=(o[u>>2]=q,k[u>>2]|0);d=c&2147483647;do if(d>>>0>1123811328)if(!(c>>>0>1124073471&(c|0)>-1))if((c|0)<0&c>>>0>3272998911){q=0.0;break}else{$d=214;break}else{q=q*1701411834604692317316873.0e14;break}else if(d>>>0<855638017)q=q+1.0;else $d=214;while(0);if(($d|0)==214){$d=0;le=q+786432.0;d=(o[u>>2]=le,k[u>>2]|0)+8|0;Zd=Apb((d>>>4)+1023|0,0,52)|0;_d=N;le=q-(le+-786432.0);me=+p[27280+((d&15)<<3)>>3];q=le*me;k[u>>2]=Zd;k[u+4>>2]=_d;q=+p[u>>3]*(me+(le*.24022650718688965+.6931471824645996)*q+(le*.009618354961276054+.055505409836769104)*(le*le*q))}me=Ma*q;o[Rc>>2]=me;k[Sc>>2]=~~(me+.5);o[Tc>>2]=me*me*.5;k[Uc>>2]=b;k[Vc>>2]=e;c=k[de>>2]|0;if((c|0)==(k[Wc>>2]|0))tWa(ce,ie);else{sWa(c,ie);k[de>>2]=(k[de>>2]|0)+468}gUa(ie);e=e+1|0}while((e|0)<(k[Ib>>2]|0))}b=b+1|0;if((b|0)<(k[a>>2]|0))h=h<<1;else break d}k[a>>2]=b}while(0);b=k[ce>>2]|0;if((((k[de>>2]|0)-b|0)/468|0)>>>0<=1){r=ke;return}g=ie+4|0;h=ie+8|0;j=a+108|0;l=a+100|0;f=a+96|0;e=1;do{k[he>>2]=0;k[ie>>2]=0;k[g>>2]=0;k[h>>2]=0;me=+o[b+(e*468|0)+448>>2]-+o[b+((e+-1|0)*468|0)+448>>2];o[je>>2]=.25;b=TWa(me,1,je,be,ie)|0;k[he>>2]=b;c=k[ge>>2]|0;if((c|0)==(k[j>>2]|0))Q4(l,he);else{k[c>>2]=b;k[ge>>2]=c+4}b=k[fe>>2]|0;if((b|0)==(k[f>>2]|0))uWa(ee,ie);else{BH(b,ie);k[fe>>2]=(k[fe>>2]|0)+12}k[ae>>2]=(k[ae>>2]|0)+1;b=k[ie>>2]|0;c=b;if(b|0){d=k[g>>2]|0;if((d|0)!=(b|0))k[g>>2]=d+(~((d+-4-c|0)>>>2)<<2);ggb(b)}e=e+1|0;b=k[ce>>2]|0}while(e>>>0<(((k[de>>2]|0)-b|0)/468|0)>>>0);r=ke;return}function sWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b>>2];i=a+4|0;d=b+4|0;k[i>>2]=k[d>>2];h=a+8|0;k[h>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];k[a+20>>2]=k[b+20>>2];k[a+24>>2]=k[b+24>>2];k[a+28>>2]=k[b+28>>2];k[a+32>>2]=k[b+32>>2];c=k[b+36>>2]|0;k[a+36>>2]=c;e=a+40|0;k[e>>2]=h;h=a+48|0;g=a+44|0;k[g>>2]=h;k[a+52>>2]=0;k[h>>2]=0;if(c|0){h=c+12|0;k[h>>2]=(k[h>>2]|0)+1}if((k[d>>2]|0)>=3){k[i>>2]=0;x1(a,k[d>>2]|0,0,0,0);if((k[i>>2]|0)>0){h=k[b+40>>2]|0;e=k[e>>2]|0;f=k[b+44>>2]|0;d=k[g>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[h+(c<<2)>>2];k[d+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{h=k[b+44>>2]|0;i=k[g>>2]|0;k[i>>2]=k[h>>2];k[i+4>>2]=k[h+4>>2]}c=a+56|0;k[c>>2]=k[b+56>>2];i=a+60|0;d=b+60|0;k[i>>2]=k[d>>2];g=a+64|0;k[g>>2]=k[b+64>>2];k[a+68>>2]=k[b+68>>2];k[a+72>>2]=k[b+72>>2];k[a+76>>2]=k[b+76>>2];k[a+80>>2]=k[b+80>>2];k[a+84>>2]=k[b+84>>2];k[a+88>>2]=k[b+88>>2];e=k[b+92>>2]|0;k[a+92>>2]=e;f=a+96|0;k[f>>2]=g;g=a+104|0;h=a+100|0;k[h>>2]=g;k[a+108>>2]=0;k[g>>2]=0;if(e|0){g=e+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[d>>2]|0)>=3){k[i>>2]=0;x1(c,k[d>>2]|0,0,0,0);if((k[i>>2]|0)>0){g=k[b+96>>2]|0;e=k[f>>2]|0;f=k[b+100>>2]|0;d=k[h>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{g=k[b+100>>2]|0;i=k[h>>2]|0;k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2]}c=a+112|0;k[c>>2]=k[b+112>>2];i=a+116|0;d=b+116|0;k[i>>2]=k[d>>2];g=a+120|0;k[g>>2]=k[b+120>>2];k[a+124>>2]=k[b+124>>2];k[a+128>>2]=k[b+128>>2];k[a+132>>2]=k[b+132>>2];k[a+136>>2]=k[b+136>>2];k[a+140>>2]=k[b+140>>2];k[a+144>>2]=k[b+144>>2];e=k[b+148>>2]|0;k[a+148>>2]=e;f=a+152|0;k[f>>2]=g;g=a+160|0;h=a+156|0;k[h>>2]=g;k[a+164>>2]=0;k[g>>2]=0;if(e|0){g=e+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[d>>2]|0)>=3){k[i>>2]=0;x1(c,k[d>>2]|0,0,0,0);if((k[i>>2]|0)>0){g=k[b+152>>2]|0;e=k[f>>2]|0;f=k[b+156>>2]|0;d=k[h>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{g=k[b+156>>2]|0;i=k[h>>2]|0;k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2]}c=a+168|0;k[c>>2]=k[b+168>>2];i=a+172|0;d=b+172|0;k[i>>2]=k[d>>2];g=a+176|0;k[g>>2]=k[b+176>>2];k[a+180>>2]=k[b+180>>2];k[a+184>>2]=k[b+184>>2];k[a+188>>2]=k[b+188>>2];k[a+192>>2]=k[b+192>>2];k[a+196>>2]=k[b+196>>2];k[a+200>>2]=k[b+200>>2];e=k[b+204>>2]|0;k[a+204>>2]=e;f=a+208|0;k[f>>2]=g;g=a+216|0;h=a+212|0;k[h>>2]=g;k[a+220>>2]=0;k[g>>2]=0;if(e|0){g=e+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[d>>2]|0)>=3){k[i>>2]=0;x1(c,k[d>>2]|0,0,0,0);if((k[i>>2]|0)>0){g=k[b+208>>2]|0;e=k[f>>2]|0;f=k[b+212>>2]|0;d=k[h>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{g=k[b+212>>2]|0;i=k[h>>2]|0;k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2]}c=a+224|0;k[c>>2]=k[b+224>>2];i=a+228|0;d=b+228|0;k[i>>2]=k[d>>2];g=a+232|0;k[g>>2]=k[b+232>>2];k[a+236>>2]=k[b+236>>2];k[a+240>>2]=k[b+240>>2];k[a+244>>2]=k[b+244>>2];k[a+248>>2]=k[b+248>>2];k[a+252>>2]=k[b+252>>2];k[a+256>>2]=k[b+256>>2];e=k[b+260>>2]|0;k[a+260>>2]=e;f=a+264|0;k[f>>2]=g;g=a+272|0;h=a+268|0;k[h>>2]=g;k[a+276>>2]=0;k[g>>2]=0;if(e|0){g=e+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[d>>2]|0)>=3){k[i>>2]=0;x1(c,k[d>>2]|0,0,0,0);if((k[i>>2]|0)>0){g=k[b+264>>2]|0;e=k[f>>2]|0;f=k[b+268>>2]|0;d=k[h>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{g=k[b+268>>2]|0;i=k[h>>2]|0;k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2]}c=a+280|0;k[c>>2]=k[b+280>>2];i=a+284|0;d=b+284|0;k[i>>2]=k[d>>2];g=a+288|0;k[g>>2]=k[b+288>>2];k[a+292>>2]=k[b+292>>2];k[a+296>>2]=k[b+296>>2];k[a+300>>2]=k[b+300>>2];k[a+304>>2]=k[b+304>>2];k[a+308>>2]=k[b+308>>2];k[a+312>>2]=k[b+312>>2];e=k[b+316>>2]|0;k[a+316>>2]=e;f=a+320|0;k[f>>2]=g;g=a+328|0;h=a+324|0;k[h>>2]=g;k[a+332>>2]=0;k[g>>2]=0;if(e|0){g=e+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[d>>2]|0)>=3){k[i>>2]=0;x1(c,k[d>>2]|0,0,0,0);if((k[i>>2]|0)>0){g=k[b+320>>2]|0;e=k[f>>2]|0;f=k[b+324>>2]|0;d=k[h>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{g=k[b+324>>2]|0;i=k[h>>2]|0;k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2]}c=a+336|0;k[c>>2]=k[b+336>>2];i=a+340|0;d=b+340|0;k[i>>2]=k[d>>2];g=a+344|0;k[g>>2]=k[b+344>>2];k[a+348>>2]=k[b+348>>2];k[a+352>>2]=k[b+352>>2];k[a+356>>2]=k[b+356>>2];k[a+360>>2]=k[b+360>>2];k[a+364>>2]=k[b+364>>2];k[a+368>>2]=k[b+368>>2];e=k[b+372>>2]|0;k[a+372>>2]=e;f=a+376|0;k[f>>2]=g;g=a+384|0;h=a+380|0;k[h>>2]=g;k[a+388>>2]=0;k[g>>2]=0;if(e|0){g=e+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[d>>2]|0)>=3){k[i>>2]=0;x1(c,k[d>>2]|0,0,0,0);if((k[i>>2]|0)>0){g=k[b+376>>2]|0;e=k[f>>2]|0;f=k[b+380>>2]|0;d=k[h>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{g=k[b+380>>2]|0;i=k[h>>2]|0;k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2]}c=a+392|0;k[c>>2]=k[b+392>>2];i=a+396|0;d=b+396|0;k[i>>2]=k[d>>2];g=a+400|0;k[g>>2]=k[b+400>>2];k[a+404>>2]=k[b+404>>2];k[a+408>>2]=k[b+408>>2];k[a+412>>2]=k[b+412>>2];k[a+416>>2]=k[b+416>>2];k[a+420>>2]=k[b+420>>2];k[a+424>>2]=k[b+424>>2];e=k[b+428>>2]|0;k[a+428>>2]=e;f=a+432|0;k[f>>2]=g;g=a+440|0;h=a+436|0;k[h>>2]=g;k[a+444>>2]=0;k[g>>2]=0;if(e|0){g=e+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[d>>2]|0)<3){g=k[b+436>>2]|0;i=k[h>>2]|0;k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2];a=a+448|0;b=b+448|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];return}k[i>>2]=0;x1(c,k[d>>2]|0,0,0,0);if((k[i>>2]|0)<=0){a=a+448|0;b=b+448|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];return}g=k[b+432>>2]|0;e=k[f>>2]|0;f=k[b+436>>2]|0;d=k[h>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));a=a+448|0;b=b+448|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];return}function tWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;h=a+4|0;c=k[a>>2]|0;e=((k[h>>2]|0)-c|0)/468|0;d=e+1|0;if(d>>>0>9177280)ad(426534,426557,304,426811);i=a+8|0;g=((k[i>>2]|0)-c|0)/468|0;f=g<<1;f=g>>>0<4588640?(f>>>0<d>>>0?d:f):9177280;if(!f)c=0;else{if(f>>>0>9177280){i=te(4)|0;k[i>>2]=172664;Cf(i|0,28816,1287)}d=f*468|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(e*468|0)|0;d=e;g=c+(f*468|0)|0;sWa(e,b);b=e+468|0;f=k[a>>2]|0;c=k[h>>2]|0;if((c|0)==(f|0)){c=f;e=c}else{do{c=c+-468|0;sWa(e+-468|0,c);e=d+-468|0;d=e}while((c|0)!=(f|0));e=k[a>>2]|0;c=k[h>>2]|0}k[a>>2]=d;k[h>>2]=b;k[i>>2]=g;d=e;while(1){if((c|0)==(d|0))break;c=c+-468|0;gUa(c)}if(!e)return;ggb(e);return}function uWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+4|0;c=k[a>>2]|0;e=((k[i>>2]|0)-c|0)/12|0;d=e+1|0;if(d>>>0>357913941)ad(426534,426557,304,426811);j=a+8|0;h=((k[j>>2]|0)-c|0)/12|0;f=h<<1;f=h>>>0<178956970?(f>>>0<d>>>0?d:f):357913941;if(!f)c=0;else{if(f>>>0>357913941){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=f*12|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}d=c+(e*12|0)|0;e=d;g=c+(f*12|0)|0;BH(d,b);b=d+12|0;f=k[a>>2]|0;c=k[i>>2]|0;if((c|0)==(f|0)){c=e;h=f;e=f}else{do{c=c+-12|0;BH(d+-12|0,c);d=e+-12|0;e=d}while((c|0)!=(f|0));c=e;h=k[a>>2]|0;e=k[i>>2]|0}k[a>>2]=c;k[i>>2]=b;k[j>>2]=g;g=h;if((e|0)!=(g|0))do{c=e;e=e+-12|0;f=k[e>>2]|0;b=f;if(f|0){c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(f|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);ggb(f)}}while((e|0)!=(g|0));if(!h)return;ggb(h);return}function vWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=r;r=r+64|0;e=f;c=k[b>>2]|0;if((c&4095|0)==4){KG(a,b)|0;e=a;r=f;return e|0}if((c&7|0)!=4){d=e+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[e>>2]=-2113863676;k[d>>2]=a;SW(b,e,4,1.0,0.0);e=a;r=f;return e|0}p4(e,b,k[b+4>>2]|0);d=vWa(a,e)|0;c=e+36|0;a=k[c>>2]|0;if(a|0?(a=a+12|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[e+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;c=e+16|0;b=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[b>>2]|0)>0){c=k[e+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[e+44>>2]|0;if(!((a|0)==(e+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=d;r=f;return e|0}function wWa(a){a=a|0;ggb(a);return}function xWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0.0;j=r;r=r+224|0;i=j;c=k[b>>2]|0;g=b+4|0;if((c|0)>=(k[g>>2]|0)){r=j;return}h=k[a+4>>2]|0;f=a+28|0;do{e=k[h>>2]|0;a=k[e+(c*468|0)+456>>2]|0;a:do if((a|0)>0){b=1;d=2;do{while(1){if(!(a&1))break;b=aa(b,d)|0;if((a|0)>1)a=a+-1|0;else break a}a=a>>>1;d=aa(d,d)|0}while((a|0)!=0)}else b=1;while(0);d=~~(+o[e+(c*468|0)+452>>2]*+o[f>>2]/+(b|0)+.5);YWa(e+(c*468|0)+336|0,e+(c*468|0)|0,1,0,d);e=k[h>>2]|0;YWa(e+(c*468|0)+336|0,e+(c*468|0)+56|0,0,1,d);e=k[h>>2]|0;YWa(e+(c*468|0)|0,e+(c*468|0)+112|0,1,0,d);e=k[h>>2]|0;YWa(e+(c*468|0)+56|0,e+(c*468|0)+224|0,0,1,d);e=k[h>>2]|0;YWa(e+(c*468|0)|0,e+(c*468|0)+168|0,0,1,d);e=(k[h>>2]|0)+(c*468|0)|0;l=+(d|0);b1(i,e,l);a=k[i>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,i,e,-1);XN(i);e=(k[h>>2]|0)+(c*468|0)+56|0;b1(i,e,l);a=k[i>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,i,e,-1);XN(i);e=(k[h>>2]|0)+(c*468|0)+112|0;l=+(aa(d,d)|0);b1(i,e,l);d=k[i>>2]|0;dh[k[(k[d>>2]|0)+12>>2]&255](d,i,e,-1);XN(i);e=(k[h>>2]|0)+(c*468|0)+168|0;b1(i,e,l);d=k[i>>2]|0;dh[k[(k[d>>2]|0)+12>>2]&255](d,i,e,-1);XN(i);e=(k[h>>2]|0)+(c*468|0)+224|0;b1(i,e,l);d=k[i>>2]|0;dh[k[(k[d>>2]|0)+12>>2]&255](d,i,e,-1);XN(i);c=c+1|0}while((c|0)<(k[g>>2]|0));r=j;return}function yWa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=142652;d=a+112|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+108>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+92|0;c=a+80|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+116>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+120>>2]|0;if(!((b|0)==(a+124|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+56|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+52>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+36|0;c=a+24|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+60>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+64>>2]|0;if((b|0)==(a+68|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function zWa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=142384;d=a+112|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+108>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+92|0;c=a+80|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+116>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+120>>2]|0;if(!((b|0)==(a+124|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+56|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+52>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+36|0;c=a+24|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+60>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+64>>2]|0;if((b|0)==(a+68|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function AWa(a){a=a|0;zWa(a);ggb(a);return}function BWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0.0,j=0.0,m=0.0,n=0,p=0,q=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,R=0.0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0;Qa=r;r=r+288|0;Na=Qa+280|0;Oa=Qa+224|0;Pa=Qa;c=k[b>>2]|0;La=b+4|0;if((c|0)>=(k[La>>2]|0)){r=Qa;return}Ma=a+4|0;ba=a+12|0;ca=a+8|0;da=a+16|0;ea=Pa+4|0;fa=Pa+8|0;ga=Pa+12|0;ha=Pa+16|0;ia=Pa+48|0;ja=Pa+56|0;ka=Pa+52|0;la=Pa+60|0;ma=Pa+64|0;na=Pa+68|0;oa=Pa+72|0;pa=Pa+104|0;qa=Pa+112|0;ra=Pa+108|0;sa=Pa+116|0;ta=Pa+120|0;ua=Pa+124|0;va=Pa+128|0;wa=Pa+160|0;xa=Pa+168|0;ya=Pa+164|0;za=Na+4|0;Aa=Oa+4|0;Ba=Oa+8|0;Ca=Oa+40|0;Da=Oa+48|0;Ea=Oa+44|0;Fa=Oa+52|0;Ga=a+28|0;Ha=a+36|0;Ia=a+64|0;Ja=Oa+16|0;Ka=a+92|0;Y=a+84|0;Z=Oa+36|0;_=Oa+32|0;a:while(1){CWa((k[k[Ma>>2]>>2]|0)+(c*28|0)|0,k[k[ba>>2]>>2]|0);V=k[k[Ma>>2]>>2]|0;X=k[ca>>2]|0;X=(k[X+16>>2]|0)+(aa(k[k[X+44>>2]>>2]|0,c)|0)|0;e=k[da>>2]|0;L=k[ba>>2]|0;P=+(1<<k[V+(c*28|0)+20>>2]|0);M=~~(+o[V+(c*28|0)+8>>2]*.5/P+.5);U=+o[V+(c*28|0)+12>>2]*3.1415927410125732/180.0;N=k[V+(c*28|0)+24>>2]|0;O=+o[V+(c*28|0)+4>>2]/P;P=+o[V+(c*28|0)>>2]/P;R=+S(+U);U=+T(+U);V=e+48|0;b=(k[V>>2]|0)*29|0;k[Pa>>2]=0;k[ea>>2]=0;k[fa>>2]=1124007936;a=ga;d=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(d|0));k[ia>>2]=ha;k[ka>>2]=ja;k[la>>2]=0;k[ja>>2]=0;k[ma>>2]=1124007936;a=na;d=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(d|0));k[pa>>2]=oa;k[ra>>2]=qa;k[sa>>2]=0;k[qa>>2]=0;k[ta>>2]=1124007936;a=ua;d=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(d|0));k[wa>>2]=va;k[ya>>2]=xa;a=xa;d=a+56|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(d|0));k[Na>>2]=1;k[za>>2]=b;j1(Pa,48,Na,5);k[Oa>>2]=1124007936;a=Aa;d=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(d|0));k[Ca>>2]=Ba;k[Ea>>2]=Da;k[Fa>>2]=0;k[Da>>2]=0;W=k[Pa>>2]|0;dh[k[(k[W>>2]|0)+12>>2]&255](W,Pa,Oa,-1);XN(Pa);while(1){b=fgb(12)|0;if(b|0){W=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){W=0;break}Qh[b&7]()}k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;G=e+52|0;k[W>>2]=k[G>>2];K=~~+$(+(+(k[G>>2]|0)*2.0/3.0));k[W+4>>2]=K;k[W+8>>2]=(k[G>>2]|0)/2|0;G=k[Ga>>2]|0;if((G|0)>0){H=0-M|0;I=k[Ha>>2]|0;J=k[k[Ia>>2]>>2]|0;e=k[Ja>>2]|0;K=k[Ea>>2]|0;F=0;do{a=I+(aa(J,F)|0)|0;b=k[a>>2]|0;if(b>>>0>=3){b=16;break a}b=k[W+(b<<2)>>2]|0;if((b|0)>0){u=k[a+4>>2]|0;w=k[a+8>>2]|0;E=k[L>>2]|0;x=k[E+(N*468|0)+296>>2]|0;y=k[k[E+(N*468|0)+324>>2]>>2]|0;a=k[V>>2]|0;z=(a|0)>1;A=w+b|0;B=E+(N*468|0)+100|0;C=E+(N*468|0)+72|0;D=E+(N*468|0)+44|0;E=E+(N*468|0)+16|0;v=u+b|0;h=0.0;g=0.0;f=0.0;do{t=+(aa(u,M)|0);s=U*t;t=R*t;b:do if(z){d=k[E>>2]|0;n=k[k[D>>2]>>2]|0;p=k[C>>2]|0;q=k[k[B>>2]>>2]|0;b=w;while(1){Sa=~~(O+(s+R*+(aa(b,M)|0))+.5);Ra=~~(P+(t+U*+(aa(b,H)|0))+.5);Ta=x+(aa(y,Sa)|0)+(Ra<<2)|0;h=h+ +o[Ta>>2];Ta=d+(aa(n,Sa)|0)+(Ra<<2)|0;j=+o[Ta>>2];Ra=p+(aa(q,Sa)|0)+(Ra<<2)|0;m=+o[Ra>>2];switch(a|0){case 2:{g=g+ +Q(+(j*j+m*m));break}case 3:{g=g+(R*j+U*m);f=f+(R*m-U*j);break}default:{}}b=b+1|0;if((b|0)>=(A|0))break b}}else{b=w;do{Ta=x+(aa(y,~~(O+(s+R*+(aa(b,M)|0))+.5))|0)+(~~(P+(t+U*+(aa(b,H)|0))+.5)<<2)|0;h=h+ +o[Ta>>2];b=b+1|0}while((b|0)<(A|0))}while(0);u=u+1|0}while((u|0)<(v|0))}else{h=0.0;g=0.0;f=0.0;a=k[V>>2]|0}b=aa(a,F)|0;d=k[K>>2]|0;Ta=e+(aa(b,d)|0)|0;o[Ta>>2]=h;switch(a|0){case 2:{Ta=e+(aa(d,F<<1|1)|0)|0;o[Ta>>2]=g;break}case 3:{Ta=e+(aa(d,(F*3|0)+1|0)|0)|0;o[Ta>>2]=g;Ta=e+(aa(d,b+2|0)|0)|0;o[Ta>>2]=f;break}default:{}}F=F+1|0}while((F|0)<(G|0))}else e=k[Ja>>2]|0;d=k[Ka>>2]|0;b=k[Y>>2]|0;if((b|0)>0){a=0;do{Ta=a<<1;if(+o[e+(k[d+(Ta<<2)>>2]<<2)>>2]>+o[e+(k[d+((Ta|1)<<2)>>2]<<2)>>2]){b=X+((a|0)/8|0)|0;i[b>>0]=l[b>>0]|0|1<<(a&7);b=k[Y>>2]|0}a=a+1|0}while((a|0)<(b|0))}if(W|0)ggb(W);b=k[Z>>2]|0;if(b|0?(Sa=b+12|0,Ta=k[Sa>>2]|0,k[Sa>>2]=Ta+-1,(Ta|0)==1):0){a=k[Z>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[_>>2]|0;if(!b){b=B1()|0;a=k[Z>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[Z>>2]=0}k[Z>>2]=0;k[Ja>>2]=0;k[Ja+4>>2]=0;k[Ja+8>>2]=0;k[Ja+12>>2]=0;if((k[Aa>>2]|0)>0){a=k[Ca>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Aa>>2]|0))}b=k[Ea>>2]|0;if(!((b|0)==(Da|0)|(b|0)==0))ggb(k[b+-4>>2]|0);c=c+1|0;if((c|0)>=(k[La>>2]|0)){b=3;break}}if((b|0)==3){r=Qa;return}else if((b|0)==16)ad(426635,426557,315,426658)}function CWa(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0;y=r;r=r+1312|0;v=y+872|0;w=y+436|0;x=y;i=k[a+24>>2]|0;d=+(1<<k[b+(i*468|0)+456>>2]|0);n=~~(+o[a+8>>2]*.5/d+.5);c=+o[a>>2]/d;d=+o[a+4>>2]/d;p=b+(i*468|0)+16|0;q=b+(i*468|0)+44|0;s=b+(i*468|0)+72|0;i=b+(i*468|0)+100|0;h=-6;b=0;do{j=aa(h,h)|0;l=~~(c+ +(aa(h,n)|0)+.5);m=142396+(h+6<<2)|0;g=-6;do{if(((aa(g,g)|0)+j|0)>>>0<36){z=~~(d+ +(aa(g,n)|0)+.5);u=+o[142448+((k[m>>2]|0)*28|0)+(k[142396+(g+6<<2)>>2]<<2)>>2];A=(k[p>>2]|0)+(aa(k[k[q>>2]>>2]|0,z)|0)+(l<<2)|0;o[v+(b<<2)>>2]=u*+o[A>>2];z=(k[s>>2]|0)+(aa(k[k[i>>2]>>2]|0,z)|0)+(l<<2)|0;o[w+(b<<2)>>2]=u*+o[z>>2];b=b+1|0}g=g+1|0}while((g|0)!=7);h=h+1|0}while((h|0)!=7);b=0;do{e=+o[v+(b<<2)>>2];f=+o[w+(b<<2)>>2];c=+P(+e);d=+P(+f);if(!(c>=d)){u=c/(d+2.220446049250313e-16);c=u*u;c=90.0-u*(c*(c*(8.914000511169434-c*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{u=d/(c+2.220446049250313e-16);c=u*u;c=u*(c*(c*(8.914000511169434-c*2.539724588394165)+-18.66744613647461)+57.283626556396484)}u=e<0.0?180.0-c:c;o[x+(b<<2)>>2]=(f<0.0?360.0-u:u)*.01745329238474369;b=b+1|0}while((b|0)!=109);j=a+12|0;u=0.0;c=0.0;do{t=u+1.0471975803375244;t=t>6.2831854820251465?u+-5.235987663269043:t;i=t<u;if(!(u<t))if(i){d=0.0;e=0.0;b=0;do{f=+o[x+(b<<2)>>2];if(!(!(f>0.0&f<t)?!(f>u&f<6.283185307179586):0)){d=d+ +o[w+(b<<2)>>2];e=e+ +o[v+(b<<2)>>2]}b=b+1|0}while((b|0)!=109)}else{d=0.0;e=0.0}else{d=0.0;e=0.0;h=0;do{f=+o[x+(h<<2)>>2];b=u<f;g=f<t;do if(!(b&g)){if(i){if(!(f>0.0&g)?!(b&f<6.283185307179586):0)break;d=d+ +o[w+(h<<2)>>2];e=e+ +o[v+(h<<2)>>2]}}else{d=d+ +o[w+(h<<2)>>2];e=e+ +o[v+(h<<2)>>2]}while(0);h=h+1|0}while((h|0)!=109)}f=e*e+d*d;if(f>c){g=e>=0.0;b=d>=0.0;do if(!(g&b)){h=e<0.0;if(h&b){c=3.1415927410125732-+X(+(-d/e));break}b=d<0.0;if(h&b){c=+X(+(d/e))+3.1415927410125732;break}if(g&b)c=6.2831854820251465-+X(+(-d/e));else c=0.0}else c=+X(+(d/e));while(0);o[j>>2]=c*180.0/3.1415927410125732;c=f}u=u+.15000000596046448}while(u<6.2831854820251465);r=y;return}function DWa(a){a=a|0;ggb(a);return}function EWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0.0,n=0.0,q=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,R=0,U=0,V=0,W=0,X=0,Y=0.0,Z=0.0,_=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;ma=r;r=r+192|0;la=ma;c=k[b>>2]|0;ha=b+4|0;if((c|0)>=(k[ha>>2]|0)){r=ma;return}ia=a+4|0;ja=a+12|0;ka=a+8|0;fa=a+16|0;ga=la+4|0;do{CWa((k[k[ia>>2]>>2]|0)+(c*28|0)|0,k[k[ja>>2]>>2]|0);f=k[k[ia>>2]>>2]|0;ea=k[ka>>2]|0;ea=(k[ea+16>>2]|0)+(aa(k[k[ea+44>>2]>>2]|0,c)|0)|0;b=k[fa>>2]|0;if((k[b+48>>2]|0)>=4){b=ZT(52)|0;k[b>>2]=1;a=b+4|0;k[la>>2]=a;k[ga>>2]=45;i[b+49>>0]=0;d=387534;e=a+45|0;do{i[a>>0]=i[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(e|0));Y8(-215,la,387580,387323,1401);k[ga>>2]=0;k[la>>2]=0;X=k[b>>2]|0;k[b>>2]=X+-1;if((X|0)==1)ggb(k[b+-4>>2]|0);b=k[fa>>2]|0}_=+(1<<k[f+(c*28|0)+20>>2]|0);Y=+(~~(+o[f+(c*28|0)+8>>2]*.5/_+.5)|0);Z=+o[f+(c*28|0)>>2]/_;_=+o[f+(c*28|0)+4>>2]/_;ca=+o[f+(c*28|0)+12>>2]*3.1415927410125732/180.0;ba=+S(+ca);ca=+T(+ca);O=k[b+52>>2]|0;da=+(O|0);X=f+(c*28|0)+24|0;P=0;a=0;V=5;W=3;while(1){U=a+2|0;U=aa(U,U)|0;M=~~+$(+(da*+p[21112+(a<<3)>>3]));N=k[X>>2]|0;R=k[b+48>>2]|0;H=0-O|0;if((O|0)>(H|0)){I=k[ja>>2]|0;J=(R|0)>1;K=(R|0)==2;L=(M|0)>0;E=H;b=0;do{F=E;E=E+M|0;G=H;do{if(L){x=G+M|0;D=k[I>>2]|0;y=k[D+(N*468|0)+296>>2]|0;z=k[k[D+(N*468|0)+324>>2]>>2]|0;A=D+(N*468|0)+100|0;B=D+(N*468|0)+72|0;C=D+(N*468|0)+44|0;D=D+(N*468|0)+16|0;s=0.0;q=0.0;m=0.0;d=0;w=F;do{u=+(w|0);v=u*ca*Y;u=u*ba*Y;if(J){f=k[D>>2]|0;g=k[k[C>>2]>>2]|0;h=k[B>>2]|0;j=k[k[A>>2]>>2]|0;e=G;do{oa=~~(v+ +(e|0)*ba*Y+_+.5);na=~~(u+ +(0-e|0)*ca*Y+Z+.5);pa=y+(aa(z,oa)|0)+(na<<2)|0;s=s+ +o[pa>>2];pa=f+(aa(g,oa)|0)+(na<<2)|0;n=+o[pa>>2];na=h+(aa(j,oa)|0)+(na<<2)|0;t=+o[na>>2];if(K)n=+Q(+(n*n+t*t));else{m=m+(n*ba+t*ca);n=t*ba-n*ca}q=q+n;d=d+1|0;e=e+1|0}while((e|0)<(x|0))}else{e=G;do{pa=y+(aa(z,~~(v+ +(e|0)*ba*Y+_+.5))|0)+(~~(u+ +(0-e|0)*ca*Y+Z+.5)<<2)|0;s=s+ +o[pa>>2];d=d+1|0;e=e+1|0}while((e|0)<(x|0))}w=w+1|0}while((w|0)<(E|0))}else{s=0.0;q=0.0;m=0.0;d=0}n=+(d|0);m=m/n;o[la+(b<<2)>>2]=s/n;if(J?(o[la+(b+1<<2)>>2]=q/n,!K):0)o[la+(b+2<<2)>>2]=m;b=b+R|0;G=G+M|0}while((G|0)<(O|0))}while((E|0)<(O|0))}d=aa(R,U)|0;if((d|0)>0){b=0;do{pa=la+(b<<2)|0;oa=k[pa>>2]|0;k[pa>>2]=oa>>31&2147483647^oa;b=b+1|0}while((b|0)!=(d|0))}if((U|0)!=0&(R|0)>0){j=0;b=P;do{h=0;g=W;while(1){f=la+((aa(h,R)|0)+j<<2)|0;f=k[f>>2]|0;h=h+1|0;if((h|0)<(U|0)){d=h;e=b;while(1){oa=la+((aa(d,R)|0)+j<<2)|0;pa=ea+(e>>3)|0;i[pa>>0]=((f|0)>(k[oa>>2]|0)&1)<<(e&7)|(l[pa>>0]|0);d=d+1|0;if((d|0)==(U|0))break;else e=e+1|0}b=b+g|0}if((h|0)==(U|0))break;else g=g+-1|0}j=j+1|0}while((j|0)!=(R|0))}else b=P;a=a+1|0;if((a|0)==3)break;pa=W+V|0;O=k[fa>>2]|0;P=b;b=O;O=k[O+52>>2]|0;V=V+2|0;W=pa}c=c+1|0}while((c|0)<(k[ha>>2]|0));r=ma;return}function FWa(a){a=a|0;yWa(a);ggb(a);return}function GWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0.0,j=0.0,m=0.0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0,P=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0;Ka=r;r=r+288|0;Ha=Ka+280|0;Ia=Ka+224|0;Ja=Ka;c=k[b>>2]|0;Fa=b+4|0;if((c|0)>=(k[Fa>>2]|0)){r=Ka;return}Ga=a+4|0;V=a+8|0;W=a+16|0;X=a+12|0;Y=Ja+4|0;Z=Ja+8|0;_=Ja+12|0;ba=Ja+16|0;ca=Ja+48|0;da=Ja+56|0;ea=Ja+52|0;fa=Ja+60|0;ga=Ja+64|0;ha=Ja+68|0;ia=Ja+72|0;ja=Ja+104|0;ka=Ja+112|0;la=Ja+108|0;ma=Ja+116|0;na=Ja+120|0;oa=Ja+124|0;pa=Ja+128|0;qa=Ja+160|0;ra=Ja+168|0;sa=Ja+164|0;ta=Ha+4|0;ua=Ia+4|0;va=Ia+8|0;wa=Ia+40|0;xa=Ia+48|0;ya=Ia+44|0;za=Ia+52|0;Aa=a+28|0;Ba=a+36|0;Ca=a+64|0;Da=Ia+16|0;Ea=a+92|0;S=a+84|0;T=Ia+36|0;U=Ia+32|0;a:while(1){O=k[k[Ga>>2]>>2]|0;R=k[V>>2]|0;R=(k[R+16>>2]|0)+(aa(k[k[R+44>>2]>>2]|0,c)|0)|0;e=k[W>>2]|0;J=k[X>>2]|0;N=+(1<<k[O+(c*28|0)+20>>2]|0);K=~~(+o[O+(c*28|0)+8>>2]*.5/N+.5);L=k[O+(c*28|0)+24>>2]|0;M=+o[O+(c*28|0)+4>>2]/N;N=+o[O+(c*28|0)>>2]/N;O=e+48|0;b=(k[O>>2]|0)*29|0;k[Ja>>2]=0;k[Y>>2]=0;k[Z>>2]=1124007936;a=_;d=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(d|0));k[ca>>2]=ba;k[ea>>2]=da;k[fa>>2]=0;k[da>>2]=0;k[ga>>2]=1124007936;a=ha;d=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(d|0));k[ja>>2]=ia;k[la>>2]=ka;k[ma>>2]=0;k[ka>>2]=0;k[na>>2]=1124007936;a=oa;d=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(d|0));k[qa>>2]=pa;k[sa>>2]=ra;a=ra;d=a+56|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(d|0));k[Ha>>2]=1;k[ta>>2]=b;j1(Ja,48,Ha,5);k[Ia>>2]=1124007936;a=ua;d=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(d|0));k[wa>>2]=va;k[ya>>2]=xa;k[za>>2]=0;k[xa>>2]=0;P=k[Ja>>2]|0;dh[k[(k[P>>2]|0)+12>>2]&255](P,Ja,Ia,-1);XN(Ja);while(1){b=fgb(12)|0;if(b|0){P=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){P=0;break}Qh[b&7]()}k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;F=e+52|0;k[P>>2]=k[F>>2];I=~~+$(+(+(k[F>>2]|0)*2.0/3.0));k[P+4>>2]=I;k[P+8>>2]=(k[F>>2]|0)/2|0;F=k[Aa>>2]|0;if((F|0)>0){G=k[Ba>>2]|0;H=k[k[Ca>>2]>>2]|0;e=k[Da>>2]|0;I=k[ya>>2]|0;E=0;do{a=G+(aa(H,E)|0)|0;b=k[a>>2]|0;if(b>>>0>=3){b=16;break a}b=k[P+(b<<2)>>2]|0;if((b|0)>0){t=k[a+4>>2]|0;v=k[a+8>>2]|0;D=k[J>>2]|0;w=k[D+(L*468|0)+296>>2]|0;x=k[k[D+(L*468|0)+324>>2]>>2]|0;a=k[O>>2]|0;y=(a|0)>1;z=v+b|0;A=D+(L*468|0)+100|0;B=D+(L*468|0)+72|0;C=D+(L*468|0)+44|0;D=D+(L*468|0)+16|0;u=t+b|0;h=0.0;g=0.0;f=0.0;do{s=~~(N+ +(aa(t,K)|0)+.5);b:do if(y){d=k[D>>2]|0;n=k[k[C>>2]>>2]|0;p=k[B>>2]|0;q=k[k[A>>2]>>2]|0;b=v;while(1){La=~~(M+ +(aa(b,K)|0)+.5);Ma=w+(aa(x,La)|0)+(s<<2)|0;h=h+ +o[Ma>>2];Ma=d+(aa(n,La)|0)+(s<<2)|0;j=+o[Ma>>2];La=p+(aa(q,La)|0)+(s<<2)|0;m=+o[La>>2];switch(a|0){case 2:{g=g+ +Q(+(j*j+m*m));break}case 3:{g=g+j;f=f+m;break}default:{}}b=b+1|0;if((b|0)>=(z|0))break b}}else{b=v;do{Ma=w+(aa(x,~~(M+ +(aa(b,K)|0)+.5))|0)+(s<<2)|0;h=h+ +o[Ma>>2];b=b+1|0}while((b|0)<(z|0))}while(0);t=t+1|0}while((t|0)<(u|0))}else{h=0.0;g=0.0;f=0.0;a=k[O>>2]|0}b=aa(a,E)|0;d=k[I>>2]|0;Ma=e+(aa(b,d)|0)|0;o[Ma>>2]=h;switch(a|0){case 2:{Ma=e+(aa(d,E<<1|1)|0)|0;o[Ma>>2]=g;break}case 3:{Ma=e+(aa(d,(E*3|0)+1|0)|0)|0;o[Ma>>2]=g;Ma=e+(aa(d,b+2|0)|0)|0;o[Ma>>2]=f;break}default:{}}E=E+1|0}while((E|0)<(F|0))}else e=k[Da>>2]|0;d=k[Ea>>2]|0;b=k[S>>2]|0;if((b|0)>0){a=0;do{Ma=a<<1;if(+o[e+(k[d+(Ma<<2)>>2]<<2)>>2]>+o[e+(k[d+((Ma|1)<<2)>>2]<<2)>>2]){b=R+((a|0)/8|0)|0;i[b>>0]=l[b>>0]|0|1<<(a&7);b=k[S>>2]|0}a=a+1|0}while((a|0)<(b|0))}if(P|0)ggb(P);b=k[T>>2]|0;if(b|0?(La=b+12|0,Ma=k[La>>2]|0,k[La>>2]=Ma+-1,(Ma|0)==1):0){a=k[T>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[U>>2]|0;if(!b){b=B1()|0;a=k[T>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[T>>2]=0}k[T>>2]=0;k[Da>>2]=0;k[Da+4>>2]=0;k[Da+8>>2]=0;k[Da+12>>2]=0;if((k[ua>>2]|0)>0){a=k[wa>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ua>>2]|0))}b=k[ya>>2]|0;if(!((b|0)==(xa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);c=c+1|0;if((c|0)>=(k[Fa>>2]|0)){b=3;break}}if((b|0)==3){r=Ka;return}else if((b|0)==16)ad(426635,426557,315,426658)}function HWa(a){a=a|0;ggb(a);return}function IWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,p=0.0,q=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0.0,Ob=0,Pb=0;Lb=r;r=r+848|0;Eb=Lb+840|0;Fb=Lb+784|0;Gb=Lb+448|0;Hb=Lb+728|0;Ib=Lb+224|0;Jb=Lb+672|0;Kb=Lb;c=k[b>>2]|0;Ab=b+4|0;if((c|0)>=(k[Ab>>2]|0)){r=Lb;return}Bb=a+4|0;Cb=a+8|0;Db=a+16|0;W=a+12|0;X=Gb+4|0;Y=Gb+8|0;Z=Gb+12|0;_=Gb+16|0;ba=Gb+48|0;ca=Gb+56|0;da=Gb+52|0;ea=Gb+60|0;fa=Gb+64|0;ga=Gb+68|0;ha=Gb+72|0;ia=Gb+104|0;ja=Gb+112|0;ka=Gb+108|0;la=Gb+116|0;ma=Gb+120|0;na=Gb+124|0;oa=Gb+128|0;pa=Gb+160|0;qa=Gb+168|0;ra=Gb+164|0;sa=Eb+4|0;ta=Fb+4|0;ua=Fb+8|0;va=Fb+40|0;wa=Fb+48|0;xa=Fb+44|0;ya=Fb+52|0;za=Ib+4|0;Aa=Ib+8|0;Ba=Ib+12|0;Ca=Ib+16|0;Da=Ib+48|0;Ea=Ib+56|0;Fa=Ib+52|0;Ga=Ib+60|0;Ha=Ib+64|0;Ia=Ib+68|0;Ja=Ib+72|0;Ka=Ib+104|0;La=Ib+112|0;Ma=Ib+108|0;Na=Ib+116|0;Oa=Ib+120|0;Pa=Ib+124|0;Qa=Ib+128|0;Ra=Ib+160|0;Sa=Ib+168|0;Ta=Ib+164|0;Ua=Eb+4|0;Va=Hb+4|0;Wa=Hb+8|0;Xa=Hb+40|0;Ya=Hb+48|0;Za=Hb+44|0;_a=Hb+52|0;$a=Kb+4|0;ab=Kb+8|0;bb=Kb+12|0;cb=Kb+16|0;db=Kb+48|0;eb=Kb+56|0;fb=Kb+52|0;gb=Kb+60|0;hb=Kb+64|0;ib=Kb+68|0;jb=Kb+72|0;kb=Kb+104|0;lb=Kb+112|0;mb=Kb+108|0;nb=Kb+116|0;ob=Kb+120|0;pb=Kb+124|0;qb=Kb+128|0;rb=Kb+160|0;sb=Kb+168|0;tb=Kb+164|0;ub=Eb+4|0;vb=Jb+4|0;wb=Jb+8|0;xb=Jb+40|0;yb=Jb+48|0;zb=Jb+44|0;M=Jb+52|0;N=Fb+16|0;O=Hb+16|0;P=Jb+16|0;Q=Jb+36|0;R=Hb+36|0;S=Fb+36|0;T=Fb+32|0;U=Hb+32|0;V=Jb+32|0;do{f=k[k[Bb>>2]>>2]|0;L=k[Cb>>2]|0;L=(k[L+16>>2]|0)+(aa(k[k[L+44>>2]>>2]|0,c)|0)|0;K=k[W>>2]|0;a=(k[Db>>2]|0)+48|0;b=k[a>>2]|0;k[Gb>>2]=0;k[X>>2]=0;k[Y>>2]=1124007936;d=Z;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[ba>>2]=_;k[da>>2]=ca;k[ea>>2]=0;k[ca>>2]=0;k[fa>>2]=1124007936;d=ga;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[ia>>2]=ha;k[ka>>2]=ja;k[la>>2]=0;k[ja>>2]=0;k[ma>>2]=1124007936;d=na;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[pa>>2]=oa;k[ra>>2]=qa;d=qa;e=d+56|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[Eb>>2]=b;k[sa>>2]=4;j1(Gb,48,Eb,5);k[Fb>>2]=1124007936;d=ta;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[va>>2]=ua;k[xa>>2]=wa;k[ya>>2]=0;k[wa>>2]=0;b=k[Gb>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,Gb,Fb,-1);XN(Gb);b=k[a>>2]|0;k[Ib>>2]=0;k[za>>2]=0;k[Aa>>2]=1124007936;d=Ba;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[Da>>2]=Ca;k[Fa>>2]=Ea;k[Ga>>2]=0;k[Ea>>2]=0;k[Ha>>2]=1124007936;d=Ia;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[Ka>>2]=Ja;k[Ma>>2]=La;k[Na>>2]=0;k[La>>2]=0;k[Oa>>2]=1124007936;d=Pa;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[Ra>>2]=Qa;k[Ta>>2]=Sa;d=Sa;e=d+56|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[Eb>>2]=b;k[Ua>>2]=9;j1(Ib,48,Eb,5);k[Hb>>2]=1124007936;d=Va;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[Xa>>2]=Wa;k[Za>>2]=Ya;k[_a>>2]=0;k[Ya>>2]=0;b=k[Ib>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,Ib,Hb,-1);XN(Ib);b=k[a>>2]|0;k[Kb>>2]=0;k[$a>>2]=0;k[ab>>2]=1124007936;d=bb;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[db>>2]=cb;k[fb>>2]=eb;k[gb>>2]=0;k[eb>>2]=0;k[hb>>2]=1124007936;d=ib;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[kb>>2]=jb;k[mb>>2]=lb;k[nb>>2]=0;k[lb>>2]=0;k[ob>>2]=1124007936;d=pb;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[rb>>2]=qb;k[tb>>2]=sb;d=sb;e=d+56|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[Eb>>2]=b;k[ub>>2]=16;j1(Kb,48,Eb,5);k[Jb>>2]=1124007936;d=vb;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[xb>>2]=wb;k[zb>>2]=yb;k[M>>2]=0;k[yb>>2]=0;H=k[Kb>>2]|0;dh[k[(k[H>>2]|0)+12>>2]&255](H,Kb,Jb,-1);XN(Kb);E=+(1<<k[f+(c*28|0)+20>>2]|0);H=~~(+o[f+(c*28|0)+8>>2]*.5/E+.5);I=k[f+(c*28|0)+24>>2]|0;J=+o[f+(c*28|0)+4>>2]/E;E=+o[f+(c*28|0)>>2]/E;F=k[(k[Db>>2]|0)+52>>2]|0;G=0-F|0;D=(F|0)>(G|0);if(D){y=k[N>>2]|0;z=(F|0)>0;A=k[k[xa>>2]>>2]|0;w=G;b=0;do{x=w;w=w+F|0;v=G;do{u=v;v=v+F|0;if(z){n=k[K>>2]|0;f=k[n+(I*468|0)+296>>2]|0;g=k[k[n+(I*468|0)+324>>2]>>2]|0;h=k[n+(I*468|0)+16>>2]|0;j=k[k[n+(I*468|0)+44>>2]>>2]|0;m=k[n+(I*468|0)+72>>2]|0;n=k[k[n+(I*468|0)+100>>2]>>2]|0;e=x;s=0.0;q=0.0;a=0;p=0.0;do{t=~~(E+ +(aa(e,H)|0)+.5);d=u;do{C=~~(J+ +(aa(d,H)|0)+.5);Mb=f+(aa(g,C)|0)+(t<<2)|0;B=h+(aa(j,C)|0)+(t<<2)|0;C=m+(aa(n,C)|0)+(t<<2)|0;s=s+ +o[Mb>>2];q=q+ +o[B>>2];p=p+ +o[C>>2];a=a+1|0;d=d+1|0}while((d|0)<(v|0));e=e+1|0}while((e|0)<(w|0))}else{s=0.0;q=0.0;a=0;p=0.0}Nb=+(a|0);Mb=y+(aa(A,b)|0)|0;o[Mb>>2]=s/Nb;o[Mb+4>>2]=q/Nb;o[Mb+8>>2]=p/Nb;b=b+1|0}while((u|0)<0)}while((x|0)<0)}j=k[N>>2]|0;m=k[xa>>2]|0;h=0;b=0;n=9;while(1){f=h;h=h+1|0;if((h|0)<4){e=h;g=b;while(1){a=k[m>>2]|0;C=j+(aa(a,f)|0)|0;Mb=j+(aa(a,e)|0)|0;if(+o[C>>2]>+o[Mb>>2]){a=L+((g|0)/8|0)|0;i[a>>0]=l[a>>0]|0|1<<(g&7);a=k[m>>2]|0}d=g+1|0;C=j+(aa(a,f)|0)+4|0;Mb=j+(aa(a,e)|0)+4|0;if(+o[C>>2]>+o[Mb>>2]){a=L+((d|0)/8|0)|0;i[a>>0]=l[a>>0]|0|1<<(d&7);a=k[m>>2]|0}d=g+2|0;C=j+(aa(a,f)|0)+8|0;Mb=j+(aa(a,e)|0)+8|0;if(+o[C>>2]>+o[Mb>>2]){Mb=L+((d|0)/8|0)|0;i[Mb>>0]=l[Mb>>0]|0|1<<(d&7)}e=e+1|0;if((e|0)==4)break;else g=g+3|0}b=b+n|0}if((h|0)==4)break;else n=n+-3|0}z=~~+$(+(+(F|0)*2.0/3.0));if(D){A=k[O>>2]|0;B=(z|0)>0;C=k[k[Za>>2]>>2]|0;x=G;a=0;do{y=x;x=x+z|0;w=G;do{g=w;w=w+z|0;if(B){u=k[K>>2]|0;h=k[u+(I*468|0)+296>>2]|0;j=k[k[u+(I*468|0)+324>>2]>>2]|0;m=k[u+(I*468|0)+16>>2]|0;n=k[k[u+(I*468|0)+44>>2]>>2]|0;t=k[u+(I*468|0)+72>>2]|0;u=k[k[u+(I*468|0)+100>>2]>>2]|0;f=y;s=0.0;q=0.0;d=0;p=0.0;do{v=~~(E+ +(aa(f,H)|0)+.5);e=g;do{Mb=~~(J+ +(aa(e,H)|0)+.5);Pb=h+(aa(j,Mb)|0)+(v<<2)|0;Ob=m+(aa(n,Mb)|0)+(v<<2)|0;Mb=t+(aa(u,Mb)|0)+(v<<2)|0;s=s+ +o[Pb>>2];q=q+ +o[Ob>>2];p=p+ +o[Mb>>2];d=d+1|0;e=e+1|0}while((e|0)<(w|0));f=f+1|0}while((f|0)<(x|0))}else{s=0.0;q=0.0;d=0;p=0.0}Nb=+(d|0);Pb=A+(aa(C,a)|0)|0;o[Pb>>2]=s/Nb;o[Pb+4>>2]=q/Nb;o[Pb+8>>2]=p/Nb;a=a+1|0}while((w|0)<(F|0))}while((x|0)<(F|0))}m=k[O>>2]|0;n=k[Za>>2]|0;j=0;h=24;while(1){f=j;j=j+1|0;if((j|0)<9){e=j;g=b;while(1){a=k[n>>2]|0;Ob=m+(aa(a,f)|0)|0;Pb=m+(aa(a,e)|0)|0;if(+o[Ob>>2]>+o[Pb>>2]){a=L+((g|0)/8|0)|0;i[a>>0]=l[a>>0]|0|1<<(g&7);a=k[n>>2]|0}d=g+1|0;Ob=m+(aa(a,f)|0)+4|0;Pb=m+(aa(a,e)|0)+4|0;if(+o[Ob>>2]>+o[Pb>>2]){a=L+((d|0)/8|0)|0;i[a>>0]=l[a>>0]|0|1<<(d&7);a=k[n>>2]|0}d=g+2|0;Ob=m+(aa(a,f)|0)+8|0;Pb=m+(aa(a,e)|0)+8|0;if(+o[Ob>>2]>+o[Pb>>2]){Pb=L+((d|0)/8|0)|0;i[Pb>>0]=l[Pb>>0]|0|1<<(d&7)}e=e+1|0;if((e|0)==9)break;else g=g+3|0}b=b+h|0}if((j|0)==9)break;else h=h+-3|0}C=(F|0)/2|0;if(D){z=k[P>>2]|0;A=(F|0)>1;B=k[k[zb>>2]>>2]|0;x=G;a=0;do{y=x;x=x+C|0;w=G;do{g=w;w=w+C|0;if(A){u=k[K>>2]|0;h=k[u+(I*468|0)+296>>2]|0;j=k[k[u+(I*468|0)+324>>2]>>2]|0;m=k[u+(I*468|0)+16>>2]|0;n=k[k[u+(I*468|0)+44>>2]>>2]|0;t=k[u+(I*468|0)+72>>2]|0;u=k[k[u+(I*468|0)+100>>2]>>2]|0;f=y;q=0.0;d=0;p=0.0;s=0.0;do{v=~~(E+ +(aa(f,H)|0)+.5);e=g;do{Pb=~~(J+ +(aa(e,H)|0)+.5);Mb=h+(aa(j,Pb)|0)+(v<<2)|0;Ob=m+(aa(n,Pb)|0)+(v<<2)|0;Pb=t+(aa(u,Pb)|0)+(v<<2)|0;s=s+ +o[Mb>>2];q=q+ +o[Ob>>2];p=p+ +o[Pb>>2];d=d+1|0;e=e+1|0}while((e|0)<(w|0));f=f+1|0}while((f|0)<(x|0))}else{s=0.0;q=0.0;d=0;p=0.0}Nb=+(d|0);Pb=z+(aa(B,a)|0)|0;o[Pb>>2]=s/Nb;o[Pb+4>>2]=q/Nb;o[Pb+8>>2]=p/Nb;a=a+1|0}while((w|0)<(F|0))}while((x|0)<(F|0))}m=k[P>>2]|0;n=k[zb>>2]|0;j=0;h=45;while(1){e=j;j=j+1|0;if((j|0)<16){f=j;g=b;while(1){a=k[n>>2]|0;Ob=m+(aa(a,e)|0)|0;Pb=m+(aa(a,f)|0)|0;if(+o[Ob>>2]>+o[Pb>>2]){a=L+((g|0)/8|0)|0;i[a>>0]=l[a>>0]|0|1<<(g&7);a=k[n>>2]|0}d=g+1|0;Ob=m+(aa(a,e)|0)+4|0;Pb=m+(aa(a,f)|0)+4|0;if(+o[Ob>>2]>+o[Pb>>2]){a=L+((d|0)/8|0)|0;i[a>>0]=l[a>>0]|0|1<<(d&7);a=k[n>>2]|0}d=g+2|0;Ob=m+(aa(a,e)|0)+8|0;Pb=m+(aa(a,f)|0)+8|0;if(+o[Ob>>2]>+o[Pb>>2]){Pb=L+((d|0)/8|0)|0;i[Pb>>0]=l[Pb>>0]|0|1<<(d&7)}f=f+1|0;if((f|0)==16)break;else g=g+3|0}b=b+h|0}if((j|0)==16)break;else h=h+-3|0}b=k[Q>>2]|0;if(b|0?(Ob=b+12|0,Pb=k[Ob>>2]|0,k[Ob>>2]=Pb+-1,(Pb|0)==1):0){a=k[Q>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[V>>2]|0;if(!b){b=B1()|0;a=k[Q>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[Q>>2]=0}k[Q>>2]=0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[vb>>2]|0)>0){a=k[xb>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[vb>>2]|0))}b=k[zb>>2]|0;if(!((b|0)==(yb|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[R>>2]|0;if(b|0?(Ob=b+12|0,Pb=k[Ob>>2]|0,k[Ob>>2]=Pb+-1,(Pb|0)==1):0){a=k[R>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[U>>2]|0;if(!b){b=B1()|0;a=k[R>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[R>>2]=0}k[R>>2]=0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[Va>>2]|0)>0){a=k[Xa>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Va>>2]|0))}b=k[Za>>2]|0;if(!((b|0)==(Ya|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[S>>2]|0;if(b|0?(Ob=b+12|0,Pb=k[Ob>>2]|0,k[Ob>>2]=Pb+-1,(Pb|0)==1):0){a=k[S>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[T>>2]|0;if(!b){b=B1()|0;a=k[S>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[S>>2]=0}k[S>>2]=0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[ta>>2]|0)>0){a=k[va>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ta>>2]|0))}b=k[xa>>2]|0;if(!((b|0)==(wa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);c=c+1|0}while((c|0)<(k[Ab>>2]|0));r=Lb;return}function JWa(a){a=a|0;ggb(a);return}function KWa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0,j=0.0,l=0.0,m=0,n=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,R=0,U=0,V=0.0,W=0.0,X=0.0,Y=0.0,_=0,$=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0,ga=0;c=k[b>>2]|0;O=b+4|0;if((c|0)>=(k[O>>2]|0))return;R=a+4|0;U=a+12|0;N=a+8|0;do{CWa((k[k[R>>2]>>2]|0)+(c*28|0)|0,k[k[U>>2]>>2]|0);B=k[k[R>>2]>>2]|0;M=k[N>>2]|0;M=(k[M+16>>2]|0)+(aa(k[k[M+44>>2]>>2]|0,c)|0)|0;y=+(1<<k[B+(c*28|0)+20>>2]|0);w=~~(+o[B+(c*28|0)+8>>2]*.5/y+.5);A=+o[B+(c*28|0)+12>>2]*3.1415927410125732/180.0;G=k[B+(c*28|0)+24>>2]|0;x=+o[B+(c*28|0)+4>>2]/y;y=+o[B+(c*28|0)>>2]/y;z=+S(+A);A=+T(+A);B=0-w|0;C=+(w|0)*2.5;C=C*(C*2.0);s=k[k[U>>2]>>2]|0;D=k[s+(G*468|0)+16>>2]|0;E=k[k[s+(G*468|0)+44>>2]>>2]|0;F=k[s+(G*468|0)+72>>2]|0;G=k[k[s+(G*468|0)+100>>2]>>2]|0;r=-.5;s=0;u=-8;d=0.0;while(1){H=u+-4|0;r=r+1.0;J=+(aa(u+1|0,w)|0);I=z*J;J=A*J;K=r+-2.0;K=K*K;L=u+4|0;q=-.5;t=-8;v=s;while(1){i=t+-4|0;j=y+(I+A*+(aa(w,~t)|0));l=x+(J+z*+(aa(t+1|0,w)|0));m=t+4|0;b=H;e=0.0;f=0.0;g=0.0;h=0.0;while(1){p=+(aa(b,w)|0);n=A*p;p=z*p;a=i;while(1){X=x+(n+z*+(aa(a,w)|0));W=y+(p+A*+(aa(a,B)|0));V=j-W;Y=l-X;Y=+Z(+(-(V*V+Y*Y)/C));ca=~~(X+-.5+.5);ba=~~(W+-.5+.5);$=~~(X+.5+.5);_=~~(W+.5+.5);W=W-+(ba|0);X=X-+(ca|0);ga=D+(aa(E,ca)|0)|0;fa=D+(aa(E,$)|0)|0;V=1.0-W;da=1.0-X;ea=V*da;da=W*da;V=X*V;X=W*X;W=ea*+o[ga+(ba<<2)>>2]+da*+o[ga+(_<<2)>>2]+V*+o[fa+(ba<<2)>>2]+X*+o[fa+(_<<2)>>2];ca=F+(aa(G,ca)|0)|0;$=F+(aa(G,$)|0)|0;X=ea*+o[ca+(ba<<2)>>2]+da*+o[ca+(_<<2)>>2]+V*+o[$+(ba<<2)>>2]+X*+o[$+(_<<2)>>2];V=Y*(z*W+A*X);W=Y*(z*X-A*W);e=e+W;f=f+V;g=g+ +P(+W);h=h+ +P(+V);if((a|0)>=(m|0))break;else a=a+1|0}if((b|0)<(L|0))b=b+1|0;else break}q=q+1.0;ea=q+-2.0;ea=+Z(+(-(K+ea*ea)/4.5));o[M+(v<<2)>>2]=e*ea;o[M+((v|1)<<2)>>2]=f*ea;o[M+((v|2)<<2)>>2]=g*ea;o[M+((v|3)<<2)>>2]=h*ea;d=d+ea*((h*h+(g*g+(f*f+e*e)))*ea);t=t+5|0;if((t|0)>=12)break;else v=v+4|0}u=u+5|0;if((u|0)>=12)break;else s=s+16|0}d=+Q(+d);b=0;do{ga=M+(b<<2)|0;o[ga>>2]=+o[ga>>2]/d;b=b+1|0}while((b|0)!=64);c=c+1|0}while((c|0)<(k[O>>2]|0));return}function LWa(a){a=a|0;ggb(a);return}function MWa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0,j=0.0,l=0,m=0.0,n=0.0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0,X=0,Y=0.0,_=0.0,$=0.0,ba=0.0;c=k[b>>2]|0;S=k[b+4>>2]|0;if((c|0)>=(S|0))return;T=k[k[a+4>>2]>>2]|0;R=k[a+8>>2]|0;O=k[R+16>>2]|0;R=k[k[R+44>>2]>>2]|0;N=k[k[a+12>>2]>>2]|0;do{M=O+(aa(R,c)|0)|0;C=+(1<<k[T+(c*28|0)+20>>2]|0);A=~~(+o[T+(c*28|0)+8>>2]*.5/C+.5);H=k[T+(c*28|0)+24>>2]|0;B=+o[T+(c*28|0)+4>>2]/C;C=+o[T+(c*28|0)>>2]/C;D=+(A|0)*2.5;D=D*(D*2.0);E=k[N+(H*468|0)+16>>2]|0;F=k[k[N+(H*468|0)+44>>2]>>2]|0;G=k[N+(H*468|0)+72>>2]|0;H=k[k[N+(H*468|0)+100>>2]>>2]|0;v=-.5;w=0;y=-8;d=0.0;while(1){I=y+-4|0;v=v+1.0;J=B+ +(aa(y+1|0,A)|0);K=v+-2.0;K=K*K;L=y+4|0;u=-.5;x=-8;z=w;while(1){i=x+-4|0;j=C+ +(aa(x+1|0,A)|0);l=x+4|0;b=I;e=0.0;f=0.0;g=0.0;h=0.0;while(1){n=B+ +(aa(b,A)|0);m=J-n;m=m*m;r=n;s=~~(r+-.5);t=~~(r+.5);n=n-+(s|0);p=E+(aa(F,s)|0)|0;q=E+(aa(F,t)|0)|0;r=1.0-n;s=G+(aa(H,s)|0)|0;t=G+(aa(H,t)|0)|0;a=i;while(1){U=C+ +(aa(a,A)|0);ba=j-U;ba=+Z(+(-(m+ba*ba)/D));Y=U;X=~~(Y+-.5);W=~~(Y+.5);U=U-+(X|0);Y=1.0-U;$=r*Y;_=r*U;Y=n*Y;U=n*U;V=ba*($*+o[p+(X<<2)>>2]+_*+o[p+(W<<2)>>2]+Y*+o[q+(X<<2)>>2]+U*+o[q+(W<<2)>>2]);U=ba*($*+o[s+(X<<2)>>2]+_*+o[s+(W<<2)>>2]+Y*+o[t+(X<<2)>>2]+U*+o[t+(W<<2)>>2]);e=e+V;f=f+U;h=h+ +P(+V);g=g+ +P(+U);if((a|0)>=(l|0))break;else a=a+1|0}if((b|0)<(L|0))b=b+1|0;else break}u=u+1.0;ba=u+-2.0;ba=+Z(+(-(K+ba*ba)/4.5));o[M+(z<<2)>>2]=e*ba;o[M+((z|1)<<2)>>2]=f*ba;o[M+((z|2)<<2)>>2]=h*ba;o[M+((z|3)<<2)>>2]=g*ba;d=d+ba*((g*g+(h*h+(f*f+e*e)))*ba);x=x+5|0;if((x|0)>=12)break;else z=z+4|0}y=y+5|0;if((y|0)>=12)break;else w=w+16|0}d=+Q(+d);b=0;do{X=M+(b<<2)|0;o[X>>2]=+o[X>>2]/d;b=b+1|0}while((b|0)!=64);c=c+1|0}while((c|0)!=(S|0));return}function NWa(a){a=a|0;ggb(a);return}function OWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=r;r=r+224|0;e=f;c=k[b>>2]|0;d=b+4|0;if((c|0)>=(k[d>>2]|0)){r=f;return}b=k[a+4>>2]|0;do{g=k[b>>2]|0;YWa(g+(c*468|0)+336|0,g+(c*468|0)|0,1,0,k[g+(c*468|0)+464>>2]|0);g=k[b>>2]|0;YWa(g+(c*468|0)+336|0,g+(c*468|0)+56|0,0,1,k[g+(c*468|0)+464>>2]|0);g=k[b>>2]|0;YWa(g+(c*468|0)|0,g+(c*468|0)+112|0,1,0,k[g+(c*468|0)+464>>2]|0);g=k[b>>2]|0;YWa(g+(c*468|0)+56|0,g+(c*468|0)+224|0,0,1,k[g+(c*468|0)+464>>2]|0);g=k[b>>2]|0;YWa(g+(c*468|0)|0,g+(c*468|0)+168|0,0,1,k[g+(c*468|0)+464>>2]|0);g=k[b>>2]|0;a=g+(c*468|0)|0;b1(e,a,+(k[g+(c*468|0)+464>>2]|0));g=k[e>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,e,a,-1);XN(e);a=k[b>>2]|0;g=a+(c*468|0)+56|0;b1(e,g,+(k[a+(c*468|0)+464>>2]|0));a=k[e>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,e,g,-1);XN(e);g=k[b>>2]|0;a=g+(c*468|0)+112|0;g=k[g+(c*468|0)+464>>2]|0;b1(e,a,+(aa(g,g)|0));g=k[e>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,e,a,-1);XN(e);a=k[b>>2]|0;g=a+(c*468|0)+168|0;a=k[a+(c*468|0)+464>>2]|0;b1(e,g,+(aa(a,a)|0));a=k[e>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,e,g,-1);XN(e);g=k[b>>2]|0;a=g+(c*468|0)+224|0;g=k[g+(c*468|0)+464>>2]|0;b1(e,a,+(aa(g,g)|0));g=k[e>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,e,a,-1);XN(e);c=c+1|0}while((c|0)<(k[d>>2]|0));r=f;return}function PWa(a){a=a|0;ggb(a);return}function QWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0.0,p=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;J=r;r=r+32|0;I=J;c=k[b>>2]|0;G=b+4|0;if((c|0)>=(k[G>>2]|0)){r=J;return}H=k[a+8>>2]|0;D=k[a+4>>2]|0;E=a+32|0;F=a+28|0;w=a+40|0;x=I+4|0;y=I+8|0;z=I+12|0;A=I+16|0;B=I+20|0;C=I+24|0;b=k[E>>2]|0;do if((b+-1|0)>1){u=c+-1|0;v=c+1|0;b=k[F>>2]|0;t=1;d=b;while(1){if((b+-1|0)>1){q=+(t|0);s=t+-1|0;p=1;b=d;while(1){m=k[D>>2]|0;f=k[m+(c*468|0)+408>>2]|0;g=k[k[m+(c*468|0)+436>>2]>>2]|0;l=f+(aa(g,t)|0)+(p<<2)|0;n=+o[l>>2];a:do if(n>+o[w>>2]?n>=+o[l+-4>>2]:0){l=p+-1|0;h=k[m+(c*468|0)+400>>2]|0;i=k[m+(c*468|0)+404>>2]|0;a=s;while(1){j=(a|0)==(t|0);if((a|0)<(h|0)){d=l;while(1){if(!((d|0)>=(i|0)|j&(d|0)==(p|0))?(K=f+(aa(g,a)|0)+(d<<2)|0,+o[K>>2]>n):0)break a;if((d|0)>(p|0))break;else d=d+1|0}}if((a|0)>(t|0))break;else a=a+1|0}f=k[m+(u*468|0)+400>>2]|0;g=k[m+(u*468|0)+404>>2]|0;h=k[m+(u*468|0)+408>>2]|0;i=k[m+(u*468|0)+436>>2]|0;a=s;while(1){if((a|0)<(f|0)){d=l;while(1){if((d|0)<(g|0)?(K=h+(aa(k[i>>2]|0,a)|0)+(d<<2)|0,+o[K>>2]>n):0)break a;if((d|0)>(p|0))break;else d=d+1|0}}if((a|0)>(t|0))break;else a=a+1|0}f=k[m+(v*468|0)+400>>2]|0;g=k[m+(v*468|0)+404>>2]|0;h=k[m+(v*468|0)+408>>2]|0;i=k[m+(v*468|0)+436>>2]|0;a=s;while(1){if((a|0)<(f|0)){d=l;while(1){if((d|0)<(g|0)?(K=h+(aa(k[i>>2]|0,a)|0)+(d<<2)|0,+o[K>>2]>n):0)break a;if((d|0)>(p|0))break;else d=d+1|0}}if((a|0)>(t|0))break;else a=a+1|0}e=+(p|0);o[I>>2]=e;o[x>>2]=q;n=+P(+n);o[A>>2]=n;k[y>>2]=k[m+(c*468|0)+452>>2];k[B>>2]=k[m+(c*468|0)+456>>2];k[C>>2]=c;o[z>>2]=+(k[m+(c*468|0)+460>>2]|0);b=k[H>>2]|0;a=b+(u*12|0)+4|0;d=k[a>>2]|0;if((d|0)==(k[b+(u*12|0)+8>>2]|0))H6(b+(u*12|0)|0,I);else{o[d>>2]=e;o[d+4>>2]=q;K=d+8|0;k[K>>2]=k[y>>2];k[K+4>>2]=k[y+4>>2];k[K+8>>2]=k[y+8>>2];k[K+12>>2]=k[y+12>>2];k[K+16>>2]=k[y+16>>2];k[a>>2]=(k[a>>2]|0)+28}b=k[F>>2]|0}while(0);p=p+1|0;if((p|0)>=(b+-1|0)){d=b;a=b;break}}}else a=b;t=t+1|0;b=k[E>>2]|0;if((t|0)>=(b+-1|0)){c=v;break}else b=a}}else c=c+1|0;while((c|0)<(k[G>>2]|0));r=J;return}function RWa(a){a=a|0;ggb(a);return}function SWa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0.0,g=0.0,h=0,l=0,m=0,n=0.0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0.0,R=0.0,U=0.0,V=0.0,W=0.0,Y=0.0,_=0.0,$=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0;c=k[a+8>>2]|0;pa=a+12|0;e=k[b>>2]|0;na=b+4|0;if((e|0)>=(k[na>>2]|0))return;oa=k[pa>>2]|0;ja=k[a+4>>2]|0;ka=a+60|0;la=a+61|0;ma=c+16|0;ha=c+44|0;ia=a+32|0;ga=a+36|0;do{h=k[ja>>2]|0;N=h+(e*28|0)+12|0;o[N>>2]=0.0;b=j[ka>>1]|0;a:do if(!((b&255)<<24>>24)){while(1){b=fgb(436)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}zpb(b|0,0,436)|0;while(1){c=fgb(436)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}zpb(c|0,0,436)|0;while(1){a=fgb(436)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}zpb(a|0,0,436)|0;q=+o[h+(e*28|0)>>2];B=+o[h+(e*28|0)+4>>2];x=k[h+(e*28|0)+24>>2]|0;t=~~(+o[h+(e*28|0)+8>>2]*.5+.5);g=+(t|0)*2.5;g=g*(g*2.0);s=k[oa>>2]|0;u=s+(x*468|0)+16|0;v=s+(x*468|0)+44|0;w=s+(x*468|0)+72|0;x=s+(x*468|0)+100|0;s=-6;h=0;do{y=aa(s,s)|0;z=~~(q+ +(aa(s,t)|0)+.5);A=(z|0)>-1;n=+(z|0)-q;n=n*n;r=-6;do{if(((aa(r,r)|0)+y|0)>>>0<36){l=~~(B+ +(aa(r,t)|0)+.5);if(((l|0)>-1?A&(l|0)<(k[ga>>2]|0):0)?(z|0)<(k[ia>>2]|0):0){f=+(l|0)-B;f=+Z(+(-(n+f*f)/g));fa=(k[u>>2]|0)+(aa(k[k[v>>2]>>2]|0,l)|0)+(z<<2)|0;d=f*+o[fa>>2];o[b+(h<<2)>>2]=d;fa=(k[w>>2]|0)+(aa(k[k[x>>2]>>2]|0,l)|0)+(z<<2)|0;f=f*+o[fa>>2];o[c+(h<<2)>>2]=f}else{o[b+(h<<2)>>2]=0.0;o[c+(h<<2)>>2]=0.0;d=0.0;f=0.0}m=d>=0.0;l=f>=0.0;do if(!(m&l)){p=d<0.0;if(p&l){d=3.1415927410125732-+X(+(-f/d));break}l=f<0.0;if(p&l){d=+X(+(f/d))+3.1415927410125732;break}if(m&l)d=6.2831854820251465-+X(+(-f/d));else d=0.0}else d=+X(+(f/d));while(0);o[a+(h<<2)>>2]=d;h=h+1|0}r=r+1|0}while((r|0)!=7);s=s+1|0}while((s|0)!=7);B=0.0;d=0.0;do{q=B+1.0471975803375244;q=q>6.2831854820251465?B+-5.235987663269043:q;p=q<B;if(!(B<q))if(p){f=0.0;g=0.0;h=0;do{$=+o[a+(h<<2)>>2];if(!(!($>0.0&$<q)?!($>B&$<6.2831854820251465):0)){f=f+ +o[c+(h<<2)>>2];g=g+ +o[b+(h<<2)>>2]}h=h+1|0}while((h|0)!=109)}else{f=0.0;g=0.0}else{f=0.0;g=0.0;m=0;do{n=+o[a+(m<<2)>>2];h=B<n;l=n<q;if(!(h&l)){if(p?n>0.0&l|h&n<6.2831854820251465:0){f=f+ +o[c+(m<<2)>>2];g=g+ +o[b+(m<<2)>>2]}}else{f=f+ +o[c+(m<<2)>>2];g=g+ +o[b+(m<<2)>>2]}m=m+1|0}while((m|0)!=109)}n=g*g+f*f;if(n>d){l=g>=0.0;h=f>=0.0;do if(!(l&h)){m=g<0.0;if(m&h){d=3.1415927410125732-+X(+(-f/g));break}h=f<0.0;if(m&h){d=+X(+(f/g))+3.1415927410125732;break}if(l&h)d=6.2831854820251465-+X(+(-f/g));else d=0.0}else d=+X(+(f/g));while(0);o[N>>2]=d*180.0/3.1415927410125732;d=n}B=B+.15000000596046448}while(B<6.283185307179586);ggb(a);ggb(c);ggb(b);ca=k[ja>>2]|0;da=(k[ma>>2]|0)+(aa(k[k[ha>>2]>>2]|0,e)|0)|0;V=+o[ca+(e*28|0)+4>>2];W=+o[ca+(e*28|0)>>2];u=~~(+o[ca+(e*28|0)+8>>2]*.5+.5);_=+o[ca+(e*28|0)+12>>2]*3.1415927410125732/180.0;ca=k[ca+(e*28|0)+24>>2]|0;Y=+S(+_);_=+T(+_);v=0-u|0;$=+(u|0)*2.5;$=$*($*2.0);w=k[ia>>2]|0;x=k[ga>>2]|0;y=w+-1|0;z=x+-1|0;fa=k[k[pa>>2]>>2]|0;A=k[fa+(ca*468|0)+16>>2]|0;N=k[k[fa+(ca*468|0)+44>>2]>>2]|0;ba=k[fa+(ca*468|0)+72>>2]|0;ca=k[k[fa+(ca*468|0)+100>>2]>>2]|0;if(!(i[la>>0]|0)){G=-.5;l=0;p=-8;d=0.0;while(1){s=p+-4|0;G=G+1.0;I=+(aa(p+1|0,u)|0);H=Y*I;I=_*I;J=G+-2.0;J=J*J;t=p+4|0;F=-.5;m=-8;r=l;while(1){a=m+-4|0;B=W+(H+_*+(aa(u,~m)|0));C=V+(I+Y*+(aa(m+1|0,u)|0));h=m+4|0;b=s;f=0.0;g=0.0;n=0.0;q=0.0;while(1){E=+(aa(b,u)|0);D=_*E;E=Y*E;c=a;while(1){O=V+(D+Y*+(aa(c,u)|0));R=W+(E+_*+(aa(c,v)|0));U=B-R;M=C-O;M=+Z(+(-(U*U+M*M)/$));ra=~~(O+-.5+.5);qa=~~(R+-.5+.5);qa=(qa|0)<0?0:qa;ra=(ra|0)<0?0:ra;qa=(qa|0)<(w|0)?qa:y;ra=(ra|0)<(x|0)?ra:z;ea=~~(O+.5);fa=~~(R+.5);fa=(fa|0)<0?0:fa;ea=(ea|0)<0?0:ea;fa=(fa|0)<(w|0)?fa:y;ea=(ea|0)<(x|0)?ea:z;R=R-+(qa|0);O=O-+(ra|0);ta=A+(aa(N,ra)|0)|0;sa=A+(aa(N,ea)|0)|0;U=1.0-R;L=1.0-O;K=U*L;L=R*L;U=U*O;O=R*O;R=K*+o[ta+(qa<<2)>>2]+L*+o[ta+(fa<<2)>>2]+U*+o[sa+(qa<<2)>>2]+O*+o[sa+(fa<<2)>>2];ra=ba+(aa(ca,ra)|0)|0;ea=ba+(aa(ca,ea)|0)|0;O=K*+o[ra+(qa<<2)>>2]+L*+o[ra+(fa<<2)>>2]+U*+o[ea+(qa<<2)>>2]+O*+o[ea+(fa<<2)>>2];U=M*(Y*R+_*O);R=M*(Y*O-_*R);f=f+R;g=g+U;q=q+ +P(+R);n=n+ +P(+U);if((c|0)>=(h|0))break;else c=c+1|0}if((b|0)<(t|0))b=b+1|0;else break}F=F+1.0;U=F+-2.0;U=+Z(+(-(J+U*U)/4.5));o[da+(r<<2)>>2]=f*U;o[da+((r|1)<<2)>>2]=g*U;o[da+((r|2)<<2)>>2]=q*U;o[da+((r|3)<<2)>>2]=n*U;d=d+U*((n*n+(q*q+(g*g+f*f)))*U);m=m+5|0;if((m|0)>=12)break;else r=r+4|0}p=p+5|0;if((p|0)>=12)break;else l=l+16|0}d=+Q(+d);b=0;while(1){ta=da+(b<<2)|0;o[ta>>2]=+o[ta>>2]/d;b=b+1|0;if((b|0)==64)break a}}else{M=-.5;m=0;r=-8;d=0.0}while(1){s=r+-4|0;M=M+1.0;R=+(aa(r+1|0,u)|0);O=Y*R;R=_*R;U=M+-2.0;U=U*U;t=r+4|0;L=-.5;p=-8;a=m;while(1){h=p+-4|0;H=W+(O+_*+(aa(u,~p)|0));I=V+(R+Y*+(aa(p+1|0,u)|0));l=p+4|0;b=s;f=0.0;n=0.0;q=0.0;B=0.0;C=0.0;D=0.0;E=0.0;g=0.0;while(1){K=+(aa(b,u)|0);J=_*K;K=Y*K;c=h;G=n;while(1){ua=V+(J+Y*+(aa(c,u)|0));n=W+(K+_*+(aa(c,v)|0));F=H-n;va=I-ua;va=+Z(+(-(F*F+va*va)/$));qa=~~(ua+-.5+.5);ra=~~(n+-.5+.5);ra=(ra|0)<0?0:ra;qa=(qa|0)<0?0:qa;ra=(ra|0)<(w|0)?ra:y;qa=(qa|0)<(x|0)?qa:z;sa=~~(ua+.5);ta=~~(n+.5);ta=(ta|0)<0?0:ta;sa=(sa|0)<0?0:sa;ta=(ta|0)<(w|0)?ta:y;sa=(sa|0)<(x|0)?sa:z;n=n-+(ra|0);ua=ua-+(qa|0);ea=A+(aa(N,qa)|0)|0;fa=A+(aa(N,sa)|0)|0;F=1.0-n;wa=1.0-ua;xa=F*wa;wa=n*wa;F=F*ua;ua=n*ua;n=xa*+o[ea+(ra<<2)>>2]+wa*+o[ea+(ta<<2)>>2]+F*+o[fa+(ra<<2)>>2]+ua*+o[fa+(ta<<2)>>2];qa=ba+(aa(ca,qa)|0)|0;sa=ba+(aa(ca,sa)|0)|0;ua=xa*+o[qa+(ra<<2)>>2]+wa*+o[qa+(ta<<2)>>2]+F*+o[sa+(ra<<2)>>2]+ua*+o[sa+(ta<<2)>>2];F=va*(Y*n+_*ua);n=va*(Y*ua-_*n);if(!(F>=0.0)){G=G+ +P(+n);B=B+n}else{D=D+ +P(+n);g=g+n}if(!(n>=0.0)){f=f+ +P(+F);q=q+F}else{C=C+ +P(+F);E=E+F}if((c|0)<(l|0))c=c+1|0;else break}if((b|0)<(t|0)){b=b+1|0;n=G}else break}L=L+1.0;xa=L+-2.0;xa=+Z(+(-(U+xa*xa)/4.5));o[da+(a<<2)>>2]=g*xa;o[da+((a|1)<<2)>>2]=B*xa;o[da+((a|2)<<2)>>2]=D*xa;o[da+((a|3)<<2)>>2]=G*xa;o[da+((a|4)<<2)>>2]=E*xa;o[da+((a|5)<<2)>>2]=q*xa;o[da+((a|6)<<2)>>2]=C*xa;o[da+((a|7)<<2)>>2]=f*xa;d=d+xa*((f*f+(C*C+(q*q+(E*E+(D*D+(g*g+B*B)+G*G)))))*xa);p=p+5|0;if((p|0)>=12)break;else a=a+8|0}r=r+5|0;if((r|0)>=12)break;else m=m+32|0}d=+Q(+d);b=0;do{ta=da+(b<<2)|0;o[ta>>2]=+o[ta>>2]/d;b=b+1|0}while((b|0)!=128)}else{o[N>>2]=0.0;fa=(k[ma>>2]|0)+(aa(k[k[ha>>2]>>2]|0,e)|0)|0;V=+o[h+(e*28|0)+4>>2];W=+o[h+(e*28|0)>>2];ea=~~(+o[h+(e*28|0)+8>>2]*.5+.5);da=k[h+(e*28|0)+24>>2]|0;U=+(ea|0)*2.5;U=U*(U*2.0);x=k[ia>>2]|0;y=k[ga>>2]|0;z=x+-1|0;A=y+-1|0;ta=k[k[pa>>2]>>2]|0;N=k[ta+(da*468|0)+16>>2]|0;ba=k[k[ta+(da*468|0)+44>>2]>>2]|0;ca=k[ta+(da*468|0)+72>>2]|0;da=k[k[ta+(da*468|0)+100>>2]>>2]|0;if((b&65535)<256){G=-.5;r=0;t=-8;d=0.0;while(1){v=t+-4|0;G=G+1.0;H=V+ +(aa(t+1|0,ea)|0);I=G+-2.0;I=I*I;w=t+4|0;F=-.5;s=-8;u=r;while(1){p=s+-4|0;E=W+ +(aa(s+1|0,ea)|0);s=s+5|0;m=v;q=0.0;n=0.0;g=0.0;f=0.0;while(1){C=V+ +(aa(m,ea)|0);B=H-C;B=B*B;h=~~(C+-.5);ta=(h|0)<0;h=ta?0:h;h=(h|0)<(y|0)?h:A;l=~~(C+.5);l=(l|0)<0?0:l;l=(l|0)<(y|0)?l:A;C=C-+(h|0);c=N+(aa(ba,h)|0)|0;a=N+(aa(ba,l)|0)|0;D=1.0-C;h=ca+(aa(da,h)|0)|0;l=ca+(aa(da,l)|0)|0;if(ta){b=p;do{xa=W+ +(aa(b,ea)|0);_=E-xa;_=+Z(+(-(B+_*_)/U));sa=~~(xa+-.5);sa=(sa|0)<0?0:sa;sa=(sa|0)<(x|0)?sa:z;ta=~~(xa+.5);ta=(ta|0)<0?0:ta;ta=(ta|0)<(x|0)?ta:z;xa=xa-+(sa|0);va=1.0-xa;$=va*D;ua=xa*D;va=va*C;xa=xa*C;wa=_*($*+o[c+(sa<<2)>>2]+ua*+o[c+(ta<<2)>>2]+va*+o[a+(sa<<2)>>2]+xa*+o[a+(ta<<2)>>2]);xa=_*($*+o[h+(sa<<2)>>2]+ua*+o[h+(ta<<2)>>2]+va*+o[l+(sa<<2)>>2]+xa*+o[l+(ta<<2)>>2]);q=q+wa;f=f+xa;g=g+ +P(+wa);n=n+ +P(+xa);b=b+1|0}while((b|0)<(s|0))}else{b=p;do{xa=W+ +(aa(b,ea)|0);_=E-xa;_=+Z(+(-(B+_*_)/U));sa=~~(xa+-.5);sa=(sa|0)<0?0:sa;sa=(sa|0)<(x|0)?sa:z;ta=~~(xa+.5);ta=(ta|0)<0?0:ta;ta=(ta|0)<(x|0)?ta:z;xa=xa-+(sa|0);va=1.0-xa;$=va*D;ua=xa*D;va=va*C;xa=xa*C;wa=_*($*+o[c+(sa<<2)>>2]+ua*+o[c+(ta<<2)>>2]+va*+o[a+(sa<<2)>>2]+xa*+o[a+(ta<<2)>>2]);xa=_*($*+o[h+(sa<<2)>>2]+ua*+o[h+(ta<<2)>>2]+va*+o[l+(sa<<2)>>2]+xa*+o[l+(ta<<2)>>2]);q=q+wa;f=f+xa;g=g+ +P(+wa);n=n+ +P(+xa);b=b+1|0}while((b|0)<(s|0))}if((m|0)<(w|0))m=m+1|0;else break}F=F+1.0;xa=F+-2.0;xa=+Z(+(-(I+xa*xa)/4.5));o[fa+(u<<2)>>2]=q*xa;o[fa+((u|1)<<2)>>2]=f*xa;o[fa+((u|2)<<2)>>2]=g*xa;o[fa+((u|3)<<2)>>2]=n*xa;d=d+xa*((n*n+(g*g+(f*f+q*q)))*xa);if((s|0)>=12)break;else u=u+4|0}t=t+5|0;if((t|0)>=12)break;else r=r+16|0}d=+Q(+d);b=0;while(1){ta=fa+(b<<2)|0;o[ta>>2]=+o[ta>>2]/d;b=b+1|0;if((b|0)==64)break a}}else{M=-.5;r=0;t=-8;d=0.0}while(1){v=t+-4|0;M=M+1.0;O=V+ +(aa(t+1|0,ea)|0);R=M+-2.0;R=R*R;w=t+4|0;L=-.5;s=-8;u=r;while(1){p=s+-4|0;K=W+ +(aa(s+1|0,ea)|0);s=s+5|0;m=v;E=0.0;D=0.0;C=0.0;B=0.0;q=0.0;n=0.0;g=0.0;f=0.0;while(1){I=V+ +(aa(m,ea)|0);H=O-I;H=H*H;h=~~(I+-.5);ta=(h|0)<0;h=ta?0:h;h=(h|0)<(y|0)?h:A;l=~~(I+.5);l=(l|0)<0?0:l;l=(l|0)<(y|0)?l:A;I=I-+(h|0);c=N+(aa(ba,h)|0)|0;a=N+(aa(ba,l)|0)|0;J=1.0-I;h=ca+(aa(da,h)|0)|0;l=ca+(aa(da,l)|0)|0;if(ta){b=p;do{G=W+ +(aa(b,ea)|0);ua=K-G;ua=+Z(+(-(H+ua*ua)/U));sa=~~(G+-.5);sa=(sa|0)<0?0:sa;sa=(sa|0)<(x|0)?sa:z;ta=~~(G+.5);ta=(ta|0)<0?0:ta;ta=(ta|0)<(x|0)?ta:z;G=G-+(sa|0);xa=1.0-G;va=xa*J;wa=G*J;xa=xa*I;G=G*I;F=ua*(va*+o[c+(sa<<2)>>2]+wa*+o[c+(ta<<2)>>2]+xa*+o[a+(sa<<2)>>2]+G*+o[a+(ta<<2)>>2]);G=ua*(va*+o[h+(sa<<2)>>2]+wa*+o[h+(ta<<2)>>2]+xa*+o[l+(sa<<2)>>2]+G*+o[l+(ta<<2)>>2]);if(!(G>=0.0)){D=D+ +P(+F);B=B+F}else{n=n+ +P(+F);f=f+F}if(!(F>=0.0)){E=E+ +P(+G);C=C+G}else{q=q+ +P(+G);g=g+G}b=b+1|0}while((b|0)<(s|0))}else{b=p;do{G=W+ +(aa(b,ea)|0);ua=K-G;ua=+Z(+(-(H+ua*ua)/U));sa=~~(G+-.5);sa=(sa|0)<0?0:sa;sa=(sa|0)<(x|0)?sa:z;ta=~~(G+.5);ta=(ta|0)<0?0:ta;ta=(ta|0)<(x|0)?ta:z;G=G-+(sa|0);xa=1.0-G;va=xa*J;wa=G*J;xa=xa*I;G=G*I;F=ua*(va*+o[c+(sa<<2)>>2]+wa*+o[c+(ta<<2)>>2]+xa*+o[a+(sa<<2)>>2]+G*+o[a+(ta<<2)>>2]);G=ua*(va*+o[h+(sa<<2)>>2]+wa*+o[h+(ta<<2)>>2]+xa*+o[l+(sa<<2)>>2]+G*+o[l+(ta<<2)>>2]);if(!(G>=0.0)){D=D+ +P(+F);B=B+F}else{n=n+ +P(+F);f=f+F}if(!(F>=0.0)){E=E+ +P(+G);C=C+G}else{q=q+ +P(+G);g=g+G}b=b+1|0}while((b|0)<(s|0))}if((m|0)<(w|0))m=m+1|0;else break}L=L+1.0;xa=L+-2.0;xa=+Z(+(-(R+xa*xa)/4.5));o[fa+(u<<2)>>2]=f*xa;o[fa+((u|1)<<2)>>2]=B*xa;o[fa+((u|2)<<2)>>2]=n*xa;o[fa+((u|3)<<2)>>2]=D*xa;o[fa+((u|4)<<2)>>2]=g*xa;o[fa+((u|5)<<2)>>2]=C*xa;o[fa+((u|6)<<2)>>2]=q*xa;o[fa+((u|7)<<2)>>2]=E*xa;d=d+xa*((E*E+(q*q+(C*C+(g*g+(n*n+(f*f+B*B)+D*D)))))*xa);if((s|0)>=12)break;else u=u+8|0}t=t+5|0;if((t|0)>=12)break;else r=r+32|0}d=+Q(+d);b=0;do{ta=fa+(b<<2)|0;o[ta>>2]=+o[ta>>2]/d;b=b+1|0}while((b|0)!=128)}while(0);e=e+1|0}while((e|0)<(k[na>>2]|0));return}function TWa(a,b,c,d,e){a=+a;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,p=0,q=0,s=0.0;q=r;r=r+16|0;p=q;h=a/+(b|0)*3.0;a=+o[c>>2];m=~~(+$(+(+Q(+(h/a+.25))+-.5+-9.99999993922529e-09))+.5);a=h/(a*+(aa(m+1|0,m)|0));k[p>>2]=0;n=p+4|0;k[n>>2]=0;k[p+8>>2]=0;if((m|0)<1){p=0;r=q;return p|0}if(m>>>0>1073741823)ad(426534,426557,304,426811);g=m<<2;f=(g|0)==0?1:g;while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}zpb(b|0,0,g|0)|0;zH(e,b,b+(m<<2)|0);if(b|0)ggb(b);if(!(i[d>>0]|0))d=0;else{if(!m){f=0;b=0}else{while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}zpb(b|0,0,g|0)|0;f=b;b=b+(m<<2)|0}zH(p,f,b);if(f|0)ggb(f);d=i[d>>0]|0}h=1.0/(+(m|0)*4.0+2.0);a=a*+o[c>>2]*.5;c=(m|0)>0;if(c){f=k[e>>2]|0;g=k[p>>2]|0;if(!(d<<24>>24)){b=0;do{s=+S(+(h*((+(b|0)*2.0+1.0)*3.1415927410125732)));o[f+(b<<2)>>2]=a/(s*s);b=b+1|0}while((b|0)!=(m|0))}else{b=0;do{s=+S(+(h*((+(b|0)*2.0+1.0)*3.1415927410125732)));o[g+(b<<2)>>2]=a/(s*s);b=b+1|0}while((b|0)!=(m|0));j=22}}else j=22;if((j|0)==22?d<<24>>24:0){j=(m|0)/2|0;l=m;while(1){b=l;l=l+1|0;if((l|0)<2)continue;d=b+-1|0;if(d>>>0<6?43>>>(d&255)&1:0)break;if(((l>>>0)%7|0|0)==0|(((l>>>0)%5|0|0)==0|((l&1|0)==0|((l>>>0)%3|0|0)==0)))continue;g=~~+Q(+(+(l|0)+1.0));if((g|0)<11)break;else{b=1;f=11}do{b=b&((l|0)%(f|0)|0|0)!=0;f=f+2|0}while((f|0)<=(g|0));if(b)break}if(c){c=k[p>>2]|0;d=k[e>>2]|0;b=0;g=0;do{do{b=b+1|0;f=(aa(b,j)|0)%(l|0)|0}while((f|0)>(m|0));k[d+(g<<2)>>2]=k[c+(f+-1<<2)>>2];g=g+1|0}while((g|0)!=(m|0))}}b=k[p>>2]|0;if(!b){p=m;r=q;return p|0}f=k[n>>2]|0;if((f|0)!=(b|0))k[n>>2]=f+(~((f+-4-b|0)>>>2)<<2);ggb(b);p=m;r=q;return p|0}function UWa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0.0,w=0.0;u=r;r=r+32|0;q=u+16|0;s=u;h=k[a+40>>2]|0;t=k[h+4>>2]|0;h=k[h>>2]|0;d=1.0/(d*d);if((h|0)>0?(i=k[a+16>>2]|0,j=k[k[a+44>>2]>>2]|0,l=k[b+16>>2]|0,m=k[k[b+44>>2]>>2]|0,n=k[c+16>>2]|0,p=k[k[c+44>>2]>>2]|0,(t|0)>0):0){b=0;do{e=i+(aa(j,b)|0)|0;f=l+(aa(m,b)|0)|0;g=n+(aa(p,b)|0)|0;a=0;do{w=+o[e+(a<<2)>>2];v=+o[f+(a<<2)>>2];o[g+(a<<2)>>2]=-(d*(w*w+v*v));a=a+1|0}while((a|0)!=(t|0));b=b+1|0}while((b|0)!=(h|0))}k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=c;t=s+4|0;p=t+4|0;k[p>>2]=0;k[p+4>>2]=0;k[s>>2]=33619968;k[t>>2]=c;XZ(q,s);r=u;return}function VWa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0.0,t=0.0;q=r;r=r+16|0;f=q;p=k[a+40>>2]|0;n=k[p+4>>2]|0;p=k[p>>2]|0;e=k[a>>2]&4095;if(!(((((k[c+4>>2]|0)<3?(k[c+8>>2]|0)==(p|0):0)?(k[c+12>>2]|0)==(n|0):0)?(k[c>>2]&4095|0)==(e|0):0)?(k[c+16>>2]|0)!=0:0)){k[f>>2]=p;k[f+4>>2]=n;G1(c,2,f,e)}d=1.0/(d*d);if((p|0)<=0){r=q;return}m=k[a+16>>2]|0;j=k[k[a+44>>2]>>2]|0;l=k[b+16>>2]|0;h=k[k[b+44>>2]>>2]|0;i=k[c+16>>2]|0;a=k[k[c+44>>2]>>2]|0;if((n|0)>0)e=0;else{r=q;return}do{b=m+(aa(j,e)|0)|0;c=l+(aa(h,e)|0)|0;g=i+(aa(a,e)|0)|0;f=0;do{t=+o[b+(f<<2)>>2];s=+o[c+(f<<2)>>2];o[g+(f<<2)>>2]=1.0/(d*(t*t+s*s)+1.0);f=f+1|0}while((f|0)!=(n|0));e=e+1|0}while((e|0)!=(p|0));r=q;return}function WWa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0;v=r;r=r+256|0;s=v+32|0;t=v;h=k[a+40>>2]|0;u=k[h+4>>2]|0;h=k[h>>2]|0;d=1.0/(d*d);if((h|0)>0?(i=k[a+16>>2]|0,j=k[k[a+44>>2]>>2]|0,l=k[b+16>>2]|0,m=k[k[b+44>>2]>>2]|0,n=k[c+16>>2]|0,q=k[k[c+44>>2]>>2]|0,(u|0)>0):0){a=0;do{e=i+(aa(j,a)|0)|0;f=l+(aa(m,a)|0)|0;g=n+(aa(q,a)|0)|0;b=0;do{x=+o[e+(b<<2)>>2];w=+o[f+(b<<2)>>2];w=d*(x*x+w*w);o[g+(b<<2)>>2]=-3.315000057220459/(w*(w*(w*w)));b=b+1|0}while((b|0)!=(u|0));a=a+1|0}while((a|0)!=(h|0))}k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=c;u=t+4|0;q=u+4|0;k[q>>2]=0;k[q+4>>2]=0;k[t>>2]=33619968;k[u>>2]=c;XZ(s,t);p[t>>3]=1.0;u=t+8|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;k[u+16>>2]=0;k[u+20>>2]=0;Z0(s,t,c);u=k[s>>2]|0;dh[k[(k[u>>2]|0)+12>>2]&255](u,s,c,-1);XN(s);r=v;return}function XWa(a,b,c,d){a=a|0;b=+b;c=+c;d=d|0;var e=0,f=0,g=0,h=0,i=0.0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,P=0,R=0,S=0.0;R=r;r=r+880|0;v=R+864|0;w=R+848|0;x=R+840|0;P=R+784|0;l=R+448|0;M=R+728|0;p=R+224|0;H=R+672|0;u=R;if(!d)N=0;else{if(d>>>0>1073741823)ad(426534,426557,304,426811);g=d<<2;f=(g|0)==0?1:g;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}zpb(e|0,0,g|0)|0;N=e}m=a+8|0;g=k[m>>2]|0;n=a+12|0;h=k[n>>2]|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=1124007936;e=l+16|0;f=l+48|0;q=l+12|0;t=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[f>>2]=e;e=l+56|0;k[l+52>>2]=e;k[l+60>>2]=0;k[e>>2]=0;k[l+64>>2]=1124007936;e=l+72|0;f=l+104|0;q=l+68|0;t=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[f>>2]=e;e=l+112|0;k[l+108>>2]=e;k[l+116>>2]=0;k[e>>2]=0;k[l+120>>2]=1124007936;e=l+128|0;f=l+160|0;q=l+124|0;t=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[f>>2]=e;q=l+168|0;k[l+164>>2]=q;t=q+56|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[v>>2]=h;k[v+4>>2]=g;j1(l,48,v,5);k[P>>2]=1124007936;J=P+4|0;C=P+8|0;I=P+40|0;q=J;t=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[I>>2]=C;L=P+48|0;K=P+44|0;k[K>>2]=L;k[P+52>>2]=0;k[L>>2]=0;g=k[l>>2]|0;dh[k[(k[g>>2]|0)+12>>2]&255](g,l,P,-1);XN(l);g=k[m>>2]|0;h=k[n>>2]|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=1124007936;e=p+16|0;f=p+48|0;q=p+12|0;t=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[f>>2]=e;e=p+56|0;k[p+52>>2]=e;k[p+60>>2]=0;k[e>>2]=0;k[p+64>>2]=1124007936;e=p+72|0;f=p+104|0;q=p+68|0;t=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[f>>2]=e;e=p+112|0;k[p+108>>2]=e;k[p+116>>2]=0;k[e>>2]=0;k[p+120>>2]=1124007936;e=p+128|0;f=p+160|0;q=p+124|0;t=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[f>>2]=e;q=p+168|0;k[p+164>>2]=q;t=q+56|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[v>>2]=h;k[v+4>>2]=g;j1(p,48,v,5);k[M>>2]=1124007936;F=M+4|0;e=M+8|0;D=M+40|0;q=F;t=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[D>>2]=e;G=M+48|0;E=M+44|0;k[E>>2]=G;k[M+52>>2]=0;k[G>>2]=0;h=k[p>>2]|0;dh[k[(k[h>>2]|0)+12>>2]&255](h,p,M,-1);XN(p);h=k[m>>2]|0;g=k[n>>2]|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=1124007936;e=u+16|0;f=u+48|0;q=u+12|0;t=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[f>>2]=e;e=u+56|0;k[u+52>>2]=e;k[u+60>>2]=0;k[e>>2]=0;k[u+64>>2]=1124007936;e=u+72|0;f=u+104|0;q=u+68|0;t=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[f>>2]=e;e=u+112|0;k[u+108>>2]=e;k[u+116>>2]=0;k[e>>2]=0;k[u+120>>2]=1124007936;e=u+128|0;f=u+160|0;q=u+124|0;t=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[f>>2]=e;q=u+168|0;k[u+164>>2]=q;t=q+56|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[v>>2]=g;k[v+4>>2]=h;j1(u,48,v,5);k[H>>2]=1124007936;B=H+4|0;e=H+8|0;z=H+40|0;q=B;t=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(t|0));k[z>>2]=e;A=H+48|0;y=H+44|0;k[y>>2]=A;k[H+52>>2]=0;k[A>>2]=0;m=k[u>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,u,H,-1);XN(u);m=~~+$(+(((c+-.800000011920929)/.30000001192092896+1.0)*2.0));m=(m&1^1)+m|0;k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=16842752;k[v+4>>2]=a;u=w+4|0;a=u+4|0;k[a>>2]=0;k[a+4>>2]=0;k[w>>2]=33619968;k[u>>2]=P;k[x>>2]=m;k[x+4>>2]=m;s=c;uua(v,w,x,s,s,1);k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=16842752;k[v+4>>2]=P;m=w+4|0;x=m+4|0;k[x>>2]=0;k[x+4>>2]=0;k[w>>2]=33619968;k[m>>2]=M;ufa(v,w,5,1,0,1.0,0.0,4);k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=16842752;k[v+4>>2]=P;m=w+4|0;x=m+4|0;k[x>>2]=0;k[x+4>>2]=0;k[w>>2]=33619968;k[m>>2]=H;ufa(v,w,5,0,1,1.0,0.0,4);m=(k[C>>2]|0)+-1|0;a:do if((m|0)>1){t=k[M+16>>2]|0;a=k[E>>2]|0;g=k[a>>2]|0;u=k[H+16>>2]|0;v=k[y>>2]|0;h=k[v>>2]|0;w=P+12|0;f=k[w>>2]|0;n=f+-1|0;if((n|0)>1){l=1;c=0.0;do{p=t+(aa(g,l)|0)|0;q=u+(aa(h,l)|0)|0;e=1;do{j=+o[p+(e<<2)>>2];s=+o[q+(e<<2)>>2];s=j*j+s*s;c=s>c?s:c;e=e+1|0}while((e|0)!=(n|0));l=l+1|0}while((l|0)!=(m|0));i=+Q(+c)}else i=0.0;s=+(d|0);e=1;c=0.0;while(1){l=t+(aa(g,e)|0)|0;h=u+(aa(h,e)|0)|0;if((f+-1|0)>1){g=1;do{S=+o[l+(g<<2)>>2];j=+o[h+(g<<2)>>2];j=S*S+j*j;if(j!=0.0){f=~~+O(+(s*(+Q(+j)/i)));f=N+((((f|0)==(d|0))<<31>>31)+f<<2)|0;k[f>>2]=(k[f>>2]|0)+1;c=c+1.0;f=k[w>>2]|0}g=g+1|0}while((g|0)<(f+-1|0))}e=e+1|0;if((e|0)>=((k[C>>2]|0)+-1|0))break a;g=k[a>>2]|0;h=k[v>>2]|0}}else{c=0.0;i=0.0}while(0);h=~~(c*b);e=(h|0)>0;if((d|0)>0&e){g=0;e=0;while(1){g=(k[N+(e<<2)>>2]|0)+g|0;f=e+1|0;e=(g|0)<(h|0);if(!((f|0)<(d|0)&e))break;else e=f}}else f=0;if(e)c=.029999999329447746;else c=i*(+(f|0)/+(d|0));g=H+36|0;e=k[g>>2]|0;if(e|0?(C=e+12|0,d=k[C>>2]|0,k[C>>2]=d+-1,(d|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[H+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;H=H+16|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[B>>2]|0)>0){f=k[z>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[B>>2]|0))}e=k[y>>2]|0;if(!((e|0)==(A|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=M+36|0;e=k[g>>2]|0;if(e|0?(d=e+12|0,H=k[d>>2]|0,k[d>>2]=H+-1,(H|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[M+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;M=M+16|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[F>>2]|0)>0){f=k[D>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[F>>2]|0))}e=k[E>>2]|0;if(!((e|0)==(G|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=P+36|0;e=k[g>>2]|0;if(e|0?(H=e+12|0,M=k[H>>2]|0,k[H>>2]=M+-1,(M|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[P+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;P=P+16|0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[J>>2]|0)>0){f=k[I>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[J>>2]|0))}e=k[K>>2]|0;if(!((e|0)==(L|0)|(e|0)==0))ggb(k[e+-4>>2]|0);if(!N){r=R;return +c}ggb(N);r=R;return +c}function YWa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;_=r;r=r+336|0;M=_+280|0;N=_+224|0;O=_+168|0;P=_+152|0;W=_+96|0;T=_+40|0;i=_+24|0;q=_;L=_+16|0;k[W>>2]=1124007936;Y=W+4|0;f=W+8|0;V=W+40|0;g=Y;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[V>>2]=f;Z=W+48|0;X=W+44|0;k[X>>2]=Z;k[W+52>>2]=0;k[Z>>2]=0;k[T>>2]=1124007936;U=T+4|0;f=T+8|0;R=T+40|0;g=U;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[R>>2]=f;S=T+48|0;Q=T+44|0;k[Q>>2]=S;k[T+52>>2]=0;k[S>>2]=0;f=i+4|0;p=f+4|0;k[p>>2]=0;k[p+4>>2]=0;k[i>>2]=33619968;k[f>>2]=W;p=q+4|0;J=p+4|0;k[J>>2]=0;k[J+4>>2]=0;k[q>>2]=33619968;k[p>>2]=T;J=e<<1|1;if((e|0)!=1){k[M>>2]=J;I=M+4|0;k[I>>2]=1;P1(i,2,M,5,-1,1,0);k[M>>2]=J;k[I>>2]=1;P1(q,2,M,5,-1,1,0);do if((k[i>>2]&2031616|0)==65536){i=k[f>>2]|0;k[M>>2]=k[i>>2];n=M+4|0;f=i+4|0;k[n>>2]=k[f>>2];I=M+8|0;k[I>>2]=k[i+8>>2];k[M+12>>2]=k[i+12>>2];k[M+16>>2]=k[i+16>>2];k[M+20>>2]=k[i+20>>2];k[M+24>>2]=k[i+24>>2];k[M+28>>2]=k[i+28>>2];k[M+32>>2]=k[i+32>>2];g=k[i+36>>2]|0;k[M+36>>2]=g;h=M+40|0;k[h>>2]=I;I=M+48|0;l=M+44|0;k[l>>2]=I;k[M+52>>2]=0;k[I>>2]=0;if(g|0){I=g+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[f>>2]|0)<3){G=k[i+44>>2]|0;I=k[l>>2]|0;k[I>>2]=k[G>>2];k[I+4>>2]=k[G+4>>2];break}k[n>>2]=0;x1(M,k[f>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[i+40>>2]|0;j=k[h>>2]|0;h=k[i+44>>2]|0;g=k[l>>2]|0;f=0;do{k[j+(f<<2)>>2]=k[m+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[n>>2]|0))}}else Q1(M,i,-1);while(0);do if((k[q>>2]&2031616|0)==65536){i=k[p>>2]|0;k[N>>2]=k[i>>2];n=N+4|0;f=i+4|0;k[n>>2]=k[f>>2];I=N+8|0;k[I>>2]=k[i+8>>2];k[N+12>>2]=k[i+12>>2];k[N+16>>2]=k[i+16>>2];k[N+20>>2]=k[i+20>>2];k[N+24>>2]=k[i+24>>2];k[N+28>>2]=k[i+28>>2];k[N+32>>2]=k[i+32>>2];g=k[i+36>>2]|0;k[N+36>>2]=g;h=N+40|0;k[h>>2]=I;I=N+48|0;l=N+44|0;k[l>>2]=I;k[N+52>>2]=0;k[I>>2]=0;if(g|0){I=g+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[f>>2]|0)<3){G=k[i+44>>2]|0;I=k[l>>2]|0;k[I>>2]=k[G>>2];k[I+4>>2]=k[G+4>>2];break}k[n>>2]=0;x1(N,k[f>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[i+40>>2]|0;j=k[h>>2]|0;h=k[i+44>>2]|0;g=k[l>>2]|0;f=0;do{k[j+(f<<2)>>2]=k[m+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[n>>2]|0))}}else Q1(N,q,-1);while(0);s=1.0/(+(e|0)*2.0*5.3333330154418945);q=J>>>0>1073741823;t=J<<2;u=O+4|0;v=O+8|0;w=O+12|0;x=O+16|0;y=O+20|0;z=O+24|0;A=O+28|0;B=O+40|0;C=O+48|0;D=O+44|0;E=P+4|0;F=E+4|0;G=O+36|0;H=s*3.3333332538604736;I=(J|0)/2|0;p=J+-1|0;l=e<<3|4;m=O+52|0;n=O+32|0;j=0;do{h=(j|0)==0;g=h?M:N;h=h?c:d;if(q){K=36;break}while(1){f=fgb(t)|0;if(f|0){i=f;break}f=k[207666]|0;k[207666]=f+0;if(!f){i=0;break}Qh[f&7]()}zpb(i|0,0,l|0)|0;switch(h|0){case 0:{o[i>>2]=s;o[i+(I<<2)>>2]=H;o[i+(p<<2)>>2]=s;break}case 1:{o[i>>2]=-1.0;o[i+(I<<2)>>2]=0.0;o[i+(p<<2)>>2]=1.0;break}default:{}}e=k[g+8>>2]|0;f=k[g+12>>2]|0;k[u>>2]=2;k[v>>2]=e;k[w>>2]=f;k[x>>2]=i;k[y>>2]=i;J=z+8|0;k[J>>2]=0;k[J+4>>2]=0;k[B>>2]=v;k[D>>2]=C;f=f<<2;k[O>>2]=1124024325;k[C>>2]=f;k[m>>2]=4;e=i+(aa(e,f)|0)|0;k[A>>2]=e;k[z>>2]=e+(0-f)+f;f=F;k[f>>2]=0;k[f+4>>2]=0;k[P>>2]=33619968;k[E>>2]=g;mY(O,P);f=k[G>>2]|0;if(f|0?(J=f+12|0,e=k[J>>2]|0,k[J>>2]=e+-1,(e|0)==1):0){g=k[G>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[n>>2]|0;if(!f){f=B1()|0;g=k[G>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[G>>2]=0}k[G>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[u>>2]|0)>0){g=k[B>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[u>>2]|0))}f=k[D>>2]|0;if(!((f|0)==(C|0)|(f|0)==0))ggb(k[f+-4>>2]|0);if(i|0)ggb(i);j=j+1|0}while((j|0)<2);if((K|0)==36)ad(426534,426557,304,426811);h=N+36|0;f=k[h>>2]|0;if(f|0?(d=f+12|0,K=k[d>>2]|0,k[d>>2]=K+-1,(K|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[N+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;K=N+16|0;g=N+4|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[g>>2]|0)>0){h=k[N+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[N+44>>2]|0;if(!((f|0)==(N+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=M+36|0;f=k[h>>2]|0;if(f|0?(d=f+12|0,K=k[d>>2]|0,k[d>>2]=K+-1,(K|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[M+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;K=M+16|0;g=M+4|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[g>>2]|0)>0){h=k[M+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[M+44>>2]|0;if(!((f|0)==(M+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}else rfa(i,q,c,d,1,5);k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=16842752;k[M+4>>2]=a;h=N+4|0;f=h+4|0;k[f>>2]=0;k[f+4>>2]=0;k[N>>2]=33619968;k[h>>2]=b;k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=W;k[P+8>>2]=0;k[P+12>>2]=0;k[P>>2]=16842752;k[P+4>>2]=T;k[L>>2]=-1;k[L+4>>2]=-1;gla(M,N,5,O,P,L,0.0,4);h=T+36|0;f=k[h>>2]|0;if(f|0?(O=f+12|0,P=k[O>>2]|0,k[O>>2]=P+-1,(P|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[T+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;T=T+16|0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[U>>2]|0)>0){g=k[R>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[U>>2]|0))}f=k[Q>>2]|0;if(!((f|0)==(S|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=W+36|0;f=k[h>>2]|0;if(f|0?(T=f+12|0,U=k[T>>2]|0,k[T>>2]=U+-1,(U|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[W+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;W=W+16|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[Y>>2]|0)>0){g=k[V>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[Y>>2]|0))}f=k[X>>2]|0;if((f|0)==(Z|0)|(f|0)==0){r=_;return}ggb(k[f+-4>>2]|0);r=_;return}function ZWa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0;C=r;r=r+64|0;z=C+40|0;A=C+16|0;B=C;f=c+8|0;x=(k[f>>2]|0)+-1|0;k[z>>2]=1;k[z+4>>2]=x;k[A>>2]=142732;k[A+4>>2]=a;k[A+8>>2]=b;k[A+12>>2]=c;o[A+16>>2]=d;$Wa(A,z);x=k[c+16>>2]|0;g=c+44|0;y=k[b+16>>2]|0;t=k[k[b+44>>2]>>2]|0;p=y+t|0;u=k[a+16>>2]|0;v=k[k[a+44>>2]>>2]|0;j=u+v|0;n=k[c+12>>2]|0;w=n+-1|0;m=(w|0)>1;if(m){e=d*.5;b=1;do{E=+o[y+(b<<2)>>2];s=b;b=b+1|0;D=+o[u+(s<<2)>>2];q=s+-1|0;o[x+(s<<2)>>2]=e*((E+ +o[y+(b<<2)>>2])*(+o[u+(b<<2)>>2]-D)-(E+ +o[y+(q<<2)>>2])*(D-+o[u+(q<<2)>>2])+(E+ +o[p+(s<<2)>>2])*(+o[j+(s<<2)>>2]-D))}while((b|0)!=(w|0))}l=k[f>>2]|0;s=l+-1|0;q=k[k[g>>2]>>2]|0;f=x+(aa(q,s)|0)|0;g=y+(aa(t,s)|0)|0;l=l+-2|0;h=y+(aa(t,l)|0)|0;i=u+(aa(v,s)|0)|0;l=u+(aa(v,l)|0)|0;if(m){e=d*.5;b=1;do{D=+o[g+(b<<2)>>2];m=b;b=b+1|0;E=+o[i+(m<<2)>>2];F=m+-1|0;o[f+(m<<2)>>2]=e*((D+ +o[g+(b<<2)>>2])*(+o[i+(b<<2)>>2]-E)-(D+ +o[g+(F<<2)>>2])*(E-+o[i+(F<<2)>>2])-(D+ +o[h+(m<<2)>>2])*(E-+o[l+(m<<2)>>2]))}while((b|0)!=(w|0))}m=n+-2|0;if((s|0)<=1){F=z+8|0;k[F>>2]=0;F=z+12|0;k[F>>2]=0;k[z>>2]=16842752;F=z+4|0;k[F>>2]=a;F=A+8|0;k[F>>2]=0;F=A+12|0;k[F>>2]=0;k[A>>2]=16842752;F=A+4|0;k[F>>2]=c;F=B+4|0;c=F+4|0;y=c;k[y>>2]=0;c=c+4|0;k[c>>2]=0;k[B>>2]=33619968;k[F>>2]=a;sU(z,A,B,49332,-1,39936,0,0);r=C;return}e=d*.5;l=u;b=p;f=y;g=1;while(1){F=g;g=g+1|0;h=y+(aa(t,g)|0)|0;i=u+(aa(v,g)|0)|0;F=x+(aa(q,F)|0)|0;E=+o[b>>2];D=+o[j>>2];o[F>>2]=e*((E+ +o[b+4>>2])*(+o[j+4>>2]-D)+(E+ +o[h>>2])*(+o[i>>2]-D)-(E+ +o[f>>2])*(D-+o[l>>2]));D=+o[b+(w<<2)>>2];E=+o[j+(w<<2)>>2];o[F+(w<<2)>>2]=e*((D+ +o[h+(w<<2)>>2])*(+o[i+(w<<2)>>2]-E)-(+o[b+(m<<2)>>2]+D)*(E-+o[j+(m<<2)>>2])-(D+ +o[f+(w<<2)>>2])*(E-+o[l+(w<<2)>>2]));if((g|0)==(s|0))break;else{f=b;l=j;j=i;b=h}}F=z+8|0;k[F>>2]=0;F=z+12|0;k[F>>2]=0;k[z>>2]=16842752;F=z+4|0;k[F>>2]=a;F=A+8|0;k[F>>2]=0;F=A+12|0;k[F>>2]=0;k[A>>2]=16842752;F=A+4|0;k[F>>2]=c;F=B+4|0;c=F+4|0;y=c;k[y>>2]=0;c=c+4|0;k[c>>2]=0;k[B>>2]=33619968;k[F>>2]=a;sU(z,A,B,49332,-1,39936,0,0);r=C;return}function _Wa(a){a=a|0;ggb(a);return}function $Wa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0;d=k[a+4>>2]|0;c=k[a+8>>2]|0;e=k[a+12>>2]|0;f=k[b>>2]|0;s=k[b+4>>2]|0;if((f|0)>=(s|0))return;t=k[c+16>>2]|0;q=k[k[c+44>>2]>>2]|0;r=k[d+16>>2]|0;m=k[k[d+44>>2]>>2]|0;n=k[e+16>>2]|0;p=k[k[e+44>>2]>>2]|0;l=(k[e+12>>2]|0)+-1|0;j=a+16|0;if((l|0)<=1)return;do{a=f+-1|0;c=t+(aa(q,a)|0)|0;d=t+(aa(q,f)|0)|0;i=f;f=f+1|0;e=t+(aa(q,f)|0)|0;a=r+(aa(m,a)|0)|0;g=r+(aa(m,i)|0)|0;h=r+(aa(m,f)|0)|0;i=n+(aa(p,i)|0)|0;b=1;do{w=+o[d+(b<<2)>>2];u=b;b=b+1|0;v=+o[g+(u<<2)>>2];x=u+-1|0;o[i+(u<<2)>>2]=+o[j>>2]*.5*((w+ +o[d+(b<<2)>>2])*(+o[g+(b<<2)>>2]-v)-(w+ +o[d+(x<<2)>>2])*(v-+o[g+(x<<2)>>2])+(w+ +o[e+(u<<2)>>2])*(+o[h+(u<<2)>>2]-v)-(w+ +o[c+(u<<2)>>2])*(v-+o[a+(u<<2)>>2]))}while((b|0)!=(l|0))}while((f|0)!=(s|0));return}function aXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0.0,i=0,j=0,l=0,m=0,n=0,p=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;z=r;r=r+32|0;x=z;if((b|0)<=-1){r=z;return}y=a+4|0;g=k[y>>2]|0;f=k[a>>2]|0;c=f;e=g;if(((g-f|0)/28|0)>>>0<=b>>>0){r=z;return}if(!b){if((e|0)==(c|0)){r=z;return}k[y>>2]=e+(~(((e+-28-f|0)>>>0)/28|0)*28|0);r=z;return}v=c+(b*28|0)|0;a:do if((v|0)!=(e|0)){b:while(1){u=g;t=(v|0)==(u|0);c:while(1){n=f;c=e-f|0;i=(c|0)/28|0;switch(i|0){case 1:case 0:break a;case 2:{w=10;break b}case 3:{w=12;break b}default:{}}if((c|0)<224){w=14;break b}m=i>>>1;i=n+(m*28|0)|0;p=e+-28|0;s=p;c=bXa(n,i,p)|0;q=+o[n+16>>2];h=+o[n+(m*28|0)+16>>2];if(q>h){e=s;break}else m=s;while(1){j=m;l=j+-28|0;m=l;if((n|0)==(l|0))break;if(+o[j+-12>>2]>h){w=40;break c}}i=n+28|0;c=i;if(!(q>+o[e+-12>>2])){if((i|0)==(p|0))break a;while(1){if(q>+o[i+16>>2])break;i=i+28|0;if((i|0)==(p|0))break a;else c=i}n=c;l=k[n>>2]|0;c=i+4|0;m=k[c>>2]|0;j=i+8|0;k[x>>2]=k[j>>2];k[x+4>>2]=k[j+4>>2];k[x+8>>2]=k[j+8>>2];k[x+12>>2]=k[j+12>>2];k[x+16>>2]=k[j+16>>2];k[n>>2]=k[p>>2];n=e+-24|0;k[c>>2]=k[n>>2];c=e+-20|0;k[j>>2]=k[c>>2];k[j+4>>2]=k[c+4>>2];k[j+8>>2]=k[c+8>>2];k[j+12>>2]=k[c+12>>2];k[j+16>>2]=k[c+16>>2];k[p>>2]=l;k[n>>2]=m;k[c>>2]=k[x>>2];k[c+4>>2]=k[x+4>>2];k[c+8>>2]=k[x+8>>2];k[c+12>>2]=k[x+12>>2];k[c+16>>2]=k[x+16>>2];c=i+28|0}if((c|0)==(p|0))break a;l=f+16|0;i=s;f=c;while(1){c=f;h=+o[l>>2];if(!(h>+o[c+16>>2])){e=c;do{s=e;e=e+28|0}while(!(h>+o[s+44>>2]));c=e;f=e}e=i;do{i=e;j=i+-28|0;e=j}while(h>+o[i+-12>>2]);if(c>>>0>=j>>>0)break;p=k[f>>2]|0;m=c+4|0;s=k[m>>2]|0;n=c+8|0;k[x>>2]=k[n>>2];k[x+4>>2]=k[n+4>>2];k[x+8>>2]=k[n+8>>2];k[x+12>>2]=k[n+12>>2];k[x+16>>2]=k[n+16>>2];k[f>>2]=k[j>>2];f=i+-24|0;k[m>>2]=k[f>>2];i=i+-20|0;k[n>>2]=k[i>>2];k[n+4>>2]=k[i+4>>2];k[n+8>>2]=k[i+8>>2];k[n+12>>2]=k[i+12>>2];k[n+16>>2]=k[i+16>>2];k[j>>2]=p;k[f>>2]=s;k[i>>2]=k[x>>2];k[i+4>>2]=k[x+4>>2];k[i+8>>2]=k[x+8>>2];k[i+12>>2]=k[x+12>>2];k[i+16>>2]=k[x+16>>2];i=e;f=c+28|0}if(v>>>0<c>>>0|t)break a;else e=u}if((w|0)==40){w=0;t=f;p=k[t>>2]|0;e=n+4|0;s=k[e>>2]|0;A=n+8|0;k[x>>2]=k[A>>2];k[x+4>>2]=k[A+4>>2];k[x+8>>2]=k[A+8>>2];k[x+12>>2]=k[A+12>>2];k[x+16>>2]=k[A+16>>2];k[t>>2]=k[l>>2];t=j+-24|0;k[e>>2]=k[t>>2];e=j+-20|0;k[A>>2]=k[e>>2];k[A+4>>2]=k[e+4>>2];k[A+8>>2]=k[e+8>>2];k[A+12>>2]=k[e+12>>2];k[A+16>>2]=k[e+16>>2];k[l>>2]=p;k[t>>2]=s;k[e>>2]=k[x>>2];k[e+4>>2]=k[x+4>>2];k[e+8>>2]=k[x+8>>2];k[e+12>>2]=k[x+12>>2];k[e+16>>2]=k[x+16>>2];c=c+1|0;e=m}A=n+28|0;l=A;d:do if(A>>>0<e>>>0)while(1){j=l;p=i;h=+o[p+16>>2];if(+o[j+16>>2]>h){l=j;do{A=l;l=l+28|0}while(+o[A+44>>2]>h);j=l}n=e;do{e=n;m=e+-28|0;n=m}while(!(+o[e+-12>>2]>h));if(j>>>0>=m>>>0)break d;t=k[l>>2]|0;B=j+4|0;A=k[B>>2]|0;s=j+8|0;k[x>>2]=k[s>>2];k[x+4>>2]=k[s+4>>2];k[x+8>>2]=k[s+8>>2];k[x+12>>2]=k[s+12>>2];k[x+16>>2]=k[s+16>>2];k[l>>2]=k[m>>2];l=e+-24|0;k[B>>2]=k[l>>2];e=e+-20|0;k[s>>2]=k[e>>2];k[s+4>>2]=k[e+4>>2];k[s+8>>2]=k[e+8>>2];k[s+12>>2]=k[e+12>>2];k[s+16>>2]=k[e+16>>2];k[m>>2]=t;k[l>>2]=A;k[e>>2]=k[x>>2];k[e+4>>2]=k[x+4>>2];k[e+8>>2]=k[x+8>>2];k[e+12>>2]=k[x+12>>2];k[e+16>>2]=k[x+16>>2];c=c+1|0;e=n;i=(p|0)==(j|0)?n:i;l=j+28|0}while(0);j=l;e=i;if((j|0)!=(e|0)?+o[e+16>>2]>+o[j+16>>2]:0){A=l;p=k[A>>2]|0;B=j+4|0;t=k[B>>2]|0;n=j+8|0;k[x>>2]=k[n>>2];k[x+4>>2]=k[n+4>>2];k[x+8>>2]=k[n+8>>2];k[x+12>>2]=k[n+12>>2];k[x+16>>2]=k[n+16>>2];s=i;k[A>>2]=k[s>>2];A=e+4|0;k[B>>2]=k[A>>2];B=e+8|0;k[n>>2]=k[B>>2];k[n+4>>2]=k[B+4>>2];k[n+8>>2]=k[B+8>>2];k[n+12>>2]=k[B+12>>2];k[n+16>>2]=k[B+16>>2];k[s>>2]=p;k[A>>2]=t;k[B>>2]=k[x>>2];k[B+4>>2]=k[x+4>>2];k[B+8>>2]=k[x+8>>2];k[B+12>>2]=k[x+12>>2];k[B+16>>2]=k[x+16>>2];c=c+1|0}if((v|0)==(j|0))break a;if(!c)if(v>>>0<j>>>0){c=f;do{e=c;c=e+28|0;if((c|0)==(j|0))break a}while(!(+o[e+44>>2]>+o[e+16>>2]))}else{c=l;do{e=c;c=e+28|0;if((c|0)==(u|0))break a}while(!(+o[e+44>>2]>+o[e+16>>2]))}c=v>>>0<j>>>0;g=c?l:g;e=g;if((v|0)==(e|0))break a;else f=c?f:j+28|0}if((w|0)==10){if(!(+o[e+-12>>2]>+o[n+16>>2]))break;v=e+-28|0;A=f;u=k[A>>2]|0;B=n+4|0;w=k[B>>2]|0;t=n+8|0;k[x>>2]=k[t>>2];k[x+4>>2]=k[t+4>>2];k[x+8>>2]=k[t+8>>2];k[x+12>>2]=k[t+12>>2];k[x+16>>2]=k[t+16>>2];k[A>>2]=k[v>>2];A=e+-24|0;k[B>>2]=k[A>>2];B=e+-20|0;k[t>>2]=k[B>>2];k[t+4>>2]=k[B+4>>2];k[t+8>>2]=k[B+8>>2];k[t+12>>2]=k[B+12>>2];k[t+16>>2]=k[B+16>>2];k[v>>2]=u;k[A>>2]=w;k[B>>2]=k[x>>2];k[B+4>>2]=k[x+4>>2];k[B+8>>2]=k[x+8>>2];k[B+12>>2]=k[x+12>>2];k[B+16>>2]=k[x+16>>2];break}else if((w|0)==12){bXa(n,n+28|0,e+-28|0)|0;break}else if((w|0)==14){j=e+-28|0;if((n|0)==(j|0))break;i=n;do{if((i|0)!=(e|0)){c=i+28|0;if((c|0)!=(e|0)){d=i;f=i;g=i;while(1){f=+o[f+44>>2]>+o[g+16>>2];d=f?c:d;g=f?c:g;f=c+28|0;if((f|0)==(e|0)){w=19;break}else{B=c;c=f;f=B}}}}else{d=e;w=19}if((w|0)==19?(w=0,(d|0)!=(i|0)):0){u=k[i>>2]|0;B=i+4|0;v=k[B>>2]|0;t=i+8|0;k[x>>2]=k[t>>2];k[x+4>>2]=k[t+4>>2];k[x+8>>2]=k[t+8>>2];k[x+12>>2]=k[t+12>>2];k[x+16>>2]=k[t+16>>2];k[i>>2]=k[d>>2];A=d+4|0;k[B>>2]=k[A>>2];B=d+8|0;k[t>>2]=k[B>>2];k[t+4>>2]=k[B+4>>2];k[t+8>>2]=k[B+8>>2];k[t+12>>2]=k[B+12>>2];k[t+16>>2]=k[B+16>>2];k[d>>2]=u;k[A>>2]=v;k[B>>2]=k[x>>2];k[B+4>>2]=k[x+4>>2];k[B+8>>2]=k[x+8>>2];k[B+12>>2]=k[x+12>>2];k[B+16>>2]=k[x+16>>2]}i=i+28|0}while((i|0)!=(j|0))}}while(0);d=k[a>>2]|0;h=+o[d+((b+-1|0)*28|0)+16>>2];d=d+(b*28|0)|0;c=k[y>>2]|0;e:do if((d|0)==(c|0))c=d;else while(1){while(1){if(!(+o[d+16>>2]>=h)){e=c;break}d=d+28|0;if((d|0)==(c|0))break e}while(1){c=e+-28|0;if((d|0)==(c|0)){c=d;break e}if(!(+o[e+-12>>2]>=h))e=c;else break}w=k[d>>2]|0;B=d+4|0;b=k[B>>2]|0;v=d+8|0;k[x>>2]=k[v>>2];k[x+4>>2]=k[v+4>>2];k[x+8>>2]=k[v+8>>2];k[x+12>>2]=k[v+12>>2];k[x+16>>2]=k[v+16>>2];k[d>>2]=k[c>>2];A=e+-24|0;k[B>>2]=k[A>>2];B=e+-20|0;k[v>>2]=k[B>>2];k[v+4>>2]=k[B+4>>2];k[v+8>>2]=k[B+8>>2];k[v+12>>2]=k[B+12>>2];k[v+16>>2]=k[B+16>>2];k[c>>2]=w;k[A>>2]=b;k[B>>2]=k[x>>2];k[B+4>>2]=k[x+4>>2];k[B+8>>2]=k[x+8>>2];k[B+12>>2]=k[x+12>>2];k[B+16>>2]=k[x+16>>2];d=d+28|0;if((d|0)==(c|0)){c=d;break}}while(0);e=k[a>>2]|0;c=(c-e|0)/28|0;f=k[y>>2]|0;d=(f-e|0)/28|0;if(c>>>0>d>>>0){p9(a,c-d|0);r=z;return}if(c>>>0>=d>>>0){r=z;return}c=e+(c*28|0)|0;if((f|0)==(c|0)){r=z;return}k[y>>2]=f+(~(((f+-28-c|0)>>>0)/28|0)*28|0);r=z;return}function bXa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0.0,n=0,p=0;l=r;r=r+32|0;i=l;j=b+16|0;m=+o[j>>2];f=a+16|0;h=c+16|0;d=+o[h>>2]>m;if(!(m>+o[f>>2])){if(!d){j=0;r=l;return j|0}p=k[b>>2]|0;e=b+4|0;n=k[e>>2]|0;d=b+8|0;k[i>>2]=k[d>>2];k[i+4>>2]=k[d+4>>2];k[i+8>>2]=k[d+8>>2];k[i+12>>2]=k[d+12>>2];k[i+16>>2]=k[d+16>>2];k[b>>2]=k[c>>2];g=c+4|0;k[e>>2]=k[g>>2];h=c+8|0;k[d>>2]=k[h>>2];k[d+4>>2]=k[h+4>>2];k[d+8>>2]=k[h+8>>2];k[d+12>>2]=k[h+12>>2];k[d+16>>2]=k[h+16>>2];k[c>>2]=p;k[g>>2]=n;k[h>>2]=k[i>>2];k[h+4>>2]=k[i+4>>2];k[h+8>>2]=k[i+8>>2];k[h+12>>2]=k[i+12>>2];k[h+16>>2]=k[i+16>>2];if(!(+o[j>>2]>+o[f>>2])){p=1;r=l;return p|0}n=k[a>>2]|0;c=a+4|0;p=k[c>>2]|0;j=a+8|0;k[i>>2]=k[j>>2];k[i+4>>2]=k[j+4>>2];k[i+8>>2]=k[j+8>>2];k[i+12>>2]=k[j+12>>2];k[i+16>>2]=k[j+16>>2];k[a>>2]=k[b>>2];k[c>>2]=k[e>>2];k[j>>2]=k[d>>2];k[j+4>>2]=k[d+4>>2];k[j+8>>2]=k[d+8>>2];k[j+12>>2]=k[d+12>>2];k[j+16>>2]=k[d+16>>2];k[b>>2]=n;k[e>>2]=p;k[d>>2]=k[i>>2];k[d+4>>2]=k[i+4>>2];k[d+8>>2]=k[i+8>>2];k[d+12>>2]=k[i+12>>2];k[d+16>>2]=k[i+16>>2];p=2;r=l;return p|0}if(d){b=k[a>>2]|0;p=a+4|0;j=k[p>>2]|0;h=a+8|0;k[i>>2]=k[h>>2];k[i+4>>2]=k[h+4>>2];k[i+8>>2]=k[h+8>>2];k[i+12>>2]=k[h+12>>2];k[i+16>>2]=k[h+16>>2];k[a>>2]=k[c>>2];n=c+4|0;k[p>>2]=k[n>>2];p=c+8|0;k[h>>2]=k[p>>2];k[h+4>>2]=k[p+4>>2];k[h+8>>2]=k[p+8>>2];k[h+12>>2]=k[p+12>>2];k[h+16>>2]=k[p+16>>2];k[c>>2]=b;k[n>>2]=j;k[p>>2]=k[i>>2];k[p+4>>2]=k[i+4>>2];k[p+8>>2]=k[i+8>>2];k[p+12>>2]=k[i+12>>2];k[p+16>>2]=k[i+16>>2];p=1;r=l;return p|0}f=k[a>>2]|0;e=a+4|0;g=k[e>>2]|0;p=a+8|0;k[i>>2]=k[p>>2];k[i+4>>2]=k[p+4>>2];k[i+8>>2]=k[p+8>>2];k[i+12>>2]=k[p+12>>2];k[i+16>>2]=k[p+16>>2];k[a>>2]=k[b>>2];d=b+4|0;k[e>>2]=k[d>>2];e=b+8|0;k[p>>2]=k[e>>2];k[p+4>>2]=k[e+4>>2];k[p+8>>2]=k[e+8>>2];k[p+12>>2]=k[e+12>>2];k[p+16>>2]=k[e+16>>2];k[b>>2]=f;k[d>>2]=g;k[e>>2]=k[i>>2];k[e+4>>2]=k[i+4>>2];k[e+8>>2]=k[i+8>>2];k[e+12>>2]=k[i+12>>2];k[e+16>>2]=k[i+16>>2];if(!(+o[h>>2]>+o[j>>2])){p=1;r=l;return p|0};k[i>>2]=k[e>>2];k[i+4>>2]=k[e+4>>2];k[i+8>>2]=k[e+8>>2];k[i+12>>2]=k[e+12>>2];k[i+16>>2]=k[e+16>>2];k[b>>2]=k[c>>2];n=c+4|0;k[d>>2]=k[n>>2];p=c+8|0;k[e>>2]=k[p>>2];k[e+4>>2]=k[p+4>>2];k[e+8>>2]=k[p+8>>2];k[e+12>>2]=k[p+12>>2];k[e+16>>2]=k[p+16>>2];k[c>>2]=f;k[n>>2]=g;k[p>>2]=k[i>>2];k[p+4>>2]=k[i+4>>2];k[p+8>>2]=k[i+8>>2];k[p+12>>2]=k[i+12>>2];k[p+16>>2]=k[i+16>>2];p=2;r=l;return p|0}function cXa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,h=0.0,i=0,j=0,l=0,m=0,n=0,p=0;if((d|0)<=0)return;n=d<<1;e=k[a>>2]|0;p=a+4|0;a=k[p>>2]|0;if(!((n|0)<(c|0)&(n|0)<(b|0))){if((a|0)==(e|0))return;k[p>>2]=a+(~(((a+-28-e|0)>>>0)/28|0)*28|0);return}n=b-d|0;j=c-d|0;l=(n|0)<(d|0)?n:d;m=(j|0)<(d|0)?j:d;n=(n|0)>(d|0)?n:d;j=(j|0)>(d|0)?j:d;if((e|0)==(a|0))return;while(1){f=+o[e>>2];b=(o[u>>2]=f,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;f=b?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=b?-0.0:0.0}c=~~f;f=+o[e+4>>2];b=(o[u>>2]=f,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;f=b?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=b?-0.0:0.0}d=~~f;if(!((d|0)<(j|0)&(((c|0)>=(n|0)|(l|0)>(c|0)|(m|0)>(d|0))^1)))break;e=e+28|0;if((e|0)==(a|0)){i=28;break}}if((i|0)==28)return;if((e|0)==(a|0))return;b=e+28|0;if((b|0)!=(a|0)){i=e;while(1){h=+o[b>>2];c=(o[u>>2]=h,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;f=c?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(f==0.0)f=c?-0.0:0.0}else f=h;d=~~f;g=+o[i+32>>2];c=(o[u>>2]=g,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;f=c?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(f==0.0)f=c?-0.0:0.0}else f=g;c=~~f;if((c|0)<(j|0)&(((d|0)>=(n|0)|(l|0)>(d|0)|(m|0)>(c|0))^1)){o[e>>2]=h;o[e+4>>2]=g;d=e+8|0;i=i+36|0;k[d>>2]=k[i>>2];k[d+4>>2]=k[i+4>>2];k[d+8>>2]=k[i+8>>2];k[d+12>>2]=k[i+12>>2];k[d+16>>2]=k[i+16>>2];e=e+28|0}c=b+28|0;if((c|0)==(a|0))break;else{i=b;b=c}}a=k[p>>2]|0}if((e|0)==(a|0))return;k[p>>2]=a+(~(((a+-28-e|0)>>>0)/28|0)*28|0);return}function dXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+64|0;m=z;y=k[b+16>>2]|0;h=y;if(!y){r=z;return}j=b+4|0;l=k[j>>2]|0;if((l|0)<3)c=aa(k[b+12>>2]|0,k[b+8>>2]|0)|0;else{e=k[b+40>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(l|0))}if(!c){r=z;return}d=k[a>>2]|0;q=a+4|0;p=k[q>>2]|0;k[m>>2]=k[b>>2];x=m+4|0;k[x>>2]=l;y=m+8|0;k[y>>2]=k[b+8>>2];k[m+12>>2]=k[b+12>>2];v=m+16|0;k[v>>2]=h;k[m+20>>2]=k[b+20>>2];k[m+24>>2]=k[b+24>>2];k[m+28>>2]=k[b+28>>2];s=m+32|0;k[s>>2]=k[b+32>>2];t=m+36|0;c=k[b+36>>2]|0;k[t>>2]=c;u=m+40|0;k[u>>2]=y;y=m+48|0;w=m+44|0;k[w>>2]=y;k[m+52>>2]=0;k[y>>2]=0;if(!c)c=l;else{c=c+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[j>>2]|0}if((c|0)>=3){k[x>>2]=0;x1(m,c,0,0,0);if((k[x>>2]|0)>0){h=k[b+40>>2]|0;j=k[u>>2]|0;e=k[b+44>>2]|0;a=k[w>>2]|0;c=0;do{k[j+(c<<2)>>2]=k[h+(c<<2)>>2];k[a+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[x>>2]|0))}}else{m=k[b+44>>2]|0;b=k[w>>2]|0;k[b>>2]=k[m>>2];k[b+4>>2]=k[m+4>>2]}a:do if((d|0)==(p|0))n=18;else{c=k[v>>2]|0;e=k[k[w>>2]>>2]|0;while(1){b=c+(aa(~~(+o[d+4>>2]+.5),e)|0)+~~(+o[d>>2]+.5)|0;if(!(i[b>>0]|0)){n=18;break a}d=d+28|0;if((d|0)==(p|0)){d=p;break}}}while(0);if((n|0)==18)if((d|0)!=(p|0)){c=d+28|0;if((c|0)!=(p|0)){e=d;while(1){f=+o[e+32>>2];g=+o[c>>2];n=(k[v>>2]|0)+(aa(k[k[w>>2]>>2]|0,~~(f+.5))|0)+~~(g+.5)|0;if(i[n>>0]|0){o[d>>2]=g;o[d+4>>2]=f;n=d+8|0;b=e+36|0;k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];k[n+8>>2]=k[b+8>>2];k[n+12>>2]=k[b+12>>2];k[n+16>>2]=k[b+16>>2];d=d+28|0}e=c+28|0;if((e|0)==(p|0))break;else{n=c;c=e;e=n}}}}else d=p;c=k[q>>2]|0;if((d|0)!=(c|0))k[q>>2]=c+(~(((c+-28-d|0)>>>0)/28|0)*28|0);c=k[t>>2]|0;if(c|0?(p=c+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){d=k[t>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[s>>2]|0;if(!c){c=B1()|0;d=k[t>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[t>>2]=0}k[t>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[x>>2]|0)>0){d=k[u>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[x>>2]|0))}c=k[w>>2]|0;if((c|0)==(y|0)|(c|0)==0){r=z;return}ggb(k[c+-4>>2]|0);r=z;return}function eXa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=142752;b=k[a+60>>2]|0;c=b;if(b|0){d=a+64|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+40|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+20|0;c=a+8|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function fXa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=142752;b=k[a+60>>2]|0;c=b;if(b|0){d=a+64|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+40|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+20|0;c=a+8|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function gXa(a){a=a|0;var b=0,c=0,d=0;b=k[a+60>>2]|0;c=a+64|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+20|0;d=a+8|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)<=0)return;c=k[a+44>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0));return}function hXa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=142772;f=a+16|0;g=k[f>>2]|0;if(!g){i=a+4|0;zF(i);return}h=a+20|0;while(1){i=k[h>>2]|0;if((i|0)==(g|0))break;k[h>>2]=i+-48;e=i+-24|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=i+-44|0;if((k[c>>2]|0)>0){d=k[i+-16>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[i+-12>>2]|0;if((b|0)==(i+-8|0)|(b|0)==0)continue;ggb(k[b+-4>>2]|0)}ggb(k[f>>2]|0);i=a+4|0;zF(i);return}function iXa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=142772;f=a+16|0;g=k[f>>2]|0;if(!g){i=a+4|0;zF(i);ggb(a);return}h=a+20|0;while(1){i=k[h>>2]|0;if((i|0)==(g|0))break;k[h>>2]=i+-48;e=i+-24|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=i+-44|0;if((k[c>>2]|0)>0){d=k[i+-16>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[i+-12>>2]|0;if((b|0)==(i+-8|0)|(b|0)==0)continue;ggb(k[b+-4>>2]|0)}ggb(k[f>>2]|0);i=a+4|0;zF(i);ggb(a);return}function jXa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;f=k[a+16>>2]|0;g=a+20|0;while(1){h=k[g>>2]|0;if((h|0)==(f|0))break;k[g>>2]=h+-48;e=h+-24|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=h+-44|0;if((k[c>>2]|0)>0){d=k[h+-16>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[h+-12>>2]|0;if((b|0)==(h+-8|0)|(b|0)==0)continue;ggb(k[b+-4>>2]|0)}g=k[a+4>>2]|0;f=a+8|0;b=k[f>>2]|0;if((b|0)==(g|0))return;do{k[f>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(h=c+12|0,a=k[h>>2]|0,k[h>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;a=b+-40|0;d=b+-52|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[f>>2]|0}while((b|0)!=(g|0));return}function kXa(a,b){a=a|0;b=b|0;return}function lXa(a,b){a=a|0;b=b|0;return}function mXa(a){a=a|0;if((k[a+4>>2]|0)!=(k[a+8>>2]|0)){a=0;return a|0}a=(k[a+16>>2]|0)==(k[a+20>>2]|0);return a|0}function nXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+80|0;m=n+56|0;l=n;c=k[b>>2]&2031616;a:do if((c|0)<655360){if((c|0)>=327680){switch(c|0){case 327680:break;default:break a}k[m>>2]=0;l=m+4|0;k[l>>2]=0;k[m+8>>2]=0;B2(b,m);qXa(a+4|0,k[a+8>>2]|0,k[m>>2]|0,k[l>>2]|0);zF(m);r=n;return}switch(c|0){case 65536:break;default:break a}e=k[b+4>>2]|0;k[l>>2]=k[e>>2];j=l+4|0;c=e+4|0;k[j>>2]=k[c>>2];h=l+8|0;k[h>>2]=k[e+8>>2];k[l+12>>2]=k[e+12>>2];k[l+16>>2]=k[e+16>>2];k[l+20>>2]=k[e+20>>2];k[l+24>>2]=k[e+24>>2];k[l+28>>2]=k[e+28>>2];k[l+32>>2]=k[e+32>>2];b=k[e+36>>2]|0;k[l+36>>2]=b;d=l+40|0;k[d>>2]=h;h=l+48|0;g=l+44|0;k[g>>2]=h;k[l+52>>2]=0;k[h>>2]=0;if(b|0){h=b+12|0;k[h>>2]=(k[h>>2]|0)+1}if((k[c>>2]|0)>=3){k[j>>2]=0;x1(l,k[c>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;b=k[g>>2]|0;c=0;do{k[f+(c<<2)>>2]=k[h+(c<<2)>>2];k[b+(c<<2)>>2]=k[d+(c<<2)>>2];c=c+1|0}while((c|0)<(k[j>>2]|0))}}else{h=k[e+44>>2]|0;j=k[g>>2]|0;k[j>>2]=k[h>>2];k[j+4>>2]=k[h+4>>2]}lwa(m,1,l);d=l+36|0;c=k[d>>2]|0;if(c|0?(h=c+12|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[l+32>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;j=l+16|0;b=l+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[b>>2]|0)>0){d=k[l+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}c=k[l+44>>2]|0;if(!((c|0)==(l+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);qXa(a+4|0,k[a+8>>2]|0,k[m>>2]|0,k[m+4>>2]|0);zF(m);r=n;return}else{if((c|0)>=720896){switch(c|0){case 720896:break;default:break a}k[m>>2]=0;h=m+4|0;k[h>>2]=0;k[m+8>>2]=0;C2(b,m);g=k[m>>2]|0;c=k[h>>2]|0;pXa(a+16|0,k[a+20>>2]|0,g,c);if(g|0){while(1){if((c|0)==(g|0))break;k[h>>2]=c+-48;f=c+-24|0;b=k[f>>2]|0;if(b|0?(l=b+8|0,a=k[l>>2]|0,k[l>>2]=a+-1,(a|0)==1):0){a=k[f>>2]|0;l=k[a+4>>2]|0;jh[k[(k[l>>2]|0)+16>>2]&1023](l,a);k[f>>2]=0}d=c+-44|0;if((k[d>>2]|0)>0){e=k[c+-16>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}k[f>>2]=0;b=k[c+-12>>2]|0;if(!((b|0)==(c+-8|0)|(b|0)==0))ggb(k[b+-4>>2]|0);c=k[h>>2]|0}ggb(k[m>>2]|0)}r=n;return}switch(c|0){case 655360:break;default:break a}A2(l,b);RV(m,l);e=l+24|0;c=k[e>>2]|0;if(c|0?(h=c+8|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){j=k[e>>2]|0;h=k[j+4>>2]|0;jh[k[(k[h>>2]|0)+16>>2]&1023](h,j);k[e>>2]=0}b=l+4|0;if((k[b>>2]|0)>0){d=k[l+32>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}k[e>>2]=0;c=k[l+36>>2]|0;if(!((c|0)==(l+40|0)|(c|0)==0))ggb(k[c+-4>>2]|0);g=k[m>>2]|0;h=m+4|0;c=k[h>>2]|0;pXa(a+16|0,k[a+20>>2]|0,g,c);if(g|0){f=c;while(1){if((f|0)==(g|0))break;k[h>>2]=f+-48;e=f+-24|0;c=k[e>>2]|0;if(c|0?(l=c+8|0,a=k[l>>2]|0,k[l>>2]=a+-1,(a|0)==1):0){a=k[e>>2]|0;l=k[a+4>>2]|0;jh[k[(k[l>>2]|0)+16>>2]&1023](l,a);k[e>>2]=0}b=f+-44|0;if((k[b>>2]|0)>0){d=k[f+-16>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}k[e>>2]=0;c=k[f+-12>>2]|0;if(!((c|0)==(f+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);f=k[h>>2]|0}ggb(k[m>>2]|0)}r=n;return}while(0);c=m+4|0;b=ZT(112)|0;k[b>>2]=1;d=b+4|0;k[m>>2]=d;k[c>>2]=106;i[b+110>>0]=0;e=388380;f=d+106|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,m,388487,388491,543);k[c>>2]=0;k[m>>2]=0;m=k[b>>2]|0;k[b>>2]=m+-1;if((m|0)==1)ggb(k[b+-4>>2]|0);r=n;return}function oXa(a){a=a|0;return}function pXa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=d;h=k[a>>2]|0;j=c;u=g-j|0;p=(u|0)/48|0;if((u|0)<=0)return;t=a+8|0;f=k[t>>2]|0;u=a+4|0;r=k[u>>2]|0;e=r;if((p|0)<=((f-e|0)/48|0|0)){o=e-b|0;e=(o|0)/48|0;if((p|0)>(e|0)){e=c+(e*48|0)|0;q=e;if((e|0)==(d|0))e=r;else{n=q;j=e;e=r;while(1){k[e>>2]=k[j>>2];m=e+4|0;f=j+4|0;k[m>>2]=k[f>>2];t=e+8|0;k[t>>2]=k[j+8>>2];k[e+12>>2]=k[j+12>>2];k[e+16>>2]=k[j+16>>2];k[e+20>>2]=k[j+20>>2];g=k[j+24>>2]|0;k[e+24>>2]=g;k[e+28>>2]=k[j+28>>2];h=e+32|0;k[h>>2]=t;t=e+40|0;l=e+36|0;k[l>>2]=t;k[e+44>>2]=0;k[t>>2]=0;if(g|0){t=g+8|0;k[t>>2]=(k[t>>2]|0)+1}if((k[f>>2]|0)>=3){k[m>>2]=0;s9(e,k[f>>2]|0,0,0,0);if((k[m>>2]|0)>0){i=k[j+32>>2]|0;h=k[h>>2]|0;g=k[j+36>>2]|0;f=k[l>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[i+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else{a=k[j+36>>2]|0;t=k[l>>2]|0;k[t>>2]=k[a>>2];k[t+4>>2]=k[a+4>>2]}f=n+48|0;e=(k[u>>2]|0)+48|0;k[u>>2]=e;if((f|0)==(d|0))break;else{n=f;j=f}}}if((o|0)<=0)return}else{q=g;e=r}p=e-(b+(p*48|0))|0;f=b+(((p|0)/48|0)*48|0)|0;if(f>>>0<r>>>0){n=f;g=e;do{k[g>>2]=k[n>>2];o=g+4|0;h=n+4|0;k[o>>2]=k[h>>2];t=g+8|0;k[t>>2]=k[n+8>>2];k[g+12>>2]=k[n+12>>2];k[g+16>>2]=k[n+16>>2];k[g+20>>2]=k[n+20>>2];i=k[n+24>>2]|0;k[g+24>>2]=i;k[g+28>>2]=k[n+28>>2];j=g+32|0;k[j>>2]=t;t=g+40|0;m=g+36|0;k[m>>2]=t;k[g+44>>2]=0;k[t>>2]=0;if(i|0){t=i+8|0;k[t>>2]=(k[t>>2]|0)+1}if((k[h>>2]|0)>=3){k[o>>2]=0;s9(g,k[h>>2]|0,0,0,0);if((k[o>>2]|0)>0){l=k[n+32>>2]|0;i=k[j>>2]|0;j=k[n+36>>2]|0;h=k[m>>2]|0;g=0;do{k[i+(g<<2)>>2]=k[l+(g<<2)>>2];k[h+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[o>>2]|0))}}else{a=k[n+36>>2]|0;t=k[m>>2]|0;k[t>>2]=k[a>>2];k[t+4>>2]=k[a+4>>2]}n=n+48|0;g=(k[u>>2]|0)+48|0;k[u>>2]=g}while(n>>>0<r>>>0)}if(p|0)do{e=e+-48|0;f=f+-48|0;D2(e,f)}while((f|0)!=(b|0));e=q;if((e|0)==(c|0))return;while(1){D2(b,c);c=c+48|0;if((c|0)==(e|0))break;else b=b+48|0}return}e=((e-h|0)/48|0)+p|0;if(e>>>0>89478485)ad(426534,426557,304,426811);g=(f-h|0)/48|0;i=g<<1;i=g>>>0<44739242?(i>>>0<e>>>0?e:i):89478485;g=(b-h|0)/48|0;if(!i)e=0;else{if(i>>>0>89478485){u=te(4)|0;k[u>>2]=172664;Cf(u|0,28816,1287)}f=i*48|0;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}}g=e+(g*48|0)|0;r=g;s=e+(i*48|0)|0;if((d|0)==(c|0))f=r;else{o=j;f=r;e=g;while(1){k[e>>2]=k[c>>2];n=e+4|0;h=c+4|0;k[n>>2]=k[h>>2];q=e+8|0;k[q>>2]=k[c+8>>2];k[e+12>>2]=k[c+12>>2];k[e+16>>2]=k[c+16>>2];k[e+20>>2]=k[c+20>>2];i=k[c+24>>2]|0;k[e+24>>2]=i;k[e+28>>2]=k[c+28>>2];j=e+32|0;k[j>>2]=q;q=e+40|0;m=e+36|0;k[m>>2]=q;k[e+44>>2]=0;k[q>>2]=0;if(i|0){q=i+8|0;k[q>>2]=(k[q>>2]|0)+1}if((k[h>>2]|0)>=3){k[n>>2]=0;s9(e,k[h>>2]|0,0,0,0);if((k[n>>2]|0)>0){l=k[c+32>>2]|0;i=k[j>>2]|0;h=k[c+36>>2]|0;e=k[m>>2]|0;c=0;do{k[i+(c<<2)>>2]=k[l+(c<<2)>>2];k[e+(c<<2)>>2]=k[h+(c<<2)>>2];c=c+1|0}while((c|0)<(k[n>>2]|0))}}else{p=k[c+36>>2]|0;q=k[m>>2]|0;k[q>>2]=k[p>>2];k[q+4>>2]=k[p+4>>2]}e=f+48|0;f=e;c=o+48|0;if((c|0)==(d|0))break;else o=c}}q=k[a>>2]|0;if((q|0)==(b|0))e=r;else{p=b;e=r;c=g;do{g=c+-48|0;m=p;p=p+-48|0;k[g>>2]=k[p>>2];o=c+-44|0;h=m+-44|0;k[o>>2]=k[h>>2];d=c+-40|0;k[d>>2]=k[m+-40>>2];k[c+-36>>2]=k[m+-36>>2];k[c+-32>>2]=k[m+-32>>2];k[c+-28>>2]=k[m+-28>>2];i=k[m+-24>>2]|0;k[c+-24>>2]=i;k[c+-20>>2]=k[m+-20>>2];j=c+-16|0;k[j>>2]=d;d=c+-8|0;n=c+-12|0;k[n>>2]=d;k[c+-4>>2]=0;k[d>>2]=0;if(i|0){d=i+8|0;k[d>>2]=(k[d>>2]|0)+1}if((k[h>>2]|0)>=3){k[o>>2]=0;s9(g,k[h>>2]|0,0,0,0);if((k[o>>2]|0)>0){l=k[m+-16>>2]|0;i=k[j>>2]|0;h=k[m+-12>>2]|0;g=k[n>>2]|0;c=0;do{k[i+(c<<2)>>2]=k[l+(c<<2)>>2];k[g+(c<<2)>>2]=k[h+(c<<2)>>2];c=c+1|0}while((c|0)<(k[o>>2]|0))}}else{r=k[m+-12>>2]|0;d=k[n>>2]|0;k[d>>2]=k[r>>2];k[d+4>>2]=k[r+4>>2]}c=e+-48|0;e=c}while((p|0)!=(q|0));g=c}c=k[u>>2]|0;if((c|0)==(b|0)){h=u;b=g}else{n=f;do{k[f>>2]=k[b>>2];m=f+4|0;g=b+4|0;k[m>>2]=k[g>>2];d=f+8|0;k[d>>2]=k[b+8>>2];k[f+12>>2]=k[b+12>>2];k[f+16>>2]=k[b+16>>2];k[f+20>>2]=k[b+20>>2];h=k[b+24>>2]|0;k[f+24>>2]=h;k[f+28>>2]=k[b+28>>2];i=f+32|0;k[i>>2]=d;d=f+40|0;l=f+36|0;k[l>>2]=d;k[f+44>>2]=0;k[d>>2]=0;if(h|0){d=h+8|0;k[d>>2]=(k[d>>2]|0)+1}if((k[g>>2]|0)>=3){k[m>>2]=0;s9(f,k[g>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[b+32>>2]|0;h=k[i>>2]|0;i=k[b+36>>2]|0;g=k[l>>2]|0;f=0;do{k[h+(f<<2)>>2]=k[j+(f<<2)>>2];k[g+(f<<2)>>2]=k[i+(f<<2)>>2];f=f+1|0}while((f|0)<(k[m>>2]|0))}}else{r=k[b+36>>2]|0;d=k[l>>2]|0;k[d>>2]=k[r>>2];k[d+4>>2]=k[r+4>>2]}b=b+48|0;f=n+48|0;n=f}while((b|0)!=(c|0));h=u;f=n;b=e;c=k[u>>2]|0}i=k[a>>2]|0;k[a>>2]=b;k[h>>2]=f;k[t>>2]=s;while(1){if((c|0)==(i|0))break;h=c+-48|0;g=c+-24|0;b=k[g>>2]|0;if(b|0?(t=b+8|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){u=k[g>>2]|0;t=k[u+4>>2]|0;jh[k[(k[t>>2]|0)+16>>2]&1023](t,u);k[g>>2]=0}e=c+-44|0;if((k[e>>2]|0)>0){f=k[c+-16>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}k[g>>2]=0;b=k[c+-12>>2]|0;if((b|0)==(c+-8|0)|(b|0)==0){c=h;continue}ggb(k[b+-4>>2]|0);c=h}if(!i)return;ggb(i);return}function qXa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=d;h=k[a>>2]|0;j=c;u=g-j|0;p=(u|0)/56|0;if((u|0)<=0)return;t=a+8|0;f=k[t>>2]|0;u=a+4|0;r=k[u>>2]|0;e=r;if((p|0)<=((f-e|0)/56|0|0)){o=e-b|0;e=(o|0)/56|0;if((p|0)>(e|0)){e=c+(e*56|0)|0;q=e;if((e|0)==(d|0))e=r;else{n=q;j=e;e=r;while(1){k[e>>2]=k[j>>2];m=e+4|0;f=j+4|0;k[m>>2]=k[f>>2];t=e+8|0;k[t>>2]=k[j+8>>2];k[e+12>>2]=k[j+12>>2];k[e+16>>2]=k[j+16>>2];k[e+20>>2]=k[j+20>>2];k[e+24>>2]=k[j+24>>2];k[e+28>>2]=k[j+28>>2];k[e+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[e+36>>2]=g;h=e+40|0;k[h>>2]=t;t=e+48|0;l=e+44|0;k[l>>2]=t;k[e+52>>2]=0;k[t>>2]=0;if(g|0){t=g+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[f>>2]|0)>=3){k[m>>2]=0;x1(e,k[f>>2]|0,0,0,0);if((k[m>>2]|0)>0){i=k[j+40>>2]|0;h=k[h>>2]|0;g=k[j+44>>2]|0;f=k[l>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[i+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else{a=k[j+44>>2]|0;t=k[l>>2]|0;k[t>>2]=k[a>>2];k[t+4>>2]=k[a+4>>2]}f=n+56|0;e=(k[u>>2]|0)+56|0;k[u>>2]=e;if((f|0)==(d|0))break;else{n=f;j=f}}}if((o|0)<=0)return}else{q=g;e=r}p=e-(b+(p*56|0))|0;f=b+(((p|0)/56|0)*56|0)|0;if(f>>>0<r>>>0){n=f;g=e;do{k[g>>2]=k[n>>2];o=g+4|0;h=n+4|0;k[o>>2]=k[h>>2];t=g+8|0;k[t>>2]=k[n+8>>2];k[g+12>>2]=k[n+12>>2];k[g+16>>2]=k[n+16>>2];k[g+20>>2]=k[n+20>>2];k[g+24>>2]=k[n+24>>2];k[g+28>>2]=k[n+28>>2];k[g+32>>2]=k[n+32>>2];i=k[n+36>>2]|0;k[g+36>>2]=i;j=g+40|0;k[j>>2]=t;t=g+48|0;m=g+44|0;k[m>>2]=t;k[g+52>>2]=0;k[t>>2]=0;if(i|0){t=i+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[h>>2]|0)>=3){k[o>>2]=0;x1(g,k[h>>2]|0,0,0,0);if((k[o>>2]|0)>0){l=k[n+40>>2]|0;i=k[j>>2]|0;j=k[n+44>>2]|0;h=k[m>>2]|0;g=0;do{k[i+(g<<2)>>2]=k[l+(g<<2)>>2];k[h+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[o>>2]|0))}}else{a=k[n+44>>2]|0;t=k[m>>2]|0;k[t>>2]=k[a>>2];k[t+4>>2]=k[a+4>>2]}n=n+56|0;g=(k[u>>2]|0)+56|0;k[u>>2]=g}while(n>>>0<r>>>0)}if(p|0)do{e=e+-56|0;f=f+-56|0;KG(e,f)|0}while((f|0)!=(b|0));e=q;if((e|0)==(c|0))return;while(1){KG(b,c)|0;c=c+56|0;if((c|0)==(e|0))break;else b=b+56|0}return}e=((e-h|0)/56|0)+p|0;if(e>>>0>76695844)ad(426534,426557,304,426811);g=(f-h|0)/56|0;i=g<<1;i=g>>>0<38347922?(i>>>0<e>>>0?e:i):76695844;g=(b-h|0)/56|0;if(!i)e=0;else{if(i>>>0>76695844){u=te(4)|0;k[u>>2]=172664;Cf(u|0,28816,1287)}f=i*56|0;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}}g=e+(g*56|0)|0;r=g;s=e+(i*56|0)|0;if((d|0)==(c|0))f=r;else{o=j;f=r;e=g;while(1){k[e>>2]=k[c>>2];n=e+4|0;h=c+4|0;k[n>>2]=k[h>>2];q=e+8|0;k[q>>2]=k[c+8>>2];k[e+12>>2]=k[c+12>>2];k[e+16>>2]=k[c+16>>2];k[e+20>>2]=k[c+20>>2];k[e+24>>2]=k[c+24>>2];k[e+28>>2]=k[c+28>>2];k[e+32>>2]=k[c+32>>2];i=k[c+36>>2]|0;k[e+36>>2]=i;j=e+40|0;k[j>>2]=q;q=e+48|0;m=e+44|0;k[m>>2]=q;k[e+52>>2]=0;k[q>>2]=0;if(i|0){q=i+12|0;k[q>>2]=(k[q>>2]|0)+1}if((k[h>>2]|0)>=3){k[n>>2]=0;x1(e,k[h>>2]|0,0,0,0);if((k[n>>2]|0)>0){l=k[c+40>>2]|0;i=k[j>>2]|0;h=k[c+44>>2]|0;e=k[m>>2]|0;c=0;do{k[i+(c<<2)>>2]=k[l+(c<<2)>>2];k[e+(c<<2)>>2]=k[h+(c<<2)>>2];c=c+1|0}while((c|0)<(k[n>>2]|0))}}else{p=k[c+44>>2]|0;q=k[m>>2]|0;k[q>>2]=k[p>>2];k[q+4>>2]=k[p+4>>2]}e=f+56|0;f=e;c=o+56|0;if((c|0)==(d|0))break;else o=c}}q=k[a>>2]|0;if((q|0)==(b|0))e=r;else{p=b;e=r;c=g;do{g=c+-56|0;m=p;p=p+-56|0;k[g>>2]=k[p>>2];o=c+-52|0;h=m+-52|0;k[o>>2]=k[h>>2];d=c+-48|0;k[d>>2]=k[m+-48>>2];k[c+-44>>2]=k[m+-44>>2];k[c+-40>>2]=k[m+-40>>2];k[c+-36>>2]=k[m+-36>>2];k[c+-32>>2]=k[m+-32>>2];k[c+-28>>2]=k[m+-28>>2];k[c+-24>>2]=k[m+-24>>2];i=k[m+-20>>2]|0;k[c+-20>>2]=i;j=c+-16|0;k[j>>2]=d;d=c+-8|0;n=c+-12|0;k[n>>2]=d;k[c+-4>>2]=0;k[d>>2]=0;if(i|0){d=i+12|0;k[d>>2]=(k[d>>2]|0)+1}if((k[h>>2]|0)>=3){k[o>>2]=0;x1(g,k[h>>2]|0,0,0,0);if((k[o>>2]|0)>0){l=k[m+-16>>2]|0;i=k[j>>2]|0;h=k[m+-12>>2]|0;g=k[n>>2]|0;c=0;do{k[i+(c<<2)>>2]=k[l+(c<<2)>>2];k[g+(c<<2)>>2]=k[h+(c<<2)>>2];c=c+1|0}while((c|0)<(k[o>>2]|0))}}else{r=k[m+-12>>2]|0;d=k[n>>2]|0;k[d>>2]=k[r>>2];k[d+4>>2]=k[r+4>>2]}c=e+-56|0;e=c}while((p|0)!=(q|0));g=c}c=k[u>>2]|0;if((c|0)==(b|0)){h=u;b=g}else{n=f;do{k[f>>2]=k[b>>2];m=f+4|0;g=b+4|0;k[m>>2]=k[g>>2];d=f+8|0;k[d>>2]=k[b+8>>2];k[f+12>>2]=k[b+12>>2];k[f+16>>2]=k[b+16>>2];k[f+20>>2]=k[b+20>>2];k[f+24>>2]=k[b+24>>2];k[f+28>>2]=k[b+28>>2];k[f+32>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[f+36>>2]=h;i=f+40|0;k[i>>2]=d;d=f+48|0;l=f+44|0;k[l>>2]=d;k[f+52>>2]=0;k[d>>2]=0;if(h|0){d=h+12|0;k[d>>2]=(k[d>>2]|0)+1}if((k[g>>2]|0)>=3){k[m>>2]=0;x1(f,k[g>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[b+40>>2]|0;h=k[i>>2]|0;i=k[b+44>>2]|0;g=k[l>>2]|0;f=0;do{k[h+(f<<2)>>2]=k[j+(f<<2)>>2];k[g+(f<<2)>>2]=k[i+(f<<2)>>2];f=f+1|0}while((f|0)<(k[m>>2]|0))}}else{r=k[b+44>>2]|0;d=k[l>>2]|0;k[d>>2]=k[r>>2];k[d+4>>2]=k[r+4>>2]}b=b+56|0;f=n+56|0;n=f}while((b|0)!=(c|0));h=u;f=n;b=e;c=k[u>>2]|0}i=k[a>>2]|0;k[a>>2]=b;k[h>>2]=f;k[t>>2]=s;h=i;while(1){if((h|0)==(c|0))break;g=c+-56|0;f=c+-20|0;b=k[f>>2]|0;if(b|0?(t=b+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[c+-24>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;b=c+-40|0;e=c+-52|0;f=c+-16|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=0;while(1){if((b|0)>=(k[e>>2]|0))break;k[(k[f>>2]|0)+(b<<2)>>2]=0;b=b+1|0}b=k[c+-12>>2]|0;if((b|0)==(c+-8|0)|(b|0)==0){c=g;continue}ggb(k[b+-4>>2]|0);c=g}if(!i)return;ggb(i);return}function rXa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=142772;f=a+16|0;g=k[f>>2]|0;if(!g){i=a+4|0;zF(i);ggb(a);return}h=a+20|0;while(1){i=k[h>>2]|0;if((i|0)==(g|0))break;k[h>>2]=i+-48;e=i+-24|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=i+-44|0;if((k[c>>2]|0)>0){d=k[i+-16>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[i+-12>>2]|0;if((b|0)==(i+-8|0)|(b|0)==0)continue;ggb(k[b+-4>>2]|0)}ggb(k[f>>2]|0);i=a+4|0;zF(i);ggb(a);return}function sXa(a){a=a|0;return 1}function tXa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;R=r;r=r+128|0;N=R+112|0;P=R+56|0;Q=R;e=b+28|0;f=b+32|0;while(1){d=fgb(36)|0;if(d|0){g=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){g=0;break}Qh[d&7]()}L=k[e>>2]|0;M=i[f>>0]|0;e=g+4|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;k[e+16>>2]=0;k[e+20>>2]=0;k[g>>2]=142836;k[g+28>>2]=L;i[g+32>>0]=M;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}L=d+4|0;k[L>>2]=1;k[d>>2]=142900;k[d+8>>2]=g;M=d;if(!c?(h=b+4|0,O=b+8|0,Y1(e,((k[O>>2]|0)-(k[h>>2]|0)|0)/56|0),h=k[h>>2]|0,O=k[O>>2]|0,(h|0)!=(O|0)):0){m=Q+4|0;n=Q+8|0;o=Q+12|0;p=Q+16|0;q=Q+20|0;s=Q+24|0;t=Q+28|0;u=Q+32|0;v=Q+36|0;w=Q+40|0;x=Q+48|0;y=Q+44|0;z=Q+52|0;A=P+36|0;B=P+16|0;C=P+4|0;D=P+40|0;E=P+44|0;F=P+48|0;G=P+8|0;H=P+52|0;I=N+4|0;J=I+4|0;K=P+32|0;l=h;j=k[e>>2]|0;while(1){k[Q>>2]=k[l>>2];e=l+4|0;k[m>>2]=k[e>>2];k[n>>2]=k[l+8>>2];k[o>>2]=k[l+12>>2];k[p>>2]=k[l+16>>2];k[q>>2]=k[l+20>>2];k[s>>2]=k[l+24>>2];k[t>>2]=k[l+28>>2];k[u>>2]=k[l+32>>2];f=k[l+36>>2]|0;k[v>>2]=f;k[w>>2]=n;k[y>>2]=x;k[z>>2]=0;k[x>>2]=0;if(f|0){h=f+12|0;k[h>>2]=(k[h>>2]|0)+1}if((k[e>>2]|0)>=3){k[m>>2]=0;x1(Q,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){c=k[l+40>>2]|0;h=k[w>>2]|0;f=k[l+44>>2]|0;b=k[y>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[c+(e<<2)>>2];k[b+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else{c=k[l+44>>2]|0;h=k[y>>2]|0;k[h>>2]=k[c>>2];k[h+4>>2]=k[c+4>>2]}k[P>>2]=1124007936;e=C;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[D>>2]=G;k[E>>2]=F;k[H>>2]=0;k[F>>2]=0;e=J;k[e>>2]=0;k[e+4>>2]=0;k[N>>2]=33619968;k[I>>2]=P;mY(Q,N);KG(j,P)|0;e=k[A>>2]|0;if(e|0?(c=e+12|0,h=k[c>>2]|0,k[c>>2]=h+-1,(h|0)==1):0){f=k[A>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[K>>2]|0;if(!e){e=B1()|0;f=k[A>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[A>>2]=0}k[A>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[C>>2]|0)>0){f=k[D>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[C>>2]|0))}e=k[E>>2]|0;if(!((e|0)==(F|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[v>>2]|0;if(e|0?(c=e+12|0,h=k[c>>2]|0,k[c>>2]=h+-1,(h|0)==1):0){f=k[v>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[u>>2]|0;if(!e){e=B1()|0;f=k[v>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[v>>2]=0}k[v>>2]=0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[m>>2]|0)>0){f=k[w>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[m>>2]|0))}e=k[y>>2]|0;if(!((e|0)==(x|0)|(e|0)==0))ggb(k[e+-4>>2]|0);l=l+56|0;if((l|0)==(O|0))break;else j=j+56|0}}k[a>>2]=M;k[a+4>>2]=g;k[L>>2]=(k[L>>2]|0)+1;Q=k[L>>2]|0;k[L>>2]=Q+-1;if((Q|0)!=1){r=R;return}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);r=R;return}function uXa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;ua=r;r=r+368|0;sa=ua+344|0;ta=ua+288|0;ra=ua+232|0;qa=ua+176|0;pa=ua+120|0;oa=ua+104|0;ja=ua+88|0;ka=ua+72|0;la=ua+56|0;ma=ua;na=a+4|0;h=k[na>>2]|0;M=a+8|0;if((h|0)==(k[M>>2]|0))h=k[a+16>>2]|0;ia=k[h>>2]&4095;if((S1(b,-1)|0)!=(ia|0)){h=sa+4|0;j=ZT(48)|0;k[j>>2]=1;X=j+4|0;k[sa>>2]=X;k[h>>2]=41;i[j+45>>0]=0;n=388589;Y=X+41|0;do{i[X>>0]=i[n>>0]|0;X=X+1|0;n=n+1|0}while((X|0)<(Y|0));Y8(-215,sa,388647,388491,726);k[h>>2]=0;k[sa>>2]=0;ia=k[j>>2]|0;k[j>>2]=ia+-1;if((ia|0)==1)ggb(k[j+-4>>2]|0)}do if(!(G2(b)|0)){if((k[na>>2]|0)==(k[M>>2]|0)?(k[a+16>>2]|0)==(k[a+20>>2]|0):0)break;k[sa>>2]=0;ia=sa+4|0;k[ia>>2]=0;k[sa+8>>2]=0;B2(e,sa);if((k[na>>2]|0)!=(k[M>>2]|0)?(I=a+16|0,o=k[I>>2]|0,J=a+20|0,l=k[J>>2]|0,(o|0)!=(l|0)):0){if((l-o|0)>0){s=ta+4|0;t=ta+8|0;u=ta+40|0;v=ta+48|0;w=ta+44|0;x=ta+52|0;y=ra+4|0;z=y+4|0;A=a+12|0;B=ta+36|0;C=ta+16|0;D=ta+12|0;E=ta+20|0;F=ta+24|0;G=ta+28|0;H=ta+32|0;q=0;do{k[ta>>2]=1124007936;X=s;Y=X+36|0;do{k[X>>2]=0;X=X+4|0}while((X|0)<(Y|0));k[u>>2]=t;k[w>>2]=v;k[x>>2]=0;k[v>>2]=0;h=z;k[h>>2]=0;k[h+4>>2]=0;k[ra>>2]=33619968;k[y>>2]=ta;w9(o+(q*48|0)|0,ra);h=k[M>>2]|0;if((h|0)==(k[A>>2]|0))Doa(na,ta);else{k[h>>2]=k[ta>>2];p=h+4|0;k[p>>2]=k[s>>2];ha=h+8|0;k[ha>>2]=k[t>>2];k[h+12>>2]=k[D>>2];k[h+16>>2]=k[C>>2];k[h+20>>2]=k[E>>2];k[h+24>>2]=k[F>>2];k[h+28>>2]=k[G>>2];k[h+32>>2]=k[H>>2];j=k[B>>2]|0;k[h+36>>2]=j;e=h+40|0;k[e>>2]=ha;ha=h+48|0;n=h+44|0;k[n>>2]=ha;k[h+52>>2]=0;k[ha>>2]=0;if(j|0){ha=j+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[s>>2]|0)>=3){k[p>>2]=0;x1(h,k[s>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[u>>2]|0;e=k[e>>2]|0;l=k[w>>2]|0;j=k[n>>2]|0;h=0;do{k[e+(h<<2)>>2]=k[o+(h<<2)>>2];k[j+(h<<2)>>2]=k[l+(h<<2)>>2];h=h+1|0}while((h|0)<(k[p>>2]|0))}}else{ga=k[w>>2]|0;ha=k[n>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2]}k[M>>2]=(k[M>>2]|0)+56}h=k[B>>2]|0;if(h|0?(ga=h+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){j=k[B>>2]|0;if(j|0){h=k[j+4>>2]|0;if(!h){h=k[H>>2]|0;if(!h){h=B1()|0;j=k[B>>2]|0}}jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[B>>2]=0}k[B>>2]=0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[s>>2]|0)>0){j=k[u>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[s>>2]|0))}h=k[w>>2]|0;if(!((h|0)==(v|0)|(h|0)==0))ggb(k[h+-4>>2]|0);q=q+1|0;h=k[J>>2]|0;ha=k[I>>2]|0;o=ha}while((q|0)<((h-ha|0)/48|0|0))}else h=l;if((h|0)!=(o|0)){n=h;do{k[J>>2]=n+-48;l=n+-24|0;h=k[l>>2]|0;if(h|0?(ga=h+8|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){ha=k[l>>2]|0;ga=k[ha+4>>2]|0;jh[k[(k[ga>>2]|0)+16>>2]&1023](ga,ha);k[l>>2]=0}j=n+-44|0;if((k[j>>2]|0)>0){e=k[n+-16>>2]|0;h=0;do{k[e+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[j>>2]|0))}k[l>>2]=0;h=k[n+-12>>2]|0;if(!((h|0)==(n+-8|0)|(h|0)==0))ggb(k[h+-4>>2]|0);n=k[J>>2]|0}while((n|0)!=(o|0))}}do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[ta>>2]=k[l>>2];q=ta+4|0;h=l+4|0;k[q>>2]=k[h>>2];ha=ta+8|0;k[ha>>2]=k[l+8>>2];k[ta+12>>2]=k[l+12>>2];k[ta+16>>2]=k[l+16>>2];k[ta+20>>2]=k[l+20>>2];k[ta+24>>2]=k[l+24>>2];k[ta+28>>2]=k[l+28>>2];k[ta+32>>2]=k[l+32>>2];j=k[l+36>>2]|0;k[ta+36>>2]=j;e=ta+40|0;k[e>>2]=ha;ha=ta+48|0;o=ta+44|0;k[o>>2]=ha;k[ta+52>>2]=0;k[ha>>2]=0;if(j|0){ha=j+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[h>>2]|0)<3){ga=k[l+44>>2]|0;ha=k[o>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2];break}k[q>>2]=0;x1(ta,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[l+40>>2]|0;n=k[e>>2]|0;e=k[l+44>>2]|0;j=k[o>>2]|0;h=0;do{k[n+(h<<2)>>2]=k[p+(h<<2)>>2];k[j+(h<<2)>>2]=k[e+(h<<2)>>2];h=h+1|0}while((h|0)<(k[q>>2]|0))}}else Q1(ta,b,-1);while(0);if((k[na>>2]|0)==(k[M>>2]|0)?(K=a+16|0,m=k[K>>2]|0,L=a+20|0,g=k[L>>2]|0,(m|0)!=(g|0)):0){if((g-m|0)>0){p=ra+4|0;q=ra+8|0;s=ra+40|0;t=ra+48|0;u=ra+44|0;v=ra+52|0;w=qa+4|0;x=w+4|0;y=a+12|0;z=ra+36|0;A=ra+16|0;B=ra+12|0;C=ra+20|0;D=ra+24|0;E=ra+28|0;F=ra+32|0;o=0;do{k[ra>>2]=1124007936;X=p;Y=X+36|0;do{k[X>>2]=0;X=X+4|0}while((X|0)<(Y|0));k[s>>2]=q;k[u>>2]=t;k[v>>2]=0;k[t>>2]=0;g=x;k[g>>2]=0;k[g+4>>2]=0;k[qa>>2]=33619968;k[w>>2]=ra;w9(m+(o*48|0)|0,qa);g=k[M>>2]|0;if((g|0)==(k[y>>2]|0))Doa(na,ra);else{k[g>>2]=k[ra>>2];n=g+4|0;k[n>>2]=k[p>>2];ha=g+8|0;k[ha>>2]=k[q>>2];k[g+12>>2]=k[B>>2];k[g+16>>2]=k[A>>2];k[g+20>>2]=k[C>>2];k[g+24>>2]=k[D>>2];k[g+28>>2]=k[E>>2];k[g+32>>2]=k[F>>2];h=k[z>>2]|0;k[g+36>>2]=h;j=g+40|0;k[j>>2]=ha;ha=g+48|0;l=g+44|0;k[l>>2]=ha;k[g+52>>2]=0;k[ha>>2]=0;if(h|0){ha=h+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[p>>2]|0)>=3){k[n>>2]=0;x1(g,k[p>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[s>>2]|0;j=k[j>>2]|0;e=k[u>>2]|0;h=k[l>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[m+(g<<2)>>2];k[h+(g<<2)>>2]=k[e+(g<<2)>>2];g=g+1|0}while((g|0)<(k[n>>2]|0))}}else{ga=k[u>>2]|0;ha=k[l>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2]}k[M>>2]=(k[M>>2]|0)+56}g=k[z>>2]|0;if(g|0?(ga=g+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){h=k[z>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[F>>2]|0;if(g|0)break;g=B1()|0;h=k[z>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[z>>2]=0}k[z>>2]=0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[p>>2]|0)>0){h=k[s>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[p>>2]|0))}g=k[u>>2]|0;if(!((g|0)==(t|0)|(g|0)==0))ggb(k[g+-4>>2]|0);o=o+1|0;g=k[L>>2]|0;ha=k[K>>2]|0;m=ha}while((o|0)<((g-ha|0)/48|0|0))}if((g|0)!=(m|0)){l=g;do{k[L>>2]=l+-48;e=l+-24|0;g=k[e>>2]|0;if(g|0?(ga=g+8|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){ha=k[e>>2]|0;ga=k[ha+4>>2]|0;jh[k[(k[ga>>2]|0)+16>>2]&1023](ga,ha);k[e>>2]=0}h=l+-44|0;if((k[h>>2]|0)>0){j=k[l+-16>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}k[e>>2]=0;g=k[l+-12>>2]|0;if(!((g|0)==(l+-8|0)|(g|0)==0))ggb(k[g+-4>>2]|0);l=k[L>>2]|0}while((l|0)!=(m|0))}}ga=ta+8|0;l=k[ga>>2]|0;ha=c+8|0;n=k[c>>2]|0;o=n;if((((k[ha>>2]|0)-n|0)/12|0)>>>0<l>>>0){p=c+4|0;h=k[p>>2]|0;e=(h-n|0)/12|0;if(!l)g=0;else{if(l>>>0>357913941){ua=te(4)|0;k[ua>>2]=172664;Cf(ua|0,28816,1287)}j=l*12|0;j=(j|0)==0?1:j;while(1){g=fgb(j)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}}e=g+(e*12|0)|0;m=e;l=g+(l*12|0)|0;if((h|0)==(o|0)){j=m;g=o}else{j=m;g=e;do{h=h+-12|0;AXa(g+-12|0,h);g=j+-12|0;j=g}while((h|0)!=(o|0));n=k[c>>2]|0;g=k[p>>2]|0}k[c>>2]=j;k[p>>2]=m;k[ha>>2]=l;m=n;if((g|0)!=(m|0)){j=g;do{g=j;j=j+-12|0;e=k[j>>2]|0;l=e;if(e|0){g=g+-8|0;h=k[g>>2]|0;if((h|0)!=(e|0))k[g>>2]=h+(~((h+-16-l|0)>>>4)<<4);ggb(e)}}while((j|0)!=(m|0))}if(n|0)ggb(n)}k[ra>>2]=1124007936;ea=ra+4|0;g=ra+8|0;ca=ra+40|0;X=ea;Y=X+36|0;do{k[X>>2]=0;X=X+4|0}while((X|0)<(Y|0));k[ca>>2]=g;fa=ra+48|0;da=ra+44|0;k[da>>2]=fa;k[ra+52>>2]=0;k[fa>>2]=0;k[qa>>2]=1124007936;$=qa+4|0;g=qa+8|0;Z=qa+40|0;X=$;Y=X+36|0;do{k[X>>2]=0;X=X+4|0}while((X|0)<(Y|0));k[Z>>2]=g;ba=qa+48|0;_=qa+44|0;k[_>>2]=ba;k[qa+52>>2]=0;k[ba>>2]=0;j=(k[M>>2]|0)-(k[na>>2]|0)|0;V=(j|0)/56|0;W=a+28|0;g=k[W>>2]|0;if((g&-2|0)!=6)if((g|0)==2)T=(k[ta>>2]&4095|0)==0;else T=0;else T=1;U=T?4:5;Y=Apb(V|0,((V|0)<0)<<31>>31|0,18)|0;X=N;if(!((X|0)<0|(X|0)==0&Y>>>0<2147483647)){k[pa>>2]=0;g=pa+4|0;k[g>>2]=0;h=ZT(44)|0;k[h>>2]=1;X=h+4|0;k[pa>>2]=X;k[g>>2]=36;i[h+40>>0]=0;n=388660;Y=X+36|0;do{i[X>>0]=i[n>>0]|0;X=X+1|0;n=n+1|0}while((X|0)<(Y|0));Y8(-215,pa,388647,388491,821);k[g>>2]=0;k[pa>>2]=0;Y=k[h>>2]|0;k[h>>2]=Y+-1;if((Y|0)==1)ggb(k[h+-4>>2]|0)}if((j|0)>0){A=pa+8|0;B=pa+12|0;C=pa+4|0;D=oa+8|0;E=oa+12|0;F=oa+4|0;G=ja+4|0;H=G+4|0;I=ka+4|0;b=I+4|0;J=ma+4|0;K=ma+8|0;L=ma+40|0;M=ma+48|0;O=ma+44|0;P=ma+52|0;Q=la+8|0;R=la+12|0;S=la+4|0;q=a+32|0;s=ma+36|0;t=ma+16|0;u=ma+12|0;v=ma+20|0;w=ma+24|0;x=ma+28|0;y=ma+32|0;z=pa+4|0;o=0;p=0;while(1){g=k[na>>2]|0;if((k[g+(p*56|0)+8>>2]|0)>=262144){k[pa>>2]=0;k[z>>2]=0;g=ZT(48)|0;k[g>>2]=1;X=g+4|0;k[pa>>2]=X;k[z>>2]=43;i[g+47>>0]=0;n=388697;Y=X+43|0;do{i[X>>0]=i[n>>0]|0;X=X+1|0;n=n+1|0}while((X|0)<(Y|0));Y8(-215,pa,388647,388491,825);k[z>>2]=0;k[pa>>2]=0;a=k[g>>2]|0;k[g>>2]=a+-1;if((a|0)==1)ggb(k[g+-4>>2]|0);g=k[na>>2]|0}k[A>>2]=0;k[B>>2]=0;k[pa>>2]=16842752;k[C>>2]=ta;k[D>>2]=0;k[E>>2]=0;k[oa>>2]=16842752;k[F>>2]=g+(p*56|0);m=H;k[m>>2]=0;k[m+4>>2]=0;k[ja>>2]=33619968;k[G>>2]=ra;m=b;k[m>>2]=0;k[m+4>>2]=0;k[ka>>2]=33619968;k[I>>2]=qa;m=k[W>>2]|0;j=k[sa>>2]|0;do if((j|0)!=(k[ia>>2]|0)){k[ma>>2]=k[j+(p*56|0)>>2];g=j+(p*56|0)+4|0;k[J>>2]=k[g>>2];k[K>>2]=k[j+(p*56|0)+8>>2];k[u>>2]=k[j+(p*56|0)+12>>2];k[t>>2]=k[j+(p*56|0)+16>>2];k[v>>2]=k[j+(p*56|0)+20>>2];k[w>>2]=k[j+(p*56|0)+24>>2];k[x>>2]=k[j+(p*56|0)+28>>2];k[y>>2]=k[j+(p*56|0)+32>>2];h=k[j+(p*56|0)+36>>2]|0;k[s>>2]=h;k[L>>2]=K;k[O>>2]=M;k[P>>2]=0;k[M>>2]=0;if(h|0){a=h+12|0;k[a>>2]=(k[a>>2]|0)+1}if((k[g>>2]|0)<3){Y=k[j+(p*56|0)+44>>2]|0;a=k[O>>2]|0;k[a>>2]=k[Y>>2];k[a+4>>2]=k[Y+4>>2];break}k[J>>2]=0;x1(ma,k[g>>2]|0,0,0,0);if((k[J>>2]|0)>0){e=k[j+(p*56|0)+40>>2]|0;l=k[L>>2]|0;h=k[j+(p*56|0)+44>>2]|0;j=k[O>>2]|0;g=0;do{k[l+(g<<2)>>2]=k[e+(g<<2)>>2];k[j+(g<<2)>>2]=k[h+(g<<2)>>2];g=g+1|0}while((g|0)<(k[J>>2]|0))}}else{k[ma>>2]=1124007936;X=J;Y=X+36|0;do{k[X>>2]=0;X=X+4|0}while((X|0)<(Y|0));k[L>>2]=K;k[O>>2]=M;k[P>>2]=0;k[M>>2]=0}while(0);k[Q>>2]=0;k[R>>2]=0;k[la>>2]=16842752;k[S>>2]=ma;F8(pa,oa,ja,U,ka,m,d,la,o,(i[q>>0]|0)!=0);g=k[s>>2]|0;if(g|0?(Y=g+12|0,a=k[Y>>2]|0,k[Y>>2]=a+-1,(a|0)==1):0){h=k[s>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[y>>2]|0;if(g|0)break;g=B1()|0;h=k[s>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[s>>2]=0}k[s>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[J>>2]|0)>0){h=k[L>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[J>>2]|0))}g=k[O>>2]|0;if(!((g|0)==(M|0)|(g|0)==0))ggb(k[g+-4>>2]|0);p=p+1|0;if((p|0)>=(V|0))break;else o=o+262144|0}}if(T){k[pa>>2]=1124007936;n=pa+4|0;g=pa+8|0;l=pa+40|0;X=n;Y=X+36|0;do{k[X>>2]=0;X=X+4|0}while((X|0)<(Y|0));k[l>>2]=g;m=pa+48|0;e=pa+44|0;k[e>>2]=m;k[pa+52>>2]=0;k[m>>2]=0;j=oa+4|0;g=j+4|0;k[g>>2]=0;k[g+4>>2]=0;k[oa>>2]=33619968;k[j>>2]=pa;SW(ra,oa,5,1.0,0.0);KG(ra,pa)|0;j=pa+36|0;g=k[j>>2]|0;if(g|0?(na=g+12|0,oa=k[na>>2]|0,k[na>>2]=oa+-1,(oa|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[pa+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;oa=pa+16|0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[n>>2]|0)>0){h=k[l>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[n>>2]|0))}g=k[e>>2]|0;if(!((g|0)==(m|0)|(g|0)==0))ggb(k[g+-4>>2]|0)}a:do if((k[ga>>2]|0)>0){x=ra+16|0;y=qa+16|0;z=c+4|0;A=qa+12|0;t=f^1;u=pa+4|0;v=pa+8|0;w=pa+12|0;s=0;b:while(1){p=(k[x>>2]|0)+(aa(k[k[da>>2]>>2]|0,s)|0)|0;q=(k[y>>2]|0)+(aa(k[k[_>>2]>>2]|0,s)|0)|0;g=k[z>>2]|0;f=k[ha>>2]|0;h=f;do if((g|0)==(f|0)){j=k[c>>2]|0;e=(g-j|0)/12|0;g=e+1|0;if(g>>>0>357913941){g=193;break b}f=(h-j|0)/12|0;j=f<<1;j=f>>>0<178956970?(j>>>0<g>>>0?g:j):357913941;if(!j)g=0;else{if(j>>>0>357913941){g=196;break b}h=j*12|0;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}}l=g+(e*12|0)|0;o=g+(j*12|0)|0;k[l>>2]=0;k[g+(e*12|0)+4>>2]=0;k[g+(e*12|0)+8>>2]=0;e=k[c>>2]|0;h=k[z>>2]|0;m=l+12|0;if((h|0)==(e|0)){g=l;n=h}else{j=0;g=l;while(1){h=h+-12|0;AXa(g+-12|0,h);g=j+-1|0;if((h|0)==(e|0))break;else{j=g;g=l+(g*12|0)|0}}g=l+(g*12|0)|0;n=k[c>>2]|0;h=k[z>>2]|0}k[c>>2]=g;k[z>>2]=m;k[ha>>2]=o;m=n;if((h|0)!=(m|0))do{g=h;h=h+-12|0;e=k[h>>2]|0;l=e;if(e|0){g=g+-8|0;j=k[g>>2]|0;if((j|0)!=(e|0))k[g>>2]=j+(~((j+-16-l|0)>>>4)<<4);ggb(e)}}while((h|0)!=(m|0));if(!n)break;ggb(n)}else{k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[z>>2]=g+12}while(0);g=k[z>>2]|0;e=g+-12|0;BXa(e,d);l=g+-8|0;c:do if((k[A>>2]|0)>0){j=g+-4|0;h=0;do{g=k[q+(h<<2)>>2]|0;if((g|0)<0)break c;f=k[p+(h<<2)>>2]|0;k[pa>>2]=s;k[u>>2]=g&262143;k[v>>2]=g>>18;k[w>>2]=f;g=k[l>>2]|0;if((g|0)==(k[j>>2]|0))I6(e,pa);else{k[g>>2]=k[pa>>2];k[g+4>>2]=k[pa+4>>2];k[g+8>>2]=k[pa+8>>2];k[g+12>>2]=k[pa+12>>2];k[l>>2]=(k[l>>2]|0)+16}h=h+1|0}while((h|0)<(k[A>>2]|0))}while(0);if(!((k[e>>2]|0)!=(k[l>>2]|0)|t)){h=k[z>>2]|0;l=h+-12|0;while(1){g=h+-12|0;k[z>>2]=g;j=k[g>>2]|0;e=j;if(j){g=h+-8|0;h=k[g>>2]|0;if((h|0)!=(j|0))k[g>>2]=h+(~((h+-16-e|0)>>>4)<<4);ggb(j);g=k[z>>2]|0}if((g|0)==(l|0))break;else h=g}}s=s+1|0;if((s|0)>=(k[ga>>2]|0))break a}if((g|0)==193)ad(426534,426557,304,426811);else if((g|0)==196){ua=te(4)|0;k[ua>>2]=172664;Cf(ua|0,28816,1287)}}while(0);j=qa+36|0;g=k[j>>2]|0;if(g|0?(d=g+12|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[qa+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;qa=qa+16|0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[qa+12>>2]=0;if((k[$>>2]|0)>0){h=k[Z>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[$>>2]|0))}g=k[_>>2]|0;if(!((g|0)==(ba|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=ra+36|0;g=k[j>>2]|0;if(g|0?(c=g+12|0,qa=k[c>>2]|0,k[c>>2]=qa+-1,(qa|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[ra+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;ra=ra+16|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[ea>>2]|0)>0){h=k[ca>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[ea>>2]|0))}g=k[da>>2]|0;if(!((g|0)==(fa|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=ta+36|0;g=k[j>>2]|0;do if(g|0){qa=g+12|0;ra=k[qa>>2]|0;k[qa>>2]=ra+-1;if((ra|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[ta+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;ra=ta+16|0;h=ta+4|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[h>>2]|0)>0){j=k[ta+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[ta+44>>2]|0;if(!((g|0)==(ta+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);zF(sa);r=ua;return}while(0);m=k[c>>2]|0;l=c+4|0;g=k[l>>2]|0;if((g|0)==(m|0)){r=ua;return}do{h=g+-12|0;k[l>>2]=h;j=k[h>>2]|0;e=j;if(!j)g=h;else{g=g+-8|0;h=k[g>>2]|0;if((h|0)!=(j|0))k[g>>2]=h+(~((h+-16-e|0)>>>4)<<4);ggb(j);g=k[l>>2]|0}}while((g|0)!=(m|0));r=ua;return}function vXa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;va=r;r=r+304|0;ta=va+288|0;ua=va+232|0;sa=va+176|0;ra=va+120|0;la=va+104|0;ma=va+88|0;na=va+72|0;oa=va+56|0;pa=va;qa=a+4|0;h=k[qa>>2]|0;P=a+8|0;if((h|0)==(k[P>>2]|0))h=k[a+16>>2]|0;ka=k[h>>2]&4095;if((S1(b,-1)|0)!=(ka|0)){h=ta+4|0;j=ZT(48)|0;k[j>>2]=1;_=j+4|0;k[ta>>2]=_;k[h>>2]=41;i[j+45>>0]=0;l=388589;$=_+41|0;do{i[_>>0]=i[l>>0]|0;_=_+1|0;l=l+1|0}while((_|0)<($|0));Y8(-215,ta,388631,388491,877);k[h>>2]=0;k[ta>>2]=0;ka=k[j>>2]|0;k[j>>2]=ka+-1;if((ka|0)==1)ggb(k[j+-4>>2]|0)}do if(!(G2(b)|0)){if((k[qa>>2]|0)==(k[P>>2]|0)?(k[a+16>>2]|0)==(k[a+20>>2]|0):0)break;k[ta>>2]=0;ka=ta+4|0;k[ka>>2]=0;k[ta+8>>2]=0;B2(e,ta);if((k[qa>>2]|0)!=(k[P>>2]|0)?(K=a+16|0,p=k[K>>2]|0,L=a+20|0,n=k[L>>2]|0,(p|0)!=(n|0)):0){if((n-p|0)>0){t=ua+4|0;u=ua+8|0;v=ua+40|0;w=ua+48|0;x=ua+44|0;y=ua+52|0;z=sa+4|0;A=z+4|0;B=a+12|0;C=ua+36|0;D=ua+16|0;E=ua+12|0;F=ua+20|0;G=ua+24|0;H=ua+28|0;I=ua+32|0;s=0;do{k[ua>>2]=1124007936;_=t;$=_+36|0;do{k[_>>2]=0;_=_+4|0}while((_|0)<($|0));k[v>>2]=u;k[x>>2]=w;k[y>>2]=0;k[w>>2]=0;h=A;k[h>>2]=0;k[h+4>>2]=0;k[sa>>2]=33619968;k[z>>2]=ua;w9(p+(s*48|0)|0,sa);h=k[P>>2]|0;if((h|0)==(k[B>>2]|0))Doa(qa,ua);else{k[h>>2]=k[ua>>2];q=h+4|0;k[q>>2]=k[t>>2];ja=h+8|0;k[ja>>2]=k[u>>2];k[h+12>>2]=k[E>>2];k[h+16>>2]=k[D>>2];k[h+20>>2]=k[F>>2];k[h+24>>2]=k[G>>2];k[h+28>>2]=k[H>>2];k[h+32>>2]=k[I>>2];j=k[C>>2]|0;k[h+36>>2]=j;l=h+40|0;k[l>>2]=ja;ja=h+48|0;n=h+44|0;k[n>>2]=ja;k[h+52>>2]=0;k[ja>>2]=0;if(j|0){ja=j+12|0;k[ja>>2]=(k[ja>>2]|0)+1}if((k[t>>2]|0)>=3){k[q>>2]=0;x1(h,k[t>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[v>>2]|0;l=k[l>>2]|0;e=k[x>>2]|0;j=k[n>>2]|0;h=0;do{k[l+(h<<2)>>2]=k[p+(h<<2)>>2];k[j+(h<<2)>>2]=k[e+(h<<2)>>2];h=h+1|0}while((h|0)<(k[q>>2]|0))}}else{ia=k[x>>2]|0;ja=k[n>>2]|0;k[ja>>2]=k[ia>>2];k[ja+4>>2]=k[ia+4>>2]}k[P>>2]=(k[P>>2]|0)+56}h=k[C>>2]|0;if(h|0?(ia=h+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){j=k[C>>2]|0;if(j|0){h=k[j+4>>2]|0;if(!h){h=k[I>>2]|0;if(!h){h=B1()|0;j=k[C>>2]|0}}jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[C>>2]=0}k[C>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[t>>2]|0)>0){j=k[v>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[t>>2]|0))}h=k[x>>2]|0;if(!((h|0)==(w|0)|(h|0)==0))ggb(k[h+-4>>2]|0);s=s+1|0;h=k[L>>2]|0;ja=k[K>>2]|0;p=ja}while((s|0)<((h-ja|0)/48|0|0))}else h=n;if((h|0)!=(p|0)){n=h;do{k[L>>2]=n+-48;e=n+-24|0;h=k[e>>2]|0;if(h|0?(ia=h+8|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){ja=k[e>>2]|0;ia=k[ja+4>>2]|0;jh[k[(k[ia>>2]|0)+16>>2]&1023](ia,ja);k[e>>2]=0}j=n+-44|0;if((k[j>>2]|0)>0){l=k[n+-16>>2]|0;h=0;do{k[l+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[j>>2]|0))}k[e>>2]=0;h=k[n+-12>>2]|0;if(!((h|0)==(n+-8|0)|(h|0)==0))ggb(k[h+-4>>2]|0);n=k[L>>2]|0}while((n|0)!=(p|0))}}do if((k[b>>2]&2031616|0)==65536){e=k[b+4>>2]|0;k[ua>>2]=k[e>>2];s=ua+4|0;h=e+4|0;k[s>>2]=k[h>>2];ja=ua+8|0;k[ja>>2]=k[e+8>>2];k[ua+12>>2]=k[e+12>>2];k[ua+16>>2]=k[e+16>>2];k[ua+20>>2]=k[e+20>>2];k[ua+24>>2]=k[e+24>>2];k[ua+28>>2]=k[e+28>>2];k[ua+32>>2]=k[e+32>>2];j=k[e+36>>2]|0;k[ua+36>>2]=j;l=ua+40|0;k[l>>2]=ja;ja=ua+48|0;p=ua+44|0;k[p>>2]=ja;k[ua+52>>2]=0;k[ja>>2]=0;if(j|0){ja=j+12|0;k[ja>>2]=(k[ja>>2]|0)+1}if((k[h>>2]|0)<3){ia=k[e+44>>2]|0;ja=k[p>>2]|0;k[ja>>2]=k[ia>>2];k[ja+4>>2]=k[ia+4>>2];break}k[s>>2]=0;x1(ua,k[h>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[e+40>>2]|0;n=k[l>>2]|0;l=k[e+44>>2]|0;j=k[p>>2]|0;h=0;do{k[n+(h<<2)>>2]=k[q+(h<<2)>>2];k[j+(h<<2)>>2]=k[l+(h<<2)>>2];h=h+1|0}while((h|0)<(k[s>>2]|0))}}else Q1(ua,b,-1);while(0);if((k[qa>>2]|0)==(k[P>>2]|0)?(M=a+16|0,m=k[M>>2]|0,N=a+20|0,g=k[N>>2]|0,(m|0)!=(g|0)):0){if((g-m|0)>0){q=sa+4|0;s=sa+8|0;t=sa+40|0;u=sa+48|0;v=sa+44|0;w=sa+52|0;x=ra+4|0;y=x+4|0;z=a+12|0;A=sa+36|0;B=sa+16|0;C=sa+12|0;D=sa+20|0;E=sa+24|0;F=sa+28|0;G=sa+32|0;p=0;do{k[sa>>2]=1124007936;_=q;$=_+36|0;do{k[_>>2]=0;_=_+4|0}while((_|0)<($|0));k[t>>2]=s;k[v>>2]=u;k[w>>2]=0;k[u>>2]=0;g=y;k[g>>2]=0;k[g+4>>2]=0;k[ra>>2]=33619968;k[x>>2]=sa;w9(m+(p*48|0)|0,ra);g=k[P>>2]|0;if((g|0)==(k[z>>2]|0))Doa(qa,sa);else{k[g>>2]=k[sa>>2];n=g+4|0;k[n>>2]=k[q>>2];ja=g+8|0;k[ja>>2]=k[s>>2];k[g+12>>2]=k[C>>2];k[g+16>>2]=k[B>>2];k[g+20>>2]=k[D>>2];k[g+24>>2]=k[E>>2];k[g+28>>2]=k[F>>2];k[g+32>>2]=k[G>>2];h=k[A>>2]|0;k[g+36>>2]=h;j=g+40|0;k[j>>2]=ja;ja=g+48|0;e=g+44|0;k[e>>2]=ja;k[g+52>>2]=0;k[ja>>2]=0;if(h|0){ja=h+12|0;k[ja>>2]=(k[ja>>2]|0)+1}if((k[q>>2]|0)>=3){k[n>>2]=0;x1(g,k[q>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[t>>2]|0;j=k[j>>2]|0;l=k[v>>2]|0;h=k[e>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[m+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[n>>2]|0))}}else{ia=k[v>>2]|0;ja=k[e>>2]|0;k[ja>>2]=k[ia>>2];k[ja+4>>2]=k[ia+4>>2]}k[P>>2]=(k[P>>2]|0)+56}g=k[A>>2]|0;if(g|0?(ia=g+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){h=k[A>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[G>>2]|0;if(g|0)break;g=B1()|0;h=k[A>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[A>>2]=0}k[A>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[q>>2]|0)>0){h=k[t>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[q>>2]|0))}g=k[v>>2]|0;if(!((g|0)==(u|0)|(g|0)==0))ggb(k[g+-4>>2]|0);p=p+1|0;g=k[N>>2]|0;ja=k[M>>2]|0;m=ja}while((p|0)<((g-ja|0)/48|0|0))}if((g|0)!=(m|0)){e=g;do{k[N>>2]=e+-48;l=e+-24|0;g=k[l>>2]|0;if(g|0?(ia=g+8|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){ja=k[l>>2]|0;ia=k[ja+4>>2]|0;jh[k[(k[ia>>2]|0)+16>>2]&1023](ia,ja);k[l>>2]=0}h=e+-44|0;if((k[h>>2]|0)>0){j=k[e+-16>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}k[l>>2]=0;g=k[e+-12>>2]|0;if(!((g|0)==(e+-8|0)|(g|0)==0))ggb(k[g+-4>>2]|0);e=k[N>>2]|0}while((e|0)!=(m|0))}}fa=ua+8|0;g=k[fa>>2]|0;m=c+4|0;l=k[m>>2]|0;j=k[c>>2]|0;h=(l-j|0)/12|0;if(g>>>0<=h>>>0){if(g>>>0<h>>>0?(O=j+(g*12|0)|0,(l|0)!=(O|0)):0)while(1){g=l+-12|0;k[m>>2]=g;j=k[g>>2]|0;e=j;if(j){g=l+-8|0;h=k[g>>2]|0;if((h|0)!=(j|0))k[g>>2]=h+(~((h+-16-e|0)>>>4)<<4);ggb(j);g=k[m>>2]|0}if((g|0)==(O|0))break;else l=g}}else wXa(c,g-h|0);k[sa>>2]=1124007936;ia=sa+4|0;g=sa+8|0;ga=sa+40|0;_=ia;$=_+36|0;do{k[_>>2]=0;_=_+4|0}while((_|0)<($|0));k[ga>>2]=g;ja=sa+48|0;ha=sa+44|0;k[ha>>2]=ja;k[sa+52>>2]=0;k[ja>>2]=0;k[ra>>2]=1124007936;da=ra+4|0;g=ra+8|0;ba=ra+40|0;_=da;$=_+36|0;do{k[_>>2]=0;_=_+4|0}while((_|0)<($|0));k[ba>>2]=g;ea=ra+48|0;ca=ra+44|0;k[ca>>2]=ea;k[ra+52>>2]=0;k[ea>>2]=0;j=k[qa>>2]|0;g=(k[P>>2]|0)-j|0;Z=(g|0)/56|0;W=a+28|0;l=k[W>>2]|0;if((l|0)!=6)if((l|0)==2)X=(k[ua>>2]&4095|0)==0;else X=0;else X=1;Y=X?4:5;a:do if((g|0)>0){s=la+8|0;t=la+12|0;u=la+4|0;v=ma+8|0;w=ma+12|0;x=ma+4|0;y=na+4|0;z=y+4|0;A=pa+4|0;B=pa+8|0;C=pa+40|0;D=pa+48|0;E=pa+44|0;F=pa+52|0;G=oa+8|0;H=oa+12|0;I=oa+4|0;K=pa+36|0;b=pa+16|0;L=la+4|0;M=L+4|0;N=ra+16|0;O=ra+12|0;P=la+4|0;a=la+8|0;Q=la+12|0;R=pa+12|0;S=pa+20|0;T=pa+24|0;U=pa+28|0;V=pa+32|0;h=0;while(1){k[s>>2]=0;k[t>>2]=0;k[la>>2]=16842752;k[u>>2]=ua;k[v>>2]=0;k[w>>2]=0;k[ma>>2]=16842752;k[x>>2]=j+(h*56|0);e=z;k[e>>2]=0;k[e+4>>2]=0;k[na>>2]=33619968;k[y>>2]=sa;e=k[ta>>2]|0;do if((e|0)!=(k[ka>>2]|0)){k[pa>>2]=k[e+(h*56|0)>>2];g=e+(h*56|0)+4|0;k[A>>2]=k[g>>2];k[B>>2]=k[e+(h*56|0)+8>>2];k[R>>2]=k[e+(h*56|0)+12>>2];k[b>>2]=k[e+(h*56|0)+16>>2];k[S>>2]=k[e+(h*56|0)+20>>2];k[T>>2]=k[e+(h*56|0)+24>>2];k[U>>2]=k[e+(h*56|0)+28>>2];k[V>>2]=k[e+(h*56|0)+32>>2];j=k[e+(h*56|0)+36>>2]|0;k[K>>2]=j;k[C>>2]=B;k[E>>2]=D;k[F>>2]=0;k[D>>2]=0;if(j|0){$=j+12|0;k[$>>2]=(k[$>>2]|0)+1}if((k[g>>2]|0)<3){_=k[e+(h*56|0)+44>>2]|0;$=k[E>>2]|0;k[$>>2]=k[_>>2];k[$+4>>2]=k[_+4>>2];break}k[A>>2]=0;x1(pa,k[g>>2]|0,0,0,0);if((k[A>>2]|0)>0){m=k[e+(h*56|0)+40>>2]|0;n=k[C>>2]|0;j=k[e+(h*56|0)+44>>2]|0;e=k[E>>2]|0;g=0;do{k[n+(g<<2)>>2]=k[m+(g<<2)>>2];k[e+(g<<2)>>2]=k[j+(g<<2)>>2];g=g+1|0}while((g|0)<(k[A>>2]|0))}}else{k[pa>>2]=1124007936;_=A;$=_+36|0;do{k[_>>2]=0;_=_+4|0}while((_|0)<($|0));k[C>>2]=B;k[E>>2]=D;k[F>>2]=0;k[D>>2]=0}while(0);k[G>>2]=0;k[H>>2]=0;k[oa>>2]=16842752;k[I>>2]=pa;F8(la,ma,na,Y,49332,l,0,oa,0,0);g=k[K>>2]|0;if(g|0?(_=g+12|0,$=k[_>>2]|0,k[_>>2]=$+-1,($|0)==1):0){j=k[K>>2]|0;if(j|0){g=k[j+4>>2]|0;do if(!g){g=k[V>>2]|0;if(g|0)break;g=B1()|0;j=k[K>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,j)}k[K>>2]=0}k[K>>2]=0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[A>>2]|0)>0){j=k[C>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[A>>2]|0))}g=k[E>>2]|0;if(!((g|0)==(D|0)|(g|0)==0))ggb(k[g+-4>>2]|0);if(X){$=M;k[$>>2]=0;k[$+4>>2]=0;k[la>>2]=33619968;k[L>>2]=ra;SW(sa,la,5,1.0,0.0)}else KG(ra,sa)|0;g=k[fa>>2]|0;if((g|0)>0){q=0;j=k[O>>2]|0;do{m=(k[N>>2]|0)+(aa(k[k[ca>>2]>>2]|0,q)|0)|0;g=k[c>>2]|0;n=g+(q*12|0)|0;if((j|0)>0){p=g+(q*12|0)+4|0;e=g+(q*12|0)+8|0;l=0;do{J=+o[m+(l<<2)>>2];if(J<=d){k[la>>2]=q;k[P>>2]=l;k[a>>2]=h;o[Q>>2]=J;g=k[p>>2]|0;if((g|0)==(k[e>>2]|0))I6(n,la);else{k[g>>2]=k[la>>2];k[g+4>>2]=k[la+4>>2];k[g+8>>2]=k[la+8>>2];k[g+12>>2]=k[la+12>>2];k[p>>2]=(k[p>>2]|0)+16}j=k[O>>2]|0}l=l+1|0}while((l|0)<(j|0))}q=q+1|0;g=k[fa>>2]|0}while((q|0)<(g|0))}h=h+1|0;if((h|0)>=(Z|0))break a;j=k[qa>>2]|0;l=k[W>>2]|0}}else g=k[fa>>2]|0;while(0);b:do if((g|0)>0){if(f){n=0;m=0;h=g}else{g=0;while(1){f=k[c>>2]|0;xXa(k[f+(g*12|0)>>2]|0,k[f+(g*12|0)+4>>2]|0);g=g+1|0;if((g|0)>=(k[fa>>2]|0))break b}}while(1){g=k[c>>2]|0;j=g+(n*12|0)|0;f=k[j>>2]|0;l=g+(n*12|0)+4|0;e=f;if((f|0)==(k[l>>2]|0))g=m;else{if((m|0)<(n|0)){qa=g+(m*12|0)|0;k[j>>2]=k[qa>>2];k[qa>>2]=e;qa=g+(m*12|0)+4|0;f=k[l>>2]|0;k[l>>2]=k[qa>>2];k[qa>>2]=f;qa=g+(n*12|0)+8|0;g=g+(m*12|0)+8|0;f=k[qa>>2]|0;k[qa>>2]=k[g>>2];k[g>>2]=f;g=k[c>>2]|0}xXa(k[g+(m*12|0)>>2]|0,k[g+(m*12|0)+4>>2]|0);g=m+1|0;h=k[fa>>2]|0}n=n+1|0;if((n|0)>=(h|0))break;else m=g}}while(0);j=ra+36|0;g=k[j>>2]|0;if(g|0?(f=g+12|0,c=k[f>>2]|0,k[f>>2]=c+-1,(c|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[ra+32>>2]|0;if(!g){g=B1()|0;h=k[j>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;ra=ra+16|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[da>>2]|0)>0){h=k[ba>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[da>>2]|0))}g=k[ca>>2]|0;if(!((g|0)==(ea|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=sa+36|0;g=k[j>>2]|0;if(g|0?(c=g+12|0,ra=k[c>>2]|0,k[c>>2]=ra+-1,(ra|0)==1):0){h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[sa+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}k[j>>2]=0;sa=sa+16|0;k[sa>>2]=0;k[sa+4>>2]=0;k[sa+8>>2]=0;k[sa+12>>2]=0;if((k[ia>>2]|0)>0){h=k[ga>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[ia>>2]|0))}g=k[ha>>2]|0;if(!((g|0)==(ja|0)|(g|0)==0))ggb(k[g+-4>>2]|0);j=ua+36|0;g=k[j>>2]|0;do if(g|0){ra=g+12|0;sa=k[ra>>2]|0;k[ra>>2]=sa+-1;if((sa|0)!=1)break;h=k[j>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[ua+32>>2]|0;if(g|0)break;g=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[j>>2]=0}while(0);k[j>>2]=0;sa=ua+16|0;h=ua+4|0;k[sa>>2]=0;k[sa+4>>2]=0;k[sa+8>>2]=0;k[sa+12>>2]=0;if((k[h>>2]|0)>0){j=k[ua+40>>2]|0;g=0;do{k[j+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[ua+44>>2]|0;if(!((g|0)==(ua+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);zF(ta);r=va;return}while(0);m=k[c>>2]|0;e=c+4|0;g=k[e>>2]|0;if((g|0)==(m|0)){r=va;return}do{h=g+-12|0;k[e>>2]=h;j=k[h>>2]|0;l=j;if(!j)g=h;else{g=g+-8|0;h=k[g>>2]|0;if((h|0)!=(j|0))k[g>>2]=h+(~((h+-16-l|0)>>>4)<<4);ggb(j);g=k[e>>2]|0}}while((g|0)!=(m|0));r=va;return}function wXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+8|0;f=k[l>>2]|0;m=a+4|0;i=k[m>>2]|0;e=i;if(((f-i|0)/12|0)>>>0>=b>>>0){zpb(i|0,0,b*12|0)|0;k[m>>2]=e+(b*12|0);return}c=k[a>>2]|0;h=(i-c|0)/12|0;d=h+b|0;if(d>>>0>357913941)ad(426534,426557,304,426811);j=c;f=(f-c|0)/12|0;g=f<<1;g=f>>>0<178956970?(g>>>0<d>>>0?d:g):357913941;if(!g)f=0;else{if(g>>>0>357913941){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=g*12|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}f=c}c=f+(h*12|0)|0;d=c;g=f+(g*12|0)|0;zpb(c|0,0,b*12|0)|0;f=c+(b*12|0)|0;if((e|0)!=(j|0)){do{e=e+-12|0;AXa(c+-12|0,e);c=d+-12|0;d=c}while((e|0)!=(j|0));i=k[a>>2]|0;e=k[m>>2]|0}k[a>>2]=d;k[m>>2]=f;k[l>>2]=g;h=i;if((e|0)!=(h|0))do{c=e;e=e+-12|0;f=k[e>>2]|0;g=f;if(f|0){c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(f|0))k[c>>2]=d+(~((d+-16-g|0)>>>4)<<4);ggb(f)}}while((e|0)!=(h|0));if(!i)return;ggb(i);return}function xXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0.0;w=r;r=r+16|0;v=w;a:while(1){q=b;t=b+-16|0;u=b+-4|0;while(1){b:while(1){p=a;c=q-p|0;d=c>>4;switch(d|0){case 2:{s=5;break a}case 3:{s=7;break a}case 4:{s=15;break a}case 5:{s=16;break a}case 1:case 0:{s=84;break a}default:{}}if((c|0)<496){s=22;break a}l=(d|0)/2|0;n=a+(l<<4)|0;do if((c|0)>15984){j=(d|0)/4|0;m=a+(j<<4)|0;e=n+(j<<4)|0;c=yXa(a,m,n,e)|0;h=e+12|0;if(!(+o[u>>2]<+o[h>>2])){d=a+(l<<4)+12|0;break};k[v>>2]=k[e>>2];k[v+4>>2]=k[e+4>>2];k[v+8>>2]=k[e+8>>2];k[v+12>>2]=k[e+12>>2];k[e>>2]=k[t>>2];k[e+4>>2]=k[t+4>>2];k[e+8>>2]=k[t+8>>2];k[e+12>>2]=k[t+12>>2];k[t>>2]=k[v>>2];k[t+4>>2]=k[v+4>>2];k[t+8>>2]=k[v+8>>2];k[t+12>>2]=k[v+12>>2];i=c+1|0;d=a+(l<<4)+12|0;if(+o[h>>2]<+o[d>>2]){k[v>>2]=k[n>>2];k[v+4>>2]=k[n+4>>2];k[v+8>>2]=k[n+8>>2];k[v+12>>2]=k[n+12>>2];k[n>>2]=k[e>>2];k[n+4>>2]=k[e+4>>2];k[n+8>>2]=k[e+8>>2];k[n+12>>2]=k[e+12>>2];k[e>>2]=k[v>>2];k[e+4>>2]=k[v+4>>2];k[e+8>>2]=k[v+8>>2];k[e+12>>2]=k[v+12>>2];h=c+2|0;e=a+(j<<4)+12|0;if(+o[d>>2]<+o[e>>2]){k[v>>2]=k[m>>2];k[v+4>>2]=k[m+4>>2];k[v+8>>2]=k[m+8>>2];k[v+12>>2]=k[m+12>>2];k[m>>2]=k[n>>2];k[m+4>>2]=k[n+4>>2];k[m+8>>2]=k[n+8>>2];k[m+12>>2]=k[n+12>>2];k[n>>2]=k[v>>2];k[n+4>>2]=k[v+4>>2];k[n+8>>2]=k[v+8>>2];k[n+12>>2]=k[v+12>>2];if(+o[e>>2]<+o[a+12>>2]){k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[m>>2];k[a+4>>2]=k[m+4>>2];k[a+8>>2]=k[m+8>>2];k[a+12>>2]=k[m+12>>2];k[m>>2]=k[v>>2];k[m+4>>2]=k[v+4>>2];k[m+8>>2]=k[v+8>>2];k[m+12>>2]=k[v+12>>2];c=c+4|0}else c=c+3|0}else c=h}else c=i}else{e=a+(l<<4)+12|0;g=+o[e>>2];c=a+12|0;d=+o[u>>2]<g;if(!(g<+o[c>>2])){if(!d){c=0;d=e;break};k[v>>2]=k[n>>2];k[v+4>>2]=k[n+4>>2];k[v+8>>2]=k[n+8>>2];k[v+12>>2]=k[n+12>>2];k[n>>2]=k[t>>2];k[n+4>>2]=k[t+4>>2];k[n+8>>2]=k[t+8>>2];k[n+12>>2]=k[t+12>>2];k[t>>2]=k[v>>2];k[t+4>>2]=k[v+4>>2];k[t+8>>2]=k[v+8>>2];k[t+12>>2]=k[v+12>>2];if(!(+o[e>>2]<+o[c>>2])){c=1;d=e;break};k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[n>>2];k[a+4>>2]=k[n+4>>2];k[a+8>>2]=k[n+8>>2];k[a+12>>2]=k[n+12>>2];k[n>>2]=k[v>>2];k[n+4>>2]=k[v+4>>2];k[n+8>>2]=k[v+8>>2];k[n+12>>2]=k[v+12>>2];c=2;d=e;break}if(d){k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[t>>2];k[a+4>>2]=k[t+4>>2];k[a+8>>2]=k[t+8>>2];k[a+12>>2]=k[t+12>>2];k[t>>2]=k[v>>2];k[t+4>>2]=k[v+4>>2];k[t+8>>2]=k[v+8>>2];k[t+12>>2]=k[v+12>>2];c=1;d=e;break};k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[n>>2];k[a+4>>2]=k[n+4>>2];k[a+8>>2]=k[n+8>>2];k[a+12>>2]=k[n+12>>2];k[n>>2]=k[v>>2];k[n+4>>2]=k[v+4>>2];k[n+8>>2]=k[v+8>>2];k[n+12>>2]=k[v+12>>2];if(+o[u>>2]<+o[e>>2]){k[v>>2]=k[n>>2];k[v+4>>2]=k[n+4>>2];k[v+8>>2]=k[n+8>>2];k[v+12>>2]=k[n+12>>2];k[n>>2]=k[t>>2];k[n+4>>2]=k[t+4>>2];k[n+8>>2]=k[t+8>>2];k[n+12>>2]=k[t+12>>2];k[t>>2]=k[v>>2];k[t+4>>2]=k[v+4>>2];k[t+8>>2]=k[v+8>>2];k[t+12>>2]=k[v+12>>2];c=2;d=e}else{c=1;d=e}}while(0);h=a+12|0;g=+o[h>>2];f=+o[d>>2];if(g<f){d=t;break}else d=t;while(1){e=d;d=d+-16|0;if((a|0)==(d|0))break;if(+o[e+-4>>2]<f){s=67;break b}}a=a+16|0;if(!(g<+o[u>>2])){if((a|0)==(t|0)){s=84;break a}while(1){if(g<+o[a+12>>2])break;a=a+16|0;if((a|0)==(t|0)){s=84;break a}}k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[t>>2];k[a+4>>2]=k[t+4>>2];k[a+8>>2]=k[t+8>>2];k[a+12>>2]=k[t+12>>2];k[t>>2]=k[v>>2];k[t+4>>2]=k[v+4>>2];k[t+8>>2]=k[v+8>>2];k[t+12>>2]=k[v+12>>2];a=a+16|0}if((a|0)==(t|0)){s=84;break a}else c=t;while(1){f=+o[h>>2];while(1){d=a+16|0;if(f<+o[a+12>>2])break;else a=d}do{p=c;c=c+-16|0}while(f<+o[p+-4>>2]);if(a>>>0>=c>>>0)continue b;k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[v>>2];k[c+4>>2]=k[v+4>>2];k[c+8>>2]=k[v+8>>2];k[c+12>>2]=k[v+12>>2];a=d}}if((s|0)==67){s=0;k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[d>>2];k[a+4>>2]=k[d+4>>2];k[a+8>>2]=k[d+8>>2];k[a+12>>2]=k[d+12>>2];k[d>>2]=k[v>>2];k[d+4>>2]=k[v+4>>2];k[d+8>>2]=k[v+8>>2];k[d+12>>2]=k[v+12>>2];c=c+1|0}e=a+16|0;c:do if(e>>>0<d>>>0){i=n;while(1){f=+o[i+12>>2];while(1){h=e+16|0;if(+o[e+12>>2]<f)e=h;else break}do{n=d;d=d+-16|0}while(!(+o[n+-4>>2]<f));if(e>>>0>d>>>0){d=i;break c};k[v>>2]=k[e>>2];k[v+4>>2]=k[e+4>>2];k[v+8>>2]=k[e+8>>2];k[v+12>>2]=k[e+12>>2];k[e>>2]=k[d>>2];k[e+4>>2]=k[d+4>>2];k[e+8>>2]=k[d+8>>2];k[e+12>>2]=k[d+12>>2];k[d>>2]=k[v>>2];k[d+4>>2]=k[v+4>>2];k[d+8>>2]=k[v+8>>2];k[d+12>>2]=k[v+12>>2];i=(i|0)==(e|0)?d:i;e=h;c=c+1|0}}else d=n;while(0);if((e|0)!=(d|0)?+o[d+12>>2]<+o[e+12>>2]:0){k[v>>2]=k[e>>2];k[v+4>>2]=k[e+4>>2];k[v+8>>2]=k[e+8>>2];k[v+12>>2]=k[e+12>>2];k[e>>2]=k[d>>2];k[e+4>>2]=k[d+4>>2];k[e+8>>2]=k[d+8>>2];k[e+12>>2]=k[d+12>>2];k[d>>2]=k[v>>2];k[d+4>>2]=k[v+4>>2];k[d+8>>2]=k[v+8>>2];k[d+12>>2]=k[v+12>>2];c=c+1|0}if(!c){c=zXa(a,e)|0;d=e+16|0;if(zXa(d,b)|0){s=83;break}if(c){a=d;continue}}n=e;if((n-p|0)>=(q-n|0)){s=82;break}xXa(a,e);a=e+16|0}if((s|0)==82){s=0;xXa(e+16|0,b);b=e;continue}else if((s|0)==83){s=0;if(c){s=84;break}else{b=e;continue}}}if((s|0)==5){if(!(+o[u>>2]<+o[a+12>>2])){r=w;return};k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[t>>2];k[a+4>>2]=k[t+4>>2];k[a+8>>2]=k[t+8>>2];k[a+12>>2]=k[t+12>>2];k[t>>2]=k[v>>2];k[t+4>>2]=k[v+4>>2];k[t+8>>2]=k[v+8>>2];k[t+12>>2]=k[v+12>>2];r=w;return}else if((s|0)==7){b=a+16|0;c=a+28|0;g=+o[c>>2];d=a+12|0;e=+o[u>>2]<g;if(!(g<+o[d>>2])){if(!e){r=w;return};k[v>>2]=k[b>>2];k[v+4>>2]=k[b+4>>2];k[v+8>>2]=k[b+8>>2];k[v+12>>2]=k[b+12>>2];k[b>>2]=k[t>>2];k[b+4>>2]=k[t+4>>2];k[b+8>>2]=k[t+8>>2];k[b+12>>2]=k[t+12>>2];k[t>>2]=k[v>>2];k[t+4>>2]=k[v+4>>2];k[t+8>>2]=k[v+8>>2];k[t+12>>2]=k[v+12>>2];if(!(+o[c>>2]<+o[d>>2])){r=w;return};k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[v>>2];k[b+4>>2]=k[v+4>>2];k[b+8>>2]=k[v+8>>2];k[b+12>>2]=k[v+12>>2];r=w;return}if(e){k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[t>>2];k[a+4>>2]=k[t+4>>2];k[a+8>>2]=k[t+8>>2];k[a+12>>2]=k[t+12>>2];k[t>>2]=k[v>>2];k[t+4>>2]=k[v+4>>2];k[t+8>>2]=k[v+8>>2];k[t+12>>2]=k[v+12>>2];r=w;return};k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[v>>2];k[b+4>>2]=k[v+4>>2];k[b+8>>2]=k[v+8>>2];k[b+12>>2]=k[v+12>>2];if(!(+o[u>>2]<+o[c>>2])){r=w;return};k[v>>2]=k[b>>2];k[v+4>>2]=k[b+4>>2];k[v+8>>2]=k[b+8>>2];k[v+12>>2]=k[b+12>>2];k[b>>2]=k[t>>2];k[b+4>>2]=k[t+4>>2];k[b+8>>2]=k[t+8>>2];k[b+12>>2]=k[t+12>>2];k[t>>2]=k[v>>2];k[t+4>>2]=k[v+4>>2];k[t+8>>2]=k[v+8>>2];k[t+12>>2]=k[v+12>>2];r=w;return}else if((s|0)==15){yXa(a,a+16|0,a+32|0,t)|0;r=w;return}else if((s|0)==16){e=a+16|0;h=a+32|0;b=a+48|0;yXa(a,e,h,b)|0;d=a+60|0;if(!(+o[u>>2]<+o[d>>2])){r=w;return};k[v>>2]=k[b>>2];k[v+4>>2]=k[b+4>>2];k[v+8>>2]=k[b+8>>2];k[v+12>>2]=k[b+12>>2];k[b>>2]=k[t>>2];k[b+4>>2]=k[t+4>>2];k[b+8>>2]=k[t+8>>2];k[b+12>>2]=k[t+12>>2];k[t>>2]=k[v>>2];k[t+4>>2]=k[v+4>>2];k[t+8>>2]=k[v+8>>2];k[t+12>>2]=k[v+12>>2];c=a+44|0;if(!(+o[d>>2]<+o[c>>2])){r=w;return};k[v>>2]=k[h>>2];k[v+4>>2]=k[h+4>>2];k[v+8>>2]=k[h+8>>2];k[v+12>>2]=k[h+12>>2];k[h>>2]=k[b>>2];k[h+4>>2]=k[b+4>>2];k[h+8>>2]=k[b+8>>2];k[h+12>>2]=k[b+12>>2];k[b>>2]=k[v>>2];k[b+4>>2]=k[v+4>>2];k[b+8>>2]=k[v+8>>2];k[b+12>>2]=k[v+12>>2];b=a+28|0;if(!(+o[c>>2]<+o[b>>2])){r=w;return};k[v>>2]=k[e>>2];k[v+4>>2]=k[e+4>>2];k[v+8>>2]=k[e+8>>2];k[v+12>>2]=k[e+12>>2];k[e>>2]=k[h>>2];k[e+4>>2]=k[h+4>>2];k[e+8>>2]=k[h+8>>2];k[e+12>>2]=k[h+12>>2];k[h>>2]=k[v>>2];k[h+4>>2]=k[v+4>>2];k[h+8>>2]=k[v+8>>2];k[h+12>>2]=k[v+12>>2];if(!(+o[b>>2]<+o[a+12>>2])){r=w;return};k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[e>>2];k[a+4>>2]=k[e+4>>2];k[a+8>>2]=k[e+8>>2];k[a+12>>2]=k[e+12>>2];k[e>>2]=k[v>>2];k[e+4>>2]=k[v+4>>2];k[e+8>>2]=k[v+8>>2];k[e+12>>2]=k[v+12>>2];r=w;return}else if((s|0)==22){d=a+32|0;c=a+16|0;e=a+28|0;x=+o[e>>2];f=+o[a+12>>2];g=+o[a+44>>2];h=g<x;do if(x<f){if(h){k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[d>>2];k[a+4>>2]=k[d+4>>2];k[a+8>>2]=k[d+8>>2];k[a+12>>2]=k[d+12>>2];k[d>>2]=k[v>>2];k[d+4>>2]=k[v+4>>2];k[d+8>>2]=k[v+8>>2];k[d+12>>2]=k[v+12>>2];break};k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[v>>2];k[c+4>>2]=k[v+4>>2];k[c+8>>2]=k[v+8>>2];k[c+12>>2]=k[v+12>>2];if(g<+o[e>>2]){k[v>>2]=k[c>>2];k[v+4>>2]=k[c+4>>2];k[v+8>>2]=k[c+8>>2];k[v+12>>2]=k[c+12>>2];k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];k[d>>2]=k[v>>2];k[d+4>>2]=k[v+4>>2];k[d+8>>2]=k[v+8>>2];k[d+12>>2]=k[v+12>>2]}}else if(h?(k[v>>2]=k[c>>2],k[v+4>>2]=k[c+4>>2],k[v+8>>2]=k[c+8>>2],k[v+12>>2]=k[c+12>>2],k[c>>2]=k[d>>2],k[c+4>>2]=k[d+4>>2],k[c+8>>2]=k[d+8>>2],k[c+12>>2]=k[d+12>>2],k[d>>2]=k[v>>2],k[d+4>>2]=k[v+4>>2],k[d+8>>2]=k[v+8>>2],k[d+12>>2]=k[v+12>>2],+o[e>>2]<f):0){k[v>>2]=k[a>>2];k[v+4>>2]=k[a+4>>2];k[v+8>>2]=k[a+8>>2];k[v+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[v>>2];k[c+4>>2]=k[v+4>>2];k[c+8>>2]=k[v+8>>2];k[c+12>>2]=k[v+12>>2]}while(0);c=a+48|0;if((c|0)==(b|0)){r=w;return}while(1){f=+o[c+12>>2];if(f<+o[d+12>>2]){k[v>>2]=k[c>>2];k[v+4>>2]=k[c+4>>2];k[v+8>>2]=k[c+8>>2];e=c;while(1){k[e>>2]=k[d>>2];k[e+4>>2]=k[d+4>>2];k[e+8>>2]=k[d+8>>2];k[e+12>>2]=k[d+12>>2];if((d|0)==(a|0)){e=a;break}if(f<+o[d+-4>>2]){e=d;d=d+-16|0}else{e=d;break}}k[d>>2]=k[v>>2];k[d+4>>2]=k[v+4>>2];k[d+8>>2]=k[v+8>>2];o[e+12>>2]=f}d=c+16|0;if((d|0)==(b|0))break;else{u=c;c=d;d=u}}r=w;return}else if((s|0)==84){r=w;return}}function yXa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0.0;j=r;r=r+16|0;g=j;h=b+12|0;l=+o[h>>2];i=a+12|0;f=c+12|0;e=+o[f>>2]<l;do if(l<+o[i>>2]){if(e){k[g>>2]=k[a>>2];k[g+4>>2]=k[a+4>>2];k[g+8>>2]=k[a+8>>2];k[g+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[g>>2];k[c+4>>2]=k[g+4>>2];k[c+8>>2]=k[g+8>>2];k[c+12>>2]=k[g+12>>2];e=1;break};k[g>>2]=k[a>>2];k[g+4>>2]=k[a+4>>2];k[g+8>>2]=k[a+8>>2];k[g+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[g>>2];k[b+4>>2]=k[g+4>>2];k[b+8>>2]=k[g+8>>2];k[b+12>>2]=k[g+12>>2];if(+o[f>>2]<+o[h>>2]){k[g>>2]=k[b>>2];k[g+4>>2]=k[b+4>>2];k[g+8>>2]=k[b+8>>2];k[g+12>>2]=k[b+12>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[c>>2]=k[g>>2];k[c+4>>2]=k[g+4>>2];k[c+8>>2]=k[g+8>>2];k[c+12>>2]=k[g+12>>2];e=2}else e=1}else if(e){k[g>>2]=k[b>>2];k[g+4>>2]=k[b+4>>2];k[g+8>>2]=k[b+8>>2];k[g+12>>2]=k[b+12>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[c>>2]=k[g>>2];k[c+4>>2]=k[g+4>>2];k[c+8>>2]=k[g+8>>2];k[c+12>>2]=k[g+12>>2];if(+o[h>>2]<+o[i>>2]){k[g>>2]=k[a>>2];k[g+4>>2]=k[a+4>>2];k[g+8>>2]=k[a+8>>2];k[g+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[g>>2];k[b+4>>2]=k[g+4>>2];k[b+8>>2]=k[g+8>>2];k[b+12>>2]=k[g+12>>2];e=2}else e=1}else e=0;while(0);if(!(+o[d+12>>2]<+o[f>>2])){i=e;r=j;return i|0};k[g>>2]=k[c>>2];k[g+4>>2]=k[c+4>>2];k[g+8>>2]=k[c+8>>2];k[g+12>>2]=k[c+12>>2];k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];k[d>>2]=k[g>>2];k[d+4>>2]=k[g+4>>2];k[d+8>>2]=k[g+8>>2];k[d+12>>2]=k[g+12>>2];if(!(+o[f>>2]<+o[h>>2])){i=e+1|0;r=j;return i|0};k[g>>2]=k[b>>2];k[g+4>>2]=k[b+4>>2];k[g+8>>2]=k[b+8>>2];k[g+12>>2]=k[b+12>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[c>>2]=k[g>>2];k[c+4>>2]=k[g+4>>2];k[c+8>>2]=k[g+8>>2];k[c+12>>2]=k[g+12>>2];if(!(+o[h>>2]<+o[i>>2])){i=e+2|0;r=j;return i|0};k[g>>2]=k[a>>2];k[g+4>>2]=k[a+4>>2];k[g+8>>2]=k[a+8>>2];k[g+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[g>>2];k[b+4>>2]=k[g+4>>2];k[b+8>>2]=k[g+8>>2];k[b+12>>2]=k[g+12>>2];i=e+3|0;r=j;return i|0}function zXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0.0,j=0.0,l=0,m=0,n=0.0;m=r;r=r+16|0;l=m;switch(b-a>>4|0){case 2:{if(!(+o[b+-4>>2]<+o[a+12>>2])){l=1;r=m;return l|0}b=b+-16|0;k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2];k[l+8>>2]=k[a+8>>2];k[l+12>>2]=k[a+12>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[b>>2]=k[l>>2];k[b+4>>2]=k[l+4>>2];k[b+8>>2]=k[l+8>>2];k[b+12>>2]=k[l+12>>2];l=1;r=m;return l|0}case 3:{e=a+16|0;f=b+-16|0;g=a+28|0;j=+o[g>>2];h=a+12|0;c=b+-4|0;d=+o[c>>2]<j;if(!(j<+o[h>>2])){if(!d){l=1;r=m;return l|0};k[l>>2]=k[e>>2];k[l+4>>2]=k[e+4>>2];k[l+8>>2]=k[e+8>>2];k[l+12>>2]=k[e+12>>2];k[e>>2]=k[f>>2];k[e+4>>2]=k[f+4>>2];k[e+8>>2]=k[f+8>>2];k[e+12>>2]=k[f+12>>2];k[f>>2]=k[l>>2];k[f+4>>2]=k[l+4>>2];k[f+8>>2]=k[l+8>>2];k[f+12>>2]=k[l+12>>2];if(!(+o[g>>2]<+o[h>>2])){l=1;r=m;return l|0};k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2];k[l+8>>2]=k[a+8>>2];k[l+12>>2]=k[a+12>>2];k[a>>2]=k[e>>2];k[a+4>>2]=k[e+4>>2];k[a+8>>2]=k[e+8>>2];k[a+12>>2]=k[e+12>>2];k[e>>2]=k[l>>2];k[e+4>>2]=k[l+4>>2];k[e+8>>2]=k[l+8>>2];k[e+12>>2]=k[l+12>>2];l=1;r=m;return l|0}if(d){k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2];k[l+8>>2]=k[a+8>>2];k[l+12>>2]=k[a+12>>2];k[a>>2]=k[f>>2];k[a+4>>2]=k[f+4>>2];k[a+8>>2]=k[f+8>>2];k[a+12>>2]=k[f+12>>2];k[f>>2]=k[l>>2];k[f+4>>2]=k[l+4>>2];k[f+8>>2]=k[l+8>>2];k[f+12>>2]=k[l+12>>2];l=1;r=m;return l|0};k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2];k[l+8>>2]=k[a+8>>2];k[l+12>>2]=k[a+12>>2];k[a>>2]=k[e>>2];k[a+4>>2]=k[e+4>>2];k[a+8>>2]=k[e+8>>2];k[a+12>>2]=k[e+12>>2];k[e>>2]=k[l>>2];k[e+4>>2]=k[l+4>>2];k[e+8>>2]=k[l+8>>2];k[e+12>>2]=k[l+12>>2];if(!(+o[c>>2]<+o[g>>2])){l=1;r=m;return l|0};k[l>>2]=k[e>>2];k[l+4>>2]=k[e+4>>2];k[l+8>>2]=k[e+8>>2];k[l+12>>2]=k[e+12>>2];k[e>>2]=k[f>>2];k[e+4>>2]=k[f+4>>2];k[e+8>>2]=k[f+8>>2];k[e+12>>2]=k[f+12>>2];k[f>>2]=k[l>>2];k[f+4>>2]=k[l+4>>2];k[f+8>>2]=k[l+8>>2];k[f+12>>2]=k[l+12>>2];l=1;r=m;return l|0}case 4:{yXa(a,a+16|0,a+32|0,b+-16|0)|0;l=1;r=m;return l|0}case 5:{f=a+16|0;g=a+32|0;c=a+48|0;yXa(a,f,g,c)|0;d=a+60|0;if(!(+o[b+-4>>2]<+o[d>>2])){l=1;r=m;return l|0}e=b+-16|0;k[l>>2]=k[c>>2];k[l+4>>2]=k[c+4>>2];k[l+8>>2]=k[c+8>>2];k[l+12>>2]=k[c+12>>2];k[c>>2]=k[e>>2];k[c+4>>2]=k[e+4>>2];k[c+8>>2]=k[e+8>>2];k[c+12>>2]=k[e+12>>2];k[e>>2]=k[l>>2];k[e+4>>2]=k[l+4>>2];k[e+8>>2]=k[l+8>>2];k[e+12>>2]=k[l+12>>2];e=a+44|0;if(!(+o[d>>2]<+o[e>>2])){l=1;r=m;return l|0};k[l>>2]=k[g>>2];k[l+4>>2]=k[g+4>>2];k[l+8>>2]=k[g+8>>2];k[l+12>>2]=k[g+12>>2];k[g>>2]=k[c>>2];k[g+4>>2]=k[c+4>>2];k[g+8>>2]=k[c+8>>2];k[g+12>>2]=k[c+12>>2];k[c>>2]=k[l>>2];k[c+4>>2]=k[l+4>>2];k[c+8>>2]=k[l+8>>2];k[c+12>>2]=k[l+12>>2];c=a+28|0;if(!(+o[e>>2]<+o[c>>2])){l=1;r=m;return l|0};k[l>>2]=k[f>>2];k[l+4>>2]=k[f+4>>2];k[l+8>>2]=k[f+8>>2];k[l+12>>2]=k[f+12>>2];k[f>>2]=k[g>>2];k[f+4>>2]=k[g+4>>2];k[f+8>>2]=k[g+8>>2];k[f+12>>2]=k[g+12>>2];k[g>>2]=k[l>>2];k[g+4>>2]=k[l+4>>2];k[g+8>>2]=k[l+8>>2];k[g+12>>2]=k[l+12>>2];if(!(+o[c>>2]<+o[a+12>>2])){l=1;r=m;return l|0};k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2];k[l+8>>2]=k[a+8>>2];k[l+12>>2]=k[a+12>>2];k[a>>2]=k[f>>2];k[a+4>>2]=k[f+4>>2];k[a+8>>2]=k[f+8>>2];k[a+12>>2]=k[f+12>>2];k[f>>2]=k[l>>2];k[f+4>>2]=k[l+4>>2];k[f+8>>2]=k[l+8>>2];k[f+12>>2]=k[l+12>>2];l=1;r=m;return l|0}case 1:case 0:{l=1;r=m;return l|0}default:{d=a+32|0;c=a+16|0;e=a+28|0;n=+o[e>>2];i=+o[a+12>>2];j=+o[a+44>>2];f=j<n;do if(n<i){if(f){k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2];k[l+8>>2]=k[a+8>>2];k[l+12>>2]=k[a+12>>2];k[a>>2]=k[d>>2];k[a+4>>2]=k[d+4>>2];k[a+8>>2]=k[d+8>>2];k[a+12>>2]=k[d+12>>2];k[d>>2]=k[l>>2];k[d+4>>2]=k[l+4>>2];k[d+8>>2]=k[l+8>>2];k[d+12>>2]=k[l+12>>2];break};k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2];k[l+8>>2]=k[a+8>>2];k[l+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[l>>2];k[c+4>>2]=k[l+4>>2];k[c+8>>2]=k[l+8>>2];k[c+12>>2]=k[l+12>>2];if(j<+o[e>>2]){k[l>>2]=k[c>>2];k[l+4>>2]=k[c+4>>2];k[l+8>>2]=k[c+8>>2];k[l+12>>2]=k[c+12>>2];k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];k[d>>2]=k[l>>2];k[d+4>>2]=k[l+4>>2];k[d+8>>2]=k[l+8>>2];k[d+12>>2]=k[l+12>>2]}}else if(f?(k[l>>2]=k[c>>2],k[l+4>>2]=k[c+4>>2],k[l+8>>2]=k[c+8>>2],k[l+12>>2]=k[c+12>>2],k[c>>2]=k[d>>2],k[c+4>>2]=k[d+4>>2],k[c+8>>2]=k[d+8>>2],k[c+12>>2]=k[d+12>>2],k[d>>2]=k[l>>2],k[d+4>>2]=k[l+4>>2],k[d+8>>2]=k[l+8>>2],k[d+12>>2]=k[l+12>>2],+o[e>>2]<i):0){k[l>>2]=k[a>>2];k[l+4>>2]=k[a+4>>2];k[l+8>>2]=k[a+8>>2];k[l+12>>2]=k[a+12>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[c>>2]=k[l>>2];k[c+4>>2]=k[l+4>>2];k[c+8>>2]=k[l+8>>2];k[c+12>>2]=k[l+12>>2]}while(0);c=a+48|0;a:do if((c|0)==(b|0)){d=1;c=0}else{e=0;while(1){i=+o[c+12>>2];if(i<+o[d+12>>2]){k[l>>2]=k[c>>2];k[l+4>>2]=k[c+4>>2];k[l+8>>2]=k[c+8>>2];f=c;while(1){k[f>>2]=k[d>>2];k[f+4>>2]=k[d+4>>2];k[f+8>>2]=k[d+8>>2];k[f+12>>2]=k[d+12>>2];if((d|0)==(a|0)){f=a;break}if(i<+o[d+-4>>2]){f=d;d=d+-16|0}else{f=d;break}}k[d>>2]=k[l>>2];k[d+4>>2]=k[l+4>>2];k[d+8>>2]=k[l+8>>2];o[f+12>>2]=i;d=e+1|0;f=c+16|0;if((d|0)==8){d=0;c=(f|0)==(b|0);break a}else{e=d;d=f}}else d=c+16|0;if((d|0)==(b|0)){d=1;c=0;break}else{h=c;c=d;d=h}}}while(0);l=c|d;r=m;return l|0}}return 0}function AXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;k[a>>2]=0;h=a+4|0;k[h>>2]=0;k[a+8>>2]=0;g=b+4|0;c=(k[g>>2]|0)-(k[b>>2]|0)|0;f=c>>4;if(!f)return;if(f>>>0>268435455)ad(426534,426557,304,426811);d=(c|0)==0?1:c;while(1){c=fgb(d)|0;if(c|0){e=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){e=0;break}Qh[c&7]()}k[h>>2]=e;k[a>>2]=e;k[a+8>>2]=e+(f<<4);d=k[b>>2]|0;c=(k[g>>2]|0)-d|0;if((c|0)<=0)return;upb(e|0,d|0,c|0)|0;k[h>>2]=e+(c>>4<<4);return}function BXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=a+8|0;i=k[a>>2]|0;if((k[h>>2]|0)-i>>4>>>0>=b>>>0)return;j=a+4|0;g=(k[j>>2]|0)-i|0;f=g>>4;if(!b)c=0;else{if(b>>>0>268435455){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=b<<4;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(f<<4)|0;d=e+(0-f<<4)|0;if((g|0)>0)upb(d|0,i|0,g|0)|0;k[a>>2]=d;k[j>>2]=e;k[h>>2]=c+(b<<4);if(!i)return;ggb(i);return}function CXa(a){a=a|0;ggb(a);return}function DXa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function EXa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=142920;k[a+52>>2]=142752;b=k[a+112>>2]|0;c=b;if(b|0){d=a+116|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+92|0;b=k[d>>2]|0;if(b|0?(h=b+12|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+88>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;i=a+72|0;c=a+60|0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+96>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+100>>2]|0;if(!((b|0)==(a+104|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=a+44|0;c=k[b>>2]|0;if(c|0?(h=c+4|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+48>>2]=0;b=a+36|0;c=k[b>>2]|0;if(c|0?(h=c+4|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+40>>2]=0;b=a+28|0;c=k[b>>2]|0;if(c|0?(h=c+4|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+32>>2]=0;k[a>>2]=142772;f=a+16|0;g=k[f>>2]|0;if(!g){a=a+4|0;zF(a);return}h=a+20|0;while(1){i=k[h>>2]|0;if((i|0)==(g|0))break;k[h>>2]=i+-48;e=i+-24|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}d=i+-44|0;if((k[d>>2]|0)>0){c=k[i+-16>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}k[e>>2]=0;b=k[i+-12>>2]|0;if((b|0)==(i+-8|0)|(b|0)==0)continue;ggb(k[b+-4>>2]|0)}ggb(k[f>>2]|0);a=a+4|0;zF(a);return}function FXa(a){a=a|0;EXa(a);ggb(a);return}function GXa(a){a=a|0;var b=0,c=0,d=0,e=0;jXa(a);b=k[a+112>>2]|0;c=a+116|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);d=a+92|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+88>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+72|0;c=a+60|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+96>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=a+44|0;c=k[b>>2]|0;if(!c){k[b>>2]=0;d=a+48|0;k[d>>2]=0;a=a+124|0;k[a>>2]=0;return}e=c+4|0;d=k[e>>2]|0;k[e>>2]=d+-1;if((d|0)!=1){k[b>>2]=0;e=a+48|0;k[e>>2]=0;e=a+124|0;k[e>>2]=0;return}Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;e=a+48|0;k[e>>2]=0;e=a+124|0;k[e>>2]=0;return}function HXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;A=r;r=r+64|0;z=A;y=A+44|0;w=A+32|0;x=A+20|0;v=A+8|0;e=z+4|0;f=ZT(16)|0;k[f>>2]=1;c=f+4|0;k[z>>2]=c;k[e>>2]=11;i[f+15>>0]=0;f=389315;g=c+11|0;do{i[c>>0]=i[f>>0]|0;c=c+1|0;f=f+1|0}while((c|0)<(g|0));c=z6(b,z)|0;d=k[z>>2]|0;k[e>>2]=0;k[z>>2]=0;if(d|0?(t=d+-4|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0)ggb(k[d+-8>>2]|0);k[z>>2]=0;u=z+4|0;k[u>>2]=0;s=ZT(8)|0;k[s>>2]=1;t=s+4|0;k[z>>2]=t;k[u>>2]=1;i[s+5>>0]=0;i[t>>0]=91;z6(c,z)|0;c=k[z>>2]|0;k[u>>2]=0;k[z>>2]=0;if(c|0?(t=c+-4|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0)ggb(k[c+-8>>2]|0);c=k[a+32>>2]|0;if(c|0){k[y>>2]=0;u=y+4|0;k[u>>2]=0;k[y+8>>2]=0;k[w>>2]=0;t=w+4|0;k[t>>2]=0;k[w+8>>2]=0;k[x>>2]=0;s=x+4|0;k[s>>2]=0;k[x+8>>2]=0;k[v>>2]=0;q=v+4|0;k[q>>2]=0;k[v+8>>2]=0;xQa(c,y,w,x,v);a:do if((k[u>>2]|0)!=(k[y>>2]|0)){f=z+4|0;g=z+4|0;h=z+4|0;l=z+4|0;m=z+4|0;n=z+4|0;e=0;while(1){k[z>>2]=0;k[f>>2]=0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[z>>2]=c;k[f>>2]=1;i[d+5>>0]=0;i[c>>0]=123;c=z6(b,z)|0;d=k[z>>2]|0;k[f>>2]=0;k[z>>2]=0;if(d|0?(C=d+-4|0,B=k[C>>2]|0,k[C>>2]=B+-1,(B|0)==1):0)ggb(k[d+-8>>2]|0);k[z>>2]=0;k[g>>2]=0;C=ZT(12)|0;k[C>>2]=1;d=C+4|0;k[z>>2]=d;k[g>>2]=4;i[C+8>>0]=0;i[d>>0]=110;i[d+1>>0]=97;i[d+2>>0]=109;i[d+3>>0]=101;c=z6(c,z)|0;d=k[z>>2]|0;k[g>>2]=0;k[z>>2]=0;if(d|0?(B=d+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[d+-8>>2]|0);c=z6(c,(k[y>>2]|0)+(e<<3)|0)|0;k[z>>2]=0;k[h>>2]=0;C=ZT(12)|0;k[C>>2]=1;d=C+4|0;k[z>>2]=d;k[h>>2]=4;i[C+8>>0]=0;i[d>>0]=116;i[d+1>>0]=121;i[d+2>>0]=112;i[d+3>>0]=101;c=z6(c,z)|0;d=k[z>>2]|0;k[h>>2]=0;k[z>>2]=0;if(d|0?(B=d+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[d+-8>>2]|0);c=ZXa(c,(k[w>>2]|0)+(e<<2)|0)|0;k[z>>2]=0;k[l>>2]=0;B=ZT(12)|0;k[B>>2]=1;C=B+4|0;k[z>>2]=C;k[l>>2]=5;i[B+9>>0]=0;i[C>>0]=i[389389]|0;i[C+1>>0]=i[389390]|0;i[C+2>>0]=i[389391]|0;i[C+3>>0]=i[389392]|0;i[C+4>>0]=i[389393]|0;z6(c,z)|0;c=k[z>>2]|0;k[l>>2]=0;k[z>>2]=0;if(c|0?(B=c+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[c+-8>>2]|0);switch(k[(k[w>>2]|0)+(e<<2)>>2]|0){case 0:{i[z>>0]=~~+p[(k[v>>2]|0)+(e<<3)>>3];_Xa(b,z);break}case 1:{i[z>>0]=~~+p[(k[v>>2]|0)+(e<<3)>>3];$Xa(b,z);break}case 2:{j[z>>1]=~~+p[(k[v>>2]|0)+(e<<3)>>3];aYa(b,z);break}case 3:{j[z>>1]=~~+p[(k[v>>2]|0)+(e<<3)>>3];bYa(b,z);break}case 23:case 15:case 4:{k[z>>2]=~~+p[(k[v>>2]|0)+(e<<3)>>3];ZXa(b,z)|0;break}case 5:{o[z>>2]=+p[(k[v>>2]|0)+(e<<3)>>3];cYa(b,z);break}case 6:{p[z>>3]=+p[(k[v>>2]|0)+(e<<3)>>3];dYa(b,z);break}case 7:{z6(b,(k[x>>2]|0)+(e<<3)|0)|0;break}default:{p[z>>3]=+p[(k[v>>2]|0)+(e<<3)>>3];dYa(b,z);k[z>>2]=0;k[m>>2]=0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[z>>2]=c;k[m>>2]=8;i[d+12>>0]=0;d=c;i[d>>0]=116;i[d+1>>0]=121;i[d+2>>0]=112;i[d+3>>0]=101;c=c+4|0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;c=z6(b,z)|0;d=k[z>>2]|0;k[m>>2]=0;k[z>>2]=0;if(d|0?(B=d+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[d+-8>>2]|0);z6(c,(k[x>>2]|0)+(e<<3)|0)|0}}k[z>>2]=0;k[n>>2]=0;C=ZT(8)|0;k[C>>2]=1;c=C+4|0;k[z>>2]=c;k[n>>2]=1;i[C+5>>0]=0;i[c>>0]=125;z6(b,z)|0;c=k[z>>2]|0;k[n>>2]=0;k[z>>2]=0;if(c|0?(B=c+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[c+-8>>2]|0);e=e+1|0;if(e>>>0>=(k[u>>2]|0)-(k[y>>2]|0)>>3>>>0)break a}}while(0);c=k[v>>2]|0;d=c;if(c|0){e=k[q>>2]|0;if((e|0)!=(c|0))k[q>>2]=e+(~((e+-8-d|0)>>>3)<<3);ggb(c)}c=k[x>>2]|0;if(c|0){while(1){d=k[s>>2]|0;if((d|0)==(c|0))break;C=d+-8|0;k[s>>2]=C;e=k[C>>2]|0;k[d+-4>>2]=0;k[C>>2]=0;if(!e)continue;B=e+-4|0;C=k[B>>2]|0;k[B>>2]=C+-1;if((C|0)!=1)continue;ggb(k[e+-8>>2]|0)}ggb(k[x>>2]|0)}c=k[w>>2]|0;d=c;if(c|0){e=k[t>>2]|0;if((e|0)!=(c|0))k[t>>2]=e+(~((e+-4-d|0)>>>2)<<2);ggb(c)}c=k[y>>2]|0;if(c|0){while(1){d=k[u>>2]|0;if((d|0)==(c|0))break;C=d+-8|0;k[u>>2]=C;e=k[C>>2]|0;k[d+-4>>2]=0;k[C>>2]=0;if(!e)continue;B=e+-4|0;C=k[B>>2]|0;k[B>>2]=C+-1;if((C|0)!=1)continue;ggb(k[e+-8>>2]|0)}ggb(k[y>>2]|0)}}k[z>>2]=0;C=z+4|0;k[C>>2]=0;c=ZT(8)|0;k[c>>2]=1;d=c+4|0;k[z>>2]=d;k[C>>2]=1;i[c+5>>0]=0;i[d>>0]=93;d=z6(b,z)|0;c=k[z>>2]|0;k[C>>2]=0;k[z>>2]=0;if(c|0?(B=c+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[c+-8>>2]|0);k[z>>2]=0;e=z+4|0;k[e>>2]=0;f=ZT(20)|0;k[f>>2]=1;c=f+4|0;k[z>>2]=c;k[e>>2]=12;i[f+16>>0]=0;f=389395;g=c+12|0;do{i[c>>0]=i[f>>0]|0;c=c+1|0;f=f+1|0}while((c|0)<(g|0));c=z6(d,z)|0;d=k[z>>2]|0;k[e>>2]=0;k[z>>2]=0;if(d|0?(B=d+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[d+-8>>2]|0);k[z>>2]=0;C=z+4|0;k[C>>2]=0;u=ZT(8)|0;k[u>>2]=1;B=u+4|0;k[z>>2]=B;k[C>>2]=1;i[u+5>>0]=0;i[B>>0]=91;z6(c,z)|0;c=k[z>>2]|0;k[C>>2]=0;k[z>>2]=0;if(c|0?(B=c+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[c+-8>>2]|0);c=k[a+40>>2]|0;if(c|0){k[y>>2]=0;u=y+4|0;k[u>>2]=0;k[y+8>>2]=0;k[w>>2]=0;t=w+4|0;k[t>>2]=0;k[w+8>>2]=0;k[x>>2]=0;s=x+4|0;k[s>>2]=0;k[x+8>>2]=0;k[v>>2]=0;q=v+4|0;k[q>>2]=0;k[v+8>>2]=0;xQa(c,y,w,x,v);b:do if((k[u>>2]|0)!=(k[y>>2]|0)){f=z+4|0;g=z+4|0;h=z+4|0;l=z+4|0;m=z+4|0;n=z+4|0;e=0;while(1){k[z>>2]=0;k[f>>2]=0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[z>>2]=c;k[f>>2]=1;i[d+5>>0]=0;i[c>>0]=123;c=z6(b,z)|0;d=k[z>>2]|0;k[f>>2]=0;k[z>>2]=0;if(d|0?(B=d+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[d+-8>>2]|0);k[z>>2]=0;k[g>>2]=0;C=ZT(12)|0;k[C>>2]=1;d=C+4|0;k[z>>2]=d;k[g>>2]=4;i[C+8>>0]=0;i[d>>0]=110;i[d+1>>0]=97;i[d+2>>0]=109;i[d+3>>0]=101;c=z6(c,z)|0;d=k[z>>2]|0;k[g>>2]=0;k[z>>2]=0;if(d|0?(B=d+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[d+-8>>2]|0);c=z6(c,(k[y>>2]|0)+(e<<3)|0)|0;k[z>>2]=0;k[h>>2]=0;C=ZT(12)|0;k[C>>2]=1;d=C+4|0;k[z>>2]=d;k[h>>2]=4;i[C+8>>0]=0;i[d>>0]=116;i[d+1>>0]=121;i[d+2>>0]=112;i[d+3>>0]=101;c=z6(c,z)|0;d=k[z>>2]|0;k[h>>2]=0;k[z>>2]=0;if(d|0?(B=d+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[d+-8>>2]|0);c=ZXa(c,(k[w>>2]|0)+(e<<2)|0)|0;k[z>>2]=0;k[l>>2]=0;B=ZT(12)|0;k[B>>2]=1;C=B+4|0;k[z>>2]=C;k[l>>2]=5;i[B+9>>0]=0;i[C>>0]=i[389389]|0;i[C+1>>0]=i[389390]|0;i[C+2>>0]=i[389391]|0;i[C+3>>0]=i[389392]|0;i[C+4>>0]=i[389393]|0;z6(c,z)|0;c=k[z>>2]|0;k[l>>2]=0;k[z>>2]=0;if(c|0?(B=c+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[c+-8>>2]|0);switch(k[(k[w>>2]|0)+(e<<2)>>2]|0){case 0:{i[z>>0]=~~+p[(k[v>>2]|0)+(e<<3)>>3];_Xa(b,z);break}case 1:{i[z>>0]=~~+p[(k[v>>2]|0)+(e<<3)>>3];$Xa(b,z);break}case 2:{j[z>>1]=~~+p[(k[v>>2]|0)+(e<<3)>>3];aYa(b,z);break}case 3:{j[z>>1]=~~+p[(k[v>>2]|0)+(e<<3)>>3];bYa(b,z);break}case 23:case 15:case 4:{k[z>>2]=~~+p[(k[v>>2]|0)+(e<<3)>>3];ZXa(b,z)|0;break}case 5:{o[z>>2]=+p[(k[v>>2]|0)+(e<<3)>>3];cYa(b,z);break}case 6:{p[z>>3]=+p[(k[v>>2]|0)+(e<<3)>>3];dYa(b,z);break}case 7:{z6(b,(k[x>>2]|0)+(e<<3)|0)|0;break}default:{p[z>>3]=+p[(k[v>>2]|0)+(e<<3)>>3];dYa(b,z);k[z>>2]=0;k[m>>2]=0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[z>>2]=c;k[m>>2]=8;i[d+12>>0]=0;d=c;i[d>>0]=116;i[d+1>>0]=121;i[d+2>>0]=112;i[d+3>>0]=101;c=c+4|0;i[c>>0]=110;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=101;c=z6(b,z)|0;d=k[z>>2]|0;k[m>>2]=0;k[z>>2]=0;if(d|0?(B=d+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[d+-8>>2]|0);z6(c,(k[x>>2]|0)+(e<<3)|0)|0}}k[z>>2]=0;k[n>>2]=0;C=ZT(8)|0;k[C>>2]=1;c=C+4|0;k[z>>2]=c;k[n>>2]=1;i[C+5>>0]=0;i[c>>0]=125;z6(b,z)|0;c=k[z>>2]|0;k[n>>2]=0;k[z>>2]=0;if(c|0?(B=c+-4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)ggb(k[c+-8>>2]|0);e=e+1|0;if(e>>>0>=(k[u>>2]|0)-(k[y>>2]|0)>>3>>>0)break b}}while(0);c=k[v>>2]|0;d=c;if(c|0){e=k[q>>2]|0;if((e|0)!=(c|0))k[q>>2]=e+(~((e+-8-d|0)>>>3)<<3);ggb(c)}c=k[x>>2]|0;if(c|0){while(1){d=k[s>>2]|0;if((d|0)==(c|0))break;C=d+-8|0;k[s>>2]=C;e=k[C>>2]|0;k[d+-4>>2]=0;k[C>>2]=0;if(!e)continue;B=e+-4|0;C=k[B>>2]|0;k[B>>2]=C+-1;if((C|0)!=1)continue;ggb(k[e+-8>>2]|0)}ggb(k[x>>2]|0)}c=k[w>>2]|0;d=c;if(c|0){e=k[t>>2]|0;if((e|0)!=(c|0))k[t>>2]=e+(~((e+-4-d|0)>>>2)<<2);ggb(c)}c=k[y>>2]|0;if(c|0){while(1){d=k[u>>2]|0;if((d|0)==(c|0))break;C=d+-8|0;k[u>>2]=C;e=k[C>>2]|0;k[d+-4>>2]=0;k[C>>2]=0;if(!e)continue;B=e+-4|0;C=k[B>>2]|0;k[B>>2]=C+-1;if((C|0)!=1)continue;ggb(k[e+-8>>2]|0)}ggb(k[y>>2]|0)}}C=z+4|0;B=ZT(8)|0;k[B>>2]=1;c=B+4|0;k[z>>2]=c;k[C>>2]=1;i[B+5>>0]=0;i[c>>0]=93;z6(b,z)|0;c=k[z>>2]|0;k[C>>2]=0;k[z>>2]=0;if(!c){r=A;return}B=c+-4|0;C=k[B>>2]|0;k[B>>2]=C+-1;if((C|0)!=1){r=A;return}ggb(k[c+-8>>2]|0);r=A;return}function IXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=r;r=r+16|0;D=F;E=F+8|0;h=a+28|0;v=a+32|0;if(!(k[v>>2]|0)){while(1){c=fgb(4)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}while(1){d=fgb(12)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}C=d+4|0;k[C>>2]=0;k[d+8>>2]=0;k[d>>2]=C;k[c>>2]=d;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=143024;k[d+8>>2]=c;k[e>>2]=(k[e>>2]|0)+1;f=k[h>>2]|0;k[h>>2]=d;k[v>>2]=c;if(f|0?(B=f+4|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0)Uh[k[(k[f>>2]|0)+8>>2]&2047](f);C=k[e>>2]|0;k[e>>2]=C+-1;if((C|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d)}B=k[b>>2]|0;t=b+4|0;A=k6(B,k[t>>2]|0,389315)|0;C=(A|0)==0;if(!C?(k[A>>2]&7|0)==5:0)z=23;else{c=D+4|0;d=ZT(32)|0;k[d>>2]=1;e=d+4|0;k[D>>2]=e;k[c>>2]=26;i[d+30>>0]=0;f=389327;h=e+26|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(h|0));Y8(-215,D,401059,388491,1076);k[c>>2]=0;k[D>>2]=0;z=k[d>>2]|0;k[d>>2]=z+-1;if((z|0)==1)ggb(k[d+-4>>2]|0);if(C){c=1;z=27}else z=23}a:do if((z|0)==23){c=k[A>>2]|0;switch(c&7){case 6:{c=k[(k[A+8>>2]|0)+60>>2]|0;break a}case 5:{c=k[(k[A+8>>2]|0)+24>>2]|0;break a}default:{c=(c&7|0)==0;z=27;break a}}}while(0);if((z|0)==27)c=c&1^1;if((c|0)>0){l=E+4|0;m=D+4|0;n=D+4|0;q=A;s=A+8|0;j=0;do{if(!C?(k[A>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=35;else c=0}else{c=j;z=35}if((z|0)==35){d=k[f+52>>2]|0;if((c<<1|0)<=(e|0)){e=k[d+12>>2]|0;if((c|0)>=(e|0))do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}z=43}else if(!j){c=q;z=43}else z=45;if((z|0)==43){z=0;if(!((c|0)!=0?(k[c>>2]&7|0)==6:0))z=45}if((z|0)==45){z=0;c=ZT(36)|0;k[c>>2]=1;e=c+4|0;k[D>>2]=e;k[n>>2]=29;i[c+33>>0]=0;f=389354;h=e+29|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(h|0));Y8(-215,D,401059,388491,1080);k[n>>2]=0;k[D>>2]=0;y=k[c>>2]|0;k[c>>2]=y+-1;if((y|0)==1)ggb(k[c+-4>>2]|0)}if(!C?(k[A>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=52;else c=0}else{c=j;z=52}if((z|0)==52){z=0;d=k[f+52>>2]|0;if((c<<1|0)<=(e|0)){e=k[d+12>>2]|0;if((c|0)>=(e|0))do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?q:0}y=k6(d,c,401026)|0;k[E>>2]=0;k[l>>2]=0;J6(y,E,E);if(!C?(k[A>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=64;else c=0}else{c=j;z=64}if((z|0)==64){z=0;d=k[f+52>>2]|0;if((c<<1|0)<=(e|0)){e=k[d+12>>2]|0;if((c|0)>=(e|0))do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?q:0}c=k6(d,c,389384)|0;b:do if(!c)z=80;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break}case 2:{g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;y=c&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}c=~~g;break}default:break b}switch(c|0){case 4:case 3:case 2:case 1:case 0:{z=80;break b}case 5:{h=k[v>>2]|0;if(!C?(k[A>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=104;else c=0}else{c=j;z=104}if((z|0)==104){z=0;d=k[f+52>>2]|0;if((c<<1|0)<=(e|0)){e=k[d+12>>2]|0;if((c|0)>=(e|0))do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?q:0}c=k6(d,c,389389)|0;c:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break c}case 2:{g=+p[c+8>>3];break c}default:{g=1000000015047466219876688.0e6;break c}}while(0);o[D>>2]=g;x=WHa(k[h>>2]|0,E)|0;w=k[x>>2]|0;y=x+4|0;jh[k[k[w>>2]>>2]&1023](w,y);k[x>>2]=428716;Ph[k[(k[107179]|0)+4>>2]&511](428716,D,y);break b}case 6:{h=k[v>>2]|0;if(!C?(k[A>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=121;else c=0}else{c=j;z=121}if((z|0)==121){z=0;d=k[f+52>>2]|0;if((c<<1|0)<=(e|0)){e=k[d+12>>2]|0;if((c|0)>=(e|0))do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?q:0}c=k6(d,c,389389)|0;d:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break d}case 2:{g=+p[c+8>>3];break d}default:{g=1.e+300;break d}}while(0);p[D>>3]=g;x=WHa(k[h>>2]|0,E)|0;w=k[x>>2]|0;y=x+4|0;jh[k[k[w>>2]>>2]&1023](w,y);k[x>>2]=827108;Ph[k[(k[206777]|0)+4>>2]&511](827108,D,y);break b}case 7:{h=k[v>>2]|0;if(!C?(k[A>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=138;else c=0}else{c=j;z=138}if((z|0)==138){z=0;d=k[f+52>>2]|0;if((c<<1|0)<=(e|0)){e=k[d+12>>2]|0;if((c|0)>=(e|0))do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?q:0}y=k6(d,c,389389)|0;k[D>>2]=0;k[m>>2]=0;J6(y,D,D);y=WHa(k[h>>2]|0,E)|0;x=k[y>>2]|0;c=y+4|0;jh[k[k[x>>2]>>2]&1023](x,c);k[y>>2]=428736;Ph[k[(k[107184]|0)+4>>2]&511](428736,D,c);c=k[D>>2]|0;k[m>>2]=0;k[D>>2]=0;if(c|0?(x=c+-4|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0)ggb(k[c+-8>>2]|0);break b}case 15:{h=k[v>>2]|0;if(!C?(k[A>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=154;else c=0}else{c=j;z=154}if((z|0)==154){z=0;d=k[f+52>>2]|0;if((c<<1|0)<=(e|0)){e=k[d+12>>2]|0;if((c|0)>=(e|0))do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?q:0}c=k6(d,c,389389)|0;e:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break e}case 2:break;default:{c=2147483647;break e}}g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;y=c&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}c=~~g}while(0);i[D>>0]=(c|0)!=0&1;x=WHa(k[h>>2]|0,E)|0;w=k[x>>2]|0;y=x+4|0;jh[k[k[w>>2]>>2]&1023](w,y);k[x>>2]=428720;Ph[k[(k[107180]|0)+4>>2]&511](428720,D,y);break b}case 23:{h=k[v>>2]|0;if(!C?(k[A>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=174;else c=0}else{c=j;z=174}if((z|0)==174){z=0;d=k[f+52>>2]|0;if((c<<1|0)<=(e|0)){e=k[d+12>>2]|0;if((c|0)>=(e|0))do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?q:0}c=k6(d,c,389389)|0;f:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break f}case 2:break;default:{c=2147483647;break f}}g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;y=c&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}c=~~g}while(0);wQa(h,c);break b}default:break b}}while(0);if((z|0)==80){z=0;h=k[v>>2]|0;if(!C?(k[A>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=84;else c=0}else{c=j;z=84}if((z|0)==84){z=0;d=k[f+52>>2]|0;if((c<<1|0)<=(e|0)){e=k[d+12>>2]|0;if((c|0)>=(e|0))do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?q:0}c=k6(d,c,389389)|0;g:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break g}case 2:break;default:{c=2147483647;break g}}g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;y=c&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}c=~~g}while(0);k[D>>2]=c;x=WHa(k[h>>2]|0,E)|0;w=k[x>>2]|0;y=x+4|0;jh[k[k[w>>2]>>2]&1023](w,y);k[x>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,D,y)}c=k[E>>2]|0;k[l>>2]=0;k[E>>2]=0;if(c|0?(x=c+-4|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0)ggb(k[c+-8>>2]|0);j=j+1|0;h:do if(C){c=1;z=198}else{c=k[A>>2]|0;switch(c&7){case 6:{c=k[(k[s>>2]|0)+60>>2]|0;break h}case 5:{c=k[(k[s>>2]|0)+24>>2]|0;break h}default:{c=(c&7|0)==0;z=198;break h}}}while(0);if((z|0)==198){z=0;c=c&1^1}}while((j|0)<(c|0))}h=a+36|0;y=a+40|0;if(!(k[y>>2]|0)){while(1){c=fgb(4)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}zQa(c,32,0.0,1);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=143044;k[d+8>>2]=c;k[e>>2]=(k[e>>2]|0)+1;f=k[h>>2]|0;k[h>>2]=d;k[y>>2]=c;if(f|0?(x=f+4|0,z=k[x>>2]|0,k[x>>2]=z+-1,(z|0)==1):0)Uh[k[(k[f>>2]|0)+8>>2]&2047](f);z=k[e>>2]|0;k[e>>2]=z+-1;if((z|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d)}w=k[b>>2]|0;b=k6(w,k[t>>2]|0,389395)|0;x=(b|0)==0;if(!x?(k[b>>2]&7|0)==5:0)z=217;else{c=D+4|0;d=ZT(32)|0;k[d>>2]=1;e=d+4|0;k[D>>2]=e;k[c>>2]=26;i[d+30>>0]=0;f=389408;h=e+26|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(h|0));Y8(-215,D,401059,388491,1115);k[c>>2]=0;k[D>>2]=0;z=k[d>>2]|0;k[d>>2]=z+-1;if((z|0)==1)ggb(k[d+-4>>2]|0);if(x){c=1;z=221}else z=217}i:do if((z|0)==217){c=k[b>>2]|0;switch(c&7){case 6:{c=k[(k[b+8>>2]|0)+60>>2]|0;break i}case 5:{c=k[(k[b+8>>2]|0)+24>>2]|0;break i}default:{c=(c&7|0)==0;z=221;break i}}}while(0);if((z|0)==221)c=c&1^1;if((c|0)>0){l=E+4|0;m=D+4|0;n=D+4|0;q=b;s=b+8|0;t=A;v=A+8|0;j=0;do{if(!x?(k[b>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=232;else c=0}else{c=j;z=232}if((z|0)==232){d=k[f+52>>2]|0;if((c<<1|0)<=(e|0)){e=k[d+12>>2]|0;if((c|0)>=(e|0))do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}z=240}else if(!j){c=q;z=240}else z=242;if((z|0)==240){z=0;if(!((c|0)!=0?(k[c>>2]&7|0)==6:0))z=242}if((z|0)==242){z=0;c=ZT(36)|0;k[c>>2]=1;e=c+4|0;k[D>>2]=e;k[n>>2]=29;i[c+33>>0]=0;f=389435;h=e+29|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(h|0));Y8(-215,D,401059,388491,1119);k[n>>2]=0;k[D>>2]=0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0)}if(!x?(k[b>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=249;else c=0}else{c=j;z=249}if((z|0)==249){z=0;d=k[f+52>>2]|0;if((c<<1|0)<=(e|0)){e=k[d+12>>2]|0;if((c|0)>=(e|0))do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=w}else{c=(j|0)==0;d=c?w:0;c=c?q:0}h=k6(d,c,401026)|0;k[E>>2]=0;k[l>>2]=0;J6(h,E,E);if(!x?(k[b>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=261;else c=0}else{c=j;z=261}if((z|0)==261){z=0;d=k[f+52>>2]|0;if((c<<1|0)<=(e|0)){e=k[d+12>>2]|0;if((c|0)>=(e|0))do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}else{do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=w}else{c=(j|0)==0;d=c?w:0;c=c?q:0}c=k6(d,c,389384)|0;j:do if(!c)z=277;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break}case 2:{g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;h=c&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}c=~~g;break}default:break j}switch(c|0){case 4:case 3:case 2:case 1:case 0:{z=277;break j}case 5:{h=k[y>>2]|0;if(!C?(k[A>>2]&7|0)==5:0){f=k[v>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=301;else c=0}else{c=j;z=301}if((z|0)==301){z=0;d=k[f+52>>2]|0;do if((c<<1|0)>(e|0)){do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}else{e=k[d+12>>2]|0;if((c|0)<(e|0))break;do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}while(0);c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?t:0}c=k6(d,c,389389)|0;k:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break k}case 2:{g=+p[c+8>>3];break k}default:{g=1000000015047466219876688.0e6;break k}}while(0);o[D>>2]=g;f=WHa(k[h>>2]|0,E)|0;e=k[f>>2]|0;h=f+4|0;jh[k[k[e>>2]>>2]&1023](e,h);k[f>>2]=428716;Ph[k[(k[107179]|0)+4>>2]&511](428716,D,h);break j}case 6:{h=k[y>>2]|0;if(!C?(k[A>>2]&7|0)==5:0){f=k[v>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=318;else c=0}else{c=j;z=318}if((z|0)==318){z=0;d=k[f+52>>2]|0;do if((c<<1|0)>(e|0)){do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}else{e=k[d+12>>2]|0;if((c|0)<(e|0))break;do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}while(0);c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?t:0}c=k6(d,c,389389)|0;l:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break l}case 2:{g=+p[c+8>>3];break l}default:{g=1.e+300;break l}}while(0);p[D>>3]=g;f=WHa(k[h>>2]|0,E)|0;e=k[f>>2]|0;h=f+4|0;jh[k[k[e>>2]>>2]&1023](e,h);k[f>>2]=827108;Ph[k[(k[206777]|0)+4>>2]&511](827108,D,h);break j}case 7:{h=k[y>>2]|0;if(!C?(k[A>>2]&7|0)==5:0){f=k[v>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=335;else c=0}else{c=j;z=335}if((z|0)==335){z=0;d=k[f+52>>2]|0;do if((c<<1|0)>(e|0)){do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}else{e=k[d+12>>2]|0;if((c|0)<(e|0))break;do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}while(0);c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?t:0}f=k6(d,c,389389)|0;k[D>>2]=0;k[m>>2]=0;J6(f,D,D);h=WHa(k[h>>2]|0,E)|0;f=k[h>>2]|0;c=h+4|0;jh[k[k[f>>2]>>2]&1023](f,c);k[h>>2]=428736;Ph[k[(k[107184]|0)+4>>2]&511](428736,D,c);c=k[D>>2]|0;k[m>>2]=0;k[D>>2]=0;if(c|0?(f=c+-4|0,h=k[f>>2]|0,k[f>>2]=h+-1,(h|0)==1):0)ggb(k[c+-8>>2]|0);break j}case 15:{h=k[y>>2]|0;if(!C?(k[A>>2]&7|0)==5:0){f=k[v>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=351;else c=0}else{c=j;z=351}if((z|0)==351){z=0;d=k[f+52>>2]|0;do if((c<<1|0)>(e|0)){do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}else{e=k[d+12>>2]|0;if((c|0)<(e|0))break;do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}while(0);c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?t:0}c=k6(d,c,389389)|0;m:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break m}case 2:break;default:{c=2147483647;break m}}g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}c=~~g}while(0);i[D>>0]=(c|0)!=0&1;f=WHa(k[h>>2]|0,E)|0;e=k[f>>2]|0;h=f+4|0;jh[k[k[e>>2]>>2]&1023](e,h);k[f>>2]=428720;Ph[k[(k[107180]|0)+4>>2]&511](428720,D,h);break j}case 23:{h=k[y>>2]|0;if(!C?(k[A>>2]&7|0)==5:0){f=k[v>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=371;else c=0}else{c=j;z=371}if((z|0)==371){z=0;d=k[f+52>>2]|0;do if((c<<1|0)>(e|0)){do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}else{e=k[d+12>>2]|0;if((c|0)<(e|0))break;do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}while(0);c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=B}else{c=(j|0)==0;d=c?B:0;c=c?t:0}c=k6(d,c,389389)|0;n:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break n}case 2:break;default:{c=2147483647;break n}}g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}c=~~g}while(0);wQa(h,c);break j}default:break j}}while(0);if((z|0)==277){z=0;h=k[y>>2]|0;if(!x?(k[b>>2]&7|0)==5:0){f=k[s>>2]|0;e=k[f+24>>2]|0;if(e>>>0<=j>>>0){c=j-((j|0)>=(e|0)?e:0)|0;if(c>>>0<e>>>0)z=281;else c=0}else{c=j;z=281}if((z|0)==281){z=0;d=k[f+52>>2]|0;do if((c<<1|0)>(e|0)){do{d=k[d>>2]|0;e=e-(k[d+12>>2]|0)|0}while((c|0)<(e|0));c=c-e|0}else{e=k[d+12>>2]|0;if((c|0)<(e|0))break;do{d=k[d+4>>2]|0;c=c-e|0;e=k[d+12>>2]|0}while((c|0)>=(e|0))}while(0);c=(k[d+16>>2]|0)+(aa(k[f+28>>2]|0,c)|0)|0}d=w}else{c=(j|0)==0;d=c?w:0;c=c?q:0}c=k6(d,c,389389)|0;o:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break o}case 2:break;default:{c=2147483647;break o}}g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;f=c&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}c=~~g}while(0);k[D>>2]=c;f=WHa(k[h>>2]|0,E)|0;e=k[f>>2]|0;h=f+4|0;jh[k[k[e>>2]>>2]&1023](e,h);k[f>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,D,h)}c=k[E>>2]|0;k[l>>2]=0;k[E>>2]=0;if(c|0?(f=c+-4|0,h=k[f>>2]|0,k[f>>2]=h+-1,(h|0)==1):0)ggb(k[c+-8>>2]|0);j=j+1|0;p:do if(x){c=1;z=395}else{c=k[b>>2]|0;switch(c&7){case 6:{c=k[(k[s>>2]|0)+60>>2]|0;break p}case 5:{c=k[(k[s>>2]|0)+24>>2]|0;break p}default:{c=(c&7|0)==0;z=395;break p}}}while(0);if((z|0)==395){z=0;c=c&1^1}}while((j|0)<(c|0))}c=a+44|0;d=k[c>>2]|0;if(!d){k[c>>2]=0;a=a+48|0;k[a>>2]=0;r=F;return}D=d+4|0;E=k[D>>2]|0;k[D>>2]=E+-1;if((E|0)!=1){k[c>>2]=0;a=a+48|0;k[a>>2]=0;r=F;return}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);k[c>>2]=0;a=a+48|0;k[a>>2]=0;r=F;return}function JXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+16|0;i=l;nXa(a,b);k[i>>2]=0;j=i+4|0;k[j>>2]=0;k[i+8>>2]=0;C2(b,i);c=k[j>>2]|0;g=k[i>>2]|0;h=g;e=c;b=g;if((c|0)!=(g|0)){f=a+124|0;c=(c-g|0)/48|0;a=0;d=k[f>>2]|0;do{d=d+(k[h+(a*48|0)+8>>2]|0)|0;a=a+1|0}while(a>>>0<c>>>0);k[f>>2]=d}if(!g){r=l;return}if((e|0)!=(h|0)){do{k[j>>2]=e+-48;d=e+-24|0;b=k[d>>2]|0;if(b|0?(f=b+8|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){g=k[d>>2]|0;f=k[g+4>>2]|0;jh[k[(k[f>>2]|0)+16>>2]&1023](f,g);k[d>>2]=0}a=e+-44|0;if((k[a>>2]|0)>0){c=k[e+-16>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}k[d>>2]=0;b=k[e+-12>>2]|0;if(!((b|0)==(e+-8|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=k[j>>2]|0}while((e|0)!=(h|0));b=k[i>>2]|0}ggb(b);r=l;return}function KXa(a){a=a|0;return 0}function LXa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;L=r;r=r+128|0;I=L+64|0;G=L+56|0;H=L;J=a+44|0;K=a+48|0;if(k[K>>2]|0?(k[a+64>>2]|0)>=(k[a+124>>2]|0):0){r=L;return}e=a+16|0;d=k[e>>2]|0;f=a+20|0;D=k[f>>2]|0;c=D;b=d;F=a+4|0;B=a+8|0;if((d|0)!=(D|0)){if((k[B>>2]|0)==(k[F>>2]|0))A=f;else{b=I+4|0;c=ZT(36)|0;k[c>>2]=1;g=c+4|0;k[I>>2]=g;k[b>>2]=31;i[c+35>>0]=0;h=389120;j=g+31|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,I,389152,388491,1061);k[b>>2]=0;k[I>>2]=0;D=k[c>>2]|0;k[c>>2]=D+-1;if((D|0)==1)ggb(k[c+-4>>2]|0);d=k[e>>2]|0;A=f;c=k[f>>2]|0;b=d}if((c|0)!=(b|0)){m=a+12|0;n=I+36|0;o=I+16|0;p=I+4|0;q=I+40|0;s=I+44|0;t=I+48|0;u=I+8|0;v=I+12|0;w=I+20|0;x=I+24|0;y=I+28|0;z=I+32|0;l=0;do{x9(I,d+(l*48|0)|0,16777216);b=k[B>>2]|0;if((b|0)==(k[m>>2]|0))Doa(F,I);else{k[b>>2]=k[I>>2];j=b+4|0;k[j>>2]=k[p>>2];D=b+8|0;k[D>>2]=k[u>>2];k[b+12>>2]=k[v>>2];k[b+16>>2]=k[o>>2];k[b+20>>2]=k[w>>2];k[b+24>>2]=k[x>>2];k[b+28>>2]=k[y>>2];k[b+32>>2]=k[z>>2];c=k[n>>2]|0;k[b+36>>2]=c;d=b+40|0;k[d>>2]=D;D=b+48|0;g=b+44|0;k[g>>2]=D;k[b+52>>2]=0;k[D>>2]=0;if(c|0){D=c+12|0;k[D>>2]=(k[D>>2]|0)+1}if((k[p>>2]|0)>=3){k[j>>2]=0;x1(b,k[p>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[q>>2]|0;d=k[d>>2]|0;f=k[s>>2]|0;c=k[g>>2]|0;b=0;do{k[d+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else{j=k[s>>2]|0;D=k[g>>2]|0;k[D>>2]=k[j>>2];k[D+4>>2]=k[j+4>>2]}k[B>>2]=(k[B>>2]|0)+56}b=k[n>>2]|0;if(b|0?(j=b+12|0,D=k[j>>2]|0,k[j>>2]=D+-1,(D|0)==1):0){c=k[n>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[z>>2]|0;if(!b){b=B1()|0;c=k[n>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[n>>2]=0}k[n>>2]=0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[p>>2]|0)>0){c=k[q>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[p>>2]|0))}b=k[s>>2]|0;if(!((b|0)==(t|0)|(b|0)==0))ggb(k[b+-4>>2]|0);l=l+1|0;d=k[e>>2]|0}while(l>>>0<(((k[A>>2]|0)-d|0)/48|0)>>>0);b=F}else b=F}else b=F;n=a+52|0;Uh[k[(k[n>>2]|0)+8>>2]&2047](n);n=(k[B>>2]|0)-(k[b>>2]|0)|0;D=(n|0)/56|0;o=(n|0)==0;if(o){b=I+4|0;c=ZT(20)|0;k[c>>2]=1;g=c+4|0;k[I>>2]=g;k[b>>2]=14;i[c+18>>0]=0;h=389228;j=g+14|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,I,389243,388491,416);k[b>>2]=0;k[I>>2]=0;B=k[c>>2]|0;k[c>>2]=B+-1;if((B|0)==1)ggb(k[c+-4>>2]|0)}B=a+112|0;c=a+116|0;e=k[c>>2]|0;b=k[B>>2]|0;d=e-b>>2;if(D>>>0<=d>>>0){if(D>>>0<d>>>0?(C=b+(D<<2)|0,(e|0)!=(C|0)):0)k[c>>2]=e+(~((e+-4-C|0)>>>2)<<2)}else{U1(B,D-d|0);b=k[B>>2]|0}k[b>>2]=0;if(D>>>0>1){l=k[F>>2]|0;j=1;c=-1;d=-1;do{m=j+-1|0;if(k[l+(m*56|0)+16>>2]|0){g=k[l+(m*56|0)+4>>2]|0;if((g|0)<3)e=aa(k[l+(m*56|0)+12>>2]|0,k[l+(m*56|0)+8>>2]|0)|0;else{h=k[l+(m*56|0)+40>>2]|0;f=0;e=1;do{e=aa(k[h+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(g|0))}if(e){e=k[l+(m*56|0)+8>>2]|0;c=k[l+(m*56|0)>>2]&4095;d=k[l+(m*56|0)+12>>2]|0}else e=0}else e=0;k[b+(j<<2)>>2]=(k[b+(m<<2)>>2]|0)+e;j=j+1|0}while((j|0)!=(D|0))}else{c=-1;d=-1}if((n|0)==56){g=k[F>>2]|0;if(k[g+16>>2]|0){e=k[g+4>>2]|0;if((e|0)<3)c=aa(k[g+12>>2]|0,k[g+8>>2]|0)|0;else{f=k[g+40>>2]|0;d=0;c=1;do{c=aa(k[f+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(e|0))}if(c|0){A=k[g>>2]&4095;d=k[g+12>>2]|0;E=63}}}else{A=c;E=63}if((E|0)==63){if((d|0)<=0){E=I+4|0;b=ZT(12)|0;k[b>>2]=1;C=b+4|0;k[I>>2]=C;k[E>>2]=7;i[b+11>>0]=0;i[C>>0]=i[389247]|0;i[C+1>>0]=i[389248]|0;i[C+2>>0]=i[389249]|0;i[C+3>>0]=i[389250]|0;i[C+4>>0]=i[389251]|0;i[C+5>>0]=i[389252]|0;i[C+6>>0]=i[389253]|0;Y8(-215,I,389243,388491,441);k[E>>2]=0;k[I>>2]=0;E=k[b>>2]|0;k[b>>2]=E+-1;if((E|0)==1)ggb(k[b+-4>>2]|0);b=k[B>>2]|0}E=D+-1|0;b=(k[(k[F>>2]|0)+(E*56|0)+8>>2]|0)+(k[b+(E<<2)>>2]|0)|0;if((b|0)>0){z=a+56|0;c=A&4095;if(!(((((k[a+60>>2]|0)<3?(k[a+64>>2]|0)==(b|0):0)?(k[a+68>>2]|0)==(d|0):0)?(k[z>>2]&4095|0)==(c|0):0)?(k[a+72>>2]|0)!=0:0)){k[I>>2]=b;k[I+4>>2]=d;G1(z,2,I,c)}if(!o){m=I+4|0;n=G+4|0;o=I+4|0;p=o+4|0;q=H+36|0;s=H+16|0;t=H+4|0;u=H+40|0;v=H+44|0;w=H+48|0;x=I+4|0;y=H+32|0;l=0;do{b=k[F>>2]|0;if(k[b+(l*56|0)+16>>2]|0){f=k[b+(l*56|0)+4>>2]|0;if((f|0)<3)c=aa(k[b+(l*56|0)+12>>2]|0,k[b+(l*56|0)+8>>2]|0)|0;else{g=k[b+(l*56|0)+40>>2]|0;e=0;c=1;do{c=aa(k[g+(e<<2)>>2]|0,c)|0;e=e+1|0}while((e|0)!=(f|0))}if(c|0){if(!((k[b+(l*56|0)+12>>2]|0)==(d|0)?(k[b+(l*56|0)>>2]&4095|0)==(A|0):0)){b=ZT(64)|0;k[b>>2]=1;g=b+4|0;k[I>>2]=g;k[x>>2]=59;i[b+63>>0]=0;h=389255;j=g+59|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,I,389243,388491,452);k[x>>2]=0;k[I>>2]=0;E=k[b>>2]|0;k[b>>2]=E+-1;if((E|0)==1)ggb(k[b+-4>>2]|0);b=k[F>>2]|0}E=k[(k[B>>2]|0)+(l<<2)>>2]|0;b=(k[b+(l*56|0)+8>>2]|0)+E|0;k[I>>2]=E;k[m>>2]=b;k[G>>2]=-2147483648;k[n>>2]=2147483647;H1(H,z,I,G);b=(k[F>>2]|0)+(l*56|0)|0;E=p;k[E>>2]=0;k[E+4>>2]=0;k[I>>2]=33619968;k[o>>2]=H;mY(b,I);b=k[q>>2]|0;if(b|0?(C=b+12|0,E=k[C>>2]|0,k[C>>2]=E+-1,(E|0)==1):0){c=k[q>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[y>>2]|0;if(b|0)break;b=B1()|0;c=k[q>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[q>>2]=0}k[q>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[t>>2]|0)>0){c=k[u>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[t>>2]|0))}b=k[v>>2]|0;if(!((b|0)==(w|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}}l=l+1|0}while(l>>>0<D>>>0)}}}d=a+56|0;c=k[a+32>>2]|0;while(1){b=fgb(20)|0;if(b|0){e=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){e=0;break}Qh[b&7]()}k[I+8>>2]=0;k[I+12>>2]=0;k[I>>2]=16842752;k[I+4>>2]=d;k[e>>2]=93156;k[e+16>>2]=0;k[e+12>>2]=5;k[e+8>>2]=0;k[e+4>>2]=1;OHa(e,I,c,1);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}c=b+4|0;k[c>>2]=1;k[b>>2]=143004;k[b+8>>2]=e;k[c>>2]=(k[c>>2]|0)+1;d=k[J>>2]|0;k[J>>2]=b;k[K>>2]=e;if(d|0?(J=d+4|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);K=k[c>>2]|0;k[c>>2]=K+-1;if((K|0)!=1){r=L;return}Uh[k[(k[b>>2]|0)+8>>2]&2047](b);r=L;return}function MXa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;S=r;r=r+144|0;P=S+128|0;Q=S+72|0;R=S;e=b+28|0;f=b+36|0;while(1){d=fgb(128)|0;if(d|0){L=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){L=0;break}Qh[d&7]()}QXa(L,e,f);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}M=d+4|0;k[M>>2]=1;k[d>>2]=142984;k[d+8>>2]=L;N=d;O=L;if(!c){k[P>>2]=0;e=P+4|0;k[e>>2]=0;f=ZT(112)|0;k[f>>2]=1;g=f+4|0;k[P>>2]=g;k[e>>2]=107;i[f+111>>0]=0;c=388884;j=g+107|0;do{i[g>>0]=i[c>>0]|0;g=g+1|0;c=c+1|0}while((g|0)<(j|0));Y8(-213,P,388992,388491,1270);k[e>>2]=0;k[P>>2]=0;K=k[f>>2]|0;k[f>>2]=K+-1;if((K|0)==1)ggb(k[f+-4>>2]|0);k[L+124>>2]=k[b+124>>2];k[R>>2]=142752;n=R+4|0;k[n>>2]=1124007936;s=R+8|0;e=R+12|0;p=R+44|0;g=s;j=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[p>>2]=e;t=R+52|0;q=R+48|0;k[q>>2]=t;m=R+60|0;o=R+64|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;k[t+16>>2]=0;f=b+56|0;k[Q>>2]=1124007936;l=Q+4|0;e=Q+8|0;h=Q+40|0;g=l;j=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[h>>2]=e;j=Q+48|0;g=Q+44|0;k[g>>2]=j;k[Q+52>>2]=0;k[j>>2]=0;c=P+4|0;e=c+4|0;k[e>>2]=0;k[e+4>>2]=0;k[P>>2]=33619968;k[c>>2]=Q;mY(f,P);KG(n,Q)|0;c=Q+36|0;e=k[c>>2]|0;if(e|0?(J=e+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){f=k[c>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[Q+32>>2]|0;if(!e){e=B1()|0;f=k[c>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[c>>2]=0}k[c>>2]=0;K=Q+16|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[l>>2]|0)>0){f=k[h>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[l>>2]|0))}e=k[g>>2]|0;if(!((e|0)==(j|0)|(e|0)==0))ggb(k[e+-4>>2]|0);KG(L+56|0,n)|0;dQ(L+112|0,k[m>>2]|0,k[o>>2]|0);k[R>>2]=142752;e=k[m>>2]|0;f=e;if(e|0){c=k[o>>2]|0;if((c|0)!=(e|0))k[o>>2]=c+(~((c+-4-f|0)>>>2)<<2);ggb(e)}c=R+40|0;e=k[c>>2]|0;if(e|0?(J=e+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){f=k[c>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[R+36>>2]|0;if(!e){e=B1()|0;f=k[c>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[c>>2]=0}k[c>>2]=0;K=R+20|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[s>>2]|0)>0){f=k[p>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[s>>2]|0))}e=k[q>>2]|0;if(!((e|0)==(t|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[b+4>>2]|0;m=k[b+8>>2]|0;if((e|0)!=(m|0)){n=R+4|0;o=R+8|0;p=R+12|0;q=R+16|0;s=R+20|0;t=R+24|0;b=R+28|0;u=R+32|0;v=R+36|0;w=R+40|0;x=R+48|0;y=R+44|0;z=R+52|0;A=Q+36|0;B=Q+16|0;C=Q+4|0;D=Q+40|0;E=Q+44|0;F=Q+48|0;G=Q+8|0;H=Q+52|0;I=P+4|0;J=I+4|0;K=Q+32|0;l=k[L+4>>2]|0;while(1){k[R>>2]=k[e>>2];f=e+4|0;k[n>>2]=k[f>>2];k[o>>2]=k[e+8>>2];k[p>>2]=k[e+12>>2];k[q>>2]=k[e+16>>2];k[s>>2]=k[e+20>>2];k[t>>2]=k[e+24>>2];k[b>>2]=k[e+28>>2];k[u>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[v>>2]=c;k[w>>2]=o;k[y>>2]=x;k[z>>2]=0;k[x>>2]=0;if(c|0){L=c+12|0;k[L>>2]=(k[L>>2]|0)+1}if((k[f>>2]|0)>=3){k[n>>2]=0;x1(R,k[f>>2]|0,0,0,0);if((k[n>>2]|0)>0){c=k[e+40>>2]|0;g=k[w>>2]|0;h=k[e+44>>2]|0;j=k[y>>2]|0;f=0;do{k[g+(f<<2)>>2]=k[c+(f<<2)>>2];k[j+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[n>>2]|0))}}else{j=k[e+44>>2]|0;L=k[y>>2]|0;k[L>>2]=k[j>>2];k[L+4>>2]=k[j+4>>2]}k[Q>>2]=1124007936;g=C;j=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[D>>2]=G;k[E>>2]=F;k[H>>2]=0;k[F>>2]=0;f=J;k[f>>2]=0;k[f+4>>2]=0;k[P>>2]=33619968;k[I>>2]=Q;mY(R,P);KG(l,Q)|0;f=k[A>>2]|0;if(f|0?(j=f+12|0,L=k[j>>2]|0,k[j>>2]=L+-1,(L|0)==1):0){c=k[A>>2]|0;if(c|0){f=k[c+4>>2]|0;do if(!f){f=k[K>>2]|0;if(f|0)break;f=B1()|0;c=k[A>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,c)}k[A>>2]=0}k[A>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[C>>2]|0)>0){c=k[D>>2]|0;f=0;do{k[c+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[C>>2]|0))}f=k[E>>2]|0;if(!((f|0)==(F|0)|(f|0)==0))ggb(k[f+-4>>2]|0);f=k[v>>2]|0;do if(f|0){j=f+12|0;L=k[j>>2]|0;k[j>>2]=L+-1;if((L|0)!=1)break;c=k[v>>2]|0;if(c|0){f=k[c+4>>2]|0;do if(!f){f=k[u>>2]|0;if(f|0)break;f=B1()|0;c=k[v>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,c)}k[v>>2]=0}while(0);k[v>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[n>>2]|0)>0){c=k[w>>2]|0;f=0;do{k[c+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[n>>2]|0))}f=k[y>>2]|0;if(!((f|0)==(x|0)|(f|0)==0))ggb(k[f+-4>>2]|0);e=e+56|0;if((e|0)==(m|0))break;else l=l+56|0}}}k[a>>2]=N;k[a+4>>2]=O;k[M>>2]=(k[M>>2]|0)+1;R=k[M>>2]|0;k[M>>2]=R+-1;if((R|0)!=1){r=S;return}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);r=S;return}function NXa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+224|0;p=x+200|0;w=x+144|0;v=x+88|0;u=x+32|0;n=x+16|0;o=x;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[w>>2]=k[g>>2];l=w+4|0;e=g+4|0;k[l>>2]=k[e>>2];m=w+8|0;k[m>>2]=k[g+8>>2];k[w+12>>2]=k[g+12>>2];k[w+16>>2]=k[g+16>>2];k[w+20>>2]=k[g+20>>2];k[w+24>>2]=k[g+24>>2];k[w+28>>2]=k[g+28>>2];k[w+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[w+36>>2]=f;b=w+40|0;k[b>>2]=m;t=w+48|0;i=w+44|0;k[i>>2]=t;k[w+52>>2]=0;k[t>>2]=0;if(f|0){t=f+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[e>>2]|0)<3){t=k[g+44>>2]|0;b=k[i>>2]|0;k[b>>2]=k[t>>2];k[b+4>>2]=k[t+4>>2];b=m;break}k[l>>2]=0;x1(w,k[e>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[b>>2]|0;b=k[g+44>>2]|0;f=k[i>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[j+(e<<2)>>2];k[f+(e<<2)>>2]=k[b+(e<<2)>>2];e=e+1|0}while((e|0)<(k[l>>2]|0));b=m}else b=m}else{Q1(w,b,-1);b=w+8|0}while(0);f=k[b>>2]|0;k[v>>2]=1124007936;s=v+4|0;e=v+8|0;m=v+40|0;h=s;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[m>>2]=e;t=v+48|0;q=v+44|0;k[q>>2]=t;k[v+52>>2]=0;k[t>>2]=0;k[p>>2]=f;g=p+4|0;k[g>>2]=d;G1(v,2,p,4);f=k[b>>2]|0;k[u>>2]=1124007936;l=u+4|0;e=u+8|0;j=u+40|0;h=l;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[j>>2]=e;i=u+48|0;h=u+44|0;k[h>>2]=i;k[u+52>>2]=0;k[i>>2]=0;k[p>>2]=f;k[g>>2]=d;G1(u,2,p,5);b=k[a+48>>2]|0;e=k[(k[b>>2]|0)+12>>2]|0;k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=w;g=n+4|0;f=g+4|0;k[f>>2]=0;k[f+4>>2]=0;k[n>>2]=33619968;k[g>>2]=v;g=o+4|0;f=g+4|0;k[f>>2]=0;k[f+4>>2]=0;k[o>>2]=33619968;k[g>>2]=u;Lg[e&255](b,p,n,o,d,k[a+40>>2]|0);PXa(a+52|0,v,u,c);b=u+36|0;e=k[b>>2]|0;if(e|0?(c=e+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){f=k[b>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[u+32>>2]|0;if(!e){e=B1()|0;f=k[b>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[b>>2]=0}k[b>>2]=0;u=u+16|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[l>>2]|0)>0){f=k[j>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[l>>2]|0))}e=k[h>>2]|0;if(!((e|0)==(i|0)|(e|0)==0))ggb(k[e+-4>>2]|0);b=v+36|0;e=k[b>>2]|0;if(e|0?(d=e+12|0,u=k[d>>2]|0,k[d>>2]=u+-1,(u|0)==1):0){f=k[b>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[v+32>>2]|0;if(!e){e=B1()|0;f=k[b>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[b>>2]=0}k[b>>2]=0;v=v+16|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[s>>2]|0)>0){f=k[m>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[s>>2]|0))}e=k[q>>2]|0;if(!((e|0)==(t|0)|(e|0)==0))ggb(k[e+-4>>2]|0);b=w+36|0;e=k[b>>2]|0;if(e|0?(u=e+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){f=k[b>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[w+32>>2]|0;if(!e){e=B1()|0;f=k[b>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[b>>2]=0}k[b>>2]=0;v=w+16|0;f=w+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[f>>2]|0)>0){b=k[w+40>>2]|0;e=0;do{k[b+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[w+44>>2]|0;if((e|0)==(w+48|0)|(e|0)==0){r=x;return}ggb(k[e+-4>>2]|0);r=x;return}function OXa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;ka=r;r=r+400|0;ba=ka+384|0;ca=ka;ja=ka+328|0;ia=ka+272|0;ha=ka+216|0;Z=ka+160|0;_=ka+104|0;$=ka+48|0;aa=ka+32|0;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[ja>>2]=k[g>>2];l=ja+4|0;e=g+4|0;k[l>>2]=k[e>>2];m=ja+8|0;k[m>>2]=k[g+8>>2];k[ja+12>>2]=k[g+12>>2];k[ja+16>>2]=k[g+16>>2];k[ja+20>>2]=k[g+20>>2];k[ja+24>>2]=k[g+24>>2];k[ja+28>>2]=k[g+28>>2];k[ja+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[ja+36>>2]=f;b=ja+40|0;k[b>>2]=m;ga=ja+48|0;i=ja+44|0;k[i>>2]=ga;k[ja+52>>2]=0;k[ga>>2]=0;if(f|0){ga=f+12|0;k[ga>>2]=(k[ga>>2]|0)+1}if((k[e>>2]|0)<3){fa=k[g+44>>2]|0;ga=k[i>>2]|0;k[ga>>2]=k[fa>>2];k[ga+4>>2]=k[fa+4>>2];break}k[l>>2]=0;x1(ja,k[e>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[b>>2]|0;b=k[g+44>>2]|0;f=k[i>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[j+(e<<2)>>2];k[f+(e<<2)>>2]=k[b+(e<<2)>>2];e=e+1|0}while((e|0)<(k[l>>2]|0))}}else{Q1(ja,b,-1);m=ja+8|0}while(0);T=a+52|0;U=k[a+64>>2]|0;f=k[m>>2]|0;p[ca>>3]=-1.0;p[ca+8>>3]=-1.0;p[ca+16>>3]=-1.0;p[ca+24>>3]=-1.0;k[ia>>2]=1124007936;fa=ia+4|0;e=ia+8|0;da=ia+40|0;g=fa;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[da>>2]=e;ga=ia+48|0;ea=ia+44|0;k[ea>>2]=ga;k[ia+52>>2]=0;k[ga>>2]=0;k[ba>>2]=f;f=ba+4|0;k[f>>2]=U;G1(ia,2,ba,4);oY(ia,ca);b=k[m>>2]|0;p[ca>>3]=-1.0;p[ca+8>>3]=-1.0;p[ca+16>>3]=-1.0;p[ca+24>>3]=-1.0;k[ha>>2]=1124007936;Y=ha+4|0;e=ha+8|0;W=ha+40|0;g=Y;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[W>>2]=e;X=ha+48|0;V=ha+44|0;k[V>>2]=X;k[ha+52>>2]=0;k[X>>2]=0;k[ba>>2]=b;k[f>>2]=U;G1(ha,2,ba,5);oY(ha,ca);if((k[m>>2]|0)>0){F=ba+4|0;G=ca+4|0;H=ba+4|0;I=ca+4|0;J=ba+4|0;K=ca+4|0;L=a+48|0;M=ba+8|0;N=ba+12|0;O=ba+4|0;P=ca+4|0;Q=P+4|0;R=aa+4|0;S=R+4|0;d=d*d;g=a+40|0;h=$+36|0;i=$+16|0;j=$+4|0;l=$+40|0;a=$+44|0;n=$+48|0;o=_+36|0;q=_+16|0;s=_+4|0;t=_+40|0;u=_+44|0;v=_+48|0;w=Z+36|0;x=Z+16|0;y=Z+4|0;z=Z+40|0;A=Z+44|0;B=Z+48|0;C=Z+32|0;D=_+32|0;E=$+32|0;b=0;do{e=b;b=b+1|0;k[ba>>2]=e;k[F>>2]=b;k[ca>>2]=-2147483648;k[G>>2]=2147483647;H1(Z,ja,ba,ca);k[ba>>2]=e;k[H>>2]=b;k[ca>>2]=-2147483648;k[I>>2]=2147483647;H1(_,ia,ba,ca);k[ba>>2]=e;k[J>>2]=b;k[ca>>2]=-2147483648;k[K>>2]=2147483647;H1($,ha,ba,ca);e=k[L>>2]|0;f=k[(k[e>>2]|0)+16>>2]|0;k[M>>2]=0;k[N>>2]=0;k[ba>>2]=16842752;k[O>>2]=Z;la=Q;k[la>>2]=0;k[la+4>>2]=0;k[ca>>2]=33619968;k[P>>2]=_;la=S;k[la>>2]=0;k[la+4>>2]=0;k[aa>>2]=33619968;k[R>>2]=$;oi[f&3](e,ba,ca,aa,d,U,k[g>>2]|0)|0;e=k[h>>2]|0;if(e|0?(f=e+12|0,la=k[f>>2]|0,k[f>>2]=la+-1,(la|0)==1):0){f=k[h>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[E>>2]|0;if(!e){e=B1()|0;f=k[h>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[h>>2]=0}k[h>>2]=0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;if((k[j>>2]|0)>0){f=k[l>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[j>>2]|0))}e=k[a>>2]|0;if(!((e|0)==(n|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[o>>2]|0;if(e|0?(f=e+12|0,la=k[f>>2]|0,k[f>>2]=la+-1,(la|0)==1):0){f=k[o>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[D>>2]|0;if(!e){e=B1()|0;f=k[o>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[o>>2]=0}k[o>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[s>>2]|0)>0){f=k[t>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[s>>2]|0))}e=k[u>>2]|0;if(!((e|0)==(v|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[w>>2]|0;if(e|0?(f=e+12|0,la=k[f>>2]|0,k[f>>2]=la+-1,(la|0)==1):0){f=k[w>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[C>>2]|0;if(!e){e=B1()|0;f=k[w>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[w>>2]=0}k[w>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[y>>2]|0)>0){f=k[z>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[y>>2]|0))}e=k[A>>2]|0;if(!((e|0)==(B|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}while((b|0)<(k[m>>2]|0))}PXa(T,ia,ha,c);b=ha+36|0;e=k[b>>2]|0;if(e|0?(c=e+12|0,la=k[c>>2]|0,k[c>>2]=la+-1,(la|0)==1):0){f=k[b>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[ha+32>>2]|0;if(!e){e=B1()|0;f=k[b>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[b>>2]=0}k[b>>2]=0;la=ha+16|0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[Y>>2]|0)>0){f=k[W>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[Y>>2]|0))}e=k[V>>2]|0;if(!((e|0)==(X|0)|(e|0)==0))ggb(k[e+-4>>2]|0);b=ia+36|0;e=k[b>>2]|0;if(e|0?(ha=e+12|0,la=k[ha>>2]|0,k[ha>>2]=la+-1,(la|0)==1):0){f=k[b>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[ia+32>>2]|0;if(!e){e=B1()|0;f=k[b>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[b>>2]=0}k[b>>2]=0;la=ia+16|0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[fa>>2]|0)>0){f=k[da>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[fa>>2]|0))}e=k[ea>>2]|0;if(!((e|0)==(ga|0)|(e|0)==0))ggb(k[e+-4>>2]|0);b=ja+36|0;e=k[b>>2]|0;if(e|0?(ia=e+12|0,la=k[ia>>2]|0,k[ia>>2]=la+-1,(la|0)==1):0){f=k[b>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[ja+32>>2]|0;if(!e){e=B1()|0;f=k[b>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[b>>2]=0}k[b>>2]=0;la=ja+16|0;f=ja+4|0;k[la>>2]=0;k[la+4>>2]=0;k[la+8>>2]=0;k[la+12>>2]=0;if((k[f>>2]|0)>0){b=k[ja+40>>2]|0;e=0;do{k[b+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[ja+44>>2]|0;if((e|0)==(ja+48|0)|(e|0)==0){r=ka;return}ggb(k[e+-4>>2]|0);r=ka;return}function PXa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0.0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;E=r;r=r+16|0;C=E;D=b+8|0;h=k[D>>2]|0;m=d+4|0;g=k[m>>2]|0;f=k[d>>2]|0;e=(g-f|0)/12|0;if(h>>>0<=e>>>0){if(h>>>0<e>>>0?(l=f+(h*12|0)|0,(g|0)!=(l|0)):0)while(1){e=g+-12|0;k[m>>2]=e;h=k[e>>2]|0;j=h;if(h){e=g+-8|0;f=k[e>>2]|0;if((f|0)!=(h|0))k[e>>2]=f+(~((f+-16-j|0)>>>4)<<4);ggb(h);e=k[m>>2]|0}if((e|0)==(l|0))break;else g=e}}else wXa(d,h-e|0);f=k[D>>2]|0;if((f|0)<=0){r=E;return}A=b+12|0;B=b+16|0;s=b+44|0;t=c+16|0;u=c+44|0;v=C+4|0;w=C+8|0;x=C+12|0;y=a+12|0;z=a+60|0;p=a+64|0;q=C+4|0;a=0;e=k[A>>2]|0;do{if((e|0)>0){b=0;do{m=(k[B>>2]|0)+(aa(k[k[s>>2]>>2]|0,a)|0)+(b<<2)|0;m=k[m>>2]|0;if((m|0)>-1){if((k[y>>2]|0)<=(m|0)){e=ZT(52)|0;k[e>>2]=1;f=e+4|0;k[C>>2]=f;k[q>>2]=46;i[e+50>>0]=0;g=388825;h=f+46|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,C,388872,388491,488);k[q>>2]=0;k[C>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}l=k[z>>2]|0;e=(k[p>>2]|0)-l>>2;f=l;if(!e)e=f;else{j=e;e=f;while(1){F=(j|0)/2|0;h=f+(F<<2)|0;g=(k[h>>2]|0)>(m|0);h=h+4|0;e=g?e:h;j=g?F:j+-1-F|0;if(!j)break;else f=g?f:h}}h=e+-4|0;f=m-(k[h>>2]|0)|0;e=(k[t>>2]|0)+(aa(k[k[u>>2]>>2]|0,a)|0)|0;if((k[c>>2]&4095|0)==4)n=+(k[e+(b<<2)>>2]|0);else n=+Q(+(+o[e+(b<<2)>>2]));g=k[d>>2]|0;k[C>>2]=a;k[v>>2]=f;k[w>>2]=h-l>>2;o[x>>2]=n;e=g+(a*12|0)+4|0;f=k[e>>2]|0;if((f|0)==(k[g+(a*12|0)+8>>2]|0))I6(g+(a*12|0)|0,C);else{k[f>>2]=k[C>>2];k[f+4>>2]=k[C+4>>2];k[f+8>>2]=k[C+8>>2];k[f+12>>2]=k[C+12>>2];k[e>>2]=(k[e>>2]|0)+16}e=k[A>>2]|0}b=b+1|0}while((b|0)<(e|0));f=k[D>>2]|0}a=a+1|0}while((a|0)<(f|0));r=E;return}function QXa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;d=a+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[a>>2]=142920;d=k[b>>2]|0;k[a+28>>2]=d;e=b+4|0;k[a+32>>2]=k[e>>2];if(d|0){h=d+4|0;k[h>>2]=(k[h>>2]|0)+1}b=k[c>>2]|0;k[a+36>>2]=b;f=c+4|0;k[a+40>>2]=k[f>>2];if(b|0){h=b+4|0;k[h>>2]=(k[h>>2]|0)+1}k[a+44>>2]=0;k[a+48>>2]=0;k[a+52>>2]=142752;k[a+56>>2]=1124007936;b=a+64|0;d=a+96|0;g=a+60|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[d>>2]=b;h=a+104|0;k[a+100>>2]=h;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;if(!(k[e>>2]|0)){k[j>>2]=0;b=j+4|0;k[b>>2]=0;d=ZT(20)|0;k[d>>2]=1;g=d+4|0;k[j>>2]=g;k[b>>2]=12;i[d+16>>0]=0;c=389075;h=g+12|0;do{i[g>>0]=i[c>>0]|0;g=g+1|0;c=c+1|0}while((g|0)<(h|0));Y8(-215,j,389088,388491,1028);k[b>>2]=0;k[j>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(k[f>>2]|0){r=l;return}k[j>>2]=0;b=j+4|0;k[b>>2]=0;d=ZT(20)|0;k[d>>2]=1;g=d+4|0;k[j>>2]=g;k[b>>2]=13;i[d+17>>0]=0;c=389106;h=g+13|0;do{i[g>>0]=i[c>>0]|0;g=g+1|0;c=c+1|0}while((g|0)<(h|0));Y8(-215,j,389088,388491,1029);k[b>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);r=l;return}function RXa(a){a=a|0;ggb(a);return}function SXa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function TXa(a){a=a|0;ggb(a);return}function UXa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function VXa(a){a=a|0;ggb(a);return}function WXa(a){a=a|0;var b=0,c=0;b=k[a+8>>2]|0;if(b|0){c=k[b>>2]|0;YHa(k[c+4>>2]|0);ggb(c);ggb(b)}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function XXa(a){a=a|0;ggb(a);return}function YXa(a){a=a|0;var b=0,c=0;b=k[a+8>>2]|0;if(b|0){c=k[b>>2]|0;YHa(k[c+4>>2]|0);ggb(c);ggb(b)}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function ZXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function _Xa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0;m=r;r=r+16|0;e=m;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=m;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,l[b>>0]|0);if(!(k[j>>2]&4)){r=m;return}k[j>>2]=6;r=m;return}function $Xa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,i[b>>0]|0);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function aYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,m[b>>1]|0);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function bYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,m=0;m=r;r=r+16|0;e=m;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=m;return}l=a+32|0;if((k[l>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,j[b>>1]|0);if(!(k[l>>2]&4)){r=m;return}k[l>>2]=6;r=m;return}function cYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+o[b>>2]);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function dYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+p[b>>3]);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function eYa(a){a=a|0;return a+4|0}function fYa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+32|0;m=p+16|0;n=p;k[n>>2]=0;o=n+4|0;k[o>>2]=0;k[n+8>>2]=0;if(!(Xh[k[(k[a>>2]|0)+20>>2]&1023](a)|0)?!(G2(b)|0):0){R1(m,b,-1);gYa(a,d,k[m+4>>2]|0);Uh[k[(k[a>>2]|0)+40>>2]&2047](a);Lg[k[(k[a>>2]|0)+48>>2]&255](a,b,n,1,d,1)}a=k[c>>2]|0;l=c+4|0;b=k[l>>2]|0;if((b|0)!=(a|0))k[l>>2]=b+(~((b+-16-a|0)>>>4)<<4);BXa(c,((k[o>>2]|0)-(k[n>>2]|0)|0)/12|0);b=k[o>>2]|0;d=k[n>>2]|0;a=d;if((b|0)!=(d|0)){h=c+8|0;j=m+4|0;g=0;do{b=d;e=k[b+(g*12|0)+4>>2]|0;if(e-(k[b+(g*12|0)>>2]|0)>>4>>>0>=2){k[m>>2]=0;k[j>>2]=0;a=ZT(32)|0;k[a>>2]=1;b=a+4|0;k[m>>2]=b;k[j>>2]=25;i[a+29>>0]=0;d=389645;e=b+25|0;do{i[b>>0]=i[d>>0]|0;b=b+1|0;d=d+1|0}while((b|0)<(e|0));Y8(-215,m,389671,388491,509);k[j>>2]=0;k[m>>2]=0;f=k[a>>2]|0;k[a>>2]=f+-1;if((f|0)==1)ggb(k[a+-4>>2]|0);d=k[n>>2]|0;b=d;e=k[d+(g*12|0)+4>>2]|0;a=d}f=k[b+(g*12|0)>>2]|0;do if((f|0)!=(e|0)){b=k[l>>2]|0;if((b|0)==(k[h>>2]|0)){I6(c,f);a=k[n>>2]|0;d=a;break}else{k[b>>2]=k[f>>2];k[b+4>>2]=k[f+4>>2];k[b+8>>2]=k[f+8>>2];k[b+12>>2]=k[f+12>>2];k[l>>2]=(k[l>>2]|0)+16;break}}while(0);g=g+1|0;b=k[o>>2]|0}while(g>>>0<((b-d|0)/12|0)>>>0)}if(!a){r=p;return}if((b|0)!=(a|0)){do{d=b+-12|0;k[o>>2]=d;e=k[d>>2]|0;f=e;if(!e)b=d;else{b=b+-8|0;d=k[b>>2]|0;if((d|0)!=(e|0))k[b>>2]=d+(~((d+-16-f|0)>>>4)<<4);ggb(e);b=k[o>>2]|0}}while((b|0)!=(a|0));a=k[n>>2]|0}ggb(a);r=p;return}function gYa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+32|0;p=t+8|0;q=t;k[p>>2]=0;d=p+4|0;k[d>>2]=0;k[p+8>>2]=0;B2(b,p);if(!(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)){zF(p);r=t;return}e=k[p>>2]|0;b=k[d>>2]|0;if((e|0)==(b|0)){zF(p);r=t;return}n=a+4|0;m=((k[a+8>>2]|0)-(k[n>>2]|0)|0)/56|0;o=a+16|0;l=((k[a+20>>2]|0)-(k[o>>2]|0)|0)/48|0;m=m>>>0<l>>>0?l:m;if(((b-e|0)/56|0|0)!=(m|0)){k[q>>2]=0;b=q+4|0;k[b>>2]=0;d=ZT(32)|0;k[d>>2]=1;a=d+4|0;k[q>>2]=a;k[b>>2]=26;i[d+30>>0]=0;e=389686;f=a+26|0;do{i[a>>0]=i[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(f|0));Y8(-215,q,389713,388491,607);k[b>>2]=0;k[q>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}if(!m){zF(p);r=t;return}l=q+4|0;j=0;do{h=k[p>>2]|0;do if(k[h+(j*56|0)+16>>2]|0){a=k[h+(j*56|0)+4>>2]|0;if((a|0)<3)b=aa(k[h+(j*56|0)+12>>2]|0,k[h+(j*56|0)+8>>2]|0)|0;else{e=k[h+(j*56|0)+40>>2]|0;d=0;b=1;do{b=aa(k[e+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(a|0))}if(b|0){g=k[n>>2]|0;f=(k[g+(j*56|0)+16>>2]|0)==0;if(!f){a=k[g+(j*56|0)+4>>2]|0;if((a|0)<3)b=aa(k[g+(j*56|0)+12>>2]|0,k[g+(j*56|0)+8>>2]|0)|0;else{e=k[g+(j*56|0)+40>>2]|0;d=0;b=1;do{b=aa(k[e+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(a|0))}if(!b)s=21}else s=21;if((s|0)==21){s=0;b=k[o>>2]|0;if(!(k[b+(j*48|0)+24>>2]|0))break;e=k[b+(j*48|0)+4>>2]|0;if((e|0)<3)b=aa(k[b+(j*48|0)+12>>2]|0,k[b+(j*48|0)+8>>2]|0)|0;else{a=k[b+(j*48|0)+32>>2]|0;d=0;b=1;do{b=aa(k[a+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if(!b)break}if(!f){a=k[g+(j*56|0)+4>>2]|0;if((a|0)<3)b=aa(k[g+(j*56|0)+12>>2]|0,k[g+(j*56|0)+8>>2]|0)|0;else{e=k[g+(j*56|0)+40>>2]|0;d=0;b=1;do{b=aa(k[e+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(a|0))}if(b)b=g+(j*56|0)+8|0;else s=33}else s=33;if((s|0)==33){s=0;b=(k[o>>2]|0)+(j*48|0)+8|0}if(((k[h+(j*56|0)+8>>2]|0)==(c|0)?(k[h+(j*56|0)+12>>2]|0)==(k[b>>2]|0):0)?(k[h+(j*56|0)>>2]&4095|0)==0:0)break;k[q>>2]=0;k[l>>2]=0;b=ZT(128)|0;k[b>>2]=1;a=b+4|0;k[q>>2]=a;k[l>>2]=120;i[b+124>>0]=0;e=389724;f=a+120|0;do{i[a>>0]=i[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(f|0));Y8(-215,q,389713,388491,615);k[l>>2]=0;k[q>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0)}}while(0);j=j+1|0}while(j>>>0<m>>>0);zF(p);r=t;return}
function Wdb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+32|0;q=s+16|0;p=s;a:do switch(e|0){case 0:{switch(d|0){case 16:case 8:case 4:case 2:case 1:{i[a+431>>0]=1;break a}default:Ucb(a,416901)}break}case 2:{switch(d|0){case 8:case 16:{i[a+431>>0]=3;break a}default:Ucb(a,416939)}break}case 3:{switch(d|0){case 8:case 4:case 2:case 1:{i[a+431>>0]=1;break a}default:Ucb(a,416971)}break}case 4:{switch(d|0){case 8:case 16:{i[a+431>>0]=2;break a}default:Ucb(a,417008)}break}case 6:{switch(d|0){case 8:case 16:{i[a+431>>0]=4;break a}default:Ucb(a,417052)}break}default:Ucb(a,417085)}while(0);if(f|0)Vcb(a,417120);if((k[a+676>>2]&4|0)!=0?(k[a+208>>2]&4096|0)==0:0){if((g|0)!=0&((e|4|0)!=6|(g|0)!=64))m=24}else if(!g)g=0;else m=24;if((m|0)==24){Vcb(a,417155);g=0}if(h>>>0>1){Vcb(a,417185);f=1}else f=h;n=d&255;o=a+428|0;i[o>>0]=n;e=e&255;i[a+427>>0]=e;m=f&255;i[a+424>>0]=m;g=g&255;i[a+680>>0]=g;i[a+712>>0]=0;k[a+348>>2]=b;k[a+352>>2]=c;h=i[a+431>>0]|0;f=aa(h&255,d)|0;i[a+430>>0]=f;f=f&255;if(f>>>0>7)f=aa(f>>>3,b)|0;else f=((aa(f,b)|0)+7|0)>>>3;k[a+364>>2]=f;k[a+360>>2]=b;i[a+429>>0]=n;i[a+432>>0]=h;i[p>>0]=b>>>24;i[p+1>>0]=b>>>16;i[p+2>>0]=b>>>8;i[p+3>>0]=b;i[p+4>>0]=c>>>24;i[p+5>>0]=c>>>16;i[p+6>>0]=c>>>8;i[p+7>>0]=c;i[p+8>>0]=n;i[p+9>>0]=e;i[p+10>>0]=0;i[p+11>>0]=g;i[p+12>>0]=m;n=a+768|0;k[n>>2]=34;i[q>>0]=0;i[q+1>>0]=0;i[q+2>>0]=0;i[q+3>>0]=13;g=q+4|0;i[g>>0]=73;i[q+5>>0]=72;i[q+6>>0]=68;i[q+7>>0]=82;d=a+180|0;f=k[d>>2]|0;if(!f)Ucb(a,416435);Ph[f&511](a,q,8);m=a+376|0;k[m>>2]=1229472850;e=a+404|0;k[e>>2]=0;h=a+212|0;if(!(k[h>>2]&2048)){c=yeb(0,g,4)|0;k[e>>2]=c}k[n>>2]=66;f=k[d>>2]|0;if(!f)Ucb(a,416435);Ph[f&511](a,p,13);c=k[h>>2]|0;f=k[e>>2]|0;if((k[m>>2]&536870912|0)==0?(c&2048|0)==0:(c&768|0)!=768){f=yeb(f,p,13)|0;k[e>>2]=f}k[n>>2]=130;i[q>>0]=f>>>24;i[q+1>>0]=f>>>16;i[q+2>>0]=f>>>8;i[q+3>>0]=f;f=k[d>>2]|0;if(!f)Ucb(a,416435);Ph[f&511](a,q,4);f=a+426|0;g=j[f>>1]|0;if((g&255)<<24>>24){a=a+208|0;k[a>>2]=1;r=s;return}if((g&-256)<<16>>16!=768?(l[o>>0]|0)>=8:0){i[f>>0]=-8;a=a+208|0;k[a>>2]=1;r=s;return}i[f>>0]=8;a=a+208|0;k[a>>2]=1;r=s;return}function Xdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+16|0;u=v+8|0;s=v;e=i[a+427>>0]|0;f=e<<24>>24==3;if(f)d=1<<(l[a+428>>0]|0);else d=256;if(d>>>0<c>>>0?1:(k[a+676>>2]&1|c|0)==0){if(f)Ucb(a,417218);Vcb(a,417218);r=v;return}if(!(e&2)){Vcb(a,417254);r=v;return}j[a+412>>1]=c;e=c*3|0;p=a+768|0;k[p>>2]=34;i[u>>0]=e>>>24;i[u+1>>0]=e>>>16;i[u+2>>0]=e>>>8;i[u+3>>0]=e;e=u+4|0;i[e>>0]=80;i[u+5>>0]=76;i[u+6>>0]=84;i[u+7>>0]=69;q=a+180|0;d=k[q>>2]|0;if(!d)Ucb(a,416435);Ph[d&511](a,u,8);m=a+376|0;k[m>>2]=1347179589;o=a+404|0;k[o>>2]=0;n=a+212|0;if(!(k[n>>2]&2048)){d=yeb(0,e,4)|0;k[o>>2]=d}else d=0;k[p>>2]=66;do if(c){g=s+1|0;h=s+2|0;f=0;d=b;while(1){i[s>>0]=i[d>>0]|0;i[g>>0]=i[d+1>>0]|0;i[h>>0]=i[d+2>>0]|0;e=k[q>>2]|0;if(!e){d=16;break}Ph[e&511](a,s,3);b=k[n>>2]|0;if((k[m>>2]&536870912|0)==0?(b&2048|0)==0:(b&768|0)!=768){b=yeb(k[o>>2]|0,s,3)|0;k[o>>2]=b}f=f+1|0;if((f|0)==(c|0)){d=20;break}else d=d+3|0}if((d|0)==16)Ucb(a,416435);else if((d|0)==20){t=k[o>>2]|0;break}}else t=d;while(0);k[p>>2]=130;i[u>>0]=t>>>24;i[u+1>>0]=t>>>16;i[u+2>>0]=t>>>8;i[u+3>>0]=t;d=k[q>>2]|0;if(!d)Ucb(a,416435);Ph[d&511](a,u,4);u=a+208|0;k[u>>2]=k[u>>2]|2;r=v;return}function Ydb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;W=r;r=r+16|0;U=W;V=a+220|0;do if((k[V>>2]|0)!=1229209940){o=a+280|0;g=k[o>>2]|0;do if(!g){g=(k[a+284>>2]|0)+4|0;if(!g)Ucb(a,412758);h=k[a+688>>2]|0;if(!h)g=fgb(g)|0;else g=Hh[h&511](a,g)|0;if(!g)Ucb(a,412758);else{k[o>>2]=g;k[g>>2]=0;break}}else{h=k[g>>2]|0;if(h|0){k[g>>2]=0;m=(a|0)==0;n=a+692|0;do{g=h;h=k[h>>2]|0;do if(!(m|(g|0)==0)){j=k[n>>2]|0;if(!j){ggb(g);break}else{jh[j&1023](a,g);break}}while(0)}while((h|0)!=0)}}while(0);if(!(_db(a,1229209940,Zdb(a)|0)|0)){S=a+236|0;k[S>>2]=(k[o>>2]|0)+4;L=a+284|0;T=a+240|0;k[T>>2]=k[L>>2];K=o;break}else Ucb(a,k[a+248>>2]|0)}else{K=a+280|0;L=a+284|0;S=a+236|0;T=a+240|0}while(0);C=a+224|0;k[C>>2]=b;b=a+228|0;k[b>>2]=0;Q=a+208|0;D=a+712|0;O=a+768|0;p=U+1|0;q=U+2|0;s=U+3|0;t=U+4|0;u=U+5|0;v=U+6|0;w=U+7|0;F=a+376|0;M=a+404|0;x=U+1|0;y=U+2|0;z=U+3|0;B=(d|0)==0;P=a+180|0;E=a+212|0;while(1){k[b>>2]=c;A=Heb(C,d)|0;c=k[b>>2]|0;k[b>>2]=0;g=k[T>>2]|0;if(!g){j=k[K>>2]|0;o=j+4|0;m=k[L>>2]|0;if(((((k[Q>>2]&4|0)==0?(i[D>>0]|0)==0:0)?(G=Zdb(a)|0,G>>>0<16385):0)?(H=l[o>>0]|0,(H&15|0)==8&(H&240)>>>0<113):0)?(I=H>>>4,J=1<<I+7,J>>>0>=G>>>0):0){g=J;h=I;do{g=g>>>1;h=h+-1|0}while(!((h|0)==0|g>>>0<G>>>0));h=h<<4|8;i[o>>0]=h;n=j+5|0;j=l[n>>0]&224;i[n>>0]=(((j|h<<8)>>>0)%31|0|j)^31}if((m|0)<0){g=31;break}k[O>>2]=34;i[U>>0]=m>>>24;i[p>>0]=m>>>16;i[q>>0]=m>>>8;i[s>>0]=m;i[t>>0]=73;i[u>>0]=68;i[v>>0]=65;i[w>>0]=84;g=k[P>>2]|0;if(!g){g=33;break}Ph[g&511](a,U,8);k[F>>2]=1229209940;k[M>>2]=0;if(!(k[E>>2]&2048)){g=yeb(0,t,4)|0;k[M>>2]=g}else g=0;k[O>>2]=66;if(m){g=k[P>>2]|0;if(!g){g=38;break}Ph[g&511](a,o,m);n=k[E>>2]|0;g=k[M>>2]|0;if((k[F>>2]&536870912|0)==0?(n&2048|0)==0:(n&768|0)!=768){n=o;j=m;while(1){h=(j|0)==0?-1:j;g=yeb(g,n,h)|0;j=j-h|0;if(!j)break;else n=n+h|0}k[M>>2]=g}}k[O>>2]=130;i[U>>0]=g>>>24;i[x>>0]=g>>>16;i[y>>0]=g>>>8;i[z>>0]=g;g=k[P>>2]|0;if(!g){g=43;break}Ph[g&511](a,U,4);k[Q>>2]=k[Q>>2]|4;k[S>>2]=o;k[T>>2]=m;if(!(B|(A|0)!=0))continue}else m=g;if(A|0){g=49;break}if(!c){g=47;break}}if((g|0)==31)Ucb(a,416874);else if((g|0)==33)Ucb(a,416435);else if((g|0)==38)Ucb(a,416435);else if((g|0)==43)Ucb(a,416435);else if((g|0)==47)if((d|0)==4)Ucb(a,417310);else{r=W;return}else if((g|0)==49){if(!((d|0)==4&(A|0)==1)){Lcb(a,A);Ucb(a,k[a+248>>2]|0)}j=k[K>>2]|0;h=j+4|0;g=(k[L>>2]|0)-m|0;if(((((k[Q>>2]&4|0)==0?(i[D>>0]|0)==0:0)?(R=Zdb(a)|0,R>>>0<16385):0)?(N=l[h>>0]|0,(N&15|0)==8&(N&240)>>>0<113):0)?(e=N>>>4,f=1<<e+7,f>>>0>=R>>>0):0){do{f=f>>>1;e=e+-1|0}while(!((e|0)==0|f>>>0<R>>>0));L=e<<4|8;i[h>>0]=L;R=j+5|0;N=l[R>>0]&224;i[R>>0]=(((N|L<<8)>>>0)%31|0|N)^31}if((g|0)<0)Ucb(a,416874);k[O>>2]=34;i[U>>0]=g>>>24;i[U+1>>0]=g>>>16;i[U+2>>0]=g>>>8;i[U+3>>0]=g;e=U+4|0;i[e>>0]=73;i[U+5>>0]=68;i[U+6>>0]=65;i[U+7>>0]=84;f=k[P>>2]|0;if(!f)Ucb(a,416435);Ph[f&511](a,U,8);k[F>>2]=1229209940;k[M>>2]=0;if(!(k[E>>2]&2048)){e=yeb(0,e,4)|0;k[M>>2]=e}else e=0;k[O>>2]=66;if(g){e=k[P>>2]|0;if(!e)Ucb(a,416435);Ph[e&511](a,h,g);R=k[E>>2]|0;e=k[M>>2]|0;if((k[F>>2]&536870912|0)==0?(R&2048|0)==0:(R&768|0)!=768){while(1){f=(g|0)==0?-1:g;e=yeb(e,h,f)|0;g=g-f|0;if(!g)break;else h=h+f|0}k[M>>2]=e}}k[O>>2]=130;i[U>>0]=e>>>24;i[U+1>>0]=e>>>16;i[U+2>>0]=e>>>8;i[U+3>>0]=e;e=k[P>>2]|0;if(!e)Ucb(a,416435);Ph[e&511](a,U,4);k[T>>2]=0;k[S>>2]=0;k[Q>>2]=k[Q>>2]|12;k[V>>2]=0;r=W;return}}function Zdb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;c=k[a+352>>2]|0;b=k[a+364>>2]|0;if((b|c)>>>0>=32768){j=-1;return j|0}if(!(i[a+424>>0]|0)){j=aa(b+1|0,c)|0;return j|0}e=i[a+430>>0]|0;g=e&255;j=(k[a+348>>2]|0)+-1|0;f=g>>>3;h=c+-1|0;if((e&255)>7){a=0;b=0;a:while(1){d=a;while(1){if((d|0)>=7)break a;c=(d|0)>1?7-d>>1:3;e=d&1;a=d+1|0;c=(j+(1<<c)-(e<<3-(a>>1)&7)|0)>>>c;if(!c)d=a;else break}c=(aa(c,f)|0)+1|0;g=(d|0)>2?8-d>>1:3;b=(aa(c,(h+(1<<g)-((e^1)<<3-(d>>1)&7)|0)>>>g)|0)+b|0}return b|0}else{a=0;b=0;b:while(1){d=a;while(1){if((d|0)>=7)break b;c=(d|0)>1?7-d>>1:3;e=d&1;a=d+1|0;c=(j+(1<<c)-(e<<3-(a>>1)&7)|0)>>>c;if(!c)d=a;else break}c=(((aa(c,g)|0)+7|0)>>>3)+1|0;f=(d|0)>2?8-d>>1:3;b=(aa(c,(h+(1<<f)-((e^1)<<3-(d>>1)&7)|0)>>>f)|0)+b|0}return b|0}return 0}function _db(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+64|0;d=s;p=a+220|0;e=k[p>>2]|0;do if(e|0){i[d>>0]=b>>>24;i[d+1>>0]=b>>>16;i[d+2>>0]=b>>>8;i[d+3>>0]=b;i[d+4>>0]=58;i[d+5>>0]=32;i[d+6>>0]=e>>>24;i[d+7>>0]=e>>>16;i[d+8>>0]=e>>>8;i[d+9>>0]=e;i[d+10>>0]=32;i[d+11>>0]=117;i[d+12>>0]=115;i[d+13>>0]=105;i[d+14>>0]=110;i[d+15>>0]=103;i[d+16>>0]=32;i[d+17>>0]=122;i[d+18>>0]=115;i[d+19>>0]=116;i[d+20>>0]=114;i[d+21>>0]=101;i[d+22>>0]=97;i[d+23>>0]=109;i[d+24>>0]=0;Vcb(a,d);if((k[p>>2]|0)!=1229209940){k[p>>2]=0;break}k[a+248>>2]=417345;q=-2;r=s;return q|0}while(0);g=k[a+288>>2]|0;f=k[a+292>>2]|0;d=k[a+296>>2]|0;e=k[a+300>>2]|0;do if((b|0)==1229209940)if(!(k[a+212>>2]&1)){o=(i[a+426>>0]|0)!=8&1;n=e;l=f;j=g;break}else{o=k[a+304>>2]|0;n=e;l=f;j=g;break}else{o=k[a+324>>2]|0;n=k[a+320>>2]|0;d=k[a+316>>2]|0;l=k[a+312>>2]|0;j=k[a+308>>2]|0}while(0);if(c>>>0<16385?(h=1<<d+-1,m=c+262|0,m>>>0<=h>>>0):0){e=h;do{e=e>>>1;d=d+-1|0}while(m>>>0<=e>>>0)}g=a+212|0;e=k[g>>2]|0;do if(e&2){if(((((k[a+328>>2]|0)==(j|0)?(k[a+332>>2]|0)==(l|0):0)?(k[a+336>>2]|0)==(d|0):0)?(k[a+340>>2]|0)==(n|0):0)?(k[a+344>>2]|0)==(o|0):0)break;if(Geb(a+224|0)|0)Vcb(a,417360);e=k[g>>2]&-3;k[g>>2]=e}while(0);f=a+224|0;k[f>>2]=0;k[a+228>>2]=0;k[a+236>>2]=0;k[a+240>>2]=0;if(!(e&2)){e=zeb(f,j,l,d,n,o,418750,56)|0;if(!e){k[g>>2]=k[g>>2]|2;q=26}}else{e=Aeb(f)|0;if(!e)q=26}if((q|0)==26){k[p>>2]=b;q=0;r=s;return q|0}d=a+248|0;if(k[d>>2]|0){q=e;r=s;return q|0}do switch(e|0){case -7:{k[d>>2]=411045;q=-7;r=s;return q|0}case 1:{k[d>>2]=410915;q=1;r=s;return q|0}case 2:{k[d>>2]=410943;q=2;r=s;return q|0}case -1:{k[d>>2]=410965;q=-1;r=s;return q|0}case -2:{k[d>>2]=410979;q=-2;r=s;return q|0}case -3:{k[d>>2]=411002;q=-3;r=s;return q|0}case -4:{k[d>>2]=420017;q=-4;r=s;return q|0}case -5:{k[d>>2]=413906;q=-5;r=s;return q|0}case -6:{k[d>>2]=411020;q=-6;r=s;return q|0}default:{k[d>>2]=410887;q=e;r=s;return q|0}}while(0);return 0}function $db(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;g=r;r=r+16|0;f=g;if(!a){f=a+208|0;a=k[f>>2]|0;a=a|16;k[f>>2]=a;r=g;return}d=a+768|0;k[d>>2]=34;c=f+4|0;k[f>>2]=0;i[c>>0]=73;i[f+5>>0]=69;i[f+6>>0]=78;i[f+7>>0]=68;e=a+180|0;b=k[e>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,f,8);k[a+376>>2]=1229278788;b=a+404|0;k[b>>2]=0;if(!(k[a+212>>2]&2048)){c=yeb(0,c,4)|0;k[b>>2]=c;b=c}else b=0;k[d>>2]=130;i[f>>0]=b>>>24;i[f+1>>0]=b>>>16;i[f+2>>0]=b>>>8;i[f+3>>0]=b;b=k[e>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,f,4);f=a+208|0;a=k[f>>2]|0;a=a|16;k[f>>2]=a;r=g;return}function aeb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;l=m+8|0;j=m;i[j>>0]=b>>>24;i[j+1>>0]=b>>>16;i[j+2>>0]=b>>>8;i[j+3>>0]=b;if(!a){r=m;return}g=a+768|0;k[g>>2]=34;i[l>>0]=0;i[l+1>>0]=0;i[l+2>>0]=0;i[l+3>>0]=4;c=l+4|0;i[c>>0]=103;i[l+5>>0]=65;i[l+6>>0]=77;i[l+7>>0]=65;h=a+180|0;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,l,8);e=a+376|0;k[e>>2]=1732332865;f=a+404|0;k[f>>2]=0;d=a+212|0;if((k[d>>2]&768|0)!=768){c=yeb(0,c,4)|0;k[f>>2]=c}k[g>>2]=66;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,j,4);d=k[d>>2]|0;b=k[f>>2]|0;if((k[e>>2]&536870912|0)==0?(d&2048|0)==0:(d&768|0)!=768){b=yeb(b,j,4)|0;k[f>>2]=b}k[g>>2]=130;i[l>>0]=b>>>24;i[l+1>>0]=b>>>16;i[l+2>>0]=b>>>8;i[l+3>>0]=b;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,l,4);r=m;return}function beb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;l=m+8|0;h=m;if((b|0)>3)Vcb(a,417388);i[h>>0]=b;if(!a){r=m;return}j=a+768|0;k[j>>2]=34;i[l>>0]=0;i[l+1>>0]=0;i[l+2>>0]=0;i[l+3>>0]=1;c=l+4|0;i[c>>0]=115;i[l+5>>0]=82;i[l+6>>0]=71;i[l+7>>0]=66;g=a+180|0;b=k[g>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,l,8);e=a+376|0;k[e>>2]=1934772034;f=a+404|0;k[f>>2]=0;d=a+212|0;if((k[d>>2]&768|0)!=768){c=yeb(0,c,4)|0;k[f>>2]=c}k[j>>2]=66;b=k[g>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,h,1);d=k[d>>2]|0;b=k[f>>2]|0;if((k[e>>2]&536870912|0)==0?(d&2048|0)==0:(d&768|0)!=768){b=yeb(b,h,1)|0;k[f>>2]=b}k[j>>2]=130;i[l>>0]=b>>>24;i[l+1>>0]=b>>>16;i[l+2>>0]=b>>>8;i[l+3>>0]=b;b=k[g>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,l,4);r=m;return}function ceb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+1136|0;u=v+1120|0;h=v+1036|0;n=v;if(!c)Ucb(a,417428);e=l[c+3>>0]|0;f=(l[c+1>>0]|0)<<16|(l[c>>0]|0)<<24|(l[c+2>>0]|0)<<8|e;if(f>>>0<132)Ucb(a,417454);if(!((e&3|0)==0|(l[c+8>>0]|0)<4))Ucb(a,417476);b=deb(a,b,h)|0;if(!b)Ucb(a,417525);i[h+(b+1)>>0]=0;g=b+2|0;k[n>>2]=c;k[n+4>>2]=f;j=n+8|0;k[j>>2]=0;if(eeb(a,1766015824,n,g)|0)Ucb(a,k[a+248>>2]|0);b=k[j>>2]|0;e=b+g|0;t=(a|0)==0;a:do if(t){e=k[70]|0;b=b-(b>>>0<1024?b:1024)|0;d=(b|0)==0;if(!((e|0)==0|d)){c=k[71]|0;do{e=k[e>>2]|0;b=b-(c>>>0>b>>>0?b:c)|0;d=(b|0)==0}while(!((e|0)==0|d))}}else{c=a+768|0;k[c>>2]=34;i[u>>0]=e>>>24;i[u+1>>0]=e>>>16;i[u+2>>0]=e>>>8;i[u+3>>0]=e;e=u+4|0;i[e>>0]=105;i[u+5>>0]=67;i[u+6>>0]=67;i[u+7>>0]=80;s=a+180|0;b=k[s>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,u,8);o=a+376|0;k[o>>2]=1766015824;p=a+404|0;k[p>>2]=0;q=a+212|0;if((k[q>>2]&768|0)!=768){m=yeb(0,e,4)|0;k[p>>2]=m}k[c>>2]=66;if(g|0){b=k[s>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,h,g);m=k[q>>2]|0;if((k[o>>2]&536870912|0)==0?(m&2048|0)==0:(m&768|0)!=768){c=h;f=k[p>>2]|0;e=g;while(1){b=(e|0)==0?-1:e;f=yeb(f,c,b)|0;e=e-b|0;if(!e)break;else c=c+b|0}k[p>>2]=f}}m=a+284|0;b=a+280|0;f=1024;c=n+12|0;e=k[j>>2]|0;while(1){j=k[b>>2]|0;h=f>>>0>e>>>0?e:f;if(h|0){b=k[s>>2]|0;if(!b)break;Ph[b&511](a,c,h);n=k[q>>2]|0;if((k[o>>2]&536870912|0)==0?(n&2048|0)==0:(n&768|0)!=768){f=k[p>>2]|0;g=h;while(1){b=(g|0)==0?-1:g;f=yeb(f,c,b)|0;g=g-b|0;if(!g)break;else c=c+b|0}k[p>>2]=f}}e=e-h|0;b=(e|0)==0;if((j|0)==0|b){d=b;break a}b=j;f=k[m>>2]|0;c=j+4|0}Ucb(a,416435)}while(0);if(!d)Ucb(a,417547);if(t){r=v;return}k[a+768>>2]=130;d=k[a+404>>2]|0;i[u>>0]=d>>>24;i[u+1>>0]=d>>>16;i[u+2>>0]=d>>>8;i[u+3>>0]=d;d=k[a+180>>2]|0;if(!d)Ucb(a,416435);Ph[d&511](a,u,4);r=v;return}function deb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=r;r=r+448|0;m=n+256|0;k=n;if(!b){i[c>>0]=0;m=0;r=n;return m|0}d=i[b>>0]|0;a:do if(!(d<<24>>24)){h=1;e=0;g=0;f=b;d=c}else{h=1;e=0;g=0;f=b;while(1){b:do if(!h){f=f+1|0;if((d&255)>160|(d+-33&255)<94)l=4;else{i[c>>0]=32;h=1;e=d<<24>>24==32?e:d&255}}else while(1){f=f+1|0;if((d&255)>160|(d+-33&255)<94){l=4;break b}e=(e|0)==0?d&255:e;d=i[f>>0]|0;if(!(d<<24>>24)){d=c;break a}}while(0);if((l|0)==4){l=0;i[c>>0]=d;h=0}g=g+1|0;c=c+1|0;d=i[f>>0]|0;if(!(g>>>0<79&d<<24>>24!=0)){d=c;break}}}while(0);c=(g|0)!=0&(h|0)!=0;j=(c<<31>>31)+g|0;h=(e|0)==0&c?32:e;i[(c?d+-1|0:d)>>0]=0;if(!j){m=0;r=n;return m|0}if(i[f>>0]|0){Vcb(a,417620);m=j;r=n;return m|0}if(!h){m=j;r=n;return m|0}d=i[b>>0]|0;if(!(d<<24>>24))d=0;else{f=0;e=d;while(1){b=b+1|0;d=f+1|0;i[k+f>>0]=e;e=i[b>>0]|0;if(!(d>>>0<31&e<<24>>24!=0))break;else f=d}}i[k+d>>0]=0;c=(h|0)<0;b=m+23|0;i[b>>0]=0;f=1;g=0;e=c?0-h|0:h;d=0;while(1){if(!((e|0)!=0|(g|0)<(f|0)))break;d=i[412648+(e&15)>>0]|0;b=b+-1|0;i[b>>0]=d;if(b>>>0>m>>>0){f=2;g=g+1|0;e=e>>>4}else break}if(!(c&b>>>0>m>>>0))if(!(d<<24>>24))d=0;else{f=0;e=d;l=23}else{b=b+-1|0;i[b>>0]=45;f=0;e=45;l=23}if((l|0)==23)while(1){l=0;b=b+1|0;d=f+1|0;i[k+32+f>>0]=e;e=i[b>>0]|0;if(!(d>>>0<31&e<<24>>24!=0))break;else{f=d;l=23}}i[k+32+d>>0]=0;b=417638;d=0;c:while(1){e=i[b>>0]|0;switch(e<<24>>24){case 0:break c;case 64:{f=b+1|0;e=i[f>>0]|0;if(e<<24>>24){g=0;while(1)if((g|0)!=9?(i[412684+g>>0]|0)!=e<<24>>24:0)g=g+1|0;else break;if((g|0)<8){c=k+(g<<5)+32|0;d:do if(d>>>0<191){g=k+(g<<5)|0;while(1){e=i[g>>0]|0;if(!(g>>>0<c>>>0&e<<24>>24!=0))break d;f=d+1|0;i[m+d>>0]=e;if(f>>>0<191){g=g+1|0;d=f}else{d=f;break}}}while(0);e=b+2|0}else{b=f;l=34}}else{e=64;l=34}break}default:l=34}if((l|0)==34){l=0;i[m+d>>0]=e;e=b+1|0;d=d+1|0}if(d>>>0<191)b=e;else break}i[m+d>>0]=0;Vcb(a,m);m=j;r=n;return m|0}function eeb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=c+4|0;b=_db(a,b,k[u>>2]|0)|0;if(b|0){c=b;return c|0}e=k[u>>2]|0;n=a+224|0;k[n>>2]=k[c>>2];o=a+228|0;k[o>>2]=0;v=c+12|0;p=a+236|0;k[p>>2]=v;q=a+240|0;k[q>>2]=1024;r=a+284|0;s=a+688|0;f=1024;m=a+280|0;g=1024;while(1){k[o>>2]=e;do if(!g)if((f+d|0)<0){e=0;h=2;j=-4;b=m}else{b=k[m>>2]|0;if(!b){b=(k[r>>2]|0)+4|0;if(!b){e=0;h=2;j=-4;b=m;break}e=k[s>>2]|0;if(!e)b=fgb(b)|0;else b=Hh[e&511](a,b)|0;if(!b){e=0;h=2;j=-4;b=m;break}k[b>>2]=0;k[m>>2]=b}k[p>>2]=b+4;t=k[r>>2]|0;k[q>>2]=t;f=t+f|0;t=13}else{b=m;t=13}while(0);if((t|0)==13){t=0;j=Heb(n,4)|0;e=k[o>>2]|0;k[o>>2]=0;h=0}g=k[q>>2]|0;if(h|j|0)break;else m=b}t=f-g|0;k[q>>2]=0;k[c+8>>2]=t;b=a+248|0;if((t+d|0)>>>0>2147483646){k[b>>2]=417595;k[a+220>>2]=0;c=-4;return c|0}a:do if(!(k[b>>2]|0)){do switch(j|0){case -7:{k[b>>2]=411045;break}case 1:{k[b>>2]=410915;break a}case 2:{k[b>>2]=410943;break}case -1:{k[b>>2]=410965;break}case -2:{k[b>>2]=410979;break}case -3:{k[b>>2]=411002;break}case -4:{k[b>>2]=420017;break}case -5:{k[b>>2]=413906;break}case -6:{k[b>>2]=411020;break}default:k[b>>2]=410887}while(0);k[a+220>>2]=0;c=j;return c|0}while(0);k[a+220>>2]=0;if(!((j|0)==1&(e|0)==0)){c=j;return c|0}f=k[u>>2]|0;if(f>>>0>=16385){c=0;return c|0}b=l[v>>0]|0;if(!((b&15|0)==8&(b&240)>>>0<113)){c=0;return c|0}b=b>>>4;e=1<<b+7;if(e>>>0<f>>>0){c=0;return c|0}do{e=e>>>1;b=b+-1|0}while(!((b|0)==0|e>>>0<f>>>0));u=b<<4|8;i[v>>0]=u;c=c+13|0;v=(l[c>>0]|0)&224;i[c>>0]=(((v|u<<8)>>>0)%31|0|v)^31;c=0;return c|0}function feb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=r;r=r+112|0;E=F+96|0;e=F+16|0;D=F;z=b+4|0;A=(i[z>>0]|0)==8?6:10;B=b+12|0;c=k[B>>2]|0;g=deb(a,k[b>>2]|0,e)|0;if(!g)Ucb(a,417673);c=g+2+(aa(A,c)|0)|0;C=(a|0)==0;if(!C){f=a+768|0;k[f>>2]=34;i[E>>0]=c>>>24;i[E+1>>0]=c>>>16;i[E+2>>0]=c>>>8;i[E+3>>0]=c;d=E+4|0;i[d>>0]=115;i[E+5>>0]=80;i[E+6>>0]=76;i[E+7>>0]=84;h=a+180|0;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,E,8);l=a+376|0;k[l>>2]=1934642260;m=a+404|0;k[m>>2]=0;n=a+212|0;if((k[n>>2]&768|0)!=768){y=yeb(0,d,4)|0;k[m>>2]=y}k[f>>2]=66;d=g+1|0;if(d|0){c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,e,d);y=k[n>>2]|0;if((k[l>>2]&536870912|0)==0?(y&2048|0)==0:(y&768|0)!=768){f=k[m>>2]|0;while(1){c=(d|0)==0?-1:d;f=yeb(f,e,c)|0;d=d-c|0;if(!d)break;else e=e+c|0}k[m>>2]=f}}c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,z,1);y=k[n>>2]|0;if((k[l>>2]&536870912|0)==0?(y&2048|0)==0:(y&768|0)!=768){d=yeb(k[m>>2]|0,z,1)|0;k[m>>2]=d;d=1}else d=1}else d=0;o=b+8|0;c=k[o>>2]|0;e=k[B>>2]|0;a:do if((e|0)>0){p=D+1|0;q=D+2|0;s=D+3|0;t=D+4|0;u=D+5|0;v=D+6|0;w=D+7|0;x=D+8|0;y=D+9|0;if(!d){m=(i[z>>0]|0)==8;l=c+(e*10|0)|0;while(1){d=j[c>>1]|0;e=j[c+2>>1]|0;f=j[c+4>>1]|0;g=j[c+6>>1]|0;h=j[c+8>>1]|0;if(m){i[D>>0]=d;i[p>>0]=e;i[q>>0]=f;i[s>>0]=g;i[t>>0]=(h&65535)>>>8;i[u>>0]=h}else{i[D>>0]=(d&65535)>>>8;i[p>>0]=d;i[q>>0]=(e&65535)>>>8;i[s>>0]=e;i[t>>0]=(f&65535)>>>8;i[u>>0]=f;i[v>>0]=(g&65535)>>>8;i[w>>0]=g;i[x>>0]=(h&65535)>>>8;i[y>>0]=h}c=c+10|0;if(c>>>0>=l>>>0)break a}}l=a+180|0;m=a+376|0;n=a+212|0;b=a+404|0;while(1){d=j[c>>1]|0;e=j[c+2>>1]|0;f=j[c+4>>1]|0;g=j[c+6>>1]|0;h=j[c+8>>1]|0;if((i[z>>0]|0)==8){i[D>>0]=d;i[p>>0]=e;i[q>>0]=f;i[s>>0]=g;i[t>>0]=(h&65535)>>>8;i[u>>0]=h}else{i[D>>0]=(d&65535)>>>8;i[p>>0]=d;i[q>>0]=(e&65535)>>>8;i[s>>0]=e;i[t>>0]=(f&65535)>>>8;i[u>>0]=f;i[v>>0]=(g&65535)>>>8;i[w>>0]=g;i[x>>0]=(h&65535)>>>8;i[y>>0]=h}d=k[l>>2]|0;if(!d)break;Ph[d&511](a,D,A);h=k[n>>2]|0;if((k[m>>2]&536870912|0)==0?(h&2048|0)==0:(h&768|0)!=768){e=D;f=k[b>>2]|0;g=A;while(1){d=(g|0)==0?-1:g;f=yeb(f,e,d)|0;g=g-d|0;if(!g)break;else e=e+d|0}k[b>>2]=f}c=c+10|0;if(c>>>0>=((k[o>>2]|0)+((k[B>>2]|0)*10|0)|0)>>>0)break a}Ucb(a,416435)}while(0);if(C){r=F;return}k[a+768>>2]=130;c=k[a+404>>2]|0;i[E>>0]=c>>>24;i[E+1>>0]=c>>>16;i[E+2>>0]=c>>>8;i[E+3>>0]=c;c=k[a+180>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,E,4);r=F;return}function geb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o+8|0;m=o;do if(!(c&2)){d=i[b+3>>0]|0;if(d<<24>>24?(d&255)<=(l[a+429>>0]|0):0){i[m>>0]=d;e=1;break}Vcb(a,417695);r=o;return}else{if((c|0)==3)e=8;else e=i[a+429>>0]|0;d=i[b>>0]|0;if(((d+-1&255)<(e&255)?(f=i[b+1>>0]|0,(f+-1&255)<(e&255)):0)?(g=i[b+2>>0]|0,(g+-1&255)<(e&255)):0){i[m>>0]=d;i[m+1>>0]=f;i[m+2>>0]=g;e=3;break}Vcb(a,417695);r=o;return}while(0);do if(!(c&4)){if(!a){r=o;return}}else{d=i[b+4>>0]|0;if(d<<24>>24?(d&255)<=(l[a+429>>0]|0):0){i[m+e>>0]=d;e=e+1|0;break}Vcb(a,417695);r=o;return}while(0);h=a+768|0;k[h>>2]=34;i[n>>0]=e>>>24;i[n+1>>0]=e>>>16;i[n+2>>0]=e>>>8;i[n+3>>0]=e;f=n+4|0;i[f>>0]=115;i[n+5>>0]=66;i[n+6>>0]=73;i[n+7>>0]=84;j=a+180|0;d=k[j>>2]|0;if(!d)Ucb(a,416435);Ph[d&511](a,n,8);b=a+376|0;k[b>>2]=1933723988;c=a+404|0;k[c>>2]=0;g=a+212|0;if((k[g>>2]&768|0)!=768){f=yeb(0,f,4)|0;k[c>>2]=f}k[h>>2]=66;d=k[j>>2]|0;if(!d)Ucb(a,416435);Ph[d&511](a,m,e);g=k[g>>2]|0;d=k[c>>2]|0;if((k[b>>2]&536870912|0)==0?(g&2048|0)==0:(g&768|0)!=768){g=m;while(1){f=(e|0)==0?-1:e;d=yeb(d,g,f)|0;e=e-f|0;if(!e)break;else g=g+f|0}k[c>>2]=d}k[h>>2]=130;i[n>>0]=d>>>24;i[n+1>>0]=d>>>16;i[n+2>>0]=d>>>8;i[n+3>>0]=d;d=k[j>>2]|0;if(!d)Ucb(a,416435);Ph[d&511](a,n,4);r=o;return}function heb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+48|0;l=m+32|0;j=m;h=k[b+24>>2]|0;i[j>>0]=h>>>24;i[j+1>>0]=h>>>16;i[j+2>>0]=h>>>8;i[j+3>>0]=h;h=k[b+28>>2]|0;i[j+4>>0]=h>>>24;i[j+5>>0]=h>>>16;i[j+6>>0]=h>>>8;i[j+7>>0]=h;h=k[b>>2]|0;i[j+8>>0]=h>>>24;i[j+9>>0]=h>>>16;i[j+10>>0]=h>>>8;i[j+11>>0]=h;h=k[b+4>>2]|0;i[j+12>>0]=h>>>24;i[j+13>>0]=h>>>16;i[j+14>>0]=h>>>8;i[j+15>>0]=h;h=k[b+8>>2]|0;i[j+16>>0]=h>>>24;i[j+17>>0]=h>>>16;i[j+18>>0]=h>>>8;i[j+19>>0]=h;h=k[b+12>>2]|0;i[j+20>>0]=h>>>24;i[j+21>>0]=h>>>16;i[j+22>>0]=h>>>8;i[j+23>>0]=h;h=k[b+16>>2]|0;i[j+24>>0]=h>>>24;i[j+25>>0]=h>>>16;i[j+26>>0]=h>>>8;i[j+27>>0]=h;h=k[b+20>>2]|0;i[j+28>>0]=h>>>24;i[j+29>>0]=h>>>16;i[j+30>>0]=h>>>8;i[j+31>>0]=h;if(!a){r=m;return}g=a+768|0;k[g>>2]=34;i[l>>0]=0;i[l+1>>0]=0;i[l+2>>0]=0;i[l+3>>0]=32;c=l+4|0;i[c>>0]=99;i[l+5>>0]=72;i[l+6>>0]=82;i[l+7>>0]=77;h=a+180|0;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,l,8);e=a+376|0;k[e>>2]=1665684045;f=a+404|0;k[f>>2]=0;d=a+212|0;if((k[d>>2]&768|0)!=768){c=yeb(0,c,4)|0;k[f>>2]=c}k[g>>2]=66;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,j,32);d=k[d>>2]|0;b=k[f>>2]|0;if((k[e>>2]&536870912|0)==0?(d&2048|0)==0:(d&768|0)!=768){b=yeb(b,j,32)|0;k[f>>2]=b}k[g>>2]=130;i[l>>0]=b>>>24;i[l+1>>0]=b>>>16;i[l+2>>0]=b>>>8;i[l+3>>0]=b;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,l,4);r=m;return}function ieb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,n=0,o=0,p=0,q=0;q=r;r=r+16|0;p=q+8|0;n=q;switch(e|0){case 3:{if((d|0)>=1?(m[a+412>>1]|0)>=(d|0):0){n=a+768|0;k[n>>2]=34;i[p>>0]=d>>>24;i[p+1>>0]=d>>>16;i[p+2>>0]=d>>>8;i[p+3>>0]=d;e=p+4|0;i[e>>0]=116;i[p+5>>0]=82;i[p+6>>0]=78;i[p+7>>0]=83;o=a+180|0;c=k[o>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,p,8);g=a+376|0;k[g>>2]=1951551059;h=a+404|0;k[h>>2]=0;f=a+212|0;if((k[f>>2]&768|0)==768)c=0;else{c=yeb(0,e,4)|0;k[h>>2]=c}k[n>>2]=66;if(b){c=k[o>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,b,d);f=k[f>>2]|0;c=k[h>>2]|0;if(d|0?((k[g>>2]&536870912|0)==0?(f&2048|0)==0:(f&768|0)!=768):0){while(1){e=(d|0)==0?-1:d;c=yeb(c,b,e)|0;d=d-e|0;if(!d)break;else b=b+e|0}k[h>>2]=c}}k[n>>2]=130;i[p>>0]=c>>>24;i[p+1>>0]=c>>>16;i[p+2>>0]=c>>>8;i[p+3>>0]=c;c=k[o>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,p,4);r=q;return}if(!(k[a+212>>2]&2097152))Ucb(a,417724);Vcb(a,417724);r=q;return}case 0:{c=j[c+8>>1]|0;if((c&65535|0)>=(1<<l[a+428>>0]|0)){if(!(k[a+212>>2]&2097152))Ucb(a,417771);Vcb(a,417771);r=q;return}i[n>>0]=(c&65535)>>>8;i[n+1>>0]=c;g=a+768|0;k[g>>2]=34;i[p>>0]=0;i[p+1>>0]=0;i[p+2>>0]=0;i[p+3>>0]=2;e=p+4|0;i[e>>0]=116;i[p+5>>0]=82;i[p+6>>0]=78;i[p+7>>0]=83;h=a+180|0;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,p,8);b=a+376|0;k[b>>2]=1951551059;f=a+404|0;k[f>>2]=0;d=a+212|0;if((k[d>>2]&768|0)!=768){o=yeb(0,e,4)|0;k[f>>2]=o}k[g>>2]=66;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,n,2);o=k[d>>2]|0;c=k[f>>2]|0;if((k[b>>2]&536870912|0)==0?(o&2048|0)==0:(o&768|0)!=768){c=yeb(c,n,2)|0;k[f>>2]=c}k[g>>2]=130;i[p>>0]=c>>>24;i[p+1>>0]=c>>>16;i[p+2>>0]=c>>>8;i[p+3>>0]=c;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,p,4);r=q;return}case 2:{f=j[c+2>>1]|0;h=(f&65535)>>>8;i[n>>0]=h;i[n+1>>0]=f;f=j[c+4>>1]|0;g=(f&65535)>>>8;i[n+2>>0]=g;i[n+3>>0]=f;f=j[c+6>>1]|0;o=(f&65535)>>>8;i[n+4>>0]=o;i[n+5>>0]=f;if((i[a+428>>0]|0)==8?(g|h|o)<<16>>16:0){if(!(k[a+212>>2]&2097152))Ucb(a,417835);Vcb(a,417835);r=q;return}g=a+768|0;k[g>>2]=34;i[p>>0]=0;i[p+1>>0]=0;i[p+2>>0]=0;i[p+3>>0]=6;e=p+4|0;i[e>>0]=116;i[p+5>>0]=82;i[p+6>>0]=78;i[p+7>>0]=83;h=a+180|0;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,p,8);b=a+376|0;k[b>>2]=1951551059;f=a+404|0;k[f>>2]=0;d=a+212|0;if((k[d>>2]&768|0)!=768){o=yeb(0,e,4)|0;k[f>>2]=o}k[g>>2]=66;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,n,6);o=k[d>>2]|0;c=k[f>>2]|0;if((k[b>>2]&536870912|0)==0?(o&2048|0)==0:(o&768|0)!=768){c=yeb(c,n,6)|0;k[f>>2]=c}k[g>>2]=130;i[p>>0]=c>>>24;i[p+1>>0]=c>>>16;i[p+2>>0]=c>>>8;i[p+3>>0]=c;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,p,4);r=q;return}default:{if(!(k[a+212>>2]&2097152))Ucb(a,417899);Vcb(a,417899);r=q;return}}}function jeb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o+8|0;m=o;if((c|0)==3){d=j[a+412>>1]|0;if(d<<16>>16==0?(k[a+676>>2]&1|0)!=0:0)c=i[b>>0]|0;else{c=i[b>>0]|0;if((c&255)>>>0>=(d&65535)>>>0){Vcb(a,417938);r=o;return}}i[m>>0]=c;g=a+768|0;k[g>>2]=34;i[n>>0]=0;i[n+1>>0]=0;i[n+2>>0]=0;i[n+3>>0]=1;b=n+4|0;i[b>>0]=98;i[n+5>>0]=75;i[n+6>>0]=71;i[n+7>>0]=68;h=a+180|0;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,n,8);e=a+376|0;k[e>>2]=1649100612;f=a+404|0;k[f>>2]=0;d=a+212|0;if((k[d>>2]&768|0)!=768){b=yeb(0,b,4)|0;k[f>>2]=b}k[g>>2]=66;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,m,1);d=k[d>>2]|0;c=k[f>>2]|0;if((k[e>>2]&536870912|0)==0?(d&2048|0)==0:(d&768|0)!=768){c=yeb(c,m,1)|0;k[f>>2]=c}k[g>>2]=130;i[n>>0]=c>>>24;i[n+1>>0]=c>>>16;i[n+2>>0]=c>>>8;i[n+3>>0]=c;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,n,4);r=o;return}if(!(c&2)){c=j[b+8>>1]|0;if((c&65535|0)>=(1<<l[a+428>>0]|0)){Vcb(a,418035);r=o;return}i[m>>0]=(c&65535)>>>8;i[m+1>>0]=c;g=a+768|0;k[g>>2]=34;i[n>>0]=0;i[n+1>>0]=0;i[n+2>>0]=0;i[n+3>>0]=2;b=n+4|0;i[b>>0]=98;i[n+5>>0]=75;i[n+6>>0]=71;i[n+7>>0]=68;h=a+180|0;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,n,8);e=a+376|0;k[e>>2]=1649100612;f=a+404|0;k[f>>2]=0;d=a+212|0;if((k[d>>2]&768|0)!=768){b=yeb(0,b,4)|0;k[f>>2]=b}k[g>>2]=66;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,m,2);d=k[d>>2]|0;c=k[f>>2]|0;if((k[e>>2]&536870912|0)==0?(d&2048|0)==0:(d&768|0)!=768){c=yeb(c,m,2)|0;k[f>>2]=c}k[g>>2]=130;i[n>>0]=c>>>24;i[n+1>>0]=c>>>16;i[n+2>>0]=c>>>8;i[n+3>>0]=c;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,n,4);r=o;return}e=j[b+2>>1]|0;g=(e&65535)>>>8;i[m>>0]=g;i[m+1>>0]=e;e=j[b+4>>1]|0;f=(e&65535)>>>8;i[m+2>>0]=f;i[m+3>>0]=e;e=j[b+6>>1]|0;h=(e&65535)>>>8;i[m+4>>0]=h;i[m+5>>0]=e;if((i[a+428>>0]|0)==8?(f|g|h)<<16>>16:0){Vcb(a,417971);r=o;return}g=a+768|0;k[g>>2]=34;i[n>>0]=0;i[n+1>>0]=0;i[n+2>>0]=0;i[n+3>>0]=6;d=n+4|0;i[d>>0]=98;i[n+5>>0]=75;i[n+6>>0]=71;i[n+7>>0]=68;h=a+180|0;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,n,8);e=a+376|0;k[e>>2]=1649100612;f=a+404|0;k[f>>2]=0;b=a+212|0;if((k[b>>2]&768|0)!=768){d=yeb(0,d,4)|0;k[f>>2]=d}k[g>>2]=66;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,m,6);d=k[b>>2]|0;c=k[f>>2]|0;if((k[e>>2]&536870912|0)==0?(d&2048|0)==0:(d&768|0)!=768){c=yeb(c,m,6)|0;k[f>>2]=c}k[g>>2]=130;i[n>>0]=c>>>24;i[n+1>>0]=c>>>16;i[n+2>>0]=c>>>8;i[n+3>>0]=c;c=k[h>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,n,4);r=o;return}function keb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+16|0;s=t+8|0;n=t;if((m[a+412>>1]|0|0)<(c|0)){Vcb(a,418099);r=t;return}o=a+768|0;k[o>>2]=34;i[s>>0]=c>>>23;i[s+1>>0]=c>>>15;i[s+2>>0]=c>>>7;i[s+3>>0]=c<<1;e=s+4|0;i[e>>0]=104;i[s+5>>0]=73;i[s+6>>0]=83;i[s+7>>0]=84;p=a+180|0;d=k[p>>2]|0;if(!d)Ucb(a,416435);Ph[d&511](a,s,8);g=a+376|0;k[g>>2]=1749635924;l=a+404|0;k[l>>2]=0;h=a+212|0;if((k[h>>2]&768|0)==768)d=0;else{d=yeb(0,e,4)|0;k[l>>2]=d}k[o>>2]=66;do if((c|0)>0){e=n+1|0;d=0;while(1){f=j[b+(d<<1)>>1]|0;i[n>>0]=(f&65535)>>>8;i[e>>0]=f;f=k[p>>2]|0;if(!f){d=10;break}Ph[f&511](a,n,2);f=k[h>>2]|0;if((k[g>>2]&536870912|0)==0?(f&2048|0)==0:(f&768|0)!=768){f=yeb(k[l>>2]|0,n,2)|0;k[l>>2]=f}d=d+1|0;if((d|0)==(c|0)){d=14;break}}if((d|0)==10)Ucb(a,416435);else if((d|0)==14){q=k[l>>2]|0;break}}else q=d;while(0);k[o>>2]=130;i[s>>0]=q>>>24;i[s+1>>0]=q>>>16;i[s+2>>0]=q>>>8;i[s+3>>0]=q;d=k[p>>2]|0;if(!d)Ucb(a,416435);Ph[d&511](a,s,4);r=t;return}function leb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+96|0;p=q+80|0;o=q;l=deb(a,b,o)|0;if(!l)Ucb(a,418145);if((c|0)!=0?(f=i[c>>0]|0,f<<24>>24!=0):0){j=c;a:do if(!(j&3)){d=c;h=9}else{g=c;b=j;d=f;while(1){if(!(d<<24>>24)){d=b;break a}d=g+1|0;b=d;if(!(b&3)){h=9;break a}g=d;d=i[d>>0]|0}}while(0);if((h|0)==9){while(1){b=k[d>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))d=d+4|0;else break}if((b&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}d=d-j|0;if(d>>>0>(2147483646-l|0)>>>0)Ucb(a,418167);else e=d}else e=0;b=l+1|0;d=b+e|0;if(!a){r=q;return}n=a+768|0;k[n>>2]=34;i[p>>0]=d>>>24;i[p+1>>0]=d>>>16;i[p+2>>0]=d>>>8;i[p+3>>0]=d;f=p+4|0;i[f>>0]=116;i[p+5>>0]=69;i[p+6>>0]=88;i[p+7>>0]=116;m=a+180|0;d=k[m>>2]|0;if(!d)Ucb(a,416435);Ph[d&511](a,p,8);h=a+376|0;k[h>>2]=1950701684;l=a+404|0;k[l>>2]=0;j=a+212|0;if((k[j>>2]&768|0)!=768){g=yeb(0,f,4)|0;k[l>>2]=g}k[n>>2]=66;if(b|0){d=k[m>>2]|0;if(!d)Ucb(a,416435);Ph[d&511](a,o,b);g=k[j>>2]|0;if((k[h>>2]&536870912|0)==0?(g&2048|0)==0:(g&768|0)!=768){f=o;g=k[l>>2]|0;while(1){d=(b|0)==0?-1:b;g=yeb(g,f,d)|0;b=b-d|0;if(!b)break;else f=f+d|0}k[l>>2]=g}}if((e|0)!=0&(c|0)!=0){d=k[m>>2]|0;if(!d)Ucb(a,416435);Ph[d&511](a,c,e);o=k[j>>2]|0;if((k[h>>2]&536870912|0)==0?(o&2048|0)==0:(o&768|0)!=768){b=c;f=k[l>>2]|0;while(1){d=(e|0)==0?-1:e;f=yeb(f,b,d)|0;e=e-d|0;if(!e)break;else b=b+d|0}k[l>>2]=f}}k[n>>2]=130;d=k[l>>2]|0;i[p>>0]=d>>>24;i[p+1>>0]=d>>>16;i[p+2>>0]=d>>>8;i[p+3>>0]=d;d=k[m>>2]|0;if(!d)Ucb(a,416435);Ph[d&511](a,p,4);r=q;return}function meb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+1136|0;t=u+1120|0;f=u+1036|0;q=u;switch(d|0){case -1:{leb(a,b,c,0);r=u;return}case 0:{b=deb(a,b,f)|0;if(!b)Ucb(a,418218);i[f+(b+1)>>0]=0;j=b+2|0;if(!c)b=0;else{h=c;a:do if(!(h&3)){b=c;g=10}else{b=c;d=h;while(1){if(!(i[b>>0]|0)){b=d;break a}b=b+1|0;d=b;if(!(d&3)){g=10;break}}}while(0);if((g|0)==10){while(1){d=k[b>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))b=b+4|0;else break}if((d&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}b=b-h|0}k[q>>2]=c;k[q+4>>2]=b;h=q+8|0;k[h>>2]=0;if(eeb(a,2052348020,q,j)|0)Ucb(a,k[a+248>>2]|0);b=k[h>>2]|0;d=b+j|0;s=(a|0)==0;b:do if(s){d=k[70]|0;b=b-(b>>>0<1024?b:1024)|0;e=(b|0)==0;if(!((d|0)==0|e)){f=k[71]|0;do{d=k[d>>2]|0;b=b-(f>>>0>b>>>0?b:f)|0;e=(b|0)==0}while(!((d|0)==0|e))}}else{g=a+768|0;k[g>>2]=34;i[t>>0]=d>>>24;i[t+1>>0]=d>>>16;i[t+2>>0]=d>>>8;i[t+3>>0]=d;d=t+4|0;i[d>>0]=122;i[t+5>>0]=84;i[t+6>>0]=88;i[t+7>>0]=116;p=a+180|0;b=k[p>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,t,8);m=a+376|0;k[m>>2]=2052348020;n=a+404|0;k[n>>2]=0;o=a+212|0;if((k[o>>2]&768|0)!=768){l=yeb(0,d,4)|0;k[n>>2]=l}k[g>>2]=66;if(j|0){b=k[p>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,f,j);l=k[o>>2]|0;if((k[m>>2]&536870912|0)==0?(l&2048|0)==0:(l&768|0)!=768){g=k[n>>2]|0;d=j;while(1){b=(d|0)==0?-1:d;g=yeb(g,f,b)|0;d=d-b|0;if(!d)break;else f=f+b|0}k[n>>2]=g}}l=a+284|0;b=a+280|0;g=1024;f=q+12|0;d=k[h>>2]|0;while(1){j=k[b>>2]|0;c=g>>>0>d>>>0?d:g;if(c|0){b=k[p>>2]|0;if(!b)break;Ph[b&511](a,f,c);q=k[o>>2]|0;if((k[m>>2]&536870912|0)==0?(q&2048|0)==0:(q&768|0)!=768){g=k[n>>2]|0;h=c;while(1){b=(h|0)==0?-1:h;g=yeb(g,f,b)|0;h=h-b|0;if(!h)break;else f=f+b|0}k[n>>2]=g}}d=d-c|0;b=(d|0)==0;if((j|0)==0|b){e=b;break b}b=j;g=k[l>>2]|0;f=j+4|0}Ucb(a,416435)}while(0);if(!e)Ucb(a,417547);do if(!s){k[a+768>>2]=130;e=k[a+404>>2]|0;i[t>>0]=e>>>24;i[t+1>>0]=e>>>16;i[t+2>>0]=e>>>8;i[t+3>>0]=e;e=k[a+180>>2]|0;if(!e)Ucb(a,416435);else{Ph[e&511](a,t,4);break}}while(0);r=u;return}default:Ucb(a,418187)}}function neb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+1136|0;x=y+1120|0;j=y+1036|0;w=y;c=deb(a,c,j)|0;if(!c)Ucb(a,418240);switch(b|0){case -1:case 1:{l=c+1|0;i[j+l>>0]=0;v=0;break}case 2:case 0:{l=c+1|0;i[j+l>>0]=1;v=1;break}default:Ucb(a,418262)}i[j+(l+1)>>0]=0;t=l+2|0;h=(d|0)==0?1016759:d;d=h;a:do if(!(d&3)){c=h;n=10}else{b=h;c=d;while(1){if(!(i[b>>0]|0))break a;b=b+1|0;c=b;if(!(c&3)){c=b;n=10;break}}}while(0);if((n|0)==10){while(1){b=k[c>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))c=c+4|0;else break}if((b&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}s=c-d+1|0;e=(e|0)==0?1016759:e;d=e;b:do if(!(d&3)){c=e;n=18}else{b=e;c=d;while(1){if(!(i[b>>0]|0))break b;b=b+1|0;c=b;if(!(c&3)){c=b;n=18;break}}}while(0);if((n|0)==18){while(1){b=k[c>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))c=c+4|0;else break}if((b&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}d=c-d+1|0;b=(f|0)==0?1016759:f;m=s>>>0>(2147483645-l|0)>>>0?2147483647:s+t|0;m=d>>>0>(2147483647-m|0)>>>0?2147483647:m+d|0;l=b;c:do if(!(l&3)){c=b;n=26}else{c=b;f=l;while(1){if(!(i[c>>0]|0)){c=f;break c}c=c+1|0;f=c;if(!(f&3)){n=26;break}}}while(0);if((n|0)==26){while(1){f=k[c>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))c=c+4|0;else break}if((f&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}c=c-l|0;k[w>>2]=b;k[w+4>>2]=c;q=w+8|0;k[q>>2]=0;do if(v)if(!(eeb(a,1767135348,w,m)|0)){o=k[q>>2]|0;break}else Ucb(a,k[a+248>>2]|0);else if(c>>>0>(2147483647-m|0)>>>0)Ucb(a,418288);else{k[q>>2]=c;o=c;break}while(0);c=o+m|0;u=(a|0)==0;if(!u){l=a+768|0;k[l>>2]=34;i[x>>0]=c>>>24;i[x+1>>0]=c>>>16;i[x+2>>0]=c>>>8;i[x+3>>0]=c;f=x+4|0;i[f>>0]=105;i[x+5>>0]=84;i[x+6>>0]=88;i[x+7>>0]=116;m=a+180|0;c=k[m>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,x,8);n=a+376|0;k[n>>2]=1767135348;p=a+404|0;k[p>>2]=0;o=a+212|0;if((k[o>>2]&768|0)!=768){f=yeb(0,f,4)|0;k[p>>2]=f}k[l>>2]=66;if(t|0){c=k[m>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,j,t);l=k[o>>2]|0;if((k[n>>2]&536870912|0)==0?(l&2048|0)==0:(l&768|0)!=768){l=k[p>>2]|0;f=t;while(1){c=(f|0)==0?-1:f;l=yeb(l,j,c)|0;f=f-c|0;if(!f)break;else j=j+c|0}k[p>>2]=l}}if((s|0)!=0&(h|0)!=0){c=k[m>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,h,s);t=k[o>>2]|0;if((k[n>>2]&536870912|0)==0?(t&2048|0)==0:(t&768|0)!=768){j=k[p>>2]|0;f=s;while(1){c=(f|0)==0?-1:f;j=yeb(j,h,c)|0;f=f-c|0;if(!f)break;else h=h+c|0}k[p>>2]=j}}if((d|0)!=0&(e|0)!=0){c=k[m>>2]|0;if(!c)Ucb(a,416435);Ph[c&511](a,e,d);t=k[o>>2]|0;if((k[n>>2]&536870912|0)==0?(t&2048|0)==0:(t&768|0)!=768){f=k[p>>2]|0;while(1){c=(d|0)==0?-1:d;f=yeb(f,e,c)|0;d=d-c|0;if(!d)break;else e=e+c|0}k[p>>2]=f;d=1}else d=1}else d=1}else d=0;c=k[q>>2]|0;if(v){b=a+280|0;p=a+284|0;d:do if(u){b=k[b>>2]|0;c=c-(c>>>0<1024?c:1024)|0;g=(c|0)==0;if(!((b|0)==0|g)){d=k[p>>2]|0;do{b=k[b>>2]|0;c=c-(d>>>0>c>>>0?c:d)|0;g=(c|0)==0}while(!((b|0)==0|g))}}else{l=a+180|0;m=a+376|0;n=a+212|0;o=a+404|0;e=1024;d=w+12|0;while(1){j=k[b>>2]|0;h=e>>>0>c>>>0?c:e;if(h|0){b=k[l>>2]|0;if(!b)break;Ph[b&511](a,d,h);w=k[n>>2]|0;if((k[m>>2]&536870912|0)==0?(w&2048|0)==0:(w&768|0)!=768){e=k[o>>2]|0;f=h;while(1){b=(f|0)==0?-1:f;e=yeb(e,d,b)|0;f=f-b|0;if(!f)break;else d=d+b|0}k[o>>2]=e}}c=c-h|0;b=(c|0)==0;if((j|0)==0|b){g=b;break d}b=j;e=k[p>>2]|0;d=j+4|0}Ucb(a,416435)}while(0);if(!g)Ucb(a,417547)}else if((b|0)!=0&d&(c|0)!=0){g=k[a+180>>2]|0;if(!g)Ucb(a,416435);Ph[g&511](a,b,c);w=k[a+212>>2]|0;if((k[a+376>>2]&536870912|0)==0?(w&2048|0)==0:(w&768|0)!=768){e=a+404|0;d=k[e>>2]|0;while(1){g=(c|0)==0?-1:c;d=yeb(d,b,g)|0;c=c-g|0;if(!c)break;else b=b+g|0}k[e>>2]=d}}if(u){r=y;return}k[a+768>>2]=130;g=k[a+404>>2]|0;i[x>>0]=g>>>24;i[x+1>>0]=g>>>16;i[x+2>>0]=g>>>8;i[x+3>>0]=g;g=k[a+180>>2]|0;if(!g)Ucb(a,416435);Ph[g&511](a,x,4);r=y;return}function oeb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+32|0;l=m+16|0;j=m;if((d|0)>1)Vcb(a,418321);i[j>>0]=b>>>24;i[j+1>>0]=b>>>16;i[j+2>>0]=b>>>8;i[j+3>>0]=b;i[j+4>>0]=c>>>24;i[j+5>>0]=c>>>16;i[j+6>>0]=c>>>8;i[j+7>>0]=c;i[j+8>>0]=d;if(!a){r=m;return}g=a+768|0;k[g>>2]=34;i[l>>0]=0;i[l+1>>0]=0;i[l+2>>0]=0;i[l+3>>0]=9;c=l+4|0;i[c>>0]=111;i[l+5>>0]=70;i[l+6>>0]=70;i[l+7>>0]=115;h=a+180|0;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,l,8);e=a+376|0;k[e>>2]=1866876531;f=a+404|0;k[f>>2]=0;d=a+212|0;if((k[d>>2]&768|0)!=768){c=yeb(0,c,4)|0;k[f>>2]=c}k[g>>2]=66;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,j,9);d=k[d>>2]|0;b=k[f>>2]|0;if((k[e>>2]&536870912|0)==0?(d&2048|0)==0:(d&768|0)!=768){b=yeb(b,j,9)|0;k[f>>2]=b}k[g>>2]=130;i[l>>0]=b>>>24;i[l+1>>0]=b>>>16;i[l+2>>0]=b>>>8;i[l+3>>0]=b;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,l,4);r=m;return}function peb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+112|0;y=z+96|0;v=z+80|0;u=z;if((e|0)>3)Ucb(a,418359);n=deb(a,b,u)|0;if(!n)Ucb(a,418401);l=n+1|0;m=g;a:do if(!(m&3)){b=g;s=8}else{j=g;b=m;while(1){if(!(i[j>>0]|0))break a;j=j+1|0;b=j;if(!(b&3)){b=j;s=8;break}}}while(0);if((s|0)==8){while(1){j=k[b>>2]|0;if(!((j&-2139062144^-2139062144)&j+-16843009))b=b+4|0;else break}if((j&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}j=b-m+((f|0)!=0&1)|0;n=n+11+j|0;b=f<<2;w=(a|0)==0;if(!w){if(!b)Ucb(a,412758);m=k[a+688>>2]|0;if(!m)b=fgb(b)|0;else b=Hh[m&511](a,b)|0;if(!b)Ucb(a,412758);else x=b}else x=0;t=(f|0)>0;if(t){q=f+-1|0;b=n;p=0;do{m=k[h+(p<<2)>>2]|0;o=m;b:do if(!(o&3))s=25;else{n=m;m=o;while(1){if(!(i[n>>0]|0))break b;n=n+1|0;m=n;if(!(m&3)){m=n;s=25;break}}}while(0);if((s|0)==25){s=0;while(1){n=k[m>>2]|0;if(!((n&-2139062144^-2139062144)&n+-16843009))m=m+4|0;else break}if((n&255)<<24>>24)do m=m+1|0;while((i[m>>0]|0)!=0)}o=m-o+((p|0)!=(q|0)&1)|0;k[x+(p<<2)>>2]=o;b=o+b|0;p=p+1|0}while((p|0)!=(f|0))}else b=n;if(!w){q=a+768|0;k[q>>2]=34;i[y>>0]=b>>>24;i[y+1>>0]=b>>>16;i[y+2>>0]=b>>>8;i[y+3>>0]=b;m=y+4|0;i[m>>0]=112;i[y+5>>0]=67;i[y+6>>0]=65;i[y+7>>0]=76;n=a+180|0;b=k[n>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,y,8);o=a+376|0;k[o>>2]=1883455820;s=a+404|0;k[s>>2]=0;p=a+212|0;if((k[p>>2]&768|0)!=768){m=yeb(0,m,4)|0;k[s>>2]=m}k[q>>2]=66;if(l){b=k[n>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,u,l);q=k[p>>2]|0;if((k[o>>2]&536870912|0)==0?(q&2048|0)==0:(q&768|0)!=768){m=u;n=k[s>>2]|0;while(1){b=(l|0)==0?-1:l;n=yeb(n,m,b)|0;l=l-b|0;if(!l)break;else m=m+b|0}k[s>>2]=n;b=1}else b=1}else b=1}else b=0;i[v>>0]=c>>>24;i[v+1>>0]=c>>>16;i[v+2>>0]=c>>>8;i[v+3>>0]=c;i[v+4>>0]=d>>>24;i[v+5>>0]=d>>>16;i[v+6>>0]=d>>>8;i[v+7>>0]=d;i[v+8>>0]=e;i[v+9>>0]=f;c:do if(b){q=a+180|0;b=k[q>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,v,10);o=a+376|0;p=a+212|0;e=k[p>>2]|0;if((k[o>>2]&536870912|0)==0?(e&2048|0)==0:(e&768|0)!=768){e=a+404|0;v=yeb(k[e>>2]|0,v,10)|0;k[e>>2]=v}if((j|0)!=0&(g|0)!=0){b=k[q>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,g,j);v=k[p>>2]|0;if((k[o>>2]&536870912|0)==0?(v&2048|0)==0:(v&768|0)!=768){m=a+404|0;l=k[m>>2]|0;while(1){b=(j|0)==0?-1:j;l=yeb(l,g,b)|0;j=j-b|0;if(!j)break;else g=g+b|0}k[m>>2]=l}}if(t){n=a+404|0;m=0;while(1){b=k[h+(m<<2)>>2]|0;g=k[x+(m<<2)>>2]|0;if((b|0)!=0&(g|0)!=0){j=k[q>>2]|0;if(!j)break;Ph[j&511](a,b,g);v=k[p>>2]|0;if((k[o>>2]&536870912|0)==0?(v&2048|0)==0:(v&768|0)!=768){l=k[n>>2]|0;while(1){j=(g|0)==0?-1:g;l=yeb(l,b,j)|0;g=g-j|0;if(!g)break;else b=b+j|0}k[n>>2]=l}}m=m+1|0;if((m|0)==(f|0))break c}Ucb(a,416435)}}while(0);do if(!(w|(x|0)==0)){b=k[a+692>>2]|0;if(!b){ggb(x);break}else{jh[b&1023](a,x);break}}while(0);if(w){r=z;return}k[a+768>>2]=130;b=k[a+404>>2]|0;i[y>>0]=b>>>24;i[y+1>>0]=b>>>16;i[y+2>>0]=b>>>8;i[y+3>>0]=b;b=k[a+180>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,y,4);r=z;return}function qeb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+80|0;m=n+64|0;h=n;g=c;a:do if(!(g&3)){e=c;l=4}else{f=c;e=g;while(1){if(!(i[f>>0]|0))break a;f=f+1|0;e=f;if(!(e&3)){e=f;l=4;break}}}while(0);if((l|0)==4){while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}j=e-g|0;g=d;b:do if(!(g&3)){e=d;l=12}else{e=d;f=g;while(1){if(!(i[e>>0]|0)){e=f;break b}e=e+1|0;f=e;if(!(f&3)){l=12;break}}}while(0);if((l|0)==12){while(1){f=k[e>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))e=e+4|0;else break}if((f&255)<<24>>24)do e=e+1|0;while((i[e>>0]|0)!=0)}e=e-g|0;g=j+2+e|0;if(g>>>0>64){Vcb(a,418423);r=n;return}i[h>>0]=b;upb(h+1|0,c|0,j+1|0)|0;upb(h+j+2|0,d|0,e|0)|0;if(!a){r=n;return}c=a+768|0;k[c>>2]=34;i[m>>0]=g>>>24;i[m+1>>0]=g>>>16;i[m+2>>0]=g>>>8;i[m+3>>0]=g;f=m+4|0;i[f>>0]=115;i[m+5>>0]=67;i[m+6>>0]=65;i[m+7>>0]=76;d=a+180|0;e=k[d>>2]|0;if(!e)Ucb(a,416435);Ph[e&511](a,m,8);l=a+376|0;k[l>>2]=1933787468;b=a+404|0;k[b>>2]=0;j=a+212|0;if((k[j>>2]&768|0)==768)e=0;else{e=yeb(0,f,4)|0;k[b>>2]=e}k[c>>2]=66;if(g){e=k[d>>2]|0;if(!e)Ucb(a,416435);Ph[e&511](a,h,g);j=k[j>>2]|0;e=k[b>>2]|0;if((k[l>>2]&536870912|0)==0?(j&2048|0)==0:(j&768|0)!=768){while(1){f=(g|0)==0?-1:g;e=yeb(e,h,f)|0;g=g-f|0;if(!g)break;else h=h+f|0}k[b>>2]=e}}k[c>>2]=130;i[m>>0]=e>>>24;i[m+1>>0]=e>>>16;i[m+2>>0]=e>>>8;i[m+3>>0]=e;e=k[d>>2]|0;if(!e)Ucb(a,416435);Ph[e&511](a,m,4);r=n;return}function reb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+32|0;l=m+16|0;j=m;if((d|0)>1)Vcb(a,418459);i[j>>0]=b>>>24;i[j+1>>0]=b>>>16;i[j+2>>0]=b>>>8;i[j+3>>0]=b;i[j+4>>0]=c>>>24;i[j+5>>0]=c>>>16;i[j+6>>0]=c>>>8;i[j+7>>0]=c;i[j+8>>0]=d;if(!a){r=m;return}g=a+768|0;k[g>>2]=34;i[l>>0]=0;i[l+1>>0]=0;i[l+2>>0]=0;i[l+3>>0]=9;c=l+4|0;i[c>>0]=112;i[l+5>>0]=72;i[l+6>>0]=89;i[l+7>>0]=115;h=a+180|0;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,l,8);e=a+376|0;k[e>>2]=1883789683;f=a+404|0;k[f>>2]=0;d=a+212|0;if((k[d>>2]&768|0)!=768){c=yeb(0,c,4)|0;k[f>>2]=c}k[g>>2]=66;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,j,9);d=k[d>>2]|0;b=k[f>>2]|0;if((k[e>>2]&536870912|0)==0?(d&2048|0)==0:(d&768|0)!=768){b=yeb(b,j,9)|0;k[f>>2]=b}k[g>>2]=130;i[l>>0]=b>>>24;i[l+1>>0]=b>>>16;i[l+2>>0]=b>>>8;i[l+3>>0]=b;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,l,4);r=m;return}function seb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0;n=r;r=r+16|0;m=n+8|0;l=n;c=j[b+2>>1]|0;g=c&255;c=(c&65535)>>>8&255;if((!((g+-1&255)>11|(c+-1&255)>30)?(e=j[b+4>>1]|0,d=e&255,e=(e&65535)>>>8&255,(d&255)<=23):0)?(f=i[b+6>>0]|0,(f&255)<=60):0){h=j[b>>1]|0;i[l>>0]=(h&65535)>>>8;i[l+1>>0]=h;i[l+2>>0]=g;i[l+3>>0]=c;i[l+4>>0]=d;i[l+5>>0]=e;i[l+6>>0]=f;if(!a){r=n;return}g=a+768|0;k[g>>2]=34;i[m>>0]=0;i[m+1>>0]=0;i[m+2>>0]=0;i[m+3>>0]=7;c=m+4|0;i[c>>0]=116;i[m+5>>0]=73;i[m+6>>0]=77;i[m+7>>0]=69;h=a+180|0;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,m,8);e=a+376|0;k[e>>2]=1950960965;f=a+404|0;k[f>>2]=0;d=a+212|0;if((k[d>>2]&768|0)!=768){c=yeb(0,c,4)|0;k[f>>2]=c}k[g>>2]=66;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,l,7);d=k[d>>2]|0;b=k[f>>2]|0;if((k[e>>2]&536870912|0)==0?(d&2048|0)==0:(d&768|0)!=768){b=yeb(b,l,7)|0;k[f>>2]=b}k[g>>2]=130;i[m>>0]=b>>>24;i[m+1>>0]=b>>>16;i[m+2>>0]=b>>>8;i[m+3>>0]=b;b=k[h>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,m,4);r=n;return}Vcb(a,418497);r=n;return}function teb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;c=aa(l[a+429>>0]|0,l[a+432>>0]|0)|0;h=a+348|0;b=k[h>>2]|0;if(c>>>0>7)b=aa(c>>>3,b)|0;else b=((aa(c,b)|0)+7|0)>>>3;g=b+1|0;i[a+435>>0]=i[a+430>>0]|0;i[a+434>>0]=c;if(!g)Ucb(a,412758);d=a+688|0;b=k[d>>2]|0;if(!b)b=fgb(g)|0;else b=Hh[b&511](a,g)|0;if(!b)Ucb(a,412758);k[a+384>>2]=b;i[b>>0]=0;b=a+426|0;c=i[b>>0]|0;e=a+352|0;c=(k[e>>2]|0)==1?c&31:c;c=(k[h>>2]|0)==1?c&47:c;c=c<<24>>24==0?8:c;i[b>>0]=c;c=c&255;do if(c&240|0?(f=a+388|0,(k[f>>2]|0)==0):0){b=k[d>>2]|0;if(!b)b=fgb(g)|0;else b=Hh[b&511](a,g)|0;if(!b)Ucb(a,412758);k[f>>2]=b;if(((c>>>5&1)+(c>>>7)+(c>>>4&1)+(c>>>6&1)|0)>>>0>1){b=k[d>>2]|0;if(!b)b=fgb(g)|0;else b=Hh[b&511](a,g)|0;if(!b)Ucb(a,412758);else{k[a+392>>2]=b;break}}}while(0);do if(c&224|0){b=k[d>>2]|0;if(!b)b=fgb(g)|0;else b=Hh[b&511](a,g)|0;if(!b)Ucb(a,412758);else{zpb(b|0,0,g|0)|0;k[a+380>>2]=b;break}}while(0);if(!(i[a+424>>0]|0)){k[a+356>>2]=k[e>>2];k[a+360>>2]=k[h>>2];return}b=k[e>>2]|0;if(!(k[a+216>>2]&2)){k[a+356>>2]=(b+7|0)>>>3;k[a+360>>2]=((k[h>>2]|0)+7|0)>>>3;return}else{k[a+356>>2]=b;k[a+360>>2]=k[h>>2];return}}function ueb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0;c=a+372|0;g=(k[c>>2]|0)+1|0;k[c>>2]=g;h=a+356|0;if(g>>>0<(k[h>>2]|0)>>>0)return;g=j[a+424>>1]|0;b=(g&65535)>>>8&255;if((g&255)<<24>>24){k[c>>2]=0;if(!(k[a+216>>2]&2)){d=a+348|0;e=a+425|0;f=a+360|0;g=a+352|0;do{b=b+1<<24>>24;c=b&255;if((b&255)>6)break;n=l[418535+c>>0]|0;m=(k[d>>2]|0)+-1+n-(l[418542+c>>0]|0)|0;k[f>>2]=(m>>>0)/(n>>>0)|0;o=l[418549+c>>0]|0;c=(k[g>>2]|0)+-1+o-(l[418556+c>>0]|0)|0;k[h>>2]=(c>>>0)/(o>>>0)|0}while(o>>>0>c>>>0|n>>>0>m>>>0);i[e>>0]=b}else{b=b+1<<24>>24;i[a+425>>0]=b}if((b&255)<7){d=k[a+380>>2]|0;if(!d)return;c=aa(l[a+429>>0]|0,l[a+432>>0]|0)|0;b=k[a+348>>2]|0;if(c>>>0>7)b=aa(c>>>3,b)|0;else b=((aa(c,b)|0)+7|0)>>>3;zpb(d|0,0,b+1|0)|0;return}}Ydb(a,0,0,4);return}function veb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;r=i[a+426>>0]|0;t=b+4|0;s=k[t>>2]|0;p=((l[b+11>>0]|0)+7|0)>>>3;u=a+384|0;b=k[u>>2]|0;q=r&255;a:do if(!(r<<24>>24==8|(q&8|0)==0)){c=b+1|0;if(s>>>0>33554430){d=0;e=0;while(1){n=i[c>>0]|0;o=n&255;d=(n<<24>>24>-1?o:256-o|0)+d|0;e=e+1|0;if(e>>>0>=s>>>0|d>>>0>33554175)break a;else c=c+1|0}}if(!s)d=0;else{d=0;e=0;while(1){n=i[c>>0]|0;o=n&255;d=(n<<24>>24>-1?o:256-o|0)+d|0;e=e+1|0;if((e|0)==(s|0))break;else c=c+1|0}}}else d=-257;while(0);if(r<<24>>24!=16){if(q&16){j=a+388|0;h=k[j>>2]|0;i[h>>0]=1;f=h+1|0;c=b+1|0;if(!p){e=0;g=0}else{g=0;e=0;while(1){n=i[c>>0]|0;i[f>>0]=n;o=n&255;e=(n<<24>>24>-1?o:256-o|0)+e|0;g=g+1|0;if((g|0)==(p|0))break;else{f=f+1|0;c=c+1|0}}c=p+1|0;g=p;f=h+c|0;c=b+c|0}b:do if(g>>>0<s>>>0){h=b;while(1){h=h+1|0;o=(l[c>>0]|0)-(l[h>>0]|0)|0;i[f>>0]=o;o=o&255;e=(o>>>0<128?o:256-o|0)+e|0;if(e>>>0>d>>>0)break b;g=g+1|0;if(g>>>0>=s>>>0)break;else{f=f+1|0;c=c+1|0}}}while(0);if(e>>>0<d>>>0){b=k[j>>2]|0;c=a+392|0;d=k[c>>2]|0;if(!d)d=e;else{k[j>>2]=d;k[c>>2]=b;d=e}}}}else{j=a+388|0;h=k[j>>2]|0;i[h>>0]=1;f=h+1|0;e=b+1|0;if(!p){c=0;g=0}else{g=0;c=0;while(1){n=i[e>>0]|0;i[f>>0]=n;o=n&255;c=(n<<24>>24>-1?o:256-o|0)+c|0;g=g+1|0;if((g|0)==(p|0))break;else{f=f+1|0;e=e+1|0}}e=p+1|0;g=p;f=h+e|0;e=b+e|0}c:do if(g>>>0<s>>>0)while(1){b=b+1|0;o=(l[e>>0]|0)-(l[b>>0]|0)|0;i[f>>0]=o;o=o&255;c=(o>>>0<128?o:256-o|0)+c|0;if(c>>>0>d>>>0)break c;g=g+1|0;if(g>>>0>=s>>>0)break;else{f=f+1|0;e=e+1|0}}while(0);b=k[j>>2]|0}if(r<<24>>24!=32){if(q&32){f=k[a+380>>2]|0;g=k[u>>2]|0;j=a+388|0;c=k[j>>2]|0;i[c>>0]=2;if(!s)e=0;else{e=0;h=0;do{g=g+1|0;f=f+1|0;c=c+1|0;o=(l[g>>0]|0)-(l[f>>0]|0)|0;i[c>>0]=o;o=o&255;e=(o>>>0<128?o:256-o|0)+e|0;h=h+1|0}while(h>>>0<s>>>0&e>>>0<=d>>>0)}if(e>>>0<d>>>0){b=k[j>>2]|0;c=a+392|0;d=k[c>>2]|0;if(!d)d=e;else{k[j>>2]=d;k[c>>2]=b;d=e}}}}else{e=k[a+380>>2]|0;c=k[u>>2]|0;h=a+388|0;b=k[h>>2]|0;i[b>>0]=2;if(s|0){f=0;g=0;do{c=c+1|0;e=e+1|0;b=b+1|0;o=(l[c>>0]|0)-(l[e>>0]|0)|0;i[b>>0]=o;o=o&255;f=(o>>>0<128?o:256-o|0)+f|0;g=g+1|0}while(g>>>0<s>>>0&f>>>0<=d>>>0)}b=k[h>>2]|0}if(r<<24>>24!=64)if(q&64){o=a+388|0;n=k[o>>2]|0;i[n>>0]=3;e=k[u>>2]|0;m=k[a+380>>2]|0;g=m+1|0;h=n+1|0;f=e+1|0;if(!p){c=0;j=0}else{j=0;c=0;while(1){v=(l[f>>0]|0)-((l[g>>0]|0)>>>1&255)|0;i[h>>0]=v;v=v&255;c=(v>>>0<128?v:256-v|0)+c|0;j=j+1|0;if((j|0)==(p|0))break;else{g=g+1|0;h=h+1|0;f=f+1|0}}f=p+1|0;j=p;g=m+f|0;h=n+f|0;f=e+f|0;e=k[u>>2]|0}d:do if(j>>>0<s>>>0)while(1){e=e+1|0;v=(l[f>>0]|0)-(((l[e>>0]|0)+(l[g>>0]|0)|0)>>>1)|0;i[h>>0]=v;v=v&255;c=(v>>>0<128?v:256-v|0)+c|0;if(c>>>0>d>>>0)break d;j=j+1|0;if(j>>>0>=s>>>0)break;else{g=g+1|0;h=h+1|0;f=f+1|0}}while(0);if(c>>>0<d>>>0){b=k[o>>2]|0;d=a+392|0;e=k[d>>2]|0;if(e){k[o>>2]=e;k[d>>2]=b}}else c=d}else c=d;else{n=a+388|0;m=k[n>>2]|0;i[m>>0]=3;c=k[u>>2]|0;j=k[a+380>>2]|0;g=j+1|0;f=m+1|0;e=c+1|0;if(!p){b=0;h=0}else{h=0;b=0;while(1){v=(l[e>>0]|0)-((l[g>>0]|0)>>>1&255)|0;i[f>>0]=v;v=v&255;b=(v>>>0<128?v:256-v|0)+b|0;h=h+1|0;if((h|0)==(p|0))break;else{g=g+1|0;f=f+1|0;e=e+1|0}}e=p+1|0;h=p;g=j+e|0;f=m+e|0;e=c+e|0;c=k[u>>2]|0}e:do if(h>>>0<s>>>0)while(1){c=c+1|0;v=(l[e>>0]|0)-(((l[c>>0]|0)+(l[g>>0]|0)|0)>>>1)|0;i[f>>0]=v;v=v&255;b=(v>>>0<128?v:256-v|0)+b|0;if(b>>>0>d>>>0)break e;h=h+1|0;if(h>>>0>=s>>>0)break;else{g=g+1|0;f=f+1|0;e=e+1|0}}while(0);b=k[n>>2]|0;c=d}if(r<<24>>24!=-128){if((q&128|0)!=0?(web(a,p,s,c)|0)>>>0<c>>>0:0){c=a+388|0;b=k[c>>2]|0;d=a+392|0;e=k[d>>2]|0;if(e){k[c>>2]=e;k[d>>2]=b}}}else{web(a,p,s,c)|0;b=k[a+388>>2]|0}Ydb(a,b,(k[t>>2]|0)+1|0,0);b=a+380|0;c=k[b>>2]|0;if(c|0){k[b>>2]=k[u>>2];k[u>>2]=c}ueb(a);b=a+472|0;v=(k[b>>2]|0)+1|0;k[b>>2]=v;if(((k[a+468>>2]|0)+-1|0)>>>0>=v>>>0)return;if((k[a+372>>2]|0)>>>0>=(k[a+356>>2]|0)>>>0)return;Ydb(a,0,0,2);k[b>>2]=0;b=k[a+464>>2]|0;if(!b)return;Uh[b&2047](a);return}function web(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;o=k[a+388>>2]|0;i[o>>0]=4;q=a+384|0;e=k[q>>2]|0;p=a+380|0;f=k[p>>2]|0;a=e+1|0;h=o+1|0;g=f+1|0;if(!b){j=a;a=0;b=0}else{n=b+1|0;m=a;a=0;j=0;while(1){r=(l[m>>0]|0)-(l[g>>0]|0)|0;i[h>>0]=r;r=r&255;a=(r>>>0<128?r:256-r|0)+a|0;j=j+1|0;if((j|0)==(b|0))break;else{m=m+1|0;h=h+1|0;g=g+1|0}}j=e+n|0;h=o+n|0;g=f+n|0;f=k[p>>2]|0;e=k[q>>2]|0}if(b>>>0>=c>>>0){r=a;return r|0}while(1){f=f+1|0;e=e+1|0;p=l[g>>0]|0;q=l[f>>0]|0;r=l[e>>0]|0;o=p-q|0;s=r-q|0;m=(o|0)<0?0-o|0:o;n=(s|0)<0?0-s|0:s;o=s+o|0;o=(o|0)<0?0-o|0:o;r=(l[j>>0]|0)-((m|0)>(n|0)|(m|0)>(o|0)?((n|0)<=(o|0)?p:q):r)|0;i[h>>0]=r;r=r&255;a=(r>>>0<128?r:256-r|0)+a|0;if(a>>>0>d>>>0){b=8;break}b=b+1|0;if(b>>>0>=c>>>0){b=8;break}else{j=j+1|0;h=h+1|0;g=g+1|0}}if((b|0)==8)return a|0;return 0}function xeb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=a>>>16;a=a&65535;if((c|0)==1){g=(l[b>>0]|0)+a|0;g=g>>>0>65520?g+-65521|0:g;f=g+d|0;g=(f>>>0>65520?f+15|0:f)<<16|g;return g|0}if(!b){g=1;return g|0}if(c>>>0<16){if(c)while(1){c=c+-1|0;a=(l[b>>0]|0)+a|0;d=a+d|0;if(!c)break;else b=b+1|0}g=((d>>>0)%65521|0)<<16|(a>>>0>65520?a+-65521|0:a);return g|0}if(c>>>0>5551){do{e=347;f=b;while(1){w=(l[f>>0]|0)+a|0;v=w+(l[f+1>>0]|0)|0;u=v+(l[f+2>>0]|0)|0;t=u+(l[f+3>>0]|0)|0;s=t+(l[f+4>>0]|0)|0;r=s+(l[f+5>>0]|0)|0;q=r+(l[f+6>>0]|0)|0;p=q+(l[f+7>>0]|0)|0;o=p+(l[f+8>>0]|0)|0;n=o+(l[f+9>>0]|0)|0;m=n+(l[f+10>>0]|0)|0;k=m+(l[f+11>>0]|0)|0;j=k+(l[f+12>>0]|0)|0;i=j+(l[f+13>>0]|0)|0;h=i+(l[f+14>>0]|0)|0;a=h+(l[f+15>>0]|0)|0;d=w+d+v+u+t+s+r+q+p+o+n+m+k+j+i+h+a|0;e=e+-1|0;if(!e)break;else f=f+16|0}c=c+-5552|0;b=b+5552|0;a=(a>>>0)%65521|0;d=(d>>>0)%65521|0}while(c>>>0>5551);if(c)if(c>>>0>15)g=14;else g=17}else g=14;if((g|0)==14){f=c+-16|0;g=f&-16;e=b;while(1){c=c+-16|0;h=(l[e>>0]|0)+a|0;i=h+(l[e+1>>0]|0)|0;j=i+(l[e+2>>0]|0)|0;k=j+(l[e+3>>0]|0)|0;m=k+(l[e+4>>0]|0)|0;n=m+(l[e+5>>0]|0)|0;o=n+(l[e+6>>0]|0)|0;p=o+(l[e+7>>0]|0)|0;q=p+(l[e+8>>0]|0)|0;r=q+(l[e+9>>0]|0)|0;s=r+(l[e+10>>0]|0)|0;t=s+(l[e+11>>0]|0)|0;u=t+(l[e+12>>0]|0)|0;v=u+(l[e+13>>0]|0)|0;w=v+(l[e+14>>0]|0)|0;a=w+(l[e+15>>0]|0)|0;d=h+d+i+j+k+m+n+o+p+q+r+s+t+u+v+w+a|0;if(c>>>0<=15)break;else e=e+16|0}c=f-g|0;if(!c)g=18;else{b=b+(g+16)|0;g=17}}if((g|0)==17)while(1){c=c+-1|0;a=(l[b>>0]|0)+a|0;d=a+d|0;if(!c){g=18;break}else{b=b+1|0;g=17}}if((g|0)==18){d=(d>>>0)%65521|0;a=(a>>>0)%65521|0}w=d<<16|a;return w|0}function yeb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;if(!b){g=0;return g|0}a=~a;a:do if(c){while(1){if(!(b&3))break;a=k[156560+(((l[b>>0]|0)^a&255)<<2)>>2]^a>>>8;c=c+-1|0;if(!c)break a;else b=b+1|0}if(c>>>0>31){f=c+-32|0;g=f&-32;e=g+32|0;d=b;while(1){h=k[d>>2]^a;h=k[158608+((h>>>8&255)<<2)>>2]^k[159632+((h&255)<<2)>>2]^k[157584+((h>>>16&255)<<2)>>2]^k[156560+(h>>>24<<2)>>2]^k[d+4>>2];h=k[158608+((h>>>8&255)<<2)>>2]^k[159632+((h&255)<<2)>>2]^k[157584+((h>>>16&255)<<2)>>2]^k[156560+(h>>>24<<2)>>2]^k[d+8>>2];h=k[158608+((h>>>8&255)<<2)>>2]^k[159632+((h&255)<<2)>>2]^k[157584+((h>>>16&255)<<2)>>2]^k[156560+(h>>>24<<2)>>2]^k[d+12>>2];h=k[158608+((h>>>8&255)<<2)>>2]^k[159632+((h&255)<<2)>>2]^k[157584+((h>>>16&255)<<2)>>2]^k[156560+(h>>>24<<2)>>2]^k[d+16>>2];h=k[158608+((h>>>8&255)<<2)>>2]^k[159632+((h&255)<<2)>>2]^k[157584+((h>>>16&255)<<2)>>2]^k[156560+(h>>>24<<2)>>2]^k[d+20>>2];h=k[158608+((h>>>8&255)<<2)>>2]^k[159632+((h&255)<<2)>>2]^k[157584+((h>>>16&255)<<2)>>2]^k[156560+(h>>>24<<2)>>2]^k[d+24>>2];h=k[158608+((h>>>8&255)<<2)>>2]^k[159632+((h&255)<<2)>>2]^k[157584+((h>>>16&255)<<2)>>2]^k[156560+(h>>>24<<2)>>2]^k[d+28>>2];a=k[158608+((h>>>8&255)<<2)>>2]^k[159632+((h&255)<<2)>>2]^k[157584+((h>>>16&255)<<2)>>2]^k[156560+(h>>>24<<2)>>2];c=c+-32|0;if(c>>>0<=31)break;else d=d+32|0}b=b+e|0;c=f-g|0}if(c>>>0>3){e=c+-4|0;f=e>>>2;d=b;while(1){h=k[d>>2]^a;a=k[158608+((h>>>8&255)<<2)>>2]^k[159632+((h&255)<<2)>>2]^k[157584+((h>>>16&255)<<2)>>2]^k[156560+(h>>>24<<2)>>2];c=c+-4|0;if(c>>>0<=3)break;else d=d+4|0}b=b+(f+1<<2)|0;c=e-(f<<2)|0}if(c)while(1){a=k[156560+(((l[b>>0]|0)^a&255)<<2)>>2]^a>>>8;c=c+-1|0;if(!c)break;else b=b+1|0}}while(0);h=~a;return h|0}function zeb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!g){o=-6;return o|0}if((h|0)!=56|(i[g>>0]|0)!=49){o=-6;return o|0}if(!a){o=-2;return o|0}n=a+24|0;k[n>>2]=0;m=a+32|0;g=k[m>>2]|0;if(!g){k[m>>2]=151;k[a+40>>2]=0;g=151}o=a+36|0;if(!(k[o>>2]|0))k[o>>2]=851;l=(b|0)==-1?6:b;if((d|0)<0){j=0;h=0-d|0}else{h=(d|0)>15;j=h?2:1;h=h?d+-16|0:d}if(f>>>0>4|(l>>>0>9|((c|0)!=8|(e+-1|0)>>>0>8|(h&-8|0)!=8))){o=-2;return o|0}h=(h|0)==8?9:h;c=a+40|0;b=ci[g&255](k[c>>2]|0,1,5828)|0;if(!b){o=-4;return o|0}d=a+28|0;k[d>>2]=b;k[b>>2]=a;k[b+24>>2]=j;k[b+28>>2]=0;k[b+48>>2]=h;p=1<<h;j=b+44|0;k[j>>2]=p;k[b+52>>2]=p+-1;q=e+7|0;k[b+80>>2]=q;q=1<<q;g=b+76|0;k[g>>2]=q;k[b+84>>2]=q+-1;k[b+88>>2]=((e+9|0)>>>0)/3|0;p=ci[k[m>>2]&255](k[c>>2]|0,p,2)|0;q=b+56|0;k[q>>2]=p;j=ci[k[m>>2]&255](k[c>>2]|0,k[j>>2]|0,2)|0;p=b+64|0;k[p>>2]=j;g=ci[k[m>>2]&255](k[c>>2]|0,k[g>>2]|0,2)|0;j=b+68|0;k[j>>2]=g;k[b+5824>>2]=0;g=1<<e+6;h=b+5788|0;k[h>>2]=g;g=ci[k[m>>2]&255](k[c>>2]|0,g,4)|0;k[b+8>>2]=g;h=k[h>>2]|0;k[b+12>>2]=h<<2;if((k[q>>2]|0?k[p>>2]|0:0)?!((k[j>>2]|0)==0|(g|0)==0):0){k[b+5796>>2]=g+(h>>>1<<1);k[b+5784>>2]=g+(h*3|0);k[b+132>>2]=l;k[b+136>>2]=f;i[b+36>>0]=8;q=Aeb(a)|0;return q|0}k[b+4>>2]=666;k[n>>2]=420017;g=k[d>>2]|0;if(!g){q=-4;return q|0}switch(k[g+4>>2]|0){case 42:case 69:case 73:case 91:case 103:case 113:case 666:break;default:{q=-4;return q|0}}h=k[g+8>>2]|0;if(h){jh[k[o>>2]&1023](k[c>>2]|0,h);g=k[d>>2]|0}h=k[g+68>>2]|0;if(h){jh[k[o>>2]&1023](k[c>>2]|0,h);g=k[d>>2]|0}h=k[g+64>>2]|0;if(h){jh[k[o>>2]&1023](k[c>>2]|0,h);g=k[d>>2]|0}h=k[g+56>>2]|0;if(h){jh[k[o>>2]&1023](k[c>>2]|0,h);g=k[d>>2]|0}jh[k[o>>2]&1023](k[c>>2]|0,g);k[d>>2]=0;q=-4;return q|0}function Aeb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;if(!a){f=-2;return f|0}e=a+28|0;f=k[e>>2]|0;if(!f){f=-2;return f|0}if(!(k[a+32>>2]|0)){f=-2;return f|0}if(!(k[a+36>>2]|0)){f=-2;return f|0}k[a+20>>2]=0;k[a+8>>2]=0;k[a+24>>2]=0;k[a+44>>2]=2;k[f+20>>2]=0;k[f+16>>2]=k[f+8>>2];c=f+24|0;b=k[c>>2]|0;d=0-b|0;if((b|0)<0){k[c>>2]=d;b=d}k[f+4>>2]=b|0?42:113;k[a+48>>2]=(b|0)!=2&1;k[f+40>>2]=0;k[f+2840>>2]=f+148;k[f+2848>>2]=164872;k[f+2852>>2]=f+2440;k[f+2860>>2]=164892;k[f+2864>>2]=f+2684;k[f+2872>>2]=164912;j[f+5816>>1]=0;k[f+5820>>2]=0;Peb(f);f=k[e>>2]|0;k[f+60>>2]=k[f+44>>2]<<1;e=k[f+76>>2]|0;a=k[f+68>>2]|0;j[a+(e+-1<<1)>>1]=0;zpb(a|0,0,(e<<1)+-2|0)|0;e=k[f+132>>2]|0;k[f+128>>2]=m[164752+(e*12|0)+2>>1];k[f+140>>2]=m[164752+(e*12|0)>>1];k[f+144>>2]=m[164752+(e*12|0)+4>>1];k[f+124>>2]=m[164752+(e*12|0)+6>>1];k[f+108>>2]=0;k[f+92>>2]=0;k[f+116>>2]=0;k[f+5812>>2]=0;k[f+120>>2]=2;k[f+96>>2]=2;k[f+104>>2]=0;k[f+72>>2]=0;f=0;return f|0}function Beb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=(k[a+12>>2]|0)+-5|0;h=h>>>0<65535?h:65535;n=a+116|0;r=a+108|0;s=a+92|0;p=a+44|0;q=a+56|0;while(1){c=k[n>>2]|0;if(c>>>0<2){Eeb(a);c=k[n>>2]|0;if(!(c|b)){c=0;d=55;break}if(!c){d=30;break}}c=(k[r>>2]|0)+c|0;k[r>>2]=c;k[n>>2]=0;d=k[s>>2]|0;e=d+h|0;if(!((c|0)!=0&c>>>0<e>>>0)){k[n>>2]=c-e;k[r>>2]=e;if((d|0)>-1)c=(k[q>>2]|0)+d|0;else c=0;Seb(a,c,h,0);k[s>>2]=k[r>>2];f=k[a>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){e=g+5816|0;w=j[e>>1]&255;d=g+20|0;v=k[d>>2]|0;k[d>>2]=v+1;i[(k[g+8>>2]|0)+v>>0]=w;j[e>>1]=(m[e>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{w=g+5816|0;v=j[w>>1]&255;d=g+20|0;x=k[d>>2]|0;k[d>>2]=x+1;e=g+8|0;i[(k[e>>2]|0)+x>>0]=v;x=(m[w>>1]|0)>>>8&255;v=k[d>>2]|0;k[d>>2]=v+1;i[(k[e>>2]|0)+v>>0]=x;j[w>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;x=k[e>>2]|0;c=c>>>0>x>>>0?x:c;if(c|0?(x=f+12|0,o=g+16|0,upb(k[x>>2]|0,k[o>>2]|0,c|0)|0,k[x>>2]=(k[x>>2]|0)+c,k[o>>2]=(k[o>>2]|0)+c,x=f+20|0,k[x>>2]=(k[x>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,x=(k[d>>2]|0)-c|0,k[d>>2]=x,(x|0)==0):0)k[o>>2]=k[g+8>>2];if(!(k[(k[a>>2]|0)+16>>2]|0)){c=0;d=55;break}d=k[s>>2]|0;c=k[r>>2]|0}e=c-d|0;if(e>>>0<((k[p>>2]|0)+-262|0)>>>0)continue;if((d|0)>-1)c=(k[q>>2]|0)+d|0;else c=0;Seb(a,c,e,0);k[s>>2]=k[r>>2];f=k[a>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){x=g+5816|0;v=j[x>>1]&255;d=g+20|0;w=k[d>>2]|0;k[d>>2]=w+1;i[(k[g+8>>2]|0)+w>>0]=v;j[x>>1]=(m[x>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{x=g+5816|0;w=j[x>>1]&255;d=g+20|0;e=k[d>>2]|0;k[d>>2]=e+1;v=g+8|0;i[(k[v>>2]|0)+e>>0]=w;e=(m[x>>1]|0)>>>8&255;w=k[d>>2]|0;k[d>>2]=w+1;i[(k[v>>2]|0)+w>>0]=e;j[x>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;x=k[e>>2]|0;c=c>>>0>x>>>0?x:c;if(c|0?(x=f+12|0,l=g+16|0,upb(k[x>>2]|0,k[l>>2]|0,c|0)|0,k[x>>2]=(k[x>>2]|0)+c,k[l>>2]=(k[l>>2]|0)+c,x=f+20|0,k[x>>2]=(k[x>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,x=(k[d>>2]|0)-c|0,k[d>>2]=x,(x|0)==0):0)k[l>>2]=k[g+8>>2];if(!(k[(k[a>>2]|0)+16>>2]|0)){c=0;d=55;break}}if((d|0)==30){k[a+5812>>2]=0;if((b|0)==4){d=k[s>>2]|0;if((d|0)>-1)c=(k[q>>2]|0)+d|0;else c=0;Seb(a,c,(k[r>>2]|0)-d|0,1);k[s>>2]=k[r>>2];f=k[a>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){x=g+5816|0;v=j[x>>1]&255;d=g+20|0;w=k[d>>2]|0;k[d>>2]=w+1;i[(k[g+8>>2]|0)+w>>0]=v;j[x>>1]=(m[x>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{x=g+5816|0;w=j[x>>1]&255;d=g+20|0;u=k[d>>2]|0;k[d>>2]=u+1;v=g+8|0;i[(k[v>>2]|0)+u>>0]=w;u=(m[x>>1]|0)>>>8&255;w=k[d>>2]|0;k[d>>2]=w+1;i[(k[v>>2]|0)+w>>0]=u;j[x>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;x=k[e>>2]|0;c=c>>>0>x>>>0?x:c;if(c|0?(x=f+12|0,t=g+16|0,upb(k[x>>2]|0,k[t>>2]|0,c|0)|0,k[x>>2]=(k[x>>2]|0)+c,k[t>>2]=(k[t>>2]|0)+c,x=f+20|0,k[x>>2]=(k[x>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,x=(k[d>>2]|0)-c|0,k[d>>2]=x,(x|0)==0):0)k[t>>2]=k[g+8>>2];x=(k[(k[a>>2]|0)+16>>2]|0)==0?2:3;return x|0}d=k[r>>2]|0;e=k[s>>2]|0;if((d|0)>(e|0)){if((e|0)>-1)c=(k[q>>2]|0)+e|0;else c=0;Seb(a,c,d-e|0,0);k[s>>2]=k[r>>2];f=k[a>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){x=g+5816|0;v=j[x>>1]&255;d=g+20|0;w=k[d>>2]|0;k[d>>2]=w+1;i[(k[g+8>>2]|0)+w>>0]=v;j[x>>1]=(m[x>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{x=g+5816|0;w=j[x>>1]&255;d=g+20|0;t=k[d>>2]|0;k[d>>2]=t+1;v=g+8|0;i[(k[v>>2]|0)+t>>0]=w;t=(m[x>>1]|0)>>>8&255;w=k[d>>2]|0;k[d>>2]=w+1;i[(k[v>>2]|0)+w>>0]=t;j[x>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;x=k[e>>2]|0;c=c>>>0>x>>>0?x:c;if(c|0?(x=f+12|0,u=g+16|0,upb(k[x>>2]|0,k[u>>2]|0,c|0)|0,k[x>>2]=(k[x>>2]|0)+c,k[u>>2]=(k[u>>2]|0)+c,x=f+20|0,k[x>>2]=(k[x>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,x=(k[d>>2]|0)-c|0,k[d>>2]=x,(x|0)==0):0)k[u>>2]=k[g+8>>2];if(!(k[(k[a>>2]|0)+16>>2]|0)){x=0;return x|0}}x=1;return x|0}else if((d|0)==55)return c|0;return 0}function Ceb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;C=a+116|0;E=(b|0)==0;F=a+72|0;G=a+88|0;M=a+108|0;K=a+56|0;H=a+84|0;I=a+68|0;t=a+52|0;u=a+64|0;v=a+44|0;w=a+96|0;x=a+112|0;J=a+5792|0;y=a+5796|0;z=a+5784|0;A=a+5788|0;B=a+128|0;L=a+92|0;while(1){if((k[C>>2]|0)>>>0<262){Eeb(a);c=k[C>>2]|0;if(E&c>>>0<262){c=0;d=54;break}if(!c){d=29;break}if(c>>>0<=2)d=9;else d=6}else d=6;if((d|0)==6){d=0;s=k[M>>2]|0;q=((l[(k[K>>2]|0)+(s+2)>>0]|0)^k[F>>2]<<k[G>>2])&k[H>>2];k[F>>2]=q;q=(k[I>>2]|0)+(q<<1)|0;r=j[q>>1]|0;j[(k[u>>2]|0)+((k[t>>2]&s)<<1)>>1]=r;c=r&65535;j[q>>1]=s;if(r<<16>>16!=0?(s-c|0)>>>0<=((k[v>>2]|0)+-262|0)>>>0:0){c=Feb(a,c)|0;k[w>>2]=c}else d=9}if((d|0)==9)c=k[w>>2]|0;do if(c>>>0>2){r=c+253|0;c=(k[M>>2]|0)-(k[x>>2]|0)|0;s=k[J>>2]|0;j[(k[y>>2]|0)+(s<<1)>>1]=c;k[J>>2]=s+1;i[(k[z>>2]|0)+s>>0]=r;r=a+148+((l[419729+(r&255)>>0]|0|256)+1<<2)|0;j[r>>1]=(j[r>>1]|0)+1<<16>>16;c=c+65535&65535;c=a+2440+((l[419217+(c>>>0<256?c:(c>>>7)+256|0)>>0]|0)<<2)|0;j[c>>1]=(j[c>>1]|0)+1<<16>>16;c=(k[J>>2]|0)==((k[A>>2]|0)+-1|0)&1;r=k[w>>2]|0;s=(k[C>>2]|0)-r|0;k[C>>2]=s;if(!(s>>>0>2?r>>>0<=(k[B>>2]|0)>>>0:0)){e=(k[M>>2]|0)+r|0;k[M>>2]=e;k[w>>2]=0;r=k[K>>2]|0;s=l[r+e>>0]|0;k[F>>2]=s;k[F>>2]=((l[r+(e+1)>>0]|0)^s<<k[G>>2])&k[H>>2];break}q=r+-1|0;k[w>>2]=q;d=k[M>>2]|0;e=k[G>>2]|0;f=k[K>>2]|0;g=k[H>>2]|0;h=k[I>>2]|0;n=k[t>>2]|0;o=k[u>>2]|0;p=k[F>>2]|0;s=d;do{P=s;s=s+1|0;k[M>>2]=s;p=((l[f+(P+3)>>0]|0)^p<<e)&g;k[F>>2]=p;P=h+(p<<1)|0;j[o+((n&s)<<1)>>1]=j[P>>1]|0;j[P>>1]=s;q=q+-1|0;k[w>>2]=q}while((q|0)!=0);e=r+d|0;k[M>>2]=e}else{c=i[(k[K>>2]|0)+(k[M>>2]|0)>>0]|0;e=k[J>>2]|0;j[(k[y>>2]|0)+(e<<1)>>1]=0;k[J>>2]=e+1;i[(k[z>>2]|0)+e>>0]=c;c=a+148+((c&255)<<2)|0;j[c>>1]=(j[c>>1]|0)+1<<16>>16;c=(k[J>>2]|0)==((k[A>>2]|0)+-1|0)&1;k[C>>2]=(k[C>>2]|0)+-1;e=(k[M>>2]|0)+1|0;k[M>>2]=e}while(0);if(!c)continue;c=k[L>>2]|0;if((c|0)>-1)d=(k[K>>2]|0)+c|0;else d=0;Seb(a,d,e-c|0,0);k[L>>2]=k[M>>2];f=k[a>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){P=g+5816|0;r=j[P>>1]&255;d=g+20|0;s=k[d>>2]|0;k[d>>2]=s+1;i[(k[g+8>>2]|0)+s>>0]=r;j[P>>1]=(m[P>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{P=g+5816|0;s=j[P>>1]&255;d=g+20|0;q=k[d>>2]|0;k[d>>2]=q+1;r=g+8|0;i[(k[r>>2]|0)+q>>0]=s;q=(m[P>>1]|0)>>>8&255;s=k[d>>2]|0;k[d>>2]=s+1;i[(k[r>>2]|0)+s>>0]=q;j[P>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;P=k[e>>2]|0;c=c>>>0>P>>>0?P:c;if(c|0?(P=f+12|0,D=g+16|0,upb(k[P>>2]|0,k[D>>2]|0,c|0)|0,k[P>>2]=(k[P>>2]|0)+c,k[D>>2]=(k[D>>2]|0)+c,P=f+20|0,k[P>>2]=(k[P>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,P=(k[d>>2]|0)-c|0,k[d>>2]=P,(P|0)==0):0)k[D>>2]=k[g+8>>2];if(!(k[(k[a>>2]|0)+16>>2]|0)){c=0;d=54;break}}if((d|0)==29){e=k[M>>2]|0;k[a+5812>>2]=e>>>0<2?e:2;if((b|0)==4){d=k[L>>2]|0;if((d|0)>-1)c=(k[K>>2]|0)+d|0;else c=0;Seb(a,c,e-d|0,1);k[L>>2]=k[M>>2];f=k[a>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){P=g+5816|0;M=j[P>>1]&255;d=g+20|0;O=k[d>>2]|0;k[d>>2]=O+1;i[(k[g+8>>2]|0)+O>>0]=M;j[P>>1]=(m[P>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{P=g+5816|0;O=j[P>>1]&255;d=g+20|0;L=k[d>>2]|0;k[d>>2]=L+1;M=g+8|0;i[(k[M>>2]|0)+L>>0]=O;L=(m[P>>1]|0)>>>8&255;O=k[d>>2]|0;k[d>>2]=O+1;i[(k[M>>2]|0)+O>>0]=L;j[P>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;P=k[e>>2]|0;c=c>>>0>P>>>0?P:c;if(c|0?(P=f+12|0,N=g+16|0,upb(k[P>>2]|0,k[N>>2]|0,c|0)|0,k[P>>2]=(k[P>>2]|0)+c,k[N>>2]=(k[N>>2]|0)+c,P=f+20|0,k[P>>2]=(k[P>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,P=(k[d>>2]|0)-c|0,k[d>>2]=P,(P|0)==0):0)k[N>>2]=k[g+8>>2];P=(k[(k[a>>2]|0)+16>>2]|0)==0?2:3;return P|0}if(k[J>>2]|0){d=k[L>>2]|0;if((d|0)>-1)c=(k[K>>2]|0)+d|0;else c=0;Seb(a,c,e-d|0,0);k[L>>2]=k[M>>2];f=k[a>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){P=g+5816|0;M=j[P>>1]&255;d=g+20|0;N=k[d>>2]|0;k[d>>2]=N+1;i[(k[g+8>>2]|0)+N>>0]=M;j[P>>1]=(m[P>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{P=g+5816|0;N=j[P>>1]&255;d=g+20|0;L=k[d>>2]|0;k[d>>2]=L+1;M=g+8|0;i[(k[M>>2]|0)+L>>0]=N;L=(m[P>>1]|0)>>>8&255;N=k[d>>2]|0;k[d>>2]=N+1;i[(k[M>>2]|0)+N>>0]=L;j[P>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;P=k[e>>2]|0;c=c>>>0>P>>>0?P:c;if(c|0?(P=f+12|0,O=g+16|0,upb(k[P>>2]|0,k[O>>2]|0,c|0)|0,k[P>>2]=(k[P>>2]|0)+c,k[O>>2]=(k[O>>2]|0)+c,P=f+20|0,k[P>>2]=(k[P>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,P=(k[d>>2]|0)-c|0,k[d>>2]=P,(P|0)==0):0)k[O>>2]=k[g+8>>2];if(!(k[(k[a>>2]|0)+16>>2]|0)){P=0;return P|0}}P=1;return P|0}else if((d|0)==54)return c|0;return 0}function Deb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;z=a+116|0;F=(b|0)==0;G=a+72|0;H=a+88|0;N=a+108|0;L=a+56|0;I=a+84|0;J=a+68|0;p=a+52|0;q=a+64|0;r=a+96|0;s=a+120|0;t=a+112|0;u=a+100|0;K=a+5792|0;v=a+5796|0;w=a+5784|0;x=a+5788|0;A=a+104|0;M=a+92|0;B=a+128|0;C=a+44|0;D=a+136|0;a:while(1){c=k[z>>2]|0;while(1){if(c>>>0<262){Eeb(a);c=k[z>>2]|0;if(F&c>>>0<262){c=0;f=75;break a}if(!c){f=48;break a}if(c>>>0<=2){k[s>>2]=k[r>>2];k[u>>2]=k[t>>2];k[r>>2]=2;c=2;f=16}else f=8}else f=8;do if((f|0)==8){f=0;c=k[N>>2]|0;e=((l[(k[L>>2]|0)+(c+2)>>0]|0)^k[G>>2]<<k[H>>2])&k[I>>2];k[G>>2]=e;e=(k[J>>2]|0)+(e<<1)|0;o=j[e>>1]|0;j[(k[q>>2]|0)+((k[p>>2]&c)<<1)>>1]=o;d=o&65535;j[e>>1]=c;e=k[r>>2]|0;k[s>>2]=e;k[u>>2]=k[t>>2];k[r>>2]=2;if(o<<16>>16)if(e>>>0<(k[B>>2]|0)>>>0)if((c-d|0)>>>0<=((k[C>>2]|0)+-262|0)>>>0){c=Feb(a,d)|0;k[r>>2]=c;if(c>>>0<6){if((k[D>>2]|0)!=1){if((c|0)!=3){f=16;break}if(((k[N>>2]|0)-(k[t>>2]|0)|0)>>>0<=4096){c=3;f=16;break}}k[r>>2]=2;c=2;f=16}else f=16}else{c=2;f=16}else c=2;else{c=2;f=16}}while(0);if((f|0)==16)e=k[s>>2]|0;if(!(e>>>0<3|c>>>0>e>>>0))break;if(!(k[A>>2]|0)){k[A>>2]=1;k[N>>2]=(k[N>>2]|0)+1;c=(k[z>>2]|0)+-1|0;k[z>>2]=c;continue}o=i[(k[L>>2]|0)+((k[N>>2]|0)+-1)>>0]|0;n=k[K>>2]|0;j[(k[v>>2]|0)+(n<<1)>>1]=0;k[K>>2]=n+1;i[(k[w>>2]|0)+n>>0]=o;o=a+148+((o&255)<<2)|0;j[o>>1]=(j[o>>1]|0)+1<<16>>16;if((k[K>>2]|0)==((k[x>>2]|0)+-1|0)){c=k[M>>2]|0;if((c|0)>-1)d=(k[L>>2]|0)+c|0;else d=0;Seb(a,d,(k[N>>2]|0)-c|0,0);k[M>>2]=k[N>>2];f=k[a>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){o=g+5816|0;h=j[o>>1]&255;d=g+20|0;n=k[d>>2]|0;k[d>>2]=n+1;i[(k[g+8>>2]|0)+n>>0]=h;j[o>>1]=(m[o>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{o=g+5816|0;n=j[o>>1]&255;d=g+20|0;e=k[d>>2]|0;k[d>>2]=e+1;h=g+8|0;i[(k[h>>2]|0)+e>>0]=n;e=(m[o>>1]|0)>>>8&255;n=k[d>>2]|0;k[d>>2]=n+1;i[(k[h>>2]|0)+n>>0]=e;j[o>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;o=k[e>>2]|0;c=c>>>0>o>>>0?o:c;if(c|0?(o=f+12|0,E=g+16|0,upb(k[o>>2]|0,k[E>>2]|0,c|0)|0,k[o>>2]=(k[o>>2]|0)+c,k[E>>2]=(k[E>>2]|0)+c,o=f+20|0,k[o>>2]=(k[o>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,o=(k[d>>2]|0)-c|0,k[d>>2]=o,(o|0)==0):0)k[E>>2]=k[g+8>>2]}k[N>>2]=(k[N>>2]|0)+1;c=(k[z>>2]|0)+-1|0;k[z>>2]=c;if(!(k[(k[a>>2]|0)+16>>2]|0)){c=0;f=75;break a}}h=k[N>>2]|0;o=h+-3+(k[z>>2]|0)|0;n=e+253|0;h=h+65535-(k[u>>2]|0)|0;d=k[K>>2]|0;j[(k[v>>2]|0)+(d<<1)>>1]=h;k[K>>2]=d+1;i[(k[w>>2]|0)+d>>0]=n;n=a+148+((l[419729+(n&255)>>0]|0|256)+1<<2)|0;j[n>>1]=(j[n>>1]|0)+1<<16>>16;h=h+65535&65535;h=a+2440+((l[419217+(h>>>0<256?h:(h>>>7)+256|0)>>0]|0)<<2)|0;j[h>>1]=(j[h>>1]|0)+1<<16>>16;h=k[K>>2]|0;n=k[x>>2]|0;d=k[s>>2]|0;k[z>>2]=1-d+(k[z>>2]|0);g=d+-2|0;k[s>>2]=g;c=k[N>>2]|0;d=d+-3|0;e=c;do{f=e;e=e+1|0;k[N>>2]=e;if(e>>>0<=o>>>0){f=((l[(k[L>>2]|0)+(f+3)>>0]|0)^k[G>>2]<<k[H>>2])&k[I>>2];k[G>>2]=f;f=(k[J>>2]|0)+(f<<1)|0;j[(k[q>>2]|0)+((k[p>>2]&e)<<1)>>1]=j[f>>1]|0;j[f>>1]=e}g=g+-1|0;k[s>>2]=g}while((g|0)!=0);k[A>>2]=0;k[r>>2]=2;e=d+c+2|0;k[N>>2]=e;if((h|0)!=(n+-1|0))continue;c=k[M>>2]|0;if((c|0)>-1)d=(k[L>>2]|0)+c|0;else d=0;Seb(a,d,e-c|0,0);k[M>>2]=k[N>>2];f=k[a>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){o=g+5816|0;h=j[o>>1]&255;d=g+20|0;n=k[d>>2]|0;k[d>>2]=n+1;i[(k[g+8>>2]|0)+n>>0]=h;j[o>>1]=(m[o>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{o=g+5816|0;n=j[o>>1]&255;d=g+20|0;e=k[d>>2]|0;k[d>>2]=e+1;h=g+8|0;i[(k[h>>2]|0)+e>>0]=n;e=(m[o>>1]|0)>>>8&255;n=k[d>>2]|0;k[d>>2]=n+1;i[(k[h>>2]|0)+n>>0]=e;j[o>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;o=k[e>>2]|0;c=c>>>0>o>>>0?o:c;if(c|0?(o=f+12|0,y=g+16|0,upb(k[o>>2]|0,k[y>>2]|0,c|0)|0,k[o>>2]=(k[o>>2]|0)+c,k[y>>2]=(k[y>>2]|0)+c,o=f+20|0,k[o>>2]=(k[o>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,o=(k[d>>2]|0)-c|0,k[d>>2]=o,(o|0)==0):0)k[y>>2]=k[g+8>>2];if(!(k[(k[a>>2]|0)+16>>2]|0)){c=0;f=75;break}}if((f|0)==48){if(k[A>>2]|0){J=i[(k[L>>2]|0)+((k[N>>2]|0)+-1)>>0]|0;I=k[K>>2]|0;j[(k[v>>2]|0)+(I<<1)>>1]=0;k[K>>2]=I+1;i[(k[w>>2]|0)+I>>0]=J;J=a+148+((J&255)<<2)|0;j[J>>1]=(j[J>>1]|0)+1<<16>>16;k[A>>2]=0}e=k[N>>2]|0;k[a+5812>>2]=e>>>0<2?e:2;if((b|0)==4){d=k[M>>2]|0;if((d|0)>-1)c=(k[L>>2]|0)+d|0;else c=0;Seb(a,c,e-d|0,1);k[M>>2]=k[N>>2];f=k[a>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){P=g+5816|0;M=j[P>>1]&255;d=g+20|0;N=k[d>>2]|0;k[d>>2]=N+1;i[(k[g+8>>2]|0)+N>>0]=M;j[P>>1]=(m[P>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{P=g+5816|0;N=j[P>>1]&255;d=g+20|0;L=k[d>>2]|0;k[d>>2]=L+1;M=g+8|0;i[(k[M>>2]|0)+L>>0]=N;L=(m[P>>1]|0)>>>8&255;N=k[d>>2]|0;k[d>>2]=N+1;i[(k[M>>2]|0)+N>>0]=L;j[P>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;P=k[e>>2]|0;c=c>>>0>P>>>0?P:c;if(c|0?(P=f+12|0,O=g+16|0,upb(k[P>>2]|0,k[O>>2]|0,c|0)|0,k[P>>2]=(k[P>>2]|0)+c,k[O>>2]=(k[O>>2]|0)+c,P=f+20|0,k[P>>2]=(k[P>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,P=(k[d>>2]|0)-c|0,k[d>>2]=P,(P|0)==0):0)k[O>>2]=k[g+8>>2];a=(k[(k[a>>2]|0)+16>>2]|0)==0?2:3;return a|0}if(k[K>>2]|0){d=k[M>>2]|0;if((d|0)>-1)c=(k[L>>2]|0)+d|0;else c=0;Seb(a,c,e-d|0,0);k[M>>2]=k[N>>2];f=k[a>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){O=g+5816|0;M=j[O>>1]&255;d=g+20|0;N=k[d>>2]|0;k[d>>2]=N+1;i[(k[g+8>>2]|0)+N>>0]=M;j[O>>1]=(m[O>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{O=g+5816|0;N=j[O>>1]&255;d=g+20|0;L=k[d>>2]|0;k[d>>2]=L+1;M=g+8|0;i[(k[M>>2]|0)+L>>0]=N;L=(m[O>>1]|0)>>>8&255;N=k[d>>2]|0;k[d>>2]=N+1;i[(k[M>>2]|0)+N>>0]=L;j[O>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;O=k[e>>2]|0;c=c>>>0>O>>>0?O:c;if(c|0?(O=f+12|0,P=g+16|0,upb(k[O>>2]|0,k[P>>2]|0,c|0)|0,k[O>>2]=(k[O>>2]|0)+c,k[P>>2]=(k[P>>2]|0)+c,O=f+20|0,k[O>>2]=(k[O>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,O=(k[d>>2]|0)-c|0,k[d>>2]=O,(O|0)==0):0)k[P>>2]=k[g+8>>2];if(!(k[(k[a>>2]|0)+16>>2]|0)){a=0;return a|0}}a=1;return a|0}else if((f|0)==75)return c|0;return 0}function Eeb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;i=a+44|0;v=k[i>>2]|0;z=a+60|0;A=a+116|0;B=a+108|0;w=v+-262|0;C=a+56|0;x=a+5812|0;y=a+72|0;n=a+88|0;o=a+84|0;p=a+68|0;q=a+52|0;r=a+64|0;s=a+112|0;t=a+92|0;u=a+76|0;b=k[A>>2]|0;c=v;while(1){d=k[B>>2]|0;e=(k[z>>2]|0)-b-d|0;if(d>>>0>=(w+c|0)>>>0){d=k[C>>2]|0;upb(d|0,d+v|0,v|0)|0;k[s>>2]=(k[s>>2]|0)-v;d=(k[B>>2]|0)-v|0;k[B>>2]=d;k[t>>2]=(k[t>>2]|0)-v;c=k[u>>2]|0;b=c;c=(k[p>>2]|0)+(c<<1)|0;do{c=c+-2|0;h=m[c>>1]|0;j[c>>1]=h>>>0<v>>>0?0:h-v&65535;b=b+-1|0}while((b|0)!=0);b=v;c=(k[r>>2]|0)+(v<<1)|0;do{c=c+-2|0;h=m[c>>1]|0;j[c>>1]=h>>>0<v>>>0?0:h-v&65535;b=b+-1|0}while((b|0)!=0);e=e+v|0}f=k[a>>2]|0;g=f+4|0;h=k[g>>2]|0;if(!h)break;b=k[A>>2]|0;d=(k[C>>2]|0)+d+b|0;c=h>>>0>e>>>0?e:h;if(!c)c=0;else{k[g>>2]=h-c;upb(d|0,k[f>>2]|0,c|0)|0;switch(k[(k[f+28>>2]|0)+24>>2]|0){case 1:{h=f+48|0;g=xeb(k[h>>2]|0,d,c)|0;k[h>>2]=g;break}case 2:{h=f+48|0;g=yeb(k[h>>2]|0,d,c)|0;k[h>>2]=g;break}default:{}}k[f>>2]=(k[f>>2]|0)+c;b=f+8|0;k[b>>2]=(k[b>>2]|0)+c;b=k[A>>2]|0}b=b+c|0;k[A>>2]=b;c=k[x>>2]|0;a:do if((c+b|0)>>>0>2){e=(k[B>>2]|0)-c|0;g=k[C>>2]|0;d=l[g+e>>0]|0;k[y>>2]=d;h=k[n>>2]|0;f=k[o>>2]|0;d=((l[g+(e+1)>>0]|0)^d<<h)&f;k[y>>2]=d;while(1){if(!c)break a;d=((l[g+(e+2)>>0]|0)^d<<h)&f;k[y>>2]=d;D=(k[p>>2]|0)+(d<<1)|0;j[(k[r>>2]|0)+((k[q>>2]&e)<<1)>>1]=j[D>>1]|0;j[D>>1]=e;c=c+-1|0;k[x>>2]=c;if((b+c|0)>>>0<3)break;else e=e+1|0}}while(0);if(b>>>0>=262)break;if(!(k[(k[a>>2]|0)+4>>2]|0))break;c=k[i>>2]|0}d=a+5824|0;e=k[d>>2]|0;c=k[z>>2]|0;if(c>>>0<=e>>>0)return;b=(k[A>>2]|0)+(k[B>>2]|0)|0;if(e>>>0<b>>>0){D=c-b|0;D=D>>>0>258?258:D;zpb((k[C>>2]|0)+b|0,0,D|0)|0;k[d>>2]=D+b;return}b=b+258|0;if(b>>>0<=e>>>0)return;D=b-e|0;B=c-e|0;D=D>>>0>B>>>0?B:D;zpb((k[C>>2]|0)+e|0,0,D|0)|0;k[d>>2]=(k[d>>2]|0)+D;return}function Feb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=k[a+124>>2]|0;u=k[a+56>>2]|0;o=k[a+108>>2]|0;v=u+o|0;f=k[a+120>>2]|0;n=k[a+144>>2]|0;l=(k[a+44>>2]|0)+-262|0;l=o>>>0>l>>>0?o-l|0:0;o=k[a+64>>2]|0;p=k[a+52>>2]|0;w=k[a+116>>2]|0;n=n>>>0>w>>>0?w:n;q=a+112|0;r=v+1|0;s=v+258|0;c=i[v+f>>0]|0;h=i[v+(f+-1)>>0]|0;j=b;b=f;g=f>>>0<(k[a+140>>2]|0)>>>0?g:g>>>2;while(1){a=u+j|0;if((((i[a+b>>0]|0)==c<<24>>24?(i[a+(b+-1)>>0]|0)==h<<24>>24:0)?(i[a>>0]|0)==(i[v>>0]|0):0)?(t=a+1|0,(i[t>>0]|0)==(i[r>>0]|0)):0){e=2;f=t;do{d=v+e|0;a=d+1|0;if((i[a>>0]|0)!=(i[f+2>>0]|0))break;a=d+2|0;if((i[a>>0]|0)!=(i[f+3>>0]|0))break;a=d+3|0;if((i[a>>0]|0)!=(i[f+4>>0]|0))break;a=d+4|0;if((i[a>>0]|0)!=(i[f+5>>0]|0))break;a=d+5|0;if((i[a>>0]|0)!=(i[f+6>>0]|0))break;a=d+6|0;if((i[a>>0]|0)!=(i[f+7>>0]|0))break;a=d+7|0;d=f;f=f+8|0;if((i[a>>0]|0)!=(i[f>>0]|0))break;e=e+8|0;a=v+e|0}while((e|0)<258?(i[a>>0]|0)==(i[d+9>>0]|0):0);a=a-s|0;d=a+258|0;if((d|0)>(b|0)){k[q>>2]=j;if((d|0)>=(n|0)){b=d;a=19;break}c=i[v+d>>0]|0;a=i[v+(a+257)>>0]|0;b=d}else a=h}else a=h;j=m[o+((j&p)<<1)>>1]|0;if(j>>>0<=l>>>0){a=19;break}g=g+-1|0;if(!g){a=19;break}else h=a}if((a|0)==19)return (b>>>0>w>>>0?w:b)|0;return 0}function Geb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;if(!a){f=-2;return f|0}e=a+28|0;b=k[e>>2]|0;if(!b){f=-2;return f|0}f=k[b+4>>2]|0;switch(f|0){case 42:case 69:case 73:case 91:case 103:case 113:case 666:break;default:{f=-2;return f|0}}c=k[b+8>>2]|0;if(c){jh[k[a+36>>2]&1023](k[a+40>>2]|0,c);b=k[e>>2]|0}c=k[b+68>>2]|0;if(c){jh[k[a+36>>2]&1023](k[a+40>>2]|0,c);b=k[e>>2]|0}c=k[b+64>>2]|0;if(c){jh[k[a+36>>2]&1023](k[a+40>>2]|0,c);b=k[e>>2]|0}c=k[b+56>>2]|0;if(!c){d=a+40|0;c=a+36|0}else{b=a+36|0;d=a+40|0;jh[k[b>>2]&1023](k[d>>2]|0,c);c=b;b=k[e>>2]|0}jh[k[c>>2]&1023](k[d>>2]|0,b);k[e>>2]=0;f=(f|0)==113?-3:0;return f|0}function Heb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;if(!a){Q=-2;return Q|0}M=a+28|0;N=k[M>>2]|0;if(b>>>0>5|(N|0)==0){Q=-2;return Q|0}Q=a+12|0;do if(k[Q>>2]|0){if((k[a>>2]|0)==0?k[a+4>>2]|0:0)break;J=N+4|0;c=k[J>>2]|0;K=(b|0)!=4;if(!(K&(c|0)==666)){P=a+16|0;if(!(k[P>>2]|0)){k[a+24>>2]=420037;Q=-5;return Q|0}k[N>>2]=a;L=N+40|0;z=k[L>>2]|0;k[L>>2]=b;do if((c|0)==42){if((k[N+24>>2]|0)!=2){d=(k[N+48>>2]<<12)+-30720|0;if((k[N+136>>2]|0)<=1?(e=k[N+132>>2]|0,(e|0)>=2):0)if((e|0)<6)c=64;else c=(e|0)==6?128:192;else c=0;A=c|d;B=N+108|0;A=(k[B>>2]|0)==0?A:A|32;k[J>>2]=113;d=N+20|0;c=k[d>>2]|0;k[d>>2]=c+1;e=N+8|0;i[(k[e>>2]|0)+c>>0]=A>>>8;c=k[d>>2]|0;k[d>>2]=c+1;i[(k[e>>2]|0)+c>>0]=((A>>>0)%31|0|A)^31;c=a+48|0;if(k[B>>2]|0){B=k[c>>2]|0;A=k[d>>2]|0;k[d>>2]=A+1;i[(k[e>>2]|0)+A>>0]=B>>>24;A=k[d>>2]|0;k[d>>2]=A+1;i[(k[e>>2]|0)+A>>0]=B>>>16;A=k[c>>2]|0;B=k[d>>2]|0;k[d>>2]=B+1;i[(k[e>>2]|0)+B>>0]=A>>>8;B=k[d>>2]|0;k[d>>2]=B+1;i[(k[e>>2]|0)+B>>0]=A}k[c>>2]=1;c=k[J>>2]|0;A=30;break}e=a+48|0;k[e>>2]=0;g=N+20|0;c=k[g>>2]|0;k[g>>2]=c+1;h=N+8|0;i[(k[h>>2]|0)+c>>0]=31;c=k[g>>2]|0;k[g>>2]=c+1;i[(k[h>>2]|0)+c>>0]=-117;c=k[g>>2]|0;k[g>>2]=c+1;i[(k[h>>2]|0)+c>>0]=8;c=N+28|0;d=k[c>>2]|0;if(!d){c=k[g>>2]|0;k[g>>2]=c+1;i[(k[h>>2]|0)+c>>0]=0;c=k[g>>2]|0;k[g>>2]=c+1;i[(k[h>>2]|0)+c>>0]=0;c=k[g>>2]|0;k[g>>2]=c+1;i[(k[h>>2]|0)+c>>0]=0;c=k[g>>2]|0;k[g>>2]=c+1;i[(k[h>>2]|0)+c>>0]=0;c=k[g>>2]|0;k[g>>2]=c+1;i[(k[h>>2]|0)+c>>0]=0;c=k[N+132>>2]|0;if((c|0)==9)c=2;else c=((c|0)<2?1:(k[N+136>>2]|0)>1)?4:0;B=k[g>>2]|0;k[g>>2]=B+1;i[(k[h>>2]|0)+B>>0]=c;B=k[g>>2]|0;k[g>>2]=B+1;i[(k[h>>2]|0)+B>>0]=3;k[J>>2]=113;break}B=((k[d+44>>2]|0?2:0)|(k[d>>2]|0)!=0|((k[d+16>>2]|0)==0?0:4)|((k[d+28>>2]|0)==0?0:8)|((k[d+36>>2]|0)==0?0:16))&255;d=k[g>>2]|0;k[g>>2]=d+1;i[(k[h>>2]|0)+d>>0]=B;d=k[(k[c>>2]|0)+4>>2]&255;B=k[g>>2]|0;k[g>>2]=B+1;i[(k[h>>2]|0)+B>>0]=d;B=(k[(k[c>>2]|0)+4>>2]|0)>>>8&255;d=k[g>>2]|0;k[g>>2]=d+1;i[(k[h>>2]|0)+d>>0]=B;d=(k[(k[c>>2]|0)+4>>2]|0)>>>16&255;B=k[g>>2]|0;k[g>>2]=B+1;i[(k[h>>2]|0)+B>>0]=d;B=(k[(k[c>>2]|0)+4>>2]|0)>>>24&255;d=k[g>>2]|0;k[g>>2]=d+1;i[(k[h>>2]|0)+d>>0]=B;d=k[N+132>>2]|0;if((d|0)==9)d=2;else d=((d|0)<2?1:(k[N+136>>2]|0)>1)?4:0;B=k[g>>2]|0;k[g>>2]=B+1;i[(k[h>>2]|0)+B>>0]=d;B=k[(k[c>>2]|0)+12>>2]&255;d=k[g>>2]|0;k[g>>2]=d+1;i[(k[h>>2]|0)+d>>0]=B;d=k[c>>2]|0;if(k[d+16>>2]|0){d=k[d+20>>2]&255;B=k[g>>2]|0;k[g>>2]=B+1;i[(k[h>>2]|0)+B>>0]=d;B=(k[(k[c>>2]|0)+20>>2]|0)>>>8&255;d=k[g>>2]|0;k[g>>2]=d+1;i[(k[h>>2]|0)+d>>0]=B;d=k[c>>2]|0}if(k[d+44>>2]|0){B=yeb(k[e>>2]|0,k[h>>2]|0,k[g>>2]|0)|0;k[e>>2]=B}k[N+32>>2]=0;k[J>>2]=69;A=32}else A=30;while(0);if((A|0)==30)if((c|0)==69){d=N+28|0;c=d;d=k[d>>2]|0;A=32}else A=58;do if((A|0)==32){if(!(k[d+16>>2]|0)){k[J>>2]=73;A=60;break}q=N+20|0;g=k[q>>2]|0;r=N+32|0;f=k[r>>2]|0;a:do if(f>>>0<(k[d+20>>2]&65535)>>>0){h=N+12|0;n=a+48|0;o=N+8|0;p=a+20|0;e=g;while(1){if((g|0)==(k[h>>2]|0)){if(g>>>0>e>>>0&(k[d+44>>2]|0)!=0){B=yeb(k[n>>2]|0,(k[o>>2]|0)+e|0,g-e|0)|0;k[n>>2]=B}f=k[M>>2]|0;d=f+5820|0;e=k[d>>2]|0;do if((e|0)!=16)if((e|0)>7){B=f+5816|0;g=j[B>>1]&255;e=f+20|0;A=k[e>>2]|0;k[e>>2]=A+1;i[(k[f+8>>2]|0)+A>>0]=g;j[B>>1]=(m[B>>1]|0)>>>8;k[d>>2]=(k[d>>2]|0)+-8;break}else{e=f+20|0;break}else{B=f+5816|0;A=j[B>>1]&255;e=f+20|0;R=k[e>>2]|0;k[e>>2]=R+1;g=f+8|0;i[(k[g>>2]|0)+R>>0]=A;R=(m[B>>1]|0)>>>8&255;A=k[e>>2]|0;k[e>>2]=A+1;i[(k[g>>2]|0)+A>>0]=R;j[B>>1]=0;k[d>>2]=0}while(0);d=k[e>>2]|0;R=k[P>>2]|0;d=d>>>0>R>>>0?R:d;if(d|0?(s=f+16|0,upb(k[Q>>2]|0,k[s>>2]|0,d|0)|0,k[Q>>2]=(k[Q>>2]|0)+d,k[s>>2]=(k[s>>2]|0)+d,k[p>>2]=(k[p>>2]|0)+d,k[P>>2]=(k[P>>2]|0)-d,R=(k[e>>2]|0)-d|0,k[e>>2]=R,(R|0)==0):0)k[s>>2]=k[f+8>>2];g=k[q>>2]|0;if((g|0)==(k[h>>2]|0))break;e=g;d=k[c>>2]|0;f=k[r>>2]|0}f=i[(k[d+16>>2]|0)+f>>0]|0;k[q>>2]=g+1;i[(k[o>>2]|0)+g>>0]=f;f=(k[r>>2]|0)+1|0;k[r>>2]=f;d=k[c>>2]|0;if(f>>>0>=(k[d+20>>2]&65535)>>>0)break a;g=k[q>>2]|0}e=g;d=k[c>>2]|0}else e=g;while(0);if(k[d+44>>2]|0?(t=k[q>>2]|0,t>>>0>e>>>0):0){R=a+48|0;B=yeb(k[R>>2]|0,(k[N+8>>2]|0)+e|0,t-e|0)|0;k[R>>2]=B}if((k[r>>2]|0)==(k[d+20>>2]|0)){k[r>>2]=0;k[J>>2]=73;A=60;break}else{c=k[J>>2]|0;A=58;break}}while(0);if((A|0)==58)if((c|0)==73){d=N+28|0;c=d;d=k[d>>2]|0;A=60}else A=83;do if((A|0)==60){if(!(k[d+28>>2]|0)){k[J>>2]=91;A=85;break}n=N+20|0;e=k[n>>2]|0;g=N+12|0;o=a+48|0;p=N+8|0;h=a+20|0;q=N+32|0;d=e;while(1){if((e|0)==(k[g>>2]|0)){if(e>>>0>d>>>0?(k[(k[c>>2]|0)+44>>2]|0)!=0:0){R=yeb(k[o>>2]|0,(k[p>>2]|0)+d|0,e-d|0)|0;k[o>>2]=R}f=k[M>>2]|0;d=f+5820|0;e=k[d>>2]|0;do if((e|0)!=16)if((e|0)>7){R=f+5816|0;A=j[R>>1]&255;e=f+20|0;B=k[e>>2]|0;k[e>>2]=B+1;i[(k[f+8>>2]|0)+B>>0]=A;j[R>>1]=(m[R>>1]|0)>>>8;k[d>>2]=(k[d>>2]|0)+-8;break}else{e=f+20|0;break}else{R=f+5816|0;B=j[R>>1]&255;e=f+20|0;t=k[e>>2]|0;k[e>>2]=t+1;A=f+8|0;i[(k[A>>2]|0)+t>>0]=B;t=(m[R>>1]|0)>>>8&255;B=k[e>>2]|0;k[e>>2]=B+1;i[(k[A>>2]|0)+B>>0]=t;j[R>>1]=0;k[d>>2]=0}while(0);d=k[e>>2]|0;R=k[P>>2]|0;d=d>>>0>R>>>0?R:d;if(d|0?(u=f+16|0,upb(k[Q>>2]|0,k[u>>2]|0,d|0)|0,k[Q>>2]=(k[Q>>2]|0)+d,k[u>>2]=(k[u>>2]|0)+d,k[h>>2]=(k[h>>2]|0)+d,k[P>>2]=(k[P>>2]|0)-d,R=(k[e>>2]|0)-d|0,k[e>>2]=R,(R|0)==0):0)k[u>>2]=k[f+8>>2];f=k[n>>2]|0;if((f|0)==(k[g>>2]|0)){e=1;d=f;break}else{d=f;e=f}}f=k[q>>2]|0;k[q>>2]=f+1;f=i[(k[(k[c>>2]|0)+28>>2]|0)+f>>0]|0;k[n>>2]=e+1;i[(k[p>>2]|0)+e>>0]=f;if(!(f<<24>>24)){e=f&255;break}e=k[n>>2]|0}if(k[(k[c>>2]|0)+44>>2]|0?(v=k[n>>2]|0,v>>>0>d>>>0):0){R=yeb(k[o>>2]|0,(k[p>>2]|0)+d|0,v-d|0)|0;k[o>>2]=R}if(!e){k[q>>2]=0;k[J>>2]=91;A=85;break}else{c=k[J>>2]|0;A=83;break}}while(0);if((A|0)==83)if((c|0)==91){c=N+28|0;A=85}else{f=c;A=108}do if((A|0)==85){if(!(k[(k[c>>2]|0)+36>>2]|0)){k[J>>2]=103;A=110;break}o=N+20|0;e=k[o>>2]|0;g=N+12|0;p=a+48|0;q=N+8|0;h=a+20|0;n=N+32|0;d=e;while(1){if((e|0)==(k[g>>2]|0)){if(e>>>0>d>>>0?(k[(k[c>>2]|0)+44>>2]|0)!=0:0){R=yeb(k[p>>2]|0,(k[q>>2]|0)+d|0,e-d|0)|0;k[p>>2]=R}f=k[M>>2]|0;d=f+5820|0;e=k[d>>2]|0;do if((e|0)!=16)if((e|0)>7){R=f+5816|0;A=j[R>>1]&255;e=f+20|0;B=k[e>>2]|0;k[e>>2]=B+1;i[(k[f+8>>2]|0)+B>>0]=A;j[R>>1]=(m[R>>1]|0)>>>8;k[d>>2]=(k[d>>2]|0)+-8;break}else{e=f+20|0;break}else{R=f+5816|0;B=j[R>>1]&255;e=f+20|0;v=k[e>>2]|0;k[e>>2]=v+1;A=f+8|0;i[(k[A>>2]|0)+v>>0]=B;v=(m[R>>1]|0)>>>8&255;B=k[e>>2]|0;k[e>>2]=B+1;i[(k[A>>2]|0)+B>>0]=v;j[R>>1]=0;k[d>>2]=0}while(0);d=k[e>>2]|0;R=k[P>>2]|0;d=d>>>0>R>>>0?R:d;if(d|0?(w=f+16|0,upb(k[Q>>2]|0,k[w>>2]|0,d|0)|0,k[Q>>2]=(k[Q>>2]|0)+d,k[w>>2]=(k[w>>2]|0)+d,k[h>>2]=(k[h>>2]|0)+d,k[P>>2]=(k[P>>2]|0)-d,R=(k[e>>2]|0)-d|0,k[e>>2]=R,(R|0)==0):0)k[w>>2]=k[f+8>>2];f=k[o>>2]|0;if((f|0)==(k[g>>2]|0)){e=1;d=f;break}else{d=f;e=f}}f=k[n>>2]|0;k[n>>2]=f+1;f=i[(k[(k[c>>2]|0)+36>>2]|0)+f>>0]|0;k[o>>2]=e+1;i[(k[q>>2]|0)+e>>0]=f;if(!(f<<24>>24)){e=f&255;break}e=k[o>>2]|0}if(k[(k[c>>2]|0)+44>>2]|0?(x=k[o>>2]|0,x>>>0>d>>>0):0){R=yeb(k[p>>2]|0,(k[q>>2]|0)+d|0,x-d|0)|0;k[p>>2]=R}if(!e){k[J>>2]=103;A=110;break}else{f=k[J>>2]|0;A=108;break}}while(0);if((A|0)==108?(f|0)==103:0){c=N+28|0;A=110}do if((A|0)==110){if(!(k[(k[c>>2]|0)+44>>2]|0)){k[J>>2]=113;break}f=N+20|0;g=N+12|0;if(((k[f>>2]|0)+2|0)>>>0>(k[g>>2]|0)>>>0){e=k[M>>2]|0;c=e+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){R=e+5816|0;A=j[R>>1]&255;d=e+20|0;B=k[d>>2]|0;k[d>>2]=B+1;i[(k[e+8>>2]|0)+B>>0]=A;j[R>>1]=(m[R>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=e+20|0;break}else{R=e+5816|0;B=j[R>>1]&255;d=e+20|0;x=k[d>>2]|0;k[d>>2]=x+1;A=e+8|0;i[(k[A>>2]|0)+x>>0]=B;x=(m[R>>1]|0)>>>8&255;B=k[d>>2]|0;k[d>>2]=B+1;i[(k[A>>2]|0)+B>>0]=x;j[R>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;R=k[P>>2]|0;c=c>>>0>R>>>0?R:c;if(c|0?(y=e+16|0,upb(k[Q>>2]|0,k[y>>2]|0,c|0)|0,k[Q>>2]=(k[Q>>2]|0)+c,k[y>>2]=(k[y>>2]|0)+c,R=a+20|0,k[R>>2]=(k[R>>2]|0)+c,k[P>>2]=(k[P>>2]|0)-c,R=(k[d>>2]|0)-c|0,k[d>>2]=R,(R|0)==0):0)k[y>>2]=k[e+8>>2]}c=k[f>>2]|0;if((c+2|0)>>>0<=(k[g>>2]|0)>>>0){R=a+48|0;y=k[R>>2]&255;k[f>>2]=c+1;A=N+8|0;i[(k[A>>2]|0)+c>>0]=y;y=(k[R>>2]|0)>>>8&255;B=k[f>>2]|0;k[f>>2]=B+1;i[(k[A>>2]|0)+B>>0]=y;k[R>>2]=0;k[J>>2]=113}}while(0);B=N+20|0;do if(!(k[B>>2]|0)){c=k[a+4>>2]|0;if(!c)if(K&((b<<1)-((b|0)>4?9:0)|0)<=((z<<1)-((z|0)>4?9:0)|0)){k[a+24>>2]=420037;R=-5;return R|0}else c=0}else{g=k[M>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){R=g+5816|0;z=j[R>>1]&255;f=g+20|0;A=k[f>>2]|0;k[f>>2]=A+1;i[(k[g+8>>2]|0)+A>>0]=z;j[R>>1]=(m[R>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{f=g+20|0;break}else{R=g+5816|0;A=j[R>>1]&255;f=g+20|0;y=k[f>>2]|0;k[f>>2]=y+1;z=g+8|0;i[(k[z>>2]|0)+y>>0]=A;y=(m[R>>1]|0)>>>8&255;A=k[f>>2]|0;k[f>>2]=A+1;i[(k[z>>2]|0)+A>>0]=y;j[R>>1]=0;k[c>>2]=0}while(0);e=k[f>>2]|0;c=k[P>>2]|0;e=e>>>0>c>>>0?c:e;if(e){d=g+16|0;upb(k[Q>>2]|0,k[d>>2]|0,e|0)|0;k[Q>>2]=(k[Q>>2]|0)+e;k[d>>2]=(k[d>>2]|0)+e;c=a+20|0;k[c>>2]=(k[c>>2]|0)+e;c=(k[P>>2]|0)-e|0;k[P>>2]=c;R=(k[f>>2]|0)-e|0;k[f>>2]=R;if(!R)k[d>>2]=k[g+8>>2]}if(c|0){c=k[a+4>>2]|0;break}k[L>>2]=-1;R=0;return R|0}while(0);d=(k[J>>2]|0)==666;c=(c|0)==0;if(d)if(c)A=142;else{k[a+24>>2]=420037;R=-5;return R|0}else if(c)A=142;else A=143;if((A|0)==142?!((k[N+116>>2]|0)==0&((b|0)==0|d)):0)A=143;do if((A|0)==143){b:do switch(k[N+136>>2]|0){case 2:{h=N+116|0;n=N+96|0;t=N+108|0;s=N+56|0;o=N+5792|0;p=N+5796|0;q=N+5784|0;r=N+5788|0;u=N+92|0;while(1){if((k[h>>2]|0)==0?(Eeb(N),(k[h>>2]|0)==0):0)break;k[n>>2]=0;R=i[(k[s>>2]|0)+(k[t>>2]|0)>>0]|0;c=k[o>>2]|0;j[(k[p>>2]|0)+(c<<1)>>1]=0;k[o>>2]=c+1;i[(k[q>>2]|0)+c>>0]=R;R=N+148+((R&255)<<2)|0;j[R>>1]=(j[R>>1]|0)+1<<16>>16;R=(k[o>>2]|0)==((k[r>>2]|0)+-1|0);k[h>>2]=(k[h>>2]|0)+-1;c=(k[t>>2]|0)+1|0;k[t>>2]=c;if(!R)continue;d=k[u>>2]|0;if((d|0)>-1)e=(k[s>>2]|0)+d|0;else e=0;Seb(N,e,c-d|0,0);k[u>>2]=k[t>>2];f=k[N>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){R=g+5816|0;H=j[R>>1]&255;d=g+20|0;I=k[d>>2]|0;k[d>>2]=I+1;i[(k[g+8>>2]|0)+I>>0]=H;j[R>>1]=(m[R>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{R=g+5816|0;I=j[R>>1]&255;d=g+20|0;G=k[d>>2]|0;k[d>>2]=G+1;H=g+8|0;i[(k[H>>2]|0)+G>>0]=I;G=(m[R>>1]|0)>>>8&255;I=k[d>>2]|0;k[d>>2]=I+1;i[(k[H>>2]|0)+I>>0]=G;j[R>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;R=k[e>>2]|0;c=c>>>0>R>>>0?R:c;if(c|0?(R=f+12|0,C=g+16|0,upb(k[R>>2]|0,k[C>>2]|0,c|0)|0,k[R>>2]=(k[R>>2]|0)+c,k[C>>2]=(k[C>>2]|0)+c,R=f+20|0,k[R>>2]=(k[R>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,R=(k[d>>2]|0)-c|0,k[d>>2]=R,(R|0)==0):0)k[C>>2]=k[g+8>>2];if(!(k[(k[N>>2]|0)+16>>2]|0)){A=247;break b}}if(b){k[N+5812>>2]=0;if((b|0)==4){d=k[u>>2]|0;if((d|0)>-1)c=(k[s>>2]|0)+d|0;else c=0;Seb(N,c,(k[t>>2]|0)-d|0,1);k[u>>2]=k[t>>2];f=k[N>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){R=g+5816|0;H=j[R>>1]&255;d=g+20|0;I=k[d>>2]|0;k[d>>2]=I+1;i[(k[g+8>>2]|0)+I>>0]=H;j[R>>1]=(m[R>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{R=g+5816|0;I=j[R>>1]&255;d=g+20|0;G=k[d>>2]|0;k[d>>2]=G+1;H=g+8|0;i[(k[H>>2]|0)+G>>0]=I;G=(m[R>>1]|0)>>>8&255;I=k[d>>2]|0;k[d>>2]=I+1;i[(k[H>>2]|0)+I>>0]=G;j[R>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;R=k[e>>2]|0;c=c>>>0>R>>>0?R:c;if(c|0?(R=f+12|0,D=g+16|0,upb(k[R>>2]|0,k[D>>2]|0,c|0)|0,k[R>>2]=(k[R>>2]|0)+c,k[D>>2]=(k[D>>2]|0)+c,R=f+20|0,k[R>>2]=(k[R>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,R=(k[d>>2]|0)-c|0,k[d>>2]=R,(R|0)==0):0)k[D>>2]=k[g+8>>2];c=(k[(k[N>>2]|0)+16>>2]|0)==0?2:3;A=244;break b}if(k[o>>2]|0){d=k[u>>2]|0;if((d|0)>-1)c=(k[s>>2]|0)+d|0;else c=0;Seb(N,c,(k[t>>2]|0)-d|0,0);k[u>>2]=k[t>>2];f=k[N>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){R=g+5816|0;I=j[R>>1]&255;d=g+20|0;J=k[d>>2]|0;k[d>>2]=J+1;i[(k[g+8>>2]|0)+J>>0]=I;j[R>>1]=(m[R>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{R=g+5816|0;J=j[R>>1]&255;d=g+20|0;H=k[d>>2]|0;k[d>>2]=H+1;I=g+8|0;i[(k[I>>2]|0)+H>>0]=J;H=(m[R>>1]|0)>>>8&255;J=k[d>>2]|0;k[d>>2]=J+1;i[(k[I>>2]|0)+J>>0]=H;j[R>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;R=k[e>>2]|0;c=c>>>0>R>>>0?R:c;if(c|0?(R=f+12|0,E=g+16|0,upb(k[R>>2]|0,k[E>>2]|0,c|0)|0,k[R>>2]=(k[R>>2]|0)+c,k[E>>2]=(k[E>>2]|0)+c,R=f+20|0,k[R>>2]=(k[R>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,R=(k[d>>2]|0)-c|0,k[d>>2]=R,(R|0)==0):0)k[E>>2]=k[g+8>>2];if(!(k[(k[N>>2]|0)+16>>2]|0))A=247}}else A=247;break}case 3:{p=N+116|0;q=(b|0)==0;r=N+96|0;y=N+108|0;s=N+5792|0;t=N+5796|0;u=N+5784|0;v=N+5788|0;x=N+56|0;z=N+92|0;w=N+2440|0;while(1){c=k[p>>2]|0;if(c>>>0<259){Eeb(N);c=k[p>>2]|0;if(q&c>>>0<259){A=247;break b}if(!c)break;k[r>>2]=0;if(c>>>0>2)A=191;else{c=k[y>>2]|0;A=206}}else{k[r>>2]=0;A=191}if((A|0)==191){A=0;o=k[y>>2]|0;if(o){g=(k[x>>2]|0)+o|0;h=i[g+-1>>0]|0;if((h<<24>>24==(i[g>>0]|0)?(F=g+1|0,h<<24>>24==(i[F>>0]|0)):0)?h<<24>>24==(i[F+1>>0]|0):0){n=g+258|0;f=1;do{e=g+f|0;d=e+2|0;if(h<<24>>24!=(i[d>>0]|0))break;d=e+3|0;if(h<<24>>24!=(i[d>>0]|0))break;d=e+4|0;if(h<<24>>24!=(i[d>>0]|0))break;d=e+5|0;if(h<<24>>24!=(i[d>>0]|0))break;d=e+6|0;if(h<<24>>24!=(i[d>>0]|0))break;d=e+7|0;if(h<<24>>24!=(i[d>>0]|0))break;e=f;f=f+8|0;d=g+f|0;if(h<<24>>24!=(i[d>>0]|0))break;R=e+9|0;d=g+R|0}while((R|0)<258?h<<24>>24==(i[d>>0]|0):0);R=d-n+258|0;c=R>>>0>c>>>0?c:R;k[r>>2]=c;if(c>>>0>2){c=c+253|0;e=k[s>>2]|0;j[(k[t>>2]|0)+(e<<1)>>1]=1;k[s>>2]=e+1;i[(k[u>>2]|0)+e>>0]=c;c=N+148+((l[419729+(c&255)>>0]|256)+1<<2)|0;j[c>>1]=(j[c>>1]|0)+1<<16>>16;j[w>>1]=(j[w>>1]|0)+1<<16>>16;c=(k[s>>2]|0)==((k[v>>2]|0)+-1|0)&1;e=k[r>>2]|0;k[p>>2]=(k[p>>2]|0)-e;e=(k[y>>2]|0)+e|0;k[y>>2]=e;k[r>>2]=0}else{c=o;A=206}}else{c=o;A=206}}else{c=0;A=206}}if((A|0)==206){A=0;c=i[(k[x>>2]|0)+c>>0]|0;e=k[s>>2]|0;j[(k[t>>2]|0)+(e<<1)>>1]=0;k[s>>2]=e+1;i[(k[u>>2]|0)+e>>0]=c;c=N+148+((c&255)<<2)|0;j[c>>1]=(j[c>>1]|0)+1<<16>>16;c=(k[s>>2]|0)==((k[v>>2]|0)+-1|0)&1;k[p>>2]=(k[p>>2]|0)+-1;e=(k[y>>2]|0)+1|0;k[y>>2]=e}if(!c)continue;c=k[z>>2]|0;if((c|0)>-1)d=(k[x>>2]|0)+c|0;else d=0;Seb(N,d,e-c|0,0);k[z>>2]=k[y>>2];f=k[N>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){R=g+5816|0;D=j[R>>1]&255;d=g+20|0;E=k[d>>2]|0;k[d>>2]=E+1;i[(k[g+8>>2]|0)+E>>0]=D;j[R>>1]=(m[R>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{R=g+5816|0;E=j[R>>1]&255;d=g+20|0;C=k[d>>2]|0;k[d>>2]=C+1;D=g+8|0;i[(k[D>>2]|0)+C>>0]=E;C=(m[R>>1]|0)>>>8&255;E=k[d>>2]|0;k[d>>2]=E+1;i[(k[D>>2]|0)+E>>0]=C;j[R>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;R=k[e>>2]|0;c=c>>>0>R>>>0?R:c;if(c|0?(R=f+12|0,G=g+16|0,upb(k[R>>2]|0,k[G>>2]|0,c|0)|0,k[R>>2]=(k[R>>2]|0)+c,k[G>>2]=(k[G>>2]|0)+c,R=f+20|0,k[R>>2]=(k[R>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,R=(k[d>>2]|0)-c|0,k[d>>2]=R,(R|0)==0):0)k[G>>2]=k[g+8>>2];if(!(k[(k[N>>2]|0)+16>>2]|0)){A=247;break b}}k[N+5812>>2]=0;if((b|0)==4){d=k[z>>2]|0;if((d|0)>-1)c=(k[x>>2]|0)+d|0;else c=0;Seb(N,c,(k[y>>2]|0)-d|0,1);k[z>>2]=k[y>>2];f=k[N>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){R=g+5816|0;G=j[R>>1]&255;d=g+20|0;I=k[d>>2]|0;k[d>>2]=I+1;i[(k[g+8>>2]|0)+I>>0]=G;j[R>>1]=(m[R>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{R=g+5816|0;I=j[R>>1]&255;d=g+20|0;F=k[d>>2]|0;k[d>>2]=F+1;G=g+8|0;i[(k[G>>2]|0)+F>>0]=I;F=(m[R>>1]|0)>>>8&255;I=k[d>>2]|0;k[d>>2]=I+1;i[(k[G>>2]|0)+I>>0]=F;j[R>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;R=k[e>>2]|0;c=c>>>0>R>>>0?R:c;if(c|0?(R=f+12|0,H=g+16|0,upb(k[R>>2]|0,k[H>>2]|0,c|0)|0,k[R>>2]=(k[R>>2]|0)+c,k[H>>2]=(k[H>>2]|0)+c,R=f+20|0,k[R>>2]=(k[R>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,R=(k[d>>2]|0)-c|0,k[d>>2]=R,(R|0)==0):0)k[H>>2]=k[g+8>>2];c=(k[(k[N>>2]|0)+16>>2]|0)==0?2:3;A=244;break b}if(k[s>>2]|0){d=k[z>>2]|0;if((d|0)>-1)c=(k[x>>2]|0)+d|0;else c=0;Seb(N,c,(k[y>>2]|0)-d|0,0);k[z>>2]=k[y>>2];f=k[N>>2]|0;g=k[f+28>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){R=g+5816|0;H=j[R>>1]&255;d=g+20|0;J=k[d>>2]|0;k[d>>2]=J+1;i[(k[g+8>>2]|0)+J>>0]=H;j[R>>1]=(m[R>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=g+20|0;break}else{R=g+5816|0;J=j[R>>1]&255;d=g+20|0;G=k[d>>2]|0;k[d>>2]=G+1;H=g+8|0;i[(k[H>>2]|0)+G>>0]=J;G=(m[R>>1]|0)>>>8&255;J=k[d>>2]|0;k[d>>2]=J+1;i[(k[H>>2]|0)+J>>0]=G;j[R>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;e=f+16|0;R=k[e>>2]|0;c=c>>>0>R>>>0?R:c;if(c|0?(R=f+12|0,I=g+16|0,upb(k[R>>2]|0,k[I>>2]|0,c|0)|0,k[R>>2]=(k[R>>2]|0)+c,k[I>>2]=(k[I>>2]|0)+c,R=f+20|0,k[R>>2]=(k[R>>2]|0)+c,k[e>>2]=(k[e>>2]|0)-c,R=(k[d>>2]|0)-c|0,k[d>>2]=R,(R|0)==0):0)k[I>>2]=k[g+8>>2];if(!(k[(k[N>>2]|0)+16>>2]|0))A=247}break}default:{c=Hh[k[164752+((k[N+132>>2]|0)*12|0)+8>>2]&511](N,b)|0;A=244}}while(0);if((A|0)==244){if((c|1|0)==3)k[J>>2]=666;if((c|2|0)!=2){if((c|0)!=1)break}else A=247}if((A|0)==247){if(k[P>>2]|0){R=0;return R|0}k[L>>2]=-1;R=0;return R|0}switch(b|0){case 1:{Reb(N);break}case 5:break;default:{Qeb(N,0,0,0);if((b|0)==3?(R=k[N+76>>2]|0,b=k[N+68>>2]|0,j[b+(R+-1<<1)>>1]=0,zpb(b|0,0,(R<<1)+-2|0)|0,(k[N+116>>2]|0)==0):0){k[N+108>>2]=0;k[N+92>>2]=0;k[N+5812>>2]=0}}}g=k[M>>2]|0;c=g+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){R=g+5816|0;J=j[R>>1]&255;f=g+20|0;b=k[f>>2]|0;k[f>>2]=b+1;i[(k[g+8>>2]|0)+b>>0]=J;j[R>>1]=(m[R>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{f=g+20|0;break}else{R=g+5816|0;b=j[R>>1]&255;f=g+20|0;I=k[f>>2]|0;k[f>>2]=I+1;J=g+8|0;i[(k[J>>2]|0)+I>>0]=b;I=(m[R>>1]|0)>>>8&255;b=k[f>>2]|0;k[f>>2]=b+1;i[(k[J>>2]|0)+b>>0]=I;j[R>>1]=0;k[c>>2]=0}while(0);e=k[f>>2]|0;c=k[P>>2]|0;e=e>>>0>c>>>0?c:e;if(e){d=g+16|0;upb(k[Q>>2]|0,k[d>>2]|0,e|0)|0;k[Q>>2]=(k[Q>>2]|0)+e;k[d>>2]=(k[d>>2]|0)+e;c=a+20|0;k[c>>2]=(k[c>>2]|0)+e;c=(k[P>>2]|0)-e|0;k[P>>2]=c;R=(k[f>>2]|0)-e|0;k[f>>2]=R;if(!R)k[d>>2]=k[g+8>>2]}if(!c){k[L>>2]=-1;R=0;return R|0}}while(0);if(K){R=0;return R|0}f=N+24|0;c=k[f>>2]|0;if((c|0)<1){R=1;return R|0}d=a+48|0;e=k[d>>2]|0;if((c|0)==2){K=k[B>>2]|0;k[B>>2]=K+1;N=N+8|0;i[(k[N>>2]|0)+K>>0]=e;K=(k[d>>2]|0)>>>8&255;L=k[B>>2]|0;k[B>>2]=L+1;i[(k[N>>2]|0)+L>>0]=K;L=(k[d>>2]|0)>>>16&255;K=k[B>>2]|0;k[B>>2]=K+1;i[(k[N>>2]|0)+K>>0]=L;K=(k[d>>2]|0)>>>24&255;L=k[B>>2]|0;k[B>>2]=L+1;i[(k[N>>2]|0)+L>>0]=K;L=a+8|0;K=k[L>>2]&255;R=k[B>>2]|0;k[B>>2]=R+1;i[(k[N>>2]|0)+R>>0]=K;R=(k[L>>2]|0)>>>8&255;K=k[B>>2]|0;k[B>>2]=K+1;i[(k[N>>2]|0)+K>>0]=R;K=(k[L>>2]|0)>>>16&255;R=k[B>>2]|0;k[B>>2]=R+1;i[(k[N>>2]|0)+R>>0]=K;L=(k[L>>2]|0)>>>24&255;R=k[B>>2]|0;k[B>>2]=R+1;i[(k[N>>2]|0)+R>>0]=L}else{L=k[B>>2]|0;k[B>>2]=L+1;N=N+8|0;i[(k[N>>2]|0)+L>>0]=e>>>24;L=k[B>>2]|0;k[B>>2]=L+1;i[(k[N>>2]|0)+L>>0]=e>>>16;L=k[d>>2]|0;R=k[B>>2]|0;k[B>>2]=R+1;i[(k[N>>2]|0)+R>>0]=L>>>8;R=k[B>>2]|0;k[B>>2]=R+1;i[(k[N>>2]|0)+R>>0]=L}e=k[M>>2]|0;c=e+5820|0;d=k[c>>2]|0;do if((d|0)!=16)if((d|0)>7){R=e+5816|0;M=j[R>>1]&255;d=e+20|0;N=k[d>>2]|0;k[d>>2]=N+1;i[(k[e+8>>2]|0)+N>>0]=M;j[R>>1]=(m[R>>1]|0)>>>8;k[c>>2]=(k[c>>2]|0)+-8;break}else{d=e+20|0;break}else{R=e+5816|0;N=j[R>>1]&255;d=e+20|0;L=k[d>>2]|0;k[d>>2]=L+1;M=e+8|0;i[(k[M>>2]|0)+L>>0]=N;L=(m[R>>1]|0)>>>8&255;N=k[d>>2]|0;k[d>>2]=N+1;i[(k[M>>2]|0)+N>>0]=L;j[R>>1]=0;k[c>>2]=0}while(0);c=k[d>>2]|0;R=k[P>>2]|0;c=c>>>0>R>>>0?R:c;if(c|0?(O=e+16|0,upb(k[Q>>2]|0,k[O>>2]|0,c|0)|0,k[Q>>2]=(k[Q>>2]|0)+c,k[O>>2]=(k[O>>2]|0)+c,R=a+20|0,k[R>>2]=(k[R>>2]|0)+c,k[P>>2]=(k[P>>2]|0)-c,R=(k[d>>2]|0)-c|0,k[d>>2]=R,(R|0)==0):0)k[O>>2]=k[e+8>>2];c=k[f>>2]|0;if((c|0)>0)k[f>>2]=0-c;R=(k[B>>2]|0)==0&1;return R|0}}while(0);k[a+24>>2]=420004;R=-2;return R|0}function Ieb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+16|0;j=l+8|0;h=l;if(!a){r=l;return}b=k[a+12>>2]|0;if((b|0)==7247){if(k[a+24>>2]|0){g=a+112|0;b=k[g>>2]|0;if(b|0?(e=a+120|0,c=k[e>>2]|0,c|0):0){d=k[b+52>>2]|0;f=a+124|0;if(d){jh[c&1023](k[f>>2]|0,d);c=k[e>>2]|0;b=k[g>>2]|0}jh[c&1023](k[f>>2]|0,b);k[g>>2]=0}ggb(k[a+36>>2]|0);ggb(k[a+32>>2]|0)}c=a+80|0;d=k[c>>2]|0;b=a+76|0;if(d|0){if((k[b>>2]|0)!=-4)ggb(d);k[c>>2]=0}k[b>>2]=0;ggb(k[a+20>>2]|0);k[h>>2]=k[a+16>>2];b=ee(6,h|0)|0;b=(b|0)==-4?-115:b;if(b>>>0>4294963200){if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=0-b}ggb(a);r=l;return}if((b|0)!=31153){r=l;return}b=a+72|0;do if(k[b>>2]|0){k[b>>2]=0;b=k[a+68>>2]|0;e=a+88|0;if(!(k[e>>2]|0)){if(!b)break}else if((Meb(a,0)|0)==-1|(b|0)==0)break;f=a+24|0;g=a+32|0;h=a+84|0;i=a+8|0;c=0;while(1){d=k[f>>2]|0;d=(d|0)<0|(d|0)>(b|0)?b:d;if(!c)zpb(k[g>>2]|0,0,d|0)|0;k[e>>2]=d;k[h>>2]=k[g>>2];k[i>>2]=(k[i>>2]|0)+d;b=b-d|0;if((Meb(a,0)|0)==-1|(b|0)==0)break;else c=1}}while(0);Meb(a,4)|0;if(k[a+24>>2]|0){if(!(k[a+40>>2]|0)){Geb(a+84|0)|0;ggb(k[a+36>>2]|0)}ggb(k[a+32>>2]|0)}c=a+80|0;d=k[c>>2]|0;b=a+76|0;if(d|0){if((k[b>>2]|0)!=-4)ggb(d);k[c>>2]=0}k[b>>2]=0;ggb(k[a+20>>2]|0);k[j>>2]=k[a+16>>2];b=ee(6,j|0)|0;b=(b|0)==-4?-115:b;if(b>>>0>4294963200){if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=0-b}ggb(a);r=l;return}function Jeb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+16|0;p=q;j=a+80|0;d=k[j>>2]|0;if(d|0){if((k[a+76>>2]|0)!=-4)ggb(d);k[j>>2]=0}switch(b|0){case 0:case -5:break;default:k[a>>2]=0}h=a+76|0;k[h>>2]=b;if((b|0)==-4|(c|0)==0){r=q;return}o=k[a+20>>2]|0;l=o;e=(l&3|0)==0;a:do if(e){d=o;n=11}else{a=o;d=l;while(1){if(!(i[a>>0]|0))break a;a=a+1|0;d=a;if(!(d&3)){d=a;n=11;break}}}while(0);if((n|0)==11){while(1){a=k[d>>2]|0;if(!((a&-2139062144^-2139062144)&a+-16843009))d=d+4|0;else break}if((a&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}b=d-l|0;m=c;g=(m&3|0)==0;b:do if(g){d=c;n=19}else{a=c;d=m;while(1){if(!(i[a>>0]|0))break b;a=a+1|0;d=a;if(!(d&3)){d=a;n=19;break}}}while(0);if((n|0)==19){while(1){a=k[d>>2]|0;if(!((a&-2139062144^-2139062144)&a+-16843009))d=d+4|0;else break}if((a&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}f=fgb(b+3+(d-m)|0)|0;k[j>>2]=f;if(!f){k[h>>2]=-4;r=q;return}c:do if(e){d=o;n=29}else{a=o;d=l;while(1){if(!(i[a>>0]|0))break c;a=a+1|0;d=a;if(!(d&3)){d=a;n=29;break}}}while(0);if((n|0)==29){while(1){a=k[d>>2]|0;if(!((a&-2139062144^-2139062144)&a+-16843009))d=d+4|0;else break}if((a&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}b=d-l|0;d:do if(g){d=c;n=37}else{d=c;a=m;while(1){if(!(i[d>>0]|0)){d=a;break d}d=d+1|0;a=d;if(!(a&3)){n=37;break}}}while(0);if((n|0)==37){while(1){a=k[d>>2]|0;if(!((a&-2139062144^-2139062144)&a+-16843009))d=d+4|0;else break}if((a&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}k[p>>2]=o;k[p+4>>2]=418573;k[p+8>>2]=c;kfb(f,b+3+(d-m)|0,418566,p)|0;r=q;return}function Keb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;L=r;r=r+48|0;C=L+32|0;I=L+16|0;B=L;h=a+44|0;E=a+52|0;w=a+88|0;D=a+24|0;x=a+100|0;H=a+36|0;y=a+96|0;z=a+84|0;A=a+28|0;j=a+32|0;m=a+116|0;n=a+120|0;o=a+124|0;p=a+108|0;q=a+112|0;s=a+104|0;t=a+92|0;u=a+132|0;J=a+76|0;F=a+16|0;v=a+40|0;G=a+4|0;a:while(1){switch(k[h>>2]|0){case 1:{K=59;break a}case 0:{if(!(k[D>>2]|0)){c=k[A>>2]|0;b=fgb(c)|0;k[j>>2]=b;d=fgb(c<<1)|0;k[H>>2]=d;e=(d|0)==0;if((b|0)==0|e){K=5;break a}k[D>>2]=c;k[m>>2]=0;k[n>>2]=0;k[o>>2]=0;k[w>>2]=0;k[z>>2]=0;k[p>>2]=0;k[m>>2]=151;k[o>>2]=0;k[n>>2]=851;b=Web(0,1,7116)|0;if(!b){K=16;break a}k[q>>2]=b;k[b+52>>2]=0;k[b+8>>2]=2;k[b+36>>2]=15;k[b+40>>2]=0;k[b+44>>2]=0;k[b+48>>2]=0;k[b+28>>2]=0;k[s>>2]=0;k[t>>2]=0;k[p>>2]=0;k[u>>2]=0;k[b>>2]=0;k[b+4>>2]=0;k[b+12>>2]=0;k[b+20>>2]=32768;k[b+32>>2]=0;k[b+56>>2]=0;k[b+60>>2]=0;g=b+1328|0;k[b+108>>2]=g;k[b+80>>2]=g;k[b+76>>2]=g;k[b+7104>>2]=1;k[b+7108>>2]=-1}b=k[w>>2]|0;if(b>>>0<2){switch(k[J>>2]|0){case -5:case 0:break;default:{b=-1;K=120;break a}}if(!(k[E>>2]|0)){if(!b)b=0;else{i[k[j>>2]>>0]=i[k[z>>2]>>0]|0;b=k[w>>2]|0}d=(k[j>>2]|0)+b|0;c=(k[D>>2]|0)-b|0;b=0;do{k[B>>2]=k[F>>2];k[B+4>>2]=d+b;k[B+8>>2]=c-b;e=ce(3,B|0)|0;if(e>>>0>4294963200){K=28;break a}if((e|0)<1){K=33;break}b=e+b|0}while(b>>>0<c>>>0);if((K|0)==33){K=0;if((e|0)<0){K=35;break a}k[E>>2]=1}b=(k[w>>2]|0)+b|0;k[w>>2]=b;k[z>>2]=k[j>>2]}switch(b|0){case 0:break;case 1:{b=1;K=55;break}default:K=48}}else K=48;if((K|0)==48){K=0;g=k[z>>2]|0;if((i[g>>0]|0)==31?(i[g+1>>0]|0)==-117:0){b=k[q>>2]|0;if(b|0){k[b+40>>2]=0;k[b+44>>2]=0;k[b+48>>2]=0;k[b+28>>2]=0;k[s>>2]=0;k[t>>2]=0;k[p>>2]=0;c=k[b+8>>2]|0;if(c|0)k[u>>2]=c&1;k[b>>2]=0;k[b+4>>2]=0;k[b+12>>2]=0;k[b+20>>2]=32768;k[b+32>>2]=0;k[b+56>>2]=0;k[b+60>>2]=0;g=b+1328|0;k[b+108>>2]=g;k[b+80>>2]=g;k[b+76>>2]=g;k[b+7104>>2]=1;k[b+7108>>2]=-1}k[h>>2]=2;k[v>>2]=0}else K=55}do if((K|0)==55){K=0;if(!(k[v>>2]|0)){k[w>>2]=0;k[E>>2]=1;k[a>>2]=0;break}else{g=k[H>>2]|0;k[G>>2]=g;upb(g|0,k[z>>2]|0,b|0)|0;k[a>>2]=k[w>>2];k[w>>2]=0;k[h>>2]=1;k[v>>2]=1;break}}while(0);if(!(k[h>>2]|0)){b=0;K=120;break a}break}case 2:{g=k[D>>2]<<1;k[x>>2]=g;k[y>>2]=k[H>>2];e=0;while(1){if(!(k[w>>2]|0)){switch(k[J>>2]|0){case -5:case 0:break;default:{b=-1;K=120;break a}}if(k[E>>2]|0){K=105;break}c=k[j>>2]|0;d=k[D>>2]|0;b=0;do{k[C>>2]=k[F>>2];k[C+4>>2]=c+b;k[C+8>>2]=d-b;f=ce(3,C|0)|0;if(f>>>0>4294963200){K=86;break a}if((f|0)<1){K=91;break}b=f+b|0}while(b>>>0<d>>>0);if((K|0)==91){K=0;if((f|0)<0){K=93;break a}k[E>>2]=1}f=(k[w>>2]|0)+b|0;k[w>>2]=f;k[z>>2]=k[j>>2];if(!f){K=105;break}}b=Neb(z,0)|0;switch(b|0){case 2:case -2:{K=107;break a}case -4:{K=108;break a}case -3:{K=113;break a}default:{}}c=k[x>>2]|0;if((b|0)!=1&(c|0)!=0)e=b;else break}if((K|0)==105){K=0;Jeb(a,-5,418576);b=e;c=k[x>>2]|0}g=g-c|0;k[a>>2]=g;k[G>>2]=(k[y>>2]|0)+(0-g);if((b|0)==1)k[h>>2]=0;break}default:{}}if(k[a>>2]|0){b=0;K=120;break}if(!(k[E>>2]|0))continue;if(!(k[w>>2]|0)){b=0;K=120;break}}switch(K|0){case 5:{if(!e){ggb(d);b=k[j>>2]|0}if(b|0)ggb(b);b=a+80|0;c=k[b>>2]|0;if(c|0){if((k[J>>2]|0)!=-4)ggb(c);k[b>>2]=0}k[a>>2]=0;k[J>>2]=-4;a=-1;r=L;return a|0}case 16:{ggb(k[H>>2]|0);ggb(k[j>>2]|0);k[D>>2]=0;b=a+80|0;c=k[b>>2]|0;if(c|0){if((k[J>>2]|0)!=-4)ggb(c);k[b>>2]=0}k[a>>2]=0;k[J>>2]=-4;a=-1;r=L;return a|0}case 28:{b=k[206783]|0;if(!b)c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=0-e;K=36;break}case 35:{b=k[206783]|0;K=36;break}case 59:{d=k[H>>2]|0;c=k[D>>2]<<1;k[a>>2]=0;b=0;while(1){k[I>>2]=k[F>>2];k[I+4>>2]=d+b;k[I+8>>2]=c-b;e=ce(3,I|0)|0;if(e>>>0>4294963200){K=61;break}if((e|0)<1){K=66;break}b=(k[a>>2]|0)+e|0;k[a>>2]=b;if(b>>>0>=c>>>0){K=79;break}}do if((K|0)==61){b=k[206783]|0;if(!b)c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=0-e}else if((K|0)==66)if((e|0)<0){b=k[206783]|0;break}else{k[E>>2]=1;K=79;break}while(0);if((K|0)==79){k[G>>2]=k[H>>2];a=0;r=L;return a|0}if(!b)b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}c=k[b>>2]|0;d=0;while(1){if((l[421658+d>>0]|0)==(c|0)){K=72;break}b=d+1|0;if((b|0)==87){b=421746;d=87;K=75;break}else d=b}if((K|0)==72)if(!d)b=421746;else{b=421746;K=75}if((K|0)==75)while(1){do{K=b;b=b+1|0}while((i[K>>0]|0)!=0);d=d+-1|0;if(!d)break;else K=75}Jeb(a,-1,b);a=-1;r=L;return a|0}case 86:{b=k[206783]|0;if(!b)c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=0-f;K=94;break}case 93:{b=k[206783]|0;K=94;break}case 107:{Jeb(a,-2,418599);a=-1;r=L;return a|0}case 108:{b=a+80|0;c=k[b>>2]|0;if(c|0){if((k[J>>2]|0)!=-4)ggb(c);k[b>>2]=0}k[a>>2]=0;k[J>>2]=-4;a=-1;r=L;return a|0}case 113:{K=k[p>>2]|0;Jeb(a,-3,(K|0)==0?418638:K);a=-1;r=L;return a|0}case 120:{r=L;return b|0}}if((K|0)==36){if(!b)b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}c=k[b>>2]|0;d=0;while(1){if((l[421658+d>>0]|0)==(c|0)){K=39;break}b=d+1|0;if((b|0)==87){b=421746;d=87;K=42;break}else d=b}if((K|0)==39)if(!d)b=421746;else{b=421746;K=42}if((K|0)==42)while(1){do{K=b;b=b+1|0}while((i[K>>0]|0)!=0);d=d+-1|0;if(!d)break;else K=42}Jeb(a,-1,b);a=-1;r=L;return a|0}else if((K|0)==94){if(!b)b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}c=k[b>>2]|0;d=0;while(1){if((l[421658+d>>0]|0)==(c|0)){K=97;break}b=d+1|0;if((b|0)==87){b=421746;d=87;K=100;break}else d=b}if((K|0)==97)if(!d)b=421746;else{b=421746;K=100}if((K|0)==100)while(1){do{K=b;b=b+1|0}while((i[K>>0]|0)!=0);d=d+-1|0;if(!d)break;else K=100}Jeb(a,-1,b);a=-1;r=L;return a|0}return 0}function Leb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;c=a+84|0;e=a+28|0;b=k[e>>2]|0;f=fgb(b)|0;g=a+32|0;k[g>>2]=f;if(!f){c=a+80|0;d=k[c>>2]|0;b=a+76|0;if(d|0){if((k[b>>2]|0)!=-4)ggb(d);k[c>>2]=0}k[a>>2]=0;k[b>>2]=-4;a=-1;return a|0}h=a+40|0;if(k[h>>2]|0){k[a+24>>2]=b;a=0;return a|0}b=fgb(b)|0;d=a+36|0;k[d>>2]=b;if(!b){ggb(f);c=a+80|0;d=k[c>>2]|0;b=a+76|0;if(d|0){if((k[b>>2]|0)!=-4)ggb(d);k[c>>2]=0}k[a>>2]=0;k[b>>2]=-4;a=-1;return a|0}k[a+116>>2]=0;k[a+120>>2]=0;k[a+124>>2]=0;if(!(zeb(c,k[a+60>>2]|0,8,31,8,k[a+64>>2]|0,418750,56)|0)){b=k[e>>2]|0;h=k[h>>2]|0;k[a+24>>2]=b;if(h|0){a=0;return a|0}k[a+100>>2]=b;h=k[d>>2]|0;k[a+96>>2]=h;k[a+4>>2]=h;a=0;return a|0}ggb(k[d>>2]|0);ggb(k[g>>2]|0);c=a+80|0;d=k[c>>2]|0;b=a+76|0;if(d|0){if((k[b>>2]|0)!=-4)ggb(d);k[c>>2]=0}k[a>>2]=0;k[b>>2]=-4;a=-1;return a|0}function Meb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+64|0;h=u+48|0;d=u+32|0;f=u+16|0;g=u;s=a+84|0;t=a+24|0;if((k[t>>2]|0)==0?(Leb(a)|0)==-1:0){a=-1;r=u;return a|0}if(k[a+40>>2]|0){s=k[s>>2]|0;c=a+88|0;t=k[c>>2]|0;k[d>>2]=k[a+16>>2];k[d+4>>2]=s;k[d+8>>2]=t;d=cf(4,d|0)|0;if(d>>>0<=4294963200){if((d|0)>=0?(d|0)==(k[c>>2]|0):0){k[c>>2]=0;a=0;r=u;return a|0}}else{if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=0-d}if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}d=k[c>>2]|0;e=0;while(1){if((l[421658+e>>0]|0)==(d|0)){j=41;break}c=e+1|0;if((c|0)==87){c=421746;e=87;j=44;break}else e=c}if((j|0)==41)if(!e)c=421746;else{c=421746;j=44}if((j|0)==44)while(1){do{t=c;c=c+1|0}while((i[t>>0]|0)!=0);e=e+-1|0;if(!e)break;else j=44}Jeb(a,-1,c);a=-1;r=u;return a|0}m=a+100|0;n=a+96|0;o=a+4|0;p=a+36|0;q=a+16|0;a:do switch(b|0){case 0:{d=k[m>>2]|0;while(1){if(!d){c=k[o>>2]|0;d=(k[n>>2]|0)-c|0;if(d){k[g>>2]=k[q>>2];k[g+4>>2]=c;k[g+8>>2]=d;e=cf(4,g|0)|0;if(e>>>0>4294963200)break;if(!((e|0)>-1&(e|0)==(d|0))){j=57;break a}c=k[m>>2]|0;if(c)d=k[n>>2]|0;else j=17}else j=17;if((j|0)==17){j=0;c=k[t>>2]|0;k[m>>2]=c;d=k[p>>2]|0;k[n>>2]=d}k[o>>2]=d}else c=d;if((Heb(s,0)|0)==-2){j=72;break a}d=k[m>>2]|0;if((c|0)==(d|0)){j=74;break a}}if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=0-e;j=57;break}case 4:{d=0;c=k[m>>2]|0;while(1){if((c|0)==0|(d|0)==1){d=k[o>>2]|0;e=(k[n>>2]|0)-d|0;if(e){k[h>>2]=k[q>>2];k[h+4>>2]=d;k[h+8>>2]=e;d=cf(4,h|0)|0;if(d>>>0>4294963200)break;if(!((d|0)>-1&(d|0)==(e|0))){j=57;break a}c=k[m>>2]|0}if(!c){c=k[t>>2]|0;k[m>>2]=c;d=k[p>>2]|0;k[n>>2]=d}else d=k[n>>2]|0;k[o>>2]=d;e=c}else e=c;d=Heb(s,4)|0;if((d|0)==-2){j=72;break a}c=k[m>>2]|0;if((e|0)==(c|0)){j=74;break a}}if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=0-d;j=57;break}default:{while(1){c=k[o>>2]|0;d=(k[n>>2]|0)-c|0;if(d|0){k[f>>2]=k[q>>2];k[f+4>>2]=c;k[f+8>>2]=d;e=cf(4,f|0)|0;if(e>>>0>4294963200)break;if(!((e|0)>-1&(e|0)==(d|0))){j=57;break a}}c=k[m>>2]|0;if(!c){c=k[t>>2]|0;k[m>>2]=c;d=k[p>>2]|0;k[n>>2]=d}else d=k[n>>2]|0;k[o>>2]=d;if((Heb(s,b)|0)==-2){j=72;break a}if((c|0)==(k[m>>2]|0)){j=74;break a}}if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=0-e;j=57}}while(0);if((j|0)==57){if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}d=k[c>>2]|0;e=0;while(1){if((l[421658+e>>0]|0)==(d|0)){j=60;break}c=e+1|0;if((c|0)==87){c=421746;e=87;j=63;break}else e=c}if((j|0)==60)if(!e)c=421746;else{c=421746;j=63}if((j|0)==63)while(1){do{t=c;c=c+1|0}while((i[t>>0]|0)!=0);e=e+-1|0;if(!e)break;else j=63}Jeb(a,-1,c);a=-1;r=u;return a|0}else if((j|0)==72){Jeb(a,-2,418697);a=-1;r=u;return a|0}else if((j|0)==74){if((b|0)!=4){a=0;r=u;return a|0}Aeb(s)|0;a=0;r=u;return a|0}return 0}function Neb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;Wa=r;r=r+16|0;va=Wa;if(!a){Va=-2;r=Wa;return Va|0}Ga=a+28|0;Va=k[Ga>>2]|0;if(!Va){Va=-2;r=Wa;return Va|0}Qa=a+12|0;h=k[Qa>>2]|0;if(!h){Va=-2;r=Wa;return Va|0}f=k[a>>2]|0;if((f|0)==0?k[a+4>>2]|0:0){Va=-2;r=Wa;return Va|0}e=k[Va>>2]|0;if((e|0)==11){k[Va>>2]=12;e=12}Ia=a+16|0;x=k[Ia>>2]|0;Ha=a+4|0;Ja=k[Ha>>2]|0;Da=Va+56|0;Ra=Va+60|0;Ma=Va+8|0;Sa=Va+24|0;Q=va+1|0;Pa=Va+16|0;R=Va+32|0;S=a+24|0;T=Va+36|0;U=Va+20|0;Ta=a+48|0;V=Va+64|0;W=Va+12|0;X=(b+-5|0)>>>0<2;Ua=Va+4|0;Y=Va+76|0;Z=Va+84|0;_=Va+80|0;$=Va+88|0;aa=(b|0)==6;ba=Va+7108|0;ca=Va+72|0;da=Va+7112|0;ea=Va+68|0;fa=Va+44|0;ga=Va+7104|0;ha=Va+48|0;ia=Va+52|0;Ea=Va+40|0;Na=a+20|0;Oa=Va+28|0;ja=va+2|0;ka=va+3|0;la=Va+104|0;ma=Va+96|0;na=Va+100|0;oa=Va+624|0;pa=Va+1328|0;qa=Va+108|0;ra=Va+112|0;sa=Va+752|0;ta=Va+92|0;t=0;n=f;P=x;o=k[Ra>>2]|0;f=k[Da>>2]|0;g=Ja;w=h;a:while(1){b:do switch(e|0){case 28:{Ka=P;Ca=o;Ba=f;d=g;ua=n;La=1;c=x;break a}case 29:{O=345;break a}case 30:{c=-4;O=369;break a}case 0:{p=k[Ma>>2]|0;if(!p){k[Va>>2]=12;h=t;q=w;p=P;e=o;s=x;break b}if(o>>>0<16){h=n;e=o;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=h;La=t;c=x;break a}g=g+-1|0;n=h+1|0;f=(l[h>>0]<<e)+f|0;e=e+8|0;if(e>>>0<16)h=n;else break}}else e=o;if((f|0)==35615&(p&2|0)!=0){k[Sa>>2]=0;i[va>>0]=31;i[Q>>0]=-117;h=yeb(0,va,2)|0;k[Sa>>2]=h;k[Va>>2]=1;h=t;q=w;p=P;e=0;f=0;s=x;break b}k[Pa>>2]=0;h=k[R>>2]|0;if(h|0)k[h+48>>2]=-1;if(p&1|0?((((f<<8&65280)+(f>>>8)|0)>>>0)%31|0|0)==0:0){if((f&15|0)!=8){k[S>>2]=418779;k[Va>>2]=29;h=t;q=w;p=P;s=x;break b}s=f>>>4;e=e+-4|0;h=(s&15)+8|0;o=k[T>>2]|0;if(o){if(h>>>0>o>>>0){k[S>>2]=418806;k[Va>>2]=29;h=t;q=w;p=P;f=s;s=x;break b}}else k[T>>2]=h;k[U>>2]=1<<h;k[Sa>>2]=1;k[Ta>>2]=1;k[Va>>2]=f>>>12&2^11;h=t;q=w;p=P;e=0;f=0;s=x;break b}k[S>>2]=418756;k[Va>>2]=29;h=t;q=w;p=P;s=x;break}case 1:{if(o>>>0<16){h=n;e=o;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=h;La=t;c=x;break a}g=g+-1|0;n=h+1|0;f=(l[h>>0]<<e)+f|0;e=e+8|0;if(e>>>0<16)h=n;else break}}else e=o;k[Pa>>2]=f;if((f&255|0)!=8){k[S>>2]=418779;k[Va>>2]=29;h=t;q=w;p=P;s=x;break b}if(f&57344|0){k[S>>2]=418826;k[Va>>2]=29;h=t;q=w;p=P;s=x;break b}e=k[R>>2]|0;if(e|0)k[e>>2]=f>>>8&1;if(f&512|0){i[va>>0]=f;i[Q>>0]=f>>>8;O=yeb(k[Sa>>2]|0,va,2)|0;k[Sa>>2]=O}k[Va>>2]=2;o=0;f=0;O=53;break}case 2:{if(o>>>0<32)O=53;else O=55;break}case 3:{if(o>>>0<16)O=61;else O=63;break}case 4:{e=o;q=k[Pa>>2]|0;O=68;break}case 5:{e=o;q=k[Pa>>2]|0;O=79;break}case 6:{e=o;o=k[Pa>>2]|0;O=89;break}case 7:{e=o;o=k[Pa>>2]|0;O=102;break}case 8:{e=o;o=k[Pa>>2]|0;O=115;break}case 9:{if(o>>>0<32){h=n;while(1){if(!g){Ka=P;Ca=o;Ba=f;d=0;ua=h;La=t;c=x;break a}g=g+-1|0;e=h+1|0;f=(l[h>>0]<<o)+f|0;o=o+8|0;if(o>>>0>=32)break;else h=e}}else e=n;h=ypb(f|0)|0;k[Sa>>2]=h;k[Ta>>2]=h;k[Va>>2]=10;h=0;f=0;O=127;break}case 10:{h=o;e=n;O=127;break}case 11:{h=o;e=n;O=130;break}case 12:{e=n;O=131;break}case 13:{e=o&7;f=f>>>e;e=o-e|0;if(e>>>0<32){h=n;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=h;La=t;c=x;break a}g=g+-1|0;n=h+1|0;f=(l[h>>0]<<e)+f|0;e=e+8|0;if(e>>>0<32)h=n;else break}}h=f&65535;if((h|0)==(f>>>16^65535|0)){k[V>>2]=h;k[Va>>2]=14;if(aa){Ka=P;Ca=0;Ba=0;d=g;ua=n;La=t;c=x;break a}else{e=0;f=0;O=150;break b}}else{k[S>>2]=418890;k[Va>>2]=29;h=t;q=w;p=P;s=x;break b}}case 14:{e=o;O=150;break}case 15:{e=o;O=151;break}case 16:{if(o>>>0<14){e=o;h=n;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=h;La=t;c=x;break a}g=g+-1|0;n=h+1|0;f=(l[h>>0]<<e)+f|0;e=e+8|0;if(e>>>0<14)h=n;else break}}else e=o;M=(f&31)+257|0;k[ma>>2]=M;N=(f>>>5&31)+1|0;k[na>>2]=N;p=(f>>>10&15)+4|0;k[ta>>2]=p;f=f>>>14;e=e+-14|0;if(M>>>0>286|N>>>0>30){k[S>>2]=418919;k[Va>>2]=29;h=t;q=w;p=P;s=x;break b}else{k[la>>2]=0;k[Va>>2]=17;h=0;O=161;break b}}case 17:{h=k[la>>2]|0;p=k[ta>>2]|0;if(h>>>0<p>>>0){e=o;O=161}else{e=o;O=162}break}case 18:{h=t;e=o;p=n;o=k[la>>2]|0;O=172;break}case 19:{h=t;e=o;O=206;break}case 20:{h=t;e=o;O=207;break}case 21:{e=o;h=t;p=k[ca>>2]|0;O=282;break}case 22:{e=o;h=t;O=289;break}case 23:{e=o;h=t;p=k[ca>>2]|0;O=301;break}case 24:{e=o;h=t;O=307;break}case 25:{if(!x){Ka=P;Ca=o;Ba=f;d=g;ua=n;La=t;c=0;break a}i[w>>0]=k[V>>2];k[Va>>2]=20;h=t;q=w+1|0;p=P;e=o;s=x+-1|0;break}case 26:{h=k[Ma>>2]|0;if(h){if(o>>>0<32){e=o;o=n;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=o;La=t;c=x;break a}g=g+-1|0;n=o+1|0;f=(l[o>>0]<<e)+f|0;e=e+8|0;if(e>>>0<32)o=n;else break}}else e=o;o=P-x|0;k[Na>>2]=(k[Na>>2]|0)+o;k[Oa>>2]=(k[Oa>>2]|0)+o;if(!o){p=k[Pa>>2]|0;o=k[Sa>>2]|0}else{p=k[Pa>>2]|0;q=k[Sa>>2]|0;s=w+(0-o)|0;if(!p)o=xeb(q,s,o)|0;else o=yeb(q,s,o)|0;k[Sa>>2]=o;k[Ta>>2]=o}P=ypb(f|0)|0;if((((p|0)==0?P:f)|0)==(o|0)){p=x;e=0;f=0}else{k[S>>2]=419093;k[Va>>2]=29;h=t;q=w;p=x;s=x;break b}}else{p=P;e=o}k[Va>>2]=27;O=337;break}case 27:{p=P;e=o;h=k[Ma>>2]|0;O=337;break}default:{O=368;break a}}while(0);if((O|0)==53)while(1){O=0;if(!g){Ka=P;Ca=o;Ba=f;d=0;ua=n;La=t;c=x;break a}g=g+-1|0;e=n+1|0;f=(l[n>>0]<<o)+f|0;o=o+8|0;if(o>>>0>=32){n=e;O=55;break}else{n=e;O=53}}else if((O|0)==127){if(!(k[W>>2]|0)){O=128;break}k[Sa>>2]=1;k[Ta>>2]=1;k[Va>>2]=11;O=130}else if((O|0)==150){k[Va>>2]=15;O=151}else if((O|0)==161){O=0;while(1){if(e>>>0<3){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=n;La=t;c=x;break a}o=e+8|0;f=(l[n>>0]<<e)+f|0;g=g+-1|0;n=n+1|0}else o=e;q=h+1|0;k[la>>2]=q;j[Va+112+(m[175104+(h<<1)>>1]<<1)>>1]=f&7;f=f>>>3;e=o+-3|0;if(q>>>0<p>>>0)h=q;else{h=q;O=162;break}}}else if((O|0)==337){O=0;if(!h){d=g;c=n;O=344;break}if(!(k[Pa>>2]|0)){d=g;c=n;O=344;break}if(e>>>0<32){h=n;while(1){if(!g){Ka=p;Ca=e;Ba=f;d=0;ua=h;La=t;c=x;break a}g=g+-1|0;n=h+1|0;f=(l[h>>0]<<e)+f|0;e=e+8|0;if(e>>>0<32)h=n;else break}}if((f|0)==(k[Oa>>2]|0)){e=0;f=0;d=g;c=n;O=344;break}k[S>>2]=419114;k[Va>>2]=29;h=t;q=w;s=x}do if((O|0)==55){e=k[R>>2]|0;if(e|0)k[e+4>>2]=f;if(k[Pa>>2]&512|0){i[va>>0]=f;i[Q>>0]=f>>>8;i[ja>>0]=f>>>16;i[ka>>0]=f>>>24;O=yeb(k[Sa>>2]|0,va,4)|0;k[Sa>>2]=O}k[Va>>2]=3;o=0;f=0;O=61}else if((O|0)==130){O=0;if(X){Ka=P;Ca=h;Ba=f;d=g;ua=e;La=t;c=x;break a}else{o=h;O=131}}else if((O|0)==151){O=0;h=k[V>>2]|0;if(!h){k[Va>>2]=11;h=t;q=w;p=P;s=x;break}o=h>>>0>g>>>0?g:h;o=o>>>0>x>>>0?x:o;if(!o){Ka=P;Ca=e;Ba=f;d=g;ua=n;La=t;c=x;break a}upb(w|0,n|0,o|0)|0;k[V>>2]=(k[V>>2]|0)-o;h=t;q=w+o|0;n=n+o|0;p=P;s=x-o|0;g=g-o|0}else if((O|0)==162){O=0;if(h>>>0<19){do{j[Va+112+(m[175104+(h<<1)>>1]<<1)>>1]=0;h=h+1|0}while((h|0)!=19);k[la>>2]=19}k[qa>>2]=pa;k[Y>>2]=pa;k[Z>>2]=7;h=Oeb(0,ra,19,qa,Z,sa)|0;if(!h){k[la>>2]=0;k[Va>>2]=18;h=0;p=n;o=0;O=172;break}else{k[S>>2]=418955;k[Va>>2]=29;q=w;p=P;s=x;break}}while(0);c:do if((O|0)==61)while(1){O=0;if(!g){Ka=P;Ca=o;Ba=f;d=0;ua=n;La=t;c=x;break a}g=g+-1|0;e=n+1|0;f=(l[n>>0]<<o)+f|0;o=o+8|0;if(o>>>0>=16){n=e;O=63;break}else{n=e;O=61}}else if((O|0)==131){O=0;if(k[Ua>>2]|0){s=o&7;k[Va>>2]=26;h=t;q=w;n=e;p=P;e=o-s|0;f=f>>>s;s=x;break}if(o>>>0<3){if(!g){Ka=P;Ca=o;Ba=f;d=0;ua=e;La=t;c=x;break a}s=o+8|0;f=(l[e>>0]<<o)+f|0;g=g+-1|0;e=e+1|0}else s=o;k[Ua>>2]=f&1;switch(f>>>1&3){case 0:{k[Va>>2]=13;break}case 1:{k[Y>>2]=172928;k[Z>>2]=9;k[_>>2]=174976;k[$>>2]=5;k[Va>>2]=19;if(aa){O=139;break a}break}case 2:{k[Va>>2]=16;break}case 3:{k[S>>2]=418871;k[Va>>2]=29;break}default:{O=142;break a}}h=t;q=w;n=e;p=P;e=s+-3|0;f=f>>>3;s=x}else if((O|0)==172){O=0;n=k[ma>>2]|0;q=k[na>>2]|0;do if(o>>>0<(q+n|0)>>>0){v=o;d:while(1){t=(1<<k[Z>>2])+-1|0;o=t&f;u=k[Y>>2]|0;s=l[u+(o<<2)+1>>0]|0;if(e>>>0<s>>>0){o=p;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=o;La=h;c=x;break a}g=g+-1|0;p=o+1|0;f=(l[o>>0]<<e)+f|0;e=e+8|0;o=t&f;s=l[u+(o<<2)+1>>0]|0;if(e>>>0<s>>>0)o=p;else break}}o=j[u+(o<<2)+2>>1]|0;if((o&65535)>=16){switch(o<<16>>16){case 16:{t=s+2|0;if(e>>>0<t>>>0){o=p;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=o;La=h;c=x;break a}g=g+-1|0;p=o+1|0;f=(l[o>>0]<<e)+f|0;e=e+8|0;if(e>>>0<t>>>0)o=p;else break}}o=f>>>s;e=e-s|0;if(!v){O=186;break d}t=m[Va+112+(v+-1<<1)>>1]|0;e=e+-2|0;f=o>>>2;s=p;p=(o&3)+3|0;break}case 17:{t=s+3|0;if(e>>>0<t>>>0){o=p;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=o;La=h;c=x;break a}g=g+-1|0;p=o+1|0;f=(l[o>>0]<<e)+f|0;e=e+8|0;if(e>>>0<t>>>0)o=p;else{o=p;break}}}else o=p;p=f>>>s;t=0;e=-3-s+e|0;f=p>>>3;s=o;p=(p&7)+3|0;break}default:{t=s+7|0;if(e>>>0<t>>>0){o=p;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=o;La=h;c=x;break a}g=g+-1|0;p=o+1|0;f=(l[o>>0]<<e)+f|0;e=e+8|0;if(e>>>0<t>>>0)o=p;else{o=p;break}}}else o=p;p=f>>>s;t=0;e=-7-s+e|0;f=p>>>7;s=o;p=(p&127)+11|0}}if((v+p|0)>>>0>(q+n|0)>>>0){O=196;break}o=t&65535;n=p+-1|0;k[la>>2]=v+1;j[Va+112+(v<<1)>>1]=o;if(!n)p=s;else{do{N=k[la>>2]|0;n=n+-1|0;k[la>>2]=N+1;j[Va+112+(N<<1)>>1]=o}while((n|0)!=0);p=s}}else{k[la>>2]=v+1;j[Va+112+(v<<1)>>1]=o;e=e-s|0;f=f>>>s}v=k[la>>2]|0;n=k[ma>>2]|0;q=k[na>>2]|0;if(v>>>0>=(q+n|0)>>>0){O=198;break}}if((O|0)==186){O=0;k[S>>2]=418980;k[Va>>2]=29;q=w;n=p;p=P;f=o;s=x;break c}else if((O|0)==196){O=0;k[S>>2]=418980;k[Va>>2]=29;q=w;n=s;p=P;s=x;break c}else if((O|0)==198){O=0;if((k[Va>>2]|0)==29){q=w;n=p;p=P;s=x;break c}else break}}while(0);if(!(j[oa>>1]|0)){k[S>>2]=419006;k[Va>>2]=29;q=w;n=p;p=P;s=x;break}k[qa>>2]=pa;k[Y>>2]=pa;k[Z>>2]=9;h=Oeb(1,ra,n,qa,Z,sa)|0;if(h|0){k[S>>2]=419043;k[Va>>2]=29;q=w;n=p;p=P;s=x;break}k[_>>2]=k[qa>>2];k[$>>2]=6;h=Oeb(2,Va+112+(k[ma>>2]<<1)|0,k[na>>2]|0,qa,$,sa)|0;if(!h){k[Va>>2]=19;if(aa){Ka=P;Ca=e;Ba=f;d=g;ua=p;La=0;c=x;break a}else{h=0;n=p;O=206;break}}else{k[S>>2]=419071;k[Va>>2]=29;q=w;n=p;p=P;s=x;break}}while(0);if((O|0)==63){e=k[R>>2]|0;if(e|0){k[e+8>>2]=f&255;k[e+12>>2]=f>>>8}h=k[Pa>>2]|0;if(h&512|0){i[va>>0]=f;i[Q>>0]=f>>>8;O=yeb(k[Sa>>2]|0,va,2)|0;k[Sa>>2]=O}k[Va>>2]=4;e=0;f=0;q=h;O=68}else if((O|0)==206){k[Va>>2]=20;O=207}do if((O|0)==68){O=0;if(!(q&1024)){h=k[R>>2]|0;if(h)k[h+16>>2]=0}else{if(e>>>0<16){h=n;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=h;La=t;c=x;break a}g=g+-1|0;n=h+1|0;f=(l[h>>0]<<e)+f|0;e=e+8|0;if(e>>>0>=16)break;else h=n}}k[V>>2]=f;e=k[R>>2]|0;if(e|0)k[e+20>>2]=f;if(!(q&512)){e=0;f=0}else{i[va>>0]=f;i[Q>>0]=f>>>8;e=yeb(k[Sa>>2]|0,va,2)|0;k[Sa>>2]=e;e=0;f=0}}k[Va>>2]=5;O=79}else if((O|0)==207){O=0;if(!(x>>>0>257&g>>>0>5)){k[ba>>2]=0;t=(1<<k[Z>>2])+-1|0;q=t&f;u=k[Y>>2]|0;o=i[u+(q<<2)+1>>0]|0;p=o&255;if(p>>>0>e>>>0)while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=n;La=h;c=x;break a}g=g+-1|0;s=n+1|0;f=(l[n>>0]<<e)+f|0;e=e+8|0;q=t&f;o=i[u+(q<<2)+1>>0]|0;p=o&255;if(p>>>0>e>>>0)n=s;else{n=s;break}}t=j[u+(q<<2)+2>>1]|0;s=i[u+(q<<2)>>0]|0;q=s&255;if(s<<24>>24!=0&(q&240|0)==0){t=t&65535;s=(1<<p+q)+-1|0;o=((f&s)>>>p)+t|0;q=i[u+(o<<2)+1>>0]|0;if(((q&255)+p|0)>>>0>e>>>0){o=n;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=o;La=h;c=x;break a}g=g+-1|0;n=o+1|0;f=(l[o>>0]<<e)+f|0;e=e+8|0;o=((f&s)>>>p)+t|0;q=i[u+(o<<2)+1>>0]|0;if(((q&255)+p|0)>>>0>e>>>0)o=n;else break}}N=j[u+(o<<2)+2>>1]|0;s=i[u+(o<<2)>>0]|0;k[ba>>2]=p;e=e-p|0;f=f>>>p;o=q;q=N}else{q=t;p=0}o=o&255;f=f>>>o;e=e-o|0;k[ba>>2]=p+o;k[V>>2]=q&65535;o=s&255;if(!(s<<24>>24)){k[Va>>2]=25;q=w;p=P;s=x;break}if(o&32|0){k[ba>>2]=-1;k[Va>>2]=11;q=w;p=P;s=x;break}if(!(o&64)){p=o&15;k[ca>>2]=p;k[Va>>2]=21;O=282;break}else{k[S>>2]=419189;k[Va>>2]=29;q=w;p=P;s=x;break}}k[Qa>>2]=w;k[Ia>>2]=x;k[a>>2]=n;k[Ha>>2]=g;k[Da>>2]=f;k[Ra>>2]=e;J=k[Ga>>2]|0;n=n+-1|0;K=n+(g+-5)|0;o=w+-1|0;L=o+(x+-257)|0;C=k[J+40>>2]|0;D=k[J+44>>2]|0;E=k[J+48>>2]|0;M=J+56|0;N=J+60|0;F=k[J+76>>2]|0;G=k[J+80>>2]|0;H=(1<<k[J+84>>2])+-1|0;I=(1<<k[J+88>>2])+-1|0;w=o+(x-P)|0;x=J+7104|0;y=(k[J+52>>2]|0)+-1|0;z=(E|0)==0;A=E+C|0;B=w-E|0;f=k[M>>2]|0;e=k[N>>2]|0;e:while(1){if(e>>>0<15){v=n+2|0;g=v;f=(l[n+1>>0]<<e)+f+(l[v>>0]<<e+8)|0;e=e+16|0}else g=n;v=f&H;n=i[F+(v<<2)>>0]|0;p=j[F+(v<<2)+2>>1]|0;v=l[F+(v<<2)+1>>0]|0;f=f>>>v;e=e-v|0;do if(!(n<<24>>24)){n=p&255;O=214}else{q=n&255;while(1){if(q&16|0)break;if(q&64|0){O=261;break e}v=(f&(1<<q)+-1)+(p&65535)|0;n=i[F+(v<<2)>>0]|0;p=j[F+(v<<2)+2>>1]|0;v=l[F+(v<<2)+1>>0]|0;f=f>>>v;e=e-v|0;if(!(n<<24>>24)){O=213;break}else q=n&255}if((O|0)==213){n=p&255;O=214;break}n=p&65535;q=q&15;if(q){p=g+1|0;if(e>>>0<q>>>0){g=p;f=(l[p>>0]<<e)+f|0;e=e+8|0}n=(f&(1<<q)+-1)+n|0;f=f>>>q;e=e-q|0}if(e>>>0<15){v=g+2|0;u=v;f=(l[g+1>>0]<<e)+f+(l[v>>0]<<e+8)|0;e=e+16|0}else u=g;p=f&I;g=j[G+(p<<2)+2>>1]|0;v=l[G+(p<<2)+1>>0]|0;f=f>>>v;e=e-v|0;p=l[G+(p<<2)>>0]|0;if(!(p&16))do{if(p&64|0){O=258;break e}p=(f&(1<<p)+-1)+(g&65535)|0;g=j[G+(p<<2)+2>>1]|0;v=l[G+(p<<2)+1>>0]|0;f=f>>>v;e=e-v|0;p=l[G+(p<<2)>>0]|0}while((p&16|0)==0);s=g&65535;t=p&15;if(e>>>0<t>>>0){g=u+1|0;f=(l[g>>0]<<e)+f|0;q=e+8|0;p=u+2|0;if(q>>>0<t>>>0){g=p;f=(l[p>>0]<<q)+f|0;e=e+16|0}else e=q}else g=u;v=(f&(1<<t)+-1)+s|0;f=f>>>t;e=e-t|0;t=o;p=t-w|0;if(v>>>0<=p>>>0){s=o+(0-v)|0;q=o;while(1){i[q+1>>0]=i[s+1>>0]|0;i[q+2>>0]=i[s+2>>0]|0;p=s+3|0;o=q+3|0;i[o>>0]=i[p>>0]|0;n=n+-3|0;if(n>>>0<=2)break;else{s=p;q=o}}if(!n)break;o=q+4|0;i[o>>0]=i[s+4>>0]|0;if((n|0)==1)break;o=q+5|0;i[o>>0]=i[s+5>>0]|0;break}q=v-p|0;if(q>>>0>D>>>0?k[x>>2]|0:0){O=229;break e}do if(z){p=y+(C-q)|0;if(n>>>0<=q>>>0)break;n=n-q|0;s=o;do{p=p+1|0;s=s+1|0;i[s>>0]=i[p>>0]|0;q=q+-1|0}while((q|0)!=0);o=o+w+(v-t)|0;p=o+(0-v)|0}else{if(E>>>0>=q>>>0){p=y+(E-q)|0;if(n>>>0<=q>>>0)break;n=n-q|0;s=o;do{p=p+1|0;s=s+1|0;i[s>>0]=i[p>>0]|0;q=q+-1|0}while((q|0)!=0);o=o+w+(v-t)|0;p=o+(0-v)|0;break}p=y+(A-q)|0;q=q-E|0;if(n>>>0<=q>>>0)break;n=n-q|0;s=o;do{p=p+1|0;s=s+1|0;i[s>>0]=i[p>>0]|0;q=q+-1|0}while((q|0)!=0);t=v-t|0;u=o+B+t|0;if(n>>>0>E>>>0){q=y;s=E;p=u}else{p=y;o=u;break}do{q=q+1|0;p=p+1|0;i[p>>0]=i[q>>0]|0;s=s+-1|0}while((s|0)!=0);o=o+w+t|0;n=n-E|0;p=o+(0-v)|0}while(0);if(n>>>0>2)do{i[o+1>>0]=i[p+1>>0]|0;i[o+2>>0]=i[p+2>>0]|0;p=p+3|0;o=o+3|0;i[o>>0]=i[p>>0]|0;n=n+-3|0}while(n>>>0>2);if(!n)break;q=o+1|0;i[q>>0]=i[p+1>>0]|0;if((n|0)==1){o=q;break}o=o+2|0;i[o>>0]=i[p+2>>0]|0}while(0);if((O|0)==214){O=0;o=o+1|0;i[o>>0]=n}if(o>>>0<L>>>0&g>>>0<K>>>0)n=g;else break}do if((O|0)==229){O=0;k[S>>2]=419137;k[J>>2]=29}else if((O|0)==258){O=0;k[S>>2]=419167;k[J>>2]=29;g=u}else if((O|0)==261){O=0;if(!(q&32)){k[S>>2]=419189;k[J>>2]=29;break}else{k[J>>2]=11;break}}while(0);n=e>>>3;g=g+(0-n)|0;e=e-(n<<3)|0;n=g+1|0;k[a>>2]=n;q=o+1|0;k[Qa>>2]=q;g=K+5-g|0;k[Ha>>2]=g;o=L+257-o|0;k[Ia>>2]=o;k[M>>2]=(1<<e)+-1&f;k[N>>2]=e;f=k[Da>>2]|0;e=k[Ra>>2]|0;if((k[Va>>2]|0)==11){k[ba>>2]=-1;p=P;s=o}else{p=P;s=o}}while(0);if((O|0)==79){O=0;if(q&1024){h=k[V>>2]|0;p=h>>>0>g>>>0?g:h;if(!p)o=q;else{o=k[R>>2]|0;if((o|0)!=0?(wa=k[o+16>>2]|0,(wa|0)!=0):0){h=(k[o+20>>2]|0)-h|0;N=k[o+24>>2]|0;upb(wa+h|0,n|0,((h+p|0)>>>0>N>>>0?N-h|0:p)|0)|0;h=k[Pa>>2]|0}else h=q;if(h&512|0){N=yeb(k[Sa>>2]|0,n,p)|0;k[Sa>>2]=N}N=(k[V>>2]|0)-p|0;k[V>>2]=N;n=n+p|0;g=g-p|0;o=h;h=N}if(!h)h=o;else{Ka=P;Ca=e;Ba=f;d=g;ua=n;La=t;c=x;break}}else h=q;k[V>>2]=0;k[Va>>2]=6;o=h;O=89}else if((O|0)==282){O=0;if(!p){o=n;n=k[V>>2]|0}else{if(e>>>0<p>>>0){o=n;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=o;La=h;c=x;break a}g=g+-1|0;n=o+1|0;f=(l[o>>0]<<e)+f|0;e=e+8|0;if(e>>>0<p>>>0)o=n;else break}}O=(k[V>>2]|0)+((1<<p)+-1&f)|0;k[V>>2]=O;k[ba>>2]=(k[ba>>2]|0)+p;e=e-p|0;f=f>>>p;o=n;n=O}k[da>>2]=n;k[Va>>2]=22;n=o;O=289}do if((O|0)==89){O=0;if(!(o&2048)){h=k[R>>2]|0;if(!h)h=o;else{k[h+28>>2]=0;h=o}}else{if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=n;La=t;c=x;break a}else p=0;do{h=p;p=p+1|0;h=i[n+h>>0]|0;o=k[R>>2]|0;if((o|0?(xa=k[o+28>>2]|0,xa|0):0)?(ya=k[V>>2]|0,ya>>>0<(k[o+32>>2]|0)>>>0):0){k[V>>2]=ya+1;i[xa+ya>>0]=h}o=h<<24>>24!=0}while(o&g>>>0>p>>>0);h=k[Pa>>2]|0;if(h&512|0){N=yeb(k[Sa>>2]|0,n,p)|0;k[Sa>>2]=N}g=g-p|0;n=n+p|0;if(o){Ka=P;Ca=e;Ba=f;d=g;ua=n;La=t;c=x;break a}}k[V>>2]=0;k[Va>>2]=7;o=h;O=102}else if((O|0)==289){O=0;t=(1<<k[$>>2])+-1|0;p=t&f;u=k[_>>2]|0;o=i[u+(p<<2)+1>>0]|0;q=o&255;if(q>>>0>e>>>0)while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=n;La=h;c=x;break a}g=g+-1|0;s=n+1|0;f=(l[n>>0]<<e)+f|0;e=e+8|0;p=t&f;o=i[u+(p<<2)+1>>0]|0;q=o&255;if(q>>>0>e>>>0)n=s;else{n=s;t=q;break}}else t=q;q=j[u+(p<<2)+2>>1]|0;s=i[u+(p<<2)>>0]|0;p=s&255;if(!(p&240)){s=q&65535;q=(1<<t+p)+-1|0;p=((f&q)>>>t)+s|0;o=i[u+(p<<2)+1>>0]|0;if(((o&255)+t|0)>>>0>e>>>0){o=n;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=o;La=h;c=x;break a}g=g+-1|0;n=o+1|0;f=(l[o>>0]<<e)+f|0;e=e+8|0;p=((f&q)>>>t)+s|0;o=i[u+(p<<2)+1>>0]|0;if(((o&255)+t|0)>>>0>e>>>0)o=n;else break}}q=j[u+(p<<2)+2>>1]|0;s=i[u+(p<<2)>>0]|0;p=(k[ba>>2]|0)+t|0;k[ba>>2]=p;e=e-t|0;f=f>>>t}else p=k[ba>>2]|0;o=o&255;f=f>>>o;e=e-o|0;k[ba>>2]=p+o;o=s&255;if(!(o&64)){k[ea>>2]=q&65535;p=o&15;k[ca>>2]=p;k[Va>>2]=23;O=301;break}else{k[S>>2]=419167;k[Va>>2]=29;q=w;p=P;s=x;break}}while(0);if((O|0)==102){O=0;if(!(o&4096)){h=k[R>>2]|0;if(!h)h=o;else{k[h+36>>2]=0;h=o}}else{if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=n;La=t;c=x;break}else p=0;do{h=p;p=p+1|0;h=i[n+h>>0]|0;o=k[R>>2]|0;if((o|0?(za=k[o+36>>2]|0,za|0):0)?(Aa=k[V>>2]|0,Aa>>>0<(k[o+40>>2]|0)>>>0):0){k[V>>2]=Aa+1;i[za+Aa>>0]=h}o=h<<24>>24!=0}while(o&g>>>0>p>>>0);h=k[Pa>>2]|0;if(h&512|0){N=yeb(k[Sa>>2]|0,n,p)|0;k[Sa>>2]=N}g=g-p|0;n=n+p|0;if(o){Ka=P;Ca=e;Ba=f;d=g;ua=n;La=t;c=x;break}}k[Va>>2]=8;o=h;O=115}else if((O|0)==301){O=0;if(p){if(e>>>0<p>>>0){o=n;while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=o;La=h;c=x;break a}g=g+-1|0;n=o+1|0;f=(l[o>>0]<<e)+f|0;e=e+8|0;if(e>>>0<p>>>0)o=n;else break}}k[ea>>2]=(k[ea>>2]|0)+((1<<p)+-1&f);k[ba>>2]=(k[ba>>2]|0)+p;e=e-p|0;f=f>>>p}k[Va>>2]=24;O=307}do if((O|0)==115){O=0;if(o&512){if(e>>>0<16)while(1){if(!g){Ka=P;Ca=e;Ba=f;d=0;ua=n;La=t;c=x;break a}g=g+-1|0;h=n+1|0;f=(l[n>>0]<<e)+f|0;e=e+8|0;if(e>>>0<16)n=h;else{n=h;break}}if((f|0)==(k[Sa>>2]&65535|0)){e=0;f=0}else{k[S>>2]=418851;k[Va>>2]=29;h=t;q=w;p=P;s=x;break}}h=k[R>>2]|0;if(h|0){k[h+44>>2]=o>>>9&1;k[h+48>>2]=1}k[Sa>>2]=0;k[Ta>>2]=0;k[Va>>2]=11;h=t;q=w;p=P;s=x}else if((O|0)==307){O=0;if(!x){Ka=P;Ca=e;Ba=f;d=g;ua=n;La=h;c=0;break a}o=P-x|0;p=k[ea>>2]|0;if(p>>>0>o>>>0){p=p-o|0;if(p>>>0>(k[fa>>2]|0)>>>0?k[ga>>2]|0:0){k[S>>2]=419137;k[Va>>2]=29;q=w;p=P;s=x;break}o=k[ha>>2]|0;if(p>>>0>o>>>0){p=p-o|0;o=(k[ia>>2]|0)+((k[Ea>>2]|0)-p)|0}else o=(k[ia>>2]|0)+(o-p)|0;q=k[V>>2]|0;p=p>>>0>q>>>0?q:p}else{q=k[V>>2]|0;o=w+(0-p)|0;p=q}s=p>>>0>x>>>0?x:p;k[V>>2]=q-s;p=s;q=w;while(1){N=q;q=q+1|0;i[N>>0]=i[o>>0]|0;p=p+-1|0;if(!p)break;else o=o+1|0}o=x-s|0;if(!(k[V>>2]|0)){k[Va>>2]=20;p=P;s=o}else{p=P;s=o}}while(0);t=h;P=p;o=e;x=s;w=q;e=k[Va>>2]|0}if((O|0)==128){k[Qa>>2]=w;k[Ia>>2]=x;k[a>>2]=e;k[Ha>>2]=g;k[Da>>2]=f;k[Ra>>2]=h;Va=2;r=Wa;return Va|0}else if((O|0)==139){Ka=P;Ca=s+-3|0;Ba=f>>>3;d=g;ua=e;La=t;c=x}else if((O|0)!=142)if((O|0)==344){k[Va>>2]=28;Ka=p;Ca=e;Ba=f;ua=c;La=1;c=x}else if((O|0)==345){Ka=P;Ca=o;Ba=f;d=g;ua=n;La=-3;c=x}else if((O|0)==368){Va=-2;r=Wa;return Va|0}else if((O|0)==369){r=Wa;return c|0}k[Qa>>2]=w;k[Ia>>2]=c;k[a>>2]=ua;k[Ha>>2]=d;k[Da>>2]=Ba;k[Ra>>2]=Ca;if(!(k[Ea>>2]|0)){if(((Ka|0)!=(c|0)?(Fa=k[Va>>2]|0,Fa>>>0<29):0)?(b|0)!=4|Fa>>>0<26:0)O=350}else O=350;if((O|0)==350){h=Ka-c|0;n=k[Ga>>2]|0;o=n+52|0;c=k[o>>2]|0;if(!c){c=ci[k[a+32>>2]&255](k[a+40>>2]|0,1<<k[n+36>>2],1)|0;k[o>>2]=c;if(!c){k[Va>>2]=30;Va=-4;r=Wa;return Va|0}}g=n+40|0;d=k[g>>2]|0;if(!d){d=1<<k[n+36>>2];k[g>>2]=d;k[n+48>>2]=0;k[n+44>>2]=0}do if(d>>>0>h>>>0){e=n+48|0;Ga=k[e>>2]|0;f=d-Ga|0;f=f>>>0>h>>>0?h:f;upb(c+Ga|0,w+(0-h)|0,f|0)|0;c=h-f|0;if(c|0){upb(k[o>>2]|0,w+(0-c)|0,c|0)|0;k[e>>2]=c;k[n+44>>2]=k[g>>2];break}c=(k[e>>2]|0)+f|0;Ga=k[g>>2]|0;k[e>>2]=(c|0)==(Ga|0)?0:c;c=n+44|0;d=k[c>>2]|0;if(d>>>0<Ga>>>0)k[c>>2]=d+f}else{upb(c|0,w+(0-d)|0,d|0)|0;k[n+48>>2]=0;k[n+44>>2]=k[g>>2]}while(0);d=k[Ha>>2]|0;c=k[Ia>>2]|0}f=Ja-d|0;e=Ka-c|0;Ka=a+8|0;k[Ka>>2]=(k[Ka>>2]|0)+f;k[Na>>2]=(k[Na>>2]|0)+e;k[Oa>>2]=(k[Oa>>2]|0)+e;if((e|0)!=0&(k[Ma>>2]|0)!=0){d=k[Sa>>2]|0;c=(k[Qa>>2]|0)+(0-e)|0;if(!(k[Pa>>2]|0))c=xeb(d,c,e)|0;else c=yeb(d,c,e)|0;k[Sa>>2]=c;k[Ta>>2]=c}Va=k[Va>>2]|0;k[a+44>>2]=(k[Ua>>2]|0?64:0)+(k[Ra>>2]|0)+((Va|0)==11?128:0)+((Va|0)==19|(Va|0)==14?256:0);Va=(La|0)==0&((b|0)==4|(e|f|0)==0)?-5:La;r=Wa;return Va|0}function Oeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+64|0;I=J+32|0;D=J;g=I;h=g+32|0;do{j[g>>1]=0;g=g+2|0}while((g|0)<(h|0));C=(c|0)==0;if(!C){g=0;do{H=I+(m[b+(g<<1)>>1]<<1)|0;j[H>>1]=(j[H>>1]|0)+1<<16>>16;g=g+1|0}while((g|0)!=(c|0));h=j[I+30>>1]|0;g=k[e>>2]|0;if(!(h<<16>>16))if(!(j[I+28>>1]|0))H=59;else{n=14;h=0;H=7}else{n=15;H=7}}else{g=k[e>>2]|0;H=59}do if((H|0)==59)if(!(j[I+26>>1]|0))if(!(j[I+24>>1]|0))if(!(j[I+22>>1]|0))if(!(j[I+20>>1]|0))if(!(j[I+18>>1]|0))if(!(j[I+16>>1]|0))if(!(j[I+14>>1]|0))if(!(j[I+12>>1]|0))if(!(j[I+10>>1]|0))if(!(j[I+8>>1]|0))if(!(j[I+6>>1]|0))if(!(j[I+4>>1]|0)){n=j[I+2>>1]|0;if(n<<16>>16){l=g>>>0>1?1:g;G=1;E=1;h=0;break}I=k[d>>2]|0;k[d>>2]=I+4;i[I>>0]=64;i[I+1>>0]=1;j[I+2>>1]=0;I=k[d>>2]|0;k[d>>2]=I+4;i[I>>0]=64;i[I+1>>0]=1;j[I+2>>1]=0;k[e>>2]=1;I=0;r=J;return I|0}else{n=2;h=0;H=7}else{n=3;h=0;H=7}else{n=4;h=0;H=7}else{n=5;h=0;H=7}else{n=6;h=0;H=7}else{n=7;h=0;H=7}else{n=8;h=0;H=7}else{n=9;h=0;H=7}else{n=10;h=0;H=7}else{n=11;h=0;H=7}else{n=12;h=0;H=7}else{n=13;h=0;H=7}while(0);if((H|0)==7){l=g>>>0>n>>>0?n:g;g=1;do{if(j[I+(g<<1)>>1]|0)break;g=g+1|0}while(g>>>0<n>>>0);G=n;E=g;n=j[I+2>>1]|0}F=l>>>0<E>>>0?E:l;A=n&65535;g=2-A|0;if((g|0)<0){I=-1;r=J;return I|0}B=m[I+4>>1]|0;g=(g<<1)-B|0;if((g|0)<0){I=-1;r=J;return I|0}z=m[I+6>>1]|0;g=(g<<1)-z|0;if((g|0)<0){I=-1;r=J;return I|0}y=m[I+8>>1]|0;g=(g<<1)-y|0;if((g|0)<0){I=-1;r=J;return I|0}x=m[I+10>>1]|0;g=(g<<1)-x|0;if((g|0)<0){I=-1;r=J;return I|0}w=m[I+12>>1]|0;g=(g<<1)-w|0;if((g|0)<0){I=-1;r=J;return I|0}v=m[I+14>>1]|0;g=(g<<1)-v|0;if((g|0)<0){I=-1;r=J;return I|0}u=m[I+16>>1]|0;g=(g<<1)-u|0;if((g|0)<0){I=-1;r=J;return I|0}t=m[I+18>>1]|0;g=(g<<1)-t|0;if((g|0)<0){I=-1;r=J;return I|0}s=m[I+20>>1]|0;g=(g<<1)-s|0;if((g|0)<0){I=-1;r=J;return I|0}q=m[I+22>>1]|0;g=(g<<1)-q|0;if((g|0)<0){I=-1;r=J;return I|0}p=m[I+24>>1]|0;g=(g<<1)-p|0;if((g|0)<0){I=-1;r=J;return I|0}o=m[I+26>>1]|0;g=(g<<1)-o|0;if((g|0)<0){I=-1;r=J;return I|0}l=m[I+28>>1]|0;g=(g<<1)-l|0;if((g|0)<0){I=-1;r=J;return I|0}g=(g<<1)-(h&65535)|0;if((g|0)<0){I=-1;r=J;return I|0}if(g|0?(a|0)==0|(G|0)!=1:0){I=-1;r=J;return I|0}j[D+2>>1]=0;j[D+4>>1]=n;B=B+A|0;j[D+6>>1]=B;B=z+B|0;j[D+8>>1]=B;B=y+B|0;j[D+10>>1]=B;B=x+B|0;j[D+12>>1]=B;B=w+B|0;j[D+14>>1]=B;B=v+B|0;j[D+16>>1]=B;B=u+B|0;j[D+18>>1]=B;B=t+B|0;j[D+20>>1]=B;B=s+B|0;j[D+22>>1]=B;B=q+B|0;j[D+24>>1]=B;B=p+B|0;j[D+26>>1]=B;B=o+B|0;j[D+28>>1]=B;j[D+30>>1]=l+B;if(!C){g=0;do{h=j[b+(g<<1)>>1]|0;if(h<<16>>16){B=D+((h&65535)<<1)|0;C=j[B>>1]|0;j[B>>1]=C+1<<16>>16;j[f+((C&65535)<<1)>>1]=g}g=g+1|0}while((g|0)!=(c|0))}switch(a|0){case 0:{a=f;c=f;D=19;g=0;B=0;break}case 1:{if(F>>>0>9){I=1;r=J;return I|0}else{a=174818;c=174692;D=256;g=0;B=1}break}default:{g=(a|0)==2;if(g&F>>>0>9){I=1;r=J;return I|0}else{a=175268;c=175142;D=-1;B=0}}}z=1<<F;A=z+-1|0;C=F&255;v=k[d>>2]|0;w=-1;o=0;u=0;h=F;n=0;l=E;a:while(1){t=1<<h;x=o;y=n;while(1){o=l-u|0;s=o&255;h=j[f+(y<<1)>>1]|0;n=h&65535;do if((n|0)<(D|0))q=0;else{if((n|0)<=(D|0)){q=96;h=0;break}q=j[a+(n<<1)>>1]&255;h=j[c+(n<<1)>>1]|0}while(0);o=1<<o;p=x>>>u;n=t;do{n=n-o|0;E=n+p|0;i[v+(E<<2)>>0]=q;i[v+(E<<2)+1>>0]=s;j[v+(E<<2)+2>>1]=h}while((n|0)!=0);h=1<<l+-1;while(1)if(!(h&x))break;else h=h>>>1;x=(h|0)==0?0:(h+-1&x)+h|0;y=y+1|0;q=I+(l<<1)|0;E=(j[q>>1]|0)+-1<<16>>16;j[q>>1]=E;if(!(E<<16>>16)){if((l|0)==(G|0))break a;l=m[b+(m[f+(y<<1)>>1]<<1)>>1]|0}if(l>>>0<=F>>>0)continue;s=x&A;if((s|0)!=(w|0))break}q=(u|0)==0?F:u;p=v+(t<<2)|0;h=l-q|0;b:do if(l>>>0<G>>>0){n=1<<h;o=l;while(1){n=n-(m[I+(o<<1)>>1]|0)|0;if((n|0)<1)break b;h=h+1|0;o=h+q|0;if(o>>>0>=G>>>0)break;else n=n<<1}}while(0);n=(1<<h)+z|0;if(B&n>>>0>852|g&n>>>0>592){g=1;H=44;break}v=k[d>>2]|0;i[v+(s<<2)>>0]=h;i[v+(s<<2)+1>>0]=C;j[v+(s<<2)+2>>1]=(p-v|0)>>>2;v=p;w=s;o=x;z=n;u=q;n=y}if((H|0)==44){r=J;return g|0}if(x|0){i[v+(x<<2)>>0]=64;i[v+(x<<2)+1>>0]=s;j[v+(x<<2)+2>>1]=0}k[d>>2]=(k[d>>2]|0)+(z<<2);k[e>>2]=F;I=0;r=J;return I|0}function Peb(a){a=a|0;var b=0;b=0;do{j[a+148+(b<<2)>>1]=0;b=b+1|0}while((b|0)!=286);j[a+2440>>1]=0;j[a+2444>>1]=0;j[a+2448>>1]=0;j[a+2452>>1]=0;j[a+2456>>1]=0;j[a+2460>>1]=0;j[a+2464>>1]=0;j[a+2468>>1]=0;j[a+2472>>1]=0;j[a+2476>>1]=0;j[a+2480>>1]=0;j[a+2484>>1]=0;j[a+2488>>1]=0;j[a+2492>>1]=0;j[a+2496>>1]=0;j[a+2500>>1]=0;j[a+2504>>1]=0;j[a+2508>>1]=0;j[a+2512>>1]=0;j[a+2516>>1]=0;j[a+2520>>1]=0;j[a+2524>>1]=0;j[a+2528>>1]=0;j[a+2532>>1]=0;j[a+2536>>1]=0;j[a+2540>>1]=0;j[a+2544>>1]=0;j[a+2548>>1]=0;j[a+2552>>1]=0;j[a+2556>>1]=0;j[a+2684>>1]=0;j[a+2688>>1]=0;j[a+2692>>1]=0;j[a+2696>>1]=0;j[a+2700>>1]=0;j[a+2704>>1]=0;j[a+2708>>1]=0;j[a+2712>>1]=0;j[a+2716>>1]=0;j[a+2720>>1]=0;j[a+2724>>1]=0;j[a+2728>>1]=0;j[a+2732>>1]=0;j[a+2736>>1]=0;j[a+2740>>1]=0;j[a+2744>>1]=0;j[a+2748>>1]=0;j[a+2752>>1]=0;j[a+2756>>1]=0;j[a+1172>>1]=1;k[a+5804>>2]=0;k[a+5800>>2]=0;k[a+5808>>2]=0;k[a+5792>>2]=0;return}function Qeb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,l=0,n=0;h=a+5820|0;f=k[h>>2]|0;e=d&65535;g=a+5816|0;d=m[g>>1]|0|e<<f;j[g>>1]=d;if((f|0)>13){n=a+20|0;f=k[n>>2]|0;k[n>>2]=f+1;l=a+8|0;i[(k[l>>2]|0)+f>>0]=d;d=(m[g>>1]|0)>>>8&255;f=k[n>>2]|0;k[n>>2]=f+1;i[(k[l>>2]|0)+f>>0]=d;f=k[h>>2]|0;d=e>>>(16-f|0);j[g>>1]=d;f=f+-13|0}else f=f+3|0;d=d&255;k[h>>2]=f;do if((f|0)<=8){e=a+20|0;if((f|0)>0){l=k[e>>2]|0;k[e>>2]=l+1;n=a+8|0;i[(k[n>>2]|0)+l>>0]=d;d=n;break}else{d=a+8|0;break}}else{e=a+20|0;l=k[e>>2]|0;k[e>>2]=l+1;n=a+8|0;i[(k[n>>2]|0)+l>>0]=d;l=(m[g>>1]|0)>>>8&255;d=k[e>>2]|0;k[e>>2]=d+1;i[(k[n>>2]|0)+d>>0]=l;d=n}while(0);j[g>>1]=0;k[h>>2]=0;l=k[e>>2]|0;k[e>>2]=l+1;i[(k[d>>2]|0)+l>>0]=c;l=k[e>>2]|0;k[e>>2]=l+1;i[(k[d>>2]|0)+l>>0]=c>>>8;l=c&65535^65535;n=k[e>>2]|0;k[e>>2]=n+1;i[(k[d>>2]|0)+n>>0]=l;n=k[e>>2]|0;k[e>>2]=n+1;i[(k[d>>2]|0)+n>>0]=l>>>8;if(!c)return;while(1){c=c+-1|0;l=i[b>>0]|0;n=k[e>>2]|0;k[e>>2]=n+1;i[(k[d>>2]|0)+n>>0]=l;if(!c)break;else b=b+1|0}return}function Reb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;d=a+5820|0;c=k[d>>2]|0;e=a+5816|0;b=m[e>>1]|0|2<<c;j[e>>1]=b;if((c|0)>13){g=a+20|0;c=k[g>>2]|0;k[g>>2]=c+1;f=a+8|0;i[(k[f>>2]|0)+c>>0]=b;b=(m[e>>1]|0)>>>8&255;c=k[g>>2]|0;k[g>>2]=c+1;i[(k[f>>2]|0)+c>>0]=b;c=k[d>>2]|0;b=2>>>(16-c|0);j[e>>1]=b;c=c+-13|0}else c=c+3|0;b=b&255;k[d>>2]=c;if((c|0)>9){f=a+20|0;g=k[f>>2]|0;k[f>>2]=g+1;c=a+8|0;i[(k[c>>2]|0)+g>>0]=b;g=(m[e>>1]|0)>>>8&255;b=k[f>>2]|0;k[f>>2]=b+1;i[(k[c>>2]|0)+b>>0]=g;j[e>>1]=0;b=0;c=(k[d>>2]|0)+-9|0}else c=c+7|0;k[d>>2]=c;if((c|0)==16){c=a+20|0;g=k[c>>2]|0;k[c>>2]=g+1;f=a+8|0;i[(k[f>>2]|0)+g>>0]=b;a=(m[e>>1]|0)>>>8&255;g=k[c>>2]|0;k[c>>2]=g+1;i[(k[f>>2]|0)+g>>0]=a;j[e>>1]=0;k[d>>2]=0;return}if((c|0)<=7)return;f=a+20|0;g=k[f>>2]|0;k[f>>2]=g+1;i[(k[a+8>>2]|0)+g>>0]=b;j[e>>1]=(m[e>>1]|0)>>>8;k[d>>2]=(k[d>>2]|0)+-8;return}function Seb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;if((k[a+132>>2]|0)>0){h=(k[a>>2]|0)+44|0;if((k[h>>2]|0)==2){e=-201342849;f=0;while(1){if(e&1|0?j[a+148+(f<<2)>>1]|0:0){e=0;break}f=f+1|0;if((f|0)>=32){g=6;break}else e=e>>>1}a:do if((g|0)==6)if(((j[a+184>>1]|0)==0?(j[a+188>>1]|0)==0:0)?(j[a+200>>1]|0)==0:0){e=32;while(1){if(j[a+148+(e<<2)>>1]|0){e=1;break a}e=e+1|0;if((e|0)>=256){e=0;break}}}else e=1;while(0);k[h>>2]=e}Teb(a,a+2840|0);Teb(a,a+2852|0);r=k[a+2844>>2]|0;p=j[a+150>>1]|0;h=p<<16>>16==0;j[a+148+(r+1<<2)+2>>1]=-1;t=a+2752|0;u=a+2756|0;v=a+2748|0;p=p&65535;e=0;q=-1;g=h?3:4;h=h?138:7;b:while(1){f=0;do{if((e|0)>(r|0))break b;e=e+1|0;n=j[a+148+(e<<2)+2>>1]|0;o=n&65535;f=f+1|0;s=(p|0)==(o|0)}while((f|0)<(h|0)&s);do if((f|0)>=(g|0))if(!p)if((f|0)<11){j[t>>1]=(j[t>>1]|0)+1<<16>>16;break}else{j[u>>1]=(j[u>>1]|0)+1<<16>>16;break}else{f=a+2684+(p<<2)|0;if((p|0)!=(q|0))j[f>>1]=(j[f>>1]|0)+1<<16>>16;j[v>>1]=(j[v>>1]|0)+1<<16>>16;break}else{q=a+2684+(p<<2)|0;j[q>>1]=(m[q>>1]|0)+f}while(0);h=n<<16>>16==0;q=p;p=o;g=h|s?3:4;h=h?138:s?6:7}r=k[a+2856>>2]|0;p=j[a+2442>>1]|0;h=p<<16>>16==0;j[a+2440+(r+1<<2)+2>>1]=-1;p=p&65535;e=0;q=-1;g=h?3:4;h=h?138:7;c:while(1){f=0;do{if((e|0)>(r|0))break c;e=e+1|0;n=j[a+2440+(e<<2)+2>>1]|0;o=n&65535;f=f+1|0;s=(p|0)==(o|0)}while((f|0)<(h|0)&s);do if((f|0)>=(g|0))if(!p)if((f|0)<11){j[t>>1]=(j[t>>1]|0)+1<<16>>16;break}else{j[u>>1]=(j[u>>1]|0)+1<<16>>16;break}else{f=a+2684+(p<<2)|0;if((p|0)!=(q|0))j[f>>1]=(j[f>>1]|0)+1<<16>>16;j[v>>1]=(j[v>>1]|0)+1<<16>>16;break}else{q=a+2684+(p<<2)|0;j[q>>1]=(m[q>>1]|0)+f}while(0);h=n<<16>>16==0;q=p;p=o;g=h|s?3:4;h=h?138:s?6:7}Teb(a,a+2864|0);if(!(j[a+2746>>1]|0))if(!(j[a+2690>>1]|0))if(!(j[a+2742>>1]|0))if(!(j[a+2694>>1]|0))if(!(j[a+2738>>1]|0))if(!(j[a+2698>>1]|0))if(!(j[a+2734>>1]|0))if(!(j[a+2702>>1]|0))if(!(j[a+2730>>1]|0))if(!(j[a+2706>>1]|0))if(!(j[a+2726>>1]|0))if(!(j[a+2710>>1]|0))if(!(j[a+2722>>1]|0))if(!(j[a+2714>>1]|0))if(!(j[a+2718>>1]|0))e=(j[a+2686>>1]|0)==0?2:3;else e=4;else e=5;else e=6;else e=7;else e=8;else e=9;else e=10;else e=11;else e=12;else e=13;else e=14;else e=15;else e=16;else e=17;else e=18;g=a+5800|0;f=(e*3|0)+17+(k[g>>2]|0)|0;k[g>>2]=f;f=(f+10|0)>>>3;g=((k[a+5804>>2]|0)+10|0)>>>3;f=g>>>0>f>>>0?f:g}else{g=c+5|0;f=g;e=0}do if((b|0)!=0&(c+4|0)>>>0<=f>>>0)Qeb(a,b,c,d);else{t=a+5820|0;n=k[t>>2]|0;h=(n|0)>13;if((g|0)==(f|0)?1:(k[a+136>>2]|0)==4){e=d+2&65535;f=a+5816|0;g=m[f>>1]|e<<n;j[f>>1]=g;if(h){u=a+20|0;v=k[u>>2]|0;k[u>>2]=v+1;b=a+8|0;i[(k[b>>2]|0)+v>>0]=g;v=(m[f>>1]|0)>>>8&255;c=k[u>>2]|0;k[u>>2]=c+1;i[(k[b>>2]|0)+c>>0]=v;c=k[t>>2]|0;j[f>>1]=e>>>(16-c|0);e=c+-13|0}else e=n+3|0;k[t>>2]=e;Ueb(a,175514,175394);break}f=d+4&65535;s=a+5816|0;g=m[s>>1]|f<<n;j[s>>1]=g;if(h){b=a+20|0;n=k[b>>2]|0;k[b>>2]=n+1;c=a+8|0;i[(k[c>>2]|0)+n>>0]=g;g=(m[s>>1]|0)>>>8&255;n=k[b>>2]|0;k[b>>2]=n+1;i[(k[c>>2]|0)+n>>0]=g;n=k[t>>2]|0;g=f>>>(16-n|0);j[s>>1]=g;n=n+-13|0}else n=n+3|0;k[t>>2]=n;q=k[a+2844>>2]|0;r=k[a+2856>>2]|0;h=q+65280&65535;f=g&65535|h<<n;j[s>>1]=f;if((n|0)>11){v=a+20|0;c=k[v>>2]|0;k[v>>2]=c+1;b=a+8|0;i[(k[b>>2]|0)+c>>0]=f;f=(m[s>>1]|0)>>>8&255;c=k[v>>2]|0;k[v>>2]=c+1;i[(k[b>>2]|0)+c>>0]=f;c=k[t>>2]|0;f=h>>>(16-c|0);j[s>>1]=f;h=c+-11|0}else h=n+5|0;k[t>>2]=h;g=r&65535;f=g<<h|f&65535;j[s>>1]=f;if((h|0)>11){b=a+20|0;h=k[b>>2]|0;k[b>>2]=h+1;c=a+8|0;i[(k[c>>2]|0)+h>>0]=f;f=(m[s>>1]|0)>>>8&255;h=k[b>>2]|0;k[b>>2]=h+1;i[(k[c>>2]|0)+h>>0]=f;h=k[t>>2]|0;f=g>>>(16-h|0);j[s>>1]=f;h=h+-11|0}else h=h+5|0;k[t>>2]=h;g=e+65533&65535;f=g<<h|f&65535;j[s>>1]=f;if((h|0)>12){p=a+20|0;c=k[p>>2]|0;k[p>>2]=c+1;o=a+8|0;i[(k[o>>2]|0)+c>>0]=f;f=(m[s>>1]|0)>>>8&255;c=k[p>>2]|0;k[p>>2]=c+1;i[(k[o>>2]|0)+c>>0]=f;c=k[t>>2]|0;f=g>>>(16-c|0);j[s>>1]=f;g=c+-12|0}else{o=a+8|0;p=a+20|0;g=h+4|0}k[t>>2]=g;n=0;while(1){h=m[a+2684+(l[419985+n>>0]<<2)+2>>1]|0;f=h<<g|f&65535;j[s>>1]=f;if((g|0)>13){g=k[p>>2]|0;k[p>>2]=g+1;i[(k[o>>2]|0)+g>>0]=f;f=(m[s>>1]|0)>>>8&255;g=k[p>>2]|0;k[p>>2]=g+1;i[(k[o>>2]|0)+g>>0]=f;g=k[t>>2]|0;f=h>>>(16-g|0);j[s>>1]=f;g=g+-13|0}else g=g+3|0;k[t>>2]=g;if((n|0)==(e|0))break;else n=n+1|0}b=a+148|0;Veb(a,b,q);c=a+2440|0;Veb(a,c,r);Ueb(a,b,c)}while(0);Peb(a);if(!d)return;g=a+5820|0;f=k[g>>2]|0;if((f|0)<=8){e=a+5816|0;if((f|0)>0){c=j[e>>1]&255;b=a+20|0;d=k[b>>2]|0;k[b>>2]=d+1;i[(k[a+8>>2]|0)+d>>0]=c}}else{e=a+5816|0;v=j[e>>1]&255;b=a+20|0;c=k[b>>2]|0;k[b>>2]=c+1;d=a+8|0;i[(k[d>>2]|0)+c>>0]=v;c=(m[e>>1]|0)>>>8&255;a=k[b>>2]|0;k[b>>2]=a+1;i[(k[d>>2]|0)+a>>0]=c}j[e>>1]=0;k[g>>2]=0;return}function Teb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+32|0;A=C;B=k[b>>2]|0;x=b+8|0;t=k[x>>2]|0;g=k[t>>2]|0;t=k[t+12>>2]|0;w=a+5200|0;k[w>>2]=0;y=a+5204|0;k[y>>2]=573;if((t|0)>0){c=-1;d=0;do{if(!(j[B+(d<<2)>>1]|0))j[B+(d<<2)+2>>1]=0;else{c=(k[w>>2]|0)+1|0;k[w>>2]=c;k[a+2908+(c<<2)>>2]=d;i[a+5208+d>>0]=0;c=d}d=d+1|0}while((d|0)!=(t|0));d=k[w>>2]|0;if((d|0)<2)e=3;else z=c}else{c=-1;d=0;e=3}if((e|0)==3){f=a+5800|0;e=a+5804|0;if(!g){do{v=(c|0)<2;z=c+1|0;c=v?z:c;z=v?z:0;d=d+1|0;k[w>>2]=d;k[a+2908+(d<<2)>>2]=z;j[B+(z<<2)>>1]=1;i[a+5208+z>>0]=0;k[f>>2]=(k[f>>2]|0)+-1;d=k[w>>2]|0}while((d|0)<2);z=c}else{do{v=(c|0)<2;z=c+1|0;c=v?z:c;z=v?z:0;d=d+1|0;k[w>>2]=d;k[a+2908+(d<<2)>>2]=z;j[B+(z<<2)>>1]=1;i[a+5208+z>>0]=0;k[f>>2]=(k[f>>2]|0)+-1;k[e>>2]=(k[e>>2]|0)-(m[g+(z<<2)+2>>1]|0);d=k[w>>2]|0}while((d|0)<2);z=c}}v=b+4|0;k[v>>2]=z;s=(d|0)/2|0;while(1){q=k[a+2908+(s<<2)>>2]|0;o=a+5208+q|0;e=s<<1;a:do if((e|0)>(d|0))c=s;else{p=B+(q<<2)|0;c=s;while(1){do if((e|0)<(d|0)){g=e|1;d=k[a+2908+(g<<2)>>2]|0;f=j[B+(d<<2)>>1]|0;h=k[a+2908+(e<<2)>>2]|0;n=j[B+(h<<2)>>1]|0;if((f&65535)>=(n&65535)){if(f<<16>>16!=n<<16>>16){g=e;break}if((l[a+5208+d>>0]|0)>(l[a+5208+h>>0]|0)){g=e;break}}}else g=e;while(0);d=j[p>>1]|0;e=k[a+2908+(g<<2)>>2]|0;f=j[B+(e<<2)>>1]|0;if((d&65535)<(f&65535))break a;if(d<<16>>16==f<<16>>16?(l[o>>0]|0)<=(l[a+5208+e>>0]|0):0)break a;k[a+2908+(c<<2)>>2]=e;e=g<<1;d=k[w>>2]|0;if((e|0)>(d|0)){c=g;break}else c=g}}while(0);k[a+2908+(c<<2)>>2]=q;if((s|0)<=1)break;s=s+-1|0;d=k[w>>2]|0}u=a+2912|0;c=k[w>>2]|0;do{s=k[u>>2]|0;d=c+-1|0;k[w>>2]=d;q=k[a+2908+(c<<2)>>2]|0;k[u>>2]=q;p=a+5208+q|0;b:do if((c|0)<3)c=1;else{o=B+(q<<2)|0;c=1;n=2;while(1){do if((n|0)<(d|0)){g=n|1;d=k[a+2908+(g<<2)>>2]|0;e=j[B+(d<<2)>>1]|0;f=k[a+2908+(n<<2)>>2]|0;h=j[B+(f<<2)>>1]|0;if((e&65535)>=(h&65535)){if(e<<16>>16!=h<<16>>16){g=n;break}if((l[a+5208+d>>0]|0)>(l[a+5208+f>>0]|0)){g=n;break}}}else g=n;while(0);d=j[o>>1]|0;e=k[a+2908+(g<<2)>>2]|0;f=j[B+(e<<2)>>1]|0;if((d&65535)<(f&65535))break b;if(d<<16>>16==f<<16>>16?(l[p>>0]|0)<=(l[a+5208+e>>0]|0):0)break b;k[a+2908+(c<<2)>>2]=e;n=g<<1;d=k[w>>2]|0;if((n|0)>(d|0)){c=g;break}else c=g}}while(0);k[a+2908+(c<<2)>>2]=q;q=k[u>>2]|0;o=(k[y>>2]|0)+-1|0;k[y>>2]=o;k[a+2908+(o<<2)>>2]=s;o=(k[y>>2]|0)+-1|0;k[y>>2]=o;k[a+2908+(o<<2)>>2]=q;o=B+(t<<2)|0;j[o>>1]=(m[B+(q<<2)>>1]|0)+(m[B+(s<<2)>>1]|0);d=i[a+5208+s>>0]|0;n=i[a+5208+q>>0]|0;p=a+5208+t|0;i[p>>0]=(((d&255)<(n&255)?n:d)&255)+1;d=t&65535;j[B+(q<<2)+2>>1]=d;j[B+(s<<2)+2>>1]=d;k[u>>2]=t;d=k[w>>2]|0;c:do if((d|0)<2)c=1;else{c=1;n=2;while(1){do if((n|0)<(d|0)){g=n|1;d=k[a+2908+(g<<2)>>2]|0;e=j[B+(d<<2)>>1]|0;f=k[a+2908+(n<<2)>>2]|0;h=j[B+(f<<2)>>1]|0;if((e&65535)>=(h&65535)){if(e<<16>>16!=h<<16>>16){g=n;break}if((l[a+5208+d>>0]|0)>(l[a+5208+f>>0]|0)){g=n;break}}}else g=n;while(0);d=j[o>>1]|0;e=k[a+2908+(g<<2)>>2]|0;f=j[B+(e<<2)>>1]|0;if((d&65535)<(f&65535))break c;if(d<<16>>16==f<<16>>16?(l[p>>0]|0)<=(l[a+5208+e>>0]|0):0)break c;k[a+2908+(c<<2)>>2]=e;n=g<<1;d=k[w>>2]|0;if((n|0)>(d|0)){c=g;break}else c=g}}while(0);k[a+2908+(c<<2)>>2]=t;t=t+1|0;c=k[w>>2]|0}while((c|0)>1);t=k[u>>2]|0;u=(k[y>>2]|0)+-1|0;k[y>>2]=u;k[a+2908+(u<<2)>>2]=t;u=k[b>>2]|0;t=k[v>>2]|0;n=k[x>>2]|0;o=k[n>>2]|0;p=k[n+4>>2]|0;q=k[n+8>>2]|0;n=k[n+16>>2]|0;c=a+2876|0;d=c+32|0;do{j[c>>1]=0;c=c+2|0}while((c|0)<(d|0));c=k[y>>2]|0;j[u+(k[a+2908+(c<<2)>>2]<<2)+2>>1]=0;c=c+1|0;d:do if((c|0)<573){s=a+5800|0;h=a+5804|0;if(!o){f=c;c=0;do{g=k[a+2908+(f<<2)>>2]|0;y=u+(g<<2)+2|0;e=m[u+(m[y>>1]<<2)+2>>1]|0;x=(e|0)<(n|0);e=x?e+1|0:n;c=(x&1^1)+c|0;j[y>>1]=e;if((g|0)<=(t|0)){y=a+2876+(e<<1)|0;j[y>>1]=(j[y>>1]|0)+1<<16>>16;if((g|0)<(q|0))d=0;else d=k[p+(g-q<<2)>>2]|0;y=aa(m[u+(g<<2)>>1]|0,d+e|0)|0;k[s>>2]=y+(k[s>>2]|0)}f=f+1|0}while((f|0)!=573)}else{f=c;c=0;do{g=k[a+2908+(f<<2)>>2]|0;y=u+(g<<2)+2|0;e=m[u+(m[y>>1]<<2)+2>>1]|0;x=(e|0)<(n|0);e=x?e+1|0:n;c=(x&1^1)+c|0;j[y>>1]=e;if((g|0)<=(t|0)){y=a+2876+(e<<1)|0;j[y>>1]=(j[y>>1]|0)+1<<16>>16;if((g|0)<(q|0))d=0;else d=k[p+(g-q<<2)>>2]|0;y=m[u+(g<<2)>>1]|0;x=aa(y,d+e|0)|0;k[s>>2]=x+(k[s>>2]|0);y=aa((m[o+(g<<2)+2>>1]|0)+d|0,y)|0;k[h>>2]=y+(k[h>>2]|0)}f=f+1|0}while((f|0)!=573)}if(c|0){h=a+2876+(n<<1)|0;while(1){e=n;while(1){d=e+-1|0;f=a+2876+(d<<1)|0;g=j[f>>1]|0;if(!(g<<16>>16))e=d;else break}j[f>>1]=g+-1<<16>>16;d=a+2876+(e<<1)|0;j[d>>1]=(m[d>>1]|0)+2;d=(j[h>>1]|0)+-1<<16>>16;j[h>>1]=d;if((c|0)>2)c=c+-2|0;else break}if(n|0){c=573;while(1){h=n&65535;if(d<<16>>16){g=d&65535;do{do{c=c+-1|0;d=k[a+2908+(c<<2)>>2]|0}while((d|0)>(t|0));e=u+(d<<2)+2|0;f=m[e>>1]|0;if((n|0)!=(f|0)){y=aa(m[u+(d<<2)>>1]|0,n-f|0)|0;k[s>>2]=y+(k[s>>2]|0);j[e>>1]=h}g=g+-1|0}while((g|0)!=0)}d=n+-1|0;if(!d)break d;n=d;d=j[a+2876+(d<<1)>>1]|0}}}}while(0);c=0;d=1;do{c=(m[a+2876+(d+-1<<1)>>1]|0)+(c&65534)<<1;j[A+(d<<1)>>1]=c;d=d+1|0}while((d|0)!=16);if((z|0)<0){r=C;return}else f=0;while(1){a=j[B+(f<<2)+2>>1]|0;c=a&65535;if(a<<16>>16){d=A+(c<<1)|0;e=j[d>>1]|0;j[d>>1]=e+1<<16>>16;d=0;e=e&65535;while(1){d=d|e&1;if((c|0)>1){d=d<<1;c=c+-1|0;e=e>>>1}else break}j[B+(f<<2)>>1]=d}if((f|0)==(z|0))break;else f=f+1|0}r=C;return}function Ueb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;v=a+5792|0;if(!(k[v>>2]|0)){g=a+5820|0;d=a+5816|0;n=d;h=g;g=k[g>>2]|0;d=j[d>>1]|0}else{w=a+5796|0;x=a+5784|0;h=a+5820|0;n=a+5816|0;t=a+20|0;u=a+8|0;s=0;do{p=j[(k[w>>2]|0)+(s<<1)>>1]|0;r=p&65535;q=l[(k[x>>2]|0)+s>>0]|0;s=s+1|0;if(p<<16>>16){p=l[419729+q>>0]|0;d=(p|256)+1|0;g=m[b+(d<<2)+2>>1]|0;o=k[h>>2]|0;d=m[b+(d<<2)>>1]|0;f=m[n>>1]|0|d<<o;e=f&65535;j[n>>1]=e;if((o|0)>(16-g|0)){e=k[t>>2]|0;k[t>>2]=e+1;i[(k[u>>2]|0)+e>>0]=f;e=(m[n>>1]|0)>>>8&255;o=k[t>>2]|0;k[t>>2]=o+1;i[(k[u>>2]|0)+o>>0]=e;o=k[h>>2]|0;e=d>>>(16-o|0)&65535;j[n>>1]=e;g=g+-16+o|0}else g=o+g|0;k[h>>2]=g;o=k[165128+(p<<2)>>2]|0;if((p+-8|0)>>>0<20){f=q-(k[165244+(p<<2)>>2]|0)&65535;d=f<<g|e&65535;e=d&65535;j[n>>1]=e;if((g|0)>(16-o|0)){e=k[t>>2]|0;k[t>>2]=e+1;i[(k[u>>2]|0)+e>>0]=d;e=(m[n>>1]|0)>>>8&255;d=k[t>>2]|0;k[t>>2]=d+1;i[(k[u>>2]|0)+d>>0]=e;d=k[h>>2]|0;e=f>>>(16-d|0)&65535;j[n>>1]=e;d=o+-16+d|0}else d=g+o|0;k[h>>2]=d;o=d}else o=g;p=r+-1|0;q=l[419217+(p>>>0<256?p:(p>>>7)+256|0)>>0]|0;f=m[c+(q<<2)+2>>1]|0;g=m[c+(q<<2)>>1]|0;e=e&65535|g<<o;d=e&65535;j[n>>1]=d;if((o|0)>(16-f|0)){d=k[t>>2]|0;k[t>>2]=d+1;i[(k[u>>2]|0)+d>>0]=e;d=(m[n>>1]|0)>>>8&255;r=k[t>>2]|0;k[t>>2]=r+1;i[(k[u>>2]|0)+r>>0]=d;r=k[h>>2]|0;d=g>>>(16-r|0)&65535;j[n>>1]=d;g=f+-16+r|0}else g=o+f|0;k[h>>2]=g;o=k[165008+(q<<2)>>2]|0;if((q+-4|0)>>>0<26){f=p-(k[165360+(q<<2)>>2]|0)&65535;e=f<<g|d&65535;d=e&65535;j[n>>1]=d;if((g|0)>(16-o|0)){d=k[t>>2]|0;k[t>>2]=d+1;i[(k[u>>2]|0)+d>>0]=e;d=(m[n>>1]|0)>>>8&255;g=k[t>>2]|0;k[t>>2]=g+1;i[(k[u>>2]|0)+g>>0]=d;g=k[h>>2]|0;d=f>>>(16-g|0)&65535;j[n>>1]=d;g=o+-16+g|0}else g=g+o|0;k[h>>2]=g}}else{g=m[b+(q<<2)+2>>1]|0;o=k[h>>2]|0;e=m[b+(q<<2)>>1]|0;f=m[n>>1]|0|e<<o;d=f&65535;j[n>>1]=d;if((o|0)>(16-g|0)){d=k[t>>2]|0;k[t>>2]=d+1;i[(k[u>>2]|0)+d>>0]=f;d=(m[n>>1]|0)>>>8&255;r=k[t>>2]|0;k[t>>2]=r+1;i[(k[u>>2]|0)+r>>0]=d;r=k[h>>2]|0;d=e>>>(16-r|0)&65535;j[n>>1]=d;g=g+-16+r|0}else g=o+g|0;k[h>>2]=g}}while(s>>>0<(k[v>>2]|0)>>>0)}f=m[b+1026>>1]|0;e=m[b+1024>>1]|0;d=d&65535|e<<g;j[n>>1]=d;if((g|0)>(16-f|0)){w=a+20|0;x=k[w>>2]|0;k[w>>2]=x+1;b=a+8|0;i[(k[b>>2]|0)+x>>0]=d;x=(m[n>>1]|0)>>>8&255;a=k[w>>2]|0;k[w>>2]=a+1;i[(k[b>>2]|0)+a>>0]=x;a=k[h>>2]|0;j[n>>1]=e>>>(16-a|0);a=f+-16+a|0;k[h>>2]=a;return}else{a=g+f|0;k[h>>2]=a;return}}function Veb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;r=j[b+2>>1]|0;g=r<<16>>16==0;B=a+2754|0;C=a+5820|0;D=a+2752|0;s=a+5816|0;t=a+20|0;u=a+8|0;v=a+2758|0;w=a+2756|0;x=a+2750|0;y=a+2748|0;d=0;e=-1;r=r&65535;f=g?138:7;g=g?3:4;a:while(1){p=d;l=0;while(1){if((p|0)>(c|0))break a;p=p+1|0;q=j[b+(p<<2)+2>>1]|0;z=q&65535;d=l+1|0;A=(r|0)==(z|0);if(!((d|0)<(f|0)&A))break;else l=d}do if((d|0)>=(g|0)){if(r|0){if((r|0)==(e|0)){l=d;f=j[s>>1]|0;h=k[C>>2]|0}else{g=m[a+2684+(r<<2)+2>>1]|0;h=k[C>>2]|0;d=m[a+2684+(r<<2)>>1]|0;e=m[s>>1]|0|d<<h;f=e&65535;j[s>>1]=f;if((h|0)>(16-g|0)){f=k[t>>2]|0;k[t>>2]=f+1;i[(k[u>>2]|0)+f>>0]=e;f=(m[s>>1]|0)>>>8&255;o=k[t>>2]|0;k[t>>2]=o+1;i[(k[u>>2]|0)+o>>0]=f;o=k[C>>2]|0;f=d>>>(16-o|0)&65535;j[s>>1]=f;d=g+-16+o|0}else d=h+g|0;k[C>>2]=d;h=d}g=m[x>>1]|0;e=m[y>>1]|0;d=f&65535|e<<h;j[s>>1]=d;if((h|0)>(16-g|0)){f=k[t>>2]|0;k[t>>2]=f+1;i[(k[u>>2]|0)+f>>0]=d;d=(m[s>>1]|0)>>>8&255;f=k[t>>2]|0;k[t>>2]=f+1;i[(k[u>>2]|0)+f>>0]=d;f=k[C>>2]|0;d=e>>>(16-f|0);j[s>>1]=d;f=g+-16+f|0}else f=h+g|0;k[C>>2]=f;e=l+65533&65535;d=d&65535|e<<f;j[s>>1]=d;if((f|0)>14){o=k[t>>2]|0;k[t>>2]=o+1;i[(k[u>>2]|0)+o>>0]=d;o=(m[s>>1]|0)>>>8&255;d=k[t>>2]|0;k[t>>2]=d+1;i[(k[u>>2]|0)+d>>0]=o;d=k[C>>2]|0;j[s>>1]=e>>>(16-d|0);d=d+-14|0}else d=f+2|0;k[C>>2]=d;break}if((d|0)<11){e=m[B>>1]|0;f=k[C>>2]|0;g=m[D>>1]|0;d=m[s>>1]|0|g<<f;j[s>>1]=d;if((f|0)>(16-e|0)){f=k[t>>2]|0;k[t>>2]=f+1;i[(k[u>>2]|0)+f>>0]=d;d=(m[s>>1]|0)>>>8&255;f=k[t>>2]|0;k[t>>2]=f+1;i[(k[u>>2]|0)+f>>0]=d;f=k[C>>2]|0;d=g>>>(16-f|0);j[s>>1]=d;f=e+-16+f|0}else f=f+e|0;k[C>>2]=f;e=l+65534&65535;d=d&65535|e<<f;j[s>>1]=d;if((f|0)>13){o=k[t>>2]|0;k[t>>2]=o+1;i[(k[u>>2]|0)+o>>0]=d;o=(m[s>>1]|0)>>>8&255;d=k[t>>2]|0;k[t>>2]=d+1;i[(k[u>>2]|0)+d>>0]=o;d=k[C>>2]|0;j[s>>1]=e>>>(16-d|0);d=d+-13|0}else d=f+3|0;k[C>>2]=d;break}else{e=m[v>>1]|0;f=k[C>>2]|0;g=m[w>>1]|0;d=m[s>>1]|0|g<<f;j[s>>1]=d;if((f|0)>(16-e|0)){f=k[t>>2]|0;k[t>>2]=f+1;i[(k[u>>2]|0)+f>>0]=d;d=(m[s>>1]|0)>>>8&255;f=k[t>>2]|0;k[t>>2]=f+1;i[(k[u>>2]|0)+f>>0]=d;f=k[C>>2]|0;d=g>>>(16-f|0);j[s>>1]=d;f=e+-16+f|0}else f=f+e|0;k[C>>2]=f;e=l+65526&65535;d=d&65535|e<<f;j[s>>1]=d;if((f|0)>9){o=k[t>>2]|0;k[t>>2]=o+1;i[(k[u>>2]|0)+o>>0]=d;o=(m[s>>1]|0)>>>8&255;d=k[t>>2]|0;k[t>>2]=d+1;i[(k[u>>2]|0)+d>>0]=o;d=k[C>>2]|0;j[s>>1]=e>>>(16-d|0);d=d+-9|0}else d=f+7|0;k[C>>2]=d;break}}else{n=a+2684+(r<<2)+2|0;o=a+2684+(r<<2)|0;l=d;d=k[C>>2]|0;e=j[s>>1]|0;do{h=m[n>>1]|0;g=m[o>>1]|0;f=e&65535|g<<d;e=f&65535;j[s>>1]=e;if((d|0)>(16-h|0)){e=k[t>>2]|0;k[t>>2]=e+1;i[(k[u>>2]|0)+e>>0]=f;e=(m[s>>1]|0)>>>8&255;d=k[t>>2]|0;k[t>>2]=d+1;i[(k[u>>2]|0)+d>>0]=e;d=k[C>>2]|0;e=g>>>(16-d|0)&65535;j[s>>1]=e;d=h+-16+d|0}else d=d+h|0;k[C>>2]=d;l=l+-1|0}while((l|0)!=0)}while(0);g=q<<16>>16==0;e=r;d=p;r=z;f=g?138:A?6:7;g=g|A?3:4}return}function Web(a,b,c){a=a|0;b=b|0;c=c|0;return fgb(aa(c,b)|0)|0}function Xeb(a,b){a=a|0;b=b|0;ggb(b);return}function Yeb(){df(28880,420050);Nd(28896,420055,1,1,0);se(28904,420060,1,-128,127);se(28936,420065,1,-128,127);se(28928,420077,1,0,255);se(28944,420091,2,-32768,32767);se(28952,420097,2,0,65535);se(28960,420112,4,-2147483648,2147483647);se(28984,420116,4,0,-1);se(28992,420129,4,-2147483648,2147483647);se(29e3,420134,4,0,-1);uf(29008,420148,4);uf(29032,420154,8);ld(5192,420161);ld(23096,420173);lf(23120,4,420206);Rd(9088,420219);Ye(9336,0,420235);Ye(23144,0,420265);Ye(9288,1,420302);Ye(9320,2,420341);Ye(9328,3,420372);Ye(9312,4,420412);Ye(23152,5,420441);Ye(23160,4,420479);Ye(23168,5,420509);Ye(23144,0,420548);Ye(9288,1,420580);Ye(9320,2,420613);Ye(9328,3,420646);Ye(9312,4,420680);Ye(23152,5,420713);Ye(9304,6,420747);Ye(9296,7,420778);Ye(23176,7,420810);return}function Zeb(a){a=a|0;var b=0,c=0,d=0,e=0;e=k[a+4>>2]|0;d=e;a:do if(!(d&3)){a=e;c=4}else{a=e;b=d;while(1){if(!(i[a>>0]|0)){a=b;break a}a=a+1|0;b=a;if(!(b&3)){c=4;break}}}while(0);if((c|0)==4){while(1){b=k[a>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))a=a+4|0;else break}if((b&255)<<24>>24)do a=a+1|0;while((i[a>>0]|0)!=0)}a=a-d+1|0;b=fgb(a)|0;if(!b){e=0;return e|0}upb(b|0,e|0,a|0)|0;e=b;return e|0}function _eb(a){a=a|0;var b=0,c=0;c=r;r=r+16|0;b=c;k[b>>2]=k[a+60>>2];a=ee(6,b|0)|0;if(a>>>0>4294963200){if(!(k[206783]|0))b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}k[b>>2]=0-a;a=-1}r=c;return a|0}function $eb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+48|0;f=m+16|0;e=m;d=m+32|0;k[d>>2]=b;g=d+4|0;l=a+48|0;h=k[l>>2]|0;k[g>>2]=c-((h|0)!=0&1);j=a+44|0;k[d+8>>2]=k[j>>2];k[d+12>>2]=h;if(!(k[206783]|0)){k[f>>2]=k[a+60>>2];k[f+4>>2]=d;k[f+8>>2]=2;d=Bd(145,f|0)|0;if(d>>>0>4294963200){if(!(k[206783]|0))e=827176;else{e=(Fpb()|0)+64|0;e=k[e>>2]|0}k[e>>2]=0-d;d=-1;h=12}else h=11}else{xd(1524,a|0);k[e>>2]=k[a+60>>2];k[e+4>>2]=d;k[e+8>>2]=2;d=Bd(145,e|0)|0;if(d>>>0>4294963200){if(!(k[206783]|0))e=827176;else{e=(Fpb()|0)+64|0;e=k[e>>2]|0}k[e>>2]=0-d;d=-1}Dd(0);h=11}if((h|0)==11)if((d|0)>=1){g=k[g>>2]|0;if(d>>>0>g>>>0){e=k[j>>2]|0;f=a+4|0;k[f>>2]=e;k[a+8>>2]=e+(d-g);if(!(k[l>>2]|0))d=c;else{k[f>>2]=e+1;i[b+(c+-1)>>0]=i[e>>0]|0;d=c}}}else h=12;if((h|0)==12){k[a>>2]=k[a>>2]|d&48^16;k[a+8>>2]=0;k[a+4>>2]=0}r=m;return d|0}function afb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=r;r=r+32|0;g=f;d=f+20|0;k[g>>2]=k[a+60>>2];k[g+4>>2]=0;k[g+8>>2]=b;k[g+12>>2]=d;k[g+16>>2]=c;b=zd(140,g|0)|0;if(b>>>0<=4294963200)if((b|0)<0)e=7;else a=k[d>>2]|0;else{if(!(k[206783]|0))a=827176;else{a=(Fpb()|0)+64|0;a=k[a>>2]|0}k[a>>2]=0-b;e=7}if((e|0)==7){k[d>>2]=-1;a=-1}r=f;return a|0}function bfb(a){a=a|0;var b=0;if(a>>>0>4294963200){if(!(k[206783]|0))b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}k[b>>2]=0-a;a=-1}return a|0}function cfb(){var a=0;if(!(k[206783]|0))a=827176;else{a=(Fpb()|0)+64|0;a=k[a>>2]|0}return a|0}function dfb(a){a=a|0;return}function efb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=r;r=r+80|0;d=e;k[a+36>>2]=35;if((k[a>>2]&64|0)==0?(k[d>>2]=k[a+60>>2],k[d+4>>2]=21505,k[d+8>>2]=e+12,pe(54,d|0)|0):0)i[a+75>>0]=-1;d=ffb(a,b,c)|0;r=e;return d|0}function ffb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+48|0;m=p+16|0;l=p;h=p+32|0;n=a+28|0;g=k[n>>2]|0;k[h>>2]=g;o=a+20|0;g=(k[o>>2]|0)-g|0;k[h+4>>2]=g;k[h+8>>2]=b;k[h+12>>2]=c;i=a+60|0;j=a+44|0;e=2;g=g+c|0;while(1){if(!(k[206783]|0)){k[m>>2]=k[i>>2];k[m+4>>2]=h;k[m+8>>2]=e;b=Cd(146,m|0)|0;if(b>>>0>4294963200){if(!(k[206783]|0))d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}k[d>>2]=0-b;b=-1}}else{xd(1525,a|0);k[l>>2]=k[i>>2];k[l+4>>2]=h;k[l+8>>2]=e;b=Cd(146,l|0)|0;if(b>>>0>4294963200){if(!(k[206783]|0))d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}k[d>>2]=0-b;b=-1}Dd(0)}if((g|0)==(b|0)){b=13;break}if((b|0)<0){b=15;break}g=g-b|0;d=k[h+4>>2]|0;if(b>>>0<=d>>>0)if((e|0)==2){k[n>>2]=(k[n>>2]|0)+b;e=2;f=h}else f=h;else{f=k[j>>2]|0;k[n>>2]=f;k[o>>2]=f;b=b-d|0;e=e+-1|0;f=h+8|0;d=k[h+12>>2]|0}k[f>>2]=(k[f>>2]|0)+b;k[f+4>>2]=d-b;h=f}if((b|0)==13){m=k[j>>2]|0;k[a+16>>2]=m+(k[a+48>>2]|0);a=m;k[n>>2]=a;k[o>>2]=a}else if((b|0)==15){k[a+16>>2]=0;k[n>>2]=0;k[o>>2]=0;k[a>>2]=k[a>>2]|32;if((e|0)==2)c=0;else c=c-(k[h+4>>2]|0)|0}r=p;return c|0}function gfb(a){a=a|0;return}function hfb(a){a=a|0;var b=0,c=0,d=0;d=a;a:do if(!(d&3))c=4;else{b=d;while(1){if(!(i[a>>0]|0)){a=b;break a}a=a+1|0;b=a;if(!(b&3)){c=4;break}}}while(0);if((c|0)==4){while(1){b=k[a>>2]|0;if(!((b&-2139062144^-2139062144)&b+-16843009))a=a+4|0;else break}if((b&255)<<24>>24)do a=a+1|0;while((i[a>>0]|0)!=0)}return a-d|0}function ifb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0;j=r;r=r+16|0;e=j;g=(d|0)==0?827188:d;d=k[g>>2]|0;a:do if(!b)if(!d)d=0;else h=15;else{f=(a|0)==0?e:a;if(!c)d=-2;else{if(!d){d=i[b>>0]|0;a=d&255;if(d<<24>>24>-1){k[f>>2]=a;d=d<<24>>24!=0&1;break}d=a+-194|0;if(d>>>0>50){h=15;break}d=k[165480+(d<<2)>>2]|0;e=c+-1|0;if(e){b=b+1|0;h=9}}else{e=c;h=9}b:do if((h|0)==9){a=i[b>>0]|0;l=(a&255)>>>3;if((l+-16|l+(d>>26))>>>0>7){h=15;break a}while(1){b=b+1|0;d=(a&255)+-128|d<<6;e=e+-1|0;if((d|0)>=0)break;if(!e)break b;a=i[b>>0]|0;if((a&-64)<<24>>24!=-128){h=15;break a}}k[g>>2]=0;k[f>>2]=d;d=c-e|0;break a}while(0);k[g>>2]=d;d=-2}}while(0);if((h|0)==15){k[g>>2]=0;if(!(k[206783]|0))d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}k[d>>2]=84;d=-1}r=j;return d|0}function jfb(a,b){a=a|0;b=b|0;do if(!a)a=1;else{if(b>>>0<128){i[a>>0]=b;a=1;break}if(b>>>0<2048){i[a>>0]=b>>>6|192;i[a+1>>0]=b&63|128;a=2;break}if(b>>>0<55296|(b&-8192|0)==57344){i[a>>0]=b>>>12|224;i[a+1>>0]=b>>>6&63|128;i[a+2>>0]=b&63|128;a=3;break}if((b+-65536|0)>>>0<1048576){i[a>>0]=b>>>18|240;i[a+1>>0]=b>>>12&63|128;i[a+2>>0]=b>>>6&63|128;i[a+3>>0]=b&63|128;a=4;break}if(!(k[206783]|0))a=827176;else{a=(Fpb()|0)+64|0;a=k[a>>2]|0}k[a>>2]=84;a=-1}while(0);return a|0}function kfb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=r;r=r+16|0;f=e;k[f>>2]=d;d=lfb(a,b,c,f)|0;r=e;return d|0}function lfb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+128|0;e=m+112|0;j=m;f=j;g=166024;h=f+112|0;do{k[f>>2]=k[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));if((b+-1|0)>>>0>2147483646)if(!b){a=e;b=1;l=6}else{if(!(k[206783]|0))b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}k[b>>2]=75;b=-1}else l=6;if((l|0)==6){l=-2-a|0;l=b>>>0>l>>>0?l:b;k[j+48>>2]=l;e=j+20|0;k[e>>2]=a;k[j+44>>2]=a;b=a+l|0;a=j+16|0;k[a>>2]=b;k[j+28>>2]=b;b=mfb(j,c,d)|0;if(l){l=k[e>>2]|0;i[l+(((l|0)==(k[a>>2]|0))<<31>>31)>>0]=0}}r=m;return b|0}function mfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+224|0;m=q+120|0;n=q+80|0;o=q;p=q+136|0;d=n;e=d+40|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[m>>2]=k[c>>2];if((nfb(0,b,m,o,n)|0)<0)c=-1;else{c=k[a>>2]|0;l=c&32;if((i[a+74>>0]|0)<1)k[a>>2]=c&-33;d=a+48|0;if(!(k[d>>2]|0)){e=a+44|0;f=k[e>>2]|0;k[e>>2]=p;g=a+28|0;k[g>>2]=p;h=a+20|0;k[h>>2]=p;k[d>>2]=80;j=a+16|0;k[j>>2]=p+80;c=nfb(a,b,m,o,n)|0;if(f){ci[k[a+36>>2]&255](a,0,0)|0;c=(k[h>>2]|0)==0?-1:c;k[e>>2]=f;k[d>>2]=0;k[j>>2]=0;k[g>>2]=0;k[h>>2]=0}}else c=nfb(a,b,m,o,n)|0;p=k[a>>2]|0;k[a>>2]=p|l;c=(p&32|0)==0?c:-1}r=q;return c|0}function nfb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,m=0,n=0.0,o=0,q=0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;ja=r;r=r+624|0;fa=ja+24|0;ga=ja+16|0;ha=ja+588|0;X=ja+576|0;ia=ja;S=ja+536|0;M=ja+8|0;O=ja+528|0;P=(a|0)!=0;Q=S+40|0;R=Q;S=S+39|0;T=M+4|0;U=ha;V=0-U|0;W=X+12|0;X=X+11|0;Y=W;Z=Y-U|0;_=-2-U|0;$=Y+2|0;ba=fa+288|0;ca=ha+9|0;da=ca;ea=ha+8|0;g=0;f=0;q=0;a:while(1){do if((f|0)>-1){if((g|0)<=(2147483647-f|0)){f=g+f|0;break}if(!(k[206783]|0))f=827176;else{f=(Fpb()|0)+64|0;f=k[f>>2]|0}k[f>>2]=75;f=-1}while(0);g=i[b>>0]|0;if(!(g<<24>>24)){L=247;break}else h=b;b:while(1){switch(g<<24>>24){case 37:{g=h;L=11;break b}case 0:{g=h;break b}default:{}}g=h+1|0;h=g;g=i[g>>0]|0}c:do if((L|0)==11)while(1){L=0;if((i[h+1>>0]|0)!=37)break c;g=g+1|0;h=h+2|0;if((i[h>>0]|0)==37)L=11;else break}while(0);g=g-b|0;if(P?(k[a>>2]&32|0)==0:0)ofb(b,g,a)|0;if(g|0){b=h;continue}o=h+1|0;m=i[o>>0]|0;g=(m<<24>>24)+-48|0;if(g>>>0<10){t=(i[h+2>>0]|0)==36;o=t?h+3|0:o;w=t?g:-1;t=t?1:q;g=i[o>>0]|0}else{w=-1;t=q;g=m}h=(g<<24>>24)+-32|0;d:do if(h>>>0<32){m=0;do{if(!(1<<h&75913))break d;m=1<<(g<<24>>24)+-32|m;o=o+1|0;g=i[o>>0]|0;h=(g<<24>>24)+-32|0}while(h>>>0<32)}else m=0;while(0);do if(g<<24>>24!=42){h=(g<<24>>24)+-48|0;if(h>>>0<10){q=0;do{q=(q*10|0)+h|0;o=o+1|0;g=i[o>>0]|0;h=(g<<24>>24)+-48|0}while(h>>>0<10);if((q|0)<0){f=-1;break a}else K=t}else{q=0;K=t}}else{s=o+1|0;g=i[s>>0]|0;h=(g<<24>>24)+-48|0;if(h>>>0<10?(i[o+2>>0]|0)==36:0){k[e+(h<<2)>>2]=10;g=k[d+((i[s>>0]|0)+-48<<3)>>2]|0;h=1;s=o+3|0}else{if(t|0){f=-1;break a}if(!P){q=0;K=0;o=s;break}h=(k[c>>2]|0)+(4-1)&~(4-1);g=k[h>>2]|0;k[c>>2]=h+4;h=0}K=(g|0)<0;q=K?0-g|0:g;m=K?m|8192:m;K=h;o=s;g=i[s>>0]|0}while(0);e:do if(g<<24>>24==46){g=o+1|0;h=i[g>>0]|0;if(h<<24>>24!=42){o=(h<<24>>24)+-48|0;if(o>>>0<10)h=0;else{x=0;break}while(1){h=(h*10|0)+o|0;g=g+1|0;o=(i[g>>0]|0)+-48|0;if(o>>>0>=10){x=h;break e}}}g=o+2|0;h=(i[g>>0]|0)+-48|0;if(h>>>0<10?(i[o+3>>0]|0)==36:0){k[e+(h<<2)>>2]=10;x=k[d+((i[g>>0]|0)+-48<<3)>>2]|0;g=o+4|0;break}if(K|0){f=-1;break a}if(P){J=(k[c>>2]|0)+(4-1)&~(4-1);x=k[J>>2]|0;k[c>>2]=J+4}else x=0}else{x=-1;g=o}while(0);t=0;while(1){h=(i[g>>0]|0)+-65|0;if(h>>>0>57){f=-1;break a}J=g+1|0;h=i[421128+(t*58|0)+h>>0]|0;o=h&255;if((o+-1|0)>>>0<8){t=o;g=J}else break}if(!(h<<24>>24)){f=-1;break}s=(w|0)>-1;do if(h<<24>>24==19)if(s){f=-1;break a}else L=53;else{if(s){k[e+(w<<2)>>2]=o;H=d+(w<<3)|0;I=k[H+4>>2]|0;L=ia;k[L>>2]=k[H>>2];k[L+4>>2]=I;L=53;break}if(!P){f=0;break a}pfb(ia,o,c)}while(0);if((L|0)==53?(L=0,!P):0){g=0;q=K;b=J;continue}E=i[g>>0]|0;E=(t|0)!=0&(E&15|0)==3?E&-33:E;s=m&-65537;I=(m&8192|0)==0?m:s;f:do switch(E|0){case 110:switch((t&255)<<24>>24){case 0:{k[k[ia>>2]>>2]=f;g=0;q=K;b=J;continue a}case 1:{k[k[ia>>2]>>2]=f;g=0;q=K;b=J;continue a}case 2:{g=k[ia>>2]|0;k[g>>2]=f;k[g+4>>2]=((f|0)<0)<<31>>31;g=0;q=K;b=J;continue a}case 3:{j[k[ia>>2]>>1]=f;g=0;q=K;b=J;continue a}case 4:{i[k[ia>>2]>>0]=f;g=0;q=K;b=J;continue a}case 6:{k[k[ia>>2]>>2]=f;g=0;q=K;b=J;continue a}case 7:{g=k[ia>>2]|0;k[g>>2]=f;k[g+4>>2]=((f|0)<0)<<31>>31;g=0;q=K;b=J;continue a}default:{g=0;q=K;b=J;continue a}}case 112:{s=120;t=x>>>0>8?x:8;g=I|8;L=65;break}case 88:case 120:{s=E;t=x;g=I;L=65;break}case 111:{h=ia;g=k[h>>2]|0;h=k[h+4>>2]|0;if((g|0)==0&(h|0)==0)b=Q;else{b=Q;do{b=b+-1|0;i[b>>0]=g&7|48;g=ppb(g|0,h|0,3)|0;h=N}while(!((g|0)==0&(h|0)==0))}if(!(I&8)){h=0;m=421608;o=x;g=I;L=78}else{o=R-b|0;h=0;m=421608;o=(x|0)>(o|0)?x:o+1|0;g=I;L=78}break}case 105:case 100:{b=ia;g=k[b>>2]|0;b=k[b+4>>2]|0;if((b|0)<0){g=jpb(0,0,g|0,b|0)|0;b=N;h=ia;k[h>>2]=g;k[h+4>>2]=b;h=1;m=421608;L=77;break f}if(!(I&2048)){m=I&1;h=m;m=(m|0)==0?421608:421610;L=77}else{h=1;m=421609;L=77}break}case 117:{b=ia;h=0;m=421608;g=k[b>>2]|0;b=k[b+4>>2]|0;L=77;break}case 99:{i[S>>0]=k[ia>>2];b=S;w=0;t=421608;h=Q;g=1;break}case 109:{if(!(k[206783]|0))g=827176;else{g=(Fpb()|0)+64|0;g=k[g>>2]|0}g=rfb(k[g>>2]|0)|0;L=85;break}case 115:{g=k[ia>>2]|0;g=g|0?g:421618;L=85;break}case 67:{k[M>>2]=k[ia>>2];k[T>>2]=0;k[ia>>2]=M;s=-1;h=M;L=89;break}case 83:{g=k[ia>>2]|0;if(!x){tfb(a,32,q,0,I);g=0;L=100}else{s=x;h=g;L=89}break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{n=+p[ia>>3];k[ga>>2]=0;p[u>>3]=n;if((k[u+4>>2]|0)>=0){g=I&1;if(!(I&2048)){G=g;H=(g|0)==0?421626:421631}else{G=1;H=421628}}else{n=-n;G=1;H=421625}p[u>>3]=n;F=k[u+4>>2]&2146435072;do if(F>>>0<2146435072|(F|0)==2146435072&0<0){v=+ufb(n,ga)*2.0;b=v!=0.0;if(b)k[ga>>2]=(k[ga>>2]|0)+-1;z=E|32;if((z|0)==97){o=E&32;w=(o|0)==0?H:H+9|0;t=G|2;g=12-x|0;do if(!(x>>>0>11|(g|0)==0)){n=8.0;do{g=g+-1|0;n=n*16.0}while((g|0)!=0);if((i[w>>0]|0)==45){n=-(n+(-v-n));break}else{n=v+n-n;break}}else n=v;while(0);b=k[ga>>2]|0;g=(b|0)<0?0-b|0:b;g=qfb(g,((g|0)<0)<<31>>31,W)|0;if((g|0)==(W|0)){i[X>>0]=48;g=X}i[g+-1>>0]=(b>>31&2)+43;s=g+-2|0;i[s>>0]=E+15;m=(x|0)<1;h=(I&8|0)==0;g=ha;do{H=~~n;b=g+1|0;i[g>>0]=l[421592+H>>0]|o;n=(n-+(H|0))*16.0;do if((b-U|0)==1){if(h&(m&n==0.0)){g=b;break}i[b>>0]=46;g=g+2|0}else g=b;while(0)}while(n!=0.0);m=s;h=(x|0)!=0&(_+g|0)<(x|0)?$+x-m|0:Z-m+g|0;o=h+t|0;tfb(a,32,q,o,I);if(!(k[a>>2]&32))ofb(w,t,a)|0;tfb(a,48,q,o,I^65536);b=g-U|0;if(!(k[a>>2]&32))ofb(ha,b,a)|0;g=Y-m|0;tfb(a,48,h-(b+g)|0,0,0);if(!(k[a>>2]&32))ofb(s,g,a)|0;tfb(a,32,q,o,I^8192);g=(o|0)<(q|0)?q:o;break}g=(x|0)<0?6:x;if(b){b=(k[ga>>2]|0)+-28|0;k[ga>>2]=b;n=v*268435456.0}else{n=v;b=k[ga>>2]|0}F=(b|0)<0?fa:ba;h=F;do{D=~~n>>>0;k[h>>2]=D;h=h+4|0;n=(n-+(D>>>0))*1.0e9}while(n!=0.0);if((b|0)>0){m=F;s=h;while(1){o=(b|0)>29?29:b;b=s+-4|0;do if(b>>>0>=m>>>0){h=0;do{C=Apb(k[b>>2]|0,0,o|0)|0;C=kpb(C|0,N|0,h|0,0)|0;D=N;B=xpb(C|0,D|0,1e9,0)|0;k[b>>2]=B;h=spb(C|0,D|0,1e9,0)|0;b=b+-4|0}while(b>>>0>=m>>>0);if(!h)break;m=m+-4|0;k[m>>2]=h}while(0);h=s;while(1){if(h>>>0<=m>>>0)break;b=h+-4|0;if(!(k[b>>2]|0))h=b;else break}b=(k[ga>>2]|0)-o|0;k[ga>>2]=b;if((b|0)>0)s=h;else break}}else m=F;if((b|0)<0){x=((g+25|0)/9|0)+1|0;y=(z|0)==102;do{w=0-b|0;w=(w|0)>9?9:w;do if(m>>>0<h>>>0){o=(1<<w)+-1|0;s=1e9>>>w;t=0;b=m;do{D=k[b>>2]|0;k[b>>2]=(D>>>w)+t;t=aa(D&o,s)|0;b=b+4|0}while(b>>>0<h>>>0);b=(k[m>>2]|0)==0?m+4|0:m;if(!t){m=b;b=h;break}k[h>>2]=t;m=b;b=h+4|0}else{m=(k[m>>2]|0)==0?m+4|0:m;b=h}while(0);h=y?F:m;h=(b-h>>2|0)>(x|0)?h+(x<<2)|0:b;b=(k[ga>>2]|0)+w|0;k[ga>>2]=b}while((b|0)<0)}D=F;do if(m>>>0<h>>>0){b=(D-m>>2)*9|0;s=k[m>>2]|0;if(s>>>0<10)break;else o=10;do{o=o*10|0;b=b+1|0}while(s>>>0>=o>>>0)}else b=0;while(0);A=(z|0)==103;B=(g|0)!=0;o=g-((z|0)!=102?b:0)+((B&A)<<31>>31)|0;if((o|0)<(((h-D>>2)*9|0)+-9|0)){o=o+9216|0;t=F+4+(((o|0)/9|0)+-1024<<2)|0;o=((o|0)%9|0)+1|0;if((o|0)<9){s=10;do{s=s*10|0;o=o+1|0}while((o|0)!=9)}else s=10;x=k[t>>2]|0;y=(x>>>0)%(s>>>0)|0;o=(t+4|0)==(h|0);do if(o&(y|0)==0)o=t;else{v=(((x>>>0)/(s>>>0)|0)&1|0)==0?9007199254740992.0:9007199254740994.0;w=(s|0)/2|0;if(y>>>0<w>>>0)n=.5;else n=o&(y|0)==(w|0)?1.0:1.5;do if(G){if((i[H>>0]|0)!=45)break;n=-n;v=-v}while(0);o=x-y|0;k[t>>2]=o;if(!(v+n!=v)){o=t;break}C=o+s|0;k[t>>2]=C;if(C>>>0>999999999){o=t;while(1){b=o+-4|0;k[o>>2]=0;if(b>>>0<m>>>0){m=m+-4|0;k[m>>2]=0}C=(k[b>>2]|0)+1|0;k[b>>2]=C;if(C>>>0>999999999)o=b;else{t=b;break}}}b=(D-m>>2)*9|0;s=k[m>>2]|0;if(s>>>0<10){o=t;break}else o=10;do{o=o*10|0;b=b+1|0}while(s>>>0>=o>>>0);o=t}while(0);C=o+4|0;h=h>>>0>C>>>0?C:h}y=0-b|0;C=h;while(1){if(C>>>0<=m>>>0){z=0;break}h=C+-4|0;if(!(k[h>>2]|0))C=h;else{z=1;break}}do if(A){g=(B&1^1)+g|0;if((g|0)>(b|0)&(b|0)>-5){t=E+-1|0;g=g+-1-b|0}else{t=E+-2|0;g=g+-1|0}h=I&8;if(h|0){w=h;break}do if(z){s=k[C+-4>>2]|0;if(!s){o=9;break}if(!((s>>>0)%10|0)){o=0;h=10}else{o=0;break}do{h=h*10|0;o=o+1|0}while(!((s>>>0)%(h>>>0)|0|0))}else o=9;while(0);h=((C-D>>2)*9|0)+-9|0;if((t|32|0)==102){w=h-o|0;w=(w|0)<0?0:w;g=(g|0)<(w|0)?g:w;w=0;break}else{w=h+b-o|0;w=(w|0)<0?0:w;g=(g|0)<(w|0)?g:w;w=0;break}}else{t=E;w=I&8}while(0);x=g|w;o=(x|0)!=0&1;s=(t|32|0)==102;if(s){y=0;b=(b|0)>0?b:0}else{h=(b|0)<0?y:b;h=qfb(h,((h|0)<0)<<31>>31,W)|0;if((Y-h|0)<2)do{h=h+-1|0;i[h>>0]=48}while((Y-h|0)<2);i[h+-1>>0]=(b>>31&2)+43;b=h+-2|0;i[b>>0]=t;y=b;b=Y-b|0}A=G+1+g+o+b|0;tfb(a,32,q,A,I);if(!(k[a>>2]&32))ofb(H,G,a)|0;tfb(a,48,q,A,I^65536);do if(s){m=m>>>0>F>>>0?F:m;h=m;do{b=qfb(k[h>>2]|0,0,ca)|0;do if((h|0)==(m|0)){if((b|0)!=(ca|0))break;i[ea>>0]=48;b=ea}else{if(b>>>0<=ha>>>0)break;zpb(ha|0,48,b-U|0)|0;do b=b+-1|0;while(b>>>0>ha>>>0)}while(0);if(!(k[a>>2]&32))ofb(b,da-b|0,a)|0;h=h+4|0}while(h>>>0<=F>>>0);do if(x|0){if(k[a>>2]&32|0)break;ofb(421656,1,a)|0}while(0);if((g|0)>0&h>>>0<C>>>0)while(1){b=qfb(k[h>>2]|0,0,ca)|0;if(b>>>0>ha>>>0){zpb(ha|0,48,b-U|0)|0;do b=b+-1|0;while(b>>>0>ha>>>0)}if(!(k[a>>2]&32))ofb(b,(g|0)>9?9:g,a)|0;h=h+4|0;b=g+-9|0;if(!((g|0)>9&h>>>0<C>>>0)){g=b;break}else g=b}tfb(a,48,g+9|0,9,0)}else{t=z?C:m+4|0;if((g|0)>-1){s=(w|0)==0;o=m;do{b=qfb(k[o>>2]|0,0,ca)|0;if((b|0)==(ca|0)){i[ea>>0]=48;b=ea}do if((o|0)==(m|0)){h=b+1|0;if(!(k[a>>2]&32))ofb(b,1,a)|0;if(s&(g|0)<1){b=h;break}if(k[a>>2]&32|0){b=h;break}ofb(421656,1,a)|0;b=h}else{if(b>>>0<=ha>>>0)break;zpb(ha|0,48,b+V|0)|0;do b=b+-1|0;while(b>>>0>ha>>>0)}while(0);h=da-b|0;if(!(k[a>>2]&32))ofb(b,(g|0)>(h|0)?h:g,a)|0;g=g-h|0;o=o+4|0}while(o>>>0<t>>>0&(g|0)>-1)}tfb(a,48,g+18|0,18,0);if(k[a>>2]&32|0)break;ofb(y,Y-y|0,a)|0}while(0);tfb(a,32,q,A,I^8192);g=(A|0)<(q|0)?q:A}else{o=(E&32|0)!=0;m=n!=n|0.0!=0.0;b=m?0:G;h=b+3|0;tfb(a,32,q,h,s);g=k[a>>2]|0;if(!(g&32)){ofb(H,b,a)|0;g=k[a>>2]|0}if(!(g&32))ofb(m?(o?423832:421652):o?421644:421648,3,a)|0;tfb(a,32,q,h,I^8192);g=(h|0)<(q|0)?q:h}while(0);q=K;b=J;continue a}default:{w=0;t=421608;h=Q;g=x;s=I}}while(0);g:do if((L|0)==65){m=ia;h=k[m>>2]|0;m=k[m+4>>2]|0;o=s&32;if((h|0)==0&(m|0)==0){b=Q;h=0;m=0}else{b=Q;do{b=b+-1|0;i[b>>0]=l[421592+(h&15)>>0]|o;h=ppb(h|0,m|0,4)|0;m=N}while(!((h|0)==0&(m|0)==0));m=ia;h=k[m>>2]|0;m=k[m+4>>2]|0}m=(g&8|0)==0|(h|0)==0&(m|0)==0;h=m?0:2;m=m?421608:421608+(s>>4)|0;o=t;L=78}else if((L|0)==77){b=qfb(g,b,Q)|0;o=x;g=I;L=78}else if((L|0)==85){L=0;I=sfb(g,0,x)|0;H=(I|0)==0;b=g;w=0;t=421608;h=H?g+x|0:I;g=H?x:I-g|0}else if((L|0)==89){L=0;o=h;g=0;b=0;while(1){m=k[o>>2]|0;if(!m)break;b=jfb(O,m)|0;if((b|0)<0|b>>>0>(s-g|0)>>>0)break;g=b+g|0;if(s>>>0>g>>>0)o=o+4|0;else break}if((b|0)<0){f=-1;break a}tfb(a,32,q,g,I);if(!g){g=0;L=100}else{m=0;while(1){b=k[h>>2]|0;if(!b){L=100;break g}b=jfb(O,b)|0;m=b+m|0;if((m|0)>(g|0)){L=100;break g}if(!(k[a>>2]&32))ofb(O,b,a)|0;if(m>>>0>=g>>>0){L=100;break}else h=h+4|0}}}while(0);if((L|0)==100){L=0;tfb(a,32,q,g,I^8192);g=(q|0)>(g|0)?q:g;q=K;b=J;continue}if((L|0)==78){L=0;s=(o|0)>-1?g&-65537:g;g=ia;g=(k[g>>2]|0)!=0|(k[g+4>>2]|0)!=0;if((o|0)!=0|g){g=(g&1^1)+(R-b)|0;w=h;t=m;h=Q;g=(o|0)>(g|0)?o:g}else{b=Q;w=h;t=m;h=Q;g=0}}o=h-b|0;h=(g|0)<(o|0)?o:g;m=h+w|0;g=(q|0)<(m|0)?m:q;tfb(a,32,g,m,s);if(!(k[a>>2]&32))ofb(t,w,a)|0;tfb(a,48,g,m,s^65536);tfb(a,48,h,o,0);if(!(k[a>>2]&32))ofb(b,o,a)|0;tfb(a,32,g,m,s^8192);q=K;b=J}h:do if((L|0)==247)if(!a)if(!q)f=0;else{f=1;while(1){g=k[e+(f<<2)>>2]|0;if(!g){b=0;break}pfb(d+(f<<3)|0,g,c);f=f+1|0;if((f|0)>=10){f=1;break h}}while(1){g=f+1|0;if(b|0){f=-1;break h}if((g|0)>=10){f=1;break h}f=g;b=k[e+(g<<2)>>2]|0}}while(0);r=ja;return f|0}function ofb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=c+16|0;e=k[d>>2]|0;if(!e)if(!(vfb(c)|0)){d=k[d>>2]|0;f=5}else d=0;else{d=e;f=5}a:do if((f|0)==5){g=c+20|0;f=k[g>>2]|0;e=f;if((d-f|0)>>>0<b>>>0){d=ci[k[c+36>>2]&255](c,a,b)|0;break}b:do if((i[c+75>>0]|0)>-1){d=b;while(1){if(!d){f=b;d=0;break b}f=d+-1|0;if((i[a+f>>0]|0)==10)break;else d=f}if((ci[k[c+36>>2]&255](c,a,d)|0)>>>0<d>>>0)break a;f=b-d|0;a=a+d|0;e=k[g>>2]|0}else{f=b;d=0}while(0);upb(e|0,a|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f;d=d+f|0}while(0);return d|0}function pfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0;a:do if(b>>>0<=20)do switch(b|0){case 9:{d=(k[c>>2]|0)+(4-1)&~(4-1);b=k[d>>2]|0;k[c>>2]=d+4;k[a>>2]=b;break a}case 10:{d=(k[c>>2]|0)+(4-1)&~(4-1);b=k[d>>2]|0;k[c>>2]=d+4;d=a;k[d>>2]=b;k[d+4>>2]=((b|0)<0)<<31>>31;break a}case 11:{d=(k[c>>2]|0)+(4-1)&~(4-1);b=k[d>>2]|0;k[c>>2]=d+4;d=a;k[d>>2]=b;k[d+4>>2]=0;break a}case 12:{d=(k[c>>2]|0)+(8-1)&~(8-1);b=d;e=k[b>>2]|0;b=k[b+4>>2]|0;k[c>>2]=d+8;d=a;k[d>>2]=e;k[d+4>>2]=b;break a}case 13:{e=(k[c>>2]|0)+(4-1)&~(4-1);d=k[e>>2]|0;k[c>>2]=e+4;d=(d&65535)<<16>>16;e=a;k[e>>2]=d;k[e+4>>2]=((d|0)<0)<<31>>31;break a}case 14:{e=(k[c>>2]|0)+(4-1)&~(4-1);d=k[e>>2]|0;k[c>>2]=e+4;e=a;k[e>>2]=d&65535;k[e+4>>2]=0;break a}case 15:{e=(k[c>>2]|0)+(4-1)&~(4-1);d=k[e>>2]|0;k[c>>2]=e+4;d=(d&255)<<24>>24;e=a;k[e>>2]=d;k[e+4>>2]=((d|0)<0)<<31>>31;break a}case 16:{e=(k[c>>2]|0)+(4-1)&~(4-1);d=k[e>>2]|0;k[c>>2]=e+4;e=a;k[e>>2]=d&255;k[e+4>>2]=0;break a}case 17:{e=(k[c>>2]|0)+(8-1)&~(8-1);f=+p[e>>3];k[c>>2]=e+8;p[a>>3]=f;break a}case 18:{e=(k[c>>2]|0)+(8-1)&~(8-1);f=+p[e>>3];k[c>>2]=e+8;p[a>>3]=f;break a}default:break a}while(0);while(0);return}function qfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(b>>>0>0|(b|0)==0&a>>>0>4294967295){while(1){d=xpb(a|0,b|0,10,0)|0;c=c+-1|0;i[c>>0]=d|48;d=a;a=spb(a|0,b|0,10,0)|0;if(!(b>>>0>9|(b|0)==9&d>>>0>4294967295))break;else b=N}b=a}else b=a;if(b)while(1){c=c+-1|0;i[c>>0]=(b>>>0)%10|0|48;if(b>>>0<10)break;else b=(b>>>0)/10|0}return c|0}function rfb(a){a=a|0;var b=0,c=0;c=0;while(1){if((l[421658+c>>0]|0)==(a|0)){a=2;break}b=c+1|0;if((b|0)==87){b=421746;c=87;a=5;break}else c=b}if((a|0)==2)if(!c)b=421746;else{b=421746;a=5}if((a|0)==5)while(1){do{a=b;b=b+1|0}while((i[a>>0]|0)!=0);c=c+-1|0;if(!c)break;else a=5}return b|0}function sfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=b&255;d=(c|0)!=0;a:do if(d&(a&3|0)!=0){e=b&255;while(1){if((i[a>>0]|0)==e<<24>>24)break a;a=a+1|0;c=c+-1|0;d=(c|0)!=0;if(!(d&(a&3|0)!=0)){g=5;break}}}else g=5;while(0);b:do if((g|0)==5)if(d){e=b&255;if((i[a>>0]|0)!=e<<24>>24){d=aa(f,16843009)|0;c:do if(c>>>0>3)while(1){f=k[a>>2]^d;if((f&-2139062144^-2139062144)&f+-16843009|0)break;a=a+4|0;c=c+-4|0;if(c>>>0<=3){g=11;break c}}else g=11;while(0);if((g|0)==11)if(!c){c=0;break}while(1){if((i[a>>0]|0)==e<<24>>24)break b;a=a+1|0;c=c+-1|0;if(!c){c=0;break}}}}else c=0;while(0);return (c|0?a:0)|0}function tfb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;g=r;r=r+256|0;f=g;do if((c|0)>(d|0)&(e&73728|0)==0){c=c-d|0;zpb(f|0,b|0,(c>>>0>256?256:c)|0)|0;d=k[a>>2]|0;e=(d&32|0)==0;if(c>>>0>255){b=c;do{if(e){ofb(f,256,a)|0;d=k[a>>2]|0}b=b+-256|0;e=(d&32|0)==0}while(b>>>0>255);if(e)c=c&255;else break}else if(!e)break;ofb(f,c,a)|0}while(0);r=g;return}function ufb(a,b){a=+a;b=b|0;var c=0,d=0,e=0;p[u>>3]=a;c=k[u>>2]|0;d=k[u+4>>2]|0;e=ppb(c|0,d|0,52)|0;switch(e&2047){case 0:{if(a!=0.0){a=+ufb(a*18446744073709551616.0,b);c=(k[b>>2]|0)+-64|0}else c=0;k[b>>2]=c;break}case 2047:break;default:{k[b>>2]=(e&2047)+-1022;k[u>>2]=c;k[u+4>>2]=d&-2146435073|1071644672;a=+p[u>>3]}}return +a}function vfb(a){a=a|0;var b=0,c=0;b=a+74|0;c=i[b>>0]|0;i[b>>0]=c+255|c;b=k[a>>2]|0;if(!(b&8)){k[a+8>>2]=0;k[a+4>>2]=0;c=k[a+44>>2]|0;k[a+28>>2]=c;k[a+20>>2]=c;k[a+16>>2]=c+(k[a+48>>2]|0);a=0}else{k[a>>2]=b|32;a=-1}return a|0}function wfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=a+20|0;e=k[d>>2]|0;a=(k[a+16>>2]|0)-e|0;a=a>>>0>c>>>0?c:a;upb(e|0,b|0,a|0)|0;k[d>>2]=(k[d>>2]|0)+a;return c|0}function xfb(a){a=a|0;var b=0,c=0;b=(Fpb()|0)+184|0;c=k[b>>2]|0;if(a|0)k[b>>2]=a;return c|0}function yfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=r;r=r+32|0;e=d;f=d+16|0;k[f>>2]=c;g=(k[f>>2]|0)+(4-1)&~(4-1);c=k[g>>2]|0;k[f>>2]=g+4;k[e>>2]=a;k[e+4>>2]=b|32768;k[e+8>>2]=c;c=bfb(fe(5,e|0)|0)|0;r=d;return c|0}function zfb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=k[b>>2]|0;if((d|0)!=0?(f=k[d>>2]|0,(f|0)!=0):0)if(!a){d=c;g=e;j=16}else{k[d>>2]=0;d=c;h=e;j=36}else if(!a){d=c;j=7}else{d=c;j=6}a:while(1)if((j|0)==6){if(!d){j=26;break}while(1){f=i[e>>0]|0;b:do if(((f&255)+-1|0)>>>0<127?d>>>0>4&(e&3|0)==0:0){do{f=k[e>>2]|0;if((f+-16843009|f)&-2139062144|0){h=e;f=f&255;break b}k[a>>2]=f&255;k[a+4>>2]=l[e+1>>0];k[a+8>>2]=l[e+2>>0];h=e;e=e+4|0;j=a;a=a+16|0;k[j+12>>2]=l[h+3>>0];d=d+-4|0}while(d>>>0>4);h=e;f=i[e>>0]|0}else h=e;while(0);g=f&255;if((g+-1|0)>>>0>=127)break;e=h+1|0;k[a>>2]=g;d=d+-1|0;if(!d){j=26;break a}else a=a+4|0}e=g+-194|0;if(e>>>0>50){e=h;j=48;break}f=k[165480+(e<<2)>>2]|0;h=h+1|0;j=36;continue}else if((j|0)==7){while(1){f=i[e>>0]|0;if(((f&255)+-1|0)>>>0<127?(e&3|0)==0:0){j=k[e>>2]|0;f=j&255;if(!((j+-16843009|j)&-2139062144)){do{e=e+4|0;d=d+-4|0;f=k[e>>2]|0}while(((f+-16843009|f)&-2139062144|0)==0);f=f&255}}g=f&255;if((g+-1|0)>>>0>=127)break;e=e+1|0;d=d+-1|0}g=g+-194|0;if(g>>>0>50){j=48;break}f=k[165480+(g<<2)>>2]|0;g=e+1|0;j=16;continue}else if((j|0)==16){j=(l[g>>0]|0)>>>3;if((j+-16|j+(f>>26))>>>0>7){j=17;break}e=g+1|0;if(f&33554432){if((i[e>>0]&-64)<<24>>24!=-128){j=20;break}e=g+2|0;if(f&524288){if((i[e>>0]&-64)<<24>>24!=-128){j=23;break}e=g+3|0}}d=d+-1|0;j=7;continue}else if((j|0)==36){g=l[h>>0]|0;j=g>>>3;if((j+-16|j+(f>>26))>>>0>7){j=37;break}e=h+1|0;g=g+-128|f<<6;if((g|0)<0){f=(l[e>>0]|0)+-128|0;if(f>>>0>63){j=40;break}e=h+2|0;f=f|g<<6;if((f|0)<0){e=(l[e>>0]|0)+-128|0;if(e>>>0>63){j=43;break}f=e|f<<6;e=h+3|0}}else f=g;k[a>>2]=f;a=a+4|0;d=d+-1|0;j=6;continue}if((j|0)==17){g=g+-1|0;j=46}else if((j|0)==20){g=g+-1|0;j=46}else if((j|0)==23){g=g+-1|0;j=46}else if((j|0)==26)k[b>>2]=e;else if((j|0)==37){g=h+-1|0;j=46}else if((j|0)==40){e=h+-1|0;j=52}else if((j|0)==43){e=h+-1|0;j=52}if((j|0)==46)if(!f){e=g;f=i[g>>0]|0;j=48}else{e=g;j=52}if((j|0)==48)if(!(f<<24>>24)){if(a|0){k[a>>2]=0;k[b>>2]=0}c=c-d|0}else j=52;if((j|0)==52){if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=84;if(!a)c=-1;else{k[b>>2]=e;c=-1}}return c|0}function Afb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=b&255;a:do if(!e){c=a+(hfb(a)|0)|0;a=c;d=b&255;c=i[c>>0]|0}else{if(a&3){d=b&255;do{c=i[a>>0]|0;if(c<<24>>24==0?1:c<<24>>24==d<<24>>24)break a;a=a+1|0}while((a&3|0)!=0)}d=aa(e,16843009)|0;c=k[a>>2]|0;b:do if(!((c&-2139062144^-2139062144)&c+-16843009))do{e=c^d;if((e&-2139062144^-2139062144)&e+-16843009|0)break b;a=a+4|0;c=k[a>>2]|0}while(!((c&-2139062144^-2139062144)&c+-16843009|0));while(0);d=b&255;while(1){c=i[a>>0]|0;if(c<<24>>24==0?1:c<<24>>24==d<<24>>24)break;else a=a+1|0}}while(0);return (c<<24>>24==d<<24>>24?a:0)|0}function Bfb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+1056|0;v=x+1024|0;w=x;n=i[b>>0]|0;do if(n<<24>>24){u=Afb(a,n<<24>>24)|0;if(u){e=i[b+1>>0]|0;if(e<<24>>24){c=u+1|0;h=i[c>>0]|0;if(h<<24>>24){f=i[b+2>>0]|0;if(!(f<<24>>24)){e=e&255|(n&255)<<8;d=l[u>>0]<<8|h&255;a=h;while(1){d=d&65535;if((d|0)==(e|0))break;c=c+1|0;a=i[c>>0]|0;if(!(a<<24>>24)){a=0;break}else d=a&255|d<<8}a=a<<24>>24?c+-1|0:0;break}c=u+2|0;a=i[c>>0]|0;if(a<<24>>24){d=i[b+3>>0]|0;if(!(d<<24>>24)){e=(e&255)<<16|(n&255)<<24|(f&255)<<8;d=(a&255)<<8|(h&255)<<16|l[u>>0]<<24;if((d|0)!=(e|0))do{c=c+1|0;a=i[c>>0]|0;d=(a&255|d)<<8}while(!(a<<24>>24==0|(d|0)==(e|0)));a=a<<24>>24?c+-2|0:0;break}c=u+3|0;g=i[c>>0]|0;if(g<<24>>24){if(!(i[b+4>>0]|0)){e=(e&255)<<16|(n&255)<<24|(f&255)<<8|d&255;d=(a&255)<<8|(h&255)<<16|g&255|l[u>>0]<<24;if((d|0)==(e|0))a=g;else do{c=c+1|0;a=i[c>>0]|0;d=a&255|d<<8}while(!(a<<24>>24==0|(d|0)==(e|0)));a=a<<24>>24?c+-3|0:0;break};k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;k[v+16>>2]=0;k[v+20>>2]=0;k[v+24>>2]=0;k[v+28>>2]=0;s=0;a=n;while(1){if(!(i[u+s>>0]|0)){a=0;break}t=v+(((a&255)>>>5&255)<<2)|0;k[t>>2]=k[t>>2]|1<<(a&31);t=s+1|0;k[w+((a&255)<<2)>>2]=t;a=i[b+t>>0]|0;if(!(a<<24>>24)){q=23;break}else s=t}a:do if((q|0)==23){b:do if(t>>>0>1){c=0;h=-1;d=1;c:while(1){e=1;a=c;while(1){c=d;d:while(1){g=1;while(1){d=i[b+(g+h)>>0]|0;f=i[b+c>>0]|0;if(d<<24>>24!=f<<24>>24)break d;if((g|0)==(e|0))break;g=g+1|0;c=g+a|0;if(c>>>0>=t>>>0){j=e;a=h;break c}}a=a+e|0;c=a+1|0;if(c>>>0>=t>>>0){j=e;a=h;break c}}e=c-h|0;if((d&255)<=(f&255))break;d=c+1|0;if(d>>>0>=t>>>0){j=e;a=h;break c}else a=c}d=a+2|0;if(d>>>0>=t>>>0){j=1;break}else{c=a+1|0;h=a}}e=0;m=-1;f=1;while(1){d=1;c=e;while(1){e=f;e:while(1){h=1;while(1){f=i[b+(h+m)>>0]|0;g=i[b+e>>0]|0;if(f<<24>>24!=g<<24>>24)break e;if((h|0)==(d|0))break;h=h+1|0;e=h+c|0;if(e>>>0>=t>>>0){e=j;c=m;break b}}c=c+d|0;e=c+1|0;if(e>>>0>=t>>>0){e=j;c=m;break b}}d=e-m|0;if((f&255)>=(g&255))break;f=e+1|0;if(f>>>0>=t>>>0){e=j;c=m;break b}else c=e}f=c+2|0;if(f>>>0>=t>>>0){e=j;d=1;break}else{e=c+1|0;m=c}}}else{e=1;a=-1;d=1;c=-1}while(0);o=(c+1|0)>>>0>(a+1|0)>>>0;g=o?d:e;o=o?c:a;p=o+1|0;f:do if(!p)q=51;else{e=b;d=p;f=b+g|0;a=n;while(1){if(a<<24>>24!=(i[f>>0]|0))break;a=d+-1|0;c=e+1|0;if(!a){q=51;break f}e=c;d=a;f=f+1|0;a=i[c>>0]|0}g=t-o+-1|0;n=0;g=(o>>>0>g>>>0?o:g)+1|0}while(0);if((q|0)==51)n=t-g|0;h=t|63;j=(n|0)!=0;m=t-g|0;a=u;f=0;c=u;g:while(1){d=a;do if((c-d|0)>>>0<t>>>0){e=sfb(c,0,h)|0;if(e)if((e-d|0)>>>0<t>>>0){a=0;break a}else break;else{e=c+h|0;break}}else e=c;while(0);c=i[a+s>>0]|0;if(!(1<<(c&31)&k[v+(((c&255)>>>5&255)<<2)>>2])){a=a+t|0;f=0;c=e;continue}c=t-(k[w+((c&255)<<2)>>2]|0)|0;if(c|0){a=a+(j&(f|0)!=0&c>>>0<g>>>0?m:c)|0;f=0;c=e;continue}c=p>>>0>f>>>0?p:f;d=i[b+c>>0]|0;h:do if(!(d<<24>>24))c=p;else{while(1){if(d<<24>>24!=(i[a+c>>0]|0))break;c=c+1|0;d=i[b+c>>0]|0;if(!(d<<24>>24)){c=p;break h}}a=a+(c-o)|0;f=0;c=e;continue g}while(0);do{if(c>>>0<=f>>>0)break a;c=c+-1|0}while((i[b+c>>0]|0)==(i[a+c>>0]|0));a=a+g|0;f=n;c=e}}while(0)}else a=0}else a=0}else a=0}else a=u}else a=0}while(0);r=x;return a|0}function Cfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;k[e>>2]=c;lfb(a,2147483647,b,e)|0;r=d;return}function Dfb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0;i=r;r=r+112|0;j=i;k[j>>2]=0;h=j+4|0;k[h>>2]=a;k[j+44>>2]=a;l=(a|0)<0?-1:a+2147483647|0;f=j+8|0;k[f>>2]=l;k[j+76>>2]=-1;k[j+104>>2]=0;g=j+108|0;k[g>>2]=l-a;k[j+100>>2]=l;c=Efb(j,c,1,d,e)|0;if(b|0)k[b>>2]=a+((k[h>>2]|0)+(k[g>>2]|0)-(k[f>>2]|0));r=i;return c|0}function Efb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0;a:do if(b>>>0>36){if(!(k[206783]|0))d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}k[d>>2]=22;f=0;d=0}else{q=a+4|0;r=a+100|0;b:while(1){f=k[q>>2]|0;if(f>>>0<(k[r>>2]|0)>>>0){k[q>>2]=f+1;f=l[f>>0]|0}else f=Ffb(a)|0;switch(f|0){case 9:case 10:case 11:case 12:case 13:case 32:break;default:break b}}c:do switch(f|0){case 43:case 45:{f=((f|0)==45)<<31>>31;g=k[q>>2]|0;if(g>>>0<(k[r>>2]|0)>>>0){k[q>>2]=g+1;p=f;f=l[g>>0]|0;break c}else{p=f;f=Ffb(a)|0;break c}}default:p=0}while(0);g=(b|0)==0;do if((b|16|0)==16&(f|0)==48){f=k[q>>2]|0;if(f>>>0<(k[r>>2]|0)>>>0){k[q>>2]=f+1;f=l[f>>0]|0}else f=Ffb(a)|0;if((f|32|0)!=120)if(g){b=8;n=51;break}else{n=37;break}f=k[q>>2]|0;if(f>>>0<(k[r>>2]|0)>>>0){k[q>>2]=f+1;f=l[f>>0]|0}else f=Ffb(a)|0;if((l[423558+f>>0]|0)>15){d=(k[r>>2]|0)==0;if(!d)k[q>>2]=(k[q>>2]|0)+-1;if(!c){k[a+104>>2]=0;f=k[a+8>>2]|0;k[a+108>>2]=f-(k[q>>2]|0);k[r>>2]=f;f=0;d=0;break a}if(d){f=0;d=0;break a}k[q>>2]=(k[q>>2]|0)+-1;f=0;d=0;break a}else{b=16;n=51}}else{b=g?10:b;if((l[423558+f>>0]|0)>>>0<b>>>0)n=37;else{if(!(k[r>>2]|0))d=k[q>>2]|0;else{d=(k[q>>2]|0)+-1|0;k[q>>2]=d}k[a+104>>2]=0;e=k[a+8>>2]|0;k[a+108>>2]=e-d;k[r>>2]=e;if(!(k[206783]|0))d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}k[d>>2]=22;f=0;d=0;break a}}while(0);if((n|0)==37)if((b|0)==10){b=f+-48|0;if(b>>>0<10){f=0;g=b;do{f=(f*10|0)+g|0;b=k[q>>2]|0;if(b>>>0<(k[r>>2]|0)>>>0){k[q>>2]=b+1;b=l[b>>0]|0}else b=Ffb(a)|0;g=b+-48|0}while(g>>>0<10&f>>>0<429496729);c=0}else{b=f;f=0;c=0}g=b+-48|0;if(g>>>0<10){m=g;while(1){g=Epb(f|0,c|0,10,0)|0;h=N;j=((m|0)<0)<<31>>31;o=~j;if(h>>>0>o>>>0|(h|0)==(o|0)&g>>>0>~m>>>0){g=b;b=m;break}f=kpb(g|0,h|0,m|0,j|0)|0;c=N;b=k[q>>2]|0;if(b>>>0<(k[r>>2]|0)>>>0){k[q>>2]=b+1;b=l[b>>0]|0}else b=Ffb(a)|0;m=b+-48|0;if(!(m>>>0<10&(c>>>0<429496729|(c|0)==429496729&f>>>0<2576980378))){g=b;b=m;break}}if(b>>>0>9){g=p;b=c}else{b=10;n=77}}else{g=p;b=c}}else n=51;d:do if((n|0)==51){if(!(b+-1&b)){n=i[423814+((b*23|0)>>>5&7)>>0]|0;c=i[423558+f>>0]|0;g=c&255;if(g>>>0<b>>>0){f=0;h=g;do{f=h|f<<n;g=k[q>>2]|0;if(g>>>0<(k[r>>2]|0)>>>0){k[q>>2]=g+1;g=l[g>>0]|0}else g=Ffb(a)|0;c=i[423558+g>>0]|0;h=c&255}while(f>>>0<134217728&h>>>0<b>>>0);h=0}else{g=f;h=0;f=0}j=ppb(-1,-1,n|0)|0;m=N;if((c&255)>>>0>=b>>>0|(h>>>0>m>>>0|(h|0)==(m|0)&f>>>0>j>>>0)){c=h;n=77;break}else g=h;while(1){f=Apb(f|0,g|0,n|0)|0;h=N;f=c&255|f;g=k[q>>2]|0;if(g>>>0<(k[r>>2]|0)>>>0){k[q>>2]=g+1;g=l[g>>0]|0}else g=Ffb(a)|0;c=i[423558+g>>0]|0;if((c&255)>>>0>=b>>>0|(h>>>0>m>>>0|(h|0)==(m|0)&f>>>0>j>>>0)){c=h;n=77;break d}else g=h}}c=i[423558+f>>0]|0;g=c&255;if(g>>>0<b>>>0){f=0;h=g;do{f=h+(aa(f,b)|0)|0;g=k[q>>2]|0;if(g>>>0<(k[r>>2]|0)>>>0){k[q>>2]=g+1;g=l[g>>0]|0}else g=Ffb(a)|0;c=i[423558+g>>0]|0;h=c&255}while(f>>>0<119304647&h>>>0<b>>>0);h=0}else{g=f;f=0;h=0}if((c&255)>>>0<b>>>0){n=spb(-1,-1,b|0,0)|0;o=N;m=h;while(1){if(m>>>0>o>>>0|(m|0)==(o|0)&f>>>0>n>>>0){c=m;n=77;break d}h=Epb(f|0,m|0,b|0,0)|0;j=N;c=c&255;if(j>>>0>4294967295|(j|0)==-1&h>>>0>~c>>>0){c=m;n=77;break d}f=kpb(c|0,0,h|0,j|0)|0;h=N;g=k[q>>2]|0;if(g>>>0<(k[r>>2]|0)>>>0){k[q>>2]=g+1;g=l[g>>0]|0}else g=Ffb(a)|0;c=i[423558+g>>0]|0;if((c&255)>>>0>=b>>>0){c=h;n=77;break}else m=h}}else{c=h;n=77}}while(0);if((n|0)==77)if((l[423558+g>>0]|0)>>>0<b>>>0){do{f=k[q>>2]|0;if(f>>>0<(k[r>>2]|0)>>>0){k[q>>2]=f+1;f=l[f>>0]|0}else f=Ffb(a)|0}while((l[423558+f>>0]|0)>>>0<b>>>0);if(!(k[206783]|0))f=827176;else{f=(Fpb()|0)+64|0;f=k[f>>2]|0}k[f>>2]=34;g=(d&1|0)==0&0==0?p:0;b=e;f=d}else{g=p;b=c}if(k[r>>2]|0)k[q>>2]=(k[q>>2]|0)+-1;if(!(b>>>0<e>>>0|(b|0)==(e|0)&f>>>0<d>>>0)){if(!((d&1|0)!=0|0!=0|(g|0)!=0)){if(!(k[206783]|0))f=827176;else{f=(Fpb()|0)+64|0;f=k[f>>2]|0}k[f>>2]=34;d=kpb(d|0,e|0,-1,-1)|0;f=N;break}if(b>>>0>e>>>0|(b|0)==(e|0)&f>>>0>d>>>0){if(!(k[206783]|0))f=827176;else{f=(Fpb()|0)+64|0;f=k[f>>2]|0}k[f>>2]=34;f=e;break}}d=((g|0)<0)<<31>>31;d=jpb(f^g|0,b^d|0,g|0,d|0)|0;f=N}while(0);N=f;return d|0}function Ffb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;c=a+104|0;g=k[c>>2]|0;if((g|0)!=0?(k[a+108>>2]|0)>=(g|0):0)h=4;else{b=Gfb(a)|0;if((b|0)>=0){c=k[c>>2]|0;g=k[a+8>>2]|0;if(c){d=a+4|0;f=k[d>>2]|0;e=c-(k[a+108>>2]|0)|0;c=g;if((g-f|0)<(e|0))h=9;else k[a+100>>2]=f+(e+-1)}else{d=a+4|0;c=g;h=9}if((h|0)==9)k[a+100>>2]=g;if(!c)c=k[d>>2]|0;else{g=k[d>>2]|0;a=a+108|0;k[a>>2]=c+1-g+(k[a>>2]|0);c=g}c=c+-1|0;if((l[c>>0]|0|0)!=(b|0))i[c>>0]=b}else h=4}if((h|0)==4){k[a+100>>2]=0;b=-1}return b|0}function Gfb(a){a=a|0;var b=0,c=0;c=r;r=r+16|0;b=c;if((k[a+8>>2]|0)==0?(Hfb(a)|0)!=0:0)a=-1;else if((ci[k[a+32>>2]&255](a,b,1)|0)==1)a=l[b>>0]|0;else a=-1;r=c;return a|0}function Hfb(a){a=a|0;var b=0,c=0;b=a+74|0;c=i[b>>0]|0;i[b>>0]=c+255|c;b=a+20|0;c=a+44|0;if((k[b>>2]|0)>>>0>(k[c>>2]|0)>>>0)ci[k[a+36>>2]&255](a,0,0)|0;k[a+16>>2]=0;k[a+28>>2]=0;k[b>>2]=0;b=k[a>>2]|0;if(b&20)if(!(b&4))b=-1;else{k[a>>2]=b|32;b=-1}else{b=k[c>>2]|0;k[a+8>>2]=b;k[a+4>>2]=b;b=0}return b|0}function Ifb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0.0,g=0,h=0,j=0,m=0,n=0,o=0.0,q=0.0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0.0;M=r;r=r+512|0;I=M;switch(b|0){case 0:{J=-149;K=24;A=4;break}case 1:{J=-1074;K=53;A=4;break}case 2:{J=-1074;K=53;A=4;break}default:d=0.0}a:do if((A|0)==4){E=a+4|0;B=a+100|0;b:while(1){b=k[E>>2]|0;if(b>>>0<(k[B>>2]|0)>>>0){k[E>>2]=b+1;b=l[b>>0]|0}else b=Ffb(a)|0;switch(b|0){case 9:case 10:case 11:case 12:case 13:case 32:break;default:break b}}c:do switch(b|0){case 43:case 45:{e=1-(((b|0)==45&1)<<1)|0;b=k[E>>2]|0;if(b>>>0<(k[B>>2]|0)>>>0){k[E>>2]=b+1;g=l[b>>0]|0;L=e;break c}else{g=Ffb(a)|0;L=e;break c}}default:{g=b;L=1}}while(0);b=0;do{if((g|32|0)!=(i[423823+b>>0]|0))break;do if(b>>>0<7){e=k[E>>2]|0;if(e>>>0<(k[B>>2]|0)>>>0){k[E>>2]=e+1;g=l[e>>0]|0;break}else{g=Ffb(a)|0;break}}while(0);b=b+1|0}while(b>>>0<8);d:do switch(b|0){case 8:break;case 3:{A=23;break}default:{h=(c|0)!=0;if(h&b>>>0>3)if((b|0)==8)break d;else{A=23;break d}e:do if(!b){b=0;do{if((g|32|0)!=(i[423832+b>>0]|0))break e;do if(b>>>0<2){e=k[E>>2]|0;if(e>>>0<(k[B>>2]|0)>>>0){k[E>>2]=e+1;g=l[e>>0]|0;break}else{g=Ffb(a)|0;break}}while(0);b=b+1|0}while(b>>>0<3)}while(0);switch(b|0){case 3:{b=k[E>>2]|0;if(b>>>0<(k[B>>2]|0)>>>0){k[E>>2]=b+1;b=l[b>>0]|0}else b=Ffb(a)|0;if((b|0)==40)b=1;else{if(!(k[B>>2]|0)){d=C;break a}k[E>>2]=(k[E>>2]|0)+-1;d=C;break a}while(1){e=k[E>>2]|0;if(e>>>0<(k[B>>2]|0)>>>0){k[E>>2]=e+1;e=l[e>>0]|0}else e=Ffb(a)|0;if(!((e+-48|0)>>>0<10|(e+-65|0)>>>0<26)?!((e|0)==95|(e+-97|0)>>>0<26):0)break;b=b+1|0}if((e|0)==41){d=C;break a}e=(k[B>>2]|0)==0;if(!e)k[E>>2]=(k[E>>2]|0)+-1;if(!h){if(!(k[206783]|0))b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}k[b>>2]=22;k[a+104>>2]=0;L=k[a+8>>2]|0;k[a+108>>2]=L-(k[E>>2]|0);k[B>>2]=L;d=0.0;break a}if(!b){d=C;break a}while(1){b=b+-1|0;if(!e)k[E>>2]=(k[E>>2]|0)+-1;if(!b){d=C;break a}}}case 0:{do if((g|0)==48){b=k[E>>2]|0;if(b>>>0<(k[B>>2]|0)>>>0){k[E>>2]=b+1;b=l[b>>0]|0}else b=Ffb(a)|0;if((b|32|0)!=120){if(!(k[B>>2]|0)){b=48;break}k[E>>2]=(k[E>>2]|0)+-1;b=48;break}b=k[E>>2]|0;if(b>>>0<(k[B>>2]|0)>>>0){k[E>>2]=b+1;e=l[b>>0]|0;g=0}else{e=Ffb(a)|0;g=0}f:while(1){switch(e|0){case 46:{A=78;break f}case 48:break;default:{v=0;j=0;o=1.0;d=0.0;b=0;h=e;w=g;y=0;x=0;g=0;e=0;break f}}b=k[E>>2]|0;if(b>>>0<(k[B>>2]|0)>>>0){k[E>>2]=b+1;e=l[b>>0]|0;g=1;continue}else{e=Ffb(a)|0;g=1;continue}}if((A|0)==78){b=k[E>>2]|0;if(b>>>0<(k[B>>2]|0)>>>0){k[E>>2]=b+1;e=l[b>>0]|0}else e=Ffb(a)|0;if((e|0)==48){g=0;e=0;do{b=k[E>>2]|0;if(b>>>0<(k[B>>2]|0)>>>0){k[E>>2]=b+1;h=l[b>>0]|0}else h=Ffb(a)|0;g=kpb(g|0,e|0,-1,-1)|0;e=N}while((h|0)==48);v=1;j=0;o=1.0;d=0.0;b=0;w=1;y=0;x=0}else{v=1;j=0;o=1.0;d=0.0;b=0;h=e;w=g;y=0;x=0;g=0;e=0}}while(1){n=h+-48|0;m=h|32;if(n>>>0>=10){s=(h|0)==46;if(!(s|(m+-97|0)>>>0<6)){m=h;break}if(s)if(!v){v=1;f=o;s=w;g=x;e=y;n=x;m=y}else{m=46;break}else A=90}else A=90;if((A|0)==90){A=0;h=(h|0)>57?m+-87|0:n;do if(!((y|0)<0|(y|0)==0&x>>>0<8)){if((y|0)<0|(y|0)==0&x>>>0<14){t=o*.0625;f=t;d=d+t*+(h|0);break}if((j|0)!=0|(h|0)==0)f=o;else{j=1;f=o;d=d+o*.5}}else{f=o;b=h+(b<<4)|0}while(0);n=kpb(x|0,y|0,1,0)|0;s=1;m=N}h=k[E>>2]|0;if(h>>>0<(k[B>>2]|0)>>>0){k[E>>2]=h+1;o=f;h=l[h>>0]|0;w=s;y=m;x=n;continue}else{o=f;h=Ffb(a)|0;w=s;y=m;x=n;continue}}if(!w){b=(k[B>>2]|0)==0;if(!b)k[E>>2]=(k[E>>2]|0)+-1;if(c){if(!b?(z=k[E>>2]|0,k[E>>2]=z+-1,v|0):0)k[E>>2]=z+-2}else{k[a+104>>2]=0;K=k[a+8>>2]|0;k[a+108>>2]=K-(k[E>>2]|0);k[B>>2]=K}d=+(L|0)*0.0;break a}j=(v|0)==0;n=j?x:g;j=j?y:e;if((y|0)<0|(y|0)==0&x>>>0<8){g=x;e=y;do{b=b<<4;g=kpb(g|0,e|0,1,0)|0;e=N}while((e|0)<0|(e|0)==0&g>>>0<8);h=b}else h=b;if((m|32|0)==112){e=Jfb(a,c)|0;b=N;if((e|0)==0&(b|0)==-2147483648){if(!c){k[a+104>>2]=0;L=k[a+8>>2]|0;k[a+108>>2]=L-(k[E>>2]|0);k[B>>2]=L;d=0.0;break a}if(!(k[B>>2]|0)){e=0;b=0}else{k[E>>2]=(k[E>>2]|0)+-1;e=0;b=0}}}else if(!(k[B>>2]|0)){e=0;b=0}else{k[E>>2]=(k[E>>2]|0)+-1;e=0;b=0}g=Apb(n|0,j|0,2)|0;g=kpb(g|0,N|0,-32,-1)|0;g=kpb(g|0,N|0,e|0,b|0)|0;b=N;if(!h){d=+(L|0)*0.0;break a}if((b|0)>0|(b|0)==0&g>>>0>(0-J|0)>>>0){if(!(k[206783]|0))b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}k[b>>2]=34;d=+(L|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break a}I=J+-106|0;H=((I|0)<0)<<31>>31;if((b|0)<(H|0)|(b|0)==(H|0)&g>>>0<I>>>0){if(!(k[206783]|0))b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}k[b>>2]=34;d=+(L|0)*2.2250738585072014e-308*2.2250738585072014e-308;break a}if((h|0)>-1){e=h;do{H=!(d>=.5);I=H&1|e<<1;e=I^1;d=d+(H?d:d+-1.0);g=kpb(g|0,b|0,-1,-1)|0;b=N}while((I|0)>-1);o=d;h=e}else o=d;J=jpb(32,0,J|0,((J|0)<0)<<31>>31|0)|0;b=kpb(g|0,b|0,J|0,N|0)|0;J=N;if(0>(J|0)|0==(J|0)&K>>>0>b>>>0)if((b|0)<0){e=0;b=84;A=135}else A=133;else{b=K;A=133}if((A|0)==133)if((b|0)<53){e=b;b=84-b|0;A=135}else{f=0.0;d=+(L|0)}if((A|0)==135){f=+Kfb(1.0,b);d=+(L|0);p[u>>3]=f;L=k[u>>2]|0;b=k[u+4>>2]|0;p[u>>3]=d;b=k[u+4>>2]&-2147483648|b&2147483647;k[u>>2]=L;k[u+4>>2]=b;f=+p[u>>3];b=e}L=(h&1|0)==0&(o!=0.0&(b|0)<32);d=d*(L?0.0:o)+(f+d*+(((L&1)+h|0)>>>0))-f;if(!(d!=0.0)){if(!(k[206783]|0))b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}k[b>>2]=34}d=+Kfb(d,g);break a}else b=g;while(0);F=J+K|0;H=0-F|0;e=0;g:while(1){switch(b|0){case 46:{A=148;break g}case 48:break;default:{m=0;h=e;n=0;j=0;break g}}b=k[E>>2]|0;if(b>>>0<(k[B>>2]|0)>>>0){k[E>>2]=b+1;b=l[b>>0]|0;e=1;continue}else{b=Ffb(a)|0;e=1;continue}}if((A|0)==148){b=k[E>>2]|0;if(b>>>0<(k[B>>2]|0)>>>0){k[E>>2]=b+1;b=l[b>>0]|0}else b=Ffb(a)|0;if((b|0)==48){e=0;b=0;while(1){e=kpb(e|0,b|0,-1,-1)|0;j=N;b=k[E>>2]|0;if(b>>>0<(k[B>>2]|0)>>>0){k[E>>2]=b+1;b=l[b>>0]|0}else b=Ffb(a)|0;if((b|0)==48)b=j;else{m=1;h=1;n=e;break}}}else{m=1;h=e;n=0;j=0}}k[I>>2]=0;s=b+-48|0;g=(b|0)==46;h:do if(g|s>>>0<10){A=I+496|0;w=0;e=0;z=0;x=m;y=h;m=0;h=0;i:while(1){do if(g)if(!x){x=1;v=z;n=m;j=h}else break i;else{m=kpb(m|0,h|0,1,0)|0;h=N;v=(b|0)!=48;if((e|0)>=125){if(!v){v=z;break}k[A>>2]=k[A>>2]|1;v=z;break}g=I+(e<<2)|0;if(!w)b=s;else b=b+-48+((k[g>>2]|0)*10|0)|0;k[g>>2]=b;w=w+1|0;y=(w|0)==9;w=y?0:w;e=(y&1)+e|0;v=v?m:z;y=1}while(0);b=k[E>>2]|0;if(b>>>0<(k[B>>2]|0)>>>0){k[E>>2]=b+1;b=l[b>>0]|0}else b=Ffb(a)|0;s=b+-48|0;g=(b|0)==46;if(!(g|s>>>0<10)){s=v;v=x;g=y;A=171;break h}else z=v}b=w;s=z;g=(y|0)!=0;A=179}else{w=0;e=0;s=0;v=m;g=h;m=0;h=0;A=171}while(0);do if((A|0)==171){z=(v|0)==0;n=z?m:n;j=z?h:j;g=(g|0)!=0;if(!(g&(b|32|0)==101))if((b|0)>-1){b=w;A=179;break}else{b=w;A=181;break}g=Jfb(a,c)|0;b=N;if((g|0)==0&(b|0)==-2147483648){if(!c){k[a+104>>2]=0;L=k[a+8>>2]|0;k[a+108>>2]=L-(k[E>>2]|0);k[B>>2]=L;d=0.0;break}if(!(k[B>>2]|0)){g=0;b=0}else{k[E>>2]=(k[E>>2]|0)+-1;g=0;b=0}}y=kpb(g|0,b|0,n|0,j|0)|0;b=w;j=N;A=185}while(0);if((A|0)==179)if(k[B>>2]|0){k[E>>2]=(k[E>>2]|0)+-1;if(g){y=n;A=185}else A=182}else A=181;if((A|0)==181)if(g){y=n;A=185}else A=182;do if((A|0)==182){if(!(k[206783]|0))b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}k[b>>2]=22;k[a+104>>2]=0;L=k[a+8>>2]|0;k[a+108>>2]=L-(k[E>>2]|0);k[B>>2]=L;d=0.0}else if((A|0)==185){g=k[I>>2]|0;if(!g){d=+(L|0)*0.0;break}if(((h|0)<0|(h|0)==0&m>>>0<10)&((y|0)==(m|0)&(j|0)==(h|0))?K>>>0>30|(g>>>K|0)==0:0){d=+(L|0)*+(g>>>0);break}E=(J|0)/-2|0;a=((E|0)<0)<<31>>31;if((j|0)>(a|0)|(j|0)==(a|0)&y>>>0>E>>>0){if(!(k[206783]|0))b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}k[b>>2]=34;d=+(L|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}E=J+-106|0;a=((E|0)<0)<<31>>31;if((j|0)<(a|0)|(j|0)==(a|0)&y>>>0<E>>>0){if(!(k[206783]|0))b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}k[b>>2]=34;d=+(L|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if(b){if((b|0)<9){h=I+(e<<2)|0;g=k[h>>2]|0;do{g=g*10|0;b=b+1|0}while((b|0)!=9);k[h>>2]=g}e=e+1|0}if((s|0)<9?(s|0)<=(y|0)&(y|0)<18:0){if((y|0)==9){d=+(L|0)*+((k[I>>2]|0)>>>0);break}if((y|0)<9){d=+(L|0)*+((k[I>>2]|0)>>>0)/+(k[169208+(8-y<<2)>>2]|0);break}E=K+27+(aa(y,-3)|0)|0;b=k[I>>2]|0;if((E|0)>30|(b>>>E|0)==0){d=+(L|0)*+(b>>>0)*+(k[169208+(y+-10<<2)>>2]|0);break}}b=(y|0)%9|0;if(!b){b=0;h=0}else{s=(y|0)>-1?b:b+9|0;m=k[169208+(8-s<<2)>>2]|0;if(e){n=1e9/(m|0)|0;h=0;j=0;g=y;b=0;do{B=I+(b<<2)|0;a=k[B>>2]|0;E=((a>>>0)/(m>>>0)|0)+h|0;k[B>>2]=E;h=aa((a>>>0)%(m>>>0)|0,n)|0;E=(b|0)==(j|0)&(E|0)==0;g=E?g+-9|0:g;j=E?j+1&127:j;b=b+1|0}while((b|0)!=(e|0));if(!h)h=j;else{k[I+(e<<2)>>2]=h;h=j;e=e+1|0}}else{h=0;e=0;g=y}b=0;y=9-s+g|0}j:while(1){s=(y|0)<18;v=(y|0)==18;w=I+(h<<2)|0;while(1){if(!s){if(!v){g=y;break j}if((k[w>>2]|0)>>>0>=9007199){g=18;break j}}g=0;x=e;e=e+127|0;while(1){j=e&127;m=I+(j<<2)|0;e=Apb(k[m>>2]|0,0,29)|0;e=kpb(e|0,N|0,g|0,0)|0;g=N;if(g>>>0>0|(g|0)==0&e>>>0>1e9){n=spb(e|0,g|0,1e9,0)|0;e=xpb(e|0,g|0,1e9,0)|0}else n=0;k[m>>2]=e;E=(j|0)==(h|0);x=(j|0)!=(x+127&127|0)|E?x:(e|0)==0?j:x;if(E)break;else{g=n;e=j+-1|0}}b=b+-29|0;if(n|0)break;else e=x}h=h+127&127;e=x+127&127;g=I+((x+126&127)<<2)|0;if((h|0)==(x|0))k[g>>2]=k[g>>2]|k[I+(e<<2)>>2];else e=x;k[I+(h<<2)>>2]=n;y=y+9|0}k:while(1){w=e+1&127;x=I+((e+127&127)<<2)|0;while(1){n=(g|0)==18;v=(g|0)>27?9:1;y=h;while(1){h=0;while(1){j=h+y&127;if((j|0)==(e|0)){G=2;A=236;break}j=k[I+(j<<2)>>2]|0;m=k[169240+(h<<2)>>2]|0;if(j>>>0<m>>>0){G=2;A=236;break}if(j>>>0>m>>>0)break;h=h+1|0;if((h|0)>=2){G=h;A=236;break}}if((A|0)==236?(A=0,n&(G|0)==2):0){d=0.0;j=0;break k}b=b+v|0;if((y|0)==(e|0))y=e;else break}n=(1<<v)+-1|0;s=1e9>>>v;m=0;h=y;j=y;do{B=I+(j<<2)|0;a=k[B>>2]|0;E=(a>>>v)+m|0;k[B>>2]=E;m=aa(a&n,s)|0;E=(j|0)==(h|0)&(E|0)==0;g=E?g+-9|0:g;h=E?h+1&127:h;j=j+1&127}while((j|0)!=(e|0));if(!m)continue;if((w|0)!=(h|0))break;k[x>>2]=k[x>>2]|1}k[I+(e<<2)>>2]=m;e=w}while(1){h=j+y&127;g=e+1&127;if((h|0)==(e|0))k[I+(g+-1<<2)>>2]=0;else g=e;d=d*1.0e9+ +((k[I+(h<<2)>>2]|0)>>>0);j=j+1|0;if((j|0)==2)break;else e=g}t=+(L|0);f=t*d;m=b+53|0;n=m-J|0;s=(n|0)<(K|0);e=s&1;j=s?((n|0)<0?0:n):K;if((j|0)<53){O=+Kfb(1.0,105-j|0);p[u>>3]=O;K=k[u>>2]|0;L=k[u+4>>2]|0;p[u>>3]=f;L=k[u+4>>2]&-2147483648|L&2147483647;k[u>>2]=K;k[u+4>>2]=L;O=+p[u>>3];o=+Lfb(f,+Kfb(1.0,53-j|0));q=O;d=o;o=O+(f-o)}else{q=0.0;d=0.0;o=f}h=y+2&127;do if((h|0)!=(g|0)){h=k[I+(h<<2)>>2]|0;do if(h>>>0>=5e8){if((h|0)!=5e8){d=t*.75+d;break}if((y+3&127|0)==(g|0)){d=t*.5+d;break}else{d=t*.75+d;break}}else{if((h|0)==0?(y+3&127|0)==(g|0):0)break;d=t*.25+d}while(0);if((53-j|0)>1){if(+Lfb(d,1.0)!=0.0){f=d;break}f=d+1.0}else f=d}else f=d;while(0);d=o+f-q;do if((m&2147483647|0)>(-2-F|0)){if(+P(+d)>=9007199254740992.0){d=d*.5;e=s&(j|0)==(n|0)?0:e;b=b+1|0}if((b+50|0)<=(H|0)?!(f!=0.0&(e|0)!=0):0)break;if(!(k[206783]|0))e=827176;else{e=(Fpb()|0)+64|0;e=k[e>>2]|0}k[e>>2]=34}while(0);d=+Kfb(d,b)}while(0);break a}default:{if(k[B>>2]|0)k[E>>2]=(k[E>>2]|0)+-1;if(!(k[206783]|0))b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}k[b>>2]=22;k[a+104>>2]=0;L=k[a+8>>2]|0;k[a+108>>2]=L-(k[E>>2]|0);k[B>>2]=L;d=0.0;break a}}}}while(0);if((A|0)==23){e=(k[B>>2]|0)==0;if(!e)k[E>>2]=(k[E>>2]|0)+-1;if((c|0)!=0&b>>>0>3)do{if(!e)k[E>>2]=(k[E>>2]|0)+-1;b=b+-1|0}while(b>>>0>3)}d=+(L|0)*D}while(0);r=M;return +d}function Jfb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;g=a+4|0;c=k[g>>2]|0;h=a+100|0;if(c>>>0<(k[h>>2]|0)>>>0){k[g>>2]=c+1;c=l[c>>0]|0}else c=Ffb(a)|0;switch(c|0){case 43:case 45:{d=(c|0)==45&1;c=k[g>>2]|0;if(c>>>0<(k[h>>2]|0)>>>0){k[g>>2]=c+1;c=l[c>>0]|0}else c=Ffb(a)|0;if((b|0)!=0&(c+-48|0)>>>0>9?(k[h>>2]|0)!=0:0)k[g>>2]=(k[g>>2]|0)+-1;break}default:d=0}if((c+-48|0)>>>0>9)if(!(k[h>>2]|0)){d=-2147483648;c=0}else{k[g>>2]=(k[g>>2]|0)+-1;d=-2147483648;c=0}else{f=0;do{f=c+-48+(f*10|0)|0;c=k[g>>2]|0;if(c>>>0<(k[h>>2]|0)>>>0){k[g>>2]=c+1;c=l[c>>0]|0}else c=Ffb(a)|0;e=(c+-48|0)>>>0<10}while(e&(f|0)<214748364);b=((f|0)<0)<<31>>31;if(e){e=f;do{b=Epb(e|0,b|0,10,0)|0;e=N;c=kpb(c|0,((c|0)<0)<<31>>31|0,-48,-1)|0;e=kpb(c|0,N|0,b|0,e|0)|0;b=N;c=k[g>>2]|0;if(c>>>0<(k[h>>2]|0)>>>0){k[g>>2]=c+1;c=l[c>>0]|0}else c=Ffb(a)|0}while((c+-48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&e>>>0<2061584302))}else e=f;if((c+-48|0)>>>0<10)do{c=k[g>>2]|0;if(c>>>0<(k[h>>2]|0)>>>0){k[g>>2]=c+1;c=l[c>>0]|0}else c=Ffb(a)|0}while((c+-48|0)>>>0<10);if(k[h>>2]|0)k[g>>2]=(k[g>>2]|0)+-1;h=(d|0)!=0;c=jpb(0,0,e|0,b|0)|0;d=h?N:b;c=h?c:e}N=d;return c|0}function Kfb(a,b){a=+a;b=b|0;var c=0;if((b|0)>1023){a=a*8988465674311579538646525.0e283;c=b+-1023|0;b=b+-2046|0;if((c|0)>1023){a=a*8988465674311579538646525.0e283;b=(b|0)>1023?1023:b}else b=c}else if((b|0)<-1022){a=a*2.2250738585072014e-308;c=b+1022|0;b=b+2044|0;if((c|0)<-1022){a=a*2.2250738585072014e-308;b=(b|0)<-1022?-1022:b}else b=c}b=Apb(b+1023|0,0,52)|0;c=N;k[u>>2]=b;k[u+4>>2]=c;return +(a*+p[u>>3])}function Lfb(a,b){a=+a;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;p[u>>3]=a;g=k[u>>2]|0;i=k[u+4>>2]|0;p[u>>3]=b;l=k[u>>2]|0;m=k[u+4>>2]|0;d=ppb(g|0,i|0,52)|0;d=d&2047;j=ppb(l|0,m|0,52)|0;j=j&2047;n=i&-2147483648;f=Apb(l|0,m|0,1)|0;h=N;a:do if(!((f|0)==0&(h|0)==0)?(e=m&2147483647,!(e>>>0>2146435072|(e|0)==2146435072&l>>>0>0|(d|0)==2047)):0){c=Apb(g|0,i|0,1)|0;e=N;if(!(e>>>0>h>>>0|(e|0)==(h|0)&c>>>0>f>>>0))return +((c|0)==(f|0)&(e|0)==(h|0)?a*0.0:a);if(!d){c=Apb(g|0,i|0,12)|0;e=N;if((e|0)>-1|(e|0)==-1&c>>>0>4294967295){d=0;do{d=d+-1|0;c=Apb(c|0,e|0,1)|0;e=N}while((e|0)>-1|(e|0)==-1&c>>>0>4294967295)}else d=0;g=Apb(g|0,i|0,1-d|0)|0;f=N}else f=i&1048575|1048576;if(!j){e=Apb(l|0,m|0,12)|0;h=N;if((h|0)>-1|(h|0)==-1&e>>>0>4294967295){c=0;do{c=c+-1|0;e=Apb(e|0,h|0,1)|0;h=N}while((h|0)>-1|(h|0)==-1&e>>>0>4294967295)}else c=0;l=Apb(l|0,m|0,1-c|0)|0;j=c;i=N}else i=m&1048575|1048576;e=jpb(g|0,f|0,l|0,i|0)|0;c=N;h=(c|0)>-1|(c|0)==-1&e>>>0>4294967295;b:do if((d|0)>(j|0)){while(1){if(h){if((e|0)==0&(c|0)==0)break}else{e=g;c=f}g=Apb(e|0,c|0,1)|0;f=N;d=d+-1|0;e=jpb(g|0,f|0,l|0,i|0)|0;c=N;h=(c|0)>-1|(c|0)==-1&e>>>0>4294967295;if((d|0)<=(j|0))break b}b=a*0.0;break a}while(0);if(h){if((e|0)==0&(c|0)==0){b=a*0.0;break}}else{c=f;e=g}if(c>>>0<1048576|(c|0)==1048576&e>>>0<0)do{e=Apb(e|0,c|0,1)|0;c=N;d=d+-1|0}while(c>>>0<1048576|(c|0)==1048576&e>>>0<0);if((d|0)>0){m=kpb(e|0,c|0,0,-1048576)|0;c=N;d=Apb(d|0,0,52)|0;c=c|N;d=m|d}else{d=ppb(e|0,c|0,1-d|0)|0;c=N}k[u>>2]=d;k[u+4>>2]=c|n;b=+p[u>>3]}else o=3;while(0);if((o|0)==3){b=a*b;b=b/b}return +b}function Mfb(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+112|0;d=g;e=d;f=e+108|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));h=d+4|0;k[h>>2]=a;e=d+8|0;k[e>>2]=-1;k[d+44>>2]=a;k[d+76>>2]=-1;k[d+104>>2]=0;f=d+108|0;k[f>>2]=~a;k[d+100>>2]=-1;c=+Ifb(d,2,1);d=(k[h>>2]|0)-(k[e>>2]|0)+(k[f>>2]|0)|0;if(b|0)k[b>>2]=d|0?a+d|0:a;r=g;return +c}function Nfb(a){a=+a;var b=0.0,c=0,d=0.0,e=0.0,f=0,g=0.0,h=0,i=0,j=0.0,l=0,m=0.0;p[u>>3]=a;f=k[u>>2]|0;c=k[u+4>>2]|0;j=(c|0)<0?-.5:.5;l=c&2147483647;k[u>>2]=f;k[u+4>>2]=l;b=+p[u>>3];do if(l>>>0<1082535490){c=c&2147483647;do if(c>>>0>1078159481){if(!(l>>>0>2146435072|(l|0)==2146435072&f>>>0>0))if(b>709.782712893384)b=b*8988465674311579538646525.0e283;else i=9}else{if(c>>>0<=1071001154)if(c>>>0<1016070144)break;else{g=0.0;h=0;i=12;break}if(c>>>0<1072734898){c=1;d=b+-.6931471803691238;e=1.9082149292705877e-10;i=10}else i=9}while(0);if((i|0)==9){c=~~(b*1.4426950408889634+.5);e=+(c|0);d=b-e*.6931471803691238;e=e*1.9082149292705877e-10;i=10}if((i|0)==10){g=d-e;b=g;g=d-g-e;h=c;i=12}a:do if((i|0)==12){e=b*.5;d=b*e;m=d*(d*(d*(d*(4.008217827329362e-06-d*2.0109921818362437e-07)+-7.93650757867488e-05)+1.5873015872548146e-03)+-.03333333333333313)+1.0;e=3.0-e*m;e=d*((m-e)/(6.0-b*e));if(!h){b=b-(b*e-d);break}d=b*(e-g)-g-d;switch(h|0){case -1:{b=(b-d)*.5+-.5;break a}case 1:if(b<-.25){b=(d-(b+.5))*-2.0;break a}else{b=(b-d)*2.0+1.0;break a}default:{f=Apb(h+1023|0,0,52)|0;i=N;k[u>>2]=f;k[u+4>>2]=i;e=+p[u>>3];if(h>>>0>56){b=b-d+1.0;b=((h|0)==1024?b*2.0*8988465674311579538646525.0e283:e*b)+-1.0;break a}c=Apb(1023-h|0,0,52)|0;f=N;if((h|0)<20){k[u>>2]=c;k[u+4>>2]=f;b=1.0-+p[u>>3]+(b-d)}else{k[u>>2]=c;k[u+4>>2]=f;b=b-(+p[u>>3]+d)+1.0}b=e*b;break a}}}while(0);if(l>>>0>=1072693248){a=j*(b+b/(b+1.0));break}if(l>>>0>=1045430272)a=j*(b*2.0-b*b/(b+1.0))}else a=j*2.0*(+Z(+(b+-1416.0996898839683))*2247116418577894884661631.0e283*2247116418577894884661631.0e283);while(0);return +a}function Ofb(a,b){a=+a;b=b|0;var c=0,d=0;c=(o[u>>2]=a,k[u>>2]|0);d=c>>>23;switch((d&255)<<24>>24){case 0:{if(a!=0.0){a=+Ofb(a*18446744073709551616.0,b);c=(k[b>>2]|0)+-64|0}else c=0;k[b>>2]=c;break}case -1:break;default:{k[b>>2]=(d&255)+-126;a=(k[u>>2]=c&-2139095041|1056964608,+o[u>>2])}}return +a}function Pfb(a){a=+a;var b=0,c=0,d=0,e=0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0;p[u>>3]=a;b=k[u>>2]|0;c=k[u+4>>2]|0;d=(c|0)<0;do if(d|c>>>0<1048576){if((b|0)==0&(c&2147483647|0)==0){a=-1.0/(a*a);break}if(d){a=(a-a)/0.0;break}else{p[u>>3]=a*18014398509481984.0;c=k[u+4>>2]|0;d=-1077;b=k[u>>2]|0;e=9;break}}else if(c>>>0<=2146435071)if((b|0)==0&0==0&(c|0)==1072693248)a=0.0;else{d=-1023;e=9}while(0);if((e|0)==9){e=c+614242|0;k[u>>2]=b;k[u+4>>2]=(e&1048575)+1072079006;h=+p[u>>3]+-1.0;g=h*(h*.5);i=h/(h+2.0);j=i*i;a=j*j;p[u>>3]=h-g;c=k[u+4>>2]|0;k[u>>2]=0;k[u+4>>2]=c;f=+p[u>>3];a=h-f-g+i*(g+(a*(a*(a*.15313837699209373+.22222198432149784)+.3999999999940942)+j*(a*(a*(a*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)));j=f*.4342944818781689;g=+(d+(e>>>20)|0);i=g*.30102999566361177;h=i+j;a=h+(j+(i-h)+(a*.4342944818781689+(g*3.694239077158931e-13+(f+a)*2.5082946711645275e-11)))}return +a}function Qfb(a){a=a|0;var b=0,c=0,d=0;d=(k[a>>2]&1|0)!=0;if(!d){nd(827160);c=k[a+52>>2]|0;b=a+56|0;if(c|0)k[c+56>>2]=k[b>>2];b=k[b>>2]|0;if(b|0)k[b+52>>2]=c;if((k[206789]|0)==(a|0))k[206789]=b;wf(827160)}b=Rfb(a)|0;b=Xh[k[a+12>>2]&1023](a)|0|b;c=k[a+92>>2]|0;if(c|0)ggb(c);if(!d)ggb(a);return b|0}function Rfb(a){a=a|0;var b=0;if(!a){if(!(k[41477]|0))a=0;else a=Rfb(k[41477]|0)|0;nd(827160);b=k[206789]|0;if(b)do{if((k[b+20>>2]|0)>>>0>(k[b+28>>2]|0)>>>0)a=Sfb(b)|0|a;b=k[b+56>>2]|0}while((b|0)!=0);wf(827160)}else a=Sfb(a)|0;return a|0}function Sfb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=a+20|0;g=a+28|0;if((k[b>>2]|0)>>>0>(k[g>>2]|0)>>>0?(ci[k[a+36>>2]&255](a,0,0)|0,(k[b>>2]|0)==0):0)a=-1;else{c=a+4|0;d=k[c>>2]|0;e=a+8|0;f=k[e>>2]|0;if(d>>>0<f>>>0)ci[k[a+40>>2]&255](a,d-f|0,1)|0;k[a+16>>2]=0;k[g>>2]=0;k[b>>2]=0;k[e>>2]=0;k[c>>2]=0;a=0}return a|0}function Tfb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+112|0;m=n+40|0;j=n+24|0;h=n+16|0;e=n;l=n+52|0;d=i[b>>0]|0;if(sfb(423836,d<<24>>24,4)|0){c=fgb(1144)|0;if(!c)c=0;else{f=c;g=f+112|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));if(!(Afb(b,43)|0))k[c>>2]=d<<24>>24==114?8:4;if(Afb(b,101)|0){k[e>>2]=a;k[e+4>>2]=2;k[e+8>>2]=1;Vc(221,e|0)|0;d=i[b>>0]|0}if(d<<24>>24==97){k[h>>2]=a;k[h+4>>2]=3;d=Vc(221,h|0)|0;if(!(d&1024)){k[j>>2]=a;k[j+4>>2]=4;k[j+8>>2]=d|1024;Vc(221,j|0)|0}b=k[c>>2]|128;k[c>>2]=b}else b=k[c>>2]|0;k[c+60>>2]=a;k[c+44>>2]=c+120;k[c+48>>2]=1024;d=c+75|0;i[d>>0]=-1;if((b&8|0)==0?(k[m>>2]=a,k[m+4>>2]=21505,k[m+8>>2]=l,(pe(54,m|0)|0)==0):0)i[d>>0]=10;k[c+32>>2]=32;k[c+36>>2]=35;k[c+40>>2]=33;k[c+12>>2]=324;if(!(k[206784]|0))k[c+76>>2]=-1;nd(827160);d=k[206789]|0;k[c+56>>2]=d;if(d|0)k[d+52>>2]=c;k[206789]=c;wf(827160)}}else{if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=22;c=0}r=n;return c|0}function Ufb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=r;r=r+32|0;e=f+16|0;d=f;c=i[b>>0]|0;do if(sfb(423836,c<<24>>24,4)|0){g=(Afb(b,43)|0)==0;g=g?c<<24>>24!=114&1:2;h=(Afb(b,120)|0)==0;g=h?g:g|128;h=(Afb(b,101)|0)==0;g=h?g:g|524288;g=c<<24>>24==114?g:g|64;g=c<<24>>24==119?g|512:g;k[d>>2]=a;k[d+4>>2]=(c<<24>>24==97?g|1024:g)|32768;k[d+8>>2]=438;c=fe(5,d|0)|0;if(c>>>0>4294963200){if(!(k[206783]|0))a=827176;else{a=(Fpb()|0)+64|0;a=k[a>>2]|0}k[a>>2]=0-c;a=0;break}else{if((c|0)<0){a=0;break}a=Tfb(c,b)|0;if(a|0)break;k[e>>2]=c;ee(6,e|0)|0;a=0;break}}else{if(!(k[206783]|0))a=827176;else{a=(Fpb()|0)+64|0;a=k[a>>2]|0}k[a>>2]=22;a=0}while(0);r=f;return a|0}function Vfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0;d=b+-1|0;a:do if((b|0)<2){c=c+74|0;j=i[c>>0]|0;i[c>>0]=j+255|j;if(!d)i[a>>0]=0;else a=0}else{b:do if(d){h=c+4|0;j=c+8|0;b=a;while(1){e=k[h>>2]|0;m=e;n=(k[j>>2]|0)-m|0;f=sfb(e,10,n)|0;g=(f|0)==0;f=g?n:1-m+f|0;f=f>>>0<d>>>0?f:d;upb(b|0,e|0,f|0)|0;e=(k[h>>2]|0)+f|0;k[h>>2]=e;b=b+f|0;f=d-f|0;if(!(g&(f|0)!=0))break b;if(e>>>0>=(k[j>>2]|0)>>>0){d=Gfb(c)|0;if((d|0)<0)break;else g=d}else{k[h>>2]=e+1;g=l[e>>0]|0}d=f+-1|0;e=b+1|0;i[b>>0]=g;if(!((d|0)!=0&(g&255|0)!=10)){b=e;break b}else b=e}if((b|0)==(a|0)){a=0;break a}if(!(k[c>>2]&16)){a=0;break a}}else b=a;while(0);if(!a)a=0;else i[b>>0]=0}while(0);return a|0}function Wfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;k[e>>2]=c;c=Xfb(a,b,e)|0;r=d;return c|0}function Xfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0.0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0;R=r;r=r+416|0;J=R+128|0;K=R+120|0;L=R+145|0;M=R+112|0;O=R+144|0;P=R;d=P;e=d+112|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[P+32>>2]=152;k[P+44>>2]=a;k[P+76>>2]=-1;k[P+84>>2]=a;f=i[b>>0]|0;a:do if(f<<24>>24){z=P+4|0;A=P+100|0;B=P+108|0;C=P+8|0;D=L+10|0;E=L+33|0;y=K+4|0;F=L+46|0;G=L+94|0;H=L+1|0;I=P+104|0;u=0;a=0;e=0;d=0;b:while(1){c:do if(f<<24>>24==32|((f&255)+-9|0)>>>0<5){while(1){f=b+1|0;x=i[f>>0]|0;if(x<<24>>24==32|((x&255)+-9|0)>>>0<5)b=f;else break}k[I>>2]=0;g=k[C>>2]|0;f=k[z>>2]|0;k[B>>2]=g-f;k[A>>2]=g;d:while(1){if(f>>>0<g>>>0){k[z>>2]=f+1;f=l[f>>0]|0}else f=Ffb(P)|0;switch(f|0){case 9:case 10:case 11:case 12:case 13:case 32:break;default:break d}f=k[z>>2]|0;g=k[A>>2]|0}if(!(k[A>>2]|0))f=k[z>>2]|0;else{f=(k[z>>2]|0)+-1|0;k[z>>2]=f}g=(k[B>>2]|0)+u+f-(k[C>>2]|0)|0}else{f=f<<24>>24==37;e:do if(f){m=b+1|0;g=i[m>>0]|0;f:do switch(g<<24>>24){case 37:break e;case 42:{g=0;b=b+2|0;break}default:{f=(g&255)+-48|0;if(f>>>0<10?(i[b+2>>0]|0)==36:0){k[J>>2]=k[c>>2];while(1){x=(k[J>>2]|0)+(4-1)&~(4-1);g=k[x>>2]|0;k[J>>2]=x+4;if(f>>>0>1)f=f+-1|0;else break}b=b+3|0;break f}b=(k[c>>2]|0)+(4-1)&~(4-1);g=k[b>>2]|0;k[c>>2]=b+4;b=m}}while(0);f=i[b>>0]|0;m=f&255;if((m+-48|0)>>>0<10){n=0;do{n=(n*10|0)+-48+m|0;b=b+1|0;f=i[b>>0]|0;m=f&255}while((m+-48|0)>>>0<10);q=b}else{n=0;q=b}if(f<<24>>24==109){f=q+1|0;b=(g|0)!=0&1;e=0;d=0;q=f;f=i[f>>0]|0}else b=0;m=q+1|0;switch(f<<24>>24){case 104:{x=(i[m>>0]|0)==104;f=x?-2:-1;m=x?q+2|0:m;break}case 108:{x=(i[m>>0]|0)==108;f=x?3:1;m=x?q+2|0:m;break}case 106:{f=3;break}case 116:case 122:{f=1;break}case 76:{f=2;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{f=0;m=q;break}default:{Q=157;break b}}t=l[m>>0]|0;v=(t&47|0)==3;t=v?t|32:t;v=v?1:f;s=t&255;switch(s<<24>>24){case 99:{n=(n|0)<1?1:n;x=u;break}case 91:{x=u;break}case 110:{if(!g){b=m;g=u;break c}switch(v|0){case -2:{i[g>>0]=u;b=m;g=u;break c}case -1:{j[g>>1]=u;b=m;g=u;break c}case 0:{k[g>>2]=u;b=m;g=u;break c}case 1:{k[g>>2]=u;b=m;g=u;break c}case 3:{b=g;k[b>>2]=u;k[b+4>>2]=((u|0)<0)<<31>>31;b=m;g=u;break c}default:{b=m;g=u;break c}}}default:{k[I>>2]=0;q=k[C>>2]|0;f=k[z>>2]|0;k[B>>2]=q-f;k[A>>2]=q;g:while(1){if(f>>>0<q>>>0){k[z>>2]=f+1;f=l[f>>0]|0}else f=Ffb(P)|0;switch(f|0){case 9:case 10:case 11:case 12:case 13:case 32:break;default:break g}f=k[z>>2]|0;q=k[A>>2]|0}if(!(k[A>>2]|0))f=k[z>>2]|0;else{f=(k[z>>2]|0)+-1|0;k[z>>2]=f}x=(k[B>>2]|0)+u+f-(k[C>>2]|0)|0}}k[I>>2]=n;f=k[C>>2]|0;q=k[z>>2]|0;w=f-q|0;k[B>>2]=w;if((n|0)!=0&(w|0)>(n|0)){f=q+n|0;k[A>>2]=f}else k[A>>2]=f;if(q>>>0<f>>>0)k[z>>2]=q+1;else{if((Ffb(P)|0)<0){Q=157;break b}f=k[A>>2]|0}if(f|0)k[z>>2]=(k[z>>2]|0)+-1;h:do switch(s<<24>>24){case 91:case 99:case 115:{w=(t|0)==99;i:do if((t|16|0)==115){zpb(H|0,-1,256)|0;i[L>>0]=0;if((t|0)==115){i[E>>0]=0;i[D>>0]=0;i[D+1>>0]=0;i[D+2>>0]=0;i[D+3>>0]=0;i[D+4>>0]=0}}else{t=m+1|0;u=(i[t>>0]|0)==94;q=u&1;m=u?m+2|0:t;zpb(H|0,u&1|0,256)|0;i[L>>0]=0;switch(i[m>>0]|0){case 45:{u=(q^1)&255;i[F>>0]=u;m=m+1|0;break}case 93:{u=(q^1)&255;i[G>>0]=u;m=m+1|0;break}default:u=(q^1)&255}while(1){q=i[m>>0]|0;j:do switch(q<<24>>24){case 0:{Q=157;break b}case 93:break i;case 45:{t=m+1|0;q=i[t>>0]|0;switch(q<<24>>24){case 93:case 0:{q=45;break j}default:{}}m=i[m+-1>>0]|0;if((m&255)<(q&255)){s=q&255;m=m&255;do{m=m+1|0;i[L+m>>0]=u}while((m|0)!=(s|0));m=t}else m=t;break}default:{}}while(0);i[L+((q&255)+1)>>0]=u;m=m+1|0}}while(0);q=w?n+1|0:31;t=(v|0)==1;u=(b|0)!=0;k:do if(t){if(u){e=fgb(q<<2)|0;if(!e){d=0;Q=157;break b}}else e=g;k[K>>2]=0;k[y>>2]=0;d=0;l:while(1){s=(e|0)==0;do{m:while(1){f=k[z>>2]|0;if(f>>>0<(k[A>>2]|0)>>>0){k[z>>2]=f+1;f=l[f>>0]|0}else f=Ffb(P)|0;if(!(i[L+(f+1)>>0]|0))break l;i[O>>0]=f;switch(ifb(M,O,1,K)|0){case -1:{d=0;Q=157;break b}case -2:break;default:break m}}if(!s){k[e+(d<<2)>>2]=k[M>>2];d=d+1|0}}while(!(u&(d|0)==(q|0)));d=q<<1|1;f=hgb(e,d<<2)|0;if(!f){d=0;Q=157;break b}else{v=q;q=d;e=f;d=v}}if(!(k[K>>2]|0)){q=d;d=0}else{d=0;Q=157;break b}}else{if(u){d=fgb(q)|0;if(!d){d=0;e=0;Q=157;break b}else e=0;while(1){do{f=k[z>>2]|0;if(f>>>0<(k[A>>2]|0)>>>0){k[z>>2]=f+1;f=l[f>>0]|0}else f=Ffb(P)|0;if(!(i[L+(f+1)>>0]|0)){q=e;e=0;break k}i[d+e>>0]=f;e=e+1|0}while((e|0)!=(q|0));e=q<<1|1;f=hgb(d,e)|0;if(!f){e=0;Q=157;break b}else{v=q;q=e;d=f;e=v}}}if(!g){e=f;while(1){d=k[z>>2]|0;if(d>>>0<e>>>0){k[z>>2]=d+1;d=l[d>>0]|0}else d=Ffb(P)|0;if(!(i[L+(d+1)>>0]|0)){q=0;d=0;e=0;break k}e=k[A>>2]|0}}else{q=0;e=f;while(1){d=k[z>>2]|0;if(d>>>0<e>>>0){k[z>>2]=d+1;d=l[d>>0]|0}else d=Ffb(P)|0;if(!(i[L+(d+1)>>0]|0)){d=g;e=0;break k}i[g+q>>0]=d;q=q+1|0;e=k[A>>2]|0}}}while(0);if(!(k[A>>2]|0))f=k[z>>2]|0;else{f=(k[z>>2]|0)+-1|0;k[z>>2]=f}f=f-(k[C>>2]|0)+(k[B>>2]|0)|0;if(!f)break b;if(!((f|0)==(n|0)|w^1))break b;do if(u)if(t){k[g>>2]=e;break}else{k[g>>2]=d;break}while(0);if(w)b=m;else{if(e|0)k[e+(q<<2)>>2]=0;if(!d){b=m;d=0;break h}i[d+q>>0]=0;b=m}break}case 120:case 88:case 112:{f=16;Q=139;break}case 111:{f=8;Q=139;break}case 117:case 100:{f=10;Q=139;break}case 105:{f=0;Q=139;break}case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{h=+Ifb(P,v,0);if((k[B>>2]|0)==((k[C>>2]|0)-(k[z>>2]|0)|0))break b;if(!g)b=m;else switch(v|0){case 0:{o[g>>2]=h;b=m;break h}case 1:{p[g>>3]=h;b=m;break h}case 2:{p[g>>3]=h;b=m;break h}default:{b=m;break h}}break}default:b=m}while(0);n:do if((Q|0)==139){Q=0;f=Efb(P,f,0,-1,-1)|0;if((k[B>>2]|0)==((k[C>>2]|0)-(k[z>>2]|0)|0))break b;if((g|0)!=0&(t|0)==112){k[g>>2]=f;b=m;break}if(!g)b=m;else switch(v|0){case -2:{i[g>>0]=f;b=m;break n}case -1:{j[g>>1]=f;b=m;break n}case 0:{k[g>>2]=f;b=m;break n}case 1:{k[g>>2]=f;b=m;break n}case 3:{b=g;k[b>>2]=f;k[b+4>>2]=N;b=m;break n}default:{b=m;break n}}}while(0);a=((g|0)!=0&1)+a|0;g=(k[B>>2]|0)+x+(k[z>>2]|0)-(k[C>>2]|0)|0;break c}while(0);b=b+(f&1)|0;k[I>>2]=0;x=k[C>>2]|0;f=k[z>>2]|0;k[B>>2]=x-f;k[A>>2]=x;if(f>>>0<x>>>0){k[z>>2]=f+1;f=l[f>>0]|0}else f=Ffb(P)|0;if((f|0)!=(l[b>>0]|0)){Q=21;break b}g=u+1|0}while(0);b=b+1|0;f=i[b>>0]|0;if(!(f<<24>>24))break a;else u=g}if((Q|0)==21){if(k[A>>2]|0)k[z>>2]=(k[z>>2]|0)+-1;if((a|0)!=0|(f|0)>-1)break;else{b=0;a=e;Q=158}}else if((Q|0)==157)if(!a){a=e;Q=158}if((Q|0)==158){e=a;a=-1}if(b){ggb(d);ggb(e)}}else a=0;while(0);r=R;return a|0}function Yfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=a+84|0;f=k[d>>2]|0;g=c+256|0;e=sfb(f,0,g)|0;e=(e|0)==0?g:e-f|0;c=e>>>0<c>>>0?e:c;upb(b|0,f|0,c|0)|0;k[a+4>>2]=f+c;b=f+e|0;k[a+8>>2]=b;k[d>>2]=b;return c|0}function Zfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=r;r=r+16|0;e=d;k[e>>2]=c;c=mfb(a,b,e)|0;r=d;return c|0}function _fb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;h=aa(c,b)|0;e=d+74|0;g=i[e>>0]|0;i[e>>0]=g+255|g;e=d+4|0;g=k[e>>2]|0;f=(k[d+8>>2]|0)-g|0;if((f|0)>0){f=f>>>0<h>>>0?f:h;upb(a|0,g|0,f|0)|0;k[e>>2]=g+f;e=h-f|0;a=a+f|0}else e=h;a:do if(e){g=d+32|0;while(1){if(Hfb(d)|0)break;f=ci[k[g>>2]&255](d,a,e)|0;if((f+1|0)>>>0<2)break;e=e-f|0;if(!e)break a;else a=a+f|0}c=((h-e|0)>>>0)/(b>>>0)|0}while(0);return c|0}function $fb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;g=j;h=b&255;i[g>>0]=h;d=a+16|0;e=k[d>>2]|0;if(!e)if(!(vfb(a)|0)){e=k[d>>2]|0;f=4}else c=-1;else f=4;do if((f|0)==4){f=a+20|0;d=k[f>>2]|0;if(d>>>0<e>>>0?(c=b&255,(c|0)!=(i[a+75>>0]|0)):0){k[f>>2]=d+1;i[d>>0]=h;break}if((ci[k[a+36>>2]&255](a,g,1)|0)==1)c=l[g>>0]|0;else c=-1}while(0);r=j;return c|0}function agb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=(i[b+75>>0]|0)==(a|0);do if((k[b+76>>2]|0)<0){if(!f?(g=b+20|0,c=k[g>>2]|0,c>>>0<(k[b+16>>2]|0)>>>0):0){k[g>>2]=c+1;i[c>>0]=a;break}$fb(b,a)|0}else{if(!f?(d=b+20|0,e=k[d>>2]|0,e>>>0<(k[b+16>>2]|0)>>>0):0){k[d>>2]=e+1;i[e>>0]=a;break}$fb(b,a)|0}while(0);return}function bgb(a,b){a=a|0;b=b|0;var c=0,d=0;do if((a|0)!=-1){if((k[b+8>>2]|0)==0?Hfb(b)|0:0){a=-1;break}c=b+4|0;d=k[c>>2]|0;if(d>>>0>((k[b+44>>2]|0)+-8|0)>>>0){d=d+-1|0;k[c>>2]=d;i[d>>0]=a;k[b>>2]=k[b>>2]&-17}else a=-1}else a=-1;while(0);return a|0}function cgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=aa(c,b)|0;a=ofb(a,e,d)|0;if((a|0)!=(e|0))c=(a>>>0)/(b>>>0)|0;return c|0}function dgb(a,b){a=a|0;b=b|0;var c=0;a=r;r=r+16|0;c=a;k[c>>2]=b;mfb(165796,356241,c)|0;r=a;return}function egb(a){a=a|0;var b=0,c=0,d=0;b=a+4|0;c=k[b>>2]|0;d=c>>>0<(k[a+8>>2]|0)>>>0;do if((k[a+76>>2]|0)<0)if(d){k[b>>2]=c+1;a=l[c>>0]|0;break}else{a=Gfb(a)|0;break}else if(d){k[b>>2]=c+1;a=l[c>>0]|0;break}else{a=Gfb(a)|0;break}while(0);return a|0}function fgb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;L=r;r=r+16|0;o=L;do if(a>>>0<245){n=a>>>0<11?16:a+11&-8;a=n>>>3;t=k[206799]|0;c=t>>>a;if(c&3|0){a=(c&1^1)+a|0;c=827236+(a<<1<<2)|0;d=c+8|0;e=k[d>>2]|0;f=e+8|0;g=k[f>>2]|0;do if((c|0)!=(g|0)){if(g>>>0<(k[206803]|0)>>>0)Ne();b=g+12|0;if((k[b>>2]|0)==(e|0)){k[b>>2]=c;k[d>>2]=g;break}else Ne()}else k[206799]=t&~(1<<a);while(0);K=a<<3;k[e+4>>2]=K|3;K=e+K+4|0;k[K>>2]=k[K>>2]|1;K=f;r=L;return K|0}s=k[206801]|0;if(n>>>0>s>>>0){if(c|0){h=2<<a;a=c<<a&(h|0-h);a=(a&0-a)+-1|0;h=a>>>12&16;a=a>>>h;d=a>>>5&8;a=a>>>d;f=a>>>2&4;a=a>>>f;c=a>>>1&2;a=a>>>c;b=a>>>1&1;b=(d|h|f|c|b)+(a>>>b)|0;a=827236+(b<<1<<2)|0;c=a+8|0;f=k[c>>2]|0;h=f+8|0;d=k[h>>2]|0;do if((a|0)!=(d|0)){if(d>>>0<(k[206803]|0)>>>0)Ne();e=d+12|0;if((k[e>>2]|0)==(f|0)){k[e>>2]=a;k[c>>2]=d;i=t;break}else Ne()}else{i=t&~(1<<b);k[206799]=i}while(0);g=(b<<3)-n|0;k[f+4>>2]=n|3;d=f+n|0;k[d+4>>2]=g|1;k[d+g>>2]=g;if(s|0){e=k[206804]|0;b=s>>>3;c=827236+(b<<1<<2)|0;b=1<<b;if(i&b){b=c+8|0;a=k[b>>2]|0;if(a>>>0<(k[206803]|0)>>>0)Ne();else{j=a;l=b}}else{k[206799]=i|b;j=c;l=c+8|0}k[l>>2]=e;k[j+12>>2]=e;k[e+8>>2]=j;k[e+12>>2]=c}k[206801]=g;k[206804]=d;K=h;r=L;return K|0}j=k[206800]|0;if(j){a=(j&0-j)+-1|0;J=a>>>12&16;a=a>>>J;I=a>>>5&8;a=a>>>I;K=a>>>2&4;a=a>>>K;h=a>>>1&2;a=a>>>h;i=a>>>1&1;i=k[827500+((I|J|K|h|i)+(a>>>i)<<2)>>2]|0;a=i;h=i;i=(k[i+4>>2]&-8)-n|0;while(1){b=k[a+16>>2]|0;if(!b){b=k[a+20>>2]|0;if(!b)break}K=(k[b+4>>2]&-8)-n|0;J=K>>>0<i>>>0;a=b;h=J?b:h;i=J?K:i}e=k[206803]|0;if(h>>>0<e>>>0)Ne();g=h+n|0;if(h>>>0>=g>>>0)Ne();f=k[h+24>>2]|0;c=k[h+12>>2]|0;do if((c|0)==(h|0)){a=h+20|0;b=k[a>>2]|0;if(!b){a=h+16|0;b=k[a>>2]|0;if(!b){m=0;break}}while(1){c=b+20|0;d=k[c>>2]|0;if(d|0){b=d;a=c;continue}c=b+16|0;d=k[c>>2]|0;if(!d)break;else{b=d;a=c}}if(a>>>0<e>>>0)Ne();else{k[a>>2]=0;m=b;break}}else{d=k[h+8>>2]|0;if(d>>>0<e>>>0)Ne();b=d+12|0;if((k[b>>2]|0)!=(h|0))Ne();a=c+8|0;if((k[a>>2]|0)==(h|0)){k[b>>2]=c;k[a>>2]=d;m=c;break}else Ne()}while(0);do if(f|0){b=k[h+28>>2]|0;a=827500+(b<<2)|0;if((h|0)==(k[a>>2]|0)){k[a>>2]=m;if(!m){k[206800]=j&~(1<<b);break}}else{if(f>>>0<(k[206803]|0)>>>0)Ne();b=f+16|0;if((k[b>>2]|0)==(h|0))k[b>>2]=m;else k[f+20>>2]=m;if(!m)break}a=k[206803]|0;if(m>>>0<a>>>0)Ne();k[m+24>>2]=f;b=k[h+16>>2]|0;do if(b|0)if(b>>>0<a>>>0)Ne();else{k[m+16>>2]=b;k[b+24>>2]=m;break}while(0);b=k[h+20>>2]|0;if(b|0)if(b>>>0<(k[206803]|0)>>>0)Ne();else{k[m+20>>2]=b;k[b+24>>2]=m;break}}while(0);if(i>>>0<16){K=i+n|0;k[h+4>>2]=K|3;K=h+K+4|0;k[K>>2]=k[K>>2]|1}else{k[h+4>>2]=n|3;k[g+4>>2]=i|1;k[g+i>>2]=i;if(s|0){d=k[206804]|0;b=s>>>3;c=827236+(b<<1<<2)|0;b=1<<b;if(t&b){b=c+8|0;a=k[b>>2]|0;if(a>>>0<(k[206803]|0)>>>0)Ne();else{p=a;q=b}}else{k[206799]=t|b;p=c;q=c+8|0}k[q>>2]=d;k[p+12>>2]=d;k[d+8>>2]=p;k[d+12>>2]=c}k[206801]=i;k[206804]=g}K=h+8|0;r=L;return K|0}}}else if(a>>>0<=4294967231){a=a+11|0;n=a&-8;j=k[206800]|0;if(j){d=0-n|0;a=a>>>8;if(a)if(n>>>0>16777215)i=31;else{q=(a+1048320|0)>>>16&8;D=a<<q;p=(D+520192|0)>>>16&4;D=D<<p;i=(D+245760|0)>>>16&2;i=14-(p|q|i)+(D<<i>>>15)|0;i=n>>>(i+7|0)&1|i<<1}else i=0;a=k[827500+(i<<2)>>2]|0;a:do if(!a){c=0;e=0;D=86}else{e=0;h=a;g=n<<((i|0)==31?0:25-(i>>>1)|0);c=0;while(1){a=(k[h+4>>2]&-8)-n|0;if(a>>>0<d>>>0)if(!a){a=h;d=0;c=h;D=90;break a}else{e=h;d=a}a=k[h+20>>2]|0;h=k[h+16+(g>>>31<<2)>>2]|0;c=(a|0)==0|(a|0)==(h|0)?c:a;a=(h|0)==0;if(a){D=86;break}else g=g<<(a&1^1)}}while(0);if((D|0)==86){if((c|0)==0&(e|0)==0){a=2<<i;a=j&(a|0-a);if(!a)break;q=(a&0-a)+-1|0;l=q>>>12&16;q=q>>>l;i=q>>>5&8;q=q>>>i;m=q>>>2&4;q=q>>>m;p=q>>>1&2;q=q>>>p;c=q>>>1&1;c=k[827500+((i|l|m|p|c)+(q>>>c)<<2)>>2]|0}if(!c){i=e;h=d}else{a=e;D=90}}if((D|0)==90)while(1){D=0;q=(k[c+4>>2]&-8)-n|0;e=q>>>0<d>>>0;d=e?q:d;a=e?c:a;e=k[c+16>>2]|0;if(e|0){c=e;D=90;continue}c=k[c+20>>2]|0;if(!c){i=a;h=d;break}else D=90}if((i|0)!=0?h>>>0<((k[206801]|0)-n|0)>>>0:0){e=k[206803]|0;if(i>>>0<e>>>0)Ne();g=i+n|0;if(i>>>0>=g>>>0)Ne();f=k[i+24>>2]|0;c=k[i+12>>2]|0;do if((c|0)==(i|0)){a=i+20|0;b=k[a>>2]|0;if(!b){a=i+16|0;b=k[a>>2]|0;if(!b){s=0;break}}while(1){c=b+20|0;d=k[c>>2]|0;if(d|0){b=d;a=c;continue}c=b+16|0;d=k[c>>2]|0;if(!d)break;else{b=d;a=c}}if(a>>>0<e>>>0)Ne();else{k[a>>2]=0;s=b;break}}else{d=k[i+8>>2]|0;if(d>>>0<e>>>0)Ne();b=d+12|0;if((k[b>>2]|0)!=(i|0))Ne();a=c+8|0;if((k[a>>2]|0)==(i|0)){k[b>>2]=c;k[a>>2]=d;s=c;break}else Ne()}while(0);do if(f){b=k[i+28>>2]|0;a=827500+(b<<2)|0;if((i|0)==(k[a>>2]|0)){k[a>>2]=s;if(!s){t=j&~(1<<b);k[206800]=t;break}}else{if(f>>>0<(k[206803]|0)>>>0)Ne();b=f+16|0;if((k[b>>2]|0)==(i|0))k[b>>2]=s;else k[f+20>>2]=s;if(!s){t=j;break}}a=k[206803]|0;if(s>>>0<a>>>0)Ne();k[s+24>>2]=f;b=k[i+16>>2]|0;do if(b|0)if(b>>>0<a>>>0)Ne();else{k[s+16>>2]=b;k[b+24>>2]=s;break}while(0);b=k[i+20>>2]|0;if(b)if(b>>>0<(k[206803]|0)>>>0)Ne();else{k[s+20>>2]=b;k[b+24>>2]=s;t=j;break}else t=j}else t=j;while(0);do if(h>>>0>=16){k[i+4>>2]=n|3;k[g+4>>2]=h|1;k[g+h>>2]=h;b=h>>>3;if(h>>>0<256){c=827236+(b<<1<<2)|0;a=k[206799]|0;b=1<<b;if(a&b){b=c+8|0;a=k[b>>2]|0;if(a>>>0<(k[206803]|0)>>>0)Ne();else{B=a;C=b}}else{k[206799]=a|b;B=c;C=c+8|0}k[C>>2]=g;k[B+12>>2]=g;k[g+8>>2]=B;k[g+12>>2]=c;break}b=h>>>8;if(b)if(h>>>0>16777215)b=31;else{J=(b+1048320|0)>>>16&8;K=b<<J;I=(K+520192|0)>>>16&4;K=K<<I;b=(K+245760|0)>>>16&2;b=14-(I|J|b)+(K<<b>>>15)|0;b=h>>>(b+7|0)&1|b<<1}else b=0;c=827500+(b<<2)|0;k[g+28>>2]=b;a=g+16|0;k[a+4>>2]=0;k[a>>2]=0;a=1<<b;if(!(t&a)){k[206800]=t|a;k[c>>2]=g;k[g+24>>2]=c;k[g+12>>2]=g;k[g+8>>2]=g;break}a=h<<((b|0)==31?0:25-(b>>>1)|0);d=k[c>>2]|0;while(1){if((k[d+4>>2]&-8|0)==(h|0)){D=148;break}c=d+16+(a>>>31<<2)|0;b=k[c>>2]|0;if(!b){D=145;break}else{a=a<<1;d=b}}if((D|0)==145)if(c>>>0<(k[206803]|0)>>>0)Ne();else{k[c>>2]=g;k[g+24>>2]=d;k[g+12>>2]=g;k[g+8>>2]=g;break}else if((D|0)==148){b=d+8|0;a=k[b>>2]|0;K=k[206803]|0;if(a>>>0>=K>>>0&d>>>0>=K>>>0){k[a+12>>2]=g;k[b>>2]=g;k[g+8>>2]=a;k[g+12>>2]=d;k[g+24>>2]=0;break}else Ne()}}else{K=h+n|0;k[i+4>>2]=K|3;K=i+K+4|0;k[K>>2]=k[K>>2]|1}while(0);K=i+8|0;r=L;return K|0}}}else n=-1;while(0);c=k[206801]|0;if(c>>>0>=n>>>0){b=c-n|0;a=k[206804]|0;if(b>>>0>15){K=a+n|0;k[206804]=K;k[206801]=b;k[K+4>>2]=b|1;k[K+b>>2]=b;k[a+4>>2]=n|3}else{k[206801]=0;k[206804]=0;k[a+4>>2]=c|3;K=a+c+4|0;k[K>>2]=k[K>>2]|1}K=a+8|0;r=L;return K|0}h=k[206802]|0;if(h>>>0>n>>>0){I=h-n|0;k[206802]=I;K=k[206805]|0;J=K+n|0;k[206805]=J;k[J+4>>2]=I|1;k[K+4>>2]=n|3;K=K+8|0;r=L;return K|0}if(!(k[206917]|0)){k[206919]=4096;k[206918]=4096;k[206920]=-1;k[206921]=-1;k[206922]=0;k[206910]=0;a=o&-16^1431655768;k[o>>2]=a;k[206917]=a;a=4096}else a=k[206919]|0;i=n+48|0;j=n+47|0;g=a+j|0;e=0-a|0;l=g&e;if(l>>>0<=n>>>0){K=0;r=L;return K|0}a=k[206909]|0;if(a|0?(B=k[206907]|0,C=B+l|0,C>>>0<=B>>>0|C>>>0>a>>>0):0){K=0;r=L;return K|0}b:do if(!(k[206910]&4)){c=k[206805]|0;c:do if(c){d=827644;while(1){a=k[d>>2]|0;if(a>>>0<=c>>>0?(u=d+4|0,(a+(k[u>>2]|0)|0)>>>0>c>>>0):0)break;a=k[d+8>>2]|0;if(!a){D=172;break c}else d=a}c=g-h&e;if(c>>>0<2147483647){a=vpb(c|0)|0;if((a|0)==((k[d>>2]|0)+(k[u>>2]|0)|0)){if((a|0)!=(-1|0)){g=c;f=a;D=190;break b}}else{b=c;D=180}}}else D=172;while(0);do if(((D|0)==172?(f=vpb(0)|0,(f|0)!=(-1|0)):0)?(b=f,v=k[206918]|0,w=v+-1|0,b=((w&b|0)==0?0:(w+b&0-v)-b|0)+l|0,v=k[206907]|0,w=b+v|0,b>>>0>n>>>0&b>>>0<2147483647):0){C=k[206909]|0;if(C|0?w>>>0<=v>>>0|w>>>0>C>>>0:0)break;a=vpb(b|0)|0;if((a|0)==(f|0)){g=b;D=190;break b}else D=180}while(0);d:do if((D|0)==180){c=0-b|0;do if(i>>>0>b>>>0&(b>>>0<2147483647&(a|0)!=(-1|0))?(x=k[206919]|0,x=j-b+x&0-x,x>>>0<2147483647):0)if((vpb(x|0)|0)==(-1|0)){vpb(c|0)|0;break d}else{b=x+b|0;break}while(0);if((a|0)!=(-1|0)){g=b;f=a;D=190;break b}}while(0);k[206910]=k[206910]|4;D=187}else D=187;while(0);if((((D|0)==187?l>>>0<2147483647:0)?(A=vpb(l|0)|0,y=vpb(0)|0,A>>>0<y>>>0&((A|0)!=(-1|0)&(y|0)!=(-1|0))):0)?(z=y-A|0,z>>>0>(n+40|0)>>>0):0){g=z;f=A;D=190}if((D|0)==190){b=(k[206907]|0)+g|0;k[206907]=b;if(b>>>0>(k[206908]|0)>>>0)k[206908]=b;j=k[206805]|0;do if(j){b=827644;while(1){a=k[b>>2]|0;c=b+4|0;d=k[c>>2]|0;if((f|0)==(a+d|0)){D=200;break}e=k[b+8>>2]|0;if(!e)break;else b=e}if(((D|0)==200?(k[b+12>>2]&8|0)==0:0)?j>>>0<f>>>0&j>>>0>=a>>>0:0){k[c>>2]=d+g;K=j+8|0;K=(K&7|0)==0?0:0-K&7;J=j+K|0;K=g-K+(k[206802]|0)|0;k[206805]=J;k[206802]=K;k[J+4>>2]=K|1;k[J+K+4>>2]=40;k[206806]=k[206921];break}b=k[206803]|0;if(f>>>0<b>>>0){k[206803]=f;h=f}else h=b;a=f+g|0;b=827644;while(1){if((k[b>>2]|0)==(a|0)){D=208;break}b=k[b+8>>2]|0;if(!b){a=827644;break}}if((D|0)==208)if(!(k[b+12>>2]&8)){k[b>>2]=f;m=b+4|0;k[m>>2]=(k[m>>2]|0)+g;m=f+8|0;m=f+((m&7|0)==0?0:0-m&7)|0;b=a+8|0;b=a+((b&7|0)==0?0:0-b&7)|0;l=m+n|0;i=b-m-n|0;k[m+4>>2]=n|3;do if((b|0)!=(j|0)){if((b|0)==(k[206804]|0)){K=(k[206801]|0)+i|0;k[206801]=K;k[206804]=l;k[l+4>>2]=K|1;k[l+K>>2]=K;break}a=k[b+4>>2]|0;if((a&3|0)==1){g=a&-8;e=a>>>3;e:do if(a>>>0>=256){f=k[b+24>>2]|0;d=k[b+12>>2]|0;do if((d|0)==(b|0)){d=b+16|0;c=d+4|0;a=k[c>>2]|0;if(!a){a=k[d>>2]|0;if(!a){I=0;break}else c=d}while(1){d=a+20|0;e=k[d>>2]|0;if(e|0){a=e;c=d;continue}d=a+16|0;e=k[d>>2]|0;if(!e)break;else{a=e;c=d}}if(c>>>0<h>>>0)Ne();else{k[c>>2]=0;I=a;break}}else{e=k[b+8>>2]|0;if(e>>>0<h>>>0)Ne();a=e+12|0;if((k[a>>2]|0)!=(b|0))Ne();c=d+8|0;if((k[c>>2]|0)==(b|0)){k[a>>2]=d;k[c>>2]=e;I=d;break}else Ne()}while(0);if(!f)break;a=k[b+28>>2]|0;c=827500+(a<<2)|0;do if((b|0)!=(k[c>>2]|0)){if(f>>>0<(k[206803]|0)>>>0)Ne();a=f+16|0;if((k[a>>2]|0)==(b|0))k[a>>2]=I;else k[f+20>>2]=I;if(!I)break e}else{k[c>>2]=I;if(I|0)break;k[206800]=k[206800]&~(1<<a);break e}while(0);d=k[206803]|0;if(I>>>0<d>>>0)Ne();k[I+24>>2]=f;a=b+16|0;c=k[a>>2]|0;do if(c|0)if(c>>>0<d>>>0)Ne();else{k[I+16>>2]=c;k[c+24>>2]=I;break}while(0);a=k[a+4>>2]|0;if(!a)break;if(a>>>0<(k[206803]|0)>>>0)Ne();else{k[I+20>>2]=a;k[a+24>>2]=I;break}}else{c=k[b+8>>2]|0;d=k[b+12>>2]|0;a=827236+(e<<1<<2)|0;do if((c|0)!=(a|0)){if(c>>>0<h>>>0)Ne();if((k[c+12>>2]|0)==(b|0))break;Ne()}while(0);if((d|0)==(c|0)){k[206799]=k[206799]&~(1<<e);break}do if((d|0)==(a|0))F=d+8|0;else{if(d>>>0<h>>>0)Ne();a=d+8|0;if((k[a>>2]|0)==(b|0)){F=a;break}Ne()}while(0);k[c+12>>2]=d;k[F>>2]=c}while(0);b=b+g|0;e=g+i|0}else e=i;b=b+4|0;k[b>>2]=k[b>>2]&-2;k[l+4>>2]=e|1;k[l+e>>2]=e;b=e>>>3;if(e>>>0<256){c=827236+(b<<1<<2)|0;a=k[206799]|0;b=1<<b;do if(!(a&b)){k[206799]=a|b;J=c;K=c+8|0}else{b=c+8|0;a=k[b>>2]|0;if(a>>>0>=(k[206803]|0)>>>0){J=a;K=b;break}Ne()}while(0);k[K>>2]=l;k[J+12>>2]=l;k[l+8>>2]=J;k[l+12>>2]=c;break}b=e>>>8;do if(!b)b=0;else{if(e>>>0>16777215){b=31;break}J=(b+1048320|0)>>>16&8;K=b<<J;I=(K+520192|0)>>>16&4;K=K<<I;b=(K+245760|0)>>>16&2;b=14-(I|J|b)+(K<<b>>>15)|0;b=e>>>(b+7|0)&1|b<<1}while(0);d=827500+(b<<2)|0;k[l+28>>2]=b;a=l+16|0;k[a+4>>2]=0;k[a>>2]=0;a=k[206800]|0;c=1<<b;if(!(a&c)){k[206800]=a|c;k[d>>2]=l;k[l+24>>2]=d;k[l+12>>2]=l;k[l+8>>2]=l;break}a=e<<((b|0)==31?0:25-(b>>>1)|0);d=k[d>>2]|0;while(1){if((k[d+4>>2]&-8|0)==(e|0)){D=278;break}c=d+16+(a>>>31<<2)|0;b=k[c>>2]|0;if(!b){D=275;break}else{a=a<<1;d=b}}if((D|0)==275)if(c>>>0<(k[206803]|0)>>>0)Ne();else{k[c>>2]=l;k[l+24>>2]=d;k[l+12>>2]=l;k[l+8>>2]=l;break}else if((D|0)==278){b=d+8|0;a=k[b>>2]|0;K=k[206803]|0;if(a>>>0>=K>>>0&d>>>0>=K>>>0){k[a+12>>2]=l;k[b>>2]=l;k[l+8>>2]=a;k[l+12>>2]=d;k[l+24>>2]=0;break}else Ne()}}else{K=(k[206802]|0)+i|0;k[206802]=K;k[206805]=l;k[l+4>>2]=K|1}while(0);K=m+8|0;r=L;return K|0}else a=827644;while(1){b=k[a>>2]|0;if(b>>>0<=j>>>0?(E=b+(k[a+4>>2]|0)|0,E>>>0>j>>>0):0)break;a=k[a+8>>2]|0}e=E+-47|0;a=e+8|0;a=e+((a&7|0)==0?0:0-a&7)|0;e=j+16|0;a=a>>>0<e>>>0?j:a;b=a+8|0;c=f+8|0;c=(c&7|0)==0?0:0-c&7;K=f+c|0;c=g+-40-c|0;k[206805]=K;k[206802]=c;k[K+4>>2]=c|1;k[K+c+4>>2]=40;k[206806]=k[206921];c=a+4|0;k[c>>2]=27;k[b>>2]=k[206911];k[b+4>>2]=k[206912];k[b+8>>2]=k[206913];k[b+12>>2]=k[206914];k[206911]=f;k[206912]=g;k[206914]=0;k[206913]=b;b=a+24|0;do{b=b+4|0;k[b>>2]=7}while((b+4|0)>>>0<E>>>0);if((a|0)!=(j|0)){f=a-j|0;k[c>>2]=k[c>>2]&-2;k[j+4>>2]=f|1;k[a>>2]=f;b=f>>>3;if(f>>>0<256){c=827236+(b<<1<<2)|0;a=k[206799]|0;b=1<<b;if(a&b){b=c+8|0;a=k[b>>2]|0;if(a>>>0<(k[206803]|0)>>>0)Ne();else{G=a;H=b}}else{k[206799]=a|b;G=c;H=c+8|0}k[H>>2]=j;k[G+12>>2]=j;k[j+8>>2]=G;k[j+12>>2]=c;break}b=f>>>8;if(b)if(f>>>0>16777215)c=31;else{J=(b+1048320|0)>>>16&8;K=b<<J;I=(K+520192|0)>>>16&4;K=K<<I;c=(K+245760|0)>>>16&2;c=14-(I|J|c)+(K<<c>>>15)|0;c=f>>>(c+7|0)&1|c<<1}else c=0;d=827500+(c<<2)|0;k[j+28>>2]=c;k[j+20>>2]=0;k[e>>2]=0;b=k[206800]|0;a=1<<c;if(!(b&a)){k[206800]=b|a;k[d>>2]=j;k[j+24>>2]=d;k[j+12>>2]=j;k[j+8>>2]=j;break}a=f<<((c|0)==31?0:25-(c>>>1)|0);d=k[d>>2]|0;while(1){if((k[d+4>>2]&-8|0)==(f|0)){D=304;break}c=d+16+(a>>>31<<2)|0;b=k[c>>2]|0;if(!b){D=301;break}else{a=a<<1;d=b}}if((D|0)==301)if(c>>>0<(k[206803]|0)>>>0)Ne();else{k[c>>2]=j;k[j+24>>2]=d;k[j+12>>2]=j;k[j+8>>2]=j;break}else if((D|0)==304){b=d+8|0;a=k[b>>2]|0;K=k[206803]|0;if(a>>>0>=K>>>0&d>>>0>=K>>>0){k[a+12>>2]=j;k[b>>2]=j;k[j+8>>2]=a;k[j+12>>2]=d;k[j+24>>2]=0;break}else Ne()}}}else{K=k[206803]|0;if((K|0)==0|f>>>0<K>>>0)k[206803]=f;k[206911]=f;k[206912]=g;k[206914]=0;k[206808]=k[206917];k[206807]=-1;b=0;do{K=827236+(b<<1<<2)|0;k[K+12>>2]=K;k[K+8>>2]=K;b=b+1|0}while((b|0)!=32);K=f+8|0;K=(K&7|0)==0?0:0-K&7;J=f+K|0;K=g+-40-K|0;k[206805]=J;k[206802]=K;k[J+4>>2]=K|1;k[J+K+4>>2]=40;k[206806]=k[206921]}while(0);b=k[206802]|0;if(b>>>0>n>>>0){I=b-n|0;k[206802]=I;K=k[206805]|0;J=K+n|0;k[206805]=J;k[J+4>>2]=I|1;k[K+4>>2]=n|3;K=K+8|0;r=L;return K|0}}if(!(k[206783]|0))b=827176;else{b=(Fpb()|0)+64|0;b=k[b>>2]|0}k[b>>2]=12;K=0;r=L;return K|0}function ggb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!a)return;c=a+-8|0;g=k[206803]|0;if(c>>>0<g>>>0)Ne();a=k[a+-4>>2]|0;b=a&3;if((b|0)==1)Ne();d=a&-8;n=c+d|0;do if(!(a&1)){a=k[c>>2]|0;if(!b)return;j=c+(0-a)|0;i=a+d|0;if(j>>>0<g>>>0)Ne();if((j|0)==(k[206804]|0)){a=n+4|0;b=k[a>>2]|0;if((b&3|0)!=3){q=j;e=i;break}k[206801]=i;k[a>>2]=b&-2;k[j+4>>2]=i|1;k[j+i>>2]=i;return}d=a>>>3;if(a>>>0<256){b=k[j+8>>2]|0;c=k[j+12>>2]|0;a=827236+(d<<1<<2)|0;if((b|0)!=(a|0)){if(b>>>0<g>>>0)Ne();if((k[b+12>>2]|0)!=(j|0))Ne()}if((c|0)==(b|0)){k[206799]=k[206799]&~(1<<d);q=j;e=i;break}if((c|0)!=(a|0)){if(c>>>0<g>>>0)Ne();a=c+8|0;if((k[a>>2]|0)==(j|0))f=a;else Ne()}else f=c+8|0;k[b+12>>2]=c;k[f>>2]=b;q=j;e=i;break}f=k[j+24>>2]|0;c=k[j+12>>2]|0;do if((c|0)==(j|0)){c=j+16|0;b=c+4|0;a=k[b>>2]|0;if(!a){a=k[c>>2]|0;if(!a){h=0;break}else b=c}while(1){c=a+20|0;d=k[c>>2]|0;if(d|0){a=d;b=c;continue}c=a+16|0;d=k[c>>2]|0;if(!d)break;else{a=d;b=c}}if(b>>>0<g>>>0)Ne();else{k[b>>2]=0;h=a;break}}else{d=k[j+8>>2]|0;if(d>>>0<g>>>0)Ne();a=d+12|0;if((k[a>>2]|0)!=(j|0))Ne();b=c+8|0;if((k[b>>2]|0)==(j|0)){k[a>>2]=c;k[b>>2]=d;h=c;break}else Ne()}while(0);if(f){a=k[j+28>>2]|0;b=827500+(a<<2)|0;if((j|0)==(k[b>>2]|0)){k[b>>2]=h;if(!h){k[206800]=k[206800]&~(1<<a);q=j;e=i;break}}else{if(f>>>0<(k[206803]|0)>>>0)Ne();a=f+16|0;if((k[a>>2]|0)==(j|0))k[a>>2]=h;else k[f+20>>2]=h;if(!h){q=j;e=i;break}}c=k[206803]|0;if(h>>>0<c>>>0)Ne();k[h+24>>2]=f;a=j+16|0;b=k[a>>2]|0;do if(b|0)if(b>>>0<c>>>0)Ne();else{k[h+16>>2]=b;k[b+24>>2]=h;break}while(0);a=k[a+4>>2]|0;if(a)if(a>>>0<(k[206803]|0)>>>0)Ne();else{k[h+20>>2]=a;k[a+24>>2]=h;q=j;e=i;break}else{q=j;e=i}}else{q=j;e=i}}else{q=c;e=d}while(0);if(q>>>0>=n>>>0)Ne();a=n+4|0;b=k[a>>2]|0;if(!(b&1))Ne();if(!(b&2)){if((n|0)==(k[206805]|0)){p=(k[206802]|0)+e|0;k[206802]=p;k[206805]=q;k[q+4>>2]=p|1;if((q|0)!=(k[206804]|0))return;k[206804]=0;k[206801]=0;return}if((n|0)==(k[206804]|0)){p=(k[206801]|0)+e|0;k[206801]=p;k[206804]=q;k[q+4>>2]=p|1;k[q+p>>2]=p;return}e=(b&-8)+e|0;d=b>>>3;do if(b>>>0>=256){f=k[n+24>>2]|0;a=k[n+12>>2]|0;do if((a|0)==(n|0)){c=n+16|0;b=c+4|0;a=k[b>>2]|0;if(!a){a=k[c>>2]|0;if(!a){m=0;break}else b=c}while(1){c=a+20|0;d=k[c>>2]|0;if(d|0){a=d;b=c;continue}c=a+16|0;d=k[c>>2]|0;if(!d)break;else{a=d;b=c}}if(b>>>0<(k[206803]|0)>>>0)Ne();else{k[b>>2]=0;m=a;break}}else{b=k[n+8>>2]|0;if(b>>>0<(k[206803]|0)>>>0)Ne();c=b+12|0;if((k[c>>2]|0)!=(n|0))Ne();d=a+8|0;if((k[d>>2]|0)==(n|0)){k[c>>2]=a;k[d>>2]=b;m=a;break}else Ne()}while(0);if(f|0){a=k[n+28>>2]|0;b=827500+(a<<2)|0;if((n|0)==(k[b>>2]|0)){k[b>>2]=m;if(!m){k[206800]=k[206800]&~(1<<a);break}}else{if(f>>>0<(k[206803]|0)>>>0)Ne();a=f+16|0;if((k[a>>2]|0)==(n|0))k[a>>2]=m;else k[f+20>>2]=m;if(!m)break}c=k[206803]|0;if(m>>>0<c>>>0)Ne();k[m+24>>2]=f;a=n+16|0;b=k[a>>2]|0;do if(b|0)if(b>>>0<c>>>0)Ne();else{k[m+16>>2]=b;k[b+24>>2]=m;break}while(0);a=k[a+4>>2]|0;if(a|0)if(a>>>0<(k[206803]|0)>>>0)Ne();else{k[m+20>>2]=a;k[a+24>>2]=m;break}}}else{b=k[n+8>>2]|0;c=k[n+12>>2]|0;a=827236+(d<<1<<2)|0;if((b|0)!=(a|0)){if(b>>>0<(k[206803]|0)>>>0)Ne();if((k[b+12>>2]|0)!=(n|0))Ne()}if((c|0)==(b|0)){k[206799]=k[206799]&~(1<<d);break}if((c|0)!=(a|0)){if(c>>>0<(k[206803]|0)>>>0)Ne();a=c+8|0;if((k[a>>2]|0)==(n|0))l=a;else Ne()}else l=c+8|0;k[b+12>>2]=c;k[l>>2]=b}while(0);k[q+4>>2]=e|1;k[q+e>>2]=e;if((q|0)==(k[206804]|0)){k[206801]=e;return}}else{k[a>>2]=b&-2;k[q+4>>2]=e|1;k[q+e>>2]=e}a=e>>>3;if(e>>>0<256){c=827236+(a<<1<<2)|0;b=k[206799]|0;a=1<<a;if(b&a){a=c+8|0;b=k[a>>2]|0;if(b>>>0<(k[206803]|0)>>>0)Ne();else{o=b;p=a}}else{k[206799]=b|a;o=c;p=c+8|0}k[p>>2]=q;k[o+12>>2]=q;k[q+8>>2]=o;k[q+12>>2]=c;return}a=e>>>8;if(a)if(e>>>0>16777215)a=31;else{o=(a+1048320|0)>>>16&8;p=a<<o;n=(p+520192|0)>>>16&4;p=p<<n;a=(p+245760|0)>>>16&2;a=14-(n|o|a)+(p<<a>>>15)|0;a=e>>>(a+7|0)&1|a<<1}else a=0;d=827500+(a<<2)|0;k[q+28>>2]=a;k[q+20>>2]=0;k[q+16>>2]=0;b=k[206800]|0;c=1<<a;do if(b&c){b=e<<((a|0)==31?0:25-(a>>>1)|0);d=k[d>>2]|0;while(1){if((k[d+4>>2]&-8|0)==(e|0)){a=130;break}c=d+16+(b>>>31<<2)|0;a=k[c>>2]|0;if(!a){a=127;break}else{b=b<<1;d=a}}if((a|0)==127)if(c>>>0<(k[206803]|0)>>>0)Ne();else{k[c>>2]=q;k[q+24>>2]=d;k[q+12>>2]=q;k[q+8>>2]=q;break}else if((a|0)==130){a=d+8|0;b=k[a>>2]|0;p=k[206803]|0;if(b>>>0>=p>>>0&d>>>0>=p>>>0){k[b+12>>2]=q;k[a>>2]=q;k[q+8>>2]=b;k[q+12>>2]=d;k[q+24>>2]=0;break}else Ne()}}else{k[206800]=b|c;k[d>>2]=q;k[q+24>>2]=d;k[q+12>>2]=q;k[q+8>>2]=q}while(0);q=(k[206807]|0)+-1|0;k[206807]=q;if(!q)a=827652;else return;while(1){a=k[a>>2]|0;if(!a)break;else a=a+8|0}k[206807]=-1;return}function hgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;if(!a){a=fgb(b)|0;return a|0}if(b>>>0>4294967231){if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=12;a=0;return a|0}n=b>>>0<11?16:b+11&-8;m=a+-8|0;p=a+-4|0;o=k[p>>2]|0;c=o&-8;i=a+(c+-8)|0;g=k[206803]|0;d=o&3;if(!((d|0)!=1&m>>>0>=g>>>0&(c|0)>0))Ne();e=k[i+4>>2]|0;if(!(e&1))Ne();do if(!d){if(!(n>>>0<256|c>>>0<(n|4)>>>0)?(c-n|0)>>>0<=k[206919]<<1>>>0:0)return a|0}else{if(c>>>0>=n>>>0){c=c-n|0;if(c>>>0<=15)return a|0;m=m+n|0;k[p>>2]=o&1|n|2;k[m+4>>2]=c|3;p=m+c+4|0;k[p>>2]=k[p>>2]|1;igb(m,c);return a|0}if((i|0)==(k[206805]|0)){c=(k[206802]|0)+c|0;if(c>>>0<=n>>>0)break;l=c-n|0;m=m+n|0;k[p>>2]=o&1|n|2;k[m+4>>2]=l|1;k[206805]=m;k[206802]=l;return a|0}if((i|0)==(k[206804]|0)){d=(k[206801]|0)+c|0;if(d>>>0<n>>>0)break;c=d-n|0;if(c>>>0>15){d=m+n|0;m=d+c|0;k[p>>2]=o&1|n|2;k[d+4>>2]=c|1;k[m>>2]=c;p=m+4|0;k[p>>2]=k[p>>2]&-2}else{k[p>>2]=o&1|d|2;d=m+d+4|0;k[d>>2]=k[d>>2]|1;d=0;c=0}k[206801]=c;k[206804]=d;return a|0}if((e&2|0)==0?(l=(e&-8)+c|0,l>>>0>=n>>>0):0){j=l-n|0;b=e>>>3;do if(e>>>0>=256){f=k[i+24>>2]|0;e=k[i+12>>2]|0;do if((e|0)==(i|0)){e=i+16|0;d=e+4|0;c=k[d>>2]|0;if(!c){c=k[e>>2]|0;if(!c){h=0;break}else d=e}while(1){e=c+20|0;b=k[e>>2]|0;if(b|0){c=b;d=e;continue}e=c+16|0;b=k[e>>2]|0;if(!b)break;else{c=b;d=e}}if(d>>>0<g>>>0)Ne();else{k[d>>2]=0;h=c;break}}else{b=k[i+8>>2]|0;if(b>>>0<g>>>0)Ne();c=b+12|0;if((k[c>>2]|0)!=(i|0))Ne();d=e+8|0;if((k[d>>2]|0)==(i|0)){k[c>>2]=e;k[d>>2]=b;h=e;break}else Ne()}while(0);if(f|0){c=k[i+28>>2]|0;d=827500+(c<<2)|0;if((i|0)==(k[d>>2]|0)){k[d>>2]=h;if(!h){k[206800]=k[206800]&~(1<<c);break}}else{if(f>>>0<(k[206803]|0)>>>0)Ne();c=f+16|0;if((k[c>>2]|0)==(i|0))k[c>>2]=h;else k[f+20>>2]=h;if(!h)break}e=k[206803]|0;if(h>>>0<e>>>0)Ne();k[h+24>>2]=f;c=i+16|0;d=k[c>>2]|0;do if(d|0)if(d>>>0<e>>>0)Ne();else{k[h+16>>2]=d;k[d+24>>2]=h;break}while(0);c=k[c+4>>2]|0;if(c|0)if(c>>>0<(k[206803]|0)>>>0)Ne();else{k[h+20>>2]=c;k[c+24>>2]=h;break}}}else{d=k[i+8>>2]|0;e=k[i+12>>2]|0;c=827236+(b<<1<<2)|0;if((d|0)!=(c|0)){if(d>>>0<g>>>0)Ne();if((k[d+12>>2]|0)!=(i|0))Ne()}if((e|0)==(d|0)){k[206799]=k[206799]&~(1<<b);break}if((e|0)!=(c|0)){if(e>>>0<g>>>0)Ne();c=e+8|0;if((k[c>>2]|0)==(i|0))f=c;else Ne()}else f=e+8|0;k[d+12>>2]=e;k[f>>2]=d}while(0);if(j>>>0<16){k[p>>2]=l|o&1|2;p=m+l+4|0;k[p>>2]=k[p>>2]|1;return a|0}else{m=m+n|0;k[p>>2]=o&1|n|2;k[m+4>>2]=j|3;p=m+j+4|0;k[p>>2]=k[p>>2]|1;igb(m,j);return a|0}}}while(0);c=fgb(b)|0;if(!c){a=0;return a|0}p=k[p>>2]|0;p=(p&-8)-((p&3|0)==0?8:4)|0;upb(c|0,a|0,(p>>>0<b>>>0?p:b)|0)|0;ggb(a);a=c;return a|0}function igb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;o=a+b|0;c=k[a+4>>2]|0;do if(!(c&1)){f=k[a>>2]|0;if(!(c&3))return;l=a+(0-f)|0;j=f+b|0;h=k[206803]|0;if(l>>>0<h>>>0)Ne();if((l|0)==(k[206804]|0)){a=o+4|0;c=k[a>>2]|0;if((c&3|0)!=3){r=l;e=j;break}k[206801]=j;k[a>>2]=c&-2;k[l+4>>2]=j|1;k[l+j>>2]=j;return}d=f>>>3;if(f>>>0<256){c=k[l+8>>2]|0;b=k[l+12>>2]|0;a=827236+(d<<1<<2)|0;if((c|0)!=(a|0)){if(c>>>0<h>>>0)Ne();if((k[c+12>>2]|0)!=(l|0))Ne()}if((b|0)==(c|0)){k[206799]=k[206799]&~(1<<d);r=l;e=j;break}if((b|0)!=(a|0)){if(b>>>0<h>>>0)Ne();a=b+8|0;if((k[a>>2]|0)==(l|0))g=a;else Ne()}else g=b+8|0;k[c+12>>2]=b;k[g>>2]=c;r=l;e=j;break}f=k[l+24>>2]|0;b=k[l+12>>2]|0;do if((b|0)==(l|0)){b=l+16|0;c=b+4|0;a=k[c>>2]|0;if(!a){a=k[b>>2]|0;if(!a){i=0;break}else c=b}while(1){b=a+20|0;d=k[b>>2]|0;if(d|0){a=d;c=b;continue}b=a+16|0;d=k[b>>2]|0;if(!d)break;else{a=d;c=b}}if(c>>>0<h>>>0)Ne();else{k[c>>2]=0;i=a;break}}else{d=k[l+8>>2]|0;if(d>>>0<h>>>0)Ne();a=d+12|0;if((k[a>>2]|0)!=(l|0))Ne();c=b+8|0;if((k[c>>2]|0)==(l|0)){k[a>>2]=b;k[c>>2]=d;i=b;break}else Ne()}while(0);if(f){a=k[l+28>>2]|0;c=827500+(a<<2)|0;if((l|0)==(k[c>>2]|0)){k[c>>2]=i;if(!i){k[206800]=k[206800]&~(1<<a);r=l;e=j;break}}else{if(f>>>0<(k[206803]|0)>>>0)Ne();a=f+16|0;if((k[a>>2]|0)==(l|0))k[a>>2]=i;else k[f+20>>2]=i;if(!i){r=l;e=j;break}}b=k[206803]|0;if(i>>>0<b>>>0)Ne();k[i+24>>2]=f;a=l+16|0;c=k[a>>2]|0;do if(c|0)if(c>>>0<b>>>0)Ne();else{k[i+16>>2]=c;k[c+24>>2]=i;break}while(0);a=k[a+4>>2]|0;if(a)if(a>>>0<(k[206803]|0)>>>0)Ne();else{k[i+20>>2]=a;k[a+24>>2]=i;r=l;e=j;break}else{r=l;e=j}}else{r=l;e=j}}else{r=a;e=b}while(0);g=k[206803]|0;if(o>>>0<g>>>0)Ne();a=o+4|0;c=k[a>>2]|0;if(!(c&2)){if((o|0)==(k[206805]|0)){q=(k[206802]|0)+e|0;k[206802]=q;k[206805]=r;k[r+4>>2]=q|1;if((r|0)!=(k[206804]|0))return;k[206804]=0;k[206801]=0;return}if((o|0)==(k[206804]|0)){q=(k[206801]|0)+e|0;k[206801]=q;k[206804]=r;k[r+4>>2]=q|1;k[r+q>>2]=q;return}e=(c&-8)+e|0;d=c>>>3;do if(c>>>0>=256){f=k[o+24>>2]|0;b=k[o+12>>2]|0;do if((b|0)==(o|0)){b=o+16|0;c=b+4|0;a=k[c>>2]|0;if(!a){a=k[b>>2]|0;if(!a){n=0;break}else c=b}while(1){b=a+20|0;d=k[b>>2]|0;if(d|0){a=d;c=b;continue}b=a+16|0;d=k[b>>2]|0;if(!d)break;else{a=d;c=b}}if(c>>>0<g>>>0)Ne();else{k[c>>2]=0;n=a;break}}else{d=k[o+8>>2]|0;if(d>>>0<g>>>0)Ne();a=d+12|0;if((k[a>>2]|0)!=(o|0))Ne();c=b+8|0;if((k[c>>2]|0)==(o|0)){k[a>>2]=b;k[c>>2]=d;n=b;break}else Ne()}while(0);if(f|0){a=k[o+28>>2]|0;c=827500+(a<<2)|0;if((o|0)==(k[c>>2]|0)){k[c>>2]=n;if(!n){k[206800]=k[206800]&~(1<<a);break}}else{if(f>>>0<(k[206803]|0)>>>0)Ne();a=f+16|0;if((k[a>>2]|0)==(o|0))k[a>>2]=n;else k[f+20>>2]=n;if(!n)break}b=k[206803]|0;if(n>>>0<b>>>0)Ne();k[n+24>>2]=f;a=o+16|0;c=k[a>>2]|0;do if(c|0)if(c>>>0<b>>>0)Ne();else{k[n+16>>2]=c;k[c+24>>2]=n;break}while(0);a=k[a+4>>2]|0;if(a|0)if(a>>>0<(k[206803]|0)>>>0)Ne();else{k[n+20>>2]=a;k[a+24>>2]=n;break}}}else{c=k[o+8>>2]|0;b=k[o+12>>2]|0;a=827236+(d<<1<<2)|0;if((c|0)!=(a|0)){if(c>>>0<g>>>0)Ne();if((k[c+12>>2]|0)!=(o|0))Ne()}if((b|0)==(c|0)){k[206799]=k[206799]&~(1<<d);break}if((b|0)!=(a|0)){if(b>>>0<g>>>0)Ne();a=b+8|0;if((k[a>>2]|0)==(o|0))m=a;else Ne()}else m=b+8|0;k[c+12>>2]=b;k[m>>2]=c}while(0);k[r+4>>2]=e|1;k[r+e>>2]=e;if((r|0)==(k[206804]|0)){k[206801]=e;return}}else{k[a>>2]=c&-2;k[r+4>>2]=e|1;k[r+e>>2]=e}a=e>>>3;if(e>>>0<256){b=827236+(a<<1<<2)|0;c=k[206799]|0;a=1<<a;if(c&a){a=b+8|0;c=k[a>>2]|0;if(c>>>0<(k[206803]|0)>>>0)Ne();else{p=c;q=a}}else{k[206799]=c|a;p=b;q=b+8|0}k[q>>2]=r;k[p+12>>2]=r;k[r+8>>2]=p;k[r+12>>2]=b;return}a=e>>>8;if(a)if(e>>>0>16777215)a=31;else{p=(a+1048320|0)>>>16&8;q=a<<p;o=(q+520192|0)>>>16&4;q=q<<o;a=(q+245760|0)>>>16&2;a=14-(o|p|a)+(q<<a>>>15)|0;a=e>>>(a+7|0)&1|a<<1}else a=0;d=827500+(a<<2)|0;k[r+28>>2]=a;k[r+20>>2]=0;k[r+16>>2]=0;c=k[206800]|0;b=1<<a;if(!(c&b)){k[206800]=c|b;k[d>>2]=r;k[r+24>>2]=d;k[r+12>>2]=r;k[r+8>>2]=r;return}c=e<<((a|0)==31?0:25-(a>>>1)|0);d=k[d>>2]|0;while(1){if((k[d+4>>2]&-8|0)==(e|0)){a=127;break}b=d+16+(c>>>31<<2)|0;a=k[b>>2]|0;if(!a){a=124;break}else{c=c<<1;d=a}}if((a|0)==124){if(b>>>0<(k[206803]|0)>>>0)Ne();k[b>>2]=r;k[r+24>>2]=d;k[r+12>>2]=r;k[r+8>>2]=r;return}else if((a|0)==127){a=d+8|0;c=k[a>>2]|0;q=k[206803]|0;if(!(c>>>0>=q>>>0&d>>>0>=q>>>0))Ne();k[c+12>>2]=r;k[a>>2]=r;k[r+8>>2]=c;k[r+12>>2]=d;k[r+24>>2]=0;return}}function jgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a:while(1){l=b;m=b+-1|0;while(1){q=a;b:while(1){k=q;a=l-k|0;switch(a|0){case 1:case 0:break a;case 2:{p=5;break a}case 3:{p=7;break a}case 4:{p=8;break a}case 5:{p=9;break a}default:{}}if((a|0)<31){p=11;break a}f=q+(a>>>1)|0;if((a|0)>999){a=a>>>2;a=mgb(q,q+a|0,f,f+a|0,m)|0}else a=kgb(q,f,m)|0;g=i[q>>0]|0;d=i[f>>0]|0;if(g<<24>>24<d<<24>>24){c=m;break}else c=m;while(1){c=c+-1|0;if((q|0)==(c|0))break;e=i[c>>0]|0;if(e<<24>>24<d<<24>>24){p=35;break b}}a=q+1|0;d=i[m>>0]|0;if(g<<24>>24>=d<<24>>24){while(1){if((a|0)==(m|0))break a;c=i[a>>0]|0;if(g<<24>>24<c<<24>>24)break;a=a+1|0}i[a>>0]=d;i[m>>0]=c;a=a+1|0}if((a|0)==(m|0))break a;else c=m;while(1){g=i[q>>0]|0;while(1){e=i[a>>0]|0;f=a+1|0;if(g<<24>>24<e<<24>>24)break;else a=f}do{c=c+-1|0;d=i[c>>0]|0}while(g<<24>>24<d<<24>>24);if(a>>>0>=c>>>0){q=a;continue b}i[a>>0]=d;i[c>>0]=e;a=f}}if((p|0)==35){p=0;i[q>>0]=e;i[c>>0]=g;a=a+1|0}d=q+1|0;c:do if(d>>>0<c>>>0){j=f;while(1){h=i[j>>0]|0;while(1){f=i[d>>0]|0;g=d+1|0;if(f<<24>>24<h<<24>>24)d=g;else break}do{c=c+-1|0;e=i[c>>0]|0}while(e<<24>>24>=h<<24>>24);if(d>>>0>c>>>0){c=j;break c}i[d>>0]=e;i[c>>0]=f;j=(j|0)==(d|0)?c:j;d=g;a=a+1|0}}else c=f;while(0);if((d|0)!=(c|0)?(n=i[c>>0]|0,o=i[d>>0]|0,n<<24>>24<o<<24>>24):0){i[d>>0]=n;i[c>>0]=o;a=a+1|0}if(!a){c=ngb(q,d)|0;a=d+1|0;if(ngb(a,b)|0){p=51;break}if(c)continue}j=d;if((j-k|0)>=(l-j|0)){p=50;break}jgb(q,d);a=d+1|0}if((p|0)==50){p=0;jgb(d+1|0,b);a=q;b=d;continue}else if((p|0)==51){p=0;if(c)break;else{a=q;b=d;continue}}}d:do if((p|0)==5){a=i[m>>0]|0;b=i[q>>0]|0;if(a<<24>>24<b<<24>>24){i[q>>0]=a;i[m>>0]=b}}else if((p|0)==7)kgb(q,q+1|0,m)|0;else if((p|0)==8)lgb(q,q+1|0,q+2|0,m)|0;else if((p|0)==9)mgb(q,q+1|0,q+2|0,q+3|0,m)|0;else if((p|0)==11){a=q+2|0;kgb(q,q+1|0,a)|0;e=q+3|0;while(1){if((e|0)==(b|0))break d;f=i[e>>0]|0;d=i[a>>0]|0;if(f<<24>>24<d<<24>>24){c=e;while(1){i[c>>0]=d;if((a|0)==(q|0)){a=q;break}c=a+-1|0;d=i[c>>0]|0;if(f<<24>>24>=d<<24>>24)break;else{p=a;a=c;c=p}}i[a>>0]=f}a=e;e=e+1|0}}while(0);return}function kgb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i[b>>0]|0;g=i[a>>0]|0;e=i[c>>0]|0;f=e<<24>>24<d<<24>>24;do if(d<<24>>24<g<<24>>24){if(f){i[a>>0]=e;i[c>>0]=g;d=1;break}i[a>>0]=d;i[b>>0]=g;d=i[c>>0]|0;if(d<<24>>24<g<<24>>24){i[b>>0]=d;i[c>>0]=g;d=2}else d=1}else if(f){i[b>>0]=e;i[c>>0]=d;d=i[b>>0]|0;e=i[a>>0]|0;if(d<<24>>24<e<<24>>24){i[a>>0]=d;i[b>>0]=e;d=2}else d=1}else d=0;while(0);return d|0}function lgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=kgb(a,b,c)|0;f=i[d>>0]|0;g=i[c>>0]|0;if(f<<24>>24<g<<24>>24){i[c>>0]=f;i[d>>0]=g;f=e+1|0;g=i[c>>0]|0;d=i[b>>0]|0;if(g<<24>>24<d<<24>>24){i[b>>0]=g;i[c>>0]=d;d=i[b>>0]|0;f=i[a>>0]|0;if(d<<24>>24<f<<24>>24){i[a>>0]=d;i[b>>0]=f;e=e+3|0}else e=e+2|0}else e=f}return e|0}function mgb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=lgb(a,b,c,d)|0;f=i[e>>0]|0;g=i[d>>0]|0;if(f<<24>>24<g<<24>>24){i[d>>0]=f;i[e>>0]=g;e=h+1|0;f=i[d>>0]|0;g=i[c>>0]|0;if(f<<24>>24<g<<24>>24){i[c>>0]=f;i[d>>0]=g;e=h+2|0;f=i[c>>0]|0;g=i[b>>0]|0;if(f<<24>>24<g<<24>>24){i[b>>0]=f;i[c>>0]=g;e=i[b>>0]|0;f=i[a>>0]|0;if(e<<24>>24<f<<24>>24){i[a>>0]=e;i[b>>0]=f;e=h+4|0}else e=h+3|0}}}else e=h;return e|0}function ngb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;switch(b-a|0){case 1:case 0:{c=1;break}case 2:{c=b+-1|0;d=i[c>>0]|0;e=i[a>>0]|0;if(d<<24>>24<e<<24>>24){i[a>>0]=d;i[c>>0]=e;c=1}else c=1;break}case 3:{kgb(a,a+1|0,b+-1|0)|0;c=1;break}case 4:{lgb(a,a+1|0,a+2|0,b+-1|0)|0;c=1;break}case 5:{mgb(a,a+1|0,a+2|0,a+3|0,b+-1|0)|0;c=1;break}default:{d=a+2|0;kgb(a,a+1|0,d)|0;h=a+3|0;c=0;while(1){if((h|0)==(b|0)){d=1;c=0;break}g=i[h>>0]|0;f=i[d>>0]|0;if(g<<24>>24<f<<24>>24)e=h;else{d=h;h=h+1|0;continue}while(1){i[e>>0]=f;if((d|0)==(a|0)){d=a;break}e=d+-1|0;f=i[e>>0]|0;if(g<<24>>24>=f<<24>>24)break;else{j=d;d=e;e=j}}i[d>>0]=g;c=c+1|0;e=h+1|0;if((c|0)==8){d=0;c=(e|0)==(b|0);break}else{d=h;h=e}}c=c|d}}return c|0}function ogb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a:while(1){l=b;m=b+-1|0;while(1){q=a;b:while(1){k=q;a=l-k|0;switch(a|0){case 1:case 0:break a;case 2:{p=5;break a}case 3:{p=7;break a}case 4:{p=8;break a}case 5:{p=9;break a}default:{}}if((a|0)<31){p=11;break a}f=q+(a>>>1)|0;if((a|0)>999){a=a>>>2;a=rgb(q,q+a|0,f,f+a|0,m)|0}else a=pgb(q,f,m)|0;g=i[q>>0]|0;d=i[f>>0]|0;if((g&255)<(d&255)){c=m;break}else c=m;while(1){c=c+-1|0;if((q|0)==(c|0))break;e=i[c>>0]|0;if((e&255)<(d&255)){p=35;break b}}a=q+1|0;d=i[m>>0]|0;if((g&255)>=(d&255)){while(1){if((a|0)==(m|0))break a;c=i[a>>0]|0;if((g&255)<(c&255))break;a=a+1|0}i[a>>0]=d;i[m>>0]=c;a=a+1|0}if((a|0)==(m|0))break a;else c=m;while(1){g=i[q>>0]|0;while(1){e=i[a>>0]|0;f=a+1|0;if((g&255)<(e&255))break;else a=f}do{c=c+-1|0;d=i[c>>0]|0}while((g&255)<(d&255));if(a>>>0>=c>>>0){q=a;continue b}i[a>>0]=d;i[c>>0]=e;a=f}}if((p|0)==35){p=0;i[q>>0]=e;i[c>>0]=g;a=a+1|0}d=q+1|0;c:do if(d>>>0<c>>>0){j=f;while(1){h=i[j>>0]|0;while(1){f=i[d>>0]|0;g=d+1|0;if((f&255)<(h&255))d=g;else break}do{c=c+-1|0;e=i[c>>0]|0}while((e&255)>=(h&255));if(d>>>0>c>>>0){c=j;break c}i[d>>0]=e;i[c>>0]=f;j=(j|0)==(d|0)?c:j;d=g;a=a+1|0}}else c=f;while(0);if((d|0)!=(c|0)?(n=i[c>>0]|0,o=i[d>>0]|0,(n&255)<(o&255)):0){i[d>>0]=n;i[c>>0]=o;a=a+1|0}if(!a){c=sgb(q,d)|0;a=d+1|0;if(sgb(a,b)|0){p=51;break}if(c)continue}j=d;if((j-k|0)>=(l-j|0)){p=50;break}ogb(q,d);a=d+1|0}if((p|0)==50){p=0;ogb(d+1|0,b);a=q;b=d;continue}else if((p|0)==51){p=0;if(c)break;else{a=q;b=d;continue}}}d:do if((p|0)==5){a=i[m>>0]|0;b=i[q>>0]|0;if((a&255)<(b&255)){i[q>>0]=a;i[m>>0]=b}}else if((p|0)==7)pgb(q,q+1|0,m)|0;else if((p|0)==8)qgb(q,q+1|0,q+2|0,m)|0;else if((p|0)==9)rgb(q,q+1|0,q+2|0,q+3|0,m)|0;else if((p|0)==11){a=q+2|0;pgb(q,q+1|0,a)|0;e=q+3|0;while(1){if((e|0)==(b|0))break d;f=i[e>>0]|0;d=i[a>>0]|0;if((f&255)<(d&255)){c=e;while(1){i[c>>0]=d;if((a|0)==(q|0)){a=q;break}c=a+-1|0;d=i[c>>0]|0;if((f&255)>=(d&255))break;else{p=a;a=c;c=p}}i[a>>0]=f}a=e;e=e+1|0}}while(0);return}function pgb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i[b>>0]|0;g=i[a>>0]|0;e=i[c>>0]|0;f=(e&255)<(d&255);do if((d&255)<(g&255)){if(f){i[a>>0]=e;i[c>>0]=g;d=1;break}i[a>>0]=d;i[b>>0]=g;d=i[c>>0]|0;if((d&255)<(g&255)){i[b>>0]=d;i[c>>0]=g;d=2}else d=1}else if(f){i[b>>0]=e;i[c>>0]=d;d=i[b>>0]|0;e=i[a>>0]|0;if((d&255)<(e&255)){i[a>>0]=d;i[b>>0]=e;d=2}else d=1}else d=0;while(0);return d|0}function qgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=pgb(a,b,c)|0;f=i[d>>0]|0;g=i[c>>0]|0;if((f&255)<(g&255)){i[c>>0]=f;i[d>>0]=g;f=e+1|0;g=i[c>>0]|0;d=i[b>>0]|0;if((g&255)<(d&255)){i[b>>0]=g;i[c>>0]=d;d=i[b>>0]|0;f=i[a>>0]|0;if((d&255)<(f&255)){i[a>>0]=d;i[b>>0]=f;e=e+3|0}else e=e+2|0}else e=f}return e|0}function rgb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=qgb(a,b,c,d)|0;f=i[e>>0]|0;g=i[d>>0]|0;if((f&255)<(g&255)){i[d>>0]=f;i[e>>0]=g;e=h+1|0;f=i[d>>0]|0;g=i[c>>0]|0;if((f&255)<(g&255)){i[c>>0]=f;i[d>>0]=g;e=h+2|0;f=i[c>>0]|0;g=i[b>>0]|0;if((f&255)<(g&255)){i[b>>0]=f;i[c>>0]=g;e=i[b>>0]|0;f=i[a>>0]|0;if((e&255)<(f&255)){i[a>>0]=e;i[b>>0]=f;e=h+4|0}else e=h+3|0}}}else e=h;return e|0}function sgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;switch(b-a|0){case 1:case 0:{c=1;break}case 2:{c=b+-1|0;d=i[c>>0]|0;e=i[a>>0]|0;if((d&255)<(e&255)){i[a>>0]=d;i[c>>0]=e;c=1}else c=1;break}case 3:{pgb(a,a+1|0,b+-1|0)|0;c=1;break}case 4:{qgb(a,a+1|0,a+2|0,b+-1|0)|0;c=1;break}case 5:{rgb(a,a+1|0,a+2|0,a+3|0,b+-1|0)|0;c=1;break}default:{d=a+2|0;pgb(a,a+1|0,d)|0;h=a+3|0;c=0;while(1){if((h|0)==(b|0)){d=1;c=0;break}g=i[h>>0]|0;f=i[d>>0]|0;if((g&255)<(f&255))e=h;else{d=h;h=h+1|0;continue}while(1){i[e>>0]=f;if((d|0)==(a|0)){d=a;break}e=d+-1|0;f=i[e>>0]|0;if((g&255)>=(f&255))break;else{j=d;d=e;e=j}}i[d>>0]=g;c=c+1|0;e=h+1|0;if((c|0)==8){d=0;c=(e|0)==(b|0);break}else{d=h;h=e}}c=c|d}}return c|0}function tgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a:while(1){l=b;m=b+-2|0;while(1){q=a;b:while(1){k=q;a=l-k|0;c=a>>1;switch(c|0){case 1:case 0:break a;case 2:{p=5;break a}case 3:{p=7;break a}case 4:{p=8;break a}case 5:{p=9;break a}default:{}}if((a|0)<62){p=11;break a}g=q+(((c|0)/2|0)<<1)|0;if((a|0)>1998){a=(c|0)/4|0;a=wgb(q,q+(a<<1)|0,g,g+(a<<1)|0,m)|0}else a=ugb(q,g,m)|0;f=j[q>>1]|0;d=j[g>>1]|0;if(f<<16>>16<d<<16>>16){c=m;break}else c=m;while(1){c=c+-2|0;if((q|0)==(c|0))break;e=j[c>>1]|0;if(e<<16>>16<d<<16>>16){p=35;break b}}a=q+2|0;d=j[m>>1]|0;if(f<<16>>16>=d<<16>>16){while(1){if((a|0)==(m|0))break a;c=j[a>>1]|0;if(f<<16>>16<c<<16>>16)break;a=a+2|0}j[a>>1]=d;j[m>>1]=c;a=a+2|0}if((a|0)==(m|0))break a;else c=m;while(1){g=j[q>>1]|0;while(1){e=j[a>>1]|0;f=a+2|0;if(g<<16>>16<e<<16>>16)break;else a=f}do{c=c+-2|0;d=j[c>>1]|0}while(g<<16>>16<d<<16>>16);if(a>>>0>=c>>>0){q=a;continue b}j[a>>1]=d;j[c>>1]=e;a=f}}if((p|0)==35){p=0;j[q>>1]=e;j[c>>1]=f;a=a+1|0}d=q+2|0;c:do if(d>>>0<c>>>0){i=g;while(1){h=j[i>>1]|0;while(1){f=j[d>>1]|0;g=d+2|0;if(f<<16>>16<h<<16>>16)d=g;else break}do{c=c+-2|0;e=j[c>>1]|0}while(e<<16>>16>=h<<16>>16);if(d>>>0>c>>>0){c=i;break c}j[d>>1]=e;j[c>>1]=f;i=(i|0)==(d|0)?c:i;d=g;a=a+1|0}}else c=g;while(0);if((d|0)!=(c|0)?(n=j[c>>1]|0,o=j[d>>1]|0,n<<16>>16<o<<16>>16):0){j[d>>1]=n;j[c>>1]=o;a=a+1|0}if(!a){c=xgb(q,d)|0;a=d+2|0;if(xgb(a,b)|0){p=51;break}if(c)continue}i=d;if((i-k|0)>=(l-i|0)){p=50;break}tgb(q,d);a=d+2|0}if((p|0)==50){p=0;tgb(d+2|0,b);a=q;b=d;continue}else if((p|0)==51){p=0;if(c)break;else{a=q;b=d;continue}}}d:do if((p|0)==5){a=j[m>>1]|0;b=j[q>>1]|0;if(a<<16>>16<b<<16>>16){j[q>>1]=a;j[m>>1]=b}}else if((p|0)==7)ugb(q,q+2|0,m)|0;else if((p|0)==8)vgb(q,q+2|0,q+4|0,m)|0;else if((p|0)==9)wgb(q,q+2|0,q+4|0,q+6|0,m)|0;else if((p|0)==11){a=q+4|0;ugb(q,q+2|0,a)|0;e=q+6|0;while(1){if((e|0)==(b|0))break d;f=j[e>>1]|0;d=j[a>>1]|0;if(f<<16>>16<d<<16>>16){c=e;while(1){j[c>>1]=d;if((a|0)==(q|0)){a=q;break}c=a+-2|0;d=j[c>>1]|0;if(f<<16>>16>=d<<16>>16)break;else{p=a;a=c;c=p}}j[a>>1]=f}a=e;e=e+2|0}}while(0);return}function ugb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=j[b>>1]|0;g=j[a>>1]|0;e=j[c>>1]|0;f=e<<16>>16<d<<16>>16;do if(d<<16>>16<g<<16>>16){if(f){j[a>>1]=e;j[c>>1]=g;d=1;break}j[a>>1]=d;j[b>>1]=g;d=j[c>>1]|0;if(d<<16>>16<g<<16>>16){j[b>>1]=d;j[c>>1]=g;d=2}else d=1}else if(f){j[b>>1]=e;j[c>>1]=d;d=j[b>>1]|0;e=j[a>>1]|0;if(d<<16>>16<e<<16>>16){j[a>>1]=d;j[b>>1]=e;d=2}else d=1}else d=0;while(0);return d|0}function vgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=ugb(a,b,c)|0;f=j[d>>1]|0;g=j[c>>1]|0;if(f<<16>>16<g<<16>>16){j[c>>1]=f;j[d>>1]=g;f=e+1|0;g=j[c>>1]|0;d=j[b>>1]|0;if(g<<16>>16<d<<16>>16){j[b>>1]=g;j[c>>1]=d;d=j[b>>1]|0;f=j[a>>1]|0;if(d<<16>>16<f<<16>>16){j[a>>1]=d;j[b>>1]=f;e=e+3|0}else e=e+2|0}else e=f}return e|0}function wgb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=vgb(a,b,c,d)|0;f=j[e>>1]|0;g=j[d>>1]|0;if(f<<16>>16<g<<16>>16){j[d>>1]=f;j[e>>1]=g;e=h+1|0;f=j[d>>1]|0;g=j[c>>1]|0;if(f<<16>>16<g<<16>>16){j[c>>1]=f;j[d>>1]=g;e=h+2|0;f=j[c>>1]|0;g=j[b>>1]|0;if(f<<16>>16<g<<16>>16){j[b>>1]=f;j[c>>1]=g;e=j[b>>1]|0;f=j[a>>1]|0;if(e<<16>>16<f<<16>>16){j[a>>1]=e;j[b>>1]=f;e=h+4|0}else e=h+3|0}}}else e=h;return e|0}function xgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;switch(b-a>>1|0){case 1:case 0:{c=1;break}case 2:{c=b+-2|0;d=j[c>>1]|0;e=j[a>>1]|0;if(d<<16>>16<e<<16>>16){j[a>>1]=d;j[c>>1]=e;c=1}else c=1;break}case 3:{ugb(a,a+2|0,b+-2|0)|0;c=1;break}case 4:{vgb(a,a+2|0,a+4|0,b+-2|0)|0;c=1;break}case 5:{wgb(a,a+2|0,a+4|0,a+6|0,b+-2|0)|0;c=1;break}default:{d=a+4|0;ugb(a,a+2|0,d)|0;h=a+6|0;c=0;while(1){if((h|0)==(b|0)){d=1;c=0;break}g=j[h>>1]|0;f=j[d>>1]|0;if(g<<16>>16<f<<16>>16)e=h;else{d=h;h=h+2|0;continue}while(1){j[e>>1]=f;if((d|0)==(a|0)){d=a;break}e=d+-2|0;f=j[e>>1]|0;if(g<<16>>16>=f<<16>>16)break;else{i=d;d=e;e=i}}j[d>>1]=g;c=c+1|0;e=h+2|0;if((c|0)==8){d=0;c=(e|0)==(b|0);break}else{d=h;h=e}}c=c|d}}return c|0}function ygb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a:while(1){l=b;m=b+-2|0;while(1){q=a;b:while(1){k=q;a=l-k|0;c=a>>1;switch(c|0){case 1:case 0:break a;case 2:{p=5;break a}case 3:{p=7;break a}case 4:{p=8;break a}case 5:{p=9;break a}default:{}}if((a|0)<62){p=11;break a}g=q+(((c|0)/2|0)<<1)|0;if((a|0)>1998){a=(c|0)/4|0;a=Bgb(q,q+(a<<1)|0,g,g+(a<<1)|0,m)|0}else a=zgb(q,g,m)|0;f=j[q>>1]|0;d=j[g>>1]|0;if((f&65535)<(d&65535)){c=m;break}else c=m;while(1){c=c+-2|0;if((q|0)==(c|0))break;e=j[c>>1]|0;if((e&65535)<(d&65535)){p=35;break b}}a=q+2|0;d=j[m>>1]|0;if((f&65535)>=(d&65535)){while(1){if((a|0)==(m|0))break a;c=j[a>>1]|0;if((f&65535)<(c&65535))break;a=a+2|0}j[a>>1]=d;j[m>>1]=c;a=a+2|0}if((a|0)==(m|0))break a;else c=m;while(1){g=j[q>>1]|0;while(1){e=j[a>>1]|0;f=a+2|0;if((g&65535)<(e&65535))break;else a=f}do{c=c+-2|0;d=j[c>>1]|0}while((g&65535)<(d&65535));if(a>>>0>=c>>>0){q=a;continue b}j[a>>1]=d;j[c>>1]=e;a=f}}if((p|0)==35){p=0;j[q>>1]=e;j[c>>1]=f;a=a+1|0}d=q+2|0;c:do if(d>>>0<c>>>0){i=g;while(1){h=j[i>>1]|0;while(1){f=j[d>>1]|0;g=d+2|0;if((f&65535)<(h&65535))d=g;else break}do{c=c+-2|0;e=j[c>>1]|0}while((e&65535)>=(h&65535));if(d>>>0>c>>>0){c=i;break c}j[d>>1]=e;j[c>>1]=f;i=(i|0)==(d|0)?c:i;d=g;a=a+1|0}}else c=g;while(0);if((d|0)!=(c|0)?(n=j[c>>1]|0,o=j[d>>1]|0,(n&65535)<(o&65535)):0){j[d>>1]=n;j[c>>1]=o;a=a+1|0}if(!a){c=Cgb(q,d)|0;a=d+2|0;if(Cgb(a,b)|0){p=51;break}if(c)continue}i=d;if((i-k|0)>=(l-i|0)){p=50;break}ygb(q,d);a=d+2|0}if((p|0)==50){p=0;ygb(d+2|0,b);a=q;b=d;continue}else if((p|0)==51){p=0;if(c)break;else{a=q;b=d;continue}}}d:do if((p|0)==5){a=j[m>>1]|0;b=j[q>>1]|0;if((a&65535)<(b&65535)){j[q>>1]=a;j[m>>1]=b}}else if((p|0)==7)zgb(q,q+2|0,m)|0;else if((p|0)==8)Agb(q,q+2|0,q+4|0,m)|0;else if((p|0)==9)Bgb(q,q+2|0,q+4|0,q+6|0,m)|0;else if((p|0)==11){a=q+4|0;zgb(q,q+2|0,a)|0;e=q+6|0;while(1){if((e|0)==(b|0))break d;f=j[e>>1]|0;d=j[a>>1]|0;if((f&65535)<(d&65535)){c=e;while(1){j[c>>1]=d;if((a|0)==(q|0)){a=q;break}c=a+-2|0;d=j[c>>1]|0;if((f&65535)>=(d&65535))break;else{p=a;a=c;c=p}}j[a>>1]=f}a=e;e=e+2|0}}while(0);return}function zgb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=j[b>>1]|0;g=j[a>>1]|0;e=j[c>>1]|0;f=(e&65535)<(d&65535);do if((d&65535)<(g&65535)){if(f){j[a>>1]=e;j[c>>1]=g;d=1;break}j[a>>1]=d;j[b>>1]=g;d=j[c>>1]|0;if((d&65535)<(g&65535)){j[b>>1]=d;j[c>>1]=g;d=2}else d=1}else if(f){j[b>>1]=e;j[c>>1]=d;d=j[b>>1]|0;e=j[a>>1]|0;if((d&65535)<(e&65535)){j[a>>1]=d;j[b>>1]=e;d=2}else d=1}else d=0;while(0);return d|0}function Agb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=zgb(a,b,c)|0;f=j[d>>1]|0;g=j[c>>1]|0;if((f&65535)<(g&65535)){j[c>>1]=f;j[d>>1]=g;f=e+1|0;g=j[c>>1]|0;d=j[b>>1]|0;if((g&65535)<(d&65535)){j[b>>1]=g;j[c>>1]=d;d=j[b>>1]|0;f=j[a>>1]|0;if((d&65535)<(f&65535)){j[a>>1]=d;j[b>>1]=f;e=e+3|0}else e=e+2|0}else e=f}return e|0}function Bgb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=Agb(a,b,c,d)|0;f=j[e>>1]|0;g=j[d>>1]|0;if((f&65535)<(g&65535)){j[d>>1]=f;j[e>>1]=g;e=h+1|0;f=j[d>>1]|0;g=j[c>>1]|0;if((f&65535)<(g&65535)){j[c>>1]=f;j[d>>1]=g;e=h+2|0;f=j[c>>1]|0;g=j[b>>1]|0;if((f&65535)<(g&65535)){j[b>>1]=f;j[c>>1]=g;e=j[b>>1]|0;f=j[a>>1]|0;if((e&65535)<(f&65535)){j[a>>1]=e;j[b>>1]=f;e=h+4|0}else e=h+3|0}}}else e=h;return e|0}function Cgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;switch(b-a>>1|0){case 1:case 0:{c=1;break}case 2:{c=b+-2|0;d=j[c>>1]|0;e=j[a>>1]|0;if((d&65535)<(e&65535)){j[a>>1]=d;j[c>>1]=e;c=1}else c=1;break}case 3:{zgb(a,a+2|0,b+-2|0)|0;c=1;break}case 4:{Agb(a,a+2|0,a+4|0,b+-2|0)|0;c=1;break}case 5:{Bgb(a,a+2|0,a+4|0,a+6|0,b+-2|0)|0;c=1;break}default:{d=a+4|0;zgb(a,a+2|0,d)|0;h=a+6|0;c=0;while(1){if((h|0)==(b|0)){d=1;c=0;break}g=j[h>>1]|0;f=j[d>>1]|0;if((g&65535)<(f&65535))e=h;else{d=h;h=h+2|0;continue}while(1){j[e>>1]=f;if((d|0)==(a|0)){d=a;break}e=d+-2|0;f=j[e>>1]|0;if((g&65535)>=(f&65535))break;else{i=d;d=e;e=i}}j[d>>1]=g;c=c+1|0;e=h+2|0;if((c|0)==8){d=0;c=(e|0)==(b|0);break}else{d=h;h=e}}c=c|d}}return c|0}function Dgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;a:while(1){l=b;m=b+-4|0;while(1){q=a;b:while(1){j=q;a=l-j|0;c=a>>2;switch(c|0){case 1:case 0:break a;case 2:{p=5;break a}case 3:{p=7;break a}case 4:{p=8;break a}case 5:{p=9;break a}default:{}}if((a|0)<124){p=11;break a}g=q+(((c|0)/2|0)<<2)|0;if((a|0)>3996){a=(c|0)/4|0;a=Ggb(q,q+(a<<2)|0,g,g+(a<<2)|0,m)|0}else a=Egb(q,g,m)|0;f=k[q>>2]|0;d=k[g>>2]|0;if((f|0)<(d|0)){c=m;break}else c=m;while(1){c=c+-4|0;if((q|0)==(c|0))break;e=k[c>>2]|0;if((e|0)<(d|0)){p=35;break b}}a=q+4|0;d=k[m>>2]|0;if((f|0)>=(d|0)){while(1){if((a|0)==(m|0))break a;c=k[a>>2]|0;if((f|0)<(c|0))break;a=a+4|0}k[a>>2]=d;k[m>>2]=c;a=a+4|0}if((a|0)==(m|0))break a;else c=m;while(1){g=k[q>>2]|0;while(1){e=k[a>>2]|0;f=a+4|0;if((g|0)<(e|0))break;else a=f}do{c=c+-4|0;d=k[c>>2]|0}while((g|0)<(d|0));if(a>>>0>=c>>>0){q=a;continue b}k[a>>2]=d;k[c>>2]=e;a=f}}if((p|0)==35){p=0;k[q>>2]=e;k[c>>2]=f;a=a+1|0}d=q+4|0;c:do if(d>>>0<c>>>0){i=g;while(1){h=k[i>>2]|0;while(1){f=k[d>>2]|0;g=d+4|0;if((f|0)<(h|0))d=g;else break}do{c=c+-4|0;e=k[c>>2]|0}while((e|0)>=(h|0));if(d>>>0>c>>>0){c=i;break c}k[d>>2]=e;k[c>>2]=f;i=(i|0)==(d|0)?c:i;d=g;a=a+1|0}}else c=g;while(0);if((d|0)!=(c|0)?(n=k[c>>2]|0,o=k[d>>2]|0,(n|0)<(o|0)):0){k[d>>2]=n;k[c>>2]=o;a=a+1|0}if(!a){c=Hgb(q,d)|0;a=d+4|0;if(Hgb(a,b)|0){p=51;break}if(c)continue}i=d;if((i-j|0)>=(l-i|0)){p=50;break}Dgb(q,d);a=d+4|0}if((p|0)==50){p=0;Dgb(d+4|0,b);a=q;b=d;continue}else if((p|0)==51){p=0;if(c)break;else{a=q;b=d;continue}}}d:do if((p|0)==5){a=k[m>>2]|0;b=k[q>>2]|0;if((a|0)<(b|0)){k[q>>2]=a;k[m>>2]=b}}else if((p|0)==7)Egb(q,q+4|0,m)|0;else if((p|0)==8)Fgb(q,q+4|0,q+8|0,m)|0;else if((p|0)==9)Ggb(q,q+4|0,q+8|0,q+12|0,m)|0;else if((p|0)==11){a=q+8|0;Egb(q,q+4|0,a)|0;e=q+12|0;while(1){if((e|0)==(b|0))break d;f=k[e>>2]|0;d=k[a>>2]|0;if((f|0)<(d|0)){c=e;while(1){k[c>>2]=d;if((a|0)==(q|0)){a=q;break}c=a+-4|0;d=k[c>>2]|0;if((f|0)>=(d|0))break;else{p=a;a=c;c=p}}k[a>>2]=f}a=e;e=e+4|0}}while(0);return}function Egb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=k[b>>2]|0;g=k[a>>2]|0;e=k[c>>2]|0;f=(e|0)<(d|0);do if((d|0)<(g|0)){if(f){k[a>>2]=e;k[c>>2]=g;d=1;break}k[a>>2]=d;k[b>>2]=g;d=k[c>>2]|0;if((d|0)<(g|0)){k[b>>2]=d;k[c>>2]=g;d=2}else d=1}else if(f){k[b>>2]=e;k[c>>2]=d;d=k[b>>2]|0;e=k[a>>2]|0;if((d|0)<(e|0)){k[a>>2]=d;k[b>>2]=e;d=2}else d=1}else d=0;while(0);return d|0}function Fgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Egb(a,b,c)|0;f=k[d>>2]|0;g=k[c>>2]|0;if((f|0)<(g|0)){k[c>>2]=f;k[d>>2]=g;f=e+1|0;g=k[c>>2]|0;d=k[b>>2]|0;if((g|0)<(d|0)){k[b>>2]=g;k[c>>2]=d;d=k[b>>2]|0;f=k[a>>2]|0;if((d|0)<(f|0)){k[a>>2]=d;k[b>>2]=f;e=e+3|0}else e=e+2|0}else e=f}return e|0}function Ggb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=Fgb(a,b,c,d)|0;f=k[e>>2]|0;g=k[d>>2]|0;if((f|0)<(g|0)){k[d>>2]=f;k[e>>2]=g;e=h+1|0;f=k[d>>2]|0;g=k[c>>2]|0;if((f|0)<(g|0)){k[c>>2]=f;k[d>>2]=g;e=h+2|0;f=k[c>>2]|0;g=k[b>>2]|0;if((f|0)<(g|0)){k[b>>2]=f;k[c>>2]=g;e=k[b>>2]|0;f=k[a>>2]|0;if((e|0)<(f|0)){k[a>>2]=e;k[b>>2]=f;e=h+4|0}else e=h+3|0}}}else e=h;return e|0}function Hgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;switch(b-a>>2|0){case 1:case 0:{c=1;break}case 2:{c=b+-4|0;d=k[c>>2]|0;e=k[a>>2]|0;if((d|0)<(e|0)){k[a>>2]=d;k[c>>2]=e;c=1}else c=1;break}case 3:{Egb(a,a+4|0,b+-4|0)|0;c=1;break}case 4:{Fgb(a,a+4|0,a+8|0,b+-4|0)|0;c=1;break}case 5:{Ggb(a,a+4|0,a+8|0,a+12|0,b+-4|0)|0;c=1;break}default:{d=a+8|0;Egb(a,a+4|0,d)|0;h=a+12|0;c=0;while(1){if((h|0)==(b|0)){d=1;c=0;break}g=k[h>>2]|0;f=k[d>>2]|0;if((g|0)<(f|0))e=h;else{d=h;h=h+4|0;continue}while(1){k[e>>2]=f;if((d|0)==(a|0)){d=a;break}e=d+-4|0;f=k[e>>2]|0;if((g|0)>=(f|0))break;else{i=d;d=e;e=i}}k[d>>2]=g;c=c+1|0;e=h+4|0;if((c|0)==8){d=0;c=(e|0)==(b|0);break}else{d=h;h=e}}c=c|d}}return c|0}function Igb(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0.0,g=0,h=0,i=0,j=0,l=0,m=0.0,n=0.0,p=0,q=0,r=0;q=b;a:while(1){j=q;l=q+-4|0;while(1){r=a;b:while(1){i=r;a=j-i|0;b=a>>2;switch(b|0){case 1:case 0:break a;case 2:{p=5;break a}case 3:{p=7;break a}case 4:{p=8;break a}case 5:{p=9;break a}default:{}}if((a|0)<124){p=11;break a}g=r+(((b|0)/2|0)<<2)|0;if((a|0)>3996){a=(b|0)/4|0;a=Lgb(r,r+(a<<2)|0,g,g+(a<<2)|0,l)|0}else a=Jgb(r,g,l)|0;f=+o[r>>2];c=+o[g>>2];if(f<c){b=l;break}else b=l;while(1){b=b+-4|0;if((r|0)==(b|0))break;d=+o[b>>2];if(d<c){p=35;break b}}a=r+4|0;d=+o[l>>2];if(!(f<d)){while(1){if((a|0)==(l|0))break a;c=+o[a>>2];if(f<c)break;a=a+4|0}o[a>>2]=d;o[l>>2]=c;a=a+4|0}if((a|0)==(l|0))break a;else b=l;while(1){f=+o[r>>2];while(1){d=+o[a>>2];e=a+4|0;if(f<d)break;else a=e}do{b=b+-4|0;c=+o[b>>2]}while(f<c);if(a>>>0>=b>>>0){r=a;continue b}o[a>>2]=c;o[b>>2]=d;a=e}}if((p|0)==35){p=0;o[r>>2]=d;o[b>>2]=f;a=a+1|0}e=r+4|0;c:do if(e>>>0<b>>>0){h=g;while(1){f=+o[h>>2];while(1){d=+o[e>>2];g=e+4|0;if(d<f)e=g;else break}do{b=b+-4|0;c=+o[b>>2]}while(!(c<f));if(e>>>0>b>>>0){b=h;break c}o[e>>2]=c;o[b>>2]=d;h=(h|0)==(e|0)?b:h;e=g;a=a+1|0}}else b=g;while(0);if((e|0)!=(b|0)?(m=+o[b>>2],n=+o[e>>2],m<n):0){o[e>>2]=m;o[b>>2]=n;a=a+1|0}if(!a){b=Mgb(r,e)|0;a=e+4|0;if(Mgb(a,q)|0){p=51;break}if(b)continue}h=e;if((h-i|0)>=(j-h|0)){p=50;break}Igb(r,e);a=e+4|0}if((p|0)==50){p=0;Igb(e+4|0,q);a=r;q=e;continue}else if((p|0)==51){p=0;if(b)break;else{a=r;q=e;continue}}}d:do if((p|0)==5){c=+o[l>>2];d=+o[r>>2];if(c<d){o[r>>2]=c;o[l>>2]=d}}else if((p|0)==7)Jgb(r,r+4|0,l)|0;else if((p|0)==8)Kgb(r,r+4|0,r+8|0,l)|0;else if((p|0)==9)Lgb(r,r+4|0,r+8|0,r+12|0,l)|0;else if((p|0)==11){a=r+8|0;Jgb(r,r+4|0,a)|0;e=r+12|0;while(1){if((e|0)==(q|0))break d;c=+o[e>>2];if(c<+o[a>>2]){b=e;while(1){k[b>>2]=k[a>>2];if((a|0)==(r|0)){a=r;break}b=a+-4|0;if(c<+o[b>>2]){p=a;a=b;b=p}else break}o[a>>2]=c}a=e;e=e+4|0}}while(0);return}function Jgb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;e=+o[b>>2];g=+o[a>>2];f=+o[c>>2];d=f<e;do if(e<g){if(d){o[a>>2]=f;o[c>>2]=g;d=1;break}o[a>>2]=e;o[b>>2]=g;e=+o[c>>2];if(e<g){o[b>>2]=e;o[c>>2]=g;d=2}else d=1}else if(d){o[b>>2]=f;o[c>>2]=e;e=+o[b>>2];f=+o[a>>2];if(e<f){o[a>>2]=e;o[b>>2]=f;d=2}else d=1}else d=0;while(0);return d|0}function Kgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0;e=Jgb(a,b,c)|0;f=+o[d>>2];g=+o[c>>2];if(f<g){o[c>>2]=f;o[d>>2]=g;d=e+1|0;g=+o[c>>2];f=+o[b>>2];if(g<f){o[b>>2]=g;o[c>>2]=f;f=+o[b>>2];g=+o[a>>2];if(f<g){o[a>>2]=f;o[b>>2]=g;e=e+3|0}else e=e+2|0}else e=d}return e|0}function Lgb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0;h=Kgb(a,b,c,d)|0;f=+o[e>>2];g=+o[d>>2];if(f<g){o[d>>2]=f;o[e>>2]=g;e=h+1|0;f=+o[d>>2];g=+o[c>>2];if(f<g){o[c>>2]=f;o[d>>2]=g;e=h+2|0;f=+o[c>>2];g=+o[b>>2];if(f<g){o[b>>2]=f;o[c>>2]=g;f=+o[b>>2];g=+o[a>>2];if(f<g){o[a>>2]=f;o[b>>2]=g;e=h+4|0}else e=h+3|0}}}else e=h;return e|0}function Mgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0.0,g=0,h=0,i=0;switch(b-a>>2|0){case 1:case 0:{c=1;break}case 2:{c=b+-4|0;e=+o[c>>2];f=+o[a>>2];if(e<f){o[a>>2]=e;o[c>>2]=f;c=1}else c=1;break}case 3:{Jgb(a,a+4|0,b+-4|0)|0;c=1;break}case 4:{Kgb(a,a+4|0,a+8|0,b+-4|0)|0;c=1;break}case 5:{Lgb(a,a+4|0,a+8|0,a+12|0,b+-4|0)|0;c=1;break}default:{d=a+8|0;Jgb(a,a+4|0,d)|0;h=a+12|0;c=0;while(1){if((h|0)==(b|0)){d=1;c=0;break}e=+o[h>>2];if(e<+o[d>>2])g=h;else{d=h;h=h+4|0;continue}while(1){k[g>>2]=k[d>>2];if((d|0)==(a|0)){d=a;break}g=d+-4|0;if(e<+o[g>>2]){i=d;d=g;g=i}else break}o[d>>2]=e;c=c+1|0;g=h+4|0;if((c|0)==8){d=0;c=(g|0)==(b|0);break}else{d=h;h=g}}c=c|d}}return c|0}function Ngb(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0,f=0,g=0.0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,q=0;a:while(1){k=b;l=b+-8|0;while(1){q=a;b:while(1){j=q;a=k-j|0;e=a>>3;switch(e|0){case 1:case 0:break a;case 2:{o=5;break a}case 3:{o=7;break a}case 4:{o=8;break a}case 5:{o=9;break a}default:{}}if((a|0)<248){o=11;break a}h=q+(((e|0)/2|0)<<3)|0;if((a|0)>7992){a=(e|0)/4|0;a=Qgb(q,q+(a<<3)|0,h,h+(a<<3)|0,l)|0}else a=Ogb(q,h,l)|0;g=+p[q>>3];c=+p[h>>3];if(g<c){e=l;break}else e=l;while(1){e=e+-8|0;if((q|0)==(e|0))break;d=+p[e>>3];if(d<c){o=35;break b}}a=q+8|0;d=+p[l>>3];if(!(g<d)){while(1){if((a|0)==(l|0))break a;c=+p[a>>3];if(g<c)break;a=a+8|0}p[a>>3]=d;p[l>>3]=c;a=a+8|0}if((a|0)==(l|0))break a;else e=l;while(1){g=+p[q>>3];while(1){d=+p[a>>3];f=a+8|0;if(g<d)break;else a=f}do{e=e+-8|0;c=+p[e>>3]}while(g<c);if(a>>>0>=e>>>0){q=a;continue b}p[a>>3]=c;p[e>>3]=d;a=f}}if((o|0)==35){o=0;p[q>>3]=d;p[e>>3]=g;a=a+1|0}f=q+8|0;c:do if(f>>>0<e>>>0){i=h;while(1){g=+p[i>>3];while(1){d=+p[f>>3];h=f+8|0;if(d<g)f=h;else break}do{e=e+-8|0;c=+p[e>>3]}while(!(c<g));if(f>>>0>e>>>0){e=i;break c}p[f>>3]=c;p[e>>3]=d;i=(i|0)==(f|0)?e:i;f=h;a=a+1|0}}else e=h;while(0);if((f|0)!=(e|0)?(m=+p[e>>3],n=+p[f>>3],m<n):0){p[f>>3]=m;p[e>>3]=n;a=a+1|0}if(!a){e=Rgb(q,f)|0;a=f+8|0;if(Rgb(a,b)|0){o=51;break}if(e)continue}i=f;if((i-j|0)>=(k-i|0)){o=50;break}Ngb(q,f);a=f+8|0}if((o|0)==50){o=0;Ngb(f+8|0,b);a=q;b=f;continue}else if((o|0)==51){o=0;if(e)break;else{a=q;b=f;continue}}}d:do if((o|0)==5){c=+p[l>>3];d=+p[q>>3];if(c<d){p[q>>3]=c;p[l>>3]=d}}else if((o|0)==7)Ogb(q,q+8|0,l)|0;else if((o|0)==8)Pgb(q,q+8|0,q+16|0,l)|0;else if((o|0)==9)Qgb(q,q+8|0,q+16|0,q+24|0,l)|0;else if((o|0)==11){a=q+16|0;Ogb(q,q+8|0,a)|0;f=q+24|0;while(1){if((f|0)==(b|0))break d;d=+p[f>>3];c=+p[a>>3];if(d<c){e=f;while(1){p[e>>3]=c;if((a|0)==(q|0)){a=q;break}e=a+-8|0;c=+p[e>>3];if(!(d<c))break;else{o=a;a=e;e=o}}p[a>>3]=d}a=f;f=f+8|0}}while(0);return}function Ogb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;e=+p[b>>3];g=+p[a>>3];f=+p[c>>3];d=f<e;do if(e<g){if(d){p[a>>3]=f;p[c>>3]=g;d=1;break}p[a>>3]=e;p[b>>3]=g;e=+p[c>>3];if(e<g){p[b>>3]=e;p[c>>3]=g;d=2}else d=1}else if(d){p[b>>3]=f;p[c>>3]=e;e=+p[b>>3];f=+p[a>>3];if(e<f){p[a>>3]=e;p[b>>3]=f;d=2}else d=1}else d=0;while(0);return d|0}function Pgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0;e=Ogb(a,b,c)|0;f=+p[d>>3];g=+p[c>>3];if(f<g){p[c>>3]=f;p[d>>3]=g;d=e+1|0;g=+p[c>>3];f=+p[b>>3];if(g<f){p[b>>3]=g;p[c>>3]=f;f=+p[b>>3];g=+p[a>>3];if(f<g){p[a>>3]=f;p[b>>3]=g;e=e+3|0}else e=e+2|0}else e=d}return e|0}function Qgb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0;h=Pgb(a,b,c,d)|0;f=+p[e>>3];g=+p[d>>3];if(f<g){p[d>>3]=f;p[e>>3]=g;e=h+1|0;f=+p[d>>3];g=+p[c>>3];if(f<g){p[c>>3]=f;p[d>>3]=g;e=h+2|0;f=+p[c>>3];g=+p[b>>3];if(f<g){p[b>>3]=f;p[c>>3]=g;f=+p[b>>3];g=+p[a>>3];if(f<g){p[a>>3]=f;p[b>>3]=g;e=h+4|0}else e=h+3|0}}}else e=h;return e|0}function Rgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0.0,g=0,h=0,i=0;switch(b-a>>3|0){case 1:case 0:{c=1;break}case 2:{c=b+-8|0;e=+p[c>>3];f=+p[a>>3];if(e<f){p[a>>3]=e;p[c>>3]=f;c=1}else c=1;break}case 3:{Ogb(a,a+8|0,b+-8|0)|0;c=1;break}case 4:{Pgb(a,a+8|0,a+16|0,b+-8|0)|0;c=1;break}case 5:{Qgb(a,a+8|0,a+16|0,a+24|0,b+-8|0)|0;c=1;break}default:{d=a+16|0;Ogb(a,a+8|0,d)|0;h=a+24|0;c=0;while(1){if((h|0)==(b|0)){d=1;c=0;break}f=+p[h>>3];e=+p[d>>3];if(f<e)g=h;else{d=h;h=h+8|0;continue}while(1){p[g>>3]=e;if((d|0)==(a|0)){d=a;break}g=d+-8|0;e=+p[g>>3];if(!(f<e))break;else{i=d;d=g;g=i}}p[d>>3]=f;c=c+1|0;g=h+8|0;if((c|0)==8){d=0;c=(g|0)==(b|0);break}else{d=h;h=g}}c=c|d}}return c|0}function Sgb(){var a=0,b=0,c=0,d=0;if(!(i[428008]|0)){i[428008]=1;k[207667]=5489;a=1;b=5489;while(1){if((a|0)==624)break;c=(aa(b>>>30^b,1812433253)|0)+a|0;k[830668+(a<<2)>>2]=c;a=a+1|0;b=c}k[208291]=0}d=k[208291]|0;b=((d+1|0)>>>0)%624|0;a=830668+(d<<2)|0;c=k[830668+(b<<2)>>2]|0;c=0-(c&1)&-1727483681^k[830668+((((d+397|0)>>>0)%624|0)<<2)>>2]^(c&2147483646|k[a>>2]&-2147483648)>>>1;k[a>>2]=c;c=c>>>11^c;k[208291]=b;c=c<<7&-1658038656^c;c=c<<15&-272236544^c;return c>>>18^c|0}function Tgb(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=169256;c=a+32|0;d=a+36|0;b=k[a+40>>2]|0;while(1){if(!b)break;e=b+-1|0;Ph[k[(k[c>>2]|0)+(e<<2)>>2]&511](0,a,k[(k[d>>2]|0)+(e<<2)>>2]|0);b=e}fob(k[a+28>>2]|0);ggb(k[c>>2]|0);ggb(k[d>>2]|0);ggb(k[a+48>>2]|0);ggb(k[a+60>>2]|0);return}function Ugb(a){a=a|0;Tgb(a);ggb(a);return}function Vgb(a){a=a|0;k[a>>2]=169272;fob(k[a+4>>2]|0);return}function Wgb(a){a=a|0;k[a>>2]=169272;fob(k[a+4>>2]|0);ggb(a);return}function Xgb(a,b){a=a|0;b=b|0;return}function Ygb(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function Zgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;f=a;k[f>>2]=0;k[f+4>>2]=0;f=a+8|0;k[f>>2]=-1;k[f+4>>2]=-1;return}function _gb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=a;k[d>>2]=0;k[d+4>>2]=0;d=a+8|0;k[d>>2]=-1;k[d+4>>2]=-1;return}function $gb(a){a=a|0;return 0}function ahb(a){a=a|0;return 0}function bhb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=a+12|0;g=a+16|0;e=0;while(1){if((e|0)>=(c|0))break;d=k[f>>2]|0;if(d>>>0<(k[g>>2]|0)>>>0){k[f>>2]=d+1;d=i[d>>0]|0}else{d=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;if((d|0)==-1)break;d=d&255}i[b>>0]=d;e=e+1|0;b=b+1|0}return e|0}function chb(a){a=a|0;return -1}function dhb(a){a=a|0;var b=0;if((Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1)a=-1;else{b=a+12|0;a=k[b>>2]|0;k[b>>2]=a+1;a=l[a>>0]|0}return a|0}function ehb(a,b){a=a|0;b=b|0;return -1}function fhb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;g=a+24|0;h=a+28|0;f=0;while(1){if((f|0)>=(c|0))break;d=k[g>>2]|0;e=k[h>>2]|0;if(d>>>0>=e>>>0){if((Hh[k[(k[a>>2]|0)+52>>2]&511](a,l[b>>0]|0)|0)==-1)break;b=b+1|0;f=f+1|0;continue}e=e-d|0;i=c-f|0;e=(i|0)<(e|0)?i:e;if(e){upb(d|0,b|0,e|0)|0;d=k[g>>2]|0}k[g>>2]=d+e;b=b+e|0;f=e+f|0}return f|0}function ghb(a,b){a=a|0;b=b|0;return -1}function hhb(a){a=a|0;k[a>>2]=169336;fob(k[a+4>>2]|0);return}function ihb(a){a=a|0;k[a>>2]=169336;fob(k[a+4>>2]|0);ggb(a);return}function jhb(a,b){a=a|0;b=b|0;return}function khb(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function lhb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;f=a;k[f>>2]=0;k[f+4>>2]=0;f=a+8|0;k[f>>2]=-1;k[f+4>>2]=-1;return}function mhb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=a;k[d>>2]=0;k[d+4>>2]=0;d=a+8|0;k[d>>2]=-1;k[d+4>>2]=-1;return}function nhb(a){a=a|0;return 0}function ohb(a){a=a|0;return 0}function phb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=a+12|0;g=a+16|0;e=0;while(1){if((e|0)>=(c|0))break;d=k[f>>2]|0;if(d>>>0>=(k[g>>2]|0)>>>0){d=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;if((d|0)==-1)break}else{k[f>>2]=d+4;d=k[d>>2]|0}k[b>>2]=d;e=e+1|0;b=b+4|0}return e|0}function qhb(a){a=a|0;return -1}function rhb(a){a=a|0;var b=0;if((Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1)a=-1;else{b=a+12|0;a=k[b>>2]|0;k[b>>2]=a+4;a=k[a>>2]|0}return a|0}function shb(a,b){a=a|0;b=b|0;return -1}function thb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;g=a+24|0;h=a+28|0;d=0;while(1){if((d|0)>=(c|0))break;e=k[g>>2]|0;f=k[h>>2]|0;if(e>>>0<f>>>0){f=f-e>>2;i=c-d|0;f=(i|0)<(f|0)?i:f;vhb(e,b,f);k[g>>2]=(k[g>>2]|0)+(f<<2);b=b+(f<<2)|0;d=f+d|0;continue}if((Hh[k[(k[a>>2]|0)+52>>2]&511](a,k[b>>2]|0)|0)==-1)break;b=b+4|0;d=d+1|0}return d|0}function uhb(a,b){a=a|0;b=b|0;return -1}function vhb(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)while(1){c=c+-1|0;k[a>>2]=k[b>>2];if(!c)break;else{b=b+4|0;a=a+4|0}}return}function whb(a){a=a|0;Tgb(a+8|0);return}function xhb(a){a=a|0;Tgb(a+8|0);ggb(a);return}function yhb(a){a=a|0;Tgb(a+(k[(k[a>>2]|0)+-12>>2]|0)+8|0);return}function zhb(a){a=a|0;xhb(a+(k[(k[a>>2]|0)+-12>>2]|0)|0);return}function Ahb(a){a=a|0;Tgb(a+8|0);return}function Bhb(a){a=a|0;Tgb(a+8|0);ggb(a);return}function Chb(a){a=a|0;Tgb(a+(k[(k[a>>2]|0)+-12>>2]|0)+8|0);return}function Dhb(a){a=a|0;Bhb(a+(k[(k[a>>2]|0)+-12>>2]|0)|0);return}function Ehb(a){a=a|0;Tgb(a+4|0);return}function Fhb(a){a=a|0;Tgb(a+4|0);ggb(a);return}function Ghb(a){a=a|0;Tgb(a+(k[(k[a>>2]|0)+-12>>2]|0)+4|0);return}function Hhb(a){a=a|0;Fhb(a+(k[(k[a>>2]|0)+-12>>2]|0)|0);return}function Ihb(a){a=a|0;Tgb(a+4|0);return}function Jhb(a){a=a|0;Tgb(a+4|0);ggb(a);return}function Khb(a){a=a|0;Tgb(a+(k[(k[a>>2]|0)+-12>>2]|0)+4|0);return}function Lhb(a){a=a|0;Jhb(a+(k[(k[a>>2]|0)+-12>>2]|0)|0);return}function Mhb(a,b){a=a|0;b=b|0;var c=0;k[a+24>>2]=b;k[a+16>>2]=(b|0)==0&1;k[a+20>>2]=0;k[a+4>>2]=4098;k[a+12>>2]=0;k[a+8>>2]=6;c=a+28|0;b=a+32|0;a=b+40|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(a|0));eob(c);return}function Nhb(a){a=a|0;k[a>>2]=169272;eob(a+4|0);a=a+8|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;return}function Ohb(a){a=a|0;k[a>>2]=169336;eob(a+4|0);a=a+8|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;return}function Phb(a){a=a|0;var b=0,c=0,d=0;c=r;r=r+16|0;b=c;if(k[a+(k[(k[a>>2]|0)+-12>>2]|0)+24>>2]|0){Qhb(b,a);if(i[b>>0]|0?(d=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[d>>2]|0)+24>>2]&1023](d)|0)==-1):0){d=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[d>>2]=k[d>>2]|1}Rhb(b)}r=c;return}function Qhb(a,b){a=a|0;b=b|0;i[a>>0]=0;k[a+4>>2]=b;b=b+(k[(k[b>>2]|0)+-12>>2]|0)|0;if(!(k[b+16>>2]|0)){b=k[b+72>>2]|0;if(b|0)Phb(b);i[a>>0]=1}return}function Rhb(a){a=a|0;var b=0;a=a+4|0;b=k[a>>2]|0;b=b+(k[(k[b>>2]|0)+-12>>2]|0)|0;if((((k[b+24>>2]|0?(k[b+16>>2]|0)==0:0)?k[b+4>>2]&8192|0:0)?!(bd()|0):0)?(b=k[a>>2]|0,b=k[b+(k[(k[b>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[b>>2]|0)+24>>2]&1023](b)|0)==-1):0){b=k[a>>2]|0;b=b+(k[(k[b>>2]|0)+-12>>2]|0)+16|0;k[b>>2]=k[b>>2]|1}return}function Shb(a){a=a|0;var b=0,c=0;c=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;b=k[c+24>>2]|0;if(b|0){if(!(k[c+16>>2]|0)){c=k[c+72>>2]|0;if(c){Shb(c);b=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+24>>2]|0}if((Xh[k[(k[b>>2]|0)+24>>2]&1023](b)|0)==-1){c=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[c>>2]=k[c>>2]|1}}c=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;if((((k[c+24>>2]|0?(k[c+16>>2]|0)==0:0)?k[c+4>>2]&8192|0:0)?!(bd()|0):0)?(c=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[c>>2]|0)+24>>2]&1023](c)|0)==-1):0){a=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[a>>2]=k[a>>2]|1}}return}function Thb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;m=r;r=r+16|0;e=m+12|0;h=m+8|0;l=m;Qhb(l,a);if(i[l>>0]|0){g=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+28>>2]|0;f=g+4|0;k[f>>2]=(k[f>>2]|0)+1;f=Sib(g,828828)|0;fob(g);g=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;j=k[g+24>>2]|0;d=g+76|0;c=k[d>>2]|0;if((c|0)==-1){n=k[g+28>>2]|0;c=n+4|0;k[c>>2]=(k[c>>2]|0)+1;c=Sib(n,828772)|0;c=Hh[k[(k[c>>2]|0)+28>>2]&511](c,32)|0;fob(n);c=c<<24>>24;k[d>>2]=c}n=k[(k[f>>2]|0)+16>>2]|0;k[h>>2]=j;k[e>>2]=k[h>>2];if(!($g[n&127](f,e,g,c&255,b)|0)){n=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[n>>2]=k[n>>2]|5}}Rhb(l);r=m;return}function Uhb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;m=r;r=r+16|0;e=m+12|0;h=m+8|0;l=m;Qhb(l,a);if(i[l>>0]|0){g=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+28>>2]|0;f=g+4|0;k[f>>2]=(k[f>>2]|0)+1;f=Sib(g,828828)|0;fob(g);g=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;j=k[g+24>>2]|0;d=g+76|0;c=k[d>>2]|0;if((c|0)==-1){n=k[g+28>>2]|0;c=n+4|0;k[c>>2]=(k[c>>2]|0)+1;c=Sib(n,828772)|0;c=Hh[k[(k[c>>2]|0)+28>>2]&511](c,32)|0;fob(n);c=c<<24>>24;k[d>>2]=c}n=k[(k[f>>2]|0)+40>>2]|0;k[h>>2]=j;k[e>>2]=k[h>>2];if(!($g[n&127](f,e,g,c&255,b)|0)){n=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[n>>2]=k[n>>2]|5}}Rhb(l);r=m;return}function Vhb(){var a=0,b=0,c=0,d=0;a=r;r=r+16|0;c=a;Nhb(828404);k[207101]=169752;k[207109]=165684;k[207111]=828460;k[207113]=-1;i[828456]=0;b=k[207102]|0;d=b+4|0;k[d>>2]=(k[d>>2]|0)+1;k[c>>2]=b;oib(828404,c);fob(b);k[206931]=169404;k[206933]=169424;k[206932]=0;Mhb(827732,828404);k[206951]=0;k[206952]=-1;Ohb(828468);k[207117]=169688;k[207125]=165684;k[207127]=828524;k[207129]=-1;i[828520]=0;b=k[207118]|0;d=b+4|0;k[d>>2]=(k[d>>2]|0)+1;k[c>>2]=b;iib(828468,c);fob(b);k[206953]=169444;k[206955]=169464;k[206954]=0;Mhb(827820,828468);k[206973]=0;k[206974]=-1;Yhb(828532,165796,828580);k[206975]=169484;k[206976]=169504;Mhb(827904,828532);k[206994]=0;k[206995]=-1;Zhb(828588,165796,828636);k[206996]=169524;k[206997]=169544;Mhb(827988,828588);k[207015]=0;k[207016]=-1;Yhb(828644,165912,828692);k[207017]=169484;k[207018]=169504;Mhb(828072,828644);k[207036]=0;k[207037]=-1;b=k[828068+(k[(k[207017]|0)+-12>>2]|0)+24>>2]|0;k[207059]=169484;k[207060]=169504;Mhb(828240,b);k[207078]=0;k[207079]=-1;Zhb(828700,165912,828748);k[207038]=169524;k[207039]=169544;Mhb(828156,828700);k[207057]=0;k[207058]=-1;b=k[828152+(k[(k[207038]|0)+-12>>2]|0)+24>>2]|0;k[207080]=169524;k[207081]=169544;Mhb(828324,b);k[207099]=0;k[207100]=-1;k[827724+(k[(k[206931]|0)+-12>>2]|0)+72>>2]=827900;k[827812+(k[(k[206953]|0)+-12>>2]|0)+72>>2]=827984;b=828068+(k[(k[207017]|0)+-12>>2]|0)+4|0;k[b>>2]=k[b>>2]|8192;b=828152+(k[(k[207038]|0)+-12>>2]|0)+4|0;k[b>>2]=k[b>>2]|8192;k[828068+(k[(k[207017]|0)+-12>>2]|0)+72>>2]=827900;k[828152+(k[(k[207038]|0)+-12>>2]|0)+72>>2]=827984;ud(1526,1016758,x|0)|0;r=a;return}function Whb(){return}function Xhb(a){a=a|0;Phb(827900);Shb(827984);Phb(828236);Shb(828320);return}function Yhb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;Nhb(a);k[a>>2]=169624;k[a+32>>2]=b;d=k[a+4>>2]|0;b=d+4|0;k[b>>2]=(k[b>>2]|0)+1;b=Sib(d,830540)|0;fob(d);k[a+36>>2]=b;k[a+40>>2]=c;c=(Xh[k[(k[b>>2]|0)+28>>2]&1023](b)|0)&1;i[a+44>>0]=c;return}function Zhb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;Ohb(a);k[a>>2]=169560;k[a+32>>2]=b;d=k[a+4>>2]|0;b=d+4|0;k[b>>2]=(k[b>>2]|0)+1;b=Sib(d,830548)|0;fob(d);k[a+36>>2]=b;k[a+40>>2]=c;c=(Xh[k[(k[b>>2]|0)+28>>2]&1023](b)|0)&1;i[a+44>>0]=c;return}function _hb(a){a=a|0;hhb(a);ggb(a);return}function $hb(a,b){a=a|0;b=b|0;Xh[k[(k[a>>2]|0)+24>>2]&1023](a)|0;b=Sib(k[b>>2]|0,830548)|0;k[a+36>>2]=b;b=(Xh[k[(k[b>>2]|0)+28>>2]&1023](b)|0)&1;i[a+44>>0]=b;return}function aib(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+16|0;c=j+8|0;d=j;e=a+36|0;f=a+40|0;g=c+8|0;h=c;b=a+32|0;a:while(1){a=k[e>>2]|0;a=$g[k[(k[a>>2]|0)+20>>2]&127](a,k[f>>2]|0,c,g,d)|0;l=(k[d>>2]|0)-h|0;if((cgb(c,1,l,k[b>>2]|0)|0)!=(l|0)){a=-1;break}switch(a|0){case 1:break;case 2:{a=-1;break a}default:{i=4;break a}}}if((i|0)==4)a=((Rfb(k[b>>2]|0)|0)!=0)<<31>>31;r=j;return a|0}function bib(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:do if(!(i[a+44>>0]|0)){d=0;while(1){if((d|0)>=(c|0))break a;if((Hh[k[(k[a>>2]|0)+52>>2]&511](a,k[b>>2]|0)|0)==-1)break a;d=d+1|0;b=b+4|0}}else d=cgb(b,4,c,k[a+32>>2]|0)|0;while(0);return d|0}function cib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+32|0;l=p+16|0;d=p+8|0;m=p+4|0;n=p;o=(b|0)==-1;do if(!o){k[d>>2]=b;if(i[a+44>>0]|0)if((cgb(d,4,1,k[a+32>>2]|0)|0)==1){c=14;break}else{a=-1;break}k[m>>2]=l;c=d+4|0;e=a+36|0;f=a+40|0;g=l+8|0;h=l;j=a+32|0;while(1){a=k[e>>2]|0;a=si[k[(k[a>>2]|0)+12>>2]&15](a,k[f>>2]|0,d,c,n,l,g,m)|0;if((k[n>>2]|0)==(d|0)){c=13;break}if((a|0)==3){c=7;break}if((a|1|0)!=1){c=13;break}d=(k[m>>2]|0)-h|0;if((cgb(l,1,d,k[j>>2]|0)|0)!=(d|0)){c=13;break}if((a|0)==1)d=k[n>>2]|0;else{c=12;break}}if((c|0)==7)if((cgb(d,1,1,k[j>>2]|0)|0)==1)c=12;else c=13;if((c|0)==12){c=14;break}else if((c|0)==13){a=-1;break}}else c=14;while(0);if((c|0)==14)a=o?0:b;r=p;return a|0}function dib(a){a=a|0;Vgb(a);ggb(a);return}function eib(a,b){a=a|0;b=b|0;Xh[k[(k[a>>2]|0)+24>>2]&1023](a)|0;b=Sib(k[b>>2]|0,830540)|0;k[a+36>>2]=b;b=(Xh[k[(k[b>>2]|0)+28>>2]&1023](b)|0)&1;i[a+44>>0]=b;return}function fib(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=r;r=r+16|0;c=j+8|0;d=j;e=a+36|0;f=a+40|0;g=c+8|0;h=c;b=a+32|0;a:while(1){a=k[e>>2]|0;a=$g[k[(k[a>>2]|0)+20>>2]&127](a,k[f>>2]|0,c,g,d)|0;l=(k[d>>2]|0)-h|0;if((cgb(c,1,l,k[b>>2]|0)|0)!=(l|0)){a=-1;break}switch(a|0){case 1:break;case 2:{a=-1;break a}default:{i=4;break a}}}if((i|0)==4)a=((Rfb(k[b>>2]|0)|0)!=0)<<31>>31;r=j;return a|0}function gib(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:do if(!(i[a+44>>0]|0)){d=0;while(1){if((d|0)>=(c|0))break a;if((Hh[k[(k[a>>2]|0)+52>>2]&511](a,l[b>>0]|0)|0)==-1)break a;d=d+1|0;b=b+1|0}}else d=cgb(b,1,c,k[a+32>>2]|0)|0;while(0);return d|0}function hib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+32|0;l=p+16|0;d=p+8|0;m=p+4|0;n=p;o=(b|0)==-1;do if(!o){i[d>>0]=b;if(i[a+44>>0]|0)if((cgb(d,1,1,k[a+32>>2]|0)|0)==1){c=14;break}else{a=-1;break}k[m>>2]=l;c=d+1|0;e=a+36|0;f=a+40|0;g=l+8|0;h=l;j=a+32|0;while(1){a=k[e>>2]|0;a=si[k[(k[a>>2]|0)+12>>2]&15](a,k[f>>2]|0,d,c,n,l,g,m)|0;if((k[n>>2]|0)==(d|0)){c=13;break}if((a|0)==3){c=7;break}if((a|1|0)!=1){c=13;break}d=(k[m>>2]|0)-h|0;if((cgb(l,1,d,k[j>>2]|0)|0)!=(d|0)){c=13;break}if((a|0)==1)d=k[n>>2]|0;else{c=12;break}}if((c|0)==7)if((cgb(d,1,1,k[j>>2]|0)|0)==1)c=12;else c=13;if((c|0)==12){c=14;break}else if((c|0)==13){a=-1;break}}else c=14;while(0);if((c|0)==14)a=o?0:b;r=p;return a|0}function iib(a,b){a=a|0;b=b|0;var c=0;c=Sib(k[b>>2]|0,830548)|0;b=a+36|0;k[b>>2]=c;c=Xh[k[(k[c>>2]|0)+24>>2]&1023](c)|0;k[a+44>>2]=c;b=k[b>>2]|0;b=(Xh[k[(k[b>>2]|0)+28>>2]&1023](b)|0)&1;i[a+53>>0]=b;return}function jib(a){a=a|0;hhb(a);ggb(a);return}function kib(a){a=a|0;return nib(a,0)|0}function lib(a){a=a|0;return nib(a,1)|0}function mib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;l=r;r=r+32|0;g=l+16|0;h=l+8|0;d=l+4|0;e=l;j=a+52|0;c=(i[j>>0]|0)!=0;a:do if((b|0)==-1)if(c)b=-1;else{b=k[a+48>>2]|0;i[j>>0]=(b|0)!=-1&1}else{b:do if(c){c=a+48|0;k[d>>2]=k[c>>2];m=k[a+36>>2]|0;switch(si[k[(k[m>>2]|0)+12>>2]&15](m,k[a+40>>2]|0,d,d+4|0,e,g,g+8|0,h)|0){case 1:case 2:break;case 3:{i[g>>0]=k[c>>2];k[h>>2]=g+1;f=8;break}default:f=8}c:do if((f|0)==8){a=a+32|0;while(1){d=k[h>>2]|0;if(d>>>0<=g>>>0)break;m=d+-1|0;k[h>>2]=m;if((bgb(i[m>>0]|0,k[a>>2]|0)|0)==-1)break c}break b}while(0);b=-1;break a}else c=a+48|0;while(0);k[c>>2]=b;i[j>>0]=1}while(0);r=l;return b|0}function nib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;s=r;r=r+32|0;o=s+16|0;p=s+8|0;l=s+4|0;m=s;e=a+52|0;if(i[e>>0]|0){d=a+48|0;c=k[d>>2]|0;if(b){k[d>>2]=-1;i[e>>0]=0}}else{c=k[a+44>>2]|0;c=(c|0)>1?c:1;n=a+32|0;d=0;while(1){if((d|0)>=(c|0)){q=8;break}e=egb(k[n>>2]|0)|0;if((e|0)==-1){c=-1;break}i[o+d>>0]=e;d=d+1|0}if((q|0)==8){do if(!(i[a+53>>0]|0)){g=a+40|0;h=a+36|0;j=p+4|0;a:while(1){t=k[g>>2]|0;e=t;d=k[e>>2]|0;e=k[e+4>>2]|0;u=k[h>>2]|0;f=o+c|0;switch(si[k[(k[u>>2]|0)+16>>2]&15](u,t,o,f,l,p,j,m)|0){case 3:{q=15;break a}case 2:{q=17;break a}case 1:break;default:break a}u=k[g>>2]|0;k[u>>2]=d;k[u+4>>2]=e;if((c|0)==8){q=17;break}d=egb(k[n>>2]|0)|0;if((d|0)==-1){q=17;break}i[f>>0]=d;c=c+1|0}if((q|0)==15)k[p>>2]=i[o>>0];else if((q|0)==17){c=-1;break}q=18}else{k[p>>2]=i[o>>0];q=18}while(0);b:do if((q|0)==18){if(b){c=k[p>>2]|0;k[a+48>>2]=c;break}while(1){if((c|0)<=0)break;c=c+-1|0;if((bgb(i[o+c>>0]|0,k[n>>2]|0)|0)==-1){c=-1;break b}}c=k[p>>2]|0}while(0)}}r=s;return c|0}function oib(a,b){a=a|0;b=b|0;var c=0;c=Sib(k[b>>2]|0,830540)|0;b=a+36|0;k[b>>2]=c;c=Xh[k[(k[c>>2]|0)+24>>2]&1023](c)|0;k[a+44>>2]=c;b=k[b>>2]|0;b=(Xh[k[(k[b>>2]|0)+28>>2]&1023](b)|0)&1;i[a+53>>0]=b;return}function pib(a){a=a|0;Vgb(a);ggb(a);return}function qib(a){a=a|0;return tib(a,0)|0}function rib(a){a=a|0;return tib(a,1)|0}function sib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;l=r;r=r+32|0;g=l+16|0;h=l+4|0;d=l+8|0;e=l;j=a+52|0;c=(i[j>>0]|0)!=0;a:do if((b|0)==-1)if(c)b=-1;else{b=k[a+48>>2]|0;i[j>>0]=(b|0)!=-1&1}else{b:do if(c){c=a+48|0;i[d>>0]=k[c>>2];m=k[a+36>>2]|0;switch(si[k[(k[m>>2]|0)+12>>2]&15](m,k[a+40>>2]|0,d,d+1|0,e,g,g+8|0,h)|0){case 1:case 2:break;case 3:{i[g>>0]=k[c>>2];k[h>>2]=g+1;f=8;break}default:f=8}c:do if((f|0)==8){a=a+32|0;while(1){d=k[h>>2]|0;if(d>>>0<=g>>>0)break;m=d+-1|0;k[h>>2]=m;if((bgb(i[m>>0]|0,k[a>>2]|0)|0)==-1)break c}break b}while(0);b=-1;break a}else c=a+48|0;while(0);k[c>>2]=b;i[j>>0]=1}while(0);r=l;return b|0}function tib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;t=r;r=r+32|0;p=t+16|0;q=t+8|0;m=t+4|0;n=t;e=a+52|0;if(i[e>>0]|0){d=a+48|0;c=k[d>>2]|0;if(b){k[d>>2]=-1;i[e>>0]=0}}else{c=k[a+44>>2]|0;c=(c|0)>1?c:1;o=a+32|0;d=0;while(1){if((d|0)>=(c|0)){s=8;break}e=egb(k[o>>2]|0)|0;if((e|0)==-1){c=-1;break}i[p+d>>0]=e;d=d+1|0}if((s|0)==8){do if(!(i[a+53>>0]|0)){g=a+40|0;h=a+36|0;j=q+1|0;a:while(1){u=k[g>>2]|0;e=u;d=k[e>>2]|0;e=k[e+4>>2]|0;v=k[h>>2]|0;f=p+c|0;switch(si[k[(k[v>>2]|0)+16>>2]&15](v,u,p,f,m,q,j,n)|0){case 3:{s=15;break a}case 2:{s=17;break a}case 1:break;default:break a}v=k[g>>2]|0;k[v>>2]=d;k[v+4>>2]=e;if((c|0)==8){s=17;break}d=egb(k[o>>2]|0)|0;if((d|0)==-1){s=17;break}i[f>>0]=d;c=c+1|0}if((s|0)==15)i[q>>0]=i[p>>0]|0;else if((s|0)==17){c=-1;break}s=18}else{i[q>>0]=i[p>>0]|0;s=18}while(0);b:do if((s|0)==18){if(b){c=i[q>>0]|0;k[a+48>>2]=c&255}else{while(1){if((c|0)<=0)break;c=c+-1|0;if((bgb(l[p+c>>0]|0,k[o>>2]|0)|0)==-1){c=-1;break b}}c=i[q>>0]|0}c=c&255}while(0)}}r=t;return c|0}function uib(a){a=a|0;return}function vib(a){a=a|0;ggb(a);return}function wib(a){a=a|0;if(a|0)Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function xib(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a=b;while(1){if((d|0)==(e|0)){g=7;break}if((a|0)==(c|0)){a=-1;break}b=i[a>>0]|0;f=i[d>>0]|0;if(b<<24>>24<f<<24>>24){a=-1;break}if(f<<24>>24<b<<24>>24){a=1;break}d=d+1|0;a=a+1|0}if((g|0)==7)a=(a|0)!=(c|0)&1;return a|0}function yib(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;f=d-c|0;if(f>>>0>4294967279)hob();if(f>>>0<11){i[a+11>>0]=f;e=a}else{b=f+16&-16;e=gob(b)|0;k[a>>2]=e;k[a+8>>2]=b|-2147483648;k[a+4>>2]=f}b=c;a=e;while(1){if((b|0)==(d|0))break;i[a>>0]=i[b>>0]|0;b=b+1|0;a=a+1|0}i[e+f>>0]=0;return}function zib(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=0;while(1){if((b|0)==(c|0))break;d=(i[b>>0]|0)+(a<<4)|0;e=d&-268435456;a=(e>>>24|e)^d;b=b+1|0}return a|0}function Aib(a){a=a|0;return}function Bib(a){a=a|0;ggb(a);return}function Cib(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a=b;while(1){if((d|0)==(e|0)){g=7;break}if((a|0)==(c|0)){a=-1;break}b=k[a>>2]|0;f=k[d>>2]|0;if((b|0)<(f|0)){a=-1;break}if((f|0)<(b|0)){a=1;break}d=d+4|0;a=a+4|0}if((g|0)==7)a=(a|0)!=(c|0)&1;return a|0}function Dib(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;f=d-c|0;e=f>>2;if(e>>>0>1073741807)hob();do if(e>>>0>=2){b=e+4&-4;if(b>>>0>1073741823)ad(426832,426869,1734,426947);else{g=gob(b<<2)|0;k[a>>2]=g;k[a+8>>2]=b|-2147483648;k[a+4>>2]=e;break}}else{i[a+8+3>>0]=e;g=a}while(0);b=g;while(1){if((c|0)==(d|0))break;k[b>>2]=k[c>>2];c=c+4|0;b=b+4|0}k[g+(f>>>2<<2)>>2]=0;return}function Eib(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=0;while(1){if((b|0)==(c|0))break;d=(k[b>>2]|0)+(a<<4)|0;e=d&-268435456;a=(e>>>24|e)^d;b=b+4|0}return a|0}function Fib(a){a=a|0;return}function Gib(a){a=a|0;ggb(a);return}function Hib(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0;n=r;r=r+48|0;m=n+16|0;g=n+12|0;l=n+8|0;h=n+4|0;j=n;if(!(k[d+4>>2]&1)){k[l>>2]=-1;o=k[(k[a>>2]|0)+16>>2]|0;k[h>>2]=k[b>>2];k[j>>2]=k[c>>2];k[g>>2]=k[h>>2];k[m>>2]=k[j>>2];g=Sf[o&127](a,g,m,d,e,l)|0;k[b>>2]=g;switch(k[l>>2]|0){case 0:{i[f>>0]=0;break}case 1:{i[f>>0]=1;break}default:{i[f>>0]=1;k[e>>2]=4}}}else{o=d+28|0;a=k[o>>2]|0;g=a+4|0;k[g>>2]=(k[g>>2]|0)+1;g=Sib(a,828772)|0;fob(a);o=k[o>>2]|0;a=o+4|0;k[a>>2]=(k[a>>2]|0)+1;a=Sib(o,828788)|0;fob(o);jh[k[(k[a>>2]|0)+24>>2]&1023](m,a);jh[k[(k[a>>2]|0)+28>>2]&1023](m+12|0,a);a=m+24|0;g=(kjb(b,k[c>>2]|0,m,a,g,e,1)|0)==(m|0)&1;i[f>>0]=g;g=k[b>>2]|0;do{a=a+-12|0;kob(a)}while((a|0)!=(m|0))}r=n;return g|0}function Iib(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=r;r=r+224|0;t=A+198|0;g=A+196|0;y=A+184|0;z=A+172|0;w=A+168|0;x=A+8|0;u=A+4|0;v=A;h=k[b>>2]|0;c=k[c>>2]|0;b=k[d+4>>2]|0;djb(y,d,t,g);k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[z+(a<<2)>>2]=0;a=a+1|0}s=cjb(b)|0;p=z+11|0;q=z+8|0;if((i[p>>0]|0)<0)a=(k[q>>2]&2147483647)+-1|0;else a=10;oob(z,a);d=(i[p>>0]|0)<0?k[z>>2]|0:z;k[w>>2]=d;k[u>>2]=x;k[v>>2]=0;o=z+4|0;n=i[g>>0]|0;a=h;b=h;a:while(1){if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){m=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;a=m?0:a;b=m?0:b}}else a=0;h=(a|0)==0;g=c;do if(c){if((k[g+12>>2]|0)!=(k[g+16>>2]|0))if(h)break;else break a;if((Xh[k[(k[c>>2]|0)+36>>2]&1023](g)|0)!=-1){if(!h)break a}else{c=0;B=14}}else B=14;while(0);if((B|0)==14){B=0;if(h){a=0;g=0;break}else g=0}h=i[p>>0]|0;h=h<<24>>24<0?k[o>>2]|0:h&255;if((k[w>>2]|0)==(d+h|0)){oob(z,h<<1);if((i[p>>0]|0)<0)d=(k[q>>2]&2147483647)+-1|0;else d=10;oob(z,d);d=(i[p>>0]|0)<0?k[z>>2]|0:z;k[w>>2]=d+h}j=a+12|0;h=k[j>>2]|0;m=a+16|0;if((h|0)==(k[m>>2]|0))h=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else h=l[h>>0]|0;if(Tib(h&255,s,d,w,v,n,y,x,u,t)|0)break;g=k[j>>2]|0;if((g|0)==(k[m>>2]|0)){Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;continue}else{k[j>>2]=g+1;continue}}t=i[y+11>>0]|0;c=k[u>>2]|0;if(((t<<24>>24<0?k[y+4>>2]|0:t&255)|0)!=0?(c-x|0)<160:0){t=k[v>>2]|0;v=c+4|0;k[u>>2]=v;k[c>>2]=t;c=v}w=jjb(d,k[w>>2]|0,e,s)|0;k[f>>2]=w;$ib(y,x,c,e);if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){f=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;b=f?0:b;a=f?0:a}}else a=0;a=(a|0)==0;do if(g){if((k[g+12>>2]|0)==(k[g+16>>2]|0)?(Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0)==-1:0){B=37;break}if(!a)B=38}else B=37;while(0);if((B|0)==37?a:0)B=38;if((B|0)==38)k[e>>2]=k[e>>2]|2;kob(z);kob(y);r=A;return b|0}function Jib(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=r;r=r+224|0;t=A+198|0;g=A+196|0;y=A+184|0;z=A+172|0;w=A+168|0;x=A+8|0;u=A+4|0;v=A;h=k[b>>2]|0;c=k[c>>2]|0;b=k[d+4>>2]|0;djb(y,d,t,g);k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[z+(a<<2)>>2]=0;a=a+1|0}s=cjb(b)|0;p=z+11|0;q=z+8|0;if((i[p>>0]|0)<0)a=(k[q>>2]&2147483647)+-1|0;else a=10;oob(z,a);d=(i[p>>0]|0)<0?k[z>>2]|0:z;k[w>>2]=d;k[u>>2]=x;k[v>>2]=0;o=z+4|0;n=i[g>>0]|0;a=h;b=h;a:while(1){if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){m=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;a=m?0:a;b=m?0:b}}else a=0;h=(a|0)==0;g=c;do if(c){if((k[g+12>>2]|0)!=(k[g+16>>2]|0))if(h)break;else break a;if((Xh[k[(k[c>>2]|0)+36>>2]&1023](g)|0)!=-1){if(!h)break a}else{c=0;B=14}}else B=14;while(0);if((B|0)==14){B=0;if(h){a=0;g=0;break}else g=0}h=i[p>>0]|0;h=h<<24>>24<0?k[o>>2]|0:h&255;if((k[w>>2]|0)==(d+h|0)){oob(z,h<<1);if((i[p>>0]|0)<0)d=(k[q>>2]&2147483647)+-1|0;else d=10;oob(z,d);d=(i[p>>0]|0)<0?k[z>>2]|0:z;k[w>>2]=d+h}j=a+12|0;h=k[j>>2]|0;m=a+16|0;if((h|0)==(k[m>>2]|0))h=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else h=l[h>>0]|0;if(Tib(h&255,s,d,w,v,n,y,x,u,t)|0)break;g=k[j>>2]|0;if((g|0)==(k[m>>2]|0)){Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;continue}else{k[j>>2]=g+1;continue}}t=i[y+11>>0]|0;c=k[u>>2]|0;if(((t<<24>>24<0?k[y+4>>2]|0:t&255)|0)!=0?(c-x|0)<160:0){t=k[v>>2]|0;v=c+4|0;k[u>>2]=v;k[c>>2]=t;c=v}w=ijb(d,k[w>>2]|0,e,s)|0;k[f>>2]=w;k[f+4>>2]=N;$ib(y,x,c,e);if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){f=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;b=f?0:b;a=f?0:a}}else a=0;a=(a|0)==0;do if(g){if((k[g+12>>2]|0)==(k[g+16>>2]|0)?(Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0)==-1:0){B=37;break}if(!a)B=38}else B=37;while(0);if((B|0)==37?a:0)B=38;if((B|0)==38)k[e>>2]=k[e>>2]|2;kob(z);kob(y);r=A;return b|0}function Kib(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;B=r;r=r+224|0;u=B+198|0;g=B+196|0;z=B+184|0;A=B+172|0;x=B+168|0;y=B+8|0;v=B+4|0;w=B;h=k[b>>2]|0;c=k[c>>2]|0;b=k[d+4>>2]|0;djb(z,d,u,g);k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[A+(a<<2)>>2]=0;a=a+1|0}t=cjb(b)|0;q=A+11|0;s=A+8|0;if((i[q>>0]|0)<0)a=(k[s>>2]&2147483647)+-1|0;else a=10;oob(A,a);d=(i[q>>0]|0)<0?k[A>>2]|0:A;k[x>>2]=d;k[v>>2]=y;k[w>>2]=0;p=A+4|0;o=i[g>>0]|0;a=h;b=h;a:while(1){if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){n=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;a=n?0:a;b=n?0:b}}else a=0;h=(a|0)==0;g=c;do if(c){if((k[g+12>>2]|0)!=(k[g+16>>2]|0))if(h)break;else break a;if((Xh[k[(k[c>>2]|0)+36>>2]&1023](g)|0)!=-1){if(!h)break a}else{c=0;C=14}}else C=14;while(0);if((C|0)==14){C=0;if(h){a=0;g=0;break}else g=0}h=i[q>>0]|0;h=h<<24>>24<0?k[p>>2]|0:h&255;if((k[x>>2]|0)==(d+h|0)){oob(A,h<<1);if((i[q>>0]|0)<0)d=(k[s>>2]&2147483647)+-1|0;else d=10;oob(A,d);d=(i[q>>0]|0)<0?k[A>>2]|0:A;k[x>>2]=d+h}m=a+12|0;h=k[m>>2]|0;n=a+16|0;if((h|0)==(k[n>>2]|0))h=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else h=l[h>>0]|0;if(Tib(h&255,t,d,x,w,o,z,y,v,u)|0)break;g=k[m>>2]|0;if((g|0)==(k[n>>2]|0)){Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;continue}else{k[m>>2]=g+1;continue}}u=i[z+11>>0]|0;c=k[v>>2]|0;if(((u<<24>>24<0?k[z+4>>2]|0:u&255)|0)!=0?(c-y|0)<160:0){u=k[w>>2]|0;w=c+4|0;k[v>>2]=w;k[c>>2]=u;c=w}x=hjb(d,k[x>>2]|0,e,t)|0;j[f>>1]=x;$ib(z,y,c,e);if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){f=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;b=f?0:b;a=f?0:a}}else a=0;a=(a|0)==0;do if(g){if((k[g+12>>2]|0)==(k[g+16>>2]|0)?(Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0)==-1:0){C=37;break}if(!a)C=38}else C=37;while(0);if((C|0)==37?a:0)C=38;if((C|0)==38)k[e>>2]=k[e>>2]|2;kob(A);kob(z);r=B;return b|0}function Lib(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=r;r=r+224|0;t=A+198|0;g=A+196|0;y=A+184|0;z=A+172|0;w=A+168|0;x=A+8|0;u=A+4|0;v=A;h=k[b>>2]|0;c=k[c>>2]|0;b=k[d+4>>2]|0;djb(y,d,t,g);k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[z+(a<<2)>>2]=0;a=a+1|0}s=cjb(b)|0;p=z+11|0;q=z+8|0;if((i[p>>0]|0)<0)a=(k[q>>2]&2147483647)+-1|0;else a=10;oob(z,a);d=(i[p>>0]|0)<0?k[z>>2]|0:z;k[w>>2]=d;k[u>>2]=x;k[v>>2]=0;o=z+4|0;n=i[g>>0]|0;a=h;b=h;a:while(1){if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){m=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;a=m?0:a;b=m?0:b}}else a=0;h=(a|0)==0;g=c;do if(c){if((k[g+12>>2]|0)!=(k[g+16>>2]|0))if(h)break;else break a;if((Xh[k[(k[c>>2]|0)+36>>2]&1023](g)|0)!=-1){if(!h)break a}else{c=0;B=14}}else B=14;while(0);if((B|0)==14){B=0;if(h){a=0;g=0;break}else g=0}h=i[p>>0]|0;h=h<<24>>24<0?k[o>>2]|0:h&255;if((k[w>>2]|0)==(d+h|0)){oob(z,h<<1);if((i[p>>0]|0)<0)d=(k[q>>2]&2147483647)+-1|0;else d=10;oob(z,d);d=(i[p>>0]|0)<0?k[z>>2]|0:z;k[w>>2]=d+h}j=a+12|0;h=k[j>>2]|0;m=a+16|0;if((h|0)==(k[m>>2]|0))h=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else h=l[h>>0]|0;if(Tib(h&255,s,d,w,v,n,y,x,u,t)|0)break;g=k[j>>2]|0;if((g|0)==(k[m>>2]|0)){Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;continue}else{k[j>>2]=g+1;continue}}t=i[y+11>>0]|0;c=k[u>>2]|0;if(((t<<24>>24<0?k[y+4>>2]|0:t&255)|0)!=0?(c-x|0)<160:0){t=k[v>>2]|0;v=c+4|0;k[u>>2]=v;k[c>>2]=t;c=v}w=gjb(d,k[w>>2]|0,e,s)|0;k[f>>2]=w;$ib(y,x,c,e);if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){f=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;b=f?0:b;a=f?0:a}}else a=0;a=(a|0)==0;do if(g){if((k[g+12>>2]|0)==(k[g+16>>2]|0)?(Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0)==-1:0){B=37;break}if(!a)B=38}else B=37;while(0);if((B|0)==37?a:0)B=38;if((B|0)==38)k[e>>2]=k[e>>2]|2;kob(z);kob(y);r=A;return b|0}function Mib(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=r;r=r+224|0;t=A+198|0;g=A+196|0;y=A+184|0;z=A+172|0;w=A+168|0;x=A+8|0;u=A+4|0;v=A;h=k[b>>2]|0;c=k[c>>2]|0;b=k[d+4>>2]|0;djb(y,d,t,g);k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[z+(a<<2)>>2]=0;a=a+1|0}s=cjb(b)|0;p=z+11|0;q=z+8|0;if((i[p>>0]|0)<0)a=(k[q>>2]&2147483647)+-1|0;else a=10;oob(z,a);d=(i[p>>0]|0)<0?k[z>>2]|0:z;k[w>>2]=d;k[u>>2]=x;k[v>>2]=0;o=z+4|0;n=i[g>>0]|0;a=h;b=h;a:while(1){if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){m=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;a=m?0:a;b=m?0:b}}else a=0;h=(a|0)==0;g=c;do if(c){if((k[g+12>>2]|0)!=(k[g+16>>2]|0))if(h)break;else break a;if((Xh[k[(k[c>>2]|0)+36>>2]&1023](g)|0)!=-1){if(!h)break a}else{c=0;B=14}}else B=14;while(0);if((B|0)==14){B=0;if(h){a=0;g=0;break}else g=0}h=i[p>>0]|0;h=h<<24>>24<0?k[o>>2]|0:h&255;if((k[w>>2]|0)==(d+h|0)){oob(z,h<<1);if((i[p>>0]|0)<0)d=(k[q>>2]&2147483647)+-1|0;else d=10;oob(z,d);d=(i[p>>0]|0)<0?k[z>>2]|0:z;k[w>>2]=d+h}j=a+12|0;h=k[j>>2]|0;m=a+16|0;if((h|0)==(k[m>>2]|0))h=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else h=l[h>>0]|0;if(Tib(h&255,s,d,w,v,n,y,x,u,t)|0)break;g=k[j>>2]|0;if((g|0)==(k[m>>2]|0)){Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;continue}else{k[j>>2]=g+1;continue}}t=i[y+11>>0]|0;c=k[u>>2]|0;if(((t<<24>>24<0?k[y+4>>2]|0:t&255)|0)!=0?(c-x|0)<160:0){t=k[v>>2]|0;v=c+4|0;k[u>>2]=v;k[c>>2]=t;c=v}w=fjb(d,k[w>>2]|0,e,s)|0;k[f>>2]=w;$ib(y,x,c,e);if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){f=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;b=f?0:b;a=f?0:a}}else a=0;a=(a|0)==0;do if(g){if((k[g+12>>2]|0)==(k[g+16>>2]|0)?(Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0)==-1:0){B=37;break}if(!a)B=38}else B=37;while(0);if((B|0)==37?a:0)B=38;if((B|0)==38)k[e>>2]=k[e>>2]|2;kob(z);kob(y);r=A;return b|0}function Nib(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=r;r=r+224|0;t=A+198|0;g=A+196|0;y=A+184|0;z=A+172|0;w=A+168|0;x=A+8|0;u=A+4|0;v=A;h=k[b>>2]|0;c=k[c>>2]|0;b=k[d+4>>2]|0;djb(y,d,t,g);k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[z+(a<<2)>>2]=0;a=a+1|0}s=cjb(b)|0;p=z+11|0;q=z+8|0;if((i[p>>0]|0)<0)a=(k[q>>2]&2147483647)+-1|0;else a=10;oob(z,a);d=(i[p>>0]|0)<0?k[z>>2]|0:z;k[w>>2]=d;k[u>>2]=x;k[v>>2]=0;o=z+4|0;n=i[g>>0]|0;a=h;b=h;a:while(1){if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){m=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;a=m?0:a;b=m?0:b}}else a=0;h=(a|0)==0;g=c;do if(c){if((k[g+12>>2]|0)!=(k[g+16>>2]|0))if(h)break;else break a;if((Xh[k[(k[c>>2]|0)+36>>2]&1023](g)|0)!=-1){if(!h)break a}else{c=0;B=14}}else B=14;while(0);if((B|0)==14){B=0;if(h){a=0;g=0;break}else g=0}h=i[p>>0]|0;h=h<<24>>24<0?k[o>>2]|0:h&255;if((k[w>>2]|0)==(d+h|0)){oob(z,h<<1);if((i[p>>0]|0)<0)d=(k[q>>2]&2147483647)+-1|0;else d=10;oob(z,d);d=(i[p>>0]|0)<0?k[z>>2]|0:z;k[w>>2]=d+h}j=a+12|0;h=k[j>>2]|0;m=a+16|0;if((h|0)==(k[m>>2]|0))h=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else h=l[h>>0]|0;if(Tib(h&255,s,d,w,v,n,y,x,u,t)|0)break;g=k[j>>2]|0;if((g|0)==(k[m>>2]|0)){Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;continue}else{k[j>>2]=g+1;continue}}t=i[y+11>>0]|0;c=k[u>>2]|0;if(((t<<24>>24<0?k[y+4>>2]|0:t&255)|0)!=0?(c-x|0)<160:0){t=k[v>>2]|0;v=c+4|0;k[u>>2]=v;k[c>>2]=t;c=v}w=ejb(d,k[w>>2]|0,e,s)|0;k[f>>2]=w;k[f+4>>2]=N;$ib(y,x,c,e);if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){f=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;b=f?0:b;a=f?0:a}}else a=0;a=(a|0)==0;do if(g){if((k[g+12>>2]|0)==(k[g+16>>2]|0)?(Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0)==-1:0){B=37;break}if(!a)B=38}else B=37;while(0);if((B|0)==37?a:0)B=38;if((B|0)==38)k[e>>2]=k[e>>2]|2;kob(z);kob(y);r=A;return b|0}function Oib(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;D=r;r=r+240|0;v=D+200|0;g=D+199|0;h=D+198|0;C=D+184|0;B=D+172|0;z=D+168|0;A=D+8|0;w=D+4|0;x=D;y=D+197|0;u=D+196|0;b=k[b>>2]|0;c=k[c>>2]|0;Yib(C,d,v,g,h);k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[B+(a<<2)>>2]=0;a=a+1|0}s=B+11|0;t=B+8|0;if((i[s>>0]|0)<0)a=(k[t>>2]&2147483647)+-1|0;else a=10;oob(B,a);d=(i[s>>0]|0)<0?k[B>>2]|0:B;k[z>>2]=d;k[w>>2]=A;k[x>>2]=0;i[y>>0]=1;i[u>>0]=69;q=B+4|0;p=i[g>>0]|0;n=i[h>>0]|0;a=b;a:while(1){if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){m=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;a=m?0:a;b=m?0:b}}else a=0;h=(a|0)==0;g=c;do if(c){if((k[g+12>>2]|0)!=(k[g+16>>2]|0))if(h)break;else break a;if((Xh[k[(k[c>>2]|0)+36>>2]&1023](g)|0)!=-1){if(!h)break a}else{c=0;E=14}}else E=14;while(0);if((E|0)==14){E=0;if(h){a=0;g=0;break}else g=0}h=i[s>>0]|0;h=h<<24>>24<0?k[q>>2]|0:h&255;if((k[z>>2]|0)==(d+h|0)){oob(B,h<<1);if((i[s>>0]|0)<0)d=(k[t>>2]&2147483647)+-1|0;else d=10;oob(B,d);d=(i[s>>0]|0)<0?k[B>>2]|0:B;k[z>>2]=d+h}j=a+12|0;h=k[j>>2]|0;m=a+16|0;if((h|0)==(k[m>>2]|0))h=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else h=l[h>>0]|0;if(Zib(h&255,y,u,d,z,p,n,C,A,w,x,v)|0)break;g=k[j>>2]|0;if((g|0)==(k[m>>2]|0)){Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;continue}else{k[j>>2]=g+1;continue}}v=i[C+11>>0]|0;c=k[w>>2]|0;if(!((i[y>>0]|0)==0?1:((v<<24>>24<0?k[C+4>>2]|0:v&255)|0)==0)?(c-A|0)<160:0){x=k[x>>2]|0;y=c+4|0;k[w>>2]=y;k[c>>2]=x;c=y}F=+bjb(d,k[z>>2]|0,e);o[f>>2]=F;$ib(C,A,c,e);if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){f=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;b=f?0:b;a=f?0:a}}else a=0;a=(a|0)==0;do if(g){if((k[g+12>>2]|0)==(k[g+16>>2]|0)?(Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0)==-1:0){E=37;break}if(!a)E=38}else E=37;while(0);if((E|0)==37?a:0)E=38;if((E|0)==38)k[e>>2]=k[e>>2]|2;kob(B);kob(C);r=D;return b|0}function Pib(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;D=r;r=r+240|0;v=D+200|0;g=D+199|0;h=D+198|0;C=D+184|0;B=D+172|0;z=D+168|0;A=D+8|0;w=D+4|0;x=D;y=D+197|0;u=D+196|0;b=k[b>>2]|0;c=k[c>>2]|0;Yib(C,d,v,g,h);k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[B+(a<<2)>>2]=0;a=a+1|0}s=B+11|0;t=B+8|0;if((i[s>>0]|0)<0)a=(k[t>>2]&2147483647)+-1|0;else a=10;oob(B,a);d=(i[s>>0]|0)<0?k[B>>2]|0:B;k[z>>2]=d;k[w>>2]=A;k[x>>2]=0;i[y>>0]=1;i[u>>0]=69;q=B+4|0;o=i[g>>0]|0;n=i[h>>0]|0;a=b;a:while(1){if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){m=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;a=m?0:a;b=m?0:b}}else a=0;h=(a|0)==0;g=c;do if(c){if((k[g+12>>2]|0)!=(k[g+16>>2]|0))if(h)break;else break a;if((Xh[k[(k[c>>2]|0)+36>>2]&1023](g)|0)!=-1){if(!h)break a}else{c=0;E=14}}else E=14;while(0);if((E|0)==14){E=0;if(h){a=0;g=0;break}else g=0}h=i[s>>0]|0;h=h<<24>>24<0?k[q>>2]|0:h&255;if((k[z>>2]|0)==(d+h|0)){oob(B,h<<1);if((i[s>>0]|0)<0)d=(k[t>>2]&2147483647)+-1|0;else d=10;oob(B,d);d=(i[s>>0]|0)<0?k[B>>2]|0:B;k[z>>2]=d+h}j=a+12|0;h=k[j>>2]|0;m=a+16|0;if((h|0)==(k[m>>2]|0))h=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else h=l[h>>0]|0;if(Zib(h&255,y,u,d,z,o,n,C,A,w,x,v)|0)break;g=k[j>>2]|0;if((g|0)==(k[m>>2]|0)){Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;continue}else{k[j>>2]=g+1;continue}}v=i[C+11>>0]|0;c=k[w>>2]|0;if(!((i[y>>0]|0)==0?1:((v<<24>>24<0?k[C+4>>2]|0:v&255)|0)==0)?(c-A|0)<160:0){x=k[x>>2]|0;y=c+4|0;k[w>>2]=y;k[c>>2]=x;c=y}F=+ajb(d,k[z>>2]|0,e);p[f>>3]=F;$ib(C,A,c,e);if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){f=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;b=f?0:b;a=f?0:a}}else a=0;a=(a|0)==0;do if(g){if((k[g+12>>2]|0)==(k[g+16>>2]|0)?(Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0)==-1:0){E=37;break}if(!a)E=38}else E=37;while(0);if((E|0)==37?a:0)E=38;if((E|0)==38)k[e>>2]=k[e>>2]|2;kob(B);kob(C);r=D;return b|0}function Qib(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;D=r;r=r+240|0;v=D+200|0;g=D+199|0;h=D+198|0;C=D+184|0;B=D+172|0;z=D+168|0;A=D+8|0;w=D+4|0;x=D;y=D+197|0;u=D+196|0;b=k[b>>2]|0;c=k[c>>2]|0;Yib(C,d,v,g,h);k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[B+(a<<2)>>2]=0;a=a+1|0}s=B+11|0;t=B+8|0;if((i[s>>0]|0)<0)a=(k[t>>2]&2147483647)+-1|0;else a=10;oob(B,a);d=(i[s>>0]|0)<0?k[B>>2]|0:B;k[z>>2]=d;k[w>>2]=A;k[x>>2]=0;i[y>>0]=1;i[u>>0]=69;q=B+4|0;o=i[g>>0]|0;n=i[h>>0]|0;a=b;a:while(1){if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){m=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;a=m?0:a;b=m?0:b}}else a=0;h=(a|0)==0;g=c;do if(c){if((k[g+12>>2]|0)!=(k[g+16>>2]|0))if(h)break;else break a;if((Xh[k[(k[c>>2]|0)+36>>2]&1023](g)|0)!=-1){if(!h)break a}else{c=0;E=14}}else E=14;while(0);if((E|0)==14){E=0;if(h){a=0;g=0;break}else g=0}h=i[s>>0]|0;h=h<<24>>24<0?k[q>>2]|0:h&255;if((k[z>>2]|0)==(d+h|0)){oob(B,h<<1);if((i[s>>0]|0)<0)d=(k[t>>2]&2147483647)+-1|0;else d=10;oob(B,d);d=(i[s>>0]|0)<0?k[B>>2]|0:B;k[z>>2]=d+h}j=a+12|0;h=k[j>>2]|0;m=a+16|0;if((h|0)==(k[m>>2]|0))h=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else h=l[h>>0]|0;if(Zib(h&255,y,u,d,z,o,n,C,A,w,x,v)|0)break;g=k[j>>2]|0;if((g|0)==(k[m>>2]|0)){Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;continue}else{k[j>>2]=g+1;continue}}v=i[C+11>>0]|0;c=k[w>>2]|0;if(!((i[y>>0]|0)==0?1:((v<<24>>24<0?k[C+4>>2]|0:v&255)|0)==0)?(c-A|0)<160:0){x=k[x>>2]|0;y=c+4|0;k[w>>2]=y;k[c>>2]=x;c=y}F=+_ib(d,k[z>>2]|0,e);p[f>>3]=F;$ib(C,A,c,e);if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)){f=(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1;b=f?0:b;a=f?0:a}}else a=0;a=(a|0)==0;do if(g){if((k[g+12>>2]|0)==(k[g+16>>2]|0)?(Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0)==-1:0){E=37;break}if(!a)E=38}else E=37;while(0);if((E|0)==37?a:0)E=38;if((E|0)==38)k[e>>2]=k[e>>2]|2;kob(B);kob(C);r=D;return b|0}function Rib(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;z=r;r=r+240|0;w=z;u=z+204|0;x=z+192|0;y=z+180|0;v=z+176|0;p=z+16|0;q=z+8|0;s=z+4|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[x+(a<<2)>>2]=0;a=a+1|0}a=k[d+28>>2]|0;t=a+4|0;k[t>>2]=(k[t>>2]|0)+1;t=Sib(a,828772)|0;Dg[k[(k[t>>2]|0)+32>>2]&127](t,424408,424434,u)|0;fob(a);k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[y+(a<<2)>>2]=0;a=a+1|0}t=y+11|0;o=y+8|0;if((i[t>>0]|0)<0)a=(k[o>>2]&2147483647)+-1|0;else a=10;oob(y,a);g=(i[t>>0]|0)<0?k[y>>2]|0:y;k[v>>2]=g;k[q>>2]=p;k[s>>2]=0;n=y+4|0;a=k[b>>2]|0;a:while(1){if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)?(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1:0){k[b>>2]=0;a=0}}else a=0;h=(a|0)==0;d=k[c>>2]|0;do if(d){if((k[d+12>>2]|0)!=(k[d+16>>2]|0))if(h)break;else break a;if((Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0)!=-1)if(h)break;else break a;else{k[c>>2]=0;A=19;break}}else A=19;while(0);if((A|0)==19){A=0;if(h){a=0;d=0;break}else d=0}h=i[t>>0]|0;h=h<<24>>24<0?k[n>>2]|0:h&255;if((k[v>>2]|0)==(g+h|0)){oob(y,h<<1);if((i[t>>0]|0)<0)g=(k[o>>2]&2147483647)+-1|0;else g=10;oob(y,g);g=(i[t>>0]|0)<0?k[y>>2]|0:y;k[v>>2]=g+h}j=a+12|0;h=k[j>>2]|0;m=a+16|0;if((h|0)==(k[m>>2]|0))h=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else h=l[h>>0]|0;if(Tib(h&255,16,g,v,s,0,x,p,q,u)|0)break;d=k[j>>2]|0;if((d|0)==(k[m>>2]|0)){Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;continue}else{k[j>>2]=d+1;continue}}oob(y,(k[v>>2]|0)-g|0);u=(i[t>>0]|0)<0?k[y>>2]|0:y;v=Uib()|0;k[w>>2]=f;if((Vib(u,v,0,w)|0)!=1)k[e>>2]=4;if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0)?(Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1:0){k[b>>2]=0;a=0}}else a=0;a=(a|0)==0;do if(d){if((k[d+12>>2]|0)==(k[d+16>>2]|0)?(Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0)==-1:0){k[c>>2]=0;A=43;break}if(!a)A=44}else A=43;while(0);if((A|0)==43?a:0)A=44;if((A|0)==44)k[e>>2]=k[e>>2]|2;A=k[b>>2]|0;kob(y);kob(x);r=z;return A|0}function Sib(a,b){a=a|0;b=b|0;b=Wib(b)|0;return k[(k[a+8>>2]|0)+(b<<2)>>2]|0}function Tib(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0;o=k[d>>2]|0;p=(o|0)==(c|0);do if(p){m=(i[l+24>>0]|0)==a<<24>>24;if(!m?(i[l+25>>0]|0)!=a<<24>>24:0){n=5;break}k[d>>2]=c+1;i[c>>0]=m?43:45;k[e>>2]=0;m=0}else n=5;while(0);a:do if((n|0)==5){n=i[g+11>>0]|0;if(a<<24>>24==f<<24>>24?((n<<24>>24<0?k[g+4>>2]|0:n&255)|0)!=0:0){m=k[j>>2]|0;if((m-h|0)>=160){m=0;break}d=k[e>>2]|0;k[j>>2]=m+4;k[m>>2]=d;k[e>>2]=0;m=0;break}g=l+26|0;f=0;while(1){m=l+f|0;if((f|0)==26){m=g;break}if((i[m>>0]|0)==a<<24>>24)break;else f=f+1|0}m=m-l|0;if((m|0)>23)m=-1;else{switch(b|0){case 10:case 8:{if((m|0)>=(b|0)){m=-1;break a}break}case 16:{if((m|0)>=22){if(p){m=-1;break a}if((o-c|0)>=3){m=-1;break a}if((i[o+-1>>0]|0)!=48){m=-1;break a}k[e>>2]=0;m=i[424408+m>>0]|0;k[d>>2]=o+1;i[o>>0]=m;m=0;break a}break}default:{}}m=i[424408+m>>0]|0;k[d>>2]=o+1;i[o>>0]=m;k[e>>2]=(k[e>>2]|0)+1;m=0}}while(0);return m|0}function Uib(){var a=0;if(!(i[428016]|0)){i[428016]=1;if(!(k[206795]|0)){k[206795]=1;a=827184}else{a=fgb(4)|0;if(a|0?k[a+-4>>2]&3|0:0){i[a>>0]=0;i[a+1>>0]=0;i[a+2>>0]=0;i[a+3>>0]=0}}k[207195]=a}return k[207195]|0}function Vib(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=r;r=r+16|0;c=e;k[c>>2]=d;b=xfb(b)|0;c=Xfb(a,424441,c)|0;if(b|0){a=(Fpb()|0)+184|0;k[a>>2]=b}r=e;return c|0}function Wib(a){a=a|0;do if((k[a>>2]|0)!=-1){mpb(830580)|0;while(1){if((k[a>>2]|0)!=1)break;Ve(830608,830580)|0}if(!(k[a>>2]|0)){k[a>>2]=1;lpb(830580)|0;Xib(a);mpb(830580)|0;k[a>>2]=-1;lpb(830580)|0;tpb(830608)|0;break}else{lpb(830580)|0;break}}while(0);return (k[a+4>>2]|0)+-1|0}function Xib(a){a=a|0;var b=0;b=k[207196]|0;k[207196]=b+1;k[a+4>>2]=b+1;return}function Yib(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=k[b+28>>2]|0;f=b+4|0;k[f>>2]=(k[f>>2]|0)+1;f=Sib(b,828772)|0;Dg[k[(k[f>>2]|0)+32>>2]&127](f,424408,424440,c)|0;c=Sib(b,828788)|0;f=Xh[k[(k[c>>2]|0)+12>>2]&1023](c)|0;i[d>>0]=f;d=Xh[k[(k[c>>2]|0)+16>>2]&1023](c)|0;i[e>>0]=d;jh[k[(k[c>>2]|0)+20>>2]&1023](a,c);fob(b);return}function Zib(a,b,c,d,e,f,g,h,j,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;m=m|0;n=n|0;o=o|0;var p=0,q=0;a:do if(a<<24>>24==f<<24>>24)if(i[b>>0]|0){i[b>>0]=0;c=k[e>>2]|0;k[e>>2]=c+1;i[c>>0]=46;e=i[h+11>>0]|0;if(((e<<24>>24<0?k[h+4>>2]|0:e&255)|0)!=0?(p=k[m>>2]|0,(p-j|0)<160):0){j=k[n>>2]|0;k[m>>2]=p+4;k[p>>2]=j;p=0}else p=0}else p=-1;else{if(a<<24>>24==g<<24>>24?(g=i[h+11>>0]|0,(g<<24>>24<0?k[h+4>>2]|0:g&255)|0):0){if(!(i[b>>0]|0)){p=-1;break}p=k[m>>2]|0;if((p-j|0)>=160){p=0;break}j=k[n>>2]|0;k[m>>2]=p+4;k[p>>2]=j;k[n>>2]=0;p=0;break}g=o+32|0;f=0;while(1){p=o+f|0;if((f|0)==32){p=g;break}if((i[p>>0]|0)==a<<24>>24)break;else f=f+1|0}f=p-o|0;if((f|0)>31)p=-1;else{g=i[424408+f>>0]|0;switch(f|0){case 24:case 25:{p=k[e>>2]|0;if((p|0)!=(d|0)?(l[p+-1>>0]&95|0)!=(l[c>>0]&127|0):0){p=-1;break a}k[e>>2]=p+1;i[p>>0]=g;p=0;break a}case 23:case 22:{i[c>>0]=80;p=k[e>>2]|0;k[e>>2]=p+1;i[p>>0]=g;p=0;break a}default:{p=g&95;if((((p|0)==(i[c>>0]|0)?(i[c>>0]=p|128,i[b>>0]|0):0)?(i[b>>0]=0,c=i[h+11>>0]|0,(c<<24>>24<0?k[h+4>>2]|0:c&255)|0):0)?(q=k[m>>2]|0,(q-j|0)<160):0){j=k[n>>2]|0;k[m>>2]=q+4;k[q>>2]=j}m=k[e>>2]|0;k[e>>2]=m+1;i[m>>0]=g;if((f|0)>21){p=0;break a}k[n>>2]=(k[n>>2]|0)+1;p=0;break a}}}}while(0);return p|0}function _ib(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;e=h;if((a|0)==(b|0)){k[c>>2]=4;d=0.0}else{f=cfb()|0;g=k[f>>2]|0;k[f>>2]=0;Uib()|0;d=+Mfb(a,e);a=k[f>>2]|0;if(!a)k[f>>2]=g;if((k[e>>2]|0)==(b|0)){if((a|0)==34)k[c>>2]=4}else{k[c>>2]=4;d=0.0}}r=h;return +d}function $ib(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;j=i[a+11>>0]|0;h=j<<24>>24<0;g=a+4|0;e=k[g>>2]|0;j=j&255;do if((h?e:j)|0){if((b|0)!=(c|0)){e=c;f=b;while(1){e=e+-4|0;if(f>>>0>=e>>>0)break;m=k[f>>2]|0;k[f>>2]=k[e>>2];k[e>>2]=m;f=f+4|0}e=k[g>>2]|0}m=h?k[a>>2]|0:a;c=c+-4|0;a=m+(h?e:j)|0;e=m;while(1){f=i[e>>0]|0;g=f<<24>>24>0&f<<24>>24!=127;if(b>>>0>=c>>>0)break;if(g?(f<<24>>24|0)!=(k[b>>2]|0):0){l=10;break}b=b+4|0;e=(a-e|0)>1?e+1|0:e}if((l|0)==10){k[d>>2]=4;break}if(g?((k[c>>2]|0)+-1|0)>>>0>=f<<24>>24>>>0:0)k[d>>2]=4}while(0);return}function ajb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;e=h;if((a|0)==(b|0)){k[c>>2]=4;d=0.0}else{f=cfb()|0;g=k[f>>2]|0;k[f>>2]=0;Uib()|0;d=+Mfb(a,e);a=k[f>>2]|0;if(!a)k[f>>2]=g;if((k[e>>2]|0)==(b|0)){if((a|0)==34)k[c>>2]=4}else{k[c>>2]=4;d=0.0}}r=h;return +d}function bjb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;e=h;if((a|0)==(b|0)){k[c>>2]=4;d=0.0}else{f=cfb()|0;g=k[f>>2]|0;k[f>>2]=0;Uib()|0;d=+Mfb(a,e);a=k[f>>2]|0;if(!a)k[f>>2]=g;if((k[e>>2]|0)==(b|0)){if((a|0)==34)k[c>>2]=4}else{k[c>>2]=4;d=0.0}}r=h;return +d}function cjb(a){a=a|0;switch(a&74){case 64:{a=8;break}case 8:{a=16;break}case 0:{a=0;break}default:a=10}return a|0}function djb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;b=k[b+28>>2]|0;e=b+4|0;k[e>>2]=(k[e>>2]|0)+1;e=Sib(b,828772)|0;Dg[k[(k[e>>2]|0)+32>>2]&127](e,424408,424434,c)|0;c=Sib(b,828788)|0;e=Xh[k[(k[c>>2]|0)+16>>2]&1023](c)|0;i[d>>0]=e;jh[k[(k[c>>2]|0)+20>>2]&1023](a,c);fob(b);return}function ejb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;f=j;do if((a|0)==(b|0)){k[c>>2]=4;d=0;a=0}else{if((i[a>>0]|0)==45){k[c>>2]=4;d=0;a=0;break}g=cfb()|0;h=k[g>>2]|0;k[g>>2]=0;Uib()|0;a=Dfb(a,f,d,-1,-1)|0;d=N;e=k[g>>2]|0;if(!e)k[g>>2]=h;if((k[f>>2]|0)==(b|0)){if((e|0)==34){k[c>>2]=4;a=-1;d=-1}}else{k[c>>2]=4;a=0;d=0}}while(0);N=d;r=j;return a|0}function fjb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;f=j;do if((a|0)==(b|0)){k[c>>2]=4;a=0}else{if((i[a>>0]|0)==45){k[c>>2]=4;a=0;break}g=cfb()|0;h=k[g>>2]|0;k[g>>2]=0;Uib()|0;a=Dfb(a,f,d,-1,-1)|0;d=N;e=k[g>>2]|0;if(!e)k[g>>2]=h;do if((k[f>>2]|0)==(b|0))if(d>>>0>0|(d|0)==0&a>>>0>4294967295|(e|0)==34){k[c>>2]=4;a=-1;break}else break;else{k[c>>2]=4;a=0}while(0)}while(0);r=j;return a|0}function gjb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;f=j;do if((a|0)==(b|0)){k[c>>2]=4;a=0}else{if((i[a>>0]|0)==45){k[c>>2]=4;a=0;break}g=cfb()|0;h=k[g>>2]|0;k[g>>2]=0;Uib()|0;a=Dfb(a,f,d,-1,-1)|0;d=N;e=k[g>>2]|0;if(!e)k[g>>2]=h;do if((k[f>>2]|0)==(b|0))if(d>>>0>0|(d|0)==0&a>>>0>4294967295|(e|0)==34){k[c>>2]=4;a=-1;break}else break;else{k[c>>2]=4;a=0}while(0)}while(0);r=j;return a|0}function hjb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;f=j;do if((a|0)==(b|0)){k[c>>2]=4;a=0}else{if((i[a>>0]|0)==45){k[c>>2]=4;a=0;break}g=cfb()|0;h=k[g>>2]|0;k[g>>2]=0;Uib()|0;a=Dfb(a,f,d,-1,-1)|0;d=N;e=k[g>>2]|0;if(!e)k[g>>2]=h;do if((k[f>>2]|0)==(b|0))if(d>>>0>0|(d|0)==0&a>>>0>65535|(e|0)==34){k[c>>2]=4;a=-1;break}else{a=a&65535;break}else{k[c>>2]=4;a=0}while(0)}while(0);r=j;return a|0}function ijb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=r;r=r+16|0;f=i;if((a|0)==(b|0)){k[c>>2]=4;d=0;a=0}else{g=cfb()|0;h=k[g>>2]|0;k[g>>2]=0;Uib()|0;a=Dfb(a,f,d,0,-2147483648)|0;d=N;e=k[g>>2]|0;if(!e)k[g>>2]=h;if((k[f>>2]|0)==(b|0)){if((e|0)==34){k[c>>2]=4;d=(d|0)>0|(d|0)==0&a>>>0>0;a=d?-1:0;d=d?2147483647:-2147483648}}else{k[c>>2]=4;a=0;d=0}}N=d;r=i;return a|0}function jjb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=r;r=r+16|0;f=i;if((a|0)==(b|0)){k[c>>2]=4;a=0}else{g=cfb()|0;h=k[g>>2]|0;k[g>>2]=0;Uib()|0;a=Dfb(a,f,d,0,-2147483648)|0;e=N;d=k[g>>2]|0;if(!d)k[g>>2]=h;a:do if((k[f>>2]|0)==(b|0)){do if((d|0)==34){k[c>>2]=4;if((e|0)>0|(e|0)==0&a>>>0>0){a=2147483647;break a}}else{if((e|0)<-1|(e|0)==-1&a>>>0<2147483648){k[c>>2]=4;break}if((e|0)>0|(e|0)==0&a>>>0>2147483647){k[c>>2]=4;a=2147483647;break a}else break a}while(0);a=-2147483648}else{k[c>>2]=4;a=0}while(0)}r=i;return a|0}function kjb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+112|0;j=(d-c|0)/12|0;if(j>>>0>100){w=fgb(j)|0;h=w}else{h=y;w=0}o=c;p=h;m=0;while(1){if((o|0)==(d|0))break;n=i[o+11>>0]|0;if(n<<24>>24<0)n=k[o+4>>2]|0;else n=n&255;if(!n){i[p>>0]=2;j=j+-1|0;m=m+1|0}else i[p>>0]=1;o=o+12|0;p=p+1|0}u=0;s=j;n=b;a:while(1){j=k[a>>2]|0;do if(j){if((k[j+12>>2]|0)==(k[j+16>>2]|0))if((Xh[k[(k[j>>2]|0)+36>>2]&1023](j)|0)==-1){k[a>>2]=0;j=0;break}else{j=k[a>>2]|0;break}}else j=0;while(0);o=(j|0)==0;if(n)if((k[n+12>>2]|0)==(k[n+16>>2]|0)){v=(Xh[k[(k[n>>2]|0)+36>>2]&1023](n)|0)==-1;p=v?0:n;v=v?0:n}else{p=n;v=n}else{p=0;v=0}n=(p|0)==0;j=k[a>>2]|0;if(!((s|0)!=0&(o^n)))break;n=k[j+12>>2]|0;if((n|0)==(k[j+16>>2]|0))j=Xh[k[(k[j>>2]|0)+36>>2]&1023](j)|0;else j=l[n>>0]|0;j=j&255;if(!g)j=Hh[k[(k[e>>2]|0)+12>>2]&511](e,j)|0;t=u+1|0;b=c;p=0;q=h;while(1){if((b|0)==(d|0))break;do if((i[q>>0]|0)==1){o=b+11|0;if((i[o>>0]|0)<0)n=k[b>>2]|0;else n=b;n=i[n+u>>0]|0;if(!g)n=Hh[k[(k[e>>2]|0)+12>>2]&511](e,n)|0;if(j<<24>>24!=n<<24>>24){i[q>>0]=0;n=p;o=s+-1|0;break}n=i[o>>0]|0;if(n<<24>>24<0)n=k[b+4>>2]|0;else n=n&255;if((n|0)==(t|0)){i[q>>0]=2;n=1;m=m+1|0;o=s+-1|0}else{n=1;o=s}}else{n=p;o=s}while(0);b=b+12|0;p=n;q=q+1|0;s=o}if(!p){u=t;n=v;continue}j=k[a>>2]|0;n=j+12|0;o=k[n>>2]|0;if((o|0)==(k[j+16>>2]|0))Xh[k[(k[j>>2]|0)+40>>2]&1023](j)|0;else k[n>>2]=o+1;if((m+s|0)>>>0>1){n=c;o=h}else{u=t;n=v;continue}while(1){if((n|0)==(d|0)){u=t;n=v;continue a}if((i[o>>0]|0)==2){j=i[n+11>>0]|0;if(j<<24>>24<0)j=k[n+4>>2]|0;else j=j&255;if((j|0)!=(t|0)){i[o>>0]=0;m=m+-1|0}}n=n+12|0;o=o+1|0}}do if(j){if((k[j+12>>2]|0)==(k[j+16>>2]|0))if((Xh[k[(k[j>>2]|0)+36>>2]&1023](j)|0)==-1){k[a>>2]=0;j=0;break}else{j=k[a>>2]|0;break}}else j=0;while(0);j=(j|0)==0;do if(!n){if((k[p+12>>2]|0)==(k[p+16>>2]|0)?(Xh[k[(k[p>>2]|0)+36>>2]&1023](p)|0)==-1:0){x=31;break}if(!j)x=66}else x=31;while(0);if((x|0)==31)if(j)x=66;if((x|0)==66)k[f>>2]=k[f>>2]|2;while(1){if((c|0)==(d|0)){x=70;break}if((i[h>>0]|0)==2)break;c=c+12|0;h=h+1|0}if((x|0)==70){k[f>>2]=k[f>>2]|4;c=d}ggb(w);r=y;return c|0}function ljb(a){a=a|0;return}function mjb(a){a=a|0;ggb(a);return}function njb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0;n=r;r=r+48|0;m=n+16|0;g=n+12|0;l=n+8|0;h=n+4|0;j=n;if(!(k[d+4>>2]&1)){k[l>>2]=-1;o=k[(k[a>>2]|0)+16>>2]|0;k[h>>2]=k[b>>2];k[j>>2]=k[c>>2];k[g>>2]=k[h>>2];k[m>>2]=k[j>>2];g=Sf[o&127](a,g,m,d,e,l)|0;k[b>>2]=g;switch(k[l>>2]|0){case 0:{i[f>>0]=0;break}case 1:{i[f>>0]=1;break}default:{i[f>>0]=1;k[e>>2]=4}}}else{o=d+28|0;a=k[o>>2]|0;g=a+4|0;k[g>>2]=(k[g>>2]|0)+1;g=Sib(a,828804)|0;fob(a);o=k[o>>2]|0;a=o+4|0;k[a>>2]=(k[a>>2]|0)+1;a=Sib(o,828812)|0;fob(o);jh[k[(k[a>>2]|0)+24>>2]&1023](m,a);jh[k[(k[a>>2]|0)+28>>2]&1023](m+12|0,a);a=m+24|0;g=(Cjb(b,k[c>>2]|0,m,a,g,e,1)|0)==(m|0)&1;i[f>>0]=g;g=k[b>>2]|0;do{a=a+-12|0;tob(a)}while((a|0)!=(m|0))}r=n;return g|0}function ojb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;z=r;r=r+304|0;s=z+200|0;g=z+196|0;x=z+184|0;y=z+172|0;v=z+168|0;w=z+8|0;t=z+4|0;u=z;h=k[b>>2]|0;j=k[c>>2]|0;b=k[d+4>>2]|0;Bjb(x,d,s,g);k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[y+(a<<2)>>2]=0;a=a+1|0}q=cjb(b)|0;o=y+11|0;p=y+8|0;if((i[o>>0]|0)<0)a=(k[p>>2]&2147483647)+-1|0;else a=10;oob(y,a);c=(i[o>>0]|0)<0?k[y>>2]|0:y;k[v>>2]=c;k[t>>2]=w;k[u>>2]=0;n=y+4|0;m=k[g>>2]|0;d=h;b=h;while(1){if(!d){l=0;g=1}else{a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;g=(a|0)==-1;l=g?0:d;b=g?0:b}d=j;if(j){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[j>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1)if(g)a=j;else break;else{a=0;A=17}}else{a=j;A=17}if((A|0)==17){A=0;if(g){d=0;break}else d=0}g=i[o>>0]|0;g=g<<24>>24<0?k[n>>2]|0:g&255;if((k[v>>2]|0)==(c+g|0)){oob(y,g<<1);if((i[o>>0]|0)<0)c=(k[p>>2]&2147483647)+-1|0;else c=10;oob(y,c);c=(i[o>>0]|0)<0?k[y>>2]|0:y;k[v>>2]=c+g}h=l+12|0;g=k[h>>2]|0;j=l+16|0;if((g|0)==(k[j>>2]|0))g=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else g=k[g>>2]|0;if(yjb(g,q,c,v,u,m,x,w,t,s)|0)break;d=k[h>>2]|0;if((d|0)==(k[j>>2]|0)){Xh[k[(k[l>>2]|0)+40>>2]&1023](l)|0;d=l;j=a;continue}else{k[h>>2]=d+4;d=l;j=a;continue}}s=i[x+11>>0]|0;a=k[t>>2]|0;if(((s<<24>>24<0?k[x+4>>2]|0:s&255)|0)!=0?(a-w|0)<160:0){s=k[u>>2]|0;u=a+4|0;k[t>>2]=u;k[a>>2]=s;a=u}v=jjb(c,k[v>>2]|0,e,q)|0;k[f>>2]=v;$ib(x,w,a,e);if(!l)c=1;else{a=k[l+12>>2]|0;if((a|0)==(k[l+16>>2]|0))a=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else a=k[a>>2]|0;c=(a|0)==-1;b=c?0:b}if(d){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1){if(!c)A=45}else A=43}else A=43;if((A|0)==43?c:0)A=45;if((A|0)==45)k[e>>2]=k[e>>2]|2;kob(y);kob(x);r=z;return b|0}function pjb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;z=r;r=r+304|0;s=z+200|0;g=z+196|0;x=z+184|0;y=z+172|0;v=z+168|0;w=z+8|0;t=z+4|0;u=z;h=k[b>>2]|0;j=k[c>>2]|0;b=k[d+4>>2]|0;Bjb(x,d,s,g);k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[y+(a<<2)>>2]=0;a=a+1|0}q=cjb(b)|0;o=y+11|0;p=y+8|0;if((i[o>>0]|0)<0)a=(k[p>>2]&2147483647)+-1|0;else a=10;oob(y,a);c=(i[o>>0]|0)<0?k[y>>2]|0:y;k[v>>2]=c;k[t>>2]=w;k[u>>2]=0;n=y+4|0;m=k[g>>2]|0;d=h;b=h;while(1){if(!d){l=0;g=1}else{a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;g=(a|0)==-1;l=g?0:d;b=g?0:b}d=j;if(j){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[j>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1)if(g)a=j;else break;else{a=0;A=17}}else{a=j;A=17}if((A|0)==17){A=0;if(g){d=0;break}else d=0}g=i[o>>0]|0;g=g<<24>>24<0?k[n>>2]|0:g&255;if((k[v>>2]|0)==(c+g|0)){oob(y,g<<1);if((i[o>>0]|0)<0)c=(k[p>>2]&2147483647)+-1|0;else c=10;oob(y,c);c=(i[o>>0]|0)<0?k[y>>2]|0:y;k[v>>2]=c+g}h=l+12|0;g=k[h>>2]|0;j=l+16|0;if((g|0)==(k[j>>2]|0))g=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else g=k[g>>2]|0;if(yjb(g,q,c,v,u,m,x,w,t,s)|0)break;d=k[h>>2]|0;if((d|0)==(k[j>>2]|0)){Xh[k[(k[l>>2]|0)+40>>2]&1023](l)|0;d=l;j=a;continue}else{k[h>>2]=d+4;d=l;j=a;continue}}s=i[x+11>>0]|0;a=k[t>>2]|0;if(((s<<24>>24<0?k[x+4>>2]|0:s&255)|0)!=0?(a-w|0)<160:0){s=k[u>>2]|0;u=a+4|0;k[t>>2]=u;k[a>>2]=s;a=u}v=ijb(c,k[v>>2]|0,e,q)|0;k[f>>2]=v;k[f+4>>2]=N;$ib(x,w,a,e);if(!l)c=1;else{a=k[l+12>>2]|0;if((a|0)==(k[l+16>>2]|0))a=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else a=k[a>>2]|0;c=(a|0)==-1;b=c?0:b}if(d){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1){if(!c)A=45}else A=43}else A=43;if((A|0)==43?c:0)A=45;if((A|0)==45)k[e>>2]=k[e>>2]|2;kob(y);kob(x);r=z;return b|0}function qjb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=r;r=r+304|0;t=A+200|0;g=A+196|0;y=A+184|0;z=A+172|0;w=A+168|0;x=A+8|0;u=A+4|0;v=A;h=k[b>>2]|0;l=k[c>>2]|0;b=k[d+4>>2]|0;Bjb(y,d,t,g);k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[z+(a<<2)>>2]=0;a=a+1|0}s=cjb(b)|0;p=z+11|0;q=z+8|0;if((i[p>>0]|0)<0)a=(k[q>>2]&2147483647)+-1|0;else a=10;oob(z,a);c=(i[p>>0]|0)<0?k[z>>2]|0:z;k[w>>2]=c;k[u>>2]=x;k[v>>2]=0;o=z+4|0;n=k[g>>2]|0;d=h;b=h;while(1){if(!d){m=0;g=1}else{a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;g=(a|0)==-1;m=g?0:d;b=g?0:b}d=l;if(l){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[l>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1)if(g)a=l;else break;else{a=0;B=17}}else{a=l;B=17}if((B|0)==17){B=0;if(g){d=0;break}else d=0}g=i[p>>0]|0;g=g<<24>>24<0?k[o>>2]|0:g&255;if((k[w>>2]|0)==(c+g|0)){oob(z,g<<1);if((i[p>>0]|0)<0)c=(k[q>>2]&2147483647)+-1|0;else c=10;oob(z,c);c=(i[p>>0]|0)<0?k[z>>2]|0:z;k[w>>2]=c+g}h=m+12|0;g=k[h>>2]|0;l=m+16|0;if((g|0)==(k[l>>2]|0))g=Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0;else g=k[g>>2]|0;if(yjb(g,s,c,w,v,n,y,x,u,t)|0)break;d=k[h>>2]|0;if((d|0)==(k[l>>2]|0)){Xh[k[(k[m>>2]|0)+40>>2]&1023](m)|0;d=m;l=a;continue}else{k[h>>2]=d+4;d=m;l=a;continue}}t=i[y+11>>0]|0;a=k[u>>2]|0;if(((t<<24>>24<0?k[y+4>>2]|0:t&255)|0)!=0?(a-x|0)<160:0){t=k[v>>2]|0;v=a+4|0;k[u>>2]=v;k[a>>2]=t;a=v}w=hjb(c,k[w>>2]|0,e,s)|0;j[f>>1]=w;$ib(y,x,a,e);if(!m)c=1;else{a=k[m+12>>2]|0;if((a|0)==(k[m+16>>2]|0))a=Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0;else a=k[a>>2]|0;c=(a|0)==-1;b=c?0:b}if(d){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1){if(!c)B=45}else B=43}else B=43;if((B|0)==43?c:0)B=45;if((B|0)==45)k[e>>2]=k[e>>2]|2;kob(z);kob(y);r=A;return b|0}function rjb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;z=r;r=r+304|0;s=z+200|0;g=z+196|0;x=z+184|0;y=z+172|0;v=z+168|0;w=z+8|0;t=z+4|0;u=z;h=k[b>>2]|0;j=k[c>>2]|0;b=k[d+4>>2]|0;Bjb(x,d,s,g);k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[y+(a<<2)>>2]=0;a=a+1|0}q=cjb(b)|0;o=y+11|0;p=y+8|0;if((i[o>>0]|0)<0)a=(k[p>>2]&2147483647)+-1|0;else a=10;oob(y,a);c=(i[o>>0]|0)<0?k[y>>2]|0:y;k[v>>2]=c;k[t>>2]=w;k[u>>2]=0;n=y+4|0;m=k[g>>2]|0;d=h;b=h;while(1){if(!d){l=0;g=1}else{a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;g=(a|0)==-1;l=g?0:d;b=g?0:b}d=j;if(j){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[j>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1)if(g)a=j;else break;else{a=0;A=17}}else{a=j;A=17}if((A|0)==17){A=0;if(g){d=0;break}else d=0}g=i[o>>0]|0;g=g<<24>>24<0?k[n>>2]|0:g&255;if((k[v>>2]|0)==(c+g|0)){oob(y,g<<1);if((i[o>>0]|0)<0)c=(k[p>>2]&2147483647)+-1|0;else c=10;oob(y,c);c=(i[o>>0]|0)<0?k[y>>2]|0:y;k[v>>2]=c+g}h=l+12|0;g=k[h>>2]|0;j=l+16|0;if((g|0)==(k[j>>2]|0))g=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else g=k[g>>2]|0;if(yjb(g,q,c,v,u,m,x,w,t,s)|0)break;d=k[h>>2]|0;if((d|0)==(k[j>>2]|0)){Xh[k[(k[l>>2]|0)+40>>2]&1023](l)|0;d=l;j=a;continue}else{k[h>>2]=d+4;d=l;j=a;continue}}s=i[x+11>>0]|0;a=k[t>>2]|0;if(((s<<24>>24<0?k[x+4>>2]|0:s&255)|0)!=0?(a-w|0)<160:0){s=k[u>>2]|0;u=a+4|0;k[t>>2]=u;k[a>>2]=s;a=u}v=gjb(c,k[v>>2]|0,e,q)|0;k[f>>2]=v;$ib(x,w,a,e);if(!l)c=1;else{a=k[l+12>>2]|0;if((a|0)==(k[l+16>>2]|0))a=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else a=k[a>>2]|0;c=(a|0)==-1;b=c?0:b}if(d){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1){if(!c)A=45}else A=43}else A=43;if((A|0)==43?c:0)A=45;if((A|0)==45)k[e>>2]=k[e>>2]|2;kob(y);kob(x);r=z;return b|0}function sjb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;z=r;r=r+304|0;s=z+200|0;g=z+196|0;x=z+184|0;y=z+172|0;v=z+168|0;w=z+8|0;t=z+4|0;u=z;h=k[b>>2]|0;j=k[c>>2]|0;b=k[d+4>>2]|0;Bjb(x,d,s,g);k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[y+(a<<2)>>2]=0;a=a+1|0}q=cjb(b)|0;o=y+11|0;p=y+8|0;if((i[o>>0]|0)<0)a=(k[p>>2]&2147483647)+-1|0;else a=10;oob(y,a);c=(i[o>>0]|0)<0?k[y>>2]|0:y;k[v>>2]=c;k[t>>2]=w;k[u>>2]=0;n=y+4|0;m=k[g>>2]|0;d=h;b=h;while(1){if(!d){l=0;g=1}else{a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;g=(a|0)==-1;l=g?0:d;b=g?0:b}d=j;if(j){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[j>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1)if(g)a=j;else break;else{a=0;A=17}}else{a=j;A=17}if((A|0)==17){A=0;if(g){d=0;break}else d=0}g=i[o>>0]|0;g=g<<24>>24<0?k[n>>2]|0:g&255;if((k[v>>2]|0)==(c+g|0)){oob(y,g<<1);if((i[o>>0]|0)<0)c=(k[p>>2]&2147483647)+-1|0;else c=10;oob(y,c);c=(i[o>>0]|0)<0?k[y>>2]|0:y;k[v>>2]=c+g}h=l+12|0;g=k[h>>2]|0;j=l+16|0;if((g|0)==(k[j>>2]|0))g=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else g=k[g>>2]|0;if(yjb(g,q,c,v,u,m,x,w,t,s)|0)break;d=k[h>>2]|0;if((d|0)==(k[j>>2]|0)){Xh[k[(k[l>>2]|0)+40>>2]&1023](l)|0;d=l;j=a;continue}else{k[h>>2]=d+4;d=l;j=a;continue}}s=i[x+11>>0]|0;a=k[t>>2]|0;if(((s<<24>>24<0?k[x+4>>2]|0:s&255)|0)!=0?(a-w|0)<160:0){s=k[u>>2]|0;u=a+4|0;k[t>>2]=u;k[a>>2]=s;a=u}v=fjb(c,k[v>>2]|0,e,q)|0;k[f>>2]=v;$ib(x,w,a,e);if(!l)c=1;else{a=k[l+12>>2]|0;if((a|0)==(k[l+16>>2]|0))a=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else a=k[a>>2]|0;c=(a|0)==-1;b=c?0:b}if(d){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1){if(!c)A=45}else A=43}else A=43;if((A|0)==43?c:0)A=45;if((A|0)==45)k[e>>2]=k[e>>2]|2;kob(y);kob(x);r=z;return b|0}function tjb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;z=r;r=r+304|0;s=z+200|0;g=z+196|0;x=z+184|0;y=z+172|0;v=z+168|0;w=z+8|0;t=z+4|0;u=z;h=k[b>>2]|0;j=k[c>>2]|0;b=k[d+4>>2]|0;Bjb(x,d,s,g);k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[y+(a<<2)>>2]=0;a=a+1|0}q=cjb(b)|0;o=y+11|0;p=y+8|0;if((i[o>>0]|0)<0)a=(k[p>>2]&2147483647)+-1|0;else a=10;oob(y,a);c=(i[o>>0]|0)<0?k[y>>2]|0:y;k[v>>2]=c;k[t>>2]=w;k[u>>2]=0;n=y+4|0;m=k[g>>2]|0;d=h;b=h;while(1){if(!d){l=0;g=1}else{a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;g=(a|0)==-1;l=g?0:d;b=g?0:b}d=j;if(j){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[j>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1)if(g)a=j;else break;else{a=0;A=17}}else{a=j;A=17}if((A|0)==17){A=0;if(g){d=0;break}else d=0}g=i[o>>0]|0;g=g<<24>>24<0?k[n>>2]|0:g&255;if((k[v>>2]|0)==(c+g|0)){oob(y,g<<1);if((i[o>>0]|0)<0)c=(k[p>>2]&2147483647)+-1|0;else c=10;oob(y,c);c=(i[o>>0]|0)<0?k[y>>2]|0:y;k[v>>2]=c+g}h=l+12|0;g=k[h>>2]|0;j=l+16|0;if((g|0)==(k[j>>2]|0))g=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else g=k[g>>2]|0;if(yjb(g,q,c,v,u,m,x,w,t,s)|0)break;d=k[h>>2]|0;if((d|0)==(k[j>>2]|0)){Xh[k[(k[l>>2]|0)+40>>2]&1023](l)|0;d=l;j=a;continue}else{k[h>>2]=d+4;d=l;j=a;continue}}s=i[x+11>>0]|0;a=k[t>>2]|0;if(((s<<24>>24<0?k[x+4>>2]|0:s&255)|0)!=0?(a-w|0)<160:0){s=k[u>>2]|0;u=a+4|0;k[t>>2]=u;k[a>>2]=s;a=u}v=ejb(c,k[v>>2]|0,e,q)|0;k[f>>2]=v;k[f+4>>2]=N;$ib(x,w,a,e);if(!l)c=1;else{a=k[l+12>>2]|0;if((a|0)==(k[l+16>>2]|0))a=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else a=k[a>>2]|0;c=(a|0)==-1;b=c?0:b}if(d){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1){if(!c)A=45}else A=43}else A=43;if((A|0)==43?c:0)A=45;if((A|0)==45)k[e>>2]=k[e>>2]|2;kob(y);kob(x);r=z;return b|0}function ujb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;C=r;r=r+352|0;u=C+208|0;g=C+200|0;h=C+196|0;B=C+184|0;A=C+172|0;y=C+168|0;z=C+8|0;v=C+4|0;w=C;x=C+337|0;t=C+336|0;b=k[b>>2]|0;j=k[c>>2]|0;zjb(B,d,u,g,h);k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[A+(a<<2)>>2]=0;a=a+1|0}q=A+11|0;s=A+8|0;if((i[q>>0]|0)<0)a=(k[s>>2]&2147483647)+-1|0;else a=10;oob(A,a);c=(i[q>>0]|0)<0?k[A>>2]|0:A;k[y>>2]=c;k[v>>2]=z;k[w>>2]=0;i[x>>0]=1;i[t>>0]=69;p=A+4|0;n=k[g>>2]|0;m=k[h>>2]|0;d=b;while(1){if(!d){l=0;g=1}else{a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;g=(a|0)==-1;l=g?0:d;b=g?0:b}d=j;if(j){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[j>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1)if(g)a=j;else break;else{a=0;D=17}}else{a=j;D=17}if((D|0)==17){D=0;if(g){d=0;break}else d=0}g=i[q>>0]|0;g=g<<24>>24<0?k[p>>2]|0:g&255;if((k[y>>2]|0)==(c+g|0)){oob(A,g<<1);if((i[q>>0]|0)<0)c=(k[s>>2]&2147483647)+-1|0;else c=10;oob(A,c);c=(i[q>>0]|0)<0?k[A>>2]|0:A;k[y>>2]=c+g}h=l+12|0;g=k[h>>2]|0;j=l+16|0;if((g|0)==(k[j>>2]|0))g=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else g=k[g>>2]|0;if(Ajb(g,x,t,c,y,n,m,B,z,v,w,u)|0)break;d=k[h>>2]|0;if((d|0)==(k[j>>2]|0)){Xh[k[(k[l>>2]|0)+40>>2]&1023](l)|0;d=l;j=a;continue}else{k[h>>2]=d+4;d=l;j=a;continue}}u=i[B+11>>0]|0;a=k[v>>2]|0;if(!((i[x>>0]|0)==0?1:((u<<24>>24<0?k[B+4>>2]|0:u&255)|0)==0)?(a-z|0)<160:0){w=k[w>>2]|0;x=a+4|0;k[v>>2]=x;k[a>>2]=w;a=x}E=+bjb(c,k[y>>2]|0,e);o[f>>2]=E;$ib(B,z,a,e);if(!l)c=1;else{a=k[l+12>>2]|0;if((a|0)==(k[l+16>>2]|0))a=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else a=k[a>>2]|0;c=(a|0)==-1;b=c?0:b}if(d){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1){if(!c)D=45}else D=43}else D=43;if((D|0)==43?c:0)D=45;if((D|0)==45)k[e>>2]=k[e>>2]|2;kob(A);kob(B);r=C;return b|0}function vjb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;C=r;r=r+352|0;u=C+208|0;g=C+200|0;h=C+196|0;B=C+184|0;A=C+172|0;y=C+168|0;z=C+8|0;v=C+4|0;w=C;x=C+337|0;t=C+336|0;b=k[b>>2]|0;j=k[c>>2]|0;zjb(B,d,u,g,h);k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[A+(a<<2)>>2]=0;a=a+1|0}q=A+11|0;s=A+8|0;if((i[q>>0]|0)<0)a=(k[s>>2]&2147483647)+-1|0;else a=10;oob(A,a);c=(i[q>>0]|0)<0?k[A>>2]|0:A;k[y>>2]=c;k[v>>2]=z;k[w>>2]=0;i[x>>0]=1;i[t>>0]=69;o=A+4|0;n=k[g>>2]|0;m=k[h>>2]|0;d=b;while(1){if(!d){l=0;g=1}else{a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;g=(a|0)==-1;l=g?0:d;b=g?0:b}d=j;if(j){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[j>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1)if(g)a=j;else break;else{a=0;D=17}}else{a=j;D=17}if((D|0)==17){D=0;if(g){d=0;break}else d=0}g=i[q>>0]|0;g=g<<24>>24<0?k[o>>2]|0:g&255;if((k[y>>2]|0)==(c+g|0)){oob(A,g<<1);if((i[q>>0]|0)<0)c=(k[s>>2]&2147483647)+-1|0;else c=10;oob(A,c);c=(i[q>>0]|0)<0?k[A>>2]|0:A;k[y>>2]=c+g}h=l+12|0;g=k[h>>2]|0;j=l+16|0;if((g|0)==(k[j>>2]|0))g=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else g=k[g>>2]|0;if(Ajb(g,x,t,c,y,n,m,B,z,v,w,u)|0)break;d=k[h>>2]|0;if((d|0)==(k[j>>2]|0)){Xh[k[(k[l>>2]|0)+40>>2]&1023](l)|0;d=l;j=a;continue}else{k[h>>2]=d+4;d=l;j=a;continue}}u=i[B+11>>0]|0;a=k[v>>2]|0;if(!((i[x>>0]|0)==0?1:((u<<24>>24<0?k[B+4>>2]|0:u&255)|0)==0)?(a-z|0)<160:0){w=k[w>>2]|0;x=a+4|0;k[v>>2]=x;k[a>>2]=w;a=x}E=+ajb(c,k[y>>2]|0,e);p[f>>3]=E;$ib(B,z,a,e);if(!l)c=1;else{a=k[l+12>>2]|0;if((a|0)==(k[l+16>>2]|0))a=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else a=k[a>>2]|0;c=(a|0)==-1;b=c?0:b}if(d){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1){if(!c)D=45}else D=43}else D=43;if((D|0)==43?c:0)D=45;if((D|0)==45)k[e>>2]=k[e>>2]|2;kob(A);kob(B);r=C;return b|0}function wjb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;C=r;r=r+352|0;u=C+208|0;g=C+200|0;h=C+196|0;B=C+184|0;A=C+172|0;y=C+168|0;z=C+8|0;v=C+4|0;w=C;x=C+337|0;t=C+336|0;b=k[b>>2]|0;j=k[c>>2]|0;zjb(B,d,u,g,h);k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[A+(a<<2)>>2]=0;a=a+1|0}q=A+11|0;s=A+8|0;if((i[q>>0]|0)<0)a=(k[s>>2]&2147483647)+-1|0;else a=10;oob(A,a);c=(i[q>>0]|0)<0?k[A>>2]|0:A;k[y>>2]=c;k[v>>2]=z;k[w>>2]=0;i[x>>0]=1;i[t>>0]=69;o=A+4|0;n=k[g>>2]|0;m=k[h>>2]|0;d=b;while(1){if(!d){l=0;g=1}else{a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;g=(a|0)==-1;l=g?0:d;b=g?0:b}d=j;if(j){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[j>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1)if(g)a=j;else break;else{a=0;D=17}}else{a=j;D=17}if((D|0)==17){D=0;if(g){d=0;break}else d=0}g=i[q>>0]|0;g=g<<24>>24<0?k[o>>2]|0:g&255;if((k[y>>2]|0)==(c+g|0)){oob(A,g<<1);if((i[q>>0]|0)<0)c=(k[s>>2]&2147483647)+-1|0;else c=10;oob(A,c);c=(i[q>>0]|0)<0?k[A>>2]|0:A;k[y>>2]=c+g}h=l+12|0;g=k[h>>2]|0;j=l+16|0;if((g|0)==(k[j>>2]|0))g=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else g=k[g>>2]|0;if(Ajb(g,x,t,c,y,n,m,B,z,v,w,u)|0)break;d=k[h>>2]|0;if((d|0)==(k[j>>2]|0)){Xh[k[(k[l>>2]|0)+40>>2]&1023](l)|0;d=l;j=a;continue}else{k[h>>2]=d+4;d=l;j=a;continue}}u=i[B+11>>0]|0;a=k[v>>2]|0;if(!((i[x>>0]|0)==0?1:((u<<24>>24<0?k[B+4>>2]|0:u&255)|0)==0)?(a-z|0)<160:0){w=k[w>>2]|0;x=a+4|0;k[v>>2]=x;k[a>>2]=w;a=x}E=+_ib(c,k[y>>2]|0,e);p[f>>3]=E;$ib(B,z,a,e);if(!l)c=1;else{a=k[l+12>>2]|0;if((a|0)==(k[l+16>>2]|0))a=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else a=k[a>>2]|0;c=(a|0)==-1;b=c?0:b}if(d){a=k[d+12>>2]|0;if((a|0)==(k[d+16>>2]|0))a=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else a=k[a>>2]|0;if((a|0)!=-1){if(!c)D=45}else D=43}else D=43;if((D|0)==43?c:0)D=45;if((D|0)==45)k[e>>2]=k[e>>2]|2;kob(A);kob(B);r=C;return b|0}function xjb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=r;r=r+320|0;v=y;t=y+208|0;w=y+192|0;x=y+180|0;u=y+176|0;p=y+16|0;q=y+8|0;s=y+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[w+(a<<2)>>2]=0;a=a+1|0}a=k[d+28>>2]|0;o=a+4|0;k[o>>2]=(k[o>>2]|0)+1;o=Sib(a,828804)|0;Dg[k[(k[o>>2]|0)+48>>2]&127](o,424408,424434,t)|0;fob(a);k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[x+(a<<2)>>2]=0;a=a+1|0}o=x+11|0;n=x+8|0;if((i[o>>0]|0)<0)a=(k[n>>2]&2147483647)+-1|0;else a=10;oob(x,a);a=(i[o>>0]|0)<0?k[x>>2]|0:x;k[u>>2]=a;k[q>>2]=p;k[s>>2]=0;m=x+4|0;g=k[b>>2]|0;a:while(1){if(g){d=k[g+12>>2]|0;if((d|0)==(k[g+16>>2]|0))d=Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0;else d=k[d>>2]|0;if((d|0)==-1){k[b>>2]=0;l=0;h=1}else{l=g;h=0}}else{l=0;h=1}g=k[c>>2]|0;do if(g){d=k[g+12>>2]|0;if((d|0)==(k[g+16>>2]|0))d=Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0;else d=k[d>>2]|0;if((d|0)!=-1)if(h)break;else break a;else{k[c>>2]=0;z=22;break}}else z=22;while(0);if((z|0)==22){z=0;if(h){g=0;break}else g=0}d=i[o>>0]|0;d=d<<24>>24<0?k[m>>2]|0:d&255;if((k[u>>2]|0)==(a+d|0)){oob(x,d<<1);if((i[o>>0]|0)<0)a=(k[n>>2]&2147483647)+-1|0;else a=10;oob(x,a);a=(i[o>>0]|0)<0?k[x>>2]|0:x;k[u>>2]=a+d}h=l+12|0;d=k[h>>2]|0;j=l+16|0;if((d|0)==(k[j>>2]|0))d=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else d=k[d>>2]|0;if(yjb(d,16,a,u,s,0,w,p,q,t)|0)break;d=k[h>>2]|0;if((d|0)==(k[j>>2]|0)){Xh[k[(k[l>>2]|0)+40>>2]&1023](l)|0;g=l;continue}else{k[h>>2]=d+4;g=l;continue}}oob(x,(k[u>>2]|0)-a|0);t=(i[o>>0]|0)<0?k[x>>2]|0:x;u=Uib()|0;k[v>>2]=f;if((Vib(t,u,0,v)|0)!=1)k[e>>2]=4;if(l){a=k[l+12>>2]|0;if((a|0)==(k[l+16>>2]|0))a=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else a=k[a>>2]|0;if((a|0)==-1){k[b>>2]=0;d=1}else d=0}else d=1;do if(g){a=k[g+12>>2]|0;if((a|0)==(k[g+16>>2]|0))a=Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0;else a=k[a>>2]|0;if((a|0)!=-1)if(d)break;else{z=51;break}else{k[c>>2]=0;z=49;break}}else z=49;while(0);if((z|0)==49?d:0)z=51;if((z|0)==51)k[e>>2]=k[e>>2]|2;z=k[b>>2]|0;kob(x);kob(w);r=y;return z|0}function yjb(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0;o=k[d>>2]|0;p=(o|0)==(c|0);do if(p){m=(k[l+96>>2]|0)==(a|0);if(!m?(k[l+100>>2]|0)!=(a|0):0){n=5;break}k[d>>2]=c+1;i[c>>0]=m?43:45;k[e>>2]=0;m=0}else n=5;while(0);a:do if((n|0)==5){n=i[g+11>>0]|0;if((a|0)==(f|0)?((n<<24>>24<0?k[g+4>>2]|0:n&255)|0)!=0:0){m=k[j>>2]|0;if((m-h|0)>=160){m=0;break}d=k[e>>2]|0;k[j>>2]=m+4;k[m>>2]=d;k[e>>2]=0;m=0;break}g=l+104|0;f=0;while(1){m=l+(f<<2)|0;if((f|0)==26){m=g;break}if((k[m>>2]|0)==(a|0))break;else f=f+1|0}m=m-l|0;f=m>>2;if((m|0)>92)m=-1;else{switch(b|0){case 10:case 8:{if((f|0)>=(b|0)){m=-1;break a}break}case 16:{if((m|0)>=88){if(p){m=-1;break a}if((o-c|0)>=3){m=-1;break a}if((i[o+-1>>0]|0)!=48){m=-1;break a}k[e>>2]=0;m=i[424408+f>>0]|0;k[d>>2]=o+1;i[o>>0]=m;m=0;break a}break}default:{}}m=i[424408+f>>0]|0;k[d>>2]=o+1;i[o>>0]=m;k[e>>2]=(k[e>>2]|0)+1;m=0}}while(0);return m|0}function zjb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=k[b+28>>2]|0;f=b+4|0;k[f>>2]=(k[f>>2]|0)+1;f=Sib(b,828804)|0;Dg[k[(k[f>>2]|0)+48>>2]&127](f,424408,424440,c)|0;c=Sib(b,828812)|0;f=Xh[k[(k[c>>2]|0)+12>>2]&1023](c)|0;k[d>>2]=f;d=Xh[k[(k[c>>2]|0)+16>>2]&1023](c)|0;k[e>>2]=d;jh[k[(k[c>>2]|0)+20>>2]&1023](a,c);fob(b);return}function Ajb(a,b,c,d,e,f,g,h,j,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;m=m|0;n=n|0;o=o|0;var p=0,q=0;a:do if((a|0)==(f|0))if(i[b>>0]|0){i[b>>0]=0;c=k[e>>2]|0;k[e>>2]=c+1;i[c>>0]=46;e=i[h+11>>0]|0;if(((e<<24>>24<0?k[h+4>>2]|0:e&255)|0)!=0?(p=k[m>>2]|0,(p-j|0)<160):0){j=k[n>>2]|0;k[m>>2]=p+4;k[p>>2]=j;p=0}else p=0}else p=-1;else{if((a|0)==(g|0)?(g=i[h+11>>0]|0,(g<<24>>24<0?k[h+4>>2]|0:g&255)|0):0){if(!(i[b>>0]|0)){p=-1;break}p=k[m>>2]|0;if((p-j|0)>=160){p=0;break}j=k[n>>2]|0;k[m>>2]=p+4;k[p>>2]=j;k[n>>2]=0;p=0;break}g=o+128|0;f=0;while(1){p=o+(f<<2)|0;if((f|0)==32){p=g;break}if((k[p>>2]|0)==(a|0))break;else f=f+1|0}f=p-o|0;p=f>>2;if((f|0)<=124){g=i[424408+p>>0]|0;switch(p|0){case 24:case 25:{p=k[e>>2]|0;if((p|0)!=(d|0)?(l[p+-1>>0]&95|0)!=(l[c>>0]&127|0):0){p=-1;break a}k[e>>2]=p+1;i[p>>0]=g;p=0;break a}case 23:case 22:{i[c>>0]=80;break}default:{p=g&95;if((((p|0)==(i[c>>0]|0)?(i[c>>0]=p|128,i[b>>0]|0):0)?(i[b>>0]=0,c=i[h+11>>0]|0,(c<<24>>24<0?k[h+4>>2]|0:c&255)|0):0)?(q=k[m>>2]|0,(q-j|0)<160):0){j=k[n>>2]|0;k[m>>2]=q+4;k[q>>2]=j}}}m=k[e>>2]|0;k[e>>2]=m+1;i[m>>0]=g;if((f|0)>84)p=0;else{k[n>>2]=(k[n>>2]|0)+1;p=0}}else p=-1}while(0);return p|0}function Bjb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;b=k[b+28>>2]|0;e=b+4|0;k[e>>2]=(k[e>>2]|0)+1;e=Sib(b,828804)|0;Dg[k[(k[e>>2]|0)+48>>2]&127](e,424408,424434,c)|0;c=Sib(b,828812)|0;e=Xh[k[(k[c>>2]|0)+16>>2]&1023](c)|0;k[d>>2]=e;jh[k[(k[c>>2]|0)+20>>2]&1023](a,c);fob(b);return}function Cjb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+112|0;j=(d-c|0)/12|0;if(j>>>0>100){v=fgb(j)|0;h=v}else{h=x;v=0}l=0;n=c;o=h;while(1){if((n|0)==(d|0))break;m=i[n+8+3>>0]|0;if(m<<24>>24<0)m=k[n+4>>2]|0;else m=m&255;if(!m){i[o>>0]=2;l=l+1|0;j=j+-1|0}else i[o>>0]=1;n=n+12|0;o=o+1|0}u=0;q=l;n=b;a:while(1){l=k[a>>2]|0;do if(l){m=k[l+12>>2]|0;if((m|0)==(k[l+16>>2]|0))l=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else l=k[m>>2]|0;if((l|0)==-1){k[a>>2]=0;o=1;break}else{o=(k[a>>2]|0)==0;break}}else o=1;while(0);if(!n){b=0;t=0;l=1}else{l=k[n+12>>2]|0;if((l|0)==(k[n+16>>2]|0))l=Xh[k[(k[n>>2]|0)+36>>2]&1023](n)|0;else l=k[l>>2]|0;l=(l|0)==-1;b=l?0:n;t=l?0:n}m=k[a>>2]|0;if(!((j|0)!=0&(o^l)))break;l=k[m+12>>2]|0;if((l|0)==(k[m+16>>2]|0))l=Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0;else l=k[l>>2]|0;if(!g)l=Hh[k[(k[e>>2]|0)+28>>2]&511](e,l)|0;s=u+1|0;b=c;o=0;p=h;while(1){if((b|0)==(d|0))break;do if((i[p>>0]|0)==1){n=b+8+3|0;if((i[n>>0]|0)<0)m=k[b>>2]|0;else m=b;m=k[m+(u<<2)>>2]|0;if(!g)m=Hh[k[(k[e>>2]|0)+28>>2]&511](e,m)|0;if((l|0)!=(m|0)){i[p>>0]=0;m=o;n=q;j=j+-1|0;break}m=i[n>>0]|0;if(m<<24>>24<0)m=k[b+4>>2]|0;else m=m&255;if((m|0)==(s|0)){i[p>>0]=2;m=1;n=q+1|0;j=j+-1|0}else{m=1;n=q}}else{m=o;n=q}while(0);b=b+12|0;o=m;p=p+1|0;q=n}if(!o){u=s;n=t;continue}l=k[a>>2]|0;m=l+12|0;n=k[m>>2]|0;if((n|0)==(k[l+16>>2]|0))Xh[k[(k[l>>2]|0)+40>>2]&1023](l)|0;else k[m>>2]=n+4;if((q+j|0)>>>0>1){n=c;o=h;l=q}else{u=s;n=t;continue}while(1){if((n|0)==(d|0)){u=s;q=l;n=t;continue a}if((i[o>>0]|0)==2){m=i[n+8+3>>0]|0;if(m<<24>>24<0)m=k[n+4>>2]|0;else m=m&255;if((m|0)!=(s|0)){i[o>>0]=0;l=l+-1|0}}n=n+12|0;o=o+1|0}}do if(m){j=k[m+12>>2]|0;if((j|0)==(k[m+16>>2]|0))j=Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0;else j=k[j>>2]|0;if((j|0)==-1){k[a>>2]=0;l=1;break}else{l=(k[a>>2]|0)==0;break}}else l=1;while(0);if(b){j=k[b+12>>2]|0;if((j|0)==(k[b+16>>2]|0))j=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else j=k[j>>2]|0;if((j|0)!=-1){if(!l)w=74}else w=38}else w=38;if((w|0)==38)if(l)w=74;if((w|0)==74)k[f>>2]=k[f>>2]|2;while(1){if((c|0)==(d|0)){w=78;break}if((i[h>>0]|0)==2)break;c=c+12|0;h=h+1|0}if((w|0)==78){k[f>>2]=k[f>>2]|4;c=d}ggb(v);r=x;return c|0}function Djb(a){a=a|0;return}function Ejb(a){a=a|0;ggb(a);return}function Fjb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l+4|0;f=l;if(!(k[c+4>>2]&1)){h=k[(k[a>>2]|0)+24>>2]|0;k[f>>2]=k[b>>2];k[j>>2]=k[f>>2];a=$g[h&127](a,j,c,d,e&1)|0}else{c=k[c+28>>2]|0;a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=Sib(c,828788)|0;fob(c);c=k[a>>2]|0;if(e)jh[k[c+24>>2]&1023](j,a);else jh[k[c+28>>2]&1023](j,a);g=j+11|0;c=i[g>>0]|0;if(c<<24>>24<0){a=k[j>>2]|0;h=8}else a=j;while(1){h=c<<24>>24<0;if((a|0)==((h?k[j>>2]|0:j)+(h?k[j+4>>2]|0:c&255)|0))break;c=i[a>>0]|0;d=k[b>>2]|0;do if(d|0){f=d+24|0;e=k[f>>2]|0;if((e|0)!=(k[d+28>>2]|0)){k[f>>2]=e+1;i[e>>0]=c;break}if((Hh[k[(k[d>>2]|0)+52>>2]&511](d,c&255)|0)==-1)k[b>>2]=0}while(0);c=i[g>>0]|0;a=a+1|0;h=8}a=k[b>>2]|0;kob(j)}r=l;return a|0}function Gjb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;a=r;r=r+64|0;h=a;l=a+50|0;n=a+36|0;g=a+32|0;f=a+28|0;j=a+24|0;i[l>>0]=i[424662]|0;i[l+1>>0]=i[424663]|0;i[l+2>>0]=i[424664]|0;i[l+3>>0]=i[424665]|0;i[l+4>>0]=i[424666]|0;i[l+5>>0]=i[424667]|0;m=c+4|0;Sjb(l+1|0,424668,1,k[m>>2]|0);o=Uib()|0;k[h>>2]=e;l=n+(Njb(n,13,o,l,h)|0)|0;m=Ojb(n,l,k[m>>2]|0)|0;e=k[c+28>>2]|0;o=e+4|0;k[o>>2]=(k[o>>2]|0)+1;k[j>>2]=e;Tjb(n,m,l,h,g,f,j);fob(e);e=kS(k[b>>2]|0,h,k[g>>2]|0,k[f>>2]|0,c,d)|0;r=a;return e|0}function Hjb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;a=r;r=r+96|0;i=a+8|0;n=a;m=a+64|0;h=a+60|0;g=a+56|0;j=a+52|0;l=n;k[l>>2]=37;k[l+4>>2]=0;l=c+4|0;Sjb(n+1|0,424659,1,k[l>>2]|0);o=Uib()|0;p=i;k[p>>2]=e;k[p+4>>2]=f;e=m+(Njb(m,23,o,n,i)|0)|0;l=Ojb(m,e,k[l>>2]|0)|0;f=k[c+28>>2]|0;n=f+4|0;k[n>>2]=(k[n>>2]|0)+1;k[j>>2]=f;Tjb(m,l,e,i,h,g,j);fob(f);f=kS(k[b>>2]|0,i,k[h>>2]|0,k[g>>2]|0,c,d)|0;r=a;return f|0}function Ijb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;a=r;r=r+64|0;h=a;l=a+48|0;n=a+36|0;g=a+32|0;f=a+28|0;j=a+24|0;i[l>>0]=i[424662]|0;i[l+1>>0]=i[424663]|0;i[l+2>>0]=i[424664]|0;i[l+3>>0]=i[424665]|0;i[l+4>>0]=i[424666]|0;i[l+5>>0]=i[424667]|0;m=c+4|0;Sjb(l+1|0,424668,0,k[m>>2]|0);o=Uib()|0;k[h>>2]=e;l=n+(Njb(n,12,o,l,h)|0)|0;m=Ojb(n,l,k[m>>2]|0)|0;e=k[c+28>>2]|0;o=e+4|0;k[o>>2]=(k[o>>2]|0)+1;k[j>>2]=e;Tjb(n,m,l,h,g,f,j);fob(e);e=kS(k[b>>2]|0,h,k[g>>2]|0,k[f>>2]|0,c,d)|0;r=a;return e|0}function Jjb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;a=r;r=r+96|0;i=a+8|0;n=a;m=a+64|0;h=a+60|0;g=a+56|0;j=a+52|0;l=n;k[l>>2]=37;k[l+4>>2]=0;l=c+4|0;Sjb(n+1|0,424659,0,k[l>>2]|0);o=Uib()|0;p=i;k[p>>2]=e;k[p+4>>2]=f;e=m+(Njb(m,23,o,n,i)|0)|0;l=Ojb(m,e,k[l>>2]|0)|0;f=k[c+28>>2]|0;n=f+4|0;k[n>>2]=(k[n>>2]|0)+1;k[j>>2]=f;Tjb(m,l,e,i,h,g,j);fob(f);f=kS(k[b>>2]|0,i,k[h>>2]|0,k[g>>2]|0,c,d)|0;r=a;return f|0}function Kjb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+160|0;m=v+48|0;l=v+32|0;h=v+24|0;g=v+8|0;j=v;q=v+130|0;n=v+68|0;f=v+72|0;u=v+64|0;s=v+60|0;t=v+56|0;o=j;k[o>>2]=37;k[o+4>>2]=0;o=c+4|0;i=Pjb(j+1|0,1016759,k[o>>2]|0)|0;k[n>>2]=q;a=Uib()|0;if(i){k[g>>2]=k[c+8>>2];p[g+8>>3]=e;a=Njb(q,30,a,j,g)|0}else{p[h>>3]=e;a=Njb(q,30,a,j,h)|0}if((a|0)>29){a=Uib()|0;if(i){k[l>>2]=k[c+8>>2];p[l+8>>3]=e;a=Qjb(n,a,j,l)|0}else{p[m>>3]=e;a=Qjb(n,a,j,m)|0}j=k[n>>2]|0;h=j}else{h=q;j=0}l=h+a|0;i=Ojb(h,l,k[o>>2]|0)|0;if((h|0)==(q|0)){g=0;a=q}else{g=fgb(a<<1)|0;f=g;a=h}q=k[c+28>>2]|0;o=q+4|0;k[o>>2]=(k[o>>2]|0)+1;k[t>>2]=q;Rjb(a,i,l,f,u,s,t);fob(q);d=kS(k[b>>2]|0,f,k[u>>2]|0,k[s>>2]|0,c,d)|0;ggb(g);ggb(j);r=v;return d|0}function Ljb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+160|0;m=v+48|0;l=v+32|0;h=v+24|0;g=v+8|0;j=v;q=v+130|0;n=v+68|0;f=v+72|0;u=v+64|0;s=v+60|0;t=v+56|0;o=j;k[o>>2]=37;k[o+4>>2]=0;o=c+4|0;i=Pjb(j+1|0,424657,k[o>>2]|0)|0;k[n>>2]=q;a=Uib()|0;if(i){k[g>>2]=k[c+8>>2];p[g+8>>3]=e;a=Njb(q,30,a,j,g)|0}else{p[h>>3]=e;a=Njb(q,30,a,j,h)|0}if((a|0)>29){a=Uib()|0;if(i){k[l>>2]=k[c+8>>2];p[l+8>>3]=e;a=Qjb(n,a,j,l)|0}else{p[m>>3]=e;a=Qjb(n,a,j,m)|0}j=k[n>>2]|0;h=j}else{h=q;j=0}l=h+a|0;i=Ojb(h,l,k[o>>2]|0)|0;if((h|0)==(q|0)){g=0;a=q}else{g=fgb(a<<1)|0;f=g;a=h}q=k[c+28>>2]|0;o=q+4|0;k[o>>2]=(k[o>>2]|0)+1;k[t>>2]=q;Rjb(a,i,l,f,u,s,t);fob(q);d=kS(k[b>>2]|0,f,k[u>>2]|0,k[s>>2]|0,c,d)|0;ggb(g);ggb(j);r=v;return d|0}function Mjb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0;a=r;r=r+80|0;h=a;j=a+60|0;f=a+40|0;i[j>>0]=i[424651]|0;i[j+1>>0]=i[424652]|0;i[j+2>>0]=i[424653]|0;i[j+3>>0]=i[424654]|0;i[j+4>>0]=i[424655]|0;i[j+5>>0]=i[424656]|0;g=Uib()|0;k[h>>2]=e;e=Njb(f,20,g,j,h)|0;j=f+e|0;g=Ojb(f,j,k[c+4>>2]|0)|0;m=k[c+28>>2]|0;l=m+4|0;k[l>>2]=(k[l>>2]|0)+1;l=Sib(m,828772)|0;fob(m);Dg[k[(k[l>>2]|0)+32>>2]&127](l,f,j,h)|0;e=h+e|0;e=kS(k[b>>2]|0,h,(g|0)==(j|0)?e:h+(g-f)|0,e,c,d)|0;r=a;return e|0}function Njb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=r;r=r+16|0;g=f;k[g>>2]=e;e=xfb(c)|0;c=lfb(a,b,d,g)|0;if(e|0){g=(Fpb()|0)+184|0;k[g>>2]=e}r=f;return c|0}function Ojb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:do switch((c&176)<<24>>24){case 16:{c=i[a>>0]|0;switch(c<<24>>24){case 43:case 45:{a=a+1|0;break a}default:{}}if((b-a|0)>1&c<<24>>24==48){switch(i[a+1>>0]|0){case 88:case 120:break;default:{d=7;break a}}a=a+2|0}else d=7;break}case 32:{a=b;break}default:d=7}while(0);return a|0}function Pjb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;if(c&2048){i[a>>0]=43;a=a+1|0}if(c&1024){i[a>>0]=35;a=a+1|0}g=c&260;d=c>>>14;f=(g|0)==260;if(f)e=0;else{i[a>>0]=46;i[a+1>>0]=42;e=1;a=a+2|0}while(1){c=i[b>>0]|0;if(!(c<<24>>24))break;i[a>>0]=c;b=b+1|0;a=a+1|0}a:do switch(g&511){case 4:if(!(d&1)){i[a>>0]=102;break a}else{i[a>>0]=70;break a}case 256:if(!(d&1)){i[a>>0]=101;break a}else{i[a>>0]=69;break a}default:{c=(d&1|0)!=0;if(f)if(c){i[a>>0]=65;break a}else{i[a>>0]=97;break a}else if(c){i[a>>0]=71;break a}else{i[a>>0]=103;break a}}}while(0);return e|0}function Qjb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=r;r=r+32|0;e=j+16|0;i=j;k[i>>2]=d;f=xfb(b)|0;d=fgb(240)|0;do if(d){k[e>>2]=k[i>>2];b=lfb(d,240,c,e)|0;if(b>>>0<240){i=hgb(d,b+1|0)|0;k[a>>2]=i|0?i:d;break}ggb(d);if((b|0)>=0?(g=b+1|0,h=fgb(g)|0,k[a>>2]=h,(h|0)!=0):0)b=lfb(h,g,c,i)|0;else b=-1}else b=-1;while(0);if(f|0){i=(Fpb()|0)+184|0;k[i>>2]=f}r=j;return b|0}function Rjb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;w=r;r=r+16|0;t=w;u=Sib(k[g>>2]|0,828772)|0;s=Sib(k[g>>2]|0,828788)|0;jh[k[(k[s>>2]|0)+20>>2]&1023](t,s);k[f>>2]=d;g=i[a>>0]|0;switch(g<<24>>24){case 43:case 45:{q=Hh[k[(k[u>>2]|0)+28>>2]&511](u,g)|0;h=k[f>>2]|0;k[f>>2]=h+1;i[h>>0]=q;h=a+1|0;break}default:h=a}q=c;a:do if((q-h|0)>1?(i[h>>0]|0)==48:0){g=h+1|0;switch(i[g>>0]|0){case 88:case 120:break;default:{g=h;v=10;break a}}o=Hh[k[(k[u>>2]|0)+28>>2]&511](u,48)|0;p=k[f>>2]|0;k[f>>2]=p+1;i[p>>0]=o;h=h+2|0;p=Hh[k[(k[u>>2]|0)+28>>2]&511](u,i[g>>0]|0)|0;g=k[f>>2]|0;k[f>>2]=g+1;i[g>>0]=p;g=h;while(1){if(g>>>0>=c>>>0)break a;p=i[g>>0]|0;Uib()|0;if(!((p+-48|0)>>>0<10|((p|32)+-97|0)>>>0<6))break a;g=g+1|0}}else{g=h;v=10}while(0);b:do if((v|0)==10)while(1){v=0;if(g>>>0>=c>>>0)break b;p=i[g>>0]|0;Uib()|0;if((p+-48|0)>>>0>=10)break b;g=g+1|0;v=10}while(0);o=t+11|0;n=i[o>>0]|0;p=t+4|0;c:do if((n<<24>>24<0?k[p>>2]|0:n&255)|0){d:do if((h|0)!=(g|0)){j=g;l=h;while(1){j=j+-1|0;if(l>>>0>=j>>>0)break d;n=i[l>>0]|0;i[l>>0]=i[j>>0]|0;i[j>>0]=n;l=l+1|0}}while(0);n=Xh[k[(k[s>>2]|0)+16>>2]&1023](s)|0;m=h;l=0;j=0;while(1){if(m>>>0>=g>>>0)break;x=i[((i[o>>0]|0)<0?k[t>>2]|0:t)+j>>0]|0;if(x<<24>>24>0&(l|0)==(x<<24>>24|0)){l=k[f>>2]|0;k[f>>2]=l+1;i[l>>0]=n;l=i[o>>0]|0;j=(j>>>0<((l<<24>>24<0?k[p>>2]|0:l&255)+-1|0)>>>0&1)+j|0;l=0}y=Hh[k[(k[u>>2]|0)+28>>2]&511](u,i[m>>0]|0)|0;x=k[f>>2]|0;k[f>>2]=x+1;i[x>>0]=y;m=m+1|0;l=l+1|0}j=d+(h-a)|0;h=k[f>>2]|0;if((j|0)==(h|0))j=u;else while(1){h=h+-1|0;if(j>>>0>=h>>>0){j=u;break c}y=i[j>>0]|0;i[j>>0]=i[h>>0]|0;i[h>>0]=y;j=j+1|0}}else{Dg[k[(k[u>>2]|0)+32>>2]&127](u,h,g,k[f>>2]|0)|0;k[f>>2]=(k[f>>2]|0)+(g-h);j=u}while(0);while(1){if(g>>>0>=c>>>0)break;h=i[g>>0]|0;if(h<<24>>24==46){v=29;break}x=Hh[k[(k[j>>2]|0)+28>>2]&511](u,h)|0;y=k[f>>2]|0;k[f>>2]=y+1;i[y>>0]=x;g=g+1|0}if((v|0)==29){x=Xh[k[(k[s>>2]|0)+12>>2]&1023](s)|0;y=k[f>>2]|0;k[f>>2]=y+1;i[y>>0]=x;g=g+1|0}Dg[k[(k[u>>2]|0)+32>>2]&127](u,g,c,k[f>>2]|0)|0;y=(k[f>>2]|0)+(q-g)|0;k[f>>2]=y;k[e>>2]=(b|0)==(c|0)?y:d+(b-a)|0;kob(t);r=w;return}function Sjb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(d&2048){i[a>>0]=43;a=a+1|0}if(d&512){i[a>>0]=35;a=a+1|0}while(1){e=i[b>>0]|0;if(!(e<<24>>24))break;i[a>>0]=e;b=b+1|0;a=a+1|0}a:do switch(d&74){case 64:{i[a>>0]=111;break}case 8:if(!(d&16384)){i[a>>0]=120;break a}else{i[a>>0]=88;break a}default:if(c){i[a>>0]=100;break a}else{i[a>>0]=117;break a}}while(0);return}function Tjb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;s=r;r=r+16|0;q=s;p=Sib(k[g>>2]|0,828772)|0;l=Sib(k[g>>2]|0,828788)|0;jh[k[(k[l>>2]|0)+20>>2]&1023](q,l);n=q+11|0;m=i[n>>0]|0;o=q+4|0;if((m<<24>>24<0?k[o>>2]|0:m&255)|0){k[f>>2]=d;g=i[a>>0]|0;switch(g<<24>>24){case 43:case 45:{m=Hh[k[(k[p>>2]|0)+28>>2]&511](p,g)|0;g=k[f>>2]|0;k[f>>2]=g+1;i[g>>0]=m;g=a+1|0;break}default:g=a}a:do if((c-g|0)>1?(i[g>>0]|0)==48:0){h=g+1|0;switch(i[h>>0]|0){case 88:case 120:break;default:break a}m=Hh[k[(k[p>>2]|0)+28>>2]&511](p,48)|0;j=k[f>>2]|0;k[f>>2]=j+1;i[j>>0]=m;j=Hh[k[(k[p>>2]|0)+28>>2]&511](p,i[h>>0]|0)|0;m=k[f>>2]|0;k[f>>2]=m+1;i[m>>0]=j;g=g+2|0}while(0);b:do if((g|0)!=(c|0)){h=c;j=g;while(1){h=h+-1|0;if(j>>>0>=h>>>0)break b;m=i[j>>0]|0;i[j>>0]=i[h>>0]|0;i[h>>0]=m;j=j+1|0}}while(0);m=Xh[k[(k[l>>2]|0)+16>>2]&1023](l)|0;l=g;h=0;j=0;while(1){if(l>>>0>=c>>>0)break;t=i[((i[n>>0]|0)<0?k[q>>2]|0:q)+h>>0]|0;if(t<<24>>24!=0&(j|0)==(t<<24>>24|0)){j=k[f>>2]|0;k[f>>2]=j+1;i[j>>0]=m;j=i[n>>0]|0;h=(h>>>0<((j<<24>>24<0?k[o>>2]|0:j&255)+-1|0)>>>0&1)+h|0;j=0}u=Hh[k[(k[p>>2]|0)+28>>2]&511](p,i[l>>0]|0)|0;t=k[f>>2]|0;k[f>>2]=t+1;i[t>>0]=u;l=l+1|0;j=j+1|0}g=d+(g-a)|0;h=k[f>>2]|0;if((g|0)!=(h|0)){while(1){h=h+-1|0;if(g>>>0>=h>>>0)break;u=i[g>>0]|0;i[g>>0]=i[h>>0]|0;i[h>>0]=u;g=g+1|0}g=k[f>>2]|0}}else{Dg[k[(k[p>>2]|0)+32>>2]&127](p,a,c,d)|0;g=d+(c-a)|0;k[f>>2]=g}k[e>>2]=(b|0)==(c|0)?g:d+(b-a)|0;kob(q);r=s;return}function Ujb(a){a=a|0;return}function Vjb(a){a=a|0;ggb(a);return}function Wjb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l+4|0;f=l;if(!(k[c+4>>2]&1)){h=k[(k[a>>2]|0)+24>>2]|0;k[f>>2]=k[b>>2];k[j>>2]=k[f>>2];a=$g[h&127](a,j,c,d,e&1)|0}else{c=k[c+28>>2]|0;a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=Sib(c,828812)|0;fob(c);c=k[a>>2]|0;if(e)jh[k[c+24>>2]&1023](j,a);else jh[k[c+28>>2]&1023](j,a);g=j+8+3|0;a=i[g>>0]|0;c=k[j>>2]|0;h=j+4|0;e=a<<24>>24<0?c:j;while(1){f=a<<24>>24<0;if((e|0)==((f?c:j)+((f?k[h>>2]|0:a&255)<<2)|0))break;a=k[e>>2]|0;c=k[b>>2]|0;if(c|0){d=c+24|0;f=k[d>>2]|0;if((f|0)==(k[c+28>>2]|0))a=Hh[k[(k[c>>2]|0)+52>>2]&511](c,a)|0;else{k[d>>2]=f+4;k[f>>2]=a}if((a|0)==-1)k[b>>2]=0}e=e+4|0;a=i[g>>0]|0;c=k[j>>2]|0}a=k[b>>2]|0;tob(j)}r=l;return a|0}function Xjb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;a=r;r=r+128|0;h=a;l=a+118|0;n=a+104|0;g=a+100|0;f=a+96|0;j=a+92|0;i[l>>0]=i[424662]|0;i[l+1>>0]=i[424663]|0;i[l+2>>0]=i[424664]|0;i[l+3>>0]=i[424665]|0;i[l+4>>0]=i[424666]|0;i[l+5>>0]=i[424667]|0;m=c+4|0;Sjb(l+1|0,424668,1,k[m>>2]|0);o=Uib()|0;k[h>>2]=e;l=n+(Njb(n,13,o,l,h)|0)|0;m=Ojb(n,l,k[m>>2]|0)|0;e=k[c+28>>2]|0;o=e+4|0;k[o>>2]=(k[o>>2]|0)+1;k[j>>2]=e;ekb(n,m,l,h,g,f,j);fob(e);e=ckb(k[b>>2]|0,h,k[g>>2]|0,k[f>>2]|0,c,d)|0;r=a;return e|0}function Yjb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;a=r;r=r+224|0;i=a+8|0;n=a;m=a+192|0;h=a+188|0;g=a+184|0;j=a+180|0;l=n;k[l>>2]=37;k[l+4>>2]=0;l=c+4|0;Sjb(n+1|0,424659,1,k[l>>2]|0);o=Uib()|0;p=i;k[p>>2]=e;k[p+4>>2]=f;e=m+(Njb(m,23,o,n,i)|0)|0;l=Ojb(m,e,k[l>>2]|0)|0;f=k[c+28>>2]|0;n=f+4|0;k[n>>2]=(k[n>>2]|0)+1;k[j>>2]=f;ekb(m,l,e,i,h,g,j);fob(f);f=ckb(k[b>>2]|0,i,k[h>>2]|0,k[g>>2]|0,c,d)|0;r=a;return f|0}function Zjb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;a=r;r=r+128|0;h=a;l=a+108|0;n=a+96|0;g=a+92|0;f=a+88|0;j=a+84|0;i[l>>0]=i[424662]|0;i[l+1>>0]=i[424663]|0;i[l+2>>0]=i[424664]|0;i[l+3>>0]=i[424665]|0;i[l+4>>0]=i[424666]|0;i[l+5>>0]=i[424667]|0;m=c+4|0;Sjb(l+1|0,424668,0,k[m>>2]|0);o=Uib()|0;k[h>>2]=e;l=n+(Njb(n,12,o,l,h)|0)|0;m=Ojb(n,l,k[m>>2]|0)|0;e=k[c+28>>2]|0;o=e+4|0;k[o>>2]=(k[o>>2]|0)+1;k[j>>2]=e;ekb(n,m,l,h,g,f,j);fob(e);e=ckb(k[b>>2]|0,h,k[g>>2]|0,k[f>>2]|0,c,d)|0;r=a;return e|0}function _jb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;a=r;r=r+224|0;i=a+8|0;n=a;m=a+192|0;h=a+188|0;g=a+184|0;j=a+180|0;l=n;k[l>>2]=37;k[l+4>>2]=0;l=c+4|0;Sjb(n+1|0,424659,0,k[l>>2]|0);o=Uib()|0;p=i;k[p>>2]=e;k[p+4>>2]=f;e=m+(Njb(m,23,o,n,i)|0)|0;l=Ojb(m,e,k[l>>2]|0)|0;f=k[c+28>>2]|0;n=f+4|0;k[n>>2]=(k[n>>2]|0)+1;k[j>>2]=f;ekb(m,l,e,i,h,g,j);fob(f);f=ckb(k[b>>2]|0,i,k[h>>2]|0,k[g>>2]|0,c,d)|0;r=a;return f|0}function $jb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+336|0;m=v+48|0;l=v+32|0;h=v+24|0;g=v+8|0;j=v;q=v+300|0;n=v+296|0;f=v+68|0;u=v+64|0;s=v+60|0;t=v+56|0;o=j;k[o>>2]=37;k[o+4>>2]=0;o=c+4|0;i=Pjb(j+1|0,1016759,k[o>>2]|0)|0;k[n>>2]=q;a=Uib()|0;if(i){k[g>>2]=k[c+8>>2];p[g+8>>3]=e;a=Njb(q,30,a,j,g)|0}else{p[h>>3]=e;a=Njb(q,30,a,j,h)|0}if((a|0)>29){a=Uib()|0;if(i){k[l>>2]=k[c+8>>2];p[l+8>>3]=e;a=Qjb(n,a,j,l)|0}else{p[m>>3]=e;a=Qjb(n,a,j,m)|0}l=k[n>>2]|0;h=l}else{h=q;l=0}j=h+a|0;i=Ojb(h,j,k[o>>2]|0)|0;if((h|0)==(q|0)){g=0;a=q}else{g=fgb(a<<3)|0;f=g;a=h}q=k[c+28>>2]|0;o=q+4|0;k[o>>2]=(k[o>>2]|0)+1;k[t>>2]=q;dkb(a,i,j,f,u,s,t);fob(q);a=ckb(k[b>>2]|0,f,k[u>>2]|0,k[s>>2]|0,c,d)|0;k[b>>2]=a;if(g|0)ggb(g);ggb(l);r=v;return a|0}function akb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+336|0;m=v+48|0;l=v+32|0;h=v+24|0;g=v+8|0;j=v;q=v+300|0;n=v+296|0;f=v+68|0;u=v+64|0;s=v+60|0;t=v+56|0;o=j;k[o>>2]=37;k[o+4>>2]=0;o=c+4|0;i=Pjb(j+1|0,424657,k[o>>2]|0)|0;k[n>>2]=q;a=Uib()|0;if(i){k[g>>2]=k[c+8>>2];p[g+8>>3]=e;a=Njb(q,30,a,j,g)|0}else{p[h>>3]=e;a=Njb(q,30,a,j,h)|0}if((a|0)>29){a=Uib()|0;if(i){k[l>>2]=k[c+8>>2];p[l+8>>3]=e;a=Qjb(n,a,j,l)|0}else{p[m>>3]=e;a=Qjb(n,a,j,m)|0}l=k[n>>2]|0;h=l}else{h=q;l=0}j=h+a|0;i=Ojb(h,j,k[o>>2]|0)|0;if((h|0)==(q|0)){g=0;a=q}else{g=fgb(a<<3)|0;f=g;a=h}q=k[c+28>>2]|0;o=q+4|0;k[o>>2]=(k[o>>2]|0)+1;k[t>>2]=q;dkb(a,i,j,f,u,s,t);fob(q);a=ckb(k[b>>2]|0,f,k[u>>2]|0,k[s>>2]|0,c,d)|0;k[b>>2]=a;if(g|0)ggb(g);ggb(l);r=v;return a|0}function bkb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0;a=r;r=r+176|0;h=a;j=a+168|0;f=a+148|0;i[j>>0]=i[424651]|0;i[j+1>>0]=i[424652]|0;i[j+2>>0]=i[424653]|0;i[j+3>>0]=i[424654]|0;i[j+4>>0]=i[424655]|0;i[j+5>>0]=i[424656]|0;g=Uib()|0;k[h>>2]=e;e=Njb(f,20,g,j,h)|0;j=f+e|0;g=Ojb(f,j,k[c+4>>2]|0)|0;m=k[c+28>>2]|0;l=m+4|0;k[l>>2]=(k[l>>2]|0)+1;l=Sib(m,828804)|0;fob(m);Dg[k[(k[l>>2]|0)+48>>2]&127](l,f,j,h)|0;e=h+(e<<2)|0;e=ckb(k[b>>2]|0,h,(g|0)==(j|0)?e:h+(g-f<<2)|0,e,c,d)|0;r=a;return e|0}function ckb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0;m=r;r=r+16|0;l=m;do if(!a)a=0;else{n=b;g=d-n>>2;j=e+12|0;e=k[j>>2]|0;e=(e|0)>(g|0)?e-g|0:0;g=c;n=g-n|0;h=n>>2;if((n|0)>0?(ci[k[(k[a>>2]|0)+48>>2]&255](a,b,h)|0)!=(h|0):0){a=0;break}if((e|0)>0?(k[l>>2]=0,k[l+4>>2]=0,k[l+8>>2]=0,sob(l,e,f),n=(ci[k[(k[a>>2]|0)+48>>2]&255](a,(i[l+8+3>>0]|0)<0?k[l>>2]|0:l,e)|0)==(e|0),tob(l),!n):0){a=0;break}n=d-g|0;d=n>>2;if((n|0)>0?(ci[k[(k[a>>2]|0)+48>>2]&255](a,c,d)|0)!=(d|0):0){a=0;break}k[j>>2]=0}while(0);r=m;return a|0}function dkb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=r;r=r+16|0;v=y;w=Sib(k[g>>2]|0,828804)|0;t=Sib(k[g>>2]|0,828812)|0;jh[k[(k[t>>2]|0)+20>>2]&1023](v,t);k[f>>2]=d;g=i[a>>0]|0;switch(g<<24>>24){case 43:case 45:{u=Hh[k[(k[w>>2]|0)+44>>2]&511](w,g)|0;g=k[f>>2]|0;k[f>>2]=g+4;k[g>>2]=u;g=a+1|0;break}default:g=a}u=c;a:do if((u-g|0)>1?(i[g>>0]|0)==48:0){h=g+1|0;switch(i[h>>0]|0){case 88:case 120:break;default:{h=g;x=10;break a}}q=Hh[k[(k[w>>2]|0)+44>>2]&511](w,48)|0;s=k[f>>2]|0;k[f>>2]=s+4;k[s>>2]=q;g=g+2|0;s=Hh[k[(k[w>>2]|0)+44>>2]&511](w,i[h>>0]|0)|0;h=k[f>>2]|0;k[f>>2]=h+4;k[h>>2]=s;h=g;while(1){if(h>>>0>=c>>>0)break a;s=i[h>>0]|0;Uib()|0;if(!((s+-48|0)>>>0<10|((s|32)+-97|0)>>>0<6))break a;h=h+1|0}}else{h=g;x=10}while(0);b:do if((x|0)==10)while(1){x=0;if(h>>>0>=c>>>0)break b;s=i[h>>0]|0;Uib()|0;if((s+-48|0)>>>0>=10)break b;h=h+1|0;x=10}while(0);q=v+11|0;p=i[q>>0]|0;s=v+4|0;c:do if((p<<24>>24<0?k[s>>2]|0:p&255)|0){d:do if((g|0)!=(h|0)){j=h;l=g;while(1){j=j+-1|0;if(l>>>0>=j>>>0)break d;p=i[l>>0]|0;i[l>>0]=i[j>>0]|0;i[j>>0]=p;l=l+1|0}}while(0);p=Xh[k[(k[t>>2]|0)+16>>2]&1023](t)|0;o=g;j=0;l=0;while(1){if(o>>>0>=h>>>0)break;m=i[q>>0]|0;n=m<<24>>24<0;z=i[(n?k[v>>2]|0:v)+j>>0]|0;if(z<<24>>24>0&(l|0)==(z<<24>>24|0)){l=k[f>>2]|0;k[f>>2]=l+4;k[l>>2]=p;j=(j>>>0<((n?k[s>>2]|0:m&255)+-1|0)>>>0&1)+j|0;l=0}n=Hh[k[(k[w>>2]|0)+44>>2]&511](w,i[o>>0]|0)|0;z=k[f>>2]|0;k[f>>2]=z+4;k[z>>2]=n;o=o+1|0;l=l+1|0}g=d+(g-a<<2)|0;l=k[f>>2]|0;if((g|0)==(l|0))j=w;else{j=l;while(1){j=j+-4|0;if(g>>>0>=j>>>0){j=w;g=l;break c}z=k[g>>2]|0;k[g>>2]=k[j>>2];k[j>>2]=z;g=g+4|0}}}else{Dg[k[(k[w>>2]|0)+48>>2]&127](w,g,h,k[f>>2]|0)|0;g=(k[f>>2]|0)+(h-g<<2)|0;k[f>>2]=g;j=w}while(0);while(1){if(h>>>0>=c>>>0)break;g=i[h>>0]|0;if(g<<24>>24==46){x=29;break}s=Hh[k[(k[j>>2]|0)+44>>2]&511](w,g)|0;z=k[f>>2]|0;g=z+4|0;k[f>>2]=g;k[z>>2]=s;h=h+1|0}if((x|0)==29){x=Xh[k[(k[t>>2]|0)+12>>2]&1023](t)|0;z=k[f>>2]|0;g=z+4|0;k[f>>2]=g;k[z>>2]=x;h=h+1|0}Dg[k[(k[w>>2]|0)+48>>2]&127](w,h,c,g)|0;z=(k[f>>2]|0)+(u-h<<2)|0;k[f>>2]=z;k[e>>2]=(b|0)==(c|0)?z:d+(b-a<<2)|0;kob(v);r=y;return}function ekb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;u=r;r=r+16|0;t=u;s=Sib(k[g>>2]|0,828804)|0;l=Sib(k[g>>2]|0,828812)|0;jh[k[(k[l>>2]|0)+20>>2]&1023](t,l);p=t+11|0;o=i[p>>0]|0;q=t+4|0;a:do if((o<<24>>24<0?k[q>>2]|0:o&255)|0){k[f>>2]=d;g=i[a>>0]|0;switch(g<<24>>24){case 43:case 45:{o=Hh[k[(k[s>>2]|0)+44>>2]&511](s,g)|0;g=k[f>>2]|0;k[f>>2]=g+4;k[g>>2]=o;g=a+1|0;break}default:g=a}b:do if((c-g|0)>1?(i[g>>0]|0)==48:0){h=g+1|0;switch(i[h>>0]|0){case 88:case 120:break;default:break b}o=Hh[k[(k[s>>2]|0)+44>>2]&511](s,48)|0;n=k[f>>2]|0;k[f>>2]=n+4;k[n>>2]=o;n=Hh[k[(k[s>>2]|0)+44>>2]&511](s,i[h>>0]|0)|0;o=k[f>>2]|0;k[f>>2]=o+4;k[o>>2]=n;g=g+2|0}while(0);c:do if((g|0)!=(c|0)){h=c;j=g;while(1){h=h+-1|0;if(j>>>0>=h>>>0)break c;o=i[j>>0]|0;i[j>>0]=i[h>>0]|0;i[h>>0]=o;j=j+1|0}}while(0);o=Xh[k[(k[l>>2]|0)+16>>2]&1023](l)|0;n=g;h=0;j=0;while(1){if(n>>>0>=c>>>0)break;l=i[p>>0]|0;m=l<<24>>24<0;v=i[(m?k[t>>2]|0:t)+h>>0]|0;if(v<<24>>24!=0&(j|0)==(v<<24>>24|0)){j=k[f>>2]|0;k[f>>2]=j+4;k[j>>2]=o;h=(h>>>0<((m?k[q>>2]|0:l&255)+-1|0)>>>0&1)+h|0;j=0}m=Hh[k[(k[s>>2]|0)+44>>2]&511](s,i[n>>0]|0)|0;v=k[f>>2]|0;k[f>>2]=v+4;k[v>>2]=m;n=n+1|0;j=j+1|0}g=d+(g-a<<2)|0;j=k[f>>2]|0;if((g|0)!=(j|0)){h=j;while(1){h=h+-4|0;if(g>>>0>=h>>>0){g=j;break a}v=k[g>>2]|0;k[g>>2]=k[h>>2];k[h>>2]=v;g=g+4|0}}}else{Dg[k[(k[s>>2]|0)+48>>2]&127](s,a,c,d)|0;g=d+(c-a<<2)|0;k[f>>2]=g}while(0);k[e>>2]=(b|0)==(c|0)?g:d+(b-a<<2)|0;kob(t);r=u;return}function fkb(a){a=a|0;return}function gkb(a){a=a|0;ggb(a);return}function hkb(a){a=a|0;return 2}function ikb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Akb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,425169,425177)|0}function jkb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0;h=a+8|0;h=Xh[k[(k[h>>2]|0)+20>>2]&1023](h)|0;g=i[h+11>>0]|0;j=g<<24>>24<0;l=j?k[h>>2]|0:h;return Akb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,l,l+(j?k[h+4>>2]|0:g&255)|0)|0}function kkb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=k[d+28>>2]|0;d=g+4|0;k[d>>2]=(k[d>>2]|0)+1;d=Sib(g,828772)|0;fob(g);ykb(a,f+24|0,b,k[c>>2]|0,e,d);return k[b>>2]|0}function lkb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=k[d+28>>2]|0;d=g+4|0;k[d>>2]=(k[d>>2]|0)+1;d=Sib(g,828772)|0;fob(g);zkb(a,f+16|0,b,k[c>>2]|0,e,d);return k[b>>2]|0}function mkb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=k[d+28>>2]|0;d=a+4|0;k[d>>2]=(k[d>>2]|0)+1;d=Sib(a,828772)|0;fob(a);Bkb(f+20|0,b,k[c>>2]|0,e,d);return k[b>>2]|0}function nkb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var m=0,n=0,o=0,p=0,q=0,s=0,t=0;s=r;r=r+16|0;m=s+12|0;h=s+8|0;n=s+4|0;o=s;k[e>>2]=0;t=k[d+28>>2]|0;p=t+4|0;k[p>>2]=(k[p>>2]|0)+1;p=Sib(t,828772)|0;fob(t);a:do switch(g<<24>>24|0){case 65:case 97:{ykb(a,f+24|0,b,k[c>>2]|0,e,p);q=113;break}case 104:case 66:case 98:{zkb(a,f+16|0,b,k[c>>2]|0,e,p);q=113;break}case 99:{t=a+8|0;t=Xh[k[(k[t>>2]|0)+12>>2]&1023](t)|0;q=i[t+11>>0]|0;p=q<<24>>24<0;g=p?k[t>>2]|0:t;q=Akb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,g,g+(p?k[t+4>>2]|0:q&255)|0)|0;k[b>>2]=q;q=113;break}case 101:case 100:{h=Ckb(b,k[c>>2]|0,e,p,2)|0;m=k[e>>2]|0;if((h+-1|0)>>>0<31&(m&4|0)==0){k[f+12>>2]=h;q=113;break a}else{k[e>>2]=m|4;q=113;break a}}case 68:{q=Akb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,425129,425137)|0;k[b>>2]=q;q=113;break}case 70:{q=Akb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,425137,425145)|0;k[b>>2]=q;q=113;break}case 72:{h=Ckb(b,k[c>>2]|0,e,p,2)|0;m=k[e>>2]|0;if((h|0)<24&(m&4|0)==0){k[f+8>>2]=h;q=113;break a}else{k[e>>2]=m|4;q=113;break a}}case 73:{h=Ckb(b,k[c>>2]|0,e,p,2)|0;m=k[e>>2]|0;if((h+-1|0)>>>0<12&(m&4|0)==0){k[f+8>>2]=h;q=113;break a}else{k[e>>2]=m|4;q=113;break a}}case 106:{h=Ckb(b,k[c>>2]|0,e,p,3)|0;m=k[e>>2]|0;if((h|0)<366&(m&4|0)==0){k[f+28>>2]=h;q=113;break a}else{k[e>>2]=m|4;q=113;break a}}case 109:{h=Ckb(b,k[c>>2]|0,e,p,2)|0;m=k[e>>2]|0;if((h|0)<13&(m&4|0)==0){k[f+16>>2]=h+-1;q=113;break a}else{k[e>>2]=m|4;q=113;break a}}case 77:{h=Ckb(b,k[c>>2]|0,e,p,2)|0;m=k[e>>2]|0;if((h|0)<60&(m&4|0)==0){k[f+4>>2]=h;q=113;break a}else{k[e>>2]=m|4;q=113;break a}}case 116:case 110:{d=p+8|0;h=k[c>>2]|0;b:while(1){m=k[b>>2]|0;do if(m){if((k[m+12>>2]|0)==(k[m+16>>2]|0))if((Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0)==-1){k[b>>2]=0;m=0;break}else{m=k[b>>2]|0;break}}else m=0;while(0);n=(m|0)==0;m=h;do if(h){if((k[m+12>>2]|0)!=(k[m+16>>2]|0))if(n){o=m;break}else break b;if((Xh[k[(k[h>>2]|0)+36>>2]&1023](m)|0)!=-1)if(n)o=m;else break b;else{h=0;q=35}}else q=35;while(0);if((q|0)==35){q=0;if(n){m=0;break}else o=0}m=k[b>>2]|0;n=k[m+12>>2]|0;if((n|0)==(k[m+16>>2]|0))m=Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0;else m=l[n>>0]|0;if((m&255)<<24>>24<=-1){m=o;break}if(!(j[(k[d>>2]|0)+(m<<24>>24<<1)>>1]&8192)){m=o;break}m=k[b>>2]|0;n=m+12|0;o=k[n>>2]|0;if((o|0)==(k[m+16>>2]|0)){Xh[k[(k[m>>2]|0)+40>>2]&1023](m)|0;continue}else{k[n>>2]=o+1;continue}}h=k[b>>2]|0;do if(h){if((k[h+12>>2]|0)==(k[h+16>>2]|0))if((Xh[k[(k[h>>2]|0)+36>>2]&1023](h)|0)==-1){k[b>>2]=0;h=0;break}else{h=k[b>>2]|0;break}}else h=0;while(0);h=(h|0)==0;do if(m){if((k[m+12>>2]|0)==(k[m+16>>2]|0)?(Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0)==-1:0){q=54;break}if(h){q=113;break a}}else q=54;while(0);if((q|0)==54?!h:0){q=113;break a}k[e>>2]=k[e>>2]|2;q=113;break}case 112:{d=f+8|0;o=k[c>>2]|0;n=a+8|0;n=Xh[k[(k[n>>2]|0)+8>>2]&1023](n)|0;h=i[n+11>>0]|0;if(h<<24>>24<0)m=k[n+4>>2]|0;else m=h&255;h=i[n+12+11>>0]|0;if(h<<24>>24<0)h=k[n+16>>2]|0;else h=h&255;if((m|0)==(0-h|0)){k[e>>2]=k[e>>2]|4;q=113;break a}h=(kjb(b,o,n,n+24|0,p,e,0)|0)-n|0;m=k[d>>2]|0;if((m|0)==12&(h|0)==0){k[d>>2]=0;q=113;break a}if((m|0)<12&(h|0)==12){k[d>>2]=m+12;q=113}else q=113;break}case 114:{q=Akb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,425145,425156)|0;k[b>>2]=q;q=113;break}case 82:{q=Akb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,425156,425161)|0;k[b>>2]=q;q=113;break}case 83:{h=Ckb(b,k[c>>2]|0,e,p,2)|0;m=k[e>>2]|0;if((h|0)<61&(m&4|0)==0){k[f>>2]=h;q=113;break a}else{k[e>>2]=m|4;q=113;break a}}case 84:{q=Akb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,425161,425169)|0;k[b>>2]=q;q=113;break}case 119:{h=Ckb(b,k[c>>2]|0,e,p,1)|0;m=k[e>>2]|0;if((h|0)<7&(m&4|0)==0){k[f+24>>2]=h;q=113;break a}else{k[e>>2]=m|4;q=113;break a}}case 120:{t=k[(k[a>>2]|0)+20>>2]|0;k[n>>2]=k[b>>2];k[o>>2]=k[c>>2];k[h>>2]=k[n>>2];k[m>>2]=k[o>>2];h=Sf[t&127](a,h,m,d,e,f)|0;break}case 88:{t=a+8|0;t=Xh[k[(k[t>>2]|0)+24>>2]&1023](t)|0;q=i[t+11>>0]|0;p=q<<24>>24<0;g=p?k[t>>2]|0:t;q=Akb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,g,g+(p?k[t+4>>2]|0:q&255)|0)|0;k[b>>2]=q;q=113;break}case 121:{Bkb(f+20|0,b,k[c>>2]|0,e,p);q=113;break}case 89:{h=Ckb(b,k[c>>2]|0,e,p,4)|0;if(!(k[e>>2]&4)){k[f+20>>2]=h+-1900;q=113}else q=113;break}case 37:{m=k[c>>2]|0;h=k[b>>2]|0;do if(h){if((k[h+12>>2]|0)==(k[h+16>>2]|0))if((Xh[k[(k[h>>2]|0)+36>>2]&1023](h)|0)==-1){k[b>>2]=0;h=0;break}else{h=k[b>>2]|0;break}}else h=0;while(0);h=(h|0)==0;do if(m){if((k[m+12>>2]|0)==(k[m+16>>2]|0)?(Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0)==-1:0){q=91;break}if(h)d=m;else q=92}else q=91;while(0);if((q|0)==91)if(h)q=92;else d=0;if((q|0)==92){k[e>>2]=k[e>>2]|6;q=113;break a}h=k[b>>2]|0;m=k[h+12>>2]|0;if((m|0)==(k[h+16>>2]|0))h=Xh[k[(k[h>>2]|0)+36>>2]&1023](h)|0;else h=l[m>>0]|0;if((ci[k[(k[p>>2]|0)+36>>2]&255](p,h&255,0)|0)<<24>>24!=37){k[e>>2]=k[e>>2]|4;q=113;break a}h=k[b>>2]|0;m=h+12|0;n=k[m>>2]|0;o=k[h+16>>2]|0;if((n|0)==(o|0)){Xh[k[(k[h>>2]|0)+40>>2]&1023](h)|0;h=k[b>>2]|0;if(!h)h=0;else{m=k[h+12>>2]|0;o=k[h+16>>2]|0;q=102}}else{q=n+1|0;k[m>>2]=q;m=q;q=102}do if((q|0)==102)if((m|0)==(o|0))if((Xh[k[(k[h>>2]|0)+36>>2]&1023](h)|0)==-1){k[b>>2]=0;h=0;break}else{h=k[b>>2]|0;break}while(0);h=(h|0)==0;do if(d){if((k[d+12>>2]|0)==(k[d+16>>2]|0)?(Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0)==-1:0){q=110;break}if(h){q=113;break a}}else q=110;while(0);if((q|0)==110?!h:0){q=113;break a}k[e>>2]=k[e>>2]|2;q=113;break}default:{k[e>>2]=k[e>>2]|4;q=113}}while(0);if((q|0)==113)h=k[b>>2]|0;r=s;return h|0}function okb(a){a=a|0;var b=0;if(!(i[428120]|0)){i[428120]=1;if(!(i[428128]|0)){i[428128]=1;b=829452;do{k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[b+(a<<2)>>2]=0;a=a+1|0}b=b+12|0}while((b|0)!=829620);ud(1527,0,x|0)|0}nob(829452,425044);nob(829464,425051);nob(829476,425058);nob(829488,425066);nob(829500,425076);nob(829512,425085);nob(829524,425092);nob(829536,425101);nob(829548,425105);nob(829560,425109);nob(829572,425113);nob(829584,425117);nob(829596,425121);nob(829608,425125);k[207405]=829452}return k[207405]|0}function pkb(a){a=a|0;var b=0;if(!(i[428104]|0)){i[428104]=1;if(!(i[428112]|0)){i[428112]=1;b=829160;do{k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[b+(a<<2)>>2]=0;a=a+1|0}b=b+12|0}while((b|0)!=829448);ud(1528,0,x|0)|0}nob(829160,424914);nob(829172,424922);nob(829184,424931);nob(829196,424937);nob(829208,424943);nob(829220,424947);nob(829232,424952);nob(829244,424957);nob(829256,424964);nob(829268,424974);nob(829280,424982);nob(829292,424991);nob(829304,425e3);nob(829316,425004);nob(829328,425008);nob(829340,425012);nob(829352,424943);nob(829364,425016);nob(829376,425020);nob(829388,425024);nob(829400,425028);nob(829412,425032);nob(829424,425036);nob(829436,425040);k[207362]=829160}return k[207362]|0}function qkb(a){a=a|0;var b=0;if(!(i[428088]|0)){i[428088]=1;if(!(i[428096]|0)){i[428096]=1;b=828868;do{k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[b+(a<<2)>>2]=0;a=a+1|0}b=b+12|0}while((b|0)!=829156);ud(1529,0,x|0)|0}nob(828868,424908);nob(828880,424911);k[207289]=828868}return k[207289]|0}function rkb(a){a=a|0;if(!(i[428080]|0)){i[428080]=1;k[207214]=0;k[207215]=0;k[207216]=0;job(828856,424887,20);ud(1530,828856,x|0)|0}return 828856}function skb(a){a=a|0;if(!(i[428072]|0)){i[428072]=1;k[207211]=0;k[207212]=0;k[207213]=0;job(828844,424875,11);ud(1530,828844,x|0)|0}return 828844}function tkb(a){a=a|0;if(!(i[428048]|0)){i[428048]=1;k[107016]=0;i[428067]=8;a=428056;k[a>>2]=623865125;k[a+4>>2]=2032480100;i[428064]=0;ud(1530,428056,x|0)|0}return 428056}function ukb(a){a=a|0;if(!(i[428024]|0)){i[428024]=1;k[107010]=0;i[428043]=8;a=428032;k[a>>2]=624576549;k[a+4>>2]=1394948685;i[428040]=0;ud(1530,428032,x|0)|0}return 428032}function vkb(a){a=a|0;a=829156;do{a=a+-12|0;kob(a)}while((a|0)!=828868);return}function wkb(a){a=a|0;a=829448;do{a=a+-12|0;kob(a)}while((a|0)!=829160);return}function xkb(a){a=a|0;a=829620;do{a=a+-12|0;kob(a)}while((a|0)!=829452);return}function ykb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=a+8|0;a=Xh[k[k[a>>2]>>2]&1023](a)|0;d=(kjb(c,d,a,a+168|0,f,e,0)|0)-a|0;if((d|0)<168)k[b>>2]=((d|0)/12|0|0)%7|0;return}function zkb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=a+8|0;a=Xh[k[(k[a>>2]|0)+4>>2]&1023](a)|0;d=(kjb(c,d,a,a+288|0,f,e,0)|0)-a|0;if((d|0)<288)k[b>>2]=((d|0)/12|0|0)%12|0;return}function Akb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+16|0;v=C+12|0;u=C+8|0;y=C+4|0;z=C;x=k[d+28>>2]|0;w=x+4|0;k[w>>2]=(k[w>>2]|0)+1;w=Sib(x,828772)|0;fob(x);k[e>>2]=0;x=w+8|0;m=0;a:while(1){p=(g|0)!=(h|0);while(1){if(!(p&(m|0)==0))break a;m=b;if(b)if((k[b+12>>2]|0)==(k[b+16>>2]|0)){t=(Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0)==-1;q=t?0:b;b=t?0:b;m=t?0:m}else q=b;else{q=0;b=0}o=(b|0)==0;n=c;do if(c){if((k[c+12>>2]|0)==(k[c+16>>2]|0)?(Xh[k[(k[c>>2]|0)+36>>2]&1023](c)|0)==-1:0){n=0;B=11;break}if(!o){B=12;break a}}else B=11;while(0);if((B|0)==11){B=0;if(o){b=0;c=0;B=12;break a}else c=0}if((ci[k[(k[w>>2]|0)+36>>2]&255](w,i[g>>0]|0,0)|0)<<24>>24==37){B=14;break}m=i[g>>0]|0;if(m<<24>>24>-1?(A=k[x>>2]|0,j[A+(m<<24>>24<<1)>>1]&8192):0){B=23;break}n=b+12|0;m=k[n>>2]|0;o=b+16|0;if((m|0)==(k[o>>2]|0))m=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else m=l[m>>0]|0;t=Hh[k[(k[w>>2]|0)+12>>2]&511](w,m&255)|0;if(t<<24>>24==(Hh[k[(k[w>>2]|0)+12>>2]&511](w,i[g>>0]|0)|0)<<24>>24){B=48;break}k[e>>2]=4;b=q;m=4}b:do if((B|0)==14){B=0;p=g+1|0;if((p|0)==(h|0)){B=15;break a}o=ci[k[(k[w>>2]|0)+36>>2]&255](w,i[p>>0]|0,0)|0;switch(o<<24>>24){case 48:case 69:{g=g+2|0;if((g|0)==(h|0)){B=20;break a}q=o;b=ci[k[(k[w>>2]|0)+36>>2]&255](w,i[g>>0]|0,0)|0;g=p;break}default:{q=0;b=o}}t=k[(k[a>>2]|0)+36>>2]|0;k[y>>2]=m;k[z>>2]=n;k[u>>2]=k[y>>2];k[v>>2]=k[z>>2];g=g+2|0;b=si[t&15](a,u,v,d,e,f,b,q)|0}else if((B|0)==23){while(1){B=0;g=g+1|0;if((g|0)==(h|0)){g=h;break}m=i[g>>0]|0;if(m<<24>>24<=-1)break;if(!(j[A+(m<<24>>24<<1)>>1]&8192))break;else B=23}n=b;m=c;b=q;p=c;o=c;while(1){if(n)if((k[n+12>>2]|0)==(k[n+16>>2]|0)){t=(Xh[k[(k[n>>2]|0)+36>>2]&1023](n)|0)==-1;b=t?0:b;t=t?0:n}else t=n;else t=0;n=(t|0)==0;do if(o){if((k[o+12>>2]|0)!=(k[o+16>>2]|0))if(n){s=m;c=p;q=o;break}else{c=p;break b}if((Xh[k[(k[o>>2]|0)+36>>2]&1023](o)|0)!=-1)if(n^(m|0)==0){s=m;c=p;q=m}else{c=p;break b}else{m=0;c=0;B=34}}else{c=p;B=34}while(0);if((B|0)==34){B=0;if(n)break b;else{s=m;q=0}}n=t+12|0;m=k[n>>2]|0;o=t+16|0;if((m|0)==(k[o>>2]|0))m=Xh[k[(k[t>>2]|0)+36>>2]&1023](t)|0;else m=l[m>>0]|0;if((m&255)<<24>>24<=-1)break b;if(!(j[(k[x>>2]|0)+(m<<24>>24<<1)>>1]&8192))break b;m=k[n>>2]|0;if((m|0)==(k[o>>2]|0)){Xh[k[(k[t>>2]|0)+40>>2]&1023](t)|0;n=t;m=s;p=c;o=q;continue}else{k[n>>2]=m+1;n=t;m=s;p=c;o=q;continue}}}else if((B|0)==48){B=0;m=k[n>>2]|0;if((m|0)==(k[o>>2]|0))Xh[k[(k[b>>2]|0)+40>>2]&1023](b)|0;else k[n>>2]=m+1;g=g+1|0;b=q}while(0);m=k[e>>2]|0}if((B|0)==12)k[e>>2]=4;else if((B|0)==15)k[e>>2]=4;else if((B|0)==20)k[e>>2]=4;if(b){if((k[b+12>>2]|0)==(k[b+16>>2]|0)){A=(Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0)==-1;b=A?0:b}}else b=0;g=(b|0)==0;do if(c){if((k[c+12>>2]|0)==(k[c+16>>2]|0)?(Xh[k[(k[c>>2]|0)+36>>2]&1023](c)|0)==-1:0){B=61;break}if(!g)B=62}else B=61;while(0);if((B|0)==61?g:0)B=62;if((B|0)==62)k[e>>2]=k[e>>2]|2;r=C;return b|0}function Bkb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;c=Ckb(b,c,d,e,4)|0;if(!(k[d>>2]&4)){if((c|0)<69)c=c+2e3|0;else c=(c|0)<100?c+1900|0:c;k[a>>2]=c+-1900}return}function Ckb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,m=0,n=0,o=0,p=0,q=0;f=k[a>>2]|0;do if(f){if((k[f+12>>2]|0)==(k[f+16>>2]|0))if((Xh[k[(k[f>>2]|0)+36>>2]&1023](f)|0)==-1){k[a>>2]=0;f=0;break}else{f=k[a>>2]|0;break}}else f=0;while(0);f=(f|0)==0;do if(b){if((k[b+12>>2]|0)==(k[b+16>>2]|0)?(Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0)==-1:0){q=10;break}if(f)q=12;else q=11}else q=10;while(0);if((q|0)==10)if(f)q=11;else{b=0;q=12}a:do if((q|0)==11){k[c>>2]=k[c>>2]|6;f=0}else if((q|0)==12){f=k[a>>2]|0;g=k[f+12>>2]|0;if((g|0)==(k[f+16>>2]|0))f=Xh[k[(k[f>>2]|0)+36>>2]&1023](f)|0;else f=l[g>>0]|0;g=f&255;if(g<<24>>24>-1?(p=d+8|0,j[(k[p>>2]|0)+(f<<24>>24<<1)>>1]&2048):0){f=(ci[k[(k[d>>2]|0)+36>>2]&255](d,g,0)|0)<<24>>24;g=k[a>>2]|0;h=g+12|0;i=k[h>>2]|0;if((i|0)==(k[g+16>>2]|0)){Xh[k[(k[g>>2]|0)+40>>2]&1023](g)|0;i=b;h=b}else{k[h>>2]=i+1;i=b;h=b}while(1){f=f+-48|0;n=e+-1|0;b=k[a>>2]|0;do if(b){if((k[b+12>>2]|0)==(k[b+16>>2]|0))if((Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0)==-1){k[a>>2]=0;b=0;break}else{b=k[a>>2]|0;break}}else b=0;while(0);g=(b|0)==0;if(h)if((k[h+12>>2]|0)==(k[h+16>>2]|0)){m=(Xh[k[(k[h>>2]|0)+36>>2]&1023](h)|0)==-1;o=m?0:i;m=m?0:i}else{o=i;m=h}else{o=i;m=0}b=k[a>>2]|0;if(!((e|0)>1&(g^(m|0)==0)))break;g=k[b+12>>2]|0;if((g|0)==(k[b+16>>2]|0))b=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else b=l[g>>0]|0;g=b&255;if(g<<24>>24<=-1)break a;if(!(j[(k[p>>2]|0)+(b<<24>>24<<1)>>1]&2048))break a;f=((ci[k[(k[d>>2]|0)+36>>2]&255](d,g,0)|0)<<24>>24)+(f*10|0)|0;b=k[a>>2]|0;g=b+12|0;h=k[g>>2]|0;if((h|0)==(k[b+16>>2]|0)){Xh[k[(k[b>>2]|0)+40>>2]&1023](b)|0;e=n;i=o;h=m;continue}else{k[g>>2]=h+1;e=n;i=o;h=m;continue}}do if(b){if((k[b+12>>2]|0)==(k[b+16>>2]|0))if((Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0)==-1){k[a>>2]=0;b=0;break}else{b=k[a>>2]|0;break}}else b=0;while(0);b=(b|0)==0;do if(o){if((k[o+12>>2]|0)==(k[o+16>>2]|0)?(Xh[k[(k[o>>2]|0)+36>>2]&1023](o)|0)==-1:0){q=47;break}if(b)break a}else q=47;while(0);if((q|0)==47?!b:0)break;k[c>>2]=k[c>>2]|2;break}k[c>>2]=k[c>>2]|4;f=0}while(0);return f|0}function Dkb(a){a=a|0;return}function Ekb(a){a=a|0;ggb(a);return}function Fkb(a){a=a|0;return 2}function Gkb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Ykb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,171520,171552)|0}function Hkb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0;h=a+8|0;h=Xh[k[(k[h>>2]|0)+20>>2]&1023](h)|0;g=i[h+8+3>>0]|0;j=g<<24>>24<0;l=j?k[h>>2]|0:h;return Ykb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,l,l+((j?k[h+4>>2]|0:g&255)<<2)|0)|0}function Ikb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=k[d+28>>2]|0;d=g+4|0;k[d>>2]=(k[d>>2]|0)+1;d=Sib(g,828804)|0;fob(g);Wkb(a,f+24|0,b,k[c>>2]|0,e,d);return k[b>>2]|0}function Jkb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=k[d+28>>2]|0;d=g+4|0;k[d>>2]=(k[d>>2]|0)+1;d=Sib(g,828804)|0;fob(g);Xkb(a,f+16|0,b,k[c>>2]|0,e,d);return k[b>>2]|0}function Kkb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=k[d+28>>2]|0;d=a+4|0;k[d>>2]=(k[d>>2]|0)+1;d=Sib(a,828804)|0;fob(a);Zkb(f+20|0,b,k[c>>2]|0,e,d);return k[b>>2]|0}function Lkb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0;p=r;r=r+16|0;j=p+12|0;h=p+8|0;l=p+4|0;m=p;k[e>>2]=0;q=k[d+28>>2]|0;n=q+4|0;k[n>>2]=(k[n>>2]|0)+1;n=Sib(q,828804)|0;fob(q);a:do switch(g<<24>>24|0){case 65:case 97:{Wkb(a,f+24|0,b,k[c>>2]|0,e,n);o=127;break}case 104:case 66:case 98:{Xkb(a,f+16|0,b,k[c>>2]|0,e,n);o=127;break}case 99:{q=a+8|0;q=Xh[k[(k[q>>2]|0)+12>>2]&1023](q)|0;o=i[q+8+3>>0]|0;n=o<<24>>24<0;g=n?k[q>>2]|0:q;o=Ykb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,g,g+((n?k[q+4>>2]|0:o&255)<<2)|0)|0;k[b>>2]=o;o=127;break}case 101:case 100:{h=_kb(b,k[c>>2]|0,e,n,2)|0;j=k[e>>2]|0;if((h+-1|0)>>>0<31&(j&4|0)==0){k[f+12>>2]=h;o=127;break a}else{k[e>>2]=j|4;o=127;break a}}case 68:{o=Ykb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,171360,171392)|0;k[b>>2]=o;o=127;break}case 70:{o=Ykb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,171392,171424)|0;k[b>>2]=o;o=127;break}case 72:{h=_kb(b,k[c>>2]|0,e,n,2)|0;j=k[e>>2]|0;if((h|0)<24&(j&4|0)==0){k[f+8>>2]=h;o=127;break a}else{k[e>>2]=j|4;o=127;break a}}case 73:{h=_kb(b,k[c>>2]|0,e,n,2)|0;j=k[e>>2]|0;if((h+-1|0)>>>0<12&(j&4|0)==0){k[f+8>>2]=h;o=127;break a}else{k[e>>2]=j|4;o=127;break a}}case 106:{h=_kb(b,k[c>>2]|0,e,n,3)|0;j=k[e>>2]|0;if((h|0)<366&(j&4|0)==0){k[f+28>>2]=h;o=127;break a}else{k[e>>2]=j|4;o=127;break a}}case 109:{h=_kb(b,k[c>>2]|0,e,n,2)|0;j=k[e>>2]|0;if((h|0)<13&(j&4|0)==0){k[f+16>>2]=h+-1;o=127;break a}else{k[e>>2]=j|4;o=127;break a}}case 77:{h=_kb(b,k[c>>2]|0,e,n,2)|0;j=k[e>>2]|0;if((h|0)<60&(j&4|0)==0){k[f+4>>2]=h;o=127;break a}else{k[e>>2]=j|4;o=127;break a}}case 116:case 110:{m=k[c>>2]|0;while(1){j=k[b>>2]|0;do if(j){h=k[j+12>>2]|0;if((h|0)==(k[j+16>>2]|0))h=Xh[k[(k[j>>2]|0)+36>>2]&1023](j)|0;else h=k[h>>2]|0;if((h|0)==-1){k[b>>2]=0;j=1;break}else{j=(k[b>>2]|0)==0;break}}else j=1;while(0);l=m;if(m){h=k[l+12>>2]|0;if((h|0)==(k[l+16>>2]|0))h=Xh[k[(k[m>>2]|0)+36>>2]&1023](l)|0;else h=k[h>>2]|0;if((h|0)!=-1)if(j){h=m;m=l}else break;else{h=0;o=38}}else{h=m;o=38}if((o|0)==38){o=0;if(j){l=0;break}else m=0}j=k[b>>2]|0;l=k[j+12>>2]|0;if((l|0)==(k[j+16>>2]|0))j=Xh[k[(k[j>>2]|0)+36>>2]&1023](j)|0;else j=k[l>>2]|0;if(!(ci[k[(k[n>>2]|0)+12>>2]&255](n,8192,j)|0)){l=m;break}j=k[b>>2]|0;l=j+12|0;m=k[l>>2]|0;if((m|0)==(k[j+16>>2]|0)){Xh[k[(k[j>>2]|0)+40>>2]&1023](j)|0;m=h;continue}else{k[l>>2]=m+4;m=h;continue}}h=k[b>>2]|0;do if(h){j=k[h+12>>2]|0;if((j|0)==(k[h+16>>2]|0))h=Xh[k[(k[h>>2]|0)+36>>2]&1023](h)|0;else h=k[j>>2]|0;if((h|0)==-1){k[b>>2]=0;j=1;break}else{j=(k[b>>2]|0)==0;break}}else j=1;while(0);if(l){h=k[l+12>>2]|0;if((h|0)==(k[l+16>>2]|0))h=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else h=k[h>>2]|0;if((h|0)!=-1){if(j){o=127;break a}}else o=59}else o=59;if((o|0)==59?!j:0){o=127;break a}k[e>>2]=k[e>>2]|2;o=127;break}case 112:{d=f+8|0;m=k[c>>2]|0;l=a+8|0;l=Xh[k[(k[l>>2]|0)+8>>2]&1023](l)|0;h=i[l+8+3>>0]|0;if(h<<24>>24<0)j=k[l+4>>2]|0;else j=h&255;h=i[l+20+3>>0]|0;if(h<<24>>24<0)h=k[l+16>>2]|0;else h=h&255;if((j|0)==(0-h|0)){k[e>>2]=k[e>>2]|4;o=127;break a}h=(Cjb(b,m,l,l+24|0,n,e,0)|0)-l|0;j=k[d>>2]|0;if((j|0)==12&(h|0)==0){k[d>>2]=0;o=127;break a}if((j|0)<12&(h|0)==12){k[d>>2]=j+12;o=127}else o=127;break}case 114:{o=Ykb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,171424,171468)|0;k[b>>2]=o;o=127;break}case 82:{o=Ykb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,171468,171488)|0;k[b>>2]=o;o=127;break}case 83:{h=_kb(b,k[c>>2]|0,e,n,2)|0;j=k[e>>2]|0;if((h|0)<61&(j&4|0)==0){k[f>>2]=h;o=127;break a}else{k[e>>2]=j|4;o=127;break a}}case 84:{o=Ykb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,171488,171520)|0;k[b>>2]=o;o=127;break}case 119:{h=_kb(b,k[c>>2]|0,e,n,1)|0;j=k[e>>2]|0;if((h|0)<7&(j&4|0)==0){k[f+24>>2]=h;o=127;break a}else{k[e>>2]=j|4;o=127;break a}}case 120:{q=k[(k[a>>2]|0)+20>>2]|0;k[l>>2]=k[b>>2];k[m>>2]=k[c>>2];k[h>>2]=k[l>>2];k[j>>2]=k[m>>2];h=Sf[q&127](a,h,j,d,e,f)|0;break}case 88:{q=a+8|0;q=Xh[k[(k[q>>2]|0)+24>>2]&1023](q)|0;o=i[q+8+3>>0]|0;n=o<<24>>24<0;g=n?k[q>>2]|0:q;o=Ykb(a,k[b>>2]|0,k[c>>2]|0,d,e,f,g,g+((n?k[q+4>>2]|0:o&255)<<2)|0)|0;k[b>>2]=o;o=127;break}case 121:{Zkb(f+20|0,b,k[c>>2]|0,e,n);o=127;break}case 89:{h=_kb(b,k[c>>2]|0,e,n,4)|0;if(!(k[e>>2]&4)){k[f+20>>2]=h+-1900;o=127}else o=127;break}case 37:{l=k[c>>2]|0;h=k[b>>2]|0;do if(h){j=k[h+12>>2]|0;if((j|0)==(k[h+16>>2]|0))h=Xh[k[(k[h>>2]|0)+36>>2]&1023](h)|0;else h=k[j>>2]|0;if((h|0)==-1){k[b>>2]=0;j=1;break}else{j=(k[b>>2]|0)==0;break}}else j=1;while(0);if(l){h=k[l+12>>2]|0;if((h|0)==(k[l+16>>2]|0))h=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else h=k[h>>2]|0;if((h|0)!=-1)if(j)d=l;else o=102;else o=100}else o=100;if((o|0)==100)if(j)o=102;else d=0;if((o|0)==102){k[e>>2]=k[e>>2]|6;o=127;break a}h=k[b>>2]|0;j=k[h+12>>2]|0;if((j|0)==(k[h+16>>2]|0))h=Xh[k[(k[h>>2]|0)+36>>2]&1023](h)|0;else h=k[j>>2]|0;if((ci[k[(k[n>>2]|0)+52>>2]&255](n,h,0)|0)<<24>>24!=37){k[e>>2]=k[e>>2]|4;o=127;break a}h=k[b>>2]|0;j=h+12|0;l=k[j>>2]|0;m=k[h+16>>2]|0;if((l|0)==(m|0)){Xh[k[(k[h>>2]|0)+40>>2]&1023](h)|0;h=k[b>>2]|0;if(!h)j=1;else{j=k[h+12>>2]|0;m=k[h+16>>2]|0;o=112}}else{o=l+4|0;k[j>>2]=o;j=o;o=112}do if((o|0)==112){if((j|0)==(m|0))h=Xh[k[(k[h>>2]|0)+36>>2]&1023](h)|0;else h=k[j>>2]|0;if((h|0)==-1){k[b>>2]=0;j=1;break}else{j=(k[b>>2]|0)==0;break}}while(0);if(d){h=k[d+12>>2]|0;if((h|0)==(k[d+16>>2]|0))h=Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0;else h=k[h>>2]|0;if((h|0)!=-1){if(j){o=127;break a}}else o=123}else o=123;if((o|0)==123?!j:0){o=127;break a}k[e>>2]=k[e>>2]|2;o=127;break}default:{k[e>>2]=k[e>>2]|4;o=127}}while(0);if((o|0)==127)h=k[b>>2]|0;r=p;return h|0}function Mkb(a){a=a|0;var b=0;if(!(i[428200]|0)){i[428200]=1;if(!(i[428208]|0)){i[428208]=1;b=830264;do{k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[b+(a<<2)>>2]=0;a=a+1|0}b=b+12|0}while((b|0)!=830432);ud(1531,0,x|0)|0}vob(830264,171020);vob(830276,171048);vob(830288,171076);vob(830300,171108);vob(830312,171148);vob(830324,171184);vob(830336,171212);vob(830348,171248);vob(830360,171264);vob(830372,171280);vob(830384,171296);vob(830396,171312);vob(830408,171328);vob(830420,171344);k[207608]=830264}return k[207608]|0}function Nkb(a){a=a|0;var b=0;if(!(i[428184]|0)){i[428184]=1;if(!(i[428192]|0)){i[428192]=1;b=829972;do{k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[b+(a<<2)>>2]=0;a=a+1|0}b=b+12|0}while((b|0)!=830260);ud(1532,0,x|0)|0}vob(829972,170500);vob(829984,170532);vob(829996,170568);vob(830008,170592);vob(830020,170616);vob(830032,170632);vob(830044,170652);vob(830056,170672);vob(830068,170700);vob(830080,170740);vob(830092,170772);vob(830104,170808);vob(830116,170844);vob(830128,170860);vob(830140,170876);vob(830152,170892);vob(830164,170616);vob(830176,170908);vob(830188,170924);vob(830200,170940);vob(830212,170956);vob(830224,170972);vob(830236,170988);vob(830248,171004);k[207565]=829972}return k[207565]|0}function Okb(a){a=a|0;var b=0;if(!(i[428168]|0)){i[428168]=1;if(!(i[428176]|0)){i[428176]=1;b=829680;do{k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[b+(a<<2)>>2]=0;a=a+1|0}b=b+12|0}while((b|0)!=829968);ud(1533,0,x|0)|0}vob(829680,170476);vob(829692,170488);k[207492]=829680}return k[207492]|0}function Pkb(a){a=a|0;if(!(i[428160]|0)){i[428160]=1;k[207417]=0;k[207418]=0;k[207419]=0;rob(829668,170392,20);ud(1534,829668,x|0)|0}return 829668}function Qkb(a){a=a|0;if(!(i[428152]|0)){i[428152]=1;k[207414]=0;k[207415]=0;k[207416]=0;rob(829656,170344,11);ud(1534,829656,x|0)|0}return 829656}function Rkb(a){a=a|0;if(!(i[428144]|0)){i[428144]=1;k[207411]=0;k[207412]=0;k[207413]=0;rob(829644,170308,8);ud(1534,829644,x|0)|0}return 829644}function Skb(a){a=a|0;if(!(i[428136]|0)){i[428136]=1;k[207408]=0;k[207409]=0;k[207410]=0;rob(829632,170272,8);ud(1534,829632,x|0)|0}return 829632}function Tkb(a){a=a|0;a=829968;do{a=a+-12|0;tob(a)}while((a|0)!=829680);return}function Ukb(a){a=a|0;a=830260;do{a=a+-12|0;tob(a)}while((a|0)!=829972);return}function Vkb(a){a=a|0;a=830432;do{a=a+-12|0;tob(a)}while((a|0)!=830264);return}function Wkb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=a+8|0;a=Xh[k[k[a>>2]>>2]&1023](a)|0;d=(Cjb(c,d,a,a+168|0,f,e,0)|0)-a|0;if((d|0)<168)k[b>>2]=((d|0)/12|0|0)%7|0;return}function Xkb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=a+8|0;a=Xh[k[(k[a>>2]|0)+4>>2]&1023](a)|0;d=(Cjb(c,d,a,a+288|0,f,e,0)|0)-a|0;if((d|0)<288)k[b>>2]=((d|0)/12|0|0)%12|0;return}function Ykb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+16|0;s=x+12|0;q=x+8|0;u=x+4|0;v=x;i=k[d+28>>2]|0;t=i+4|0;k[t>>2]=(k[t>>2]|0)+1;t=Sib(i,828804)|0;fob(i);k[e>>2]=0;i=0;a:while(1){m=(g|0)!=(h|0);while(1){if(!(m&(i|0)==0)){i=c;break a}j=b;if(!b){o=0;b=0;l=1;n=j}else{i=k[b+12>>2]|0;if((i|0)==(k[b+16>>2]|0))i=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else i=k[i>>2]|0;n=(i|0)==-1;o=n?0:b;b=n?0:b;l=n;n=n?0:j}i=c;if(c){j=k[c+12>>2]|0;if((j|0)==(k[c+16>>2]|0))j=Xh[k[(k[c>>2]|0)+36>>2]&1023](c)|0;else j=k[j>>2]|0;if((j|0)!=-1){if(!l){w=16;break a}}else{i=0;w=14}}else w=14;if((w|0)==14){w=0;if(l){c=0;w=16;break a}else c=0}if((ci[k[(k[t>>2]|0)+52>>2]&255](t,k[g>>2]|0,0)|0)<<24>>24==37){w=18;break}if(ci[k[(k[t>>2]|0)+12>>2]&255](t,8192,k[g>>2]|0)|0){w=26;break}j=b+12|0;i=k[j>>2]|0;l=b+16|0;if((i|0)==(k[l>>2]|0))i=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else i=k[i>>2]|0;p=Hh[k[(k[t>>2]|0)+28>>2]&511](t,i)|0;if((p|0)==(Hh[k[(k[t>>2]|0)+28>>2]&511](t,k[g>>2]|0)|0)){w=52;break}k[e>>2]=4;b=o;i=4}b:do if((w|0)==18){w=0;l=g+4|0;if((l|0)==(h|0)){w=19;break a}j=ci[k[(k[t>>2]|0)+52>>2]&255](t,k[l>>2]|0,0)|0;switch(j<<24>>24){case 48:case 69:{g=g+8|0;if((g|0)==(h|0)){w=24;break a}m=j;b=ci[k[(k[t>>2]|0)+52>>2]&255](t,k[g>>2]|0,0)|0;g=l;break}default:{m=0;b=j}}p=k[(k[a>>2]|0)+36>>2]|0;k[u>>2]=n;k[v>>2]=i;k[q>>2]=k[u>>2];k[s>>2]=k[v>>2];g=g+8|0;b=si[p&15](a,q,s,d,e,f,b,m)|0}else if((w|0)==26){while(1){w=0;g=g+4|0;if((g|0)==(h|0)){g=h;break}if(ci[k[(k[t>>2]|0)+12>>2]&255](t,8192,k[g>>2]|0)|0)w=26;else break}m=b;i=c;b=o;p=c;l=c;while(1){if(!m){j=1;m=0}else{c=k[m+12>>2]|0;if((c|0)==(k[m+16>>2]|0))c=Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0;else c=k[c>>2]|0;o=(c|0)==-1;b=o?0:b;j=o;m=o?0:m}if(l){c=k[l+12>>2]|0;if((c|0)==(k[l+16>>2]|0))c=Xh[k[(k[l>>2]|0)+36>>2]&1023](l)|0;else c=k[c>>2]|0;if((c|0)!=-1)if(j^(i|0)==0){n=i;c=p;o=i}else{c=p;break b}else{i=0;c=0;w=39}}else{c=p;w=39}if((w|0)==39){w=0;if(j)break b;else{n=i;o=0}}j=m+12|0;i=k[j>>2]|0;l=m+16|0;if((i|0)==(k[l>>2]|0))i=Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0;else i=k[i>>2]|0;if(!(ci[k[(k[t>>2]|0)+12>>2]&255](t,8192,i)|0))break b;i=k[j>>2]|0;if((i|0)==(k[l>>2]|0)){Xh[k[(k[m>>2]|0)+40>>2]&1023](m)|0;i=n;p=c;l=o;continue}else{k[j>>2]=i+4;i=n;p=c;l=o;continue}}}else if((w|0)==52){w=0;i=k[j>>2]|0;if((i|0)==(k[l>>2]|0))Xh[k[(k[b>>2]|0)+40>>2]&1023](b)|0;else k[j>>2]=i+4;g=g+4|0;b=o}while(0);i=k[e>>2]|0}if((w|0)==16){k[e>>2]=4;i=c}else if((w|0)==19){k[e>>2]=4;i=c}else if((w|0)==24){k[e>>2]=4;i=c}if(!b){b=0;g=1}else{c=k[b+12>>2]|0;if((c|0)==(k[b+16>>2]|0))c=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else c=k[c>>2]|0;g=(c|0)==-1;b=g?0:b}if(i){c=k[i+12>>2]|0;if((c|0)==(k[i+16>>2]|0))c=Xh[k[(k[i>>2]|0)+36>>2]&1023](i)|0;else c=k[c>>2]|0;if((c|0)!=-1){if(!g)w=70}else w=68}else w=68;if((w|0)==68?g:0)w=70;if((w|0)==70)k[e>>2]=k[e>>2]|2;r=x;return b|0}function Zkb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;c=_kb(b,c,d,e,4)|0;if(!(k[d>>2]&4)){if((c|0)<69)c=c+2e3|0;else c=(c|0)<100?c+1900|0:c;k[a>>2]=c+-1900}return}function _kb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;f=k[a>>2]|0;do if(f){g=k[f+12>>2]|0;if((g|0)==(k[f+16>>2]|0))f=Xh[k[(k[f>>2]|0)+36>>2]&1023](f)|0;else f=k[g>>2]|0;if((f|0)==-1){k[a>>2]=0;g=1;break}else{g=(k[a>>2]|0)==0;break}}else g=1;while(0);if(b){f=k[b+12>>2]|0;if((f|0)==(k[b+16>>2]|0))f=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else f=k[f>>2]|0;if((f|0)!=-1)if(g){i=b;o=16}else o=15;else o=13}else o=13;if((o|0)==13)if(g)o=15;else{i=0;o=16}a:do if((o|0)==15){k[c>>2]=k[c>>2]|6;f=0}else if((o|0)==16){f=k[a>>2]|0;g=k[f+12>>2]|0;if((g|0)==(k[f+16>>2]|0))f=Xh[k[(k[f>>2]|0)+36>>2]&1023](f)|0;else f=k[g>>2]|0;if(!(ci[k[(k[d>>2]|0)+12>>2]&255](d,2048,f)|0)){k[c>>2]=k[c>>2]|4;f=0;break}f=(ci[k[(k[d>>2]|0)+52>>2]&255](d,f,0)|0)<<24>>24;g=k[a>>2]|0;b=g+12|0;h=k[b>>2]|0;if((h|0)==(k[g+16>>2]|0)){Xh[k[(k[g>>2]|0)+40>>2]&1023](g)|0;j=i;h=i}else{k[b>>2]=h+4;j=i;h=i}while(1){f=f+-48|0;n=e+-1|0;g=k[a>>2]|0;do if(g){b=k[g+12>>2]|0;if((b|0)==(k[g+16>>2]|0))g=Xh[k[(k[g>>2]|0)+36>>2]&1023](g)|0;else g=k[b>>2]|0;if((g|0)==-1){k[a>>2]=0;i=1;break}else{i=(k[a>>2]|0)==0;break}}else i=1;while(0);if(!h){m=j;l=0;g=1}else{g=k[h+12>>2]|0;if((g|0)==(k[h+16>>2]|0))g=Xh[k[(k[h>>2]|0)+36>>2]&1023](h)|0;else g=k[g>>2]|0;g=(g|0)==-1;m=g?0:j;l=g?0:j;g=g|(j|0)==0}b=k[a>>2]|0;if(!((e|0)>1&(i^g)))break;g=k[b+12>>2]|0;if((g|0)==(k[b+16>>2]|0))g=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else g=k[g>>2]|0;if(!(ci[k[(k[d>>2]|0)+12>>2]&255](d,2048,g)|0))break a;f=((ci[k[(k[d>>2]|0)+52>>2]&255](d,g,0)|0)<<24>>24)+(f*10|0)|0;g=k[a>>2]|0;b=g+12|0;h=k[b>>2]|0;if((h|0)==(k[g+16>>2]|0)){Xh[k[(k[g>>2]|0)+40>>2]&1023](g)|0;e=n;j=m;h=l;continue}else{k[b>>2]=h+4;e=n;j=m;h=l;continue}}do if(b){g=k[b+12>>2]|0;if((g|0)==(k[b+16>>2]|0))g=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else g=k[g>>2]|0;if((g|0)==-1){k[a>>2]=0;b=1;break}else{b=(k[a>>2]|0)==0;break}}else b=1;while(0);if(m){g=k[m+12>>2]|0;if((g|0)==(k[m+16>>2]|0))g=Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0;else g=k[g>>2]|0;if((g|0)!=-1){if(b)break}else o=56}else o=56;if((o|0)==56?!b:0)break;k[c>>2]=k[c>>2]|2}while(0);return f|0}function $kb(a){a=a|0;dlb(a+8|0);return}function alb(a){a=a|0;dlb(a+8|0);ggb(a);return}function blb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=r;r=r+112|0;c=h+4|0;d=h;k[d>>2]=c+100;clb(a+8|0,c,d,e,f,g);g=k[d>>2]|0;f=c;c=k[b>>2]|0;while(1){if((f|0)==(g|0))break;d=i[f>>0]|0;do if(c){a=c+24|0;e=k[a>>2]|0;if((e|0)==(k[c+28>>2]|0)){b=(Hh[k[(k[c>>2]|0)+52>>2]&511](c,d&255)|0)==-1;c=b?0:c;break}else{k[a>>2]=e+1;i[e>>0]=d;break}}else c=0;while(0);f=f+1|0}r=h;return c|0}function clb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0;l=r;r=r+16|0;g=l;i[g>>0]=37;h=g+1|0;i[h>>0]=e;j=g+2|0;i[j>>0]=f;i[g+3>>0]=0;if(f<<24>>24){i[h>>0]=f;i[j>>0]=e}j=b+(hf(b|0,(k[c>>2]|0)-b|0,g|0,d|0,k[a>>2]|0)|0)|0;k[c>>2]=j;r=l;return}function dlb(a){a=a|0;var b=0;b=k[a>>2]|0;if((b|0)!=(Uib()|0))ggb(k[a>>2]|0);return}function elb(a){a=a|0;dlb(a+8|0);return}function flb(a){a=a|0;dlb(a+8|0);ggb(a);return}function glb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0;i=r;r=r+528|0;l=i+416|0;m=i+412|0;d=i;j=i+408|0;h=i+8|0;c=a+8|0;k[m>>2]=l+100;clb(c,l,m,e,f,g);g=d;k[g>>2]=0;k[g+4>>2]=0;k[j>>2]=l;c=xfb(k[c>>2]|0)|0;d=zfb(h,j,100,d)|0;if(c|0){m=(Fpb()|0)+184|0;k[m>>2]=c}g=h+(d<<2)|0;f=h;c=k[b>>2]|0;while(1){if((f|0)==(g|0))break;d=k[f>>2]|0;if(!c)c=0;else{a=c+24|0;e=k[a>>2]|0;if((e|0)==(k[c+28>>2]|0))d=Hh[k[(k[c>>2]|0)+52>>2]&511](c,d)|0;else{k[a>>2]=e+4;k[e>>2]=d}c=(d|0)==-1?0:c}f=f+4|0}r=i;return c|0}function hlb(a){a=a|0;return}function ilb(a){a=a|0;ggb(a);return}function jlb(a){a=a|0;return 127}function klb(a){a=a|0;return 127}function llb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}return}function mlb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}return}function nlb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}return}function olb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;i[a+11>>0]=1;i[a>>0]=45;i[a+1>>0]=0;return}function plb(a){a=a|0;return 0}function qlb(a,b){a=a|0;b=b|0;i[a>>0]=2;i[a+1>>0]=3;i[a+2>>0]=0;i[a+3>>0]=4;return}function rlb(a,b){a=a|0;b=b|0;i[a>>0]=2;i[a+1>>0]=3;i[a+2>>0]=0;i[a+3>>0]=4;return}function slb(a){a=a|0;return}function tlb(a){a=a|0;ggb(a);return}function ulb(a){a=a|0;return 127}function vlb(a){a=a|0;return 127}function wlb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}return}function xlb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}return}function ylb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}return}function zlb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;i[a+11>>0]=1;i[a>>0]=45;i[a+1>>0]=0;return}function Alb(a){a=a|0;return 0}function Blb(a,b){a=a|0;b=b|0;i[a>>0]=2;i[a+1>>0]=3;i[a+2>>0]=0;i[a+3>>0]=4;return}function Clb(a,b){a=a|0;b=b|0;i[a>>0]=2;i[a+1>>0]=3;i[a+2>>0]=0;i[a+3>>0]=4;return}function Dlb(a){a=a|0;return}function Elb(a){a=a|0;ggb(a);return}function Flb(a){a=a|0;return 2147483647}function Glb(a){a=a|0;return 2147483647}function Hlb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}return}function Ilb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}return}function Jlb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}return}function Klb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;i[a+8+3>>0]=1;k[a>>2]=45;k[a+4>>2]=0;return}function Llb(a){a=a|0;return 0}function Mlb(a,b){a=a|0;b=b|0;i[a>>0]=2;i[a+1>>0]=3;i[a+2>>0]=0;i[a+3>>0]=4;return}function Nlb(a,b){a=a|0;b=b|0;i[a>>0]=2;i[a+1>>0]=3;i[a+2>>0]=0;i[a+3>>0]=4;return}function Olb(a){a=a|0;return}function Plb(a){a=a|0;ggb(a);return}function Qlb(a){a=a|0;return 2147483647}function Rlb(a){a=a|0;return 2147483647}function Slb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}return}function Tlb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}return}function Ulb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}return}function Vlb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;i[a+8+3>>0]=1;k[a>>2]=45;k[a+4>>2]=0;return}function Wlb(a){a=a|0;return 0}function Xlb(a,b){a=a|0;b=b|0;i[a>>0]=2;i[a+1>>0]=3;i[a+2>>0]=0;i[a+3>>0]=4;return}function Ylb(a,b){a=a|0;b=b|0;i[a>>0]=2;i[a+1>>0]=3;i[a+2>>0]=0;i[a+3>>0]=4;return}function Zlb(a){a=a|0;return}function _lb(a){a=a|0;ggb(a);return}function $lb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+240|0;q=w;m=w+128|0;v=w+8|0;p=w+4|0;h=w+126|0;n=w+116|0;o=w+16|0;k[v>>2]=m;u=v+4|0;k[u>>2]=1535;s=k[e+28>>2]|0;a=s+4|0;k[a>>2]=(k[a>>2]|0)+1;a=Sib(s,828772)|0;i[h>>0]=0;if(cmb(b,k[c>>2]|0,d,s,k[e+4>>2]|0,f,h,a,v,p,m+100|0)|0){Dg[k[(k[a>>2]|0)+32>>2]&127](a,425694,425704,n)|0;d=k[p>>2]|0;e=k[v>>2]|0;a=d-e|0;if((a|0)>98){m=fgb(a+2|0)|0;a=m}else{a=o;m=0}if(i[h>>0]|0){i[a>>0]=45;a=a+1|0}j=n+10|0;l=n;h=e;while(1){if(h>>>0>=d>>>0)break;e=i[h>>0]|0;d=n;while(1){if((d|0)==(j|0)){d=j;break}if((i[d>>0]|0)==e<<24>>24)break;d=d+1|0}i[a>>0]=i[425694+(d-l)>>0]|0;h=h+1|0;a=a+1|0;d=k[p>>2]|0}i[a>>0]=0;k[q>>2]=g;Wfb(o,425705,q)|0;if(m|0)ggb(m)}a=k[b>>2]|0;do if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0))if((Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1){k[b>>2]=0;a=0;break}else{a=k[b>>2]|0;break}}else a=0;while(0);a=(a|0)==0;d=k[c>>2]|0;do if(d){if((k[d+12>>2]|0)==(k[d+16>>2]|0)?(Xh[k[(k[d>>2]|0)+36>>2]&1023](d)|0)==-1:0){k[c>>2]=0;t=26;break}if(!a)t=27}else t=26;while(0);if((t|0)==26?a:0)t=27;if((t|0)==27)k[f>>2]=k[f>>2]|2;d=k[b>>2]|0;fob(s);a=k[v>>2]|0;k[v>>2]=0;if(a|0)Uh[k[u>>2]&2047](a);r=w;return d|0}function amb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+128|0;o=w+20|0;v=w+8|0;j=w;a=w+16|0;k[v>>2]=o;u=v+4|0;k[u>>2]=1535;s=k[e+28>>2]|0;h=s+4|0;k[h>>2]=(k[h>>2]|0)+1;h=Sib(s,828772)|0;i[a>>0]=0;q=k[c>>2]|0;p=q;do if(cmb(b,p,d,s,k[e+4>>2]|0,f,a,h,v,j,o+100|0)|0){o=g+11|0;if((i[o>>0]|0)<0){i[k[g>>2]>>0]=0;k[g+4>>2]=0}else{i[g>>0]=0;i[o>>0]=0}if(i[a>>0]|0)qob(g,Hh[k[(k[h>>2]|0)+28>>2]&511](h,45)|0);h=Hh[k[(k[h>>2]|0)+28>>2]&511](h,48)|0;n=k[j>>2]|0;a=n+-1|0;m=k[v>>2]|0;while(1){if(m>>>0>=a>>>0)break;if((i[m>>0]|0)!=h<<24>>24)break;m=m+1|0}d=m;a=i[o>>0]|0;if(a<<24>>24<0){l=k[g+4>>2]|0;h=(k[g+8>>2]&2147483647)+-1|0}else{l=a&255;h=10}j=n-d|0;if(j|0){if((h-l|0)>>>0<j>>>0){pob(g,h,l+j-h|0,l,l);a=i[o>>0]|0}e=a<<24>>24<0?k[g>>2]|0:g;d=n+(l-d)|0;h=e+l|0;a=m;while(1){if((a|0)==(n|0))break;i[h>>0]=i[a>>0]|0;h=h+1|0;a=a+1|0}i[e+d>>0]=0;a=l+j|0;if((i[o>>0]|0)<0){k[g+4>>2]=a;break}else{i[o>>0]=a;break}}}while(0);a=k[b>>2]|0;do if(a){if((k[a+12>>2]|0)==(k[a+16>>2]|0))if((Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)==-1){k[b>>2]=0;a=0;break}else{a=k[b>>2]|0;break}}else a=0;while(0);a=(a|0)==0;do if(q){if((k[p+12>>2]|0)==(k[p+16>>2]|0)?(Xh[k[(k[q>>2]|0)+36>>2]&1023](p)|0)==-1:0){k[c>>2]=0;t=33;break}if(!a)t=34}else t=33;while(0);if((t|0)==33?a:0)t=34;if((t|0)==34)k[f>>2]=k[f>>2]|2;h=k[b>>2]|0;fob(s);a=k[v>>2]|0;k[v>>2]=0;if(a|0)Uh[k[u>>2]&2047](a);r=w;return h|0}function bmb(a){a=a|0;return}function cmb(a,b,c,d,e,f,g,h,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=r;r=r+496|0;T=$+484|0;O=$+480|0;v=$+80|0;_=$+72|0;P=$+68|0;Q=$+64|0;R=$+60|0;U=$+48|0;V=$+36|0;W=$+24|0;X=$+12|0;Y=$;k[O>>2]=o;k[_>>2]=v;Z=_+4|0;k[Z>>2]=1535;k[P>>2]=v;k[Q>>2]=v+400;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;o=0;while(1){if((o|0)==3)break;k[U+(o<<2)>>2]=0;o=o+1|0}k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;o=0;while(1){if((o|0)==3)break;k[V+(o<<2)>>2]=0;o=o+1|0}k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;o=0;while(1){if((o|0)==3)break;k[W+(o<<2)>>2]=0;o=o+1|0}k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;o=0;while(1){if((o|0)==3)break;k[X+(o<<2)>>2]=0;o=o+1|0}k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;o=0;while(1){if((o|0)==3)break;k[Y+(o<<2)>>2]=0;o=o+1|0}if(c){u=Sib(d,830468)|0;jh[k[(k[u>>2]|0)+44>>2]&1023](R,u);jh[k[(k[u>>2]|0)+32>>2]&1023](T,u);t=X+11|0;if((i[t>>0]|0)<0){i[k[X>>2]>>0]=0;k[X+4>>2]=0}else{i[X>>0]=0;i[t>>0]=0}mob(X);k[X>>2]=k[T>>2];k[X+4>>2]=k[T+4>>2];k[X+8>>2]=k[T+8>>2];o=0;while(1){if((o|0)==3)break;k[T+(o<<2)>>2]=0;o=o+1|0}kob(T);jh[k[(k[u>>2]|0)+28>>2]&1023](T,u);p=W+11|0;if((i[p>>0]|0)<0){i[k[W>>2]>>0]=0;k[W+4>>2]=0}else{i[W>>0]=0;i[p>>0]=0}mob(W);k[W>>2]=k[T>>2];k[W+4>>2]=k[T+4>>2];k[W+8>>2]=k[T+8>>2];o=0;while(1){if((o|0)==3)break;k[T+(o<<2)>>2]=0;o=o+1|0}kob(T);c=Xh[k[(k[u>>2]|0)+12>>2]&1023](u)|0;d=Xh[k[(k[u>>2]|0)+16>>2]&1023](u)|0;jh[k[(k[u>>2]|0)+20>>2]&1023](T,u);s=U+11|0;if((i[s>>0]|0)<0){i[k[U>>2]>>0]=0;k[U+4>>2]=0}else{i[U>>0]=0;i[s>>0]=0}mob(U);k[U>>2]=k[T>>2];k[U+4>>2]=k[T+4>>2];k[U+8>>2]=k[T+8>>2];o=0;while(1){if((o|0)==3)break;k[T+(o<<2)>>2]=0;o=o+1|0}kob(T);jh[k[(k[u>>2]|0)+24>>2]&1023](T,u);q=V+11|0;if((i[q>>0]|0)<0){i[k[V>>2]>>0]=0;k[V+4>>2]=0}else{i[V>>0]=0;i[q>>0]=0}mob(V);k[V>>2]=k[T>>2];k[V+4>>2]=k[T+4>>2];k[V+8>>2]=k[T+8>>2];o=0;while(1){if((o|0)==3)break;k[T+(o<<2)>>2]=0;o=o+1|0}kob(T);o=Xh[k[(k[u>>2]|0)+36>>2]&1023](u)|0}else{u=Sib(d,830460)|0;jh[k[(k[u>>2]|0)+44>>2]&1023](T,u);k[R>>2]=k[T>>2];jh[k[(k[u>>2]|0)+32>>2]&1023](T,u);t=X+11|0;if((i[t>>0]|0)<0){i[k[X>>2]>>0]=0;k[X+4>>2]=0}else{i[X>>0]=0;i[t>>0]=0}mob(X);k[X>>2]=k[T>>2];k[X+4>>2]=k[T+4>>2];k[X+8>>2]=k[T+8>>2];o=0;while(1){if((o|0)==3)break;k[T+(o<<2)>>2]=0;o=o+1|0}kob(T);jh[k[(k[u>>2]|0)+28>>2]&1023](T,u);p=W+11|0;if((i[p>>0]|0)<0){i[k[W>>2]>>0]=0;k[W+4>>2]=0}else{i[W>>0]=0;i[p>>0]=0}mob(W);k[W>>2]=k[T>>2];k[W+4>>2]=k[T+4>>2];k[W+8>>2]=k[T+8>>2];o=0;while(1){if((o|0)==3)break;k[T+(o<<2)>>2]=0;o=o+1|0}kob(T);c=Xh[k[(k[u>>2]|0)+12>>2]&1023](u)|0;d=Xh[k[(k[u>>2]|0)+16>>2]&1023](u)|0;jh[k[(k[u>>2]|0)+20>>2]&1023](T,u);s=U+11|0;if((i[s>>0]|0)<0){i[k[U>>2]>>0]=0;k[U+4>>2]=0}else{i[U>>0]=0;i[s>>0]=0}mob(U);k[U>>2]=k[T>>2];k[U+4>>2]=k[T+4>>2];k[U+8>>2]=k[T+8>>2];o=0;while(1){if((o|0)==3)break;k[T+(o<<2)>>2]=0;o=o+1|0}kob(T);jh[k[(k[u>>2]|0)+24>>2]&1023](T,u);q=V+11|0;if((i[q>>0]|0)<0){i[k[V>>2]>>0]=0;k[V+4>>2]=0}else{i[V>>0]=0;i[q>>0]=0}mob(V);k[V>>2]=k[T>>2];k[V+4>>2]=k[T+4>>2];k[V+8>>2]=k[T+8>>2];o=0;while(1){if((o|0)==3)break;k[T+(o<<2)>>2]=0;o=o+1|0}kob(T);o=Xh[k[(k[u>>2]|0)+36>>2]&1023](u)|0}k[n>>2]=k[m>>2];K=h+8|0;L=W+4|0;M=X+4|0;E=(e&512|0)!=0;F=V+4|0;G=Y+11|0;H=Y+4|0;I=R+3|0;J=U+4|0;N=0;D=0;C=o;B=v;a:while(1){if(D>>>0>=4){S=262;break}o=k[a>>2]|0;do if(o){if((k[o+12>>2]|0)==(k[o+16>>2]|0))if((Xh[k[(k[o>>2]|0)+36>>2]&1023](o)|0)==-1){k[a>>2]=0;o=0;break}else{o=k[a>>2]|0;break}}else o=0;while(0);o=(o|0)==0;do if(b){if((k[b+12>>2]|0)!=(k[b+16>>2]|0))if(o)break;else{S=262;break a}if((Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0)!=-1){if(!o){S=262;break a}}else S=78}else S=78;while(0);if((S|0)==78){S=0;if(o){b=0;S=262;break}else b=0}b:do switch(i[R+D>>0]|0){case 1:{if((D|0)==3){h=N;o=C;u=B}else{o=k[a>>2]|0;u=k[o+12>>2]|0;if((u|0)==(k[o+16>>2]|0))o=Xh[k[(k[o>>2]|0)+36>>2]&1023](o)|0;else o=l[u>>0]|0;if((o&255)<<24>>24<=-1){S=91;break a}if(!(j[(k[K>>2]|0)+(o<<24>>24<<1)>>1]&8192)){S=91;break a}o=k[a>>2]|0;u=o+12|0;h=k[u>>2]|0;if((h|0)==(k[o+16>>2]|0))o=Xh[k[(k[o>>2]|0)+40>>2]&1023](o)|0;else{k[u>>2]=h+1;o=l[h>>0]|0}qob(Y,o&255);o=b;e=b;h=b;S=93}break}case 0:{if((D|0)==3){h=N;o=C;u=B}else{o=b;e=b;h=b;S=93}break}case 3:{o=i[p>>0]|0;u=o<<24>>24<0?k[L>>2]|0:o&255;e=i[t>>0]|0;e=e<<24>>24<0?k[M>>2]|0:e&255;if((u|0)==(0-e|0)){h=N;o=C;u=B}else{v=(u|0)==0;w=k[a>>2]|0;x=k[w+12>>2]|0;u=k[w+16>>2]|0;h=(x|0)==(u|0);if(v|(e|0)==0){if(h)o=Xh[k[(k[w>>2]|0)+36>>2]&1023](w)|0;else o=l[x>>0]|0;u=o&255;if(v){o=i[t>>0]|0;if(u<<24>>24!=(i[(o<<24>>24<0?k[X>>2]|0:X)>>0]|0)){h=N;o=C;u=B;break b}u=k[a>>2]|0;h=u+12|0;e=k[h>>2]|0;if((e|0)==(k[u+16>>2]|0)){Xh[k[(k[u>>2]|0)+40>>2]&1023](u)|0;o=i[t>>0]|0}else k[h>>2]=e+1;i[g>>0]=1;h=(o<<24>>24<0?k[M>>2]|0:o&255)>>>0>1?X:N;o=C;u=B;break b}o=i[p>>0]|0;if(u<<24>>24!=(i[(o<<24>>24<0?k[W>>2]|0:W)>>0]|0)){i[g>>0]=1;h=N;o=C;u=B;break b}u=k[a>>2]|0;h=u+12|0;e=k[h>>2]|0;if((e|0)==(k[u+16>>2]|0)){Xh[k[(k[u>>2]|0)+40>>2]&1023](u)|0;o=i[p>>0]|0}else k[h>>2]=e+1;h=(o<<24>>24<0?k[L>>2]|0:o&255)>>>0>1?W:N;o=C;u=B;break b}if(h){v=Xh[k[(k[w>>2]|0)+36>>2]&1023](w)|0;u=k[a>>2]|0;o=i[p>>0]|0;w=u;e=k[u+12>>2]|0;u=k[u+16>>2]|0}else{v=l[x>>0]|0;e=x}h=w+12|0;u=(e|0)==(u|0);if((v&255)<<24>>24==(i[(o<<24>>24<0?k[W>>2]|0:W)>>0]|0)){if(u){Xh[k[(k[w>>2]|0)+40>>2]&1023](w)|0;o=i[p>>0]|0}else k[h>>2]=e+1;h=(o<<24>>24<0?k[L>>2]|0:o&255)>>>0>1?W:N;o=C;u=B;break b}if(u)u=Xh[k[(k[w>>2]|0)+36>>2]&1023](w)|0;else u=l[e>>0]|0;o=i[t>>0]|0;if((u&255)<<24>>24!=(i[(o<<24>>24<0?k[X>>2]|0:X)>>0]|0)){S=146;break a}u=k[a>>2]|0;h=u+12|0;e=k[h>>2]|0;if((e|0)==(k[u+16>>2]|0)){Xh[k[(k[u>>2]|0)+40>>2]&1023](u)|0;o=i[t>>0]|0}else k[h>>2]=e+1;i[g>>0]=1;h=(o<<24>>24<0?k[M>>2]|0:o&255)>>>0>1?X:N;o=C;u=B}break}case 2:{if(!(D>>>0<2|(N|0)!=0)?!(E|(D|0)==2&(i[I>>0]|0)!=0):0){h=0;o=C;u=B;break b}y=i[q>>0]|0;o=y<<24>>24<0;A=k[V>>2]|0;u=o?A:V;w=u;c:do if((D|0)!=0?(l[R+(D+-1)>>0]|0)<2:0){o=u+(o?k[F>>2]|0:y&255)|0;v=w;while(1){h=v;if((h|0)==(o|0))break;e=i[h>>0]|0;if(e<<24>>24<=-1)break;if(!(j[(k[K>>2]|0)+(e<<24>>24<<1)>>1]&8192))break;v=h+1|0}e=v-w|0;h=i[G>>0]|0;o=h<<24>>24<0;h=o?k[H>>2]|0:h&255;if(e>>>0<=h>>>0){h=(o?k[Y>>2]|0:Y)+h|0;o=h+(0-e)|0;while(1){if((o|0)==(h|0)){x=b;z=b;h=v;u=y;o=A;e=b;break c}if((i[o>>0]|0)!=(i[u>>0]|0)){x=b;z=b;h=w;u=y;o=A;e=b;break c}u=u+1|0;o=o+1|0}}else{x=b;z=b;h=w;u=y;o=A;e=b}}else{x=b;z=b;h=w;u=y;o=A;e=b}while(0);d:while(1){w=u<<24>>24<0;o=(w?o:V)+(w?k[F>>2]|0:u&255)|0;w=h;if((w|0)==(o|0)){b=z;break}b=k[a>>2]|0;do if(b){if((k[b+12>>2]|0)==(k[b+16>>2]|0))if((Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0)==-1){k[a>>2]=0;b=0;break}else{b=k[a>>2]|0;break}}else b=0;while(0);u=(b|0)==0;do if(e){if((k[e+12>>2]|0)!=(k[e+16>>2]|0))if(u){v=x;b=z;break}else{o=w;b=z;break d}if((Xh[k[(k[e>>2]|0)+36>>2]&1023](e)|0)!=-1)if(u^(x|0)==0){v=x;b=z;e=x}else{o=w;b=z;break d}else{o=0;b=0;S=171}}else{o=x;b=z;S=171}while(0);if((S|0)==171){S=0;if(u){o=w;break}else{v=o;e=0}}o=k[a>>2]|0;u=k[o+12>>2]|0;if((u|0)==(k[o+16>>2]|0))o=Xh[k[(k[o>>2]|0)+36>>2]&1023](o)|0;else o=l[u>>0]|0;if((o&255)<<24>>24!=(i[w>>0]|0)){o=w;break}o=k[a>>2]|0;u=o+12|0;h=k[u>>2]|0;if((h|0)==(k[o+16>>2]|0))Xh[k[(k[o>>2]|0)+40>>2]&1023](o)|0;else k[u>>2]=h+1;x=v;z=b;h=w+1|0;u=i[q>>0]|0;o=k[V>>2]|0}if(E?(A=i[q>>0]|0,z=A<<24>>24<0,(o|0)!=((z?k[V>>2]|0:V)+(z?k[F>>2]|0:A&255)|0)):0){S=183;break a}else{h=N;o=C;u=B}break}case 4:{v=0;u=b;w=b;e=b;o=B;e:while(1){b=k[a>>2]|0;do if(b){if((k[b+12>>2]|0)==(k[b+16>>2]|0))if((Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0)==-1){k[a>>2]=0;b=0;break}else{b=k[a>>2]|0;break}}else b=0;while(0);h=(b|0)==0;do if(e){if((k[e+12>>2]|0)!=(k[e+16>>2]|0))if(h){y=u;b=w;x=e;break}else{b=w;break e}if((Xh[k[(k[e>>2]|0)+36>>2]&1023](e)|0)!=-1)if(h^(u|0)==0){y=u;b=w;x=u}else{b=w;break e}else{u=0;b=0;S=193}}else{b=w;S=193}while(0);if((S|0)==193){S=0;if(h)break;else{y=u;x=0}}u=k[a>>2]|0;h=k[u+12>>2]|0;if((h|0)==(k[u+16>>2]|0))u=Xh[k[(k[u>>2]|0)+36>>2]&1023](u)|0;else u=l[h>>0]|0;h=u&255;if(h<<24>>24>-1?(j[(k[K>>2]|0)+(u<<24>>24<<1)>>1]&2048)!=0:0){u=k[n>>2]|0;if((u|0)==(k[O>>2]|0)){dmb(m,n,O);u=k[n>>2]|0}k[n>>2]=u+1;i[u>>0]=h;v=v+1|0}else{B=i[s>>0]|0;if(!(h<<24>>24==d<<24>>24&(v|0?((B<<24>>24<0?k[J>>2]|0:B&255)|0)!=0:0))){u=y;break}if((o|0)==(k[Q>>2]|0)){emb(_,P,Q);o=k[P>>2]|0}B=o+4|0;k[P>>2]=B;k[o>>2]=v;v=0;o=B}u=k[a>>2]|0;h=u+12|0;e=k[h>>2]|0;if((e|0)==(k[u+16>>2]|0)){Xh[k[(k[u>>2]|0)+40>>2]&1023](u)|0;u=y;w=b;e=x;continue}else{k[h>>2]=e+1;u=y;w=b;e=x;continue}}if(v|0?(k[_>>2]|0)!=(o|0):0){if((o|0)==(k[Q>>2]|0)){emb(_,P,Q);o=k[P>>2]|0}y=o+4|0;k[P>>2]=y;k[o>>2]=v}else y=o;f:do if((C|0)>0){o=k[a>>2]|0;do if(o){if((k[o+12>>2]|0)==(k[o+16>>2]|0))if((Xh[k[(k[o>>2]|0)+36>>2]&1023](o)|0)==-1){k[a>>2]=0;o=0;break}else{o=k[a>>2]|0;break}}else o=0;while(0);o=(o|0)==0;do if(u){if((k[u+12>>2]|0)==(k[u+16>>2]|0)?(Xh[k[(k[u>>2]|0)+36>>2]&1023](u)|0)==-1:0){b=0;S=224;break}if(o)e=u;else{S=229;break a}}else S=224;while(0);if((S|0)==224){S=0;if(o){S=229;break a}else e=0}o=k[a>>2]|0;u=k[o+12>>2]|0;if((u|0)==(k[o+16>>2]|0))o=Xh[k[(k[o>>2]|0)+36>>2]&1023](o)|0;else o=l[u>>0]|0;if((o&255)<<24>>24!=c<<24>>24){S=229;break a}o=k[a>>2]|0;u=o+12|0;h=k[u>>2]|0;if((h|0)==(k[o+16>>2]|0)){Xh[k[(k[o>>2]|0)+40>>2]&1023](o)|0;x=C;o=e;h=e}else{k[u>>2]=h+1;x=C;o=e;h=e}while(1){if((x|0)<=0){o=x;break f}u=k[a>>2]|0;do if(u){if((k[u+12>>2]|0)==(k[u+16>>2]|0))if((Xh[k[(k[u>>2]|0)+36>>2]&1023](u)|0)==-1){k[a>>2]=0;u=0;break}else{u=k[a>>2]|0;break}}else u=0;while(0);u=(u|0)==0;do if(h){if((k[h+12>>2]|0)!=(k[h+16>>2]|0))if(u){w=o;v=h;break}else{S=250;break a}if((Xh[k[(k[h>>2]|0)+36>>2]&1023](h)|0)==-1){o=0;b=0;S=243;break}if(u^(o|0)==0){w=o;v=o}else{S=250;break a}}else S=243;while(0);if((S|0)==243){S=0;if(u){S=250;break a}else{w=o;v=0}}o=k[a>>2]|0;u=k[o+12>>2]|0;if((u|0)==(k[o+16>>2]|0))o=Xh[k[(k[o>>2]|0)+36>>2]&1023](o)|0;else o=l[u>>0]|0;if((o&255)<<24>>24<=-1){S=250;break a}if(!(j[(k[K>>2]|0)+(o<<24>>24<<1)>>1]&2048)){S=250;break a}if((k[n>>2]|0)==(k[O>>2]|0))dmb(m,n,O);o=k[a>>2]|0;u=k[o+12>>2]|0;if((u|0)==(k[o+16>>2]|0))o=Xh[k[(k[o>>2]|0)+36>>2]&1023](o)|0;else o=l[u>>0]|0;u=k[n>>2]|0;k[n>>2]=u+1;i[u>>0]=o;o=x+-1|0;u=k[a>>2]|0;h=u+12|0;e=k[h>>2]|0;if((e|0)==(k[u+16>>2]|0)){Xh[k[(k[u>>2]|0)+40>>2]&1023](u)|0;x=o;o=w;h=v;continue}else{k[h>>2]=e+1;x=o;o=w;h=v;continue}}}else o=C;while(0);if((k[n>>2]|0)==(k[m>>2]|0)){S=260;break a}else{h=N;u=y}break}default:{h=N;o=C;u=B}}while(0);g:do if((S|0)==93)while(1){S=0;b=k[a>>2]|0;do if(b){if((k[b+12>>2]|0)==(k[b+16>>2]|0))if((Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0)==-1){k[a>>2]=0;b=0;break}else{b=k[a>>2]|0;break}}else b=0;while(0);u=(b|0)==0;do if(h){if((k[h+12>>2]|0)!=(k[h+16>>2]|0))if(u){w=o;b=e;v=h;break}else{h=N;o=C;b=e;u=B;break g}if((Xh[k[(k[h>>2]|0)+36>>2]&1023](h)|0)!=-1)if(u^(o|0)==0){w=o;b=e;v=o}else{h=N;o=C;b=e;u=B;break g}else{o=0;b=0;S=102}}else{b=e;S=102}while(0);if((S|0)==102){S=0;if(u){h=N;o=C;u=B;break g}else{w=o;v=0}}o=k[a>>2]|0;u=k[o+12>>2]|0;if((u|0)==(k[o+16>>2]|0))o=Xh[k[(k[o>>2]|0)+36>>2]&1023](o)|0;else o=l[u>>0]|0;if((o&255)<<24>>24<=-1){h=N;o=C;u=B;break g}if(!(j[(k[K>>2]|0)+(o<<24>>24<<1)>>1]&8192)){h=N;o=C;u=B;break g}o=k[a>>2]|0;u=o+12|0;h=k[u>>2]|0;if((h|0)==(k[o+16>>2]|0))o=Xh[k[(k[o>>2]|0)+40>>2]&1023](o)|0;else{k[u>>2]=h+1;o=l[h>>0]|0}qob(Y,o&255);o=w;e=b;h=v;S=93}while(0);N=h;D=D+1|0;C=o;B=u}h:do if((S|0)==91){k[f>>2]=k[f>>2]|4;o=0}else if((S|0)==146){k[f>>2]=k[f>>2]|4;o=0}else if((S|0)==183){k[f>>2]=k[f>>2]|4;o=0}else if((S|0)==229){k[f>>2]=k[f>>2]|4;o=0}else if((S|0)==250){k[f>>2]=k[f>>2]|4;o=0}else if((S|0)==260){k[f>>2]=k[f>>2]|4;o=0}else if((S|0)==262){i:do if(N|0){q=N+11|0;s=N+4|0;c=1;j:while(1){o=i[q>>0]|0;if(o<<24>>24<0)o=k[s>>2]|0;else o=o&255;if(c>>>0>=o>>>0)break i;o=k[a>>2]|0;do if(o){if((k[o+12>>2]|0)==(k[o+16>>2]|0))if((Xh[k[(k[o>>2]|0)+36>>2]&1023](o)|0)==-1){k[a>>2]=0;o=0;break}else{o=k[a>>2]|0;break}}else o=0;while(0);o=(o|0)==0;do if(b){if((k[b+12>>2]|0)==(k[b+16>>2]|0)?(Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0)==-1:0){S=277;break}if(!o)break j}else S=277;while(0);if((S|0)==277){S=0;if(o)break;else b=0}o=k[a>>2]|0;d=k[o+12>>2]|0;if((d|0)==(k[o+16>>2]|0))o=Xh[k[(k[o>>2]|0)+36>>2]&1023](o)|0;else o=l[d>>0]|0;if((i[q>>0]|0)<0)d=k[N>>2]|0;else d=N;if((o&255)<<24>>24!=(i[d+c>>0]|0))break;o=c+1|0;d=k[a>>2]|0;c=d+12|0;p=k[c>>2]|0;if((p|0)==(k[d+16>>2]|0)){Xh[k[(k[d>>2]|0)+40>>2]&1023](d)|0;c=o;continue}else{k[c>>2]=p+1;c=o;continue}}k[f>>2]=k[f>>2]|4;o=0;break h}while(0);b=k[_>>2]|0;if((b|0)!=(B|0)){k[T>>2]=0;$ib(U,b,B,T);if(!(k[T>>2]|0)){o=1;break}else{k[f>>2]=k[f>>2]|4;o=0;break}}else o=1}while(0);kob(Y);kob(X);kob(W);kob(V);kob(U);b=k[_>>2]|0;k[_>>2]=0;if(b|0)Uh[k[Z>>2]&2047](b);r=$;return o|0}function dmb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;h=a+4|0;e=(k[h>>2]|0)!=1535;d=k[a>>2]|0;f=(k[c>>2]|0)-d|0;f=f>>>0<2147483647?f<<1:-1;f=(f|0)==0?1:f;g=(k[b>>2]|0)-d|0;d=hgb(e?d:0,f)|0;if(!e){e=k[a>>2]|0;k[a>>2]=d;if(e){Uh[k[h>>2]&2047](e);d=k[a>>2]|0}}else k[a>>2]=d;k[h>>2]=1459;k[b>>2]=d+g;k[c>>2]=(k[a>>2]|0)+f;return}function emb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;h=a+4|0;e=(k[h>>2]|0)!=1535;d=k[a>>2]|0;f=(k[c>>2]|0)-d|0;f=f>>>0<2147483647?f<<1:-1;f=(f|0)==0?4:f;g=(k[b>>2]|0)-d>>2;d=hgb(e?d:0,f)|0;if(!e){e=k[a>>2]|0;k[a>>2]=d;if(e){Uh[k[h>>2]&2047](e);d=k[a>>2]|0}}else k[a>>2]=d;k[h>>2]=1459;k[b>>2]=d+(g<<2);k[c>>2]=(k[a>>2]|0)+(f>>>2<<2);return}function fmb(a){a=a|0;return}function gmb(a){a=a|0;ggb(a);return}function hmb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+576|0;q=w;m=w+64|0;v=w+56|0;p=w+48|0;h=w+564|0;n=w+8|0;o=w+464|0;k[v>>2]=m;u=v+4|0;k[u>>2]=1535;s=k[e+28>>2]|0;a=s+4|0;k[a>>2]=(k[a>>2]|0)+1;a=Sib(s,828804)|0;i[h>>0]=0;if(jmb(b,k[c>>2]|0,d,s,k[e+4>>2]|0,f,h,a,v,p,m+400|0)|0){Dg[k[(k[a>>2]|0)+48>>2]&127](a,425804,425814,n)|0;d=k[p>>2]|0;e=k[v>>2]|0;a=d-e|0;if((a|0)>392){m=fgb((a>>2)+2|0)|0;a=m}else{a=o;m=0}if(i[h>>0]|0){i[a>>0]=45;a=a+1|0}j=n+40|0;l=n;h=e;while(1){if(h>>>0>=d>>>0)break;e=k[h>>2]|0;d=n;while(1){if((d|0)==(j|0)){d=j;break}if((k[d>>2]|0)==(e|0))break;d=d+4|0}i[a>>0]=i[425804+(d-l>>2)>>0]|0;h=h+4|0;a=a+1|0;d=k[p>>2]|0}i[a>>0]=0;k[q>>2]=g;Wfb(o,425705,q)|0;if(m|0)ggb(m)}a=k[b>>2]|0;do if(a){d=k[a+12>>2]|0;if((d|0)==(k[a+16>>2]|0))a=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else a=k[d>>2]|0;if((a|0)==-1){k[b>>2]=0;e=1;break}else{e=(k[b>>2]|0)==0;break}}else e=1;while(0);a=k[c>>2]|0;do if(a){d=k[a+12>>2]|0;if((d|0)==(k[a+16>>2]|0))a=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else a=k[d>>2]|0;if((a|0)!=-1)if(e)break;else{t=31;break}else{k[c>>2]=0;t=29;break}}else t=29;while(0);if((t|0)==29?e:0)t=31;if((t|0)==31)k[f>>2]=k[f>>2]|2;d=k[b>>2]|0;fob(s);a=k[v>>2]|0;k[v>>2]=0;if(a|0)Uh[k[u>>2]&2047](a);r=w;return d|0}function imb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+432|0;p=x+16|0;w=x+8|0;j=x;a=x+416|0;k[w>>2]=p;v=w+4|0;k[v>>2]=1535;t=k[e+28>>2]|0;h=t+4|0;k[h>>2]=(k[h>>2]|0)+1;h=Sib(t,828804)|0;i[a>>0]=0;s=k[c>>2]|0;q=s;do if(jmb(b,q,d,t,k[e+4>>2]|0,f,a,h,w,j,p+400|0)|0){e=g+8|0;p=e+3|0;if((i[p>>0]|0)<0){k[k[g>>2]>>2]=0;k[g+4>>2]=0}else{k[g>>2]=0;i[p>>0]=0}if(i[a>>0]|0)xob(g,Hh[k[(k[h>>2]|0)+44>>2]&511](h,45)|0);d=Hh[k[(k[h>>2]|0)+44>>2]&511](h,48)|0;o=k[j>>2]|0;a=o+-4|0;n=k[w>>2]|0;while(1){if(n>>>0>=a>>>0)break;if((k[n>>2]|0)!=(d|0))break;n=n+4|0}a=i[p>>0]|0;if(a<<24>>24<0){m=k[g+4>>2]|0;d=(k[e>>2]&2147483647)+-1|0}else{m=a&255;d=1}e=o-n|0;l=e>>2;if(l|0){if((d-m|0)>>>0<l>>>0){wob(g,d,m+l-d|0,m,m);a=i[p>>0]|0}j=a<<24>>24<0;h=j?k[g>>2]|0:g;e=e>>>2;d=h+(m<<2)|0;a=n;while(1){if((a|0)==(o|0))break;k[d>>2]=k[a>>2];d=d+4|0;a=a+4|0}k[h+(m+e<<2)>>2]=0;a=m+l|0;if(j){k[g+4>>2]=a;break}else{i[p>>0]=a;break}}}while(0);a=k[b>>2]|0;do if(a){d=k[a+12>>2]|0;if((d|0)==(k[a+16>>2]|0))a=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;else a=k[d>>2]|0;if((a|0)==-1){k[b>>2]=0;d=1;break}else{d=(k[b>>2]|0)==0;break}}else d=1;while(0);do if(s){a=k[q+12>>2]|0;if((a|0)==(k[q+16>>2]|0))a=Xh[k[(k[s>>2]|0)+36>>2]&1023](q)|0;else a=k[a>>2]|0;if((a|0)!=-1)if(d)break;else{u=38;break}else{k[c>>2]=0;u=36;break}}else u=36;while(0);if((u|0)==36?d:0)u=38;if((u|0)==38)k[f>>2]=k[f>>2]|2;d=k[b>>2]|0;fob(t);a=k[w>>2]|0;k[w>>2]=0;if(a|0)Uh[k[v>>2]&2047](a);r=x;return d|0}function jmb(a,b,c,d,e,f,g,h,j,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;m=m|0;n=n|0;var o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;_=r;r=r+496|0;S=_+484|0;N=_+480|0;u=_+80|0;Z=_+72|0;O=_+68|0;P=_+64|0;Q=_+60|0;T=_+48|0;U=_+36|0;V=_+24|0;W=_+12|0;X=_;k[N>>2]=n;k[Z>>2]=u;Y=Z+4|0;k[Y>>2]=1535;k[O>>2]=u;k[P>>2]=u+400;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;n=0;while(1){if((n|0)==3)break;k[T+(n<<2)>>2]=0;n=n+1|0}k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;n=0;while(1){if((n|0)==3)break;k[U+(n<<2)>>2]=0;n=n+1|0}k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;n=0;while(1){if((n|0)==3)break;k[V+(n<<2)>>2]=0;n=n+1|0}k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;n=0;while(1){if((n|0)==3)break;k[W+(n<<2)>>2]=0;n=n+1|0}k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;n=0;while(1){if((n|0)==3)break;k[X+(n<<2)>>2]=0;n=n+1|0}if(c){t=Sib(d,830484)|0;jh[k[(k[t>>2]|0)+44>>2]&1023](Q,t);jh[k[(k[t>>2]|0)+32>>2]&1023](S,t);q=W+8+3|0;if((i[q>>0]|0)<0){k[k[W>>2]>>2]=0;k[W+4>>2]=0}else{k[W>>2]=0;i[q>>0]=0}uob(W);k[W>>2]=k[S>>2];k[W+4>>2]=k[S+4>>2];k[W+8>>2]=k[S+8>>2];n=0;while(1){if((n|0)==3)break;k[S+(n<<2)>>2]=0;n=n+1|0}tob(S);jh[k[(k[t>>2]|0)+28>>2]&1023](S,t);o=V+8+3|0;if((i[o>>0]|0)<0){k[k[V>>2]>>2]=0;k[V+4>>2]=0}else{k[V>>2]=0;i[o>>0]=0}uob(V);k[V>>2]=k[S>>2];k[V+4>>2]=k[S+4>>2];k[V+8>>2]=k[S+8>>2];n=0;while(1){if((n|0)==3)break;k[S+(n<<2)>>2]=0;n=n+1|0}tob(S);c=Xh[k[(k[t>>2]|0)+12>>2]&1023](t)|0;d=Xh[k[(k[t>>2]|0)+16>>2]&1023](t)|0;jh[k[(k[t>>2]|0)+20>>2]&1023](S,t);s=T+11|0;if((i[s>>0]|0)<0){i[k[T>>2]>>0]=0;k[T+4>>2]=0}else{i[T>>0]=0;i[s>>0]=0}mob(T);k[T>>2]=k[S>>2];k[T+4>>2]=k[S+4>>2];k[T+8>>2]=k[S+8>>2];n=0;while(1){if((n|0)==3)break;k[S+(n<<2)>>2]=0;n=n+1|0}kob(S);jh[k[(k[t>>2]|0)+24>>2]&1023](S,t);p=U+8+3|0;if((i[p>>0]|0)<0){k[k[U>>2]>>2]=0;k[U+4>>2]=0}else{k[U>>2]=0;i[p>>0]=0}uob(U);k[U>>2]=k[S>>2];k[U+4>>2]=k[S+4>>2];k[U+8>>2]=k[S+8>>2];n=0;while(1){if((n|0)==3)break;k[S+(n<<2)>>2]=0;n=n+1|0}tob(S);n=Xh[k[(k[t>>2]|0)+36>>2]&1023](t)|0}else{t=Sib(d,830476)|0;jh[k[(k[t>>2]|0)+44>>2]&1023](S,t);k[Q>>2]=k[S>>2];jh[k[(k[t>>2]|0)+32>>2]&1023](S,t);q=W+8+3|0;if((i[q>>0]|0)<0){k[k[W>>2]>>2]=0;k[W+4>>2]=0}else{k[W>>2]=0;i[q>>0]=0}uob(W);k[W>>2]=k[S>>2];k[W+4>>2]=k[S+4>>2];k[W+8>>2]=k[S+8>>2];n=0;while(1){if((n|0)==3)break;k[S+(n<<2)>>2]=0;n=n+1|0}tob(S);jh[k[(k[t>>2]|0)+28>>2]&1023](S,t);o=V+8+3|0;if((i[o>>0]|0)<0){k[k[V>>2]>>2]=0;k[V+4>>2]=0}else{k[V>>2]=0;i[o>>0]=0}uob(V);k[V>>2]=k[S>>2];k[V+4>>2]=k[S+4>>2];k[V+8>>2]=k[S+8>>2];n=0;while(1){if((n|0)==3)break;k[S+(n<<2)>>2]=0;n=n+1|0}tob(S);c=Xh[k[(k[t>>2]|0)+12>>2]&1023](t)|0;d=Xh[k[(k[t>>2]|0)+16>>2]&1023](t)|0;jh[k[(k[t>>2]|0)+20>>2]&1023](S,t);s=T+11|0;if((i[s>>0]|0)<0){i[k[T>>2]>>0]=0;k[T+4>>2]=0}else{i[T>>0]=0;i[s>>0]=0}mob(T);k[T>>2]=k[S>>2];k[T+4>>2]=k[S+4>>2];k[T+8>>2]=k[S+8>>2];n=0;while(1){if((n|0)==3)break;k[S+(n<<2)>>2]=0;n=n+1|0}kob(S);jh[k[(k[t>>2]|0)+24>>2]&1023](S,t);p=U+8+3|0;if((i[p>>0]|0)<0){k[k[U>>2]>>2]=0;k[U+4>>2]=0}else{k[U>>2]=0;i[p>>0]=0}uob(U);k[U>>2]=k[S>>2];k[U+4>>2]=k[S+4>>2];k[U+8>>2]=k[S+8>>2];n=0;while(1){if((n|0)==3)break;k[S+(n<<2)>>2]=0;n=n+1|0}tob(S);n=Xh[k[(k[t>>2]|0)+36>>2]&1023](t)|0}k[m>>2]=k[j>>2];K=V+4|0;L=W+4|0;E=(e&512|0)!=0;F=U+4|0;G=X+8+3|0;H=X+4|0;I=Q+3|0;J=T+4|0;M=0;D=0;C=u;a:while(1){if(D>>>0>=4){R=276;break}t=k[a>>2]|0;do if(t){e=k[t+12>>2]|0;if((e|0)==(k[t+16>>2]|0))t=Xh[k[(k[t>>2]|0)+36>>2]&1023](t)|0;else t=k[e>>2]|0;if((t|0)==-1){k[a>>2]=0;e=1;break}else{e=(k[a>>2]|0)==0;break}}else e=1;while(0);if(b){t=k[b+12>>2]|0;if((t|0)==(k[b+16>>2]|0))t=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else t=k[t>>2]|0;if((t|0)!=-1){if(!e){R=276;break}}else R=81}else R=81;if((R|0)==81){R=0;if(e){b=0;R=276;break}else b=0}b:do switch(i[Q+D>>0]|0){case 1:{if((D|0)==3){e=M;t=C}else{t=k[a>>2]|0;e=k[t+12>>2]|0;if((e|0)==(k[t+16>>2]|0))t=Xh[k[(k[t>>2]|0)+36>>2]&1023](t)|0;else t=k[e>>2]|0;if(!(ci[k[(k[h>>2]|0)+12>>2]&255](h,8192,t)|0)){R=93;break a}t=k[a>>2]|0;e=t+12|0;u=k[e>>2]|0;if((u|0)==(k[t+16>>2]|0))t=Xh[k[(k[t>>2]|0)+40>>2]&1023](t)|0;else{k[e>>2]=u+4;t=k[u>>2]|0}xob(X,t);t=b;x=b;u=b;R=95}break}case 0:{if((D|0)==3){e=M;t=C}else{t=b;x=b;u=b;R=95}break}case 3:{t=i[o>>0]|0;e=t<<24>>24<0?k[K>>2]|0:t&255;v=i[q>>0]|0;v=v<<24>>24<0?k[L>>2]|0:v&255;if((e|0)==(0-v|0)){e=M;t=C}else{w=(e|0)==0;x=k[a>>2]|0;y=k[x+12>>2]|0;e=k[x+16>>2]|0;u=(y|0)==(e|0);if(w|(v|0)==0){if(u)e=Xh[k[(k[x>>2]|0)+36>>2]&1023](x)|0;else e=k[y>>2]|0;if(w){t=i[q>>0]|0;if((e|0)!=(k[(t<<24>>24<0?k[W>>2]|0:W)>>2]|0)){e=M;t=C;break b}e=k[a>>2]|0;u=e+12|0;v=k[u>>2]|0;if((v|0)==(k[e+16>>2]|0)){Xh[k[(k[e>>2]|0)+40>>2]&1023](e)|0;t=i[q>>0]|0}else k[u>>2]=v+4;i[g>>0]=1;e=(t<<24>>24<0?k[L>>2]|0:t&255)>>>0>1?W:M;t=C;break b}t=i[o>>0]|0;if((e|0)!=(k[(t<<24>>24<0?k[V>>2]|0:V)>>2]|0)){i[g>>0]=1;e=M;t=C;break b}e=k[a>>2]|0;u=e+12|0;v=k[u>>2]|0;if((v|0)==(k[e+16>>2]|0)){Xh[k[(k[e>>2]|0)+40>>2]&1023](e)|0;t=i[o>>0]|0}else k[u>>2]=v+4;e=(t<<24>>24<0?k[K>>2]|0:t&255)>>>0>1?V:M;t=C;break b}if(u){w=Xh[k[(k[x>>2]|0)+36>>2]&1023](x)|0;e=k[a>>2]|0;t=i[o>>0]|0;x=e;v=k[e+12>>2]|0;e=k[e+16>>2]|0}else{w=k[y>>2]|0;v=y}u=x+12|0;e=(v|0)==(e|0);if((w|0)==(k[(t<<24>>24<0?k[V>>2]|0:V)>>2]|0)){if(e){Xh[k[(k[x>>2]|0)+40>>2]&1023](x)|0;t=i[o>>0]|0}else k[u>>2]=v+4;e=(t<<24>>24<0?k[K>>2]|0:t&255)>>>0>1?V:M;t=C;break b}if(e)e=Xh[k[(k[x>>2]|0)+36>>2]&1023](x)|0;else e=k[v>>2]|0;t=i[q>>0]|0;if((e|0)!=(k[(t<<24>>24<0?k[W>>2]|0:W)>>2]|0)){R=150;break a}e=k[a>>2]|0;u=e+12|0;v=k[u>>2]|0;if((v|0)==(k[e+16>>2]|0)){Xh[k[(k[e>>2]|0)+40>>2]&1023](e)|0;t=i[q>>0]|0}else k[u>>2]=v+4;i[g>>0]=1;e=(t<<24>>24<0?k[L>>2]|0:t&255)>>>0>1?W:M;t=C}break}case 2:{if(!(D>>>0<2|(M|0)!=0)?!(E|(D|0)==2&(i[I>>0]|0)!=0):0){e=0;t=C;break b}e=i[p>>0]|0;u=k[U>>2]|0;t=e<<24>>24<0?u:U;c:do if((D|0)!=0?(l[Q+(D+-1)>>0]|0)<2:0){z=t;while(1){B=e<<24>>24<0;t=z;if((t|0)==((B?u:U)+((B?k[F>>2]|0:e&255)<<2)|0))break;if(!(ci[k[(k[h>>2]|0)+12>>2]&255](h,8192,k[t>>2]|0)|0)){R=157;break}z=t+4|0;e=i[p>>0]|0;u=k[U>>2]|0}if((R|0)==157){R=0;e=i[p>>0]|0;u=k[U>>2]|0}v=e<<24>>24<0?u:U;y=v;x=z-y>>2;w=i[G>>0]|0;t=w<<24>>24<0;w=t?k[H>>2]|0:w&255;if(x>>>0>w>>>0){A=b;B=b;v=y;w=b}else{w=(t?k[X>>2]|0:X)+(w<<2)|0;t=w+(0-x<<2)|0;while(1){if((t|0)==(w|0)){A=b;B=b;v=z;w=b;break c}if((k[t>>2]|0)!=(k[v>>2]|0)){A=b;B=b;v=y;w=b;break c}v=v+4|0;t=t+4|0}}}else{A=b;B=b;v=t;w=b}while(0);while(1){t=e<<24>>24<0;t=(t?u:U)+((t?k[F>>2]|0:e&255)<<2)|0;x=v;if((x|0)==(t|0)){b=B;break}b=k[a>>2]|0;do if(b){t=k[b+12>>2]|0;if((t|0)==(k[b+16>>2]|0))b=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else b=k[t>>2]|0;if((b|0)==-1){k[a>>2]=0;e=1;break}else{e=(k[a>>2]|0)==0;break}}else e=1;while(0);if(w){b=k[w+12>>2]|0;if((b|0)==(k[w+16>>2]|0))b=Xh[k[(k[w>>2]|0)+36>>2]&1023](w)|0;else b=k[b>>2]|0;if((b|0)!=-1)if(e^(A|0)==0){v=A;b=B;w=A}else{t=x;b=B;break}else{t=0;b=0;R=177}}else{t=A;b=B;R=177}if((R|0)==177){R=0;if(e){t=x;break}else{v=t;w=0}}t=k[a>>2]|0;e=k[t+12>>2]|0;if((e|0)==(k[t+16>>2]|0))t=Xh[k[(k[t>>2]|0)+36>>2]&1023](t)|0;else t=k[e>>2]|0;if((t|0)!=(k[x>>2]|0)){t=x;break}t=k[a>>2]|0;e=t+12|0;u=k[e>>2]|0;if((u|0)==(k[t+16>>2]|0))Xh[k[(k[t>>2]|0)+40>>2]&1023](t)|0;else k[e>>2]=u+4;A=v;B=b;v=x+4|0;e=i[p>>0]|0;u=k[U>>2]|0}if(E?(B=i[p>>0]|0,A=B<<24>>24<0,(t|0)!=((A?k[U>>2]|0:U)+((A?k[F>>2]|0:B&255)<<2)|0)):0){R=189;break a}else{e=M;t=C}break}case 4:{w=0;e=b;x=b;v=b;t=C;while(1){b=k[a>>2]|0;do if(b){u=k[b+12>>2]|0;if((u|0)==(k[b+16>>2]|0))b=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else b=k[u>>2]|0;if((b|0)==-1){k[a>>2]=0;u=1;break}else{u=(k[a>>2]|0)==0;break}}else u=1;while(0);if(v){b=k[v+12>>2]|0;if((b|0)==(k[v+16>>2]|0))b=Xh[k[(k[v>>2]|0)+36>>2]&1023](v)|0;else b=k[b>>2]|0;if((b|0)!=-1)if(u^(e|0)==0){z=e;b=x;y=e}else{v=e;b=x;break}else{e=0;b=0;R=202}}else{b=x;R=202}if((R|0)==202){R=0;if(u){v=e;break}else{z=e;y=0}}e=k[a>>2]|0;u=k[e+12>>2]|0;if((u|0)==(k[e+16>>2]|0))u=Xh[k[(k[e>>2]|0)+36>>2]&1023](e)|0;else u=k[u>>2]|0;if(ci[k[(k[h>>2]|0)+12>>2]&255](h,2048,u)|0){e=k[m>>2]|0;if((e|0)==(k[N>>2]|0)){kmb(j,m,N);e=k[m>>2]|0}k[m>>2]=e+4;k[e>>2]=u;w=w+1|0}else{C=i[s>>0]|0;if(!((u|0)==(d|0)&(w|0?((C<<24>>24<0?k[J>>2]|0:C&255)|0)!=0:0))){v=z;break}if((t|0)==(k[P>>2]|0)){emb(Z,O,P);t=k[O>>2]|0}C=t+4|0;k[O>>2]=C;k[t>>2]=w;w=0;t=C}e=k[a>>2]|0;u=e+12|0;v=k[u>>2]|0;if((v|0)==(k[e+16>>2]|0)){Xh[k[(k[e>>2]|0)+40>>2]&1023](e)|0;e=z;x=b;v=y;continue}else{k[u>>2]=v+4;e=z;x=b;v=y;continue}}if(w|0?(k[Z>>2]|0)!=(t|0):0){if((t|0)==(k[P>>2]|0)){emb(Z,O,P);t=k[O>>2]|0}y=t+4|0;k[O>>2]=y;k[t>>2]=w}else y=t;d:do if((n|0)>0){t=k[a>>2]|0;do if(t){e=k[t+12>>2]|0;if((e|0)==(k[t+16>>2]|0))t=Xh[k[(k[t>>2]|0)+36>>2]&1023](t)|0;else t=k[e>>2]|0;if((t|0)==-1){k[a>>2]=0;e=1;break}else{e=(k[a>>2]|0)==0;break}}else e=1;while(0);if(v){t=k[v+12>>2]|0;if((t|0)==(k[v+16>>2]|0))t=Xh[k[(k[v>>2]|0)+36>>2]&1023](v)|0;else t=k[t>>2]|0;if((t|0)!=-1){if(!e){R=241;break a}}else{b=0;R=235}}else R=235;if((R|0)==235){R=0;if(e){R=241;break a}else v=0}t=k[a>>2]|0;e=k[t+12>>2]|0;if((e|0)==(k[t+16>>2]|0))t=Xh[k[(k[t>>2]|0)+36>>2]&1023](t)|0;else t=k[e>>2]|0;if((t|0)!=(c|0)){R=241;break a}t=k[a>>2]|0;e=t+12|0;u=k[e>>2]|0;if((u|0)==(k[t+16>>2]|0)){Xh[k[(k[t>>2]|0)+40>>2]&1023](t)|0;w=v;u=v}else{k[e>>2]=u+4;w=v;u=v}while(1){if((n|0)<=0)break d;t=k[a>>2]|0;do if(t){e=k[t+12>>2]|0;if((e|0)==(k[t+16>>2]|0))t=Xh[k[(k[t>>2]|0)+36>>2]&1023](t)|0;else t=k[e>>2]|0;if((t|0)==-1){k[a>>2]=0;e=1;break}else{e=(k[a>>2]|0)==0;break}}else e=1;while(0);do if(u){t=k[u+12>>2]|0;if((t|0)==(k[u+16>>2]|0))t=Xh[k[(k[u>>2]|0)+36>>2]&1023](u)|0;else t=k[t>>2]|0;if((t|0)==-1){t=0;b=0;R=258;break}if(e^(w|0)==0){x=w;v=w}else{R=264;break a}}else{t=w;R=258}while(0);if((R|0)==258){R=0;if(e){R=264;break a}else{x=t;v=0}}t=k[a>>2]|0;e=k[t+12>>2]|0;if((e|0)==(k[t+16>>2]|0))t=Xh[k[(k[t>>2]|0)+36>>2]&1023](t)|0;else t=k[e>>2]|0;if(!(ci[k[(k[h>>2]|0)+12>>2]&255](h,2048,t)|0)){R=264;break a}if((k[m>>2]|0)==(k[N>>2]|0))kmb(j,m,N);t=k[a>>2]|0;e=k[t+12>>2]|0;if((e|0)==(k[t+16>>2]|0))t=Xh[k[(k[t>>2]|0)+36>>2]&1023](t)|0;else t=k[e>>2]|0;e=k[m>>2]|0;k[m>>2]=e+4;k[e>>2]=t;n=n+-1|0;t=k[a>>2]|0;e=t+12|0;u=k[e>>2]|0;if((u|0)==(k[t+16>>2]|0)){Xh[k[(k[t>>2]|0)+40>>2]&1023](t)|0;w=x;u=v;continue}else{k[e>>2]=u+4;w=x;u=v;continue}}}while(0);if((k[m>>2]|0)==(k[j>>2]|0)){R=274;break a}else{e=M;t=y}break}default:{e=M;t=C}}while(0);e:do if((R|0)==95)while(1){R=0;b=k[a>>2]|0;do if(b){e=k[b+12>>2]|0;if((e|0)==(k[b+16>>2]|0))b=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else b=k[e>>2]|0;if((b|0)==-1){k[a>>2]=0;e=1;break}else{e=(k[a>>2]|0)==0;break}}else e=1;while(0);if(u){b=k[u+12>>2]|0;if((b|0)==(k[u+16>>2]|0))b=Xh[k[(k[u>>2]|0)+36>>2]&1023](u)|0;else b=k[b>>2]|0;if((b|0)!=-1)if(e^(t|0)==0){w=t;b=x;v=t}else{e=M;b=x;t=C;break e}else{t=0;b=0;R=107}}else{b=x;R=107}if((R|0)==107){R=0;if(e){e=M;t=C;break e}else{w=t;v=0}}t=k[a>>2]|0;e=k[t+12>>2]|0;if((e|0)==(k[t+16>>2]|0))t=Xh[k[(k[t>>2]|0)+36>>2]&1023](t)|0;else t=k[e>>2]|0;if(!(ci[k[(k[h>>2]|0)+12>>2]&255](h,8192,t)|0)){e=M;t=C;break e}t=k[a>>2]|0;e=t+12|0;u=k[e>>2]|0;if((u|0)==(k[t+16>>2]|0))t=Xh[k[(k[t>>2]|0)+40>>2]&1023](t)|0;else{k[e>>2]=u+4;t=k[u>>2]|0}xob(X,t);t=w;x=b;u=v;R=95}while(0);M=e;D=D+1|0;C=t}f:do if((R|0)==93){k[f>>2]=k[f>>2]|4;n=0}else if((R|0)==150){k[f>>2]=k[f>>2]|4;n=0}else if((R|0)==189){k[f>>2]=k[f>>2]|4;n=0}else if((R|0)==241){k[f>>2]=k[f>>2]|4;n=0}else if((R|0)==264){k[f>>2]=k[f>>2]|4;n=0}else if((R|0)==274){k[f>>2]=k[f>>2]|4;n=0}else if((R|0)==276){g:do if(M|0){p=M+8+3|0;q=M+4|0;c=1;while(1){n=i[p>>0]|0;if(n<<24>>24<0)n=k[q>>2]|0;else n=n&255;if(c>>>0>=n>>>0)break g;n=k[a>>2]|0;do if(n){d=k[n+12>>2]|0;if((d|0)==(k[n+16>>2]|0))n=Xh[k[(k[n>>2]|0)+36>>2]&1023](n)|0;else n=k[d>>2]|0;if((n|0)==-1){k[a>>2]=0;d=1;break}else{d=(k[a>>2]|0)==0;break}}else d=1;while(0);if(b){n=k[b+12>>2]|0;if((n|0)==(k[b+16>>2]|0))n=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;else n=k[n>>2]|0;if((n|0)!=-1){if(!d)break}else R=294}else R=294;if((R|0)==294){R=0;if(d)break;else b=0}n=k[a>>2]|0;d=k[n+12>>2]|0;if((d|0)==(k[n+16>>2]|0))n=Xh[k[(k[n>>2]|0)+36>>2]&1023](n)|0;else n=k[d>>2]|0;if((i[p>>0]|0)<0)d=k[M>>2]|0;else d=M;if((n|0)!=(k[d+(c<<2)>>2]|0))break;n=c+1|0;d=k[a>>2]|0;c=d+12|0;o=k[c>>2]|0;if((o|0)==(k[d+16>>2]|0)){Xh[k[(k[d>>2]|0)+40>>2]&1023](d)|0;c=n;continue}else{k[c>>2]=o+4;c=n;continue}}k[f>>2]=k[f>>2]|4;n=0;break f}while(0);b=k[Z>>2]|0;if((b|0)!=(C|0)){k[S>>2]=0;$ib(T,b,C,S);if(!(k[S>>2]|0)){n=1;break}else{k[f>>2]=k[f>>2]|4;n=0;break}}else n=1}while(0);tob(X);tob(W);tob(V);tob(U);kob(T);b=k[Z>>2]|0;k[Z>>2]=0;if(b|0)Uh[k[Y>>2]&2047](b);r=_;return n|0}function kmb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;h=a+4|0;e=(k[h>>2]|0)!=1535;d=k[a>>2]|0;f=(k[c>>2]|0)-d|0;f=f>>>0<2147483647?f<<1:-1;f=(f|0)==0?4:f;g=(k[b>>2]|0)-d>>2;d=hgb(e?d:0,f)|0;if(!e){e=k[a>>2]|0;k[a>>2]=d;if(e){Uh[k[h>>2]&2047](e);d=k[a>>2]|0}}else k[a>>2]=d;k[h>>2]=1459;k[b>>2]=d+(g<<2);k[c>>2]=(k[a>>2]|0)+(f>>>2<<2);return}function lmb(a){a=a|0;return}function mmb(a){a=a|0;ggb(a);return}function nmb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+384|0;g=D+8|0;z=D;j=D+272|0;a=D+64|0;y=D+169|0;v=D+168|0;A=D+52|0;B=D+40|0;C=D+28|0;m=D+24|0;u=D+68|0;w=D+20|0;x=D+16|0;k[a>>2]=j;p[z>>3]=f;h=kfb(j,100,425910,z)|0;if(h>>>0>99){h=Uib()|0;p[g>>3]=f;h=Qjb(a,h,425910,g)|0;a=k[a>>2]|0;s=fgb(h)|0;q=s;t=a}else{q=D+172|0;s=0;t=0;a=j}o=k[d+28>>2]|0;n=o+4|0;k[n>>2]=(k[n>>2]|0)+1;n=Sib(o,828772)|0;Dg[k[(k[n>>2]|0)+32>>2]&127](n,a,a+h|0,q)|0;if(!h)l=0;else l=(i[a>>0]|0)==45;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[A+(a<<2)>>2]=0;a=a+1|0}k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[B+(a<<2)>>2]=0;a=a+1|0}k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[C+(a<<2)>>2]=0;a=a+1|0}pmb(c,l,o,z,y,v,A,B,C,m);j=k[m>>2]|0;if((h|0)>(j|0)){c=i[C+11>>0]|0;a=i[B+11>>0]|0;a=(c<<24>>24<0?k[C+4>>2]|0:c&255)+(h-j<<1|1)+(a<<24>>24<0?k[B+4>>2]|0:a&255)|0}else{c=i[C+11>>0]|0;a=i[B+11>>0]|0;a=(c<<24>>24<0?k[C+4>>2]|0:c&255)+2+(a<<24>>24<0?k[B+4>>2]|0:a&255)|0}a=a+j|0;if(a>>>0>100){g=fgb(a)|0;a=g}else{a=u;g=0}qmb(a,w,x,k[d+4>>2]|0,q,q+h|0,n,l,z,i[y>>0]|0,i[v>>0]|0,A,B,C,j);a=kS(k[b>>2]|0,a,k[w>>2]|0,k[x>>2]|0,d,e)|0;if(g|0)ggb(g);kob(C);kob(B);kob(A);fob(o);if(s|0)ggb(s);if(t|0)ggb(t);r=D;return a|0}function omb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=r;r=r+160|0;t=A+152|0;u=A+149|0;v=A+148|0;z=A+36|0;w=A+24|0;x=A+12|0;h=A+8|0;j=A+48|0;p=A+4|0;q=A;y=k[d+28>>2]|0;s=y+4|0;k[s>>2]=(k[s>>2]|0)+1;s=Sib(y,828772)|0;m=f+11|0;o=i[m>>0]|0;a=o<<24>>24<0;n=f+4|0;if(!((a?k[n>>2]|0:o&255)|0))o=0;else{o=i[(a?k[f>>2]|0:f)>>0]|0;o=o<<24>>24==(Hh[k[(k[s>>2]|0)+28>>2]&511](s,45)|0)<<24>>24};k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[z+(a<<2)>>2]=0;a=a+1|0}k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[w+(a<<2)>>2]=0;a=a+1|0}k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[x+(a<<2)>>2]=0;a=a+1|0}pmb(c,o,y,t,u,v,z,w,x,h);g=i[m>>0]|0;a=k[n>>2]|0;c=g<<24>>24<0?a:g&255;l=k[h>>2]|0;if((c|0)>(l|0)){B=i[x+11>>0]|0;h=i[w+11>>0]|0;c=(B<<24>>24<0?k[x+4>>2]|0:B&255)+(c-l<<1|1)+(h<<24>>24<0?k[w+4>>2]|0:h&255)|0}else{B=i[x+11>>0]|0;c=i[w+11>>0]|0;c=(B<<24>>24<0?k[x+4>>2]|0:B&255)+2+(c<<24>>24<0?k[w+4>>2]|0:c&255)|0}c=c+l|0;if(c>>>0>100){c=fgb(c)|0;h=c;if(!c){c=0;g=i[m>>0]|0;a=k[n>>2]|0}}else{c=j;h=0}B=g<<24>>24<0;f=B?k[f>>2]|0:f;qmb(c,p,q,k[d+4>>2]|0,f,f+(B?a:g&255)|0,s,o,t,i[u>>0]|0,i[v>>0]|0,z,w,x,l);a=kS(k[b>>2]|0,c,k[p>>2]|0,k[q>>2]|0,d,e)|0;if(h|0)ggb(h);kob(x);kob(w);kob(z);fob(y);r=A;return a|0}function pmb(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0;o=r;r=r+16|0;n=o;if(a){m=Sib(c,830468)|0;if(b){jh[k[(k[m>>2]|0)+44>>2]&1023](n,m);c=k[n>>2]|0;i[d>>0]=c;i[d+1>>0]=c>>8;i[d+2>>0]=c>>16;i[d+3>>0]=c>>24;jh[k[(k[m>>2]|0)+32>>2]&1023](n,m);c=j+11|0;if((i[c>>0]|0)<0){i[k[j>>2]>>0]=0;k[j+4>>2]=0;c=j}else{i[j>>0]=0;i[c>>0]=0;c=j}mob(j);k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];c=0;while(1){if((c|0)==3)break;k[n+(c<<2)>>2]=0;c=c+1|0}kob(n);a=m}else{jh[k[(k[m>>2]|0)+40>>2]&1023](n,m);c=k[n>>2]|0;i[d>>0]=c;i[d+1>>0]=c>>8;i[d+2>>0]=c>>16;i[d+3>>0]=c>>24;jh[k[(k[m>>2]|0)+28>>2]&1023](n,m);c=j+11|0;if((i[c>>0]|0)<0){i[k[j>>2]>>0]=0;k[j+4>>2]=0;c=j}else{i[j>>0]=0;i[c>>0]=0;c=j}mob(j);k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];c=0;while(1){if((c|0)==3)break;k[n+(c<<2)>>2]=0;c=c+1|0}kob(n);a=m}c=Xh[k[(k[m>>2]|0)+12>>2]&1023](m)|0;i[e>>0]=c;c=Xh[k[(k[m>>2]|0)+16>>2]&1023](m)|0;i[f>>0]=c;jh[k[(k[a>>2]|0)+20>>2]&1023](n,m);c=g+11|0;if((i[c>>0]|0)<0){i[k[g>>2]>>0]=0;k[g+4>>2]=0;c=g}else{i[g>>0]=0;i[c>>0]=0;c=g}mob(g);k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];c=0;while(1){if((c|0)==3)break;k[n+(c<<2)>>2]=0;c=c+1|0}kob(n);jh[k[(k[a>>2]|0)+24>>2]&1023](n,m);c=h+11|0;if((i[c>>0]|0)<0){i[k[h>>2]>>0]=0;k[h+4>>2]=0;c=h}else{i[h>>0]=0;i[c>>0]=0;c=h}mob(h);k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];c=0;while(1){if((c|0)==3)break;k[n+(c<<2)>>2]=0;c=c+1|0}kob(n);c=Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0}else{m=Sib(c,830460)|0;if(b){jh[k[(k[m>>2]|0)+44>>2]&1023](n,m);c=k[n>>2]|0;i[d>>0]=c;i[d+1>>0]=c>>8;i[d+2>>0]=c>>16;i[d+3>>0]=c>>24;jh[k[(k[m>>2]|0)+32>>2]&1023](n,m);c=j+11|0;if((i[c>>0]|0)<0){i[k[j>>2]>>0]=0;k[j+4>>2]=0;c=j}else{i[j>>0]=0;i[c>>0]=0;c=j}mob(j);k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];c=0;while(1){if((c|0)==3)break;k[n+(c<<2)>>2]=0;c=c+1|0}kob(n);a=m}else{jh[k[(k[m>>2]|0)+40>>2]&1023](n,m);c=k[n>>2]|0;i[d>>0]=c;i[d+1>>0]=c>>8;i[d+2>>0]=c>>16;i[d+3>>0]=c>>24;jh[k[(k[m>>2]|0)+28>>2]&1023](n,m);c=j+11|0;if((i[c>>0]|0)<0){i[k[j>>2]>>0]=0;k[j+4>>2]=0;c=j}else{i[j>>0]=0;i[c>>0]=0;c=j}mob(j);k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];c=0;while(1){if((c|0)==3)break;k[n+(c<<2)>>2]=0;c=c+1|0}kob(n);a=m}c=Xh[k[(k[m>>2]|0)+12>>2]&1023](m)|0;i[e>>0]=c;c=Xh[k[(k[m>>2]|0)+16>>2]&1023](m)|0;i[f>>0]=c;jh[k[(k[a>>2]|0)+20>>2]&1023](n,m);c=g+11|0;if((i[c>>0]|0)<0){i[k[g>>2]>>0]=0;k[g+4>>2]=0;c=g}else{i[g>>0]=0;i[c>>0]=0;c=g}mob(g);k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];c=0;while(1){if((c|0)==3)break;k[n+(c<<2)>>2]=0;c=c+1|0}kob(n);jh[k[(k[a>>2]|0)+24>>2]&1023](n,m);c=h+11|0;if((i[c>>0]|0)<0){i[k[h>>2]>>0]=0;k[h+4>>2]=0;c=h}else{i[h>>0]=0;i[c>>0]=0;c=h}mob(h);k[c>>2]=k[n>>2];k[c+4>>2]=k[n+4>>2];k[c+8>>2]=k[n+8>>2];c=0;while(1){if((c|0)==3)break;k[n+(c<<2)>>2]=0;c=c+1|0}kob(n);c=Xh[k[(k[m>>2]|0)+36>>2]&1023](m)|0}k[l>>2]=c;r=o;return}function qmb(a,b,c,d,e,f,g,h,l,m,n,o,p,q,r){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k[c>>2]=a;z=q+11|0;H=q+4|0;A=p+11|0;B=p+4|0;C=(d&512|0)==0;D=g+8|0;E=(r|0)>0;F=o+11|0;G=o+4|0;y=0;while(1){if((y|0)==4)break;a:do switch(i[l+y>>0]|0){case 0:{k[b>>2]=k[c>>2];break}case 1:{k[b>>2]=k[c>>2];w=Hh[k[(k[g>>2]|0)+28>>2]&511](g,32)|0;x=k[c>>2]|0;k[c>>2]=x+1;i[x>>0]=w;break}case 3:{x=i[z>>0]|0;s=x<<24>>24<0;if((s?k[H>>2]|0:x&255)|0){w=i[(s?k[q>>2]|0:q)>>0]|0;x=k[c>>2]|0;k[c>>2]=x+1;i[x>>0]=w}break}case 2:{w=i[A>>0]|0;s=w<<24>>24<0;w=s?k[B>>2]|0:w&255;if(!(C|(w|0)==0)){t=s?k[p>>2]|0:p;u=t+w|0;v=k[c>>2]|0;s=v;while(1){if((t|0)==(u|0))break;i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}k[c>>2]=v+w}break}case 4:{t=k[c>>2]|0;e=h?e+1|0:e;u=e;while(1){if(u>>>0>=f>>>0)break;s=i[u>>0]|0;if(s<<24>>24<=-1)break;if(!(j[(k[D>>2]|0)+(s<<24>>24<<1)>>1]&2048))break;u=u+1|0}if(E){v=r;while(1){s=(v|0)>0;if(!(u>>>0>e>>>0&s))break;x=u+-1|0;s=i[x>>0]|0;w=k[c>>2]|0;k[c>>2]=w+1;i[w>>0]=s;v=v+-1|0;u=x}if(s)w=Hh[k[(k[g>>2]|0)+28>>2]&511](g,48)|0;else w=0;s=v;while(1){v=k[c>>2]|0;k[c>>2]=v+1;if((s|0)<=0)break;i[v>>0]=w;s=s+-1|0}i[v>>0]=m}b:do if((u|0)==(e|0)){w=Hh[k[(k[g>>2]|0)+28>>2]&511](g,48)|0;x=k[c>>2]|0;k[c>>2]=x+1;i[x>>0]=w}else{x=i[F>>0]|0;s=x<<24>>24<0;if(!((s?k[G>>2]|0:x&255)|0)){w=-1;v=0;x=0}else{w=i[(s?k[o>>2]|0:o)>>0]|0;v=0;x=0}while(1){if((u|0)==(e|0))break b;if((x|0)==(w|0)){w=k[c>>2]|0;k[c>>2]=w+1;i[w>>0]=n;v=v+1|0;w=i[F>>0]|0;s=w<<24>>24<0;if(v>>>0<(s?k[G>>2]|0:w&255)>>>0){w=i[(s?k[o>>2]|0:o)+v>>0]|0;w=w<<24>>24==127?-1:w<<24>>24;s=0}else{w=x;s=0}}else s=x;I=u+-1|0;J=i[I>>0]|0;x=k[c>>2]|0;k[c>>2]=x+1;i[x>>0]=J;x=s+1|0;u=I}}while(0);s=k[c>>2]|0;if((t|0)!=(s|0))while(1){s=s+-1|0;if(t>>>0>=s>>>0)break a;J=i[t>>0]|0;i[t>>0]=i[s>>0]|0;i[s>>0]=J;t=t+1|0}break}default:{}}while(0);y=y+1|0}s=i[z>>0]|0;e=s<<24>>24<0;s=e?k[H>>2]|0:s&255;if(s>>>0>1){e=e?k[q>>2]|0:q;u=e+s|0;v=k[c>>2]|0;t=s+-1|0;s=v;while(1){e=e+1|0;if((e|0)==(u|0))break;i[s>>0]=i[e>>0]|0;s=s+1|0}k[c>>2]=v+t}switch((d&176)<<24>>24){case 32:{k[b>>2]=k[c>>2];break}case 16:break;default:k[b>>2]=a}return}function rmb(a){a=a|0;return}function smb(a){a=a|0;ggb(a);return}function tmb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+976|0;g=D+8|0;z=D;j=D+876|0;a=D+872|0;y=D+468|0;v=D+464|0;A=D+452|0;B=D+440|0;C=D+428|0;m=D+424|0;u=D+24|0;w=D+20|0;x=D+16|0;k[a>>2]=j;p[z>>3]=f;h=kfb(j,100,425910,z)|0;if(h>>>0>99){h=Uib()|0;p[g>>3]=f;h=Qjb(a,h,425910,g)|0;a=k[a>>2]|0;s=fgb(h<<2)|0;q=s;t=a}else{q=D+472|0;s=0;t=0;a=j}o=k[d+28>>2]|0;n=o+4|0;k[n>>2]=(k[n>>2]|0)+1;n=Sib(o,828804)|0;Dg[k[(k[n>>2]|0)+48>>2]&127](n,a,a+h|0,q)|0;if(!h)l=0;else l=(i[a>>0]|0)==45;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[A+(a<<2)>>2]=0;a=a+1|0}k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[B+(a<<2)>>2]=0;a=a+1|0}k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[C+(a<<2)>>2]=0;a=a+1|0}vmb(c,l,o,z,y,v,A,B,C,m);j=k[m>>2]|0;if((h|0)>(j|0)){c=i[C+8+3>>0]|0;a=i[B+8+3>>0]|0;a=(c<<24>>24<0?k[C+4>>2]|0:c&255)+(h-j<<1|1)+(a<<24>>24<0?k[B+4>>2]|0:a&255)|0}else{c=i[C+8+3>>0]|0;a=i[B+8+3>>0]|0;a=(c<<24>>24<0?k[C+4>>2]|0:c&255)+2+(a<<24>>24<0?k[B+4>>2]|0:a&255)|0}a=a+j|0;if(a>>>0>100){g=fgb(a<<2)|0;a=g}else{a=u;g=0}wmb(a,w,x,k[d+4>>2]|0,q,q+(h<<2)|0,n,l,z,k[y>>2]|0,k[v>>2]|0,A,B,C,j);a=ckb(k[b>>2]|0,a,k[w>>2]|0,k[x>>2]|0,d,e)|0;if(g|0)ggb(g);tob(C);tob(B);kob(A);fob(o);if(s|0)ggb(s);if(t|0)ggb(t);r=D;return a|0}function umb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=r;r=r+464|0;t=A+456|0;u=A+452|0;v=A+448|0;z=A+436|0;w=A+424|0;x=A+412|0;g=A+408|0;h=A+8|0;p=A+4|0;q=A;y=k[d+28>>2]|0;s=y+4|0;k[s>>2]=(k[s>>2]|0)+1;s=Sib(y,828804)|0;n=f+8+3|0;o=i[n>>0]|0;a=o<<24>>24<0;m=f+4|0;if(!((a?k[m>>2]|0:o&255)|0))o=0;else{o=k[(a?k[f>>2]|0:f)>>2]|0;o=(o|0)==(Hh[k[(k[s>>2]|0)+44>>2]&511](s,45)|0)};k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[z+(a<<2)>>2]=0;a=a+1|0}k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[w+(a<<2)>>2]=0;a=a+1|0}k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;a=0;while(1){if((a|0)==3)break;k[x+(a<<2)>>2]=0;a=a+1|0}vmb(c,o,y,t,u,v,z,w,x,g);a=i[n>>0]|0;j=k[m>>2]|0;c=a<<24>>24<0?j:a&255;l=k[g>>2]|0;if((c|0)>(l|0)){B=i[x+8+3>>0]|0;g=i[w+8+3>>0]|0;c=(B<<24>>24<0?k[x+4>>2]|0:B&255)+(c-l<<1|1)+(g<<24>>24<0?k[w+4>>2]|0:g&255)|0}else{B=i[x+8+3>>0]|0;c=i[w+8+3>>0]|0;c=(B<<24>>24<0?k[x+4>>2]|0:B&255)+2+(c<<24>>24<0?k[w+4>>2]|0:c&255)|0}c=c+l|0;if(c>>>0>100){c=fgb(c<<2)|0;g=c;if(!c){h=0;c=k[m>>2]|0;a=i[n>>0]|0}else{h=c;c=j}}else{g=0;c=j}B=a<<24>>24<0;f=B?k[f>>2]|0:f;wmb(h,p,q,k[d+4>>2]|0,f,f+((B?c:a&255)<<2)|0,s,o,t,k[u>>2]|0,k[v>>2]|0,z,w,x,l);a=ckb(k[b>>2]|0,h,k[p>>2]|0,k[q>>2]|0,d,e)|0;if(g|0)ggb(g);tob(x);tob(w);kob(z);fob(y);r=A;return a|0}
function Yea(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+128|0;s=t+64|0;o=t;q=t+8|0;do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[s>>2]=k[h>>2];m=s+4|0;a=h+4|0;k[m>>2]=k[a>>2];p=s+8|0;k[p>>2]=k[h+8>>2];k[s+12>>2]=k[h+12>>2];k[s+16>>2]=k[h+16>>2];k[s+20>>2]=k[h+20>>2];k[s+24>>2]=k[h+24>>2];k[s+28>>2]=k[h+28>>2];k[s+32>>2]=k[h+32>>2];g=k[h+36>>2]|0;k[s+36>>2]=g;n=s+40|0;k[n>>2]=p;p=s+48|0;i=s+44|0;k[i>>2]=p;k[s+52>>2]=0;k[p>>2]=0;if(g|0){p=g+12|0;k[p>>2]=(k[p>>2]|0)+1}if((k[a>>2]|0)<3){m=k[h+44>>2]|0;p=k[i>>2]|0;k[p>>2]=k[m>>2];k[p+4>>2]=k[m+4>>2];p=n;break}k[m>>2]=0;x1(s,k[a>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[h+40>>2]|0;l=k[n>>2]|0;h=k[h+44>>2]|0;g=k[i>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[j+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0));p=n}else p=n}else{Q1(s,a,-1);p=s+40|0}while(0);m=k[p>>2]|0;n=k[m>>2]|0;k[o>>2]=k[m+4>>2];k[o+4>>2]=n;x2(b,o,5,0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[q>>2]=k[j>>2];n=q+4|0;g=j+4|0;k[n>>2]=k[g>>2];o=q+8|0;k[o>>2]=k[j+8>>2];k[q+12>>2]=k[j+12>>2];k[q+16>>2]=k[j+16>>2];k[q+20>>2]=k[j+20>>2];k[q+24>>2]=k[j+24>>2];k[q+28>>2]=k[j+28>>2];k[q+32>>2]=k[j+32>>2];a=k[j+36>>2]|0;k[q+36>>2]=a;h=q+40|0;k[h>>2]=o;o=q+48|0;l=q+44|0;k[l>>2]=o;k[q+52>>2]=0;k[o>>2]=0;if(a|0){o=a+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[g>>2]|0)<3){b=k[j+44>>2]|0;o=k[l>>2]|0;k[o>>2]=k[b>>2];k[o+4>>2]=k[b+4>>2];break}k[n>>2]=0;x1(q,k[g>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[j+40>>2]|0;i=k[h>>2]|0;h=k[j+44>>2]|0;g=k[l>>2]|0;a=0;do{k[i+(a<<2)>>2]=k[m+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(q,b,-1);while(0);Xea(s,q,c,d,1,e,f);h=q+36|0;a=k[h>>2]|0;if(a|0?(d=a+12|0,f=k[d>>2]|0,k[d>>2]=f+-1,(f|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;f=q+16|0;g=q+4|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[g>>2]|0)>0){h=k[q+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[q+44>>2]|0;if(!((a|0)==(q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=s+36|0;a=k[h>>2]|0;if(a|0?(f=a+12|0,q=k[f>>2]|0,k[f>>2]=q+-1,(q|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[s+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;q=s+16|0;h=s+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[h>>2]|0)>0){g=k[p>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[s+44>>2]|0;if((a|0)==(s+48|0)|(a|0)==0){r=t;return}ggb(k[a+-4>>2]|0);r=t;return}function Zea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0;Ya=r;r=r+1392|0;Qa=Ya;F=Ya+1240|0;Xa=Ya+1160|0;Wa=Ya+1104|0;y=Ya+1232|0;z=Ya+1224|0;Pa=Ya+1048|0;x=Ya+1216|0;do if((k[a>>2]&2031616|0)==65536){f=k[a+4>>2]|0;k[Xa>>2]=k[f>>2];p=Xa+4|0;a=f+4|0;k[p>>2]=k[a>>2];Va=Xa+8|0;k[Va>>2]=k[f+8>>2];k[Xa+12>>2]=k[f+12>>2];k[Xa+16>>2]=k[f+16>>2];k[Xa+20>>2]=k[f+20>>2];k[Xa+24>>2]=k[f+24>>2];k[Xa+28>>2]=k[f+28>>2];k[Xa+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[Xa+36>>2]=e;q=Xa+40|0;k[q>>2]=Va;Va=Xa+48|0;g=Xa+44|0;k[g>>2]=Va;k[Xa+52>>2]=0;k[Va>>2]=0;if(e|0){Va=e+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[a>>2]|0)<3){Va=k[f+44>>2]|0;a=k[g>>2]|0;k[a>>2]=k[Va>>2];k[a+4>>2]=k[Va+4>>2];a=Xa;break}k[p>>2]=0;x1(Xa,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){h=k[f+40>>2]|0;n=k[q>>2]|0;f=k[f+44>>2]|0;e=k[g>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[h+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0));a=Xa}else a=Xa}else{Q1(Xa,a,-1);a=Xa;q=Xa+40|0}while(0);k[Wa>>2]=1124007936;Sa=Wa+4|0;E=Wa+8|0;Ra=Wa+40|0;v=Sa;w=v+36|0;do{k[v>>2]=0;v=v+4|0}while((v|0)<(w|0));k[Ra>>2]=E;Ua=Wa+48|0;Ta=Wa+44|0;k[Ta>>2]=Ua;k[Wa+52>>2]=0;k[Ua>>2]=0;s=k[q>>2]|0;p=k[s+4>>2]|0;s=k[s>>2]|0;n=k[a>>2]|0;h=n>>>3&511;n=n&7;C=(n|0)==0;D=(n|0)==2;if((n|2|0)!=2){k[Qa>>2]=0;a=Qa+4|0;k[a>>2]=0;e=ZT(40)|0;k[e>>2]=1;v=e+4|0;k[Qa>>2]=v;k[a>>2]=33;i[e+37>>0]=0;g=244365;w=v+33|0;do{i[v>>0]=i[g>>0]|0;v=v+1|0;g=g+1|0}while((v|0)<(w|0));Y8(-215,Qa,244399,244411,1622);k[a>>2]=0;k[Qa>>2]=0;Va=k[e>>2]|0;k[e>>2]=Va+-1;if((Va|0)==1)ggb(k[e+-4>>2]|0)}Va=Xa+16|0;if(k[Va>>2]|0){f=k[Xa+4>>2]|0;if((f|0)<3)a=aa(k[Xa+12>>2]|0,k[Xa+8>>2]|0)|0;else{g=k[q>>2]|0;e=0;a=1;do{a=aa(k[g+(e<<2)>>2]|0,a)|0;e=e+1|0}while((e|0)!=(f|0))}if(!a)t=20}else t=20;if((t|0)==20){k[Qa>>2]=0;a=Qa+4|0;k[a>>2]=0;e=ZT(20)|0;k[e>>2]=1;v=e+4|0;k[Qa>>2]=v;k[a>>2]=12;i[e+16>>0]=0;g=401621;w=v+12|0;do{i[v>>0]=i[g>>0]|0;v=v+1|0;g=g+1|0}while((v|0)<(w|0));Y8(-215,Qa,244399,244411,1623);k[a>>2]=0;k[Qa>>2]=0;Oa=k[e>>2]|0;k[e>>2]=Oa+-1;if((Oa|0)==1)ggb(k[e+-4>>2]|0)}a:do switch(c|0){case 89:case 88:case 87:case 86:{f=(d|0)<1?1:d;if(!((f|0)==1&(h|0)==0)){k[Qa>>2]=0;a=Qa+4|0;k[a>>2]=0;e=ZT(28)|0;k[e>>2]=1;v=e+4|0;k[Qa>>2]=v;k[a>>2]=20;i[e+24>>0]=0;g=244484;w=v+20|0;do{i[v>>0]=i[g>>0]|0;v=v+1|0;g=g+1|0}while((v|0)<(w|0));Y8(-215,Qa,244399,244411,1630);k[a>>2]=0;k[Qa>>2]=0;Pa=k[e>>2]|0;k[e>>2]=Pa+-1;if((Pa|0)==1)ggb(k[e+-4>>2]|0)}k[y>>2]=p;k[y+4>>2]=s;x2(b,y,n|(f<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[Qa>>2]=k[g>>2];s=Qa+4|0;a=g+4|0;k[s>>2]=k[a>>2];Pa=Qa+8|0;k[Pa>>2]=k[g+8>>2];k[Qa+12>>2]=k[g+12>>2];k[Qa+16>>2]=k[g+16>>2];k[Qa+20>>2]=k[g+20>>2];k[Qa+24>>2]=k[g+24>>2];k[Qa+28>>2]=k[g+28>>2];k[Qa+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Qa+36>>2]=e;f=Qa+40|0;k[f>>2]=Pa;Pa=Qa+48|0;n=Qa+44|0;k[n>>2]=Pa;k[Qa+52>>2]=0;k[Pa>>2]=0;if(e|0){Pa=e+12|0;k[Pa>>2]=(k[Pa>>2]|0)+1}if((k[a>>2]|0)<3){Oa=k[g+44>>2]|0;Pa=k[n>>2]|0;k[Pa>>2]=k[Oa>>2];k[Pa+4>>2]=k[Oa+4>>2];break}k[s>>2]=0;x1(Qa,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){p=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[n>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[p+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else Q1(Qa,b,-1);while(0);KG(Wa,Qa)|0;f=Qa+36|0;a=k[f>>2]|0;if(a|0?(Oa=a+12|0,Pa=k[Oa>>2]|0,k[Oa>>2]=Pa+-1,(Pa|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[Qa+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;Pa=Qa+16|0;e=Qa+4|0;k[Pa>>2]=0;k[Pa+4>>2]=0;k[Pa+8>>2]=0;k[Pa+12>>2]=0;if((k[e>>2]|0)>0){f=k[Qa+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[Qa+44>>2]|0;if(!((a|0)==(Qa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);if(C){y=k[q>>2]|0;Pa=k[y>>2]|0;w=(c&-2|0)==86;x=Pa+-2|0;y=(k[y+4>>2]|0)+-2|0;if((Pa|0)>2){v=w?1868:4899;d=w?4899:1868;t=((c|0)==87|(c|0)==89)&1;k[Qa>>2]=0;k[Qa+4>>2]=x;k[F>>2]=63280;g=F+4|0;k[g>>2]=k[Xa>>2];s=F+8|0;e=Xa+4|0;a=k[e>>2]|0;k[s>>2]=a;Pa=F+12|0;k[Pa>>2]=k[Xa+8>>2];k[F+16>>2]=k[Xa+12>>2];k[F+20>>2]=k[Va>>2];k[F+24>>2]=k[Xa+20>>2];k[F+28>>2]=k[Xa+24>>2];k[F+32>>2]=k[Xa+28>>2];k[F+36>>2]=k[Xa+32>>2];f=k[Xa+36>>2]|0;k[F+40>>2]=f;n=F+44|0;k[n>>2]=Pa;Pa=F+52|0;p=F+48|0;k[p>>2]=Pa;k[F+56>>2]=0;k[Pa>>2]=0;if(f){a=f+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[e>>2]|0}if((a|0)>=3){k[s>>2]=0;x1(g,a,0,0,0);if((k[s>>2]|0)>0){h=k[Xa+40>>2]|0;f=k[n>>2]|0;g=k[Xa+44>>2]|0;e=k[p>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[e+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else{Oa=k[Xa+44>>2]|0;Pa=k[p>>2]|0;k[Pa>>2]=k[Oa>>2];k[Pa+4>>2]=k[Oa+4>>2]}g=F+60|0;k[g>>2]=k[Wa>>2];s=F+64|0;e=k[Sa>>2]|0;k[s>>2]=e;Pa=F+68|0;k[Pa>>2]=k[E>>2];k[F+72>>2]=k[Wa+12>>2];a=Wa+16|0;k[F+76>>2]=k[a>>2];k[F+80>>2]=k[Wa+20>>2];k[F+84>>2]=k[Wa+24>>2];k[F+88>>2]=k[Wa+28>>2];k[F+92>>2]=k[Wa+32>>2];f=k[Wa+36>>2]|0;k[F+96>>2]=f;h=F+100|0;k[h>>2]=Pa;Pa=F+108|0;p=F+104|0;k[p>>2]=Pa;k[F+112>>2]=0;k[Pa>>2]=0;if(f){e=f+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[Sa>>2]|0}if((e|0)>=3){k[s>>2]=0;x1(g,e,0,0,0);if((k[s>>2]|0)>0){n=k[Ra>>2]|0;g=k[h>>2]|0;h=k[Ta>>2]|0;f=k[p>>2]|0;e=0;do{k[g+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[h+(e<<2)>>2];e=e+1|0}while((e|0)<(k[s>>2]|0))}}else{Oa=k[Ta>>2]|0;Pa=k[p>>2]|0;k[Pa>>2]=k[Oa>>2];k[Pa+4>>2]=k[Oa+4>>2]}k[F+116>>2]=t;i[F+120>>0]=w&1;k[F+124>>2]=y;k[F+128>>2]=x;k[F+132>>2]=v;k[F+136>>2]=d;jh[k[(k[F>>2]|0)+8>>2]&1023](F,Qa);_ea(F)}else a=Wa+16|0;e=k[Ra>>2]|0;n=k[e+4>>2]|0;e=k[e>>2]|0;h=k[a>>2]|0;g=k[Ua>>2]|0;a=(n|0)>0;if((e|0)>2){if(!a)break a;f=aa(e+-2|0,g)|0;e=aa(e+-1|0,g)|0;a=0;while(1){i[h+a>>0]=i[h+(a+g)>>0]|0;i[h+(e+a)>>0]=i[h+(f+a)>>0]|0;a=a+1|0;if((a|0)==(n|0))break a}}else{if(!a)break a;a=aa(e+-1|0,g)|0;i[h+a>>0]=0;i[h>>0]=0;if((n|0)==1)break a;else e=1;while(1){i[h+(a+e)>>0]=0;i[h+e>>0]=0;e=e+1|0;if((e|0)==(n|0))break a}}}if(!D){k[Qa>>2]=0;a=Qa+4|0;k[a>>2]=0;e=ZT(60)|0;k[e>>2]=1;v=e+4|0;k[Qa>>2]=v;k[a>>2]=54;i[e+58>>0]=0;g=244505;w=v+54|0;do{i[v>>0]=i[g>>0]|0;v=v+1|0;g=g+1|0}while((v|0)<(w|0));Y8(-210,Qa,244399,244411,1640);k[a>>2]=0;k[Qa>>2]=0;Qa=k[e>>2]|0;k[e>>2]=Qa+-1;if((Qa|0)==1)ggb(k[e+-4>>2]|0);break a}y=k[q>>2]|0;Pa=k[y>>2]|0;w=(c&-2|0)==86;x=Pa+-2|0;y=(k[y+4>>2]|0)+-2|0;if((Pa|0)>2){v=w?1868:4899;d=w?4899:1868;t=((c|0)==87|(c|0)==89)&1;k[Qa>>2]=0;k[Qa+4>>2]=x;k[F>>2]=63260;g=F+4|0;k[g>>2]=k[Xa>>2];s=F+8|0;e=Xa+4|0;a=k[e>>2]|0;k[s>>2]=a;Pa=F+12|0;k[Pa>>2]=k[Xa+8>>2];k[F+16>>2]=k[Xa+12>>2];k[F+20>>2]=k[Va>>2];k[F+24>>2]=k[Xa+20>>2];k[F+28>>2]=k[Xa+24>>2];k[F+32>>2]=k[Xa+28>>2];k[F+36>>2]=k[Xa+32>>2];f=k[Xa+36>>2]|0;k[F+40>>2]=f;n=F+44|0;k[n>>2]=Pa;Pa=F+52|0;p=F+48|0;k[p>>2]=Pa;k[F+56>>2]=0;k[Pa>>2]=0;if(f){a=f+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[e>>2]|0}if((a|0)>=3){k[s>>2]=0;x1(g,a,0,0,0);if((k[s>>2]|0)>0){h=k[Xa+40>>2]|0;f=k[n>>2]|0;g=k[Xa+44>>2]|0;e=k[p>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[e+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else{Oa=k[Xa+44>>2]|0;Pa=k[p>>2]|0;k[Pa>>2]=k[Oa>>2];k[Pa+4>>2]=k[Oa+4>>2]}g=F+60|0;k[g>>2]=k[Wa>>2];s=F+64|0;e=k[Sa>>2]|0;k[s>>2]=e;Pa=F+68|0;k[Pa>>2]=k[E>>2];k[F+72>>2]=k[Wa+12>>2];a=Wa+16|0;k[F+76>>2]=k[a>>2];k[F+80>>2]=k[Wa+20>>2];k[F+84>>2]=k[Wa+24>>2];k[F+88>>2]=k[Wa+28>>2];k[F+92>>2]=k[Wa+32>>2];f=k[Wa+36>>2]|0;k[F+96>>2]=f;h=F+100|0;k[h>>2]=Pa;Pa=F+108|0;p=F+104|0;k[p>>2]=Pa;k[F+112>>2]=0;k[Pa>>2]=0;if(f){e=f+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[Sa>>2]|0}if((e|0)>=3){k[s>>2]=0;x1(g,e,0,0,0);if((k[s>>2]|0)>0){n=k[Ra>>2]|0;g=k[h>>2]|0;h=k[Ta>>2]|0;f=k[p>>2]|0;e=0;do{k[g+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[h+(e<<2)>>2];e=e+1|0}while((e|0)<(k[s>>2]|0))}}else{Oa=k[Ta>>2]|0;Pa=k[p>>2]|0;k[Pa>>2]=k[Oa>>2];k[Pa+4>>2]=k[Oa+4>>2]}k[F+116>>2]=t;i[F+120>>0]=w&1;k[F+124>>2]=y;k[F+128>>2]=x;k[F+132>>2]=v;k[F+136>>2]=d;jh[k[(k[F>>2]|0)+8>>2]&1023](F,Qa);$ea(F)}else a=Wa+16|0;e=k[Ra>>2]|0;n=k[e+4>>2]|0;e=k[e>>2]|0;h=k[a>>2]|0;g=(k[Ua>>2]|0)>>>1;a=(n|0)>0;if((e|0)>2){if(!a)break a;f=aa(g,e+-2|0)|0;e=aa(g,e+-1|0)|0;a=0;do{j[h+(a<<1)>>1]=j[h+(a+g<<1)>>1]|0;j[h+(a+e<<1)>>1]=j[h+(a+f<<1)>>1]|0;a=a+1|0}while((a|0)!=(n|0))}else{if(!a)break a;e=aa(g,e+-1|0)|0;a=0;do{j[h+(a+e<<1)>>1]=0;j[h+(a<<1)>>1]=0;a=a+1|0}while((a|0)!=(n|0))}break}case 65:case 64:case 63:case 62:case 49:case 48:case 47:case 46:{f=(d|0)<1?3:d;if(!((f+-3|0)>>>0<2&(h|0)==0)){k[Qa>>2]=0;a=Qa+4|0;k[a>>2]=0;e=ZT(40)|0;k[e>>2]=1;v=e+4|0;k[Qa>>2]=v;k[a>>2]=34;i[e+38>>0]=0;g=244560;w=v+34|0;do{i[v>>0]=i[g>>0]|0;v=v+1|0;g=g+1|0}while((v|0)<(w|0));Y8(-215,Qa,244399,244411,1648);k[a>>2]=0;k[Qa>>2]=0;Oa=k[e>>2]|0;k[e>>2]=Oa+-1;if((Oa|0)==1)ggb(k[e+-4>>2]|0)}k[z>>2]=p;k[z+4>>2]=s;x2(b,z,n|(f<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[Pa>>2]=k[g>>2];s=Pa+4|0;a=g+4|0;k[s>>2]=k[a>>2];Oa=Pa+8|0;k[Oa>>2]=k[g+8>>2];k[Pa+12>>2]=k[g+12>>2];k[Pa+16>>2]=k[g+16>>2];k[Pa+20>>2]=k[g+20>>2];k[Pa+24>>2]=k[g+24>>2];k[Pa+28>>2]=k[g+28>>2];k[Pa+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Pa+36>>2]=e;f=Pa+40|0;k[f>>2]=Oa;Oa=Pa+48|0;n=Pa+44|0;k[n>>2]=Oa;k[Pa+52>>2]=0;k[Oa>>2]=0;if(e|0){Oa=e+12|0;k[Oa>>2]=(k[Oa>>2]|0)+1}if((k[a>>2]|0)<3){Na=k[g+44>>2]|0;Oa=k[n>>2]|0;k[Oa>>2]=k[Na>>2];k[Oa+4>>2]=k[Na+4>>2];break}k[s>>2]=0;x1(Pa,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){p=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[n>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[p+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else Q1(Pa,b,-1);while(0);do if((c+-46|0)>>>0<4){if(C){afa(Xa,Pa,c);break}if(!D){k[Qa>>2]=0;a=Qa+4|0;k[a>>2]=0;e=ZT(60)|0;k[e>>2]=1;v=e+4|0;k[Qa>>2]=v;k[a>>2]=53;i[e+57>>0]=0;g=244595;w=v+53|0;do{i[v>>0]=i[g>>0]|0;v=v+1|0;g=g+1|0}while((v|0)<(w|0));Y8(-210,Qa,244399,244411,1661);k[a>>2]=0;k[Qa>>2]=0;Qa=k[e>>2]|0;k[e>>2]=Qa+-1;if((Qa|0)==1)ggb(k[e+-4>>2]|0);break}z=(k[Pa+48>>2]|0)>>>1;w=k[q>>2]|0;Oa=k[w>>2]|0;y=((k[Pa>>2]|0)>>>3&511)+1|0;v=Oa+-2|0;w=(k[w+4>>2]|0)+-2|0;if((Oa|0)>2){x=((c|0)==47|(c|0)==49)&1;d=(c|1|0)==47?-1:1;k[Qa>>2]=0;k[Qa+4>>2]=v;k[F>>2]=63220;g=F+4|0;k[g>>2]=k[Xa>>2];s=F+8|0;e=Xa+4|0;a=k[e>>2]|0;k[s>>2]=a;Oa=F+12|0;k[Oa>>2]=k[Xa+8>>2];k[F+16>>2]=k[Xa+12>>2];k[F+20>>2]=k[Va>>2];k[F+24>>2]=k[Xa+20>>2];k[F+28>>2]=k[Xa+24>>2];k[F+32>>2]=k[Xa+28>>2];k[F+36>>2]=k[Xa+32>>2];f=k[Xa+36>>2]|0;k[F+40>>2]=f;n=F+44|0;k[n>>2]=Oa;Oa=F+52|0;p=F+48|0;k[p>>2]=Oa;k[F+56>>2]=0;k[Oa>>2]=0;if(f){a=f+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[e>>2]|0}if((a|0)>=3){k[s>>2]=0;x1(g,a,0,0,0);if((k[s>>2]|0)>0){h=k[Xa+40>>2]|0;f=k[n>>2]|0;g=k[Xa+44>>2]|0;e=k[p>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[e+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else{Na=k[Xa+44>>2]|0;Oa=k[p>>2]|0;k[Oa>>2]=k[Na>>2];k[Oa+4>>2]=k[Na+4>>2]}h=F+60|0;k[h>>2]=k[Pa>>2];t=F+64|0;f=Pa+4|0;e=k[f>>2]|0;k[t>>2]=e;Oa=F+68|0;k[Oa>>2]=k[Pa+8>>2];k[F+72>>2]=k[Pa+12>>2];a=Pa+16|0;k[F+76>>2]=k[a>>2];k[F+80>>2]=k[Pa+20>>2];k[F+84>>2]=k[Pa+24>>2];k[F+88>>2]=k[Pa+28>>2];k[F+92>>2]=k[Pa+32>>2];g=k[Pa+36>>2]|0;k[F+96>>2]=g;p=F+100|0;k[p>>2]=Oa;Oa=F+108|0;s=F+104|0;k[s>>2]=Oa;k[F+112>>2]=0;k[Oa>>2]=0;if(g){e=g+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[f>>2]|0}if((e|0)>=3){k[t>>2]=0;x1(h,e,0,0,0);if((k[t>>2]|0)>0){n=k[Pa+40>>2]|0;g=k[p>>2]|0;h=k[Pa+44>>2]|0;f=k[s>>2]|0;e=0;do{k[g+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[h+(e<<2)>>2];e=e+1|0}while((e|0)<(k[t>>2]|0))}}else{Na=k[Pa+44>>2]|0;Oa=k[s>>2]|0;k[Oa>>2]=k[Na>>2];k[Oa+4>>2]=k[Na+4>>2]}k[F+116>>2]=x;k[F+120>>2]=d;k[F+124>>2]=w;k[F+128>>2]=v;jh[k[(k[F>>2]|0)+8>>2]&1023](F,Qa);bfa(F)}else a=Pa+16|0;g=k[Pa+40>>2]|0;e=k[g>>2]|0;h=k[a>>2]|0;g=aa(k[g+4>>2]|0,y)|0;a=(g|0)>0;if((e|0)>2){if(!a)break;f=aa(e+-2|0,z)|0;e=aa(e+-1|0,z)|0;a=0;do{j[h+(a<<1)>>1]=j[h+(a+z<<1)>>1]|0;j[h+(a+e<<1)>>1]=j[h+(a+f<<1)>>1]|0;a=a+1|0}while((a|0)!=(g|0))}else{if(!a)break;e=aa(e+-1|0,z)|0;a=0;do{j[h+(a+e<<1)>>1]=0;j[h+(a<<1)>>1]=0;a=a+1|0}while((a|0)!=(g|0))}}else{if(!C){k[Qa>>2]=0;a=Qa+4|0;k[a>>2]=0;e=ZT(20)|0;k[e>>2]=1;v=e+4|0;k[Qa>>2]=v;k[a>>2]=14;i[e+18>>0]=0;g=403519;w=v+14|0;do{i[v>>0]=i[g>>0]|0;v=v+1|0;g=g+1|0}while((v|0)<(w|0));Y8(-215,Qa,244399,244411,1665);k[a>>2]=0;k[Qa>>2]=0;Oa=k[e>>2]|0;k[e>>2]=Oa+-1;if((Oa|0)==1)ggb(k[e+-4>>2]|0)}g=k[Va>>2]|0;Ha=k[Xa+48>>2]|0;La=k[Pa+16>>2]|0;Ma=k[Pa+48>>2]|0;Ja=k[q>>2]|0;Ia=k[Ja+4>>2]|0;Ja=k[Ja>>2]|0;if((((Ia|0)>(Ja|0)?Ja:Ia)|0)<8){afa(Xa,Pa,c);break}n=(c|0)!=62&(c|0)!=64;h=(c|1|0)==63?0:2;Ca=Ia<<1;Ka=Ia*3|0;Da=Ia<<2;Ea=Ia*5|0;Fa=Ia*6|0;Ga=Ia*49|0;f=Ia*147|0;Na=Qa+8|0;k[Qa>>2]=Na;Oa=Qa+4|0;k[Oa>>2]=520;if(f>>>0>520){e=f>>>0>2147483647?-1:f<<1;e=(e|0)==0?1:e;while(1){a=fgb(e)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[Qa>>2]=a}else a=Na;k[Oa>>2]=f;Aa=Ha<<1;L=g+Aa|0;Ba=Ja+-4|0;if((Ba|0)>2){M=Ia+-2|0;N=Ia+-1|0;O=(N|0)>1;P=~Ha;Q=Ha+-1|0;R=0-Ha|0;S=1-Ha|0;T=Ha+1|0;U=(M|0)>2;V=Ka+-9|0;W=M*3|0;X=Ia+1|0;Y=Ca|1;Z=Ca+-1|0;_=Ka+-1|0;$=Ka+1|0;ba=R<<1;ca=ba+-1|0;da=ba|1;ea=Aa+-1|0;fa=Aa|1;ga=-2-Ha|0;ha=Ha+-2|0;ia=2-Ha|0;ja=Ha+2|0;ka=Da|1;la=Da+-1|0;ma=Ea+-1|0;na=Ea+1|0;sa=aa(Ha,-2)|0;oa=sa+2|0;pa=Fa|1;qa=Aa+-2|0;ra=Fa+-1|0;sa=sa+-2|0;ta=Aa+2|0;ua=M+Ia|0;va=M+Ca|0;wa=M+Ka|0;xa=M+Da|0;ya=M+Ea|0;za=M+Fa|0;e=h;K=2;J=n;while(1){n=(K|0)==2?-1:1;do{g=n+K|0;f=a+((aa((g+-1|0)%3|0,Ga)|0)<<1)+2|0;j[f+(M<<1)>>1]=0;j[f+-2>>1]=0;j[f+(ua<<1)>>1]=0;j[f+(N<<1)>>1]=0;j[f+(va<<1)>>1]=0;j[f+(Z<<1)>>1]=0;j[f+(wa<<1)>>1]=0;j[f+(_<<1)>>1]=0;j[f+(xa<<1)>>1]=0;j[f+(la<<1)>>1]=0;j[f+(ya<<1)>>1]=0;j[f+(ma<<1)>>1]=0;j[f+(za<<1)>>1]=0;j[f+(ra<<1)>>1]=0;if(O){g=L+(aa(g,Ha)|0)+1|0;h=1;while(1){E=g+P|0;c=g+Q|0;G=(l[E>>0]|0)-(l[c>>0]|0)|0;H=g+R|0;I=g+Ha|0;z=(l[H>>0]|0)-(l[I>>0]|0)|0;F=g+S|0;D=g+T|0;b=(l[F>>0]|0)-(l[D>>0]|0)|0;j[f>>1]=(((z|0)>-1?z:0-z|0)<<1)+((G|0)>-1?G:0-G|0)+((b|0)>-1?b:0-b|0);b=(l[E>>0]|0)-(l[F>>0]|0)|0;G=g+-1|0;g=g+1|0;z=(l[G>>0]|0)-(l[g>>0]|0)|0;C=(l[c>>0]|0)-(l[D>>0]|0)|0;j[f+(Ia<<1)>>1]=(((z|0)>-1?z:0-z|0)<<1)+((b|0)>-1?b:0-b|0)+((C|0)>-1?C:0-C|0);c=(l[F>>0]|0)-(l[c>>0]|0)|0;F=f+(Ca<<1)|0;j[F>>1]=((c|0)>-1?c:0-c|0)<<1;D=(l[E>>0]|0)-(l[D>>0]|0)|0;E=f+(Ka<<1)|0;j[E>>1]=((D|0)>-1?D:0-D|0)<<1;D=(l[H>>0]|0)-(l[G>>0]|0)|0;c=(l[I>>0]|0)-(l[g>>0]|0)|0;j[f+(Da<<1)>>1]=((D|0)>-1?D:0-D|0)+(m[F>>1]|0)+((c|0)>-1?c:0-c|0);c=(l[H>>0]|0)-(l[g>>0]|0)|0;F=(l[I>>0]|0)-(l[G>>0]|0)|0;j[f+(Ea<<1)>>1]=((c|0)>-1?c:0-c|0)+(m[E>>1]|0)+((F|0)>-1?F:0-F|0);j[f+(Fa<<1)>>1]=((l[G>>0]|0)+(l[H>>0]|0)+(l[g>>0]|0)+(l[I>>0]|0)|0)>>>1;h=h+1|0;if((h|0)==(N|0))break;else f=f+2|0}}n=n+1|0}while((n|0)!=2);H=aa(K,Ma)|0;I=La+H|0;if(U){G=e^2;z=J;b=a+((aa((K|0)%3|0,Ga)|0)<<1)+4|0;C=a+((aa((K+-1|0)%3|0,Ga)|0)<<1)+4|0;D=a+((aa((K+-2|0)%3|0,Ga)|0)<<1)+4|0;c=I+6|0;E=L+(aa(K,Ha)|0)+2|0;F=2;while(1){p=m[C>>1]|0;h=p+(m[D>>1]|0)|0;p=(m[b>>1]|0)+p|0;y=m[C+(Ia<<1)>>1]|0;d=y+(m[C+(N<<1)>>1]|0)|0;y=(m[C+(X<<1)>>1]|0)+y|0;f=p>>>0<h>>>0?p:h;f=(d|0)<(f|0)?d:f;f=(y|0)<(f|0)?y:f;g=h>>>0<p>>>0?p:h;g=(g|0)<(d|0)?d:g;g=(g|0)<(y|0)?y:g;if(z){t=m[C+(Ca<<1)>>1]|0;s=(m[D+(Y<<1)>>1]|0)+(m[D+(Ca<<1)>>1]|0)+t+(m[C+(Y<<1)>>1]|0)|0;t=(m[C+(Z<<1)>>1]|0)+t+(m[b+(Ca<<1)>>1]|0)+(m[b+(Z<<1)>>1]|0)|0;x=m[C+(Ka<<1)>>1]|0;v=(m[D+(_<<1)>>1]|0)+(m[D+(Ka<<1)>>1]|0)+x+(m[C+(_<<1)>>1]|0)|0;x=(m[C+($<<1)>>1]|0)+x+(m[b+(Ka<<1)>>1]|0)+(m[b+($<<1)>>1]|0)|0;w=(s|0)<(f|0)?s:f;w=(t|0)<(w|0)?t:w;w=(v|0)<(w|0)?v:w;n=(g|0)<(s|0)?s:g;n=(n|0)<(t|0)?t:n;n=(n|0)<(v|0)?v:n;n=(n|0)<(x|0)?x:n;w=((n|0)<2?1:(n|0)/2|0)+((x|0)<(w|0)?x:w)|0;if((h|0)<(w|0)){g=1;h=(l[E+R>>0]|0)<<1;n=(l[E>>0]|0)+(l[E+ba>>0]|0)|0;f=(l[E+da>>0]|0)+(l[E+ca>>0]|0)|0}else{g=0;h=0;n=0;f=0}if((p|0)<(w|0)){g=g+1|0;h=((l[E+Ha>>0]|0)<<1)+h|0;n=(l[E+Aa>>0]|0)+n+(l[E>>0]|0)|0;f=(l[E+ea>>0]|0)+f+(l[E+fa>>0]|0)|0}if((d|0)<(w|0)){g=g+1|0;h=(l[E+ga>>0]|0)+h+(l[E+ha>>0]|0)|0;n=(l[E+-2>>0]|0)+n+(l[E>>0]|0)|0;f=((l[E+-1>>0]|0)<<1)+f|0}if((y|0)<(w|0)){g=g+1|0;h=(l[E+ia>>0]|0)+h+(l[E+ja>>0]|0)|0;n=(l[E+2>>0]|0)+n+(l[E>>0]|0)|0;f=((l[E+1>>0]|0)<<1)+f|0}if((s|0)<(w|0)){g=g+1|0;h=(l[E+R>>0]|0)+h+(l[E+ia>>0]|0)|0;n=((l[E+S>>0]|0)<<1)+n|0;f=(l[E+da>>0]|0)+f+(l[E+1>>0]|0)|0}if((t|0)<(w|0)){g=g+1|0;h=(l[E+Ha>>0]|0)+h+(l[E+ha>>0]|0)|0;n=((l[E+Q>>0]|0)<<1)+n|0;f=(l[E+ea>>0]|0)+f+(l[E+-1>>0]|0)|0}if((v|0)<(w|0)){g=g+1|0;h=(l[E+ga>>0]|0)+h+(l[E+R>>0]|0)|0;n=((l[E+P>>0]|0)<<1)+n|0;f=(l[E+ca>>0]|0)+f+(l[E+-1>>0]|0)|0}if((x|0)<(w|0)){g=g+1|0;h=(l[E+ja>>0]|0)+h+(l[E+Ha>>0]|0)|0;n=((l[E+T>>0]|0)<<1)+n|0;f=(l[E+fa>>0]|0)+f+(l[E+1>>0]|0)|0}p=l[E>>0]|0;B=+o[63136+(g<<2)>>2];A=+(f-n|0)*B;f=(o[u>>2]=A,k[u>>2]|0);do if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;A=f?A+-8388608.0+8388608.0:A+8388608.0+-8388608.0;if(!(A==0.0))break;A=f?-0.0:0.0}while(0);f=~~A+p|0;A=+(h-n|0)*B;g=(o[u>>2]=A,k[u>>2]|0);do if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;A=g?A+-8388608.0+8388608.0:A+8388608.0+-8388608.0;if(!(A==0.0))break;A=g?-0.0:0.0}while(0);h=~~A+p|0;g=p}else{t=m[C+(Da<<1)>>1]|0;s=t+(m[D+(ka<<1)>>1]|0)|0;t=(m[b+(la<<1)>>1]|0)+t|0;x=m[C+(Ea<<1)>>1]|0;v=x+(m[D+(ma<<1)>>1]|0)|0;x=(m[b+(na<<1)>>1]|0)+x|0;w=(s|0)<(f|0)?s:f;w=(t|0)<(w|0)?t:w;w=(v|0)<(w|0)?v:w;n=(g|0)<(s|0)?s:g;n=(n|0)<(t|0)?t:n;n=(n|0)<(v|0)?v:n;n=(n|0)<(x|0)?x:n;w=((n|0)<2?1:(n|0)/2|0)+((x|0)<(w|0)?x:w)|0;if((h|0)<(w|0)){f=1;h=(l[E+S>>0]|0)+(l[E+P>>0]|0)|0;g=(l[E+R>>0]|0)<<1;n=(l[E>>0]|0)+(l[E+ba>>0]|0)|0}else{f=0;h=0;g=0;n=0}if((p|0)<(w|0)){f=f+1|0;h=(l[E+Q>>0]|0)+h+(l[E+T>>0]|0)|0;g=((l[E+Ha>>0]|0)<<1)+g|0;n=(l[E+Aa>>0]|0)+n+(l[E>>0]|0)|0}if((d|0)<(w|0)){f=f+1|0;h=(l[E+P>>0]|0)+h+(l[E+Q>>0]|0)|0;g=((l[E+-1>>0]|0)<<1)+g|0;n=(l[E+-2>>0]|0)+n+(l[E>>0]|0)|0}if((y|0)<(w|0)){f=f+1|0;h=(l[E+S>>0]|0)+h+(l[E+T>>0]|0)|0;g=((l[E+1>>0]|0)<<1)+g|0;n=(l[E+2>>0]|0)+n+(l[E>>0]|0)|0}if((s|0)<(w|0)){f=f+1|0;h=((l[E+S>>0]|0)<<1)+h|0;g=(m[D+(pa<<1)>>1]|0)+g|0;n=(l[E+oa>>0]|0)+n+(l[E>>0]|0)|0}if((t|0)<(w|0)){f=f+1|0;h=((l[E+Q>>0]|0)<<1)+h|0;g=(m[b+(ra<<1)>>1]|0)+g|0;n=(l[E+qa>>0]|0)+n+(l[E>>0]|0)|0}if((v|0)<(w|0)){f=f+1|0;h=((l[E+S>>0]|0)<<1)+h|0;g=(m[D+(ra<<1)>>1]|0)+g|0;n=(l[E+sa>>0]|0)+n+(l[E>>0]|0)|0}if((x|0)<(w|0)){y=i[E>>0]|0;p=f+1|0;h=((l[E+S>>0]|0)<<1)+h|0;g=(m[b+(pa<<1)>>1]|0)+g|0;n=(l[E+ta>>0]|0)+n+(y&255)|0;f=y}else{p=f;f=i[E>>0]|0}f=f&255;B=+o[63136+(p<<2)>>2];A=+(g-n|0)*B;g=(o[u>>2]=A,k[u>>2]|0);do if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;A=g?A+-8388608.0+8388608.0:A+8388608.0+-8388608.0;if(!(A==0.0))break;A=g?-0.0:0.0}while(0);p=~~A+f|0;A=+(h-n|0)*B;g=(o[u>>2]=A,k[u>>2]|0);do if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;A=g?A+-8388608.0+8388608.0:A+8388608.0+-8388608.0;if(!(A==0.0))break;A=g?-0.0:0.0}while(0);h=~~A+f|0;g=p}i[c+e>>0]=h>>>0<256?h:(h|0)>0?255:0;i[c+1>>0]=g>>>0<256?g:(g|0)>0?255:0;i[c+G>>0]=f>>>0<256?f:(f|0)>0?255:0;F=F+1|0;if((F|0)==(M|0)){e=G;break}else{z=z^1;b=b+2|0;C=C+2|0;D=D+2|0;c=c+3|0;E=E+1|0}}}else e=e^2;F=V+H|0;G=H+W|0;D=La+(H+5)|0;i[D>>0]=i[La+(H+8)>>0]|0;i[La+G>>0]=i[La+F>>0]|0;c=La+(H+4)|0;i[c>>0]=i[La+(H+7)>>0]|0;i[La+(G+1)>>0]=i[La+(F+1)>>0]|0;E=La+(H+3)|0;i[E>>0]=i[La+(H+6)>>0]|0;i[La+(G+2)>>0]=i[La+(F+2)>>0]|0;i[La+(H+2)>>0]=i[D>>0]|0;i[La+(G+3)>>0]=i[La+(F+3)>>0]|0;i[La+(H+1)>>0]=i[c>>0]|0;i[La+(G+4)>>0]=i[La+(F+4)>>0]|0;i[I>>0]=i[E>>0]|0;i[La+(G+5)>>0]=i[La+(F+5)>>0]|0;K=K+1|0;if((K|0)==(Ba|0))break;else J=J^1}}if((Ka|0)>0){g=Ma<<1;h=aa(Ja+-5|0,Ma)|0;n=aa(Ja+-1|0,Ma)|0;p=aa(Ja+-2|0,Ma)|0;f=aa(Ja+-3|0,Ma)|0;e=aa(Ba,Ma)|0;a=0;do{Ja=i[La+(a+g)>>0]|0;i[La+(a+Ma)>>0]=Ja;i[La+a>>0]=Ja;Ja=i[La+(a+h)>>0]|0;i[La+(a+n)>>0]=Ja;i[La+(a+p)>>0]=Ja;i[La+(a+f)>>0]=Ja;i[La+(a+e)>>0]=Ja;a=a+1|0}while((a|0)!=(Ka|0))}a=k[Qa>>2]|0;if((a|0)!=(Na|0)){if(a|0)ggb(a);k[Qa>>2]=Na;k[Oa>>2]=520}}while(0);f=Pa+36|0;a=k[f>>2]|0;if(a|0?(Oa=a+12|0,Qa=k[Oa>>2]|0,k[Oa>>2]=Qa+-1,(Qa|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[Pa+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;Qa=Pa+16|0;e=Pa+4|0;k[Qa>>2]=0;k[Qa+4>>2]=0;k[Qa+8>>2]=0;k[Qa+12>>2]=0;if((k[e>>2]|0)>0){f=k[Pa+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[Pa+44>>2]|0;if(!((a|0)==(Pa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break}case 138:case 137:case 136:case 135:{f=(d|0)<1?3:d;if(!((f|0)==3&(h|0)==0)){k[Qa>>2]=0;a=Qa+4|0;k[a>>2]=0;e=ZT(28)|0;k[e>>2]=1;v=e+4|0;k[Qa>>2]=v;k[a>>2]=20;i[e+24>>0]=0;g=244649;w=v+20|0;do{i[v>>0]=i[g>>0]|0;v=v+1|0;g=g+1|0}while((v|0)<(w|0));Y8(-215,Qa,244399,244411,1675);k[a>>2]=0;k[Qa>>2]=0;Pa=k[e>>2]|0;k[e>>2]=Pa+-1;if((Pa|0)==1)ggb(k[e+-4>>2]|0)}k[x>>2]=p;k[x+4>>2]=s;x2(b,x,n|(f<<3)+-8,0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[Qa>>2]=k[g>>2];s=Qa+4|0;a=g+4|0;k[s>>2]=k[a>>2];Pa=Qa+8|0;k[Pa>>2]=k[g+8>>2];k[Qa+12>>2]=k[g+12>>2];k[Qa+16>>2]=k[g+16>>2];k[Qa+20>>2]=k[g+20>>2];k[Qa+24>>2]=k[g+24>>2];k[Qa+28>>2]=k[g+28>>2];k[Qa+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Qa+36>>2]=e;f=Qa+40|0;k[f>>2]=Pa;Pa=Qa+48|0;n=Qa+44|0;k[n>>2]=Pa;k[Qa+52>>2]=0;k[Pa>>2]=0;if(e|0){Pa=e+12|0;k[Pa>>2]=(k[Pa>>2]|0)+1}if((k[a>>2]|0)<3){Oa=k[g+44>>2]|0;Pa=k[n>>2]|0;k[Pa>>2]=k[Oa>>2];k[Pa+4>>2]=k[Oa+4>>2];break}k[s>>2]=0;x1(Qa,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){p=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[n>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[p+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else Q1(Qa,b,-1);while(0);KG(Wa,Qa)|0;f=Qa+36|0;a=k[f>>2]|0;if(a|0?(Oa=a+12|0,Pa=k[Oa>>2]|0,k[Oa>>2]=Pa+-1,(Pa|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[Qa+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;Pa=Qa+16|0;e=Qa+4|0;k[Pa>>2]=0;k[Pa+4>>2]=0;k[Pa+8>>2]=0;k[Pa+12>>2]=0;if((k[e>>2]|0)>0){f=k[Qa+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[Qa+44>>2]|0;if(!((a|0)==(Qa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);if(C){e=k[q>>2]|0;a=k[e+4>>2]|0;e=k[e>>2]|0;if((a|0)<3|(e|0)<3){k[Qa>>2]=0;k[Qa+4>>2]=0;k[Qa+8>>2]=0;k[Qa+12>>2]=0;k[Qa+16>>2]=0;k[Qa+20>>2]=0;k[Qa+24>>2]=0;k[Qa+28>>2]=0;oY(Wa,Qa);break a}v=a+-2|0;w=e+-2|0;if((e|0)>2){d=(c+-135|0)>>>0<2&1;t=(c|2|0)==138&1;k[Qa>>2]=63200;g=Qa+4|0;k[g>>2]=k[Xa>>2];s=Qa+8|0;e=Xa+4|0;a=k[e>>2]|0;k[s>>2]=a;Pa=Qa+12|0;k[Pa>>2]=k[Xa+8>>2];k[Qa+16>>2]=k[Xa+12>>2];k[Qa+20>>2]=k[Va>>2];k[Qa+24>>2]=k[Xa+20>>2];k[Qa+28>>2]=k[Xa+24>>2];k[Qa+32>>2]=k[Xa+28>>2];k[Qa+36>>2]=k[Xa+32>>2];f=k[Xa+36>>2]|0;k[Qa+40>>2]=f;n=Qa+44|0;k[n>>2]=Pa;Pa=Qa+52|0;p=Qa+48|0;k[p>>2]=Pa;k[Qa+56>>2]=0;k[Pa>>2]=0;if(f){a=f+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[e>>2]|0}if((a|0)>=3){k[s>>2]=0;x1(g,a,0,0,0);if((k[s>>2]|0)>0){h=k[Xa+40>>2]|0;f=k[n>>2]|0;g=k[Xa+44>>2]|0;e=k[p>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[e+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else{Oa=k[Xa+44>>2]|0;Pa=k[p>>2]|0;k[Pa>>2]=k[Oa>>2];k[Pa+4>>2]=k[Oa+4>>2]}g=Qa+60|0;k[g>>2]=k[Wa>>2];s=Qa+64|0;e=k[Sa>>2]|0;k[s>>2]=e;Pa=Qa+68|0;k[Pa>>2]=k[E>>2];k[Qa+72>>2]=k[Wa+12>>2];a=Wa+16|0;k[Qa+76>>2]=k[a>>2];k[Qa+80>>2]=k[Wa+20>>2];k[Qa+84>>2]=k[Wa+24>>2];k[Qa+88>>2]=k[Wa+28>>2];k[Qa+92>>2]=k[Wa+32>>2];f=k[Wa+36>>2]|0;k[Qa+96>>2]=f;h=Qa+100|0;k[h>>2]=Pa;Pa=Qa+108|0;p=Qa+104|0;k[p>>2]=Pa;k[Qa+112>>2]=0;k[Pa>>2]=0;if(f){e=f+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[Sa>>2]|0}if((e|0)>=3){k[s>>2]=0;x1(g,e,0,0,0);if((k[s>>2]|0)>0){n=k[Ra>>2]|0;g=k[h>>2]|0;h=k[Ta>>2]|0;f=k[p>>2]|0;e=0;do{k[g+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[h+(e<<2)>>2];e=e+1|0}while((e|0)<(k[s>>2]|0))}}else{Oa=k[Ta>>2]|0;Pa=k[p>>2]|0;k[Pa>>2]=k[Oa>>2];k[Pa+4>>2]=k[Oa+4>>2]}k[Qa+116>>2]=v;k[Qa+120>>2]=w;k[Qa+124>>2]=d;k[Qa+128>>2]=t;k[F>>2]=0;k[F+4>>2]=w;jh[k[(k[Qa>>2]|0)+8>>2]&1023](Qa,F);cfa(Qa)}else a=Wa+16|0;n=k[Ra>>2]|0;Qa=k[n>>2]|0;e=k[Wa>>2]|0;n=aa((e>>>3&511)+1|0,k[n+4>>2]|0)|0;e=((k[Ua>>2]|0)>>>0)/((1212424721>>>(e<<2&28)&15)>>>0)|0;g=k[a>>2]|0;h=g+(aa(e,Qa+-1|0)|0)|0;a=(n|0)>0;if((Qa|0)<=2){if(a)a=0;else break a;while(1){i[h+a>>0]=0;i[g+a>>0]=0;a=a+1|0;if((a|0)==(n|0))break a}}if(!a)break a;f=g+e|0;e=h+(0-e)|0;a=0;while(1){i[g+a>>0]=i[f+a>>0]|0;i[h+a>>0]=i[e+a>>0]|0;a=a+1|0;if((a|0)==(n|0))break a}}if(!D){k[Qa>>2]=0;a=Qa+4|0;k[a>>2]=0;e=ZT(80)|0;k[e>>2]=1;v=e+4|0;k[Qa>>2]=v;k[a>>2]=74;i[e+78>>0]=0;g=244670;w=v+74|0;do{i[v>>0]=i[g>>0]|0;v=v+1|0;g=g+1|0}while((v|0)<(w|0));Y8(-210,Qa,244399,244411,1684);k[a>>2]=0;k[Qa>>2]=0;Qa=k[e>>2]|0;k[e>>2]=Qa+-1;if((Qa|0)==1)ggb(k[e+-4>>2]|0);break a}e=k[q>>2]|0;a=k[e+4>>2]|0;e=k[e>>2]|0;if((a|0)<3|(e|0)<3){k[Qa>>2]=0;k[Qa+4>>2]=0;k[Qa+8>>2]=0;k[Qa+12>>2]=0;k[Qa+16>>2]=0;k[Qa+20>>2]=0;k[Qa+24>>2]=0;k[Qa+28>>2]=0;oY(Wa,Qa);break a}v=a+-2|0;w=e+-2|0;if((e|0)>2){d=(c+-135|0)>>>0<2&1;t=(c|2|0)==138&1;k[Qa>>2]=63180;g=Qa+4|0;k[g>>2]=k[Xa>>2];s=Qa+8|0;e=Xa+4|0;a=k[e>>2]|0;k[s>>2]=a;Pa=Qa+12|0;k[Pa>>2]=k[Xa+8>>2];k[Qa+16>>2]=k[Xa+12>>2];k[Qa+20>>2]=k[Va>>2];k[Qa+24>>2]=k[Xa+20>>2];k[Qa+28>>2]=k[Xa+24>>2];k[Qa+32>>2]=k[Xa+28>>2];k[Qa+36>>2]=k[Xa+32>>2];f=k[Xa+36>>2]|0;k[Qa+40>>2]=f;n=Qa+44|0;k[n>>2]=Pa;Pa=Qa+52|0;p=Qa+48|0;k[p>>2]=Pa;k[Qa+56>>2]=0;k[Pa>>2]=0;if(f){a=f+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[e>>2]|0}if((a|0)>=3){k[s>>2]=0;x1(g,a,0,0,0);if((k[s>>2]|0)>0){h=k[Xa+40>>2]|0;f=k[n>>2]|0;g=k[Xa+44>>2]|0;e=k[p>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[e+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else{Oa=k[Xa+44>>2]|0;Pa=k[p>>2]|0;k[Pa>>2]=k[Oa>>2];k[Pa+4>>2]=k[Oa+4>>2]}g=Qa+60|0;k[g>>2]=k[Wa>>2];s=Qa+64|0;e=k[Sa>>2]|0;k[s>>2]=e;Pa=Qa+68|0;k[Pa>>2]=k[E>>2];k[Qa+72>>2]=k[Wa+12>>2];a=Wa+16|0;k[Qa+76>>2]=k[a>>2];k[Qa+80>>2]=k[Wa+20>>2];k[Qa+84>>2]=k[Wa+24>>2];k[Qa+88>>2]=k[Wa+28>>2];k[Qa+92>>2]=k[Wa+32>>2];f=k[Wa+36>>2]|0;k[Qa+96>>2]=f;h=Qa+100|0;k[h>>2]=Pa;Pa=Qa+108|0;p=Qa+104|0;k[p>>2]=Pa;k[Qa+112>>2]=0;k[Pa>>2]=0;if(f){e=f+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[Sa>>2]|0}if((e|0)>=3){k[s>>2]=0;x1(g,e,0,0,0);if((k[s>>2]|0)>0){n=k[Ra>>2]|0;g=k[h>>2]|0;h=k[Ta>>2]|0;f=k[p>>2]|0;e=0;do{k[g+(e<<2)>>2]=k[n+(e<<2)>>2];k[f+(e<<2)>>2]=k[h+(e<<2)>>2];e=e+1|0}while((e|0)<(k[s>>2]|0))}}else{Oa=k[Ta>>2]|0;Pa=k[p>>2]|0;k[Pa>>2]=k[Oa>>2];k[Pa+4>>2]=k[Oa+4>>2]}k[Qa+116>>2]=v;k[Qa+120>>2]=w;k[Qa+124>>2]=d;k[Qa+128>>2]=t;k[F>>2]=0;k[F+4>>2]=w;jh[k[(k[Qa>>2]|0)+8>>2]&1023](Qa,F);dfa(Qa)}else a=Wa+16|0;n=k[Ra>>2]|0;Qa=k[n>>2]|0;e=k[Wa>>2]|0;n=aa((e>>>3&511)+1|0,k[n+4>>2]|0)|0;e=((k[Ua>>2]|0)>>>0)/((1212424721>>>(e<<2&28)&15)>>>0)|0;g=k[a>>2]|0;h=g+((aa(e,Qa+-1|0)|0)<<1)|0;a=(n|0)>0;if((Qa|0)<=2){if(a)a=0;else break a;while(1){j[h+(a<<1)>>1]=0;j[g+(a<<1)>>1]=0;a=a+1|0;if((a|0)==(n|0))break a}}if(a){f=g+(e<<1)|0;e=h+(0-e<<1)|0;a=0;do{j[g+(a<<1)>>1]=j[f+(a<<1)>>1]|0;j[h+(a<<1)>>1]=j[e+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(n|0))}break}default:{k[Qa>>2]=0;a=Qa+4|0;k[a>>2]=0;e=ZT(48)|0;k[e>>2]=1;v=e+4|0;k[Qa>>2]=v;k[a>>2]=43;i[e+47>>0]=0;g=244745;w=v+43|0;do{i[v>>0]=i[g>>0]|0;v=v+1|0;g=g+1|0}while((v|0)<(w|0));Y8(-206,Qa,244399,244411,1689);k[a>>2]=0;k[Qa>>2]=0;Qa=k[e>>2]|0;k[e>>2]=Qa+-1;if((Qa|0)==1)ggb(k[e+-4>>2]|0)}}while(0);f=Wa+36|0;a=k[f>>2]|0;if(a|0?(Pa=a+12|0,Qa=k[Pa>>2]|0,k[Pa>>2]=Qa+-1,(Qa|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[Wa+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;Wa=Wa+16|0;k[Wa>>2]=0;k[Wa+4>>2]=0;k[Wa+8>>2]=0;k[Wa+12>>2]=0;if((k[Sa>>2]|0)>0){e=k[Ra>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Sa>>2]|0))}a=k[Ta>>2]|0;if(!((a|0)==(Ua|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=Xa+36|0;a=k[f>>2]|0;if(a|0?(Ua=a+12|0,Wa=k[Ua>>2]|0,k[Ua>>2]=Wa+-1,(Wa|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[Xa+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;f=Xa+4|0;k[Va>>2]=0;k[Va+4>>2]=0;k[Va+8>>2]=0;k[Va+12>>2]=0;if((k[f>>2]|0)>0){e=k[q>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[Xa+44>>2]|0;if((a|0)==(Xa+48|0)|(a|0)==0){r=Ya;return}ggb(k[a+-4>>2]|0);r=Ya;return}function _ea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=63280;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function $ea(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=63260;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function afa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;v=r;r=r+144|0;q=v+136|0;s=v;u=k[b+48>>2]|0;g=a+40|0;o=k[g>>2]|0;p=k[o>>2]|0;t=((k[b>>2]|0)>>>3&511)+1|0;n=p+-2|0;o=(k[o+4>>2]|0)+-2|0;if((p|0)>2){p=((c|0)==47|(c|0)==49)&1;m=(c|1|0)==47?-1:1;k[q>>2]=0;k[q+4>>2]=n;k[s>>2]=63240;f=s+4|0;k[f>>2]=k[a>>2];l=s+8|0;d=a+4|0;c=k[d>>2]|0;k[l>>2]=c;w=s+12|0;k[w>>2]=k[a+8>>2];k[s+16>>2]=k[a+12>>2];k[s+20>>2]=k[a+16>>2];k[s+24>>2]=k[a+20>>2];k[s+28>>2]=k[a+24>>2];k[s+32>>2]=k[a+28>>2];k[s+36>>2]=k[a+32>>2];e=k[a+36>>2]|0;k[s+40>>2]=e;h=s+44|0;k[h>>2]=w;w=s+52|0;j=s+48|0;k[j>>2]=w;k[s+56>>2]=0;k[w>>2]=0;if(e){c=e+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[d>>2]|0}if((c|0)>=3){k[l>>2]=0;x1(f,c,0,0,0);if((k[l>>2]|0)>0){g=k[g>>2]|0;f=k[h>>2]|0;e=k[a+44>>2]|0;d=k[j>>2]|0;c=0;do{k[f+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[l>>2]|0))}}else{l=k[a+44>>2]|0;w=k[j>>2]|0;k[w>>2]=k[l>>2];k[w+4>>2]=k[l+4>>2]}g=s+60|0;k[g>>2]=k[b>>2];l=s+64|0;f=b+4|0;d=k[f>>2]|0;k[l>>2]=d;w=s+68|0;k[w>>2]=k[b+8>>2];k[s+72>>2]=k[b+12>>2];c=b+16|0;k[s+76>>2]=k[c>>2];k[s+80>>2]=k[b+20>>2];k[s+84>>2]=k[b+24>>2];k[s+88>>2]=k[b+28>>2];k[s+92>>2]=k[b+32>>2];e=k[b+36>>2]|0;k[s+96>>2]=e;a=s+100|0;k[a>>2]=w;w=s+108|0;j=s+104|0;k[j>>2]=w;k[s+112>>2]=0;k[w>>2]=0;if(e){d=e+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[f>>2]|0}if((d|0)>=3){k[l>>2]=0;x1(g,d,0,0,0);if((k[l>>2]|0)>0){h=k[b+40>>2]|0;f=k[a>>2]|0;g=k[b+44>>2]|0;e=k[j>>2]|0;d=0;do{k[f+(d<<2)>>2]=k[h+(d<<2)>>2];k[e+(d<<2)>>2]=k[g+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else{l=k[b+44>>2]|0;w=k[j>>2]|0;k[w>>2]=k[l>>2];k[w+4>>2]=k[l+4>>2]}k[s+116>>2]=p;k[s+120>>2]=m;k[s+124>>2]=o;k[s+128>>2]=n;jh[k[(k[s>>2]|0)+8>>2]&1023](s,q);kfa(s)}else c=b+16|0;f=k[b+40>>2]|0;d=k[f>>2]|0;g=k[c>>2]|0;f=aa(k[f+4>>2]|0,t)|0;c=(f|0)>0;if((d|0)>2){if(!c){r=v;return}e=aa(d+-2|0,u)|0;d=aa(d+-1|0,u)|0;c=0;do{i[g+c>>0]=i[g+(c+u)>>0]|0;i[g+(d+c)>>0]=i[g+(e+c)>>0]|0;c=c+1|0}while((c|0)!=(f|0));r=v;return}if(!c){r=v;return}c=aa(d+-1|0,u)|0;i[g+c>>0]=0;i[g>>0]=0;if((f|0)==1){r=v;return}else d=1;do{i[g+(c+d)>>0]=0;i[g+d>>0]=0;d=d+1|0}while((d|0)!=(f|0));r=v;return}function bfa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=63220;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function cfa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=63200;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function dfa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=63180;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function efa(a){a=a|0;dfa(a);ggb(a);return}function ffa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=k[a+60>>2]|0;f=e>>>3&511;z=f+1|0;A=z<<1;y=((k[a+52>>2]|0)>>>0)/((1212424721>>>(k[a+4>>2]<<2&28)&15)>>>0)|0;c=k[a+108>>2]|0;e=(c>>>0)/((1212424721>>>(e<<2&28)&15)>>>0)|0;g=k[b>>2]|0;d=g+1|0;h=g&1;x=k[b+4>>2]|0;if((g|0)>=(x|0))return;b=(k[a+76>>2]|0)+(aa(d,c)|0)+(z<<1)|0;c=(k[a+20>>2]|0)+(aa(k[k[a+48>>2]>>2]|0,d)|0)+2|0;u=0-y|0;v=k[a+116>>2]|0;w=A-e|0;p=z-e|0;q=~y;r=1-y|0;s=y+-1|0;t=y+1|0;o=(f<<2)+4|0;n=h^k[a+124>>2];l=h^k[a+128>>2];while(1){if(!l)e=1;else{e=n<<1;j[b+(e<<1)>>1]=((m[c+(y<<1)>>1]|0)+(m[c+(u<<1)>>1]|0)|0)>>>1;j[b+2>>1]=j[c>>1]|0;i=c+2|0;j[b+(2-e<<1)>>1]=((m[i>>1]|0)+(m[c+-2>>1]|0)|0)>>>1;e=2;b=b+(z<<1)|0;c=i}d=(e|0)<(v|0);if(!n){if(d){f=e+2|0;a=(((v|0)>(f|0)?v:f)+-1-e|0)>>>1;i=b+(A<<1)|0;h=aa(o,a)|0;d=c;while(1){D=d+(r<<1)|0;C=d+(t<<1)|0;j[b>>1]=((m[d+(q<<1)>>1]|0)+2+(m[D>>1]|0)+(m[d+(s<<1)>>1]|0)+(m[C>>1]|0)|0)>>>2;E=m[d+-2>>1]|0;B=d+2|0;F=m[B>>1]|0;J=E-F|0;G=m[d+(y<<1)>>1]|0;H=m[d+(u<<1)>>1]|0;I=G-H|0;j[b+2>>1]=(((((J|0)>-1?J:0-J|0)|0)>(((I|0)>-1?I:0-I|0)|0)?H+G|0:F+E|0)+1|0)>>>1;j[b+4>>1]=j[d>>1]|0;j[b+6>>1]=((m[D>>1]|0)+1+(m[C>>1]|0)|0)>>>1;j[b+8>>1]=j[B>>1]|0;B=d;d=d+4|0;j[b+10>>1]=((m[B>>1]|0)+1+(m[d>>1]|0)|0)>>>1;e=e+2|0;if((e|0)>=(v|0))break;else b=b+(A<<1)|0}J=a<<1;e=f+J|0;b=i+h|0;c=c+4+(J<<1)|0}}else if(d){f=e+2|0;a=(((v|0)>(f|0)?v:f)+-1-e|0)>>>1;i=b+(A<<1)|0;h=aa(o,a)|0;d=c;while(1){j[b>>1]=j[d>>1]|0;I=m[d+-2>>1]|0;H=d+2|0;J=m[H>>1]|0;D=I-J|0;G=m[d+(y<<1)>>1]|0;F=m[d+(u<<1)>>1]|0;E=G-F|0;j[b+2>>1]=(((((D|0)>-1?D:0-D|0)|0)>(((E|0)>-1?E:0-E|0)|0)?F+G|0:J+I|0)+1|0)>>>1;I=d+(r<<1)|0;J=d+(t<<1)|0;j[b+4>>1]=((m[I>>1]|0)+(m[d+(q<<1)>>1]|0)+(m[d+(s<<1)>>1]|0)+(m[J>>1]|0)|0)>>>2;G=d;d=d+4|0;j[b+6>>1]=((m[G>>1]|0)+1+(m[d>>1]|0)|0)>>>1;j[b+8>>1]=j[H>>1]|0;j[b+10>>1]=((m[I>>1]|0)+1+(m[J>>1]|0)|0)>>>1;e=e+2|0;if((e|0)>=(v|0))break;else b=b+(A<<1)|0}J=a<<1;e=f+J|0;b=i+h|0;c=c+4+(J<<1)|0}if((e|0)>(v|0))d=b;else{d=n<<1;j[b+(d<<1)>>1]=((m[c+(q<<1)>>1]|0)+2+(m[c+(r<<1)>>1]|0)+(m[c+(s<<1)>>1]|0)+(m[c+(t<<1)>>1]|0)|0)>>>2;I=m[c+-2>>1]|0;J=c+2|0;H=m[J>>1]|0;D=I-H|0;G=m[c+(y<<1)>>1]|0;F=m[c+(u<<1)>>1]|0;E=G-F|0;j[b+2>>1]=(((((D|0)>-1?D:0-D|0)|0)>(((E|0)>-1?E:0-E|0)|0)?F+G|0:H+I|0)+1|0)>>>1;j[b+(2-d<<1)>>1]=j[c>>1]|0;d=b+(z<<1)|0;c=J}b=0;do{j[d+(b<<1)>>1]=j[d+(b-z<<1)>>1]|0;j[d+(p+b<<1)>>1]=j[d+(w+b<<1)>>1]|0;b=b+1|0}while((b|0)!=(z|0));g=g+1|0;if((g|0)==(x|0))break;else{b=d+(A<<1)|0;c=c+4|0;n=n^1;l=l^1}}return}function gfa(a){a=a|0;cfa(a);ggb(a);return}function hfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=k[a+60>>2]|0;v=(d>>>3&511)+1|0;w=v<<1;u=((k[a+52>>2]|0)>>>0)/((1212424721>>>(k[a+4>>2]<<2&28)&15)>>>0)|0;c=k[a+108>>2]|0;d=(c>>>0)/((1212424721>>>(d<<2&28)&15)>>>0)|0;e=k[b>>2]|0;f=e+1|0;g=e&1;t=b+4|0;if((e|0)>=(k[t>>2]|0))return;c=(k[a+76>>2]|0)+(aa(f,c)|0)+v|0;q=0-u|0;r=a+116|0;s=w-d|0;j=v-d|0;m=~u;n=1-u|0;o=u+-1|0;p=u+1|0;b=(k[a+20>>2]|0)+(aa(k[k[a+48>>2]>>2]|0,f)|0)+1|0;h=g^k[a+124>>2];g=g^k[a+128>>2];while(1){if(!g)a=1;else{a=h<<1;i[c+a>>0]=((l[b+u>>0]|0)+(l[b+q>>0]|0)|0)>>>1;i[c+1>>0]=i[b>>0]|0;f=b+1|0;i[c+(2-a)>>0]=((l[f>>0]|0)+(l[b+-1>>0]|0)|0)>>>1;a=2;c=c+v|0;b=f}d=k[r>>2]|0;f=(a|0)<(d|0);if(!h){if(f)while(1){x=b+n|0;d=b+p|0;i[c>>0]=((l[b+m>>0]|0)+2+(l[x>>0]|0)+(l[b+o>>0]|0)+(l[d>>0]|0)|0)>>>2;y=l[b+-1>>0]|0;f=b+1|0;z=l[f>>0]|0;D=y-z|0;A=l[b+u>>0]|0;B=l[b+q>>0]|0;C=A-B|0;i[c+1>>0]=(((((D|0)>-1?D:0-D|0)|0)>(((C|0)>-1?C:0-C|0)|0)?B+A|0:z+y|0)+1|0)>>>1;i[c+2>>0]=i[b>>0]|0;i[c+3>>0]=((l[x>>0]|0)+1+(l[d>>0]|0)|0)>>>1;i[c+4>>0]=i[f>>0]|0;f=b+2|0;i[c+5>>0]=((l[b>>0]|0)+1+(l[f>>0]|0)|0)>>>1;b=a+2|0;c=c+w|0;d=k[r>>2]|0;if((b|0)<(d|0)){a=b;b=f}else{a=b;b=f;break}}}else if(f)while(1){i[c>>0]=i[b>>0]|0;D=l[b+-1>>0]|0;C=b+1|0;d=l[C>>0]|0;z=D-d|0;f=l[b+u>>0]|0;B=l[b+q>>0]|0;A=f-B|0;i[c+1>>0]=(((((z|0)>-1?z:0-z|0)|0)>(((A|0)>-1?A:0-A|0)|0)?B+f|0:d+D|0)+1|0)>>>1;D=b+n|0;d=b+p|0;i[c+2>>0]=((l[D>>0]|0)+(l[b+m>>0]|0)+(l[b+o>>0]|0)+(l[d>>0]|0)|0)>>>2;f=b+2|0;i[c+3>>0]=((l[b>>0]|0)+1+(l[f>>0]|0)|0)>>>1;i[c+4>>0]=i[C>>0]|0;i[c+5>>0]=((l[D>>0]|0)+1+(l[d>>0]|0)|0)>>>1;b=a+2|0;c=c+w|0;d=k[r>>2]|0;if((b|0)<(d|0)){a=b;b=f}else{a=b;b=f;break}}if((a|0)>(d|0))d=b;else{D=h<<1;i[c+D>>0]=((l[b+m>>0]|0)+2+(l[b+n>>0]|0)+(l[b+o>>0]|0)+(l[b+p>>0]|0)|0)>>>2;C=l[b+-1>>0]|0;d=b+1|0;B=l[d>>0]|0;x=C-B|0;A=l[b+u>>0]|0;z=l[b+q>>0]|0;y=A-z|0;i[c+1>>0]=(((((x|0)>-1?x:0-x|0)|0)>(((y|0)>-1?y:0-y|0)|0)?z+A|0:B+C|0)+1|0)>>>1;i[c+(2-D)>>0]=i[b>>0]|0;c=c+v|0}b=0;do{i[c+b>>0]=i[c+(b-v)>>0]|0;i[c+(j+b)>>0]=i[c+(s+b)>>0]|0;b=b+1|0}while((b|0)!=(v|0));e=e+1|0;if((e|0)>=(k[t>>2]|0))break;else{c=c+w|0;b=d+2|0;h=h^1;g=g^1}}return}function ifa(a){a=a|0;bfa(a);ggb(a);return}function jfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;Q=((k[a+60>>2]|0)>>>3&511)+1|0;R=Q<<1;c=k[a+52>>2]|0;O=c>>>1;d=k[b>>2]|0;P=(k[a+108>>2]|0)>>>1;f=k[a+120>>2]|0;e=k[a+116>>2]|0;g=(d&1|0)==0;N=k[b+4>>2]|0;if((d|0)>=(N|0))return;n=(k[a+76>>2]|0)+((aa(P,d+1|0)|0)<<1)+(Q<<1)+2|0;l=(k[a+20>>2]|0)+((aa(d,O)|0)<<1)|0;I=k[a+124>>2]|0;J=(I|0)<1;K=(Q|0)==3;L=aa(I,Q)|0;M=L+1|0;o=c|1;p=O+2|0;q=O+1|0;r=(Q|0)==4;s=O<<1;t=s+2|0;u=s|1;v=O+3|0;w=L+-1|0;x=L+2|0;y=I*3|0;z=y+-4|0;A=y+-1|0;B=y+-3|0;C=y+-2|0;D=y+1|0;E=L+-5|0;F=L+-4|0;G=L+-3|0;H=L+-2|0;b=g?e:(e|0)==0&1;a=g?f:0-f|0;while(1){h=l+(I<<1)|0;do if(J){j[n+(M<<1)>>1]=0;j[n+(L<<1)>>1]=0;j[n+(w<<1)>>1]=0;if(K){j[n+-4>>1]=0;j[n+-6>>1]=0;j[n+-8>>1]=0;break}else{j[n+-6>>1]=0;j[n+-8>>1]=0;j[n+-10>>1]=0;j[n+(x<<1)>>1]=-1;j[n+-4>>1]=-1;break}}else{i=(b|0)!=0;if(i){b=l+2|0;g=((m[l+(O<<1)>>1]|0)+1+(m[l+(p<<1)>>1]|0)|0)>>>1;j[n+(0-a<<1)>>1]=((m[b>>1]|0)+1+(m[l+(o<<1)>>1]|0)|0)>>>1;j[n>>1]=j[l+(q<<1)>>1]|0;j[n+(a<<1)>>1]=g;if(r)j[n+4>>1]=-1;c=n+(Q<<1)|0}else{c=n;b=l}e=(a|0)>0;g=h+-4|0;f=b>>>0>g>>>0;do if(K)if(e){if(f)break;while(1){e=b+4|0;T=b+(t<<1)|0;S=b+(p<<1)|0;f=((m[b+2>>1]|0)+2+(m[b+(O<<1)>>1]|0)+(m[S>>1]|0)+(m[b+(u<<1)>>1]|0)|0)>>>2;j[c+-2>>1]=((m[b>>1]|0)+2+(m[e>>1]|0)+(m[b+(s<<1)>>1]|0)+(m[T>>1]|0)|0)>>>2;j[c>>1]=f;f=b+(q<<1)|0;j[c+2>>1]=j[f>>1]|0;f=((m[f>>1]|0)+1+(m[b+(v<<1)>>1]|0)|0)>>>1;j[c+4>>1]=((m[e>>1]|0)+1+(m[T>>1]|0)|0)>>>1;j[c+6>>1]=j[S>>1]|0;j[c+8>>1]=f;c=c+(R<<1)|0;if(e>>>0>g>>>0){b=e;break}else b=e}}else{if(f)break;while(1){e=b+4|0;f=b+(t<<1)|0;S=b+(p<<1)|0;T=((m[b+2>>1]|0)+2+(m[b+(O<<1)>>1]|0)+(m[S>>1]|0)+(m[b+(u<<1)>>1]|0)|0)>>>2;j[c+2>>1]=((m[b>>1]|0)+2+(m[e>>1]|0)+(m[b+(s<<1)>>1]|0)+(m[f>>1]|0)|0)>>>2;j[c>>1]=T;T=b+(q<<1)|0;j[c+-2>>1]=j[T>>1]|0;T=((m[T>>1]|0)+1+(m[b+(v<<1)>>1]|0)|0)>>>1;j[c+8>>1]=((m[e>>1]|0)+1+(m[f>>1]|0)|0)>>>1;j[c+6>>1]=j[S>>1]|0;j[c+4>>1]=T;c=c+(R<<1)|0;if(e>>>0>g>>>0){b=e;break}else b=e}}else if(e){if(f)break;while(1){e=b+4|0;f=b+(t<<1)|0;S=b+(p<<1)|0;T=((m[b+2>>1]|0)+2+(m[b+(O<<1)>>1]|0)+(m[S>>1]|0)+(m[b+(u<<1)>>1]|0)|0)>>>2;j[c+-2>>1]=((m[b>>1]|0)+2+(m[e>>1]|0)+(m[b+(s<<1)>>1]|0)+(m[f>>1]|0)|0)>>>2;j[c>>1]=T;T=b+(q<<1)|0;j[c+2>>1]=j[T>>1]|0;j[c+4>>1]=-1;T=((m[T>>1]|0)+1+(m[b+(v<<1)>>1]|0)|0)>>>1;j[c+6>>1]=((m[e>>1]|0)+1+(m[f>>1]|0)|0)>>>1;j[c+8>>1]=j[S>>1]|0;j[c+10>>1]=T;j[c+12>>1]=-1;c=c+(R<<1)|0;if(e>>>0>g>>>0){b=e;break}else b=e}}else{if(f)break;while(1){e=b+4|0;T=b+(t<<1)|0;U=((m[b>>1]|0)+2+(m[e>>1]|0)+(m[b+(s<<1)>>1]|0)+(m[T>>1]|0)|0)>>>2;S=b+(p<<1)|0;V=((m[b+2>>1]|0)+2+(m[b+(O<<1)>>1]|0)+(m[S>>1]|0)+(m[b+(u<<1)>>1]|0)|0)>>>2;f=b+(q<<1)|0;j[c+-2>>1]=j[f>>1]|0;j[c>>1]=V;j[c+2>>1]=U;j[c+4>>1]=-1;T=((m[e>>1]|0)+1+(m[T>>1]|0)|0)>>>1;j[c+6>>1]=((m[f>>1]|0)+1+(m[b+(v<<1)>>1]|0)|0)>>>1;j[c+8>>1]=j[S>>1]|0;j[c+10>>1]=T;j[c+12>>1]=-1;c=c+(R<<1)|0;if(e>>>0>g>>>0){b=e;break}else b=e}}while(0);if(b>>>0<h>>>0?(V=((m[b+2>>1]|0)+2+(m[b+(O<<1)>>1]|0)+(m[b+(p<<1)>>1]|0)+(m[b+(u<<1)>>1]|0)|0)>>>2,j[c+(0-a<<1)>>1]=((m[b>>1]|0)+2+(m[b+4>>1]|0)+(m[b+(s<<1)>>1]|0)+(m[b+(t<<1)>>1]|0)|0)>>>2,j[c>>1]=V,j[c+(a<<1)>>1]=j[b+(q<<1)>>1]|0,r):0)j[c+4>>1]=-1;b=j[n+-2>>1]|0;if(K){j[n+-8>>1]=b;j[n+-6>>1]=j[n>>1]|0;j[n+-4>>1]=j[n+2>>1]|0;j[n+(A<<1)>>1]=j[n+(z<<1)>>1]|0;j[n+(y<<1)>>1]=j[n+(B<<1)>>1]|0;j[n+(D<<1)>>1]=j[n+(C<<1)>>1]|0}else{j[n+-10>>1]=b;j[n+-8>>1]=j[n>>1]|0;j[n+-6>>1]=j[n+2>>1]|0;j[n+-4>>1]=j[n+4>>1]|0;j[n+(w<<1)>>1]=j[n+(E<<1)>>1]|0;j[n+(L<<1)>>1]=j[n+(F<<1)>>1]|0;j[n+(M<<1)>>1]=j[n+(G<<1)>>1]|0;j[n+(x<<1)>>1]=j[n+(H<<1)>>1]|0}b=i&1^1;a=0-a|0}while(0);d=d+1|0;if((d|0)==(N|0))break;else{n=n+(P<<1)|0;l=l+(O<<1)|0}}return}function kfa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=63240;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function lfa(a){a=a|0;kfa(a);ggb(a);return}function mfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;z=((k[a+60>>2]|0)>>>3&511)+1|0;A=z<<1;B=k[a+52>>2]|0;c=k[b>>2]|0;y=k[a+108>>2]|0;e=k[a+120>>2]|0;d=k[a+116>>2]|0;f=(c&1|0)==0;o=b+4|0;if((c|0)>=(k[o>>2]|0))return;m=(k[a+76>>2]|0)+(aa(c+1|0,y)|0)+z+1|0;p=a+124|0;q=(z|0)==3;r=B<<1;s=r|1;t=B+2|0;u=B+1|0;v=(z|0)==4;w=r+2|0;x=B+3|0;n=c;j=(k[a+20>>2]|0)+(aa(c,B)|0)|0;b=f?d:(d|0)==0&1;a=f?e:0-e|0;while(1){c=k[p>>2]|0;h=j+c|0;do if((c|0)<1){h=m+((aa(c,z)|0)+1)|0;i[h>>0]=0;h=m+(aa(k[p>>2]|0,z)|0)|0;i[h>>0]=0;h=m+((aa(k[p>>2]|0,z)|0)+-1)|0;i[h>>0]=0;if(q){i[m+-2>>0]=0;i[m+-3>>0]=0;i[m+-4>>0]=0;break}else{i[m+-3>>0]=0;i[m+-4>>0]=0;i[m+-5>>0]=0;h=m+((aa(k[p>>2]|0,z)|0)+2)|0;i[h>>0]=-1;i[m+-2>>0]=-1;break}}else{g=(b|0)!=0;if(g){b=j+1|0;f=((l[j+B>>0]|0)+1+(l[j+t>>0]|0)|0)>>>1;i[m+(0-a)>>0]=((l[b>>0]|0)+1+(l[j+s>>0]|0)|0)>>>1;i[m>>0]=i[j+u>>0]|0;i[m+a>>0]=f;if(v)i[m+2>>0]=-1;c=m+z|0}else{c=m;b=j}d=(a|0)>0;f=h+-2|0;e=b>>>0>f>>>0;do if(q)if(d){if(e)break;while(1){d=b+2|0;D=b+w|0;C=b+t|0;e=((l[b+1>>0]|0)+2+(l[b+B>>0]|0)+(l[C>>0]|0)+(l[b+s>>0]|0)|0)>>>2;i[c+-1>>0]=((l[b>>0]|0)+2+(l[d>>0]|0)+(l[b+r>>0]|0)+(l[D>>0]|0)|0)>>>2;i[c>>0]=e;e=b+u|0;i[c+1>>0]=i[e>>0]|0;e=((l[e>>0]|0)+1+(l[b+x>>0]|0)|0)>>>1;i[c+2>>0]=((l[d>>0]|0)+1+(l[D>>0]|0)|0)>>>1;i[c+3>>0]=i[C>>0]|0;i[c+4>>0]=e;c=c+A|0;if(d>>>0>f>>>0){b=d;break}else b=d}}else{if(e)break;while(1){d=b+2|0;e=b+w|0;C=b+t|0;D=((l[b+1>>0]|0)+2+(l[b+B>>0]|0)+(l[C>>0]|0)+(l[b+s>>0]|0)|0)>>>2;i[c+1>>0]=((l[b>>0]|0)+2+(l[d>>0]|0)+(l[b+r>>0]|0)+(l[e>>0]|0)|0)>>>2;i[c>>0]=D;D=b+u|0;i[c+-1>>0]=i[D>>0]|0;D=((l[D>>0]|0)+1+(l[b+x>>0]|0)|0)>>>1;i[c+4>>0]=((l[d>>0]|0)+1+(l[e>>0]|0)|0)>>>1;i[c+3>>0]=i[C>>0]|0;i[c+2>>0]=D;c=c+A|0;if(d>>>0>f>>>0){b=d;break}else b=d}}else if(d){if(e)break;while(1){d=b+2|0;e=b+w|0;C=b+t|0;D=((l[b+1>>0]|0)+2+(l[b+B>>0]|0)+(l[C>>0]|0)+(l[b+s>>0]|0)|0)>>>2;i[c+-1>>0]=((l[b>>0]|0)+2+(l[d>>0]|0)+(l[b+r>>0]|0)+(l[e>>0]|0)|0)>>>2;i[c>>0]=D;D=b+u|0;i[c+1>>0]=i[D>>0]|0;i[c+2>>0]=-1;D=((l[D>>0]|0)+1+(l[b+x>>0]|0)|0)>>>1;i[c+3>>0]=((l[d>>0]|0)+1+(l[e>>0]|0)|0)>>>1;i[c+4>>0]=i[C>>0]|0;i[c+5>>0]=D;i[c+6>>0]=-1;c=c+A|0;if(d>>>0>f>>>0){b=d;break}else b=d}}else{if(e)break;while(1){d=b+2|0;D=b+w|0;E=((l[b>>0]|0)+2+(l[d>>0]|0)+(l[b+r>>0]|0)+(l[D>>0]|0)|0)>>>2;C=b+t|0;F=((l[b+1>>0]|0)+2+(l[b+B>>0]|0)+(l[C>>0]|0)+(l[b+s>>0]|0)|0)>>>2;e=b+u|0;i[c+-1>>0]=i[e>>0]|0;i[c>>0]=F;i[c+1>>0]=E;i[c+2>>0]=-1;D=((l[d>>0]|0)+1+(l[D>>0]|0)|0)>>>1;i[c+3>>0]=((l[e>>0]|0)+1+(l[b+x>>0]|0)|0)>>>1;i[c+4>>0]=i[C>>0]|0;i[c+5>>0]=D;i[c+6>>0]=-1;c=c+A|0;if(d>>>0>f>>>0){b=d;break}else b=d}}while(0);if(b>>>0<h>>>0?(F=((l[b+1>>0]|0)+2+(l[b+B>>0]|0)+(l[b+t>>0]|0)+(l[b+s>>0]|0)|0)>>>2,i[c+(0-a)>>0]=((l[b>>0]|0)+2+(l[b+2>>0]|0)+(l[b+r>>0]|0)+(l[b+w>>0]|0)|0)>>>2,i[c>>0]=F,i[c+a>>0]=i[b+u>>0]|0,v):0)i[c+2>>0]=-1;b=i[m+-1>>0]|0;if(q){i[m+-4>>0]=b;i[m+-3>>0]=i[m>>0]|0;i[m+-2>>0]=i[m+1>>0]|0;F=(k[p>>2]|0)*3|0;i[m+(F+-1)>>0]=i[m+(F+-4)>>0]|0;F=(k[p>>2]|0)*3|0;i[m+F>>0]=i[m+(F+-3)>>0]|0;F=(k[p>>2]|0)*3|0;i[m+(F+1)>>0]=i[m+(F+-2)>>0]|0}else{i[m+-5>>0]=b;i[m+-4>>0]=i[m>>0]|0;i[m+-3>>0]=i[m+1>>0]|0;i[m+-2>>0]=i[m+2>>0]|0;F=aa(k[p>>2]|0,z)|0;i[m+(F+-1)>>0]=i[m+(F+-5)>>0]|0;F=aa(k[p>>2]|0,z)|0;i[m+F>>0]=i[m+(F+-4)>>0]|0;F=aa(k[p>>2]|0,z)|0;i[m+(F+1)>>0]=i[m+(F+-3)>>0]|0;F=aa(k[p>>2]|0,z)|0;i[m+(F+2)>>0]=i[m+(F+-2)>>0]|0}b=g&1^1;a=0-a|0}while(0);n=n+1|0;if((n|0)>=(k[o>>2]|0))break;else{m=m+y|0;j=j+B|0}}return}function nfa(a){a=a|0;$ea(a);ggb(a);return}function ofa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=k[a+52>>2]|0;A=c>>>1;B=(k[a+108>>2]|0)>>>1;h=k[a+132>>2]|0;f=k[a+136>>2]|0;e=k[a+116>>2]|0;d=k[b>>2]|0;g=(d&1|0)==0;z=k[b+4>>2]|0;if((d|0)>=(z|0))return;o=(k[a+76>>2]|0)+(B+1<<1)+((aa(d,B)|0)<<1)|0;n=(k[a+20>>2]|0)+((aa(d,A)|0)<<1)|0;x=k[a+124>>2]|0;y=(x|0)<1;p=c|1;q=A+2|0;r=A+1|0;s=A<<1;t=s+2|0;u=s|1;v=A+3|0;w=x+-1|0;b=g?e:(e|0)==0&1;l=g?f:h;a=g?h:f;while(1){h=n+(x<<1)|0;if(y){j[o+(x<<1)>>1]=0;j[o+-2>>1]=0;c=l}else{i=(b|0)!=0;if(i){b=n+2|0;g=aa((m[n+(p<<1)>>1]|0)+(m[b>>1]|0)|0,l)|0;c=aa((m[n+(q<<1)>>1]|0)+(m[n+(A<<1)>>1]|0)|0,a)|0;j[o>>1]=(g+16384+c+((m[n+(r<<1)>>1]|0)*19234|0)|0)>>>15;c=o+2|0}else{c=o;b=n}f=h+-4|0;if(b>>>0<=f>>>0){g=a<<2;while(1){e=b+4|0;D=b+(t<<1)|0;F=aa((m[e>>1]|0)+(m[b>>1]|0)+(m[b+(s<<1)>>1]|0)+(m[D>>1]|0)|0,l)|0;C=b+(q<<1)|0;E=b+(r<<1)|0;F=(F+32768+(((m[b+(A<<1)>>1]|0)+(m[b+2>>1]|0)+(m[C>>1]|0)+(m[b+(u<<1)>>1]|0)|0)*9617|0)+(aa(g,m[E>>1]|0)|0)|0)>>>16&65535;j[c>>1]=F;D=aa((m[D>>1]|0)+(m[e>>1]|0)|0,l)|0;b=aa((m[b+(v<<1)>>1]|0)+(m[E>>1]|0)|0,a)|0;j[c+2>>1]=(D+16384+b+((m[C>>1]|0)*19234|0)|0)>>>15;c=c+4|0;if(e>>>0>f>>>0){b=e;break}else b=e}}if(b>>>0<h>>>0){F=aa((m[b+4>>1]|0)+(m[b>>1]|0)+(m[b+(s<<1)>>1]|0)+(m[b+(t<<1)>>1]|0)|0,l)|0;F=(F+32768+(((m[b+(A<<1)>>1]|0)+(m[b+2>>1]|0)+(m[b+(q<<1)>>1]|0)+(m[b+(u<<1)>>1]|0)|0)*9617|0)+(aa(a<<2,m[b+(r<<1)>>1]|0)|0)|0)>>>16&65535;j[c>>1]=F}j[o+-2>>1]=j[o>>1]|0;j[o+(x<<1)>>1]=j[o+(w<<1)>>1]|0;c=a;b=i&1^1;a=l}d=d+1|0;if((d|0)==(z|0))break;else{o=o+(B<<1)|0;n=n+(A<<1)|0;l=c}}return}function pfa(a){a=a|0;_ea(a);ggb(a);return}function qfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;x=k[a+52>>2]|0;y=k[a+108>>2]|0;f=k[a+132>>2]|0;g=k[a+136>>2]|0;d=k[a+116>>2]|0;c=k[b>>2]|0;e=(c&1|0)==0;p=b+4|0;if((c|0)>=(k[p>>2]|0))return;q=a+124|0;r=x<<1;s=r|1;t=x+2|0;u=x+1|0;v=r+2|0;w=x+3|0;n=(k[a+76>>2]|0)+(y+1)+(aa(c,y)|0)|0;o=c;m=(k[a+20>>2]|0)+(aa(c,x)|0)|0;b=e?d:(d|0)==0&1;j=e?g:f;a=e?f:g;while(1){c=k[q>>2]|0;h=m+c|0;if((c|0)<1){i[n+c>>0]=0;i[n+-1>>0]=0;c=j}else{g=(b|0)!=0;if(g){b=m+1|0;f=aa((l[m+s>>0]|0)+(l[b>>0]|0)|0,j)|0;c=aa((l[m+t>>0]|0)+(l[m+x>>0]|0)|0,a)|0;i[n>>0]=(f+16384+c+((l[m+u>>0]|0)*19234|0)|0)>>>15;c=n+1|0}else{c=n;b=m}e=h+-2|0;if(b>>>0<=e>>>0){f=a<<2;while(1){d=b+2|0;A=b+v|0;C=aa((l[d>>0]|0)+(l[b>>0]|0)+(l[b+r>>0]|0)+(l[A>>0]|0)|0,j)|0;z=b+t|0;B=b+u|0;C=(C+32768+(((l[b+x>>0]|0)+(l[b+1>>0]|0)+(l[z>>0]|0)+(l[b+s>>0]|0)|0)*9617|0)+(aa(f,l[B>>0]|0)|0)|0)>>>16&255;i[c>>0]=C;A=aa((l[A>>0]|0)+(l[d>>0]|0)|0,j)|0;b=aa((l[b+w>>0]|0)+(l[B>>0]|0)|0,a)|0;i[c+1>>0]=(A+16384+b+((l[z>>0]|0)*19234|0)|0)>>>15;c=c+2|0;if(d>>>0>e>>>0){b=d;break}else b=d}}if(b>>>0<h>>>0){C=aa((l[b+2>>0]|0)+(l[b>>0]|0)+(l[b+r>>0]|0)+(l[b+v>>0]|0)|0,j)|0;C=(C+32768+(((l[b+x>>0]|0)+(l[b+1>>0]|0)+(l[b+t>>0]|0)+(l[b+s>>0]|0)|0)*9617|0)+(aa(a<<2,l[b+u>>0]|0)|0)|0)>>>16&255;i[c>>0]=C}i[n+-1>>0]=i[n>>0]|0;c=k[q>>2]|0;i[n+c>>0]=i[n+(c+-1)>>0]|0;c=a;b=g&1^1;a=j}o=o+1|0;if((o|0)>=(k[p>>2]|0))break;else{n=n+y|0;m=m+x|0;j=c}}return}function rfa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=r;r=r+208|0;D=E+144|0;C=E+88|0;A=E+72|0;B=E+16|0;z=E;if((f+-5|0)>>>0>=2){g=D+4|0;h=ZT(40)|0;k[h>>2]=1;j=h+4|0;k[D>>2]=j;k[g>>2]=34;i[h+38>>0]=0;l=351405;m=j+34|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,D,245373,245209,58);k[g>>2]=0;k[D>>2]=0;y=k[h>>2]|0;k[h>>2]=y+-1;if((y|0)==1)ggb(k[h+-4>>2]|0)}k[D>>2]=3;y=D+4|0;k[y>>2]=1;P1(a,2,D,f,-1,1,0);k[D>>2]=3;k[y>>2]=1;P1(b,2,D,f,-1,1,0);do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[D>>2]=k[j>>2];o=D+4|0;a=j+4|0;k[o>>2]=k[a>>2];y=D+8|0;k[y>>2]=k[j+8>>2];k[D+12>>2]=k[j+12>>2];k[D+16>>2]=k[j+16>>2];k[D+20>>2]=k[j+20>>2];k[D+24>>2]=k[j+24>>2];k[D+28>>2]=k[j+28>>2];k[D+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[D+36>>2]=g;h=D+40|0;k[h>>2]=y;y=D+48|0;m=D+44|0;k[m>>2]=y;k[D+52>>2]=0;k[y>>2]=0;if(g|0){y=g+12|0;k[y>>2]=(k[y>>2]|0)+1}if((k[a>>2]|0)<3){x=k[j+44>>2]|0;y=k[m>>2]|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];break}k[o>>2]=0;x1(D,k[a>>2]|0,0,0,0);if((k[o>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[o>>2]|0))}}else Q1(D,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[C>>2]=k[l>>2];o=C+4|0;g=l+4|0;k[o>>2]=k[g>>2];y=C+8|0;k[y>>2]=k[l+8>>2];k[C+12>>2]=k[l+12>>2];k[C+16>>2]=k[l+16>>2];k[C+20>>2]=k[l+20>>2];k[C+24>>2]=k[l+24>>2];k[C+28>>2]=k[l+28>>2];k[C+32>>2]=k[l+32>>2];a=k[l+36>>2]|0;k[C+36>>2]=a;h=C+40|0;k[h>>2]=y;y=C+48|0;m=C+44|0;k[m>>2]=y;k[C+52>>2]=0;k[y>>2]=0;if(a|0){y=a+12|0;k[y>>2]=(k[y>>2]|0)+1}if((k[g>>2]|0)<3){x=k[l+44>>2]|0;y=k[m>>2]|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2];break}k[o>>2]=0;x1(C,k[g>>2]|0,0,0,0);if((k[o>>2]|0)>0){n=k[l+40>>2]|0;j=k[h>>2]|0;h=k[l+44>>2]|0;g=k[m>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[o>>2]|0))}}else Q1(C,b,-1);while(0);if(!((d|c|0)>-1&(d+c|0)==1)){k[A>>2]=0;a=A+4|0;k[a>>2]=0;g=ZT(40)|0;k[g>>2]=1;j=g+4|0;k[A>>2]=j;k[a>>2]=32;i[g+36>>0]=0;l=245390;m=j+32|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,A,245373,245209,64);k[a>>2]=0;k[A>>2]=0;y=k[g>>2]|0;k[g>>2]=y+-1;if((y|0)==1)ggb(k[g+-4>>2]|0)}w=B+4|0;h=B+8|0;j=B+12|0;t=B+16|0;l=B+20|0;m=B+24|0;n=B+28|0;u=B+40|0;y=B+48|0;x=B+44|0;o=z+4|0;b=o+4|0;v=B+36|0;p=A+4|0;q=A+8|0;s=B+52|0;if(e){switch(c|0){case 0:{k[A>>2]=3;k[p>>2]=10;k[q>>2]=3;break}case 1:{k[A>>2]=-1;k[p>>2]=0;k[q>>2]=1;break}default:{}}e=k[D+8>>2]|0;a=k[D+12>>2]|0;k[w>>2]=2;k[h>>2]=e;k[j>>2]=a;k[t>>2]=A;k[l>>2]=A;g=m+8|0;k[g>>2]=0;k[g+4>>2]=0;k[u>>2]=h;k[x>>2]=y;a=a<<2;k[B>>2]=1124024324;k[y>>2]=a;k[s>>2]=4;e=A+(aa(e,a)|0)|0;k[n>>2]=e;k[m>>2]=e+(0-a)+a;a=b;k[a>>2]=0;k[a+4>>2]=0;k[z>>2]=33619968;k[o>>2]=D;SW(B,z,f,(c|0)==1?1.0:.03125,0.0);a=k[v>>2]|0;if(a|0?(c=a+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){g=k[v>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[B+32>>2]|0;if(!a){a=B1()|0;g=k[v>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[v>>2]=0}k[v>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[w>>2]|0)>0){g=k[u>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[x>>2]|0;if(!((a|0)==(y|0)|(a|0)==0))ggb(k[a+-4>>2]|0);switch(d|0){case 0:{k[A>>2]=3;k[p>>2]=10;k[q>>2]=3;break}case 1:{k[A>>2]=-1;k[p>>2]=0;k[q>>2]=1;break}default:{}}e=k[C+8>>2]|0;a=k[C+12>>2]|0;k[w>>2]=2;k[h>>2]=e;k[j>>2]=a;k[t>>2]=A;k[l>>2]=A;c=m+8|0;k[c>>2]=0;k[c+4>>2]=0;k[u>>2]=h;k[x>>2]=y;a=a<<2;k[B>>2]=1124024324;k[y>>2]=a;k[s>>2]=4;A=A+(aa(e,a)|0)|0;k[n>>2]=A;k[m>>2]=A+(0-a)+a;a=b;k[a>>2]=0;k[a+4>>2]=0;k[z>>2]=33619968;k[o>>2]=C;SW(B,z,f,(d|0)==1?1.0:.03125,0.0);a=k[v>>2]|0;if(a|0?(f=a+12|0,A=k[f>>2]|0,k[f>>2]=A+-1,(A|0)==1):0){g=k[v>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[B+32>>2]|0;if(!a){a=B1()|0;g=k[v>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[v>>2]=0}k[v>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[w>>2]|0)>0){g=k[u>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[x>>2]|0;if(!((a|0)==(y|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else{switch(c|0){case 0:{k[A>>2]=3;k[p>>2]=10;k[q>>2]=3;break}case 1:{k[A>>2]=-1;k[p>>2]=0;k[q>>2]=1;break}default:{}}e=k[D+8>>2]|0;a=k[D+12>>2]|0;k[w>>2]=2;k[h>>2]=e;k[j>>2]=a;k[t>>2]=A;k[l>>2]=A;c=m+8|0;k[c>>2]=0;k[c+4>>2]=0;k[u>>2]=h;k[x>>2]=y;a=a<<2;k[B>>2]=1124024324;k[y>>2]=a;k[s>>2]=4;e=A+(aa(e,a)|0)|0;k[n>>2]=e;k[m>>2]=e+(0-a)+a;a=b;k[a>>2]=0;k[a+4>>2]=0;k[z>>2]=33619968;k[o>>2]=D;SW(B,z,f,1.0,0.0);a=k[v>>2]|0;if(a|0?(c=a+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){g=k[v>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[B+32>>2]|0;if(!a){a=B1()|0;g=k[v>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[v>>2]=0}k[v>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[w>>2]|0)>0){g=k[u>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[x>>2]|0;if(!((a|0)==(y|0)|(a|0)==0))ggb(k[a+-4>>2]|0);switch(d|0){case 0:{k[A>>2]=3;k[p>>2]=10;k[q>>2]=3;break}case 1:{k[A>>2]=-1;k[p>>2]=0;k[q>>2]=1;break}default:{}}d=k[C+8>>2]|0;a=k[C+12>>2]|0;k[w>>2]=2;k[h>>2]=d;k[j>>2]=a;k[t>>2]=A;k[l>>2]=A;e=m+8|0;k[e>>2]=0;k[e+4>>2]=0;k[u>>2]=h;k[x>>2]=y;a=a<<2;k[B>>2]=1124024324;k[y>>2]=a;k[s>>2]=4;A=A+(aa(d,a)|0)|0;k[n>>2]=A;k[m>>2]=A+(0-a)+a;a=b;k[a>>2]=0;k[a+4>>2]=0;k[z>>2]=33619968;k[o>>2]=C;SW(B,z,f,1.0,0.0);a=k[v>>2]|0;if(a|0?(f=a+12|0,A=k[f>>2]|0,k[f>>2]=A+-1,(A|0)==1):0){g=k[v>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[B+32>>2]|0;if(!a){a=B1()|0;g=k[v>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[v>>2]=0}k[v>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[w>>2]|0)>0){g=k[u>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[x>>2]|0;if(!((a|0)==(y|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}h=C+36|0;a=k[h>>2]|0;if(a|0?(A=a+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[C+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;B=C+16|0;g=C+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[g>>2]|0)>0){h=k[C+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[C+44>>2]|0;if(!((a|0)==(C+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=D+36|0;a=k[h>>2]|0;if(a|0?(B=a+12|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[D+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;C=D+16|0;g=D+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[g>>2]|0)>0){h=k[D+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[D+44>>2]|0;if((a|0)==(D+48|0)|(a|0)==0){r=E;return}ggb(k[a+-4>>2]|0);r=E;return}function sfa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;S=r;r=r+192|0;P=S+168|0;R=S+112|0;Q=S+56|0;O=S;M=(e|0)==1;N=(c|0)>0&M?3:e;M=(d|0)>0&M?3:e;if((g+-5|0)>>>0>=2){h=P+4|0;j=ZT(40)|0;k[j>>2]=1;l=j+4|0;k[P>>2]=l;k[h>>2]=34;i[j+38>>0]=0;m=351405;n=l+34|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,P,245193,245209,93);k[h>>2]=0;k[P>>2]=0;L=k[j>>2]|0;k[j>>2]=L+-1;if((L|0)==1)ggb(k[j+-4>>2]|0)}k[P>>2]=N;L=P+4|0;k[L>>2]=1;P1(a,2,P,g,-1,1,0);k[P>>2]=M;k[L>>2]=1;P1(b,2,P,g,-1,1,0);do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[R>>2]=k[l>>2];p=R+4|0;a=l+4|0;k[p>>2]=k[a>>2];L=R+8|0;k[L>>2]=k[l+8>>2];k[R+12>>2]=k[l+12>>2];k[R+16>>2]=k[l+16>>2];k[R+20>>2]=k[l+20>>2];k[R+24>>2]=k[l+24>>2];k[R+28>>2]=k[l+28>>2];k[R+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[R+36>>2]=h;j=R+40|0;k[j>>2]=L;L=R+48|0;n=R+44|0;k[n>>2]=L;k[R+52>>2]=0;k[L>>2]=0;if(h|0){L=h+12|0;k[L>>2]=(k[L>>2]|0)+1}if((k[a>>2]|0)<3){K=k[l+44>>2]|0;L=k[n>>2]|0;k[L>>2]=k[K>>2];k[L+4>>2]=k[K+4>>2];break}k[p>>2]=0;x1(R,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(R,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){m=k[b+4>>2]|0;k[Q>>2]=k[m>>2];p=Q+4|0;h=m+4|0;k[p>>2]=k[h>>2];L=Q+8|0;k[L>>2]=k[m+8>>2];k[Q+12>>2]=k[m+12>>2];k[Q+16>>2]=k[m+16>>2];k[Q+20>>2]=k[m+20>>2];k[Q+24>>2]=k[m+24>>2];k[Q+28>>2]=k[m+28>>2];k[Q+32>>2]=k[m+32>>2];a=k[m+36>>2]|0;k[Q+36>>2]=a;j=Q+40|0;k[j>>2]=L;L=Q+48|0;n=Q+44|0;k[n>>2]=L;k[Q+52>>2]=0;k[L>>2]=0;if(a|0){L=a+12|0;k[L>>2]=(k[L>>2]|0)+1}if((k[h>>2]|0)<3){K=k[m+44>>2]|0;L=k[n>>2]|0;k[L>>2]=k[K>>2];k[L+4>>2]=k[K+4>>2];break}k[p>>2]=0;x1(Q,k[h>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[m+40>>2]|0;l=k[j>>2]|0;j=k[m+44>>2]|0;h=k[n>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(Q,b,-1);while(0);if((e|0)>31|(e&1|0)==0){k[P>>2]=0;a=P+4|0;k[a>>2]=0;h=ZT(56)|0;k[h>>2]=1;l=h+4|0;k[P>>2]=l;k[a>>2]=50;i[h+54>>0]=0;m=245276;n=l+50|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-211,P,245193,245209,101);k[a>>2]=0;k[P>>2]=0;L=k[h>>2]|0;k[h>>2]=L+-1;if((L|0)==1)ggb(k[h+-4>>2]|0)}a=((N|0)<(M|0)?M:N)+1|0;if(!a)a=0;else{if(a>>>0>1073741823)ad(426534,426557,304,426811);j=a<<2;h=(j|0)==0?1:j;while(1){a=fgb(h)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}zpb(a|0,0,j|0)|0}if(!((d|c|0)>-1&(d+c|0)>0)){k[P>>2]=0;h=P+4|0;k[h>>2]=0;j=ZT(36)|0;k[j>>2]=1;l=j+4|0;k[P>>2]=l;k[h>>2]=31;i[j+35>>0]=0;m=245327;n=l+31|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,P,245193,245209,104);k[h>>2]=0;k[P>>2]=0;L=k[j>>2]|0;k[j>>2]=L+-1;if((L|0)==1)ggb(k[j+-4>>2]|0)}t=O+4|0;u=O+8|0;v=O+12|0;w=O+16|0;x=O+20|0;y=O+24|0;z=O+28|0;A=O+40|0;B=O+48|0;C=O+44|0;D=O+52|0;E=P+4|0;F=P+4|0;G=F+4|0;H=O+36|0;I=P+4|0;L=a+4|0;J=O+32|0;K=a+8|0;s=0;do{b=(s|0)==0;e=b?R:Q;p=b?c:d;b=b?N:M;if((b|0)<=(p|0)){k[P>>2]=0;k[I>>2]=0;h=ZT(20)|0;k[h>>2]=1;l=h+4|0;k[P>>2]=l;k[I>>2]=13;i[h+17>>0]=0;m=245359;n=l+13|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,P,245193,245209,112);k[I>>2]=0;k[P>>2]=0;o=k[h>>2]|0;k[h>>2]=o+-1;if((o|0)==1)ggb(k[h+-4>>2]|0)}a:do switch(b|0){case 1:{k[a>>2]=1;break}case 3:switch(p|0){case 0:{k[a>>2]=1;k[L>>2]=2;k[K>>2]=1;break a}case 1:{k[a>>2]=-1;k[L>>2]=0;k[K>>2]=1;break a}default:{k[a>>2]=1;k[L>>2]=-2;k[K>>2]=1;break a}}default:{k[a>>2]=1;if((b|0)>0){zpb(L|0,0,b<<2|0)|0;o=b+~p|0;b:do if(!((o|0)<1|(b|0)<1)){h=0;j=1;while(1){m=j;n=1;l=j;while(1){j=k[a+(n<<2)>>2]|0;k[a+(n+-1<<2)>>2]=m;if((n|0)==(b|0))break;else{m=l+j|0;n=n+1|0;l=j}}h=h+1|0;if((h|0)==(o|0))break b;j=k[a>>2]|0}}while(0);if(!((p|0)<1|(b|0)<1)){l=0;do{n=k[a>>2]|0;h=0-n|0;j=1;while(1){m=k[a+(j<<2)>>2]|0;k[a+(j+-1<<2)>>2]=h;if((j|0)==(b|0))break;else{h=n-m|0;j=j+1|0;n=m}}l=l+1|0}while((l|0)!=(p|0))}}}}while(0);o=k[e+8>>2]|0;h=k[e+12>>2]|0;k[O>>2]=1124007940;k[t>>2]=2;k[u>>2]=o;k[v>>2]=h;k[w>>2]=a;k[x>>2]=a;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;k[A>>2]=u;k[C>>2]=B;k[D>>2]=0;k[B>>2]=0;if((aa(h,o)|0)!=0&(a|0)==0){k[P>>2]=0;k[E>>2]=0;h=ZT(36)|0;k[h>>2]=1;l=h+4|0;k[P>>2]=l;k[E>>2]=28;i[h+32>>0]=0;m=390609;n=l+28|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,P,390638,390642,410);k[E>>2]=0;k[P>>2]=0;o=k[h>>2]|0;k[h>>2]=o+-1;if((o|0)==1)ggb(k[h+-4>>2]|0);h=k[v>>2]|0;j=k[O>>2]|0;l=k[C>>2]|0;m=k[x>>2]|0}else{j=1124007940;l=B;m=a}o=h<<2;k[O>>2]=j|16384;k[l>>2]=o;k[l+4>>2]=4;n=m+(aa(k[u>>2]|0,o)|0)|0;k[z>>2]=n;k[y>>2]=n+(0-o)+o;if(f)q=1.0/+(1<<b+~p|0);else q=1.0;h=G;k[h>>2]=0;k[h+4>>2]=0;k[P>>2]=33619968;k[F>>2]=e;SW(O,P,g,q,0.0);h=k[H>>2]|0;if(h|0?(b=h+12|0,e=k[b>>2]|0,k[b>>2]=e+-1,(e|0)==1):0){j=k[H>>2]|0;if(j|0){h=k[j+4>>2]|0;if(!h){h=k[J>>2]|0;if(!h){h=B1()|0;j=k[H>>2]|0}}jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[H>>2]=0}k[H>>2]=0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[t>>2]|0)>0){j=k[A>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[t>>2]|0))}h=k[C>>2]|0;if(!((h|0)==(B|0)|(h|0)==0))ggb(k[h+-4>>2]|0);s=s+1|0}while((s|0)<2);if(a|0)ggb(a);j=Q+36|0;a=k[j>>2]|0;if(a|0?(g=a+12|0,P=k[g>>2]|0,k[g>>2]=P+-1,(P|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[Q+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;P=Q+16|0;h=Q+4|0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[h>>2]|0)>0){j=k[Q+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[Q+44>>2]|0;if(!((a|0)==(Q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=R+36|0;a=k[j>>2]|0;if(a|0?(P=a+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[R+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;Q=R+16|0;h=R+4|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[h>>2]|0)>0){j=k[R+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[R+44>>2]|0;if((a|0)==(R+48|0)|(a|0)==0){r=S;return}ggb(k[a+-4>>2]|0);r=S;return}function tfa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+160|0;q=C+144|0;x=C+136|0;y=C+80|0;v=C+24|0;o=C;p=C+16|0;A=S1(a,-1)|0;n=A&7;m=(c|0)<0?n:c;R1(x,a,-1);x2(b,x,m&7|A&4088,0);n=(m|0)<(n|0)?n:m;n=(n|0)>5?n:5;k[y>>2]=1124007936;A=y+4|0;c=y+8|0;x=y+40|0;j=A;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[x>>2]=c;B=y+48|0;z=y+44|0;k[z>>2]=B;k[y+52>>2]=0;k[B>>2]=0;k[v>>2]=1124007936;w=v+4|0;c=v+8|0;t=v+40|0;j=w;l=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[t>>2]=c;u=v+48|0;s=v+44|0;k[s>>2]=u;k[v+52>>2]=0;k[u>>2]=0;l=q+4|0;j=l+4|0;k[j>>2]=0;k[j+4>>2]=0;k[q>>2]=33619968;k[l>>2]=y;l=o+4|0;j=l+4|0;k[j>>2]=0;k[j+4>>2]=0;k[o>>2]=33619968;k[l>>2]=v;if((f|0)<1)rfa(q,o,d,e,0,n);else sfa(q,o,d,e,f,0,n);do if(g!=1.0)if(!d){f=q+4|0;e=f+4|0;k[e>>2]=0;k[e+4>>2]=0;k[q>>2]=33619968;k[f>>2]=y;SW(y,q,-1,g,0.0);break}else{f=q+4|0;e=f+4|0;k[e>>2]=0;k[e+4>>2]=0;k[q>>2]=33619968;k[f>>2]=v;SW(v,q,-1,g,0.0);break}while(0);k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=y;k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=v;k[p>>2]=-1;k[p+4>>2]=-1;gla(a,b,m,q,o,p,h,i);l=v+36|0;c=k[l>>2]|0;if(c|0?(i=c+12|0,q=k[i>>2]|0,k[i>>2]=q+-1,(q|0)==1):0){j=k[l>>2]|0;if(j|0){c=k[j+4>>2]|0;if(!c){c=k[v+32>>2]|0;if(!c){c=B1()|0;j=k[l>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,j)}k[l>>2]=0}k[l>>2]=0;v=v+16|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[w>>2]|0)>0){j=k[t>>2]|0;c=0;do{k[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[w>>2]|0))}c=k[s>>2]|0;if(!((c|0)==(u|0)|(c|0)==0))ggb(k[c+-4>>2]|0);l=y+36|0;c=k[l>>2]|0;if(c|0?(v=c+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){j=k[l>>2]|0;if(j|0){c=k[j+4>>2]|0;if(!c){c=k[y+32>>2]|0;if(!c){c=B1()|0;j=k[l>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,j)}k[l>>2]=0}k[l>>2]=0;y=y+16|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[A>>2]|0)>0){j=k[x>>2]|0;c=0;do{k[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[A>>2]|0))}c=k[z>>2]|0;if((c|0)==(B|0)|(c|0)==0){r=C;return}ggb(k[c+-4>>2]|0);r=C;return}function ufa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;var i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+160|0;p=B+144|0;w=B+136|0;x=B+80|0;u=B+24|0;n=B;o=B+16|0;z=S1(a,-1)|0;m=z&7;l=(c|0)<0?m:c;R1(w,a,-1);x2(b,w,l&7|z&4088,0);m=(l|0)<(m|0)?m:l;m=(m|0)>5?m:5;k[x>>2]=1124007936;z=x+4|0;c=x+8|0;w=x+40|0;i=z;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[w>>2]=c;A=x+48|0;y=x+44|0;k[y>>2]=A;k[x+52>>2]=0;k[A>>2]=0;k[u>>2]=1124007936;v=u+4|0;c=u+8|0;s=u+40|0;i=v;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[s>>2]=c;t=u+48|0;q=u+44|0;k[q>>2]=t;k[u+52>>2]=0;k[t>>2]=0;j=p+4|0;i=j+4|0;k[i>>2]=0;k[i+4>>2]=0;k[p>>2]=33619968;k[j>>2]=x;j=n+4|0;i=j+4|0;k[i>>2]=0;k[i+4>>2]=0;k[n>>2]=33619968;k[j>>2]=u;rfa(p,n,d,e,0,m);do if(f!=1.0)if(!d){e=p+4|0;d=e+4|0;k[d>>2]=0;k[d+4>>2]=0;k[p>>2]=33619968;k[e>>2]=x;SW(x,p,-1,f,0.0);break}else{e=p+4|0;d=e+4|0;k[d>>2]=0;k[d+4>>2]=0;k[p>>2]=33619968;k[e>>2]=u;SW(u,p,-1,f,0.0);break}while(0);k[p+8>>2]=0;k[p+12>>2]=0;k[p>>2]=16842752;k[p+4>>2]=x;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=u;k[o>>2]=-1;k[o+4>>2]=-1;gla(a,b,l,p,n,o,g,h);j=u+36|0;c=k[j>>2]|0;if(c|0?(h=c+12|0,p=k[h>>2]|0,k[h>>2]=p+-1,(p|0)==1):0){i=k[j>>2]|0;if(i|0){c=k[i+4>>2]|0;if(!c){c=k[u+32>>2]|0;if(!c){c=B1()|0;i=k[j>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,i)}k[j>>2]=0}k[j>>2]=0;u=u+16|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[v>>2]|0)>0){i=k[s>>2]|0;c=0;do{k[i+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[v>>2]|0))}c=k[q>>2]|0;if(!((c|0)==(t|0)|(c|0)==0))ggb(k[c+-4>>2]|0);j=x+36|0;c=k[j>>2]|0;if(c|0?(u=c+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){i=k[j>>2]|0;if(i|0){c=k[i+4>>2]|0;if(!c){c=k[x+32>>2]|0;if(!c){c=B1()|0;i=k[j>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,i)}k[j>>2]=0}k[j>>2]=0;x=x+16|0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[z>>2]|0)>0){i=k[w>>2]|0;c=0;do{k[i+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[z>>2]|0))}c=k[y>>2]|0;if((c|0)==(A|0)|(c|0)==0){r=B;return}ggb(k[c+-4>>2]|0);r=B;return}function vfa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;var h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;pa=r;r=r+592|0;Y=pa+568|0;Z=pa+496|0;_=pa;na=pa+488|0;i=pa+480|0;oa=pa+408|0;ja=pa+352|0;ea=pa+344|0;j=pa+472|0;ca=pa+336|0;l=pa+464|0;da=pa+280|0;ba=pa+224|0;$=pa+168|0;W=pa+112|0;T=pa+56|0;m=S1(a,-1)|0;p=m&7;ma=m>>>3&511;q=ma+1|0;V=(c|0)<0?p:c;R1(na,a,-1);c=ma<<3;x2(b,na,V&7|c,0);if((d|2|0)==3){c=(d|0)==3;n=Z;h=63292;o=n+72|0;do{k[n>>2]=k[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(o|0));na=c&1;oa=Z+(na*36|0)|0;m=_+4|0;k[m>>2]=2;n=_+8|0;k[n>>2]=3;k[_+12>>2]=3;j=_+16|0;k[j>>2]=oa;k[_+20>>2]=oa;oa=_+24|0;l=_+40|0;d=oa+8|0;k[d>>2]=0;k[d+4>>2]=0;k[l>>2]=n;n=_+48|0;d=_+44|0;k[d>>2]=n;k[_>>2]=1124024325;k[n>>2]=12;k[_+52>>2]=4;na=Z+(na*36|0)+36|0;k[_+28>>2]=na;k[oa>>2]=na;if(e!=1.0){oa=Y+4|0;na=oa+4|0;k[na>>2]=0;k[na+4>>2]=0;k[Y>>2]=33619968;k[oa>>2]=_;SW(_,Y,-1,e,0.0)}k[Y+8>>2]=0;k[Y+12>>2]=0;k[Y>>2]=16842752;k[Y+4>>2]=_;k[i>>2]=-1;k[i+4>>2]=-1;fla(a,b,V,Y,i,f,g);i=_+36|0;c=k[i>>2]|0;if(c|0?(na=c+12|0,oa=k[na>>2]|0,k[na>>2]=oa+-1,(oa|0)==1):0){h=k[i>>2]|0;if(h|0){c=k[h+4>>2]|0;if(!c){c=k[_+32>>2]|0;if(!c){c=B1()|0;h=k[i>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,h)}k[i>>2]=0}k[i>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[m>>2]|0)>0){h=k[l>>2]|0;c=0;do{k[h+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[m>>2]|0))}c=k[d>>2]|0;if(!((c|0)==(n|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=pa;return}h=(V|0)<(p|0)?p:V;h=(h|0)>5?h:5;t=((d|0)<6&(p|0)==0?3:p>>>0<6?5:6)|c;k[oa>>2]=1124007936;la=oa+4|0;s=oa+8|0;ka=oa+40|0;n=la;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[ka>>2]=s;na=oa+48|0;ma=oa+44|0;k[ma>>2]=na;k[oa+52>>2]=0;k[na>>2]=0;k[ja>>2]=1124007936;ha=ja+4|0;c=ja+8|0;fa=ja+40|0;n=ha;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[fa>>2]=c;ia=ja+48|0;ga=ja+44|0;k[ga>>2]=ia;k[ja+52>>2]=0;k[ia>>2]=0;X=Y+4|0;U=X+4|0;k[U>>2]=0;k[U+4>>2]=0;k[Y>>2]=33619968;k[X>>2]=oa;X=Z+4|0;U=X+4|0;k[U>>2]=0;k[U+4>>2]=0;k[Z>>2]=33619968;k[X>>2]=ja;sfa(Y,Z,2,0,d,0,h);k[Y+8>>2]=0;k[Y+12>>2]=0;k[Y>>2]=16842752;k[Y+4>>2]=oa;k[Z+8>>2]=0;k[Z+12>>2]=0;k[Z>>2]=16842752;k[Z+4>>2]=ja;k[j>>2]=-1;k[j+4>>2]=-1;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;k[_+16>>2]=0;k[_+20>>2]=0;k[_+24>>2]=0;k[_+28>>2]=0;Qja(ea,m,t,Y,Z,j,0.0,g,g,_);k[Y+8>>2]=0;k[Y+12>>2]=0;k[Y>>2]=16842752;k[Y+4>>2]=ja;k[Z+8>>2]=0;k[Z+12>>2]=0;k[Z>>2]=16842752;k[Z+4>>2]=oa;k[l>>2]=-1;k[l+4>>2]=-1;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;k[_+16>>2]=0;k[_+20>>2]=0;k[_+24>>2]=0;k[_+28>>2]=0;Qja(ca,m,t,Y,Z,l,0.0,g,g,_);do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[da>>2]=k[j>>2];n=da+4|0;c=j+4|0;k[n>>2]=k[c>>2];X=da+8|0;k[X>>2]=k[j+8>>2];k[da+12>>2]=k[j+12>>2];k[da+16>>2]=k[j+16>>2];k[da+20>>2]=k[j+20>>2];k[da+24>>2]=k[j+24>>2];k[da+28>>2]=k[j+28>>2];k[da+32>>2]=k[j+32>>2];h=k[j+36>>2]|0;k[da+36>>2]=h;i=da+40|0;k[i>>2]=X;X=da+48|0;m=da+44|0;k[m>>2]=X;k[da+52>>2]=0;k[X>>2]=0;if(h|0){X=h+12|0;k[X>>2]=(k[X>>2]|0)+1}if((k[c>>2]|0)<3){U=k[j+44>>2]|0;X=k[m>>2]|0;k[X>>2]=k[U>>2];k[X+4>>2]=k[U+4>>2];break}k[n>>2]=0;x1(da,k[c>>2]|0,0,0,0);if((k[n>>2]|0)>0){d=k[j+40>>2]|0;l=k[i>>2]|0;i=k[j+44>>2]|0;h=k[m>>2]|0;c=0;do{k[l+(c<<2)>>2]=k[d+(c<<2)>>2];k[h+(c<<2)>>2]=k[i+(c<<2)>>2];c=c+1|0}while((c|0)<(k[n>>2]|0))}}else Q1(da,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[ba>>2]=k[j>>2];n=ba+4|0;c=j+4|0;k[n>>2]=k[c>>2];X=ba+8|0;k[X>>2]=k[j+8>>2];k[ba+12>>2]=k[j+12>>2];k[ba+16>>2]=k[j+16>>2];k[ba+20>>2]=k[j+20>>2];k[ba+24>>2]=k[j+24>>2];k[ba+28>>2]=k[j+28>>2];k[ba+32>>2]=k[j+32>>2];h=k[j+36>>2]|0;k[ba+36>>2]=h;i=ba+40|0;k[i>>2]=X;X=ba+48|0;m=ba+44|0;k[m>>2]=X;k[ba+52>>2]=0;k[X>>2]=0;if(h|0){X=h+12|0;k[X>>2]=(k[X>>2]|0)+1}if((k[c>>2]|0)<3){U=k[j+44>>2]|0;X=k[m>>2]|0;k[X>>2]=k[U>>2];k[X+4>>2]=k[U+4>>2];break}k[n>>2]=0;x1(ba,k[c>>2]|0,0,0,0);if((k[n>>2]|0)>0){d=k[j+40>>2]|0;l=k[i>>2]|0;i=k[j+44>>2]|0;h=k[m>>2]|0;c=0;do{k[l+(c<<2)>>2]=k[d+(c<<2)>>2];k[h+(c<<2)>>2]=k[i+(c<<2)>>2];c=c+1|0}while((c|0)<(k[n>>2]|0))}}else Q1(ba,b,-1);while(0);J=ea+4|0;m=k[J>>2]|0;l=k[(k[m>>2]|0)+12>>2]|0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=-1;k[Y+12>>2]=-1;l=$g[l&127](m,da,Y,0,-1)|0;K=ca+4|0;U=k[K>>2]|0;X=k[(k[U>>2]|0)+12>>2]|0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=-1;k[Y+12>>2]=-1;$g[X&127](U,da,Y,0,-1)|0;U=da+16|0;X=da+44|0;l=(k[U>>2]|0)+(aa(k[k[X>>2]>>2]|0,l)|0)|0;i=da+12|0;h=k[i>>2]|0;H=aa(h,q<<(47696>>>(p<<1)&3))|0;G=da+8|0;c=k[G>>2]|0;H=H>>>0>16384?1:16384/(H>>>0)|0;H=(c|0)<(H|0)?c:H;c=(k[s>>2]|0)+-1+H|0;k[$>>2]=1124007936;Q=$+4|0;I=$+8|0;P=$+40|0;n=Q;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[P>>2]=I;S=$+48|0;R=$+44|0;k[R>>2]=S;k[$+52>>2]=0;k[S>>2]=0;k[Y>>2]=c;j=Y+4|0;k[j>>2]=h;G1($,2,Y,t);h=H+-1+(k[s>>2]|0)|0;c=k[i>>2]|0;k[W>>2]=1124007936;O=W+4|0;F=W+8|0;L=W+40|0;n=O;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[L>>2]=F;N=W+48|0;M=W+44|0;k[M>>2]=N;k[W+52>>2]=0;k[N>>2]=0;k[Y>>2]=h;k[j>>2]=c;G1(W,2,Y,t);a:do if((k[G>>2]|0)>0){j=da+48|0;d=$+16|0;n=W+16|0;a=Y+4|0;g=Z+4|0;b=Y+8|0;o=Y+12|0;p=Y+4|0;q=Z+8|0;s=Z+12|0;t=Z+4|0;u=_+4|0;v=u+4|0;w=Y+4|0;x=w+4|0;y=T+36|0;z=T+16|0;A=T+4|0;B=T+40|0;C=T+44|0;D=T+48|0;E=T+32|0;c=0;i=m;h=k[j>>2]|0;while(1){Sf[k[(k[i>>2]|0)+16>>2]&127](i,l,h,H,k[d>>2]|0,k[S>>2]|0)|0;h=k[K>>2]|0;h=Sf[k[(k[h>>2]|0)+16>>2]&127](h,l,k[j>>2]|0,H,k[n>>2]|0,k[N>>2]|0)|0;if((h|0)>0){i=h+c|0;k[Y>>2]=c;k[a>>2]=i;k[Z>>2]=-2147483648;k[g>>2]=2147483647;H1(T,ba,Y,Z);k[F>>2]=h;k[I>>2]=h;k[b>>2]=0;k[o>>2]=0;k[Y>>2]=16842752;k[p>>2]=$;k[q>>2]=0;k[s>>2]=0;k[Z>>2]=16842752;k[t>>2]=W;c=v;k[c>>2]=0;k[c+4>>2]=0;k[_>>2]=33619968;k[u>>2]=$;sU(Y,Z,_,49332,-1,39936,0,0);c=x;k[c>>2]=0;k[c+4>>2]=0;k[Y>>2]=33619968;k[w>>2]=T;SW($,Y,V,e,f);c=k[y>>2]|0;if(c|0?(h=c+12|0,m=k[h>>2]|0,k[h>>2]=m+-1,(m|0)==1):0){h=k[y>>2]|0;if(h|0){c=k[h+4>>2]|0;if(!c){c=k[E>>2]|0;if(!c){c=B1()|0;h=k[y>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,h)}k[y>>2]=0}k[y>>2]=0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[A>>2]|0)>0){h=k[B>>2]|0;c=0;do{k[h+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[A>>2]|0))}c=k[C>>2]|0;if(!((c|0)==(D|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=i}else c=h+c|0;h=k[j>>2]|0;if((c|0)>=(k[G>>2]|0))break a;i=l+(aa(h,H)|0)|0;l=i;i=k[J>>2]|0}}while(0);i=W+36|0;c=k[i>>2]|0;if(c|0?(Z=c+12|0,_=k[Z>>2]|0,k[Z>>2]=_+-1,(_|0)==1):0){h=k[i>>2]|0;if(h|0){c=k[h+4>>2]|0;if(!c){c=k[W+32>>2]|0;if(!c){c=B1()|0;h=k[i>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,h)}k[i>>2]=0}k[i>>2]=0;_=W+16|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[O>>2]|0)>0){h=k[L>>2]|0;c=0;do{k[h+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[O>>2]|0))}c=k[M>>2]|0;if(!((c|0)==(N|0)|(c|0)==0))ggb(k[c+-4>>2]|0);i=$+36|0;c=k[i>>2]|0;if(c|0?(Z=c+12|0,_=k[Z>>2]|0,k[Z>>2]=_+-1,(_|0)==1):0){h=k[i>>2]|0;if(h|0){c=k[h+4>>2]|0;if(!c){c=k[$+32>>2]|0;if(!c){c=B1()|0;h=k[i>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,h)}k[i>>2]=0}k[i>>2]=0;$=$+16|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[Q>>2]|0)>0){h=k[P>>2]|0;c=0;do{k[h+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Q>>2]|0))}c=k[R>>2]|0;if(!((c|0)==(S|0)|(c|0)==0))ggb(k[c+-4>>2]|0);i=ba+36|0;c=k[i>>2]|0;if(c|0?(_=c+12|0,$=k[_>>2]|0,k[_>>2]=$+-1,($|0)==1):0){h=k[i>>2]|0;if(h|0){c=k[h+4>>2]|0;if(!c){c=k[ba+32>>2]|0;if(!c){c=B1()|0;h=k[i>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,h)}k[i>>2]=0}k[i>>2]=0;$=ba+16|0;h=ba+4|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[h>>2]|0)>0){i=k[ba+40>>2]|0;c=0;do{k[i+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[h>>2]|0))}c=k[ba+44>>2]|0;if(!((c|0)==(ba+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);i=da+36|0;c=k[i>>2]|0;if(c|0?($=c+12|0,ba=k[$>>2]|0,k[$>>2]=ba+-1,(ba|0)==1):0){h=k[i>>2]|0;if(h|0){c=k[h+4>>2]|0;do if(!c){c=k[da+32>>2]|0;if(c|0)break;c=B1()|0;h=k[i>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,h)}k[i>>2]=0}k[i>>2]=0;i=da+4|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[i>>2]|0)>0){h=k[da+40>>2]|0;c=0;do{k[h+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[i>>2]|0))}c=k[X>>2]|0;if(!((c|0)==(da+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[ca>>2]|0;if(c|0?(ca=c+4|0,da=k[ca>>2]|0,k[ca>>2]=da+-1,(da|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);c=k[ea>>2]|0;if(c|0?(da=c+4|0,ea=k[da>>2]|0,k[da>>2]=ea+-1,(ea|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);i=ja+36|0;c=k[i>>2]|0;do if(c|0){da=c+12|0;ea=k[da>>2]|0;k[da>>2]=ea+-1;if((ea|0)!=1)break;h=k[i>>2]|0;if(h|0){c=k[h+4>>2]|0;do if(!c){c=k[ja+32>>2]|0;if(c|0)break;c=B1()|0;h=k[i>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,h)}k[i>>2]=0}while(0);k[i>>2]=0;ja=ja+16|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[ha>>2]|0)>0){h=k[fa>>2]|0;c=0;do{k[h+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[ha>>2]|0))}c=k[ga>>2]|0;if(!((c|0)==(ia|0)|(c|0)==0))ggb(k[c+-4>>2]|0);i=oa+36|0;c=k[i>>2]|0;do if(c|0){ia=c+12|0;ja=k[ia>>2]|0;k[ia>>2]=ja+-1;if((ja|0)!=1)break;h=k[i>>2]|0;if(h|0){c=k[h+4>>2]|0;do if(!c){c=k[oa+32>>2]|0;if(c|0)break;c=B1()|0;h=k[i>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,h)}k[i>>2]=0}while(0);k[i>>2]=0;oa=oa+16|0;k[oa>>2]=0;k[oa+4>>2]=0;k[oa+8>>2]=0;k[oa+12>>2]=0;if((k[la>>2]|0)>0){h=k[ka>>2]|0;c=0;do{k[h+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[la>>2]|0))}c=k[ma>>2]|0;if(!((c|0)==(na|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=pa;return}function wfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+144|0;j=q+128|0;p=q+72|0;n=q+16|0;l=q;M1(p,a,0,1,0,0);M1(n,b,0,1,0,0);o=p+40|0;g=k[o>>2]|0;m=n+40|0;h=k[m>>2]|0;if(((k[g>>2]|0)==(k[h>>2]|0)?(k[g+4>>2]|0)==(k[h+4>>2]|0):0)?(e=k[n>>2]|0,((e^k[p>>2])&4088|0)==0):0)b=e;else{k[j>>2]=0;b=j+4|0;k[b>>2]=0;e=ZT(68)|0;k[e>>2]=1;f=e+4|0;k[j>>2]=f;k[b>>2]=60;i[e+64>>0]=0;g=245423;h=f+60|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,j,245484,245209,889);k[b>>2]=0;k[j>>2]=0;h=k[e>>2]|0;k[e>>2]=h+-1;if((h|0)==1)ggb(k[e+-4>>2]|0);b=k[n>>2]|0}k[j+8>>2]=0;k[j+12>>2]=0;k[j>>2]=16842752;k[j+4>>2]=p;h=l+4|0;g=h+4|0;k[g>>2]=0;k[g+4>>2]=0;k[l>>2]=33619968;k[h>>2]=n;tfa(j,l,b&7,c,d,3,1.0,0.0,1);if(((a|0?(k[a>>2]|0)==112:0)?k[a+68>>2]|0:0)?!((d&1|0)==0|(k[a+32>>2]|0)==0):0){l=j+4|0;d=l+4|0;k[d>>2]=0;k[d+4>>2]=0;k[j>>2]=33619968;k[l>>2]=n;SW(n,j,-1,-1.0,0.0)}f=n+36|0;b=k[f>>2]|0;if(b|0?(j=b+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[n+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;l=n+16|0;f=n+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[f>>2]|0)>0){e=k[m>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[n+44>>2]|0;if(!((b|0)==(n+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);f=p+36|0;b=k[f>>2]|0;if(b|0?(m=b+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[p+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[f>>2]=0;n=p+16|0;f=p+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[f>>2]|0)>0){e=k[o>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[p+44>>2]|0;if((b|0)==(p+48|0)|(b|0)==0){r=q;return}ggb(k[b+-4>>2]|0);r=q;return}function xfa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0;$=r;r=r+1568|0;E=$+520|0;S=$+456|0;D=$+232|0;_=$+392|0;Z=$+336|0;s=$+512|0;X=$+280|0;t=$+448|0;x=$;z=$+8|0;B=$+264|0;do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[_>>2]=k[l>>2];q=_+4|0;a=l+4|0;k[q>>2]=k[a>>2];Y=_+8|0;k[Y>>2]=k[l+8>>2];k[_+12>>2]=k[l+12>>2];k[_+16>>2]=k[l+16>>2];k[_+20>>2]=k[l+20>>2];k[_+24>>2]=k[l+24>>2];k[_+28>>2]=k[l+28>>2];k[_+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[_+36>>2]=g;h=_+40|0;k[h>>2]=Y;Y=_+48|0;n=_+44|0;k[n>>2]=Y;k[_+52>>2]=0;k[Y>>2]=0;if(g|0){Y=g+12|0;k[Y>>2]=(k[Y>>2]|0)+1}if((k[a>>2]|0)<3){Y=k[l+44>>2]|0;w=k[n>>2]|0;k[w>>2]=k[Y>>2];k[w+4>>2]=k[Y+4>>2];w=_;break}k[q>>2]=0;x1(_,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[p+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0));w=_}else w=_}else{Q1(_,a,-1);w=_}while(0);k[Z>>2]=1124007936;V=Z+4|0;a=Z+8|0;T=Z+40|0;q=V;v=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(v|0));k[T>>2]=a;W=Z+48|0;U=Z+44|0;k[U>>2]=W;k[Z+52>>2]=0;k[W>>2]=0;y=(k[c>>2]&2031616|0)!=0;if(k[w>>2]&4095|0){k[E>>2]=0;a=E+4|0;k[a>>2]=0;g=ZT(28)|0;k[g>>2]=1;q=g+4|0;k[E>>2]=q;k[a>>2]=21;i[g+25>>0]=0;n=354023;v=q+21|0;do{i[q>>0]=i[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(v|0));Y8(-215,E,245492,245510,716);k[a>>2]=0;k[E>>2]=0;Y=k[g>>2]|0;k[g>>2]=Y+-1;if((Y|0)==1)ggb(k[g+-4>>2]|0)}Y=_+40|0;Q=k[Y>>2]|0;R=k[Q>>2]|0;k[s>>2]=k[Q+4>>2];k[s+4>>2]=R;x2(b,s,5,0);do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[X>>2]=k[l>>2];q=X+4|0;a=l+4|0;k[q>>2]=k[a>>2];R=X+8|0;k[R>>2]=k[l+8>>2];k[X+12>>2]=k[l+12>>2];k[X+16>>2]=k[l+16>>2];k[X+20>>2]=k[l+20>>2];k[X+24>>2]=k[l+24>>2];k[X+28>>2]=k[l+28>>2];k[X+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[X+36>>2]=g;h=X+40|0;k[h>>2]=R;R=X+48|0;n=X+44|0;k[n>>2]=R;k[X+52>>2]=0;k[R>>2]=0;if(g|0){R=g+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[a>>2]|0)<3){Q=k[l+44>>2]|0;R=k[n>>2]|0;k[R>>2]=k[Q>>2];k[R+4>>2]=k[Q+4>>2];break}k[q>>2]=0;x1(X,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[p+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(X,b,-1);while(0);a:do if(y){if((f|1|0)!=1){k[E>>2]=0;a=E+4|0;k[a>>2]=0;g=ZT(68)|0;k[g>>2]=1;q=g+4|0;k[E>>2]=q;k[a>>2]=62;i[g+66>>0]=0;n=245584;v=q+62|0;do{i[q>>0]=i[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(v|0));Y8(-215,E,245492,245510,723);k[a>>2]=0;k[E>>2]=0;R=k[g>>2]|0;k[g>>2]=R+-1;if((R|0)==1)ggb(k[g+-4>>2]|0)}Q=k[Y>>2]|0;R=k[Q>>2]|0;k[t>>2]=k[Q+4>>2];k[t+4>>2]=R;x2(c,t,4,0);do if((k[c>>2]&2031616|0)==65536){l=k[c+4>>2]|0;k[E>>2]=k[l>>2];q=E+4|0;a=l+4|0;k[q>>2]=k[a>>2];R=E+8|0;k[R>>2]=k[l+8>>2];k[E+12>>2]=k[l+12>>2];k[E+16>>2]=k[l+16>>2];k[E+20>>2]=k[l+20>>2];k[E+24>>2]=k[l+24>>2];k[E+28>>2]=k[l+28>>2];k[E+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[E+36>>2]=g;h=E+40|0;k[h>>2]=R;R=E+48|0;n=E+44|0;k[n>>2]=R;k[E+52>>2]=0;k[R>>2]=0;if(g|0){R=g+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[a>>2]|0)<3){Q=k[l+44>>2]|0;R=k[n>>2]|0;k[R>>2]=k[Q>>2];k[R+4>>2]=k[Q+4>>2];break}k[q>>2]=0;x1(E,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[p+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(E,c,-1);while(0);KG(Z,E)|0;h=E+36|0;a=k[h>>2]|0;if(a|0?(Q=a+12|0,R=k[Q>>2]|0,k[Q>>2]=R+-1,(R|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[E+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;R=E+16|0;g=E+4|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[g>>2]|0)>0){h=k[E+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[E+44>>2]|0;if(!((a|0)==(E+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=x;k[a>>2]=0;k[a+4>>2]=0;a=5}else{R=x;k[R>>2]=0;k[R+4>>2]=0;switch(e|0){case 0:case 3:case 5:{a=e;break a}default:{}}k[E>>2]=0;a=E+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;q=g+4|0;k[E>>2]=q;k[a>>2]=41;i[g+45>>0]=0;n=245647;v=q+41|0;do{i[q>>0]=i[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(v|0));Y8(-201,E,245492,245510,733);k[a>>2]=0;k[E>>2]=0;R=k[g>>2]|0;k[g>>2]=R+-1;if((R|0)==1)ggb(k[g+-4>>2]|0);a=e}while(0);h=(d|0)==3;l=(d|0)==1;if((d|2|0)!=3){a=(d|0)==2&y?5:a;if(!a){Q=k[Y>>2]|0;R=k[X+40>>2]|0;if(!((k[Q>>2]|0)==(k[R>>2]|0)?(k[Q+4>>2]|0)==(k[R+4>>2]|0):0)){k[E>>2]=0;a=E+4|0;k[a>>2]=0;g=ZT(32)|0;k[g>>2]=1;q=g+4|0;k[E>>2]=q;k[a>>2]=24;i[g+28>>0]=0;n=348093;v=q+24|0;do{i[q>>0]=i[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(v|0));Y8(-215,E,245689,245510,560);k[a>>2]=0;k[E>>2]=0;R=k[g>>2]|0;k[g>>2]=R+-1;if((R|0)==1)ggb(k[g+-4>>2]|0)}if(!((k[w>>2]&4095|0)==0?(k[X>>2]&4095|0)==5:0)){k[E>>2]=0;a=E+4|0;k[a>>2]=0;g=ZT(52)|0;k[g>>2]=1;q=g+4|0;k[E>>2]=q;k[a>>2]=47;i[g+51>>0]=0;n=245703;v=q+47|0;do{i[q>>0]=i[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(v|0));Y8(-215,E,245689,245510,562);k[a>>2]=0;k[E>>2]=0;R=k[g>>2]|0;k[g>>2]=R+-1;if((R|0)==1)ggb(k[g+-4>>2]|0)}n=_+8|0;b=k[n>>2]|0;s=k[_+12>>2]|0;p=b<<1;q=b*3|0;g=(b*12|0)+4+(b<<3)|0;t=s<<3;g=g>>>0<t>>>0?t:g;t=E+8|0;k[E>>2]=t;c=E+4|0;k[c>>2]=1032;if(g>>>0>1032){while(1){a=fgb(g)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[E>>2]=a;m=a}else m=t;k[c>>2]=g;g=m+(p<<2)+3&-4;l=g;h=(b|0)>0;if(h){a=0;do{L=+(aa(a,a)|0);o[m+(a<<2)>>2]=L;a=a+1|0}while((a|0)!=(b|0))}if((b|0)<(p|0)){a=b;do{o[m+(a<<2)>>2]=999999986991104.0;a=a+1|0}while((a|0)!=(p|0))}if(h){a=(p|0)>1?p:1;zpb(g|0,0,a<<2|0)|0}else a=0;if((a|0)<=(q|0))while(1){k[l+(a<<2)>>2]=a-p;if((a|0)<(q|0))a=a+1|0;else break}k[S>>2]=0;k[S+4>>2]=s;k[D>>2]=63372;k[D+4>>2]=_;k[D+8>>2]=X;k[D+12>>2]=l+(k[n>>2]<<1<<2)+4;k[D+16>>2]=m;Bfa(D,S);g=m+(s<<2)|0;o[m>>2]=0.0;o[g>>2]=0.0;if((s|0)>1){a=1;do{o[g+(a<<2)>>2]=.5/+(a|0);L=+(aa(a,a)|0);o[m+(a<<2)>>2]=L;a=a+1|0}while((a|0)!=(s|0))}k[S>>2]=0;k[S+4>>2]=b;k[D>>2]=63392;k[D+4>>2]=X;k[D+8>>2]=m;k[D+12>>2]=g;zfa(D,S);a=k[E>>2]|0;if((a|0)!=(t|0)){if(a|0)ggb(a);k[E>>2]=t;k[c>>2]=1032}}else{m=a;C=87}}else{m=y?5:3;C=87}if((C|0)==87){switch(d|0){case 3:{a=0;break}case 2:case 1:{C=91;break}default:{k[E>>2]=0;a=E+4|0;k[a>>2]=0;g=ZT(80)|0;k[g>>2]=1;q=g+4|0;k[E>>2]=q;k[a>>2]=73;i[g+77>>0]=0;n=245751;v=q+73|0;do{i[q>>0]=i[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(v|0));Y8(-215,E,245492,245510,774);k[a>>2]=0;k[E>>2]=0;R=k[g>>2]|0;k[g>>2]=R+-1;if((R|0)==1)ggb(k[g+-4>>2]|0);if(h)a=0;else C=91}}if((C|0)==91)a=l?1:2;switch(a+(m*10|0)|0){case 30:{j=65536.0;A=65536.0;L=0.0;break}case 31:{j=65536.0;A=131072.0;L=0.0;break}case 32:{j=62586.87890625;A=89738.4453125;L=0.0;break}case 50:{j=65536.0;A=65536.0;L=131072.0;break}case 51:{j=65536.0;A=131072.0;L=196608.0;break}case 52:{j=65536.0;A=91750.3984375;L=143976.03125;break}default:{k[E>>2]=0;a=E+4|0;k[a>>2]=0;g=ZT(24)|0;k[g>>2]=1;q=g+4|0;k[E>>2]=q;k[a>>2]=19;i[g+23>>0]=0;n=245825;v=q+19|0;do{i[q>>0]=i[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(v|0));Y8(-5,E,245845,245510,441);k[a>>2]=0;k[E>>2]=0;R=k[g>>2]|0;k[g>>2]=R+-1;if((R|0)==1)ggb(k[g+-4>>2]|0);j=0.0;A=0.0;L=0.0}}Q=k[Y>>2]|0;l=(m|0)==3;h=l?2:4;g=(k[Q>>2]|0)+h|0;h=(k[Q+4>>2]|0)+h|0;k[S>>2]=1124007936;Q=S+4|0;a=S+8|0;O=S+40|0;q=Q;v=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(v|0));k[O>>2]=a;R=S+48|0;P=S+44|0;k[P>>2]=R;k[S+52>>2]=0;k[R>>2]=0;k[E>>2]=g;k[E+4>>2]=h;G1(S,2,E,4);b:do if(y){k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;k[E>>2]=-1056833530;k[E+4>>2]=D;k[E+8>>2]=1;k[E+12>>2]=4;pY(Z,E,49332);if(!f){k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=1124007936;a=z+16|0;g=z+48|0;q=z+12|0;v=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(v|0));k[g>>2]=a;a=z+56|0;k[z+52>>2]=a;k[z+60>>2]=0;k[a>>2]=0;k[z+64>>2]=1124007936;a=z+72|0;g=z+104|0;q=z+68|0;v=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(v|0));k[g>>2]=a;a=z+112|0;k[z+108>>2]=a;k[z+116>>2]=0;k[a>>2]=0;k[z+120>>2]=1124007936;a=z+128|0;g=z+160|0;q=z+124|0;v=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(v|0));k[g>>2]=a;q=z+168|0;k[z+164>>2]=q;v=q+56|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(v|0));h1(z,0,_,0.0);k[E>>2]=1124007936;p=E+4|0;a=E+8|0;m=E+40|0;q=p;v=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(v|0));k[m>>2]=a;n=E+48|0;l=E+44|0;k[l>>2]=n;k[E+52>>2]=0;k[n>>2]=0;h=k[z>>2]|0;dh[k[(k[h>>2]|0)+12>>2]&255](h,z,E,-1);XN(z);k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=E;h=B+4|0;a=h+4|0;k[a>>2]=0;k[a+4>>2]=0;k[B>>2]=33619968;k[h>>2]=Z;Aea(D,B,8,4)|0;h=E+36|0;a=k[h>>2]|0;if(a|0?(M=a+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[E+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;N=E+16|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[p>>2]|0)>0){g=k[m>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[p>>2]|0))}a=k[l>>2]|0;if(!((a|0)==(n|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else{t=_+8|0;if((k[t>>2]|0)>0){c=_+12|0;p=k[_+16>>2]|0;q=k[_+44>>2]|0;b=k[Z+16>>2]|0;s=k[U>>2]|0;n=0;g=1;a=k[c>>2]|0;do{l=p+(aa(k[q>>2]|0,n)|0)|0;m=b+(aa(k[s>>2]|0,n)|0)|0;if((a|0)>0){h=0;do{if(!(i[l+h>>0]|0)){k[m+(h<<2)>>2]=g;g=g+1|0;a=k[c>>2]|0}h=h+1|0}while((h|0)<(a|0))}n=n+1|0}while((n|0)<(k[t>>2]|0))}}a=(o[u>>2]=j,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;j=a?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=a?-0.0:0.0}N=~~j;a=(o[u>>2]=A,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;j=a?A+-8388608.0+8388608.0:A+8388608.0+-8388608.0;if(j==0.0)j=a?-0.0:0.0}else j=A;M=~~j;a=(o[u>>2]=L,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;j=a?L+-8388608.0+8388608.0:L+8388608.0+-8388608.0;if(j==0.0)j=a?-0.0:0.0}else j=L;D=~~j;y=k[_+16>>2]|0;E=k[S+16>>2]|0;g=k[P>>2]|0;F=k[X+16>>2]|0;G=k[Z+16>>2]|0;f=k[_+48>>2]|0;H=(k[R>>2]|0)>>>2;I=(k[X+48>>2]|0)>>>2;J=(k[W>>2]|0)>>>2;z=k[Y>>2]|0;K=k[z+4>>2]|0;z=k[z>>2]|0;l=k[O>>2]|0;m=k[l+4>>2]|0;l=k[l>>2]|0;if((m|0)>0){h=E+(aa(k[g>>2]|0,l+-1|0)|0)|0;a=0;do{k[E+(a<<2)>>2]=536870911;k[h+(a<<2)>>2]=536870911;a=a+1|0}while((a|0)!=(m|0));g=k[g>>2]|0;h=E+g|0;g=E+(aa(g,l+-2|0)|0)|0;a=0;do{k[h+(a<<2)>>2]=536870911;k[g+(a<<2)>>2]=536870911;a=a+1|0}while((a|0)!=(m|0))}if((z|0)>0){d=(K|0)>0;B=H<<1;C=J<<1;s=~C;t=1-C|0;c=-2-J|0;e=~J;v=1-J|0;w=2-J|0;x=K+1|0;m=0;do{q=aa(m,f)|0;p=E+((aa(m+2|0,H)|0)<<2)+8|0;b=aa(m,J)|0;k[p+(K<<2)>>2]=536870911;k[p+-4>>2]=536870911;k[p+(x<<2)>>2]=536870911;k[p+-8>>2]=536870911;q=y+q|0;b=G+(b<<2)|0;if(d){n=0;do{if(!(i[q+n>>0]|0))k[p+(n<<2)>>2]=0;else{g=n-B|0;a=(k[p+(g+-1<<2)>>2]|0)+D|0;if((a|0)<536870911){h=a;a=k[b+(n+s<<2)>>2]|0}else{h=536870911;a=0}g=(k[p+(g+1<<2)>>2]|0)+D|0;if((h|0)>(g|0))a=k[b+(t+n<<2)>>2]|0;else g=h;l=n-H|0;h=(k[p+(l+-2<<2)>>2]|0)+D|0;if((g|0)>(h|0)){g=h;a=k[b+(c+n<<2)>>2]|0}h=(k[p+(l+-1<<2)>>2]|0)+M|0;if((g|0)>(h|0)){g=h;a=k[b+(n+e<<2)>>2]|0}h=(k[p+(l<<2)>>2]|0)+N|0;if((g|0)>(h|0)){g=h;a=k[b+(n-J<<2)>>2]|0}h=(k[p+(l+1<<2)>>2]|0)+M|0;if((g|0)>(h|0)){g=h;a=k[b+(v+n<<2)>>2]|0}h=(k[p+(l+2<<2)>>2]|0)+D|0;if((g|0)>(h|0)){g=h;a=k[b+(w+n<<2)>>2]|0}l=n+-1|0;h=(k[p+(l<<2)>>2]|0)+N|0;if((g|0)>(h|0)){g=h;a=k[b+(l<<2)>>2]|0}k[p+(n<<2)>>2]=g;k[b+(n<<2)>>2]=a}n=n+1|0}while((n|0)!=(K|0))}m=m+1|0}while((m|0)!=(z|0));t=B+-1|0;c=C+-1|0;e=J+2|0;if(d){l=z;do{m=l;l=l+-1|0;q=F+((aa(l,I)|0)<<2)|0;b=E+((aa(m+1|0,H)|0)<<2)+8|0;s=G+((aa(l,J)|0)<<2)|0;n=K;do{p=n;n=n+-1|0;g=b+(n<<2)|0;a=k[g>>2]|0;h=s+(n<<2)|0;if((a|0)>(N|0)){da=(k[b+(p+B<<2)>>2]|0)+D|0;z=(a|0)>(da|0);a=z?da:a;da=(k[b+(t+n<<2)>>2]|0)+D|0;f=(a|0)>(da|0);a=f?da:a;da=n+H|0;ba=(k[b+(da+2<<2)>>2]|0)+D|0;y=(a|0)>(ba|0);a=y?ba:a;ba=(k[b+(p+H<<2)>>2]|0)+M|0;d=(a|0)>(ba|0);a=d?ba:a;ba=(k[b+(da<<2)>>2]|0)+N|0;w=(a|0)>(ba|0);x=n+J|0;a=w?ba:a;ba=(k[b+(da+-1<<2)>>2]|0)+M|0;v=(a|0)>(ba|0);a=v?ba:a;da=(k[b+(da+-2<<2)>>2]|0)+D|0;ba=(a|0)>(da|0);a=ba?da:a;da=(k[b+(p<<2)>>2]|0)+N|0;ca=(a|0)>(da|0);a=ca?da:a;z=k[(ca?s+(p<<2)|0:ba?s+(x+-2<<2)|0:v?s+(x+-1<<2)|0:w?s+(x<<2)|0:d?s+(p+J<<2)|0:y?s+(e+n<<2)|0:f?s+(c+n<<2)|0:z?s+(p+C<<2)|0:h)>>2]|0;k[g>>2]=a;k[h>>2]=z}o[q+(n<<2)>>2]=+(a|0)*.0000152587890625}while((p|0)>1)}while((m|0)>1)}}}else{a=(o[u>>2]=j,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;j=a?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=a?-0.0:0.0}f=~~j;a=(o[u>>2]=A,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;j=a?A+-8388608.0+8388608.0:A+8388608.0+-8388608.0;if(j==0.0)j=a?-0.0:0.0}else j=A;y=~~j;if(l){p=k[_+16>>2]|0;s=k[S+16>>2]|0;t=k[X+16>>2]|0;q=k[_+48>>2]|0;c=(k[R>>2]|0)>>>2;e=(k[X+48>>2]|0)>>>2;b=k[Y>>2]|0;v=k[b+4>>2]|0;b=k[b>>2]|0;a=k[O>>2]|0;h=k[a+4>>2]|0;if((h|0)>0){g=s+(aa(k[k[P>>2]>>2]|0,(k[a>>2]|0)+-1|0)|0)|0;a=0;do{k[s+(a<<2)>>2]=536870911;k[g+(a<<2)>>2]=536870911;a=a+1|0}while((a|0)!=(h|0))}if((b|0)<=0)break;n=(v|0)>0;if(n){g=0;do{m=aa(g,q)|0;g=g+1|0;l=s+((aa(g,c)|0)<<2)+4|0;k[l+(v<<2)>>2]=536870911;k[l+-4>>2]=536870911;m=p+m|0;h=0;a=536870911;do{if(!(i[m+h>>0]|0))a=0;else{ca=h-c|0;da=(k[l+(ca+-1<<2)>>2]|0)+y|0;ba=(k[l+(ca<<2)>>2]|0)+f|0;da=(da|0)>(ba|0)?ba:da;ca=(k[l+(ca+1<<2)>>2]|0)+y|0;da=(da|0)>(ca|0)?ca:da;a=a+f|0;a=(da|0)>(a|0)?a:da}k[l+(h<<2)>>2]=a;h=h+1|0}while((h|0)!=(v|0))}while((g|0)!=(b|0))}else{a=0;do{a=a+1|0;da=s+((aa(a,c)|0)<<2)+4|0;k[da+(v<<2)>>2]=536870911;k[da+-4>>2]=536870911}while((a|0)!=(b|0))}if(n)h=b;else break;while(1){l=h;h=h+-1|0;p=t+((aa(h,e)|0)<<2)|0;q=s+((aa(l,c)|0)<<2)+4|0;m=v;do{n=m;m=m+-1|0;g=q+(m<<2)|0;a=k[g>>2]|0;if((a|0)>(f|0)){da=m+c|0;ca=(k[q+(n+c<<2)>>2]|0)+y|0;a=(a|0)>(ca|0)?ca:a;ca=(k[q+(da<<2)>>2]|0)+f|0;a=(a|0)>(ca|0)?ca:a;da=(k[q+(da+-1<<2)>>2]|0)+y|0;a=(a|0)>(da|0)?da:a;da=(k[q+(n<<2)>>2]|0)+f|0;a=(a|0)>(da|0)?da:a;k[g>>2]=a}o[p+(m<<2)>>2]=+(a|0)*.0000152587890625}while((n|0)>1);if((l|0)<=1)break b}}a=(o[u>>2]=L,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;j=a?L+-8388608.0+8388608.0:L+8388608.0+-8388608.0;if(j==0.0)j=a?-0.0:0.0}else j=L;c=~~j;q=k[_+16>>2]|0;e=k[S+16>>2]|0;g=k[P>>2]|0;v=k[X+16>>2]|0;b=k[_+48>>2]|0;w=(k[R>>2]|0)>>>2;x=(k[X+48>>2]|0)>>>2;s=k[Y>>2]|0;d=k[s+4>>2]|0;s=k[s>>2]|0;l=k[O>>2]|0;m=k[l+4>>2]|0;l=k[l>>2]|0;if((m|0)>0){h=e+(aa(k[g>>2]|0,l+-1|0)|0)|0;a=0;do{k[e+(a<<2)>>2]=536870911;k[h+(a<<2)>>2]=536870911;a=a+1|0}while((a|0)!=(m|0));g=k[g>>2]|0;h=e+g|0;g=e+(aa(g,l+-2|0)|0)|0;a=0;do{k[h+(a<<2)>>2]=536870911;k[g+(a<<2)>>2]=536870911;a=a+1|0}while((a|0)!=(m|0))}if((s|0)>0){p=(d|0)>0;t=w<<1;n=d+1|0;if(p){g=0;do{m=aa(g,b)|0;l=e+((aa(g+2|0,w)|0)<<2)+8|0;k[l+(d<<2)>>2]=536870911;k[l+-4>>2]=536870911;k[l+(n<<2)>>2]=536870911;k[l+-8>>2]=536870911;m=q+m|0;h=0;do{if(!(i[m+h>>0]|0))a=0;else{da=h-t|0;a=(k[l+(da+-1<<2)>>2]|0)+c|0;da=(k[l+(da+1<<2)>>2]|0)+c|0;a=(a|0)>(da|0)?da:a;da=h-w|0;ca=(k[l+(da+-2<<2)>>2]|0)+c|0;a=(a|0)>(ca|0)?ca:a;ca=(k[l+(da+-1<<2)>>2]|0)+y|0;a=(a|0)>(ca|0)?ca:a;ca=(k[l+(da<<2)>>2]|0)+f|0;a=(a|0)>(ca|0)?ca:a;ca=(k[l+(da+1<<2)>>2]|0)+y|0;a=(a|0)>(ca|0)?ca:a;da=(k[l+(da+2<<2)>>2]|0)+c|0;a=(a|0)>(da|0)?da:a;da=(k[l+(h+-1<<2)>>2]|0)+f|0;a=(a|0)>(da|0)?da:a}k[l+(h<<2)>>2]=a;h=h+1|0}while((h|0)!=(d|0));g=g+1|0}while((g|0)!=(s|0))}else{a=0;do{da=e+((aa(a+2|0,w)|0)<<2)+8|0;k[da+(d<<2)>>2]=536870911;k[da+-4>>2]=536870911;k[da+(n<<2)>>2]=536870911;k[da+-8>>2]=536870911;a=a+1|0}while((a|0)!=(s|0))}b=t+-1|0;if(p){h=s;do{l=h;h=h+-1|0;p=v+((aa(h,x)|0)<<2)|0;q=e+((aa(l+1|0,w)|0)<<2)+8|0;m=d;do{n=m;m=m+-1|0;g=q+(m<<2)|0;a=k[g>>2]|0;if((a|0)>(f|0)){da=(k[q+(n+t<<2)>>2]|0)+c|0;a=(a|0)>(da|0)?da:a;da=(k[q+(b+m<<2)>>2]|0)+c|0;a=(a|0)>(da|0)?da:a;da=m+w|0;ca=(k[q+(da+2<<2)>>2]|0)+c|0;a=(a|0)>(ca|0)?ca:a;ca=(k[q+(n+w<<2)>>2]|0)+y|0;a=(a|0)>(ca|0)?ca:a;ca=(k[q+(da<<2)>>2]|0)+f|0;a=(a|0)>(ca|0)?ca:a;ca=(k[q+(da+-1<<2)>>2]|0)+y|0;a=(a|0)>(ca|0)?ca:a;da=(k[q+(da+-2<<2)>>2]|0)+c|0;a=(a|0)>(da|0)?da:a;da=(k[q+(n<<2)>>2]|0)+f|0;a=(a|0)>(da|0)?da:a;k[g>>2]=a}o[p+(m<<2)>>2]=+(a|0)*.0000152587890625}while((n|0)>1)}while((l|0)>1)}}}while(0);h=S+36|0;a=k[h>>2]|0;if(a|0?(ca=a+12|0,da=k[ca>>2]|0,k[ca>>2]=da+-1,(da|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[S+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;da=S+16|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[Q>>2]|0)>0){g=k[O>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Q>>2]|0))}a=k[P>>2]|0;if(!((a|0)==(R|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}h=X+36|0;a=k[h>>2]|0;if(a|0?(ca=a+12|0,da=k[ca>>2]|0,k[ca>>2]=da+-1,(da|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[X+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;da=X+16|0;g=X+4|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[g>>2]|0)>0){h=k[X+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[X+44>>2]|0;if(!((a|0)==(X+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=Z+36|0;a=k[h>>2]|0;if(a|0?(ca=a+12|0,da=k[ca>>2]|0,k[ca>>2]=da+-1,(da|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[Z+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;da=Z+16|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[V>>2]|0)>0){g=k[T>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[V>>2]|0))}a=k[U>>2]|0;if(!((a|0)==(W|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=_+36|0;a=k[h>>2]|0;if(a|0?(ca=a+12|0,da=k[ca>>2]|0,k[ca>>2]=da+-1,(da|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[_+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;da=_+16|0;h=_+4|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[h>>2]|0)>0){g=k[Y>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[_+44>>2]|0;if((a|0)==(_+48|0)|(a|0)==0){r=$;return}ggb(k[a+-4>>2]|0);r=$;return}function yfa(a){a=a|0;ggb(a);return}function zfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=r;r=r+1040|0;x=y;e=k[b>>2]|0;v=k[b+4>>2]|0;d=k[a+4>>2]|0;w=k[d+12>>2]|0;c=(w*12|0)+24|0;t=x+8|0;k[x>>2]=t;u=x+4|0;k[u>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[x>>2]=b}else b=t;k[u>>2]=c;p=b+(w<<2)|0;q=p+(w<<2)+4+3&-4;a:do if((e|0)<(v|0)){s=k[d+16>>2]|0;l=k[d+44>>2]|0;m=p+4|0;n=(w|0)>0;j=a+8|0;if((w|0)<=1)while(1){h=s+(aa(k[l>>2]|0,e)|0)|0;k[q>>2]=0;o[p>>2]=-999999986991104.0;o[m>>2]=999999986991104.0;k[b>>2]=k[h>>2];if(n){i=k[j>>2]|0;a=0;c=0;do{f=+(a|0);while(1){d=c+1|0;if(+o[p+(d<<2)>>2]<f)c=d;else break}d=k[q+(c<<2)>>2]|0;z=a-d|0;g=+Q(+(+o[i+(((z|0)>-1?z:0-z|0)<<2)>>2]+ +o[b+(d<<2)>>2]));o[h+(a<<2)>>2]=g;a=a+1|0}while((a|0)!=(w|0))}e=e+1|0;if((e|0)==(v|0))break a}j=k[j>>2]|0;i=k[a+12>>2]|0;do{h=s+(aa(k[l>>2]|0,e)|0)|0;k[q>>2]=0;o[p>>2]=-999999986991104.0;o[m>>2]=999999986991104.0;k[b>>2]=k[h>>2];c=0;d=1;do{f=+o[h+(d<<2)>>2];o[b+(d<<2)>>2]=f;f=f+ +o[j+(d<<2)>>2];a=c;while(1){z=k[q+(a<<2)>>2]|0;g=(f-+o[h+(z<<2)>>2]-+o[j+(z<<2)>>2])*+o[i+(d-z<<2)>>2];if(g>+o[p+(a<<2)>>2])break;else a=a+-1|0}c=a+1|0;k[q+(c<<2)>>2]=d;o[p+(c<<2)>>2]=g;o[p+(a+2<<2)>>2]=999999986991104.0;d=d+1|0}while((d|0)!=(w|0));if(n){a=0;c=0;do{f=+(a|0);while(1){d=c+1|0;if(+o[p+(d<<2)>>2]<f)c=d;else break}z=k[q+(c<<2)>>2]|0;d=a-z|0;g=+Q(+(+o[j+(((d|0)>-1?d:0-d|0)<<2)>>2]+ +o[b+(z<<2)>>2]));o[h+(a<<2)>>2]=g;a=a+1|0}while((a|0)!=(w|0))}e=e+1|0}while((e|0)!=(v|0))}while(0);if((b|0)==(t|0)){r=y;return}ggb(b);k[x>>2]=t;k[u>>2]=1032;r=y;return}function Afa(a){a=a|0;ggb(a);return}function Bfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;x=r;r=r+1072|0;s=x;g=k[b>>2]|0;p=k[b+4>>2]|0;e=k[a+4>>2]|0;q=k[e+8>>2]|0;d=k[e+48>>2]|0;f=k[a+8>>2]|0;m=(k[f+48>>2]|0)>>>2;n=s+8|0;k[s>>2]=n;o=s+4|0;k[o>>2]=264;if(q>>>0>264){c=q>>>0>1073741823?-1:q<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[s>>2]=b}else b=n;k[o>>2]=q;if((g|0)<(p|0)?(t=q+-1|0,u=a+12|0,v=a+16|0,w=0-d|0,(q|0)>0):0){l=k[e+16>>2]|0;j=k[e+44>>2]|0;h=k[f+16>>2]|0;do{c=t;d=l+(aa(k[j>>2]|0,t)|0)+g|0;a=t;while(1){a=i[d>>0]|0?a+1|0:0;k[b+(c<<2)>>2]=a;if((c|0)<=0)break;else{c=c+-1|0;d=d+w|0}}e=k[u>>2]|0;f=k[v>>2]|0;c=h+(g<<2)|0;d=0;a=t;while(1){y=b+(d<<2)|0;a=a+1-(k[e+(a-(k[y>>2]|0)<<2)>>2]|0)|0;k[y>>2]=a;k[c>>2]=k[f+(a<<2)>>2];d=d+1|0;if((d|0)==(q|0))break;else c=c+(m<<2)|0}g=g+1|0}while((g|0)!=(p|0))}if((b|0)==(n|0)){r=x;return}ggb(b);k[s>>2]=n;k[o>>2]=264;r=x;return}function Cfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;q=a+-1|0;r=((q|0)<0)<<31>>31;n=b+-1|0;o=((n|0)<0)<<31>>31;if((a|0)<1|(b|0)<1){t=0;return t|0}g=k[c>>2]|0;m=((g|0)<0)<<31>>31;s=c+4|0;f=k[s>>2]|0;j=((f|0)<0)<<31>>31;h=k[d>>2]|0;p=((h|0)<0)<<31>>31;t=d+4|0;i=k[t>>2]|0;l=((i|0)<0)<<31>>31;e=((g|0)>=(a|0)&1)<<1|g>>>31|f>>>31<<2|((f|0)>=(b|0)&1)<<3;a=((h|0)>=(a|0)&1)<<1|h>>>31|i>>>31<<2|((i|0)>=(b|0)&1)<<3;if(!((a&e|0)!=0|(a|e|0)==0)){if(e&12){b=e>>>0<8;u=b?0:n;b=b?0:o;e=jpb(u|0,b|0,f|0,j|0)|0;v=N;w=jpb(h|0,p|0,g|0,m|0)|0;w=Epb(e|0,v|0,w|0,N|0)|0;v=N;e=jpb(i|0,l|0,f|0,j|0)|0;e=Bpb(w|0,v|0,e|0,N|0)|0;g=kpb(e|0,N|0,g|0,m|0)|0;m=N;e=ppb(g|0,m|0,63)|0;e=(((m|0)>(r|0)|(m|0)==(r|0)&g>>>0>q>>>0)&1)<<1|e;f=u;j=b}if(!(a&12))b=p;else{w=a>>>0<8;v=w?0:n;w=w?0:o;a=jpb(v|0,w|0,i|0,l|0)|0;u=N;b=jpb(h|0,p|0,g|0,m|0)|0;u=Epb(b|0,N|0,a|0,u|0)|0;a=N;b=jpb(i|0,l|0,f|0,j|0)|0;b=Bpb(u|0,a|0,b|0,N|0)|0;h=kpb(b|0,N|0,h|0,p|0)|0;b=N;a=ppb(h|0,b|0,63)|0;a=(((b|0)>(r|0)|(b|0)==(r|0)&h>>>0>q>>>0)&1)<<1|a;i=v;l=w}if(!((a&e|0)!=0|(a|e|0)==0)){if(!e)e=m;else{e=(e|0)==1;w=e?0:q;e=e?0:r;v=jpb(w|0,e|0,g|0,m|0)|0;u=N;p=jpb(i|0,l|0,f|0,j|0)|0;u=Epb(p|0,N|0,v|0,u|0)|0;v=N;g=jpb(h|0,b|0,g|0,m|0)|0;g=Bpb(u|0,v|0,g|0,N|0)|0;f=kpb(g|0,N|0,f|0,j|0)|0;j=N;g=w}if(!a){a=0;e=0}else{v=(a|0)==1;w=v?0:q;v=jpb(w|0,(v?0:r)|0,h|0,b|0)|0;u=N;a=jpb(i|0,l|0,f|0,j|0)|0;u=Epb(a|0,N|0,v|0,u|0)|0;v=N;a=jpb(h|0,b|0,g|0,e|0)|0;a=Bpb(u|0,v|0,a|0,N|0)|0;i=kpb(a|0,N|0,i|0,l|0)|0;a=0;h=w;e=0}}k[c>>2]=g;k[s>>2]=f;k[d>>2]=h;k[t>>2]=i}w=(a|e|0)==0;return w|0}function Dfa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0.0,l=0.0,m=0.0,n=0.0,q=0.0,s=0,t=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;D=r;r=r+16|0;A=D;C=a+4|0;B=((d|0)>0?d:0)+359-d|0;z=+(b|0);w=+(c|0);x=+(k[a>>2]|0);y=+(k[C>>2]|0);c=B-((B>>>0)%360|0)+d|0;d=c+~((c|0)<360?c:360)+360|0;d=c+(((d>>>0)%360|0)-d)|0;c=(e|0)>(f|0);b=c?e:f;c=c?f:e;if((c|0)<0){v=~c;B=((c|0)>-360?c:-360)+v+360|0;B=B-((B>>>0)%360|0)|0;c=B+359-v|0;b=b+B+360|0}if((b|0)>360){B=b+-361|0;B=B-((B>>>0)%360|0)|0;c=c+-360-B|0;b=b+-360-B|0}B=(b-c|0)>360;v=B?360:b;b=B?0:c;B=(d>>31&360)+d|0;l=+o[63404+(B<<2)>>2];j=+o[63404+(450-B<<2)>>2];B=h+4|0;c=k[B>>2]|0;e=k[h>>2]|0;d=c;if(!((c|0)==(e|0)|(d|0)==(e|0))){c=d+(~((d+-8-e|0)>>>3)<<3)|0;k[B>>2]=c;d=c}t=v+g|0;if((b|0)<(t|0)){s=A+4|0;q=j;i=h+8|0;f=b;c=-2147483648;b=-2147483648;do{d=(f|0)>(v|0)?v:f;d=(d|0)<0?d+360|0:d;m=z*+o[63404+(450-d<<2)>>2];n=w*+o[63404+(d<<2)>>2];j=x+q*m-l*n;p[u>>3]=j;d=k[u+4>>2]|0;e=d&2146435072;if(!(e>>>0>1126170624|(e|0)==1126170624&0>0)){d=(d|0)<0;j=d?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=d?-0.0:0.0}e=~~j;k[A>>2]=e;j=y+l*m+q*n;p[u>>3]=j;d=k[u+4>>2]|0;E=d&2146435072;if(!(E>>>0>1126170624|(E|0)==1126170624&0>0)){d=(d|0)<0;j=d?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=d?-0.0:0.0}d=~~j;k[s>>2]=d;do if((d|0)!=(b|0)|(e|0)!=(c|0)){b=k[B>>2]|0;if((b|0)==(k[i>>2]|0)){Efa(h,A);c=e;b=d;break}else{k[b>>2]=e;k[b+4>>2]=d;k[B>>2]=b+8;c=e;b=d;break}}while(0);f=f+g|0}while((f|0)<(t|0));d=k[B>>2]|0;e=k[h>>2]|0;c=d}if((c-e|0)!=8){r=D;return}f=h+8|0;b=k[f>>2]|0;i=e;if(b-e>>3>>>0>=2){d=c-e>>3;e=d>>>0<2;b=e?d:2;f=c;if(b|0){c=i;while(1){k[c>>2]=k[a>>2];k[c+4>>2]=k[C>>2];b=b+-1|0;if(!b)break;else c=c+8|0}}if(e){c=2-d|0;b=c;d=f;while(1){k[d>>2]=k[a>>2];k[d+4>>2]=k[C>>2];b=b+-1|0;if(!b)break;else d=d+8|0}k[B>>2]=f+(c<<3);r=D;return}else{b=i+16|0;if((f|0)==(b|0)){r=D;return}k[B>>2]=f+(~((f+-8-b|0)>>>3)<<3);r=D;return}}c=e;if(e){if((d|0)!=(i|0))k[B>>2]=d+(~((d+-8-e|0)>>>3)<<3);ggb(c);k[f>>2]=0;k[B>>2]=0;k[h>>2]=0;b=0}d=b>>2;d=b>>3>>>0<268435455?(d>>>0<2?2:d):536870911;if(d>>>0>536870911)bob();c=d<<3;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[B>>2]=b;k[h>>2]=b;k[f>>2]=b+(d<<3);k[b>>2]=k[a>>2];k[b+4>>2]=k[C>>2];k[b+8>>2]=k[a>>2];k[b+12>>2]=k[C>>2];k[B>>2]=b+16;r=D;return}function Efa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+4|0;c=k[l>>2]|0;m=k[a>>2]|0;f=c-m>>3;d=f+1|0;if(d>>>0>536870911)ad(426534,426557,304,426811);j=m;h=c;i=a+8|0;g=(k[i>>2]|0)-m|0;e=g>>2;e=g>>3>>>0<268435455?(e>>>0<d>>>0?d:e):536870911;if(!e)d=0;else{if(e>>>0>536870911){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c}c=d+(f<<3)|0;g=d+(e<<3)|0;k[c>>2]=k[b>>2];k[d+(f<<3)+4>>2]=k[b+4>>2];f=c+8|0;if((h|0)!=(j|0)){b=h+-8|0;d=h;e=c;while(1){h=d;d=d+-8|0;k[e+-8>>2]=k[d>>2];k[e+-4>>2]=k[h+-4>>2];if((d|0)==(j|0))break;else e=e+-8|0}c=c+(~((b-m|0)>>>3)<<3)|0}k[a>>2]=c;k[l>>2]=f;k[i>>2]=g;if(!m)return;ggb(m);return}function Ffa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;ba=r;r=r+384|0;_=ba+360|0;$=ba+352|0;aa=ba+344|0;h=ba+336|0;i=ba+328|0;j=ba+320|0;l=ba+312|0;m=ba+304|0;n=ba+296|0;o=ba+288|0;p=ba+280|0;q=ba+272|0;s=ba+264|0;t=ba+256|0;u=ba+248|0;v=ba+240|0;w=ba+232|0;x=ba+224|0;y=ba+216|0;z=ba+208|0;A=ba+200|0;B=ba+192|0;C=ba+184|0;D=ba+176|0;E=ba+168|0;F=ba+160|0;G=ba+152|0;H=ba+144|0;I=ba+136|0;J=ba+128|0;K=ba+120|0;L=ba+112|0;M=ba+104|0;N=ba+96|0;O=ba+88|0;P=ba+80|0;Q=ba+72|0;R=ba+64|0;S=ba+56|0;T=ba+48|0;U=ba+40|0;V=ba+32|0;W=ba+24|0;X=ba+16|0;Y=ba+8|0;Z=ba;switch(d|0){case 0:{W=_+4|0;Z=W+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[_>>2]=50397184;k[W>>2]=a;W=k[b>>2]|0;Z=(e|0)/2|0;Y=b+4|0;X=k[Y>>2]|0;k[$>>2]=W-Z;k[$+4>>2]=X;k[aa>>2]=W+Z;k[aa+4>>2]=X;Gfa(_,$,aa,c,f,g,0);$=_+4|0;aa=$+4|0;k[aa>>2]=0;k[aa+4>>2]=0;k[_>>2]=50397184;k[$>>2]=a;$=k[b>>2]|0;aa=k[Y>>2]|0;k[h>>2]=$;k[h+4>>2]=aa-Z;k[i>>2]=$;k[i+4>>2]=aa+Z;Gfa(_,h,i,c,f,g,0);r=ba;return}case 1:{Y=_+4|0;aa=Y+4|0;k[aa>>2]=0;k[aa+4>>2]=0;k[_>>2]=50397184;k[Y>>2]=a;Y=k[b>>2]|0;aa=(e|0)/2|0;$=b+4|0;Z=k[$>>2]|0;k[j>>2]=Y-aa;k[j+4>>2]=Z-aa;k[l>>2]=Y+aa;k[l+4>>2]=Z+aa;Gfa(_,j,l,c,f,g,0);Z=_+4|0;Y=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[_>>2]=50397184;k[Z>>2]=a;Z=k[b>>2]|0;$=k[$>>2]|0;k[m>>2]=Z+aa;k[m+4>>2]=$-aa;k[n>>2]=Z-aa;k[n+4>>2]=$+aa;Gfa(_,m,n,c,f,g,0);r=ba;return}case 2:{Y=_+4|0;aa=Y+4|0;k[aa>>2]=0;k[aa+4>>2]=0;k[_>>2]=50397184;k[Y>>2]=a;Y=k[b>>2]|0;aa=(e|0)/2|0;$=b+4|0;Z=k[$>>2]|0;k[o>>2]=Y-aa;k[o+4>>2]=Z;k[p>>2]=Y+aa;k[p+4>>2]=Z;Gfa(_,o,p,c,f,g,0);Z=_+4|0;Y=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[_>>2]=50397184;k[Z>>2]=a;Z=k[b>>2]|0;Y=k[$>>2]|0;k[q>>2]=Z;k[q+4>>2]=Y-aa;k[s>>2]=Z;k[s+4>>2]=Y+aa;Gfa(_,q,s,c,f,g,0);Y=_+4|0;Z=Y+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[_>>2]=50397184;k[Y>>2]=a;Y=k[b>>2]|0;Z=k[$>>2]|0;k[t>>2]=Y-aa;k[t+4>>2]=Z-aa;k[u>>2]=Y+aa;k[u+4>>2]=Z+aa;Gfa(_,t,u,c,f,g,0);Z=_+4|0;Y=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[_>>2]=50397184;k[Z>>2]=a;Z=k[b>>2]|0;$=k[$>>2]|0;k[v>>2]=Z+aa;k[v+4>>2]=$-aa;k[w>>2]=Z-aa;k[w+4>>2]=$+aa;Gfa(_,v,w,c,f,g,0);r=ba;return}case 3:{Y=_+4|0;$=Y+4|0;k[$>>2]=0;k[$+4>>2]=0;k[_>>2]=50397184;k[Y>>2]=a;Y=k[b>>2]|0;$=b+4|0;Z=k[$>>2]|0;aa=(e|0)/2|0;k[x>>2]=Y;k[x+4>>2]=Z-aa;k[y>>2]=Y+aa;k[y+4>>2]=Z;Gfa(_,x,y,c,f,g,0);Z=_+4|0;Y=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[_>>2]=50397184;k[Z>>2]=a;Z=k[b>>2]|0;Y=k[$>>2]|0;k[z>>2]=Z+aa;k[z+4>>2]=Y;k[A>>2]=Z;k[A+4>>2]=Y+aa;Gfa(_,z,A,c,f,g,0);Y=_+4|0;Z=Y+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[_>>2]=50397184;k[Y>>2]=a;Y=k[b>>2]|0;Z=k[$>>2]|0;k[B>>2]=Y;k[B+4>>2]=Z+aa;k[C>>2]=Y-aa;k[C+4>>2]=Z;Gfa(_,B,C,c,f,g,0);Z=_+4|0;Y=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[_>>2]=50397184;k[Z>>2]=a;Z=k[b>>2]|0;$=k[$>>2]|0;k[D>>2]=Z-aa;k[D+4>>2]=$;k[E>>2]=Z;k[E+4>>2]=$-aa;Gfa(_,D,E,c,f,g,0);r=ba;return}case 4:{Y=_+4|0;aa=Y+4|0;k[aa>>2]=0;k[aa+4>>2]=0;k[_>>2]=50397184;k[Y>>2]=a;Y=k[b>>2]|0;aa=(e|0)/2|0;$=b+4|0;Z=(k[$>>2]|0)-aa|0;k[F>>2]=Y-aa;k[F+4>>2]=Z;k[G>>2]=Y+aa;k[G+4>>2]=Z;Gfa(_,F,G,c,f,g,0);Z=_+4|0;Y=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[_>>2]=50397184;k[Z>>2]=a;Z=(k[b>>2]|0)+aa|0;Y=k[$>>2]|0;k[H>>2]=Z;k[H+4>>2]=Y-aa;k[I>>2]=Z;k[I+4>>2]=Y+aa;Gfa(_,H,I,c,f,g,0);Y=_+4|0;Z=Y+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[_>>2]=50397184;k[Y>>2]=a;Y=k[b>>2]|0;Z=(k[$>>2]|0)+aa|0;k[J>>2]=Y+aa;k[J+4>>2]=Z;k[K>>2]=Y-aa;k[K+4>>2]=Z;Gfa(_,J,K,c,f,g,0);Z=_+4|0;Y=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[_>>2]=50397184;k[Z>>2]=a;Z=(k[b>>2]|0)-aa|0;$=k[$>>2]|0;k[L>>2]=Z;k[L+4>>2]=$+aa;k[M>>2]=Z;k[M+4>>2]=$-aa;Gfa(_,L,M,c,f,g,0);r=ba;return}case 5:{Z=_+4|0;$=Z+4|0;k[$>>2]=0;k[$+4>>2]=0;k[_>>2]=50397184;k[Z>>2]=a;Z=k[b>>2]|0;$=(e|0)/2|0;aa=b+4|0;Y=(k[aa>>2]|0)+$|0;k[N>>2]=Z-$;k[N+4>>2]=Y;k[O>>2]=Z+$;k[O+4>>2]=Y;Gfa(_,N,O,c,f,g,0);Y=_+4|0;Z=Y+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[_>>2]=50397184;k[Y>>2]=a;Y=k[b>>2]|0;Z=k[aa>>2]|0;k[P>>2]=Y+$;k[P+4>>2]=Z+$;k[Q>>2]=Y;k[Q+4>>2]=Z-$;Gfa(_,P,Q,c,f,g,0);Z=_+4|0;Y=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[_>>2]=50397184;k[Z>>2]=a;Z=k[b>>2]|0;aa=(k[aa>>2]|0)-$|0;k[R>>2]=Z;k[R+4>>2]=aa;k[S>>2]=Z-$;k[S+4>>2]=aa;Gfa(_,R,S,c,f,g,0);r=ba;return}case 6:{S=_+4|0;aa=S+4|0;k[aa>>2]=0;k[aa+4>>2]=0;k[_>>2]=50397184;k[S>>2]=a;S=k[b>>2]|0;aa=(e|0)/2|0;$=b+4|0;Z=(k[$>>2]|0)-aa|0;k[T>>2]=S-aa;k[T+4>>2]=Z;k[U>>2]=S+aa;k[U+4>>2]=Z;Gfa(_,T,U,c,f,g,0);U=_+4|0;Z=U+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[_>>2]=50397184;k[U>>2]=a;U=k[b>>2]|0;Z=k[$>>2]|0;k[V>>2]=U+aa;k[V+4>>2]=Z-aa;k[W>>2]=U;k[W+4>>2]=Z+aa;Gfa(_,V,W,c,f,g,0);Z=_+4|0;W=Z+4|0;k[W>>2]=0;k[W+4>>2]=0;k[_>>2]=50397184;k[Z>>2]=a;Z=k[b>>2]|0;$=k[$>>2]|0;k[X>>2]=Z;k[X+4>>2]=$+aa;k[Y>>2]=Z-aa;k[Y+4>>2]=$-aa;Gfa(_,X,Y,c,f,g,0);r=ba;return}default:{k[Z>>2]=k[b>>2];k[Z+4>>2]=k[b+4>>2];Ffa(a,Z,c,0,e,f,g);r=ba;return}}}function Gfa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+112|0;u=v+48|0;s=v;t=v+40|0;q=v+32|0;do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[u>>2]=k[l>>2];p=u+4|0;a=l+4|0;k[p>>2]=k[a>>2];o=u+8|0;k[o>>2]=k[l+8>>2];k[u+12>>2]=k[l+12>>2];k[u+16>>2]=k[l+16>>2];k[u+20>>2]=k[l+20>>2];k[u+24>>2]=k[l+24>>2];k[u+28>>2]=k[l+28>>2];k[u+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[u+36>>2]=h;j=u+40|0;k[j>>2]=o;o=u+48|0;n=u+44|0;k[n>>2]=o;k[u+52>>2]=0;k[o>>2]=0;if(h|0){o=h+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[a>>2]|0)<3){o=k[l+44>>2]|0;p=k[n>>2]|0;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];break}k[p>>2]=0;x1(u,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(u,a,-1);while(0);if((f|0)==16)f=(k[u>>2]&7|0)==0?16:8;if(e>>>0>=32768){k[s>>2]=0;a=s+4|0;k[a>>2]=0;h=ZT(52)|0;k[h>>2]=1;j=h+4|0;k[s>>2]=j;k[a>>2]=44;i[h+48>>0]=0;l=246123;m=j+44|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,s,246168,246054,1734);k[a>>2]=0;k[s>>2]=0;p=k[h>>2]|0;k[h>>2]=p+-1;if((p|0)==1)ggb(k[h+-4>>2]|0)}if(g>>>0>=17){k[s>>2]=0;a=s+4|0;k[a>>2]=0;h=ZT(36)|0;k[h>>2]=1;j=h+4|0;k[s>>2]=j;k[a>>2]=31;i[h+35>>0]=0;l=246173;m=j+31|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,s,246168,246054,1735);k[a>>2]=0;k[s>>2]=0;p=k[h>>2]|0;k[h>>2]=p+-1;if((p|0)==1)ggb(k[h+-4>>2]|0)}z2(d,s,k[u>>2]&4095,0);k[t>>2]=k[b>>2];k[t+4>>2]=k[b+4>>2];k[q>>2]=k[c>>2];k[q+4>>2]=k[c+4>>2];Hfa(u,t,q,s,e,f,3,g);f=u+36|0;a=k[f>>2]|0;if(a|0?(s=a+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){h=k[f>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[u+32>>2]|0;if(!a){a=B1()|0;h=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[f>>2]=0}k[f>>2]=0;t=u+16|0;h=u+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[h>>2]|0)>0){f=k[u+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[u+44>>2]|0;if((a|0)==(u+48|0)|(a|0)==0){r=v;return}ggb(k[a+-4>>2]|0);r=v;return}function Hfa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0.0,m=0,n=0,o=0.0,q=0.0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+96|0;m=D+48|0;n=D+40|0;i=D+32|0;j=D+24|0;t=D+56|0;y=D+16|0;z=D+8|0;A=D;w=16-h|0;k[b>>2]=k[b>>2]<<w;B=b+4|0;k[B>>2]=k[B>>2]<<w;v=k[c>>2]<<w;k[c>>2]=v;C=c+4|0;w=k[C>>2]<<w;k[C>>2]=w;if((e|0)<2){if((f|0)>=16){k[i>>2]=k[b>>2];k[i+4>>2]=k[B>>2];k[j>>2]=v;k[j+4>>2]=w;Kfa(a,i,j,d);r=D;return}a:do if(h|0){switch(f|0){case 1:case 4:break a;default:{}}k[m>>2]=k[b>>2];k[m+4>>2]=k[B>>2];k[n>>2]=v;k[n+4>>2]=w;Jfa(a,m,n,d);r=D;return}while(0);k[b>>2]=(k[b>>2]|0)+32768>>16;k[B>>2]=(k[B>>2]|0)+32768>>16;A=(k[c>>2]|0)+32768>>16;k[c>>2]=A;g=(k[C>>2]|0)+32768>>16;k[C>>2]=g;Ifa(a,k[b>>2]|0,k[B>>2]|0,A,g,d,f);r=D;return};k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;k[t+16>>2]=0;k[t+20>>2]=0;k[t+24>>2]=0;k[t+28>>2]=0;h=k[b>>2]|0;s=+(h-v|0)*.0000152587890625;m=k[B>>2]|0;o=+(w-m|0)*.0000152587890625;l=s*s+o*o;x=e<<15;if(+P(+l)>2.220446049250313e-16){q=(+(x|0)+ +(e<<16&65536|0)*.5)/+Q(+l);l=o*q;p[u>>3]=l;i=k[u+4>>2]|0;e=i&2146435072;if(!(e>>>0>1126170624|(e|0)==1126170624&0>0)){i=(i|0)<0;l=i?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=i?-0.0:0.0}j=~~l;l=s*q;p[u>>3]=l;i=k[u+4>>2]|0;e=i&2146435072;if(!(e>>>0>1126170624|(e|0)==1126170624&0>0)){i=(i|0)<0;l=i?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=i?-0.0:0.0}e=~~l;k[t>>2]=j+h;k[t+4>>2]=m+e;k[t+8>>2]=h-j;k[t+12>>2]=m-e;k[t+16>>2]=v-j;k[t+20>>2]=w-e;k[t+24>>2]=v+j;k[t+28>>2]=w+e;Lfa(a,t,4,d,f,16)}h=y+4|0;m=x+32768>>16;n=z+4|0;e=A+4|0;i=(g&1|0)==0;if((f|0)<16){if(!i){f=(k[B>>2]|0)+32768>>16;k[y>>2]=(k[b>>2]|0)+32768>>16;k[h>>2]=f;Mfa(a,y,m,d,1)}i=k[c>>2]|0;k[b>>2]=i;j=k[C>>2]|0;k[B>>2]=j;if(g&2|0){k[y>>2]=i+32768>>16;k[h>>2]=j+32768>>16;Mfa(a,y,m,d,1)}}else{if(!i){k[z>>2]=k[b>>2];k[n>>2]=k[B>>2];k[A>>2]=x;k[e>>2]=x;Nfa(a,z,A,0,0,360,d,-1,f)}i=k[c>>2]|0;k[b>>2]=i;j=k[C>>2]|0;k[B>>2]=j;if(g&2|0){k[z>>2]=i;k[n>>2]=j;k[A>>2]=x;k[e>>2]=x;Nfa(a,z,A,0,0,360,d,-1,f)}}k[b>>2]=k[c>>2];k[B>>2]=k[C>>2];r=D;return}function Ifa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+32|0;h=v+16|0;m=v+8|0;n=v;u=(g|0)==0?8:(g|0)==1?4:g;k[m>>2]=b;l=m+4|0;k[l>>2]=c;k[n>>2]=d;j=n+4|0;k[j>>2]=e;o=(u|0)==8;switch(u|0){case 4:case 8:break;default:{b=h+4|0;g=ZT(44)|0;k[g>>2]=1;d=g+4|0;k[h>>2]=d;k[b>>2]=38;i[g+42>>0]=0;c=246002;e=d+38|0;do{i[d>>0]=i[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(e|0));Y8(-215,h,246041,246054,158);k[b>>2]=0;k[h>>2]=0;u=k[g>>2]|0;k[g>>2]=u+-1;if((u|0)==1)ggb(k[g+-4>>2]|0);b=k[m>>2]|0}}u=k[a+12>>2]|0;if((b>>>0<u>>>0?(k[n>>2]|0)>>>0<u>>>0:0)?(u=k[a+8>>2]|0,(k[l>>2]|0)>>>0<u>>>0?(k[j>>2]|0)>>>0<u>>>0:0):0)p=9;else{u=k[a+40>>2]|0;if(Cfa(k[u+4>>2]|0,k[u>>2]|0,m,n)|0)p=9;else{o=k[a+16>>2]|0;d=0;u=0;t=0;j=0;s=0;q=0;b=k[a+4>>2]|0}}if((p|0)==9){p=k[a+4>>2]|0;if((p|0)>0)b=k[(k[a+44>>2]|0)+(p+-1<<2)>>2]|0;else b=0;u=k[a+48>>2]|0;n=k[n>>2]|0;e=k[m>>2]|0;g=n-e|0;q=k[j>>2]|0;t=k[l>>2]|0;s=g>>31;g=(s^g)-s|0;c=(q-t^s)-s|0;e=s&(e^n)^e;k[m>>2]=e;t=(q^t)&s^t;k[l>>2]=t;e=(k[a+16>>2]|0)+(aa(t,u)|0)+(aa(e,b)|0)|0;t=c>>31;c=(t^c)-t|0;t=(t^u)-t|0;u=(c|0)>(g|0);g=(u?c:0)^g;c=(u?g:0)^c;g=(u?c:0)^g;l=(u?t:0)^b;b=(u?l:0)^t;l=(u?b:0)^l;if(o){d=c<<1;h=d;j=g<<1;d=g-d|0}else{j=c<<1;h=j;b=b-l|0;j=(g<<1)+j|0;d=0;g=g+c|0}o=e;u=g+1|0;t=0-h|0;s=l;q=b;b=p}if((b|0)>0)n=k[(k[a+44>>2]|0)+(b+-1<<2)>>2]|0;else n=0;if((u|0)<=0){r=v;return}l=f+1|0;m=f+2|0;switch(n|0){case 1:{c=0;h=o;e=d;b=o;while(1){i[b>>0]=i[f>>0]|0;b=c+1|0;g=e>>31;d=h+((q&g)+s)|0;if((b|0)==(u|0))break;else{c=b;h=d;e=t+e+(j&g)|0;b=d}}r=v;return}case 3:{e=0;h=o;b=o;while(1){i[b>>0]=i[f>>0]|0;i[b+1>>0]=i[l>>0]|0;i[b+2>>0]=i[m>>0]|0;b=e+1|0;g=d>>31;c=h+((q&g)+s)|0;if((b|0)==(u|0))break;else{e=b;h=c;d=t+d+(j&g)|0;b=c}}r=v;return}default:{e=0;h=o;b=o;while(1){upb(b|0,f|0,n|0)|0;b=e+1|0;g=d>>31;c=h+((q&g)+s)|0;if((b|0)==(u|0))break;else{e=b;h=c;d=t+d+(j&g)|0;b=c}}r=v;return}}}function Jfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;y=i[d>>0]|0;v=i[d+1>>0]|0;w=i[d+2>>0]|0;e=k[a+4>>2]|0;if((e|0)>0)x=k[(k[a+44>>2]|0)+(e+-1<<2)>>2]|0;else x=0;C=k[a+16>>2]|0;D=k[a+48>>2]|0;A=k[a+40>>2]|0;z=k[A+4>>2]|0;A=k[A>>2]|0;if(!(Cfa(z<<16,A<<16,b,c)|0))return;f=k[c>>2]|0;g=k[b>>2]|0;h=f-g|0;p=c+4|0;j=k[p>>2]|0;B=b+4|0;l=k[B>>2]|0;m=j-l|0;e=h>>31;n=(e^h)-e|0;a=m>>31;o=(a^m)-a|0;s=(n|0)>(o|0);if(s){h=(m^e)-e|0;a=e&f^g;k[b>>2]=a;a=k[c>>2]^a&e;k[c>>2]=a;a=k[b>>2]^a&e;k[b>>2]=a;f=l^j&e;k[B>>2]=f;f=k[p>>2]^f&e;k[p>>2]=f;f=k[B>>2]^f&e;k[B>>2]=f;e=Apb(h|0,((h|0)<0)<<31>>31|0,16)|0;h=n|1;h=Bpb(e|0,N|0,h|0,((h|0)<0)<<31>>31|0)|0;e=(k[c>>2]|0)-a|0;j=65536}else{e=(a^h)-a|0;n=a&f^g;k[b>>2]=n;n=k[c>>2]^n&a;k[c>>2]=n;n=k[b>>2]^n&a;k[b>>2]=n;f=l^j&a;k[B>>2]=f;f=k[p>>2]^f&a;k[p>>2]=f;f=k[B>>2]^f&a;k[B>>2]=f;e=Apb(e|0,((e|0)<0)<<31>>31|0,16)|0;j=o|1;j=Bpb(e|0,N|0,j|0,((j|0)<0)<<31>>31|0)|0;e=(k[p>>2]|0)-f|0;h=65536;a=n}g=e>>16;k[b>>2]=a+32768;k[B>>2]=f+32768;if((x|0)==3){a=(k[c>>2]|0)+32768>>16;e=(k[p>>2]|0)+32768>>16;if((a|0)>-1?(q=C+(aa(e,D)|0)+(a*3|0)|0,(e|0)<(A|0)&((a|0)<(z|0)&(e|0)>-1)):0){i[q>>0]=y;i[q+1>>0]=v;i[q+2>>0]=w}if(s){e=k[b>>2]>>16;k[b>>2]=e;if((g|0)<=-1)return;f=k[B>>2]|0;while(1){a=f>>16;if((e|0)>-1?(t=C+(aa(a,D)|0)+(e*3|0)|0,(a|0)<(A|0)&((e|0)<(z|0)&(a|0)>-1)):0){i[t>>0]=y;i[t+1>>0]=v;i[t+2>>0]=w;e=k[b>>2]|0;a=k[B>>2]|0}else a=f;e=e+1|0;k[b>>2]=e;f=a+h|0;k[B>>2]=f;if((g|0)<=0)break;else g=g+-1|0}return}else{e=k[B>>2]>>16;k[B>>2]=e;if((g|0)<=-1)return;f=k[b>>2]|0;while(1){a=f>>16;if((a|0)>-1?(u=C+(aa(e,D)|0)+(a*3|0)|0,(e|0)<(A|0)&((a|0)<(z|0)&(e|0)>-1)):0){i[u>>0]=y;i[u+1>>0]=v;i[u+2>>0]=w;a=k[b>>2]|0;e=k[B>>2]|0}else a=f;f=a+j|0;k[b>>2]=f;e=e+1|0;k[B>>2]=e;if((g|0)<=0)break;else g=g+-1|0}return}}f=(k[c>>2]|0)+32768>>16;e=(k[p>>2]|0)+32768>>16;a=(f|0)>-1;if((x|0)==1){if(a?(e|0)<(A|0)&((f|0)<(z|0)&(e|0)>-1):0){d=C+(aa(e,D)|0)+f|0;i[d>>0]=y}if(s){e=k[b>>2]>>16;k[b>>2]=e;if((g|0)<=-1)return;f=k[B>>2]|0;while(1){a=f>>16;if((e|0)>-1?(a|0)<(A|0)&((e|0)<(z|0)&(a|0)>-1):0){e=C+(aa(a,D)|0)+e|0;i[e>>0]=y;e=k[b>>2]|0;a=k[B>>2]|0}else a=f;e=e+1|0;k[b>>2]=e;f=a+h|0;k[B>>2]=f;if((g|0)<=0)break;else g=g+-1|0}return}else{e=k[B>>2]>>16;k[B>>2]=e;if((g|0)<=-1)return;f=k[b>>2]|0;while(1){a=f>>16;if((a|0)>-1?(e|0)<(A|0)&((a|0)<(z|0)&(e|0)>-1):0){a=C+(aa(e,D)|0)+a|0;i[a>>0]=y;a=k[b>>2]|0;e=k[B>>2]|0}else a=f;f=a+j|0;k[b>>2]=f;e=e+1|0;k[B>>2]=e;if((g|0)<=0)break;else g=g+-1|0}return}}if((a?(e|0)<(A|0)&((f|0)<(z|0)&(e|0)>-1):0)?(r=C+(aa(e,D)|0)+(aa(f,x)|0)|0,(x|0)>0):0){e=0;do{i[r+e>>0]=i[d+e>>0]|0;e=e+1|0}while((e|0)!=(x|0))}if(s){a=k[b>>2]>>16;k[b>>2]=a;if((g|0)<=-1)return;e=k[B>>2]|0;if((x|0)>0)f=a;else{C=~((g|0)<0?g:0);D=e+(aa(h,g+C+2|0)|0)|0;k[b>>2]=g+a+C+2;k[B>>2]=D;return}while(1){a=e>>16;if((f|0)>-1?(a|0)<(A|0)&((f|0)<(z|0)&(a|0)>-1):0){a=C+(aa(a,D)|0)+(aa(f,x)|0)|0;e=0;do{i[a+e>>0]=i[d+e>>0]|0;e=e+1|0}while((e|0)!=(x|0));a=k[b>>2]|0;e=k[B>>2]|0}else a=f;f=a+1|0;k[b>>2]=f;e=e+h|0;k[B>>2]=e;if((g|0)<=0)break;else g=g+-1|0}return}else{a=k[B>>2]>>16;k[B>>2]=a;if((g|0)<=-1)return;e=k[b>>2]|0;if((x|0)>0)f=a;else{D=~((g|0)<0?g:0);C=e+(aa(j,g+D+2|0)|0)|0;k[b>>2]=C;k[B>>2]=g+a+D+2;return}while(1){a=e>>16;if((a|0)>-1?(f|0)<(A|0)&((a|0)<(z|0)&(f|0)>-1):0){a=C+(aa(f,D)|0)+(aa(a,x)|0)|0;e=0;do{i[a+e>>0]=i[d+e>>0]|0;e=e+1|0}while((e|0)!=(x|0));e=k[b>>2]|0;a=k[B>>2]|0}else a=f;e=e+j|0;k[b>>2]=e;f=a+1|0;k[B>>2]=f;if((g|0)<=0)break;else g=g+-1|0}return}}function Kfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+48|0;z=B;A=l[d>>0]|0;x=l[d+1>>0]|0;w=l[d+2>>0]|0;u=l[d+3>>0]|0;e=k[a>>2]|0;f=e>>>3;g=k[a+16>>2]|0;h=a+48|0;y=k[h>>2]|0;m=k[a+40>>2]|0;j=k[m+4>>2]|0;m=k[m>>2]|0;t=f&65535;switch(t&511){case 0:case 2:case 3:{if(!(e&7)){k[b>>2]=(k[b>>2]|0)+-131072;v=b+4|0;k[v>>2]=(k[v>>2]|0)+-131072;k[c>>2]=(k[c>>2]|0)+-131072;p=c+4|0;k[p>>2]=(k[p>>2]|0)+-131072;s=g+((k[h>>2]|0)+((f&511)+1)<<1)|0;if(!(Cfa((j<<16)+-327679|0,(m<<16)+-327679|0,b,c)|0)){r=B;return}d=k[c>>2]|0;f=k[b>>2]|0;g=d-f|0;h=k[p>>2]|0;j=k[v>>2]|0;m=h-j|0;a=g>>31;n=(a^g)-a|0;e=m>>31;o=(e^m)-e|0;q=(n|0)>(o|0);if(q){g=(m^a)-a|0;e=a&d^f;k[b>>2]=e;e=k[c>>2]^e&a;k[c>>2]=e;k[b>>2]=k[b>>2]^e&a;e=j^h&a;k[v>>2]=e;e=k[p>>2]^e&a;k[p>>2]=e;e=k[v>>2]^e&a;f=Apb(g|0,((g|0)<0)<<31>>31|0,16)|0;n=n|1;n=Bpb(f|0,N|0,n|0,((n|0)<0)<<31>>31|0)|0;f=(k[c>>2]|0)+65536|0;k[c>>2]=f;j=k[b>>2]|0;a=0-(j&65535)|0;a=Epb(a|0,((a|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;a=ppb(a|0,N|0,16)|0;a=e+32768+a|0;k[v>>2]=a;e=(f>>16)-(j>>16)|0;g=n>>>11^n>>31;m=65536;d=j>>9;f=f>>9}else{m=(e^g)-e|0;g=e&d^f;k[b>>2]=g;g=k[c>>2]^g&e;k[c>>2]=g;g=k[b>>2]^g&e;f=j^h&e;k[v>>2]=f;f=k[p>>2]^f&e;k[p>>2]=f;k[v>>2]=k[v>>2]^f&e;f=Apb(m|0,((m|0)<0)<<31>>31|0,16)|0;m=o|1;m=Bpb(f|0,N|0,m|0,((m|0)<0)<<31>>31|0)|0;f=(k[p>>2]|0)+65536|0;k[p>>2]=f;a=k[v>>2]|0;j=0-(a&65535)|0;j=Epb(j|0,((j|0)<0)<<31>>31|0,m|0,((m|0)<0)<<31>>31|0)|0;j=ppb(j|0,N|0,16)|0;j=g+32768+j|0;k[b>>2]=j;e=(f>>16)-(a>>16)|0;g=m>>>11^m>>31;n=65536;d=a>>>9;f=f>>>9}h=d&120;f=f&120;if(!(g&32))d=l[246264+(g&63)>>0]|0;else d=256;c=d<<7;o=aa(d,120-h|4)|0;p=aa(d,f|4)|0;k[z>>2]=0;k[z+32>>2]=d;h=f-h|0;g=(aa(d,h&120|4)|0)>>>8;k[z+12>>2]=g;k[z+4>>2]=g;k[z+8>>2]=o>>>8;h=(aa(d,h+128|4)|0)>>>8&511;k[z+16>>2]=h;k[z+20>>2]=(o+c|0)>>>8&511;k[z+24>>2]=p>>>8;k[z+28>>2]=(p+c|0)>>>8;switch(t&511){case 2:{d=(e|0)>-1;if(q){if(!d){r=B;return}f=0;d=s+((j>>16)*3|0)|0;while(1){q=d+(aa((a>>16)+-1|0,y)|0)|0;p=k[z+(((((f|0)>1?2:1)&(f|2))*3|0)+(((e|0)>1?2:1)&(e|2))<<2)>>2]|0;c=a>>>11&31;s=(aa(k[65208+((c|32)<<2)>>2]|0,p)|0)>>>8&255;t=l[q>>0]|0;t=(((aa(A-t|0,s)|0)+127|0)>>>8)+t|0;b=q+1|0;u=l[b>>0]|0;u=(((aa(x-u|0,s)|0)+127|0)>>>8)+u|0;m=q+2|0;o=l[m>>0]|0;o=(((aa(w-o|0,s)|0)+127|0)>>>8)+o|0;u=(((aa(x-(u&255)|0,s)|0)+127|0)>>>8)+u|0;o=(((aa(w-(o&255)|0,s)|0)+127|0)>>>8)+o|0;t=(((aa(A-(t&255)|0,s)|0)+127|0)>>>8)+t&255;i[q>>0]=t;i[b>>0]=u;i[m>>0]=o;q=q+y|0;m=(aa(k[65208+(c<<2)>>2]|0,p)|0)>>>8&255;o=l[q>>0]|0;o=(((aa(A-o|0,m)|0)+127|0)>>>8)+o|0;b=q+1|0;u=l[b>>0]|0;u=(((aa(x-u|0,m)|0)+127|0)>>>8)+u|0;t=q+2|0;s=l[t>>0]|0;s=(((aa(w-s|0,m)|0)+127|0)>>>8)+s|0;u=(((aa(x-(u&255)|0,m)|0)+127|0)>>>8)+u|0;s=(((aa(w-(s&255)|0,m)|0)+127|0)>>>8)+s|0;o=(((aa(A-(o&255)|0,m)|0)+127|0)>>>8)+o&255;i[q>>0]=o;i[b>>0]=u;i[t>>0]=s;q=q+y|0;p=(aa(k[65208+((c^63)<<2)>>2]|0,p)|0)>>>8&255;c=l[q>>0]|0;c=(((aa(A-c|0,p)|0)+127|0)>>>8)+c|0;t=q+1|0;s=l[t>>0]|0;s=(((aa(x-s|0,p)|0)+127|0)>>>8)+s|0;b=q+2|0;u=l[b>>0]|0;u=(((aa(w-u|0,p)|0)+127|0)>>>8)+u|0;s=(((aa(x-(s&255)|0,p)|0)+127|0)>>>8)+s|0;u=(((aa(w-(u&255)|0,p)|0)+127|0)>>>8)+u|0;c=(((aa(A-(c&255)|0,p)|0)+127|0)>>>8)+c&255;i[q>>0]=c;i[t>>0]=s;i[b>>0]=u;a=(k[v>>2]|0)+n|0;k[v>>2]=a;if((e|0)<=0)break;else{f=f+1|0;d=d+3|0;e=e+-1|0}}r=B;return}else{if(!d){r=B;return}f=0;d=s+(aa(a>>16,y)|0)|0;a=j;while(1){q=d+(((a>>16)*3|0)+-3)|0;p=k[z+(((((f|0)>1?2:1)&(f|2))*3|0)+(((e|0)>1?2:1)&(e|2))<<2)>>2]|0;c=a>>>11&31;s=(aa(k[65208+((c|32)<<2)>>2]|0,p)|0)>>>8&255;t=l[q>>0]|0;t=(((aa(A-t|0,s)|0)+127|0)>>>8)+t|0;v=q+1|0;u=l[v>>0]|0;u=(((aa(x-u|0,s)|0)+127|0)>>>8)+u|0;n=q+2|0;o=l[n>>0]|0;o=(((aa(w-o|0,s)|0)+127|0)>>>8)+o|0;u=(((aa(x-(u&255)|0,s)|0)+127|0)>>>8)+u|0;o=(((aa(w-(o&255)|0,s)|0)+127|0)>>>8)+o|0;t=(((aa(A-(t&255)|0,s)|0)+127|0)>>>8)+t&255;i[q>>0]=t;i[v>>0]=u;i[n>>0]=o;q=q+3|0;n=(aa(k[65208+(c<<2)>>2]|0,p)|0)>>>8&255;o=l[q>>0]|0;o=(((aa(A-o|0,n)|0)+127|0)>>>8)+o|0;v=q+1|0;u=l[v>>0]|0;u=(((aa(x-u|0,n)|0)+127|0)>>>8)+u|0;t=q+2|0;s=l[t>>0]|0;s=(((aa(w-s|0,n)|0)+127|0)>>>8)+s|0;u=(((aa(x-(u&255)|0,n)|0)+127|0)>>>8)+u|0;s=(((aa(w-(s&255)|0,n)|0)+127|0)>>>8)+s|0;o=(((aa(A-(o&255)|0,n)|0)+127|0)>>>8)+o&255;i[q>>0]=o;i[v>>0]=u;i[t>>0]=s;q=q+3|0;p=(aa(k[65208+((c^63)<<2)>>2]|0,p)|0)>>>8&255;c=l[q>>0]|0;c=(((aa(A-c|0,p)|0)+127|0)>>>8)+c|0;t=q+1|0;s=l[t>>0]|0;s=(((aa(x-s|0,p)|0)+127|0)>>>8)+s|0;v=q+2|0;u=l[v>>0]|0;u=(((aa(w-u|0,p)|0)+127|0)>>>8)+u|0;s=(((aa(x-(s&255)|0,p)|0)+127|0)>>>8)+s|0;u=(((aa(w-(u&255)|0,p)|0)+127|0)>>>8)+u|0;c=(((aa(A-(c&255)|0,p)|0)+127|0)>>>8)+c&255;i[q>>0]=c;i[t>>0]=s;i[v>>0]=u;a=(k[b>>2]|0)+m|0;k[b>>2]=a;if((e|0)<=0)break;else{f=f+1|0;d=d+y|0;e=e+-1|0}}r=B;return}}case 0:{d=(e|0)>-1;if(q){if(!d){r=B;return}d=s+(j>>16)|0;f=0;while(1){x=d+(aa((a>>16)+-1|0,y)|0)|0;b=k[z+(((((f|0)>1?2:1)&(f|2))*3|0)+(((e|0)>1?2:1)&(e|2))<<2)>>2]|0;w=a>>>11&31;u=(aa(k[65208+((w|32)<<2)>>2]|0,b)|0)>>>8&255;t=l[x>>0]|0;t=(((aa(A-t|0,u)|0)+127|0)>>>8)+t|0;t=(((aa(A-(t&255)|0,u)|0)+127|0)>>>8)+t&255;i[x>>0]=t;x=x+y|0;t=(aa(k[65208+(w<<2)>>2]|0,b)|0)>>>8&255;u=l[x>>0]|0;u=(((aa(A-u|0,t)|0)+127|0)>>>8)+u|0;u=(((aa(A-(u&255)|0,t)|0)+127|0)>>>8)+u&255;i[x>>0]=u;x=x+y|0;b=(aa(k[65208+((w^63)<<2)>>2]|0,b)|0)>>>8&255;w=l[x>>0]|0;w=(((aa(A-w|0,b)|0)+127|0)>>>8)+w|0;w=(((aa(A-(w&255)|0,b)|0)+127|0)>>>8)+w&255;i[x>>0]=w;a=(k[v>>2]|0)+n|0;k[v>>2]=a;if((e|0)<=0)break;else{d=d+1|0;f=f+1|0;e=e+-1|0}}r=B;return}else{if(!d){r=B;return}d=s+(aa(a>>16,y)|0)|0;f=0;a=j;while(1){x=d+((a>>16)+-1)|0;v=k[z+(((((f|0)>1?2:1)&(f|2))*3|0)+(((e|0)>1?2:1)&(e|2))<<2)>>2]|0;w=a>>>11&31;u=(aa(k[65208+((w|32)<<2)>>2]|0,v)|0)>>>8&255;t=l[x>>0]|0;t=(((aa(A-t|0,u)|0)+127|0)>>>8)+t|0;t=(((aa(A-(t&255)|0,u)|0)+127|0)>>>8)+t&255;i[x>>0]=t;x=x+1|0;t=(aa(k[65208+(w<<2)>>2]|0,v)|0)>>>8&255;u=l[x>>0]|0;u=(((aa(A-u|0,t)|0)+127|0)>>>8)+u|0;u=(((aa(A-(u&255)|0,t)|0)+127|0)>>>8)+u&255;i[x>>0]=u;x=x+1|0;v=(aa(k[65208+((w^63)<<2)>>2]|0,v)|0)>>>8&255;w=l[x>>0]|0;w=(((aa(A-w|0,v)|0)+127|0)>>>8)+w|0;w=(((aa(A-(w&255)|0,v)|0)+127|0)>>>8)+w&255;i[x>>0]=w;a=(k[b>>2]|0)+m|0;k[b>>2]=a;if((e|0)<=0)break;else{d=d+y|0;f=f+1|0;e=e+-1|0}}r=B;return}}default:{d=(e|0)>-1;if(q){if(!d){r=B;return}d=s+(j>>16<<2)|0;f=0;while(1){o=d+(aa((a>>16)+-1|0,y)|0)|0;j=k[z+(((((f|0)>1?2:1)&(f|2))*3|0)+(((e|0)>1?2:1)&(e|2))<<2)>>2]|0;m=a>>>11&31;p=(aa(k[65208+((m|32)<<2)>>2]|0,j)|0)>>>8&255;c=l[o>>0]|0;c=(((aa(A-c|0,p)|0)+127|0)>>>8)+c|0;s=o+1|0;q=l[s>>0]|0;q=(((aa(x-q|0,p)|0)+127|0)>>>8)+q|0;b=o+2|0;t=l[b>>0]|0;t=(((aa(w-t|0,p)|0)+127|0)>>>8)+t|0;g=o+3|0;h=l[g>>0]|0;h=(((aa(u-h|0,p)|0)+127|0)>>>8)+h|0;q=(((aa(x-(q&255)|0,p)|0)+127|0)>>>8)+q|0;t=(((aa(w-(t&255)|0,p)|0)+127|0)>>>8)+t|0;h=(((aa(u-(h&255)|0,p)|0)+127|0)>>>8)+h|0;c=(((aa(A-(c&255)|0,p)|0)+127|0)>>>8)+c&255;i[o>>0]=c;i[s>>0]=q;i[b>>0]=t;i[g>>0]=h;o=o+y|0;g=(aa(k[65208+(m<<2)>>2]|0,j)|0)>>>8&255;h=l[o>>0]|0;h=(((aa(A-h|0,g)|0)+127|0)>>>8)+h|0;b=o+1|0;t=l[b>>0]|0;t=(((aa(x-t|0,g)|0)+127|0)>>>8)+t|0;s=o+2|0;q=l[s>>0]|0;q=(((aa(w-q|0,g)|0)+127|0)>>>8)+q|0;c=o+3|0;p=l[c>>0]|0;p=(((aa(u-p|0,g)|0)+127|0)>>>8)+p|0;t=(((aa(x-(t&255)|0,g)|0)+127|0)>>>8)+t|0;q=(((aa(w-(q&255)|0,g)|0)+127|0)>>>8)+q|0;p=(((aa(u-(p&255)|0,g)|0)+127|0)>>>8)+p|0;h=(((aa(A-(h&255)|0,g)|0)+127|0)>>>8)+h&255;i[o>>0]=h;i[b>>0]=t;i[s>>0]=q;i[c>>0]=p;o=o+y|0;j=(aa(k[65208+((m^63)<<2)>>2]|0,j)|0)>>>8&255;m=l[o>>0]|0;m=(((aa(A-m|0,j)|0)+127|0)>>>8)+m|0;c=o+1|0;p=l[c>>0]|0;p=(((aa(x-p|0,j)|0)+127|0)>>>8)+p|0;s=o+2|0;q=l[s>>0]|0;q=(((aa(w-q|0,j)|0)+127|0)>>>8)+q|0;b=o+3|0;t=l[b>>0]|0;t=(((aa(u-t|0,j)|0)+127|0)>>>8)+t|0;p=(((aa(x-(p&255)|0,j)|0)+127|0)>>>8)+p|0;q=(((aa(w-(q&255)|0,j)|0)+127|0)>>>8)+q|0;t=(((aa(u-(t&255)|0,j)|0)+127|0)>>>8)+t|0;m=(((aa(A-(m&255)|0,j)|0)+127|0)>>>8)+m&255;i[o>>0]=m;i[c>>0]=p;i[s>>0]=q;i[b>>0]=t;a=(k[v>>2]|0)+n|0;k[v>>2]=a;if((e|0)<=0)break;else{d=d+4|0;f=f+1|0;e=e+-1|0}}r=B;return}else{if(!d){r=B;return}d=s+(aa(a>>16,y)|0)|0;f=0;a=j;while(1){o=d+((a>>16<<2)+-4)|0;j=k[z+(((((f|0)>1?2:1)&(f|2))*3|0)+(((e|0)>1?2:1)&(e|2))<<2)>>2]|0;n=a>>>11&31;p=(aa(k[65208+((n|32)<<2)>>2]|0,j)|0)>>>8&255;c=l[o>>0]|0;c=(((aa(A-c|0,p)|0)+127|0)>>>8)+c|0;s=o+1|0;q=l[s>>0]|0;q=(((aa(x-q|0,p)|0)+127|0)>>>8)+q|0;v=o+2|0;t=l[v>>0]|0;t=(((aa(w-t|0,p)|0)+127|0)>>>8)+t|0;g=o+3|0;h=l[g>>0]|0;h=(((aa(u-h|0,p)|0)+127|0)>>>8)+h|0;q=(((aa(x-(q&255)|0,p)|0)+127|0)>>>8)+q|0;t=(((aa(w-(t&255)|0,p)|0)+127|0)>>>8)+t|0;h=(((aa(u-(h&255)|0,p)|0)+127|0)>>>8)+h|0;c=(((aa(A-(c&255)|0,p)|0)+127|0)>>>8)+c&255;i[o>>0]=c;i[s>>0]=q;i[v>>0]=t;i[g>>0]=h;o=o+4|0;g=(aa(k[65208+(n<<2)>>2]|0,j)|0)>>>8&255;h=l[o>>0]|0;h=(((aa(A-h|0,g)|0)+127|0)>>>8)+h|0;v=o+1|0;t=l[v>>0]|0;t=(((aa(x-t|0,g)|0)+127|0)>>>8)+t|0;s=o+2|0;q=l[s>>0]|0;q=(((aa(w-q|0,g)|0)+127|0)>>>8)+q|0;c=o+3|0;p=l[c>>0]|0;p=(((aa(u-p|0,g)|0)+127|0)>>>8)+p|0;t=(((aa(x-(t&255)|0,g)|0)+127|0)>>>8)+t|0;q=(((aa(w-(q&255)|0,g)|0)+127|0)>>>8)+q|0;p=(((aa(u-(p&255)|0,g)|0)+127|0)>>>8)+p|0;h=(((aa(A-(h&255)|0,g)|0)+127|0)>>>8)+h&255;i[o>>0]=h;i[v>>0]=t;i[s>>0]=q;i[c>>0]=p;o=o+4|0;j=(aa(k[65208+((n^63)<<2)>>2]|0,j)|0)>>>8&255;n=l[o>>0]|0;n=(((aa(A-n|0,j)|0)+127|0)>>>8)+n|0;c=o+1|0;p=l[c>>0]|0;p=(((aa(x-p|0,j)|0)+127|0)>>>8)+p|0;s=o+2|0;q=l[s>>0]|0;q=(((aa(w-q|0,j)|0)+127|0)>>>8)+q|0;v=o+3|0;t=l[v>>0]|0;t=(((aa(u-t|0,j)|0)+127|0)>>>8)+t|0;p=(((aa(x-(p&255)|0,j)|0)+127|0)>>>8)+p|0;q=(((aa(w-(q&255)|0,j)|0)+127|0)>>>8)+q|0;t=(((aa(u-(t&255)|0,j)|0)+127|0)>>>8)+t|0;n=(((aa(A-(n&255)|0,j)|0)+127|0)>>>8)+n&255;i[o>>0]=n;i[c>>0]=p;i[s>>0]=q;i[v>>0]=t;a=(k[b>>2]|0)+m|0;k[b>>2]=a;if((e|0)<=0)break;else{d=d+y|0;f=f+1|0;e=e+-1|0}}r=B;return}}}}break}default:{}}Ifa(a,k[b>>2]|0,k[b+4>>2]|0,k[c>>2]|0,k[c+4>>2]|0,d,8);r=B;return}function Lfa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;X=r;r=r+80|0;W=X+32|0;B=X+24|0;C=X+16|0;D=X+8|0;z=X;A=(f|0)==0;Q=A?0:1<<f+-1;K=k[a+16>>2]|0;E=k[a+40>>2]|0;V=k[E+4>>2]|0;E=k[E>>2]|0;g=k[a+4>>2]|0;if((g|0)>0)P=k[(k[a+44>>2]|0)+(g+-1<<2)>>2]|0;else P=0;N=(e|0)<16;L=N?32768:65535;M=N?32768:0;I=c+-1|0;O=16-f|0;t=k[b+(I<<3)>>2]<<O;s=k[b+(I<<3)+4>>2]<<O;o=k[b>>2]|0;n=k[b+4>>2]|0;a:do if((c|0)>0){v=B+4|0;w=C+4|0;x=D+4|0;y=z+4|0;if((e|0)<9){u=0;m=0;j=n;l=o;h=o;g=n;q=n;n=o}else{u=0;m=0;j=n;l=o;h=o;g=n;q=n;n=o;while(1){o=(q|0)<(j|0);j=o?q:j;m=o?u:m;g=(g|0)<(q|0)?q:g;h=(h|0)<(n|0)?n:h;l=(l|0)>(n|0)?n:l;o=n<<O;n=q<<O;k[D>>2]=t;k[x>>2]=s;k[z>>2]=o;k[y>>2]=n;Kfa(a,D,z,d);p=u+1|0;if((p|0)==(c|0))break a;u=p;t=o;s=n;q=k[b+(p<<3)+4>>2]|0;n=k[b+(p<<3)>>2]|0}}while(1){o=(q|0)<(j|0);j=o?q:j;m=o?u:m;g=(g|0)<(q|0)?q:g;h=(h|0)<(n|0)?n:h;l=(l|0)>(n|0)?n:l;o=n<<O;n=q<<O;if(A)Ifa(a,t>>16,s>>16,o>>16,n>>16,d,e);else{k[B>>2]=t;k[v>>2]=s;k[C>>2]=o;k[w>>2]=n;Jfa(a,B,C,d)}p=u+1|0;if((p|0)==(c|0))break a;u=p;t=o;s=n;q=k[b+(p<<3)+4>>2]|0;n=k[b+(p<<3)>>2]|0}}else{m=0;j=n;l=o;h=o;g=n}while(0);J=j+Q>>f;g=g+Q>>f;if((c|0)<3|(h+Q|g|0)<0){r=X;return}if(!((J|0)<(E|0)?(l+Q>>f|0)<(V|0):0)){r=X;return}G=E+-1|0;G=(g|0)>(G|0)?G:g;H=W+20|0;k[H>>2]=m;k[W>>2]=m;C=W+36|0;k[C>>2]=J;D=W+16|0;k[D>>2]=J;E=W+4|0;k[E>>2]=1;F=W+24|0;k[F>>2]=I;A=a+48|0;p=k[A>>2]|0;e=V+-1|0;B=(P|0)>0;w=W+32|0;x=W+28|0;y=W+12|0;z=W+8|0;t=J;u=0;v=1;q=K+(aa(p,J)|0)|0;g=c;h=0;while(1){s=(t|0)<(G|0);if((t|0)==(J|0)|(N|s)){if((t|0)>=(k[D>>2]|0)){j=k[W>>2]|0;n=k[E>>2]|0;l=(k[b+(j<<3)+4>>2]|0)+Q>>f;h=(l|0)>(t|0);if((g|0)==0|h)if(h)h=0;else{g=33;break}else{m=j;while(1){j=m+n|0;j=j-((j|0)>=(c|0)?c:0)|0;g=g+-1|0;l=(k[b+(j<<3)+4>>2]|0)+Q>>f;h=(l|0)>(t|0);if((g|0)==0|h)break;else m=j}if(h)h=k[b+(m<<3)>>2]<<O;else{g=33;break}}a=k[b+(j<<3)>>2]<<O;k[D>>2]=l;K=l-t|0;k[y>>2]=((a-h<<1)+K|0)/(K<<1|0)|0;k[z>>2]=h;k[W>>2]=j}if((t|0)>=(k[C>>2]|0)){j=k[H>>2]|0;n=k[F>>2]|0;l=(k[b+(j<<3)+4>>2]|0)+Q>>f;h=(l|0)>(t|0);if((g|0)==0|h)if(h)h=0;else{g=33;break}else{m=j;while(1){j=m+n|0;j=j-((j|0)>=(c|0)?c:0)|0;g=g+-1|0;l=(k[b+(j<<3)+4>>2]|0)+Q>>f;h=(l|0)>(t|0);if((g|0)==0|h)break;else m=j}if(h)h=k[b+(m<<3)>>2]<<O;else{g=33;break}}a=k[b+(j<<3)>>2]<<O;k[C>>2]=l;K=l-t|0;k[w>>2]=((a-h<<1)+K|0)/(K<<1|0)|0;k[x>>2]=h;k[H>>2]=j}h=k[W+(v*20|0)+8>>2]|0}m=(k[W+(u*20|0)+8>>2]|0)>(h|0)&1;v=m^v;u=m^u;m=W+(u*20|0)+8|0;n=k[m>>2]|0;o=W+(v*20|0)+8|0;l=k[o>>2]|0;b:do if(((t|0)>-1?(R=n+L>>16,S=l+M>>16,(R|0)<(V|0)&(S|0)>-1):0)?(a=aa((R|0)<0?0:R,P)|0,T=q+a|0,K=aa((S|0)<(V|0)?S:e,P)|0,U=q+K|0,(a|0)<=(K|0)):0){if(B)h=T;else{h=T;while(1){h=h+P|0;if(h>>>0>U>>>0){j=p;break b}}}do{j=0;do{i[h+j>>0]=i[d+j>>0]|0;j=j+1|0}while((j|0)!=(P|0));h=h+P|0}while(h>>>0<=U>>>0);j=k[A>>2]|0}else j=p;while(0);h=(k[W+(v*20|0)+12>>2]|0)+l|0;k[m>>2]=(k[W+(u*20|0)+12>>2]|0)+n;k[o>>2]=h;if(!s){g=33;break}else{t=t+1|0;q=q+j|0;p=j}}if((g|0)==33){r=X;return}}function Mfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;C=k[a+40>>2]|0;B=k[C+4>>2]|0;C=k[C>>2]|0;A=k[a+48>>2]|0;f=k[a+4>>2]|0;if((f|0)>0)z=k[(k[a+44>>2]|0)+(f+-1<<2)>>2]|0;else z=0;y=k[a+16>>2]|0;f=(c<<1)+-1|0;h=k[b>>2]|0;if((h|0)>=(c|0)&(h|0)<(B-c|0)?(g=k[b+4>>2]|0,(g|0)>=(c|0)):0)w=(g|0)<(C-c|0);else w=0;if((c|0)<0)return;x=b+4|0;t=(e|0)!=0;u=(z|0)>0;v=B+-1|0;q=0;a=c;r=0;s=1;p=f;while(1){o=k[x>>2]|0;f=o-r|0;m=o+r|0;n=o-a|0;o=o+a|0;g=h-a|0;j=h+a|0;c=h-r|0;h=h+r|0;a:do if(w){e=y+(aa(f,A)|0)|0;m=y+(aa(m,A)|0)|0;l=aa(g,z)|0;f=e+l|0;if(!t){upb(f|0,d|0,z|0)|0;upb(m+l|0,d|0,z|0)|0;l=aa(j,z)|0;upb(e+l|0,d|0,z|0)|0;upb(m+l|0,d|0,z|0)|0;m=y+(aa(n,A)|0)|0;n=y+(aa(o,A)|0)|0;o=aa(c,z)|0;upb(m+o|0,d|0,z|0)|0;upb(n+o|0,d|0,z|0)|0;o=aa(h,z)|0;upb(m+o|0,d|0,z|0)|0;upb(n+o|0,d|0,z|0)|0;break}j=aa(j,z)|0;e=e+j|0;b:do if((l|0)<=(j|0)){if(u)do{g=0;do{i[f+g>>0]=i[d+g>>0]|0;g=g+1|0}while((g|0)!=(z|0));f=f+z|0}while(f>>>0<=e>>>0);else do f=f+z|0;while(f>>>0<=e>>>0);f=m+l|0;e=m+j|0;if(!u)while(1){f=f+z|0;if(f>>>0>e>>>0)break b}do{g=0;do{i[f+g>>0]=i[d+g>>0]|0;g=g+1|0}while((g|0)!=(z|0));f=f+z|0}while(f>>>0<=e>>>0)}while(0);e=y+(aa(n,A)|0)|0;j=y+(aa(o,A)|0)|0;c=aa(c,z)|0;f=e+c|0;h=aa(h,z)|0;e=e+h|0;if((c|0)<=(h|0)){if(u)do{g=0;do{i[f+g>>0]=i[d+g>>0]|0;g=g+1|0}while((g|0)!=(z|0));f=f+z|0}while(f>>>0<=e>>>0);else do f=f+z|0;while(f>>>0<=e>>>0);f=j+c|0;e=j+h|0;if(!u)while(1){f=f+z|0;if(f>>>0>e>>>0)break a}do{g=0;do{i[f+g>>0]=i[d+g>>0]|0;g=g+1|0}while((g|0)!=(z|0));f=f+z|0}while(f>>>0<=e>>>0)}}else if((g|0)<(B|0)&(j|0)>-1?(n|0)<(C|0)&(o|0)>-1:0){if(t){j=(j|0)>(v|0)?v:j;l=(g|0)<0?0:g}else l=g;c:do if(f>>>0<C>>>0){g=y+(aa(f,A)|0)|0;if(!t){if((l|0)>-1)upb(g+(aa(l,z)|0)|0,d|0,z|0)|0;if((j|0)>=(B|0))break;upb(g+(aa(j,z)|0)|0,d|0,z|0)|0;break}E=aa(l,z)|0;f=g+E|0;D=aa(j,z)|0;e=g+D|0;if((E|0)<=(D|0)){if(!u)while(1){f=f+z|0;if(f>>>0>e>>>0)break c}do{g=0;do{i[f+g>>0]=i[d+g>>0]|0;g=g+1|0}while((g|0)!=(z|0));f=f+z|0}while(f>>>0<=e>>>0)}}while(0);d:do if(m>>>0<C>>>0){g=y+(aa(m,A)|0)|0;if(!t){if((l|0)>-1)upb(g+(aa(l,z)|0)|0,d|0,z|0)|0;if((j|0)>=(B|0))break;upb(g+(aa(j,z)|0)|0,d|0,z|0)|0;break}D=aa(l,z)|0;f=g+D|0;E=aa(j,z)|0;e=g+E|0;if((D|0)<=(E|0)){if(!u)while(1){f=f+z|0;if(f>>>0>e>>>0)break d}do{g=0;do{i[f+g>>0]=i[d+g>>0]|0;g=g+1|0}while((g|0)!=(z|0));f=f+z|0}while(f>>>0<=e>>>0)}}while(0);if((c|0)<(B|0)&(h|0)>-1){if(t){h=(h|0)>(v|0)?v:h;c=(c|0)<0?0:c}e:do if(n>>>0<C>>>0){g=y+(aa(n,A)|0)|0;if(!t){if((c|0)>-1)upb(g+(aa(c,z)|0)|0,d|0,z|0)|0;if((h|0)>=(B|0))break;upb(g+(aa(h,z)|0)|0,d|0,z|0)|0;break}D=aa(c,z)|0;f=g+D|0;E=aa(h,z)|0;e=g+E|0;if((D|0)<=(E|0)){if(!u)while(1){f=f+z|0;if(f>>>0>e>>>0)break e}do{g=0;do{i[f+g>>0]=i[d+g>>0]|0;g=g+1|0}while((g|0)!=(z|0));f=f+z|0}while(f>>>0<=e>>>0)}}while(0);if(o>>>0<C>>>0){g=y+(aa(o,A)|0)|0;if(!t){if((c|0)>-1)upb(g+(aa(c,z)|0)|0,d|0,z|0)|0;if((h|0)>=(B|0))break;upb(g+(aa(h,z)|0)|0,d|0,z|0)|0;break}D=aa(c,z)|0;f=g+D|0;E=aa(h,z)|0;e=g+E|0;if((D|0)<=(E|0)){if(!u)while(1){f=f+z|0;if(f>>>0>e>>>0)break a}do{g=0;do{i[f+g>>0]=i[d+g>>0]|0;g=g+1|0}while((g|0)!=(z|0));f=f+z|0}while(f>>>0<=e>>>0)}}}}while(0);f=q+s|0;g=(f|0)>0;a=(g<<31>>31)+a|0;if((a|0)<=(r|0))break;q=f-(g?p:0)|0;r=r+1|0;s=s+2|0;p=p-(g?2:0)|0;h=k[b>>2]|0}return}function Nfa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+48|0;o=t+28|0;m=t+8|0;p=t+16|0;q=t;n=k[c>>2]|0;n=(n|0)>-1?n:0-n|0;k[c>>2]=n;c=c+4|0;j=k[c>>2]|0;j=(j|0)>-1?j:0-j|0;k[c>>2]=j;c=((n|0)<(j|0)?j:n)+32768>>16;if((c|0)>=3)if((c|0)<10)c=30;else c=(c|0)<15?18:5;else c=90;k[o>>2]=0;s=o+4|0;k[s>>2]=0;k[o+8>>2]=0;k[m>>2]=k[b>>2];l=b+4|0;k[m+4>>2]=k[l>>2];Dfa(m,n,j,d,e,f,c,o);do if((h|0)>-1){j=k[o>>2]|0;c=k[s>>2]|0;Ofa(a,j,c-j>>3,0,g,h,i,16)}else{if((f-e|0)>359){j=k[o>>2]|0;c=k[s>>2]|0;Lfa(a,j,c-j>>3,g,i,16);break}c=k[s>>2]|0;if((c|0)==(k[o+8>>2]|0)){Efa(o,b);c=k[s>>2]|0;l=c}else{k[c>>2]=k[b>>2];k[c+4>>2]=k[l>>2];c=c+8|0;k[s>>2]=c;l=c}k[p>>2]=0;d=p+4|0;k[d>>2]=0;k[p+8>>2]=0;j=k[o>>2]|0;k[q>>2]=0;k[q+4>>2]=0;Pfa(a,j,l-j>>3,p,g,i,16,q);Qfa(a,p,g);l=k[p>>2]|0;m=l;if(l|0){n=k[d>>2]|0;if((n|0)!=(l|0))k[d>>2]=n+(~(((n+-20-m|0)>>>0)/20|0)*20|0);ggb(l)}}while(0);if(!j){r=t;return}if((c|0)!=(j|0))k[s>>2]=c+(~((c+-8-j|0)>>>3)<<3);ggb(j);r=t;return}function Ofa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+32|0;q=v+16|0;u=v+8|0;t=v;if((b|0)==0|(c|0)<1){r=v;return}s=d?c+-1|0:0;j=d&1^1;m=j|2;if(!((f|0)>-1&h>>>0<17)){d=q+4|0;l=ZT(56)|0;k[l>>2]=1;n=l+4|0;k[q>>2]=n;k[d>>2]=49;i[l+53>>0]=0;o=246205;p=n+49|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,q,246255,246054,1645);k[d>>2]=0;k[q>>2]=0;q=k[l>>2]|0;k[l>>2]=q+-1;if((q|0)==1)ggb(k[l+-4>>2]|0)}if((j|0)>=(c|0)){r=v;return}n=u+4|0;o=t+4|0;l=k[b+(s<<3)>>2]|0;d=k[b+(s<<3)+4>>2]|0;while(1){q=l;l=k[b+(j<<3)>>2]|0;s=d;d=k[b+(j<<3)+4>>2]|0;k[u>>2]=q;k[n>>2]=s;k[t>>2]=l;k[o>>2]=d;Hfa(a,u,t,e,f,g,m,h);j=j+1|0;if((j|0)==(c|0))break;else m=2}r=v;return}function Pfa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+48|0;A=B+16|0;s=B+8|0;o=B;t=(k[h+4>>2]|0)+((g|0)==0?0:1<<g+-1)|0;l=c+-1|0;u=16-g|0;m=(k[h>>2]|0)+(k[b+(l<<3)>>2]|0)<<u;l=(k[b+(l<<3)+4>>2]|0)+t>>g;v=d+4|0;Xfa(d,(((k[v>>2]|0)-(k[d>>2]|0)|0)/20|0)+c|0);if((c|0)<=0){r=B;return}w=A+4|0;x=A+8|0;y=A+12|0;z=d+8|0;p=s+4|0;q=o+4|0;if((f|0)<16){n=0;do{k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;k[A+16>>2]=0;i=m;m=(k[h>>2]|0)+(k[b+(n<<3)>>2]|0)<<u;j=l;l=(k[b+(n<<3)+4>>2]|0)+t>>g;Ifa(a,i+32768>>16,j,m+32768>>16,l,e,f);do if((l|0)!=(j|0)){s=(l|0)>(j|0);k[A>>2]=s?j:l;k[w>>2]=s?l:j;k[x>>2]=s?i:m;k[y>>2]=(m-i|0)/(l-j|0)|0;i=k[v>>2]|0;if((i|0)==(k[z>>2]|0)){Sfa(d,A);break}else{k[i>>2]=k[A>>2];k[i+4>>2]=k[A+4>>2];k[i+8>>2]=k[A+8>>2];k[i+12>>2]=k[A+12>>2];k[i+16>>2]=k[A+16>>2];k[v>>2]=(k[v>>2]|0)+20;break}}while(0);n=n+1|0}while((n|0)!=(c|0));r=B;return}else{n=0;do{k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;k[A+16>>2]=0;i=m;m=(k[h>>2]|0)+(k[b+(n<<3)>>2]|0)<<u;j=l;l=(k[b+(n<<3)+4>>2]|0)+t>>g;k[s>>2]=i;k[p>>2]=j<<16;k[o>>2]=m;k[q>>2]=l<<16;Kfa(a,s,o,e);do if((l|0)!=(j|0)){f=(l|0)>(j|0);k[A>>2]=f?j:l;k[w>>2]=f?l:j;k[x>>2]=f?i:m;k[y>>2]=(m-i|0)/(l-j|0)|0;i=k[v>>2]|0;if((i|0)==(k[z>>2]|0)){Sfa(d,A);break}else{k[i>>2]=k[A>>2];k[i+4>>2]=k[A+4>>2];k[i+8>>2]=k[A+8>>2];k[i+12>>2]=k[A+12>>2];k[i+16>>2]=k[A+16>>2];k[v>>2]=(k[v>>2]|0)+20;break}}while(0);n=n+1|0}while((n|0)!=(c|0));r=B;return}}function Qfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;F=r;r=r+32|0;C=F;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;k[C+16>>2]=0;m=b+4|0;j=k[m>>2]|0;h=k[b>>2]|0;e=j-h|0;D=(e|0)/20|0;n=k[a+40>>2]|0;z=k[n+4>>2]|0;n=k[n>>2]|0;d=k[a+4>>2]|0;if((d|0)>0)y=k[(k[a+44>>2]|0)+(d+-1<<2)>>2]|0;else y=0;if((e|0)<40){r=F;return}else{l=-2147483648;d=-2147483648;e=2147483647;f=2147483647;g=0}do{x=k[h+(g*20|0)+8>>2]|0;v=k[h+(g*20|0)+4>>2]|0;u=k[h+(g*20|0)>>2]|0;w=(aa(v-u|0,k[h+(g*20|0)+12>>2]|0)|0)+x|0;e=(u|0)<(e|0)?u:e;l=(l|0)<(v|0)?v:l;v=(x|0)<(f|0)?x:f;x=(d|0)<(x|0)?x:d;f=(w|0)<(v|0)?w:v;d=(x|0)<(w|0)?w:x;g=g+1|0}while((g|0)<(D|0));if((l|0)<0){r=F;return}if(!((f|0)<(z<<16|0)&((e|0)<(n|0)&(d|0)>-1))){r=F;return}Rfa(h,j);k[C>>2]=2147483647;d=k[m>>2]|0;if((d|0)==(k[b+8>>2]|0))Sfa(b,C);else{k[d>>2]=k[C>>2];k[d+4>>2]=k[C+4>>2];k[d+8>>2]=k[C+8>>2];k[d+12>>2]=k[C+12>>2];k[d+16>>2]=k[C+16>>2];k[m>>2]=(k[m>>2]|0)+20}x=C+16|0;k[x>>2]=0;e=k[b>>2]|0;v=(l|0)>(n|0)?n:l;d=k[e>>2]|0;if((d|0)>=(v|0)){r=F;return}w=a+16|0;s=a+44|0;t=z+-1|0;u=(y|0)>0;f=e;g=0;e=0;while(1){a:do if((d|0)<0){a=k[b>>2]|0;l=0;m=C;n=f;while(1){b:do if(!e)E=21;else{f=m+16|0;while(1){if((k[e+4>>2]|0)!=(d|0))break;e=e+16|0;k[f>>2]=k[e>>2];e=k[e>>2]|0;if(!e){E=21;break b}}if((k[n>>2]|0)<=(d|0)?(k[e+8>>2]|0)>=(k[n+8>>2]|0):0)if((g|0)<(D|0)){E=23;break}else{m=g;break a}h=k[e+16>>2]|0;j=e;f=n}while(0);if((E|0)==21){E=0;if(!((g|0)<(D|0)?(k[n>>2]|0)==(d|0):0)){m=g;break a}e=0;f=m+16|0;E=23}if((E|0)==23){E=0;k[f>>2]=n;k[n+16>>2]=e;g=g+1|0;h=e;j=n;f=a+(g*20|0)|0}if(l|0){q=m+8|0;k[q>>2]=(k[q>>2]|0)+(k[m+12>>2]|0);q=j+8|0;k[q>>2]=(k[q>>2]|0)+(k[j+12>>2]|0)}e=h;l=l^1;m=j;n=f}}else{p=0;q=C;h=f;while(1){c:do if(!e)E=30;else{f=q+16|0;while(1){if((k[e+4>>2]|0)!=(d|0))break;e=e+16|0;k[f>>2]=k[e>>2];e=k[e>>2]|0;if(!e){E=30;break c}}if((k[h>>2]|0)<=(d|0)?(k[e+8>>2]|0)>=(k[h+8>>2]|0):0)if((g|0)<(D|0)){E=39;break}else{n=h;m=g;break a}a=k[e+16>>2]|0;o=e;n=h}while(0);if((E|0)==30){E=0;if(!((g|0)<(D|0)?(k[h>>2]|0)==(d|0):0)){n=h;m=g;break a}e=0;f=q+16|0;E=39}if((E|0)==39){E=0;k[f>>2]=h;k[h+16>>2]=e;g=g+1|0;a=e;o=h;n=(k[b>>2]|0)+(g*20|0)|0}if(p|0){f=(k[w>>2]|0)+(aa(k[k[s>>2]>>2]|0,d)|0)|0;l=q+8|0;e=k[l>>2]|0;m=o+8|0;j=k[m>>2]|0;G=(e|0)>(j|0);h=(G?j:e)+65535>>16;j=(G?e:j)>>16;d:do if((j|0)>-1&(h|0)<(z|0)?(h=aa((h|0)<0?0:h,y)|0,A=f+h|0,G=aa((j|0)<(z|0)?j:t,y)|0,B=f+G|0,(h|0)<=(G|0)):0){if(u)f=A;else{f=A;while(1){f=f+y|0;if(f>>>0>B>>>0)break d}}do{e=0;do{i[f+e>>0]=i[c+e>>0]|0;e=e+1|0}while((e|0)!=(y|0));f=f+y|0}while(f>>>0<=B>>>0);e=k[l>>2]|0}while(0);k[l>>2]=e+(k[q+12>>2]|0);k[m>>2]=(k[m>>2]|0)+(k[o+12>>2]|0)}e=a;p=p^1;q=o;h=n}}while(0);e=0;l=0;f=k[x>>2]|0;while(1){g=C;e:while(1){while(1){if((f|0)==(l|0))break e;h=f+16|0;j=k[h>>2]|0;if(!j)break e;if((k[f+8>>2]|0)>(k[j+8>>2]|0))break;else{g=f;f=j}}k[g+16>>2]=j;e=j+16|0;k[h>>2]=k[e>>2];k[e>>2]=f;e=1;g=j}if(!e)break;f=k[x>>2]|0;if(!((g|0)!=(C|0)&(g|0)!=(f|0)))break;else l=g}d=d+1|0;if((d|0)>=(v|0))break;f=n;g=m;e=k[x>>2]|0}r=F;return}function Rfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+32|0;u=w;a:while(1){o=b;s=b+-20|0;p=b+-40|0;q=b+-12|0;t=b+-8|0;while(1){b:while(1){n=a;c=o-n|0;switch((c|0)/20|0|0){case 2:{v=5;break a}case 3:{v=11;break a}case 4:{v=12;break a}case 5:{v=13;break a}case 1:case 0:{v=107;break a}default:{}}if((c|0)<620){v=15;break a}f=(c>>>0)/40|0;m=a+(f*20|0)|0;if((c|0)>19980){c=(c>>>0)/80|0;c=Vfa(a,a+(c*20|0)|0,m,m+(c*20|0)|0,s)|0}else c=Tfa(a,m,s)|0;l=k[a>>2]|0;j=k[m>>2]|0;do if((l|0)==(j|0)){d=k[a+8>>2]|0;e=k[a+(f*20|0)+8>>2]|0;if((d|0)==(e|0))if((k[a+12>>2]|0)<(k[a+(f*20|0)+12>>2]|0)){d=s;break b}else break;else if((d|0)<(e|0)){d=s;break b}else break}else if((l|0)<(j|0)){d=s;break b}while(0);if((a|0)!=(p|0)){i=a+(f*20|0)+8|0;h=a+(f*20|0)+12|0;g=s;d=p;while(1){e=k[d>>2]|0;do if((e|0)==(j|0)){e=k[g+-12>>2]|0;f=k[i>>2]|0;if((e|0)==(f|0))if((k[g+-8>>2]|0)<(k[h>>2]|0)){v=77;break b}else break;else if((e|0)<(f|0)){v=77;break b}else break}else if((e|0)<(j|0)){v=77;break b}while(0);e=d+-20|0;if((a|0)==(e|0))break;else{g=d;d=e}}}e=a+20|0;c=k[s>>2]|0;do if((l|0)==(c|0)){c=k[a+8>>2]|0;d=k[q>>2]|0;if((c|0)==(d|0))if((k[a+12>>2]|0)<(k[t>>2]|0)){c=e;break}else{v=46;break}else if((c|0)<(d|0)){c=e;break}else{v=46;break}}else if((l|0)<(c|0))c=e;else v=46;while(0);if((v|0)==46){v=0;if((e|0)==(s|0)){v=107;break a}f=a+8|0;g=a+12|0;c=e;c:while(1){d=k[c>>2]|0;do if((l|0)==(d|0)){d=k[f>>2]|0;e=k[c+8>>2]|0;if((d|0)==(e|0))if((k[g>>2]|0)<(k[c+12>>2]|0))break c;else break;else if((d|0)<(e|0))break c;else break}else if((l|0)<(d|0))break c;while(0);c=c+20|0;if((c|0)==(s|0)){v=107;break a}}k[u>>2]=k[c>>2];k[u+4>>2]=k[c+4>>2];k[u+8>>2]=k[c+8>>2];k[u+12>>2]=k[c+12>>2];k[u+16>>2]=k[c+16>>2];k[c>>2]=k[s>>2];k[c+4>>2]=k[s+4>>2];k[c+8>>2]=k[s+8>>2];k[c+12>>2]=k[s+12>>2];k[c+16>>2]=k[s+16>>2];k[s>>2]=k[u>>2];k[s+4>>2]=k[u+4>>2];k[s+8>>2]=k[u+8>>2];k[s+12>>2]=k[u+12>>2];k[s+16>>2]=k[u+16>>2];c=c+20|0}if((c|0)==(s|0)){v=107;break a}i=a+12|0;j=a+8|0;f=s;while(1){h=k[a>>2]|0;d:while(1){d=k[c>>2]|0;do if((h|0)==(d|0)){d=k[j>>2]|0;e=k[c+8>>2]|0;if((d|0)==(e|0))if((k[i>>2]|0)<(k[c+12>>2]|0))break d;else break;else if((d|0)<(e|0))break d;else break}else if((h|0)<(d|0))break d;while(0);c=c+20|0}while(1){g=f+-20|0;d=k[g>>2]|0;if((h|0)!=(d|0))if((h|0)<(d|0)){f=g;continue}else break;d=k[j>>2]|0;e=k[f+-12>>2]|0;if((d|0)==(e|0))if((k[i>>2]|0)<(k[f+-8>>2]|0)){f=g;continue}else break;else if((d|0)<(e|0)){f=g;continue}else break}if(c>>>0>=g>>>0){a=c;continue b};k[u>>2]=k[c>>2];k[u+4>>2]=k[c+4>>2];k[u+8>>2]=k[c+8>>2];k[u+12>>2]=k[c+12>>2];k[u+16>>2]=k[c+16>>2];k[c>>2]=k[g>>2];k[c+4>>2]=k[g+4>>2];k[c+8>>2]=k[g+8>>2];k[c+12>>2]=k[g+12>>2];k[c+16>>2]=k[g+16>>2];k[g>>2]=k[u>>2];k[g+4>>2]=k[u+4>>2];k[g+8>>2]=k[u+8>>2];k[g+12>>2]=k[u+12>>2];k[g+16>>2]=k[u+16>>2];f=g;c=c+20|0}}if((v|0)==77){v=0;k[u>>2]=k[a>>2];k[u+4>>2]=k[a+4>>2];k[u+8>>2]=k[a+8>>2];k[u+12>>2]=k[a+12>>2];k[u+16>>2]=k[a+16>>2];k[a>>2]=k[d>>2];k[a+4>>2]=k[d+4>>2];k[a+8>>2]=k[d+8>>2];k[a+12>>2]=k[d+12>>2];k[a+16>>2]=k[d+16>>2];k[d>>2]=k[u>>2];k[d+4>>2]=k[u+4>>2];k[d+8>>2]=k[u+8>>2];k[d+12>>2]=k[u+12>>2];k[d+16>>2]=k[u+16>>2];c=c+1|0}e=a+20|0;e:do if(e>>>0<d>>>0)while(1){i=k[m>>2]|0;j=m+8|0;l=m+12|0;f:while(1){f=k[e>>2]|0;do if((f|0)==(i|0)){f=k[e+8>>2]|0;g=k[j>>2]|0;if((f|0)==(g|0))if((k[e+12>>2]|0)<(k[l>>2]|0))break;else break f;else if((f|0)<(g|0))break;else break f}else if((f|0)>=(i|0))break f;while(0);e=e+20|0}while(1){h=d+-20|0;f=k[h>>2]|0;if((f|0)!=(i|0))if((f|0)<(i|0))break;else{d=h;continue}f=k[d+-12>>2]|0;g=k[j>>2]|0;if((f|0)==(g|0))if((k[d+-8>>2]|0)<(k[l>>2]|0))break;else{d=h;continue}else if((f|0)<(g|0))break;else{d=h;continue}}if(e>>>0>h>>>0){f=m;g=e;break e};k[u>>2]=k[e>>2];k[u+4>>2]=k[e+4>>2];k[u+8>>2]=k[e+8>>2];k[u+12>>2]=k[e+12>>2];k[u+16>>2]=k[e+16>>2];k[e>>2]=k[h>>2];k[e+4>>2]=k[h+4>>2];k[e+8>>2]=k[h+8>>2];k[e+12>>2]=k[h+12>>2];k[e+16>>2]=k[h+16>>2];k[h>>2]=k[u>>2];k[h+4>>2]=k[u+4>>2];k[h+8>>2]=k[u+8>>2];k[h+12>>2]=k[u+12>>2];k[h+16>>2]=k[u+16>>2];m=(m|0)==(e|0)?h:m;d=h;e=e+20|0;c=c+1|0}else{f=m;g=e}while(0);g:do if((g|0)!=(f|0)){d=k[f>>2]|0;e=k[g>>2]|0;do if((d|0)==(e|0)){d=k[f+8>>2]|0;e=k[g+8>>2]|0;if((d|0)==(e|0))if((k[f+12>>2]|0)<(k[g+12>>2]|0))break;else break g;else if((d|0)<(e|0))break;else break g}else if((d|0)>=(e|0))break g;while(0);k[u>>2]=k[g>>2];k[u+4>>2]=k[g+4>>2];k[u+8>>2]=k[g+8>>2];k[u+12>>2]=k[g+12>>2];k[u+16>>2]=k[g+16>>2];k[g>>2]=k[f>>2];k[g+4>>2]=k[f+4>>2];k[g+8>>2]=k[f+8>>2];k[g+12>>2]=k[f+12>>2];k[g+16>>2]=k[f+16>>2];k[f>>2]=k[u>>2];k[f+4>>2]=k[u+4>>2];k[f+8>>2]=k[u+8>>2];k[f+12>>2]=k[u+12>>2];k[f+16>>2]=k[u+16>>2];c=c+1|0}while(0);if(!c){c=Wfa(a,g)|0;d=g+20|0;if(Wfa(d,b)|0){v=106;break}if(c){a=d;continue}}m=g;if((m-n|0)>=(o-m|0)){v=105;break}Rfa(a,g);a=g+20|0}if((v|0)==105){v=0;Rfa(g+20|0,b);b=g;continue}else if((v|0)==106){v=0;if(c){v=107;break}else{b=g;continue}}}if((v|0)==5){b=k[s>>2]|0;c=k[a>>2]|0;do if((b|0)==(c|0)){b=k[q>>2]|0;c=k[a+8>>2]|0;if((b|0)==(c|0)){if((k[t>>2]|0)<(k[a+12>>2]|0))break;r=w;return}else{if((b|0)<(c|0))break;r=w;return}}else if((b|0)>=(c|0)){r=w;return}while(0);k[u>>2]=k[a>>2];k[u+4>>2]=k[a+4>>2];k[u+8>>2]=k[a+8>>2];k[u+12>>2]=k[a+12>>2];k[u+16>>2]=k[a+16>>2];k[a>>2]=k[s>>2];k[a+4>>2]=k[s+4>>2];k[a+8>>2]=k[s+8>>2];k[a+12>>2]=k[s+12>>2];k[a+16>>2]=k[s+16>>2];k[s>>2]=k[u>>2];k[s+4>>2]=k[u+4>>2];k[s+8>>2]=k[u+8>>2];k[s+12>>2]=k[u+12>>2];k[s+16>>2]=k[u+16>>2];r=w;return}else if((v|0)==11){Tfa(a,a+20|0,s)|0;r=w;return}else if((v|0)==12){Ufa(a,a+20|0,a+40|0,s)|0;r=w;return}else if((v|0)==13){Vfa(a,a+20|0,a+40|0,a+60|0,s)|0;r=w;return}else if((v|0)==15){d=a+40|0;Tfa(a,a+20|0,d)|0;c=a+60|0;if((c|0)==(b|0)){r=w;return}while(1){l=k[c>>2]|0;e=k[d>>2]|0;do if((l|0)==(e|0)){e=k[c+8>>2]|0;f=k[d+8>>2]|0;if((e|0)==(f|0))if((k[c+12>>2]|0)<(k[d+12>>2]|0)){v=22;break}else break;else if((e|0)<(f|0)){v=22;break}else break}else if((l|0)<(e|0)){e=k[c+8>>2]|0;v=22}while(0);if((v|0)==22){v=0;h=k[c+4>>2]|0;i=k[c+12>>2]|0;j=k[c+16>>2]|0;k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];k[c+16>>2]=k[d+16>>2];h:do if((d|0)==(a|0))d=a;else while(1){g=d;d=d+-20|0;f=k[d>>2]|0;do if((l|0)==(f|0)){f=k[g+-12>>2]|0;if((e|0)==(f|0))if((i|0)<(k[g+-8>>2]|0))break;else{d=g;break h}else if((e|0)<(f|0))break;else{d=g;break h}}else if((l|0)>=(f|0)){d=g;break h}while(0);k[g>>2]=k[d>>2];k[g+4>>2]=k[d+4>>2];k[g+8>>2]=k[d+8>>2];k[g+12>>2]=k[d+12>>2];k[g+16>>2]=k[d+16>>2];if((d|0)==(a|0)){d=a;break}}while(0);k[d>>2]=l;k[d+4>>2]=h;k[d+8>>2]=e;k[d+12>>2]=i;k[d+16>>2]=j}d=c+20|0;if((d|0)==(b|0))break;else{u=c;c=d;d=u}}r=w;return}else if((v|0)==107){r=w;return}}function Sfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=a+4|0;h=k[a>>2]|0;i=(k[g>>2]|0)-h|0;e=(i|0)/20|0;c=e+1|0;if(c>>>0>214748364)ad(426534,426557,304,426811);j=a+8|0;d=((k[j>>2]|0)-h|0)/20|0;f=d<<1;f=d>>>0<107374182?(f>>>0<c>>>0?c:f):214748364;if(!f)c=0;else{if(f>>>0>214748364){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=f*20|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(e*20|0)|0;k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2];k[e+12>>2]=k[b+12>>2];k[e+16>>2]=k[b+16>>2];d=e+(((i|0)/-20|0)*20|0)|0;if((i|0)>0)upb(d|0,h|0,i|0)|0;k[a>>2]=d;k[g>>2]=e+20;k[j>>2]=c+(f*20|0);if(!h)return;ggb(h);return}function Tfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=r;r=r+32|0;h=i;f=k[b>>2]|0;d=k[a>>2]|0;do if((f|0)==(d|0)){e=k[b+8>>2]|0;d=k[a+8>>2]|0;if((e|0)==(d|0)){g=(k[b+12>>2]|0)<(k[a+12>>2]|0);break}else{g=(e|0)<(d|0);break}}else g=(f|0)<(d|0);while(0);d=k[c>>2]|0;do if((d|0)==(f|0)){d=k[c+8>>2]|0;e=k[b+8>>2]|0;if((d|0)==(e|0)){d=(k[c+12>>2]|0)<(k[b+12>>2]|0);break}else{d=(d|0)<(e|0);break}}else d=(d|0)<(f|0);while(0);if(!g){if(!d){h=0;r=i;return h|0};k[h>>2]=k[b>>2];k[h+4>>2]=k[b+4>>2];k[h+8>>2]=k[b+8>>2];k[h+12>>2]=k[b+12>>2];k[h+16>>2]=k[b+16>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[b+16>>2]=k[c+16>>2];k[c>>2]=k[h>>2];k[c+4>>2]=k[h+4>>2];k[c+8>>2]=k[h+8>>2];k[c+12>>2]=k[h+12>>2];k[c+16>>2]=k[h+16>>2];d=k[b>>2]|0;e=k[a>>2]|0;do if((d|0)==(e|0)){d=k[b+8>>2]|0;e=k[a+8>>2]|0;if((d|0)==(e|0)){if((k[b+12>>2]|0)<(k[a+12>>2]|0))break;else d=1;r=i;return d|0}else{if((d|0)<(e|0))break;else d=1;r=i;return d|0}}else if((d|0)>=(e|0)){h=1;r=i;return h|0}while(0);k[h>>2]=k[a>>2];k[h+4>>2]=k[a+4>>2];k[h+8>>2]=k[a+8>>2];k[h+12>>2]=k[a+12>>2];k[h+16>>2]=k[a+16>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];k[b>>2]=k[h>>2];k[b+4>>2]=k[h+4>>2];k[b+8>>2]=k[h+8>>2];k[b+12>>2]=k[h+12>>2];k[b+16>>2]=k[h+16>>2];h=2;r=i;return h|0}if(d){k[h>>2]=k[a>>2];k[h+4>>2]=k[a+4>>2];k[h+8>>2]=k[a+8>>2];k[h+12>>2]=k[a+12>>2];k[h+16>>2]=k[a+16>>2];k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[a+16>>2]=k[c+16>>2];k[c>>2]=k[h>>2];k[c+4>>2]=k[h+4>>2];k[c+8>>2]=k[h+8>>2];k[c+12>>2]=k[h+12>>2];k[c+16>>2]=k[h+16>>2];h=1;r=i;return h|0};k[h>>2]=k[a>>2];k[h+4>>2]=k[a+4>>2];k[h+8>>2]=k[a+8>>2];k[h+12>>2]=k[a+12>>2];k[h+16>>2]=k[a+16>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];k[b>>2]=k[h>>2];k[b+4>>2]=k[h+4>>2];k[b+8>>2]=k[h+8>>2];k[b+12>>2]=k[h+12>>2];k[b+16>>2]=k[h+16>>2];d=k[c>>2]|0;e=k[b>>2]|0;do if((d|0)==(e|0)){d=k[c+8>>2]|0;e=k[b+8>>2]|0;if((d|0)==(e|0)){if((k[c+12>>2]|0)<(k[b+12>>2]|0))break;else d=1;r=i;return d|0}else{if((d|0)<(e|0))break;else d=1;r=i;return d|0}}else if((d|0)>=(e|0)){h=1;r=i;return h|0}while(0);k[h>>2]=k[b>>2];k[h+4>>2]=k[b+4>>2];k[h+8>>2]=k[b+8>>2];k[h+12>>2]=k[b+12>>2];k[h+16>>2]=k[b+16>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[b+16>>2]=k[c+16>>2];k[c>>2]=k[h>>2];k[c+4>>2]=k[h+4>>2];k[c+8>>2]=k[h+8>>2];k[c+12>>2]=k[h+12>>2];k[c+16>>2]=k[h+16>>2];h=2;r=i;return h|0}function Ufa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=r;r=r+32|0;g=i;h=Tfa(a,b,c)|0;e=k[d>>2]|0;f=k[c>>2]|0;do if((e|0)==(f|0)){e=k[d+8>>2]|0;f=k[c+8>>2]|0;if((e|0)==(f|0)){if((k[d+12>>2]|0)<(k[c+12>>2]|0))break;else e=h;r=i;return e|0}else{if((e|0)<(f|0))break;else e=h;r=i;return e|0}}else if((e|0)>=(f|0)){r=i;return h|0}while(0);k[g>>2]=k[c>>2];k[g+4>>2]=k[c+4>>2];k[g+8>>2]=k[c+8>>2];k[g+12>>2]=k[c+12>>2];k[g+16>>2]=k[c+16>>2];k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];k[c+16>>2]=k[d+16>>2];k[d>>2]=k[g>>2];k[d+4>>2]=k[g+4>>2];k[d+8>>2]=k[g+8>>2];k[d+12>>2]=k[g+12>>2];k[d+16>>2]=k[g+16>>2];e=h+1|0;f=k[c>>2]|0;d=k[b>>2]|0;do if((f|0)==(d|0)){f=k[c+8>>2]|0;d=k[b+8>>2]|0;if((f|0)==(d|0)){if((k[c+12>>2]|0)<(k[b+12>>2]|0))break;r=i;return e|0}else{if((f|0)<(d|0))break;r=i;return e|0}}else if((f|0)>=(d|0)){h=e;r=i;return h|0}while(0);k[g>>2]=k[b>>2];k[g+4>>2]=k[b+4>>2];k[g+8>>2]=k[b+8>>2];k[g+12>>2]=k[b+12>>2];k[g+16>>2]=k[b+16>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[b+16>>2]=k[c+16>>2];k[c>>2]=k[g>>2];k[c+4>>2]=k[g+4>>2];k[c+8>>2]=k[g+8>>2];k[c+12>>2]=k[g+12>>2];k[c+16>>2]=k[g+16>>2];e=h+2|0;f=k[b>>2]|0;d=k[a>>2]|0;do if((f|0)==(d|0)){f=k[b+8>>2]|0;d=k[a+8>>2]|0;if((f|0)==(d|0)){if((k[b+12>>2]|0)<(k[a+12>>2]|0))break;r=i;return e|0}else{if((f|0)<(d|0))break;r=i;return e|0}}else if((f|0)>=(d|0)){h=e;r=i;return h|0}while(0);k[g>>2]=k[a>>2];k[g+4>>2]=k[a+4>>2];k[g+8>>2]=k[a+8>>2];k[g+12>>2]=k[a+12>>2];k[g+16>>2]=k[a+16>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];k[b>>2]=k[g>>2];k[b+4>>2]=k[g+4>>2];k[b+8>>2]=k[g+8>>2];k[b+12>>2]=k[g+12>>2];k[b+16>>2]=k[g+16>>2];h=h+3|0;r=i;return h|0}function Vfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;j=r;r=r+32|0;h=j;i=Ufa(a,b,c,d)|0;f=k[e>>2]|0;g=k[d>>2]|0;do if((f|0)==(g|0)){f=k[e+8>>2]|0;g=k[d+8>>2]|0;if((f|0)==(g|0)){if((k[e+12>>2]|0)<(k[d+12>>2]|0))break;else f=i;r=j;return f|0}else{if((f|0)<(g|0))break;else f=i;r=j;return f|0}}else if((f|0)>=(g|0)){r=j;return i|0}while(0);k[h>>2]=k[d>>2];k[h+4>>2]=k[d+4>>2];k[h+8>>2]=k[d+8>>2];k[h+12>>2]=k[d+12>>2];k[h+16>>2]=k[d+16>>2];k[d>>2]=k[e>>2];k[d+4>>2]=k[e+4>>2];k[d+8>>2]=k[e+8>>2];k[d+12>>2]=k[e+12>>2];k[d+16>>2]=k[e+16>>2];k[e>>2]=k[h>>2];k[e+4>>2]=k[h+4>>2];k[e+8>>2]=k[h+8>>2];k[e+12>>2]=k[h+12>>2];k[e+16>>2]=k[h+16>>2];f=i+1|0;g=k[d>>2]|0;e=k[c>>2]|0;do if((g|0)==(e|0)){g=k[d+8>>2]|0;e=k[c+8>>2]|0;if((g|0)==(e|0)){if((k[d+12>>2]|0)<(k[c+12>>2]|0))break;r=j;return f|0}else{if((g|0)<(e|0))break;r=j;return f|0}}else if((g|0)>=(e|0)){i=f;r=j;return i|0}while(0);k[h>>2]=k[c>>2];k[h+4>>2]=k[c+4>>2];k[h+8>>2]=k[c+8>>2];k[h+12>>2]=k[c+12>>2];k[h+16>>2]=k[c+16>>2];k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];k[c+8>>2]=k[d+8>>2];k[c+12>>2]=k[d+12>>2];k[c+16>>2]=k[d+16>>2];k[d>>2]=k[h>>2];k[d+4>>2]=k[h+4>>2];k[d+8>>2]=k[h+8>>2];k[d+12>>2]=k[h+12>>2];k[d+16>>2]=k[h+16>>2];f=i+2|0;g=k[c>>2]|0;e=k[b>>2]|0;do if((g|0)==(e|0)){g=k[c+8>>2]|0;e=k[b+8>>2]|0;if((g|0)==(e|0)){if((k[c+12>>2]|0)<(k[b+12>>2]|0))break;r=j;return f|0}else{if((g|0)<(e|0))break;r=j;return f|0}}else if((g|0)>=(e|0)){i=f;r=j;return i|0}while(0);k[h>>2]=k[b>>2];k[h+4>>2]=k[b+4>>2];k[h+8>>2]=k[b+8>>2];k[h+12>>2]=k[b+12>>2];k[h+16>>2]=k[b+16>>2];k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];k[b+8>>2]=k[c+8>>2];k[b+12>>2]=k[c+12>>2];k[b+16>>2]=k[c+16>>2];k[c>>2]=k[h>>2];k[c+4>>2]=k[h+4>>2];k[c+8>>2]=k[h+8>>2];k[c+12>>2]=k[h+12>>2];k[c+16>>2]=k[h+16>>2];f=i+3|0;g=k[b>>2]|0;e=k[a>>2]|0;do if((g|0)==(e|0)){g=k[b+8>>2]|0;e=k[a+8>>2]|0;if((g|0)==(e|0)){if((k[b+12>>2]|0)<(k[a+12>>2]|0))break;r=j;return f|0}else{if((g|0)<(e|0))break;r=j;return f|0}}else if((g|0)>=(e|0)){i=f;r=j;return i|0}while(0);k[h>>2]=k[a>>2];k[h+4>>2]=k[a+4>>2];k[h+8>>2]=k[a+8>>2];k[h+12>>2]=k[a+12>>2];k[h+16>>2]=k[a+16>>2];k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];k[a+16>>2]=k[b+16>>2];k[b>>2]=k[h>>2];k[b+4>>2]=k[h+4>>2];k[b+8>>2]=k[h+8>>2];k[b+12>>2]=k[h+12>>2];k[b+16>>2]=k[h+16>>2];i=i+4|0;r=j;return i|0}function Wfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+32|0;f=o;switch((b-a|0)/20|0|0){case 2:{e=b+-20|0;c=k[e>>2]|0;d=k[a>>2]|0;do if((c|0)==(d|0)){c=k[b+-12>>2]|0;d=k[a+8>>2]|0;if((c|0)==(d|0)){if((k[b+-8>>2]|0)<(k[a+12>>2]|0))break;else c=1;r=o;return c|0}else{if((c|0)<(d|0))break;else c=1;r=o;return c|0}}else if((c|0)>=(d|0)){b=1;r=o;return b|0}while(0);k[f>>2]=k[a>>2];k[f+4>>2]=k[a+4>>2];k[f+8>>2]=k[a+8>>2];k[f+12>>2]=k[a+12>>2];k[f+16>>2]=k[a+16>>2];k[a>>2]=k[e>>2];k[a+4>>2]=k[e+4>>2];k[a+8>>2]=k[e+8>>2];k[a+12>>2]=k[e+12>>2];k[a+16>>2]=k[e+16>>2];k[e>>2]=k[f>>2];k[e+4>>2]=k[f+4>>2];k[e+8>>2]=k[f+8>>2];k[e+12>>2]=k[f+12>>2];k[e+16>>2]=k[f+16>>2];b=1;r=o;return b|0}case 3:{Tfa(a,a+20|0,b+-20|0)|0;b=1;r=o;return b|0}case 4:{Ufa(a,a+20|0,a+40|0,b+-20|0)|0;b=1;r=o;return b|0}case 5:{Vfa(a,a+20|0,a+40|0,a+60|0,b+-20|0)|0;b=1;r=o;return b|0}case 1:case 0:{b=1;r=o;return b|0}default:{e=a+40|0;Tfa(a,a+20|0,e)|0;c=a+60|0;a:do if((c|0)==(b|0)){d=1;c=0}else{d=0;while(1){m=k[c>>2]|0;f=k[e>>2]|0;do if((m|0)==(f|0)){f=k[c+8>>2]|0;g=k[e+8>>2]|0;if((f|0)==(g|0))if((k[c+12>>2]|0)<(k[e+12>>2]|0)){n=18;break}else break;else if((f|0)<(g|0)){n=18;break}else break}else if((m|0)<(f|0)){f=k[c+8>>2]|0;n=18}while(0);if((n|0)==18){n=0;i=k[c+4>>2]|0;j=k[c+12>>2]|0;l=k[c+16>>2]|0;k[c>>2]=k[e>>2];k[c+4>>2]=k[e+4>>2];k[c+8>>2]=k[e+8>>2];k[c+12>>2]=k[e+12>>2];k[c+16>>2]=k[e+16>>2];b:do if((e|0)==(a|0))e=a;else while(1){h=e;e=e+-20|0;g=k[e>>2]|0;do if((m|0)==(g|0)){g=k[h+-12>>2]|0;if((f|0)==(g|0))if((j|0)<(k[h+-8>>2]|0))break;else{e=h;break b}else if((f|0)<(g|0))break;else{e=h;break b}}else if((m|0)>=(g|0)){e=h;break b}while(0);k[h>>2]=k[e>>2];k[h+4>>2]=k[e+4>>2];k[h+8>>2]=k[e+8>>2];k[h+12>>2]=k[e+12>>2];k[h+16>>2]=k[e+16>>2];if((e|0)==(a|0)){e=a;break}}while(0);k[e>>2]=m;k[e+4>>2]=i;k[e+8>>2]=f;k[e+12>>2]=j;k[e+16>>2]=l;d=d+1|0;if((d|0)==8){d=0;c=(c+20|0)==(b|0);break a}}e=c+20|0;if((e|0)==(b|0)){d=1;c=0;break}else{m=c;c=e;e=m}}}while(0);b=c|d;r=o;return b|0}}return 0}function Xfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;g=a+8|0;h=k[a>>2]|0;if((((k[g>>2]|0)-h|0)/20|0)>>>0>=b>>>0)return;i=a+4|0;f=(k[i>>2]|0)-h|0;e=(f|0)/20|0;if(!b)c=0;else{if(b>>>0>214748364){i=te(4)|0;k[i>>2]=172664;Cf(i|0,28816,1287)}d=b*20|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}d=c+(e*20|0)|0;e=d+(((f|0)/-20|0)*20|0)|0;if((f|0)>0)upb(e|0,h|0,f|0)|0;k[a>>2]=e;k[i>>2]=d;k[g>>2]=c+(b*20|0);if(!h)return;ggb(h);return}function Yfa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+128|0;t=u+64|0;q=u;s=u+32|0;do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[t>>2]=k[l>>2];p=t+4|0;a=l+4|0;k[p>>2]=k[a>>2];o=t+8|0;k[o>>2]=k[l+8>>2];k[t+12>>2]=k[l+12>>2];k[t+16>>2]=k[l+16>>2];k[t+20>>2]=k[l+20>>2];k[t+24>>2]=k[l+24>>2];k[t+28>>2]=k[l+28>>2];k[t+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[t+36>>2]=h;j=t+40|0;k[j>>2]=o;o=t+48|0;n=t+44|0;k[n>>2]=o;k[t+52>>2]=0;k[o>>2]=0;if(h|0){o=h+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[a>>2]|0)<3){o=k[l+44>>2]|0;p=k[n>>2]|0;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];break}k[p>>2]=0;x1(t,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(t,a,-1);while(0);if((f|0)==16)f=(k[t>>2]&7|0)==0?16:8;if((e|0)>=32768){k[q>>2]=0;a=q+4|0;k[a>>2]=0;h=ZT(32)|0;k[h>>2]=1;j=h+4|0;k[q>>2]=j;k[a>>2]=26;i[h+30>>0]=0;l=246296;m=j+26|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,q,246323,246054,1769);k[a>>2]=0;k[q>>2]=0;p=k[h>>2]|0;k[h>>2]=p+-1;if((p|0)==1)ggb(k[h+-4>>2]|0)}if(g>>>0>=17){k[q>>2]=0;a=q+4|0;k[a>>2]=0;h=ZT(36)|0;k[h>>2]=1;j=h+4|0;k[q>>2]=j;k[a>>2]=31;i[h+35>>0]=0;l=246173;m=j+31|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,q,246323,246054,1770);k[a>>2]=0;k[q>>2]=0;p=k[h>>2]|0;k[h>>2]=p+-1;if((p|0)==1)ggb(k[h+-4>>2]|0)}z2(d,q,k[t>>2]&4095,0);p=k[b>>2]|0;k[s>>2]=p;b=k[b+4>>2]|0;k[s+4>>2]=b;d=k[c>>2]|0;k[s+8>>2]=d;k[s+12>>2]=b;k[s+16>>2]=d;d=k[c+4>>2]|0;k[s+20>>2]=d;k[s+24>>2]=p;k[s+28>>2]=d;if((e|0)>-1)Ofa(t,s,4,1,q,e,f,g);else Lfa(t,s,4,q,f,g);f=t+36|0;a=k[f>>2]|0;if(a|0?(q=a+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){h=k[f>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[t+32>>2]|0;if(!a){a=B1()|0;h=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[f>>2]=0}k[f>>2]=0;s=t+16|0;h=t+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[h>>2]|0)>0){f=k[t+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[t+44>>2]|0;if((a|0)==(t+48|0)|(a|0)==0){r=u;return}ggb(k[a+-4>>2]|0);r=u;return}function Zfa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+112|0;v=w+56|0;t=w;u=w+48|0;q=w+40|0;s=w+32|0;do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[v>>2]=k[l>>2];p=v+4|0;a=l+4|0;k[p>>2]=k[a>>2];o=v+8|0;k[o>>2]=k[l+8>>2];k[v+12>>2]=k[l+12>>2];k[v+16>>2]=k[l+16>>2];k[v+20>>2]=k[l+20>>2];k[v+24>>2]=k[l+24>>2];k[v+28>>2]=k[l+28>>2];k[v+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[v+36>>2]=h;j=v+40|0;k[j>>2]=o;o=v+48|0;n=v+44|0;k[n>>2]=o;k[v+52>>2]=0;k[o>>2]=0;if(h|0){o=h+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[a>>2]|0)<3){o=k[l+44>>2]|0;p=k[n>>2]|0;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];break}k[p>>2]=0;x1(v,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(v,a,-1);while(0);if((f|0)==16)a=(k[v>>2]&7|0)==0?16:8;else a=f;if(!((g|0)<17&((e|0)<32768&(g|c|0)>-1))){k[t>>2]=0;h=t+4|0;k[h>>2]=0;j=ZT(84)|0;k[j>>2]=1;l=j+4|0;k[t>>2]=l;k[h>>2]=76;i[j+80>>0]=0;m=246333;n=l+76|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,t,246410,246054,1811);k[h>>2]=0;k[t>>2]=0;f=k[j>>2]|0;k[j>>2]=f+-1;if((f|0)==1)ggb(k[j+-4>>2]|0)}z2(d,t,k[v>>2]&4095,0);if((g|0)>0|((e|0)>1|(a|0)>15)){g=16-g|0;s=k[b>>2]<<g;k[b>>2]=s;b=b+4|0;d=k[b>>2]<<g;k[b>>2]=d;g=c<<g;k[u>>2]=s;k[u+4>>2]=d;k[q>>2]=g;k[q+4>>2]=g;Nfa(v,u,q,0,0,360,t,e,a)}else{k[s>>2]=k[b>>2];k[s+4>>2]=k[b+4>>2];Mfa(v,s,c,t,e>>>31)}j=v+36|0;a=k[j>>2]|0;if(a|0?(t=a+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[v+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;u=v+16|0;h=v+4|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[h>>2]|0)>0){j=k[v+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[v+44>>2]|0;if((a|0)==(v+48|0)|(a|0)==0){r=w;return}ggb(k[a+-4>>2]|0);r=w;return}function _fa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;g=r;r=r+16|0;f=g;b=a>>>4;switch(a&15){case 0:{a=69944;break}case 1:{a=b&1|0?65464:65848;break}case 2:{a=69560;break}case 3:{a=(b&1|0)==0?66232:66872;break}case 4:{a=b&1|0?67256:67640;break}case 5:{a=b&1|0?68024:68408;break}case 6:{a=69176;break}case 7:{a=68792;break}default:{a=f+4|0;b=ZT(24)|0;k[b>>2]=1;c=b+4|0;k[f>>2]=c;k[a>>2]=17;i[b+21>>0]=0;d=246812;e=c+17|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-211,f,246830,246054,2102);k[a>>2]=0;k[f>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0);a=0}}r=g;return a|0}function $fa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;x=r;r=r+64|0;u=x;if((d|0)<=-1){r=x;return}v=u+16|0;w=u+4|0;m=u+8|0;n=u+12|0;o=u+36|0;p=u+40|0;q=u+44|0;s=u+48|0;t=u+32|0;do{Q1(u,a,d);j=k[v>>2]|0;l=k[w>>2]|0;if(!j)j=0;else{if((l|0)<3)g=aa(k[n>>2]|0,k[m>>2]|0)|0;else{i=k[p>>2]|0;h=0;g=1;do{g=aa(k[i+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(l|0))}j=(g|0)==0?0:j}if((l|0)<3)g=aa(k[n>>2]|0,k[m>>2]|0)|0;else{i=k[p>>2]|0;h=0;g=1;do{g=aa(k[i+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(l|0))}MY(20492,56,8,j,g,(k[e>>2]|0)+(d*56|0)|0,(k[f>>2]|0)+(d*20|0)|0)|0;h=c+(d<<4)|0;y=k[h>>2]|0;l=k[c+(d<<4)+4>>2]|0;g=k[c+(d<<4)+8>>2]|0;i=k[c+(d<<4)+12>>2]|0;j=k[e>>2]|0;k[j+(d*56|0)+12>>2]=(y|0)>-1&(y|0)<(b|0)?j+(y*56|0)|0:0;k[j+(d*56|0)+8>>2]=(l|0)>-1&(l|0)<(b|0)?j+(l*56|0)|0:0;l=(g|0)>-1;k[j+(d*56|0)+20>>2]=l&(g|0)<(b|0)?j+(g*56|0)|0:0;k[j+(d*56|0)+16>>2]=(i|0)>-1&(i|0)<(b|0)?j+(i*56|0)|0:0;if(l)$fa(a,b,c,g,e,f);d=k[o>>2]|0;if(d|0?(l=d+12|0,y=k[l>>2]|0,k[l>>2]=y+-1,(y|0)==1):0){g=k[o>>2]|0;if(g|0){d=k[g+4>>2]|0;if(!d){d=k[t>>2]|0;if(!d){d=B1()|0;g=k[o>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[o>>2]=0}k[o>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[w>>2]|0)>0){g=k[p>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[w>>2]|0))}d=k[q>>2]|0;if(!((d|0)==(s|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[h>>2]|0}while((d|0)>-1);r=x;return}function aga(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;j=+j;var l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0;ea=r;r=r+432|0;X=ea+416|0;da=ea+360|0;ca=ea+304|0;ba=ea+248|0;x=ea+32|0;W=ea+136|0;R=ea+120|0;O=ea+104|0;z=ea+48|0;y=ea;Q=ea+192|0;if(!((c|0)>-1&(d>0.0&e>=0.0))){l=X+4|0;m=ZT(60)|0;k[m>>2]=1;s=m+4|0;k[X>>2]=s;k[l>>2]=55;i[m+59>>0]=0;n=247074;v=s+55|0;do{i[s>>0]=i[n>>0]|0;s=s+1|0;n=n+1|0}while((s|0)<(v|0));Y8(-215,X,247130,247150,270);k[l>>2]=0;k[X>>2]=0;$=k[m>>2]|0;k[m>>2]=$+-1;if(($|0)==1)ggb(k[m+-4>>2]|0)}do if(!(G2(f)|0)){if((S1(f,-1)|0)==0?E2(f,a)|0:0)break;l=X+4|0;m=ZT(76)|0;k[m>>2]=1;s=m+4|0;k[X>>2]=s;k[l>>2]=68;i[m+72>>0]=0;n=247225;v=s+68|0;do{i[s>>0]=i[n>>0]|0;s=s+1|0;n=n+1|0}while((s|0)<(v|0));Y8(-215,X,247130,247150,271);k[l>>2]=0;k[X>>2]=0;$=k[m>>2]|0;k[m>>2]=$+-1;if(($|0)==1)ggb(k[m+-4>>2]|0)}while(0);do if((k[a>>2]&2031616|0)==65536){n=k[a+4>>2]|0;k[da>>2]=k[n>>2];v=da+4|0;l=n+4|0;k[v>>2]=k[l>>2];$=da+8|0;k[$>>2]=k[n+8>>2];k[da+12>>2]=k[n+12>>2];w=da+16|0;k[w>>2]=k[n+16>>2];k[da+20>>2]=k[n+20>>2];k[da+24>>2]=k[n+24>>2];k[da+28>>2]=k[n+28>>2];k[da+32>>2]=k[n+32>>2];m=k[n+36>>2]|0;k[da+36>>2]=m;a=da+40|0;k[a>>2]=$;$=da+48|0;s=da+44|0;k[s>>2]=$;k[da+52>>2]=0;k[$>>2]=0;if(m|0){$=m+12|0;k[$>>2]=(k[$>>2]|0)+1}if((k[l>>2]|0)<3){_=k[n+44>>2]|0;$=k[s>>2]|0;k[$>>2]=k[_>>2];k[$+4>>2]=k[_+4>>2];break}k[v>>2]=0;x1(da,k[l>>2]|0,0,0,0);if((k[v>>2]|0)>0){t=k[n+40>>2]|0;q=k[a>>2]|0;a=k[n+44>>2]|0;m=k[s>>2]|0;l=0;do{k[q+(l<<2)>>2]=k[t+(l<<2)>>2];k[m+(l<<2)>>2]=k[a+(l<<2)>>2];l=l+1|0}while((l|0)<(k[v>>2]|0))}}else{Q1(da,a,-1);w=da+16|0}while(0);k[ca>>2]=1124007936;_=ca+4|0;l=ca+8|0;Y=ca+40|0;s=_;v=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(v|0));k[Y>>2]=l;$=ca+48|0;Z=ca+44|0;k[Z>>2]=$;k[ca+52>>2]=0;k[$>>2]=0;k[ba>>2]=1124007936;U=ba+4|0;l=ba+8|0;S=ba+40|0;s=U;v=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(v|0));k[S>>2]=l;V=ba+48|0;T=ba+44|0;k[T>>2]=V;k[ba+52>>2]=0;k[V>>2]=0;if(k[w>>2]|0){a=k[da+4>>2]|0;if((a|0)<3)l=aa(k[da+12>>2]|0,k[da+8>>2]|0)|0;else{n=k[da+40>>2]|0;m=0;l=1;do{l=aa(k[n+(m<<2)>>2]|0,l)|0;m=m+1|0}while((m|0)!=(a|0))}if(l){if(h){k[X+8>>2]=0;k[X+12>>2]=0;k[X>>2]=16842752;k[X+4>>2]=da;N=x+4|0;M=N+4|0;k[M>>2]=0;k[M+4>>2]=0;k[x>>2]=33619968;k[N>>2]=ca;Yea(X,x,g,3,j,4)}else{k[X+8>>2]=0;k[X+12>>2]=0;k[X>>2]=16842752;k[X+4>>2]=da;N=x+4|0;M=N+4|0;k[M>>2]=0;k[M+4>>2]=0;k[x>>2]=33619968;k[N>>2]=ca;Wea(X,x,g,3,4)}p[x>>3]=0.0;k[X+8>>2]=0;k[X+12>>2]=0;k[X>>2]=16842752;k[X+4>>2]=ca;L7(X,0,x,0,0,f);k[X+8>>2]=0;k[X+12>>2]=0;k[X>>2]=16842752;k[X+4>>2]=ca;t=W+4|0;l=t+4|0;k[l>>2]=0;k[l+4>>2]=0;k[W>>2]=33619968;k[t>>2]=ca;+Yua(X,W,+p[x>>3]*d,0.0,3);k[W+8>>2]=0;k[W+12>>2]=0;k[W>>2]=16842752;k[W+4>>2]=ca;t=R+4|0;l=t+4|0;k[l>>2]=0;k[l+4>>2]=0;k[R>>2]=33619968;k[t>>2]=ba;k[z>>2]=1124007936;t=z+4|0;l=z+8|0;q=z+40|0;s=t;v=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(v|0));k[q>>2]=l;s=z+48|0;n=z+44|0;k[n>>2]=s;k[z+52>>2]=0;k[s>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=z;p[y>>3]=1797693134862315708145274.0e284;p[y+8>>3]=1797693134862315708145274.0e284;p[y+16>>3]=1797693134862315708145274.0e284;p[y+24>>3]=1797693134862315708145274.0e284;k[X>>2]=-1;k[X+4>>2]=-1;Dra(1,W,R,O,X,1,0,y);a=z+36|0;l=k[a>>2]|0;if(l|0?(M=l+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){m=k[a>>2]|0;if(m|0){l=k[m+4>>2]|0;if(!l){l=k[z+32>>2]|0;if(!l){l=B1()|0;m=k[a>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[a>>2]=0}k[a>>2]=0;N=z+16|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[t>>2]|0)>0){m=k[q>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[t>>2]|0))}l=k[n>>2]|0;if(!((l|0)==(s|0)|(l|0)==0))ggb(k[l+-4>>2]|0);x=k[da+40>>2]|0;g=k[x+4>>2]|0;x=k[x>>2]|0;k[X>>2]=0;N=X+4|0;k[N>>2]=0;k[X+8>>2]=0;do if((k[f>>2]&2031616|0)==65536){n=k[f+4>>2]|0;k[W>>2]=k[n>>2];v=W+4|0;l=n+4|0;k[v>>2]=k[l>>2];M=W+8|0;k[M>>2]=k[n+8>>2];k[W+12>>2]=k[n+12>>2];k[W+16>>2]=k[n+16>>2];k[W+20>>2]=k[n+20>>2];k[W+24>>2]=k[n+24>>2];k[W+28>>2]=k[n+28>>2];k[W+32>>2]=k[n+32>>2];m=k[n+36>>2]|0;k[W+36>>2]=m;a=W+40|0;k[a>>2]=M;M=W+48|0;s=W+44|0;k[s>>2]=M;k[W+52>>2]=0;k[M>>2]=0;if(m|0){M=m+12|0;k[M>>2]=(k[M>>2]|0)+1}if((k[l>>2]|0)<3){L=k[n+44>>2]|0;M=k[s>>2]|0;k[M>>2]=k[L>>2];k[M+4>>2]=k[L+4>>2];break}k[v>>2]=0;x1(W,k[l>>2]|0,0,0,0);if((k[v>>2]|0)>0){t=k[n+40>>2]|0;q=k[a>>2]|0;a=k[n+44>>2]|0;m=k[s>>2]|0;l=0;do{k[q+(l<<2)>>2]=k[t+(l<<2)>>2];k[m+(l<<2)>>2]=k[a+(l<<2)>>2];l=l+1|0}while((l|0)<(k[v>>2]|0))}}else Q1(W,f,-1);while(0);t=x+-1|0;if((t|0)>1?(A=ca+16|0,B=ba+16|0,C=W+16|0,D=g+-1|0,E=X+8|0,F=W+44|0,(D|0)>1):0){n=1;do{q=(k[A>>2]|0)+(aa(k[k[Z>>2]>>2]|0,n)|0)|0;s=(k[B>>2]|0)+(aa(k[k[T>>2]>>2]|0,n)|0)|0;l=k[C>>2]|0;if((l|0)!=0?(G=l+(aa(k[k[F>>2]>>2]|0,n)|0)|0,(G|0)!=0):0){m=1;do{a=q+(m<<2)|0;d=+o[a>>2];do if(d!=0.0){if(!(d==+o[s+(m<<2)>>2]))break;if(!(i[G+m>>0]|0))break;k[R>>2]=a;l=k[N>>2]|0;if((l|0)==(k[E>>2]|0))bga(X,R);else{k[l>>2]=a;k[N>>2]=l+4}}while(0);m=m+1|0}while((m|0)<(D|0))}else{m=1;P=65}if((P|0)==65)while(1){P=0;a=q+(m<<2)|0;d=+o[a>>2];do if(d!=0.0){if(!(d==+o[s+(m<<2)>>2]))break;k[R>>2]=a;l=k[N>>2]|0;if((l|0)==(k[E>>2]|0))bga(X,R);else{k[l>>2]=a;k[N>>2]=l+4}}while(0);m=m+1|0;if((m|0)>=(D|0))break;else P=65}n=n+1|0}while((n|0)<(t|0))}k[R>>2]=0;M=R+4|0;k[M>>2]=0;k[R+8>>2]=0;l=k[N>>2]|0;t=k[X>>2]|0;L=l-t>>2;do if(!L)b2(b);else{cga(t,l);a:do if(!(e>=1.0)){n=ca+16|0;q=O+4|0;s=R+8|0;if((c|0)>0){l=0;m=0;a=0;while(1){I=(k[t+(l<<2)>>2]|0)-(k[n>>2]|0)|0;J=k[$>>2]|0;K=(I>>>0)/(J>>>0)|0;d=+((I-(aa(K,J)|0)|0)>>>2|0);j=+(K|0);o[O>>2]=d;o[q>>2]=j;if((m|0)==(a|0))dga(R,O);else{o[m>>2]=d;o[m+4>>2]=j;k[M>>2]=m+8}l=l+1|0;if(!((l|0)!=(c|0)&l>>>0<L>>>0))break a;m=k[M>>2]|0;a=k[s>>2]|0}}else{l=0;m=0;a=0;while(1){J=(k[t+(l<<2)>>2]|0)-(k[n>>2]|0)|0;K=k[$>>2]|0;c=(J>>>0)/(K>>>0)|0;d=+((J-(aa(c,K)|0)|0)>>>2|0);j=+(c|0);o[O>>2]=d;o[q>>2]=j;if((m|0)==(a|0))dga(R,O);else{o[m>>2]=d;o[m+4>>2]=j;k[M>>2]=m+8}l=l+1|0;if(l>>>0>=L>>>0)break a;m=k[M>>2]|0;a=k[s>>2]|0}}}else{m=k[da+12>>2]|0;a=k[da+8>>2]|0;p[u>>3]=e;l=k[u+4>>2]|0;P=l&2146435072;if(!(P>>>0>1126170624|(P|0)==1126170624&0>0)){l=(l|0)<0;d=l?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=l?-0.0:0.0}else d=e;K=~~d;I=(m+-1+K|0)/(K|0)|0;q=(a+-1+K|0)/(K|0)|0;n=aa(q,I)|0;if(!n){J=0;a=0}else{if(n>>>0>357913941)ad(426534,426557,304,426811);a=n*12|0;m=(a|0)==0?1:a;while(1){l=fgb(m)|0;if(l|0)break;l=k[207666]|0;k[207666]=l+0;if(!l){l=0;break}Qh[l&7]()}zpb(l|0,0,a|0)|0;J=l;a=l+(n*12|0)|0}e=e*e;G=ca+16|0;H=I+-1|0;B=q+-1|0;C=O+4|0;D=O+4|0;E=R+8|0;F=(c|0)>0;A=0;l=0;while(1){z=(k[(k[X>>2]|0)+(A<<2)>>2]|0)-(k[G>>2]|0)|0;m=k[$>>2]|0;q=(z>>>0)/(m>>>0)|0;m=(z-(aa(q,m)|0)|0)>>>2;z=(m|0)/(K|0)|0;f=(q|0)/(K|0)|0;y=z+-1|0;n=f+-1|0;h=z+1|0;g=f+1|0;y=(y|0)>0?y:0;n=(n|0)>0?n:0;h=(h|0)<(H|0)?h:H;g=(g|0)<(B|0)?g:B;do if((n|0)<=(g|0)){j=+(m|0);d=+(q|0);if((y|0)>(h|0)){P=105;break}else m=1;b:while(1){x=aa(n,I)|0;v=y;while(1){s=v+x|0;q=k[J+(s*12|0)+4>>2]|0;s=k[J+(s*12|0)>>2]|0;t=s;if((q|0)!=(s|0)){s=q-s>>3;q=0;do{ga=j-+o[t+(q<<3)>>2];fa=d-+o[t+(q<<3)+4>>2];P=ga*ga+fa*fa<e;m=m&(P^1);q=q+1|0;if(P){P=104;break b}}while(q>>>0<s>>>0)}if((v|0)<(h|0))v=v+1|0;else break}if((n|0)<(g|0))n=n+1|0;else{P=97;break}}if((P|0)==97){P=0;if(m){P=105;break}else break}else if((P|0)==104){P=0;if(m){P=105;break}else break}}else{j=+(m|0);d=+(q|0);P=105}while(0);if((P|0)==105){P=0;m=(aa(f,I)|0)+z|0;o[O>>2]=j;o[C>>2]=d;n=J+(m*12|0)+4|0;q=k[n>>2]|0;if((q|0)==(k[J+(m*12|0)+8>>2]|0))dga(J+(m*12|0)|0,O);else{o[q>>2]=j;o[q+4>>2]=d;k[n>>2]=q+8}o[O>>2]=j;o[D>>2]=d;m=k[M>>2]|0;if((m|0)==(k[E>>2]|0))dga(R,O);else{o[m>>2]=j;o[m+4>>2]=d;k[M>>2]=m+8}l=l+1|0;if(F&(l|0)==(c|0))break}A=A+1|0;if(A>>>0>=L>>>0){P=113;break}}if((P|0)==113?(J|0)==0:0)break;if((a|0)!=(J|0))do{l=a;a=a+-12|0;n=k[a>>2]|0;q=n;if(n|0){l=l+-8|0;m=k[l>>2]|0;if((m|0)!=(n|0))k[l>>2]=m+(~((m+-8-q|0)>>>3)<<3);ggb(n)}}while((a|0)!=(J|0));ggb(J)}while(0);k[Q>>2]=1124024333;h=Q+4|0;k[h>>2]=2;z=Q+8|0;O=k[M>>2]|0;l=k[R>>2]|0;m=O-l|0;k[z>>2]=m>>3;k[Q+12>>2]=1;v=Q+16|0;k[v>>2]=0;a=Q+20|0;k[a>>2]=0;n=Q+24|0;k[n>>2]=0;t=Q+32|0;k[t>>2]=0;x=Q+36|0;k[x>>2]=0;g=Q+40|0;k[g>>2]=z;z=Q+48|0;y=Q+44|0;k[y>>2]=z;q=Q+52|0;k[q>>2]=0;k[z>>2]=0;s=l;if((s|0)!=(O|0)){k[q>>2]=8;k[z>>2]=8;k[v>>2]=s;k[a>>2]=s;O=l+m|0;k[n>>2]=O;k[Q+28>>2]=O}if((k[b>>2]|0)<0)l=S1(b,-1)|0;else l=5;SW(Q,b,l,1.0,0.0);l=k[x>>2]|0;do if(l|0){b=l+12|0;Q=k[b>>2]|0;k[b>>2]=Q+-1;if((Q|0)!=1)break;m=k[x>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[t>>2]|0;if(l|0)break;l=B1()|0;m=k[x>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[x>>2]=0}while(0);k[x>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[h>>2]|0)>0){m=k[g>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[h>>2]|0))}l=k[y>>2]|0;if((l|0)==(z|0)|(l|0)==0)break;ggb(k[l+-4>>2]|0)}while(0);l=k[R>>2]|0;m=l;if(l|0){a=k[M>>2]|0;if((a|0)!=(l|0))k[M>>2]=a+(~((a+-8-m|0)>>>3)<<3);ggb(l)}a=W+36|0;l=k[a>>2]|0;if(l|0?(Q=l+12|0,R=k[Q>>2]|0,k[Q>>2]=R+-1,(R|0)==1):0){m=k[a>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[W+32>>2]|0;if(l|0)break;l=B1()|0;m=k[a>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[a>>2]=0}k[a>>2]=0;R=W+16|0;m=W+4|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[m>>2]|0)>0){a=k[W+40>>2]|0;l=0;do{k[a+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[m>>2]|0))}l=k[W+44>>2]|0;if(!((l|0)==(W+48|0)|(l|0)==0))ggb(k[l+-4>>2]|0);l=k[X>>2]|0;m=l;if(l|0){a=k[N>>2]|0;if((a|0)!=(l|0))k[N>>2]=a+(~((a+-4-m|0)>>>2)<<2);ggb(l)}}else P=26}else P=26;if((P|0)==26)b2(b);a=ba+36|0;l=k[a>>2]|0;if(l|0?(W=l+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){m=k[a>>2]|0;if(m|0){l=k[m+4>>2]|0;if(!l){l=k[ba+32>>2]|0;if(!l){l=B1()|0;m=k[a>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[a>>2]=0}k[a>>2]=0;ba=ba+16|0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[U>>2]|0)>0){m=k[S>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[U>>2]|0))}l=k[T>>2]|0;if(!((l|0)==(V|0)|(l|0)==0))ggb(k[l+-4>>2]|0);a=ca+36|0;l=k[a>>2]|0;if(l|0?(X=l+12|0,ba=k[X>>2]|0,k[X>>2]=ba+-1,(ba|0)==1):0){m=k[a>>2]|0;if(m|0){l=k[m+4>>2]|0;if(!l){l=k[ca+32>>2]|0;if(!l){l=B1()|0;m=k[a>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[a>>2]=0}k[a>>2]=0;ca=ca+16|0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;if((k[_>>2]|0)>0){m=k[Y>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[_>>2]|0))}l=k[Z>>2]|0;if(!((l|0)==($|0)|(l|0)==0))ggb(k[l+-4>>2]|0);a=da+36|0;l=k[a>>2]|0;if(l|0?(ba=l+12|0,ca=k[ba>>2]|0,k[ba>>2]=ca+-1,(ca|0)==1):0){m=k[a>>2]|0;if(m|0){l=k[m+4>>2]|0;if(!l){l=k[da+32>>2]|0;if(!l){l=B1()|0;m=k[a>>2]|0}}jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[a>>2]=0}k[a>>2]=0;a=da+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[a>>2]|0)>0){m=k[da+40>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[a>>2]|0))}l=k[da+44>>2]|0;if((l|0)==(da+48|0)|(l|0)==0){r=ea;return}ggb(k[l+-4>>2]|0);r=ea;return}function bga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>2;c=g+1|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>1;f=e>>2>>>0<536870911?(f>>>0<c>>>0?c:f):1073741823;if(!f)c=0;else{if(f>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<2)|0;k[e>>2]=k[b>>2];d=e+(0-g<<2)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+4;k[l>>2]=c+(f<<2);if(!i)return;ggb(i);return}function cga(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0.0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0.0;a:while(1){m=b;r=b+-4|0;while(1){s=a;b:while(1){l=s;a=m-l|0;c=a>>2;switch(c|0){case 2:{q=5;break a}case 3:{q=7;break a}case 4:{q=15;break a}case 5:{q=27;break a}case 1:case 0:{q=85;break a}default:{}}if((a|0)<124){q=29;break a}j=s+(((c|0)/2|0)<<2)|0;do if((a|0)<=3996){c=k[j>>2]|0;f=k[s>>2]|0;g=+o[c>>2];d=+o[f>>2];e=k[r>>2]|0;a=+o[e>>2]>g;if(!(g>d)){if(!a){a=0;break}k[j>>2]=e;k[r>>2]=c;a=k[j>>2]|0;c=k[s>>2]|0;if(!(+o[a>>2]>+o[c>>2])){a=1;break}k[s>>2]=a;k[j>>2]=c;a=2;break}if(a){k[s>>2]=e;k[r>>2]=f;a=1;break}k[s>>2]=c;k[j>>2]=f;a=k[r>>2]|0;if(+o[a>>2]>d){k[j>>2]=a;k[r>>2]=f;a=2}else a=1}else{a=(c|0)/4|0;a=ega(s,s+(a<<2)|0,j,j+(a<<2)|0,r)|0}while(0);e=k[s>>2]|0;g=+o[e>>2];d=+o[k[j>>2]>>2];if(g>d){c=r;break}else c=r;while(1){c=c+-4|0;if((s|0)==(c|0))break;f=k[c>>2]|0;if(+o[f>>2]>d){q=68;break b}}a=s+4|0;l=k[r>>2]|0;e=l;if(!(g>+o[l>>2])){if((a|0)==(r|0)){q=85;break a}while(1){c=k[a>>2]|0;if(g>+o[c>>2])break;a=a+4|0;if((a|0)==(r|0)){q=85;break a}}k[a>>2]=e;k[r>>2]=c;a=a+4|0}if((a|0)==(r|0)){q=85;break a}else c=r;while(1){d=+o[k[s>>2]>>2];while(1){f=k[a>>2]|0;h=a+4|0;if(d>+o[f>>2])break;else a=h}do{c=c+-4|0;e=k[c>>2]|0}while(d>+o[e>>2]);if(a>>>0>=c>>>0){s=a;continue b}k[a>>2]=e;k[c>>2]=f;a=h}}if((q|0)==68){q=0;k[s>>2]=f;k[c>>2]=e;a=a+1|0}e=s+4|0;c:do if(e>>>0<c>>>0)while(1){d=+o[k[j>>2]>>2];while(1){h=k[e>>2]|0;i=e+4|0;if(+o[h>>2]>d)e=i;else break}do{c=c+-4|0;f=k[c>>2]|0}while(!(+o[f>>2]>d));if(e>>>0>c>>>0){c=j;break c}k[e>>2]=f;k[c>>2]=h;j=(j|0)==(e|0)?c:j;e=i;a=a+1|0}else c=j;while(0);if((e|0)!=(c|0)?(n=k[c>>2]|0,p=k[e>>2]|0,+o[n>>2]>+o[p>>2]):0){k[e>>2]=n;k[c>>2]=p;a=a+1|0}if(!a){c=fga(s,e)|0;a=e+4|0;if(fga(a,b)|0){q=84;break}if(c)continue}j=e;if((j-l|0)>=(m-j|0)){q=83;break}cga(s,e);a=e+4|0}if((q|0)==83){q=0;cga(e+4|0,b);a=s;b=e;continue}else if((q|0)==84){q=0;if(c){q=85;break}else{a=s;b=e;continue}}}if((q|0)==5){a=k[r>>2]|0;b=k[s>>2]|0;if(!(+o[a>>2]>+o[b>>2]))return;k[s>>2]=a;k[r>>2]=b;return}else if((q|0)==7){f=s+4|0;b=k[f>>2]|0;e=k[s>>2]|0;g=+o[b>>2];d=+o[e>>2];c=k[r>>2]|0;a=+o[c>>2]>g;if(!(g>d)){if(!a)return;k[f>>2]=c;k[r>>2]=b;a=k[f>>2]|0;b=k[s>>2]|0;if(!(+o[a>>2]>+o[b>>2]))return;k[s>>2]=a;k[f>>2]=b;return}if(a){k[s>>2]=c;k[r>>2]=e;return}k[s>>2]=b;k[f>>2]=e;a=k[r>>2]|0;if(!(+o[a>>2]>d))return;k[f>>2]=a;k[r>>2]=e;return}else if((q|0)==15){l=s+4|0;j=s+8|0;c=k[l>>2]|0;a=k[s>>2]|0;t=+o[c>>2];d=+o[a>>2];e=k[j>>2]|0;g=+o[e>>2];f=g>t;b=c;h=e;i=a;do if(t>d){if(f){k[s>>2]=h;k[j>>2]=i;c=a;b=i;break}k[s>>2]=b;k[l>>2]=i;if(g>d){k[l>>2]=h;k[j>>2]=i;c=a;b=i}else{c=e;b=h}}else if(f){k[l>>2]=h;k[j>>2]=b;if(g>d){k[s>>2]=h;k[l>>2]=i}}else{c=e;b=h}while(0);a=k[r>>2]|0;if(!(+o[a>>2]>+o[c>>2]))return;k[j>>2]=a;k[r>>2]=b;a=k[j>>2]|0;b=k[l>>2]|0;d=+o[a>>2];if(!(d>+o[b>>2]))return;c=a;k[l>>2]=c;k[j>>2]=b;a=k[s>>2]|0;if(!(d>+o[a>>2]))return;k[s>>2]=c;k[l>>2]=a;return}else if((q|0)==27){ega(s,s+4|0,s+8|0,s+12|0,r)|0;return}else if((q|0)==29){m=s+8|0;a=s+4|0;c=k[a>>2]|0;e=k[s>>2]|0;t=+o[c>>2];d=+o[e>>2];f=k[m>>2]|0;g=+o[f>>2];h=g>t;i=c;j=f;l=e;do if(t>d){if(h){k[s>>2]=j;k[m>>2]=l;c=e;break}k[s>>2]=i;k[a>>2]=l;if(g>d){k[a>>2]=j;k[m>>2]=l;c=e}else c=f}else if(h){k[a>>2]=j;k[m>>2]=i;if(g>d){k[s>>2]=j;k[a>>2]=l}}else c=f;while(0);a=s+12|0;if((a|0)==(b|0))return;else{f=a;a=m}while(1){e=k[f>>2]|0;d=+o[e>>2];if(d>+o[c>>2]){c=a;a=f;while(1){k[a>>2]=k[c>>2];if((c|0)==(s|0))break;a=c+-4|0;if(d>+o[k[a>>2]>>2]){r=c;c=a;a=r}else break}k[c>>2]=e}a=f+4|0;if((a|0)==(b|0))break;c=k[f>>2]|0;r=f;f=a;a=r}return}else if((q|0)==85)return}function dga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=a+4|0;c=k[l>>2]|0;m=k[a>>2]|0;f=c-m>>3;d=f+1|0;if(d>>>0>536870911)ad(426534,426557,304,426811);j=m;h=c;i=a+8|0;g=(k[i>>2]|0)-m|0;e=g>>2;e=g>>3>>>0<268435455?(e>>>0<d>>>0?d:e):536870911;if(!e)d=0;else{if(e>>>0>536870911){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c}c=d+(f<<3)|0;g=d+(e<<3)|0;k[c>>2]=k[b>>2];k[d+(f<<3)+4>>2]=k[b+4>>2];f=c+8|0;if((h|0)!=(j|0)){b=h+-8|0;d=h;e=c;do{h=e;e=e+-8|0;n=d;d=d+-8|0;k[e>>2]=k[d>>2];k[h+-4>>2]=k[n+-4>>2]}while((d|0)!=(j|0));c=c+(~((b-m|0)>>>3)<<3)|0}k[a>>2]=c;k[l>>2]=f;k[i>>2]=g;if(!m)return;ggb(m);return}function ega(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0.0,j=0,l=0,m=0,n=0,p=0,q=0.0;j=k[b>>2]|0;l=k[a>>2]|0;q=+o[j>>2];i=+o[l>>2];h=k[c>>2]|0;f=+o[h>>2]>q;m=j;g=h;n=l;do if(q>i){if(f){k[a>>2]=g;k[c>>2]=n;p=1;h=l;g=n;break}k[a>>2]=m;k[b>>2]=n;f=k[c>>2]|0;g=f;if(+o[f>>2]>i){k[b>>2]=g;k[c>>2]=n;p=2;h=l;g=n}else{p=1;h=f}}else if(f){k[b>>2]=g;k[c>>2]=m;f=k[b>>2]|0;g=k[a>>2]|0;if(+o[f>>2]>+o[g>>2]){k[a>>2]=f;k[b>>2]=g;g=k[c>>2]|0;p=2;h=g}else{p=1;h=j;g=m}}else p=0;while(0);f=k[d>>2]|0;if(+o[f>>2]>+o[h>>2]){k[c>>2]=f;k[d>>2]=g;f=p+1|0;g=k[c>>2]|0;h=k[b>>2]|0;if(+o[g>>2]>+o[h>>2]){k[b>>2]=g;k[c>>2]=h;f=k[b>>2]|0;g=k[a>>2]|0;if(+o[f>>2]>+o[g>>2]){k[a>>2]=f;k[b>>2]=g;h=p+3|0}else h=p+2|0}else h=f}else h=p;f=k[e>>2]|0;g=k[d>>2]|0;if(!(+o[f>>2]>+o[g>>2])){b=h;return b|0}k[d>>2]=f;k[e>>2]=g;f=k[d>>2]|0;g=k[c>>2]|0;if(!(+o[f>>2]>+o[g>>2])){b=h+1|0;return b|0}k[c>>2]=f;k[d>>2]=g;f=k[c>>2]|0;g=k[b>>2]|0;if(!(+o[f>>2]>+o[g>>2])){b=h+2|0;return b|0}k[b>>2]=f;k[c>>2]=g;f=k[b>>2]|0;g=k[a>>2]|0;if(!(+o[f>>2]>+o[g>>2])){b=h+3|0;return b|0}k[a>>2]=f;k[b>>2]=g;b=h+4|0;return b|0}function fga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0,h=0,i=0,j=0.0,l=0,m=0,n=0,p=0,q=0.0;switch(b-a>>2|0){case 2:{c=b+-4|0;d=k[c>>2]|0;e=k[a>>2]|0;if(!(+o[d>>2]>+o[e>>2])){a=1;return a|0}k[a>>2]=d;k[c>>2]=e;a=1;return a|0}case 3:{i=a+4|0;g=b+-4|0;d=k[i>>2]|0;h=k[a>>2]|0;j=+o[d>>2];f=+o[h>>2];e=k[g>>2]|0;c=+o[e>>2]>j;if(!(j>f)){if(!c){a=1;return a|0}k[i>>2]=e;k[g>>2]=d;c=k[i>>2]|0;d=k[a>>2]|0;if(!(+o[c>>2]>+o[d>>2])){a=1;return a|0}k[a>>2]=c;k[i>>2]=d;a=1;return a|0}if(c){k[a>>2]=e;k[g>>2]=h;a=1;return a|0}k[a>>2]=d;k[i>>2]=h;c=k[g>>2]|0;if(!(+o[c>>2]>f)){a=1;return a|0}k[i>>2]=c;k[g>>2]=h;a=1;return a|0}case 4:{p=a+4|0;n=a+8|0;m=b+-4|0;e=k[p>>2]|0;c=k[a>>2]|0;q=+o[e>>2];f=+o[c>>2];g=k[n>>2]|0;j=+o[g>>2];h=j>q;d=e;i=g;l=c;do if(q>f){if(h){k[a>>2]=i;k[n>>2]=l;e=c;d=l;break}k[a>>2]=d;k[p>>2]=l;if(j>f){k[p>>2]=i;k[n>>2]=l;e=c;d=l}else{e=g;d=i}}else if(h){k[p>>2]=i;k[n>>2]=d;if(j>f){k[a>>2]=i;k[p>>2]=l}}else{e=g;d=i}while(0);c=k[m>>2]|0;if(!(+o[c>>2]>+o[e>>2])){a=1;return a|0}k[n>>2]=c;k[m>>2]=d;c=k[n>>2]|0;d=k[p>>2]|0;f=+o[c>>2];if(!(f>+o[d>>2])){a=1;return a|0}e=c;k[p>>2]=e;k[n>>2]=d;c=k[a>>2]|0;if(!(f>+o[c>>2])){a=1;return a|0}k[a>>2]=e;k[p>>2]=c;a=1;return a|0}case 5:{ega(a,a+4|0,a+8|0,a+12|0,b+-4|0)|0;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{n=a+8|0;c=a+4|0;e=k[c>>2]|0;d=k[a>>2]|0;q=+o[e>>2];f=+o[d>>2];g=k[n>>2]|0;j=+o[g>>2];h=j>q;i=e;l=g;m=d;do if(q>f){if(h){k[a>>2]=l;k[n>>2]=m;e=d;break}k[a>>2]=i;k[c>>2]=m;if(j>f){k[c>>2]=l;k[n>>2]=m;e=d}else e=g}else if(h){k[c>>2]=l;k[n>>2]=i;if(j>f){k[a>>2]=l;k[c>>2]=m}}else e=g;while(0);c=a+12|0;a:do if((c|0)==(b|0)){d=1;c=0}else{h=c;d=0;c=n;while(1){g=k[h>>2]|0;f=+o[g>>2];if(f>+o[e>>2]){e=c;c=h;while(1){k[c>>2]=k[e>>2];if((e|0)==(a|0))break;c=e+-4|0;if(f>+o[k[c>>2]>>2]){p=e;e=c;c=p}else break}k[e>>2]=g;d=d+1|0;c=h+4|0;if((d|0)==8){d=0;c=(c|0)==(b|0);break a}}else c=h+4|0;if((c|0)==(b|0)){d=1;c=0;break a}e=k[h>>2]|0;p=h;h=c;c=p}}while(0);a=c|d;return a|0}}return 0}function gga(a){a=a|0;return}function hga(a){a=a|0;return}function iga(a){a=a|0;return}function jga(a){a=a|0;return}function kga(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=70400;b=a+192|0;c=k[b>>2]|0;if(c|0?(d=c+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+196>>2]=0;b=a+184|0;c=k[b>>2]|0;if(c|0?(d=c+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+188>>2]=0;b=a+176|0;c=k[b>>2]|0;if(c|0?(d=c+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+180>>2]=0;b=k[a+164>>2]|0;c=b;if(b|0){d=a+168|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+128>>2]|0;if(b|0){c=a+132|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+116>>2]|0;if(b|0){c=a+120|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+104>>2]|0;if(b|0){c=a+108|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+92>>2]|0;if(b|0){c=a+96|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+76>>2]|0;if(!d)return;b=a+80|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-4-d|0)>>>2)<<2);ggb(d);return}function lga(a){a=a|0;kga(a);ggb(a);return}function mga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=r;r=r+16|0;e=M;A=k[b>>2]|0;D=a+36|0;k[D>>2]=A;I=k[b+4>>2]|0;L=a+40|0;k[L>>2]=I;E=k[c>>2]|0;C=a+44|0;k[C>>2]=E;H=k[c+4>>2]|0;J=a+48|0;k[J>>2]=H;b=k[c+8>>2]|0;G=a+52|0;k[G>>2]=b;F=k[c+12>>2]|0;K=a+56|0;k[K>>2]=F;if(((b+E|0)>(A|0)?1:(E|H|b|F|0)<0)|(F+H|0)>(I|0)){I=e+4|0;b=ZT(148)|0;k[b>>2]=1;H=b+4|0;k[e>>2]=H;k[I>>2]=143;i[b+147>>0]=0;upb(H|0,247851,143)|0;Y8(-215,e,247845,247404,169);k[I>>2]=0;k[e>>2]=0;I=k[b>>2]|0;k[b>>2]=I+-1;if((I|0)==1)ggb(k[b+-4>>2]|0);b=k[G>>2]|0}o=a+4|0;c=k[o>>2]|0;F=(c>>>3&511)+1<<(47696>>>(c<<1&14)&3);s=a+12|0;A=k[s>>2]|0;A=(A>>>3&511)+1<<(47696>>>(A<<1&14)&3);v=a+116|0;E=k[v>>2]|0;w=a+120|0;E=(E|0)==(k[w>>2]|0)?0:E;I=a+20|0;e=k[I>>2]|0;n=(d|0)<0?e+3|0:d;H=a+28|0;m=a+16|0;z=k[H>>2]|0;e=e-z+-1|0;z=((z|0)<(e|0)?e:z)<<1|1;n=(n|0)<(z|0)?z:n;z=a+32|0;e=k[z>>2]|0;if((e|0)>=(b|0)){f=a+164|0;d=a+168|0;h=k[d>>2]|0;g=k[f>>2]|0;if((n|0)==(h-g>>2|0))h=a+180|0;else{j=f;l=d;y=d;x=f;f=g;d=h;p=9}}else{d=a+168|0;f=a+164|0;j=f;l=d;y=d;x=f;f=k[f>>2]|0;d=k[d>>2]|0;p=9}do if((p|0)==9){g=d-f>>2;if(n>>>0<=g>>>0){if(n>>>0<g>>>0?(q=f+(n<<2)|0,(d|0)!=(q|0)):0)k[l>>2]=d+(~((d+-4-q|0)>>>2)<<2)}else{vaa(j,n-g|0);e=k[z>>2]|0;b=k[G>>2]|0;c=k[o>>2]|0}b=(e|0)<(b|0)?b:e;k[z>>2]=b;n=(c>>>3&511)+1|0;o=a+104|0;b=aa(b+-1+(k[m>>2]|0)|0,F)|0;c=a+108|0;f=k[c>>2]|0;d=k[o>>2]|0;e=f-d|0;if(b>>>0<=e>>>0){if(b>>>0<e>>>0?(t=d+b|0,(f|0)!=(t|0)):0)k[c>>2]=t}else T1(o,b-e|0);if(!(k[a+72>>2]|0)){l=a+128|0;d=k[s>>2]|0;e=k[z>>2]|0;b=k[m>>2]|0;d=aa((d>>>3&511)+1<<(47696>>>(d<<1&14)&3),e+15+b|0)|0;f=a+132|0;j=k[f>>2]|0;c=k[l>>2]|0;g=j-c|0;h=c;if(d>>>0<=g>>>0){if(d>>>0<g>>>0?(u=h+d|0,(j|0)!=(u|0)):0)k[f>>2]=u}else{T1(l,d-g|0);c=k[l>>2]|0;e=k[z>>2]|0;b=k[m>>2]|0}g=c+15&-16;d=aa(e+-1+b|0,F)|0;h=a+180|0;b=k[h>>2]|0;if(!b)f=k[o>>2]|0;else f=g;if((d|0)>0){c=(k[w>>2]|0)-(k[v>>2]|0)|0;e=0;do{w=d-e|0;c=(w|0)<(c|0)?w:c;if((c|0)>0){b=0;do{i[f+(b+e)>>0]=i[E+b>>0]|0;b=b+1|0}while((b|0)<(c|0))}e=c+e|0}while((d|0)>(e|0));b=k[h>>2]|0}if(!b){w=k[a+188>>2]|0;eh[k[(k[w>>2]|0)+8>>2]&255](w,k[o>>2]|0,g,k[z>>2]|0,n)}}else h=a+180|0;if(!(k[h>>2]|0))b=0;else b=(k[m>>2]|0)+-1|0;b=aa((k[z>>2]|0)+15+b&-16,A)|0;g=a+92|0;b=(aa(b,(k[y>>2]|0)-(k[x>>2]|0)>>2)|0)+16|0;c=a+96|0;e=k[c>>2]|0;d=k[g>>2]|0;f=e-d|0;if(b>>>0>f>>>0){T1(g,b-f|0);break}if(b>>>0<f>>>0?(B=d+b|0,(e|0)!=(B|0)):0)k[c>>2]=B}while(0);q=k[G>>2]|0;j=k[h>>2]|0;f=(j|0)==0;g=(k[m>>2]|0)+-1|0;d=aa(q+15+(f?0:g)&-16,A)|0;l=a+140|0;k[l>>2]=d;d=k[a+24>>2]|0;b=k[C>>2]|0;e=d-b|0;e=(e|0)<0?0:e;p=a+60|0;k[p>>2]=e;n=k[D>>2]|0;D=g-d+b+q-n|0;D=(D|0)<0?0:D;q=a+64|0;k[q>>2]=D;g=(e|0)>0;a:do if(g|(D|0)>0){o=a+68|0;c=k[o>>2]|0;if(!c){if(!f){b=(k[a+168>>2]|0)-(k[a+164>>2]|0)|0;if((b|0)>0)f=b>>2;else break}else f=1;e=a+104|0;d=a+92|0;b=0;c=j;while(1){if(!c)c=k[e>>2]|0;else c=((k[d>>2]|0)+15&-16)+(aa(k[l>>2]|0,b)|0)|0;upb(c|0,E|0,aa(k[p>>2]|0,F)|0)|0;D=k[q>>2]|0;upb(c+(aa((k[G>>2]|0)+-1+(k[m>>2]|0)-D|0,F)|0)|0,E|0,aa(D,F)|0)|0;b=b+1|0;if((b|0)==(f|0))break a;c=k[h>>2]|0}}f=((d|0)<(b|0)?d:b)-b|0;j=k[a+88>>2]|0;l=k[a+76>>2]|0;b:do if(g){if((j|0)>0)b=0;else{uY(0-e|0,n,c)|0;b=k[p>>2]|0;if((b|0)>1)c=1;else break;while(1){uY(c-b|0,n,k[o>>2]|0)|0;c=c+1|0;b=k[p>>2]|0;if((c|0)>=(b|0))break b}}while(1){e=aa((uY(b-e|0,n,c)|0)+f|0,j)|0;d=aa(b,j)|0;c=0;do{k[l+(c+d<<2)>>2]=c+e;c=c+1|0}while((c|0)!=(j|0));b=b+1|0;c=k[p>>2]|0;if((b|0)>=(c|0))break b;e=c;c=k[o>>2]|0}}while(0);if((k[q>>2]|0)>0){if((j|0)>0)c=0;else{b=0;while(1){uY(b+n|0,n,k[o>>2]|0)|0;b=b+1|0;if((b|0)>=(k[q>>2]|0))break a}}do{e=aa((uY(c+n|0,n,k[o>>2]|0)|0)+f|0,j)|0;b=0;do{G=l+((aa((k[p>>2]|0)+c|0,j)|0)+b<<2)|0;k[G>>2]=b+e;b=b+1|0}while((b|0)!=(j|0));c=c+1|0}while((c|0)<(k[q>>2]|0))}}while(0);k[a+160>>2]=0;k[a+156>>2]=0;J=k[J>>2]|0;b=k[H>>2]|0;H=J-b|0;H=(H|0)<0?0:H;k[a+148>>2]=H;c=a+144|0;k[c>>2]=H;b=J+-1+(k[K>>2]|0)+(k[I>>2]|0)-b|0;L=k[L>>2]|0;k[a+152>>2]=(L|0)<(b|0)?L:b;b=k[a+196>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+12>>2]&2047](b);b=k[h>>2]|0;if(!b){a=k[c>>2]|0;r=M;return a|0}Uh[k[(k[b>>2]|0)+12>>2]&2047](b);a=k[c>>2]|0;r=M;return a|0}function nga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+48|0;q=v+32|0;s=v+16|0;t=v+24|0;u=v;h=k[c>>2]|0;m=k[c+4>>2]|0;j=k[c+8>>2]|0;l=k[c+12>>2]|0;if(!h)if(!m)if((j|0)==-1)if((l|0)==-1){c=0;j=k[b+12>>2]|0;l=k[b+8>>2]|0;m=0;p=8}else{h=0;j=-1;g=l;f=0;p=11}else{c=0;m=0;p=8}else{c=0;p=7}else if((h|0)>-1){c=h;p=7}else{g=l;f=m;p=11}if((p|0)==7)if((m|0)>-1)p=8;else{h=c;g=l;f=m;p=11}if((p|0)==8)if(((l|j|0)>-1?(g=k[b+12>>2]|0,(j+c|0)<=(g|0)):0)?(f=k[b+8>>2]|0,(l+m|0)<=(f|0)):0){h=c;o=j;n=l}else{h=c;g=l;f=m;p=11}if((p|0)==11){p=q+4|0;c=ZT(160)|0;k[c>>2]=1;o=c+4|0;k[q>>2]=o;k[p>>2]=152;i[c+156>>0]=0;upb(o|0,247692,152)|0;Y8(-215,q,247845,247404,274);k[p>>2]=0;k[q>>2]=0;p=k[c>>2]|0;k[c>>2]=p+-1;if((p|0)==1)ggb(k[c+-4>>2]|0);o=j;n=g;m=f;g=k[b+12>>2]|0;f=k[b+8>>2]|0}k[q>>2]=0;l=q+4|0;k[l>>2]=0;k[s>>2]=g;c=s+4|0;k[c>>2]=f;if(d){j=0;c=0}else{N1(b,s,q);j=k[q>>2]|0;g=k[s>>2]|0;f=k[c>>2]|0;c=k[l>>2]|0}s=k[(k[a>>2]|0)+8>>2]|0;k[t>>2]=g;k[t+4>>2]=f;k[u>>2]=j+h;k[u+4>>2]=c+m;k[u+8>>2]=o;k[u+12>>2]=n;Dg[s&127](a,t,u,e)|0;r=v;return (k[a+144>>2]|0)-c|0}function oga(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;ja=r;r=r+16|0;ia=ja;if(!((k[a+36>>2]|0)>0?(k[a+40>>2]|0)>0:0)){g=ia+4|0;h=ZT(48)|0;k[h>>2]=1;p=h+4|0;k[ia>>2]=p;k[g>>2]=43;i[h+47>>0]=0;q=247582;s=p+43|0;do{i[p>>0]=i[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(s|0));Y8(-215,ia,247626,247404,299);k[g>>2]=0;k[ia>>2]=0;ha=k[h>>2]|0;k[h>>2]=ha+-1;if((ha|0)==1)ggb(k[h+-4>>2]|0)}X=k[a+76>>2]|0;Y=a+4|0;o=k[Y>>2]|0;o=(o>>>3&511)+1<<(47696>>>(o<<1&14)&3);m=k[a+88>>2]|0;_=k[a+164>>2]|0;$=(k[a+168>>2]|0)-_>>2;ba=((k[a+12>>2]|0)>>>3&511)+1|0;ca=a+52|0;da=k[ca>>2]|0;j=k[a+16>>2]|0;ea=k[a+20>>2]|0;fa=k[a+28>>2]|0;l=k[a+60>>2]|0;n=k[a+64>>2]|0;g=k[a+24>>2]|0;h=k[a+44>>2]|0;ga=a+180|0;ha=(k[ga>>2]|0)==0;if((l|0)>0|(n|0)>0)Z=(k[a+68>>2]|0)!=0;else Z=0;b=b+(aa((g|0)<(h|0)?g:h,0-o|0)|0)|0;V=a+144|0;W=a+156|0;U=(k[a+152>>2]|0)-(k[V>>2]|0)-(k[W>>2]|0)|0;d=(U|0)<(d|0)?U:d;if(!((e|0)!=0&(b|0)!=0&(d|0)>0)){g=ia+4|0;h=ZT(28)|0;k[h>>2]=1;p=h+4|0;k[ia>>2]=p;k[g>>2]=23;i[h+27>>0]=0;q=247634;s=p+23|0;do{i[p>>0]=i[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(s|0));Y8(-215,ia,247626,247404,318);k[g>>2]=0;k[ia>>2]=0;U=k[h>>2]|0;k[h>>2]=U+-1;if((U|0)==1)ggb(k[h+-4>>2]|0)}R=$-fa|0;S=a+48|0;T=$+1-ea|0;U=a+148|0;N=a+92|0;O=a+140|0;P=a+104|0;Q=aa(l,o)|0;v=da+-1+j-n|0;L=aa(v-l|0,o)|0;M=(m<<2|0)==(o|0);H=aa(l,m)|0;I=(H|0)>0;J=aa(n,m)|0;K=(J|0)>0;F=aa(v,m)|0;G=(Q|0)>0;D=aa(n,o)|0;E=(D|0)>0;v=aa(v,o)|0;w=a+188|0;x=a+56|0;y=a+160|0;z=ea+-1|0;A=a+196|0;B=a+40|0;C=a+72|0;t=a+128|0;u=ia+4|0;n=b;a=0;g=d;while(1){b=k[V>>2]|0;d=k[W>>2]|0;h=R-b-d+(k[S>>2]|0)|0;h=(h|0)>0?h:T;h=(g|0)<(h|0)?g:h;o=g-h|0;j=h+-1|0;do if((h|0)>0){m=aa(h,c)|0;if(ha){l=n;g=d;while(1){h=((k[N>>2]|0)+15&-16)+(aa(k[O>>2]|0,(b-(k[U>>2]|0)+g|0)%($|0)|0)|0)|0;d=k[P>>2]|0;k[W>>2]=g+1;if((g|0)>=($|0)){k[W>>2]=g;k[V>>2]=b+1}upb(d+Q|0,l|0,L|0)|0;do if(Z)if(M){if(I){g=0;do{k[d+(g<<2)>>2]=k[l+(k[X+(g<<2)>>2]<<2)>>2];g=g+1|0}while((g|0)!=(H|0))}if(K)g=0;else break;do{k[d+(g+F<<2)>>2]=k[l+(k[X+(g+H<<2)>>2]<<2)>>2];g=g+1|0}while((g|0)!=(J|0))}else{if(G){g=0;do{i[d+g>>0]=i[l+(k[X+(g<<2)>>2]|0)>>0]|0;g=g+1|0}while((g|0)!=(Q|0))}if(E)g=0;else break;do{i[d+(g+v)>>0]=i[l+(k[X+(g+Q<<2)>>2]|0)>>0]|0;g=g+1|0}while((g|0)!=(D|0))}while(0);s=k[w>>2]|0;eh[k[(k[s>>2]|0)+8>>2]&255](s,d,h,da,((k[Y>>2]|0)>>>3&511)+1|0);if((j|0)<=0)break;l=l+c|0;b=k[V>>2]|0;g=k[W>>2]|0;j=j+-1|0}l=n+m|0;break}else{l=n;g=d;d=j;while(1){h=((k[N>>2]|0)+15&-16)+(aa(k[O>>2]|0,(b-(k[U>>2]|0)+g|0)%($|0)|0)|0)|0;k[W>>2]=g+1;if((g|0)>=($|0)){k[W>>2]=g;k[V>>2]=b+1}upb(h+Q|0,l|0,L|0)|0;do if(Z)if(M){if(I){g=0;do{k[h+(g<<2)>>2]=k[l+(k[X+(g<<2)>>2]<<2)>>2];g=g+1|0}while((g|0)!=(H|0))}if(K)g=0;else break;do{k[h+(g+F<<2)>>2]=k[l+(k[X+(g+H<<2)>>2]<<2)>>2];g=g+1|0}while((g|0)!=(J|0))}else{if(G){g=0;do{i[h+g>>0]=i[l+(k[X+(g<<2)>>2]|0)>>0]|0;g=g+1|0}while((g|0)!=(Q|0))}if(E)g=0;else break;do{i[h+(g+v)>>0]=i[l+(k[X+(g+Q<<2)>>2]|0)>>0]|0;g=g+1|0}while((g|0)!=(D|0))}while(0);if((d|0)<=0)break;l=l+c|0;b=k[V>>2]|0;g=k[W>>2]|0;d=d+-1|0}l=n+m|0;break}}else l=n;while(0);h=k[y>>2]|0;d=z-a+(k[x>>2]|0)-h|0;d=(d|0)<($|0)?d:$;a:do if((d|0)>0){j=a-fa|0;g=0;while(1){b=uY(j+g+h+(k[S>>2]|0)|0,k[B>>2]|0,k[C>>2]|0)|0;if((b|0)<0)k[_+(g<<2)>>2]=(k[t>>2]|0)+15&-16;else{h=k[V>>2]|0;if((b|0)<(h|0)){h=ZT(20)|0;k[h>>2]=1;p=h+4|0;k[ia>>2]=p;k[u>>2]=14;i[h+18>>0]=0;q=247658;s=p+14|0;do{i[p>>0]=i[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(s|0));Y8(-215,ia,247626,247404,374);k[u>>2]=0;k[ia>>2]=0;s=k[h>>2]|0;k[h>>2]=s+-1;if((s|0)==1)ggb(k[h+-4>>2]|0);h=k[V>>2]|0}if((b|0)>=((k[W>>2]|0)+h|0))break a;s=((k[N>>2]|0)+15&-16)+(aa(k[O>>2]|0,(b-(k[U>>2]|0)|0)%($|0)|0)|0)|0;k[_+(g<<2)>>2]=s}g=g+1|0;if((g|0)>=(d|0))break a;h=k[y>>2]|0}}else g=0;while(0);if((g|0)<(ea|0))break;h=g-z|0;g=k[ga>>2]|0;if(!g){q=k[A>>2]|0;s=aa(k[ca>>2]|0,ba)|0;Lg[k[(k[q>>2]|0)+8>>2]&255](q,_,e,f,h,s)}else Eh[k[(k[g>>2]|0)+8>>2]&127](g,_,e,f,h,k[ca>>2]|0,ba);n=l;e=e+(aa(h,f)|0)|0;a=h+a|0;g=o}f=(k[y>>2]|0)+a|0;k[y>>2]=f;if((f|0)<=(k[x>>2]|0)){r=ja;return a|0}g=ia+4|0;h=ZT(24)|0;k[h>>2]=1;p=h+4|0;k[ia>>2]=p;k[g>>2]=18;i[h+22>>0]=0;q=247673;s=p+18|0;do{i[p>>0]=i[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(s|0));Y8(-215,ia,247626,247404,391);k[g>>2]=0;k[ia>>2]=0;ia=k[h>>2]|0;k[h>>2]=ia+-1;if((ia|0)==1)ggb(k[h+-4>>2]|0);r=ja;return a|0}function pga(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;q=r;r=r+32|0;p=q+8|0;o=q;if(!((k[b>>2]&4095|0)==(k[a+4>>2]|0)?(k[c>>2]&4095|0)==(k[a+8>>2]|0):0)){g=p+4|0;h=ZT(52)|0;k[h>>2]=1;j=h+4|0;k[p>>2]=j;k[g>>2]=46;i[h+50>>0]=0;l=247357;m=j+46|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,p,400950,247404,399);k[g>>2]=0;k[p>>2]=0;m=k[h>>2]|0;k[h>>2]=m+-1;if((m|0)==1)ggb(k[h+-4>>2]|0)}s=k[d>>2]|0;k[p>>2]=s;h=p+4|0;t=k[d+4>>2]|0;k[h>>2]=t;l=p+8|0;j=k[d+8>>2]|0;k[l>>2]=j;m=p+12|0;g=k[d+12>>2]|0;k[m>>2]=g;if((t|s|0)==0&(j&g|0)==-1){j=k[b+12>>2]|0;g=k[b+8>>2]|0;k[p>>2]=0;k[h>>2]=0;k[l>>2]=j;k[m>>2]=g}if(!(aa(g,j)|0)){r=q;return}h=k[e>>2]|0;if(!((((h|0)>-1?(n=k[e+4>>2]|0,(n|0)>-1):0)?(h+j|0)<=(k[c+12>>2]|0):0)?(n+g|0)<=(k[c+8>>2]|0):0)){g=o+4|0;h=ZT(116)|0;k[h>>2]=1;j=h+4|0;k[o>>2]=j;k[g>>2]=109;i[h+113>>0]=0;l=247472;m=j+109|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,o,400950,247404,410);k[g>>2]=0;k[o>>2]=0;t=k[h>>2]|0;k[h>>2]=t+-1;if((t|0)==1)ggb(k[h+-4>>2]|0)}h=$g[k[(k[a>>2]|0)+12>>2]&127](a,b,p,f,-1)|0;m=k[b+48>>2]|0;h=(k[b+16>>2]|0)+(aa(m,h)|0)|0;g=k[b+4>>2]|0;if((g|0)>0)g=k[(k[b+44>>2]|0)+(g+-1<<2)>>2]|0;else g=0;l=h+(aa(g,k[p>>2]|0)|0)|0;g=k[c+44>>2]|0;j=(k[c+16>>2]|0)+(aa(k[g>>2]|0,k[e+4>>2]|0)|0)|0;h=k[c+4>>2]|0;if((h|0)>0)g=k[g+(h+-1<<2)>>2]|0;else g=0;t=j+(aa(g,k[e>>2]|0)|0)|0;Sf[k[(k[a>>2]|0)+16>>2]&127](a,l,m,(k[a+152>>2]|0)-(k[a+144>>2]|0)|0,t,k[c+48>>2]|0)|0;r=q;return}function qga(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=r;r=r+16|0;v=G;k[a>>2]=70400;w=a+16|0;F=a+36|0;k[a+76>>2]=0;x=a+80|0;k[x>>2]=0;k[a+84>>2]=0;C=a+120|0;y=a+128|0;B=a+132|0;m=a+164|0;s=a+180|0;t=a+188|0;u=a+196|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;k[F+16>>2]=0;k[F+20>>2]=0;n=a+92|0;o=n+48|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));n=m;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));A=e&4095;E=a+4|0;k[E>>2]=A;A=(e>>>3&511)+1<<(47696>>>(A<<1&14)&3);k[a+8>>2]=f&4095;p=a+12|0;k[p>>2]=g&4095;f=a+176|0;g=k[b>>2]|0;e=k[b+4>>2]|0;if(g){m=g+4|0;k[m>>2]=(k[m>>2]|0)+1;m=k[f>>2]|0;k[f>>2]=g;k[s>>2]=e;if(m|0?(n=m+4|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0)Uh[k[(k[m>>2]|0)+8>>2]&2047](m)}else{k[f>>2]=g;k[s>>2]=e}f=a+184|0;g=k[c>>2]|0;m=k[c+4>>2]|0;if(g|0){o=g+4|0;k[o>>2]=(k[o>>2]|0)+1}e=k[f>>2]|0;k[f>>2]=g;k[t>>2]=m;if(e|0?(n=e+4|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);f=a+192|0;g=k[d>>2]|0;m=k[d+4>>2]|0;if(g|0){o=g+4|0;k[o>>2]=(k[o>>2]|0)+1}e=k[f>>2]|0;k[f>>2]=g;k[u>>2]=m;if(e|0?(n=e+4|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);o=(j|0)<0?h:j;j=a+68|0;k[j>>2]=h;d=a+72|0;k[d>>2]=o;if((o|0)==3){k[v>>2]=0;m=v+4|0;k[m>>2]=0;e=ZT(36)|0;k[e>>2]=1;n=e+4|0;k[v>>2]=n;k[m>>2]=31;i[e+35>>0]=0;f=248015;o=n+31|0;do{i[n>>0]=i[f>>0]|0;n=n+1|0;f=f+1|0}while((n|0)<(o|0));Y8(-215,v,403227,247404,123);k[m>>2]=0;k[v>>2]=0;h=k[e>>2]|0;k[e>>2]=h+-1;if((h|0)==1)ggb(k[e+-4>>2]|0)}m=k[s>>2]|0;if(!m){e=k[t>>2]|0;if((e|0)!=0?(q=k[u>>2]|0,(q|0)!=0):0)m=q;else{k[v>>2]=0;m=v+4|0;k[m>>2]=0;e=ZT(32)|0;k[e>>2]=1;n=e+4|0;k[v>>2]=n;k[m>>2]=25;i[e+29>>0]=0;f=248047;o=n+25|0;do{i[n>>0]=i[f>>0]|0;n=n+1|0;f=f+1|0}while((n|0)<(o|0));Y8(-215,v,403227,247404,127);k[m>>2]=0;k[v>>2]=0;s=k[e>>2]|0;k[e>>2]=s+-1;if((s|0)==1)ggb(k[e+-4>>2]|0);e=k[t>>2]|0;m=k[u>>2]|0}u=k[e+4>>2]|0;g=k[m+4>>2]|0;k[w>>2]=u;k[a+20>>2]=g;e=k[e+8>>2]|0;f=k[m+8>>2]|0;k[a+24>>2]=e;k[a+28>>2]=f;m=u}else{if((k[p>>2]|0)!=(k[E>>2]|0)){k[v>>2]=0;m=v+4|0;k[m>>2]=0;e=ZT(24)|0;k[e>>2]=1;n=e+4|0;k[v>>2]=n;k[m>>2]=18;i[e+22>>0]=0;f=248073;o=n+18|0;do{i[n>>0]=i[f>>0]|0;n=n+1|0;f=f+1|0}while((n|0)<(o|0));Y8(-215,v,403227,247404,133);k[m>>2]=0;k[v>>2]=0;u=k[e>>2]|0;k[e>>2]=u+-1;if((u|0)==1)ggb(k[e+-4>>2]|0);m=k[s>>2]|0}u=k[m+4>>2]|0;k[w>>2]=u;g=k[m+8>>2]|0;k[a+20>>2]=g;e=k[m+12>>2]|0;k[a+24>>2]=e;f=k[m+16>>2]|0;k[a+28>>2]=f;m=u}if(!((e|f|0)>-1&(e|0)<(m|0)&(f|0)<(g|0))){k[v>>2]=0;m=v+4|0;k[m>>2]=0;e=ZT(88)|0;k[e>>2]=1;n=e+4|0;k[v>>2]=n;k[m>>2]=83;i[e+87>>0]=0;f=248092;o=n+83|0;do{i[n>>0]=i[f>>0]|0;n=n+1|0;f=f+1|0}while((n|0)<(o|0));Y8(-215,v,403227,247404,139);k[m>>2]=0;k[v>>2]=0;v=k[e>>2]|0;k[e>>2]=v+-1;if((v|0)==1)ggb(k[e+-4>>2]|0);m=k[w>>2]|0}e=A>>>((k[E>>2]|0)>>>1&2);k[a+88>>2]=e;c=m+-1|0;c=(c|0)<1?1:c;m=a+76|0;e=aa(c,e)|0;b=k[x>>2]|0;g=k[m>>2]|0;f=b-g>>2;if(e>>>0<=f>>>0){if(e>>>0<f>>>0?(z=g+(e<<2)|0,(b|0)!=(z|0)):0)k[x>>2]=b+(~((b+-4-z|0)>>>2)<<2)}else U1(m,e-f|0);k[a+140>>2]=0;k[a+32>>2]=0;m=k[y>>2]|0;if((k[B>>2]|0)!=(m|0))k[B>>2]=m;if(k[j>>2]|0?k[d>>2]|0:0){k[F>>2]=-1;l=a+40|0;k[l>>2]=-1;r=G;return}b=a+116|0;e=aa(c,A)|0;g=k[C>>2]|0;m=k[b>>2]|0;f=g-m|0;if(e>>>0<=f>>>0){if(e>>>0<f>>>0?(D=m+e|0,(g|0)!=(D|0)):0)k[C>>2]=D}else{T1(b,e-f|0);m=k[b>>2]|0}D=k[E>>2]|0;C=D>>>3&511;E=C+1|0;z2(l,m,(E>>>0>4?24:C<<3)|D&7,aa(E,c)|0);k[F>>2]=-1;l=a+40|0;k[l>>2]=-1;r=G;return}function rga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0.0,o=0,q=0,s=0,t=0,v=0,w=0,x=0;x=r;r=r+128|0;w=x+72|0;v=x+16|0;o=x;do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[w>>2]=k[g>>2];m=w+4|0;a=g+4|0;k[m>>2]=k[a>>2];t=w+8|0;k[t>>2]=k[g+8>>2];k[w+12>>2]=k[g+12>>2];k[w+16>>2]=k[g+16>>2];k[w+20>>2]=k[g+20>>2];k[w+24>>2]=k[g+24>>2];k[w+28>>2]=k[g+28>>2];k[w+32>>2]=k[g+32>>2];c=k[g+36>>2]|0;k[w+36>>2]=c;d=w+40|0;k[d>>2]=t;t=w+48|0;h=w+44|0;k[h>>2]=t;k[w+52>>2]=0;k[t>>2]=0;if(c|0){t=c+12|0;k[t>>2]=(k[t>>2]|0)+1}if((k[a>>2]|0)<3){t=k[g+44>>2]|0;a=k[h>>2]|0;k[a>>2]=k[t>>2];k[a+4>>2]=k[t+4>>2];a=w;break}k[m>>2]=0;x1(w,k[a>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[g+40>>2]|0;f=k[d>>2]|0;d=k[g+44>>2]|0;c=k[h>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[j+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0));a=w}else a=w}else{Q1(w,a,-1);a=w}while(0);if(k[a>>2]&4088|0){k[v>>2]=0;a=v+4|0;k[a>>2]=0;c=ZT(28)|0;k[c>>2]=1;f=c+4|0;k[v>>2]=f;k[a>>2]=23;i[c+27>>0]=0;d=248176;g=f+23|0;do{i[f>>0]=i[d>>0]|0;f=f+1|0;d=d+1|0}while((f|0)<(g|0));Y8(-215,v,248200,247404,428);k[a>>2]=0;k[v>>2]=0;t=k[c>>2]|0;k[c>>2]=t+-1;if((t|0)==1)ggb(k[c+-4>>2]|0)}c=w+8|0;d=w+12|0;h=aa(k[d>>2]|0,k[c>>2]|0)|0;k[v>>2]=1124007936;t=v+4|0;a=v+8|0;q=v+40|0;f=t;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[q>>2]=a;s=v+48|0;m=v+44|0;k[m>>2]=s;k[v+52>>2]=0;k[s>>2]=0;j=o+4|0;g=j+4|0;k[g>>2]=0;k[g+4>>2]=0;k[o>>2]=33619968;k[j>>2]=v;SW(w,o,6,1.0,0.0);j=v+16|0;g=k[j>>2]|0;a=k[c>>2]|0;o=k[d>>2]|0;if((a|0)==1|(o|0)==1?(k[b>>2]<<1|1|0)==(o|0):0)a=(k[b+4>>2]<<1|1|0)==(a|0)?15:12;else a=12;if((h|0)>0){f=h+-1|0;e=0.0;d=0;do{n=+p[g+(d<<3)>>3];l=+p[g+(f-d<<3)>>3];c=n!=l?a&-2:a;c=n!=-l?c&-3:c;c=n<0.0?c&-5:c;p[u>>3]=n;a=k[u+4>>2]|0;b=a&2146435072;if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){a=(a|0)<0;l=a?n+-4503599627370496.0+4503599627370496.0:n+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}else l=n;a=n!=+(~~l|0)?c&-9:c;e=e+n;d=d+1|0}while((d|0)!=(h|0))}else e=0.0;f=+P(+(e+-1.0))>(+P(+e)+1.0)*1.1920928955078125e-07;f=f?a&-5:a;d=v+36|0;a=k[d>>2]|0;if(a|0?(o=a+12|0,b=k[o>>2]|0,k[o>>2]=b+-1,(b|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[v+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[t>>2]|0)>0){c=k[q>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[t>>2]|0))}a=k[m>>2]|0;if(!((a|0)==(s|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=w+36|0;a=k[d>>2]|0;if(a|0?(t=a+12|0,v=k[t>>2]|0,k[t>>2]=v+-1,(v|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[w+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;v=w+16|0;c=w+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[c>>2]|0)>0){d=k[w+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[w+44>>2]|0;if((a|0)==(w+48|0)|(a|0)==0){r=x;return f|0}ggb(k[a+-4>>2]|0);r=x;return f|0}function sga(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+80|0;p=u;s=u+64|0;t=u+8|0;do if((k[d>>2]&2031616|0)==65536){j=k[d+4>>2]|0;k[t>>2]=k[j>>2];o=t+4|0;d=j+4|0;k[o>>2]=k[d>>2];n=t+8|0;k[n>>2]=k[j+8>>2];k[t+12>>2]=k[j+12>>2];k[t+16>>2]=k[j+16>>2];k[t+20>>2]=k[j+20>>2];k[t+24>>2]=k[j+24>>2];k[t+28>>2]=k[j+28>>2];k[t+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[t+36>>2]=g;h=t+40|0;k[h>>2]=n;n=t+48|0;m=t+44|0;k[m>>2]=n;k[t+52>>2]=0;k[n>>2]=0;if(g|0){n=g+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[d>>2]|0)<3){n=k[j+44>>2]|0;o=k[m>>2]|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2];break}k[o>>2]=0;x1(t,k[d>>2]|0,0,0,0);if((k[o>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;d=0;do{k[l+(d<<2)>>2]=k[n+(d<<2)>>2];k[g+(d<<2)>>2]=k[h+(d<<2)>>2];d=d+1|0}while((d|0)<(k[o>>2]|0))}}else Q1(t,d,-1);while(0);l=b&7;j=c&7;if(!((((c^b)&4088|0)==0?(j|0)>=((l>>>0<4?4:l)|0):0)?(k[t>>2]&4095|0)==(j|0):0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(96)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=89;i[g+93>>0]=0;h=248214;o=n+89|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248304,247404,3632);k[d>>2]=0;k[s>>2]=0;o=k[g>>2]|0;k[g>>2]=o+-1;if((o|0)==1)ggb(k[g+-4>>2]|0)}do if(f&3|0?((k[t+12>>2]|0)+(k[t+8>>2]|0)|0)<7:0){if((l|0)==0&(j|0)==4){while(1){d=fgb(76)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}d=m+8|0;k[d>>2]=-1;l=m+4|0;k[l>>2]=-1;k[m>>2]=70932;g=m+12|0;k[g>>2]=1124007936;h=m+20|0;j=m+52|0;n=m+16|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[j>>2]=h;p=m+60|0;k[m+56>>2]=p;k[m+64>>2]=0;k[p>>2]=0;if(!(k[t>>2]&16384)){p=s+4|0;c=p+4|0;k[c>>2]=0;k[c+4>>2]=0;k[s>>2]=33619968;k[p>>2]=g;mY(t,s)}else KG(g,t)|0;k[d>>2]=e;p=k[h>>2]|0;e=k[m+24>>2]|0;k[l>>2]=p+-1+e;if(!((k[g>>2]&4095|0)==4?(p|0)==1|(e|0)==1:0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(84)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=77;i[g+81>>0]=0;h=248408;o=n+77|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248486,247404,3080);k[d>>2]=0;k[s>>2]=0;e=k[g>>2]|0;k[g>>2]=e+-1;if((e|0)==1)ggb(k[g+-4>>2]|0)}k[m>>2]=70912;k[m+72>>2]=f;if((k[l>>2]|0)>=6){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(92)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=84;i[g+88>>0]=0;h=249696;o=n+84|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,249781,247404,3139);k[d>>2]=0;k[s>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=1;k[d>>2]=70432;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;k[s>>2]=(k[s>>2]|0)+1;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if((l|0)==5&(j|0)==5){while(1){d=fgb(76)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}d=m+8|0;k[d>>2]=-1;l=m+4|0;k[l>>2]=-1;k[m>>2]=70892;g=m+12|0;k[g>>2]=1124007936;h=m+20|0;j=m+52|0;n=m+16|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[j>>2]=h;p=m+60|0;k[m+56>>2]=p;k[m+64>>2]=0;k[p>>2]=0;if(!(k[t>>2]&16384)){p=s+4|0;c=p+4|0;k[c>>2]=0;k[c+4>>2]=0;k[s>>2]=33619968;k[p>>2]=g;mY(t,s)}else KG(g,t)|0;k[d>>2]=e;p=k[h>>2]|0;e=k[m+24>>2]|0;k[l>>2]=p+-1+e;if(!((k[g>>2]&4095|0)==5?(p|0)==1|(e|0)==1:0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(84)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=77;i[g+81>>0]=0;h=248408;o=n+77|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248486,247404,3080);k[d>>2]=0;k[s>>2]=0;e=k[g>>2]|0;k[g>>2]=e+-1;if((e|0)==1)ggb(k[g+-4>>2]|0)}k[m>>2]=70872;k[m+72>>2]=f;if((k[l>>2]|0)>=6){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(92)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=84;i[g+88>>0]=0;h=249696;o=n+84|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,249781,247404,3139);k[d>>2]=0;k[s>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=1;k[d>>2]=70452;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;k[s>>2]=(k[s>>2]|0)+1;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d)}else q=59}else q=59;while(0);do if((q|0)==59){d=(l|0)==0;if(d&(j|0)==4){while(1){d=fgb(72)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}d=m+8|0;k[d>>2]=-1;g=m+4|0;k[g>>2]=-1;k[m>>2]=70852;h=m+12|0;k[h>>2]=1124007936;j=m+20|0;l=m+52|0;n=m+16|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[l>>2]=j;q=m+60|0;k[m+56>>2]=q;k[m+64>>2]=0;k[q>>2]=0;if(!(k[t>>2]&16384)){q=s+4|0;f=q+4|0;k[f>>2]=0;k[f+4>>2]=0;k[s>>2]=33619968;k[q>>2]=h;mY(t,s)}else KG(h,t)|0;k[d>>2]=e;q=k[j>>2]|0;e=k[m+24>>2]|0;k[g>>2]=q+-1+e;if(!((k[h>>2]&4095|0)==4?(q|0)==1|(e|0)==1:0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(84)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=77;i[g+81>>0]=0;h=248408;o=n+77|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248486,247404,3080);k[d>>2]=0;k[s>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=1;k[d>>2]=70472;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;k[s>>2]=(k[s>>2]|0)+1;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}h=(j|0)==5;if(d&h){while(1){d=fgb(72)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}d=m+8|0;k[d>>2]=-1;g=m+4|0;k[g>>2]=-1;k[m>>2]=70832;h=m+12|0;k[h>>2]=1124007936;j=m+20|0;l=m+52|0;n=m+16|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[l>>2]=j;q=m+60|0;k[m+56>>2]=q;k[m+64>>2]=0;k[q>>2]=0;if(!(k[t>>2]&16384)){q=s+4|0;f=q+4|0;k[f>>2]=0;k[f+4>>2]=0;k[s>>2]=33619968;k[q>>2]=h;mY(t,s)}else KG(h,t)|0;k[d>>2]=e;q=k[j>>2]|0;e=k[m+24>>2]|0;k[g>>2]=q+-1+e;if(!((k[h>>2]&4095|0)==5?(q|0)==1|(e|0)==1:0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(84)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=77;i[g+81>>0]=0;h=248408;o=n+77|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248486,247404,3080);k[d>>2]=0;k[s>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=1;k[d>>2]=70492;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;k[s>>2]=(k[s>>2]|0)+1;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}g=(j|0)==6;if(d&g){while(1){d=fgb(72)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}d=m+8|0;k[d>>2]=-1;g=m+4|0;k[g>>2]=-1;k[m>>2]=70812;h=m+12|0;k[h>>2]=1124007936;j=m+20|0;l=m+52|0;n=m+16|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[l>>2]=j;q=m+60|0;k[m+56>>2]=q;k[m+64>>2]=0;k[q>>2]=0;if(!(k[t>>2]&16384)){q=s+4|0;f=q+4|0;k[f>>2]=0;k[f+4>>2]=0;k[s>>2]=33619968;k[q>>2]=h;mY(t,s)}else KG(h,t)|0;k[d>>2]=e;q=k[j>>2]|0;e=k[m+24>>2]|0;k[g>>2]=q+-1+e;if(!((k[h>>2]&4095|0)==6?(q|0)==1|(e|0)==1:0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(84)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=77;i[g+81>>0]=0;h=248408;o=n+77|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248486,247404,3080);k[d>>2]=0;k[s>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=1;k[d>>2]=70512;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;k[s>>2]=(k[s>>2]|0)+1;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}d=(l|0)==2;if(d&h){while(1){d=fgb(72)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}d=m+8|0;k[d>>2]=-1;g=m+4|0;k[g>>2]=-1;k[m>>2]=70792;h=m+12|0;k[h>>2]=1124007936;j=m+20|0;l=m+52|0;n=m+16|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[l>>2]=j;q=m+60|0;k[m+56>>2]=q;k[m+64>>2]=0;k[q>>2]=0;if(!(k[t>>2]&16384)){q=s+4|0;f=q+4|0;k[f>>2]=0;k[f+4>>2]=0;k[s>>2]=33619968;k[q>>2]=h;mY(t,s)}else KG(h,t)|0;k[d>>2]=e;q=k[j>>2]|0;e=k[m+24>>2]|0;k[g>>2]=q+-1+e;if(!((k[h>>2]&4095|0)==5?(q|0)==1|(e|0)==1:0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(84)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=77;i[g+81>>0]=0;h=248408;o=n+77|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248486,247404,3080);k[d>>2]=0;k[s>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=1;k[d>>2]=70532;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;k[s>>2]=(k[s>>2]|0)+1;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(d&g){while(1){d=fgb(72)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}d=m+8|0;k[d>>2]=-1;g=m+4|0;k[g>>2]=-1;k[m>>2]=70772;h=m+12|0;k[h>>2]=1124007936;j=m+20|0;l=m+52|0;n=m+16|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[l>>2]=j;q=m+60|0;k[m+56>>2]=q;k[m+64>>2]=0;k[q>>2]=0;if(!(k[t>>2]&16384)){q=s+4|0;f=q+4|0;k[f>>2]=0;k[f+4>>2]=0;k[s>>2]=33619968;k[q>>2]=h;mY(t,s)}else KG(h,t)|0;k[d>>2]=e;q=k[j>>2]|0;e=k[m+24>>2]|0;k[g>>2]=q+-1+e;if(!((k[h>>2]&4095|0)==6?(q|0)==1|(e|0)==1:0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(84)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=77;i[g+81>>0]=0;h=248408;o=n+77|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248486,247404,3080);k[d>>2]=0;k[s>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=1;k[d>>2]=70552;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;k[s>>2]=(k[s>>2]|0)+1;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}d=(l|0)==3;if(d&h){while(1){d=fgb(72)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}d=m+8|0;k[d>>2]=-1;g=m+4|0;k[g>>2]=-1;k[m>>2]=70752;h=m+12|0;k[h>>2]=1124007936;j=m+20|0;l=m+52|0;n=m+16|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[l>>2]=j;q=m+60|0;k[m+56>>2]=q;k[m+64>>2]=0;k[q>>2]=0;if(!(k[t>>2]&16384)){q=s+4|0;f=q+4|0;k[f>>2]=0;k[f+4>>2]=0;k[s>>2]=33619968;k[q>>2]=h;mY(t,s)}else KG(h,t)|0;k[d>>2]=e;q=k[j>>2]|0;e=k[m+24>>2]|0;k[g>>2]=q+-1+e;if(!((k[h>>2]&4095|0)==5?(q|0)==1|(e|0)==1:0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(84)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=77;i[g+81>>0]=0;h=248408;o=n+77|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248486,247404,3080);k[d>>2]=0;k[s>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=1;k[d>>2]=70572;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;k[s>>2]=(k[s>>2]|0)+1;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(d&g){while(1){d=fgb(72)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}d=m+8|0;k[d>>2]=-1;g=m+4|0;k[g>>2]=-1;k[m>>2]=70732;h=m+12|0;k[h>>2]=1124007936;j=m+20|0;l=m+52|0;n=m+16|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[l>>2]=j;q=m+60|0;k[m+56>>2]=q;k[m+64>>2]=0;k[q>>2]=0;if(!(k[t>>2]&16384)){q=s+4|0;f=q+4|0;k[f>>2]=0;k[f+4>>2]=0;k[s>>2]=33619968;k[q>>2]=h;mY(t,s)}else KG(h,t)|0;k[d>>2]=e;q=k[j>>2]|0;e=k[m+24>>2]|0;k[g>>2]=q+-1+e;if(!((k[h>>2]&4095|0)==6?(q|0)==1|(e|0)==1:0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(84)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=77;i[g+81>>0]=0;h=248408;o=n+77|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248486,247404,3080);k[d>>2]=0;k[s>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=1;k[d>>2]=70592;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;k[s>>2]=(k[s>>2]|0)+1;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}d=(l|0)==5;if(d&h){while(1){d=fgb(72)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}d=m+8|0;k[d>>2]=-1;g=m+4|0;k[g>>2]=-1;k[m>>2]=70712;h=m+12|0;k[h>>2]=1124007936;j=m+20|0;l=m+52|0;n=m+16|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[l>>2]=j;q=m+60|0;k[m+56>>2]=q;k[m+64>>2]=0;k[q>>2]=0;if(!(k[t>>2]&16384)){q=s+4|0;f=q+4|0;k[f>>2]=0;k[f+4>>2]=0;k[s>>2]=33619968;k[q>>2]=h;mY(t,s)}else KG(h,t)|0;k[d>>2]=e;q=k[j>>2]|0;e=k[m+24>>2]|0;k[g>>2]=q+-1+e;if(!((k[h>>2]&4095|0)==5?(q|0)==1|(e|0)==1:0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(84)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=77;i[g+81>>0]=0;h=248408;o=n+77|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248486,247404,3080);k[d>>2]=0;k[s>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=1;k[d>>2]=70612;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;k[s>>2]=(k[s>>2]|0)+1;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(d&g){while(1){d=fgb(72)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}d=m+8|0;k[d>>2]=-1;g=m+4|0;k[g>>2]=-1;k[m>>2]=70692;h=m+12|0;k[h>>2]=1124007936;j=m+20|0;l=m+52|0;n=m+16|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[l>>2]=j;q=m+60|0;k[m+56>>2]=q;k[m+64>>2]=0;k[q>>2]=0;if(!(k[t>>2]&16384)){q=s+4|0;f=q+4|0;k[f>>2]=0;k[f+4>>2]=0;k[s>>2]=33619968;k[q>>2]=h;mY(t,s)}else KG(h,t)|0;k[d>>2]=e;q=k[j>>2]|0;e=k[m+24>>2]|0;k[g>>2]=q+-1+e;if(!((k[h>>2]&4095|0)==6?(q|0)==1|(e|0)==1:0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(84)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=77;i[g+81>>0]=0;h=248408;o=n+77|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248486,247404,3080);k[d>>2]=0;k[s>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=1;k[d>>2]=70632;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;k[s>>2]=(k[s>>2]|0)+1;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(!((l|0)==6&g)){k[p>>2]=b;k[p+4>>2]=c;$8(s,348914,p);Y8(-213,s,248304,247404,3671);d=k[s>>2]|0;k[s+4>>2]=0;k[s>>2]=0;if(d|0?(e=d+-4|0,s=k[e>>2]|0,k[e>>2]=s+-1,(s|0)==1):0)ggb(k[d+-8>>2]|0);k[a>>2]=0;k[a+4>>2]=0;break}while(1){d=fgb(72)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}d=m+8|0;k[d>>2]=-1;g=m+4|0;k[g>>2]=-1;k[m>>2]=70672;h=m+12|0;k[h>>2]=1124007936;j=m+20|0;l=m+52|0;n=m+16|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[l>>2]=j;q=m+60|0;k[m+56>>2]=q;k[m+64>>2]=0;k[q>>2]=0;if(!(k[t>>2]&16384)){q=s+4|0;f=q+4|0;k[f>>2]=0;k[f+4>>2]=0;k[s>>2]=33619968;k[q>>2]=h;mY(t,s)}else KG(h,t)|0;k[d>>2]=e;q=k[j>>2]|0;e=k[m+24>>2]|0;k[g>>2]=q+-1+e;if(!((k[h>>2]&4095|0)==6?(q|0)==1|(e|0)==1:0)){k[s>>2]=0;d=s+4|0;k[d>>2]=0;g=ZT(84)|0;k[g>>2]=1;n=g+4|0;k[s>>2]=n;k[d>>2]=77;i[g+81>>0]=0;h=248408;o=n+77|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(o|0));Y8(-215,s,248486,247404,3080);k[d>>2]=0;k[s>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}s=d+4|0;k[s>>2]=1;k[d>>2]=70652;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;k[s>>2]=(k[s>>2]|0)+1;a=k[s>>2]|0;k[s>>2]=a+-1;if((a|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d)}while(0);h=t+36|0;d=k[h>>2]|0;if(d|0?(s=d+12|0,a=k[s>>2]|0,k[s>>2]=a+-1,(a|0)==1):0){g=k[h>>2]|0;if(g|0){d=k[g+4>>2]|0;if(!d){d=k[t+32>>2]|0;if(!d){d=B1()|0;g=k[h>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[h>>2]=0}k[h>>2]=0;a=t+16|0;g=t+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[g>>2]|0)>0){h=k[t+40>>2]|0;d=0;do{k[h+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[g>>2]|0))}d=k[t+44>>2]|0;if((d|0)==(t+48|0)|(d|0)==0){r=u;return}ggb(k[d+-4>>2]|0);r=u;return}function tga(a){a=a|0;ggb(a);return}function uga(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function vga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70672;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function wga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70672;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function xga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0,j=0.0,l=0,m=0,n=0,o=0,q=0.0;n=k[a+4>>2]|0;o=k[a+28>>2]|0;m=aa(e,d)|0;l=m+-4|0;do if((m|0)<4)a=0;else{if((n|0)>1)g=0;else{a=0;do{g=b+(a<<3)|0;f=+p[o>>3];h=f*+p[g+8>>3];i=f*+p[g+16>>3];j=f*+p[g+24>>3];p[c+(a<<3)>>3]=f*+p[g>>3];p[c+((a|1)<<3)>>3]=h;p[c+((a|2)<<3)>>3]=i;p[c+((a|3)<<3)>>3]=j;a=a+4|0}while((a|0)<=(l|0));a=m&-4;break}do{d=b+(g<<3)|0;j=+p[o>>3];a=d;f=j*+p[d+24>>3];h=j*+p[d+16>>3];i=j*+p[d+8>>3];j=j*+p[d>>3];d=1;do{a=a+(e<<3)|0;q=+p[o+(d<<3)>>3];j=j+q*+p[a>>3];i=i+q*+p[a+8>>3];h=h+q*+p[a+16>>3];f=f+q*+p[a+24>>3];d=d+1|0}while((d|0)!=(n|0));p[c+(g<<3)>>3]=j;p[c+((g|1)<<3)>>3]=i;p[c+((g|2)<<3)>>3]=h;p[c+((g|3)<<3)>>3]=f;g=g+4|0}while((g|0)<=(l|0));a=m&-4}while(0);if((a|0)>=(m|0))return;if((n|0)<=1){do{p[c+(a<<3)>>3]=+p[o>>3]*+p[b+(a<<3)>>3];a=a+1|0}while((a|0)!=(m|0));return}do{d=b+(a<<3)|0;f=+p[o>>3]*+p[d>>3];g=1;do{d=d+(e<<3)|0;f=f+ +p[o+(g<<3)>>3]*+p[d>>3];g=g+1|0}while((g|0)!=(n|0));p[c+(a<<3)>>3]=f;a=a+1|0}while((a|0)!=(m|0));return}function yga(a){a=a|0;ggb(a);return}function zga(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Aga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70692;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Bga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70692;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Cga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0,j=0.0,l=0,m=0,n=0,q=0,r=0.0;n=k[a+4>>2]|0;q=k[a+28>>2]|0;m=aa(e,d)|0;l=m+-4|0;do if((m|0)<4)a=0;else{if((n|0)>1)g=0;else{a=0;do{g=b+(a<<2)|0;f=+p[q>>3];h=f*+o[g+4>>2];i=f*+o[g+8>>2];j=f*+o[g+12>>2];p[c+(a<<3)>>3]=f*+o[g>>2];p[c+((a|1)<<3)>>3]=h;p[c+((a|2)<<3)>>3]=i;p[c+((a|3)<<3)>>3]=j;a=a+4|0}while((a|0)<=(l|0));a=m&-4;break}do{d=b+(g<<2)|0;j=+p[q>>3];a=d;f=j*+o[d+12>>2];h=j*+o[d+8>>2];i=j*+o[d+4>>2];j=j*+o[d>>2];d=1;do{a=a+(e<<2)|0;r=+p[q+(d<<3)>>3];j=j+r*+o[a>>2];i=i+r*+o[a+4>>2];h=h+r*+o[a+8>>2];f=f+r*+o[a+12>>2];d=d+1|0}while((d|0)!=(n|0));p[c+(g<<3)>>3]=j;p[c+((g|1)<<3)>>3]=i;p[c+((g|2)<<3)>>3]=h;p[c+((g|3)<<3)>>3]=f;g=g+4|0}while((g|0)<=(l|0));a=m&-4}while(0);if((a|0)>=(m|0))return;if((n|0)<=1){do{p[c+(a<<3)>>3]=+p[q>>3]*+o[b+(a<<2)>>2];a=a+1|0}while((a|0)!=(m|0));return}do{d=b+(a<<2)|0;f=+p[q>>3]*+o[d>>2];g=1;do{d=d+(e<<2)|0;f=f+ +p[q+(g<<3)>>3]*+o[d>>2];g=g+1|0}while((g|0)!=(n|0));p[c+(a<<3)>>3]=f;a=a+1|0}while((a|0)!=(m|0));return}function Dga(a){a=a|0;ggb(a);return}function Ega(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Fga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70712;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Gga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70712;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Hga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0,j=0.0,l=0,m=0,n=0,p=0,q=0.0;n=k[a+4>>2]|0;p=k[a+28>>2]|0;m=aa(e,d)|0;l=m+-4|0;do if((m|0)<4)a=0;else{if((n|0)>1)g=0;else{a=0;do{g=b+(a<<2)|0;f=+o[p>>2];h=f*+o[g+4>>2];i=f*+o[g+8>>2];j=f*+o[g+12>>2];o[c+(a<<2)>>2]=f*+o[g>>2];o[c+((a|1)<<2)>>2]=h;o[c+((a|2)<<2)>>2]=i;o[c+((a|3)<<2)>>2]=j;a=a+4|0}while((a|0)<=(l|0));a=m&-4;break}do{d=b+(g<<2)|0;j=+o[p>>2];a=d;f=j*+o[d+12>>2];h=j*+o[d+8>>2];i=j*+o[d+4>>2];j=j*+o[d>>2];d=1;do{a=a+(e<<2)|0;q=+o[p+(d<<2)>>2];j=j+q*+o[a>>2];i=i+q*+o[a+4>>2];h=h+q*+o[a+8>>2];f=f+q*+o[a+12>>2];d=d+1|0}while((d|0)!=(n|0));o[c+(g<<2)>>2]=j;o[c+((g|1)<<2)>>2]=i;o[c+((g|2)<<2)>>2]=h;o[c+((g|3)<<2)>>2]=f;g=g+4|0}while((g|0)<=(l|0));a=m&-4}while(0);if((a|0)>=(m|0))return;if((n|0)<=1){do{o[c+(a<<2)>>2]=+o[p>>2]*+o[b+(a<<2)>>2];a=a+1|0}while((a|0)!=(m|0));return}do{d=b+(a<<2)|0;f=+o[p>>2]*+o[d>>2];g=1;do{d=d+(e<<2)|0;f=f+ +o[p+(g<<2)>>2]*+o[d>>2];g=g+1|0}while((g|0)!=(n|0));o[c+(a<<2)>>2]=f;a=a+1|0}while((a|0)!=(m|0));return}function Iga(a){a=a|0;ggb(a);return}function Jga(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Kga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70732;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Lga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70732;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Mga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0.0;o=k[a+4>>2]|0;q=k[a+28>>2]|0;n=aa(e,d)|0;m=n+-4|0;do if((n|0)<4)a=0;else{if((o|0)>1)g=0;else{a=0;do{g=b+(a<<1)|0;f=+p[q>>3];h=f*+(j[g+2>>1]|0);i=f*+(j[g+4>>1]|0);l=f*+(j[g+6>>1]|0);p[c+(a<<3)>>3]=f*+(j[g>>1]|0);p[c+((a|1)<<3)>>3]=h;p[c+((a|2)<<3)>>3]=i;p[c+((a|3)<<3)>>3]=l;a=a+4|0}while((a|0)<=(m|0));a=n&-4;break}do{d=b+(g<<1)|0;l=+p[q>>3];a=d;f=l*+(j[d+6>>1]|0);h=l*+(j[d+4>>1]|0);i=l*+(j[d+2>>1]|0);l=l*+(j[d>>1]|0);d=1;do{a=a+(e<<1)|0;r=+p[q+(d<<3)>>3];l=l+r*+(j[a>>1]|0);i=i+r*+(j[a+2>>1]|0);h=h+r*+(j[a+4>>1]|0);f=f+r*+(j[a+6>>1]|0);d=d+1|0}while((d|0)!=(o|0));p[c+(g<<3)>>3]=l;p[c+((g|1)<<3)>>3]=i;p[c+((g|2)<<3)>>3]=h;p[c+((g|3)<<3)>>3]=f;g=g+4|0}while((g|0)<=(m|0));a=n&-4}while(0);if((a|0)>=(n|0))return;if((o|0)<=1){do{p[c+(a<<3)>>3]=+p[q>>3]*+(j[b+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(n|0));return}do{d=b+(a<<1)|0;f=+p[q>>3]*+(j[d>>1]|0);g=1;do{d=d+(e<<1)|0;f=f+ +p[q+(g<<3)>>3]*+(j[d>>1]|0);g=g+1|0}while((g|0)!=(o|0));p[c+(a<<3)>>3]=f;a=a+1|0}while((a|0)!=(n|0));return}function Nga(a){a=a|0;ggb(a);return}function Oga(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Pga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70752;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Qga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70752;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Rga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0,l=0.0,m=0,n=0,p=0,q=0,r=0.0;p=k[a+4>>2]|0;q=k[a+28>>2]|0;n=aa(e,d)|0;m=n+-4|0;do if((n|0)<4)a=0;else{if((p|0)>1)g=0;else{a=0;do{g=b+(a<<1)|0;f=+o[q>>2];h=f*+(j[g+2>>1]|0);i=f*+(j[g+4>>1]|0);l=f*+(j[g+6>>1]|0);o[c+(a<<2)>>2]=f*+(j[g>>1]|0);o[c+((a|1)<<2)>>2]=h;o[c+((a|2)<<2)>>2]=i;o[c+((a|3)<<2)>>2]=l;a=a+4|0}while((a|0)<=(m|0));a=n&-4;break}do{d=b+(g<<1)|0;l=+o[q>>2];a=d;f=l*+(j[d+6>>1]|0);h=l*+(j[d+4>>1]|0);i=l*+(j[d+2>>1]|0);l=l*+(j[d>>1]|0);d=1;do{a=a+(e<<1)|0;r=+o[q+(d<<2)>>2];l=l+r*+(j[a>>1]|0);i=i+r*+(j[a+2>>1]|0);h=h+r*+(j[a+4>>1]|0);f=f+r*+(j[a+6>>1]|0);d=d+1|0}while((d|0)!=(p|0));o[c+(g<<2)>>2]=l;o[c+((g|1)<<2)>>2]=i;o[c+((g|2)<<2)>>2]=h;o[c+((g|3)<<2)>>2]=f;g=g+4|0}while((g|0)<=(m|0));a=n&-4}while(0);if((a|0)>=(n|0))return;if((p|0)<=1){do{o[c+(a<<2)>>2]=+o[q>>2]*+(j[b+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(n|0));return}do{d=b+(a<<1)|0;f=+o[q>>2]*+(j[d>>1]|0);g=1;do{d=d+(e<<1)|0;f=f+ +o[q+(g<<2)>>2]*+(j[d>>1]|0);g=g+1|0}while((g|0)!=(p|0));o[c+(a<<2)>>2]=f;a=a+1|0}while((a|0)!=(n|0));return}function Sga(a){a=a|0;ggb(a);return}function Tga(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Uga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70772;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Vga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70772;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Wga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0,j=0.0,l=0,n=0,o=0,q=0,r=0.0;o=k[a+4>>2]|0;q=k[a+28>>2]|0;n=aa(e,d)|0;l=n+-4|0;do if((n|0)<4)a=0;else{if((o|0)>1)g=0;else{a=0;do{g=b+(a<<1)|0;f=+p[q>>3];h=f*+(m[g+2>>1]|0);i=f*+(m[g+4>>1]|0);j=f*+(m[g+6>>1]|0);p[c+(a<<3)>>3]=f*+(m[g>>1]|0);p[c+((a|1)<<3)>>3]=h;p[c+((a|2)<<3)>>3]=i;p[c+((a|3)<<3)>>3]=j;a=a+4|0}while((a|0)<=(l|0));a=n&-4;break}do{d=b+(g<<1)|0;j=+p[q>>3];a=d;f=j*+(m[d+6>>1]|0);h=j*+(m[d+4>>1]|0);i=j*+(m[d+2>>1]|0);j=j*+(m[d>>1]|0);d=1;do{a=a+(e<<1)|0;r=+p[q+(d<<3)>>3];j=j+r*+(m[a>>1]|0);i=i+r*+(m[a+2>>1]|0);h=h+r*+(m[a+4>>1]|0);f=f+r*+(m[a+6>>1]|0);d=d+1|0}while((d|0)!=(o|0));p[c+(g<<3)>>3]=j;p[c+((g|1)<<3)>>3]=i;p[c+((g|2)<<3)>>3]=h;p[c+((g|3)<<3)>>3]=f;g=g+4|0}while((g|0)<=(l|0));a=n&-4}while(0);if((a|0)>=(n|0))return;if((o|0)<=1){do{p[c+(a<<3)>>3]=+p[q>>3]*+(m[b+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(n|0));return}do{d=b+(a<<1)|0;f=+p[q>>3]*+(m[d>>1]|0);g=1;do{d=d+(e<<1)|0;f=f+ +p[q+(g<<3)>>3]*+(m[d>>1]|0);g=g+1|0}while((g|0)!=(o|0));p[c+(a<<3)>>3]=f;a=a+1|0}while((a|0)!=(n|0));return}function Xga(a){a=a|0;ggb(a);return}function Yga(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Zga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70792;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function _ga(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70792;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function $ga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0,j=0.0,l=0,n=0,p=0,q=0,r=0.0;p=k[a+4>>2]|0;q=k[a+28>>2]|0;n=aa(e,d)|0;l=n+-4|0;do if((n|0)<4)a=0;else{if((p|0)>1)g=0;else{a=0;do{g=b+(a<<1)|0;f=+o[q>>2];h=f*+(m[g+2>>1]|0);i=f*+(m[g+4>>1]|0);j=f*+(m[g+6>>1]|0);o[c+(a<<2)>>2]=f*+(m[g>>1]|0);o[c+((a|1)<<2)>>2]=h;o[c+((a|2)<<2)>>2]=i;o[c+((a|3)<<2)>>2]=j;a=a+4|0}while((a|0)<=(l|0));a=n&-4;break}do{d=b+(g<<1)|0;j=+o[q>>2];a=d;f=j*+(m[d+6>>1]|0);h=j*+(m[d+4>>1]|0);i=j*+(m[d+2>>1]|0);j=j*+(m[d>>1]|0);d=1;do{a=a+(e<<1)|0;r=+o[q+(d<<2)>>2];j=j+r*+(m[a>>1]|0);i=i+r*+(m[a+2>>1]|0);h=h+r*+(m[a+4>>1]|0);f=f+r*+(m[a+6>>1]|0);d=d+1|0}while((d|0)!=(p|0));o[c+(g<<2)>>2]=j;o[c+((g|1)<<2)>>2]=i;o[c+((g|2)<<2)>>2]=h;o[c+((g|3)<<2)>>2]=f;g=g+4|0}while((g|0)<=(l|0));a=n&-4}while(0);if((a|0)>=(n|0))return;if((p|0)<=1){do{o[c+(a<<2)>>2]=+o[q>>2]*+(m[b+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(n|0));return}do{d=b+(a<<1)|0;f=+o[q>>2]*+(m[d>>1]|0);g=1;do{d=d+(e<<1)|0;f=f+ +o[q+(g<<2)>>2]*+(m[d>>1]|0);g=g+1|0}while((g|0)!=(p|0));o[c+(a<<2)>>2]=f;a=a+1|0}while((a|0)!=(n|0));return}function aha(a){a=a|0;ggb(a);return}function bha(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function cha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70812;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function dha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70812;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function eha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0,j=0.0,m=0,n=0,o=0,q=0,r=0.0;o=k[a+4>>2]|0;q=k[a+28>>2]|0;n=aa(e,d)|0;m=n+-4|0;do if((n|0)<4)a=0;else{if((o|0)>1)g=0;else{a=0;do{g=b+a|0;f=+p[q>>3];h=f*+(l[g+1>>0]|0);i=f*+(l[g+2>>0]|0);j=f*+(l[g+3>>0]|0);p[c+(a<<3)>>3]=f*+(l[g>>0]|0);p[c+((a|1)<<3)>>3]=h;p[c+((a|2)<<3)>>3]=i;p[c+((a|3)<<3)>>3]=j;a=a+4|0}while((a|0)<=(m|0));a=n&-4;break}do{d=b+g|0;j=+p[q>>3];a=d;f=j*+(l[d+3>>0]|0);h=j*+(l[d+2>>0]|0);i=j*+(l[d+1>>0]|0);j=j*+(l[d>>0]|0);d=1;do{a=a+e|0;r=+p[q+(d<<3)>>3];j=j+r*+(l[a>>0]|0);i=i+r*+(l[a+1>>0]|0);h=h+r*+(l[a+2>>0]|0);f=f+r*+(l[a+3>>0]|0);d=d+1|0}while((d|0)!=(o|0));p[c+(g<<3)>>3]=j;p[c+((g|1)<<3)>>3]=i;p[c+((g|2)<<3)>>3]=h;p[c+((g|3)<<3)>>3]=f;g=g+4|0}while((g|0)<=(m|0));a=n&-4}while(0);if((a|0)>=(n|0))return;if((o|0)<=1){do{p[c+(a<<3)>>3]=+p[q>>3]*+(l[b+a>>0]|0);a=a+1|0}while((a|0)!=(n|0));return}do{d=b+a|0;f=+p[q>>3]*+(l[d>>0]|0);g=1;do{d=d+e|0;f=f+ +p[q+(g<<3)>>3]*+(l[d>>0]|0);g=g+1|0}while((g|0)!=(o|0));p[c+(a<<3)>>3]=f;a=a+1|0}while((a|0)!=(n|0));return}function fha(a){a=a|0;ggb(a);return}function gha(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function hha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70832;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function iha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70832;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function jha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0,j=0.0,m=0,n=0,p=0,q=0,r=0.0;p=k[a+4>>2]|0;q=k[a+28>>2]|0;n=aa(e,d)|0;m=n+-4|0;do if((n|0)<4)a=0;else{if((p|0)>1)g=0;else{a=0;do{g=b+a|0;f=+o[q>>2];h=f*+(l[g+1>>0]|0);i=f*+(l[g+2>>0]|0);j=f*+(l[g+3>>0]|0);o[c+(a<<2)>>2]=f*+(l[g>>0]|0);o[c+((a|1)<<2)>>2]=h;o[c+((a|2)<<2)>>2]=i;o[c+((a|3)<<2)>>2]=j;a=a+4|0}while((a|0)<=(m|0));a=n&-4;break}do{d=b+g|0;j=+o[q>>2];a=d;f=j*+(l[d+3>>0]|0);h=j*+(l[d+2>>0]|0);i=j*+(l[d+1>>0]|0);j=j*+(l[d>>0]|0);d=1;do{a=a+e|0;r=+o[q+(d<<2)>>2];j=j+r*+(l[a>>0]|0);i=i+r*+(l[a+1>>0]|0);h=h+r*+(l[a+2>>0]|0);f=f+r*+(l[a+3>>0]|0);d=d+1|0}while((d|0)!=(p|0));o[c+(g<<2)>>2]=j;o[c+((g|1)<<2)>>2]=i;o[c+((g|2)<<2)>>2]=h;o[c+((g|3)<<2)>>2]=f;g=g+4|0}while((g|0)<=(m|0));a=n&-4}while(0);if((a|0)>=(n|0))return;if((p|0)<=1){do{o[c+(a<<2)>>2]=+o[q>>2]*+(l[b+a>>0]|0);a=a+1|0}while((a|0)!=(n|0));return}do{d=b+a|0;f=+o[q>>2]*+(l[d>>0]|0);g=1;do{d=d+e|0;f=f+ +o[q+(g<<2)>>2]*+(l[d>>0]|0);g=g+1|0}while((g|0)!=(p|0));o[c+(a<<2)>>2]=f;a=a+1|0}while((a|0)!=(n|0));return}function kha(a){a=a|0;ggb(a);return}function lha(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function mha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70852;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function nha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70852;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function oha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0;o=k[a+4>>2]|0;p=k[a+28>>2]|0;n=aa(e,d)|0;m=n+-4|0;do if((n|0)<4)a=0;else{if((o|0)>1)j=0;else{a=0;do{f=b+a|0;j=k[p>>2]|0;g=aa(l[f>>0]|0,j)|0;h=aa(l[f+1>>0]|0,j)|0;i=aa(l[f+2>>0]|0,j)|0;j=aa(l[f+3>>0]|0,j)|0;k[c+(a<<2)>>2]=g;k[c+((a|1)<<2)>>2]=h;k[c+((a|2)<<2)>>2]=i;k[c+((a|3)<<2)>>2]=j;a=a+4|0}while((a|0)<=(m|0));a=n&-4;break}do{i=b+j|0;d=k[p>>2]|0;h=aa(l[i>>0]|0,d)|0;g=aa(l[i+1>>0]|0,d)|0;f=aa(l[i+2>>0]|0,d)|0;a=i;d=aa(l[i+3>>0]|0,d)|0;i=1;do{a=a+e|0;q=k[p+(i<<2)>>2]|0;h=(aa(l[a>>0]|0,q)|0)+h|0;g=(aa(l[a+1>>0]|0,q)|0)+g|0;f=(aa(l[a+2>>0]|0,q)|0)+f|0;d=(aa(l[a+3>>0]|0,q)|0)+d|0;i=i+1|0}while((i|0)!=(o|0));k[c+(j<<2)>>2]=h;k[c+((j|1)<<2)>>2]=g;k[c+((j|2)<<2)>>2]=f;k[c+((j|3)<<2)>>2]=d;j=j+4|0}while((j|0)<=(m|0));a=n&-4}while(0);if((a|0)>=(n|0))return;if((o|0)<=1){do{q=aa(l[b+a>>0]|0,k[p>>2]|0)|0;k[c+(a<<2)>>2]=q;a=a+1|0}while((a|0)!=(n|0));return}do{f=b+a|0;d=aa(l[f>>0]|0,k[p>>2]|0)|0;g=1;do{f=f+e|0;d=(aa(l[f>>0]|0,k[p+(g<<2)>>2]|0)|0)+d|0;g=g+1|0}while((g|0)!=(o|0));k[c+(a<<2)>>2]=d;a=a+1|0}while((a|0)!=(n|0));return}function pha(a){a=a|0;ggb(a);return}function qha(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function rha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70892;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function sha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70892;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function tha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0,j=0.0,l=0,m=0,n=0,p=0,q=0.0;n=k[a+4>>2]|0;p=k[a+28>>2]|0;m=aa(e,d)|0;l=m+-4|0;do if((m|0)<4)a=0;else{if((n|0)>1)g=0;else{a=0;do{g=b+(a<<2)|0;f=+o[p>>2];h=f*+o[g+4>>2];i=f*+o[g+8>>2];j=f*+o[g+12>>2];o[c+(a<<2)>>2]=f*+o[g>>2];o[c+((a|1)<<2)>>2]=h;o[c+((a|2)<<2)>>2]=i;o[c+((a|3)<<2)>>2]=j;a=a+4|0}while((a|0)<=(l|0));a=m&-4;break}do{d=b+(g<<2)|0;j=+o[p>>2];a=d;f=j*+o[d+12>>2];h=j*+o[d+8>>2];i=j*+o[d+4>>2];j=j*+o[d>>2];d=1;do{a=a+(e<<2)|0;q=+o[p+(d<<2)>>2];j=j+q*+o[a>>2];i=i+q*+o[a+4>>2];h=h+q*+o[a+8>>2];f=f+q*+o[a+12>>2];d=d+1|0}while((d|0)!=(n|0));o[c+(g<<2)>>2]=j;o[c+((g|1)<<2)>>2]=i;o[c+((g|2)<<2)>>2]=h;o[c+((g|3)<<2)>>2]=f;g=g+4|0}while((g|0)<=(l|0));a=m&-4}while(0);if((a|0)>=(m|0))return;if((n|0)<=1){do{o[c+(a<<2)>>2]=+o[p>>2]*+o[b+(a<<2)>>2];a=a+1|0}while((a|0)!=(m|0));return}do{d=b+(a<<2)|0;f=+o[p>>2]*+o[d>>2];g=1;do{d=d+(e<<2)|0;f=f+ +o[p+(g<<2)>>2]*+o[d>>2];g=g+1|0}while((g|0)!=(n|0));o[c+(a<<2)>>2]=f;a=a+1|0}while((a|0)!=(m|0));return}function uha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70892;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function vha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,i=0,j=0,l=0,m=0,n=0.0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0;v=k[a+4>>2]|0;w=(v|0)/2|0;u=aa(w,e)|0;y=(k[a+28>>2]|0)+(w<<2)|0;f=b+(u<<2)|0;x=aa(e,d)|0;if(!(k[a+72>>2]&1)){a:do switch(v|0){case 3:{h=+o[y+4>>2];m=x+-2|0;d=(x|0)<2;if(+o[y>>2]==0.0&h==1.0){if(d){d=0;break a}g=0-e|0;i=e+1|0;j=1-e|0;l=m>>>1;a=(u<<2)+(l<<3)+8|0;d=0;while(1){t=+o[f+(i<<2)>>2]-+o[f+(j<<2)>>2];o[c+(d<<2)>>2]=+o[f+(e<<2)>>2]-+o[f+(g<<2)>>2];o[c+((d|1)<<2)>>2]=t;d=d+2|0;if((d|0)>(m|0))break;else f=f+8|0}f=b+a|0;d=(l<<1)+2|0;break a}else{if(d){d=0;break a}g=0-e|0;i=e+1|0;j=1-e|0;l=m>>>1;a=(u<<2)+(l<<3)+8|0;d=0;while(1){t=h*(+o[f+(i<<2)>>2]-+o[f+(j<<2)>>2]);o[c+(d<<2)>>2]=h*(+o[f+(e<<2)>>2]-+o[f+(g<<2)>>2]);o[c+((d|1)<<2)>>2]=t;d=d+2|0;if((d|0)>(m|0))break;else f=f+8|0}f=b+a|0;d=(l<<1)+2|0;break a}}case 5:{h=+o[y+4>>2];n=+o[y+8>>2];g=x+-2|0;if((x|0)<2)d=0;else{i=0-e|0;j=e<<1;l=i<<1;m=e+1|0;p=1-e|0;q=j|1;r=1-j|0;s=g>>>1;a=(u<<2)+(s<<3)+8|0;d=0;while(1){t=h*(+o[f+(m<<2)>>2]-+o[f+(p<<2)>>2])+n*(+o[f+(q<<2)>>2]-+o[f+(r<<2)>>2]);o[c+(d<<2)>>2]=h*(+o[f+(e<<2)>>2]-+o[f+(i<<2)>>2])+n*(+o[f+(j<<2)>>2]-+o[f+(l<<2)>>2]);o[c+((d|1)<<2)>>2]=t;d=d+2|0;if((d|0)>(g|0))break;else f=f+8|0}f=b+a|0;d=(s<<1)+2|0}break}default:d=0}while(0);if((d|0)>=(x|0))return;if((v|0)<2){while(1){o[c+(d<<2)>>2]=+o[y>>2]*+o[f>>2];d=d+1|0;if((d|0)==(x|0))break;else f=f+4|0}return}while(1){h=+o[y>>2]*+o[f>>2];a=e;g=1;while(1){h=h+ +o[y+(g<<2)>>2]*(+o[f+(a<<2)>>2]-+o[f+(0-a<<2)>>2]);if((g|0)>=(w|0))break;else{a=a+e|0;g=g+1|0}}o[c+(d<<2)>>2]=h;d=d+1|0;if((d|0)==(x|0))break;else f=f+4|0}return}b:do switch(v|0){case 1:{if(+o[y>>2]==1.0?(j=x+-2|0,(x|0)>=2):0){i=j>>>1;g=(u<<2)+(i<<3)+8|0;a=0;d=f;while(1){u=a|1;s=k[f+(u<<2)>>2]|0;k[c+(a<<2)>>2]=k[d>>2];k[c+(u<<2)>>2]=s;d=a+2|0;if((d|0)>(j|0))break;else{a=d;d=f+(d<<2)|0}}f=b+g|0;d=(i<<1)+2|0}else d=0;break}case 3:{h=+o[y>>2];n=+o[y+4>>2];if(h==2.0&n==1.0){g=x+-2|0;if((x|0)<2){d=0;break b}i=0-e|0;j=1-e|0;l=e+1|0;m=g>>>1;a=(u<<2)+(m<<3)+8|0;d=0;while(1){t=+o[f+(l<<2)>>2]+(+o[f+(j<<2)>>2]+ +o[f+4>>2]*2.0);o[c+(d<<2)>>2]=+o[f+(e<<2)>>2]+(+o[f+(i<<2)>>2]+ +o[f>>2]*2.0);o[c+((d|1)<<2)>>2]=t;d=d+2|0;if((d|0)>(g|0))break;else f=f+8|0}f=b+a|0;d=(m<<1)+2|0;break b}m=x+-2|0;d=(x|0)<2;if(h==-2.0&n==1.0){if(d){d=0;break b}g=0-e|0;i=1-e|0;j=e+1|0;l=m>>>1;a=(u<<2)+(l<<3)+8|0;d=0;while(1){t=+o[f+(j<<2)>>2]+(+o[f+(i<<2)>>2]-+o[f+4>>2]*2.0);o[c+(d<<2)>>2]=+o[f+(e<<2)>>2]+(+o[f+(g<<2)>>2]-+o[f>>2]*2.0);o[c+((d|1)<<2)>>2]=t;d=d+2|0;if((d|0)>(m|0))break;else f=f+8|0}f=b+a|0;d=(l<<1)+2|0;break b}else{if(d){d=0;break b}g=0-e|0;i=1-e|0;j=e+1|0;l=m>>>1;a=(u<<2)+(l<<3)+8|0;d=0;while(1){t=h*+o[f+4>>2]+n*(+o[f+(i<<2)>>2]+ +o[f+(j<<2)>>2]);o[c+(d<<2)>>2]=h*+o[f>>2]+n*(+o[f+(g<<2)>>2]+ +o[f+(e<<2)>>2]);o[c+((d|1)<<2)>>2]=t;d=d+2|0;if((d|0)>(m|0))break;else f=f+8|0}f=b+a|0;d=(l<<1)+2|0;break b}}case 5:{h=+o[y>>2];n=+o[y+4>>2];t=+o[y+8>>2];s=x+-2|0;d=(x|0)<2;if(h==-2.0&n==0.0&t==1.0){if(d){d=0;break b}g=0-e<<1;i=e<<1;j=1-i|0;l=i|1;m=s>>>1;a=(u<<2)+(m<<3)+8|0;d=0;while(1){t=+o[f+(j<<2)>>2]-+o[f+4>>2]*2.0+ +o[f+(l<<2)>>2];o[c+(d<<2)>>2]=+o[f+(g<<2)>>2]-+o[f>>2]*2.0+ +o[f+(i<<2)>>2];o[c+((d|1)<<2)>>2]=t;d=d+2|0;if((d|0)>(s|0))break;else f=f+8|0}f=b+a|0;d=(m<<1)+2|0;break b}else{if(d){d=0;break b}g=0-e|0;i=g<<1;j=e<<1;l=1-e|0;m=e+1|0;p=1-j|0;q=j|1;r=s>>>1;a=(u<<2)+(r<<3)+8|0;d=0;while(1){z=h*+o[f+4>>2]+n*(+o[f+(l<<2)>>2]+ +o[f+(m<<2)>>2])+t*(+o[f+(p<<2)>>2]+ +o[f+(q<<2)>>2]);o[c+(d<<2)>>2]=h*+o[f>>2]+n*(+o[f+(g<<2)>>2]+ +o[f+(e<<2)>>2])+t*(+o[f+(i<<2)>>2]+ +o[f+(j<<2)>>2]);o[c+((d|1)<<2)>>2]=z;d=d+2|0;if((d|0)>(s|0))break;else f=f+8|0}f=b+a|0;d=(r<<1)+2|0;break b}}default:d=0}while(0);if((d|0)>=(x|0))return;if((v|0)<2){while(1){o[c+(d<<2)>>2]=+o[y>>2]*+o[f>>2];d=d+1|0;if((d|0)==(x|0))break;else f=f+4|0}return}while(1){a=e;g=1;h=+o[y>>2]*+o[f>>2];while(1){h=h+ +o[y+(g<<2)>>2]*(+o[f+(a<<2)>>2]+ +o[f+(0-a<<2)>>2]);if((g|0)>=(w|0))break;else{a=a+e|0;g=g+1|0}}o[c+(d<<2)>>2]=h;d=d+1|0;if((d|0)==(x|0))break;else f=f+4|0}return}function wha(a){a=a|0;ggb(a);return}function xha(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function yha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70932;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function zha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70932;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Aha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0;o=k[a+4>>2]|0;p=k[a+28>>2]|0;n=aa(e,d)|0;m=n+-4|0;do if((n|0)<4)a=0;else{if((o|0)>1)j=0;else{a=0;do{f=b+a|0;j=k[p>>2]|0;g=aa(l[f>>0]|0,j)|0;h=aa(l[f+1>>0]|0,j)|0;i=aa(l[f+2>>0]|0,j)|0;j=aa(l[f+3>>0]|0,j)|0;k[c+(a<<2)>>2]=g;k[c+((a|1)<<2)>>2]=h;k[c+((a|2)<<2)>>2]=i;k[c+((a|3)<<2)>>2]=j;a=a+4|0}while((a|0)<=(m|0));a=n&-4;break}do{i=b+j|0;d=k[p>>2]|0;h=aa(l[i>>0]|0,d)|0;g=aa(l[i+1>>0]|0,d)|0;f=aa(l[i+2>>0]|0,d)|0;a=i;d=aa(l[i+3>>0]|0,d)|0;i=1;do{a=a+e|0;q=k[p+(i<<2)>>2]|0;h=(aa(l[a>>0]|0,q)|0)+h|0;g=(aa(l[a+1>>0]|0,q)|0)+g|0;f=(aa(l[a+2>>0]|0,q)|0)+f|0;d=(aa(l[a+3>>0]|0,q)|0)+d|0;i=i+1|0}while((i|0)!=(o|0));k[c+(j<<2)>>2]=h;k[c+((j|1)<<2)>>2]=g;k[c+((j|2)<<2)>>2]=f;k[c+((j|3)<<2)>>2]=d;j=j+4|0}while((j|0)<=(m|0));a=n&-4}while(0);if((a|0)>=(n|0))return;if((o|0)<=1){do{q=aa(l[b+a>>0]|0,k[p>>2]|0)|0;k[c+(a<<2)>>2]=q;a=a+1|0}while((a|0)!=(n|0));return}do{f=b+a|0;d=aa(l[f>>0]|0,k[p>>2]|0)|0;g=1;do{f=f+e|0;d=(aa(l[f>>0]|0,k[p+(g<<2)>>2]|0)|0)+d|0;g=g+1|0}while((g|0)!=(o|0));k[c+(a<<2)>>2]=d;a=a+1|0}while((a|0)!=(n|0));return}function Bha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=70932;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Cha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;v=k[a+4>>2]|0;w=(v|0)/2|0;u=aa(w,e)|0;y=(k[a+28>>2]|0)+(w<<2)|0;f=b+u|0;x=aa(e,d)|0;if(!(k[a+72>>2]&1)){a:do switch(v|0){case 3:{j=k[y+4>>2]|0;n=x+-2|0;d=(x|0)<2;if((k[y>>2]|0)==0&(j|0)==1){if(d){d=0;break a}g=0-e|0;h=e+1|0;i=1-e|0;j=n&-2;a=u+j|0;d=0;while(1){u=(l[f+h>>0]|0)-(l[f+i>>0]|0)|0;k[c+(d<<2)>>2]=(l[f+e>>0]|0)-(l[f+g>>0]|0);k[c+((d|1)<<2)>>2]=u;d=d+2|0;if((d|0)>(n|0))break;else f=f+2|0}f=b+(a+2)|0;d=j+2|0;break a}else{if(d){d=0;break a}g=0-e|0;h=e+1|0;i=1-e|0;m=n&-2;a=u+m|0;d=0;while(1){t=aa((l[f+e>>0]|0)-(l[f+g>>0]|0)|0,j)|0;u=aa((l[f+h>>0]|0)-(l[f+i>>0]|0)|0,j)|0;k[c+(d<<2)>>2]=t;k[c+((d|1)<<2)>>2]=u;d=d+2|0;if((d|0)>(n|0))break;else f=f+2|0}f=b+(a+2)|0;d=m+2|0;break a}}case 5:{g=k[y+4>>2]|0;h=k[y+8>>2]|0;i=x+-2|0;if((x|0)<2)d=0;else{j=0-e|0;m=e<<1;n=j<<1;o=e+1|0;p=1-e|0;q=m|1;r=1-m|0;s=i&-2;a=u+s|0;d=0;while(1){t=aa((l[f+e>>0]|0)-(l[f+j>>0]|0)|0,g)|0;t=(aa((l[f+m>>0]|0)-(l[f+n>>0]|0)|0,h)|0)+t|0;u=aa((l[f+o>>0]|0)-(l[f+p>>0]|0)|0,g)|0;u=(aa((l[f+q>>0]|0)-(l[f+r>>0]|0)|0,h)|0)+u|0;k[c+(d<<2)>>2]=t;k[c+((d|1)<<2)>>2]=u;d=d+2|0;if((d|0)>(i|0))break;else f=f+2|0}f=b+(a+2)|0;d=s+2|0}break}default:d=0}while(0);if((d|0)>=(x|0))return;if((v|0)<2){while(1){w=aa(l[f>>0]|0,k[y>>2]|0)|0;k[c+(d<<2)>>2]=w;d=d+1|0;if((d|0)==(x|0))break;else f=f+1|0}return}while(1){a=aa(l[f>>0]|0,k[y>>2]|0)|0;g=e;h=1;while(1){a=(aa((l[f+g>>0]|0)-(l[f+(0-g)>>0]|0)|0,k[y+(h<<2)>>2]|0)|0)+a|0;if((h|0)>=(w|0))break;else{g=g+e|0;h=h+1|0}}k[c+(d<<2)>>2]=a;d=d+1|0;if((d|0)==(x|0))break;else f=f+1|0}return}b:do switch(v|0){case 1:{if((k[y>>2]|0)==1?(i=x+-2|0,(x|0)>=2):0){h=i&-2;g=u+h|0;a=0;d=f;while(1){u=a|1;t=l[f+u>>0]|0;k[c+(a<<2)>>2]=l[d>>0];k[c+(u<<2)>>2]=t;d=a+2|0;if((d|0)>(i|0))break;else{a=d;d=f+d|0}}f=b+(g+2)|0;d=h+2|0}else d=0;break}case 3:{o=k[y>>2]|0;switch(o|0){case 2:{d=k[y+4>>2]|0;if((d|0)==1){g=x+-2|0;if((x|0)<2){d=0;break b}h=0-e|0;i=1-e|0;j=e+1|0;m=g&-2;a=u+m|0;d=0;while(1){u=((l[f+1>>0]|0)<<1)+(l[f+i>>0]|0)+(l[f+j>>0]|0)|0;k[c+(d<<2)>>2]=((l[f>>0]|0)<<1)+(l[f+h>>0]|0)+(l[f+e>>0]|0);k[c+((d|1)<<2)>>2]=u;d=d+2|0;if((d|0)>(g|0))break;else f=f+2|0}f=b+(a+2)|0;d=m+2|0;break b}break}case -2:{d=k[y+4>>2]|0;if((d|0)==1){g=x+-2|0;if((x|0)<2){d=0;break b}h=0-e|0;i=1-e|0;j=e+1|0;m=g&-2;a=u+m|0;d=0;while(1){u=(l[f+i>>0]|0)-((l[f+1>>0]|0)<<1)+(l[f+j>>0]|0)|0;k[c+(d<<2)>>2]=(l[f+h>>0]|0)-((l[f>>0]|0)<<1)+(l[f+e>>0]|0);k[c+((d|1)<<2)>>2]=u;d=d+2|0;if((d|0)>(g|0))break;else f=f+2|0}f=b+(a+2)|0;d=m+2|0;break b}break}default:d=k[y+4>>2]|0}h=x+-2|0;if((x|0)<2)d=0;else{i=0-e|0;j=1-e|0;m=e+1|0;n=h&-2;g=u+n|0;a=0;while(1){t=aa(l[f>>0]|0,o)|0;t=(aa((l[f+e>>0]|0)+(l[f+i>>0]|0)|0,d)|0)+t|0;u=aa(l[f+1>>0]|0,o)|0;u=(aa((l[f+m>>0]|0)+(l[f+j>>0]|0)|0,d)|0)+u|0;k[c+(a<<2)>>2]=t;k[c+((a|1)<<2)>>2]=u;a=a+2|0;if((a|0)>(h|0))break;else f=f+2|0}f=b+(g+2)|0;d=n+2|0}break}case 5:{p=k[y>>2]|0;q=k[y+4>>2]|0;r=k[y+8>>2]|0;t=x+-2|0;d=(x|0)<2;if((p|0)==-2&(q|0)==0&(r|0)==1){if(d){d=0;break b}g=0-e<<1;h=e<<1;i=1-h|0;j=h|1;m=t&-2;a=u+m|0;d=0;while(1){s=aa(l[f>>0]|0,-2)|0;u=aa(l[f+1>>0]|0,-2)|0;u=u+(l[f+i>>0]|0)+(l[f+j>>0]|0)|0;k[c+(d<<2)>>2]=s+(l[f+g>>0]|0)+(l[f+h>>0]|0);k[c+((d|1)<<2)>>2]=u;d=d+2|0;if((d|0)>(t|0))break;else f=f+2|0}f=b+(a+2)|0;d=m+2|0;break b}else{if(d){d=0;break b}g=0-e|0;h=g<<1;i=e<<1;j=1-e|0;m=e+1|0;n=1-i|0;o=i|1;s=t&-2;a=u+s|0;d=0;while(1){z=aa(l[f>>0]|0,p)|0;z=(aa((l[f+e>>0]|0)+(l[f+g>>0]|0)|0,q)|0)+z|0;z=z+(aa((l[f+i>>0]|0)+(l[f+h>>0]|0)|0,r)|0)|0;u=aa(l[f+1>>0]|0,p)|0;u=(aa((l[f+m>>0]|0)+(l[f+j>>0]|0)|0,q)|0)+u|0;u=u+(aa((l[f+o>>0]|0)+(l[f+n>>0]|0)|0,r)|0)|0;k[c+(d<<2)>>2]=z;k[c+((d|1)<<2)>>2]=u;d=d+2|0;if((d|0)>(t|0))break;else f=f+2|0}f=b+(a+2)|0;d=s+2|0;break b}}default:d=0}while(0);if((d|0)>=(x|0))return;if((v|0)<2){while(1){z=aa(l[f>>0]|0,k[y>>2]|0)|0;k[c+(d<<2)>>2]=z;d=d+1|0;if((d|0)==(x|0))break;else f=f+1|0}return}while(1){a=e;g=1;h=aa(l[f>>0]|0,k[y>>2]|0)|0;while(1){h=(aa((l[f+(0-a)>>0]|0)+(l[f+a>>0]|0)|0,k[y+(g<<2)>>2]|0)|0)+h|0;if((g|0)>=(w|0))break;else{a=a+e|0;g=g+1|0}}k[c+(d<<2)>>2]=h;d=d+1|0;if((d|0)==(x|0))break;else f=f+1|0}return}function Dha(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;var j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+96|0;w=A;x=A+72|0;z=A+16|0;v=A+8|0;do if((k[d>>2]&2031616|0)==65536){m=k[d+4>>2]|0;k[z>>2]=k[m>>2];t=z+4|0;d=m+4|0;k[t>>2]=k[d>>2];s=z+8|0;k[s>>2]=k[m+8>>2];k[z+12>>2]=k[m+12>>2];k[z+16>>2]=k[m+16>>2];k[z+20>>2]=k[m+20>>2];k[z+24>>2]=k[m+24>>2];k[z+28>>2]=k[m+28>>2];k[z+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[z+36>>2]=j;l=z+40|0;k[l>>2]=s;s=z+48|0;q=z+44|0;k[q>>2]=s;k[z+52>>2]=0;k[s>>2]=0;if(j|0){s=j+12|0;k[s>>2]=(k[s>>2]|0)+1}if((k[d>>2]|0)<3){s=k[m+44>>2]|0;t=k[q>>2]|0;k[t>>2]=k[s>>2];k[t+4>>2]=k[s+4>>2];break}k[t>>2]=0;x1(z,k[d>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[q>>2]|0;d=0;do{k[n+(d<<2)>>2]=k[s+(d<<2)>>2];k[j+(d<<2)>>2]=k[l+(d<<2)>>2];d=d+1|0}while((d|0)<(k[t>>2]|0))}}else Q1(z,d,-1);while(0);n=b&7;q=c&7;if(!((((c^b)&4088|0)==0?(n|0)>=((q>>>0<4?4:q)|0):0)?(k[z>>2]&4095|0)==(n|0):0)){k[x>>2]=0;d=x+4|0;k[d>>2]=0;j=ZT(96)|0;k[j>>2]=1;s=j+4|0;k[x>>2]=s;k[d>>2]=89;i[j+93>>0]=0;m=250097;t=s+89|0;do{i[s>>0]=i[m>>0]|0;s=s+1|0;m=m+1|0}while((s|0)<(t|0));Y8(-215,x,250187,247404,3687);k[d>>2]=0;k[x>>2]=0;t=k[j>>2]|0;k[j>>2]=t+-1;if((t|0)==1)ggb(k[j+-4>>2]|0)}a:do if(!(f&3)){d=(q|0)==0;if((n|0)==4&d){k[x>>2]=h;k[x+4>>2]=(h|0)==0?0:1<<h+-1;while(1){d=fgb(84)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Eha(j,z,e,g,x);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=70952;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}l=(n|0)==5;if(l&d){while(1){d=fgb(76)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Fha(j,z,e,g);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=70972;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}j=(n|0)==6;if(j&d){while(1){d=fgb(80)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Gha(j,z,e,g);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=70992;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}d=(q|0)==2;if(l&d){while(1){d=fgb(76)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Hha(j,z,e,g);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71012;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(j&d){while(1){d=fgb(80)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Iha(j,z,e,g);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71032;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}d=(q|0)==3;if(l&d){while(1){d=fgb(76)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Jha(j,z,e,g);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71052;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(j&d){while(1){d=fgb(80)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Kha(j,z,e,g);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71072;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(l&(q|0)==5){while(1){d=fgb(76)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Lha(j,z,e,g);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71092;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(j&(q|0)==6){while(1){d=fgb(80)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Mha(j,z,e,g);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71112;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d)}else y=283}else{do if(((k[z+12>>2]|0)+(k[z+8>>2]|0)|0)==4){d=(n|0)==4;if(d&(q|0)==0){k[v>>2]=h;k[v+4>>2]=(h|0)==0?0:1<<h+-1;while(1){d=fgb(88)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}Nha(l,z,e,g,f,v);k[l>>2]=72016;if((k[l+4>>2]|0)!=3){k[x>>2]=0;d=x+4|0;k[d>>2]=0;j=ZT(24)|0;k[j>>2]=1;s=j+4|0;k[x>>2]=s;k[d>>2]=16;i[j+20>>0]=0;m=252771;t=s+16|0;do{i[s>>0]=i[m>>0]|0;s=s+1|0;m=m+1|0}while((s|0)<(t|0));Y8(-215,x,252788,247404,3447);k[d>>2]=0;k[x>>2]=0;e=k[j>>2]|0;k[j>>2]=e+-1;if((e|0)==1)ggb(k[j+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71132;k[d+8>>2]=l;k[a>>2]=d;k[a+4>>2]=l;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break a}if(!(d&(q|0)==3&(h|0)==0)){if(!((n|0)==5&(q|0)==5))break;while(1){d=fgb(80)|0;if(d|0){q=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){q=0;break}Qh[d&7]()}d=q+8|0;k[d>>2]=-1;n=q+4|0;k[n>>2]=-1;k[q>>2]=71896;j=q+12|0;k[j>>2]=1124007936;l=q+20|0;m=q+52|0;s=q+16|0;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[m>>2]=l;w=q+60|0;k[q+56>>2]=w;k[q+64>>2]=0;k[w>>2]=0;if(!(k[z>>2]&16384)){w=x+4|0;c=w+4|0;k[c>>2]=0;k[c+4>>2]=0;k[x>>2]=33619968;k[w>>2]=j;mY(z,x)}else KG(j,z)|0;k[d>>2]=e;w=k[l>>2]|0;e=k[q+24>>2]|0;k[n>>2]=w+-1+e;o[q+72>>2]=g;if(!((k[j>>2]&4095|0)==5?(w|0)==1|(e|0)==1:0)){k[x>>2]=0;d=x+4|0;k[d>>2]=0;j=ZT(84)|0;k[j>>2]=1;s=j+4|0;k[x>>2]=s;k[d>>2]=77;i[j+81>>0]=0;m=251448;t=s+77|0;do{i[s>>0]=i[m>>0]|0;s=s+1|0;m=m+1|0}while((s|0)<(t|0));Y8(-215,x,251526,247404,3278);k[d>>2]=0;k[x>>2]=0;e=k[j>>2]|0;k[j>>2]=e+-1;if((e|0)==1)ggb(k[j+-4>>2]|0)}k[q>>2]=71920;k[q+76>>2]=f;e=k[n>>2]|0;k[q>>2]=71872;if((e|0)!=3){k[x>>2]=0;d=x+4|0;k[d>>2]=0;j=ZT(24)|0;k[j>>2]=1;s=j+4|0;k[x>>2]=s;k[d>>2]=16;i[j+20>>0]=0;m=252771;t=s+16|0;do{i[s>>0]=i[m>>0]|0;s=s+1|0;m=m+1|0}while((s|0)<(t|0));Y8(-215,x,252788,247404,3447);k[d>>2]=0;k[x>>2]=0;e=k[j>>2]|0;k[j>>2]=e+-1;if((e|0)==1)ggb(k[j+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71172;k[d+8>>2]=q;k[a>>2]=d;k[a+4>>2]=q;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break a;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break a}while(1){d=fgb(80)|0;if(d|0){q=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){q=0;break}Qh[d&7]()}d=q+8|0;k[d>>2]=-1;n=q+4|0;k[n>>2]=-1;k[q>>2]=71968;m=q+12|0;k[m>>2]=1124007936;j=q+20|0;l=q+52|0;s=q+16|0;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[l>>2]=j;w=q+60|0;k[q+56>>2]=w;k[q+64>>2]=0;k[w>>2]=0;if(!(k[z>>2]&16384)){w=x+4|0;c=w+4|0;k[c>>2]=0;k[c+4>>2]=0;k[x>>2]=33619968;k[w>>2]=m;mY(z,x)}else KG(m,z)|0;k[d>>2]=e;j=k[j>>2]|0;l=k[q+24>>2]|0;k[n>>2]=j+-1+l;p[u>>3]=g;d=k[u+4>>2]|0;e=d&2146435072;if(!(e>>>0>1126170624|(e|0)==1126170624&0>0)){d=(d|0)<0;g=d?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=d?-0.0:0.0}k[q+72>>2]=~~g;if(!((k[m>>2]&4095|0)==4?(j|0)==1|(l|0)==1:0)){k[x>>2]=0;d=x+4|0;k[d>>2]=0;j=ZT(84)|0;k[j>>2]=1;s=j+4|0;k[x>>2]=s;k[d>>2]=77;i[j+81>>0]=0;m=251448;t=s+77|0;do{i[s>>0]=i[m>>0]|0;s=s+1|0;m=m+1|0}while((s|0)<(t|0));Y8(-215,x,251526,247404,3278);k[d>>2]=0;k[x>>2]=0;e=k[j>>2]|0;k[j>>2]=e+-1;if((e|0)==1)ggb(k[j+-4>>2]|0)}k[q>>2]=71992;k[q+76>>2]=f;e=k[n>>2]|0;k[q>>2]=71944;if((e|0)!=3){k[x>>2]=0;d=x+4|0;k[d>>2]=0;j=ZT(24)|0;k[j>>2]=1;s=j+4|0;k[x>>2]=s;k[d>>2]=16;i[j+20>>0]=0;m=252771;t=s+16|0;do{i[s>>0]=i[m>>0]|0;s=s+1|0;m=m+1|0}while((s|0)<(t|0));Y8(-215,x,252788,247404,3447);k[d>>2]=0;k[x>>2]=0;e=k[j>>2]|0;k[j>>2]=e+-1;if((e|0)==1)ggb(k[j+-4>>2]|0)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71152;k[d+8>>2]=q;k[a>>2]=d;k[a+4>>2]=q;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break a;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break a}while(0);d=(q|0)==0;m=(n|0)==4;if(m&d){k[x>>2]=h;k[x+4>>2]=(h|0)==0?0:1<<h+-1;while(1){d=fgb(88)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Nha(j,z,e,g,f,x);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71192;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}l=(n|0)==5;if(l&d){while(1){d=fgb(80)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Fha(j,z,e,g);k[j>>2]=71776;k[j+76>>2]=f;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71212;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}j=(n|0)==6;if(j&d){while(1){d=fgb(88)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Gha(j,z,e,g);k[j>>2]=71728;k[j+80>>2]=f;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71232;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}d=(q|0)==2;if(l&d){while(1){d=fgb(80)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Hha(j,z,e,g);k[j>>2]=71680;k[j+76>>2]=f;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71252;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(j&d){while(1){d=fgb(88)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Iha(j,z,e,g);k[j>>2]=71632;k[j+80>>2]=f;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71272;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}d=(q|0)==3;if(m&d){while(1){d=fgb(80)|0;if(d|0){q=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){q=0;break}Qh[d&7]()}d=q+8|0;k[d>>2]=-1;m=q+4|0;k[m>>2]=-1;k[q>>2]=71608;n=q+12|0;k[n>>2]=1124007936;j=q+20|0;l=q+52|0;s=q+16|0;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[l>>2]=j;w=q+60|0;k[q+56>>2]=w;k[q+64>>2]=0;k[w>>2]=0;if(!(k[z>>2]&16384)){w=x+4|0;c=w+4|0;k[c>>2]=0;k[c+4>>2]=0;k[x>>2]=33619968;k[w>>2]=n;mY(z,x)}else KG(n,z)|0;k[d>>2]=e;j=k[j>>2]|0;l=k[q+24>>2]|0;k[m>>2]=j+-1+l;p[u>>3]=g;d=k[u+4>>2]|0;e=d&2146435072;if(!(e>>>0>1126170624|(e|0)==1126170624&0>0)){d=(d|0)<0;g=d?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=d?-0.0:0.0}k[q+72>>2]=~~g;if(!((k[n>>2]&4095|0)==4?(j|0)==1|(l|0)==1:0)){k[x>>2]=0;d=x+4|0;k[d>>2]=0;j=ZT(84)|0;k[j>>2]=1;s=j+4|0;k[x>>2]=s;k[d>>2]=77;i[j+81>>0]=0;m=251448;t=s+77|0;do{i[s>>0]=i[m>>0]|0;s=s+1|0;m=m+1|0}while((s|0)<(t|0));Y8(-215,x,251526,247404,3278);k[d>>2]=0;k[x>>2]=0;e=k[j>>2]|0;k[j>>2]=e+-1;if((e|0)==1)ggb(k[j+-4>>2]|0)}k[q>>2]=71584;k[q+76>>2]=f;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71292;k[d+8>>2]=q;k[a>>2]=d;k[a+4>>2]=q;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(l&d){while(1){d=fgb(80)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Jha(j,z,e,g);k[j>>2]=71536;k[j+76>>2]=f;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71312;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(j&d){while(1){d=fgb(88)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Kha(j,z,e,g);k[j>>2]=71488;k[j+80>>2]=f;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71332;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(l&(q|0)==5){while(1){d=fgb(80)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Lha(j,z,e,g);k[j>>2]=71440;k[j+76>>2]=f;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71352;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(j&(q|0)==6){while(1){d=fgb(88)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}Mha(j,z,e,g);k[j>>2]=71392;k[j+80>>2]=f;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d+4|0;k[e>>2]=1;k[d>>2]=71372;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;k[e>>2]=(k[e>>2]|0)+1;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d)}else y=283}while(0);if((y|0)==283){k[w>>2]=b;k[w+4>>2]=c;$8(x,250209,w);Y8(-213,x,250187,247404,3768);d=k[x>>2]|0;k[x+4>>2]=0;k[x>>2]=0;if(d|0?(e=d+-4|0,y=k[e>>2]|0,k[e>>2]=y+-1,(y|0)==1):0)ggb(k[d+-8>>2]|0);k[a>>2]=0;k[a+4>>2]=0}l=z+36|0;d=k[l>>2]|0;if(d|0?(y=d+12|0,a=k[y>>2]|0,k[y>>2]=a+-1,(a|0)==1):0){j=k[l>>2]|0;if(j|0){d=k[j+4>>2]|0;if(!d){d=k[z+32>>2]|0;if(!d){d=B1()|0;j=k[l>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,j)}k[l>>2]=0}k[l>>2]=0;a=z+16|0;j=z+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[j>>2]|0)>0){l=k[z+40>>2]|0;d=0;do{k[l+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[z+44>>2]|0;if((d|0)==(z+48|0)|(d|0)==0){r=A;return}ggb(k[d+-4>>2]|0);r=A;return}function Eha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0;q=r;r=r+16|0;o=q;h=a+8|0;k[h>>2]=-1;j=a+4|0;k[j>>2]=-1;k[a>>2]=71848;n=a+12|0;k[n>>2]=1124007936;g=a+20|0;f=a+52|0;l=a+16|0;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[f>>2]=g;m=a+60|0;k[a+56>>2]=m;l=a+68|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if(!(k[b>>2]&16384)){m=o+4|0;f=m+4|0;k[f>>2]=0;k[f+4>>2]=0;k[o>>2]=33619968;k[m>>2]=n;mY(b,o)}else KG(n,b)|0;k[h>>2]=c;b=k[g>>2]|0;g=k[a+24>>2]|0;k[j>>2]=b+-1+g;p[u>>3]=d;f=k[u+4>>2]|0;m=f&2146435072;if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){f=(f|0)<0;d=f?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=f?-0.0:0.0}k[a+80>>2]=~~d;m=e;a=k[m+4>>2]|0;e=l;k[e>>2]=k[m>>2];k[e+4>>2]=a;if((k[n>>2]&4095|0)==4?(b|0)==1|(g|0)==1:0){r=q;return}k[o>>2]=0;f=o+4|0;k[f>>2]=0;b=ZT(84)|0;k[b>>2]=1;l=b+4|0;k[o>>2]=l;k[f>>2]=77;i[b+81>>0]=0;g=251448;m=l+77|0;do{i[l>>0]=i[g>>0]|0;l=l+1|0;g=g+1|0}while((l|0)<(m|0));Y8(-215,o,251526,247404,3278);k[f>>2]=0;k[o>>2]=0;o=k[b>>2]|0;k[b>>2]=o+-1;if((o|0)==1)ggb(k[b+-4>>2]|0);r=q;return}function Fha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0;n=r;r=r+16|0;l=n;f=a+8|0;k[f>>2]=-1;g=a+4|0;k[g>>2]=-1;k[a>>2]=71800;h=a+12|0;k[h>>2]=1124007936;j=a+20|0;e=a+52|0;m=a+16|0;p=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(p|0));k[e>>2]=j;p=a+60|0;k[a+56>>2]=p;k[a+64>>2]=0;k[p>>2]=0;if(!(k[b>>2]&16384)){p=l+4|0;m=p+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=33619968;k[p>>2]=h;mY(b,l)}else KG(h,b)|0;k[f>>2]=c;m=k[j>>2]|0;p=k[a+24>>2]|0;k[g>>2]=m+-1+p;o[a+72>>2]=d;if((k[h>>2]&4095|0)==5?(m|0)==1|(p|0)==1:0){r=n;return}k[l>>2]=0;a=l+4|0;k[a>>2]=0;b=ZT(84)|0;k[b>>2]=1;m=b+4|0;k[l>>2]=m;k[a>>2]=77;i[b+81>>0]=0;e=251448;p=m+77|0;do{i[m>>0]=i[e>>0]|0;m=m+1|0;e=e+1|0}while((m|0)<(p|0));Y8(-215,l,251526,247404,3278);k[a>>2]=0;k[l>>2]=0;p=k[b>>2]|0;k[b>>2]=p+-1;if((p|0)==1)ggb(k[b+-4>>2]|0);r=n;return}function Gha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;n=r;r=r+16|0;l=n;f=a+8|0;k[f>>2]=-1;g=a+4|0;k[g>>2]=-1;k[a>>2]=71752;h=a+12|0;k[h>>2]=1124007936;j=a+20|0;e=a+52|0;m=a+16|0;o=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(o|0));k[e>>2]=j;o=a+60|0;k[a+56>>2]=o;k[a+64>>2]=0;k[o>>2]=0;if(!(k[b>>2]&16384)){o=l+4|0;m=o+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=33619968;k[o>>2]=h;mY(b,l)}else KG(h,b)|0;k[f>>2]=c;m=k[j>>2]|0;o=k[a+24>>2]|0;k[g>>2]=m+-1+o;p[a+72>>3]=d;if((k[h>>2]&4095|0)==6?(m|0)==1|(o|0)==1:0){r=n;return}k[l>>2]=0;a=l+4|0;k[a>>2]=0;b=ZT(84)|0;k[b>>2]=1;m=b+4|0;k[l>>2]=m;k[a>>2]=77;i[b+81>>0]=0;e=251448;o=m+77|0;do{i[m>>0]=i[e>>0]|0;m=m+1|0;e=e+1|0}while((m|0)<(o|0));Y8(-215,l,251526,247404,3278);k[a>>2]=0;k[l>>2]=0;o=k[b>>2]|0;k[b>>2]=o+-1;if((o|0)==1)ggb(k[b+-4>>2]|0);r=n;return}function Hha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0;n=r;r=r+16|0;l=n;f=a+8|0;k[f>>2]=-1;g=a+4|0;k[g>>2]=-1;k[a>>2]=71704;h=a+12|0;k[h>>2]=1124007936;j=a+20|0;e=a+52|0;m=a+16|0;p=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(p|0));k[e>>2]=j;p=a+60|0;k[a+56>>2]=p;k[a+64>>2]=0;k[p>>2]=0;if(!(k[b>>2]&16384)){p=l+4|0;m=p+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=33619968;k[p>>2]=h;mY(b,l)}else KG(h,b)|0;k[f>>2]=c;m=k[j>>2]|0;p=k[a+24>>2]|0;k[g>>2]=m+-1+p;o[a+72>>2]=d;if((k[h>>2]&4095|0)==5?(m|0)==1|(p|0)==1:0){r=n;return}k[l>>2]=0;a=l+4|0;k[a>>2]=0;b=ZT(84)|0;k[b>>2]=1;m=b+4|0;k[l>>2]=m;k[a>>2]=77;i[b+81>>0]=0;e=251448;p=m+77|0;do{i[m>>0]=i[e>>0]|0;m=m+1|0;e=e+1|0}while((m|0)<(p|0));Y8(-215,l,251526,247404,3278);k[a>>2]=0;k[l>>2]=0;p=k[b>>2]|0;k[b>>2]=p+-1;if((p|0)==1)ggb(k[b+-4>>2]|0);r=n;return}function Iha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;n=r;r=r+16|0;l=n;f=a+8|0;k[f>>2]=-1;g=a+4|0;k[g>>2]=-1;k[a>>2]=71656;h=a+12|0;k[h>>2]=1124007936;j=a+20|0;e=a+52|0;m=a+16|0;o=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(o|0));k[e>>2]=j;o=a+60|0;k[a+56>>2]=o;k[a+64>>2]=0;k[o>>2]=0;if(!(k[b>>2]&16384)){o=l+4|0;m=o+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=33619968;k[o>>2]=h;mY(b,l)}else KG(h,b)|0;k[f>>2]=c;m=k[j>>2]|0;o=k[a+24>>2]|0;k[g>>2]=m+-1+o;p[a+72>>3]=d;if((k[h>>2]&4095|0)==6?(m|0)==1|(o|0)==1:0){r=n;return}k[l>>2]=0;a=l+4|0;k[a>>2]=0;b=ZT(84)|0;k[b>>2]=1;m=b+4|0;k[l>>2]=m;k[a>>2]=77;i[b+81>>0]=0;e=251448;o=m+77|0;do{i[m>>0]=i[e>>0]|0;m=m+1|0;e=e+1|0}while((m|0)<(o|0));Y8(-215,l,251526,247404,3278);k[a>>2]=0;k[l>>2]=0;o=k[b>>2]|0;k[b>>2]=o+-1;if((o|0)==1)ggb(k[b+-4>>2]|0);r=n;return}function Jha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0;n=r;r=r+16|0;l=n;f=a+8|0;k[f>>2]=-1;g=a+4|0;k[g>>2]=-1;k[a>>2]=71560;h=a+12|0;k[h>>2]=1124007936;j=a+20|0;e=a+52|0;m=a+16|0;p=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(p|0));k[e>>2]=j;p=a+60|0;k[a+56>>2]=p;k[a+64>>2]=0;k[p>>2]=0;if(!(k[b>>2]&16384)){p=l+4|0;m=p+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=33619968;k[p>>2]=h;mY(b,l)}else KG(h,b)|0;k[f>>2]=c;m=k[j>>2]|0;p=k[a+24>>2]|0;k[g>>2]=m+-1+p;o[a+72>>2]=d;if((k[h>>2]&4095|0)==5?(m|0)==1|(p|0)==1:0){r=n;return}k[l>>2]=0;a=l+4|0;k[a>>2]=0;b=ZT(84)|0;k[b>>2]=1;m=b+4|0;k[l>>2]=m;k[a>>2]=77;i[b+81>>0]=0;e=251448;p=m+77|0;do{i[m>>0]=i[e>>0]|0;m=m+1|0;e=e+1|0}while((m|0)<(p|0));Y8(-215,l,251526,247404,3278);k[a>>2]=0;k[l>>2]=0;p=k[b>>2]|0;k[b>>2]=p+-1;if((p|0)==1)ggb(k[b+-4>>2]|0);r=n;return}function Kha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;n=r;r=r+16|0;l=n;f=a+8|0;k[f>>2]=-1;g=a+4|0;k[g>>2]=-1;k[a>>2]=71512;h=a+12|0;k[h>>2]=1124007936;j=a+20|0;e=a+52|0;m=a+16|0;o=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(o|0));k[e>>2]=j;o=a+60|0;k[a+56>>2]=o;k[a+64>>2]=0;k[o>>2]=0;if(!(k[b>>2]&16384)){o=l+4|0;m=o+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=33619968;k[o>>2]=h;mY(b,l)}else KG(h,b)|0;k[f>>2]=c;m=k[j>>2]|0;o=k[a+24>>2]|0;k[g>>2]=m+-1+o;p[a+72>>3]=d;if((k[h>>2]&4095|0)==6?(m|0)==1|(o|0)==1:0){r=n;return}k[l>>2]=0;a=l+4|0;k[a>>2]=0;b=ZT(84)|0;k[b>>2]=1;m=b+4|0;k[l>>2]=m;k[a>>2]=77;i[b+81>>0]=0;e=251448;o=m+77|0;do{i[m>>0]=i[e>>0]|0;m=m+1|0;e=e+1|0}while((m|0)<(o|0));Y8(-215,l,251526,247404,3278);k[a>>2]=0;k[l>>2]=0;o=k[b>>2]|0;k[b>>2]=o+-1;if((o|0)==1)ggb(k[b+-4>>2]|0);r=n;return}function Lha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0;n=r;r=r+16|0;l=n;f=a+8|0;k[f>>2]=-1;g=a+4|0;k[g>>2]=-1;k[a>>2]=71464;h=a+12|0;k[h>>2]=1124007936;j=a+20|0;e=a+52|0;m=a+16|0;p=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(p|0));k[e>>2]=j;p=a+60|0;k[a+56>>2]=p;k[a+64>>2]=0;k[p>>2]=0;if(!(k[b>>2]&16384)){p=l+4|0;m=p+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=33619968;k[p>>2]=h;mY(b,l)}else KG(h,b)|0;k[f>>2]=c;m=k[j>>2]|0;p=k[a+24>>2]|0;k[g>>2]=m+-1+p;o[a+72>>2]=d;if((k[h>>2]&4095|0)==5?(m|0)==1|(p|0)==1:0){r=n;return}k[l>>2]=0;a=l+4|0;k[a>>2]=0;b=ZT(84)|0;k[b>>2]=1;m=b+4|0;k[l>>2]=m;k[a>>2]=77;i[b+81>>0]=0;e=251448;p=m+77|0;do{i[m>>0]=i[e>>0]|0;m=m+1|0;e=e+1|0}while((m|0)<(p|0));Y8(-215,l,251526,247404,3278);k[a>>2]=0;k[l>>2]=0;p=k[b>>2]|0;k[b>>2]=p+-1;if((p|0)==1)ggb(k[b+-4>>2]|0);r=n;return}function Mha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;n=r;r=r+16|0;l=n;f=a+8|0;k[f>>2]=-1;g=a+4|0;k[g>>2]=-1;k[a>>2]=71416;h=a+12|0;k[h>>2]=1124007936;j=a+20|0;e=a+52|0;m=a+16|0;o=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(o|0));k[e>>2]=j;o=a+60|0;k[a+56>>2]=o;k[a+64>>2]=0;k[o>>2]=0;if(!(k[b>>2]&16384)){o=l+4|0;m=o+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=33619968;k[o>>2]=h;mY(b,l)}else KG(h,b)|0;k[f>>2]=c;m=k[j>>2]|0;o=k[a+24>>2]|0;k[g>>2]=m+-1+o;p[a+72>>3]=d;if((k[h>>2]&4095|0)==6?(m|0)==1|(o|0)==1:0){r=n;return}k[l>>2]=0;a=l+4|0;k[a>>2]=0;b=ZT(84)|0;k[b>>2]=1;m=b+4|0;k[l>>2]=m;k[a>>2]=77;i[b+81>>0]=0;e=251448;o=m+77|0;do{i[m>>0]=i[e>>0]|0;m=m+1|0;e=e+1|0}while((m|0)<(o|0));Y8(-215,l,251526,247404,3278);k[a>>2]=0;k[l>>2]=0;o=k[b>>2]|0;k[b>>2]=o+-1;if((o|0)==1)ggb(k[b+-4>>2]|0);r=n;return}function Nha(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;var g=0,h=0;h=r;r=r+16|0;g=h;Eha(a,b,c,d,f);k[a>>2]=71824;k[a+84>>2]=e;if(e&3|0){r=h;return}k[g>>2]=0;a=g+4|0;k[a>>2]=0;b=ZT(72)|0;k[b>>2]=1;c=b+4|0;k[g>>2]=c;k[a>>2]=64;i[b+68>>0]=0;e=250394;f=c+64|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));Y8(-215,g,250459,247404,3341);k[a>>2]=0;k[g>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0);r=h;return}function Oha(a){a=a|0;ggb(a);return}function Pha(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Qha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71416;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Rha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71416;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Sha(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0,j=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0;t=k[a+28>>2]|0;u=+p[a+72>>3];n=k[a+4>>2]|0;if(!e)return;o=f+-4|0;q=(f|0)<4;r=(n|0)>1;s=f&-4;while(1){e=e+-1|0;a:do if(q)a=0;else{i=k[b>>2]|0;if(r)h=0;else{a=0;while(1){g=+p[t>>3];h=i+(a<<3)|0;j=u+g*+p[h+8>>3];l=u+g*+p[h+16>>3];m=u+g*+p[h+24>>3];p[c+(a<<3)>>3]=u+g*+p[h>>3];p[c+((a|1)<<3)>>3]=j;p[c+((a|2)<<3)>>3]=l;p[c+((a|3)<<3)>>3]=m;a=a+4|0;if((a|0)>(o|0)){a=s;break a}}}do{m=+p[t>>3];a=i+(h<<3)|0;g=u+m*+p[a+24>>3];j=u+m*+p[a+16>>3];l=u+m*+p[a+8>>3];m=u+m*+p[a>>3];a=1;do{v=(k[b+(a<<2)>>2]|0)+(h<<3)|0;w=+p[t+(a<<3)>>3];m=m+w*+p[v>>3];l=l+w*+p[v+8>>3];j=j+w*+p[v+16>>3];g=g+w*+p[v+24>>3];a=a+1|0}while((a|0)!=(n|0));p[c+(h<<3)>>3]=m;p[c+((h|1)<<3)>>3]=l;p[c+((h|2)<<3)>>3]=j;p[c+((h|3)<<3)>>3]=g;h=h+4|0}while((h|0)<=(o|0));a=s}while(0);b:do if((a|0)<(f|0)){i=k[b>>2]|0;if(!r)while(1){p[c+(a<<3)>>3]=u+ +p[t>>3]*+p[i+(a<<3)>>3];a=a+1|0;if((a|0)==(f|0))break b}do{g=u+ +p[t>>3]*+p[i+(a<<3)>>3];h=1;do{g=g+ +p[t+(h<<3)>>3]*+p[(k[b+(h<<2)>>2]|0)+(a<<3)>>3];h=h+1|0}while((h|0)!=(n|0));p[c+(a<<3)>>3]=g;a=a+1|0}while((a|0)!=(f|0))}while(0);if(!e)break;else{b=b+4|0;c=c+d|0}}return}function Tha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71416;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Uha(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0;h=k[a+4>>2]|0;u=(h|0)/2|0;s=(k[a+28>>2]|0)+(u<<3)|0;t=+p[a+72>>3];m=b+(u<<2)|0;n=e+-1|0;b=(e|0)==0;if(!(k[a+80>>2]&1)){if(b)return;o=f+-4|0;q=(f|0)<4;a=(h|0)<2;h=f&-4;while(1){a:do if(q)b=0;else{if(a){b=0;while(1){p[c+(b<<3)>>3]=t;p[c+((b|1)<<3)>>3]=t;p[c+((b|2)<<3)>>3]=t;p[c+((b|3)<<3)>>3]=t;b=b+4|0;if((b|0)>(o|0)){b=h;break a}}}else e=0;do{g=t;i=t;j=t;l=t;b=1;while(1){v=(k[m+(b<<2)>>2]|0)+(e<<3)|0;r=(k[m+(0-b<<2)>>2]|0)+(e<<3)|0;w=+p[s+(b<<3)>>3];l=l+w*(+p[v>>3]-+p[r>>3]);j=j+w*(+p[v+8>>3]-+p[r+8>>3]);i=i+w*(+p[v+16>>3]-+p[r+16>>3]);g=g+w*(+p[v+24>>3]-+p[r+24>>3]);if((b|0)>=(u|0))break;else b=b+1|0}p[c+(e<<3)>>3]=l;p[c+((e|1)<<3)>>3]=j;p[c+((e|2)<<3)>>3]=i;p[c+((e|3)<<3)>>3]=g;e=e+4|0}while((e|0)<=(o|0));b=h}while(0);b:do if((b|0)<(f|0)){if(a)while(1){p[c+(b<<3)>>3]=t;b=b+1|0;if((b|0)==(f|0))break b}do{g=t;e=1;while(1){g=g+ +p[s+(e<<3)>>3]*(+p[(k[m+(e<<2)>>2]|0)+(b<<3)>>3]-+p[(k[m+(0-e<<2)>>2]|0)+(b<<3)>>3]);if((e|0)>=(u|0))break;else e=e+1|0}p[c+(b<<3)>>3]=g;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!n)break;else{c=c+d|0;m=m+4|0;n=n+-1|0}}return}else{if(b)return;q=f+-4|0;r=(f|0)<4;h=(h|0)<2;o=f&-4;while(1){c:do if(r)b=0;else{a=k[m>>2]|0;if(h){b=0;while(1){i=+p[s>>3];v=a+(b<<3)|0;j=t+i*+p[v+8>>3];l=t+i*+p[v+16>>3];w=t+i*+p[v+24>>3];p[c+(b<<3)>>3]=t+i*+p[v>>3];p[c+((b|1)<<3)>>3]=j;p[c+((b|2)<<3)>>3]=l;p[c+((b|3)<<3)>>3]=w;b=b+4|0;if((b|0)>(q|0)){b=o;break c}}}else b=0;do{l=+p[s>>3];e=a+(b<<3)|0;g=t+l*+p[e+24>>3];i=t+l*+p[e+16>>3];j=t+l*+p[e+8>>3];l=t+l*+p[e>>3];e=1;while(1){x=(k[m+(e<<2)>>2]|0)+(b<<3)|0;v=(k[m+(0-e<<2)>>2]|0)+(b<<3)|0;w=+p[s+(e<<3)>>3];l=l+w*(+p[x>>3]+ +p[v>>3]);j=j+w*(+p[x+8>>3]+ +p[v+8>>3]);i=i+w*(+p[x+16>>3]+ +p[v+16>>3]);g=g+w*(+p[x+24>>3]+ +p[v+24>>3]);if((e|0)>=(u|0))break;else e=e+1|0}p[c+(b<<3)>>3]=l;p[c+((b|1)<<3)>>3]=j;p[c+((b|2)<<3)>>3]=i;p[c+((b|3)<<3)>>3]=g;b=b+4|0}while((b|0)<=(q|0));b=o}while(0);d:do if((b|0)<(f|0)){a=k[m>>2]|0;if(h)while(1){p[c+(b<<3)>>3]=t+ +p[s>>3]*+p[a+(b<<3)>>3];b=b+1|0;if((b|0)==(f|0))break d}do{g=t+ +p[s>>3]*+p[a+(b<<3)>>3];e=1;while(1){g=g+ +p[s+(e<<3)>>3]*(+p[(k[m+(e<<2)>>2]|0)+(b<<3)>>3]+ +p[(k[m+(0-e<<2)>>2]|0)+(b<<3)>>3]);if((e|0)>=(u|0))break;else e=e+1|0}p[c+(b<<3)>>3]=g;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!n)break;else{m=m+4|0;c=c+d|0;n=n+-1|0}}return}}function Vha(a){a=a|0;ggb(a);return}function Wha(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Xha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71464;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Yha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71464;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Zha(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0,j=0.0,l=0.0,m=0.0,n=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0;t=k[a+28>>2]|0;u=+o[a+72>>2];n=k[a+4>>2]|0;if(!e)return;p=f+-4|0;q=(f|0)<4;r=(n|0)>1;s=f&-4;while(1){e=e+-1|0;a:do if(q)a=0;else{i=k[b>>2]|0;if(r)h=0;else{a=0;while(1){g=+o[t>>2];h=i+(a<<2)|0;j=u+g*+o[h+4>>2];l=u+g*+o[h+8>>2];m=u+g*+o[h+12>>2];o[c+(a<<2)>>2]=u+g*+o[h>>2];o[c+((a|1)<<2)>>2]=j;o[c+((a|2)<<2)>>2]=l;o[c+((a|3)<<2)>>2]=m;a=a+4|0;if((a|0)>(p|0)){a=s;break a}}}do{m=+o[t>>2];a=i+(h<<2)|0;g=u+m*+o[a+12>>2];j=u+m*+o[a+8>>2];l=u+m*+o[a+4>>2];m=u+m*+o[a>>2];a=1;do{v=(k[b+(a<<2)>>2]|0)+(h<<2)|0;w=+o[t+(a<<2)>>2];m=m+w*+o[v>>2];l=l+w*+o[v+4>>2];j=j+w*+o[v+8>>2];g=g+w*+o[v+12>>2];a=a+1|0}while((a|0)!=(n|0));o[c+(h<<2)>>2]=m;o[c+((h|1)<<2)>>2]=l;o[c+((h|2)<<2)>>2]=j;o[c+((h|3)<<2)>>2]=g;h=h+4|0}while((h|0)<=(p|0));a=s}while(0);b:do if((a|0)<(f|0)){i=k[b>>2]|0;if(!r)while(1){o[c+(a<<2)>>2]=u+ +o[t>>2]*+o[i+(a<<2)>>2];a=a+1|0;if((a|0)==(f|0))break b}do{g=u+ +o[t>>2]*+o[i+(a<<2)>>2];h=1;do{g=g+ +o[t+(h<<2)>>2]*+o[(k[b+(h<<2)>>2]|0)+(a<<2)>>2];h=h+1|0}while((h|0)!=(n|0));o[c+(a<<2)>>2]=g;a=a+1|0}while((a|0)!=(f|0))}while(0);if(!e)break;else{b=b+4|0;c=c+d|0}}return}function _ha(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71464;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function $ha(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0.0,l=0.0,m=0,n=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0;h=k[a+4>>2]|0;u=(h|0)/2|0;s=(k[a+28>>2]|0)+(u<<2)|0;t=+o[a+72>>2];m=b+(u<<2)|0;n=e+-1|0;b=(e|0)==0;if(!(k[a+76>>2]&1)){if(b)return;p=f+-4|0;q=(f|0)<4;a=(h|0)<2;h=f&-4;while(1){a:do if(q)b=0;else{if(a){b=0;while(1){o[c+(b<<2)>>2]=t;o[c+((b|1)<<2)>>2]=t;o[c+((b|2)<<2)>>2]=t;o[c+((b|3)<<2)>>2]=t;b=b+4|0;if((b|0)>(p|0)){b=h;break a}}}else e=0;do{g=t;i=t;j=t;l=t;b=1;while(1){v=(k[m+(b<<2)>>2]|0)+(e<<2)|0;r=(k[m+(0-b<<2)>>2]|0)+(e<<2)|0;w=+o[s+(b<<2)>>2];l=l+w*(+o[v>>2]-+o[r>>2]);j=j+w*(+o[v+4>>2]-+o[r+4>>2]);i=i+w*(+o[v+8>>2]-+o[r+8>>2]);g=g+w*(+o[v+12>>2]-+o[r+12>>2]);if((b|0)>=(u|0))break;else b=b+1|0}o[c+(e<<2)>>2]=l;o[c+((e|1)<<2)>>2]=j;o[c+((e|2)<<2)>>2]=i;o[c+((e|3)<<2)>>2]=g;e=e+4|0}while((e|0)<=(p|0));b=h}while(0);b:do if((b|0)<(f|0)){if(a)while(1){o[c+(b<<2)>>2]=t;b=b+1|0;if((b|0)==(f|0))break b}do{g=t;e=1;while(1){g=g+ +o[s+(e<<2)>>2]*(+o[(k[m+(e<<2)>>2]|0)+(b<<2)>>2]-+o[(k[m+(0-e<<2)>>2]|0)+(b<<2)>>2]);if((e|0)>=(u|0))break;else e=e+1|0}o[c+(b<<2)>>2]=g;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!n)break;else{c=c+d|0;m=m+4|0;n=n+-1|0}}return}else{if(b)return;q=f+-4|0;r=(f|0)<4;h=(h|0)<2;p=f&-4;while(1){c:do if(r)b=0;else{a=k[m>>2]|0;if(h){b=0;while(1){i=+o[s>>2];v=a+(b<<2)|0;j=t+i*+o[v+4>>2];l=t+i*+o[v+8>>2];w=t+i*+o[v+12>>2];o[c+(b<<2)>>2]=t+i*+o[v>>2];o[c+((b|1)<<2)>>2]=j;o[c+((b|2)<<2)>>2]=l;o[c+((b|3)<<2)>>2]=w;b=b+4|0;if((b|0)>(q|0)){b=p;break c}}}else b=0;do{l=+o[s>>2];e=a+(b<<2)|0;g=t+l*+o[e+12>>2];i=t+l*+o[e+8>>2];j=t+l*+o[e+4>>2];l=t+l*+o[e>>2];e=1;while(1){x=(k[m+(e<<2)>>2]|0)+(b<<2)|0;v=(k[m+(0-e<<2)>>2]|0)+(b<<2)|0;w=+o[s+(e<<2)>>2];l=l+w*(+o[x>>2]+ +o[v>>2]);j=j+w*(+o[x+4>>2]+ +o[v+4>>2]);i=i+w*(+o[x+8>>2]+ +o[v+8>>2]);g=g+w*(+o[x+12>>2]+ +o[v+12>>2]);if((e|0)>=(u|0))break;else e=e+1|0}o[c+(b<<2)>>2]=l;o[c+((b|1)<<2)>>2]=j;o[c+((b|2)<<2)>>2]=i;o[c+((b|3)<<2)>>2]=g;b=b+4|0}while((b|0)<=(q|0));b=p}while(0);d:do if((b|0)<(f|0)){a=k[m>>2]|0;if(h)while(1){o[c+(b<<2)>>2]=t+ +o[s>>2]*+o[a+(b<<2)>>2];b=b+1|0;if((b|0)==(f|0))break d}do{g=t+ +o[s>>2]*+o[a+(b<<2)>>2];e=1;while(1){g=g+ +o[s+(e<<2)>>2]*(+o[(k[m+(e<<2)>>2]|0)+(b<<2)>>2]+ +o[(k[m+(0-e<<2)>>2]|0)+(b<<2)>>2]);if((e|0)>=(u|0))break;else e=e+1|0}o[c+(b<<2)>>2]=g;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!n)break;else{m=m+4|0;c=c+d|0;n=n+-1|0}}return}}function aia(a){a=a|0;ggb(a);return}function bia(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function cia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71512;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function dia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71512;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function eia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0,l=0.0,m=0.0,n=0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0.0;w=k[a+28>>2]|0;x=+p[a+72>>3];q=k[a+4>>2]|0;if(!e)return;r=f+-4|0;s=(f|0)<4;t=(q|0)>1;v=f&-4;while(1){e=e+-1|0;a:do if(s)a=0;else{o=+p[w>>3];n=k[b>>2]|0;if(t)i=0;else{i=0;while(1){a=n+(i<<3)|0;m=x+o*+p[a>>3];l=x+o*+p[a+8>>3];h=x+o*+p[a+16>>3];g=x+o*+p[a+24>>3];p[u>>3]=m;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}a=~~m;j[c+(i<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;p[u>>3]=l;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;j[c+((i|1)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;p[u>>3]=h;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;j[c+((i|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;p[u>>3]=g;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}y=~~g;j[c+((i|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;i=i+4|0;if((i|0)>(r|0)){a=v;break a}}}do{a=n+(i<<3)|0;g=x+o*+p[a+24>>3];h=x+o*+p[a+16>>3];l=x+o*+p[a+8>>3];m=x+o*+p[a>>3];a=1;do{y=(k[b+(a<<2)>>2]|0)+(i<<3)|0;z=+p[w+(a<<3)>>3];m=m+z*+p[y>>3];l=l+z*+p[y+8>>3];h=h+z*+p[y+16>>3];g=g+z*+p[y+24>>3];a=a+1|0}while((a|0)!=(q|0));p[u>>3]=m;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}a=~~m;j[c+(i<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;p[u>>3]=l;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;j[c+((i|1)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;p[u>>3]=h;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;j[c+((i|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;p[u>>3]=g;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}y=~~g;j[c+((i|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;i=i+4|0}while((i|0)<=(r|0));a=v}while(0);b:do if((a|0)<(f|0)){h=+p[w>>3];n=k[b>>2]|0;if(!t)while(1){g=x+h*+p[n+(a<<3)>>3];p[u>>3]=g;i=k[u+4>>2]|0;y=i&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){i=(i|0)<0;g=i?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=i?-0.0:0.0}y=~~g;j[c+(a<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;a=a+1|0;if((a|0)==(f|0))break b}do{g=x+h*+p[n+(a<<3)>>3];i=1;do{g=g+ +p[w+(i<<3)>>3]*+p[(k[b+(i<<2)>>2]|0)+(a<<3)>>3];i=i+1|0}while((i|0)!=(q|0));p[u>>3]=g;i=k[u+4>>2]|0;y=i&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){i=(i|0)<0;g=i?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=i?-0.0:0.0}y=~~g;j[c+(a<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;a=a+1|0}while((a|0)!=(f|0))}while(0);if(!e)break;else{b=b+4|0;c=c+d|0}}return}function fia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71512;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function gia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0,l=0.0,m=0.0,n=0,o=0,q=0.0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0;i=k[a+4>>2]|0;z=(i|0)/2|0;x=(k[a+28>>2]|0)+(z<<3)|0;y=+p[a+72>>3];n=b+(z<<2)|0;o=e+-1|0;b=(e|0)==0;if(!(k[a+80>>2]&1)){if(b)return;v=f+-4|0;w=(f|0)<4;a=(i|0)<2;i=f&-4;p[u>>3]=y;e=k[u+4>>2]|0;r=e&2146435072;r=r>>>0>1126170624|(r|0)==1126170624&0>0;e=(e|0)<0;q=e?y+-4503599627370496.0+4503599627370496.0:y+4503599627370496.0+-4503599627370496.0;s=q==0.0;t=e?-0.0:0.0;while(1){a:do if(w)b=0;else{if(a){e=~~(r|s^1?(r?y:q):t);e=((e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768)&65535;b=0;while(1){j[c+(b<<1)>>1]=e;j[c+((b|1)<<1)>>1]=e;j[c+((b|2)<<1)>>1]=e;j[c+((b|3)<<1)>>1]=e;b=b+4|0;if((b|0)>(v|0)){b=i;break a}}}else e=0;do{g=y;h=y;l=y;m=y;b=1;while(1){B=(k[n+(b<<2)>>2]|0)+(e<<3)|0;A=(k[n+(0-b<<2)>>2]|0)+(e<<3)|0;C=+p[x+(b<<3)>>3];m=m+C*(+p[B>>3]-+p[A>>3]);l=l+C*(+p[B+8>>3]-+p[A+8>>3]);h=h+C*(+p[B+16>>3]-+p[A+16>>3]);g=g+C*(+p[B+24>>3]-+p[A+24>>3]);if((b|0)>=(z|0))break;else b=b+1|0}p[u>>3]=m;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;m=b?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=b?-0.0:0.0}b=~~m;j[c+(e<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;p[u>>3]=l;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;l=b?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;j[c+((e|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;p[u>>3]=h;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;j[c+((e|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;p[u>>3]=g;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;j[c+((e|3)<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;e=e+4|0}while((e|0)<=(v|0));b=i}while(0);b:do if((b|0)<(f|0)){if(a){e=~~(r|s^1?(r?y:q):t);e=((e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768)&65535;while(1){j[c+(b<<1)>>1]=e;b=b+1|0;if((b|0)==(f|0))break b}}do{g=y;e=1;while(1){g=g+ +p[x+(e<<3)>>3]*(+p[(k[n+(e<<2)>>2]|0)+(b<<3)>>3]-+p[(k[n+(0-e<<2)>>2]|0)+(b<<3)>>3]);if((e|0)>=(z|0))break;else e=e+1|0}p[u>>3]=g;e=k[u+4>>2]|0;B=e&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;j[c+(b<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!o)break;else{c=c+d|0;n=n+4|0;o=o+-1|0}}return}if(b)return;s=f+-4|0;v=(f|0)<4;i=(i|0)<2;r=f&-4;while(1){c:do if(v)b=0;else{q=+p[x>>3];a=k[n>>2]|0;if(i){e=0;while(1){b=a+(e<<3)|0;m=y+q*+p[b>>3];l=y+q*+p[b+8>>3];h=y+q*+p[b+16>>3];g=y+q*+p[b+24>>3];p[u>>3]=m;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;m=b?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=b?-0.0:0.0}b=~~m;j[c+(e<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;p[u>>3]=l;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;l=b?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;j[c+((e|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;p[u>>3]=h;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;j[c+((e|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;p[u>>3]=g;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;j[c+((e|3)<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;e=e+4|0;if((e|0)>(s|0)){b=r;break c}}}else e=0;do{b=a+(e<<3)|0;g=y+q*+p[b+24>>3];h=y+q*+p[b+16>>3];l=y+q*+p[b+8>>3];m=y+q*+p[b>>3];b=1;while(1){A=(k[n+(b<<2)>>2]|0)+(e<<3)|0;B=(k[n+(0-b<<2)>>2]|0)+(e<<3)|0;C=+p[x+(b<<3)>>3];m=m+C*(+p[A>>3]+ +p[B>>3]);l=l+C*(+p[A+8>>3]+ +p[B+8>>3]);h=h+C*(+p[A+16>>3]+ +p[B+16>>3]);g=g+C*(+p[A+24>>3]+ +p[B+24>>3]);if((b|0)>=(z|0))break;else b=b+1|0}p[u>>3]=m;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;m=b?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=b?-0.0:0.0}b=~~m;j[c+(e<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;p[u>>3]=l;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;l=b?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;j[c+((e|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;p[u>>3]=h;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;j[c+((e|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;p[u>>3]=g;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;j[c+((e|3)<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;e=e+4|0}while((e|0)<=(s|0));b=r}while(0);d:do if((b|0)<(f|0)){h=+p[x>>3];a=k[n>>2]|0;if(i)while(1){g=y+h*+p[a+(b<<3)>>3];p[u>>3]=g;e=k[u+4>>2]|0;B=e&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;j[c+(b<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;b=b+1|0;if((b|0)==(f|0))break d}do{g=y+h*+p[a+(b<<3)>>3];e=1;while(1){g=g+ +p[x+(e<<3)>>3]*(+p[(k[n+(e<<2)>>2]|0)+(b<<3)>>3]+ +p[(k[n+(0-e<<2)>>2]|0)+(b<<3)>>3]);if((e|0)>=(z|0))break;else e=e+1|0}p[u>>3]=g;e=k[u+4>>2]|0;B=e&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;j[c+(b<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!o)break;else{n=n+4|0;c=c+d|0;o=o+-1|0}}return}function hia(a){a=a|0;ggb(a);return}function iia(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function jia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71560;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function kia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71560;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function lia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0,l=0.0,m=0.0,n=0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0.0;w=k[a+28>>2]|0;x=+o[a+72>>2];q=k[a+4>>2]|0;if(!e)return;r=f+-4|0;s=(f|0)<4;t=(q|0)>1;v=f&-4;while(1){e=e+-1|0;a:do if(s)a=0;else{p=+o[w>>2];n=k[b>>2]|0;if(t)i=0;else{i=0;while(1){a=n+(i<<2)|0;m=x+p*+o[a>>2];l=x+p*+o[a+4>>2];h=x+p*+o[a+8>>2];g=x+p*+o[a+12>>2];a=(o[u>>2]=m,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}a=~~m;j[c+(i<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=l,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;l=a?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;j[c+((i|1)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;j[c+((i|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=g,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;g=a?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=a?-0.0:0.0}a=~~g;j[c+((i|3)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;i=i+4|0;if((i|0)>(r|0)){a=v;break a}}}do{a=n+(i<<2)|0;g=x+p*+o[a+12>>2];h=x+p*+o[a+8>>2];l=x+p*+o[a+4>>2];m=x+p*+o[a>>2];a=1;do{y=(k[b+(a<<2)>>2]|0)+(i<<2)|0;z=+o[w+(a<<2)>>2];m=m+z*+o[y>>2];l=l+z*+o[y+4>>2];h=h+z*+o[y+8>>2];g=g+z*+o[y+12>>2];a=a+1|0}while((a|0)!=(q|0));a=(o[u>>2]=m,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}a=~~m;j[c+(i<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=l,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;l=a?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;j[c+((i|1)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;j[c+((i|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=g,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;g=a?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=a?-0.0:0.0}y=~~g;j[c+((i|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;i=i+4|0}while((i|0)<=(r|0));a=v}while(0);b:do if((a|0)<(f|0)){h=+o[w>>2];n=k[b>>2]|0;if(!t)while(1){g=x+h*+o[n+(a<<2)>>2];i=(o[u>>2]=g,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;g=i?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=i?-0.0:0.0}y=~~g;j[c+(a<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;a=a+1|0;if((a|0)==(f|0))break b}do{g=x+h*+o[n+(a<<2)>>2];i=1;do{g=g+ +o[w+(i<<2)>>2]*+o[(k[b+(i<<2)>>2]|0)+(a<<2)>>2];i=i+1|0}while((i|0)!=(q|0));i=(o[u>>2]=g,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;g=i?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=i?-0.0:0.0}y=~~g;j[c+(a<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;a=a+1|0}while((a|0)!=(f|0))}while(0);if(!e)break;else{b=b+4|0;c=c+d|0}}return}function mia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71560;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function nia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0,l=0.0,m=0.0,n=0,p=0,q=0.0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0;i=k[a+4>>2]|0;z=(i|0)/2|0;x=(k[a+28>>2]|0)+(z<<2)|0;y=+o[a+72>>2];n=b+(z<<2)|0;p=e+-1|0;b=(e|0)==0;if(!(k[a+76>>2]&1)){if(b)return;v=f+-4|0;w=(f|0)<4;a=(i|0)<2;i=f&-4;e=(o[u>>2]=y,k[u>>2]|0);r=(e&2130706432)>>>0>1249902592;e=(e|0)<0;q=e?y+-8388608.0+8388608.0:y+8388608.0+-8388608.0;s=q==0.0;t=e?-0.0:0.0;while(1){a:do if(w)b=0;else{if(a){e=~~(r|s^1?(r?y:q):t);e=((e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768)&65535;b=0;while(1){j[c+(b<<1)>>1]=e;j[c+((b|1)<<1)>>1]=e;j[c+((b|2)<<1)>>1]=e;j[c+((b|3)<<1)>>1]=e;b=b+4|0;if((b|0)>(v|0)){b=i;break a}}}else e=0;do{g=y;h=y;l=y;m=y;b=1;while(1){B=(k[n+(b<<2)>>2]|0)+(e<<2)|0;A=(k[n+(0-b<<2)>>2]|0)+(e<<2)|0;C=+o[x+(b<<2)>>2];m=m+C*(+o[B>>2]-+o[A>>2]);l=l+C*(+o[B+4>>2]-+o[A+4>>2]);h=h+C*(+o[B+8>>2]-+o[A+8>>2]);g=g+C*(+o[B+12>>2]-+o[A+12>>2]);if((b|0)>=(z|0))break;else b=b+1|0}b=(o[u>>2]=m,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;m=b?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=b?-0.0:0.0}b=~~m;j[c+(e<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;j[c+((e|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=(o[u>>2]=h,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;h=b?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;j[c+((e|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=(o[u>>2]=g,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;g=b?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;j[c+((e|3)<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;e=e+4|0}while((e|0)<=(v|0));b=i}while(0);b:do if((b|0)<(f|0)){if(a){e=~~(r|s^1?(r?y:q):t);e=((e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768)&65535;while(1){j[c+(b<<1)>>1]=e;b=b+1|0;if((b|0)==(f|0))break b}}do{g=y;e=1;while(1){g=g+ +o[x+(e<<2)>>2]*(+o[(k[n+(e<<2)>>2]|0)+(b<<2)>>2]-+o[(k[n+(0-e<<2)>>2]|0)+(b<<2)>>2]);if((e|0)>=(z|0))break;else e=e+1|0}e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;j[c+(b<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!p)break;else{c=c+d|0;n=n+4|0;p=p+-1|0}}return}if(b)return;s=f+-4|0;v=(f|0)<4;i=(i|0)<2;r=f&-4;while(1){c:do if(v)b=0;else{q=+o[x>>2];a=k[n>>2]|0;if(i){e=0;while(1){b=a+(e<<2)|0;m=y+q*+o[b>>2];l=y+q*+o[b+4>>2];h=y+q*+o[b+8>>2];g=y+q*+o[b+12>>2];b=(o[u>>2]=m,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;m=b?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=b?-0.0:0.0}b=~~m;j[c+(e<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;j[c+((e|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=(o[u>>2]=h,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;h=b?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;j[c+((e|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=(o[u>>2]=g,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;g=b?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;j[c+((e|3)<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;e=e+4|0;if((e|0)>(s|0)){b=r;break c}}}else e=0;do{b=a+(e<<2)|0;g=y+q*+o[b+12>>2];h=y+q*+o[b+8>>2];l=y+q*+o[b+4>>2];m=y+q*+o[b>>2];b=1;while(1){A=(k[n+(b<<2)>>2]|0)+(e<<2)|0;B=(k[n+(0-b<<2)>>2]|0)+(e<<2)|0;C=+o[x+(b<<2)>>2];m=m+C*(+o[A>>2]+ +o[B>>2]);l=l+C*(+o[A+4>>2]+ +o[B+4>>2]);h=h+C*(+o[A+8>>2]+ +o[B+8>>2]);g=g+C*(+o[A+12>>2]+ +o[B+12>>2]);if((b|0)>=(z|0))break;else b=b+1|0}b=(o[u>>2]=m,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;m=b?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=b?-0.0:0.0}b=~~m;j[c+(e<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;j[c+((e|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=(o[u>>2]=h,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;h=b?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;j[c+((e|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=(o[u>>2]=g,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;g=b?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;j[c+((e|3)<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;e=e+4|0}while((e|0)<=(s|0));b=r}while(0);d:do if((b|0)<(f|0)){h=+o[x>>2];a=k[n>>2]|0;if(i)while(1){g=y+h*+o[a+(b<<2)>>2];e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;j[c+(b<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;b=b+1|0;if((b|0)==(f|0))break d}do{g=y+h*+o[a+(b<<2)>>2];e=1;while(1){g=g+ +o[x+(e<<2)>>2]*(+o[(k[n+(e<<2)>>2]|0)+(b<<2)>>2]+ +o[(k[n+(0-e<<2)>>2]|0)+(b<<2)>>2]);if((e|0)>=(z|0))break;else e=e+1|0}e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;j[c+(b<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!p)break;else{n=n+4|0;c=c+d|0;p=p+-1|0}}return}function oia(a){a=a|0;ggb(a);return}function pia(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function qia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71608;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function ria(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71608;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function sia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;u=k[a+28>>2]|0;v=k[a+72>>2]|0;p=k[a+4>>2]|0;if(!e)return;q=f+-4|0;r=(f|0)<4;s=(p|0)>1;t=f&-4;while(1){e=e+-1|0;a:do if(r)a=0;else{n=k[u>>2]|0;o=k[b>>2]|0;if(s)m=0;else{a=0;while(1){m=o+(a<<2)|0;h=(aa(k[m>>2]|0,n)|0)+v|0;i=(aa(k[m+4>>2]|0,n)|0)+v|0;l=(aa(k[m+8>>2]|0,n)|0)+v|0;m=(aa(k[m+12>>2]|0,n)|0)+v|0;j[c+(a<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;j[c+((a|1)<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;j[c+((a|2)<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;j[c+((a|3)<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;a=a+4|0;if((a|0)>(q|0)){a=t;break a}}}do{a=o+(m<<2)|0;i=(aa(k[a>>2]|0,n)|0)+v|0;h=(aa(k[a+4>>2]|0,n)|0)+v|0;g=(aa(k[a+8>>2]|0,n)|0)+v|0;a=(aa(k[a+12>>2]|0,n)|0)+v|0;l=1;do{x=(k[b+(l<<2)>>2]|0)+(m<<2)|0;w=k[u+(l<<2)>>2]|0;i=(aa(k[x>>2]|0,w)|0)+i|0;h=(aa(k[x+4>>2]|0,w)|0)+h|0;g=(aa(k[x+8>>2]|0,w)|0)+g|0;a=(aa(k[x+12>>2]|0,w)|0)+a|0;l=l+1|0}while((l|0)!=(p|0));j[c+(m<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;j[c+((m|1)<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;j[c+((m|2)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;j[c+((m|3)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;m=m+4|0}while((m|0)<=(q|0));a=t}while(0);b:do if((a|0)<(f|0)){i=k[u>>2]|0;l=k[b>>2]|0;if(!s)while(1){x=(aa(k[l+(a<<2)>>2]|0,i)|0)+v|0;j[c+(a<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;a=a+1|0;if((a|0)==(f|0))break b}do{g=(aa(k[l+(a<<2)>>2]|0,i)|0)+v|0;h=1;do{g=(aa(k[(k[b+(h<<2)>>2]|0)+(a<<2)>>2]|0,k[u+(h<<2)>>2]|0)|0)+g|0;h=h+1|0}while((h|0)!=(p|0));j[c+(a<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;a=a+1|0}while((a|0)!=(f|0))}while(0);if(!e)break;else{b=b+4|0;c=c+d|0}}return}function tia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71608;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function uia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=k[a+4>>2]|0;v=(g|0)/2|0;t=(k[a+28>>2]|0)+(v<<2)|0;u=k[a+72>>2]|0;h=b+(v<<2)|0;i=e+-1|0;b=(e|0)==0;if(!(k[a+76>>2]&1)){if(b)return;q=f+-4|0;r=(f|0)<4;n=(g|0)<2;o=f&-4;p=((u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768)&65535;m=c;l=h;while(1){a:do if(r)b=0;else{if(n){b=0;while(1){j[m+(b<<1)>>1]=p;j[m+((b|1)<<1)>>1]=p;j[m+((b|2)<<1)>>1]=p;j[m+((b|3)<<1)>>1]=p;b=b+4|0;if((b|0)>(q|0)){b=o;break a}}}else c=0;do{b=u;e=u;a=u;g=u;h=1;while(1){x=(k[l+(h<<2)>>2]|0)+(c<<2)|0;w=(k[l+(0-h<<2)>>2]|0)+(c<<2)|0;s=k[t+(h<<2)>>2]|0;g=(aa((k[x>>2]|0)-(k[w>>2]|0)|0,s)|0)+g|0;a=(aa((k[x+4>>2]|0)-(k[w+4>>2]|0)|0,s)|0)+a|0;e=(aa((k[x+8>>2]|0)-(k[w+8>>2]|0)|0,s)|0)+e|0;b=(aa((k[x+12>>2]|0)-(k[w+12>>2]|0)|0,s)|0)+b|0;if((h|0)>=(v|0))break;else h=h+1|0}j[m+(c<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;j[m+((c|1)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;j[m+((c|2)<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;j[m+((c|3)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;c=c+4|0}while((c|0)<=(q|0));b=o}while(0);b:do if((b|0)<(f|0)){if(n)while(1){j[m+(b<<1)>>1]=p;b=b+1|0;if((b|0)==(f|0))break b}do{e=u;a=1;while(1){e=(aa((k[(k[l+(a<<2)>>2]|0)+(b<<2)>>2]|0)-(k[(k[l+(0-a<<2)>>2]|0)+(b<<2)>>2]|0)|0,k[t+(a<<2)>>2]|0)|0)+e|0;if((a|0)>=(v|0))break;else a=a+1|0}j[m+(b<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!i)break;else{m=m+d|0;l=l+4|0;i=i+-1|0}}return}else{if(b)return;r=f+-4|0;s=(f|0)<4;p=(g|0)<2;q=f&-4;o=h;n=c;m=i;while(1){c:do if(s)b=0;else{i=k[t>>2]|0;l=k[o>>2]|0;if(p){b=0;while(1){x=l+(b<<2)|0;h=(aa(k[x>>2]|0,i)|0)+u|0;c=(aa(k[x+4>>2]|0,i)|0)+u|0;w=(aa(k[x+8>>2]|0,i)|0)+u|0;x=(aa(k[x+12>>2]|0,i)|0)+u|0;j[n+(b<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;j[n+((b|1)<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;j[n+((b|2)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;j[n+((b|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;b=b+4|0;if((b|0)>(r|0)){b=q;break c}}}else h=0;do{b=l+(h<<2)|0;g=(aa(k[b>>2]|0,i)|0)+u|0;a=(aa(k[b+4>>2]|0,i)|0)+u|0;e=(aa(k[b+8>>2]|0,i)|0)+u|0;b=(aa(k[b+12>>2]|0,i)|0)+u|0;c=1;while(1){w=(k[o+(c<<2)>>2]|0)+(h<<2)|0;y=(k[o+(0-c<<2)>>2]|0)+(h<<2)|0;x=k[t+(c<<2)>>2]|0;g=(aa((k[y>>2]|0)+(k[w>>2]|0)|0,x)|0)+g|0;a=(aa((k[y+4>>2]|0)+(k[w+4>>2]|0)|0,x)|0)+a|0;e=(aa((k[y+8>>2]|0)+(k[w+8>>2]|0)|0,x)|0)+e|0;b=(aa((k[y+12>>2]|0)+(k[w+12>>2]|0)|0,x)|0)+b|0;if((c|0)>=(v|0))break;else c=c+1|0}j[n+(h<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;j[n+((h|1)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;j[n+((h|2)<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;j[n+((h|3)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;h=h+4|0}while((h|0)<=(r|0));b=q}while(0);d:do if((b|0)<(f|0)){g=k[t>>2]|0;h=k[o>>2]|0;if(p)while(1){y=(aa(k[h+(b<<2)>>2]|0,g)|0)+u|0;j[n+(b<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;b=b+1|0;if((b|0)==(f|0))break d}do{e=(aa(k[h+(b<<2)>>2]|0,g)|0)+u|0;a=1;while(1){e=(aa((k[(k[o+(0-a<<2)>>2]|0)+(b<<2)>>2]|0)+(k[(k[o+(a<<2)>>2]|0)+(b<<2)>>2]|0)|0,k[t+(a<<2)>>2]|0)|0)+e|0;if((a|0)>=(v|0))break;else a=a+1|0}j[n+(b<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!m)break;else{o=o+4|0;n=n+d|0;m=m+-1|0}}return}}function via(a){a=a|0;ggb(a);return}function wia(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function xia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71656;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function yia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71656;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function zia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0,l=0.0,m=0.0,n=0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0.0;w=k[a+28>>2]|0;x=+p[a+72>>3];q=k[a+4>>2]|0;if(!e)return;r=f+-4|0;s=(f|0)<4;t=(q|0)>1;v=f&-4;while(1){e=e+-1|0;a:do if(s)a=0;else{o=+p[w>>3];n=k[b>>2]|0;if(t)i=0;else{i=0;while(1){a=n+(i<<3)|0;m=x+o*+p[a>>3];l=x+o*+p[a+8>>3];h=x+o*+p[a+16>>3];g=x+o*+p[a+24>>3];p[u>>3]=m;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}a=~~m;j[c+(i<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;p[u>>3]=l;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;j[c+((i|1)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;p[u>>3]=h;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;j[c+((i|2)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;p[u>>3]=g;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}y=~~g;j[c+((i|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;i=i+4|0;if((i|0)>(r|0)){a=v;break a}}}do{a=n+(i<<3)|0;g=x+o*+p[a+24>>3];h=x+o*+p[a+16>>3];l=x+o*+p[a+8>>3];m=x+o*+p[a>>3];a=1;do{y=(k[b+(a<<2)>>2]|0)+(i<<3)|0;z=+p[w+(a<<3)>>3];m=m+z*+p[y>>3];l=l+z*+p[y+8>>3];h=h+z*+p[y+16>>3];g=g+z*+p[y+24>>3];a=a+1|0}while((a|0)!=(q|0));p[u>>3]=m;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}a=~~m;j[c+(i<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;p[u>>3]=l;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;j[c+((i|1)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;p[u>>3]=h;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;j[c+((i|2)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;p[u>>3]=g;a=k[u+4>>2]|0;y=a&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}y=~~g;j[c+((i|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;i=i+4|0}while((i|0)<=(r|0));a=v}while(0);b:do if((a|0)<(f|0)){h=+p[w>>3];n=k[b>>2]|0;if(!t)while(1){g=x+h*+p[n+(a<<3)>>3];p[u>>3]=g;i=k[u+4>>2]|0;y=i&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){i=(i|0)<0;g=i?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=i?-0.0:0.0}y=~~g;j[c+(a<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;a=a+1|0;if((a|0)==(f|0))break b}do{g=x+h*+p[n+(a<<3)>>3];i=1;do{g=g+ +p[w+(i<<3)>>3]*+p[(k[b+(i<<2)>>2]|0)+(a<<3)>>3];i=i+1|0}while((i|0)!=(q|0));p[u>>3]=g;i=k[u+4>>2]|0;y=i&2146435072;if(!(y>>>0>1126170624|(y|0)==1126170624&0>0)){i=(i|0)<0;g=i?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=i?-0.0:0.0}y=~~g;j[c+(a<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;a=a+1|0}while((a|0)!=(f|0))}while(0);if(!e)break;else{b=b+4|0;c=c+d|0}}return}function Aia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71656;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Bia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0,l=0.0,m=0.0,n=0,o=0,q=0.0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0;i=k[a+4>>2]|0;z=(i|0)/2|0;x=(k[a+28>>2]|0)+(z<<3)|0;y=+p[a+72>>3];n=b+(z<<2)|0;o=e+-1|0;b=(e|0)==0;if(!(k[a+80>>2]&1)){if(b)return;v=f+-4|0;w=(f|0)<4;a=(i|0)<2;i=f&-4;p[u>>3]=y;e=k[u+4>>2]|0;r=e&2146435072;r=r>>>0>1126170624|(r|0)==1126170624&0>0;e=(e|0)<0;q=e?y+-4503599627370496.0+4503599627370496.0:y+4503599627370496.0+-4503599627370496.0;s=q==0.0;t=e?-0.0:0.0;while(1){a:do if(w)b=0;else{if(a){e=~~(r|s^1?(r?y:q):t);e=(e>>>0<65536?e:(e|0)>0?65535:0)&65535;b=0;while(1){j[c+(b<<1)>>1]=e;j[c+((b|1)<<1)>>1]=e;j[c+((b|2)<<1)>>1]=e;j[c+((b|3)<<1)>>1]=e;b=b+4|0;if((b|0)>(v|0)){b=i;break a}}}else e=0;do{g=y;h=y;l=y;m=y;b=1;while(1){B=(k[n+(b<<2)>>2]|0)+(e<<3)|0;A=(k[n+(0-b<<2)>>2]|0)+(e<<3)|0;C=+p[x+(b<<3)>>3];m=m+C*(+p[B>>3]-+p[A>>3]);l=l+C*(+p[B+8>>3]-+p[A+8>>3]);h=h+C*(+p[B+16>>3]-+p[A+16>>3]);g=g+C*(+p[B+24>>3]-+p[A+24>>3]);if((b|0)>=(z|0))break;else b=b+1|0}p[u>>3]=m;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;m=b?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=b?-0.0:0.0}b=~~m;j[c+(e<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;p[u>>3]=l;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;l=b?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;j[c+((e|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;p[u>>3]=h;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;j[c+((e|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;p[u>>3]=g;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;j[c+((e|3)<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;e=e+4|0}while((e|0)<=(v|0));b=i}while(0);b:do if((b|0)<(f|0)){if(a){e=~~(r|s^1?(r?y:q):t);e=(e>>>0<65536?e:(e|0)>0?65535:0)&65535;while(1){j[c+(b<<1)>>1]=e;b=b+1|0;if((b|0)==(f|0))break b}}do{g=y;e=1;while(1){g=g+ +p[x+(e<<3)>>3]*(+p[(k[n+(e<<2)>>2]|0)+(b<<3)>>3]-+p[(k[n+(0-e<<2)>>2]|0)+(b<<3)>>3]);if((e|0)>=(z|0))break;else e=e+1|0}p[u>>3]=g;e=k[u+4>>2]|0;B=e&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;j[c+(b<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!o)break;else{c=c+d|0;n=n+4|0;o=o+-1|0}}return}if(b)return;s=f+-4|0;v=(f|0)<4;i=(i|0)<2;r=f&-4;while(1){c:do if(v)b=0;else{q=+p[x>>3];a=k[n>>2]|0;if(i){e=0;while(1){b=a+(e<<3)|0;m=y+q*+p[b>>3];l=y+q*+p[b+8>>3];h=y+q*+p[b+16>>3];g=y+q*+p[b+24>>3];p[u>>3]=m;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;m=b?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=b?-0.0:0.0}b=~~m;j[c+(e<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;p[u>>3]=l;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;l=b?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;j[c+((e|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;p[u>>3]=h;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;j[c+((e|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;p[u>>3]=g;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;j[c+((e|3)<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;e=e+4|0;if((e|0)>(s|0)){b=r;break c}}}else e=0;do{b=a+(e<<3)|0;g=y+q*+p[b+24>>3];h=y+q*+p[b+16>>3];l=y+q*+p[b+8>>3];m=y+q*+p[b>>3];b=1;while(1){A=(k[n+(b<<2)>>2]|0)+(e<<3)|0;B=(k[n+(0-b<<2)>>2]|0)+(e<<3)|0;C=+p[x+(b<<3)>>3];m=m+C*(+p[A>>3]+ +p[B>>3]);l=l+C*(+p[A+8>>3]+ +p[B+8>>3]);h=h+C*(+p[A+16>>3]+ +p[B+16>>3]);g=g+C*(+p[A+24>>3]+ +p[B+24>>3]);if((b|0)>=(z|0))break;else b=b+1|0}p[u>>3]=m;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;m=b?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=b?-0.0:0.0}b=~~m;j[c+(e<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;p[u>>3]=l;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;l=b?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;j[c+((e|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;p[u>>3]=h;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;j[c+((e|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;p[u>>3]=g;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;j[c+((e|3)<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;e=e+4|0}while((e|0)<=(s|0));b=r}while(0);d:do if((b|0)<(f|0)){h=+p[x>>3];a=k[n>>2]|0;if(i)while(1){g=y+h*+p[a+(b<<3)>>3];p[u>>3]=g;e=k[u+4>>2]|0;B=e&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;j[c+(b<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;b=b+1|0;if((b|0)==(f|0))break d}do{g=y+h*+p[a+(b<<3)>>3];e=1;while(1){g=g+ +p[x+(e<<3)>>3]*(+p[(k[n+(e<<2)>>2]|0)+(b<<3)>>3]+ +p[(k[n+(0-e<<2)>>2]|0)+(b<<3)>>3]);if((e|0)>=(z|0))break;else e=e+1|0}p[u>>3]=g;e=k[u+4>>2]|0;B=e&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;j[c+(b<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!o)break;else{n=n+4|0;c=c+d|0;o=o+-1|0}}return}function Cia(a){a=a|0;ggb(a);return}function Dia(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Eia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71704;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Fia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71704;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Gia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0,l=0.0,m=0.0,n=0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0.0;w=k[a+28>>2]|0;x=+o[a+72>>2];q=k[a+4>>2]|0;if(!e)return;r=f+-4|0;s=(f|0)<4;t=(q|0)>1;v=f&-4;while(1){e=e+-1|0;a:do if(s)a=0;else{p=+o[w>>2];n=k[b>>2]|0;if(t)i=0;else{i=0;while(1){a=n+(i<<2)|0;m=x+p*+o[a>>2];l=x+p*+o[a+4>>2];h=x+p*+o[a+8>>2];g=x+p*+o[a+12>>2];a=(o[u>>2]=m,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}a=~~m;j[c+(i<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=l,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;l=a?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;j[c+((i|1)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;j[c+((i|2)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=g,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;g=a?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=a?-0.0:0.0}a=~~g;j[c+((i|3)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;i=i+4|0;if((i|0)>(r|0)){a=v;break a}}}do{a=n+(i<<2)|0;g=x+p*+o[a+12>>2];h=x+p*+o[a+8>>2];l=x+p*+o[a+4>>2];m=x+p*+o[a>>2];a=1;do{y=(k[b+(a<<2)>>2]|0)+(i<<2)|0;z=+o[w+(a<<2)>>2];m=m+z*+o[y>>2];l=l+z*+o[y+4>>2];h=h+z*+o[y+8>>2];g=g+z*+o[y+12>>2];a=a+1|0}while((a|0)!=(q|0));a=(o[u>>2]=m,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}a=~~m;j[c+(i<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=l,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;l=a?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;j[c+((i|1)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;j[c+((i|2)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=g,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;g=a?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=a?-0.0:0.0}y=~~g;j[c+((i|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;i=i+4|0}while((i|0)<=(r|0));a=v}while(0);b:do if((a|0)<(f|0)){h=+o[w>>2];n=k[b>>2]|0;if(!t)while(1){g=x+h*+o[n+(a<<2)>>2];i=(o[u>>2]=g,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;g=i?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=i?-0.0:0.0}y=~~g;j[c+(a<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;a=a+1|0;if((a|0)==(f|0))break b}do{g=x+h*+o[n+(a<<2)>>2];i=1;do{g=g+ +o[w+(i<<2)>>2]*+o[(k[b+(i<<2)>>2]|0)+(a<<2)>>2];i=i+1|0}while((i|0)!=(q|0));i=(o[u>>2]=g,k[u>>2]|0);if((i&2130706432)>>>0<=1249902592){i=(i|0)<0;g=i?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=i?-0.0:0.0}y=~~g;j[c+(a<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;a=a+1|0}while((a|0)!=(f|0))}while(0);if(!e)break;else{b=b+4|0;c=c+d|0}}return}function Hia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71704;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Iia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0,l=0.0,m=0.0,n=0,p=0,q=0.0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0;i=k[a+4>>2]|0;z=(i|0)/2|0;x=(k[a+28>>2]|0)+(z<<2)|0;y=+o[a+72>>2];n=b+(z<<2)|0;p=e+-1|0;b=(e|0)==0;if(!(k[a+76>>2]&1)){if(b)return;v=f+-4|0;w=(f|0)<4;a=(i|0)<2;i=f&-4;e=(o[u>>2]=y,k[u>>2]|0);r=(e&2130706432)>>>0>1249902592;e=(e|0)<0;q=e?y+-8388608.0+8388608.0:y+8388608.0+-8388608.0;s=q==0.0;t=e?-0.0:0.0;while(1){a:do if(w)b=0;else{if(a){e=~~(r|s^1?(r?y:q):t);e=(e>>>0<65536?e:(e|0)>0?65535:0)&65535;b=0;while(1){j[c+(b<<1)>>1]=e;j[c+((b|1)<<1)>>1]=e;j[c+((b|2)<<1)>>1]=e;j[c+((b|3)<<1)>>1]=e;b=b+4|0;if((b|0)>(v|0)){b=i;break a}}}else e=0;do{g=y;h=y;l=y;m=y;b=1;while(1){B=(k[n+(b<<2)>>2]|0)+(e<<2)|0;A=(k[n+(0-b<<2)>>2]|0)+(e<<2)|0;C=+o[x+(b<<2)>>2];m=m+C*(+o[B>>2]-+o[A>>2]);l=l+C*(+o[B+4>>2]-+o[A+4>>2]);h=h+C*(+o[B+8>>2]-+o[A+8>>2]);g=g+C*(+o[B+12>>2]-+o[A+12>>2]);if((b|0)>=(z|0))break;else b=b+1|0}b=(o[u>>2]=m,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;m=b?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=b?-0.0:0.0}b=~~m;j[c+(e<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;j[c+((e|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=(o[u>>2]=h,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;h=b?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;j[c+((e|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=(o[u>>2]=g,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;g=b?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;j[c+((e|3)<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;e=e+4|0}while((e|0)<=(v|0));b=i}while(0);b:do if((b|0)<(f|0)){if(a){e=~~(r|s^1?(r?y:q):t);e=(e>>>0<65536?e:(e|0)>0?65535:0)&65535;while(1){j[c+(b<<1)>>1]=e;b=b+1|0;if((b|0)==(f|0))break b}}do{g=y;e=1;while(1){g=g+ +o[x+(e<<2)>>2]*(+o[(k[n+(e<<2)>>2]|0)+(b<<2)>>2]-+o[(k[n+(0-e<<2)>>2]|0)+(b<<2)>>2]);if((e|0)>=(z|0))break;else e=e+1|0}e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;j[c+(b<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!p)break;else{c=c+d|0;n=n+4|0;p=p+-1|0}}return}if(b)return;s=f+-4|0;v=(f|0)<4;i=(i|0)<2;r=f&-4;while(1){c:do if(v)b=0;else{q=+o[x>>2];a=k[n>>2]|0;if(i){e=0;while(1){b=a+(e<<2)|0;m=y+q*+o[b>>2];l=y+q*+o[b+4>>2];h=y+q*+o[b+8>>2];g=y+q*+o[b+12>>2];b=(o[u>>2]=m,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;m=b?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=b?-0.0:0.0}b=~~m;j[c+(e<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;j[c+((e|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=(o[u>>2]=h,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;h=b?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;j[c+((e|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=(o[u>>2]=g,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;g=b?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;j[c+((e|3)<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;e=e+4|0;if((e|0)>(s|0)){b=r;break c}}}else e=0;do{b=a+(e<<2)|0;g=y+q*+o[b+12>>2];h=y+q*+o[b+8>>2];l=y+q*+o[b+4>>2];m=y+q*+o[b>>2];b=1;while(1){A=(k[n+(b<<2)>>2]|0)+(e<<2)|0;B=(k[n+(0-b<<2)>>2]|0)+(e<<2)|0;C=+o[x+(b<<2)>>2];m=m+C*(+o[A>>2]+ +o[B>>2]);l=l+C*(+o[A+4>>2]+ +o[B+4>>2]);h=h+C*(+o[A+8>>2]+ +o[B+8>>2]);g=g+C*(+o[A+12>>2]+ +o[B+12>>2]);if((b|0)>=(z|0))break;else b=b+1|0}b=(o[u>>2]=m,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;m=b?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=b?-0.0:0.0}b=~~m;j[c+(e<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;j[c+((e|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=(o[u>>2]=h,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;h=b?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;j[c+((e|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=(o[u>>2]=g,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;g=b?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;j[c+((e|3)<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;e=e+4|0}while((e|0)<=(s|0));b=r}while(0);d:do if((b|0)<(f|0)){h=+o[x>>2];a=k[n>>2]|0;if(i)while(1){g=y+h*+o[a+(b<<2)>>2];e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;j[c+(b<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;b=b+1|0;if((b|0)==(f|0))break d}do{g=y+h*+o[a+(b<<2)>>2];e=1;while(1){g=g+ +o[x+(e<<2)>>2]*(+o[(k[n+(e<<2)>>2]|0)+(b<<2)>>2]+ +o[(k[n+(0-e<<2)>>2]|0)+(b<<2)>>2]);if((e|0)>=(z|0))break;else e=e+1|0}e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;j[c+(b<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!p)break;else{n=n+4|0;c=c+d|0;p=p+-1|0}}return}function Jia(a){a=a|0;ggb(a);return}function Kia(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Lia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71752;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Mia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71752;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Nia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,j=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0.0;t=k[a+28>>2]|0;v=+p[a+72>>3];n=k[a+4>>2]|0;if(!e)return;o=f+-4|0;q=(f|0)<4;r=(n|0)>1;s=f&-4;m=e;while(1){m=m+-1|0;a:do if(q)a=0;else{if(r)e=0;else{e=0;while(1){g=+p[t>>3];a=(k[b>>2]|0)+(e<<3)|0;l=v+g*+p[a>>3];j=v+g*+p[a+8>>3];h=v+g*+p[a+16>>3];g=v+g*+p[a+24>>3];p[u>>3]=l;a=k[u+4>>2]|0;w=a&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;i[c+e>>0]=a>>>0<256?a:(a|0)>0?255:0;p[u>>3]=j;a=k[u+4>>2]|0;w=a&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){a=(a|0)<0;j=a?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=a?-0.0:0.0}a=~~j;i[c+(e|1)>>0]=a>>>0<256?a:(a|0)>0?255:0;p[u>>3]=h;a=k[u+4>>2]|0;w=a&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;i[c+(e|2)>>0]=a>>>0<256?a:(a|0)>0?255:0;p[u>>3]=g;a=k[u+4>>2]|0;w=a&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}w=~~g;i[c+(e|3)>>0]=w>>>0<256?w:(w|0)>0?255:0;e=e+4|0;if((e|0)>(o|0)){a=s;break a}}}do{l=+p[t>>3];a=(k[b>>2]|0)+(e<<3)|0;g=v+l*+p[a+24>>3];h=v+l*+p[a+16>>3];j=v+l*+p[a+8>>3];l=v+l*+p[a>>3];a=1;do{w=(k[b+(a<<2)>>2]|0)+(e<<3)|0;x=+p[t+(a<<3)>>3];l=l+x*+p[w>>3];j=j+x*+p[w+8>>3];h=h+x*+p[w+16>>3];g=g+x*+p[w+24>>3];a=a+1|0}while((a|0)!=(n|0));p[u>>3]=l;a=k[u+4>>2]|0;w=a&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;i[c+e>>0]=a>>>0<256?a:(a|0)>0?255:0;p[u>>3]=j;a=k[u+4>>2]|0;w=a&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){a=(a|0)<0;j=a?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=a?-0.0:0.0}a=~~j;i[c+(e|1)>>0]=a>>>0<256?a:(a|0)>0?255:0;p[u>>3]=h;a=k[u+4>>2]|0;w=a&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;i[c+(e|2)>>0]=a>>>0<256?a:(a|0)>0?255:0;p[u>>3]=g;a=k[u+4>>2]|0;w=a&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}w=~~g;i[c+(e|3)>>0]=w>>>0<256?w:(w|0)>0?255:0;e=e+4|0}while((e|0)<=(o|0));a=s}while(0);b:do if((a|0)<(f|0)){if(!r)while(1){g=v+ +p[t>>3]*+p[(k[b>>2]|0)+(a<<3)>>3];p[u>>3]=g;e=k[u+4>>2]|0;w=e&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=e?-0.0:0.0}w=~~g;i[c+a>>0]=w>>>0<256?w:(w|0)>0?255:0;a=a+1|0;if((a|0)==(f|0))break b}do{g=v+ +p[t>>3]*+p[(k[b>>2]|0)+(a<<3)>>3];e=1;do{g=g+ +p[t+(e<<3)>>3]*+p[(k[b+(e<<2)>>2]|0)+(a<<3)>>3];e=e+1|0}while((e|0)!=(n|0));p[u>>3]=g;e=k[u+4>>2]|0;w=e&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=e?-0.0:0.0}w=~~g;i[c+a>>0]=w>>>0<256?w:(w|0)>0?255:0;a=a+1|0}while((a|0)!=(f|0))}while(0);if(!m)break;else{b=b+4|0;c=c+d|0}}return}function Oia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71752;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Pia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,j=0.0,l=0.0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0;m=k[a+4>>2]|0;z=(m|0)/2|0;x=(k[a+28>>2]|0)+(z<<3)|0;y=+p[a+72>>3];n=b+(z<<2)|0;o=e+-1|0;b=(e|0)==0;if(!(k[a+80>>2]&1)){if(b)return;v=f+-4|0;w=(f|0)<4;a=(m|0)<2;m=f&-4;p[u>>3]=y;e=k[u+4>>2]|0;r=e&2146435072;r=r>>>0>1126170624|(r|0)==1126170624&0>0;e=(e|0)<0;q=e?y+-4503599627370496.0+4503599627370496.0:y+4503599627370496.0+-4503599627370496.0;s=q==0.0;t=e?-0.0:0.0;while(1){a:do if(w)b=0;else{if(a){e=~~(r|s^1?(r?y:q):t);e=(e>>>0<256?e:(e|0)>0?255:0)&255;b=0;while(1){i[c+b>>0]=e;i[c+(b|1)>>0]=e;i[c+(b|2)>>0]=e;i[c+(b|3)>>0]=e;b=b+4|0;if((b|0)>(v|0)){b=m;break a}}}else e=0;do{g=y;h=y;j=y;l=y;b=1;while(1){B=(k[n+(b<<2)>>2]|0)+(e<<3)|0;A=(k[n+(0-b<<2)>>2]|0)+(e<<3)|0;C=+p[x+(b<<3)>>3];l=l+C*(+p[B>>3]-+p[A>>3]);j=j+C*(+p[B+8>>3]-+p[A+8>>3]);h=h+C*(+p[B+16>>3]-+p[A+16>>3]);g=g+C*(+p[B+24>>3]-+p[A+24>>3]);if((b|0)>=(z|0))break;else b=b+1|0}p[u>>3]=l;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;l=b?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;i[c+e>>0]=b>>>0<256?b:(b|0)>0?255:0;p[u>>3]=j;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;j=b?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=b?-0.0:0.0}b=~~j;i[c+(e|1)>>0]=b>>>0<256?b:(b|0)>0?255:0;p[u>>3]=h;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;i[c+(e|2)>>0]=b>>>0<256?b:(b|0)>0?255:0;p[u>>3]=g;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;i[c+(e|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;e=e+4|0}while((e|0)<=(v|0));b=m}while(0);b:do if((b|0)<(f|0)){if(a){e=~~(r|s^1?(r?y:q):t);e=(e>>>0<256?e:(e|0)>0?255:0)&255;while(1){i[c+b>>0]=e;b=b+1|0;if((b|0)==(f|0))break b}}do{g=y;e=1;while(1){g=g+ +p[x+(e<<3)>>3]*(+p[(k[n+(e<<2)>>2]|0)+(b<<3)>>3]-+p[(k[n+(0-e<<2)>>2]|0)+(b<<3)>>3]);if((e|0)>=(z|0))break;else e=e+1|0}p[u>>3]=g;e=k[u+4>>2]|0;B=e&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;i[c+b>>0]=B>>>0<256?B:(B|0)>0?255:0;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!o)break;else{c=c+d|0;n=n+4|0;o=o+-1|0}}return}if(b)return;r=f+-4|0;s=(f|0)<4;a=(m|0)<2;m=f&-4;while(1){c:do if(s)b=0;else{if(a){e=0;while(1){g=+p[x>>3];b=(k[n>>2]|0)+(e<<3)|0;l=y+g*+p[b>>3];j=y+g*+p[b+8>>3];h=y+g*+p[b+16>>3];g=y+g*+p[b+24>>3];p[u>>3]=l;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;l=b?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;i[c+e>>0]=b>>>0<256?b:(b|0)>0?255:0;p[u>>3]=j;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;j=b?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=b?-0.0:0.0}b=~~j;i[c+(e|1)>>0]=b>>>0<256?b:(b|0)>0?255:0;p[u>>3]=h;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;i[c+(e|2)>>0]=b>>>0<256?b:(b|0)>0?255:0;p[u>>3]=g;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;i[c+(e|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;e=e+4|0;if((e|0)>(r|0)){b=m;break c}}}else e=0;do{l=+p[x>>3];b=(k[n>>2]|0)+(e<<3)|0;g=y+l*+p[b+24>>3];h=y+l*+p[b+16>>3];j=y+l*+p[b+8>>3];l=y+l*+p[b>>3];b=1;while(1){A=(k[n+(b<<2)>>2]|0)+(e<<3)|0;B=(k[n+(0-b<<2)>>2]|0)+(e<<3)|0;C=+p[x+(b<<3)>>3];l=l+C*(+p[A>>3]+ +p[B>>3]);j=j+C*(+p[A+8>>3]+ +p[B+8>>3]);h=h+C*(+p[A+16>>3]+ +p[B+16>>3]);g=g+C*(+p[A+24>>3]+ +p[B+24>>3]);if((b|0)>=(z|0))break;else b=b+1|0}p[u>>3]=l;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;l=b?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;i[c+e>>0]=b>>>0<256?b:(b|0)>0?255:0;p[u>>3]=j;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;j=b?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=b?-0.0:0.0}b=~~j;i[c+(e|1)>>0]=b>>>0<256?b:(b|0)>0?255:0;p[u>>3]=h;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;h=b?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;i[c+(e|2)>>0]=b>>>0<256?b:(b|0)>0?255:0;p[u>>3]=g;b=k[u+4>>2]|0;B=b&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){b=(b|0)<0;g=b?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;i[c+(e|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;e=e+4|0}while((e|0)<=(r|0));b=m}while(0);d:do if((b|0)<(f|0)){if(a)while(1){g=y+ +p[x>>3]*+p[(k[n>>2]|0)+(b<<3)>>3];p[u>>3]=g;e=k[u+4>>2]|0;B=e&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;i[c+b>>0]=B>>>0<256?B:(B|0)>0?255:0;b=b+1|0;if((b|0)==(f|0))break d}do{g=y+ +p[x>>3]*+p[(k[n>>2]|0)+(b<<3)>>3];e=1;while(1){g=g+ +p[x+(e<<3)>>3]*(+p[(k[n+(e<<2)>>2]|0)+(b<<3)>>3]+ +p[(k[n+(0-e<<2)>>2]|0)+(b<<3)>>3]);if((e|0)>=(z|0))break;else e=e+1|0}p[u>>3]=g;e=k[u+4>>2]|0;B=e&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){e=(e|0)<0;g=e?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;i[c+b>>0]=B>>>0<256?B:(B|0)>0?255:0;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!o)break;else{n=n+4|0;c=c+d|0;o=o+-1|0}}return}function Qia(a){a=a|0;ggb(a);return}function Ria(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Sia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71800;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Tia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71800;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Uia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,j=0.0,l=0.0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0.0;t=k[a+28>>2]|0;v=+o[a+72>>2];n=k[a+4>>2]|0;if(!e)return;p=f+-4|0;q=(f|0)<4;r=(n|0)>1;s=f&-4;m=e;while(1){m=m+-1|0;a:do if(q)a=0;else{if(r)e=0;else{e=0;while(1){g=+o[t>>2];a=(k[b>>2]|0)+(e<<2)|0;l=v+g*+o[a>>2];j=v+g*+o[a+4>>2];h=v+g*+o[a+8>>2];g=v+g*+o[a+12>>2];a=(o[u>>2]=l,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;l=a?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;i[c+e>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(o[u>>2]=j,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;j=a?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=a?-0.0:0.0}a=~~j;i[c+(e|1)>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;i[c+(e|2)>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(o[u>>2]=g,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;g=a?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=a?-0.0:0.0}a=~~g;i[c+(e|3)>>0]=a>>>0<256?a:(a|0)>0?255:0;e=e+4|0;if((e|0)>(p|0)){a=s;break a}}}do{l=+o[t>>2];a=(k[b>>2]|0)+(e<<2)|0;g=v+l*+o[a+12>>2];h=v+l*+o[a+8>>2];j=v+l*+o[a+4>>2];l=v+l*+o[a>>2];a=1;do{w=(k[b+(a<<2)>>2]|0)+(e<<2)|0;x=+o[t+(a<<2)>>2];l=l+x*+o[w>>2];j=j+x*+o[w+4>>2];h=h+x*+o[w+8>>2];g=g+x*+o[w+12>>2];a=a+1|0}while((a|0)!=(n|0));a=(o[u>>2]=l,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;l=a?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;i[c+e>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(o[u>>2]=j,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;j=a?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=a?-0.0:0.0}a=~~j;i[c+(e|1)>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;i[c+(e|2)>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(o[u>>2]=g,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;g=a?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=a?-0.0:0.0}w=~~g;i[c+(e|3)>>0]=w>>>0<256?w:(w|0)>0?255:0;e=e+4|0}while((e|0)<=(p|0));a=s}while(0);b:do if((a|0)<(f|0)){if(!r)while(1){g=v+ +o[t>>2]*+o[(k[b>>2]|0)+(a<<2)>>2];e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}w=~~g;i[c+a>>0]=w>>>0<256?w:(w|0)>0?255:0;a=a+1|0;if((a|0)==(f|0))break b}do{g=v+ +o[t>>2]*+o[(k[b>>2]|0)+(a<<2)>>2];e=1;do{g=g+ +o[t+(e<<2)>>2]*+o[(k[b+(e<<2)>>2]|0)+(a<<2)>>2];e=e+1|0}while((e|0)!=(n|0));e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}w=~~g;i[c+a>>0]=w>>>0<256?w:(w|0)>0?255:0;a=a+1|0}while((a|0)!=(f|0))}while(0);if(!m)break;else{b=b+4|0;c=c+d|0}}return}function Via(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71800;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function Wia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,j=0.0,l=0.0,m=0,n=0,p=0,q=0.0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0;m=k[a+4>>2]|0;z=(m|0)/2|0;x=(k[a+28>>2]|0)+(z<<2)|0;y=+o[a+72>>2];n=b+(z<<2)|0;p=e+-1|0;b=(e|0)==0;if(!(k[a+76>>2]&1)){if(b)return;v=f+-4|0;w=(f|0)<4;a=(m|0)<2;m=f&-4;e=(o[u>>2]=y,k[u>>2]|0);r=(e&2130706432)>>>0>1249902592;e=(e|0)<0;q=e?y+-8388608.0+8388608.0:y+8388608.0+-8388608.0;s=q==0.0;t=e?-0.0:0.0;while(1){a:do if(w)b=0;else{if(a){e=~~(r|s^1?(r?y:q):t);e=(e>>>0<256?e:(e|0)>0?255:0)&255;b=0;while(1){i[c+b>>0]=e;i[c+(b|1)>>0]=e;i[c+(b|2)>>0]=e;i[c+(b|3)>>0]=e;b=b+4|0;if((b|0)>(v|0)){b=m;break a}}}else e=0;do{g=y;h=y;j=y;l=y;b=1;while(1){B=(k[n+(b<<2)>>2]|0)+(e<<2)|0;A=(k[n+(0-b<<2)>>2]|0)+(e<<2)|0;C=+o[x+(b<<2)>>2];l=l+C*(+o[B>>2]-+o[A>>2]);j=j+C*(+o[B+4>>2]-+o[A+4>>2]);h=h+C*(+o[B+8>>2]-+o[A+8>>2]);g=g+C*(+o[B+12>>2]-+o[A+12>>2]);if((b|0)>=(z|0))break;else b=b+1|0}b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;i[c+e>>0]=b>>>0<256?b:(b|0)>0?255:0;b=(o[u>>2]=j,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;j=b?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=b?-0.0:0.0}b=~~j;i[c+(e|1)>>0]=b>>>0<256?b:(b|0)>0?255:0;b=(o[u>>2]=h,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;h=b?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;i[c+(e|2)>>0]=b>>>0<256?b:(b|0)>0?255:0;b=(o[u>>2]=g,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;g=b?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;i[c+(e|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;e=e+4|0}while((e|0)<=(v|0));b=m}while(0);b:do if((b|0)<(f|0)){if(a){e=~~(r|s^1?(r?y:q):t);e=(e>>>0<256?e:(e|0)>0?255:0)&255;while(1){i[c+b>>0]=e;b=b+1|0;if((b|0)==(f|0))break b}}do{g=y;e=1;while(1){g=g+ +o[x+(e<<2)>>2]*(+o[(k[n+(e<<2)>>2]|0)+(b<<2)>>2]-+o[(k[n+(0-e<<2)>>2]|0)+(b<<2)>>2]);if((e|0)>=(z|0))break;else e=e+1|0}e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;i[c+b>>0]=B>>>0<256?B:(B|0)>0?255:0;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!p)break;else{c=c+d|0;n=n+4|0;p=p+-1|0}}return}if(b)return;r=f+-4|0;s=(f|0)<4;a=(m|0)<2;m=f&-4;while(1){c:do if(s)b=0;else{if(a){e=0;while(1){g=+o[x>>2];b=(k[n>>2]|0)+(e<<2)|0;l=y+g*+o[b>>2];j=y+g*+o[b+4>>2];h=y+g*+o[b+8>>2];g=y+g*+o[b+12>>2];b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;i[c+e>>0]=b>>>0<256?b:(b|0)>0?255:0;b=(o[u>>2]=j,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;j=b?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=b?-0.0:0.0}b=~~j;i[c+(e|1)>>0]=b>>>0<256?b:(b|0)>0?255:0;b=(o[u>>2]=h,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;h=b?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;i[c+(e|2)>>0]=b>>>0<256?b:(b|0)>0?255:0;b=(o[u>>2]=g,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;g=b?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;i[c+(e|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;e=e+4|0;if((e|0)>(r|0)){b=m;break c}}}else e=0;do{l=+o[x>>2];b=(k[n>>2]|0)+(e<<2)|0;g=y+l*+o[b+12>>2];h=y+l*+o[b+8>>2];j=y+l*+o[b+4>>2];l=y+l*+o[b>>2];b=1;while(1){A=(k[n+(b<<2)>>2]|0)+(e<<2)|0;B=(k[n+(0-b<<2)>>2]|0)+(e<<2)|0;C=+o[x+(b<<2)>>2];l=l+C*(+o[A>>2]+ +o[B>>2]);j=j+C*(+o[A+4>>2]+ +o[B+4>>2]);h=h+C*(+o[A+8>>2]+ +o[B+8>>2]);g=g+C*(+o[A+12>>2]+ +o[B+12>>2]);if((b|0)>=(z|0))break;else b=b+1|0}b=(o[u>>2]=l,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;l=b?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=b?-0.0:0.0}b=~~l;i[c+e>>0]=b>>>0<256?b:(b|0)>0?255:0;b=(o[u>>2]=j,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;j=b?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=b?-0.0:0.0}b=~~j;i[c+(e|1)>>0]=b>>>0<256?b:(b|0)>0?255:0;b=(o[u>>2]=h,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;h=b?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=b?-0.0:0.0}b=~~h;i[c+(e|2)>>0]=b>>>0<256?b:(b|0)>0?255:0;b=(o[u>>2]=g,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;g=b?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=b?-0.0:0.0}B=~~g;i[c+(e|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;e=e+4|0}while((e|0)<=(r|0));b=m}while(0);d:do if((b|0)<(f|0)){if(a)while(1){g=y+ +o[x>>2]*+o[(k[n>>2]|0)+(b<<2)>>2];e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;i[c+b>>0]=B>>>0<256?B:(B|0)>0?255:0;b=b+1|0;if((b|0)==(f|0))break d}do{g=y+ +o[x>>2]*+o[(k[n>>2]|0)+(b<<2)>>2];e=1;while(1){g=g+ +o[x+(e<<2)>>2]*(+o[(k[n+(e<<2)>>2]|0)+(b<<2)>>2]+ +o[(k[n+(0-e<<2)>>2]|0)+(b<<2)>>2]);if((e|0)>=(z|0))break;else e=e+1|0}e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}B=~~g;i[c+b>>0]=B>>>0<256?B:(B|0)>0?255:0;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!p)break;else{n=n+4|0;c=c+d|0;p=p+-1|0}}return}function Xia(a){a=a|0;ggb(a);return}function Yia(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Zia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71848;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function _ia(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71848;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function $ia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;u=k[a+28>>2]|0;v=k[a+80>>2]|0;t=k[a+4>>2]|0;o=a+68|0;n=k[o>>2]|0;o=k[o+4>>2]|0;if(!e)return;p=f+-4|0;q=(f|0)<4;r=(t|0)>1;s=f&-4;m=e;while(1){m=m+-1|0;a:do if(q)a=0;else{if(r)l=0;else{a=0;while(1){l=k[u>>2]|0;e=(k[b>>2]|0)+(a<<2)|0;g=(aa(k[e>>2]|0,l)|0)+v|0;h=(aa(k[e+4>>2]|0,l)|0)+v|0;j=(aa(k[e+8>>2]|0,l)|0)+v|0;l=(aa(k[e+12>>2]|0,l)|0)+v|0;g=g+o>>n;i[c+a>>0]=g>>>0<256?g:(g|0)>0?255:0;h=h+o>>n;i[c+(a|1)>>0]=h>>>0<256?h:(h|0)>0?255:0;j=j+o>>n;i[c+(a|2)>>0]=j>>>0<256?j:(j|0)>0?255:0;l=l+o>>n;i[c+(a|3)>>0]=l>>>0<256?l:(l|0)>0?255:0;a=a+4|0;if((a|0)>(p|0)){a=s;break a}}}do{a=k[u>>2]|0;j=(k[b>>2]|0)+(l<<2)|0;h=(aa(k[j>>2]|0,a)|0)+v|0;g=(aa(k[j+4>>2]|0,a)|0)+v|0;e=(aa(k[j+8>>2]|0,a)|0)+v|0;a=(aa(k[j+12>>2]|0,a)|0)+v|0;j=1;do{x=(k[b+(j<<2)>>2]|0)+(l<<2)|0;w=k[u+(j<<2)>>2]|0;h=(aa(k[x>>2]|0,w)|0)+h|0;g=(aa(k[x+4>>2]|0,w)|0)+g|0;e=(aa(k[x+8>>2]|0,w)|0)+e|0;a=(aa(k[x+12>>2]|0,w)|0)+a|0;j=j+1|0}while((j|0)!=(t|0));x=h+o>>n;i[c+l>>0]=x>>>0<256?x:(x|0)>0?255:0;x=g+o>>n;i[c+(l|1)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=e+o>>n;i[c+(l|2)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=a+o>>n;i[c+(l|3)>>0]=x>>>0<256?x:(x|0)>0?255:0;l=l+4|0}while((l|0)<=(p|0));a=s}while(0);b:do if((a|0)<(f|0)){if(!r)while(1){x=(aa(k[(k[b>>2]|0)+(a<<2)>>2]|0,k[u>>2]|0)|0)+v+o>>n;i[c+a>>0]=x>>>0<256?x:(x|0)>0?255:0;a=a+1|0;if((a|0)==(f|0))break b}do{e=(aa(k[(k[b>>2]|0)+(a<<2)>>2]|0,k[u>>2]|0)|0)+v|0;g=1;do{e=(aa(k[(k[b+(g<<2)>>2]|0)+(a<<2)>>2]|0,k[u+(g<<2)>>2]|0)|0)+e|0;g=g+1|0}while((g|0)!=(t|0));x=e+o>>n;i[c+a>>0]=x>>>0<256?x:(x|0)>0?255:0;a=a+1|0}while((a|0)!=(f|0))}while(0);if(!m)break;else{b=b+4|0;c=c+d|0}}return}function aja(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71848;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function bja(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=k[a+4>>2]|0;w=(g|0)/2|0;s=(k[a+28>>2]|0)+(w<<2)|0;t=k[a+80>>2]|0;v=a+68|0;u=k[v>>2]|0;v=k[v+4>>2]|0;h=b+(w<<2)|0;j=e+-1|0;b=(e|0)==0;if(!(k[a+84>>2]&1)){if(b)return;q=f+-4|0;r=(f|0)<4;n=(g|0)<2;o=f&-4;p=t+v>>u;p=(p>>>0<256?p:(p|0)>0?255:0)&255;m=c;l=h;while(1){a:do if(r)b=0;else{if(n){b=0;while(1){i[m+b>>0]=p;i[m+(b|1)>>0]=p;i[m+(b|2)>>0]=p;i[m+(b|3)>>0]=p;b=b+4|0;if((b|0)>(q|0)){b=o;break a}}}else c=0;do{b=t;e=t;a=t;g=t;h=1;while(1){z=(k[l+(h<<2)>>2]|0)+(c<<2)|0;y=(k[l+(0-h<<2)>>2]|0)+(c<<2)|0;x=k[s+(h<<2)>>2]|0;g=(aa((k[z>>2]|0)-(k[y>>2]|0)|0,x)|0)+g|0;a=(aa((k[z+4>>2]|0)-(k[y+4>>2]|0)|0,x)|0)+a|0;e=(aa((k[z+8>>2]|0)-(k[y+8>>2]|0)|0,x)|0)+e|0;b=(aa((k[z+12>>2]|0)-(k[y+12>>2]|0)|0,x)|0)+b|0;if((h|0)>=(w|0))break;else h=h+1|0}z=g+v>>u;i[m+c>>0]=z>>>0<256?z:(z|0)>0?255:0;z=a+v>>u;i[m+(c|1)>>0]=z>>>0<256?z:(z|0)>0?255:0;z=e+v>>u;i[m+(c|2)>>0]=z>>>0<256?z:(z|0)>0?255:0;z=b+v>>u;i[m+(c|3)>>0]=z>>>0<256?z:(z|0)>0?255:0;c=c+4|0}while((c|0)<=(q|0));b=o}while(0);b:do if((b|0)<(f|0)){if(n)while(1){i[m+b>>0]=p;b=b+1|0;if((b|0)==(f|0))break b}do{e=t;a=1;while(1){e=(aa((k[(k[l+(a<<2)>>2]|0)+(b<<2)>>2]|0)-(k[(k[l+(0-a<<2)>>2]|0)+(b<<2)>>2]|0)|0,k[s+(a<<2)>>2]|0)|0)+e|0;if((a|0)>=(w|0))break;else a=a+1|0}z=e+v>>u;i[m+b>>0]=z>>>0<256?z:(z|0)>0?255:0;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!j)break;else{m=m+d|0;l=l+4|0;j=j+-1|0}}return}else{if(b)return;p=f+-4|0;q=(f|0)<4;n=(g|0)<2;o=f&-4;m=h;l=c;while(1){c:do if(q)b=0;else{if(n){b=0;while(1){z=k[s>>2]|0;c=(k[m>>2]|0)+(b<<2)|0;r=(aa(k[c>>2]|0,z)|0)+t|0;x=(aa(k[c+4>>2]|0,z)|0)+t|0;y=(aa(k[c+8>>2]|0,z)|0)+t|0;z=(aa(k[c+12>>2]|0,z)|0)+t|0;r=r+v>>u;i[l+b>>0]=r>>>0<256?r:(r|0)>0?255:0;x=x+v>>u;i[l+(b|1)>>0]=x>>>0<256?x:(x|0)>0?255:0;y=y+v>>u;i[l+(b|2)>>0]=y>>>0<256?y:(y|0)>0?255:0;z=z+v>>u;i[l+(b|3)>>0]=z>>>0<256?z:(z|0)>0?255:0;b=b+4|0;if((b|0)>(p|0)){b=o;break c}}}else h=0;do{b=k[s>>2]|0;c=(k[m>>2]|0)+(h<<2)|0;g=(aa(k[c>>2]|0,b)|0)+t|0;a=(aa(k[c+4>>2]|0,b)|0)+t|0;e=(aa(k[c+8>>2]|0,b)|0)+t|0;b=(aa(k[c+12>>2]|0,b)|0)+t|0;c=1;while(1){y=(k[m+(c<<2)>>2]|0)+(h<<2)|0;x=(k[m+(0-c<<2)>>2]|0)+(h<<2)|0;z=k[s+(c<<2)>>2]|0;g=(aa((k[x>>2]|0)+(k[y>>2]|0)|0,z)|0)+g|0;a=(aa((k[x+4>>2]|0)+(k[y+4>>2]|0)|0,z)|0)+a|0;e=(aa((k[x+8>>2]|0)+(k[y+8>>2]|0)|0,z)|0)+e|0;b=(aa((k[x+12>>2]|0)+(k[y+12>>2]|0)|0,z)|0)+b|0;if((c|0)>=(w|0))break;else c=c+1|0}z=g+v>>u;i[l+h>>0]=z>>>0<256?z:(z|0)>0?255:0;z=a+v>>u;i[l+(h|1)>>0]=z>>>0<256?z:(z|0)>0?255:0;z=e+v>>u;i[l+(h|2)>>0]=z>>>0<256?z:(z|0)>0?255:0;z=b+v>>u;i[l+(h|3)>>0]=z>>>0<256?z:(z|0)>0?255:0;h=h+4|0}while((h|0)<=(p|0));b=o}while(0);d:do if((b|0)<(f|0)){if(n)while(1){z=(aa(k[(k[m>>2]|0)+(b<<2)>>2]|0,k[s>>2]|0)|0)+t+v>>u;i[l+b>>0]=z>>>0<256?z:(z|0)>0?255:0;b=b+1|0;if((b|0)==(f|0))break d}do{e=(aa(k[(k[m>>2]|0)+(b<<2)>>2]|0,k[s>>2]|0)|0)+t|0;a=1;while(1){e=(aa((k[(k[m+(0-a<<2)>>2]|0)+(b<<2)>>2]|0)+(k[(k[m+(a<<2)>>2]|0)+(b<<2)>>2]|0)|0,k[s+(a<<2)>>2]|0)|0)+e|0;if((a|0)>=(w|0))break;else a=a+1|0}z=e+v>>u;i[l+b>>0]=z>>>0<256?z:(z|0)>0?255:0;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!j)break;else{m=m+4|0;l=l+d|0;j=j+-1|0}}return}}function cja(a){a=a|0;ggb(a);return}function dja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function eja(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71896;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function fja(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71896;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function gja(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0,j=0.0,l=0.0,m=0.0,n=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0;t=k[a+28>>2]|0;u=+o[a+72>>2];n=k[a+4>>2]|0;if(!e)return;p=f+-4|0;q=(f|0)<4;r=(n|0)>1;s=f&-4;while(1){e=e+-1|0;a:do if(q)a=0;else{i=k[b>>2]|0;if(r)h=0;else{a=0;while(1){g=+o[t>>2];h=i+(a<<2)|0;j=u+g*+o[h+4>>2];l=u+g*+o[h+8>>2];m=u+g*+o[h+12>>2];o[c+(a<<2)>>2]=u+g*+o[h>>2];o[c+((a|1)<<2)>>2]=j;o[c+((a|2)<<2)>>2]=l;o[c+((a|3)<<2)>>2]=m;a=a+4|0;if((a|0)>(p|0)){a=s;break a}}}do{m=+o[t>>2];a=i+(h<<2)|0;g=u+m*+o[a+12>>2];j=u+m*+o[a+8>>2];l=u+m*+o[a+4>>2];m=u+m*+o[a>>2];a=1;do{v=(k[b+(a<<2)>>2]|0)+(h<<2)|0;w=+o[t+(a<<2)>>2];m=m+w*+o[v>>2];l=l+w*+o[v+4>>2];j=j+w*+o[v+8>>2];g=g+w*+o[v+12>>2];a=a+1|0}while((a|0)!=(n|0));o[c+(h<<2)>>2]=m;o[c+((h|1)<<2)>>2]=l;o[c+((h|2)<<2)>>2]=j;o[c+((h|3)<<2)>>2]=g;h=h+4|0}while((h|0)<=(p|0));a=s}while(0);b:do if((a|0)<(f|0)){i=k[b>>2]|0;if(!r)while(1){o[c+(a<<2)>>2]=u+ +o[t>>2]*+o[i+(a<<2)>>2];a=a+1|0;if((a|0)==(f|0))break b}do{g=u+ +o[t>>2]*+o[i+(a<<2)>>2];h=1;do{g=g+ +o[t+(h<<2)>>2]*+o[(k[b+(h<<2)>>2]|0)+(a<<2)>>2];h=h+1|0}while((h|0)!=(n|0));o[c+(a<<2)>>2]=g;a=a+1|0}while((a|0)!=(f|0))}while(0);if(!e)break;else{b=b+4|0;c=c+d|0}}return}function hja(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71896;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function ija(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0,z=0,A=0;i=(k[a+4>>2]|0)/2|0;g=(k[a+28>>2]|0)+(i<<2)|0;v=(k[a+76>>2]&1|0)==0;w=+o[g>>2];if(w==2.0)x=+o[g+4>>2]==1.0;else x=0;h=+o[g+4>>2];t=w==-2.0&h==1.0;if(w==0.0)if(h==1.0){u=1.0;s=1}else{u=h;s=h==-1.0}else{u=h;s=0}h=+o[a+72>>2];if(!e)return;n=u<0.0;p=f+-4|0;q=(f|0)<4;r=f&-4;m=b+(i<<2)|0;l=e;while(1){l=l+-1|0;i=k[m+-4>>2]|0;j=k[m>>2]|0;m=m+4|0;e=k[m>>2]|0;a:do if(v)if(s){a=n?e:i;e=n?i:e;if(q)g=0;else{b=e;i=a;g=0;do{z=g|1;y=h+(+o[b+(z<<2)>>2]-+o[i+(z<<2)>>2]);o[c+(g<<2)>>2]=h+(+o[b+(g<<2)>>2]-+o[i+(g<<2)>>2]);o[c+(z<<2)>>2]=y;z=g|2;j=g|3;y=h+(+o[b+(j<<2)>>2]-+o[i+(j<<2)>>2]);o[c+(z<<2)>>2]=h+(+o[b+(z<<2)>>2]-+o[i+(z<<2)>>2]);o[c+(j<<2)>>2]=y;g=g+4|0}while((g|0)<=(p|0));g=r}if((g|0)>=(f|0))break;b=e;do{o[c+(g<<2)>>2]=h+(+o[b+(g<<2)>>2]-+o[a+(g<<2)>>2]);g=g+1|0}while((g|0)!=(f|0))}else{if(q)g=0;else{a=e;b=i;g=0;do{j=g|1;y=h+u*(+o[a+(j<<2)>>2]-+o[b+(j<<2)>>2]);o[c+(g<<2)>>2]=h+u*(+o[a+(g<<2)>>2]-+o[b+(g<<2)>>2]);o[c+(j<<2)>>2]=y;j=g|2;z=g|3;y=h+u*(+o[a+(z<<2)>>2]-+o[b+(z<<2)>>2]);o[c+(j<<2)>>2]=h+u*(+o[a+(j<<2)>>2]-+o[b+(j<<2)>>2]);o[c+(z<<2)>>2]=y;g=g+4|0}while((g|0)<=(p|0));g=r}if((g|0)>=(f|0))break;b=e;a=i;do{o[c+(g<<2)>>2]=h+u*(+o[b+(g<<2)>>2]-+o[a+(g<<2)>>2]);g=g+1|0}while((g|0)!=(f|0))}else{if(x){if(q)g=0;else{a=i;b=e;g=0;do{A=g|1;y=h+(+o[b+(A<<2)>>2]+(+o[a+(A<<2)>>2]+ +o[j+(A<<2)>>2]*2.0));o[c+(g<<2)>>2]=h+(+o[b+(g<<2)>>2]+(+o[a+(g<<2)>>2]+ +o[j+(g<<2)>>2]*2.0));o[c+(A<<2)>>2]=y;A=g|2;z=g|3;y=h+(+o[b+(z<<2)>>2]+(+o[a+(z<<2)>>2]+ +o[j+(z<<2)>>2]*2.0));o[c+(A<<2)>>2]=h+(+o[b+(A<<2)>>2]+(+o[a+(A<<2)>>2]+ +o[j+(A<<2)>>2]*2.0));o[c+(z<<2)>>2]=y;g=g+4|0}while((g|0)<=(p|0));g=r}if((g|0)>=(f|0))break;b=i;a=e;while(1){o[c+(g<<2)>>2]=h+(+o[a+(g<<2)>>2]+(+o[b+(g<<2)>>2]+ +o[j+(g<<2)>>2]*2.0));g=g+1|0;if((g|0)==(f|0))break a}}if(t){if(q)g=0;else{a=i;b=e;g=0;do{z=g|1;y=h+(+o[b+(z<<2)>>2]+(+o[a+(z<<2)>>2]-+o[j+(z<<2)>>2]*2.0));o[c+(g<<2)>>2]=h+(+o[b+(g<<2)>>2]+(+o[a+(g<<2)>>2]-+o[j+(g<<2)>>2]*2.0));o[c+(z<<2)>>2]=y;z=g|2;A=g|3;y=h+(+o[b+(A<<2)>>2]+(+o[a+(A<<2)>>2]-+o[j+(A<<2)>>2]*2.0));o[c+(z<<2)>>2]=h+(+o[b+(z<<2)>>2]+(+o[a+(z<<2)>>2]-+o[j+(z<<2)>>2]*2.0));o[c+(A<<2)>>2]=y;g=g+4|0}while((g|0)<=(p|0));g=r}if((g|0)>=(f|0))break;b=i;a=e;do{o[c+(g<<2)>>2]=h+(+o[a+(g<<2)>>2]+(+o[b+(g<<2)>>2]-+o[j+(g<<2)>>2]*2.0));g=g+1|0}while((g|0)!=(f|0))}else{if(q)g=0;else{a=i;b=e;g=0;do{z=g|1;y=h+(u*(+o[a+(z<<2)>>2]+ +o[b+(z<<2)>>2])+w*+o[j+(z<<2)>>2]);o[c+(g<<2)>>2]=h+(u*(+o[a+(g<<2)>>2]+ +o[b+(g<<2)>>2])+w*+o[j+(g<<2)>>2]);o[c+(z<<2)>>2]=y;z=g|2;A=g|3;y=h+(u*(+o[a+(A<<2)>>2]+ +o[b+(A<<2)>>2])+w*+o[j+(A<<2)>>2]);o[c+(z<<2)>>2]=h+(u*(+o[a+(z<<2)>>2]+ +o[b+(z<<2)>>2])+w*+o[j+(z<<2)>>2]);o[c+(A<<2)>>2]=y;g=g+4|0}while((g|0)<=(p|0));g=r}if((g|0)>=(f|0))break;b=i;a=e;do{o[c+(g<<2)>>2]=h+(u*(+o[b+(g<<2)>>2]+ +o[a+(g<<2)>>2])+w*+o[j+(g<<2)>>2]);g=g+1|0}while((g|0)!=(f|0))}}while(0);if(!l)break;else c=c+d|0}return}function jja(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71896;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function kja(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0.0,l=0.0,m=0,n=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0;h=k[a+4>>2]|0;u=(h|0)/2|0;s=(k[a+28>>2]|0)+(u<<2)|0;t=+o[a+72>>2];m=b+(u<<2)|0;n=e+-1|0;b=(e|0)==0;if(!(k[a+76>>2]&1)){if(b)return;p=f+-4|0;q=(f|0)<4;a=(h|0)<2;h=f&-4;while(1){a:do if(q)b=0;else{if(a){b=0;while(1){o[c+(b<<2)>>2]=t;o[c+((b|1)<<2)>>2]=t;o[c+((b|2)<<2)>>2]=t;o[c+((b|3)<<2)>>2]=t;b=b+4|0;if((b|0)>(p|0)){b=h;break a}}}else e=0;do{g=t;i=t;j=t;l=t;b=1;while(1){v=(k[m+(b<<2)>>2]|0)+(e<<2)|0;r=(k[m+(0-b<<2)>>2]|0)+(e<<2)|0;w=+o[s+(b<<2)>>2];l=l+w*(+o[v>>2]-+o[r>>2]);j=j+w*(+o[v+4>>2]-+o[r+4>>2]);i=i+w*(+o[v+8>>2]-+o[r+8>>2]);g=g+w*(+o[v+12>>2]-+o[r+12>>2]);if((b|0)>=(u|0))break;else b=b+1|0}o[c+(e<<2)>>2]=l;o[c+((e|1)<<2)>>2]=j;o[c+((e|2)<<2)>>2]=i;o[c+((e|3)<<2)>>2]=g;e=e+4|0}while((e|0)<=(p|0));b=h}while(0);b:do if((b|0)<(f|0)){if(a)while(1){o[c+(b<<2)>>2]=t;b=b+1|0;if((b|0)==(f|0))break b}do{g=t;e=1;while(1){g=g+ +o[s+(e<<2)>>2]*(+o[(k[m+(e<<2)>>2]|0)+(b<<2)>>2]-+o[(k[m+(0-e<<2)>>2]|0)+(b<<2)>>2]);if((e|0)>=(u|0))break;else e=e+1|0}o[c+(b<<2)>>2]=g;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!n)break;else{c=c+d|0;m=m+4|0;n=n+-1|0}}return}else{if(b)return;q=f+-4|0;r=(f|0)<4;h=(h|0)<2;p=f&-4;while(1){c:do if(r)b=0;else{a=k[m>>2]|0;if(h){b=0;while(1){i=+o[s>>2];v=a+(b<<2)|0;j=t+i*+o[v+4>>2];l=t+i*+o[v+8>>2];w=t+i*+o[v+12>>2];o[c+(b<<2)>>2]=t+i*+o[v>>2];o[c+((b|1)<<2)>>2]=j;o[c+((b|2)<<2)>>2]=l;o[c+((b|3)<<2)>>2]=w;b=b+4|0;if((b|0)>(q|0)){b=p;break c}}}else b=0;do{l=+o[s>>2];e=a+(b<<2)|0;g=t+l*+o[e+12>>2];i=t+l*+o[e+8>>2];j=t+l*+o[e+4>>2];l=t+l*+o[e>>2];e=1;while(1){x=(k[m+(e<<2)>>2]|0)+(b<<2)|0;v=(k[m+(0-e<<2)>>2]|0)+(b<<2)|0;w=+o[s+(e<<2)>>2];l=l+w*(+o[x>>2]+ +o[v>>2]);j=j+w*(+o[x+4>>2]+ +o[v+4>>2]);i=i+w*(+o[x+8>>2]+ +o[v+8>>2]);g=g+w*(+o[x+12>>2]+ +o[v+12>>2]);if((e|0)>=(u|0))break;else e=e+1|0}o[c+(b<<2)>>2]=l;o[c+((b|1)<<2)>>2]=j;o[c+((b|2)<<2)>>2]=i;o[c+((b|3)<<2)>>2]=g;b=b+4|0}while((b|0)<=(q|0));b=p}while(0);d:do if((b|0)<(f|0)){a=k[m>>2]|0;if(h)while(1){o[c+(b<<2)>>2]=t+ +o[s>>2]*+o[a+(b<<2)>>2];b=b+1|0;if((b|0)==(f|0))break d}do{g=t+ +o[s>>2]*+o[a+(b<<2)>>2];e=1;while(1){g=g+ +o[s+(e<<2)>>2]*(+o[(k[m+(e<<2)>>2]|0)+(b<<2)>>2]+ +o[(k[m+(0-e<<2)>>2]|0)+(b<<2)>>2]);if((e|0)>=(u|0))break;else e=e+1|0}o[c+(b<<2)>>2]=g;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!n)break;else{m=m+4|0;c=c+d|0;n=n+-1|0}}return}}function lja(a){a=a|0;ggb(a);return}function mja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function nja(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71968;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function oja(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71968;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function pja(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;u=k[a+28>>2]|0;v=k[a+72>>2]|0;p=k[a+4>>2]|0;if(!e)return;q=f+-4|0;r=(f|0)<4;s=(p|0)>1;t=f&-4;while(1){e=e+-1|0;a:do if(r)a=0;else{n=k[u>>2]|0;o=k[b>>2]|0;if(s)m=0;else{a=0;while(1){m=o+(a<<2)|0;h=(aa(k[m>>2]|0,n)|0)+v|0;i=(aa(k[m+4>>2]|0,n)|0)+v|0;l=(aa(k[m+8>>2]|0,n)|0)+v|0;m=(aa(k[m+12>>2]|0,n)|0)+v|0;j[c+(a<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;j[c+((a|1)<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;j[c+((a|2)<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;j[c+((a|3)<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;a=a+4|0;if((a|0)>(q|0)){a=t;break a}}}do{a=o+(m<<2)|0;i=(aa(k[a>>2]|0,n)|0)+v|0;h=(aa(k[a+4>>2]|0,n)|0)+v|0;g=(aa(k[a+8>>2]|0,n)|0)+v|0;a=(aa(k[a+12>>2]|0,n)|0)+v|0;l=1;do{x=(k[b+(l<<2)>>2]|0)+(m<<2)|0;w=k[u+(l<<2)>>2]|0;i=(aa(k[x>>2]|0,w)|0)+i|0;h=(aa(k[x+4>>2]|0,w)|0)+h|0;g=(aa(k[x+8>>2]|0,w)|0)+g|0;a=(aa(k[x+12>>2]|0,w)|0)+a|0;l=l+1|0}while((l|0)!=(p|0));j[c+(m<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;j[c+((m|1)<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;j[c+((m|2)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;j[c+((m|3)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;m=m+4|0}while((m|0)<=(q|0));a=t}while(0);b:do if((a|0)<(f|0)){i=k[u>>2]|0;l=k[b>>2]|0;if(!s)while(1){x=(aa(k[l+(a<<2)>>2]|0,i)|0)+v|0;j[c+(a<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;a=a+1|0;if((a|0)==(f|0))break b}do{g=(aa(k[l+(a<<2)>>2]|0,i)|0)+v|0;h=1;do{g=(aa(k[(k[b+(h<<2)>>2]|0)+(a<<2)>>2]|0,k[u+(h<<2)>>2]|0)|0)+g|0;h=h+1|0}while((h|0)!=(p|0));j[c+(a<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;a=a+1|0}while((a|0)!=(f|0))}while(0);if(!e)break;else{b=b+4|0;c=c+d|0}}return}function qja(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71968;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function rja(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=(k[a+4>>2]|0)/2|0;g=(k[a+28>>2]|0)+(h<<2)|0;w=(k[a+76>>2]&1|0)==0;x=k[g>>2]|0;switch(x|0){case 2:{u=k[g+4>>2]|0;s=u;t=0;u=(u|0)==1;v=0;break}case -2:{t=k[g+4>>2]|0;s=t;t=(t|0)==1;u=0;v=0;break}case 0:{v=k[g+4>>2]|0;s=v;t=0;u=0;v=(v|0)==1|(v|0)==-1;break}default:{s=k[g+4>>2]|0;t=0;u=0;v=0}}n=k[a+72>>2]|0;if(!e)return;o=(s|0)<0;p=f+-4|0;q=(f|0)<4;r=f&-4;m=b+(h<<2)|0;while(1){e=e+-1|0;h=k[m+-4>>2]|0;l=k[m>>2]|0;m=m+4|0;i=k[m>>2]|0;a:do if(w)if(v){a=o?i:h;i=o?h:i;if(q)g=0;else{b=i;h=a;g=0;do{l=(k[b+(g<<2)>>2]|0)-(k[h+(g<<2)>>2]|0)+n|0;z=g|1;A=(k[b+(z<<2)>>2]|0)-(k[h+(z<<2)>>2]|0)+n|0;j[c+(g<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;j[c+(z<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;z=g|2;A=(k[b+(z<<2)>>2]|0)-(k[h+(z<<2)>>2]|0)+n|0;l=g|3;y=(k[b+(l<<2)>>2]|0)-(k[h+(l<<2)>>2]|0)+n|0;j[c+(z<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;j[c+(l<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;g=g+4|0}while((g|0)<=(p|0));g=r}if((g|0)>=(f|0))break;b=i;do{A=(k[b+(g<<2)>>2]|0)-(k[a+(g<<2)>>2]|0)+n|0;j[c+(g<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;g=g+1|0}while((g|0)!=(f|0))}else{if(q)g=0;else{a=i;b=h;g=0;do{A=(aa((k[a+(g<<2)>>2]|0)-(k[b+(g<<2)>>2]|0)|0,s)|0)+n|0;y=g|1;l=(aa((k[a+(y<<2)>>2]|0)-(k[b+(y<<2)>>2]|0)|0,s)|0)+n|0;j[c+(g<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;j[c+(y<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;y=g|2;l=(aa((k[a+(y<<2)>>2]|0)-(k[b+(y<<2)>>2]|0)|0,s)|0)+n|0;A=g|3;z=(aa((k[a+(A<<2)>>2]|0)-(k[b+(A<<2)>>2]|0)|0,s)|0)+n|0;j[c+(y<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;j[c+(A<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;g=g+4|0}while((g|0)<=(p|0));g=r}if((g|0)>=(f|0))break;b=i;a=h;do{A=(aa((k[b+(g<<2)>>2]|0)-(k[a+(g<<2)>>2]|0)|0,s)|0)+n|0;j[c+(g<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;g=g+1|0}while((g|0)!=(f|0))}else{if(u){if(q)g=0;else{a=h;b=i;g=0;do{A=(k[a+(g<<2)>>2]|0)+n+(k[l+(g<<2)>>2]<<1)+(k[b+(g<<2)>>2]|0)|0;y=g|1;B=(k[a+(y<<2)>>2]|0)+n+(k[l+(y<<2)>>2]<<1)+(k[b+(y<<2)>>2]|0)|0;j[c+(g<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;j[c+(y<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;y=g|2;B=(k[a+(y<<2)>>2]|0)+n+(k[l+(y<<2)>>2]<<1)+(k[b+(y<<2)>>2]|0)|0;A=g|3;z=(k[a+(A<<2)>>2]|0)+n+(k[l+(A<<2)>>2]<<1)+(k[b+(A<<2)>>2]|0)|0;j[c+(y<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;j[c+(A<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;g=g+4|0}while((g|0)<=(p|0));g=r}if((g|0)>=(f|0))break;b=h;a=i;while(1){B=(k[b+(g<<2)>>2]|0)+n+(k[l+(g<<2)>>2]<<1)+(k[a+(g<<2)>>2]|0)|0;j[c+(g<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;g=g+1|0;if((g|0)==(f|0))break a}}if(t){if(q)g=0;else{a=h;b=i;g=0;do{B=(k[a+(g<<2)>>2]|0)+n-(k[l+(g<<2)>>2]<<1)+(k[b+(g<<2)>>2]|0)|0;z=g|1;y=(k[a+(z<<2)>>2]|0)+n-(k[l+(z<<2)>>2]<<1)+(k[b+(z<<2)>>2]|0)|0;j[c+(g<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;j[c+(z<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;z=g|2;y=(k[a+(z<<2)>>2]|0)+n-(k[l+(z<<2)>>2]<<1)+(k[b+(z<<2)>>2]|0)|0;B=g|3;A=(k[a+(B<<2)>>2]|0)+n-(k[l+(B<<2)>>2]<<1)+(k[b+(B<<2)>>2]|0)|0;j[c+(z<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;j[c+(B<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;g=g+4|0}while((g|0)<=(p|0));g=r}if((g|0)>=(f|0))break;b=h;a=i;do{B=(k[b+(g<<2)>>2]|0)+n-(k[l+(g<<2)>>2]<<1)+(k[a+(g<<2)>>2]|0)|0;j[c+(g<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;g=g+1|0}while((g|0)!=(f|0))}else{if(q)g=0;else{a=h;b=i;g=0;do{B=aa((k[b+(g<<2)>>2]|0)+(k[a+(g<<2)>>2]|0)|0,s)|0;B=(aa(k[l+(g<<2)>>2]|0,x)|0)+n+B|0;z=g|1;y=aa((k[b+(z<<2)>>2]|0)+(k[a+(z<<2)>>2]|0)|0,s)|0;y=(aa(k[l+(z<<2)>>2]|0,x)|0)+n+y|0;j[c+(g<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;j[c+(z<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;z=g|2;y=aa((k[b+(z<<2)>>2]|0)+(k[a+(z<<2)>>2]|0)|0,s)|0;y=(aa(k[l+(z<<2)>>2]|0,x)|0)+n+y|0;B=g|3;A=aa((k[b+(B<<2)>>2]|0)+(k[a+(B<<2)>>2]|0)|0,s)|0;A=(aa(k[l+(B<<2)>>2]|0,x)|0)+n+A|0;j[c+(z<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;j[c+(B<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;g=g+4|0}while((g|0)<=(p|0));g=r}if((g|0)>=(f|0))break;b=h;a=i;do{B=aa((k[a+(g<<2)>>2]|0)+(k[b+(g<<2)>>2]|0)|0,s)|0;B=(aa(k[l+(g<<2)>>2]|0,x)|0)+n+B|0;j[c+(g<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;g=g+1|0}while((g|0)!=(f|0))}}while(0);if(!e)break;else c=c+d|0}return}function sja(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71968;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function tja(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=k[a+4>>2]|0;v=(g|0)/2|0;t=(k[a+28>>2]|0)+(v<<2)|0;u=k[a+72>>2]|0;h=b+(v<<2)|0;i=e+-1|0;b=(e|0)==0;if(!(k[a+76>>2]&1)){if(b)return;q=f+-4|0;r=(f|0)<4;n=(g|0)<2;o=f&-4;p=((u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768)&65535;m=c;l=h;while(1){a:do if(r)b=0;else{if(n){b=0;while(1){j[m+(b<<1)>>1]=p;j[m+((b|1)<<1)>>1]=p;j[m+((b|2)<<1)>>1]=p;j[m+((b|3)<<1)>>1]=p;b=b+4|0;if((b|0)>(q|0)){b=o;break a}}}else c=0;do{b=u;e=u;a=u;g=u;h=1;while(1){x=(k[l+(h<<2)>>2]|0)+(c<<2)|0;w=(k[l+(0-h<<2)>>2]|0)+(c<<2)|0;s=k[t+(h<<2)>>2]|0;g=(aa((k[x>>2]|0)-(k[w>>2]|0)|0,s)|0)+g|0;a=(aa((k[x+4>>2]|0)-(k[w+4>>2]|0)|0,s)|0)+a|0;e=(aa((k[x+8>>2]|0)-(k[w+8>>2]|0)|0,s)|0)+e|0;b=(aa((k[x+12>>2]|0)-(k[w+12>>2]|0)|0,s)|0)+b|0;if((h|0)>=(v|0))break;else h=h+1|0}j[m+(c<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;j[m+((c|1)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;j[m+((c|2)<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;j[m+((c|3)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;c=c+4|0}while((c|0)<=(q|0));b=o}while(0);b:do if((b|0)<(f|0)){if(n)while(1){j[m+(b<<1)>>1]=p;b=b+1|0;if((b|0)==(f|0))break b}do{e=u;a=1;while(1){e=(aa((k[(k[l+(a<<2)>>2]|0)+(b<<2)>>2]|0)-(k[(k[l+(0-a<<2)>>2]|0)+(b<<2)>>2]|0)|0,k[t+(a<<2)>>2]|0)|0)+e|0;if((a|0)>=(v|0))break;else a=a+1|0}j[m+(b<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!i)break;else{m=m+d|0;l=l+4|0;i=i+-1|0}}return}else{if(b)return;r=f+-4|0;s=(f|0)<4;p=(g|0)<2;q=f&-4;o=h;n=c;m=i;while(1){c:do if(s)b=0;else{i=k[t>>2]|0;l=k[o>>2]|0;if(p){b=0;while(1){x=l+(b<<2)|0;h=(aa(k[x>>2]|0,i)|0)+u|0;c=(aa(k[x+4>>2]|0,i)|0)+u|0;w=(aa(k[x+8>>2]|0,i)|0)+u|0;x=(aa(k[x+12>>2]|0,i)|0)+u|0;j[n+(b<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;j[n+((b|1)<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;j[n+((b|2)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;j[n+((b|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;b=b+4|0;if((b|0)>(r|0)){b=q;break c}}}else h=0;do{b=l+(h<<2)|0;g=(aa(k[b>>2]|0,i)|0)+u|0;a=(aa(k[b+4>>2]|0,i)|0)+u|0;e=(aa(k[b+8>>2]|0,i)|0)+u|0;b=(aa(k[b+12>>2]|0,i)|0)+u|0;c=1;while(1){w=(k[o+(c<<2)>>2]|0)+(h<<2)|0;y=(k[o+(0-c<<2)>>2]|0)+(h<<2)|0;x=k[t+(c<<2)>>2]|0;g=(aa((k[y>>2]|0)+(k[w>>2]|0)|0,x)|0)+g|0;a=(aa((k[y+4>>2]|0)+(k[w+4>>2]|0)|0,x)|0)+a|0;e=(aa((k[y+8>>2]|0)+(k[w+8>>2]|0)|0,x)|0)+e|0;b=(aa((k[y+12>>2]|0)+(k[w+12>>2]|0)|0,x)|0)+b|0;if((c|0)>=(v|0))break;else c=c+1|0}j[n+(h<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;j[n+((h|1)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;j[n+((h|2)<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;j[n+((h|3)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;h=h+4|0}while((h|0)<=(r|0));b=q}while(0);d:do if((b|0)<(f|0)){g=k[t>>2]|0;h=k[o>>2]|0;if(p)while(1){y=(aa(k[h+(b<<2)>>2]|0,g)|0)+u|0;j[n+(b<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;b=b+1|0;if((b|0)==(f|0))break d}do{e=(aa(k[h+(b<<2)>>2]|0,g)|0)+u|0;a=1;while(1){e=(aa((k[(k[o+(0-a<<2)>>2]|0)+(b<<2)>>2]|0)+(k[(k[o+(a<<2)>>2]|0)+(b<<2)>>2]|0)|0,k[t+(a<<2)>>2]|0)|0)+e|0;if((a|0)>=(v|0))break;else a=a+1|0}j[n+(b<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;b=b+1|0}while((b|0)!=(f|0))}while(0);if(!m)break;else{o=o+4|0;n=n+d|0;m=m+-1|0}}return}}function uja(a){a=a|0;ggb(a);return}function vja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function wja(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=71848;d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0){ggb(a);return}ggb(k[b+-4>>2]|0);ggb(a);return}function xja(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=(k[a+4>>2]|0)/2|0;g=(k[a+28>>2]|0)+(h<<2)|0;x=(k[a+84>>2]&1|0)==0;y=k[g>>2]|0;switch(y|0){case 2:{v=k[g+4>>2]|0;q=v;u=0;v=(v|0)==1;w=0;break}case -2:{u=k[g+4>>2]|0;q=u;u=(u|0)==1;v=0;w=0;break}case 0:{w=k[g+4>>2]|0;q=w;u=0;v=0;w=(w|0)==1|(w|0)==-1;break}default:{q=k[g+4>>2]|0;u=0;v=0;w=0}}g=a+68|0;p=k[g>>2]|0;if(!e)return;r=(q|0)<0;s=f+-4|0;t=(f|0)<4;n=(k[g+4>>2]|0)+(k[a+80>>2]|0)|0;o=f&-4;m=b+(h<<2)|0;l=e;while(1){l=l+-1|0;h=k[m+-4>>2]|0;j=k[m>>2]|0;m=m+4|0;e=k[m>>2]|0;a:do if(x)if(w){a=r?e:h;e=r?h:e;if(t)g=0;else{b=e;h=a;g=0;do{B=g|1;A=k[b+(B<<2)>>2]|0;j=k[h+(B<<2)>>2]|0;z=n+(k[b+(g<<2)>>2]|0)-(k[h+(g<<2)>>2]|0)>>p;i[c+g>>0]=z>>>0<256?z:(z|0)>0?255:0;j=n+A-j>>p;i[c+B>>0]=j>>>0<256?j:(j|0)>0?255:0;B=g|2;j=g|3;A=k[b+(j<<2)>>2]|0;z=k[h+(j<<2)>>2]|0;C=n+(k[b+(B<<2)>>2]|0)-(k[h+(B<<2)>>2]|0)>>p;i[c+B>>0]=C>>>0<256?C:(C|0)>0?255:0;z=n+A-z>>p;i[c+j>>0]=z>>>0<256?z:(z|0)>0?255:0;g=g+4|0}while((g|0)<=(s|0));g=o}if((g|0)>=(f|0))break;b=e;do{C=n+(k[b+(g<<2)>>2]|0)-(k[a+(g<<2)>>2]|0)>>p;i[c+g>>0]=C>>>0<256?C:(C|0)>0?255:0;g=g+1|0}while((g|0)!=(f|0))}else{if(t)g=0;else{a=e;b=h;g=0;do{C=aa((k[a+(g<<2)>>2]|0)-(k[b+(g<<2)>>2]|0)|0,q)|0;A=g|1;z=aa((k[a+(A<<2)>>2]|0)-(k[b+(A<<2)>>2]|0)|0,q)|0;C=n+C>>p;i[c+g>>0]=C>>>0<256?C:(C|0)>0?255:0;z=n+z>>p;i[c+A>>0]=z>>>0<256?z:(z|0)>0?255:0;A=g|2;z=aa((k[a+(A<<2)>>2]|0)-(k[b+(A<<2)>>2]|0)|0,q)|0;C=g|3;B=aa((k[a+(C<<2)>>2]|0)-(k[b+(C<<2)>>2]|0)|0,q)|0;z=n+z>>p;i[c+A>>0]=z>>>0<256?z:(z|0)>0?255:0;B=n+B>>p;i[c+C>>0]=B>>>0<256?B:(B|0)>0?255:0;g=g+4|0}while((g|0)<=(s|0));g=o}if((g|0)>=(f|0))break;b=e;a=h;do{C=n+(aa((k[b+(g<<2)>>2]|0)-(k[a+(g<<2)>>2]|0)|0,q)|0)>>p;i[c+g>>0]=C>>>0<256?C:(C|0)>0?255:0;g=g+1|0}while((g|0)!=(f|0))}else{if(v){if(t)g=0;else{a=h;b=e;g=0;do{D=g|1;A=k[a+(D<<2)>>2]|0;z=k[j+(D<<2)>>2]<<1;C=k[b+(D<<2)>>2]|0;B=n+(k[a+(g<<2)>>2]|0)+(k[j+(g<<2)>>2]<<1)+(k[b+(g<<2)>>2]|0)>>p;i[c+g>>0]=B>>>0<256?B:(B|0)>0?255:0;C=n+A+z+C>>p;i[c+D>>0]=C>>>0<256?C:(C|0)>0?255:0;D=g|2;C=g|3;z=k[a+(C<<2)>>2]|0;A=k[j+(C<<2)>>2]<<1;B=k[b+(C<<2)>>2]|0;E=n+(k[a+(D<<2)>>2]|0)+(k[j+(D<<2)>>2]<<1)+(k[b+(D<<2)>>2]|0)>>p;i[c+D>>0]=E>>>0<256?E:(E|0)>0?255:0;B=n+z+A+B>>p;i[c+C>>0]=B>>>0<256?B:(B|0)>0?255:0;g=g+4|0}while((g|0)<=(s|0));g=o}if((g|0)>=(f|0))break;b=h;a=e;while(1){E=n+(k[b+(g<<2)>>2]|0)+(k[j+(g<<2)>>2]<<1)+(k[a+(g<<2)>>2]|0)>>p;i[c+g>>0]=E>>>0<256?E:(E|0)>0?255:0;g=g+1|0;if((g|0)==(f|0))break a}}if(u){if(t)g=0;else{a=h;b=e;g=0;do{A=g|1;C=k[a+(A<<2)>>2]|0;B=k[j+(A<<2)>>2]<<1;E=k[b+(A<<2)>>2]|0;D=n+(k[a+(g<<2)>>2]|0)-(k[j+(g<<2)>>2]<<1)+(k[b+(g<<2)>>2]|0)>>p;i[c+g>>0]=D>>>0<256?D:(D|0)>0?255:0;E=n+C-B+E>>p;i[c+A>>0]=E>>>0<256?E:(E|0)>0?255:0;A=g|2;E=g|3;B=k[a+(E<<2)>>2]|0;C=k[j+(E<<2)>>2]<<1;D=k[b+(E<<2)>>2]|0;z=n+(k[a+(A<<2)>>2]|0)-(k[j+(A<<2)>>2]<<1)+(k[b+(A<<2)>>2]|0)>>p;i[c+A>>0]=z>>>0<256?z:(z|0)>0?255:0;D=n+B-C+D>>p;i[c+E>>0]=D>>>0<256?D:(D|0)>0?255:0;g=g+4|0}while((g|0)<=(s|0));g=o}if((g|0)>=(f|0))break;b=h;a=e;do{E=n+(k[b+(g<<2)>>2]|0)-(k[j+(g<<2)>>2]<<1)+(k[a+(g<<2)>>2]|0)>>p;i[c+g>>0]=E>>>0<256?E:(E|0)>0?255:0;g=g+1|0}while((g|0)!=(f|0))}else{if(t)g=0;else{a=h;b=e;g=0;do{E=aa((k[b+(g<<2)>>2]|0)+(k[a+(g<<2)>>2]|0)|0,q)|0;D=aa(k[j+(g<<2)>>2]|0,y)|0;B=g|1;A=aa((k[b+(B<<2)>>2]|0)+(k[a+(B<<2)>>2]|0)|0,q)|0;z=aa(k[j+(B<<2)>>2]|0,y)|0;E=n+D+E>>p;i[c+g>>0]=E>>>0<256?E:(E|0)>0?255:0;A=n+z+A>>p;i[c+B>>0]=A>>>0<256?A:(A|0)>0?255:0;B=g|2;A=aa((k[b+(B<<2)>>2]|0)+(k[a+(B<<2)>>2]|0)|0,q)|0;z=aa(k[j+(B<<2)>>2]|0,y)|0;E=g|3;D=aa((k[b+(E<<2)>>2]|0)+(k[a+(E<<2)>>2]|0)|0,q)|0;C=aa(k[j+(E<<2)>>2]|0,y)|0;A=n+z+A>>p;i[c+B>>0]=A>>>0<256?A:(A|0)>0?255:0;D=n+C+D>>p;i[c+E>>0]=D>>>0<256?D:(D|0)>0?255:0;g=g+4|0}while((g|0)<=(s|0));g=o}if((g|0)>=(f|0))break;b=h;a=e;do{E=aa((k[a+(g<<2)>>2]|0)+(k[b+(g<<2)>>2]|0)|0,q)|0;E=n+(aa(k[j+(g<<2)>>2]|0,y)|0)+E>>p;i[c+g>>0]=E>>>0<256?E:(E|0)>0?255:0;g=g+1|0}while((g|0)!=(f|0))}}while(0);if(!l)break;else c=c+d|0}return}function yja(a){a=a|0;ggb(a);return}function zja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Aja(a){a=a|0;ggb(a);return}function Bja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Cja(a){a=a|0;ggb(a);return}function Dja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Eja(a){a=a|0;ggb(a);return}function Fja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Gja(a){a=a|0;ggb(a);return}function Hja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Ija(a){a=a|0;ggb(a);return}function Jja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Kja(a){a=a|0;ggb(a);return}function Lja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Mja(a){a=a|0;ggb(a);return}function Nja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Oja(a){a=a|0;ggb(a);return}function Pja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Qja(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0;K=r;r=r+288|0;J=K+232|0;I=K+176|0;H=K+120|0;x=K+112|0;y=K+104|0;G=K+48|0;F=K+32|0;E=K+16|0;D=K;do if((k[d>>2]&2031616|0)==65536){o=k[d+4>>2]|0;k[J>>2]=k[o>>2];t=J+4|0;d=o+4|0;k[t>>2]=k[d>>2];B=J+8|0;k[B>>2]=k[o+8>>2];k[J+12>>2]=k[o+12>>2];k[J+16>>2]=k[o+16>>2];k[J+20>>2]=k[o+20>>2];k[J+24>>2]=k[o+24>>2];k[J+28>>2]=k[o+28>>2];k[J+32>>2]=k[o+32>>2];m=k[o+36>>2]|0;k[J+36>>2]=m;n=J+40|0;k[n>>2]=B;B=J+48|0;q=J+44|0;k[q>>2]=B;k[J+52>>2]=0;k[B>>2]=0;if(m|0){B=m+12|0;k[B>>2]=(k[B>>2]|0)+1}if((k[d>>2]|0)<3){A=k[o+44>>2]|0;B=k[q>>2]|0;k[B>>2]=k[A>>2];k[B+4>>2]=k[A+4>>2];break}k[t>>2]=0;x1(J,k[d>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[o+40>>2]|0;p=k[n>>2]|0;n=k[o+44>>2]|0;m=k[q>>2]|0;d=0;do{k[p+(d<<2)>>2]=k[s+(d<<2)>>2];k[m+(d<<2)>>2]=k[n+(d<<2)>>2];d=d+1|0}while((d|0)<(k[t>>2]|0))}}else Q1(J,d,-1);while(0);do if((k[e>>2]&2031616|0)==65536){p=k[e+4>>2]|0;k[I>>2]=k[p>>2];t=I+4|0;m=p+4|0;k[t>>2]=k[m>>2];B=I+8|0;k[B>>2]=k[p+8>>2];k[I+12>>2]=k[p+12>>2];k[I+16>>2]=k[p+16>>2];k[I+20>>2]=k[p+20>>2];k[I+24>>2]=k[p+24>>2];k[I+28>>2]=k[p+28>>2];k[I+32>>2]=k[p+32>>2];d=k[p+36>>2]|0;k[I+36>>2]=d;n=I+40|0;k[n>>2]=B;B=I+48|0;q=I+44|0;k[q>>2]=B;k[I+52>>2]=0;k[B>>2]=0;if(d|0){B=d+12|0;k[B>>2]=(k[B>>2]|0)+1}if((k[m>>2]|0)<3){A=k[p+44>>2]|0;B=k[q>>2]|0;k[B>>2]=k[A>>2];k[B+4>>2]=k[A+4>>2];break}k[t>>2]=0;x1(I,k[m>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[p+40>>2]|0;o=k[n>>2]|0;n=k[p+44>>2]|0;m=k[q>>2]|0;d=0;do{k[o+(d<<2)>>2]=k[s+(d<<2)>>2];k[m+(d<<2)>>2]=k[n+(d<<2)>>2];d=d+1|0}while((d|0)<(k[t>>2]|0))}}else Q1(I,e,-1);while(0);v=b&4095;w=c&4095;e=b&7;u=c&7;b=b>>>3&511;if((b|0)!=(c>>>3&511|0)){k[H>>2]=0;d=H+4|0;k[d>>2]=0;m=ZT(32)|0;k[m>>2]=1;o=m+4|0;k[H>>2]=o;k[d>>2]=25;i[m+29>>0]=0;n=254464;p=o+25|0;do{i[o>>0]=i[n>>0]|0;o=o+1|0;n=n+1|0}while((o|0)<(p|0));Y8(-215,H,254490,247404,3786);k[d>>2]=0;k[H>>2]=0;B=k[m>>2]|0;k[m>>2]=B+-1;if((B|0)==1)ggb(k[m+-4>>2]|0)}m=J+8|0;o=I+8|0;n=(k[o>>2]|0)+-1+(k[I+12>>2]|0)|0;d=k[f>>2]|0;if((d|0)<0){d=((k[m>>2]|0)+-1+(k[J+12>>2]|0)|0)/2|0;k[f>>2]=d}t=f+4|0;if((k[t>>2]|0)<0)k[t>>2]=(n|0)/2|0;k[H+8>>2]=0;k[H+12>>2]=0;k[H>>2]=16842752;k[H+4>>2]=J;s=(k[m>>2]|0)==1;k[x>>2]=s?d:0;k[x+4>>2]=s?0:d;s=rga(H,x)|0;k[H+8>>2]=0;k[H+12>>2]=0;k[H>>2]=16842752;k[H+4>>2]=I;A=(k[o>>2]|0)==1;q=k[t>>2]|0;k[y>>2]=A?q:0;k[y+4>>2]=A?0:q;q=rga(H,y)|0;k[H>>2]=1124007936;A=H+4|0;d=H+8|0;y=H+40|0;o=A;p=o+36|0;do{k[o>>2]=0;o=o+4|0}while((o|0)<(p|0));k[y>>2]=d;B=H+48|0;z=H+44|0;k[z>>2]=B;k[H+52>>2]=0;k[B>>2]=0;k[G>>2]=1124007936;x=G+4|0;d=G+8|0;c=G+40|0;o=x;p=o+36|0;do{k[o>>2]=0;o=o+4|0}while((o|0)<(p|0));k[c>>2]=d;p=G+48|0;o=G+44|0;k[o>>2]=p;k[G+52>>2]=0;k[p>>2]=0;d=e>>>0<u>>>0?u:e;d=(d|0)>5?d:5;do if(!e){m=(u|0)==0;if(!((s|0)==5&(q|0)==5&m)){if((s&3|0)==0|(q&3|0)==0){C=32;break}if(!((s&8&q|0)!=0&(u|0)==3)){C=32;break}}u=m?8:0;m=F+4|0;d=m+4|0;k[d>>2]=0;k[d+4>>2]=0;k[F>>2]=33619968;k[m>>2]=H;L=+(1<<u|0);SW(J,F,4,L,0.0);m=F+4|0;d=m+4|0;k[d>>2]=0;k[d+4>>2]=0;k[F>>2]=33619968;k[m>>2]=G;SW(I,F,4,L,0.0);u=u<<1;m=u;d=4;g=+(1<<u|0)*g}else C=32;while(0);do if((C|0)==32){if((k[J>>2]&4095|0)==(d|0))KG(H,J)|0;else{C=F+4|0;u=C+4|0;k[u>>2]=0;k[u+4>>2]=0;k[F>>2]=33619968;k[C>>2]=H;SW(J,F,d,1.0,0.0)}if((k[I>>2]&4095|0)==(d|0)){KG(G,I)|0;m=0;break}else{m=F+4|0;C=m+4|0;k[C>>2]=0;k[C+4>>2]=0;k[F>>2]=33619968;k[m>>2]=G;SW(I,F,d,1.0,0.0);m=0;break}}while(0);n=d&7|b<<3;k[E+8>>2]=0;k[E+12>>2]=0;k[E>>2]=16842752;k[E+4>>2]=H;sga(F,v,n,E,k[f>>2]|0,s);k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=G;Dha(E,n,w,D,k[t>>2]|0,q,g,m);while(1){d=fgb(200)|0;if(d|0){m=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){m=0;break}Qh[d&7]()}k[D>>2]=0;k[D+4>>2]=0;qga(m,D,F,E,v,w,n,h,j,l);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d+4>>2]=1;k[d>>2]=72040;k[d+8>>2]=m;k[a>>2]=d;k[a+4>>2]=m;d=k[E>>2]|0;if(d|0?(a=d+4|0,E=k[a>>2]|0,k[a>>2]=E+-1,(E|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=k[F>>2]|0;if(d|0?(E=d+4|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);n=G+36|0;d=k[n>>2]|0;if(d|0?(E=d+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){m=k[n>>2]|0;if(m|0){d=k[m+4>>2]|0;if(!d){d=k[G+32>>2]|0;if(!d){d=B1()|0;m=k[n>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,m)}k[n>>2]=0}k[n>>2]=0;G=G+16|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[x>>2]|0)>0){m=k[c>>2]|0;d=0;do{k[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[x>>2]|0))}d=k[o>>2]|0;if(!((d|0)==(p|0)|(d|0)==0))ggb(k[d+-4>>2]|0);n=H+36|0;d=k[n>>2]|0;if(d|0?(F=d+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){m=k[n>>2]|0;if(m|0){d=k[m+4>>2]|0;if(!d){d=k[H+32>>2]|0;if(!d){d=B1()|0;m=k[n>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,m)}k[n>>2]=0}k[n>>2]=0;H=H+16|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[A>>2]|0)>0){m=k[y>>2]|0;d=0;do{k[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[A>>2]|0))}d=k[z>>2]|0;if(!((d|0)==(B|0)|(d|0)==0))ggb(k[d+-4>>2]|0);n=I+36|0;d=k[n>>2]|0;if(d|0?(G=d+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){m=k[n>>2]|0;if(m|0){d=k[m+4>>2]|0;do if(!d){d=k[I+32>>2]|0;if(d|0)break;d=B1()|0;m=k[n>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,m)}k[n>>2]=0}k[n>>2]=0;H=I+16|0;m=I+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[m>>2]|0)>0){n=k[I+40>>2]|0;d=0;do{k[n+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[m>>2]|0))}d=k[I+44>>2]|0;if(!((d|0)==(I+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);n=J+36|0;d=k[n>>2]|0;if(d|0?(H=d+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){m=k[n>>2]|0;if(m|0){d=k[m+4>>2]|0;do if(!d){d=k[J+32>>2]|0;if(d|0)break;d=B1()|0;m=k[n>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,m)}k[n>>2]=0}k[n>>2]=0;I=J+16|0;m=J+4|0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[m>>2]|0)>0){n=k[J+40>>2]|0;d=0;do{k[n+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[m>>2]|0))}d=k[J+44>>2]|0;if((d|0)==(J+48|0)|(d|0)==0){r=K;return}ggb(k[d+-4>>2]|0);r=K;return}function Rja(a){a=a|0;ggb(a);return}function Sja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Tja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+16|0;f=w;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=a;m=o7(f)|0;q=k[a>>2]|0;m=(m|0)==0?1:m;v=q&65535;switch(v&4095){case 0:case 4:case 5:case 6:break;default:{d=f+4|0;e=ZT(76)|0;k[e>>2]=1;g=e+4|0;k[f>>2]=g;k[d>>2]=71;i[e+75>>0]=0;h=254590;j=g+71|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,f,254662,247404,3853);k[d>>2]=0;k[f>>2]=0;u=k[e>>2]|0;k[e>>2]=u+-1;if((u|0)==1)ggb(k[e+-4>>2]|0)}}d=b+4|0;g=k[d>>2]|0;f=k[b>>2]|0;e=g-f>>3;if(m>>>0<=e>>>0){if(m>>>0<e>>>0?(n=f+(m<<3)|0,(g|0)!=(n|0)):0)k[d>>2]=g+(~((g+-8-n|0)>>>3)<<3)}else Uja(b,m-e|0);d=aa((q>>>3&511)+1<<(47696>>>(q<<1&14)&3),m)|0;e=c+4|0;h=k[e>>2]|0;g=k[c>>2]|0;f=h-g|0;if(d>>>0<=f>>>0){if(d>>>0<f>>>0?(s=g+d|0,(h|0)!=(s|0)):0)k[e>>2]=s}else{T1(c,d-f|0);g=k[c>>2]|0}s=a+8|0;if((k[s>>2]|0)<=0){r=w;return}t=a+16|0;u=a+44|0;q=a+12|0;c=(v&4095)==0;n=0;e=0;d=k[q>>2]|0;do{m=(k[t>>2]|0)+(aa(k[k[u>>2]>>2]|0,n)|0)|0;a:do if((d|0)>0){if(c){h=0;while(1){f=i[m+h>>0]|0;if(f<<24>>24){d=k[b>>2]|0;k[d+(e<<3)>>2]=h;k[d+(e<<3)+4>>2]=n;i[g+e>>0]=f;e=e+1|0;d=k[q>>2]|0}h=h+1|0;if((h|0)>=(d|0))break a}}j=k[b>>2]|0;h=0;while(1){switch(v&4095){case 5:{l=+o[m+(h<<2)>>2];if(!(l==0.0)){k[j+(e<<3)>>2]=h;k[j+(e<<3)+4>>2]=n;o[g+(e<<2)>>2]=l;e=e+1|0}break}case 4:{f=k[m+(h<<2)>>2]|0;if(f){k[j+(e<<3)>>2]=h;k[j+(e<<3)+4>>2]=n;k[g+(e<<2)>>2]=f;e=e+1|0;d=k[q>>2]|0}break}default:{l=+p[m+(h<<3)>>3];if(!(l==0.0)){k[j+(e<<3)>>2]=h;k[j+(e<<3)+4>>2]=n;p[g+(e<<3)>>3]=l;e=e+1|0}}}h=h+1|0;if((h|0)>=(d|0))break a}}while(0);n=n+1|0}while((n|0)<(k[s>>2]|0));r=w;return}function Uja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+8|0;e=k[l>>2]|0;m=a+4|0;c=k[m>>2]|0;d=c;if(e-c>>3>>>0>=b>>>0){zpb(c|0,0,b<<3|0)|0;k[m>>2]=d+(b<<3);return}j=k[a>>2]|0;g=c-j>>3;c=g+b|0;if(c>>>0>536870911)ad(426534,426557,304,426811);i=j;h=e-j|0;f=h>>2;f=h>>3>>>0<268435455?(f>>>0<c>>>0?c:f):536870911;if(!f)e=0;else{if(f>>>0>536870911){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}e=f<<3;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=c}c=e+(g<<3)|0;h=e+(f<<3)|0;zpb(c|0,0,b<<3|0)|0;g=c+(b<<3)|0;if((d|0)!=(i|0)){f=d+-8|0;e=c;while(1){b=d;d=d+-8|0;k[e+-8>>2]=k[d>>2];k[e+-4>>2]=k[b+-4>>2];if((d|0)==(i|0))break;else e=e+-8|0}c=c+(~((f-j|0)>>>3)<<3)|0}k[a>>2]=c;k[m>>2]=g;k[l>>2]=h;if(!j)return;ggb(j);return}function Vja(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=r;r=r+144|0;t=P;H=P+120|0;O=P+64|0;N=P+8|0;do if((k[d>>2]&2031616|0)==65536){j=k[d+4>>2]|0;k[O>>2]=k[j>>2];q=O+4|0;d=j+4|0;k[q>>2]=k[d>>2];M=O+8|0;k[M>>2]=k[j+8>>2];k[O+12>>2]=k[j+12>>2];k[O+16>>2]=k[j+16>>2];k[O+20>>2]=k[j+20>>2];k[O+24>>2]=k[j+24>>2];k[O+28>>2]=k[j+28>>2];k[O+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[O+36>>2]=g;h=O+40|0;k[h>>2]=M;M=O+48|0;m=O+44|0;k[m>>2]=M;k[O+52>>2]=0;k[M>>2]=0;if(g|0){M=g+12|0;k[M>>2]=(k[M>>2]|0)+1}if((k[d>>2]|0)<3){M=k[j+44>>2]|0;n=k[m>>2]|0;k[n>>2]=k[M>>2];k[n+4>>2]=k[M+4>>2];n=O;break}k[q>>2]=0;x1(O,k[d>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;d=0;do{k[l+(d<<2)>>2]=k[n+(d<<2)>>2];k[g+(d<<2)>>2]=k[h+(d<<2)>>2];d=d+1|0}while((d|0)<(k[q>>2]|0));n=O}else n=O}else{Q1(O,d,-1);n=O}while(0);s=b&7;q=c&7;if(q>>>0<s>>>0|((c^b)&4088|0)!=0){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(52)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=44;i[g+48>>0]=0;E=254681;G=F+44|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254726,247404,4455);k[d>>2]=0;k[H>>2]=0;M=k[g>>2]|0;k[g>>2]=M+-1;if((M|0)==1)ggb(k[g+-4>>2]|0)}d=k[e>>2]|0;D=e+4|0;g=k[D>>2]|0;M=O+40|0;L=k[M>>2]|0;K=k[L+4>>2]|0;L=k[L>>2]|0;d=(d|0)==-1?(K|0)/2|0:d;g=(g|0)==-1?(L|0)/2|0:g;if(!((d|0)>-1&(d|0)<(K|0)?(g|0)>-1&(g|0)<(L|0):0)){k[H>>2]=0;h=H+4|0;k[h>>2]=0;j=ZT(60)|0;k[j>>2]=1;F=j+4|0;k[H>>2]=F;k[h>>2]=52;i[j+56>>0]=0;E=344955;G=F+52|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,345008,345024,363);k[h>>2]=0;k[H>>2]=0;L=k[j>>2]|0;k[j>>2]=L+-1;if((L|0)==1)ggb(k[j+-4>>2]|0)}k[e>>2]=d;k[D>>2]=g;l=(s|0)==6;m=(q|0)==6;g=l|m?6:5;k[N>>2]=1124007936;K=N+4|0;d=N+8|0;I=N+40|0;F=K;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[I>>2]=d;L=N+48|0;J=N+44|0;k[J>>2]=L;k[N+52>>2]=0;k[L>>2]=0;if((k[n>>2]&4095|0)==(g|0))KG(N,O)|0;else{G=H+4|0;F=G+4|0;k[F>>2]=0;k[F+4>>2]=0;k[H>>2]=33619968;k[G>>2]=N;SW(O,H,g,1.0,0.0)}d=(s|0)==0;do if(!((c|b)&7)){while(1){d=fgb(64)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72608;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;o[s+56>>2]=f;if((k[N>>2]&4095|0)!=5){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;if(d>>>0<=g>>>0){if(d>>>0<g>>>0?(u=h+(d<<2)|0,(j|0)!=(u|0)):0)k[q>>2]=j+(~((j+-4-u|0)>>>2)<<2)}else vaa(n,d-g|0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72060;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)==1)Uh[k[(k[d>>2]|0)+8>>2]&2047](d)}else{h=(q|0)==2;if(d&h){while(1){d=fgb(64)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72584;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;o[s+56>>2]=f;if((k[N>>2]&4095|0)!=5){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;if(d>>>0<=g>>>0){if(d>>>0<g>>>0?(v=h+(d<<2)|0,(j|0)!=(v|0)):0)k[q>>2]=j+(~((j+-4-v|0)>>>2)<<2)}else vaa(n,d-g|0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72080;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}j=(q|0)==3;if(d&j){while(1){d=fgb(64)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72560;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;o[s+56>>2]=f;if((k[N>>2]&4095|0)!=5){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;if(d>>>0<=g>>>0){if(d>>>0<g>>>0?(w=h+(d<<2)|0,(j|0)!=(w|0)):0)k[q>>2]=j+(~((j+-4-w|0)>>>2)<<2)}else vaa(n,d-g|0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72100;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}g=(q|0)==5;if(d&g){while(1){d=fgb(64)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72536;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;o[s+56>>2]=f;if((k[N>>2]&4095|0)!=5){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;if(d>>>0<=g>>>0){if(d>>>0<g>>>0?(x=h+(d<<2)|0,(j|0)!=(x|0)):0)k[q>>2]=j+(~((j+-4-x|0)>>>2)<<2)}else vaa(n,d-g|0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72120;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(d&m){while(1){d=fgb(72)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72512;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;p[s+56>>3]=f;if((k[N>>2]&4095|0)!=6){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;if(d>>>0<=g>>>0){if(d>>>0<g>>>0?(y=h+(d<<2)|0,(j|0)!=(y|0)):0)k[q>>2]=j+(~((j+-4-y|0)>>>2)<<2)}else vaa(n,d-g|0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72140;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}d=(s|0)==2;if(d&h){while(1){d=fgb(64)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72488;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;o[s+56>>2]=f;if((k[N>>2]&4095|0)!=5){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;if(d>>>0<=g>>>0){if(d>>>0<g>>>0?(z=h+(d<<2)|0,(j|0)!=(z|0)):0)k[q>>2]=j+(~((j+-4-z|0)>>>2)<<2)}else vaa(n,d-g|0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72160;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(d&g){while(1){d=fgb(64)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72464;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;o[s+56>>2]=f;if((k[N>>2]&4095|0)!=5){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;if(d>>>0<=g>>>0){if(d>>>0<g>>>0?(A=h+(d<<2)|0,(j|0)!=(A|0)):0)k[q>>2]=j+(~((j+-4-A|0)>>>2)<<2)}else vaa(n,d-g|0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72180;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(d&m){while(1){d=fgb(72)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72440;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;p[s+56>>3]=f;if((k[N>>2]&4095|0)!=6){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;if(d>>>0<=g>>>0){if(d>>>0<g>>>0?(B=h+(d<<2)|0,(j|0)!=(B|0)):0)k[q>>2]=j+(~((j+-4-B|0)>>>2)<<2)}else vaa(n,d-g|0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72200;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}d=(s|0)==3;if(d&j){while(1){d=fgb(64)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72416;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;o[s+56>>2]=f;if((k[N>>2]&4095|0)!=5){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;if(d>>>0<=g>>>0){if(d>>>0<g>>>0?(C=h+(d<<2)|0,(j|0)!=(C|0)):0)k[q>>2]=j+(~((j+-4-C|0)>>>2)<<2)}else vaa(n,d-g|0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72220;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(d&g){while(1){d=fgb(64)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72392;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;o[s+56>>2]=f;if((k[N>>2]&4095|0)!=5){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;do if(d>>>0<=g>>>0){if(d>>>0<g>>>0){d=h+(d<<2)|0;if((j|0)==(d|0))break;k[q>>2]=j+(~((j+-4-d|0)>>>2)<<2)}}else vaa(n,d-g|0);while(0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72240;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(d&m){while(1){d=fgb(72)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72368;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;p[s+56>>3]=f;if((k[N>>2]&4095|0)!=6){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;do if(d>>>0>g>>>0)vaa(n,d-g|0);else{if(d>>>0>=g>>>0)break;d=h+(d<<2)|0;if((j|0)==(d|0))break;k[q>>2]=j+(~((j+-4-d|0)>>>2)<<2)}while(0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72260;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if((s|0)==5&g){while(1){d=fgb(64)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72344;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;o[s+56>>2]=f;if((k[N>>2]&4095|0)!=5){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;do if(d>>>0>g>>>0)vaa(n,d-g|0);else{if(d>>>0>=g>>>0)break;d=h+(d<<2)|0;if((j|0)==(d|0))break;k[q>>2]=j+(~((j+-4-d|0)>>>2)<<2)}while(0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72280;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d);break}if(!(l&m)){k[t>>2]=b;k[t+4>>2]=c;$8(H,254742,t);Y8(-213,H,254726,247404,4520);d=k[H>>2]|0;k[H+4>>2]=0;k[H>>2]=0;do if(d|0){G=d+-4|0;H=k[G>>2]|0;k[G>>2]=H+-1;if((H|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[a>>2]=0;k[a+4>>2]=0;break}while(1){d=fgb(72)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}h=k[e>>2]|0;d=k[D>>2]|0;g=s+4|0;k[g>>2]=-1;k[g+4>>2]=-1;k[g+8>>2]=-1;k[s>>2]=72320;j=s+20|0;l=s+24|0;m=s+32|0;n=s+44|0;q=s+48|0;F=j;G=F+36|0;do{k[F>>2]=0;F=F+4|0}while((F|0)<(G|0));k[s+12>>2]=h;k[s+16>>2]=d;F=k[I>>2]|0;G=k[F>>2]|0;k[g>>2]=k[F+4>>2];k[s+8>>2]=G;p[s+56>>3]=f;if((k[N>>2]&4095|0)!=6){k[H>>2]=0;d=H+4|0;k[d>>2]=0;g=ZT(44)|0;k[g>>2]=1;F=g+4|0;k[H>>2]=F;k[d>>2]=36;i[g+40>>0]=0;E=254919;G=F+36|0;do{i[F>>0]=i[E>>0]|0;F=F+1|0;E=E+1|0}while((F|0)<(G|0));Y8(-215,H,254956,247404,3914);k[d>>2]=0;k[H>>2]=0;H=k[g>>2]|0;k[g>>2]=H+-1;if((H|0)==1)ggb(k[g+-4>>2]|0)}Tja(N,j,m);d=(k[l>>2]|0)-(k[j>>2]|0)>>3;j=k[q>>2]|0;h=k[n>>2]|0;g=j-h>>2;do if(d>>>0>g>>>0)vaa(n,d-g|0);else{if(d>>>0>=g>>>0)break;d=h+(d<<2)|0;if((j|0)==(d|0))break;k[q>>2]=j+(~((j+-4-d|0)>>>2)<<2)}while(0);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}H=d+4|0;k[H>>2]=1;k[d>>2]=72300;k[d+8>>2]=s;k[a>>2]=d;k[a+4>>2]=s;k[H>>2]=(k[H>>2]|0)+1;a=k[H>>2]|0;k[H>>2]=a+-1;if((a|0)!=1)break;Uh[k[(k[d>>2]|0)+8>>2]&2047](d)}while(0);h=N+36|0;d=k[h>>2]|0;if(d|0?(H=d+12|0,a=k[H>>2]|0,k[H>>2]=a+-1,(a|0)==1):0){g=k[h>>2]|0;if(g|0){d=k[g+4>>2]|0;if(!d){d=k[N+32>>2]|0;if(!d){d=B1()|0;g=k[h>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[h>>2]=0}k[h>>2]=0;N=N+16|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[K>>2]|0)>0){g=k[I>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[K>>2]|0))}d=k[J>>2]|0;if(!((d|0)==(L|0)|(d|0)==0))ggb(k[d+-4>>2]|0);h=O+36|0;d=k[h>>2]|0;if(d|0?(a=d+12|0,N=k[a>>2]|0,k[a>>2]=N+-1,(N|0)==1):0){g=k[h>>2]|0;if(g|0){d=k[g+4>>2]|0;if(!d){d=k[O+32>>2]|0;if(!d){d=B1()|0;g=k[h>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[h>>2]=0}k[h>>2]=0;N=O+16|0;h=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[h>>2]|0)>0){g=k[M>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[h>>2]|0))}d=k[O+44>>2]|0;if((d|0)==(O+48|0)|(d|0)==0){r=P;return}ggb(k[d+-4>>2]|0);r=P;return}function Wja(a){a=a|0;ggb(a);return}function Xja(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Yja(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72320;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function Zja(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72320;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function _ja(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;w=+p[a+56>>3];t=k[a+20>>2]|0;u=k[a+32>>2]|0;v=k[a+44>>2]|0;a=(k[a+24>>2]|0)-t|0;s=a>>3;r=aa(g,f)|0;if((e|0)<=0)return;m=(a|0)>0;n=r+-4|0;o=(r|0)<4;q=r&-4;while(1){if(m){a=0;do{f=(k[b+(k[t+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[t+(a<<3)>>2]|0,g)|0)<<3)|0;k[v+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(s|0))}a:do if(o)a=0;else{if(m)a=0;else{a=0;while(1){p[c+(a<<3)>>3]=w;p[c+((a|1)<<3)>>3]=w;p[c+((a|2)<<3)>>3]=w;p[c+((a|3)<<3)>>3]=w;a=a+4|0;if((a|0)>(n|0)){a=q;break a}}}do{h=w;i=w;j=w;l=w;f=0;do{x=(k[v+(f<<2)>>2]|0)+(a<<3)|0;y=+p[u+(f<<3)>>3];l=l+y*+p[x>>3];j=j+y*+p[x+8>>3];i=i+y*+p[x+16>>3];h=h+y*+p[x+24>>3];f=f+1|0}while((f|0)<(s|0));p[c+(a<<3)>>3]=l;p[c+((a|1)<<3)>>3]=j;p[c+((a|2)<<3)>>3]=i;p[c+((a|3)<<3)>>3]=h;a=a+4|0}while((a|0)<=(n|0));a=q}while(0);b:do if((a|0)<(r|0)){if(!m)while(1){p[c+(a<<3)>>3]=w;a=a+1|0;if((a|0)==(r|0))break b}do{h=w;f=0;do{h=h+ +p[u+(f<<3)>>3]*+p[(k[v+(f<<2)>>2]|0)+(a<<3)>>3];f=f+1|0}while((f|0)<(s|0));p[c+(a<<3)>>3]=h;a=a+1|0}while((a|0)!=(r|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function $ja(a){a=a|0;ggb(a);return}function aka(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function bka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72344;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function cka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72344;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function dka(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,l=0.0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;w=+o[a+56>>2];t=k[a+20>>2]|0;u=k[a+32>>2]|0;v=k[a+44>>2]|0;a=(k[a+24>>2]|0)-t|0;s=a>>3;r=aa(g,f)|0;if((e|0)<=0)return;m=(a|0)>0;n=r+-4|0;p=(r|0)<4;q=r&-4;while(1){if(m){a=0;do{f=(k[b+(k[t+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[t+(a<<3)>>2]|0,g)|0)<<2)|0;k[v+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(s|0))}a:do if(p)a=0;else{if(m)a=0;else{a=0;while(1){o[c+(a<<2)>>2]=w;o[c+((a|1)<<2)>>2]=w;o[c+((a|2)<<2)>>2]=w;o[c+((a|3)<<2)>>2]=w;a=a+4|0;if((a|0)>(n|0)){a=q;break a}}}do{h=w;i=w;j=w;l=w;f=0;do{x=(k[v+(f<<2)>>2]|0)+(a<<2)|0;y=+o[u+(f<<2)>>2];l=l+y*+o[x>>2];j=j+y*+o[x+4>>2];i=i+y*+o[x+8>>2];h=h+y*+o[x+12>>2];f=f+1|0}while((f|0)<(s|0));o[c+(a<<2)>>2]=l;o[c+((a|1)<<2)>>2]=j;o[c+((a|2)<<2)>>2]=i;o[c+((a|3)<<2)>>2]=h;a=a+4|0}while((a|0)<=(n|0));a=q}while(0);b:do if((a|0)<(r|0)){if(!m)while(1){o[c+(a<<2)>>2]=w;a=a+1|0;if((a|0)==(r|0))break b}do{h=w;f=0;do{h=h+ +o[u+(f<<2)>>2]*+o[(k[v+(f<<2)>>2]|0)+(a<<2)>>2];f=f+1|0}while((f|0)<(s|0));o[c+(a<<2)>>2]=h;a=a+1|0}while((a|0)!=(r|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function eka(a){a=a|0;ggb(a);return}function fka(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function gka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72368;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function hka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72368;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function ika(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0;x=+p[a+56>>3];u=k[a+20>>2]|0;v=k[a+32>>2]|0;w=k[a+44>>2]|0;a=(k[a+24>>2]|0)-u|0;t=a>>3;s=aa(g,f)|0;if((e|0)<=0)return;n=(a|0)>0;o=s+-4|0;q=(s|0)<4;r=s&-4;while(1){if(n){a=0;do{f=(k[b+(k[u+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[u+(a<<3)>>2]|0,g)|0)<<1)|0;k[w+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(t|0))}a:do if(q)a=0;else{if(n)a=0;else{a=0;while(1){p[c+(a<<3)>>3]=x;p[c+((a|1)<<3)>>3]=x;p[c+((a|2)<<3)>>3]=x;p[c+((a|3)<<3)>>3]=x;a=a+4|0;if((a|0)>(o|0)){a=r;break a}}}do{h=x;i=x;l=x;m=x;f=0;do{y=(k[w+(f<<2)>>2]|0)+(a<<1)|0;z=+p[v+(f<<3)>>3];m=m+z*+(j[y>>1]|0);l=l+z*+(j[y+2>>1]|0);i=i+z*+(j[y+4>>1]|0);h=h+z*+(j[y+6>>1]|0);f=f+1|0}while((f|0)<(t|0));p[c+(a<<3)>>3]=m;p[c+((a|1)<<3)>>3]=l;p[c+((a|2)<<3)>>3]=i;p[c+((a|3)<<3)>>3]=h;a=a+4|0}while((a|0)<=(o|0));a=r}while(0);b:do if((a|0)<(s|0)){if(!n)while(1){p[c+(a<<3)>>3]=x;a=a+1|0;if((a|0)==(s|0))break b}do{h=x;f=0;do{h=h+ +p[v+(f<<3)>>3]*+(j[(k[w+(f<<2)>>2]|0)+(a<<1)>>1]|0);f=f+1|0}while((f|0)<(t|0));p[c+(a<<3)>>3]=h;a=a+1|0}while((a|0)!=(s|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function jka(a){a=a|0;ggb(a);return}function kka(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}
function gKa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0,p=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0;D=r;r=r+32|0;z=D+16|0;B=D;e=ZT(12)|0;k[e>>2]=1;A=e+4|0;i[e+10>>0]=0;i[A>>0]=i[373823]|0;i[A+1>>0]=i[373824]|0;i[A+2>>0]=i[373825]|0;i[A+3>>0]=i[373826]|0;i[A+4>>0]=i[373827]|0;i[A+5>>0]=i[373828]|0;k[z>>2]=32;A=dIa(d,A,z)|0;v=k[e>>2]|0;k[e>>2]=v+-1;if((v|0)==1)ggb(k[e+-4>>2]|0);e=ZT(8)|0;k[e>>2]=1;v=e+4|0;i[e+7>>0]=0;i[v>>0]=i[374006]|0;i[v+1>>0]=i[374007]|0;i[v+2>>0]=i[374008]|0;o[z>>2]=0.0;C=+sJa(d,v,z)+1.0;v=k[e>>2]|0;k[e>>2]=v+-1;if((v|0)==1)ggb(k[e+-4>>2]|0);if((A|0)==-1){g=a+4|0;e=k[g>>2]|0;if((e|0)>1){e=k[41482]|0;d=(e|0)==0;a:do if((k[41497]|0)>-1){do if(d){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;d=k[41489]|0;k[41485]=d;k[41483]=d;e=d+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;break a}}else d=k[41483]|0;while(0);if((e-d|0)>>>0<68){ci[k[165948>>2]&255](165912,375043,68)|0;break}else{e=375043;f=d+68|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));k[41483]=(k[41483]|0)+68;break}}else{do if(d){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;d=k[41489]|0;k[41485]=d;k[41483]=d;e=d+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;break a}}else d=k[41483]|0;while(0);if((e-d|0)>>>0<68){ci[k[165948>>2]&255](165912,375043,68)|0;break}else{e=375043;f=d+68|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));k[41483]=(k[41483]|0)+68;break}}while(0);e=k[g>>2]|0}if((e|0)<=0){r=D;return}hKa(a,b,c,k[k[a+64>>2]>>2]|0,0.0,C);r=D;return}k[z>>2]=0;while(1){e=fgb(20)|0;if(e|0){u=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){u=0;break}Qh[e&7]()}g=a+48|0;e=k[g>>2]|0;k[u>>2]=0;v=u+4|0;k[v>>2]=0;h=u+8|0;k[h>>2]=0;k[u+12>>2]=e;if(e){if(e>>>0>536870911){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}f=e<<3;f=(f|0)==0?1:f;while(1){d=fgb(f)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}t=d;k[u>>2]=t;k[v>>2]=t;k[h>>2]=d+(e<<3);e=k[g>>2]|0}s=u+16|0;k[s>>2]=0;k[B>>2]=0;t=B+4|0;k[t>>2]=0;k[B+8>>2]=0;k[B+12>>2]=e;r4(B,(e>>>5)+1|0);e=k[B>>2]|0;d=(k[t>>2]|0)-e|0;if((d|0)>0){p=d>>2;zpb(e|0,0,((((p|0)<1?p:1)^1073741823)+p<<2)+8|0)|0}d=a+4|0;if((k[d>>2]|0)>0){f=a+64|0;e=0;do{iKa(a,b,c,k[(k[f>>2]|0)+(e<<2)>>2]|0,0.0,z,A,C,u,B);e=e+1|0}while((e|0)<(k[d>>2]|0))}while(1){if(!(k[s>>2]|0))break;n=k[u>>2]|0;p=k[n>>2]|0;q=+o[n+4>>2];e=k[v>>2]|0;m=e-n|0;d=m>>3;if(((m|0)>8?(w=e+-8|0,m=n,j=k[m>>2]|0,m=k[m+4>>2]|0,f=w,g=k[f+4>>2]|0,h=n,k[h>>2]=k[f>>2],k[h+4>>2]=g,w,k[w>>2]=j,k[w+4>>2]=m,w=d+-1|0,(d|0)!=2):0)?(m=d+-3|0,x=(m|0)/2|0,(m|0)>=-1):0){e=n+8|0;if((w|0)>2?+o[n+20>>2]<+o[n+12>>2]:0){d=2;e=n+16|0}else d=1;l=+o[n+4>>2];if(!(l<+o[e+4>>2])){m=k[n>>2]|0;j=n;while(1){h=j;j=e;f=j;g=k[f+4>>2]|0;k[h>>2]=k[f>>2];k[h+4>>2]=g;if((x|0)<(d|0))break;d=d<<1|1;g=n+(d<<3)|0;f=g;h=d+1|0;if((h|0)<(w|0)?(y=g+8|0,+o[y+4>>2]<+o[n+(d<<3)+4>>2]):0){d=h;f=y}if(l<+o[f+4>>2])break;else e=f}k[e>>2]=m;o[e+4>>2]=l}}k[v>>2]=(k[v>>2]|0)+-8;k[s>>2]=(k[s>>2]|0)+-1;if((k[z>>2]|0)>=(A|0)?Xh[k[(k[b>>2]|0)+8>>2]&1023](b)|0:0)break;iKa(a,b,c,p,q,z,A,C,u,B)}e=k[u>>2]|0;d=e;if(e|0){f=k[v>>2]|0;if((f|0)!=(e|0))k[v>>2]=f+(~((f+-8-d|0)>>>3)<<3);ggb(e)}ggb(u);e=k[B>>2]|0;d=e;if(e|0){f=k[t>>2]|0;if((f|0)!=(e|0))k[t>>2]=f+(~((f+-4-d|0)>>>2)<<2);ggb(e)}r=D;return}function hKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;var g=0,h=0,i=0,j=0,l=0,m=0,n=0.0,p=0.0;while(1){g=d+8|0;h=d+12|0;if((k[g>>2]|0)==0?(k[h>>2]|0)==0:0)break;p=+o[c+(k[d>>2]<<2)>>2]-+o[d+4>>2];m=p<0.0;d=k[(m?h:g)>>2]|0;n=e;e=e+ +P(+p);hKa(a,b,c,k[(m?g:h)>>2]|0,n,f);if(!(e*f<=+hg[k[(k[b>>2]|0)+16>>2]&127](b))){i=10;break}}if((i|0)==10)return;m=k[d>>2]|0;j=(k[a+32>>2]|0)+((aa(k[a+28>>2]|0,m)|0)<<2)|0;l=j+(k[a+52>>2]<<2)|0;i=l+-12|0;a=((i>>>0<j>>>0?j:i)+12+(3-j)|0)>>>4<<2;g=c+(a<<2)|0;if(j>>>0<i>>>0){h=j;d=c;e=0.0;while(1){f=+P(+(+o[h>>2]-+o[d>>2]));n=+P(+(+o[h+4>>2]-+o[d+4>>2]));p=+P(+(+o[h+8>>2]-+o[d+8>>2]));e=e+(f+n+p+ +P(+(+o[h+12>>2]-+o[d+12>>2])));h=h+16|0;if(h>>>0>=i>>>0)break;else d=d+16|0}}else e=0.0;d=j+(a<<2)|0;if(d>>>0<l>>>0)while(1){e=e+ +P(+(+o[d>>2]-+o[g>>2]));d=d+4|0;if(d>>>0>=l>>>0)break;else g=g+4|0}$f[k[(k[b>>2]|0)+12>>2]&15](b,e,m);return}function iKa(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;var l=0.0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;if(+hg[k[(k[b>>2]|0)+16>>2]&127](b)<e)return;n=d+8|0;p=d+12|0;if((k[n>>2]|0)==0?(k[p>>2]|0)==0:0){t=k[d>>2]|0;n=t>>>5;d=k[j>>2]|0;m=k[d+(n<<2)>>2]|0;p=1<<(t&31);if(m&p|0)return;do if((k[f>>2]|0)>=(g|0))if(Xh[k[(k[b>>2]|0)+8>>2]&1023](b)|0)return;else{m=k[j>>2]|0;d=m;m=k[m+(n<<2)>>2]|0;break}while(0);k[d+(n<<2)>>2]=m|p;k[f>>2]=(k[f>>2]|0)+1;r=(k[a+32>>2]|0)+((aa(k[a+28>>2]|0,t)|0)<<2)|0;s=r+(k[a+52>>2]<<2)|0;p=s+-12|0;q=((p>>>0<r>>>0?r:p)+12+(3-r)|0)>>>4<<2;d=c+(q<<2)|0;if(r>>>0<p>>>0){n=r;m=c;l=0.0;while(1){A=+P(+(+o[n>>2]-+o[m>>2]));e=+P(+(+o[n+4>>2]-+o[m+4>>2]));h=+P(+(+o[n+8>>2]-+o[m+8>>2]));l=l+(A+e+h+ +P(+(+o[n+12>>2]-+o[m+12>>2])));n=n+16|0;if(n>>>0>=p>>>0)break;else m=m+16|0}}else l=0.0;m=r+(q<<2)|0;if(m>>>0<s>>>0)while(1){l=l+ +P(+(+o[m>>2]-+o[d>>2]));m=m+4|0;if(m>>>0>=s>>>0)break;else d=d+4|0}$f[k[(k[b>>2]|0)+12>>2]&15](b,l,t);return}l=+o[c+(k[d>>2]<<2)>>2]-+o[d+4>>2];v=l<0.0;x=k[(v?n:p)>>2]|0;p=k[(v?p:n)>>2]|0;l=+P(+l)+e;if(!(!(l*h<+hg[k[(k[b>>2]|0)+16>>2]&127](b))?Xh[k[(k[b>>2]|0)+8>>2]&1023](b)|0:0))q=15;if((q|0)==15?(y=i+16|0,(k[y>>2]|0)!=(k[i+12>>2]|0)):0){v=i+4|0;d=k[v>>2]|0;t=i+8|0;u=k[t>>2]|0;n=u;if((d|0)==(u|0)){u=k[i>>2]|0;s=d-u|0;r=s>>3;d=r+1|0;if(d>>>0>536870911)ad(426534,426557,304,426811);n=n-u|0;q=n>>2;q=n>>3>>>0<268435455?(q>>>0<d>>>0?d:q):536870911;if(!q)n=0;else{if(q>>>0>536870911){b=te(4)|0;k[b>>2]=172664;Cf(b|0,28816,1287)}n=q<<3;n=(n|0)==0?1:n;while(1){d=fgb(n)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}n=d}d=n+(r<<3)|0;k[d>>2]=p;o[n+(r<<3)+4>>2]=l;p=d+8|0;d=d+(0-r<<3)|0;if((s|0)>0)upb(d|0,u|0,s|0)|0;k[i>>2]=d;k[v>>2]=p;k[t>>2]=n+(q<<3);if(!u)d=i;else{ggb(u);d=i;p=k[v>>2]|0}}else{k[d>>2]=p;o[d+4>>2]=l;p=(k[v>>2]|0)+8|0;k[v>>2]=p;d=i}d=k[d>>2]|0;n=p-d|0;if((n|0)>8?(m=((n>>3)+-2|0)/2|0,z=d,v=p,w=v+-8|0,A=+o[v+-4>>2],A<+o[z+(m<<3)+4>>2]):0){p=k[w>>2]|0;n=w;while(1){w=n;n=z+(m<<3)|0;u=n;v=k[u+4>>2]|0;k[w>>2]=k[u>>2];k[w+4>>2]=v;if(!m){m=0;break}d=(m+-1|0)/2|0;if(!(A<+o[z+(d<<3)+4>>2]))break;else m=d}k[n>>2]=p;o[z+(m<<3)+4>>2]=A}k[y>>2]=(k[y>>2]|0)+1}iKa(a,b,c,x,e,f,g,h,i,j);return}function jKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;g=a+68|0;h=a+88|0;j=a+72|0;l=a+76|0;m=a+84|0;while(1){e=k[g>>2]|0;a:do if((e|0)<16){k[h>>2]=(k[h>>2]|0)+e;d=fgb(8192)|0;if(d|0){k[d>>2]=k[j>>2];k[j>>2]=d;k[g>>2]=8188;d=d+4|0;k[l>>2]=d;e=8172;n=29;break}d=k[41482]|0;e=(d|0)==0;if((k[41497]|0)>-1){do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}else{do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}}else{d=k[l>>2]|0;e=e+-16|0;n=29}while(0);if((n|0)==29){n=0;k[l>>2]=d+16;k[g>>2]=e;k[m>>2]=(k[m>>2]|0)+16}k[c>>2]=d;if((_fb(d,16,1,b)|0)!=1){n=31;break}d=k[c>>2]|0;e=d+8|0;if(!(k[e>>2]|0))c=d;else{jKa(a,b,e);c=k[c>>2]|0}c=c+12|0;if(!(k[c>>2]|0)){n=35;break}}if((n|0)==31){n=te(44)|0;VHa(n,373124);Cf(n|0,19720,57)}else if((n|0)==35)return}function kKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=a+76|0;m=a+16|0;n=a+74|0;o=a+8|0;p=a+4|0;q=a+44|0;r=a+28|0;s=a+20|0;g=a+48|0;h=a+36|0;j=a+75|0;do{c=k[m>>2]|0;d=(c|0)==0;a:do if((k[l>>2]|0)>-1){do if(d){c=i[n>>0]|0;i[n>>0]=c+255|c;c=k[a>>2]|0;if(!(c&8)){k[o>>2]=0;k[p>>2]=0;d=k[q>>2]|0;k[r>>2]=d;k[s>>2]=d;c=d+(k[g>>2]|0)|0;k[m>>2]=c;break}else{k[a>>2]=c|32;break a}}else d=k[s>>2]|0;while(0);f=d;if((c-d|0)>>>0<16){ci[k[h>>2]&255](a,b,16)|0;break}b:do if((i[j>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=b;c=f;break b}c=d+-1|0;if((i[b+c>>0]|0)==10)break;else d=c}if((ci[k[h>>2]&255](a,b,d)|0)>>>0<d>>>0)break a;e=16-d|0;d=b+d|0;c=k[s>>2]|0}else{e=16;d=b;c=f}while(0);upb(c|0,d|0,e|0)|0;k[s>>2]=(k[s>>2]|0)+e}else{do if(d){c=i[n>>0]|0;i[n>>0]=c+255|c;c=k[a>>2]|0;if(!(c&8)){k[o>>2]=0;k[p>>2]=0;d=k[q>>2]|0;k[r>>2]=d;k[s>>2]=d;c=d+(k[g>>2]|0)|0;k[m>>2]=c;break}else{k[a>>2]=c|32;break a}}else d=k[s>>2]|0;while(0);f=d;if((c-d|0)>>>0<16){ci[k[h>>2]&255](a,b,16)|0;break}c:do if((i[j>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=b;c=f;break c}c=d+-1|0;if((i[b+c>>0]|0)==10)break;else d=c}if((ci[k[h>>2]&255](a,b,d)|0)>>>0<d>>>0)break a;e=16-d|0;d=b+d|0;c=k[s>>2]|0}else{e=16;d=b;c=f}while(0);upb(c|0,d|0,e|0)|0;k[s>>2]=(k[s>>2]|0)+e}while(0);c=k[b+8>>2]|0;if(c|0)kKa(a,c);b=k[b+12>>2]|0}while((b|0)!=0);return}function lKa(a){a=a|0;var b=0,c=0,d=0,e=0.0,f=0,g=0.0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0;z=a+12|0;if((k[z>>2]|0)<2){z=te(44)|0;VHa(z,373858);Cf(z|0,19720,57)}j=a+56|0;d=k[j>>2]|0;c=d>>>0>1073741823?-1:d<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}y=a+68|0;k[y>>2]=b;if(d|0){d=k[j>>2]|0;c=0;do{k[b+(c<<2)>>2]=c;c=c+1|0}while(c>>>0<d>>>0)}f=a+76|0;c=k[f>>2]|0;a:do if((c|0)<32){b=a+96|0;k[b>>2]=(k[b>>2]|0)+c;b=fgb(8192)|0;if(b|0){d=a+80|0;k[b>>2]=k[d>>2];k[d>>2]=b;k[f>>2]=8188;b=b+4|0;d=a+84|0;k[d>>2]=b;c=8156;h=36;break}b=k[41482]|0;c=(b|0)==0;if((k[41497]|0)>-1){do if(c){b=i[165986]|0;i[165986]=b+255|b;b=k[41478]|0;if(!(b&8)){k[41480]=0;k[41479]=0;c=k[41489]|0;k[41485]=c;k[41483]=c;b=c+(k[41490]|0)|0;k[41482]=b;break}else{k[41478]=b|32;b=0;break a}}else c=k[41483]|0;while(0);if((b-c|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;b=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){b=0;break}b=0;d=373857;c=k[41483]|0}else{b=27;d=373830}upb(c|0,d|0,b|0)|0;k[41483]=(k[41483]|0)+b;b=0;break}else{do if(c){b=i[165986]|0;i[165986]=b+255|b;b=k[41478]|0;if(!(b&8)){k[41480]=0;k[41479]=0;c=k[41489]|0;k[41485]=c;k[41483]=c;b=c+(k[41490]|0)|0;k[41482]=b;break}else{k[41478]=b|32;b=0;break a}}else c=k[41483]|0;while(0);if((b-c|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;b=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){b=0;break}b=0;d=373857;c=k[41483]|0}else{b=27;d=373830}upb(c|0,d|0,b|0)|0;k[41483]=(k[41483]|0)+b;b=0;break}}else{b=a+84|0;d=b;b=k[b>>2]|0;c=c+-32|0;h=36}while(0);if((h|0)==36){k[d>>2]=b+32;k[f>>2]=c;x=a+92|0;k[x>>2]=(k[x>>2]|0)+32}x=a+64|0;k[x>>2]=b;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;k[b+24>>2]=0;k[b+28>>2]=0;w=k[x>>2]|0;u=k[y>>2]|0;v=k[j>>2]|0;p=k[a+60>>2]|0;c=p>>>0>1073741823?-1:p<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}t=p<<2;r=a+100|0;k[r>>2]=(k[r>>2]|0)+t;zpb(b|0,0,t|0)|0;t=k[j>>2]|0;b:do if(!t)e=0.0;else{m=k[a+40>>2]|0;n=k[a+36>>2]|0;if(!p){f=0;e=0.0;while(1){d=m+((aa(n,k[u+(f<<2)>>2]|0)|0)<<2)|0;c=d+((d+12+(3-d)|0)>>>4<<2<<2)|0;if(c>>>0<d>>>0){g=0.0;do{g=g+ +P(+(+o[c>>2]));c=c+4|0}while(c>>>0<d>>>0)}else g=0.0;e=e+g;f=f+1|0;if((f|0)==(t|0))break b}}else{l=0;e=0.0}do{h=m+((aa(n,k[u+(l<<2)>>2]|0)|0)<<2)|0;c=0;do{r=b+(c<<2)|0;o[r>>2]=+o[h+(c<<2)>>2]+ +o[r>>2];c=c+1|0}while((c|0)!=(p|0));j=h+(p<<2)|0;d=j+-12|0;f=((d>>>0<h>>>0?h:d)+12+(3-h)|0)>>>4<<2;if(h>>>0<d>>>0){c=h;g=0.0;do{B=+P(+(+o[c>>2]));A=+P(+(+o[c+4>>2]));s=+P(+(+o[c+8>>2]));g=g+(B+A+s+ +P(+(+o[c+12>>2])));c=c+16|0}while(c>>>0<d>>>0)}else g=0.0;c=h+(f<<2)|0;if(c>>>0<j>>>0)do{g=g+ +P(+(+o[c>>2]));c=c+4|0}while(c>>>0<j>>>0);e=e+g;l=l+1|0}while((l|0)!=(t|0))}while(0);g=+(t>>>0);if(!p)c=0;else{c=0;do{r=b+(c<<2)|0;o[r>>2]=+o[r>>2]/g;c=c+1|0}while((c|0)!=(p|0));c=p}g=e/g;h=b+(c<<2)|0;d=h+-12|0;j=3-b|0;f=((d>>>0<b>>>0?b:d)+12+j|0)>>>4<<2;if(b>>>0<d>>>0){c=b;e=0.0;do{s=+P(+(+o[c>>2]));A=+P(+(+o[c+4>>2]));B=+P(+(+o[c+8>>2]));e=e+(s+A+B+ +P(+(+o[c+12>>2])));c=c+16|0}while(c>>>0<d>>>0)}else e=0.0;c=b+(f<<2)|0;if(c>>>0<h>>>0)do{e=e+ +P(+(+o[c>>2]));c=c+4|0}while(c>>>0<h>>>0);s=g-e;if((v|0)<=0){B=0.0;v=w+12|0;o[v>>2]=s;v=w+4|0;o[v>>2]=B;k[w>>2]=b;x=k[x>>2]|0;y=k[y>>2]|0;z=k[z>>2]|0;CKa(a,x,y,t,z,0);return}q=k[a+40>>2]|0;r=k[a+36>>2]|0;p=b+(p<<2)|0;l=p+-12|0;m=((l>>>0<b>>>0?b:l)+12+j|0)>>>4<<2;n=b+(m<<2)|0;j=n>>>0<p>>>0;if(b>>>0<l>>>0){e=0.0;h=0}else{if(j){e=0.0;f=0}else{B=0.0;v=w+12|0;o[v>>2]=s;v=w+4|0;o[v>>2]=B;k[w>>2]=b;x=k[x>>2]|0;y=k[y>>2]|0;z=k[z>>2]|0;CKa(a,x,y,t,z,0);return}do{c=q+((aa(r,k[u+(f<<2)>>2]|0)|0)<<2)+(m<<2)|0;g=0.0;d=n;while(1){l=d;d=d+4|0;g=g+ +P(+(+o[l>>2]-+o[c>>2]));if(d>>>0>=p>>>0)break;else c=c+4|0}e=g>e?g:e;f=f+1|0}while((f|0)!=(v|0));v=w+12|0;o[v>>2]=s;v=w+4|0;o[v>>2]=e;k[w>>2]=b;x=k[x>>2]|0;y=k[y>>2]|0;z=k[z>>2]|0;CKa(a,x,y,t,z,0);return}do{f=q+((aa(r,k[u+(h<<2)>>2]|0)|0)<<2)|0;c=b;d=f;g=0.0;while(1){C=+P(+(+o[c>>2]-+o[d>>2]));A=+P(+(+o[c+4>>2]-+o[d+4>>2]));B=+P(+(+o[c+8>>2]-+o[d+8>>2]));g=g+(C+A+B+ +P(+(+o[c+12>>2]-+o[d+12>>2])));c=c+16|0;if(c>>>0>=l>>>0)break;else d=d+16|0}if(j){d=f+(m<<2)|0;c=n;while(1){g=g+ +P(+(+o[c>>2]-+o[d>>2]));c=c+4|0;if(c>>>0>=p>>>0)break;else d=d+4|0}}e=g>e?g:e;h=h+1|0}while((h|0)!=(v|0));v=w+12|0;o[v>>2]=s;v=w+4|0;o[v>>2]=e;k[w>>2]=b;x=k[x>>2]|0;y=k[y>>2]|0;z=k[z>>2]|0;CKa(a,x,y,t,z,0);return}function mKa(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[b>>2]|0;if(c|0)ggb(c);c=b+20|0;b=k[c>>2]|0;if(!b)return;d=a+12|0;if((k[d>>2]|0)<=0)return;mKa(a,k[b>>2]|0);if((k[d>>2]|0)>1)b=1;else return;do{mKa(a,k[(k[c>>2]|0)+(b<<2)>>2]|0);b=b+1|0}while((b|0)<(k[d>>2]|0));return}function nKa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=93720;b=k[a+64>>2]|0;if(b|0)mKa(a,b);b=k[a+68>>2]|0;if(b|0)ggb(b);c=a+80|0;b=k[c>>2]|0;if(b|0)do{d=b;b=k[b>>2]|0;ggb(d);k[c>>2]=b}while((b|0)!=0);YHa(k[a+48>>2]|0);return}function oKa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=93720;b=k[a+64>>2]|0;if(b|0)mKa(a,b);b=k[a+68>>2]|0;if(b|0)ggb(b);c=a+80|0;b=k[c>>2]|0;if(b|0)do{d=b;b=k[b>>2]|0;ggb(d);k[c>>2]=b}while((b|0)!=0);YHa(k[a+48>>2]|0);ggb(a);return}function pKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;h=a+12|0;j=b+76|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}b:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break b}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;f=k[b+44>>2]|0;k[b+28>>2]=f;g=b+20|0;k[g>>2]=f;d=f+(k[b+48>>2]|0)|0;k[e>>2]=d;e=f;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;d=c;g=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}c:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;d=h;break c}d=e+-1|0;if((i[h+d>>0]|0)==10)break;else e=d}if((ci[k[b+36>>2]&255](b,h,e)|0)>>>0<e>>>0)break a;f=4-e|0;d=h+e|0;c=k[g>>2]|0}else{f=4;d=h}while(0);upb(c|0,d|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f}while(0);h=a+16|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;d:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}e:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break e}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}f:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break f}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+100|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;g:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}h:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break h}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}i:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break i}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+24|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;j:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}k:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break k}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}l:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break l}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);d=k[a+68>>2]|0;h=k[a+56>>2]<<2;f=b+16|0;e=k[f>>2]|0;c=(e|0)==0;if((k[j>>2]|0)>-1){do if(c){c=b+74|0;j=i[c>>0]|0;i[c>>0]=j+255|j;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;j=k[b+44>>2]|0;k[b+28>>2]=j;g=b+20|0;k[g>>2]=j;e=j+(k[b+48>>2]|0)|0;k[f>>2]=e;f=j;break}k[b>>2]=c|32;j=a+64|0;j=k[j>>2]|0;BKa(a,b,j);return}else{f=b+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;j=a+64|0;j=k[j>>2]|0;BKa(a,b,j);return}m:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break m}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0){j=a+64|0;j=k[j>>2]|0;BKa(a,b,j);return}else{e=h-f|0;d=d+f|0;c=k[g>>2]|0;break}}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e;j=a+64|0;j=k[j>>2]|0;BKa(a,b,j);return}else{do if(c){c=b+74|0;j=i[c>>0]|0;i[c>>0]=j+255|j;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;j=k[b+44>>2]|0;k[b+28>>2]=j;g=b+20|0;k[g>>2]=j;e=j+(k[b+48>>2]|0)|0;k[f>>2]=e;f=j;break}k[b>>2]=c|32;j=a+64|0;j=k[j>>2]|0;BKa(a,b,j);return}else{f=b+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;j=a+64|0;j=k[j>>2]|0;BKa(a,b,j);return}n:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break n}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0){j=a+64|0;j=k[j>>2]|0;BKa(a,b,j);return}else{e=h-f|0;d=d+f|0;c=k[g>>2]|0;break}}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e;j=a+64|0;j=k[j>>2]|0;BKa(a,b,j);return}}function qKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o+8|0;h=o;j=a+12|0;if((_fb(j,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}l=a+16|0;if((_fb(l,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}if((_fb(a+100|0,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}m=a+24|0;if((_fb(m,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}f=a+68|0;c=k[f>>2]|0;if(c|0)ggb(c);e=k[a+56>>2]|0;d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[f>>2]=c;if((_fb(c,4,e,b)|0)!=(e|0)){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}c=a+64|0;d=k[c>>2]|0;if(d|0)mKa(a,d);AKa(a,b,c);g=a+44|0;c=n+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373358;b=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(b|0));f=WHa(g,n)|0;e=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[h>>2]=e;e=k[f>>2]|0;b=f+4|0;jh[k[k[e>>2]>>2]&1023](e,b);k[f>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,h,b);k[c>>2]=0;k[n>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);c=n+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373742;b=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(b|0));b=WHa(g,n)|0;f=k[b>>2]|0;h=b+4|0;jh[k[k[f>>2]>>2]&1023](f,h);k[b>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,j,h);k[c>>2]=0;k[n>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);c=n+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=10;i[d+14>>0]=0;f=375191;b=e+10|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(b|0));h=WHa(g,n)|0;b=k[h>>2]|0;j=h+4|0;jh[k[k[b>>2]>>2]&1023](b,j);k[h>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,l,j);k[c>>2]=0;k[n>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0);c=n+4|0;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=12;i[d+16>>0]=0;f=373752;b=e+12|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(b|0));j=WHa(g,n)|0;h=k[j>>2]|0;l=j+4|0;jh[k[k[h>>2]>>2]&1023](h,l);k[j>>2]=428728;Ph[k[(k[107182]|0)+4>>2]&511](428728,a+20|0,l);k[c>>2]=0;k[n>>2]=0;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)==1)ggb(k[d+-4>>2]|0);a=n+4|0;c=ZT(16)|0;k[c>>2]=1;j=c+4|0;k[n>>2]=j;k[a>>2]=8;i[c+12>>0]=0;h=j;i[h>>0]=99;i[h+1>>0]=98;i[h+2>>0]=95;i[h+3>>0]=105;j=j+4|0;i[j>>0]=110;i[j+1>>0]=100;i[j+2>>0]=101;i[j+3>>0]=120;j=WHa(g,n)|0;h=k[j>>2]|0;l=j+4|0;jh[k[k[h>>2]>>2]&1023](h,l);k[j>>2]=428716;Ph[k[(k[107179]|0)+4>>2]&511](428716,m,l);k[a>>2]=0;k[n>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)!=1){r=o;return}ggb(k[c+-4>>2]|0);r=o;return}function rKa(a){a=a|0;return k[a+56>>2]|0}function sKa(a){a=a|0;return k[a+60>>2]|0}function tKa(a){a=a|0;return (k[a+96>>2]|0)+(k[a+92>>2]|0)+(k[a+100>>2]|0)|0}function uKa(a){a=a|0;return 2}function vKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+44>>2]|0;f=b+48|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function wKa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;m=o+8|0;n=o;e=ZT(12)|0;k[e>>2]=1;l=e+4|0;i[e+10>>0]=0;i[l>>0]=i[373823]|0;i[l+1>>0]=i[373824]|0;i[l+2>>0]=i[373825]|0;i[l+3>>0]=i[373826]|0;i[l+4>>0]=i[373827]|0;i[l+5>>0]=i[373828]|0;k[m>>2]=32;l=dIa(d,l,m)|0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);if((l|0)==-1){xKa(a,k[a+64>>2]|0,b,c);r=o;return}while(1){d=fgb(20)|0;if(d|0){h=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){h=0;break}Qh[d&7]()}f=k[a+56>>2]|0;k[h>>2]=0;j=h+4|0;k[j>>2]=0;g=h+8|0;k[g>>2]=0;k[h+12>>2]=f;if(f|0){if(f>>>0>536870911){o=te(4)|0;k[o>>2]=172664;Cf(o|0,28816,1287)}e=f<<3;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d;k[h>>2]=e;k[j>>2]=e;k[g>>2]=d+(f<<3)}k[h+16>>2]=0;k[m>>2]=0;yKa(a,k[a+64>>2]|0,b,c,m,l,h);a:do if(zKa(h,n)|0)do{if((k[m>>2]|0)>=(l|0)?Xh[k[(k[b>>2]|0)+8>>2]&1023](b)|0:0)break a;yKa(a,k[n>>2]|0,b,c,m,l,h)}while(zKa(h,n)|0);while(0);d=k[h>>2]|0;e=d;if(d|0){f=k[j>>2]|0;if((f|0)!=(d|0))k[j>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(d)}ggb(h);r=o;return}function xKa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0;f=k[b>>2]|0;t=a+60|0;l=d+(k[t>>2]<<2)|0;i=l+-12|0;s=3-d|0;j=((i>>>0<d>>>0?d:i)+12+s|0)>>>4<<2;g=f+(j<<2)|0;if(i>>>0>d>>>0){h=d;e=0.0;while(1){w=+P(+(+o[h>>2]-+o[f>>2]));v=+P(+(+o[h+4>>2]-+o[f+4>>2]));u=+P(+(+o[h+8>>2]-+o[f+8>>2]));e=e+(w+v+u+ +P(+(+o[h+12>>2]-+o[f+12>>2])));h=h+16|0;if(h>>>0>=i>>>0)break;else f=f+16|0}}else e=0.0;f=d+(j<<2)|0;if(f>>>0<l>>>0)while(1){e=e+ +P(+(+o[f>>2]-+o[g>>2]));f=f+4|0;if(f>>>0>=l>>>0)break;else g=g+4|0}v=+o[b+4>>2];w=+hg[k[(k[c>>2]|0)+16>>2]&127](c);u=e-v-w;if(!(u>0.0?!(u*u-v*4.0*w>0.0):1))return;r=b+20|0;if(!(k[r>>2]|0)){s=b+16|0;if((k[s>>2]|0)<=0)return;q=b+24|0;r=a+40|0;n=a+36|0;m=0;do{p=k[(k[q>>2]|0)+(m<<2)>>2]|0;j=(k[r>>2]|0)+((aa(k[n>>2]|0,p)|0)<<2)|0;b=j+(k[t>>2]<<2)|0;i=b+-12|0;l=((i>>>0<j>>>0?j:i)+12+(3-j)|0)>>>4<<2;g=d+(l<<2)|0;if(j>>>0<i>>>0){f=j;h=d;e=0.0;while(1){u=+P(+(+o[f>>2]-+o[h>>2]));v=+P(+(+o[f+4>>2]-+o[h+4>>2]));w=+P(+(+o[f+8>>2]-+o[h+8>>2]));e=e+(u+v+w+ +P(+(+o[f+12>>2]-+o[h+12>>2])));f=f+16|0;if(f>>>0>=i>>>0)break;else h=h+16|0}}else e=0.0;f=j+(l<<2)|0;if(f>>>0<b>>>0)while(1){e=e+ +P(+(+o[f>>2]-+o[g>>2]));f=f+4|0;if(f>>>0>=b>>>0)break;else g=g+4|0}$f[k[(k[c>>2]|0)+12>>2]&15](c,e,p);m=m+1|0}while((m|0)<(k[s>>2]|0));return}q=a+12|0;g=k[q>>2]|0;g=g>>>0>1073741823?-1:g<<2;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0){p=f;break}f=k[207666]|0;k[207666]=f+0;if(!f){p=0;break}Qh[f&7]()}h=k[q>>2]|0;g=h>>>0>1073741823?-1:h<<2;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}if((h|0)>0){n=k[r>>2]|0;m=0;do{g=k[k[n+(m<<2)>>2]>>2]|0;b=d+(k[t>>2]<<2)|0;j=b+-12|0;l=((j>>>0<d>>>0?d:j)+12+s|0)>>>4<<2;h=g+(l<<2)|0;if(j>>>0>d>>>0){i=d;e=0.0;while(1){u=+P(+(+o[i>>2]-+o[g>>2]));v=+P(+(+o[i+4>>2]-+o[g+4>>2]));w=+P(+(+o[i+8>>2]-+o[g+8>>2]));e=e+(u+v+w+ +P(+(+o[i+12>>2]-+o[g+12>>2])));i=i+16|0;if(i>>>0>=j>>>0)break;else g=g+16|0}}else e=0.0;g=d+(l<<2)|0;if(g>>>0<b>>>0)while(1){e=e+ +P(+(+o[g>>2]-+o[h>>2]));g=g+4|0;if(g>>>0>=b>>>0)break;else h=h+4|0}h=0;while(1){i=f+(h<<2)|0;g=(h|0)<(m|0);if(g&+o[i>>2]<e)h=h+1|0;else break}if(g){g=m;do{b=g;g=g+-1|0;k[f+(b<<2)>>2]=k[f+(g<<2)>>2];k[p+(b<<2)>>2]=k[p+(g<<2)>>2]}while((g|0)>(h|0))}o[i>>2]=e;k[p+(h<<2)>>2]=m;m=m+1|0}while((m|0)<(k[q>>2]|0))}ggb(f);if((k[q>>2]|0)>0){f=0;do{xKa(a,k[(k[r>>2]|0)+(k[p+(f<<2)>>2]<<2)>>2]|0,c,d);f=f+1|0}while((f|0)<(k[q>>2]|0))}ggb(p);return}function yKa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0.0,M=0.0,N=0.0;K=a+60|0;J=3-d|0;x=a+12|0;y=a+24|0;z=g+16|0;A=g+12|0;B=g+4|0;C=g+8|0;p=b;a:while(1){b=k[p>>2]|0;n=d+(k[K>>2]<<2)|0;l=n+-12|0;m=((l>>>0<d>>>0?d:l)+12+J|0)>>>4<<2;i=b+(m<<2)|0;if(l>>>0>d>>>0){j=d;h=0.0;while(1){N=+P(+(+o[j>>2]-+o[b>>2]));M=+P(+(+o[j+4>>2]-+o[b+4>>2]));L=+P(+(+o[j+8>>2]-+o[b+8>>2]));h=h+(N+M+L+ +P(+(+o[j+12>>2]-+o[b+12>>2])));j=j+16|0;if(j>>>0>=l>>>0)break;else b=b+16|0}}else h=0.0;b=d+(m<<2)|0;if(b>>>0<n>>>0)while(1){h=h+ +P(+(+o[b>>2]-+o[i>>2]));b=b+4|0;if(b>>>0>=n>>>0)break;else i=i+4|0}M=+o[p+4>>2];N=+hg[k[(k[c>>2]|0)+16>>2]&127](c);L=h-M-N;if(!(L>0.0?!(L*L-M*4.0*N>0.0):1)){b=67;break}w=p+20|0;if(!(k[w>>2]|0)){b=8;break}i=k[x>>2]|0;i=i>>>0>1073741823?-1:i<<2;i=(i|0)==0?1:i;while(1){b=fgb(i)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}t=k[w>>2]|0;i=k[k[t>>2]>>2]|0;u=d+(k[K>>2]<<2)|0;r=u+-12|0;v=((r>>>0<d>>>0?d:r)+12+J|0)>>>4<<2;l=i+(v<<2)|0;m=r>>>0>d>>>0;if(m){j=d;h=0.0;while(1){L=+P(+(+o[j>>2]-+o[i>>2]));M=+P(+(+o[j+4>>2]-+o[i+4>>2]));N=+P(+(+o[j+8>>2]-+o[i+8>>2]));h=h+(L+M+N+ +P(+(+o[j+12>>2]-+o[i+12>>2])));j=j+16|0;if(j>>>0>=r>>>0)break;else i=i+16|0}}else h=0.0;s=d+(v<<2)|0;q=s>>>0<u>>>0;if(q){j=l;i=s;while(1){h=h+ +P(+(+o[i>>2]-+o[j>>2]));i=i+4|0;if(i>>>0>=u>>>0)break;else j=j+4|0}}o[b>>2]=h;j=k[x>>2]|0;b:do if((j|0)>1){if(m){p=1;i=0}else{if(q){n=1;i=0}else{l=1;i=0;while(1){o[b+(l<<2)>>2]=0.0;i=+o[b+(i<<2)>>2]>0.0?l:i;l=l+1|0;if((l|0)==(j|0))break b}}while(1){l=(k[k[t+(n<<2)>>2]>>2]|0)+(v<<2)|0;h=0.0;m=s;while(1){r=m;m=m+4|0;h=h+ +P(+(+o[r>>2]-+o[l>>2]));if(m>>>0>=u>>>0)break;else l=l+4|0}o[b+(n<<2)>>2]=h;i=h<+o[b+(i<<2)>>2]?n:i;n=n+1|0;if((n|0)==(j|0))break b}}do{n=k[k[t+(p<<2)>>2]>>2]|0;l=d;m=n;h=0.0;while(1){L=+P(+(+o[l>>2]-+o[m>>2]));M=+P(+(+o[l+4>>2]-+o[m+4>>2]));N=+P(+(+o[l+8>>2]-+o[m+8>>2]));h=h+(L+M+N+ +P(+(+o[l+12>>2]-+o[m+12>>2])));l=l+16|0;if(l>>>0>=r>>>0)break;else m=m+16|0}if(q){m=n+(v<<2)|0;l=s;while(1){h=h+ +P(+(+o[l>>2]-+o[m>>2]));l=l+4|0;if(l>>>0>=u>>>0)break;else m=m+4|0}}o[b+(p<<2)>>2]=h;i=h<+o[b+(i<<2)>>2]?p:i;p=p+1|0}while((p|0)!=(j|0))}else i=0;while(0);if((j|0)>0){s=0;do{if((s|0)!=(i|0)?(E=k[(k[w>>2]|0)+(s<<2)>>2]|0,v=b+(s<<2)|0,D=+o[v>>2]-+o[y>>2]*+o[E+12>>2],o[v>>2]=D,E,(k[z>>2]|0)!=(k[A>>2]|0)):0){j=k[B>>2]|0;v=k[C>>2]|0;l=v;if((j|0)==(v|0)){r=k[g>>2]|0;q=j-r|0;p=q>>3;j=p+1|0;if(j>>>0>536870911){b=45;break a}v=l-r|0;n=v>>2;n=v>>3>>>0<268435455?(n>>>0<j>>>0?j:n):536870911;if(!n)j=0;else{if(n>>>0>536870911){b=48;break a}l=n<<3;l=(l|0)==0?1:l;while(1){j=fgb(l)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}}l=j+(p<<3)|0;k[l>>2]=E;o[j+(p<<3)+4>>2]=D;m=l+8|0;l=l+(0-p<<3)|0;if((q|0)>0)upb(l|0,r|0,q|0)|0;k[g>>2]=l;k[B>>2]=m;k[C>>2]=j+(n<<3);if(r){ggb(r);m=k[B>>2]|0}}else{k[j>>2]=E;o[j+4>>2]=D;m=(k[B>>2]|0)+8|0;k[B>>2]=m}j=k[g>>2]|0;l=m-j|0;if((l|0)>8?(F=((l>>3)+-2|0)/2|0,G=j,v=m,H=v+-8|0,I=+o[v+-4>>2],I<+o[G+(F<<3)+4>>2]):0){n=k[H>>2]|0;m=H;j=F;while(1){v=m;m=G+(j<<3)|0;t=m;u=k[t+4>>2]|0;k[v>>2]=k[t>>2];k[v+4>>2]=u;if(!j){j=0;break}l=(j+-1|0)/2|0;if(!(I<+o[G+(l<<3)+4>>2]))break;else j=l}k[m>>2]=n;o[G+(j<<3)+4>>2]=I}k[z>>2]=(k[z>>2]|0)+1;j=k[x>>2]|0}s=s+1|0}while((s|0)<(j|0))}ggb(b);p=k[(k[w>>2]|0)+(i<<2)>>2]|0}if((b|0)==8){b=k[e>>2]|0;do if((b|0)>=(f|0))if(Xh[k[(k[c>>2]|0)+8>>2]&1023](c)|0)return;else{b=k[e>>2]|0;break}while(0);v=p+16|0;k[e>>2]=b+(k[v>>2]|0);if((k[v>>2]|0)<=0)return;t=p+24|0;u=a+40|0;r=a+36|0;q=0;do{s=k[(k[t>>2]|0)+(q<<2)>>2]|0;n=(k[u>>2]|0)+((aa(k[r>>2]|0,s)|0)<<2)|0;p=n+(k[K>>2]<<2)|0;l=p+-12|0;m=((l>>>0<n>>>0?n:l)+12+(3-n)|0)>>>4<<2;i=d+(m<<2)|0;if(n>>>0<l>>>0){b=n;j=d;h=0.0;while(1){L=+P(+(+o[b>>2]-+o[j>>2]));M=+P(+(+o[b+4>>2]-+o[j+4>>2]));N=+P(+(+o[b+8>>2]-+o[j+8>>2]));h=h+(L+M+N+ +P(+(+o[b+12>>2]-+o[j+12>>2])));b=b+16|0;if(b>>>0>=l>>>0)break;else j=j+16|0}}else h=0.0;b=n+(m<<2)|0;if(b>>>0<p>>>0)while(1){h=h+ +P(+(+o[b>>2]-+o[i>>2]));b=b+4|0;if(b>>>0>=p>>>0)break;else i=i+4|0}$f[k[(k[c>>2]|0)+12>>2]&15](c,h,s);q=q+1|0}while((q|0)<(k[v>>2]|0));return}else if((b|0)==45)ad(426534,426557,304,426811);else if((b|0)==48){K=te(4)|0;k[K>>2]=172664;Cf(K|0,28816,1287)}else if((b|0)==67)return}function zKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0.0,i=0,j=0,l=0,m=0,n=0,p=0,q=0;j=a+16|0;if(!(k[j>>2]|0)){q=0;return q|0}g=k[a>>2]|0;i=k[g+4>>2]|0;c=b;k[c>>2]=k[g>>2];k[c+4>>2]=i;c=k[a>>2]|0;i=a+4|0;b=k[i>>2]|0;g=b-c|0;a=g>>3;if(((g|0)>8?(l=c,m=b+-8|0,n=l,g=k[n>>2]|0,n=k[n+4>>2]|0,d=m,e=k[d+4>>2]|0,f=l,k[f>>2]=k[d>>2],k[f+4>>2]=e,m,k[m>>2]=g,k[m+4>>2]=n,m=a+-1|0,n=c,(a|0)!=2):0)?(g=a+-3|0,p=(g|0)/2|0,(g|0)>=-1):0){b=l+8|0;if((m|0)>2?+o[n+20>>2]<+o[n+12>>2]:0){a=2;b=l+16|0}else a=1;h=+o[n+4>>2];if(!(h<+o[b+4>>2])){g=k[c>>2]|0;f=l;while(1){e=f;f=b;c=f;d=k[c+4>>2]|0;k[e>>2]=k[c>>2];k[e+4>>2]=d;if((p|0)<(a|0))break;a=a<<1|1;d=l+(a<<3)|0;c=d;e=a+1|0;if((e|0)<(m|0)?(q=d+8|0,+o[q+4>>2]<+o[n+(a<<3)+4>>2]):0){a=e;c=q}if(h<+o[c+4>>2])break;else b=c}k[b>>2]=g;o[b+4>>2]=h}}k[i>>2]=(k[i>>2]|0)+-8;k[j>>2]=(k[j>>2]|0)+-1;q=1;return q|0}function AKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;g=m;j=a+76|0;e=k[j>>2]|0;a:do if((e|0)<32){d=a+96|0;k[d>>2]=(k[d>>2]|0)+e;d=fgb(8192)|0;if(d|0){f=a+80|0;k[d>>2]=k[f>>2];k[f>>2]=d;k[j>>2]=8188;d=d+4|0;f=a+84|0;k[f>>2]=d;e=8156;l=28;break}d=k[41482]|0;e=(d|0)==0;if((k[41497]|0)>-1){do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}else{do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}}else{d=a+84|0;f=d;d=k[d>>2]|0;e=e+-32|0;l=28}while(0);if((l|0)==28){k[f>>2]=d+32;k[j>>2]=e;h=a+92|0;k[h>>2]=(k[h>>2]|0)+32}k[c>>2]=d;if((_fb(d,32,1,b)|0)!=1){m=te(44)|0;VHa(m,373124);Cf(m|0,19720,57)}f=k[a+60>>2]|0;e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[k[c>>2]>>2]=d;if((_fb(k[k[c>>2]>>2]|0,4,f,b)|0)!=(f|0)){m=te(44)|0;VHa(m,373124);Cf(m|0,19720,57)}if(!(k[(k[c>>2]|0)+20>>2]|0)){if((_fb(g,4,1,b)|0)!=1){m=te(44)|0;VHa(m,373124);Cf(m|0,19720,57)}k[(k[c>>2]|0)+24>>2]=(k[a+68>>2]|0)+(k[g>>2]<<2);r=m;return}h=a+12|0;g=(k[h>>2]<<2)+15&-16;e=k[j>>2]|0;b:do if((g|0)>(e|0)){d=a+96|0;k[d>>2]=(k[d>>2]|0)+e;d=(g|4)+15|0;d=d>>>0>8192?d:8192;e=fgb(d)|0;if(e|0){l=a+80|0;k[e>>2]=k[l>>2];k[l>>2]=e;l=d+-4|0;k[j>>2]=l;d=e+4|0;f=a+84|0;k[f>>2]=d;e=l;l=68;break}d=k[41482]|0;e=(d|0)==0;if((k[41497]|0)>-1){do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break b}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}else{do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break b}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}}else{d=a+84|0;f=d;d=k[d>>2]|0;l=68}while(0);if((l|0)==68){k[f>>2]=d+g;k[j>>2]=e-g;l=a+92|0;k[l>>2]=(k[l>>2]|0)+g}k[(k[c>>2]|0)+20>>2]=d;if((k[h>>2]|0)>0)d=0;else{r=m;return}do{AKa(a,b,(k[(k[c>>2]|0)+20>>2]|0)+(d<<2)|0);d=d+1|0}while((d|0)<(k[h>>2]|0));r=m;return}function BKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;e=n;m=b+76|0;g=b+16|0;d=k[g>>2]|0;f=(d|0)==0;a:do if((k[m>>2]|0)>-1){do if(f){d=b+74|0;l=i[d>>0]|0;i[d>>0]=l+255|l;d=k[b>>2]|0;if(!(d&8)){k[b+8>>2]=0;k[b+4>>2]=0;f=k[b+44>>2]|0;k[b+28>>2]=f;j=b+20|0;k[j>>2]=f;d=f+(k[b+48>>2]|0)|0;k[g>>2]=d;break}else{k[b>>2]=d|32;break a}}else{f=b+20|0;j=f;f=k[f>>2]|0}while(0);h=f;if((d-f|0)>>>0<32){ci[k[b+36>>2]&255](b,c,32)|0;break}b:do if((i[b+75>>0]|0)>-1){f=32;while(1){if(!f){g=32;f=c;d=h;break b}d=f+-1|0;if((i[c+d>>0]|0)==10)break;else f=d}if((ci[k[b+36>>2]&255](b,c,f)|0)>>>0<f>>>0)break a;g=32-f|0;f=c+f|0;d=k[j>>2]|0}else{g=32;f=c;d=h}while(0);upb(d|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}else{do if(f){d=b+74|0;l=i[d>>0]|0;i[d>>0]=l+255|l;d=k[b>>2]|0;if(!(d&8)){k[b+8>>2]=0;k[b+4>>2]=0;f=k[b+44>>2]|0;k[b+28>>2]=f;j=b+20|0;k[j>>2]=f;d=f+(k[b+48>>2]|0)|0;k[g>>2]=d;break}else{k[b>>2]=d|32;break a}}else{f=b+20|0;j=f;f=k[f>>2]|0}while(0);h=f;if((d-f|0)>>>0<32){ci[k[b+36>>2]&255](b,c,32)|0;break}c:do if((i[b+75>>0]|0)>-1){f=32;while(1){if(!f){g=32;f=c;d=h;break c}d=f+-1|0;if((i[c+d>>0]|0)==10)break;else f=d}if((ci[k[b+36>>2]&255](b,c,f)|0)>>>0<f>>>0)break a;g=32-f|0;f=c+f|0;d=k[j>>2]|0}else{g=32;f=c;d=h}while(0);upb(d|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}while(0);f=k[c>>2]|0;l=k[a+60>>2]<<2;h=b+16|0;d=k[h>>2]|0;g=(d|0)==0;d:do if((k[m>>2]|0)>-1){do if(g){d=b+74|0;j=i[d>>0]|0;i[d>>0]=j+255|j;d=k[b>>2]|0;if(!(d&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;j=b+20|0;k[j>>2]=d;g=d+(k[b+48>>2]|0)|0;k[h>>2]=g;h=d;break}else{k[b>>2]=d|32;break d}}else{h=b+20|0;g=d;j=h;h=k[h>>2]|0}while(0);d=h;if((g-h|0)>>>0<l>>>0){ci[k[b+36>>2]&255](b,f,l)|0;break}e:do if((i[b+75>>0]|0)>-1){h=l;while(1){if(!h){g=l;break e}g=h+-1|0;if((i[f+g>>0]|0)==10)break;else h=g}if((ci[k[b+36>>2]&255](b,f,h)|0)>>>0<h>>>0)break d;g=l-h|0;f=f+h|0;d=k[j>>2]|0}else g=l;while(0);upb(d|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}else{do if(g){d=b+74|0;j=i[d>>0]|0;i[d>>0]=j+255|j;d=k[b>>2]|0;if(!(d&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;j=b+20|0;k[j>>2]=d;g=d+(k[b+48>>2]|0)|0;k[h>>2]=g;h=d;break}else{k[b>>2]=d|32;break d}}else{h=b+20|0;g=d;j=h;h=k[h>>2]|0}while(0);d=h;if((g-h|0)>>>0<l>>>0){ci[k[b+36>>2]&255](b,f,l)|0;break}f:do if((i[b+75>>0]|0)>-1){h=l;while(1){if(!h){g=l;break f}g=h+-1|0;if((i[f+g>>0]|0)==10)break;else h=g}if((ci[k[b+36>>2]&255](b,f,h)|0)>>>0<h>>>0)break d;g=l-h|0;f=f+h|0;d=k[j>>2]|0}else g=l;while(0);upb(d|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}while(0);f=c+20|0;d=k[f>>2]|0;if(d|0){e=a+12|0;if((k[e>>2]|0)<=0){r=n;return}BKa(a,b,k[d>>2]|0);if((k[e>>2]|0)>1)d=1;else{r=n;return}do{BKa(a,b,k[(k[f>>2]|0)+(d<<2)>>2]|0);d=d+1|0}while((d|0)<(k[e>>2]|0));r=n;return}k[e>>2]=(k[c+24>>2]|0)-(k[a+68>>2]|0)>>2;g=b+16|0;f=k[g>>2]|0;d=(f|0)==0;g:do if((k[m>>2]|0)>-1){do if(d){d=b+74|0;m=i[d>>0]|0;i[d>>0]=m+255|m;d=k[b>>2]|0;if(!(d&8)){k[b+8>>2]=0;k[b+4>>2]=0;m=k[b+44>>2]|0;k[b+28>>2]=m;h=b+20|0;k[h>>2]=m;f=m+(k[b+48>>2]|0)|0;k[g>>2]=f;g=m;break}else{k[b>>2]=d|32;break g}}else{g=b+20|0;h=g;g=k[g>>2]|0}while(0);d=g;if((f-g|0)>>>0<4){ci[k[b+36>>2]&255](b,e,4)|0;break}h:do if((i[b+75>>0]|0)>-1){g=4;while(1){if(!g){f=4;break h}f=g+-1|0;if((i[e+f>>0]|0)==10)break;else g=f}if((ci[k[b+36>>2]&255](b,e,g)|0)>>>0<g>>>0)break g;f=4-g|0;e=e+g|0;d=k[h>>2]|0}else f=4;while(0);upb(d|0,e|0,f|0)|0;k[h>>2]=(k[h>>2]|0)+f}else{do if(d){d=b+74|0;m=i[d>>0]|0;i[d>>0]=m+255|m;d=k[b>>2]|0;if(!(d&8)){k[b+8>>2]=0;k[b+4>>2]=0;m=k[b+44>>2]|0;k[b+28>>2]=m;h=b+20|0;k[h>>2]=m;f=m+(k[b+48>>2]|0)|0;k[g>>2]=f;g=m;break}else{k[b>>2]=d|32;break g}}else{g=b+20|0;h=g;g=k[g>>2]|0}while(0);d=g;if((f-g|0)>>>0<4){ci[k[b+36>>2]&255](b,e,4)|0;break}i:do if((i[b+75>>0]|0)>-1){g=4;while(1){if(!g){f=4;break i}f=g+-1|0;if((i[e+f>>0]|0)==10)break;else g=f}if((ci[k[b+36>>2]&255](b,e,g)|0)>>>0<g>>>0)break g;f=4-g|0;e=e+g|0;d=k[h>>2]|0}else f=4;while(0);upb(d|0,e|0,f|0)|0;k[h>>2]=(k[h>>2]|0)+f}while(0);r=n;return}function CKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,q=0.0,s=0.0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0;Ha=r;r=r+4400|0;Ga=Ha+3328|0;l=Ha+3320|0;Da=Ha;ka=Ha+3304|0;Ba=Ha+3288|0;Ca=Ha+2224|0;Aa=Ha+1160|0;Z=Ha+4392|0;_=Ha+1152|0;$=Ha+1104|0;ba=Ha+1096|0;k[b+16>>2]=d;k[b+28>>2]=f;if((d|0)<(e|0)){k[b+24>>2]=c;Dgb(c,c+(d<<2)|0);k[b+20>>2]=0;r=Ha;return}Ea=Ga+8|0;k[Ga>>2]=Ea;Fa=Ga+4|0;k[Fa>>2]=264;y=e>>>0>264;if(y){h=e>>>0>1073741823?-1:e<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[Ga>>2]=g}else g=Ea;k[Fa>>2]=e;h=k[a+4>>2]|0;ya=k[a+8>>2]|0;j=a+(ya>>1)|0;if(ya&1)h=k[(k[j>>2]|0)+h>>2]|0;Lg[h&255](j,e,c,d,g,l);t=k[l>>2]|0;if((t|0)>=(e|0)){wa=a+60|0;v=k[wa>>2]|0;l=aa(v,e)|0;xa=Da+8|0;k[Da>>2]=xa;ya=Da+4|0;k[ya>>2]=136;h=xa;if(l>>>0>136){j=l>>>0>536870911?-1:l<<3;j=(j|0)==0?1:j;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[Da>>2]=h}k[ya>>2]=l;k[ka>>2]=e;k[ka+4>>2]=v;Y=ka+8|0;X=ka+12|0;k[X>>2]=h;k[Y>>2]=v;if((t|0)>0?(w=k[a+40>>2]|0,x=k[a+36>>2]|0,v|0):0){j=0;do{m=w+((aa(x,k[g+(j<<2)>>2]|0)|0)<<2)|0;n=h+((aa(v,j)|0)<<3)|0;l=0;do{p[n+(l<<3)>>3]=+o[m+(l<<2)>>2];l=l+1|0}while((l|0)!=(v|0));j=j+1|0}while((j|0)!=(t|0))}k[Ba>>2]=0;va=Ba+4|0;k[va>>2]=0;k[Ba+8>>2]=0;if(e|0){if(e>>>0>1073741823)ad(426534,426557,304,426811);j=e<<2;h=(j|0)==0?1:j;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[Ba>>2]=g;ua=g+(e<<2)|0;k[Ba+8>>2]=ua;zpb(g|0,0,j|0)|0;k[va>>2]=ua}ua=Ca+8|0;k[Ca>>2]=ua;ta=Ca+4|0;k[ta>>2]=264;if(y){h=e>>>0>1073741823?-1:e<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[Ca>>2]=g;sa=g}else sa=ua;k[ta>>2]=e;la=(e|0)>0;if(la){h=k[Ba>>2]|0;g=0;do{o[h+(g<<2)>>2]=0.0;k[sa+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(e|0))}qa=Aa+8|0;k[Aa>>2]=qa;ra=Aa+4|0;k[ra>>2]=264;if(d>>>0>264){h=d>>>0>1073741823?-1:d<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[Aa>>2]=g;pa=g}else pa=qa;k[ra>>2]=d;na=(d|0)>0;oa=a+40|0;if(na){D=k[oa>>2]|0;E=a+36|0;F=k[X>>2]|0;G=(e|0)>1;H=k[Ba>>2]|0;I=k[E>>2]|0;J=k[wa>>2]|0;K=k[Y>>2]|0;C=0;do{v=c+(C<<2)|0;m=D+((aa(I,k[v>>2]|0)|0)<<2)|0;t=m+(J<<2)|0;l=t+-12|0;n=((l>>>0<m>>>0?m:l)+12+(3-m)|0)>>>4<<2;h=F+(n<<3)|0;if(m>>>0<l>>>0){g=m;j=F;q=0.0;while(1){s=+P(+(+o[g>>2]-+p[j>>3]));u=+P(+(+o[g+4>>2]-+p[j+8>>3]));z=+P(+(+o[g+8>>2]-+p[j+16>>3]));q=q+(s+u+z+ +P(+(+o[g+12>>2]-+p[j+24>>3])));g=g+16|0;if(g>>>0>=l>>>0)break;else j=j+32|0}}else q=0.0;g=m+(n<<2)|0;if(g>>>0<t>>>0)while(1){q=q+ +P(+(+o[g>>2]-+p[h>>3]));g=g+4|0;if(g>>>0>=t>>>0)break;else h=h+8|0}B=pa+(C<<2)|0;k[B>>2]=0;if(G){n=D+((aa(k[E>>2]|0,k[v>>2]|0)|0)<<2)|0;t=n+(k[wa>>2]<<2)|0;v=t+-12|0;w=((v>>>0<n>>>0?n:v)+12+(3-n)|0)>>>4<<2;x=n>>>0<v>>>0;A=n+(w<<2)|0;y=A>>>0<t>>>0;m=1;h=0;do{g=F+((aa(K,m)|0)<<3)|0;j=g+(w<<3)|0;if(x){l=n;s=0.0;while(1){Ia=+P(+(+o[l>>2]-+p[g>>3]));u=+P(+(+o[l+4>>2]-+p[g+8>>3]));z=+P(+(+o[l+8>>2]-+p[g+16>>3]));s=s+(Ia+u+z+ +P(+(+o[l+12>>2]-+p[g+24>>3])));l=l+16|0;if(l>>>0>=v>>>0)break;else g=g+32|0}}else s=0.0;if(y){g=A;while(1){s=s+ +P(+(+o[g>>2]-+p[j>>3]));g=g+4|0;if(g>>>0>=t>>>0)break;else j=j+8|0}}if(q>s){k[B>>2]=m;q=s;h=m}m=m+1|0}while((m|0)!=(e|0))}else h=0;g=H+(h<<2)|0;if(q>+o[g>>2])o[g>>2]=q;ma=sa+(h<<2)|0;k[ma>>2]=(k[ma>>2]|0)+1;C=C+1|0}while((C|0)!=(d|0));ma=E}else ma=a+36|0;i[Z>>0]=0;I=a+16|0;J=a+28|0;K=$+8|0;L=$+12|0;M=$+16|0;N=$+20|0;O=$+24|0;R=$+28|0;S=$+32|0;T=$+36|0;U=$+40|0;V=$+44|0;W=ba+4|0;H=0;do{if((H|0)>=(k[I>>2]|0))break;i[Z>>0]=1;H=H+1|0;if(la){g=0;do{G=(k[X>>2]|0)+((aa(k[Y>>2]|0,g)|0)<<3)|0;zpb(G|0,0,k[wa>>2]<<3|0)|0;o[(k[Ba>>2]|0)+(g<<2)>>2]=0.0;g=g+1|0}while((g|0)!=(e|0))}if(na?(ca=k[oa>>2]|0,da=k[ma>>2]|0,ea=k[X>>2]|0,fa=k[Y>>2]|0,ga=k[wa>>2]|0,ga|0):0){h=0;do{j=ca+((aa(da,k[c+(h<<2)>>2]|0)|0)<<2)|0;l=ea+((aa(fa,k[pa+(h<<2)>>2]|0)|0)<<3)|0;g=0;do{G=l+(g<<3)|0;p[G>>3]=+p[G>>3]+ +o[j+(g<<2)>>2];g=g+1|0}while((g|0)!=(ga|0));h=h+1|0}while((h|0)!=(d|0))}if(la?(ha=k[wa>>2]|0,ia=k[X>>2]|0,ja=k[Y>>2]|0,ha|0):0){h=0;do{q=+(k[sa+(h<<2)>>2]|0);j=ia+((aa(ja,h)|0)<<3)|0;g=0;do{G=j+(g<<3)|0;p[G>>3]=+p[G>>3]/q;g=g+1|0}while((g|0)!=(ha|0));h=h+1|0}while((h|0)!=(e|0))}m9(_);G=k[wa>>2]|0;k[$>>2]=93780;k[K>>2]=J;k[L>>2]=e;k[M>>2]=c;k[N>>2]=ka;k[O>>2]=G;k[R>>2]=sa;k[S>>2]=pa;k[T>>2]=Ba;k[U>>2]=Z;k[V>>2]=_;k[ba>>2]=0;k[W>>2]=d;EKa($,ba);if(la){y=k[X>>2]|0;A=k[Ba>>2]|0;B=k[Y>>2]|0;w=0;do{C=sa+(w<<2)|0;if(!(k[C>>2]|0)){x=w;do{x=(x+1|0)%(e|0)|0;D=sa+(x<<2)|0}while((k[D>>2]|0)<2);a:do if(na){E=y+((aa(B,x)|0)<<3)|0;F=A+(x<<2)|0;v=0;while(1){G=pa+(v<<2)|0;if((k[G>>2]|0)==(x|0)){m=(k[oa>>2]|0)+((aa(k[ma>>2]|0,k[c+(v<<2)>>2]|0)|0)<<2)|0;t=m+(k[wa>>2]<<2)|0;l=t+-12|0;n=((l>>>0<m>>>0?m:l)+12+(3-m)|0)>>>4<<2;h=E+(n<<3)|0;if(m>>>0<l>>>0){g=m;j=E;q=0.0;while(1){u=+P(+(+o[g>>2]-+p[j>>3]));z=+P(+(+o[g+4>>2]-+p[j+8>>3]));Ia=+P(+(+o[g+8>>2]-+p[j+16>>3]));q=q+(u+z+Ia+ +P(+(+o[g+12>>2]-+p[j+24>>3])));g=g+16|0;if(g>>>0>=l>>>0)break;else j=j+32|0}}else q=0.0;g=m+(n<<2)|0;if(g>>>0<t>>>0)while(1){q=q+ +P(+(+o[g>>2]-+p[h>>3]));g=g+4|0;if(g>>>0>=t>>>0)break;else h=h+8|0}if(q==+o[F>>2])break}v=v+1|0;if((v|0)>=(d|0))break a}k[G>>2]=w;k[D>>2]=(k[D>>2]|0)+-1;k[C>>2]=(k[C>>2]|0)+1}while(0);i[Z>>0]=0}w=w+1|0}while((w|0)!=(e|0))}F=(k[_>>2]|0)+28|0;G=k[F>>2]|0;k[F>>2]=G+-1;do if((G|0)==1){g=k[_>>2]|0;if(!g)break;rf(g|0)|0;ggb(g)}while(0)}while(!(i[Z>>0]|0));h=e>>>0>1073741823?-1:e<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0){J=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){J=0;break}Qh[g&7]()}if(la){v=a+100|0;t=k[X>>2]|0;n=k[Y>>2]|0;m=k[wa>>2]|0;l=0;g=m;do{j=g>>>0>1073741823?-1:g<<2;j=(j|0)==0?1:j;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[J+(l<<2)>>2]=h;k[v>>2]=(k[v>>2]|0)+(g<<2);if(!g)g=0;else{j=t+((aa(n,l)|0)<<3)|0;g=0;do{o[h+(g<<2)>>2]=+p[j+(g<<3)>>3];g=g+1|0}while(g>>>0<m>>>0);g=m}l=l+1|0}while((l|0)!=(e|0))}l=(e<<2)+15&-16;I=a+76|0;h=k[I>>2]|0;b:do if((l|0)>(h|0)){g=a+96|0;k[g>>2]=(k[g>>2]|0)+h;g=(l|4)+15|0;g=g>>>0>8192?g:8192;h=fgb(g)|0;if(h|0){za=a+80|0;k[h>>2]=k[za>>2];k[za>>2]=h;za=g+-4|0;k[I>>2]=za;g=h+4|0;j=a+84|0;k[j>>2]=g;h=za;za=134;break}g=k[41482]|0;h=(g|0)==0;if((k[41497]|0)>-1){do if(h){g=i[165986]|0;i[165986]=g+255|g;g=k[41478]|0;if(!(g&8)){k[41480]=0;k[41479]=0;h=k[41489]|0;k[41485]=h;k[41483]=h;g=h+(k[41490]|0)|0;k[41482]=g;break}else{k[41478]=g|32;g=0;break b}}else h=k[41483]|0;while(0);if((g-h|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;g=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){g=0;break}g=0;j=373857;h=k[41483]|0}else{g=27;j=373830}upb(h|0,j|0,g|0)|0;k[41483]=(k[41483]|0)+g;g=0;break}else{do if(h){g=i[165986]|0;i[165986]=g+255|g;g=k[41478]|0;if(!(g&8)){k[41480]=0;k[41479]=0;h=k[41489]|0;k[41485]=h;k[41483]=h;g=h+(k[41490]|0)|0;k[41482]=g;break}else{k[41478]=g|32;g=0;break b}}else h=k[41483]|0;while(0);if((g-h|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;g=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){g=0;break}g=0;j=373857;h=k[41483]|0}else{g=27;j=373830}upb(h|0,j|0,g|0)|0;k[41483]=(k[41483]|0)+g;g=0;break}}else{g=a+84|0;j=g;g=k[g>>2]|0;za=134}while(0);if((za|0)==134){k[j>>2]=g+l;k[I>>2]=h-l;ka=a+92|0;k[ka>>2]=(k[ka>>2]|0)+l}H=b+20|0;k[H>>2]=g;if(la){E=a+96|0;F=a+80|0;G=a+84|0;C=f+1|0;D=a+92|0;A=0;B=0;while(1){y=k[sa+(A<<2)>>2]|0;if(na){x=0;q=0.0;s=0.0;g=B;do{t=pa+(x<<2)|0;if((k[t>>2]|0)==(A|0)){v=c+(x<<2)|0;w=k[v>>2]|0;l=(k[oa>>2]|0)+((aa(k[ma>>2]|0,w)|0)<<2)|0;n=l+(k[wa>>2]<<2)|0;j=n+-12|0;m=((j>>>0<l>>>0?l:j)+12+(3-l)|0)>>>4<<2;if(l>>>0<j>>>0){h=l;u=0.0;do{Ja=+P(+(+o[h>>2]));z=+P(+(+o[h+4>>2]));Ia=+P(+(+o[h+8>>2]));u=u+(Ja+z+Ia+ +P(+(+o[h+12>>2])));h=h+16|0}while(h>>>0<j>>>0)}else u=0.0;h=l+(m<<2)|0;if(h>>>0<n>>>0)do{u=u+ +P(+(+o[h>>2]));h=h+4|0}while(h>>>0<n>>>0);q=q+ +Q(+u);f=c+(g<<2)|0;k[v>>2]=k[f>>2];k[f>>2]=w;f=pa+(g<<2)|0;b=k[t>>2]|0;k[t>>2]=k[f>>2];k[f>>2]=b;s=s+u;g=g+1|0}x=x+1|0}while((x|0)!=(d|0));t=g}else{q=0.0;s=0.0;t=B}z=+(y|0);j=k[J+(A<<2)>>2]|0;m=j+(k[wa>>2]<<2)|0;h=m+-12|0;n=j;l=((h>>>0<j>>>0?j:h)+12+(3-n)|0)>>>4<<2;if(j>>>0<h>>>0){g=j;u=0.0;do{Ka=+P(+(+o[g>>2]));Ia=+P(+(+o[g+4>>2]));Ja=+P(+(+o[g+8>>2]));u=u+(Ka+Ia+Ja+ +P(+(+o[g+12>>2])));g=g+16|0}while(g>>>0<h>>>0)}else u=0.0;g=j+(l<<2)|0;if(g>>>0<m>>>0)do{u=u+ +P(+(+o[g>>2]));g=g+4|0}while(g>>>0<m>>>0);h=k[I>>2]|0;c:do if((h|0)<32){k[E>>2]=(k[E>>2]|0)+h;g=fgb(8192)|0;if(g|0){k[g>>2]=k[F>>2];k[F>>2]=g;k[I>>2]=8188;g=g+4|0;k[G>>2]=g;h=8188;za=189;break}g=k[41482]|0;h=(g|0)==0;if((k[41497]|0)>-1){do if(h){g=i[165986]|0;i[165986]=g+255|g;g=k[41478]|0;if(!(g&8)){k[41480]=0;k[41479]=0;h=k[41489]|0;k[41485]=h;k[41483]=h;g=h+(k[41490]|0)|0;k[41482]=g;break}else{k[41478]=g|32;g=0;break c}}else h=k[41483]|0;while(0);if((g-h|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;g=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){g=0;break}g=0;j=373857;h=k[41483]|0}else{g=27;j=373830}upb(h|0,j|0,g|0)|0;k[41483]=(k[41483]|0)+g;g=0;break}else{do if(h){g=i[165986]|0;i[165986]=g+255|g;g=k[41478]|0;if(!(g&8)){k[41480]=0;k[41479]=0;h=k[41489]|0;k[41485]=h;k[41483]=h;g=h+(k[41490]|0)|0;k[41482]=g;break}else{k[41478]=g|32;g=0;break c}}else h=k[41483]|0;while(0);if((g-h|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;g=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){g=0;break}g=0;j=373857;h=k[41483]|0}else{g=27;j=373830}upb(h|0,j|0,g|0)|0;k[41483]=(k[41483]|0)+g;g=0;break}}else{g=k[G>>2]|0;za=189}while(0);if((za|0)==189){za=0;k[G>>2]=g+32;k[I>>2]=h+-32;k[D>>2]=(k[D>>2]|0)+32}k[(k[H>>2]|0)+(A<<2)>>2]=g;f=k[(k[H>>2]|0)+(A<<2)>>2]|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[f+28>>2]=0;f=(k[H>>2]|0)+(A<<2)|0;b=k[f>>2]|0;k[b+4>>2]=k[(k[Ba>>2]|0)+(A<<2)>>2];k[b>>2]=n;f=k[f>>2]|0;o[f+12>>2]=s/z-u;o[f+8>>2]=q/z;CKa(a,f,c+(B<<2)|0,t-B|0,e,C);A=A+1|0;if((A|0)>=(e|0))break;else B=t}}g=k[Aa>>2]|0;if((g|0)!=(qa|0)){if(g|0)ggb(g);k[Aa>>2]=qa;k[ra>>2]=264}g=k[Ca>>2]|0;if((g|0)!=(ua|0)){if(g|0)ggb(g);k[Ca>>2]=ua;k[ta>>2]=264}g=k[Ba>>2]|0;h=g;if(g|0){j=k[va>>2]|0;if((j|0)!=(g|0))k[va>>2]=j+(~((j+-4-h|0)>>>2)<<2);ggb(g)}g=k[Da>>2]|0;if((g|0)!=(xa|0)){if(g|0)ggb(g);k[Da>>2]=xa;k[ya>>2]=136}}else{k[b+24>>2]=c;Dgb(c,c+(d<<2)|0);k[b+20>>2]=0}g=k[Ga>>2]|0;if((g|0)!=(Ea|0)){if(g|0)ggb(g);k[Ga>>2]=Ea;k[Fa>>2]=264}r=Ha;return}function DKa(a){a=a|0;ggb(a);return}function EKa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0.0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0;c=k[b>>2]|0;B=k[b+4>>2]|0;if((c|0)>=(B|0))return;C=a+8|0;D=a+16|0;E=a+20|0;F=a+24|0;w=a+12|0;x=a+36|0;y=a+32|0;z=a+28|0;A=a+44|0;v=a+40|0;do{l=k[C>>2]|0;l=(k[l+12>>2]|0)+((aa(k[l+8>>2]|0,k[(k[D>>2]|0)+(c<<2)>>2]|0)|0)<<2)|0;g=k[E>>2]|0;s=k[g+12>>2]|0;t=l+(k[F>>2]<<2)|0;m=t+-12|0;u=((m>>>0<l>>>0?l:m)+12+(3-l)|0)>>>4<<2;e=s+(u<<3)|0;h=l>>>0<m>>>0;if(h){b=l;a=s;d=0.0;while(1){H=+P(+(+o[b>>2]-+p[a>>3]));G=+P(+(+o[b+4>>2]-+p[a+8>>3]));f=+P(+(+o[b+8>>2]-+p[a+16>>3]));d=d+(H+G+f+ +P(+(+o[b+12>>2]-+p[a+24>>3])));b=b+16|0;if(b>>>0>=m>>>0)break;else a=a+32|0}}else d=0.0;r=l+(u<<2)|0;q=r>>>0<t>>>0;if(q){a=e;b=r;while(1){d=d+ +P(+(+o[b>>2]-+p[a>>3]));b=b+4|0;if(b>>>0>=t>>>0)break;else a=a+8|0}}n=k[w>>2]|0;a:do if((n|0)>1){j=k[g+8>>2]|0;if(h){h=1;e=0}else{g=1;e=0;while(1){if(q){b=s+((aa(j,g)|0)<<3)+(u<<3)|0;f=0.0;a=r;while(1){f=f+ +P(+(+o[a>>2]-+p[b>>3]));a=a+4|0;if(a>>>0>=t>>>0)break;else b=b+8|0}}else f=0.0;m=d>f;d=m?f:d;e=m?g:e;g=g+1|0;if((g|0)==(n|0))break a}}do{g=s+((aa(j,h)|0)<<3)|0;b=l;a=g;f=0.0;while(1){I=+P(+(+o[b>>2]-+p[a>>3]));G=+P(+(+o[b+4>>2]-+p[a+8>>3]));H=+P(+(+o[b+8>>2]-+p[a+16>>3]));f=f+(I+G+H+ +P(+(+o[b+12>>2]-+p[a+24>>3])));b=b+16|0;if(b>>>0>=m>>>0)break;else a=a+32|0}if(q){a=g+(u<<3)|0;b=r;while(1){f=f+ +P(+(+o[b>>2]-+p[a>>3]));b=b+4|0;if(b>>>0>=t>>>0)break;else a=a+8|0}}g=d>f;d=g?f:d;e=g?h:e;h=h+1|0}while((h|0)!=(n|0))}else e=0;while(0);b=(k[k[x>>2]>>2]|0)+(e<<2)|0;if(d>+o[b>>2])o[b>>2]=d;b=(k[y>>2]|0)+(c<<2)|0;a=k[b>>2]|0;if((e|0)!=(a|0)){u=k[z>>2]|0;t=u+(a<<2)|0;k[t>>2]=(k[t>>2]|0)+-1;u=u+(e<<2)|0;k[u>>2]=(k[u>>2]|0)+1;k[b>>2]=e;mpb(k[k[A>>2]>>2]|0)|0;i[k[v>>2]>>0]=0;lpb(k[k[A>>2]>>2]|0)|0}c=c+1|0}while((c|0)!=(B|0));return}function FKa(a){a=a|0;var b=0;k[a>>2]=93800;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);b=k[a+4>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);YHa(k[a+16>>2]|0);return}function GKa(a){a=a|0;var b=0;k[a>>2]=93800;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);b=k[a+4>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);YHa(k[a+16>>2]|0);ggb(a);return}function HKa(a){a=a|0;var b=0,c=0;b=r;r=r+16|0;IJa(375452,b);c=k[a+4>>2]|0;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);IJa(375477,b+8|0);a=k[a+8>>2]|0;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);r=b;return}function IKa(a,b){a=a|0;b=b|0;var c=0;c=k[a+4>>2]|0;jh[k[(k[c>>2]|0)+20>>2]&1023](c,b);a=k[a+8>>2]|0;jh[k[(k[a>>2]|0)+20>>2]&1023](a,b);return}function JKa(a,b){a=a|0;b=b|0;var c=0;c=k[a+4>>2]|0;jh[k[(k[c>>2]|0)+24>>2]&1023](c,b);a=k[a+8>>2]|0;jh[k[(k[a>>2]|0)+24>>2]&1023](a,b);return}function KKa(a){a=a|0;a=k[a+8>>2]|0;return Xh[k[(k[a>>2]|0)+28>>2]&1023](a)|0}function LKa(a){a=a|0;a=k[a+8>>2]|0;return Xh[k[(k[a>>2]|0)+32>>2]&1023](a)|0}function MKa(a){a=a|0;var b=0;b=k[a+4>>2]|0;b=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;a=k[a+8>>2]|0;return (Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)+b|0}function NKa(a){a=a|0;return 3}function OKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+12>>2]|0;f=b+16|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function PKa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=k[a+4>>2]|0;dh[k[(k[e>>2]|0)+48>>2]&255](e,b,c,d);a=k[a+8>>2]|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,b,c,d);return}function QKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0;G=r;r=r+32|0;F=G;$Ia(F,d);a:do if((b|0)>0){E=F+16|0;g=k[F>>2]|0;C=a+40|0;D=a+36|0;B=a+32|0;A=k[F+12>>2]|0;a=k[E>>2]|0;d=0;b:while(1){y=e+(d<<2)|0;z=(d|0)>0;if((a|0)==(A|0)){l=23;break a}while(1){h=a;a=a+1|0;h=k[g+(h<<2)>>2]|0;if((h|0)<0){l=6;break b}h=k[c+(h<<2)>>2]|0;k[y>>2]=h;if(!z)break;w=k[C>>2]|0;x=k[D>>2]|0;p=w+((aa(x,h)|0)<<2)|0;t=p+(k[B>>2]<<2)|0;q=t+-12|0;u=((q>>>0<p>>>0?p:q)+12+(3-p)|0)>>>4<<2;v=p+(u<<2)|0;s=v>>>0<t>>>0;if(p>>>0>=q>>>0){if(s){m=0;h=0;do{i=w+((aa(k[e+(m<<2)>>2]|0,x)|0)<<2)+(u<<2)|0;j=0.0;l=v;while(1){s=l;l=l+4|0;j=j+ +P(+(+o[s>>2]-+o[i>>2]));if(l>>>0>=t>>>0)break;else i=i+4|0}h=j<1.0e-16?1:h;m=m+1|0}while((m|0)!=(d|0));i=h;l=19}}else{n=0;h=0;do{m=w+((aa(k[e+(n<<2)>>2]|0,x)|0)<<2)|0;i=p;l=m;j=0.0;while(1){J=+P(+(+o[i>>2]-+o[l>>2]));I=+P(+(+o[i+4>>2]-+o[l+4>>2]));H=+P(+(+o[i+8>>2]-+o[l+8>>2]));j=j+(J+I+H+ +P(+(+o[i+12>>2]-+o[l+12>>2])));i=i+16|0;if(i>>>0>=q>>>0)break;else l=l+16|0}if(s){l=m+(u<<2)|0;i=v;while(1){j=j+ +P(+(+o[i>>2]-+o[l>>2]));i=i+4|0;if(i>>>0>=t>>>0)break;else l=l+4|0}}h=j<1.0e-16?1:h;n=n+1|0}while((n|0)!=(d|0));i=h;l=19}if((l|0)==19?(l=0,(i&1)==0):0)break;if((a|0)==(A|0)){l=22;break b}}k[E>>2]=a;d=d+1|0;if((d|0)>=(b|0)){l=23;break a}}if((l|0)==6){k[E>>2]=a;k[f>>2]=d;break}else if((l|0)==22){k[E>>2]=A;l=23;break}}else{d=0;g=k[F>>2]|0;l=23}while(0);if((l|0)==23){k[f>>2]=d;if(!g){r=G;return}}d=F+4|0;a=k[d>>2]|0;if((a|0)!=(g|0))k[d>>2]=a+(~((a+-4-g|0)>>>2)<<2);ggb(g);r=G;return}function RKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0.0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,O=0.0;J=428e3;J=Epb(k[J>>2]|0,k[J+4>>2]|0,1284865837,1481765933)|0;J=kpb(J|0,N|0,1,0)|0;K=N;I=428e3;k[I>>2]=J;k[I+4>>2]=K;K=ppb(J|0,K|0,33)|0;k[e>>2]=k[c+(~~(+(d|0)*(+(K|0)*4.656612873077393e-10))<<2)>>2];if((b|0)<=1){e=1;k[f>>2]=e;return}I=(d|0)>0;J=a+40|0;K=a+36|0;H=a+32|0;a=1;while(1){if(!I){a=1;g=18;break}w=k[J>>2]|0;x=k[K>>2]|0;y=w+((aa(x,k[e>>2]|0)|0)<<2)|0;z=k[H>>2]|0;A=y+(z<<2)|0;B=A+-12|0;C=((B>>>0<y>>>0?y:B)+12+(3-y)|0)>>>4<<2;D=y>>>0<B>>>0;G=y+(C<<2)|0;E=G>>>0<A>>>0;F=(a|0)>1;t=0;u=0.0;v=-1;while(1){s=w+((aa(k[c+(t<<2)>>2]|0,x)|0)<<2)|0;l=s+(C<<2)|0;if(D){g=y;j=s;h=0.0;while(1){M=+P(+(+o[g>>2]-+o[j>>2]));L=+P(+(+o[g+4>>2]-+o[j+4>>2]));i=+P(+(+o[g+8>>2]-+o[j+8>>2]));h=h+(M+L+i+ +P(+(+o[g+12>>2]-+o[j+12>>2])));g=g+16|0;if(g>>>0>=B>>>0)break;else j=j+16|0}}else h=0.0;if(E){j=l;g=G;while(1){h=h+ +P(+(+o[g>>2]-+o[j>>2]));g=g+4|0;if(g>>>0>=A>>>0)break;else j=j+4|0}}if(F){r=1;do{p=w+((aa(x,k[e+(r<<2)>>2]|0)|0)<<2)|0;q=p+(z<<2)|0;m=q+-12|0;n=((m>>>0<p>>>0?p:m)+12+(3-p)|0)>>>4<<2;j=s+(n<<2)|0;if(p>>>0<m>>>0){g=p;l=s;i=0.0;while(1){O=+P(+(+o[g>>2]-+o[l>>2]));L=+P(+(+o[g+4>>2]-+o[l+4>>2]));M=+P(+(+o[g+8>>2]-+o[l+8>>2]));i=i+(O+L+M+ +P(+(+o[g+12>>2]-+o[l+12>>2])));g=g+16|0;if(g>>>0>=m>>>0)break;else l=l+16|0}}else i=0.0;g=p+(n<<2)|0;if(g>>>0<q>>>0)while(1){i=i+ +P(+(+o[g>>2]-+o[j>>2]));g=g+4|0;if(g>>>0>=q>>>0)break;else j=j+4|0}h=i<h?i:h;r=r+1|0}while((r|0)!=(a|0))}g=h>u;v=g?t:v;t=t+1|0;if((t|0)==(d|0))break;else u=g?h:u}if((v|0)==-1){g=18;break}k[e+(a<<2)>>2]=k[c+(v<<2)>>2];a=a+1|0;if((a|0)>=(b|0)){g=18;break}}if((g|0)==18){k[f>>2]=a;return}}function SKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0.0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,O=0.0;K=r;r=r+16|0;J=K;h=d>>>0>1073741823?-1:d<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}y=428e3;y=Epb(k[y>>2]|0,k[y+4>>2]|0,1284865837,1481765933)|0;y=kpb(y|0,N|0,1,0)|0;z=N;h=428e3;k[h>>2]=y;k[h+4>>2]=z;h=ppb(y|0,z|0,33)|0;h=c+(~~(+(d|0)*(+(h|0)*4.656612873077393e-10))<<2)|0;k[e>>2]=k[h>>2];I=(d|0)>0;if(I){w=k[a+40>>2]|0;x=k[a+36>>2]|0;u=w+((aa(k[h>>2]|0,x)|0)<<2)|0;v=k[a+32>>2]|0;t=0;i=0.0;do{p=w+((aa(x,k[c+(t<<2)>>2]|0)|0)<<2)|0;s=p+(v<<2)|0;n=s+-12|0;q=((n>>>0<p>>>0?p:n)+12+(3-p)|0)>>>4<<2;l=u+(q<<2)|0;if(p>>>0<n>>>0){h=p;m=u;j=0.0;while(1){O=+P(+(+o[h>>2]-+o[m>>2]));M=+P(+(+o[h+4>>2]-+o[m+4>>2]));L=+P(+(+o[h+8>>2]-+o[m+8>>2]));j=j+(O+M+L+ +P(+(+o[h+12>>2]-+o[m+12>>2])));h=h+16|0;if(h>>>0>=n>>>0)break;else m=m+16|0}}else j=0.0;h=p+(q<<2)|0;if(h>>>0<s>>>0)while(1){j=j+ +P(+(+o[h>>2]-+o[l>>2]));h=h+4|0;if(h>>>0>=s>>>0)break;else l=l+4|0}O=j*j;o[g+(t<<2)>>2]=O;i=i+O;t=t+1|0}while((t|0)!=(d|0))}else i=0.0;if((b|0)<=1){J=1;k[f>>2]=J;ggb(g);r=K;return}E=d+-1|0;F=(d|0)>1;G=a+40|0;H=a+36|0;D=a+32|0;C=1;B=y;do{y=Epb(B|0,z|0,1284865837,1481765933)|0;B=kpb(y|0,N|0,1,0)|0;z=N;a:do if(F){y=ppb(B|0,z|0,33)|0;h=0;i=i*(+(y|0)*4.656612873077393e-10)+0.0;while(1){j=+o[g+(h<<2)>>2];if(i<=j)break;h=h+1|0;if((h|0)<(E|0))i=i-j;else break}if(!I){k[e+(C<<2)>>2]=k[c+(h<<2)>>2];i=0.0;break}y=k[G>>2]|0;w=k[H>>2]|0;l=k[c+(h<<2)>>2]|0;a=y+((aa(l,w)|0)<<2)|0;x=k[D>>2]|0;v=0;i=0.0;do{s=y+((aa(w,k[c+(v<<2)>>2]|0)|0)<<2)|0;u=s+(x<<2)|0;q=u+-12|0;t=((q>>>0<s>>>0?s:q)+12+(3-s)|0)>>>4<<2;n=a+(t<<2)|0;if(s>>>0<q>>>0){m=s;p=a;j=0.0;while(1){L=+P(+(+o[m>>2]-+o[p>>2]));M=+P(+(+o[m+4>>2]-+o[p+4>>2]));O=+P(+(+o[m+8>>2]-+o[p+8>>2]));j=j+(L+M+O+ +P(+(+o[m+12>>2]-+o[p+12>>2])));m=m+16|0;if(m>>>0>=q>>>0)break;else p=p+16|0}}else j=0.0;m=s+(t<<2)|0;if(m>>>0<u>>>0)while(1){j=j+ +P(+(+o[m>>2]-+o[n>>2]));m=m+4|0;if(m>>>0>=u>>>0)break;else n=n+4|0}O=j*j;M=+o[g+(v<<2)>>2];i=i+(M<O?M:O);v=v+1|0}while((v|0)!=(d|0));x=y;A=28}else{if(!I){k[e+(C<<2)>>2]=k[c>>2];i=0.0;break}x=k[G>>2]|0;v=k[H>>2]|0;l=k[c>>2]|0;w=x+((aa(l,v)|0)<<2)|0;a=k[D>>2]|0;u=0;i=0.0;h=l;while(1){q=x+((aa(v,h)|0)<<2)|0;t=q+(a<<2)|0;p=t+-12|0;s=((p>>>0<q>>>0?q:p)+12+(3-q)|0)>>>4<<2;m=w+(s<<2)|0;if(q>>>0<p>>>0){h=q;n=w;j=0.0;while(1){L=+P(+(+o[h>>2]-+o[n>>2]));M=+P(+(+o[h+4>>2]-+o[n+4>>2]));O=+P(+(+o[h+8>>2]-+o[n+8>>2]));j=j+(L+M+O+ +P(+(+o[h+12>>2]-+o[n+12>>2])));h=h+16|0;if(h>>>0>=p>>>0)break;else n=n+16|0}}else j=0.0;h=q+(s<<2)|0;if(h>>>0<t>>>0)while(1){j=j+ +P(+(+o[h>>2]-+o[m>>2]));h=h+4|0;if(h>>>0>=t>>>0)break;else m=m+4|0}O=j*j;M=+o[g+(u<<2)>>2];i=i+(M<O?M:O);h=u+1|0;if((h|0)==(d|0)){h=0;A=28;break a}u=h;h=k[c+(h<<2)>>2]|0}}while(0);if((A|0)==28){A=0;k[e+(C<<2)>>2]=l;if(I){w=k[H>>2]|0;u=x+((aa(k[c+(h<<2)>>2]|0,w)|0)<<2)|0;v=k[D>>2]|0;t=0;do{p=x+((aa(w,k[c+(t<<2)>>2]|0)|0)<<2)|0;s=p+(v<<2)|0;n=s+-12|0;q=((n>>>0<p>>>0?p:n)+12+(3-p)|0)>>>4<<2;l=u+(q<<2)|0;if(p>>>0<n>>>0){h=p;m=u;j=0.0;while(1){L=+P(+(+o[h>>2]-+o[m>>2]));M=+P(+(+o[h+4>>2]-+o[m+4>>2]));O=+P(+(+o[h+8>>2]-+o[m+8>>2]));j=j+(L+M+O+ +P(+(+o[h+12>>2]-+o[m+12>>2])));h=h+16|0;if(h>>>0>=n>>>0)break;else m=m+16|0}}else j=0.0;h=p+(q<<2)|0;if(h>>>0<s>>>0)while(1){j=j+ +P(+(+o[h>>2]-+o[l>>2]));h=h+4|0;if(h>>>0>=s>>>0)break;else l=l+4|0}O=j*j;o[J>>2]=O;y=g+(t<<2)|0;k[y>>2]=k[(+o[y>>2]<O?y:J)>>2];t=t+1|0}while((t|0)!=(d|0))}}C=C+1|0}while((C|0)!=(b|0));J=428e3;k[J>>2]=B;k[J+4>>2]=z;J=b;k[f>>2]=J;ggb(g);r=K;return}function TKa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=93860;if(i[a+36>>0]|0?(b=k[a+64>>2]|0,b|0):0)ggb(b);c=a+96|0;b=k[c>>2]|0;if(b|0)do{e=b;b=k[b>>2]|0;ggb(e);k[c>>2]=b}while((b|0)!=0);b=k[a+80>>2]|0;c=b;if(b|0){d=a+84|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}b=k[a+40>>2]|0;if(!b){a=a+24|0;a=k[a>>2]|0;YHa(a);return}c=a+44|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);ggb(b);a=a+24|0;a=k[a>>2]|0;YHa(a);return}function UKa(a){a=a|0;TKa(a);ggb(a);return}function VKa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0,p=0,q=0;p=a+80|0;q=a+72|0;e=k[q>>2]|0;f=a+84|0;c=k[f>>2]|0;b=k[p>>2]|0;g=c-b>>3;if(e>>>0<=g>>>0)if(e>>>0<g>>>0?(d=b+(e<<3)|0,(c|0)!=(d|0)):0){k[f>>2]=c+(~((c+-8-d|0)>>>3)<<3);m=e}else m=e;else{gLa(p,e-g|0);m=k[q>>2]|0}e=(m|0)==0;if(!e){c=k[a+16>>2]|0;d=k[p>>2]|0;b=0;do{j=c+(b<<2)|0;k[d+(b<<3)>>2]=k[j>>2];k[d+(b<<3)+4>>2]=k[j>>2];b=b+1|0}while((b|0)!=(m|0))}j=k[a+4>>2]|0;if(j>>>0>1?(n=k[p>>2]|0,!e):0){f=k[a+16>>2]|0;g=k[a+12>>2]|0;d=1;do{h=f+((aa(g,d)|0)<<2)|0;e=0;do{b=h+(e<<2)|0;l=+o[b>>2];c=n+(e<<3)|0;if(l<+o[c>>2]){o[c>>2]=l;l=+o[b>>2]}b=n+(e<<3)+4|0;if(l>+o[b>>2])o[b>>2]=l;e=e+1|0}while((e|0)!=(m|0));d=d+1|0}while((d|0)!=(j|0))}c=a+68|0;p=mLa(a,0,k[c>>2]|0,p)|0;k[a+76>>2]=p;if(!(i[a+36>>0]|0)){q=a+52|0;a=a+4|0;k[q>>2]=k[a>>2];k[q+4>>2]=k[a+4>>2];k[q+8>>2]=k[a+8>>2];k[q+12>>2]=k[a+12>>2];return}d=a+64|0;b=k[d>>2]|0;if(b|0)ggb(b);n=k[c>>2]|0;m=k[q>>2]|0;c=aa(m,n)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[a+52>>2]=n;k[a+56>>2]=m;k[a+60>>2]=m;k[d>>2]=b;if((n|0)==0|(m|0)==0)return;h=k[a+40>>2]|0;j=k[a+16>>2]|0;e=k[a+12>>2]|0;c=0;do{f=j+((aa(e,k[h+(c<<2)>>2]|0)|0)<<2)|0;g=b+((aa(m,c)|0)<<2)|0;d=0;do{k[g+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)!=(m|0));c=c+1|0}while((c|0)!=(n|0));return}function WKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;v=r;r=r+32|0;s=v;k[s>>2]=93920;t=s+12|0;k[t>>2]=e;u=s+16|0;k[u>>2]=0;if(!(k[b>>2]|0)){r=v;return}q=c+12|0;n=c+8|0;p=d+12|0;g=d+8|0;h=s+4|0;i=s+8|0;j=s+20|0;l=b+12|0;m=b+8|0;c=0;d=e;while(1){w=(k[q>>2]|0)+((aa(k[n>>2]|0,c)|0)<<2)|0;e=(k[p>>2]|0)+((aa(k[g>>2]|0,c)|0)<<2)|0;k[h>>2]=w;k[i>>2]=e;k[u>>2]=0;o[j>>2]=3402823466385288598117041.0e14;o[e+(d+-1<<2)>>2]=3402823466385288598117041.0e14;e=(k[l>>2]|0)+((aa(k[m>>2]|0,c)|0)<<2)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,s,e,f);c=c+1|0;if(c>>>0>=(k[b>>2]|0)>>>0)break;d=k[t>>2]|0}r=v;return}function XKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+16|0;p=s;h=a+68|0;q=b+76|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[q>>2]|0)>-1){do if(d){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}b:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break b}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;n=k[b+44>>2]|0;k[b+28>>2]=n;g=b+20|0;k[g>>2]=n;d=n+(k[b+48>>2]|0)|0;k[e>>2]=d;e=n;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;d=c;g=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}c:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;d=h;break c}d=e+-1|0;if((i[h+d>>0]|0)==10)break;else e=d}if((ci[k[b+36>>2]&255](b,h,e)|0)>>>0<e>>>0)break a;f=4-e|0;d=h+e|0;c=k[g>>2]|0}else{f=4;d=h}while(0);upb(c|0,d|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f}while(0);h=a+72|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;d:do if((k[q>>2]|0)>-1){do if(d){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}e:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break e}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}f:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break f}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+80|0;k[p>>2]=(k[a+84>>2]|0)-(k[h>>2]|0)>>3;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;g:do if((k[q>>2]|0)>-1){do if(d){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,p,4)|0;break}h:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=p;c=f;break h}c=d+-1|0;if((i[p+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,p,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=p+d|0;c=k[g>>2]|0}else{e=4;d=p;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,p,4)|0;break}i:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=p;c=f;break i}c=d+-1|0;if((i[p+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,p,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=p+d|0;c=k[g>>2]|0}else{e=4;d=p;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);d=k[h>>2]|0;h=k[p>>2]<<3;f=b+16|0;c=k[f>>2]|0;e=(c|0)==0;j:do if((k[q>>2]|0)>-1){do if(e){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;n=k[b+44>>2]|0;k[b+28>>2]=n;g=b+20|0;k[g>>2]=n;e=n+(k[b+48>>2]|0)|0;k[f>>2]=e;f=n;break}else{k[b>>2]=c|32;break j}}else{f=b+20|0;e=c;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;break}k:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break k}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0)break j;e=h-f|0;d=d+f|0;c=k[g>>2]|0}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(e){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;n=k[b+44>>2]|0;k[b+28>>2]=n;g=b+20|0;k[g>>2]=n;e=n+(k[b+48>>2]|0)|0;k[f>>2]=e;f=n;break}else{k[b>>2]=c|32;break j}}else{f=b+20|0;e=c;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;break}l:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break l}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0)break j;e=h-f|0;d=d+f|0;c=k[g>>2]|0}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);n=a+36|0;l=i[n>>0]|0;m=l<<24>>24;h=i[b+75>>0]|0;c=h<<24>>24==l<<24>>24;do if((k[q>>2]|0)<0){if(!c){c=b+20|0;d=k[c>>2]|0;e=b+16|0;f=k[e>>2]|0;if(d>>>0<f>>>0){k[c>>2]=d+1;i[d>>0]=l;break}else c=f}else{c=b+16|0;e=c;c=k[c>>2]|0}i[p>>0]=l;do if(!c){c=b+74|0;d=j[c>>1]|0;h=(d&65535)<<24>>24;i[c>>0]=h+255|h;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;g=k[b+44>>2]|0;k[b+28>>2]=g;f=b+20|0;k[f>>2]=g;c=g+(k[b+48>>2]|0)|0;k[e>>2]=c;e=c;c=(d&65535)>>>8&255;o=119;break}else{k[b>>2]=c|32;break}}else{g=b+20|0;f=g;g=k[g>>2]|0;e=c;c=h;o=119}while(0);do if((o|0)==119){if(g>>>0<e>>>0?(m&255|0)!=(c<<24>>24|0):0){k[f>>2]=g+1;i[g>>0]=l;break}ci[k[b+36>>2]&255](b,p,1)|0}while(0)}else{if(!c){c=b+20|0;d=k[c>>2]|0;e=b+16|0;f=k[e>>2]|0;if(d>>>0<f>>>0){k[c>>2]=d+1;i[d>>0]=l;break}else c=f}else{c=b+16|0;e=c;c=k[c>>2]|0}i[p>>0]=l;do if(!c){c=b+74|0;d=j[c>>1]|0;h=(d&65535)<<24>>24;i[c>>0]=h+255|h;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;g=k[b+44>>2]|0;k[b+28>>2]=g;f=b+20|0;k[f>>2]=g;c=g+(k[b+48>>2]|0)|0;k[e>>2]=c;e=c;c=(d&65535)>>>8&255;o=133;break}else{k[b>>2]=c|32;break}}else{g=b+20|0;f=g;g=k[g>>2]|0;e=c;c=h;o=133}while(0);do if((o|0)==133){if(g>>>0<e>>>0?(m&255|0)!=(c<<24>>24|0):0){k[f>>2]=g+1;i[g>>0]=l;break}ci[k[b+36>>2]&255](b,p,1)|0}while(0)}while(0);h=a+32|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;m:do if((k[q>>2]|0)>-1){do if(d){c=b+74|0;o=i[c>>0]|0;i[c>>0]=o+255|o;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break m}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}n:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break n}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break m;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;o=i[c>>0]|0;i[c>>0]=o+255|o;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break m}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}o:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break o}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break m;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+40|0;k[p>>2]=(k[a+44>>2]|0)-(k[h>>2]|0)>>2;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;p:do if((k[q>>2]|0)>-1){do if(d){c=b+74|0;o=i[c>>0]|0;i[c>>0]=o+255|o;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break p}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,p,4)|0;break}q:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=p;c=f;break q}c=d+-1|0;if((i[p+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,p,d)|0)>>>0<d>>>0)break p;e=4-d|0;d=p+d|0;c=k[g>>2]|0}else{e=4;d=p;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;o=i[c>>0]|0;i[c>>0]=o+255|o;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break p}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,p,4)|0;break}r:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=p;c=f;break r}c=d+-1|0;if((i[p+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,p,d)|0)>>>0<d>>>0)break p;e=4-d|0;d=p+d|0;c=k[g>>2]|0}else{e=4;d=p;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);d=k[h>>2]|0;h=k[p>>2]<<2;f=b+16|0;c=k[f>>2]|0;e=(c|0)==0;s:do if((k[q>>2]|0)>-1){do if(e){c=b+74|0;p=i[c>>0]|0;i[c>>0]=p+255|p;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;p=k[b+44>>2]|0;k[b+28>>2]=p;g=b+20|0;k[g>>2]=p;e=p+(k[b+48>>2]|0)|0;k[f>>2]=e;f=p;break}else{k[b>>2]=c|32;break s}}else{f=b+20|0;e=c;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;break}t:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break t}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0)break s;e=h-f|0;d=d+f|0;c=k[g>>2]|0}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(e){c=b+74|0;p=i[c>>0]|0;i[c>>0]=p+255|p;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;p=k[b+44>>2]|0;k[b+28>>2]=p;g=b+20|0;k[g>>2]=p;e=p+(k[b+48>>2]|0)|0;k[f>>2]=e;f=p;break}else{k[b>>2]=c|32;break s}}else{f=b+20|0;e=c;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;break}u:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break u}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0)break s;e=h-f|0;d=d+f|0;c=k[g>>2]|0}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);if(!(i[n>>0]|0)){a=a+76|0;a=k[a>>2]|0;hLa(b,a);r=s;return}h=a+52|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;v:do if((k[q>>2]|0)>-1){do if(d){c=b+74|0;p=i[c>>0]|0;i[c>>0]=p+255|p;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break v}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<16){ci[k[b+36>>2]&255](b,h,16)|0;break}w:do if((i[b+75>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=h;c=f;break w}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break v;e=16-d|0;d=h+d|0;c=k[g>>2]|0}else{e=16;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;p=i[c>>0]|0;i[c>>0]=p+255|p;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break v}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<16){ci[k[b+36>>2]&255](b,h,16)|0;break}x:do if((i[b+75>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=h;c=f;break x}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break v;e=16-d|0;d=h+d|0;c=k[g>>2]|0}else{e=16;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);d=k[a+64>>2]|0;h=(aa(k[a+56>>2]|0,k[h>>2]|0)|0)<<2;f=b+16|0;e=k[f>>2]|0;c=(e|0)==0;if((k[q>>2]|0)>-1){do if(c){c=b+74|0;q=i[c>>0]|0;i[c>>0]=q+255|q;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;q=k[b+44>>2]|0;k[b+28>>2]=q;g=b+20|0;k[g>>2]=q;e=q+(k[b+48>>2]|0)|0;k[f>>2]=e;f=q;break}k[b>>2]=c|32;a=a+76|0;a=k[a>>2]|0;hLa(b,a);r=s;return}else{f=b+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;a=a+76|0;a=k[a>>2]|0;hLa(b,a);r=s;return}y:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break y}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0){a=a+76|0;a=k[a>>2]|0;hLa(b,a);r=s;return}else{e=h-f|0;d=d+f|0;c=k[g>>2]|0;break}}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e;a=a+76|0;a=k[a>>2]|0;hLa(b,a);r=s;return}else{do if(c){c=b+74|0;q=i[c>>0]|0;i[c>>0]=q+255|q;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;q=k[b+44>>2]|0;k[b+28>>2]=q;g=b+20|0;k[g>>2]=q;e=q+(k[b+48>>2]|0)|0;k[f>>2]=e;f=q;break}k[b>>2]=c|32;a=a+76|0;a=k[a>>2]|0;hLa(b,a);r=s;return}else{f=b+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;a=a+76|0;a=k[a>>2]|0;hLa(b,a);r=s;return}z:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break z}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0){a=a+76|0;a=k[a>>2]|0;hLa(b,a);r=s;return}else{e=h-f|0;d=d+f|0;c=k[g>>2]|0;break}}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e;a=a+76|0;a=k[a>>2]|0;hLa(b,a);r=s;return}}function YKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o+8|0;m=o;if((_fb(a+68|0,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}if((_fb(a+72|0,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}d=a+80|0;if((_fb(n,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}l=k[n>>2]|0;e=a+84|0;h=k[e>>2]|0;c=k[d>>2]|0;f=h-c>>3;g=c;if(l>>>0<=f>>>0){if(l>>>0<f>>>0?(j=g+(l<<3)|0,(h|0)!=(j|0)):0)k[e>>2]=h+(~((h+-8-j|0)>>>3)<<3)}else{gLa(d,l-f|0);c=k[d>>2]|0}if((_fb(c,8,l,b)|0)!=(l|0)){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}l=a+36|0;if((_fb(l,1,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}j=a+32|0;if((_fb(j,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}eLa(b,a+40|0);c=a+52|0;if(!(i[l>>0]|0)){h=a+4|0;k[c>>2]=k[h>>2];k[c+4>>2]=k[h+4>>2];k[c+8>>2]=k[h+8>>2];k[c+12>>2]=k[h+12>>2]}else vIa(b,c);fLa(a,b,a+76|0);h=a+20|0;c=n+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373358;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));b=WHa(h,n)|0;g=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[m>>2]=g;g=k[b>>2]|0;a=b+4|0;jh[k[k[g>>2]>>2]&1023](g,a);k[b>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,m,a);k[c>>2]=0;k[n>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0);c=n+4|0;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=13;i[d+17>>0]=0;f=375545;g=e+13|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));a=WHa(h,n)|0;b=k[a>>2]|0;m=a+4|0;jh[k[k[b>>2]>>2]&1023](b,m);k[a>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,j,m);k[c>>2]=0;k[n>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0);m=n+4|0;c=ZT(12)|0;k[c>>2]=1;b=c+4|0;k[n>>2]=b;k[m>>2]=7;i[c+11>>0]=0;i[b>>0]=i[375559]|0;i[b+1>>0]=i[375560]|0;i[b+2>>0]=i[375561]|0;i[b+3>>0]=i[375562]|0;i[b+4>>0]=i[375563]|0;i[b+5>>0]=i[375564]|0;i[b+6>>0]=i[375565]|0;b=WHa(h,n)|0;j=k[b>>2]|0;a=b+4|0;jh[k[k[j>>2]>>2]&1023](j,a);k[b>>2]=428720;Ph[k[(k[107180]|0)+4>>2]&511](428720,l,a);k[m>>2]=0;k[n>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)!=1){r=o;return}ggb(k[c+-4>>2]|0);r=o;return}function ZKa(a){a=a|0;return k[a+68>>2]|0}function _Ka(a){a=a|0;return k[a+72>>2]|0}function $Ka(a){a=a|0;return (k[a+112>>2]|0)+(k[a+108>>2]|0)+(k[a+4>>2]<<2)|0}function aLa(a){a=a|0;return 4}function bLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+20>>2]|0;f=b+24|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function cLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0.0,j=0.0,l=0,m=0,n=0.0,p=0,q=0,s=0;s=r;r=r+16|0;q=s;e=ZT(8)|0;k[e>>2]=1;p=e+4|0;i[e+7>>0]=0;i[p>>0]=i[374006]|0;i[p+1>>0]=i[374007]|0;i[p+2>>0]=i[374008]|0;o[q>>2]=0.0;n=+sJa(d,p,q);p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0);l=a+72|0;m=k[l>>2]|0;k[q>>2]=0;p=q+4|0;k[p>>2]=0;k[q+8>>2]=0;if(m){if(m>>>0>1073741823)ad(426534,426557,304,426811);e=m<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[p>>2]=d;k[q>>2]=d;k[q+8>>2]=d+(m<<2);e=m;g=d;while(1){k[g>>2]=0;e=e+-1|0;if(!e)break;else g=g+4|0}k[p>>2]=d+(m<<2);g=k[l>>2]|0;if(g){l=k[a+80>>2]|0;m=k[q>>2]|0;f=0.0;e=0;do{d=c+(e<<2)|0;j=+o[d>>2];h=+o[l+(e<<3)>>2];if(j<h){j=+P(+(j-h));o[m+(e<<2)>>2]=j;f=f+j;j=+o[d>>2]}h=+o[l+(e<<3)+4>>2];if(j>h){j=+P(+(j-h));o[m+(e<<2)>>2]=j;f=f+j}e=e+1|0}while((e|0)!=(g|0))}else f=0.0}else f=0.0;dLa(a,b,c,k[a+76>>2]|0,f,q,n+1.0);d=k[q>>2]|0;if(!d){r=s;return}e=k[p>>2]|0;if((e|0)!=(d|0))k[p>>2]=e+(~((e+-4-d|0)>>>2)<<2);ggb(d);r=s;return}function dLa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=+g;var h=0.0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0;l=d+20|0;j=d+24|0;if((k[l>>2]|0)==0?(k[j>>2]|0)==0:0){h=+hg[k[(k[b>>2]|0)+16>>2]&127](b);j=k[d>>2]|0;t=d+4|0;d=k[t>>2]|0;if((j|0)>=(d|0))return;u=a+36|0;v=a+40|0;w=a+64|0;x=a+60|0;q=a+72|0;r=h>0.0;s=3-c|0;p=j;do{if(!(i[u>>0]|0))j=k[(k[v>>2]|0)+(p<<2)>>2]|0;else j=p;l=(k[w>>2]|0)+((aa(k[x>>2]|0,j)|0)<<2)|0;n=c+(k[q>>2]<<2)|0;a=n+-12|0;a:do if(r){j=c;e=0.0;while(1){if(j>>>0>=a>>>0){m=12;break a}z=+P(+(+o[j>>2]-+o[l>>2]));y=+P(+(+o[j+4>>2]-+o[l+4>>2]));g=+P(+(+o[j+8>>2]-+o[l+8>>2]));e=e+(z+y+g+ +P(+(+o[j+12>>2]-+o[l+12>>2])));if(e>h)break;else{j=j+16|0;l=l+16|0}}}else{m=((a>>>0<c>>>0?c:a)+12+s|0)>>>4<<2;f=l+(m<<2)|0;if(a>>>0>c>>>0){j=c;e=0.0;while(1){g=+P(+(+o[j>>2]-+o[l>>2]));y=+P(+(+o[j+4>>2]-+o[l+4>>2]));z=+P(+(+o[j+8>>2]-+o[l+8>>2]));e=e+(g+y+z+ +P(+(+o[j+12>>2]-+o[l+12>>2])));j=j+16|0;if(j>>>0>=a>>>0)break;else l=l+16|0}}else e=0.0;j=c+(m<<2)|0;l=f;m=12}while(0);if((m|0)==12){m=0;if(j>>>0<n>>>0)while(1){e=e+ +P(+(+o[j>>2]-+o[l>>2]));j=j+4|0;if(j>>>0>=n>>>0)break;else l=l+4|0}}if(e<h){$f[k[(k[b>>2]|0)+12>>2]&15](b,e,k[(k[v>>2]|0)+(p<<2)>>2]|0);d=k[t>>2]|0}p=p+1|0}while((p|0)<(d|0));return}m=k[d+8>>2]|0;h=+o[c+(m<<2)>>2];z=h-+o[d+12>>2];h=h-+o[d+16>>2];x=z+h<0.0;d=k[(x?j:l)>>2]|0;z=+P(+(x?h:z));dLa(a,b,c,k[(x?l:j)>>2]|0,e,f,g);x=(k[f>>2]|0)+(m<<2)|0;h=+o[x>>2];e=z+e-h;o[x>>2]=z;if(e*g<=+hg[k[(k[b>>2]|0)+16>>2]&127](b))dLa(a,b,c,d,e,f,g);o[(k[f>>2]|0)+(m<<2)>>2]=h;return}function eLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=r;r=r+16|0;c=j;if((_fb(c,4,1,a)|0)!=1){j=te(44)|0;VHa(j,373124);Cf(j|0,19720,57)}i=k[c>>2]|0;g=b+4|0;f=k[g>>2]|0;c=k[b>>2]|0;d=f-c>>2;e=c;if(i>>>0<=d>>>0){if(i>>>0<d>>>0?(h=e+(i<<2)|0,(f|0)!=(h|0)):0)k[g>>2]=f+(~((f+-4-h|0)>>>2)<<2)}else{U1(b,i-d|0);c=k[b>>2]|0}if((_fb(c,4,i,a)|0)==(i|0)){r=j;return}else{j=te(44)|0;VHa(j,373124);Cf(j|0,19720,57)}}function fLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;g=a+92|0;h=a+112|0;j=a+96|0;l=a+100|0;m=a+108|0;while(1){e=k[g>>2]|0;a:do if((e|0)<32){k[h>>2]=(k[h>>2]|0)+e;d=fgb(8192)|0;if(d|0){k[d>>2]=k[j>>2];k[j>>2]=d;k[g>>2]=8188;d=d+4|0;k[l>>2]=d;e=8156;n=29;break}d=k[41482]|0;e=(d|0)==0;if((k[41497]|0)>-1){do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}else{do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}}else{d=k[l>>2]|0;e=e+-32|0;n=29}while(0);if((n|0)==29){n=0;k[l>>2]=d+32;k[g>>2]=e;k[m>>2]=(k[m>>2]|0)+32}k[c>>2]=d;if((_fb(d,28,1,b)|0)!=1){n=31;break}d=k[c>>2]|0;e=d+20|0;if(!(k[e>>2]|0))c=d;else{fLa(a,b,e);c=k[c>>2]|0}c=c+24|0;if(!(k[c>>2]|0)){n=35;break}}if((n|0)==31){n=te(44)|0;VHa(n,373124);Cf(n|0,19720,57)}else if((n|0)==35)return}function gLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+8|0;e=k[i>>2]|0;j=a+4|0;c=k[j>>2]|0;if(e-c>>3>>>0>=b>>>0){do{i=c;k[i>>2]=0;k[i+4>>2]=0;c=(k[j>>2]|0)+8|0;k[j>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=c-d>>3;c=f+b|0;if(c>>>0>536870911)ad(426534,426557,304,426811);g=e-d|0;h=g>>2;h=g>>3>>>0<268435455?(h>>>0<c>>>0?c:h):536870911;if(!h)c=0;else{if(h>>>0>536870911){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=h<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}g=c+(f<<3)|0;d=g;f=g;do{e=d;k[e>>2]=0;k[e+4>>2]=0;d=f+8|0;f=d;b=b+-1|0}while((b|0)!=0);d=k[a>>2]|0;e=(k[j>>2]|0)-d|0;b=g+(0-(e>>3)<<3)|0;if((e|0)>0)upb(b|0,d|0,e|0)|0;k[a>>2]=b;k[j>>2]=f;k[i>>2]=c+(h<<3);if(!d)return;ggb(d);return}function hLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=a+76|0;m=a+16|0;n=a+74|0;o=a+8|0;p=a+4|0;q=a+44|0;r=a+28|0;s=a+20|0;g=a+48|0;h=a+36|0;j=a+75|0;do{c=k[m>>2]|0;d=(c|0)==0;a:do if((k[l>>2]|0)>-1){do if(d){c=i[n>>0]|0;i[n>>0]=c+255|c;c=k[a>>2]|0;if(!(c&8)){k[o>>2]=0;k[p>>2]=0;d=k[q>>2]|0;k[r>>2]=d;k[s>>2]=d;c=d+(k[g>>2]|0)|0;k[m>>2]=c;break}else{k[a>>2]=c|32;break a}}else d=k[s>>2]|0;while(0);f=d;if((c-d|0)>>>0<28){ci[k[h>>2]&255](a,b,28)|0;break}b:do if((i[j>>0]|0)>-1){d=28;while(1){if(!d){e=28;d=b;c=f;break b}c=d+-1|0;if((i[b+c>>0]|0)==10)break;else d=c}if((ci[k[h>>2]&255](a,b,d)|0)>>>0<d>>>0)break a;e=28-d|0;d=b+d|0;c=k[s>>2]|0}else{e=28;d=b;c=f}while(0);upb(c|0,d|0,e|0)|0;k[s>>2]=(k[s>>2]|0)+e}else{do if(d){c=i[n>>0]|0;i[n>>0]=c+255|c;c=k[a>>2]|0;if(!(c&8)){k[o>>2]=0;k[p>>2]=0;d=k[q>>2]|0;k[r>>2]=d;k[s>>2]=d;c=d+(k[g>>2]|0)|0;k[m>>2]=c;break}else{k[a>>2]=c|32;break a}}else d=k[s>>2]|0;while(0);f=d;if((c-d|0)>>>0<28){ci[k[h>>2]&255](a,b,28)|0;break}c:do if((i[j>>0]|0)>-1){d=28;while(1){if(!d){e=28;d=b;c=f;break c}c=d+-1|0;if((i[b+c>>0]|0)==10)break;else d=c}if((ci[k[h>>2]&255](a,b,d)|0)>>>0<d>>>0)break a;e=28-d|0;d=b+d|0;c=k[s>>2]|0}else{e=28;d=b;c=f}while(0);upb(c|0,d|0,e|0)|0;k[s>>2]=(k[s>>2]|0)+e}while(0);c=k[b+20>>2]|0;if(c|0)hLa(a,c);b=k[b+24>>2]|0}while((b|0)!=0);return}function iLa(a){a=a|0;ggb(a);return}function jLa(a){a=a|0;return (k[a+16>>2]|0)==(k[a+12>>2]|0)|0}function kLa(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0.0,h=0,i=0,j=0,l=0,m=0;j=a+20|0;if(+o[j>>2]<=b)return;l=a+16|0;e=k[l>>2]|0;if((e|0)>0){h=k[a+8>>2]|0;f=a+12|0;i=a+4|0;d=e;while(1){e=d+-1|0;g=+o[h+(e<<2)>>2];if(!(g>b))break;if((d|0)<(k[f>>2]|0)){o[h+(d<<2)>>2]=g;m=k[i>>2]|0;k[m+(d<<2)>>2]=k[m+(e<<2)>>2]}if((d|0)>1)d=e;else{d=e;break}}e=k[l>>2]|0}else{d=e;f=a+12|0}if((e|0)<(k[f>>2]|0))k[l>>2]=e+1;m=k[a+8>>2]|0;o[m+(d<<2)>>2]=b;k[(k[a+4>>2]|0)+(d<<2)>>2]=c;k[j>>2]=k[m+((k[f>>2]|0)+-1<<2)>>2];return}function lLa(a){a=a|0;return +(+o[a+20>>2])}function mLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0.0,v=0.0,w=0,x=0.0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+32|0;G=J+12|0;H=J;j=a+92|0;e=k[j>>2]|0;a:do if((e|0)<32){I=a+112|0;k[I>>2]=(k[I>>2]|0)+e;e=fgb(8192)|0;if(e|0){g=a+96|0;k[e>>2]=k[g>>2];k[g>>2]=e;k[j>>2]=8188;g=e+4|0;f=a+100|0;k[f>>2]=g;e=8188;l=28;break}e=k[41482]|0;f=(e|0)==0;if((k[41497]|0)>-1){do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;I=0;break a}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;I=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){I=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;I=0;break}else{do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;I=0;break a}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;I=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){I=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;I=0;break}}else{g=a+100|0;f=g;g=k[g>>2]|0;l=28}while(0);if((l|0)==28){k[f>>2]=g+32;k[j>>2]=e+-32;I=a+108|0;k[I>>2]=(k[I>>2]|0)+32;I=g}D=c-b|0;if((D|0)<=(k[a+32>>2]|0)){k[I+24>>2]=0;k[I+20>>2]=0;k[I>>2]=b;k[I+4>>2]=c;s=k[a+72>>2]|0;j=(s|0)==0;if(!j){f=(k[a+16>>2]|0)+((aa(k[a+12>>2]|0,k[(k[a+40>>2]|0)+(b<<2)>>2]|0)|0)<<2)|0;g=k[d>>2]|0;e=0;do{H=f+(e<<2)|0;k[g+(e<<3)>>2]=k[H>>2];k[g+(e<<3)+4>>2]=k[H>>2];e=e+1|0}while((e|0)!=(s|0))}e=b+1|0;if((e|0)>=(c|0)){r=J;return I|0}q=k[d>>2]|0;if(j){r=J;return I|0}n=k[a+40>>2]|0;p=k[a+16>>2]|0;m=k[a+12>>2]|0;do{l=p+((aa(m,k[n+(e<<2)>>2]|0)|0)<<2)|0;j=0;do{f=q+(j<<3)|0;g=l+(j<<2)|0;h=+o[g>>2];if(+o[f>>2]>h){o[f>>2]=h;h=+o[g>>2]}f=q+(j<<3)+4|0;if(+o[f>>2]<h)o[f>>2]=h;j=j+1|0}while((j|0)!=(s|0));e=e+1|0}while((e|0)!=(c|0));r=J;return I|0}C=(k[a+40>>2]|0)+(b<<2)|0;B=k[d>>2]|0;t=+o[B+4>>2];v=+o[B>>2];h=t-v;F=a+72|0;A=k[F>>2]|0;E=B;if(A>>>0>1){e=1;do{z=+o[B+(e<<3)+4>>2]-+o[B+(e<<3)>>2];h=z>h?z:h;e=e+1|0}while((e|0)!=(A|0))}b:do if(!A){A=0;e=a+16|0;f=a+12|0;w=0}else{z=h*.9999899864196777;e=a+16|0;f=a+12|0;if((D|0)>1){g=0;x=-1.0;y=0;h=t;l=0}else{h=-1.0;m=0;g=0;j=0;while(1){if(t-v>z?(y=(k[e>>2]|0)+((aa(k[f>>2]|0,k[C>>2]|0)|0)<<2)+(j<<2)|0,x=+o[y>>2],x=x-x,x>h):0){h=x;g=m;j=m}l=m+1|0;if(l>>>0>=A>>>0){A=g;w=j;break b}m=l;v=+o[B+(l<<3)>>2];t=+o[B+(l<<3)+4>>2]}}while(1){if(h-v>z){q=k[e>>2]|0;s=k[f>>2]|0;w=q+((aa(s,k[C>>2]|0)|0)<<2)+(l<<2)|0;w=k[w>>2]|0;m=1;n=w;p=w;h=(k[u>>2]=w,+o[u>>2]);while(1){j=q+((aa(k[C+(m<<2)>>2]|0,s)|0)<<2)+(l<<2)|0;t=+o[j>>2];j=t<(k[u>>2]=p,+o[u>>2]);w=(o[u>>2]=t,k[u>>2]|0);p=j?w:p;h=j?(k[u>>2]=n,+o[u>>2]):h;j=t>h;n=j?w:n;m=m+1|0;if((m|0)==(D|0))break;else h=j?t:h}h=(k[u>>2]=n,+o[u>>2]);h=h-(k[u>>2]=p,+o[u>>2]);if(h>x){g=y;l=y}else h=x}else h=x;j=y+1|0;if(j>>>0>=A>>>0){A=g;w=l;break b}x=h;y=j;v=+o[B+(j<<3)>>2];h=+o[B+(j<<3)+4>>2]}}while(0);v=(+o[B+(w<<3)>>2]+ +o[B+(w<<3)+4>>2])*.5;n=k[e>>2]|0;m=k[f>>2]|0;g=n+((aa(m,k[C>>2]|0)|0)<<2)+(w<<2)|0;g=k[g>>2]|0;if((D|0)>1){l=1;f=g;e=g;h=(k[u>>2]=g,+o[u>>2]);while(1){B=n+((aa(k[C+(l<<2)>>2]|0,m)|0)<<2)+(w<<2)|0;t=+o[B>>2];B=t<(k[u>>2]=e,+o[u>>2]);g=(o[u>>2]=t,k[u>>2]|0);e=B?g:e;h=B?(k[u>>2]=f,+o[u>>2]):h;j=t>h;f=j?g:f;l=l+1|0;if((l|0)==(D|0))break;else h=j?t:h}}else{f=g;e=g}h=(k[u>>2]=e,+o[u>>2]);if(!(v<h)){h=(k[u>>2]=f,+o[u>>2]);if(v>h)y=f;else{y=(o[u>>2]=v,k[u>>2]|0);h=v}}else y=e;p=D+-1|0;q=a+16|0;s=a+12|0;n=p;e=0;c:while(1){d:do if((e|0)<=(n|0)){g=k[q>>2]|0;j=k[s>>2]|0;while(1){B=g+((aa(j,k[C+(e<<2)>>2]|0)|0)<<2)+(w<<2)|0;if(!(+o[B>>2]<h))break d;f=e+1|0;if((e|0)<(n|0))e=f;else{e=f;break}}}while(0);if((e|0)>(n|0)){f=e;break}l=k[q>>2]|0;m=k[s>>2]|0;f=n;while(1){g=C+(f<<2)|0;j=k[g>>2]|0;B=l+((aa(m,j)|0)<<2)+(w<<2)|0;if(!(+o[B>>2]>=h))break;if((e|0)<(f|0))f=f+-1|0;else{f=e;break c}}B=C+(e<<2)|0;n=k[B>>2]|0;k[B>>2]=j;k[g>>2]=n;n=f+-1|0;e=e+1|0}e:while(1){f:do if((f|0)<=(p|0)){j=k[q>>2]|0;l=k[s>>2]|0;while(1){B=j+((aa(l,k[C+(f<<2)>>2]|0)|0)<<2)+(w<<2)|0;if(!(+o[B>>2]<=h))break f;g=f+1|0;if((f|0)<(p|0))f=g;else{f=g;break}}}while(0);if((f|0)>(p|0))break;m=k[q>>2]|0;n=k[s>>2]|0;g=p;while(1){j=C+(g<<2)|0;l=k[j>>2]|0;B=m+((aa(n,l)|0)<<2)+(w<<2)|0;if(!(+o[B>>2]>h))break;if((f|0)<(g|0))g=g+-1|0;else break e}B=C+(f<<2)|0;p=k[B>>2]|0;k[B>>2]=l;k[j>>2]=p;p=g+-1|0;f=f+1|0}j=(D|0)/2|0;j=(e|0)>(j|0)?e:(f|0)<(j|0)?f:j;k[I+8>>2]=A;k[G>>2]=0;p=G+4|0;k[p>>2]=0;k[G+8>>2]=0;l=d+4|0;e=(k[l>>2]|0)-E|0;g=e>>3;if(g>>>0>536870911)ad(426534,426557,304,426811);f=(e|0)==0?1:e;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[p>>2]=e;k[G>>2]=e;k[G+8>>2]=e+(g<<3);f=k[d>>2]|0;g=(k[l>>2]|0)-f|0;if((g|0)>0){upb(e|0,f|0,g|0)|0;k[p>>2]=e+(g>>3<<3)}k[e+(A<<3)+4>>2]=y;j=j+b|0;n=mLa(a,b,j,G)|0;k[I+20>>2]=n;k[H>>2]=0;n=H+4|0;k[n>>2]=0;k[H+8>>2]=0;e=(k[l>>2]|0)-(k[d>>2]|0)|0;g=e>>3;if(g>>>0>536870911)ad(426534,426557,304,426811);f=(e|0)==0?1:e;while(1){e=fgb(f)|0;if(e|0){m=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){m=0;break}Qh[e&7]()}k[n>>2]=m;k[H>>2]=m;k[H+8>>2]=m+(g<<3);f=k[d>>2]|0;e=(k[l>>2]|0)-f|0;if((e|0)>0){upb(m|0,f|0,e|0)|0;l=m+(e>>3<<3)|0;k[n>>2]=l}else l=m;k[m+(A<<3)>>2]=y;j=mLa(a,j,c,H)|0;k[I+24>>2]=j;j=k[G>>2]|0;k[I+12>>2]=k[j+(A<<3)+4>>2];k[I+16>>2]=k[m+(A<<3)>>2];g=k[F>>2]|0;if(g|0){f=k[d>>2]|0;e=0;do{c=j+(e<<3)|0;a=m+(e<<3)|0;k[f+(e<<3)>>2]=k[(+o[a>>2]<+o[c>>2]?a:c)>>2];c=j+(e<<3)+4|0;a=m+(e<<3)+4|0;k[f+(e<<3)+4>>2]=k[(+o[c>>2]<+o[a>>2]?a:c)>>2];e=e+1|0}while((e|0)!=(g|0))}if((l|0)!=(m|0))k[n>>2]=l+(~((l+-8-m|0)>>>3)<<3);ggb(m);e=j;if(j|0){f=k[p>>2]|0;if((f|0)!=(j|0))k[p>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(j)}r=J;return I|0}function nLa(a){a=a|0;k[a>>2]=93948;YHa(k[a+24>>2]|0);return}function oLa(a){a=a|0;k[a>>2]=93948;YHa(k[a+24>>2]|0);ggb(a);return}function pLa(a){a=a|0;return}function qLa(a,b){a=a|0;b=b|0;return}function rLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;b=h+8|0;c=h;d=a+20|0;e=b+4|0;f=ZT(16)|0;k[f>>2]=1;g=f+4|0;k[b>>2]=g;k[e>>2]=9;i[f+13>>0]=0;j=373358;l=g+9|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));l=WHa(d,b)|0;j=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[c>>2]=j;j=k[l>>2]|0;a=l+4|0;jh[k[k[j>>2]>>2]&1023](j,a);k[l>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,c,a);k[e>>2]=0;k[b>>2]=0;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1){r=h;return}ggb(k[f+-4>>2]|0);r=h;return}function sLa(a){a=a|0;return k[a+4>>2]|0}function tLa(a){a=a|0;return k[a+8>>2]|0}function uLa(a){a=a|0;return 0}function vLa(a){a=a|0;return 0}function wLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+20>>2]|0;f=b+24|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function xLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0.0,q=0.0,r=0.0;m=a+4|0;if(!(k[m>>2]|0))return;n=a+8|0;l=0;j=k[a+16>>2]|0;d=k[n>>2]|0;while(1){i=j+(d<<2)|0;g=i+-12|0;h=((g>>>0<j>>>0?j:g)+12+(3-j)|0)>>>4<<2;a=c+(h<<2)|0;if(j>>>0<g>>>0){d=j;f=c;e=0.0;while(1){r=+P(+(+o[d>>2]-+o[f>>2]));q=+P(+(+o[d+4>>2]-+o[f+4>>2]));p=+P(+(+o[d+8>>2]-+o[f+8>>2]));e=e+(r+q+p+ +P(+(+o[d+12>>2]-+o[f+12>>2])));d=d+16|0;if(d>>>0>=g>>>0)break;else f=f+16|0}}else e=0.0;d=j+(h<<2)|0;if(d>>>0<i>>>0)while(1){e=e+ +P(+(+o[d>>2]-+o[a>>2]));d=d+4|0;if(d>>>0>=i>>>0)break;else a=a+4|0}$f[k[(k[b>>2]|0)+12>>2]&15](b,e,l);l=l+1|0;d=k[n>>2]|0;if(l>>>0>=(k[m>>2]|0)>>>0)break;else j=j+(d<<2)|0}return}function yLa(a){a=a|0;var b=0;k[a>>2]=93196;b=k[a+4>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);YHa(k[a+16>>2]|0);return}function zLa(a){a=a|0;var b=0;k[a>>2]=93196;b=k[a+4>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);YHa(k[a+16>>2]|0);ggb(a);return}function ALa(a){a=a|0;if(i[a+8>>0]|0)return;a=k[a+4>>2]|0;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);return}function BLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=k[a+4>>2]|0;Lg[k[(k[a>>2]|0)+12>>2]&255](a,b,c,d,e,f);return}function CLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;a=k[a+4>>2]|0;return li[k[(k[a>>2]|0)+16>>2]&7](a,b,c,d,e,f)|0}function DLa(a,b){a=a|0;b=b|0;a=k[a+4>>2]|0;jh[k[(k[a>>2]|0)+20>>2]&1023](a,b);return}function ELa(a,b){a=a|0;b=b|0;a=k[a+4>>2]|0;jh[k[(k[a>>2]|0)+24>>2]&1023](a,b);return}function FLa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+28>>2]&1023](a)|0}function GLa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+32>>2]&1023](a)|0}function HLa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0}function ILa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0}function JLa(a,b){a=a|0;b=b|0;b=k[b+4>>2]|0;jh[k[(k[b>>2]|0)+44>>2]&1023](a,b);return}function KLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=k[a+4>>2]|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,b,c,d);return}function LLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;v=r;r=r+96|0;p=v+48|0;q=v+32|0;s=v+24|0;o=v+16|0;t=v+8|0;u=v;k[a>>2]=94008;n=a+12|0;h=a+16|0;k[h>>2]=0;j=a+20|0;k[j>>2]=0;l=a+16|0;k[n>>2]=l;d=k[c>>2]|0;m=c+4|0;if((d|0)!=(m|0)){e=d;while(1){f=e+16|0;g=ZHa(n,l,p,f)|0;if(!(k[g>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){f=f+-4|0;k[f>>2]=(k[f>>2]|0)+1}x=d+24|0;k[x>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);w=k[e+24>>2]|0;k[x>>2]=w;Ph[k[(k[w>>2]|0)+8>>2]&511](w,e+28|0,f);f=k[p>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[n>>2]>>2]|0;if(f){k[n>>2]=f;d=k[g>>2]|0}B4(k[h>>2]|0,d);k[j>>2]=(k[j>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(m|0))break;else e=d}}k[o>>2]=0;e=o+4|0;k[e>>2]=0;f=ZT(16)|0;k[f>>2]=1;h=f+4|0;k[o>>2]=h;k[e>>2]=9;i[f+13>>0]=0;j=373358;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));d=_Ha(c,o)|0;k[e>>2]=0;k[o>>2]=0;x=k[f>>2]|0;k[f>>2]=x+-1;if((x|0)==1)ggb(k[f+-4>>2]|0);n=a+8|0;i[n>>0]=0;if((d|0)!=254){x=MLa(b,c)|0;k[a+4>>2]=x;r=v;return}k[u>>2]=0;m=u+4|0;k[m>>2]=0;g=ZT(16)|0;k[g>>2]=1;d=g+4|0;k[u>>2]=d;k[m>>2]=8;i[g+12>>0]=0;g=d;i[g>>0]=102;i[g+1>>0]=105;i[g+2>>0]=108;i[g+3>>0]=101;d=d+4|0;i[d>>0]=110;i[d+1>>0]=97;i[d+2>>0]=109;i[d+3>>0]=101;$Ha(t,c,u);d=k[t>>2]|0;g=Ufb((d|0)==0?1016759:d,373005)|0;if(!g)e=0;else{UHa(p,g);if((k[p+32>>2]|0)!=8){x=te(44)|0;VHa(x,375679);Cf(x|0,19720,57)}if((k[p+40>>2]|0)!=(k[b>>2]|0)){x=te(44)|0;VHa(x,375747);Cf(x|0,19720,57)}if((k[p+44>>2]|0)!=(k[b+4>>2]|0)){x=te(44)|0;VHa(x,375747);Cf(x|0,19720,57)}k[q+4>>2]=0;k[q+8>>2]=0;d=q+4|0;k[q>>2]=d;k[s>>2]=0;e=s+4|0;k[e>>2]=0;f=ZT(16)|0;k[f>>2]=1;h=f+4|0;k[s>>2]=h;k[e>>2]=9;i[f+13>>0]=0;j=373358;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));w=WHa(q,s)|0;c=k[w>>2]|0;x=w+4|0;jh[k[k[c>>2]>>2]&1023](c,x);k[w>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,p+36|0,x);k[e>>2]=0;k[s>>2]=0;x=k[f>>2]|0;k[f>>2]=x+-1;if((x|0)==1)ggb(k[f+-4>>2]|0);e=MLa(b,q)|0;jh[k[(k[e>>2]|0)+24>>2]&1023](e,g);Qfb(g)|0;YHa(k[d>>2]|0);d=k[t>>2]|0}k[a+4>>2]=e;k[t+4>>2]=0;k[t>>2]=0;if(d|0?(w=d+-4|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0)ggb(k[d+-8>>2]|0);d=k[u>>2]|0;k[m>>2]=0;k[u>>2]=0;if(d|0?(w=d+-4|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0)ggb(k[d+-8>>2]|0);i[n>>0]=1;r=v;return}function MLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0.0;v=r;r=r+16|0;u=v+8|0;d=v;e=d+4|0;f=ZT(16)|0;k[f>>2]=1;q=f+4|0;k[d>>2]=q;k[e>>2]=9;i[f+13>>0]=0;p=373358;s=q+9|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));c=_Ha(b,d)|0;k[e>>2]=0;k[d>>2]=0;s=k[f>>2]|0;k[f>>2]=s+-1;if((s|0)==1)ggb(k[f+-4>>2]|0);switch(c|0){case 0:{while(1){c=fgb(36)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=94508;j=c+4|0;k[j>>2]=k[a>>2];k[j+4>>2]=k[a+4>>2];k[j+8>>2]=k[a+8>>2];k[j+12>>2]=k[a+12>>2];j=c+20|0;l=c+24|0;k[l>>2]=0;m=c+28|0;k[m>>2]=0;k[j>>2]=l;d=k[b>>2]|0;h=b+4|0;if((d|0)==(h|0)){u=c;r=v;return u|0}e=d;while(1){f=e+16|0;g=ZHa(j,l,u,f)|0;if(!(k[g>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){b=f+-4|0;k[b>>2]=(k[b>>2]|0)+1}a=d+24|0;k[a>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);b=k[e+24>>2]|0;k[a>>2]=b;Ph[k[(k[b>>2]|0)+8>>2]&511](b,e+28|0,f);f=k[u>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[j>>2]>>2]|0;if(f){k[j>>2]=f;d=k[g>>2]|0}B4(k[l>>2]|0,d);k[m>>2]=(k[m>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(h|0))break;else e=d}r=v;return c|0}case 4:{while(1){c=fgb(120)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=94448;n=c+4|0;k[n>>2]=k[a>>2];k[n+4>>2]=k[a+4>>2];k[n+8>>2]=k[a+8>>2];k[n+12>>2]=k[a+12>>2];h=c+20|0;j=c+24|0;k[j>>2]=0;l=c+28|0;k[l>>2]=0;k[h>>2]=j;d=k[b>>2]|0;m=b+4|0;if((d|0)!=(m|0)){e=d;while(1){f=e+16|0;g=ZHa(h,j,u,f)|0;if(!(k[g>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){a=f+-4|0;k[a>>2]=(k[a>>2]|0)+1}s=d+24|0;k[s>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);a=k[e+24>>2]|0;k[s>>2]=a;Ph[k[(k[a>>2]|0)+8>>2]&511](a,e+28|0,f);f=k[u>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[h>>2]>>2]|0;if(f){k[h>>2]=f;d=k[g>>2]|0}B4(k[j>>2]|0,d);k[l>>2]=(k[l>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(m|0))break;else e=d}}j=c+40|0;h=c+44|0;k[c+80>>2]=0;k[c+84>>2]=0;k[c+88>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;k[j+20>>2]=0;k[j+24>>2]=0;k[c+104>>2]=8192;k[c+92>>2]=0;k[c+96>>2]=0;k[c+108>>2]=0;k[c+112>>2]=0;l=c+68|0;k[l>>2]=k[n>>2];d=c+72|0;k[d>>2]=k[c+8>>2];e=ZT(8)|0;k[e>>2]=1;f=e+4|0;i[e+7>>0]=0;i[f>>0]=i[375541]|0;i[f+1>>0]=i[375542]|0;i[f+2>>0]=i[375543]|0;k[u>>2]=-1;f=dIa(b,f,u)|0;a=k[e>>2]|0;k[e>>2]=a+-1;if((a|0)==1)ggb(k[e+-4>>2]|0);if((f|0)>0)k[d>>2]=f;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;i[d+17>>0]=0;q=e;p=375545;s=q+13|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));k[u>>2]=10;a=dIa(b,e,u)|0;k[c+32>>2]=a;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)==1)ggb(k[d+-4>>2]|0);d=ZT(12)|0;k[d>>2]=1;a=d+4|0;i[d+11>>0]=0;i[a>>0]=i[375559]|0;i[a+1>>0]=i[375560]|0;i[a+2>>0]=i[375561]|0;i[a+3>>0]=i[375562]|0;i[a+4>>0]=i[375563]|0;i[a+5>>0]=i[375564]|0;i[a+6>>0]=i[375565]|0;i[u>>0]=1;u=(xIa(b,a,u)|0)&1;i[c+36>>0]=u;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0);d=k[l>>2]|0;g=k[h>>2]|0;f=k[j>>2]|0;e=g-f>>2;if(d>>>0<=e>>>0){if(d>>>0<e>>>0?(t=f+(d<<2)|0,(g|0)!=(t|0)):0)k[h>>2]=g+(~((g+-4-t|0)>>>2)<<2)}else{U1(j,d-e|0);d=k[l>>2]|0}if(!d){u=c;r=v;return u|0}e=k[j>>2]|0;d=0;do{k[e+(d<<2)>>2]=d;d=d+1|0}while(d>>>0<(k[l>>2]|0)>>>0);r=v;return c|0}case 1:{while(1){c=fgb(96)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}NLa(c,a,b);u=c;r=v;return u|0}case 2:{while(1){c=fgb(104)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}OLa(c,a,b);u=c;r=v;return u|0}case 3:{while(1){c=fgb(24)|0;if(c|0){m=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){m=0;break}Qh[c&7]()}k[m>>2]=94388;g=m+12|0;h=m+16|0;k[h>>2]=0;j=m+20|0;k[j>>2]=0;k[g>>2]=h;c=k[b>>2]|0;l=b+4|0;if((c|0)!=(l|0)){d=c;while(1){e=d+16|0;f=ZHa(g,h,u,e)|0;if(!(k[f>>2]|0)){while(1){c=fgb(32)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=k[e>>2]|0;k[c+16>>2]=e;k[c+20>>2]=k[d+20>>2];if(e|0){t=e+-4|0;k[t>>2]=(k[t>>2]|0)+1}s=c+24|0;k[s>>2]=428704;e=c+28|0;k[e>>2]=0;jh[k[k[107176]>>2]&1023](428704,e);t=k[d+24>>2]|0;k[s>>2]=t;Ph[k[(k[t>>2]|0)+8>>2]&511](t,d+28|0,e);e=k[u>>2]|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=e;k[f>>2]=c;e=k[k[g>>2]>>2]|0;if(e){k[g>>2]=e;c=k[f>>2]|0}B4(k[h>>2]|0,c);k[j>>2]=(k[j>>2]|0)+1}else d=c;c=k[d+4>>2]|0;if(!c)while(1){c=k[d+8>>2]|0;if((k[c>>2]|0)==(d|0))break;else d=c}else while(1){d=k[c>>2]|0;if(!d)break;else c=d}if((c|0)==(l|0))break;else d=c}}while(1){c=fgb(96)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}NLa(c,a,b);k[m+8>>2]=c;while(1){c=fgb(104)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}OLa(c,a,b);k[m+4>>2]=c;u=m;r=v;return u|0}case 255:{while(1){c=fgb(120)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=94188;d=c+12|0;k[d>>2]=0;k[c+16>>2]=0;k[c+8>>2]=d;rJa(c+20|0,32);d=c+84|0;q=c+32|0;s=q+48|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[d>>2]=k[a>>2];k[d+4>>2]=k[a+4>>2];k[d+8>>2]=k[a+8>>2];k[d+12>>2]=k[a+12>>2];d=ZT(24)|0;k[d>>2]=1;e=d+4|0;i[d+20>>0]=0;q=e;p=373946;s=q+16|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));o[u>>2]=.800000011920929;w=+sJa(b,e,u);o[c+100>>2]=w;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)==1)ggb(k[d+-4>>2]|0);d=ZT(20)|0;k[d>>2]=1;e=d+4|0;i[d+16>>0]=0;q=e;p=373963;s=q+12|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));o[u>>2]=.009999999776482582;w=+sJa(b,e,u);o[c+104>>2]=w;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)==1)ggb(k[d+-4>>2]|0);d=ZT(20)|0;k[d>>2]=1;e=d+4|0;i[d+17>>0]=0;q=e;p=373976;s=q+13|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));o[u>>2]=0.0;w=+sJa(b,e,u);o[c+108>>2]=w;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)==1)ggb(k[d+-4>>2]|0);d=ZT(20)|0;k[d>>2]=1;e=d+4|0;i[d+19>>0]=0;q=e;p=373990;s=q+15|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));o[u>>2]=.10000000149011612;w=+sJa(b,e,u);o[c+112>>2]=w;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0);k[c+4>>2]=0;u=c;r=v;return u|0}case 5:{while(1){c=fgb(104)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=94128;m=c+12|0;k[m>>2]=k[a>>2];k[m+4>>2]=k[a+4>>2];k[m+8>>2]=k[a+8>>2];k[m+12>>2]=k[a+12>>2];n=c+28|0;j=c+32|0;k[j>>2]=0;l=c+36|0;k[l>>2]=0;k[n>>2]=j;d=k[b>>2]|0;h=b+4|0;if((d|0)!=(h|0)){e=d;while(1){f=e+16|0;g=ZHa(n,j,u,f)|0;if(!(k[g>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){b=f+-4|0;k[b>>2]=(k[b>>2]|0)+1}a=d+24|0;k[a>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);b=k[e+24>>2]|0;k[a>>2]=b;Ph[k[(k[b>>2]|0)+8>>2]&511](b,e+28|0,f);f=k[u>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[n>>2]>>2]|0;if(f){k[n>>2]=f;d=k[g>>2]|0}B4(k[j>>2]|0,d);k[l>>2]=(k[l>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(h|0))break;else e=d}}h=c+48|0;k[h>>2]=0;j=c+52|0;k[j>>2]=0;k[c+72>>2]=8192;k[c+60>>2]=0;k[c+64>>2]=0;k[c+76>>2]=0;k[c+80>>2]=0;k[c+84>>2]=0;k[c+40>>2]=k[m>>2];k[c+44>>2]=k[c+16>>2];d=ZT(16)|0;k[d>>2]=1;e=d+4|0;i[d+13>>0]=0;q=e;p=373742;s=q+9|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));k[u>>2]=32;b=dIa(n,e,u)|0;k[c+88>>2]=b;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);e=ZT(20)|0;k[e>>2]=1;d=e+4|0;i[e+16>>0]=0;q=d;p=373752;s=q+12|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));k[u>>2]=0;b=WIa(n,d,u)|0;f=c+96|0;k[f>>2]=b;b=k[e>>2]|0;k[e>>2]=b+-1;if((b|0)==1)ggb(k[e+-4>>2]|0);d=ZT(12)|0;k[d>>2]=1;b=d+4|0;i[d+9>>0]=0;i[b>>0]=i[380533]|0;i[b+1>>0]=i[380534]|0;i[b+2>>0]=i[380535]|0;i[b+3>>0]=i[380536]|0;i[b+4>>0]=i[380537]|0;k[u>>2]=4;b=dIa(n,b,u)|0;g=c+92|0;k[g>>2]=b;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);d=ZT(16)|0;k[d>>2]=1;e=d+4|0;i[d+13>>0]=0;q=e;p=373765;s=q+9|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));k[u>>2]=100;b=dIa(n,e,u)|0;k[c+100>>2]=b;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);switch(k[f>>2]|0){case 0:{k[c+4>>2]=167;k[c+8>>2]=0;break}case 1:{k[c+4>>2]=168;k[c+8>>2]=0;break}case 2:{k[c+4>>2]=169;k[c+8>>2]=0;break}case 3:{k[c+4>>2]=170;k[c+8>>2]=0;break}default:{v=te(44)|0;VHa(v,373775);Cf(v|0,19720,57)}}d=ZT(12)|0;k[d>>2]=1;b=d+4|0;i[d+9>>0]=0;i[b>>0]=i[380533]|0;i[b+1>>0]=i[380534]|0;i[b+2>>0]=i[380535]|0;i[b+3>>0]=i[380536]|0;i[b+4>>0]=i[380537]|0;k[u>>2]=4;u=dIa(n,b,u)|0;k[g>>2]=u;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0);g=k[g>>2]|0;f=g>>>0>1073741823?-1:g<<2;f=(f|0)==0?1:f;while(1){d=fgb(f)|0;if(d|0){e=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){e=0;break}Qh[d&7]()}k[h>>2]=e;while(1){d=fgb(f)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[j>>2]=d;if((g|0)<=0){u=c;r=v;return u|0}k[e>>2]=0;k[k[j>>2]>>2]=0;if((g|0)==1){u=c;r=v;return u|0}else d=1;do{k[(k[h>>2]|0)+(d<<2)>>2]=0;k[(k[j>>2]|0)+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(g|0));r=v;return c|0}case 6:{while(1){c=fgb(76)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=94068;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;m=c+16|0;k[m>>2]=k[a>>2];k[m+4>>2]=k[a+4>>2];k[m+8>>2]=k[a+8>>2];k[m+12>>2]=k[a+12>>2];m=c+36|0;j=c+40|0;k[j>>2]=0;l=c+44|0;k[l>>2]=0;k[m>>2]=j;d=k[b>>2]|0;h=b+4|0;if((d|0)!=(h|0)){e=d;while(1){f=e+16|0;g=ZHa(m,j,u,f)|0;if(!(k[g>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){b=f+-4|0;k[b>>2]=(k[b>>2]|0)+1}a=d+24|0;k[a>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);b=k[e+24>>2]|0;k[a>>2]=b;Ph[k[(k[b>>2]|0)+8>>2]&511](b,e+28|0,f);f=k[u>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[m>>2]>>2]|0;if(f){k[m>>2]=f;d=k[g>>2]|0}B4(k[j>>2]|0,d);k[l>>2]=(k[l>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(h|0))break;else e=d}}g=c+60|0;k[g>>2]=0;k[c+64>>2]=0;k[c+68>>2]=0;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;i[d+16>>0]=0;q=e;p=373387;s=q+12|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));k[u>>2]=12;b=dIa(m,e,u)|0;k[c+48>>2]=b;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);d=ZT(16)|0;k[d>>2]=1;b=d+4|0;i[d+12>>0]=0;f=b;a=f;i[a>>0]=107;i[a+1>>0]=101;i[a+2>>0]=121;i[a+3>>0]=95;f=f+4|0;i[f>>0]=115;i[f+1>>0]=105;i[f+2>>0]=122;i[f+3>>0]=101;k[u>>2]=20;b=dIa(m,b,u)|0;f=c+52|0;k[f>>2]=b;b=k[d>>2]|0;k[d>>2]=b+-1;if((b|0)==1)ggb(k[d+-4>>2]|0);e=ZT(24)|0;k[e>>2]=1;d=e+4|0;i[e+21>>0]=0;q=d;p=373400;s=q+17|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));k[u>>2]=2;u=dIa(m,d,u)|0;d=c+56|0;k[d>>2]=u;u=k[e>>2]|0;k[e>>2]=u+-1;if((u|0)==1)ggb(k[e+-4>>2]|0);k[c+32>>2]=k[c+20>>2];PLa(0,k[f>>2]|0,k[d>>2]|0,g);u=c;r=v;return u|0}default:{v=te(44)|0;VHa(v,373368);Cf(v|0,19720,57)}}return 0}function NLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;s=r;r=r+16|0;n=s;k[a>>2]=94248;q=a+8|0;k[q>>2]=0;p=a+12|0;k[p>>2]=0;k[a+16>>2]=0;l=a+20|0;k[l>>2]=k[b>>2];k[l+4>>2]=k[b+4>>2];k[l+8>>2]=k[b+8>>2];k[l+12>>2]=k[b+12>>2];m=a+36|0;j=a+40|0;k[j>>2]=0;g=a+44|0;k[g>>2]=0;h=a+40|0;k[m>>2]=h;b=k[c>>2]|0;f=c+4|0;if((b|0)!=(f|0)){c=b;while(1){d=c+16|0;e=ZHa(m,h,n,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}u=b+24|0;k[u>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);t=k[c+24>>2]|0;k[u>>2]=t;Ph[k[(k[t>>2]|0)+8>>2]&511](t,c+28|0,d);d=k[n>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[m>>2]>>2]|0;if(d){k[m>>2]=d;b=k[e>>2]|0}B4(k[j>>2]|0,b);k[g>>2]=(k[g>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}}k[a+80>>2]=8192;k[a+68>>2]=0;k[a+72>>2]=0;k[a+84>>2]=0;k[a+88>>2]=0;g=a+48|0;k[g>>2]=k[l>>2];f=a+52|0;k[f>>2]=k[a+24>>2];c=ZT(12)|0;k[c>>2]=1;u=c+4|0;i[c+9>>0]=0;i[u>>0]=i[380533]|0;i[u+1>>0]=i[380534]|0;i[u+2>>0]=i[380535]|0;i[u+3>>0]=i[380536]|0;i[u+4>>0]=i[380537]|0;k[n>>2]=4;u=dIa(m,u,n)|0;b=a+4|0;k[b>>2]=u;u=k[c>>2]|0;k[c>>2]=u+-1;if((u|0)==1)ggb(k[c+-4>>2]|0);c=k[b>>2]|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[a+64>>2]=b;b=k[g>>2]|0;e=k[p>>2]|0;d=k[q>>2]|0;c=e-d>>2;if(b>>>0<=c>>>0){if(b>>>0<c>>>0?(o=d+(b<<2)|0,(e|0)!=(o|0)):0)k[p>>2]=e+(~((e+-4-o|0)>>>2)<<2)}else{U1(q,b-c|0);b=k[g>>2]|0}if(b|0){c=k[q>>2]|0;b=0;do{k[c+(b<<2)>>2]=b;b=b+1|0}while(b>>>0<(k[g>>2]|0)>>>0)}c=k[f>>2]|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[a+56>>2]=b;while(1){b=fgb(c)|0;if(b|0){c=37;break}b=k[207666]|0;k[207666]=b+0;if(!b){b=0;c=37;break}Qh[b&7]()}if((c|0)==37){k[a+60>>2]=b;r=s;return}}function OLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0;q=r;r=r+16|0;p=q;k[a>>2]=94308;n=a+28|0;k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];k[n+8>>2]=k[b+8>>2];k[n+12>>2]=k[b+12>>2];h=a+44|0;j=a+48|0;k[j>>2]=0;l=a+52|0;k[l>>2]=0;m=a+48|0;k[h>>2]=m;b=k[c>>2]|0;g=c+4|0;if((b|0)!=(g|0)){d=b;while(1){e=d+16|0;f=ZHa(h,m,p,e)|0;if(!(k[f>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}e=k[e>>2]|0;k[b+16>>2]=e;k[b+20>>2]=k[d+20>>2];if(e|0){e=e+-4|0;k[e>>2]=(k[e>>2]|0)+1}t=b+24|0;k[t>>2]=428704;e=b+28|0;k[e>>2]=0;jh[k[k[107176]>>2]&1023](428704,e);s=k[d+24>>2]|0;k[t>>2]=s;Ph[k[(k[s>>2]|0)+8>>2]&511](s,d+28|0,e);e=k[p>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=e;k[f>>2]=b;e=k[k[h>>2]>>2]|0;if(e){k[h>>2]=e;b=k[f>>2]|0}B4(k[j>>2]|0,b);k[l>>2]=(k[l>>2]|0)+1}else d=b;b=k[d+4>>2]|0;if(!b)while(1){b=k[d+8>>2]|0;if((k[b>>2]|0)==(d|0))break;else d=b}else while(1){d=k[b>>2]|0;if(!d)break;else b=d}if((b|0)==(g|0))break;else d=b}}k[a+64>>2]=0;k[a+68>>2]=0;k[a+88>>2]=8192;k[a+76>>2]=0;k[a+80>>2]=0;k[a+92>>2]=0;k[a+96>>2]=0;k[a+100>>2]=0;k[a+56>>2]=k[n>>2];k[a+60>>2]=k[a+32>>2];b=ZT(16)|0;k[b>>2]=1;d=b+4|0;i[b+13>>0]=0;e=d;f=373742;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));k[p>>2]=32;t=dIa(c,d,p)|0;k[a+12>>2]=t;t=k[b>>2]|0;k[b>>2]=t+-1;if((t|0)==1)ggb(k[b+-4>>2]|0);d=ZT(16)|0;k[d>>2]=1;b=d+4|0;i[d+14>>0]=0;e=b;f=375191;g=e+10|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));k[p>>2]=11;t=dIa(c,b,p)|0;b=a+16|0;k[b>>2]=t;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0);if((k[b>>2]|0)<0)k[b>>2]=2147483647;d=ZT(20)|0;k[d>>2]=1;b=d+4|0;i[d+16>>0]=0;e=b;f=373752;g=e+12|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));k[p>>2]=0;t=WIa(c,b,p)|0;b=a+20|0;k[b>>2]=t;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0);switch(k[b>>2]|0){case 0:{k[a+4>>2]=171;k[a+8>>2]=0;t=a+24|0;o[t>>2]=.4000000059604645;r=q;return}case 1:{k[a+4>>2]=172;k[a+8>>2]=0;t=a+24|0;o[t>>2]=.4000000059604645;r=q;return}case 2:{k[a+4>>2]=173;k[a+8>>2]=0;t=a+24|0;o[t>>2]=.4000000059604645;r=q;return}default:{t=te(44)|0;VHa(t,373775);Cf(t|0,19720,57)}}}function PLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;h=r;r=r+16|0;e=h;k[e>>2]=a;f=d+4|0;g=k[f>>2]|0;if((g|0)==(k[d+8>>2]|0))P4(d,e);else{k[g>>2]=a;k[f>>2]=g+4}if(!((c|0)!=0&(b|0)>0)){r=h;return}c=c+-1|0;do{g=b;b=b+-1|0;PLa(1<<b|a,b,c,d)}while((g|0)>1);r=h;return}function QLa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=94068;b=k[a+60>>2]|0;c=b;if(b|0){d=a+64|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}YHa(k[a+40>>2]|0);d=a+4|0;e=k[d>>2]|0;if(!e)return;b=a+8|0;while(1){c=k[b>>2]|0;if((c|0)==(e|0))break;a=c+-60|0;k[b>>2]=a;fIa(a)}ggb(k[d>>2]|0);return}function RLa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=94068;b=k[a+60>>2]|0;c=b;if(b|0){d=a+64|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}YHa(k[a+40>>2]|0);b=a+4|0;c=k[b>>2]|0;if(!c){ggb(a);return}d=a+8|0;while(1){e=k[d>>2]|0;if((e|0)==(c|0))break;e=e+-60|0;k[d>>2]=e;fIa(e)}ggb(k[b>>2]|0);ggb(a);return}function SLa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+64|0;h=l;i=a+4|0;j=a+48|0;d=k[j>>2]|0;g=a+8|0;b=k[g>>2]|0;c=k[i>>2]|0;e=(b-c|0)/60|0;if(d>>>0<=e>>>0){if(d>>>0<e>>>0?(f=c+(d*60|0)|0,(b|0)!=(f|0)):0)do{e=b+-60|0;k[g>>2]=e;fIa(e);b=k[g>>2]|0}while((b|0)!=(f|0))}else MIa(i,d-e|0);if(!(k[j>>2]|0)){r=l;return}d=a+16|0;b=0;do{a=(k[i>>2]|0)+(b*60|0)|0;NIa(h);OIa(a,h);fIa(h);e=k[d>>2]|0;if(e|0){c=0;do{PIa(a,c);c=c+1|0}while((c|0)!=(e|0))}QIa(a);b=b+1|0}while(b>>>0<(k[j>>2]|0)>>>0);r=l;return}function TLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;z=r;r=r+32|0;v=z;w=z+28|0;x=v+8|0;y=v+12|0;q=v+20|0;s=v+16|0;k[v>>2]=93396;k[v+24>>2]=e;t=v+4|0;k[q>>2]=0;k[y>>2]=s;k[s>>2]=0;o[x>>2]=3402823466385288598117041.0e14;i[t>>0]=0;if(!(k[b>>2]|0)){k[v>>2]=93356;y=k[s>>2]|0;wIa(y);r=z;return}u=c+12|0;l=c+8|0;m=b+12|0;n=b+8|0;p=d+12|0;j=d+8|0;if((e|0)<=0){c=0;d=0;while(1){wIa(d);k[q>>2]=0;k[y>>2]=s;k[s>>2]=0;o[x>>2]=3402823466385288598117041.0e14;i[t>>0]=0;d=(k[m>>2]|0)+((aa(k[n>>2]|0,c)|0)<<2)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,v,d,f);d=ZT(12)|0;k[d>>2]=1;g=d+4|0;i[d+10>>0]=0;i[g>>0]=i[373546]|0;i[g+1>>0]=i[373547]|0;i[g+2>>0]=i[373548]|0;i[g+3>>0]=i[373549]|0;i[g+4>>0]=i[373550]|0;i[g+5>>0]=i[373551]|0;i[w>>0]=1;g=xIa(f,g,w)|0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);d=k[v>>2]|0;if(g){g=(k[u>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0;h=(k[p>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;dh[k[d+28>>2]&255](v,g,h,e)}else{g=(k[u>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0;h=(k[p>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;dh[k[d+24>>2]&255](v,g,h,e)}c=c+1|0;if(c>>>0>=(k[b>>2]|0)>>>0)break;d=k[s>>2]|0}k[v>>2]=93356;y=k[s>>2]|0;wIa(y);r=z;return}h=e<<2;c=0;d=0;while(1){wIa(d);k[q>>2]=0;k[y>>2]=s;k[s>>2]=0;o[x>>2]=3402823466385288598117041.0e14;i[t>>0]=0;zpb((k[u>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0,-1,h|0)|0;d=e;g=(k[p>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;while(1){k[g>>2]=2139095039;if((d|0)>1){d=d+-1|0;g=g+4|0}else break}d=(k[m>>2]|0)+((aa(k[n>>2]|0,c)|0)<<2)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,v,d,f);d=ZT(12)|0;k[d>>2]=1;g=d+4|0;i[d+10>>0]=0;i[g>>0]=i[373546]|0;i[g+1>>0]=i[373547]|0;i[g+2>>0]=i[373548]|0;i[g+3>>0]=i[373549]|0;i[g+4>>0]=i[373550]|0;i[g+5>>0]=i[373551]|0;i[w>>0]=1;g=xIa(f,g,w)|0;A=k[d>>2]|0;k[d>>2]=A+-1;if((A|0)==1)ggb(k[d+-4>>2]|0);d=k[v>>2]|0;if(g){g=(k[u>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0;A=(k[p>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;dh[k[d+28>>2]&255](v,g,A,e)}else{g=(k[u>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0;A=(k[p>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;dh[k[d+24>>2]&255](v,g,A,e)}c=c+1|0;if(c>>>0>=(k[b>>2]|0)>>>0)break;d=k[s>>2]|0}k[v>>2]=93356;A=k[s>>2]|0;wIa(A);r=z;return}function ULa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0;q=r;r=r+32|0;n=q;h=q+28|0;if((k[b>>2]|0)==1){p=k[c+4>>2]|0;g=(p|0)==0;m=g?0:k[c+12>>2]|0;g=g?0:k[d+12>>2]|0;o[n+8>>2]=3402823466385288598117041.0e14;j=n+20|0;l=n+16|0;k[n>>2]=93316;o[n+24>>2]=e;i[n+4>>0]=1;k[j>>2]=0;k[n+12>>2]=l;k[l>>2]=0;dh[k[(k[a>>2]|0)+48>>2]&255](a,n,k[b+12>>2]|0,f);do if((p|0)>0){c=ZT(12)|0;k[c>>2]=1;d=c+4|0;i[c+10>>0]=0;i[d>>0]=i[373546]|0;i[d+1>>0]=i[373547]|0;i[d+2>>0]=i[373548]|0;i[d+3>>0]=i[373549]|0;i[d+4>>0]=i[373550]|0;i[d+5>>0]=i[373551]|0;i[h>>0]=1;d=xIa(f,d,h)|0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0);c=k[n>>2]|0;if(d){dh[k[c+28>>2]&255](n,m,g,p);break}else{dh[k[c+24>>2]&255](n,m,g,p);break}}while(0);p=k[j>>2]|0;k[n>>2]=93356;wIa(k[l>>2]|0);r=q;return p|0}c=k[41482]|0;d=(c|0)==0;if((k[41497]|0)>-1){do if(d){c=i[165986]|0;i[165986]=c+255|c;c=k[41478]|0;if(!(c&8)){k[41480]=0;k[41479]=0;d=k[41489]|0;k[41485]=d;k[41483]=d;c=d+(k[41490]|0)|0;k[41482]=c;break}k[41478]=c|32;p=-1;r=q;return p|0}else d=k[41483]|0;while(0);if((c-d|0)>>>0<57){ci[k[165948>>2]&255](165912,373488,57)|0;p=-1;r=q;return p|0}do if((i[165987]|0)>-1)if((ci[k[165948>>2]&255](165912,373488,57)|0)>>>0<57){p=-1;r=q;return p|0}else{c=0;a=373545;d=k[41483]|0;break}else{c=57;a=373488}while(0);upb(d|0,a|0,c|0)|0;k[41483]=(k[41483]|0)+c;p=-1;r=q;return p|0}else{do if(d){c=i[165986]|0;i[165986]=c+255|c;c=k[41478]|0;if(!(c&8)){k[41480]=0;k[41479]=0;d=k[41489]|0;k[41485]=d;k[41483]=d;c=d+(k[41490]|0)|0;k[41482]=c;break}k[41478]=c|32;p=-1;r=q;return p|0}else d=k[41483]|0;while(0);if((c-d|0)>>>0<57){ci[k[165948>>2]&255](165912,373488,57)|0;p=-1;r=q;return p|0}do if((i[165987]|0)>-1)if((ci[k[165948>>2]&255](165912,373488,57)|0)>>>0<57){p=-1;r=q;return p|0}else{c=0;a=373545;d=k[41483]|0;break}else{c=57;a=373488}while(0);upb(d|0,a|0,c|0)|0;k[41483]=(k[41483]|0)+c;p=-1;r=q;return p|0}return 0}function VLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;h=a+48|0;j=b+76|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}b:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break b}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;f=k[b+44>>2]|0;k[b+28>>2]=f;g=b+20|0;k[g>>2]=f;d=f+(k[b+48>>2]|0)|0;k[e>>2]=d;e=f;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;d=c;g=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}c:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;d=h;break c}d=e+-1|0;if((i[h+d>>0]|0)==10)break;else e=d}if((ci[k[b+36>>2]&255](b,h,e)|0)>>>0<e>>>0)break a;f=4-e|0;d=h+e|0;c=k[g>>2]|0}else{f=4;d=h}while(0);upb(c|0,d|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f}while(0);h=a+52|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;d:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}e:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break e}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}f:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break f}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+56|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;g:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}h:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break h}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}i:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break i}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+16|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;j:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<16){ci[k[b+36>>2]&255](b,h,16)|0;break}k:do if((i[b+75>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=h;c=f;break k}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=16-d|0;d=h+d|0;c=k[g>>2]|0}else{e=16;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<16){ci[k[b+36>>2]&255](b,h,16)|0;break}l:do if((i[b+75>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=h;c=f;break l}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=16-d|0;d=h+d|0;c=k[g>>2]|0}else{e=16;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);d=k[a+28>>2]|0;e=(aa(k[a+20>>2]|0,k[h>>2]|0)|0)<<2;g=b+16|0;f=k[g>>2]|0;c=(f|0)==0;if((k[j>>2]|0)>-1){do if(c){c=b+74|0;j=i[c>>0]|0;i[c>>0]=j+255|j;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;j=k[b+44>>2]|0;k[b+28>>2]=j;h=b+20|0;k[h>>2]=j;f=j+(k[b+48>>2]|0)|0;k[g>>2]=f;g=j;break}k[b>>2]=c|32;return}else{g=b+20|0;h=g;g=k[g>>2]|0}while(0);c=g;if((f-g|0)>>>0<e>>>0){ci[k[b+36>>2]&255](b,d,e)|0;return}m:do if((i[b+75>>0]|0)>-1){g=e;while(1){if(!g)break m;f=g+-1|0;if((i[d+f>>0]|0)==10)break;else g=f}if((ci[k[b+36>>2]&255](b,d,g)|0)>>>0<g>>>0)return;else{e=e-g|0;d=d+g|0;c=k[h>>2]|0;break}}while(0);upb(c|0,d|0,e|0)|0;k[h>>2]=(k[h>>2]|0)+e;return}else{do if(c){c=b+74|0;j=i[c>>0]|0;i[c>>0]=j+255|j;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;j=k[b+44>>2]|0;k[b+28>>2]=j;h=b+20|0;k[h>>2]=j;f=j+(k[b+48>>2]|0)|0;k[g>>2]=f;g=j;break}k[b>>2]=c|32;return}else{g=b+20|0;h=g;g=k[g>>2]|0}while(0);c=g;if((f-g|0)>>>0<e>>>0){ci[k[b+36>>2]&255](b,d,e)|0;return}n:do if((i[b+75>>0]|0)>-1){g=e;while(1){if(!g)break n;f=g+-1|0;if((i[d+f>>0]|0)==10)break;else g=f}if((ci[k[b+36>>2]&255](b,d,g)|0)>>>0<g>>>0)return;else{e=e-g|0;d=d+g|0;c=k[h>>2]|0;break}}while(0);upb(c|0,d|0,e|0)|0;k[h>>2]=(k[h>>2]|0)+e;return}}function WLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o+8|0;d=o;e=a+48|0;if((_fb(e,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}f=a+52|0;if((_fb(f,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}m=a+56|0;if((_fb(m,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}vIa(b,a+16|0);Uh[k[(k[a>>2]|0)+8>>2]&2047](a);l=a+36|0;b=n+4|0;c=ZT(16)|0;k[c>>2]=1;g=c+4|0;k[n>>2]=g;k[b>>2]=9;i[c+13>>0]=0;h=373358;j=g+9|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));h=WHa(l,n)|0;g=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[d>>2]=g;g=k[h>>2]|0;j=h+4|0;jh[k[k[g>>2]>>2]&1023](g,j);k[h>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,d,j);k[b>>2]=0;k[n>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0);b=n+4|0;c=ZT(20)|0;k[c>>2]=1;g=c+4|0;k[n>>2]=g;k[b>>2]=12;i[c+16>>0]=0;h=373387;j=g+12|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));h=WHa(l,n)|0;g=k[h>>2]|0;j=h+4|0;jh[k[k[g>>2]>>2]&1023](g,j);k[h>>2]=428732;Ph[k[(k[107183]|0)+4>>2]&511](428732,e,j);k[b>>2]=0;k[n>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0);j=n+4|0;b=ZT(16)|0;k[b>>2]=1;g=b+4|0;k[n>>2]=g;k[j>>2]=8;i[b+12>>0]=0;e=g;i[e>>0]=107;i[e+1>>0]=101;i[e+2>>0]=121;i[e+3>>0]=95;g=g+4|0;i[g>>0]=115;i[g+1>>0]=105;i[g+2>>0]=122;i[g+3>>0]=101;g=WHa(l,n)|0;e=k[g>>2]|0;h=g+4|0;jh[k[k[e>>2]>>2]&1023](e,h);k[g>>2]=428732;Ph[k[(k[107183]|0)+4>>2]&511](428732,f,h);k[j>>2]=0;k[n>>2]=0;j=k[b>>2]|0;k[b>>2]=j+-1;if((j|0)==1)ggb(k[b+-4>>2]|0);b=n+4|0;c=ZT(24)|0;k[c>>2]=1;g=c+4|0;k[n>>2]=g;k[b>>2]=17;i[c+21>>0]=0;h=373400;j=g+17|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));j=WHa(l,n)|0;h=k[j>>2]|0;l=j+4|0;jh[k[k[h>>2]>>2]&1023](h,l);k[j>>2]=428732;Ph[k[(k[107183]|0)+4>>2]&511](428732,m,l);k[b>>2]=0;k[n>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)!=1){r=o;return}ggb(k[c+-4>>2]|0);r=o;return}function XLa(a){a=a|0;return k[a+16>>2]|0}function YLa(a){a=a|0;return k[a+32>>2]|0}function ZLa(a){a=a|0;return k[a+16>>2]<<2|0}function _La(a){a=a|0;return 6}function $La(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+36>>2]|0;f=b+40|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function aMa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0;d=k[a+4>>2]|0;z=k[a+8>>2]|0;if((d|0)==(z|0))return;A=a+64|0;v=a+28|0;w=a+24|0;x=a+20|0;y=3-c|0;u=a+60|0;do{uIa();a=k[u>>2]|0;q=k[A>>2]|0;a:do if((a|0)!=(q|0)){r=d+24|0;s=d+28|0;t=d+16|0;p=a;while(1){a=k[p>>2]|0;h=a^1;switch(k[r>>2]|0){case 0:{a=(k[d>>2]|0)+(h*12|0)|0;if(a|0){n=a;D=24}break}case 1:{if(k[(k[s>>2]|0)+(a>>>5<<2)>>2]&1<<(h&31)|0){e=k[t>>2]|0;if(e){a=t;b:while(1){g=e;while(1){if((k[g+16>>2]|0)>>>0>=h>>>0)break;e=k[g+4>>2]|0;if(!e)break b;else g=e}e=k[g>>2]|0;if(!e){a=g;break}else a=g}if(!((a|0)!=(t|0)?(k[a+16>>2]|0)>>>0<=h>>>0:0))D=14}else D=14;if((D|0)==14)a=t;n=a+20|0;D=24}break}case 2:{e=k[t>>2]|0;if(e|0){a=t;c:while(1){g=e;while(1){if((k[g+16>>2]|0)>>>0>=h>>>0)break;e=k[g+4>>2]|0;if(!e)break c;else g=e}e=k[g>>2]|0;if(!e){a=g;break}else a=g}if((a|0)!=(t|0)?(k[a+16>>2]|0)>>>0<=h>>>0:0){n=a+20|0;D=24}}break}default:{}}if((D|0)==24?(D=0,B=k[n>>2]|0,C=k[n+4>>2]|0,B>>>0<C>>>0):0){l=B;do{m=k[l>>2]|0;a=(k[v>>2]|0)+((aa(k[w>>2]|0,m)|0)<<2)|0;j=c+(k[x>>2]<<2)|0;h=j+-12|0;i=((h>>>0<c>>>0?c:h)+12+y|0)>>>4<<2;e=a+(i<<2)|0;if(h>>>0>c>>>0){g=c;f=0.0;while(1){H=+o[g>>2]-+o[a>>2];G=+o[g+4>>2]-+o[a+4>>2];F=+o[g+8>>2]-+o[a+8>>2];E=+o[g+12>>2]-+o[a+12>>2];f=f+(H*H+G*G+F*F+E*E);g=g+16|0;if(g>>>0>=h>>>0)break;else a=a+16|0}}else f=0.0;a=c+(i<<2)|0;if(a>>>0<j>>>0)while(1){H=+o[a>>2]-+o[e>>2];a=a+4|0;f=f+H*H;if(a>>>0>=j>>>0)break;else e=e+4|0}$f[k[(k[b>>2]|0)+12>>2]&15](b,f,m);l=l+4|0}while(l>>>0<C>>>0)}p=p+4|0;if((p|0)==(q|0))break a}}while(0);d=d+60|0}while((d|0)!=(z|0));return}function bMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0;G=r;r=r+32|0;F=G;$Ia(F,d);a:do if((b|0)>0){E=F+16|0;g=k[F>>2]|0;C=a+24|0;D=a+20|0;B=a+16|0;A=k[F+12>>2]|0;a=k[E>>2]|0;d=0;b:while(1){y=e+(d<<2)|0;z=(d|0)>0;if((a|0)==(A|0)){l=23;break a}while(1){h=a;a=a+1|0;h=k[g+(h<<2)>>2]|0;if((h|0)<0){l=6;break b}h=k[c+(h<<2)>>2]|0;k[y>>2]=h;if(!z)break;w=k[C>>2]|0;x=k[D>>2]|0;p=w+((aa(x,h)|0)<<2)|0;t=p+(k[B>>2]<<2)|0;q=t+-12|0;u=((q>>>0<p>>>0?p:q)+12+(3-p)|0)>>>4<<2;v=p+(u<<2)|0;s=v>>>0<t>>>0;if(p>>>0>=q>>>0){if(s){m=0;h=0;do{i=w+((aa(k[e+(m<<2)>>2]|0,x)|0)<<2)+(u<<2)|0;j=0.0;l=v;while(1){H=+o[l>>2]-+o[i>>2];l=l+4|0;j=j+H*H;if(l>>>0>=t>>>0)break;else i=i+4|0}h=j<1.0e-16?1:h;m=m+1|0}while((m|0)!=(d|0));i=h;l=19}}else{n=0;h=0;do{m=w+((aa(k[e+(n<<2)>>2]|0,x)|0)<<2)|0;i=p;l=m;j=0.0;while(1){K=+o[i>>2]-+o[l>>2];J=+o[i+4>>2]-+o[l+4>>2];I=+o[i+8>>2]-+o[l+8>>2];H=+o[i+12>>2]-+o[l+12>>2];j=j+(K*K+J*J+I*I+H*H);i=i+16|0;if(i>>>0>=q>>>0)break;else l=l+16|0}if(s){l=m+(u<<2)|0;i=v;while(1){K=+o[i>>2]-+o[l>>2];i=i+4|0;j=j+K*K;if(i>>>0>=t>>>0)break;else l=l+4|0}}h=j<1.0e-16?1:h;n=n+1|0}while((n|0)!=(d|0));i=h;l=19}if((l|0)==19?(l=0,(i&1)==0):0)break;if((a|0)==(A|0)){l=22;break b}}k[E>>2]=a;d=d+1|0;if((d|0)>=(b|0)){l=23;break a}}if((l|0)==6){k[E>>2]=a;k[f>>2]=d;break}else if((l|0)==22){k[E>>2]=A;l=23;break}}else{d=0;g=k[F>>2]|0;l=23}while(0);if((l|0)==23){k[f>>2]=d;if(!g){r=G;return}}d=F+4|0;a=k[d>>2]|0;if((a|0)!=(g|0))k[d>>2]=a+(~((a+-4-g|0)>>>2)<<2);ggb(g);r=G;return}function cMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0.0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,O=0.0,P=0.0;J=428e3;J=Epb(k[J>>2]|0,k[J+4>>2]|0,1284865837,1481765933)|0;J=kpb(J|0,N|0,1,0)|0;K=N;I=428e3;k[I>>2]=J;k[I+4>>2]=K;K=ppb(J|0,K|0,33)|0;k[e>>2]=k[c+(~~(+(d|0)*(+(K|0)*4.656612873077393e-10))<<2)>>2];if((b|0)<=1){e=1;k[f>>2]=e;return}I=(d|0)>0;J=a+24|0;K=a+20|0;H=a+16|0;a=1;while(1){if(!I){a=1;g=18;break}w=k[J>>2]|0;x=k[K>>2]|0;y=w+((aa(x,k[e>>2]|0)|0)<<2)|0;z=k[H>>2]|0;A=y+(z<<2)|0;B=A+-12|0;C=((B>>>0<y>>>0?y:B)+12+(3-y)|0)>>>4<<2;D=y>>>0<B>>>0;G=y+(C<<2)|0;E=G>>>0<A>>>0;F=(a|0)>1;t=0;u=0.0;v=-1;while(1){s=w+((aa(k[c+(t<<2)>>2]|0,x)|0)<<2)|0;l=s+(C<<2)|0;if(D){g=y;j=s;h=0.0;while(1){O=+o[g>>2]-+o[j>>2];M=+o[g+4>>2]-+o[j+4>>2];L=+o[g+8>>2]-+o[j+8>>2];i=+o[g+12>>2]-+o[j+12>>2];h=h+(O*O+M*M+L*L+i*i);g=g+16|0;if(g>>>0>=B>>>0)break;else j=j+16|0}}else h=0.0;if(E){j=l;g=G;while(1){O=+o[g>>2]-+o[j>>2];g=g+4|0;h=h+O*O;if(g>>>0>=A>>>0)break;else j=j+4|0}}if(F){r=1;do{p=w+((aa(x,k[e+(r<<2)>>2]|0)|0)<<2)|0;q=p+(z<<2)|0;m=q+-12|0;n=((m>>>0<p>>>0?p:m)+12+(3-p)|0)>>>4<<2;j=s+(n<<2)|0;if(p>>>0<m>>>0){g=p;l=s;i=0.0;while(1){P=+o[g>>2]-+o[l>>2];L=+o[g+4>>2]-+o[l+4>>2];M=+o[g+8>>2]-+o[l+8>>2];O=+o[g+12>>2]-+o[l+12>>2];i=i+(P*P+L*L+M*M+O*O);g=g+16|0;if(g>>>0>=m>>>0)break;else l=l+16|0}}else i=0.0;g=p+(n<<2)|0;if(g>>>0<q>>>0)while(1){P=+o[g>>2]-+o[j>>2];g=g+4|0;i=i+P*P;if(g>>>0>=q>>>0)break;else j=j+4|0}h=i<h?i:h;r=r+1|0}while((r|0)!=(a|0))}g=h>u;v=g?t:v;t=t+1|0;if((t|0)==(d|0))break;else u=g?h:u}if((v|0)==-1){g=18;break}k[e+(a<<2)>>2]=k[c+(v<<2)>>2];a=a+1|0;if((a|0)>=(b|0)){g=18;break}}if((g|0)==18){k[f>>2]=a;return}}function dMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0.0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,O=0.0,P=0.0;K=r;r=r+16|0;J=K;h=d>>>0>1073741823?-1:d<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}y=428e3;y=Epb(k[y>>2]|0,k[y+4>>2]|0,1284865837,1481765933)|0;y=kpb(y|0,N|0,1,0)|0;z=N;h=428e3;k[h>>2]=y;k[h+4>>2]=z;h=ppb(y|0,z|0,33)|0;h=c+(~~(+(d|0)*(+(h|0)*4.656612873077393e-10))<<2)|0;k[e>>2]=k[h>>2];I=(d|0)>0;if(I){w=k[a+24>>2]|0;x=k[a+20>>2]|0;u=w+((aa(k[h>>2]|0,x)|0)<<2)|0;v=k[a+16>>2]|0;t=0;i=0.0;do{p=w+((aa(x,k[c+(t<<2)>>2]|0)|0)<<2)|0;s=p+(v<<2)|0;n=s+-12|0;q=((n>>>0<p>>>0?p:n)+12+(3-p)|0)>>>4<<2;l=u+(q<<2)|0;if(p>>>0<n>>>0){h=p;m=u;j=0.0;while(1){P=+o[h>>2]-+o[m>>2];O=+o[h+4>>2]-+o[m+4>>2];M=+o[h+8>>2]-+o[m+8>>2];L=+o[h+12>>2]-+o[m+12>>2];j=j+(P*P+O*O+M*M+L*L);h=h+16|0;if(h>>>0>=n>>>0)break;else m=m+16|0}}else j=0.0;h=p+(q<<2)|0;if(h>>>0<s>>>0)while(1){P=+o[h>>2]-+o[l>>2];h=h+4|0;j=j+P*P;if(h>>>0>=s>>>0)break;else l=l+4|0}o[g+(t<<2)>>2]=j;i=i+j;t=t+1|0}while((t|0)!=(d|0))}else i=0.0;if((b|0)<=1){J=1;k[f>>2]=J;ggb(g);r=K;return}E=d+-1|0;F=(d|0)>1;G=a+24|0;H=a+20|0;D=a+16|0;C=1;B=y;do{y=Epb(B|0,z|0,1284865837,1481765933)|0;B=kpb(y|0,N|0,1,0)|0;z=N;a:do if(F){y=ppb(B|0,z|0,33)|0;h=0;i=i*(+(y|0)*4.656612873077393e-10)+0.0;while(1){j=+o[g+(h<<2)>>2];if(i<=j)break;h=h+1|0;if((h|0)<(E|0))i=i-j;else break}if(!I){k[e+(C<<2)>>2]=k[c+(h<<2)>>2];i=0.0;break}y=k[G>>2]|0;w=k[H>>2]|0;l=k[c+(h<<2)>>2]|0;a=y+((aa(l,w)|0)<<2)|0;x=k[D>>2]|0;v=0;i=0.0;do{s=y+((aa(w,k[c+(v<<2)>>2]|0)|0)<<2)|0;u=s+(x<<2)|0;q=u+-12|0;t=((q>>>0<s>>>0?s:q)+12+(3-s)|0)>>>4<<2;n=a+(t<<2)|0;if(s>>>0<q>>>0){m=s;p=a;j=0.0;while(1){L=+o[m>>2]-+o[p>>2];M=+o[m+4>>2]-+o[p+4>>2];O=+o[m+8>>2]-+o[p+8>>2];P=+o[m+12>>2]-+o[p+12>>2];j=j+(L*L+M*M+O*O+P*P);m=m+16|0;if(m>>>0>=q>>>0)break;else p=p+16|0}}else j=0.0;m=s+(t<<2)|0;if(m>>>0<u>>>0)while(1){P=+o[m>>2]-+o[n>>2];m=m+4|0;j=j+P*P;if(m>>>0>=u>>>0)break;else n=n+4|0}P=+o[g+(v<<2)>>2];i=i+(P<j?P:j);v=v+1|0}while((v|0)!=(d|0));x=y;A=28}else{if(!I){k[e+(C<<2)>>2]=k[c>>2];i=0.0;break}x=k[G>>2]|0;v=k[H>>2]|0;l=k[c>>2]|0;w=x+((aa(l,v)|0)<<2)|0;a=k[D>>2]|0;u=0;i=0.0;h=l;while(1){q=x+((aa(v,h)|0)<<2)|0;t=q+(a<<2)|0;p=t+-12|0;s=((p>>>0<q>>>0?q:p)+12+(3-q)|0)>>>4<<2;m=w+(s<<2)|0;if(q>>>0<p>>>0){h=q;n=w;j=0.0;while(1){L=+o[h>>2]-+o[n>>2];M=+o[h+4>>2]-+o[n+4>>2];O=+o[h+8>>2]-+o[n+8>>2];P=+o[h+12>>2]-+o[n+12>>2];j=j+(L*L+M*M+O*O+P*P);h=h+16|0;if(h>>>0>=p>>>0)break;else n=n+16|0}}else j=0.0;h=q+(s<<2)|0;if(h>>>0<t>>>0)while(1){P=+o[h>>2]-+o[m>>2];h=h+4|0;j=j+P*P;if(h>>>0>=t>>>0)break;else m=m+4|0}P=+o[g+(u<<2)>>2];i=i+(P<j?P:j);h=u+1|0;if((h|0)==(d|0)){h=0;A=28;break a}u=h;h=k[c+(h<<2)>>2]|0}}while(0);if((A|0)==28){A=0;k[e+(C<<2)>>2]=l;if(I){w=k[H>>2]|0;u=x+((aa(k[c+(h<<2)>>2]|0,w)|0)<<2)|0;v=k[D>>2]|0;t=0;do{p=x+((aa(w,k[c+(t<<2)>>2]|0)|0)<<2)|0;s=p+(v<<2)|0;n=s+-12|0;q=((n>>>0<p>>>0?p:n)+12+(3-p)|0)>>>4<<2;l=u+(q<<2)|0;if(p>>>0<n>>>0){h=p;m=u;j=0.0;while(1){L=+o[h>>2]-+o[m>>2];M=+o[h+4>>2]-+o[m+4>>2];O=+o[h+8>>2]-+o[m+8>>2];P=+o[h+12>>2]-+o[m+12>>2];j=j+(L*L+M*M+O*O+P*P);h=h+16|0;if(h>>>0>=n>>>0)break;else m=m+16|0}}else j=0.0;h=p+(q<<2)|0;if(h>>>0<s>>>0)while(1){P=+o[h>>2]-+o[l>>2];h=h+4|0;j=j+P*P;if(h>>>0>=s>>>0)break;else l=l+4|0}o[J>>2]=j;y=g+(t<<2)|0;k[y>>2]=k[(+o[y>>2]<j?y:J)>>2];t=t+1|0}while((t|0)!=(d|0))}}C=C+1|0}while((C|0)!=(b|0));J=428e3;k[J>>2]=B;k[J+4>>2]=z;J=b;k[f>>2]=J;ggb(g);r=K;return}function eMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0.0,j=0.0,l=0,m=0,n=0,p=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0;I=r;r=r+16|0;H=I;h=d>>>0>1073741823?-1:d<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}G=428e3;G=Epb(k[G>>2]|0,k[G+4>>2]|0,1284865837,1481765933)|0;G=kpb(G|0,N|0,1,0)|0;h=N;F=428e3;k[F>>2]=G;k[F+4>>2]=h;h=ppb(G|0,h|0,33)|0;h=c+(~~(+(d|0)*(+(h|0)*4.656612873077393e-10))<<2)|0;k[e>>2]=k[h>>2];G=(d|0)>0;if(G){x=k[a+24>>2]|0;y=k[a+20>>2]|0;v=x+((aa(k[h>>2]|0,y)|0)<<2)|0;w=k[a+16>>2]|0;u=0;do{q=x+((aa(y,k[c+(u<<2)>>2]|0)|0)<<2)|0;t=q+(w<<2)|0;n=t+-12|0;s=((n>>>0<q>>>0?q:n)+12+(3-q)|0)>>>4<<2;l=v+(s<<2)|0;if(q>>>0<n>>>0){h=q;m=v;i=0.0;while(1){j=+o[h>>2]-+o[m>>2];p=+o[h+4>>2]-+o[m+4>>2];z=+o[h+8>>2]-+o[m+8>>2];A=+o[h+12>>2]-+o[m+12>>2];i=i+(j*j+p*p+z*z+A*A);h=h+16|0;if(h>>>0>=n>>>0)break;else m=m+16|0}}else i=0.0;h=q+(s<<2)|0;if(h>>>0<t>>>0)while(1){A=+o[h>>2]-+o[l>>2];h=h+4|0;i=i+A*A;if(h>>>0>=t>>>0)break;else l=l+4|0}o[g+(u<<2)>>2]=i;u=u+1|0}while((u|0)!=(d|0))}if((b|0)<=1){H=1;k[f>>2]=H;ggb(g);r=I;return}E=a+24|0;F=a+20|0;D=a+16|0;C=1;do{if(G){j=0.0;h=0;i=-1.0;B=0;do{z=+o[g+(B<<2)>>2];if(z>j*1.2999999523162842){x=k[E>>2]|0;w=k[F>>2]|0;a=x+((aa(k[c+(B<<2)>>2]|0,w)|0)<<2)|0;y=k[D>>2]|0;v=0;A=0.0;do{s=x+((aa(w,k[c+(v<<2)>>2]|0)|0)<<2)|0;u=s+(y<<2)|0;q=u+-12|0;t=((q>>>0<s>>>0?s:q)+12+(3-s)|0)>>>4<<2;m=a+(t<<2)|0;if(s>>>0<q>>>0){l=s;n=a;p=0.0;while(1){M=+o[l>>2]-+o[n>>2];L=+o[l+4>>2]-+o[n+4>>2];K=+o[l+8>>2]-+o[n+8>>2];J=+o[l+12>>2]-+o[n+12>>2];p=p+(M*M+L*L+K*K+J*J);l=l+16|0;if(l>>>0>=q>>>0)break;else n=n+16|0}}else p=0.0;l=s+(t<<2)|0;if(l>>>0<u>>>0)while(1){M=+o[l>>2]-+o[m>>2];l=l+4|0;p=p+M*M;if(l>>>0>=u>>>0)break;else m=m+4|0}M=+o[g+(v<<2)>>2];A=A+(M<p?M:p);v=v+1|0}while((v|0)!=(d|0));a=!(i<0.0)&!(A<=i);j=a?j:z;h=a?h:B;i=a?i:A}B=B+1|0}while((B|0)!=(d|0));x=c+(h<<2)|0;k[e+(C<<2)>>2]=k[x>>2];v=k[E>>2]|0;w=k[F>>2]|0;x=v+((aa(k[x>>2]|0,w)|0)<<2)|0;y=k[D>>2]|0;u=0;do{q=v+((aa(w,k[c+(u<<2)>>2]|0)|0)<<2)|0;t=q+(y<<2)|0;n=t+-12|0;s=((n>>>0<q>>>0?q:n)+12+(3-q)|0)>>>4<<2;l=x+(s<<2)|0;if(q>>>0<n>>>0){h=q;m=x;i=0.0;while(1){J=+o[h>>2]-+o[m>>2];K=+o[h+4>>2]-+o[m+4>>2];L=+o[h+8>>2]-+o[m+8>>2];M=+o[h+12>>2]-+o[m+12>>2];i=i+(J*J+K*K+L*L+M*M);h=h+16|0;if(h>>>0>=n>>>0)break;else m=m+16|0}}else i=0.0;h=q+(s<<2)|0;if(h>>>0<t>>>0)while(1){M=+o[h>>2]-+o[l>>2];h=h+4|0;i=i+M*M;if(h>>>0>=t>>>0)break;else l=l+4|0}o[H>>2]=i;B=g+(u<<2)|0;k[B>>2]=k[(+o[B>>2]<i?B:H)>>2];u=u+1|0}while((u|0)!=(d|0))}else k[e+(C<<2)>>2]=k[c>>2];C=C+1|0}while((C|0)!=(b|0));k[f>>2]=b;ggb(g);r=I;return}function fMa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;k[a>>2]=94128;f=a+52|0;d=k[f>>2]|0;a:do if(d|0?(e=a+92|0,c=k[e>>2]|0,(c|0)>0):0){b=0;while(1){d=k[d+(b<<2)>>2]|0;if(d){ggb(d);k[(k[f>>2]|0)+(b<<2)>>2]=0;c=k[e>>2]|0}b=b+1|0;if((b|0)>=(c|0))break a;d=k[f>>2]|0}}while(0);b=k[a+48>>2]|0;if(b|0)ggb(b);b=k[f>>2]|0;if(b|0)ggb(b);c=a+64|0;b=k[c>>2]|0;if(b|0)do{f=b;b=k[b>>2]|0;ggb(f);k[c>>2]=b}while((b|0)!=0);YHa(k[a+32>>2]|0);return}function gMa(a){a=a|0;fMa(a);ggb(a);return}function hMa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;p=a+88|0;if((k[p>>2]|0)<2){r=te(44)|0;VHa(r,373858);Cf(r|0,19720,57)}q=a+52|0;d=k[q>>2]|0;o=a+92|0;b=k[o>>2]|0;a:do if(d){if((b|0)>0)c=0;else return;while(1){d=k[d+(c<<2)>>2]|0;if(d){ggb(d);k[(k[q>>2]|0)+(c<<2)>>2]=0;b=k[o>>2]|0}c=c+1|0;if((c|0)>=(b|0))break a;d=k[q>>2]|0}}while(0);if((b|0)<=0)return;f=a+40|0;g=a+60|0;h=a+80|0;j=a+64|0;l=a+68|0;m=a+48|0;n=a+76|0;e=0;do{d=k[f>>2]|0;c=d>>>0>1073741823?-1:d<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[(k[q>>2]|0)+(e<<2)>>2]=b;if(!d)b=0;else{d=k[(k[q>>2]|0)+(e<<2)>>2]|0;c=0;do{k[d+(c<<2)>>2]=c;c=c+1|0;b=k[f>>2]|0}while(c>>>0<b>>>0)}d=k[g>>2]|0;do if((d|0)<32){k[h>>2]=(k[h>>2]|0)+d;c=fgb(8192)|0;if(c|0){k[c>>2]=k[j>>2];k[j>>2]=c;k[g>>2]=8188;c=c+4|0;k[l>>2]=c;d=8188;r=46;break}b=k[41482]|0;c=(b|0)==0;b:do if((k[41497]|0)>-1){do if(c){b=i[165986]|0;i[165986]=b+255|b;b=k[41478]|0;if(!(b&8)){k[41480]=0;k[41479]=0;c=k[41489]|0;k[41485]=c;k[41483]=c;b=c+(k[41490]|0)|0;k[41482]=b;break}else{k[41478]=b|32;break b}}else c=k[41483]|0;while(0);if((b-c|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27)break;b=0;d=373857;c=k[41483]|0}else{b=27;d=373830}upb(c|0,d|0,b|0)|0;k[41483]=(k[41483]|0)+b}else{do if(c){b=i[165986]|0;i[165986]=b+255|b;b=k[41478]|0;if(!(b&8)){k[41480]=0;k[41479]=0;c=k[41489]|0;k[41485]=c;k[41483]=c;b=c+(k[41490]|0)|0;k[41482]=b;break}else{k[41478]=b|32;break b}}else c=k[41483]|0;while(0);if((b-c|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27)break;b=0;d=373857;c=k[41483]|0}else{b=27;d=373830}upb(c|0,d|0,b|0)|0;k[41483]=(k[41483]|0)+b}while(0);c=0;b=k[f>>2]|0}else{c=k[l>>2]|0;r=46}while(0);if((r|0)==46){r=0;k[l>>2]=c+32;k[g>>2]=d+-32;k[n>>2]=(k[n>>2]|0)+32}k[(k[m>>2]|0)+(e<<2)>>2]=c;uMa(a,k[(k[m>>2]|0)+(e<<2)>>2]|0,k[(k[q>>2]|0)+(e<<2)>>2]|0,b,k[p>>2]|0,0);e=e+1|0}while((e|0)<(k[o>>2]|0));return}function iMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=r;r=r+32|0;x=y;u=y+28|0;v=x+8|0;w=x+12|0;m=x+20|0;n=x+16|0;k[x>>2]=93396;k[x+24>>2]=e;p=x+4|0;k[m>>2]=0;k[w>>2]=n;k[n>>2]=0;o[v>>2]=3402823466385288598117041.0e14;i[p>>0]=0;if(!(k[b>>2]|0)){w=0;k[x>>2]=93356;wIa(w);r=y;return}q=b+12|0;s=b+8|0;t=c+12|0;j=c+8|0;l=d+12|0;h=d+8|0;g=0;c=0;do{wIa(c);k[m>>2]=0;k[w>>2]=n;k[n>>2]=0;o[v>>2]=3402823466385288598117041.0e14;i[p>>0]=0;c=(k[q>>2]|0)+((aa(k[s>>2]|0,g)|0)<<2)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,x,c,f);c=ZT(12)|0;k[c>>2]=1;d=c+4|0;i[c+10>>0]=0;i[d>>0]=i[373546]|0;i[d+1>>0]=i[373547]|0;i[d+2>>0]=i[373548]|0;i[d+3>>0]=i[373549]|0;i[d+4>>0]=i[373550]|0;i[d+5>>0]=i[373551]|0;i[u>>0]=1;d=xIa(f,d,u)|0;z=k[c>>2]|0;k[c>>2]=z+-1;if((z|0)==1)ggb(k[c+-4>>2]|0);c=k[x>>2]|0;if(d){d=(k[t>>2]|0)+((aa(k[j>>2]|0,g)|0)<<2)|0;z=(k[l>>2]|0)+((aa(k[h>>2]|0,g)|0)<<2)|0;dh[k[c+28>>2]&255](x,d,z,e)}else{d=(k[t>>2]|0)+((aa(k[j>>2]|0,g)|0)<<2)|0;z=(k[l>>2]|0)+((aa(k[h>>2]|0,g)|0)<<2)|0;dh[k[c+24>>2]&255](x,d,z,e)}g=g+1|0;c=k[n>>2]|0}while(g>>>0<(k[b>>2]|0)>>>0);k[x>>2]=93356;wIa(c);r=y;return}function jMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=a+88|0;y=b+76|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;x=i[c>>0]|0;i[c>>0]=x+255|x;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}b:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break b}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;x=i[c>>0]|0;i[c>>0]=x+255|x;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;x=k[b+44>>2]|0;k[b+28>>2]=x;g=b+20|0;k[g>>2]=x;d=x+(k[b+48>>2]|0)|0;k[e>>2]=d;e=x;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;d=c;g=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}c:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;d=h;break c}d=e+-1|0;if((i[h+d>>0]|0)==10)break;else e=d}if((ci[k[b+36>>2]&255](b,h,e)|0)>>>0<e>>>0)break a;f=4-e|0;d=h+e|0;c=k[g>>2]|0}else{f=4;d=h}while(0);upb(c|0,d|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f}while(0);x=a+92|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;d:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,x,4)|0;break}e:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=x;c=f;break e}c=d+-1|0;if((i[x+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,x,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=x+d|0;c=k[g>>2]|0}else{e=4;d=x;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,x,4)|0;break}f:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=x;c=f;break f}c=d+-1|0;if((i[x+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,x,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=x+d|0;c=k[g>>2]|0}else{e=4;d=x;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+96|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;g:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}h:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break h}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}i:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break i}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+100|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;j:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}k:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break k}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}l:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break l}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+84|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;m:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break m}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}n:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break n}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break m;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break m}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}o:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break o}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break m;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);if((k[x>>2]|0)<=0)return;j=a+52|0;l=a+40|0;m=a+48|0;n=b+16|0;o=b+74|0;p=b+8|0;q=b+4|0;r=b+44|0;s=b+28|0;t=b+20|0;u=b+48|0;v=b+36|0;w=b+75|0;h=0;do{d=k[(k[j>>2]|0)+(h<<2)>>2]|0;g=k[l>>2]<<2;c=k[n>>2]|0;e=(c|0)==0;p:do if((k[y>>2]|0)>-1){do if(e){c=i[o>>0]|0;i[o>>0]=c+255|c;c=k[b>>2]|0;if(!(c&8)){k[p>>2]=0;k[q>>2]=0;f=k[r>>2]|0;k[s>>2]=f;k[t>>2]=f;e=f+(k[u>>2]|0)|0;k[n>>2]=e;break}else{k[b>>2]=c|32;break p}}else{e=c;f=k[t>>2]|0}while(0);c=f;if((e-f|0)>>>0<g>>>0){ci[k[v>>2]&255](b,d,g)|0;break}q:do if((i[w>>0]|0)>-1){f=g;while(1){if(!f){e=g;break q}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[v>>2]&255](b,d,f)|0)>>>0<f>>>0)break p;e=g-f|0;d=d+f|0;c=k[t>>2]|0}else e=g;while(0);upb(c|0,d|0,e|0)|0;k[t>>2]=(k[t>>2]|0)+e}else{do if(e){c=i[o>>0]|0;i[o>>0]=c+255|c;c=k[b>>2]|0;if(!(c&8)){k[p>>2]=0;k[q>>2]=0;f=k[r>>2]|0;k[s>>2]=f;k[t>>2]=f;e=f+(k[u>>2]|0)|0;k[n>>2]=e;break}else{k[b>>2]=c|32;break p}}else{e=c;f=k[t>>2]|0}while(0);c=f;if((e-f|0)>>>0<g>>>0){ci[k[v>>2]&255](b,d,g)|0;break}r:do if((i[w>>0]|0)>-1){f=g;while(1){if(!f){e=g;break r}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[v>>2]&255](b,d,f)|0)>>>0<f>>>0)break p;e=g-f|0;d=d+f|0;c=k[t>>2]|0}else e=g;while(0);upb(c|0,d|0,e|0)|0;k[t>>2]=(k[t>>2]|0)+e}while(0);tMa(a,b,k[(k[m>>2]|0)+(h<<2)>>2]|0,h);h=h+1|0}while((h|0)<(k[x>>2]|0));return}function kMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+16|0;s=t+8|0;q=t;o=a+52|0;d=k[o>>2]|0;a:do if(d|0?(f=a+92|0,e=k[f>>2]|0,(e|0)>0):0){c=0;while(1){d=k[d+(c<<2)>>2]|0;if(d){ggb(d);k[(k[o>>2]|0)+(c<<2)>>2]=0;e=k[f>>2]|0}c=c+1|0;if((c|0)>=(e|0))break a;d=k[o>>2]|0}}while(0);j=a+48|0;c=k[j>>2]|0;if(c|0)ggb(c);c=k[o>>2]|0;if(c|0)ggb(c);l=a+88|0;if((_fb(l,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}m=a+92|0;if((_fb(m,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}n=a+96|0;if((_fb(n,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}p=a+100|0;if((_fb(p,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}if((_fb(a+84|0,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}f=k[m>>2]|0;d=f>>>0>1073741823?-1:f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0){e=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){e=0;break}Qh[c&7]()}k[o>>2]=e;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[j>>2]=c;b:do if((f|0)>0){h=a+40|0;c=0;g=e;while(1){f=k[h>>2]|0;e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[g+(c<<2)>>2]=d;if((_fb(k[(k[o>>2]|0)+(c<<2)>>2]|0,4,f,b)|0)!=(f|0))break;sMa(a,b,(k[j>>2]|0)+(c<<2)|0,c);c=c+1|0;if((c|0)>=(k[m>>2]|0))break b;g=k[o>>2]|0}t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}while(0);h=a+28|0;c=s+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373358;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));o=WHa(h,s)|0;b=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[q>>2]=b;b=k[o>>2]|0;a=o+4|0;jh[k[k[b>>2]>>2]&1023](b,a);k[o>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,q,a);k[c>>2]=0;k[s>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0);c=s+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373742;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));a=WHa(h,s)|0;o=k[a>>2]|0;q=a+4|0;jh[k[k[o>>2]>>2]&1023](o,q);k[a>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,l,q);k[c>>2]=0;k[s>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0);q=s+4|0;c=ZT(12)|0;k[c>>2]=1;o=c+4|0;k[s>>2]=o;k[q>>2]=5;i[c+9>>0]=0;i[o>>0]=i[380533]|0;i[o+1>>0]=i[380534]|0;i[o+2>>0]=i[380535]|0;i[o+3>>0]=i[380536]|0;i[o+4>>0]=i[380537]|0;o=WHa(h,s)|0;b=k[o>>2]|0;a=o+4|0;jh[k[k[b>>2]>>2]&1023](b,a);k[o>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,m,a);k[q>>2]=0;k[s>>2]=0;q=k[c>>2]|0;k[c>>2]=q+-1;if((q|0)==1)ggb(k[c+-4>>2]|0);c=s+4|0;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[c>>2]=12;i[d+16>>0]=0;f=373752;g=e+12|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));a=WHa(h,s)|0;o=k[a>>2]|0;q=a+4|0;jh[k[k[o>>2]>>2]&1023](o,q);k[a>>2]=428728;Ph[k[(k[107182]|0)+4>>2]&511](428728,n,q);k[c>>2]=0;k[s>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0);c=s+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373765;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));a=WHa(h,s)|0;o=k[a>>2]|0;q=a+4|0;jh[k[k[o>>2]>>2]&1023](o,q);k[a>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,p,q);k[c>>2]=0;k[s>>2]=0;s=k[d>>2]|0;k[d>>2]=s+-1;if((s|0)!=1){r=t;return}ggb(k[d+-4>>2]|0);r=t;return}function lMa(a){a=a|0;return k[a+40>>2]|0}function mMa(a){a=a|0;return k[a+44>>2]|0}function nMa(a){a=a|0;return (k[a+80>>2]|0)+(k[a+76>>2]|0)+(k[a+84>>2]|0)|0}function oMa(a){a=a|0;return 5}function pMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+28>>2]|0;f=b+32|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function qMa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+16|0;z=A+4|0;y=A;e=ZT(12)|0;k[e>>2]=1;u=e+4|0;i[e+10>>0]=0;i[u>>0]=i[373823]|0;i[u+1>>0]=i[373824]|0;i[u+2>>0]=i[373825]|0;i[u+3>>0]=i[373826]|0;i[u+4>>0]=i[373827]|0;i[u+5>>0]=i[373828]|0;k[z>>2]=32;u=dIa(d,u,z)|0;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)ggb(k[e+-4>>2]|0);while(1){d=fgb(20)|0;if(d|0){s=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){s=0;break}Qh[d&7]()}f=a+40|0;g=k[f>>2]|0;k[s>>2]=0;t=s+4|0;k[t>>2]=0;h=s+8|0;k[h>>2]=0;k[s+12>>2]=g;if(g){if(g>>>0>536870911){A=te(4)|0;k[A>>2]=172664;Cf(A|0,28816,1287)}e=g<<3;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}q=d;k[s>>2]=q;k[t>>2]=q;k[h>>2]=d+(g<<3);g=k[f>>2]|0}q=s+16|0;k[q>>2]=0;k[z>>2]=0;f=z+4|0;k[f>>2]=0;h=z+8|0;k[h>>2]=0;if(g|0){if((g|0)<0)ad(426534,426557,304,426811);j=((g+-1|0)>>>5)+1|0;e=j<<2;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[z>>2]=d;k[h>>2]=j;k[f>>2]=g;p=g>>>5;zpb(d|0,0,p<<2|0)|0;e=g-(p<<5)|0;d=d+(p<<2)|0;if(e|0)k[d>>2]=k[d>>2]&~(-1>>>(32-e|0))}k[y>>2]=0;e=a+92|0;if((k[e>>2]|0)>0){f=a+48|0;d=0;do{rMa(a,k[(k[f>>2]|0)+(d<<2)>>2]|0,b,c,y,u,s,z);d=d+1|0}while((d|0)<(k[e>>2]|0))}while(1){if(!(k[q>>2]|0))break;n=k[s>>2]|0;p=k[n>>2]|0;d=k[t>>2]|0;m=d-n|0;e=m>>3;if(((m|0)>8?(v=d+-8|0,m=n,j=k[m>>2]|0,m=k[m+4>>2]|0,f=v,g=k[f+4>>2]|0,h=n,k[h>>2]=k[f>>2],k[h+4>>2]=g,v,k[v>>2]=j,k[v+4>>2]=m,v=e+-1|0,(e|0)!=2):0)?(m=e+-3|0,w=(m|0)/2|0,(m|0)>=-1):0){d=n+8|0;if((v|0)>2?+o[n+20>>2]<+o[n+12>>2]:0){e=2;d=n+16|0}else e=1;l=+o[n+4>>2];if(!(l<+o[d+4>>2])){m=k[n>>2]|0;j=n;while(1){h=j;j=d;f=j;g=k[f+4>>2]|0;k[h>>2]=k[f>>2];k[h+4>>2]=g;if((w|0)<(e|0))break;e=e<<1|1;g=n+(e<<3)|0;f=g;h=e+1|0;if((h|0)<(v|0)?(x=g+8|0,+o[x+4>>2]<+o[n+(e<<3)+4>>2]):0){e=h;f=x}if(l<+o[f+4>>2])break;else d=f}k[d>>2]=m;o[d+4>>2]=l}}k[t>>2]=(k[t>>2]|0)+-8;k[q>>2]=(k[q>>2]|0)+-1;if((k[y>>2]|0)>=(u|0)?Xh[k[(k[b>>2]|0)+8>>2]&1023](b)|0:0)break;rMa(a,p,b,c,y,u,s,z)}d=k[s>>2]|0;e=d;if(d|0){f=k[t>>2]|0;if((f|0)!=(d|0))k[t>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(d)}ggb(s);d=k[z>>2]|0;if(!d){r=A;return}ggb(d);r=A;return}function rMa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0.0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0.0,I=0.0,J=0.0,K=0.0;G=b+8|0;w=k[G>>2]|0;if(!w){if((k[e>>2]|0)>=(f|0)?Xh[k[(k[c>>2]|0)+8>>2]&1023](c)|0:0)return;z=b+4|0;i=k[z>>2]|0;if((i|0)<=0)return;w=b+12|0;x=a+24|0;y=a+20|0;v=a+44|0;u=0;b=k[h>>2]|0;do{r=k[(k[w>>2]|0)+(u<<2)>>2]|0;s=r>>>5;t=1<<(r&31);if(!(t&k[b+(s<<2)>>2])){n=(k[x>>2]|0)+((aa(k[y>>2]|0,r)|0)<<2)|0;q=n+(k[v>>2]<<2)|0;m=q+-12|0;p=((m>>>0<n>>>0?n:m)+12+(3-n)|0)>>>4<<2;i=d+(p<<2)|0;if(n>>>0<m>>>0){b=n;l=d;j=0.0;while(1){J=+o[b>>2]-+o[l>>2];I=+o[b+4>>2]-+o[l+4>>2];H=+o[b+8>>2]-+o[l+8>>2];F=+o[b+12>>2]-+o[l+12>>2];j=j+(J*J+I*I+H*H+F*F);b=b+16|0;if(b>>>0>=m>>>0)break;else l=l+16|0}}else j=0.0;b=n+(p<<2)|0;if(b>>>0<q>>>0)while(1){J=+o[b>>2]-+o[i>>2];b=b+4|0;j=j+J*J;if(b>>>0>=q>>>0)break;else i=i+4|0}$f[k[(k[c>>2]|0)+12>>2]&15](c,j,r);b=k[h>>2]|0;i=b+(s<<2)|0;k[i>>2]=k[i>>2]|t;k[e>>2]=(k[e>>2]|0)+1;i=k[z>>2]|0}u=u+1|0}while((u|0)<(i|0));return}z=a+88|0;x=k[z>>2]|0;i=x>>>0>1073741823?-1:x<<2;i=(i|0)==0?1:i;while(1){b=fgb(i)|0;if(b|0){y=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){y=0;break}Qh[b&7]()}s=k[a+24>>2]|0;t=k[a+20>>2]|0;b=s+((aa(t,k[k[w>>2]>>2]|0)|0)<<2)|0;u=d+(k[a+44>>2]<<2)|0;q=u+-12|0;v=((q>>>0<d>>>0?d:q)+12+(3-d)|0)>>>4<<2;l=b+(v<<2)|0;m=q>>>0>d>>>0;if(m){i=d;j=0.0;while(1){K=+o[i>>2]-+o[b>>2];H=+o[i+4>>2]-+o[b+4>>2];I=+o[i+8>>2]-+o[b+8>>2];J=+o[i+12>>2]-+o[b+12>>2];j=j+(K*K+H*H+I*I+J*J);i=i+16|0;if(i>>>0>=q>>>0)break;else b=b+16|0}}else j=0.0;r=d+(v<<2)|0;p=r>>>0<u>>>0;if(p){i=l;b=r;while(1){K=+o[b>>2]-+o[i>>2];b=b+4|0;j=j+K*K;if(b>>>0>=u>>>0)break;else i=i+4|0}}o[y>>2]=j;a:do if((x|0)>1){if(m){n=1;b=0}else{if(p){m=1;b=0}else{i=1;b=0;while(1){o[y+(i<<2)>>2]=0.0;b=+o[y+(b<<2)>>2]>0.0?i:b;i=i+1|0;if((i|0)==(x|0)){w=b;break a}}}while(1){i=s+((aa(t,k[k[w+(m<<2)>>2]>>2]|0)|0)<<2)+(v<<2)|0;j=0.0;l=r;while(1){K=+o[l>>2]-+o[i>>2];l=l+4|0;j=j+K*K;if(l>>>0>=u>>>0)break;else i=i+4|0}o[y+(m<<2)>>2]=j;b=j<+o[y+(b<<2)>>2]?m:b;m=m+1|0;if((m|0)==(x|0)){w=b;break a}}}do{m=s+((aa(t,k[k[w+(n<<2)>>2]>>2]|0)|0)<<2)|0;i=d;l=m;j=0.0;while(1){H=+o[i>>2]-+o[l>>2];I=+o[i+4>>2]-+o[l+4>>2];J=+o[i+8>>2]-+o[l+8>>2];K=+o[i+12>>2]-+o[l+12>>2];j=j+(H*H+I*I+J*J+K*K);i=i+16|0;if(i>>>0>=q>>>0)break;else l=l+16|0}if(p){l=m+(v<<2)|0;i=r;while(1){K=+o[i>>2]-+o[l>>2];i=i+4|0;j=j+K*K;if(i>>>0>=u>>>0)break;else l=l+4|0}}o[y+(n<<2)>>2]=j;b=j<+o[y+(b<<2)>>2]?n:b;n=n+1|0}while((n|0)!=(x|0));w=b}else w=0;while(0);b:do if((x|0)>0){s=g+16|0;t=g+12|0;u=g+4|0;v=g+8|0;r=0;b=x;while(1){if((r|0)!=(w|0)?(A=k[y+(r<<2)>>2]|0,B=k[(k[G>>2]|0)+(r<<2)>>2]|0,(k[s>>2]|0)!=(k[t>>2]|0)):0){b=k[u>>2]|0;x=k[v>>2]|0;i=x;if((b|0)==(x|0)){q=k[g>>2]|0;p=b-q|0;n=p>>3;b=n+1|0;if(b>>>0>536870911){b=41;break}x=i-q|0;m=x>>2;m=x>>3>>>0<268435455?(m>>>0<b>>>0?b:m):536870911;if(!m)b=0;else{if(m>>>0>536870911){b=44;break}i=m<<3;i=(i|0)==0?1:i;while(1){b=fgb(i)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}}i=b+(n<<3)|0;l=i;k[l>>2]=B;k[l+4>>2]=A;l=i+8|0;i=i+(0-n<<3)|0;if((p|0)>0)upb(i|0,q|0,p|0)|0;k[g>>2]=i;k[u>>2]=l;k[v>>2]=b+(m<<3);if(q){ggb(q);l=k[u>>2]|0}}else{l=b;k[l>>2]=B;k[l+4>>2]=A;l=(k[u>>2]|0)+8|0;k[u>>2]=l}b=k[g>>2]|0;i=l-b|0;if((i|0)>8?(C=((i>>3)+-2|0)/2|0,D=b,x=l,E=x+-8|0,F=+o[x+-4>>2],F<+o[D+(C<<3)+4>>2]):0){m=k[E>>2]|0;l=E;b=C;while(1){x=l;l=D+(b<<3)|0;p=l;q=k[p+4>>2]|0;k[x>>2]=k[p>>2];k[x+4>>2]=q;if(!b){b=0;break}i=(b+-1|0)/2|0;if(!(F<+o[D+(i<<3)+4>>2]))break;else b=i}k[l>>2]=m;o[D+(b<<3)+4>>2]=F}k[s>>2]=(k[s>>2]|0)+1;b=k[z>>2]|0}r=r+1|0;if((r|0)>=(b|0))break b}if((b|0)==41)ad(426534,426557,304,426811);else if((b|0)==44){h=te(4)|0;k[h>>2]=172664;Cf(h|0,28816,1287)}}while(0);ggb(y);rMa(a,k[(k[G>>2]|0)+(w<<2)>>2]|0,c,d,e,f,g,h);return}function sMa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;h=n;l=a+60|0;f=k[l>>2]|0;a:do if((f|0)<32){e=a+80|0;k[e>>2]=(k[e>>2]|0)+f;e=fgb(8192)|0;if(e|0){g=a+64|0;k[e>>2]=k[g>>2];k[g>>2]=e;k[l>>2]=8188;e=e+4|0;g=a+68|0;k[g>>2]=e;f=8156;m=28;break}e=k[41482]|0;f=(e|0)==0;if((k[41497]|0)>-1){do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;e=0;break a}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;e=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){e=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;e=0;break}else{do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;e=0;break a}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;e=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){e=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;e=0;break}}else{e=a+68|0;g=e;e=k[e>>2]|0;f=f+-32|0;m=28}while(0);if((m|0)==28){k[g>>2]=e+32;k[l>>2]=f;j=a+76|0;k[j>>2]=(k[j>>2]|0)+32}k[c>>2]=e;if((_fb(e,20,1,b)|0)!=1){n=te(44)|0;VHa(n,373124);Cf(n|0,19720,57)}if(!(k[(k[c>>2]|0)+8>>2]|0)){if((_fb(h,4,1,b)|0)!=1){n=te(44)|0;VHa(n,373124);Cf(n|0,19720,57)}k[(k[c>>2]|0)+12>>2]=(k[(k[a+52>>2]|0)+(d<<2)>>2]|0)+(k[h>>2]<<2);r=n;return}j=a+88|0;h=(k[j>>2]<<2)+15&-16;f=k[l>>2]|0;b:do if((h|0)>(f|0)){e=a+80|0;k[e>>2]=(k[e>>2]|0)+f;e=(h|4)+15|0;e=e>>>0>8192?e:8192;f=fgb(e)|0;if(f|0){m=a+64|0;k[f>>2]=k[m>>2];k[m>>2]=f;m=e+-4|0;k[l>>2]=m;e=f+4|0;g=a+68|0;k[g>>2]=e;f=m;m=62;break}e=k[41482]|0;f=(e|0)==0;if((k[41497]|0)>-1){do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;e=0;break b}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;e=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){e=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;e=0;break}else{do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;e=0;break b}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;e=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){e=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;e=0;break}}else{e=a+68|0;g=e;e=k[e>>2]|0;m=62}while(0);if((m|0)==62){k[g>>2]=e+h;k[l>>2]=f-h;m=a+76|0;k[m>>2]=(k[m>>2]|0)+h}k[(k[c>>2]|0)+8>>2]=e;if((k[j>>2]|0)>0)e=0;else{r=n;return}do{sMa(a,b,(k[(k[c>>2]|0)+8>>2]|0)+(e<<2)|0,d);e=e+1|0}while((e|0)<(k[j>>2]|0));r=n;return}function tMa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;f=n;m=b+76|0;h=b+16|0;g=k[h>>2]|0;e=(g|0)==0;a:do if((k[m>>2]|0)>-1){do if(e){e=b+74|0;l=i[e>>0]|0;i[e>>0]=l+255|l;e=k[b>>2]|0;if(!(e&8)){k[b+8>>2]=0;k[b+4>>2]=0;e=k[b+44>>2]|0;k[b+28>>2]=e;l=b+20|0;k[l>>2]=e;g=e+(k[b+48>>2]|0)|0;k[h>>2]=g;break}else{k[b>>2]=e|32;break a}}else{e=b+20|0;l=e;e=k[e>>2]|0}while(0);j=e;if((g-e|0)>>>0<20){ci[k[b+36>>2]&255](b,c,20)|0;break}b:do if((i[b+75>>0]|0)>-1){g=20;while(1){if(!g){h=20;g=c;e=j;break b}e=g+-1|0;if((i[c+e>>0]|0)==10)break;else g=e}if((ci[k[b+36>>2]&255](b,c,g)|0)>>>0<g>>>0)break a;h=20-g|0;g=c+g|0;e=k[l>>2]|0}else{h=20;g=c;e=j}while(0);upb(e|0,g|0,h|0)|0;k[l>>2]=(k[l>>2]|0)+h}else{do if(e){e=b+74|0;l=i[e>>0]|0;i[e>>0]=l+255|l;e=k[b>>2]|0;if(!(e&8)){k[b+8>>2]=0;k[b+4>>2]=0;e=k[b+44>>2]|0;k[b+28>>2]=e;l=b+20|0;k[l>>2]=e;g=e+(k[b+48>>2]|0)|0;k[h>>2]=g;break}else{k[b>>2]=e|32;break a}}else{e=b+20|0;l=e;e=k[e>>2]|0}while(0);j=e;if((g-e|0)>>>0<20){ci[k[b+36>>2]&255](b,c,20)|0;break}c:do if((i[b+75>>0]|0)>-1){g=20;while(1){if(!g){h=20;g=c;e=j;break c}e=g+-1|0;if((i[c+e>>0]|0)==10)break;else g=e}if((ci[k[b+36>>2]&255](b,c,g)|0)>>>0<g>>>0)break a;h=20-g|0;g=c+g|0;e=k[l>>2]|0}else{h=20;g=c;e=j}while(0);upb(e|0,g|0,h|0)|0;k[l>>2]=(k[l>>2]|0)+h}while(0);g=c+8|0;e=k[g>>2]|0;if(e|0){f=a+88|0;if((k[f>>2]|0)<=0){r=n;return}tMa(a,b,k[e>>2]|0,d);if((k[f>>2]|0)>1)e=1;else{r=n;return}do{tMa(a,b,k[(k[g>>2]|0)+(e<<2)>>2]|0,d);e=e+1|0}while((e|0)<(k[f>>2]|0));r=n;return}k[f>>2]=(k[c+12>>2]|0)-(k[(k[a+52>>2]|0)+(d<<2)>>2]|0)>>2;h=b+16|0;g=k[h>>2]|0;e=(g|0)==0;d:do if((k[m>>2]|0)>-1){do if(e){e=b+74|0;m=i[e>>0]|0;i[e>>0]=m+255|m;e=k[b>>2]|0;if(!(e&8)){k[b+8>>2]=0;k[b+4>>2]=0;m=k[b+44>>2]|0;k[b+28>>2]=m;j=b+20|0;k[j>>2]=m;g=m+(k[b+48>>2]|0)|0;k[h>>2]=g;h=m;break}else{k[b>>2]=e|32;break d}}else{h=b+20|0;j=h;h=k[h>>2]|0}while(0);e=h;if((g-h|0)>>>0<4){ci[k[b+36>>2]&255](b,f,4)|0;break}e:do if((i[b+75>>0]|0)>-1){h=4;while(1){if(!h){g=4;break e}g=h+-1|0;if((i[f+g>>0]|0)==10)break;else h=g}if((ci[k[b+36>>2]&255](b,f,h)|0)>>>0<h>>>0)break d;g=4-h|0;f=f+h|0;e=k[j>>2]|0}else g=4;while(0);upb(e|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}else{do if(e){e=b+74|0;m=i[e>>0]|0;i[e>>0]=m+255|m;e=k[b>>2]|0;if(!(e&8)){k[b+8>>2]=0;k[b+4>>2]=0;m=k[b+44>>2]|0;k[b+28>>2]=m;j=b+20|0;k[j>>2]=m;g=m+(k[b+48>>2]|0)|0;k[h>>2]=g;h=m;break}else{k[b>>2]=e|32;break d}}else{h=b+20|0;j=h;h=k[h>>2]|0}while(0);e=h;if((g-h|0)>>>0<4){ci[k[b+36>>2]&255](b,f,4)|0;break}f:do if((i[b+75>>0]|0)>-1){h=4;while(1){if(!h){g=4;break f}g=h+-1|0;if((i[f+g>>0]|0)==10)break;else h=g}if((ci[k[b+36>>2]&255](b,f,h)|0)>>>0<h>>>0)break d;g=4-h|0;f=f+h|0;e=k[j>>2]|0}else g=4;while(0);upb(e|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}while(0);r=n;return}function uMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,p=0.0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0;G=r;r=r+16|0;m=G;k[b+4>>2]=d;k[b+16>>2]=f;if((k[a+100>>2]|0)>(d|0)){k[b+12>>2]=c;Dgb(c,c+(d<<2)|0);k[b+8>>2]=0;r=G;return}if(!e)g=0;else{if(e>>>0>1073741823)ad(426534,426557,304,426811);j=e<<2;h=(j|0)==0?1:j;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}zpb(g|0,0,j|0)|0}if(!d)h=0;else{if(d>>>0>1073741823)ad(426534,426557,304,426811);l=d<<2;j=(l|0)==0?1:l;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}zpb(h|0,0,l|0)|0}j=k[a+4>>2]|0;E=k[a+8>>2]|0;l=a+(E>>1)|0;if(E&1)j=k[(k[l>>2]|0)+j>>2]|0;Lg[j&255](l,e,c,d,g,m);x=k[m>>2]|0;a:do if((x|0)>=(e|0)){E=(d|0)>0;if(E){y=k[a+24>>2]|0;z=a+20|0;A=a+44|0;B=(x|0)>1;w=0;do{j=k[z>>2]|0;C=y+((aa(j,k[c+(w<<2)>>2]|0)|0)<<2)|0;j=y+((aa(k[g>>2]|0,j)|0)<<2)|0;t=C+(k[A>>2]<<2)|0;n=t+-12|0;D=3-C|0;s=((n>>>0<C>>>0?C:n)+12+D|0)>>>4<<2;l=j+(s<<2)|0;if(C>>>0<n>>>0){m=C;p=0.0;while(1){J=+o[m>>2]-+o[j>>2];I=+o[m+4>>2]-+o[j+4>>2];H=+o[m+8>>2]-+o[j+8>>2];q=+o[m+12>>2]-+o[j+12>>2];p=p+(J*J+I*I+H*H+q*q);m=m+16|0;if(m>>>0>=n>>>0)break;else j=j+16|0}}else p=0.0;j=C+(s<<2)|0;if(j>>>0<t>>>0)while(1){J=+o[j>>2]-+o[l>>2];j=j+4|0;p=p+J*J;if(j>>>0>=t>>>0)break;else l=l+4|0}v=h+(w<<2)|0;k[v>>2]=0;if(B){u=1;do{j=y+((aa(k[z>>2]|0,k[g+(u<<2)>>2]|0)|0)<<2)|0;t=C+(k[A>>2]<<2)|0;n=t+-12|0;s=((n>>>0<C>>>0?C:n)+12+D|0)>>>4<<2;l=j+(s<<2)|0;if(C>>>0<n>>>0){m=C;q=0.0;while(1){K=+o[m>>2]-+o[j>>2];H=+o[m+4>>2]-+o[j+4>>2];I=+o[m+8>>2]-+o[j+8>>2];J=+o[m+12>>2]-+o[j+12>>2];q=q+(K*K+H*H+I*I+J*J);m=m+16|0;if(m>>>0>=n>>>0)break;else j=j+16|0}}else q=0.0;j=C+(s<<2)|0;if(j>>>0<t>>>0)while(1){K=+o[j>>2]-+o[l>>2];j=j+4|0;q=q+K*K;if(j>>>0>=t>>>0)break;else l=l+4|0}if(p>q){k[v>>2]=u;p=q}u=u+1|0}while((u|0)!=(x|0))}w=w+1|0}while((w|0)!=(d|0))}n=(e<<2)+15&-16;A=a+60|0;l=k[A>>2]|0;b:do if((n|0)>(l|0)){j=a+80|0;k[j>>2]=(k[j>>2]|0)+l;j=(n|4)+15|0;j=j>>>0>8192?j:8192;l=fgb(j)|0;if(l|0){F=a+64|0;k[l>>2]=k[F>>2];k[F>>2]=l;F=j+-4|0;k[A>>2]=F;j=l+4|0;m=a+68|0;k[m>>2]=j;l=F;F=66;break}j=k[41482]|0;l=(j|0)==0;if((k[41497]|0)>-1){do if(l){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;l=k[41489]|0;k[41485]=l;k[41483]=l;j=l+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break b}}else l=k[41483]|0;while(0);if((j-l|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;m=373857;l=k[41483]|0}else{j=27;m=373830}upb(l|0,m|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}else{do if(l){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;l=k[41489]|0;k[41485]=l;k[41483]=l;j=l+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break b}}else l=k[41483]|0;while(0);if((j-l|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;m=373857;l=k[41483]|0}else{j=27;m=373830}upb(l|0,m|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}}else{j=a+68|0;m=j;j=k[j>>2]|0;F=66}while(0);if((F|0)==66){k[m>>2]=j+n;k[A>>2]=l-n;D=a+76|0;k[D>>2]=(k[D>>2]|0)+n}z=b+8|0;k[z>>2]=j;if((e|0)>0){w=a+80|0;x=a+64|0;y=a+68|0;u=f+1|0;v=a+76|0;if(E){s=0;t=0}else{n=0;while(1){l=k[A>>2]|0;c:do if((l|0)<32){k[w>>2]=(k[w>>2]|0)+l;j=fgb(8192)|0;if(j|0){k[j>>2]=k[x>>2];k[x>>2]=j;k[A>>2]=8188;j=j+4|0;k[y>>2]=j;l=8188;F=129;break}j=k[41482]|0;l=(j|0)==0;if((k[41497]|0)>-1){do if(l){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;l=k[41489]|0;k[41485]=l;k[41483]=l;j=l+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break c}}else l=k[41483]|0;while(0);if((j-l|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;m=373857;l=k[41483]|0}else{j=27;m=373830}upb(l|0,m|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}else{do if(l){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;l=k[41489]|0;k[41485]=l;k[41483]=l;j=l+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break c}}else l=k[41483]|0;while(0);if((j-l|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;m=373857;l=k[41483]|0}else{j=27;m=373830}upb(l|0,m|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}}else{j=k[y>>2]|0;F=129}while(0);if((F|0)==129){F=0;k[y>>2]=j+32;k[A>>2]=l+-32;k[v>>2]=(k[v>>2]|0)+32}k[(k[z>>2]|0)+(n<<2)>>2]=j;d=(k[z>>2]|0)+(n<<2)|0;f=k[d>>2]|0;k[f>>2]=k[g+(n<<2)>>2];k[f+12>>2]=0;uMa(a,k[d>>2]|0,c,0,e,u);n=n+1|0;if((n|0)>=(e|0))break a}}while(1){m=0;j=t;while(1){l=h+(m<<2)|0;if((k[l>>2]|0)==(s|0)){b=c+(m<<2)|0;n=c+(j<<2)|0;f=k[b>>2]|0;k[b>>2]=k[n>>2];k[n>>2]=f;n=h+(j<<2)|0;f=k[l>>2]|0;k[l>>2]=k[n>>2];k[n>>2]=f;n=j+1|0}else n=j;m=m+1|0;if((m|0)==(d|0))break;else j=n}l=k[A>>2]|0;d:do if((l|0)<32){k[w>>2]=(k[w>>2]|0)+l;j=fgb(8192)|0;if(j|0){k[j>>2]=k[x>>2];k[x>>2]=j;k[A>>2]=8188;j=j+4|0;k[y>>2]=j;l=8188;F=73;break}j=k[41482]|0;l=(j|0)==0;if((k[41497]|0)>-1){do if(l){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;l=k[41489]|0;k[41485]=l;k[41483]=l;j=l+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break d}}else l=k[41483]|0;while(0);if((j-l|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;m=373857;l=k[41483]|0}else{j=27;m=373830}upb(l|0,m|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}else{do if(l){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;l=k[41489]|0;k[41485]=l;k[41483]=l;j=l+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break d}}else l=k[41483]|0;while(0);if((j-l|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;m=373857;l=k[41483]|0}else{j=27;m=373830}upb(l|0,m|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}}else{j=k[y>>2]|0;F=73}while(0);if((F|0)==73){F=0;k[y>>2]=j+32;k[A>>2]=l+-32;k[v>>2]=(k[v>>2]|0)+32}k[(k[z>>2]|0)+(s<<2)>>2]=j;f=(k[z>>2]|0)+(s<<2)|0;b=k[f>>2]|0;k[b>>2]=k[g+(s<<2)>>2];k[b+12>>2]=0;uMa(a,k[f>>2]|0,c+(t<<2)|0,n-t|0,e,u);s=s+1|0;if((s|0)>=(e|0))break;else t=n}}}else{k[b+12>>2]=c;Dgb(c,c+(d<<2)|0);k[b+8>>2]=0}while(0);if(h|0)ggb(h);if(!g){r=G;return}ggb(g);r=G;return}function vMa(a){a=a|0;var b=0,c=0;k[a>>2]=94188;b=a+4|0;c=k[b>>2]|0;if(c|0){Uh[k[(k[c>>2]|0)+4>>2]&2047](c);k[b>>2]=0}YHa(k[a+24>>2]|0);YHa(k[a+12>>2]|0);return}function wMa(a){a=a|0;var b=0,c=0;k[a>>2]=94188;b=a+4|0;c=k[b>>2]|0;if(c|0){Uh[k[(k[c>>2]|0)+4>>2]&2047](c);k[b>>2]=0}YHa(k[a+24>>2]|0);YHa(k[a+12>>2]|0);ggb(a);return}function xMa(a){a=a|0;var b=0,c=0.0,d=0,e=0.0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0;Na=r;r=r+768|0;La=Na+360|0;Ka=Na+352|0;Ja=Na+344|0;Ia=Na+336|0;Aa=Na+328|0;ya=Na+320|0;ua=Na+312|0;xa=Na+304|0;za=Na+296|0;Ha=Na+280|0;Ba=Na+264|0;va=Na+248|0;ra=Na+240|0;la=Na+224|0;ja=Na+208|0;$=Na+200|0;_=Na+176|0;Z=Na+168|0;Y=Na+160|0;ca=Na+64|0;ba=Na+32|0;q=Na+24|0;pa=Na;Q=Na+720|0;R=Na+616|0;S=Na+600|0;X=Na+580|0;T=Na+552|0;ma=Na+540|0;s=Na+512|0;Ga=Na+376|0;oa=Na+364|0;qa=Na+744|0;Ea=Na+732|0;Ma=Ga+56|0;Fa=Ga+4|0;k[Ga>>2]=49424;k[Ma>>2]=49444;k[Ga+80>>2]=Fa;k[Ga+72>>2]=0;k[Ga+76>>2]=0;k[Ga+60>>2]=4098;k[Ga+68>>2]=0;k[Ga+64>>2]=6;b=Ga+84|0;L=Ga+88|0;M=L+40|0;do{k[L>>2]=0;L=L+4|0}while((L|0)<(M|0));eob(b);k[Ga+128>>2]=0;k[Ga+132>>2]=-1;k[Ga>>2]=49464;k[Ma>>2]=49484;k[Fa>>2]=169272;Ca=Ga+8|0;eob(Ca);Da=Ga+12|0;k[Da>>2]=0;k[Da+4>>2]=0;k[Da+8>>2]=0;k[Da+12>>2]=0;k[Da+16>>2]=0;k[Da+20>>2]=0;k[Fa>>2]=49500;Da=Ga+36|0;k[Da>>2]=0;k[Da+4>>2]=0;k[Da+8>>2]=0;k[Da+12>>2]=0;k[Ga+52>>2]=16;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;C4(Fa,Q);if((i[Q+11>>0]|0)<0)ggb(k[Q>>2]|0);wa=a+8|0;k[ma>>2]=0;na=ma+4|0;k[na>>2]=0;k[ma+8>>2]=0;sa=a+84|0;ka=k[sa>>2]|0;b=~~(+o[a+112>>2]*+(ka>>>0));d=(b|0)/10|0;d=(d|0)>1e3?1e3:d;ta=a+100|0;h=+o[ta>>2];k[pa>>2]=ka;k[pa+4>>2]=b;k[pa+8>>2]=d;p[pa+16>>3]=h;IJa(374745,pa);if((d|0)<10){IJa(374842,q);TJa(pa);j=oa+4|0;k[j>>2]=0;l=oa+8|0;k[l>>2]=0;m=oa+4|0;k[oa>>2]=m;b=k[pa>>2]|0;n=pa+4|0;if((b|0)!=(n|0)){d=b;while(1){f=d+16|0;g=ZHa(oa,m,q,f)|0;if(!(k[g>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=k[f>>2]|0;k[b+16>>2]=f;k[b+20>>2]=k[d+20>>2];if(f|0){la=f+-4|0;k[la>>2]=(k[la>>2]|0)+1}ka=b+24|0;k[ka>>2]=428704;f=b+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);la=k[d+24>>2]|0;k[ka>>2]=la;Ph[k[(k[la>>2]|0)+8>>2]&511](la,d+28|0,f);f=k[q>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=f;k[g>>2]=b;f=k[k[oa>>2]>>2]|0;if(f){k[oa>>2]=f;b=k[g>>2]|0}B4(k[j>>2]|0,b);k[l>>2]=(k[l>>2]|0)+1}else d=b;b=k[d+4>>2]|0;if(!b)while(1){b=k[d+8>>2]|0;if((k[b>>2]|0)==(d|0))break;else d=b}else while(1){d=k[b>>2]|0;if(!d)break;else b=d}if((b|0)==(n|0))break;else d=b}}YHa(k[n>>2]|0)}else{W=a+32|0;JJa(pa,sa,b);k[W>>2]=k[pa>>2];k[W+4>>2]=k[pa+4>>2];k[W+8>>2]=k[pa+8>>2];k[W+12>>2]=k[pa+12>>2];V=a+48|0;UJa(pa,W,d);k[V>>2]=k[pa>>2];k[V+4>>2]=k[pa+4>>2];k[V+8>>2]=k[pa+8>>2];k[V+12>>2]=k[pa+12>>2];IJa(374878,ba);f=k[V>>2]|0;d=f>>>0>1073741823?-1:f<<2;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[a+64>>2]=f;j=a+68|0;k[j>>2]=1;l=a+72|0;k[l>>2]=1;ga=a+76|0;k[ga>>2]=b;he(ba|0,pa|0)|0;n=k[ba>>2]|0;n=Epb(n|0,((n|0)<0)<<31>>31|0,1e6,0)|0;m=k[ba+4>>2]|0;m=kpb(n|0,N|0,m|0,((m|0)<0)<<31>>31|0)|0;n=N;if(k[V>>2]|0){d=a+60|0;f=a+56|0;b=0;do{fa=(k[d>>2]|0)+((aa(k[f>>2]|0,b)|0)<<2)|0;ka=(k[ga>>2]|0)+((aa(k[l>>2]|0,b)|0)<<2)|0;GMa(W,fa,ka,k[j>>2]|0,0);b=b+1|0}while(b>>>0<(k[V>>2]|0)>>>0)}he(ba|0,pa|0)|0;f=k[ba>>2]|0;f=Epb(f|0,((f|0)<0)<<31>>31|0,1e6,0)|0;b=k[ba+4>>2]|0;b=kpb(f|0,N|0,b|0,((b|0)<0)<<31>>31|0)|0;f=s+16|0;k[s+20>>2]=0;k[s+24>>2]=0;ka=s+20|0;k[f>>2]=ka;o[s>>2]=(+(b>>>0)+4294967296.0*+(N|0)-(+(m>>>0)+4294967296.0*+(n|0)))/1.0e6+0.0;o[s+4>>2]=0.0;o[s+8>>2]=0.0;k[ba>>2]=0;b=ba+4|0;k[b>>2]=0;d=ZT(16)|0;k[d>>2]=1;L=d+4|0;k[ba>>2]=L;k[b>>2]=9;i[d+13>>0]=0;K=373358;M=L+9|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));da=WHa(f,ba)|0;k[pa>>2]=0;U=k[da>>2]|0;fa=da+4|0;jh[k[k[U>>2]>>2]&1023](U,fa);k[da>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,pa,fa);k[b>>2]=0;k[ba>>2]=0;fa=k[d>>2]|0;k[d>>2]=fa+-1;if((fa|0)==1)ggb(k[d+-4>>2]|0);b=k[na>>2]|0;U=ma+8|0;d=k[U>>2]|0;if((b|0)==(d|0)){KMa(ma,s);fa=na;s=U;f=k[na>>2]|0;d=k[U>>2]|0}else{JMa(b,s);f=b+28|0;k[na>>2]=f;fa=na;s=U}IJa(374906,ca);IJa(375148,Y);k[S>>2]=k[23419];k[S+4>>2]=k[23420];k[S+8>>2]=k[23421];k[S+12>>2]=k[23422];k[X>>2]=k[23423];k[X+4>>2]=k[23424];k[X+8>>2]=k[23425];k[X+12>>2]=k[23426];k[X+16>>2]=k[23427];q=k[ma>>2]|0;j=f-q|0;m=((j|0)/28|0)+20|0;b=q;if(((d-q|0)/28|0)>>>0<m>>>0){l=(f-q|0)/28|0;if(!m)d=0;else{if(m>>>0>153391689){Na=te(4)|0;k[Na>>2]=172664;Cf(Na|0,28816,1287)}j=j+560|0;j=(j|0)==0?1:j;while(1){d=fgb(j)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}l=d+(l*28|0)|0;n=l;m=d+(m*28|0)|0;if((f|0)==(b|0)){j=n;f=q}else{j=n;d=l;do{f=f+-28|0;JMa(d+-28|0,f);d=j+-28|0;j=d}while((f|0)!=(b|0));f=k[ma>>2]|0;b=k[na>>2]|0}k[ma>>2]=j;k[fa>>2]=n;k[s>>2]=m;d=f;if((b|0)!=(d|0))do{YHa(k[b+-8>>2]|0);b=b+-28|0}while((b|0)!=(d|0));if(f|0)ggb(f)}l=T+16|0;m=T+20|0;n=T+24|0;q=T+20|0;s=Y+4|0;t=Y+4|0;u=Y+4|0;v=Y+4|0;w=pa+4|0;x=Q+4|0;y=Y+4|0;z=Y+4|0;O=a+64|0;P=a+36|0;A=R+92|0;B=R+96|0;C=R+100|0;D=T+8|0;E=T+4|0;da=a+104|0;F=R+64|0;G=R+68|0;H=R+80|0;I=R+48|0;j=0;do{J=S+(j<<2)|0;f=0;do{k[m>>2]=0;k[n>>2]=0;k[l>>2]=q;k[Y>>2]=0;k[s>>2]=0;b=ZT(16)|0;k[b>>2]=1;L=b+4|0;k[Y>>2]=L;k[s>>2]=9;i[b+13>>0]=0;K=373358;M=L+9|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));L=WHa(l,Y)|0;k[ca>>2]=2;K=k[L>>2]|0;M=L+4|0;jh[k[k[K>>2]>>2]&1023](K,M);k[L>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,ca,M);k[s>>2]=0;k[Y>>2]=0;M=k[b>>2]|0;k[b>>2]=M+-1;if((M|0)==1)ggb(k[b+-4>>2]|0);k[Y>>2]=0;k[t>>2]=0;b=ZT(20)|0;k[b>>2]=1;L=b+4|0;k[Y>>2]=L;k[t>>2]=12;i[b+16>>0]=0;K=373752;M=L+12|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));L=WHa(l,Y)|0;k[ca>>2]=0;K=k[L>>2]|0;M=L+4|0;jh[k[k[K>>2]>>2]&1023](K,M);k[L>>2]=428728;Ph[k[(k[107182]|0)+4>>2]&511](428728,ca,M);k[t>>2]=0;k[Y>>2]=0;M=k[b>>2]|0;k[b>>2]=M+-1;if((M|0)==1)ggb(k[b+-4>>2]|0);k[Y>>2]=0;k[u>>2]=0;b=ZT(16)|0;k[b>>2]=1;L=b+4|0;k[Y>>2]=L;k[u>>2]=10;i[b+14>>0]=0;K=375191;M=L+10|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));L=WHa(l,Y)|0;K=k[L>>2]|0;M=L+4|0;jh[k[k[K>>2]>>2]&1023](K,M);k[L>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,J,M);k[u>>2]=0;k[Y>>2]=0;M=k[b>>2]|0;k[b>>2]=M+-1;if((M|0)==1)ggb(k[b+-4>>2]|0);k[Y>>2]=0;k[v>>2]=0;b=ZT(16)|0;k[b>>2]=1;L=b+4|0;k[Y>>2]=L;k[v>>2]=9;i[b+13>>0]=0;K=373742;M=L+9|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));L=WHa(l,Y)|0;K=k[L>>2]|0;M=L+4|0;jh[k[k[K>>2]>>2]&1023](K,M);k[L>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,X+(f<<2)|0,M);k[v>>2]=0;k[Y>>2]=0;M=k[b>>2]|0;k[b>>2]=M+-1;if((M|0)==1)ggb(k[b+-4>>2]|0);k[pa>>2]=0;k[w>>2]=0;K=ZT(16)|0;k[K>>2]=1;L=K+4|0;k[pa>>2]=L;k[w>>2]=10;i[K+14>>0]=0;K=375191;M=L+10|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));b=EJa(l,pa)|0;k[Q>>2]=0;k[x>>2]=0;d=ZT(16)|0;k[d>>2]=1;L=d+4|0;k[Q>>2]=L;k[x>>2]=9;i[d+13>>0]=0;K=373742;M=L+9|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));M=EJa(l,Q)|0;k[Z>>2]=b;k[Z+4>>2]=M;IJa(375202,Z);k[x>>2]=0;k[Q>>2]=0;M=k[d>>2]|0;k[d>>2]=M+-1;if((M|0)==1)ggb(k[d+-4>>2]|0);b=k[pa>>2]|0;k[w>>2]=0;k[pa>>2]=0;if(b|0?(L=b+-4|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0)ggb(k[b+-8>>2]|0);OLa(R,W,l);he(Y|0,ca|0)|0;b=k[Y>>2]|0;M=k[y>>2]|0;$Ma(R);b=Epb(b|0,((b|0)<0)<<31>>31|0,1e6,0)|0;M=kpb(b|0,N|0,M|0,((M|0)<0)<<31>>31|0)|0;b=N;he(Y|0,ca|0)|0;K=k[Y>>2]|0;K=Epb(K|0,((K|0)<0)<<31>>31|0,1e6,0)|0;L=k[z>>2]|0;L=kpb(K|0,N|0,L|0,((L|0)<0)<<31>>31|0)|0;c=(+(L>>>0)+4294967296.0*+(N|0)-(+(M>>>0)+4294967296.0*+(b|0)))/1.0e6+0.0;e=+HMa(R,W,V,O,+o[ta>>2],ba,0);h=+((aa(k[W>>2]<<2,k[P>>2]|0)|0)>>>0);o[D>>2]=(h+ +((k[B>>2]|0)+(k[A>>2]|0)+(k[C>>2]|0)|0))/h;o[T>>2]=e;o[E>>2]=c;h=+o[da>>2];p[_>>3]=c;p[_+8>>3]=e;p[_+16>>3]=h;IJa(375260,_);k[R>>2]=94308;b=k[F>>2]|0;if(b|0)aNa(R,b);b=k[G>>2]|0;if(b|0)ggb(b);b=k[H>>2]|0;if(b|0)do{M=b;b=k[b>>2]|0;ggb(M);k[H>>2]=b}while((b|0)!=0);YHa(k[I>>2]|0);b=k[na>>2]|0;if((b|0)==(k[U>>2]|0))KMa(ma,T);else{JMa(b,T);k[na>>2]=b+28}YHa(k[q>>2]|0);f=f+1|0}while(f>>>0<5);j=j+1|0}while(j>>>0<4);IJa(374932,$);k[X>>2]=k[23399];k[X+4>>2]=k[23400];k[X+8>>2]=k[23401];k[X+12>>2]=k[23402];k[X+16>>2]=k[23403];l=ba+16|0;m=ba+20|0;n=ba+24|0;q=ba+20|0;s=$+4|0;t=$+4|0;u=Y+4|0;v=$+4|0;w=ca+4|0;x=ca+8|0;y=ca+12|0;z=ca+48|0;A=ca+64|0;B=$+4|0;C=ca+84|0;D=ca+88|0;E=ca+20|0;F=ba+8|0;G=ba+4|0;j=0;do{k[m>>2]=0;k[n>>2]=0;k[l>>2]=q;k[$>>2]=0;k[s>>2]=0;b=ZT(16)|0;k[b>>2]=1;L=b+4|0;k[$>>2]=L;k[s>>2]=9;i[b+13>>0]=0;K=373358;M=L+9|0;do{i[L>>0]=i[K>>0]|0;L=L+1|0;K=K+1|0}while((L|0)<(M|0));S=WHa(l,$)|0;k[_>>2]=1;R=k[S>>2]|0;T=S+4|0;jh[k[k[R>>2]>>2]&1023](R,T);k[S>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,_,T);k[s>>2]=0;k[$>>2]=0;T=k[b>>2]|0;k[b>>2]=T+-1;if((T|0)==1)ggb(k[b+-4>>2]|0);k[$>>2]=0;k[t>>2]=0;b=ZT(12)|0;k[b>>2]=1;S=b+4|0;k[$>>2]=S;k[t>>2]=5;i[b+9>>0]=0;i[S>>0]=i[380533]|0;i[S+1>>0]=i[380534]|0;i[S+2>>0]=i[380535]|0;i[S+3>>0]=i[380536]|0;i[S+4>>0]=i[380537]|0;S=WHa(l,$)|0;R=k[S>>2]|0;T=S+4|0;jh[k[k[R>>2]>>2]&1023](R,T);k[S>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,X+(j<<2)|0,T);k[t>>2]=0;k[$>>2]=0;T=k[b>>2]|0;k[b>>2]=T+-1;if((T|0)==1)ggb(k[b+-4>>2]|0);k[Y>>2]=0;k[u>>2]=0;b=ZT(12)|0;k[b>>2]=1;T=b+4|0;k[Y>>2]=T;k[u>>2]=5;i[b+9>>0]=0;i[T>>0]=i[380533]|0;i[T+1>>0]=i[380534]|0;i[T+2>>0]=i[380535]|0;i[T+3>>0]=i[380536]|0;i[T+4>>0]=i[380537]|0;T=EJa(l,Y)|0;k[ja>>2]=T;IJa(374976,ja);k[u>>2]=0;k[Y>>2]=0;T=k[b>>2]|0;k[b>>2]=T+-1;if((T|0)==1)ggb(k[b+-4>>2]|0);NLa(ca,W,l);he($|0,_|0)|0;f=k[$>>2]|0;f=Epb(f|0,((f|0)<0)<<31>>31|0,1e6,0)|0;d=k[v>>2]|0;d=kpb(f|0,N|0,d|0,((d|0)<0)<<31>>31|0)|0;f=N;if((k[w>>2]|0)>0){b=0;do{aJa(k[x>>2]|0,k[y>>2]|0);T=LMa(ca,k[x>>2]|0,k[z>>2]|0)|0;k[(k[A>>2]|0)+(b<<2)>>2]=T;b=b+1|0}while((b|0)<(k[w>>2]|0))}he($|0,_|0)|0;T=k[$>>2]|0;T=Epb(T|0,((T|0)<0)<<31>>31|0,1e6,0)|0;b=k[B>>2]|0;b=kpb(T|0,N|0,b|0,((b|0)<0)<<31>>31|0)|0;e=(+(b>>>0)+4294967296.0*+(N|0)-(+(d>>>0)+4294967296.0*+(f|0)))/1.0e6+0.0;h=+HMa(ca,W,V,O,+o[ta>>2],Z,0);c=+((aa(k[W>>2]<<2,k[P>>2]|0)|0)>>>0);o[F>>2]=(c+ +((k[D>>2]|0)+(k[C>>2]|0)+(k[E>>2]<<2)|0))/c;o[ba>>2]=h;o[G>>2]=e;p[la>>3]=e;p[la+8>>3]=h;IJa(375007,la);MMa(ca);b=k[na>>2]|0;if((b|0)==(k[U>>2]|0))KMa(ma,ba);else{JMa(b,ba);k[na>>2]=b+28}YHa(k[q>>2]|0);j=j+1|0}while(j>>>0<5);f=k[ma>>2]|0;h=+o[f>>2];d=k[fa>>2]|0;b=f;if((d|0)!=(b|0)){e=+o[da>>2];d=(d-b|0)/28|0;c=+o[f+4>>2]*e+h;c=c<h?c:h;if(d>>>0>1){b=1;do{Oa=+o[f+(b*28|0)+4>>2]*e+ +o[f+(b*28|0)>>2];c=Oa<c?Oa:c;b=b+1|0}while((b|0)!=(d|0))}}else c=h;e=h/c;m=ja+4|0;k[m>>2]=0;n=ja+8|0;k[n>>2]=0;q=ja+4|0;k[ja>>2]=q;b=k[f+16>>2]|0;l=f+20|0;if((b|0)!=(l|0)){d=b;while(1){f=d+16|0;j=ZHa(ja,q,la,f)|0;if(!(k[j>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=k[f>>2]|0;k[b+16>>2]=f;k[b+20>>2]=k[d+20>>2];if(f|0){ca=f+-4|0;k[ca>>2]=(k[ca>>2]|0)+1}ba=b+24|0;k[ba>>2]=428704;f=b+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);ca=k[d+24>>2]|0;k[ba>>2]=ca;Ph[k[(k[ca>>2]|0)+8>>2]&511](ca,d+28|0,f);f=k[la>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=f;k[j>>2]=b;f=k[k[ja>>2]>>2]|0;if(f){k[ja>>2]=f;b=k[j>>2]|0}B4(k[m>>2]|0,b);k[n>>2]=(k[n>>2]|0)+1}else d=b;b=k[d+4>>2]|0;if(!b)while(1){b=k[d+8>>2]|0;if((k[b>>2]|0)==(d|0))break;else d=b}else while(1){d=k[b>>2]|0;if(!d)break;else b=d}if((b|0)==(l|0))break;else d=b}}if(c>0.0?(ea=k[fa>>2]|0,g=k[ma>>2]|0,(ea|0)!=(g|0)):0){l=a+108|0;j=0;d=ea;while(1){f=g;h=(+o[f+(j*28|0)+4>>2]*+o[da>>2]+ +o[f+(j*28|0)>>2])/c+ +o[l>>2]*+o[f+(j*28|0)+8>>2];if(h<e){b=f+(j*28|0)+16|0;if((ja|0)!=(b|0)?(YHa(k[q>>2]|0),k[n>>2]=0,k[ja>>2]=q,k[q>>2]=0,ha=k[b>>2]|0,ia=f+(j*28|0)+20|0,(ha|0)!=(ia|0)):0){d=ha;b=ha;while(1){f=d+16|0;g=ZHa(ja,q,la,f)|0;if(!(k[g>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=k[f>>2]|0;k[b+16>>2]=f;k[b+20>>2]=k[d+20>>2];if(f|0){ea=f+-4|0;k[ea>>2]=(k[ea>>2]|0)+1}ca=b+24|0;k[ca>>2]=428704;f=b+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);ea=k[d+24>>2]|0;k[ca>>2]=ea;Ph[k[(k[ea>>2]|0)+8>>2]&511](ea,d+28|0,f);f=k[la>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=f;k[g>>2]=b;f=k[k[ja>>2]>>2]|0;if(f){k[ja>>2]=f;b=k[g>>2]|0}B4(k[m>>2]|0,b);k[n>>2]=(k[n>>2]|0)+1}else d=b;b=k[d+4>>2]|0;if(!b)while(1){b=k[d+8>>2]|0;if((k[b>>2]|0)==(d|0))break;else d=b}else while(1){d=k[b>>2]|0;if(!d)break;else b=d}if((b|0)==(ia|0))break;else d=b}e=h;b=k[ma>>2]|0;d=k[fa>>2]|0}else{e=h;b=g}}else b=g;j=j+1|0;if(j>>>0>=((d-b|0)/28|0)>>>0)break;else g=b}}b=k[ga>>2]|0;if(b|0)ggb(b);b=k[a+60>>2]|0;if(b|0)ggb(b);b=k[a+44>>2]|0;if(b|0)ggb(b);j=oa+4|0;k[j>>2]=0;l=oa+8|0;k[l>>2]=0;m=oa+4|0;k[oa>>2]=m;b=k[ja>>2]|0;if((b|0)!=(q|0)){d=b;while(1){f=d+16|0;g=ZHa(oa,m,la,f)|0;if(!(k[g>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=k[f>>2]|0;k[b+16>>2]=f;k[b+20>>2]=k[d+20>>2];if(f|0){ja=f+-4|0;k[ja>>2]=(k[ja>>2]|0)+1}ia=b+24|0;k[ia>>2]=428704;f=b+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);ja=k[d+24>>2]|0;k[ia>>2]=ja;Ph[k[(k[ja>>2]|0)+8>>2]&511](ja,d+28|0,f);f=k[la>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=f;k[g>>2]=b;f=k[k[oa>>2]>>2]|0;if(f){k[oa>>2]=f;b=k[g>>2]|0}B4(k[j>>2]|0,b);k[l>>2]=(k[l>>2]|0)+1}else d=b;b=k[d+4>>2]|0;if(!b)while(1){b=k[d+8>>2]|0;if((k[b>>2]|0)==(d|0))break;else d=b}else while(1){d=k[b>>2]|0;if(!d)break;else b=d}if((b|0)==(q|0))break;else d=b}}YHa(k[q>>2]|0);YHa(k[ka>>2]|0)}d=k[ma>>2]|0;if(d|0){b=k[na>>2]|0;if((b|0)!=(d|0))do{ma=b;b=b+-28|0;k[na>>2]=b;YHa(k[ma+-8>>2]|0)}while((b|0)!=(d|0));ggb(d)}if((wa|0)!=(oa|0)){m=a+12|0;YHa(k[m>>2]|0);n=a+16|0;k[n>>2]=0;k[wa>>2]=m;k[m>>2]=0;d=k[oa>>2]|0;b=oa+4|0;if((d|0)!=(b|0)){l=a+12|0;f=d;while(1){g=f+16|0;j=ZHa(wa,m,pa,g)|0;if(!(k[j>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}g=k[g>>2]|0;k[d+16>>2]=g;k[d+20>>2]=k[f+20>>2];if(g|0){oa=g+-4|0;k[oa>>2]=(k[oa>>2]|0)+1}na=d+24|0;k[na>>2]=428704;g=d+28|0;k[g>>2]=0;jh[k[k[107176]>>2]&1023](428704,g);oa=k[f+24>>2]|0;k[na>>2]=oa;Ph[k[(k[oa>>2]|0)+8>>2]&511](oa,f+28|0,g);g=k[pa>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=g;k[j>>2]=d;g=k[k[wa>>2]>>2]|0;if(g){k[wa>>2]=g;d=k[j>>2]|0}B4(k[l>>2]|0,d);k[n>>2]=(k[n>>2]|0)+1}else f=d;d=k[f+4>>2]|0;if(!d)while(1){d=k[f+8>>2]|0;if((k[d>>2]|0)==(f|0))break;else f=d}else while(1){f=k[d>>2]|0;if(!f)break;else d=f}if((d|0)==(b|0))break;else f=d}}}else b=oa+4|0;YHa(k[b>>2]|0);HJa(wa,Ga);IJa(374139,ra);IJa(374193,va);D4(qa,Fa);ra=qa+11|0;k[Ba>>2]=(i[ra>>0]|0)<0?k[qa>>2]|0:qa;IJa(418563,Ba);if((i[ra>>0]|0)<0)ggb(k[qa>>2]|0);IJa(374139,Ha);v=MLa(sa,wa)|0;t=a+4|0;k[t>>2]=v;Uh[k[(k[v>>2]|0)+8>>2]&2047](v);v=a+20|0;b=((k[sa>>2]|0)>>>0)/10|0;b=b>>>0>1e3?1e3:b;if((b|0)>0){JJa(Ba,sa,b);IJa(374236,za);f=k[Ba>>2]|0;d=f>>>0>1073741823?-1:f<<2;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[va>>2]=f;j=va+4|0;k[j>>2]=1;l=va+8|0;u=va+12|0;k[u>>2]=b;k[l>>2]=1;he(za|0,Ha|0)|0;n=k[za>>2]|0;n=Epb(n|0,((n|0)<0)<<31>>31|0,1e6,0)|0;m=k[za+4>>2]|0;m=kpb(n|0,N|0,m|0,((m|0)<0)<<31>>31|0)|0;n=N;a:do if(k[Ba>>2]|0){q=Ba+12|0;s=Ba+8|0;f=0;g=1;d=1;while(1){GMa(sa,(k[q>>2]|0)+((aa(k[s>>2]|0,f)|0)<<2)|0,b+((aa(g,f)|0)<<2)|0,d,1);b=f+1|0;if(b>>>0>=(k[Ba>>2]|0)>>>0)break a;f=b;g=k[l>>2]|0;b=k[u>>2]|0;d=k[j>>2]|0}}while(0);he(za|0,Ha|0)|0;qa=k[za>>2]|0;qa=Epb(qa|0,((qa|0)<0)<<31>>31|0,1e6,0)|0;ra=k[za+4>>2]|0;ra=kpb(qa|0,N|0,ra|0,((ra|0)<0)<<31>>31|0)|0;h=(+(ra>>>0)+4294967296.0*+(N|0)-(+(m>>>0)+4294967296.0*+(n|0)))/1.0e6+0.0;IJa(374260,xa);ra=k[t>>2]|0;if((Xh[k[(k[ra>>2]|0)+40>>2]&1023](ra)|0)==2){IJa(374289,ua);d=k[t>>2]|0;o[xa>>2]=0.0;b=d+24|0;o[b>>2]=0.0;e=+HMa(d,sa,Ba,va,+o[ta>>2],za,1);ua=k[za>>2]|0;o[xa>>2]=.20000000298023224;o[b>>2]=.20000000298023224;c=+HMa(d,sa,Ba,va,+o[ta>>2],za,1);qa=e==-1.0|c<e;ra=k[za>>2]|0;e=qa?c:e;o[xa>>2]=.4000000059604645;o[b>>2]=.4000000059604645;c=+HMa(d,sa,Ba,va,+o[ta>>2],za,1);oa=e==-1.0|c<e;pa=k[za>>2]|0;e=oa?c:e;o[xa>>2]=.6000000238418579;o[b>>2]=.6000000238418579;c=+HMa(d,sa,Ba,va,+o[ta>>2],za,1);ma=e==-1.0|c<e;na=k[za>>2]|0;e=ma?c:e;o[xa>>2]=.800000011920929;o[b>>2]=.800000011920929;c=+HMa(d,sa,Ba,va,+o[ta>>2],za,1);ka=e==-1.0|c<e;la=k[za>>2]|0;e=ka?c:e;o[xa>>2]=1.0;o[b>>2]=1.0;c=+HMa(d,sa,Ba,va,+o[ta>>2],za,1);d=e==-1.0|c<e;Oa=d?1.0:ka?.800000011920929:ma?.6000000238418579:oa?.4000000059604645:qa?.20000000298023224:0.0;va=d?k[za>>2]|0:ka?la:ma?na:oa?pa:qa?ra:ua;o[xa>>2]=Oa;k[za>>2]=va;o[b>>2]=Oa;p[ya>>3]=Oa;IJa(374341,ya);k[ya>>2]=0;va=ya+4|0;k[va>>2]=0;b=ZT(16)|0;k[b>>2]=1;ua=b+4|0;k[ya>>2]=ua;k[va>>2]=8;i[b+12>>0]=0;ta=ua;i[ta>>0]=99;i[ta+1>>0]=98;i[ta+2>>0]=95;i[ta+3>>0]=105;ua=ua+4|0;i[ua>>0]=110;i[ua+1>>0]=100;i[ua+2>>0]=101;i[ua+3>>0]=120;ua=WHa(wa,ya)|0;ta=k[ua>>2]|0;wa=ua+4|0;jh[k[k[ta>>2]>>2]&1023](ta,wa);k[ua>>2]=428716;Ph[k[(k[107179]|0)+4>>2]&511](428716,xa,wa);k[va>>2]=0;k[ya>>2]=0;ya=k[b>>2]|0;k[b>>2]=ya+-1;if((ya|0)==1)ggb(k[b+-4>>2]|0);c=d?c:e}else c=+HMa(k[t>>2]|0,sa,Ba,va,+o[ta>>2],za,1);k[Aa>>2]=k[za>>2];IJa(374363,Aa);k[Aa>>2]=0;ya=Aa+4|0;k[ya>>2]=0;b=ZT(12)|0;k[b>>2]=1;wa=b+4|0;k[Aa>>2]=wa;k[ya>>2]=6;i[b+10>>0]=0;i[wa>>0]=i[373823]|0;i[wa+1>>0]=i[373824]|0;i[wa+2>>0]=i[373825]|0;i[wa+3>>0]=i[373826]|0;i[wa+4>>0]=i[373827]|0;i[wa+5>>0]=i[373828]|0;wa=WHa(v,Aa)|0;va=k[wa>>2]|0;xa=wa+4|0;jh[k[k[va>>2]>>2]&1023](va,xa);k[wa>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,za,xa);k[ya>>2]=0;k[Aa>>2]=0;Aa=k[b>>2]|0;k[b>>2]=Aa+-1;if((Aa|0)==1)ggb(k[b+-4>>2]|0);b=k[u>>2]|0;if(b|0)ggb(b);b=k[Ba+12>>2]|0;if(b|0)ggb(b);c=h/c}else c=0.0;o[a+80>>2]=c;k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ha+8>>2]=0;C4(Fa,Ha);if((i[Ha+11>>0]|0)<0)ggb(k[Ha>>2]|0);HJa(v,Ga);IJa(374139,Ia);IJa(374216,Ja);D4(Ea,Fa);Ja=Ea+11|0;k[Ka>>2]=(i[Ja>>0]|0)<0?k[Ea>>2]|0:Ea;IJa(418563,Ka);if((i[Ja>>0]|0)<0)ggb(k[Ea>>2]|0);IJa(374139,La);k[Ga>>2]=49464;k[Ma>>2]=49484;k[Fa>>2]=49500;if((i[Da+11>>0]|0)<0)ggb(k[Da>>2]|0);k[Fa>>2]=169272;b=k[Ca>>2]|0;Ka=b+4|0;La=k[Ka>>2]|0;k[Ka>>2]=La+-1;if(La|0){Tgb(Ma);r=Na;return}Uh[k[(k[b>>2]|0)+8>>2]&2047](b);Tgb(Ma);r=Na;return}function yMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;d=n+8|0;m=n;j=a+4|0;l=k[j>>2]|0;l=Xh[k[(k[l>>2]|0)+40>>2]&1023](l)|0;k[d>>2]=l;l=b+76|0;f=b+16|0;c=k[f>>2]|0;e=(c|0)==0;a:do if((k[l>>2]|0)>-1){do if(e){c=b+74|0;h=i[c>>0]|0;i[c>>0]=h+255|h;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;e=k[b+44>>2]|0;k[b+28>>2]=e;h=b+20|0;k[h>>2]=e;c=e+(k[b+48>>2]|0)|0;k[f>>2]=c;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;h=e;e=k[e>>2]|0}while(0);g=e;if((c-e|0)>>>0<4){ci[k[b+36>>2]&255](b,d,4)|0;break}b:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;e=d;c=g;break b}c=e+-1|0;if((i[d+c>>0]|0)==10)break;else e=c}if((ci[k[b+36>>2]&255](b,d,e)|0)>>>0<e>>>0)break a;f=4-e|0;e=d+e|0;c=k[h>>2]|0}else{f=4;e=d;c=g}while(0);upb(c|0,e|0,f|0)|0;k[h>>2]=(k[h>>2]|0)+f}else{do if(e){c=b+74|0;h=i[c>>0]|0;i[c>>0]=h+255|h;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;e=k[b+44>>2]|0;k[b+28>>2]=e;h=b+20|0;k[h>>2]=e;c=e+(k[b+48>>2]|0)|0;k[f>>2]=c;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;h=e;e=k[e>>2]|0}while(0);g=e;if((c-e|0)>>>0<4){ci[k[b+36>>2]&255](b,d,4)|0;break}c:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;e=d;c=g;break c}c=e+-1|0;if((i[d+c>>0]|0)==10)break;else e=c}if((ci[k[b+36>>2]&255](b,d,e)|0)>>>0<e>>>0)break a;f=4-e|0;e=d+e|0;c=k[h>>2]|0}else{f=4;e=d;c=g}while(0);upb(c|0,e|0,f|0)|0;k[h>>2]=(k[h>>2]|0)+f}while(0);h=k[j>>2]|0;jh[k[(k[h>>2]|0)+20>>2]&1023](h,b);h=m+4|0;e=ZT(12)|0;k[e>>2]=1;f=e+4|0;k[m>>2]=f;k[h>>2]=6;i[e+10>>0]=0;i[f>>0]=i[373823]|0;i[f+1>>0]=i[373824]|0;i[f+2>>0]=i[373825]|0;i[f+3>>0]=i[373826]|0;i[f+4>>0]=i[373827]|0;i[f+5>>0]=i[373828]|0;f=EJa(a+20|0,m)|0;k[d>>2]=f;f=b+16|0;e=k[f>>2]|0;c=(e|0)==0;d:do if((k[l>>2]|0)>-1){do if(c){c=b+74|0;l=i[c>>0]|0;i[c>>0]=l+255|l;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;l=k[b+44>>2]|0;k[b+28>>2]=l;g=b+20|0;k[g>>2]=l;e=l+(k[b+48>>2]|0)|0;k[f>>2]=e;f=l;break}else{k[b>>2]=c|32;break d}}else{f=b+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<4){ci[k[b+36>>2]&255](b,d,4)|0;break}e:do if((i[b+75>>0]|0)>-1){f=4;while(1){if(!f){e=4;break e}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0)break d;e=4-f|0;d=d+f|0;c=k[g>>2]|0}else e=4;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(c){c=b+74|0;l=i[c>>0]|0;i[c>>0]=l+255|l;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;l=k[b+44>>2]|0;k[b+28>>2]=l;g=b+20|0;k[g>>2]=l;e=l+(k[b+48>>2]|0)|0;k[f>>2]=e;f=l;break}else{k[b>>2]=c|32;break d}}else{f=b+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<4){ci[k[b+36>>2]&255](b,d,4)|0;break}f:do if((i[b+75>>0]|0)>-1){f=4;while(1){if(!f){e=4;break f}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0)break d;e=4-f|0;d=d+f|0;c=k[g>>2]|0}else e=4;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);c=k[m>>2]|0;k[h>>2]=0;k[m>>2]=0;if(!c){r=n;return}b=c+-4|0;m=k[b>>2]|0;k[b>>2]=m+-1;if((m|0)!=1){r=n;return}ggb(k[c+-8>>2]|0);r=n;return}function zMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+32|0;e=o+28|0;f=o+16|0;m=o+8|0;n=o;if((_fb(e,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}k[f+4>>2]=0;k[f+8>>2]=0;l=f+4|0;k[f>>2]=l;k[m>>2]=0;c=m+4|0;k[c>>2]=0;d=ZT(16)|0;k[d>>2]=1;g=d+4|0;k[m>>2]=g;k[c>>2]=9;i[d+13>>0]=0;h=373358;j=g+9|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));h=WHa(f,m)|0;k[n>>2]=k[e>>2];g=k[h>>2]|0;j=h+4|0;jh[k[k[g>>2]>>2]&1023](g,j);k[h>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,n,j);k[c>>2]=0;k[m>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);j=MLa(a+84|0,f)|0;k[a+4>>2]=j;jh[k[(k[j>>2]|0)+24>>2]&1023](j,b);if((_fb(m,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}k[n>>2]=0;j=n+4|0;k[j>>2]=0;b=ZT(12)|0;k[b>>2]=1;h=b+4|0;k[n>>2]=h;k[j>>2]=6;i[b+10>>0]=0;i[h>>0]=i[373823]|0;i[h+1>>0]=i[373824]|0;i[h+2>>0]=i[373825]|0;i[h+3>>0]=i[373826]|0;i[h+4>>0]=i[373827]|0;i[h+5>>0]=i[373828]|0;h=WHa(a+20|0,n)|0;g=k[h>>2]|0;a=h+4|0;jh[k[k[g>>2]>>2]&1023](g,a);k[h>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,m,a);k[j>>2]=0;k[n>>2]=0;n=k[b>>2]|0;k[b>>2]=n+-1;if((n|0)!=1){n=k[l>>2]|0;YHa(n);r=o;return}ggb(k[b+-4>>2]|0);n=k[l>>2]|0;YHa(n);r=o;return}function AMa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+28>>2]&1023](a)|0}function BMa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+32>>2]&1023](a)|0}function CMa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0}function DMa(a){a=a|0;return 255}function EMa(a,b){a=a|0;b=b|0;b=k[b+4>>2]|0;jh[k[(k[b>>2]|0)+44>>2]&1023](a,b);return}function FMa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;e=ZT(12)|0;k[e>>2]=1;f=e+4|0;i[e+10>>0]=0;i[f>>0]=i[373823]|0;i[f+1>>0]=i[373824]|0;i[f+2>>0]=i[373825]|0;i[f+3>>0]=i[373826]|0;i[f+4>>0]=i[373827]|0;i[f+5>>0]=i[373828]|0;k[g>>2]=-2;g=dIa(d,f,g)|0;f=k[e>>2]|0;k[e>>2]=f+-1;if((f|0)==1)ggb(k[e+-4>>2]|0);e=k[a+4>>2]|0;f=k[(k[e>>2]|0)+48>>2]|0;if((g|0)==-2){dh[f&255](e,b,c,a+20|0);r=h;return}else{dh[f&255](e,b,c,d);r=h;return}}function GMa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0.0,j=0,l=0,m=0,n=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;x=e+d|0;h=(x|0)==0;if(!h){if(x>>>0>1073741823)ad(426534,426557,304,426811);j=x<<2;g=(j|0)==0?1:j;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}zpb(f|0,0,j|0)|0;if(h)w=0;else{if(x>>>0>1073741823)ad(426534,426557,304,426811);j=x<<2;h=(j|0)==0?1:j;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}zpb(g|0,0,j|0)|0;w=g}}else{w=0;f=0}t=k[a+12>>2]|0;u=a+8|0;v=a+4|0;p=t+(k[v>>2]<<2)|0;l=p+-12|0;m=((l>>>0<t>>>0?t:l)+12+(3-t)|0)>>>4<<2;h=b+(m<<2)|0;if(t>>>0<l>>>0){g=t;j=b;i=0.0;while(1){A=+o[g>>2]-+o[j>>2];z=+o[g+4>>2]-+o[j+4>>2];y=+o[g+8>>2]-+o[j+8>>2];n=+o[g+12>>2]-+o[j+12>>2];i=i+(A*A+z*z+y*y+n*n);g=g+16|0;if(g>>>0>=l>>>0)break;else j=j+16|0}}else i=0.0;g=t+(m<<2)|0;if(g>>>0<p>>>0)while(1){A=+o[g>>2]-+o[h>>2];g=g+4|0;i=i+A*A;if(g>>>0>=p>>>0)break;else h=h+4|0}o[w>>2]=i;k[f>>2]=0;if((k[a>>2]|0)>>>0>1){s=1;r=1;while(1){m=t+((aa(k[u>>2]|0,s)|0)<<2)|0;q=m+(k[v>>2]<<2)|0;l=q+-12|0;p=((l>>>0<m>>>0?m:l)+12+(3-m)|0)>>>4<<2;h=b+(p<<2)|0;if(m>>>0<l>>>0){g=m;j=b;i=0.0;while(1){n=+o[g>>2]-+o[j>>2];y=+o[g+4>>2]-+o[j+4>>2];z=+o[g+8>>2]-+o[j+8>>2];A=+o[g+12>>2]-+o[j+12>>2];i=i+(n*n+y*y+z*z+A*A);g=g+16|0;if(g>>>0>=l>>>0)break;else j=j+16|0}}else i=0.0;g=m+(p<<2)|0;if(g>>>0<q>>>0)while(1){A=+o[g>>2]-+o[h>>2];g=g+4|0;i=i+A*A;if(g>>>0>=q>>>0)break;else h=h+4|0}if((r|0)>=(x|0)){g=r+-1|0;h=w+(g<<2)|0;if(i<+o[h>>2]){o[h>>2]=i;k[f+(g<<2)>>2]=s;h=r}else h=r}else{k[f+(r<<2)>>2]=s;o[w+(r<<2)>>2]=i;h=r+1|0}a:do if((h|0)>1){g=h;do{l=g;g=g+-1|0;j=w+(g<<2)|0;i=+o[j>>2];l=l+-2|0;m=w+(l<<2)|0;n=+o[m>>2];if(!(i<n))break a;o[j>>2]=n;o[m>>2]=i;p=f+(g<<2)|0;r=f+(l<<2)|0;q=k[p>>2]|0;k[p>>2]=k[r>>2];k[r>>2]=q}while((g|0)>1)}while(0);s=s+1|0;if(s>>>0>=(k[a>>2]|0)>>>0)break;else r=h}}if((d|0)>0){g=0;do{k[c+(g<<2)>>2]=k[f+(g+e<<2)>>2];g=g+1|0}while((g|0)!=(d|0));if(w)ggb(w)}else{ggb(w);if(!f)return}ggb(f);return}function HMa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;var h=0,i=0.0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+48|0;n=u+40|0;q=u+32|0;m=u+24|0;s=u+8|0;p=u;IJa(374395,p);IJa(374454,s);i=+IMa(a,b,c,d,1,s,p,g);if(i>e){IJa(374513,u+16|0);t=1;k[f>>2]=t;e=+o[s>>2];r=u;return +e}if(i<e){h=1;while(1){j=h<<1;i=+IMa(a,b,c,d,j,s,p,g);if(i<e)h=j;else{l=h;break}}}else{l=1;j=1}if(!(+P(+(i-e))>1.0000000474974513e-03)){IJa(374561,n);t=j;k[f>>2]=t;e=+o[s>>2];r=u;return +e}IJa(374536,m);h=(l+j|0)/2|0;i=+IMa(a,b,c,d,h,s,p,g);if(!(+P(+(i-e))>1.0000000474974513e-03)){t=h;k[f>>2]=t;e=+o[s>>2];r=u;return +e}while(1){n=i<e;j=n?j:h;l=n?h:l;h=(l+j|0)/2|0;if((h|0)==(l|0))break;i=+IMa(a,b,c,d,h,s,p,g);if(!(+P(+(i-e))>1.0000000474974513e-03)){t=11;break}}if((t|0)==11){k[f>>2]=h;e=+o[s>>2];r=u;return +e}IJa(374513,q);t=l;k[f>>2]=t;e=+o[s>>2];r=u;return +e}function IMa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,l=0,m=0,n=0,q=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0;ca=r;r=r+112|0;ba=ca+8|0;j=ca;Z=ca+96|0;_=ca+88|0;Y=ca+64|0;$=ca+48|0;if(!(k[d+4>>2]|0)){k[j>>2]=0;k[j+4>>2]=1;IJa(374592,j);ca=te(44)|0;VHa(ca,374616);Cf(ca|0,19720,57)}m=h+1|0;k[Y>>2]=93576;W=Y+12|0;k[W>>2]=m;X=Y+16|0;k[X>>2]=0;rJa($,e);n=(m|0)==0;if(!n){if(m>>>0>1073741823)ad(426534,426557,304,426811);q=m<<2;l=(q|0)==0?1:q;while(1){j=fgb(l)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}s=j;zpb(j|0,0,q|0)|0;if(n)j=0;else{if(m>>>0>1073741823)ad(426534,426557,304,426811);m=m<<2;l=(m|0)==0?1:m;while(1){j=fgb(l)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}zpb(j|0,0,m|0)|0}}else{j=0;s=0}P=s+(h<<2)|0;Q=Y+4|0;R=Y+8|0;S=Y+20|0;T=c+12|0;U=c+8|0;V=d+12|0;J=d+8|0;K=c+4|0;L=Z+4|0;M=Z+4|0;O=b+12|0;G=b+8|0;E=0;F=0.0;do{E=E+1|0;he(Z|0,_|0)|0;I=k[Z>>2]|0;I=Epb(I|0,((I|0)<0)<<31>>31|0,1e6,0)|0;H=k[L>>2]|0;H=kpb(I|0,N|0,H|0,((H|0)<0)<<31>>31|0)|0;I=N;if(!(k[c>>2]|0)){t=0.0;i=0.0}else{A=0;t=0.0;D=0;B=k[U>>2]|0;C=k[T>>2]|0;do{k[Q>>2]=s;k[R>>2]=j;k[X>>2]=0;o[S>>2]=3402823466385288598117041.0e14;o[j+((k[W>>2]|0)+-1<<2)>>2]=3402823466385288598117041.0e14;d=C+((aa(B,A)|0)<<2)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,Y,d,$);d=(k[V>>2]|0)+((aa(k[J>>2]|0,A)|0)<<2)|0;v=k[P>>2]|0;d=k[d>>2]|0;D=((v|0)==(d|0)&1)+D|0;C=k[T>>2]|0;B=k[U>>2]|0;l=C+((aa(B,A)|0)<<2)|0;z=k[K>>2]|0;w=k[O>>2]|0;x=k[G>>2]|0;d=w+((aa(x,d)|0)<<2)|0;u=d+(z<<2)|0;h=u+-12|0;b=((h>>>0<d>>>0?d:h)+12+(3-d)|0)>>>4<<2;n=l+(b<<2)|0;if(d>>>0<h>>>0){m=d;q=l;i=0.0;while(1){fa=+o[m>>2]-+o[q>>2];ea=+o[m+4>>2]-+o[q+4>>2];da=+o[m+8>>2]-+o[q+8>>2];y=+o[m+12>>2]-+o[q+12>>2];i=i+(fa*fa+ea*ea+da*da+y*y);m=m+16|0;if(m>>>0>=h>>>0)break;else q=q+16|0}}else i=0.0;m=d+(b<<2)|0;if(m>>>0<u>>>0)while(1){fa=+o[m>>2]-+o[n>>2];m=m+4|0;i=i+fa*fa;if(m>>>0>=u>>>0){y=i;break}else n=n+4|0}else y=i;d=w+((aa(x,v)|0)<<2)|0;b=d+(z<<2)|0;q=b+-12|0;h=((q>>>0<d>>>0?d:q)+12+(3-d)|0)>>>4<<2;m=l+(h<<2)|0;if(d>>>0<q>>>0){n=d;i=0.0;while(1){ga=+o[n>>2]-+o[l>>2];da=+o[n+4>>2]-+o[l+4>>2];ea=+o[n+8>>2]-+o[l+8>>2];fa=+o[n+12>>2]-+o[l+12>>2];i=i+(ga*ga+da*da+ea*ea+fa*fa);n=n+16|0;if(n>>>0>=q>>>0)break;else l=l+16|0}}else i=0.0;l=d+(h<<2)|0;if(l>>>0<b>>>0)while(1){ga=+o[l>>2]-+o[m>>2];l=l+4|0;i=i+ga*ga;if(l>>>0>=b>>>0)break;else m=m+4|0}if(y==0.0&i==0.0)i=1.0;else i=i/y+0.0;t=t+i;A=A+1|0}while(A>>>0<(k[c>>2]|0)>>>0);i=+(D|0)}he(Z|0,_|0)|0;C=k[Z>>2]|0;C=Epb(C|0,((C|0)<0)<<31>>31|0,1e6,0)|0;D=k[M>>2]|0;D=kpb(C|0,N|0,D|0,((D|0)<0)<<31>>31|0)|0;F=F+(+(D>>>0)+4294967296.0*+(N|0)-(+(H>>>0)+4294967296.0*+(I|0)))/1.0e6}while(F<.2);o[f>>2]=F/+(E|0);_=k[c>>2]|0;ga=+(_>>>0);i=i/ga;ga=t/ga;o[g>>2]=ga;fa=+o[f>>2];k[ba>>2]=e;p[ba+8>>3]=i;p[ba+16>>3]=fa;p[ba+24>>3]=fa*1.0e3/+(_>>>0);p[ba+32>>3]=ga;IJa(374680,ba);if(j|0)ggb(j);if(!s){ba=$+4|0;ba=k[ba>>2]|0;YHa(ba);r=ca;return +i}ggb(s);ba=$+4|0;ba=k[ba>>2]|0;YHa(ba);r=ca;return +i}function JMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];h=a+16|0;i=a+20|0;k[i>>2]=0;j=a+24|0;k[j>>2]=0;f=a+20|0;k[h>>2]=f;a=k[b+16>>2]|0;e=b+20|0;if((a|0)==(e|0)){r=l;return}b=a;while(1){c=b+16|0;d=ZHa(h,f,g,c)|0;if(!(k[d>>2]|0)){while(1){a=fgb(32)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;Qh[a&7]()}c=k[c>>2]|0;k[a+16>>2]=c;k[a+20>>2]=k[b+20>>2];if(c|0){c=c+-4|0;k[c>>2]=(k[c>>2]|0)+1}n=a+24|0;k[n>>2]=428704;c=a+28|0;k[c>>2]=0;jh[k[k[107176]>>2]&1023](428704,c);m=k[b+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,b+28|0,c);c=k[g>>2]|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=c;k[d>>2]=a;c=k[k[h>>2]>>2]|0;if(c){k[h>>2]=c;a=k[d>>2]|0}B4(k[i>>2]|0,a);k[j>>2]=(k[j>>2]|0)+1}else b=a;a=k[b+4>>2]|0;if(!a)while(1){a=k[b+8>>2]|0;if((k[a>>2]|0)==(b|0))break;else b=a}else while(1){b=k[a>>2]|0;if(!b)break;else a=b}if((a|0)==(e|0))break;else b=a}r=l;return}function KMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;h=a+4|0;c=k[a>>2]|0;e=((k[h>>2]|0)-c|0)/28|0;d=e+1|0;if(d>>>0>153391689)ad(426534,426557,304,426811);i=a+8|0;g=((k[i>>2]|0)-c|0)/28|0;f=g<<1;f=g>>>0<76695844?(f>>>0<d>>>0?d:f):153391689;if(!f)c=0;else{if(f>>>0>153391689){i=te(4)|0;k[i>>2]=172664;Cf(i|0,28816,1287)}d=f*28|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}d=c+(e*28|0)|0;e=d;g=c+(f*28|0)|0;JMa(d,b);b=d+28|0;f=k[a>>2]|0;c=k[h>>2]|0;if((c|0)==(f|0)){d=e;e=f;c=f}else{do{c=c+-28|0;JMa(d+-28|0,c);d=e+-28|0;e=d}while((c|0)!=(f|0));d=e;e=k[a>>2]|0;c=k[h>>2]|0}k[a>>2]=d;k[h>>2]=b;k[i>>2]=g;d=e;if((c|0)!=(d|0))do{YHa(k[c+-8>>2]|0);c=c+-28|0}while((c|0)!=(d|0));if(!e)return;ggb(e);return}function LMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+32|0;y=z;g=a+68|0;d=k[g>>2]|0;a:do if((d|0)<16){w=a+88|0;k[w>>2]=(k[w>>2]|0)+d;d=fgb(8192)|0;if(d|0){f=a+72|0;k[d>>2]=k[f>>2];k[f>>2]=d;k[g>>2]=8188;f=d+4|0;e=a+76|0;k[e>>2]=f;d=8172;x=28;break}d=k[41482]|0;e=(d|0)==0;if((k[41497]|0)>-1){do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;f=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;f=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){f=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;f=0;break}else{do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;f=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;f=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){f=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;f=0;break}}else{f=a+76|0;e=f;f=k[f>>2]|0;d=d+-16|0;x=28}while(0);if((x|0)==28){k[e>>2]=f+16;k[g>>2]=d;x=a+84|0;k[x>>2]=(k[x>>2]|0)+16}if((c|0)==1){k[f+12>>2]=0;k[f+8>>2]=0;k[f>>2]=k[b>>2];r=z;return f|0}w=a+56|0;d=a+52|0;zpb(k[w>>2]|0,0,k[d>>2]<<2|0)|0;s=a+60|0;zpb(k[s>>2]|0,0,k[d>>2]<<2|0)|0;v=(c|0)<101?c:101;p=(c|0)>0;if(p){m=k[a+32>>2]|0;n=k[a+28>>2]|0;e=k[d>>2]|0;if(!e)x=48;else{j=k[w>>2]|0;g=0;do{l=m+((aa(n,k[b+(g<<2)>>2]|0)|0)<<2)|0;d=0;do{x=j+(d<<2)|0;o[x>>2]=+o[l+(d<<2)>>2]+ +o[x>>2];d=d+1|0}while((d|0)!=(e|0));g=g+1|0}while((g|0)<(v|0));x=38}}else{e=k[d>>2]|0;x=38}do if((x|0)==38){if(!e){t=0;q=1}else{h=+(v|0);g=k[w>>2]|0;d=0;do{t=g+(d<<2)|0;o[t>>2]=+o[t>>2]/h;d=d+1|0}while((d|0)!=(e|0));t=e;q=0}if(p){m=k[a+32>>2]|0;n=k[a+28>>2]|0;if(q){x=48;break}l=k[w>>2]|0;g=k[s>>2]|0;e=0;do{j=m+((aa(n,k[b+(e<<2)>>2]|0)|0)<<2)|0;d=0;do{h=+o[j+(d<<2)>>2]-+o[l+(d<<2)>>2];s=g+(d<<2)|0;o[s>>2]=+o[s>>2]+h*h;d=d+1|0}while(d>>>0<t>>>0);e=e+1|0}while((e|0)<(v|0));p=g}else p=k[s>>2]|0;if(q)d=0;else{n=0;d=0;do{if((d|0)>=5){e=y+(d+-1<<2)|0;if(+o[p+(n<<2)>>2]>+o[p+(k[e>>2]<<2)>>2]){k[e>>2]=n;x=54}}else{k[y+(d<<2)>>2]=n;d=d+1|0;x=54}b:do if((x|0)==54){x=0;if((d|0)>1){e=d;do{l=e;e=e+-1|0;g=y+(e<<2)|0;j=k[g>>2]|0;l=y+(l+-2<<2)|0;m=k[l>>2]|0;if(!(+o[p+(j<<2)>>2]>+o[p+(m<<2)>>2]))break b;k[g>>2]=m;k[l>>2]=j}while((e|0)>1)}}while(0);n=n+1|0}while((n|0)!=(t|0))}}while(0);if((x|0)==48)d=0;q=428e3;q=Epb(k[q>>2]|0,k[q+4>>2]|0,1284865837,1481765933)|0;q=kpb(q|0,N|0,1,0)|0;v=N;p=428e3;k[p>>2]=q;k[p+4>>2]=v;v=ppb(q|0,v|0,33)|0;v=k[y+(~~(+(d|0)*(+(v|0)*4.656612873077393e-10))<<2)>>2]|0;q=k[(k[w>>2]|0)+(v<<2)>>2]|0;h=(k[u>>2]=q,+o[u>>2]);p=c+-1|0;s=a+32|0;t=a+28|0;n=p;d=0;c:while(1){d:do if((d|0)<=(n|0)){g=k[s>>2]|0;j=k[t>>2]|0;while(1){y=g+((aa(j,k[b+(d<<2)>>2]|0)|0)<<2)+(v<<2)|0;if(!(+o[y>>2]<h))break d;e=d+1|0;if((d|0)<(n|0))d=e;else{d=e;break}}}while(0);if((d|0)>(n|0)){e=d;break}l=k[s>>2]|0;m=k[t>>2]|0;e=n;while(1){g=b+(e<<2)|0;j=k[g>>2]|0;y=l+((aa(m,j)|0)<<2)+(v<<2)|0;if(!(+o[y>>2]>=h))break;if((d|0)<(e|0))e=e+-1|0;else{e=d;break c}}y=b+(d<<2)|0;n=k[y>>2]|0;k[y>>2]=j;k[g>>2]=n;n=e+-1|0;d=d+1|0}e:while(1){f:do if((e|0)<=(p|0)){j=k[s>>2]|0;l=k[t>>2]|0;while(1){y=j+((aa(l,k[b+(e<<2)>>2]|0)|0)<<2)+(v<<2)|0;if(!(+o[y>>2]<=h))break f;g=e+1|0;if((e|0)<(p|0))e=g;else{e=g;break}}}while(0);if((e|0)>(p|0))break;m=k[s>>2]|0;n=k[t>>2]|0;g=p;while(1){j=b+(g<<2)|0;l=k[j>>2]|0;y=m+((aa(n,l)|0)<<2)+(v<<2)|0;if(!(+o[y>>2]>h))break;if((e|0)<(g|0))g=g+-1|0;else break e}y=b+(e<<2)|0;p=k[y>>2]|0;k[y>>2]=l;k[j>>2]=p;p=g+-1|0;e=e+1|0}y=(c|0)/2|0;y=(d|0)==(c|0)|(e|0)==0?y:(d|0)>(y|0)?d:(e|0)<(y|0)?e:y;k[f>>2]=v;k[f+4>>2]=q;x=LMa(a,b,y)|0;k[f+8>>2]=x;c=LMa(a,b+(y<<2)|0,c-y|0)|0;k[f+12>>2]=c;r=z;return f|0}function MMa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=94248;b=k[a+64>>2]|0;if(b|0)ggb(b);b=k[a+56>>2]|0;if(b|0)ggb(b);b=k[a+60>>2]|0;if(b|0)ggb(b);c=a+72|0;b=k[c>>2]|0;if(b|0)do{d=b;b=k[b>>2]|0;ggb(d);k[c>>2]=b}while((b|0)!=0);YHa(k[a+40>>2]|0);d=k[a+8>>2]|0;if(!d)return;b=a+12|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-4-d|0)>>>2)<<2);ggb(d);return}function NMa(a){a=a|0;MMa(a);ggb(a);return}function OMa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;c=a+4|0;if((k[c>>2]|0)<=0)return;d=a+8|0;e=a+12|0;f=a+48|0;g=a+64|0;b=0;do{aJa(k[d>>2]|0,k[e>>2]|0);h=LMa(a,k[d>>2]|0,k[f>>2]|0)|0;k[(k[g>>2]|0)+(b<<2)>>2]=h;b=b+1|0}while((b|0)<(k[c>>2]|0));return}function PMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=a+4|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[b+76>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}b:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break b}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}c:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break c}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);if((k[h>>2]|0)<=0)return;d=a+64|0;c=0;do{_Ma(b,k[(k[d>>2]|0)+(c<<2)>>2]|0);c=c+1|0}while((c|0)<(k[h>>2]|0));return}function QMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;j=m+8|0;h=m;f=a+4|0;if((_fb(f,4,1,b)|0)!=1){m=te(44)|0;VHa(m,373124);Cf(m|0,19720,57)}l=a+64|0;c=k[l>>2]|0;if(c|0)ggb(c);e=k[f>>2]|0;d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[l>>2]=c;if((e|0)>0?(ZMa(a,b,c),(k[f>>2]|0)>1):0){c=1;do{ZMa(a,b,(k[l>>2]|0)+(c<<2)|0);c=c+1|0}while((c|0)<(k[f>>2]|0))}g=a+36|0;c=j+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=9;i[d+13>>0]=0;b=373358;f=e+9|0;do{i[e>>0]=i[b>>0]|0;e=e+1|0;b=b+1|0}while((e|0)<(f|0));f=WHa(g,j)|0;b=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[h>>2]=b;b=k[f>>2]|0;a=f+4|0;jh[k[k[b>>2]>>2]&1023](b,a);k[f>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,h,a);k[c>>2]=0;k[j>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);h=j+4|0;c=ZT(12)|0;k[c>>2]=1;f=c+4|0;k[j>>2]=f;k[h>>2]=5;i[c+9>>0]=0;i[f>>0]=i[380533]|0;i[f+1>>0]=i[380534]|0;i[f+2>>0]=i[380535]|0;i[f+3>>0]=i[380536]|0;i[f+4>>0]=i[380537]|0;g=WHa(g,j)|0;f=k[g>>2]|0;a=g+4|0;jh[k[k[f>>2]>>2]&1023](f,a);k[g>>2]=827104;Ph[k[(k[206776]|0)+4>>2]&511](827104,l,a);k[h>>2]=0;k[j>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)!=1){r=m;return}ggb(k[c+-4>>2]|0);r=m;return}function RMa(a){a=a|0;return k[a+48>>2]|0}function SMa(a){a=a|0;return k[a+52>>2]|0}function TMa(a){a=a|0;return (k[a+88>>2]|0)+(k[a+84>>2]|0)+(k[a+20>>2]<<2)|0}function UMa(a){a=a|0;return 1}function VMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+36>>2]|0;f=b+40|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function WMa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0,p=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0;D=r;r=r+32|0;z=D+16|0;B=D;e=ZT(12)|0;k[e>>2]=1;A=e+4|0;i[e+10>>0]=0;i[A>>0]=i[373823]|0;i[A+1>>0]=i[373824]|0;i[A+2>>0]=i[373825]|0;i[A+3>>0]=i[373826]|0;i[A+4>>0]=i[373827]|0;i[A+5>>0]=i[373828]|0;k[z>>2]=32;A=dIa(d,A,z)|0;v=k[e>>2]|0;k[e>>2]=v+-1;if((v|0)==1)ggb(k[e+-4>>2]|0);e=ZT(8)|0;k[e>>2]=1;v=e+4|0;i[e+7>>0]=0;i[v>>0]=i[374006]|0;i[v+1>>0]=i[374007]|0;i[v+2>>0]=i[374008]|0;o[z>>2]=0.0;C=+sJa(d,v,z)+1.0;v=k[e>>2]|0;k[e>>2]=v+-1;if((v|0)==1)ggb(k[e+-4>>2]|0);if((A|0)==-1){g=a+4|0;e=k[g>>2]|0;if((e|0)>1){e=k[41482]|0;d=(e|0)==0;a:do if((k[41497]|0)>-1){do if(d){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;d=k[41489]|0;k[41485]=d;k[41483]=d;e=d+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;break a}}else d=k[41483]|0;while(0);if((e-d|0)>>>0<68){ci[k[165948>>2]&255](165912,375043,68)|0;break}else{e=375043;f=d+68|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));k[41483]=(k[41483]|0)+68;break}}else{do if(d){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;d=k[41489]|0;k[41485]=d;k[41483]=d;e=d+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;break a}}else d=k[41483]|0;while(0);if((e-d|0)>>>0<68){ci[k[165948>>2]&255](165912,375043,68)|0;break}else{e=375043;f=d+68|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));k[41483]=(k[41483]|0)+68;break}}while(0);e=k[g>>2]|0}if((e|0)<=0){r=D;return}XMa(a,b,c,k[k[a+64>>2]>>2]|0,0.0,C);r=D;return}k[z>>2]=0;while(1){e=fgb(20)|0;if(e|0){u=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){u=0;break}Qh[e&7]()}g=a+48|0;e=k[g>>2]|0;k[u>>2]=0;v=u+4|0;k[v>>2]=0;h=u+8|0;k[h>>2]=0;k[u+12>>2]=e;if(e){if(e>>>0>536870911){D=te(4)|0;k[D>>2]=172664;Cf(D|0,28816,1287)}f=e<<3;f=(f|0)==0?1:f;while(1){d=fgb(f)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}t=d;k[u>>2]=t;k[v>>2]=t;k[h>>2]=d+(e<<3);e=k[g>>2]|0}s=u+16|0;k[s>>2]=0;k[B>>2]=0;t=B+4|0;k[t>>2]=0;k[B+8>>2]=0;k[B+12>>2]=e;r4(B,(e>>>5)+1|0);e=k[B>>2]|0;d=(k[t>>2]|0)-e|0;if((d|0)>0){p=d>>2;zpb(e|0,0,((((p|0)<1?p:1)^1073741823)+p<<2)+8|0)|0}d=a+4|0;if((k[d>>2]|0)>0){f=a+64|0;e=0;do{YMa(a,b,c,k[(k[f>>2]|0)+(e<<2)>>2]|0,0.0,z,A,C,u,B);e=e+1|0}while((e|0)<(k[d>>2]|0))}while(1){if(!(k[s>>2]|0))break;n=k[u>>2]|0;p=k[n>>2]|0;q=+o[n+4>>2];e=k[v>>2]|0;m=e-n|0;d=m>>3;if(((m|0)>8?(w=e+-8|0,m=n,j=k[m>>2]|0,m=k[m+4>>2]|0,f=w,g=k[f+4>>2]|0,h=n,k[h>>2]=k[f>>2],k[h+4>>2]=g,w,k[w>>2]=j,k[w+4>>2]=m,w=d+-1|0,(d|0)!=2):0)?(m=d+-3|0,x=(m|0)/2|0,(m|0)>=-1):0){e=n+8|0;if((w|0)>2?+o[n+20>>2]<+o[n+12>>2]:0){d=2;e=n+16|0}else d=1;l=+o[n+4>>2];if(!(l<+o[e+4>>2])){m=k[n>>2]|0;j=n;while(1){h=j;j=e;f=j;g=k[f+4>>2]|0;k[h>>2]=k[f>>2];k[h+4>>2]=g;if((x|0)<(d|0))break;d=d<<1|1;g=n+(d<<3)|0;f=g;h=d+1|0;if((h|0)<(w|0)?(y=g+8|0,+o[y+4>>2]<+o[n+(d<<3)+4>>2]):0){d=h;f=y}if(l<+o[f+4>>2])break;else e=f}k[e>>2]=m;o[e+4>>2]=l}}k[v>>2]=(k[v>>2]|0)+-8;k[s>>2]=(k[s>>2]|0)+-1;if((k[z>>2]|0)>=(A|0)?Xh[k[(k[b>>2]|0)+8>>2]&1023](b)|0:0)break;YMa(a,b,c,p,q,z,A,C,u,B)}e=k[u>>2]|0;d=e;if(e|0){f=k[v>>2]|0;if((f|0)!=(e|0))k[v>>2]=f+(~((f+-8-d|0)>>>3)<<3);ggb(e)}ggb(u);e=k[B>>2]|0;d=e;if(e|0){f=k[t>>2]|0;if((f|0)!=(e|0))k[t>>2]=f+(~((f+-4-d|0)>>>2)<<2);ggb(e)}r=D;return}function XMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;var g=0,h=0,i=0,j=0,l=0,m=0,n=0.0,p=0.0,q=0.0;while(1){g=d+8|0;h=d+12|0;if((k[g>>2]|0)==0?(k[h>>2]|0)==0:0)break;n=+o[c+(k[d>>2]<<2)>>2]-+o[d+4>>2];m=n<0.0;d=k[(m?h:g)>>2]|0;XMa(a,b,c,k[(m?g:h)>>2]|0,e,f);e=e+n*n;if(!(e*f<=+hg[k[(k[b>>2]|0)+16>>2]&127](b))){i=10;break}}if((i|0)==10)return;m=k[d>>2]|0;j=(k[a+32>>2]|0)+((aa(k[a+28>>2]|0,m)|0)<<2)|0;l=j+(k[a+52>>2]<<2)|0;i=l+-12|0;a=((i>>>0<j>>>0?j:i)+12+(3-j)|0)>>>4<<2;g=c+(a<<2)|0;if(j>>>0<i>>>0){h=j;d=c;e=0.0;while(1){q=+o[h>>2]-+o[d>>2];p=+o[h+4>>2]-+o[d+4>>2];f=+o[h+8>>2]-+o[d+8>>2];n=+o[h+12>>2]-+o[d+12>>2];e=e+(q*q+p*p+f*f+n*n);h=h+16|0;if(h>>>0>=i>>>0)break;else d=d+16|0}}else e=0.0;d=j+(a<<2)|0;if(d>>>0<l>>>0)while(1){q=+o[d>>2]-+o[g>>2];d=d+4|0;e=e+q*q;if(d>>>0>=l>>>0)break;else g=g+4|0}$f[k[(k[b>>2]|0)+12>>2]&15](b,e,m);return}function YMa(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;var l=0.0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0;if(+hg[k[(k[b>>2]|0)+16>>2]&127](b)<e)return;n=d+8|0;p=d+12|0;if((k[n>>2]|0)==0?(k[p>>2]|0)==0:0){t=k[d>>2]|0;n=t>>>5;d=k[j>>2]|0;m=k[d+(n<<2)>>2]|0;p=1<<(t&31);if(m&p|0)return;do if((k[f>>2]|0)>=(g|0))if(Xh[k[(k[b>>2]|0)+8>>2]&1023](b)|0)return;else{m=k[j>>2]|0;d=m;m=k[m+(n<<2)>>2]|0;break}while(0);k[d+(n<<2)>>2]=m|p;k[f>>2]=(k[f>>2]|0)+1;r=(k[a+32>>2]|0)+((aa(k[a+28>>2]|0,t)|0)<<2)|0;s=r+(k[a+52>>2]<<2)|0;p=s+-12|0;q=((p>>>0<r>>>0?r:p)+12+(3-r)|0)>>>4<<2;d=c+(q<<2)|0;if(r>>>0<p>>>0){n=r;m=c;l=0.0;while(1){B=+o[n>>2]-+o[m>>2];A=+o[n+4>>2]-+o[m+4>>2];e=+o[n+8>>2]-+o[m+8>>2];h=+o[n+12>>2]-+o[m+12>>2];l=l+(B*B+A*A+e*e+h*h);n=n+16|0;if(n>>>0>=p>>>0)break;else m=m+16|0}}else l=0.0;m=r+(q<<2)|0;if(m>>>0<s>>>0)while(1){B=+o[m>>2]-+o[d>>2];m=m+4|0;l=l+B*B;if(m>>>0>=s>>>0)break;else d=d+4|0}$f[k[(k[b>>2]|0)+12>>2]&15](b,l,t);return}l=+o[c+(k[d>>2]<<2)>>2]-+o[d+4>>2];v=l<0.0;x=k[(v?n:p)>>2]|0;p=k[(v?p:n)>>2]|0;l=l*l+e;if(!(!(l*h<+hg[k[(k[b>>2]|0)+16>>2]&127](b))?Xh[k[(k[b>>2]|0)+8>>2]&1023](b)|0:0))q=15;if((q|0)==15?(y=i+16|0,(k[y>>2]|0)!=(k[i+12>>2]|0)):0){v=i+4|0;d=k[v>>2]|0;t=i+8|0;u=k[t>>2]|0;n=u;if((d|0)==(u|0)){u=k[i>>2]|0;s=d-u|0;r=s>>3;d=r+1|0;if(d>>>0>536870911)ad(426534,426557,304,426811);n=n-u|0;q=n>>2;q=n>>3>>>0<268435455?(q>>>0<d>>>0?d:q):536870911;if(!q)n=0;else{if(q>>>0>536870911){b=te(4)|0;k[b>>2]=172664;Cf(b|0,28816,1287)}n=q<<3;n=(n|0)==0?1:n;while(1){d=fgb(n)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}n=d}d=n+(r<<3)|0;k[d>>2]=p;o[n+(r<<3)+4>>2]=l;p=d+8|0;d=d+(0-r<<3)|0;if((s|0)>0)upb(d|0,u|0,s|0)|0;k[i>>2]=d;k[v>>2]=p;k[t>>2]=n+(q<<3);if(!u)d=i;else{ggb(u);d=i;p=k[v>>2]|0}}else{k[d>>2]=p;o[d+4>>2]=l;p=(k[v>>2]|0)+8|0;k[v>>2]=p;d=i}d=k[d>>2]|0;n=p-d|0;if((n|0)>8?(m=((n>>3)+-2|0)/2|0,z=d,v=p,w=v+-8|0,A=+o[v+-4>>2],A<+o[z+(m<<3)+4>>2]):0){p=k[w>>2]|0;n=w;while(1){w=n;n=z+(m<<3)|0;u=n;v=k[u+4>>2]|0;k[w>>2]=k[u>>2];k[w+4>>2]=v;if(!m){m=0;break}d=(m+-1|0)/2|0;if(!(A<+o[z+(d<<3)+4>>2]))break;else m=d}k[n>>2]=p;o[z+(m<<3)+4>>2]=A}k[y>>2]=(k[y>>2]|0)+1}YMa(a,b,c,x,e,f,g,h,i,j);return}function ZMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;g=a+68|0;h=a+88|0;j=a+72|0;l=a+76|0;m=a+84|0;while(1){e=k[g>>2]|0;a:do if((e|0)<16){k[h>>2]=(k[h>>2]|0)+e;d=fgb(8192)|0;if(d|0){k[d>>2]=k[j>>2];k[j>>2]=d;k[g>>2]=8188;d=d+4|0;k[l>>2]=d;e=8172;n=29;break}d=k[41482]|0;e=(d|0)==0;if((k[41497]|0)>-1){do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}else{do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}}else{d=k[l>>2]|0;e=e+-16|0;n=29}while(0);if((n|0)==29){n=0;k[l>>2]=d+16;k[g>>2]=e;k[m>>2]=(k[m>>2]|0)+16}k[c>>2]=d;if((_fb(d,16,1,b)|0)!=1){n=31;break}d=k[c>>2]|0;e=d+8|0;if(!(k[e>>2]|0))c=d;else{ZMa(a,b,e);c=k[c>>2]|0}c=c+12|0;if(!(k[c>>2]|0)){n=35;break}}if((n|0)==31){n=te(44)|0;VHa(n,373124);Cf(n|0,19720,57)}else if((n|0)==35)return}function _Ma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=a+76|0;m=a+16|0;n=a+74|0;o=a+8|0;p=a+4|0;q=a+44|0;r=a+28|0;s=a+20|0;g=a+48|0;h=a+36|0;j=a+75|0;do{c=k[m>>2]|0;d=(c|0)==0;a:do if((k[l>>2]|0)>-1){do if(d){c=i[n>>0]|0;i[n>>0]=c+255|c;c=k[a>>2]|0;if(!(c&8)){k[o>>2]=0;k[p>>2]=0;d=k[q>>2]|0;k[r>>2]=d;k[s>>2]=d;c=d+(k[g>>2]|0)|0;k[m>>2]=c;break}else{k[a>>2]=c|32;break a}}else d=k[s>>2]|0;while(0);f=d;if((c-d|0)>>>0<16){ci[k[h>>2]&255](a,b,16)|0;break}b:do if((i[j>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=b;c=f;break b}c=d+-1|0;if((i[b+c>>0]|0)==10)break;else d=c}if((ci[k[h>>2]&255](a,b,d)|0)>>>0<d>>>0)break a;e=16-d|0;d=b+d|0;c=k[s>>2]|0}else{e=16;d=b;c=f}while(0);upb(c|0,d|0,e|0)|0;k[s>>2]=(k[s>>2]|0)+e}else{do if(d){c=i[n>>0]|0;i[n>>0]=c+255|c;c=k[a>>2]|0;if(!(c&8)){k[o>>2]=0;k[p>>2]=0;d=k[q>>2]|0;k[r>>2]=d;k[s>>2]=d;c=d+(k[g>>2]|0)|0;k[m>>2]=c;break}else{k[a>>2]=c|32;break a}}else d=k[s>>2]|0;while(0);f=d;if((c-d|0)>>>0<16){ci[k[h>>2]&255](a,b,16)|0;break}c:do if((i[j>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=b;c=f;break c}c=d+-1|0;if((i[b+c>>0]|0)==10)break;else d=c}if((ci[k[h>>2]&255](a,b,d)|0)>>>0<d>>>0)break a;e=16-d|0;d=b+d|0;c=k[s>>2]|0}else{e=16;d=b;c=f}while(0);upb(c|0,d|0,e|0)|0;k[s>>2]=(k[s>>2]|0)+e}while(0);c=k[b+8>>2]|0;if(c|0)_Ma(a,c);b=k[b+12>>2]|0}while((b|0)!=0);return}function $Ma(a){a=a|0;var b=0,c=0,d=0,e=0.0,f=0,g=0.0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0;z=a+12|0;if((k[z>>2]|0)<2){z=te(44)|0;VHa(z,373858);Cf(z|0,19720,57)}j=a+56|0;d=k[j>>2]|0;c=d>>>0>1073741823?-1:d<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}y=a+68|0;k[y>>2]=b;if(d|0){d=k[j>>2]|0;c=0;do{k[b+(c<<2)>>2]=c;c=c+1|0}while(c>>>0<d>>>0)}f=a+76|0;c=k[f>>2]|0;a:do if((c|0)<32){b=a+96|0;k[b>>2]=(k[b>>2]|0)+c;b=fgb(8192)|0;if(b|0){d=a+80|0;k[b>>2]=k[d>>2];k[d>>2]=b;k[f>>2]=8188;b=b+4|0;d=a+84|0;k[d>>2]=b;c=8156;h=36;break}b=k[41482]|0;c=(b|0)==0;if((k[41497]|0)>-1){do if(c){b=i[165986]|0;i[165986]=b+255|b;b=k[41478]|0;if(!(b&8)){k[41480]=0;k[41479]=0;c=k[41489]|0;k[41485]=c;k[41483]=c;b=c+(k[41490]|0)|0;k[41482]=b;break}else{k[41478]=b|32;b=0;break a}}else c=k[41483]|0;while(0);if((b-c|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;b=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){b=0;break}b=0;d=373857;c=k[41483]|0}else{b=27;d=373830}upb(c|0,d|0,b|0)|0;k[41483]=(k[41483]|0)+b;b=0;break}else{do if(c){b=i[165986]|0;i[165986]=b+255|b;b=k[41478]|0;if(!(b&8)){k[41480]=0;k[41479]=0;c=k[41489]|0;k[41485]=c;k[41483]=c;b=c+(k[41490]|0)|0;k[41482]=b;break}else{k[41478]=b|32;b=0;break a}}else c=k[41483]|0;while(0);if((b-c|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;b=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){b=0;break}b=0;d=373857;c=k[41483]|0}else{b=27;d=373830}upb(c|0,d|0,b|0)|0;k[41483]=(k[41483]|0)+b;b=0;break}}else{b=a+84|0;d=b;b=k[b>>2]|0;c=c+-32|0;h=36}while(0);if((h|0)==36){k[d>>2]=b+32;k[f>>2]=c;x=a+92|0;k[x>>2]=(k[x>>2]|0)+32}x=a+64|0;k[x>>2]=b;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;k[b+24>>2]=0;k[b+28>>2]=0;w=k[x>>2]|0;u=k[y>>2]|0;v=k[j>>2]|0;p=k[a+60>>2]|0;c=p>>>0>1073741823?-1:p<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}t=p<<2;r=a+100|0;k[r>>2]=(k[r>>2]|0)+t;zpb(b|0,0,t|0)|0;t=k[j>>2]|0;b:do if(!t)e=0.0;else{m=k[a+40>>2]|0;n=k[a+36>>2]|0;if(!p){f=0;e=0.0;while(1){d=m+((aa(n,k[u+(f<<2)>>2]|0)|0)<<2)|0;c=d+((d+12+(3-d)|0)>>>4<<2<<2)|0;if(c>>>0<d>>>0){g=0.0;do{s=+o[c>>2];c=c+4|0;g=g+s*s}while(c>>>0<d>>>0)}else g=0.0;e=e+g;f=f+1|0;if((f|0)==(t|0))break b}}else{l=0;e=0.0}do{h=m+((aa(n,k[u+(l<<2)>>2]|0)|0)<<2)|0;c=0;do{r=b+(c<<2)|0;o[r>>2]=+o[h+(c<<2)>>2]+ +o[r>>2];c=c+1|0}while((c|0)!=(p|0));j=h+(p<<2)|0;d=j+-12|0;f=((d>>>0<h>>>0?h:d)+12+(3-h)|0)>>>4<<2;if(h>>>0<d>>>0){c=h;g=0.0;do{C=+o[c>>2];B=+o[c+4>>2];A=+o[c+8>>2];s=+o[c+12>>2];g=g+(C*C+B*B+A*A+s*s);c=c+16|0}while(c>>>0<d>>>0)}else g=0.0;c=h+(f<<2)|0;if(c>>>0<j>>>0)do{C=+o[c>>2];c=c+4|0;g=g+C*C}while(c>>>0<j>>>0);e=e+g;l=l+1|0}while((l|0)!=(t|0))}while(0);g=+(t>>>0);if(!p)c=0;else{c=0;do{r=b+(c<<2)|0;o[r>>2]=+o[r>>2]/g;c=c+1|0}while((c|0)!=(p|0));c=p}g=e/g;h=b+(c<<2)|0;d=h+-12|0;j=3-b|0;f=((d>>>0<b>>>0?b:d)+12+j|0)>>>4<<2;if(b>>>0<d>>>0){c=b;e=0.0;do{s=+o[c>>2];A=+o[c+4>>2];B=+o[c+8>>2];C=+o[c+12>>2];e=e+(s*s+A*A+B*B+C*C);c=c+16|0}while(c>>>0<d>>>0)}else e=0.0;c=b+(f<<2)|0;if(c>>>0<h>>>0)do{C=+o[c>>2];c=c+4|0;e=e+C*C}while(c>>>0<h>>>0);s=g-e;if((v|0)<=0){C=0.0;v=w+12|0;o[v>>2]=s;v=w+4|0;o[v>>2]=C;k[w>>2]=b;x=k[x>>2]|0;y=k[y>>2]|0;z=k[z>>2]|0;qNa(a,x,y,t,z,0);return}q=k[a+40>>2]|0;r=k[a+36>>2]|0;p=b+(p<<2)|0;l=p+-12|0;m=((l>>>0<b>>>0?b:l)+12+j|0)>>>4<<2;n=b+(m<<2)|0;j=n>>>0<p>>>0;if(b>>>0<l>>>0){e=0.0;h=0}else{if(j){e=0.0;f=0}else{C=0.0;v=w+12|0;o[v>>2]=s;v=w+4|0;o[v>>2]=C;k[w>>2]=b;x=k[x>>2]|0;y=k[y>>2]|0;z=k[z>>2]|0;qNa(a,x,y,t,z,0);return}do{c=q+((aa(r,k[u+(f<<2)>>2]|0)|0)<<2)+(m<<2)|0;g=0.0;d=n;while(1){C=+o[d>>2]-+o[c>>2];d=d+4|0;g=g+C*C;if(d>>>0>=p>>>0)break;else c=c+4|0}e=g>e?g:e;f=f+1|0}while((f|0)!=(v|0));v=w+12|0;o[v>>2]=s;v=w+4|0;o[v>>2]=e;k[w>>2]=b;x=k[x>>2]|0;y=k[y>>2]|0;z=k[z>>2]|0;qNa(a,x,y,t,z,0);return}do{f=q+((aa(r,k[u+(h<<2)>>2]|0)|0)<<2)|0;c=b;d=f;g=0.0;while(1){D=+o[c>>2]-+o[d>>2];A=+o[c+4>>2]-+o[d+4>>2];B=+o[c+8>>2]-+o[d+8>>2];C=+o[c+12>>2]-+o[d+12>>2];g=g+(D*D+A*A+B*B+C*C);c=c+16|0;if(c>>>0>=l>>>0)break;else d=d+16|0}if(j){d=f+(m<<2)|0;c=n;while(1){D=+o[c>>2]-+o[d>>2];c=c+4|0;g=g+D*D;if(c>>>0>=p>>>0)break;else d=d+4|0}}e=g>e?g:e;h=h+1|0}while((h|0)!=(v|0));v=w+12|0;o[v>>2]=s;v=w+4|0;o[v>>2]=e;k[w>>2]=b;x=k[x>>2]|0;y=k[y>>2]|0;z=k[z>>2]|0;qNa(a,x,y,t,z,0);return}function aNa(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[b>>2]|0;if(c|0)ggb(c);c=b+20|0;b=k[c>>2]|0;if(!b)return;d=a+12|0;if((k[d>>2]|0)<=0)return;aNa(a,k[b>>2]|0);if((k[d>>2]|0)>1)b=1;else return;do{aNa(a,k[(k[c>>2]|0)+(b<<2)>>2]|0);b=b+1|0}while((b|0)<(k[d>>2]|0));return}function bNa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=94308;b=k[a+64>>2]|0;if(b|0)aNa(a,b);b=k[a+68>>2]|0;if(b|0)ggb(b);c=a+80|0;b=k[c>>2]|0;if(b|0)do{d=b;b=k[b>>2]|0;ggb(d);k[c>>2]=b}while((b|0)!=0);YHa(k[a+48>>2]|0);return}function cNa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=94308;b=k[a+64>>2]|0;if(b|0)aNa(a,b);b=k[a+68>>2]|0;if(b|0)ggb(b);c=a+80|0;b=k[c>>2]|0;if(b|0)do{d=b;b=k[b>>2]|0;ggb(d);k[c>>2]=b}while((b|0)!=0);YHa(k[a+48>>2]|0);ggb(a);return}function dNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;h=a+12|0;j=b+76|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}b:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break b}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;f=k[b+44>>2]|0;k[b+28>>2]=f;g=b+20|0;k[g>>2]=f;d=f+(k[b+48>>2]|0)|0;k[e>>2]=d;e=f;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;d=c;g=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}c:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;d=h;break c}d=e+-1|0;if((i[h+d>>0]|0)==10)break;else e=d}if((ci[k[b+36>>2]&255](b,h,e)|0)>>>0<e>>>0)break a;f=4-e|0;d=h+e|0;c=k[g>>2]|0}else{f=4;d=h}while(0);upb(c|0,d|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f}while(0);h=a+16|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;d:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}e:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break e}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}f:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break f}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+100|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;g:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}h:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break h}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}i:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break i}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+24|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;j:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}k:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break k}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}l:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break l}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);d=k[a+68>>2]|0;h=k[a+56>>2]<<2;f=b+16|0;e=k[f>>2]|0;c=(e|0)==0;if((k[j>>2]|0)>-1){do if(c){c=b+74|0;j=i[c>>0]|0;i[c>>0]=j+255|j;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;j=k[b+44>>2]|0;k[b+28>>2]=j;g=b+20|0;k[g>>2]=j;e=j+(k[b+48>>2]|0)|0;k[f>>2]=e;f=j;break}k[b>>2]=c|32;j=a+64|0;j=k[j>>2]|0;pNa(a,b,j);return}else{f=b+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;j=a+64|0;j=k[j>>2]|0;pNa(a,b,j);return}m:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break m}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0){j=a+64|0;j=k[j>>2]|0;pNa(a,b,j);return}else{e=h-f|0;d=d+f|0;c=k[g>>2]|0;break}}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e;j=a+64|0;j=k[j>>2]|0;pNa(a,b,j);return}else{do if(c){c=b+74|0;j=i[c>>0]|0;i[c>>0]=j+255|j;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;j=k[b+44>>2]|0;k[b+28>>2]=j;g=b+20|0;k[g>>2]=j;e=j+(k[b+48>>2]|0)|0;k[f>>2]=e;f=j;break}k[b>>2]=c|32;j=a+64|0;j=k[j>>2]|0;pNa(a,b,j);return}else{f=b+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;j=a+64|0;j=k[j>>2]|0;pNa(a,b,j);return}n:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break n}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0){j=a+64|0;j=k[j>>2]|0;pNa(a,b,j);return}else{e=h-f|0;d=d+f|0;c=k[g>>2]|0;break}}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e;j=a+64|0;j=k[j>>2]|0;pNa(a,b,j);return}}function eNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o+8|0;h=o;j=a+12|0;if((_fb(j,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}l=a+16|0;if((_fb(l,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}if((_fb(a+100|0,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}m=a+24|0;if((_fb(m,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}f=a+68|0;c=k[f>>2]|0;if(c|0)ggb(c);e=k[a+56>>2]|0;d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[f>>2]=c;if((_fb(c,4,e,b)|0)!=(e|0)){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}c=a+64|0;d=k[c>>2]|0;if(d|0)aNa(a,d);oNa(a,b,c);g=a+44|0;c=n+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373358;b=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(b|0));f=WHa(g,n)|0;e=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[h>>2]=e;e=k[f>>2]|0;b=f+4|0;jh[k[k[e>>2]>>2]&1023](e,b);k[f>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,h,b);k[c>>2]=0;k[n>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);c=n+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373742;b=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(b|0));b=WHa(g,n)|0;f=k[b>>2]|0;h=b+4|0;jh[k[k[f>>2]>>2]&1023](f,h);k[b>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,j,h);k[c>>2]=0;k[n>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);c=n+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=10;i[d+14>>0]=0;f=375191;b=e+10|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(b|0));h=WHa(g,n)|0;b=k[h>>2]|0;j=h+4|0;jh[k[k[b>>2]>>2]&1023](b,j);k[h>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,l,j);k[c>>2]=0;k[n>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0);c=n+4|0;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=12;i[d+16>>0]=0;f=373752;b=e+12|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(b|0));j=WHa(g,n)|0;h=k[j>>2]|0;l=j+4|0;jh[k[k[h>>2]>>2]&1023](h,l);k[j>>2]=428728;Ph[k[(k[107182]|0)+4>>2]&511](428728,a+20|0,l);k[c>>2]=0;k[n>>2]=0;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)==1)ggb(k[d+-4>>2]|0);a=n+4|0;c=ZT(16)|0;k[c>>2]=1;j=c+4|0;k[n>>2]=j;k[a>>2]=8;i[c+12>>0]=0;h=j;i[h>>0]=99;i[h+1>>0]=98;i[h+2>>0]=95;i[h+3>>0]=105;j=j+4|0;i[j>>0]=110;i[j+1>>0]=100;i[j+2>>0]=101;i[j+3>>0]=120;j=WHa(g,n)|0;h=k[j>>2]|0;l=j+4|0;jh[k[k[h>>2]>>2]&1023](h,l);k[j>>2]=428716;Ph[k[(k[107179]|0)+4>>2]&511](428716,m,l);k[a>>2]=0;k[n>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)!=1){r=o;return}ggb(k[c+-4>>2]|0);r=o;return}function fNa(a){a=a|0;return k[a+56>>2]|0}function gNa(a){a=a|0;return k[a+60>>2]|0}function hNa(a){a=a|0;return (k[a+96>>2]|0)+(k[a+92>>2]|0)+(k[a+100>>2]|0)|0}function iNa(a){a=a|0;return 2}function jNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+44>>2]|0;f=b+48|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function kNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;m=o+8|0;n=o;e=ZT(12)|0;k[e>>2]=1;l=e+4|0;i[e+10>>0]=0;i[l>>0]=i[373823]|0;i[l+1>>0]=i[373824]|0;i[l+2>>0]=i[373825]|0;i[l+3>>0]=i[373826]|0;i[l+4>>0]=i[373827]|0;i[l+5>>0]=i[373828]|0;k[m>>2]=32;l=dIa(d,l,m)|0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);if((l|0)==-1){lNa(a,k[a+64>>2]|0,b,c);r=o;return}while(1){d=fgb(20)|0;if(d|0){h=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){h=0;break}Qh[d&7]()}f=k[a+56>>2]|0;k[h>>2]=0;j=h+4|0;k[j>>2]=0;g=h+8|0;k[g>>2]=0;k[h+12>>2]=f;if(f|0){if(f>>>0>536870911){o=te(4)|0;k[o>>2]=172664;Cf(o|0,28816,1287)}e=f<<3;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d;k[h>>2]=e;k[j>>2]=e;k[g>>2]=d+(f<<3)}k[h+16>>2]=0;k[m>>2]=0;mNa(a,k[a+64>>2]|0,b,c,m,l,h);a:do if(nNa(h,n)|0)do{if((k[m>>2]|0)>=(l|0)?Xh[k[(k[b>>2]|0)+8>>2]&1023](b)|0:0)break a;mNa(a,k[n>>2]|0,b,c,m,l,h)}while(nNa(h,n)|0);while(0);d=k[h>>2]|0;e=d;if(d|0){f=k[j>>2]|0;if((f|0)!=(d|0))k[j>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(d)}ggb(h);r=o;return}function lNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0;f=k[b>>2]|0;t=a+60|0;l=d+(k[t>>2]<<2)|0;i=l+-12|0;s=3-d|0;j=((i>>>0<d>>>0?d:i)+12+s|0)>>>4<<2;g=f+(j<<2)|0;if(i>>>0>d>>>0){h=d;e=0.0;while(1){x=+o[h>>2]-+o[f>>2];w=+o[h+4>>2]-+o[f+4>>2];v=+o[h+8>>2]-+o[f+8>>2];u=+o[h+12>>2]-+o[f+12>>2];e=e+(x*x+w*w+v*v+u*u);h=h+16|0;if(h>>>0>=i>>>0)break;else f=f+16|0}}else e=0.0;f=d+(j<<2)|0;if(f>>>0<l>>>0)while(1){x=+o[f>>2]-+o[g>>2];f=f+4|0;e=e+x*x;if(f>>>0>=l>>>0)break;else g=g+4|0}w=+o[b+4>>2];x=+hg[k[(k[c>>2]|0)+16>>2]&127](c);v=e-w-x;if(!(v>0.0?!(v*v-w*4.0*x>0.0):1))return;r=b+20|0;if(!(k[r>>2]|0)){s=b+16|0;if((k[s>>2]|0)<=0)return;q=b+24|0;r=a+40|0;n=a+36|0;m=0;do{p=k[(k[q>>2]|0)+(m<<2)>>2]|0;j=(k[r>>2]|0)+((aa(k[n>>2]|0,p)|0)<<2)|0;b=j+(k[t>>2]<<2)|0;i=b+-12|0;l=((i>>>0<j>>>0?j:i)+12+(3-j)|0)>>>4<<2;g=d+(l<<2)|0;if(j>>>0<i>>>0){f=j;h=d;e=0.0;while(1){u=+o[f>>2]-+o[h>>2];v=+o[f+4>>2]-+o[h+4>>2];w=+o[f+8>>2]-+o[h+8>>2];x=+o[f+12>>2]-+o[h+12>>2];e=e+(u*u+v*v+w*w+x*x);f=f+16|0;if(f>>>0>=i>>>0)break;else h=h+16|0}}else e=0.0;f=j+(l<<2)|0;if(f>>>0<b>>>0)while(1){x=+o[f>>2]-+o[g>>2];f=f+4|0;e=e+x*x;if(f>>>0>=b>>>0)break;else g=g+4|0}$f[k[(k[c>>2]|0)+12>>2]&15](c,e,p);m=m+1|0}while((m|0)<(k[s>>2]|0));return}q=a+12|0;g=k[q>>2]|0;g=g>>>0>1073741823?-1:g<<2;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0){p=f;break}f=k[207666]|0;k[207666]=f+0;if(!f){p=0;break}Qh[f&7]()}h=k[q>>2]|0;g=h>>>0>1073741823?-1:h<<2;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}if((h|0)>0){n=k[r>>2]|0;m=0;do{g=k[k[n+(m<<2)>>2]>>2]|0;b=d+(k[t>>2]<<2)|0;j=b+-12|0;l=((j>>>0<d>>>0?d:j)+12+s|0)>>>4<<2;h=g+(l<<2)|0;if(j>>>0>d>>>0){i=d;e=0.0;while(1){u=+o[i>>2]-+o[g>>2];v=+o[i+4>>2]-+o[g+4>>2];w=+o[i+8>>2]-+o[g+8>>2];x=+o[i+12>>2]-+o[g+12>>2];e=e+(u*u+v*v+w*w+x*x);i=i+16|0;if(i>>>0>=j>>>0)break;else g=g+16|0}}else e=0.0;g=d+(l<<2)|0;if(g>>>0<b>>>0)while(1){x=+o[g>>2]-+o[h>>2];g=g+4|0;e=e+x*x;if(g>>>0>=b>>>0)break;else h=h+4|0}h=0;while(1){i=f+(h<<2)|0;g=(h|0)<(m|0);if(g&+o[i>>2]<e)h=h+1|0;else break}if(g){g=m;do{b=g;g=g+-1|0;k[f+(b<<2)>>2]=k[f+(g<<2)>>2];k[p+(b<<2)>>2]=k[p+(g<<2)>>2]}while((g|0)>(h|0))}o[i>>2]=e;k[p+(h<<2)>>2]=m;m=m+1|0}while((m|0)<(k[q>>2]|0))}ggb(f);if((k[q>>2]|0)>0){f=0;do{lNa(a,k[(k[r>>2]|0)+(k[p+(f<<2)>>2]<<2)>>2]|0,c,d);f=f+1|0}while((f|0)<(k[q>>2]|0))}ggb(p);return}function mNa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;K=a+60|0;J=3-d|0;x=a+12|0;y=a+24|0;z=g+16|0;A=g+12|0;B=g+4|0;C=g+8|0;p=b;a:while(1){b=k[p>>2]|0;n=d+(k[K>>2]<<2)|0;l=n+-12|0;m=((l>>>0<d>>>0?d:l)+12+J|0)>>>4<<2;i=b+(m<<2)|0;if(l>>>0>d>>>0){j=d;h=0.0;while(1){O=+o[j>>2]-+o[b>>2];N=+o[j+4>>2]-+o[b+4>>2];M=+o[j+8>>2]-+o[b+8>>2];L=+o[j+12>>2]-+o[b+12>>2];h=h+(O*O+N*N+M*M+L*L);j=j+16|0;if(j>>>0>=l>>>0)break;else b=b+16|0}}else h=0.0;b=d+(m<<2)|0;if(b>>>0<n>>>0)while(1){O=+o[b>>2]-+o[i>>2];b=b+4|0;h=h+O*O;if(b>>>0>=n>>>0)break;else i=i+4|0}N=+o[p+4>>2];O=+hg[k[(k[c>>2]|0)+16>>2]&127](c);M=h-N-O;if(!(M>0.0?!(M*M-N*4.0*O>0.0):1)){b=67;break}w=p+20|0;if(!(k[w>>2]|0)){b=8;break}i=k[x>>2]|0;i=i>>>0>1073741823?-1:i<<2;i=(i|0)==0?1:i;while(1){b=fgb(i)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}t=k[w>>2]|0;i=k[k[t>>2]>>2]|0;u=d+(k[K>>2]<<2)|0;r=u+-12|0;v=((r>>>0<d>>>0?d:r)+12+J|0)>>>4<<2;l=i+(v<<2)|0;m=r>>>0>d>>>0;if(m){j=d;h=0.0;while(1){L=+o[j>>2]-+o[i>>2];M=+o[j+4>>2]-+o[i+4>>2];N=+o[j+8>>2]-+o[i+8>>2];O=+o[j+12>>2]-+o[i+12>>2];h=h+(L*L+M*M+N*N+O*O);j=j+16|0;if(j>>>0>=r>>>0)break;else i=i+16|0}}else h=0.0;s=d+(v<<2)|0;q=s>>>0<u>>>0;if(q){j=l;i=s;while(1){O=+o[i>>2]-+o[j>>2];i=i+4|0;h=h+O*O;if(i>>>0>=u>>>0)break;else j=j+4|0}}o[b>>2]=h;j=k[x>>2]|0;b:do if((j|0)>1){if(m){p=1;i=0}else{if(q){n=1;i=0}else{l=1;i=0;while(1){o[b+(l<<2)>>2]=0.0;i=+o[b+(i<<2)>>2]>0.0?l:i;l=l+1|0;if((l|0)==(j|0))break b}}while(1){l=(k[k[t+(n<<2)>>2]>>2]|0)+(v<<2)|0;h=0.0;m=s;while(1){O=+o[m>>2]-+o[l>>2];m=m+4|0;h=h+O*O;if(m>>>0>=u>>>0)break;else l=l+4|0}o[b+(n<<2)>>2]=h;i=h<+o[b+(i<<2)>>2]?n:i;n=n+1|0;if((n|0)==(j|0))break b}}do{n=k[k[t+(p<<2)>>2]>>2]|0;l=d;m=n;h=0.0;while(1){L=+o[l>>2]-+o[m>>2];M=+o[l+4>>2]-+o[m+4>>2];N=+o[l+8>>2]-+o[m+8>>2];O=+o[l+12>>2]-+o[m+12>>2];h=h+(L*L+M*M+N*N+O*O);l=l+16|0;if(l>>>0>=r>>>0)break;else m=m+16|0}if(q){m=n+(v<<2)|0;l=s;while(1){O=+o[l>>2]-+o[m>>2];l=l+4|0;h=h+O*O;if(l>>>0>=u>>>0)break;else m=m+4|0}}o[b+(p<<2)>>2]=h;i=h<+o[b+(i<<2)>>2]?p:i;p=p+1|0}while((p|0)!=(j|0))}else i=0;while(0);if((j|0)>0){s=0;do{if((s|0)!=(i|0)?(E=k[(k[w>>2]|0)+(s<<2)>>2]|0,v=b+(s<<2)|0,D=+o[v>>2]-+o[y>>2]*+o[E+12>>2],o[v>>2]=D,E,(k[z>>2]|0)!=(k[A>>2]|0)):0){j=k[B>>2]|0;v=k[C>>2]|0;l=v;if((j|0)==(v|0)){r=k[g>>2]|0;q=j-r|0;p=q>>3;j=p+1|0;if(j>>>0>536870911){b=45;break a}v=l-r|0;n=v>>2;n=v>>3>>>0<268435455?(n>>>0<j>>>0?j:n):536870911;if(!n)j=0;else{if(n>>>0>536870911){b=48;break a}l=n<<3;l=(l|0)==0?1:l;while(1){j=fgb(l)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}}l=j+(p<<3)|0;k[l>>2]=E;o[j+(p<<3)+4>>2]=D;m=l+8|0;l=l+(0-p<<3)|0;if((q|0)>0)upb(l|0,r|0,q|0)|0;k[g>>2]=l;k[B>>2]=m;k[C>>2]=j+(n<<3);if(r){ggb(r);m=k[B>>2]|0}}else{k[j>>2]=E;o[j+4>>2]=D;m=(k[B>>2]|0)+8|0;k[B>>2]=m}j=k[g>>2]|0;l=m-j|0;if((l|0)>8?(F=((l>>3)+-2|0)/2|0,G=j,v=m,H=v+-8|0,I=+o[v+-4>>2],I<+o[G+(F<<3)+4>>2]):0){n=k[H>>2]|0;m=H;j=F;while(1){v=m;m=G+(j<<3)|0;t=m;u=k[t+4>>2]|0;k[v>>2]=k[t>>2];k[v+4>>2]=u;if(!j){j=0;break}l=(j+-1|0)/2|0;if(!(I<+o[G+(l<<3)+4>>2]))break;else j=l}k[m>>2]=n;o[G+(j<<3)+4>>2]=I}k[z>>2]=(k[z>>2]|0)+1;j=k[x>>2]|0}s=s+1|0}while((s|0)<(j|0))}ggb(b);p=k[(k[w>>2]|0)+(i<<2)>>2]|0}if((b|0)==8){b=k[e>>2]|0;do if((b|0)>=(f|0))if(Xh[k[(k[c>>2]|0)+8>>2]&1023](c)|0)return;else{b=k[e>>2]|0;break}while(0);v=p+16|0;k[e>>2]=b+(k[v>>2]|0);if((k[v>>2]|0)<=0)return;t=p+24|0;u=a+40|0;r=a+36|0;q=0;do{s=k[(k[t>>2]|0)+(q<<2)>>2]|0;n=(k[u>>2]|0)+((aa(k[r>>2]|0,s)|0)<<2)|0;p=n+(k[K>>2]<<2)|0;l=p+-12|0;m=((l>>>0<n>>>0?n:l)+12+(3-n)|0)>>>4<<2;i=d+(m<<2)|0;if(n>>>0<l>>>0){b=n;j=d;h=0.0;while(1){L=+o[b>>2]-+o[j>>2];M=+o[b+4>>2]-+o[j+4>>2];N=+o[b+8>>2]-+o[j+8>>2];O=+o[b+12>>2]-+o[j+12>>2];h=h+(L*L+M*M+N*N+O*O);b=b+16|0;if(b>>>0>=l>>>0)break;else j=j+16|0}}else h=0.0;b=n+(m<<2)|0;if(b>>>0<p>>>0)while(1){O=+o[b>>2]-+o[i>>2];b=b+4|0;h=h+O*O;if(b>>>0>=p>>>0)break;else i=i+4|0}$f[k[(k[c>>2]|0)+12>>2]&15](c,h,s);q=q+1|0}while((q|0)<(k[v>>2]|0));return}else if((b|0)==45)ad(426534,426557,304,426811);else if((b|0)==48){K=te(4)|0;k[K>>2]=172664;Cf(K|0,28816,1287)}else if((b|0)==67)return}function nNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0.0,i=0,j=0,l=0,m=0,n=0,p=0,q=0;j=a+16|0;if(!(k[j>>2]|0)){q=0;return q|0}g=k[a>>2]|0;i=k[g+4>>2]|0;c=b;k[c>>2]=k[g>>2];k[c+4>>2]=i;c=k[a>>2]|0;i=a+4|0;b=k[i>>2]|0;g=b-c|0;a=g>>3;if(((g|0)>8?(l=c,m=b+-8|0,n=l,g=k[n>>2]|0,n=k[n+4>>2]|0,d=m,e=k[d+4>>2]|0,f=l,k[f>>2]=k[d>>2],k[f+4>>2]=e,m,k[m>>2]=g,k[m+4>>2]=n,m=a+-1|0,n=c,(a|0)!=2):0)?(g=a+-3|0,p=(g|0)/2|0,(g|0)>=-1):0){b=l+8|0;if((m|0)>2?+o[n+20>>2]<+o[n+12>>2]:0){a=2;b=l+16|0}else a=1;h=+o[n+4>>2];if(!(h<+o[b+4>>2])){g=k[c>>2]|0;f=l;while(1){e=f;f=b;c=f;d=k[c+4>>2]|0;k[e>>2]=k[c>>2];k[e+4>>2]=d;if((p|0)<(a|0))break;a=a<<1|1;d=l+(a<<3)|0;c=d;e=a+1|0;if((e|0)<(m|0)?(q=d+8|0,+o[q+4>>2]<+o[n+(a<<3)+4>>2]):0){a=e;c=q}if(h<+o[c+4>>2])break;else b=c}k[b>>2]=g;o[b+4>>2]=h}}k[i>>2]=(k[i>>2]|0)+-8;k[j>>2]=(k[j>>2]|0)+-1;q=1;return q|0}function oNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;g=m;j=a+76|0;e=k[j>>2]|0;a:do if((e|0)<32){d=a+96|0;k[d>>2]=(k[d>>2]|0)+e;d=fgb(8192)|0;if(d|0){f=a+80|0;k[d>>2]=k[f>>2];k[f>>2]=d;k[j>>2]=8188;d=d+4|0;f=a+84|0;k[f>>2]=d;e=8156;l=28;break}d=k[41482]|0;e=(d|0)==0;if((k[41497]|0)>-1){do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}else{do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}}else{d=a+84|0;f=d;d=k[d>>2]|0;e=e+-32|0;l=28}while(0);if((l|0)==28){k[f>>2]=d+32;k[j>>2]=e;h=a+92|0;k[h>>2]=(k[h>>2]|0)+32}k[c>>2]=d;if((_fb(d,32,1,b)|0)!=1){m=te(44)|0;VHa(m,373124);Cf(m|0,19720,57)}f=k[a+60>>2]|0;e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[k[c>>2]>>2]=d;if((_fb(k[k[c>>2]>>2]|0,4,f,b)|0)!=(f|0)){m=te(44)|0;VHa(m,373124);Cf(m|0,19720,57)}if(!(k[(k[c>>2]|0)+20>>2]|0)){if((_fb(g,4,1,b)|0)!=1){m=te(44)|0;VHa(m,373124);Cf(m|0,19720,57)}k[(k[c>>2]|0)+24>>2]=(k[a+68>>2]|0)+(k[g>>2]<<2);r=m;return}h=a+12|0;g=(k[h>>2]<<2)+15&-16;e=k[j>>2]|0;b:do if((g|0)>(e|0)){d=a+96|0;k[d>>2]=(k[d>>2]|0)+e;d=(g|4)+15|0;d=d>>>0>8192?d:8192;e=fgb(d)|0;if(e|0){l=a+80|0;k[e>>2]=k[l>>2];k[l>>2]=e;l=d+-4|0;k[j>>2]=l;d=e+4|0;f=a+84|0;k[f>>2]=d;e=l;l=68;break}d=k[41482]|0;e=(d|0)==0;if((k[41497]|0)>-1){do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break b}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}else{do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break b}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}}else{d=a+84|0;f=d;d=k[d>>2]|0;l=68}while(0);if((l|0)==68){k[f>>2]=d+g;k[j>>2]=e-g;l=a+92|0;k[l>>2]=(k[l>>2]|0)+g}k[(k[c>>2]|0)+20>>2]=d;if((k[h>>2]|0)>0)d=0;else{r=m;return}do{oNa(a,b,(k[(k[c>>2]|0)+20>>2]|0)+(d<<2)|0);d=d+1|0}while((d|0)<(k[h>>2]|0));r=m;return}function pNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;e=n;m=b+76|0;g=b+16|0;d=k[g>>2]|0;f=(d|0)==0;a:do if((k[m>>2]|0)>-1){do if(f){d=b+74|0;l=i[d>>0]|0;i[d>>0]=l+255|l;d=k[b>>2]|0;if(!(d&8)){k[b+8>>2]=0;k[b+4>>2]=0;f=k[b+44>>2]|0;k[b+28>>2]=f;j=b+20|0;k[j>>2]=f;d=f+(k[b+48>>2]|0)|0;k[g>>2]=d;break}else{k[b>>2]=d|32;break a}}else{f=b+20|0;j=f;f=k[f>>2]|0}while(0);h=f;if((d-f|0)>>>0<32){ci[k[b+36>>2]&255](b,c,32)|0;break}b:do if((i[b+75>>0]|0)>-1){f=32;while(1){if(!f){g=32;f=c;d=h;break b}d=f+-1|0;if((i[c+d>>0]|0)==10)break;else f=d}if((ci[k[b+36>>2]&255](b,c,f)|0)>>>0<f>>>0)break a;g=32-f|0;f=c+f|0;d=k[j>>2]|0}else{g=32;f=c;d=h}while(0);upb(d|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}else{do if(f){d=b+74|0;l=i[d>>0]|0;i[d>>0]=l+255|l;d=k[b>>2]|0;if(!(d&8)){k[b+8>>2]=0;k[b+4>>2]=0;f=k[b+44>>2]|0;k[b+28>>2]=f;j=b+20|0;k[j>>2]=f;d=f+(k[b+48>>2]|0)|0;k[g>>2]=d;break}else{k[b>>2]=d|32;break a}}else{f=b+20|0;j=f;f=k[f>>2]|0}while(0);h=f;if((d-f|0)>>>0<32){ci[k[b+36>>2]&255](b,c,32)|0;break}c:do if((i[b+75>>0]|0)>-1){f=32;while(1){if(!f){g=32;f=c;d=h;break c}d=f+-1|0;if((i[c+d>>0]|0)==10)break;else f=d}if((ci[k[b+36>>2]&255](b,c,f)|0)>>>0<f>>>0)break a;g=32-f|0;f=c+f|0;d=k[j>>2]|0}else{g=32;f=c;d=h}while(0);upb(d|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}while(0);f=k[c>>2]|0;l=k[a+60>>2]<<2;h=b+16|0;d=k[h>>2]|0;g=(d|0)==0;d:do if((k[m>>2]|0)>-1){do if(g){d=b+74|0;j=i[d>>0]|0;i[d>>0]=j+255|j;d=k[b>>2]|0;if(!(d&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;j=b+20|0;k[j>>2]=d;g=d+(k[b+48>>2]|0)|0;k[h>>2]=g;h=d;break}else{k[b>>2]=d|32;break d}}else{h=b+20|0;g=d;j=h;h=k[h>>2]|0}while(0);d=h;if((g-h|0)>>>0<l>>>0){ci[k[b+36>>2]&255](b,f,l)|0;break}e:do if((i[b+75>>0]|0)>-1){h=l;while(1){if(!h){g=l;break e}g=h+-1|0;if((i[f+g>>0]|0)==10)break;else h=g}if((ci[k[b+36>>2]&255](b,f,h)|0)>>>0<h>>>0)break d;g=l-h|0;f=f+h|0;d=k[j>>2]|0}else g=l;while(0);upb(d|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}else{do if(g){d=b+74|0;j=i[d>>0]|0;i[d>>0]=j+255|j;d=k[b>>2]|0;if(!(d&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;j=b+20|0;k[j>>2]=d;g=d+(k[b+48>>2]|0)|0;k[h>>2]=g;h=d;break}else{k[b>>2]=d|32;break d}}else{h=b+20|0;g=d;j=h;h=k[h>>2]|0}while(0);d=h;if((g-h|0)>>>0<l>>>0){ci[k[b+36>>2]&255](b,f,l)|0;break}f:do if((i[b+75>>0]|0)>-1){h=l;while(1){if(!h){g=l;break f}g=h+-1|0;if((i[f+g>>0]|0)==10)break;else h=g}if((ci[k[b+36>>2]&255](b,f,h)|0)>>>0<h>>>0)break d;g=l-h|0;f=f+h|0;d=k[j>>2]|0}else g=l;while(0);upb(d|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}while(0);f=c+20|0;d=k[f>>2]|0;if(d|0){e=a+12|0;if((k[e>>2]|0)<=0){r=n;return}pNa(a,b,k[d>>2]|0);if((k[e>>2]|0)>1)d=1;else{r=n;return}do{pNa(a,b,k[(k[f>>2]|0)+(d<<2)>>2]|0);d=d+1|0}while((d|0)<(k[e>>2]|0));r=n;return}k[e>>2]=(k[c+24>>2]|0)-(k[a+68>>2]|0)>>2;g=b+16|0;f=k[g>>2]|0;d=(f|0)==0;g:do if((k[m>>2]|0)>-1){do if(d){d=b+74|0;m=i[d>>0]|0;i[d>>0]=m+255|m;d=k[b>>2]|0;if(!(d&8)){k[b+8>>2]=0;k[b+4>>2]=0;m=k[b+44>>2]|0;k[b+28>>2]=m;h=b+20|0;k[h>>2]=m;f=m+(k[b+48>>2]|0)|0;k[g>>2]=f;g=m;break}else{k[b>>2]=d|32;break g}}else{g=b+20|0;h=g;g=k[g>>2]|0}while(0);d=g;if((f-g|0)>>>0<4){ci[k[b+36>>2]&255](b,e,4)|0;break}h:do if((i[b+75>>0]|0)>-1){g=4;while(1){if(!g){f=4;break h}f=g+-1|0;if((i[e+f>>0]|0)==10)break;else g=f}if((ci[k[b+36>>2]&255](b,e,g)|0)>>>0<g>>>0)break g;f=4-g|0;e=e+g|0;d=k[h>>2]|0}else f=4;while(0);upb(d|0,e|0,f|0)|0;k[h>>2]=(k[h>>2]|0)+f}else{do if(d){d=b+74|0;m=i[d>>0]|0;i[d>>0]=m+255|m;d=k[b>>2]|0;if(!(d&8)){k[b+8>>2]=0;k[b+4>>2]=0;m=k[b+44>>2]|0;k[b+28>>2]=m;h=b+20|0;k[h>>2]=m;f=m+(k[b+48>>2]|0)|0;k[g>>2]=f;g=m;break}else{k[b>>2]=d|32;break g}}else{g=b+20|0;h=g;g=k[g>>2]|0}while(0);d=g;if((f-g|0)>>>0<4){ci[k[b+36>>2]&255](b,e,4)|0;break}i:do if((i[b+75>>0]|0)>-1){g=4;while(1){if(!g){f=4;break i}f=g+-1|0;if((i[e+f>>0]|0)==10)break;else g=f}if((ci[k[b+36>>2]&255](b,e,g)|0)>>>0<g>>>0)break g;f=4-g|0;e=e+g|0;d=k[h>>2]|0}else f=4;while(0);upb(d|0,e|0,f|0)|0;k[h>>2]=(k[h>>2]|0)+f}while(0);r=n;return}function qNa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0.0,n=0,q=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0;Ga=r;r=r+4400|0;Fa=Ga+3328|0;l=Ga+3320|0;Ca=Ga;ja=Ga+3304|0;Aa=Ga+3288|0;Ba=Ga+2224|0;za=Ga+1160|0;Y=Ga+4392|0;Z=Ga+1152|0;_=Ga+1104|0;$=Ga+1096|0;k[b+16>>2]=d;k[b+28>>2]=f;if((d|0)<(e|0)){k[b+24>>2]=c;Dgb(c,c+(d<<2)|0);k[b+20>>2]=0;r=Ga;return}Da=Fa+8|0;k[Fa>>2]=Da;Ea=Fa+4|0;k[Ea>>2]=264;y=e>>>0>264;if(y){h=e>>>0>1073741823?-1:e<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[Fa>>2]=g}else g=Da;k[Ea>>2]=e;h=k[a+4>>2]|0;xa=k[a+8>>2]|0;j=a+(xa>>1)|0;if(xa&1)h=k[(k[j>>2]|0)+h>>2]|0;Lg[h&255](j,e,c,d,g,l);t=k[l>>2]|0;if((t|0)>=(e|0)){va=a+60|0;u=k[va>>2]|0;l=aa(u,e)|0;wa=Ca+8|0;k[Ca>>2]=wa;xa=Ca+4|0;k[xa>>2]=136;h=wa;if(l>>>0>136){j=l>>>0>536870911?-1:l<<3;j=(j|0)==0?1:j;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[Ca>>2]=h}k[xa>>2]=l;k[ja>>2]=e;k[ja+4>>2]=u;X=ja+8|0;W=ja+12|0;k[W>>2]=h;k[X>>2]=u;if((t|0)>0?(w=k[a+40>>2]|0,x=k[a+36>>2]|0,u|0):0){j=0;do{n=w+((aa(x,k[g+(j<<2)>>2]|0)|0)<<2)|0;q=h+((aa(u,j)|0)<<3)|0;l=0;do{p[q+(l<<3)>>3]=+o[n+(l<<2)>>2];l=l+1|0}while((l|0)!=(u|0));j=j+1|0}while((j|0)!=(t|0))}k[Aa>>2]=0;ua=Aa+4|0;k[ua>>2]=0;k[Aa+8>>2]=0;if(e|0){if(e>>>0>1073741823)ad(426534,426557,304,426811);j=e<<2;h=(j|0)==0?1:j;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[Aa>>2]=g;ta=g+(e<<2)|0;k[Aa+8>>2]=ta;zpb(g|0,0,j|0)|0;k[ua>>2]=ta}ta=Ba+8|0;k[Ba>>2]=ta;sa=Ba+4|0;k[sa>>2]=264;if(y){h=e>>>0>1073741823?-1:e<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[Ba>>2]=g;ra=g}else ra=ta;k[sa>>2]=e;ka=(e|0)>0;if(ka){h=k[Aa>>2]|0;g=0;do{o[h+(g<<2)>>2]=0.0;k[ra+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(e|0))}pa=za+8|0;k[za>>2]=pa;qa=za+4|0;k[qa>>2]=264;if(d>>>0>264){h=d>>>0>1073741823?-1:d<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[za>>2]=g;oa=g}else oa=pa;k[qa>>2]=d;ma=(d|0)>0;na=a+40|0;if(ma){D=k[na>>2]|0;E=a+36|0;F=k[W>>2]|0;G=(e|0)>1;H=k[Aa>>2]|0;I=k[E>>2]|0;J=k[va>>2]|0;K=k[X>>2]|0;C=0;do{u=c+(C<<2)|0;n=D+((aa(I,k[u>>2]|0)|0)<<2)|0;t=n+(J<<2)|0;l=t+-12|0;q=((l>>>0<n>>>0?n:l)+12+(3-n)|0)>>>4<<2;h=F+(q<<3)|0;if(n>>>0<l>>>0){g=n;j=F;m=0.0;while(1){Ha=+o[g>>2]-+p[j>>3];s=+o[g+4>>2]-+p[j+8>>3];v=+o[g+8>>2]-+p[j+16>>3];z=+o[g+12>>2]-+p[j+24>>3];m=m+(Ha*Ha+s*s+v*v+z*z);g=g+16|0;if(g>>>0>=l>>>0)break;else j=j+32|0}}else m=0.0;g=n+(q<<2)|0;if(g>>>0<t>>>0)while(1){Ha=+o[g>>2]-+p[h>>3];g=g+4|0;m=m+Ha*Ha;if(g>>>0>=t>>>0)break;else h=h+8|0}B=oa+(C<<2)|0;k[B>>2]=0;if(G){q=D+((aa(k[E>>2]|0,k[u>>2]|0)|0)<<2)|0;t=q+(k[va>>2]<<2)|0;u=t+-12|0;w=((u>>>0<q>>>0?q:u)+12+(3-q)|0)>>>4<<2;x=q>>>0<u>>>0;A=q+(w<<2)|0;y=A>>>0<t>>>0;n=1;h=0;do{g=F+((aa(K,n)|0)<<3)|0;j=g+(w<<3)|0;if(x){l=q;s=0.0;while(1){Ia=+o[l>>2]-+p[g>>3];v=+o[l+4>>2]-+p[g+8>>3];z=+o[l+8>>2]-+p[g+16>>3];Ha=+o[l+12>>2]-+p[g+24>>3];s=s+(Ia*Ia+v*v+z*z+Ha*Ha);l=l+16|0;if(l>>>0>=u>>>0)break;else g=g+32|0}}else s=0.0;if(y){g=A;while(1){Ia=+o[g>>2]-+p[j>>3];g=g+4|0;s=s+Ia*Ia;if(g>>>0>=t>>>0)break;else j=j+8|0}}if(m>s){k[B>>2]=n;m=s;h=n}n=n+1|0}while((n|0)!=(e|0))}else h=0;g=H+(h<<2)|0;if(m>+o[g>>2])o[g>>2]=m;la=ra+(h<<2)|0;k[la>>2]=(k[la>>2]|0)+1;C=C+1|0}while((C|0)!=(d|0));la=E}else la=a+36|0;i[Y>>0]=0;I=a+16|0;J=a+28|0;K=_+8|0;L=_+12|0;M=_+16|0;N=_+20|0;O=_+24|0;P=_+28|0;R=_+32|0;S=_+36|0;T=_+40|0;U=_+44|0;V=$+4|0;H=0;do{if((H|0)>=(k[I>>2]|0))break;i[Y>>0]=1;H=H+1|0;if(ka){g=0;do{G=(k[W>>2]|0)+((aa(k[X>>2]|0,g)|0)<<3)|0;zpb(G|0,0,k[va>>2]<<3|0)|0;o[(k[Aa>>2]|0)+(g<<2)>>2]=0.0;g=g+1|0}while((g|0)!=(e|0))}if(ma?(ba=k[na>>2]|0,ca=k[la>>2]|0,da=k[W>>2]|0,ea=k[X>>2]|0,fa=k[va>>2]|0,fa|0):0){h=0;do{j=ba+((aa(ca,k[c+(h<<2)>>2]|0)|0)<<2)|0;l=da+((aa(ea,k[oa+(h<<2)>>2]|0)|0)<<3)|0;g=0;do{G=l+(g<<3)|0;p[G>>3]=+p[G>>3]+ +o[j+(g<<2)>>2];g=g+1|0}while((g|0)!=(fa|0));h=h+1|0}while((h|0)!=(d|0))}if(ka?(ga=k[va>>2]|0,ha=k[W>>2]|0,ia=k[X>>2]|0,ga|0):0){h=0;do{m=+(k[ra+(h<<2)>>2]|0);j=ha+((aa(ia,h)|0)<<3)|0;g=0;do{G=j+(g<<3)|0;p[G>>3]=+p[G>>3]/m;g=g+1|0}while((g|0)!=(ga|0));h=h+1|0}while((h|0)!=(e|0))}m9(Z);G=k[va>>2]|0;k[_>>2]=94368;k[K>>2]=J;k[L>>2]=e;k[M>>2]=c;k[N>>2]=ja;k[O>>2]=G;k[P>>2]=ra;k[R>>2]=oa;k[S>>2]=Aa;k[T>>2]=Y;k[U>>2]=Z;k[$>>2]=0;k[V>>2]=d;sNa(_,$);if(ka){y=k[W>>2]|0;A=k[Aa>>2]|0;B=k[X>>2]|0;w=0;do{C=ra+(w<<2)|0;if(!(k[C>>2]|0)){x=w;do{x=(x+1|0)%(e|0)|0;D=ra+(x<<2)|0}while((k[D>>2]|0)<2);a:do if(ma){E=y+((aa(B,x)|0)<<3)|0;F=A+(x<<2)|0;u=0;while(1){G=oa+(u<<2)|0;if((k[G>>2]|0)==(x|0)){n=(k[na>>2]|0)+((aa(k[la>>2]|0,k[c+(u<<2)>>2]|0)|0)<<2)|0;t=n+(k[va>>2]<<2)|0;l=t+-12|0;q=((l>>>0<n>>>0?n:l)+12+(3-n)|0)>>>4<<2;h=E+(q<<3)|0;if(n>>>0<l>>>0){g=n;j=E;m=0.0;while(1){v=+o[g>>2]-+p[j>>3];z=+o[g+4>>2]-+p[j+8>>3];Ha=+o[g+8>>2]-+p[j+16>>3];Ia=+o[g+12>>2]-+p[j+24>>3];m=m+(v*v+z*z+Ha*Ha+Ia*Ia);g=g+16|0;if(g>>>0>=l>>>0)break;else j=j+32|0}}else m=0.0;g=n+(q<<2)|0;if(g>>>0<t>>>0)while(1){Ia=+o[g>>2]-+p[h>>3];g=g+4|0;m=m+Ia*Ia;if(g>>>0>=t>>>0)break;else h=h+8|0}if(m==+o[F>>2])break}u=u+1|0;if((u|0)>=(d|0))break a}k[G>>2]=w;k[D>>2]=(k[D>>2]|0)+-1;k[C>>2]=(k[C>>2]|0)+1}while(0);i[Y>>0]=0}w=w+1|0}while((w|0)!=(e|0))}F=(k[Z>>2]|0)+28|0;G=k[F>>2]|0;k[F>>2]=G+-1;do if((G|0)==1){g=k[Z>>2]|0;if(!g)break;rf(g|0)|0;ggb(g)}while(0)}while(!(i[Y>>0]|0));h=e>>>0>1073741823?-1:e<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0){J=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){J=0;break}Qh[g&7]()}if(ka){u=a+100|0;t=k[W>>2]|0;q=k[X>>2]|0;n=k[va>>2]|0;l=0;g=n;do{j=g>>>0>1073741823?-1:g<<2;j=(j|0)==0?1:j;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[J+(l<<2)>>2]=h;k[u>>2]=(k[u>>2]|0)+(g<<2);if(!g)g=0;else{j=t+((aa(q,l)|0)<<3)|0;g=0;do{o[h+(g<<2)>>2]=+p[j+(g<<3)>>3];g=g+1|0}while(g>>>0<n>>>0);g=n}l=l+1|0}while((l|0)!=(e|0))}l=(e<<2)+15&-16;I=a+76|0;h=k[I>>2]|0;b:do if((l|0)>(h|0)){g=a+96|0;k[g>>2]=(k[g>>2]|0)+h;g=(l|4)+15|0;g=g>>>0>8192?g:8192;h=fgb(g)|0;if(h|0){ya=a+80|0;k[h>>2]=k[ya>>2];k[ya>>2]=h;ya=g+-4|0;k[I>>2]=ya;g=h+4|0;j=a+84|0;k[j>>2]=g;h=ya;ya=134;break}g=k[41482]|0;h=(g|0)==0;if((k[41497]|0)>-1){do if(h){g=i[165986]|0;i[165986]=g+255|g;g=k[41478]|0;if(!(g&8)){k[41480]=0;k[41479]=0;h=k[41489]|0;k[41485]=h;k[41483]=h;g=h+(k[41490]|0)|0;k[41482]=g;break}else{k[41478]=g|32;g=0;break b}}else h=k[41483]|0;while(0);if((g-h|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;g=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){g=0;break}g=0;j=373857;h=k[41483]|0}else{g=27;j=373830}upb(h|0,j|0,g|0)|0;k[41483]=(k[41483]|0)+g;g=0;break}else{do if(h){g=i[165986]|0;i[165986]=g+255|g;g=k[41478]|0;if(!(g&8)){k[41480]=0;k[41479]=0;h=k[41489]|0;k[41485]=h;k[41483]=h;g=h+(k[41490]|0)|0;k[41482]=g;break}else{k[41478]=g|32;g=0;break b}}else h=k[41483]|0;while(0);if((g-h|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;g=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){g=0;break}g=0;j=373857;h=k[41483]|0}else{g=27;j=373830}upb(h|0,j|0,g|0)|0;k[41483]=(k[41483]|0)+g;g=0;break}}else{g=a+84|0;j=g;g=k[g>>2]|0;ya=134}while(0);if((ya|0)==134){k[j>>2]=g+l;k[I>>2]=h-l;ja=a+92|0;k[ja>>2]=(k[ja>>2]|0)+l}H=b+20|0;k[H>>2]=g;if(ka){E=a+96|0;F=a+80|0;G=a+84|0;C=f+1|0;D=a+92|0;A=0;B=0;while(1){y=k[ra+(A<<2)>>2]|0;if(ma){x=0;m=0.0;s=0.0;g=B;do{t=oa+(x<<2)|0;if((k[t>>2]|0)==(A|0)){u=c+(x<<2)|0;w=k[u>>2]|0;l=(k[na>>2]|0)+((aa(k[la>>2]|0,w)|0)<<2)|0;q=l+(k[va>>2]<<2)|0;j=q+-12|0;n=((j>>>0<l>>>0?l:j)+12+(3-l)|0)>>>4<<2;if(l>>>0<j>>>0){h=l;v=0.0;do{Ja=+o[h>>2];z=+o[h+4>>2];Ha=+o[h+8>>2];Ia=+o[h+12>>2];v=v+(Ja*Ja+z*z+Ha*Ha+Ia*Ia);h=h+16|0}while(h>>>0<j>>>0)}else v=0.0;h=l+(n<<2)|0;if(h>>>0<q>>>0)do{Ja=+o[h>>2];h=h+4|0;v=v+Ja*Ja}while(h>>>0<q>>>0);m=m+ +Q(+v);f=c+(g<<2)|0;k[u>>2]=k[f>>2];k[f>>2]=w;f=oa+(g<<2)|0;b=k[t>>2]|0;k[t>>2]=k[f>>2];k[f>>2]=b;s=s+v;g=g+1|0}x=x+1|0}while((x|0)!=(d|0));t=g}else{m=0.0;s=0.0;t=B}z=+(y|0);v=m/z;j=k[J+(A<<2)>>2]|0;n=j+(k[va>>2]<<2)|0;h=n+-12|0;q=j;l=((h>>>0<j>>>0?j:h)+12+(3-q)|0)>>>4<<2;if(j>>>0<h>>>0){g=j;m=0.0;do{Ka=+o[g>>2];Ha=+o[g+4>>2];Ia=+o[g+8>>2];Ja=+o[g+12>>2];m=m+(Ka*Ka+Ha*Ha+Ia*Ia+Ja*Ja);g=g+16|0}while(g>>>0<h>>>0)}else m=0.0;g=j+(l<<2)|0;if(g>>>0<n>>>0)do{Ka=+o[g>>2];g=g+4|0;m=m+Ka*Ka}while(g>>>0<n>>>0);h=k[I>>2]|0;c:do if((h|0)<32){k[E>>2]=(k[E>>2]|0)+h;g=fgb(8192)|0;if(g|0){k[g>>2]=k[F>>2];k[F>>2]=g;k[I>>2]=8188;g=g+4|0;k[G>>2]=g;h=8188;ya=196;break}g=k[41482]|0;h=(g|0)==0;if((k[41497]|0)>-1){do if(h){g=i[165986]|0;i[165986]=g+255|g;g=k[41478]|0;if(!(g&8)){k[41480]=0;k[41479]=0;h=k[41489]|0;k[41485]=h;k[41483]=h;g=h+(k[41490]|0)|0;k[41482]=g;break}else{k[41478]=g|32;g=0;break c}}else h=k[41483]|0;while(0);if((g-h|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;g=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){g=0;break}g=0;j=373857;h=k[41483]|0}else{g=27;j=373830}upb(h|0,j|0,g|0)|0;k[41483]=(k[41483]|0)+g;g=0;break}else{do if(h){g=i[165986]|0;i[165986]=g+255|g;g=k[41478]|0;if(!(g&8)){k[41480]=0;k[41479]=0;h=k[41489]|0;k[41485]=h;k[41483]=h;g=h+(k[41490]|0)|0;k[41482]=g;break}else{k[41478]=g|32;g=0;break c}}else h=k[41483]|0;while(0);if((g-h|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;g=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){g=0;break}g=0;j=373857;h=k[41483]|0}else{g=27;j=373830}upb(h|0,j|0,g|0)|0;k[41483]=(k[41483]|0)+g;g=0;break}}else{g=k[G>>2]|0;ya=196}while(0);if((ya|0)==196){ya=0;k[G>>2]=g+32;k[I>>2]=h+-32;k[D>>2]=(k[D>>2]|0)+32}k[(k[H>>2]|0)+(A<<2)>>2]=g;f=k[(k[H>>2]|0)+(A<<2)>>2]|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[f+28>>2]=0;f=(k[H>>2]|0)+(A<<2)|0;b=k[f>>2]|0;k[b+4>>2]=k[(k[Aa>>2]|0)+(A<<2)>>2];k[b>>2]=q;f=k[f>>2]|0;o[f+12>>2]=s/z-m;o[f+8>>2]=v;qNa(a,f,c+(B<<2)|0,t-B|0,e,C);A=A+1|0;if((A|0)>=(e|0))break;else B=t}}g=k[za>>2]|0;if((g|0)!=(pa|0)){if(g|0)ggb(g);k[za>>2]=pa;k[qa>>2]=264}g=k[Ba>>2]|0;if((g|0)!=(ta|0)){if(g|0)ggb(g);k[Ba>>2]=ta;k[sa>>2]=264}g=k[Aa>>2]|0;h=g;if(g|0){j=k[ua>>2]|0;if((j|0)!=(g|0))k[ua>>2]=j+(~((j+-4-h|0)>>>2)<<2);ggb(g)}g=k[Ca>>2]|0;if((g|0)!=(wa|0)){if(g|0)ggb(g);k[Ca>>2]=wa;k[xa>>2]=136}}else{k[b+24>>2]=c;Dgb(c,c+(d<<2)|0);k[b+20>>2]=0}g=k[Fa>>2]|0;if((g|0)!=(Da|0)){if(g|0)ggb(g);k[Fa>>2]=Da;k[Ea>>2]=264}r=Ga;return}function rNa(a){a=a|0;ggb(a);return}function sNa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0.0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0;c=k[b>>2]|0;B=k[b+4>>2]|0;if((c|0)>=(B|0))return;C=a+8|0;D=a+16|0;E=a+20|0;F=a+24|0;w=a+12|0;x=a+36|0;y=a+32|0;z=a+28|0;A=a+44|0;v=a+40|0;do{l=k[C>>2]|0;l=(k[l+12>>2]|0)+((aa(k[l+8>>2]|0,k[(k[D>>2]|0)+(c<<2)>>2]|0)|0)<<2)|0;g=k[E>>2]|0;s=k[g+12>>2]|0;t=l+(k[F>>2]<<2)|0;m=t+-12|0;u=((m>>>0<l>>>0?l:m)+12+(3-l)|0)>>>4<<2;e=s+(u<<3)|0;h=l>>>0<m>>>0;if(h){b=l;a=s;d=0.0;while(1){I=+o[b>>2]-+p[a>>3];H=+o[b+4>>2]-+p[a+8>>3];G=+o[b+8>>2]-+p[a+16>>3];f=+o[b+12>>2]-+p[a+24>>3];d=d+(I*I+H*H+G*G+f*f);b=b+16|0;if(b>>>0>=m>>>0)break;else a=a+32|0}}else d=0.0;r=l+(u<<2)|0;q=r>>>0<t>>>0;if(q){a=e;b=r;while(1){I=+o[b>>2]-+p[a>>3];b=b+4|0;d=d+I*I;if(b>>>0>=t>>>0)break;else a=a+8|0}}n=k[w>>2]|0;a:do if((n|0)>1){j=k[g+8>>2]|0;if(h){h=1;e=0}else{g=1;e=0;while(1){if(q){b=s+((aa(j,g)|0)<<3)+(u<<3)|0;f=0.0;a=r;while(1){I=+o[a>>2]-+p[b>>3];a=a+4|0;f=f+I*I;if(a>>>0>=t>>>0)break;else b=b+8|0}}else f=0.0;m=d>f;d=m?f:d;e=m?g:e;g=g+1|0;if((g|0)==(n|0))break a}}do{g=s+((aa(j,h)|0)<<3)|0;b=l;a=g;f=0.0;while(1){J=+o[b>>2]-+p[a>>3];G=+o[b+4>>2]-+p[a+8>>3];H=+o[b+8>>2]-+p[a+16>>3];I=+o[b+12>>2]-+p[a+24>>3];f=f+(J*J+G*G+H*H+I*I);b=b+16|0;if(b>>>0>=m>>>0)break;else a=a+32|0}if(q){a=g+(u<<3)|0;b=r;while(1){J=+o[b>>2]-+p[a>>3];b=b+4|0;f=f+J*J;if(b>>>0>=t>>>0)break;else a=a+8|0}}g=d>f;d=g?f:d;e=g?h:e;h=h+1|0}while((h|0)!=(n|0))}else e=0;while(0);b=(k[k[x>>2]>>2]|0)+(e<<2)|0;if(d>+o[b>>2])o[b>>2]=d;b=(k[y>>2]|0)+(c<<2)|0;a=k[b>>2]|0;if((e|0)!=(a|0)){u=k[z>>2]|0;t=u+(a<<2)|0;k[t>>2]=(k[t>>2]|0)+-1;u=u+(e<<2)|0;k[u>>2]=(k[u>>2]|0)+1;k[b>>2]=e;mpb(k[k[A>>2]>>2]|0)|0;i[k[v>>2]>>0]=0;lpb(k[k[A>>2]>>2]|0)|0}c=c+1|0}while((c|0)!=(B|0));return}function tNa(a){a=a|0;var b=0;k[a>>2]=94388;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);b=k[a+4>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);YHa(k[a+16>>2]|0);return}function uNa(a){a=a|0;var b=0;k[a>>2]=94388;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);b=k[a+4>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);YHa(k[a+16>>2]|0);ggb(a);return}function vNa(a){a=a|0;var b=0,c=0;b=r;r=r+16|0;IJa(375452,b);c=k[a+4>>2]|0;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);IJa(375477,b+8|0);a=k[a+8>>2]|0;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);r=b;return}function wNa(a,b){a=a|0;b=b|0;var c=0;c=k[a+4>>2]|0;jh[k[(k[c>>2]|0)+20>>2]&1023](c,b);a=k[a+8>>2]|0;jh[k[(k[a>>2]|0)+20>>2]&1023](a,b);return}function xNa(a,b){a=a|0;b=b|0;var c=0;c=k[a+4>>2]|0;jh[k[(k[c>>2]|0)+24>>2]&1023](c,b);a=k[a+8>>2]|0;jh[k[(k[a>>2]|0)+24>>2]&1023](a,b);return}function yNa(a){a=a|0;a=k[a+8>>2]|0;return Xh[k[(k[a>>2]|0)+28>>2]&1023](a)|0}function zNa(a){a=a|0;a=k[a+8>>2]|0;return Xh[k[(k[a>>2]|0)+32>>2]&1023](a)|0}function ANa(a){a=a|0;var b=0;b=k[a+4>>2]|0;b=Xh[k[(k[b>>2]|0)+36>>2]&1023](b)|0;a=k[a+8>>2]|0;return (Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0)+b|0}function BNa(a){a=a|0;return 3}function CNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+12>>2]|0;f=b+16|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function DNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=k[a+4>>2]|0;dh[k[(k[e>>2]|0)+48>>2]&255](e,b,c,d);a=k[a+8>>2]|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,b,c,d);return}function ENa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0;G=r;r=r+32|0;F=G;$Ia(F,d);a:do if((b|0)>0){E=F+16|0;g=k[F>>2]|0;C=a+40|0;D=a+36|0;B=a+32|0;A=k[F+12>>2]|0;a=k[E>>2]|0;d=0;b:while(1){y=e+(d<<2)|0;z=(d|0)>0;if((a|0)==(A|0)){l=23;break a}while(1){h=a;a=a+1|0;h=k[g+(h<<2)>>2]|0;if((h|0)<0){l=6;break b}h=k[c+(h<<2)>>2]|0;k[y>>2]=h;if(!z)break;w=k[C>>2]|0;x=k[D>>2]|0;p=w+((aa(x,h)|0)<<2)|0;t=p+(k[B>>2]<<2)|0;q=t+-12|0;u=((q>>>0<p>>>0?p:q)+12+(3-p)|0)>>>4<<2;v=p+(u<<2)|0;s=v>>>0<t>>>0;if(p>>>0>=q>>>0){if(s){m=0;h=0;do{i=w+((aa(k[e+(m<<2)>>2]|0,x)|0)<<2)+(u<<2)|0;j=0.0;l=v;while(1){H=+o[l>>2]-+o[i>>2];l=l+4|0;j=j+H*H;if(l>>>0>=t>>>0)break;else i=i+4|0}h=j<1.0e-16?1:h;m=m+1|0}while((m|0)!=(d|0));i=h;l=19}}else{n=0;h=0;do{m=w+((aa(k[e+(n<<2)>>2]|0,x)|0)<<2)|0;i=p;l=m;j=0.0;while(1){K=+o[i>>2]-+o[l>>2];J=+o[i+4>>2]-+o[l+4>>2];I=+o[i+8>>2]-+o[l+8>>2];H=+o[i+12>>2]-+o[l+12>>2];j=j+(K*K+J*J+I*I+H*H);i=i+16|0;if(i>>>0>=q>>>0)break;else l=l+16|0}if(s){l=m+(u<<2)|0;i=v;while(1){K=+o[i>>2]-+o[l>>2];i=i+4|0;j=j+K*K;if(i>>>0>=t>>>0)break;else l=l+4|0}}h=j<1.0e-16?1:h;n=n+1|0}while((n|0)!=(d|0));i=h;l=19}if((l|0)==19?(l=0,(i&1)==0):0)break;if((a|0)==(A|0)){l=22;break b}}k[E>>2]=a;d=d+1|0;if((d|0)>=(b|0)){l=23;break a}}if((l|0)==6){k[E>>2]=a;k[f>>2]=d;break}else if((l|0)==22){k[E>>2]=A;l=23;break}}else{d=0;g=k[F>>2]|0;l=23}while(0);if((l|0)==23){k[f>>2]=d;if(!g){r=G;return}}d=F+4|0;a=k[d>>2]|0;if((a|0)!=(g|0))k[d>>2]=a+(~((a+-4-g|0)>>>2)<<2);ggb(g);r=G;return}function FNa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0.0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,O=0.0,P=0.0;J=428e3;J=Epb(k[J>>2]|0,k[J+4>>2]|0,1284865837,1481765933)|0;J=kpb(J|0,N|0,1,0)|0;K=N;I=428e3;k[I>>2]=J;k[I+4>>2]=K;K=ppb(J|0,K|0,33)|0;k[e>>2]=k[c+(~~(+(d|0)*(+(K|0)*4.656612873077393e-10))<<2)>>2];if((b|0)<=1){e=1;k[f>>2]=e;return}I=(d|0)>0;J=a+40|0;K=a+36|0;H=a+32|0;a=1;while(1){if(!I){a=1;g=18;break}w=k[J>>2]|0;x=k[K>>2]|0;y=w+((aa(x,k[e>>2]|0)|0)<<2)|0;z=k[H>>2]|0;A=y+(z<<2)|0;B=A+-12|0;C=((B>>>0<y>>>0?y:B)+12+(3-y)|0)>>>4<<2;D=y>>>0<B>>>0;G=y+(C<<2)|0;E=G>>>0<A>>>0;F=(a|0)>1;t=0;u=0.0;v=-1;while(1){s=w+((aa(k[c+(t<<2)>>2]|0,x)|0)<<2)|0;l=s+(C<<2)|0;if(D){g=y;j=s;h=0.0;while(1){O=+o[g>>2]-+o[j>>2];M=+o[g+4>>2]-+o[j+4>>2];L=+o[g+8>>2]-+o[j+8>>2];i=+o[g+12>>2]-+o[j+12>>2];h=h+(O*O+M*M+L*L+i*i);g=g+16|0;if(g>>>0>=B>>>0)break;else j=j+16|0}}else h=0.0;if(E){j=l;g=G;while(1){O=+o[g>>2]-+o[j>>2];g=g+4|0;h=h+O*O;if(g>>>0>=A>>>0)break;else j=j+4|0}}if(F){r=1;do{p=w+((aa(x,k[e+(r<<2)>>2]|0)|0)<<2)|0;q=p+(z<<2)|0;m=q+-12|0;n=((m>>>0<p>>>0?p:m)+12+(3-p)|0)>>>4<<2;j=s+(n<<2)|0;if(p>>>0<m>>>0){g=p;l=s;i=0.0;while(1){P=+o[g>>2]-+o[l>>2];L=+o[g+4>>2]-+o[l+4>>2];M=+o[g+8>>2]-+o[l+8>>2];O=+o[g+12>>2]-+o[l+12>>2];i=i+(P*P+L*L+M*M+O*O);g=g+16|0;if(g>>>0>=m>>>0)break;else l=l+16|0}}else i=0.0;g=p+(n<<2)|0;if(g>>>0<q>>>0)while(1){P=+o[g>>2]-+o[j>>2];g=g+4|0;i=i+P*P;if(g>>>0>=q>>>0)break;else j=j+4|0}h=i<h?i:h;r=r+1|0}while((r|0)!=(a|0))}g=h>u;v=g?t:v;t=t+1|0;if((t|0)==(d|0))break;else u=g?h:u}if((v|0)==-1){g=18;break}k[e+(a<<2)>>2]=k[c+(v<<2)>>2];a=a+1|0;if((a|0)>=(b|0)){g=18;break}}if((g|0)==18){k[f>>2]=a;return}}function GNa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0.0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,O=0.0,P=0.0;K=r;r=r+16|0;J=K;h=d>>>0>1073741823?-1:d<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}y=428e3;y=Epb(k[y>>2]|0,k[y+4>>2]|0,1284865837,1481765933)|0;y=kpb(y|0,N|0,1,0)|0;z=N;h=428e3;k[h>>2]=y;k[h+4>>2]=z;h=ppb(y|0,z|0,33)|0;h=c+(~~(+(d|0)*(+(h|0)*4.656612873077393e-10))<<2)|0;k[e>>2]=k[h>>2];I=(d|0)>0;if(I){w=k[a+40>>2]|0;x=k[a+36>>2]|0;u=w+((aa(k[h>>2]|0,x)|0)<<2)|0;v=k[a+32>>2]|0;t=0;i=0.0;do{p=w+((aa(x,k[c+(t<<2)>>2]|0)|0)<<2)|0;s=p+(v<<2)|0;n=s+-12|0;q=((n>>>0<p>>>0?p:n)+12+(3-p)|0)>>>4<<2;l=u+(q<<2)|0;if(p>>>0<n>>>0){h=p;m=u;j=0.0;while(1){P=+o[h>>2]-+o[m>>2];O=+o[h+4>>2]-+o[m+4>>2];M=+o[h+8>>2]-+o[m+8>>2];L=+o[h+12>>2]-+o[m+12>>2];j=j+(P*P+O*O+M*M+L*L);h=h+16|0;if(h>>>0>=n>>>0)break;else m=m+16|0}}else j=0.0;h=p+(q<<2)|0;if(h>>>0<s>>>0)while(1){P=+o[h>>2]-+o[l>>2];h=h+4|0;j=j+P*P;if(h>>>0>=s>>>0)break;else l=l+4|0}o[g+(t<<2)>>2]=j;i=i+j;t=t+1|0}while((t|0)!=(d|0))}else i=0.0;if((b|0)<=1){J=1;k[f>>2]=J;ggb(g);r=K;return}E=d+-1|0;F=(d|0)>1;G=a+40|0;H=a+36|0;D=a+32|0;C=1;B=y;do{y=Epb(B|0,z|0,1284865837,1481765933)|0;B=kpb(y|0,N|0,1,0)|0;z=N;a:do if(F){y=ppb(B|0,z|0,33)|0;h=0;i=i*(+(y|0)*4.656612873077393e-10)+0.0;while(1){j=+o[g+(h<<2)>>2];if(i<=j)break;h=h+1|0;if((h|0)<(E|0))i=i-j;else break}if(!I){k[e+(C<<2)>>2]=k[c+(h<<2)>>2];i=0.0;break}y=k[G>>2]|0;w=k[H>>2]|0;l=k[c+(h<<2)>>2]|0;a=y+((aa(l,w)|0)<<2)|0;x=k[D>>2]|0;v=0;i=0.0;do{s=y+((aa(w,k[c+(v<<2)>>2]|0)|0)<<2)|0;u=s+(x<<2)|0;q=u+-12|0;t=((q>>>0<s>>>0?s:q)+12+(3-s)|0)>>>4<<2;n=a+(t<<2)|0;if(s>>>0<q>>>0){m=s;p=a;j=0.0;while(1){L=+o[m>>2]-+o[p>>2];M=+o[m+4>>2]-+o[p+4>>2];O=+o[m+8>>2]-+o[p+8>>2];P=+o[m+12>>2]-+o[p+12>>2];j=j+(L*L+M*M+O*O+P*P);m=m+16|0;if(m>>>0>=q>>>0)break;else p=p+16|0}}else j=0.0;m=s+(t<<2)|0;if(m>>>0<u>>>0)while(1){P=+o[m>>2]-+o[n>>2];m=m+4|0;j=j+P*P;if(m>>>0>=u>>>0)break;else n=n+4|0}P=+o[g+(v<<2)>>2];i=i+(P<j?P:j);v=v+1|0}while((v|0)!=(d|0));x=y;A=28}else{if(!I){k[e+(C<<2)>>2]=k[c>>2];i=0.0;break}x=k[G>>2]|0;v=k[H>>2]|0;l=k[c>>2]|0;w=x+((aa(l,v)|0)<<2)|0;a=k[D>>2]|0;u=0;i=0.0;h=l;while(1){q=x+((aa(v,h)|0)<<2)|0;t=q+(a<<2)|0;p=t+-12|0;s=((p>>>0<q>>>0?q:p)+12+(3-q)|0)>>>4<<2;m=w+(s<<2)|0;if(q>>>0<p>>>0){h=q;n=w;j=0.0;while(1){L=+o[h>>2]-+o[n>>2];M=+o[h+4>>2]-+o[n+4>>2];O=+o[h+8>>2]-+o[n+8>>2];P=+o[h+12>>2]-+o[n+12>>2];j=j+(L*L+M*M+O*O+P*P);h=h+16|0;if(h>>>0>=p>>>0)break;else n=n+16|0}}else j=0.0;h=q+(s<<2)|0;if(h>>>0<t>>>0)while(1){P=+o[h>>2]-+o[m>>2];h=h+4|0;j=j+P*P;if(h>>>0>=t>>>0)break;else m=m+4|0}P=+o[g+(u<<2)>>2];i=i+(P<j?P:j);h=u+1|0;if((h|0)==(d|0)){h=0;A=28;break a}u=h;h=k[c+(h<<2)>>2]|0}}while(0);if((A|0)==28){A=0;k[e+(C<<2)>>2]=l;if(I){w=k[H>>2]|0;u=x+((aa(k[c+(h<<2)>>2]|0,w)|0)<<2)|0;v=k[D>>2]|0;t=0;do{p=x+((aa(w,k[c+(t<<2)>>2]|0)|0)<<2)|0;s=p+(v<<2)|0;n=s+-12|0;q=((n>>>0<p>>>0?p:n)+12+(3-p)|0)>>>4<<2;l=u+(q<<2)|0;if(p>>>0<n>>>0){h=p;m=u;j=0.0;while(1){L=+o[h>>2]-+o[m>>2];M=+o[h+4>>2]-+o[m+4>>2];O=+o[h+8>>2]-+o[m+8>>2];P=+o[h+12>>2]-+o[m+12>>2];j=j+(L*L+M*M+O*O+P*P);h=h+16|0;if(h>>>0>=n>>>0)break;else m=m+16|0}}else j=0.0;h=p+(q<<2)|0;if(h>>>0<s>>>0)while(1){P=+o[h>>2]-+o[l>>2];h=h+4|0;j=j+P*P;if(h>>>0>=s>>>0)break;else l=l+4|0}o[J>>2]=j;y=g+(t<<2)|0;k[y>>2]=k[(+o[y>>2]<j?y:J)>>2];t=t+1|0}while((t|0)!=(d|0))}}C=C+1|0}while((C|0)!=(b|0));J=428e3;k[J>>2]=B;k[J+4>>2]=z;J=b;k[f>>2]=J;ggb(g);r=K;return}function HNa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=94448;if(i[a+36>>0]|0?(b=k[a+64>>2]|0,b|0):0)ggb(b);c=a+96|0;b=k[c>>2]|0;if(b|0)do{e=b;b=k[b>>2]|0;ggb(e);k[c>>2]=b}while((b|0)!=0);b=k[a+80>>2]|0;c=b;if(b|0){d=a+84|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}b=k[a+40>>2]|0;if(!b){a=a+24|0;a=k[a>>2]|0;YHa(a);return}c=a+44|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);ggb(b);a=a+24|0;a=k[a>>2]|0;YHa(a);return}function INa(a){a=a|0;HNa(a);ggb(a);return}function JNa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0,p=0,q=0;p=a+80|0;q=a+72|0;e=k[q>>2]|0;f=a+84|0;c=k[f>>2]|0;b=k[p>>2]|0;g=c-b>>3;if(e>>>0<=g>>>0)if(e>>>0<g>>>0?(d=b+(e<<3)|0,(c|0)!=(d|0)):0){k[f>>2]=c+(~((c+-8-d|0)>>>3)<<3);m=e}else m=e;else{VNa(p,e-g|0);m=k[q>>2]|0}e=(m|0)==0;if(!e){c=k[a+16>>2]|0;d=k[p>>2]|0;b=0;do{j=c+(b<<2)|0;k[d+(b<<3)>>2]=k[j>>2];k[d+(b<<3)+4>>2]=k[j>>2];b=b+1|0}while((b|0)!=(m|0))}j=k[a+4>>2]|0;if(j>>>0>1?(n=k[p>>2]|0,!e):0){f=k[a+16>>2]|0;g=k[a+12>>2]|0;d=1;do{h=f+((aa(g,d)|0)<<2)|0;e=0;do{b=h+(e<<2)|0;l=+o[b>>2];c=n+(e<<3)|0;if(l<+o[c>>2]){o[c>>2]=l;l=+o[b>>2]}b=n+(e<<3)+4|0;if(l>+o[b>>2])o[b>>2]=l;e=e+1|0}while((e|0)!=(m|0));d=d+1|0}while((d|0)!=(j|0))}c=a+68|0;p=XNa(a,0,k[c>>2]|0,p)|0;k[a+76>>2]=p;if(!(i[a+36>>0]|0)){q=a+52|0;a=a+4|0;k[q>>2]=k[a>>2];k[q+4>>2]=k[a+4>>2];k[q+8>>2]=k[a+8>>2];k[q+12>>2]=k[a+12>>2];return}d=a+64|0;b=k[d>>2]|0;if(b|0)ggb(b);n=k[c>>2]|0;m=k[q>>2]|0;c=aa(m,n)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[a+52>>2]=n;k[a+56>>2]=m;k[a+60>>2]=m;k[d>>2]=b;if((n|0)==0|(m|0)==0)return;h=k[a+40>>2]|0;j=k[a+16>>2]|0;e=k[a+12>>2]|0;c=0;do{f=j+((aa(e,k[h+(c<<2)>>2]|0)|0)<<2)|0;g=b+((aa(m,c)|0)<<2)|0;d=0;do{k[g+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)!=(m|0));c=c+1|0}while((c|0)!=(n|0));return}function KNa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;v=r;r=r+32|0;s=v;k[s>>2]=93920;t=s+12|0;k[t>>2]=e;u=s+16|0;k[u>>2]=0;if(!(k[b>>2]|0)){r=v;return}q=c+12|0;n=c+8|0;p=d+12|0;g=d+8|0;h=s+4|0;i=s+8|0;j=s+20|0;l=b+12|0;m=b+8|0;c=0;d=e;while(1){w=(k[q>>2]|0)+((aa(k[n>>2]|0,c)|0)<<2)|0;e=(k[p>>2]|0)+((aa(k[g>>2]|0,c)|0)<<2)|0;k[h>>2]=w;k[i>>2]=e;k[u>>2]=0;o[j>>2]=3402823466385288598117041.0e14;o[e+(d+-1<<2)>>2]=3402823466385288598117041.0e14;e=(k[l>>2]|0)+((aa(k[m>>2]|0,c)|0)<<2)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,s,e,f);c=c+1|0;if(c>>>0>=(k[b>>2]|0)>>>0)break;d=k[t>>2]|0}r=v;return}function LNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+16|0;p=s;h=a+68|0;q=b+76|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[q>>2]|0)>-1){do if(d){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}b:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break b}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;n=k[b+44>>2]|0;k[b+28>>2]=n;g=b+20|0;k[g>>2]=n;d=n+(k[b+48>>2]|0)|0;k[e>>2]=d;e=n;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;d=c;g=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}c:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;d=h;break c}d=e+-1|0;if((i[h+d>>0]|0)==10)break;else e=d}if((ci[k[b+36>>2]&255](b,h,e)|0)>>>0<e>>>0)break a;f=4-e|0;d=h+e|0;c=k[g>>2]|0}else{f=4;d=h}while(0);upb(c|0,d|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f}while(0);h=a+72|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;d:do if((k[q>>2]|0)>-1){do if(d){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}e:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break e}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}f:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break f}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+80|0;k[p>>2]=(k[a+84>>2]|0)-(k[h>>2]|0)>>3;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;g:do if((k[q>>2]|0)>-1){do if(d){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,p,4)|0;break}h:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=p;c=f;break h}c=d+-1|0;if((i[p+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,p,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=p+d|0;c=k[g>>2]|0}else{e=4;d=p;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,p,4)|0;break}i:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=p;c=f;break i}c=d+-1|0;if((i[p+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,p,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=p+d|0;c=k[g>>2]|0}else{e=4;d=p;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);d=k[h>>2]|0;h=k[p>>2]<<3;f=b+16|0;c=k[f>>2]|0;e=(c|0)==0;j:do if((k[q>>2]|0)>-1){do if(e){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;n=k[b+44>>2]|0;k[b+28>>2]=n;g=b+20|0;k[g>>2]=n;e=n+(k[b+48>>2]|0)|0;k[f>>2]=e;f=n;break}else{k[b>>2]=c|32;break j}}else{f=b+20|0;e=c;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;break}k:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break k}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0)break j;e=h-f|0;d=d+f|0;c=k[g>>2]|0}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(e){c=b+74|0;n=i[c>>0]|0;i[c>>0]=n+255|n;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;n=k[b+44>>2]|0;k[b+28>>2]=n;g=b+20|0;k[g>>2]=n;e=n+(k[b+48>>2]|0)|0;k[f>>2]=e;f=n;break}else{k[b>>2]=c|32;break j}}else{f=b+20|0;e=c;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;break}l:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break l}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0)break j;e=h-f|0;d=d+f|0;c=k[g>>2]|0}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);n=a+36|0;l=i[n>>0]|0;m=l<<24>>24;h=i[b+75>>0]|0;c=h<<24>>24==l<<24>>24;do if((k[q>>2]|0)<0){if(!c){c=b+20|0;d=k[c>>2]|0;e=b+16|0;f=k[e>>2]|0;if(d>>>0<f>>>0){k[c>>2]=d+1;i[d>>0]=l;break}else c=f}else{c=b+16|0;e=c;c=k[c>>2]|0}i[p>>0]=l;do if(!c){c=b+74|0;d=j[c>>1]|0;h=(d&65535)<<24>>24;i[c>>0]=h+255|h;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;g=k[b+44>>2]|0;k[b+28>>2]=g;f=b+20|0;k[f>>2]=g;c=g+(k[b+48>>2]|0)|0;k[e>>2]=c;e=c;c=(d&65535)>>>8&255;o=119;break}else{k[b>>2]=c|32;break}}else{g=b+20|0;f=g;g=k[g>>2]|0;e=c;c=h;o=119}while(0);do if((o|0)==119){if(g>>>0<e>>>0?(m&255|0)!=(c<<24>>24|0):0){k[f>>2]=g+1;i[g>>0]=l;break}ci[k[b+36>>2]&255](b,p,1)|0}while(0)}else{if(!c){c=b+20|0;d=k[c>>2]|0;e=b+16|0;f=k[e>>2]|0;if(d>>>0<f>>>0){k[c>>2]=d+1;i[d>>0]=l;break}else c=f}else{c=b+16|0;e=c;c=k[c>>2]|0}i[p>>0]=l;do if(!c){c=b+74|0;d=j[c>>1]|0;h=(d&65535)<<24>>24;i[c>>0]=h+255|h;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;g=k[b+44>>2]|0;k[b+28>>2]=g;f=b+20|0;k[f>>2]=g;c=g+(k[b+48>>2]|0)|0;k[e>>2]=c;e=c;c=(d&65535)>>>8&255;o=133;break}else{k[b>>2]=c|32;break}}else{g=b+20|0;f=g;g=k[g>>2]|0;e=c;c=h;o=133}while(0);do if((o|0)==133){if(g>>>0<e>>>0?(m&255|0)!=(c<<24>>24|0):0){k[f>>2]=g+1;i[g>>0]=l;break}ci[k[b+36>>2]&255](b,p,1)|0}while(0)}while(0);h=a+32|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;m:do if((k[q>>2]|0)>-1){do if(d){c=b+74|0;o=i[c>>0]|0;i[c>>0]=o+255|o;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break m}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}n:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break n}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break m;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;o=i[c>>0]|0;i[c>>0]=o+255|o;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break m}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}o:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break o}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break m;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+40|0;k[p>>2]=(k[a+44>>2]|0)-(k[h>>2]|0)>>2;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;p:do if((k[q>>2]|0)>-1){do if(d){c=b+74|0;o=i[c>>0]|0;i[c>>0]=o+255|o;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break p}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,p,4)|0;break}q:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=p;c=f;break q}c=d+-1|0;if((i[p+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,p,d)|0)>>>0<d>>>0)break p;e=4-d|0;d=p+d|0;c=k[g>>2]|0}else{e=4;d=p;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;o=i[c>>0]|0;i[c>>0]=o+255|o;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break p}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,p,4)|0;break}r:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=p;c=f;break r}c=d+-1|0;if((i[p+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,p,d)|0)>>>0<d>>>0)break p;e=4-d|0;d=p+d|0;c=k[g>>2]|0}else{e=4;d=p;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);d=k[h>>2]|0;h=k[p>>2]<<2;f=b+16|0;c=k[f>>2]|0;e=(c|0)==0;s:do if((k[q>>2]|0)>-1){do if(e){c=b+74|0;p=i[c>>0]|0;i[c>>0]=p+255|p;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;p=k[b+44>>2]|0;k[b+28>>2]=p;g=b+20|0;k[g>>2]=p;e=p+(k[b+48>>2]|0)|0;k[f>>2]=e;f=p;break}else{k[b>>2]=c|32;break s}}else{f=b+20|0;e=c;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;break}t:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break t}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0)break s;e=h-f|0;d=d+f|0;c=k[g>>2]|0}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(e){c=b+74|0;p=i[c>>0]|0;i[c>>0]=p+255|p;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;p=k[b+44>>2]|0;k[b+28>>2]=p;g=b+20|0;k[g>>2]=p;e=p+(k[b+48>>2]|0)|0;k[f>>2]=e;f=p;break}else{k[b>>2]=c|32;break s}}else{f=b+20|0;e=c;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;break}u:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break u}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0)break s;e=h-f|0;d=d+f|0;c=k[g>>2]|0}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);if(!(i[n>>0]|0)){a=a+76|0;a=k[a>>2]|0;WNa(b,a);r=s;return}h=a+52|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;v:do if((k[q>>2]|0)>-1){do if(d){c=b+74|0;p=i[c>>0]|0;i[c>>0]=p+255|p;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break v}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<16){ci[k[b+36>>2]&255](b,h,16)|0;break}w:do if((i[b+75>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=h;c=f;break w}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break v;e=16-d|0;d=h+d|0;c=k[g>>2]|0}else{e=16;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;p=i[c>>0]|0;i[c>>0]=p+255|p;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break v}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<16){ci[k[b+36>>2]&255](b,h,16)|0;break}x:do if((i[b+75>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=h;c=f;break x}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break v;e=16-d|0;d=h+d|0;c=k[g>>2]|0}else{e=16;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);d=k[a+64>>2]|0;h=(aa(k[a+56>>2]|0,k[h>>2]|0)|0)<<2;f=b+16|0;e=k[f>>2]|0;c=(e|0)==0;if((k[q>>2]|0)>-1){do if(c){c=b+74|0;q=i[c>>0]|0;i[c>>0]=q+255|q;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;q=k[b+44>>2]|0;k[b+28>>2]=q;g=b+20|0;k[g>>2]=q;e=q+(k[b+48>>2]|0)|0;k[f>>2]=e;f=q;break}k[b>>2]=c|32;a=a+76|0;a=k[a>>2]|0;WNa(b,a);r=s;return}else{f=b+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;a=a+76|0;a=k[a>>2]|0;WNa(b,a);r=s;return}y:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break y}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0){a=a+76|0;a=k[a>>2]|0;WNa(b,a);r=s;return}else{e=h-f|0;d=d+f|0;c=k[g>>2]|0;break}}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e;a=a+76|0;a=k[a>>2]|0;WNa(b,a);r=s;return}else{do if(c){c=b+74|0;q=i[c>>0]|0;i[c>>0]=q+255|q;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;q=k[b+44>>2]|0;k[b+28>>2]=q;g=b+20|0;k[g>>2]=q;e=q+(k[b+48>>2]|0)|0;k[f>>2]=e;f=q;break}k[b>>2]=c|32;a=a+76|0;a=k[a>>2]|0;WNa(b,a);r=s;return}else{f=b+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<h>>>0){ci[k[b+36>>2]&255](b,d,h)|0;a=a+76|0;a=k[a>>2]|0;WNa(b,a);r=s;return}z:do if((i[b+75>>0]|0)>-1){f=h;while(1){if(!f){e=h;break z}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[b+36>>2]&255](b,d,f)|0)>>>0<f>>>0){a=a+76|0;a=k[a>>2]|0;WNa(b,a);r=s;return}else{e=h-f|0;d=d+f|0;c=k[g>>2]|0;break}}else e=h;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e;a=a+76|0;a=k[a>>2]|0;WNa(b,a);r=s;return}}function MNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o+8|0;m=o;if((_fb(a+68|0,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}if((_fb(a+72|0,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}d=a+80|0;if((_fb(n,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}l=k[n>>2]|0;e=a+84|0;h=k[e>>2]|0;c=k[d>>2]|0;f=h-c>>3;g=c;if(l>>>0<=f>>>0){if(l>>>0<f>>>0?(j=g+(l<<3)|0,(h|0)!=(j|0)):0)k[e>>2]=h+(~((h+-8-j|0)>>>3)<<3)}else{VNa(d,l-f|0);c=k[d>>2]|0}if((_fb(c,8,l,b)|0)!=(l|0)){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}l=a+36|0;if((_fb(l,1,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}j=a+32|0;if((_fb(j,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}eLa(b,a+40|0);c=a+52|0;if(!(i[l>>0]|0)){h=a+4|0;k[c>>2]=k[h>>2];k[c+4>>2]=k[h+4>>2];k[c+8>>2]=k[h+8>>2];k[c+12>>2]=k[h+12>>2]}else vIa(b,c);UNa(a,b,a+76|0);h=a+20|0;c=n+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373358;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));b=WHa(h,n)|0;g=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[m>>2]=g;g=k[b>>2]|0;a=b+4|0;jh[k[k[g>>2]>>2]&1023](g,a);k[b>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,m,a);k[c>>2]=0;k[n>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0);c=n+4|0;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=13;i[d+17>>0]=0;f=375545;g=e+13|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));a=WHa(h,n)|0;b=k[a>>2]|0;m=a+4|0;jh[k[k[b>>2]>>2]&1023](b,m);k[a>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,j,m);k[c>>2]=0;k[n>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0);m=n+4|0;c=ZT(12)|0;k[c>>2]=1;b=c+4|0;k[n>>2]=b;k[m>>2]=7;i[c+11>>0]=0;i[b>>0]=i[375559]|0;i[b+1>>0]=i[375560]|0;i[b+2>>0]=i[375561]|0;i[b+3>>0]=i[375562]|0;i[b+4>>0]=i[375563]|0;i[b+5>>0]=i[375564]|0;i[b+6>>0]=i[375565]|0;b=WHa(h,n)|0;j=k[b>>2]|0;a=b+4|0;jh[k[k[j>>2]>>2]&1023](j,a);k[b>>2]=428720;Ph[k[(k[107180]|0)+4>>2]&511](428720,l,a);k[m>>2]=0;k[n>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)!=1){r=o;return}ggb(k[c+-4>>2]|0);r=o;return}function NNa(a){a=a|0;return k[a+68>>2]|0}function ONa(a){a=a|0;return k[a+72>>2]|0}function PNa(a){a=a|0;return (k[a+112>>2]|0)+(k[a+108>>2]|0)+(k[a+4>>2]<<2)|0}function QNa(a){a=a|0;return 4}function RNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+20>>2]|0;f=b+24|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function SNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0.0,j=0.0,l=0,m=0,n=0.0,p=0,q=0,s=0;s=r;r=r+16|0;q=s;e=ZT(8)|0;k[e>>2]=1;p=e+4|0;i[e+7>>0]=0;i[p>>0]=i[374006]|0;i[p+1>>0]=i[374007]|0;i[p+2>>0]=i[374008]|0;o[q>>2]=0.0;n=+sJa(d,p,q);p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0);l=a+72|0;m=k[l>>2]|0;k[q>>2]=0;p=q+4|0;k[p>>2]=0;k[q+8>>2]=0;if(m){if(m>>>0>1073741823)ad(426534,426557,304,426811);e=m<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[p>>2]=d;k[q>>2]=d;k[q+8>>2]=d+(m<<2);e=m;g=d;while(1){k[g>>2]=0;e=e+-1|0;if(!e)break;else g=g+4|0}k[p>>2]=d+(m<<2);g=k[l>>2]|0;if(g){l=k[a+80>>2]|0;m=k[q>>2]|0;f=0.0;e=0;do{d=c+(e<<2)|0;j=+o[d>>2];h=+o[l+(e<<3)>>2];if(j<h){j=j-h;j=j*j;o[m+(e<<2)>>2]=j;f=f+j;j=+o[d>>2]}h=+o[l+(e<<3)+4>>2];if(j>h){j=j-h;j=j*j;o[m+(e<<2)>>2]=j;f=f+j}e=e+1|0}while((e|0)!=(g|0))}else f=0.0}else f=0.0;TNa(a,b,c,k[a+76>>2]|0,f,q,n+1.0);d=k[q>>2]|0;if(!d){r=s;return}e=k[p>>2]|0;if((e|0)!=(d|0))k[p>>2]=e+(~((e+-4-d|0)>>>2)<<2);ggb(d);r=s;return}function TNa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=+g;var h=0.0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;l=d+20|0;j=d+24|0;if((k[l>>2]|0)==0?(k[j>>2]|0)==0:0){h=+hg[k[(k[b>>2]|0)+16>>2]&127](b);j=k[d>>2]|0;t=d+4|0;d=k[t>>2]|0;if((j|0)>=(d|0))return;u=a+36|0;v=a+40|0;w=a+64|0;x=a+60|0;q=a+72|0;r=h>0.0;s=3-c|0;p=j;do{if(!(i[u>>0]|0))j=k[(k[v>>2]|0)+(p<<2)>>2]|0;else j=p;l=(k[w>>2]|0)+((aa(k[x>>2]|0,j)|0)<<2)|0;n=c+(k[q>>2]<<2)|0;a=n+-12|0;a:do if(r){j=c;e=0.0;while(1){if(j>>>0>=a>>>0){m=12;break a}A=+o[j>>2]-+o[l>>2];z=+o[j+4>>2]-+o[l+4>>2];y=+o[j+8>>2]-+o[l+8>>2];g=+o[j+12>>2]-+o[l+12>>2];e=e+(A*A+z*z+y*y+g*g);if(e>h)break;else{j=j+16|0;l=l+16|0}}}else{m=((a>>>0<c>>>0?c:a)+12+s|0)>>>4<<2;f=l+(m<<2)|0;if(a>>>0>c>>>0){j=c;e=0.0;while(1){g=+o[j>>2]-+o[l>>2];y=+o[j+4>>2]-+o[l+4>>2];z=+o[j+8>>2]-+o[l+8>>2];A=+o[j+12>>2]-+o[l+12>>2];e=e+(g*g+y*y+z*z+A*A);j=j+16|0;if(j>>>0>=a>>>0)break;else l=l+16|0}}else e=0.0;j=c+(m<<2)|0;l=f;m=12}while(0);if((m|0)==12){m=0;if(j>>>0<n>>>0)while(1){A=+o[j>>2]-+o[l>>2];j=j+4|0;e=e+A*A;if(j>>>0>=n>>>0)break;else l=l+4|0}}if(e<h){$f[k[(k[b>>2]|0)+12>>2]&15](b,e,k[(k[v>>2]|0)+(p<<2)>>2]|0);d=k[t>>2]|0}p=p+1|0}while((p|0)<(d|0));return}m=k[d+8>>2]|0;h=+o[c+(m<<2)>>2];A=h-+o[d+12>>2];h=h-+o[d+16>>2];x=A+h<0.0;A=x?h*h:A*A;d=k[(x?j:l)>>2]|0;TNa(a,b,c,k[(x?l:j)>>2]|0,e,f,g);x=(k[f>>2]|0)+(m<<2)|0;h=+o[x>>2];e=A+e-h;o[x>>2]=A;if(e*g<=+hg[k[(k[b>>2]|0)+16>>2]&127](b))TNa(a,b,c,d,e,f,g);o[(k[f>>2]|0)+(m<<2)>>2]=h;return}function UNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;g=a+92|0;h=a+112|0;j=a+96|0;l=a+100|0;m=a+108|0;while(1){e=k[g>>2]|0;a:do if((e|0)<32){k[h>>2]=(k[h>>2]|0)+e;d=fgb(8192)|0;if(d|0){k[d>>2]=k[j>>2];k[j>>2]=d;k[g>>2]=8188;d=d+4|0;k[l>>2]=d;e=8156;n=29;break}d=k[41482]|0;e=(d|0)==0;if((k[41497]|0)>-1){do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}else{do if(e){d=i[165986]|0;i[165986]=d+255|d;d=k[41478]|0;if(!(d&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;d=e+(k[41490]|0)|0;k[41482]=d;break}else{k[41478]=d|32;d=0;break a}}else e=k[41483]|0;while(0);if((d-e|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;d=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){d=0;break}d=0;f=373857;e=k[41483]|0}else{d=27;f=373830}upb(e|0,f|0,d|0)|0;k[41483]=(k[41483]|0)+d;d=0;break}}else{d=k[l>>2]|0;e=e+-32|0;n=29}while(0);if((n|0)==29){n=0;k[l>>2]=d+32;k[g>>2]=e;k[m>>2]=(k[m>>2]|0)+32}k[c>>2]=d;if((_fb(d,28,1,b)|0)!=1){n=31;break}d=k[c>>2]|0;e=d+20|0;if(!(k[e>>2]|0))c=d;else{UNa(a,b,e);c=k[c>>2]|0}c=c+24|0;if(!(k[c>>2]|0)){n=35;break}}if((n|0)==31){n=te(44)|0;VHa(n,373124);Cf(n|0,19720,57)}else if((n|0)==35)return}function VNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+8|0;e=k[i>>2]|0;j=a+4|0;c=k[j>>2]|0;if(e-c>>3>>>0>=b>>>0){do{i=c;k[i>>2]=0;k[i+4>>2]=0;c=(k[j>>2]|0)+8|0;k[j>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=c-d>>3;c=f+b|0;if(c>>>0>536870911)ad(426534,426557,304,426811);g=e-d|0;h=g>>2;h=g>>3>>>0<268435455?(h>>>0<c>>>0?c:h):536870911;if(!h)c=0;else{if(h>>>0>536870911){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=h<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}g=c+(f<<3)|0;d=g;f=g;do{e=d;k[e>>2]=0;k[e+4>>2]=0;d=f+8|0;f=d;b=b+-1|0}while((b|0)!=0);d=k[a>>2]|0;e=(k[j>>2]|0)-d|0;b=g+(0-(e>>3)<<3)|0;if((e|0)>0)upb(b|0,d|0,e|0)|0;k[a>>2]=b;k[j>>2]=f;k[i>>2]=c+(h<<3);if(!d)return;ggb(d);return}function WNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=a+76|0;m=a+16|0;n=a+74|0;o=a+8|0;p=a+4|0;q=a+44|0;r=a+28|0;s=a+20|0;g=a+48|0;h=a+36|0;j=a+75|0;do{c=k[m>>2]|0;d=(c|0)==0;a:do if((k[l>>2]|0)>-1){do if(d){c=i[n>>0]|0;i[n>>0]=c+255|c;c=k[a>>2]|0;if(!(c&8)){k[o>>2]=0;k[p>>2]=0;d=k[q>>2]|0;k[r>>2]=d;k[s>>2]=d;c=d+(k[g>>2]|0)|0;k[m>>2]=c;break}else{k[a>>2]=c|32;break a}}else d=k[s>>2]|0;while(0);f=d;if((c-d|0)>>>0<28){ci[k[h>>2]&255](a,b,28)|0;break}b:do if((i[j>>0]|0)>-1){d=28;while(1){if(!d){e=28;d=b;c=f;break b}c=d+-1|0;if((i[b+c>>0]|0)==10)break;else d=c}if((ci[k[h>>2]&255](a,b,d)|0)>>>0<d>>>0)break a;e=28-d|0;d=b+d|0;c=k[s>>2]|0}else{e=28;d=b;c=f}while(0);upb(c|0,d|0,e|0)|0;k[s>>2]=(k[s>>2]|0)+e}else{do if(d){c=i[n>>0]|0;i[n>>0]=c+255|c;c=k[a>>2]|0;if(!(c&8)){k[o>>2]=0;k[p>>2]=0;d=k[q>>2]|0;k[r>>2]=d;k[s>>2]=d;c=d+(k[g>>2]|0)|0;k[m>>2]=c;break}else{k[a>>2]=c|32;break a}}else d=k[s>>2]|0;while(0);f=d;if((c-d|0)>>>0<28){ci[k[h>>2]&255](a,b,28)|0;break}c:do if((i[j>>0]|0)>-1){d=28;while(1){if(!d){e=28;d=b;c=f;break c}c=d+-1|0;if((i[b+c>>0]|0)==10)break;else d=c}if((ci[k[h>>2]&255](a,b,d)|0)>>>0<d>>>0)break a;e=28-d|0;d=b+d|0;c=k[s>>2]|0}else{e=28;d=b;c=f}while(0);upb(c|0,d|0,e|0)|0;k[s>>2]=(k[s>>2]|0)+e}while(0);c=k[b+20>>2]|0;if(c|0)WNa(a,c);b=k[b+24>>2]|0}while((b|0)!=0);return}function XNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0.0,v=0.0,w=0,x=0.0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+32|0;G=J+12|0;H=J;j=a+92|0;e=k[j>>2]|0;a:do if((e|0)<32){I=a+112|0;k[I>>2]=(k[I>>2]|0)+e;e=fgb(8192)|0;if(e|0){g=a+96|0;k[e>>2]=k[g>>2];k[g>>2]=e;k[j>>2]=8188;g=e+4|0;f=a+100|0;k[f>>2]=g;e=8188;l=28;break}e=k[41482]|0;f=(e|0)==0;if((k[41497]|0)>-1){do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;I=0;break a}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;I=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){I=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;I=0;break}else{do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;I=0;break a}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;I=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){I=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;I=0;break}}else{g=a+100|0;f=g;g=k[g>>2]|0;l=28}while(0);if((l|0)==28){k[f>>2]=g+32;k[j>>2]=e+-32;I=a+108|0;k[I>>2]=(k[I>>2]|0)+32;I=g}D=c-b|0;if((D|0)<=(k[a+32>>2]|0)){k[I+24>>2]=0;k[I+20>>2]=0;k[I>>2]=b;k[I+4>>2]=c;s=k[a+72>>2]|0;j=(s|0)==0;if(!j){f=(k[a+16>>2]|0)+((aa(k[a+12>>2]|0,k[(k[a+40>>2]|0)+(b<<2)>>2]|0)|0)<<2)|0;g=k[d>>2]|0;e=0;do{H=f+(e<<2)|0;k[g+(e<<3)>>2]=k[H>>2];k[g+(e<<3)+4>>2]=k[H>>2];e=e+1|0}while((e|0)!=(s|0))}e=b+1|0;if((e|0)>=(c|0)){r=J;return I|0}q=k[d>>2]|0;if(j){r=J;return I|0}n=k[a+40>>2]|0;p=k[a+16>>2]|0;m=k[a+12>>2]|0;do{l=p+((aa(m,k[n+(e<<2)>>2]|0)|0)<<2)|0;j=0;do{f=q+(j<<3)|0;g=l+(j<<2)|0;h=+o[g>>2];if(+o[f>>2]>h){o[f>>2]=h;h=+o[g>>2]}f=q+(j<<3)+4|0;if(+o[f>>2]<h)o[f>>2]=h;j=j+1|0}while((j|0)!=(s|0));e=e+1|0}while((e|0)!=(c|0));r=J;return I|0}C=(k[a+40>>2]|0)+(b<<2)|0;B=k[d>>2]|0;t=+o[B+4>>2];v=+o[B>>2];h=t-v;F=a+72|0;A=k[F>>2]|0;E=B;if(A>>>0>1){e=1;do{z=+o[B+(e<<3)+4>>2]-+o[B+(e<<3)>>2];h=z>h?z:h;e=e+1|0}while((e|0)!=(A|0))}b:do if(!A){A=0;e=a+16|0;f=a+12|0;w=0}else{z=h*.9999899864196777;e=a+16|0;f=a+12|0;if((D|0)>1){g=0;x=-1.0;y=0;h=t;l=0}else{h=-1.0;m=0;g=0;j=0;while(1){if(t-v>z?(y=(k[e>>2]|0)+((aa(k[f>>2]|0,k[C>>2]|0)|0)<<2)+(j<<2)|0,x=+o[y>>2],x=x-x,x>h):0){h=x;g=m;j=m}l=m+1|0;if(l>>>0>=A>>>0){A=g;w=j;break b}m=l;v=+o[B+(l<<3)>>2];t=+o[B+(l<<3)+4>>2]}}while(1){if(h-v>z){q=k[e>>2]|0;s=k[f>>2]|0;w=q+((aa(s,k[C>>2]|0)|0)<<2)+(l<<2)|0;w=k[w>>2]|0;m=1;n=w;p=w;h=(k[u>>2]=w,+o[u>>2]);while(1){j=q+((aa(k[C+(m<<2)>>2]|0,s)|0)<<2)+(l<<2)|0;t=+o[j>>2];j=t<(k[u>>2]=p,+o[u>>2]);w=(o[u>>2]=t,k[u>>2]|0);p=j?w:p;h=j?(k[u>>2]=n,+o[u>>2]):h;j=t>h;n=j?w:n;m=m+1|0;if((m|0)==(D|0))break;else h=j?t:h}h=(k[u>>2]=n,+o[u>>2]);h=h-(k[u>>2]=p,+o[u>>2]);if(h>x){g=y;l=y}else h=x}else h=x;j=y+1|0;if(j>>>0>=A>>>0){A=g;w=l;break b}x=h;y=j;v=+o[B+(j<<3)>>2];h=+o[B+(j<<3)+4>>2]}}while(0);v=(+o[B+(w<<3)>>2]+ +o[B+(w<<3)+4>>2])*.5;n=k[e>>2]|0;m=k[f>>2]|0;g=n+((aa(m,k[C>>2]|0)|0)<<2)+(w<<2)|0;g=k[g>>2]|0;if((D|0)>1){l=1;f=g;e=g;h=(k[u>>2]=g,+o[u>>2]);while(1){B=n+((aa(k[C+(l<<2)>>2]|0,m)|0)<<2)+(w<<2)|0;t=+o[B>>2];B=t<(k[u>>2]=e,+o[u>>2]);g=(o[u>>2]=t,k[u>>2]|0);e=B?g:e;h=B?(k[u>>2]=f,+o[u>>2]):h;j=t>h;f=j?g:f;l=l+1|0;if((l|0)==(D|0))break;else h=j?t:h}}else{f=g;e=g}h=(k[u>>2]=e,+o[u>>2]);if(!(v<h)){h=(k[u>>2]=f,+o[u>>2]);if(v>h)y=f;else{y=(o[u>>2]=v,k[u>>2]|0);h=v}}else y=e;p=D+-1|0;q=a+16|0;s=a+12|0;n=p;e=0;c:while(1){d:do if((e|0)<=(n|0)){g=k[q>>2]|0;j=k[s>>2]|0;while(1){B=g+((aa(j,k[C+(e<<2)>>2]|0)|0)<<2)+(w<<2)|0;if(!(+o[B>>2]<h))break d;f=e+1|0;if((e|0)<(n|0))e=f;else{e=f;break}}}while(0);if((e|0)>(n|0)){f=e;break}l=k[q>>2]|0;m=k[s>>2]|0;f=n;while(1){g=C+(f<<2)|0;j=k[g>>2]|0;B=l+((aa(m,j)|0)<<2)+(w<<2)|0;if(!(+o[B>>2]>=h))break;if((e|0)<(f|0))f=f+-1|0;else{f=e;break c}}B=C+(e<<2)|0;n=k[B>>2]|0;k[B>>2]=j;k[g>>2]=n;n=f+-1|0;e=e+1|0}e:while(1){f:do if((f|0)<=(p|0)){j=k[q>>2]|0;l=k[s>>2]|0;while(1){B=j+((aa(l,k[C+(f<<2)>>2]|0)|0)<<2)+(w<<2)|0;if(!(+o[B>>2]<=h))break f;g=f+1|0;if((f|0)<(p|0))f=g;else{f=g;break}}}while(0);if((f|0)>(p|0))break;m=k[q>>2]|0;n=k[s>>2]|0;g=p;while(1){j=C+(g<<2)|0;l=k[j>>2]|0;B=m+((aa(n,l)|0)<<2)+(w<<2)|0;if(!(+o[B>>2]>h))break;if((f|0)<(g|0))g=g+-1|0;else break e}B=C+(f<<2)|0;p=k[B>>2]|0;k[B>>2]=l;k[j>>2]=p;p=g+-1|0;f=f+1|0}j=(D|0)/2|0;j=(e|0)>(j|0)?e:(f|0)<(j|0)?f:j;k[I+8>>2]=A;k[G>>2]=0;p=G+4|0;k[p>>2]=0;k[G+8>>2]=0;l=d+4|0;e=(k[l>>2]|0)-E|0;g=e>>3;if(g>>>0>536870911)ad(426534,426557,304,426811);f=(e|0)==0?1:e;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[p>>2]=e;k[G>>2]=e;k[G+8>>2]=e+(g<<3);f=k[d>>2]|0;g=(k[l>>2]|0)-f|0;if((g|0)>0){upb(e|0,f|0,g|0)|0;k[p>>2]=e+(g>>3<<3)}k[e+(A<<3)+4>>2]=y;j=j+b|0;n=XNa(a,b,j,G)|0;k[I+20>>2]=n;k[H>>2]=0;n=H+4|0;k[n>>2]=0;k[H+8>>2]=0;e=(k[l>>2]|0)-(k[d>>2]|0)|0;g=e>>3;if(g>>>0>536870911)ad(426534,426557,304,426811);f=(e|0)==0?1:e;while(1){e=fgb(f)|0;if(e|0){m=e;break}e=k[207666]|0;k[207666]=e+0;if(!e){m=0;break}Qh[e&7]()}k[n>>2]=m;k[H>>2]=m;k[H+8>>2]=m+(g<<3);f=k[d>>2]|0;e=(k[l>>2]|0)-f|0;if((e|0)>0){upb(m|0,f|0,e|0)|0;l=m+(e>>3<<3)|0;k[n>>2]=l}else l=m;k[m+(A<<3)>>2]=y;j=XNa(a,j,c,H)|0;k[I+24>>2]=j;j=k[G>>2]|0;k[I+12>>2]=k[j+(A<<3)+4>>2];k[I+16>>2]=k[m+(A<<3)>>2];g=k[F>>2]|0;if(g|0){f=k[d>>2]|0;e=0;do{c=j+(e<<3)|0;a=m+(e<<3)|0;k[f+(e<<3)>>2]=k[(+o[a>>2]<+o[c>>2]?a:c)>>2];c=j+(e<<3)+4|0;a=m+(e<<3)+4|0;k[f+(e<<3)+4>>2]=k[(+o[c>>2]<+o[a>>2]?a:c)>>2];e=e+1|0}while((e|0)!=(g|0))}if((l|0)!=(m|0))k[n>>2]=l+(~((l+-8-m|0)>>>3)<<3);ggb(m);e=j;if(j|0){f=k[p>>2]|0;if((f|0)!=(j|0))k[p>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(j)}r=J;return I|0}function YNa(a){a=a|0;k[a>>2]=94508;YHa(k[a+24>>2]|0);return}function ZNa(a){a=a|0;k[a>>2]=94508;YHa(k[a+24>>2]|0);ggb(a);return}function _Na(a){a=a|0;return}function $Na(a,b){a=a|0;b=b|0;return}function aOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;b=h+8|0;c=h;d=a+20|0;e=b+4|0;f=ZT(16)|0;k[f>>2]=1;g=f+4|0;k[b>>2]=g;k[e>>2]=9;i[f+13>>0]=0;j=373358;l=g+9|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));l=WHa(d,b)|0;j=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[c>>2]=j;j=k[l>>2]|0;a=l+4|0;jh[k[k[j>>2]>>2]&1023](j,a);k[l>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,c,a);k[e>>2]=0;k[b>>2]=0;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1){r=h;return}ggb(k[f+-4>>2]|0);r=h;return}function bOa(a){a=a|0;return k[a+4>>2]|0}function cOa(a){a=a|0;return k[a+8>>2]|0}function dOa(a){a=a|0;return 0}function eOa(a){a=a|0;return 0}function fOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+20>>2]|0;f=b+24|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function gOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0.0,q=0.0,r=0.0,s=0.0;m=a+4|0;if(!(k[m>>2]|0))return;n=a+8|0;l=0;j=k[a+16>>2]|0;d=k[n>>2]|0;while(1){i=j+(d<<2)|0;g=i+-12|0;h=((g>>>0<j>>>0?j:g)+12+(3-j)|0)>>>4<<2;a=c+(h<<2)|0;if(j>>>0<g>>>0){d=j;f=c;e=0.0;while(1){s=+o[d>>2]-+o[f>>2];r=+o[d+4>>2]-+o[f+4>>2];q=+o[d+8>>2]-+o[f+8>>2];p=+o[d+12>>2]-+o[f+12>>2];e=e+(s*s+r*r+q*q+p*p);d=d+16|0;if(d>>>0>=g>>>0)break;else f=f+16|0}}else e=0.0;d=j+(h<<2)|0;if(d>>>0<i>>>0)while(1){s=+o[d>>2]-+o[a>>2];d=d+4|0;e=e+s*s;if(d>>>0>=i>>>0)break;else a=a+4|0}$f[k[(k[b>>2]|0)+12>>2]&15](b,e,l);l=l+1|0;d=k[n>>2]|0;if(l>>>0>=(k[m>>2]|0)>>>0)break;else j=j+(d<<2)|0}return}function hOa(a){a=a|0;var b=0;k[a>>2]=94008;b=k[a+4>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);YHa(k[a+16>>2]|0);return}function iOa(a){a=a|0;var b=0;k[a>>2]=94008;b=k[a+4>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);YHa(k[a+16>>2]|0);ggb(a);return}function jOa(a){a=a|0;if(i[a+8>>0]|0)return;a=k[a+4>>2]|0;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);return}function kOa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=k[a+4>>2]|0;Lg[k[(k[a>>2]|0)+12>>2]&255](a,b,c,d,e,f);return}function lOa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;a=k[a+4>>2]|0;return li[k[(k[a>>2]|0)+16>>2]&7](a,b,c,d,e,f)|0}function mOa(a,b){a=a|0;b=b|0;a=k[a+4>>2]|0;jh[k[(k[a>>2]|0)+20>>2]&1023](a,b);return}function nOa(a,b){a=a|0;b=b|0;a=k[a+4>>2]|0;jh[k[(k[a>>2]|0)+24>>2]&1023](a,b);return}function oOa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+28>>2]&1023](a)|0}function pOa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+32>>2]&1023](a)|0}function qOa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0}function rOa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0}function sOa(a,b){a=a|0;b=b|0;b=k[b+4>>2]|0;jh[k[(k[b>>2]|0)+44>>2]&1023](a,b);return}function tOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=k[a+4>>2]|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,b,c,d);return}function uOa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;v=r;r=r+96|0;p=v+48|0;q=v+32|0;s=v+24|0;o=v+16|0;t=v+8|0;u=v;k[a>>2]=94568;n=a+12|0;h=a+16|0;k[h>>2]=0;j=a+20|0;k[j>>2]=0;l=a+16|0;k[n>>2]=l;d=k[c>>2]|0;m=c+4|0;if((d|0)!=(m|0)){e=d;while(1){f=e+16|0;g=ZHa(n,l,p,f)|0;if(!(k[g>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){f=f+-4|0;k[f>>2]=(k[f>>2]|0)+1}x=d+24|0;k[x>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);w=k[e+24>>2]|0;k[x>>2]=w;Ph[k[(k[w>>2]|0)+8>>2]&511](w,e+28|0,f);f=k[p>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[n>>2]>>2]|0;if(f){k[n>>2]=f;d=k[g>>2]|0}B4(k[h>>2]|0,d);k[j>>2]=(k[j>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(m|0))break;else e=d}}k[o>>2]=0;e=o+4|0;k[e>>2]=0;f=ZT(16)|0;k[f>>2]=1;h=f+4|0;k[o>>2]=h;k[e>>2]=9;i[f+13>>0]=0;j=373358;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));d=_Ha(c,o)|0;k[e>>2]=0;k[o>>2]=0;x=k[f>>2]|0;k[f>>2]=x+-1;if((x|0)==1)ggb(k[f+-4>>2]|0);n=a+8|0;i[n>>0]=0;if((d|0)!=254){x=vOa(b,c)|0;k[a+4>>2]=x;r=v;return}k[u>>2]=0;m=u+4|0;k[m>>2]=0;g=ZT(16)|0;k[g>>2]=1;d=g+4|0;k[u>>2]=d;k[m>>2]=8;i[g+12>>0]=0;g=d;i[g>>0]=102;i[g+1>>0]=105;i[g+2>>0]=108;i[g+3>>0]=101;d=d+4|0;i[d>>0]=110;i[d+1>>0]=97;i[d+2>>0]=109;i[d+3>>0]=101;$Ha(t,c,u);d=k[t>>2]|0;g=Ufb((d|0)==0?1016759:d,373005)|0;if(!g)e=0;else{UHa(p,g);if((k[p+32>>2]|0)!=4){x=te(44)|0;VHa(x,375679);Cf(x|0,19720,57)}if((k[p+40>>2]|0)!=(k[b>>2]|0)){x=te(44)|0;VHa(x,375747);Cf(x|0,19720,57)}if((k[p+44>>2]|0)!=(k[b+4>>2]|0)){x=te(44)|0;VHa(x,375747);Cf(x|0,19720,57)}k[q+4>>2]=0;k[q+8>>2]=0;d=q+4|0;k[q>>2]=d;k[s>>2]=0;e=s+4|0;k[e>>2]=0;f=ZT(16)|0;k[f>>2]=1;h=f+4|0;k[s>>2]=h;k[e>>2]=9;i[f+13>>0]=0;j=373358;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));w=WHa(q,s)|0;c=k[w>>2]|0;x=w+4|0;jh[k[k[c>>2]>>2]&1023](c,x);k[w>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,p+36|0,x);k[e>>2]=0;k[s>>2]=0;x=k[f>>2]|0;k[f>>2]=x+-1;if((x|0)==1)ggb(k[f+-4>>2]|0);e=vOa(b,q)|0;jh[k[(k[e>>2]|0)+24>>2]&1023](e,g);Qfb(g)|0;YHa(k[d>>2]|0);d=k[t>>2]|0}k[a+4>>2]=e;k[t+4>>2]=0;k[t>>2]=0;if(d|0?(w=d+-4|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0)ggb(k[d+-8>>2]|0);d=k[u>>2]|0;k[m>>2]=0;k[u>>2]=0;if(d|0?(w=d+-4|0,x=k[w>>2]|0,k[w>>2]=x+-1,(x|0)==1):0)ggb(k[d+-8>>2]|0);i[n>>0]=1;r=v;return}function vOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;o=r;r=r+16|0;n=o+8|0;d=o;e=d+4|0;f=ZT(16)|0;k[f>>2]=1;h=f+4|0;k[d>>2]=h;k[e>>2]=9;i[f+13>>0]=0;j=373358;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));c=_Ha(b,d)|0;k[e>>2]=0;k[d>>2]=0;m=k[f>>2]|0;k[f>>2]=m+-1;if((m|0)==1)ggb(k[f+-4>>2]|0);switch(c|0){case 0:{while(1){c=fgb(36)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=94868;g=c+4|0;k[g>>2]=k[a>>2];k[g+4>>2]=k[a+4>>2];k[g+8>>2]=k[a+8>>2];k[g+12>>2]=k[a+12>>2];g=c+20|0;h=c+24|0;k[h>>2]=0;j=c+28|0;k[j>>2]=0;k[g>>2]=h;d=k[b>>2]|0;b=b+4|0;if((d|0)==(b|0)){n=c;r=o;return n|0}e=d;while(1){f=e+16|0;a=ZHa(g,h,n,f)|0;if(!(k[a>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){m=f+-4|0;k[m>>2]=(k[m>>2]|0)+1}l=d+24|0;k[l>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);m=k[e+24>>2]|0;k[l>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,e+28|0,f);f=k[n>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[a>>2]=d;f=k[k[g>>2]>>2]|0;if(f){k[g>>2]=f;d=k[a>>2]|0}B4(k[h>>2]|0,d);k[j>>2]=(k[j>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(b|0))break;else e=d}r=o;return c|0}case 5:{while(1){c=fgb(104)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=94808;j=c+12|0;k[j>>2]=k[a>>2];k[j+4>>2]=k[a+4>>2];k[j+8>>2]=k[a+8>>2];k[j+12>>2]=k[a+12>>2];m=c+28|0;g=c+32|0;k[g>>2]=0;h=c+36|0;k[h>>2]=0;k[m>>2]=g;d=k[b>>2]|0;b=b+4|0;if((d|0)!=(b|0)){e=d;while(1){f=e+16|0;a=ZHa(m,g,n,f)|0;if(!(k[a>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){l=f+-4|0;k[l>>2]=(k[l>>2]|0)+1}p=d+24|0;k[p>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);l=k[e+24>>2]|0;k[p>>2]=l;Ph[k[(k[l>>2]|0)+8>>2]&511](l,e+28|0,f);f=k[n>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[a>>2]=d;f=k[k[m>>2]>>2]|0;if(f){k[m>>2]=f;d=k[a>>2]|0}B4(k[g>>2]|0,d);k[h>>2]=(k[h>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(b|0))break;else e=d}}b=c+48|0;k[b>>2]=0;g=c+52|0;k[g>>2]=0;k[c+72>>2]=8192;k[c+60>>2]=0;k[c+64>>2]=0;k[c+76>>2]=0;k[c+80>>2]=0;k[c+84>>2]=0;k[c+40>>2]=k[j>>2];k[c+44>>2]=k[c+16>>2];d=ZT(16)|0;k[d>>2]=1;e=d+4|0;i[d+13>>0]=0;h=e;j=373742;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));k[n>>2]=32;p=dIa(m,e,n)|0;k[c+88>>2]=p;p=k[d>>2]|0;k[d>>2]=p+-1;if((p|0)==1)ggb(k[d+-4>>2]|0);e=ZT(20)|0;k[e>>2]=1;d=e+4|0;i[e+16>>0]=0;h=d;j=373752;l=h+12|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));k[n>>2]=0;p=WIa(m,d,n)|0;f=c+96|0;k[f>>2]=p;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0);d=ZT(12)|0;k[d>>2]=1;p=d+4|0;i[d+9>>0]=0;i[p>>0]=i[380533]|0;i[p+1>>0]=i[380534]|0;i[p+2>>0]=i[380535]|0;i[p+3>>0]=i[380536]|0;i[p+4>>0]=i[380537]|0;k[n>>2]=4;p=dIa(m,p,n)|0;a=c+92|0;k[a>>2]=p;p=k[d>>2]|0;k[d>>2]=p+-1;if((p|0)==1)ggb(k[d+-4>>2]|0);d=ZT(16)|0;k[d>>2]=1;e=d+4|0;i[d+13>>0]=0;h=e;j=373765;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));k[n>>2]=100;p=dIa(m,e,n)|0;k[c+100>>2]=p;p=k[d>>2]|0;k[d>>2]=p+-1;if((p|0)==1)ggb(k[d+-4>>2]|0);switch(k[f>>2]|0){case 0:{k[c+4>>2]=174;k[c+8>>2]=0;break}case 1:{k[c+4>>2]=175;k[c+8>>2]=0;break}case 2:{k[c+4>>2]=176;k[c+8>>2]=0;break}case 3:{k[c+4>>2]=177;k[c+8>>2]=0;break}default:{p=te(44)|0;VHa(p,373775);Cf(p|0,19720,57)}}d=ZT(12)|0;k[d>>2]=1;p=d+4|0;i[d+9>>0]=0;i[p>>0]=i[380533]|0;i[p+1>>0]=i[380534]|0;i[p+2>>0]=i[380535]|0;i[p+3>>0]=i[380536]|0;i[p+4>>0]=i[380537]|0;k[n>>2]=4;p=dIa(m,p,n)|0;k[a>>2]=p;p=k[d>>2]|0;k[d>>2]=p+-1;if((p|0)==1)ggb(k[d+-4>>2]|0);a=k[a>>2]|0;f=a>>>0>1073741823?-1:a<<2;f=(f|0)==0?1:f;while(1){d=fgb(f)|0;if(d|0){e=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){e=0;break}Qh[d&7]()}k[b>>2]=e;while(1){d=fgb(f)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[g>>2]=d;if((a|0)<=0){p=c;r=o;return p|0}k[e>>2]=0;k[k[g>>2]>>2]=0;if((a|0)==1){p=c;r=o;return p|0}else d=1;do{k[(k[b>>2]|0)+(d<<2)>>2]=0;k[(k[g>>2]|0)+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(a|0));r=o;return c|0}case 6:{while(1){c=fgb(76)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c>>2]=94628;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;m=c+16|0;k[m>>2]=k[a>>2];k[m+4>>2]=k[a+4>>2];k[m+8>>2]=k[a+8>>2];k[m+12>>2]=k[a+12>>2];m=c+36|0;g=c+40|0;k[g>>2]=0;h=c+44|0;k[h>>2]=0;k[m>>2]=g;d=k[b>>2]|0;b=b+4|0;if((d|0)!=(b|0)){e=d;while(1){f=e+16|0;a=ZHa(m,g,n,f)|0;if(!(k[a>>2]|0)){while(1){d=fgb(32)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}f=k[f>>2]|0;k[d+16>>2]=f;k[d+20>>2]=k[e+20>>2];if(f|0){p=f+-4|0;k[p>>2]=(k[p>>2]|0)+1}l=d+24|0;k[l>>2]=428704;f=d+28|0;k[f>>2]=0;jh[k[k[107176]>>2]&1023](428704,f);p=k[e+24>>2]|0;k[l>>2]=p;Ph[k[(k[p>>2]|0)+8>>2]&511](p,e+28|0,f);f=k[n>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[a>>2]=d;f=k[k[m>>2]>>2]|0;if(f){k[m>>2]=f;d=k[a>>2]|0}B4(k[g>>2]|0,d);k[h>>2]=(k[h>>2]|0)+1}else e=d;d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(b|0))break;else e=d}}a=c+60|0;k[a>>2]=0;k[c+64>>2]=0;k[c+68>>2]=0;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;i[d+16>>0]=0;h=e;j=373387;l=h+12|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));k[n>>2]=12;p=dIa(m,e,n)|0;k[c+48>>2]=p;p=k[d>>2]|0;k[d>>2]=p+-1;if((p|0)==1)ggb(k[d+-4>>2]|0);d=ZT(16)|0;k[d>>2]=1;p=d+4|0;i[d+12>>0]=0;f=p;l=f;i[l>>0]=107;i[l+1>>0]=101;i[l+2>>0]=121;i[l+3>>0]=95;f=f+4|0;i[f>>0]=115;i[f+1>>0]=105;i[f+2>>0]=122;i[f+3>>0]=101;k[n>>2]=20;p=dIa(m,p,n)|0;f=c+52|0;k[f>>2]=p;p=k[d>>2]|0;k[d>>2]=p+-1;if((p|0)==1)ggb(k[d+-4>>2]|0);e=ZT(24)|0;k[e>>2]=1;d=e+4|0;i[e+21>>0]=0;h=d;j=373400;l=h+17|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));k[n>>2]=2;p=dIa(m,d,n)|0;d=c+56|0;k[d>>2]=p;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0);k[c+32>>2]=k[c+20>>2];wOa(0,k[f>>2]|0,k[d>>2]|0,a);p=c;r=o;return p|0}default:{p=te(44)|0;VHa(p,373368);Cf(p|0,19720,57)}}return 0}function wOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;h=r;r=r+16|0;e=h;k[e>>2]=a;f=d+4|0;g=k[f>>2]|0;if((g|0)==(k[d+8>>2]|0))P4(d,e);else{k[g>>2]=a;k[f>>2]=g+4}if(!((c|0)!=0&(b|0)>0)){r=h;return}c=c+-1|0;do{g=b;b=b+-1|0;wOa(1<<b|a,b,c,d)}while((g|0)>1);r=h;return}function xOa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=k[a+48>>2]|0;c=b;if(b|0){d=a+52|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+28>>2]|0;c=b;if(b|0){d=a+32|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}gIa(k[a+16>>2]|0);b=k[a>>2]|0;if(!b)return;g=a+4|0;c=k[g>>2]|0;if((c|0)!=(b|0)){do{d=c+-12|0;k[g>>2]=d;e=k[d>>2]|0;f=e;if(!e)c=d;else{c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(e|0))k[c>>2]=d+(~((d+-4-f|0)>>>2)<<2);ggb(e);c=k[g>>2]|0}}while((c|0)!=(b|0));b=k[a>>2]|0}ggb(b);return}function yOa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=94628;b=k[a+60>>2]|0;c=b;if(b|0){d=a+64|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}YHa(k[a+40>>2]|0);d=a+4|0;e=k[d>>2]|0;if(!e)return;b=a+8|0;while(1){c=k[b>>2]|0;if((c|0)==(e|0))break;a=c+-60|0;k[b>>2]=a;xOa(a)}ggb(k[d>>2]|0);return}function zOa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=94628;b=k[a+60>>2]|0;c=b;if(b|0){d=a+64|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}YHa(k[a+40>>2]|0);b=a+4|0;c=k[b>>2]|0;if(!c){ggb(a);return}d=a+8|0;while(1){e=k[d>>2]|0;if((e|0)==(c|0))break;e=e+-60|0;k[d>>2]=e;xOa(e)}ggb(k[b>>2]|0);ggb(a);return}function AOa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0;ga=r;r=r+80|0;fa=ga;X=ga+72|0;Z=ga+12|0;_=a+4|0;ba=a+48|0;e=k[ba>>2]|0;v=a+8|0;f=k[v>>2]|0;g=k[_>>2]|0;h=(f-g|0)/60|0;c=g;b=f;a:do if(e>>>0>h>>>0){c=e-h|0;u=a+12|0;d=k[u>>2]|0;if(((d-f|0)/60|0)>>>0>=c>>>0)while(1){k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;k[b+12>>2]=b+16;k[b+28>>2]=0;k[b+32>>2]=0;k[b+36>>2]=0;k[b+48>>2]=0;k[b+52>>2]=0;k[b+56>>2]=0;b=(k[v>>2]|0)+60|0;k[v>>2]=b;c=c+-1|0;if(!c)break a}if(e>>>0>71582788)ad(426534,426557,304,426811);V=(d-g|0)/60|0;f=V<<1;f=V>>>0<35791394?(f>>>0<e>>>0?e:f):71582788;if(!f)b=0;else{if(f>>>0>71582788){ga=te(4)|0;k[ga>>2]=172664;Cf(ga|0,28816,1287)}d=f*60|0;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}}g=b+(h*60|0)|0;e=g;t=e;d=g;do{k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[d+12>>2]=d+16;k[d+28>>2]=0;k[d+32>>2]=0;k[d+36>>2]=0;k[d+48>>2]=0;k[d+52>>2]=0;k[d+56>>2]=0;d=t+60|0;t=d;c=c+-1|0}while((c|0)!=0);s=b+(f*60|0)|0;d=k[_>>2]|0;b=k[v>>2]|0;if((b|0)==(d|0)){b=d;c=e;d=b}else{c=e;do{l=b;b=b+-60|0;VIa(g+-60|0,b);m=g+-48|0;n=g+-44|0;k[n>>2]=0;o=g+-40|0;k[o>>2]=0;p=g+-44|0;k[m>>2]=p;e=k[l+-48>>2]|0;q=l+-44|0;if((e|0)!=(q|0)){f=e;i=e;while(1){h=i+16|0;j=UIa(m,p,X,h)|0;if(!(k[j>>2]|0)){while(1){e=fgb(32)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[e+16>>2]=k[h>>2];SIa(e+20|0,i+20|0);h=k[X>>2]|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=h;k[j>>2]=e;h=k[k[m>>2]>>2]|0;if(h){k[m>>2]=h;e=k[j>>2]|0}B4(k[n>>2]|0,e);k[o>>2]=(k[o>>2]|0)+1}e=k[f+4>>2]|0;if(!e)while(1){e=k[f+8>>2]|0;if((k[e>>2]|0)==(f|0))break;else f=e}else while(1){f=k[e>>2]|0;if(!f)break;else e=f}if((e|0)==(q|0))break;else{f=e;i=e}}}k[g+-36>>2]=k[l+-36>>2];SIa(g+-32|0,l+-32|0);k[g+-20>>2]=k[l+-20>>2];k[g+-16>>2]=k[l+-16>>2];SIa(g+-12|0,l+-12|0);g=c+-60|0;c=g}while((b|0)!=(d|0));d=k[_>>2]|0;b=k[v>>2]|0}k[_>>2]=c;k[v>>2]=t;k[u>>2]=s;c=d;while(1){if((b|0)==(c|0))break;b=b+-60|0;xOa(b)}if(d|0)ggb(d)}else if(e>>>0<h>>>0?(d=c+(e*60|0)|0,(b|0)!=(d|0)):0)do{V=b+-60|0;k[v>>2]=V;xOa(V);b=k[v>>2]|0}while((b|0)!=(d|0));while(0);if(!(k[ba>>2]|0)){r=ga;return}U=a+32|0;V=a+52|0;S=a+16|0;T=a+24|0;z=a+28|0;A=Z+4|0;B=Z+8|0;C=Z+12|0;D=Z+16|0;E=Z+20|0;F=Z+16|0;G=Z+28|0;H=Z+32|0;I=Z+36|0;J=Z+48|0;K=Z+52|0;L=Z+56|0;M=Z+24|0;N=Z+44|0;O=Z+40|0;P=Z+48|0;Q=Z+12|0;R=X+4|0;y=0;while(1){w=k[_>>2]|0;x=w+(y*60|0)|0;f=k[U>>2]|0;b=k[V>>2]|0;k[Z>>2]=0;k[A>>2]=0;k[B>>2]=0;k[D>>2]=0;k[E>>2]=0;k[C>>2]=F;k[G>>2]=0;k[H>>2]=0;k[I>>2]=0;k[J>>2]=0;k[K>>2]=0;k[L>>2]=0;if(((b+-1|0)>>>0>=31?(k[fa>>2]=b,k[fa+4>>2]=1,k[fa+8>>2]=32,$8(X,376637,fa),Y8(-5,X,400998,376715,271),Y=k[X>>2]|0,k[R>>2]=0,k[X>>2]=0,Y|0):0)?(v=Y+-4|0,a=k[v>>2]|0,k[v>>2]=a+-1,(a|0)==1):0)ggb(k[Y+-8>>2]|0);k[M>>2]=2;k[N>>2]=b;d=~~+$(+(+(f>>>0)*.25))>>>0;if(d){if(d>>>0>1073741823){W=53;break}e=d<<2;c=(e|0)==0?1:e;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}zpb(b|0,0,e|0)|0;s4(J,b,b+(d<<2)|0);if(b|0)ggb(b)}else s4(J,0,0);e=f<<3;if(!e){h=0;b=0}else{if(e>>>0>1073741823){W=62;break}d=f<<5;c=(d|0)==0?1:d;while(1){b=fgb(c)|0;if(b|0){c=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){c=0;break}Qh[b&7]()}zpb(c|0,0,d|0)|0;b=0;do{k[c+(b<<2)>>2]=b;b=b+1|0}while((b|0)!=(e|0));h=c;b=c+(e<<2)|0}c=b-h|0;do if((c|0)>4){mpb(827696)|0;k[206923]=1;g=b+-4|0;if(h>>>0<g>>>0){e=c>>2;f=h;do{c=e;e=e+-1|0;if(e|0){if(!c)b=Sgb()|0;else{a=32-(da(c|0)|0)|0;a=(((-1>>>(33-a|0)&c|0)==0)<<31>>31)+a|0;d=((a&31|0)!=0&1)+(a>>>5)|0;d=d>>>0>a>>>0?0:-1>>>(32-((a>>>0)/(d>>>0)|0)|0);do b=(Sgb()|0)&d;while(b>>>0>=c>>>0)}if(b|0){a=f+(b<<2)|0;v=k[f>>2]|0;k[f>>2]=k[a>>2];k[a>>2]=v}}f=f+4|0}while(f>>>0<g>>>0);a=(k[206923]|0)+-1|0;k[206923]=a;if(a|0)break}else k[206923]=0;lpb(827696)|0}while(0);if(!(k[N>>2]|0)){if(h|0)W=87}else{c=k[J>>2]|0;b=0;do{a=k[h+(b<<2)>>2]|0;W=c+(a>>>5<<2)|0;k[W>>2]=k[W>>2]|1<<(a&31);b=b+1|0}while(b>>>0<(k[N>>2]|0)>>>0);W=87}if((W|0)==87){W=0;ggb(h)}g=(x|0)==(Z|0);if(!g){TIa(x,k[Z>>2]|0,k[A>>2]|0);h=w+(y*60|0)+12|0;i=w+(y*60|0)+16|0;gIa(k[i>>2]|0);j=w+(y*60|0)+20|0;k[j>>2]=0;k[h>>2]=i;k[i>>2]=0;b=k[Q>>2]|0;if((b|0)==(F|0))k[w+(y*60|0)+24>>2]=k[M>>2];else{l=w+(y*60|0)+16|0;f=b;c=b;while(1){d=f+16|0;e=UIa(h,i,X,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b+16>>2]=k[d>>2];SIa(b+20|0,f+20|0);d=k[X>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[h>>2]>>2]|0;if(d){k[h>>2]=d;b=k[e>>2]|0}B4(k[l>>2]|0,b);k[j>>2]=(k[j>>2]|0)+1}b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(F|0))break;else{f=b;c=b}}k[w+(y*60|0)+24>>2]=k[M>>2]}s4(w+(y*60|0)+28|0,k[G>>2]|0,k[H>>2]|0);k[w+(y*60|0)+40>>2]=k[O>>2];k[w+(y*60|0)+44>>2]=k[N>>2];if(!g)s4(w+(y*60|0)+48|0,k[P>>2]|0,k[K>>2]|0)}else{k[w+(y*60|0)+24>>2]=k[M>>2];k[w+(y*60|0)+40>>2]=k[O>>2];k[w+(y*60|0)+44>>2]=k[N>>2]}xOa(Z);l=k[S>>2]|0;m=k[T>>2]|0;n=k[z>>2]|0;b:do if(!l)b=w+(y*60|0)+24|0;else{o=w+(y*60|0)+48|0;p=w+(y*60|0)+52|0;b=w+(y*60|0)+24|0;q=w+(y*60|0)+28|0;s=w+(y*60|0)+12|0;t=w+(y*60|0)+16|0;u=t;v=w+(y*60|0)+16|0;a=w+(y*60|0)+20|0;j=0;while(1){k[Z>>2]=j;c=k[o>>2]|0;i=k[p>>2]|0;if((c|0)==(i|0))f=0;else{e=0;d=1;h=n+(aa(j,m)|0)|0;while(1){g=k[h>>2]|0;f=k[c>>2]|0;if(f)do{ha=f&0-f;e=(ha&g|0?d:0)+e|0;f=ha^f;d=d<<1}while((f|0)!=0);c=c+4|0;if((c|0)==(i|0)){f=e;break}else h=h+4|0}}c:do switch(k[b>>2]|0){case 0:{c=k[x>>2]|0;d=c+(f*12|0)+4|0;e=k[d>>2]|0;if((e|0)==(k[c+(f*12|0)+8>>2]|0)){P4(c+(f*12|0)|0,Z);break c}else{k[e>>2]=j;k[d>>2]=e+4;break c}}case 1:{c=(k[q>>2]|0)+(f>>>5<<2)|0;k[c>>2]=k[c>>2]|1<<(f&31);c=k[t>>2]|0;do if(c){while(1){d=k[c+16>>2]|0;if(f>>>0<d>>>0){d=k[c>>2]|0;if(!d){W=123;break}else c=d}else{if(d>>>0>=f>>>0){W=129;break}e=c+4|0;d=k[e>>2]|0;if(!d){W=127;break}else c=d}}if((W|0)==123){k[X>>2]=c;d=c;e=c;W=130;break}else if((W|0)==127){k[X>>2]=c;d=c;W=130;break}else if((W|0)==129){W=0;k[X>>2]=c;if(!c){d=c;e=X;W=130;break}else break}}else{k[X>>2]=t;d=u;e=t;W=130}while(0);if((W|0)==130){W=0;while(1){c=fgb(32)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c+16>>2]=f;k[c+20>>2]=0;k[c+24>>2]=0;k[c+28>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=d;k[e>>2]=c;d=k[k[s>>2]>>2]|0;if(!d)d=c;else{k[s>>2]=d;d=k[e>>2]|0}B4(k[v>>2]|0,d);k[a>>2]=(k[a>>2]|0)+1}d=c+24|0;e=k[d>>2]|0;if((e|0)==(k[c+28>>2]|0)){P4(c+20|0,Z);break c}else{k[e>>2]=k[Z>>2];k[d>>2]=e+4;break c}}case 2:{c=k[t>>2]|0;do if(c){while(1){d=k[c+16>>2]|0;if(f>>>0<d>>>0){d=k[c>>2]|0;if(!d){W=143;break}else c=d}else{if(d>>>0>=f>>>0){W=149;break}e=c+4|0;d=k[e>>2]|0;if(!d){W=147;break}else c=d}}if((W|0)==143){k[X>>2]=c;d=c;e=c;W=150;break}else if((W|0)==147){k[X>>2]=c;d=c;W=150;break}else if((W|0)==149){W=0;k[X>>2]=c;if(!c){d=c;e=X;W=150;break}else break}}else{k[X>>2]=t;d=u;e=t;W=150}while(0);if((W|0)==150){W=0;while(1){c=fgb(32)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[c+16>>2]=f;k[c+20>>2]=0;k[c+24>>2]=0;k[c+28>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=d;k[e>>2]=c;d=k[k[s>>2]>>2]|0;if(!d)d=c;else{k[s>>2]=d;d=k[e>>2]|0}B4(k[v>>2]|0,d);k[a>>2]=(k[a>>2]|0)+1}d=c+24|0;e=k[d>>2]|0;if((e|0)==(k[c+28>>2]|0)){P4(c+20|0,Z);break c}else{k[e>>2]=j;k[d>>2]=e+4;break c}}default:{}}while(0);j=j+1|0;if((j|0)==(l|0))break b}}while(0);d:do if(k[b>>2]|0){j=w+(y*60|0)+12|0;h=w+(y*60|0)+20|0;c=k[h>>2]|0;d=k[w+(y*60|0)+44>>2]|0;e=1<<d;if(c>>>0<=e>>>1>>>0){ha=((k[w+(y*60|0)+4>>2]|0)-(k[x>>2]|0)|0)/12|0;if(!(d>>>0<33?1:((((c>>>0<ha>>>0?ha:c)*96|0)>>>0)/10|0)>>>0>=e>>>0)){k[b>>2]=2;c=k[w+(y*60|0)+28>>2]|0;b=(k[w+(y*60|0)+32>>2]|0)-c|0;if((b|0)<=0)break;ha=b>>2;zpb(c|0,0,((((ha|0)<1?ha:1)^1073741823)+ha<<2)+8|0)|0;break}k[b>>2]=1;i=w+(y*60|0)+28|0;k[w+(y*60|0)+40>>2]=e;d=(e>>>5)+1|0;h=w+(y*60|0)+32|0;b=k[h>>2]|0;c=k[i>>2]|0;e=b-c>>2;f=c;g=b;if(d>>>0<=e>>>0){if(d>>>0<e>>>0?(ea=f+(d<<2)|0,(g|0)!=(ea|0)):0){b=g+(~((g+-4-ea|0)>>>2)<<2)|0;k[h>>2]=b}}else{r4(i,d-e|0);c=k[i>>2]|0;b=k[h>>2]|0}b=b-c|0;if((b|0)>0){ha=b>>2;zpb(c|0,0,((((ha|0)<1?ha:1)^1073741823)+ha<<2)+8|0)|0}c=k[j>>2]|0;e=w+(y*60|0)+16|0;b=c;if((b|0)==(e|0))break;d=k[i>>2]|0;while(1){ha=k[b+16>>2]|0;b=d+(ha>>>5<<2)|0;k[b>>2]=k[b>>2]|1<<(ha&31);b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(e|0))break d;else c=b}}k[b>>2]=0;g=w+(y*60|0)+4|0;d=k[g>>2]|0;c=k[x>>2]|0;b=(d-c|0)/12|0;if(e>>>0<=b>>>0){if(e>>>0<b>>>0?(ca=c+(e*12|0)|0,(d|0)!=(ca|0)):0)while(1){b=d+-12|0;k[g>>2]=b;e=k[b>>2]|0;f=e;if(e){b=d+-8|0;c=k[b>>2]|0;if((c|0)!=(e|0))k[b>>2]=c+(~((c+-4-f|0)>>>2)<<2);ggb(e);b=k[g>>2]|0}if((b|0)==(ca|0))break;else d=b}}else RIa(x,e-b|0);c=k[j>>2]|0;f=w+(y*60|0)+16|0;b=c;if((b|0)!=(f|0))while(1){d=(k[x>>2]|0)+((k[b+16>>2]|0)*12|0)|0;e=b+20|0;if((d|0)!=(e|0))s4(d,k[e>>2]|0,k[b+24>>2]|0);b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}gIa(k[f>>2]|0);k[h>>2]=0;k[j>>2]=f;k[f>>2]=0}while(0);y=y+1|0;if(y>>>0>=(k[ba>>2]|0)>>>0){W=44;break}}if((W|0)==44){r=ga;return}else if((W|0)==53)ad(426534,426557,304,426811);else if((W|0)==62)ad(426534,426557,304,426811)}function BOa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=r;r=r+32|0;u=y;v=y+28|0;w=u+8|0;x=u+12|0;p=u+20|0;q=u+16|0;k[u>>2]=94768;k[u+24>>2]=e;s=u+4|0;k[p>>2]=0;k[x>>2]=q;k[q>>2]=0;k[w>>2]=2147483647;i[s>>0]=0;if(!(k[b>>2]|0)){k[u>>2]=94728;x=k[q>>2]|0;LOa(x);r=y;return}t=c+12|0;l=c+8|0;m=b+12|0;n=b+8|0;o=d+12|0;j=d+8|0;if((e|0)<=0){c=0;d=0;while(1){LOa(d);k[p>>2]=0;k[x>>2]=q;k[q>>2]=0;k[w>>2]=2147483647;i[s>>0]=0;d=(k[m>>2]|0)+(aa(k[n>>2]|0,c)|0)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,u,d,f);d=ZT(12)|0;k[d>>2]=1;g=d+4|0;i[d+10>>0]=0;i[g>>0]=i[373546]|0;i[g+1>>0]=i[373547]|0;i[g+2>>0]=i[373548]|0;i[g+3>>0]=i[373549]|0;i[g+4>>0]=i[373550]|0;i[g+5>>0]=i[373551]|0;i[v>>0]=1;g=xIa(f,g,v)|0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);d=k[u>>2]|0;if(g){g=(k[t>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0;h=(k[o>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;dh[k[d+28>>2]&255](u,g,h,e)}else{g=(k[t>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0;h=(k[o>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;dh[k[d+24>>2]&255](u,g,h,e)}c=c+1|0;if(c>>>0>=(k[b>>2]|0)>>>0)break;d=k[q>>2]|0}k[u>>2]=94728;x=k[q>>2]|0;LOa(x);r=y;return}h=e<<2;c=0;d=0;while(1){LOa(d);k[p>>2]=0;k[x>>2]=q;k[q>>2]=0;k[w>>2]=2147483647;i[s>>0]=0;zpb((k[t>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0,-1,h|0)|0;d=e;g=(k[o>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;while(1){k[g>>2]=2147483647;if((d|0)>1){d=d+-1|0;g=g+4|0}else break}d=(k[m>>2]|0)+(aa(k[n>>2]|0,c)|0)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,u,d,f);d=ZT(12)|0;k[d>>2]=1;g=d+4|0;i[d+10>>0]=0;i[g>>0]=i[373546]|0;i[g+1>>0]=i[373547]|0;i[g+2>>0]=i[373548]|0;i[g+3>>0]=i[373549]|0;i[g+4>>0]=i[373550]|0;i[g+5>>0]=i[373551]|0;i[v>>0]=1;g=xIa(f,g,v)|0;z=k[d>>2]|0;k[d>>2]=z+-1;if((z|0)==1)ggb(k[d+-4>>2]|0);d=k[u>>2]|0;if(g){g=(k[t>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0;z=(k[o>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;dh[k[d+28>>2]&255](u,g,z,e)}else{g=(k[t>>2]|0)+((aa(k[l>>2]|0,c)|0)<<2)|0;z=(k[o>>2]|0)+((aa(k[j>>2]|0,c)|0)<<2)|0;dh[k[d+24>>2]&255](u,g,z,e)}c=c+1|0;if(c>>>0>=(k[b>>2]|0)>>>0)break;d=k[q>>2]|0}k[u>>2]=94728;z=k[q>>2]|0;LOa(z);r=y;return}function COa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+32|0;n=p;h=p+28|0;if((k[b>>2]|0)==1){o=k[c+4>>2]|0;g=(o|0)==0;m=g?0:k[c+12>>2]|0;g=g?0:k[d+12>>2]|0;k[n+8>>2]=2147483647;j=n+20|0;l=n+16|0;k[n>>2]=94688;k[n+24>>2]=~~e;i[n+4>>0]=1;k[j>>2]=0;k[n+12>>2]=l;k[l>>2]=0;dh[k[(k[a>>2]|0)+48>>2]&255](a,n,k[b+12>>2]|0,f);do if((o|0)>0){c=ZT(12)|0;k[c>>2]=1;d=c+4|0;i[c+10>>0]=0;i[d>>0]=i[373546]|0;i[d+1>>0]=i[373547]|0;i[d+2>>0]=i[373548]|0;i[d+3>>0]=i[373549]|0;i[d+4>>0]=i[373550]|0;i[d+5>>0]=i[373551]|0;i[h>>0]=1;d=xIa(f,d,h)|0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0);c=k[n>>2]|0;if(d){dh[k[c+28>>2]&255](n,m,g,o);break}else{dh[k[c+24>>2]&255](n,m,g,o);break}}while(0);o=k[j>>2]|0;k[n>>2]=94728;LOa(k[l>>2]|0);r=p;return o|0}c=k[41482]|0;d=(c|0)==0;if((k[41497]|0)>-1){do if(d){c=i[165986]|0;i[165986]=c+255|c;c=k[41478]|0;if(!(c&8)){k[41480]=0;k[41479]=0;d=k[41489]|0;k[41485]=d;k[41483]=d;c=d+(k[41490]|0)|0;k[41482]=c;break}k[41478]=c|32;o=-1;r=p;return o|0}else d=k[41483]|0;while(0);if((c-d|0)>>>0<57){ci[k[165948>>2]&255](165912,373488,57)|0;o=-1;r=p;return o|0}do if((i[165987]|0)>-1)if((ci[k[165948>>2]&255](165912,373488,57)|0)>>>0<57){o=-1;r=p;return o|0}else{c=0;a=373545;d=k[41483]|0;break}else{c=57;a=373488}while(0);upb(d|0,a|0,c|0)|0;k[41483]=(k[41483]|0)+c;o=-1;r=p;return o|0}else{do if(d){c=i[165986]|0;i[165986]=c+255|c;c=k[41478]|0;if(!(c&8)){k[41480]=0;k[41479]=0;d=k[41489]|0;k[41485]=d;k[41483]=d;c=d+(k[41490]|0)|0;k[41482]=c;break}k[41478]=c|32;o=-1;r=p;return o|0}else d=k[41483]|0;while(0);if((c-d|0)>>>0<57){ci[k[165948>>2]&255](165912,373488,57)|0;o=-1;r=p;return o|0}do if((i[165987]|0)>-1)if((ci[k[165948>>2]&255](165912,373488,57)|0)>>>0<57){o=-1;r=p;return o|0}else{c=0;a=373545;d=k[41483]|0;break}else{c=57;a=373488}while(0);upb(d|0,a|0,c|0)|0;k[41483]=(k[41483]|0)+c;o=-1;r=p;return o|0}return 0}function DOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;h=a+48|0;j=b+76|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}b:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break b}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;f=k[b+44>>2]|0;k[b+28>>2]=f;g=b+20|0;k[g>>2]=f;d=f+(k[b+48>>2]|0)|0;k[e>>2]=d;e=f;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;d=c;g=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}c:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;d=h;break c}d=e+-1|0;if((i[h+d>>0]|0)==10)break;else e=d}if((ci[k[b+36>>2]&255](b,h,e)|0)>>>0<e>>>0)break a;f=4-e|0;d=h+e|0;c=k[g>>2]|0}else{f=4;d=h}while(0);upb(c|0,d|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f}while(0);h=a+52|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;d:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}e:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break e}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}f:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break f}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+56|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;g:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}h:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break h}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}i:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break i}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+16|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;j:do if((k[j>>2]|0)>-1){do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<16){ci[k[b+36>>2]&255](b,h,16)|0;break}k:do if((i[b+75>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=h;c=f;break k}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=16-d|0;d=h+d|0;c=k[g>>2]|0}else{e=16;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;g=i[c>>0]|0;i[c>>0]=g+255|g;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<16){ci[k[b+36>>2]&255](b,h,16)|0;break}l:do if((i[b+75>>0]|0)>-1){d=16;while(1){if(!d){e=16;d=h;c=f;break l}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=16-d|0;d=h+d|0;c=k[g>>2]|0}else{e=16;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);d=k[a+28>>2]|0;e=aa(k[a+20>>2]|0,k[h>>2]|0)|0;g=b+16|0;f=k[g>>2]|0;c=(f|0)==0;if((k[j>>2]|0)>-1){do if(c){c=b+74|0;j=i[c>>0]|0;i[c>>0]=j+255|j;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;j=k[b+44>>2]|0;k[b+28>>2]=j;h=b+20|0;k[h>>2]=j;f=j+(k[b+48>>2]|0)|0;k[g>>2]=f;g=j;break}k[b>>2]=c|32;return}else{g=b+20|0;h=g;g=k[g>>2]|0}while(0);c=g;if((f-g|0)>>>0<e>>>0){ci[k[b+36>>2]&255](b,d,e)|0;return}m:do if((i[b+75>>0]|0)>-1){g=e;while(1){if(!g)break m;f=g+-1|0;if((i[d+f>>0]|0)==10)break;else g=f}if((ci[k[b+36>>2]&255](b,d,g)|0)>>>0<g>>>0)return;else{e=e-g|0;d=d+g|0;c=k[h>>2]|0;break}}while(0);upb(c|0,d|0,e|0)|0;k[h>>2]=(k[h>>2]|0)+e;return}else{do if(c){c=b+74|0;j=i[c>>0]|0;i[c>>0]=j+255|j;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;j=k[b+44>>2]|0;k[b+28>>2]=j;h=b+20|0;k[h>>2]=j;f=j+(k[b+48>>2]|0)|0;k[g>>2]=f;g=j;break}k[b>>2]=c|32;return}else{g=b+20|0;h=g;g=k[g>>2]|0}while(0);c=g;if((f-g|0)>>>0<e>>>0){ci[k[b+36>>2]&255](b,d,e)|0;return}n:do if((i[b+75>>0]|0)>-1){g=e;while(1){if(!g)break n;f=g+-1|0;if((i[d+f>>0]|0)==10)break;else g=f}if((ci[k[b+36>>2]&255](b,d,g)|0)>>>0<g>>>0)return;else{e=e-g|0;d=d+g|0;c=k[h>>2]|0;break}}while(0);upb(c|0,d|0,e|0)|0;k[h>>2]=(k[h>>2]|0)+e;return}}function EOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o+8|0;h=o;j=a+48|0;if((_fb(j,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}l=a+52|0;if((_fb(l,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}m=a+56|0;if((_fb(m,4,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}e=a+16|0;if((_fb(e,16,1,b)|0)!=1){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}f=a+20|0;g=aa(k[f>>2]|0,k[e>>2]|0)|0;d=(g|0)==0?1:g;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[a+28>>2]=c;g=_fb(c,1,g,b)|0;if((g|0)!=(aa(k[f>>2]|0,k[e>>2]|0)|0)){o=te(44)|0;VHa(o,373124);Cf(o|0,19720,57)}Uh[k[(k[a>>2]|0)+8>>2]&2047](a);g=a+36|0;c=n+4|0;d=ZT(16)|0;k[d>>2]=1;b=d+4|0;k[n>>2]=b;k[c>>2]=9;i[d+13>>0]=0;e=373358;f=b+9|0;do{i[b>>0]=i[e>>0]|0;b=b+1|0;e=e+1|0}while((b|0)<(f|0));f=WHa(g,n)|0;e=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[h>>2]=e;e=k[f>>2]|0;a=f+4|0;jh[k[k[e>>2]>>2]&1023](e,a);k[f>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,h,a);k[c>>2]=0;k[n>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);c=n+4|0;d=ZT(20)|0;k[d>>2]=1;b=d+4|0;k[n>>2]=b;k[c>>2]=12;i[d+16>>0]=0;e=373387;f=b+12|0;do{i[b>>0]=i[e>>0]|0;b=b+1|0;e=e+1|0}while((b|0)<(f|0));a=WHa(g,n)|0;f=k[a>>2]|0;h=a+4|0;jh[k[k[f>>2]>>2]&1023](f,h);k[a>>2]=428732;Ph[k[(k[107183]|0)+4>>2]&511](428732,j,h);k[c>>2]=0;k[n>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);j=n+4|0;c=ZT(16)|0;k[c>>2]=1;a=c+4|0;k[n>>2]=a;k[j>>2]=8;i[c+12>>0]=0;f=a;i[f>>0]=107;i[f+1>>0]=101;i[f+2>>0]=121;i[f+3>>0]=95;a=a+4|0;i[a>>0]=115;i[a+1>>0]=105;i[a+2>>0]=122;i[a+3>>0]=101;a=WHa(g,n)|0;f=k[a>>2]|0;h=a+4|0;jh[k[k[f>>2]>>2]&1023](f,h);k[a>>2]=428732;Ph[k[(k[107183]|0)+4>>2]&511](428732,l,h);k[j>>2]=0;k[n>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)==1)ggb(k[c+-4>>2]|0);c=n+4|0;d=ZT(24)|0;k[d>>2]=1;b=d+4|0;k[n>>2]=b;k[c>>2]=17;i[d+21>>0]=0;e=373400;f=b+17|0;do{i[b>>0]=i[e>>0]|0;b=b+1|0;e=e+1|0}while((b|0)<(f|0));j=WHa(g,n)|0;h=k[j>>2]|0;l=j+4|0;jh[k[k[h>>2]>>2]&1023](h,l);k[j>>2]=428732;Ph[k[(k[107183]|0)+4>>2]&511](428732,m,l);k[c>>2]=0;k[n>>2]=0;n=k[d>>2]|0;k[d>>2]=n+-1;if((n|0)!=1){r=o;return}ggb(k[d+-4>>2]|0);r=o;return}function FOa(a){a=a|0;return k[a+16>>2]|0}function GOa(a){a=a|0;return k[a+32>>2]|0}function HOa(a){a=a|0;return k[a+16>>2]<<2|0}function IOa(a){a=a|0;return 6}function JOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+36>>2]|0;f=b+40|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function KOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=k[a+4>>2]|0;x=k[a+8>>2]|0;if((d|0)==(x|0))return;y=a+64|0;u=a+28|0;v=a+24|0;w=a+20|0;t=a+60|0;do{a=k[d+48>>2]|0;m=k[d+52>>2]|0;if((a|0)==(m|0))f=0;else{f=0;e=1;j=c;while(1){h=k[j>>2]|0;g=k[a>>2]|0;if(g)do{r=g&0-g;f=(r&h|0?e:0)+f|0;g=r^g;e=e<<1}while((g|0)!=0);a=a+4|0;if((a|0)==(m|0))break;else j=j+4|0}}a=k[t>>2]|0;o=k[y>>2]|0;a:do if((a|0)!=(o|0)){p=d+24|0;q=d+28|0;r=d+16|0;n=a;while(1){h=k[n>>2]^f;switch(k[p>>2]|0){case 0:{a=(k[d>>2]|0)+(h*12|0)|0;if(a|0){s=a;B=28}break}case 1:{if(k[(k[q>>2]|0)+(h>>>5<<2)>>2]&1<<(h&31)|0){e=k[r>>2]|0;if(e){a=r;b:while(1){g=e;while(1){if((k[g+16>>2]|0)>>>0>=h>>>0)break;e=k[g+4>>2]|0;if(!e)break b;else g=e}e=k[g>>2]|0;if(!e){a=g;break}else a=g}if(!((a|0)!=(r|0)?(k[a+16>>2]|0)>>>0<=h>>>0:0))B=18}else B=18;if((B|0)==18)a=r;s=a+20|0;B=28}break}case 2:{e=k[r>>2]|0;if(e|0){a=r;c:while(1){g=e;while(1){if((k[g+16>>2]|0)>>>0>=h>>>0)break;e=k[g+4>>2]|0;if(!e)break c;else g=e}e=k[g>>2]|0;if(!e){a=g;break}else a=g}if((a|0)!=(r|0)?(k[a+16>>2]|0)>>>0<=h>>>0:0){s=a+20|0;B=28}}break}default:{}}if((B|0)==28?(B=0,z=k[s>>2]|0,A=k[s+4>>2]|0,z>>>0<A>>>0):0){j=z;do{m=k[j>>2]|0;g=(k[u>>2]|0)+(aa(k[v>>2]|0,m)|0)|0;h=k[w>>2]|0;if(!h)a=0;else{a=0;e=0;do{a=(l[376255+((i[g+e>>0]^i[c+e>>0])&255)>>0]|0)+a|0;e=e+1|0}while((e|0)!=(h|0))}Ph[k[(k[b>>2]|0)+12>>2]&511](b,a,m);j=j+4|0}while(j>>>0<A>>>0)}n=n+4|0;if((n|0)==(o|0))break a}}while(0);d=d+60|0}while((d|0)!=(x|0));return}function LOa(a){a=a|0;if(!a)return;else{LOa(k[a>>2]|0);LOa(k[a+4>>2]|0);ggb(a);return}}function MOa(a){a=a|0;k[a>>2]=94728;LOa(k[a+16>>2]|0);return}function NOa(a){a=a|0;k[a>>2]=94728;LOa(k[a+16>>2]|0);ggb(a);return}function OOa(a){a=a|0;return (i[a+4>>0]|0)!=0|0}function POa(a){a=a|0;return k[a+8>>2]|0}function QOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=k[a+12>>2]|0;g=a+16|0;if((d|0)<0){if((e|0)==(g|0))return;while(1){k[b>>2]=k[e+20>>2];k[c>>2]=k[e+16>>2];a=k[e+4>>2]|0;if(!a)while(1){a=k[e+8>>2]|0;if((k[a>>2]|0)==(e|0))break;else e=a}else while(1){e=k[a>>2]|0;if(!e)break;else a=e}if((a|0)==(g|0))break;else{b=b+4|0;c=c+4|0;e=a}}return}else{if(!((e|0)!=(g|0)&(d|0)!=0))return;f=0;while(1){k[b>>2]=k[e+20>>2];k[c>>2]=k[e+16>>2];a=k[e+4>>2]|0;if(!a){a=e;while(1){e=k[a+8>>2]|0;if((k[e>>2]|0)==(a|0))break;else a=e}}else{e=a;while(1){a=k[e>>2]|0;if(!a)break;else e=a}}f=f+1|0;if(!((e|0)!=(g|0)&(f|0)<(d|0)))break;else{c=c+4|0;b=b+4|0}}return}}function ROa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dh[k[(k[a>>2]|0)+24>>2]&255](a,b,c,d);return}function SOa(a){a=a|0;k[a>>2]=94728;LOa(k[a+16>>2]|0);ggb(a);return}function TOa(a){a=a|0;return 1}function UOa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=r;r=r+16|0;h=j;if((k[a+24>>2]|0)<(b|0)){r=j;return}i=a+12|0;e=a+16|0;d=k[e>>2]|0;do if(d){while(1){e=d+16|0;f=k[e>>2]|0;if((f|0)<=(b|0)?(g=(f|0)==(b|0),!(g&(k[e+4>>2]|0)>>>0>c>>>0)):0){if((f|0)>=(b|0)){if(!g){e=13;break}if((k[d+20>>2]|0)>>>0>=c>>>0){e=13;break}}f=d+4|0;e=k[f>>2]|0;if(!e){e=12;break}else d=e}else{e=k[d>>2]|0;if(!e){e=6;break}else d=e}}if((e|0)==6){k[h>>2]=d;g=d;f=d;break}else if((e|0)==12){k[h>>2]=d;g=d;break}else if((e|0)==13){k[h>>2]=d;g=d;f=h;break}}else{k[h>>2]=e;g=e;f=e}while(0);if(!(k[f>>2]|0)){while(1){d=fgb(24)|0;if(d|0)break;h=k[207666]|0;k[207666]=h+0;Qh[h&7]()}e=d+16|0;k[e>>2]=b;k[e+4>>2]=c;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=g;k[f>>2]=d;e=k[k[i>>2]>>2]|0;if(e){k[i>>2]=e;d=k[f>>2]|0}B4(k[a+16>>2]|0,d);a=a+20|0;k[a>>2]=(k[a>>2]|0)+1}r=j;return}function VOa(a){a=a|0;return k[a+24>>2]|0}function WOa(a){a=a|0;var b=0;b=a+16|0;LOa(k[b>>2]|0);k[a+20>>2]=0;k[a+12>>2]=b;k[b>>2]=0;return}function XOa(a){a=a|0;k[a>>2]=94728;LOa(k[a+16>>2]|0);ggb(a);return}function YOa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+16|0;j=s;q=a+8|0;if((k[q>>2]|0)<=(b|0)){r=s;return}o=a+12|0;e=a+16|0;d=k[e>>2]|0;do if(d){while(1){f=d+16|0;g=k[f>>2]|0;if((g|0)<=(b|0)?(h=(g|0)==(b|0),!(h&(k[f+4>>2]|0)>>>0>c>>>0)):0){if((g|0)>=(b|0)){if(!h){p=13;break}if((k[d+20>>2]|0)>>>0>=c>>>0){p=13;break}}g=d+4|0;f=k[g>>2]|0;if(!f){p=12;break}else d=f}else{f=k[d>>2]|0;if(!f){p=6;break}else d=f}}if((p|0)==6){k[j>>2]=d;f=d;g=d;break}else if((p|0)==12){k[j>>2]=d;f=d;break}else if((p|0)==13){k[j>>2]=d;f=d;g=j;break}}else{k[j>>2]=e;f=e;g=e}while(0);if(!(k[g>>2]|0)){while(1){d=fgb(24)|0;if(d|0)break;l=k[207666]|0;k[207666]=l+0;Qh[l&7]()}l=d+16|0;k[l>>2]=b;k[l+4>>2]=c;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[g>>2]=d;f=k[k[o>>2]>>2]|0;if(f){k[o>>2]=f;d=k[g>>2]|0}B4(k[a+16>>2]|0,d);c=a+20|0;l=(k[c>>2]|0)+1|0;k[c>>2]=l}else l=k[a+20>>2]|0;d=a+4|0;f=k[a+24>>2]|0;if(!(i[d>>0]|0)){if((l|0)!=(f|0)){r=s;return}i[d>>0]=1;d=k[e>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))e=d;else break}else while(1){e=k[d+4>>2]|0;if(!e)break;else d=e}k[q>>2]=k[d+16>>2];r=s;return}if(l>>>0<=f>>>0){r=s;return}d=k[e>>2]|0;if(!d){g=e;while(1){f=k[g+8>>2]|0;if((k[f>>2]|0)==(g|0))g=f;else break}}else{f=d;while(1){g=k[f+4>>2]|0;if(!g)break;else f=g}}if(d){b=f+16|0;c=k[b>>2]|0;b=k[b+4>>2]|0;j=e;h=d;a:while(1){g=h;while(1){h=k[g+16>>2]|0;if((h|0)>=(c|0)){if((h|0)!=(c|0))break;if((k[g+20>>2]|0)>>>0>=b>>>0)break}g=k[g+4>>2]|0;if(!g)break a}h=k[g>>2]|0;if(!h){j=g;break}else j=g}do if((j|0)!=(e|0)?(m=j+16|0,n=k[m>>2]|0,m=k[m+4>>2]|0,(c|0)>=(n|0)):0){if((c|0)==(n|0)?(k[f+20>>2]|0)>>>0<m>>>0:0)break;f=k[j+4>>2]|0;if(!f){g=j;while(1){f=k[g+8>>2]|0;if((k[f>>2]|0)==(g|0))break;else g=f}}else while(1){g=k[f>>2]|0;if(!g)break;else f=g}if((k[o>>2]|0)==(j|0))k[o>>2]=f;k[a+20>>2]=l+-1;bya(d,j);ggb(j);d=k[e>>2]|0}while(0);if(d)while(1){e=k[d+4>>2]|0;if(!e)break;else d=e}else p=47}else p=47;if((p|0)==47)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0)){e=d;p=47}else break}k[q>>2]=k[d+16>>2];r=s;return}function ZOa(a){a=a|0;var b=0;b=a+16|0;LOa(k[b>>2]|0);k[a+20>>2]=0;k[a+12>>2]=b;k[b>>2]=0;k[a+8>>2]=2147483647;i[a+4>>0]=0;return}function _Oa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+32|0;A=B;$Ia(A,d);a:do if((b|0)>0){y=A+16|0;w=a+24|0;x=a+20|0;v=a+16|0;a=k[A+12>>2]|0;z=k[A>>2]|0;g=k[y>>2]|0;d=0;b:while(1){u=e+(d<<2)|0;h=(g|0)==(a|0);if((d|0)>0){if(h){a=z;m=20;break a}while(1){h=g;g=g+1|0;h=k[z+(h<<2)>>2]|0;if((h|0)<0){a=g;m=19;break b}q=k[c+(h<<2)>>2]|0;k[u>>2]=q;o=k[w>>2]|0;p=k[x>>2]|0;q=o+(aa(p,q)|0)|0;s=k[v>>2]|0;if(s|0){m=0;n=0;do{t=o+(aa(k[e+(m<<2)>>2]|0,p)|0)|0;h=0;j=0;do{h=(l[376255+((i[t+j>>0]^i[q+j>>0])&255)>>0]|0)+h|0;j=j+1|0}while((j|0)!=(s|0));n=(h|0)<1?1:n;m=m+1|0}while((m|0)!=(d|0));if(!(n&1))break}if((g|0)==(a|0)){m=19;break b}}k[y>>2]=g}else{if(h){a=z;m=20;break a}h=g+1|0;k[y>>2]=h;g=k[z+(g<<2)>>2]|0;if((g|0)<0){m=15;break}k[u>>2]=k[c+(g<<2)>>2];g=h}d=d+1|0;if((d|0)>=(b|0)){a=z;m=20;break a}}if((m|0)==15){k[f>>2]=d;h=z;j=z;g=z;break}else if((m|0)==19){k[y>>2]=a;a=z;m=20;break}}else{d=0;a=k[A>>2]|0;m=20}while(0);if((m|0)==20){k[f>>2]=d;if(!a){r=B;return}else{h=a;j=a;g=a}}d=A+4|0;a=k[d>>2]|0;if((a|0)!=(h|0))k[d>>2]=a+(~((a+-4-j|0)>>>2)<<2);ggb(g);r=B;return}function $Oa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=428e3;A=Epb(k[A>>2]|0,k[A+4>>2]|0,1284865837,1481765933)|0;A=kpb(A|0,N|0,1,0)|0;B=N;z=428e3;k[z>>2]=A;k[z+4>>2]=B;B=ppb(A|0,B|0,33)|0;k[e>>2]=k[c+(~~(+(d|0)*(+(B|0)*4.656612873077393e-10))<<2)>>2];if((b|0)<=1){e=1;k[f>>2]=e;return}z=(d|0)>0;A=a+24|0;B=a+20|0;y=a+16|0;a=1;while(1){if(!z){a=1;g=16;break}t=k[A>>2]|0;u=k[B>>2]|0;v=t+(aa(u,k[e>>2]|0)|0)|0;w=k[y>>2]|0;x=(a|0)>1;if(!w){g=16;break}else{q=0;r=0;s=-1;j=w}while(1){p=t+(aa(k[c+(q<<2)>>2]|0,u)|0)|0;g=0;h=0;do{g=(l[376255+((i[p+h>>0]^i[v+h>>0])&255)>>0]|0)+g|0;h=h+1|0}while((h|0)!=(w|0));a:do if(x){if(!j){h=1;while(1){g=(g|0)>0?0:g;h=h+1|0;if((h|0)==(a|0)){j=0;break a}}}else o=1;do{n=t+(aa(u,k[e+(o<<2)>>2]|0)|0)|0;h=0;m=0;do{h=(l[376255+((i[p+m>>0]^i[n+m>>0])&255)>>0]|0)+h|0;m=m+1|0}while((m|0)!=(j|0));g=(h|0)<(g|0)?h:g;o=o+1|0}while((o|0)!=(a|0))}while(0);h=(g|0)>(r|0);s=h?q:s;q=q+1|0;if((q|0)==(d|0))break;else r=h?g:r}if((s|0)==-1){g=16;break}k[e+(a<<2)>>2]=k[c+(s<<2)>>2];a=a+1|0;if((a|0)>=(b|0)){g=16;break}}if((g|0)==16){k[f>>2]=a;return}}function aPa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=d>>>0>1073741823?-1:d<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}v=428e3;v=Epb(k[v>>2]|0,k[v+4>>2]|0,1284865837,1481765933)|0;v=kpb(v|0,N|0,1,0)|0;w=N;h=428e3;k[h>>2]=v;k[h+4>>2]=w;h=ppb(v|0,w|0,33)|0;h=c+(~~(+(d|0)*(+(h|0)*4.656612873077393e-10))<<2)|0;k[e>>2]=k[h>>2];E=(d|0)>0;if(E){s=k[a+24>>2]|0;t=k[a+20>>2]|0;u=k[a+16>>2]|0;q=s+(aa(k[h>>2]|0,t)|0)|0;r=(u|0)==0;p=0;j=0.0;do{o=s+(aa(t,k[c+(p<<2)>>2]|0)|0)|0;if(r)h=0;else{h=0;m=0;do{h=(l[376255+((i[q+m>>0]^i[o+m>>0])&255)>>0]|0)+h|0;m=m+1|0}while((m|0)!=(u|0))}D=aa(h,h)|0;k[g+(p<<2)>>2]=D;j=j+ +(D|0);p=p+1|0}while((p|0)!=(d|0))}else j=0.0;if((b|0)<=1){e=1;k[f>>2]=e;ggb(g);return}A=d+-1|0;B=(d|0)>1;C=a+24|0;D=a+20|0;z=a+16|0;y=1;do{a=Epb(v|0,w|0,1284865837,1481765933)|0;v=kpb(a|0,N|0,1,0)|0;w=N;a:do if(B){a=ppb(v|0,w|0,33)|0;h=0;j=j*(+(a|0)*4.656612873077393e-10)+0.0;while(1){n=+(k[g+(h<<2)>>2]|0);if(j<=n)break;h=h+1|0;if((h|0)<(A|0))j=j-n;else break}if(!E){k[e+(y<<2)>>2]=k[c+(h<<2)>>2];j=0.0;break}a=k[C>>2]|0;t=k[D>>2]|0;m=k[c+(h<<2)>>2]|0;u=a+(aa(m,t)|0)|0;s=k[z>>2]|0;if(!s){o=0;j=0.0;while(1){x=k[g+(o<<2)>>2]|0;j=j+ +(((x|0)<0?x:0)|0);o=o+1|0;if((o|0)==(d|0)){u=a;x=25;break a}}}else{r=0;j=0.0}do{q=a+(aa(t,k[c+(r<<2)>>2]|0)|0)|0;o=0;p=0;do{o=(l[376255+((i[u+p>>0]^i[q+p>>0])&255)>>0]|0)+o|0;p=p+1|0}while((p|0)!=(s|0));x=aa(o,o)|0;q=k[g+(r<<2)>>2]|0;j=j+ +(((q|0)<(x|0)?q:x)|0);r=r+1|0}while((r|0)!=(d|0));u=a;x=25}else{if(!E){k[e+(y<<2)>>2]=k[c>>2];j=0.0;break}u=k[C>>2]|0;r=k[D>>2]|0;m=k[c>>2]|0;s=u+(aa(m,r)|0)|0;t=k[z>>2]|0;if(!t){h=0;j=0.0;while(1){x=k[g+(h<<2)>>2]|0;j=j+ +(((x|0)<0?x:0)|0);h=h+1|0;if((h|0)==(d|0)){h=0;x=25;break a}}}else{q=0;j=0.0;h=m}while(1){p=u+(aa(r,h)|0)|0;h=0;o=0;do{h=(l[376255+((i[s+o>>0]^i[p+o>>0])&255)>>0]|0)+h|0;o=o+1|0}while((o|0)!=(t|0));h=aa(h,h)|0;x=k[g+(q<<2)>>2]|0;j=j+ +(((x|0)<(h|0)?x:h)|0);h=q+1|0;if((h|0)==(d|0)){h=0;x=25;break a}q=h;h=k[c+(h<<2)>>2]|0}}while(0);if((x|0)==25){x=0;k[e+(y<<2)>>2]=m;if(E){s=k[D>>2]|0;t=k[z>>2]|0;q=u+(aa(k[c+(h<<2)>>2]|0,s)|0)|0;r=(t|0)==0;p=0;do{o=u+(aa(s,k[c+(p<<2)>>2]|0)|0)|0;if(r)h=0;else{h=0;m=0;do{h=(l[376255+((i[q+m>>0]^i[o+m>>0])&255)>>0]|0)+h|0;m=m+1|0}while((m|0)!=(t|0))}o=aa(h,h)|0;a=g+(p<<2)|0;m=k[a>>2]|0;k[a>>2]=(m|0)<(o|0)?m:o;p=p+1|0}while((p|0)!=(d|0))}}y=y+1|0}while((y|0)!=(b|0));e=428e3;k[e>>2]=v;k[e+4>>2]=w;e=b;k[f>>2]=e;ggb(g);return}function bPa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=d>>>0>1073741823?-1:d<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}B=428e3;B=Epb(k[B>>2]|0,k[B+4>>2]|0,1284865837,1481765933)|0;B=kpb(B|0,N|0,1,0)|0;h=N;A=428e3;k[A>>2]=B;k[A+4>>2]=h;h=ppb(B|0,h|0,33)|0;h=c+(~~(+(d|0)*(+(h|0)*4.656612873077393e-10))<<2)|0;k[e>>2]=k[h>>2];B=(d|0)>0;if(B){s=k[a+24>>2]|0;t=k[a+20>>2]|0;u=k[a+16>>2]|0;q=s+(aa(k[h>>2]|0,t)|0)|0;r=(u|0)==0;p=0;do{o=s+(aa(t,k[c+(p<<2)>>2]|0)|0)|0;if(r)h=0;else{h=0;m=0;do{h=(l[376255+((i[q+m>>0]^i[o+m>>0])&255)>>0]|0)+h|0;m=m+1|0}while((m|0)!=(u|0))}k[g+(p<<2)>>2]=h;p=p+1|0}while((p|0)!=(d|0))}if((b|0)<=1){e=1;k[f>>2]=e;ggb(g);return}z=a+24|0;A=a+20|0;y=a+16|0;x=1;do{if(B){h=0;m=0;j=-1.0;w=0;do{v=k[g+(w<<2)>>2]|0;if(+(v|0)>+(h|0)*1.2999999523162842){t=k[z>>2]|0;s=k[A>>2]|0;u=t+(aa(k[c+(w<<2)>>2]|0,s)|0)|0;a=k[y>>2]|0;if(!a){o=0;n=0.0;do{a=k[g+(o<<2)>>2]|0;n=n+ +(((a|0)<0?a:0)|0);o=o+1|0}while((o|0)!=(d|0))}else{r=0;n=0.0;do{q=t+(aa(s,k[c+(r<<2)>>2]|0)|0)|0;o=0;p=0;do{o=(l[376255+((i[u+p>>0]^i[q+p>>0])&255)>>0]|0)+o|0;p=p+1|0}while((p|0)!=(a|0));q=k[g+(r<<2)>>2]|0;n=n+ +(((q|0)<(o|0)?q:o)|0);r=r+1|0}while((r|0)!=(d|0))}a=!(j<0.0)&!(n<=j);h=a?h:v;m=a?m:w;j=a?j:n}w=w+1|0}while((w|0)!=(d|0));t=c+(m<<2)|0;k[e+(x<<2)>>2]=k[t>>2];q=k[z>>2]|0;r=k[A>>2]|0;s=k[y>>2]|0;t=q+(aa(k[t>>2]|0,r)|0)|0;u=(s|0)==0;p=0;do{o=q+(aa(r,k[c+(p<<2)>>2]|0)|0)|0;if(u)h=0;else{h=0;m=0;do{h=(l[376255+((i[t+m>>0]^i[o+m>>0])&255)>>0]|0)+h|0;m=m+1|0}while((m|0)!=(s|0))}w=g+(p<<2)|0;v=k[w>>2]|0;k[w>>2]=(v|0)<(h|0)?v:h;p=p+1|0}while((p|0)!=(d|0))}else k[e+(x<<2)>>2]=k[c>>2];x=x+1|0}while((x|0)!=(b|0));k[f>>2]=b;ggb(g);return}function cPa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;k[a>>2]=94808;f=a+52|0;d=k[f>>2]|0;a:do if(d|0?(e=a+92|0,c=k[e>>2]|0,(c|0)>0):0){b=0;while(1){d=k[d+(b<<2)>>2]|0;if(d){ggb(d);k[(k[f>>2]|0)+(b<<2)>>2]=0;c=k[e>>2]|0}b=b+1|0;if((b|0)>=(c|0))break a;d=k[f>>2]|0}}while(0);b=k[a+48>>2]|0;if(b|0)ggb(b);b=k[f>>2]|0;if(b|0)ggb(b);c=a+64|0;b=k[c>>2]|0;if(b|0)do{f=b;b=k[b>>2]|0;ggb(f);k[c>>2]=b}while((b|0)!=0);YHa(k[a+32>>2]|0);return}function dPa(a){a=a|0;cPa(a);ggb(a);return}function ePa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;p=a+88|0;if((k[p>>2]|0)<2){r=te(44)|0;VHa(r,373858);Cf(r|0,19720,57)}q=a+52|0;d=k[q>>2]|0;o=a+92|0;b=k[o>>2]|0;a:do if(d){if((b|0)>0)c=0;else return;while(1){d=k[d+(c<<2)>>2]|0;if(d){ggb(d);k[(k[q>>2]|0)+(c<<2)>>2]=0;b=k[o>>2]|0}c=c+1|0;if((c|0)>=(b|0))break a;d=k[q>>2]|0}}while(0);if((b|0)<=0)return;f=a+40|0;g=a+60|0;h=a+80|0;j=a+64|0;l=a+68|0;m=a+48|0;n=a+76|0;e=0;do{d=k[f>>2]|0;c=d>>>0>1073741823?-1:d<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[(k[q>>2]|0)+(e<<2)>>2]=b;if(!d)b=0;else{d=k[(k[q>>2]|0)+(e<<2)>>2]|0;c=0;do{k[d+(c<<2)>>2]=c;c=c+1|0;b=k[f>>2]|0}while(c>>>0<b>>>0)}d=k[g>>2]|0;do if((d|0)<32){k[h>>2]=(k[h>>2]|0)+d;c=fgb(8192)|0;if(c|0){k[c>>2]=k[j>>2];k[j>>2]=c;k[g>>2]=8188;c=c+4|0;k[l>>2]=c;d=8188;r=46;break}b=k[41482]|0;c=(b|0)==0;b:do if((k[41497]|0)>-1){do if(c){b=i[165986]|0;i[165986]=b+255|b;b=k[41478]|0;if(!(b&8)){k[41480]=0;k[41479]=0;c=k[41489]|0;k[41485]=c;k[41483]=c;b=c+(k[41490]|0)|0;k[41482]=b;break}else{k[41478]=b|32;break b}}else c=k[41483]|0;while(0);if((b-c|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27)break;b=0;d=373857;c=k[41483]|0}else{b=27;d=373830}upb(c|0,d|0,b|0)|0;k[41483]=(k[41483]|0)+b}else{do if(c){b=i[165986]|0;i[165986]=b+255|b;b=k[41478]|0;if(!(b&8)){k[41480]=0;k[41479]=0;c=k[41489]|0;k[41485]=c;k[41483]=c;b=c+(k[41490]|0)|0;k[41482]=b;break}else{k[41478]=b|32;break b}}else c=k[41483]|0;while(0);if((b-c|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27)break;b=0;d=373857;c=k[41483]|0}else{b=27;d=373830}upb(c|0,d|0,b|0)|0;k[41483]=(k[41483]|0)+b}while(0);c=0;b=k[f>>2]|0}else{c=k[l>>2]|0;r=46}while(0);if((r|0)==46){r=0;k[l>>2]=c+32;k[g>>2]=d+-32;k[n>>2]=(k[n>>2]|0)+32}k[(k[m>>2]|0)+(e<<2)>>2]=c;rPa(a,k[(k[m>>2]|0)+(e<<2)>>2]|0,k[(k[q>>2]|0)+(e<<2)>>2]|0,b,k[p>>2]|0,0);e=e+1|0}while((e|0)<(k[o>>2]|0));return}function fPa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;x=r;r=r+32|0;w=x;t=x+28|0;u=w+8|0;v=w+12|0;m=w+20|0;n=w+16|0;k[w>>2]=94768;k[w+24>>2]=e;o=w+4|0;k[m>>2]=0;k[v>>2]=n;k[n>>2]=0;k[u>>2]=2147483647;i[o>>0]=0;if(!(k[b>>2]|0)){v=0;k[w>>2]=94728;LOa(v);r=x;return}p=b+12|0;q=b+8|0;s=c+12|0;j=c+8|0;l=d+12|0;h=d+8|0;g=0;c=0;do{LOa(c);k[m>>2]=0;k[v>>2]=n;k[n>>2]=0;k[u>>2]=2147483647;i[o>>0]=0;c=(k[p>>2]|0)+(aa(k[q>>2]|0,g)|0)|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,w,c,f);c=ZT(12)|0;k[c>>2]=1;d=c+4|0;i[c+10>>0]=0;i[d>>0]=i[373546]|0;i[d+1>>0]=i[373547]|0;i[d+2>>0]=i[373548]|0;i[d+3>>0]=i[373549]|0;i[d+4>>0]=i[373550]|0;i[d+5>>0]=i[373551]|0;i[t>>0]=1;d=xIa(f,d,t)|0;y=k[c>>2]|0;k[c>>2]=y+-1;if((y|0)==1)ggb(k[c+-4>>2]|0);c=k[w>>2]|0;if(d){d=(k[s>>2]|0)+((aa(k[j>>2]|0,g)|0)<<2)|0;y=(k[l>>2]|0)+((aa(k[h>>2]|0,g)|0)<<2)|0;dh[k[c+28>>2]&255](w,d,y,e)}else{d=(k[s>>2]|0)+((aa(k[j>>2]|0,g)|0)<<2)|0;y=(k[l>>2]|0)+((aa(k[h>>2]|0,g)|0)<<2)|0;dh[k[c+24>>2]&255](w,d,y,e)}g=g+1|0;c=k[n>>2]|0}while(g>>>0<(k[b>>2]|0)>>>0);k[w>>2]=94728;LOa(c);r=x;return}function gPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=a+88|0;y=b+76|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;a:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;x=i[c>>0]|0;i[c>>0]=x+255|x;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break a}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}b:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break b}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break a;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;x=i[c>>0]|0;i[c>>0]=x+255|x;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;x=k[b+44>>2]|0;k[b+28>>2]=x;g=b+20|0;k[g>>2]=x;d=x+(k[b+48>>2]|0)|0;k[e>>2]=d;e=x;break}else{k[b>>2]=c|32;break a}}else{e=b+20|0;d=c;g=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}c:do if((i[b+75>>0]|0)>-1){e=4;while(1){if(!e){f=4;d=h;break c}d=e+-1|0;if((i[h+d>>0]|0)==10)break;else e=d}if((ci[k[b+36>>2]&255](b,h,e)|0)>>>0<e>>>0)break a;f=4-e|0;d=h+e|0;c=k[g>>2]|0}else{f=4;d=h}while(0);upb(c|0,d|0,f|0)|0;k[g>>2]=(k[g>>2]|0)+f}while(0);x=a+92|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;d:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,x,4)|0;break}e:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=x;c=f;break e}c=d+-1|0;if((i[x+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,x,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=x+d|0;c=k[g>>2]|0}else{e=4;d=x;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break d}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,x,4)|0;break}f:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=x;c=f;break f}c=d+-1|0;if((i[x+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,x,d)|0)>>>0<d>>>0)break d;e=4-d|0;d=x+d|0;c=k[g>>2]|0}else{e=4;d=x;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+96|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;g:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}h:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break h}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break g}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}i:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break i}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break g;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+100|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;j:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}k:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break k}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break j}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}l:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break l}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break j;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);h=a+84|0;e=b+16|0;c=k[e>>2]|0;d=(c|0)==0;m:do if((k[y>>2]|0)>-1){do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break m}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}n:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break n}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break m;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(d){c=b+74|0;w=i[c>>0]|0;i[c>>0]=w+255|w;c=k[b>>2]|0;if(!(c&8)){k[b+8>>2]=0;k[b+4>>2]=0;d=k[b+44>>2]|0;k[b+28>>2]=d;g=b+20|0;k[g>>2]=d;c=d+(k[b+48>>2]|0)|0;k[e>>2]=c;break}else{k[b>>2]=c|32;break m}}else{d=b+20|0;g=d;d=k[d>>2]|0}while(0);f=d;if((c-d|0)>>>0<4){ci[k[b+36>>2]&255](b,h,4)|0;break}o:do if((i[b+75>>0]|0)>-1){d=4;while(1){if(!d){e=4;d=h;c=f;break o}c=d+-1|0;if((i[h+c>>0]|0)==10)break;else d=c}if((ci[k[b+36>>2]&255](b,h,d)|0)>>>0<d>>>0)break m;e=4-d|0;d=h+d|0;c=k[g>>2]|0}else{e=4;d=h;c=f}while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);if((k[x>>2]|0)<=0)return;j=a+52|0;l=a+40|0;m=a+48|0;n=b+16|0;o=b+74|0;p=b+8|0;q=b+4|0;r=b+44|0;s=b+28|0;t=b+20|0;u=b+48|0;v=b+36|0;w=b+75|0;h=0;do{d=k[(k[j>>2]|0)+(h<<2)>>2]|0;g=k[l>>2]<<2;c=k[n>>2]|0;e=(c|0)==0;p:do if((k[y>>2]|0)>-1){do if(e){c=i[o>>0]|0;i[o>>0]=c+255|c;c=k[b>>2]|0;if(!(c&8)){k[p>>2]=0;k[q>>2]=0;f=k[r>>2]|0;k[s>>2]=f;k[t>>2]=f;e=f+(k[u>>2]|0)|0;k[n>>2]=e;break}else{k[b>>2]=c|32;break p}}else{e=c;f=k[t>>2]|0}while(0);c=f;if((e-f|0)>>>0<g>>>0){ci[k[v>>2]&255](b,d,g)|0;break}q:do if((i[w>>0]|0)>-1){f=g;while(1){if(!f){e=g;break q}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[v>>2]&255](b,d,f)|0)>>>0<f>>>0)break p;e=g-f|0;d=d+f|0;c=k[t>>2]|0}else e=g;while(0);upb(c|0,d|0,e|0)|0;k[t>>2]=(k[t>>2]|0)+e}else{do if(e){c=i[o>>0]|0;i[o>>0]=c+255|c;c=k[b>>2]|0;if(!(c&8)){k[p>>2]=0;k[q>>2]=0;f=k[r>>2]|0;k[s>>2]=f;k[t>>2]=f;e=f+(k[u>>2]|0)|0;k[n>>2]=e;break}else{k[b>>2]=c|32;break p}}else{e=c;f=k[t>>2]|0}while(0);c=f;if((e-f|0)>>>0<g>>>0){ci[k[v>>2]&255](b,d,g)|0;break}r:do if((i[w>>0]|0)>-1){f=g;while(1){if(!f){e=g;break r}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[v>>2]&255](b,d,f)|0)>>>0<f>>>0)break p;e=g-f|0;d=d+f|0;c=k[t>>2]|0}else e=g;while(0);upb(c|0,d|0,e|0)|0;k[t>>2]=(k[t>>2]|0)+e}while(0);qPa(a,b,k[(k[m>>2]|0)+(h<<2)>>2]|0,h);h=h+1|0}while((h|0)<(k[x>>2]|0));return}function hPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+16|0;s=t+8|0;q=t;o=a+52|0;d=k[o>>2]|0;a:do if(d|0?(f=a+92|0,e=k[f>>2]|0,(e|0)>0):0){c=0;while(1){d=k[d+(c<<2)>>2]|0;if(d){ggb(d);k[(k[o>>2]|0)+(c<<2)>>2]=0;e=k[f>>2]|0}c=c+1|0;if((c|0)>=(e|0))break a;d=k[o>>2]|0}}while(0);j=a+48|0;c=k[j>>2]|0;if(c|0)ggb(c);c=k[o>>2]|0;if(c|0)ggb(c);l=a+88|0;if((_fb(l,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}m=a+92|0;if((_fb(m,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}n=a+96|0;if((_fb(n,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}p=a+100|0;if((_fb(p,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}if((_fb(a+84|0,4,1,b)|0)!=1){t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}f=k[m>>2]|0;d=f>>>0>1073741823?-1:f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0){e=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){e=0;break}Qh[c&7]()}k[o>>2]=e;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[j>>2]=c;b:do if((f|0)>0){h=a+40|0;c=0;g=e;while(1){f=k[h>>2]|0;e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[g+(c<<2)>>2]=d;if((_fb(k[(k[o>>2]|0)+(c<<2)>>2]|0,4,f,b)|0)!=(f|0))break;pPa(a,b,(k[j>>2]|0)+(c<<2)|0,c);c=c+1|0;if((c|0)>=(k[m>>2]|0))break b;g=k[o>>2]|0}t=te(44)|0;VHa(t,373124);Cf(t|0,19720,57)}while(0);h=a+28|0;c=s+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373358;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));o=WHa(h,s)|0;b=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[q>>2]=b;b=k[o>>2]|0;a=o+4|0;jh[k[k[b>>2]>>2]&1023](b,a);k[o>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,q,a);k[c>>2]=0;k[s>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0);c=s+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373742;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));a=WHa(h,s)|0;o=k[a>>2]|0;q=a+4|0;jh[k[k[o>>2]>>2]&1023](o,q);k[a>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,l,q);k[c>>2]=0;k[s>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0);q=s+4|0;c=ZT(12)|0;k[c>>2]=1;o=c+4|0;k[s>>2]=o;k[q>>2]=5;i[c+9>>0]=0;i[o>>0]=i[380533]|0;i[o+1>>0]=i[380534]|0;i[o+2>>0]=i[380535]|0;i[o+3>>0]=i[380536]|0;i[o+4>>0]=i[380537]|0;o=WHa(h,s)|0;b=k[o>>2]|0;a=o+4|0;jh[k[k[b>>2]>>2]&1023](b,a);k[o>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,m,a);k[q>>2]=0;k[s>>2]=0;q=k[c>>2]|0;k[c>>2]=q+-1;if((q|0)==1)ggb(k[c+-4>>2]|0);c=s+4|0;d=ZT(20)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[c>>2]=12;i[d+16>>0]=0;f=373752;g=e+12|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));a=WHa(h,s)|0;o=k[a>>2]|0;q=a+4|0;jh[k[k[o>>2]>>2]&1023](o,q);k[a>>2]=428728;Ph[k[(k[107182]|0)+4>>2]&511](428728,n,q);k[c>>2]=0;k[s>>2]=0;q=k[d>>2]|0;k[d>>2]=q+-1;if((q|0)==1)ggb(k[d+-4>>2]|0);c=s+4|0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[c>>2]=9;i[d+13>>0]=0;f=373765;g=e+9|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));a=WHa(h,s)|0;o=k[a>>2]|0;q=a+4|0;jh[k[k[o>>2]>>2]&1023](o,q);k[a>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,p,q);k[c>>2]=0;k[s>>2]=0;s=k[d>>2]|0;k[d>>2]=s+-1;if((s|0)!=1){r=t;return}ggb(k[d+-4>>2]|0);r=t;return}function iPa(a){a=a|0;return k[a+40>>2]|0}function jPa(a){a=a|0;return k[a+44>>2]|0}function kPa(a){a=a|0;return (k[a+80>>2]|0)+(k[a+76>>2]|0)+(k[a+84>>2]|0)|0}function lPa(a){a=a|0;return 5}function mPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+28>>2]|0;f=b+32|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function nPa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;x=r;r=r+16|0;w=x+4|0;v=x;e=ZT(12)|0;k[e>>2]=1;s=e+4|0;i[e+10>>0]=0;i[s>>0]=i[373823]|0;i[s+1>>0]=i[373824]|0;i[s+2>>0]=i[373825]|0;i[s+3>>0]=i[373826]|0;i[s+4>>0]=i[373827]|0;i[s+5>>0]=i[373828]|0;k[w>>2]=32;s=dIa(d,s,w)|0;q=k[e>>2]|0;k[e>>2]=q+-1;if((q|0)==1)ggb(k[e+-4>>2]|0);while(1){d=fgb(20)|0;if(d|0){p=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){p=0;break}Qh[d&7]()}f=a+40|0;g=k[f>>2]|0;k[p>>2]=0;q=p+4|0;k[q>>2]=0;h=p+8|0;k[h>>2]=0;k[p+12>>2]=g;if(g){if(g>>>0>536870911){x=te(4)|0;k[x>>2]=172664;Cf(x|0,28816,1287)}e=g<<3;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}o=d;k[p>>2]=o;k[q>>2]=o;k[h>>2]=d+(g<<3);g=k[f>>2]|0}o=p+16|0;k[o>>2]=0;k[w>>2]=0;f=w+4|0;k[f>>2]=0;h=w+8|0;k[h>>2]=0;if(g|0){if((g|0)<0)ad(426534,426557,304,426811);j=((g+-1|0)>>>5)+1|0;e=j<<2;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[w>>2]=d;k[h>>2]=j;k[f>>2]=g;n=g>>>5;zpb(d|0,0,n<<2|0)|0;e=g-(n<<5)|0;d=d+(n<<2)|0;if(e|0)k[d>>2]=k[d>>2]&~(-1>>>(32-e|0))}k[v>>2]=0;e=a+92|0;if((k[e>>2]|0)>0){f=a+48|0;d=0;do{oPa(a,k[(k[f>>2]|0)+(d<<2)>>2]|0,b,c,v,s,p,w);d=d+1|0}while((d|0)<(k[e>>2]|0))}while(1){if(!(k[o>>2]|0))break;m=k[p>>2]|0;n=k[m>>2]|0;d=k[q>>2]|0;l=d-m|0;e=l>>3;if(((l|0)>8?(t=d+-8|0,l=m,j=k[l>>2]|0,l=k[l+4>>2]|0,f=t,g=k[f+4>>2]|0,h=m,k[h>>2]=k[f>>2],k[h+4>>2]=g,t,k[t>>2]=j,k[t+4>>2]=l,t=e+-1|0,(e|0)!=2):0)?(l=e+-3|0,u=(l|0)/2|0,(l|0)>=-1):0){d=m+8|0;if((t|0)>2){l=(k[m+20>>2]|0)<(k[m+12>>2]|0);e=l?2:1;d=l?m+16|0:d}else e=1;if((k[m+4>>2]|0)>=(k[d+4>>2]|0)){l=m;j=k[l>>2]|0;l=k[l+4>>2]|0;h=m;do{g=h;h=d;d=h;f=k[d+4>>2]|0;k[g>>2]=k[d>>2];k[g+4>>2]=f;if((u|0)<(e|0))break;e=e<<1|1;f=m+(e<<3)|0;d=f;g=e+1|0;if((g|0)<(t|0)){f=f+8|0;y=(k[f+4>>2]|0)<(k[m+(e<<3)+4>>2]|0);e=y?g:e;d=y?f:d}}while((l|0)>=(k[d+4>>2]|0));y=h;k[y>>2]=j;k[y+4>>2]=l}}k[q>>2]=(k[q>>2]|0)+-8;k[o>>2]=(k[o>>2]|0)+-1;if((k[v>>2]|0)>=(s|0)?Xh[k[(k[b>>2]|0)+8>>2]&1023](b)|0:0)break;oPa(a,n,b,c,v,s,p,w)}d=k[p>>2]|0;e=d;if(d|0){f=k[q>>2]|0;if((f|0)!=(d|0))k[q>>2]=f+(~((f+-8-e|0)>>>3)<<3);ggb(d)}ggb(p);d=k[w>>2]|0;if(!d){r=x;return}ggb(d);r=x;return}function oPa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=b+8|0;t=k[F>>2]|0;if(!t){if((k[e>>2]|0)>=(f|0)?Xh[k[(k[c>>2]|0)+8>>2]&1023](c)|0:0)return;w=b+4|0;j=k[w>>2]|0;if((j|0)<=0)return;t=b+12|0;u=a+24|0;v=a+20|0;s=a+44|0;r=0;b=k[h>>2]|0;do{o=k[(k[t>>2]|0)+(r<<2)>>2]|0;p=o>>>5;q=1<<(o&31);if(!(q&k[b+(p<<2)>>2])){m=(k[u>>2]|0)+(aa(k[v>>2]|0,o)|0)|0;n=k[s>>2]|0;if(!n)j=0;else{j=0;b=0;do{j=(l[376255+((i[d+b>>0]^i[m+b>>0])&255)>>0]|0)+j|0;b=b+1|0}while((b|0)!=(n|0))}Ph[k[(k[c>>2]|0)+12>>2]&511](c,j,o);b=k[h>>2]|0;j=b+(p<<2)|0;k[j>>2]=k[j>>2]|q;k[e>>2]=(k[e>>2]|0)+1;j=k[w>>2]|0}r=r+1|0}while((r|0)<(j|0));return}z=a+88|0;u=k[z>>2]|0;b=u>>>0>1073741823?-1:u<<2;b=(b|0)==0?1:b;while(1){j=fgb(b)|0;if(j|0){y=j;break}j=k[207666]|0;k[207666]=j+0;if(!j){y=0;break}Qh[j&7]()}p=k[a+24>>2]|0;q=k[a+20>>2]|0;m=p+(aa(q,k[k[t>>2]>>2]|0)|0)|0;r=k[a+44>>2]|0;s=(r|0)==0;if(s)j=0;else{j=0;b=0;do{j=(l[376255+((i[m+b>>0]^i[d+b>>0])&255)>>0]|0)+j|0;b=b+1|0}while((b|0)!=(r|0))}k[y>>2]=j;if((u|0)>1){o=1;j=0;do{n=p+(aa(q,k[k[t+(o<<2)>>2]>>2]|0)|0)|0;if(s)b=0;else{b=0;m=0;do{b=(l[376255+((i[n+m>>0]^i[d+m>>0])&255)>>0]|0)+b|0;m=m+1|0}while((m|0)!=(r|0))}k[y+(o<<2)>>2]=b;j=(b|0)<(k[y+(j<<2)>>2]|0)?o:j;o=o+1|0}while((o|0)!=(u|0));x=j}else x=0;a:do if((u|0)>0){t=g+16|0;v=g+12|0;w=g+4|0;s=g+8|0;r=0;j=u;while(1){if((r|0)!=(x|0)?(A=k[y+(r<<2)>>2]|0,B=k[(k[F>>2]|0)+(r<<2)>>2]|0,(k[t>>2]|0)!=(k[v>>2]|0)):0){j=k[w>>2]|0;u=k[s>>2]|0;b=u;if((j|0)==(u|0)){q=k[g>>2]|0;p=j-q|0;o=p>>3;j=o+1|0;if(j>>>0>536870911){j=28;break}u=b-q|0;n=u>>2;n=u>>3>>>0<268435455?(n>>>0<j>>>0?j:n):536870911;if(!n)j=0;else{if(n>>>0>536870911){j=31;break}b=n<<3;b=(b|0)==0?1:b;while(1){j=fgb(b)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}}b=j+(o<<3)|0;m=b;k[m>>2]=B;k[m+4>>2]=A;m=b+8|0;b=b+(0-o<<3)|0;if((p|0)>0)upb(b|0,q|0,p|0)|0;k[g>>2]=b;k[w>>2]=m;k[s>>2]=j+(n<<3);if(q){ggb(q);m=k[w>>2]|0}}else{m=j;k[m>>2]=B;k[m+4>>2]=A;m=(k[w>>2]|0)+8|0;k[w>>2]=m}j=k[g>>2]|0;b=m-j|0;if((b|0)>8?(C=((b>>3)+-2|0)/2|0,D=j,E=m,(k[E+-4>>2]|0)<(k[D+(C<<3)+4>>2]|0)):0){n=E+-8|0;m=n;b=k[m>>2]|0;m=k[m+4>>2]|0;j=C;do{u=n;n=D+(j<<3)|0;p=n;q=k[p+4>>2]|0;k[u>>2]=k[p>>2];k[u+4>>2]=q;if(!j)break;j=(j+-1|0)/2|0}while((m|0)<(k[D+(j<<3)+4>>2]|0));u=n;k[u>>2]=b;k[u+4>>2]=m}k[t>>2]=(k[t>>2]|0)+1;j=k[z>>2]|0}r=r+1|0;if((r|0)>=(j|0))break a}if((j|0)==28)ad(426534,426557,304,426811);else if((j|0)==31){h=te(4)|0;k[h>>2]=172664;Cf(h|0,28816,1287)}}while(0);ggb(y);oPa(a,k[(k[F>>2]|0)+(x<<2)>>2]|0,c,d,e,f,g,h);return}function pPa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;h=n;l=a+60|0;f=k[l>>2]|0;a:do if((f|0)<32){e=a+80|0;k[e>>2]=(k[e>>2]|0)+f;e=fgb(8192)|0;if(e|0){g=a+64|0;k[e>>2]=k[g>>2];k[g>>2]=e;k[l>>2]=8188;e=e+4|0;g=a+68|0;k[g>>2]=e;f=8156;m=28;break}e=k[41482]|0;f=(e|0)==0;if((k[41497]|0)>-1){do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;e=0;break a}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;e=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){e=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;e=0;break}else{do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;e=0;break a}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;e=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){e=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;e=0;break}}else{e=a+68|0;g=e;e=k[e>>2]|0;f=f+-32|0;m=28}while(0);if((m|0)==28){k[g>>2]=e+32;k[l>>2]=f;j=a+76|0;k[j>>2]=(k[j>>2]|0)+32}k[c>>2]=e;if((_fb(e,20,1,b)|0)!=1){n=te(44)|0;VHa(n,373124);Cf(n|0,19720,57)}if(!(k[(k[c>>2]|0)+8>>2]|0)){if((_fb(h,4,1,b)|0)!=1){n=te(44)|0;VHa(n,373124);Cf(n|0,19720,57)}k[(k[c>>2]|0)+12>>2]=(k[(k[a+52>>2]|0)+(d<<2)>>2]|0)+(k[h>>2]<<2);r=n;return}j=a+88|0;h=(k[j>>2]<<2)+15&-16;f=k[l>>2]|0;b:do if((h|0)>(f|0)){e=a+80|0;k[e>>2]=(k[e>>2]|0)+f;e=(h|4)+15|0;e=e>>>0>8192?e:8192;f=fgb(e)|0;if(f|0){m=a+64|0;k[f>>2]=k[m>>2];k[m>>2]=f;m=e+-4|0;k[l>>2]=m;e=f+4|0;g=a+68|0;k[g>>2]=e;f=m;m=62;break}e=k[41482]|0;f=(e|0)==0;if((k[41497]|0)>-1){do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;e=0;break b}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;e=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){e=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;e=0;break}else{do if(f){e=i[165986]|0;i[165986]=e+255|e;e=k[41478]|0;if(!(e&8)){k[41480]=0;k[41479]=0;f=k[41489]|0;k[41485]=f;k[41483]=f;e=f+(k[41490]|0)|0;k[41482]=e;break}else{k[41478]=e|32;e=0;break b}}else f=k[41483]|0;while(0);if((e-f|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;e=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){e=0;break}e=0;g=373857;f=k[41483]|0}else{e=27;g=373830}upb(f|0,g|0,e|0)|0;k[41483]=(k[41483]|0)+e;e=0;break}}else{e=a+68|0;g=e;e=k[e>>2]|0;m=62}while(0);if((m|0)==62){k[g>>2]=e+h;k[l>>2]=f-h;m=a+76|0;k[m>>2]=(k[m>>2]|0)+h}k[(k[c>>2]|0)+8>>2]=e;if((k[j>>2]|0)>0)e=0;else{r=n;return}do{pPa(a,b,(k[(k[c>>2]|0)+8>>2]|0)+(e<<2)|0,d);e=e+1|0}while((e|0)<(k[j>>2]|0));r=n;return}function qPa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;f=n;m=b+76|0;h=b+16|0;g=k[h>>2]|0;e=(g|0)==0;a:do if((k[m>>2]|0)>-1){do if(e){e=b+74|0;l=i[e>>0]|0;i[e>>0]=l+255|l;e=k[b>>2]|0;if(!(e&8)){k[b+8>>2]=0;k[b+4>>2]=0;e=k[b+44>>2]|0;k[b+28>>2]=e;l=b+20|0;k[l>>2]=e;g=e+(k[b+48>>2]|0)|0;k[h>>2]=g;break}else{k[b>>2]=e|32;break a}}else{e=b+20|0;l=e;e=k[e>>2]|0}while(0);j=e;if((g-e|0)>>>0<20){ci[k[b+36>>2]&255](b,c,20)|0;break}b:do if((i[b+75>>0]|0)>-1){g=20;while(1){if(!g){h=20;g=c;e=j;break b}e=g+-1|0;if((i[c+e>>0]|0)==10)break;else g=e}if((ci[k[b+36>>2]&255](b,c,g)|0)>>>0<g>>>0)break a;h=20-g|0;g=c+g|0;e=k[l>>2]|0}else{h=20;g=c;e=j}while(0);upb(e|0,g|0,h|0)|0;k[l>>2]=(k[l>>2]|0)+h}else{do if(e){e=b+74|0;l=i[e>>0]|0;i[e>>0]=l+255|l;e=k[b>>2]|0;if(!(e&8)){k[b+8>>2]=0;k[b+4>>2]=0;e=k[b+44>>2]|0;k[b+28>>2]=e;l=b+20|0;k[l>>2]=e;g=e+(k[b+48>>2]|0)|0;k[h>>2]=g;break}else{k[b>>2]=e|32;break a}}else{e=b+20|0;l=e;e=k[e>>2]|0}while(0);j=e;if((g-e|0)>>>0<20){ci[k[b+36>>2]&255](b,c,20)|0;break}c:do if((i[b+75>>0]|0)>-1){g=20;while(1){if(!g){h=20;g=c;e=j;break c}e=g+-1|0;if((i[c+e>>0]|0)==10)break;else g=e}if((ci[k[b+36>>2]&255](b,c,g)|0)>>>0<g>>>0)break a;h=20-g|0;g=c+g|0;e=k[l>>2]|0}else{h=20;g=c;e=j}while(0);upb(e|0,g|0,h|0)|0;k[l>>2]=(k[l>>2]|0)+h}while(0);g=c+8|0;e=k[g>>2]|0;if(e|0){f=a+88|0;if((k[f>>2]|0)<=0){r=n;return}qPa(a,b,k[e>>2]|0,d);if((k[f>>2]|0)>1)e=1;else{r=n;return}do{qPa(a,b,k[(k[g>>2]|0)+(e<<2)>>2]|0,d);e=e+1|0}while((e|0)<(k[f>>2]|0));r=n;return}k[f>>2]=(k[c+12>>2]|0)-(k[(k[a+52>>2]|0)+(d<<2)>>2]|0)>>2;h=b+16|0;g=k[h>>2]|0;e=(g|0)==0;d:do if((k[m>>2]|0)>-1){do if(e){e=b+74|0;m=i[e>>0]|0;i[e>>0]=m+255|m;e=k[b>>2]|0;if(!(e&8)){k[b+8>>2]=0;k[b+4>>2]=0;m=k[b+44>>2]|0;k[b+28>>2]=m;j=b+20|0;k[j>>2]=m;g=m+(k[b+48>>2]|0)|0;k[h>>2]=g;h=m;break}else{k[b>>2]=e|32;break d}}else{h=b+20|0;j=h;h=k[h>>2]|0}while(0);e=h;if((g-h|0)>>>0<4){ci[k[b+36>>2]&255](b,f,4)|0;break}e:do if((i[b+75>>0]|0)>-1){h=4;while(1){if(!h){g=4;break e}g=h+-1|0;if((i[f+g>>0]|0)==10)break;else h=g}if((ci[k[b+36>>2]&255](b,f,h)|0)>>>0<h>>>0)break d;g=4-h|0;f=f+h|0;e=k[j>>2]|0}else g=4;while(0);upb(e|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}else{do if(e){e=b+74|0;m=i[e>>0]|0;i[e>>0]=m+255|m;e=k[b>>2]|0;if(!(e&8)){k[b+8>>2]=0;k[b+4>>2]=0;m=k[b+44>>2]|0;k[b+28>>2]=m;j=b+20|0;k[j>>2]=m;g=m+(k[b+48>>2]|0)|0;k[h>>2]=g;h=m;break}else{k[b>>2]=e|32;break d}}else{h=b+20|0;j=h;h=k[h>>2]|0}while(0);e=h;if((g-h|0)>>>0<4){ci[k[b+36>>2]&255](b,f,4)|0;break}f:do if((i[b+75>>0]|0)>-1){h=4;while(1){if(!h){g=4;break f}g=h+-1|0;if((i[f+g>>0]|0)==10)break;else h=g}if((ci[k[b+36>>2]&255](b,f,h)|0)>>>0<h>>>0)break d;g=4-h|0;f=f+h|0;e=k[j>>2]|0}else g=4;while(0);upb(e|0,f|0,g|0)|0;k[j>>2]=(k[j>>2]|0)+g}while(0);r=n;return}function rPa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+16|0;n=B;k[b+4>>2]=d;k[b+16>>2]=f;if((k[a+100>>2]|0)>(d|0)){k[b+12>>2]=c;Dgb(c,c+(d<<2)|0);k[b+8>>2]=0;r=B;return}if(!e)g=0;else{if(e>>>0>1073741823)ad(426534,426557,304,426811);j=e<<2;h=(j|0)==0?1:j;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}zpb(g|0,0,j|0)|0}if(!d)h=0;else{if(d>>>0>1073741823)ad(426534,426557,304,426811);m=d<<2;j=(m|0)==0?1:m;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}zpb(h|0,0,m|0)|0}j=k[a+4>>2]|0;z=k[a+8>>2]|0;m=a+(z>>1)|0;if(z&1)j=k[(k[m>>2]|0)+j>>2]|0;Lg[j&255](m,e,c,d,g,n);v=k[n>>2]|0;a:do if((v|0)>=(e|0)){z=(d|0)>0;b:do if(z){w=a+20|0;y=a+44|0;u=k[a+24>>2]|0;if((v|0)>1)t=0;else{m=0;while(1){n=k[y>>2]|0;if(n|0){j=0;do j=j+1|0;while((j|0)!=(n|0))}k[h+(m<<2)>>2]=0;m=m+1|0;if((m|0)==(d|0))break b}}do{n=k[w>>2]|0;x=u+(aa(n,k[c+(t<<2)>>2]|0)|0)|0;n=u+(aa(k[g>>2]|0,n)|0)|0;o=k[y>>2]|0;if(!o)j=0;else{j=0;m=0;do{j=(l[376255+((i[n+m>>0]^i[x+m>>0])&255)>>0]|0)+j|0;m=m+1|0}while((m|0)!=(o|0))}s=h+(t<<2)|0;k[s>>2]=0;q=1;do{o=u+(aa(k[w>>2]|0,k[g+(q<<2)>>2]|0)|0)|0;p=k[y>>2]|0;if(!p)m=0;else{m=0;n=0;do{m=(l[376255+((i[o+n>>0]^i[x+n>>0])&255)>>0]|0)+m|0;n=n+1|0}while((n|0)!=(p|0))}if((j|0)>(m|0)){k[s>>2]=q;j=m}q=q+1|0}while((q|0)!=(v|0));t=t+1|0}while((t|0)!=(d|0))}while(0);o=(e<<2)+15&-16;y=a+60|0;m=k[y>>2]|0;c:do if((o|0)>(m|0)){j=a+80|0;k[j>>2]=(k[j>>2]|0)+m;j=(o|4)+15|0;j=j>>>0>8192?j:8192;m=fgb(j)|0;if(m|0){A=a+64|0;k[m>>2]=k[A>>2];k[A>>2]=m;A=j+-4|0;k[y>>2]=A;j=m+4|0;n=a+68|0;k[n>>2]=j;m=A;A=65;break}j=k[41482]|0;m=(j|0)==0;if((k[41497]|0)>-1){do if(m){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;m=k[41489]|0;k[41485]=m;k[41483]=m;j=m+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break c}}else m=k[41483]|0;while(0);if((j-m|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;n=373857;m=k[41483]|0}else{j=27;n=373830}upb(m|0,n|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}else{do if(m){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;m=k[41489]|0;k[41485]=m;k[41483]=m;j=m+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break c}}else m=k[41483]|0;while(0);if((j-m|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;n=373857;m=k[41483]|0}else{j=27;n=373830}upb(m|0,n|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}}else{j=a+68|0;n=j;j=k[j>>2]|0;A=65}while(0);if((A|0)==65){k[n>>2]=j+o;k[y>>2]=m-o;x=a+76|0;k[x>>2]=(k[x>>2]|0)+o}x=b+8|0;k[x>>2]=j;if((e|0)>0){u=a+80|0;v=a+64|0;w=a+68|0;s=f+1|0;t=a+76|0;if(z){p=0;q=0}else{o=0;while(1){m=k[y>>2]|0;d:do if((m|0)<32){k[u>>2]=(k[u>>2]|0)+m;j=fgb(8192)|0;if(j|0){k[j>>2]=k[v>>2];k[v>>2]=j;k[y>>2]=8188;j=j+4|0;k[w>>2]=j;m=8188;A=128;break}j=k[41482]|0;m=(j|0)==0;if((k[41497]|0)>-1){do if(m){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;m=k[41489]|0;k[41485]=m;k[41483]=m;j=m+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break d}}else m=k[41483]|0;while(0);if((j-m|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;n=373857;m=k[41483]|0}else{j=27;n=373830}upb(m|0,n|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}else{do if(m){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;m=k[41489]|0;k[41485]=m;k[41483]=m;j=m+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break d}}else m=k[41483]|0;while(0);if((j-m|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;n=373857;m=k[41483]|0}else{j=27;n=373830}upb(m|0,n|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}}else{j=k[w>>2]|0;A=128}while(0);if((A|0)==128){A=0;k[w>>2]=j+32;k[y>>2]=m+-32;k[t>>2]=(k[t>>2]|0)+32}k[(k[x>>2]|0)+(o<<2)>>2]=j;d=(k[x>>2]|0)+(o<<2)|0;f=k[d>>2]|0;k[f>>2]=k[g+(o<<2)>>2];k[f+12>>2]=0;rPa(a,k[d>>2]|0,c,0,e,s);o=o+1|0;if((o|0)>=(e|0))break a}}while(1){n=0;j=q;while(1){m=h+(n<<2)|0;if((k[m>>2]|0)==(p|0)){b=c+(n<<2)|0;o=c+(j<<2)|0;f=k[b>>2]|0;k[b>>2]=k[o>>2];k[o>>2]=f;o=h+(j<<2)|0;f=k[m>>2]|0;k[m>>2]=k[o>>2];k[o>>2]=f;o=j+1|0}else o=j;n=n+1|0;if((n|0)==(d|0))break;else j=o}m=k[y>>2]|0;e:do if((m|0)<32){k[u>>2]=(k[u>>2]|0)+m;j=fgb(8192)|0;if(j|0){k[j>>2]=k[v>>2];k[v>>2]=j;k[y>>2]=8188;j=j+4|0;k[w>>2]=j;m=8188;A=72;break}j=k[41482]|0;m=(j|0)==0;if((k[41497]|0)>-1){do if(m){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;m=k[41489]|0;k[41485]=m;k[41483]=m;j=m+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break e}}else m=k[41483]|0;while(0);if((j-m|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;n=373857;m=k[41483]|0}else{j=27;n=373830}upb(m|0,n|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}else{do if(m){j=i[165986]|0;i[165986]=j+255|j;j=k[41478]|0;if(!(j&8)){k[41480]=0;k[41479]=0;m=k[41489]|0;k[41485]=m;k[41483]=m;j=m+(k[41490]|0)|0;k[41482]=j;break}else{k[41478]=j|32;j=0;break e}}else m=k[41483]|0;while(0);if((j-m|0)>>>0<27){ci[k[165948>>2]&255](165912,373830,27)|0;j=0;break}if((i[165987]|0)>-1){if((ci[k[165948>>2]&255](165912,373830,27)|0)>>>0<27){j=0;break}j=0;n=373857;m=k[41483]|0}else{j=27;n=373830}upb(m|0,n|0,j|0)|0;k[41483]=(k[41483]|0)+j;j=0;break}}else{j=k[w>>2]|0;A=72}while(0);if((A|0)==72){A=0;k[w>>2]=j+32;k[y>>2]=m+-32;k[t>>2]=(k[t>>2]|0)+32}k[(k[x>>2]|0)+(p<<2)>>2]=j;f=(k[x>>2]|0)+(p<<2)|0;b=k[f>>2]|0;k[b>>2]=k[g+(p<<2)>>2];k[b+12>>2]=0;rPa(a,k[f>>2]|0,c+(q<<2)|0,o-q|0,e,s);p=p+1|0;if((p|0)>=(e|0))break;else q=o}}}else{k[b+12>>2]=c;Dgb(c,c+(d<<2)|0);k[b+8>>2]=0}while(0);if(h|0)ggb(h);if(!g){r=B;return}ggb(g);r=B;return}function sPa(a){a=a|0;k[a>>2]=94868;YHa(k[a+24>>2]|0);return}function tPa(a){a=a|0;k[a>>2]=94868;YHa(k[a+24>>2]|0);ggb(a);return}function uPa(a){a=a|0;return}function vPa(a,b){a=a|0;b=b|0;return}function wPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;b=h+8|0;c=h;d=a+20|0;e=b+4|0;f=ZT(16)|0;k[f>>2]=1;g=f+4|0;k[b>>2]=g;k[e>>2]=9;i[f+13>>0]=0;j=373358;l=g+9|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));l=WHa(d,b)|0;j=Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0;k[c>>2]=j;j=k[l>>2]|0;a=l+4|0;jh[k[k[j>>2]>>2]&1023](j,a);k[l>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,c,a);k[e>>2]=0;k[b>>2]=0;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1){r=h;return}ggb(k[f+-4>>2]|0);r=h;return}function xPa(a){a=a|0;return k[a+4>>2]|0}function yPa(a){a=a|0;return k[a+8>>2]|0}function zPa(a){a=a|0;return 0}function APa(a){a=a|0;return 0}function BPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=r;r=r+16|0;g=l;h=a+4|0;k[h>>2]=0;i=a+8|0;k[i>>2]=0;j=a+4|0;k[a>>2]=j;d=k[b+20>>2]|0;f=b+24|0;if((d|0)==(f|0)){r=l;return}c=d;b=d;while(1){d=c+16|0;e=ZHa(a,j,g,d)|0;if(!(k[e>>2]|0)){while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}d=k[d>>2]|0;k[b+16>>2]=d;k[b+20>>2]=k[c+20>>2];if(d|0){d=d+-4|0;k[d>>2]=(k[d>>2]|0)+1}n=b+24|0;k[n>>2]=428704;d=b+28|0;k[d>>2]=0;jh[k[k[107176]>>2]&1023](428704,d);m=k[c+24>>2]|0;k[n>>2]=m;Ph[k[(k[m>>2]|0)+8>>2]&511](m,c+28|0,d);d=k[g>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[e>>2]=b;d=k[k[a>>2]>>2]|0;if(d){k[a>>2]=d;b=k[e>>2]|0}B4(k[h>>2]|0,b);k[i>>2]=(k[i>>2]|0)+1}else c=b;b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(f|0))break;else c=b}r=l;return}function CPa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;h=a+4|0;if(!(k[h>>2]|0))return;j=a+8|0;g=0;f=k[a+16>>2]|0;e=k[j>>2]|0;while(1){if(!e)d=0;else{d=0;a=0;do{d=(l[376255+((i[c+a>>0]^i[f+a>>0])&255)>>0]|0)+d|0;a=a+1|0}while((a|0)!=(e|0))}Ph[k[(k[b>>2]|0)+12>>2]&511](b,d,g);g=g+1|0;d=k[j>>2]|0;if(g>>>0>=(k[h>>2]|0)>>>0)break;else{f=f+d|0;e=d}}return}function DPa(a){a=a|0;var b=0;k[a>>2]=94568;b=k[a+4>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);YHa(k[a+16>>2]|0);return}function EPa(a){a=a|0;var b=0;k[a>>2]=94568;b=k[a+4>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);YHa(k[a+16>>2]|0);ggb(a);return}function FPa(a){a=a|0;if(i[a+8>>0]|0)return;a=k[a+4>>2]|0;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);return}function GPa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=k[a+4>>2]|0;Lg[k[(k[a>>2]|0)+12>>2]&255](a,b,c,d,e,f);return}function HPa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;a=k[a+4>>2]|0;return li[k[(k[a>>2]|0)+16>>2]&7](a,b,c,d,e,f)|0}function IPa(a,b){a=a|0;b=b|0;a=k[a+4>>2]|0;jh[k[(k[a>>2]|0)+20>>2]&1023](a,b);return}function JPa(a,b){a=a|0;b=b|0;a=k[a+4>>2]|0;jh[k[(k[a>>2]|0)+24>>2]&1023](a,b);return}function KPa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+28>>2]&1023](a)|0}function LPa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+32>>2]&1023](a)|0}function MPa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0}function NPa(a){a=a|0;a=k[a+4>>2]|0;return Xh[k[(k[a>>2]|0)+40>>2]&1023](a)|0}function OPa(a,b){a=a|0;b=b|0;b=k[b+4>>2]|0;jh[k[(k[b>>2]|0)+44>>2]&1023](a,b);return}function PPa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=k[a+4>>2]|0;dh[k[(k[a>>2]|0)+48>>2]&255](a,b,c,d);return}function QPa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+64|0;s=t;i=k[a>>2]&2031616;do if(i){do if((i|0)==65536){m=k[a+4>>2]|0;k[s>>2]=k[m>>2];q=s+4|0;i=m+4|0;k[q>>2]=k[i>>2];p=s+8|0;k[p>>2]=k[m+8>>2];k[s+12>>2]=k[m+12>>2];k[s+16>>2]=k[m+16>>2];k[s+20>>2]=k[m+20>>2];k[s+24>>2]=k[m+24>>2];k[s+28>>2]=k[m+28>>2];k[s+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[s+36>>2]=j;l=s+40|0;k[l>>2]=p;p=s+48|0;o=s+44|0;k[o>>2]=p;k[s+52>>2]=0;k[p>>2]=0;if(j|0){p=j+12|0;k[p>>2]=(k[p>>2]|0)+1}if((k[i>>2]|0)<3){p=k[m+44>>2]|0;q=k[o>>2]|0;k[q>>2]=k[p>>2];k[q+4>>2]=k[p+4>>2];break}k[q>>2]=0;x1(s,k[i>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;i=0;do{k[n+(i<<2)>>2]=k[p+(i<<2)>>2];k[j+(i<<2)>>2]=k[l+(i<<2)>>2];i=i+1|0}while((i|0)<(k[q>>2]|0))}}else Q1(s,a,-1);while(0);KG(c,s)|0;l=s+36|0;i=k[l>>2]|0;if(i|0?(p=i+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){j=k[l>>2]|0;if(j|0){i=k[j+4>>2]|0;if(!i){i=k[s+32>>2]|0;if(!i){i=B1()|0;j=k[l>>2]|0}}jh[k[(k[i>>2]|0)+24>>2]&1023](i,j)}k[l>>2]=0}k[l>>2]=0;q=s+16|0;l=s+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[l>>2]|0)>0){j=k[s+40>>2]|0;i=0;do{k[j+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(k[l>>2]|0))}i=k[s+44>>2]|0;if(!((i|0)==(s+48|0)|(i|0)==0))ggb(k[i+-4>>2]|0);i=k[c>>2]|0;if(((i&20479|0)==16388?(k[c+8>>2]|0)==(e|0):0)?(q=k[c+12>>2]|0,!((q|0)<(f|0)|(q|0)>(g|0))):0)break;if(!(i&16384))b2(a);c2(a,e,f,4,-1,0,0);do if((k[a>>2]&2031616|0)==65536){m=k[a+4>>2]|0;k[s>>2]=k[m>>2];q=s+4|0;i=m+4|0;k[q>>2]=k[i>>2];a=s+8|0;k[a>>2]=k[m+8>>2];k[s+12>>2]=k[m+12>>2];k[s+16>>2]=k[m+16>>2];k[s+20>>2]=k[m+20>>2];k[s+24>>2]=k[m+24>>2];k[s+28>>2]=k[m+28>>2];k[s+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[s+36>>2]=j;l=s+40|0;k[l>>2]=a;a=s+48|0;o=s+44|0;k[o>>2]=a;k[s+52>>2]=0;k[a>>2]=0;if(j|0){a=j+12|0;k[a>>2]=(k[a>>2]|0)+1}if((k[i>>2]|0)<3){q=k[m+44>>2]|0;a=k[o>>2]|0;k[a>>2]=k[q>>2];k[a+4>>2]=k[q+4>>2];break}k[q>>2]=0;x1(s,k[i>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;i=0;do{k[n+(i<<2)>>2]=k[p+(i<<2)>>2];k[j+(i<<2)>>2]=k[l+(i<<2)>>2];i=i+1|0}while((i|0)<(k[q>>2]|0))}}else Q1(s,a,-1);while(0);KG(c,s)|0;l=s+36|0;i=k[l>>2]|0;if(i|0?(q=i+12|0,a=k[q>>2]|0,k[q>>2]=a+-1,(a|0)==1):0){j=k[l>>2]|0;if(j|0){i=k[j+4>>2]|0;if(!i){i=k[s+32>>2]|0;if(!i){i=B1()|0;j=k[l>>2]|0}}jh[k[(k[i>>2]|0)+24>>2]&1023](i,j)}k[l>>2]=0}k[l>>2]=0;a=s+16|0;j=s+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[j>>2]|0)>0){l=k[s+40>>2]|0;i=0;do{k[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(k[j>>2]|0))}i=k[s+44>>2]|0;if(!((i|0)==(s+48|0)|(i|0)==0))ggb(k[i+-4>>2]|0)}else{if(((((k[c+4>>2]|0)<3?(k[c+8>>2]|0)==(e|0):0)?(k[c+12>>2]|0)==(f|0):0)?(k[c>>2]&4095|0)==4:0)?k[c+16>>2]|0:0)break;k[s>>2]=e;k[s+4>>2]=f;G1(c,2,s,4)}while(0);i=k[b>>2]&2031616;if(!i){i=h&4095;if(((((k[d+4>>2]|0)<3?(k[d+8>>2]|0)==(e|0):0)?(k[d+12>>2]|0)==(f|0):0)?(k[d>>2]&4095|0)==(i|0):0)?k[d+16>>2]|0:0){r=t;return}k[s>>2]=e;k[s+4>>2]=f;G1(d,2,s,i);r=t;return}do if((i|0)==65536){m=k[b+4>>2]|0;k[s>>2]=k[m>>2];q=s+4|0;i=m+4|0;k[q>>2]=k[i>>2];a=s+8|0;k[a>>2]=k[m+8>>2];k[s+12>>2]=k[m+12>>2];k[s+16>>2]=k[m+16>>2];k[s+20>>2]=k[m+20>>2];k[s+24>>2]=k[m+24>>2];k[s+28>>2]=k[m+28>>2];k[s+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[s+36>>2]=j;l=s+40|0;k[l>>2]=a;a=s+48|0;o=s+44|0;k[o>>2]=a;k[s+52>>2]=0;k[a>>2]=0;if(j|0){a=j+12|0;k[a>>2]=(k[a>>2]|0)+1}if((k[i>>2]|0)<3){q=k[m+44>>2]|0;a=k[o>>2]|0;k[a>>2]=k[q>>2];k[a+4>>2]=k[q+4>>2];break}k[q>>2]=0;x1(s,k[i>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;i=0;do{k[n+(i<<2)>>2]=k[p+(i<<2)>>2];k[j+(i<<2)>>2]=k[l+(i<<2)>>2];i=i+1|0}while((i|0)<(k[q>>2]|0))}}else Q1(s,b,-1);while(0);KG(d,s)|0;l=s+36|0;i=k[l>>2]|0;if(i|0?(q=i+12|0,a=k[q>>2]|0,k[q>>2]=a+-1,(a|0)==1):0){j=k[l>>2]|0;if(j|0){i=k[j+4>>2]|0;if(!i){i=k[s+32>>2]|0;if(!i){i=B1()|0;j=k[l>>2]|0}}jh[k[(k[i>>2]|0)+24>>2]&1023](i,j)}k[l>>2]=0}k[l>>2]=0;a=s+16|0;j=s+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[j>>2]|0)>0){l=k[s+40>>2]|0;i=0;do{k[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(k[j>>2]|0))}i=k[s+44>>2]|0;if(!((i|0)==(s+48|0)|(i|0)==0))ggb(k[i+-4>>2]|0);a=k[d>>2]|0;if(((a&16384|0)!=0&(a&4095|0)==(h|0)?(k[d+8>>2]|0)==(e|0):0)?(a=k[d+12>>2]|0,!((a|0)<(f|0)|(a|0)>(g|0))):0){r=t;return}if(!(k[c>>2]&16384))b2(b);c2(b,e,f,h,-1,0,0);do if((k[b>>2]&2031616|0)==65536){m=k[b+4>>2]|0;k[s>>2]=k[m>>2];q=s+4|0;i=m+4|0;k[q>>2]=k[i>>2];f=s+8|0;k[f>>2]=k[m+8>>2];k[s+12>>2]=k[m+12>>2];k[s+16>>2]=k[m+16>>2];k[s+20>>2]=k[m+20>>2];k[s+24>>2]=k[m+24>>2];k[s+28>>2]=k[m+28>>2];k[s+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[s+36>>2]=j;l=s+40|0;k[l>>2]=f;f=s+48|0;o=s+44|0;k[o>>2]=f;k[s+52>>2]=0;k[f>>2]=0;if(j|0){f=j+12|0;k[f>>2]=(k[f>>2]|0)+1}if((k[i>>2]|0)<3){e=k[m+44>>2]|0;f=k[o>>2]|0;k[f>>2]=k[e>>2];k[f+4>>2]=k[e+4>>2];break}k[q>>2]=0;x1(s,k[i>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;i=0;do{k[n+(i<<2)>>2]=k[p+(i<<2)>>2];k[j+(i<<2)>>2]=k[l+(i<<2)>>2];i=i+1|0}while((i|0)<(k[q>>2]|0))}}else Q1(s,b,-1);while(0);KG(d,s)|0;l=s+36|0;i=k[l>>2]|0;if(i|0?(f=i+12|0,d=k[f>>2]|0,k[f>>2]=d+-1,(d|0)==1):0){j=k[l>>2]|0;if(j|0){i=k[j+4>>2]|0;if(!i){i=k[s+32>>2]|0;if(!i){i=B1()|0;j=k[l>>2]|0}}jh[k[(k[i>>2]|0)+24>>2]&1023](i,j)}k[l>>2]=0}k[l>>2]=0;d=s+16|0;j=s+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[j>>2]|0)>0){l=k[s+40>>2]|0;i=0;do{k[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(k[j>>2]|0))}i=k[s+44>>2]|0;if(!((i|0)==(s+48|0)|(i|0)==0))ggb(k[i+-4>>2]|0);r=t;return}function RPa(){var a=0;if(i[427808]|0)return;k[206777]=95032;a=427808;k[a>>2]=1;k[a+4>>2]=0;return}function SPa(){var a=0;if(i[427792]|0)return;k[206776]=94980;a=427792;k[a>>2]=1;k[a+4>>2]=0;return}function TPa(){var a=0;if(i[427800]|0)return;k[206775]=94928;a=427800;k[a>>2]=1;k[a+4>>2]=0;return}function UPa(a,b){a=a|0;b=b|0;return}function VPa(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function WPa(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function XPa(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function YPa(a,b){a=a|0;b=b|0;return b|0}function ZPa(a,b){a=a|0;b=b|0;return b|0}function _Pa(a){a=a|0;return 4}function $Pa(a){a=a|0;return 20312}function aQa(a,b,c){a=a|0;b=b|0;c=c|0;Uhb(b,k[c>>2]|0);return}function bQa(a){a=a|0;ggb(a);return}function cQa(a,b){a=a|0;b=b|0;return}function dQa(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function eQa(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function fQa(a,b,c){a=a|0;b=b|0;c=c|0;k[c>>2]=k[b>>2];return}function gQa(a,b){a=a|0;b=b|0;return b|0}function hQa(a,b){a=a|0;b=b|0;return b|0}function iQa(a){a=a|0;return 4}function jQa(a){a=a|0;return 20384}function kQa(a,b,c){a=a|0;b=b|0;c=c|0;Uhb(b,k[c>>2]|0);return}function lQa(a){a=a|0;ggb(a);return}function mQa(a,b){a=a|0;b=b|0;a=k[b>>2]|0;if(a|0)ggb(a);k[b>>2]=0;return}function nQa(a,b,c){a=a|0;b=b|0;c=c|0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;Qh[a&7]()}p[a>>3]=+p[b>>3];k[c>>2]=a;return}function oQa(a,b,c){a=a|0;b=b|0;c=c|0;while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;Qh[a&7]()}p[a>>3]=+p[k[b>>2]>>3];k[c>>2]=a;return}function pQa(a,b,c){a=a|0;b=b|0;c=c|0;p[k[c>>2]>>3]=+p[k[b>>2]>>3];return}function qQa(a,b){a=a|0;b=b|0;return k[b>>2]|0}function rQa(a,b){a=a|0;b=b|0;return k[b>>2]|0}function sQa(a){a=a|0;return 8}function tQa(a){a=a|0;return 29032}function uQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,o=0;m=r;r=r+16|0;j=m+8|0;l=m;h=+p[k[c>>2]>>3];a=k[(k[b>>2]|0)+-12>>2]|0;c=b+a|0;if(!(k[c+16>>2]|0)){c=k[c+72>>2]|0;if((c|0)!=0?(k[c+(k[(k[c>>2]|0)+-12>>2]|0)+24>>2]|0)!=0:0){Qhb(j,c);if(i[j>>0]|0?(g=k[c+(k[(k[c>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[g>>2]|0)+24>>2]&1023](g)|0)==-1):0){g=c+(k[(k[c>>2]|0)+-12>>2]|0)+16|0;k[g>>2]=k[g>>2]|1}a=k[j+4>>2]|0;g=a+(k[(k[a>>2]|0)+-12>>2]|0)|0;if((((k[g+24>>2]|0?(k[g+16>>2]|0)==0:0)?k[g+4>>2]&8192|0:0)?!(bd()|0):0)?(g=k[a+(k[(k[a>>2]|0)+-12>>2]|0)+24>>2]|0,(Xh[k[(k[g>>2]|0)+24>>2]&1023](g)|0)==-1):0){g=a+(k[(k[a>>2]|0)+-12>>2]|0)+16|0;k[g>>2]=k[g>>2]|1}a=k[(k[b>>2]|0)+-12>>2]|0}a=k[b+a+28>>2]|0;g=a+4|0;k[g>>2]=(k[g>>2]|0)+1;g=Wib(828828)|0;g=k[(k[a+8>>2]|0)+(g<<2)>>2]|0;e=a+4|0;f=k[e>>2]|0;k[e>>2]=f+-1;if(!f)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);e=b+(k[(k[b>>2]|0)+-12>>2]|0)|0;f=k[e+24>>2]|0;d=e+76|0;a=k[d>>2]|0;if((a|0)==-1){a=k[e+28>>2]|0;c=a+4|0;k[c>>2]=(k[c>>2]|0)+1;c=Wib(828772)|0;c=k[(k[a+8>>2]|0)+(c<<2)>>2]|0;c=Hh[k[(k[c>>2]|0)+28>>2]&511](c,32)|0;o=a+4|0;n=k[o>>2]|0;k[o>>2]=n+-1;if(!n)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);a=c<<24>>24;k[d>>2]=a}o=k[(k[g>>2]|0)+32>>2]|0;k[l>>2]=f;k[j>>2]=k[l>>2];if(!(ch[o&7](g,j,e,a&255,h)|0)){o=b+(k[(k[b>>2]|0)+-12>>2]|0)+16|0;k[o>>2]=k[o>>2]|5}}a=b+(k[(k[b>>2]|0)+-12>>2]|0)|0;if(!(k[a+24>>2]|0)){r=m;return}if(k[a+16>>2]|0){r=m;return}if(!(k[a+4>>2]&8192)){r=m;return}if(bd()|0){r=m;return}o=k[b+(k[(k[b>>2]|0)+-12>>2]|0)+24>>2]|0;if((Xh[k[(k[o>>2]|0)+24>>2]&1023](o)|0)!=-1){r=m;return}o=b+(k[(k[b>>2]|0)+-12>>2]|0)+16|0;k[o>>2]=k[o>>2]|1;r=m;return}function vQa(a){a=a|0;ggb(a);return}function wQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;c=h+8|0;d=h;e=c+4|0;f=ZT(16)|0;k[f>>2]=1;g=f+4|0;k[c>>2]=g;k[e>>2]=9;i[f+13>>0]=0;j=373358;l=g+9|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));k[d>>2]=b;j=WHa(k[a>>2]|0,c)|0;g=k[j>>2]|0;l=j+4|0;jh[k[k[g>>2]>>2]&1023](g,l);k[j>>2]=428724;Ph[k[(k[107181]|0)+4>>2]&511](428724,d,l);k[e>>2]=0;k[c>>2]=0;l=k[f>>2]|0;k[f>>2]=l+-1;if((l|0)!=1){r=h;return}ggb(k[f+-4>>2]|0);r=h;return}function xQa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+16|0;u=x+8|0;v=x;g=k[b>>2]|0;w=b+4|0;while(1){h=k[w>>2]|0;if((h|0)==(g|0))break;t=h+-8|0;k[w>>2]=t;f=k[t>>2]|0;k[h+-4>>2]=0;k[t>>2]=0;if(!f)continue;s=f+-4|0;t=k[s>>2]|0;k[s>>2]=t+-1;if((t|0)!=1)continue;ggb(k[f+-8>>2]|0)}f=k[c>>2]|0;t=c+4|0;g=k[t>>2]|0;if((g|0)!=(f|0))k[t>>2]=g+(~((g+-4-f|0)>>>2)<<2);f=k[d>>2]|0;s=d+4|0;while(1){g=k[s>>2]|0;if((g|0)==(f|0))break;q=g+-8|0;k[s>>2]=q;h=k[q>>2]|0;k[g+-4>>2]=0;k[q>>2]=0;if(!h)continue;o=h+-4|0;q=k[o>>2]|0;k[o>>2]=q+-1;if((q|0)!=1)continue;ggb(k[h+-8>>2]|0)}f=k[e>>2]|0;q=e+4|0;g=k[q>>2]|0;if((g|0)!=(f|0))k[q>>2]=g+(~((g+-8-f|0)>>>3)<<3);i=k[a>>2]|0;g=k[i>>2]|0;i=i+4|0;f=g;if((f|0)==(i|0)){r=x;return}j=b+8|0;l=u+4|0;m=c+8|0;n=d+8|0;o=e+8|0;while(1){a=f+16|0;h=k[w>>2]|0;if((h|0)==(k[j>>2]|0))yQa(b,a);else{a=k[a>>2]|0;k[h>>2]=a;k[h+4>>2]=k[f+20>>2];if(a){h=a+-4|0;k[h>>2]=(k[h>>2]|0)+1;h=k[w>>2]|0}k[w>>2]=h+8}h=f+24|0;a=k[h>>2]|0;a=(Xh[k[(k[a>>2]|0)+28>>2]&1023](a)|0)+4|0;if((k[a>>2]|0)!=195498){f=23;break}a=k[h>>2]|0;a=Hh[k[(k[a>>2]|0)+20>>2]&511](a,f+28|0)|0;f=k[a>>2]|0;k[u>>2]=f;k[l>>2]=k[a+4>>2];if(f|0){a=f+-4|0;k[a>>2]=(k[a>>2]|0)+1}k[v>>2]=7;f=k[t>>2]|0;if((f|0)==(k[m>>2]|0))Q4(c,v);else{k[f>>2]=7;k[t>>2]=f+4}f=k[s>>2]|0;if((f|0)==(k[n>>2]|0))yQa(d,u);else{h=k[u>>2]|0;k[f>>2]=h;k[f+4>>2]=k[l>>2];if(h){f=h+-4|0;k[f>>2]=(k[f>>2]|0)+1;f=k[s>>2]|0}k[s>>2]=f+8}p[v>>3]=-1.0;f=k[q>>2]|0;if((f|0)==(k[o>>2]|0))Koa(e,v);else{p[f>>3]=-1.0;k[q>>2]=f+8}f=k[u>>2]|0;k[l>>2]=0;k[u>>2]=0;if(f|0?(h=f+-4|0,a=k[h>>2]|0,k[h>>2]=a+-1,(a|0)==1):0)ggb(k[f+-8>>2]|0);f=k[g+4>>2]|0;if(!f)while(1){f=k[g+8>>2]|0;if((k[f>>2]|0)==(g|0))break;else g=f}else while(1){g=k[f>>2]|0;if(!g)break;else f=g}if((f|0)==(i|0)){f=44;break}else g=f}if((f|0)==23)Cf(te(1)|0,19736,0);else if((f|0)==44){r=x;return}}function yQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=a+4|0;c=k[n>>2]|0;d=k[a>>2]|0;i=c-d>>3;e=i+1|0;if(e>>>0>536870911)ad(426534,426557,304,426811);j=d;f=c;m=a+8|0;l=(k[m>>2]|0)-d|0;g=l>>2;g=l>>3>>>0<268435455?(g>>>0<e>>>0?e:g):536870911;if(!g)d=0;else{if(g>>>0>536870911){n=te(4)|0;k[n>>2]=172664;Cf(n|0,28816,1287)}e=g<<3;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}h=d+(i<<3)|0;e=h;l=d+(g<<3)|0;g=k[b>>2]|0;k[h>>2]=g;k[d+(i<<3)+4>>2]=k[b+4>>2];if(!g)g=j;else{c=g+-4|0;k[c>>2]=(k[c>>2]|0)+1;c=k[n>>2]|0;f=c;g=k[a>>2]|0}b=h+8|0;if((f|0)==(g|0)){d=e;g=f}else{c=h;do{j=f;f=f+-8|0;d=k[f>>2]|0;k[c+-8>>2]=d;k[c+-4>>2]=k[j+-4>>2];if(d|0){j=d+-4|0;k[j>>2]=(k[j>>2]|0)+1}c=e+-8|0;e=c}while((f|0)!=(g|0));d=e;g=k[a>>2]|0;c=k[n>>2]|0}k[a>>2]=d;k[n>>2]=b;k[m>>2]=l;f=g;while(1){if((c|0)==(f|0))break;n=c+-8|0;d=n;e=k[n>>2]|0;k[c+-4>>2]=0;k[n>>2]=0;if(!e){c=d;continue}m=e+-4|0;n=k[m>>2]|0;k[m>>2]=n+-1;if((n|0)!=1){c=d;continue}ggb(k[e+-8>>2]|0);c=d}if(!g)return;ggb(g);return}function zQa(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;j=r;r=r+32|0;e=j+4|0;f=j;g=j+16|0;h=j+8|0;k[e>>2]=b;o[f>>2]=c;i[g>>0]=d&1;while(1){b=fgb(12)|0;if(b|0){d=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){d=0;break}Qh[b&7]()}b=d+4|0;k[b>>2]=0;k[d+8>>2]=0;k[d>>2]=b;k[a>>2]=d;k[h>>2]=0;a=h+4|0;k[a>>2]=0;b=ZT(12)|0;k[b>>2]=1;m=b+4|0;k[h>>2]=m;k[a>>2]=6;i[b+10>>0]=0;i[m>>0]=i[373823]|0;i[m+1>>0]=i[373824]|0;i[m+2>>0]=i[373825]|0;i[m+3>>0]=i[373826]|0;i[m+4>>0]=i[373827]|0;i[m+5>>0]=i[373828]|0;m=WHa(d,h)|0;n=k[m>>2]|0;l=m+4|0;jh[k[k[n>>2]>>2]&1023](n,l);k[m>>2]=428712;Ph[k[(k[107178]|0)+4>>2]&511](428712,e,l);k[a>>2]=0;k[h>>2]=0;e=k[b>>2]|0;k[b>>2]=e+-1;if((e|0)==1)ggb(k[b+-4>>2]|0);k[h>>2]=0;n=h+4|0;k[n>>2]=0;b=ZT(8)|0;k[b>>2]=1;l=b+4|0;k[h>>2]=l;k[n>>2]=3;i[b+7>>0]=0;i[l>>0]=i[374006]|0;i[l+1>>0]=i[374007]|0;i[l+2>>0]=i[374008]|0;l=WHa(d,h)|0;e=k[l>>2]|0;m=l+4|0;jh[k[k[e>>2]>>2]&1023](e,m);k[l>>2]=428716;Ph[k[(k[107179]|0)+4>>2]&511](428716,f,m);k[n>>2]=0;k[h>>2]=0;n=k[b>>2]|0;k[b>>2]=n+-1;if((n|0)==1)ggb(k[b+-4>>2]|0);k[h>>2]=0;n=h+4|0;k[n>>2]=0;b=ZT(12)|0;k[b>>2]=1;l=b+4|0;k[h>>2]=l;k[n>>2]=6;i[b+10>>0]=0;i[l>>0]=i[373546]|0;i[l+1>>0]=i[373547]|0;i[l+2>>0]=i[373548]|0;i[l+3>>0]=i[373549]|0;i[l+4>>0]=i[373550]|0;i[l+5>>0]=i[373551]|0;l=WHa(d,h)|0;f=k[l>>2]|0;m=l+4|0;jh[k[k[f>>2]>>2]&1023](f,m);k[l>>2]=428720;Ph[k[(k[107180]|0)+4>>2]&511](428720,g,m);k[n>>2]=0;k[h>>2]=0;n=k[b>>2]|0;k[b>>2]=n+-1;if((n|0)!=1){r=j;return}ggb(k[b+-4>>2]|0);r=j;return}function AQa(a){a=a|0;return k[a+4>>2]|0}function BQa(a){a=a|0;return k[a+8>>2]|0}function CQa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=95084;b=a+348|0;c=k[b>>2]|0;if(c|0?(d=c+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+352>>2]=0;e=a+324|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=a+304|0;if((k[c>>2]|0)>0){d=k[a+332>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[a+336>>2]|0;if(!((b|0)==(a+340|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=a+276|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=a+256|0;if((k[c>>2]|0)>0){d=k[a+284>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[a+288>>2]|0;if(!((b|0)==(a+292|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=a+228|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=a+208|0;if((k[c>>2]|0)>0){d=k[a+236>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[a+240>>2]|0;if(!((b|0)==(a+244|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=a+180|0;b=k[e>>2]|0;if(b|0?(c=b+8|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;c=k[d+4>>2]|0;jh[k[(k[c>>2]|0)+16>>2]&1023](c,d);k[e>>2]=0}c=a+160|0;if((k[c>>2]|0)>0){d=k[a+188>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}k[e>>2]=0;b=k[a+192>>2]|0;if(!((b|0)==(a+196|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+136|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+132>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+116|0;c=a+104|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+140>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+144>>2]|0;if(!((b|0)==(a+148|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+80|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[a+76>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+60|0;c=a+48|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+84>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+88>>2]|0;if((b|0)==(a+92|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function DQa(a){a=a|0;CQa(a);ggb(a);return}function EQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;k[a+8>>2]=k[c>>2];k[a+12>>2]=k[c+4>>2];b=a+24|0;f=a+348|0;e=a+352|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;b=k[e>>2]|0;if(b|0){a=k[b>>2]|0;b=b+4|0;c=k[b>>2]|0;if((c|0)==(a|0))return 1;k[b>>2]=c+(~(((c+-20-a|0)>>>0)/20|0)*20|0);return 1}while(1){d=fgb(12)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;Qh[d&7]()}k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}c=b+4|0;k[c>>2]=1;k[b>>2]=95144;k[b+8>>2]=d;k[c>>2]=(k[c>>2]|0)+1;a=k[f>>2]|0;k[f>>2]=b;k[e>>2]=d;if(a|0?(e=a+4|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);f=k[c>>2]|0;k[c>>2]=f+-1;if((f|0)!=1)return 1;Uh[k[(k[b>>2]|0)+8>>2]&2047](b);return 1}function FQa(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;return}function GQa(a){a=a|0;return -1}function HQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;Z=r;r=r+208|0;X=Z+152|0;Y=Z+96|0;x=Z+80|0;I=Z+88|0;S=Z+16|0;T=Z;U=Z+72|0;R1(x,b,-1);t=k[x>>2]|0;x=k[x+4>>2]|0;j=a+348|0;W=a+352|0;if(!(k[W>>2]|0)){while(1){d=fgb(12)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}f=e+4|0;k[f>>2]=1;k[e>>2]=95144;k[e+8>>2]=d;k[f>>2]=(k[f>>2]|0)+1;g=k[j>>2]|0;k[j>>2]=e;k[W>>2]=d;if(g|0?(Q=g+4|0,R=k[Q>>2]|0,k[Q>>2]=R+-1,(R|0)==1):0)Uh[k[(k[g>>2]|0)+8>>2]&2047](g);R=k[f>>2]|0;k[f>>2]=R+-1;if((R|0)==1)Uh[k[(k[e>>2]|0)+8>>2]&2047](e)}g=k[c>>2]|0;y=(k[c+4>>2]|0)-g>>2;p=k[W>>2]|0;q=p+4|0;d=k[q>>2]|0;j=k[p>>2]|0;s=(d-j|0)/20|0;e=j;f=d;if(y>>>0<=s>>>0)if(y>>>0<s>>>0?(l=e+(y*20|0)|0,(f|0)!=(l|0)):0){k[q>>2]=f+(~(((f+-20-l|0)>>>0)/20|0)*20|0);d=g}else d=g;else{e=y-s|0;n=p+8|0;f=k[n>>2]|0;if(((f-d|0)/20|0)>>>0<e>>>0){if(y>>>0>214748364)ad(426534,426557,304,426811);R=(f-j|0)/20|0;j=R<<1;j=R>>>0<107374182?(j>>>0<y>>>0?y:j):214748364;if(!j)d=0;else{if(j>>>0>214748364){Z=te(4)|0;k[Z>>2]=172664;Cf(Z|0,28816,1287)}f=j*20|0;f=(f|0)==0?1:f;while(1){d=fgb(f)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}f=d+(s*20|0)|0;l=f;g=f;m=l;do{k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g+16>>2]=0;g=m+20|0;m=g;e=e+-1|0}while((e|0)!=0);j=d+(j*20|0)|0;d=k[p>>2]|0;e=k[q>>2]|0;if((e|0)==(d|0))e=l;else{g=e;e=l;do{N=g;g=g+-20|0;k[f+-20>>2]=k[g>>2];k[f+-16>>2]=k[N+-16>>2];k[f+-12>>2]=k[N+-12>>2];N=N+-8|0;Q=k[N+4>>2]|0;R=f+-8|0;k[R>>2]=k[N>>2];k[R+4>>2]=Q;f=e+-20|0;e=f}while((g|0)!=(d|0));d=k[p>>2]|0}k[p>>2]=e;k[q>>2]=m;k[n>>2]=j;if(d|0)ggb(d)}else do{k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;d=(k[q>>2]|0)+20|0;k[q>>2]=d;e=e+-1|0}while((e|0)!=0);d=k[c>>2]|0}G=a+16|0;e=k[G>>2]|0;F=a+20|0;w=k[F>>2]|0;O=+(t|0);h=O/+o[d>>2];d=(o[u>>2]=h,k[u>>2]|0);if((d&2130706432)>>>0<=1249902592){d=(d|0)<0;h=d?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=d?-0.0:0.0}v=~~h+62&-32;d=(e|0)<(v|0);k[G>>2]=d?v:e;d=(y|0)!=(s|0)|d;v=k[W>>2]|0;t=k[v+4>>2]|0;v=k[v>>2]|0;do if(y){q=(t-v|0)/20|0;s=v;p=k[c>>2]|0;B=+(x|0);m=0;l=0;j=0;n=0;while(1){if(q>>>0<=l>>>0){V=47;break}e=s+(l*20|0)|0;if(!d){h=+o[p+(l<<2)>>2];if(+P(+(+o[e>>2]-h))>h*1.1920928955078125e-05){d=1;A=h}else{d=0;A=h}}else{d=1;A=+o[p+(l<<2)>>2]}h=O/A;f=(o[u>>2]=h,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;h=f?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=f?-0.0:0.0}g=~~h;h=B/A;f=(o[u>>2]=h,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;h=f?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=f?-0.0:0.0}k[s+(l*20|0)+16>>2]=A>=2.0?1:2;o[e>>2]=A;f=g+1|0;Q=~~h+1|0;k[s+(l*20|0)+4>>2]=f;k[s+(l*20|0)+8>>2]=Q;R=(l|0)==0?Q:m;V=k[G>>2]|0;N=(f+j|0)>(V|0);e=N?0:j;n=(N?R:0)+n|0;m=N?Q:R;V=(aa(n,V)|0)+e|0;k[s+(l*20|0)+12>>2]=V;l=l+1|0;if((l|0)==(y|0)){V=58;break}else j=e+f|0}if((V|0)==47)ad(426635,426557,315,426658);else if((V|0)==58){E=d;z=m;C=n;D=k[F>>2]|0;break}}else{E=d;z=0;C=0;D=w}while(0);d=z+C|0;d=(D|0)<(d|0)?d:D;k[F>>2]=d;Q=t-v|0;R=(Q|0)/20|0;if(!Q){Y=0;r=Z;return Y|0}z=v;Q=k[z+8>>2]|0;x=a+100|0;y=a+112|0;z=(k[z+4>>2]|0)+15&-16;C=k[y>>2]|0;C=(C|0)<(z|0)?z:C;z=a+108|0;D=k[z>>2]|0;D=(D|0)<(Q|0)?Q:D;if(E|(d|0)!=(w|0)){Uh[k[(k[a>>2]|0)+48>>2]&2047](a);j=k[W>>2]|0;w=a+300|0;e=k[j>>2]|0;l=j+4|0;d=k[l>>2]|0;if((e|0)==(d|0)){g=a+324|0;d=k[g>>2]|0;if(d|0?(N=d+8|0,Q=k[N>>2]|0,k[N>>2]=Q+-1,(Q|0)==1):0){Q=k[g>>2]|0;N=k[Q+4>>2]|0;jh[k[(k[N>>2]|0)+16>>2]&1023](N,Q);k[g>>2]=0}e=a+304|0;if((k[e>>2]|0)>0){f=k[a+332>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}k[g>>2]=0;e=k[j>>2]|0;d=k[l>>2]|0}f=d-e|0;d=e;k[Y>>2]=1124007936;t=Y+4|0;k[t>>2]=2;m=Y+8|0;k[m>>2]=1;j=Y+12|0;k[j>>2]=f;q=Y+16|0;k[q>>2]=d;l=Y+20|0;k[l>>2]=d;n=Y+24|0;p=Y+28|0;s=Y+40|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[s>>2]=m;c=Y+48|0;v=Y+44|0;k[v>>2]=c;k[Y+52>>2]=0;k[c>>2]=0;if((e|0)==0&(f|0)!=0){d=X+4|0;e=ZT(36)|0;k[e>>2]=1;f=e+4|0;k[X>>2]=f;k[d>>2]=28;i[e+32>>0]=0;g=390609;Q=f+28|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(Q|0));Y8(-215,X,390638,390642,410);k[d>>2]=0;k[X>>2]=0;Q=k[e>>2]|0;k[e>>2]=Q+-1;if((Q|0)==1)ggb(k[e+-4>>2]|0);g=k[Y>>2]|16384;f=k[j>>2]|0;e=k[v>>2]|0;d=k[l>>2]|0}else{g=1124024320;e=c}k[Y>>2]=g;k[e>>2]=f;k[e+4>>2]=1;d=d+(aa(k[m>>2]|0,f)|0)|0;k[p>>2]=d;k[n>>2]=d+(0-f)+f;f=X+4|0;d=f+4|0;k[d>>2]=0;k[d+4>>2]=0;k[X>>2]=34209792;k[f>>2]=w;mY(Y,X);f=Y+36|0;d=k[f>>2]|0;if(d|0?(N=d+12|0,Q=k[N>>2]|0,k[N>>2]=Q+-1,(Q|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[Y+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[t>>2]|0)>0){e=k[s>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[t>>2]|0))}d=k[v>>2]|0;if(!((d|0)==(c|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}d=k[b>>2]&2031616;do if((d|0)!=655360)if((d|0)==65536){g=k[b+4>>2]|0;k[Y>>2]=k[g>>2];n=Y+4|0;d=g+4|0;k[n>>2]=k[d>>2];Q=Y+8|0;k[Q>>2]=k[g+8>>2];k[Y+12>>2]=k[g+12>>2];k[Y+16>>2]=k[g+16>>2];k[Y+20>>2]=k[g+20>>2];k[Y+24>>2]=k[g+24>>2];k[Y+28>>2]=k[g+28>>2];k[Y+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Y+36>>2]=e;f=Y+40|0;k[f>>2]=Q;Q=Y+48|0;l=Y+44|0;k[l>>2]=Q;k[Y+52>>2]=0;k[Q>>2]=0;if(e|0){Q=e+12|0;k[Q>>2]=(k[Q>>2]|0)+1}if((k[d>>2]|0)<3){N=k[g+44>>2]|0;Q=k[l>>2]|0;k[Q>>2]=k[N>>2];k[Q+4>>2]=k[N+4>>2];break}k[n>>2]=0;x1(Y,k[d>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[g+40>>2]|0;j=k[f>>2]|0;f=k[g+44>>2]|0;e=k[l>>2]|0;d=0;do{k[j+(d<<2)>>2]=k[m+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[n>>2]|0))}}else V=124;else{if((aa(k[a+28>>2]|0,k[a+24>>2]|0)|0)<=0){V=124;break}f=a+204|0;e=aa(k[a+40>>2]|0,k[F>>2]|0)|0;d=k[G>>2]|0;if(!(((((k[a+208>>2]|0)<3?(k[a+212>>2]|0)==(e|0):0)?(k[a+216>>2]|0)==(d|0):0)?(k[f>>2]&4095|0)==4:0)?(k[a+228>>2]|0)!=0:0)){k[X>>2]=e;k[X+4>>2]=d;v9(f,2,X,4)}z=a+156|0;if(!(((((k[a+160>>2]|0)<3?(k[a+164>>2]|0)==(D|0):0)?(k[a+168>>2]|0)==(C|0):0)?(k[z>>2]&4095|0)==0:0)?(k[a+180>>2]|0)!=0:0)){k[X>>2]=D;k[X+4>>2]=C;v9(z,2,X,0)}g=Y+4|0;j=Y+8|0;l=Y+12|0;m=Y+4|0;n=m+4|0;p=X+32|0;q=I+4|0;s=Y+8|0;t=Y+12|0;v=Y+4|0;w=X+24|0;c=X+4|0;x=X+36|0;y=X+40|0;f=0;do{U=k[W>>2]|0;d=k[U>>2]|0;if((((k[U+4>>2]|0)-d|0)/20|0)>>>0<=f>>>0){V=105;break}U=(k[d+(f*20|0)+4>>2]|0)+-1|0;T=(k[d+(f*20|0)+8>>2]|0)+-1|0;k[Y>>2]=0;k[g>>2]=0;k[j>>2]=U;k[l>>2]=T;u9(X,z,Y);T=n;k[T>>2]=0;k[T+4>>2]=0;k[Y>>2]=34209792;k[m>>2]=X;T=k[p>>2]|0;U=k[T>>2]|0;k[I>>2]=k[T+4>>2];k[q>>2]=U;O=1.0/+o[d+(f*20|0)>>2];Rla(b,Y,I,O,O,1);d=k[(k[a>>2]|0)+44>>2]|0;k[s>>2]=0;k[t>>2]=0;k[Y>>2]=17432576;k[v>>2]=X;Ph[d&511](a,f,Y);d=k[w>>2]|0;if(d|0?(T=d+8|0,U=k[T>>2]|0,k[T>>2]=U+-1,(U|0)==1):0){U=k[w>>2]|0;T=k[U+4>>2]|0;jh[k[(k[T>>2]|0)+16>>2]&1023](T,U);k[w>>2]=0}if((k[c>>2]|0)>0){e=k[p>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[c>>2]|0))}k[w>>2]=0;d=k[x>>2]|0;if(!((d|0)==(y|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=f+1|0}while(f>>>0<R>>>0);if((V|0)==105)ad(426635,426557,315,426658);k[a+4>>2]=2;Y=1;r=Z;return Y|0}while(0);if((V|0)==124)Q1(Y,b,-1);f=a+44|0;e=aa(k[a+40>>2]|0,k[F>>2]|0)|0;d=k[G>>2]|0;if(!(((((k[a+48>>2]|0)<3?(k[a+52>>2]|0)==(e|0):0)?(k[a+56>>2]|0)==(d|0):0)?(k[f>>2]&4095|0)==4:0)?(k[a+60>>2]|0)!=0:0)){k[X>>2]=e;k[X+4>>2]=d;G1(f,2,X,4)}if(((((k[a+104>>2]|0)<3?(k[z>>2]|0)==(D|0):0)?(k[y>>2]|0)==(C|0):0)?(k[x>>2]&4095|0)==0:0)?(H=a+116|0,(k[H>>2]|0)!=0):0)n=H;else{k[X>>2]=D;k[X+4>>2]=C;G1(x,2,X,0);n=a+116|0}p=S+4|0;q=S+8|0;s=S+12|0;t=S+16|0;v=S+20|0;w=S+24|0;c=S+28|0;x=S+40|0;y=S+48|0;z=S+44|0;C=S+52|0;D=X+4|0;E=X+8|0;F=X+12|0;G=X+4|0;H=T+4|0;b=H+4|0;I=U+4|0;J=X+8|0;K=X+12|0;L=X+4|0;M=S+36|0;N=S+32|0;m=0;do{Q=k[W>>2]|0;d=k[Q>>2]|0;if((((k[Q+4>>2]|0)-d|0)/20|0)>>>0<=m>>>0){V=139;break}Q=(k[d+(m*20|0)+8>>2]|0)+-1|0;e=(k[d+(m*20|0)+4>>2]|0)+-1|0;f=k[n>>2]|0;k[S>>2]=1124007936;k[p>>2]=2;k[q>>2]=Q;k[s>>2]=e;k[t>>2]=f;k[v>>2]=f;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;k[x>>2]=q;k[z>>2]=y;k[C>>2]=0;k[y>>2]=0;if((f|0)==0&(aa(e,Q)|0)!=0){k[X>>2]=0;k[D>>2]=0;e=ZT(36)|0;k[e>>2]=1;f=e+4|0;k[X>>2]=f;k[D>>2]=28;i[e+32>>0]=0;g=390609;Q=f+28|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(Q|0));Y8(-215,X,390638,390642,410);k[D>>2]=0;k[X>>2]=0;Q=k[e>>2]|0;k[e>>2]=Q+-1;if((Q|0)==1)ggb(k[e+-4>>2]|0);l=k[S>>2]|0;e=k[s>>2]|0;j=k[z>>2]|0;f=k[v>>2]|0;g=k[x>>2]|0}else{l=1124007936;j=y;g=q}k[S>>2]=l|16384;k[j>>2]=e;k[j+4>>2]=1;Q=f+(aa(k[q>>2]|0,e)|0)|0;k[c>>2]=Q;k[w>>2]=Q+(0-e)+e;k[E>>2]=0;k[F>>2]=0;k[X>>2]=16842752;k[G>>2]=Y;Q=b;k[Q>>2]=0;k[Q+4>>2]=0;k[T>>2]=33619968;k[H>>2]=S;Q=k[g>>2]|0;k[U>>2]=k[g+4>>2];k[I>>2]=Q;O=1.0/+o[d+(m*20|0)>>2];Rla(X,T,U,O,O,1);d=k[(k[a>>2]|0)+44>>2]|0;k[J>>2]=0;k[K>>2]=0;k[X>>2]=16842752;k[L>>2]=S;Ph[d&511](a,m,X);d=k[M>>2]|0;if(d|0?(l=d+12|0,Q=k[l>>2]|0,k[l>>2]=Q+-1,(Q|0)==1):0){e=k[M>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[N>>2]|0;if(!d){d=B1()|0;e=k[M>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[M>>2]=0}k[M>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[p>>2]|0)>0){e=k[x>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[p>>2]|0))}d=k[z>>2]|0;if(!((d|0)==(y|0)|(d|0)==0))ggb(k[d+-4>>2]|0);m=m+1|0}while(m>>>0<R>>>0);if((V|0)==139)ad(426635,426557,315,426658);k[a+4>>2]=1;f=Y+36|0;d=k[f>>2]|0;if(d|0?(W=d+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[Y+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;X=Y+16|0;e=Y+4|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[e>>2]|0)>0){f=k[Y+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[Y+44>>2]|0;if(!((d|0)==(Y+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);Y=1;r=Z;return Y|0}function IQa(a,b,c){a=a|0;b=b|0;c=c|0;return 1}function JQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;c=n;d=a+4|0;if(!(k[d>>2]&2)){m=c+4|0;l=m+4|0;k[l>>2]=0;k[l+4>>2]=0;k[c>>2]=34209792;k[m>>2]=a+204;mY(a+44|0,c);k[d>>2]=k[d>>2]|2}j=k[b>>2]|0;m=b+4|0;while(1){g=k[m>>2]|0;if((g|0)==(j|0))break;k[m>>2]=g+-48;f=g+-24|0;c=k[f>>2]|0;if(c|0?(i=c+8|0,l=k[i>>2]|0,k[i>>2]=l+-1,(l|0)==1):0){l=k[f>>2]|0;i=k[l+4>>2]|0;jh[k[(k[i>>2]|0)+16>>2]&1023](i,l);k[f>>2]=0}d=g+-44|0;if((k[d>>2]|0)>0){e=k[g+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}k[f>>2]=0;c=k[g+-12>>2]|0;if((c|0)==(g+-8|0)|(c|0)==0)continue;ggb(k[c+-4>>2]|0)}c=a+300|0;l=b+8|0;if((j|0)==(k[l>>2]|0)){PQa(b,c);e=k[m>>2]|0}else{k[j>>2]=k[c>>2];i=j+4|0;c=a+304|0;k[i>>2]=k[c>>2];g=j+8|0;k[g>>2]=k[a+308>>2];k[j+12>>2]=k[a+312>>2];k[j+16>>2]=k[a+316>>2];k[j+20>>2]=k[a+320>>2];d=k[a+324>>2]|0;k[j+24>>2]=d;k[j+28>>2]=k[a+328>>2];e=j+32|0;k[e>>2]=g;g=j+40|0;h=j+36|0;k[h>>2]=g;k[j+44>>2]=0;k[g>>2]=0;if(d|0){g=d+8|0;k[g>>2]=(k[g>>2]|0)+1}if((k[c>>2]|0)>=3){k[i>>2]=0;s9(j,k[c>>2]|0,0,0,0);if((k[i>>2]|0)>0){g=k[a+332>>2]|0;f=k[e>>2]|0;e=k[a+336>>2]|0;d=k[h>>2]|0;c=0;do{k[f+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{i=k[a+336>>2]|0;j=k[h>>2]|0;k[j>>2]=k[i>>2];k[j+4>>2]=k[i+4>>2]}e=(k[m>>2]|0)+48|0;k[m>>2]=e}c=a+204|0;if((e|0)==(k[l>>2]|0)){PQa(b,c);f=k[m>>2]|0}else{k[e>>2]=k[c>>2];i=e+4|0;c=a+208|0;k[i>>2]=k[c>>2];j=e+8|0;k[j>>2]=k[a+212>>2];k[e+12>>2]=k[a+216>>2];k[e+16>>2]=k[a+220>>2];k[e+20>>2]=k[a+224>>2];d=k[a+228>>2]|0;k[e+24>>2]=d;k[e+28>>2]=k[a+232>>2];f=e+32|0;k[f>>2]=j;j=e+40|0;h=e+36|0;k[h>>2]=j;k[e+44>>2]=0;k[j>>2]=0;if(d|0){j=d+8|0;k[j>>2]=(k[j>>2]|0)+1}if((k[c>>2]|0)>=3){k[i>>2]=0;s9(e,k[c>>2]|0,0,0,0);if((k[i>>2]|0)>0){g=k[a+236>>2]|0;e=k[f>>2]|0;f=k[a+240>>2]|0;d=k[h>>2]|0;c=0;do{k[e+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{i=k[a+240>>2]|0;j=k[h>>2]|0;k[j>>2]=k[i>>2];k[j+4>>2]=k[i+4>>2]}f=(k[m>>2]|0)+48|0;k[m>>2]=f}c=a+252|0;if((f|0)==(k[l>>2]|0)){PQa(b,c);r=n;return}k[f>>2]=k[c>>2];i=f+4|0;c=a+256|0;k[i>>2]=k[c>>2];b=f+8|0;k[b>>2]=k[a+260>>2];k[f+12>>2]=k[a+264>>2];k[f+16>>2]=k[a+268>>2];k[f+20>>2]=k[a+272>>2];d=k[a+276>>2]|0;k[f+24>>2]=d;k[f+28>>2]=k[a+280>>2];e=f+32|0;k[e>>2]=b;b=f+40|0;h=f+36|0;k[h>>2]=b;k[f+44>>2]=0;k[b>>2]=0;if(d|0){b=d+8|0;k[b>>2]=(k[b>>2]|0)+1}if((k[c>>2]|0)>=3){k[i>>2]=0;s9(f,k[c>>2]|0,0,0,0);if((k[i>>2]|0)>0){g=k[a+284>>2]|0;f=k[e>>2]|0;e=k[a+288>>2]|0;d=k[h>>2]|0;c=0;do{k[f+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{b=k[a+288>>2]|0;a=k[h>>2]|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2]}k[m>>2]=(k[m>>2]|0)+48;r=n;return}function KQa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;d=r;r=r+16|0;b=d;c=a+4|0;if(k[c>>2]&1|0){r=d;return}e=b+4|0;f=e+4|0;k[f>>2]=0;k[f+4>>2]=0;k[b>>2]=33619968;k[e>>2]=a+44;w9(a+204|0,b);k[c>>2]=k[c>>2]|1;r=d;return}function LQa(a,b){a=a|0;b=b|0;return 0.0}function MQa(a,b){a=a|0;b=b|0;return 0}function NQa(a,b,c){a=a|0;b=b|0;c=c|0;return}function OQa(a){a=a|0;return}function PQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;q=a+4|0;c=k[a>>2]|0;h=((k[q>>2]|0)-c|0)/48|0;d=h+1|0;if(d>>>0>89478485)ad(426534,426557,304,426811);r=a+8|0;p=((k[r>>2]|0)-c|0)/48|0;e=p<<1;e=p>>>0<44739242?(e>>>0<d>>>0?d:e):89478485;if(!e)c=0;else{if(e>>>0>89478485){r=te(4)|0;k[r>>2]=172664;Cf(r|0,28816,1287)}d=e*48|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}m=c+(h*48|0)|0;d=m;p=c+(e*48|0)|0;k[m>>2]=k[b>>2];l=c+(h*48|0)+4|0;g=b+4|0;e=k[g>>2]|0;k[l>>2]=e;o=c+(h*48|0)+8|0;k[o>>2]=k[b+8>>2];k[c+(h*48|0)+12>>2]=k[b+12>>2];k[c+(h*48|0)+16>>2]=k[b+16>>2];k[c+(h*48|0)+20>>2]=k[b+20>>2];f=k[b+24>>2]|0;k[c+(h*48|0)+24>>2]=f;k[c+(h*48|0)+28>>2]=k[b+28>>2];i=c+(h*48|0)+32|0;k[i>>2]=o;o=c+(h*48|0)+40|0;j=c+(h*48|0)+36|0;k[j>>2]=o;k[c+(h*48|0)+44>>2]=0;k[o>>2]=0;if(!f)c=e;else{c=f+8|0;k[c>>2]=(k[c>>2]|0)+1;c=k[g>>2]|0}if((c|0)>=3){k[l>>2]=0;s9(m,k[g>>2]|0,0,0,0);if((k[l>>2]|0)>0){h=k[b+32>>2]|0;g=k[i>>2]|0;f=k[b+36>>2]|0;e=k[j>>2]|0;c=0;do{k[g+(c<<2)>>2]=k[h+(c<<2)>>2];k[e+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[l>>2]|0))}}else{n=k[b+36>>2]|0;o=k[j>>2]|0;k[o>>2]=k[n>>2];k[o+4>>2]=k[n+4>>2]}o=m+48|0;n=k[a>>2]|0;c=k[q>>2]|0;if((c|0)==(n|0)){c=n;j=c}else{g=m;do{f=g+-48|0;l=c;c=c+-48|0;k[f>>2]=k[c>>2];m=g+-44|0;h=l+-44|0;k[m>>2]=k[h>>2];j=g+-40|0;k[j>>2]=k[l+-40>>2];k[g+-36>>2]=k[l+-36>>2];k[g+-32>>2]=k[l+-32>>2];k[g+-28>>2]=k[l+-28>>2];e=k[l+-24>>2]|0;k[g+-24>>2]=e;k[g+-20>>2]=k[l+-20>>2];i=g+-16|0;k[i>>2]=j;j=g+-8|0;b=g+-12|0;k[b>>2]=j;k[g+-4>>2]=0;k[j>>2]=0;if(e|0){j=e+8|0;k[j>>2]=(k[j>>2]|0)+1}if((k[h>>2]|0)>=3){k[m>>2]=0;s9(f,k[h>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[l+-16>>2]|0;h=k[i>>2]|0;g=k[l+-12>>2]|0;f=k[b>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[j+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else{l=k[l+-12>>2]|0;m=k[b>>2]|0;k[m>>2]=k[l>>2];k[m+4>>2]=k[l+4>>2]}g=d+-48|0;d=g}while((c|0)!=(n|0));j=k[a>>2]|0;c=k[q>>2]|0}k[a>>2]=d;k[q>>2]=o;k[r>>2]=p;i=j;while(1){if((c|0)==(i|0))break;h=c+-48|0;g=c+-24|0;d=k[g>>2]|0;if(d|0?(q=d+8|0,r=k[q>>2]|0,k[q>>2]=r+-1,(r|0)==1):0){r=k[g>>2]|0;q=k[r+4>>2]|0;jh[k[(k[q>>2]|0)+16>>2]&1023](q,r);k[g>>2]=0}e=c+-44|0;if((k[e>>2]|0)>0){f=k[c+-16>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}k[g>>2]=0;d=k[c+-12>>2]|0;if((d|0)==(c+-8|0)|(d|0)==0){c=h;continue}ggb(k[d+-4>>2]|0);c=h}if(!j)return;ggb(j);return}function QQa(a){a=a|0;ggb(a);return}function RQa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=k[a+8>>2]|0;if(b|0){c=k[b>>2]|0;d=c;if(c|0){e=b+4|0;f=k[e>>2]|0;if((f|0)!=(c|0))k[e>>2]=f+(~(((f+-20-d|0)>>>0)/20|0)*20|0);ggb(c)}ggb(b)}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function SQa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=95164;b=a+372|0;c=k[b>>2]|0;if(c|0?(e=c+4|0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+376>>2]=0;b=a+364|0;c=k[b>>2]|0;if(c|0?(d=c+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+368>>2]=0;b=a+356|0;c=k[b>>2]|0;if(c|0?(d=c+4|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+360>>2]=0;CQa(a);return}function TQa(a){a=a|0;SQa(a);ggb(a);return}
function W5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;ja=r;r=r+8256|0;ea=ja+8224|0;ha=ja+8192|0;g=ja+4096|0;ia=ja;f=k6(a,b,225896)|0;c=k6(a,b,225918)|0;if((c|0)!=0?(k[c>>2]&7|0)==3:0){c=k[c+8+4>>2]|0;if(!((f|0)!=0&(c|0)!=0))ca=4}else{c=0;ca=4}if((ca|0)==4){d=ea+4|0;e=ZT(52)|0;k[e>>2]=1;n=e+4|0;k[ea>>2]=n;k[d>>2]=46;i[e+50>>0]=0;o=226106;p=n+46|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-2,ea,227126,221854,3793);k[d>>2]=0;k[ea>>2]=0;ba=k[e>>2]|0;k[e>>2]=ba+-1;if((ba|0)==1)ggb(k[e+-4>>2]|0)}d=k[f>>2]&7;if((d|0)==5)ba=k[(k[f+8>>2]|0)+24>>2]|0;else ba=(d|0)==1?1:-1;$=ba+-1|0;if($>>>0>1023){d=ea+4|0;e=ZT(56)|0;k[e>>2]=1;n=e+4|0;k[ea>>2]=n;k[d>>2]=48;i[e+52>>0]=0;o=227143;p=n+48|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-212,ea,227126,221854,3799);k[d>>2]=0;k[ea>>2]=0;_=k[e>>2]|0;k[e>>2]=_+-1;if((_|0)==1)ggb(k[e+-4>>2]|0);h=g}else h=g;n6(a,f,ea);if((k[f>>2]&7|0)==5)d=k[(k[f+8>>2]|0)+24>>2]|0;else d=1;o6(a,ea,d,g,225902);f=m6(c)|0;g=k6(a,b,225921)|0;if(!((g|0)!=0?(k[g>>2]&7|0)==5:0)){d=ea+4|0;e=ZT(52)|0;k[e>>2]=1;n=e+4|0;k[ea>>2]=n;k[d>>2]=44;i[e+48>>0]=0;o=226212;p=n+44|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-2,ea,227126,221854,3806);k[d>>2]=0;k[ea>>2]=0;_=k[e>>2]|0;k[e>>2]=_+-1;if((_|0)==1)ggb(k[e+-4>>2]|0)}_=H9(ba,h,f)|0;e=f>>>3&511;Z=e+1|0;d=k[g+8>>2]|0;n6(a,g,ha);W=d+24|0;if((k[W>>2]|0)<=0){r=ja;return _|0}X=ha+12|0;Y=ia+($<<2)|0;U=d+28|0;V=ha+20|0;B=e+2|0;C=ea+4|0;D=ea+4|0;E=(_|0)==0;F=ea+4|0;G=ia+4|0;H=_+24|0;I=_+20|0;J=_+16|0;K=_+4|0;L=ea+4|0;M=_+68|0;N=_+28|0;O=_+8|0;P=_+48|0;Q=_+40|0;R=_+44|0;S=_+72|0;T=ea+4|0;s=ea+4|0;t=_+64|0;u=ea+4|0;v=_+32|0;w=ea+4|0;x=ea+4|0;y=ea+4|0;z=ha+8|0;q=ha+4|0;A=ha+16|0;f=0;do{d=k[X>>2]|0;if((k[d>>2]&7|0)!=1){e=ZT(36)|0;k[e>>2]=1;n=e+4|0;k[ea>>2]=n;k[D>>2]=31;i[e+35>>0]=0;o=227192;p=n+31|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-212,ea,227126,221854,3821);k[D>>2]=0;k[ea>>2]=0;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0)}d=k[d+8>>2]|0;e=(f|0)>0;if(!(e&(d|0)>-1)){if(e)d=$+d|0;else{k[ia>>2]=d;d=1}if((d|0)<(ba|0))do{e=(k[X>>2]|0)+(k[U>>2]|0)|0;k[X>>2]=e;if(e>>>0>=(k[V>>2]|0)>>>0){p=k[(k[z>>2]|0)+4>>2]|0;k[z>>2]=p;e=k[p+16>>2]|0;k[X>>2]=e;n=e;o=k[(k[q>>2]|0)+28>>2]|0;p=k[p+12>>2]|0;k[A>>2]=n;p=n+(aa(o,p)|0)|0;k[V>>2]=p}f=f+1|0;if((k[e>>2]&7|0)==1?(da=k[e+8>>2]|0,(da|0)>=0):0)e=da;else{g=ZT(36)|0;k[g>>2]=1;n=g+4|0;k[ea>>2]=n;k[C>>2]=31;i[g+35>>0]=0;o=227192;p=n+31|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-212,ea,227126,221854,3837);k[C>>2]=0;k[ea>>2]=0;p=k[g>>2]|0;k[g>>2]=p+-1;if((p|0)==1)ggb(k[g+-4>>2]|0);e=k[e+8>>2]|0}k[ia+(d<<2)>>2]=e;d=d+1|0}while((d|0)<(ba|0))}else k[Y>>2]=d;p=(k[X>>2]|0)+(k[U>>2]|0)|0;k[X>>2]=p;if(p>>>0>=(k[V>>2]|0)>>>0){p=k[(k[z>>2]|0)+4>>2]|0;k[z>>2]=p;n=k[p+16>>2]|0;k[X>>2]=n;o=k[(k[q>>2]|0)+28>>2]|0;p=k[p+12>>2]|0;k[A>>2]=n;p=n+(aa(o,p)|0)|0;k[V>>2]=p}a:do if(E)ca=97;else{e=k[_>>2]|0;b=e&-65536;b:do if((b|0)<1111687168){switch(b|0){case 1111621632:break;default:{ca=57;break b}}if((k[H>>2]|0)>0){if(!((k[I>>2]|0)>0|(e|0)==112)){ca=97;break a}d=k[ia>>2]|0;g=k[G>>2]|0;ca=59}else ca=57}else{if((b|0)>=1111752704){switch(b|0){case 1111752704:break;default:{ca=57;break b}}d=M9(_,ia)|0;break a}switch(b|0){case 1111687168:break;default:{ca=57;break b}}d=k[J>>2]|0;if(!d)ca=57;else{e=k[K>>2]|0;if((e|0)>0)b=0;else break a;while(1){h=ia+(b<<2)|0;g=k[h>>2]|0;if(g>>>0>=(k[I+(b<<3)>>2]|0)>>>0){e=ZT(28)|0;k[e>>2]=1;n=e+4|0;k[ea>>2]=n;k[y>>2]=21;i[e+25>>0]=0;o=234903;p=n+21|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-211,ea,235102,233613,1903);k[y>>2]=0;k[ea>>2]=0;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0);g=k[h>>2]|0;e=k[K>>2]|0}d=d+(aa(k[I+(b<<3)+4>>2]|0,g)|0)|0;b=b+1|0;if((b|0)>=(e|0))break a}}}while(0);if((ca|0)==57){if((e|0)!=112){ca=97;break}d=k[ia>>2]|0;g=k[G>>2]|0;if((b|0)==1111621632)ca=59;else ca=68}if((ca|0)==59){ca=0;h=k[H>>2]|0;if(((h|0)>0?(fa=k[I>>2]|0,(fa|0)>0):0)?(ga=k[J>>2]|0,(ga|0)!=0):0){if(h>>>0>g>>>0&fa>>>0>d>>>0)h=ga;else{e=ZT(28)|0;k[e>>2]=1;n=e+4|0;k[ea>>2]=n;k[L>>2]=21;i[e+25>>0]=0;o=234903;p=n+21|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-211,ea,234925,233613,1764);k[L>>2]=0;k[ea>>2]=0;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0);h=k[J>>2]|0;e=k[_>>2]|0}d=h+(aa(k[K>>2]|0,d)|0)+(aa((e>>>3&511)+1<<(47696>>>(e<<1&14)&3),g)|0)|0;break}if((e|0)==112)ca=68}c:do if((ca|0)==68){ca=0;l=k[M>>2]|0;if(!l){if((b|0)>=1111752704){switch(b|0){case 1111752704:break;default:break c}k[ea>>2]=d;k[x>>2]=g;d=M9(_,ea)|0;break a}switch(b|0){case 1111687168:break;default:break c}e=k[J>>2]|0;if(!e)break;do if((k[K>>2]|0)==2){if((k[I>>2]|0)>>>0<=d>>>0){ca=89;break}if((k[N>>2]|0)>>>0<=g>>>0)ca=89}else ca=89;while(0);if((ca|0)==89){ca=0;e=ZT(28)|0;k[e>>2]=1;n=e+4|0;k[ea>>2]=n;k[w>>2]=21;i[e+25>>0]=0;o=234903;p=n+21|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-211,ea,234925,233613,1827);k[w>>2]=0;k[ea>>2]=0;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0);e=k[J>>2]|0}d=e+(aa(k[H>>2]|0,d)|0)|0;d=d+(aa(k[v>>2]|0,g)|0)|0;break a}e=(k[J>>2]|0)>>>3&31;m=(k[N>>2]|0)==0;if(m)e=aa(k[O>>2]|0,e)|0;j=k[P>>2]|0;if(j){h=k[j+12>>2]|0;b=k[j+16>>2]|0;p=aa(k[S>>2]|0,k[j+8>>2]|0)|0;l=l+((aa(k[j+4>>2]|0,e)|0)+p)|0;if(!m){j=k[j>>2]|0;if(!j){m=ZT(52)|0;k[m>>2]=1;n=m+4|0;k[ea>>2]=n;k[s>>2]=45;i[m+49>>0]=0;o=234933;p=n+45|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-24,ea,234925,233613,1795);k[s>>2]=0;k[ea>>2]=0;p=k[m>>2]|0;k[m>>2]=p+-1;if((p|0)==1)ggb(k[m+-4>>2]|0)}l=l+(aa(k[t>>2]|0,j+-1|0)|0)|0}}else{b=k[R>>2]|0;h=k[Q>>2]|0}if(!(h>>>0>g>>>0&b>>>0>d>>>0)){h=ZT(28)|0;k[h>>2]=1;n=h+4|0;k[ea>>2]=n;k[T>>2]=21;i[h+25>>0]=0;o=234903;p=n+21|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-211,ea,234925,233613,1807);k[T>>2]=0;k[ea>>2]=0;p=k[h>>2]|0;k[h>>2]=p+-1;if((p|0)==1)ggb(k[h+-4>>2]|0)}d=l+((aa(k[S>>2]|0,d)|0)+(aa(e,g)|0))|0;break a}while(0);d=ZT(44)|0;k[d>>2]=1;n=d+4|0;k[ea>>2]=n;k[u>>2]=38;i[d+42>>0]=0;o=233744;p=n+38|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-5,ea,234925,233613,1840);k[u>>2]=0;k[ea>>2]=0;p=k[d>>2]|0;k[d>>2]=p+-1;if((p|0)==1)ggb(k[d+-4>>2]|0);d=0}while(0);if((ca|0)==97){ca=0;d=ZT(44)|0;k[d>>2]=1;n=d+4|0;k[ea>>2]=n;k[F>>2]=38;i[d+42>>0]=0;o=233744;p=n+38|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-5,ea,235102,233613,1913);k[F>>2]=0;k[ea>>2]=0;p=k[d>>2]|0;k[d>>2]=p+-1;if((p|0)==1)ggb(k[d+-4>>2]|0);d=0}o6(a,ha,Z,d,c);f=B+f|0}while((f|0)<(k[W>>2]|0));r=ja;return _|0}function X5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;Ja=r;r=r+1856|0;Ea=Ja;ya=Ja+1808|0;za=Ja+272|0;Aa=Ja+240|0;Ba=Ja+208|0;Ca=Ja+176|0;Da=Ja+144|0;wa=Ja+112|0;xa=Ja+80|0;Ha=Ja+76|0;m=Ja+64|0;Fa=Ja+32|0;Ia=Ja+1840|0;va=zY(0)|0;k[Ha>>2]=va;g6(a,b,6,225831);Ga=N9(c,0)|0;g6(a,225896,13,0);h6(a,c+36|0,Ga,225902);_4(a);ua=k[c>>2]|0;d=i[225904+(ua&7)>>0]|0;k[Ea>>2]=(ua>>>3&511)+1;k[Ea+4>>2]=d;Cfb(Ia,225913,Ea);i6(a,225918,Ia+((i[Ia+2>>0]|0)==0&(i[Ia>>0]|0)==49&1)|0,0);g6(a,225921,13,0);va=HY(7,56,4,va)|0;d=K9(c,m)|0;if(d|0){g=c+32|0;h=m+4|0;j=m+8|0;a:while(1){k[Ea>>2]=d+(k[g>>2]|0);SY(va,Ea)|0;d=k[(k[h>>2]|0)+4>>2]|0;if(!d){b=(k[j>>2]|0)+1|0;k[j>>2]=b;d=k[m>>2]|0;f=k[d+24>>2]|0;if((b|0)>=(f|0))break;e=k[d+20>>2]|0;while(1){d=k[e+(b<<2)>>2]|0;if(d|0)break;d=b+1|0;if((d|0)<(f|0))b=d;else break a}k[j>>2]=b}k[h>>2]=d}}d=(va|0)!=0;if(!(d?(k[va>>2]&-65536|0)==1117323264:0)){d=d?-5:-27;b=Aa+4|0;e=ZT(24)|0;k[e>>2]=1;f=e+4|0;k[Aa>>2]=f;k[b>>2]=18;i[e+22>>0]=0;g=212559;h=f+18|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(d,Aa,212578,211567,1921);k[b>>2]=0;k[Aa>>2]=0;ua=k[e>>2]|0;k[e>>2]=ua+-1;if((ua|0)==1)ggb(k[e+-4>>2]|0)}ua=va+24|0;b:do if((k[ua>>2]|0)>=2){qa=k[va+28>>2]|0;ra=qa*7|0;sa=Ea+4|0;d=sa+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[Ea>>2]=32;k[sa>>2]=va;d=k[va+52>>2]|0;if(!d){pa=Ea+8|0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;k[pa+16>>2]=0;k[pa+20>>2]=0;ma=Ea+12|0;la=ma;na=Ea+16|0;oa=Ea+20|0;d=0;g=0;h=0}else{pa=k[d>>2]|0;g=k[d+16>>2]|0;ma=Ea+12|0;k[ma>>2]=g;pa=(k[pa+16>>2]|0)+(aa((k[pa+12>>2]|0)+-1|0,qa)|0)|0;k[Ea+28>>2]=pa;k[Ea+24>>2]=k[d+8>>2];pa=Ea+8|0;k[pa>>2]=d;h=g;na=Ea+16|0;k[na>>2]=h;h=h+(aa(qa,k[d+12>>2]|0)|0)|0;oa=Ea+20|0;k[oa>>2]=h;la=ma};k[ya>>2]=k[Ea>>2];k[ya+4>>2]=k[Ea+4>>2];k[ya+8>>2]=k[Ea+8>>2];k[ya+12>>2]=k[Ea+12>>2];k[ya+16>>2]=k[Ea+16>>2];k[ya+20>>2]=k[Ea+20>>2];k[ya+24>>2]=k[Ea+24>>2];k[ya+28>>2]=k[Ea+28>>2];k[za>>2]=d;k[za+4>>2]=g;k[za+8>>2]=g;k[za+12>>2]=h;ha=ya+12|0;ia=0-qa|0;b=(k[ha>>2]|0)+ia|0;k[ha>>2]=b;ja=ya+16|0;d=k[ja>>2]|0;ka=ya+8|0;if(b>>>0<d>>>0){f=k[k[ka>>2]>>2]|0;k[ka>>2]=f;d=k[f+16>>2]|0;e=k[f+12>>2]|0;ga=ya+4|0;fa=k[(k[ga>>2]|0)+28>>2]|0;b=d+(aa(fa,e+-1|0)|0)|0;k[ha>>2]=b;k[ja>>2]=d;e=d+(aa(fa,e)|0)|0;fa=ya+20|0;k[fa>>2]=e;da=ka;ea=fa}else{e=ya+20|0;da=ka;ea=e;fa=e;ga=ya+4|0;f=k[ka>>2]|0;e=k[e>>2]|0}k[za+16>>2]=f;k[za+20>>2]=b;k[za+24>>2]=d;k[za+28>>2]=e;C=wa+12|0;D=(qa|0)>0;E=Da+12|0;F=Da+16|0;G=Da+8|0;H=Da+4|0;I=Da+20|0;J=Ba+12|0;K=Ba+20|0;L=Ba+8|0;z=Ba+4|0;M=Ba+16|0;N=wa+20|0;O=xa+12|0;P=xa+20|0;Q=xa+8|0;B=xa+4|0;R=xa+16|0;S=wa+8|0;A=wa+4|0;T=wa+16|0;U=Aa+8|0;V=Aa+12|0;W=Aa+16|0;X=Aa+20|0;Y=Ca+8|0;Z=Ca+12|0;_=Ca+16|0;$=Ca+20|0;x=(qa|0)<1;y=D^1;ca=(qa|0)==1;ba=(Ga|0)>0;m=0;n=g;j=g;g=h;while(1){w=k[za+(m<<5)>>2]|0;k[pa>>2]=w;k[ma>>2]=n;k[na>>2]=j;k[oa>>2]=g;k[da>>2]=f;k[ha>>2]=b;k[ja>>2]=d;k[fa>>2]=e;u=m+-1|0;b=w;d=f;c:while(1){if((b|0)==(d|0))d=(k[ha>>2]|0)+qa-(k[ma>>2]|0)|0;else{d=RY(ya)|0;d=aa(d+1-(RY(Ea)|0)|0,qa)|0}if((d|0)<=(ra|0)){d=u;ta=31;break};k[wa>>2]=k[Ea>>2];k[wa+4>>2]=k[Ea+4>>2];k[wa+8>>2]=k[Ea+8>>2];k[wa+12>>2]=k[Ea+12>>2];k[wa+16>>2]=k[Ea+16>>2];k[wa+20>>2]=k[Ea+20>>2];k[wa+24>>2]=k[Ea+24>>2];k[wa+28>>2]=k[Ea+28>>2];k[Aa>>2]=k[Ea>>2];k[Aa+4>>2]=k[Ea+4>>2];k[Aa+8>>2]=k[Ea+8>>2];k[Aa+12>>2]=k[Ea+12>>2];k[Aa+16>>2]=k[Ea+16>>2];k[Aa+20>>2]=k[Ea+20>>2];k[Aa+24>>2]=k[Ea+24>>2];k[Aa+28>>2]=k[Ea+28>>2];k[Da>>2]=k[ya>>2];k[Da+4>>2]=k[ya+4>>2];k[Da+8>>2]=k[ya+8>>2];k[Da+12>>2]=k[ya+12>>2];k[Da+16>>2]=k[ya+16>>2];k[Da+20>>2]=k[ya+20>>2];k[Da+24>>2]=k[ya+24>>2];k[Da+28>>2]=k[ya+28>>2];k[Ca>>2]=k[ya>>2];k[Ca+4>>2]=k[ya+4>>2];k[Ca+8>>2]=k[ya+8>>2];k[Ca+12>>2]=k[ya+12>>2];k[Ca+16>>2]=k[ya+16>>2];k[Ca+20>>2]=k[ya+20>>2];k[Ca+24>>2]=k[ya+24>>2];k[Ca+28>>2]=k[ya+28>>2];s=(d|0)/(qa|0)|0;d:do if((s|0)>40){t=s>>>3;m=k[C>>2]|0;LY(wa,t,1);h=k[C>>2]|0;LY(wa,t,1);n=k[C>>2]|0;j=k[m>>2]|0;g=k[h>>2]|0;e:do if(ba){b=0;while(1){d=(k[j+(b<<2)>>2]|0)-(k[g+(b<<2)>>2]|0)|0;b=b+1|0;if(d|0)break;if((b|0)>=(Ga|0)){d=0;break}}d=(d|0)<0;e=k[n>>2]|0;f:do if(ba){b=0;while(1){f=(k[g+(b<<2)>>2]|0)-(k[e+(b<<2)>>2]|0)|0;b=b+1|0;if(f|0){b=f;break f}if((b|0)>=(Ga|0)){b=0;break}}}else b=0;while(0);if(!d){if((b|0)>0)break;if(ba)b=0;else{d=0;ta=78;break}while(1){d=(k[j+(b<<2)>>2]|0)-(k[e+(b<<2)>>2]|0)|0;b=b+1|0;if(d|0){ta=78;break e}if((b|0)>=(Ga|0)){d=0;ta=78;break e}}}if((b|0)>=0){g:do if(ba){b=0;while(1){d=(k[j+(b<<2)>>2]|0)-(k[e+(b<<2)>>2]|0)|0;b=b+1|0;if(d|0)break g;if((b|0)>=(Ga|0)){d=0;break}}}else d=0;while(0);h=(d|0)<0?n:m}}else{d=0;ta=78}while(0);if((ta|0)==78){ta=0;h=(d|0)<0?m:n}p=s>>>1;q=t*3|0;LY(wa,p-q|0,1);n=k[C>>2]|0;LY(wa,t,1);j=k[C>>2]|0;LY(wa,t,1);o=k[C>>2]|0;m=k[n>>2]|0;g=k[j>>2]|0;h:do if(ba){b=0;while(1){d=(k[m+(b<<2)>>2]|0)-(k[g+(b<<2)>>2]|0)|0;b=b+1|0;if(d|0)break;if((b|0)>=(Ga|0)){d=0;break}}d=(d|0)<0;e=k[o>>2]|0;i:do if(ba){b=0;while(1){f=(k[g+(b<<2)>>2]|0)-(k[e+(b<<2)>>2]|0)|0;b=b+1|0;if(f|0){b=f;break i}if((b|0)>=(Ga|0)){b=0;break}}}else b=0;while(0);if(!d){if((b|0)>0)break;if(ba)b=0;else{d=0;ta=96;break}while(1){d=(k[m+(b<<2)>>2]|0)-(k[e+(b<<2)>>2]|0)|0;b=b+1|0;if(d|0){ta=96;break h}if((b|0)>=(Ga|0)){d=0;ta=96;break h}}}if((b|0)>=0){j:do if(ba){b=0;while(1){d=(k[m+(b<<2)>>2]|0)-(k[e+(b<<2)>>2]|0)|0;b=b+1|0;if(d|0)break j;if((b|0)>=(Ga|0)){d=0;break}}}else d=0;while(0);j=(d|0)<0?o:n}}else{d=0;ta=96}while(0);if((ta|0)==96){ta=0;j=(d|0)<0?n:o}LY(wa,s+-1-p-q|0,1);p=k[C>>2]|0;LY(wa,t,1);m=k[C>>2]|0;LY(wa,t,1);o=k[C>>2]|0;n=k[p>>2]|0;g=k[m>>2]|0;k:do if(ba){b=0;while(1){d=(k[n+(b<<2)>>2]|0)-(k[g+(b<<2)>>2]|0)|0;b=b+1|0;if(d|0)break;if((b|0)>=(Ga|0)){d=0;break}}d=(d|0)<0;e=k[o>>2]|0;l:do if(ba){b=0;while(1){f=(k[g+(b<<2)>>2]|0)-(k[e+(b<<2)>>2]|0)|0;b=b+1|0;if(f|0){b=f;break l}if((b|0)>=(Ga|0)){b=0;break}}}else b=0;while(0);if(!d){if((b|0)>0)break d;if(ba)b=0;else{d=0;break}while(1){d=(k[n+(b<<2)>>2]|0)-(k[e+(b<<2)>>2]|0)|0;b=b+1|0;if(d|0)break k;if((b|0)>=(Ga|0)){d=0;break k}}}if((b|0)<0)break d;m:do if(ba){b=0;while(1){d=(k[n+(b<<2)>>2]|0)-(k[e+(b<<2)>>2]|0)|0;b=b+1|0;if(d|0)break m;if((b|0)>=(Ga|0)){d=0;break}}}else d=0;while(0);m=(d|0)<0?o:p;break d}else d=0;while(0);m=(d|0)<0?p:o}else{h=k[C>>2]|0;m=(s|0)/2|0;LY(wa,m,1);j=k[C>>2]|0;LY(wa,s+-1-m|0,1);m=k[C>>2]|0}while(0);n=k[h>>2]|0;g=k[j>>2]|0;n:do if(ba){b=0;while(1){d=(k[n+(b<<2)>>2]|0)-(k[g+(b<<2)>>2]|0)|0;b=b+1|0;if(d|0)break;if((b|0)>=(Ga|0)){d=0;break}}d=(d|0)<0;e=k[m>>2]|0;o:do if(ba){b=0;while(1){f=(k[g+(b<<2)>>2]|0)-(k[e+(b<<2)>>2]|0)|0;b=b+1|0;if(f|0){b=f;break o}if((b|0)>=(Ga|0)){b=0;break}}}else b=0;while(0);if(!d){if((b|0)>0){e=j;break}if(ba)b=0;else{d=0;ta=133;break}while(1){d=(k[n+(b<<2)>>2]|0)-(k[e+(b<<2)>>2]|0)|0;b=b+1|0;if(d|0){ta=133;break n}if((b|0)>=(Ga|0)){d=0;ta=133;break n}}}if((b|0)<0)e=j;else{p:do if(ba){b=0;while(1){d=(k[n+(b<<2)>>2]|0)-(k[e+(b<<2)>>2]|0)|0;b=b+1|0;if(d|0)break p;if((b|0)>=(Ga|0)){d=0;break}}}else d=0;while(0);e=(d|0)<0?m:h}}else{d=0;ta=133}while(0);if((ta|0)==133){ta=0;e=(d|0)<0?h:m};k[Ea>>2]=k[Aa>>2];k[Ea+4>>2]=k[Aa+4>>2];k[Ea+8>>2]=k[Aa+8>>2];k[Ea+12>>2]=k[Aa+12>>2];k[Ea+16>>2]=k[Aa+16>>2];k[Ea+20>>2]=k[Aa+20>>2];k[Ea+24>>2]=k[Aa+24>>2];k[Ea+28>>2]=k[Aa+28>>2];d=k[la>>2]|0;if((e|0)==(d|0)|y)m=d;else{b=0;do{v=e+b|0;w=i[v>>0]|0;i[v>>0]=i[d+b>>0]|0;i[(k[la>>2]|0)+b>>0]=w;b=b+1|0;d=k[la>>2]|0}while((b|0)!=(qa|0));m=d}d=m+qa|0;k[la>>2]=d;e=k[oa>>2]|0;if(d>>>0<e>>>0)b=d;else{e=k[(k[pa>>2]|0)+4>>2]|0;k[pa>>2]=e;b=k[e+16>>2]|0;k[ma>>2]=b;e=k[e+12>>2]|0;w=k[(k[sa>>2]|0)+28>>2]|0;k[na>>2]=b;e=b+(aa(w,e)|0)|0;k[oa>>2]=e};k[Ba>>2]=k[Ea>>2];k[Ba+4>>2]=k[Ea+4>>2];k[Ba+8>>2]=k[Ea+8>>2];k[Ba+12>>2]=k[Ea+12>>2];k[Ba+16>>2]=k[Ea+16>>2];k[Ba+20>>2]=k[Ea+20>>2];k[Ba+24>>2]=k[Ea+24>>2];k[Ba+28>>2]=k[Ea+28>>2];d=0;f=k[ha>>2]|0;while(1){q:do if((b|0)!=(f|0)){if(!D)while(1){g=k[b>>2]|0;h=k[m>>2]|0;r:do if(ba){f=0;while(1){j=(k[g+(f<<2)>>2]|0)-(k[h+(f<<2)>>2]|0)|0;f=f+1|0;if(j|0)break;if((f|0)>=(Ga|0)){ta=171;break r}}if((j|0)>=1)break q}else ta=171;while(0);do if((ta|0)==171){ta=0;w=(k[J>>2]|0)+qa|0;k[J>>2]=w;if(w>>>0<(k[K>>2]|0)>>>0){d=1;break}d=k[(k[L>>2]|0)+4>>2]|0;k[L>>2]=d;v=k[d+16>>2]|0;k[J>>2]=v;d=k[d+12>>2]|0;w=k[(k[z>>2]|0)+28>>2]|0;k[M>>2]=v;d=v+(aa(w,d)|0)|0;k[K>>2]=d;d=1}while(0);b=b+qa|0;k[la>>2]=b;if(b>>>0>=e>>>0){e=k[(k[pa>>2]|0)+4>>2]|0;k[pa>>2]=e;b=k[e+16>>2]|0;k[ma>>2]=b;e=k[e+12>>2]|0;w=k[(k[sa>>2]|0)+28>>2]|0;k[na>>2]=b;e=b+(aa(w,e)|0)|0;k[oa>>2]=e}if((b|0)==(k[ha>>2]|0))break q}do{f=k[b>>2]|0;g=k[m>>2]|0;s:do if(ba){e=0;while(1){h=(k[f+(e<<2)>>2]|0)-(k[g+(e<<2)>>2]|0)|0;e=e+1|0;if(h|0)break;if((e|0)>=(Ga|0)){ta=145;break s}}if((h|0)>=1)break q}else ta=145;while(0);do if((ta|0)==145){ta=0;d=k[J>>2]|0;do if((d|0)==(b|0))d=b;else{w=i[d>>0]|0;i[d>>0]=i[b>>0]|0;i[k[la>>2]>>0]=w;d=k[J>>2]|0;if(ca)break;else b=1;do{w=d+b|0;d=i[w>>0]|0;i[w>>0]=i[(k[la>>2]|0)+b>>0]|0;i[(k[la>>2]|0)+b>>0]=d;b=b+1|0;d=k[J>>2]|0}while((b|0)!=(qa|0))}while(0);w=d+qa|0;k[J>>2]=w;if(w>>>0<(k[K>>2]|0)>>>0){d=1;break}d=k[(k[L>>2]|0)+4>>2]|0;k[L>>2]=d;v=k[d+16>>2]|0;k[J>>2]=v;d=k[d+12>>2]|0;w=k[(k[z>>2]|0)+28>>2]|0;k[M>>2]=v;d=v+(aa(w,d)|0)|0;k[K>>2]=d;d=1}while(0);b=(k[la>>2]|0)+qa|0;k[la>>2]=b;if(b>>>0>=(k[oa>>2]|0)>>>0){w=k[(k[pa>>2]|0)+4>>2]|0;k[pa>>2]=w;b=k[w+16>>2]|0;k[ma>>2]=b;w=k[w+12>>2]|0;v=k[(k[sa>>2]|0)+28>>2]|0;k[na>>2]=b;w=b+(aa(v,w)|0)|0;k[oa>>2]=w}}while((b|0)!=(k[ha>>2]|0))}while(0);e=k[ha>>2]|0;t:do if((b|0)!=(e|0)){if(!D)while(1){f=k[e>>2]|0;g=k[m>>2]|0;u:do if(ba){e=0;while(1){h=(k[f+(e<<2)>>2]|0)-(k[g+(e<<2)>>2]|0)|0;e=e+1|0;if(h|0)break;if((e|0)>=(Ga|0)){ta=180;break u}}if((h|0)<=-1)break t}else ta=180;while(0);do if((ta|0)==180){ta=0;w=(k[E>>2]|0)+ia|0;k[E>>2]=w;if(w>>>0>=(k[F>>2]|0)>>>0){d=1;break}d=k[k[G>>2]>>2]|0;k[G>>2]=d;v=k[d+16>>2]|0;d=k[d+12>>2]|0;w=k[(k[H>>2]|0)+28>>2]|0;t=v+(aa(w,d+-1|0)|0)|0;k[E>>2]=t;k[F>>2]=v;d=v+(aa(w,d)|0)|0;k[I>>2]=d;d=1}while(0);e=(k[ha>>2]|0)+ia|0;k[ha>>2]=e;if(e>>>0<(k[ja>>2]|0)>>>0){w=k[k[ka>>2]>>2]|0;k[ka>>2]=w;t=k[w+16>>2]|0;w=k[w+12>>2]|0;v=k[(k[ga>>2]|0)+28>>2]|0;e=t+(aa(v,w+-1|0)|0)|0;k[ha>>2]=e;k[ja>>2]=t;w=t+(aa(v,w)|0)|0;k[ea>>2]=w}if((b|0)==(e|0))break t}while(1){f=k[e>>2]|0;g=k[m>>2]|0;v:do if(ba){e=0;while(1){h=(k[f+(e<<2)>>2]|0)-(k[g+(e<<2)>>2]|0)|0;e=e+1|0;if(h|0)break;if((e|0)>=(Ga|0)){ta=159;break v}}if((h|0)<=-1)break t}else ta=159;while(0);do if((ta|0)==159){ta=0;d=k[E>>2]|0;b=k[ha>>2]|0;do if((d|0)!=(b|0)){w=i[d>>0]|0;i[d>>0]=i[b>>0]|0;i[k[ha>>2]>>0]=w;d=k[E>>2]|0;if(ca)break;else b=1;do{w=d+b|0;d=i[w>>0]|0;i[w>>0]=i[(k[ha>>2]|0)+b>>0]|0;i[(k[ha>>2]|0)+b>>0]=d;b=b+1|0;d=k[E>>2]|0}while((b|0)!=(qa|0))}while(0);w=d+ia|0;k[E>>2]=w;if(w>>>0>=(k[F>>2]|0)>>>0){d=1;break}d=k[k[G>>2]>>2]|0;k[G>>2]=d;v=k[d+16>>2]|0;d=k[d+12>>2]|0;w=k[(k[H>>2]|0)+28>>2]|0;t=v+(aa(w,d+-1|0)|0)|0;k[E>>2]=t;k[F>>2]=v;d=v+(aa(w,d)|0)|0;k[I>>2]=d;d=1}while(0);b=(k[ha>>2]|0)+ia|0;k[ha>>2]=b;if(b>>>0<(k[ja>>2]|0)>>>0){w=k[k[ka>>2]>>2]|0;k[ka>>2]=w;t=k[w+16>>2]|0;w=k[w+12>>2]|0;v=k[(k[ga>>2]|0)+28>>2]|0;e=t+(aa(v,w+-1|0)|0)|0;k[ha>>2]=e;k[ja>>2]=t;w=t+(aa(v,w)|0)|0;k[ea>>2]=w}else e=b;b=k[la>>2]|0;if((b|0)==(e|0)){b=e;break}}}while(0);e=k[ha>>2]|0;if((b|0)==(e|0)){ta=188;break}do if(D){d=i[b>>0]|0;i[b>>0]=i[e>>0]|0;i[k[ha>>2]>>0]=d;d=k[la>>2]|0;if(ca)break;else b=1;do{w=d+b|0;d=i[w>>0]|0;i[w>>0]=i[(k[ha>>2]|0)+b>>0]|0;i[(k[ha>>2]|0)+b>>0]=d;b=b+1|0;d=k[la>>2]|0}while((b|0)!=(qa|0))}else d=b;while(0);b=d+qa|0;k[la>>2]=b;d=k[oa>>2]|0;if(b>>>0<d>>>0)e=d;else{e=k[(k[pa>>2]|0)+4>>2]|0;k[pa>>2]=e;b=k[e+16>>2]|0;k[ma>>2]=b;e=k[e+12>>2]|0;w=k[(k[sa>>2]|0)+28>>2]|0;k[na>>2]=b;e=b+(aa(w,e)|0)|0;k[oa>>2]=e}d=k[ha>>2]|0;f=d+ia|0;k[ha>>2]=f;if(f>>>0<(k[ja>>2]|0)>>>0){w=k[k[ka>>2]>>2]|0;k[ka>>2]=w;t=k[w+16>>2]|0;w=k[w+12>>2]|0;v=k[(k[ga>>2]|0)+28>>2]|0;f=t+(aa(v,w+-1|0)|0)|0;k[ha>>2]=f;k[ja>>2]=t;w=t+(aa(v,w)|0)|0;k[ea>>2]=w}if((b|0)==(d|0)){ta=209;break}else d=1}if((ta|0)==188){ta=0;h=k[b>>2]|0;f=k[m>>2]|0;w:do if(ba){e=0;while(1){g=(k[h+(e<<2)>>2]|0)-(k[f+(e<<2)>>2]|0)|0;e=e+1|0;if(g|0)break;if((e|0)>=(Ga|0)){ta=191;break w}}if((g|0)>=1){w=b+ia|0;k[ha>>2]=w;if(w>>>0<(k[ja>>2]|0)>>>0){w=k[k[ka>>2]>>2]|0;k[ka>>2]=w;t=k[w+16>>2]|0;w=k[w+12>>2]|0;v=k[(k[ga>>2]|0)+28>>2]|0;s=t+(aa(v,w+-1|0)|0)|0;k[ha>>2]=s;k[ja>>2]=t;w=t+(aa(v,w)|0)|0;k[ea>>2]=w}}else ta=197}else ta=191;while(0);if((ta|0)==191){d=k[J>>2]|0;if(!((d|0)==(b|0)|x)){ta=i[d>>0]|0;i[d>>0]=i[b>>0]|0;i[k[la>>2]>>0]=ta;d=k[J>>2]|0;if(!ca){b=1;do{ta=d+b|0;d=i[ta>>0]|0;i[ta>>0]=i[(k[la>>2]|0)+b>>0]|0;i[(k[la>>2]|0)+b>>0]=d;b=b+1|0;d=k[J>>2]|0}while((b|0)!=(qa|0))}}ta=d+qa|0;k[J>>2]=ta;if(ta>>>0<(k[K>>2]|0)>>>0){d=1;ta=197}else{d=k[(k[L>>2]|0)+4>>2]|0;k[L>>2]=d;w=k[d+16>>2]|0;k[J>>2]=w;d=k[d+12>>2]|0;ta=k[(k[z>>2]|0)+28>>2]|0;k[M>>2]=w;d=w+(aa(ta,d)|0)|0;k[K>>2]=d;d=1;ta=197}}if((ta|0)==197){ta=0;w=(k[la>>2]|0)+qa|0;k[la>>2]=w;if(w>>>0>=(k[oa>>2]|0)>>>0){w=k[(k[pa>>2]|0)+4>>2]|0;k[pa>>2]=w;t=k[w+16>>2]|0;k[ma>>2]=t;w=k[w+12>>2]|0;v=k[(k[sa>>2]|0)+28>>2]|0;k[na>>2]=t;w=t+(aa(v,w)|0)|0;k[oa>>2]=w}}if(!d){k[Ea>>2]=k[Aa>>2];k[Ea+4>>2]=k[Aa+4>>2];k[Ea+8>>2]=k[Aa+8>>2];k[Ea+12>>2]=k[Aa+12>>2];k[Ea+16>>2]=k[Aa+16>>2];k[Ea+20>>2]=k[Aa+20>>2];k[Ea+24>>2]=k[Aa+24>>2];k[Ea+28>>2]=k[Aa+28>>2];k[ya>>2]=k[Ca>>2];k[ya+4>>2]=k[Ca+4>>2];k[ya+8>>2]=k[Ca+8>>2];k[ya+12>>2]=k[Ca+12>>2];k[ya+16>>2]=k[Ca+16>>2];k[ya+20>>2]=k[Ca+20>>2];k[ya+24>>2]=k[Ca+24>>2];k[ya+28>>2]=k[Ca+28>>2];b=6;d=u}else ta=209}do if((ta|0)==209){ta=0;d=RY(Ea)|0;if(!d)d=k[ua>>2]|0;e=RY(Aa)|0;b=RY(Ba)|0;if(!b)b=k[ua>>2]|0;m=d-b|0;h=b-e|0;h=(m|0)>(h|0)?h:m;x:do if((h|0)>0){k[wa>>2]=k[Aa>>2];k[wa+4>>2]=k[Aa+4>>2];k[wa+8>>2]=k[Aa+8>>2];k[wa+12>>2]=k[Aa+12>>2];k[wa+16>>2]=k[Aa+16>>2];k[wa+20>>2]=k[Aa+20>>2];k[wa+24>>2]=k[Aa+24>>2];k[wa+28>>2]=k[Aa+28>>2];k[xa>>2]=k[Ea>>2];k[xa+4>>2]=k[Ea+4>>2];k[xa+8>>2]=k[Ea+8>>2];k[xa+12>>2]=k[Ea+12>>2];k[xa+16>>2]=k[Ea+16>>2];k[xa+20>>2]=k[Ea+20>>2];k[xa+24>>2]=k[Ea+24>>2];k[xa+28>>2]=k[Ea+28>>2];LY(xa,0-h|0,1);d=k[C>>2]|0;if(D)e=0;else{g=(k[B>>2]|0)+28|0;f=(k[A>>2]|0)+28|0;e=0;b=k[N>>2]|0;while(1){d=d+qa|0;k[C>>2]=d;if(d>>>0>=b>>>0){b=k[(k[S>>2]|0)+4>>2]|0;k[S>>2]=b;d=k[b+16>>2]|0;k[C>>2]=d;b=k[b+12>>2]|0;w=k[f>>2]|0;k[T>>2]=d;b=d+(aa(w,b)|0)|0;k[N>>2]=b}w=(k[O>>2]|0)+qa|0;k[O>>2]=w;if(w>>>0>=(k[P>>2]|0)>>>0){w=k[(k[Q>>2]|0)+4>>2]|0;k[Q>>2]=w;t=k[w+16>>2]|0;k[O>>2]=t;w=k[w+12>>2]|0;v=k[g>>2]|0;k[R>>2]=t;w=t+(aa(v,w)|0)|0;k[P>>2]=w}e=e+1|0;if((e|0)>=(h|0))break x}}do{b=0;do{v=d+b|0;w=i[v>>0]|0;i[v>>0]=i[(k[O>>2]|0)+b>>0]|0;i[(k[O>>2]|0)+b>>0]=w;b=b+1|0;d=k[C>>2]|0}while((b|0)!=(qa|0));d=d+qa|0;k[C>>2]=d;if(d>>>0>=(k[N>>2]|0)>>>0){w=k[(k[S>>2]|0)+4>>2]|0;k[S>>2]=w;d=k[w+16>>2]|0;k[C>>2]=d;w=k[w+12>>2]|0;v=k[(k[A>>2]|0)+28>>2]|0;k[T>>2]=d;w=d+(aa(v,w)|0)|0;k[N>>2]=w}w=(k[O>>2]|0)+qa|0;k[O>>2]=w;if(w>>>0>=(k[P>>2]|0)>>>0){w=k[(k[Q>>2]|0)+4>>2]|0;k[Q>>2]=w;t=k[w+16>>2]|0;k[O>>2]=t;w=k[w+12>>2]|0;v=k[(k[B>>2]|0)+28>>2]|0;k[R>>2]=t;w=t+(aa(v,w)|0)|0;k[P>>2]=w}e=e+1|0}while((e|0)<(h|0))}while(0);j=RY(ya)|0;h=RY(Ca)|0;w=RY(Da)|0;h=h-w|0;j=w-j|0;h=(h|0)>(j|0)?j:h;y:do if((h|0)>0){k[wa>>2]=k[Ea>>2];k[wa+4>>2]=k[Ea+4>>2];k[wa+8>>2]=k[Ea+8>>2];k[wa+12>>2]=k[Ea+12>>2];k[wa+16>>2]=k[Ea+16>>2];k[wa+20>>2]=k[Ea+20>>2];k[wa+24>>2]=k[Ea+24>>2];k[wa+28>>2]=k[Ea+28>>2];k[xa>>2]=k[Ca>>2];k[xa+4>>2]=k[Ca+4>>2];k[xa+8>>2]=k[Ca+8>>2];k[xa+12>>2]=k[Ca+12>>2];k[xa+16>>2]=k[Ca+16>>2];k[xa+20>>2]=k[Ca+20>>2];k[xa+24>>2]=k[Ca+24>>2];k[xa+28>>2]=k[Ca+28>>2];LY(xa,1-h|0,1);d=k[C>>2]|0;if(D)e=0;else{g=(k[B>>2]|0)+28|0;f=(k[A>>2]|0)+28|0;e=0;b=k[N>>2]|0;while(1){d=d+qa|0;k[C>>2]=d;if(d>>>0>=b>>>0){b=k[(k[S>>2]|0)+4>>2]|0;k[S>>2]=b;d=k[b+16>>2]|0;k[C>>2]=d;b=k[b+12>>2]|0;w=k[f>>2]|0;k[T>>2]=d;b=d+(aa(w,b)|0)|0;k[N>>2]=b}w=(k[O>>2]|0)+qa|0;k[O>>2]=w;if(w>>>0>=(k[P>>2]|0)>>>0){w=k[(k[Q>>2]|0)+4>>2]|0;k[Q>>2]=w;t=k[w+16>>2]|0;k[O>>2]=t;w=k[w+12>>2]|0;v=k[g>>2]|0;k[R>>2]=t;w=t+(aa(v,w)|0)|0;k[P>>2]=w}e=e+1|0;if((e|0)>=(h|0))break y}}do{b=0;do{v=d+b|0;w=i[v>>0]|0;i[v>>0]=i[(k[O>>2]|0)+b>>0]|0;i[(k[O>>2]|0)+b>>0]=w;b=b+1|0;d=k[C>>2]|0}while((b|0)!=(qa|0));d=d+qa|0;k[C>>2]=d;if(d>>>0>=(k[N>>2]|0)>>>0){w=k[(k[S>>2]|0)+4>>2]|0;k[S>>2]=w;d=k[w+16>>2]|0;k[C>>2]=d;w=k[w+12>>2]|0;v=k[(k[A>>2]|0)+28>>2]|0;k[T>>2]=d;w=d+(aa(v,w)|0)|0;k[N>>2]=w}w=(k[O>>2]|0)+qa|0;k[O>>2]=w;if(w>>>0>=(k[P>>2]|0)>>>0){w=k[(k[Q>>2]|0)+4>>2]|0;k[Q>>2]=w;t=k[w+16>>2]|0;k[O>>2]=t;w=k[w+12>>2]|0;v=k[(k[B>>2]|0)+28>>2]|0;k[R>>2]=t;w=t+(aa(v,w)|0)|0;k[P>>2]=w}e=e+1|0}while((e|0)<(h|0))}while(0);d=(j|0)>1;if((m|0)<=1){if(!d){b=4;d=u;break}k[ya>>2]=k[Ca>>2];k[ya+4>>2]=k[Ca+4>>2];k[ya+8>>2]=k[Ca+8>>2];k[ya+12>>2]=k[Ca+12>>2];k[ya+16>>2]=k[Ca+16>>2];k[ya+20>>2]=k[Ca+20>>2];k[ya+24>>2]=k[Ca+24>>2];k[ya+28>>2]=k[Ca+28>>2];k[Ea>>2]=k[Ca>>2];k[Ea+4>>2]=k[Ca+4>>2];k[Ea+8>>2]=k[Ca+8>>2];k[Ea+12>>2]=k[Ca+12>>2];k[Ea+16>>2]=k[Ca+16>>2];k[Ea+20>>2]=k[Ca+20>>2];k[Ea+24>>2]=k[Ca+24>>2];k[Ea+28>>2]=k[Ca+28>>2];LY(Ea,1-j|0,1);b=0;d=u;break}if(!d){k[ya>>2]=k[Aa>>2];k[ya+4>>2]=k[Aa+4>>2];k[ya+8>>2]=k[Aa+8>>2];k[ya+12>>2]=k[Aa+12>>2];k[ya+16>>2]=k[Aa+16>>2];k[ya+20>>2]=k[Aa+20>>2];k[ya+24>>2]=k[Aa+24>>2];k[ya+28>>2]=k[Aa+28>>2];k[Ea>>2]=k[Aa>>2];k[Ea+4>>2]=k[Aa+4>>2];k[Ea+8>>2]=k[Aa+8>>2];k[Ea+12>>2]=k[Aa+12>>2];k[Ea+16>>2]=k[Aa+16>>2];k[Ea+20>>2]=k[Aa+20>>2];k[Ea+24>>2]=k[Aa+24>>2];k[Ea+28>>2]=k[Aa+28>>2];LY(ya,m+-1|0,1);b=0;d=u;break}d=u+1|0;if((m|0)>(j|0)){k[za+(d<<5)>>2]=k[U>>2];k[za+(d<<5)+4>>2]=k[V>>2];k[za+(d<<5)+8>>2]=k[W>>2];k[za+(d<<5)+12>>2]=k[X>>2];LY(Aa,m+-1|0,1);k[za+(d<<5)+16>>2]=k[U>>2];k[za+(d<<5)+20>>2]=k[V>>2];k[za+(d<<5)+24>>2]=k[W>>2];k[za+(d<<5)+28>>2]=k[X>>2];k[ya>>2]=k[Ca>>2];k[ya+4>>2]=k[Ca+4>>2];k[ya+8>>2]=k[Ca+8>>2];k[ya+12>>2]=k[Ca+12>>2];k[ya+16>>2]=k[Ca+16>>2];k[ya+20>>2]=k[Ca+20>>2];k[ya+24>>2]=k[Ca+24>>2];k[ya+28>>2]=k[Ca+28>>2];k[Ea>>2]=k[Ca>>2];k[Ea+4>>2]=k[Ca+4>>2];k[Ea+8>>2]=k[Ca+8>>2];k[Ea+12>>2]=k[Ca+12>>2];k[Ea+16>>2]=k[Ca+16>>2];k[Ea+20>>2]=k[Ca+20>>2];k[Ea+24>>2]=k[Ca+24>>2];k[Ea+28>>2]=k[Ca+28>>2];LY(Ea,1-j|0,1);b=0;break}else{k[za+(d<<5)+16>>2]=k[Y>>2];k[za+(d<<5)+20>>2]=k[Z>>2];k[za+(d<<5)+24>>2]=k[_>>2];k[za+(d<<5)+28>>2]=k[$>>2];LY(Ca,1-j|0,1);k[za+(d<<5)>>2]=k[Y>>2];k[za+(d<<5)+4>>2]=k[Z>>2];k[za+(d<<5)+8>>2]=k[_>>2];k[za+(d<<5)+12>>2]=k[$>>2];k[ya>>2]=k[Aa>>2];k[ya+4>>2]=k[Aa+4>>2];k[ya+8>>2]=k[Aa+8>>2];k[ya+12>>2]=k[Aa+12>>2];k[ya+16>>2]=k[Aa+16>>2];k[ya+20>>2]=k[Aa+20>>2];k[ya+24>>2]=k[Aa+24>>2];k[ya+28>>2]=k[Aa+28>>2];k[Ea>>2]=k[Aa>>2];k[Ea+4>>2]=k[Aa+4>>2];k[Ea+8>>2]=k[Aa+8>>2];k[Ea+12>>2]=k[Aa+12>>2];k[Ea+16>>2]=k[Aa+16>>2];k[Ea+20>>2]=k[Aa+20>>2];k[Ea+24>>2]=k[Aa+24>>2];k[Ea+28>>2]=k[Aa+28>>2];LY(ya,m+-1|0,1);b=0;break}}while(0);switch(b&7){case 6:{ta=31;break c}case 0:break;default:if(b|0){e=d;break c}}u=d;b=k[pa>>2]|0;d=k[ka>>2]|0}z:do if((ta|0)==31){ta=0;g=k[sa>>2]|0;n=k[pa>>2]|0;h=k[la>>2]|0;e=k[na>>2]|0;f=k[oa>>2]|0;b=h+qa|0;if(b>>>0<f>>>0){j=e;m=n}else{m=k[n+4>>2]|0;f=k[m+16>>2]|0;b=f;j=f;f=f+(aa(k[g+28>>2]|0,k[m+12>>2]|0)|0)|0}w=(k[ha>>2]|0)+qa|0;k[ha>>2]=w;if(w>>>0>=(k[ea>>2]|0)>>>0){w=k[(k[ka>>2]|0)+4>>2]|0;k[ka>>2]=w;u=k[w+16>>2]|0;k[ha>>2]=u;w=k[w+12>>2]|0;v=k[(k[ga>>2]|0)+28>>2]|0;k[ja>>2]=u;w=u+(aa(v,w)|0)|0;k[ea>>2]=w}w=g+28|0;g=n;v=m;while(1){if(D)do{if((b|0)==(k[ha>>2]|0)){e=d;break z}e=(g|0)==(v|0)?e:j;A:do if((b|0)==(h|0))g=v;else{g=v;u=b;t=h;while(1){h=u+ia|0;if(h>>>0<e>>>0){h=k[g>>2]|0;s=k[h+16>>2]|0;e=s;g=h;h=s+(aa(k[w>>2]|0,(k[h+12>>2]|0)+-1|0)|0)|0}p=k[h>>2]|0;q=k[u>>2]|0;m=p&255;n=q&255;if(ba)o=0;else{h=t;break A}while(1){s=(k[p+(o<<2)>>2]|0)-(k[q+(o<<2)>>2]|0)|0;o=o+1|0;if(s|0)break;if((o|0)>=(Ga|0)){h=t;break A}}if((s|0)<1){h=t;break A}else o=0;while(1){i[h+o>>0]=n;i[u+o>>0]=m;m=o+1|0;if((m|0)==(qa|0))break;o=m;n=i[u+m>>0]|0;m=i[h+m>>0]|0}t=k[la>>2]|0;if((h|0)==(t|0))break;else u=h}}while(0);b=b+qa|0}while(b>>>0<f>>>0);else{s=k[ha>>2]|0;do{if((b|0)==(s|0)){e=d;break z}e=(g|0)==(v|0)?e:j;B:do if((b|0)==(h|0))g=v;else{g=v;n=b;while(1){m=n+ia|0;if(m>>>0<e>>>0){m=k[g>>2]|0;u=k[m+16>>2]|0;e=u;g=m;m=u+(aa(k[w>>2]|0,(k[m+12>>2]|0)+-1|0)|0)|0}q=k[m>>2]|0;o=k[n>>2]|0;if(ba)n=0;else break B;while(1){p=(k[q+(n<<2)>>2]|0)-(k[o+(n<<2)>>2]|0)|0;n=n+1|0;if(p|0)break;if((n|0)>=(Ga|0))break B}if((p|0)<1|(m|0)==(h|0))break;else n=m}}while(0);b=b+qa|0}while(b>>>0<f>>>0)}u=k[v+4>>2]|0;f=k[u+16>>2]|0;b=f;j=f;f=f+(aa(k[w>>2]|0,k[u+12>>2]|0)|0)|0;v=u}}while(0);if((e|0)<=-1)break b;m=e;n=k[za+(e<<5)+4>>2]|0;j=k[za+(e<<5)+8>>2]|0;g=k[za+(e<<5)+12>>2]|0;f=k[za+(e<<5)+16>>2]|0;b=k[za+(e<<5)+20>>2]|0;d=k[za+(e<<5)+24>>2]|0;e=k[za+(e<<5)+28>>2]|0}}while(0);KY(va,Fa);if((k[ua>>2]|0)<=0){_4(a);_4(a);BY(Ha);r=Ja;return}q=Fa+12|0;s=Fa+20|0;t=c+32|0;m=c+28|0;n=a+236|0;o=Ga+-1|0;p=Fa+8|0;j=Fa+4|0;h=Fa+16|0;f=0;g=0;do{Fa=k[q>>2]|0;b=g;g=l[Fa>>0]|l[Fa+1>>0]<<8|l[Fa+2>>0]<<16|l[Fa+3>>0]<<24;Fa=Fa+4|0;k[q>>2]=Fa;if(Fa>>>0>=(k[s>>2]|0)>>>0){Fa=k[(k[p>>2]|0)+4>>2]|0;k[p>>2]=Fa;Ea=k[Fa+16>>2]|0;k[q>>2]=Ea;c=k[(k[j>>2]|0)+28>>2]|0;Fa=k[Fa+12>>2]|0;k[h>>2]=Ea;Fa=Ea+(aa(c,Fa)|0)|0;k[s>>2]=Fa}if((f|0)>0){d=0;while(1){e=d+1|0;if((k[g+(d<<2)>>2]|0)==(k[b+(d<<2)>>2]|0))d=e;else break}if((d|0)<(o|0))Ph[k[n>>2]&511](a,0,e-Ga|0)}else d=0;if((d|0)<(Ga|0))do{Ph[k[n>>2]&511](a,0,k[g+(d<<2)>>2]|0);d=d+1|0}while((d|0)!=(Ga|0));h6(a,g+(0-(k[t>>2]|0))+(k[m>>2]|0)|0,1,Ia);f=f+1|0}while((f|0)<(k[ua>>2]|0));_4(a);_4(a);BY(Ha);r=Ja;return}function Y5(a){a=a|0;if(!a)a=0;else a=(k[a>>2]|0)==112;return a&1|0}function Z5(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+48|0;G=I+32|0;H=I;d=k6(a,b,380241)|0;a:do if(!d)F=0;else{switch(k[d>>2]&7){case 1:{F=k[d+8>>2]|0;break a}case 2:break;default:{F=2147483647;break a}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;F=d&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}F=~~c}while(0);d=k6(a,b,380234)|0;b:do if(!d)C=0;else{switch(k[d>>2]&7){case 1:{C=k[d+8>>2]|0;break b}case 2:break;default:{C=2147483647;break b}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;E=d&2146435072;if(!(E>>>0>1126170624|(E|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}C=~~c}while(0);d=k6(a,b,225918)|0;if((d|0)!=0?(k[d>>2]&7|0)==3:0)E=k[d+8+4>>2]|0;else E=0;d=k6(a,b,226942)|0;if((d|0)!=0?(k[d>>2]&7|0)==3:0)d=k[d+8+4>>2]|0;else d=0;if((F|0)==0|(C|0)==0|(E|0)==0|(d|0)==0){d=G+4|0;e=ZT(52)|0;k[e>>2]=1;g=e+4|0;k[G>>2]=g;k[d>>2]=45;i[e+49>>0]=0;h=226987;j=g+45|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-2,G,227033,221854,3933);k[d>>2]=0;k[G>>2]=0;B=k[e>>2]|0;k[e>>2]=B+-1;if((B|0)==1)ggb(k[e+-4>>2]|0)}B=m6(E)|0;d=k6(a,b,226968)|0;if(d)if((k[d>>2]&7|0)==3)d=k[d+8+4>>2]|0;else d=0;else d=226956;if((i[d>>0]|0)==105){g=226956;do{d=d+1|0;g=g+1|0;e=i[d>>0]|0;f=i[g>>0]|0}while(!(e<<24>>24==0?1:e<<24>>24!=f<<24>>24));if(e<<24>>24!=f<<24>>24)D=31}else D=31;if((D|0)==31){d=G+4|0;e=ZT(40)|0;k[e>>2]=1;g=e+4|0;k[G>>2]=g;k[d>>2]=35;i[e+39>>0]=0;h=227046;j=g+35|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-2,G,227033,221854,3938);k[d>>2]=0;k[G>>2]=0;z=k[e>>2]|0;k[e>>2]=z+-1;if((z|0)==1)ggb(k[e+-4>>2]|0)}z=k6(a,b,225921)|0;if(!z){d=G+4|0;e=ZT(48)|0;k[e>>2]=1;g=e+4|0;k[G>>2]=g;k[d>>2]=43;i[e+47>>0]=0;h=227082;j=g+43|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-2,G,227033,221854,3942);k[d>>2]=0;k[G>>2]=0;y=k[e>>2]|0;k[e>>2]=y+-1;if((y|0)==1)ggb(k[e+-4>>2]|0)}d=k[z>>2]&7;if(d>>>0>4)d=k[(k[z+8>>2]|0)+24>>2]|0;else d=(d|0)!=0&1;w=aa(C,F)|0;f=B>>>3&511;x=f+1|0;if((d|0)!=(aa(x,w)|0)){d=G+4|0;e=ZT(68)|0;k[e>>2]=1;g=e+4|0;k[G>>2]=g;k[d>>2]=63;i[e+67>>0]=0;h=226257;j=g+63|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-209,G,227033,221854,3946);k[d>>2]=0;k[G>>2]=0;y=k[e>>2]|0;k[e>>2]=y+-1;if((y|0)==1)ggb(k[e+-4>>2]|0)}m=B&7;l=1212424721>>>(m<<2)<<3&120;m=l|((m|0)==4|(m|2|0)==3?-2147483648:0);y=ZT(112)|0;v=(y|0)==0;if(v){d=G+4|0;e=ZT(28)|0;k[e>>2]=1;g=e+4|0;k[G>>2]=g;k[d>>2]=22;i[e+26>>0]=0;h=235358;j=g+22|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-9,G,235381,233613,2919);k[d>>2]=0;k[G>>2]=0;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)ggb(k[e+-4>>2]|0)}g=y+4|0;j=g+108|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(j|0));k[y>>2]=112;if(f>>>0<4){h=k[51648+(f<<3)+4>>2]|0;d=k[51648+(f<<3)>>2]|0}else{h=1016759;d=1016759}e=y+20|0;f=d;c:do if(!((d^e)&3)){d:do if(d&3){d=4;g=f;do{t=i[g>>0]|0;i[e>>0]=t;if(!(t<<24>>24)){f=g;break d}d=d+-1|0;g=g+1|0;e=e+1|0;f=(d|0)!=0}while(f&(g&3|0)!=0);if(f)f=g;else{d=0;break c}}else d=4;while(0);if(i[f>>0]|0){e:do if(d>>>0>3){g=f;while(1){f=k[g>>2]|0;if((f&-2139062144^-2139062144)&f+-16843009|0)break;k[e>>2]=f;d=d+-4|0;f=g+4|0;e=e+4|0;if(d>>>0>3)g=f;else break e}f=g;D=62;break c}while(0);if(!d)d=0;else D=62}}else{d=4;D=62}while(0);f:do if((D|0)==62)while(1){D=0;t=i[f>>0]|0;i[e>>0]=t;if(!(t<<24>>24))break f;d=d+-1|0;e=e+1|0;if(!d){d=0;break}else{f=f+1|0;D=62}}while(0);zpb(e|0,0,d|0)|0;e=y+24|0;f=h;g:do if(!((h^e)&3)){h:do if(h&3){d=4;g=f;do{t=i[g>>0]|0;i[e>>0]=t;if(!(t<<24>>24)){f=g;break h}d=d+-1|0;g=g+1|0;e=e+1|0;f=(d|0)!=0}while(f&(g&3|0)!=0);if(f)f=g;else{d=0;break g}}else d=4;while(0);if(i[f>>0]|0){i:do if(d>>>0>3){g=f;while(1){f=k[g>>2]|0;if((f&-2139062144^-2139062144)&f+-16843009|0)break;k[e>>2]=f;d=d+-4|0;f=g+4|0;e=e+4|0;if(d>>>0>3)g=f;else break i}f=g;D=75;break g}while(0);if(!d)d=0;else D=75}}else{d=4;D=75}while(0);j:do if((D|0)==75)while(1){D=0;t=i[f>>0]|0;i[e>>0]=t;if(!(t<<24>>24))break j;d=d+-1|0;e=e+1|0;if(!d){d=0;break}else{f=f+1|0;D=75}}while(0);zpb(e|0,0,d|0)|0;if((F|C|0)<0){d=G+4|0;e=ZT(20)|0;k[e>>2]=1;g=e+4|0;k[G>>2]=g;k[d>>2]=13;i[e+17>>0]=0;h=235399;j=g+13|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-25,G,235381,233613,2929);k[d>>2]=0;k[G>>2]=0;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)ggb(k[e+-4>>2]|0)}if((m|0)<8)switch(m|0){case -2147483640:case -2147483632:case -2147483616:break;default:D=82}else switch(m|0){case 8:case 16:case 32:case 64:break;default:D=82}if((D|0)==82){d=G+4|0;e=ZT(24)|0;k[e>>2]=1;g=e+4|0;k[G>>2]=g;k[d>>2]=18;i[e+22>>0]=0;h=235413;j=g+18|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-17,G,235381,233613,2936);k[d>>2]=0;k[G>>2]=0;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)ggb(k[e+-4>>2]|0)}o=y+40|0;k[o>>2]=F;q=y+44|0;k[q>>2]=C;s=y+48|0;d=k[s>>2]|0;if(d|0){k[d>>2]=0;k[d+8>>2]=0;k[d+4>>2]=0;k[d+12>>2]=F;k[d+16>>2]=C}n=y+8|0;k[n>>2]=x;k[y+16>>2]=m;k[y+36>>2]=4;e=((aa(aa(x,l)|0,F)|0)>>>3)+3&1073741820;t=y+72|0;k[t>>2]=e;k[y+32>>2]=0;e=aa(e,C)|0;k[y+64>>2]=e;z9(y);e=k6(a,b,226975)|0;do if(e|0){d=k6(a,e,226979)|0;k:do if(!d)b=0;else{switch(k[d>>2]&7){case 1:{b=k[d+8>>2]|0;break k}case 2:break;default:{b=2147483647;break k}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;b=d&2146435072;do if(!(b>>>0>1126170624|(b|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(!(c==0.0))break;c=d?-0.0:0.0}while(0);b=~~c}while(0);d=k6(a,e,226981)|0;l:do if(!d)m=0;else{switch(k[d>>2]&7){case 1:{m=k[d+8>>2]|0;break l}case 2:break;default:{m=2147483647;break l}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;m=d&2146435072;do if(!(m>>>0>1126170624|(m|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(!(c==0.0))break;c=d?-0.0:0.0}while(0);m=~~c}while(0);d=k6(a,e,380241)|0;m:do if(!d)h=0;else{switch(k[d>>2]&7){case 1:{h=k[d+8>>2]|0;break m}case 2:break;default:{h=2147483647;break m}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;l=d&2146435072;do if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(!(c==0.0))break;c=d?-0.0:0.0}while(0);h=~~c}while(0);d=k6(a,e,380234)|0;n:do if(!d)g=0;else{switch(k[d>>2]&7){case 1:{g=k[d+8>>2]|0;break n}case 2:break;default:{g=2147483647;break n}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;l=d&2146435072;do if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(!(c==0.0))break;c=d?-0.0:0.0}while(0);g=~~c}while(0);d=k6(a,e,226983)|0;o:do if(!d)l=0;else{switch(k[d>>2]&7){case 1:{l=k[d+8>>2]|0;break o}case 2:break;default:{l=2147483647;break o}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;l=d&2146435072;do if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(!(c==0.0))break;c=d?-0.0:0.0}while(0);l=~~c}while(0);if(v?(v=G+4|0,A=ZT(8)|0,k[A>>2]=1,j=A+4|0,k[G>>2]=j,k[v>>2]=0,i[j>>0]=0,Y8(-9,G,235465,233613,3011),k[v>>2]=0,k[G>>2]=0,v=k[A>>2]|0,k[A>>2]=v+-1,(v|0)==1):0)ggb(k[A+-4>>2]|0);do if((h|g|0)>-1){f=k[o>>2]|0;if((b|0)>=(f|0)){D=132;break}j=k[q>>2]|0;if((m|0)>=(j|0)){D=132;break}e=b+h|0;if((e|0)<((h|0)>0|0)){D=132;break}d=m+g|0;if((d|0)<((g|0)>0|0))D=132}else D=132;while(0);if((D|0)==132){D=G+4|0;d=ZT(192)|0;k[d>>2]=1;A=d+4|0;k[G>>2]=A;k[D>>2]=184;i[d+188>>0]=0;upb(A|0,235479,184)|0;Y8(-215,G,235465,233613,3017);k[D>>2]=0;k[G>>2]=0;D=k[d>>2]|0;k[d>>2]=D+-1;if((D|0)==1)ggb(k[d+-4>>2]|0);d=g+m|0;e=h+b|0;f=k[o>>2]|0;j=k[q>>2]|0}h=(b|0)<0?0:b;g=(m|0)<0?0:m;f=((f|0)<(e|0)?f:e)-h|0;e=((j|0)<(d|0)?j:d)-g|0;d=k[s>>2]|0;if(!d){d=ZT(20)|0;k[d>>2]=0;k[d+4>>2]=h;k[d+8>>2]=g;k[d+12>>2]=f;k[d+16>>2]=e;k[s>>2]=d}else{k[d+4>>2]=h;k[d+8>>2]=g;k[d+12>>2]=f;k[d+16>>2]=e}if((k[n>>2]|0)>>>0<l>>>0){D=G+4|0;d=ZT(8)|0;k[d>>2]=1;A=d+4|0;k[G>>2]=A;k[D>>2]=0;i[A>>0]=0;Y8(-24,G,235664,233613,3087);k[D>>2]=0;k[G>>2]=0;G=k[d>>2]|0;k[d>>2]=G+-1;if((G|0)==1)ggb(k[d+-4>>2]|0);d=k[s>>2]|0}e=(d|0)!=0;if(!((l|0)!=0|e))break;if(e){k[d>>2]=l;break}else{D=k[q>>2]|0;A=k[o>>2]|0;G=ZT(20)|0;k[G>>2]=l;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=A;k[G+16>>2]=D;k[s>>2]=G;break}}while(0);f=aa(x<<(47696>>>(B<<1&14)&3),F)|0;f=(f|0)==(k[t>>2]|0);g=f?1:C;f=aa(f?w:F,x)|0;n6(a,z,H);if((g|0)<=0){r=I;return y|0}e=y+68|0;d=0;do{o6(a,H,f,(k[e>>2]|0)+(aa(k[t>>2]|0,d)|0)|0,E);d=d+1|0}while((d|0)!=(g|0));r=I;return y|0}function _5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+32|0;n=o;m=o+16|0;e=o+8|0;l=c+28|0;if((k[l>>2]|0)==1){f=e+4|0;d=ZT(56)|0;k[d>>2]=1;g=d+4|0;k[e>>2]=g;k[f>>2]=48;i[d+52>>0]=0;h=226858;j=g+48|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-210,e,226907,221854,3874);k[f>>2]=0;k[e>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}g6(a,b,6,225852);e=c+40|0;p6(a,380241,k[e>>2]|0);f=c+44|0;p6(a,380234,k[f>>2]|0);i6(a,226942,(k[c+32>>2]|0)==0?226921:226930,0);i6(a,226968,(k[l>>2]|0)==1?226949:226956,0);d=c+48|0;if(k[d>>2]|0){g6(a,226975,14,0);p6(a,226979,k[(k[d>>2]|0)+4>>2]|0);p6(a,226981,k[(k[d>>2]|0)+8>>2]|0);p6(a,380241,k[(k[d>>2]|0)+12>>2]|0);p6(a,380234,k[(k[d>>2]|0)+16>>2]|0);p6(a,226983,k[k[d>>2]>>2]|0);_4(a)}h=k[c+16>>2]|0;h=1125516576>>>((h>>>2&60)+(h>>31&20)|0);l=c+8|0;j=i[225904+(h&7)>>0]|0;k[n>>2]=k[l>>2];k[n+4>>2]=j;Cfb(m,225913,n);j=m+((i[m+2>>0]|0)==0&(i[m>>0]|0)==49&1)|0;i6(a,225918,j,0);m=k[e>>2]|0;g=k[f>>2]|0;n=(aa(k[l>>2]|0,m)|0)<<(47696>>>(h<<1&14)&3);h=c+72|0;n=(n|0)==(k[h>>2]|0);f=aa(n?g:1,m)|0;g=n?1:g;g6(a,225921,13,0);if((g|0)<=0){_4(a);_4(a);r=o;return}e=c+68|0;d=0;do{h6(a,(k[e>>2]|0)+(aa(k[h>>2]|0,d)|0)|0,f,j);d=d+1|0}while((d|0)!=(g|0));_4(a);_4(a);r=o;return}function $5(a){a=a|0;if(((a|0)!=0?(k[a>>2]&-65536|0)==1111621632:0)?(k[a+24>>2]|0)>-1:0)a=(k[a+20>>2]|0)>-1;else a=0;return a&1|0}function a6(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0;t=r;r=r+16|0;s=t;d=k6(a,b,226826)|0;a:do if(!d)q=-1;else{switch(k[d>>2]&7){case 1:{q=k[d+8>>2]|0;break a}case 2:break;default:{q=2147483647;break a}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;q=d&2146435072;if(!(q>>>0>1126170624|(q|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}q=~~c}while(0);d=k6(a,b,226831)|0;b:do if(!d)o=-1;else{switch(k[d>>2]&7){case 1:{o=k[d+8>>2]|0;break b}case 2:break;default:{o=2147483647;break b}}c=+p[d+8>>3];p[u>>3]=c;d=k[u+4>>2]|0;o=d&2146435072;if(!(o>>>0>1126170624|(o|0)==1126170624&0>0)){d=(d|0)<0;c=d?c+-4503599627370496.0+4503599627370496.0:c+4503599627370496.0+-4503599627370496.0;if(c==0.0)c=d?-0.0:0.0}o=~~c}while(0);d=k6(a,b,225918)|0;if((d|0)!=0?(k[d>>2]&7|0)==3:0){e=k[d+8+4>>2]|0;d=o|q;if((d|0)>-1&(e|0)!=0)j=e;else f=19}else{d=o|q;e=0;f=19}if((f|0)==19){f=s+4|0;g=ZT(52)|0;k[g>>2]=1;l=g+4|0;k[s>>2]=l;k[f>>2]=46;i[g+50>>0]=0;m=226106;n=l+46|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-2,s,226847,221854,3555);k[f>>2]=0;k[s>>2]=0;n=k[g>>2]|0;k[g>>2]=n+-1;if((n|0)==1)ggb(k[g+-4>>2]|0);j=e}h=m6(j)|0;g=k6(a,b,225921)|0;if(!g){e=s+4|0;f=ZT(52)|0;k[f>>2]=1;l=f+4|0;k[s>>2]=l;k[e>>2]=44;i[f+48>>0]=0;m=226212;n=l+44|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-2,s,226847,221854,3561);k[e>>2]=0;k[s>>2]=0;b=k[f>>2]|0;k[f>>2]=b+-1;if((b|0)==1)ggb(k[f+-4>>2]|0)}e=k[g>>2]&7;if(e>>>0>4)e=k[(k[g+8>>2]|0)+24>>2]|0;else e=(e|0)!=0&1;if((e|0)<=0)if(!d){s=y9(0,1,h)|0;r=t;return s|0}else{s=y9(q,o,h)|0;r=t;return s|0}if((e|0)!=(aa(aa(o,q)|0,(h>>>3&511)+1|0)|0)){e=s+4|0;d=ZT(68)|0;k[d>>2]=1;l=d+4|0;k[s>>2]=l;k[e>>2]=63;i[d+67>>0]=0;m=226257;n=l+63|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-209,s,226847,221854,3566);k[e>>2]=0;k[s>>2]=0;s=k[d>>2]|0;k[d>>2]=s+-1;if((s|0)==1)ggb(k[d+-4>>2]|0)}s=y9(q,o,h)|0;z9(s);l6(a,g,k[s+16>>2]|0,j);r=t;return s|0}function b6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;m=r;r=r+32|0;j=m;l=m+8|0;g6(a,b,6,225865);b=c+20|0;p6(a,226826,k[b>>2]|0);e=c+24|0;p6(a,226831,k[e>>2]|0);n=k[c>>2]|0;d=i[225904+(n&7)>>0]|0;k[j>>2]=(n>>>3&511)+1;k[j+4>>2]=d;Cfb(l,225913,j);i6(a,225918,l+((i[l+2>>0]|0)==0&(i[l>>0]|0)==49&1)|0,0);g6(a,225921,13,0);a:do if(c|0){d=k[c>>2]|0;if(((d&-65536|0)==1111621632?(f=k[e>>2]|0,(f|0)>-1):0)?(g=k[b>>2]|0,(g|0)>-1):0){b=f;d=g}else h=5;do if((h|0)==5){if((d|0)!=112)break a;d=k[c+48>>2]|0;if(!d){b=k[c+40>>2]|0;d=k[c+44>>2]|0;break}else{b=k[d+12>>2]|0;d=k[d+16>>2]|0;break}}while(0);if(!((b|0)>0&(d|0)>0)){_4(a);_4(a);r=m;return}h=c+16|0;f=k[h>>2]|0;if(!f){_4(a);_4(a);r=m;return}e=(k[c>>2]&16384|0)==0;g=e?d:1;e=aa(e?1:d,b)|0;if((g|0)<=0){_4(a);_4(a);r=m;return}b=c+4|0;h6(a,f,e,l);if((g|0)==1){_4(a);_4(a);r=m;return}else d=1;do{h6(a,(k[h>>2]|0)+(aa(k[b>>2]|0,d)|0)|0,e,l);d=d+1|0}while((d|0)!=(g|0));_4(a);_4(a);r=m;return}while(0);d=j+4|0;b=ZT(40)|0;k[b>>2]=1;e=b+4|0;k[j>>2]=e;k[d>>2]=33;i[b+37>>0]=0;f=235048;g=e+33|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-5,j,235082,233613,1248);k[d>>2]=0;k[j>>2]=0;n=k[b>>2]|0;k[b>>2]=n+-1;if((n|0)==1)ggb(k[b+-4>>2]|0);_4(a);_4(a);r=m;return}function c6(a){a=a|0;if(!a)a=0;else a=(k[a>>2]&-65536|0)==1111687168;return a&1|0}function d6(a){a=a|0;B9(a);return}function e6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+160|0;p=q+128|0;n=q;f=k6(a,b,225896)|0;c=k6(a,b,225918)|0;if((c|0)!=0?(k[c>>2]&7|0)==3:0){c=k[c+8+4>>2]|0;if((f|0)!=0&(c|0)!=0)o=c;else d=4}else{c=0;d=4}if((d|0)==4){d=p+4|0;e=ZT(52)|0;k[e>>2]=1;g=e+4|0;k[p>>2]=g;k[d>>2]=46;i[e+50>>0]=0;h=226106;j=g+46|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-2,p,226153,221854,3640);k[d>>2]=0;k[p>>2]=0;o=k[e>>2]|0;k[e>>2]=o+-1;if((o|0)==1)ggb(k[e+-4>>2]|0);o=c}c=k[f>>2]&7;if((c|0)==5)m=k[(k[f+8>>2]|0)+24>>2]|0;else m=(c|0)==1?1:-1;if((m+-1|0)>>>0>31){c=p+4|0;d=ZT(52)|0;k[d>>2]=1;g=d+4|0;k[p>>2]=g;k[c>>2]=45;i[d+49>>0]=0;h=226166;j=g+45|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-212,p,226153,221854,3646);k[c>>2]=0;k[p>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0);l=n}else l=n;n6(a,f,p);if((k[f>>2]&7|0)==5)c=k[(k[f+8>>2]|0)+24>>2]|0;else c=1;o6(a,p,c,n,225902);f=m6(o)|0;b=k6(a,b,225921)|0;if(!b){c=p+4|0;d=ZT(52)|0;k[d>>2]=1;g=d+4|0;k[p>>2]=g;k[c>>2]=44;i[d+48>>0]=0;h=226212;j=g+44|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-2,p,226153,221854,3653);k[c>>2]=0;k[p>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}c=(f>>>3&511)+1|0;if((m|0)>0){d=0;do{c=aa(k[n+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(m|0))}d=k[b>>2]&7;if(d>>>0>4)d=k[(k[b+8>>2]|0)+24>>2]|0;else d=(d|0)!=0&1;e=(d|0)>0;if(!((d|0)==(c|0)|e^1)){c=p+4|0;d=ZT(68)|0;k[d>>2]=1;g=d+4|0;k[p>>2]=g;k[c>>2]=63;i[d+67>>0]=0;h=226257;j=g+63|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-209,p,226153,221854,3664);k[c>>2]=0;k[p>>2]=0;p=k[d>>2]|0;k[d>>2]=p+-1;if((p|0)==1)ggb(k[d+-4>>2]|0)}c=E9(m,l,f)|0;if(!e){r=q;return c|0}z9(c);l6(a,b,k[c+16>>2]|0,o);r=q;return c|0}function f6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=r;r=r+704|0;D=G;x=G+672|0;y=G+664|0;z=G+660|0;A=G+384|0;F=G+160|0;w=G+32|0;E=G+680|0;k[z>>2]=c;k[F+8>>2]=0;k[F+12>>2]=0;g6(a,b,6,225879);B=N9(c,w)|0;g6(a,225896,13,0);h6(a,w,B,225902);_4(a);do if(c){d=k[c>>2]|0;b=d&-65536;a:do if((b|0)<1111687168){switch(b|0){case 1111621632:break;default:break a}if((k[c+24>>2]|0)>0?(k[c+20>>2]|0)>0:0)C=5}else if((b|0)<1111752704)switch(b|0){case 1111687168:{C=5;break a}default:break a}else switch(b|0){case 1111752704:{C=5;break a}default:break a}while(0);if((C|0)==5){d=d&4095;break}if((d|0)==112?(k[c+68>>2]|0)!=0:0){d=k[c+16>>2]|0;d=1125516576>>>((d>>>2&60)+(d>>31&20)|0)&7|(k[c+8>>2]<<3)+-8}else C=9}else C=9;while(0);if((C|0)==9){d=x+4|0;b=ZT(44)|0;k[b>>2]=1;f=b+4|0;k[x>>2]=f;k[d>>2]=38;i[b+42>>0]=0;g=233744;h=f+38|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-5,x,235024,233613,1096);k[d>>2]=0;k[x>>2]=0;B=k[b>>2]|0;k[b>>2]=B+-1;if((B|0)==1)ggb(k[b+-4>>2]|0);d=-1}B=i[225904+(d&7)>>0]|0;k[D>>2]=(d>>>3&511)+1;k[D+4>>2]=B;Cfb(E,225913,D);i6(a,225918,E+((i[E+2>>0]|0)==0&(i[E>>0]|0)==49&1)|0,0);g6(a,225921,13,0);if((k[c+20>>2]|0)<=0){_4(a);_4(a);r=G;return}if(!(k[c+16>>2]|0)){_4(a);_4(a);r=G;return}l=D+4|0;m=D+4|0;n=x+4|0;o=x+4|0;p=A+8|0;q=A+12|0;s=A+4|0;t=A+20|0;u=A+24|0;v=A+28|0;w=A+32|0;c=0;B=-1;j=0;while(1){if((j|0)>=1)break;d=k[z+(j<<2)>>2]|0;if(!d){C=17;break}if(!((k[d>>2]&-65536|0)==1111687168?(k[d+16>>2]|0)!=0:0)){e=A+(j*276|0)|0;k[y>>2]=0;b=k[d>>2]|0;if((b&-65536|0)==1111687168){if(!(k[d+16>>2]|0)){b=ZT(40)|0;k[b>>2]=1;f=b+4|0;k[D>>2]=f;k[m>>2]=32;i[b+36>>0]=0;g=234353;h=f+32|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-27,D,234342,233613,340);k[m>>2]=0;k[D>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0)}}else{if((b|0)==112)d=G9(d,D,y,0)|0;if(d){if(!(((k[d>>2]&-65536|0)==1111621632?(k[d+24>>2]|0)>0:0)?(k[d+20>>2]|0)>0:0))C=33}else{d=0;C=33}if((C|0)==33){C=0;b=ZT(44)|0;k[b>>2]=1;f=b+4|0;k[x>>2]=f;k[n>>2]=38;i[b+42>>0]=0;g=234386;h=f+38|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-5,x,234342,233613,352);k[n>>2]=0;k[x>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0)}c=d+16|0;b=k[c>>2]|0;if(!b){b=ZT(40)|0;k[b>>2]=1;f=b+4|0;k[x>>2]=f;k[o>>2]=33;i[b+37>>0]=0;g=234425;h=f+33|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-27,x,234342,233613,355);k[o>>2]=0;k[x>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0);b=k[c>>2]|0}k[A+(j*276|0)+16>>2]=b;k[p>>2]=0;k[q>>2]=0;h=k[d>>2]|0;k[e>>2]=h;k[s>>2]=2;k[t>>2]=k[d+20>>2];k[u>>2]=k[d+4>>2];k[v>>2]=k[d+24>>2];k[w>>2]=(h>>>3&511)+1<<(47696>>>(h<<1&14)&3);d=e}if(k[y>>2]|0){b=ZT(32)|0;k[b>>2]=1;f=b+4|0;k[D>>2]=f;k[l>>2]=27;i[b+31>>0]=0;g=234285;h=f+27|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-24,D,234224,233613,420);k[l>>2]=0;k[D>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0)}}h=F+184+(j<<2)|0;k[h>>2]=d;c=k[d>>2]|0;c=(c>>>3&511)+1<<(47696>>>(c<<1&14)&3);b=k[d+4>>2]|0;e=b+-1|0;b:do if((e|0)>(B|0)){g=e;f=0;while(1){e=k[d+20+(g<<3)+4>>2]|0;if(!((c|0)==(e|0)&(f|0)==(((e|0)<0)<<31>>31|0))){e=g;break b}e=k[d+20+(g<<3)>>2]|0;c=Epb(e|0,((e|0)<0)<<31>>31|0,c|0,f|0)|0;f=N;e=g+-1|0;if((e|0)>(B|0)){b=g;g=e}else{b=g;break}}}else f=0;while(0);g=(e|0)==(B|0)&((f|0)>0|(f|0)==0&c>>>0>2147483647)?b:e;k[h>>2]=d;k[F+16+(j<<2)>>2]=k[d+16>>2];c=d;B=(g|0)>(B|0)?g:B;j=j+1|0}if((C|0)==17){d=D+4|0;b=ZT(44)|0;k[b>>2]=1;f=b+4|0;k[D>>2]=f;k[d>>2]=39;i[b+43>>0]=0;g=234245;h=f+39|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-27,D,234224,233613,409);k[d>>2]=0;k[D>>2]=0;D=k[b>>2]|0;k[b>>2]=D+-1;if((D|0)==1)ggb(k[b+-4>>2]|0)}d=(k[c+4>>2]|0)+-1|0;if((d|0)>(B|0)){b=1;do{b=aa(k[c+20+(d<<3)>>2]|0,b)|0;d=d+-1|0}while((d|0)>(B|0));d=1}else{b=1;d=1}j=B+1|0;k[F+4>>2]=j;k[F>>2]=1;D=F+8|0;k[D>>2]=b;k[D+4>>2]=d;if((B|0)>=0){d=0;do{k[F+56+(d<<2)>>2]=k[c+20+(d<<3)>>2];d=d+1|0}while((d|0)!=(j|0))}e=F+16|0;f=(j|0)>0;g=F+184|0;c:while(1){h6(a,k[e>>2]|0,b,E);if(f)d=j;else{C=60;break}while(1){c=d;d=d+-1|0;h=F+16|0;k[h>>2]=(k[h>>2]|0)+(k[(k[F+184>>2]|0)+20+(d<<3)+4>>2]|0);h=F+56+(d<<2)|0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)>1)continue c;C=k[g>>2]|0;D=k[C+20+(d<<3)>>2]|0;C=(k[e>>2]|0)+(aa(k[C+20+(d<<3)+4>>2]|0,0-D|0)|0)|0;k[e>>2]=C;k[h>>2]=D;if((c|0)<=1){C=60;break c}}}if((C|0)==60){_4(a);_4(a);r=G;return}}function g6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;m=n;e=(a|0)!=0;if(!(e?(k[a>>2]|0)==1280131417:0)){f=e?-5:-27;g=m+4|0;e=ZT(36)|0;k[e>>2]=1;h=e+4|0;k[m>>2]=h;k[g>>2]=31;i[e+35>>0]=0;j=221977;l=h+31|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(f,m,226087,221854,2933);k[g>>2]=0;k[m>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}if(k[a+8>>2]|0){m=a+228|0;m=k[m>>2]|0;dh[m&255](a,b,c,d);r=n;return}e=m+4|0;f=ZT(44)|0;k[f>>2]=1;h=f+4|0;k[m>>2]=h;k[e>>2]=38;i[f+42>>0]=0;j=222026;l=h+38|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-2,m,226087,221854,2933);k[e>>2]=0;k[m>>2]=0;m=k[f>>2]|0;k[f>>2]=m+-1;if((m|0)==1)ggb(k[f+-4>>2]|0);m=a+228|0;m=k[m>>2]|0;dh[m&255](a,b,c,d);r=n;return}function h6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0.0,n=0,q=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;J=r;r=r+1312|0;H=J+8|0;G=J;E=J+24|0;F=J+1048|0;v=J+16|0;zpb(F|0,0,256)|0;e=(a|0)!=0;if(!(e?(k[a>>2]|0)==1280131417:0)){e=e?-5:-27;f=v+4|0;g=ZT(36)|0;k[g>>2]=1;n=g+4|0;k[v>>2]=n;k[f>>2]=31;i[g+35>>0]=0;q=221977;s=n+31|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(s|0));Y8(e,v,225940,221854,3101);k[f>>2]=0;k[v>>2]=0;D=k[g>>2]|0;k[g>>2]=D+-1;if((D|0)==1)ggb(k[g+-4>>2]|0)}if(!(k[a+8>>2]|0)){e=v+4|0;f=ZT(44)|0;k[f>>2]=1;n=f+4|0;k[v>>2]=n;k[e>>2]=38;i[f+42>>0]=0;q=222026;s=n+38|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(s|0));Y8(-2,v,225940,221854,3101);k[e>>2]=0;k[v>>2]=0;D=k[f>>2]|0;k[f>>2]=D+-1;if((D|0)==1)ggb(k[f+-4>>2]|0)}if((c|0)>=0){e=j6(d,E)|0;if(!c){r=J;return}else d=E}else{e=v+4|0;f=ZT(32)|0;k[f>>2]=1;n=f+4|0;k[v>>2]=n;k[e>>2]=27;i[f+31>>0]=0;q=225955;s=n+27|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(s|0));Y8(-211,v,225940,221854,3104);k[e>>2]=0;k[v>>2]=0;D=k[f>>2]|0;k[f>>2]=D+-1;if((D|0)==1)ggb(k[f+-4>>2]|0);e=j6(d,E)|0;d=E}if(!b){f=v+4|0;g=ZT(24)|0;k[g>>2]=1;n=g+4|0;k[v>>2]=n;k[f>>2]=17;i[g+21>>0]=0;q=225983;s=n+17|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(s|0));Y8(-27,v,225940,221854,3112);k[f>>2]=0;k[v>>2]=0;D=k[g>>2]|0;k[g>>2]=D+-1;if((D|0)==1)ggb(k[g+-4>>2]|0)}if((e|0)!=1)if(!c){r=J;return}else f=c;else{f=aa(k[d>>2]|0,c)|0;k[d>>2]=f;f=1}y=(e|0)>0;z=b;A=F+23|0;B=a+4|0;C=F+1|0;D=F;g=0;a:while(1){f=f+-1|0;if(y){x=0;do{w=x<<1;v=k[E+(w<<2)>>2]|0;w=k[E+((w|1)<<2)>>2]|0;c=(w>>>3&511)+1<<(47696>>>(w<<1&14)&3);g=b+(g+-1+c&0-c)|0;b:do if((v|0)>0){c=0;while(1){switch(w|0){case 0:{n=l[g>>0]|0;i[A>>0]=0;d=A;do{s=n;n=(n>>>0)/10|0;q=s+48+(aa(n,-10)|0)&255;d=d+-1|0;i[d>>0]=q}while(s>>>0>9);g=g+1|0;break}case 1:{s=i[g>>0]|0;q=s<<24>>24;i[A>>0]=0;n=A;q=s<<24>>24>-1?q:0-q|0;while(1){K=q;q=(q>>>0)/10|0;L=K+48+(aa(q,-10)|0)&255;d=n+-1|0;i[d>>0]=L;if(K>>>0<=9)break;else n=d}if(s<<24>>24<0){d=n+-2|0;i[d>>0]=45}g=g+1|0;break}case 2:{n=m[g>>1]|0;i[A>>0]=0;d=A;do{L=n;n=(n>>>0)/10|0;K=L+48+(aa(n,-10)|0)&255;d=d+-1|0;i[d>>0]=K}while(L>>>0>9);g=g+2|0;break}case 3:{s=j[g>>1]|0;q=s<<16>>16;i[A>>0]=0;n=A;q=s<<16>>16>-1?q:0-q|0;while(1){L=q;q=(q>>>0)/10|0;K=L+48+(aa(q,-10)|0)&255;d=n+-1|0;i[d>>0]=K;if(L>>>0<=9)break;else n=d}if(s<<16>>16<0){d=n+-2|0;i[d>>0]=45}g=g+2|0;break}case 4:{s=k[g>>2]|0;i[A>>0]=0;n=A;q=(s|0)>-1?s:0-s|0;while(1){L=q;q=(q>>>0)/10|0;K=L+48+(aa(q,-10)|0)&255;d=n+-1|0;i[d>>0]=K;if(L>>>0<=9)break;else n=d}if((s|0)<0){d=n+-2|0;i[d>>0]=45}g=g+4|0;break}case 5:{t=+o[g>>2];d=(o[u>>2]=t,k[u>>2]|0);c:do if((d&2139095040|0)==2139095040){if((d&2147483647|0)!=2139095040){i[F>>0]=i[225001]|0;i[F+1>>0]=i[225002]|0;i[F+2>>0]=i[225003]|0;i[F+3>>0]=i[225004]|0;i[F+4>>0]=i[225005]|0;break}n=(d|0)<0?225006:225012;d=n;if(!((d^D)&3)){if(!(d&3))d=F;else{d=F;do{L=i[n>>0]|0;i[d>>0]=L;if(!(L<<24>>24))break c;n=n+1|0;d=d+1|0}while((n&3|0)!=0)}q=k[n>>2]|0;if(!((q&-2139062144^-2139062144)&q+-16843009))while(1){n=n+4|0;s=d+4|0;k[d>>2]=q;q=k[n>>2]|0;if((q&-2139062144^-2139062144)&q+-16843009|0){d=s;break}else d=s}}else d=F;L=i[n>>0]|0;i[d>>0]=L;if(L<<24>>24)do{n=n+1|0;d=d+1|0;L=i[n>>0]|0;i[d>>0]=L}while(L<<24>>24!=0)}else{if((d&2130706432)>>>0<=1249902592){d=(d|0)<0;h=d?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(h==0.0)h=d?-0.0:0.0}else h=t;d=~~h;if(+(d|0)==t){k[G>>2]=d;Cfb(F,224991,G);break}p[H>>3]=t;Cfb(F,226001,H);switch(i[F>>0]|0){case 45:case 43:{d=C;break}default:d=F}while(1){n=i[d>>0]|0;if((n+-48&255)<10)d=d+1|0;else break}if(n<<24>>24==44)i[d>>0]=46}while(0);d=F;g=g+4|0;break}case 6:{d=E5(F,+p[g>>3])|0;g=g+8|0;break}case 7:{s=k[g>>2]|0;i[A>>0]=0;n=A;q=(s|0)>-1?s:0-s|0;while(1){L=q;q=(q>>>0)/10|0;K=L+48+(aa(q,-10)|0)&255;d=n+-1|0;i[d>>0]=K;if(L>>>0<=9)break;else n=d}if((s|0)<0){d=n+-2|0;i[d>>0]=45}g=g+4|0;break}default:{I=90;break a}}if((k[B>>2]|0)==8){s=d;d:do if(!(s&3)){n=d;I=81}else{q=d;n=s;while(1){if(!(i[q>>0]|0))break d;q=q+1|0;n=q;if(!(n&3)){n=q;I=81;break}}}while(0);if((I|0)==81){I=0;while(1){q=k[n>>2]|0;if(!((q&-2139062144^-2139062144)&q+-16843009))n=n+4|0;else break}if((q&255)<<24>>24)do n=n+1|0;while((i[n>>0]|0)!=0)}F5(a,0,d,n-s|0)}else D5(a,0,d);c=c+1|0;if((c|0)>=(v|0))break b}}while(0);g=g-z|0;x=x+1|0}while((x|0)<(e|0))}if(!f){I=90;break}}if((I|0)==90){r=J;return}}function i6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;m=n;e=(a|0)!=0;if(!(e?(k[a>>2]|0)==1280131417:0)){f=e?-5:-27;g=m+4|0;e=ZT(36)|0;k[e>>2]=1;h=e+4|0;k[m>>2]=h;k[g>>2]=31;i[e+35>>0]=0;j=221977;l=h+31|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(f,m,225926,221854,2965);k[g>>2]=0;k[m>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0)}if(k[a+8>>2]|0){m=a+244|0;m=k[m>>2]|0;dh[m&255](a,b,c,d);r=n;return}e=m+4|0;f=ZT(44)|0;k[f>>2]=1;h=f+4|0;k[m>>2]=h;k[e>>2]=38;i[f+42>>0]=0;j=222026;l=h+38|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-2,m,225926,221854,2965);k[e>>2]=0;k[m>>2]=0;m=k[f>>2]|0;k[f>>2]=m+-1;if((m|0)==1)ggb(k[f+-4>>2]|0);m=a+244|0;m=k[m>>2]|0;dh[m&255](a,b,c,d);r=n;return}function j6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+112|0;y=A;if(!a){z=0;r=A;return z|0}e=a;a:do if(!(e&3)){c=a;z=5}else{d=a;c=e;while(1){if(!(i[d>>0]|0))break a;d=d+1|0;c=d;if(!(c&3)){c=d;z=5;break}}}while(0);if((z|0)==5){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}x=c-e|0;if(!x){z=0;r=A;return z|0}k[b>>2]=0;if((x|0)>0){l=~e;m=y+4|0;n=y+4|0;o=y+4|0;p=y+4|0;q=y+44|0;s=y+8|0;t=y+76|0;u=y+104|0;v=y+108|0;w=y+100|0;d=0;c=0;do{f=a+d|0;j=i[f>>0]|0;e=j<<24>>24;if((j+-48&255)<10){if(((i[a+(d+1)>>0]|0)+-48&255)<10){k[y>>2]=0;k[p>>2]=f;k[q>>2]=f;g=(f|0)<0?-1:f+2147483647|0;k[s>>2]=g;k[t>>2]=-1;k[u>>2]=0;k[v>>2]=g-f;k[w>>2]=g;g=Efb(y,10,1,-2147483648,0)|0;d=f+((k[p>>2]|0)+(k[v>>2]|0)-(k[s>>2]|0))+l|0}else g=e+-48|0;if((g|0)<1){e=ZT(36)|0;k[e>>2]=1;f=e+4|0;k[y>>2]=f;k[m>>2]=31;i[e+35>>0]=0;h=226006;j=f+31|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-5,y,226038,221854,3024);k[m>>2]=0;k[y>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0)}k[b+(c<<2)>>2]=g}else{h=e&255;b:do if(0){f=225904;e=9;do{if((i[f>>0]|0)==j<<24>>24){z=25;break b}f=f+1|0;e=e+-1|0;g=(e|0)!=0}while(g&(f&3|0)!=0);if(g)z=25;else e=0}else{f=225904;e=9;z=25}while(0);c:do if((z|0)==25){z=0;if((i[f>>0]|0)!=j<<24>>24){g=aa(h,16843009)|0;d:do if(e>>>0>3)while(1){h=k[f>>2]^g;if((h&-2139062144^-2139062144)&h+-16843009|0)break;f=f+4|0;e=e+-4|0;if(e>>>0<=3){z=30;break d}}else z=30;while(0);if((z|0)==30){z=0;if(!e){e=0;break}}while(1){if((i[f>>0]|0)==j<<24>>24)break c;f=f+1|0;e=e+-1|0;if(!e){e=0;break}}}}while(0);g=e|0?f:0;if(!g){e=ZT(36)|0;k[e>>2]=1;f=e+4|0;k[y>>2]=f;k[n>>2]=31;i[e+35>>0]=0;h=226006;j=f+31|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-5,y,226038,221854,3032);k[n>>2]=0;k[y>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0)}f=b+(c<<2)|0;e=k[f>>2]|0;if(!e){k[f>>2]=1;e=1}j=g-225904|0;k[b+(c+1<<2)>>2]=j;if((c|0)>0?(j|0)==(k[b+(c+-1<<2)>>2]|0):0){j=b+(c+-2<<2)|0;k[j>>2]=(k[j>>2]|0)+e}else{c=c+2|0;if((c|0)>255){e=ZT(40)|0;k[e>>2]=1;f=e+4|0;k[y>>2]=f;k[o>>2]=32;i[e+36>>0]=0;h=226054;j=f+32|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-5,y,226038,221854,3042);k[o>>2]=0;k[y>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0)}}k[b+(c<<2)>>2]=0}d=d+1|0}while((d|0)<(x|0))}else c=0;z=(c|0)/2|0;r=A;return z|0}function k6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+16|0;o=q;if(!a){c=0;r=q;return c|0}if((k[a>>2]|0)!=1280131417){d=o+4|0;e=ZT(36)|0;k[e>>2]=1;f=e+4|0;k[o>>2]=f;k[d>>2]=31;i[e+35>>0]=0;g=221977;h=f+31|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-5,o,226788,221854,709);k[d>>2]=0;k[o>>2]=0;n=k[e>>2]|0;k[e>>2]=n+-1;if((n|0)==1)ggb(k[e+-4>>2]|0)}if(!c){d=o+4|0;e=ZT(24)|0;k[e>>2]=1;f=e+4|0;k[o>>2]=f;k[d>>2]=17;i[e+21>>0]=0;g=226808;h=f+17|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-27,o,226788,221854,712);k[d>>2]=0;k[o>>2]=0;n=k[e>>2]|0;k[e>>2]=n+-1;if((n|0)==1)ggb(k[e+-4>>2]|0)}e=i[c>>0]|0;if(!(e<<24>>24)){d=0;n=0}else{d=0;f=0;do{d=(e&255)+(d*33|0)|0;f=f+1|0;e=i[c+f>>0]|0}while(e<<24>>24!=0);n=f}m=d&2147483647;a:do if(!b){d=k[a+32>>2]|0;if(!d){c=0;r=q;return c|0}j=k[d+24>>2]|0;if((j|0)<=0){c=0;r=q;return c|0}l=d+52|0;h=d+28|0;a=(n|0)==0;g=0;b:while(1){d=k[l>>2]|0;if((g<<1|0)<=(j|0)){e=k[d+12>>2]|0;if((g|0)<(e|0))b=g;else{b=g;do{d=k[d+4>>2]|0;b=b-e|0;e=k[d+12>>2]|0}while((b|0)>=(e|0))}}else{b=j;do{d=k[d>>2]|0;b=b-(k[d+12>>2]|0)|0}while((g|0)<(b|0));b=g-b|0}b=(k[d+16>>2]|0)+(aa(k[h>>2]|0,b)|0)|0;d=k[b>>2]|0;switch(d&7){case 5:{p=35;break b}case 6:break;default:break a}e=k[b+8>>2]|0;d=k[e+64>>2]|0;b=d+-1|0;if(!(b&d))d=b&m;else d=(m>>>0)%(d>>>0)|0;d=k[(k[e+68>>2]|0)+(d<<2)>>2]|0;if(d|0)do{b=k[d+16>>2]|0;c:do if((k[b>>2]|0)==(m|0)?(k[b+4>>2]|0)==(n|0):0){if(a){p=53;break a}b=k[b+8>>2]|0;e=n;f=c;while(1){if((i[b>>0]|0)!=(i[f>>0]|0))break c;e=e+-1|0;if(!e){p=53;break a}else{b=b+1|0;f=f+1|0}}}while(0);d=k[d+20>>2]|0}while((d|0)!=0);g=g+1|0;if((g|0)>=(j|0)){d=0;p=54;break}}if((p|0)==35){p=36;break}else if((p|0)==54){r=q;return d|0}}else{d=k[b>>2]|0;switch(d&7){case 5:{p=36;break a}case 6:break;default:break a}e=k[b+8>>2]|0;d=k[e+64>>2]|0;b=d+-1|0;if(!(b&d))d=b&m;else d=(m>>>0)%(d>>>0)|0;d=k[(k[e+68>>2]|0)+(d<<2)>>2]|0;if(!d){c=0;r=q;return c|0}g=(n|0)==0;while(1){b=k[d+16>>2]|0;d:do if((k[b>>2]|0)==(m|0)?(k[b+4>>2]|0)==(n|0):0){if(g){p=53;break a}b=k[b+8>>2]|0;e=n;f=c;while(1){if((i[b>>0]|0)!=(i[f>>0]|0))break d;e=e+-1|0;if(!e){p=53;break a}else{b=b+1|0;f=f+1|0}}}while(0);d=k[d+20>>2]|0;if(!d){d=0;break}}r=q;return d|0}while(0);if((p|0)==36){if(!(k[(k[b+8>>2]|0)+24>>2]|0)){c=0;r=q;return c|0}}else if((p|0)==53){c=d;r=q;return c|0}if(!(d&7)){c=0;r=q;return c|0}d=o+4|0;b=ZT(56)|0;k[b>>2]=1;f=b+4|0;k[o>>2]=f;k[d>>2]=49;i[b+53>>0]=0;g=223449;h=f+49|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,o,226788,221854,739);k[d>>2]=0;k[o>>2]=0;c=k[b>>2]|0;k[b>>2]=c+-1;if((c|0)==1)ggb(k[b+-4>>2]|0);c=0;r=q;return c|0}function l6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;l=r;r=r+48|0;e=l+8|0;f=l;if(!((b|0)!=0&(c|0)!=0)){g=f+4|0;h=ZT(60)|0;k[h>>2]=1;j=h+4|0;k[f>>2]=j;k[g>>2]=54;i[h+58>>0]=0;m=226377;n=j+54|0;do{i[j>>0]=i[m>>0]|0;j=j+1|0;m=m+1|0}while((j|0)<(n|0));Y8(-27,f,226432,221854,3375);k[g>>2]=0;k[f>>2]=0;n=k[h>>2]|0;k[h>>2]=n+-1;if((n|0)==1)ggb(k[h+-4>>2]|0)}n6(a,b,e);if((k[b>>2]&7|0)!=5){n=1;o6(a,e,n,c,d);r=l;return}n=k[(k[b+8>>2]|0)+24>>2]|0;o6(a,e,n,c,d);r=l;return}function m6(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+528|0;g=j+8|0;h=j;f=(j6(a,g)|0)!=1;a=k[g>>2]|0;if(!(f|(a|0)>4)){h=g+4|0;h=k[h>>2]|0;h=h&7;g=a<<3;g=g+-8|0;h=g|h;r=j;return h|0}b=h+4|0;c=ZT(40)|0;k[c>>2]=1;d=c+4|0;k[h>>2]=d;k[b>>2]=33;i[c+37>>0]=0;e=226321;f=d+33|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-2,h,226355,221854,3085);k[b>>2]=0;k[h>>2]=0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0);h=g+4|0;h=k[h>>2]|0;h=h&7;g=a<<3;g=g+-8|0;h=g|h;r=j;return h|0}function n6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;d=(a|0)!=0;if(!(d?(k[a>>2]|0)==1280131417:0)){a=d?-5:-27;d=j+4|0;e=ZT(36)|0;k[e>>2]=1;f=e+4|0;k[j>>2]=f;k[d>>2]=31;i[e+35>>0]=0;g=221977;h=f+31|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(a,j,226669,221854,3192);k[d>>2]=0;k[j>>2]=0;h=k[e>>2]|0;k[e>>2]=h+-1;if((h|0)==1)ggb(k[e+-4>>2]|0)}if(!((b|0)!=0&(c|0)!=0)){a=j+4|0;d=ZT(48)|0;k[d>>2]=1;f=d+4|0;k[j>>2]=f;k[a>>2]=42;i[d+46>>0]=0;g=226688;h=f+42|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-27,j,226669,221854,3195);k[a>>2]=0;k[j>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}a=k[b>>2]|0;if(((a&7)+-1|0)>>>0<2){k[c+12>>2]=b;k[c+20>>2]=b+32;k[c+16>>2]=b;k[c+4>>2]=0;r=l;return}switch(a&7){case 5:{KY(k[b+8>>2]|0,c);r=l;return}case 0:{k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;k[c+16>>2]=0;k[c+20>>2]=0;k[c+24>>2]=0;k[c+28>>2]=0;r=l;return}default:{a=j+4|0;d=ZT(64)|0;k[d>>2]=1;f=d+4|0;k[j>>2]=f;k[a>>2]=56;i[d+60>>0]=0;g=226731;h=f+56|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-5,j,226669,221854,3215);k[a>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);r=l;return}}}function o6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=r;r=r+1040|0;C=E+8|0;D=E;f=(a|0)!=0;if(!(f?(k[a>>2]|0)==1280131417:0)){a=f?-5:-27;f=D+4|0;g=ZT(36)|0;k[g>>2]=1;l=g+4|0;k[D>>2]=l;k[f>>2]=31;i[g+35>>0]=0;m=221977;n=l+31|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(a,D,226446,221854,3227);k[f>>2]=0;k[D>>2]=0;B=k[g>>2]|0;k[g>>2]=B+-1;if((B|0)==1)ggb(k[g+-4>>2]|0)}if(!((b|0)!=0&(d|0)!=0)){a=D+4|0;f=ZT(48)|0;k[f>>2]=1;l=f+4|0;k[D>>2]=l;k[a>>2]=43;i[f+47>>0]=0;m=226465;n=l+43|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-27,D,226446,221854,3230);k[a>>2]=0;k[D>>2]=0;B=k[f>>2]|0;k[f>>2]=B+-1;if((B|0)==1)ggb(k[f+-4>>2]|0)}B=b+4|0;if((c|0)!=1&(k[B>>2]|0)==0){a=D+4|0;f=ZT(56)|0;k[f>>2]=1;l=f+4|0;k[D>>2]=l;k[a>>2]=51;i[f+55>>0]=0;m=226509;n=l+51|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-201,D,226446,221854,3233);k[a>>2]=0;k[D>>2]=0;A=k[f>>2]|0;k[f>>2]=A+-1;if((A|0)==1)ggb(k[f+-4>>2]|0)}z=j6(e,C)|0;t=(z|0)>0;v=d;A=b+12|0;w=D+4|0;x=b+20|0;y=b+8|0;s=b+16|0;g=c;a=0;a:while(1){do{}while(!t);f=0;while(1){q=f<<1;c=k[C+((q|1)<<2)>>2]|0;n=(c>>>3&511)+1<<(47696>>>(c<<1&14)&3);q=k[C+(q<<2)>>2]|0;a=d+(a+-1+n&0-n)|0;b:do if((q|0)>0){b=0;e=k[A>>2]|0;while(1){c:do switch(k[e>>2]&7){case 1:{e=k[e+8>>2]|0;switch(c|0){case 0:{i[a>>0]=e>>>0<256?e:(e|0)>0?255:0;a=a+1|0;break c}case 1:{i[a>>0]=(e+128|0)>>>0<256?e:(e|0)>0?127:128;a=a+1|0;break c}case 2:{j[a>>1]=e>>>0<65536?e:(e|0)>0?65535:0;a=a+2|0;break c}case 3:{j[a>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;a=a+2|0;break c}case 4:{k[a>>2]=e;a=a+4|0;break c}case 5:{o[a>>2]=+(e|0);a=a+4|0;break c}case 6:{p[a>>3]=+(e|0);a=a+8|0;break c}case 7:{k[a>>2]=e;a=a+4|0;break c}default:{a=70;break a}}}case 2:{h=+p[e+8>>3];switch(c|0){case 0:{p[u>>3]=h;e=k[u+4>>2]|0;n=e&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){e=(e|0)<0;h=e?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=e?-0.0:0.0}n=~~h;i[a>>0]=n>>>0<256?n:(n|0)>0?255:0;a=a+1|0;break c}case 1:{p[u>>3]=h;e=k[u+4>>2]|0;n=e&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){e=(e|0)<0;h=e?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=e?-0.0:0.0}n=~~h;i[a>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;a=a+1|0;break c}case 2:{p[u>>3]=h;e=k[u+4>>2]|0;n=e&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){e=(e|0)<0;h=e?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=e?-0.0:0.0}n=~~h;j[a>>1]=n>>>0<65536?n:(n|0)>0?65535:0;a=a+2|0;break c}case 3:{p[u>>3]=h;e=k[u+4>>2]|0;n=e&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){e=(e|0)<0;h=e?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=e?-0.0:0.0}n=~~h;j[a>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;a=a+2|0;break c}case 4:{p[u>>3]=h;e=k[u+4>>2]|0;n=e&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){e=(e|0)<0;h=e?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=e?-0.0:0.0}k[a>>2]=~~h;a=a+4|0;break c}case 5:{o[a>>2]=h;a=a+4|0;break c}case 6:{p[a>>3]=h;a=a+8|0;break c}case 7:{p[u>>3]=h;e=k[u+4>>2]|0;n=e&2146435072;if(!(n>>>0>1126170624|(n|0)==1126170624&0>0)){e=(e|0)<0;h=e?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=e?-0.0:0.0}k[a>>2]=~~h;a=a+4|0;break c}default:{a=70;break a}}}default:{e=ZT(52)|0;k[e>>2]=1;l=e+4|0;k[D>>2]=l;k[w>>2]=46;i[e+50>>0]=0;m=226561;n=l+46|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-2,D,226446,221854,3347);k[w>>2]=0;k[D>>2]=0;n=k[e>>2]|0;k[e>>2]=n+-1;if((n|0)==1)ggb(k[e+-4>>2]|0)}}while(0);e=(k[A>>2]|0)+16|0;k[A>>2]=e;if(e>>>0>=(k[x>>2]|0)>>>0){n=k[(k[y>>2]|0)+4>>2]|0;k[y>>2]=n;e=k[n+16>>2]|0;k[A>>2]=e;l=e;m=k[(k[B>>2]|0)+28>>2]|0;n=k[n+12>>2]|0;k[s>>2]=l;n=l+(aa(m,n)|0)|0;k[x>>2]=n}g=g+-1|0;if(!g){a=64;break a}b=b+1|0;if((b|0)>=(q|0))break b}}while(0);a=a-v|0;f=f+1|0;if((f|0)>=(z|0))continue a}}if((a|0)==64){if(!((f|0)==(z+-1|0)&(b|0)==(q+-1|0))){a=D+4|0;f=ZT(68)|0;k[f>>2]=1;l=f+4|0;k[D>>2]=l;k[a>>2]=60;i[f+64>>0]=0;m=226608;n=l+60|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-201,D,226446,221854,3361);k[a>>2]=0;k[D>>2]=0;D=k[f>>2]|0;k[f>>2]=D+-1;if((D|0)==1)ggb(k[f+-4>>2]|0)}if(k[B>>2]|0){r=E;return}k[A>>2]=(k[A>>2]|0)+-16;r=E;return}else if((a|0)==70){r=E;return}}function p6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;l=m;d=(a|0)!=0;if(!(d?(k[a>>2]|0)==1280131417:0)){d=d?-5:-27;e=l+4|0;f=ZT(36)|0;k[f>>2]=1;g=f+4|0;k[l>>2]=g;k[e>>2]=31;i[f+35>>0]=0;h=221977;j=g+31|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(d,l,226836,221854,2949);k[e>>2]=0;k[l>>2]=0;j=k[f>>2]|0;k[f>>2]=j+-1;if((j|0)==1)ggb(k[f+-4>>2]|0)}if(k[a+8>>2]|0){l=a+236|0;l=k[l>>2]|0;Ph[l&511](a,b,c);r=m;return}d=l+4|0;e=ZT(44)|0;k[e>>2]=1;g=e+4|0;k[l>>2]=g;k[d>>2]=38;i[e+42>>0]=0;h=222026;j=g+38|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-2,l,226836,221854,2949);k[d>>2]=0;k[l>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0);l=a+236|0;l=k[l>>2]|0;Ph[l&511](a,b,c);r=m;return}function q6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+544|0;s=v+16|0;q=v+8|0;t=v;u=v+24|0;a:do if(c|0){b:while(1){p=k[c>>2]|0;if(!p)break a;f=k[p>>2]|0;if(f|0){n=i[b>>0]|0;o=n<<24>>24==0;m=0;g=0;do{h=i[f>>0]|0;if(o|n<<24>>24!=h<<24>>24)f=n;else{j=b;do{j=j+1|0;f=f+1|0;l=i[j>>0]|0;h=i[f>>0]|0}while(!(l<<24>>24==0?1:l<<24>>24!=h<<24>>24));f=l}m=m+1|0;if(f<<24>>24==h<<24>>24)break b;g=m<<1;f=k[p+(g<<2)>>2]|0}while((f|0)!=0)}c=k[c+4>>2]|0;if(!c)break a}l=k[p+((g|1)<<2)>>2]|0;if(l|0){e=j6(l,u)|0;g=e<<1;if((e|0)>0){c=d;f=0;do{e=k[u+((f|1)<<2)>>2]|0;e=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);c=(c+-1+e&0-e)+(aa(e,k[u+(f<<2)>>2]|0)|0)|0;f=f+2|0}while((f|0)<(g|0))}else c=d;if(!d){e=k[u+4>>2]|0;e=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);c=c+-1+e&0-e}if((c|0)==(k[a+28>>2]|0)){u=l;r=v;return u|0}c=u+4|0;f=ZT(76)|0;k[f>>2]=1;g=f+4|0;k[u>>2]=g;k[c>>2]=71;i[f+75>>0]=0;h=227437;j=g+71|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-209,u,227509,221854,4086);k[c>>2]=0;k[u>>2]=0;u=k[f>>2]|0;k[f>>2]=u+-1;if((u|0)==1)ggb(k[f+-4>>2]|0);u=l;r=v;return u|0}}while(0);c=k[a>>2]|0;f=k[a+28>>2]|0;if(!(c&4095))if((f|0)!=1){if((f|0)<=(d|0)){u=0;r=v;return u|0}c=f-d|0;if(!(c&3)){k[q>>2]=c>>>2;Cfb(e,227412,q);u=e;r=v;return u|0}else{k[s>>2]=c;Cfb(e,227416,s);u=e;r=v;return u|0}}else f=1;if(((c>>>3&511)+1<<(47696>>>(c<<1&14)&3)|0)!=(f|0)){c=u+4|0;f=ZT(76)|0;k[f>>2]=1;g=f+4|0;k[u>>2]=g;k[c>>2]=68;i[f+72>>0]=0;h=227522;j=g+68|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-209,u,227509,221854,4092);k[c>>2]=0;k[u>>2]=0;u=k[f>>2]|0;k[f>>2]=u+-1;if((u|0)==1)ggb(k[f+-4>>2]|0);c=k[a>>2]|0}u=i[225904+(c&7)>>0]|0;k[t>>2]=(c>>>3&511)+1;k[t+4>>2]=u;Cfb(e,225913,t);if(!(i[e+2>>0]|0))c=(i[e>>0]|0)==49;else c=0;u=e+(c&1)|0;r=v;return u|0}function r6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+656|0;p=t+8|0;o=t;q=t+16|0;n=t+528|0;a:do if(c){b:while(1){m=k[c>>2]|0;if(!m){s=18;break a}e=k[m>>2]|0;if(e|0){l=0;f=0;do{g=i[e>>0]|0;if(g<<24>>24==104){h=227302;do{h=h+1|0;e=e+1|0;j=i[h>>0]|0;g=i[e>>0]|0}while(!(j<<24>>24==0?1:j<<24>>24!=g<<24>>24));e=j}else e=104;l=l+1|0;if(e<<24>>24==g<<24>>24)break b;f=l<<1;e=k[m+(f<<2)>>2]|0}while((e|0)!=0)}c=k[c+4>>2]|0;if(!c){s=18;break a}}c=k[m+((f|1)<<2)>>2]|0;if(c){p=j6(c,q)|0;g=p<<1;if((p|0)>0){e=d;f=0;do{p=k[q+((f|1)<<2)>>2]|0;p=(p>>>3&511)+1<<(47696>>>(p<<1&14)&3);e=(e+-1+p&0-p)+(aa(p,k[q+(f<<2)>>2]|0)|0)|0;f=f+2|0}while((f|0)<(g|0))}else e=d;if(!d){d=k[q+4>>2]|0;d=(d>>>3&511)+1<<(47696>>>(d<<1&14)&3);e=e+-1+d&0-d}if((e|0)>(k[b+4>>2]|0)){e=q+4|0;f=ZT(80)|0;k[f>>2]=1;g=f+4|0;k[q>>2]=g;k[e>>2]=74;i[f+78>>0]=0;h=227312;j=g+74|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-209,q,227387,221854,4022);k[e>>2]=0;k[q>>2]=0;q=k[f>>2]|0;k[f>>2]=q+-1;if((q|0)==1)ggb(k[f+-4>>2]|0)}}else s=18}else s=18;while(0);do if((s|0)==18){c=k[b+4>>2]|0;if((c|0)<=(d|0)){r=t;return}e=k[b>>2]|0;if(((e&-65536|0)==1117323264?(c|0)==88&(e&4094|0)==12:0)?(k[b+28>>2]|0)==8:0){g6(a,379272,14,0);p6(a,226979,k[b+56>>2]|0);p6(a,226981,k[b+60>>2]|0);p6(a,380241,k[b+64>>2]|0);p6(a,380234,k[b+68>>2]|0);_4(a);p6(a,227406,k[b+72>>2]|0);r=t;return}if((e&-53248|0)==1117327360?((e&4095|0)==0?(k[b+28>>2]|0)==1:0):0){g6(a,226942,14,0);p6(a,226979,k[b+56>>2]|0);p6(a,226981,k[b+60>>2]|0);_4(a);r=t;return}c=c-d|0;if(!(c&3)){k[o>>2]=c>>>2;Cfb(n,227412,o);c=n;break}else{k[p>>2]=c;Cfb(n,227416,p);c=n;break}}while(0);i6(a,227302,c,0);g6(a,227420,13,0);h6(a,b+56|0,1,c);_4(a);r=t;return}function s6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;l=m;d=(a|0)!=0;if(!(d?(k[a>>2]|0)==1280131417:0)){d=d?-5:-27;e=l+4|0;f=ZT(36)|0;k[f>>2]=1;g=f+4|0;k[l>>2]=g;k[e>>2]=31;i[f+35>>0]=0;h=221977;j=g+31|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(d,l,228136,221854,4970);k[e>>2]=0;k[l>>2]=0;j=k[f>>2]|0;k[f>>2]=j+-1;if((j|0)==1)ggb(k[f+-4>>2]|0)}if(!b){b=0;r=m;return b|0}if(!((k[b>>2]&16|0)!=0?(c=k[b+4>>2]|0,(c|0)!=0):0)){c=l+4|0;d=ZT(64)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[c>>2]=57;i[d+61>>0]=0;h=228143;j=g+57|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-2,l,228136,221854,4976);k[c>>2]=0;k[l>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0);c=k[b+4>>2]|0}b=Hh[k[c+28>>2]&511](a,b)|0;r=m;return b|0}function t6(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0;m=r;r=r+272|0;l=m;k[l>>2]=d;k[l+4>>2]=e;h=m+136|0;g6(a,b,6,225781);if((f|0)>-1)p6(a,228073,f);j=q6(c,225918,l,0,m+8|0)|0;i[h>>0]=0;f=k[c>>2]|0;if(f&16384|0){b=h;if(!(b&3)){d=h;while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}else d=b;b=h+(d-b)|0;e=b;i[e>>0]=32;i[e+1>>0]=99;i[e+2>>0]=108;i[e+3>>0]=111;b=b+4|0;i[b>>0]=115;i[b+1>>0]=101;i[b+2>>0]=100;i[b+3>>0]=0}if(f&32768|0){b=h;a:do if(!(b&3)){d=h;g=15}else{e=h;d=b;while(1){if(!(i[e>>0]|0))break a;e=e+1|0;d=e;if(!(d&3)){d=e;g=15;break}}}while(0);if((g|0)==15){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}b=h+(d-b)|0;i[b>>0]=i[228437]|0;i[b+1>>0]=i[228438]|0;i[b+2>>0]=i[228439]|0;i[b+3>>0]=i[228440]|0;i[b+4>>0]=i[228441]|0;i[b+5>>0]=i[228442]|0}if((f&12288|0)==4096){b=h;b:do if(!(b&3)){d=h;g=25}else{e=h;d=b;while(1){if(!(i[e>>0]|0))break b;e=e+1|0;d=e;if(!(d&3)){d=e;g=25;break}}}while(0);if((g|0)==25){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}b=h+(d-b)|0;i[b>>0]=i[228443]|0;i[b+1>>0]=i[228444]|0;i[b+2>>0]=i[228445]|0;i[b+3>>0]=i[228446]|0;i[b+4>>0]=i[228447]|0;i[b+5>>0]=i[228448]|0;i[b+6>>0]=i[228449]|0}if((f&4095|0)==0?(k[c+28>>2]|0)!=1:0){b=h;c:do if(!(b&3)){d=h;g=36}else{d=h;e=b;while(1){if(!(i[d>>0]|0)){d=e;break c}d=d+1|0;e=d;if(!(e&3)){g=36;break}}}while(0);if((g|0)==36){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}d=h+(d-b)|0;e=228450;b=d+9|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(b|0))}i6(a,227233,h+((i[h>>0]|0)!=0&1)|0,1);p6(a,367797,k[c+24>>2]|0);i6(a,225918,j,0);r6(a,c,l,56);g6(a,225921,13,0);e=c+52|0;d=k[e>>2]|0;if(!d){_4(a);_4(a);r=m;return}while(1){h6(a,k[d+16>>2]|0,k[d+12>>2]|0,j);if((d|0)==(k[k[e>>2]>>2]|0)){g=45;break}d=k[d+4>>2]|0;if(!d){g=45;break}}if((g|0)==45){_4(a);_4(a);r=m;return}}function u6(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;l=m;d=(a|0)!=0;if(!(d?(k[a>>2]|0)==1280131417:0)){d=d?-5:-27;e=l+4|0;f=ZT(36)|0;k[f>>2]=1;g=f+4|0;k[l>>2]=g;k[e>>2]=31;i[f+35>>0]=0;h=221977;j=g+31|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(d,l,228742,221854,2957);k[e>>2]=0;k[l>>2]=0;j=k[f>>2]|0;k[f>>2]=j+-1;if((j|0)==1)ggb(k[f+-4>>2]|0)}if(k[a+8>>2]|0){l=a+240|0;l=k[l>>2]|0;Rh[l&63](a,b,c);r=m;return}d=l+4|0;e=ZT(44)|0;k[e>>2]=1;g=e+4|0;k[l>>2]=g;k[d>>2]=38;i[e+42>>0]=0;h=222026;j=g+38|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-2,l,228742,221854,2957);k[d>>2]=0;k[l>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0);l=a+240|0;l=k[l>>2]|0;Rh[l&63](a,b,c);r=m;return}function v6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;c=(a|0)!=0;if(!(c?(k[a>>2]|0)==1280131417:0)){c=c?-5:-27;d=j+4|0;e=ZT(36)|0;k[e>>2]=1;f=e+4|0;k[j>>2]=f;k[d>>2]=31;i[e+35>>0]=0;g=221977;h=f+31|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(c,j,228754,221854,2973);k[d>>2]=0;k[j>>2]=0;h=k[e>>2]|0;k[e>>2]=h+-1;if((h|0)==1)ggb(k[e+-4>>2]|0)}if(k[a+8>>2]|0){j=a+248|0;j=k[j>>2]|0;Ph[j&511](a,b,1);r=l;return}c=j+4|0;d=ZT(44)|0;k[d>>2]=1;f=d+4|0;k[j>>2]=f;k[c>>2]=38;i[d+42>>0]=0;g=222026;h=f+38|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,j,228754,221854,2973);k[c>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);j=a+248|0;j=k[j>>2]|0;Ph[j&511](a,b,1);r=l;return}function w6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+16|0;p=q+8|0;o=q;f=(a|0)!=0;if(!(f?(k[a>>2]|0)==1280131417:0)){h=f?-5:-27;f=p+4|0;g=ZT(36)|0;k[g>>2]=1;l=g+4|0;k[p>>2]=l;k[f>>2]=31;i[g+35>>0]=0;m=221977;n=l+31|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(h,p,228832,221854,4993);k[f>>2]=0;k[p>>2]=0;n=k[g>>2]|0;k[g>>2]=n+-1;if((n|0)==1)ggb(k[g+-4>>2]|0)}if(!(k[a+8>>2]|0)){f=p+4|0;g=ZT(44)|0;k[g>>2]=1;l=g+4|0;k[p>>2]=l;k[f>>2]=38;i[g+42>>0]=0;m=222026;n=l+38|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-2,p,228832,221854,4993);k[f>>2]=0;k[p>>2]=0;n=k[g>>2]|0;k[g>>2]=n+-1;if((n|0)==1)ggb(k[g+-4>>2]|0)}a:do if(c){f=k[107193]|0;if(!f)j=17;else while(1){if(Xh[k[f+20>>2]&1023](c)|0)break a;f=k[f+12>>2]|0;if(!f){j=17;break}}}else{f=p+4|0;g=ZT(40)|0;k[g>>2]=1;l=g+4|0;k[p>>2]=l;k[f>>2]=34;i[g+38>>0]=0;m=228840;n=l+34|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-27,p,228832,221854,4996);k[f>>2]=0;k[p>>2]=0;n=k[g>>2]|0;k[g>>2]=n+-1;if((n|0)==1)ggb(k[g+-4>>2]|0);j=17}while(0);if((j|0)==17){f=p+4|0;g=ZT(20)|0;k[g>>2]=1;l=g+4|0;k[p>>2]=l;k[f>>2]=14;i[g+18>>0]=0;m=228875;n=l+14|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-5,p,228832,221854,5e3);k[f>>2]=0;k[p>>2]=0;n=k[g>>2]|0;k[g>>2]=n+-1;if((n|0)==1)ggb(k[g+-4>>2]|0);f=0}h=f+32|0;f=k[h>>2]|0;if(f|0){n=f;k[o>>2]=d;m=o+4|0;k[m>>2]=e;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];dh[n&255](a,b,c,p);r=q;return}f=p+4|0;g=ZT(44)|0;k[g>>2]=1;l=g+4|0;k[p>>2]=l;k[f>>2]=39;i[g+43>>0]=0;m=228890;n=l+39|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-5,p,228832,221854,5003);k[f>>2]=0;k[p>>2]=0;n=k[g>>2]|0;k[g>>2]=n+-1;if((n|0)==1)ggb(k[g+-4>>2]|0);n=k[h>>2]|0;k[o>>2]=d;m=o+4|0;k[m>>2]=e;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];dh[n&255](a,b,c,p);r=q;return}function x6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;k[a>>2]=49564;f=a+8|0;g=a+4+8|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g+16>>2]=0;g=a+4|0;k[g>>2]=0;k[f>>2]=0;h=a+32|0;k[h>>2]=0;e=k[b>>2]|0;if(!(k[d+4>>2]|0))b=0;else{b=k[d>>2]|0;b=(b|0)==0?1016759:b}e=a5((e|0)==0?1016759:e,c,b)|0;if(!e)b=0;else{while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b+4>>2]=1;k[b>>2]=49596;k[b+8>>2]=e}d=k[g>>2]|0;k[g>>2]=b;k[f>>2]=e;if(d|0?(f=d+4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);g=Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0;k[h>>2]=g?6:0;return}function y6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;h=l;if(!(Xh[k[(k[b>>2]|0)+12>>2]&1023](b)|0)){j=0;h=0;k[a>>2]=h;a=a+4|0;k[a>>2]=j;r=l;return}j=k[b+8>>2]|0;b=(j|0)!=0;if(!(b?(k[j>>2]|0)==1280131417:0)){b=b?-5:-27;c=h+4|0;d=ZT(36)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=31;i[d+35>>0]=0;f=221977;g=e+31|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(b,h,228724,221854,772);k[c>>2]=0;k[h>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}e=k[j+32>>2]|0;if(!e){h=0;k[a>>2]=j;a=a+4|0;k[a>>2]=h;r=l;return}c=k[e+24>>2]|0;if(!c){h=0;k[a>>2]=j;a=a+4|0;k[a>>2]=h;r=l;return}b=k[e+52>>2]|0;if((c|0)>=0){d=k[b+12>>2]|0;if((d|0)>0)c=0;else{c=0;do{b=k[b+4>>2]|0;c=c-d|0;d=k[b+12>>2]|0}while((c|0)>=(d|0))}}else{do{b=k[b>>2]|0;c=c-(k[b+12>>2]|0)|0}while((c|0)>0);c=0-c|0}h=(k[b+16>>2]|0)+(aa(k[e+28>>2]|0,c)|0)|0;k[a>>2]=j;a=a+4|0;k[a>>2]=h;r=l;return}function z6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+32|0;f=q+16|0;h=q+8|0;g=q;j=q+24|0;o=k[b>>2]|0;o=(o|0)==0?1016759:o;if(!((Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)&(o|0)!=0)){r=q;return a|0}e=i[o>>0]|0;switch(e<<24>>24){case 93:case 125:{f=a+20|0;b=a+24|0;c=k[b>>2]|0;if((k[f>>2]|0)==(c|0)){k[g>>2]=e<<24>>24;$8(j,229061,g);Y8(-2,j,401251,221854,5208);c=k[j>>2]|0;k[j+4>>2]=0;k[j>>2]=0;if(c|0?(n=c+-4|0,p=k[n>>2]|0,k[n>>2]=p+-1,(p|0)==1):0)ggb(k[c+-8>>2]|0);e=i[o>>0]|0;c=k[b>>2]|0}d=i[c+-1>>0]|0;if(((e<<24>>24==93?91:123)|0)!=(d|0)){k[h>>2]=e<<24>>24;k[h+4>>2]=d;$8(j,229080,h);Y8(-2,j,401251,221854,5211);c=k[j>>2]|0;k[j+4>>2]=0;k[j>>2]=0;if(c|0?(o=c+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[c+-8>>2]|0);c=k[b>>2]|0}p=c+-1|0;k[b>>2]=p;if((k[f>>2]|0)==(p|0))c=6;else c=(i[c+-2>>0]|0)==123?6:1;k[a+32>>2]=c;_4(k[a+8>>2]|0);c=a+12|0;d=k[c>>2]|0;e=a+16|0;k[e>>2]=0;k[c>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);k[c>>2]=0;k[e>>2]=0;r=q;return a|0}default:{}}p=a+32|0;c=k[p>>2]|0;if((c|0)==6){if((((e&-33)+-65&255)>=26?(k[f>>2]=o,$8(j,229129,f),Y8(-2,j,401251,221854,5221),d=k[j>>2]|0,k[j+4>>2]=0,k[j>>2]=0,d|0):0)?(n=d+-4|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0)ggb(k[d+-8>>2]|0);d=a+12|0;if((d|0)!=(b|0)){c=k[d>>2]|0;e=a+16|0;k[e>>2]=0;k[d>>2]=0;if(c|0?(n=c+-4|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0)ggb(k[c+-8>>2]|0);c=k[b>>2]|0;if(!c)c=0;else{c=c+-4|0;k[c>>2]=(k[c>>2]|0)+1;c=k[b>>2]|0}k[d>>2]=c;k[e>>2]=k[b+4>>2]}k[p>>2]=5;r=q;return a|0}if((c&3|0)!=1){c=j+4|0;d=ZT(24)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=16;i[d+20>>0]=0;f=229155;g=e+16|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-2,j,401251,221854,5251);k[c>>2]=0;k[j>>2]=0;p=k[d>>2]|0;k[d>>2]=p+-1;if((p|0)==1)ggb(k[d+-4>>2]|0);r=q;return a|0}a:do switch(e<<24>>24){case 91:case 123:{m=a+24|0;c=k[m>>2]|0;n=a+28|0;l=k[n>>2]|0;d=l;if((c|0)==(l|0)){j=a+20|0;l=k[j>>2]|0;b=c-l|0;c=b+1|0;if((c|0)<0)ad(426534,426557,304,426811);h=l;f=d-l|0;g=f<<1;g=f>>>0<1073741823?(g>>>0<c>>>0?c:g):2147483647;if(!g)c=0;else{while(1){c=fgb(g)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=i[o>>0]|0}f=c+b|0;i[f>>0]=e;d=f+(0-b)|0;if((b|0)>0)upb(d|0,h|0,b|0)|0;k[j>>2]=d;k[m>>2]=f+1;k[n>>2]=c+g;if(l|0)ggb(h)}else{i[c>>0]=e;k[m>>2]=(k[m>>2]|0)+1}c=o+1|0;e=(i[o>>0]|0)==123;b=e?6:5;k[p>>2]=e?6:1;e=(i[c>>0]|0)==58;c=e?o+2|0:c;f=a+12|0;g=a+16|0;if(!(k[g>>2]|0))d=0;else{d=k[f>>2]|0;d=(d|0)==0?1016759:d}g6(k[a+8>>2]|0,d,e?b|8:b,i[c>>0]|0?c:0);c=k[f>>2]|0;k[g>>2]=0;k[f>>2]=0;if(c|0?(o=c+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[c+-8>>2]|0);k[f>>2]=0;k[g>>2]=0;r=q;return a|0}case 92:{g=o+1|0;c=i[g>>0]|0;switch(c<<24>>24){case 93:case 91:case 125:case 123:break;default:{l=65;break a}}f=g;b:do if(!(f&3)){c=g;l=59}else{e=g;d=c;c=f;while(1){if(!(d<<24>>24))break b;d=e+1|0;c=d;if(!(c&3)){c=d;l=59;break b}e=d;d=i[d>>0]|0}}while(0);if((l|0)==59){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}o=c-f|0;c=ZT(o+8&-4)|0;k[c>>2]=1;c=c+4|0;i[c+o>>0]=0;upb(c|0,g|0,o|0)|0;break}default:l=65}while(0);if((l|0)==65){c=k[b>>2]|0;if(!c)c=0;else{o=c+-4|0;k[o>>2]=(k[o>>2]|0)+1}}if(!(k[a+16>>2]|0))d=0;else{d=k[a+12>>2]|0;d=(d|0)==0?1016759:d}i6(k[a+8>>2]|0,d,(c|0)==0?1016759:c,0);d=c;if(c|0?(n=d+-4|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0)ggb(k[d+-8>>2]|0);if((k[p>>2]|0)!=5){r=q;return a|0}k[p>>2]=6;r=q;return a|0}function A6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;m=n;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=n;return}e=k[b>>2]|0;f=(e|0)==0?1016759:e;g=i[f>>0]|0;if((g+-48&255)<10){f=i[f+1>>0]|0;g=(g<<24>>24)+-48|0}else{f=g;g=1}a:do switch(f<<24>>24){case 99:case 117:{f=1;break}default:{switch(f<<24>>24){case 115:case 119:{f=2;break a}default:{}}switch(f<<24>>24){case 102:case 105:{f=4;break a}default:{}}if(f<<24>>24==100)f=8;else f=f<<24>>24==114?4:0}}while(0);l=aa(f,g)|0;if((d>>>0)%(l>>>0)|0){e=m+4|0;f=ZT(24)|0;k[f>>2]=1;g=f+4|0;k[m>>2]=g;k[e>>2]=19;i[f+23>>0]=0;h=229172;j=g+19|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,m,229192,221854,5262);k[e>>2]=0;k[m>>2]=0;m=k[f>>2]|0;k[f>>2]=m+-1;if((m|0)==1)ggb(k[f+-4>>2]|0);e=k[b>>2]|0}h6(k[a+8>>2]|0,c,(d>>>0)/(l>>>0)|0,(e|0)==0?1016759:e);r=n;return}function B6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;if((b|0)!=0&(c|0)!=0?(e=k[c>>2]|0,f=e&7,f|0):0){k[a>>2]=b;g=a+4|0;k[g>>2]=c;if((f+-5|0)>>>0<2&(e&16|0)==0){e=c+8|0;KY(k[e>>2]|0,a+8|0);b=k[c>>2]|0;switch(b&7){case 6:{b=k[(k[e>>2]|0)+60>>2]|0;break}case 5:{b=k[(k[e>>2]|0)+24>>2]|0;break}default:b=(b&7|0)!=0&1}k[a+40>>2]=b;f=b}else{k[a+20>>2]=c;k[a+12>>2]=0;k[a+40>>2]=1;f=1}if(!d)return;if((d|0)>0)b=(f|0)<(d|0)?f:d;else{b=k[g>>2]|0;a:do if(!b){b=1;h=18}else{e=k[b>>2]|0;switch(e&7){case 6:{b=k[(k[b+8>>2]|0)+60>>2]|0;break a}case 5:{b=k[(k[b+8>>2]|0)+24>>2]|0;break a}default:{b=(e&7|0)==0;h=18;break a}}}while(0);if((h|0)==18)b=b&1^1;h=f-d|0;b=f-(b>>>0<h>>>0?b:h)|0}k[a+40>>2]=f-b;if(!(k[a+12>>2]|0))return;LY(a+8|0,b,1);return}k[a>>2]=0;k[a+4>>2]=0;k[a+20>>2]=0;k[a+40>>2]=0;return}function C6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+16|0;l=p;f=k[a>>2]|0;if(!f){r=p;return a|0}n=a+4|0;if(!(k[n>>2]|0)){r=p;return a|0}o=a+40|0;j=k[o>>2]|0;if(!j){r=p;return a|0}g=k[b>>2]|0;h=(g|0)==0?1016759:g;e=i[h>>0]|0;if((e+-48&255)<10){m=(e<<24>>24)+-48|0;e=i[h+1>>0]|0}else m=1;a:do switch(e<<24>>24){case 99:case 117:{e=1;break}default:{switch(e<<24>>24){case 115:case 119:{e=2;break a}default:{}}switch(e<<24>>24){case 102:case 105:{e=4;break a}default:{}}if(e<<24>>24==100)e=8;else e=e<<24>>24==114?4:0}}while(0);if(!(aa(e,m)|0)){e=l+4|0;f=ZT(20)|0;k[f>>2]=1;g=f+4|0;k[l>>2]=g;k[e>>2]=13;i[f+17>>0]=0;h=229201;j=g+13|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,l,229215,221854,5435);k[e>>2]=0;k[l>>2]=0;l=k[f>>2]|0;k[f>>2]=l+-1;if((l|0)==1)ggb(k[f+-4>>2]|0);e=k[o>>2]|0;g=k[b>>2]|0;f=k[a>>2]|0}else e=j;e=e>>>0>d>>>0?d:e;if(!(k[a+12>>2]|0)){l6(f,k[n>>2]|0,c,(g|0)==0?1016759:g);e=0}else{o6(f,a+8|0,e,c,(g|0)==0?1016759:g);e=aa(e,m)|0;e=(k[o>>2]|0)-e|0}k[o>>2]=e;r=p;return a|0}function D6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=r;r=r+288|0;g=h;d=c+4|0;e=k[d>>2]|0;if((e|0)<3){i=k[c+8>>2]|0;d=(e|0)==1?1:k[c+12>>2]|0;f=k[c>>2]|0;e=f&4095;j=k[c+16>>2]|0;l=aa((f>>>3&511)+1<<(47696>>>(e<<1&14)&3),d)|0;k[g>>2]=e|1111638016;e=g+4|0;k[e>>2]=l;k[g+8>>2]=0;k[g+12>>2]=0;k[g+16>>2]=j;k[g+20>>2]=i;k[g+24>>2]=d;k[e>>2]=k[k[c+44>>2]>>2];k[g>>2]=f&20479|1111621632;if(!(k[b+4>>2]|0))d=0;else{d=k[b>>2]|0;d=(d|0)==0?1016759:d}w6(k[a+8>>2]|0,d,g,0,0);r=h;return}D9(g,e,k[c+40>>2]|0,k[c>>2]&4095,k[c+16>>2]|0)|0;e=k[d>>2]|0;if((e|0)>0){f=k[c+44>>2]|0;d=0;do{k[g+20+(d<<3)+4>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)!=(e|0))}k[g>>2]=k[g>>2]|k[c>>2]&16384;if(!(k[b+4>>2]|0))d=0;else{d=k[b>>2]|0;d=(d|0)==0?1016759:d}w6(k[a+8>>2]|0,d,g,0,0);r=h;return}function E6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0;k[a>>2]=b;g6(k[b+8>>2]|0,(d|0)==0?0:(c|0)==0?1016759:c,e,(g|0)==0?0:(f|0)==0?1016759:f);d=k[a>>2]|0;c=d+12|0;f=k[c>>2]|0;d=d+16|0;k[d>>2]=0;k[c>>2]=0;if(f|0?(j=f+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[f+-8>>2]|0);k[c>>2]=0;k[d>>2]=0;d=k[a>>2]|0;c=d+32|0;if((e&7|0)==5){k[c>>2]=1;j=d+24|0;c=k[j>>2]|0;l=d+28|0;f=k[l>>2]|0;if((c|0)!=(f|0)){i[c>>0]=91;k[j>>2]=(k[j>>2]|0)+1;return}e=d+20|0;h=k[e>>2]|0;b=c-h|0;c=b+1|0;if((c|0)<0)ad(426534,426557,304,426811);a=h;d=f-h|0;g=d<<1;g=d>>>0<1073741823?(g>>>0<c>>>0?c:g):2147483647;a:do if(!g)c=0;else while(1){c=fgb(g)|0;if(c|0)break a;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break a}Qh[c&7]()}while(0);f=c+b|0;i[f>>0]=91;d=f+(0-b)|0;if((b|0)>0)upb(d|0,a|0,b|0)|0;k[e>>2]=d;k[j>>2]=f+1;k[l>>2]=c+g;if(!h)return;ggb(a);return}else{k[c>>2]=6;j=d+24|0;c=k[j>>2]|0;l=d+28|0;f=k[l>>2]|0;if((c|0)!=(f|0)){i[c>>0]=123;k[j>>2]=(k[j>>2]|0)+1;return}e=d+20|0;h=k[e>>2]|0;b=c-h|0;c=b+1|0;if((c|0)<0)ad(426534,426557,304,426811);a=h;d=f-h|0;g=d<<1;g=d>>>0<1073741823?(g>>>0<c>>>0?c:g):2147483647;b:do if(!g)c=0;else while(1){c=fgb(g)|0;if(c|0)break b;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break b}Qh[c&7]()}while(0);f=c+b|0;i[f>>0]=123;d=f+(0-b)|0;if((b|0)>0)upb(d|0,a|0,b|0)|0;k[e>>2]=d;k[j>>2]=f+1;k[l>>2]=c+g;if(!h)return;ggb(a);return}}function F6(a){a=a|0;var b=0,c=0,d=0,e=0;_4(k[(k[a>>2]|0)+8>>2]|0);d=k[a>>2]|0;b=d+24|0;a=k[b>>2]|0;c=a+-1|0;k[b>>2]=c;if((k[d+20>>2]|0)==(c|0))a=6;else a=(i[a+-2>>0]|0)==123?6:1;k[d+32>>2]=a;b=d+12|0;c=k[b>>2]|0;a=d+16|0;k[a>>2]=0;k[b>>2]=0;if(!c){k[b>>2]=0;k[a>>2]=0;return}e=c+-4|0;d=k[e>>2]|0;k[e>>2]=d+-1;if((d|0)!=1){k[b>>2]=0;k[a>>2]=0;return}ggb(k[c+-8>>2]|0);k[b>>2]=0;k[a>>2]=0;return}function G6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+144|0;g=l+120|0;j=l;e=l+64|0;f=l+8|0;if(!b){j=g+4|0;h=j+4|0;k[h>>2]=0;k[h+4>>2]=0;k[g>>2]=33619968;k[j>>2]=c;mY(d,g);r=l;return}b=s6(a,b)|0;k[j>>2]=b;a:do if(!b)h=46;else{a=k[b>>2]&-65536;b:do if((a|0)<1111687168){switch(a|0){case 1111621632:break;default:break b}if((k[b+24>>2]|0)>-1?(k[b+20>>2]|0)>-1:0){M1(e,b,0,1,0,0);d=g+4|0;a=d+4|0;k[a>>2]=0;k[a+4>>2]=0;k[g>>2]=33619968;k[d>>2]=c;mY(e,g);d=e+36|0;a=k[d>>2]|0;if(a|0?(f=a+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[e+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;g=e+16|0;b=e+4|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[b>>2]|0)>0){d=k[e+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[e+44>>2]|0;if(!((a|0)==(e+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);B9(j);break a}}else{switch(a|0){case 1111687168:break;default:break b}M1(f,b,0,1,0,0);d=g+4|0;a=d+4|0;k[a>>2]=0;k[a+4>>2]=0;k[g>>2]=33619968;k[d>>2]=c;mY(f,g);d=f+36|0;a=k[d>>2]|0;if(a|0?(e=a+12|0,g=k[e>>2]|0,k[e>>2]=g+-1,(g|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[f+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;g=f+16|0;b=f+4|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[b>>2]|0)>0){d=k[f+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[f+44>>2]|0;if(!((a|0)==(f+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);B9(j);break a}while(0);a=k[107193]|0;c:do if(!a)h=38;else while(1){if(Xh[k[a+20>>2]&1023](b)|0)break c;a=k[a+12>>2]|0;if(!a){h=38;break}}while(0);if((h|0)==38){a=g+4|0;b=ZT(24)|0;k[b>>2]=1;c=b+4|0;k[g>>2]=c;k[a>>2]=19;i[b+23>>0]=0;e=228779;f=c+19|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));Y8(-2,g,228769,221854,4936);k[a>>2]=0;k[g>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0);a=0}d=a+24|0;a=k[d>>2]|0;if(!a){a=g+4|0;b=ZT(40)|0;k[b>>2]=1;c=b+4|0;k[g>>2]=c;k[a>>2]=32;i[b+36>>0]=0;e=228799;f=c+32|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));Y8(-2,g,228769,221854,4938);k[a>>2]=0;k[g>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0);a=k[d>>2]|0}Uh[a&2047](j);k[j>>2]=0;h=46}while(0);if((h|0)==46){a=g+4|0;b=ZT(24)|0;k[b>>2]=1;c=b+4|0;k[g>>2]=c;k[a>>2]=18;i[b+22>>0]=0;e=229223;f=c+18|0;do{i[c>>0]=i[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(f|0));Y8(-5,g,401059,221854,5550);k[a>>2]=0;k[g>>2]=0;j=k[b>>2]|0;k[b>>2]=j+-1;if((j|0)==1)ggb(k[b+-4>>2]|0)}r=l;return}function H6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=a+4|0;c=k[n>>2]|0;d=k[a>>2]|0;i=(c-d|0)/28|0;e=i+1|0;if(e>>>0>153391689)ad(426534,426557,304,426811);l=d;j=c;m=a+8|0;h=((k[m>>2]|0)-d|0)/28|0;f=h<<1;f=h>>>0<76695844?(f>>>0<e>>>0?e:f):153391689;if(!f)e=0;else{if(f>>>0>153391689){n=te(4)|0;k[n>>2]=172664;Cf(n|0,28816,1287)}e=f*28|0;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d}g=e+(i*28|0)|0;d=g;h=e+(f*28|0)|0;k[g>>2]=k[b>>2];k[e+(i*28|0)+4>>2]=k[b+4>>2];f=e+(i*28|0)+8|0;i=b+8|0;k[f>>2]=k[i>>2];k[f+4>>2]=k[i+4>>2];k[f+8>>2]=k[i+8>>2];k[f+12>>2]=k[i+12>>2];k[f+16>>2]=k[i+16>>2];f=g+28|0;if((j|0)!=(l|0)){e=j;c=g;do{i=e;e=e+-28|0;k[c+-28>>2]=k[e>>2];k[c+-24>>2]=k[i+-24>>2];j=c+-20|0;i=i+-20|0;k[j>>2]=k[i>>2];k[j+4>>2]=k[i+4>>2];k[j+8>>2]=k[i+8>>2];k[j+12>>2]=k[i+12>>2];k[j+16>>2]=k[i+16>>2];c=d+-28|0;d=c}while((e|0)!=(l|0));c=k[a>>2]|0}k[a>>2]=d;k[n>>2]=f;k[m>>2]=h;if(!c)return;ggb(c);return}function I6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>4;c=g+1|0;if(c>>>0>268435455)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>3;f=e>>4>>>0<134217727?(f>>>0<c>>>0?c:f):268435455;if(!f)c=0;else{if(f>>>0>268435455){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<4;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<4)|0;k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2];k[e+12>>2]=k[b+12>>2];d=e+(0-g<<4)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+16;k[l>>2]=c+(f<<4);if(!i)return;ggb(i);return}function J6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;d=j;do if(!a){a=k[c>>2]|0;k[d>>2]=a;k[d+4>>2]=k[c+4>>2];if(a|0){h=a+-4|0;k[h>>2]=(k[h>>2]|0)+1}}else{if((k[a>>2]&7|0)!=3){k[d>>2]=0;k[d+4>>2]=0;break}f=k[a+8+4>>2]|0;k[d>>2]=0;g=d+4|0;k[g>>2]=0;if(f|0){h=f;a:do if(!(h&3)){a=f;e=9}else{a=f;c=h;while(1){if(!(i[a>>0]|0)){a=c;break a}a=a+1|0;c=a;if(!(c&3)){e=9;break}}}while(0);if((e|0)==9){while(1){c=k[a>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))a=a+4|0;else break}if((c&255)<<24>>24)do a=a+1|0;while((i[a>>0]|0)!=0)}h=a-h|0;e=ZT(h+8&-4)|0;k[e>>2]=1;e=e+4|0;k[d>>2]=e;k[g>>2]=h;i[e+h>>0]=0;upb(k[d>>2]|0,f|0,h|0)|0}}while(0);if((d|0)==(b|0)){c=d+4|0;a=k[b>>2]|0}else{a=k[b>>2]|0;e=b+4|0;k[e>>2]=0;k[b>>2]=0;if(a|0?(g=a+-4|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0)ggb(k[a+-8>>2]|0);a=k[d>>2]|0;if(!a)c=0;else{a=a+-4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[d>>2]|0;c=a}k[b>>2]=c;c=d+4|0;k[e>>2]=k[c>>2]}k[c>>2]=0;k[d>>2]=0;if(!a){r=j;return}h=a+-4|0;b=k[h>>2]|0;k[h>>2]=b+-1;if((b|0)!=1){r=j;return}ggb(k[a+-8>>2]|0);r=j;return}function K6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,q=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,$=0.0,ba=0.0,ca=0,da=0;Y=r;r=r+2528|0;H=Y+2464|0;X=Y+2408|0;W=Y+2352|0;V=Y+2296|0;U=Y+1096|0;P=Y+2224|0;w=Y+2288|0;z=Y+2280|0;S=Y+2192|0;T=Y;do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[X>>2]=k[j>>2];q=X+4|0;b=j+4|0;k[q>>2]=k[b>>2];O=X+8|0;k[O>>2]=k[j+8>>2];k[X+12>>2]=k[j+12>>2];k[X+16>>2]=k[j+16>>2];k[X+20>>2]=k[j+20>>2];k[X+24>>2]=k[j+24>>2];k[X+28>>2]=k[j+28>>2];k[X+32>>2]=k[j+32>>2];f=k[j+36>>2]|0;k[X+36>>2]=f;g=X+40|0;k[g>>2]=O;O=X+48|0;m=X+44|0;k[m>>2]=O;k[X+52>>2]=0;k[O>>2]=0;if(f|0){O=f+12|0;k[O>>2]=(k[O>>2]|0)+1}if((k[b>>2]|0)<3){M=k[j+44>>2]|0;O=k[m>>2]|0;k[O>>2]=k[M>>2];k[O+4>>2]=k[M+4>>2];break}k[q>>2]=0;x1(X,k[b>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[j+40>>2]|0;l=k[g>>2]|0;g=k[j+44>>2]|0;f=k[m>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[n+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else Q1(X,b,-1);while(0);do if((k[d>>2]&2031616|0)==65536){l=k[d+4>>2]|0;k[W>>2]=k[l>>2];q=W+4|0;f=l+4|0;k[q>>2]=k[f>>2];O=W+8|0;k[O>>2]=k[l+8>>2];k[W+12>>2]=k[l+12>>2];k[W+16>>2]=k[l+16>>2];k[W+20>>2]=k[l+20>>2];k[W+24>>2]=k[l+24>>2];k[W+28>>2]=k[l+28>>2];k[W+32>>2]=k[l+32>>2];b=k[l+36>>2]|0;k[W+36>>2]=b;g=W+40|0;k[g>>2]=O;O=W+48|0;m=W+44|0;k[m>>2]=O;k[W+52>>2]=0;k[O>>2]=0;if(b|0){O=b+12|0;k[O>>2]=(k[O>>2]|0)+1}if((k[f>>2]|0)<3){M=k[l+44>>2]|0;O=k[m>>2]|0;k[O>>2]=k[M>>2];k[O+4>>2]=k[M+4>>2];break}k[q>>2]=0;x1(W,k[f>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[l+40>>2]|0;j=k[g>>2]|0;g=k[l+44>>2]|0;f=k[m>>2]|0;b=0;do{k[j+(b<<2)>>2]=k[n+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else Q1(W,d,-1);while(0);do if((k[e>>2]&2031616|0)==65536){j=k[e+4>>2]|0;k[V>>2]=k[j>>2];q=V+4|0;b=j+4|0;k[q>>2]=k[b>>2];O=V+8|0;k[O>>2]=k[j+8>>2];k[V+12>>2]=k[j+12>>2];k[V+16>>2]=k[j+16>>2];k[V+20>>2]=k[j+20>>2];k[V+24>>2]=k[j+24>>2];k[V+28>>2]=k[j+28>>2];k[V+32>>2]=k[j+32>>2];f=k[j+36>>2]|0;k[V+36>>2]=f;g=V+40|0;k[g>>2]=O;O=V+48|0;m=V+44|0;k[m>>2]=O;k[V+52>>2]=0;k[O>>2]=0;if(f|0){O=f+12|0;k[O>>2]=(k[O>>2]|0)+1}if((k[b>>2]|0)<3){M=k[j+44>>2]|0;O=k[m>>2]|0;k[O>>2]=k[M>>2];k[O+4>>2]=k[M+4>>2];break}k[q>>2]=0;x1(V,k[b>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[j+40>>2]|0;l=k[g>>2]|0;g=k[j+44>>2]|0;f=k[m>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[n+(b<<2)>>2];k[f+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[q>>2]|0))}}else Q1(V,e,-1);while(0);G=k[X>>2]|0;E=G&7;G=G>>>3&511;K=G+1|0;L=U+8|0;k[U>>2]=L;M=U+4|0;k[M>>2]=136;f=k[W>>2]|0;do if(!(f&4088)){g=k[W+8>>2]|0;b=k[W+12>>2]|0;if((g|0)!=1)if((b|0)==1)b=1;else{R=34;break}O=g+-1+b|0;if(!((O|0)==(K|0)|(O|0)==1)){O=k[W+40>>2]|0;if(!(((k[O>>2]|0)==4?(k[O+4>>2]|0)==1:0)?K>>>0<5&(f&4095|0)==6:0))R=34}}else R=34;while(0);if((R|0)==34?(k[H>>2]=0,O=H+4|0,k[O>>2]=0,t=ZT(228)|0,k[t>>2]=1,J=t+4|0,k[H>>2]=J,k[O>>2]=223,i[t+227>>0]=0,upb(J|0,229242,223)|0,Y8(-215,H,229466,229471,493),k[O>>2]=0,k[H>>2]=0,O=k[t>>2]|0,k[t>>2]=O+-1,(O|0)==1):0)ggb(k[t+-4>>2]|0);do if(!(k[V>>2]&4088)){f=k[V+8>>2]|0;b=k[V+12>>2]|0;if((f|0)!=1){if((b|0)==1){b=1;R=40}}else R=40;if((R|0)==40){O=f+-1+b|0;if((O|0)==(K|0)|(O|0)==1)break;O=k[W+40>>2]|0;if(((k[O>>2]|0)==4?(k[O+4>>2]|0)==1:0)?(K>>>0<5?(k[W>>2]&4095|0)==6:0):0)break}if(!((f|0)==(K|0)?(c|0)==1&(b|0)==(K|0):0))R=45}else R=45;while(0);if((R|0)==45?(k[H>>2]=0,O=H+4|0,k[O>>2]=0,v=ZT(300)|0,k[v>>2]=1,J=v+4|0,k[H>>2]=J,k[O>>2]=295,i[v+299>>0]=0,upb(J|0,229534,295)|0,Y8(-215,H,229466,229471,498),k[O>>2]=0,k[H>>2]=0,O=k[v>>2]|0,k[v>>2]=O+-1,(O|0)==1):0)ggb(k[v+-4>>2]|0);O=W+4|0;g=k[O>>2]|0;if((g|0)<3)C=aa(k[W+12>>2]|0,k[W+8>>2]|0)|0;else{j=k[W+40>>2]|0;f=0;b=1;do{b=aa(k[j+(f<<2)>>2]|0,b)|0;f=f+1|0}while((f|0)!=(g|0));C=b}J=V+4|0;g=k[J>>2]|0;if((g|0)<3)B=aa(k[V+12>>2]|0,k[V+8>>2]|0)|0;else{j=k[V+40>>2]|0;f=0;b=1;do{b=aa(k[j+(f<<2)>>2]|0,b)|0;f=f+1|0}while((f|0)!=(g|0));B=b}I=(c|0)==0;do if(I){g=C+(K<<3)+B|0;if((k[M>>2]|0)>>>0<g>>>0){b=k[U>>2]|0;if((b|0)!=(L|0)){if(b|0)ggb(b);k[U>>2]=L;k[M>>2]=136}if(g>>>0>136){f=g>>>0>536870911?-1:g<<3;f=(f|0)==0?1:f;while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[U>>2]=b;k[M>>2]=g}else b=L}else{k[M>>2]=g;b=k[U>>2]|0}n=k[V+16>>2]|0;F=k[W>>2]|0;if((F&16384|0)!=0?(C|0)==(K|0)&(F&4095|0)==6:0)t=k[W+16>>2]|0;else{F=k[W+40>>2]|0;f=k[F+4>>2]|0;F=k[F>>2]|0;k[P>>2]=1124007942;c=P+4|0;k[c>>2]=2;q=P+8|0;k[q>>2]=F;j=P+12|0;k[j>>2]=f;t=P+16|0;k[t>>2]=b;m=P+20|0;k[m>>2]=b;d=P+24|0;e=P+28|0;v=P+40|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[v>>2]=q;A=P+48|0;w=P+44|0;k[w>>2]=A;k[P+52>>2]=0;k[A>>2]=0;if((b|0)==0&(aa(F,f)|0)!=0){k[H>>2]=0;f=H+4|0;k[f>>2]=0;g=ZT(36)|0;k[g>>2]=1;x=g+4|0;k[H>>2]=x;k[f>>2]=28;i[g+32>>0]=0;y=390609;z=x+28|0;do{i[x>>0]=i[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));Y8(-215,H,390638,390642,443);k[f>>2]=0;k[H>>2]=0;F=k[g>>2]|0;k[g>>2]=F+-1;if((F|0)==1)ggb(k[g+-4>>2]|0);f=k[j>>2]|0;j=k[P>>2]|0;l=k[w>>2]|0;g=k[m>>2]|0}else{j=1124007942;l=A;g=b}F=f<<3;k[P>>2]=j|16384;k[l>>2]=F;k[l+4>>2]=8;D=g+(aa(k[q>>2]|0,F)|0)|0;k[e>>2]=D;k[d>>2]=D+(0-F)+F;F=H+4|0;D=F+4|0;k[D>>2]=0;k[D+4>>2]=0;k[H>>2]=33619968;k[F>>2]=P;SW(W,H,6,1.0,0.0);if((C|0)<=(G|0)){f=C;while(1){p[b+(f<<3)>>3]=+p[b+(f-C<<3)>>3];if((f|0)<(G|0))f=f+1|0;else break}}j=P+36|0;f=k[j>>2]|0;if(f|0?(D=f+12|0,F=k[D>>2]|0,k[D>>2]=F+-1,(F|0)==1):0){g=k[j>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[P+32>>2]|0;if(f|0)break;f=B1()|0;g=k[j>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[j>>2]=0}k[j>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[c>>2]|0)>0){g=k[v>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[c>>2]|0))}f=k[w>>2]|0;if(!((f|0)==(A|0)|(f|0)==0))ggb(k[f+-4>>2]|0);t=b}F=k[V>>2]|0;if(!((F&16384|0)!=0?(B|0)==(K|0)&(F&4095|0)==6:0)){C=k[V+40>>2]|0;D=k[C+4>>2]|0;C=k[C>>2]|0;n=b+(K<<3)|0;q=H+4|0;k[q>>2]=2;e=H+8|0;k[e>>2]=C;k[H+12>>2]=D;l=H+16|0;k[l>>2]=n;k[H+20>>2]=n;F=H+24|0;m=H+40|0;d=F+8|0;k[d>>2]=0;k[d+4>>2]=0;k[m>>2]=e;e=H+48|0;d=H+44|0;k[d>>2]=e;D=D<<3;k[H>>2]=1124024326;k[e>>2]=D;k[H+52>>2]=8;C=n+(aa(C,D)|0)|0;k[H+28>>2]=C;k[F>>2]=C+(0-D)+D;F=P+4|0;D=F+4|0;k[D>>2]=0;k[D+4>>2]=0;k[P>>2]=33619968;k[F>>2]=H;SW(V,P,6,1.0,0.0);if((B|0)<=(G|0)){f=B;while(1){p[n+(f<<3)>>3]=+p[n+(f-B<<3)>>3];if((f|0)<(G|0))f=f+1|0;else break}}j=H+36|0;f=k[j>>2]|0;if(f|0?(D=f+12|0,F=k[D>>2]|0,k[D>>2]=F+-1,(F|0)==1):0){g=k[j>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[H+32>>2]|0;if(f|0)break;f=B1()|0;g=k[j>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[j>>2]=0}k[j>>2]=0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[q>>2]|0)>0){g=k[m>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[q>>2]|0))}f=k[d>>2]|0;if(!((f|0)==(e|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}if(E>>>0<5){e=b+(K<<1<<3)|0;d=1;b=1;l=0;while(1){$=+p[n+(l<<3)>>3];s=+p[t+(l<<3)>>3];h=$<s?$:s;s=s<$?$:s;j=~~h;j=(+(j|0)<h&1)+j|0;f=e+(l<<3)|0;g=f+4|0;k[g>>2]=j;m=~~s;j=m-(+(m|0)>s&1)-j|0;m=j+-1|0;k[f>>2]=m;s=s-h;d=s<=4294967296.0&(m&j|0)==0&1&d;m=(d|0)==0;if(m){if(s>2147483647.0)k[f>>2]=2147483647;if(h<-1073741824.0){k[g>>2]=-1073741824;q=b}else q=b}else q=(j|0)<257&b;l=l+1|0;if((l|0)==(K|0))break;else b=q}if(m){g=e+(K<<3)|0;b=0;do{f=e+(b<<3)|0;k[g+(b*20|0)+16>>2]=k[f+4>>2];f=(k[f>>2]|0)+1|0;k[g+(b*20|0)>>2]=f;m=0;while(1){j=Apb(1,0,m|0)|0;l=N;if(l>>>0<0|(l|0)==0&j>>>0<f>>>0)m=m+1|0;else break}F=jpb(j|0,l|0,f|0,0)|0;F=spb(0,F|0,f|0,0)|0;k[g+(b*20|0)+4>>2]=F+1;k[g+(b*20|0)+8>>2]=(m|0)>1?1:m;F=m+-1|0;k[g+(b*20|0)+12>>2]=(F|0)<0?0:F;b=b+1|0}while((b|0)!=(K|0))}else g=0;j=49608+(d<<5)+(E<<2)|0;l=e;b=0;f=0;m=g}else{h=(E|0)==6?5.421010862427522e-20:2.3283064365386963e-10;f=b+(K<<1<<3)|0;if((E|0)==5){b=0;do{s=+p[n+(b<<3)>>3];$=+p[t+(b<<3)>>3];ba=s-$;F=f+(b<<3)|0;o[F>>2]=h*(ba<1797693134862315708145274.0e284?ba:1797693134862315708145274.0e284);o[F+4>>2]=(s+$)*.5;b=b+1|0}while((b|0)!=(K|0));b=0}else{b=0;do{D=n+(b<<3)|0;F=t+(b<<3)|0;ba=+p[D>>3]-+p[F>>3];p[f+(b<<4)>>3]=h*(ba<1797693134862315708145274.0e284?ba:1797693134862315708145274.0e284);p[f+(b<<4)+8>>3]=(+p[D>>3]+ +p[F>>3])*.5;b=b+1|0}while((b|0)!=(K|0));b=f;f=0}j=49608+(E<<2)|0;l=0;m=0;q=1}g=k[j>>2]|0;if(!g){k[H>>2]=0;g=H+4|0;k[g>>2]=0;j=ZT(16)|0;k[j>>2]=1;x=j+4|0;k[H>>2]=x;k[g>>2]=9;i[j+13>>0]=0;y=335726;z=x+9|0;do{i[x>>0]=i[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));Y8(-215,H,229466,229471,617);k[g>>2]=0;k[H>>2]=0;F=k[j>>2]|0;k[j>>2]=F+-1;if((F|0)==1)ggb(k[j+-4>>2]|0);F=0;j=0;g=0;t=l;E=0;D=0;d=m}else{F=0;j=0;t=l;E=0;D=0;d=m}}else{if((c|0)!=1){k[H>>2]=0;b=H+4|0;k[b>>2]=0;f=ZT(32)|0;k[f>>2]=1;x=f+4|0;k[H>>2]=x;k[b>>2]=25;i[f+29>>0]=0;y=229845;z=x+25|0;do{i[x>>0]=i[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));Y8(-5,H,229466,229471,658);k[b>>2]=0;k[H>>2]=0;F=k[f>>2]|0;k[f>>2]=F+-1;if((F|0)==1)ggb(k[f+-4>>2]|0);F=0;j=0;g=0;t=0;E=0;D=0;b=0;f=0;d=0;q=1;break}d=(C|0)<=(G|0);g=((B|0)<(K|0)?K:B)+(d?K:C)|0;if((k[M>>2]|0)>>>0<g>>>0){b=k[U>>2]|0;if((b|0)!=(L|0)){if(b|0)ggb(b);k[U>>2]=L;k[M>>2]=136}if(g>>>0>136){f=g>>>0>536870911?-1:g<<3;f=(f|0)==0?1:f;while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[U>>2]=b;k[M>>2]=g}else b=L}else{k[M>>2]=g;b=k[U>>2]|0}m=(E|0)==6?6:5;n=47696>>>(m<<1)&3;F=k[W>>2]|0;if((F&16384|0)!=0&(F&4095|0)==(m|0))q=k[W+16>>2]|0;else{f=k[W+40>>2]|0;j=k[f>>2]|0;k[w>>2]=k[f+4>>2];k[w+4>>2]=j;YN(H,w,m,b,0);j=P+4|0;f=j+4|0;k[f>>2]=0;k[f+4>>2]=0;k[P>>2]=33619968;k[j>>2]=H;SW(W,P,m,1.0,0.0);j=H+36|0;f=k[j>>2]|0;if(f|0?(B=f+12|0,F=k[B>>2]|0,k[B>>2]=F+-1,(F|0)==1):0){g=k[j>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[H+32>>2]|0;if(f|0)break;f=B1()|0;g=k[j>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[j>>2]=0}k[j>>2]=0;F=H+16|0;g=H+4|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[g>>2]|0)>0){j=k[H+40>>2]|0;f=0;do{k[j+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[H+44>>2]|0;if(!((f|0)==(H+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);q=b}if(d?(x=C<<n,y=K<<n,(x|0)<(y|0)):0){f=x;do{i[q+f>>0]=i[q+(f-x)>>0]|0;f=f+1|0}while((f|0)!=(y|0))}F=k[V>>2]|0;if((F&16384|0)!=0&(F&4095|0)==(m|0))l=k[V+16>>2]|0;else{g=k[V+40>>2]|0;l=k[g>>2]|0;k[z>>2]=k[g+4>>2];k[z+4>>2]=l;l=b+(K<<3)|0;YN(H,z,m,l,0);g=P+4|0;b=g+4|0;k[b>>2]=0;k[b+4>>2]=0;k[P>>2]=33619968;k[g>>2]=H;SW(V,P,m,1.0,0.0);g=H+36|0;b=k[g>>2]|0;if(b|0?(B=b+12|0,F=k[B>>2]|0,k[B>>2]=F+-1,(F|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[H+32>>2]|0;if(b|0)break;b=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;F=H+16|0;f=H+4|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[f>>2]|0)>0){g=k[H+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[f>>2]|0))}b=k[H+44>>2]|0;if(!((b|0)==(H+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}if(d?(A=C<<n,D=K<<n,(A|0)<(D|0)):0){b=A;do{i[l+b>>0]=i[l+(b-A)>>0]|0;b=b+1|0}while((b|0)!=(D|0))}j=(k[V+8>>2]|0)==(K|0)?(k[V+12>>2]|0)==(K|0):0;g=k[49672+(E<<2)>>2]|0;if((E|0)==7){k[H>>2]=0;b=H+4|0;k[b>>2]=0;f=ZT(20)|0;k[f>>2]=1;x=f+4|0;k[H>>2]=x;k[b>>2]=14;i[f+18>>0]=0;y=229830;z=x+14|0;do{i[x>>0]=i[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));Y8(-215,H,229466,229471,655);k[b>>2]=0;k[H>>2]=0;F=k[f>>2]|0;k[f>>2]=F+-1;if((F|0)==1)ggb(k[f+-4>>2]|0);F=g;g=0;t=0;E=l;D=q;b=0;f=0;d=0;q=1}else{F=g;g=0;t=0;E=l;D=q;b=0;f=0;d=0;q=1}}while(0);k[H>>2]=X;k[H+4>>2]=0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;k[S+16>>2]=0;k[S+20>>2]=0;k[S+24>>2]=0;k[S+28>>2]=0;z1(S,H,0,P,-1);A=k[S+20>>2]|0;z=((G|1024)>>>0)/(K>>>0)|0;z=(A|0)<(z|0)?A:z;G=X+4|0;l=k[G>>2]|0;if((l|0)>0)y=k[(k[X+44>>2]|0)+(l+-1<<2)>>2]|0;else y=0;B=T+8|0;k[T>>2]=B;C=T+4|0;k[C>>2]=136;e=aa(z,K)|0;do if(I){n=e<<2;if(n>>>0>136){m=n>>>0>536870911?-1:n<<3;m=(m|0)==0?1:m;while(1){l=fgb(m)|0;if(l|0)break;l=k[207666]|0;k[207666]=l+0;if(!l){l=0;break}Qh[l&7]()}k[T>>2]=l;m=l}else m=B;k[C>>2]=n;if(!t)if(!f){if((e|0)>0)f=0;else{b=0;w=m;break}do{l=0;do{H=m+(l+f<<4)|0;x=b+(l<<4)|0;k[H>>2]=k[x>>2];k[H+4>>2]=k[x+4>>2];k[H+8>>2]=k[x+8>>2];k[H+12>>2]=k[x+12>>2];l=l+1|0}while((l|0)!=(K|0));f=f+K|0}while((f|0)<(e|0));b=0;w=m}else{if((e|0)>0)b=0;else{b=0;w=m;break}do{l=0;do{H=m+(l+b<<3)|0;x=f+(l<<3)|0;k[u>>2]=k[x>>2];k[u+4>>2]=k[x+4>>2];p[u>>3]=+p[u>>3];k[H>>2]=k[u>>2];k[H+4>>2]=k[u+4>>2];l=l+1|0}while((l|0)!=(K|0));b=b+K|0}while((b|0)<(e|0));b=0;w=m}else if(!d){if((e|0)>0)f=0;else{b=0;w=m;break}do{b=0;do{H=m+(b+f<<3)|0;x=t+(b<<3)|0;k[u>>2]=k[x>>2];k[u+4>>2]=k[x+4>>2];p[u>>3]=+p[u>>3];k[H>>2]=k[u>>2];k[H+4>>2]=k[u+4>>2];b=b+1|0}while((b|0)!=(K|0));f=f+K|0}while((f|0)<(e|0));b=0;w=m}else{if((e|0)>0)f=0;else{b=0;w=m;break}do{b=0;do{H=m+((b+f|0)*20|0)|0;x=d+(b*20|0)|0;k[H>>2]=k[x>>2];k[H+4>>2]=k[x+4>>2];k[H+8>>2]=k[x+8>>2];k[H+12>>2]=k[x+12>>2];k[H+16>>2]=k[x+16>>2];b=b+1|0}while((b|0)!=(K|0));f=f+K|0}while((f|0)<(e|0));b=0;w=m}}else{l=(e+1|0)/2|0;if(l>>>0>136){f=l>>>0>536870911?-1:l<<3;f=(f|0)==0?1:f;while(1){b=fgb(f)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[T>>2]=b}else b=B;k[C>>2]=l;w=0}while(0);x=S+16|0;c=(q|0)!=0;a:do if((A|0)>0){v=0;while(1){if(v>>>0>=(k[x>>2]|0)>>>0)break a;if(I){f=0;l=k[P>>2]|0;do{H=A-f|0;H=(z|0)<(H|0)?z:H;t=aa(H,K)|0;eh[g&255](l,t,a,w,c);H=aa(H,y)|0;l=(k[P>>2]|0)+H|0;k[P>>2]=l;f=f+z|0}while((A|0)>(f|0))}else{e=0;do{t=A-e|0;t=(z|0)<(t|0)?z:t;d=aa(t,K)|0;f=a;l=k[f>>2]|0;f=k[f+4>>2]|0;if(!(i[1012370]|0)){k[107202]=1991057938;k[107203]=0;o[107330]=1.7290404663583558e-09;o[107457]=1.6030947680434338e-09;o[107458]=1.0;o[107585]=2.6696291752159595e-03;m=126;h=3.442619855899;while(1){ba=h;h=+Q(+(+_(+(.00991256303526217/h+ +Z(+(h*(h*-.5)))))*-2.0));k[428808+(m+1<<2)>>2]=~~(h/ba*2147483648.0)>>>0;ba=+Z(+(h*(h*-.5)));o[429832+(m<<2)>>2]=ba;o[429320+(m<<2)>>2]=h*4.656612873077393e-10;if((m|0)<=1)break;else m=m+-1|0}i[1012370]=1}if((d|0)>0){q=0;do{do{m=Epb(l|0,0,-130063606,0)|0;m=kpb(m|0,N|0,f|0,0)|0;f=N;n=l&127;h=+o[429320+(n<<2)>>2]*+(l|0);if(((l|0)>-1?l:0-l|0)>>>0<(k[428808+(n<<2)>>2]|0)>>>0){l=m;break}if(!n){R=237;break}l=Epb(m|0,0,-130063606,0)|0;l=kpb(l|0,N|0,f|0,0)|0;f=N;$=+o[429832+(n<<2)>>2];ba=h}while(!($+ +(m>>>0)*2.3283064365386963e-10*(+o[429832+(n+-1<<2)>>2]-$)<+Z(+(ba*(ba*-.5)))));if((R|0)==237){while(1){R=0;H=Epb(m|0,0,-130063606,0)|0;H=kpb(H|0,N|0,f|0,0)|0;ca=N;da=Epb(H|0,0,-130063606,0)|0;n=m;m=kpb(da|0,N|0,ca|0,0)|0;f=N;h=-+_(+(+(n>>>0)*2.3283064365386963e-10+1.1754943508222875e-38))*.2904764;ba=+_(+(+(H>>>0)*2.3283064365386963e-10+1.1754943508222875e-38));if(!(-ba-ba<h*h))break;else R=237}h=(l|0)>0?h+3.442620038986206:-3.442620038986206-h;l=m}o[b+(q<<2)>>2]=h;q=q+1|0}while((q|0)!=(d|0))}da=a;k[da>>2]=l;k[da+4>>2]=f;Eh[F&127](b,k[P>>2]|0,t,K,D,E,j);da=aa(t,y)|0;k[P>>2]=(k[P>>2]|0)+da;e=e+z|0}while((A|0)>(e|0))}A1(S);v=v+1|0}}else{b=0;while(1){if(b>>>0>=(k[x>>2]|0)>>>0)break a;A1(S);b=b+1|0}}while(0);b=k[T>>2]|0;if((b|0)!=(B|0)){if(b|0)ggb(b);k[T>>2]=B;k[C>>2]=136}b=k[U>>2]|0;if((b|0)!=(L|0)){if(b|0)ggb(b);k[U>>2]=L;k[M>>2]=136}g=V+36|0;b=k[g>>2]|0;if(b|0?(ca=b+12|0,da=k[ca>>2]|0,k[ca>>2]=da+-1,(da|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[V+32>>2]|0;if(b|0)break;b=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;da=V+16|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[J>>2]|0)>0){f=k[V+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[J>>2]|0))}b=k[V+44>>2]|0;if(!((b|0)==(V+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=W+36|0;b=k[g>>2]|0;if(b|0?(ca=b+12|0,da=k[ca>>2]|0,k[ca>>2]=da+-1,(da|0)==1):0){f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[W+32>>2]|0;if(b|0)break;b=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}k[g>>2]=0;da=W+16|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[O>>2]|0)>0){f=k[W+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[O>>2]|0))}b=k[W+44>>2]|0;if(!((b|0)==(W+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=X+36|0;b=k[g>>2]|0;do if(b|0){ca=b+12|0;da=k[ca>>2]|0;k[ca>>2]=da+-1;if((da|0)!=1)break;f=k[g>>2]|0;if(f|0){b=k[f+4>>2]|0;do if(!b){b=k[X+32>>2]|0;if(b|0)break;b=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,f)}k[g>>2]=0}while(0);k[g>>2]=0;da=X+16|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[G>>2]|0)>0){f=k[X+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[G>>2]|0))}b=k[X+44>>2]|0;if((b|0)==(X+48|0)|(b|0)==0){r=Y;return}ggb(k[b+-4>>2]|0);r=Y;return}function L6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,j=0,l=0.0,m=0.0,n=0,p=0;if(g){if((c|0)>0&(d|0)>0)p=0;else return;while(1){n=0;do{j=aa(n,d)|0;h=+o[e+(n<<2)>>2];g=0;do{h=h+ +o[a+(g<<2)>>2]*+o[f+(g+j<<2)>>2];g=g+1|0}while((g|0)!=(d|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}j=~~h;i[b+n>>0]=j>>>0<256?j:(j|0)>0?255:0;n=n+1|0}while((n|0)!=(d|0));p=p+1|0;if((p|0)==(c|0))break;else{b=b+d|0;a=a+(d<<2)|0}}return}if((d|0)==1){m=+o[e>>2];l=+o[f>>2];if((c|0)>0)j=0;else return;do{h=m+l*+o[a+(j<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}f=~~h;i[b+j>>0]=f>>>0<256?f:(f|0)>0?255:0;j=j+1|0}while((j|0)!=(c|0));return}if((c|0)>0&(d|0)>0){j=b;p=0}else return;while(1){n=0;do{h=+o[a+(n<<2)>>2]*+o[f+(n<<2)>>2]+ +o[e+(n<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}b=~~h;i[j+n>>0]=b>>>0<256?b:(b|0)>0?255:0;n=n+1|0}while((n|0)!=(d|0));p=p+1|0;if((p|0)==(c|0))break;else{a=a+(d<<2)|0;j=j+d|0}}return}function M6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,j=0,l=0.0,m=0.0,n=0,p=0;if(g){if((c|0)>0&(d|0)>0)p=0;else return;while(1){n=0;do{j=aa(n,d)|0;h=+o[e+(n<<2)>>2];g=0;do{h=h+ +o[a+(g<<2)>>2]*+o[f+(g+j<<2)>>2];g=g+1|0}while((g|0)!=(d|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}j=~~h;i[b+n>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;n=n+1|0}while((n|0)!=(d|0));p=p+1|0;if((p|0)==(c|0))break;else{b=b+d|0;a=a+(d<<2)|0}}return}if((d|0)==1){m=+o[e>>2];l=+o[f>>2];if((c|0)>0)j=0;else return;do{h=m+l*+o[a+(j<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}f=~~h;i[b+j>>0]=(f+128|0)>>>0<256?f:(f|0)>0?127:128;j=j+1|0}while((j|0)!=(c|0));return}if((c|0)>0&(d|0)>0){j=b;p=0}else return;while(1){n=0;do{h=+o[a+(n<<2)>>2]*+o[f+(n<<2)>>2]+ +o[e+(n<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}b=~~h;i[j+n>>0]=(b+128|0)>>>0<256?b:(b|0)>0?127:128;n=n+1|0}while((n|0)!=(d|0));p=p+1|0;if((p|0)==(c|0))break;else{a=a+(d<<2)|0;j=j+d|0}}return}function N6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,l=0.0,m=0.0,n=0,p=0;if(g){if((c|0)>0&(d|0)>0)p=0;else return;while(1){n=0;do{i=aa(n,d)|0;h=+o[e+(n<<2)>>2];g=0;do{h=h+ +o[a+(g<<2)>>2]*+o[f+(g+i<<2)>>2];g=g+1|0}while((g|0)!=(d|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;j[b+(n<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;n=n+1|0}while((n|0)!=(d|0));p=p+1|0;if((p|0)==(c|0))break;else{b=b+(d<<1)|0;a=a+(d<<2)|0}}return}if((d|0)==1){m=+o[e>>2];l=+o[f>>2];if((c|0)>0)i=0;else return;do{h=m+l*+o[a+(i<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}f=~~h;j[b+(i<<1)>>1]=f>>>0<65536?f:(f|0)>0?65535:0;i=i+1|0}while((i|0)!=(c|0));return}if((c|0)>0&(d|0)>0){i=b;p=0}else return;while(1){n=0;do{h=+o[a+(n<<2)>>2]*+o[f+(n<<2)>>2]+ +o[e+(n<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}b=~~h;j[i+(n<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;n=n+1|0}while((n|0)!=(d|0));p=p+1|0;if((p|0)==(c|0))break;else{a=a+(d<<2)|0;i=i+(d<<1)|0}}return}function O6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,l=0.0,m=0.0,n=0,p=0;if(g){if((c|0)>0&(d|0)>0)p=0;else return;while(1){n=0;do{i=aa(n,d)|0;h=+o[e+(n<<2)>>2];g=0;do{h=h+ +o[a+(g<<2)>>2]*+o[f+(g+i<<2)>>2];g=g+1|0}while((g|0)!=(d|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;j[b+(n<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;n=n+1|0}while((n|0)!=(d|0));p=p+1|0;if((p|0)==(c|0))break;else{b=b+(d<<1)|0;a=a+(d<<2)|0}}return}if((d|0)==1){m=+o[e>>2];l=+o[f>>2];if((c|0)>0)i=0;else return;do{h=m+l*+o[a+(i<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}f=~~h;j[b+(i<<1)>>1]=(f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768;i=i+1|0}while((i|0)!=(c|0));return}if((c|0)>0&(d|0)>0){i=b;p=0}else return;while(1){n=0;do{h=+o[a+(n<<2)>>2]*+o[f+(n<<2)>>2]+ +o[e+(n<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}b=~~h;j[i+(n<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;n=n+1|0}while((n|0)!=(d|0));p=p+1|0;if((p|0)==(c|0))break;else{a=a+(d<<2)|0;i=i+(d<<1)|0}}return}function P6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,l=0.0,m=0,n=0;if(g){if((c|0)>0&(d|0)>0)n=0;else return;while(1){m=0;do{i=aa(m,d)|0;h=+o[e+(m<<2)>>2];g=0;do{h=h+ +o[a+(g<<2)>>2]*+o[f+(g+i<<2)>>2];g=g+1|0}while((g|0)!=(d|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}k[b+(m<<2)>>2]=~~h;m=m+1|0}while((m|0)!=(d|0));n=n+1|0;if((n|0)==(c|0))break;else{b=b+(d<<2)|0;a=a+(d<<2)|0}}return}if((d|0)==1){l=+o[e>>2];j=+o[f>>2];if((c|0)>0)i=0;else return;do{h=l+j*+o[a+(i<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}k[b+(i<<2)>>2]=~~h;i=i+1|0}while((i|0)!=(c|0));return}if((c|0)>0&(d|0)>0){i=b;n=0}else return;while(1){m=0;do{h=+o[a+(m<<2)>>2]*+o[f+(m<<2)>>2]+ +o[e+(m<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}k[i+(m<<2)>>2]=~~h;m=m+1|0}while((m|0)!=(d|0));n=n+1|0;if((n|0)==(c|0))break;else{a=a+(d<<2)|0;i=i+(d<<2)|0}}return}function Q6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0,k=0,l=0;if(g){if((c|0)>0&(d|0)>0){l=b;j=0}else return;while(1){g=0;do{k=aa(g,d)|0;h=+o[e+(g<<2)>>2];b=0;do{h=h+ +o[a+(b<<2)>>2]*+o[f+(b+k<<2)>>2];b=b+1|0}while((b|0)!=(d|0));o[l+(g<<2)>>2]=h;g=g+1|0}while((g|0)!=(d|0));j=j+1|0;if((j|0)==(c|0))break;else{l=l+(d<<2)|0;a=a+(d<<2)|0}}return}if((d|0)==1){i=+o[e>>2];h=+o[f>>2];if((c|0)>0)g=0;else return;do{o[b+(g<<2)>>2]=i+h*+o[a+(g<<2)>>2];g=g+1|0}while((g|0)!=(c|0));return}if((c|0)>0&(d|0)>0){g=b;j=0}else return;while(1){b=0;do{o[g+(b<<2)>>2]=+o[a+(b<<2)>>2]*+o[f+(b<<2)>>2]+ +o[e+(b<<2)>>2];b=b+1|0}while((b|0)!=(d|0));j=j+1|0;if((j|0)==(c|0))break;else{a=a+(d<<2)|0;g=g+(d<<2)|0}}return}function R6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0,k=0,l=0;if(g){if((c|0)>0&(d|0)>0){l=b;j=0}else return;while(1){g=0;do{k=aa(g,d)|0;h=+p[e+(g<<3)>>3];b=0;do{h=h+ +o[a+(b<<2)>>2]*+p[f+(b+k<<3)>>3];b=b+1|0}while((b|0)!=(d|0));p[l+(g<<3)>>3]=h;g=g+1|0}while((g|0)!=(d|0));j=j+1|0;if((j|0)==(c|0))break;else{l=l+(d<<3)|0;a=a+(d<<2)|0}}return}if((d|0)==1){i=+p[e>>3];h=+p[f>>3];if((c|0)>0)g=0;else return;do{p[b+(g<<3)>>3]=i+h*+o[a+(g<<2)>>2];g=g+1|0}while((g|0)!=(c|0));return}if((c|0)>0&(d|0)>0){g=b;j=0}else return;while(1){b=0;do{p[g+(b<<3)>>3]=+o[a+(b<<2)>>2]*+p[f+(b<<3)>>3]+ +p[e+(b<<3)>>3];b=b+1|0}while((b|0)!=(d|0));j=j+1|0;if((j|0)==(c|0))break;else{a=a+(d<<2)|0;g=g+(d<<3)|0}}return}function S6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;e=c;f=k[e>>2]|0;e=k[e+4>>2]|0;h=b+-4|0;if((b|0)<4)g=0;else{g=0;do{p=Epb(f|0,0,-130063606,0)|0;p=kpb(p|0,N|0,e|0,0)|0;m=N;o=Epb(p|0,0,-130063606,0)|0;m=kpb(o|0,N|0,m|0,0)|0;o=N;Epb(p|0,0,k[d+(g*20|0)+4>>2]|0,0)|0;l=N;n=g|1;Epb(m|0,0,k[d+(n*20|0)+4>>2]|0,0)|0;j=N;l=p-(aa((((p-l|0)>>>(k[d+(g*20|0)+8>>2]|0))+l|0)>>>(k[d+(g*20|0)+12>>2]|0),k[d+(g*20|0)>>2]|0)|0)|0;l=l+(k[d+(g*20|0)+16>>2]|0)|0;j=m-(aa((((m-j|0)>>>(k[d+(n*20|0)+8>>2]|0))+j|0)>>>(k[d+(n*20|0)+12>>2]|0),k[d+(n*20|0)>>2]|0)|0)|0;j=j+(k[d+(n*20|0)+16>>2]|0)|0;i[a+g>>0]=l>>>0<256?l:(l|0)>0?255:0;i[a+n>>0]=j>>>0<256?j:(j|0)>0?255:0;m=Epb(m|0,0,-130063606,0)|0;o=kpb(m|0,N|0,o|0,0)|0;m=N;n=Epb(o|0,0,-130063606,0)|0;f=kpb(n|0,N|0,m|0,0)|0;e=N;m=g|2;Epb(k[d+(m*20|0)+4>>2]|0,0,o|0,0)|0;n=N;j=g|3;Epb(k[d+(j*20|0)+4>>2]|0,0,f|0,0)|0;l=N;n=o-(aa((((o-n|0)>>>(k[d+(m*20|0)+8>>2]|0))+n|0)>>>(k[d+(m*20|0)+12>>2]|0),k[d+(m*20|0)>>2]|0)|0)|0;n=n+(k[d+(m*20|0)+16>>2]|0)|0;l=f-(aa((((f-l|0)>>>(k[d+(j*20|0)+8>>2]|0))+l|0)>>>(k[d+(j*20|0)+12>>2]|0),k[d+(j*20|0)>>2]|0)|0)|0;l=l+(k[d+(j*20|0)+16>>2]|0)|0;i[a+m>>0]=n>>>0<256?n:(n|0)>0?255:0;i[a+j>>0]=l>>>0<256?l:(l|0)>0?255:0;g=g+4|0}while((g|0)<=(h|0));g=b&-4}if((g|0)>=(b|0)){m=f;o=e;p=c;n=p;k[n>>2]=m;p=p+4|0;k[p>>2]=o;return}do{f=Epb(f|0,0,-130063606,0)|0;f=kpb(f|0,N|0,e|0,0)|0;e=N;Epb(f|0,0,k[d+(g*20|0)+4>>2]|0,0)|0;p=N;p=f-(aa((((f-p|0)>>>(k[d+(g*20|0)+8>>2]|0))+p|0)>>>(k[d+(g*20|0)+12>>2]|0),k[d+(g*20|0)>>2]|0)|0)|0;p=p+(k[d+(g*20|0)+16>>2]|0)|0;i[a+g>>0]=p>>>0<256?p:(p|0)>0?255:0;g=g+1|0}while((g|0)!=(b|0));p=c;o=p;k[o>>2]=f;p=p+4|0;k[p>>2]=e;return}function T6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;e=c;f=k[e>>2]|0;e=k[e+4>>2]|0;h=b+-4|0;if((b|0)<4)g=0;else{g=0;do{p=Epb(f|0,0,-130063606,0)|0;p=kpb(p|0,N|0,e|0,0)|0;m=N;o=Epb(p|0,0,-130063606,0)|0;m=kpb(o|0,N|0,m|0,0)|0;o=N;Epb(p|0,0,k[d+(g*20|0)+4>>2]|0,0)|0;l=N;n=g|1;Epb(m|0,0,k[d+(n*20|0)+4>>2]|0,0)|0;j=N;l=p-(aa((((p-l|0)>>>(k[d+(g*20|0)+8>>2]|0))+l|0)>>>(k[d+(g*20|0)+12>>2]|0),k[d+(g*20|0)>>2]|0)|0)|0;l=l+(k[d+(g*20|0)+16>>2]|0)|0;j=m-(aa((((m-j|0)>>>(k[d+(n*20|0)+8>>2]|0))+j|0)>>>(k[d+(n*20|0)+12>>2]|0),k[d+(n*20|0)>>2]|0)|0)|0;j=j+(k[d+(n*20|0)+16>>2]|0)|0;i[a+g>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;i[a+n>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;m=Epb(m|0,0,-130063606,0)|0;o=kpb(m|0,N|0,o|0,0)|0;m=N;n=Epb(o|0,0,-130063606,0)|0;f=kpb(n|0,N|0,m|0,0)|0;e=N;m=g|2;Epb(k[d+(m*20|0)+4>>2]|0,0,o|0,0)|0;n=N;j=g|3;Epb(k[d+(j*20|0)+4>>2]|0,0,f|0,0)|0;l=N;n=o-(aa((((o-n|0)>>>(k[d+(m*20|0)+8>>2]|0))+n|0)>>>(k[d+(m*20|0)+12>>2]|0),k[d+(m*20|0)>>2]|0)|0)|0;n=n+(k[d+(m*20|0)+16>>2]|0)|0;l=f-(aa((((f-l|0)>>>(k[d+(j*20|0)+8>>2]|0))+l|0)>>>(k[d+(j*20|0)+12>>2]|0),k[d+(j*20|0)>>2]|0)|0)|0;l=l+(k[d+(j*20|0)+16>>2]|0)|0;i[a+m>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;i[a+j>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;g=g+4|0}while((g|0)<=(h|0));g=b&-4}if((g|0)>=(b|0)){m=f;o=e;p=c;n=p;k[n>>2]=m;p=p+4|0;k[p>>2]=o;return}do{f=Epb(f|0,0,-130063606,0)|0;f=kpb(f|0,N|0,e|0,0)|0;e=N;Epb(f|0,0,k[d+(g*20|0)+4>>2]|0,0)|0;p=N;p=f-(aa((((f-p|0)>>>(k[d+(g*20|0)+8>>2]|0))+p|0)>>>(k[d+(g*20|0)+12>>2]|0),k[d+(g*20|0)>>2]|0)|0)|0;p=p+(k[d+(g*20|0)+16>>2]|0)|0;i[a+g>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;g=g+1|0}while((g|0)!=(b|0));p=c;o=p;k[o>>2]=f;p=p+4|0;k[p>>2]=e;return}function U6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0;e=c;f=k[e>>2]|0;e=k[e+4>>2]|0;h=b+-4|0;if((b|0)<4)g=0;else{g=0;do{p=Epb(f|0,0,-130063606,0)|0;p=kpb(p|0,N|0,e|0,0)|0;m=N;o=Epb(p|0,0,-130063606,0)|0;m=kpb(o|0,N|0,m|0,0)|0;o=N;Epb(p|0,0,k[d+(g*20|0)+4>>2]|0,0)|0;l=N;n=g|1;Epb(m|0,0,k[d+(n*20|0)+4>>2]|0,0)|0;i=N;l=p-(aa((((p-l|0)>>>(k[d+(g*20|0)+8>>2]|0))+l|0)>>>(k[d+(g*20|0)+12>>2]|0),k[d+(g*20|0)>>2]|0)|0)|0;l=l+(k[d+(g*20|0)+16>>2]|0)|0;i=m-(aa((((m-i|0)>>>(k[d+(n*20|0)+8>>2]|0))+i|0)>>>(k[d+(n*20|0)+12>>2]|0),k[d+(n*20|0)>>2]|0)|0)|0;i=i+(k[d+(n*20|0)+16>>2]|0)|0;j[a+(g<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;j[a+(n<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;m=Epb(m|0,0,-130063606,0)|0;o=kpb(m|0,N|0,o|0,0)|0;m=N;n=Epb(o|0,0,-130063606,0)|0;f=kpb(n|0,N|0,m|0,0)|0;e=N;m=g|2;Epb(k[d+(m*20|0)+4>>2]|0,0,o|0,0)|0;n=N;i=g|3;Epb(k[d+(i*20|0)+4>>2]|0,0,f|0,0)|0;l=N;n=o-(aa((((o-n|0)>>>(k[d+(m*20|0)+8>>2]|0))+n|0)>>>(k[d+(m*20|0)+12>>2]|0),k[d+(m*20|0)>>2]|0)|0)|0;n=n+(k[d+(m*20|0)+16>>2]|0)|0;l=f-(aa((((f-l|0)>>>(k[d+(i*20|0)+8>>2]|0))+l|0)>>>(k[d+(i*20|0)+12>>2]|0),k[d+(i*20|0)>>2]|0)|0)|0;l=l+(k[d+(i*20|0)+16>>2]|0)|0;j[a+(m<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;j[a+(i<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;g=g+4|0}while((g|0)<=(h|0));g=b&-4}if((g|0)>=(b|0)){m=f;o=e;p=c;n=p;k[n>>2]=m;p=p+4|0;k[p>>2]=o;return}do{f=Epb(f|0,0,-130063606,0)|0;f=kpb(f|0,N|0,e|0,0)|0;e=N;Epb(f|0,0,k[d+(g*20|0)+4>>2]|0,0)|0;p=N;p=f-(aa((((f-p|0)>>>(k[d+(g*20|0)+8>>2]|0))+p|0)>>>(k[d+(g*20|0)+12>>2]|0),k[d+(g*20|0)>>2]|0)|0)|0;p=p+(k[d+(g*20|0)+16>>2]|0)|0;j[a+(g<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;g=g+1|0}while((g|0)!=(b|0));p=c;o=p;k[o>>2]=f;p=p+4|0;k[p>>2]=e;return}function V6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0;e=c;f=k[e>>2]|0;e=k[e+4>>2]|0;h=b+-4|0;if((b|0)<4)g=0;else{g=0;do{p=Epb(f|0,0,-130063606,0)|0;p=kpb(p|0,N|0,e|0,0)|0;m=N;o=Epb(p|0,0,-130063606,0)|0;m=kpb(o|0,N|0,m|0,0)|0;o=N;Epb(p|0,0,k[d+(g*20|0)+4>>2]|0,0)|0;l=N;n=g|1;Epb(m|0,0,k[d+(n*20|0)+4>>2]|0,0)|0;i=N;l=p-(aa((((p-l|0)>>>(k[d+(g*20|0)+8>>2]|0))+l|0)>>>(k[d+(g*20|0)+12>>2]|0),k[d+(g*20|0)>>2]|0)|0)|0;l=l+(k[d+(g*20|0)+16>>2]|0)|0;i=m-(aa((((m-i|0)>>>(k[d+(n*20|0)+8>>2]|0))+i|0)>>>(k[d+(n*20|0)+12>>2]|0),k[d+(n*20|0)>>2]|0)|0)|0;i=i+(k[d+(n*20|0)+16>>2]|0)|0;j[a+(g<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;j[a+(n<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;m=Epb(m|0,0,-130063606,0)|0;o=kpb(m|0,N|0,o|0,0)|0;m=N;n=Epb(o|0,0,-130063606,0)|0;f=kpb(n|0,N|0,m|0,0)|0;e=N;m=g|2;Epb(k[d+(m*20|0)+4>>2]|0,0,o|0,0)|0;n=N;i=g|3;Epb(k[d+(i*20|0)+4>>2]|0,0,f|0,0)|0;l=N;n=o-(aa((((o-n|0)>>>(k[d+(m*20|0)+8>>2]|0))+n|0)>>>(k[d+(m*20|0)+12>>2]|0),k[d+(m*20|0)>>2]|0)|0)|0;n=n+(k[d+(m*20|0)+16>>2]|0)|0;l=f-(aa((((f-l|0)>>>(k[d+(i*20|0)+8>>2]|0))+l|0)>>>(k[d+(i*20|0)+12>>2]|0),k[d+(i*20|0)>>2]|0)|0)|0;l=l+(k[d+(i*20|0)+16>>2]|0)|0;j[a+(m<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;j[a+(i<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;g=g+4|0}while((g|0)<=(h|0));g=b&-4}if((g|0)>=(b|0)){m=f;o=e;p=c;n=p;k[n>>2]=m;p=p+4|0;k[p>>2]=o;return}do{f=Epb(f|0,0,-130063606,0)|0;f=kpb(f|0,N|0,e|0,0)|0;e=N;Epb(f|0,0,k[d+(g*20|0)+4>>2]|0,0)|0;p=N;p=f-(aa((((f-p|0)>>>(k[d+(g*20|0)+8>>2]|0))+p|0)>>>(k[d+(g*20|0)+12>>2]|0),k[d+(g*20|0)>>2]|0)|0)|0;p=p+(k[d+(g*20|0)+16>>2]|0)|0;j[a+(g<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;g=g+1|0}while((g|0)!=(b|0));p=c;o=p;k[o>>2]=f;p=p+4|0;k[p>>2]=e;return}function W6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;e=c;f=k[e>>2]|0;e=k[e+4>>2]|0;h=b+-4|0;if((b|0)<4)g=0;else{g=0;do{o=Epb(f|0,0,-130063606,0)|0;o=kpb(o|0,N|0,e|0,0)|0;l=N;n=Epb(o|0,0,-130063606,0)|0;l=kpb(n|0,N|0,l|0,0)|0;n=N;Epb(o|0,0,k[d+(g*20|0)+4>>2]|0,0)|0;j=N;m=g|1;Epb(l|0,0,k[d+(m*20|0)+4>>2]|0,0)|0;i=N;j=aa((((o-j|0)>>>(k[d+(g*20|0)+8>>2]|0))+j|0)>>>(k[d+(g*20|0)+12>>2]|0),k[d+(g*20|0)>>2]|0)|0;i=aa((((l-i|0)>>>(k[d+(m*20|0)+8>>2]|0))+i|0)>>>(k[d+(m*20|0)+12>>2]|0),k[d+(m*20|0)>>2]|0)|0;i=(k[d+(m*20|0)+16>>2]|0)+l-i|0;k[a+(g<<2)>>2]=(k[d+(g*20|0)+16>>2]|0)+o-j;k[a+(m<<2)>>2]=i;l=Epb(l|0,0,-130063606,0)|0;n=kpb(l|0,N|0,n|0,0)|0;l=N;m=Epb(n|0,0,-130063606,0)|0;f=kpb(m|0,N|0,l|0,0)|0;e=N;l=g|2;Epb(k[d+(l*20|0)+4>>2]|0,0,n|0,0)|0;m=N;i=g|3;Epb(k[d+(i*20|0)+4>>2]|0,0,f|0,0)|0;j=N;m=aa((((n-m|0)>>>(k[d+(l*20|0)+8>>2]|0))+m|0)>>>(k[d+(l*20|0)+12>>2]|0),k[d+(l*20|0)>>2]|0)|0;j=aa((((f-j|0)>>>(k[d+(i*20|0)+8>>2]|0))+j|0)>>>(k[d+(i*20|0)+12>>2]|0),k[d+(i*20|0)>>2]|0)|0;j=(k[d+(i*20|0)+16>>2]|0)+f-j|0;k[a+(l<<2)>>2]=(k[d+(l*20|0)+16>>2]|0)+n-m;k[a+(i<<2)>>2]=j;g=g+4|0}while((g|0)<=(h|0));g=b&-4}if((g|0)>=(b|0)){l=f;n=e;o=c;m=o;k[m>>2]=l;o=o+4|0;k[o>>2]=n;return}do{f=Epb(f|0,0,-130063606,0)|0;f=kpb(f|0,N|0,e|0,0)|0;e=N;Epb(f|0,0,k[d+(g*20|0)+4>>2]|0,0)|0;o=N;o=aa((((f-o|0)>>>(k[d+(g*20|0)+8>>2]|0))+o|0)>>>(k[d+(g*20|0)+12>>2]|0),k[d+(g*20|0)>>2]|0)|0;k[a+(g<<2)>>2]=(k[d+(g*20|0)+16>>2]|0)+f-o;g=g+1|0}while((g|0)!=(b|0));o=c;n=o;k[n>>2]=f;o=o+4|0;k[o>>2]=e;return}function X6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;e=c;f=k[e>>2]|0;e=k[e+4>>2]|0;h=b+-4|0;if((b|0)<4)g=0;else{g=0;do{i=Epb(f|0,0,-130063606,0)|0;i=kpb(i|0,N|0,e|0,0)|0;l=N;j=Epb(i|0,0,-130063606,0)|0;l=kpb(j|0,N|0,l|0,0)|0;j=N;m=Epb(l|0,0,-130063606,0)|0;j=kpb(m|0,N|0,j|0,0)|0;m=N;n=Epb(j|0,0,-130063606,0)|0;f=kpb(n|0,N|0,m|0,0)|0;e=N;o[a+(g<<2)>>2]=+(i|0)*+o[d+(g<<3)>>2]+ +o[d+(g<<3)+4>>2];i=g|1;o[a+(i<<2)>>2]=+(l|0)*+o[d+(i<<3)>>2]+ +o[d+(i<<3)+4>>2];i=g|2;o[a+(i<<2)>>2]=+(j|0)*+o[d+(i<<3)>>2]+ +o[d+(i<<3)+4>>2];i=g|3;o[a+(i<<2)>>2]=+(f|0)*+o[d+(i<<3)>>2]+ +o[d+(i<<3)+4>>2];g=g+4|0}while((g|0)<=(h|0));g=b&-4}if((g|0)>=(b|0)){j=f;m=e;n=c;l=n;k[l>>2]=j;n=n+4|0;k[n>>2]=m;return}do{f=Epb(f|0,0,-130063606,0)|0;f=kpb(f|0,N|0,e|0,0)|0;e=N;o[a+(g<<2)>>2]=+(f|0)*+o[d+(g<<3)>>2]+ +o[d+(g<<3)+4>>2];g=g+1|0}while((g|0)!=(b|0));n=c;m=n;k[m>>2]=f;n=n+4|0;k[n>>2]=e;return}function Y6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0.0,l=0,m=0.0,n=0;e=c;f=k[e>>2]|0;e=k[e+4>>2]|0;h=b+-4|0;if((b|0)<4)g=0;else{g=0;do{n=Epb(f|0,0,-130063606,0)|0;n=kpb(n|0,N|0,e|0,0)|0;i=N;j=(+(i>>>0)+4294967296.0*+(n|0))*+p[d+(g<<4)>>3]+ +p[d+(g<<4)+8>>3];n=Epb(n|0,0,-130063606,0)|0;i=kpb(n|0,N|0,i|0,0)|0;n=N;l=g|1;m=(+(n>>>0)+4294967296.0*+(i|0))*+p[d+(l<<4)>>3]+ +p[d+(l<<4)+8>>3];p[a+(g<<3)>>3]=j;p[a+(l<<3)>>3]=m;i=Epb(i|0,0,-130063606,0)|0;n=kpb(i|0,N|0,n|0,0)|0;i=N;l=g|2;m=(+(i>>>0)+4294967296.0*+(n|0))*+p[d+(l<<4)>>3]+ +p[d+(l<<4)+8>>3];n=Epb(n|0,0,-130063606,0)|0;f=kpb(n|0,N|0,i|0,0)|0;e=N;i=g|3;j=(+(e>>>0)+4294967296.0*+(f|0))*+p[d+(i<<4)>>3]+ +p[d+(i<<4)+8>>3];p[a+(l<<3)>>3]=m;p[a+(i<<3)>>3]=j;g=g+4|0}while((g|0)<=(h|0));g=b&-4}if((g|0)>=(b|0)){d=f;l=e;n=c;i=n;k[i>>2]=d;n=n+4|0;k[n>>2]=l;return}do{f=Epb(f|0,0,-130063606,0)|0;f=kpb(f|0,N|0,e|0,0)|0;e=N;p[a+(g<<3)>>3]=(+(e>>>0)+4294967296.0*+(f|0))*+p[d+(g<<4)>>3]+ +p[d+(g<<4)+8>>3];g=g+1|0}while((g|0)!=(b|0));n=c;l=n;k[l>>2]=f;n=n+4|0;k[n>>2]=e;return}function Z6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;f=c;g=k[f>>2]|0;f=k[f+4>>2]|0;j=b+-4|0;h=(b|0)<4;if(e)if(h)h=0;else{h=0;do{e=Epb(g|0,0,-130063606,0)|0;g=kpb(e|0,N|0,f|0,0)|0;f=N;e=(g&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;m=h|1;n=(g>>8&k[d+(m<<3)>>2])+(k[d+(m<<3)+4>>2]|0)|0;i[a+h>>0]=e>>>0<256?e:(e|0)>0?255:0;i[a+m>>0]=n>>>0<256?n:(n|0)>0?255:0;m=h|2;n=(k[d+(m<<3)>>2]&g>>16)+(k[d+(m<<3)+4>>2]|0)|0;e=h|3;l=(k[d+(e<<3)>>2]&g>>24)+(k[d+(e<<3)+4>>2]|0)|0;i[a+m>>0]=n>>>0<256?n:(n|0)>0?255:0;i[a+e>>0]=l>>>0<256?l:(l|0)>0?255:0;h=h+4|0}while((h|0)<=(j|0));h=b&-4}else if(h)h=0;else{h=0;do{m=Epb(g|0,0,-130063606,0)|0;m=kpb(m|0,N|0,f|0,0)|0;n=N;o=(m&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;m=Epb(m|0,0,-130063606,0)|0;n=kpb(m|0,N|0,n|0,0)|0;m=N;l=h|1;e=(n&k[d+(l<<3)>>2])+(k[d+(l<<3)+4>>2]|0)|0;i[a+h>>0]=o>>>0<256?o:(o|0)>0?255:0;i[a+l>>0]=e>>>0<256?e:(e|0)>0?255:0;n=Epb(n|0,0,-130063606,0)|0;m=kpb(n|0,N|0,m|0,0)|0;n=N;l=h|2;e=(m&k[d+(l<<3)>>2])+(k[d+(l<<3)+4>>2]|0)|0;m=Epb(m|0,0,-130063606,0)|0;g=kpb(m|0,N|0,n|0,0)|0;f=N;n=h|3;m=(g&k[d+(n<<3)>>2])+(k[d+(n<<3)+4>>2]|0)|0;i[a+l>>0]=e>>>0<256?e:(e|0)>0?255:0;i[a+n>>0]=m>>>0<256?m:(m|0)>0?255:0;h=h+4|0}while((h|0)<=(j|0));h=b&-4}if((h|0)>=(b|0)){l=g;n=f;o=c;m=o;k[m>>2]=l;o=o+4|0;k[o>>2]=n;return}do{g=Epb(g|0,0,-130063606,0)|0;g=kpb(g|0,N|0,f|0,0)|0;f=N;o=(g&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;i[a+h>>0]=o>>>0<256?o:(o|0)>0?255:0;h=h+1|0}while((h|0)!=(b|0));o=c;n=o;k[n>>2]=g;o=o+4|0;k[o>>2]=f;return}function _6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;f=c;g=k[f>>2]|0;f=k[f+4>>2]|0;j=b+-4|0;h=(b|0)<4;if(e)if(h)h=0;else{h=0;do{e=Epb(g|0,0,-130063606,0)|0;g=kpb(e|0,N|0,f|0,0)|0;f=N;e=(g&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;m=h|1;n=(g>>8&k[d+(m<<3)>>2])+(k[d+(m<<3)+4>>2]|0)|0;i[a+h>>0]=(e+128|0)>>>0<256?e:(e|0)>0?127:128;i[a+m>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;m=h|2;n=(k[d+(m<<3)>>2]&g>>16)+(k[d+(m<<3)+4>>2]|0)|0;e=h|3;l=(k[d+(e<<3)>>2]&g>>24)+(k[d+(e<<3)+4>>2]|0)|0;i[a+m>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;i[a+e>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;h=h+4|0}while((h|0)<=(j|0));h=b&-4}else if(h)h=0;else{h=0;do{m=Epb(g|0,0,-130063606,0)|0;m=kpb(m|0,N|0,f|0,0)|0;n=N;o=(m&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;m=Epb(m|0,0,-130063606,0)|0;n=kpb(m|0,N|0,n|0,0)|0;m=N;l=h|1;e=(n&k[d+(l<<3)>>2])+(k[d+(l<<3)+4>>2]|0)|0;i[a+h>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;i[a+l>>0]=(e+128|0)>>>0<256?e:(e|0)>0?127:128;n=Epb(n|0,0,-130063606,0)|0;m=kpb(n|0,N|0,m|0,0)|0;n=N;l=h|2;e=(m&k[d+(l<<3)>>2])+(k[d+(l<<3)+4>>2]|0)|0;m=Epb(m|0,0,-130063606,0)|0;g=kpb(m|0,N|0,n|0,0)|0;f=N;n=h|3;m=(g&k[d+(n<<3)>>2])+(k[d+(n<<3)+4>>2]|0)|0;i[a+l>>0]=(e+128|0)>>>0<256?e:(e|0)>0?127:128;i[a+n>>0]=(m+128|0)>>>0<256?m:(m|0)>0?127:128;h=h+4|0}while((h|0)<=(j|0));h=b&-4}if((h|0)>=(b|0)){l=g;n=f;o=c;m=o;k[m>>2]=l;o=o+4|0;k[o>>2]=n;return}do{g=Epb(g|0,0,-130063606,0)|0;g=kpb(g|0,N|0,f|0,0)|0;f=N;o=(g&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;i[a+h>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;h=h+1|0}while((h|0)!=(b|0));o=c;n=o;k[n>>2]=g;o=o+4|0;k[o>>2]=f;return}function $6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0;f=c;g=k[f>>2]|0;f=k[f+4>>2]|0;i=b+-4|0;h=(b|0)<4;if(e)if(h)h=0;else{h=0;do{e=Epb(g|0,0,-130063606,0)|0;g=kpb(e|0,N|0,f|0,0)|0;f=N;e=(g&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;m=h|1;n=(g>>8&k[d+(m<<3)>>2])+(k[d+(m<<3)+4>>2]|0)|0;j[a+(h<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;j[a+(m<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;m=h|2;n=(k[d+(m<<3)>>2]&g>>16)+(k[d+(m<<3)+4>>2]|0)|0;e=h|3;l=(k[d+(e<<3)>>2]&g>>24)+(k[d+(e<<3)+4>>2]|0)|0;j[a+(m<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;j[a+(e<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;h=h+4|0}while((h|0)<=(i|0));h=b&-4}else if(h)h=0;else{h=0;do{m=Epb(g|0,0,-130063606,0)|0;m=kpb(m|0,N|0,f|0,0)|0;n=N;o=(m&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;m=Epb(m|0,0,-130063606,0)|0;n=kpb(m|0,N|0,n|0,0)|0;m=N;l=h|1;e=(n&k[d+(l<<3)>>2])+(k[d+(l<<3)+4>>2]|0)|0;j[a+(h<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;j[a+(l<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;n=Epb(n|0,0,-130063606,0)|0;m=kpb(n|0,N|0,m|0,0)|0;n=N;l=h|2;e=(m&k[d+(l<<3)>>2])+(k[d+(l<<3)+4>>2]|0)|0;m=Epb(m|0,0,-130063606,0)|0;g=kpb(m|0,N|0,n|0,0)|0;f=N;n=h|3;m=(g&k[d+(n<<3)>>2])+(k[d+(n<<3)+4>>2]|0)|0;j[a+(l<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;j[a+(n<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;h=h+4|0}while((h|0)<=(i|0));h=b&-4}if((h|0)>=(b|0)){l=g;n=f;o=c;m=o;k[m>>2]=l;o=o+4|0;k[o>>2]=n;return}do{g=Epb(g|0,0,-130063606,0)|0;g=kpb(g|0,N|0,f|0,0)|0;f=N;o=(g&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;j[a+(h<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;h=h+1|0}while((h|0)!=(b|0));o=c;n=o;k[n>>2]=g;o=o+4|0;k[o>>2]=f;return}function a7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0;f=c;g=k[f>>2]|0;f=k[f+4>>2]|0;i=b+-4|0;h=(b|0)<4;if(e)if(h)h=0;else{h=0;do{e=Epb(g|0,0,-130063606,0)|0;g=kpb(e|0,N|0,f|0,0)|0;f=N;e=(g&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;m=h|1;n=(g>>8&k[d+(m<<3)>>2])+(k[d+(m<<3)+4>>2]|0)|0;j[a+(h<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;j[a+(m<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;m=h|2;n=(k[d+(m<<3)>>2]&g>>16)+(k[d+(m<<3)+4>>2]|0)|0;e=h|3;l=(k[d+(e<<3)>>2]&g>>24)+(k[d+(e<<3)+4>>2]|0)|0;j[a+(m<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;j[a+(e<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;h=h+4|0}while((h|0)<=(i|0));h=b&-4}else if(h)h=0;else{h=0;do{m=Epb(g|0,0,-130063606,0)|0;m=kpb(m|0,N|0,f|0,0)|0;n=N;o=(m&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;m=Epb(m|0,0,-130063606,0)|0;n=kpb(m|0,N|0,n|0,0)|0;m=N;l=h|1;e=(n&k[d+(l<<3)>>2])+(k[d+(l<<3)+4>>2]|0)|0;j[a+(h<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;j[a+(l<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;n=Epb(n|0,0,-130063606,0)|0;m=kpb(n|0,N|0,m|0,0)|0;n=N;l=h|2;e=(m&k[d+(l<<3)>>2])+(k[d+(l<<3)+4>>2]|0)|0;m=Epb(m|0,0,-130063606,0)|0;g=kpb(m|0,N|0,n|0,0)|0;f=N;n=h|3;m=(g&k[d+(n<<3)>>2])+(k[d+(n<<3)+4>>2]|0)|0;j[a+(l<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;j[a+(n<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;h=h+4|0}while((h|0)<=(i|0));h=b&-4}if((h|0)>=(b|0)){l=g;n=f;o=c;m=o;k[m>>2]=l;o=o+4|0;k[o>>2]=n;return}do{g=Epb(g|0,0,-130063606,0)|0;g=kpb(g|0,N|0,f|0,0)|0;f=N;o=(g&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;j[a+(h<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;h=h+1|0}while((h|0)!=(b|0));o=c;n=o;k[n>>2]=g;o=o+4|0;k[o>>2]=f;return}function b7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;f=c;g=k[f>>2]|0;f=k[f+4>>2]|0;i=b+-4|0;h=(b|0)<4;if(e)if(h)h=0;else{h=0;do{l=Epb(g|0,0,-130063606,0)|0;g=kpb(l|0,N|0,f|0,0)|0;f=N;l=h|1;e=(g>>8&k[d+(l<<3)>>2])+(k[d+(l<<3)+4>>2]|0)|0;k[a+(h<<2)>>2]=(g&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0);k[a+(l<<2)>>2]=e;l=h|2;e=h|3;j=(k[d+(e<<3)>>2]&g>>24)+(k[d+(e<<3)+4>>2]|0)|0;k[a+(l<<2)>>2]=(k[d+(l<<3)>>2]&g>>16)+(k[d+(l<<3)+4>>2]|0);k[a+(e<<2)>>2]=j;h=h+4|0}while((h|0)<=(i|0));h=b&-4}else if(h)h=0;else{h=0;do{j=Epb(g|0,0,-130063606,0)|0;j=kpb(j|0,N|0,f|0,0)|0;l=N;n=(j&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0)|0;j=Epb(j|0,0,-130063606,0)|0;l=kpb(j|0,N|0,l|0,0)|0;j=N;e=h|1;m=(l&k[d+(e<<3)>>2])+(k[d+(e<<3)+4>>2]|0)|0;k[a+(h<<2)>>2]=n;k[a+(e<<2)>>2]=m;l=Epb(l|0,0,-130063606,0)|0;j=kpb(l|0,N|0,j|0,0)|0;l=N;e=h|2;m=(j&k[d+(e<<3)>>2])+(k[d+(e<<3)+4>>2]|0)|0;j=Epb(j|0,0,-130063606,0)|0;g=kpb(j|0,N|0,l|0,0)|0;f=N;l=h|3;j=(g&k[d+(l<<3)>>2])+(k[d+(l<<3)+4>>2]|0)|0;k[a+(e<<2)>>2]=m;k[a+(l<<2)>>2]=j;h=h+4|0}while((h|0)<=(i|0));h=b&-4}if((h|0)>=(b|0)){j=g;m=f;n=c;l=n;k[l>>2]=j;n=n+4|0;k[n>>2]=m;return}do{g=Epb(g|0,0,-130063606,0)|0;g=kpb(g|0,N|0,f|0,0)|0;f=N;k[a+(h<<2)>>2]=(g&k[d+(h<<3)>>2])+(k[d+(h<<3)+4>>2]|0);h=h+1|0}while((h|0)!=(b|0));n=c;m=n;k[m>>2]=g;n=n+4|0;k[n>>2]=f;return}function c7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;e=(d|0)%4|0;e=(e|0)==0?4:e;a:do switch(e|0){case 1:{g=k[b>>2]|0;if((d|0)==1){upb(g|0,a|0,c|0)|0;e=1;break a}if((c|0)>0){e=0;f=0;while(1){i[g+e>>0]=i[a+f>>0]|0;e=e+1|0;if((e|0)==(c|0)){e=1;break}else f=f+d|0}}else return;break}case 2:{g=k[b>>2]|0;h=k[b+4>>2]|0;if((c|0)>0){e=0;f=0;while(1){i[g+f>>0]=i[a+e>>0]|0;i[h+f>>0]=i[a+(e+1)>>0]|0;f=f+1|0;if((f|0)==(c|0)){e=2;break}else e=e+d|0}}else return;break}case 3:{g=k[b>>2]|0;h=k[b+4>>2]|0;j=k[b+8>>2]|0;if((c|0)>0){e=0;f=0;while(1){i[g+f>>0]=i[a+e>>0]|0;i[h+f>>0]=i[a+(e+1)>>0]|0;i[j+f>>0]=i[a+(e+2)>>0]|0;f=f+1|0;if((f|0)==(c|0)){e=3;break}else e=e+d|0}}else return;break}default:{h=k[b>>2]|0;j=k[b+4>>2]|0;l=k[b+8>>2]|0;m=k[b+12>>2]|0;if((c|0)>0){f=0;g=0;while(1){i[h+g>>0]=i[a+f>>0]|0;i[j+g>>0]=i[a+(f+1)>>0]|0;i[l+g>>0]=i[a+(f+2)>>0]|0;i[m+g>>0]=i[a+(f+3)>>0]|0;g=g+1|0;if((g|0)==(c|0))break;else f=f+d|0}}else return}}while(0);if(!((c|0)>0&(e|0)<(d|0)))return;do{h=k[b+(e<<2)>>2]|0;j=k[b+(e+1<<2)>>2]|0;l=k[b+(e+2<<2)>>2]|0;m=k[b+(e+3<<2)>>2]|0;f=e;g=0;while(1){i[h+g>>0]=i[a+f>>0]|0;i[j+g>>0]=i[a+(f+1)>>0]|0;i[l+g>>0]=i[a+(f+2)>>0]|0;i[m+g>>0]=i[a+(f+3)>>0]|0;g=g+1|0;if((g|0)==(c|0))break;else f=f+d|0}e=e+4|0}while((e|0)<(d|0));return}function d7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,l=0,m=0;e=(d|0)%4|0;e=(e|0)==0?4:e;a:do switch(e|0){case 1:{g=k[b>>2]|0;if((d|0)==1){upb(g|0,a|0,c<<1|0)|0;e=1;break a}if((c|0)>0){e=0;f=0;while(1){j[g+(e<<1)>>1]=j[a+(f<<1)>>1]|0;e=e+1|0;if((e|0)==(c|0)){e=1;break}else f=f+d|0}}else return;break}case 2:{g=k[b>>2]|0;h=k[b+4>>2]|0;if((c|0)>0){e=0;f=0;while(1){j[g+(f<<1)>>1]=j[a+(e<<1)>>1]|0;j[h+(f<<1)>>1]=j[a+(e+1<<1)>>1]|0;f=f+1|0;if((f|0)==(c|0)){e=2;break}else e=e+d|0}}else return;break}case 3:{g=k[b>>2]|0;h=k[b+4>>2]|0;i=k[b+8>>2]|0;if((c|0)>0){e=0;f=0;while(1){j[g+(f<<1)>>1]=j[a+(e<<1)>>1]|0;j[h+(f<<1)>>1]=j[a+(e+1<<1)>>1]|0;j[i+(f<<1)>>1]=j[a+(e+2<<1)>>1]|0;f=f+1|0;if((f|0)==(c|0)){e=3;break}else e=e+d|0}}else return;break}default:{h=k[b>>2]|0;i=k[b+4>>2]|0;l=k[b+8>>2]|0;m=k[b+12>>2]|0;if((c|0)>0){f=0;g=0;while(1){j[h+(g<<1)>>1]=j[a+(f<<1)>>1]|0;j[i+(g<<1)>>1]=j[a+(f+1<<1)>>1]|0;j[l+(g<<1)>>1]=j[a+(f+2<<1)>>1]|0;j[m+(g<<1)>>1]=j[a+(f+3<<1)>>1]|0;g=g+1|0;if((g|0)==(c|0))break;else f=f+d|0}}else return}}while(0);if(!((c|0)>0&(e|0)<(d|0)))return;do{h=k[b+(e<<2)>>2]|0;i=k[b+(e+1<<2)>>2]|0;l=k[b+(e+2<<2)>>2]|0;m=k[b+(e+3<<2)>>2]|0;f=e;g=0;while(1){j[h+(g<<1)>>1]=j[a+(f<<1)>>1]|0;j[i+(g<<1)>>1]=j[a+(f+1<<1)>>1]|0;j[l+(g<<1)>>1]=j[a+(f+2<<1)>>1]|0;j[m+(g<<1)>>1]=j[a+(f+3<<1)>>1]|0;g=g+1|0;if((g|0)==(c|0))break;else f=f+d|0}e=e+4|0}while((e|0)<(d|0));return}function e7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0;e=(d|0)%4|0;e=(e|0)==0?4:e;a:do switch(e|0){case 1:{g=k[b>>2]|0;if((d|0)==1){upb(g|0,a|0,c<<2|0)|0;e=1;break a}if((c|0)>0){e=0;f=0;while(1){k[g+(e<<2)>>2]=k[a+(f<<2)>>2];e=e+1|0;if((e|0)==(c|0)){e=1;break}else f=f+d|0}}else return;break}case 2:{g=k[b>>2]|0;h=k[b+4>>2]|0;if((c|0)>0){e=0;f=0;while(1){k[g+(f<<2)>>2]=k[a+(e<<2)>>2];k[h+(f<<2)>>2]=k[a+(e+1<<2)>>2];f=f+1|0;if((f|0)==(c|0)){e=2;break}else e=e+d|0}}else return;break}case 3:{g=k[b>>2]|0;h=k[b+4>>2]|0;i=k[b+8>>2]|0;if((c|0)>0){e=0;f=0;while(1){k[g+(f<<2)>>2]=k[a+(e<<2)>>2];k[h+(f<<2)>>2]=k[a+(e+1<<2)>>2];k[i+(f<<2)>>2]=k[a+(e+2<<2)>>2];f=f+1|0;if((f|0)==(c|0)){e=3;break}else e=e+d|0}}else return;break}default:{h=k[b>>2]|0;i=k[b+4>>2]|0;j=k[b+8>>2]|0;l=k[b+12>>2]|0;if((c|0)>0){f=0;g=0;while(1){k[h+(g<<2)>>2]=k[a+(f<<2)>>2];k[i+(g<<2)>>2]=k[a+(f+1<<2)>>2];k[j+(g<<2)>>2]=k[a+(f+2<<2)>>2];k[l+(g<<2)>>2]=k[a+(f+3<<2)>>2];g=g+1|0;if((g|0)==(c|0))break;else f=f+d|0}}else return}}while(0);if(!((c|0)>0&(e|0)<(d|0)))return;do{h=k[b+(e<<2)>>2]|0;i=k[b+(e+1<<2)>>2]|0;j=k[b+(e+2<<2)>>2]|0;l=k[b+(e+3<<2)>>2]|0;f=e;g=0;while(1){k[h+(g<<2)>>2]=k[a+(f<<2)>>2];k[i+(g<<2)>>2]=k[a+(f+1<<2)>>2];k[j+(g<<2)>>2]=k[a+(f+2<<2)>>2];k[l+(g<<2)>>2]=k[a+(f+3<<2)>>2];g=g+1|0;if((g|0)==(c|0))break;else f=f+d|0}e=e+4|0}while((e|0)<(d|0));return}function f7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;e=(d|0)%4|0;e=(e|0)==0?4:e;a:do switch(e|0){case 1:{g=k[b>>2]|0;if((d|0)==1){upb(g|0,a|0,c<<3|0)|0;e=1;break a}if((c|0)>0){e=0;f=0;while(1){i=a+(f<<3)|0;j=k[i+4>>2]|0;l=g+(e<<3)|0;k[l>>2]=k[i>>2];k[l+4>>2]=j;e=e+1|0;if((e|0)==(c|0)){e=1;break}else f=f+d|0}}else return;break}case 2:{g=k[b>>2]|0;h=k[b+4>>2]|0;if((c|0)>0){e=0;f=0;while(1){l=a+(e<<3)|0;j=k[l+4>>2]|0;i=g+(f<<3)|0;k[i>>2]=k[l>>2];k[i+4>>2]=j;i=a+(e+1<<3)|0;j=k[i+4>>2]|0;l=h+(f<<3)|0;k[l>>2]=k[i>>2];k[l+4>>2]=j;f=f+1|0;if((f|0)==(c|0)){e=2;break}else e=e+d|0}}else return;break}case 3:{g=k[b>>2]|0;h=k[b+4>>2]|0;i=k[b+8>>2]|0;if((c|0)>0){e=0;f=0;while(1){m=a+(e<<3)|0;j=k[m+4>>2]|0;l=g+(f<<3)|0;k[l>>2]=k[m>>2];k[l+4>>2]=j;l=a+(e+1<<3)|0;j=k[l+4>>2]|0;m=h+(f<<3)|0;k[m>>2]=k[l>>2];k[m+4>>2]=j;m=a+(e+2<<3)|0;j=k[m+4>>2]|0;l=i+(f<<3)|0;k[l>>2]=k[m>>2];k[l+4>>2]=j;f=f+1|0;if((f|0)==(c|0)){e=3;break}else e=e+d|0}}else return;break}default:{h=k[b>>2]|0;i=k[b+4>>2]|0;j=k[b+8>>2]|0;l=k[b+12>>2]|0;if((c|0)>0){f=0;g=0;while(1){m=a+(f<<3)|0;n=k[m+4>>2]|0;o=h+(g<<3)|0;k[o>>2]=k[m>>2];k[o+4>>2]=n;o=a+(f+1<<3)|0;n=k[o+4>>2]|0;m=i+(g<<3)|0;k[m>>2]=k[o>>2];k[m+4>>2]=n;m=a+(f+2<<3)|0;n=k[m+4>>2]|0;o=j+(g<<3)|0;k[o>>2]=k[m>>2];k[o+4>>2]=n;o=a+(f+3<<3)|0;n=k[o+4>>2]|0;m=l+(g<<3)|0;k[m>>2]=k[o>>2];k[m+4>>2]=n;g=g+1|0;if((g|0)==(c|0))break;else f=f+d|0}}else return}}while(0);if(!((c|0)>0&(e|0)<(d|0)))return;do{h=k[b+(e<<2)>>2]|0;i=k[b+(e+1<<2)>>2]|0;j=k[b+(e+2<<2)>>2]|0;l=k[b+(e+3<<2)>>2]|0;f=e;g=0;while(1){o=a+(f<<3)|0;n=k[o+4>>2]|0;m=h+(g<<3)|0;k[m>>2]=k[o>>2];k[m+4>>2]=n;m=a+(f+1<<3)|0;n=k[m+4>>2]|0;o=i+(g<<3)|0;k[o>>2]=k[m>>2];k[o+4>>2]=n;o=a+(f+2<<3)|0;n=k[o+4>>2]|0;m=j+(g<<3)|0;k[m>>2]=k[o>>2];k[m+4>>2]=n;m=a+(f+3<<3)|0;n=k[m+4>>2]|0;o=l+(g<<3)|0;k[o>>2]=k[m>>2];k[o+4>>2]=n;g=g+1|0;if((g|0)==(c|0))break;else f=f+d|0}e=e+4|0}while((e|0)<(d|0));return}function g7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=r;r=r+1168|0;z=A+1112|0;l=A+1104|0;v=A+1096|0;x=A+1064|0;y=A;do if((k[b>>2]&2031616|0)==65536){e=k[b+4>>2]|0;k[z>>2]=k[e>>2];j=z+4|0;b=e+4|0;k[j>>2]=k[b>>2];u=z+8|0;k[u>>2]=k[e+8>>2];k[z+12>>2]=k[e+12>>2];k[z+16>>2]=k[e+16>>2];k[z+20>>2]=k[e+20>>2];k[z+24>>2]=k[e+24>>2];k[z+28>>2]=k[e+28>>2];k[z+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[z+36>>2]=c;d=z+40|0;k[d>>2]=u;u=z+48|0;g=z+44|0;k[g>>2]=u;k[z+52>>2]=0;k[u>>2]=0;if(c|0){u=c+12|0;k[u>>2]=(k[u>>2]|0)+1}if((k[b>>2]|0)<3){u=k[e+44>>2]|0;b=k[g>>2]|0;k[b>>2]=k[u>>2];k[b+4>>2]=k[u+4>>2];b=z;break}k[j>>2]=0;x1(z,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0));b=z}else b=z}else{Q1(z,b,-1);b=z}while(0);g=k[b>>2]|0;h=g>>>3&511;t=h+1|0;g=g&7;u=k[49704+(g<<2)>>2]|0;if(!((g|0)!=7&t>>>0<5)){k[l>>2]=0;b=l+4|0;k[b>>2]=0;c=ZT(28)|0;k[c>>2]=1;d=c+4|0;k[l>>2]=d;k[b>>2]=20;i[c+24>>0]=0;e=229871;f=d+20|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,l,367803,229892,1210);k[b>>2]=0;k[l>>2]=0;s=k[c>>2]|0;k[c>>2]=s+-1;if((s|0)==1)ggb(k[c+-4>>2]|0)}k[l>>2]=z;k[l+4>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;k[x+16>>2]=0;k[x+20>>2]=0;k[x+24>>2]=0;k[x+28>>2]=0;z1(x,l,0,v,-1);k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;k[a+24>>2]=0;k[a+28>>2]=0;n=k[x+20>>2]|0;q=y+8|0;k[y>>2]=q;s=y+4|0;k[s>>2]=264;o=g>>>0<4;if(o){e=g>>>0<2?8388608:32768;d=(e|0)<(n|0)?e:n;if(t>>>0>264){c=t<<2;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[y>>2]=b}else b=q;k[s>>2]=t;zpb(b|0,0,(h<<2)+4|0)|0;c=k[z+4>>2]|0;if((c|0)>0){m=d;l=e;h=k[(k[z+44>>2]|0)+(c+-1<<2)>>2]|0}else{m=d;l=e;h=0}}else{m=n;l=0;h=0;b=a}j=x+16|0;a:do if((n|0)>0){c=0;d=0;while(1){if(c>>>0>=(k[j>>2]|0)>>>0)break a;c=c+1|0;e=k[v>>2]|0;if(o){g=0;do{f=n-g|0;f=(m|0)<(f|0)?m:f;$g[u&127](e,0,b,f,t)|0;d=f+d|0;if(!((d+m|0)<(l|0)?((f+g|0)<(n|0)?1:c>>>0<(k[j>>2]|0)>>>0):0)){d=0;w=31}if((w|0)==31)while(1){w=0;e=b+(d<<2)|0;B=a+(d<<3)|0;p[B>>3]=+p[B>>3]+ +(k[e>>2]|0);k[e>>2]=0;d=d+1|0;if((d|0)==(t|0)){d=0;break}else w=31}e=aa(f,h)|0;e=(k[v>>2]|0)+e|0;k[v>>2]=e;g=g+m|0}while((n|0)>(g|0))}else{f=0;do{B=n-f|0;B=(m|0)<(B|0)?m:B;$g[u&127](e,0,b,B,t)|0;d=B+d|0;B=aa(B,h)|0;e=(k[v>>2]|0)+B|0;k[v>>2]=e;f=f+m|0}while((n|0)>(f|0))}A1(x)}}else{b=0;while(1){if(b>>>0>=(k[j>>2]|0)>>>0)break a;A1(x);b=b+1|0}}while(0);b=k[y>>2]|0;if((b|0)!=(q|0)){if(b|0)ggb(b);k[y>>2]=q;k[s>>2]=264}d=z+36|0;b=k[d>>2]|0;if(b|0?(y=b+12|0,B=k[y>>2]|0,k[y>>2]=B+-1,(B|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[z+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;B=z+16|0;c=z+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[c>>2]|0)>0){d=k[z+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[z+44>>2]|0;if((b|0)==(z+48|0)|(b|0)==0){r=A;return}ggb(k[b+-4>>2]|0);r=A;return}function h7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0;if(!b){r=(e|0)%4|0;switch(r|0){case 1:{g=k[c>>2]|0;o=d+-4|0;if((d|0)<4){h=a;f=0}else{j=e<<1;m=e*3|0;n=e<<2;h=a;f=0;while(1){g=(l[h>>0]|0)+g+(l[h+e>>0]|0)+(l[h+j>>0]|0)+(l[h+m>>0]|0)|0;f=f+4|0;if((f|0)>(o|0))break;else h=h+n|0}f=d&-4;h=a+(aa(f,e)|0)|0}if((f|0)<(d|0))while(1){g=(l[h>>0]|0)+g|0;f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+e|0}k[c>>2]=g;break}case 2:{g=k[c>>2]|0;m=c+4|0;f=k[m>>2]|0;if((d|0)>0){h=0;j=a;while(1){g=(l[j>>0]|0)+g|0;f=(l[j+1>>0]|0)+f|0;h=h+1|0;if((h|0)==(d|0)){h=f;f=d;break}else j=j+e|0}}else{h=f;f=0}k[c>>2]=g;k[m>>2]=h;break}case 3:{g=k[c>>2]|0;n=c+4|0;h=k[n>>2]|0;o=c+8|0;f=k[o>>2]|0;if((d|0)>0){j=0;m=a;while(1){g=(l[m>>0]|0)+g|0;h=(l[m+1>>0]|0)+h|0;f=(l[m+2>>0]|0)+f|0;j=j+1|0;if((j|0)==(d|0)){j=f;f=d;break}else m=m+e|0}}else{j=f;f=0}k[c>>2]=g;k[n>>2]=h;k[o>>2]=j;break}default:f=0}if((r|0)>=(e|0)){c=d;return c|0}do{o=c+(r<<2)|0;h=k[o>>2]|0;p=c+(r+1<<2)|0;m=k[p>>2]|0;b=c+(r+2<<2)|0;j=k[b>>2]|0;q=c+(r+3<<2)|0;g=k[q>>2]|0;if((f|0)<(d|0)){n=a+(aa(f,e)|0)+r|0;while(1){h=(l[n>>0]|0)+h|0;m=(l[n+1>>0]|0)+m|0;j=(l[n+2>>0]|0)+j|0;g=(l[n+3>>0]|0)+g|0;f=f+1|0;if((f|0)==(d|0)){f=d;break}else n=n+e|0}}k[o>>2]=h;k[p>>2]=m;k[b>>2]=j;k[q>>2]=g;r=r+4|0}while((r|0)<(e|0));f=d;return f|0}switch(e|0){case 1:{g=k[c>>2]|0;if((d|0)>0){f=0;h=0;do{if(i[b+h>>0]|0){g=(l[a+h>>0]|0)+g|0;f=f+1|0}h=h+1|0}while((h|0)!=(d|0))}else f=0;k[c>>2]=g;c=f;return c|0}case 3:{g=k[c>>2]|0;o=c+4|0;h=k[o>>2]|0;p=c+8|0;f=k[p>>2]|0;if((d|0)>0){j=f;n=0;f=0;m=a;while(1){if(i[b+n>>0]|0){j=(l[m+2>>0]|0)+j|0;h=(l[m+1>>0]|0)+h|0;g=(l[m>>0]|0)+g|0;f=f+1|0}n=n+1|0;if((n|0)==(d|0))break;else m=m+3|0}}else{j=f;f=0}k[c>>2]=g;k[o>>2]=h;k[p>>2]=j;c=f;return c|0}default:{if((d|0)<=0){c=0;return c|0}n=e+-4|0;if((e|0)<4){if((e|0)>0){j=0;f=0;h=a}else{g=0;f=0;do{f=f+((i[b+g>>0]|0)!=0&1)|0;g=g+1|0}while((g|0)!=(d|0));return f|0}while(1){if(i[b+j>>0]|0){g=0;do{a=c+(g<<2)|0;k[a>>2]=(k[a>>2]|0)+(l[h+g>>0]|0);g=g+1|0}while((g|0)!=(e|0));f=f+1|0}j=j+1|0;if((j|0)==(d|0))break;else h=h+e|0}return f|0}m=e&-4;if((m|0)<(e|0)){j=0;f=0;h=a}else{j=0;f=0;h=a;while(1){if(i[b+j>>0]|0){g=0;do{r=c+(g<<2)|0;q=g|1;p=c+(q<<2)|0;q=(l[h+q>>0]|0)+(k[p>>2]|0)|0;k[r>>2]=(l[h+g>>0]|0)+(k[r>>2]|0);k[p>>2]=q;p=g|2;q=c+(p<<2)|0;r=g|3;a=c+(r<<2)|0;r=(l[h+r>>0]|0)+(k[a>>2]|0)|0;k[q>>2]=(l[h+p>>0]|0)+(k[q>>2]|0);k[a>>2]=r;g=g+4|0}while((g|0)<=(n|0));f=f+1|0}j=j+1|0;if((j|0)==(d|0))break;else h=h+e|0}return f|0}while(1){if(i[b+j>>0]|0){g=0;do{r=c+(g<<2)|0;q=g|1;p=c+(q<<2)|0;q=(l[h+q>>0]|0)+(k[p>>2]|0)|0;k[r>>2]=(l[h+g>>0]|0)+(k[r>>2]|0);k[p>>2]=q;p=g|2;q=c+(p<<2)|0;r=g|3;a=c+(r<<2)|0;r=(l[h+r>>0]|0)+(k[a>>2]|0)|0;k[q>>2]=(l[h+p>>0]|0)+(k[q>>2]|0);k[a>>2]=r;g=g+4|0}while((g|0)<=(n|0));g=m;do{a=c+(g<<2)|0;k[a>>2]=(k[a>>2]|0)+(l[h+g>>0]|0);g=g+1|0}while((g|0)!=(e|0));f=f+1|0}j=j+1|0;if((j|0)==(d|0))break;else h=h+e|0}return f|0}}return 0}function i7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!b){q=(e|0)%4|0;switch(q|0){case 1:{g=k[c>>2]|0;n=d+-4|0;if((d|0)<4){h=a;f=0}else{j=e<<1;l=e*3|0;m=e<<2;h=a;f=0;while(1){g=(i[h>>0]|0)+g+(i[h+e>>0]|0)+(i[h+j>>0]|0)+(i[h+l>>0]|0)|0;f=f+4|0;if((f|0)>(n|0))break;else h=h+m|0}f=d&-4;h=a+(aa(f,e)|0)|0}if((f|0)<(d|0))while(1){g=(i[h>>0]|0)+g|0;f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+e|0}k[c>>2]=g;break}case 2:{g=k[c>>2]|0;l=c+4|0;f=k[l>>2]|0;if((d|0)>0){h=0;j=a;while(1){g=(i[j>>0]|0)+g|0;f=(i[j+1>>0]|0)+f|0;h=h+1|0;if((h|0)==(d|0)){h=f;f=d;break}else j=j+e|0}}else{h=f;f=0}k[c>>2]=g;k[l>>2]=h;break}case 3:{g=k[c>>2]|0;m=c+4|0;h=k[m>>2]|0;n=c+8|0;f=k[n>>2]|0;if((d|0)>0){j=0;l=a;while(1){g=(i[l>>0]|0)+g|0;h=(i[l+1>>0]|0)+h|0;f=(i[l+2>>0]|0)+f|0;j=j+1|0;if((j|0)==(d|0)){j=f;f=d;break}else l=l+e|0}}else{j=f;f=0}k[c>>2]=g;k[m>>2]=h;k[n>>2]=j;break}default:f=0}if((q|0)>=(e|0)){c=d;return c|0}do{n=c+(q<<2)|0;h=k[n>>2]|0;o=c+(q+1<<2)|0;l=k[o>>2]|0;b=c+(q+2<<2)|0;j=k[b>>2]|0;p=c+(q+3<<2)|0;g=k[p>>2]|0;if((f|0)<(d|0)){m=a+(aa(f,e)|0)+q|0;while(1){h=(i[m>>0]|0)+h|0;l=(i[m+1>>0]|0)+l|0;j=(i[m+2>>0]|0)+j|0;g=(i[m+3>>0]|0)+g|0;f=f+1|0;if((f|0)==(d|0)){f=d;break}else m=m+e|0}}k[n>>2]=h;k[o>>2]=l;k[b>>2]=j;k[p>>2]=g;q=q+4|0}while((q|0)<(e|0));f=d;return f|0}switch(e|0){case 1:{g=k[c>>2]|0;if((d|0)>0){f=0;h=0;do{if(i[b+h>>0]|0){g=(i[a+h>>0]|0)+g|0;f=f+1|0}h=h+1|0}while((h|0)!=(d|0))}else f=0;k[c>>2]=g;c=f;return c|0}case 3:{g=k[c>>2]|0;n=c+4|0;h=k[n>>2]|0;o=c+8|0;f=k[o>>2]|0;if((d|0)>0){j=f;m=0;f=0;l=a;while(1){if(i[b+m>>0]|0){j=(i[l+2>>0]|0)+j|0;h=(i[l+1>>0]|0)+h|0;g=(i[l>>0]|0)+g|0;f=f+1|0}m=m+1|0;if((m|0)==(d|0))break;else l=l+3|0}}else{j=f;f=0}k[c>>2]=g;k[n>>2]=h;k[o>>2]=j;c=f;return c|0}default:{if((d|0)<=0){c=0;return c|0}m=e+-4|0;if((e|0)<4){if((e|0)>0){j=0;f=0;h=a}else{g=0;f=0;do{f=f+((i[b+g>>0]|0)!=0&1)|0;g=g+1|0}while((g|0)!=(d|0));return f|0}while(1){if(i[b+j>>0]|0){g=0;do{a=c+(g<<2)|0;k[a>>2]=(k[a>>2]|0)+(i[h+g>>0]|0);g=g+1|0}while((g|0)!=(e|0));f=f+1|0}j=j+1|0;if((j|0)==(d|0))break;else h=h+e|0}return f|0}l=e&-4;if((l|0)<(e|0)){j=0;f=0;h=a}else{j=0;f=0;h=a;while(1){if(i[b+j>>0]|0){g=0;do{q=c+(g<<2)|0;p=g|1;o=c+(p<<2)|0;p=(i[h+p>>0]|0)+(k[o>>2]|0)|0;k[q>>2]=(i[h+g>>0]|0)+(k[q>>2]|0);k[o>>2]=p;o=g|2;p=c+(o<<2)|0;q=g|3;a=c+(q<<2)|0;q=(i[h+q>>0]|0)+(k[a>>2]|0)|0;k[p>>2]=(i[h+o>>0]|0)+(k[p>>2]|0);k[a>>2]=q;g=g+4|0}while((g|0)<=(m|0));f=f+1|0}j=j+1|0;if((j|0)==(d|0))break;else h=h+e|0}return f|0}while(1){if(i[b+j>>0]|0){g=0;do{q=c+(g<<2)|0;p=g|1;o=c+(p<<2)|0;p=(i[h+p>>0]|0)+(k[o>>2]|0)|0;k[q>>2]=(i[h+g>>0]|0)+(k[q>>2]|0);k[o>>2]=p;o=g|2;p=c+(o<<2)|0;q=g|3;a=c+(q<<2)|0;q=(i[h+q>>0]|0)+(k[a>>2]|0)|0;k[p>>2]=(i[h+o>>0]|0)+(k[p>>2]|0);k[a>>2]=q;g=g+4|0}while((g|0)<=(m|0));g=l;do{a=c+(g<<2)|0;k[a>>2]=(k[a>>2]|0)+(i[h+g>>0]|0);g=g+1|0}while((g|0)!=(e|0));f=f+1|0}j=j+1|0;if((j|0)==(d|0))break;else h=h+e|0}return f|0}}return 0}function j7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,n=0,o=0,p=0,q=0,r=0;if(!b){r=(e|0)%4|0;switch(r|0){case 1:{g=k[c>>2]|0;p=d+-4|0;if((d|0)<4){h=a;f=0}else{j=e<<1;l=e*3|0;n=e<<2;b=p>>>2;o=(b<<3)+8|0;h=a;f=0;while(1){g=(m[h>>1]|0)+g+(m[h+(e<<1)>>1]|0)+(m[h+(j<<1)>>1]|0)+(m[h+(l<<1)>>1]|0)|0;f=f+4|0;if((f|0)>(p|0))break;else h=h+(n<<1)|0}h=a+(aa(o,e)|0)|0;f=(b<<2)+4|0}if((f|0)<(d|0))while(1){g=(m[h>>1]|0)+g|0;f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<1)|0}k[c>>2]=g;break}case 2:{g=k[c>>2]|0;l=c+4|0;f=k[l>>2]|0;if((d|0)>0){h=0;j=a;while(1){g=(m[j>>1]|0)+g|0;f=(m[j+2>>1]|0)+f|0;h=h+1|0;if((h|0)==(d|0)){h=f;f=d;break}else j=j+(e<<1)|0}}else{h=f;f=0}k[c>>2]=g;k[l>>2]=h;break}case 3:{g=k[c>>2]|0;n=c+4|0;h=k[n>>2]|0;o=c+8|0;f=k[o>>2]|0;if((d|0)>0){j=0;l=a;while(1){g=(m[l>>1]|0)+g|0;h=(m[l+2>>1]|0)+h|0;f=(m[l+4>>1]|0)+f|0;j=j+1|0;if((j|0)==(d|0)){j=f;f=d;break}else l=l+(e<<1)|0}}else{j=f;f=0}k[c>>2]=g;k[n>>2]=h;k[o>>2]=j;break}default:f=0}if((r|0)>=(e|0)){c=d;return c|0}do{o=c+(r<<2)|0;h=k[o>>2]|0;p=c+(r+1<<2)|0;l=k[p>>2]|0;b=c+(r+2<<2)|0;j=k[b>>2]|0;q=c+(r+3<<2)|0;g=k[q>>2]|0;if((f|0)<(d|0)){n=a+((aa(f,e)|0)<<1)+(r<<1)|0;while(1){h=(m[n>>1]|0)+h|0;l=(m[n+2>>1]|0)+l|0;j=(m[n+4>>1]|0)+j|0;g=(m[n+6>>1]|0)+g|0;f=f+1|0;if((f|0)==(d|0)){f=d;break}else n=n+(e<<1)|0}}k[o>>2]=h;k[p>>2]=l;k[b>>2]=j;k[q>>2]=g;r=r+4|0}while((r|0)<(e|0));f=d;return f|0}switch(e|0){case 1:{g=k[c>>2]|0;if((d|0)>0){f=0;h=0;do{if(i[b+h>>0]|0){g=(m[a+(h<<1)>>1]|0)+g|0;f=f+1|0}h=h+1|0}while((h|0)!=(d|0))}else f=0;k[c>>2]=g;c=f;return c|0}case 3:{g=k[c>>2]|0;o=c+4|0;h=k[o>>2]|0;p=c+8|0;f=k[p>>2]|0;if((d|0)>0){j=f;n=0;f=0;l=a;while(1){if(i[b+n>>0]|0){j=(m[l+4>>1]|0)+j|0;h=(m[l+2>>1]|0)+h|0;g=(m[l>>1]|0)+g|0;f=f+1|0}n=n+1|0;if((n|0)==(d|0))break;else l=l+6|0}}else{j=f;f=0}k[c>>2]=g;k[o>>2]=h;k[p>>2]=j;c=f;return c|0}default:{if((d|0)<=0){c=0;return c|0}n=e+-4|0;if((e|0)<4){if((e|0)>0){j=0;f=0;h=a}else{g=0;f=0;do{f=f+((i[b+g>>0]|0)!=0&1)|0;g=g+1|0}while((g|0)!=(d|0));return f|0}while(1){if(i[b+j>>0]|0){g=0;do{a=c+(g<<2)|0;k[a>>2]=(k[a>>2]|0)+(m[h+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(e|0));f=f+1|0}j=j+1|0;if((j|0)==(d|0))break;else h=h+(e<<1)|0}return f|0}l=e&-4;if((l|0)<(e|0)){j=0;f=0;h=a}else{j=0;f=0;h=a;while(1){if(i[b+j>>0]|0){g=0;do{r=c+(g<<2)|0;q=g|1;p=c+(q<<2)|0;q=(m[h+(q<<1)>>1]|0)+(k[p>>2]|0)|0;k[r>>2]=(m[h+(g<<1)>>1]|0)+(k[r>>2]|0);k[p>>2]=q;p=g|2;q=c+(p<<2)|0;r=g|3;a=c+(r<<2)|0;r=(m[h+(r<<1)>>1]|0)+(k[a>>2]|0)|0;k[q>>2]=(m[h+(p<<1)>>1]|0)+(k[q>>2]|0);k[a>>2]=r;g=g+4|0}while((g|0)<=(n|0));f=f+1|0}j=j+1|0;if((j|0)==(d|0))break;else h=h+(e<<1)|0}return f|0}while(1){if(i[b+j>>0]|0){g=0;do{r=c+(g<<2)|0;q=g|1;p=c+(q<<2)|0;q=(m[h+(q<<1)>>1]|0)+(k[p>>2]|0)|0;k[r>>2]=(m[h+(g<<1)>>1]|0)+(k[r>>2]|0);k[p>>2]=q;p=g|2;q=c+(p<<2)|0;r=g|3;a=c+(r<<2)|0;r=(m[h+(r<<1)>>1]|0)+(k[a>>2]|0)|0;k[q>>2]=(m[h+(p<<1)>>1]|0)+(k[q>>2]|0);k[a>>2]=r;g=g+4|0}while((g|0)<=(n|0));g=l;do{a=c+(g<<2)|0;k[a>>2]=(k[a>>2]|0)+(m[h+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(e|0));f=f+1|0}j=j+1|0;if((j|0)==(d|0))break;else h=h+(e<<1)|0}return f|0}}return 0}function k7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(!b){r=(e|0)%4|0;switch(r|0){case 1:{g=k[c>>2]|0;p=d+-4|0;if((d|0)<4){h=a;f=0}else{l=e<<1;m=e*3|0;n=e<<2;b=p>>>2;o=(b<<3)+8|0;h=a;f=0;while(1){g=(j[h>>1]|0)+g+(j[h+(e<<1)>>1]|0)+(j[h+(l<<1)>>1]|0)+(j[h+(m<<1)>>1]|0)|0;f=f+4|0;if((f|0)>(p|0))break;else h=h+(n<<1)|0}h=a+(aa(o,e)|0)|0;f=(b<<2)+4|0}if((f|0)<(d|0))while(1){g=(j[h>>1]|0)+g|0;f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<1)|0}k[c>>2]=g;break}case 2:{g=k[c>>2]|0;m=c+4|0;f=k[m>>2]|0;if((d|0)>0){h=0;l=a;while(1){g=(j[l>>1]|0)+g|0;f=(j[l+2>>1]|0)+f|0;h=h+1|0;if((h|0)==(d|0)){h=f;f=d;break}else l=l+(e<<1)|0}}else{h=f;f=0}k[c>>2]=g;k[m>>2]=h;break}case 3:{g=k[c>>2]|0;n=c+4|0;h=k[n>>2]|0;o=c+8|0;f=k[o>>2]|0;if((d|0)>0){l=0;m=a;while(1){g=(j[m>>1]|0)+g|0;h=(j[m+2>>1]|0)+h|0;f=(j[m+4>>1]|0)+f|0;l=l+1|0;if((l|0)==(d|0)){l=f;f=d;break}else m=m+(e<<1)|0}}else{l=f;f=0}k[c>>2]=g;k[n>>2]=h;k[o>>2]=l;break}default:f=0}if((r|0)>=(e|0)){c=d;return c|0}do{o=c+(r<<2)|0;h=k[o>>2]|0;p=c+(r+1<<2)|0;m=k[p>>2]|0;b=c+(r+2<<2)|0;l=k[b>>2]|0;q=c+(r+3<<2)|0;g=k[q>>2]|0;if((f|0)<(d|0)){n=a+((aa(f,e)|0)<<1)+(r<<1)|0;while(1){h=(j[n>>1]|0)+h|0;m=(j[n+2>>1]|0)+m|0;l=(j[n+4>>1]|0)+l|0;g=(j[n+6>>1]|0)+g|0;f=f+1|0;if((f|0)==(d|0)){f=d;break}else n=n+(e<<1)|0}}k[o>>2]=h;k[p>>2]=m;k[b>>2]=l;k[q>>2]=g;r=r+4|0}while((r|0)<(e|0));f=d;return f|0}switch(e|0){case 1:{g=k[c>>2]|0;if((d|0)>0){f=0;h=0;do{if(i[b+h>>0]|0){g=(j[a+(h<<1)>>1]|0)+g|0;f=f+1|0}h=h+1|0}while((h|0)!=(d|0))}else f=0;k[c>>2]=g;c=f;return c|0}case 3:{g=k[c>>2]|0;o=c+4|0;h=k[o>>2]|0;p=c+8|0;f=k[p>>2]|0;if((d|0)>0){l=f;n=0;f=0;m=a;while(1){if(i[b+n>>0]|0){l=(j[m+4>>1]|0)+l|0;h=(j[m+2>>1]|0)+h|0;g=(j[m>>1]|0)+g|0;f=f+1|0}n=n+1|0;if((n|0)==(d|0))break;else m=m+6|0}}else{l=f;f=0}k[c>>2]=g;k[o>>2]=h;k[p>>2]=l;c=f;return c|0}default:{if((d|0)<=0){c=0;return c|0}n=e+-4|0;if((e|0)<4){if((e|0)>0){l=0;f=0;h=a}else{g=0;f=0;do{f=f+((i[b+g>>0]|0)!=0&1)|0;g=g+1|0}while((g|0)!=(d|0));return f|0}while(1){if(i[b+l>>0]|0){g=0;do{a=c+(g<<2)|0;k[a>>2]=(k[a>>2]|0)+(j[h+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(e|0));f=f+1|0}l=l+1|0;if((l|0)==(d|0))break;else h=h+(e<<1)|0}return f|0}m=e&-4;if((m|0)<(e|0)){l=0;f=0;h=a}else{l=0;f=0;h=a;while(1){if(i[b+l>>0]|0){g=0;do{r=c+(g<<2)|0;q=g|1;p=c+(q<<2)|0;q=(j[h+(q<<1)>>1]|0)+(k[p>>2]|0)|0;k[r>>2]=(j[h+(g<<1)>>1]|0)+(k[r>>2]|0);k[p>>2]=q;p=g|2;q=c+(p<<2)|0;r=g|3;a=c+(r<<2)|0;r=(j[h+(r<<1)>>1]|0)+(k[a>>2]|0)|0;k[q>>2]=(j[h+(p<<1)>>1]|0)+(k[q>>2]|0);k[a>>2]=r;g=g+4|0}while((g|0)<=(n|0));f=f+1|0}l=l+1|0;if((l|0)==(d|0))break;else h=h+(e<<1)|0}return f|0}while(1){if(i[b+l>>0]|0){g=0;do{r=c+(g<<2)|0;q=g|1;p=c+(q<<2)|0;q=(j[h+(q<<1)>>1]|0)+(k[p>>2]|0)|0;k[r>>2]=(j[h+(g<<1)>>1]|0)+(k[r>>2]|0);k[p>>2]=q;p=g|2;q=c+(p<<2)|0;r=g|3;a=c+(r<<2)|0;r=(j[h+(r<<1)>>1]|0)+(k[a>>2]|0)|0;k[q>>2]=(j[h+(p<<1)>>1]|0)+(k[q>>2]|0);k[a>>2]=r;g=g+4|0}while((g|0)<=(n|0));g=m;do{a=c+(g<<2)|0;k[a>>2]=(k[a>>2]|0)+(j[h+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(e|0));f=f+1|0}l=l+1|0;if((l|0)==(d|0))break;else h=h+(e<<1)|0}return f|0}}return 0}function l7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0,j=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0;if(!b){t=(e|0)%4|0;switch(t|0){case 1:{g=+p[c>>3];q=d+-4|0;if((d|0)<4){h=a;f=0}else{m=e<<1;n=e*3|0;o=e<<2;s=q>>>2;b=(s<<4)+16|0;h=a;f=0;while(1){g=g+ +((k[h+(e<<2)>>2]|0)+(k[h>>2]|0)+(k[h+(m<<2)>>2]|0)+(k[h+(n<<2)>>2]|0)|0);f=f+4|0;if((f|0)>(q|0))break;else h=h+(o<<2)|0}h=a+(aa(b,e)|0)|0;f=(s<<2)+4|0}if((f|0)<(d|0))while(1){g=g+ +(k[h>>2]|0);f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<2)|0}p[c>>3]=g;break}case 2:{j=+p[c>>3];m=c+8|0;g=+p[m>>3];if((d|0)>0){f=0;h=a;while(1){j=j+ +(k[h>>2]|0);g=g+ +(k[h+4>>2]|0);f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<2)|0}}else f=0;p[c>>3]=j;p[m>>3]=g;break}case 3:{j=+p[c>>3];m=c+8|0;l=+p[m>>3];n=c+16|0;g=+p[n>>3];if((d|0)>0){f=0;h=a;while(1){j=j+ +(k[h>>2]|0);l=l+ +(k[h+4>>2]|0);g=g+ +(k[h+8>>2]|0);f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<2)|0}}else f=0;p[c>>3]=j;p[m>>3]=l;p[n>>3]=g;break}default:f=0}if((t|0)<(e|0))q=t;else{c=d;return c|0}do{m=c+(q<<3)|0;j=+p[m>>3];n=c+(q+1<<3)|0;r=+p[n>>3];o=c+(q+2<<3)|0;l=+p[o>>3];b=c+(q+3<<3)|0;g=+p[b>>3];if((f|0)<(d|0)){h=a+((aa(f,e)|0)<<2)+(q<<2)|0;while(1){j=j+ +(k[h>>2]|0);r=r+ +(k[h+4>>2]|0);l=l+ +(k[h+8>>2]|0);g=g+ +(k[h+12>>2]|0);f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<2)|0}}p[m>>3]=j;p[n>>3]=r;p[o>>3]=l;p[b>>3]=g;q=q+4|0}while((q|0)<(e|0));f=d;return f|0}switch(e|0){case 1:{g=+p[c>>3];if((d|0)>0){f=0;h=0;do{if(i[b+h>>0]|0){g=g+ +(k[a+(h<<2)>>2]|0);f=f+1|0}h=h+1|0}while((h|0)!=(d|0))}else f=0;p[c>>3]=g;c=f;return c|0}case 3:{g=+p[c>>3];m=c+8|0;l=+p[m>>3];n=c+16|0;j=+p[n>>3];if((d|0)>0){h=0;f=0;while(1){if(i[b+h>>0]|0){j=j+ +(k[a+8>>2]|0);l=l+ +(k[a+4>>2]|0);g=g+ +(k[a>>2]|0);f=f+1|0}h=h+1|0;if((h|0)==(d|0))break;else a=a+12|0}}else f=0;p[c>>3]=g;p[m>>3]=l;p[n>>3]=j;c=f;return c|0}default:{if((d|0)<=0){c=0;return c|0}o=e+-4|0;if((e|0)<4){if((e|0)>0){m=0;f=0}else{h=0;f=0;do{f=f+((i[b+h>>0]|0)!=0&1)|0;h=h+1|0}while((h|0)!=(d|0));return f|0}while(1){if(i[b+m>>0]|0){h=0;do{t=c+(h<<3)|0;p[t>>3]=+p[t>>3]+ +(k[a+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f=f+1|0}m=m+1|0;if((m|0)==(d|0))break;else a=a+(e<<2)|0}return f|0}n=e&-4;if((n|0)<(e|0)){m=0;f=0}else{m=0;f=0;while(1){if(i[b+m>>0]|0){h=0;do{s=c+(h<<3)|0;n=h|1;q=c+(n<<3)|0;r=+p[q>>3]+ +(k[a+(n<<2)>>2]|0);p[s>>3]=+p[s>>3]+ +(k[a+(h<<2)>>2]|0);p[q>>3]=r;q=h|2;s=c+(q<<3)|0;n=h|3;t=c+(n<<3)|0;r=+p[t>>3]+ +(k[a+(n<<2)>>2]|0);p[s>>3]=+p[s>>3]+ +(k[a+(q<<2)>>2]|0);p[t>>3]=r;h=h+4|0}while((h|0)<=(o|0));f=f+1|0}m=m+1|0;if((m|0)==(d|0))break;else a=a+(e<<2)|0}return f|0}while(1){if(i[b+m>>0]|0){h=0;do{s=c+(h<<3)|0;u=h|1;q=c+(u<<3)|0;r=+p[q>>3]+ +(k[a+(u<<2)>>2]|0);p[s>>3]=+p[s>>3]+ +(k[a+(h<<2)>>2]|0);p[q>>3]=r;q=h|2;s=c+(q<<3)|0;u=h|3;t=c+(u<<3)|0;r=+p[t>>3]+ +(k[a+(u<<2)>>2]|0);p[s>>3]=+p[s>>3]+ +(k[a+(q<<2)>>2]|0);p[t>>3]=r;h=h+4|0}while((h|0)<=(o|0));h=n;do{u=c+(h<<3)|0;p[u>>3]=+p[u>>3]+ +(k[a+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f=f+1|0}m=m+1|0;if((m|0)==(d|0))break;else a=a+(e<<2)|0}return f|0}}return 0}function m7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0,j=0.0,k=0.0,l=0,m=0,n=0,q=0,r=0.0,s=0,t=0,u=0;if(!b){t=(e|0)%4|0;switch(t|0){case 1:{g=+p[c>>3];q=d+-4|0;if((d|0)<4){h=a;f=0}else{l=e<<1;m=e*3|0;n=e<<2;s=q>>>2;b=(s<<4)+16|0;h=a;f=0;while(1){g=g+(+o[h>>2]+ +o[h+(e<<2)>>2]+ +o[h+(l<<2)>>2]+ +o[h+(m<<2)>>2]);f=f+4|0;if((f|0)>(q|0))break;else h=h+(n<<2)|0}h=a+(aa(b,e)|0)|0;f=(s<<2)+4|0}if((f|0)<(d|0))while(1){g=g+ +o[h>>2];f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<2)|0}p[c>>3]=g;break}case 2:{j=+p[c>>3];l=c+8|0;g=+p[l>>3];if((d|0)>0){f=0;h=a;while(1){j=j+ +o[h>>2];g=g+ +o[h+4>>2];f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<2)|0}}else f=0;p[c>>3]=j;p[l>>3]=g;break}case 3:{j=+p[c>>3];l=c+8|0;k=+p[l>>3];m=c+16|0;g=+p[m>>3];if((d|0)>0){f=0;h=a;while(1){j=j+ +o[h>>2];k=k+ +o[h+4>>2];g=g+ +o[h+8>>2];f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<2)|0}}else f=0;p[c>>3]=j;p[l>>3]=k;p[m>>3]=g;break}default:f=0}if((t|0)<(e|0))q=t;else{c=d;return c|0}do{l=c+(q<<3)|0;j=+p[l>>3];m=c+(q+1<<3)|0;r=+p[m>>3];n=c+(q+2<<3)|0;k=+p[n>>3];b=c+(q+3<<3)|0;g=+p[b>>3];if((f|0)<(d|0)){h=a+((aa(f,e)|0)<<2)+(q<<2)|0;while(1){j=j+ +o[h>>2];r=r+ +o[h+4>>2];k=k+ +o[h+8>>2];g=g+ +o[h+12>>2];f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<2)|0}}p[l>>3]=j;p[m>>3]=r;p[n>>3]=k;p[b>>3]=g;q=q+4|0}while((q|0)<(e|0));f=d;return f|0}switch(e|0){case 1:{g=+p[c>>3];if((d|0)>0){f=0;h=0;do{if(i[b+h>>0]|0){g=g+ +o[a+(h<<2)>>2];f=f+1|0}h=h+1|0}while((h|0)!=(d|0))}else f=0;p[c>>3]=g;c=f;return c|0}case 3:{g=+p[c>>3];l=c+8|0;k=+p[l>>3];m=c+16|0;j=+p[m>>3];if((d|0)>0){h=0;f=0;while(1){if(i[b+h>>0]|0){j=j+ +o[a+8>>2];k=k+ +o[a+4>>2];g=g+ +o[a>>2];f=f+1|0}h=h+1|0;if((h|0)==(d|0))break;else a=a+12|0}}else f=0;p[c>>3]=g;p[l>>3]=k;p[m>>3]=j;c=f;return c|0}default:{if((d|0)<=0){c=0;return c|0}n=e+-4|0;if((e|0)<4){if((e|0)>0){l=0;f=0}else{h=0;f=0;do{f=f+((i[b+h>>0]|0)!=0&1)|0;h=h+1|0}while((h|0)!=(d|0));return f|0}while(1){if(i[b+l>>0]|0){h=0;do{t=c+(h<<3)|0;p[t>>3]=+p[t>>3]+ +o[a+(h<<2)>>2];h=h+1|0}while((h|0)!=(e|0));f=f+1|0}l=l+1|0;if((l|0)==(d|0))break;else a=a+(e<<2)|0}return f|0}m=e&-4;if((m|0)<(e|0)){l=0;f=0}else{l=0;f=0;while(1){if(i[b+l>>0]|0){h=0;do{s=c+(h<<3)|0;m=h|1;q=c+(m<<3)|0;r=+p[q>>3]+ +o[a+(m<<2)>>2];p[s>>3]=+p[s>>3]+ +o[a+(h<<2)>>2];p[q>>3]=r;q=h|2;s=c+(q<<3)|0;m=h|3;t=c+(m<<3)|0;r=+p[t>>3]+ +o[a+(m<<2)>>2];p[s>>3]=+p[s>>3]+ +o[a+(q<<2)>>2];p[t>>3]=r;h=h+4|0}while((h|0)<=(n|0));f=f+1|0}l=l+1|0;if((l|0)==(d|0))break;else a=a+(e<<2)|0}return f|0}while(1){if(i[b+l>>0]|0){h=0;do{s=c+(h<<3)|0;u=h|1;q=c+(u<<3)|0;r=+p[q>>3]+ +o[a+(u<<2)>>2];p[s>>3]=+p[s>>3]+ +o[a+(h<<2)>>2];p[q>>3]=r;q=h|2;s=c+(q<<3)|0;u=h|3;t=c+(u<<3)|0;r=+p[t>>3]+ +o[a+(u<<2)>>2];p[s>>3]=+p[s>>3]+ +o[a+(q<<2)>>2];p[t>>3]=r;h=h+4|0}while((h|0)<=(n|0));h=m;do{u=c+(h<<3)|0;p[u>>3]=+p[u>>3]+ +o[a+(h<<2)>>2];h=h+1|0}while((h|0)!=(e|0));f=f+1|0}l=l+1|0;if((l|0)==(d|0))break;else a=a+(e<<2)|0}return f|0}}return 0}function n7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0;if(!b){s=(e|0)%4|0;switch(s|0){case 1:{g=+p[c>>3];o=d+-4|0;if((d|0)<4){h=a;f=0}else{l=e<<1;m=e*3|0;n=e<<2;r=o>>>2;b=(r<<5)+32|0;h=a;f=0;while(1){g=g+(+p[h>>3]+ +p[h+(e<<3)>>3]+ +p[h+(l<<3)>>3]+ +p[h+(m<<3)>>3]);f=f+4|0;if((f|0)>(o|0))break;else h=h+(n<<3)|0}h=a+(aa(b,e)|0)|0;f=(r<<2)+4|0}if((f|0)<(d|0))while(1){g=g+ +p[h>>3];f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<3)|0}p[c>>3]=g;break}case 2:{j=+p[c>>3];l=c+8|0;g=+p[l>>3];if((d|0)>0){f=0;h=a;while(1){j=j+ +p[h>>3];g=g+ +p[h+8>>3];f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<3)|0}}else f=0;p[c>>3]=j;p[l>>3]=g;break}case 3:{j=+p[c>>3];l=c+8|0;k=+p[l>>3];m=c+16|0;g=+p[m>>3];if((d|0)>0){f=0;h=a;while(1){j=j+ +p[h>>3];k=k+ +p[h+8>>3];g=g+ +p[h+16>>3];f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<3)|0}}else f=0;p[c>>3]=j;p[l>>3]=k;p[m>>3]=g;break}default:f=0}if((s|0)<(e|0))o=s;else{c=d;return c|0}do{l=c+(o<<3)|0;j=+p[l>>3];m=c+(o+1<<3)|0;q=+p[m>>3];n=c+(o+2<<3)|0;k=+p[n>>3];b=c+(o+3<<3)|0;g=+p[b>>3];if((f|0)<(d|0)){h=a+((aa(f,e)|0)<<3)+(o<<3)|0;while(1){j=j+ +p[h>>3];q=q+ +p[h+8>>3];k=k+ +p[h+16>>3];g=g+ +p[h+24>>3];f=f+1|0;if((f|0)==(d|0)){f=d;break}else h=h+(e<<3)|0}}p[l>>3]=j;p[m>>3]=q;p[n>>3]=k;p[b>>3]=g;o=o+4|0}while((o|0)<(e|0));f=d;return f|0}switch(e|0){case 1:{g=+p[c>>3];if((d|0)>0){f=0;h=0;do{if(i[b+h>>0]|0){g=g+ +p[a+(h<<3)>>3];f=f+1|0}h=h+1|0}while((h|0)!=(d|0))}else f=0;p[c>>3]=g;c=f;return c|0}case 3:{g=+p[c>>3];l=c+8|0;k=+p[l>>3];m=c+16|0;j=+p[m>>3];if((d|0)>0){h=0;f=0;while(1){if(i[b+h>>0]|0){j=j+ +p[a+16>>3];k=k+ +p[a+8>>3];g=g+ +p[a>>3];f=f+1|0}h=h+1|0;if((h|0)==(d|0))break;else a=a+24|0}}else f=0;p[c>>3]=g;p[l>>3]=k;p[m>>3]=j;c=f;return c|0}default:{if((d|0)<=0){c=0;return c|0}n=e+-4|0;if((e|0)<4){if((e|0)>0){l=0;f=0}else{h=0;f=0;do{f=f+((i[b+h>>0]|0)!=0&1)|0;h=h+1|0}while((h|0)!=(d|0));return f|0}while(1){if(i[b+l>>0]|0){h=0;do{s=c+(h<<3)|0;p[s>>3]=+p[a+(h<<3)>>3]+ +p[s>>3];h=h+1|0}while((h|0)!=(e|0));f=f+1|0}l=l+1|0;if((l|0)==(d|0))break;else a=a+(e<<3)|0}return f|0}m=e&-4;if((m|0)<(e|0)){l=0;f=0}else{l=0;f=0;while(1){if(i[b+l>>0]|0){h=0;do{r=c+(h<<3)|0;m=h|1;o=c+(m<<3)|0;q=+p[o>>3]+ +p[a+(m<<3)>>3];p[r>>3]=+p[r>>3]+ +p[a+(h<<3)>>3];p[o>>3]=q;o=h|2;r=c+(o<<3)|0;m=h|3;s=c+(m<<3)|0;q=+p[s>>3]+ +p[a+(m<<3)>>3];p[r>>3]=+p[r>>3]+ +p[a+(o<<3)>>3];p[s>>3]=q;h=h+4|0}while((h|0)<=(n|0));f=f+1|0}l=l+1|0;if((l|0)==(d|0))break;else a=a+(e<<3)|0}return f|0}while(1){if(i[b+l>>0]|0){h=0;do{r=c+(h<<3)|0;t=h|1;o=c+(t<<3)|0;q=+p[o>>3]+ +p[a+(t<<3)>>3];p[r>>3]=+p[r>>3]+ +p[a+(h<<3)>>3];p[o>>3]=q;o=h|2;r=c+(o<<3)|0;t=h|3;s=c+(t<<3)|0;q=+p[s>>3]+ +p[a+(t<<3)>>3];p[r>>3]=+p[r>>3]+ +p[a+(o<<3)>>3];p[s>>3]=q;h=h+4|0}while((h|0)<=(n|0));h=m;do{t=c+(h<<3)|0;p[t>>3]=+p[a+(h<<3)>>3]+ +p[t>>3];h=h+1|0}while((h|0)!=(e|0));f=f+1|0}l=l+1|0;if((l|0)==(d|0))break;else a=a+(e<<3)|0}return f|0}}return 0}function o7(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+112|0;n=o+48|0;j=o+40|0;l=o+32|0;m=o;if((S1(a,-1)|0)&4088|0?(h=n+4|0,b=ZT(12)|0,k[b>>2]=1,g=b+4|0,k[n>>2]=g,k[h>>2]=7,i[b+11>>0]=0,i[g>>0]=i[401499]|0,i[g+1>>0]=i[401500]|0,i[g+2>>0]=i[401501]|0,i[g+3>>0]=i[401502]|0,i[g+4>>0]=i[401503]|0,i[g+5>>0]=i[401504]|0,i[g+6>>0]=i[401505]|0,Y8(-215,n,229955,229892,1342),k[h>>2]=0,k[n>>2]=0,h=k[b>>2]|0,k[b>>2]=h+-1,(h|0)==1):0)ggb(k[b+-4>>2]|0);do if((k[a>>2]&2031616|0)==65536){d=k[a+4>>2]|0;k[n>>2]=k[d>>2];h=n+4|0;a=d+4|0;k[h>>2]=k[a>>2];g=n+8|0;k[g>>2]=k[d+8>>2];k[n+12>>2]=k[d+12>>2];k[n+16>>2]=k[d+16>>2];k[n+20>>2]=k[d+20>>2];k[n+24>>2]=k[d+24>>2];k[n+28>>2]=k[d+28>>2];k[n+32>>2]=k[d+32>>2];b=k[d+36>>2]|0;k[n+36>>2]=b;c=n+40|0;k[c>>2]=g;g=n+48|0;f=n+44|0;k[f>>2]=g;k[n+52>>2]=0;k[g>>2]=0;if(b|0){g=b+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[a>>2]|0)<3){h=k[d+44>>2]|0;a=k[f>>2]|0;k[a>>2]=k[h>>2];k[a+4>>2]=k[h+4>>2];a=n;break}k[h>>2]=0;x1(n,k[a>>2]|0,0,0,0);if((k[h>>2]|0)>0){g=k[d+40>>2]|0;e=k[c>>2]|0;c=k[d+44>>2]|0;b=k[f>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[c+(a<<2)>>2];a=a+1|0}while((a|0)<(k[h>>2]|0));a=n}else a=n}else{Q1(n,a,-1);a=n}while(0);h=k[a>>2]&7;f=k[49736+(h<<2)>>2]|0;if((h|0)==7){k[j>>2]=0;a=j+4|0;k[a>>2]=0;b=ZT(16)|0;k[b>>2]=1;c=b+4|0;k[j>>2]=c;k[a>>2]=9;i[b+13>>0]=0;d=335726;e=c+9|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,j,229955,229892,1358);k[a>>2]=0;k[j>>2]=0;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1)ggb(k[b+-4>>2]|0)}k[j>>2]=n;k[j+4>>2]=0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[m+16>>2]=0;k[m+20>>2]=0;k[m+24>>2]=0;k[m+28>>2]=0;z1(m,j,0,l,-1);c=k[m+20>>2]|0;b=m+16|0;a=0;d=0;while(1){if(a>>>0>=(k[b>>2]|0)>>>0)break;j=(Hh[f&511](k[l>>2]|0,c)|0)+d|0;A1(m);a=a+1|0;d=j}c=n+36|0;a=k[c>>2]|0;if(a|0?(l=a+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;m=n+16|0;b=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[b>>2]|0)>0){c=k[n+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[n+44>>2]|0;if((a|0)==(n+48|0)|(a|0)==0){r=o;return d|0}ggb(k[a+-4>>2]|0);r=o;return d|0}function p7(a,b){a=a|0;b=b|0;var c=0,d=0;if((b|0)>0){c=0;d=0}else{b=0;return b|0}do{c=((i[a+d>>0]|0)!=0&1)+c|0;d=d+1|0}while((d|0)!=(b|0));return c|0}function q7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=b+-4|0;if((b|0)<4){c=0;d=0}else{d=0;c=0;do{c=((j[a+(d<<1)>>1]|0)!=0&1)+c+((j[a+((d|1)<<1)>>1]|0)!=0&1)+((j[a+((d|2)<<1)>>1]|0)!=0&1)+((j[a+((d|3)<<1)>>1]|0)!=0&1)|0;d=d+4|0}while((d|0)<=(e|0));d=b&-4}if((d|0)>=(b|0)){b=c;return b|0}do{c=((j[a+(d<<1)>>1]|0)!=0&1)+c|0;d=d+1|0}while((d|0)!=(b|0));return c|0}function r7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=b+-4|0;if((b|0)<4){c=0;d=0}else{d=0;c=0;do{c=((k[a+(d<<2)>>2]|0)!=0&1)+c+((k[a+((d|1)<<2)>>2]|0)!=0&1)+((k[a+((d|2)<<2)>>2]|0)!=0&1)+((k[a+((d|3)<<2)>>2]|0)!=0&1)|0;d=d+4|0}while((d|0)<=(e|0));d=b&-4}if((d|0)>=(b|0)){b=c;return b|0}do{c=((k[a+(d<<2)>>2]|0)!=0&1)+c|0;d=d+1|0}while((d|0)!=(b|0));return c|0}function s7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=b+-4|0;if((b|0)<4){c=0;d=0}else{d=0;c=0;do{c=(+o[a+(d<<2)>>2]!=0.0&1)+c+(+o[a+((d|1)<<2)>>2]!=0.0&1)+(+o[a+((d|2)<<2)>>2]!=0.0&1)+(+o[a+((d|3)<<2)>>2]!=0.0&1)|0;d=d+4|0}while((d|0)<=(e|0));d=b&-4}if((d|0)>=(b|0)){b=c;return b|0}do{c=(+o[a+(d<<2)>>2]!=0.0&1)+c|0;d=d+1|0}while((d|0)!=(b|0));return c|0}function t7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=b+-4|0;if((b|0)<4){c=0;d=0}else{d=0;c=0;do{c=(+p[a+(d<<3)>>3]!=0.0&1)+c+(+p[a+((d|1)<<3)>>3]!=0.0&1)+(+p[a+((d|2)<<3)>>3]!=0.0&1)+(+p[a+((d|3)<<3)>>3]!=0.0&1)|0;d=d+4|0}while((d|0)<=(e|0));d=b&-4}if((d|0)>=(b|0)){b=c;return b|0}do{c=(+p[a+(d<<3)>>3]!=0.0&1)+c|0;d=d+1|0}while((d|0)!=(b|0));return c|0}function u7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0;I=r;r=r+1264|0;H=I+1208|0;G=I+1152|0;E=I;n=I+1136|0;B=I+1128|0;C=I+1096|0;F=I+32|0;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[H>>2]=k[g>>2];m=H+4|0;b=g+4|0;k[m>>2]=k[b>>2];A=H+8|0;k[A>>2]=k[g+8>>2];k[H+12>>2]=k[g+12>>2];k[H+16>>2]=k[g+16>>2];k[H+20>>2]=k[g+20>>2];k[H+24>>2]=k[g+24>>2];k[H+28>>2]=k[g+28>>2];k[H+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[H+36>>2]=d;e=H+40|0;k[e>>2]=A;A=H+48|0;j=H+44|0;k[j>>2]=A;k[H+52>>2]=0;k[A>>2]=0;if(d|0){A=d+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[b>>2]|0)<3){z=k[g+44>>2]|0;A=k[j>>2]|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];break}k[m>>2]=0;x1(H,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[e>>2]|0;e=k[g+44>>2]|0;d=k[j>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[l+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(H,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[G>>2]=k[h>>2];m=G+4|0;d=h+4|0;k[m>>2]=k[d>>2];A=G+8|0;k[A>>2]=k[h+8>>2];k[G+12>>2]=k[h+12>>2];c=G+16|0;k[c>>2]=k[h+16>>2];k[G+20>>2]=k[h+20>>2];k[G+24>>2]=k[h+24>>2];k[G+28>>2]=k[h+28>>2];k[G+32>>2]=k[h+32>>2];b=k[h+36>>2]|0;k[G+36>>2]=b;e=G+40|0;k[e>>2]=A;A=G+48|0;j=G+44|0;k[j>>2]=A;k[G+52>>2]=0;k[A>>2]=0;if(b|0){A=b+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[d>>2]|0)<3){z=k[h+44>>2]|0;A=k[j>>2]|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];break}k[m>>2]=0;x1(G,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[h+40>>2]|0;g=k[e>>2]|0;e=k[h+44>>2]|0;d=k[j>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[l+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else{Q1(G,c,-1);c=G+16|0}while(0);if(k[c>>2]|0){e=k[G+4>>2]|0;if((e|0)<3)b=aa(k[G+12>>2]|0,k[G+8>>2]|0)|0;else{g=k[G+40>>2]|0;d=0;b=1;do{b=aa(k[g+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if(b|0?k[G>>2]&4095|0:0){k[E>>2]=0;b=E+4|0;k[b>>2]=0;d=ZT(44)|0;k[d>>2]=1;e=d+4|0;k[E>>2]=e;k[b>>2]=36;i[d+40>>0]=0;g=229968;h=e+36|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-215,E,230005,229892,1465);k[b>>2]=0;k[E>>2]=0;A=k[d>>2]|0;k[d>>2]=A+-1;if((A|0)==1)ggb(k[d+-4>>2]|0)}}j=k[H>>2]|0;l=j>>>3&511;z=l+1|0;j=j&7;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;k[E+16>>2]=0;k[E+20>>2]=0;k[E+24>>2]=0;k[E+28>>2]=0;A=k[49704+(j<<2)>>2]|0;if(!((j|0)!=7&z>>>0<5)){k[n>>2]=0;b=n+4|0;k[b>>2]=0;d=ZT(28)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[b>>2]=20;i[d+24>>0]=0;g=229871;h=e+20|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-215,n,230005,229892,1474);k[b>>2]=0;k[n>>2]=0;y=k[d>>2]|0;k[d>>2]=y+-1;if((y|0)==1)ggb(k[d+-4>>2]|0)}k[n>>2]=H;k[n+4>>2]=G;k[n+8>>2]=0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;k[C+16>>2]=0;k[C+20>>2]=0;k[C+24>>2]=0;k[C+28>>2]=0;z1(C,n,0,B,-1);v=k[C+20>>2]|0;x=F+8|0;k[F>>2]=x;y=F+4|0;k[y>>2]=264;w=j>>>0<4;if(w){g=j>>>0<2?8388608:32768;e=(g|0)<(v|0)?g:v;if(z>>>0>264){d=z<<2;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b}else b=x;k[y>>2]=z;zpb(b|0,0,(l<<2)+4|0)|0;d=k[H+4>>2]|0;if((d|0)>0){u=k[(k[H+44>>2]|0)+(d+-1<<2)>>2]|0;t=e}else{u=0;t=e}}else{u=0;b=E;t=v;g=0}o=C+16|0;q=(v|0)>0;s=B+4|0;h=0;e=0;d=0;while(1){if(d>>>0>=(k[o>>2]|0)>>>0)break;d=d+1|0;a:do if(q){l=k[B>>2]|0;j=k[s>>2]|0;if(w)n=0;else{n=0;m=l;while(1){l=v-n|0;l=(t|0)<(l|0)?t:l;j=$g[A&127](m,j,b,l,z)|0;e=j+e|0;h=j+h|0;j=aa(l,u)|0;m=(k[B>>2]|0)+j|0;k[B>>2]=m;j=k[s>>2]|0;if(!j)j=0;else{j=j+l|0;k[s>>2]=j}n=n+t|0;if((v|0)<=(n|0))break a}}do{m=v-n|0;m=(t|0)<(m|0)?t:m;l=$g[A&127](l,j,b,m,z)|0;e=l+e|0;h=l+h|0;if(!((e+t|0)<(g|0)?((m+n|0)<(v|0)?1:d>>>0<(k[o>>2]|0)>>>0):0)){e=0;D=48}if((D|0)==48)while(1){D=0;l=b+(e<<2)|0;j=E+(e<<3)|0;p[j>>3]=+p[j>>3]+ +(k[l>>2]|0);k[l>>2]=0;e=e+1|0;if((e|0)==(z|0)){e=0;break}else D=48}l=aa(m,u)|0;l=(k[B>>2]|0)+l|0;k[B>>2]=l;j=k[s>>2]|0;if(!j)j=0;else{j=j+m|0;k[s>>2]=j}n=n+t|0}while((v|0)>(n|0))}while(0);A1(C)}if(!h)f=0.0;else f=1.0/+(h>>>0);L=f*+p[E+8>>3];K=f*+p[E+16>>3];J=f*+p[E+24>>3];p[a>>3]=f*+p[E>>3];p[a+8>>3]=L;p[a+16>>3]=K;p[a+24>>3]=J;b=k[F>>2]|0;if((b|0)!=(x|0)){if(b|0)ggb(b);k[F>>2]=x;k[y>>2]=264}e=G+36|0;b=k[e>>2]|0;if(b|0?(E=b+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[G+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;e=G+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[e>>2]|0)>0){d=k[G+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[G+44>>2]|0;if(!((b|0)==(G+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=H+36|0;b=k[e>>2]|0;if(b|0?(F=b+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[H+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;G=H+16|0;d=H+4|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[d>>2]|0)>0){e=k[H+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[H+44>>2]|0;if((b|0)==(H+48|0)|(b|0)==0){r=I;return}ggb(k[b+-4>>2]|0);r=I;return}function v7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0;Z=r;r=r+1344|0;V=Z+1288|0;Y=Z+1232|0;X=Z+1176|0;o=Z+1160|0;B=Z+1152|0;C=Z+1120|0;W=Z+16|0;T=Z;U=Z+1112|0;do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[Y>>2]=k[g>>2];n=Y+4|0;a=g+4|0;k[n>>2]=k[a>>2];R=Y+8|0;k[R>>2]=k[g+8>>2];k[Y+12>>2]=k[g+12>>2];k[Y+16>>2]=k[g+16>>2];k[Y+20>>2]=k[g+20>>2];k[Y+24>>2]=k[g+24>>2];k[Y+28>>2]=k[g+28>>2];k[Y+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[Y+36>>2]=e;f=Y+40|0;k[f>>2]=R;R=Y+48|0;l=Y+44|0;k[l>>2]=R;k[Y+52>>2]=0;k[R>>2]=0;if(e|0){R=e+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[a>>2]|0)<3){P=k[g+44>>2]|0;R=k[l>>2]|0;k[R>>2]=k[P>>2];k[R+4>>2]=k[P+4>>2];break}k[n>>2]=0;x1(Y,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[g+40>>2]|0;j=k[f>>2]|0;f=k[g+44>>2]|0;e=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(Y,a,-1);while(0);do if((k[d>>2]&2031616|0)==65536){j=k[d+4>>2]|0;k[X>>2]=k[j>>2];n=X+4|0;e=j+4|0;k[n>>2]=k[e>>2];R=X+8|0;k[R>>2]=k[j+8>>2];k[X+12>>2]=k[j+12>>2];d=X+16|0;k[d>>2]=k[j+16>>2];k[X+20>>2]=k[j+20>>2];k[X+24>>2]=k[j+24>>2];k[X+28>>2]=k[j+28>>2];k[X+32>>2]=k[j+32>>2];a=k[j+36>>2]|0;k[X+36>>2]=a;f=X+40|0;k[f>>2]=R;R=X+48|0;l=X+44|0;k[l>>2]=R;k[X+52>>2]=0;k[R>>2]=0;if(a|0){R=a+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[e>>2]|0)<3){P=k[j+44>>2]|0;R=k[l>>2]|0;k[R>>2]=k[P>>2];k[R+4>>2]=k[P+4>>2];break}k[n>>2]=0;x1(X,k[e>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[j+40>>2]|0;g=k[f>>2]|0;f=k[j+44>>2]|0;e=k[l>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[m+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else{Q1(X,d,-1);d=X+16|0}while(0);if(k[d>>2]|0){f=k[X+4>>2]|0;if((f|0)<3)a=aa(k[X+12>>2]|0,k[X+8>>2]|0)|0;else{g=k[X+40>>2]|0;e=0;a=1;do{a=aa(k[g+(e<<2)>>2]|0,a)|0;e=e+1|0}while((e|0)!=(f|0))}if(a|0?k[X>>2]&4095|0:0){k[V>>2]=0;a=V+4|0;k[a>>2]=0;e=ZT(44)|0;k[e>>2]=1;j=e+4|0;k[V>>2]=j;k[a>>2]=38;i[e+42>>0]=0;l=334093;m=j+38|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,V,230010,229892,1762);k[a>>2]=0;k[V>>2]=0;R=k[e>>2]|0;k[e>>2]=R+-1;if((R|0)==1)ggb(k[e+-4>>2]|0)}}g=k[Y>>2]|0;K=g>>>3;P=K&511;R=P+1|0;g=g&7;A=k[49768+(g<<2)>>2]|0;if((g|0)==7){k[V>>2]=0;a=V+4|0;k[a>>2]=0;e=ZT(16)|0;k[e>>2]=1;j=e+4|0;k[V>>2]=j;k[a>>2]=9;i[e+13>>0]=0;l=335726;m=j+9|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,V,230010,229892,1770);k[a>>2]=0;k[V>>2]=0;O=k[e>>2]|0;k[e>>2]=O+-1;if((O|0)==1)ggb(k[e+-4>>2]|0)}k[o>>2]=Y;k[o+4>>2]=X;k[o+8>>2]=0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;k[C+16>>2]=0;k[C+20>>2]=0;k[C+24>>2]=0;k[C+28>>2]=0;z1(C,o,0,B,-1);z=k[C+20>>2]|0;f=R<<2;N=W+8|0;k[W>>2]=N;O=W+4|0;k[O>>2]=136;if(f>>>0>136){e=R<<5;while(1){a=fgb(e)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[W>>2]=a;M=a}else M=N;k[O>>2]=f;L=M+(R<<3)|0;a=0;do{p[L+(a<<3)>>3]=0.0;p[M+(a<<3)>>3]=0.0;a=a+1|0}while((a|0)!=(R|0));y=g>>>0<4;x=g>>>0<2;if(y){f=L+(R<<3)|0;g=x?f+(R<<2)|0:L;a=0;do{k[g+(a<<2)>>2]=0;k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)!=(R|0));e=(z|0)>32768?32768:z;a=k[Y+4>>2]|0;if((a|0)>0){w=k[(k[Y+44>>2]|0)+(a+-1<<2)>>2]|0;v=32768}else{w=0;v=32768}}else{w=0;f=M;e=z;v=0;g=L}s=C+16|0;t=(z|0)>0;u=B+4|0;l=0;j=0;a=0;while(1){if(a>>>0>=(k[s>>2]|0)>>>0)break;a=a+1|0;a:do if(t){n=k[B>>2]|0;m=k[u>>2]|0;if(y)q=0;else{q=0;o=n;while(1){n=z-q|0;n=(e|0)<(n|0)?e:n;m=Sf[A&127](o,m,f,g,n,R)|0;l=m+l|0;j=m+j|0;m=aa(n,w)|0;o=(k[B>>2]|0)+m|0;k[B>>2]=o;m=k[u>>2]|0;if(!m)m=0;else{m=m+n|0;k[u>>2]=m}q=q+e|0;if((z|0)<=(q|0))break a}}do{o=z-q|0;o=(e|0)<(o|0)?e:o;J=Sf[A&127](n,m,f,g,o,R)|0;l=J+l|0;j=J+j|0;if(!((l+e|0)<(v|0)?((o+q|0)<(z|0)?1:a>>>0<(k[s>>2]|0)>>>0):0)){l=0;S=52}if((S|0)==52){while(1){S=0;J=f+(l<<2)|0;I=M+(l<<3)|0;p[I>>3]=+p[I>>3]+ +(k[J>>2]|0);k[J>>2]=0;l=l+1|0;if((l|0)==(R|0))break;else S=52}if(x){l=0;do{J=g+(l<<2)|0;I=L+(l<<3)|0;p[I>>3]=+p[I>>3]+ +(k[J>>2]|0);k[J>>2]=0;l=l+1|0}while((l|0)!=(R|0));l=0}else l=0}n=aa(o,w)|0;n=(k[B>>2]|0)+n|0;k[B>>2]=n;m=k[u>>2]|0;if(!m)m=0;else{m=m+o|0;k[u>>2]=m}q=q+e|0}while((z|0)>(q|0))}while(0);A1(C)}if(!j)h=0.0;else h=1.0/+(j|0);a=0;do{S=M+(a<<3)|0;_=h*+p[S>>3];p[S>>3]=_;S=L+(a<<3)|0;_=h*+p[S>>3]-_*_;_=+Q(+(_<0.0?0.0:_));p[S>>3]=_;a=a+1|0}while((a|0)!=(R|0));t=T+8|0;u=T+12|0;v=T+4|0;w=V+4|0;x=V+8|0;y=V+12|0;z=V+16|0;A=V+20|0;B=V+24|0;C=V+28|0;D=V+32|0;E=V+36|0;F=V+40|0;G=V+48|0;H=V+44|0;I=V+52|0;J=U+4|0;q=(K|536870400)^511;s=V+4|0;o=0;do{S=(o|0)==0;n=S?M:L;S=S?b:c;m=S;a=k[m>>2]|0;m=k[m+4>>2]|0;K=T;k[K>>2]=a;k[K+4>>2]=m;k[t>>2]=k[S+8>>2];k[u>>2]=k[S+12>>2];if(a&2031616|0){if(!(a&1073741824)){k[V>>2]=R;k[s>>2]=1;P1(T,2,V,6,-1,1,0);a=k[T>>2]|0}do if((a&2031616|0)==65536){f=k[v>>2]|0;k[V>>2]=k[f>>2];a=f+4|0;k[w>>2]=k[a>>2];k[x>>2]=k[f+8>>2];k[y>>2]=k[f+12>>2];k[z>>2]=k[f+16>>2];k[A>>2]=k[f+20>>2];k[B>>2]=k[f+24>>2];k[C>>2]=k[f+28>>2];k[D>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[E>>2]=e;k[F>>2]=x;k[H>>2]=G;k[I>>2]=0;k[G>>2]=0;if(e|0){S=e+12|0;k[S>>2]=(k[S>>2]|0)+1}if((k[a>>2]|0)<3){K=k[f+44>>2]|0;S=k[H>>2]|0;k[S>>2]=k[K>>2];k[S+4>>2]=k[K+4>>2];S=79;break}k[w>>2]=0;x1(V,k[a>>2]|0,0,0,0);if((k[w>>2]|0)>0){j=k[f+40>>2]|0;l=k[F>>2]|0;e=k[f+44>>2]|0;f=k[H>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[j+(a<<2)>>2];k[f+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0;g=k[w>>2]|0}while((a|0)<(g|0));S=80}else S=82}else{Q1(V,T,-1);S=79}while(0);if((S|0)==79){g=k[w>>2]|0;S=80}if((S|0)==80){S=0;if((g|0)<3)S=82;else{f=k[F>>2]|0;e=0;a=1;do{a=aa(k[f+(e<<2)>>2]|0,a)|0;e=e+1|0}while((e|0)!=(g|0));f=a}}if((S|0)==82){S=0;f=aa(k[y>>2]|0,k[x>>2]|0)|0}do if((k[V>>2]&20479|0)==16390)if((k[y>>2]|0)==1)if((f|0)>(P|0))break;else{S=88;break}else if((f|0)<=(P|0)|(k[x>>2]|0)!=1){S=88;break}else break;else S=88;while(0);if((S|0)==88){k[U>>2]=0;k[J>>2]=0;a=ZT(96)|0;k[a>>2]=1;j=a+4|0;k[U>>2]=j;k[J>>2]=91;i[a+95>>0]=0;l=230021;m=j+91|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,U,230010,229892,1848);k[J>>2]=0;k[U>>2]=0;S=k[a>>2]|0;k[a>>2]=S+-1;if((S|0)==1)ggb(k[a+-4>>2]|0)}e=k[z>>2]|0;a=0;do{p[e+(a<<3)>>3]=+p[n+(a<<3)>>3];a=a+1|0}while((a|0)!=(R|0));if((R|0)<(f|0))zpb(e+(R<<3)|0,0,q+f<<3|0)|0;a=k[E>>2]|0;if(a|0?(K=a+12|0,S=k[K>>2]|0,k[K>>2]=S+-1,(S|0)==1):0){e=k[E>>2]|0;if(e|0){a=k[e+4>>2]|0;do if(!a){a=k[D>>2]|0;if(a|0)break;a=B1()|0;e=k[E>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[E>>2]=0}k[E>>2]=0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[w>>2]|0)>0){e=k[F>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[H>>2]|0;if(!((a|0)==(G|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}o=o+1|0}while((o|0)<2);a=k[W>>2]|0;if((a|0)!=(N|0)){if(a|0)ggb(a);k[W>>2]=N;k[O>>2]=136}f=X+36|0;a=k[f>>2]|0;if(a|0?(V=a+12|0,W=k[V>>2]|0,k[V>>2]=W+-1,(W|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[X+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;f=X+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[f>>2]|0)>0){e=k[X+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[X+44>>2]|0;if(!((a|0)==(X+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=Y+36|0;a=k[f>>2]|0;if(a|0?(W=a+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[Y+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;X=Y+16|0;e=Y+4|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[e>>2]|0)>0){f=k[Y+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[Y+44>>2]|0;if((a|0)==(Y+48|0)|(a|0)==0){r=Z;return}ggb(k[a+-4>>2]|0);r=Z;return}function w7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;if(!b){A=(f|0)%4|0;switch(A|0){case 1:{j=k[c>>2]|0;h=k[d>>2]|0;if((e|0)>0){g=a;m=0;while(1){z=l[g>>0]|0;j=z+j|0;h=(aa(z,z)|0)+h|0;m=m+1|0;if((m|0)==(e|0)){g=e;break}else g=g+f|0}}else g=0;k[c>>2]=j;k[d>>2]=h;break}case 2:{g=k[c>>2]|0;p=c+4|0;j=k[p>>2]|0;m=k[d>>2]|0;q=d+4|0;h=k[q>>2]|0;if((e|0)>0){n=0;o=a;while(1){z=l[o>>0]|0;g=z+g|0;m=(aa(z,z)|0)+m|0;z=l[o+1>>0]|0;j=z+j|0;h=(aa(z,z)|0)+h|0;n=n+1|0;if((n|0)==(e|0)){n=g;g=e;break}else o=o+f|0}}else{n=g;g=0}k[c>>2]=n;k[p>>2]=j;k[d>>2]=m;k[q>>2]=h;break}case 3:{g=k[c>>2]|0;r=c+4|0;j=k[r>>2]|0;s=c+8|0;h=k[s>>2]|0;m=k[d>>2]|0;t=d+4|0;o=k[t>>2]|0;u=d+8|0;n=k[u>>2]|0;if((e|0)>0){p=0;q=a;while(1){z=l[q>>0]|0;g=z+g|0;m=(aa(z,z)|0)+m|0;z=l[q+1>>0]|0;j=z+j|0;o=(aa(z,z)|0)+o|0;z=l[q+2>>0]|0;h=z+h|0;n=(aa(z,z)|0)+n|0;p=p+1|0;if((p|0)==(e|0)){p=g;g=e;break}else q=q+f|0}}else{p=g;g=0}k[c>>2]=p;k[r>>2]=j;k[s>>2]=h;k[d>>2]=m;k[t>>2]=o;k[u>>2]=n;break}default:g=0}if((A|0)>=(f|0)){d=e;return d|0}do{t=c+(A<<2)|0;j=k[t>>2]|0;x=A+1|0;u=c+(x<<2)|0;n=k[u>>2]|0;y=A+2|0;v=c+(y<<2)|0;p=k[v>>2]|0;z=A+3|0;b=c+(z<<2)|0;r=k[b>>2]|0;w=d+(A<<2)|0;q=k[w>>2]|0;x=d+(x<<2)|0;o=k[x>>2]|0;y=d+(y<<2)|0;m=k[y>>2]|0;z=d+(z<<2)|0;h=k[z>>2]|0;if((g|0)<(e|0)){s=a+A|0;while(1){B=l[s>>0]|0;j=B+j|0;q=(aa(B,B)|0)+q|0;B=l[s+1>>0]|0;n=B+n|0;o=(aa(B,B)|0)+o|0;B=l[s+2>>0]|0;p=B+p|0;m=(aa(B,B)|0)+m|0;B=l[s+3>>0]|0;r=B+r|0;h=(aa(B,B)|0)+h|0;g=g+1|0;if((g|0)==(e|0)){g=e;break}else s=s+f|0}}k[t>>2]=j;k[u>>2]=n;k[v>>2]=p;k[b>>2]=r;k[w>>2]=q;k[x>>2]=o;k[y>>2]=m;k[z>>2]=h;A=A+4|0}while((A|0)<(f|0));g=e;return g|0}switch(f|0){case 1:{h=k[c>>2]|0;g=k[d>>2]|0;if((e|0)>0){j=g;g=0;m=0;do{if(i[b+m>>0]|0){B=l[a+m>>0]|0;j=(aa(B,B)|0)+j|0;h=B+h|0;g=g+1|0}m=m+1|0}while((m|0)!=(e|0))}else{j=g;g=0}k[c>>2]=h;k[d>>2]=j;B=g;return B|0}case 3:{h=k[c>>2]|0;s=c+4|0;j=k[s>>2]|0;t=c+8|0;n=k[t>>2]|0;o=k[d>>2]|0;u=d+4|0;m=k[u>>2]|0;v=d+8|0;g=k[v>>2]|0;if((e|0)>0){p=g;r=0;g=0;q=a;while(1){if(i[b+r>>0]|0){B=l[q>>0]|0;a=l[q+1>>0]|0;f=l[q+2>>0]|0;p=(aa(f,f)|0)+p|0;m=(aa(a,a)|0)+m|0;o=(aa(B,B)|0)+o|0;n=f+n|0;j=a+j|0;h=B+h|0;g=g+1|0}r=r+1|0;if((r|0)==(e|0))break;else q=q+3|0}}else{p=g;g=0}k[c>>2]=h;k[s>>2]=j;k[t>>2]=n;k[d>>2]=o;k[u>>2]=m;k[v>>2]=p;B=g;return B|0}default:{if((e|0)<=0){B=0;return B|0}if((f|0)>0){m=0;g=0;j=a}else{h=0;g=0;do{g=((i[b+h>>0]|0)!=0&1)+g|0;h=h+1|0}while((h|0)!=(e|0));return g|0}while(1){if(i[b+m>>0]|0){h=0;do{A=c+(h<<2)|0;z=l[j+h>>0]|0;B=d+(h<<2)|0;a=(k[B>>2]|0)+(aa(z,z)|0)|0;k[A>>2]=(k[A>>2]|0)+z;k[B>>2]=a;h=h+1|0}while((h|0)!=(f|0));g=g+1|0}m=m+1|0;if((m|0)==(e|0))break;else j=j+f|0}return g|0}}return 0}function x7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if(!b){z=(f|0)%4|0;switch(z|0){case 1:{j=k[c>>2]|0;h=k[d>>2]|0;if((e|0)>0){g=a;l=0;while(1){y=i[g>>0]|0;j=y+j|0;h=(aa(y,y)|0)+h|0;l=l+1|0;if((l|0)==(e|0)){g=e;break}else g=g+f|0}}else g=0;k[c>>2]=j;k[d>>2]=h;break}case 2:{g=k[c>>2]|0;o=c+4|0;j=k[o>>2]|0;l=k[d>>2]|0;p=d+4|0;h=k[p>>2]|0;if((e|0)>0){m=0;n=a;while(1){y=i[n>>0]|0;g=y+g|0;l=(aa(y,y)|0)+l|0;y=i[n+1>>0]|0;j=y+j|0;h=(aa(y,y)|0)+h|0;m=m+1|0;if((m|0)==(e|0)){m=g;g=e;break}else n=n+f|0}}else{m=g;g=0}k[c>>2]=m;k[o>>2]=j;k[d>>2]=l;k[p>>2]=h;break}case 3:{g=k[c>>2]|0;q=c+4|0;j=k[q>>2]|0;r=c+8|0;h=k[r>>2]|0;l=k[d>>2]|0;s=d+4|0;n=k[s>>2]|0;t=d+8|0;m=k[t>>2]|0;if((e|0)>0){o=0;p=a;while(1){y=i[p>>0]|0;g=y+g|0;l=(aa(y,y)|0)+l|0;y=i[p+1>>0]|0;j=y+j|0;n=(aa(y,y)|0)+n|0;y=i[p+2>>0]|0;h=y+h|0;m=(aa(y,y)|0)+m|0;o=o+1|0;if((o|0)==(e|0)){o=g;g=e;break}else p=p+f|0}}else{o=g;g=0}k[c>>2]=o;k[q>>2]=j;k[r>>2]=h;k[d>>2]=l;k[s>>2]=n;k[t>>2]=m;break}default:g=0}if((z|0)>=(f|0)){d=e;return d|0}do{s=c+(z<<2)|0;j=k[s>>2]|0;w=z+1|0;t=c+(w<<2)|0;m=k[t>>2]|0;x=z+2|0;u=c+(x<<2)|0;o=k[u>>2]|0;y=z+3|0;b=c+(y<<2)|0;q=k[b>>2]|0;v=d+(z<<2)|0;p=k[v>>2]|0;w=d+(w<<2)|0;n=k[w>>2]|0;x=d+(x<<2)|0;l=k[x>>2]|0;y=d+(y<<2)|0;h=k[y>>2]|0;if((g|0)<(e|0)){r=a+z|0;while(1){A=i[r>>0]|0;j=A+j|0;p=(aa(A,A)|0)+p|0;A=i[r+1>>0]|0;m=A+m|0;n=(aa(A,A)|0)+n|0;A=i[r+2>>0]|0;o=A+o|0;l=(aa(A,A)|0)+l|0;A=i[r+3>>0]|0;q=A+q|0;h=(aa(A,A)|0)+h|0;g=g+1|0;if((g|0)==(e|0)){g=e;break}else r=r+f|0}}k[s>>2]=j;k[t>>2]=m;k[u>>2]=o;k[b>>2]=q;k[v>>2]=p;k[w>>2]=n;k[x>>2]=l;k[y>>2]=h;z=z+4|0}while((z|0)<(f|0));g=e;return g|0}switch(f|0){case 1:{h=k[c>>2]|0;g=k[d>>2]|0;if((e|0)>0){j=g;g=0;l=0;do{if(i[b+l>>0]|0){A=i[a+l>>0]|0;j=(aa(A,A)|0)+j|0;h=A+h|0;g=g+1|0}l=l+1|0}while((l|0)!=(e|0))}else{j=g;g=0}k[c>>2]=h;k[d>>2]=j;A=g;return A|0}case 3:{h=k[c>>2]|0;r=c+4|0;j=k[r>>2]|0;s=c+8|0;m=k[s>>2]|0;n=k[d>>2]|0;t=d+4|0;l=k[t>>2]|0;u=d+8|0;g=k[u>>2]|0;if((e|0)>0){o=g;q=0;g=0;p=a;while(1){if(i[b+q>>0]|0){A=i[p>>0]|0;a=i[p+1>>0]|0;f=i[p+2>>0]|0;o=(aa(f,f)|0)+o|0;l=(aa(a,a)|0)+l|0;n=(aa(A,A)|0)+n|0;m=f+m|0;j=a+j|0;h=A+h|0;g=g+1|0}q=q+1|0;if((q|0)==(e|0))break;else p=p+3|0}}else{o=g;g=0}k[c>>2]=h;k[r>>2]=j;k[s>>2]=m;k[d>>2]=n;k[t>>2]=l;k[u>>2]=o;A=g;return A|0}default:{if((e|0)<=0){A=0;return A|0}if((f|0)>0){l=0;g=0;j=a}else{h=0;g=0;do{g=((i[b+h>>0]|0)!=0&1)+g|0;h=h+1|0}while((h|0)!=(e|0));return g|0}while(1){if(i[b+l>>0]|0){h=0;do{z=c+(h<<2)|0;y=i[j+h>>0]|0;A=d+(h<<2)|0;a=(k[A>>2]|0)+(aa(y,y)|0)|0;k[z>>2]=(k[z>>2]|0)+y;k[A>>2]=a;h=h+1|0}while((h|0)!=(f|0));g=g+1|0}l=l+1|0;if((l|0)==(e|0))break;else j=j+f|0}return g|0}}return 0}function y7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0.0,m=0,n=0.0,o=0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0;if(!b){B=(f|0)%4|0;switch(B|0){case 1:{h=k[c>>2]|0;l=+p[d>>3];if((e|0)>0){g=a;m=0;while(1){A=j[g>>1]|0;h=(A&65535)+h|0;t=+(A&65535);l=l+t*t;m=m+1|0;if((m|0)==(e|0)){g=e;break}else g=g+(f<<1)|0}}else g=0;k[c>>2]=h;p[d>>3]=l;break}case 2:{g=k[c>>2]|0;r=c+4|0;h=k[r>>2]|0;n=+p[d>>3];s=d+8|0;l=+p[s>>3];if((e|0)>0){m=0;o=a;while(1){z=j[o>>1]|0;A=j[o+2>>1]|0;g=(z&65535)+g|0;t=+(z&65535);n=n+t*t;h=(A&65535)+h|0;t=+(A&65535);l=l+t*t;m=m+1|0;if((m|0)==(e|0)){m=g;g=e;break}else o=o+(f<<1)|0}}else{m=g;g=0}k[c>>2]=m;k[r>>2]=h;p[d>>3]=n;p[s>>3]=l;break}case 3:{g=k[c>>2]|0;s=c+4|0;m=k[s>>2]|0;u=c+8|0;h=k[u>>2]|0;l=+p[d>>3];v=d+8|0;q=+p[v>>3];w=d+16|0;n=+p[w>>3];if((e|0)>0){o=0;r=a;while(1){y=j[r>>1]|0;z=j[r+2>>1]|0;A=j[r+4>>1]|0;g=(y&65535)+g|0;t=+(y&65535);l=l+t*t;m=(z&65535)+m|0;t=+(z&65535);q=q+t*t;h=(A&65535)+h|0;t=+(A&65535);n=n+t*t;o=o+1|0;if((o|0)==(e|0)){o=g;g=e;break}else r=r+(f<<1)|0}}else{o=g;g=0}k[c>>2]=o;k[s>>2]=m;k[u>>2]=h;p[d>>3]=l;p[v>>3]=q;p[w>>3]=n;break}default:g=0}if((B|0)>=(f|0)){d=e;return d|0}do{u=c+(B<<2)|0;h=k[u>>2]|0;y=B+1|0;v=c+(y<<2)|0;m=k[v>>2]|0;z=B+2|0;w=c+(z<<2)|0;o=k[w>>2]|0;A=B+3|0;b=c+(A<<2)|0;r=k[b>>2]|0;x=d+(B<<3)|0;t=+p[x>>3];y=d+(y<<3)|0;q=+p[y>>3];z=d+(z<<3)|0;n=+p[z>>3];A=d+(A<<3)|0;l=+p[A>>3];if((g|0)<(e|0)){s=a+(B<<1)|0;while(1){D=j[s>>1]|0;E=j[s+2>>1]|0;h=(D&65535)+h|0;C=+(D&65535);t=t+C*C;m=(E&65535)+m|0;C=+(E&65535);q=q+C*C;E=j[s+4>>1]|0;D=j[s+6>>1]|0;o=(E&65535)+o|0;C=+(E&65535);n=n+C*C;r=(D&65535)+r|0;C=+(D&65535);l=l+C*C;g=g+1|0;if((g|0)==(e|0)){g=e;break}else s=s+(f<<1)|0}}k[u>>2]=h;k[v>>2]=m;k[w>>2]=o;k[b>>2]=r;p[x>>3]=t;p[y>>3]=q;p[z>>3]=n;p[A>>3]=l;B=B+4|0}while((B|0)<(f|0));g=e;return g|0}switch(f|0){case 1:{h=k[c>>2]|0;l=+p[d>>3];if((e|0)>0){g=0;m=0;do{if(i[b+m>>0]|0){E=j[a+(m<<1)>>1]|0;C=+(E&65535);l=l+C*C;h=(E&65535)+h|0;g=g+1|0}m=m+1|0}while((m|0)!=(e|0))}else g=0;k[c>>2]=h;p[d>>3]=l;E=g;return E|0}case 3:{h=k[c>>2]|0;s=c+4|0;g=k[s>>2]|0;u=c+8|0;m=k[u>>2]|0;q=+p[d>>3];v=d+8|0;n=+p[v>>3];w=d+16|0;l=+p[w>>3];if((e|0)>0){o=g;r=0;g=0;while(1){if(i[b+r>>0]|0){E=j[a>>1]|0;D=j[a+2>>1]|0;f=j[a+4>>1]|0;C=+(E&65535);t=+(D&65535);F=+(f&65535);l=l+F*F;n=n+t*t;q=q+C*C;m=(f&65535)+m|0;o=(D&65535)+o|0;h=(E&65535)+h|0;g=g+1|0}r=r+1|0;if((r|0)==(e|0)){a=o;break}else a=a+6|0}}else{a=g;g=0}k[c>>2]=h;k[s>>2]=a;k[u>>2]=m;p[d>>3]=q;p[v>>3]=n;p[w>>3]=l;E=g;return E|0}default:{if((e|0)<=0){E=0;return E|0}if((f|0)>0){m=0;g=0}else{h=0;g=0;do{g=((i[b+h>>0]|0)!=0&1)+g|0;h=h+1|0}while((h|0)!=(e|0));return g|0}while(1){if(i[b+m>>0]|0){h=0;do{B=j[a+(h<<1)>>1]|0;D=c+(h<<2)|0;E=d+(h<<3)|0;F=+(B&65535);F=+p[E>>3]+F*F;k[D>>2]=(k[D>>2]|0)+(B&65535);p[E>>3]=F;h=h+1|0}while((h|0)!=(f|0));g=g+1|0}m=m+1|0;if((m|0)==(e|0))break;else a=a+(f<<1)|0}return g|0}}return 0}function z7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0.0,m=0,n=0.0,o=0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0;if(!b){B=(f|0)%4|0;switch(B|0){case 1:{h=k[c>>2]|0;l=+p[d>>3];if((e|0)>0){g=a;m=0;while(1){A=j[g>>1]|0;h=(A<<16>>16)+h|0;t=+(A<<16>>16);l=l+t*t;m=m+1|0;if((m|0)==(e|0)){g=e;break}else g=g+(f<<1)|0}}else g=0;k[c>>2]=h;p[d>>3]=l;break}case 2:{g=k[c>>2]|0;r=c+4|0;h=k[r>>2]|0;n=+p[d>>3];s=d+8|0;l=+p[s>>3];if((e|0)>0){m=0;o=a;while(1){z=j[o>>1]|0;A=j[o+2>>1]|0;g=(z<<16>>16)+g|0;t=+(z<<16>>16);n=n+t*t;h=(A<<16>>16)+h|0;t=+(A<<16>>16);l=l+t*t;m=m+1|0;if((m|0)==(e|0)){m=g;g=e;break}else o=o+(f<<1)|0}}else{m=g;g=0}k[c>>2]=m;k[r>>2]=h;p[d>>3]=n;p[s>>3]=l;break}case 3:{g=k[c>>2]|0;s=c+4|0;m=k[s>>2]|0;u=c+8|0;h=k[u>>2]|0;l=+p[d>>3];v=d+8|0;q=+p[v>>3];w=d+16|0;n=+p[w>>3];if((e|0)>0){o=0;r=a;while(1){y=j[r>>1]|0;z=j[r+2>>1]|0;A=j[r+4>>1]|0;g=(y<<16>>16)+g|0;t=+(y<<16>>16);l=l+t*t;m=(z<<16>>16)+m|0;t=+(z<<16>>16);q=q+t*t;h=(A<<16>>16)+h|0;t=+(A<<16>>16);n=n+t*t;o=o+1|0;if((o|0)==(e|0)){o=g;g=e;break}else r=r+(f<<1)|0}}else{o=g;g=0}k[c>>2]=o;k[s>>2]=m;k[u>>2]=h;p[d>>3]=l;p[v>>3]=q;p[w>>3]=n;break}default:g=0}if((B|0)>=(f|0)){d=e;return d|0}do{u=c+(B<<2)|0;h=k[u>>2]|0;y=B+1|0;v=c+(y<<2)|0;m=k[v>>2]|0;z=B+2|0;w=c+(z<<2)|0;o=k[w>>2]|0;A=B+3|0;b=c+(A<<2)|0;r=k[b>>2]|0;x=d+(B<<3)|0;t=+p[x>>3];y=d+(y<<3)|0;q=+p[y>>3];z=d+(z<<3)|0;n=+p[z>>3];A=d+(A<<3)|0;l=+p[A>>3];if((g|0)<(e|0)){s=a+(B<<1)|0;while(1){D=j[s>>1]|0;E=j[s+2>>1]|0;h=(D<<16>>16)+h|0;C=+(D<<16>>16);t=t+C*C;m=(E<<16>>16)+m|0;C=+(E<<16>>16);q=q+C*C;E=j[s+4>>1]|0;D=j[s+6>>1]|0;o=(E<<16>>16)+o|0;C=+(E<<16>>16);n=n+C*C;r=(D<<16>>16)+r|0;C=+(D<<16>>16);l=l+C*C;g=g+1|0;if((g|0)==(e|0)){g=e;break}else s=s+(f<<1)|0}}k[u>>2]=h;k[v>>2]=m;k[w>>2]=o;k[b>>2]=r;p[x>>3]=t;p[y>>3]=q;p[z>>3]=n;p[A>>3]=l;B=B+4|0}while((B|0)<(f|0));g=e;return g|0}switch(f|0){case 1:{h=k[c>>2]|0;l=+p[d>>3];if((e|0)>0){g=0;m=0;do{if(i[b+m>>0]|0){E=j[a+(m<<1)>>1]|0;C=+(E<<16>>16);l=l+C*C;h=(E<<16>>16)+h|0;g=g+1|0}m=m+1|0}while((m|0)!=(e|0))}else g=0;k[c>>2]=h;p[d>>3]=l;E=g;return E|0}case 3:{h=k[c>>2]|0;s=c+4|0;g=k[s>>2]|0;u=c+8|0;m=k[u>>2]|0;q=+p[d>>3];v=d+8|0;n=+p[v>>3];w=d+16|0;l=+p[w>>3];if((e|0)>0){o=g;r=0;g=0;while(1){if(i[b+r>>0]|0){E=j[a>>1]|0;D=j[a+2>>1]|0;f=j[a+4>>1]|0;C=+(E<<16>>16);t=+(D<<16>>16);F=+(f<<16>>16);l=l+F*F;n=n+t*t;q=q+C*C;m=(f<<16>>16)+m|0;o=(D<<16>>16)+o|0;h=(E<<16>>16)+h|0;g=g+1|0}r=r+1|0;if((r|0)==(e|0)){a=o;break}else a=a+6|0}}else{a=g;g=0}k[c>>2]=h;k[s>>2]=a;k[u>>2]=m;p[d>>3]=q;p[v>>3]=n;p[w>>3]=l;E=g;return E|0}default:{if((e|0)<=0){E=0;return E|0}if((f|0)>0){m=0;g=0}else{h=0;g=0;do{g=((i[b+h>>0]|0)!=0&1)+g|0;h=h+1|0}while((h|0)!=(e|0));return g|0}while(1){if(i[b+m>>0]|0){h=0;do{B=j[a+(h<<1)>>1]|0;D=c+(h<<2)|0;E=d+(h<<3)|0;F=+(B<<16>>16);F=+p[E>>3]+F*F;k[D>>2]=(k[D>>2]|0)+(B<<16>>16);p[E>>3]=F;h=h+1|0}while((h|0)!=(f|0));g=g+1|0}m=m+1|0;if((m|0)==(e|0))break;else a=a+(f<<1)|0}return g|0}}return 0}function A7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0.0,l=0.0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;if(!b){A=(f|0)%4|0;switch(A|0){case 1:{l=+p[c>>3];j=+p[d>>3];if((e|0)>0){g=a;h=0;while(1){u=+(k[g>>2]|0);l=l+u;j=j+u*u;h=h+1|0;if((h|0)==(e|0)){g=e;break}else g=g+(f<<2)|0}}else g=0;p[c>>3]=l;p[d>>3]=j;break}case 2:{j=+p[c>>3];m=c+8|0;n=+p[m>>3];o=+p[d>>3];s=d+8|0;l=+p[s>>3];if((e|0)>0){g=0;h=a;while(1){u=+(k[h>>2]|0);j=j+u;o=o+u*u;u=+(k[h+4>>2]|0);n=n+u;l=l+u*u;g=g+1|0;if((g|0)==(e|0)){g=e;break}else h=h+(f<<2)|0}}else g=0;p[c>>3]=j;p[m>>3]=n;p[d>>3]=o;p[s>>3]=l;break}case 3:{j=+p[c>>3];m=c+8|0;n=+p[m>>3];s=c+16|0;l=+p[s>>3];o=+p[d>>3];v=d+8|0;r=+p[v>>3];w=d+16|0;q=+p[w>>3];if((e|0)>0){g=0;h=a;while(1){u=+(k[h>>2]|0);j=j+u;o=o+u*u;u=+(k[h+4>>2]|0);n=n+u;r=r+u*u;u=+(k[h+8>>2]|0);l=l+u;q=q+u*u;g=g+1|0;if((g|0)==(e|0)){g=e;break}else h=h+(f<<2)|0}}else g=0;p[c>>3]=j;p[m>>3]=n;p[s>>3]=l;p[d>>3]=o;p[v>>3]=r;p[w>>3]=q;break}default:g=0}if((A|0)>=(f|0)){d=e;return d|0}do{m=c+(A<<3)|0;l=+p[m>>3];x=A+1|0;s=c+(x<<3)|0;o=+p[s>>3];y=A+2|0;v=c+(y<<3)|0;r=+p[v>>3];z=A+3|0;w=c+(z<<3)|0;u=+p[w>>3];b=d+(A<<3)|0;t=+p[b>>3];x=d+(x<<3)|0;q=+p[x>>3];y=d+(y<<3)|0;n=+p[y>>3];z=d+(z<<3)|0;j=+p[z>>3];if((g|0)<(e|0)){h=a+(A<<2)|0;while(1){B=+(k[h>>2]|0);l=l+B;t=t+B*B;B=+(k[h+4>>2]|0);o=o+B;q=q+B*B;B=+(k[h+8>>2]|0);r=r+B;n=n+B*B;B=+(k[h+12>>2]|0);u=u+B;j=j+B*B;g=g+1|0;if((g|0)==(e|0)){g=e;break}else h=h+(f<<2)|0}}p[m>>3]=l;p[s>>3]=o;p[v>>3]=r;p[w>>3]=u;p[b>>3]=t;p[x>>3]=q;p[y>>3]=n;p[z>>3]=j;A=A+4|0}while((A|0)<(f|0));g=e;return g|0}switch(f|0){case 1:{j=+p[c>>3];l=+p[d>>3];if((e|0)>0){g=0;h=0;do{if(i[b+h>>0]|0){B=+(k[a+(h<<2)>>2]|0);l=l+B*B;j=j+B;g=g+1|0}h=h+1|0}while((h|0)!=(e|0))}else g=0;p[c>>3]=j;p[d>>3]=l;d=g;return d|0}case 3:{j=+p[c>>3];m=c+8|0;n=+p[m>>3];s=c+16|0;q=+p[s>>3];r=+p[d>>3];v=d+8|0;o=+p[v>>3];w=d+16|0;l=+p[w>>3];if((e|0)>0){h=0;g=0;while(1){if(i[b+h>>0]|0){B=+(k[a>>2]|0);u=+(k[a+4>>2]|0);t=+(k[a+8>>2]|0);l=l+t*t;o=o+u*u;r=r+B*B;q=q+t;n=n+u;j=j+B;g=g+1|0}h=h+1|0;if((h|0)==(e|0))break;else a=a+12|0}}else g=0;p[c>>3]=j;p[m>>3]=n;p[s>>3]=q;p[d>>3]=r;p[v>>3]=o;p[w>>3]=l;d=g;return d|0}default:{if((e|0)<=0){d=0;return d|0}if((f|0)>0){m=0;g=0}else{h=0;g=0;do{g=((i[b+h>>0]|0)!=0&1)+g|0;h=h+1|0}while((h|0)!=(e|0));return g|0}while(1){if(i[b+m>>0]|0){h=0;do{z=c+(h<<3)|0;u=+(k[a+(h<<2)>>2]|0);A=d+(h<<3)|0;B=+p[A>>3]+u*u;p[z>>3]=+p[z>>3]+u;p[A>>3]=B;h=h+1|0}while((h|0)!=(f|0));g=g+1|0}m=m+1|0;if((m|0)==(e|0))break;else a=a+(f<<2)|0}return g|0}}return 0}function B7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;if(!b){A=(f|0)%4|0;switch(A|0){case 1:{k=+p[c>>3];j=+p[d>>3];if((e|0)>0){g=a;h=0;while(1){u=+o[g>>2];k=k+u;j=j+u*u;h=h+1|0;if((h|0)==(e|0)){g=e;break}else g=g+(f<<2)|0}}else g=0;p[c>>3]=k;p[d>>3]=j;break}case 2:{j=+p[c>>3];l=c+8|0;m=+p[l>>3];n=+p[d>>3];s=d+8|0;k=+p[s>>3];if((e|0)>0){g=0;h=a;while(1){u=+o[h>>2];j=j+u;n=n+u*u;u=+o[h+4>>2];m=m+u;k=k+u*u;g=g+1|0;if((g|0)==(e|0)){g=e;break}else h=h+(f<<2)|0}}else g=0;p[c>>3]=j;p[l>>3]=m;p[d>>3]=n;p[s>>3]=k;break}case 3:{j=+p[c>>3];l=c+8|0;m=+p[l>>3];s=c+16|0;k=+p[s>>3];n=+p[d>>3];v=d+8|0;r=+p[v>>3];w=d+16|0;q=+p[w>>3];if((e|0)>0){g=0;h=a;while(1){u=+o[h>>2];j=j+u;n=n+u*u;u=+o[h+4>>2];m=m+u;r=r+u*u;u=+o[h+8>>2];k=k+u;q=q+u*u;g=g+1|0;if((g|0)==(e|0)){g=e;break}else h=h+(f<<2)|0}}else g=0;p[c>>3]=j;p[l>>3]=m;p[s>>3]=k;p[d>>3]=n;p[v>>3]=r;p[w>>3]=q;break}default:g=0}if((A|0)>=(f|0)){d=e;return d|0}do{l=c+(A<<3)|0;k=+p[l>>3];x=A+1|0;s=c+(x<<3)|0;n=+p[s>>3];y=A+2|0;v=c+(y<<3)|0;r=+p[v>>3];z=A+3|0;w=c+(z<<3)|0;u=+p[w>>3];b=d+(A<<3)|0;t=+p[b>>3];x=d+(x<<3)|0;q=+p[x>>3];y=d+(y<<3)|0;m=+p[y>>3];z=d+(z<<3)|0;j=+p[z>>3];if((g|0)<(e|0)){h=a+(A<<2)|0;while(1){B=+o[h>>2];k=k+B;t=t+B*B;B=+o[h+4>>2];n=n+B;q=q+B*B;B=+o[h+8>>2];r=r+B;m=m+B*B;B=+o[h+12>>2];u=u+B;j=j+B*B;g=g+1|0;if((g|0)==(e|0)){g=e;break}else h=h+(f<<2)|0}}p[l>>3]=k;p[s>>3]=n;p[v>>3]=r;p[w>>3]=u;p[b>>3]=t;p[x>>3]=q;p[y>>3]=m;p[z>>3]=j;A=A+4|0}while((A|0)<(f|0));g=e;return g|0}switch(f|0){case 1:{j=+p[c>>3];k=+p[d>>3];if((e|0)>0){g=0;h=0;do{if(i[b+h>>0]|0){B=+o[a+(h<<2)>>2];k=k+B*B;j=j+B;g=g+1|0}h=h+1|0}while((h|0)!=(e|0))}else g=0;p[c>>3]=j;p[d>>3]=k;d=g;return d|0}case 3:{j=+p[c>>3];l=c+8|0;m=+p[l>>3];s=c+16|0;q=+p[s>>3];r=+p[d>>3];v=d+8|0;n=+p[v>>3];w=d+16|0;k=+p[w>>3];if((e|0)>0){h=0;g=0;while(1){if(i[b+h>>0]|0){B=+o[a>>2];u=+o[a+4>>2];t=+o[a+8>>2];k=k+t*t;n=n+u*u;r=r+B*B;q=q+t;m=m+u;j=j+B;g=g+1|0}h=h+1|0;if((h|0)==(e|0))break;else a=a+12|0}}else g=0;p[c>>3]=j;p[l>>3]=m;p[s>>3]=q;p[d>>3]=r;p[v>>3]=n;p[w>>3]=k;d=g;return d|0}default:{if((e|0)<=0){d=0;return d|0}if((f|0)>0){l=0;g=0}else{h=0;g=0;do{g=((i[b+h>>0]|0)!=0&1)+g|0;h=h+1|0}while((h|0)!=(e|0));return g|0}while(1){if(i[b+l>>0]|0){h=0;do{z=c+(h<<3)|0;u=+o[a+(h<<2)>>2];A=d+(h<<3)|0;B=+p[A>>3]+u*u;p[z>>3]=+p[z>>3]+u;p[A>>3]=B;h=h+1|0}while((h|0)!=(f|0));g=g+1|0}l=l+1|0;if((l|0)==(e|0))break;else a=a+(f<<2)|0}return g|0}}return 0}function C7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0;if(!b){z=(f|0)%4|0;switch(z|0){case 1:{k=+p[c>>3];j=+p[d>>3];if((e|0)>0){g=a;h=0;while(1){t=+p[g>>3];k=k+t;j=j+t*t;h=h+1|0;if((h|0)==(e|0)){g=e;break}else g=g+(f<<3)|0}}else g=0;p[c>>3]=k;p[d>>3]=j;break}case 2:{j=+p[c>>3];l=c+8|0;m=+p[l>>3];n=+p[d>>3];r=d+8|0;k=+p[r>>3];if((e|0)>0){g=0;h=a;while(1){s=+p[h>>3];t=+p[h+8>>3];j=j+s;n=n+s*s;m=m+t;k=k+t*t;g=g+1|0;if((g|0)==(e|0)){g=e;break}else h=h+(f<<3)|0}}else g=0;p[c>>3]=j;p[l>>3]=m;p[d>>3]=n;p[r>>3]=k;break}case 3:{j=+p[c>>3];l=c+8|0;m=+p[l>>3];r=c+16|0;k=+p[r>>3];n=+p[d>>3];u=d+8|0;q=+p[u>>3];v=d+16|0;o=+p[v>>3];if((e|0)>0){g=0;h=a;while(1){A=+p[h>>3];s=+p[h+8>>3];t=+p[h+16>>3];j=j+A;n=n+A*A;m=m+s;q=q+s*s;k=k+t;o=o+t*t;g=g+1|0;if((g|0)==(e|0)){g=e;break}else h=h+(f<<3)|0}}else g=0;p[c>>3]=j;p[l>>3]=m;p[r>>3]=k;p[d>>3]=n;p[u>>3]=q;p[v>>3]=o;break}default:g=0}if((z|0)>=(f|0)){d=e;return d|0}do{l=c+(z<<3)|0;k=+p[l>>3];w=z+1|0;r=c+(w<<3)|0;n=+p[r>>3];x=z+2|0;u=c+(x<<3)|0;q=+p[u>>3];y=z+3|0;v=c+(y<<3)|0;t=+p[v>>3];b=d+(z<<3)|0;s=+p[b>>3];w=d+(w<<3)|0;o=+p[w>>3];x=d+(x<<3)|0;m=+p[x>>3];y=d+(y<<3)|0;j=+p[y>>3];if((g|0)<(e|0)){h=a+(z<<3)|0;while(1){A=+p[h>>3];B=+p[h+8>>3];k=k+A;s=s+A*A;n=n+B;o=o+B*B;B=+p[h+16>>3];A=+p[h+24>>3];q=q+B;m=m+B*B;t=t+A;j=j+A*A;g=g+1|0;if((g|0)==(e|0)){g=e;break}else h=h+(f<<3)|0}}p[l>>3]=k;p[r>>3]=n;p[u>>3]=q;p[v>>3]=t;p[b>>3]=s;p[w>>3]=o;p[x>>3]=m;p[y>>3]=j;z=z+4|0}while((z|0)<(f|0));g=e;return g|0}switch(f|0){case 1:{j=+p[c>>3];k=+p[d>>3];if((e|0)>0){g=0;h=0;do{if(i[b+h>>0]|0){B=+p[a+(h<<3)>>3];k=k+B*B;j=j+B;g=g+1|0}h=h+1|0}while((h|0)!=(e|0))}else g=0;p[c>>3]=j;p[d>>3]=k;d=g;return d|0}case 3:{j=+p[c>>3];l=c+8|0;m=+p[l>>3];r=c+16|0;o=+p[r>>3];q=+p[d>>3];u=d+8|0;n=+p[u>>3];v=d+16|0;k=+p[v>>3];if((e|0)>0){h=0;g=0;while(1){if(i[b+h>>0]|0){B=+p[a>>3];A=+p[a+8>>3];t=+p[a+16>>3];k=k+t*t;n=n+A*A;q=q+B*B;o=o+t;m=m+A;j=j+B;g=g+1|0}h=h+1|0;if((h|0)==(e|0))break;else a=a+24|0}}else g=0;p[c>>3]=j;p[l>>3]=m;p[r>>3]=o;p[d>>3]=q;p[u>>3]=n;p[v>>3]=k;d=g;return d|0}default:{if((e|0)<=0){d=0;return d|0}if((f|0)>0){l=0;g=0}else{h=0;g=0;do{g=((i[b+h>>0]|0)!=0&1)+g|0;h=h+1|0}while((h|0)!=(e|0));return g|0}while(1){if(i[b+l>>0]|0){h=0;do{A=+p[a+(h<<3)>>3];y=c+(h<<3)|0;z=d+(h<<3)|0;B=A*A+ +p[z>>3];p[y>>3]=A+ +p[y>>3];p[z>>3]=B;h=h+1|0}while((h|0)!=(f|0));g=g+1|0}l=l+1|0;if((l|0)==(e|0))break;else a=a+(f<<3)|0}return g|0}}return 0}function D7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+208|0;H=I+152|0;G=I+96|0;t=I+80|0;v=I+72|0;u=I+40|0;w=I+36|0;F=I+32|0;x=I+28|0;y=I+24|0;z=I+20|0;A=I+16|0;B=I+8|0;C=I;q=S1(a,-1)|0;E=q&7;q=q>>>3&511;s=q+1|0;g=G2(f)|0;if(!q){if(!g?S1(f,-1)|0:0)h=5}else if((e|0)!=0|((d|0)!=0|g^1))h=5;if((h|0)==5){g=H+4|0;h=ZT(112)|0;k[h>>2]=1;j=h+4|0;k[H>>2]=j;k[g>>2]=104;i[h+108>>0]=0;l=230113;m=j+104|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,H,230218,229892,2328);k[g>>2]=0;k[H>>2]=0;q=k[h>>2]|0;k[h>>2]=q+-1;if((q|0)==1)ggb(k[h+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[H>>2]=k[j>>2];q=H+4|0;g=j+4|0;k[q>>2]=k[g>>2];n=H+8|0;k[n>>2]=k[j+8>>2];k[H+12>>2]=k[j+12>>2];k[H+16>>2]=k[j+16>>2];k[H+20>>2]=k[j+20>>2];k[H+24>>2]=k[j+24>>2];k[H+28>>2]=k[j+28>>2];k[H+32>>2]=k[j+32>>2];h=k[j+36>>2]|0;k[H+36>>2]=h;a=H+40|0;k[a>>2]=n;n=H+48|0;m=H+44|0;k[m>>2]=n;k[H+52>>2]=0;k[n>>2]=0;if(h|0){n=h+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[g>>2]|0)<3){n=k[j+44>>2]|0;q=k[m>>2]|0;k[q>>2]=k[n>>2];k[q+4>>2]=k[n+4>>2];break}k[q>>2]=0;x1(H,k[g>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[j+40>>2]|0;l=k[a>>2]|0;a=k[j+44>>2]|0;h=k[m>>2]|0;g=0;do{k[l+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[a+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else Q1(H,a,-1);while(0);do if((k[f>>2]&2031616|0)==65536){j=k[f+4>>2]|0;k[G>>2]=k[j>>2];q=G+4|0;g=j+4|0;k[q>>2]=k[g>>2];f=G+8|0;k[f>>2]=k[j+8>>2];k[G+12>>2]=k[j+12>>2];k[G+16>>2]=k[j+16>>2];k[G+20>>2]=k[j+20>>2];k[G+24>>2]=k[j+24>>2];k[G+28>>2]=k[j+28>>2];k[G+32>>2]=k[j+32>>2];h=k[j+36>>2]|0;k[G+36>>2]=h;a=G+40|0;k[a>>2]=f;f=G+48|0;m=G+44|0;k[m>>2]=f;k[G+52>>2]=0;k[f>>2]=0;if(h|0){f=h+12|0;k[f>>2]=(k[f>>2]|0)+1}if((k[g>>2]|0)<3){q=k[j+44>>2]|0;f=k[m>>2]|0;k[f>>2]=k[q>>2];k[f+4>>2]=k[q+4>>2];break}k[q>>2]=0;x1(G,k[g>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[j+40>>2]|0;l=k[a>>2]|0;a=k[j+44>>2]|0;h=k[m>>2]|0;g=0;do{k[l+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[a+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else Q1(G,f,-1);while(0);q=k[49800+(E<<2)>>2]|0;if((E|0)==7){k[t>>2]=0;g=t+4|0;k[g>>2]=0;h=ZT(16)|0;k[h>>2]=1;j=h+4|0;k[t>>2]=j;k[g>>2]=9;i[h+13>>0]=0;l=335726;m=j+9|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,t,230218,229892,2337);k[g>>2]=0;k[t>>2]=0;f=k[h>>2]|0;k[h>>2]=f+-1;if((f|0)==1)ggb(k[h+-4>>2]|0)}k[t>>2]=H;k[t+4>>2]=G;k[t+8>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;k[u+16>>2]=0;k[u+20>>2]=0;k[u+24>>2]=0;k[u+28>>2]=0;z1(u,t,0,v,-1);k[w>>2]=0;k[F>>2]=0;k[x>>2]=2147483647;k[y>>2]=-2147483648;o[z>>2]=D;o[A>>2]=-D;p[B>>3]=D;p[C>>3]=-D;l=aa(k[u+20>>2]|0,s)|0;f=(E|0)==5;if(!f)if((E|0)==6){h=C;a=B}else{h=y;a=x}else{h=A;a=z}m=u+16|0;if(k[m>>2]|0){n=v+4|0;g=0;j=1;while(1){sh[q&255](k[v>>2]|0,k[n>>2]|0,a,h,w,F,l,j);A1(u);g=g+1|0;if(g>>>0>=(k[m>>2]|0)>>>0)break;else j=j+l|0}}m=H+16|0;do if(k[m>>2]|0){a=k[H+4>>2]|0;if((a|0)<3)g=aa(k[H+12>>2]|0,k[H+8>>2]|0)|0;else{j=k[H+40>>2]|0;h=0;g=1;do{g=aa(k[j+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(a|0))}if(g|0){if(k[G+16>>2]|0){a=k[G+4>>2]|0;if((a|0)<3)g=aa(k[G+12>>2]|0,k[G+8>>2]|0)|0;else{j=k[G+40>>2]|0;h=0;g=1;do{g=aa(k[j+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(a|0))}if(g|0)break}if(!(k[w>>2]|0))k[w>>2]=1;if(!(k[F>>2]|0))k[F>>2]=1}}while(0);l=k[w>>2]|0;h=(l|0)==0;do if(!h){if(f){p[B>>3]=+o[z>>2];p[C>>3]=+o[A>>2];break}if(E>>>0<5){p[B>>3]=+(k[x>>2]|0);p[C>>3]=+(k[y>>2]|0)}}else{p[C>>3]=0.0;p[B>>3]=0.0}while(0);if(b|0)p[b>>3]=+p[B>>3];if(c|0)p[c>>3]=+p[C>>3];do if(d|0){a=k[H+4>>2]|0;g=(a|0)>0;if(h){if(!g)break;zpb(d|0,-1,a<<2|0)|0;break}if(g){j=k[H+40>>2]|0;g=l+-1|0;while(1){E=a;a=a+-1|0;h=k[j+(a<<2)>>2]|0;k[d+(a<<2)>>2]=(g>>>0)%(h>>>0)|0;if((E|0)<=1)break;else g=(g>>>0)/(h>>>0)|0}}}while(0);do if(e|0){a=k[F>>2]|0;h=k[H+4>>2]|0;g=(h|0)>0;if(!a){if(!g)break;zpb(e|0,-1,h<<2|0)|0;break}if(g){j=k[H+40>>2]|0;g=a+-1|0;while(1){d=h;h=h+-1|0;a=k[j+(h<<2)>>2]|0;k[e+(h<<2)>>2]=(g>>>0)%(a>>>0)|0;if((d|0)<=1)break;else g=(g>>>0)/(a>>>0)|0}}}while(0);a=G+36|0;g=k[a>>2]|0;if(g|0?(d=g+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){h=k[a>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[G+32>>2]|0;if(!g){g=B1()|0;h=k[a>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[a>>2]=0}k[a>>2]=0;e=G+16|0;h=G+4|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[h>>2]|0)>0){a=k[G+40>>2]|0;g=0;do{k[a+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[G+44>>2]|0;if(!((g|0)==(G+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);a=H+36|0;g=k[a>>2]|0;if(g|0?(e=g+12|0,G=k[e>>2]|0,k[e>>2]=G+-1,(G|0)==1):0){h=k[a>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[H+32>>2]|0;if(g|0)break;g=B1()|0;h=k[a>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[a>>2]=0}k[a>>2]=0;a=H+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[a>>2]|0)>0){h=k[H+40>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[a>>2]|0))}g=k[H+44>>2]|0;if((g|0)==(H+48|0)|(g|0)==0){r=I;return}ggb(k[g+-4>>2]|0);r=I;return}function E7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=k[c>>2]|0;o=k[d>>2]|0;j=k[e>>2]|0;m=k[f>>2]|0;p=(g|0)>0;if(!b){if(p){p=0;do{b=l[a+p>>0]|0;q=(b|0)<(n|0);r=p+h|0;j=q?r:j;n=q?b:n;q=(b|0)>(o|0);m=q?r:m;o=q?b:o;p=p+1|0}while((p|0)!=(g|0))}}else if(p){q=0;do{p=l[a+q>>0]|0;if(i[b+q>>0]|0){s=q+h|0;r=(p|0)<(n|0);t=(p|0)>(o|0);o=t?p:o;m=t?s:m;j=r?s:j;n=r?p:n}q=q+1|0}while((q|0)!=(g|0))}k[e>>2]=j;k[f>>2]=m;k[c>>2]=n;k[d>>2]=o;return}function F7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;m=k[c>>2]|0;n=k[d>>2]|0;j=k[e>>2]|0;l=k[f>>2]|0;o=(g|0)>0;if(!b){if(o){o=0;do{b=i[a+o>>0]|0;p=(b|0)<(m|0);q=o+h|0;j=p?q:j;m=p?b:m;p=(b|0)>(n|0);l=p?q:l;n=p?b:n;o=o+1|0}while((o|0)!=(g|0))}}else if(o){p=0;do{o=i[a+p>>0]|0;if(i[b+p>>0]|0){r=p+h|0;q=(o|0)<(m|0);s=(o|0)>(n|0);n=s?o:n;l=s?r:l;j=q?r:j;m=q?o:m}p=p+1|0}while((p|0)!=(g|0))}k[e>>2]=j;k[f>>2]=l;k[c>>2]=m;k[d>>2]=n;return}function G7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=k[c>>2]|0;o=k[d>>2]|0;j=k[e>>2]|0;l=k[f>>2]|0;p=(g|0)>0;if(!b){if(p){p=0;do{b=m[a+(p<<1)>>1]|0;q=(b|0)<(n|0);r=p+h|0;j=q?r:j;n=q?b:n;q=(b|0)>(o|0);l=q?r:l;o=q?b:o;p=p+1|0}while((p|0)!=(g|0))}}else if(p){q=0;do{p=m[a+(q<<1)>>1]|0;if(i[b+q>>0]|0){s=q+h|0;r=(p|0)<(n|0);t=(p|0)>(o|0);o=t?p:o;l=t?s:l;j=r?s:j;n=r?p:n}q=q+1|0}while((q|0)!=(g|0))}k[e>>2]=j;k[f>>2]=l;k[c>>2]=n;k[d>>2]=o;return}function H7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=k[c>>2]|0;o=k[d>>2]|0;l=k[e>>2]|0;m=k[f>>2]|0;p=(g|0)>0;if(!b){if(p){p=0;do{b=j[a+(p<<1)>>1]|0;q=(b|0)<(n|0);r=p+h|0;l=q?r:l;n=q?b:n;q=(b|0)>(o|0);m=q?r:m;o=q?b:o;p=p+1|0}while((p|0)!=(g|0))}}else if(p){q=0;do{p=j[a+(q<<1)>>1]|0;if(i[b+q>>0]|0){s=q+h|0;r=(p|0)<(n|0);t=(p|0)>(o|0);o=t?p:o;m=t?s:m;l=r?s:l;n=r?p:n}q=q+1|0}while((q|0)!=(g|0))}k[e>>2]=l;k[f>>2]=m;k[c>>2]=n;k[d>>2]=o;return}function I7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;m=k[c>>2]|0;n=k[d>>2]|0;j=k[e>>2]|0;l=k[f>>2]|0;o=(g|0)>0;if(!b){if(o){o=0;do{b=k[a+(o<<2)>>2]|0;p=(b|0)<(m|0);q=o+h|0;j=p?q:j;m=p?b:m;p=(b|0)>(n|0);l=p?q:l;n=p?b:n;o=o+1|0}while((o|0)!=(g|0))}}else if(o){o=0;do{q=k[a+(o<<2)>>2]|0;p=(i[b+o>>0]|0)!=0;s=(q|0)<(m|0)&p;r=o+h|0;j=s?r:j;m=s?q:m;p=(q|0)>(n|0)&p;l=p?r:l;n=p?q:n;o=o+1|0}while((o|0)!=(g|0))}k[e>>2]=j;k[f>>2]=l;k[c>>2]=m;k[d>>2]=n;return}function J7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0.0,n=0.0,p=0,q=0.0,r=0,s=0,t=0;m=+o[c>>2];n=+o[d>>2];j=k[e>>2]|0;l=k[f>>2]|0;p=(g|0)>0;if(!b){if(p){p=0;do{q=+o[a+(p<<2)>>2];b=q<m;r=p+h|0;j=b?r:j;m=b?q:m;b=q>n;l=b?r:l;n=b?q:n;p=p+1|0}while((p|0)!=(g|0))}}else if(p){p=0;do{q=+o[a+(p<<2)>>2];r=(i[b+p>>0]|0)!=0;t=q<m&r;s=p+h|0;j=t?s:j;m=t?q:m;r=q>n&r;l=r?s:l;n=r?q:n;p=p+1|0}while((p|0)!=(g|0))}k[e>>2]=j;k[f>>2]=l;o[c>>2]=m;o[d>>2]=n;return}function K7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0.0,n=0.0,o=0,q=0.0,r=0,s=0,t=0;m=+p[c>>3];n=+p[d>>3];j=k[e>>2]|0;l=k[f>>2]|0;o=(g|0)>0;if(!b){if(o){o=0;do{q=+p[a+(o<<3)>>3];b=q<m;r=o+h|0;j=b?r:j;m=b?q:m;b=q>n;l=b?r:l;n=b?q:n;o=o+1|0}while((o|0)!=(g|0))}}else if(o){o=0;do{q=+p[a+(o<<3)>>3];r=(i[b+o>>0]|0)!=0;t=q<m&r;s=o+h|0;j=t?s:j;m=t?q:m;r=q>n&r;l=r?s:l;n=r?q:n;o=o+1|0}while((o|0)!=(g|0))}k[e>>2]=j;k[f>>2]=l;p[c>>3]=m;p[d>>3]=n;return}function L7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0;m=r;r=r+16|0;h=m;if((a2(a)|0)>=3){j=h+4|0;g=ZT(24)|0;k[g>>2]=1;l=g+4|0;k[h>>2]=l;k[j>>2]=16;i[g+20>>0]=0;n=230228;o=l+16|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));Y8(-215,h,230245,229892,2388);k[j>>2]=0;k[h>>2]=0;o=k[g>>2]|0;k[g>>2]=o+-1;if((o|0)==1)ggb(k[g+-4>>2]|0)}D7(a,b,c,d,e,f);if(d|0){o=d+4|0;n=k[d>>2]|0;k[d>>2]=k[o>>2];k[o>>2]=n}if(!e){r=m;return}o=e+4|0;n=k[e>>2]|0;k[e>>2]=k[o>>2];k[o>>2]=n;r=m;return}function M7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;f=c+-4|0;if((c|0)<4){d=0;e=0}else{e=0;d=0;do{j=e|1;h=e|2;g=e|3;d=(l[376255+((i[b+e>>0]^i[a+e>>0])&255)>>0]|0)+d+(l[376255+((i[b+j>>0]^i[a+j>>0])&255)>>0]|0)+(l[376255+((i[b+h>>0]^i[a+h>>0])&255)>>0]|0)+(l[376255+((i[b+g>>0]^i[a+g>>0])&255)>>0]|0)|0;e=e+4|0}while((e|0)<=(f|0));e=c&-4}if((e|0)>=(c|0)){j=d;return j|0}do{d=(l[376255+((i[b+e>>0]^i[a+e>>0])&255)>>0]|0)+d|0;e=e+1|0}while((e|0)!=(c|0));return d|0}function N7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,R=0.0,S=0.0;M=r;r=r+272|0;w=M+248|0;J=M+192|0;L=M+136|0;K=M+80|0;I=M;G=M+48|0;F=M+32|0;v=b&7;D=(v|0)==1;t=(v|0)==2;E=(v|0)==4;q=(v|0)==5;n=b&255;a:do switch(n&7){case 1:case 2:case 4:case 5:break;default:{if((v|1|0)==7?(S1(a,-1)|0)==0:0)break a;C=w+4|0;b=ZT(184)|0;k[b>>2]=1;B=b+4|0;k[w>>2]=B;k[C>>2]=177;i[b+181>>0]=0;upb(B|0,230255,177)|0;Y8(-215,w,366900,229892,2846);k[C>>2]=0;k[w>>2]=0;C=k[b>>2]|0;k[b>>2]=C+-1;if((C|0)==1)ggb(k[b+-4>>2]|0)}}while(0);do if((k[a>>2]&2031616|0)==65536){f=k[a+4>>2]|0;k[L>>2]=k[f>>2];m=L+4|0;b=f+4|0;k[m>>2]=k[b>>2];C=L+8|0;k[C>>2]=k[f+8>>2];k[L+12>>2]=k[f+12>>2];k[L+16>>2]=k[f+16>>2];k[L+20>>2]=k[f+20>>2];k[L+24>>2]=k[f+24>>2];k[L+28>>2]=k[f+28>>2];k[L+32>>2]=k[f+32>>2];a=k[f+36>>2]|0;k[L+36>>2]=a;e=L+40|0;k[e>>2]=C;C=L+48|0;h=L+44|0;k[h>>2]=C;k[L+52>>2]=0;k[C>>2]=0;if(a|0){C=a+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[b>>2]|0)<3){B=k[f+44>>2]|0;C=k[h>>2]|0;k[C>>2]=k[B>>2];k[C+4>>2]=k[B+4>>2];break}k[m>>2]=0;x1(L,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;a=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[a+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else Q1(L,a,-1);while(0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[K>>2]=k[g>>2];m=K+4|0;b=g+4|0;k[m>>2]=k[b>>2];C=K+8|0;k[C>>2]=k[g+8>>2];k[K+12>>2]=k[g+12>>2];c=K+16|0;k[c>>2]=k[g+16>>2];k[K+20>>2]=k[g+20>>2];k[K+24>>2]=k[g+24>>2];k[K+28>>2]=k[g+28>>2];k[K+32>>2]=k[g+32>>2];a=k[g+36>>2]|0;k[K+36>>2]=a;e=K+40|0;k[e>>2]=C;C=K+48|0;h=K+44|0;k[h>>2]=C;k[K+52>>2]=0;k[C>>2]=0;if(a|0){C=a+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[b>>2]|0)<3){B=k[g+44>>2]|0;C=k[h>>2]|0;k[C>>2]=k[B>>2];k[C+4>>2]=k[B+4>>2];break}k[m>>2]=0;x1(K,k[b>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[g+40>>2]|0;f=k[e>>2]|0;e=k[g+44>>2]|0;a=k[h>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[j+(b<<2)>>2];k[a+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[m>>2]|0))}}else{Q1(K,c,-1);c=K+16|0}while(0);C=k[L>>2]|0;j=C&7;B=(C>>>3&511)+1|0;g=k[c>>2]|0;b:do if(!(C&16384))H=76;else{if(g|0){e=k[K+4>>2]|0;if((e|0)<3)b=aa(k[K+12>>2]|0,k[K+8>>2]|0)|0;else{f=k[K+40>>2]|0;a=0;b=1;do{b=aa(k[f+(a<<2)>>2]|0,b)|0;a=a+1|0}while((a|0)!=(e|0))}if(b|0){H=76;break}}e=k[L+4>>2]|0;if((e|0)<3)b=aa(k[L+12>>2]|0,k[L+8>>2]|0)|0;else{f=k[L+40>>2]|0;a=0;b=1;do{b=aa(k[f+(a<<2)>>2]|0,b)|0;a=a+1|0}while((a|0)!=(e|0))}h=aa(b,B)|0;switch(C&7){case 5:break;case 0:{f=k[L+16>>2]|0;switch(n&7){case 6:{e=h+-4|0;if((h|0)<4){b=0;a=0}else{a=0;b=0;do{b=(l[376255+(l[f+a>>0]|0)>>0]|0)+b+(l[376255+(l[f+(a|1)>>0]|0)>>0]|0)+(l[376255+(l[f+(a|2)>>0]|0)>>0]|0)+(l[376255+(l[f+(a|3)>>0]|0)>>0]|0)|0;a=a+4|0}while((a|0)<=(e|0));a=h&-4}if((a|0)<(h|0))do{b=(l[376255+(l[f+a>>0]|0)>>0]|0)+b|0;a=a+1|0}while((a|0)!=(h|0));d=+(b|0);break b}case 7:{e=h+-4|0;if((h|0)<4){b=0;a=0}else{a=0;b=0;do{b=(l[230433+(l[f+a>>0]|0)>>0]|0)+b+(l[230433+(l[f+(a|1)>>0]|0)>>0]|0)+(l[230433+(l[f+(a|2)>>0]|0)>>0]|0)+(l[230433+(l[f+(a|3)>>0]|0)>>0]|0)|0;a=a+4|0}while((a|0)<=(e|0));a=h&-4}if((a|0)<(h|0))do{b=(l[230433+(l[f+a>>0]|0)>>0]|0)+b|0;a=a+1|0}while((a|0)!=(h|0));d=+(b|0);break b}default:{H=76;break b}}}default:{H=76;break b}}e=k[L+16>>2]|0;if(E){a=h+-4|0;if((h|0)<4){d=0.0;b=0}else{b=0;d=0.0;do{S=+o[e+(b<<2)>>2];R=+o[e+((b|1)<<2)>>2];O=+o[e+((b|2)<<2)>>2];N=+o[e+((b|3)<<2)>>2];d=d+(S*S+R*R+O*O+N*N);b=b+4|0}while((b|0)<=(a|0));b=h&-4}if((b|0)<(h|0))do{S=+o[e+(b<<2)>>2];d=d+S*S;b=b+1|0}while((b|0)!=(h|0));d=+Q(+(d+0.0));break}if(q){a=h+-4|0;if((h|0)<4){d=0.0;b=0}else{b=0;d=0.0;do{N=+o[e+(b<<2)>>2];O=+o[e+((b|1)<<2)>>2];R=+o[e+((b|2)<<2)>>2];S=+o[e+((b|3)<<2)>>2];d=d+(N*N+O*O+R*R+S*S);b=b+4|0}while((b|0)<=(a|0));b=h&-4}if((b|0)<(h|0))do{S=+o[e+(b<<2)>>2];d=d+S*S;b=b+1|0}while((b|0)!=(h|0));d=d+0.0;break}if(!t){if(!D){H=76;break}k[w>>2]=0;if((h|0)>0){b=0;d=0.0;do{S=+P(+(+o[e+(b<<2)>>2]));o[J>>2]=S;I=k[(d<S?J:w)>>2]|0;k[w>>2]=I;b=b+1|0;d=(k[u>>2]=I,+o[u>>2])}while((b|0)!=(h|0))}else d=0.0;d=d>0.0?d:0.0;break}a=h+-4|0;if((h|0)<4){b=0;d=0.0}else{d=0.0;b=0;do{S=+P(+(+o[e+(b<<2)>>2]));S=S+ +P(+(+o[e+((b|1)<<2)>>2]));S=S+ +P(+(+o[e+((b|2)<<2)>>2]));d=d+(S+ +P(+(+o[e+((b|3)<<2)>>2])));b=b+4|0}while((b|0)<=(a|0));b=h&-4}if((b|0)<(h|0))do{d=d+ +P(+(+o[e+(b<<2)>>2]));b=b+1|0}while((b|0)!=(h|0));d=d+0.0}while(0);do if((H|0)==76){if(g|0){e=k[K+4>>2]|0;if((e|0)<3)b=aa(k[K+12>>2]|0,k[K+8>>2]|0)|0;else{f=k[K+40>>2]|0;a=0;b=1;do{b=aa(k[f+(a<<2)>>2]|0,b)|0;a=a+1|0}while((a|0)!=(e|0))}if(b|0?k[K>>2]&4095|0:0){k[w>>2]=0;b=w+4|0;k[b>>2]=0;a=ZT(44)|0;k[a>>2]=1;h=a+4|0;k[w>>2]=h;k[b>>2]=36;i[a+40>>0]=0;f=229968;m=h+36|0;do{i[h>>0]=i[f>>0]|0;h=h+1|0;f=f+1|0}while((h|0)<(m|0));Y8(-215,w,366900,229892,2913);k[b>>2]=0;k[w>>2]=0;A=k[a>>2]|0;k[a>>2]=A+-1;if((A|0)==1)ggb(k[a+-4>>2]|0)}}s=(v|0)==6;e=v|1;if((e|0)!=7){A=k[49832+(v>>>1<<5)+(j<<2)>>2]|0;if(!A){k[w>>2]=0;b=w+4|0;k[b>>2]=0;a=ZT(16)|0;k[a>>2]=1;h=a+4|0;k[w>>2]=h;k[b>>2]=9;i[a+13>>0]=0;f=335726;m=h+9|0;do{i[h>>0]=i[f>>0]|0;h=h+1|0;f=f+1|0}while((h|0)<(m|0));Y8(-215,w,366900,229892,2940);k[b>>2]=0;k[w>>2]=0;z=k[a>>2]|0;k[a>>2]=z+-1;if((z|0)==1)ggb(k[a+-4>>2]|0)}k[w>>2]=L;k[w+4>>2]=K;k[w+8>>2]=0;p[I>>3]=0.0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;k[G+16>>2]=0;k[G+20>>2]=0;k[G+24>>2]=0;k[G+28>>2]=0;z1(G,w,0,J,-1);z=k[G+20>>2]|0;if(!(t&j>>>0<4)){k[F>>2]=0;if((e|0)==5&j>>>0<2){f=I;H=127}else{x=0;y=I;a=0;e=z;f=I;w=0}}else{k[F>>2]=0;f=I;H=127}if((H|0)==127){a=((t&j>>>0<2?8388608:32768)>>>0)/(B>>>0)|0;e=(a|0)<(z|0)?a:z;b=k[L+4>>2]|0;if((b|0)>0){x=k[(k[L+44>>2]|0)+(b+-1<<2)>>2]|0;y=F;w=1}else{x=0;y=F;w=1}}v=G+16|0;t=J+4|0;c:do if((z|0)>0){g=0;b=0;while(1){h=k[v>>2]|0;if(g>>>0>=h>>>0)break c;g=g+1|0;j=k[J>>2]|0;q=k[t>>2]|0;if(w){s=g>>>0<h>>>0;n=0;h=q;do{m=z-n|0;m=(e|0)<(m|0)?e:m;$g[A&127](j,h,y,m,B)|0;b=m+b|0;if(!((b+e|0)<(a|0)?(m+n|0)<(z|0)|s:0)){p[I>>3]=+p[I>>3]+ +(k[F>>2]|0);k[F>>2]=0;b=0}j=aa(m,x)|0;j=(k[J>>2]|0)+j|0;k[J>>2]=j;h=k[t>>2]|0;if(!h)h=0;else{h=h+m|0;k[t>>2]=h}n=n+e|0}while((z|0)>(n|0))}else{n=0;m=j;h=q;do{j=z-n|0;j=(e|0)<(j|0)?e:j;$g[A&127](m,h,y,j,B)|0;b=j+b|0;h=aa(j,x)|0;m=(k[J>>2]|0)+h|0;k[J>>2]=m;h=k[t>>2]|0;if(!h)h=0;else{h=h+j|0;k[t>>2]=h}n=n+e|0}while((z|0)>(n|0))}A1(G)}}else{b=0;while(1){if(b>>>0>=(k[v>>2]|0)>>>0)break c;A1(G);b=b+1|0}}while(0);d:do if(!D){if(E){S=+Q(+(+p[I>>3]));p[I>>3]=S}}else switch(C&7){case 6:break d;case 5:{p[I>>3]=+o[I>>2];break d}default:{p[I>>3]=+(k[f>>2]|0);break d}}while(0);d=+p[I>>3];break}if(k[c>>2]|0){e=k[K+4>>2]|0;if((e|0)<3)b=aa(k[K+12>>2]|0,k[K+8>>2]|0)|0;else{f=k[K+40>>2]|0;a=0;b=1;do{b=aa(k[f+(a<<2)>>2]|0,b)|0;a=a+1|0}while((a|0)!=(e|0))}if(b|0){k[J>>2]=1124007936;j=J+4|0;b=J+8|0;g=J+40|0;h=j;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[g>>2]=b;h=J+48|0;f=J+44|0;k[f>>2]=h;k[J+52>>2]=0;k[h>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;k[I>>2]=16842752;k[I+4>>2]=L;k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=K;e=F+4|0;b=e+4|0;k[b>>2]=0;k[b+4>>2]=0;k[F>>2]=33619968;k[e>>2]=J;k[w>>2]=98;aU(I,G,F,49332,w,1,9);k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=J;d=+N7(w,v,49332);e=J+36|0;b=k[e>>2]|0;if(b|0?(H=b+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){a=k[e>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[J+32>>2]|0;if(!b){b=B1()|0;a=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[e>>2]=0}k[e>>2]=0;J=J+16|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[j>>2]|0)>0){a=k[g>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[j>>2]|0))}b=k[f>>2]|0;if(!((b|0)==(h|0)|(b|0)==0))ggb(k[b+-4>>2]|0);break}}k[w>>2]=L;k[w+4>>2]=0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;k[I+16>>2]=0;k[I+20>>2]=0;k[I+24>>2]=0;k[I+28>>2]=0;z1(I,w,0,J,-1);h=k[I+20>>2]|0;j=I+16|0;m=h+-4|0;n=(h|0)<4;q=h&-4;f=0;g=0;while(1){if(f>>>0>=(k[j>>2]|0)>>>0)break;e=k[J>>2]|0;if(s){if(n){b=0;a=0}else{a=0;b=0;do{b=(l[376255+(l[e+a>>0]|0)>>0]|0)+b+(l[376255+(l[e+(a|1)>>0]|0)>>0]|0)+(l[376255+(l[e+(a|2)>>0]|0)>>0]|0)+(l[376255+(l[e+(a|3)>>0]|0)>>0]|0)|0;a=a+4|0}while((a|0)<=(m|0));a=q}if((a|0)<(h|0))do{b=(l[376255+(l[e+a>>0]|0)>>0]|0)+b|0;a=a+1|0}while((a|0)!=(h|0))}else{if(n){b=0;a=0}else{a=0;b=0;do{b=(l[230433+(l[e+a>>0]|0)>>0]|0)+b+(l[230433+(l[e+(a|1)>>0]|0)>>0]|0)+(l[230433+(l[e+(a|2)>>0]|0)>>0]|0)+(l[230433+(l[e+(a|3)>>0]|0)>>0]|0)|0;a=a+4|0}while((a|0)<=(m|0));a=q}if((a|0)<(h|0))do{b=(l[230433+(l[e+a>>0]|0)>>0]|0)+b|0;a=a+1|0}while((a|0)!=(h|0))}A1(I);f=f+1|0;g=b+g|0}d=+(g|0)}while(0);e=K+36|0;b=k[e>>2]|0;if(b|0?(I=b+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){a=k[e>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[K+32>>2]|0;if(!b){b=B1()|0;a=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[e>>2]=0}k[e>>2]=0;e=K+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[e>>2]|0)>0){a=k[K+40>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[K+44>>2]|0;if(!((b|0)==(K+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=L+36|0;b=k[e>>2]|0;if(b|0?(J=b+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){a=k[e>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[L+32>>2]|0;if(!b){b=B1()|0;a=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[e>>2]=0}k[e>>2]=0;K=L+16|0;a=L+4|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[a>>2]|0)>0){e=k[L+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[L+44>>2]|0;if((b|0)==(L+48|0)|(b|0)==0){r=M;return +d}ggb(k[b+-4>>2]|0);r=M;return +d}function O7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=k[c>>2]|0;if(!b){b=aa(e,d)|0;if((b|0)>0){g=0;h=0;do{e=l[a+h>>0]|0;g=(g|0)<(e|0)?e:g;h=h+1|0}while((h|0)!=(b|0))}else g=0;e=(f|0)<(g|0)?g:f;k[c>>2]=e;return 0}if((d|0)>0&(e|0)>0)h=0;else{e=f;k[c>>2]=e;return 0}while(1){if(i[b+h>>0]|0){g=0;do{j=l[a+g>>0]|0;f=(f|0)<(j|0)?j:f;g=g+1|0}while((g|0)!=(e|0))}h=h+1|0;if((h|0)==(d|0))break;else a=a+e|0}k[c>>2]=f;return 0}function P7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0;f=k[c>>2]|0;if(!b){b=aa(e,d)|0;if((b|0)>0){g=0;h=0;do{d=i[a+h>>0]|0;e=d<<24>>24;e=d<<24>>24>-1?e:0-e|0;g=(g|0)<(e|0)?e:g;h=h+1|0}while((h|0)!=(b|0))}else g=0;e=(f|0)<(g|0)?g:f;k[c>>2]=e;return 0}if((d|0)>0&(e|0)>0)h=0;else{e=f;k[c>>2]=e;return 0}while(1){if(i[b+h>>0]|0){g=0;do{l=i[a+g>>0]|0;j=l<<24>>24;j=l<<24>>24>-1?j:0-j|0;f=(f|0)<(j|0)?j:f;g=g+1|0}while((g|0)!=(e|0))}h=h+1|0;if((h|0)==(d|0))break;else a=a+e|0}k[c>>2]=f;return 0}function Q7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=k[c>>2]|0;if(!b){b=aa(e,d)|0;if((b|0)>0){g=0;h=0;do{e=m[a+(h<<1)>>1]|0;g=(g|0)<(e|0)?e:g;h=h+1|0}while((h|0)!=(b|0))}else g=0;e=(f|0)<(g|0)?g:f;k[c>>2]=e;return 0}if((d|0)>0&(e|0)>0)h=0;else{e=f;k[c>>2]=e;return 0}while(1){if(i[b+h>>0]|0){g=0;do{j=m[a+(g<<1)>>1]|0;f=(f|0)<(j|0)?j:f;g=g+1|0}while((g|0)!=(e|0))}h=h+1|0;if((h|0)==(d|0))break;else a=a+(e<<1)|0}k[c>>2]=f;return 0}function R7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0;f=k[c>>2]|0;if(!b){b=aa(e,d)|0;if((b|0)>0){g=0;h=0;do{d=j[a+(h<<1)>>1]|0;e=d<<16>>16;e=d<<16>>16>-1?e:0-e|0;g=(g|0)<(e|0)?e:g;h=h+1|0}while((h|0)!=(b|0))}else g=0;e=(f|0)<(g|0)?g:f;k[c>>2]=e;return 0}if((d|0)>0&(e|0)>0)h=0;else{e=f;k[c>>2]=e;return 0}while(1){if(i[b+h>>0]|0){g=0;do{m=j[a+(g<<1)>>1]|0;l=m<<16>>16;l=m<<16>>16>-1?l:0-l|0;f=(f|0)<(l|0)?l:f;g=g+1|0}while((g|0)!=(e|0))}h=h+1|0;if((h|0)==(d|0))break;else a=a+(e<<1)|0}k[c>>2]=f;return 0}function S7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=k[c>>2]|0;if(!b){b=aa(e,d)|0;if((b|0)>0){g=0;h=0;do{e=k[a+(h<<2)>>2]|0;e=(e|0)>-1?e:0-e|0;g=(g|0)<(e|0)?e:g;h=h+1|0}while((h|0)!=(b|0))}else g=0;e=(f|0)<(g|0)?g:f;k[c>>2]=e;return 0}if((d|0)>0&(e|0)>0)h=0;else{e=f;k[c>>2]=e;return 0}while(1){if(i[b+h>>0]|0){g=0;do{j=k[a+(g<<2)>>2]|0;j=(j|0)>-1?j:0-j|0;f=(f|0)<(j|0)?j:f;g=g+1|0}while((g|0)!=(e|0))}h=h+1|0;if((h|0)==(d|0))break;else a=a+(e<<2)|0}k[c>>2]=f;return 0}function T7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0,j=0,l=0,m=0.0,n=0,p=0,q=0,s=0.0;q=r;r=r+16|0;n=q+12|0;j=q+8|0;p=q+4|0;l=q;f=k[c>>2]|0;k[p>>2]=f;m=(k[u>>2]=f,+o[u>>2]);if(!b){h=aa(e,d)|0;k[n>>2]=0;if((h|0)>0){f=0;g=0.0;do{s=+P(+(+o[a+(f<<2)>>2]));o[j>>2]=s;e=k[(g<s?j:n)>>2]|0;k[n>>2]=e;f=f+1|0;g=(k[u>>2]=e,+o[u>>2])}while((f|0)!=(h|0))}else g=0.0;o[l>>2]=g;n=k[(m<g?l:p)>>2]|0;k[p>>2]=n;p=n;k[c>>2]=p;r=q;return 0}if(!((d|0)>0&(e|0)>0)){p=f;k[c>>2]=p;r=q;return 0}j=0;g=m;while(1){if(i[b+j>>0]|0){h=0;do{s=+P(+(+o[a+(h<<2)>>2]));o[n>>2]=s;f=k[(g<s?n:p)>>2]|0;k[p>>2]=f;h=h+1|0;g=(k[u>>2]=f,+o[u>>2])}while((h|0)!=(e|0))}j=j+1|0;if((j|0)==(d|0))break;else a=a+(e<<2)|0}k[c>>2]=f;r=q;return 0}function U7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0,j=0,k=0.0;f=+p[c>>3];if(!b){j=aa(e,d)|0;if((j|0)>0){g=0.0;h=0;do{k=+P(+(+p[a+(h<<3)>>3]));g=g<k?k:g;h=h+1|0}while((h|0)!=(j|0))}else g=0.0;k=f<g?g:f;p[c>>3]=k;return 0}if((d|0)>0&(e|0)>0)j=0;else{k=f;p[c>>3]=k;return 0}while(1){if(i[b+j>>0]|0){h=0;do{k=+P(+(+p[a+(h<<3)>>3]));f=f<k?k:f;h=h+1|0}while((h|0)!=(e|0))}j=j+1|0;if((j|0)==(d|0))break;else a=a+(e<<3)|0}p[c>>3]=f;return 0}function V7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=k[c>>2]|0;if(b|0){if((d|0)>0&(e|0)>0){j=0;h=a}else{a=f;k[c>>2]=a;return 0}while(1){if(i[b+j>>0]|0){g=0;do{f=(l[h+g>>0]|0)+f|0;g=g+1|0}while((g|0)!=(e|0))}j=j+1|0;if((j|0)==(d|0))break;else h=h+e|0}k[c>>2]=f;return 0}b=aa(e,d)|0;j=b+-4|0;if((b|0)<4){h=0;g=0}else{g=0;h=0;do{g=(l[a+h>>0]|0)+g+(l[a+(h|1)>>0]|0)+(l[a+(h|2)>>0]|0)+(l[a+(h|3)>>0]|0)|0;h=h+4|0}while((h|0)<=(j|0));h=b&-4}if((h|0)<(b|0))do{g=(l[a+h>>0]|0)+g|0;h=h+1|0}while((h|0)!=(b|0));a=g+f|0;k[c>>2]=a;return 0}function W7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;f=k[c>>2]|0;if(b|0){if((d|0)>0&(e|0)>0){j=0;h=a}else{a=f;k[c>>2]=a;return 0}while(1){if(i[b+j>>0]|0){g=0;do{l=i[h+g>>0]|0;a=l<<24>>24;f=(l<<24>>24>-1?a:0-a|0)+f|0;g=g+1|0}while((g|0)!=(e|0))}j=j+1|0;if((j|0)==(d|0))break;else h=h+e|0}k[c>>2]=f;return 0}b=aa(e,d)|0;j=b+-4|0;if((b|0)<4){h=0;g=0}else{g=0;h=0;do{q=i[a+h>>0]|0;p=q<<24>>24;o=i[a+(h|1)>>0]|0;n=o<<24>>24;m=i[a+(h|2)>>0]|0;d=m<<24>>24;e=i[a+(h|3)>>0]|0;l=e<<24>>24;g=(q<<24>>24>-1?p:0-p|0)+g+(o<<24>>24>-1?n:0-n|0)+(m<<24>>24>-1?d:0-d|0)+(e<<24>>24>-1?l:0-l|0)|0;h=h+4|0}while((h|0)<=(j|0));h=b&-4}if((h|0)<(b|0))do{p=i[a+h>>0]|0;q=p<<24>>24;g=(p<<24>>24>-1?q:0-q|0)+g|0;h=h+1|0}while((h|0)!=(b|0));q=g+f|0;k[c>>2]=q;return 0}function X7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=k[c>>2]|0;if(b|0){if((d|0)>0&(e|0)>0){j=0;h=a}else{a=f;k[c>>2]=a;return 0}while(1){if(i[b+j>>0]|0){g=0;do{f=(m[h+(g<<1)>>1]|0)+f|0;g=g+1|0}while((g|0)!=(e|0))}j=j+1|0;if((j|0)==(d|0))break;else h=h+(e<<1)|0}k[c>>2]=f;return 0}b=aa(e,d)|0;j=b+-4|0;if((b|0)<4){h=0;g=0}else{g=0;h=0;do{g=(m[a+(h<<1)>>1]|0)+g+(m[a+((h|1)<<1)>>1]|0)+(m[a+((h|2)<<1)>>1]|0)+(m[a+((h|3)<<1)>>1]|0)|0;h=h+4|0}while((h|0)<=(j|0));h=b&-4}if((h|0)<(b|0))do{g=(m[a+(h<<1)>>1]|0)+g|0;h=h+1|0}while((h|0)!=(b|0));a=g+f|0;k[c>>2]=a;return 0}function Y7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=k[c>>2]|0;if(b|0){if((d|0)>0&(e|0)>0){l=0;h=a}else{a=f;k[c>>2]=a;return 0}while(1){if(i[b+l>>0]|0){g=0;do{m=j[h+(g<<1)>>1]|0;a=m<<16>>16;f=(m<<16>>16>-1?a:0-a|0)+f|0;g=g+1|0}while((g|0)!=(e|0))}l=l+1|0;if((l|0)==(d|0))break;else h=h+(e<<1)|0}k[c>>2]=f;return 0}b=aa(e,d)|0;l=b+-4|0;if((b|0)<4){h=0;g=0}else{g=0;h=0;do{r=j[a+(h<<1)>>1]|0;q=r<<16>>16;p=j[a+((h|1)<<1)>>1]|0;o=p<<16>>16;n=j[a+((h|2)<<1)>>1]|0;d=n<<16>>16;e=j[a+((h|3)<<1)>>1]|0;m=e<<16>>16;g=(r<<16>>16>-1?q:0-q|0)+g+(p<<16>>16>-1?o:0-o|0)+(n<<16>>16>-1?d:0-d|0)+(e<<16>>16>-1?m:0-m|0)|0;h=h+4|0}while((h|0)<=(l|0));h=b&-4}if((h|0)<(b|0))do{q=j[a+(h<<1)>>1]|0;r=q<<16>>16;g=(q<<16>>16>-1?r:0-r|0)+g|0;h=h+1|0}while((h|0)!=(b|0));r=g+f|0;k[c>>2]=r;return 0}function Z7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0,j=0,l=0,m=0;f=+p[c>>3];if(b|0){if((d|0)>0&(e|0)>0){l=0;j=a}else{g=f;p[c>>3]=g;return 0}while(1){if(i[b+l>>0]|0){h=0;do{a=k[j+(h<<2)>>2]|0;f=f+ +(((a|0)>-1?a:0-a|0)|0);h=h+1|0}while((h|0)!=(e|0))}l=l+1|0;if((l|0)==(d|0))break;else j=j+(e<<2)|0}p[c>>3]=f;return 0}l=aa(e,d)|0;j=l+-4|0;if((l|0)<4){h=0;g=0.0}else{g=0.0;h=0;do{m=k[a+(h<<2)>>2]|0;b=k[a+((h|1)<<2)>>2]|0;d=k[a+((h|2)<<2)>>2]|0;e=k[a+((h|3)<<2)>>2]|0;g=g+(+(((m|0)>-1?m:0-m|0)|0)+ +(((b|0)>-1?b:0-b|0)|0)+ +(((d|0)>-1?d:0-d|0)|0)+ +(((e|0)>-1?e:0-e|0)|0));h=h+4|0}while((h|0)<=(j|0));h=l&-4}if((h|0)<(l|0))do{m=k[a+(h<<2)>>2]|0;g=g+ +(((m|0)>-1?m:0-m|0)|0);h=h+1|0}while((h|0)!=(l|0));g=f+g;p[c>>3]=g;return 0}function _7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0,j=0,k=0,l=0.0;f=+p[c>>3];if(b|0){if((d|0)>0&(e|0)>0){k=0;j=a}else{g=f;p[c>>3]=g;return 0}while(1){if(i[b+k>>0]|0){h=0;do{f=f+ +P(+(+o[j+(h<<2)>>2]));h=h+1|0}while((h|0)!=(e|0))}k=k+1|0;if((k|0)==(d|0))break;else j=j+(e<<2)|0}p[c>>3]=f;return 0}k=aa(e,d)|0;j=k+-4|0;if((k|0)<4){h=0;g=0.0}else{g=0.0;h=0;do{l=+P(+(+o[a+(h<<2)>>2]));l=l+ +P(+(+o[a+((h|1)<<2)>>2]));l=l+ +P(+(+o[a+((h|2)<<2)>>2]));g=g+(l+ +P(+(+o[a+((h|3)<<2)>>2])));h=h+4|0}while((h|0)<=(j|0));h=k&-4}if((h|0)<(k|0))do{g=g+ +P(+(+o[a+(h<<2)>>2]));h=h+1|0}while((h|0)!=(k|0));l=f+g;p[c>>3]=l;return 0}function $7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0,j=0,k=0,l=0.0;f=+p[c>>3];if(b|0){if((d|0)>0&(e|0)>0){k=0;j=a}else{g=f;p[c>>3]=g;return 0}while(1){if(i[b+k>>0]|0){h=0;do{f=f+ +P(+(+p[j+(h<<3)>>3]));h=h+1|0}while((h|0)!=(e|0))}k=k+1|0;if((k|0)==(d|0))break;else j=j+(e<<3)|0}p[c>>3]=f;return 0}k=aa(e,d)|0;j=k+-4|0;if((k|0)<4){h=0;g=0.0}else{g=0.0;h=0;do{l=+P(+(+p[a+(h<<3)>>3]));l=l+ +P(+(+p[a+((h|1)<<3)>>3]));l=l+ +P(+(+p[a+((h|2)<<3)>>3]));g=g+(l+ +P(+(+p[a+((h|3)<<3)>>3])));h=h+4|0}while((h|0)<=(j|0));h=k&-4}if((h|0)<(k|0))do{g=g+ +P(+(+p[a+(h<<3)>>3]));h=h+1|0}while((h|0)!=(k|0));l=f+g;p[c>>3]=l;return 0}function a8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0;f=k[c>>2]|0;if(b|0){if((d|0)>0&(e|0)>0){j=0;h=a}else{a=f;k[c>>2]=a;return 0}while(1){if(i[b+j>>0]|0){g=0;do{a=l[h+g>>0]|0;f=(aa(a,a)|0)+f|0;g=g+1|0}while((g|0)!=(e|0))}j=j+1|0;if((j|0)==(d|0))break;else h=h+e|0}k[c>>2]=f;return 0}b=aa(e,d)|0;j=b+-4|0;if((b|0)<4){g=0;h=0}else{h=0;g=0;do{n=l[a+h>>0]|0;m=l[a+(h|1)>>0]|0;d=l[a+(h|2)>>0]|0;e=l[a+(h|3)>>0]|0;g=(aa(n,n)|0)+g+(aa(m,m)|0)+(aa(d,d)|0)+(aa(e,e)|0)|0;h=h+4|0}while((h|0)<=(j|0));h=b&-4}if((h|0)<(b|0))do{n=l[a+h>>0]|0;g=(aa(n,n)|0)+g|0;h=h+1|0}while((h|0)!=(b|0));n=g+f|0;k[c>>2]=n;return 0}function b8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0;f=k[c>>2]|0;if(b|0){if((d|0)>0&(e|0)>0){j=0;h=a}else{a=f;k[c>>2]=a;return 0}while(1){if(i[b+j>>0]|0){g=0;do{a=i[h+g>>0]|0;f=(aa(a,a)|0)+f|0;g=g+1|0}while((g|0)!=(e|0))}j=j+1|0;if((j|0)==(d|0))break;else h=h+e|0}k[c>>2]=f;return 0}b=aa(e,d)|0;j=b+-4|0;if((b|0)<4){g=0;h=0}else{h=0;g=0;do{m=i[a+h>>0]|0;l=i[a+(h|1)>>0]|0;d=i[a+(h|2)>>0]|0;e=i[a+(h|3)>>0]|0;g=(aa(m,m)|0)+g+(aa(l,l)|0)+(aa(d,d)|0)+(aa(e,e)|0)|0;h=h+4|0}while((h|0)<=(j|0));h=b&-4}if((h|0)<(b|0))do{m=i[a+h>>0]|0;g=(aa(m,m)|0)+g|0;h=h+1|0}while((h|0)!=(b|0));m=g+f|0;k[c>>2]=m;return 0}function c8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0,j=0,k=0,l=0.0,n=0.0,o=0.0,q=0.0;f=+p[c>>3];if(b|0){if((d|0)>0&(e|0)>0){k=0;j=a}else{g=f;p[c>>3]=g;return 0}while(1){if(i[b+k>>0]|0){h=0;do{g=+(m[j+(h<<1)>>1]|0);f=f+g*g;h=h+1|0}while((h|0)!=(e|0))}k=k+1|0;if((k|0)==(d|0))break;else j=j+(e<<1)|0}p[c>>3]=f;return 0}k=aa(e,d)|0;j=k+-4|0;if((k|0)<4){g=0.0;h=0}else{h=0;g=0.0;do{q=+(m[a+(h<<1)>>1]|0);o=+(m[a+((h|1)<<1)>>1]|0);n=+(m[a+((h|2)<<1)>>1]|0);l=+(m[a+((h|3)<<1)>>1]|0);g=g+(q*q+o*o+n*n+l*l);h=h+4|0}while((h|0)<=(j|0));h=k&-4}if((h|0)<(k|0))do{q=+(m[a+(h<<1)>>1]|0);g=g+q*q;h=h+1|0}while((h|0)!=(k|0));q=f+g;p[c>>3]=q;return 0}function d8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0;f=+p[c>>3];if(b|0){if((d|0)>0&(e|0)>0){l=0;k=a}else{g=f;p[c>>3]=g;return 0}while(1){if(i[b+l>>0]|0){h=0;do{g=+(j[k+(h<<1)>>1]|0);f=f+g*g;h=h+1|0}while((h|0)!=(e|0))}l=l+1|0;if((l|0)==(d|0))break;else k=k+(e<<1)|0}p[c>>3]=f;return 0}l=aa(e,d)|0;k=l+-4|0;if((l|0)<4){g=0.0;h=0}else{h=0;g=0.0;do{q=+(j[a+(h<<1)>>1]|0);o=+(j[a+((h|1)<<1)>>1]|0);n=+(j[a+((h|2)<<1)>>1]|0);m=+(j[a+((h|3)<<1)>>1]|0);g=g+(q*q+o*o+n*n+m*m);h=h+4|0}while((h|0)<=(k|0));h=l&-4}if((h|0)<(l|0))do{q=+(j[a+(h<<1)>>1]|0);g=g+q*q;h=h+1|0}while((h|0)!=(l|0));q=f+g;p[c>>3]=q;return 0}function e8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0,j=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0;f=+p[c>>3];if(b|0){if((d|0)>0&(e|0)>0){l=0;j=a}else{g=f;p[c>>3]=g;return 0}while(1){if(i[b+l>>0]|0){h=0;do{g=+(k[j+(h<<2)>>2]|0);f=f+g*g;h=h+1|0}while((h|0)!=(e|0))}l=l+1|0;if((l|0)==(d|0))break;else j=j+(e<<2)|0}p[c>>3]=f;return 0}l=aa(e,d)|0;j=l+-4|0;if((l|0)<4){g=0.0;h=0}else{h=0;g=0.0;do{q=+(k[a+(h<<2)>>2]|0);o=+(k[a+((h|1)<<2)>>2]|0);n=+(k[a+((h|2)<<2)>>2]|0);m=+(k[a+((h|3)<<2)>>2]|0);g=g+(q*q+o*o+n*n+m*m);h=h+4|0}while((h|0)<=(j|0));h=l&-4}if((h|0)<(l|0))do{q=+(k[a+(h<<2)>>2]|0);g=g+q*q;h=h+1|0}while((h|0)!=(l|0));q=f+g;p[c>>3]=q;return 0}function f8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0,j=0,k=0,l=0.0,m=0.0,n=0.0,q=0.0;f=+p[c>>3];if(b|0){if((d|0)>0&(e|0)>0){k=0;j=a}else{g=f;p[c>>3]=g;return 0}while(1){if(i[b+k>>0]|0){h=0;do{g=+o[j+(h<<2)>>2];f=f+g*g;h=h+1|0}while((h|0)!=(e|0))}k=k+1|0;if((k|0)==(d|0))break;else j=j+(e<<2)|0}p[c>>3]=f;return 0}k=aa(e,d)|0;j=k+-4|0;if((k|0)<4){g=0.0;h=0}else{h=0;g=0.0;do{q=+o[a+(h<<2)>>2];n=+o[a+((h|1)<<2)>>2];m=+o[a+((h|2)<<2)>>2];l=+o[a+((h|3)<<2)>>2];g=g+(q*q+n*n+m*m+l*l);h=h+4|0}while((h|0)<=(j|0));h=k&-4}if((h|0)<(k|0))do{q=+o[a+(h<<2)>>2];g=g+q*q;h=h+1|0}while((h|0)!=(k|0));q=f+g;p[c>>3]=q;return 0}function g8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;f=+p[c>>3];if(b|0){if((d|0)>0&(e|0)>0){k=0;j=a}else{g=f;p[c>>3]=g;return 0}while(1){if(i[b+k>>0]|0){h=0;do{g=+p[j+(h<<3)>>3];f=f+g*g;h=h+1|0}while((h|0)!=(e|0))}k=k+1|0;if((k|0)==(d|0))break;else j=j+(e<<3)|0}p[c>>3]=f;return 0}k=aa(e,d)|0;j=k+-4|0;if((k|0)<4){g=0.0;h=0}else{h=0;g=0.0;do{o=+p[a+(h<<3)>>3];n=+p[a+((h|1)<<3)>>3];m=+p[a+((h|2)<<3)>>3];l=+p[a+((h|3)<<3)>>3];g=g+(o*o+n*n+m*m+l*l);h=h+4|0}while((h|0)<=(j|0));h=k&-4}if((h|0)<(k|0))do{o=+p[a+(h<<3)>>3];g=g+o*o;h=h+1|0}while((h|0)!=(k|0));o=f+g;p[c>>3]=o;return 0}function h8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,R=0.0,S=0.0,T=0.0;N=r;r=r+320|0;t=N+304|0;J=N+248|0;M=N+192|0;L=N+136|0;K=N+80|0;I=N;G=N+48|0;H=N+32|0;if(!(E2(a,b)|0?(F=S1(a,-1)|0,(F|0)==(S1(b,-1)|0)):0)){f=t+4|0;g=ZT(60)|0;k[g>>2]=1;n=g+4|0;k[t>>2]=n;k[f>>2]=53;i[g+57>>0]=0;h=230945;q=n+53|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(q|0));Y8(-215,t,366900,229892,3362);k[f>>2]=0;k[t>>2]=0;F=k[g>>2]|0;k[g>>2]=F+-1;if((F|0)==1)ggb(k[g+-4>>2]|0)}if(c&8|0){e=+h8(a,b,c&-9,d);e=e/(+N7(b,c,d)+2.220446049250313e-16);r=N;return +e}do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[M>>2]=k[h>>2];n=M+4|0;a=h+4|0;k[n>>2]=k[a>>2];F=M+8|0;k[F>>2]=k[h+8>>2];k[M+12>>2]=k[h+12>>2];k[M+16>>2]=k[h+16>>2];k[M+20>>2]=k[h+20>>2];k[M+24>>2]=k[h+24>>2];k[M+28>>2]=k[h+28>>2];k[M+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[M+36>>2]=f;g=M+40|0;k[g>>2]=F;F=M+48|0;l=M+44|0;k[l>>2]=F;k[M+52>>2]=0;k[F>>2]=0;if(f|0){F=f+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[a>>2]|0)<3){E=k[h+44>>2]|0;F=k[l>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2];break}k[n>>2]=0;x1(M,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(M,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[L>>2]=k[h>>2];n=L+4|0;a=h+4|0;k[n>>2]=k[a>>2];F=L+8|0;k[F>>2]=k[h+8>>2];k[L+12>>2]=k[h+12>>2];k[L+16>>2]=k[h+16>>2];k[L+20>>2]=k[h+20>>2];k[L+24>>2]=k[h+24>>2];k[L+28>>2]=k[h+28>>2];k[L+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[L+36>>2]=f;g=L+40|0;k[g>>2]=F;F=L+48|0;l=L+44|0;k[l>>2]=F;k[L+52>>2]=0;k[F>>2]=0;if(f|0){F=f+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[a>>2]|0)<3){E=k[h+44>>2]|0;F=k[l>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2];break}k[n>>2]=0;x1(L,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(L,b,-1);while(0);do if((k[d>>2]&2031616|0)==65536){h=k[d+4>>2]|0;k[K>>2]=k[h>>2];n=K+4|0;a=h+4|0;k[n>>2]=k[a>>2];F=K+8|0;k[F>>2]=k[h+8>>2];k[K+12>>2]=k[h+12>>2];k[K+16>>2]=k[h+16>>2];k[K+20>>2]=k[h+20>>2];k[K+24>>2]=k[h+24>>2];k[K+28>>2]=k[h+28>>2];k[K+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[K+36>>2]=f;g=K+40|0;k[g>>2]=F;F=K+48|0;l=K+44|0;k[l>>2]=F;k[K+52>>2]=0;k[F>>2]=0;if(f|0){F=f+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[a>>2]|0)<3){E=k[h+44>>2]|0;F=k[l>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2];break}k[n>>2]=0;x1(K,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(K,d,-1);while(0);C=k[M>>2]|0;b=C&7;D=(C>>>3&511)+1|0;s=c&7;E=(s|0)==1;d=(s|0)==2;F=(s|0)==4;l=(s|0)==5;switch(c&7){case 1:case 2:case 4:case 5:{j=C;break}default:if((s|1|0)==7&(C&4095|0)==0)j=C;else{k[t>>2]=0;B=t+4|0;k[B>>2]=0;a=ZT(184)|0;k[a>>2]=1;A=a+4|0;k[t>>2]=A;k[B>>2]=177;i[a+181>>0]=0;upb(A|0,230999,177)|0;Y8(-215,t,366900,229892,3387);k[B>>2]=0;k[t>>2]=0;B=k[a>>2]|0;k[a>>2]=B+-1;if((B|0)==1)ggb(k[a+-4>>2]|0);j=k[M>>2]|0}}do if((j&16384|0)!=0?(k[L>>2]&16384|0)!=0:0){if(k[K+16>>2]|0){g=k[K+4>>2]|0;if((g|0)<3)a=aa(k[K+12>>2]|0,k[K+8>>2]|0)|0;else{h=k[K+40>>2]|0;f=0;a=1;do{a=aa(k[h+(f<<2)>>2]|0,a)|0;f=f+1|0}while((f|0)!=(g|0))}if(a|0){v=79;break}}g=k[M+4>>2]|0;if((g|0)<3)a=aa(k[M+12>>2]|0,k[M+8>>2]|0)|0;else{h=k[M+40>>2]|0;f=0;a=1;do{a=aa(k[h+(f<<2)>>2]|0,a)|0;f=f+1|0}while((f|0)!=(g|0))}m=aa((j>>>3&511)+1|0,a)|0;if((j&7|0)==5){g=k[M+16>>2]|0;h=k[L+16>>2]|0;if(F){f=m+-4|0;if((m|0)<4){e=0.0;a=0}else{a=0;e=0.0;do{T=+o[g+(a<<2)>>2]-+o[h+(a<<2)>>2];J=a|1;S=+o[g+(J<<2)>>2]-+o[h+(J<<2)>>2];J=a|2;R=+o[g+(J<<2)>>2]-+o[h+(J<<2)>>2];J=a|3;O=+o[g+(J<<2)>>2]-+o[h+(J<<2)>>2];e=e+(T*T+S*S+R*R+O*O);a=a+4|0}while((a|0)<=(f|0));a=m&-4}if((a|0)<(m|0))do{T=+o[g+(a<<2)>>2]-+o[h+(a<<2)>>2];e=e+T*T;a=a+1|0}while((a|0)!=(m|0));e=+Q(+(e+0.0));break}if(l){f=m+-4|0;if((m|0)<4){e=0.0;a=0}else{a=0;e=0.0;do{O=+o[g+(a<<2)>>2]-+o[h+(a<<2)>>2];J=a|1;R=+o[g+(J<<2)>>2]-+o[h+(J<<2)>>2];J=a|2;S=+o[g+(J<<2)>>2]-+o[h+(J<<2)>>2];J=a|3;T=+o[g+(J<<2)>>2]-+o[h+(J<<2)>>2];e=e+(O*O+R*R+S*S+T*T);a=a+4|0}while((a|0)<=(f|0));a=m&-4}if((a|0)<(m|0))do{T=+o[g+(a<<2)>>2]-+o[h+(a<<2)>>2];e=e+T*T;a=a+1|0}while((a|0)!=(m|0));e=e+0.0;break}if(!d){if(!E){v=79;break}k[t>>2]=0;if((m|0)>0){a=0;e=0.0;do{T=+P(+(+o[g+(a<<2)>>2]-+o[h+(a<<2)>>2]));o[J>>2]=T;I=k[(e<T?J:t)>>2]|0;k[t>>2]=I;a=a+1|0;e=(k[u>>2]=I,+o[u>>2])}while((a|0)!=(m|0))}else e=0.0;e=e>0.0?e:0.0;break}f=m+-4|0;if((m|0)<4){e=0.0;a=0}else{a=0;e=0.0;do{H=a|1;I=a|2;J=a|3;e=e+(+P(+(+o[g+(a<<2)>>2]-+o[h+(a<<2)>>2]))+ +P(+(+o[g+(H<<2)>>2]-+o[h+(H<<2)>>2]))+ +P(+(+o[g+(I<<2)>>2]-+o[h+(I<<2)>>2]))+ +P(+(+o[g+(J<<2)>>2]-+o[h+(J<<2)>>2])));a=a+4|0}while((a|0)<=(f|0));a=m&-4}if((a|0)<(m|0))do{e=e+ +P(+(+o[g+(a<<2)>>2]-+o[h+(a<<2)>>2]));a=a+1|0}while((a|0)!=(m|0));e=e+0.0}else v=79}else v=79;while(0);do if((v|0)==79){l=K+16|0;if(k[l>>2]|0){g=k[K+4>>2]|0;if((g|0)<3)a=aa(k[K+12>>2]|0,k[K+8>>2]|0)|0;else{h=k[K+40>>2]|0;f=0;a=1;do{a=aa(k[h+(f<<2)>>2]|0,a)|0;f=f+1|0}while((f|0)!=(g|0))}if(a|0?k[K>>2]&4095|0:0){k[t>>2]=0;a=t+4|0;k[a>>2]=0;f=ZT(44)|0;k[f>>2]=1;n=f+4|0;k[t>>2]=n;k[a>>2]=36;i[f+40>>0]=0;h=229968;q=n+36|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(q|0));Y8(-215,t,366900,229892,3427);k[a>>2]=0;k[t>>2]=0;B=k[f>>2]|0;k[f>>2]=B+-1;if((B|0)==1)ggb(k[f+-4>>2]|0)}}j=(s|0)==6;g=s|1;if((g|0)==7){if(k[l>>2]|0){g=k[K+4>>2]|0;if((g|0)<3)a=aa(k[K+12>>2]|0,k[K+8>>2]|0)|0;else{h=k[K+40>>2]|0;f=0;a=1;do{a=aa(k[h+(f<<2)>>2]|0,a)|0;f=f+1|0}while((f|0)!=(g|0))}if(a|0){k[J>>2]=1124007936;m=J+4|0;a=J+8|0;j=J+40|0;n=m;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[j>>2]=a;l=J+48|0;h=J+44|0;k[h>>2]=l;k[J+52>>2]=0;k[l>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;k[I>>2]=16842752;k[I+4>>2]=M;k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=L;g=H+4|0;a=g+4|0;k[a>>2]=0;k[a+4>>2]=0;k[H>>2]=33619968;k[g>>2]=J;k[t>>2]=101;aU(I,G,H,49332,t,1,11);k[I+8>>2]=0;k[I+12>>2]=0;k[I>>2]=16842752;k[I+4>>2]=J;k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=K;g=H+4|0;a=g+4|0;k[a>>2]=0;k[a+4>>2]=0;k[H>>2]=33619968;k[g>>2]=J;k[t>>2]=98;aU(I,G,H,49332,t,1,9);k[t+8>>2]=0;k[t+12>>2]=0;k[t>>2]=16842752;k[t+4>>2]=J;e=+N7(t,s,49332);g=J+36|0;a=k[g>>2]|0;if(a|0?(H=a+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[J+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;J=J+16|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[m>>2]|0)>0){f=k[j>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[h>>2]|0;if(!((a|0)==(l|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break}}l=j?1:2;k[t>>2]=M;k[t+4>>2]=L;k[t+8>>2]=0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;k[I+16>>2]=0;k[I+20>>2]=0;k[I+24>>2]=0;k[I+28>>2]=0;z1(I,t,0,J,-1);g=k[I+20>>2]|0;h=I+16|0;j=J+4|0;a=0;f=0;while(1){if(a>>>0>=(k[h>>2]|0)>>>0)break;H=(i8(k[J>>2]|0,k[j>>2]|0,g,l)|0)+f|0;A1(I);a=a+1|0;f=H}e=+(f|0);break}B=k[49928+(s>>>1<<5)+(b<<2)>>2]|0;if(!B){k[t>>2]=0;a=t+4|0;k[a>>2]=0;f=ZT(16)|0;k[f>>2]=1;n=f+4|0;k[t>>2]=n;k[a>>2]=9;i[f+13>>0]=0;h=335726;q=n+9|0;do{i[n>>0]=i[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(q|0));Y8(-215,t,366900,229892,3455);k[a>>2]=0;k[t>>2]=0;A=k[f>>2]|0;k[f>>2]=A+-1;if((A|0)==1)ggb(k[f+-4>>2]|0)}k[t>>2]=M;k[t+4>>2]=L;k[t+8>>2]=K;k[t+12>>2]=0;p[I>>3]=0.0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;k[G+16>>2]=0;k[G+20>>2]=0;k[G+24>>2]=0;k[G+28>>2]=0;z1(G,t,0,J,-1);A=k[G+20>>2]|0;if(!(d&b>>>0<4)){k[H>>2]=0;if((g|0)==5&b>>>0<2){h=I;v=121}else{y=0;z=I;f=0;g=A;h=I;x=0}}else{k[H>>2]=0;h=I;v=121}if((v|0)==121){f=d&b>>>0<2?8388608:32768;g=(f|0)<(A|0)?f:A;a=k[M+4>>2]|0;if((a|0)>0){y=k[(k[M+44>>2]|0)+(a+-1<<2)>>2]|0;z=H;x=1}else{y=0;z=H;x=1}}s=G+16|0;t=(A|0)>0;v=J+4|0;w=J+8|0;j=0;a=0;while(1){l=k[s>>2]|0;if(j>>>0>=l>>>0)break;j=j+1|0;a:do if(t){m=k[J>>2]|0;n=k[v>>2]|0;d=k[w>>2]|0;if(!x){q=0;b=m;l=d;while(1){m=A-q|0;m=(g|0)<(m|0)?g:m;Sf[B&127](b,n,l,z,m,D)|0;a=m+a|0;l=aa(m,y)|0;b=(k[J>>2]|0)+l|0;k[J>>2]=b;n=(k[v>>2]|0)+l|0;k[v>>2]=n;l=k[w>>2]|0;if(!l)l=0;else{l=l+m|0;k[w>>2]=l}q=q+g|0;if((A|0)<=(q|0))break a}}c=j>>>0<l>>>0;q=0;b=n;l=d;do{n=A-q|0;n=(g|0)<(n|0)?g:n;Sf[B&127](m,b,l,z,n,D)|0;a=n+a|0;if(!((a+g|0)<(f|0)?(n+q|0)<(A|0)|c:0)){p[I>>3]=+p[I>>3]+ +((k[H>>2]|0)>>>0);k[H>>2]=0;a=0}b=aa(n,y)|0;m=(k[J>>2]|0)+b|0;k[J>>2]=m;b=(k[v>>2]|0)+b|0;k[v>>2]=b;l=k[w>>2]|0;if(!l)l=0;else{l=l+n|0;k[w>>2]=l}q=q+g|0}while((A|0)>(q|0))}while(0);A1(G)}b:do if(!E){if(F){T=+Q(+(+p[I>>3]));p[I>>3]=T}}else switch(C&7){case 6:break b;case 5:{p[I>>3]=+o[I>>2];break b}default:{p[I>>3]=+((k[h>>2]|0)>>>0);break b}}while(0);e=+p[I>>3]}while(0);g=K+36|0;a=k[g>>2]|0;if(a|0?(I=a+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[K+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;J=K+16|0;f=K+4|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[f>>2]|0)>0){g=k[K+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[K+44>>2]|0;if(!((a|0)==(K+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=L+36|0;a=k[g>>2]|0;if(a|0?(J=a+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[L+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;K=L+16|0;f=L+4|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[f>>2]|0)>0){g=k[L+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[L+44>>2]|0;if(!((a|0)==(L+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=M+36|0;a=k[g>>2]|0;if(a|0?(K=a+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[M+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;L=M+16|0;f=M+4|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[f>>2]|0)>0){g=k[M+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[M+44>>2]|0;if(!((a|0)==(M+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);T=e;r=N;return +T}function i8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;switch(d|0){case 1:{c=M7(a,b,c)|0;return c|0}case 2:{g=230433;break}case 4:{g=230689;break}default:{c=-1;return c|0}}f=c+-4|0;if((c|0)<4){d=0;e=0}else{e=0;d=0;do{k=e|1;j=e|2;h=e|3;d=(l[g+((i[b+e>>0]^i[a+e>>0])&255)>>0]|0)+d+(l[g+((i[b+k>>0]^i[a+k>>0])&255)>>0]|0)+(l[g+((i[b+j>>0]^i[a+j>>0])&255)>>0]|0)+(l[g+((i[b+h>>0]^i[a+h>>0])&255)>>0]|0)|0;e=e+4|0}while((e|0)<=(f|0));e=c&-4}if((e|0)>=(c|0)){k=d;return k|0}do{d=(l[g+((i[b+e>>0]^i[a+e>>0])&255)>>0]|0)+d|0;e=e+1|0}while((e|0)!=(c|0));return d|0}function j8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0;g=k[d>>2]|0;if(!c){m=aa(f,e)|0;if((m|0)>0){h=0;j=0;do{f=(l[a+j>>0]|0)-(l[b+j>>0]|0)|0;f=(f|0)>-1?f:0-f|0;h=(h|0)<(f|0)?f:h;j=j+1|0}while((j|0)!=(m|0))}else h=0;f=(g|0)<(h|0)?h:g;k[d>>2]=f;return 0}if((e|0)>0&(f|0)>0){m=0;j=b}else{f=g;k[d>>2]=f;return 0}while(1){if(i[c+m>>0]|0){h=0;do{b=(l[a+h>>0]|0)-(l[j+h>>0]|0)|0;b=(b|0)>-1?b:0-b|0;g=(g|0)<(b|0)?b:g;h=h+1|0}while((h|0)!=(f|0))}m=m+1|0;if((m|0)==(e|0))break;else{a=a+f|0;j=j+f|0}}k[d>>2]=g;return 0}function k8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0;g=k[d>>2]|0;if(!c){l=aa(f,e)|0;if((l|0)>0){h=0;j=0;do{f=(i[a+j>>0]|0)-(i[b+j>>0]|0)|0;f=(f|0)>-1?f:0-f|0;h=(h|0)<(f|0)?f:h;j=j+1|0}while((j|0)!=(l|0))}else h=0;f=(g|0)<(h|0)?h:g;k[d>>2]=f;return 0}if((e|0)>0&(f|0)>0){l=0;j=b}else{f=g;k[d>>2]=f;return 0}while(1){if(i[c+l>>0]|0){h=0;do{b=(i[a+h>>0]|0)-(i[j+h>>0]|0)|0;b=(b|0)>-1?b:0-b|0;g=(g|0)<(b|0)?b:g;h=h+1|0}while((h|0)!=(f|0))}l=l+1|0;if((l|0)==(e|0))break;else{a=a+f|0;j=j+f|0}}k[d>>2]=g;return 0}function l8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0;g=k[d>>2]|0;if(!c){l=aa(f,e)|0;if((l|0)>0){h=0;j=0;do{f=(m[a+(j<<1)>>1]|0)-(m[b+(j<<1)>>1]|0)|0;f=(f|0)>-1?f:0-f|0;h=(h|0)<(f|0)?f:h;j=j+1|0}while((j|0)!=(l|0))}else h=0;f=(g|0)<(h|0)?h:g;k[d>>2]=f;return 0}if((e|0)>0&(f|0)>0){l=0;j=b}else{f=g;k[d>>2]=f;return 0}while(1){if(i[c+l>>0]|0){h=0;do{b=(m[a+(h<<1)>>1]|0)-(m[j+(h<<1)>>1]|0)|0;b=(b|0)>-1?b:0-b|0;g=(g|0)<(b|0)?b:g;h=h+1|0}while((h|0)!=(f|0))}l=l+1|0;if((l|0)==(e|0))break;else{a=a+(f<<1)|0;j=j+(f<<1)|0}}k[d>>2]=g;return 0}function m8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0,m=0;g=k[d>>2]|0;if(!c){m=aa(f,e)|0;if((m|0)>0){h=0;l=0;do{f=(j[a+(l<<1)>>1]|0)-(j[b+(l<<1)>>1]|0)|0;f=(f|0)>-1?f:0-f|0;h=(h|0)<(f|0)?f:h;l=l+1|0}while((l|0)!=(m|0))}else h=0;f=(g|0)<(h|0)?h:g;k[d>>2]=f;return 0}if((e|0)>0&(f|0)>0){m=0;l=b}else{f=g;k[d>>2]=f;return 0}while(1){if(i[c+m>>0]|0){h=0;do{b=(j[a+(h<<1)>>1]|0)-(j[l+(h<<1)>>1]|0)|0;b=(b|0)>-1?b:0-b|0;g=(g|0)<(b|0)?b:g;h=h+1|0}while((h|0)!=(f|0))}m=m+1|0;if((m|0)==(e|0))break;else{a=a+(f<<1)|0;l=l+(f<<1)|0}}k[d>>2]=g;return 0}function n8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0;g=k[d>>2]|0;if(!c){l=aa(f,e)|0;if((l|0)>0){h=0;j=0;do{f=(k[a+(j<<2)>>2]|0)-(k[b+(j<<2)>>2]|0)|0;f=(f|0)>-1?f:0-f|0;h=(h|0)<(f|0)?f:h;j=j+1|0}while((j|0)!=(l|0))}else h=0;f=(g|0)<(h|0)?h:g;k[d>>2]=f;return 0}if((e|0)>0&(f|0)>0){l=0;j=b}else{f=g;k[d>>2]=f;return 0}while(1){if(i[c+l>>0]|0){h=0;do{b=(k[a+(h<<2)>>2]|0)-(k[j+(h<<2)>>2]|0)|0;b=(b|0)>-1?b:0-b|0;g=(g|0)<(b|0)?b:g;h=h+1|0}while((h|0)!=(f|0))}l=l+1|0;if((l|0)==(e|0))break;else{a=a+(f<<2)|0;j=j+(f<<2)|0}}k[d>>2]=g;return 0}function o8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,j=0,l=0,m=0,n=0.0,p=0,q=0,s=0,t=0.0;s=r;r=r+16|0;p=s+12|0;l=s+8|0;q=s+4|0;m=s;g=k[d>>2]|0;k[q>>2]=g;n=(k[u>>2]=g,+o[u>>2]);if(!c){j=aa(f,e)|0;k[p>>2]=0;if((j|0)>0){g=0;h=0.0;do{t=+P(+(+o[a+(g<<2)>>2]-+o[b+(g<<2)>>2]));o[l>>2]=t;f=k[(h<t?l:p)>>2]|0;k[p>>2]=f;g=g+1|0;h=(k[u>>2]=f,+o[u>>2])}while((g|0)!=(j|0))}else h=0.0;o[m>>2]=h;p=k[(n<h?m:q)>>2]|0;k[q>>2]=p;q=p;k[d>>2]=q;r=s;return 0}if(!((e|0)>0&(f|0)>0)){q=g;k[d>>2]=q;r=s;return 0}l=0;h=n;while(1){if(i[c+l>>0]|0){j=0;do{t=+P(+(+o[a+(j<<2)>>2]-+o[b+(j<<2)>>2]));o[p>>2]=t;g=k[(h<t?p:q)>>2]|0;k[q>>2]=g;j=j+1|0;h=(k[u>>2]=g,+o[u>>2])}while((j|0)!=(f|0))}l=l+1|0;if((l|0)==(e|0))break;else{a=a+(f<<2)|0;b=b+(f<<2)|0}}k[d>>2]=g;r=s;return 0}function p8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,j=0,k=0,l=0,m=0.0;g=+p[d>>3];if(!c){k=aa(f,e)|0;if((k|0)>0){h=0.0;j=0;do{m=+P(+(+p[a+(j<<3)>>3]-+p[b+(j<<3)>>3]));h=h<m?m:h;j=j+1|0}while((j|0)!=(k|0))}else h=0.0;m=g<h?h:g;p[d>>3]=m;return 0}if((e|0)>0&(f|0)>0){l=0;k=b}else{m=g;p[d>>3]=m;return 0}while(1){if(i[c+l>>0]|0){j=0;do{m=+P(+(+p[a+(j<<3)>>3]-+p[k+(j<<3)>>3]));g=g<m?m:g;j=j+1|0}while((j|0)!=(f|0))}l=l+1|0;if((l|0)==(e|0))break;else{a=a+(f<<3)|0;k=k+(f<<3)|0}}p[d>>3]=g;return 0}function q8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0;g=k[d>>2]|0;if(!c){f=(E8(a,b,aa(f,e)|0)|0)+g|0;k[d>>2]=f;return 0}if((e|0)>0&(f|0)>0)j=0;else{f=g;k[d>>2]=f;return 0}while(1){if(i[c+j>>0]|0){h=0;do{m=(l[a+h>>0]|0)-(l[b+h>>0]|0)|0;g=((m|0)>-1?m:0-m|0)+g|0;h=h+1|0}while((h|0)!=(f|0))}j=j+1|0;if((j|0)==(e|0))break;else{a=a+f|0;b=b+f|0}}k[d>>2]=g;return 0}function r8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0;g=k[d>>2]|0;if(c|0){if((e|0)>0&(f|0)>0){m=0;l=a;j=b}else{b=g;k[d>>2]=b;return 0}while(1){if(i[c+m>>0]|0){h=0;do{b=(i[l+h>>0]|0)-(i[j+h>>0]|0)|0;g=((b|0)>-1?b:0-b|0)+g|0;h=h+1|0}while((h|0)!=(f|0))}m=m+1|0;if((m|0)==(e|0))break;else{l=l+f|0;j=j+f|0}}k[d>>2]=g;return 0}m=aa(f,e)|0;l=m+-4|0;if((m|0)<4){h=0;j=0}else{j=0;h=0;do{n=(i[a+j>>0]|0)-(i[b+j>>0]|0)|0;c=j|1;c=(i[a+c>>0]|0)-(i[b+c>>0]|0)|0;e=j|2;e=(i[a+e>>0]|0)-(i[b+e>>0]|0)|0;f=j|3;f=(i[a+f>>0]|0)-(i[b+f>>0]|0)|0;h=((n|0)>-1?n:0-n|0)+h+((c|0)>-1?c:0-c|0)+((e|0)>-1?e:0-e|0)+((f|0)>-1?f:0-f|0)|0;j=j+4|0}while((j|0)<=(l|0));j=m&-4}if((j|0)<(m|0))do{n=(i[a+j>>0]|0)-(i[b+j>>0]|0)|0;h=((n|0)>-1?n:0-n|0)+h|0;j=j+1|0}while((j|0)!=(m|0));n=h+g|0;k[d>>2]=n;return 0}function s8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,n=0,o=0;g=k[d>>2]|0;if(c|0){if((e|0)>0&(f|0)>0){n=0;l=a;j=b}else{b=g;k[d>>2]=b;return 0}while(1){if(i[c+n>>0]|0){h=0;do{b=(m[l+(h<<1)>>1]|0)-(m[j+(h<<1)>>1]|0)|0;g=((b|0)>-1?b:0-b|0)+g|0;h=h+1|0}while((h|0)!=(f|0))}n=n+1|0;if((n|0)==(e|0))break;else{l=l+(f<<1)|0;j=j+(f<<1)|0}}k[d>>2]=g;return 0}n=aa(f,e)|0;l=n+-4|0;if((n|0)<4){h=0;j=0}else{j=0;h=0;do{o=(m[a+(j<<1)>>1]|0)-(m[b+(j<<1)>>1]|0)|0;c=j|1;c=(m[a+(c<<1)>>1]|0)-(m[b+(c<<1)>>1]|0)|0;e=j|2;e=(m[a+(e<<1)>>1]|0)-(m[b+(e<<1)>>1]|0)|0;f=j|3;f=(m[a+(f<<1)>>1]|0)-(m[b+(f<<1)>>1]|0)|0;h=((o|0)>-1?o:0-o|0)+h+((c|0)>-1?c:0-c|0)+((e|0)>-1?e:0-e|0)+((f|0)>-1?f:0-f|0)|0;j=j+4|0}while((j|0)<=(l|0));j=n&-4}if((j|0)<(n|0))do{o=(m[a+(j<<1)>>1]|0)-(m[b+(j<<1)>>1]|0)|0;h=((o|0)>-1?o:0-o|0)+h|0;j=j+1|0}while((j|0)!=(n|0));o=h+g|0;k[d>>2]=o;return 0}function t8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0,m=0,n=0,o=0;g=k[d>>2]|0;if(c|0){if((e|0)>0&(f|0)>0){n=0;m=a;l=b}else{b=g;k[d>>2]=b;return 0}while(1){if(i[c+n>>0]|0){h=0;do{b=(j[m+(h<<1)>>1]|0)-(j[l+(h<<1)>>1]|0)|0;g=((b|0)>-1?b:0-b|0)+g|0;h=h+1|0}while((h|0)!=(f|0))}n=n+1|0;if((n|0)==(e|0))break;else{m=m+(f<<1)|0;l=l+(f<<1)|0}}k[d>>2]=g;return 0}n=aa(f,e)|0;m=n+-4|0;if((n|0)<4){h=0;l=0}else{l=0;h=0;do{o=(j[a+(l<<1)>>1]|0)-(j[b+(l<<1)>>1]|0)|0;c=l|1;c=(j[a+(c<<1)>>1]|0)-(j[b+(c<<1)>>1]|0)|0;e=l|2;e=(j[a+(e<<1)>>1]|0)-(j[b+(e<<1)>>1]|0)|0;f=l|3;f=(j[a+(f<<1)>>1]|0)-(j[b+(f<<1)>>1]|0)|0;h=((o|0)>-1?o:0-o|0)+h+((c|0)>-1?c:0-c|0)+((e|0)>-1?e:0-e|0)+((f|0)>-1?f:0-f|0)|0;l=l+4|0}while((l|0)<=(m|0));l=n&-4}if((l|0)<(n|0))do{o=(j[a+(l<<1)>>1]|0)-(j[b+(l<<1)>>1]|0)|0;h=((o|0)>-1?o:0-o|0)+h|0;l=l+1|0}while((l|0)!=(n|0));o=h+g|0;k[d>>2]=o;return 0}function u8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,j=0,l=0,m=0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){m=0;l=b}else{h=g;p[d>>3]=h;return 0}while(1){if(i[c+m>>0]|0){j=0;do{b=(k[a+(j<<2)>>2]|0)-(k[l+(j<<2)>>2]|0)|0;g=g+ +(((b|0)>-1?b:0-b|0)|0);j=j+1|0}while((j|0)!=(f|0))}m=m+1|0;if((m|0)==(e|0))break;else{a=a+(f<<2)|0;l=l+(f<<2)|0}}p[d>>3]=g;return 0}m=aa(f,e)|0;l=m+-4|0;if((m|0)<4){h=0.0;j=0}else{j=0;h=0.0;do{c=j|1;e=j|2;f=j|3;h=h+(+P(+(+((k[a+(j<<2)>>2]|0)-(k[b+(j<<2)>>2]|0)|0)))+ +P(+(+((k[a+(c<<2)>>2]|0)-(k[b+(c<<2)>>2]|0)|0)))+ +P(+(+((k[a+(e<<2)>>2]|0)-(k[b+(e<<2)>>2]|0)|0)))+ +P(+(+((k[a+(f<<2)>>2]|0)-(k[b+(f<<2)>>2]|0)|0))));j=j+4|0}while((j|0)<=(l|0));j=m&-4}if((j|0)<(m|0))do{h=h+ +P(+(+((k[a+(j<<2)>>2]|0)-(k[b+(j<<2)>>2]|0)|0)));j=j+1|0}while((j|0)!=(m|0));h=g+h;p[d>>3]=h;return 0}function v8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,j=0,k=0,l=0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){l=0;k=b}else{h=g;p[d>>3]=h;return 0}while(1){if(i[c+l>>0]|0){j=0;do{g=g+ +P(+(+o[a+(j<<2)>>2]-+o[k+(j<<2)>>2]));j=j+1|0}while((j|0)!=(f|0))}l=l+1|0;if((l|0)==(e|0))break;else{a=a+(f<<2)|0;k=k+(f<<2)|0}}p[d>>3]=g;return 0}l=aa(f,e)|0;k=l+-4|0;if((l|0)<4){h=0.0;j=0}else{j=0;h=0.0;do{c=j|1;e=j|2;f=j|3;h=h+(+P(+(+o[a+(j<<2)>>2]-+o[b+(j<<2)>>2]))+ +P(+(+o[a+(c<<2)>>2]-+o[b+(c<<2)>>2]))+ +P(+(+o[a+(e<<2)>>2]-+o[b+(e<<2)>>2]))+ +P(+(+o[a+(f<<2)>>2]-+o[b+(f<<2)>>2])));j=j+4|0}while((j|0)<=(k|0));j=l&-4}if((j|0)<(l|0))do{h=h+ +P(+(+o[a+(j<<2)>>2]-+o[b+(j<<2)>>2]));j=j+1|0}while((j|0)!=(l|0));h=g+h;p[d>>3]=h;return 0}function w8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,j=0,k=0,l=0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){l=0;k=b}else{h=g;p[d>>3]=h;return 0}while(1){if(i[c+l>>0]|0){j=0;do{g=g+ +P(+(+p[a+(j<<3)>>3]-+p[k+(j<<3)>>3]));j=j+1|0}while((j|0)!=(f|0))}l=l+1|0;if((l|0)==(e|0))break;else{a=a+(f<<3)|0;k=k+(f<<3)|0}}p[d>>3]=g;return 0}l=aa(f,e)|0;k=l+-4|0;if((l|0)<4){h=0.0;j=0}else{j=0;h=0.0;do{c=j|1;e=j|2;f=j|3;h=h+(+P(+(+p[a+(j<<3)>>3]-+p[b+(j<<3)>>3]))+ +P(+(+p[a+(c<<3)>>3]-+p[b+(c<<3)>>3]))+ +P(+(+p[a+(e<<3)>>3]-+p[b+(e<<3)>>3]))+ +P(+(+p[a+(f<<3)>>3]-+p[b+(f<<3)>>3])));j=j+4|0}while((j|0)<=(k|0));j=l&-4}if((j|0)<(l|0))do{h=h+ +P(+(+p[a+(j<<3)>>3]-+p[b+(j<<3)>>3]));j=j+1|0}while((j|0)!=(l|0));h=g+h;p[d>>3]=h;return 0}function x8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0;g=k[d>>2]|0;if(c|0){if((e|0)>0&(f|0)>0){n=0;m=b;j=a}else{a=g;k[d>>2]=a;return 0}while(1){if(i[c+n>>0]|0){h=0;do{a=(l[j+h>>0]|0)-(l[m+h>>0]|0)|0;g=(aa(a,a)|0)+g|0;h=h+1|0}while((h|0)!=(f|0))}n=n+1|0;if((n|0)==(e|0))break;else{m=m+f|0;j=j+f|0}}k[d>>2]=g;return 0}n=aa(f,e)|0;m=n+-4|0;if((n|0)<4){h=0;j=0}else{j=0;h=0;do{o=(l[a+j>>0]|0)-(l[b+j>>0]|0)|0;c=j|1;c=(l[a+c>>0]|0)-(l[b+c>>0]|0)|0;e=j|2;e=(l[a+e>>0]|0)-(l[b+e>>0]|0)|0;f=j|3;f=(l[a+f>>0]|0)-(l[b+f>>0]|0)|0;h=(aa(o,o)|0)+h+(aa(c,c)|0)+(aa(e,e)|0)+(aa(f,f)|0)|0;j=j+4|0}while((j|0)<=(m|0));j=n&-4}if((j|0)<(n|0))do{o=(l[a+j>>0]|0)-(l[b+j>>0]|0)|0;h=(aa(o,o)|0)+h|0;j=j+1|0}while((j|0)!=(n|0));o=h+g|0;k[d>>2]=o;return 0}function y8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0;g=k[d>>2]|0;if(c|0){if((e|0)>0&(f|0)>0){m=0;l=b;j=a}else{a=g;k[d>>2]=a;return 0}while(1){if(i[c+m>>0]|0){h=0;do{a=(i[j+h>>0]|0)-(i[l+h>>0]|0)|0;g=(aa(a,a)|0)+g|0;h=h+1|0}while((h|0)!=(f|0))}m=m+1|0;if((m|0)==(e|0))break;else{l=l+f|0;j=j+f|0}}k[d>>2]=g;return 0}m=aa(f,e)|0;l=m+-4|0;if((m|0)<4){h=0;j=0}else{j=0;h=0;do{n=(i[a+j>>0]|0)-(i[b+j>>0]|0)|0;c=j|1;c=(i[a+c>>0]|0)-(i[b+c>>0]|0)|0;e=j|2;e=(i[a+e>>0]|0)-(i[b+e>>0]|0)|0;f=j|3;f=(i[a+f>>0]|0)-(i[b+f>>0]|0)|0;h=(aa(n,n)|0)+h+(aa(c,c)|0)+(aa(e,e)|0)+(aa(f,f)|0)|0;j=j+4|0}while((j|0)<=(l|0));j=m&-4}if((j|0)<(m|0))do{n=(i[a+j>>0]|0)-(i[b+j>>0]|0)|0;h=(aa(n,n)|0)+h|0;j=j+1|0}while((j|0)!=(m|0));n=h+g|0;k[d>>2]=n;return 0}function z8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,j=0,k=0,l=0,n=0.0,o=0.0,q=0.0,r=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){l=0;k=a}else{h=g;p[d>>3]=h;return 0}while(1){if(i[c+l>>0]|0){j=0;do{h=+((m[k+(j<<1)>>1]|0)-(m[b+(j<<1)>>1]|0)|0);g=g+h*h;j=j+1|0}while((j|0)!=(f|0))}l=l+1|0;if((l|0)==(e|0))break;else{b=b+(f<<1)|0;k=k+(f<<1)|0}}p[d>>3]=g;return 0}l=aa(f,e)|0;k=l+-4|0;if((l|0)<4){h=0.0;j=0}else{j=0;h=0.0;do{r=+((m[a+(j<<1)>>1]|0)-(m[b+(j<<1)>>1]|0)|0);f=j|1;q=+((m[a+(f<<1)>>1]|0)-(m[b+(f<<1)>>1]|0)|0);f=j|2;o=+((m[a+(f<<1)>>1]|0)-(m[b+(f<<1)>>1]|0)|0);f=j|3;n=+((m[a+(f<<1)>>1]|0)-(m[b+(f<<1)>>1]|0)|0);h=h+(r*r+q*q+o*o+n*n);j=j+4|0}while((j|0)<=(k|0));j=l&-4}if((j|0)<(l|0))do{r=+((m[a+(j<<1)>>1]|0)-(m[b+(j<<1)>>1]|0)|0);h=h+r*r;j=j+1|0}while((j|0)!=(l|0));r=g+h;p[d>>3]=r;return 0}function A8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){m=0;l=a}else{h=g;p[d>>3]=h;return 0}while(1){if(i[c+m>>0]|0){k=0;do{h=+((j[l+(k<<1)>>1]|0)-(j[b+(k<<1)>>1]|0)|0);g=g+h*h;k=k+1|0}while((k|0)!=(f|0))}m=m+1|0;if((m|0)==(e|0))break;else{b=b+(f<<1)|0;l=l+(f<<1)|0}}p[d>>3]=g;return 0}m=aa(f,e)|0;l=m+-4|0;if((m|0)<4){h=0.0;k=0}else{k=0;h=0.0;do{r=+((j[a+(k<<1)>>1]|0)-(j[b+(k<<1)>>1]|0)|0);f=k|1;q=+((j[a+(f<<1)>>1]|0)-(j[b+(f<<1)>>1]|0)|0);f=k|2;o=+((j[a+(f<<1)>>1]|0)-(j[b+(f<<1)>>1]|0)|0);f=k|3;n=+((j[a+(f<<1)>>1]|0)-(j[b+(f<<1)>>1]|0)|0);h=h+(r*r+q*q+o*o+n*n);k=k+4|0}while((k|0)<=(l|0));k=m&-4}if((k|0)<(m|0))do{r=+((j[a+(k<<1)>>1]|0)-(j[b+(k<<1)>>1]|0)|0);h=h+r*r;k=k+1|0}while((k|0)!=(m|0));r=g+h;p[d>>3]=r;return 0}function B8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,j=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){m=0;l=a}else{h=g;p[d>>3]=h;return 0}while(1){if(i[c+m>>0]|0){j=0;do{h=+((k[l+(j<<2)>>2]|0)-(k[b+(j<<2)>>2]|0)|0);g=g+h*h;j=j+1|0}while((j|0)!=(f|0))}m=m+1|0;if((m|0)==(e|0))break;else{b=b+(f<<2)|0;l=l+(f<<2)|0}}p[d>>3]=g;return 0}m=aa(f,e)|0;l=m+-4|0;if((m|0)<4){h=0.0;j=0}else{j=0;h=0.0;do{r=+((k[a+(j<<2)>>2]|0)-(k[b+(j<<2)>>2]|0)|0);f=j|1;q=+((k[a+(f<<2)>>2]|0)-(k[b+(f<<2)>>2]|0)|0);f=j|2;o=+((k[a+(f<<2)>>2]|0)-(k[b+(f<<2)>>2]|0)|0);f=j|3;n=+((k[a+(f<<2)>>2]|0)-(k[b+(f<<2)>>2]|0)|0);h=h+(r*r+q*q+o*o+n*n);j=j+4|0}while((j|0)<=(l|0));j=m&-4}if((j|0)<(m|0))do{r=+((k[a+(j<<2)>>2]|0)-(k[b+(j<<2)>>2]|0)|0);h=h+r*r;j=j+1|0}while((j|0)!=(m|0));r=g+h;p[d>>3]=r;return 0}function C8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,j=0,k=0,l=0,m=0.0,n=0.0,q=0.0,r=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){l=0;k=a}else{h=g;p[d>>3]=h;return 0}while(1){if(i[c+l>>0]|0){j=0;do{h=+o[k+(j<<2)>>2]-+o[b+(j<<2)>>2];g=g+h*h;j=j+1|0}while((j|0)!=(f|0))}l=l+1|0;if((l|0)==(e|0))break;else{b=b+(f<<2)|0;k=k+(f<<2)|0}}p[d>>3]=g;return 0}l=aa(f,e)|0;k=l+-4|0;if((l|0)<4){h=0.0;j=0}else{j=0;h=0.0;do{r=+o[a+(j<<2)>>2]-+o[b+(j<<2)>>2];f=j|1;q=+o[a+(f<<2)>>2]-+o[b+(f<<2)>>2];f=j|2;n=+o[a+(f<<2)>>2]-+o[b+(f<<2)>>2];f=j|3;m=+o[a+(f<<2)>>2]-+o[b+(f<<2)>>2];h=h+(r*r+q*q+n*n+m*m);j=j+4|0}while((j|0)<=(k|0));j=l&-4}if((j|0)<(l|0))do{r=+o[a+(j<<2)>>2]-+o[b+(j<<2)>>2];h=h+r*r;j=j+1|0}while((j|0)!=(l|0));r=g+h;p[d>>3]=r;return 0}function D8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){l=0;k=a}else{h=g;p[d>>3]=h;return 0}while(1){if(i[c+l>>0]|0){j=0;do{h=+p[k+(j<<3)>>3]-+p[b+(j<<3)>>3];g=g+h*h;j=j+1|0}while((j|0)!=(f|0))}l=l+1|0;if((l|0)==(e|0))break;else{b=b+(f<<3)|0;k=k+(f<<3)|0}}p[d>>3]=g;return 0}l=aa(f,e)|0;k=l+-4|0;if((l|0)<4){h=0.0;j=0}else{j=0;h=0.0;do{q=+p[a+(j<<3)>>3]-+p[b+(j<<3)>>3];f=j|1;o=+p[a+(f<<3)>>3]-+p[b+(f<<3)>>3];f=j|2;n=+p[a+(f<<3)>>3]-+p[b+(f<<3)>>3];f=j|3;m=+p[a+(f<<3)>>3]-+p[b+(f<<3)>>3];h=h+(q*q+o*o+n*n+m*m);j=j+4|0}while((j|0)<=(k|0));j=l&-4}if((j|0)<(l|0))do{q=+p[a+(j<<3)>>3]-+p[b+(j<<3)>>3];h=h+q*q;j=j+1|0}while((j|0)!=(l|0));q=g+h;p[d>>3]=q;return 0}function E8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=c+-4|0;if((c|0)<4){d=0;e=0}else{e=0;d=0;do{j=(l[a+e>>0]|0)-(l[b+e>>0]|0)|0;i=e|1;i=(l[a+i>>0]|0)-(l[b+i>>0]|0)|0;h=e|2;h=(l[a+h>>0]|0)-(l[b+h>>0]|0)|0;g=e|3;g=(l[a+g>>0]|0)-(l[b+g>>0]|0)|0;d=((j|0)>-1?j:0-j|0)+d+((i|0)>-1?i:0-i|0)+((h|0)>-1?h:0-h|0)+((g|0)>-1?g:0-g|0)|0;e=e+4|0}while((e|0)<=(f|0));e=c&-4}if((e|0)>=(c|0)){j=d;return j|0}do{j=(l[a+e>>0]|0)-(l[b+e>>0]|0)|0;d=((j|0)>-1?j:0-j|0)+d|0;e=e+1|0}while((e|0)!=(c|0));return d|0}function F8(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0;ca=r;r=r+496|0;C=ca+56|0;ba=ca+440|0;$=ca+384|0;_=ca+328|0;Z=ca+272|0;Y=ca+208|0;z=ca+264|0;X=ca;W=ca+152|0;D=ca+136|0;E=ca+120|0;F=ca+104|0;G=ca+88|0;M=ca+72|0;do if((k[a>>2]&2031616|0)==65536){q=k[a+4>>2]|0;k[ba>>2]=k[q>>2];v=ba+4|0;a=q+4|0;k[v>>2]=k[a>>2];U=ba+8|0;k[U>>2]=k[q+8>>2];k[ba+12>>2]=k[q+12>>2];k[ba+16>>2]=k[q+16>>2];k[ba+20>>2]=k[q+20>>2];k[ba+24>>2]=k[q+24>>2];k[ba+28>>2]=k[q+28>>2];k[ba+32>>2]=k[q+32>>2];m=k[q+36>>2]|0;k[ba+36>>2]=m;n=ba+40|0;k[n>>2]=U;U=ba+48|0;t=ba+44|0;k[t>>2]=U;k[ba+52>>2]=0;k[U>>2]=0;if(m|0){U=m+12|0;k[U>>2]=(k[U>>2]|0)+1}if((k[a>>2]|0)<3){T=k[q+44>>2]|0;U=k[t>>2]|0;k[U>>2]=k[T>>2];k[U+4>>2]=k[T+4>>2];break}k[v>>2]=0;x1(ba,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){u=k[q+40>>2]|0;s=k[n>>2]|0;n=k[q+44>>2]|0;m=k[t>>2]|0;a=0;do{k[s+(a<<2)>>2]=k[u+(a<<2)>>2];k[m+(a<<2)>>2]=k[n+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(ba,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){s=k[b+4>>2]|0;k[$>>2]=k[s>>2];v=$+4|0;m=s+4|0;k[v>>2]=k[m>>2];U=$+8|0;k[U>>2]=k[s+8>>2];k[$+12>>2]=k[s+12>>2];k[$+16>>2]=k[s+16>>2];k[$+20>>2]=k[s+20>>2];k[$+24>>2]=k[s+24>>2];k[$+28>>2]=k[s+28>>2];k[$+32>>2]=k[s+32>>2];a=k[s+36>>2]|0;k[$+36>>2]=a;n=$+40|0;k[n>>2]=U;U=$+48|0;t=$+44|0;k[t>>2]=U;k[$+52>>2]=0;k[U>>2]=0;if(a|0){U=a+12|0;k[U>>2]=(k[U>>2]|0)+1}if((k[m>>2]|0)<3){T=k[s+44>>2]|0;U=k[t>>2]|0;k[U>>2]=k[T>>2];k[U+4>>2]=k[T+4>>2];break}k[v>>2]=0;x1($,k[m>>2]|0,0,0,0);if((k[v>>2]|0)>0){u=k[s+40>>2]|0;q=k[n>>2]|0;n=k[s+44>>2]|0;m=k[t>>2]|0;a=0;do{k[q+(a<<2)>>2]=k[u+(a<<2)>>2];k[m+(a<<2)>>2]=k[n+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1($,b,-1);while(0);do if((k[h>>2]&2031616|0)==65536){q=k[h+4>>2]|0;k[_>>2]=k[q>>2];v=_+4|0;a=q+4|0;k[v>>2]=k[a>>2];U=_+8|0;k[U>>2]=k[q+8>>2];k[_+12>>2]=k[q+12>>2];k[_+16>>2]=k[q+16>>2];k[_+20>>2]=k[q+20>>2];k[_+24>>2]=k[q+24>>2];k[_+28>>2]=k[q+28>>2];k[_+32>>2]=k[q+32>>2];m=k[q+36>>2]|0;k[_+36>>2]=m;n=_+40|0;k[n>>2]=U;U=_+48|0;t=_+44|0;k[t>>2]=U;k[_+52>>2]=0;k[U>>2]=0;if(m|0){U=m+12|0;k[U>>2]=(k[U>>2]|0)+1}if((k[a>>2]|0)<3){T=k[q+44>>2]|0;U=k[t>>2]|0;k[U>>2]=k[T>>2];k[U+4>>2]=k[T+4>>2];break}k[v>>2]=0;x1(_,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){u=k[q+40>>2]|0;s=k[n>>2]|0;n=k[q+44>>2]|0;m=k[t>>2]|0;a=0;do{k[s+(a<<2)>>2]=k[u+(a<<2)>>2];k[m+(a<<2)>>2]=k[n+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(_,h,-1);while(0);a=k[ba>>2]|0;y=a&4095;if((y|0)==(k[$>>2]&4095|0)?(k[ba+12>>2]|0)==(k[$+12>>2]|0):0)switch(a&4095){case 0:case 5:break;default:V=31}else V=31;if((V|0)==31){k[Z>>2]=0;a=Z+4|0;k[a>>2]=0;m=ZT(88)|0;k[m>>2]=1;q=m+4|0;k[Z>>2]=q;k[a>>2]=82;i[m+86>>0]=0;n=231177;s=q+82|0;do{i[q>>0]=i[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(s|0));Y8(-215,Z,231260,229892,3749);k[a>>2]=0;k[Z>>2]=0;U=k[m>>2]|0;k[m>>2]=U+-1;if((U|0)==1)ggb(k[m+-4>>2]|0)}if((g|0)>0^(k[e>>2]&2031616|0)!=0){k[Z>>2]=0;a=Z+4|0;k[a>>2]=0;m=ZT(32)|0;k[m>>2]=1;q=m+4|0;k[Z>>2]=q;k[a>>2]=25;i[m+29>>0]=0;n=231274;s=q+25|0;do{i[q>>0]=i[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(s|0));Y8(-215,Z,231260,229892,3750);k[a>>2]=0;k[Z>>2]=0;U=k[m>>2]|0;k[m>>2]=U+-1;if((U|0)==1)ggb(k[m+-4>>2]|0)}A=(d|0)==-1?((f|1|0)==7?4:5):d;h=(y|0)==0;B=(A|0)==4;x=(A|0)==5;if(!(x|B&h)){k[Z>>2]=0;a=Z+4|0;k[a>>2]=0;m=ZT(60)|0;k[m>>2]=1;q=m+4|0;k[Z>>2]=q;k[a>>2]=53;i[m+57>>0]=0;n=231300;s=q+53|0;do{i[q>>0]=i[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(s|0));Y8(-215,Z,231260,229892,3756);k[a>>2]=0;k[Z>>2]=0;U=k[m>>2]|0;k[m>>2]=U+-1;if((U|0)==1)ggb(k[m+-4>>2]|0)}U=k[$+8>>2]|0;g=(U|0)<(g|0)?U:g;d=ba+8|0;b=(g|0)>0;c2(c,k[d>>2]|0,b?g:U,A,-1,0,0);do if((k[c>>2]&2031616|0)==65536){q=k[c+4>>2]|0;k[Z>>2]=k[q>>2];v=Z+4|0;a=q+4|0;k[v>>2]=k[a>>2];U=Z+8|0;k[U>>2]=k[q+8>>2];k[Z+12>>2]=k[q+12>>2];k[Z+16>>2]=k[q+16>>2];k[Z+20>>2]=k[q+20>>2];k[Z+24>>2]=k[q+24>>2];k[Z+28>>2]=k[q+28>>2];k[Z+32>>2]=k[q+32>>2];m=k[q+36>>2]|0;k[Z+36>>2]=m;n=Z+40|0;k[n>>2]=U;U=Z+48|0;t=Z+44|0;k[t>>2]=U;k[Z+52>>2]=0;k[U>>2]=0;if(m|0){U=m+12|0;k[U>>2]=(k[U>>2]|0)+1}if((k[a>>2]|0)<3){T=k[q+44>>2]|0;U=k[t>>2]|0;k[U>>2]=k[T>>2];k[U+4>>2]=k[T+4>>2];break}k[v>>2]=0;x1(Z,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){u=k[q+40>>2]|0;s=k[n>>2]|0;n=k[q+44>>2]|0;m=k[t>>2]|0;a=0;do{k[s+(a<<2)>>2]=k[u+(a<<2)>>2];k[m+(a<<2)>>2]=k[n+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(Z,c,-1);while(0);k[Y>>2]=1124007936;T=Y+4|0;a=Y+8|0;R=Y+40|0;q=T;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[R>>2]=a;U=Y+48|0;S=Y+44|0;k[S>>2]=U;k[Y+52>>2]=0;k[U>>2]=0;if(k[e>>2]&2031616|0){P=k[Z+40>>2]|0;Q=k[P>>2]|0;k[z>>2]=k[P+4>>2];k[z+4>>2]=Q;x2(e,z,4,0);do if((k[e>>2]&2031616|0)==65536){q=k[e+4>>2]|0;k[X>>2]=k[q>>2];v=X+4|0;a=q+4|0;k[v>>2]=k[a>>2];Q=X+8|0;k[Q>>2]=k[q+8>>2];k[X+12>>2]=k[q+12>>2];k[X+16>>2]=k[q+16>>2];k[X+20>>2]=k[q+20>>2];k[X+24>>2]=k[q+24>>2];k[X+28>>2]=k[q+28>>2];k[X+32>>2]=k[q+32>>2];m=k[q+36>>2]|0;k[X+36>>2]=m;n=X+40|0;k[n>>2]=Q;Q=X+48|0;t=X+44|0;k[t>>2]=Q;k[X+52>>2]=0;k[Q>>2]=0;if(m|0){Q=m+12|0;k[Q>>2]=(k[Q>>2]|0)+1}if((k[a>>2]|0)<3){P=k[q+44>>2]|0;Q=k[t>>2]|0;k[Q>>2]=k[P>>2];k[Q+4>>2]=k[P+4>>2];break}k[v>>2]=0;x1(X,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){u=k[q+40>>2]|0;s=k[n>>2]|0;n=k[q+44>>2]|0;m=k[t>>2]|0;a=0;do{k[s+(a<<2)>>2]=k[u+(a<<2)>>2];k[m+(a<<2)>>2]=k[n+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(X,e,-1);while(0);KG(Y,X)|0;n=X+36|0;a=k[n>>2]|0;if(a|0?(P=a+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){m=k[n>>2]|0;if(m|0){a=k[m+4>>2]|0;if(!a){a=k[X+32>>2]|0;if(!a){a=B1()|0;m=k[n>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,m)}k[n>>2]=0}k[n>>2]=0;Q=X+16|0;m=X+4|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[m>>2]|0)>0){n=k[X+40>>2]|0;a=0;do{k[n+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[X+44>>2]|0;if(!((a|0)==(X+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}a=(j|0)==0;if(a&b){w=B?2147483647.0:3402823466385288598117041.0e14;p[X>>3]=w;p[X+8>>3]=w;p[X+16>>3]=w;p[X+24>>3]=w;oY(Z,X);p[X>>3]=-1.0;p[X+8>>3]=-1.0;p[X+16>>3]=-1.0;p[X+24>>3]=-1.0;oY(Y,X)}if(l){if(a&(g|0)==1){if(k[_+16>>2]|0){n=k[_+4>>2]|0;if((n|0)<3)a=aa(k[_+12>>2]|0,k[_+8>>2]|0)|0;else{q=k[_+40>>2]|0;m=0;a=1;do{a=aa(k[q+(m<<2)>>2]|0,a)|0;m=m+1|0}while((m|0)!=(n|0))}if(a|0)V=85}}else V=85;if((V|0)==85){k[X>>2]=0;a=X+4|0;k[a>>2]=0;m=ZT(44)|0;k[m>>2]=1;q=m+4|0;k[X>>2]=q;k[a>>2]=37;i[m+41>>0]=0;n=231354;s=q+37|0;do{i[q>>0]=i[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(s|0));Y8(-215,X,231260,229892,3776);k[a>>2]=0;k[X>>2]=0;Q=k[m>>2]|0;k[m>>2]=Q+-1;if((Q|0)==1)ggb(k[m+-4>>2]|0)}k[X>>2]=1124007936;O=X+4|0;H=X+8|0;N=X+40|0;q=O;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[N>>2]=H;Q=X+48|0;P=X+44|0;k[P>>2]=Q;k[X+52>>2]=0;k[Q>>2]=0;k[W>>2]=1124007936;L=W+4|0;a=W+8|0;J=W+40|0;q=L;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[J>>2]=a;K=W+48|0;I=W+44|0;k[I>>2]=K;k[W+52>>2]=0;k[K>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=$;k[E+8>>2]=0;k[E+12>>2]=0;k[E>>2]=16842752;k[E+4>>2]=ba;m=F+4|0;a=m+4|0;k[a>>2]=0;k[a+4>>2]=0;k[F>>2]=33619968;k[m>>2]=X;m=G+4|0;a=m+4|0;k[a>>2]=0;k[a+4>>2]=0;k[G>>2]=33619968;k[m>>2]=W;k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=16842752;k[M+4>>2]=_;F8(D,E,F,A,G,f,g,M,0,0);m=k[H>>2]|0;a=(m|0)>0;if(B){if(a){b=k[J>>2]|0;h=b+4|0;d=W+16|0;g=W+12|0;x=k[N>>2]|0;c=x+4|0;y=X+16|0;z=X+12|0;e=k[Z+40>>2]|0;A=e+4|0;B=Z+16|0;l=Z+44|0;C=Z+12|0;D=k[R>>2]|0;E=D+4|0;F=Y+16|0;G=Y+12|0;v=0;a=m;do{do if((k[W>>2]&16384|0)==0?(k[b>>2]|0)!=1:0){m=k[d>>2]|0;n=k[I>>2]|0;if((k[h>>2]|0)==1){m=m+(aa(k[n>>2]|0,v)|0)|0;break}else{f=k[g>>2]|0;M=(v|0)/(f|0)|0;f=v-(aa(M,f)|0)|0;m=m+(aa(k[n>>2]|0,M)|0)+(f<<2)|0;break}}else V=95;while(0);if((V|0)==95){V=0;m=(k[d>>2]|0)+(v<<2)|0}u=k[m>>2]|0;do if((k[X>>2]&16384|0)==0?(k[x>>2]|0)!=1:0){m=k[y>>2]|0;n=k[P>>2]|0;if((k[c>>2]|0)==1){m=m+(aa(k[n>>2]|0,v)|0)|0;break}else{f=k[z>>2]|0;M=(v|0)/(f|0)|0;f=v-(aa(M,f)|0)|0;m=m+(aa(k[n>>2]|0,M)|0)+(f<<2)|0;break}}else V=101;while(0);if((V|0)==101){V=0;m=(k[y>>2]|0)+(v<<2)|0}t=k[m>>2]|0;s=(k[Z>>2]&16384|0)==0;do if(s){if((k[e>>2]|0)==1){V=107;break}n=k[B>>2]|0;m=k[l>>2]|0;if((k[A>>2]|0)==1){m=n+(aa(k[m>>2]|0,u)|0)|0;q=n;break}else{q=k[C>>2]|0;f=(u|0)/(q|0)|0;q=u-(aa(f,q)|0)|0;m=n+(aa(k[m>>2]|0,f)|0)+(q<<2)|0;q=n;break}}else V=107;while(0);if((V|0)==107){V=0;n=k[B>>2]|0;m=n+(u<<2)|0;q=n}if((t|0)<(k[m>>2]|0)){do if(s){if((k[e>>2]|0)==1){V=114;break}a=k[l>>2]|0;if((k[A>>2]|0)==1){a=n+(aa(k[a>>2]|0,u)|0)|0;break}else{f=k[C>>2]|0;M=(u|0)/(f|0)|0;f=u-(aa(M,f)|0)|0;a=n+(aa(k[a>>2]|0,M)|0)+(f<<2)|0;break}}else V=114;while(0);if((V|0)==114){V=0;a=q+(u<<2)|0}k[a>>2]=t;n=v+j|0;do if(!(k[Y>>2]&16384)){if((k[D>>2]|0)==1){V=120;break}a=k[F>>2]|0;m=k[S>>2]|0;if((k[E>>2]|0)==1){a=a+(aa(k[m>>2]|0,u)|0)|0;break}else{f=k[G>>2]|0;M=(u|0)/(f|0)|0;f=u-(aa(M,f)|0)|0;a=a+(aa(k[m>>2]|0,M)|0)+(f<<2)|0;break}}else V=120;while(0);if((V|0)==120){V=0;a=(k[F>>2]|0)+(u<<2)|0}k[a>>2]=n;a=k[H>>2]|0}v=v+1|0}while((v|0)<(a|0))}}else if(a){v=k[J>>2]|0;b=v+4|0;h=W+16|0;d=W+12|0;g=k[N>>2]|0;x=g+4|0;c=X+16|0;y=X+12|0;z=k[Z+40>>2]|0;e=z+4|0;A=Z+16|0;B=Z+44|0;l=Z+12|0;C=k[R>>2]|0;D=C+4|0;E=Y+16|0;F=Y+12|0;u=0;a=m;do{do if((k[W>>2]&16384|0)==0?(k[v>>2]|0)!=1:0){m=k[h>>2]|0;n=k[I>>2]|0;if((k[b>>2]|0)==1){m=m+(aa(k[n>>2]|0,u)|0)|0;break}else{f=k[d>>2]|0;M=(u|0)/(f|0)|0;f=u-(aa(M,f)|0)|0;m=m+(aa(k[n>>2]|0,M)|0)+(f<<2)|0;break}}else V=128;while(0);if((V|0)==128){V=0;m=(k[h>>2]|0)+(u<<2)|0}t=k[m>>2]|0;do if((k[X>>2]&16384|0)==0?(k[g>>2]|0)!=1:0){m=k[c>>2]|0;n=k[P>>2]|0;if((k[x>>2]|0)==1){m=m+(aa(k[n>>2]|0,u)|0)|0;break}else{f=k[y>>2]|0;M=(u|0)/(f|0)|0;f=u-(aa(M,f)|0)|0;m=m+(aa(k[n>>2]|0,M)|0)+(f<<2)|0;break}}else V=134;while(0);if((V|0)==134){V=0;m=(k[c>>2]|0)+(u<<2)|0}w=+o[m>>2];s=(k[Z>>2]&16384|0)==0;do if(s){if((k[z>>2]|0)==1){V=140;break}n=k[A>>2]|0;m=k[B>>2]|0;if((k[e>>2]|0)==1){m=n+(aa(k[m>>2]|0,t)|0)|0;q=n;break}else{q=k[l>>2]|0;f=(t|0)/(q|0)|0;q=t-(aa(f,q)|0)|0;m=n+(aa(k[m>>2]|0,f)|0)+(q<<2)|0;q=n;break}}else V=140;while(0);if((V|0)==140){V=0;n=k[A>>2]|0;m=n+(t<<2)|0;q=n}if(w<+o[m>>2]){do if(s){if((k[z>>2]|0)==1){V=147;break}a=k[B>>2]|0;if((k[e>>2]|0)==1){a=n+(aa(k[a>>2]|0,t)|0)|0;break}else{f=k[l>>2]|0;M=(t|0)/(f|0)|0;f=t-(aa(M,f)|0)|0;a=n+(aa(k[a>>2]|0,M)|0)+(f<<2)|0;break}}else V=147;while(0);if((V|0)==147){V=0;a=q+(t<<2)|0}o[a>>2]=w;n=u+j|0;do if(!(k[Y>>2]&16384)){if((k[C>>2]|0)==1){V=153;break}a=k[E>>2]|0;m=k[S>>2]|0;if((k[D>>2]|0)==1){a=a+(aa(k[m>>2]|0,t)|0)|0;break}else{f=k[F>>2]|0;M=(t|0)/(f|0)|0;f=t-(aa(M,f)|0)|0;a=a+(aa(k[m>>2]|0,M)|0)+(f<<2)|0;break}}else V=153;while(0);if((V|0)==153){V=0;a=(k[E>>2]|0)+(t<<2)|0}k[a>>2]=n;a=k[H>>2]|0}u=u+1|0}while((u|0)<(a|0))}n=W+36|0;a=k[n>>2]|0;if(a|0?(V=a+12|0,j=k[V>>2]|0,k[V>>2]=j+-1,(j|0)==1):0){m=k[n>>2]|0;if(m|0){a=k[m+4>>2]|0;do if(!a){a=k[W+32>>2]|0;if(a|0)break;a=B1()|0;m=k[n>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,m)}k[n>>2]=0}k[n>>2]=0;W=W+16|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[L>>2]|0)>0){m=k[J>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[L>>2]|0))}a=k[I>>2]|0;if(!((a|0)==(K|0)|(a|0)==0))ggb(k[a+-4>>2]|0);n=X+36|0;a=k[n>>2]|0;if(a|0?(j=a+12|0,W=k[j>>2]|0,k[j>>2]=W+-1,(W|0)==1):0){m=k[n>>2]|0;if(m|0){a=k[m+4>>2]|0;do if(!a){a=k[X+32>>2]|0;if(a|0)break;a=B1()|0;m=k[n>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,m)}k[n>>2]=0}k[n>>2]=0;X=X+16|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[O>>2]|0)>0){m=k[N>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[O>>2]|0))}a=k[P>>2]|0;if(!((a|0)==(Q|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else{a:do if(h){a=(f|0)==2;if(!(a&B))if(!(a&x)){a=(f|0)==5;if(!(a&B))if(!(a&x))if(!((f|0)==4&x))if(!((f|0)==6&B))if((f|0)==7&B)a=91;else V=198;else a=90;else a=89;else a=88;else a=87}else a=86;else a=85}else if(x&(y|0)==5)switch(f|0){case 2:{a=92;break a}case 5:{a=93;break a}default:if((f|0)==4){a=94;break a}else{V=198;break a}}else V=198;while(0);if((V|0)==198){k[C>>2]=y;k[C+4>>2]=A;k[C+8>>2]=f;$8(X,231392,C);Y8(-210,X,231260,229892,3846);a=k[X>>2]|0;k[X+4>>2]=0;k[X>>2]=0;if(a|0?(Q=a+-4|0,V=k[Q>>2]|0,k[Q>>2]=V+-1,(V|0)==1):0)ggb(k[a+-8>>2]|0);a=0}V=k[d>>2]|0;k[X>>2]=0;k[X+4>>2]=V;k[W>>2]=50032;k[W+4>>2]=ba;k[W+8>>2]=$;k[W+12>>2]=Z;k[W+16>>2]=Y;k[W+24>>2]=g;k[W+20>>2]=_;k[W+28>>2]=j;k[W+32>>2]=a;R8(W,X)}n=Y+36|0;a=k[n>>2]|0;if(a|0?(W=a+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){m=k[n>>2]|0;if(m|0){a=k[m+4>>2]|0;if(!a){a=k[Y+32>>2]|0;if(!a){a=B1()|0;m=k[n>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,m)}k[n>>2]=0}k[n>>2]=0;Y=Y+16|0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[T>>2]|0)>0){m=k[R>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[T>>2]|0))}a=k[S>>2]|0;if(!((a|0)==(U|0)|(a|0)==0))ggb(k[a+-4>>2]|0);n=Z+36|0;a=k[n>>2]|0;if(a|0?(X=a+12|0,Y=k[X>>2]|0,k[X>>2]=Y+-1,(Y|0)==1):0){m=k[n>>2]|0;if(m|0){a=k[m+4>>2]|0;do if(!a){a=k[Z+32>>2]|0;if(a|0)break;a=B1()|0;m=k[n>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,m)}k[n>>2]=0}k[n>>2]=0;Y=Z+16|0;m=Z+4|0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[m>>2]|0)>0){n=k[Z+40>>2]|0;a=0;do{k[n+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[Z+44>>2]|0;if(!((a|0)==(Z+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);n=_+36|0;a=k[n>>2]|0;if(a|0?(Y=a+12|0,Z=k[Y>>2]|0,k[Y>>2]=Z+-1,(Z|0)==1):0){m=k[n>>2]|0;if(m|0){a=k[m+4>>2]|0;do if(!a){a=k[_+32>>2]|0;if(a|0)break;a=B1()|0;m=k[n>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,m)}k[n>>2]=0}k[n>>2]=0;Z=_+16|0;m=_+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[m>>2]|0)>0){n=k[_+40>>2]|0;a=0;do{k[n+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[_+44>>2]|0;if(!((a|0)==(_+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);n=$+36|0;a=k[n>>2]|0;do if(a|0){Z=a+12|0;_=k[Z>>2]|0;k[Z>>2]=_+-1;if((_|0)!=1)break;m=k[n>>2]|0;if(m|0){a=k[m+4>>2]|0;do if(!a){a=k[$+32>>2]|0;if(a|0)break;a=B1()|0;m=k[n>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,m)}k[n>>2]=0}while(0);k[n>>2]=0;_=$+16|0;m=$+4|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[m>>2]|0)>0){n=k[$+40>>2]|0;a=0;do{k[n+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[$+44>>2]|0;if(!((a|0)==($+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);n=ba+36|0;a=k[n>>2]|0;do if(a|0){_=a+12|0;$=k[_>>2]|0;k[_>>2]=$+-1;if(($|0)!=1)break;m=k[n>>2]|0;if(m|0){a=k[m+4>>2]|0;do if(!a){a=k[ba+32>>2]|0;if(a|0)break;a=B1()|0;m=k[n>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,m)}k[n>>2]=0}while(0);k[n>>2]=0;$=ba+16|0;m=ba+4|0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[m>>2]|0)>0){n=k[ba+40>>2]|0;a=0;do{k[n+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[ba+44>>2]|0;if((a|0)==(ba+48|0)|(a|0)==0){r=ca;return}ggb(k[a+-4>>2]|0);r=ca;return}function G8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0;p=c>>>2;c=(d|0)>0;if(!g){if(!c)return;l=e+-4|0;m=e&-4;if((e|0)<4){l=(e|0)>0;k=0;do{j=b+((aa(k,p)|0)<<2)|0;if(l){c=0;h=0.0;do{h=h+ +P(+(+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2]));c=c+1|0}while((c|0)!=(e|0))}else h=0.0;o[f+(k<<2)>>2]=h;k=k+1|0}while((k|0)!=(d|0));return}n=(m|0)<(e|0);k=0;do{j=b+((aa(k,p)|0)<<2)|0;c=0;h=0.0;do{r=c|1;q=c|2;g=c|3;h=h+(+P(+(+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2]))+ +P(+(+o[a+(r<<2)>>2]-+o[j+(r<<2)>>2]))+ +P(+(+o[a+(q<<2)>>2]-+o[j+(q<<2)>>2]))+ +P(+(+o[a+(g<<2)>>2]-+o[j+(g<<2)>>2])));c=c+4|0}while((c|0)<=(l|0));if(n){c=m;do{h=h+ +P(+(+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2]));c=c+1|0}while((c|0)!=(e|0))}o[f+(k<<2)>>2]=h;k=k+1|0}while((k|0)!=(d|0));return}if(!c)return;l=e+-4|0;m=e&-4;if((e|0)<4){l=(e|0)>0;k=0;do{if(i[g+k>>0]|0){j=b+((aa(k,p)|0)<<2)|0;if(l){c=0;h=0.0;do{h=h+ +P(+(+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2]));c=c+1|0}while((c|0)!=(e|0))}else h=0.0}else h=3402823466385288598117041.0e14;o[f+(k<<2)>>2]=h;k=k+1|0}while((k|0)!=(d|0));return}n=(m|0)<(e|0);k=0;do{if(i[g+k>>0]|0){j=b+((aa(k,p)|0)<<2)|0;c=0;h=0.0;do{s=c|1;q=c|2;r=c|3;h=h+(+P(+(+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2]))+ +P(+(+o[a+(s<<2)>>2]-+o[j+(s<<2)>>2]))+ +P(+(+o[a+(q<<2)>>2]-+o[j+(q<<2)>>2]))+ +P(+(+o[a+(r<<2)>>2]-+o[j+(r<<2)>>2])));c=c+4|0}while((c|0)<=(l|0));if(n){c=m;do{h=h+ +P(+(+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2]));c=c+1|0}while((c|0)!=(e|0))}}else h=3402823466385288598117041.0e14;o[f+(k<<2)>>2]=h;k=k+1|0}while((k|0)!=(d|0));return}function H8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=(d|0)>0;if(!g){if(h)h=0;else return;do{g=M7(a,b+(aa(h,c)|0)|0,e)|0;k[f+(h<<2)>>2]=g;h=h+1|0}while((h|0)!=(d|0));return}if(h)h=0;else return;do{if(!(i[g+h>>0]|0))j=2147483647;else j=M7(a,b+(aa(h,c)|0)|0,e)|0;k[f+(h<<2)>>2]=j;h=h+1|0}while((h|0)!=(d|0));return}function I8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0.0,k=0,m=0,n=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0;h=(d|0)>0;if(!g){if(!h)return;n=e+-4|0;p=e&-4;if((e|0)<4){n=(e|0)>0;m=0;do{k=b+(aa(m,c)|0)|0;if(n){h=0;j=0.0;do{r=+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0);j=j+r*r;h=h+1|0}while((h|0)!=(e|0))}else j=0.0;r=+Q(+j);o[f+(m<<2)>>2]=r;m=m+1|0}while((m|0)!=(d|0));return}q=(p|0)<(e|0);m=0;do{k=b+(aa(m,c)|0)|0;h=0;j=0.0;do{u=+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0);g=h|1;t=+((l[a+g>>0]|0)-(l[k+g>>0]|0)|0);g=h|2;s=+((l[a+g>>0]|0)-(l[k+g>>0]|0)|0);g=h|3;r=+((l[a+g>>0]|0)-(l[k+g>>0]|0)|0);j=j+(u*u+t*t+s*s+r*r);h=h+4|0}while((h|0)<=(n|0));if(q){h=p;do{u=+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0);j=j+u*u;h=h+1|0}while((h|0)!=(e|0))}u=+Q(+j);o[f+(m<<2)>>2]=u;m=m+1|0}while((m|0)!=(d|0));return}if(!h)return;q=e+-4|0;n=e&-4;if((e|0)<4){n=(e|0)>0;m=0;do{if(!(i[g+m>>0]|0))j=3402823466385288598117041.0e14;else{k=b+(aa(m,c)|0)|0;if(n){h=0;j=0.0;do{u=+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0);j=j+u*u;h=h+1|0}while((h|0)!=(e|0))}else j=0.0;j=+Q(+j)}o[f+(m<<2)>>2]=j;m=m+1|0}while((m|0)!=(d|0));return}p=(n|0)<(e|0);m=0;do{if(!(i[g+m>>0]|0))j=3402823466385288598117041.0e14;else{k=b+(aa(m,c)|0)|0;h=0;j=0.0;do{r=+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0);v=h|1;s=+((l[a+v>>0]|0)-(l[k+v>>0]|0)|0);v=h|2;t=+((l[a+v>>0]|0)-(l[k+v>>0]|0)|0);v=h|3;u=+((l[a+v>>0]|0)-(l[k+v>>0]|0)|0);j=j+(r*r+s*s+t*t+u*u);h=h+4|0}while((h|0)<=(q|0));if(p){h=n;do{u=+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0);j=j+u*u;h=h+1|0}while((h|0)!=(e|0))}j=+Q(+j)}o[f+(m<<2)>>2]=j;m=m+1|0}while((m|0)!=(d|0));return}function J8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0.0,k=0,m=0,n=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0;h=(d|0)>0;if(!g){if(!h)return;n=e+-4|0;p=e&-4;if((e|0)<4){n=(e|0)>0;m=0;do{k=b+(aa(m,c)|0)|0;if(n){h=0;j=0.0;do{r=+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0);j=j+r*r;h=h+1|0}while((h|0)!=(e|0))}else j=0.0;o[f+(m<<2)>>2]=j;m=m+1|0}while((m|0)!=(d|0));return}q=(p|0)<(e|0);m=0;do{k=b+(aa(m,c)|0)|0;h=0;j=0.0;do{u=+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0);g=h|1;t=+((l[a+g>>0]|0)-(l[k+g>>0]|0)|0);g=h|2;s=+((l[a+g>>0]|0)-(l[k+g>>0]|0)|0);g=h|3;r=+((l[a+g>>0]|0)-(l[k+g>>0]|0)|0);j=j+(u*u+t*t+s*s+r*r);h=h+4|0}while((h|0)<=(n|0));if(q){h=p;do{u=+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0);j=j+u*u;h=h+1|0}while((h|0)!=(e|0))}o[f+(m<<2)>>2]=j;m=m+1|0}while((m|0)!=(d|0));return}if(!h)return;q=e+-4|0;n=e&-4;if((e|0)<4){n=(e|0)>0;m=0;do{if(i[g+m>>0]|0){k=b+(aa(m,c)|0)|0;if(n){h=0;j=0.0;do{u=+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0);j=j+u*u;h=h+1|0}while((h|0)!=(e|0))}else j=0.0}else j=3402823466385288598117041.0e14;o[f+(m<<2)>>2]=j;m=m+1|0}while((m|0)!=(d|0));return}p=(n|0)<(e|0);m=0;do{if(i[g+m>>0]|0){k=b+(aa(m,c)|0)|0;h=0;j=0.0;do{r=+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0);v=h|1;s=+((l[a+v>>0]|0)-(l[k+v>>0]|0)|0);v=h|2;t=+((l[a+v>>0]|0)-(l[k+v>>0]|0)|0);v=h|3;u=+((l[a+v>>0]|0)-(l[k+v>>0]|0)|0);j=j+(r*r+s*s+t*t+u*u);h=h+4|0}while((h|0)<=(q|0));if(p){h=n;do{u=+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0);j=j+u*u;h=h+1|0}while((h|0)!=(e|0))}}else j=3402823466385288598117041.0e14;o[f+(m<<2)>>2]=j;m=m+1|0}while((m|0)!=(d|0));return}function K8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=(d|0)>0;if(!g){if(!h)return;o=e+-4|0;p=e&-4;if((e|0)<4){o=(e|0)>0;n=0;do{m=b+(aa(n,c)|0)|0;if(o){j=0;h=0;do{g=(l[a+j>>0]|0)-(l[m+j>>0]|0)|0;h=(aa(g,g)|0)+h|0;j=j+1|0}while((j|0)!=(e|0))}else h=0;k[f+(n<<2)>>2]=h;n=n+1|0}while((n|0)!=(d|0));return}q=(p|0)<(e|0);n=0;do{m=b+(aa(n,c)|0)|0;j=0;h=0;do{t=(l[a+j>>0]|0)-(l[m+j>>0]|0)|0;s=j|1;s=(l[a+s>>0]|0)-(l[m+s>>0]|0)|0;r=j|2;r=(l[a+r>>0]|0)-(l[m+r>>0]|0)|0;g=j|3;g=(l[a+g>>0]|0)-(l[m+g>>0]|0)|0;h=(aa(t,t)|0)+h+(aa(s,s)|0)+(aa(r,r)|0)+(aa(g,g)|0)|0;j=j+4|0}while((j|0)<=(o|0));if(q){j=p;do{t=(l[a+j>>0]|0)-(l[m+j>>0]|0)|0;h=(aa(t,t)|0)+h|0;j=j+1|0}while((j|0)!=(e|0))}k[f+(n<<2)>>2]=h;n=n+1|0}while((n|0)!=(d|0));return}if(!h)return;q=e+-4|0;o=e&-4;if((e|0)<4){o=(e|0)>0;n=0;do{if(i[g+n>>0]|0){m=b+(aa(n,c)|0)|0;if(o){j=0;h=0;do{t=(l[a+j>>0]|0)-(l[m+j>>0]|0)|0;h=(aa(t,t)|0)+h|0;j=j+1|0}while((j|0)!=(e|0))}else h=0}else h=2147483647;k[f+(n<<2)>>2]=h;n=n+1|0}while((n|0)!=(d|0));return}p=(o|0)<(e|0);n=0;do{if(i[g+n>>0]|0){m=b+(aa(n,c)|0)|0;j=0;h=0;do{u=(l[a+j>>0]|0)-(l[m+j>>0]|0)|0;r=j|1;r=(l[a+r>>0]|0)-(l[m+r>>0]|0)|0;s=j|2;s=(l[a+s>>0]|0)-(l[m+s>>0]|0)|0;t=j|3;t=(l[a+t>>0]|0)-(l[m+t>>0]|0)|0;h=(aa(u,u)|0)+h+(aa(r,r)|0)+(aa(s,s)|0)+(aa(t,t)|0)|0;j=j+4|0}while((j|0)<=(q|0));if(p){j=o;do{u=(l[a+j>>0]|0)-(l[m+j>>0]|0)|0;h=(aa(u,u)|0)+h|0;j=j+1|0}while((j|0)!=(e|0))}}else h=2147483647;k[f+(n<<2)>>2]=h;n=n+1|0}while((n|0)!=(d|0));return}function L8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0.0,k=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0;h=(d|0)>0;if(!g){if(!h)return;n=e+-4|0;p=e&-4;if((e|0)<4){n=(e|0)>0;m=0;do{k=b+(aa(m,c)|0)|0;if(n){h=0;j=0.0;do{j=j+ +P(+(+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0)));h=h+1|0}while((h|0)!=(e|0))}else j=0.0;o[f+(m<<2)>>2]=j;m=m+1|0}while((m|0)!=(d|0));return}q=(p|0)<(e|0);m=0;do{k=b+(aa(m,c)|0)|0;h=0;j=0.0;do{s=h|1;r=h|2;g=h|3;j=j+(+P(+(+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0)))+ +P(+(+((l[a+s>>0]|0)-(l[k+s>>0]|0)|0)))+ +P(+(+((l[a+r>>0]|0)-(l[k+r>>0]|0)|0)))+ +P(+(+((l[a+g>>0]|0)-(l[k+g>>0]|0)|0))));h=h+4|0}while((h|0)<=(n|0));if(q){h=p;do{j=j+ +P(+(+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0)));h=h+1|0}while((h|0)!=(e|0))}o[f+(m<<2)>>2]=j;m=m+1|0}while((m|0)!=(d|0));return}if(!h)return;q=e+-4|0;n=e&-4;if((e|0)<4){n=(e|0)>0;m=0;do{if(i[g+m>>0]|0){k=b+(aa(m,c)|0)|0;if(n){h=0;j=0.0;do{j=j+ +P(+(+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0)));h=h+1|0}while((h|0)!=(e|0))}else j=0.0}else j=3402823466385288598117041.0e14;o[f+(m<<2)>>2]=j;m=m+1|0}while((m|0)!=(d|0));return}p=(n|0)<(e|0);m=0;do{if(i[g+m>>0]|0){k=b+(aa(m,c)|0)|0;h=0;j=0.0;do{t=h|1;r=h|2;s=h|3;j=j+(+P(+(+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0)))+ +P(+(+((l[a+t>>0]|0)-(l[k+t>>0]|0)|0)))+ +P(+(+((l[a+r>>0]|0)-(l[k+r>>0]|0)|0)))+ +P(+(+((l[a+s>>0]|0)-(l[k+s>>0]|0)|0))));h=h+4|0}while((h|0)<=(q|0));if(p){h=n;do{j=j+ +P(+(+((l[a+h>>0]|0)-(l[k+h>>0]|0)|0)));h=h+1|0}while((h|0)!=(e|0))}}else j=3402823466385288598117041.0e14;o[f+(m<<2)>>2]=j;m=m+1|0}while((m|0)!=(d|0));return}function M8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=(d|0)>0;if(!g){if(h)h=0;else return;do{g=E8(a,b+(aa(h,c)|0)|0,e)|0;k[f+(h<<2)>>2]=g;h=h+1|0}while((h|0)!=(d|0));return}if(h)h=0;else return;do{if(!(i[g+h>>0]|0))j=2147483647;else j=E8(a,b+(aa(h,c)|0)|0,e)|0;k[f+(h<<2)>>2]=j;h=h+1|0}while((h|0)!=(d|0));return}function N8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,j=0,k=0,l=0,m=0,n=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0;p=c>>>2;c=(d|0)>0;if(!g){if(!c)return;l=e+-4|0;m=e&-4;if((e|0)<4){l=(e|0)>0;k=0;do{j=b+((aa(k,p)|0)<<2)|0;if(l){c=0;h=0.0;do{q=+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2];h=h+q*q;c=c+1|0}while((c|0)!=(e|0))}else h=0.0;o[f+(k<<2)>>2]=h;k=k+1|0}while((k|0)!=(d|0));return}n=(m|0)<(e|0);k=0;do{j=b+((aa(k,p)|0)<<2)|0;c=0;h=0.0;do{t=+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2];g=c|1;s=+o[a+(g<<2)>>2]-+o[j+(g<<2)>>2];g=c|2;r=+o[a+(g<<2)>>2]-+o[j+(g<<2)>>2];g=c|3;q=+o[a+(g<<2)>>2]-+o[j+(g<<2)>>2];h=h+(t*t+s*s+r*r+q*q);c=c+4|0}while((c|0)<=(l|0));if(n){c=m;do{t=+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2];h=h+t*t;c=c+1|0}while((c|0)!=(e|0))}o[f+(k<<2)>>2]=h;k=k+1|0}while((k|0)!=(d|0));return}if(!c)return;l=e+-4|0;m=e&-4;if((e|0)<4){l=(e|0)>0;k=0;do{if(i[g+k>>0]|0){j=b+((aa(k,p)|0)<<2)|0;if(l){c=0;h=0.0;do{t=+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2];h=h+t*t;c=c+1|0}while((c|0)!=(e|0))}else h=0.0}else h=3402823466385288598117041.0e14;o[f+(k<<2)>>2]=h;k=k+1|0}while((k|0)!=(d|0));return}n=(m|0)<(e|0);k=0;do{if(i[g+k>>0]|0){j=b+((aa(k,p)|0)<<2)|0;c=0;h=0.0;do{q=+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2];u=c|1;r=+o[a+(u<<2)>>2]-+o[j+(u<<2)>>2];u=c|2;s=+o[a+(u<<2)>>2]-+o[j+(u<<2)>>2];u=c|3;t=+o[a+(u<<2)>>2]-+o[j+(u<<2)>>2];h=h+(q*q+r*r+s*s+t*t);c=c+4|0}while((c|0)<=(l|0));if(n){c=m;do{t=+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2];h=h+t*t;c=c+1|0}while((c|0)!=(e|0))}}else h=3402823466385288598117041.0e14;o[f+(k<<2)>>2]=h;k=k+1|0}while((k|0)!=(d|0));return}function O8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=(d|0)>0;if(!g){if(h)h=0;else return;do{g=i8(a,b+(aa(h,c)|0)|0,e,2)|0;k[f+(h<<2)>>2]=g;h=h+1|0}while((h|0)!=(d|0));return}if(h)h=0;else return;do{if(!(i[g+h>>0]|0))j=2147483647;else j=i8(a,b+(aa(h,c)|0)|0,e,2)|0;k[f+(h<<2)>>2]=j;h=h+1|0}while((h|0)!=(d|0));return}function P8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,j=0,k=0,l=0,m=0,n=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0;p=c>>>2;c=(d|0)>0;if(!g){if(!c)return;l=e+-4|0;m=e&-4;if((e|0)<4){l=(e|0)>0;k=0;do{j=b+((aa(k,p)|0)<<2)|0;if(l){c=0;h=0.0;do{q=+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2];h=h+q*q;c=c+1|0}while((c|0)!=(e|0))}else h=0.0;q=+Q(+h);o[f+(k<<2)>>2]=q;k=k+1|0}while((k|0)!=(d|0));return}n=(m|0)<(e|0);k=0;do{j=b+((aa(k,p)|0)<<2)|0;c=0;h=0.0;do{t=+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2];g=c|1;s=+o[a+(g<<2)>>2]-+o[j+(g<<2)>>2];g=c|2;r=+o[a+(g<<2)>>2]-+o[j+(g<<2)>>2];g=c|3;q=+o[a+(g<<2)>>2]-+o[j+(g<<2)>>2];h=h+(t*t+s*s+r*r+q*q);c=c+4|0}while((c|0)<=(l|0));if(n){c=m;do{t=+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2];h=h+t*t;c=c+1|0}while((c|0)!=(e|0))}t=+Q(+h);o[f+(k<<2)>>2]=t;k=k+1|0}while((k|0)!=(d|0));return}if(!c)return;l=e+-4|0;m=e&-4;if((e|0)<4){l=(e|0)>0;k=0;do{if(!(i[g+k>>0]|0))h=3402823466385288598117041.0e14;else{j=b+((aa(k,p)|0)<<2)|0;if(l){c=0;h=0.0;do{t=+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2];h=h+t*t;c=c+1|0}while((c|0)!=(e|0))}else h=0.0;h=+Q(+h)}o[f+(k<<2)>>2]=h;k=k+1|0}while((k|0)!=(d|0));return}n=(m|0)<(e|0);k=0;do{if(!(i[g+k>>0]|0))h=3402823466385288598117041.0e14;else{j=b+((aa(k,p)|0)<<2)|0;c=0;h=0.0;do{q=+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2];u=c|1;r=+o[a+(u<<2)>>2]-+o[j+(u<<2)>>2];u=c|2;s=+o[a+(u<<2)>>2]-+o[j+(u<<2)>>2];u=c|3;t=+o[a+(u<<2)>>2]-+o[j+(u<<2)>>2];h=h+(q*q+r*r+s*s+t*t);c=c+4|0}while((c|0)<=(l|0));if(n){c=m;do{t=+o[a+(c<<2)>>2]-+o[j+(c<<2)>>2];h=h+t*t;c=c+1|0}while((c|0)!=(e|0))}h=+Q(+h)}o[f+(k<<2)>>2]=h;k=k+1|0}while((k|0)!=(d|0));return}function Q8(a){a=a|0;ggb(a);return}function R8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+1072|0;w=z;q=a+8|0;f=k[q>>2]|0;e=k[f+8>>2]|0;x=w+8|0;k[w>>2]=x;y=w+4|0;k[y>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[w>>2]=c}else c=x;k[y>>2]=e;d=k[b>>2]|0;i=b+4|0;if((d|0)<(k[i>>2]|0)){j=a+32|0;l=a+4|0;m=a+24|0;n=a+20|0;o=a+16|0;p=a+12|0;h=a+28|0;while(1){a=k[l>>2]|0;a=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,d)|0)|0;if((k[m>>2]|0)>0)g=c;else{g=k[p>>2]|0;g=(k[g+16>>2]|0)+(aa(k[k[g+44>>2]>>2]|0,d)|0)|0}e=k[n>>2]|0;b=k[e+16>>2]|0;if(!b)e=0;else e=b+(aa(k[k[e+44>>2]>>2]|0,d)|0)|0;Eh[k[j>>2]&127](a,k[f+16>>2]|0,k[f+48>>2]|0,k[f+8>>2]|0,k[f+12>>2]|0,g,e);a=k[m>>2]|0;a:do if((a|0)>0?(s=k[o>>2]|0,s=(k[s+16>>2]|0)+(aa(k[k[s+44>>2]>>2]|0,d)|0)|0,t=k[p>>2]|0,t=(k[t+16>>2]|0)+(aa(k[k[t+44>>2]>>2]|0,d)|0)|0,u=(k[q>>2]|0)+8|0,v=k[u>>2]|0,(v|0)>0):0){e=0;b=v;while(1){f=k[c+(e<<2)>>2]|0;if((f|0)<(k[t+(a+-1<<2)>>2]|0)){b=a+-2|0;b:do if((b|0)>-1)while(1){a=t+(b<<2)|0;if((k[a>>2]|0)<=(f|0))break b;g=b+1|0;k[s+(g<<2)>>2]=k[s+(b<<2)>>2];k[t+(g<<2)>>2]=k[a>>2];a=b+-1|0;if((b|0)>0)b=a;else{b=a;break}}while(0);b=b+1|0;k[s+(b<<2)>>2]=(k[h>>2]|0)+e;k[t+(b<<2)>>2]=f;b=k[u>>2]|0}e=e+1|0;if((e|0)>=(b|0))break a;a=k[m>>2]|0}}while(0);d=d+1|0;if((d|0)>=(k[i>>2]|0))break;f=k[q>>2]|0}c=k[w>>2]|0}if((c|0)==(x|0)){r=z;return}if(c|0)ggb(c);k[w>>2]=x;k[y>>2]=264;r=z;return}function S8(a){a=a|0;var b=0,c=0;b=k[a>>2]|0;k[a+4>>2]=0;k[a>>2]=0;if(!b)return;c=b+-4|0;a=k[c>>2]|0;k[c>>2]=a+-1;if((a|0)!=1)return;ggb(k[b+-8>>2]|0);return}function T8(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=50052;c=a+32|0;b=k[c>>2]|0;k[a+36>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+24|0;b=k[d>>2]|0;k[a+28>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+16|0;b=k[d>>2]|0;k[a+20>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1)return;ggb(k[b+-8>>2]|0);return}function U8(a){a=a|0;T8(a);ggb(a);return}function V8(a){a=a|0;a=k[a+4>>2]|0;return ((a|0)==0?1016759:a)|0}function W8(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;g=r;r=r+16|0;f=g;k[a>>2]=50072;if((k[a+4>>2]|0)==-1){r=g;return}a=f+4|0;b=ZT(16)|0;k[b>>2]=1;c=b+4|0;k[f>>2]=c;k[a>>2]=10;i[b+14>>0]=0;d=231561;e=c+10|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,f,231572,231590,1172);k[a>>2]=0;k[f>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0);r=g;return}function X8(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;f=r;r=r+16|0;b=f;k[a>>2]=50072;if((k[a+4>>2]|0)==-1){ggb(a);r=f;return}k[b>>2]=0;c=b+4|0;k[c>>2]=0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[b>>2]=e;k[c>>2]=10;i[d+14>>0]=0;g=231561;h=e+10|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-215,b,231572,231590,1172);k[c>>2]=0;k[b>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);ggb(a);r=f;return}function Y8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+64|0;m=o+16|0;n=o+8|0;k[n>>2]=0;j=n+4|0;k[j>>2]=0;if(c|0){h=c;a:do if(!(h&3)){f=c;l=5}else{g=c;f=h;while(1){if(!(i[g>>0]|0))break a;g=g+1|0;f=g;if(!(f&3)){f=g;l=5;break}}}while(0);if((l|0)==5){while(1){g=k[f>>2]|0;if(!((g&-2139062144^-2139062144)&g+-16843009))f=f+4|0;else break}if((g&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}h=f-h|0;g=ZT(h+8&-4)|0;k[g>>2]=1;g=g+4|0;k[n>>2]=g;k[j>>2]=h;i[g+h>>0]=0;upb(g|0,c|0,h|0)|0}k[o>>2]=0;h=o+4|0;k[h>>2]=0;if(!d){Z8(m,a,b,n,o,e);_8(m)}c=d;b:do if(!(c&3)){f=d;l=15}else{f=d;g=c;while(1){if(!(i[f>>0]|0)){f=g;break b}f=f+1|0;g=f;if(!(g&3)){l=15;break}}}while(0);if((l|0)==15){while(1){g=k[f>>2]|0;if(!((g&-2139062144^-2139062144)&g+-16843009))f=f+4|0;else break}if((g&255)<<24>>24)do f=f+1|0;while((i[f>>0]|0)!=0)}l=f-c|0;j=ZT(l+8&-4)|0;k[j>>2]=1;j=j+4|0;k[o>>2]=j;k[h>>2]=l;i[j+l>>0]=0;upb(j|0,d|0,l|0)|0;Z8(m,a,b,n,o,e);_8(m)}function Z8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=r;r=r+48|0;i=n+24|0;h=n;m=n+40|0;k[a>>2]=50052;j=a+4|0;k[j>>2]=0;l=a+8|0;k[l>>2]=0;g=a+12|0;k[g>>2]=b;b=k[c>>2]|0;k[a+16>>2]=b;k[a+20>>2]=k[c+4>>2];if(b|0){c=b+-4|0;k[c>>2]=(k[c>>2]|0)+1}b=k[d>>2]|0;k[a+24>>2]=b;c=a+28|0;k[c>>2]=k[d+4>>2];if(b|0){d=b+-4|0;k[d>>2]=(k[d>>2]|0)+1}b=k[e>>2]|0;k[a+32>>2]=b;k[a+36>>2]=k[e+4>>2];if(b|0){e=b+-4|0;k[e>>2]=(k[e>>2]|0)+1}k[a+40>>2]=f;if(!(k[c>>2]|0)){e=k[a+32>>2]|0;g=k[g>>2]|0;h=k[a+16>>2]|0;k[i>>2]=(e|0)==0?1016759:e;k[i+4>>2]=f;k[i+8>>2]=g;k[i+12>>2]=(h|0)==0?1016759:h;$8(m,232592,i);if((m|0)==(j|0)){c=m+4|0;d=m;b=k[m>>2]|0}else{b=k[j>>2]|0;k[l>>2]=0;k[j>>2]=0;if(b|0?(h=b+-4|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0)ggb(k[b+-8>>2]|0);b=k[m>>2]|0;if(!b)c=0;else{c=b+-4|0;k[c>>2]=(k[c>>2]|0)+1;c=k[m>>2]|0;b=c}k[j>>2]=c;c=m+4|0;k[l>>2]=k[c>>2];d=m}k[c>>2]=0;k[d>>2]=0;if(b|0?(l=b+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[b+-8>>2]|0);r=n;return}else{d=k[a+32>>2]|0;e=k[g>>2]|0;g=k[a+16>>2]|0;i=k[a+24>>2]|0;k[h>>2]=(d|0)==0?1016759:d;k[h+4>>2]=f;k[h+8>>2]=e;k[h+12>>2]=(g|0)==0?1016759:g;k[h+16>>2]=(i|0)==0?1016759:i;$8(m,232554,h);if((m|0)==(j|0)){c=m;d=m+4|0;b=k[m>>2]|0}else{b=k[j>>2]|0;k[l>>2]=0;k[j>>2]=0;if(b|0?(h=b+-4|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0)ggb(k[b+-8>>2]|0);b=k[m>>2]|0;if(!b)c=0;else{c=b+-4|0;k[c>>2]=(k[c>>2]|0)+1;c=k[m>>2]|0;b=c}k[j>>2]=c;d=m+4|0;k[l>>2]=k[d>>2];c=m}k[d>>2]=0;k[c>>2]=0;if(b|0?(l=b+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[b+-8>>2]|0);r=n;return}}function _8(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;e=r;r=r+65584|0;g=e+32|0;f=e+8|0;c=e;e=e+40|0;h=a+12|0;b=k[h>>2]|0;do switch(b|0){case 0:{b=232482;break}case -1:{b=232472;break}case -2:{b=232454;break}case -3:{b=232439;break}case -4:{b=232419;break}case -5:{b=232406;break}case -7:{b=232379;break}case -8:{b=232364;break}case -201:{b=232334;break}case -27:{b=232321;break}case -202:{b=232296;break}case -13:{b=232276;break}case -203:{b=232241;break}case -204:{b=232210;break}case -17:{b=232163;break}case -205:{b=232123;break}case -209:{b=232085;break}case -211:{b=232044;break}case -210:{b=231999;break}case -24:{b=231972;break}case -15:{b=231949;break}case -206:{b=231909;break}case -207:{b=231879;break}case -208:{b=231853;break}case -212:{b=231839;break}case -213:{b=231799;break}case -214:{b=231767;break}case -215:{b=231750;break}case -216:{b=231734;break}case -217:{b=231721;break}case -218:{b=231703;break}case -219:{b=231687;break}default:{k[c>>2]=(b|0)>-1?231655:231662;k[c+4>>2]=b;Cfb(1012371,231668,c);b=1012371}}while(0);d=k[a+16>>2]|0;i=a+28|0;if(!(k[i>>2]|0))c=232491;else{c=k[a+24>>2]|0;c=(c|0)==0?1016759:c}m=k[a+32>>2]|0;j=a+40|0;l=k[j>>2]|0;k[f>>2]=b;k[f+4>>2]=(d|0)==0?1016759:d;k[f+8>>2]=c;k[f+12>>2]=(m|0)==0?1016759:m;k[f+16>>2]=l;Cfb(e,232508,f);k[g>>2]=e;Zfb(165912,410544,g)|0;b=(k[41483]|0)>>>0>(k[41485]|0)>>>0;do if((k[41497]|0)>-1){if(b?(ci[k[165948>>2]&255](165912,0,0)|0,(k[41483]|0)==0):0)break;b=k[41479]|0;c=k[41480]|0;if(b>>>0<c>>>0)ci[k[165952>>2]&255](165912,b-c|0,1)|0;k[41482]=0;k[41485]=0;k[41483]=0;k[41480]=0;k[41479]=0}else{if(b?(ci[k[165948>>2]&255](165912,0,0)|0,(k[41483]|0)==0):0)break;b=k[41479]|0;c=k[41480]|0;if(b>>>0<c>>>0)ci[k[165952>>2]&255](165912,b-c|0,1)|0;k[41482]=0;k[41485]=0;k[41483]=0;k[41480]=0;k[41479]=0}while(0);c=te(44)|0;k[c>>2]=50052;b=k[a+4>>2]|0;k[c+4>>2]=b;k[c+8>>2]=k[a+8>>2];if(b|0){m=b+-4|0;k[m>>2]=(k[m>>2]|0)+1}k[c+12>>2]=k[h>>2];b=k[a+16>>2]|0;k[c+16>>2]=b;k[c+20>>2]=k[a+20>>2];if(b|0){m=b+-4|0;k[m>>2]=(k[m>>2]|0)+1}b=k[a+24>>2]|0;k[c+24>>2]=b;k[c+28>>2]=k[i>>2];if(b|0){m=b+-4|0;k[m>>2]=(k[m>>2]|0)+1}b=k[a+32>>2]|0;k[c+32>>2]=b;k[c+36>>2]=k[a+36>>2];if(!b){m=c+40|0;l=k[j>>2]|0;k[m>>2]=l;Cf(c|0,12696,57)}m=b+-4|0;k[m>>2]=(k[m>>2]|0)+1;m=c+40|0;l=k[j>>2]|0;k[m>>2]=l;Cf(c|0,12696,57)}function $8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+1168|0;q=y+1160|0;s=y+1048|0;v=y+16|0;t=y;w=v+8|0;k[v>>2]=w;x=v+4|0;k[x>>2]=1024;k[t>>2]=c;j=k[x>>2]|0;e=k[v>>2]|0;f=s;g=166024;h=f+112|0;do{k[f>>2]=k[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));if((j+-1|0)>>>0>2147483646)if(!j){e=q;d=1;u=6}else{if(!(k[206783]|0))d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}k[d>>2]=75;e=-1}else{d=j;u=6}if((u|0)==6){p=-2-e|0;p=d>>>0>p>>>0?p:d;k[s+48>>2]=p;f=s+20|0;k[f>>2]=e;k[s+44>>2]=e;e=e+p|0;d=s+16|0;k[d>>2]=e;k[s+28>>2]=e;e=mfb(s,b,t)|0;if(p){p=k[f>>2]|0;i[p+(((p|0)==(k[d>>2]|0))<<31>>31)>>0]=0}}if(!((e|0)>-1&(e|0)<(j|0))){l=s+48|0;m=s+20|0;n=s+44|0;o=s+16|0;p=s+28|0;do{f=j<<1;d=e+1|0;f=(f|0)<(d|0)?d:f;d=k[x>>2]|0;if(d>>>0<f>>>0){g=k[v>>2]|0;a:do if(f>>>0>1024)while(1){e=fgb(f)|0;if(e|0)break a;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break a}Qh[e&7]()}else e=w;while(0);k[v>>2]=e;k[x>>2]=f;if((d|0)!=0&(e|0)!=(g|0)){i[e>>0]=i[g>>0]|0;if((d|0)!=1){i[e+1>>0]=i[g+1>>0]|0;if((d|0)==2)d=2;else{e=2;do{i[(k[v>>2]|0)+e>>0]=i[g+e>>0]|0;e=e+1|0}while((e|0)!=(d|0))}}else d=1}do{i[(k[v>>2]|0)+d>>0]=0;d=d+1|0}while((d|0)!=(f|0));if(!((g|0)==(w|0)|(g|0)==0))ggb(g)}else k[x>>2]=f;k[t>>2]=c;j=k[x>>2]|0;d=k[v>>2]|0;f=s;g=166024;h=f+112|0;do{k[f>>2]=k[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));if((j+-1|0)>>>0>2147483646)if(!j){d=q;e=1;u=28}else{if(!(k[206783]|0))d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}k[d>>2]=75;e=-1}else{e=j;u=28}if((u|0)==28){u=0;h=-2-d|0;h=e>>>0>h>>>0?h:e;k[l>>2]=h;k[m>>2]=d;k[n>>2]=d;e=d+h|0;k[o>>2]=e;k[p>>2]=e;e=mfb(s,b,t)|0;if(h){h=k[m>>2]|0;i[h+(((h|0)==(k[o>>2]|0))<<31>>31)>>0]=0}}}while(!((e|0)>-1&(e|0)<(j|0)))}d=k[v>>2]|0;k[a>>2]=0;f=a+4|0;k[f>>2]=0;if(e){u=ZT(e+8&-4)|0;k[u>>2]=1;u=u+4|0;k[a>>2]=u;k[f>>2]=e;i[u+e>>0]=0;upb(u|0,d|0,e|0)|0;d=k[v>>2]|0}if((d|0)==(w|0)){r=y;return}if(d|0)ggb(d);k[v>>2]=w;k[x>>2]=1024;r=y;return}function a9(){var a=0;a=b9()|0;k[107586]=a;zpb(430348,0,260)|0;return}function b9(){var a=0,b=0,c=0,d=0;d=r;r=r+16|0;c=d;a=k[107652]|0;if(a|0){c=a;r=d;return c|0}while(1){a=fgb(4)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}yf(c|0)|0;xf(c|0,1)|0;Jf(b|0,c|0)|0;gf(c|0)|0;k[b+28>>2]=1;k[a>>2]=b;k[107652]=a;c=a;r=d;return c|0}function c9(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+16|0;l=p;if(k[107654]|0){o=k[107654]|0;r=p;return o|0}o=b9()|0;mpb(k[o>>2]|0)|0;if(!(k[107654]|0)){while(1){a=fgb(8)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[a>>2]=50072;f=d9()|0;m=f+4|0;mpb(k[m>>2]|0)|0;g=f+8|0;j=f+12|0;b=k[j>>2]|0;c=k[g>>2]|0;h=c;i=b;a:do if((b|0)==(c|0))n=11;else{e=b-c>>2;b=0;while(1){d=h+(b<<2)|0;if(!(k[d>>2]|0))break;b=b+1|0;if(b>>>0>=e>>>0){n=11;break a}}k[d>>2]=1}while(0);if((n|0)==11){k[l>>2]=1;if((i|0)==(k[f+16>>2]|0)){Q4(g,l);c=k[g>>2]|0;b=k[j>>2]|0}else{k[i>>2]=1;b=i+4|0;k[j>>2]=b}b=(b-c>>2)+-1|0}lpb(k[m>>2]|0)|0;k[a+4>>2]=b;k[a>>2]=50096;k[107654]=a}lpb(k[o>>2]|0)|0;o=k[107654]|0;r=p;return o|0}function d9(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;f=j;if(k[107653]|0){h=k[107653]|0;r=j;return h|0}h=b9()|0;mpb(k[h>>2]|0)|0;if(!(k[107653]|0)){while(1){a=fgb(32)|0;if(a|0){g=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){g=0;break}Qh[a&7]()}if(He(g|0,0)|0){k[f>>2]=0;a=f+4|0;k[a>>2]=0;b=ZT(44)|0;k[b>>2]=1;c=b+4|0;k[f>>2]=c;k[a>>2]=38;i[b+42>>0]=0;d=232764;e=c+38|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,f,232803,231590,986);k[a>>2]=0;k[f>>2]=0;e=k[b>>2]|0;k[b>>2]=e+-1;if((e|0)==1)ggb(k[b+-4>>2]|0)}b=g+4|0;while(1){a=fgb(32)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}yf(f|0)|0;xf(f|0,1)|0;Jf(a|0,f|0)|0;gf(f|0)|0;k[a+28>>2]=1;k[b>>2]=a;b=g+8|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;while(1){a=fgb(128)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}f=a;k[b>>2]=f;k[g+12>>2]=f;k[g+16>>2]=a+128;while(1){a=fgb(128)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}f=a;k[g+20>>2]=f;k[g+24>>2]=f;k[g+28>>2]=a+128;k[107653]=g}lpb(k[h>>2]|0)|0;h=k[107653]|0;r=j;return h|0}function e9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>2;c=g+1|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>1;f=e>>2>>>0<536870911?(f>>>0<c>>>0?c:f):1073741823;if(!f)c=0;else{if(f>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<2)|0;k[e>>2]=k[b>>2];d=e+(0-g<<2)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+4;k[l>>2]=c+(f<<2);if(!i)return;ggb(i);return}function f9(a){a=a|0;k[a>>2]=50096;j9(a);W8(a);return}function g9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;f=r;r=r+16|0;b=f;k[a>>2]=50096;j9(a);k[a>>2]=50072;if((k[a+4>>2]|0)==-1){ggb(a);r=f;return}k[b>>2]=0;c=b+4|0;k[c>>2]=0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[b>>2]=e;k[c>>2]=10;i[d+14>>0]=0;g=231561;h=e+10|0;do{i[e>>0]=i[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Y8(-215,b,231572,231590,1172);k[c>>2]=0;k[b>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);ggb(a);r=f;return}function h9(a){a=a|0;var b=0;while(1){a=fgb(24)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}b=a;k[b>>2]=-1;k[b+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=-1;k[a+20>>2]=-1;return a|0}function i9(a,b){a=a|0;b=b|0;var c=0;if(!b)return;a=k[b+12>>2]|0;if(a|0?(c=k[a>>2]|0,k[a>>2]=c+-1,(c|0)==1):0)ggb(a);ggb(b);return}function j9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+32|0;h=u+16|0;q=u;k[q>>2]=0;t=q+4|0;k[t>>2]=0;k[q+8>>2]=0;while(1){b=fgb(128)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}n=q+8|0;g=b;k[q>>2]=g;k[t>>2]=g;k[n>>2]=b+128;g=d9()|0;s=a+4|0;j=k[s>>2]|0;l=g+4|0;mpb(k[l>>2]|0)|0;m=g+8|0;if((k[g+12>>2]|0)-(k[m>>2]|0)>>2>>>0<=j>>>0){k[h>>2]=0;b=h+4|0;k[b>>2]=0;c=ZT(32)|0;k[c>>2]=1;d=c+4|0;k[h>>2]=d;k[b>>2]=25;i[c+29>>0]=0;e=232730;f=d+25|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,h,232818,231590,1084);k[b>>2]=0;k[h>>2]=0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0)}h=g+20|0;f=g+24|0;c=k[f>>2]|0;b=k[h>>2]|0;if((c|0)!=(b|0)){e=0;do{g=k[b+(e<<2)>>2]|0;d=k[g>>2]|0;if((k[g+4>>2]|0)-d>>2>>>0>j>>>0?(o=d+(j<<2)|0,g=k[o>>2]|0,p=g,(g|0)!=0):0){b=k[t>>2]|0;if((b|0)==(k[n>>2]|0))e9(q,o);else{k[b>>2]=p;k[t>>2]=b+4}k[(k[k[(k[h>>2]|0)+(e<<2)>>2]>>2]|0)+(j<<2)>>2]=0;b=k[h>>2]|0;c=k[f>>2]|0}e=e+1|0}while(e>>>0<c-b>>2>>>0)}k[(k[m>>2]|0)+(j<<2)>>2]=0;lpb(k[l>>2]|0)|0;b=k[t>>2]|0;d=k[q>>2]|0;e=d;if((b|0)!=(d|0)){c=0;do{jh[k[(k[a>>2]|0)+12>>2]&1023](a,k[e+(c<<2)>>2]|0);c=c+1|0}while(c>>>0<b-d>>2>>>0)}k[s>>2]=-1;if(!d){r=u;return}if((b|0)!=(e|0))k[t>>2]=b+(~((b+-4-d|0)>>>2)<<2);ggb(d);r=u;return}function k9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+48|0;v=x+24|0;t=x+16|0;s=x+8|0;q=x;o=x+32|0;g=Ce(232863)|0;if((g|0)!=0?(b=i[g>>0]|0,b<<24>>24!=0):0){e=g;a:do if(!(e&3)){b=g;u=8}else{d=g;c=b;b=e;while(1){if(!(c<<24>>24))break a;c=d+1|0;b=c;if(!(b&3)){b=c;u=8;break a}d=c;c=i[c>>0]|0}}while(0);if((u|0)==8){while(1){c=k[b>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))b=b+4|0;else break}if((c&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}d=b-e|0;f=ZT(d+8&-4)|0;k[f>>2]=1;c=f+4|0;i[c+d>>0]=0;upb(c|0,g|0,d|0)|0;switch(i[c+(d+-1)>>0]|0){case 92:case 47:break;default:{g=d+1|0;b=ZT(d+9&-4)|0;k[b>>2]=1;h=b+4|0;e=h;i[h+g>>0]=0;upb(h|0,c|0,d|0)|0;i[h+d>>0]=47;h=k[f>>2]|0;k[f>>2]=h+-1;if((h|0)==1)ggb(k[f+-4>>2]|0);k[b>>2]=(k[b>>2]|0)+1;h=k[b>>2]|0;k[b>>2]=h+-1;if((h|0)==1){ggb(k[b+-4>>2]|0);c=e;d=g}else{c=e;d=g}}}h=d+20|0;g=ZT(d+28&-4)|0;k[g>>2]=1;e=g+4|0;b=e;i[e+h>>0]=0;upb(e|0,c|0,d|0)|0;d=e+d|0;e=232906;f=d+20|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));e=c+-4|0;f=k[e>>2]|0;k[e>>2]=f+-1;if((f|0)==1)ggb(k[c+-8>>2]|0);k[g>>2]=(k[g>>2]|0)+1;f=k[g>>2]|0;k[g>>2]=f+-1;if((f|0)==1)ggb(k[g+-4>>2]|0)}else{e=ZT(32)|0;k[e>>2]=1;d=e+4|0;b=d;i[e+29>>0]=0;e=232880;f=d+25|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));h=25}g=b;b:do if(!(b&3)){c=g;u=25}else{d=g;c=b;while(1){if(!(i[d>>0]|0))break b;d=d+1|0;c=d;if(!(c&3)){c=d;u=25;break}}}while(0);if((u|0)==25){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}c=c-b|0;do if((((((c>>>0>=6?(p=g+c+-6|0,(i[p>>0]|0)==88):0)?(j=p+1|0,(i[j>>0]|0)==88):0)?(l=j+1|0,(i[l>>0]|0)==88):0)?(m=l+1|0,(i[m>>0]|0)==88):0)?(n=m+1|0,(i[n>>0]|0)==88):0)?(i[n+1>>0]|0)==88:0){e=o+4|0;f=(o>>>4)+p|0;d=100;while(1){xe(0,o|0)|0;c=(k[e>>2]|0)*65537^f;i[p>>0]=(c&15)+65|c<<1&32;n=c>>>5;i[p+1>>0]=(n&15)+65|n<<1&32;n=c>>>10;i[p+2>>0]=(n&15)+65|n<<1&32;n=c>>>15;i[p+3>>0]=(n&15)+65|n<<1&32;n=c>>>20;i[p+4>>0]=(n&15)+65|n<<1&32;c=c>>>25;i[p+5>>0]=(c&15)+65|c<<1&32;k[q>>2]=384;c=yfb(g,194,q)|0;if((c|0)>-1)break;d=d+-1|0;if(!d){u=42;break}if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}if((k[c>>2]|0)!=17){u=42;break}}if((u|0)==42){i[p>>0]=i[423550]|0;i[p+1>>0]=i[423551]|0;i[p+2>>0]=i[423552]|0;i[p+3>>0]=i[423553]|0;i[p+4>>0]=i[423554]|0;i[p+5>>0]=i[423555]|0;u=43;break}k[s>>2]=c;c=ee(6,s|0)|0;c=(c|0)==-4?-115:c;if(c>>>0>4294963200){if(!(k[206783]|0))d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}k[d>>2]=0-c}k[t>>2]=g;e=_d(10,t|0)|0;if(e>>>0<=4294963200){if(e|0){c=k[206783]|0;u=54}}else{c=k[206783]|0;if(!c)d=827176;else{d=(Fpb()|0)+64|0;d=k[d>>2]|0}k[d>>2]=0-e;u=54}if((u|0)==54){if(!c)c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}if((k[c>>2]|0)==21?(k[v>>2]=g,w=_e(40,v|0)|0,w>>>0>4294963200):0){if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=0-w}}k[a>>2]=b;k[a+4>>2]=h;a=b+-4|0;k[a>>2]=(k[a>>2]|0)+1}else u=34;while(0);if((u|0)==34){if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=22;u=43}if((u|0)==43){k[a>>2]=0;k[a+4>>2]=0}w=b+-4|0;a=k[w>>2]|0;k[w>>2]=a+-1;if((a|0)!=1){r=x;return}ggb(k[b+-8>>2]|0);r=x;return}function l9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+80|0;j=n+24|0;l=n+16|0;m=n+8|0;k[l>>2]=0;f=l+4|0;k[f>>2]=0;if(b|0){g=b;a:do if(!(g&3)){d=b;h=5}else{e=b;d=g;while(1){if(!(i[e>>0]|0))break a;e=e+1|0;d=e;if(!(d&3)){d=e;h=5;break}}}while(0);if((h|0)==5){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}g=d-g|0;e=ZT(g+8&-4)|0;k[e>>2]=1;e=e+4|0;k[l>>2]=e;k[f>>2]=g;i[e+g>>0]=0;upb(e|0,b|0,g|0)|0}k[m>>2]=0;b=m+4|0;k[b>>2]=0;if(a|0){f=a;b:do if(!(f&3)){d=a;h=15}else{d=a;e=f;while(1){if(!(i[d>>0]|0)){d=e;break b}d=d+1|0;e=d;if(!(e&3)){h=15;break}}}while(0);if((h|0)==15){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}h=d-f|0;g=ZT(h+8&-4)|0;k[g>>2]=1;g=g+4|0;k[m>>2]=g;k[b>>2]=h;i[g+h>>0]=0;upb(g|0,a|0,h|0)|0}k[n>>2]=0;b=n+4|0;k[b>>2]=0;e=ZT(76)|0;k[e>>2]=1;d=e+4|0;k[n>>2]=d;k[b>>2]=69;i[e+73>>0]=0;e=221854;b=d+69|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(b|0));Z8(j,-212,l,m,n,c);_8(j)}function m9(a){a=a|0;var b=0,c=0,d=0;d=r;r=r+16|0;c=d;while(1){b=fgb(32)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}yf(c|0)|0;xf(c|0,1)|0;Jf(b|0,c|0)|0;gf(c|0)|0;k[b+28>>2]=1;k[a>>2]=b;r=d;return}function n9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+16|0;t=u;d=d9()|0;h=a+4|0;g=k[h>>2]|0;if((k[d+12>>2]|0)-(k[d+8>>2]|0)>>2>>>0<=g>>>0){b=t+4|0;c=ZT(32)|0;k[c>>2]=1;j=c+4|0;k[t>>2]=j;k[b>>2]=25;i[c+29>>0]=0;l=232730;m=j+25|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,t,232756,231590,1102);k[b>>2]=0;k[t>>2]=0;s=k[c>>2]|0;k[c>>2]=s+-1;if((s|0)==1)ggb(k[c+-4>>2]|0)}b=Ue(k[d>>2]|0)|0;if((b|0?(e=k[b>>2]|0,(k[b+4>>2]|0)-e>>2>>>0>g>>>0):0)?(f=k[e+(g<<2)>>2]|0,f|0):0){t=f;r=u;return t|0}s=Xh[k[(k[a>>2]|0)+8>>2]&1023](a)|0;p=d9()|0;q=k[h>>2]|0;if(!(s|0?(k[p+12>>2]|0)-(k[p+8>>2]|0)>>2>>>0>q>>>0:0)){b=t+4|0;c=ZT(48)|0;k[c>>2]=1;j=c+4|0;k[t>>2]=j;k[b>>2]=42;i[c+46>>0]=0;l=232639;m=j+42|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,t,362333,231590,1128);k[b>>2]=0;k[t>>2]=0;o=k[c>>2]|0;k[c>>2]=o+-1;if((o|0)==1)ggb(k[c+-4>>2]|0)}b=Ue(k[p>>2]|0)|0;c=b;if(!b){while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;while(1){c=fgb(128)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}o=c;k[b>>2]=o;k[b+4>>2]=o;k[b+8>>2]=c+128;c=b;if(zf(k[p>>2]|0,b|0)|0){d=t+4|0;a=ZT(44)|0;k[a>>2]=1;j=a+4|0;k[t>>2]=j;k[d>>2]=39;i[a+43>>0]=0;l=232682;m=j+39|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,t,232722,231590,998);k[d>>2]=0;k[t>>2]=0;o=k[a>>2]|0;k[a>>2]=o+-1;if((o|0)==1)ggb(k[a+-4>>2]|0)}h=p+4|0;mpb(k[h>>2]|0)|0;j=p+20|0;l=p+24|0;d=k[l>>2]|0;m=k[j>>2]|0;n=d-m|0;g=n>>2;k[b+12>>2]=g;o=p+28|0;f=k[o>>2]|0;a=f;if((d|0)==(f|0)){d=g+1|0;if(d>>>0>1073741823)ad(426534,426557,304,426811);e=a-m|0;f=e>>1;f=e>>2>>>0<536870911?(f>>>0<d>>>0?d:f):1073741823;if(!f)d=0;else{if(f>>>0>1073741823){u=te(4)|0;k[u>>2]=172664;Cf(u|0,28816,1287)}a=f<<2;a=(a|0)==0?1:a;while(1){d=fgb(a)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}}e=d+(g<<2)|0;k[e>>2]=c;a=e+(0-g<<2)|0;if((n|0)>0)upb(a|0,m|0,n|0)|0;k[j>>2]=a;k[l>>2]=e+4;k[o>>2]=d+(f<<2);if(m|0)ggb(m)}else{k[d>>2]=c;k[l>>2]=(k[l>>2]|0)+4}lpb(k[h>>2]|0)|0}if((k[b+4>>2]|0)-(k[b>>2]|0)>>2>>>0<=q>>>0){e=p+4|0;mpb(k[e>>2]|0)|0;b=c;f=b+4|0;d=k[f>>2]|0;a=c;if(d-(k[a>>2]|0)>>2>>>0<=q>>>0){c=d;do{k[t>>2]=0;if((c|0)==(k[b+8>>2]|0)){e9(b,t);c=k[f>>2]|0}else{k[c>>2]=0;c=(k[f>>2]|0)+4|0;k[f>>2]=c}}while(c-(k[a>>2]|0)>>2>>>0<=q>>>0)}lpb(k[e>>2]|0)|0}k[(k[b>>2]|0)+(q<<2)>>2]=s;t=s;r=u;return t|0}function o9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=a+8|0;e=k[l>>2]|0;m=a+4|0;c=k[m>>2]|0;d=c;if(e-c>>3>>>0>=b>>>0){zpb(c|0,0,b<<3|0)|0;k[m>>2]=d+(b<<3);return}j=k[a>>2]|0;g=c-j>>3;c=g+b|0;if(c>>>0>536870911)ad(426534,426557,304,426811);i=j;h=e-j|0;f=h>>2;f=h>>3>>>0<268435455?(f>>>0<c>>>0?c:f):536870911;if(!f)e=0;else{if(f>>>0>536870911){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}e=f<<3;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=c}c=e+(g<<3)|0;h=e+(f<<3)|0;zpb(c|0,0,b<<3|0)|0;g=c+(b<<3)|0;if((d|0)!=(i|0)){f=d+-8|0;e=c;do{b=e;e=e+-8|0;n=d;d=d+-8|0;k[e>>2]=k[d>>2];k[b+-4>>2]=k[n+-4>>2]}while((d|0)!=(i|0));c=c+(~((f-j|0)>>>3)<<3)|0}k[a>>2]=c;k[m>>2]=g;k[l>>2]=h;if(!j)return;ggb(j);return}function p9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+8|0;g=k[l>>2]|0;m=a+4|0;c=k[m>>2]|0;e=c;if(((g-c|0)/28|0)>>>0>=b>>>0){c=b;d=e;while(1){o[d>>2]=0.0;o[d+4>>2]=0.0;o[d+8>>2]=0.0;o[d+12>>2]=-1.0;o[d+16>>2]=0.0;k[d+20>>2]=0;k[d+24>>2]=-1;c=c+-1|0;if(!c)break;else d=d+28|0}k[m>>2]=e+(b*28|0);return}d=k[a>>2]|0;h=(c-d|0)/28|0;f=h+b|0;if(f>>>0>153391689)ad(426534,426557,304,426811);j=d;g=(g-d|0)/28|0;i=g<<1;i=g>>>0<76695844?(i>>>0<f>>>0?f:i):153391689;if(!i)g=0;else{if(i>>>0>153391689){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}f=i*28|0;f=(f|0)==0?1:f;while(1){d=fgb(f)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}g=d}h=g+(h*28|0)|0;d=b;f=h;while(1){o[f>>2]=0.0;o[f+4>>2]=0.0;o[f+8>>2]=0.0;o[f+12>>2]=-1.0;o[f+16>>2]=0.0;k[f+20>>2]=0;k[f+24>>2]=-1;d=d+-1|0;if(!d)break;else f=f+28|0}d=h;g=g+(i*28|0)|0;f=h+(b*28|0)|0;if((e|0)!=(j|0)){c=h;do{i=e;e=e+-28|0;k[c+-28>>2]=k[e>>2];k[c+-24>>2]=k[i+-24>>2];b=c+-20|0;i=i+-20|0;k[b>>2]=k[i>>2];k[b+4>>2]=k[i+4>>2];k[b+8>>2]=k[i+8>>2];k[b+12>>2]=k[i+12>>2];k[b+16>>2]=k[i+16>>2];c=d+-28|0;d=c}while((e|0)!=(j|0));c=k[a>>2]|0}k[a>>2]=d;k[m>>2]=f;k[l>>2]=g;if(!c)return;ggb(c);return}function q9(){m9(430620);m9(430624);m9(430628);m9(430632);m9(430636);m9(430640);m9(430644);m9(430648);m9(430652);m9(430656);m9(430660);m9(430664);m9(430668);m9(430672);m9(430676);m9(430680);m9(430684);m9(430688);m9(430692);m9(430696);m9(430700);m9(430704);m9(430708);m9(430712);m9(430716);m9(430720);m9(430724);m9(430728);m9(430732);m9(430736);m9(430740);ud(1455,0,x|0)|0;return}function r9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=(k[107685]|0)+28|0;a=k[u>>2]|0;k[u>>2]=a+-1;if((a|0)==1?(l=k[107685]|0,l|0):0){rf(l|0)|0;ggb(l)}k[107685]=0;l=(k[107684]|0)+28|0;u=k[l>>2]|0;k[l>>2]=u+-1;if((u|0)==1?(d=k[107684]|0,d|0):0){rf(d|0)|0;ggb(d)}k[107684]=0;l=(k[107683]|0)+28|0;u=k[l>>2]|0;k[l>>2]=u+-1;if((u|0)==1?(e=k[107683]|0,e|0):0){rf(e|0)|0;ggb(e)}k[107683]=0;l=(k[107682]|0)+28|0;u=k[l>>2]|0;k[l>>2]=u+-1;if((u|0)==1?(f=k[107682]|0,f|0):0){rf(f|0)|0;ggb(f)}k[107682]=0;l=(k[107681]|0)+28|0;u=k[l>>2]|0;k[l>>2]=u+-1;if((u|0)==1?(g=k[107681]|0,g|0):0){rf(g|0)|0;ggb(g)}k[107681]=0;l=(k[107680]|0)+28|0;u=k[l>>2]|0;k[l>>2]=u+-1;if((u|0)==1?(h=k[107680]|0,h|0):0){rf(h|0)|0;ggb(h)}k[107680]=0;l=(k[107679]|0)+28|0;u=k[l>>2]|0;k[l>>2]=u+-1;if((u|0)==1?(i=k[107679]|0,i|0):0){rf(i|0)|0;ggb(i)}k[107679]=0;l=(k[107678]|0)+28|0;u=k[l>>2]|0;k[l>>2]=u+-1;if((u|0)==1?(j=k[107678]|0,j|0):0){rf(j|0)|0;ggb(j)}k[107678]=0;l=(k[107677]|0)+28|0;u=k[l>>2]|0;k[l>>2]=u+-1;if((u|0)==1?(m=k[107677]|0,m|0):0){rf(m|0)|0;ggb(m)}k[107677]=0;m=(k[107676]|0)+28|0;u=k[m>>2]|0;k[m>>2]=u+-1;if((u|0)==1?(n=k[107676]|0,n|0):0){rf(n|0)|0;ggb(n)}k[107676]=0;n=(k[107675]|0)+28|0;u=k[n>>2]|0;k[n>>2]=u+-1;if((u|0)==1?(o=k[107675]|0,o|0):0){rf(o|0)|0;ggb(o)}k[107675]=0;o=(k[107674]|0)+28|0;u=k[o>>2]|0;k[o>>2]=u+-1;if((u|0)==1?(p=k[107674]|0,p|0):0){rf(p|0)|0;ggb(p)}k[107674]=0;p=(k[107673]|0)+28|0;u=k[p>>2]|0;k[p>>2]=u+-1;if((u|0)==1?(q=k[107673]|0,q|0):0){rf(q|0)|0;ggb(q)}k[107673]=0;q=(k[107672]|0)+28|0;u=k[q>>2]|0;k[q>>2]=u+-1;if((u|0)==1?(r=k[107672]|0,r|0):0){rf(r|0)|0;ggb(r)}k[107672]=0;r=(k[107671]|0)+28|0;u=k[r>>2]|0;k[r>>2]=u+-1;if((u|0)==1?(s=k[107671]|0,s|0):0){rf(s|0)|0;ggb(s)}k[107671]=0;s=(k[107670]|0)+28|0;u=k[s>>2]|0;k[s>>2]=u+-1;if((u|0)==1?(t=k[107670]|0,t|0):0){rf(t|0)|0;ggb(t)}k[107670]=0;t=(k[107669]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;if((u|0)==1?(b=k[107669]|0,b|0):0){rf(b|0)|0;ggb(b)}k[107669]=0;t=(k[107668]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;if((u|0)==1?(c=k[107668]|0,c|0):0){rf(c|0)|0;ggb(c)}k[107668]=0;t=(k[107667]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;do if((u|0)==1){a=k[107667]|0;if(!a)break;rf(a|0)|0;ggb(a)}while(0);k[107667]=0;t=(k[107666]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;do if((u|0)==1){a=k[107666]|0;if(!a)break;rf(a|0)|0;ggb(a)}while(0);k[107666]=0;t=(k[107665]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;do if((u|0)==1){a=k[107665]|0;if(!a)break;rf(a|0)|0;ggb(a)}while(0);k[107665]=0;t=(k[107664]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;do if((u|0)==1){a=k[107664]|0;if(!a)break;rf(a|0)|0;ggb(a)}while(0);k[107664]=0;t=(k[107663]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;do if((u|0)==1){a=k[107663]|0;if(!a)break;rf(a|0)|0;ggb(a)}while(0);k[107663]=0;t=(k[107662]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;do if((u|0)==1){a=k[107662]|0;if(!a)break;rf(a|0)|0;ggb(a)}while(0);k[107662]=0;t=(k[107661]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;do if((u|0)==1){a=k[107661]|0;if(!a)break;rf(a|0)|0;ggb(a)}while(0);k[107661]=0;t=(k[107660]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;do if((u|0)==1){a=k[107660]|0;if(!a)break;rf(a|0)|0;ggb(a)}while(0);k[107660]=0;t=(k[107659]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;do if((u|0)==1){a=k[107659]|0;if(!a)break;rf(a|0)|0;ggb(a)}while(0);k[107659]=0;t=(k[107658]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;do if((u|0)==1){a=k[107658]|0;if(!a)break;rf(a|0)|0;ggb(a)}while(0);k[107658]=0;t=(k[107657]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;do if((u|0)==1){a=k[107657]|0;if(!a)break;rf(a|0)|0;ggb(a)}while(0);k[107657]=0;t=(k[107656]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;do if((u|0)==1){a=k[107656]|0;if(!a)break;rf(a|0)|0;ggb(a)}while(0);k[107656]=0;t=(k[107655]|0)+28|0;u=k[t>>2]|0;k[t>>2]=u+-1;if((u|0)!=1){k[107655]=0;return}a=k[107655]|0;if(!a){k[107655]=0;return}rf(a|0)|0;ggb(a);k[107655]=0;return}function s9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+16|0;w=x;if(b>>>0>=33){f=w+4|0;g=ZT(40)|0;k[g>>2]=1;j=g+4|0;k[w>>2]=j;k[f>>2]=33;i[g+37>>0]=0;l=233146;m=j+33|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,w,233180,233080,182);k[f>>2]=0;k[w>>2]=0;v=k[g>>2]|0;k[g>>2]=v+-1;if((v|0)==1)ggb(k[g+-4>>2]|0)}v=a+4|0;if((k[v>>2]|0)!=(b|0)){f=a+36|0;g=k[f>>2]|0;h=a+40|0;if((g|0)!=(h|0)){if(g|0)ggb(k[g+-4>>2]|0);k[f>>2]=h;k[a+32>>2]=a+8}if((b|0)>2){t=ZT(b<<3|4)|0;k[f>>2]=t;t=t+(b<<2)+4|0;k[a+32>>2]=t;k[t+-4>>2]=b;k[a+12>>2]=-1;k[a+8>>2]=-1}}k[v>>2]=b;if(!c){r=x;return}p=k[a>>2]|0;p=(p>>>3&511)+1<<(47696>>>(p<<1&14)&3);h=b+-1|0;if((b|0)<=0){r=x;return}q=a+32|0;s=a+36|0;n=w+4|0;t=w+4|0;if(!d){f=p;while(1){g=k[c+(h<<2)>>2]|0;if((g|0)<=-1?(u=ZT(12)|0,k[u>>2]=1,o=u+4|0,k[w>>2]=o,k[t>>2]=6,i[u+10>>0]=0,i[o>>0]=i[233188]|0,i[o+1>>0]=i[233189]|0,i[o+2>>0]=i[233190]|0,i[o+3>>0]=i[233191]|0,i[o+4>>0]=i[233192]|0,i[o+5>>0]=i[233193]|0,Y8(-215,w,233180,233080,209),k[t>>2]=0,k[w>>2]=0,o=k[u>>2]|0,k[u>>2]=o+-1,(o|0)==1):0)ggb(k[u+-4>>2]|0);k[(k[q>>2]|0)+(h<<2)>>2]=g;if(e){k[(k[s>>2]|0)+(h<<2)>>2]=f;f=Epb(g|0,((g|0)<0)<<31>>31|0,f|0,0)|0;if(!((f|0)==(f|0)&(N|0)==0)){g=ZT(56)|0;k[g>>2]=1;j=g+4|0;k[w>>2]=j;k[n>>2]=51;i[g+55>>0]=0;l=233195;m=j+51|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-211,w,233180,233080,219);k[n>>2]=0;k[w>>2]=0;o=k[g>>2]|0;k[g>>2]=o+-1;if((o|0)==1)ggb(k[g+-4>>2]|0)}}if((h|0)>0)h=h+-1|0;else break}}else{g=h;while(1){f=k[c+(g<<2)>>2]|0;if((f|0)<=-1?(o=ZT(12)|0,k[o>>2]=1,u=o+4|0,k[w>>2]=u,k[t>>2]=6,i[o+10>>0]=0,i[u>>0]=i[233188]|0,i[u+1>>0]=i[233189]|0,i[u+2>>0]=i[233190]|0,i[u+3>>0]=i[233191]|0,i[u+4>>0]=i[233192]|0,i[u+5>>0]=i[233193]|0,Y8(-215,w,233180,233080,209),k[t>>2]=0,k[w>>2]=0,u=k[o>>2]|0,k[o>>2]=u+-1,(u|0)==1):0)ggb(k[o+-4>>2]|0);k[(k[q>>2]|0)+(g<<2)>>2]=f;if((g|0)<(h|0))f=k[d+(g<<2)>>2]|0;else f=p;k[(k[s>>2]|0)+(g<<2)>>2]=f;if((g|0)>0)g=g+-1|0;else break}}if((b|0)!=1){r=x;return}k[v>>2]=2;k[a+12>>2]=1;k[(k[s>>2]|0)+4>>2]=p;r=x;return}function t9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+192|0;z=I+136|0;s=I+128|0;t=I+120|0;C=I+64|0;v=I;u=I+48|0;k[z>>2]=1124007936;G=z+4|0;x=z+8|0;y=z+20|0;E=z+24|0;w=z+28|0;D=z+32|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;k[G+16>>2]=0;k[G+20>>2]=0;k[G+24>>2]=0;k[D>>2]=x;H=z+40|0;F=z+36|0;k[F>>2]=H;k[z+44>>2]=0;k[H>>2]=0;n=b+16|0;if(k[n>>2]|0){k[s>>2]=0;m=s+4|0;k[m>>2]=0;k[t>>2]=0;o=t+4|0;k[o>>2]=0;N1(b,s,t);p=k[b+12>>2]|0;q=k[b+8>>2]|0;do if(!(k[o>>2]|k[t>>2])){if((k[n>>2]|0)!=(k[b+20>>2]|0)){k[C>>2]=0;d=C+4|0;k[d>>2]=0;e=ZT(24)|0;k[e>>2]=1;j=e+4|0;k[C>>2]=j;k[d>>2]=17;i[e+21>>0]=0;l=233247;m=j+17|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,C,233265,233080,284);k[d>>2]=0;k[C>>2]=0;B=k[e>>2]|0;k[e>>2]=B+-1;if((B|0)==1)ggb(k[e+-4>>2]|0)}d=c|50331648;B=k[b+32>>2]|0;f=B1()|0;B=(B|0)==0?f:B;f=b+4|0;g=b+40|0;h=b+44|0;n=si[k[(k[B>>2]|0)+8>>2]&15](B,k[f>>2]|0,k[g>>2]|0,k[b>>2]&4095,k[n>>2]|0,k[h>>2]|0,d,0)|0;B=B1()|0;if(!(Dg[k[(k[B>>2]|0)+12>>2]&127](B,n,d,0)|0)?(B=B1()|0,!(Dg[k[(k[B>>2]|0)+12>>2]&127](B,n,d,0)|0)):0){k[C>>2]=0;d=C+4|0;k[d>>2]=0;e=ZT(16)|0;k[e>>2]=1;j=e+4|0;k[C>>2]=j;k[d>>2]=9;i[e+13>>0]=0;l=233273;m=j+9|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,C,233265,233080,306);k[d>>2]=0;k[C>>2]=0;C=k[e>>2]|0;k[e>>2]=C+-1;if((C|0)==1)ggb(k[e+-4>>2]|0)}d=b+36|0;e=k[d>>2]|0;if(e|0){k[n+48>>2]=e;C=e+12|0;k[C>>2]=(k[C>>2]|0)+1;C=(k[d>>2]|0)+8|0;k[C>>2]=(k[C>>2]|0)+1}k[z>>2]=k[b>>2];s9(z,k[f>>2]|0,k[g>>2]|0,k[h>>2]|0,0);d=k[G>>2]|0;j=k[D>>2]|0;a:do if((d|0)>0){e=0;do{if((k[j+(e<<2)>>2]|0)>1)break a;e=e+1|0}while((e|0)<(d|0))}else e=0;while(0);h=k[F>>2]|0;f=d;do{g=f;f=f+-1|0;if((f|0)<=(e|0))break;C=aa(k[j+(f<<2)>>2]|0,k[h+(f<<2)>>2]|0)|0}while(C>>>0>=(k[h+(g+-2<<2)>>2]|0)>>>0);b=k[j>>2]|0;b=Epb(b|0,((b|0)<0)<<31>>31|0,k[h>>2]|0,0)|0;C=k[z>>2]|0;e=(f|0)<=(e|0)&((b|0)==(b|0)&(N|0)==0)?C|16384:C&-16385;k[z>>2]=e;if((d|0)>2){k[z+12>>2]=-1;k[x>>2]=-1}k[E>>2]=n;k[w>>2]=0;if(!n){g=0;f=0}else{e=n+8|0;k[e>>2]=(k[e>>2]|0)+1;e=k[z>>2]|0;d=k[G>>2]|0;g=k[E>>2]|0;f=k[w>>2]|0}k[a>>2]=e;l=a+4|0;k[l>>2]=d;C=a+8|0;k[C>>2]=k[x>>2];k[a+12>>2]=k[z+12>>2];k[a+16>>2]=k[z+16>>2];k[a+20>>2]=k[y>>2];k[a+24>>2]=g;k[a+28>>2]=f;e=a+32|0;k[e>>2]=C;C=a+40|0;j=a+36|0;k[j>>2]=C;k[a+44>>2]=0;k[C>>2]=0;if(g){d=g+8|0;k[d>>2]=(k[d>>2]|0)+1;d=k[G>>2]|0}if((d|0)<3){C=k[F>>2]|0;a=k[j>>2]|0;k[a>>2]=k[C>>2];k[a+4>>2]=k[C+4>>2];break}k[l>>2]=0;s9(a,d,0,0,0);if((k[l>>2]|0)>0){h=k[D>>2]|0;f=k[e>>2]|0;g=k[F>>2]|0;e=k[j>>2]|0;d=0;do{k[f+(d<<2)>>2]=k[h+(d<<2)>>2];k[e+(d<<2)>>2]=k[g+(d<<2)>>2];d=d+1|0}while((d|0)<(k[l>>2]|0))}}else{k[C>>2]=k[b>>2];A=C+4|0;f=b+4|0;d=k[f>>2]|0;k[A>>2]=d;j=C+8|0;k[j>>2]=q;l=C+12|0;k[l>>2]=p;y=C+16|0;k[y>>2]=k[n>>2];k[C+20>>2]=k[b+20>>2];k[C+24>>2]=k[b+24>>2];k[C+28>>2]=k[b+28>>2];n=C+32|0;k[n>>2]=k[b+32>>2];w=C+36|0;e=k[b+36>>2]|0;k[w>>2]=e;x=C+40|0;k[x>>2]=j;B=C+48|0;z=C+44|0;k[z>>2]=B;k[C+52>>2]=0;k[B>>2]=0;if(e){d=e+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[f>>2]|0}if((d|0)>=3){k[A>>2]=0;x1(C,d,0,0,0);if((k[A>>2]|0)>0){g=k[b+40>>2]|0;h=k[x>>2]|0;e=k[b+44>>2]|0;f=k[z>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[g+(d<<2)>>2];k[f+(d<<2)>>2]=k[e+(d<<2)>>2];d=d+1|0}while((d|0)<(k[A>>2]|0))}}else{h=k[b+44>>2]|0;b=k[z>>2]|0;k[b>>2]=k[h>>2];k[b+4>>2]=k[h+4>>2]}g=k[o>>2]|0;d=k[t>>2]|0;O1(C,g,(k[m>>2]|0)-g-(k[j>>2]|0)|0,d,(k[s>>2]|0)-d-(k[l>>2]|0)|0);t9(v,C,c);k[u>>2]=d;k[u+4>>2]=g;k[u+8>>2]=p;k[u+12>>2]=q;u9(a,v,u);g=v+24|0;d=k[g>>2]|0;if(d|0?(C=d+8|0,a=k[C>>2]|0,k[C>>2]=a+-1,(a|0)==1):0){a=k[g>>2]|0;C=k[a+4>>2]|0;jh[k[(k[C>>2]|0)+16>>2]&1023](C,a);k[g>>2]=0}e=v+4|0;if((k[e>>2]|0)>0){f=k[v+32>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}k[g>>2]=0;d=k[v+36>>2]|0;if(!((d|0)==(v+40|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[w>>2]|0;if(d|0?(C=d+12|0,a=k[C>>2]|0,k[C>>2]=a+-1,(a|0)==1):0){e=k[w>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[n>>2]|0;if(!d){d=B1()|0;e=k[w>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[w>>2]=0}k[w>>2]=0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[A>>2]|0)>0){e=k[x>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[A>>2]|0))}d=k[z>>2]|0;if(!((d|0)==(B|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}while(0);d=k[E>>2]|0;if(d|0?(C=d+8|0,a=k[C>>2]|0,k[C>>2]=a+-1,(a|0)==1):0){a=k[E>>2]|0;C=k[a+4>>2]|0;jh[k[(k[C>>2]|0)+16>>2]&1023](C,a);k[E>>2]=0}}else{k[a>>2]=1124007936;C=a+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;k[C+16>>2]=0;k[C+20>>2]=0;k[C+24>>2]=0;k[a+32>>2]=a+8;C=a+40|0;k[a+36>>2]=C;k[C>>2]=0;k[a+44>>2]=0}if((k[G>>2]|0)>0){e=k[D>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[G>>2]|0))}k[E>>2]=0;d=k[F>>2]|0;if((d|0)==(H|0)|(d|0)==0){r=I;return}ggb(k[d+-4>>2]|0);r=I;return}function u9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+16|0;p=A;d=k[b>>2]|0;k[a>>2]=d;x=a+4|0;k[x>>2]=2;y=a+8|0;u=c+12|0;k[y>>2]=k[u>>2];z=a+12|0;q=c+8|0;k[z>>2]=k[q>>2];k[a+16>>2]=k[b+16>>2];k[a+20>>2]=k[b+20>>2];w=a+24|0;k[w>>2]=k[b+24>>2];m=a+28|0;n=c+4|0;s=b+36|0;e=(aa(k[k[s>>2]>>2]|0,k[n>>2]|0)|0)+(k[b+28>>2]|0)|0;k[m>>2]=e;v=a+32|0;k[v>>2]=y;l=a+40|0;t=a+36|0;k[t>>2]=l;k[a+44>>2]=0;k[l>>2]=0;if((k[b+4>>2]|0)>=3){d=p+4|0;e=ZT(16)|0;k[e>>2]=1;f=e+4|0;k[p>>2]=f;k[d>>2]=11;i[e+15>>0]=0;g=233283;h=f+11|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,p,233295,233080,454);k[d>>2]=0;k[p>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0);d=k[a>>2]|0;e=k[m>>2]|0}g=k[q>>2]|0;l=b+12|0;h=k[l>>2]|0;f=k[u>>2]|0;k[a>>2]=((f|0)==1?16384:0)|((g|0)<(h|0)?-16385:-1)&d;j=(d>>>3&511)+1<<(47696>>>(d<<1&14)&3);c=k[c>>2]|0;e=(aa(j,c)|0)+e|0;k[m>>2]=e;if(!((!((c|g|0)<0|(g+c|0)>(h|0))?(o=k[n>>2]|0,(o|f|0)>-1):0)?(f+o|0)<=(k[b+8>>2]|0):0)){d=p+4|0;e=ZT(132)|0;k[e>>2]=1;f=e+4|0;k[p>>2]=f;k[d>>2]=124;i[e+128>>0]=0;g=233300;h=f+124|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,p,233295,233080,461);k[d>>2]=0;k[p>>2]=0;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0)}d=k[w>>2]|0;if(d|0){p=d+8|0;k[p>>2]=(k[p>>2]|0)+1}if(!((k[q>>2]|0)>=(k[l>>2]|0)?(k[u>>2]|0)>=(k[b+8>>2]|0):0))k[a>>2]=k[a>>2]|32768;u=k[t>>2]|0;k[u>>2]=k[k[s>>2]>>2];k[u+4>>2]=j;if((k[y>>2]|0)>=1?(k[z>>2]|0)>=1:0){r=A;return}d=k[w>>2]|0;if(d|0?(t=d+8|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){u=k[w>>2]|0;t=k[u+4>>2]|0;jh[k[(k[t>>2]|0)+16>>2]&1023](t,u);k[w>>2]=0}if((k[x>>2]|0)>0){e=k[v>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[x>>2]|0))}k[w>>2]=0;k[z>>2]=0;k[y>>2]=0;r=A;return}function v9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+16|0;p=s;n=a+20|0;k[n>>2]=0;if(!(b>>>0<33&(c|0)!=0)){e=p+4|0;f=ZT(40)|0;k[f>>2]=1;g=f+4|0;k[p>>2]=g;k[e>>2]=35;i[f+39>>0]=0;j=233425;l=g+35|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-215,p,389997,233080,334);k[e>>2]=0;k[p>>2]=0;q=k[f>>2]|0;k[f>>2]=q+-1;if((q|0)==1)ggb(k[f+-4>>2]|0)}g=d&4095;q=a+24|0;f=k[q>>2]|0;o=a+4|0;if(f|0){l=k[o>>2]|0;if(!((l|0)!=(b|0)?!((b|0)==1&(l|0)<3):0))h=8;if((h|0)==8?(g|0)==(k[a>>2]&4095|0):0){if((b|0)==2)if((k[a+8>>2]|0)==(k[c>>2]|0)?(k[a+12>>2]|0)==(k[c+4>>2]|0):0){r=s;return}else h=13;else if((b|0)>0)h=13;else d=0;a:do if((h|0)==13){e=k[a+32>>2]|0;d=0;do{if((k[e+(d<<2)>>2]|0)!=(k[c+(d<<2)>>2]|0))break a;d=d+1|0}while((d|0)<(b|0))}while(0);if((d|0)==(b|0)){if((b|0)>1){r=s;return}if((k[(k[a+32>>2]|0)+4>>2]|0)==1){r=s;return}}}j=f+8|0;l=k[j>>2]|0;k[j>>2]=l+-1;if((l|0)==1){l=k[q>>2]|0;j=k[l+4>>2]|0;jh[k[(k[j>>2]|0)+16>>2]&1023](j,l);k[q>>2]=0}}if((k[o>>2]|0)>0){e=k[a+32>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[o>>2]|0))}k[q>>2]=0;if(!b){r=s;return}k[a>>2]=g|1124007936;s9(a,b,c,0,1);k[a+28>>2]=0;j=k[o>>2]|0;if((j|0)<3)d=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{f=k[a+32>>2]|0;e=0;d=1;do{d=aa(k[f+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(j|0))}if(d){d=k[a+16>>2]|0;e=B1()|0;if(!d)B1()|0;else e=d;d=a+32|0;f=a+36|0;n=si[k[(k[e>>2]|0)+8>>2]&15](e,k[o>>2]|0,k[d>>2]|0,g,0,k[f>>2]|0,0,k[n>>2]|0)|0;k[q>>2]=n;if((n|0)==0?(k[p>>2]=0,n=p+4|0,k[n>>2]=0,m=ZT(12)|0,k[m>>2]=1,c=m+4|0,k[p>>2]=c,k[n>>2]=6,i[m+10>>0]=0,i[c>>0]=i[233461]|0,i[c+1>>0]=i[233462]|0,i[c+2>>0]=i[233463]|0,i[c+3>>0]=i[233464]|0,i[c+4>>0]=i[233465]|0,i[c+5>>0]=i[233466]|0,Y8(-215,p,389997,233080,366),k[n>>2]=0,k[p>>2]=0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0)ggb(k[m+-4>>2]|0);e=k[o>>2]|0;n=k[a>>2]|0;if((k[(k[f>>2]|0)+(e+-1<<2)>>2]|0)==((n>>>3&511)+1<<(47696>>>(n<<1&14)&3)|0))j=e;else{e=p+4|0;f=ZT(48)|0;k[f>>2]=1;g=f+4|0;k[p>>2]=g;k[e>>2]=43;i[f+47>>0]=0;j=233468;l=g+43|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-215,p,389997,233080,374);k[e>>2]=0;k[p>>2]=0;p=k[f>>2]|0;k[f>>2]=p+-1;if((p|0)==1)ggb(k[f+-4>>2]|0);j=k[o>>2]|0}}else d=a+32|0;h=k[d>>2]|0;b:do if((j|0)>0){d=0;do{if((k[h+(d<<2)>>2]|0)>1)break b;d=d+1|0}while((d|0)<(j|0))}else d=0;while(0);g=k[a+36>>2]|0;e=j;do{f=e;e=e+-1|0;if((e|0)<=(d|0))break;p=aa(k[h+(e<<2)>>2]|0,k[g+(e<<2)>>2]|0)|0}while(p>>>0>=(k[g+(f+-2<<2)>>2]|0)>>>0);o=k[h>>2]|0;o=Epb(o|0,((o|0)<0)<<31>>31|0,k[g>>2]|0,0)|0;p=k[a>>2]|0;k[a>>2]=(e|0)<=(d|0)&((o|0)==(o|0)&(N|0)==0)?p|16384:p&-16385;if((j|0)>2){k[a+12>>2]=-1;k[a+8>>2]=-1}d=k[q>>2]|0;if(!d){r=s;return}a=d+8|0;k[a>>2]=(k[a>>2]|0)+1;r=s;return}function w9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;w=r;r=r+448|0;u=w+312|0;l=w+184|0;o=w+56|0;v=w;h=S1(b,-1)|0;if((k[b>>2]|0)<0?(d=k[a>>2]|0,(h|0)!=(d&4095|0)):0){if((d^h)&4088){c=u+4|0;d=ZT(36)|0;k[d>>2]=1;e=d+4|0;k[u>>2]=e;k[c>>2]=30;i[d+34>>0]=0;f=233512;g=e+30|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,u,233543,233080,771);k[c>>2]=0;k[u>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0);d=k[a>>2]|0}if((h|0)<0)if((k[b>>2]|0)<0)c=S1(b,-1)|0;else c=d&4095;else c=d&4088|h&7;if(!((c^d)&7)){w9(a,b);r=w;return}x9(u,a,16777216);SW(u,b,c,1.0,0.0);e=u+36|0;c=k[e>>2]|0;if(c|0?(a=c+12|0,v=k[a>>2]|0,k[a>>2]=v+-1,(v|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[u+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;v=u+16|0;d=u+4|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[d>>2]|0)>0){e=k[u+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[u+44>>2]|0;if(!((c|0)==(u+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=w;return}q=a+24|0;if(k[q>>2]|0){t=a+4|0;j=k[t>>2]|0;if((j|0)<3)c=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{e=k[a+32>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(j|0))}if(c|0){d=(j|0)>0;if(!d)if(!j){k[u+-4>>2]=0;d=-1;m=0;c=k[a+32>>2]|0;p=l}else{g=0;s=38}else{g=k[(k[a+36>>2]|0)+(j+-1<<2)>>2]|0;s=38}if((s|0)==38){h=k[a+32>>2]|0;c=0;do{k[u+(c<<2)>>2]=k[h+(c<<2)>>2];c=c+1|0}while(c>>>0<j>>>0);f=j+-1|0;p=u+(f<<2)|0;n=aa(k[p>>2]|0,g)|0;k[p>>2]=n;if(d){e=k[a+36>>2]|0;c=0;d=k[a+28>>2]|0;do{p=k[e+(c<<2)>>2]|0;n=(d>>>0)/(p>>>0)|0;k[l+(c<<2)>>2]=n;d=d-(aa(n,p)|0)|0;c=c+1|0}while((c|0)!=(j|0));d=f;m=g;c=h;p=l}else{d=f;m=g;c=h;p=l}}n=l+(d<<2)|0;l=aa(k[n>>2]|0,m)|0;k[n>>2]=l;P1(b,j,c,k[a>>2]&4095,-1,0,0);c=k[b>>2]|0;do if((c&2031616|0)==655360){A2(v,b);h=k[q>>2]|0;n=v+24|0;j=k[n>>2]|0;if((h|0)==(j|0)?(k[v+28>>2]|0)==(k[a+28>>2]|0):0){if(h|0?(a=h+8|0,u=k[a>>2]|0,k[a>>2]=u+-1,(u|0)==1):0){u=k[n>>2]|0;a=k[u+4>>2]|0;jh[k[(k[a>>2]|0)+16>>2]&1023](a,u);k[n>>2]=0}d=v+4|0;if((k[d>>2]|0)>0){e=k[v+32>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}k[n>>2]=0;c=k[v+36>>2]|0;if(!((c|0)==(v+40|0)|(c|0)==0))ggb(k[c+-4>>2]|0);break}l=k[h+4>>2]|0;if((l|0)!=(k[j+4>>2]|0)){o=j+8|0;s=k[o>>2]|0;k[o>>2]=s+-1;if((s|0)==1){s=k[n>>2]|0;o=k[s+4>>2]|0;jh[k[(k[o>>2]|0)+16>>2]&1023](o,s);k[n>>2]=0}d=v+4|0;if((k[d>>2]|0)>0){e=k[v+32>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}k[n>>2]=0;c=k[v+36>>2]|0;if(!((c|0)==(v+40|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[b>>2]|0;s=60;break}b=v+4|0;f=k[b>>2]|0;if((f|0)>0){g=v+36|0;c=k[g>>2]|0;d=0;e=k[v+28>>2]|0;do{q=k[c+(d<<2)>>2]|0;x=(e>>>0)/(q>>>0)|0;k[o+(d<<2)>>2]=x;e=e-(aa(x,q)|0)|0;d=d+1|0}while((d|0)!=(f|0))}else{c=v+36|0;g=c;c=k[c>>2]|0}x=k[t>>2]|0;t=o+(x+-1<<2)|0;q=aa(k[t>>2]|0,m)|0;k[t>>2]=q;Sg[k[(k[l>>2]|0)+36>>2]&31](l,h,j,x,u,p,k[a+36>>2]|0,o,c,0);c=k[n>>2]|0;if(c|0?(u=c+8|0,x=k[u>>2]|0,k[u>>2]=x+-1,(x|0)==1):0){x=k[n>>2]|0;u=k[x+4>>2]|0;jh[k[(k[u>>2]|0)+16>>2]&1023](u,x);k[n>>2]=0}if((k[b>>2]|0)>0){d=k[v+32>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[b>>2]|0))}k[n>>2]=0;c=k[g>>2]|0;if(!((c|0)==(v+40|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}else s=60;while(0);if((s|0)==60){do if((c&2031616|0)==65536){f=k[b+4>>2]|0;k[v>>2]=k[f>>2];j=v+4|0;c=f+4|0;k[j>>2]=k[c>>2];x=v+8|0;k[x>>2]=k[f+8>>2];k[v+12>>2]=k[f+12>>2];l=v+16|0;k[l>>2]=k[f+16>>2];k[v+20>>2]=k[f+20>>2];k[v+24>>2]=k[f+24>>2];k[v+28>>2]=k[f+28>>2];k[v+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[v+36>>2]=d;e=v+40|0;k[e>>2]=x;x=v+48|0;b=v+44|0;k[b>>2]=x;k[v+52>>2]=0;k[x>>2]=0;if(d|0){x=d+12|0;k[x>>2]=(k[x>>2]|0)+1}if((k[c>>2]|0)<3){g=k[f+44>>2]|0;f=k[b>>2]|0;k[f>>2]=k[g>>2];k[f+4>>2]=k[g+4>>2];f=l;g=b;break}k[j>>2]=0;x1(v,k[c>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[f+40>>2]|0;g=k[e>>2]|0;d=k[f+44>>2]|0;e=k[b>>2]|0;c=0;do{k[g+(c<<2)>>2]=k[h+(c<<2)>>2];k[e+(c<<2)>>2]=k[d+(c<<2)>>2];c=c+1|0}while((c|0)<(k[j>>2]|0));f=l;g=b}else{f=l;g=b}}else{Q1(v,b,-1);f=v+16|0;g=v+44|0}while(0);e=k[q>>2]|0;c=k[e+4>>2]|0;sh[k[(k[c>>2]|0)+28>>2]&255](c,e,k[f>>2]|0,k[t>>2]|0,u,p,k[a+36>>2]|0,k[g>>2]|0);e=v+36|0;c=k[e>>2]|0;if(c|0?(u=c+12|0,x=k[u>>2]|0,k[u>>2]=x+-1,(x|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[v+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=v+4|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[e>>2]|0)>0){d=k[v+40>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}c=k[g>>2]|0;if(!((c|0)==(v+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}r=w;return}}b2(b);r=w;return}function x9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+16|0;f=t;o=b+24|0;d=k[o>>2]|0;if(!d){k[a>>2]=1124007936;d=a+8|0;c=a+40|0;p=a+4|0;q=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(q|0));k[c>>2]=d;s=a+48|0;k[a+44>>2]=s;k[a+52>>2]=0;k[s>>2]=0;r=t;return}s=430620+(((d>>>0)%31|0)<<2)|0;mpb(k[s>>2]|0)|0;p=(k[o>>2]|0)+12|0;q=k[p>>2]|0;k[p>>2]=q+1;if(!q){q=k[o>>2]|0;p=k[q+4>>2]|0;Ph[k[(k[p>>2]|0)+20>>2]&511](p,q,c|50331648)}d=k[o>>2]|0;c=k[d+16>>2]|0;if(!c){q=d+12|0;k[q>>2]=(k[q>>2]|0)+-1;if(!(k[(k[o>>2]|0)+16>>2]|0)){k[f>>2]=0;d=f+4|0;k[d>>2]=0;c=ZT(60)|0;k[c>>2]=1;p=c+4|0;k[f>>2]=p;k[d>>2]=55;i[c+59>>0]=0;e=233550;q=p+55|0;do{i[p>>0]=i[e>>0]|0;p=p+1|0;e=e+1|0}while((p|0)<(q|0));Y8(-215,f,233606,233080,731);k[d>>2]=0;k[f>>2]=0;q=k[c>>2]|0;k[c>>2]=q+-1;if((q|0)==1)ggb(k[c+-4>>2]|0)}k[a>>2]=1124007936;d=a+8|0;c=a+40|0;p=a+4|0;q=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(q|0));k[c>>2]=d;q=a+48|0;k[a+44>>2]=q;k[a+52>>2]=0;k[q>>2]=0}else{j=k[b+4>>2]|0;l=k[b+32>>2]|0;m=k[b>>2]&4095;n=b+28|0;d=c+(k[n>>2]|0)|0;c=k[b+36>>2]|0;e=a+8|0;f=a+16|0;g=a+20|0;h=a+40|0;p=a+4|0;q=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(q|0));k[h>>2]=e;q=a+48|0;k[a+44>>2]=q;k[a+52>>2]=0;k[q>>2]=0;k[a>>2]=m|1124007936;k[f>>2]=d;k[g>>2]=d;x1(a,j,l,c,1);y1(a);k[a>>2]=k[b>>2];q=k[o>>2]|0;k[a+36>>2]=q;p=k[q+16>>2]|0;k[g>>2]=p;k[f>>2]=p+(k[n>>2]|0);q=p+(k[q+24>>2]|0)|0;k[a+24>>2]=q;k[a+28>>2]=q}lpb(k[s>>2]|0)|0;r=t;return}function y9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;f=m;l=c&4095;if((a|0)<0|(b|0)<1){d=f+4|0;e=ZT(36)|0;k[e>>2]=1;g=e+4|0;k[f>>2]=g;k[d>>2]=28;i[e+32>>0]=0;h=233783;j=g+28|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-201,f,233812,233613,119);k[d>>2]=0;k[f>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0)}e=aa((c>>>3&511)+1<<(47696>>>(c<<1&14)&3),b)|0;if((e|0)<1){c=f+4|0;d=ZT(24)|0;k[d>>2]=1;g=d+4|0;k[f>>2]=g;k[c>>2]=19;i[d+23>>0]=0;h=233830;j=g+19|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-210,f,233812,233613,123);k[c>>2]=0;k[f>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}c=ZT(28)|0;k[c+4>>2]=e;k[c>>2]=l|1111638016;k[c+20>>2]=a;k[c+24>>2]=b;k[c+16>>2]=0;k[c+8>>2]=0;k[c+12>>2]=1;b=Epb(a|0,((a|0)<0)<<31>>31|0,e|0,((e|0)<0)<<31>>31|0)|0;a=N;if(!((a|0)>0|(a|0)==0&b>>>0>2147483647)){r=m;return c|0}k[c>>2]=l|1111621632;r=m;return c|0}function z9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;m=n;if(a|0){c=k[a>>2]|0;b=c&-65536;if(((b|0)==1111621632?(f=a+24|0,e=k[f>>2]|0,(e|0)>-1):0)?(g=a+20|0,d=k[g>>2]|0,(d|0)>-1):0){b=k[a+4>>2]|0;if((e|0)==0|(d|0)==0){r=n;return}e=a+16|0;if(k[e>>2]|0){c=m+4|0;d=ZT(32)|0;k[d>>2]=1;h=d+4|0;k[m>>2]=h;k[c>>2]=25;i[d+29>>0]=0;j=233677;l=h+25|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-2,m,233703,233613,814);k[c>>2]=0;k[m>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}if(!b){b=k[a>>2]|0;b=aa((b>>>3&511)+1<<(47696>>>(b<<1&14)&3),k[f>>2]|0)|0}l=k[g>>2]|0;b=Epb(l|0,((l|0)<0)<<31>>31|0,b|0,0)|0;b=kpb(b|0,N|0,20,0)|0;if(!((b|0)==(b|0)&(N|0)==0)){c=m+4|0;d=ZT(32)|0;k[d>>2]=1;h=d+4|0;k[m>>2]=h;k[c>>2]=27;i[d+31>>0]=0;j=233716;l=h+27|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-4,m,233703,233613,822);k[c>>2]=0;k[m>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0)}m=ZT(b)|0;k[a+8>>2]=m;k[e>>2]=m+4+15&-16;k[m>>2]=1;r=n;return}if((c|0)==112){b=a+68|0;if(k[b>>2]|0){c=m+4|0;d=ZT(32)|0;k[d>>2]=1;h=d+4|0;k[m>>2]=h;k[c>>2]=25;i[d+29>>0]=0;j=233677;l=h+25|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-2,m,233703,233613,832);k[c>>2]=0;k[m>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0)}m=ZT(k[a+64>>2]|0)|0;k[a+108>>2]=m;k[b>>2]=m;r=n;return}if((b|0)==1111687168){b=(c>>>3&511)+1<<(47696>>>(c<<1&14)&3);e=a+20|0;if(!(k[e>>2]|0)){r=n;return}f=a+16|0;if(k[f>>2]|0){c=m+4|0;d=ZT(32)|0;k[d>>2]=1;h=d+4|0;k[m>>2]=h;k[c>>2]=25;i[d+29>>0]=0;j=233677;l=h+25|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-2,m,233703,233613,865);k[c>>2]=0;k[m>>2]=0;m=k[d>>2]|0;k[d>>2]=m+-1;if((m|0)==1)ggb(k[d+-4>>2]|0);c=k[a>>2]|0}if(!(c&16384)){c=k[a+4>>2]|0;if((c|0)>0)do{m=c;c=c+-1|0;l=aa(k[e+(c<<3)>>2]|0,k[e+(c<<3)+4>>2]|0)|0;b=b>>>0<l>>>0?l:b}while((m|0)>1)}else{m=k[a+24>>2]|0;b=aa((m|0)==0?b:m,k[e>>2]|0)|0}m=ZT(b+20|0)|0;k[a+8>>2]=m;k[f>>2]=m+4+15&-16;k[m>>2]=1;r=n;return}}b=m+4|0;c=ZT(44)|0;k[c>>2]=1;h=c+4|0;k[m>>2]=h;k[b>>2]=38;i[c+42>>0]=0;j=233744;l=h+38|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,m,233703,233613,890);k[b>>2]=0;k[m>>2]=0;a=k[c>>2]|0;k[c>>2]=a+-1;if((a|0)==1)ggb(k[c+-4>>2]|0);r=n;return}function A9(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+16|0;o=p;if((a|0)==0?(m=o+4|0,g=ZT(8)|0,k[g>>2]=1,l=g+4|0,k[o>>2]=l,k[m>>2]=0,i[l>>0]=0,Y8(-27,o,233850,233613,146),k[m>>2]=0,k[o>>2]=0,m=k[g>>2]|0,k[g>>2]=m+-1,(m|0)==1):0)ggb(k[g+-4>>2]|0);if((b|0)<0|(c|0)<1){g=o+4|0;h=ZT(32)|0;k[h>>2]=1;j=h+4|0;k[o>>2]=j;k[g>>2]=25;i[h+29>>0]=0;l=233866;m=j+25|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-201,o,233850,233613,152);k[g>>2]=0;k[o>>2]=0;m=k[h>>2]|0;k[h>>2]=m+-1;if((m|0)==1)ggb(k[h+-4>>2]|0)}j=d&4095|1111621632;k[a>>2]=j;h=a+20|0;k[h>>2]=b;k[a+24>>2]=c;k[a+16>>2]=e;k[a+8>>2]=0;k[a+12>>2]=0;g=aa((d>>>3&511)+1<<(47696>>>(d<<1&14)&3),c)|0;if((f|0)<2147483647)switch(f|0){case 0:{n=15;break}default:{}}else switch(f|0){case 2147483647:{n=15;break}default:{}}if((n|0)==15){k[a+4>>2]=g;d=b;e=g;o=(d|0)==1;f=(e|0)==(g|0);f=o|f;f=f?16384:0;o=(e|0)<0;o=o<<31>>31;n=(d|0)<0;n=n<<31>>31;o=Epb(d|0,n|0,e|0,o|0)|0;e=N;n=(e|0)>0;o=o>>>0>2147483647;e=(e|0)==0;o=e&o;o=n|o;f=o?0:f;f=j|f;k[a>>2]=f;r=p;return}if((g|0)>(f|0)){n=o+4|0;b=ZT(8)|0;k[b>>2]=1;e=b+4|0;k[o>>2]=e;k[n>>2]=0;i[e>>0]=0;Y8(-13,o,233850,233613,168);k[n>>2]=0;k[o>>2]=0;o=k[b>>2]|0;k[b>>2]=o+-1;if((o|0)==1)ggb(k[b+-4>>2]|0);b=k[h>>2]|0}k[a+4>>2]=f;d=b;e=f;o=(d|0)==1;f=(e|0)==(g|0);f=o|f;f=f?16384:0;o=(e|0)<0;o=o<<31>>31;n=(d|0)<0;n=n<<31>>31;o=Epb(d|0,n|0,e|0,o|0)|0;e=N;n=(e|0)>0;o=o>>>0>2147483647;e=(e|0)==0;o=e&o;o=n|o;f=o?0:f;f=j|f;k[a>>2]=f;r=p;return}function B9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;d=h;if((a|0)==0?(g=d+4|0,b=ZT(8)|0,k[b>>2]=1,c=b+4|0,k[d>>2]=c,k[g>>2]=0,i[c>>0]=0,Y8(-9,d,233892,233613,189),k[g>>2]=0,k[d>>2]=0,g=k[b>>2]|0,k[b>>2]=g+-1,(g|0)==1):0)ggb(k[b+-4>>2]|0);g=k[a>>2]|0;if(!g){r=h;return}b=k[g>>2]|0;c=b&-65536;a:do if((c|0)<1111687168){switch(c|0){case 1111621632:break;default:{e=9;break a}}if(!((k[g+24>>2]|0)>-1?(k[g+20>>2]|0)>-1:0))e=9}else switch(c|0){case 1111687168:break;default:e=9}while(0);if((e|0)==9){e=d+4|0;b=ZT(8)|0;k[b>>2]=1;c=b+4|0;k[d>>2]=c;k[e>>2]=0;i[c>>0]=0;Y8(-206,d,233892,233613,196);k[e>>2]=0;k[d>>2]=0;e=k[b>>2]|0;k[b>>2]=e+-1;if((e|0)==1)ggb(k[b+-4>>2]|0);b=k[g>>2]|0}k[a>>2]=0;b=b&-65536;b:do if((b|0)<1111687168){switch(b|0){case 1111621632:break;default:break b}if(((k[g+24>>2]|0)>0?(k[g+20>>2]|0)>0:0)?(f=g+16|0,k[f>>2]|0):0){k[f>>2]=0;b=g+8|0;c=k[b>>2]|0;if(c|0?(f=(k[c>>2]|0)+-1|0,k[c>>2]=f,(f|0)==0):0){ggb(k[c+-4>>2]|0);k[b>>2]=0}k[b>>2]=0}}else{switch(b|0){case 1111687168:break;default:break b}b=g+16|0;if(k[b>>2]|0){k[b>>2]=0;b=g+8|0;c=k[b>>2]|0;if(c|0?(f=(k[c>>2]|0)+-1|0,k[c>>2]=f,(f|0)==0):0){ggb(k[c+-4>>2]|0);k[b>>2]=0}k[b>>2]=0}}while(0);ggb(k[g+-4>>2]|0);r=h;return}function C9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;if(!((((a|0)!=0?(b=k[a>>2]|0,(b&-65536|0)==1111621632):0)?(d=k[a+24>>2]|0,(d|0)>0):0)?(c=k[a+20>>2]|0,(c|0)>0):0)){b=g+4|0;c=ZT(24)|0;k[c>>2]=1;d=c+4|0;k[g>>2]=d;k[b>>2]=16;i[c+20>>0]=0;e=233905;f=d+16|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-5,g,233922,233613,211);k[b>>2]=0;k[g>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)==1)ggb(k[c+-4>>2]|0);c=k[a+20>>2]|0;d=k[a+24>>2]|0;b=k[a>>2]|0}b=y9(c,d,b)|0;if(!(k[a+16>>2]|0)){r=h;return b|0}z9(b);wY(a,b);r=h;return b|0}function D9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+16|0;s=u;t=d&4095;d=(d>>>3&511)+1<<(47696>>>(d<<1&14)&3);if(!a){f=s+4|0;g=ZT(32)|0;k[g>>2]=1;o=g+4|0;k[s>>2]=o;k[f>>2]=26;i[g+30>>0]=0;p=233933;q=o+26|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Y8(-27,s,233960,233613,237);k[f>>2]=0;k[s>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0)}if(!d){f=s+4|0;g=ZT(28)|0;k[g>>2]=1;o=g+4|0;k[s>>2]=o;k[f>>2]=23;i[g+27>>0]=0;p=233978;q=o+23|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Y8(-210,s,233960,233613,240);k[f>>2]=0;k[s>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0)}if(!c){f=s+4|0;g=ZT(28)|0;k[g>>2]=1;o=g+4|0;k[s>>2]=o;k[f>>2]=20;i[g+24>>0]=0;p=234002;q=o+20|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Y8(-27,s,233960,233613,243);k[f>>2]=0;k[s>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0)}if((b+-1|0)>>>0>31){f=s+4|0;g=ZT(52)|0;k[g>>2]=1;o=g+4|0;k[s>>2]=o;k[f>>2]=46;i[g+50>>0]=0;p=234023;q=o+46|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Y8(-211,s,233960,233613,247);k[f>>2]=0;k[s>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0)}if((b|0)<=0){q=0;s=d;c=(q|0)<0;s=s>>>0<2147483648;q=(q|0)==0;s=q&s;s=c|s;s=s?1111703552:1111687168;t=s|t;k[a>>2]=t;t=a+4|0;k[t>>2]=b;t=a+16|0;k[t>>2]=e;t=a+8|0;k[t>>2]=0;t=a+12|0;k[t>>2]=0;r=u;return a|0}m=s+4|0;n=s+4|0;l=b;f=0;do{j=l;l=l+-1|0;h=c+(l<<2)|0;g=k[h>>2]|0;if((g|0)<0){g=ZT(44)|0;k[g>>2]=1;o=g+4|0;k[s>>2]=o;k[m>>2]=37;i[g+41>>0]=0;p=234070;q=o+37|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Y8(-201,s,233960,233613,252);k[m>>2]=0;k[s>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0);g=k[h>>2]|0}k[a+20+(l<<3)>>2]=g;if((f|0)>0|(f|0)==0&d>>>0>2147483647){g=ZT(28)|0;k[g>>2]=1;o=g+4|0;k[s>>2]=o;k[n>>2]=20;i[g+24>>0]=0;p=234108;q=o+20|0;do{i[o>>0]=i[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Y8(-211,s,233960,233613,255);k[n>>2]=0;k[s>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0)}k[a+20+(l<<3)+4>>2]=d;q=k[h>>2]|0;d=Epb(q|0,((q|0)<0)<<31>>31|0,d|0,f|0)|0;f=N}while((j|0)>1);c=(f|0)<0;s=d>>>0<2147483648;q=(f|0)==0;s=q&s;s=c|s;s=s?1111703552:1111687168;t=s|t;k[a>>2]=t;t=a+4|0;k[t>>2]=b;t=a+16|0;k[t>>2]=e;t=a+8|0;k[t>>2]=0;t=a+12|0;k[t>>2]=0;r=u;return a|0}function E9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;d=h;if((a+-1|0)>>>0>31){e=d+4|0;f=ZT(52)|0;k[f>>2]=1;g=f+4|0;k[d>>2]=g;k[e>>2]=46;i[f+50>>0]=0;j=234023;l=g+46|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-211,d,234129,233613,286);k[e>>2]=0;k[d>>2]=0;l=k[f>>2]|0;k[f>>2]=l+-1;if((l|0)==1)ggb(k[f+-4>>2]|0)}l=ZT(276)|0;D9(l,a,b,c,0)|0;k[l+12>>2]=1;r=h;return l|0}function F9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+256|0;e=o+128|0;n=o+72|0;l=o+16|0;j=o;if(!((a|0)!=0?(k[a>>2]&-65536|0)==1111687168:0)){c=e+4|0;b=ZT(24)|0;k[b>>2]=1;f=b+4|0;k[e>>2]=f;k[c>>2]=18;i[b+22>>0]=0;g=234149;h=f+18|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-5,e,234168,233613,301);k[c>>2]=0;k[e>>2]=0;m=k[b>>2]|0;k[b>>2]=m+-1;if((m|0)==1)ggb(k[b+-4>>2]|0)}d=a+4|0;b=k[d>>2]|0;if((b|0)<33)c=b;else{b=e+4|0;c=ZT(28)|0;k[c>>2]=1;f=c+4|0;k[e>>2]=f;k[b>>2]=23;i[c+27>>0]=0;g=234181;h=f+23|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,e,234168,233613,303);k[b>>2]=0;k[e>>2]=0;m=k[c>>2]|0;k[c>>2]=m+-1;if((m|0)==1)ggb(k[c+-4>>2]|0);c=k[d>>2]|0}if((c|0)>0){b=0;do{k[e+(b<<2)>>2]=k[a+20+(b<<3)>>2];b=b+1|0}while((b|0)!=(c|0))}m=E9(c,e,k[a>>2]|0)|0;if(!(k[a+16>>2]|0)){r=o;return m|0}z9(m);M1(n,a,0,1,0,0);M1(l,m,0,1,0,0);h=k[m+16>>2]|0;e=j+4|0;g=e+4|0;k[g>>2]=0;k[g+4>>2]=0;k[j>>2]=33619968;k[e>>2]=l;mY(n,j);e=l+16|0;if((k[e>>2]|0)!=(h|0)){k[j>>2]=0;b=j+4|0;k[b>>2]=0;c=ZT(24)|0;k[c>>2]=1;f=c+4|0;k[j>>2]=f;k[b>>2]=18;i[c+22>>0]=0;g=234205;h=f+18|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,j,234168,233613,318);k[b>>2]=0;k[j>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0)}d=l+36|0;b=k[d>>2]|0;if(b|0?(h=b+12|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[l+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=l+4|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){c=k[l+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[l+44>>2]|0;if(!((b|0)==(l+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=n+36|0;b=k[d>>2]|0;if(b|0?(j=b+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[n+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;l=n+16|0;c=n+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[c>>2]|0)>0){d=k[n+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[n+44>>2]|0;if(!((b|0)==(n+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);r=o;return m|0}function G9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+16|0;q=t;e=(a|0)!=0;if(!(e&(b|0)!=0)){f=q+4|0;g=ZT(36)|0;k[g>>2]=1;n=g+4|0;k[q>>2]=n;k[f>>2]=28;i[g+32>>0]=0;o=234313;p=n+28|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-27,q,234459,233613,2392);k[f>>2]=0;k[q>>2]=0;p=k[g>>2]|0;k[g>>2]=p+-1;if((p|0)==1)ggb(k[g+-4>>2]|0)}do if(e){f=k[a>>2]|0;e=f&-65536;if(((e|0)==1111621632?(k[a+24>>2]|0)>0:0)?(k[a+20>>2]|0)>0:0){if(k[a+16>>2]|0){e=0;break}e=q+4|0;f=ZT(40)|0;k[f>>2]=1;n=f+4|0;k[q>>2]=n;k[e>>2]=32;i[f+36>>0]=0;o=234353;p=n+32|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-27,q,234459,233613,2397);k[e>>2]=0;k[q>>2]=0;b=k[f>>2]|0;k[f>>2]=b+-1;if((b|0)==1)ggb(k[f+-4>>2]|0);e=0;break}if((f|0)!=112){if(!((d|0)!=0&(e|0)==1111687168)){s=50;break}d=a+20|0;j=k[d>>2]|0;h=a+16|0;if(!(k[h>>2]|0)){e=q+4|0;f=ZT(40)|0;k[f>>2]=1;n=f+4|0;k[q>>2]=n;k[e>>2]=33;i[f+37>>0]=0;o=234425;p=n+33|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-27,q,234459,233613,2467);k[e>>2]=0;k[q>>2]=0;p=k[f>>2]|0;k[f>>2]=p+-1;if((p|0)==1)ggb(k[f+-4>>2]|0);e=k[a>>2]|0}else e=f;if(!(e&16384)){e=q+4|0;f=ZT(52)|0;k[f>>2]=1;n=f+4|0;k[q>>2]=n;k[e>>2]=44;i[f+48>>0]=0;o=234662;p=n+44|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-5,q,234459,233613,2470);k[e>>2]=0;k[q>>2]=0;q=k[f>>2]|0;k[f>>2]=q+-1;if((q|0)==1)ggb(k[f+-4>>2]|0)}g=k[a+4>>2]|0;if((g|0)<=2)if((g|0)==1)f=1;else f=k[a+28>>2]|0;else{f=1;e=1;do{f=aa(k[d+(e<<3)>>2]|0,f)|0;e=e+1|0}while((e|0)!=(g|0))}k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=k[h>>2];k[b+20>>2]=j;k[b+24>>2]=f;q=k[a>>2]|0;e=q&4095;k[b>>2]=e|1111638016;q=aa((q>>>3&511)+1<<(47696>>>(q<<1&14)&3),f)|0;q=(j|0)>1?q:0;k[b+4>>2]=q;q=Epb(q|0,((q|0)<0)<<31>>31|0,j|0,((j|0)<0)<<31>>31|0)|0;p=N;if(!((p|0)>0|(p|0)==0&q>>>0>2147483647)){a=b;e=0;break}k[b>>2]=e|1111621632;a=b;e=0;break}m=a+68|0;if(!(k[m>>2]|0)){e=q+4|0;f=ZT(36)|0;k[f>>2]=1;n=f+4|0;k[q>>2]=n;k[e>>2]=31;i[f+35>>0]=0;o=234468;p=n+31|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-27,q,234459,233613,2407);k[e>>2]=0;k[q>>2]=0;p=k[f>>2]|0;k[f>>2]=p+-1;if((p|0)==1)ggb(k[f+-4>>2]|0)}l=k[a+16>>2]|0;l=1125516576>>>((l>>>2&60)+(l>>31&20)|0);d=l&7;g=k[a+8>>2]|0;e=(g|0)>1?k[a+28>>2]|0:0;j=a+48|0;f=k[j>>2]|0;if(!f){g=d|(g<<3)+-8;if(e|0){e=q+4|0;f=ZT(48)|0;k[f>>2]=1;n=f+4|0;k[q>>2]=n;k[e>>2]=40;i[f+44>>0]=0;o=234621;p=n+40|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-206,q,234459,233613,2453);k[e>>2]=0;k[q>>2]=0;q=k[f>>2]|0;k[f>>2]=q+-1;if((q|0)==1)ggb(k[f+-4>>2]|0)}A9(b,k[a+44>>2]|0,k[a+40>>2]|0,g,k[m>>2]|0,k[a+72>>2]|0);a=b;e=0;break}if((e|0)==1){e=k[f>>2]|0;if(!e){e=q+4|0;f=ZT(68)|0;k[f>>2]=1;n=f+4|0;k[q>>2]=n;k[e>>2]=63;i[f+67>>0]=0;o=234500;p=n+63|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-206,q,234459,233613,2423);k[e>>2]=0;k[q>>2]=0;q=k[f>>2]|0;k[f>>2]=q+-1;if((q|0)==1)ggb(k[f+-4>>2]|0);e=k[j>>2]|0;f=e;e=k[e>>2]|0}e=(k[m>>2]|0)+(aa(e+-1|0,k[a+64>>2]|0)|0)|0;a=k[a+72>>2]|0;e=e+(aa(a,k[f+8>>2]|0)|0)|0;A9(b,k[f+16>>2]|0,k[f+12>>2]|0,d,e+(k[f+4>>2]<<(47696>>>(l<<1&14)&3))|0,a);a=b;e=0;break}else{h=(g<<3)+-8|0;d=d|h;e=k[f>>2]|0;if((g|0)>512){f=q+4|0;g=ZT(64)|0;k[g>>2]=1;n=g+4|0;k[q>>2]=n;k[f>>2]=56;i[g+60>>0]=0;o=234564;p=n+56|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-15,q,234459,233613,2439);k[f>>2]=0;k[q>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0);f=k[j>>2]|0}a=k[a+72>>2]|0;q=(k[m>>2]|0)+(aa(a,k[f+8>>2]|0)|0)|0;A9(b,k[f+16>>2]|0,k[f+12>>2]|0,d,q+(aa(k[f+4>>2]|0,(h>>>3&511)+1<<(47696>>>(l<<1&14)&3))|0)|0,a);a=b;break}}else s=50;while(0);if((s|0)==50){e=q+4|0;a=ZT(44)|0;k[a>>2]=1;n=a+4|0;k[q>>2]=n;k[e>>2]=38;i[a+42>>0]=0;o=234386;p=n+38|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-206,q,234459,233613,2494);k[e>>2]=0;k[q>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0);a=0;e=0}if(!c){r=t;return a|0}k[c>>2]=e;r=t;return a|0}function H9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;l=o;m=c&4095;n=1212424721>>>(c<<2&28)&15;f=aa(n,(c>>>3&511)+1|0)|0;if(!f){c=l+4|0;d=ZT(28)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[c>>2]=23;i[d+27>>0]=0;h=233978;j=g+23|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-210,l,234707,233613,545);k[c>>2]=0;k[l>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}if((a+-1|0)>>>0>1023){c=l+4|0;d=ZT(32)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[c>>2]=24;i[d+28>>0]=0;h=234725;j=g+24|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-211,l,234707,233613,548);k[c>>2]=0;k[l>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}if(!b){c=l+4|0;d=ZT(28)|0;k[d>>2]=1;g=d+4|0;k[l>>2]=g;k[c>>2]=20;i[d+24>>0]=0;h=234002;j=g+20|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-27,l,234707,233613,551);k[c>>2]=0;k[l>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}if((a|0)>0){d=l+4|0;c=0;do{if((k[b+(c<<2)>>2]|0)<1){e=ZT(44)|0;k[e>>2]=1;g=e+4|0;k[l>>2]=g;k[d>>2]=37;i[e+41>>0]=0;h=234070;j=g+37|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-201,l,234707,233613,556);k[d>>2]=0;k[l>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0)}c=c+1|0}while((c|0)<(a|0))}l=a+-32|0;l=ZT((((l|0)>0?l:0)<<2)+164|0)|0;k[l>>2]=m|1111752704;k[l+4>>2]=a;k[l+8>>2]=0;k[l+12>>2]=1;m=a<<2;upb(l+36|0,b|0,m|0)|0;n=n+7&0-n;k[l+28>>2]=n;n=f+3+n&65532;k[l+32>>2]=n;n=WY(0,64,m+7+n&-8,zY(4096)|0)|0;k[l+16>>2]=n;k[l+24>>2]=1024;n=ZT(4096)|0;k[l+20>>2]=n;zpb(n|0,0,4096)|0;r=o;return l|0}function I9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;f=r;r=r+16|0;c=f;if((a|0)==0?(e=c+4|0,b=ZT(8)|0,k[b>>2]=1,g=b+4|0,k[c>>2]=g,k[e>>2]=0,i[g>>0]=0,Y8(-9,c,234750,233613,589),k[e>>2]=0,k[c>>2]=0,e=k[b>>2]|0,k[b>>2]=e+-1,(e|0)==1):0)ggb(k[b+-4>>2]|0);e=k[a>>2]|0;if(!e){r=f;return}if((k[e>>2]&-65536|0)!=1111752704?(g=c+4|0,d=ZT(8)|0,k[d>>2]=1,b=d+4|0,k[c>>2]=b,k[g>>2]=0,i[b>>0]=0,Y8(-206,c,234750,233613,596),k[g>>2]=0,k[c>>2]=0,g=k[d>>2]|0,k[d>>2]=g+-1,(g|0)==1):0)ggb(k[d+-4>>2]|0);k[a>>2]=0;k[c>>2]=k[(k[e+16>>2]|0)+44>>2];BY(c);b=e+20|0;a=k[b>>2]|0;if(a|0)ggb(k[a+-4>>2]|0);k[b>>2]=0;ggb(k[e+-4>>2]|0);r=f;return}function J9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;if(a|0?(b=k[a>>2]|0,(b&-65536|0)==1111752704):0){g=b;e=a+4|0;e=k[e>>2]|0;f=a+36|0;g=H9(e,f,g)|0;wY(a,g);r=h;return g|0}b=g+4|0;c=ZT(32)|0;k[c>>2]=1;d=c+4|0;k[g>>2]=d;k[b>>2]=27;i[c+31>>0]=0;e=234769;f=d+27|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-5,g,234797,233613,613);k[b>>2]=0;k[g>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)==1)ggb(k[c+-4>>2]|0);g=k[a>>2]|0;e=a+4|0;e=k[e>>2]|0;f=a+36|0;g=H9(e,f,g)|0;wY(a,g);r=h;return g|0}function K9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!((a|0)!=0?(k[a>>2]&-65536|0)==1111752704:0)){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=28;i[d+32>>0]=0;g=234814;h=f+28|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-5,e,234843,233613,628);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!b){c=e+4|0;d=ZT(28)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=21;i[d+25>>0]=0;g=234867;h=f+21|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-27,e,234843,233613,631);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}k[b>>2]=a;f=b+4|0;k[f>>2]=0;g=k[a+24>>2]|0;if((g|0)<=0){a=0;j=0;b=b+8|0;k[b>>2]=a;r=l;return j|0}e=k[a+20>>2]|0;c=0;while(1){d=k[e+(c<<2)>>2]|0;if(d|0)break;c=c+1|0;if((c|0)>=(g|0)){d=0;j=15;break}}if((j|0)==15){j=b+8|0;k[j>>2]=c;r=l;return d|0}k[f>>2]=d;a=c;j=d;b=b+8|0;k[b>>2]=a;r=l;return j|0}function L9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;g=r;r=r+16|0;f=g;if(a|0){b=k[a>>2]|0;c=b&-65536;a:do if((c|0)<1111687168){switch(c|0){case 1111621632:break;default:break a}if((k[a+24>>2]|0)>0?(k[a+20>>2]|0)>0:0){b=a+16|0;if(!(k[b>>2]|0)){r=g;return}k[b>>2]=0;b=a+8|0;c=k[b>>2]|0;if(c|0?(f=(k[c>>2]|0)+-1|0,k[c>>2]=f,(f|0)==0):0){ggb(k[c+-4>>2]|0);k[b>>2]=0}k[b>>2]=0;r=g;return}}else{switch(c|0){case 1111687168:break;default:break a}b=a+16|0;if(!(k[b>>2]|0)){r=g;return}k[b>>2]=0;b=a+8|0;c=k[b>>2]|0;if(c|0?(f=(k[c>>2]|0)+-1|0,k[c>>2]=f,(f|0)==0):0){ggb(k[c+-4>>2]|0);k[b>>2]=0}k[b>>2]=0;r=g;return}while(0);if((b|0)==112){f=a+108|0;b=k[f>>2]|0;k[f>>2]=0;k[a+68>>2]=0;if(!b){r=g;return}ggb(k[b+-4>>2]|0);r=g;return}}b=f+4|0;c=ZT(44)|0;k[c>>2]=1;a=c+4|0;k[f>>2]=a;k[b>>2]=38;i[c+42>>0]=0;d=233744;e=a+38|0;do{i[a>>0]=i[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(e|0));Y8(-5,f,234889,233613,1003);k[b>>2]=0;k[f>>2]=0;f=k[c>>2]|0;k[c>>2]=f+-1;if((f|0)==1)ggb(k[c+-4>>2]|0);r=g;return}function M9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+16|0;q=w;v=a+4|0;d=k[v>>2]|0;if((d|0)>0){l=q+4|0;j=0;c=0;do{h=k[b+(j<<2)>>2]|0;if(h>>>0>=(k[a+36+(j<<2)>>2]|0)>>>0){d=ZT(36)|0;k[d>>2]=1;e=d+4|0;k[q>>2]=e;k[l>>2]=30;i[d+34>>0]=0;f=234979;g=e+30|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-211,q,235010,233613,665);k[l>>2]=0;k[q>>2]=0;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0);d=k[v>>2]|0}c=h+(aa(c,1540483477)|0)|0;j=j+1|0}while((j|0)<(d|0))}else c=0;p=a+24|0;j=k[p>>2]|0;l=j+-1&c;u=c&2147483647;t=a+20|0;c=k[t>>2]|0;e=k[c+(l<<2)>>2]|0;a:do if(e|0){h=a+32|0;while(1){if((k[e>>2]|0)==(u|0)){g=e+(k[h>>2]|0)|0;b:do if((d|0)>0){f=0;do{if((k[b+(f<<2)>>2]|0)!=(k[g+(f<<2)>>2]|0))break b;f=f+1|0}while((f|0)<(d|0))}else f=0;while(0);if((f|0)==(d|0))break}e=k[e+4>>2]|0;if(!e)break a}d=e+(k[a+28>>2]|0)|0;if(d|0){v=d;r=w;return v|0}}while(0);o=a+16|0;d=k[o>>2]|0;if((k[d+60>>2]|0)<(j*3|0)){p=l;o=d}else{n=j<<1;n=(n|0)<1024?1024:n;d=n<<2;c=ZT(d)|0;zpb(c|0,0,d|0)|0;d=K9(a,q)|0;if(d|0){j=q+4|0;l=q+8|0;m=n+-1|0;while(1){e=k[(k[j>>2]|0)+4>>2]|0;c:do if(!e){f=(k[l>>2]|0)+1|0;k[l>>2]=f;e=k[q>>2]|0;h=k[e+24>>2]|0;if((f|0)<(h|0)){g=k[e+20>>2]|0;while(1){e=k[g+(f<<2)>>2]|0;if(e|0)break;e=f+1|0;if((e|0)<(h|0))f=e;else{e=0;break c}}k[l>>2]=f;k[j>>2]=e}else e=0}else k[j>>2]=e;while(0);h=c+((k[d>>2]&m)<<2)|0;k[d+4>>2]=k[h>>2];k[h>>2]=d;if(!e)break;else d=e}}d=k[t>>2]|0;if(d|0)ggb(k[d+-4>>2]|0);k[t>>2]=c;k[p>>2]=n;p=n+2147483647&u;o=k[o>>2]|0}n=o+56|0;d=k[n>>2]|0;if(!d){if(!o){m=q+4|0;c=ZT(8)|0;k[c>>2]=1;l=c+4|0;k[q>>2]=l;k[m>>2]=0;i[l>>0]=0;Y8(-27,q,212600,211567,2507);k[m>>2]=0;k[q>>2]=0;q=k[c>>2]|0;k[c>>2]=q+-1;if((q|0)==1)ggb(k[c+-4>>2]|0);d=k[n>>2]|0;if(!d)s=37}else s=37;if((s|0)==37){h=o+24|0;c=k[h>>2]|0;j=k[o+28>>2]|0;QY(o);l=o+36|0;d=k[l>>2]|0;k[n>>2]=d;e=d+j|0;g=k[o+32>>2]|0;m=g;if(e>>>0>g>>>0)e=d;else{f=d;while(1){k[f>>2]=c|-2147483648;k[f+4>>2]=e;c=c+1|0;f=e+j|0;if(f>>>0>g>>>0)break;else{s=e;e=f;f=s}}}k[e+(0-j)+4>>2]=0;s=(k[k[o+52>>2]>>2]|0)+12|0;k[s>>2]=c-(k[h>>2]|0)+(k[s>>2]|0);k[h>>2]=c;k[l>>2]=m}k[n>>2]=k[d+4>>2];k[d>>2]=k[d>>2]&67108863;c=o+60|0;k[c>>2]=(k[c>>2]|0)+1;c=k[t>>2]|0}else{k[n>>2]=k[d+4>>2];k[d>>2]=k[d>>2]&67108863;t=o+60|0;k[t>>2]=(k[t>>2]|0)+1}k[d>>2]=u;u=c+(p<<2)|0;k[d+4>>2]=k[u>>2];k[u>>2]=d;upb(d+(k[a+32>>2]|0)|0,b|0,k[v>>2]<<2|0)|0;v=d+(k[a+28>>2]|0)|0;b=k[a>>2]|0;zpb(v|0,0,(b>>>3&511)+1<<(47696>>>(b<<1&14)&3)|0)|0;r=w;return v|0}function N9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;h=r;r=r+16|0;g=h;a:do if(a|0){d=k[a>>2]|0;e=d&-65536;if(((e|0)==1111621632?(f=a+24|0,(k[f>>2]|0)>0):0)?(c=k[a+20>>2]|0,(c|0)>0):0){if(!b){g=2;r=h;return g|0}k[b>>2]=c;k[b+4>>2]=k[f>>2];g=2;r=h;return g|0}if((d|0)==112?k[a+68>>2]|0:0){if(!b){g=2;r=h;return g|0}k[b>>2]=k[a+44>>2];k[b+4>>2]=k[a+40>>2];g=2;r=h;return g|0}if((e|0)>=1111752704){switch(e|0){case 1111752704:break;default:break a}c=k[a+4>>2]|0;if(!b){g=c;r=h;return g|0}upb(b|0,a+36|0,c<<2|0)|0;g=c;r=h;return g|0}switch(e|0){case 1111687168:break;default:break a}c=k[a+4>>2]|0;if(!((b|0)!=0&(c|0)>0)){g=c;r=h;return g|0}e=a+20|0;d=0;do{k[b+(d<<2)>>2]=k[e+(d<<3)>>2];d=d+1|0}while((d|0)!=(c|0));r=h;return c|0}while(0);c=g+4|0;d=ZT(44)|0;k[d>>2]=1;e=d+4|0;k[g>>2]=e;k[c>>2]=38;i[d+42>>0]=0;f=233744;a=e+38|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(a|0));Y8(-5,g,235038,233613,1150);k[c>>2]=0;k[g>>2]=0;g=k[d>>2]|0;k[d>>2]=g+-1;if((g|0)==1)ggb(k[d+-4>>2]|0);g=-1;r=h;return g|0}function O9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;e=r;r=r+16|0;b=e;if((a|0)==0?(d=b+4|0,c=ZT(8)|0,k[c>>2]=1,f=c+4|0,k[b>>2]=f,k[d>>2]=0,i[f>>0]=0,Y8(-27,b,235450,233613,2994),k[d>>2]=0,k[b>>2]=0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[c+-4>>2]|0);d=k[a>>2]|0;if(!d){r=e;return}k[a>>2]=0;L9(d);b=d+48|0;c=k[b>>2]|0;if(c|0)ggb(k[c+-4>>2]|0);k[b>>2]=0;ggb(k[d+-4>>2]|0);r=e;return}function P9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;j=r;r=r+16|0;b=j;if(!((a|0)!=0?(k[a>>2]|0)==112:0)){c=b+4|0;d=ZT(24)|0;k[d>>2]=1;e=d+4|0;k[b>>2]=e;k[c>>2]=16;i[d+20>>0]=0;f=235678;g=e+16|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-5,b,235695,233613,3119);k[c>>2]=0;k[b>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}h=ZT(112)|0;e=h;f=a;g=e+108|0;do{k[e>>2]=k[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(g|0));k[h+108>>2]=0;d=h+68|0;k[d>>2]=0;b=h+48|0;k[b>>2]=0;c=k[a+48>>2]|0;if(c|0){f=k[c+16>>2]|0;e=k[c+12>>2]|0;l=k[c+8>>2]|0;m=k[c+4>>2]|0;c=k[c>>2]|0;g=ZT(20)|0;k[g>>2]=c;k[g+4>>2]=m;k[g+8>>2]=l;k[g+12>>2]=e;k[g+16>>2]=f;k[b>>2]=g}b=a+68|0;if(!(k[b>>2]|0)){r=j;return h|0}m=k[a+64>>2]|0;z9(h);upb(k[d>>2]|0,k[b>>2]|0,m|0)|0;r=j;return h|0}function Q9(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;a=e;b=a+4|0;c=ZT(52)|0;k[c>>2]=1;d=c+4|0;k[a>>2]=d;k[b>>2]=44;i[c+48>>0]=0;f=235708;g=d+44|0;do{i[d>>0]=i[f>>0]|0;d=d+1|0;f=f+1|0}while((d|0)<(g|0));Y8(-216,a,235753,235767,97);k[b>>2]=0;k[a>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)!=1){r=e;return}ggb(k[c+-4>>2]|0);r=e;return}function R9(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;a=e;b=a+4|0;c=ZT(52)|0;k[c>>2]=1;d=c+4|0;k[a>>2]=d;k[b>>2]=44;i[c+48>>0]=0;f=235708;g=d+44|0;do{i[d>>0]=i[f>>0]|0;d=d+1|0;f=f+1|0}while((d|0)<(g|0));Y8(-216,a,235753,235767,97);k[b>>2]=0;k[a>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)!=1){r=e;return}ggb(k[c+-4>>2]|0);r=e;return}function S9(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0;e=r;r=r+16|0;c=e;a=c+4|0;b=ZT(52)|0;k[b>>2]=1;d=b+4|0;k[c>>2]=d;k[a>>2]=44;i[b+48>>0]=0;f=235708;g=d+44|0;do{i[d>>0]=i[f>>0]|0;d=d+1|0;f=f+1|0}while((d|0)<(g|0));Y8(-216,c,235753,235767,97);k[a>>2]=0;k[c>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0);if(i[427776]|0){r=e;return 430744}i[427776]=1;k[107686]=0;k[107687]=0;k[c>>2]=0;a=c+4|0;k[a>>2]=0;b=ZT(52)|0;k[b>>2]=1;d=b+4|0;k[c>>2]=d;k[a>>2]=44;i[b+48>>0]=0;f=235708;g=d+44|0;do{i[d>>0]=i[f>>0]|0;d=d+1|0;f=f+1|0}while((d|0)<(g|0));Y8(-216,c,235753,235767,97);k[a>>2]=0;k[c>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0);ud(1456,430744,x|0)|0;r=e;return 430744}function T9(a){a=a|0;var b=0,c=0,d=0;b=k[a>>2]|0;if(b|0?(d=b+4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);k[a>>2]=0;k[a+4>>2]=0;return}function U9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0,m=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{c=b+(f<<2)|0;k=f|1;e=b+(k<<2)|0;j=+(l[a+k>>0]|0)+ +o[e>>2];o[c>>2]=+(l[a+f>>0]|0)+ +o[c>>2];o[e>>2]=j;e=f|2;c=b+(e<<2)|0;k=f|3;d=b+(k<<2)|0;j=+(l[a+k>>0]|0)+ +o[d>>2];o[c>>2]=+(l[a+e>>0]|0)+ +o[c>>2];o[d>>2]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=b+(f<<2)|0;o[k>>2]=+o[k>>2]+ +(l[a+f>>0]|0);f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{if(i[c+f>>0]|0){k=b+(f<<2)|0;o[k>>2]=+o[k>>2]+ +(l[a+f>>0]|0)}f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){b=f+4|0;m=+(l[a+1>>0]|0)+ +o[b>>2];k=f+8|0;j=+(l[a+2>>0]|0)+ +o[k>>2];o[f>>2]=+(l[a>>0]|0)+ +o[f>>2];o[b>>2]=m;o[k>>2]=j}g=g+1|0;if((g|0)==(d|0))break;else{a=a+3|0;f=f+12|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{k=h+(f<<2)|0;o[k>>2]=+o[k>>2]+ +(l[a+f>>0]|0);f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<2)|0;a=a+e|0}}return}}}function V9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0,m=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{c=b+(f<<3)|0;k=f|1;e=b+(k<<3)|0;j=+(l[a+k>>0]|0)+ +p[e>>3];p[c>>3]=+(l[a+f>>0]|0)+ +p[c>>3];p[e>>3]=j;e=f|2;c=b+(e<<3)|0;k=f|3;d=b+(k<<3)|0;j=+(l[a+k>>0]|0)+ +p[d>>3];p[c>>3]=+(l[a+e>>0]|0)+ +p[c>>3];p[d>>3]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=b+(f<<3)|0;p[k>>3]=+p[k>>3]+ +(l[a+f>>0]|0);f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{if(i[c+f>>0]|0){k=b+(f<<3)|0;p[k>>3]=+p[k>>3]+ +(l[a+f>>0]|0)}f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){b=f+8|0;m=+(l[a+1>>0]|0)+ +p[b>>3];k=f+16|0;j=+(l[a+2>>0]|0)+ +p[k>>3];p[f>>3]=+(l[a>>0]|0)+ +p[f>>3];p[b>>3]=m;p[k>>3]=j}g=g+1|0;if((g|0)==(d|0))break;else{a=a+3|0;f=f+24|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{k=h+(f<<3)|0;p[k>>3]=+p[k>>3]+ +(l[a+f>>0]|0);f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<3)|0;a=a+e|0}}return}}}function W9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0,l=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{c=b+(f<<2)|0;k=f|1;e=b+(k<<2)|0;j=+(m[a+(k<<1)>>1]|0)+ +o[e>>2];o[c>>2]=+(m[a+(f<<1)>>1]|0)+ +o[c>>2];o[e>>2]=j;e=f|2;c=b+(e<<2)|0;k=f|3;d=b+(k<<2)|0;j=+(m[a+(k<<1)>>1]|0)+ +o[d>>2];o[c>>2]=+(m[a+(e<<1)>>1]|0)+ +o[c>>2];o[d>>2]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=b+(f<<2)|0;o[k>>2]=+o[k>>2]+ +(m[a+(f<<1)>>1]|0);f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{if(i[c+f>>0]|0){k=b+(f<<2)|0;o[k>>2]=+o[k>>2]+ +(m[a+(f<<1)>>1]|0)}f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){b=f+4|0;l=+(m[a+2>>1]|0)+ +o[b>>2];k=f+8|0;j=+(m[a+4>>1]|0)+ +o[k>>2];o[f>>2]=+(m[a>>1]|0)+ +o[f>>2];o[b>>2]=l;o[k>>2]=j}g=g+1|0;if((g|0)==(d|0))break;else{a=a+6|0;f=f+12|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{k=h+(f<<2)|0;o[k>>2]=+o[k>>2]+ +(m[a+(f<<1)>>1]|0);f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<2)|0;a=a+(e<<1)|0}}return}}}function X9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0,l=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{c=b+(f<<3)|0;k=f|1;e=b+(k<<3)|0;j=+(m[a+(k<<1)>>1]|0)+ +p[e>>3];p[c>>3]=+(m[a+(f<<1)>>1]|0)+ +p[c>>3];p[e>>3]=j;e=f|2;c=b+(e<<3)|0;k=f|3;d=b+(k<<3)|0;j=+(m[a+(k<<1)>>1]|0)+ +p[d>>3];p[c>>3]=+(m[a+(e<<1)>>1]|0)+ +p[c>>3];p[d>>3]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=b+(f<<3)|0;p[k>>3]=+p[k>>3]+ +(m[a+(f<<1)>>1]|0);f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{if(i[c+f>>0]|0){k=b+(f<<3)|0;p[k>>3]=+p[k>>3]+ +(m[a+(f<<1)>>1]|0)}f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){b=f+8|0;l=+(m[a+2>>1]|0)+ +p[b>>3];k=f+16|0;j=+(m[a+4>>1]|0)+ +p[k>>3];p[f>>3]=+(m[a>>1]|0)+ +p[f>>3];p[b>>3]=l;p[k>>3]=j}g=g+1|0;if((g|0)==(d|0))break;else{a=a+6|0;f=f+24|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{k=h+(f<<3)|0;p[k>>3]=+p[k>>3]+ +(m[a+(f<<1)>>1]|0);f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<3)|0;a=a+(e<<1)|0}}return}}}function Y9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0,l=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{c=b+(f<<2)|0;k=f|1;e=b+(k<<2)|0;j=+o[a+(k<<2)>>2]+ +o[e>>2];o[c>>2]=+o[a+(f<<2)>>2]+ +o[c>>2];o[e>>2]=j;e=f|2;c=b+(e<<2)|0;k=f|3;d=b+(k<<2)|0;j=+o[a+(k<<2)>>2]+ +o[d>>2];o[c>>2]=+o[a+(e<<2)>>2]+ +o[c>>2];o[d>>2]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=b+(f<<2)|0;o[k>>2]=+o[a+(f<<2)>>2]+ +o[k>>2];f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{g=b+(f<<2)|0;if(i[c+f>>0]|0)o[g>>2]=+o[a+(f<<2)>>2]+ +o[g>>2];f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){b=f+4|0;l=+o[a+4>>2]+ +o[b>>2];k=f+8|0;j=+o[a+8>>2]+ +o[k>>2];o[f>>2]=+o[a>>2]+ +o[f>>2];o[b>>2]=l;o[k>>2]=j}g=g+1|0;if((g|0)==(d|0))break;else{a=a+12|0;f=f+12|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{k=h+(f<<2)|0;o[k>>2]=+o[a+(f<<2)>>2]+ +o[k>>2];f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<2)|0;a=a+(e<<2)|0}}return}}}function Z9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0,l=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{c=b+(f<<3)|0;k=f|1;e=b+(k<<3)|0;j=+o[a+(k<<2)>>2]+ +p[e>>3];p[c>>3]=+o[a+(f<<2)>>2]+ +p[c>>3];p[e>>3]=j;e=f|2;c=b+(e<<3)|0;k=f|3;d=b+(k<<3)|0;j=+o[a+(k<<2)>>2]+ +p[d>>3];p[c>>3]=+o[a+(e<<2)>>2]+ +p[c>>3];p[d>>3]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=b+(f<<3)|0;p[k>>3]=+p[k>>3]+ +o[a+(f<<2)>>2];f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{if(i[c+f>>0]|0){k=b+(f<<3)|0;p[k>>3]=+p[k>>3]+ +o[a+(f<<2)>>2]}f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){b=f+8|0;l=+o[a+4>>2]+ +p[b>>3];k=f+16|0;j=+o[a+8>>2]+ +p[k>>3];p[f>>3]=+o[a>>2]+ +p[f>>3];p[b>>3]=l;p[k>>3]=j}g=g+1|0;if((g|0)==(d|0))break;else{a=a+12|0;f=f+24|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{k=h+(f<<3)|0;p[k>>3]=+p[k>>3]+ +o[a+(f<<2)>>2];f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<3)|0;a=a+(e<<2)|0}}return}}}function _9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0,l=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{c=b+(f<<3)|0;k=f|1;e=b+(k<<3)|0;j=+p[a+(k<<3)>>3]+ +p[e>>3];p[c>>3]=+p[a+(f<<3)>>3]+ +p[c>>3];p[e>>3]=j;e=f|2;c=b+(e<<3)|0;k=f|3;d=b+(k<<3)|0;j=+p[a+(k<<3)>>3]+ +p[d>>3];p[c>>3]=+p[a+(e<<3)>>3]+ +p[c>>3];p[d>>3]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=b+(f<<3)|0;p[k>>3]=+p[a+(f<<3)>>3]+ +p[k>>3];f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{g=b+(f<<3)|0;if(i[c+f>>0]|0)p[g>>3]=+p[a+(f<<3)>>3]+ +p[g>>3];f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){b=f+8|0;l=+p[a+8>>3]+ +p[b>>3];k=f+16|0;j=+p[a+16>>3]+ +p[k>>3];p[f>>3]=+p[a>>3]+ +p[f>>3];p[b>>3]=l;p[k>>3]=j}g=g+1|0;if((g|0)==(d|0))break;else{a=a+24|0;f=f+24|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{k=h+(f<<3)|0;p[k>>3]=+p[a+(f<<3)>>3]+ +p[k>>3];f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<3)|0;a=a+(e<<3)|0}}return}}}function $9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0.0,m=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{j=+(l[a+f>>0]|0);d=b+(f<<2)|0;c=f|1;k=+(l[a+c>>0]|0);c=b+(c<<2)|0;k=+o[c>>2]+k*k;o[d>>2]=+o[d>>2]+j*j;o[c>>2]=k;c=f|2;k=+(l[a+c>>0]|0);c=b+(c<<2)|0;d=f|3;j=+(l[a+d>>0]|0);d=b+(d<<2)|0;j=+o[d>>2]+j*j;o[c>>2]=+o[c>>2]+k*k;o[d>>2]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=+(l[a+f>>0]|0);d=b+(f<<2)|0;o[d>>2]=+o[d>>2]+k*k;f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{if(i[c+f>>0]|0){k=+(l[a+f>>0]|0);e=b+(f<<2)|0;o[e>>2]=+o[e>>2]+k*k}f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){m=+(l[a>>0]|0);j=+(l[a+1>>0]|0);e=f+4|0;j=+o[e>>2]+j*j;k=+(l[a+2>>0]|0);b=f+8|0;k=+o[b>>2]+k*k;o[f>>2]=+o[f>>2]+m*m;o[e>>2]=j;o[b>>2]=k}g=g+1|0;if((g|0)==(d|0))break;else{a=a+3|0;f=f+12|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{m=+(l[a+f>>0]|0);b=h+(f<<2)|0;o[b>>2]=+o[b>>2]+m*m;f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<2)|0;a=a+e|0}}return}}}function aaa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0.0,m=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{j=+(l[a+f>>0]|0);d=b+(f<<3)|0;c=f|1;k=+(l[a+c>>0]|0);c=b+(c<<3)|0;k=+p[c>>3]+k*k;p[d>>3]=+p[d>>3]+j*j;p[c>>3]=k;c=f|2;k=+(l[a+c>>0]|0);c=b+(c<<3)|0;d=f|3;j=+(l[a+d>>0]|0);d=b+(d<<3)|0;j=+p[d>>3]+j*j;p[c>>3]=+p[c>>3]+k*k;p[d>>3]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=+(l[a+f>>0]|0);d=b+(f<<3)|0;p[d>>3]=+p[d>>3]+k*k;f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{if(i[c+f>>0]|0){k=+(l[a+f>>0]|0);e=b+(f<<3)|0;p[e>>3]=+p[e>>3]+k*k}f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){m=+(l[a>>0]|0);j=+(l[a+1>>0]|0);e=f+8|0;j=+p[e>>3]+j*j;k=+(l[a+2>>0]|0);b=f+16|0;k=+p[b>>3]+k*k;p[f>>3]=+p[f>>3]+m*m;p[e>>3]=j;p[b>>3]=k}g=g+1|0;if((g|0)==(d|0))break;else{a=a+3|0;f=f+24|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{m=+(l[a+f>>0]|0);b=h+(f<<3)|0;p[b>>3]=+p[b>>3]+m*m;f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<3)|0;a=a+e|0}}return}}}function baa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0.0,l=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{j=+(m[a+(f<<1)>>1]|0);d=b+(f<<2)|0;c=f|1;k=+(m[a+(c<<1)>>1]|0);c=b+(c<<2)|0;k=+o[c>>2]+k*k;o[d>>2]=+o[d>>2]+j*j;o[c>>2]=k;c=f|2;k=+(m[a+(c<<1)>>1]|0);c=b+(c<<2)|0;d=f|3;j=+(m[a+(d<<1)>>1]|0);d=b+(d<<2)|0;j=+o[d>>2]+j*j;o[c>>2]=+o[c>>2]+k*k;o[d>>2]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=+(m[a+(f<<1)>>1]|0);d=b+(f<<2)|0;o[d>>2]=+o[d>>2]+k*k;f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{if(i[c+f>>0]|0){k=+(m[a+(f<<1)>>1]|0);e=b+(f<<2)|0;o[e>>2]=+o[e>>2]+k*k}f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){l=+(m[a>>1]|0);j=+(m[a+2>>1]|0);e=f+4|0;j=+o[e>>2]+j*j;k=+(m[a+4>>1]|0);b=f+8|0;k=+o[b>>2]+k*k;o[f>>2]=+o[f>>2]+l*l;o[e>>2]=j;o[b>>2]=k}g=g+1|0;if((g|0)==(d|0))break;else{a=a+6|0;f=f+12|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{l=+(m[a+(f<<1)>>1]|0);b=h+(f<<2)|0;o[b>>2]=+o[b>>2]+l*l;f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<2)|0;a=a+(e<<1)|0}}return}}}function caa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0.0,l=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{j=+(m[a+(f<<1)>>1]|0);d=b+(f<<3)|0;c=f|1;k=+(m[a+(c<<1)>>1]|0);c=b+(c<<3)|0;k=+p[c>>3]+k*k;p[d>>3]=+p[d>>3]+j*j;p[c>>3]=k;c=f|2;k=+(m[a+(c<<1)>>1]|0);c=b+(c<<3)|0;d=f|3;j=+(m[a+(d<<1)>>1]|0);d=b+(d<<3)|0;j=+p[d>>3]+j*j;p[c>>3]=+p[c>>3]+k*k;p[d>>3]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=+(m[a+(f<<1)>>1]|0);d=b+(f<<3)|0;p[d>>3]=+p[d>>3]+k*k;f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{if(i[c+f>>0]|0){k=+(m[a+(f<<1)>>1]|0);e=b+(f<<3)|0;p[e>>3]=+p[e>>3]+k*k}f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){l=+(m[a>>1]|0);j=+(m[a+2>>1]|0);e=f+8|0;j=+p[e>>3]+j*j;k=+(m[a+4>>1]|0);b=f+16|0;k=+p[b>>3]+k*k;p[f>>3]=+p[f>>3]+l*l;p[e>>3]=j;p[b>>3]=k}g=g+1|0;if((g|0)==(d|0))break;else{a=a+6|0;f=f+24|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{l=+(m[a+(f<<1)>>1]|0);b=h+(f<<3)|0;p[b>>3]=+p[b>>3]+l*l;f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<3)|0;a=a+(e<<1)|0}}return}}}function daa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0.0,l=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{j=+o[a+(f<<2)>>2];d=b+(f<<2)|0;c=f|1;k=+o[a+(c<<2)>>2];c=b+(c<<2)|0;k=k*k+ +o[c>>2];o[d>>2]=j*j+ +o[d>>2];o[c>>2]=k;c=f|2;k=+o[a+(c<<2)>>2];c=b+(c<<2)|0;d=f|3;j=+o[a+(d<<2)>>2];d=b+(d<<2)|0;j=j*j+ +o[d>>2];o[c>>2]=k*k+ +o[c>>2];o[d>>2]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=+o[a+(f<<2)>>2];d=b+(f<<2)|0;o[d>>2]=+o[d>>2]+k*k;f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{if(i[c+f>>0]|0){k=+o[a+(f<<2)>>2];e=b+(f<<2)|0;o[e>>2]=+o[e>>2]+k*k}f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){l=+o[a>>2];j=+o[a+4>>2];e=f+4|0;j=j*j+ +o[e>>2];k=+o[a+8>>2];b=f+8|0;k=k*k+ +o[b>>2];o[f>>2]=l*l+ +o[f>>2];o[e>>2]=j;o[b>>2]=k}g=g+1|0;if((g|0)==(d|0))break;else{a=a+12|0;f=f+12|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{l=+o[a+(f<<2)>>2];b=h+(f<<2)|0;o[b>>2]=+o[b>>2]+l*l;f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<2)|0;a=a+(e<<2)|0}}return}}}function eaa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0.0,l=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{j=+o[a+(f<<2)>>2];d=b+(f<<3)|0;c=f|1;k=+o[a+(c<<2)>>2];c=b+(c<<3)|0;k=+p[c>>3]+k*k;p[d>>3]=+p[d>>3]+j*j;p[c>>3]=k;c=f|2;k=+o[a+(c<<2)>>2];c=b+(c<<3)|0;d=f|3;j=+o[a+(d<<2)>>2];d=b+(d<<3)|0;j=+p[d>>3]+j*j;p[c>>3]=+p[c>>3]+k*k;p[d>>3]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=+o[a+(f<<2)>>2];d=b+(f<<3)|0;p[d>>3]=+p[d>>3]+k*k;f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{if(i[c+f>>0]|0){k=+o[a+(f<<2)>>2];e=b+(f<<3)|0;p[e>>3]=+p[e>>3]+k*k}f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){l=+o[a>>2];j=+o[a+4>>2];e=f+8|0;j=+p[e>>3]+j*j;k=+o[a+8>>2];b=f+16|0;k=+p[b>>3]+k*k;p[f>>3]=+p[f>>3]+l*l;p[e>>3]=j;p[b>>3]=k}g=g+1|0;if((g|0)==(d|0))break;else{a=a+12|0;f=f+24|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{l=+o[a+(f<<2)>>2];b=h+(f<<3)|0;p[b>>3]=+p[b>>3]+l*l;f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<3)|0;a=a+(e<<2)|0}}return}}}function faa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0.0,l=0.0;if(!c){h=aa(e,d)|0;g=h+-4|0;if((h|0)<4)f=0;else{f=0;do{j=+p[a+(f<<3)>>3];d=b+(f<<3)|0;c=f|1;k=+p[a+(c<<3)>>3];c=b+(c<<3)|0;k=k*k+ +p[c>>3];p[d>>3]=j*j+ +p[d>>3];p[c>>3]=k;c=f|2;k=+p[a+(c<<3)>>3];c=b+(c<<3)|0;d=f|3;j=+p[a+(d<<3)>>3];d=b+(d<<3)|0;j=j*j+ +p[d>>3];p[c>>3]=k*k+ +p[c>>3];p[d>>3]=j;f=f+4|0}while((f|0)<=(g|0));f=h&-4}if((f|0)>=(h|0))return;do{k=+p[a+(f<<3)>>3];d=b+(f<<3)|0;p[d>>3]=+p[d>>3]+k*k;f=f+1|0}while((f|0)!=(h|0));return}switch(e|0){case 1:{if((d|0)>0)f=0;else return;do{if(i[c+f>>0]|0){k=+p[a+(f<<3)>>3];e=b+(f<<3)|0;p[e>>3]=+p[e>>3]+k*k}f=f+1|0}while((f|0)!=(d|0));return}case 3:{if((d|0)>0){f=b;g=0}else return;while(1){if(i[c+g>>0]|0){l=+p[a>>3];j=+p[a+8>>3];e=f+8|0;j=j*j+ +p[e>>3];k=+p[a+16>>3];b=f+16|0;k=k*k+ +p[b>>3];p[f>>3]=l*l+ +p[f>>3];p[e>>3]=j;p[b>>3]=k}g=g+1|0;if((g|0)==(d|0))break;else{a=a+24|0;f=f+24|0}}return}default:{if((d|0)>0&(e|0)>0){h=b;g=0}else return;while(1){if(i[c+g>>0]|0){f=0;do{l=+p[a+(f<<3)>>3];b=h+(f<<3)|0;p[b>>3]=+p[b>>3]+l*l;f=f+1|0}while((f|0)!=(e|0))}g=g+1|0;if((g|0)==(d|0))break;else{h=h+(e<<3)|0;a=a+(e<<3)|0}}return}}}function gaa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0.0,m=0,n=0.0;if(!d){j=aa(f,e)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{d=c+(g<<2)|0;m=g|1;f=c+(m<<2)|0;k=+o[f>>2]+ +(l[a+m>>0]|0)*+(l[b+m>>0]|0);o[d>>2]=+o[d>>2]+ +(l[a+g>>0]|0)*+(l[b+g>>0]|0);o[f>>2]=k;f=g|2;d=c+(f<<2)|0;m=g|3;e=c+(m<<2)|0;k=+o[e>>2]+ +(l[a+m>>0]|0)*+(l[b+m>>0]|0);o[d>>2]=+o[d>>2]+ +(l[a+f>>0]|0)*+(l[b+f>>0]|0);o[e>>2]=k;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{m=c+(g<<2)|0;o[m>>2]=+o[m>>2]+ +(l[a+g>>0]|0)*+(l[b+g>>0]|0);g=g+1|0}while((g|0)!=(j|0));return}switch(f|0){case 1:{if((e|0)>0)g=0;else return;do{if(i[d+g>>0]|0){m=c+(g<<2)|0;o[m>>2]=+o[m>>2]+ +(l[a+g>>0]|0)*+(l[b+g>>0]|0)}g=g+1|0}while((g|0)!=(e|0));return}case 3:{if((e|0)>0){g=c;h=0}else return;while(1){if(i[d+h>>0]|0){c=g+4|0;n=+o[c>>2]+ +(l[a+1>>0]|0)*+(l[b+1>>0]|0);m=g+8|0;k=+o[m>>2]+ +(l[a+2>>0]|0)*+(l[b+2>>0]|0);o[g>>2]=+o[g>>2]+ +(l[a>>0]|0)*+(l[b>>0]|0);o[c>>2]=n;o[m>>2]=k}h=h+1|0;if((h|0)==(e|0))break;else{a=a+3|0;b=b+3|0;g=g+12|0}}return}default:{if((e|0)>0&(f|0)>0){j=c;h=0}else return;while(1){if(i[d+h>>0]|0){g=0;do{m=j+(g<<2)|0;o[m>>2]=+o[m>>2]+ +(l[a+g>>0]|0)*+(l[b+g>>0]|0);g=g+1|0}while((g|0)!=(f|0))}h=h+1|0;if((h|0)==(e|0))break;else{b=b+f|0;j=j+(f<<2)|0;a=a+f|0}}return}}}function haa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0.0,m=0,n=0.0;if(!d){j=aa(f,e)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{d=c+(g<<3)|0;m=g|1;f=c+(m<<3)|0;k=+p[f>>3]+ +(l[a+m>>0]|0)*+(l[b+m>>0]|0);p[d>>3]=+p[d>>3]+ +(l[a+g>>0]|0)*+(l[b+g>>0]|0);p[f>>3]=k;f=g|2;d=c+(f<<3)|0;m=g|3;e=c+(m<<3)|0;k=+p[e>>3]+ +(l[a+m>>0]|0)*+(l[b+m>>0]|0);p[d>>3]=+p[d>>3]+ +(l[a+f>>0]|0)*+(l[b+f>>0]|0);p[e>>3]=k;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{m=c+(g<<3)|0;p[m>>3]=+p[m>>3]+ +(l[a+g>>0]|0)*+(l[b+g>>0]|0);g=g+1|0}while((g|0)!=(j|0));return}switch(f|0){case 1:{if((e|0)>0)g=0;else return;do{if(i[d+g>>0]|0){m=c+(g<<3)|0;p[m>>3]=+p[m>>3]+ +(l[a+g>>0]|0)*+(l[b+g>>0]|0)}g=g+1|0}while((g|0)!=(e|0));return}case 3:{if((e|0)>0){g=c;h=0}else return;while(1){if(i[d+h>>0]|0){c=g+8|0;n=+p[c>>3]+ +(l[a+1>>0]|0)*+(l[b+1>>0]|0);m=g+16|0;k=+p[m>>3]+ +(l[a+2>>0]|0)*+(l[b+2>>0]|0);p[g>>3]=+p[g>>3]+ +(l[a>>0]|0)*+(l[b>>0]|0);p[c>>3]=n;p[m>>3]=k}h=h+1|0;if((h|0)==(e|0))break;else{a=a+3|0;b=b+3|0;g=g+24|0}}return}default:{if((e|0)>0&(f|0)>0){j=c;h=0}else return;while(1){if(i[d+h>>0]|0){g=0;do{m=j+(g<<3)|0;p[m>>3]=+p[m>>3]+ +(l[a+g>>0]|0)*+(l[b+g>>0]|0);g=g+1|0}while((g|0)!=(f|0))}h=h+1|0;if((h|0)==(e|0))break;else{b=b+f|0;j=j+(f<<3)|0;a=a+f|0}}return}}}function iaa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0.0,l=0,n=0.0;if(!d){j=aa(f,e)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{d=c+(g<<2)|0;l=g|1;f=c+(l<<2)|0;k=+o[f>>2]+ +(m[a+(l<<1)>>1]|0)*+(m[b+(l<<1)>>1]|0);o[d>>2]=+o[d>>2]+ +(m[a+(g<<1)>>1]|0)*+(m[b+(g<<1)>>1]|0);o[f>>2]=k;f=g|2;d=c+(f<<2)|0;l=g|3;e=c+(l<<2)|0;k=+o[e>>2]+ +(m[a+(l<<1)>>1]|0)*+(m[b+(l<<1)>>1]|0);o[d>>2]=+o[d>>2]+ +(m[a+(f<<1)>>1]|0)*+(m[b+(f<<1)>>1]|0);o[e>>2]=k;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{l=c+(g<<2)|0;o[l>>2]=+o[l>>2]+ +(m[a+(g<<1)>>1]|0)*+(m[b+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(j|0));return}switch(f|0){case 1:{if((e|0)>0)g=0;else return;do{if(i[d+g>>0]|0){l=c+(g<<2)|0;o[l>>2]=+o[l>>2]+ +(m[a+(g<<1)>>1]|0)*+(m[b+(g<<1)>>1]|0)}g=g+1|0}while((g|0)!=(e|0));return}case 3:{if((e|0)>0){g=c;h=0}else return;while(1){if(i[d+h>>0]|0){c=g+4|0;n=+o[c>>2]+ +(m[a+2>>1]|0)*+(m[b+2>>1]|0);l=g+8|0;k=+o[l>>2]+ +(m[a+4>>1]|0)*+(m[b+4>>1]|0);o[g>>2]=+o[g>>2]+ +(m[a>>1]|0)*+(m[b>>1]|0);o[c>>2]=n;o[l>>2]=k}h=h+1|0;if((h|0)==(e|0))break;else{a=a+6|0;b=b+6|0;g=g+12|0}}return}default:{if((e|0)>0&(f|0)>0){j=c;h=0}else return;while(1){if(i[d+h>>0]|0){g=0;do{l=j+(g<<2)|0;o[l>>2]=+o[l>>2]+ +(m[a+(g<<1)>>1]|0)*+(m[b+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(f|0))}h=h+1|0;if((h|0)==(e|0))break;else{b=b+(f<<1)|0;j=j+(f<<2)|0;a=a+(f<<1)|0}}return}}}function jaa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0.0,l=0,n=0.0;if(!d){j=aa(f,e)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{d=c+(g<<3)|0;l=g|1;f=c+(l<<3)|0;k=+p[f>>3]+ +(m[a+(l<<1)>>1]|0)*+(m[b+(l<<1)>>1]|0);p[d>>3]=+p[d>>3]+ +(m[a+(g<<1)>>1]|0)*+(m[b+(g<<1)>>1]|0);p[f>>3]=k;f=g|2;d=c+(f<<3)|0;l=g|3;e=c+(l<<3)|0;k=+p[e>>3]+ +(m[a+(l<<1)>>1]|0)*+(m[b+(l<<1)>>1]|0);p[d>>3]=+p[d>>3]+ +(m[a+(f<<1)>>1]|0)*+(m[b+(f<<1)>>1]|0);p[e>>3]=k;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{l=c+(g<<3)|0;p[l>>3]=+p[l>>3]+ +(m[a+(g<<1)>>1]|0)*+(m[b+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(j|0));return}switch(f|0){case 1:{if((e|0)>0)g=0;else return;do{if(i[d+g>>0]|0){l=c+(g<<3)|0;p[l>>3]=+p[l>>3]+ +(m[a+(g<<1)>>1]|0)*+(m[b+(g<<1)>>1]|0)}g=g+1|0}while((g|0)!=(e|0));return}case 3:{if((e|0)>0){g=c;h=0}else return;while(1){if(i[d+h>>0]|0){c=g+8|0;n=+p[c>>3]+ +(m[a+2>>1]|0)*+(m[b+2>>1]|0);l=g+16|0;k=+p[l>>3]+ +(m[a+4>>1]|0)*+(m[b+4>>1]|0);p[g>>3]=+p[g>>3]+ +(m[a>>1]|0)*+(m[b>>1]|0);p[c>>3]=n;p[l>>3]=k}h=h+1|0;if((h|0)==(e|0))break;else{a=a+6|0;b=b+6|0;g=g+24|0}}return}default:{if((e|0)>0&(f|0)>0){j=c;h=0}else return;while(1){if(i[d+h>>0]|0){g=0;do{l=j+(g<<3)|0;p[l>>3]=+p[l>>3]+ +(m[a+(g<<1)>>1]|0)*+(m[b+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(f|0))}h=h+1|0;if((h|0)==(e|0))break;else{b=b+(f<<1)|0;j=j+(f<<3)|0;a=a+(f<<1)|0}}return}}}function kaa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0.0,l=0,m=0.0;if(!d){j=aa(f,e)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{d=c+(g<<2)|0;l=g|1;f=c+(l<<2)|0;k=+o[a+(l<<2)>>2]*+o[b+(l<<2)>>2]+ +o[f>>2];o[d>>2]=+o[a+(g<<2)>>2]*+o[b+(g<<2)>>2]+ +o[d>>2];o[f>>2]=k;f=g|2;d=c+(f<<2)|0;l=g|3;e=c+(l<<2)|0;k=+o[a+(l<<2)>>2]*+o[b+(l<<2)>>2]+ +o[e>>2];o[d>>2]=+o[a+(f<<2)>>2]*+o[b+(f<<2)>>2]+ +o[d>>2];o[e>>2]=k;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{l=c+(g<<2)|0;o[l>>2]=+o[l>>2]+ +o[a+(g<<2)>>2]*+o[b+(g<<2)>>2];g=g+1|0}while((g|0)!=(j|0));return}switch(f|0){case 1:{if((e|0)>0)g=0;else return;do{if(i[d+g>>0]|0){l=c+(g<<2)|0;o[l>>2]=+o[l>>2]+ +o[a+(g<<2)>>2]*+o[b+(g<<2)>>2]}g=g+1|0}while((g|0)!=(e|0));return}case 3:{if((e|0)>0){g=c;h=0}else return;while(1){if(i[d+h>>0]|0){c=g+4|0;m=+o[a+4>>2]*+o[b+4>>2]+ +o[c>>2];l=g+8|0;k=+o[a+8>>2]*+o[b+8>>2]+ +o[l>>2];o[g>>2]=+o[a>>2]*+o[b>>2]+ +o[g>>2];o[c>>2]=m;o[l>>2]=k}h=h+1|0;if((h|0)==(e|0))break;else{a=a+12|0;b=b+12|0;g=g+12|0}}return}default:{if((e|0)>0&(f|0)>0){j=c;h=0}else return;while(1){if(i[d+h>>0]|0){g=0;do{l=j+(g<<2)|0;o[l>>2]=+o[l>>2]+ +o[a+(g<<2)>>2]*+o[b+(g<<2)>>2];g=g+1|0}while((g|0)!=(f|0))}h=h+1|0;if((h|0)==(e|0))break;else{b=b+(f<<2)|0;j=j+(f<<2)|0;a=a+(f<<2)|0}}return}}}function laa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0.0,l=0,m=0.0;if(!d){j=aa(f,e)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{d=c+(g<<3)|0;l=g|1;f=c+(l<<3)|0;k=+p[f>>3]+ +o[a+(l<<2)>>2]*+o[b+(l<<2)>>2];p[d>>3]=+p[d>>3]+ +o[a+(g<<2)>>2]*+o[b+(g<<2)>>2];p[f>>3]=k;f=g|2;d=c+(f<<3)|0;l=g|3;e=c+(l<<3)|0;k=+p[e>>3]+ +o[a+(l<<2)>>2]*+o[b+(l<<2)>>2];p[d>>3]=+p[d>>3]+ +o[a+(f<<2)>>2]*+o[b+(f<<2)>>2];p[e>>3]=k;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{l=c+(g<<3)|0;p[l>>3]=+p[l>>3]+ +o[a+(g<<2)>>2]*+o[b+(g<<2)>>2];g=g+1|0}while((g|0)!=(j|0));return}switch(f|0){case 1:{if((e|0)>0)g=0;else return;do{if(i[d+g>>0]|0){l=c+(g<<3)|0;p[l>>3]=+p[l>>3]+ +o[a+(g<<2)>>2]*+o[b+(g<<2)>>2]}g=g+1|0}while((g|0)!=(e|0));return}case 3:{if((e|0)>0){g=c;h=0}else return;while(1){if(i[d+h>>0]|0){c=g+8|0;m=+p[c>>3]+ +o[a+4>>2]*+o[b+4>>2];l=g+16|0;k=+p[l>>3]+ +o[a+8>>2]*+o[b+8>>2];p[g>>3]=+p[g>>3]+ +o[a>>2]*+o[b>>2];p[c>>3]=m;p[l>>3]=k}h=h+1|0;if((h|0)==(e|0))break;else{a=a+12|0;b=b+12|0;g=g+24|0}}return}default:{if((e|0)>0&(f|0)>0){j=c;h=0}else return;while(1){if(i[d+h>>0]|0){g=0;do{l=j+(g<<3)|0;p[l>>3]=+p[l>>3]+ +o[a+(g<<2)>>2]*+o[b+(g<<2)>>2];g=g+1|0}while((g|0)!=(f|0))}h=h+1|0;if((h|0)==(e|0))break;else{b=b+(f<<2)|0;j=j+(f<<3)|0;a=a+(f<<2)|0}}return}}}function maa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0.0,l=0,m=0.0;if(!d){j=aa(f,e)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{d=c+(g<<3)|0;l=g|1;f=c+(l<<3)|0;k=+p[a+(l<<3)>>3]*+p[b+(l<<3)>>3]+ +p[f>>3];p[d>>3]=+p[a+(g<<3)>>3]*+p[b+(g<<3)>>3]+ +p[d>>3];p[f>>3]=k;f=g|2;d=c+(f<<3)|0;l=g|3;e=c+(l<<3)|0;k=+p[a+(l<<3)>>3]*+p[b+(l<<3)>>3]+ +p[e>>3];p[d>>3]=+p[a+(f<<3)>>3]*+p[b+(f<<3)>>3]+ +p[d>>3];p[e>>3]=k;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{l=c+(g<<3)|0;p[l>>3]=+p[l>>3]+ +p[a+(g<<3)>>3]*+p[b+(g<<3)>>3];g=g+1|0}while((g|0)!=(j|0));return}switch(f|0){case 1:{if((e|0)>0)g=0;else return;do{if(i[d+g>>0]|0){l=c+(g<<3)|0;p[l>>3]=+p[l>>3]+ +p[a+(g<<3)>>3]*+p[b+(g<<3)>>3]}g=g+1|0}while((g|0)!=(e|0));return}case 3:{if((e|0)>0){g=c;h=0}else return;while(1){if(i[d+h>>0]|0){c=g+8|0;m=+p[a+8>>3]*+p[b+8>>3]+ +p[c>>3];l=g+16|0;k=+p[a+16>>3]*+p[b+16>>3]+ +p[l>>3];p[g>>3]=+p[a>>3]*+p[b>>3]+ +p[g>>3];p[c>>3]=m;p[l>>3]=k}h=h+1|0;if((h|0)==(e|0))break;else{a=a+24|0;b=b+24|0;g=g+24|0}}return}default:{if((e|0)>0&(f|0)>0){j=c;h=0}else return;while(1){if(i[d+h>>0]|0){g=0;do{l=j+(g<<3)|0;p[l>>3]=+p[l>>3]+ +p[a+(g<<3)>>3]*+p[b+(g<<3)>>3];g=g+1|0}while((g|0)!=(f|0))}h=h+1|0;if((h|0)==(e|0))break;else{b=b+(f<<3)|0;j=j+(f<<3)|0;a=a+(f<<3)|0}}return}}}function naa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,j=0,k=0.0,m=0.0,n=0,p=0.0;k=1.0-f;if(!c){j=aa(e,d)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{c=b+(g<<2)|0;n=g|1;e=b+(n<<2)|0;m=f*+(l[a+n>>0]|0)+k*+o[e>>2];o[c>>2]=f*+(l[a+g>>0]|0)+k*+o[c>>2];o[e>>2]=m;e=g|2;c=b+(e<<2)|0;n=g|3;d=b+(n<<2)|0;m=f*+(l[a+n>>0]|0)+k*+o[d>>2];o[c>>2]=f*+(l[a+e>>0]|0)+k*+o[c>>2];o[d>>2]=m;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{n=b+(g<<2)|0;o[n>>2]=f*+(l[a+g>>0]|0)+k*+o[n>>2];g=g+1|0}while((g|0)!=(j|0));return}switch(e|0){case 1:{if((d|0)>0)g=0;else return;do{if(i[c+g>>0]|0){n=b+(g<<2)|0;o[n>>2]=f*+(l[a+g>>0]|0)+k*+o[n>>2]}g=g+1|0}while((g|0)!=(d|0));return}case 3:{if((d|0)>0){g=b;h=0}else return;while(1){if(i[c+h>>0]|0){b=g+4|0;p=f*+(l[a+1>>0]|0)+k*+o[b>>2];n=g+8|0;m=f*+(l[a+2>>0]|0)+k*+o[n>>2];o[g>>2]=f*+(l[a>>0]|0)+k*+o[g>>2];o[b>>2]=p;o[n>>2]=m}h=h+1|0;if((h|0)==(d|0))break;else{a=a+3|0;g=g+12|0}}return}default:{if((d|0)>0&(e|0)>0){j=b;h=0}else return;while(1){if(i[c+h>>0]|0){g=0;do{n=j+(g<<2)|0;o[n>>2]=f*+(l[a+g>>0]|0)+k*+o[n>>2];g=g+1|0}while((g|0)!=(e|0))}h=h+1|0;if((h|0)==(d|0))break;else{j=j+(e<<2)|0;a=a+e|0}}return}}}function oaa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,j=0,k=0.0,m=0.0,n=0,o=0.0;k=1.0-f;if(!c){j=aa(e,d)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{c=b+(g<<3)|0;n=g|1;e=b+(n<<3)|0;m=+(l[a+n>>0]|0)*f+k*+p[e>>3];p[c>>3]=+(l[a+g>>0]|0)*f+k*+p[c>>3];p[e>>3]=m;e=g|2;c=b+(e<<3)|0;n=g|3;d=b+(n<<3)|0;m=+(l[a+n>>0]|0)*f+k*+p[d>>3];p[c>>3]=+(l[a+e>>0]|0)*f+k*+p[c>>3];p[d>>3]=m;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{n=b+(g<<3)|0;p[n>>3]=+(l[a+g>>0]|0)*f+k*+p[n>>3];g=g+1|0}while((g|0)!=(j|0));return}switch(e|0){case 1:{if((d|0)>0)g=0;else return;do{if(i[c+g>>0]|0){n=b+(g<<3)|0;p[n>>3]=+(l[a+g>>0]|0)*f+k*+p[n>>3]}g=g+1|0}while((g|0)!=(d|0));return}case 3:{if((d|0)>0){g=b;h=0}else return;while(1){if(i[c+h>>0]|0){b=g+8|0;o=+(l[a+1>>0]|0)*f+k*+p[b>>3];n=g+16|0;m=+(l[a+2>>0]|0)*f+k*+p[n>>3];p[g>>3]=+(l[a>>0]|0)*f+k*+p[g>>3];p[b>>3]=o;p[n>>3]=m}h=h+1|0;if((h|0)==(d|0))break;else{a=a+3|0;g=g+24|0}}return}default:{if((d|0)>0&(e|0)>0){j=b;h=0}else return;while(1){if(i[c+h>>0]|0){g=0;do{n=j+(g<<3)|0;p[n>>3]=+(l[a+g>>0]|0)*f+k*+p[n>>3];g=g+1|0}while((g|0)!=(e|0))}h=h+1|0;if((h|0)==(d|0))break;else{j=j+(e<<3)|0;a=a+e|0}}return}}}function paa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,j=0,k=0.0,l=0.0,n=0,p=0.0;k=1.0-f;if(!c){j=aa(e,d)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{c=b+(g<<2)|0;n=g|1;e=b+(n<<2)|0;l=f*+(m[a+(n<<1)>>1]|0)+k*+o[e>>2];o[c>>2]=f*+(m[a+(g<<1)>>1]|0)+k*+o[c>>2];o[e>>2]=l;e=g|2;c=b+(e<<2)|0;n=g|3;d=b+(n<<2)|0;l=f*+(m[a+(n<<1)>>1]|0)+k*+o[d>>2];o[c>>2]=f*+(m[a+(e<<1)>>1]|0)+k*+o[c>>2];o[d>>2]=l;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{n=b+(g<<2)|0;o[n>>2]=f*+(m[a+(g<<1)>>1]|0)+k*+o[n>>2];g=g+1|0}while((g|0)!=(j|0));return}switch(e|0){case 1:{if((d|0)>0)g=0;else return;do{if(i[c+g>>0]|0){n=b+(g<<2)|0;o[n>>2]=f*+(m[a+(g<<1)>>1]|0)+k*+o[n>>2]}g=g+1|0}while((g|0)!=(d|0));return}case 3:{if((d|0)>0){g=b;h=0}else return;while(1){if(i[c+h>>0]|0){b=g+4|0;p=f*+(m[a+2>>1]|0)+k*+o[b>>2];n=g+8|0;l=f*+(m[a+4>>1]|0)+k*+o[n>>2];o[g>>2]=f*+(m[a>>1]|0)+k*+o[g>>2];o[b>>2]=p;o[n>>2]=l}h=h+1|0;if((h|0)==(d|0))break;else{a=a+6|0;g=g+12|0}}return}default:{if((d|0)>0&(e|0)>0){j=b;h=0}else return;while(1){if(i[c+h>>0]|0){g=0;do{n=j+(g<<2)|0;o[n>>2]=f*+(m[a+(g<<1)>>1]|0)+k*+o[n>>2];g=g+1|0}while((g|0)!=(e|0))}h=h+1|0;if((h|0)==(d|0))break;else{j=j+(e<<2)|0;a=a+(e<<1)|0}}return}}}function qaa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,j=0,k=0.0,l=0.0,n=0,o=0.0;k=1.0-f;if(!c){j=aa(e,d)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{c=b+(g<<3)|0;n=g|1;e=b+(n<<3)|0;l=+(m[a+(n<<1)>>1]|0)*f+k*+p[e>>3];p[c>>3]=+(m[a+(g<<1)>>1]|0)*f+k*+p[c>>3];p[e>>3]=l;e=g|2;c=b+(e<<3)|0;n=g|3;d=b+(n<<3)|0;l=+(m[a+(n<<1)>>1]|0)*f+k*+p[d>>3];p[c>>3]=+(m[a+(e<<1)>>1]|0)*f+k*+p[c>>3];p[d>>3]=l;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{n=b+(g<<3)|0;p[n>>3]=+(m[a+(g<<1)>>1]|0)*f+k*+p[n>>3];g=g+1|0}while((g|0)!=(j|0));return}switch(e|0){case 1:{if((d|0)>0)g=0;else return;do{if(i[c+g>>0]|0){n=b+(g<<3)|0;p[n>>3]=+(m[a+(g<<1)>>1]|0)*f+k*+p[n>>3]}g=g+1|0}while((g|0)!=(d|0));return}case 3:{if((d|0)>0){g=b;h=0}else return;while(1){if(i[c+h>>0]|0){b=g+8|0;o=+(m[a+2>>1]|0)*f+k*+p[b>>3];n=g+16|0;l=+(m[a+4>>1]|0)*f+k*+p[n>>3];p[g>>3]=+(m[a>>1]|0)*f+k*+p[g>>3];p[b>>3]=o;p[n>>3]=l}h=h+1|0;if((h|0)==(d|0))break;else{a=a+6|0;g=g+24|0}}return}default:{if((d|0)>0&(e|0)>0){j=b;h=0}else return;while(1){if(i[c+h>>0]|0){g=0;do{n=j+(g<<3)|0;p[n>>3]=+(m[a+(g<<1)>>1]|0)*f+k*+p[n>>3];g=g+1|0}while((g|0)!=(e|0))}h=h+1|0;if((h|0)==(d|0))break;else{j=j+(e<<3)|0;a=a+(e<<1)|0}}return}}}function raa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,j=0,k=0.0,l=0.0,m=0,n=0.0;k=1.0-f;if(!c){j=aa(e,d)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{c=b+(g<<2)|0;m=g|1;e=b+(m<<2)|0;l=f*+o[a+(m<<2)>>2]+k*+o[e>>2];o[c>>2]=f*+o[a+(g<<2)>>2]+k*+o[c>>2];o[e>>2]=l;e=g|2;c=b+(e<<2)|0;m=g|3;d=b+(m<<2)|0;l=f*+o[a+(m<<2)>>2]+k*+o[d>>2];o[c>>2]=f*+o[a+(e<<2)>>2]+k*+o[c>>2];o[d>>2]=l;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{m=b+(g<<2)|0;o[m>>2]=f*+o[a+(g<<2)>>2]+k*+o[m>>2];g=g+1|0}while((g|0)!=(j|0));return}switch(e|0){case 1:{if((d|0)>0)g=0;else return;do{if(i[c+g>>0]|0){m=b+(g<<2)|0;o[m>>2]=f*+o[a+(g<<2)>>2]+k*+o[m>>2]}g=g+1|0}while((g|0)!=(d|0));return}case 3:{if((d|0)>0){g=b;h=0}else return;while(1){if(i[c+h>>0]|0){b=g+4|0;n=f*+o[a+4>>2]+k*+o[b>>2];m=g+8|0;l=f*+o[a+8>>2]+k*+o[m>>2];o[g>>2]=f*+o[a>>2]+k*+o[g>>2];o[b>>2]=n;o[m>>2]=l}h=h+1|0;if((h|0)==(d|0))break;else{a=a+12|0;g=g+12|0}}return}default:{if((d|0)>0&(e|0)>0){j=b;h=0}else return;while(1){if(i[c+h>>0]|0){g=0;do{m=j+(g<<2)|0;o[m>>2]=f*+o[a+(g<<2)>>2]+k*+o[m>>2];g=g+1|0}while((g|0)!=(e|0))}h=h+1|0;if((h|0)==(d|0))break;else{j=j+(e<<2)|0;a=a+(e<<2)|0}}return}}}function saa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,j=0,k=0.0,l=0.0,m=0,n=0.0;k=1.0-f;if(!c){j=aa(e,d)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{c=b+(g<<3)|0;m=g|1;e=b+(m<<3)|0;l=+o[a+(m<<2)>>2]*f+k*+p[e>>3];p[c>>3]=+o[a+(g<<2)>>2]*f+k*+p[c>>3];p[e>>3]=l;e=g|2;c=b+(e<<3)|0;m=g|3;d=b+(m<<3)|0;l=+o[a+(m<<2)>>2]*f+k*+p[d>>3];p[c>>3]=+o[a+(e<<2)>>2]*f+k*+p[c>>3];p[d>>3]=l;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{m=b+(g<<3)|0;p[m>>3]=+o[a+(g<<2)>>2]*f+k*+p[m>>3];g=g+1|0}while((g|0)!=(j|0));return}switch(e|0){case 1:{if((d|0)>0)g=0;else return;do{if(i[c+g>>0]|0){m=b+(g<<3)|0;p[m>>3]=+o[a+(g<<2)>>2]*f+k*+p[m>>3]}g=g+1|0}while((g|0)!=(d|0));return}case 3:{if((d|0)>0){g=b;h=0}else return;while(1){if(i[c+h>>0]|0){b=g+8|0;n=+o[a+4>>2]*f+k*+p[b>>3];m=g+16|0;l=+o[a+8>>2]*f+k*+p[m>>3];p[g>>3]=+o[a>>2]*f+k*+p[g>>3];p[b>>3]=n;p[m>>3]=l}h=h+1|0;if((h|0)==(d|0))break;else{a=a+12|0;g=g+24|0}}return}default:{if((d|0)>0&(e|0)>0){j=b;h=0}else return;while(1){if(i[c+h>>0]|0){g=0;do{m=j+(g<<3)|0;p[m>>3]=+o[a+(g<<2)>>2]*f+k*+p[m>>3];g=g+1|0}while((g|0)!=(e|0))}h=h+1|0;if((h|0)==(d|0))break;else{j=j+(e<<3)|0;a=a+(e<<2)|0}}return}}}function taa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,j=0,k=0.0,l=0.0,m=0,n=0.0;k=1.0-f;if(!c){j=aa(e,d)|0;h=j+-4|0;if((j|0)<4)g=0;else{g=0;do{c=b+(g<<3)|0;m=g|1;e=b+(m<<3)|0;l=+p[a+(m<<3)>>3]*f+k*+p[e>>3];p[c>>3]=+p[a+(g<<3)>>3]*f+k*+p[c>>3];p[e>>3]=l;e=g|2;c=b+(e<<3)|0;m=g|3;d=b+(m<<3)|0;l=+p[a+(m<<3)>>3]*f+k*+p[d>>3];p[c>>3]=+p[a+(e<<3)>>3]*f+k*+p[c>>3];p[d>>3]=l;g=g+4|0}while((g|0)<=(h|0));g=j&-4}if((g|0)>=(j|0))return;do{m=b+(g<<3)|0;p[m>>3]=+p[a+(g<<3)>>3]*f+k*+p[m>>3];g=g+1|0}while((g|0)!=(j|0));return}switch(e|0){case 1:{if((d|0)>0)g=0;else return;do{if(i[c+g>>0]|0){m=b+(g<<3)|0;p[m>>3]=+p[a+(g<<3)>>3]*f+k*+p[m>>3]}g=g+1|0}while((g|0)!=(d|0));return}case 3:{if((d|0)>0){g=b;h=0}else return;while(1){if(i[c+h>>0]|0){b=g+8|0;n=+p[a+8>>3]*f+k*+p[b>>3];m=g+16|0;l=+p[a+16>>3]*f+k*+p[m>>3];p[g>>3]=+p[a>>3]*f+k*+p[g>>3];p[b>>3]=n;p[m>>3]=l}h=h+1|0;if((h|0)==(d|0))break;else{a=a+24|0;g=g+24|0}}return}default:{if((d|0)>0&(e|0)>0){j=b;h=0}else return;while(1){if(i[c+h>>0]|0){g=0;do{m=j+(g<<3)|0;p[m>>3]=+p[a+(g<<3)>>3]*f+k*+p[m>>3];g=g+1|0}while((g|0)!=(e|0))}h=h+1|0;if((h|0)==(d|0))break;else{j=j+(e<<3)|0;a=a+(e<<3)|0}}return}}}function uaa(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;var g=0,h=0,m=0,n=0,o=0.0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;ja=r;r=r+1312|0;ea=ja+272|0;m=ja+264|0;n=ja+256|0;ia=ja+200|0;ha=ja+144|0;ga=ja+88|0;fa=ja+32|0;P=ja+16|0;da=ja;ca=S1(a,-1)|0;u=ca>>>3&511;Q=u+1|0;R1(m,a,-1);if(ca&7|0){g=ea+4|0;h=ZT(20)|0;k[h>>2]=1;q=h+4|0;k[ea>>2]=q;k[g>>2]=14;i[h+18>>0]=0;p=403519;s=q+14|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));Y8(-215,ea,236463,236469,599);k[g>>2]=0;k[ea>>2]=0;ca=k[h>>2]|0;k[h>>2]=ca+-1;if((ca|0)==1)ggb(k[h+-4>>2]|0)}k[n>>2]=k[m>>2];k[n+4>>2]=k[m+4>>2];x2(b,n,0,0);t=(e|0)<0&(f^1);M=t|f;t=t?e&2147483647:e;if(!(t&1))S=7;else switch(t|0){case 3:case 4:case 5:case 6:case 7:case -1:break;default:S=7}if((S|0)==7){g=ea+4|0;h=ZT(32)|0;k[h>>2]=1;q=h+4|0;k[ea>>2]=q;k[g>>2]=27;i[h+31>>0]=0;p=236536;s=q+27|0;do{i[q>>0]=i[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(s|0));Y8(-206,ea,236463,236469,610);k[g>>2]=0;k[ea>>2]=0;ca=k[h>>2]|0;k[h>>2]=ca+-1;if((ca|0)==1)ggb(k[h+-4>>2]|0)}ca=c>d;o=ca?c:d;c=ca?d:c;do if((k[a>>2]&2031616|0)==65536){n=k[a+4>>2]|0;k[ia>>2]=k[n>>2];a=ia+4|0;g=n+4|0;k[a>>2]=k[g>>2];ca=ia+8|0;k[ca>>2]=k[n+8>>2];k[ia+12>>2]=k[n+12>>2];k[ia+16>>2]=k[n+16>>2];k[ia+20>>2]=k[n+20>>2];k[ia+24>>2]=k[n+24>>2];k[ia+28>>2]=k[n+28>>2];k[ia+32>>2]=k[n+32>>2];h=k[n+36>>2]|0;k[ia+36>>2]=h;f=ia+40|0;k[f>>2]=ca;ca=ia+48|0;p=ia+44|0;k[p>>2]=ca;k[ia+52>>2]=0;k[ca>>2]=0;if(h|0){ca=h+12|0;k[ca>>2]=(k[ca>>2]|0)+1}if((k[g>>2]|0)<3){ba=k[n+44>>2]|0;ca=k[p>>2]|0;k[ca>>2]=k[ba>>2];k[ca+4>>2]=k[ba+4>>2];break}k[a>>2]=0;x1(ia,k[g>>2]|0,0,0,0);if((k[a>>2]|0)>0){e=k[n+40>>2]|0;m=k[f>>2]|0;f=k[n+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[e+(g<<2)>>2];k[h+(g<<2)>>2]=k[f+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else Q1(ia,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){m=k[b+4>>2]|0;k[ha>>2]=k[m>>2];a=ha+4|0;g=m+4|0;k[a>>2]=k[g>>2];ca=ha+8|0;k[ca>>2]=k[m+8>>2];k[ha+12>>2]=k[m+12>>2];k[ha+16>>2]=k[m+16>>2];k[ha+20>>2]=k[m+20>>2];k[ha+24>>2]=k[m+24>>2];k[ha+28>>2]=k[m+28>>2];k[ha+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[ha+36>>2]=h;f=ha+40|0;k[f>>2]=ca;ca=ha+48|0;e=ha+44|0;k[e>>2]=ca;k[ha+52>>2]=0;k[ca>>2]=0;if(h|0){ca=h+12|0;k[ca>>2]=(k[ca>>2]|0)+1}if((k[g>>2]|0)<3){ba=k[m+44>>2]|0;ca=k[e>>2]|0;k[ca>>2]=k[ba>>2];k[ca+4>>2]=k[ba+4>>2];break}k[a>>2]=0;x1(ha,k[g>>2]|0,0,0,0);if((k[a>>2]|0)>0){p=k[m+40>>2]|0;n=k[f>>2]|0;f=k[m+44>>2]|0;h=k[e>>2]|0;g=0;do{k[n+(g<<2)>>2]=k[p+(g<<2)>>2];k[h+(g<<2)>>2]=k[f+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else Q1(ha,b,-1);while(0);T=ia+8|0;f=k[T>>2]|0;U=ia+12|0;m=k[U>>2]|0;h=u<<3;k[ga>>2]=1124007936;ba=ga+4|0;g=ga+8|0;_=ga+40|0;q=ba;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[_>>2]=g;ca=ga+48|0;$=ga+44|0;k[$>>2]=ca;k[ga+52>>2]=0;k[ca>>2]=0;e=h|3;k[ea>>2]=f;n=ea+4|0;k[n>>2]=m;G1(ga,2,ea,e);h=k[T>>2]|0;f=k[U>>2]|0;k[fa>>2]=1124007936;Y=fa+4|0;g=fa+8|0;W=fa+40|0;q=Y;s=q+36|0;do{k[q>>2]=0;q=q+4|0}while((q|0)<(s|0));k[W>>2]=g;X=fa+48|0;V=fa+44|0;k[V>>2]=X;k[fa+52>>2]=0;k[X>>2]=0;k[ea>>2]=h;k[n>>2]=f;G1(fa,2,ea,e);k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea>>2]=16842752;k[ea+4>>2]=ia;O=P+4|0;N=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[P>>2]=33619968;k[O>>2]=ga;tfa(ea,P,3,1,0,t,1.0,0.0,1);k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea>>2]=16842752;k[ea+4>>2]=ia;O=P+4|0;N=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[P>>2]=33619968;k[O>>2]=fa;tfa(ea,P,3,0,1,t,1.0,0.0,1);if(M){c=c<32767.0?c:32767.0;o=o<32767.0?o:32767.0;c=c>0.0?c*c:c;if(o>0.0)o=o*o}H=~~c;H=H-(+(H|0)>c&1)|0;G=~~o;G=G-(+(G|0)>o&1)|0;I=k[U>>2]|0;K=I+2|0;g=k[T>>2]|0;m=aa(K,Q)|0;f=(aa(g+2|0,K)|0)+(m*12|0)|0;N=ea+8|0;k[ea>>2]=N;O=ea+4|0;k[O>>2]=1032;if(f>>>0>1032){while(1){h=fgb(f)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[ea>>2]=h}else h=N;k[O>>2]=f;k[P>>2]=h;J=h+(m<<2)|0;D=P+4|0;k[D>>2]=J;J=J+(m<<2)|0;E=P+8|0;k[E>>2]=J;F=K<<2;zpb(h|0,0,F|0)|0;J=J+(m<<2)|0;zpb(J|0,1,K|0)|0;zpb(J+(aa(g+1|0,K)|0)|0,1,K|0)|0;m=(aa(g,I)|0)/10|0;m=(m|0)>1024?m:1024;k[da>>2]=0;L=da+4|0;k[L>>2]=0;k[da+8>>2]=0;if(!m)f=0;else{if(m>>>0>1073741823)ad(426534,426557,304,426811);n=m<<2;while(1){f=fgb(n)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[L>>2]=f;k[da>>2]=f;k[da+8>>2]=f+(m<<2);n=m;p=f;e=f;while(1){k[p>>2]=0;e=e+4|0;n=n+-1|0;if(!n)break;else p=e}k[L>>2]=f+(m<<2)}if((g|0)>=0){B=ga+16|0;C=fa+16|0;A=(u|0)!=0;n=f;y=f;z=0;t=h;e=h;while(1){q=k[P+(((z|0)>0?2:1)<<2)>>2]|0;s=q+4|0;if((z|0)<(g|0)){a=(k[B>>2]|0)+(aa(k[k[$>>2]>>2]|0,z)|0)|0;b=(k[C>>2]|0)+(aa(k[k[V>>2]>>2]|0,z)|0)|0;h=aa(k[U>>2]|0,Q)|0;g=(h|0)>0;if(M){if(g){g=0;do{x=j[a+(g<<1)>>1]|0;x=aa(x,x)|0;w=j[b+(g<<1)>>1]|0;x=(aa(w,w)|0)+x|0;k[s+(g<<2)>>2]=x;g=g+1|0}while((g|0)!=(h|0))}}else if(g){g=0;do{w=j[a+(g<<1)>>1]|0;x=w<<16>>16;u=j[b+(g<<1)>>1]|0;v=u<<16>>16;k[s+(g<<2)>>2]=(u<<16>>16>-1?v:0-v|0)+(w<<16>>16>-1?x:0-x|0);g=g+1|0}while((g|0)!=(h|0))}g=k[U>>2]|0;if(A&(g|0)>0){f=0;p=0;while(1){g=p;h=1;do{x=h+p|0;g=(k[s+(x<<2)>>2]|0)>(k[s+(g<<2)>>2]|0)?x:g;h=h+1|0}while((h|0)!=(Q|0));k[s+(f<<2)>>2]=k[s+(g<<2)>>2];j[a+(f<<1)>>1]=j[a+(g<<1)>>1]|0;j[b+(f<<1)>>1]=j[b+(g<<1)>>1]|0;f=f+1|0;g=k[U>>2]|0;if((f|0)>=(g|0))break;else p=p+Q|0}}k[s+(g<<2)>>2]=0;k[q>>2]=0}else zpb(q|0,0,F|0)|0;if(!z){h=y;f=t}else{v=J+(aa(z,K)|0)+1|0;i[v+(k[U>>2]|0)>>0]=1;i[v+-1>>0]=1;p=k[D>>2]|0;w=p+4|0;f=k[E>>2]|0;x=f-p>>2;s=t-p>>2;u=z+-1|0;t=(k[B>>2]|0)+(aa(k[k[$>>2]>>2]|0,u)|0)|0;u=(k[C>>2]|0)+(aa(k[k[V>>2]>>2]|0,u)|0)|0;b=n-y>>2;g=k[U>>2]|0;h=g+b|0;if((h|0)>(m|0)){m=(m*3|0)/2|0;m=(m|0)<(h|0)?h:m;a=k[L>>2]|0;h=k[da>>2]|0;n=a-h>>2;if(m>>>0<=n>>>0){if(m>>>0<n>>>0?(R=h+(m<<2)|0,(a|0)!=(R|0)):0)k[L>>2]=a+(~((a+-4-R|0)>>>2)<<2)}else{vaa(da,m-n|0);g=k[U>>2]|0;h=k[da>>2]|0}n=h+(b<<2)|0}else h=y;if((g|0)>0){q=0;g=0;do{b=k[w+(q<<2)>>2]|0;a:do if((b|0)>(H|0)){f=j[t+(q<<1)>>1]|0;p=f<<16>>16;e=j[u+(q<<1)>>1]|0;a=e<<16>>16;p=f<<16>>16>-1?p:0-p|0;a=(e<<16>>16>-1?a:0-a|0)<<15;do if((a|0)<(p*13573|0)){if((b|0)<=(k[w+(q+-1<<2)>>2]|0)){S=83;break a}if((b|0)<(k[w+(q+1<<2)>>2]|0)){S=83;break a}}else if((a|0)>(p*79109|0)){if((b|0)<=(k[w+(q+s<<2)>>2]|0)){S=83;break a}if((b|0)<(k[w+(q+x<<2)>>2]|0)){S=83;break a}else break}else{f=(e^f)<<16>>16<0?-1:1;if((b|0)<=(k[w+(q+s-f<<2)>>2]|0)){S=83;break a}if((b|0)>(k[w+(q+x+f<<2)>>2]|0))break;else{S=83;break a}}while(0);do if((g|0)==0&(b|0)>(G|0)){if((i[v+(q-K)>>0]|0)==2)break;g=v+q|0;i[g>>0]=2;k[n>>2]=g;g=1;n=n+4|0;break a}while(0);i[v+q>>0]=0}else S=83;while(0);if((S|0)==83){S=0;i[v+q>>0]=1;g=0}q=q+1|0}while((q|0)<(k[U>>2]|0));p=k[D>>2]|0;f=k[E>>2]|0;g=k[P>>2]|0}else g=e;k[P>>2]=p;k[D>>2]=f;k[E>>2]=g;e=p;f=p}g=k[T>>2]|0;if((z|0)>=(g|0))break;else{y=h;z=z+1|0;t=f}}if(n>>>0>h>>>0){a=-2-I|0;b=a+-1|0;q=a+1|0;s=I+1|0;p=I+3|0;g=n;while(1){n=g-h>>2;if((n+8|0)>(m|0)){m=(m*3|0)/2|0;f=k[L>>2]|0;h=k[da>>2]|0;g=f-h>>2;if(m>>>0<=g>>>0){if(m>>>0<g>>>0?(Z=h+(m<<2)|0,(f|0)!=(Z|0)):0)k[L>>2]=f+(~((f+-4-Z|0)>>>2)<<2)}else{vaa(da,m-g|0);h=k[da>>2]|0}e=h;g=h+(n<<2)|0}else e=h;h=g+-4|0;n=k[h>>2]|0;f=n+-1|0;if(!(i[f>>0]|0)){i[f>>0]=2;k[h>>2]=f}else g=h;h=n+1|0;if(!(i[h>>0]|0)){i[h>>0]=2;k[g>>2]=h;g=g+4|0}h=n+a|0;if(!(i[n+b>>0]|0)){S=h+-1|0;i[S>>0]=2;k[g>>2]=S;g=g+4|0}if(!(i[h>>0]|0)){i[h>>0]=2;k[g>>2]=h;g=g+4|0}if(!(i[n+q>>0]|0)){S=h+1|0;i[S>>0]=2;k[g>>2]=S;g=g+4|0}h=n+K|0;if(!(i[n+s>>0]|0)){S=h+-1|0;i[S>>0]=2;k[g>>2]=S;g=g+4|0}if(!(i[h>>0]|0)){i[h>>0]=2;k[g>>2]=h;g=g+4|0}if(!(i[n+p>>0]|0)){S=h+1|0;i[S>>0]=2;k[g>>2]=S;g=g+4|0}if(g>>>0>e>>>0)h=e;else break}g=k[T>>2]|0}e=ha+16|0;a=ha+44|0;if((g|0)>0){p=ha+48|0;m=0;n=k[e>>2]|0;f=J+K+1|0;h=k[U>>2]|0;while(1){if((h|0)>0){g=0;do{i[n+g>>0]=0-((l[f+g>>0]|0)>>>1);g=g+1|0;h=k[U>>2]|0}while((g|0)<(h|0));g=k[T>>2]|0}m=m+1|0;if((m|0)>=(g|0))break;else{n=n+(k[p>>2]|0)|0;f=f+K|0}}}}else{e=ha+16|0;a=ha+44|0}g=k[da>>2]|0;h=g;if(g|0){f=k[L>>2]|0;if((f|0)!=(g|0))k[L>>2]=f+(~((f+-4-h|0)>>>2)<<2);ggb(g)}g=k[ea>>2]|0;if((g|0)!=(N|0)){if(g|0)ggb(g);k[ea>>2]=N;k[O>>2]=1032}f=fa+36|0;g=k[f>>2]|0;if(g|0?(da=g+12|0,ea=k[da>>2]|0,k[da>>2]=ea+-1,(ea|0)==1):0){h=k[f>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[fa+32>>2]|0;if(!g){g=B1()|0;h=k[f>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[f>>2]=0}k[f>>2]=0;fa=fa+16|0;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=0;k[fa+12>>2]=0;if((k[Y>>2]|0)>0){h=k[W>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[Y>>2]|0))}g=k[V>>2]|0;if(!((g|0)==(X|0)|(g|0)==0))ggb(k[g+-4>>2]|0);f=ga+36|0;g=k[f>>2]|0;if(g|0?(ea=g+12|0,fa=k[ea>>2]|0,k[ea>>2]=fa+-1,(fa|0)==1):0){h=k[f>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[ga+32>>2]|0;if(g|0)break;g=B1()|0;h=k[f>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[f>>2]=0}k[f>>2]=0;ga=ga+16|0;k[ga>>2]=0;k[ga+4>>2]=0;k[ga+8>>2]=0;k[ga+12>>2]=0;if((k[ba>>2]|0)>0){h=k[_>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[ba>>2]|0))}g=k[$>>2]|0;if(!((g|0)==(ca|0)|(g|0)==0))ggb(k[g+-4>>2]|0);f=ha+36|0;g=k[f>>2]|0;if(g|0?(fa=g+12|0,ga=k[fa>>2]|0,k[fa>>2]=ga+-1,(ga|0)==1):0){h=k[f>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[ha+32>>2]|0;if(g|0)break;g=B1()|0;h=k[f>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[f>>2]=0}k[f>>2]=0;f=ha+4|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[f>>2]|0)>0){h=k[ha+40>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[f>>2]|0))}g=k[a>>2]|0;if(!((g|0)==(ha+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);f=ia+36|0;g=k[f>>2]|0;do if(g|0){ga=g+12|0;ha=k[ga>>2]|0;k[ga>>2]=ha+-1;if((ha|0)!=1)break;h=k[f>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[ia+32>>2]|0;if(g|0)break;g=B1()|0;h=k[f>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[f>>2]=0}while(0);k[f>>2]=0;ha=ia+16|0;h=ia+4|0;k[ha>>2]=0;k[ha+4>>2]=0;k[ha+8>>2]=0;k[ha+12>>2]=0;if((k[h>>2]|0)>0){f=k[ia+40>>2]|0;g=0;do{k[f+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[ia+44>>2]|0;if((g|0)==(ia+48|0)|(g|0)==0){r=ja;return}ggb(k[g+-4>>2]|0);r=ja;return}function vaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+8|0;e=k[i>>2]|0;j=a+4|0;c=k[j>>2]|0;if(e-c>>2>>>0>=b>>>0){do{k[c>>2]=0;c=(k[j>>2]|0)+4|0;k[j>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=c-d>>2;c=f+b|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);g=e-d|0;h=g>>1;h=g>>2>>>0<536870911?(h>>>0<c>>>0?c:h):1073741823;if(!h)c=0;else{if(h>>>0>1073741823){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=h<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}g=c+(f<<2)|0;f=g;d=g;do{k[d>>2]=0;d=f+4|0;f=d;b=b+-1|0}while((b|0)!=0);d=k[a>>2]|0;e=(k[j>>2]|0)-d|0;b=g+(0-(e>>2)<<2)|0;if((e|0)>0)upb(b|0,d|0,e|0)|0;k[a>>2]=b;k[j>>2]=f;k[i>>2]=c+(h<<2);if(!d)return;ggb(d);return}function waa(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+144|0;o=p+88|0;m=p+32|0;h=p+16|0;j=p;M1(o,a,0,1,0,0);M1(m,b,0,1,0,0);n=o+40|0;f=k[n>>2]|0;b=k[f+-4>>2]|0;l=m+40|0;e=k[l>>2]|0;a:do if((b|0)==(k[e+-4>>2]|0)){if((b|0)==2){if((k[f>>2]|0)!=(k[e>>2]|0)){g=10;break}if((k[f+4>>2]|0)!=(k[e+4>>2]|0)){g=10;break}}else if((b|0)>0){a=0;do{if((k[f+(a<<2)>>2]|0)!=(k[e+(a<<2)>>2]|0)){g=10;break a}a=a+1|0}while((a|0)<(b|0))}if(!((k[o>>2]&7|0)==0?!(k[m>>2]&4095|0):0))g=10}else g=10;while(0);if((g|0)==10){k[h>>2]=0;a=h+4|0;k[a>>2]=0;b=ZT(72)|0;k[b>>2]=1;e=b+4|0;k[h>>2]=e;k[a>>2]=67;i[b+71>>0]=0;f=236564;g=e+67|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,h,236632,236469,966);k[a>>2]=0;k[h>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0)}k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=o;e=j+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[j>>2]=33619968;k[e>>2]=m;uaa(h,j,c,d,3,0);e=m+36|0;a=k[e>>2]|0;if(a|0?(h=a+12|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[m+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;j=m+16|0;e=m+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[e>>2]|0)>0){b=k[l>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[m+44>>2]|0;if(!((a|0)==(m+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=o+36|0;a=k[e>>2]|0;if(a|0?(l=a+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[o+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;m=o+16|0;e=o+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[e>>2]|0)>0){b=k[n>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[o+44>>2]|0;if((a|0)==(o+48|0)|(a|0)==0){r=p;return}ggb(k[a+-4>>2]|0);r=p;return}function xaa(a){a=a|0;ggb(a);return}function yaa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function zaa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=51860;d=a+116|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+112>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+96|0;c=a+84|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+120>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+124>>2]|0;if(!((b|0)==(a+128|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+60|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+56>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+40|0;c=a+28|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+64>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+68>>2]|0;if((b|0)==(a+72|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Aaa(a){a=a|0;zaa(a);ggb(a);return}function Baa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+256|0;D=I+240|0;w=I+56|0;f=I+232|0;g=I+224|0;j=I+216|0;l=I+208|0;n=I+144|0;m=I+80|0;H=I;v=I+72|0;G=I+152|0;F=I+88|0;if(S1(b,-1)|0?(S1(b,-1)|0)!=2:0){d=D+4|0;e=ZT(56)|0;k[e>>2]=1;s=e+4|0;k[D>>2]=s;k[d>>2]=49;i[e+53>>0]=0;t=236722;u=s+49|0;do{i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(u|0));Y8(-215,D,400950,236772,354);k[d>>2]=0;k[D>>2]=0;E=k[e>>2]|0;k[e>>2]=E+-1;if((E|0)==1)ggb(k[e+-4>>2]|0)}s=(S1(b,-1)|0)==0;s=s?256:4096;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;R1(f,b,-1);B=a+16|0;if(!((k[f>>2]|0)%(k[B>>2]|0)|0)){R1(g,b,-1);e=a+20|0;d=k[e>>2]|0;if(!((k[g+4>>2]|0)%(d|0)|0)){R1(j,b,-1);E=k[j>>2]|0;C=k[B>>2]|0;R1(l,b,-1);A=(k[l+4>>2]|0)/(k[e>>2]|0)|0;u=b;y=k[u+4>>2]|0;z=w;k[z>>2]=k[u>>2];k[z+4>>2]=y;k[w+8>>2]=k[b+8>>2];k[w+12>>2]=k[b+12>>2];C=(E|0)/(C|0)|0}else q=10}else{d=a+20|0;e=d;d=k[d>>2]|0;q=10}if((q|0)==10){E=a+24|0;u=D+4|0;y=u+4|0;k[y>>2]=0;k[y+4>>2]=0;k[D>>2]=33619968;k[u>>2]=E;R1(n,b,-1);u=k[n+4>>2]|0;y=k[e>>2]|0;z=k[B>>2]|0;R1(m,b,-1);C=k[m>>2]|0;A=k[B>>2]|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;k[H+16>>2]=0;k[H+20>>2]=0;k[H+24>>2]=0;k[H+28>>2]=0;vY(b,D,0,d-((u|0)%(y|0)|0)|0,0,z-((C|0)%(A|0)|0)|0,4,H);A=k[a+64>>2]|0;C=(k[A+4>>2]|0)/(k[B>>2]|0)|0;A=(k[A>>2]|0)/(k[e>>2]|0)|0;k[w>>2]=16842752;k[w+4>>2]=E;k[w+8>>2]=0;k[w+12>>2]=0}d=aa(A,C)|0;x=+(s+-1|0)/+(d|0);h=+p[a+8>>3];if(h>0.0){t=~~(h*+(d|0)/+(s|0));t=(t|0)<1?1:t}else t=0;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[H>>2]=k[f>>2];m=H+4|0;d=f+4|0;k[m>>2]=k[d>>2];E=H+8|0;k[E>>2]=k[f+8>>2];k[H+12>>2]=k[f+12>>2];k[H+16>>2]=k[f+16>>2];k[H+20>>2]=k[f+20>>2];k[H+24>>2]=k[f+24>>2];k[H+28>>2]=k[f+28>>2];k[H+32>>2]=k[f+32>>2];e=k[f+36>>2]|0;k[H+36>>2]=e;n=H+40|0;k[n>>2]=E;E=H+48|0;g=H+44|0;k[g>>2]=E;k[H+52>>2]=0;k[E>>2]=0;if(e|0){E=e+12|0;k[E>>2]=(k[E>>2]|0)+1}if((k[d>>2]|0)<3){y=k[f+44>>2]|0;E=k[g>>2]|0;k[E>>2]=k[y>>2];k[E+4>>2]=k[y+4>>2];E=n;y=H;break}k[m>>2]=0;x1(H,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){j=k[f+40>>2]|0;l=k[n>>2]|0;f=k[f+44>>2]|0;e=k[g>>2]|0;d=0;do{k[l+(d<<2)>>2]=k[j+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0));E=n;y=H}else{E=n;y=H}}else{Q1(H,b,-1);E=H+40|0;y=H}while(0);u=k[E>>2]|0;z=k[u>>2]|0;k[v>>2]=k[u+4>>2];k[v+4>>2]=z;x2(c,v,k[y>>2]&4095,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[G>>2]=k[g>>2];n=G+4|0;d=g+4|0;k[n>>2]=k[d>>2];z=G+8|0;k[z>>2]=k[g+8>>2];k[G+12>>2]=k[g+12>>2];k[G+16>>2]=k[g+16>>2];k[G+20>>2]=k[g+20>>2];k[G+24>>2]=k[g+24>>2];k[G+28>>2]=k[g+28>>2];k[G+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[G+36>>2]=e;f=G+40|0;k[f>>2]=z;z=G+48|0;l=G+44|0;k[l>>2]=z;k[G+52>>2]=0;k[z>>2]=0;if(e|0){z=e+12|0;k[z>>2]=(k[z>>2]|0)+1}if((k[d>>2]|0)<3){c=k[g+44>>2]|0;z=k[l>>2]|0;k[z>>2]=k[c>>2];k[z+4>>2]=k[c+4>>2];break}k[n>>2]=0;x1(G,k[d>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[g+40>>2]|0;j=k[f>>2]|0;f=k[g+44>>2]|0;e=k[l>>2]|0;d=0;do{k[j+(d<<2)>>2]=k[m+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[n>>2]|0))}}else Q1(G,c,-1);while(0);do if((k[w>>2]&2031616|0)==65536){g=k[w+4>>2]|0;k[F>>2]=k[g>>2];n=F+4|0;d=g+4|0;k[n>>2]=k[d>>2];z=F+8|0;k[z>>2]=k[g+8>>2];k[F+12>>2]=k[g+12>>2];k[F+16>>2]=k[g+16>>2];k[F+20>>2]=k[g+20>>2];k[F+24>>2]=k[g+24>>2];k[F+28>>2]=k[g+28>>2];k[F+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[F+36>>2]=e;f=F+40|0;k[f>>2]=z;z=F+48|0;l=F+44|0;k[l>>2]=z;k[F+52>>2]=0;k[z>>2]=0;if(e|0){z=e+12|0;k[z>>2]=(k[z>>2]|0)+1}if((k[d>>2]|0)<3){w=k[g+44>>2]|0;z=k[l>>2]|0;k[z>>2]=k[w>>2];k[z+4>>2]=k[w+4>>2];break}k[n>>2]=0;x1(F,k[d>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[g+40>>2]|0;j=k[f>>2]|0;f=k[g+44>>2]|0;e=k[l>>2]|0;d=0;do{k[j+(d<<2)>>2]=k[m+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[n>>2]|0))}}else Q1(F,w,-1);while(0);v=a+80|0;d=k[B>>2]|0;z=a+20|0;e=k[z>>2]|0;d=aa(e,d)|0;e=(S1(b,-1)|0)&4095;w=a+84|0;if(!(((((k[w>>2]|0)<3?(k[a+88>>2]|0)==(d|0):0)?(k[a+92>>2]|0)==(s|0):0)?(k[v>>2]&4095|0)==(e|0):0)?(k[a+96>>2]|0)!=0:0)){k[D>>2]=d;k[D+4>>2]=s;G1(v,2,D,e)}do if(!(S1(b,-1)|0)){while(1){d=fgb(136)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d>>2]=51944;j=d+4|0;k[j>>2]=k[F>>2];q=d+8|0;f=F+4|0;e=k[f>>2]|0;k[q>>2]=e;c=d+12|0;k[c>>2]=k[F+8>>2];k[d+16>>2]=k[F+12>>2];k[d+20>>2]=k[F+16>>2];k[d+24>>2]=k[F+20>>2];k[d+28>>2]=k[F+24>>2];k[d+32>>2]=k[F+28>>2];k[d+36>>2]=k[F+32>>2];g=k[F+36>>2]|0;k[d+40>>2]=g;m=d+44|0;k[m>>2]=c;c=d+52|0;n=d+48|0;k[n>>2]=c;k[d+56>>2]=0;k[c>>2]=0;if(g){e=g+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[f>>2]|0}if((e|0)>=3){k[q>>2]=0;x1(j,e,0,0,0);if((k[q>>2]|0)>0){l=k[F+40>>2]|0;g=k[m>>2]|0;j=k[F+44>>2]|0;f=k[n>>2]|0;e=0;do{k[g+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[j+(e<<2)>>2];e=e+1|0}while((e|0)<(k[q>>2]|0))}}else{u=k[F+44>>2]|0;c=k[n>>2]|0;k[c>>2]=k[u>>2];k[c+4>>2]=k[u+4>>2]}g=d+60|0;k[g>>2]=k[v>>2];n=d+64|0;e=k[w>>2]|0;k[n>>2]=e;c=d+68|0;k[c>>2]=k[a+88>>2];k[d+72>>2]=k[a+92>>2];k[d+76>>2]=k[a+96>>2];k[d+80>>2]=k[a+100>>2];k[d+84>>2]=k[a+104>>2];k[d+88>>2]=k[a+108>>2];k[d+92>>2]=k[a+112>>2];f=k[a+116>>2]|0;k[d+96>>2]=f;j=d+100|0;k[j>>2]=c;c=d+108|0;m=d+104|0;k[m>>2]=c;k[d+112>>2]=0;k[c>>2]=0;if(f){e=f+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[w>>2]|0}if((e|0)>=3){k[n>>2]=0;x1(g,k[w>>2]|0,0,0,0);if((k[n>>2]|0)>0){l=k[a+120>>2]|0;g=k[j>>2]|0;j=k[a+124>>2]|0;f=k[m>>2]|0;e=0;do{k[g+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[j+(e<<2)>>2];e=e+1|0}while((e|0)<(k[n>>2]|0))}}else{u=k[a+124>>2]|0;c=k[m>>2]|0;k[c>>2]=k[u>>2];k[c+4>>2]=k[u+4>>2]}k[d+116>>2]=C;k[d+120>>2]=A;k[d+124>>2]=k[B>>2];k[d+128>>2]=t;o[d+132>>2]=x;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}u=e+4|0;k[u>>2]=1;k[e>>2]=51964;k[e+8>>2]=d;f=e;k[u>>2]=(k[u>>2]|0)+1;c=k[u>>2]|0;k[u>>2]=c+-1;if((c|0)==1){Uh[k[(k[e>>2]|0)+8>>2]&2047](e);c=f}else c=f}else{if((S1(b,-1)|0)!=2){k[D>>2]=0;d=D+4|0;k[d>>2]=0;e=ZT(24)|0;k[e>>2]=1;s=e+4|0;k[D>>2]=s;k[d>>2]=16;i[e+20>>0]=0;t=236839;u=s+16|0;do{i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(u|0));Y8(-5,D,400950,236772,419);k[d>>2]=0;k[D>>2]=0;c=k[e>>2]|0;k[e>>2]=c+-1;if((c|0)==1)ggb(k[e+-4>>2]|0);c=0;d=0;break}while(1){d=fgb(136)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d>>2]=51984;j=d+4|0;k[j>>2]=k[F>>2];q=d+8|0;f=F+4|0;e=k[f>>2]|0;k[q>>2]=e;c=d+12|0;k[c>>2]=k[F+8>>2];k[d+16>>2]=k[F+12>>2];k[d+20>>2]=k[F+16>>2];k[d+24>>2]=k[F+20>>2];k[d+28>>2]=k[F+24>>2];k[d+32>>2]=k[F+28>>2];k[d+36>>2]=k[F+32>>2];g=k[F+36>>2]|0;k[d+40>>2]=g;m=d+44|0;k[m>>2]=c;c=d+52|0;n=d+48|0;k[n>>2]=c;k[d+56>>2]=0;k[c>>2]=0;if(g){e=g+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[f>>2]|0}if((e|0)>=3){k[q>>2]=0;x1(j,e,0,0,0);if((k[q>>2]|0)>0){l=k[F+40>>2]|0;g=k[m>>2]|0;j=k[F+44>>2]|0;f=k[n>>2]|0;e=0;do{k[g+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[j+(e<<2)>>2];e=e+1|0}while((e|0)<(k[q>>2]|0))}}else{u=k[F+44>>2]|0;c=k[n>>2]|0;k[c>>2]=k[u>>2];k[c+4>>2]=k[u+4>>2]}g=d+60|0;k[g>>2]=k[v>>2];n=d+64|0;e=k[w>>2]|0;k[n>>2]=e;c=d+68|0;k[c>>2]=k[a+88>>2];k[d+72>>2]=k[a+92>>2];k[d+76>>2]=k[a+96>>2];k[d+80>>2]=k[a+100>>2];k[d+84>>2]=k[a+104>>2];k[d+88>>2]=k[a+108>>2];k[d+92>>2]=k[a+112>>2];f=k[a+116>>2]|0;k[d+96>>2]=f;j=d+100|0;k[j>>2]=c;c=d+108|0;m=d+104|0;k[m>>2]=c;k[d+112>>2]=0;k[c>>2]=0;if(f){e=f+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[w>>2]|0}if((e|0)>=3){k[n>>2]=0;x1(g,k[w>>2]|0,0,0,0);if((k[n>>2]|0)>0){l=k[a+120>>2]|0;g=k[j>>2]|0;j=k[a+124>>2]|0;f=k[m>>2]|0;e=0;do{k[g+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[j+(e<<2)>>2];e=e+1|0}while((e|0)<(k[n>>2]|0))}}else{u=k[a+124>>2]|0;c=k[m>>2]|0;k[c>>2]=k[u>>2];k[c+4>>2]=k[u+4>>2]}k[d+116>>2]=C;k[d+120>>2]=A;k[d+124>>2]=k[B>>2];k[d+128>>2]=t;o[d+132>>2]=x;while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}u=e+4|0;k[u>>2]=1;k[e>>2]=52004;k[e+8>>2]=d;f=e;k[u>>2]=(k[u>>2]|0)+1;c=k[u>>2]|0;k[u>>2]=c+-1;if((c|0)==1){Uh[k[(k[e>>2]|0)+8>>2]&2047](e);c=f}else c=f}while(0);u=aa(k[z>>2]|0,k[B>>2]|0)|0;k[D>>2]=0;k[D+4>>2]=u;jh[k[(k[d>>2]|0)+8>>2]&1023](d,D);do if(!(S1(b,-1)|0)){while(1){d=fgb(1268)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d>>2]=52024;l=d+4|0;k[l>>2]=k[y>>2];s=d+8|0;f=H+4|0;e=k[f>>2]|0;k[s>>2]=e;b=d+12|0;g=H+8|0;k[b>>2]=k[g>>2];t=H+12|0;k[d+16>>2]=k[t>>2];k[d+20>>2]=k[H+16>>2];k[d+24>>2]=k[H+20>>2];k[d+28>>2]=k[H+24>>2];k[d+32>>2]=k[H+28>>2];k[d+36>>2]=k[H+32>>2];j=k[H+36>>2]|0;k[d+40>>2]=j;n=d+44|0;k[n>>2]=b;b=d+52|0;q=d+48|0;k[q>>2]=b;k[d+56>>2]=0;k[b>>2]=0;if(j){e=j+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[f>>2]|0}if((e|0)>=3){k[s>>2]=0;x1(l,e,0,0,0);if((k[s>>2]|0)>0){m=k[H+40>>2]|0;j=k[n>>2]|0;l=k[H+44>>2]|0;f=k[q>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[m+(e<<2)>>2];k[f+(e<<2)>>2]=k[l+(e<<2)>>2];e=e+1|0}while((e|0)<(k[s>>2]|0))}}else{y=k[H+44>>2]|0;b=k[q>>2]|0;k[b>>2]=k[y>>2];k[b+4>>2]=k[y+4>>2]}l=d+60|0;k[l>>2]=k[G>>2];s=d+64|0;f=G+4|0;e=k[f>>2]|0;k[s>>2]=e;b=d+68|0;k[b>>2]=k[G+8>>2];k[d+72>>2]=k[G+12>>2];k[d+76>>2]=k[G+16>>2];k[d+80>>2]=k[G+20>>2];k[d+84>>2]=k[G+24>>2];k[d+88>>2]=k[G+28>>2];k[d+92>>2]=k[G+32>>2];j=k[G+36>>2]|0;k[d+96>>2]=j;n=d+100|0;k[n>>2]=b;b=d+108|0;q=d+104|0;k[q>>2]=b;k[d+112>>2]=0;k[b>>2]=0;if(j){e=j+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[f>>2]|0}if((e|0)>=3){k[s>>2]=0;x1(l,e,0,0,0);if((k[s>>2]|0)>0){m=k[G+40>>2]|0;j=k[n>>2]|0;l=k[G+44>>2]|0;f=k[q>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[m+(e<<2)>>2];k[f+(e<<2)>>2]=k[l+(e<<2)>>2];e=e+1|0}while((e|0)<(k[s>>2]|0))}}else{y=k[G+44>>2]|0;b=k[q>>2]|0;k[b>>2]=k[y>>2];k[b+4>>2]=k[y+4>>2]}j=d+116|0;k[j>>2]=k[v>>2];q=d+120|0;e=k[w>>2]|0;k[q>>2]=e;v=d+124|0;k[v>>2]=k[a+88>>2];k[d+128>>2]=k[a+92>>2];k[d+132>>2]=k[a+96>>2];k[d+136>>2]=k[a+100>>2];k[d+140>>2]=k[a+104>>2];k[d+144>>2]=k[a+108>>2];k[d+148>>2]=k[a+112>>2];f=k[a+116>>2]|0;k[d+152>>2]=f;l=d+156|0;k[l>>2]=v;v=d+164|0;n=d+160|0;k[n>>2]=v;k[d+168>>2]=0;k[v>>2]=0;if(f){e=f+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[w>>2]|0}if((e|0)>=3){k[q>>2]=0;x1(j,k[w>>2]|0,0,0,0);if((k[q>>2]|0)>0){m=k[a+120>>2]|0;l=k[l>>2]|0;j=k[a+124>>2]|0;f=k[n>>2]|0;e=0;do{k[l+(e<<2)>>2]=k[m+(e<<2)>>2];k[f+(e<<2)>>2]=k[j+(e<<2)>>2];e=e+1|0}while((e|0)<(k[q>>2]|0))}}else{b=k[a+124>>2]|0;a=k[n>>2]|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2]}k[d+172>>2]=C;k[d+176>>2]=A;u=d+180|0;f=k[B>>2]|0;k[u>>2]=f;k[d+184>>2]=k[z>>2];l=d+188|0;e=d+196|0;k[l>>2]=e;n=d+192|0;k[n>>2]=264;t=k[t>>2]|0;m=t<<2;if(m>>>0>264){j=m>>>0>1073741823?-1:m<<2;j=(j|0)==0?1:j;while(1){e=fgb(j)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[l>>2]=e}k[n>>2]=m;k[d+1252>>2]=e;n=e+(t<<2)|0;k[d+1256>>2]=n;q=n+(t<<2)|0;k[d+1260>>2]=q;s=q+(t<<2)|0;k[d+1264>>2]=s;m=k[v>>2]|0;h=1.0/+(C|0);a:do if((t|0)>0){l=t+-1|0;j=0;while(1){x=h*+(j|0)+-.5;a=~~x;a=a-(+(a|0)>x&1)|0;C=a+1|0;x=x-+(a|0);o[q+(j<<2)>>2]=x;o[s+(j<<2)>>2]=1.0-x;B=f+-1|0;a=aa((a|0)<0?0:a,m)|0;k[e+(j<<2)>>2]=a;C=aa((B|0)<(C|0)?B:C,m)|0;k[n+(j<<2)>>2]=C;if((j|0)==(l|0))break a;j=j+1|0;f=k[u>>2]|0}}while(0);while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}B=e+4|0;k[B>>2]=1;k[e>>2]=52044;k[e+8>>2]=d;f=e;k[B>>2]=(k[B>>2]|0)+1;C=k[B>>2]|0;k[B>>2]=C+-1;if((C|0)==1){Uh[k[(k[e>>2]|0)+8>>2]&2047](e);e=f}else e=f}else{if((S1(b,-1)|0)!=2){g=H+8|0;e=0;d=0;break}while(1){d=fgb(1268)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d>>2]=52064;l=d+4|0;k[l>>2]=k[y>>2];s=d+8|0;f=H+4|0;e=k[f>>2]|0;k[s>>2]=e;b=d+12|0;g=H+8|0;k[b>>2]=k[g>>2];t=H+12|0;k[d+16>>2]=k[t>>2];k[d+20>>2]=k[H+16>>2];k[d+24>>2]=k[H+20>>2];k[d+28>>2]=k[H+24>>2];k[d+32>>2]=k[H+28>>2];k[d+36>>2]=k[H+32>>2];j=k[H+36>>2]|0;k[d+40>>2]=j;n=d+44|0;k[n>>2]=b;b=d+52|0;q=d+48|0;k[q>>2]=b;k[d+56>>2]=0;k[b>>2]=0;if(j){e=j+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[f>>2]|0}if((e|0)>=3){k[s>>2]=0;x1(l,e,0,0,0);if((k[s>>2]|0)>0){m=k[H+40>>2]|0;j=k[n>>2]|0;l=k[H+44>>2]|0;f=k[q>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[m+(e<<2)>>2];k[f+(e<<2)>>2]=k[l+(e<<2)>>2];e=e+1|0}while((e|0)<(k[s>>2]|0))}}else{y=k[H+44>>2]|0;b=k[q>>2]|0;k[b>>2]=k[y>>2];k[b+4>>2]=k[y+4>>2]}l=d+60|0;k[l>>2]=k[G>>2];s=d+64|0;f=G+4|0;e=k[f>>2]|0;k[s>>2]=e;b=d+68|0;k[b>>2]=k[G+8>>2];k[d+72>>2]=k[G+12>>2];k[d+76>>2]=k[G+16>>2];k[d+80>>2]=k[G+20>>2];k[d+84>>2]=k[G+24>>2];k[d+88>>2]=k[G+28>>2];k[d+92>>2]=k[G+32>>2];j=k[G+36>>2]|0;k[d+96>>2]=j;n=d+100|0;k[n>>2]=b;b=d+108|0;q=d+104|0;k[q>>2]=b;k[d+112>>2]=0;k[b>>2]=0;if(j){e=j+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[f>>2]|0}if((e|0)>=3){k[s>>2]=0;x1(l,e,0,0,0);if((k[s>>2]|0)>0){m=k[G+40>>2]|0;j=k[n>>2]|0;l=k[G+44>>2]|0;f=k[q>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[m+(e<<2)>>2];k[f+(e<<2)>>2]=k[l+(e<<2)>>2];e=e+1|0}while((e|0)<(k[s>>2]|0))}}else{y=k[G+44>>2]|0;b=k[q>>2]|0;k[b>>2]=k[y>>2];k[b+4>>2]=k[y+4>>2]}j=d+116|0;k[j>>2]=k[v>>2];q=d+120|0;e=k[w>>2]|0;k[q>>2]=e;v=d+124|0;k[v>>2]=k[a+88>>2];k[d+128>>2]=k[a+92>>2];k[d+132>>2]=k[a+96>>2];k[d+136>>2]=k[a+100>>2];k[d+140>>2]=k[a+104>>2];k[d+144>>2]=k[a+108>>2];k[d+148>>2]=k[a+112>>2];f=k[a+116>>2]|0;k[d+152>>2]=f;l=d+156|0;k[l>>2]=v;v=d+164|0;n=d+160|0;k[n>>2]=v;k[d+168>>2]=0;k[v>>2]=0;if(f){e=f+12|0;k[e>>2]=(k[e>>2]|0)+1;e=k[w>>2]|0}if((e|0)>=3){k[q>>2]=0;x1(j,k[w>>2]|0,0,0,0);if((k[q>>2]|0)>0){m=k[a+120>>2]|0;l=k[l>>2]|0;j=k[a+124>>2]|0;f=k[n>>2]|0;e=0;do{k[l+(e<<2)>>2]=k[m+(e<<2)>>2];k[f+(e<<2)>>2]=k[j+(e<<2)>>2];e=e+1|0}while((e|0)<(k[q>>2]|0))}}else{b=k[a+124>>2]|0;a=k[n>>2]|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2]}k[d+172>>2]=C;k[d+176>>2]=A;u=d+180|0;f=k[B>>2]|0;k[u>>2]=f;k[d+184>>2]=k[z>>2];l=d+188|0;e=d+196|0;k[l>>2]=e;n=d+192|0;k[n>>2]=264;t=k[t>>2]|0;m=t<<2;if(m>>>0>264){j=m>>>0>1073741823?-1:m<<2;j=(j|0)==0?1:j;while(1){e=fgb(j)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[l>>2]=e}k[n>>2]=m;k[d+1252>>2]=e;n=e+(t<<2)|0;k[d+1256>>2]=n;q=n+(t<<2)|0;k[d+1260>>2]=q;s=q+(t<<2)|0;k[d+1264>>2]=s;m=(k[v>>2]|0)>>>1;h=1.0/+(C|0);b:do if((t|0)>0){l=t+-1|0;j=0;while(1){x=h*+(j|0)+-.5;a=~~x;a=a-(+(a|0)>x&1)|0;C=a+1|0;x=x-+(a|0);o[q+(j<<2)>>2]=x;o[s+(j<<2)>>2]=1.0-x;B=f+-1|0;a=aa((a|0)<0?0:a,m)|0;k[e+(j<<2)>>2]=a;C=aa((B|0)<(C|0)?B:C,m)|0;k[n+(j<<2)>>2]=C;if((j|0)==(l|0))break b;j=j+1|0;f=k[u>>2]|0}}while(0);while(1){e=fgb(16)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}B=e+4|0;k[B>>2]=1;k[e>>2]=52084;k[e+8>>2]=d;f=e;k[B>>2]=(k[B>>2]|0)+1;C=k[B>>2]|0;k[B>>2]=C+-1;if((C|0)==1){Uh[k[(k[e>>2]|0)+8>>2]&2047](e);e=f}else e=f}while(0);C=k[g>>2]|0;k[D>>2]=0;k[D+4>>2]=C;jh[k[(k[d>>2]|0)+8>>2]&1023](d,D);d=e;if(e|0?(C=d+4|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](d);d=c;if(c|0?(C=d+4|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](d);f=F+36|0;d=k[f>>2]|0;if(d|0?(C=d+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[F+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;D=F+16|0;e=F+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[e>>2]|0)>0){f=k[F+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[F+44>>2]|0;if(!((d|0)==(F+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=G+36|0;d=k[f>>2]|0;if(d|0?(D=d+12|0,F=k[D>>2]|0,k[D>>2]=F+-1,(F|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[G+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;F=G+16|0;e=G+4|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[e>>2]|0)>0){f=k[G+40>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[G+44>>2]|0;if(!((d|0)==(G+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=H+36|0;d=k[f>>2]|0;if(d|0?(F=d+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[H+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;G=H+16|0;f=H+4|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[f>>2]|0)>0){e=k[E>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[f>>2]|0))}d=k[H+44>>2]|0;if((d|0)==(H+48|0)|(d|0)==0){r=I;return}ggb(k[d+-4>>2]|0);r=I;return}function Caa(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function Daa(a){a=a|0;return +(+p[a+8>>3])}function Eaa(a,b){a=a|0;b=b|0;k[a+16>>2]=k[b>>2];k[a+20>>2]=k[b+4>>2];return}function Faa(a,b){a=a|0;b=b|0;var c=0;c=k[b+20>>2]|0;k[a>>2]=k[b+16>>2];k[a+4>>2]=c;return}function Gaa(a){a=a|0;var b=0,c=0,d=0;d=a+60|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+56>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+40|0;c=a+28|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+64>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+116|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+112>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+96|0;d=a+84|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)<=0)return;c=k[a+120>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0));return}function Haa(a){a=a|0;ggb(a);return}function Iaa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Jaa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=52064;b=a+188|0;c=k[b>>2]|0;d=a+196|0;if((c|0)!=(d|0)){if(c|0)ggb(c);k[b>>2]=d;k[a+192>>2]=264}d=a+152|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+148>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+132|0;c=a+120|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+156>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+160>>2]|0;if(!((b|0)==(a+164|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Kaa(a){a=a|0;Jaa(a);ggb(a);return}function Laa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0.0,h=0.0,i=0,l=0,n=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0.0;D=1.0/+(k[a+176>>2]|0);c=k[b>>2]|0;C=k[b+4>>2]|0;if((c|0)>=(C|0))return;s=k[a+20>>2]|0;t=k[k[a+48>>2]>>2]|0;v=k[a+76>>2]|0;w=k[k[a+104>>2]>>2]|0;x=(k[a+184>>2]|0)+-1|0;y=k[a+180>>2]|0;z=k[a+132>>2]|0;A=k[k[a+160>>2]>>2]|0;B=k[a+16>>2]|0;if((B|0)<=0)return;p=k[a+1252>>2]|0;q=k[a+1256>>2]|0;r=k[a+1264>>2]|0;n=k[a+1260>>2]|0;do{e=s+(aa(t,c)|0)|0;f=v+(aa(w,c)|0)|0;g=D*+(c|0)+-.5;i=~~g;i=i-(+(i|0)>g&1)|0;l=i+1|0;g=g-+(i|0);h=1.0-g;i=z+(aa(aa(y,(i|0)<0?0:i)|0,A)|0)|0;l=z+(aa(aa((x|0)<(l|0)?x:l,y)|0,A)|0)|0;a=0;do{b=m[e+(a<<1)>>1]|0;E=(k[p+(a<<2)>>2]|0)+b|0;b=(k[q+(a<<2)>>2]|0)+b|0;F=+o[r+(a<<2)>>2];d=+o[n+(a<<2)>>2];d=h*(+(m[i+(E<<1)>>1]|0)*F+ +(m[i+(b<<1)>>1]|0)*d)+g*(F*+(m[l+(E<<1)>>1]|0)+d*+(m[l+(b<<1)>>1]|0));b=(o[u>>2]=d,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;d=b?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=b?-0.0:0.0}E=~~d;j[f+(a<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;a=a+1|0}while((a|0)!=(B|0));c=c+1|0}while((c|0)!=(C|0));return}function Maa(a){a=a|0;ggb(a);return}function Naa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Oaa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=52024;b=a+188|0;c=k[b>>2]|0;d=a+196|0;if((c|0)!=(d|0)){if(c|0)ggb(c);k[b>>2]=d;k[a+192>>2]=264}d=a+152|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+148>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+132|0;c=a+120|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+156>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+160>>2]|0;if(!((b|0)==(a+164|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Paa(a){a=a|0;Oaa(a);ggb(a);return}function Qaa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0.0,j=0.0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;E=1.0/+(k[a+176>>2]|0);c=k[b>>2]|0;D=b+4|0;b=k[D>>2]|0;if((c|0)>=(b|0))return;q=a+20|0;r=a+48|0;s=a+76|0;t=a+104|0;v=a+184|0;w=a+180|0;x=a+132|0;y=a+160|0;z=a+16|0;A=a+1252|0;B=a+1256|0;C=a+1264|0;p=a+1260|0;a=k[z>>2]|0;do{f=(k[q>>2]|0)+(aa(k[k[r>>2]>>2]|0,c)|0)|0;g=(k[s>>2]|0)+(aa(k[k[t>>2]>>2]|0,c)|0)|0;h=E*+(c|0)+-.5;m=~~h;m=m-(+(m|0)>h&1)|0;F=m+1|0;h=h-+(m|0);j=1.0-h;G=(k[v>>2]|0)+-1|0;e=k[w>>2]|0;m=aa(e,(m|0)<0?0:m)|0;H=k[x>>2]|0;n=k[k[y>>2]>>2]|0;m=H+(aa(m,n)|0)|0;n=H+(aa(aa((G|0)<(F|0)?G:F,e)|0,n)|0)|0;if((a|0)>0){e=0;do{b=l[f+e>>0]|0;H=(k[(k[A>>2]|0)+(e<<2)>>2]|0)+b|0;b=(k[(k[B>>2]|0)+(e<<2)>>2]|0)+b|0;I=+o[(k[C>>2]|0)+(e<<2)>>2];d=+o[(k[p>>2]|0)+(e<<2)>>2];d=j*(+(l[m+H>>0]|0)*I+ +(l[m+b>>0]|0)*d)+h*(I*+(l[n+H>>0]|0)+d*+(l[n+b>>0]|0));b=(o[u>>2]=d,k[u>>2]|0);if((b&2130706432)>>>0<=1249902592){b=(b|0)<0;d=b?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=b?-0.0:0.0}a=~~d;i[g+e>>0]=a>>>0<256?a:(a|0)>0?255:0;e=e+1|0;a=k[z>>2]|0}while((e|0)<(a|0));b=k[D>>2]|0}c=c+1|0}while((c|0)<(b|0));return}function Raa(a){a=a|0;ggb(a);return}function Saa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Taa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=51984;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Uaa(a){a=a|0;Taa(a);ggb(a);return}
function Pva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;Q=r;r=r+2352|0;G=Q+2096|0;P=Q+1048|0;O=Q+8|0;B=Q;C=Q+2088|0;c=k[b+16>>2]|0;d=k[b+48>>2]|0;F=(k[b>>2]&4088|0)!=0;t=a+4|0;D=k[t>>2]|0;g=a+1160|0;u=k[g>>2]|0;u=(((aa((u|0)==15?16:u,D)|0)+7|0)/8|0)+3&-4;E=F?3:1;D=aa(D,E)|0;f=a+1164|0;if((k[f>>2]|0)<0){P=0;r=Q;return P|0}J=a+96|0;if(!(i[a+128>>0]|0)){P=0;r=Q;return P|0}if((k[a+1156>>2]|0)==1){c=c+(aa((k[a+8>>2]|0)+-1|0,d)|0)|0;d=0-d|0}M=P+8|0;k[P>>2]=M;N=P+4|0;k[N>>2]=1032;K=O+8|0;k[O>>2]=K;L=O+4|0;k[L>>2]=1032;e=u+32|0;if(e>>>0>1032){while(1){b=fgb(e)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[P>>2]=b}k[N>>2]=e;do if(!F){b=k[g>>2]|0;if((b|0)<9){e=1<<b;b=0;do{I=a+132+(b<<2)|0;i[G+b>>0]=(((l[I>>0]|0)*1868|0)+8192+((l[I+1>>0]|0)*9617|0)+((l[I+2>>0]|0)*4899|0)|0)>>>14;b=b+1|0}while((b|0)!=(e|0));b=k[L>>2]|0}else b=1032;e=((k[t>>2]|0)*3|0)+32|0;if(b>>>0>=e>>>0){k[L>>2]=e;n=k[O>>2]|0;break}b=k[O>>2]|0;if((b|0)!=(K|0)){if(b|0)ggb(b);k[O>>2]=K;k[L>>2]=1032}if(e>>>0>1032){while(1){b=fgb(e)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[O>>2]=b;k[L>>2]=e;n=b}else n=K}else n=K;while(0);I=k[P>>2]|0;b=k[f>>2]|0;if(!(k[a+116>>2]|0)){e=b;b=0}else{H=(b|0)%(k[a+120>>2]|0)|0;e=H;b=b-H|0}A=(k[a+104>>2]|0)+e|0;k[a+124>>2]=b;H=a+112|0;k[H>>2]=A;a:do switch(k[g>>2]|0){case 1:{p=a+8|0;if((k[p>>2]|0)>0){q=a+132|0;s=(u|0)>0;o=a+108|0;if(F){j=0;while(1){if(s){e=k[H>>2]|0;h=I;g=u;b=e;while(1){b=(k[o>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[o>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;b=f;e=f}else break}}dya(c,I,k[t>>2]|0,q);j=j+1|0;if((j|0)>=(k[p>>2]|0)){c=1;break a}else c=c+d|0}}else j=0;while(1){if(s){b=k[H>>2]|0;h=I;g=u;e=b;while(1){b=(k[o>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[o>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;e=f;b=f}else break}}dya(n,I,k[t>>2]|0,q);f=k[t>>2]|0;if((f|0)>0){b=0;e=n;while(1){i[c+b>>0]=(((l[e>>0]|0)*1868|0)+8192+((l[e+1>>0]|0)*9617|0)+((l[e+2>>0]|0)*4899|0)|0)>>>14;b=b+1|0;if((b|0)>=(f|0))break;else e=e+3|0}}j=j+1|0;if((j|0)>=(k[p>>2]|0)){c=1;break}else c=c+d|0}}else c=1;break}case 4:{switch(k[a+1168>>2]|0){case 0:{o=a+8|0;if((k[o>>2]|0)<=0){c=1;break a}p=(u|0)>0;q=a+108|0;if(F){j=0;while(1){if(p){b=k[H>>2]|0;h=I;g=u;e=b;while(1){b=(k[q>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[q>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;e=f;b=f}else break}}G=(k[t>>2]|0)*3|0;h=c+G|0;e=c+6|0;if((G|0)>6){g=I;f=c;while(1){b=g+1|0;G=l[g>>0]|0;F=a+132+(G>>>4<<2)|0;F=l[F>>0]|l[F+1>>0]<<8|l[F+2>>0]<<16|l[F+3>>0]<<24;i[f>>0]=F;i[f+1>>0]=F>>8;i[f+2>>0]=F>>16;i[f+3>>0]=F>>24;f=f+3|0;G=a+132+((G&15)<<2)|0;G=l[G>>0]|l[G+1>>0]<<8|l[G+2>>0]<<16|l[G+3>>0]<<24;i[f>>0]=G;i[f+1>>0]=G>>8;i[f+2>>0]=G>>16;i[f+3>>0]=G>>24;f=e+6|0;if(f>>>0<h>>>0){G=e;g=b;e=f;f=G}else{g=e;e=f;break}}}else{g=c;b=I}b=l[b>>0]|0;E=b>>>4;F=i[a+132+(E<<2)+1>>0]|0;G=i[a+132+(E<<2)+2>>0]|0;i[g>>0]=i[a+132+(E<<2)>>0]|0;i[g+1>>0]=F;i[g+2>>0]=G;if((e|0)==(h|0)){E=b&15;F=i[a+132+(E<<2)+1>>0]|0;G=i[a+132+(E<<2)+2>>0]|0;i[g+3>>0]=i[a+132+(E<<2)>>0]|0;i[g+4>>0]=F;i[g+5>>0]=G}j=j+1|0;if((j|0)>=(k[o>>2]|0)){c=1;break a}else c=c+d|0}}else n=0;while(1){if(p){b=k[H>>2]|0;h=I;g=u;e=b;while(1){b=(k[q>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[q>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;e=f;b=f}else break}}a=k[t>>2]|0;j=c+a|0;e=c+2|0;if((a|0)>2){g=c+4|0;g=((j>>>0>g>>>0?j:g)+(-3-c)|0)>>>1;h=g<<1;g=g+1|0;f=I;b=c;while(1){a=l[f>>0]|0;i[b>>0]=i[G+(a>>>4)>>0]|0;i[b+1>>0]=i[G+(a&15)>>0]|0;b=e+2|0;if(b>>>0<j>>>0){a=e;f=f+1|0;e=b;b=a}else break}f=c+(h+2)|0;b=I+g|0;e=c+(h+4)|0}else{f=c;b=I}b=l[b>>0]|0;i[f>>0]=i[G+(b>>>4)>>0]|0;if((e|0)==(j|0))i[f+1>>0]=i[G+(b&15)>>0]|0;n=n+1|0;if((n|0)>=(k[o>>2]|0)){c=1;break a}else c=c+d|0}}case 2:break;default:{c=0;break a}}t=a+8|0;u=a+132|0;v=B+4|0;w=C+1|0;x=B+1|0;y=B+2|0;z=a+108|0;A=0-D|0;b=c;q=0;c=c+D|0;b:while(1){s=c;while(1){o=b;e=k[H>>2]|0;f=e+1|0;g=k[z>>2]|0;if(f>>>0<g>>>0){D=l[f>>0]<<8|l[e>>0];f=e+2|0;k[H>>2]=f;e=D}else{if(e>>>0>=g>>>0){Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;g=k[z>>2]|0}f=l[e>>0]|0;e=e+1|0;k[H>>2]=e;if(e>>>0>=g>>>0){Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0}p=l[e>>0]|0;D=e+1|0;k[H>>2]=D;e=p<<8|f;f=D}g=e&255;j=e>>8;if(g|0){e=e>>12;f=a+132+(e<<2)|0;f=l[f>>0]|l[f+1>>0]<<8|l[f+2>>0]<<16|l[f+3>>0]<<24;k[B>>2]=f;h=j&15;D=a+132+(h<<2)|0;k[v>>2]=l[D>>0]|l[D+1>>0]<<8|l[D+2>>0]<<16|l[D+3>>0]<<24;e=i[G+e>>0]|0;i[C>>0]=e;i[w>>0]=i[G+h>>0]|0;g=aa(g,E)|0;h=b+g|0;if(h>>>0>s>>>0)break b;if(F){i[b>>0]=f;i[b+1>>0]=i[x>>0]|0;i[b+2>>0]=i[y>>0]|0;b=b+E|0;if(E>>>0<g>>>0){e=1;while(1){i[b>>0]=i[B+(e<<2)>>0]|0;i[b+1>>0]=i[B+(e<<2)+1>>0]|0;i[b+2>>0]=i[B+(e<<2)+2>>0]|0;b=b+E|0;if(b>>>0<h>>>0)e=e^1;else break}}}else{i[b>>0]=e;b=b+E|0;if(E>>>0<g>>>0){e=1;while(1){i[b>>0]=i[C+e>>0]|0;b=b+E|0;if(b>>>0<h>>>0)e=e^1;else break}}}continue}if((j|0)<=2)break;if((b+(aa(j,E)|0)|0)>>>0>s>>>0){c=0;break a}e=(j+1>>1)+1&-2;if((e|0)>0){h=I;while(1){g=(k[z>>2]|0)-f|0;g=(g|0)>(e|0)?e:g;if((g|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);f=k[H>>2]|0;g=(k[z>>2]|0)-f|0;g=(g|0)>(e|0)?e:g}while((g|0)<=0);upb(h|0,f|0,g|0)|0;f=(k[H>>2]|0)+g|0;k[H>>2]=f;e=e-g|0;if((e|0)<=0)break;else h=h+g|0}}if(F){D=j*3|0;j=b+D|0;f=b+6|0;if((D|0)>6){h=I;g=b;b=f;while(1){e=h+1|0;D=l[h>>0]|0;f=a+132+(D>>>4<<2)|0;f=l[f>>0]|l[f+1>>0]<<8|l[f+2>>0]<<16|l[f+3>>0]<<24;i[g>>0]=f;i[g+1>>0]=f>>8;i[g+2>>0]=f>>16;i[g+3>>0]=f>>24;f=g+3|0;D=a+132+((D&15)<<2)|0;D=l[D>>0]|l[D+1>>0]<<8|l[D+2>>0]<<16|l[D+3>>0]<<24;i[f>>0]=D;i[f+1>>0]=D>>8;i[f+2>>0]=D>>16;i[f+3>>0]=D>>24;f=b+6|0;if(f>>>0<j>>>0){g=b;h=e;b=f}else break}}else e=I;e=l[e>>0]|0;o=e>>>4;p=i[a+132+(o<<2)+1>>0]|0;D=i[a+132+(o<<2)+2>>0]|0;i[b>>0]=i[a+132+(o<<2)>>0]|0;i[b+1>>0]=p;i[b+2>>0]=D;if((f|0)!=(j|0)){b=j;continue}o=e&15;p=i[a+132+(o<<2)+1>>0]|0;D=i[a+132+(o<<2)+2>>0]|0;i[b+3>>0]=i[a+132+(o<<2)>>0]|0;i[b+4>>0]=p;i[b+5>>0]=D;b=j;continue}else{n=b+j|0;h=b+4|0;h=((n>>>0>h>>>0?n:h)+(-3-o)|0)>>>1;j=h<<1;h=h+1|0;f=I;e=b;g=b+2|0;while(1){D=l[f>>0]|0;i[e>>0]=i[G+(D>>>4)>>0]|0;i[e+1>>0]=i[G+(D&15)>>0]|0;e=g+2|0;if(e>>>0<n>>>0){D=g;f=f+1|0;g=e;e=D}else break}f=b+(j+2)|0;e=l[I+h>>0]|0;i[f>>0]=i[G+(e>>>4)>>0]|0;if((b+(j+4)|0)!=(n|0)){b=n;continue}i[f+1>>0]=i[G+(e&15)>>0]|0;b=n;continue}}e=c-b|0;if((j|0)==2){e=k[z>>2]|0;if(f>>>0<e>>>0)g=e;else{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);f=k[H>>2]|0;g=k[z>>2]|0}h=l[f>>0]|0;e=f+1|0;k[H>>2]=e;if(e>>>0>=g>>>0){Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0}k[H>>2]=e+1;e=aa(h,E)|0}p=k[t>>2]|0;c:do if(F){o=l[u>>0]|l[u+1>>0]<<8|l[u+2>>0]<<16|l[u+3>>0]<<24;j=o&255;n=o>>>8&255;o=o>>>16&255;f=q;h=s;do{g=b+e|0;g=g>>>0>h>>>0?h:g;e=b-g+e|0;if(b>>>0<g>>>0){do{i[b>>0]=j;i[b+1>>0]=n;i[b+2>>0]=o;b=b+3|0}while(b>>>0<g>>>0);h=c}if(b>>>0>=h>>>0){h=h+d|0;c=h;b=h+A|0;f=f+1|0;if((f|0)>=(p|0))break c}}while((e|0)>0)}else{o=i[G>>0]|0;f=q;g=s;do{h=b;j=b+e|0;n=j>>>0>g>>>0?g:j;e=h-n+e|0;if(b>>>0<n>>>0){s=g;D=j;zpb(b|0,o|0,~h-~(D>>>0>s>>>0?s:D)|0)|0;do b=b+1|0;while(b>>>0<n>>>0);g=c}if(b>>>0>=g>>>0){g=g+d|0;c=g;b=g+A|0;f=f+1|0;if((f|0)>=(p|0))break c}}while((e|0)>0)}while(0);if((f|0)<(k[t>>2]|0))q=f;else{c=1;break a}}c=0;break}case 8:{switch(k[a+1168>>2]|0){case 0:{n=a+8|0;if((k[n>>2]|0)<=0){c=1;break a}o=(u|0)>0;p=a+108|0;if(F)j=0;else{j=0;while(1){if(o){b=k[H>>2]|0;h=I;g=u;e=b;while(1){b=(k[p>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[p>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;e=f;b=f}else break}}e=k[t>>2]|0;if((e|0)>0){b=0;do{i[c+b>>0]=i[G+(l[I+b>>0]|0)>>0]|0;b=b+1|0}while((b|0)!=(e|0))}j=j+1|0;if((j|0)>=(k[n>>2]|0)){c=1;break a}else c=c+d|0}}while(1){if(o){b=k[H>>2]|0;h=I;g=u;e=b;while(1){b=(k[p>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[p>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;e=f;b=f}else break}}G=(k[t>>2]|0)*3|0;h=c+G|0;if((G|0)>3){g=I;f=c;e=c+3|0;while(1){b=g+1|0;G=a+132+(l[g>>0]<<2)|0;G=l[G>>0]|l[G+1>>0]<<8|l[G+2>>0]<<16|l[G+3>>0]<<24;i[f>>0]=G;i[f+1>>0]=G>>8;i[f+2>>0]=G>>16;i[f+3>>0]=G>>24;f=e+3|0;if(f>>>0<h>>>0){G=e;g=b;e=f;f=G}else break}}else{e=c;b=I}E=l[b>>0]|0;F=i[a+132+(E<<2)+1>>0]|0;G=i[a+132+(E<<2)+2>>0]|0;i[e>>0]=i[a+132+(E<<2)>>0]|0;i[e+1>>0]=F;i[e+2>>0]=G;j=j+1|0;if((j|0)>=(k[n>>2]|0)){c=1;break a}else c=c+d|0}}case 1:break;default:{c=0;break a}}t=a+8|0;u=a+132|0;v=a+108|0;w=0-D|0;g=0;e=c;s=0;c=c+D|0;while(1){q=c;n=g;while(1){b=k[H>>2]|0;f=b+1|0;g=k[v>>2]|0;if(f>>>0<g>>>0){C=l[f>>0]<<8|l[b>>0];f=b+2|0;k[H>>2]=f;b=C}else{if(b>>>0>=g>>>0){Uh[k[(k[J>>2]|0)+20>>2]&2047](J);b=k[H>>2]|0;g=k[v>>2]|0}f=l[b>>0]|0;b=b+1|0;k[H>>2]=b;if(b>>>0>=g>>>0){Uh[k[(k[J>>2]|0)+20>>2]&2047](J);b=k[H>>2]|0}B=l[b>>0]|0;C=b+1|0;k[H>>2]=C;b=B<<8|f;f=C}g=b&255;o=b>>8;if(g|0){x=163;break}if((o|0)<=2)break;if((e+(aa(o,E)|0)|0)>>>0>q>>>0){c=0;break a}b=o+1&-2;if((b|0)>0){h=I;while(1){g=(k[v>>2]|0)-f|0;g=(g|0)>(b|0)?b:g;if((g|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);f=k[H>>2]|0;g=(k[v>>2]|0)-f|0;g=(g|0)>(b|0)?b:g}while((g|0)<=0);upb(h|0,f|0,g|0)|0;f=(k[H>>2]|0)+g|0;k[H>>2]=f;b=b-g|0;if((b|0)<=0)break;else h=h+g|0}}if(F){C=o*3|0;j=e+C|0;b=e+3|0;if((C|0)>3){h=I;g=e;e=b;while(1){f=h+1|0;b=a+132+(l[h>>0]<<2)|0;b=l[b>>0]|l[b+1>>0]<<8|l[b+2>>0]<<16|l[b+3>>0]<<24;i[g>>0]=b;i[g+1>>0]=b>>8;i[g+2>>0]=b>>16;i[g+3>>0]=b>>24;b=e+3|0;if(b>>>0<j>>>0){g=e;h=f;e=b}else break}}else f=I;B=l[f>>0]|0;C=i[a+132+(B<<2)+1>>0]|0;n=i[a+132+(B<<2)+2>>0]|0;i[e>>0]=i[a+132+(B<<2)>>0]|0;i[e+1>>0]=C;i[e+2>>0]=n;n=0;e=b;continue}else{if((o|0)>0){b=0;do{i[e+b>>0]=i[G+(l[I+b>>0]|0)>>0]|0;b=b+1|0}while((b|0)!=(o|0))}n=0;e=e+o|0;continue}}if((x|0)==163){x=0;b=aa(g,E)|0;if((e+b|0)>>>0>q>>>0){c=0;break a}p=k[t>>2]|0;d:do if(F){o=a+132+(o<<2)|0;o=l[o>>0]|l[o+1>>0]<<8|l[o+2>>0]<<16|l[o+3>>0]<<24;j=o&255;n=o>>>8&255;o=o>>>16&255;h=b;b=s;g=q;do{f=e+h|0;f=f>>>0>g>>>0?g:f;h=e-f+h|0;if(e>>>0<f>>>0){do{i[e>>0]=j;i[e+1>>0]=n;i[e+2>>0]=o;e=e+3|0}while(e>>>0<f>>>0);g=c}if(e>>>0>=g>>>0){g=g+d|0;c=g;e=g+w|0;b=b+1|0;if((b|0)>=(p|0))break d}}while((h|0)>0)}else{o=i[G+o>>0]|0;n=b;b=s;f=q;do{g=e;h=e+n|0;j=h>>>0>f>>>0?f:h;n=g-j+n|0;if(e>>>0<j>>>0){B=f;C=h;zpb(e|0,o|0,~g-~(C>>>0>B>>>0?B:C)|0)|0;do e=e+1|0;while(e>>>0<j>>>0);f=c}if(e>>>0>=f>>>0){f=f+d|0;c=f;e=f+w|0;b=b+1|0;if((b|0)>=(p|0))break d}}while((n|0)>0)}while(0);g=b-s|0;s=b;continue}h=c-e|0;j=(o|0)==0;b=k[t>>2]|0;if((h|0)<(D|0)|(n|0)!=0&j^1){g=b-s|0;if((o|0)==2){b=k[v>>2]|0;if(f>>>0<b>>>0)g=b;else{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);f=k[H>>2]|0;g=k[v>>2]|0}h=l[f>>0]|0;b=f+1|0;k[H>>2]=b;if(b>>>0>=g>>>0){Uh[k[(k[J>>2]|0)+20>>2]&2047](J);b=k[H>>2]|0}g=i[b>>0]|0;k[H>>2]=b+1;f=aa(h,E)|0;g=g&255;b=k[t>>2]|0}else f=h;C=aa(g,D)|0;f=(j?0:C)+f|0;if((s|0)>=(b|0)){c=1;break a}e:do if(F){p=l[u>>0]|l[u+1>>0]<<8|l[u+2>>0]<<16|l[u+3>>0]<<24;n=p&255;o=p>>>8&255;p=p>>>16&255;j=f;f=s;h=q;do{g=e+j|0;g=g>>>0>h>>>0?h:g;j=e-g+j|0;if(e>>>0<g>>>0){do{i[e>>0]=n;i[e+1>>0]=o;i[e+2>>0]=p;e=e+3|0}while(e>>>0<g>>>0);h=c}if(e>>>0>=h>>>0){h=h+d|0;c=h;e=h+w|0;f=f+1|0;if((f|0)>=(b|0))break e}}while((j|0)>0)}else{p=i[G>>0]|0;o=f;f=s;g=q;do{h=e;j=e+o|0;n=j>>>0>g>>>0?g:j;o=h-n+o|0;if(e>>>0<n>>>0){B=g;C=j;zpb(e|0,p|0,~h-~(C>>>0>B>>>0?B:C)|0)|0;do e=e+1|0;while(e>>>0<n>>>0);g=c}if(e>>>0>=g>>>0){g=g+d|0;c=g;e=g+w|0;f=f+1|0;if((f|0)>=(b|0))break e}}while((o|0)>0)}while(0);b=k[t>>2]|0;if((f|0)>=(b|0)){c=1;break a}}else f=s;if((f|0)<(b|0)){g=0;s=f}else{c=1;break}}break}case 15:{o=a+8|0;if((k[o>>2]|0)>0){p=(u|0)>0;n=a+108|0;if(F){j=0;while(1){if(p){b=k[H>>2]|0;h=I;g=u;e=b;while(1){b=(k[n>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[n>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;e=f;b=f}else break}}f=k[t>>2]|0;if((f|0)>0){b=0;e=c;while(1){a=m[I+(b<<1)>>1]|0;i[e>>0]=a<<3;i[e+1>>0]=a>>>2&248;i[e+2>>0]=a>>>7&248;b=b+1|0;if((b|0)>=(f|0))break;else e=e+3|0}}j=j+1|0;if((j|0)>=(k[o>>2]|0)){c=1;break}else c=c+d|0}}else{j=0;while(1){if(p){b=k[H>>2]|0;h=I;g=u;e=b;while(1){b=(k[n>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[n>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;e=f;b=f}else break}}e=k[t>>2]|0;if((e|0)>0){b=0;do{a=m[I+(b<<1)>>1]|0;i[c+b>>0]=(((a>>>2&248)*9617|0)+8192+((a<<3&248)*1868|0)+((a>>>7&248)*4899|0)|0)>>>14;b=b+1|0}while((b|0)<(e|0))}j=j+1|0;if((j|0)>=(k[o>>2]|0)){c=1;break}else c=c+d|0}}}else c=1;break}case 16:{o=a+8|0;if((k[o>>2]|0)>0){p=(u|0)>0;n=a+108|0;if(F){j=0;while(1){if(p){b=k[H>>2]|0;h=I;g=u;e=b;while(1){b=(k[n>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[n>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;e=f;b=f}else break}}f=k[t>>2]|0;if((f|0)>0){b=0;e=c;while(1){a=m[I+(b<<1)>>1]|0;i[e>>0]=a<<3;i[e+1>>0]=a>>>3&252;i[e+2>>0]=a>>>8&248;b=b+1|0;if((b|0)>=(f|0))break;else e=e+3|0}}j=j+1|0;if((j|0)>=(k[o>>2]|0)){c=1;break}else c=c+d|0}}else{j=0;while(1){if(p){e=k[H>>2]|0;h=I;g=u;b=e;while(1){b=(k[n>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[n>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;b=f;e=f}else break}}e=k[t>>2]|0;if((e|0)>0){b=0;do{a=m[I+(b<<1)>>1]|0;i[c+b>>0]=(((a>>>3&252)*9617|0)+8192+((a<<3&248)*1868|0)+((a>>>8&248)*4899|0)|0)>>>14;b=b+1|0}while((b|0)<(e|0))}j=j+1|0;if((j|0)>=(k[o>>2]|0)){c=1;break}else c=c+d|0}}}else c=1;break}case 24:{o=a+8|0;if((k[o>>2]|0)>0){p=(u|0)>0;n=a+108|0;if(F){j=0;while(1){if(p){e=k[H>>2]|0;h=I;g=u;b=e;while(1){b=(k[n>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[n>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;b=f;e=f}else break}}upb(c|0,I|0,(k[t>>2]|0)*3|0)|0;j=j+1|0;if((j|0)>=(k[o>>2]|0)){c=1;break a}else c=c+d|0}}else j=0;while(1){if(p){e=k[H>>2]|0;h=I;g=u;b=e;while(1){b=(k[n>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[n>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;b=f;e=f}else break}}f=k[t>>2]|0;if((f|0)>0){b=0;e=I;while(1){i[c+b>>0]=(((l[e>>0]|0)*1868|0)+8192+((l[e+1>>0]|0)*9617|0)+((l[e+2>>0]|0)*4899|0)|0)>>>14;b=b+1|0;if((b|0)>=(f|0))break;else e=e+3|0}}j=j+1|0;if((j|0)>=(k[o>>2]|0)){c=1;break}else c=c+d|0}}else c=1;break}case 32:{o=a+8|0;if((k[o>>2]|0)>0){p=(u|0)>0;n=a+108|0;if(F){j=0;while(1){if(p){e=k[H>>2]|0;h=I;g=u;b=e;while(1){b=(k[n>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[n>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;b=f;e=f}else break}}g=k[t>>2]|0;if((g|0)>0){b=0;e=c;f=I;while(1){a=i[f+1>>0]|0;i[e>>0]=i[f>>0]|0;i[e+1>>0]=a;i[e+2>>0]=i[f+2>>0]|0;b=b+1|0;if((b|0)>=(g|0))break;else{e=e+3|0;f=f+4|0}}}j=j+1|0;if((j|0)>=(k[o>>2]|0)){c=1;break}else c=c+d|0}}else{j=0;while(1){if(p){e=k[H>>2]|0;h=I;g=u;b=e;while(1){b=(k[n>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[J>>2]|0)+20>>2]&2047](J);e=k[H>>2]|0;b=(k[n>>2]|0)-e|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(h|0,e|0,b|0)|0;f=(k[H>>2]|0)+b|0;k[H>>2]=f;e=g-b|0;if((e|0)>0){h=h+b|0;g=e;b=f;e=f}else break}}f=k[t>>2]|0;if((f|0)>0){b=0;e=I;while(1){i[c+b>>0]=(((l[e>>0]|0)*1868|0)+8192+((l[e+1>>0]|0)*9617|0)+((l[e+2>>0]|0)*4899|0)|0)>>>14;b=b+1|0;if((b|0)>=(f|0))break;else e=e+4|0}}j=j+1|0;if((j|0)>=(k[o>>2]|0)){c=1;break}else c=c+d|0}}}else c=1;break}default:c=0}while(0);b=k[O>>2]|0;if((b|0)!=(K|0)){if(b|0)ggb(b);k[O>>2]=K;k[L>>2]=1032}b=k[P>>2]|0;if((b|0)!=(M|0)){if(b|0)ggb(b);k[P>>2]=M;k[N>>2]=1032}P=c;r=Q;return P|0}function Qva(a){a=a|0;return 0}function Rva(a,b){a=a|0;b=b|0;var c=0,d=0;while(1){b=fgb(1172)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Sva(b);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=89352;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function Sva(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+20|0;k[b>>2]=0;k[b+4>>2]=0;k[a+36>>2]=1124007936;b=a+44|0;c=a+76|0;d=a+40|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;e=a+84|0;k[a+80>>2]=e;k[a+88>>2]=0;k[e>>2]=0;k[a+8>>2]=0;k[a+4>>2]=0;k[a+12>>2]=-1;e=a+92|0;i[e>>0]=0;k[a+16>>2]=1;k[a>>2]=89612;d=a+104|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[a+120>>2]=32768;i[a+128>>0]=0;i[a+100>>0]=0;k[a+96>>2]=90336;d=a+28|0;b=a+32|0;k[b>>2]=0;k[d>>2]=0;c=ZT(8)|0;k[c>>2]=1;k[d>>2]=c+4;k[b>>2]=2;i[c+6>>0]=0;d=k[d>>2]|0;i[d>>0]=66;i[d+1>>0]=77;k[a+1164>>2]=-1;i[e>>0]=1;return}function Tva(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90496;d=a+72|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+68>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+52|0;c=a+40|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+76>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+80>>2]|0;if(!((b|0)==(a+84|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+28|0;b=k[d>>2]|0;k[a+32>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+20|0;b=k[d>>2]|0;k[a+24>>2]=0;k[d>>2]=0;if(!b)return;d=b+-4|0;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;ggb(k[b+-8>>2]|0);return}function Uva(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1)return;ggb(k[b+-8>>2]|0);return}function Vva(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b){ggb(a);return}c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function Wva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+1072|0;x=C+1064|0;B=C;e=C+40|0;s=k[b+12>>2]|0;v=k[b+8>>2]|0;t=(k[b>>2]|0)>>>3&511;u=t+1|0;y=aa(u,s)|0;w=y+3&-4;i[x>>0]=0;i[x+1>>0]=0;i[x+2>>0]=0;i[x+3>>0]=0;i[x+4>>0]=0;z=B+12|0;k[z>>2]=0;A=B+8|0;k[A>>2]=0;c=B+4|0;k[c>>2]=0;d=B+24|0;k[d>>2]=0;k[B+16>>2]=32768;f=B+28|0;i[f>>0]=0;g=B+32|0;k[g>>2]=0;k[B>>2]=90416;j=a+20|0;h=k[j>>2]|0;Gxa(B);Uh[k[(k[B>>2]|0)+28>>2]&2047](B);do if(!h){q=k[a+12>>2]|0;q=Ufb((q|0)==0?1016759:q,377117)|0;k[d>>2]=q;if(!q){A=0;Cxa(B);r=C;return A|0}else{i[f>>0]=1;k[B+20>>2]=0;k[z>>2]=k[c>>2];break}}else{k[g>>2]=h;i[f>>0]=1;k[B+20>>2]=0;k[z>>2]=k[c>>2]}while(0);p=t|0?54:1078;q=(aa(w,v)|0)+p|0;g=k[j>>2]|0;if(g|0?(l=q+271&-256,m=g+8|0,n=k[g>>2]|0,o=n,((k[m>>2]|0)-n|0)>>>0<l>>>0):0){h=g+4|0;a=(k[h>>2]|0)-n|0;a:do if(!l)c=0;else while(1){c=fgb(l)|0;if(c|0)break a;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break a}Qh[c&7]()}while(0);d=c+a|0;f=d+(0-a)|0;if((a|0)>0)upb(f|0,o|0,a|0)|0;k[g>>2]=f;k[h>>2]=d;k[m>>2]=c+l;if(n|0)ggb(o)}f=357999;h=2;do{c=k[A>>2]|0;d=k[z>>2]|0;g=c-d|0;g=(g|0)>(h|0)?h:g;if((g|0)>0){upb(d|0,f|0,g|0)|0;d=(k[z>>2]|0)+g|0;k[z>>2]=d;f=f+g|0;h=h-g|0;c=k[A>>2]|0}if((d|0)==(c|0))Uh[k[(k[B>>2]|0)+20>>2]&2047](B)}while((h|0)!=0);Qxa(B,q);Qxa(B,0);Qxa(B,p);Qxa(B,40);Qxa(B,s);Qxa(B,v);c=k[z>>2]|0;d=c+1|0;if(d>>>0<(k[A>>2]|0)>>>0){i[c>>0]=1;i[d>>0]=0;s=c+2|0;k[z>>2]=s;if((s|0)==(k[A>>2]|0))Uh[k[(k[B>>2]|0)+20>>2]&2047](B)}else{k[z>>2]=d;i[c>>0]=1;c=k[z>>2]|0;if(c>>>0>=(k[A>>2]|0)>>>0){Uh[k[(k[B>>2]|0)+20>>2]&2047](B);c=k[z>>2]|0}k[z>>2]=c+1;i[c>>0]=0;if((k[z>>2]|0)>>>0>=(k[A>>2]|0)>>>0)Uh[k[(k[B>>2]|0)+20>>2]&2047](B)}c=k[z>>2]|0;d=c+1|0;f=u<<3&255;if(d>>>0<(k[A>>2]|0)>>>0){i[c>>0]=f;i[d>>0]=u>>>5;u=c+2|0;k[z>>2]=u;if((u|0)==(k[A>>2]|0))Uh[k[(k[B>>2]|0)+20>>2]&2047](B)}else{k[z>>2]=d;i[c>>0]=f;c=k[z>>2]|0;if(c>>>0>=(k[A>>2]|0)>>>0){Uh[k[(k[B>>2]|0)+20>>2]&2047](B);c=k[z>>2]|0}k[z>>2]=c+1;i[c>>0]=u>>>5;if((k[z>>2]|0)>>>0>=(k[A>>2]|0)>>>0)Uh[k[(k[B>>2]|0)+20>>2]&2047](B)}Qxa(B,0);Qxa(B,0);Qxa(B,0);Qxa(B,0);Qxa(B,0);Qxa(B,0);if(!t){c=0;do{u=c&255;i[e+(c<<2)+2>>0]=u;i[e+(c<<2)+1>>0]=u;i[e+(c<<2)>>0]=u;i[e+(c<<2)+3>>0]=0;c=c+1|0}while((c|0)!=256);g=1024;do{c=k[A>>2]|0;d=k[z>>2]|0;f=c-d|0;f=(f|0)>(g|0)?g:f;if((f|0)>0){upb(d|0,e|0,f|0)|0;d=(k[z>>2]|0)+f|0;k[z>>2]=d;e=e+f|0;g=g-f|0;c=k[A>>2]|0}if((d|0)==(c|0))Uh[k[(k[B>>2]|0)+20>>2]&2047](B)}while((g|0)!=0)}c=v+-1|0;b:do if((v|0)>0){n=b+16|0;l=b+44|0;j=w-y|0;m=(y|0)==0;if((w|0)<=(y|0)){h=c;while(1){if(!m){e=(k[n>>2]|0)+(aa(k[k[l>>2]>>2]|0,h)|0)|0;g=y;do{c=k[A>>2]|0;d=k[z>>2]|0;f=c-d|0;f=(f|0)>(g|0)?g:f;if((f|0)>0){upb(d|0,e|0,f|0)|0;d=(k[z>>2]|0)+f|0;k[z>>2]=d;e=e+f|0;g=g-f|0;c=k[A>>2]|0}if((d|0)==(c|0))Uh[k[(k[B>>2]|0)+20>>2]&2047](B)}while((g|0)!=0)}if((h|0)>0)h=h+-1|0;else break b}}a=(j|0)==0;while(1){if(!m){f=(k[n>>2]|0)+(aa(k[k[l>>2]>>2]|0,c)|0)|0;h=y;do{d=k[A>>2]|0;e=k[z>>2]|0;g=d-e|0;g=(g|0)>(h|0)?h:g;if((g|0)>0){upb(e|0,f|0,g|0)|0;e=(k[z>>2]|0)+g|0;k[z>>2]=e;f=f+g|0;h=h-g|0;d=k[A>>2]|0}if((e|0)==(d|0))Uh[k[(k[B>>2]|0)+20>>2]&2047](B)}while((h|0)!=0)}if(!a){f=x;h=j;do{d=k[A>>2]|0;e=k[z>>2]|0;g=d-e|0;g=(g|0)>(h|0)?h:g;if((g|0)>0){upb(e|0,f|0,g|0)|0;e=(k[z>>2]|0)+g|0;k[z>>2]=e;f=f+g|0;h=h-g|0;d=k[A>>2]|0}if((e|0)==(d|0))Uh[k[(k[B>>2]|0)+20>>2]&2047](B)}while((h|0)!=0)}if((c|0)>0)c=c+-1|0;else break}}while(0);Uh[k[(k[B>>2]|0)+16>>2]&2047](B);A=1;Cxa(B);r=C;return A|0}function Xva(a,b){a=a|0;b=b|0;var c=0,d=0;while(1){b=fgb(36)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Yva(b);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=89372;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function Yva(a){a=a|0;var b=0,c=0,d=0;k[a+28>>2]=0;k[a+32>>2]=0;d=a+24|0;i[d>>0]=0;b=a+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[a>>2]=89668;b=a+4|0;c=a+8|0;k[c>>2]=0;k[b>>2]=0;a=ZT(36)|0;k[a>>2]=1;k[b>>2]=a+4;k[c>>2]=28;i[a+32>>0]=0;a=k[b>>2]|0;b=357970;c=a+28|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));i[d>>0]=1;return}function Zva(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=89712;c=a+96|0;b=k[c>>2]|0;k[a+100>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);Tva(a);return}function _va(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=89712;c=a+96|0;b=k[c>>2]|0;k[a+100>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);Tva(a);ggb(a);return}function $va(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+144|0;n=o;h=o+8|0;j=k[a+20>>2]|0;j=Ufb((j|0)==0?1016759:j,373005)|0;l=a+104|0;k[l>>2]=j;if(!j){n=0;r=o;return n|0}m=a+4|0;g=a+8|0;a:do if(!(Vfb(h,128,j)|0))Sxa(0,0);else{b:do if(Vfb(h,128,j)|0){f=0;c:while(1){d:while(1){a=i[h>>0]|0;switch(a<<24>>24){case 10:{a=359738;b=h;break c}case 70:{b=359714;c=h;e=5;break d}case 35:break;default:{b=70;break d}}if(!(Vfb(h,128,j)|0))break b}if((e|0)==5)while(1){e=0;c=c+1|0;b=b+1|0;a=i[c>>0]|0;d=i[b>>0]|0;if(a<<24>>24==0?1:a<<24>>24!=d<<24>>24){b=d;break}else e=5}if(!(Vfb(h,128,j)|0))break b;else f=f|a<<24>>24==b<<24>>24}do{b=b+1|0;a=a+1|0;c=i[b>>0]|0;d=i[a>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=d<<24>>24));if(c<<24>>24!=d<<24>>24){Sxa(2,359740);break a}if(!f){Sxa(2,359782);break a}if(!(Vfb(h,128,j)|0)){Sxa(0,0);break a}k[n>>2]=g;k[n+4>>2]=m;if((Wfb(h,359807,n)|0)>=2)break a;Sxa(2,359819);break a}while(0);Sxa(0,0)}while(0);if((k[m>>2]|0)>=1?(k[g>>2]|0)>=1:0){n=1;r=o;return n|0}Qfb(k[l>>2]|0)|0;k[l>>2]=0;n=0;r=o;return n|0}function awa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0.0,P=0,Q=0;M=r;r=r+80|0;G=M+56|0;C=M+76|0;D=M+72|0;J=M;e=k[a+8>>2]|0;f=k[a+4>>2]|0;k[J>>2]=1124007936;L=J+4|0;g=J+8|0;H=J+40|0;c=L;d=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));k[H>>2]=g;K=J+48|0;I=J+44|0;k[I>>2]=K;k[J+52>>2]=0;k[K>>2]=0;k[G>>2]=e;k[G+4>>2]=f;G1(J,2,G,21);F=a+104|0;c=k[F>>2]|0;if(!c)if(Xh[k[(k[a>>2]|0)+24>>2]&1023](a)|0){E=k[F>>2]|0;j=4}else f=0;else{E=c;j=4}do if((j|0)==4){a=k[J+16>>2]|0;B=k[J+12>>2]|0;d=k[g>>2]|0;a:do if((B+-8|0)>>>0>32759){c=aa(d,B)|0;b:do if((c|0)>0){g=G+3|0;h=G+1|0;j=G+2|0;while(1){if(!(_fb(G,4,1,E)|0))break;d=a+8|0;e=a+4|0;f=i[g>>0]|0;if(!(f<<24>>24)){o[a>>2]=0.0;o[e>>2]=0.0;o[d>>2]=0.0}else{C=f&255;B=C+-136|0;D=(B|0)>1023;B=Apb((D?C+2937|0:B)+1023|0,0,52)|0;C=N;k[u>>2]=B;k[u+4>>2]=C;O=(D?8988465674311579538646525.0e283:1.0)*+p[u>>3];o[d>>2]=O*+(l[G>>0]|0);o[e>>2]=O*+(l[h>>0]|0);o[a>>2]=O*+(l[j>>0]|0)}if((c|0)>1){a=a+12|0;c=c+-1|0}else break b}Sxa(0,0)}while(0)}else{c:do if((d|0)>0){q=C+1|0;A=C+2|0;z=C+3|0;s=B<<2;t=D+1|0;v=(B|0)>0;w=B<<1;x=B*3|0;c=0;y=d;d:while(1){if(!(_fb(C,4,1,E)|0)){j=17;break}g=i[C>>0]|0;h=i[q>>0]|0;if(!(g<<24>>24==2&h<<24>>24==2)){j=20;break}d=l[A>>0]|0;if(d&128|0){h=2;g=2;j=20;break}if((l[z>>0]|0|d<<8|0)!=(B|0)){j=33;break}if(!c){c=fgb(s)|0;if(!c){j=37;break}}m=0;d=c;do{m=m+1|0;h=c+(aa(m,B)|0)|0;if(d>>>0<h>>>0){j=h;do{if(!(_fb(D,2,1,E)|0)){j=43;break d}e=i[D>>0]|0;g=e&255;do if((e&255)>128){e=g+-128|0;if(!e){j=47;break d}if((e|0)>(j-d|0)){j=47;break d}else f=d;while(1){i[f>>0]=i[t>>0]|0;if((e|0)>1){e=e+-1|0;f=f+1|0}else break}d=d+-128+g|0}else{if(!(e<<24>>24)){j=51;break d}if((g|0)>(j-d|0)){j=51;break d}f=d+1|0;i[d>>0]=i[t>>0]|0;d=g+-1|0;if((e&255)<=1){d=f;break}if(!(_fb(f,d,1,E)|0)){j=56;break d}d=f+d|0}while(0)}while(d>>>0<h>>>0)}}while((m|0)<4);if(v){d=0;e=a;while(1){f=i[c+d>>0]|0;i[C>>0]=f;g=i[c+(d+B)>>0]|0;i[q>>0]=g;h=i[c+(d+w)>>0]|0;i[A>>0]=h;j=i[c+(d+x)>>0]|0;i[z>>0]=j;m=e+8|0;n=e+4|0;if(!(j<<24>>24)){o[e>>2]=0.0;o[n>>2]=0.0;o[m>>2]=0.0}else{P=j&255;Q=P+-136|0;j=(Q|0)>1023;Q=Apb((j?P+2937|0:Q)+1023|0,0,52)|0;P=N;k[u>>2]=Q;k[u+4>>2]=P;O=(j?8988465674311579538646525.0e283:1.0)*+p[u>>3];o[m>>2]=O*+(f&255);o[n>>2]=O*+(g&255);o[e>>2]=O*+(h&255)}d=d+1|0;if((d|0)==(B|0))break;else e=e+12|0}a=a+(x<<2)|0}if((y|0)>1)y=y+-1|0;else break c}if((j|0)==17){ggb(c);Sxa(0,0);break a}else if((j|0)==20){e=a+8|0;f=a+4|0;d=i[z>>0]|0;if(!(d<<24>>24)){o[a>>2]=0.0;o[f>>2]=0.0;o[e>>2]=0.0}else{P=d&255;D=P+-136|0;Q=(D|0)>1023;D=Apb((Q?P+2937|0:D)+1023|0,0,52)|0;P=N;k[u>>2]=D;k[u+4>>2]=P;O=(Q?8988465674311579538646525.0e283:1.0)*+p[u>>3];o[e>>2]=O*+(g&255);o[f>>2]=O*+(h&255);o[a>>2]=O*+(l[A>>0]|0)}ggb(c);c=aa(y,B)|0;e:do if((c|0)>1){g=G+3|0;h=G+1|0;j=G+2|0;while(1){d=a;a=a+12|0;c=c+-1|0;if(!(_fb(G,4,1,E)|0))break;f=d+20|0;d=d+16|0;e=i[g>>0]|0;if(!(e<<24>>24)){o[a>>2]=0.0;o[d>>2]=0.0;o[f>>2]=0.0}else{P=e&255;D=P+-136|0;Q=(D|0)>1023;D=Apb((Q?P+2937|0:D)+1023|0,0,52)|0;P=N;k[u>>2]=D;k[u+4>>2]=P;O=(Q?8988465674311579538646525.0e283:1.0)*+p[u>>3];o[f>>2]=O*+(l[G>>0]|0);o[d>>2]=O*+(l[h>>0]|0);o[a>>2]=O*+(l[j>>0]|0)}if((c|0)<=1)break e}Sxa(0,0)}while(0);break a}else if((j|0)==33){ggb(c);Sxa(2,359848);break a}else if((j|0)==37){Sxa(3,359869);break a}else if((j|0)==43){ggb(c);Sxa(0,0);break a}else if((j|0)==47){ggb(c);Sxa(2,359901);break a}else if((j|0)==51){ggb(c);Sxa(2,359901);break a}else if((j|0)==56){ggb(c);Sxa(0,0);break a}}else c=0;while(0);ggb(c)}while(0);Qfb(k[F>>2]|0)|0;k[F>>2]=0;c=k[b>>2]|0;if(!((k[J>>2]^c)&7)){f=G+4|0;Q=f+4|0;k[Q>>2]=0;k[Q+4>>2]=0;k[G>>2]=33619968;k[f>>2]=b;SW(J,G,c&4095,1.0,0.0);f=1;break}else{f=G+4|0;Q=f+4|0;k[Q>>2]=0;k[Q+4>>2]=0;k[G>>2]=33619968;k[f>>2]=b;SW(J,G,c&4095,255.0,0.0);f=1;break}}while(0);e=J+36|0;c=k[e>>2]|0;if(c|0?(P=c+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;Q=J+16|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[L>>2]|0)>0){d=k[H>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[L>>2]|0))}c=k[I>>2]|0;if((c|0)==(K|0)|(c|0)==0){r=M;return f|0}ggb(k[c+-4>>2]|0);r=M;return f|0}function bwa(a){a=a|0;var b=0;b=k[a+32>>2]|0;a=k[a+100>>2]|0;return (b>>>0>a>>>0?b:a)|0}function cwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=k[a+32>>2]|0;if((k[b+4>>2]|0)>>>0<c>>>0){a=0;return a|0}d=k[b>>2]|0;d=(d|0)==0?1016759:d;b=k[a+28>>2]|0;if(!c){a=1;return a|0}e=d;b=(b|0)==0?1016759:b;while(1){if((i[e>>0]|0)!=(i[b>>0]|0))break;c=c+-1|0;if(!c){f=1;g=10;break}else{e=e+1|0;b=b+1|0}}if((g|0)==10)return f|0;b=k[a+96>>2]|0;c=k[a+100>>2]|0;if(!c){a=1;return a|0}b=(b|0)==0?1016759:b;while(1){if((i[d>>0]|0)!=(i[b>>0]|0)){f=0;g=10;break}c=c+-1|0;if(!c){f=1;g=10;break}else{d=d+1|0;b=b+1|0}}if((g|0)==10)return f|0;return 0}function dwa(a,b){a=a|0;b=b|0;var c=0,d=0;while(1){b=fgb(108)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}ewa(b);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=89392;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function ewa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=a+20|0;k[b>>2]=0;k[b+4>>2]=0;k[a+36>>2]=1124007936;b=a+44|0;c=a+76|0;d=a+40|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;f=a+84|0;k[a+80>>2]=f;k[a+88>>2]=0;k[f>>2]=0;k[a+8>>2]=0;k[a+4>>2]=0;f=a+12|0;k[f>>2]=-1;i[a+92>>0]=0;k[a+16>>2]=1;k[a>>2]=89712;b=a+96|0;k[b>>2]=0;c=a+100|0;k[c>>2]=0;d=a+28|0;g=a+32|0;k[g>>2]=0;k[d>>2]=0;e=ZT(12)|0;k[e>>2]=1;k[d>>2]=e+4;k[g>>2]=6;i[e+10>>0]=0;d=k[d>>2]|0;i[d>>0]=i[358020]|0;i[d+1>>0]=i[358021]|0;i[d+2>>0]=i[358022]|0;i[d+3>>0]=i[358023]|0;i[d+4>>0]=i[358024]|0;i[d+5>>0]=i[358025]|0;d=k[b>>2]|0;k[c>>2]=0;k[b>>2]=0;if(d|0?(e=d+-4|0,g=k[e>>2]|0,k[e>>2]=g+-1,(g|0)==1):0)ggb(k[d+-8>>2]|0);d=ZT(16)|0;k[d>>2]=1;k[b>>2]=d+4;k[c>>2]=10;i[d+14>>0]=0;d=k[b>>2]|0;b=358027;e=d+10|0;do{i[d>>0]=i[b>>0]|0;d=d+1|0;b=b+1|0}while((d|0)<(e|0));k[a+104>>2]=0;k[f>>2]=21;return}function fwa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1)return;ggb(k[b+-8>>2]|0);return}function gwa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b){ggb(a);return}c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function hwa(a,b){a=a|0;b=b|0;return (b|0)!=6|0}function iwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0;ca=r;r=r+144|0;p=ca+16|0;n=ca+8|0;X=ca;W=ca+128|0;Z=ca+72|0;f=ca+56|0;g=ca+40|0;h=ca+24|0;k[Z>>2]=1124007936;$=Z+4|0;q=Z+8|0;Y=Z+40|0;j=$;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[Y>>2]=q;ba=Z+48|0;_=Z+44|0;k[_>>2]=ba;k[Z+52>>2]=0;k[ba>>2]=0;d=k[b>>2]|0;switch(d>>>3&511){case 0:case 2:break;default:{k[W>>2]=0;d=W+4|0;k[d>>2]=0;e=ZT(60)|0;k[e>>2]=1;j=e+4|0;k[W>>2]=j;k[d>>2]=54;i[e+58>>0]=0;l=358083;m=j+54|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,W,370627,358138,128);k[d>>2]=0;k[W>>2]=0;T=k[e>>2]|0;k[e>>2]=T+-1;if((T|0)==1)ggb(k[e+-4>>2]|0);d=k[b>>2]|0}}if(!(d&4088)){lwa(f,3,b);k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=17104896;k[g+4>>2]=f;S=h+4|0;T=S+4|0;k[T>>2]=0;k[T+4>>2]=0;k[h>>2]=33619968;k[S>>2]=Z;k[W>>2]=0;S=W+4|0;k[S>>2]=0;k[W+8>>2]=0;B2(g,W);T=k[W>>2]|0;S=k[S>>2]|0;GV((T|0)==(S|0)?0:T,(S-T|0)/56|0,h);zF(W);zF(f)}else{T=W+4|0;S=T+4|0;k[S>>2]=0;k[S+4>>2]=0;k[W>>2]=33619968;k[T>>2]=Z;mY(b,W)}if((k[Z>>2]&7|0)!=5){T=W+4|0;S=T+4|0;k[S>>2]=0;k[S+4>>2]=0;k[W>>2]=33619968;k[T>>2]=Z;SW(Z,W,21,.003921568859368563,0.0)}T=k[c>>2]|0;f=c+4|0;if((T|0)!=(k[f>>2]|0)?(k[T>>2]|0)>>>0>=2:0){k[W>>2]=0;d=W+4|0;k[d>>2]=0;e=ZT(68)|0;k[e>>2]=1;j=e+4|0;k[W>>2]=j;k[d>>2]=63;i[e+67>>0]=0;l=358211;m=j+63|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,W,370627,358138,138);k[d>>2]=0;k[W>>2]=0;T=k[e>>2]|0;k[e>>2]=T+-1;if((T|0)==1)ggb(k[e+-4>>2]|0)}T=k[a+12>>2]|0;T=Ufb((T|0)==0?1016759:T,377117)|0;if(!T)f=0;else{b=Z+12|0;d=k[b>>2]|0;e=k[q>>2]|0;k[X>>2]=359516;do if((Zfb(T,359521,X)|0)>=0){if((Zfb(T,359527,n)|0)<0){Sxa(1,0);break}k[p>>2]=e;k[p+4>>2]=d;if((Zfb(T,359552,p)|0)<0)Sxa(1,0)}else Sxa(1,0);while(0);S=k[c>>2]|0;if((S|0)!=(k[f>>2]|0)?(k[S>>2]|0)!=1:0)Txa(T,k[Z+16>>2]|0,aa(k[q>>2]|0,k[b>>2]|0)|0)|0;else{d=k[Z+16>>2]|0;S=k[b>>2]|0;e=k[q>>2]|0;a:do if((S+-8|0)>>>0>32759)Txa(T,d,aa(e,S)|0)|0;else{R=fgb(S<<2)|0;if(!R){Txa(T,d,aa(e,S)|0)|0;break}b:do if((e|0)>0){x=W+1|0;y=S>>>8&255;z=W+2|0;A=S&255;B=W+3|0;C=(S|0)>0;D=S<<1;E=S*3|0;F=X+1|0;G=T+76|0;H=T+16|0;I=T+74|0;J=T+8|0;K=T+4|0;L=T+44|0;M=T+28|0;N=T+20|0;O=T+48|0;P=T+36|0;Q=T+75|0;c:while(1){q=e;e=e+-1|0;i[W>>0]=2;i[x>>0]=2;i[z>>0]=y;i[B>>0]=A;b=k[H>>2]|0;f=(b|0)==0;d:do if((k[G>>2]|0)>-1){if(f){b=i[I>>0]|0;i[I>>0]=b+255|b;b=k[T>>2]|0;if(b&8|0){V=48;break c}k[J>>2]=0;k[K>>2]=0;f=k[L>>2]|0;k[M>>2]=f;k[N>>2]=f;b=f+(k[O>>2]|0)|0;k[H>>2]=b}else f=k[N>>2]|0;j=f;if((b-f|0)>>>0<4){b=ci[k[P>>2]&255](T,W,4)|0;break}e:do if((i[Q>>0]|0)>-1){b=4;while(1){if(!b){g=4;h=W;b=0;f=j;break e}f=b+-1|0;if((i[W+f>>0]|0)==10)break;else b=f}if((ci[k[P>>2]&255](T,W,b)|0)>>>0<b>>>0)break d;g=4-b|0;h=W+b|0;f=k[N>>2]|0}else{g=4;h=W;b=0;f=j}while(0);upb(f|0,h|0,g|0)|0;k[N>>2]=(k[N>>2]|0)+g;b=b+g|0}else{if(f){b=i[I>>0]|0;i[I>>0]=b+255|b;b=k[T>>2]|0;if(b&8|0){V=35;break c}k[J>>2]=0;k[K>>2]=0;f=k[L>>2]|0;k[M>>2]=f;k[N>>2]=f;b=f+(k[O>>2]|0)|0;k[H>>2]=b}else f=k[N>>2]|0;j=f;if((b-f|0)>>>0<4){b=ci[k[P>>2]&255](T,W,4)|0;break}f:do if((i[Q>>0]|0)>-1){b=4;while(1){if(!b){g=4;h=W;b=0;f=j;break f}f=b+-1|0;if((i[W+f>>0]|0)==10)break;else b=f}if((ci[k[P>>2]&255](T,W,b)|0)>>>0<b>>>0)break d;g=4-b|0;h=W+b|0;f=k[N>>2]|0}else{g=4;h=W;b=0;f=j}while(0);upb(f|0,h|0,g|0)|0;k[N>>2]=(k[N>>2]|0)+g;b=b+g|0}while(0);if(b>>>0<4){V=60;break}if(C){j=0;l=d;while(1){t=+o[l+8>>2];w=+o[l+4>>2];v=+o[l>>2];s=w>t?w:t;s=s<v?v:s;u=s;if(u<1.0e-32){i[W>>0]=0;h=0;g=0;b=0;f=0}else{u=+Ofb(s,X)*256.0/u;f=~~(t*u)&255;i[W>>0]=f;h=(k[X>>2]|0)+128&255;g=~~(v*u)&255;b=~~(w*u)&255}i[x>>0]=b;i[z>>0]=g;i[B>>0]=h;i[R+j>>0]=f;i[R+(j+S)>>0]=b;i[R+(j+D)>>0]=g;i[R+(j+E)>>0]=h;j=j+1|0;if((j|0)==(S|0))break;else l=l+12|0}d=d+(E<<2)|0;n=0;do{p=R+(aa(n,S)|0)|0;b=0;do do if((b|0)<(S|0)){j=0;a=b;while(1){a=a+j|0;f=a+1|0;g:do if((f|0)<(S|0)){h=i[p+a>>0]|0;g=1;while(1){if(h<<24>>24!=(i[p+f>>0]|0)){c=g;break g}g=g+1|0;f=g+a|0;if(!((g|0)<127&(f|0)<(S|0))){c=g;break}}}else c=1;while(0);if(!((a|0)<(S|0)&(c|0)<4))break;else j=c}do if((j|0)>1&(j|0)==(a-b|0)){i[X>>0]=j+128;i[F>>0]=i[p+b>>0]|0;b=k[H>>2]|0;f=(b|0)==0;h:do if((k[G>>2]|0)>-1){if(f){b=i[I>>0]|0;i[I>>0]=b+255|b;b=k[T>>2]|0;if(b&8|0){V=145;break c}k[J>>2]=0;k[K>>2]=0;f=k[L>>2]|0;k[M>>2]=f;k[N>>2]=f;b=f+(k[O>>2]|0)|0;k[H>>2]=b}else f=k[N>>2]|0;j=f;if((b-f|0)>>>0<2){b=ci[k[P>>2]&255](T,X,2)|0;break}i:do if((i[Q>>0]|0)>-1){b=2;while(1){if(!b){g=2;h=X;b=0;f=j;break i}f=b+-1|0;if((i[X+f>>0]|0)==10)break;else b=f}if((ci[k[P>>2]&255](T,X,b)|0)>>>0<b>>>0)break h;g=2-b|0;h=X+b|0;f=k[N>>2]|0}else{g=2;h=X;b=0;f=j}while(0);upb(f|0,h|0,g|0)|0;k[N>>2]=(k[N>>2]|0)+g;b=b+g|0}else{if(f){b=i[I>>0]|0;i[I>>0]=b+255|b;b=k[T>>2]|0;if(b&8|0){V=132;break c}k[J>>2]=0;k[K>>2]=0;f=k[L>>2]|0;k[M>>2]=f;k[N>>2]=f;b=f+(k[O>>2]|0)|0;k[H>>2]=b}else f=k[N>>2]|0;j=f;if((b-f|0)>>>0<2){b=ci[k[P>>2]&255](T,X,2)|0;break}j:do if((i[Q>>0]|0)>-1){b=2;while(1){if(!b){g=2;h=X;b=0;f=j;break j}f=b+-1|0;if((i[X+f>>0]|0)==10)break;else b=f}if((ci[k[P>>2]&255](T,X,b)|0)>>>0<b>>>0)break h;g=2-b|0;h=X+b|0;f=k[N>>2]|0}else{g=2;h=X;b=0;f=j}while(0);upb(f|0,h|0,g|0)|0;k[N>>2]=(k[N>>2]|0)+g;b=b+g|0}while(0);if(b>>>0<2){V=192;break c}else b=a}else{if((a|0)<=(b|0))break;do{m=a-b|0;m=(m|0)>128?128:m;i[X>>0]=m;f=k[H>>2]|0;g=(f|0)==0;k:do if((k[G>>2]|0)>-1){if(g){f=i[I>>0]|0;i[I>>0]=f+255|f;f=k[T>>2]|0;if(f&8|0){V=88;break c}k[J>>2]=0;k[K>>2]=0;g=k[L>>2]|0;k[M>>2]=g;k[N>>2]=g;f=g+(k[O>>2]|0)|0;k[H>>2]=f}else g=k[N>>2]|0;l=g;if((f|0)==(g|0)){U=ci[k[P>>2]&255](T,X,1)|0;V=98;break}l:do if((i[Q>>0]|0)>-1){g=1;while(1){if(!g){h=1;j=X;g=0;f=l;break l}f=g+-1|0;if((i[X+f>>0]|0)==10)break;else g=f}if((ci[k[P>>2]&255](T,X,g)|0)>>>0<g>>>0)break k;h=1-g|0;j=X+g|0;f=k[N>>2]|0}else{h=1;j=X;g=0;f=l}while(0);upb(f|0,j|0,h|0)|0;k[N>>2]=(k[N>>2]|0)+h;U=g+h|0;V=98}else{if(g){f=i[I>>0]|0;i[I>>0]=f+255|f;f=k[T>>2]|0;if(f&8|0){V=75;break c}k[J>>2]=0;k[K>>2]=0;g=k[L>>2]|0;k[M>>2]=g;k[N>>2]=g;f=g+(k[O>>2]|0)|0;k[H>>2]=f}else g=k[N>>2]|0;l=g;if((f|0)==(g|0)){U=ci[k[P>>2]&255](T,X,1)|0;V=98;break}m:do if((i[Q>>0]|0)>-1){g=1;while(1){if(!g){h=1;j=X;g=0;f=l;break m}f=g+-1|0;if((i[X+f>>0]|0)==10)break;else g=f}if((ci[k[P>>2]&255](T,X,g)|0)>>>0<g>>>0)break k;h=1-g|0;j=X+g|0;f=k[N>>2]|0}else{h=1;j=X;g=0;f=l}while(0);upb(f|0,j|0,h|0)|0;k[N>>2]=(k[N>>2]|0)+h;U=g+h|0;V=98}while(0);if((V|0)==98?(V=0,(U|0)==0):0){V=193;break c}h=p+b|0;f=k[H>>2]|0;g=(f|0)==0;n:do if((k[G>>2]|0)>-1){do if(g){f=i[I>>0]|0;i[I>>0]=f+255|f;f=k[T>>2]|0;if(!(f&8)){k[J>>2]=0;k[K>>2]=0;g=k[L>>2]|0;k[M>>2]=g;k[N>>2]=g;f=g+(k[O>>2]|0)|0;k[H>>2]=f;break}else{k[T>>2]=f|32;f=0;break n}}else g=k[N>>2]|0;while(0);l=g;if((f-g|0)>>>0<m>>>0){f=ci[k[P>>2]&255](T,h,m)|0;break}o:do if((i[Q>>0]|0)>-1){f=m;while(1){if(!f){j=m;f=0;g=l;break o}g=f+-1|0;if((i[h+g>>0]|0)==10)break;else f=g}if((ci[k[P>>2]&255](T,h,f)|0)>>>0<f>>>0)break n;j=m-f|0;h=h+f|0;g=k[N>>2]|0}else{j=m;f=0;g=l}while(0);upb(g|0,h|0,j|0)|0;k[N>>2]=(k[N>>2]|0)+j;f=f+j|0}else{do if(g){f=i[I>>0]|0;i[I>>0]=f+255|f;f=k[T>>2]|0;if(!(f&8)){k[J>>2]=0;k[K>>2]=0;g=k[L>>2]|0;k[M>>2]=g;k[N>>2]=g;f=g+(k[O>>2]|0)|0;k[H>>2]=f;break}else{k[T>>2]=f|32;f=0;break n}}else g=k[N>>2]|0;while(0);l=g;if((f-g|0)>>>0<m>>>0){f=ci[k[P>>2]&255](T,h,m)|0;break}p:do if((i[Q>>0]|0)>-1){f=m;while(1){if(!f){j=m;f=0;g=l;break p}g=f+-1|0;if((i[h+g>>0]|0)==10)break;else f=g}if((ci[k[P>>2]&255](T,h,f)|0)>>>0<f>>>0)break n;j=m-f|0;h=h+f|0;g=k[N>>2]|0}else{j=m;f=0;g=l}while(0);upb(g|0,h|0,j|0)|0;k[N>>2]=(k[N>>2]|0)+j;f=f+j|0}while(0);if(m>>>0>f>>>0){V=194;break c}b=m+b|0}while((a|0)>(b|0))}while(0);if((c|0)<=3)break;i[X>>0]=c+128;i[F>>0]=i[p+a>>0]|0;f=k[H>>2]|0;g=(f|0)==0;q:do if((k[G>>2]|0)>-1){if(g){f=i[I>>0]|0;i[I>>0]=f+255|f;f=k[T>>2]|0;if(f&8|0){V=174;break c}k[J>>2]=0;k[K>>2]=0;g=k[L>>2]|0;k[M>>2]=g;k[N>>2]=g;f=g+(k[O>>2]|0)|0;k[H>>2]=f}else g=k[N>>2]|0;l=g;if((f-g|0)>>>0<2){f=ci[k[P>>2]&255](T,X,2)|0;break}r:do if((i[Q>>0]|0)>-1){f=2;while(1){if(!f){h=2;j=X;f=0;g=l;break r}g=f+-1|0;if((i[X+g>>0]|0)==10)break;else f=g}if((ci[k[P>>2]&255](T,X,f)|0)>>>0<f>>>0)break q;h=2-f|0;j=X+f|0;g=k[N>>2]|0}else{h=2;j=X;f=0;g=l}while(0);upb(g|0,j|0,h|0)|0;k[N>>2]=(k[N>>2]|0)+h;f=f+h|0}else{if(g){f=i[I>>0]|0;i[I>>0]=f+255|f;f=k[T>>2]|0;if(f&8|0){V=161;break c}k[J>>2]=0;k[K>>2]=0;g=k[L>>2]|0;k[M>>2]=g;k[N>>2]=g;f=g+(k[O>>2]|0)|0;k[H>>2]=f}else g=k[N>>2]|0;l=g;if((f-g|0)>>>0<2){f=ci[k[P>>2]&255](T,X,2)|0;break}s:do if((i[Q>>0]|0)>-1){f=2;while(1){if(!f){h=2;j=X;f=0;g=l;break s}g=f+-1|0;if((i[X+g>>0]|0)==10)break;else f=g}if((ci[k[P>>2]&255](T,X,f)|0)>>>0<f>>>0)break q;h=2-f|0;j=X+f|0;g=k[N>>2]|0}else{h=2;j=X;f=0;g=l}while(0);upb(g|0,j|0,h|0)|0;k[N>>2]=(k[N>>2]|0)+h;f=f+h|0}while(0);if(f>>>0<2){V=195;break c}b=b+c|0}while(0);while((b|0)<(S|0));n=n+1|0}while((n|0)<4)}if((q|0)<=1)break b}if((V|0)==35){k[T>>2]=b|32;V=60}else if((V|0)==48){k[T>>2]=b|32;V=60}else if((V|0)==75){k[T>>2]=f|32;V=193}else if((V|0)==88){k[T>>2]=f|32;V=193}else if((V|0)==132){k[T>>2]=b|32;V=192}else if((V|0)==145){k[T>>2]=b|32;V=192}else if((V|0)==161){k[T>>2]=f|32;V=195}else if((V|0)==174){k[T>>2]=f|32;V=195}else if((V|0)==194)Sxa(1,0);if((V|0)==60){ggb(R);Sxa(1,0);break a}else if((V|0)==192)Sxa(1,0);else if((V|0)==193)Sxa(1,0);else if((V|0)==195)Sxa(1,0);ggb(R);break a}while(0);ggb(R)}while(0)}Qfb(T)|0;f=1}b=Z+36|0;d=k[b>>2]|0;if(d|0?(W=d+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){e=k[b>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[Z+32>>2]|0;if(!d){d=B1()|0;e=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[b>>2]=0}k[b>>2]=0;Z=Z+16|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[$>>2]|0)>0){e=k[Y>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[$>>2]|0))}d=k[_>>2]|0;if((d|0)==(ba|0)|(d|0)==0){r=ca;return f|0}ggb(k[d+-4>>2]|0);r=ca;return f|0}function jwa(a,b){a=a|0;b=b|0;var c=0,d=0;while(1){b=fgb(36)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}kwa(b);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=89412;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function kwa(a){a=a|0;var b=0,c=0;k[a+28>>2]=0;k[a+32>>2]=0;i[a+24>>0]=0;b=a+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[a>>2]=89768;b=a+4|0;c=a+8|0;k[c>>2]=0;k[b>>2]=0;a=ZT(32)|0;k[a>>2]=1;k[b>>2]=a+4;k[c>>2]=26;i[a+30>>0]=0;a=k[b>>2]|0;b=358056;c=a+26|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));return}function lwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k[a>>2]=0;v=a+4|0;k[v>>2]=0;k[a+8>>2]=0;if(!b)return;if(b>>>0>76695844)ad(426534,426557,304,426811);e=b*56|0;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[v>>2]=d;k[a>>2]=d;k[a+8>>2]=d+(b*56|0);j=c+4|0;l=c+8|0;m=c+12|0;n=c+16|0;o=c+20|0;p=c+24|0;q=c+28|0;r=c+32|0;s=c+36|0;t=c+44|0;u=c+40|0;do{k[d>>2]=k[c>>2];i=d+4|0;k[i>>2]=k[j>>2];h=d+8|0;k[h>>2]=k[l>>2];k[d+12>>2]=k[m>>2];k[d+16>>2]=k[n>>2];k[d+20>>2]=k[o>>2];k[d+24>>2]=k[p>>2];k[d+28>>2]=k[q>>2];k[d+32>>2]=k[r>>2];e=k[s>>2]|0;k[d+36>>2]=e;a=d+40|0;k[a>>2]=h;h=d+48|0;g=d+44|0;k[g>>2]=h;k[d+52>>2]=0;k[h>>2]=0;if(e|0){h=e+12|0;k[h>>2]=(k[h>>2]|0)+1}if((k[j>>2]|0)>=3){k[i>>2]=0;x1(d,k[j>>2]|0,0,0,0);if((k[i>>2]|0)>0){h=k[u>>2]|0;a=k[a>>2]|0;f=k[t>>2]|0;e=k[g>>2]|0;d=0;do{k[a+(d<<2)>>2]=k[h+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[i>>2]|0))}}else{h=k[t>>2]|0;i=k[g>>2]|0;k[i>>2]=k[h>>2];k[i+4>>2]=k[h+4>>2]}d=(k[v>>2]|0)+56|0;k[v>>2]=d;b=b+-1|0}while((b|0)!=0);return}function mwa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=89812;b=a+100|0;c=k[b>>2]|0;if(c|0){d=k[c+4>>2]|0;if(d|0)Uh[k[d+40>>2]&2047](c);ggb(c);k[b>>2]=0}c=a+96|0;b=k[c>>2]|0;if(b|0){Qfb(b)|0;k[c>>2]=0}k[a+8>>2]=0;k[a+4>>2]=0;k[a+12>>2]=-1;Tva(a);return}function nwa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=89812;b=a+100|0;c=k[b>>2]|0;if(c|0){d=k[c+4>>2]|0;if(d|0)Uh[k[d+40>>2]&2047](c);ggb(c);k[b>>2]=0}c=a+96|0;b=k[c>>2]|0;if(b|0){Qfb(b)|0;k[c>>2]=0}k[a+8>>2]=0;k[a+4>>2]=0;k[a+12>>2]=-1;Tva(a);ggb(a);return}function owa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+128|0;H=4;G=fgb(40)|0;k[G>>2]=0;B=I+72|0;C=I+56|0;D=I;E=I+112|0;i[E>>0]=0;F=a+100|0;d=k[F>>2]|0;do if(d){b=k[d+4>>2]|0;if(b|0){y=0;rc(k[b+40>>2]|0,d|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){w=0;v=0;u=0;f=0;t=0;s=0;b=N;break}}y=0;rc(1459,d|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){w=0;v=0;u=0;f=0;t=0;s=0;b=N}else{k[F>>2]=0;x=7}}else x=7;while(0);a:do if((x|0)==7){h=a+96|0;b=k[h>>2]|0;if(b|0){y=0;uc(776,b|0)|0;b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){w=0;v=0;u=0;f=0;t=0;s=h;b=N;break}k[h>>2]=0}g=a+8|0;k[g>>2]=0;f=a+4|0;k[f>>2]=0;e=a+12|0;k[e>>2]=-1;while(1){y=0;b=uc(777,808)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,G|0,H|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){w=0;v=0;u=e;t=g;s=h;b=N;break a}if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}y=0;nc(b|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){w=0;v=0;u=e;t=g;s=h;b=N;break a}}k[F>>2]=b;c=b+488|0;k[b+492>>2]=818;k[b+496>>2]=1460;k[b+500>>2]=819;k[b+504>>2]=1461;k[b+592>>2]=0;k[b+596>>2]=0;k[b+508>>2]=0;k[b+600>>2]=152892;k[b+604>>2]=126;k[b+608>>2]=0;k[b+612>>2]=0;k[b+616>>2]=0;k[b>>2]=c;k[c>>2]=1462;G=npb(b+620|0,1,G|0,H|0)|0;H=N;y=0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,G|0,H|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){w=b;v=b;u=e;t=g;s=h;b=N}else{w=b;v=b;u=e;t=g;s=h;b=0}}while(0);b:while(1){if(!b){n=w+4|0;k[n>>2]=0;q=w+12|0;b=k[q>>2]|0;zpb(n|0,0,484)|0;k[q>>2]=b;q=w+16|0;k[q>>2]=1;y=0;rc(1463,w|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}k[w+8>>2]=0;j=w+24|0;k[j>>2]=0;o=w+312|0;k[o>>2]=0;b=w+164|0;c=b+48|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(c|0));y=0;b=Bc(k[k[n>>2]>>2]|0,w|0,0,172)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,G|0,H|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}d=w+464|0;k[d>>2]=b;k[b>>2]=1464;k[b+4>>2]=778;k[b+8>>2]=779;k[b+28>>2]=780;k[b+96>>2]=0;k[b+100>>2]=0;k[b+36>>2]=780;k[b+104>>2]=0;k[b+40>>2]=780;k[b+108>>2]=0;k[b+44>>2]=780;k[b+112>>2]=0;k[b+48>>2]=780;k[b+116>>2]=0;k[b+52>>2]=780;k[b+120>>2]=0;k[b+56>>2]=780;k[b+124>>2]=0;k[b+60>>2]=780;k[b+128>>2]=0;k[b+64>>2]=780;k[b+132>>2]=0;k[b+68>>2]=780;k[b+136>>2]=0;k[b+72>>2]=780;k[b+140>>2]=0;k[b+76>>2]=780;k[b+144>>2]=0;k[b+80>>2]=780;k[b+148>>2]=0;k[b+84>>2]=780;k[b+152>>2]=0;k[b+156>>2]=0;k[b+92>>2]=780;k[b+160>>2]=0;k[b+32>>2]=781;k[b+88>>2]=781;d=k[d>>2]|0;l=w+216|0;k[l>>2]=0;k[w+144>>2]=0;k[w+440>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+24>>2]=0;k[d+164>>2]=0;y=0;d=Bc(k[k[n>>2]>>2]|0,w|0,0,28)|0;b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}b=w+460|0;k[b>>2]=d;k[d>>2]=782;k[d+4>>2]=1465;k[d+8>>2]=1466;k[d+12>>2]=1467;k[d+16>>2]=0;k[d+20>>2]=0;k[d+24>>2]=1;m=w+20|0;k[m>>2]=200;h=k[a+52>>2]|0;g=h;if(h){h=k[a+40>>2]|0;if((h|0)<3)c=aa(k[a+48>>2]|0,k[a+44>>2]|0)|0;else{e=k[a+76>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(h|0))}if(c){d=w+776|0;k[j>>2]=d;k[w+784>>2]=1468;k[w+788>>2]=783;k[w+792>>2]=820;k[w+796>>2]=270;k[w+800>>2]=1468;e=w+780|0;k[e>>2]=0;k[w+804>>2]=0;k[d>>2]=g;d=aa(k[a+44>>2]|0,k[a+48>>2]|0)|0;if((h|0)>0)c=k[(k[a+80>>2]|0)+(h+-1<<2)>>2]|0;else c=0;h=aa(d,c)|0;k[e>>2]=h}else x=31}else x=31;if((x|0)==31){x=0;h=k[a+20>>2]|0;y=0;h=ec(271,((h|0)==0?1016759:h)|0,373005)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,G|0,H|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}k[s>>2]=h;if(h|0){c=k[j>>2]|0;if(!c){y=0;g=Bc(k[k[n>>2]>>2]|0,w|0,0,40)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,G|0,H|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}k[j>>2]=g;y=0;c=Bc(k[k[n>>2]>>2]|0,w|0,0,4096)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,G|0,H|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}k[g+32>>2]=c;c=k[j>>2]|0}k[c+8>>2]=1469;k[c+12>>2]=784;k[c+16>>2]=821;k[c+20>>2]=270;k[c+24>>2]=1470;k[c+28>>2]=h;k[c+4>>2]=0;k[c>>2]=0}}if(k[j>>2]|0){c=k[m>>2]|0;if((c&-2|0)!=200){h=k[w>>2]|0;k[h+20>>2]=21;k[h+24>>2]=c;y=0;rc(k[h>>2]|0,w|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,G|0,H|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}c=k[m>>2]|0}switch(c|0){case 200:{y=0;rc(k[(k[b>>2]|0)+4>>2]|0,v|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,G|0,H|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}y=0;rc(k[(k[j>>2]|0)+8>>2]|0,v|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,G|0,H|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}k[m>>2]=201;x=48;break}case 201:{x=48;break}case 202:break;case 210:case 208:case 207:case 206:case 205:case 204:case 203:{y=0;b=uc(k[k[b>>2]>>2]|0,v|0)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,G|0,H|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}A=b;x=81;break}default:{b=k[w>>2]|0;k[b+20>>2]=21;k[b+24>>2]=c;y=0;rc(k[b>>2]|0,w|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}}}if((x|0)==48){x=0;y=0;b=uc(k[k[b>>2]>>2]|0,v|0)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,G|0,H|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}if((b|0)==1){switch(k[w+36>>2]|0){case 1:{k[w+40>>2]=1;k[w+44>>2]=1;break}case 3:{c:do if(!(k[w+284>>2]|0)){if(k[w+296>>2]|0){b=i[w+300>>0]|0;switch(b<<24>>24){case 0:{k[w+40>>2]=2;break c}case 1:{k[w+40>>2]=3;break c}default:{l=k[w>>2]|0;k[l+20>>2]=116;k[l+24>>2]=b&255;y=0;Ib(k[l+4>>2]|0,w|0,-1);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}k[w+40>>2]=3;break c}}}d=k[l>>2]|0;b=k[d>>2]|0;c=k[d+88>>2]|0;d=k[d+176>>2]|0;if((b|0)==1&(c|0)==2&(d|0)==3){k[w+40>>2]=3;break}if((b|0)==82&(c|0)==71&(d|0)==66){k[w+40>>2]=2;break}l=k[w>>2]|0;k[l+24>>2]=b;k[l+28>>2]=c;k[l+32>>2]=d;k[l+20>>2]=113;y=0;Ib(k[l+4>>2]|0,w|0,1);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}k[w+40>>2]=3}else k[w+40>>2]=3;while(0);k[w+44>>2]=2;break}case 4:{d:do if(!(k[w+296>>2]|0))k[w+40>>2]=4;else{b=i[w+300>>0]|0;switch(b<<24>>24){case 0:{k[w+40>>2]=4;break d}case 2:{k[w+40>>2]=5;break d}default:{l=k[w>>2]|0;k[l+20>>2]=116;k[l+24>>2]=b&255;y=0;Ib(k[l+4>>2]|0,w|0,-1);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}k[w+40>>2]=5;break d}}}while(0);k[w+44>>2]=4;break}default:{k[w+40>>2]=0;k[w+44>>2]=0}}l=k[w+428>>2]|0;k[w+48>>2]=l;k[w+52>>2]=l;p[w+56>>3]=1.0;k[w+64>>2]=0;k[w+68>>2]=0;k[w+72>>2]=0;k[w+76>>2]=1;k[w+80>>2]=1;k[w+84>>2]=0;k[w+88>>2]=2;k[w+92>>2]=1;k[w+96>>2]=256;k[w+136>>2]=0;k[w+100>>2]=0;k[w+104>>2]=0;k[w+108>>2]=0;k[m>>2]=202}else{A=b;x=81}}do if((x|0)==81?(x=0,(A|0)==2):0){b=k[w>>2]|0;k[b+20>>2]=53;y=0;rc(k[b>>2]|0,w|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}b=k[n>>2]|0;if(b|0){y=0;Ib(k[b+36>>2]|0,w|0,1);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}if(!(k[q>>2]|0)){k[m>>2]=100;break}else{k[m>>2]=200;k[o>>2]=0;break}}}while(0);k[w+48>>2]=1;b=a+16|0;k[w+52>>2]=k[b>>2];k[b>>2]=1;y=0;rc(1471,w|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}k[f>>2]=k[w+112>>2];k[t>>2]=k[w+116>>2];k[u>>2]=(k[w+36>>2]|0)>1?16:0;i[E>>0]=1}}h=k[a+20>>2]|0;j=k[a+24>>2]|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;if(j>>>0>4294967279){y=0;nc(5);b=y;y=0;if((b|0)!=0&(z|0)!=0){q=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!q)dd(b|0,z|0);N=z};j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}if(j>>>0<11){c=C+11|0;i[c>>0]=j;if(!j)b=C;else{b=C;x=101}}else{g=j+16&-16;e=(g|0)==0?1:g;while(1){y=0;b=uc(777,e|0)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,G|0,H|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}y=0;nc(b|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}}k[C>>2]=b;k[C+8>>2]=g|-2147483648;k[C+4>>2]=j;c=C+11|0;x=101}if((x|0)==101){x=0;upb(b|0,h|0,j|0)|0}i[b+j>>0]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;b=i[c>>0]|0;if(b<<24>>24<0){j=k[C>>2]|0;l=k[C+4>>2]|0;if(l>>>0>4294967279){y=0;nc(5);b=y;y=0;if((b|0)!=0&(z|0)!=0){q=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!q)dd(b|0,z|0);N=z};j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}if(l>>>0<11){i[B+11>>0]=l;if(!l)b=B;else{b=B;x=115}}else{h=l+16&-16;g=(h|0)==0?1:h;while(1){y=0;b=uc(777,g|0)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,G|0,H|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}y=0;nc(b|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){d=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!d)dd(b|0,z|0);N=z}else d=-1;if((d|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue b}}k[B>>2]=b;k[B+8>>2]=h|-2147483648;k[B+4>>2]=l;x=115}if((x|0)==115){x=0;upb(b|0,j|0,l|0)|0}i[b+l>>0]=0;b=i[c>>0]|0}else{k[B>>2]=k[C>>2];k[B+4>>2]=k[C+4>>2];k[B+8>>2]=k[C+8>>2]}j=B+12|0;k[j>>2]=0;l=B+16|0;k[l>>2]=0;k[B+20>>2]=0;k[B+28>>2]=0;k[B+32>>2]=0;h=B+28|0;k[B+24>>2]=h;k[B+36>>2]=0;if(b<<24>>24<0){y=0;rc(1459,k[C>>2]|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}}y=0;b=uc(785,B|0)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,G|0,H|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}if(b){y=0;mc(307,D|0,B|0,274);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}g=k[D+48>>2]|0;g=(g&65535)<<16>>16==-1?1:g>>>16;b=D+12|0;if((i[b+11>>0]|0)<0){y=0;rc(1459,k[b>>2]|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}}b=k[D>>2]|0;c=b;if(b|0){d=D+4|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);y=0;rc(1459,b|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}}d=g}else d=1;y=0;rc(1472,k[h>>2]|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}b=k[j>>2]|0;if(b|0){if((k[l>>2]|0)!=(b|0))k[l>>2]=b;y=0;rc(1459,b|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}}if((i[B+11>>0]|0)<0){y=0;rc(1459,k[B>>2]|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}}k[a+104>>2]=d;if(i[E>>0]&1){x=152;break}d=k[F>>2]|0;if(d|0){b=k[d+4>>2]|0;if(b|0){y=0;rc(k[b+40>>2]|0,d|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}}y=0;rc(1459,d|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q;continue}k[F>>2]=0}b=k[s>>2]|0;if(!b)break;y=0;uc(776,b|0)|0;b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,G|0,H|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){j=s;l=t;m=f;n=u;o=v;q=w;b=N;s=j;t=l;f=m;u=n;v=o;w=q}else{x=150;break}}if((x|0)==150)k[s>>2]=0;else if((x|0)==152){H=i[E>>0]|0;H=H&1;H=H<<24>>24!=0;ggb(G|0);r=I;return H|0}k[t>>2]=0;k[f>>2]=0;k[u>>2]=-1;H=i[E>>0]|0;H=H&1;H=H<<24>>24!=0;ggb(G|0);r=I;return H|0}function pwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;qa=r;r=r+608|0;pa=4;oa=fgb(40)|0;k[oa>>2]=0;W=qa+312|0;da=qa+296|0;ha=qa+280|0;ia=qa+264|0;ka=qa+248|0;la=qa+232|0;ma=qa+216|0;na=qa+200|0;L=qa+184|0;M=qa+168|0;O=qa+152|0;P=qa+136|0;Q=qa+120|0;R=qa+104|0;S=qa+88|0;T=qa+72|0;U=qa+56|0;V=qa+40|0;X=qa+24|0;Y=qa+8|0;Z=qa+4|0;_=qa;K=qa+592|0;$=qa+336|0;ba=qa+328|0;i[ba>>0]=0;ca=k[b+48>>2]|0;ea=(k[b>>2]&4088|0)!=0;fa=a+100|0;ga=k[fa>>2]|0;if(ga){f=a+4|0;if(k[f>>2]|0){e=a+8|0;if(k[e>>2]|0){oa=npb(ga+620|0,1,oa|0,pa|0)|0;pa=N;y=0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){h=ga;c=N;J=6}else{h=ga;c=0;J=6}}else{h=0;g=f;J=110}}else{h=0;e=0;g=f;J=110}}else{h=0;e=0;f=0;J=116}a:while(1)if((J|0)==6){J=0;if(c|0){g=f;J=110;continue}H=ga+196|0;if((((k[H>>2]|0)==0?(k[ga+200>>2]|0)==0:0)?(ja=ga+180|0,(k[ja>>2]|0)==0):0)?(k[ga+184>>2]|0)==0:0){I=ga+4|0;n=4;G=416;while(1){F=i[358297+n>>0]|0;c=n+1|0;d=K;g=358298+n|0;j=d+16|0;do{i[d>>0]=i[g>>0]|0;d=d+1|0;g=g+1|0}while((d|0)<(j|0));s=l[358297+c>>0]|0;t=l[358297+(n+2)>>0]|0;u=l[358297+(n+3)>>0]|0;v=l[358297+(n+4)>>0]|0;w=l[358297+(n+5)>>0]|0;x=l[358297+(n+6)>>0]|0;A=l[358297+(n+7)>>0]|0;B=l[358297+(n+8)>>0]|0;C=l[358297+(n+9)>>0]|0;D=l[358297+(n+10)>>0]|0;g=l[358297+(n+11)>>0]|0;j=l[358297+(n+12)>>0]|0;m=l[358297+(n+13)>>0]|0;o=l[358297+(n+14)>>0]|0;p=l[358297+(n+15)>>0]|0;q=l[358297+(n+16)>>0]|0;E=t+s+u+v+w+x+A+B+C+D+g+j+m+o+p+q|0;F=F&255;c=n+17|0;d=G+-17|0;if(E>>>0>256|d>>>0<E>>>0)break;if(!E)n=c;else{upb($|0,358314+n|0,E|0)|0;n=s+c+t+u+v+w+x+A+B+C+D+g+j+m+o+p+q|0}G=d-E|0;D=(F&16|0)==0;E=F+-16|0;m=D?ja+(F<<2)|0:H+(E<<2)|0;if((D?F:E)>>>0>3)break;c=k[m>>2]|0;if(!c){y=0;c=Bc(k[k[I>>2]>>2]|0,ga|0,0,280)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){g=Cpb(k[d>>2]|0,oa|0,pa|0)|0;if(!g)dd(d|0,z|0);N=z}else g=-1;if((g|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}k[c+276>>2]=0;k[m>>2]=c;if(!c)break}i[c>>0]=0;d=c+1|0;g=K;j=d+16|0;do{i[d>>0]=i[g>>0]|0;d=d+1|0;g=g+1|0}while((d|0)<(j|0));upb((k[m>>2]|0)+17|0,$|0,256)|0;if(G>>>0<=16)break}}c=(k[ga+36>>2]|0)!=4;d=ga+44|0;do if(ea)if(c){k[d>>2]=2;k[ga+120>>2]=3;break}else{k[d>>2]=4;k[ga+120>>2]=4;break}else if(c){k[d>>2]=1;k[ga+120>>2]=1;break}else{k[d>>2]=4;k[ga+120>>2]=4;break}while(0);y=0;uc(786,ga|0)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue}w=ga+4|0;y=0;v=ab(k[(k[w>>2]|0)+8>>2]|0,ga|0,1,k[f>>2]<<2|0,1)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue}c=k[b+16>>2]|0;I=k[e>>2]|0;k[e>>2]=I+-1;b:do if(!I)m=ga+20|0;else{u=ga+120|0;if(!ea){m=ga+20|0;n=ga+140|0;o=ga+116|0;p=ga+8|0;q=ga+448|0;j=c;while(1){c=k[m>>2]|0;if((c|0)!=205){I=k[ga>>2]|0;k[I+20>>2]=21;k[I+24>>2]=c;y=0;rc(k[I>>2]|0,ga|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}}c=k[n>>2]|0;d=k[o>>2]|0;if(c>>>0>=d>>>0){c=k[ga>>2]|0;k[c+20>>2]=126;y=0;Ib(k[c+4>>2]|0,ga|0,-1);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}}else{g=k[p>>2]|0;if(g|0){k[g+4>>2]=c;k[g+8>>2]=d;y=0;rc(k[g>>2]|0,ga|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}}k[Z>>2]=0;y=0;Cb(k[(k[q>>2]|0)+4>>2]|0,ga|0,v|0,Z|0,1);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}k[n>>2]=(k[n>>2]|0)+(k[Z>>2]|0)}c=k[v>>2]|0;g=k[f>>2]|0;if((k[u>>2]|0)!=1){if((g|0)>0){d=0;while(1){I=l[c+3>>0]|0;I=(((I-((aa(I,(l[c+1>>0]|0)^255)|0)>>>8)|0)*9617|0)+8192+((I-((aa((l[c+2>>0]|0)^255,I)|0)>>>8)|0)*1868|0)+((I-((aa(I,(l[c>>0]|0)^255)|0)>>>8)|0)*4899|0)|0)>>>14&255;i[j+d>>0]=I;d=d+1|0;if((d|0)>=(g|0))break;else c=c+4|0}}}else upb(j|0,c|0,g|0)|0;I=k[e>>2]|0;k[e>>2]=I+-1;if(!I)break b;else j=j+ca|0}}o=ga+20|0;p=ga+140|0;q=ga+116|0;s=ga+8|0;t=ga+448|0;n=c;while(1){c=k[o>>2]|0;if((c|0)!=205){I=k[ga>>2]|0;k[I+20>>2]=21;k[I+24>>2]=c;y=0;rc(k[I>>2]|0,ga|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}}c=k[p>>2]|0;d=k[q>>2]|0;if(c>>>0>=d>>>0){c=k[ga>>2]|0;k[c+20>>2]=126;y=0;Ib(k[c+4>>2]|0,ga|0,-1);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}}else{g=k[s>>2]|0;if(g|0){k[g+4>>2]=c;k[g+8>>2]=d;y=0;rc(k[g>>2]|0,ga|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}}k[_>>2]=0;y=0;Cb(k[(k[t>>2]|0)+4>>2]|0,ga|0,v|0,_|0,1);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}k[p>>2]=(k[p>>2]|0)+(k[_>>2]|0)}j=k[v>>2]|0;m=k[f>>2]|0;c=(m|0)>0;if((k[u>>2]|0)==3){if(c){d=0;g=n;c=j;while(1){H=i[c+1>>0]|0;I=i[c+2>>0]|0;i[g+2>>0]=i[c>>0]|0;i[g+1>>0]=H;i[g>>0]=I;d=d+1|0;if((d|0)>=(m|0))break;else{g=g+3|0;c=c+3|0}}}}else if(c){d=0;g=n;c=j;while(1){G=l[c+3>>0]|0;H=G-((aa(G,(l[c+1>>0]|0)^255)|0)>>>8)|0;I=G-((aa((l[c+2>>0]|0)^255,G)|0)>>>8)|0;G=G-((aa(G,(l[c>>0]|0)^255)|0)>>>8)&255;i[g+2>>0]=G;i[g+1>>0]=H;i[g>>0]=I;d=d+1|0;if((d|0)>=(m|0))break;else{g=g+3|0;c=c+4|0}}}I=k[e>>2]|0;k[e>>2]=I+-1;if(!I){m=o;break}else n=n+ca|0}}while(0);i[ba>>0]=1;c=k[m>>2]|0;if((c+-205|0)>>>0<2?(k[ga+64>>2]|0)==0:0){if((k[ga+140>>2]|0)>>>0<(k[ga+116>>2]|0)>>>0){c=k[ga>>2]|0;k[c+20>>2]=69;y=0;rc(k[c>>2]|0,ga|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue}}y=0;rc(k[(k[ga+444>>2]|0)+4>>2]|0,h|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue}k[m>>2]=210}else J=78;c:do if((J|0)==78){J=0;switch(c|0){case 210:break c;case 207:{k[m>>2]=210;break c}default:{}}I=k[ga>>2]|0;k[I+20>>2]=21;k[I+24>>2]=c;y=0;rc(k[I>>2]|0,ga|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}}while(0);j=ga+460|0;while(1){c=k[j>>2]|0;if(k[c+20>>2]|0){J=86;break}y=0;c=uc(k[c>>2]|0,h|0)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){g=Cpb(k[d>>2]|0,oa|0,pa|0)|0;if(!g)dd(d|0,z|0);N=z}else g=-1;if((g|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}if(!c)break}do if((J|0)==86){y=0;rc(k[(k[ga+24>>2]|0)+24>>2]|0,h|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}c=k[w>>2]|0;if(c|0){y=0;Ib(k[c+36>>2]|0,ga|0,1);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}if(!(k[ga+16>>2]|0)){k[m>>2]=100;break}else{k[m>>2]=200;k[ga+312>>2]=0;break}}}while(0);switch(k[a+104>>2]|0){case 8:{k[U+8>>2]=0;k[U+12>>2]=0;k[U>>2]=16842752;k[U+4>>2]=b;c=V+4|0;J=c+4|0;k[J>>2]=0;k[J+4>>2]=0;k[V>>2]=33619968;k[c>>2]=b;y=0;Ib(822,U|0,V|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}k[X+8>>2]=0;k[X+12>>2]=0;k[X>>2]=16842752;k[X+4>>2]=b;c=Y+4|0;J=c+4|0;k[J>>2]=0;k[J+4>>2]=0;k[Y>>2]=33619968;k[c>>2]=b;y=0;mc(308,X|0,Y|0,0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}g=f;J=110;continue a}case 2:{k[W+8>>2]=0;k[W+12>>2]=0;k[W>>2]=16842752;k[W+4>>2]=b;c=da+4|0;J=c+4|0;k[J>>2]=0;k[J+4>>2]=0;k[da>>2]=33619968;k[c>>2]=b;y=0;mc(308,W|0,da|0,1);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}g=f;J=110;continue a}case 3:{k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=b;c=ia+4|0;J=c+4|0;k[J>>2]=0;k[J+4>>2]=0;k[ia>>2]=33619968;k[c>>2]=b;y=0;mc(308,ha|0,ia|0,-1);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}g=f;J=110;continue a}case 4:{k[ka+8>>2]=0;k[ka+12>>2]=0;k[ka>>2]=16842752;k[ka+4>>2]=b;c=la+4|0;J=c+4|0;k[J>>2]=0;k[J+4>>2]=0;k[la>>2]=33619968;k[c>>2]=b;y=0;mc(308,ka|0,la|0,0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}g=f;J=110;continue a}case 5:{k[ma+8>>2]=0;k[ma+12>>2]=0;k[ma>>2]=16842752;k[ma+4>>2]=b;c=na+4|0;J=c+4|0;k[J>>2]=0;k[J+4>>2]=0;k[na>>2]=33619968;k[c>>2]=b;y=0;Ib(822,ma|0,na|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}g=f;J=110;continue a}case 6:{k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=b;c=M+4|0;J=c+4|0;k[J>>2]=0;k[J+4>>2]=0;k[M>>2]=33619968;k[c>>2]=b;y=0;Ib(822,L|0,M|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=b;c=P+4|0;J=c+4|0;k[J>>2]=0;k[J+4>>2]=0;k[P>>2]=33619968;k[c>>2]=b;y=0;mc(308,O|0,P|0,1);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}g=f;J=110;continue a}case 7:{k[Q+8>>2]=0;k[Q+12>>2]=0;k[Q>>2]=16842752;k[Q+4>>2]=b;c=R+4|0;J=c+4|0;k[J>>2]=0;k[J+4>>2]=0;k[R>>2]=33619968;k[c>>2]=b;y=0;Ib(822,Q|0,R|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}k[S+8>>2]=0;k[S+12>>2]=0;k[S>>2]=16842752;k[S+4>>2]=b;c=T+4|0;J=c+4|0;k[J>>2]=0;k[J+4>>2]=0;k[T>>2]=33619968;k[c>>2]=b;y=0;mc(308,S|0,T|0,-1);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){H=f;I=e;J=h;c=N;f=H;e=I;h=J;J=6;continue a}g=f;J=110;continue a}default:{g=f;J=110;continue a}}}else if((J|0)==110){f=k[fa>>2]|0;if(!f){f=g;J=116;continue}c=k[f+4>>2]|0;if(c|0){y=0;rc(k[c+40>>2]|0,f|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){f=g;c=N;J=6;continue}}y=0;rc(1459,f|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){f=g;c=N;J=6;continue}k[fa>>2]=0;f=g;J=116;continue}else if((J|0)==116){J=0;g=a+96|0;c=k[g>>2]|0;if(!c){J=119;break}y=0;uc(776,c|0)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,oa|0,pa|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){c=N;J=6;continue}else break}if((J|0)==119){pa=a+8|0;k[pa>>2]=0;pa=a+4|0;k[pa>>2]=0;pa=a+12|0;k[pa>>2]=-1;pa=i[ba>>0]|0;pa=pa&1;pa=pa<<24>>24!=0;ggb(oa|0);r=qa;return pa|0}k[g>>2]=0;pa=a+8|0;k[pa>>2]=0;pa=a+4|0;k[pa>>2]=0;pa=a+12|0;k[pa>>2]=-1;pa=i[ba>>0]|0;pa=pa&1;pa=pa<<24>>24!=0;ggb(oa|0);r=qa;return pa|0}function qwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;while(1){b=fgb(108)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}c=b+20|0;k[c>>2]=0;k[c+4>>2]=0;k[b+36>>2]=1124007936;c=b+44|0;d=b+76|0;e=b+40|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;f=b+84|0;k[b+80>>2]=f;k[b+88>>2]=0;k[f>>2]=0;k[b+8>>2]=0;k[b+4>>2]=0;k[b+12>>2]=-1;f=b+92|0;i[f>>0]=0;k[b+16>>2]=1;k[b>>2]=89812;e=b+28|0;c=b+32|0;k[c>>2]=0;k[e>>2]=0;d=ZT(8)|0;k[d>>2]=1;k[e>>2]=d+4;k[c>>2]=3;i[d+7>>0]=0;e=k[e>>2]|0;i[e>>0]=i[358293]|0;i[e+1>>0]=i[358294]|0;i[e+2>>0]=i[358295]|0;k[b+100>>2]=0;k[b+96>>2]=0;i[f>>0]=1;k[b+104>>2]=1;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}f=c+4|0;k[f>>2]=1;k[c>>2]=89432;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[f>>2]=(k[f>>2]|0)+1;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function rwa(a){a=a|0;dd((k[a>>2]|0)+132|0,1)}function swa(a){a=a|0;return}function twa(a){a=a|0;return 0}function uwa(a,b){a=a|0;b=b|0;var c=0,d=0;a=k[a+24>>2]|0;c=a+4|0;d=k[c>>2]|0;if((d|0)<(b|0)){k[a>>2]=(k[a>>2]|0)+d;k[c>>2]=0;d=b-d|0;b=a+28|0;k[b>>2]=d;return}else{k[c>>2]=d-b;k[a>>2]=(k[a>>2]|0)+b;d=0;b=a+28|0;k[b>>2]=d;return}}function vwa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1)return;ggb(k[b+-8>>2]|0);return}function wwa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b){ggb(a);return}c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function xwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;ga=r;r=r+2032|0;fa=4;ea=fgb(40)|0;k[ea>>2]=0;ba=ga+2016|0;M=ga+1800|0;G=ga+760|0;ca=ga;C=ga+472|0;B=ga+444|0;da=ga+440|0;Z=ga+1816|0;_=a+28|0;d=k[_>>2]|0;$=a+32|0;k[$>>2]=0;k[_>>2]=0;if((d|0)!=0?(W=d+-4|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){y=0;rc(1459,k[d+-8>>2]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){P=0;g=0;h=0;X=0;l=0;W=0;V=0;U=0;T=0;S=0;R=0;u=0;v=0;w=0;B=0;C=0;L=0;x=0;K=0;A=0;J=0;H=0;I=0;F=0;E=0;D=0;d=N;a=0}else Y=5}else Y=5;a:do if((Y|0)==5){i[ba>>0]=0;D=k[b+12>>2]|0;E=k[b+8>>2]|0;k[M>>2]=0;F=M+4|0;k[F>>2]=0;k[M+8>>2]=0;while(1){y=0;d=uc(777,4096)|0;e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,ea|0,fa|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){P=0;g=0;h=0;X=0;l=0;W=0;V=0;U=0;T=0;S=0;R=0;u=0;v=0;w=0;B=0;C=0;L=0;x=0;K=0;A=0;J=0;H=F;I=M;F=M;d=N;a=0;break a}if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}y=0;nc(d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){P=0;g=0;h=0;X=0;l=0;W=0;V=0;U=0;T=0;S=0;R=0;u=0;v=0;w=0;B=0;C=0;L=0;x=0;K=0;A=0;J=0;H=F;I=M;F=M;d=N;a=0;break a}}k[F>>2]=d;k[M>>2]=d;k[M+8>>2]=d+4096;e=4096;do{i[d>>0]=0;d=(k[F>>2]|0)+1|0;k[F>>2]=d;e=e+-1|0}while((e|0)!=0);A=G+8|0;k[G>>2]=A;x=G+4|0;k[x>>2]=1032;w=ca+4|0;k[w>>2]=0;d=ca+12|0;X=k[d>>2]|0;zpb(w|0,0,436)|0;k[d>>2]=X;k[ca+16>>2]=0;y=0;rc(1463,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)!=1){v=ca+8|0;k[v>>2]=0;u=ca+24|0;k[u>>2]=0;t=ca+84|0;k[t>>2]=0;s=ca+88|0;k[s>>2]=0;q=ca+104|0;k[q>>2]=100;o=ca+92|0;k[o>>2]=0;n=ca+108|0;k[n>>2]=100;m=ca+96|0;k[m>>2]=0;k[ca+112>>2]=100;l=ca+100|0;k[l>>2]=0;k[ca+116>>2]=100;j=ca+120|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;k[j+20>>2]=0;k[j+24>>2]=0;k[j+28>>2]=0;k[ca+380>>2]=8;k[ca+384>>2]=153432;k[ca+388>>2]=63;k[ca+428>>2]=0;p[ca+48>>3]=1.0;h=ca+20|0;k[h>>2]=100;k[C+4>>2]=818;k[C+8>>2]=1460;g=C+12|0;k[g>>2]=819;k[C+16>>2]=1461;k[C+104>>2]=0;k[C+108>>2]=0;k[C+20>>2]=0;k[C+112>>2]=152892;k[C+116>>2]=126;k[C+120>>2]=0;k[C+124>>2]=0;k[C+128>>2]=0;k[ca>>2]=C;k[C>>2]=1462;d=k[a+20>>2]|0;if(!d){a=k[a+12>>2]|0;y=0;a=ec(271,((a|0)==0?1016759:a)|0,377117)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){P=ca;X=j;W=m;V=n;U=o;T=q;S=s;R=t;L=ca;K=G;J=G;H=F;I=M;F=M;d=N;a=0;break}if(!a){P=ca;O=v;L=ca;K=G;J=G;H=F;I=M;F=M;G=0;v=0;Y=146;break}d=k[u>>2]|0;if(!d){y=0;d=Bc(k[k[w>>2]>>2]|0,ca|0,0,28)|0;e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,ea|0,fa|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){P=ca;X=j;W=m;V=n;U=o;T=q;S=s;R=t;L=ca;K=G;J=G;H=F;I=M;F=M;d=N;a=0;break}k[u>>2]=d}k[d+8>>2]=1473;k[d+12>>2]=787;k[d+16>>2]=1474;k[d+20>>2]=a}else{k[B+24>>2]=d;k[B+20>>2]=M;k[u>>2]=B;k[B+8>>2]=1475;k[B+12>>2]=788;k[B+16>>2]=1476;a=k[M>>2]|0;k[B>>2]=a;k[B+4>>2]=(k[F>>2]|0)-a;a=0}ea=npb(C+132|0,1,ea|0,fa|0)|0;fa=N;y=0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){P=ca;X=j;W=m;V=n;U=o;T=q;S=s;R=t;L=ca;K=G;J=G;H=F;I=M;F=M;d=N}else{P=ca;X=j;W=m;V=n;U=o;T=q;S=s;R=t;L=ca;K=G;J=G;H=F;I=M;F=M;d=0}}else{P=0;g=0;h=0;X=0;l=0;W=0;V=0;U=0;T=0;S=0;R=0;u=0;v=0;L=ca;K=G;J=G;H=F;I=M;F=M;d=N;a=0}}while(0);b:while(1){if((Y|0)==146){Y=0;if(!(i[ba>>0]&1)){y=0;Ib(k[g>>2]|0,ca|0,Z|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){X=j;W=m;V=n;U=o;T=q;S=s;R=t;v=O;d=N;a=G;continue}d=k[_>>2]|0;k[$>>2]=0;k[_>>2]=0;if(d|0?(W=d+-4|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){y=0;rc(1459,k[d+-8>>2]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){X=j;W=m;V=n;U=o;T=q;S=s;R=t;v=O;d=N;a=G;continue}}f=Z;c:do if(!(f&3)){d=Z;Y=155}else{e=Z;d=f;while(1){if(!(i[e>>0]|0))break c;e=e+1|0;d=e;if(!(d&3)){d=e;Y=155;break}}}while(0);if((Y|0)==155){Y=0;while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}d=d-f|0;y=0;e=uc(789,d+8&-4|0)|0;f=y;y=0;if((f|0)!=0&(z|0)!=0){a=Cpb(k[f>>2]|0,ea|0,fa|0)|0;if(!a)dd(f|0,z|0);N=z}else a=-1;if((a|0)==1){X=j;W=m;V=n;U=o;T=q;S=s;R=t;v=O;d=N;a=G;continue}k[e>>2]=1;X=e+4|0;k[_>>2]=X;k[$>>2]=d;i[X+d>>0]=0;upb(k[_>>2]|0,Z|0,d|0)|0}d=k[w>>2]|0;if(d|0){y=0;rc(k[d+40>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){X=j;W=m;V=n;U=o;T=q;S=s;R=t;v=O;d=N;a=G;continue}}f=(i[ba>>0]&1)!=0;d=k[K>>2]|0;if((d|0)!=(A|0)){if(d|0){y=0;rc(1459,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){X=j;W=m;V=n;U=o;T=q;S=s;R=t;v=O;d=N;a=G;continue}}k[K>>2]=A;k[x>>2]=1032}d=k[I>>2]|0;if(d|0){if((k[H>>2]|0)!=(d|0))k[H>>2]=d;y=0;rc(1459,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){X=j;W=m;V=n;U=o;T=q;S=s;R=t;v=O;d=N;a=G;continue}}if(!v){Y=178;break}y=0;uc(776,v|0)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){X=j;W=m;V=n;U=o;T=q;S=s;R=t;v=O;d=N;a=G}else break}if(d|0){j=X;m=W;n=V;o=U;q=T;s=S;t=R;O=v;G=a;v=a;Y=146;continue}k[ca+28>>2]=D;Q=ca+32|0;k[Q>>2]=E;O=(k[b>>2]|0)>>>3;G=(O&511|0)!=0;M=G?3:1;k[ca+36>>2]=M;k[ca+40>>2]=G?2:1;d=k[c+4>>2]|0;e=k[c>>2]|0;t=e;d:do if((d|0)==(e|0)){q=-1;n=-1;j=0;o=0;m=0;d=95}else{s=d-e>>2;q=0;e=-1;n=-1;j=0;o=0;m=0;d=95;while(1){switch(k[t+(q<<2)>>2]|0){case 1:{d=k[t+((q|1)<<2)>>2]|0;d=(d|0)<0?0:d;d=(d|0)>100?100:d;break}case 2:{m=k[t+((q|1)<<2)>>2]|0;break}case 3:{o=k[t+((q|1)<<2)>>2]|0;break}case 5:{f=k[t+((q|1)<<2)>>2]|0;if((f|0)>-1){d=(f|0)>100?100:f;n=d;e=(e|0)<0?d:e}break}case 6:{f=k[t+((q|1)<<2)>>2]|0;if((f|0)>-1)e=(f|0)>100?100:f;break}case 4:{j=k[t+((q|1)<<2)>>2]|0;j=(j|0)<0?0:j;j=(j|0)>65535?65535:j;break}default:{}}q=q+2|0;if(q>>>0>=s>>>0){q=e;break d}}}while(0);y=0;rc(1477,ca|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,ea|0,fa|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){ua=a;ta=D;sa=E;ra=F;qa=I;pa=H;oa=J;na=A;ma=K;la=x;ka=L;ja=C;ia=B;ha=w;e=v;f=u;j=R;m=S;n=T;o=U;q=V;s=W;t=l;G=X;M=h;O=g;Q=P;d=N;a=ua;D=ta;E=sa;F=ra;I=qa;H=pa;J=oa;A=na;K=ma;x=la;L=ka;C=ja;B=ia;w=ha;v=e;u=f;R=j;S=m;T=n;U=o;V=q;W=s;l=t;X=G;h=M;g=O;P=Q;continue}k[ca+236>>2]=j;d=(d|0)<1?1:d;d=(d|0)>100?100:d;if((d|0)<50)d=5e3/(d|0)|0;else d=200-(d<<1)|0;y=0;mc(309,ca|0,d|0,1);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue}if(m|0){y=0;rc(1478,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue}}if(o|0)k[ca+216>>2]=1;if((q|n|0)>-1){d=(n|0)<1?1:n;d=(d|0)>100?100:d;if((d|0)<50)d=5e3/(d|0)|0;else d=200-(d<<1)|0;k[T>>2]=d;d=(q|0)<1?1:q;d=(d|0)>100?100:d;if((d|0)<50)d=5e3/(d|0)|0;else d=200-(d<<1)|0;k[V>>2]=d;if((n|0)!=(q|0)){ua=k[R>>2]|0;k[ua+12>>2]=1;k[ua+8>>2]=1;k[ua+100>>2]=1;k[ua+96>>2]=1}y=0;Ib(823,ca|0,1);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue}}d=k[h>>2]|0;if((d|0)!=100){ua=k[P>>2]|0;k[ua+20>>2]=21;k[ua+24>>2]=d;y=0;rc(k[ua>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue}}d=k[S>>2]|0;if(d|0)k[d+128>>2]=0;d=k[U>>2]|0;if(d|0)k[d+128>>2]=0;d=k[W>>2]|0;if(d|0)k[d+128>>2]=0;d=k[l>>2]|0;if(d|0)k[d+128>>2]=0;d=k[X>>2]|0;if(d|0)k[d+276>>2]=0;d=k[ca+136>>2]|0;if(d|0)k[d+276>>2]=0;d=k[ca+124>>2]|0;if(d|0)k[d+276>>2]=0;d=k[ca+140>>2]|0;if(d|0)k[d+276>>2]=0;d=k[ca+128>>2]|0;if(d|0)k[d+276>>2]=0;d=k[ca+144>>2]|0;if(d|0)k[d+276>>2]=0;d=k[ca+132>>2]|0;if(d|0)k[d+276>>2]=0;d=k[ca+148>>2]|0;if(d|0)k[d+276>>2]=0;y=0;rc(k[(k[P>>2]|0)+16>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue}y=0;rc(k[(k[u>>2]|0)+8>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue}y=0;rc(1479,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue}s=ca+392|0;y=0;rc(k[k[s>>2]>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue}q=ca+264|0;k[q>>2]=0;k[h>>2]=k[ca+208>>2]|0?102:101;do if(G){j=aa(M,D)|0;if((k[x>>2]|0)>>>0>=j>>>0){k[x>>2]=j;break}d=k[K>>2]|0;if((d|0)!=(A|0)){if(d|0){y=0;rc(1459,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}}k[K>>2]=A;k[x>>2]=1032}if(j>>>0<=1032)break;while(1){y=0;d=uc(777,j|0)|0;e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,ea|0,fa|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}y=0;nc(d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}}k[K>>2]=d;k[x>>2]=j}while(0);m=k[K>>2]|0;if((E|0)>0){n=b+16|0;o=b+48|0;switch(O&511){case 2:{j=0;while(1){d=(k[n>>2]|0)+(aa(k[o>>2]|0,j)|0)|0;k[da>>2]=d;if((D|0)>0){e=0;f=m;while(1){ta=i[d+1>>0]|0;ua=i[d+2>>0]|0;i[f+2>>0]=i[d>>0]|0;i[f+1>>0]=ta;i[f>>0]=ua;e=e+1|0;if((e|0)>=(D|0))break;else{f=f+3|0;d=d+3|0}}}k[da>>2]=m;y=0;Bc(145,ca|0,da|0,1)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}j=j+1|0;if((j|0)==(E|0))break}break}case 3:{j=0;while(1){d=(k[n>>2]|0)+(aa(k[o>>2]|0,j)|0)|0;k[da>>2]=d;if((D|0)>0){e=0;f=m;while(1){ua=i[d+1>>0]|0;i[f>>0]=i[d+2>>0]|0;i[f+1>>0]=ua;i[f+2>>0]=i[d>>0]|0;e=e+1|0;if((e|0)>=(D|0))break;else{f=f+3|0;d=d+4|0}}}k[da>>2]=m;y=0;Bc(145,ca|0,da|0,1)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}j=j+1|0;if((j|0)==(E|0))break}break}default:{d=0;while(1){e=(k[n>>2]|0)+(aa(k[o>>2]|0,d)|0)|0;k[da>>2]=e;y=0;Bc(145,ca|0,da|0,1)|0;e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,ea|0,fa|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}d=d+1|0;if((d|0)==(E|0))break}}}}d=k[h>>2]|0;switch(d|0){case 102:case 101:{if((k[q>>2]|0)>>>0<(k[Q>>2]|0)>>>0){d=k[P>>2]|0;k[d+20>>2]=69;y=0;rc(k[d>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}}y=0;rc(k[(k[s>>2]|0)+8>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}break}case 103:break;default:{ua=k[P>>2]|0;k[ua+20>>2]=21;k[ua+24>>2]=d;y=0;rc(k[ua>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}}}d=k[s>>2]|0;if(!(k[d+16>>2]|0)){m=ca+288|0;n=ca+404|0;while(1){y=0;rc(k[d>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}d=k[m>>2]|0;if(d|0){j=0;while(1){e=k[v>>2]|0;if(e|0){k[e+4>>2]=j;k[e+8>>2]=d;y=0;rc(k[e>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}}y=0;d=ec(k[(k[n>>2]|0)+4>>2]|0,ca|0,0)|0;e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,ea|0,fa|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}if(!d){d=k[P>>2]|0;k[d+20>>2]=25;y=0;rc(k[d>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}}j=j+1|0;d=k[m>>2]|0;if(j>>>0>=d>>>0)break}}y=0;rc(k[(k[s>>2]|0)+8>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}d=k[s>>2]|0;if(k[d+16>>2]|0)break}}y=0;rc(k[(k[ca+408>>2]|0)+12>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue}y=0;rc(k[(k[u>>2]|0)+16>>2]|0,ca|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue}d=k[ca+4>>2]|0;do if(d|0){y=0;Ib(k[d+36>>2]|0,ca|0,1);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,ea|0,fa|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){e=a;f=D;j=E;m=F;n=I;o=H;q=J;s=A;t=K;G=x;M=L;O=C;Q=B;ha=w;ia=v;ja=u;ka=R;la=S;ma=T;na=U;oa=V;pa=W;qa=l;ra=X;sa=h;ta=g;ua=P;d=N;a=e;D=f;E=j;F=m;I=n;H=o;J=q;A=s;K=t;x=G;L=M;C=O;B=Q;w=ha;v=ia;u=ja;R=ka;S=la;T=ma;U=na;V=oa;W=pa;l=qa;X=ra;h=sa;g=ta;P=ua;continue b}d=ca+20|0;if(!(k[ca+16>>2]|0)){k[d>>2]=100;break}else{k[d>>2]=200;k[ca+312>>2]=0;break}}while(0);i[ba>>0]=1;j=X;m=W;n=V;o=U;q=T;s=S;t=R;O=v;G=a;v=a;Y=146}if((Y|0)==178){ggb(ea|0);r=ga;return f|0}ggb(ea|0);r=ga;return f|0}function ywa(a,b){a=a|0;b=b|0;var c=0,d=0;while(1){b=fgb(36)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}zwa(b);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=89452;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function zwa(a){a=a|0;var b=0,c=0,d=0;k[a+28>>2]=0;k[a+32>>2]=0;d=a+24|0;i[d>>0]=0;b=a+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[a>>2]=89868;b=a+4|0;c=a+8|0;k[c>>2]=0;k[b>>2]=0;a=ZT(36)|0;k[a>>2]=1;k[b>>2]=a+4;k[c>>2]=31;i[a+35>>0]=0;a=k[b>>2]|0;b=358736;c=a+31|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));i[d>>0]=1;return}function Awa(a){a=a|0;return}function Bwa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;j=k[a+24>>2]|0;f=j+24|0;b=k[f>>2]|0;g=b+4|0;e=k[g>>2]|0;d=k[b>>2]|0;l=e-d|0;m=j+20|0;a=k[m>>2]|0;i=(k[a+4>>2]|0)-(k[a>>2]|0)|0;c=i+l|0;if(l>>>0>=c>>>0){if(l>>>0>c>>>0?(h=d+c|0,(e|0)!=(h|0)):0)k[g>>2]=h}else{T1(b,i);b=k[f>>2]|0;a=k[m>>2]|0}upb((k[b>>2]|0)+l|0,k[a>>2]|0,i|0)|0;k[j>>2]=k[k[m>>2]>>2];k[j+4>>2]=i;return 1}function Cwa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=k[a+24>>2]|0;f=j+24|0;b=k[f>>2]|0;g=b+4|0;c=k[g>>2]|0;d=k[b>>2]|0;l=c-d|0;i=j+20|0;a=k[i>>2]|0;j=(k[a+4>>2]|0)-(k[a>>2]|0)-(k[j+4>>2]|0)|0;if(!j)return;e=j+l|0;if(l>>>0>=e>>>0){if(l>>>0>e>>>0?(h=d+e|0,(c|0)!=(h|0)):0)k[g>>2]=h}else{T1(b,j);b=k[f>>2]|0;a=k[i>>2]|0}upb((k[b>>2]|0)+l|0,k[a>>2]|0,j|0)|0;return}function Dwa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+16|0;d=g+8|0;e=g+4|0;f=g;k[a>>2]=89912;b=a+112|0;c=k[b>>2]|0;if(c|0){Qfb(c)|0;k[b>>2]=0}b=a+100|0;c=k[b>>2]|0;if(!c){Tva(a);r=g;return}k[d>>2]=c;c=a+104|0;k[e>>2]=k[c>>2];h=a+108|0;k[f>>2]=k[h>>2];$cb(d,e,f);k[h>>2]=0;k[c>>2]=0;k[b>>2]=0;Tva(a);r=g;return}function Ewa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+16|0;d=g+8|0;e=g+4|0;f=g;k[a>>2]=89912;b=a+112|0;c=k[b>>2]|0;if(c|0){Qfb(c)|0;k[b>>2]=0}b=a+100|0;c=k[b>>2]|0;if(!c){Tva(a);ggb(a);r=g;return}k[d>>2]=c;c=a+104|0;k[e>>2]=k[c>>2];h=a+108|0;k[f>>2]=k[h>>2];$cb(d,e,f);k[h>>2]=0;k[c>>2]=0;k[b>>2]=0;Tva(a);ggb(a);r=g;return}function Fwa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;U=r;r=r+464|0;T=4;S=fgb(40)|0;k[S>>2]=0;J=U+454|0;M=U+240|0;O=U+26|0;P=U+20|0;Q=U+16|0;R=U+12|0;f=U+8|0;g=U+4|0;h=U;K=U+24|0;i[K>>0]=0;L=a+112|0;b=k[L>>2]|0;if(b){y=0;uc(776,b|0)|0;b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){t=0;s=0;q=0;p=0;o=0;n=0;m=0;H=0;G=0;F=0;b=N}else{k[L>>2]=0;I=4}}else I=4;a:do if((I|0)==4){u=a+100|0;b=k[u>>2]|0;if(b|0){k[f>>2]=b;d=a+104|0;k[g>>2]=k[d>>2];e=a+108|0;k[h>>2]=k[e>>2];y=0;mc(310,f|0,g|0,h|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){t=0;s=0;q=0;p=0;o=0;n=0;m=0;H=0;G=0;F=u;b=N;break}k[e>>2]=0;k[d>>2]=0;k[u>>2]=0}y=0;g=kc(77)|0;b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)!=1)if(g){h=g+208|0;k[h>>2]=32768;k[g+764>>2]=8192;m=g+212|0;k[m>>2]=k[m>>2]|3145728;n=g+188|0;k[n>>2]=0;o=g+184|0;k[o>>2]=311;p=g+180|0;if(k[p>>2]|0){k[p>>2]=0;y=0;Ib(824,g|0,416475);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){t=0;s=0;q=0;H=h;G=g;F=u;b=N;break}}q=g+464|0;k[q>>2]=0;e=g+688|0;b=k[e>>2]|0;if(!b){y=0;b=uc(777,268)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,S|0,T|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){t=0;s=0;H=h;G=g;F=u;b=N;break}f=b}else{y=0;b=ec(b|0,g|0,268)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,S|0,T|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){t=0;s=0;H=h;G=g;F=u;b=N;break}f=b}if(f|0)zpb(f|0,0,268)|0;b=k[e>>2]|0;if(!b){y=0;b=uc(777,268)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,S|0,T|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){t=f;s=f;H=h;G=g;F=u;b=N;break}}else{y=0;b=ec(b|0,g|0,268)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,S|0,T|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){t=f;s=f;H=h;G=g;F=u;b=N;break}}if(b|0)zpb(b|0,0,268)|0;k[u>>2]=g;k[a+104>>2]=f;k[a+108>>2]=b;k[a+120>>2]=0;if((f|0)!=0&(b|0)!=0){c=g+160|0;b=k[c>>2]|0;d=g+164|0;b:do if(!b){k[d>>2]=0;k[c>>2]=g;b=g;I=34}else switch(k[d>>2]|0){case 156:{I=34;break b}case 0:{if((b|0)==(g|0)){I=34;break b}y=0;Ib(825,g|0,412694);b=y;y=0;if((b|0)!=0&(z|0)!=0){H=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!H)dd(b|0,z|0);N=z};t=f;s=f;H=h;G=g;F=u;b=N;break a}default:{y=0;Ib(824,g|0,412725);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){t=f;s=f;H=h;G=g;F=u;b=N;break a}b=0;break b}}while(0);if((I|0)==34)k[g+156>>2]=826;S=npb(b,1,S|0,T|0)|0;T=N;y=0;b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){t=f;s=f;H=h;G=g;F=u;b=N}else{t=f;s=f;H=h;G=g;F=u;b=0}}else{t=f;s=f;f=u;I=176}}else{t=0;s=0;q=0;p=0;o=0;n=0;m=0;h=0;f=u;I=176}else{t=0;s=0;q=0;p=0;o=0;n=0;m=0;H=0;G=g;F=u;b=N}}while(0);c:while(1){if((I|0)==176){I=0;if(i[K>>0]&1){I=183;break}b=k[L>>2]|0;if(b|0){y=0;uc(776,b|0)|0;b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){H=h;G=g;F=f;b=N;continue}k[L>>2]=0}b=k[f>>2]|0;if(!b){I=183;break}k[P>>2]=b;b=a+104|0;k[Q>>2]=k[b>>2];c=a+108|0;k[R>>2]=k[c>>2];y=0;mc(310,P|0,Q|0,R|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,S|0,T|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){H=h;G=g;F=f;b=N}else{I=182;break}}if(b|0){h=H;g=G;f=F;I=176;continue}f=a+52|0;if(k[f>>2]|0){d=k[a+40>>2]|0;if((d|0)<3)b=aa(k[a+48>>2]|0,k[a+44>>2]|0)|0;else{e=k[a+76>>2]|0;c=0;b=1;do{b=aa(k[e+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(d|0))}if(b){k[n>>2]=a;k[o>>2]=312;if(k[p>>2]|0){k[p>>2]=0;y=0;Ib(824,G|0,416475);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue}}k[q>>2]=0}else I=48}else I=48;if((I|0)==48){I=0;b=k[a+20>>2]|0;y=0;b=ec(271,((b|0)==0?1016759:b)|0,373005)|0;c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,S|0,T|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue}k[L>>2]=b;if(b|0)k[n>>2]=b}if(k[f>>2]|0){d=k[a+40>>2]|0;if((d|0)<3)b=aa(k[a+48>>2]|0,k[a+44>>2]|0)|0;else{e=k[a+76>>2]|0;c=0;b=1;do{b=aa(k[e+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(d|0))}if(!b)I=57}else I=57;if((I|0)==57?(I=0,(k[L>>2]|0)==0):0){h=H;g=G;f=F;I=176;continue}e=G+433|0;f=i[e>>0]|0;h=f&255;d:do if((f&255)<=7){g=8-h|0;k[G+768>>2]=17;b=k[o>>2]|0;if(!b){y=0;Ib(825,G|0,413195);b=y;y=0;if((b|0)!=0&(z|0)!=0){E=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!E)dd(b|0,z|0);N=z};h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}d=s+32+h|0;y=0;mc(b|0,G|0,d|0,g|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}i[e>>0]=8;if(g>>>0<=8){if(g|0){b=g;I=64}}else{b=8;I=64}e:do if((I|0)==64){I=0;b=(b+h|0)>>>0>8?g:b;if(b|0){e=d;c=410818+h|0;while(1){if((i[e>>0]|0)!=(i[c>>0]|0))break e;b=b+-1|0;if(!b)break;else{e=e+1|0;c=c+1|0}}}if((f&255)>=3)break d;k[H>>2]=k[H>>2]|4096;break d}while(0);f:do if((f&255)<4){b=g+-4|0;if(b>>>0<=8){if(b|0)I=71}else{b=8;I=71}g:do if((I|0)==71){I=0;b=(b+h|0)>>>0>8?g:b;if(!b)break f;c=b;b=410818+h|0;while(1){if((i[d>>0]|0)!=(i[b>>0]|0))break g;c=c+-1|0;if(!c)break f;else{d=d+1|0;b=b+1|0}}}while(0);y=0;Ib(825,G|0,413632);b=y;y=0;if((b|0)!=0&(z|0)!=0){E=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!E)dd(b|0,z|0);N=z};h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}while(0);y=0;Ib(825,G|0,413647);b=y;y=0;if((b|0)!=0&(z|0)!=0){E=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!E)dd(b|0,z|0);N=z};h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}while(0);v=G+376|0;w=G+427|0;x=J+1|0;A=J+2|0;B=J+3|0;C=J+4|0;D=G+660|0;E=G+664|0;h:while(1){y=0;u=uc(790,G|0)|0;b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}g=k[v>>2]|0;h=(g|0)==1229209940;b=k[H>>2]|0;i:do if(h){if(!(b&1)){I=83;break h}if((b&2|0)==0&(i[w>>0]|0)==3){I=85;break h}if(b&8){if(!(k[m>>2]&1048576)){I=88;break h}y=0;mc(313,1229209940,O|0,412880);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}y=0;Ib(824,G|0,O|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}b=k[H>>2]|0}k[H>>2]=b|4}else{if(b&4){b=b|8;k[H>>2]=b}if((g|0)>=1229472850){switch(g|0){case 1229472850:break;default:break i}y=0;mc(314,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}switch(g|0){case 1229278788:break;default:break i}if((b&5|0)!=5){I=99;break h}k[H>>2]=b|24;y=0;ec(272,G|0,u|0)|0;b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}if(!u)continue h;if(!(k[m>>2]&1048576)){I=103;break h}y=0;mc(313,k[v>>2]|0,M|0,413728);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}y=0;Ib(824,G|0,M|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}while(0);i[J>>0]=g>>>24;i[x>>0]=g>>>16;i[A>>0]=g>>>8;i[B>>0]=g;i[C>>0]=0;b=k[D>>2]|0;j:do if(b){f=k[E>>2]|0;d=f+(b*5|0)|0;while(1){e=d+-5|0;b=i[J>>0]|0;c=i[e>>0]|0;if(b<<24>>24==c<<24>>24){b=i[J+1>>0]|0;c=i[d+-4>>0]|0;if(b<<24>>24==c<<24>>24){b=i[J+2>>0]|0;c=i[d+-3>>0]|0;if(b<<24>>24==c<<24>>24){b=i[J+3>>0]|0;c=i[d+-2>>0]|0;if(b<<24>>24==c<<24>>24)break}}}if(b<<24>>24==c<<24>>24)break;if(e>>>0>f>>>0)d=e;else{I=113;break j}}b=i[d+-1>>0]|0;if(b<<24>>24){y=0;Cb(200,G|0,s|0,u|0,b&255|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}if((g|0)!=1347179589)if(h){I=119;break h}else continue h;else{k[H>>2]=k[H>>2]|2;continue h}}}else I=113;while(0);if((I|0)==113)I=0;if((g|0)==1347179589){y=0;mc(315,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue}if(h){I=124;break}k:do if((g|0)<1883789683)if((g|0)<1766015824)if((g|0)<1732332865)if((g|0)<1665684045){switch(g|0){case 1649100612:break;default:break k}y=0;mc(316,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else{switch(g|0){case 1665684045:break;default:break k}y=0;mc(317,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else if((g|0)<1749635924){switch(g|0){case 1732332865:break;default:break k}y=0;mc(318,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else{switch(g|0){case 1749635924:break;default:break k}y=0;mc(319,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else if((g|0)<1866876531)if((g|0)<1767135348){switch(g|0){case 1766015824:break;default:break k}y=0;mc(326,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else{switch(g|0){case 1767135348:break;default:break k}y=0;mc(332,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else if((g|0)<1883455820){switch(g|0){case 1866876531:break;default:break k}y=0;mc(320,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else{switch(g|0){case 1883455820:break;default:break k}y=0;mc(321,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else{if((g|0)<1934772034)if((g|0)<1933787468)if((g|0)<1933723988){switch(g|0){case 1883789683:break;default:break k}y=0;mc(323,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else{switch(g|0){case 1933723988:break;default:break k}y=0;mc(324,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else if((g|0)<1934642260){switch(g|0){case 1933787468:break;default:break k}y=0;mc(322,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else{switch(g|0){case 1934642260:break;default:break k}y=0;mc(327,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}if((g|0)<1950960965)if((g|0)<1950701684){switch(g|0){case 1934772034:break;default:break k}y=0;mc(325,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else{switch(g|0){case 1950701684:break;default:break k}y=0;mc(328,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}if((g|0)<1951551059){switch(g|0){case 1950960965:break;default:break k}y=0;mc(329,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}if((g|0)<2052348020){switch(g|0){case 1951551059:break;default:break k}y=0;mc(330,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}else{switch(g|0){case 2052348020:break;default:break k}y=0;mc(331,G|0,s|0,u|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}continue h}}while(0);y=0;Cb(200,G|0,s|0,u|0,0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue c}}if((I|0)==83){I=0;y=0;Ib(827,G|0,412830);b=y;y=0;if((b|0)!=0&(z|0)!=0){E=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!E)dd(b|0,z|0);N=z};h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue}else if((I|0)==85){I=0;y=0;Ib(827,G|0,412855);b=y;y=0;if((b|0)!=0&(z|0)!=0){E=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!E)dd(b|0,z|0);N=z};h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue}else if((I|0)==88){I=0;y=0;Ib(827,G|0,412880);b=y;y=0;if((b|0)!=0&(z|0)!=0){E=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!E)dd(b|0,z|0);N=z};h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue}else if((I|0)==99){I=0;y=0;Ib(827,G|0,413715);b=y;y=0;if((b|0)!=0&(z|0)!=0){E=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!E)dd(b|0,z|0);N=z};h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue}else if((I|0)==103){I=0;y=0;Ib(827,G|0,413728);b=y;y=0;if((b|0)!=0&(z|0)!=0){E=Cpb(k[b>>2]|0,S|0,T|0)|0;if(!E)dd(b|0,z|0);N=z};h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue}else if((I|0)==119){I=0;k[G+400>>2]=0}else if((I|0)==124){I=0;k[G+400>>2]=u}b=k[t>>2]|0;c=k[t+4>>2]|0;e=t+24|0;h=j[e>>1]|0;g=h&255;h=(h&65535)>>>8;d=h&65535;e=k[e>>2]|0;y=0;Rb(141,G|0,b|0,c|0,e&255|0,e>>>8&255|0,l[t+28>>0]|0,e>>>16&255|0,e>>>24|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,S|0,T|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){h=F;u=G;v=H;w=m;x=n;A=o;B=p;C=q;D=s;E=t;b=N;F=h;G=u;H=v;m=w;n=x;o=A;p=B;q=C;s=D;t=E;continue}k[a+4>>2]=b;k[a+8>>2]=c;k[a+116>>2]=d;k[a+96>>2]=g;c=(g|0)==16;if(!(g>>>0<9|c)){h=H;g=G;f=F;I=176;continue}l:do switch((h&255)<<24>>24){case 2:{k[a+12>>2]=16;b=18;break}case 3:{if(k[t+8>>2]&16){b=a+12|0;if(j[t+22>>1]|0){k[b>>2]=24;b=26;break l}}else b=a+12|0;k[b>>2]=16;b=18;break}case 6:{k[a+12>>2]=24;b=26;break}default:{k[a+12>>2]=0;b=2}}while(0);if(c)k[a+12>>2]=b;i[K>>0]=1;h=H;g=G;f=F;I=176}if((I|0)==182){k[c>>2]=0;k[b>>2]=0;k[f>>2]=0;T=i[K>>0]|0;T=T&1;T=T<<24>>24!=0;ggb(S|0);r=U;return T|0}else if((I|0)==183){T=i[K>>0]|0;T=T&1;T=T<<24>>24!=0;ggb(S|0);r=U;return T|0}return 0}function Gwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;Da=r;r=r+1328|0;Ca=4;Ba=fgb(40)|0;k[Ba>>2]=0;ta=Da+1104|0;ua=Da+1096|0;va=Da+1076|0;wa=Da+1072|0;xa=Da+1068|0;ya=Da+1064|0;za=Da+1088|0;Aa=Da;i[za>>0]=0;qa=a+8|0;g=k[qa>>2]|0;ra=Aa+8|0;k[Aa>>2]=ra;sa=Aa+4|0;k[sa>>2]=264;a:do if(g>>>0>264){f=g>>>0>1073741823?-1:g<<2;f=(f|0)==0?1:f;while(1){y=0;c=uc(777,f|0)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){p=0;oa=0;h=0;n=0;o=0;q=0;na=0;t=0;b=0;c=0;d=N;break a}if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}y=0;nc(c|0);c=y;y=0;if((c|0)!=0&(z|0)!=0){d=Cpb(k[c>>2]|0,Ba|0,Ca|0)|0;if(!d)dd(c|0,z|0);N=z}else d=-1;if((d|0)==1){p=0;oa=0;h=0;n=0;o=0;q=0;na=0;t=0;b=0;c=0;d=N;break a}}k[Aa>>2]=c;pa=9}else{c=ra;pa=9}while(0);b:do if((pa|0)==9){k[sa>>2]=g;t=(k[b>>2]&4088|0)!=0;s=k[b+16>>2]|0;q=k[b+48>>2]|0;o=a+100|0;n=k[o>>2]|0;if(n){h=k[a+104>>2]|0;if(((h|0)!=0?(p=k[a+108>>2]|0,(p|0)!=0):0)?!((k[a+4>>2]|0)==0|(g|0)==0):0){e=n+160|0;d=k[e>>2]|0;f=n+164|0;c:do if(!d){k[f>>2]=0;k[e>>2]=n;d=n;pa=20}else switch(k[f>>2]|0){case 156:{pa=20;break c}case 0:{if((d|0)==(n|0)){pa=20;break c}y=0;Ib(825,n|0,412694);d=y;y=0;if((d|0)!=0&(z|0)!=0){oa=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!oa)dd(d|0,z|0);N=z};oa=n;na=s;d=N;break b}default:{y=0;Ib(824,n|0,412725);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){oa=n;na=s;d=N;break b}d=0;break c}}while(0);if((pa|0)==20)k[n+156>>2]=826;Ba=npb(d,1,Ba|0,Ca|0)|0;Ca=N;y=0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){oa=n;na=s;d=N}else{oa=n;na=s;d=0}}else{p=0;u=0;pa=363}}else{p=0;u=0;h=0;pa=363}}while(0);d:while(1){if((pa|0)==363){pa=0;f=a+112|0;d=k[f>>2]|0;if(d|0){y=0;uc(776,d|0)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){oa=u;na=s;d=N;continue}k[f>>2]=0}d=k[o>>2]|0;if(d|0){k[wa>>2]=d;d=a+104|0;k[xa>>2]=k[d>>2];e=a+108|0;k[ya>>2]=k[e>>2];y=0;mc(310,wa|0,xa|0,ya|0);f=y;y=0;if((f|0)!=0&(z|0)!=0){g=Cpb(k[f>>2]|0,Ba|0,Ca|0)|0;if(!g)dd(f|0,z|0);N=z}else g=-1;if((g|0)==1){oa=u;na=s;d=N;continue}k[e>>2]=0;k[d>>2]=0;k[o>>2]=0}f=(i[za>>0]&1)!=0;d=k[Aa>>2]|0;if((d|0)==(ra|0)){pa=374;break}if(!d)break;y=0;rc(1459,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){oa=u;na=s;d=N}else{pa=372;break}}if(d|0){u=oa;s=na;pa=363;continue}do if((k[b>>2]&7|0)==0?(k[a+96>>2]|0)==16:0){d=n+212|0;e=k[d>>2]|0;if(!(e&64)){k[d>>2]=e|16384;ma=n+216|0;k[ma>>2]=k[ma>>2]|1024;break}if(!(e&4194304)){y=0;Ib(825,oa|0,413233);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}y=0;Ib(824,oa|0,413233);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}else pa=32;while(0);if((pa|0)==32?(pa=0,(i[n+428>>0]|0)==16):0){ma=n+216|0;k[ma>>2]=k[ma>>2]|16}do if((((k[b>>2]|0)>>>3&511)+1|0)>>>0<4){d=n+212|0;e=k[d>>2]|0;if(!(e&64)){k[d>>2]=e|16384;ma=n+216|0;k[ma>>2]=k[ma>>2]|262144;break}if(!(e&4194304)){y=0;Ib(825,oa|0,413233);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}y=0;Ib(824,oa|0,413233);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}while(0);f=a+116|0;d=k[f>>2]|0;if((d|0)==3){d=n+212|0;e=k[d>>2]|0;if(e&64){if(!(e&4194304)){y=0;Ib(825,oa|0,413233);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue}y=0;Ib(824,oa|0,413233);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue}}else{k[d>>2]=e|16384;ma=n+216|0;k[ma>>2]=k[ma>>2]|33558528}d=k[f>>2]|0}do if((d|0)==0?(k[a+96>>2]|0)<8:0){d=n+212|0;e=k[d>>2]|0;if(!(e&64)){k[d>>2]=e|16384;ma=n+216|0;k[ma>>2]=k[ma>>2]|4096;break}if(!(e&4194304)){y=0;Ib(825,oa|0,413233);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}y=0;Ib(824,oa|0,413233);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}while(0);do if(!(t&(k[a+12>>2]&4088|0)!=0)){d=n+212|0;e=k[d>>2]|0;f=(e&64|0)==0;if(t){if(f){k[d>>2]=e|16384;ma=n+216|0;k[ma>>2]=k[ma>>2]|20480;break}if(!(e&4194304)){y=0;Ib(825,oa|0,413233);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}y=0;Ib(824,oa|0,413233);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break}if(!f){if(!(e&4194304)){y=0;Ib(825,oa|0,413233);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}y=0;Ib(824,oa|0,413233);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break}if(k[n+208>>2]&1|0){k[d>>2]=e|16384;d=n+216|0;e=k[d>>2]|0;k[d>>2]=e|6291456;if((i[n+427>>0]|0)==3)k[d>>2]=e|6295552;j[n+670>>1]=9797;j[n+672>>1]=19234;i[n+669>>0]=1;break}if(!(e&4194304)){y=0;Ib(825,oa|0,413292);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}y=0;Ib(824,oa|0,413292);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}else{ma=n+216|0;k[ma>>2]=k[ma>>2]|1}while(0);la=n+424|0;if(i[la>>0]|0){ma=n+216|0;k[ma>>2]=k[ma>>2]|2}ma=n+212|0;d=k[ma>>2]|0;if(d&64){if(!(d&4194304)){y=0;Ib(825,oa|0,412901);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue}y=0;Ib(824,oa|0,412901);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue}}else{y=0;rc(1480,oa|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue}u=k[n+216>>2]|0;do if(u&4096|0){d=h+25|0;e=i[d>>0]|0;f=(j[n+420>>1]|0)==0;if(e<<24>>24==3){i[d>>0]=f?2:6;i[h+24>>0]=8;j[h+22>>1]=0;if(k[n+408>>2]|0)break;y=0;Ib(825,oa|0,413419);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}if(!((u&33554432|0)==0|f))i[d>>0]=e&255|4;d=h+24|0;if((l[d>>0]|0)<8)i[d>>0]=8;j[h+22>>1]=0}while(0);if(u&128|0){pa=h+170|0;ka=n+444|0;j[pa>>1]=j[ka>>1]|0;j[pa+2>>1]=j[ka+2>>1]|0;j[pa+4>>1]=j[ka+4>>1]|0;j[pa+6>>1]=j[ka+6>>1]|0;j[pa+8>>1]=j[ka+8>>1]|0}k[h+40>>2]=k[n+792>>2];s=h+24|0;f=j[s>>1]|0;d=f&255;f=(f&65535)>>>8;e=f&255;if(d<<24>>24==16){if(!(u&67108864))d=16;else{i[s>>0]=8;d=8}if(u&1024){i[s>>0]=8;d=8}}if(u&16384){e=(f&65535|2)&255;i[h+25>>0]=e}if(u&6291456){e=e&253;i[h+25>>0]=e}e:do if(u&64){f=h+25|0;switch(e<<24>>24){case 6:case 2:break;default:{pa=107;break e}}if((k[n+604>>2]|0)!=0&d<<24>>24==8){i[f>>0]=3;e=3;d=8;g=h+25|0;pa=112}else pa=107}else pa=107;while(0);do if((pa|0)==107){pa=0;do if(d<<24>>24!=8|(u&512|0)==0|e<<24>>24==3){if(!((u&4|0)!=0&(d&255)<8))break;i[s>>0]=8;d=8}else{i[s>>0]=16;d=16}while(0);g=h+25|0;if(e<<24>>24==3){pa=112;break}f=h+29|0;if(!(e&2)){i[f>>0]=1;f=1;break}else{i[f>>0]=3;f=3;break}}while(0);if((pa|0)==112){pa=0;i[h+29>>0]=1;f=1}if(u&262144){e=e&251;i[g>>0]=e;j[h+22>>1]=0}if(e&4){f=f+1<<24>>24;i[h+29>>0]=f}f:do if(!(u&32768))e=f;else{switch(e<<24>>24){case 0:case 2:break;default:{e=f;break f}}f=f+1<<24>>24;i[h+29>>0]=f;if(!(u&16777216)){e=f;break}i[g>>0]=e&255|4;e=f}while(0);do if(u&1048576){g=j[n+204>>1]|0;f=g&255;g=(g&65535)>>>8&255;if(f<<24>>24){i[s>>0]=f;d=f}if(!(g<<24>>24))break;i[h+29>>0]=g;e=g}while(0);d=aa(d&255,e&255)|0;i[h+30>>0]=d;d=d&255;e=k[h>>2]|0;if(d>>>0>7)d=aa(d>>>3,e)|0;else d=((aa(d,e)|0)+7|0)>>>3;k[h+12>>2]=d;k[n+396>>2]=d}e=k[qa>>2]|0;if((e|0)>0){d=0;do{ka=na+(aa(d,q)|0)|0;k[c+(d<<2)>>2]=ka;d=d+1|0}while((d|0)!=(e|0))}d=(i[la>>0]|0)==0;do if(k[ma>>2]&64)if(d)d=1;else{if(!(k[n+216>>2]&2)){y=0;Ib(824,oa|0,413089);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}k[n+356>>2]=k[n+352>>2];if(!(i[la>>0]|0)){d=1;break}}d=n+216|0;k[d>>2]=k[d>>2]|2;d=7}else{if(d)d=1;else{d=n+216|0;k[d>>2]=k[d>>2]|2;d=7}y=0;rc(1480,oa|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}while(0);M=k[n+352>>2]|0;g:do if(M|0){O=n+368|0;P=n+427|0;Q=va+8|0;R=n+428|0;S=va+9|0;T=va+10|0;U=va+11|0;V=va+4|0;W=n+372|0;X=n+208|0;Y=n+384|0;L=n+380|0;Z=n+676|0;_=n+216|0;$=n+435|0;ba=n+434|0;ca=n+536|0;da=n+425|0;ea=n+680|0;fa=n+776|0;ga=n+430|0;ha=n+780|0;ia=n+784|0;ja=n+788|0;ka=n+348|0;I=0;h:while(1){J=0;K=c;while(1){H=k[K>>2]|0;if(!(k[ma>>2]&64)){y=0;rc(1480,oa|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}e=k[O>>2]|0;k[va>>2]=e;i[Q>>0]=i[P>>0]|0;f=k[R>>2]|0;i[S>>0]=f;i[T>>0]=f>>>24;f=f>>>16;G=f&255;i[U>>0]=G;f=f&255;if((G&255)>7)f=aa(e,f>>>3)|0;else f=((aa(e,f)|0)+7|0)>>>3;k[V>>2]=f;e=k[W>>2]|0;G=j[la>>1]|0;g=(G&65535)>>>8&255;i:do if(!((G&255)<<24>>24))pa=185;else{if(!(k[_>>2]&2)){pa=185;break}switch(g<<24>>24){case 0:{if(!(e&7)){pa=185;break i}y=0;rc(1481,oa|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break i}case 1:{if((e&7|0)==0?(k[ka>>2]|0)>>>0>=5:0){pa=185;break i}y=0;rc(1481,oa|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break i}case 2:{if((e&7|0)==4){pa=185;break i}y=0;rc(1481,oa|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break i}case 3:{if((e&3|0)==0?(k[ka>>2]|0)>>>0>=3:0){pa=185;break i}y=0;rc(1481,oa|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break i}case 4:{if((e&3|0)==2){pa=185;break i}y=0;rc(1481,oa|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break i}case 5:{if((e&1|0)==0?(k[ka>>2]|0)>>>0>=2:0){pa=185;break i}y=0;rc(1481,oa|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break i}default:{if(e&1|0){pa=185;break i}y=0;rc(1481,oa|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break i}}}while(0);do if((pa|0)==185){pa=0;if(!(k[X>>2]&4)){pa=186;break h}y=0;mc(333,oa|0,k[Y>>2]|0,f+1|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){g=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!g)dd(e|0,z|0);N=z}else g=-1;if((g|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}e=k[Y>>2]|0;g=i[e>>0]|0;u=g&255;if(g<<24>>24){if((g&255)>=5){pa=196;break h}g=e+1|0;s=(k[L>>2]|0)+1|0;f=u+-1|0;if(f>>>0<4){if(!(k[fa>>2]|0)){G=(l[ga>>0]|0)+7|0;k[fa>>2]=334;k[ha>>2]=335;k[ia>>2]=336;k[ja>>2]=(G&504|0)==8?338:337}y=0;mc(k[oa+776+(f<<2)>>2]|0,va|0,g|0,s|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}e=k[Y>>2]|0}f=k[V>>2]|0}upb(k[L>>2]|0,e|0,f+1|0)|0;j:do if(k[Z>>2]&4|0){if((i[ea>>0]|0)!=64)break;e=(k[Y>>2]|0)+1|0;s=k[va>>2]|0;f=j[Q>>1]|0;g=f&255;if(!(g&2))break;switch(((f&65535)>>>8&255)<<24>>24){case 8:{switch(g<<24>>24){case 2:{g=3;break}case 6:{g=4;break}default:break j}if(!s)break j;else f=0;while(1){F=l[e+1>>0]|0;i[e>>0]=F+(l[e>>0]|0);G=e+2|0;i[G>>0]=(l[G>>0]|0)+F;f=f+1|0;if((f|0)==(s|0))break;else e=e+g|0}break}case 16:{switch(g<<24>>24){case 2:{g=6;break}case 6:{g=8;break}default:break j}if(!s)break j;else f=0;while(1){D=e+1|0;F=l[e+2>>0]<<8|l[e+3>>0];E=e+4|0;G=e+5|0;C=F+(l[e>>0]<<8|l[D>>0])|0;F=(l[E>>0]<<8|l[G>>0])+F|0;i[e>>0]=C>>>8;i[D>>0]=C;i[E>>0]=F>>>8;i[G>>0]=F;f=f+1|0;if((f|0)==(s|0))break;else e=e+g|0}break}default:break j}}while(0);if(k[_>>2]|0){y=0;Ib(828,oa|0,va|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}e=i[$>>0]|0;g=i[U>>0]|0;if(!(e<<24>>24)){i[$>>0]=g;if((g&255)>(l[ba>>0]|0)){pa=214;break h}}else if(e<<24>>24!=g<<24>>24){pa=216;break h}G=j[la>>1]|0;f=(G&65535)>>>8;e=f&255;do if((G&255)<<24>>24){s=k[_>>2]|0;if(!(s&2)){pa=255;break}if((e&255)<6){E=(k[Y>>2]|0)+1|0;D=k[va>>2]|0;F=k[156532+((f&65535)<<2)>>2]|0;G=aa(F,D)|0;k:do switch(g<<24>>24){case 1:{e=D+7&7;if(!(s&65536)){e=e^7;f=G+7&7^7;A=0;B=7;C=1}else{f=G+7&7;A=7;B=0;C=-1}if(!D)break k;else{x=E+((D+-1|0)>>>3)|0;s=E+((G+-1|0)>>>3)|0;w=0}while(1){v=(l[x>>0]|0)>>>e&1;g=0;u=f;do{i[s>>0]=l[s>>0]&32639>>>(7-u|0)|v<<u;E=(u|0)==(B|0);u=E?A:u+C|0;s=E?s+-1|0:s;g=g+1|0}while((g|0)<(F|0));f=(e|0)==(B|0);w=w+1|0;if(w>>>0>=(k[va>>2]|0)>>>0)break;else{x=f?x+-1|0:x;e=f?A:e+C|0;f=u}}break}case 2:{e=(D<<1)+6&6;if(!(s&65536)){x=2;A=6;B=0;f=(G<<1)+6&6^6;e=e^6}else{x=-2;A=0;B=6;f=(G<<1)+6&6}if(!D)break k;else{w=0;s=E+((G+-1|0)>>>2)|0;v=E+((D+-1|0)>>>2)|0}while(1){u=(l[v>>0]|0)>>>e&3;g=0;do{i[s>>0]=l[s>>0]&16191>>>(6-f|0)|u<<f;E=(f|0)==(A|0);s=E?s+-1|0:s;f=E?B:f+x|0;g=g+1|0}while((g|0)<(F|0));g=(e|0)==(A|0);w=w+1|0;if(w>>>0>=(k[va>>2]|0)>>>0)break;else{v=g?v+-1|0:v;e=g?B:e+x|0}}break}case 4:{e=D&1;if(!(s&65536)){A=4;B=4;C=0;f=G&1}else{A=-4;B=0;C=4;f=G&1^1;e=e^1}if(!D)break k;x=0;w=E+((G+-1|0)>>>1)|0;v=E+((D+-1|0)>>>1)|0;g=f<<2;u=e<<2;while(1){s=(l[v>>0]|0)>>>u&15;e=0;f=w;do{i[f>>0]=l[f>>0]&3855>>>(4-g|0)|s<<g;E=(g|0)==(B|0);f=E?f+-1|0:f;g=E?C:g+A|0;e=e+1|0}while((e|0)<(F|0));e=(u|0)==(B|0);x=x+1|0;if(x>>>0>=(k[va>>2]|0)>>>0)break;else{w=f;v=e?v+-1|0:v;u=e?C:u+A|0}}break}default:{u=(g&255)>>>3;if(!D)break k;v=0-u|0;s=0;e=E+(aa(u,G+-1|0)|0)|0;f=E+(aa(u,D+-1|0)|0)|0;while(1){upb(ua|0,f|0,u|0)|0;g=0;do{upb(e|0,ua|0,u|0)|0;e=e+v|0;g=g+1|0}while((g|0)<(F|0));s=s+1|0;if(s>>>0>=(k[va>>2]|0)>>>0)break;else f=f+v|0}}}while(0);k[va>>2]=G;F=i[U>>0]|0;e=F&255;if((F&255)>7)e=aa(e>>>3,G)|0;else e=((aa(e,G)|0)+7|0)>>>3;k[V>>2]=e}if(!H)break;y=0;mc(339,oa|0,H|0,0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}else pa=255;while(0);do if((pa|0)==255){pa=0;if(!H)break;y=0;mc(339,oa|0,H|0,-1);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}while(0);y=0;rc(1481,oa|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}e=k[ca>>2]|0;if(!e)break;y=0;mc(e|0,oa|0,k[W>>2]|0,l[da>>0]|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ba|0,Ca|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}while(0);J=J+1|0;if((J|0)==(M|0))break;else K=K+4|0}I=I+1|0;if((I|0)==(d|0))break g}if((pa|0)==186){pa=0;y=0;Ib(825,oa|0,412959);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}else if((pa|0)==196){pa=0;y=0;Ib(825,oa|0,412992);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}else if((pa|0)==214){pa=0;y=0;Ib(825,oa|0,413018);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}else if((pa|0)==216){pa=0;y=0;Ib(825,oa|0,413042);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}while(0);i[ua>>0]=73;B=ua+1|0;i[B>>0]=68;C=ua+2|0;i[C>>0]=65;D=ua+3|0;i[D>>0]=84;E=ua+4|0;i[E>>0]=0;F=n+660|0;d=k[F>>2]|0;l:do if(d){s=k[n+664>>2]|0;f=s+(d*5|0)|0;while(1){g=f+-5|0;d=i[ua>>0]|0;e=i[g>>0]|0;if(d<<24>>24==e<<24>>24){d=i[ua+1>>0]|0;e=i[f+-4>>0]|0;if(d<<24>>24==e<<24>>24){d=i[ua+2>>0]|0;e=i[f+-3>>0]|0;if(d<<24>>24==e<<24>>24){d=i[ua+3>>0]|0;e=i[f+-2>>0]|0;if(d<<24>>24==e<<24>>24)break}}}if(d<<24>>24==e<<24>>24)break;if(g>>>0>s>>>0)f=g;else{pa=270;break l}}if(!(i[f+-1>>0]|0))pa=272}else pa=270;while(0);if((pa|0)==270)pa=272;if((pa|0)==272){pa=0;if(!(k[ma>>2]&8)){y=0;mc(333,oa|0,0,0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue}k[n+236>>2]=0;d=k[ma>>2]|0;if(!(d&8)){la=n+208|0;k[la>>2]=k[la>>2]|8;k[ma>>2]=d|8}}d=n+220|0;if((k[d>>2]|0)==1229209940){k[n+224>>2]=0;k[n+228>>2]=0;k[d>>2]=0;y=0;ec(272,oa|0,k[n+400>>2]|0)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue}}}if((i[n+427>>0]|0)==3?(k[n+416>>2]|0)>(m[n+412>>1]|0):0){y=0;Ib(829,oa|0,413154);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue}}w=n+376|0;x=n+208|0;A=n+664|0;m:while(1){y=0;v=uc(790,oa|0)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}u=k[w>>2]|0;n:do if((u|0)<1229472850){switch(u|0){case 1229278788:break;default:{pa=297;break n}}d=k[x>>2]|0;if((d&5|0)!=5){pa=287;break m}k[x>>2]=d|24;y=0;ec(272,oa|0,v|0)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}if(!v)break;if(!(k[ma>>2]&1048576)){pa=291;break m}y=0;mc(313,k[w>>2]|0,ta|0,413728);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}y=0;Ib(824,oa|0,ta|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}else{switch(u|0){case 1229472850:break;default:{pa=297;break n}}y=0;mc(314,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}while(0);o:do if((pa|0)==297){pa=0;i[ua>>0]=u>>>24;i[B>>0]=u>>>16;i[C>>0]=u>>>8;i[D>>0]=u;i[E>>0]=0;d=k[F>>2]|0;p:do if(d){s=k[A>>2]|0;f=s+(d*5|0)|0;q:while(1){g=f+-5|0;d=i[ua>>0]|0;e=i[g>>0]|0;do if(d<<24>>24==e<<24>>24){d=i[ua+1>>0]|0;e=i[f+-4>>0]|0;if(d<<24>>24!=e<<24>>24)break;d=i[ua+2>>0]|0;e=i[f+-3>>0]|0;if(d<<24>>24!=e<<24>>24)break;d=i[ua+3>>0]|0;e=i[f+-2>>0]|0;if(d<<24>>24==e<<24>>24)break q}while(0);if(d<<24>>24==e<<24>>24)break;if(g>>>0>s>>>0)f=g;else{pa=303;break p}}la=i[f+-1>>0]|0;f=la&255;d=(u|0)==1229209940;if(la<<24>>24){if(!d){y=0;Cb(200,oa|0,p|0,v|0,f|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}if((u|0)!=1347179589)break o;k[x>>2]=k[x>>2]|2;break o}if(!((v|0)==0?!(k[x>>2]&8192|0):0)){y=0;Ib(829,oa|0,412880);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}y=0;Cb(200,oa|0,p|0,v|0,f|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}if(d){pa=316;break}if((u|0)<1883789683){if((u|0)<1749635924)if((u|0)<1665684045)if((u|0)<1649100612)switch(u|0){case 1347179589:{pa=323;break p}default:{pa=359;break p}}else switch(u|0){case 1649100612:{pa=325;break p}default:{pa=359;break p}}else if((u|0)<1732332865)switch(u|0){case 1665684045:{pa=327;break p}default:{pa=359;break p}}else switch(u|0){case 1732332865:{pa=329;break p}default:{pa=359;break p}}if((u|0)<1767135348)if((u|0)<1766015824)switch(u|0){case 1749635924:{pa=331;break p}default:{pa=359;break p}}else switch(u|0){case 1766015824:{pa=345;break p}default:{pa=359;break p}}if((u|0)<1866876531)switch(u|0){case 1767135348:{pa=357;break p}default:{pa=359;break p}}if((u|0)<1883455820)switch(u|0){case 1866876531:{pa=333;break p}default:{pa=359;break p}}else switch(u|0){case 1883455820:{pa=335;break p}default:{pa=359;break p}}}else{if((u|0)<1934772034)if((u|0)<1933787468)if((u|0)<1933723988)switch(u|0){case 1883789683:{pa=339;break p}default:{pa=359;break p}}else switch(u|0){case 1933723988:{pa=341;break p}default:{pa=359;break p}}else if((u|0)<1934642260)switch(u|0){case 1933787468:{pa=337;break p}default:{pa=359;break p}}else switch(u|0){case 1934642260:{pa=347;break p}default:{pa=359;break p}}if((u|0)<1950960965)if((u|0)<1950701684)switch(u|0){case 1934772034:{pa=343;break p}default:{pa=359;break p}}else switch(u|0){case 1950701684:{pa=349;break p}default:{pa=359;break p}}if((u|0)<1951551059)switch(u|0){case 1950960965:{pa=351;break p}default:{pa=359;break p}}if((u|0)<2052348020)switch(u|0){case 1951551059:{pa=353;break p}default:{pa=359;break p}}else switch(u|0){case 2052348020:{pa=355;break p}default:{pa=359;break p}}}}else pa=303;while(0);r:do if((pa|0)==303){if((u|0)<1883455820){if((u|0)<1732332865)if((u|0)<1649100612)if((u|0)<1347179589)switch(u|0){case 1229209940:{pa=316;break r}default:{pa=359;break r}}else switch(u|0){case 1347179589:{pa=323;break r}default:{pa=359;break r}}else if((u|0)<1665684045)switch(u|0){case 1649100612:{pa=325;break r}default:{pa=359;break r}}else switch(u|0){case 1665684045:{pa=327;break r}default:{pa=359;break r}}if((u|0)<1766015824)if((u|0)<1749635924)switch(u|0){case 1732332865:{pa=329;break r}default:{pa=359;break r}}else switch(u|0){case 1749635924:{pa=331;break r}default:{pa=359;break r}}if((u|0)<1767135348)switch(u|0){case 1766015824:{pa=345;break r}default:{pa=359;break r}}if((u|0)<1866876531)switch(u|0){case 1767135348:{pa=357;break r}default:{pa=359;break r}}else switch(u|0){case 1866876531:{pa=333;break r}default:{pa=359;break r}}}if((u|0)<1934772034){if((u|0)<1933723988)if((u|0)<1883789683)switch(u|0){case 1883455820:{pa=335;break r}default:{pa=359;break r}}else switch(u|0){case 1883789683:{pa=339;break r}default:{pa=359;break r}}if((u|0)<1933787468)switch(u|0){case 1933723988:{pa=341;break r}default:{pa=359;break r}}if((u|0)<1934642260)switch(u|0){case 1933787468:{pa=337;break r}default:{pa=359;break r}}else switch(u|0){case 1934642260:{pa=347;break r}default:{pa=359;break r}}}else{if((u|0)<1950960965)if((u|0)<1950701684)switch(u|0){case 1934772034:{pa=343;break r}default:{pa=359;break r}}else switch(u|0){case 1950701684:{pa=349;break r}default:{pa=359;break r}}if((u|0)<1951551059)switch(u|0){case 1950960965:{pa=351;break r}default:{pa=359;break r}}if((u|0)<2052348020)switch(u|0){case 1951551059:{pa=353;break r}default:{pa=359;break r}}else switch(u|0){case 2052348020:{pa=355;break r}default:{pa=359;break r}}}}while(0);switch(pa|0){case 316:{pa=0;if(!((v|0)==0?!(k[x>>2]&8192|0):0)){y=0;Ib(829,oa|0,412880);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}}y=0;ec(272,oa|0,v|0)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 323:{pa=0;y=0;mc(315,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 325:{pa=0;y=0;mc(316,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 327:{pa=0;y=0;mc(317,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 329:{pa=0;y=0;mc(318,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 331:{pa=0;y=0;mc(319,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 333:{pa=0;y=0;mc(320,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 335:{pa=0;y=0;mc(321,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 337:{pa=0;y=0;mc(322,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 339:{pa=0;y=0;mc(323,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 341:{pa=0;y=0;mc(324,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 343:{pa=0;y=0;mc(325,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 345:{pa=0;y=0;mc(326,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 347:{pa=0;y=0;mc(327,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 349:{pa=0;y=0;mc(328,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 351:{pa=0;y=0;mc(329,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 353:{pa=0;y=0;mc(330,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 355:{pa=0;y=0;mc(331,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 357:{pa=0;y=0;mc(332,oa|0,p|0,v|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}case 359:{pa=0;y=0;Cb(200,oa|0,p|0,v|0,0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue d}break o}}}while(0);if(k[x>>2]&16|0){pa=362;break}}if((pa|0)==287){pa=0;y=0;Ib(827,oa|0,413715);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue}else if((pa|0)==291){pa=0;y=0;Ib(827,oa|0,413728);d=y;y=0;if((d|0)!=0&(z|0)!=0){ma=Cpb(k[d>>2]|0,Ba|0,Ca|0)|0;if(!ma)dd(d|0,z|0);N=z};da=c;ea=b;fa=t;ga=na;ha=q;ia=o;ja=n;ka=h;la=oa;ma=p;d=N;c=da;b=ea;t=fa;na=ga;q=ha;o=ia;n=ja;h=ka;oa=la;p=ma;continue}else if((pa|0)==362){i[za>>0]=1;u=oa;s=na;pa=363;continue}}if((pa|0)!=372)if((pa|0)==374){ggb(Ba|0);r=Da;return f|0}k[Aa>>2]=ra;k[sa>>2]=264;ggb(Ba|0);r=Da;return f|0}function Hwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;while(1){b=fgb(124)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}c=b+20|0;k[c>>2]=0;k[c+4>>2]=0;k[b+36>>2]=1124007936;c=b+44|0;d=b+76|0;e=b+40|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;f=b+84|0;k[b+80>>2]=f;k[b+88>>2]=0;k[f>>2]=0;k[b+8>>2]=0;k[b+4>>2]=0;k[b+12>>2]=-1;f=b+92|0;i[f>>0]=0;k[b+16>>2]=1;k[b>>2]=89912;e=b+28|0;c=b+32|0;k[c>>2]=0;k[e>>2]=0;d=ZT(16)|0;k[d>>2]=1;k[e>>2]=d+4;k[c>>2]=8;i[d+12>>0]=0;e=k[e>>2]|0;d=e;i[d>>0]=137;i[d+1>>0]=80;i[d+2>>0]=78;i[d+3>>0]=71;e=e+4|0;i[e>>0]=13;i[e+1>>0]=10;i[e+2>>0]=26;i[e+3>>0]=10;e=b+100|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;k[e+16>>2]=0;i[f>>0]=1;k[b+120>>2]=0;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}f=c+4|0;k[f>>2]=1;k[c>>2]=89572;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[f>>2]=(k[f>>2]|0)+1;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function Iwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;j=r;r=r+16|0;l=j;if(a|0?(h=k[a+188>>2]|0,h|0):0){e=h+120|0;f=k[e>>2]|0;g=aa(k[h+44>>2]|0,k[h+48>>2]|0)|0;d=k[h+40>>2]|0;if((d|0)>0)d=k[(k[h+80>>2]|0)+(d+-1<<2)>>2]|0;else d=0;if((f+c|0)>>>0>(aa(g,d)|0)>>>0)Ucb(a,358884);else{upb(b|0,(k[h+52>>2]|0)+f|0,c|0)|0;k[e>>2]=(k[e>>2]|0)+c;r=j;return}}j=l+4|0;d=ZT(12)|0;k[d>>2]=1;h=d+4|0;k[l>>2]=h;k[j>>2]=7;i[d+11>>0]=0;i[h>>0]=i[358787]|0;i[h+1>>0]=i[358788]|0;i[h+2>>0]=i[358789]|0;i[h+3>>0]=i[358790]|0;i[h+4>>0]=i[358791]|0;i[h+5>>0]=i[358792]|0;i[h+6>>0]=i[358793]|0;Y8(-215,l,358795,358811,130);k[j>>2]=0;k[l>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;ggb(k[d+-4>>2]|0)}function Jwa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1)return;ggb(k[b+-8>>2]|0);return}function Kwa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b){ggb(a);return}c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function Lwa(a,b){a=a|0;b=b|0;return (b|2|0)==2|0}function Mwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;Ja=r;r=r+2e3|0;Ha=4;Ia=fgb(40)|0;k[Ia>>2]=0;Aa=Ja+1120|0;Ba=Ja+1104|0;Ca=Ja+1088|0;Da=Ja+1076|0;Ea=Ja;Fa=Ja+1072|0;Ga=Ja+1988|0;ya=Ja+8|0;y=0;za=kc(77)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;a:do if((e|0)!=1){C=(za|0)==0;if(!C?(k[za+284>>2]=8192,k[za+304>>2]=1,k[za+288>>2]=-1,k[za+300>>2]=8,k[za+296>>2]=15,k[za+292>>2]=8,k[za+324>>2]=0,k[za+308>>2]=-1,k[za+320>>2]=8,k[za+316>>2]=15,k[za+312>>2]=8,f=za+212|0,k[f>>2]=k[f>>2]|2097152,k[za+188>>2]=0,k[za+180>>2]=340,k[za+464>>2]=1482,f=za+184|0,k[f>>2]|0):0){k[f>>2]=0;y=0;Ib(824,za|0,416475);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){B=0;A=0;x=0;xa=0;w=0;s=0;v=0;va=0;wa=0;q=0;ua=0;ta=0;sa=0;d=N;ra=24;break}}k[Fa>>2]=0;n=k[b+12>>2]|0;o=k[b+8>>2]|0;xa=k[b>>2]|0;p=xa&7;q=xa>>>3&511;i[Ga>>0]=0;u=ya+8|0;k[ya>>2]=u;s=ya+4|0;k[s>>2]=264;switch(xa&7){case 0:case 2:break;default:{Ha=0;ggb(Ia|0);r=Ja;return Ha|0}}if(!C){h=za+688|0;d=k[h>>2]|0;if(!d){y=0;d=uc(777,268)|0;e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ia|0,Ha|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){B=0;A=Fa;x=0;xa=h;w=za;v=ya;va=u;wa=ya;ua=p;ta=o;sa=n;d=N;ra=24;break}g=d}else{y=0;d=ec(d|0,za|0,268)|0;e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ia|0,Ha|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){B=0;A=Fa;x=0;xa=h;w=za;v=ya;va=u;wa=ya;ua=p;ta=o;sa=n;d=N;ra=24;break}g=d}if(g){zpb(g|0,0,268)|0;e=za+160|0;d=k[e>>2]|0;f=za+164|0;b:do if(!d){k[f>>2]=0;k[e>>2]=za;d=za;ra=21}else switch(k[f>>2]|0){case 156:{ra=21;break b}case 0:{if((d|0)==(za|0)){ra=21;break b}y=0;Ib(825,za|0,412694);d=y;y=0;if((d|0)!=0&(z|0)!=0){xa=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!xa)dd(d|0,z|0);N=z};B=g;A=Fa;x=g;xa=h;w=za;v=ya;va=u;wa=ya;ua=p;ta=o;sa=n;d=N;ra=24;break a}default:{y=0;Ib(824,za|0,412725);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){B=g;A=Fa;x=g;xa=h;w=za;v=ya;va=u;wa=ya;ua=p;ta=o;sa=n;d=N;ra=24;break a}d=0;break b}}while(0);if((ra|0)==21)k[za+156>>2]=826;Ia=npb(d,1,Ia|0,Ha|0)|0;Ha=N;y=0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){B=g;A=Fa;x=g;xa=h;w=za;v=ya;va=u;wa=ya;ua=p;ta=o;sa=n;d=N;ra=24}else{B=g;A=Fa;x=g;xa=h;w=za;v=ya;va=u;wa=ya;ua=p;ta=o;sa=n;d=0;ra=24}}else{B=g;A=Fa;x=g;w=za;v=ya;t=ya;D=n;ra=484}}else{B=0;A=Fa;x=0;h=0;w=0;v=ya;t=ya;g=C;ra=532}}else{B=0;A=0;x=0;xa=0;w=0;s=0;v=0;va=0;wa=0;q=0;ua=0;ta=0;sa=0;C=0;d=N;ra=24}while(0);c:while(1)if((ra|0)==24){ra=0;if(!d){p=a+20|0;if(!(k[p>>2]|0)){d=k[a+12>>2]|0;y=0;d=ec(271,((d|0)==0?1016759:d)|0,377117)|0;e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ia|0,Ha|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue}k[Fa>>2]=d;if(k[Fa>>2]|0)k[za+188>>2]=k[Fa>>2]}else{k[za+188>>2]=a;k[za+180>>2]=341;k[za+464>>2]=1483;d=za+184|0;if(k[d>>2]|0){k[d>>2]=0;y=0;Ib(824,za|0,416475);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue}}}d=k[c+4>>2]|0;e=k[c>>2]|0;n=e;d:do if((d|0)==(e|0)){E=0;o=3;d=-1}else{h=d-e>>2;g=0;e=0;f=3;d=-1;while(1){switch(k[n+(g<<2)>>2]|0){case 16:{d=k[n+((g|1)<<2)>>2]|0;d=(d|0)<0?0:d;d=(d|0)>9?9:d;break}case 17:{f=k[n+((g|1)<<2)>>2]|0;f=(f|0)<0?0:f;f=(f|0)>4?4:f;break}case 18:{e=(k[n+((g|1)<<2)>>2]|0)!=0;break}default:{}}g=g+2|0;if(g>>>0>=h>>>0){E=e;o=f;break d}}}while(0);if(!((k[p>>2]|0)==0?!(k[Fa>>2]|0):0))ra=41;do if((ra|0)==41){ra=0;if((d|0)>-1)k[za+288>>2]=d;else{n=za+426|0;i[n>>0]=16;do if(k[za+384>>2]|0){e=k[za+348>>2]|0;d=(e|0)==1?0:16;f=aa(l[za+429>>0]|0,l[za+432>>0]|0)|0;if(f>>>0>7)e=aa(f>>>3,e)|0;else e=((aa(f,e)|0)+7|0)>>>3;h=za+388|0;if(!(k[h>>2]|0)){e=e+1|0;if(e|0){f=k[xa>>2]|0;if(!f){y=0;e=uc(777,e|0)|0;f=y;y=0;if((f|0)!=0&(z|0)!=0){g=Cpb(k[f>>2]|0,Ia|0,Ha|0)|0;if(!g)dd(f|0,z|0);N=z}else g=-1;if((g|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}else{y=0;e=ec(f|0,w|0,e|0)|0;f=y;y=0;if((f|0)!=0&(z|0)!=0){g=Cpb(k[f>>2]|0,Ia|0,Ha|0)|0;if(!g)dd(f|0,z|0);N=z}else g=-1;if((g|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}if(e|0){k[h>>2]=e;break}}y=0;Ib(825,za|0,412758);d=y;y=0;if((d|0)!=0&(z|0)!=0){ra=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!ra)dd(d|0,z|0);N=z};ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}else d=16;while(0);i[n>>0]=d;k[za+288>>2]=1}d=za+212|0;k[d>>2]=k[d>>2]|1;k[za+304>>2]=o;y=0;dc(106,za|0,x|0,sa|0,ta|0,((ua|0)==0?(E?1:8):16)|0,((q|0)==0?0:(q|0)==2?2:6)|0,0,0,0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}qa=(B|0)==0;do if(!qa){D=za+208|0;if(!(k[D>>2]&1024)){f=Ea;k[f>>2]=1196314761;k[f+4>>2]=169478669;k[za+768>>2]=18;f=za+433|0;d=l[f>>0]|0;e=k[za+180>>2]|0;if(!e){y=0;Ib(825,za|0,416435);d=y;y=0;if((d|0)!=0&(z|0)!=0){ra=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!ra)dd(d|0,z|0);N=z};ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}y=0;mc(e|0,za|0,Ea+d|0,8-d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[D>>2]|0;if((l[f>>0]|0)<3){d=d|4096;k[D>>2]=d}do if(d&4096|0){d=za+676|0;if(!(k[d>>2]|0))break;y=0;Ib(824,za|0,416543);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ia|0,Ha|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}k[d>>2]=0}while(0);d=k[B+24>>2]|0;f=B+25|0;y=0;Rb(142,w|0,k[B>>2]|0,k[B+4>>2]|0,d&255|0,d>>>8&255|0,d>>>16&255|0,d>>>24|0,l[B+28>>0]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}g=B+114|0;d=j[g>>1]|0;h=B+8|0;do if((d&-32760)<<16>>16==8){if(!(k[h>>2]&1))break;y=0;Ib(830,w|0,k[B+40>>2]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=j[g>>1]|0}while(0);do if(d<<16>>16>-1){pa=k[h>>2]|0;d=(pa&2048|0)==0;if(!(pa&4096)){if(d)break;y=0;Ib(831,w|0,m[B+112>>1]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}break}if(!d){if(!(k[za+212>>2]&2097152)){y=0;Ib(825,za|0,416592);d=y;y=0;if((d|0)!=0&(z|0)!=0){ra=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!ra)dd(d|0,z|0);N=z};ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}y=0;Ib(824,za|0,416592);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}y=0;mc(342,w|0,k[B+116>>2]|0,k[B+120>>2]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}while(0);if(k[h>>2]&2|0){y=0;mc(343,w|0,B+148|0,l[f>>0]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}do if((j[g>>1]&-32752)<<16>>16==16){if(!(k[h>>2]&4))break;y=0;Ib(832,w|0,B+44|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}while(0);d=k[B+240>>2]|0;if((d|0)>0){n=k[B+236>>2]|0;u=za+656|0;o=n+(d*20|0)|0;p=za+660|0;t=za+664|0;while(1){e:do if(i[n+16>>0]&1){f:do if(n){d=k[p>>2]|0;if(!d){d=0;break}h=k[t>>2]|0;f=h+(d*5|0)|0;g:while(1){g=f+-5|0;d=i[n>>0]|0;e=i[g>>0]|0;do if(d<<24>>24==e<<24>>24){d=i[n+1>>0]|0;e=i[f+-4>>0]|0;if(d<<24>>24!=e<<24>>24)break;d=i[n+2>>0]|0;e=i[f+-3>>0]|0;if(d<<24>>24!=e<<24>>24)break;d=i[n+3>>0]|0;e=i[f+-2>>0]|0;if(d<<24>>24==e<<24>>24)break g}while(0);if(d<<24>>24==e<<24>>24)break;if(g>>>0>h>>>0)f=g;else{d=0;break f}}d=i[f+-1>>0]|0;if(d<<24>>24==1)break e;else d=d&255}else d=0;while(0);if(!((d|0)==3|(i[n+3>>0]&32)!=0)){if(d|0)break;if((k[u>>2]|0)!=3)break}f=n+12|0;d=k[f>>2]|0;if(!d){y=0;Ib(824,za|0,416638);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[f>>2]|0}y=0;Cb(201,w|0,n|0,k[n+8>>2]|0,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}while(0);n=n+20|0;if(n>>>0>=o>>>0)break}}k[D>>2]=k[D>>2]|1024}h=B+8|0;d=k[h>>2]|0;if(!(d&8)){if((i[B+25>>0]|0)==3){y=0;Ib(825,za|0,416672);d=y;y=0;if((d|0)!=0&(z|0)!=0){ra=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!ra)dd(d|0,z|0);N=z};ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}else{y=0;mc(344,w|0,k[B+16>>2]|0,m[B+20>>1]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0}if(d&16){f=B+25|0;do if(k[za+216>>2]&524288|0?(i[f>>0]|0)==3:0){d=m[B+22>>1]|0;d=d>>>0>256?256:d;if((d|0)<=0)break;g=B+156|0;e=0;do{pa=(k[g>>2]|0)+e|0;i[pa>>0]=l[pa>>0]^255;e=e+1|0}while((e|0)<(d|0))}while(0);y=0;Db(152,w|0,k[B+156>>2]|0,B+160|0,m[B+22>>1]|0,l[f>>0]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0}if(d&32){y=0;mc(345,w|0,B+170|0,l[B+25>>0]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0}if(d&64){y=0;mc(346,w|0,k[B+204>>2]|0,m[B+20>>1]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0}if(d&256){y=0;Cb(202,w|0,k[B+180>>2]|0,k[B+184>>2]|0,l[B+188>>0]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0}if(d&1024){d=j[B+228>>1]|0;y=0;Rb(143,w|0,k[B+208>>2]|0,k[B+212>>2]|0,k[B+216>>2]|0,d&255|0,(d&65535)>>>8&65535|0,k[B+220>>2]|0,k[B+224>>2]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0}if(d&16384){y=0;Cb(203,w|0,l[B+252>>0]|0,k[B+256>>2]|0,k[B+260>>2]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0}if(d&128){y=0;Cb(204,w|0,k[B+192>>2]|0,k[B+196>>2]|0,l[B+200>>0]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0}if(d&512){y=0;Ib(833,w|0,B+140|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=za+208|0;k[d>>2]=k[d>>2]|512;d=k[h>>2]|0}do if(d&8192|0){e=B+248|0;if((k[e>>2]|0)<=0)break;f=B+244|0;d=0;while(1){y=0;Ib(834,w|0,(k[f>>2]|0)+(d<<4)|0);g=y;y=0;if((g|0)!=0&(z|0)!=0){h=Cpb(k[g>>2]|0,Ia|0,Ha|0)|0;if(!h)dd(g|0,z|0);N=z}else h=-1;if((h|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=d+1|0;if((d|0)>=(k[e>>2]|0))break}}while(0);g=B+128|0;if((k[g>>2]|0)>0){h=B+136|0;f=0;d=k[h>>2]|0;while(1){e=k[d+(f*28|0)>>2]|0;h:do if((e|0)>0){y=0;ib(159,w|0,e|0,k[d+(f*28|0)+4>>2]|0,k[d+(f*28|0)+20>>2]|0,k[d+(f*28|0)+24>>2]|0,k[d+(f*28|0)+8>>2]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0;e=d+(f*28|0)|0;if((k[e>>2]|0)==-1){k[e>>2]=-3;break}else{k[e>>2]=-2;break}}else switch(e|0){case 0:{y=0;Cb(205,w|0,k[d+(f*28|0)+4>>2]|0,k[d+(f*28|0)+8>>2]|0,0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0;k[d+(f*28|0)>>2]=-2;break h}case -1:{y=0;Cb(206,w|0,k[d+(f*28|0)+4>>2]|0,k[d+(f*28|0)+8>>2]|0,0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0;k[d+(f*28|0)>>2]=-3;break h}default:break h}while(0);f=f+1|0;if((f|0)>=(k[g>>2]|0))break}}d=k[B+240>>2]|0;if((d|0)<=0)break;n=k[B+236>>2]|0;u=za+656|0;o=n+(d*20|0)|0;p=za+660|0;t=za+664|0;while(1){i:do if(i[n+16>>0]&2){j:do if(n){d=k[p>>2]|0;if(!d){d=0;break}h=k[t>>2]|0;f=h+(d*5|0)|0;k:while(1){g=f+-5|0;d=i[n>>0]|0;e=i[g>>0]|0;do if(d<<24>>24==e<<24>>24){d=i[n+1>>0]|0;e=i[f+-4>>0]|0;if(d<<24>>24!=e<<24>>24)break;d=i[n+2>>0]|0;e=i[f+-3>>0]|0;if(d<<24>>24!=e<<24>>24)break;d=i[n+3>>0]|0;e=i[f+-2>>0]|0;if(d<<24>>24==e<<24>>24)break k}while(0);if(d<<24>>24==e<<24>>24)break;if(g>>>0>h>>>0)f=g;else{d=0;break j}}d=i[f+-1>>0]|0;if(d<<24>>24==1)break i;else d=d&255}else d=0;while(0);if(!((d|0)==3|(i[n+3>>0]&32)!=0)){if(d|0)break;if((k[u>>2]|0)!=3)break}f=n+12|0;d=k[f>>2]|0;if(!d){y=0;Ib(824,za|0,416638);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[f>>2]|0}y=0;Cb(201,w|0,n|0,k[n+8>>2]|0,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}while(0);n=n+20|0;if(n>>>0>=o>>>0)break}}while(0);if((za|0)==0|E^1){if(za|0)ra=191}else if((l[za+428>>0]|0)<8){ra=za+216|0;k[ra>>2]=k[ra>>2]|4;i[za+429>>0]=8;ra=191}else ra=191;if((ra|0)==191?(ra=0,pa=za+216|0,k[pa>>2]=k[pa>>2]|1,(i[za+428>>0]|0)==16):0){pa=za+216|0;k[pa>>2]=k[pa>>2]|16}if((k[s>>2]|0)>>>0<ta>>>0){d=k[v>>2]|0;if((d|0)!=(va|0)){if(d|0){y=0;rc(1459,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}k[v>>2]=va;k[s>>2]=264}if(ta>>>0>264){g=ta>>>0>1073741823?-1:ta<<2;g=(g|0)==0?1:g;while(1){y=0;d=uc(777,g|0)|0;e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ia|0,Ha|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}y=0;nc(d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}k[ya>>2]=d;k[s>>2]=ta}}else k[s>>2]=ta;if((ta|0)>0){e=b+16|0;f=k[b+48>>2]|0;d=0;do{pa=(k[e>>2]|0)+(aa(f,d)|0)|0;k[(k[v>>2]|0)+(d<<2)>>2]=pa;d=d+1|0}while((d|0)!=(ta|0))}I=k[v>>2]|0;J=za+424|0;H=za+216|0;if(!(i[J>>0]|0))F=1;else{k[H>>2]=k[H>>2]|2;F=7}K=za+352|0;L=za+372|0;M=za+425|0;pa=za+208|0;O=Da+8|0;P=za+360|0;Q=za+432|0;R=Da+10|0;S=za+429|0;T=Da+9|0;U=Da+11|0;V=Da+4|0;W=za+384|0;X=za+430|0;Y=za+435|0;Z=za+676|0;_=za+416|0;$=za+540|0;ba=za+680|0;ca=za+516|0;da=za+517|0;ea=za+513|0;fa=za+514|0;ga=Ba+4|0;ha=Ca+4|0;ia=za+515|0;ja=Ba+8|0;ka=Ca+8|0;la=za+428|0;ma=za+212|0;na=za+196|0;oa=za+348|0;G=0;d=k[K>>2]|0;l:while(1){if(!d)d=0;else{D=0;E=I;while(1){f=k[E>>2]|0;do if(!(k[L>>2]|0)){if(i[M>>0]|0)break;if(!(k[pa>>2]&1024)){ra=218;break l}y=0;rc(1484,w|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}while(0);u=k[J>>2]|0;d=(u&65535)>>>8&255;e=u>>>24&255;m:do if(!((u&255)<<24>>24))ra=248;else{if(!(k[H>>2]&2)){ra=248;break}switch(d<<24>>24){case 0:{if(!(k[L>>2]&7)){ra=248;break m}y=0;rc(1485,w|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}break m}case 1:{if((k[L>>2]&7|0)==0?(k[oa>>2]|0)>>>0>=5:0){ra=248;break m}y=0;rc(1485,w|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}break m}case 2:{if((k[L>>2]&7|0)==4){ra=248;break m}y=0;rc(1485,w|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}break m}case 3:{if((k[L>>2]&3|0)==0?(k[oa>>2]|0)>>>0>=3:0){ra=248;break m}y=0;rc(1485,w|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}break m}case 4:{if((k[L>>2]&3|0)==2){ra=248;break m}y=0;rc(1485,w|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}break m}case 5:{if((k[L>>2]&1|0)==0?(k[oa>>2]|0)>>>0>=2:0){ra=248;break m}y=0;rc(1485,w|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}break m}case 6:{if(k[L>>2]&1|0){ra=248;break m}y=0;rc(1485,w|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}break m}default:{ra=248;break m}}}while(0);n:do if((ra|0)==248){ra=0;i[O>>0]=e;d=k[P>>2]|0;k[Da>>2]=d;e=i[Q>>0]|0;i[R>>0]=e;u=i[S>>0]|0;i[T>>0]=u;e=aa(u&255,e&255)|0;i[U>>0]=e;e=e&255;if(e>>>0>7)d=aa(e>>>3,d)|0;else d=((aa(d,e)|0)+7|0)>>>3;k[V>>2]=d;upb((k[W>>2]|0)+1|0,f|0,d|0)|0;e=j[J>>1]|0;d=(e&65535)>>>8;do if(!((e&255)<<24>>24))ra=293;else{t=d&65535;if((d&255)>=6){ra=293;break}d=k[H>>2]|0;if(!(d&2))break;p=(k[W>>2]|0)+1|0;if((e&65535)<1536){d=i[U>>0]|0;o:do switch(d<<24>>24){case 1:{n=k[Da>>2]|0;d=i[418542+t>>0]|0;e=d&255;if(e>>>0>=n>>>0)break o;o=l[418535+t>>0]|0;g=7;h=0;f=p;do{h=((l[p+(e>>>3)>>0]|0)>>>(e&7^7)&1)<<g|h;if(!g){i[f>>0]=h;f=f+1|0;g=7;h=0}else g=g+-1|0;e=o+e|0}while(e>>>0<n>>>0);if((g|0)==7)break o;i[f>>0]=h;break}case 2:{n=k[Da>>2]|0;d=i[418542+t>>0]|0;e=d&255;if(e>>>0>=n>>>0)break o;o=l[418535+t>>0]|0;g=p;h=6;f=0;do{f=((l[p+(e>>>2)>>0]|0)>>>(e<<1&6^6)&3)<<h|f;if(!h){i[g>>0]=f;g=g+1|0;h=6;f=0}else h=h+-2|0;e=o+e|0}while(e>>>0<n>>>0);if((h|0)==6)break o;i[g>>0]=f;break}case 4:{n=k[Da>>2]|0;d=i[418542+t>>0]|0;e=d&255;if(e>>>0>=n>>>0)break o;o=l[418535+t>>0]|0;f=0;g=4;h=p;do{f=((l[p+(e>>>1)>>0]|0)>>>(e<<2&4^4)&15)<<g|f;if(!g){i[h>>0]=f;f=0;g=4;h=h+1|0}else g=g+-4|0;e=o+e|0}while(e>>>0<n>>>0);if((g|0)==4)break o;i[h>>0]=f;break}default:{o=k[Da>>2]|0;h=(d&255)>>>3;d=i[418542+t>>0]|0;e=d&255;if(e>>>0>=o>>>0)break o;n=l[418535+t>>0]|0;f=p;while(1){g=p+(aa(e,h)|0)|0;if((f|0)!=(g|0))upb(f|0,g|0,h|0)|0;e=n+e|0;if(e>>>0>=o>>>0)break;else f=f+h|0}}}while(0);u=l[418535+t>>0]|0;d=(((k[Da>>2]|0)+-1+u-(d&255)|0)>>>0)/(u>>>0)|0;k[Da>>2]=d;u=i[U>>0]|0;e=u&255;if((u&255)>7)e=aa(e>>>3,d)|0;else e=((aa(e,d)|0)+7|0)>>>3;k[V>>2]=e}else d=k[Da>>2]|0;if(d|0){ra=293;break}y=0;rc(1485,w|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}break n}while(0);if((ra|0)==293){ra=0;d=k[H>>2]|0}p:do if(d|0){do if(d&1048576){e=k[na>>2]|0;if(!e)break;y=0;mc(e|0,za|0,Da|0,(k[W>>2]|0)+1|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[H>>2]|0}while(0);if(d&32768){y=0;mc(347,Da|0,(k[W>>2]|0)+1|0,(k[ma>>2]|0)>>>7&1^1|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[H>>2]|0}q:do if(d&65536){f=(k[W>>2]|0)+1|0;e=i[T>>0]|0;if((e&255)>=8)break;g=k[V>>2]|0;h=f+g|0;switch(e<<24>>24){case 1:{e=416179;break}case 2:{e=415667;break}case 4:{e=415923;break}default:break q}if((g|0)>0)d=f;else break;do{i[d>>0]=i[e+(l[d>>0]|0)>>0]|0;d=d+1|0}while(d>>>0<h>>>0);d=k[H>>2]|0}while(0);do if(d&4){g=(k[W>>2]|0)+1|0;o=i[la>>0]|0;p=o&255;if(!((i[T>>0]|0)==8&(i[R>>0]|0)==1))break;r:do switch(o<<24>>24){case 1:{n=k[Da>>2]|0;if(!n)break r;else{e=g;f=128;d=0;h=0}while(1){d=((i[g>>0]|0)==0?0:f)|d;if((f|0)>1)f=f>>1;else{i[e>>0]=d;e=e+1|0;f=128;d=0}h=h+1|0;if((h|0)==(n|0))break;else g=g+1|0}if((f|0)==128)break r;i[e>>0]=d;break}case 2:{n=k[Da>>2]|0;if(!n)break r;else{h=0;d=0;e=6;f=g}while(1){d=(l[g>>0]&3)<<e|d;if(!e){i[f>>0]=d;d=0;e=6;f=f+1|0}else e=e+-2|0;h=h+1|0;if((h|0)==(n|0))break;else g=g+1|0}if((e|0)==6)break r;i[f>>0]=d;break}case 4:{n=k[Da>>2]|0;if(!n)break r;else{h=0;d=0;e=4;f=g}while(1){d=(l[g>>0]&15)<<e|d;if(!e){i[f>>0]=d;d=0;e=4;f=f+1|0}else e=e+-4|0;h=h+1|0;if((h|0)==(n|0))break;else g=g+1|0}if((e|0)==4)break r;i[f>>0]=d;break}default:{}}while(0);i[T>>0]=o;d=aa(l[R>>0]|0,p)|0;i[U>>0]=d;d=d&255;e=k[Da>>2]|0;if(d>>>0>7)d=aa(d>>>3,e)|0;else d=((aa(d,e)|0)+7|0)>>>3;k[V>>2]=d;d=k[H>>2]|0}while(0);do if((d&16|0)!=0&(i[T>>0]|0)==16){f=aa(l[R>>0]|0,k[Da>>2]|0)|0;if(!f)break;else{d=0;e=(k[W>>2]|0)+1|0}while(1){t=i[e>>0]|0;u=e+1|0;i[e>>0]=i[u>>0]|0;i[u>>0]=t;d=d+1|0;if((d|0)==(f|0))break;else e=e+2|0}d=k[H>>2]|0}while(0);do if(d&8){n=(k[W>>2]|0)+1|0;e=j[O>>1]|0;g=e&255;e=(e&65535)>>>8;h=e&255;if(g<<24>>24==3)break;f=e&65535;if(!(g&2)){d=1;e=l[ca>>0]|0}else{e=l[ea>>0]|0;d=l[fa>>0]|0;k[ga>>2]=f-d;k[ha>>2]=d;d=l[ia>>0]|0;k[ja>>2]=f-d;k[ka>>2]=d;d=3}k[Ba>>2]=f-e;k[Ca>>2]=e;if(!(g&4))t=d;else{t=l[da>>0]|0;k[Ba+(d<<2)>>2]=f-t;k[Ca+(d<<2)>>2]=t;t=d+1|0}do if((h&255)>=8){u=aa(k[Da>>2]|0,t)|0;d=(u|0)!=0;if(h<<24>>24==8){if(d)o=0;else break;while(1){g=(o>>>0)%(t>>>0)|0;f=l[n>>0]|0;e=k[Ba+(g<<2)>>2]|0;g=k[Ca+(g<<2)>>2]|0;h=0-g|0;if((e|0)>(h|0)){d=0;do{d=((e|0)>0?f<<e:f>>>(0-e|0))|d;e=e-g|0}while((e|0)>(h|0))}else d=0;i[n>>0]=d;o=o+1|0;if((o|0)==(u|0))break;else n=n+1|0}}else{if(d)p=0;else break;while(1){g=(p>>>0)%(t>>>0)|0;o=n+1|0;f=l[n>>0]<<8|l[o>>0];e=k[Ba+(g<<2)>>2]|0;g=k[Ca+(g<<2)>>2]|0;h=0-g|0;if((e|0)>(h|0)){d=0;do{d=((e|0)>0?f<<e:f>>>(0-e|0))|d;e=e-g|0}while((e|0)>(h|0))}else d=0;i[n>>0]=d>>>8;i[o>>0]=d;p=p+1|0;if((p|0)==(u|0))break;else n=n+2|0}}}else{u=k[V>>2]|0;d=i[ca>>0]|0;if(h<<24>>24==2&d<<24>>24==1)t=85;else t=h<<24>>24==4&d<<24>>24==3?17:255;if(!u)break;else p=0;while(1){g=l[n>>0]|0;d=k[Ba>>2]|0;h=k[Ca>>2]|0;o=0-h|0;if((d|0)>(o|0)){f=d;d=0;do{if((f|0)>0)e=g<<f;else e=g>>>(0-f|0)&t;d=e|d;f=f-h|0}while((f|0)>(o|0))}else d=0;i[n>>0]=d;p=p+1|0;if((p|0)==(u|0))break;else n=n+1|0}}while(0);d=k[H>>2]|0}while(0);s:do if(d&131072|0){d=(k[W>>2]|0)+1|0;u=j[O>>1]|0;f=(u&65535)>>>8&255;switch((u&255)<<24>>24){case 6:{g=k[Da>>2]|0;e=(g|0)!=0;if(f<<24>>24==8){if(e)e=0;else break s;while(1){o=d+1|0;t=i[d>>0]|0;p=d+2|0;i[d>>0]=i[o>>0]|0;u=d+3|0;i[o>>0]=i[p>>0]|0;i[p>>0]=i[u>>0]|0;i[u>>0]=t;e=e+1|0;if((e|0)==(g|0))break;else d=d+4|0}}else{if(e)e=0;else break s;while(1){n=d+1|0;o=i[d>>0]|0;p=d+2|0;t=i[n>>0]|0;u=d+3|0;i[d>>0]=i[p>>0]|0;h=d+4|0;i[n>>0]=i[u>>0]|0;n=d+5|0;i[p>>0]=i[h>>0]|0;p=d+6|0;i[u>>0]=i[n>>0]|0;u=d+7|0;i[h>>0]=i[p>>0]|0;i[n>>0]=i[u>>0]|0;i[p>>0]=o;i[u>>0]=t;e=e+1|0;if((e|0)==(g|0))break;else d=d+8|0}}break}case 4:{g=k[Da>>2]|0;e=(g|0)!=0;if(f<<24>>24==8){if(e)e=0;else break s;while(1){u=d+1|0;t=i[d>>0]|0;i[d>>0]=i[u>>0]|0;i[u>>0]=t;e=e+1|0;if((e|0)==(g|0))break;else d=d+2|0}}else{if(e)e=0;else break s;while(1){n=d+1|0;o=i[d>>0]|0;p=d+2|0;t=i[n>>0]|0;u=d+3|0;i[d>>0]=i[p>>0]|0;i[n>>0]=i[u>>0]|0;i[p>>0]=o;i[u>>0]=t;e=e+1|0;if((e|0)==(g|0))break;else d=d+4|0}}break}default:break s}}while(0);t:do if(k[H>>2]&524288|0){d=(k[W>>2]|0)+1|0;u=j[O>>1]|0;f=(u&65535)>>>8&255;switch((u&255)<<24>>24){case 6:{g=k[Da>>2]|0;e=(g|0)!=0;if(f<<24>>24==8){if(e)e=0;else break t;while(1){u=d+3|0;i[u>>0]=l[u>>0]^255;e=e+1|0;if((e|0)==(g|0))break;else d=d+4|0}}else{if(e)e=0;else break t;while(1){t=d+6|0;u=d+7|0;i[t>>0]=l[t>>0]^255;i[u>>0]=l[u>>0]^255;e=e+1|0;if((e|0)==(g|0))break;else d=d+8|0}}break}case 4:{g=k[Da>>2]|0;e=(g|0)!=0;if(f<<24>>24==8){if(e)e=0;else break t;while(1){u=d+1|0;i[u>>0]=l[u>>0]^255;e=e+1|0;if((e|0)==(g|0))break;else d=d+2|0}}else{if(e)e=0;else break t;while(1){t=d+2|0;u=d+3|0;i[t>>0]=l[t>>0]^255;i[u>>0]=l[u>>0]^255;e=e+1|0;if((e|0)==(g|0))break;else d=d+4|0}}break}default:break t}}while(0);d=k[H>>2]|0;if(d&1){y=0;Ib(835,Da|0,(k[W>>2]|0)+1|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[H>>2]|0}if(!(d&32))break;g=(k[W>>2]|0)+1|0;d=j[O>>1]|0;switch((d&255)<<24>>24){case 0:{f=k[V>>2]|0;if(!f)break p;else{e=0;d=g}while(1){i[d>>0]=l[d>>0]^255;e=e+1|0;if((e|0)==(f|0))break p;else d=d+1|0}}case 4:break;default:break p}switch(((d&65535)>>>8&255)<<24>>24){case 8:{f=k[V>>2]|0;if(!f)break p;else{e=0;d=g}while(1){i[d>>0]=l[d>>0]^255;e=e+2|0;if(e>>>0>=f>>>0)break;else d=d+2|0}break}case 16:{f=k[V>>2]|0;if(!f)break p;else{e=0;d=g}while(1){i[d>>0]=l[d>>0]^255;u=d+1|0;i[u>>0]=l[u>>0]^255;e=e+4|0;if(e>>>0>=f>>>0)break;else d=d+4|0}break}default:break p}}while(0);d=i[U>>0]|0;if(d<<24>>24!=(i[X>>0]|0)){ra=407;break l}if(d<<24>>24!=(i[Y>>0]|0)){ra=407;break l}u:do if(k[Z>>2]&4|0){if((i[ba>>0]|0)!=64)break;d=(k[W>>2]|0)+1|0;g=k[Da>>2]|0;e=j[O>>1]|0;f=e&255;if(!(f&2))break;switch(((e&65535)>>>8&255)<<24>>24){case 8:{switch(f<<24>>24){case 2:{f=3;break}case 6:{f=4;break}default:break u}if(!g)break u;else e=0;while(1){t=l[d+1>>0]|0;i[d>>0]=(l[d>>0]|0)-t;u=d+2|0;i[u>>0]=(l[u>>0]|0)-t;e=e+1|0;if((e|0)==(g|0))break;else d=d+f|0}break}case 16:{switch(f<<24>>24){case 2:{f=6;break}case 6:{f=8;break}default:break u}if(!g)break u;else e=0;while(1){o=d+1|0;t=l[d+2>>0]<<8|l[d+3>>0];p=d+4|0;u=d+5|0;n=(l[d>>0]<<8|l[o>>0])-t|0;t=(l[p>>0]<<8|l[u>>0])-t|0;i[d>>0]=n>>>8;i[o>>0]=n;i[p>>0]=t>>>8;i[u>>0]=t;e=e+1|0;if((e|0)==(g|0))break;else d=d+f|0}break}default:break u}}while(0);do if((i[O>>0]|0)==3){if((k[_>>2]|0)<=-1)break;y=0;Ib(836,za|0,Da|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}while(0);y=0;Ib(837,w|0,Da|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[$>>2]|0;if(!d)break;y=0;mc(d|0,za|0,k[L>>2]|0,l[M>>0]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}while(0);D=D+1|0;d=k[K>>2]|0;if(D>>>0>=d>>>0)break;else E=E+4|0}}G=G+1|0;if((G|0)==(F|0)){ra=430;break}}if((ra|0)==218){y=0;Ib(825,za|0,416784);d=y;y=0;if((d|0)!=0&(z|0)!=0){ra=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!ra)dd(d|0,z|0);N=z};ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}else if((ra|0)==407){y=0;Ib(825,za|0,416837);d=y;y=0;if((d|0)!=0&(z|0)!=0){ra=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!ra)dd(d|0,z|0);N=z};ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}else if((ra|0)==430){if(!(k[pa>>2]&4)){y=0;Ib(825,za|0,416715);d=y;y=0;if((d|0)!=0&(z|0)!=0){ra=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!ra)dd(d|0,z|0);N=z};ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}if((k[_>>2]|0)>(m[za+412>>1]|0)){y=0;Ib(829,za|0,416742);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}do if(!qa){do if(k[B+8>>2]&512|0){if(k[pa>>2]&512|0)break;y=0;Ib(833,w|0,B+140|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}while(0);g=B+128|0;if((k[g>>2]|0)>0){h=B+136|0;f=0;d=k[h>>2]|0;while(1){e=k[d+(f*28|0)>>2]|0;do if((e|0)>0){y=0;ib(159,w|0,e|0,k[d+(f*28|0)+4>>2]|0,k[d+(f*28|0)+20>>2]|0,k[d+(f*28|0)+24>>2]|0,k[d+(f*28|0)+8>>2]|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0;e=d+(f*28|0)|0;if((k[e>>2]|0)==-1){k[e>>2]=-3;break}else{k[e>>2]=-2;break}}else{if((e|0)>-1){y=0;Cb(205,w|0,k[d+(f*28|0)+4>>2]|0,k[d+(f*28|0)+8>>2]|0,e|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0;k[d+(f*28|0)>>2]=-2;break}if((e|0)!=-1)break;y=0;Cb(206,w|0,k[d+(f*28|0)+4>>2]|0,k[d+(f*28|0)+8>>2]|0,0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[h>>2]|0;k[d+(f*28|0)>>2]=-3}while(0);f=f+1|0;if((f|0)>=(k[g>>2]|0))break}}d=k[B+240>>2]|0;if((d|0)<=0)break;n=k[B+236>>2]|0;u=za+656|0;o=n+(d*20|0)|0;p=za+660|0;t=za+664|0;while(1){v:do if(i[n+16>>0]&8){w:do if(n){d=k[p>>2]|0;if(!d){d=0;break}h=k[t>>2]|0;f=h+(d*5|0)|0;x:while(1){g=f+-5|0;d=i[n>>0]|0;e=i[g>>0]|0;do if(d<<24>>24==e<<24>>24){d=i[n+1>>0]|0;e=i[f+-4>>0]|0;if(d<<24>>24!=e<<24>>24)break;d=i[n+2>>0]|0;e=i[f+-3>>0]|0;if(d<<24>>24!=e<<24>>24)break;d=i[n+3>>0]|0;e=i[f+-2>>0]|0;if(d<<24>>24==e<<24>>24)break x}while(0);if(d<<24>>24==e<<24>>24)break;if(g>>>0>h>>>0)f=g;else{d=0;break w}}d=i[f+-1>>0]|0;if(d<<24>>24==1)break v;else d=d&255}else d=0;while(0);if(!((d|0)==3|(i[n+3>>0]&32)!=0)){if(d|0)break;if((k[u>>2]|0)!=3)break}f=n+12|0;d=k[f>>2]|0;if(!d){y=0;Ib(824,za|0,416638);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}d=k[f>>2]|0}y=0;Cb(201,w|0,n|0,k[n+8>>2]|0,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}}while(0);n=n+20|0;if(n>>>0>=o>>>0)break}}while(0);k[pa>>2]=k[pa>>2]|8;y=0;rc(1486,w|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue c}i[Ga>>0]=1;break}}while(0);if(C){h=xa;u=va;t=wa;p=ua;o=ta;n=sa;g=C;ra=532;continue}if(!x){h=xa;u=va;t=wa;p=ua;o=ta;D=sa;ra=484;continue}}y=0;Cb(207,za|0,x|0,32767,-1);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue}zpb(x|0,0,268)|0;d=k[za+692>>2]|0;if(!d){y=0;rc(1459,x|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue}h=xa;u=va;t=wa;p=ua;o=ta;D=sa;ra=484;continue}else{y=0;Ib(d|0,za|0,x|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){ea=C;fa=sa;ga=ta;ha=ua;ia=q;ja=wa;ka=va;la=v;ma=s;na=w;oa=xa;pa=x;qa=A;ra=B;d=N;C=ea;sa=fa;ta=ga;ua=ha;q=ia;wa=ja;va=ka;v=la;s=ma;w=na;xa=oa;x=pa;A=qa;B=ra;ra=24;continue}h=xa;u=va;t=wa;p=ua;o=ta;D=sa;ra=484;continue}}else if((ra|0)==484){if(k[za+212>>2]&2|0){y=0;uc(791,za+224|0)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue}}d=za+280|0;e=k[d>>2]|0;if(e|0){k[d>>2]=0;g=za+692|0;while(1){d=e;e=k[e>>2]|0;f=k[g>>2]|0;if(!f){y=0;rc(1459,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){f=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!f)dd(d|0,z|0);N=z}else f=-1;if((f|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue c}}else{y=0;Ib(f|0,za|0,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){f=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!f)dd(d|0,z|0);N=z}else f=-1;if((f|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue c}}if(!e)break}}f=za+384|0;d=k[f>>2]|0;do if(d|0){e=k[za+692>>2]|0;if(!e){y=0;rc(1459,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue c}break}else{y=0;Ib(e|0,za|0,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue c}break}}while(0);k[f>>2]=0;n=za+380|0;d=k[n>>2]|0;do if(d|0){e=k[za+692>>2]|0;if(!e){y=0;rc(1459,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue c}break}else{y=0;Ib(e|0,za|0,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue c}break}}while(0);g=za+388|0;d=k[g>>2]|0;do if(d|0){e=k[za+692>>2]|0;if(!e){y=0;rc(1459,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue c}break}else{y=0;Ib(e|0,za|0,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue c}break}}while(0);f=za+392|0;d=k[f>>2]|0;do if(d|0){e=k[za+692>>2]|0;if(!e){y=0;rc(1459,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue c}break}else{y=0;Ib(e|0,za|0,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue c}break}}while(0);k[n>>2]=0;k[g>>2]=0;k[f>>2]=0;f=za+664|0;d=k[f>>2]|0;do if(d|0){e=k[za+692>>2]|0;if(!e){y=0;rc(1459,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue c}break}else{y=0;Ib(e|0,za|0,d|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue c}break}}while(0);k[f>>2]=0;upb(Aa|0,za|0,868)|0;zpb(za|0,0,868)|0;d=k[Aa+692>>2]|0;if(!d){y=0;rc(1459,za|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue}}else{y=0;Ib(d|0,Aa|0,za|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue}}y=0;rc(1487,Aa|0);d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=D;d=N;ra=24;continue}n=D;g=C;ra=532;continue}else if((ra|0)==532){ra=0;if(k[Fa>>2]|0){y=0;uc(776,k[Fa>>2]|0)|0;d=y;y=0;if((d|0)!=0&(z|0)!=0){e=Cpb(k[d>>2]|0,Ia|0,Ha|0)|0;if(!e)dd(d|0,z|0);N=z}else e=-1;if((e|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=n;C=g;d=N;ra=24;continue}}d=(i[Ga>>0]&1)!=0;e=k[v>>2]|0;if((e|0)==(u|0)){ra=540;break}if(!e)break;y=0;rc(1459,e|0);e=y;y=0;if((e|0)!=0&(z|0)!=0){f=Cpb(k[e>>2]|0,Ia|0,Ha|0)|0;if(!f)dd(e|0,z|0);N=z}else f=-1;if((f|0)==1){xa=h;va=u;wa=t;ua=p;ta=o;sa=n;C=g;d=N;ra=24;continue}else{ra=538;break}}if((ra|0)!=538)if((ra|0)==540){ggb(Ia|0);r=Ja;return d|0}k[v>>2]=u;k[s>>2]=264;Ha=d;ggb(Ia|0);r=Ja;return Ha|0}function Nwa(a,b){a=a|0;b=b|0;var c=0,d=0;while(1){b=fgb(36)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Owa(b);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=89592;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function Owa(a){a=a|0;var b=0,c=0,d=0;k[a+28>>2]=0;k[a+32>>2]=0;d=a+24|0;i[d>>0]=0;b=a+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[a>>2]=89968;b=a+4|0;c=a+8|0;k[c>>2]=0;k[b>>2]=0;a=ZT(44)|0;k[a>>2]=1;k[b>>2]=a+4;k[c>>2]=39;i[a+43>>0]=0;a=k[b>>2]|0;b=358933;c=a+39|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));i[d>>0]=1;return}function Pwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;j=m;if(!c){r=m;return}if((a|0)!=0?(e=k[a+188>>2]|0,(e|0)!=0):0){d=e+20|0;a=k[d>>2]|0;if(!a)f=5}else{e=0;f=5}if((f|0)==5){a=j+4|0;d=ZT(32)|0;k[d>>2]=1;f=d+4|0;k[j>>2]=f;k[a>>2]=25;i[d+29>>0]=0;g=358973;h=f+25|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,j,358999,358811,330);k[a>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);a=e+20|0;d=a;a=k[a>>2]|0}e=a+4|0;h=k[e>>2]|0;g=k[a>>2]|0;j=h-g|0;f=j+c|0;if(j>>>0>=f>>>0){if(j>>>0>f>>>0?(l=g+f|0,(h|0)!=(l|0)):0)k[e>>2]=l}else{T1(a,c);a=k[d>>2]|0}upb((k[a>>2]|0)+j|0,b|0,c|0)|0;r=m;return}function Qwa(a){a=a|0;return}function Rwa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90012;b=a+96|0;Uh[k[(k[b>>2]|0)+16>>2]&2047](b);k[b>>2]=90256;c=a+116|0;d=k[c>>2]|0;if(d|0){Qfb(d)|0;k[c>>2]=0}i[a+128>>0]=0;if(!(i[a+100>>0]|0)){k[a+112>>2]=0;k[a+108>>2]=0;k[a+104>>2]=0}Uh[k[(k[b>>2]|0)+24>>2]&2047](b);Tva(a);return}function Swa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90012;b=a+96|0;Uh[k[(k[b>>2]|0)+16>>2]&2047](b);k[b>>2]=90256;c=a+116|0;d=k[c>>2]|0;if(d|0){Qfb(d)|0;k[c>>2]=0}i[a+128>>0]=0;if(!(i[a+100>>0]|0)){k[a+112>>2]=0;k[a+108>>2]=0;k[a+104>>2]=0}Uh[k[(k[b>>2]|0)+24>>2]&2047](b);Tva(a);ggb(a);return}function Twa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;f=a+36|0;if(k[a+52>>2]|0){e=k[a+40>>2]|0;if((e|0)<3)b=aa(k[a+48>>2]|0,k[a+44>>2]|0)|0;else{d=k[a+76>>2]|0;c=0;b=1;do{b=aa(k[d+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(e|0))}c=a+96|0;if(b)if(Hh[k[(k[c>>2]|0)+12>>2]&511](c,f)|0)b=c;else{a=0;return a|0}else{b=c;g=9}}else{c=a+96|0;b=c;g=9}if((g|0)==9)if(!(Hh[k[(k[b>>2]|0)+8>>2]&511](c,a+20|0)|0)){a=0;return a|0}f=b+16|0;d=k[f>>2]|0;e=b+12|0;if(d>>>0>=(k[e>>2]|0)>>>0){Uh[k[(k[b>>2]|0)+20>>2]&2047](b);d=k[f>>2]|0}h=i[d>>0]|0;d=d+1|0;k[f>>2]=d;if(h<<24>>24!=80){a=te(4)|0;k[a>>2]=-125;Cf(a|0,18944,0)}if(d>>>0>=(k[e>>2]|0)>>>0){Uh[k[(k[b>>2]|0)+20>>2]&2047](b);d=k[f>>2]|0}e=i[d>>0]|0;k[f>>2]=d+1;switch(e<<24>>24){case 52:case 49:{f=a+1156|0;k[f>>2]=1;d=0;break}case 53:case 50:{f=a+1156|0;k[f>>2]=8;d=0;break}case 54:case 51:{f=a+1156|0;k[f>>2]=24;d=16;break}default:{a=te(4)|0;k[a>>2]=-125;Cf(a|0,18944,0)}}i[a+1164>>0]=(e&255)>51&1;h=a+12|0;k[h>>2]=d;d=Ywa(b,2147483647)|0;g=a+4|0;k[g>>2]=d;d=Ywa(b,2147483647)|0;e=a+8|0;k[e>>2]=d;if((k[f>>2]|0)!=1){d=Ywa(b,2147483647)|0;k[a+1168>>2]=d;if((d|0)>65535){a=te(4)|0;k[a>>2]=-125;Cf(a|0,18944,0)}if((d|0)>255)k[h>>2]=k[h>>2]&4088|2}else{k[a+1168>>2]=1;d=1}if((k[g>>2]|0)>0?(k[e>>2]|0)>0&(d+-1|0)>>>0<65535:0){k[a+1160>>2]=(k[c+16>>2]|0)+(k[c+28>>2]|0)-(k[c+8>>2]|0);a=1;return a|0}k[a+1160>>2]=-1;k[e>>2]=-1;k[g>>2]=-1;Uh[k[(k[b>>2]|0)+16>>2]&2047](c);a=0;return a|0}function Uwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;R=r;r=r+3104|0;s=R+2080|0;O=R+1040|0;N=R;D=(k[b>>2]&4088|0)!=0;d=k[b+16>>2]|0;K=k[b+48>>2]|0;n=k[a+12>>2]|0;o=1212424721>>>(n<<2&28)<<3&120;L=a+4|0;C=k[L>>2]|0;B=a+1156|0;p=aa(aa(k[B>>2]|0,C)|0,o)|0;G=(((p|0)/8|0)+7|0)/8|0;C=aa((n>>>3&511)+1|0,C)|0;n=a+1160|0;if((k[n>>2]|0)<0){Q=0;r=R;return Q|0}M=a+96|0;if(!(i[a+128>>0]|0)){Q=0;r=R;return Q|0}e=G+32|0;P=O+8|0;k[O>>2]=P;Q=O+4|0;k[Q>>2]=1032;if(e>>>0>1032){while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[O>>2]=c;H=c}else H=P;k[Q>>2]=e;I=N+8|0;k[N>>2]=I;J=N+4|0;k[J>>2]=1032;z=(o|0)==8;if(z){h=k[a+1168>>2]|0;e=h+1|0;if(e>>>0>1032){while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[N>>2]=c}else c=I;k[J>>2]=e;f=k[B>>2]|0;if((h|0)>=0){g=(f|0)==1?255:0;e=0;while(1){i[c+e>>0]=g^((e*255|0)/(h|0)|0);if((e|0)==(h|0))break;else e=e+1|0}}g=(f|0)==1;f=g?2:256;g=g?255:0;h=f+-1|0;e=0;do{F=(((e*255|0)/(h|0)|0)^g)&255;i[s+(e<<2)+2>>0]=F;i[s+(e<<2)+1>>0]=F;i[s+(e<<2)>>0]=F;i[s+(e<<2)+3>>0]=0;e=e+1|0}while((e|0)<(f|0));E=c}else E=I;c=k[n>>2]|0;if(!(k[a+116>>2]|0)){e=c;c=0}else{F=(c|0)%(k[a+120>>2]|0)|0;e=F;c=c-F|0}y=(k[a+104>>2]|0)+e|0;k[a+124>>2]=c;F=a+112|0;k[F>>2]=y;a:do switch(k[B>>2]|0){case 1:{q=a+8|0;c=(k[q>>2]|0)>0;if(!(i[a+1164>>0]|0)){if(!c){d=1;break a}if(D){n=0;h=d}else{e=0;while(1){if((k[L>>2]|0)>0){c=0;do{f=(Ywa(M,1)|0)!=0&1;i[H+c>>0]=f;c=c+1|0;f=k[L>>2]|0}while((c|0)<(f|0));if((f|0)>0){c=0;do{i[d+c>>0]=i[E+(l[H+c>>0]|0)>>0]|0;c=c+1|0}while((c|0)!=(f|0))}}e=e+1|0;if((e|0)>=(k[q>>2]|0)){d=1;break a}else d=d+K|0}}while(1){c=k[L>>2]|0;if((c|0)>0){d=0;do{c=(Ywa(M,1)|0)!=0&1;i[H+d>>0]=c;d=d+1|0;c=k[L>>2]|0}while((d|0)<(c|0))}G=c*3|0;g=h+G|0;if((G|0)>3){f=H;e=h;d=h+3|0;while(1){c=f+1|0;G=s+(l[f>>0]<<2)|0;G=l[G>>0]|l[G+1>>0]<<8|l[G+2>>0]<<16|l[G+3>>0]<<24;i[e>>0]=G;i[e+1>>0]=G>>8;i[e+2>>0]=G>>16;i[e+3>>0]=G>>24;e=d+3|0;if(e>>>0<g>>>0){G=d;f=c;d=e;e=G}else break}}else{d=h;c=H}E=l[c>>0]|0;F=i[s+(E<<2)+1>>0]|0;G=i[s+(E<<2)+2>>0]|0;i[d>>0]=i[s+(E<<2)>>0]|0;i[d+1>>0]=F;i[d+2>>0]=G;n=n+1|0;if((n|0)>=(k[q>>2]|0)){d=1;break a}else h=h+K|0}}if(c){p=(p|0)>7;o=a+108|0;if(D){n=0;while(1){if(p){e=k[F>>2]|0;h=H;g=G;c=e;while(1){c=(k[o>>2]|0)-c|0;c=(c|0)>(g|0)?g:c;if((c|0)<=0)do{Uh[k[(k[M>>2]|0)+20>>2]&2047](M);e=k[F>>2]|0;c=(k[o>>2]|0)-e|0;c=(c|0)>(g|0)?g:c}while((c|0)<=0);upb(h|0,e|0,c|0)|0;f=(k[F>>2]|0)+c|0;k[F>>2]=f;e=g-c|0;if((e|0)>0){h=h+c|0;g=e;c=f;e=f}else break}}dya(d,H,k[L>>2]|0,s);n=n+1|0;if((n|0)>=(k[q>>2]|0)){d=1;break}else d=d+K|0}}else{n=0;while(1){if(p){e=k[F>>2]|0;h=H;g=G;c=e;while(1){c=(k[o>>2]|0)-c|0;c=(c|0)>(g|0)?g:c;if((c|0)<=0)do{Uh[k[(k[M>>2]|0)+20>>2]&2047](M);e=k[F>>2]|0;c=(k[o>>2]|0)-e|0;c=(c|0)>(g|0)?g:c}while((c|0)<=0);upb(h|0,e|0,c|0)|0;f=(k[F>>2]|0)+c|0;k[F>>2]=f;e=g-c|0;if((e|0)>0){h=h+c|0;g=e;c=f;e=f}else break}}eya(d,H,k[L>>2]|0,E);n=n+1|0;if((n|0)>=(k[q>>2]|0)){d=1;break}else d=d+K|0}}}else d=1;break}case 24:case 8:{y=a+8|0;if((k[y>>2]|0)>0){t=a+1164|0;u=(C|0)>0;v=a+1168|0;w=o>>>3;x=(o|0)==16;s=(o|0)!=16;q=(C|0)<1;p=(p|0)>7;o=a+108|0;n=0;while(1){if(!(i[t>>0]|0))if(u)if(z){c=0;do{A=Ywa(M,2147483647)|0;a=k[v>>2]|0;i[H+c>>0]=i[E+(A>>>0>a>>>0?a:A)>>0]|0;c=c+1|0}while((c|0)<(C|0));A=72}else{c=0;do{A=Ywa(M,2147483647)|0;a=k[v>>2]|0;j[H+(c<<1)>>1]=A>>>0>a>>>0?a:A;c=c+1|0}while((c|0)<(C|0));A=72}else A=72;else{if(p){e=k[F>>2]|0;h=H;g=G;c=e;while(1){c=(k[o>>2]|0)-c|0;c=(c|0)>(g|0)?g:c;if((c|0)<=0)do{Uh[k[(k[M>>2]|0)+20>>2]&2047](M);e=k[F>>2]|0;c=(k[o>>2]|0)-e|0;c=(c|0)>(g|0)?g:c}while((c|0)<=0);upb(h|0,e|0,c|0)|0;f=(k[F>>2]|0)+c|0;k[F>>2]=f;e=g-c|0;if((e|0)>0){h=h+c|0;g=e;c=f;e=f}else break}}if(x)if(u){c=0;do{A=c<<1;h=H+A|0;a=i[h>>0]|0;A=H+(A|1)|0;i[h>>0]=i[A>>0]|0;i[A>>0]=a;c=c+1|0}while((c|0)!=(C|0));A=72}else A=72}if((A|0)==72?(A=0,!((k[b>>2]&7|0)!=0|s|q)):0){c=0;do{i[H+c>>0]=(m[H+(c<<1)>>1]|0)>>>8;c=c+1|0}while((c|0)!=(C|0))}b:do if((k[B>>2]|0)==8){if(!D){upb(d|0,H|0,aa(k[L>>2]|0,w)|0)|0;break}c=k[L>>2]|0;if(!(k[b>>2]&7)){f=H+c|0;if((c|0)>0){c=H;e=d}else break;while(1){a=i[c>>0]|0;i[e+2>>0]=a;i[e+1>>0]=a;i[e>>0]=a;c=c+1|0;if(c>>>0>=f>>>0)break b;else e=e+3|0}}f=H+(c<<1)|0;if(H>>>0<f>>>0){c=H;e=d;while(1){a=j[c>>1]|0;j[e+4>>1]=a;j[e+2>>1]=a;j[e>>1]=a;c=c+2|0;if(c>>>0>=f>>>0)break;else e=e+6|0}}}else{c=(k[b>>2]&7|0)==0;g=k[L>>2]|0;if(D){if(!c){if((g|0)>0){c=0;e=d;f=H}else break;while(1){h=j[f+2>>1]|0;a=j[f+4>>1]|0;j[e+4>>1]=j[f>>1]|0;j[e+2>>1]=h;j[e>>1]=a;c=c+1|0;if((c|0)==(g|0))break b;else{e=e+6|0;f=f+6|0}}}if((g|0)>0){c=0;e=d;f=H;while(1){h=i[f+1>>0]|0;a=i[f+2>>0]|0;i[e+2>>0]=i[f>>0]|0;i[e+1>>0]=h;i[e>>0]=a;c=c+1|0;if((c|0)>=(g|0))break;else{e=e+3|0;f=f+3|0}}}break}else{if(!c){if((g|0)>0){c=0;e=H}else break;while(1){j[d+(c<<1)>>1]=(((m[e+4>>1]|0)*1868|0)+8192+((m[e+2>>1]|0)*9617|0)+((m[e>>1]|0)*4899|0)|0)>>>14;c=c+1|0;if((c|0)==(g|0))break b;else e=e+6|0}}if((g|0)>0){c=0;e=H;while(1){i[d+c>>0]=(((l[e+2>>0]|0)*1868|0)+8192+((l[e+1>>0]|0)*9617|0)+((l[e>>0]|0)*4899|0)|0)>>>14;c=c+1|0;if((c|0)>=(g|0))break;else e=e+3|0}}break}}while(0);n=n+1|0;if((n|0)>=(k[y>>2]|0)){d=1;break}else d=d+K|0}}else d=1;break}default:d=0}while(0);c=k[N>>2]|0;if((c|0)!=(I|0)){if(c|0)ggb(c);k[N>>2]=I;k[J>>2]=1032}c=k[O>>2]|0;if((c|0)!=(P|0)){if(c|0)ggb(c);k[O>>2]=P;k[Q>>2]=1032}Q=d;r=R;return Q|0}function Vwa(a){a=a|0;return 3}function Wwa(a,b){a=a|0;b=b|0;if((k[b+4>>2]|0)>>>0<=2){b=0;return b|0}a=k[b>>2]|0;if((i[a>>0]|0)!=80){b=0;return b|0}if(((i[a+1>>0]|0)+-49&255)>=6){b=0;return b|0}b=i[a+2>>0]|0;b=b<<24>>24==32|((b<<24>>24)+-9|0)>>>0<5;return b|0}function Xwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;while(1){b=fgb(1172)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}c=b+20|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;k[b+36>>2]=1124007936;c=b+44|0;d=b+76|0;e=b+40|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;f=b+84|0;k[b+80>>2]=f;k[b+88>>2]=0;k[f>>2]=0;k[b+8>>2]=0;k[b+4>>2]=0;k[b+12>>2]=-1;k[b+16>>2]=1;k[b>>2]=90012;f=b+104|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[b+120>>2]=32768;i[b+128>>0]=0;i[b+100>>0]=0;k[b+96>>2]=90336;k[b+1160>>2]=-1;i[b+92>>0]=1;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}f=c+4|0;k[f>>2]=1;k[c>>2]=89512;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[f>>2]=(k[f>>2]|0)+1;a=k[f>>2]|0;k[f>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function Ywa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;g=a+16|0;c=k[g>>2]|0;h=a+12|0;if(c>>>0>=(k[h>>2]|0)>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=k[g>>2]|0}d=l[c>>0]|0;c=c+1|0;k[g>>2]=c;if((d+-48|0)>>>0<10){e=0;f=0}else while(1){a:do if((d|0)==35)while(1){if(c>>>0>=(k[h>>2]|0)>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=k[g>>2]|0}f=i[c>>0]|0;c=c+1|0;k[g>>2]=c;switch(f<<24>>24){case 10:case 13:break a;default:{}}}while(0);if(c>>>0>=(k[h>>2]|0)>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=k[g>>2]|0}f=i[c>>0]|0;d=f&255;c=c+1|0;k[g>>2]=c;if(f<<24>>24==32|(d+-9|0)>>>0<5)do{if(c>>>0>=(k[h>>2]|0)>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=k[g>>2]|0}f=i[c>>0]|0;d=f&255;c=c+1|0;k[g>>2]=c}while(f<<24>>24==32|(d+-9|0)>>>0<5);if((d+-48|0)>>>0<=9){e=0;f=0;break}}while(1){f=d+-48+(f*10|0)|0;e=e+1|0;if((e|0)>=(b|0)){c=19;break}if(c>>>0>=(k[h>>2]|0)>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=k[g>>2]|0}d=l[c>>0]|0;c=c+1|0;k[g>>2]=c;if((d+-48|0)>>>0>=10){c=19;break}}if((c|0)==19)return f|0;return 0}function Zwa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1)return;ggb(k[b+-8>>2]|0);return}function _wa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b){ggb(a);return}c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function $wa(a,b){a=a|0;b=b|0;return (b|2|0)==2|0}function axa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;Z=r;r=r+1168|0;U=Z+72|0;T=Z+64|0;S=Z+56|0;R=Z+48|0;Q=Z+40|0;P=Z+32|0;W=Z+24|0;V=Z+16|0;s=Z;X=Z+1120|0;Y=Z+80|0;N=k[b+12>>2]|0;O=k[b+8>>2]|0;t=k[b>>2]|0;u=t>>>3&511;t=1212424721>>>(t<<2&28)<<3&120;L=(u|0)!=0;M=L?3:1;q=b+4|0;d=k[q>>2]|0;if((d|0)>0)d=k[(k[b+44>>2]|0)+(d+-1<<2)>>2]|0;else d=0;K=aa(d,N)|0;e=k[c+4>>2]|0;d=k[c>>2]|0;f=d;if((e|0)==(d|0))G=1;else{e=e-d>>2;d=1;c=0;do{if((k[f+(c<<2)>>2]|0)==32)d=(k[f+((c|1)<<2)>>2]|0)!=0;c=c+2|0}while(c>>>0<e>>>0);G=d}H=X+12|0;k[H>>2]=0;I=X+8|0;k[I>>2]=0;d=X+4|0;k[d>>2]=0;c=X+24|0;k[c>>2]=0;k[X+16>>2]=32768;e=X+28|0;i[e>>0]=0;f=X+32|0;k[f>>2]=0;k[X>>2]=90416;h=a+20|0;g=k[h>>2]|0;Gxa(X);Uh[k[(k[X>>2]|0)+28>>2]&2047](X);do if(!g){F=k[a+12>>2]|0;F=Ufb((F|0)==0?1016759:F,377117)|0;k[c>>2]=F;if(!F){Y=0;Cxa(X);r=Z;return Y|0}else{i[e>>0]=1;k[X+20>>2]=0;k[H>>2]=k[d>>2];break}}else{k[f>>2]=g;i[e>>0]=1;k[X+20>>2]=0;k[H>>2]=k[d>>2];d=k[b>>2]&7|(M<<3)+-8;p=k[h>>2]|0;if(G)d=K;else{if(d)if((d|0)==16)d=14;else d=(d|0)==2?6:20;else d=4;d=aa(d,N)|0|1}f=(aa(d,O)|0)+511&-256;g=p+8|0;h=k[p>>2]|0;a=h;if(((k[g>>2]|0)-h|0)>>>0<f>>>0){n=p+4|0;o=(k[n>>2]|0)-h|0;a:do if(!f)d=0;else while(1){d=fgb(f)|0;if(d|0)break a;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break a}Qh[d&7]()}while(0);c=d+o|0;e=c+(0-o)|0;if((o|0)>0)upb(e|0,a|0,o|0)|0;k[p>>2]=e;k[n>>2]=c;k[g>>2]=d+f;if(h|0)ggb(a)}}while(0);if(G){d=k[q>>2]|0;if((d|0)>0)d=k[(k[b+44>>2]|0)+(d+-1<<2)>>2]|0;else d=0;d=aa(d,N)|0}else d=(aa((M*6|0)+(L?2:0)|0,N)|0)+32|0;c=(d|0)>128?d:128;E=Y+8|0;k[Y>>2]=E;F=Y+4|0;k[F>>2]=1032;if(c>>>0>1032){while(1){d=fgb(c)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[Y>>2]=d;D=d}else D=E;k[F>>2]=c;k[s>>2]=(G?3:0)+(L?51:50);k[s+4>>2]=N;k[s+8>>2]=O;k[s+12>>2]=(1<<t)+-1;Cfb(D,359114,s);C=D;b:do if(!(C&3)){d=D;J=38}else{c=D;d=C;while(1){if(!(i[c>>0]|0))break b;c=c+1|0;d=c;if(!(d&3)){d=c;J=38;break}}}while(0);if((J|0)==38){while(1){c=k[d>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))d=d+4|0;else break}if((c&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}d=d-C|0;if(d|0){g=D;do{c=k[I>>2]|0;e=k[H>>2]|0;f=c-e|0;f=(f|0)>(d|0)?d:f;if((f|0)>0){upb(e|0,g|0,f|0)|0;e=(k[H>>2]|0)+f|0;k[H>>2]=e;g=g+f|0;d=d-f|0;c=k[I>>2]|0}if((e|0)==(c|0))Uh[k[(k[X>>2]|0)+20>>2]&2047](X)}while((d|0)!=0)}if((O|0)>0){B=b+16|0;x=b+44|0;y=(u|0)==2;z=(t|0)==8;A=L|t>>>0>8;w=(t|0)==16;a=(u|0)==0;n=aa(M,N<<1)|0;o=(n|0)>0;p=aa(M,N)|0;q=(p|0)>0;s=(N|0)>0;u=D+(N*6|0)|0;v=D+(N<<2)|0;b=(N|0)>0;t=(K|0)==0;h=0;while(1){f=(k[B>>2]|0)+(aa(k[k[x>>2]>>2]|0,h)|0)|0;if(G){c:do if(y){if(!z){if(b){d=0;c=D;e=f}else{J=61;break}while(1){g=j[e+2>>1]|0;J=j[e+4>>1]|0;j[c+4>>1]=j[e>>1]|0;j[c+2>>1]=g;j[c>>1]=J;d=d+1|0;if((d|0)==(N|0)){J=61;break c}else{c=c+6|0;e=e+6|0}}}if((N|0)>0){d=0;c=D;e=f;while(1){_=i[e+1>>0]|0;g=i[e+2>>0]|0;i[c+2>>0]=i[e>>0]|0;i[c+1>>0]=_;i[c>>0]=g;d=d+1|0;if((d|0)>=(N|0))break;else{c=c+3|0;e=e+3|0}}}}else J=61;while(0);if((J|0)==61?(J=0,w):0){if(a)upb(D|0,f|0,K|0)|0;if(o){d=0;do{e=D+d|0;g=i[e>>0]|0;_=D+(d|1)|0;i[e>>0]=i[_>>0]|0;i[_>>0]=g;d=d+2|0}while((d|0)<(n|0))}}if(!t){e=A?D:f;g=K;do{d=k[I>>2]|0;c=k[H>>2]|0;f=d-c|0;f=(f|0)>(g|0)?g:f;if((f|0)>0){upb(c|0,e|0,f|0)|0;c=(k[H>>2]|0)+f|0;k[H>>2]=c;e=e+f|0;g=g-f|0;d=k[I>>2]|0}if((c|0)==(d|0))Uh[k[(k[X>>2]|0)+20>>2]&2047](X)}while((g|0)!=0)}}else{d:do if(L){if(z){if(q){c=D;e=0}else{d=D;break}while(1){k[V>>2]=l[f+(e+2)>>0];Cfb(c,359128,V);k[W>>2]=l[f+(e+1)>>0];Cfb(c+4|0,359128,W);k[P>>2]=l[f+e>>0];Cfb(c+8|0,359128,P);i[c+12>>0]=32;d=c+14|0;i[c+13>>0]=32;e=e+M|0;if((e|0)>=(p|0))break d;else c=d}}if(q){c=D;e=0;while(1){k[Q>>2]=m[f+(e+2<<1)>>1];Cfb(c,359133,Q);k[R>>2]=m[f+(e+1<<1)>>1];Cfb(c+6|0,359133,R);k[S>>2]=m[f+(e<<1)>>1];Cfb(c+12|0,359133,S);i[c+18>>0]=32;d=c+20|0;i[c+19>>0]=32;e=e+M|0;if((e|0)>=(p|0))break;else c=d}}else d=D}else{if(z){if(s){d=D;c=0}else{d=D;break}while(1){k[T>>2]=l[f+c>>0];Cfb(d,359128,T);c=c+1|0;if((c|0)==(N|0)){d=v;break d}else d=d+4|0}}if(s){d=D;c=0;while(1){k[U>>2]=m[f+(c<<1)>>1];Cfb(d,359133,U);c=c+1|0;if((c|0)==(N|0)){d=u;break}else d=d+6|0}}else d=D}while(0);i[d>>0]=10;d=d+1-C|0;if(d|0){g=D;do{c=k[I>>2]|0;e=k[H>>2]|0;f=c-e|0;f=(f|0)>(d|0)?d:f;if((f|0)>0){upb(e|0,g|0,f|0)|0;e=(k[H>>2]|0)+f|0;k[H>>2]=e;g=g+f|0;d=d-f|0;c=k[I>>2]|0}if((e|0)==(c|0))Uh[k[(k[X>>2]|0)+20>>2]&2047](X)}while((d|0)!=0)}}h=h+1|0;if((h|0)>=(O|0)){d=X;break}}}else d=X;Uh[k[(k[d>>2]|0)+16>>2]&2047](X);d=k[Y>>2]|0;if((d|0)!=(E|0)){if(d|0)ggb(d);k[Y>>2]=E;k[F>>2]=1032}_=1;Cxa(X);r=Z;return _|0}function bxa(a,b){a=a|0;b=b|0;var c=0,d=0;while(1){b=fgb(36)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}cxa(b);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=89532;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function cxa(a){a=a|0;var b=0,c=0,d=0;k[a+28>>2]=0;k[a+32>>2]=0;d=a+24|0;i[d>>0]=0;b=a+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[a>>2]=90068;b=a+4|0;c=a+8|0;k[c>>2]=0;k[b>>2]=0;a=ZT(60)|0;k[a>>2]=1;k[b>>2]=a+4;k[c>>2]=53;i[a+57>>0]=0;a=k[b>>2]|0;b=359060;c=a+53|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));i[d>>0]=1;return}function dxa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90112;b=a+96|0;k[b>>2]=90256;c=a+116|0;d=k[c>>2]|0;if(d|0){Qfb(d)|0;k[c>>2]=0}i[a+128>>0]=0;if(!(i[a+100>>0]|0)){k[a+112>>2]=0;k[a+108>>2]=0;k[a+104>>2]=0}Uh[k[(k[b>>2]|0)+24>>2]&2047](b);Tva(a);return}function exa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90112;b=a+96|0;k[b>>2]=90256;c=a+116|0;d=k[c>>2]|0;if(d|0){Qfb(d)|0;k[c>>2]=0}i[a+128>>0]=0;if(!(i[a+100>>0]|0)){k[a+112>>2]=0;k[a+108>>2]=0;k[a+104>>2]=0}Uh[k[(k[b>>2]|0)+24>>2]&2047](b);Tva(a);ggb(a);return}function fxa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+768|0;o=s;n=a+96|0;if(!(Hh[k[(k[n>>2]|0)+8>>2]&511](n,a+20|0)|0)){q=0;r=s;return q|0}q=a+112|0;k[q>>2]=(k[q>>2]|0)+4;b=Pxa(n)|0;l=a+4|0;k[l>>2]=b;b=Pxa(n)|0;m=a+8|0;k[m>>2]=b;b=Pxa(n)|0;p=a+1156|0;k[p>>2]=b;b=3<<b;k[q>>2]=(k[q>>2]|0)+4;g=Pxa(n)|0;c=a+1164|0;k[c>>2]=g;g=Pxa(n)|0;d=a+1168|0;k[d>>2]=g;g=Pxa(n)|0;j=a+1172|0;k[j>>2]=g;a:do if((k[l>>2]|0)>0?(k[m>>2]|0)>0:0){e=k[p>>2]|0;switch(e|0){case 32:case 24:case 8:case 1:break;default:break a}b:do if((k[c>>2]|0)>>>0>=2){switch(k[a+12>>2]|0){case 3:break b;case 2:break;default:break a}if((e|0)!=8)break a}while(0);switch(k[d>>2]|0){case 0:{if(g|0)break a;zpb(a+132|0,0,1024)|0;break}case 1:{if(!((g|0)<=(b|0)&(g|0)>0&(e|0)<9))break a;zpb(a+132|0,0,1024)|0;if(g|0){h=a+108|0;b=k[q>>2]|0;d=0;f=o;c=b;while(1){b=(k[h>>2]|0)-b|0;b=(b|0)>(g|0)?g:b;if((b|0)<=0)do{Uh[k[(k[n>>2]|0)+20>>2]&2047](n);c=k[q>>2]|0;b=(k[h>>2]|0)-c|0;b=(b|0)>(g|0)?g:b}while((b|0)<=0);upb(f|0,c|0,b|0)|0;e=(k[q>>2]|0)+b|0;k[q>>2]=e;c=g-b|0;d=b+d|0;if((c|0)>0){f=f+b|0;g=c;c=e;b=e}else break}b=k[j>>2]|0;if((d|0)!=(b|0))break a;d=(b|0)/3|0;if((b|0)>2){c=d<<1;b=0;do{i[a+132+(b<<2)>>0]=i[o+(b+c)>>0]|0;i[a+132+(b<<2)+1>>0]=i[o+(b+d)>>0]|0;i[a+132+(b<<2)+2>>0]=i[o+b>>0]|0;i[a+132+(b<<2)+3>>0]=0;b=b+1|0}while((b|0)<(d|0))}p=k[p>>2]|0;c=1<<p;c:do if((p|0)==31)b=0;else{b=0;while(1){d=i[a+132+(b<<2)>>0]|0;if(d<<24>>24!=(i[a+132+(b<<2)+1>>0]|0)){b=16;break c}if(d<<24>>24!=(i[a+132+(b<<2)+2>>0]|0)){b=16;break c}b=b+1|0;if((b|0)>=(c|0)){b=0;break}}}while(0);k[a+12>>2]=b;k[a+1160>>2]=(k[q>>2]|0)+(k[a+124>>2]|0)-(k[a+104>>2]|0);q=1;r=s;return q|0}break}default:break a}p=(e|0)>8?16:0;k[a+12>>2]=p;if((p>>>3|1|0)==1?(f=1<<e,(e|0)!=31):0){c=f+-1|0;b=0;do{p=((b*255|0)/(c|0)|0)&255;i[a+132+(b<<2)+2>>0]=p;i[a+132+(b<<2)+1>>0]=p;i[a+132+(b<<2)>>0]=p;i[a+132+(b<<2)+3>>0]=0;b=b+1|0}while((b|0)<(f|0))}k[a+1160>>2]=(k[q>>2]|0)+(k[a+124>>2]|0)-(k[a+104>>2]|0);q=1;r=s;return q|0}while(0);k[a+1160>>2]=-1;k[m>>2]=-1;k[l>>2]=-1;Uh[k[(k[n>>2]|0)+16>>2]&2047](n);q=0;r=s;return q|0}function gxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+2336|0;x=I+2080|0;H=I+1040|0;G=I;w=(k[b>>2]&4088|0)!=0;f=k[b+16>>2]|0;C=k[b+48>>2]|0;u=a+4|0;b=k[u>>2]|0;g=a+1156|0;t=(((aa(k[g>>2]|0,b)|0)+7|0)/8|0)+1&-2;v=w?3:1;h=aa(b,v)|0;d=a+1160|0;if((k[d>>2]|0)<0){H=0;r=I;return H|0}D=a+96|0;if(!(i[a+128>>0]|0)){H=0;r=I;return H|0}c=t+32|0;E=H+8|0;k[H>>2]=E;F=H+4|0;k[F>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[H>>2]=b;y=b;b=k[u>>2]|0}else y=E;k[F>>2]=c;c=(b*3|0)+32|0;A=G+8|0;k[G>>2]=A;B=G+4|0;k[B>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[G>>2]=b;j=b}else j=A;k[B>>2]=c;if((!w?(k[a+1168>>2]|0)==1:0)?(z=k[g>>2]|0,e=1<<z,(z|0)!=31):0){b=0;do{z=a+132+(b<<2)|0;i[x+b>>0]=(((l[z>>0]|0)*1868|0)+8192+((l[z+1>>0]|0)*9617|0)+((l[z+2>>0]|0)*4899|0)|0)>>>14;b=b+1|0}while((b|0)!=(e|0))}b=k[d>>2]|0;if(!(k[a+116>>2]|0)){c=b;b=0}else{z=(b|0)%(k[a+120>>2]|0)|0;c=z;b=b-z|0}s=(k[a+104>>2]|0)+c|0;k[a+124>>2]=b;z=a+112|0;k[z>>2]=s;a:do switch(k[g>>2]|0){case 1:{if((k[a+12>>2]|0)!=2){n=a+8|0;if((k[n>>2]|0)<=0){c=1;break a}j=a+132|0;o=(t|0)>0;m=a+108|0;if(w){h=0;while(1){if(o){c=k[z>>2]|0;g=y;e=t;b=c;while(1){b=(k[m>>2]|0)-b|0;b=(b|0)>(e|0)?e:b;if((b|0)<=0)do{Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0;b=(k[m>>2]|0)-c|0;b=(b|0)>(e|0)?e:b}while((b|0)<=0);upb(g|0,c|0,b|0)|0;d=(k[z>>2]|0)+b|0;k[z>>2]=d;c=e-b|0;if((c|0)>0){g=g+b|0;e=c;b=d;c=d}else break}}dya(f,y,k[u>>2]|0,j);h=h+1|0;if((h|0)>=(k[n>>2]|0)){c=1;break a}else f=f+C|0}}else{h=0;while(1){if(o){c=k[z>>2]|0;g=y;e=t;b=c;while(1){b=(k[m>>2]|0)-b|0;b=(b|0)>(e|0)?e:b;if((b|0)<=0)do{Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0;b=(k[m>>2]|0)-c|0;b=(b|0)>(e|0)?e:b}while((b|0)<=0);upb(g|0,c|0,b|0)|0;d=(k[z>>2]|0)+b|0;k[z>>2]=d;c=e-b|0;if((c|0)>0){g=g+b|0;e=c;b=d;c=d}else break}}eya(f,y,k[u>>2]|0,x);h=h+1|0;if((h|0)>=(k[n>>2]|0)){c=1;break a}else f=f+C|0}}}o=y+(((k[u>>2]|0)+7|0)/8|0)|0;p=o;m=a+132|0;q=a+8|0;n=a+108|0;if(w){h=f;j=0;while(1){b=y;do{f=p-b|0;g=0;while(1){c=k[z>>2]|0;if(c>>>0>=(k[n>>2]|0)>>>0){Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0}e=i[c>>0]|0;c=c+1|0;k[z>>2]=c;if(e<<24>>24==-128){if(c>>>0>=(k[n>>2]|0)>>>0){Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0}d=i[c>>0]|0;c=c+1|0;k[z>>2]=c;if(d<<24>>24){e=47;break}}i[b+g>>0]=e;c=g+1|0;if((c|0)<(f|0))g=c;else{e=46;break}}if((e|0)==46)b=b+c|0;else if((e|0)==47){f=d&255;d=b+g|0;e=f+1|0;if(c>>>0<(k[n>>2]|0)>>>0)b=c;else{Uh[k[(k[D>>2]|0)+20>>2]&2047](D);b=k[z>>2]|0}c=i[b>>0]|0;k[z>>2]=b+1;if((f|0)>=(p-d|0)){c=0;break a}zpb(d|0,c|0,e|0)|0;b=d+e|0}}while(b>>>0<o>>>0);dya(h,y,k[u>>2]|0,m);j=j+1|0;if((j|0)>=(k[q>>2]|0)){c=1;break}else h=h+C|0}}else{h=f;j=0;while(1){b=y;do{f=p-b|0;g=0;while(1){c=k[z>>2]|0;if(c>>>0>=(k[n>>2]|0)>>>0){Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0}e=i[c>>0]|0;c=c+1|0;k[z>>2]=c;if(e<<24>>24==-128){if(c>>>0>=(k[n>>2]|0)>>>0){Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0}d=i[c>>0]|0;c=c+1|0;k[z>>2]=c;if(d<<24>>24){e=64;break}}i[b+g>>0]=e;c=g+1|0;if((c|0)<(f|0))g=c;else{e=63;break}}if((e|0)==63)b=b+c|0;else if((e|0)==64){f=d&255;d=b+g|0;e=f+1|0;if(c>>>0<(k[n>>2]|0)>>>0)b=c;else{Uh[k[(k[D>>2]|0)+20>>2]&2047](D);b=k[z>>2]|0}c=i[b>>0]|0;k[z>>2]=b+1;if((f|0)>=(p-d|0)){c=0;break a}zpb(d|0,c|0,e|0)|0;b=d+e|0}}while(b>>>0<o>>>0);eya(h,y,k[u>>2]|0,x);j=j+1|0;if((j|0)>=(k[q>>2]|0)){c=1;break}else h=h+C|0}}break}case 8:{if((k[a+12>>2]|0)!=2){j=a+8|0;if((k[j>>2]|0)<=0){c=1;break a}m=(t|0)>0;n=a+108|0;if(w){h=0;g=f}else{h=0;while(1){if(m){c=k[z>>2]|0;g=y;e=t;b=c;while(1){b=(k[n>>2]|0)-b|0;b=(b|0)>(e|0)?e:b;if((b|0)<=0)do{Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0;b=(k[n>>2]|0)-c|0;b=(b|0)>(e|0)?e:b}while((b|0)<=0);upb(g|0,c|0,b|0)|0;d=(k[z>>2]|0)+b|0;k[z>>2]=d;c=e-b|0;if((c|0)>0){g=g+b|0;e=c;b=d;c=d}else break}}c=k[u>>2]|0;if((c|0)>0){b=0;do{i[f+b>>0]=i[x+(l[y+b>>0]|0)>>0]|0;b=b+1|0}while((b|0)!=(c|0))}h=h+1|0;if((h|0)>=(k[j>>2]|0)){c=1;break a}else f=f+C|0}}while(1){if(m){c=k[z>>2]|0;f=y;e=t;b=c;while(1){b=(k[n>>2]|0)-b|0;b=(b|0)>(e|0)?e:b;if((b|0)<=0)do{Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0;b=(k[n>>2]|0)-c|0;b=(b|0)>(e|0)?e:b}while((b|0)<=0);upb(f|0,c|0,b|0)|0;d=(k[z>>2]|0)+b|0;k[z>>2]=d;c=e-b|0;if((c|0)>0){f=f+b|0;e=c;b=d;c=d}else break}}x=(k[u>>2]|0)*3|0;f=g+x|0;if((x|0)>3){e=y;d=g;c=g+3|0;while(1){b=e+1|0;x=a+132+(l[e>>0]<<2)|0;x=l[x>>0]|l[x+1>>0]<<8|l[x+2>>0]<<16|l[x+3>>0]<<24;i[d>>0]=x;i[d+1>>0]=x>>8;i[d+2>>0]=x>>16;i[d+3>>0]=x>>24;d=c+3|0;if(d>>>0<f>>>0){x=c;e=b;c=d;d=x}else break}}else{c=g;b=y}v=l[b>>0]|0;w=i[a+132+(v<<2)+1>>0]|0;x=i[a+132+(v<<2)+2>>0]|0;i[c>>0]=i[a+132+(v<<2)>>0]|0;i[c+1>>0]=w;i[c+2>>0]=x;h=h+1|0;if((h|0)>=(k[j>>2]|0)){c=1;break a}else g=g+C|0}}q=y;s=a+8|0;t=0-h|0;u=a+108|0;o=f+h|0;b=f;n=0;while(1){c=y;g=o-b|0;while(1){d=k[z>>2]|0;if(d>>>0>=(k[u>>2]|0)>>>0){Uh[k[(k[D>>2]|0)+20>>2]&2047](D);d=k[z>>2]|0}f=i[d>>0]|0;d=d+1|0;k[z>>2]=d;if(f<<24>>24==-128){if(d>>>0>=(k[u>>2]|0)>>>0){Uh[k[(k[D>>2]|0)+20>>2]&2047](D);d=k[z>>2]|0}e=i[d>>0]|0;k[z>>2]=d+1;if(e<<24>>24){j=e&255;break}}d=c+1|0;i[c>>0]=f;g=g-v|0;if((g|0)<=0){c=d;j=0;break}else c=d}h=c-q|0;if((h|0)>0){if(w){p=h*3|0;g=b+p|0;if((p|0)>3){f=y;e=b;d=b+3|0;while(1){c=f+1|0;p=a+132+(l[f>>0]<<2)|0;p=l[p>>0]|l[p+1>>0]<<8|l[p+2>>0]<<16|l[p+3>>0]<<24;i[e>>0]=p;i[e+1>>0]=p>>8;i[e+2>>0]=p>>16;i[e+3>>0]=p>>24;e=d+3|0;if(e>>>0<g>>>0){p=d;f=c;d=e;e=p}else break}}else{d=b;c=y}g=l[c>>0]|0;m=i[a+132+(g<<2)+1>>0]|0;p=i[a+132+(g<<2)+2>>0]|0;i[d>>0]=i[a+132+(g<<2)>>0]|0;i[d+1>>0]=m;i[d+2>>0]=p}else{c=0;do{i[b+c>>0]=i[x+(l[y+c>>0]|0)>>0]|0;c=c+1|0}while((c|0)!=(h|0))}b=b+(aa(h,v)|0)|0}if(j){e=aa(j+1|0,v)|0;c=k[z>>2]|0;if(c>>>0>=(k[u>>2]|0)>>>0){Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0}d=l[c>>0]|0;k[z>>2]=c+1;p=k[s>>2]|0;b:do if(w){m=a+132+(d<<2)|0;m=l[m>>0]|l[m+1>>0]<<8|l[m+2>>0]<<16|l[m+3>>0]<<24;h=m&255;j=m>>>8&255;m=m>>>16&255;g=e;d=o;c=n;e=o;do{f=b+g|0;f=f>>>0>e>>>0?e:f;g=b-f+g|0;if(b>>>0<f>>>0){do{i[b>>0]=h;i[b+1>>0]=j;i[b+2>>0]=m;b=b+3|0}while(b>>>0<f>>>0);e=d}if(b>>>0>=e>>>0){e=e+C|0;b=e+t|0;c=c+1|0;if((c|0)<(p|0))d=e;else{d=e;break b}}}while((g|0)>0)}else{m=i[x+d>>0]|0;j=e;c=n;d=o;g=o;while(1){e=b;f=b+j|0;h=f>>>0>g>>>0?g:f;j=e-h+j|0;if(b>>>0<h>>>0){n=g;o=f;zpb(b|0,m|0,~e-~(o>>>0>n>>>0?n:o)|0)|0;do b=b+1|0;while(b>>>0<h>>>0);e=d}else e=g;if(b>>>0>=e>>>0){e=e+C|0;b=e+t|0;c=c+1|0;if((c|0)<(p|0))d=e;else{d=e;break b}}if((j|0)<=0)break;else g=e}}while(0);if((c|0)>=(k[s>>2]|0)){c=1;break a}}else{c=n;d=o}if((b|0)!=(d|0)){o=d;n=c;continue}b=k[z>>2]|0;if(b>>>0>=(k[u>>2]|0)>>>0){Uh[k[(k[D>>2]|0)+20>>2]&2047](D);b=k[z>>2]|0}p=i[b>>0]|0;k[z>>2]=b+1;if(p<<24>>24){c=0;break a}b=d+C|0;n=c+1|0;if((n|0)>=(k[s>>2]|0)){c=1;break}else{o=b;b=b+t|0}}break}case 24:{n=a+8|0;if((k[n>>2]|0)>0){o=a+12|0;p=(t|0)>0;m=a+108|0;if(w)h=0;else{g=f;h=0;while(1){if(p){c=k[z>>2]|0;f=j;e=t;b=c;while(1){b=(k[m>>2]|0)-b|0;b=(b|0)>(e|0)?e:b;if((b|0)<=0)do{Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0;b=(k[m>>2]|0)-c|0;b=(b|0)>(e|0)?e:b}while((b|0)<=0);upb(f|0,c|0,b|0)|0;d=(k[z>>2]|0)+b|0;k[z>>2]=d;c=e-b|0;if((c|0)>0){f=f+b|0;e=c;b=d;c=d}else break}}d=k[u>>2]|0;e=(k[o>>2]|0)==3?2:0;f=e^2;if((d|0)>0){b=0;c=j;while(1){i[g+b>>0]=(((l[c+e>>0]|0)*1868|0)+8192+((l[c+1>>0]|0)*9617|0)+((l[c+f>>0]|0)*4899|0)|0)>>>14;b=b+1|0;if((b|0)>=(d|0))break;else c=c+3|0}}h=h+1|0;if((h|0)>=(k[n>>2]|0)){c=1;break a}else g=g+C|0}}while(1){if(p){c=k[z>>2]|0;g=f;e=t;b=c;while(1){b=(k[m>>2]|0)-b|0;b=(b|0)>(e|0)?e:b;if((b|0)<=0)do{Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0;b=(k[m>>2]|0)-c|0;b=(b|0)>(e|0)?e:b}while((b|0)<=0);upb(g|0,c|0,b|0)|0;d=(k[z>>2]|0)+b|0;k[z>>2]=d;c=e-b|0;if((c|0)>0){g=g+b|0;e=c;b=d;c=d}else break}}if((k[o>>2]|0)==3?(q=k[u>>2]|0,(q|0)>0):0){b=0;c=f;d=f;while(1){x=i[d+1>>0]|0;y=i[d+2>>0]|0;i[c+2>>0]=i[d>>0]|0;i[c+1>>0]=x;i[c>>0]=y;b=b+1|0;if((b|0)>=(q|0))break;else{c=c+3|0;d=d+3|0}}}h=h+1|0;if((h|0)>=(k[n>>2]|0)){c=1;break}else f=f+C|0}}else c=1;break}case 32:{q=a+8|0;if((k[q>>2]|0)>0){s=y+3|0;n=y+4|0;o=a+12|0;p=(t|0)>0;m=a+108|0;if(w){h=f;j=0;while(1){if(p){c=k[z>>2]|0;f=s;e=t;b=c;while(1){b=(k[m>>2]|0)-b|0;b=(b|0)>(e|0)?e:b;if((b|0)<=0)do{Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0;b=(k[m>>2]|0)-c|0;b=(b|0)>(e|0)?e:b}while((b|0)<=0);upb(f|0,c|0,b|0)|0;d=(k[z>>2]|0)+b|0;k[z>>2]=d;c=e-b|0;if((c|0)>0){f=f+b|0;e=c;b=d;c=d}else break}}e=k[u>>2]|0;f=(k[o>>2]|0)==3?2:0;g=f^2;if((e|0)>0){b=0;c=h;d=n;while(1){y=i[d+1>>0]|0;i[c>>0]=i[d+f>>0]|0;i[c+1>>0]=y;i[c+2>>0]=i[d+g>>0]|0;b=b+1|0;if((b|0)>=(e|0))break;else{c=c+3|0;d=d+4|0}}}j=j+1|0;if((j|0)>=(k[q>>2]|0)){c=1;break}else h=h+C|0}}else{g=f;h=0;while(1){if(p){c=k[z>>2]|0;f=s;e=t;b=c;while(1){b=(k[m>>2]|0)-b|0;b=(b|0)>(e|0)?e:b;if((b|0)<=0)do{Uh[k[(k[D>>2]|0)+20>>2]&2047](D);c=k[z>>2]|0;b=(k[m>>2]|0)-c|0;b=(b|0)>(e|0)?e:b}while((b|0)<=0);upb(f|0,c|0,b|0)|0;d=(k[z>>2]|0)+b|0;k[z>>2]=d;c=e-b|0;if((c|0)>0){f=f+b|0;e=c;b=d;c=d}else break}}d=k[u>>2]|0;e=(k[o>>2]|0)==3?2:0;f=e^2;if((d|0)>0){b=0;c=n;while(1){i[g+b>>0]=(((l[c+e>>0]|0)*1868|0)+8192+((l[c+1>>0]|0)*9617|0)+((l[c+f>>0]|0)*4899|0)|0)>>>14;b=b+1|0;if((b|0)>=(d|0))break;else c=c+4|0}}h=h+1|0;if((h|0)>=(k[q>>2]|0)){c=1;break}else g=g+C|0}}}else c=1;break}default:c=0}while(0);b=k[G>>2]|0;if((b|0)!=(A|0)){if(b|0)ggb(b);k[G>>2]=A;k[B>>2]=1032}b=k[H>>2]|0;if((b|0)!=(E|0)){if(b|0)ggb(b);k[H>>2]=E;k[F>>2]=1032}H=c;r=I;return H|0}function hxa(a,b){a=a|0;b=b|0;var c=0,d=0;while(1){b=fgb(1176)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}ixa(b);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=89472;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function ixa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+20|0;k[b>>2]=0;k[b+4>>2]=0;k[a+36>>2]=1124007936;b=a+44|0;c=a+76|0;d=a+40|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;e=a+84|0;k[a+80>>2]=e;k[a+88>>2]=0;k[e>>2]=0;k[a+8>>2]=0;k[a+4>>2]=0;k[a+12>>2]=-1;i[a+92>>0]=0;k[a+16>>2]=1;k[a>>2]=90112;e=a+104|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;k[a+120>>2]=32768;i[a+128>>0]=0;i[a+100>>0]=0;k[a+96>>2]=90376;k[a+1160>>2]=-1;e=a+28|0;c=a+32|0;k[c>>2]=0;k[e>>2]=0;d=ZT(12)|0;k[d>>2]=1;k[e>>2]=d+4;k[c>>2]=4;i[d+8>>0]=0;e=k[e>>2]|0;i[e>>0]=-1788172711;i[e+1>>0]=-1788172711>>8;i[e+2>>0]=-1788172711>>16;i[e+3>>0]=-1788172711>>24;return}function jxa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1)return;ggb(k[b+-8>>2]|0);return}function kxa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b){ggb(a);return}c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function lxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+48|0;o=q;h=k[b+12>>2]|0;p=k[b+8>>2]|0;g=((k[b>>2]|0)>>>3&511)+1|0;l=(aa(g,h)|0)+1&-2;m=o+12|0;k[m>>2]=0;n=o+8|0;k[n>>2]=0;c=o+4|0;k[c>>2]=0;f=o+24|0;k[f>>2]=0;k[o+16>>2]=32768;d=o+28|0;i[d>>0]=0;k[o+32>>2]=0;k[o>>2]=90456;Gxa(o);Uh[k[(k[o>>2]|0)+28>>2]&2047](o);j=k[a+12>>2]|0;j=Ufb((j|0)==0?1016759:j,377117)|0;k[f>>2]=j;if(!j){p=0;Cxa(o);r=q;return p|0}i[d>>0]=1;k[o+20>>2]=0;d=k[c>>2]|0;k[m>>2]=d;a=359210;f=4;while(1){c=k[n>>2]|0;e=c-d|0;e=(e|0)>(f|0)?f:e;if((e|0)>0){upb(d|0,a|0,e|0)|0;d=(k[m>>2]|0)+e|0;k[m>>2]=d;a=a+e|0;f=f-e|0;c=k[n>>2]|0}if((d|0)==(c|0))Uh[k[(k[o>>2]|0)+20>>2]&2047](o);if(!f)break;d=k[m>>2]|0}Rxa(o,h);Rxa(o,p);Rxa(o,g<<3);Rxa(o,aa(l,p)|0);Rxa(o,1);Rxa(o,0);Rxa(o,0);if((p|0)>0){j=b+16|0;h=b+44|0;b=(l|0)==0;g=0;do{if(!b){a=(k[j>>2]|0)+(aa(k[k[h>>2]>>2]|0,g)|0)|0;f=l;do{c=k[n>>2]|0;d=k[m>>2]|0;e=c-d|0;e=(e|0)>(f|0)?f:e;if((e|0)>0){upb(d|0,a|0,e|0)|0;d=(k[m>>2]|0)+e|0;k[m>>2]=d;a=a+e|0;f=f-e|0;c=k[n>>2]|0}if((d|0)==(c|0))Uh[k[(k[o>>2]|0)+20>>2]&2047](o)}while((f|0)!=0)}g=g+1|0}while((g|0)<(p|0))}Uh[k[(k[o>>2]|0)+16>>2]&2047](o);p=1;Cxa(o);r=q;return p|0}function mxa(a,b){a=a|0;b=b|0;var c=0,d=0;while(1){b=fgb(36)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}nxa(b);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=89492;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function nxa(a){a=a|0;var b=0,c=0;k[a+28>>2]=0;k[a+32>>2]=0;i[a+24>>0]=0;b=a+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[a>>2]=90168;b=a+4|0;c=a+8|0;k[c>>2]=0;k[b>>2]=0;a=ZT(36)|0;k[a>>2]=1;k[b>>2]=a+4;k[c>>2]=29;i[a+33>>0]=0;a=k[b>>2]|0;b=359180;c=a+29|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));return}function oxa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1)return;ggb(k[b+-8>>2]|0);return}function pxa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b){ggb(a);return}c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function qxa(a,b){a=a|0;b=b|0;return (b|2|0)==2|0}function rxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;U=r;r=r+3200|0;T=U+3152|0;S=U+2088|0;R=U+1040|0;Q=U;P=k[b>>2]|0;s=P>>>3;z=s&511;E=z+1|0;C=k[b+12>>2]|0;D=k[b+8>>2]|0;c=P&7;switch(P&7){case 0:case 2:break;default:{T=0;r=U;return T|0}}x=(c|0)==0;q=x?1:2;y=aa(aa(E,C)|0,q)|0;H=T+12|0;k[H>>2]=0;I=T+8|0;k[I>>2]=0;B=T+4|0;k[B>>2]=0;c=T+24|0;k[c>>2]=0;k[T+16>>2]=32768;d=T+28|0;i[d>>0]=0;e=T+32|0;k[e>>2]=0;k[T>>2]=90416;J=a+20|0;f=k[J>>2]|0;Gxa(T);Uh[k[(k[T>>2]|0)+28>>2]&2047](T);if(!f){P=k[a+12>>2]|0;P=Ufb((P|0)==0?1016759:P,377117)|0;k[c>>2]=P;if(!P)c=0;else{i[d>>0]=1;k[T+20>>2]=0;k[H>>2]=k[B>>2];A=6}}else{k[e>>2]=f;i[d>>0]=1;k[T+20>>2]=0;k[H>>2]=k[B>>2];A=6}if((A|0)==6){F=8192/(y|0)|0;F=(F|0)<1?1:F;F=(F|0)>(D|0)?D:F;G=(D+-1+F|0)/(F|0)|0;f=k[J>>2]|0;if(f|0?(l=(aa(y,D)|0)+511+(G<<3)&-256,n=f+8|0,o=k[f>>2]|0,p=o,((k[n>>2]|0)-o|0)>>>0<l>>>0):0){g=f+4|0;h=(k[g>>2]|0)-o|0;a:do if(!l)c=0;else while(1){c=fgb(l)|0;if(c|0)break a;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break a}Qh[c&7]()}while(0);d=c+h|0;e=d+(0-h)|0;if((h|0)>0)upb(e|0,p|0,h|0)|0;k[f>>2]=e;k[g>>2]=d;k[n>>2]=c+l;if(o|0)ggb(p)}O=S+8|0;k[S>>2]=O;P=S+4|0;k[P>>2]=264;if(G>>>0>264){d=G>>>0>1073741823?-1:G<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[S>>2]=c}k[P>>2]=G;M=R+8|0;k[R>>2]=M;N=R+4|0;k[N>>2]=520;if(G>>>0>520){d=G>>>0>2147483647?-1:G<<1;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[R>>2]=c}k[N>>2]=G;e=y+32|0;K=Q+8|0;k[Q>>2]=K;L=Q+4|0;k[L>>2]=1032;if(e>>>0>1032){while(1){d=fgb(e)|0;if(d|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){d=0;break}Qh[c&7]()}k[Q>>2]=d}else d=K;k[L>>2]=e;w=q<<3;f=359265;h=4;do{c=k[I>>2]|0;e=k[H>>2]|0;g=c-e|0;g=(g|0)>(h|0)?h:g;if((g|0)>0){upb(e|0,f|0,g|0)|0;e=(k[H>>2]|0)+g|0;k[H>>2]=e;f=f+g|0;h=h-g|0;c=k[I>>2]|0}if((e|0)==(c|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while((h|0)!=0);Qxa(T,0);b:do if((G|0)>0){v=s&65535;t=(z|0)==0;u=b+16|0;p=b+44|0;b=T+20|0;q=(y|0)==0;s=(C|0)>0;c=0;o=0;g=k[b>>2]|0;h=k[H>>2]|0;l=k[B>>2]|0;e=k[S>>2]|0;while(1){n=c+F|0;n=(n|0)>(D|0)?D:n;k[e+(o<<2)>>2]=h+g-l;c:do if((c|0)<(n|0))switch(v&511){case 2:{if(x){do{e=(k[u>>2]|0)+(aa(k[k[p>>2]>>2]|0,c)|0)|0;if((C|0)>0){f=0;g=d;while(1){h=i[e+1>>0]|0;l=i[e+2>>0]|0;i[g+2>>0]=i[e>>0]|0;i[g+1>>0]=h;i[g>>0]=l;f=f+1|0;if((f|0)>=(C|0))break;else{g=g+3|0;e=e+3|0}}}if(!q){g=d;l=y;do{e=k[I>>2]|0;f=k[H>>2]|0;h=e-f|0;h=(h|0)>(l|0)?l:h;if((h|0)>0){upb(f|0,g|0,h|0)|0;f=(k[H>>2]|0)+h|0;k[H>>2]=f;g=g+h|0;l=l-h|0;e=k[I>>2]|0}if((f|0)==(e|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while((l|0)!=0)}c=c+1|0}while((c|0)<(n|0));f=c}else{do{e=(k[u>>2]|0)+(aa(k[k[p>>2]>>2]|0,c)|0)|0;if(s){f=0;g=d;while(1){h=j[e+2>>1]|0;l=j[e+4>>1]|0;j[g+4>>1]=j[e>>1]|0;j[g+2>>1]=h;j[g>>1]=l;f=f+1|0;if((f|0)==(C|0))break;else{g=g+6|0;e=e+6|0}}}if(!q){g=d;l=y;do{e=k[I>>2]|0;f=k[H>>2]|0;h=e-f|0;h=(h|0)>(l|0)?l:h;if((h|0)>0){upb(f|0,g|0,h|0)|0;f=(k[H>>2]|0)+h|0;k[H>>2]=f;g=g+h|0;l=l-h|0;e=k[I>>2]|0}if((f|0)==(e|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while((l|0)!=0)}c=c+1|0}while((c|0)<(n|0));f=c}break}case 3:{do{e=(k[u>>2]|0)+(aa(k[k[p>>2]>>2]|0,c)|0)|0;if(x){if((C|0)>0){f=0;g=d;while(1){h=i[e>>0]|0;V=i[e+1>>0]|0;l=i[e+3>>0]|0;i[g>>0]=i[e+2>>0]|0;i[g+1>>0]=V;i[g+2>>0]=h;i[g+3>>0]=l;f=f+1|0;if((f|0)>=(C|0))break;else{g=g+4|0;e=e+4|0}}}}else if(s){f=0;g=d;while(1){l=j[e>>1]|0;h=j[e+2>>1]|0;V=j[e+6>>1]|0;j[g>>1]=j[e+4>>1]|0;j[g+2>>1]=h;j[g+4>>1]=l;j[g+6>>1]=V;f=f+1|0;if((f|0)==(C|0))break;else{g=g+8|0;e=e+8|0}}}if(!q){g=d;l=y;do{e=k[I>>2]|0;f=k[H>>2]|0;h=e-f|0;h=(h|0)>(l|0)?l:h;if((h|0)>0){upb(f|0,g|0,h|0)|0;f=(k[H>>2]|0)+h|0;k[H>>2]=f;g=g+h|0;l=l-h|0;e=k[I>>2]|0}if((f|0)==(e|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while((l|0)!=0)}c=c+1|0}while((c|0)<(n|0));f=c;break}default:{if(!t)while(1){if(!q){g=d;l=y;do{e=k[I>>2]|0;f=k[H>>2]|0;h=e-f|0;h=(h|0)>(l|0)?l:h;if((h|0)>0){upb(f|0,g|0,h|0)|0;f=(k[H>>2]|0)+h|0;k[H>>2]=f;g=g+h|0;l=l-h|0;e=k[I>>2]|0}if((f|0)==(e|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while((l|0)!=0)}c=c+1|0;if((c|0)>=(n|0)){f=c;break c}}do{if(!q){g=(k[u>>2]|0)+(aa(k[k[p>>2]>>2]|0,c)|0)|0;l=y;do{e=k[I>>2]|0;f=k[H>>2]|0;h=e-f|0;h=(h|0)>(l|0)?l:h;if((h|0)>0){upb(f|0,g|0,h|0)|0;f=(k[H>>2]|0)+h|0;k[H>>2]=f;g=g+h|0;l=l-h|0;e=k[I>>2]|0}if((f|0)==(e|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while((l|0)!=0)}c=c+1|0}while((c|0)<(n|0));f=c}}else f=c;while(0);h=k[H>>2]|0;g=k[b>>2]|0;l=k[B>>2]|0;n=h+g-l|0;e=k[S>>2]|0;c=k[R>>2]|0;j[c+(o<<1)>>1]=n-(k[e+(o<<2)>>2]|0);o=o+1|0;if((o|0)>=(G|0))break;else c=f}if((G|0)>2)c=0;else{if((G|0)!=2){A=108;break}Qxa(T,k[e>>2]|0);Qxa(T,k[(k[S>>2]|0)+4>>2]|0);l=k[R>>2]|0;l=(m[l+2>>1]<<16)+(j[l>>1]|0)|0;break}while(1){Qxa(T,k[e+(c<<2)>>2]|0);c=c+1|0;if((c|0)>=(G|0))break;e=k[S>>2]|0}f=k[H>>2]|0;l=f+(k[b>>2]|0)-(k[B>>2]|0)|0;c=0;while(1){g=j[(k[R>>2]|0)+(c<<1)>>1]|0;h=g<<16>>16;e=f+1|0;g=g&255;if(e>>>0<(k[I>>2]|0)>>>0){i[f>>0]=g;i[e>>0]=h>>>8;V=f+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[f>>0]=g;e=k[H>>2]|0;if(e>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);e=k[H>>2]|0}k[H>>2]=e+1;i[e>>0]=h>>>8;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}c=c+1|0;if((c|0)>=(G|0))break b;f=k[H>>2]|0}}else{e=k[S>>2]|0;c=k[R>>2]|0;A=108}while(0);if((A|0)==108){l=j[c>>1]|0;n=k[e>>2]|0}o=(z|0)!=0;h=T+20|0;do if(o){c=k[H>>2]|0;g=c+(k[h>>2]|0)-(k[B>>2]|0)|0;e=c+1|0;f=w&255;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=f;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=f;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}c=k[H>>2]|0;e=c+1|0;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=f;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=f;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}c=k[H>>2]|0;e=c+1|0;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=f;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=f;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}if((E|0)==4){c=k[H>>2]|0;e=c+1|0;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=f;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)!=(k[I>>2]|0)){c=B;break}Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=B;break}k[H>>2]=e;i[c>>0]=f;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=B}else c=B}else c=B}else{g=w;c=B}while(0);e=k[H>>2]|0;p=e+(k[h>>2]|0)-(k[c>>2]|0)|0;c=e;e=c+1|0;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=9;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=9;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}c=k[H>>2]|0;e=c+1|0;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=0;i[e>>0]=1;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=0;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=1;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}c=k[H>>2]|0;e=c+1|0;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=4;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=4;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}Qxa(T,1);Qxa(T,C);c=k[H>>2]|0;e=c+1|0;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=1;i[e>>0]=1;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=1;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=1;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}c=k[H>>2]|0;e=c+1|0;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=4;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=4;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}Qxa(T,1);Qxa(T,D);c=k[H>>2]|0;e=c+1|0;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=2;i[e>>0]=1;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=2;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=1;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}c=k[H>>2]|0;e=c+1|0;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=3;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=3;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}Qxa(T,E);Qxa(T,g);c=k[H>>2]|0;e=c+1|0;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=3;i[e>>0]=1;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=3;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=1;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}c=k[H>>2]|0;e=c+1|0;if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=4;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=4;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0>=(k[I>>2]|0)>>>0)Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}Qxa(T,1);Qxa(T,1);f=o?2:1;c=k[H>>2]|0;e=c+1|0;do if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=6;i[e>>0]=1;V=c+2|0;k[H>>2]=V;if((V|0)==(k[I>>2]|0))Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=6;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=1;if((k[H>>2]|0)>>>0<(k[I>>2]|0)>>>0)break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while(0);c=k[H>>2]|0;e=c+1|0;do if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=3;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)!=(k[I>>2]|0))break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=3;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0<(k[I>>2]|0)>>>0)break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while(0);Qxa(T,1);Qxa(T,f);c=k[H>>2]|0;e=c+1|0;do if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=17;i[e>>0]=1;V=c+2|0;k[H>>2]=V;if((V|0)!=(k[I>>2]|0))break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=17;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=1;if((k[H>>2]|0)>>>0<(k[I>>2]|0)>>>0)break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while(0);c=k[H>>2]|0;e=c+1|0;do if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=4;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)!=(k[I>>2]|0))break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=4;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0<(k[I>>2]|0)>>>0)break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while(0);Qxa(T,G);Qxa(T,n);c=k[H>>2]|0;e=c+1|0;do if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=21;i[e>>0]=1;V=c+2|0;k[H>>2]=V;if((V|0)!=(k[I>>2]|0))break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=21;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=1;if((k[H>>2]|0)>>>0<(k[I>>2]|0)>>>0)break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while(0);c=k[H>>2]|0;e=c+1|0;do if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=3;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)!=(k[I>>2]|0))break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=3;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0<(k[I>>2]|0)>>>0)break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while(0);Qxa(T,1);Qxa(T,E);c=k[H>>2]|0;e=c+1|0;do if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=22;i[e>>0]=1;V=c+2|0;k[H>>2]=V;if((V|0)!=(k[I>>2]|0))break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=22;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=1;if((k[H>>2]|0)>>>0<(k[I>>2]|0)>>>0)break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while(0);c=k[H>>2]|0;e=c+1|0;do if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=4;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)!=(k[I>>2]|0))break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=4;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0<(k[I>>2]|0)>>>0)break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while(0);Qxa(T,1);Qxa(T,F);c=k[H>>2]|0;e=c+1|0;do if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=23;i[e>>0]=1;V=c+2|0;k[H>>2]=V;if((V|0)!=(k[I>>2]|0))break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=23;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=1;if((k[H>>2]|0)>>>0<(k[I>>2]|0)>>>0)break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while(0);c=k[H>>2]|0;e=c+1|0;f=(G|0)>1?3:4;do if(e>>>0<(k[I>>2]|0)>>>0){i[c>>0]=f;i[e>>0]=0;V=c+2|0;k[H>>2]=V;if((V|0)!=(k[I>>2]|0))break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}else{k[H>>2]=e;i[c>>0]=f;c=k[H>>2]|0;if(c>>>0>=(k[I>>2]|0)>>>0){Uh[k[(k[T>>2]|0)+20>>2]&2047](T);c=k[H>>2]|0}k[H>>2]=c+1;i[c>>0]=0;if((k[H>>2]|0)>>>0<(k[I>>2]|0)>>>0)break;Uh[k[(k[T>>2]|0)+20>>2]&2047](T)}while(0);Qxa(T,G);Qxa(T,l);Qxa(T,0);Uh[k[(k[T>>2]|0)+16>>2]&2047](T);c=k[J>>2]|0;if(!c){h=k[a+12>>2]|0;h=Ufb((h|0)==0?1016759:h,359270)|0;i[d>>0]=p;i[d+1>>0]=p>>>8;i[d+2>>0]=p>>>16;i[d+3>>0]=p>>>24;g=h+76|0;c=h+20|0;e=h+28|0;f=(k[c>>2]|0)>>>0>(k[e>>2]|0)>>>0;do if((k[g>>2]|0)>-1){if(f?(ci[k[h+36>>2]&255](h,0,0)|0,(k[c>>2]|0)==0):0)break;k[h+16>>2]=0;k[e>>2]=0;k[c>>2]=0;if((ci[k[h+40>>2]&255](h,4,0)|0)<0)break;k[h+8>>2]=0;k[h+4>>2]=0;k[h>>2]=k[h>>2]&-17}else{if(f?(ci[k[h+36>>2]&255](h,0,0)|0,(k[c>>2]|0)==0):0)break;k[h+16>>2]=0;k[e>>2]=0;k[c>>2]=0;if((ci[k[h+40>>2]&255](h,4,0)|0)<0)break;k[h+8>>2]=0;k[h+4>>2]=0;k[h>>2]=k[h>>2]&-17}while(0);f=h+16|0;e=k[f>>2]|0;c=(e|0)==0;d:do if((k[g>>2]|0)>-1){do if(c){c=h+74|0;V=i[c>>0]|0;i[c>>0]=V+255|V;c=k[h>>2]|0;if(!(c&8)){k[h+8>>2]=0;k[h+4>>2]=0;V=k[h+44>>2]|0;k[h+28>>2]=V;g=h+20|0;k[g>>2]=V;e=V+(k[h+48>>2]|0)|0;k[f>>2]=e;f=V;break}else{k[h>>2]=c|32;break d}}else{f=h+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<4){ci[k[h+36>>2]&255](h,d,4)|0;break}e:do if((i[h+75>>0]|0)>-1){f=4;while(1){if(!f){e=4;break e}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[h+36>>2]&255](h,d,f)|0)>>>0<f>>>0)break d;e=4-f|0;d=d+f|0;c=k[g>>2]|0}else e=4;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}else{do if(c){c=h+74|0;V=i[c>>0]|0;i[c>>0]=V+255|V;c=k[h>>2]|0;if(!(c&8)){k[h+8>>2]=0;k[h+4>>2]=0;V=k[h+44>>2]|0;k[h+28>>2]=V;g=h+20|0;k[g>>2]=V;e=V+(k[h+48>>2]|0)|0;k[f>>2]=e;f=V;break}else{k[h>>2]=c|32;break d}}else{f=h+20|0;g=f;f=k[f>>2]|0}while(0);c=f;if((e-f|0)>>>0<4){ci[k[h+36>>2]&255](h,d,4)|0;break}f:do if((i[h+75>>0]|0)>-1){f=4;while(1){if(!f){e=4;break f}e=f+-1|0;if((i[d+e>>0]|0)==10)break;else f=e}if((ci[k[h+36>>2]&255](h,d,f)|0)>>>0<f>>>0)break d;e=4-f|0;d=d+f|0;c=k[g>>2]|0}else e=4;while(0);upb(c|0,d|0,e|0)|0;k[g>>2]=(k[g>>2]|0)+e}while(0);Qfb(h)|0}else{i[(k[c>>2]|0)+4>>0]=p;i[(k[k[J>>2]>>2]|0)+5>>0]=p>>>8;i[(k[k[J>>2]>>2]|0)+6>>0]=p>>>16;i[(k[k[J>>2]>>2]|0)+7>>0]=p>>>24}c=k[Q>>2]|0;if((c|0)!=(K|0)){if(c|0)ggb(c);k[Q>>2]=K;k[L>>2]=1032}c=k[R>>2]|0;if((c|0)!=(M|0)){if(c|0)ggb(c);k[R>>2]=M;k[N>>2]=520}c=k[S>>2]|0;if((c|0)!=(O|0)){if(c|0)ggb(c);k[S>>2]=O;k[P>>2]=264}c=1}Cxa(T);V=c;r=U;return V|0}function sxa(a,b){a=a|0;b=b|0;var c=0,d=0;while(1){b=fgb(36)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}txa(b);while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=89552;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function txa(a){a=a|0;var b=0,c=0,d=0;k[a+28>>2]=0;k[a+32>>2]=0;d=a+24|0;i[d>>0]=0;b=a+4+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[a>>2]=90212;b=a+4|0;c=a+8|0;k[c>>2]=0;k[b>>2]=0;a=ZT(32)|0;k[a>>2]=1;k[b>>2]=a+4;k[c>>2]=25;i[a+29>>0]=0;a=k[b>>2]|0;b=359239;c=a+25|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));i[d>>0]=1;return}function uxa(a){a=a|0;var b=0,c=0;k[a>>2]=90256;b=a+20|0;c=k[b>>2]|0;if(c|0){Qfb(c)|0;k[b>>2]=0}i[a+32>>0]=0;if(!(i[a+4>>0]|0)){k[a+16>>2]=0;k[a+12>>2]=0;k[a+8>>2]=0}Uh[k[(k[a>>2]|0)+24>>2]&2047](a);return}function vxa(a){a=a|0;var b=0,c=0;k[a>>2]=90256;b=a+20|0;c=k[b>>2]|0;if(c|0){Qfb(c)|0;k[b>>2]=0}i[a+32>>0]=0;if(!(i[a+4>>0]|0)){k[a+16>>2]=0;k[a+12>>2]=0;k[a+8>>2]=0}Uh[k[(k[a>>2]|0)+24>>2]&2047](a);ggb(a);return}function wxa(a,b){a=a|0;b=b|0;var c=0;Uh[k[(k[a>>2]|0)+16>>2]&2047](a);Uh[k[(k[a>>2]|0)+28>>2]&2047](a);c=k[b>>2]|0;c=Ufb((c|0)==0?1016759:c,373005)|0;b=a+20|0;k[b>>2]=c;if(!c){c=0;return c|0}i[a+32>>0]=1;c=k[a+8>>2]|0;k[a+28>>2]=0;k[a+16>>2]=c;Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=(k[b>>2]|0)!=0;return c|0}function xxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;h=m;Uh[k[(k[a>>2]|0)+16>>2]&2047](a);j=b+16|0;e=k[j>>2]|0;if(!e){a=0;r=m;return a|0}l=b+4|0;c=k[l>>2]|0;if((c|0)<3)d=aa(k[b+12>>2]|0,k[b+8>>2]|0)|0;else{g=k[b+40>>2]|0;f=0;d=1;do{d=aa(k[g+(f<<2)>>2]|0,d)|0;f=f+1|0}while((f|0)!=(c|0))}if(!d){a=0;r=m;return a|0}if(!(k[b>>2]&16384)){c=h+4|0;d=ZT(24)|0;k[d>>2]=1;e=d+4|0;k[h>>2]=e;k[c>>2]=18;i[d+22>>0]=0;f=359303;g=e+18|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,h,359322,359327,133);k[c>>2]=0;k[h>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0);e=k[j>>2]|0;c=k[l>>2]|0}k[a+8>>2]=e;d=aa(k[b+8>>2]|0,k[b+12>>2]|0)|0;if((c|0)>0)c=k[(k[b+44>>2]|0)+(c+-1<<2)>>2]|0;else c=0;b=e+(aa(d,c)|0)|0;k[a+12>>2]=b;i[a+4>>0]=0;i[a+32>>0]=1;k[a+28>>2]=0;k[a+16>>2]=e;a=1;r=m;return a|0}function yxa(a){a=a|0;var b=0,c=0;b=a+20|0;c=k[b>>2]|0;if(c|0){Qfb(c)|0;k[b>>2]=0}i[a+32>>0]=0;if(i[a+4>>0]|0)return;k[a+16>>2]=0;k[a+12>>2]=0;k[a+8>>2]=0;return}function zxa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;d=a+28|0;h=a+16|0;i=a+8|0;c=k[i>>2]|0;b=(k[h>>2]|0)+(k[d>>2]|0)-c|0;j=a+20|0;f=k[j>>2]|0;if(!f){j=c+b|0;k[d>>2]=0;k[h>>2]=j;if(j>>>0<(k[a+12>>2]|0)>>>0)return;else{j=te(4)|0;k[j>>2]=-123;Cf(j|0,19024,0)}}g=a+24|0;l=(b|0)%(k[g>>2]|0)|0;e=b-l|0;k[d>>2]=e;k[h>>2]=c+l;b=f+20|0;c=f+28|0;d=(k[b>>2]|0)>>>0>(k[c>>2]|0)>>>0;do if((k[f+76>>2]|0)>-1){if(d?(ci[k[f+36>>2]&255](f,0,0)|0,(k[b>>2]|0)==0):0)break;k[f+16>>2]=0;k[c>>2]=0;k[b>>2]=0;if((ci[k[f+40>>2]&255](f,e,0)|0)>=0){k[f+8>>2]=0;k[f+4>>2]=0;k[f>>2]=k[f>>2]&-17}}else{if(d?(ci[k[f+36>>2]&255](f,0,0)|0,(k[b>>2]|0)==0):0)break;k[f+16>>2]=0;k[c>>2]=0;k[b>>2]=0;if((ci[k[f+40>>2]&255](f,e,0)|0)>=0){k[f+8>>2]=0;k[f+4>>2]=0;k[f>>2]=k[f>>2]&-17}}while(0);l=_fb(k[i>>2]|0,1,k[g>>2]|0,k[j>>2]|0)|0;j=k[i>>2]|0;k[a+12>>2]=j+l;k[h>>2]=j;if((l|0)>0)return;else{l=te(4)|0;k[l>>2]=-123;Cf(l|0,19024,0)}}function Axa(a){a=a|0;var b=0,c=0,d=0;c=a+4|0;b=a+8|0;if(i[c>>0]|0?(d=k[b>>2]|0,d|0):0)ggb(d);k[a+16>>2]=0;k[a+12>>2]=0;k[b>>2]=0;i[c>>0]=0;return}function Bxa(a){a=a|0;var b=0,c=0,d=0,e=0;d=a+4|0;if(i[d>>0]|0)return;e=k[a+24>>2]|0;c=(e|0)>-1?e:-1;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[a+8>>2]=b;e=b+e|0;k[a+12>>2]=e;k[a+16>>2]=e;i[d>>0]=1;return}function Cxa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;k[a>>2]=90296;p=a+28|0;if(i[p>>0]|0?(m=a+12|0,n=a+4|0,b=k[n>>2]|0,o=(k[m>>2]|0)-b|0,o|0):0){d=a+32|0;e=k[d>>2]|0;a:do if(!e){g=k[a+24>>2]|0;e=g+16|0;c=k[e>>2]|0;d=(c|0)==0;if((k[g+76>>2]|0)>-1){do if(d){c=g+74|0;l=i[c>>0]|0;i[c>>0]=l+255|l;c=k[g>>2]|0;if(!(c&8)){k[g+8>>2]=0;k[g+4>>2]=0;l=k[g+44>>2]|0;k[g+28>>2]=l;f=g+20|0;k[f>>2]=l;d=l+(k[g+48>>2]|0)|0;k[e>>2]=d;e=l;break}else{k[g>>2]=c|32;break a}}else{e=g+20|0;d=c;f=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<o>>>0){ci[k[g+36>>2]&255](g,b,o)|0;break}b:do if((i[g+75>>0]|0)>-1){e=o;while(1){if(!e){d=o;break b}d=e+-1|0;if((i[b+d>>0]|0)==10)break;else e=d}if((ci[k[g+36>>2]&255](g,b,e)|0)>>>0<e>>>0)break a;d=o-e|0;b=b+e|0;c=k[f>>2]|0}else d=o;while(0);upb(c|0,b|0,d|0)|0;k[f>>2]=(k[f>>2]|0)+d;break}else{do if(d){c=g+74|0;l=i[c>>0]|0;i[c>>0]=l+255|l;c=k[g>>2]|0;if(!(c&8)){k[g+8>>2]=0;k[g+4>>2]=0;l=k[g+44>>2]|0;k[g+28>>2]=l;f=g+20|0;k[f>>2]=l;d=l+(k[g+48>>2]|0)|0;k[e>>2]=d;e=l;break}else{k[g>>2]=c|32;break a}}else{e=g+20|0;d=c;f=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<o>>>0){ci[k[g+36>>2]&255](g,b,o)|0;break}c:do if((i[g+75>>0]|0)>-1){e=o;while(1){if(!e){d=o;break c}d=e+-1|0;if((i[b+d>>0]|0)==10)break;else e=d}if((ci[k[g+36>>2]&255](g,b,e)|0)>>>0<e>>>0)break a;d=o-e|0;b=b+e|0;c=k[f>>2]|0}else d=o;while(0);upb(c|0,b|0,d|0)|0;k[f>>2]=(k[f>>2]|0)+d;break}}else{f=e+4|0;h=k[f>>2]|0;c=k[e>>2]|0;l=h-c|0;g=l+o|0;if(l>>>0>=g>>>0){if(l>>>0>g>>>0?(j=c+g|0,(h|0)!=(j|0)):0)k[f>>2]=j}else{T1(e,o);c=k[k[d>>2]>>2]|0;b=k[n>>2]|0}upb(c+l|0,b|0,o|0)|0}while(0);k[m>>2]=k[n>>2];n=a+20|0;k[n>>2]=(k[n>>2]|0)+o}b=a+24|0;c=k[b>>2]|0;if(!c){o=a+32|0;k[o>>2]=0;i[p>>0]=0;p=k[a>>2]|0;p=p+24|0;p=k[p>>2]|0;Uh[p&2047](a);return}Qfb(c)|0;k[b>>2]=0;o=a+32|0;k[o>>2]=0;i[p>>0]=0;p=k[a>>2]|0;p=p+24|0;p=k[p>>2]|0;Uh[p&2047](a);return}function Dxa(a){a=a|0;Cxa(a);ggb(a);return}function Exa(a,b){a=a|0;b=b|0;Uh[k[(k[a>>2]|0)+16>>2]&2047](a);Uh[k[(k[a>>2]|0)+28>>2]&2047](a);b=k[b>>2]|0;b=Ufb((b|0)==0?1016759:b,377117)|0;k[a+24>>2]=b;if(!b){a=(b|0)!=0;return a|0}i[a+28>>0]=1;k[a+20>>2]=0;k[a+12>>2]=k[a+4>>2];a=(b|0)!=0;return a|0}function Fxa(a,b){a=a|0;b=b|0;Uh[k[(k[a>>2]|0)+16>>2]&2047](a);Uh[k[(k[a>>2]|0)+28>>2]&2047](a);k[a+32>>2]=b;i[a+28>>0]=1;k[a+20>>2]=0;k[a+12>>2]=k[a+4>>2];return 1}function Gxa(a){a=a|0;var b=0,c=0,d=0;b=a+28|0;if(i[b>>0]|0)Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=a+24|0;d=k[c>>2]|0;if(d|0){Qfb(d)|0;k[c>>2]=0}k[a+32>>2]=0;i[b>>0]=0;return}function Hxa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;m=a+12|0;n=a+4|0;b=k[n>>2]|0;o=(k[m>>2]|0)-b|0;if(!o)return;j=a+32|0;c=k[j>>2]|0;a:do if(!c){g=k[a+24>>2]|0;e=g+16|0;c=k[e>>2]|0;d=(c|0)==0;if((k[g+76>>2]|0)>-1){do if(d){c=g+74|0;l=i[c>>0]|0;i[c>>0]=l+255|l;c=k[g>>2]|0;if(!(c&8)){k[g+8>>2]=0;k[g+4>>2]=0;l=k[g+44>>2]|0;k[g+28>>2]=l;f=g+20|0;k[f>>2]=l;d=l+(k[g+48>>2]|0)|0;k[e>>2]=d;e=l;break}else{k[g>>2]=c|32;break a}}else{e=g+20|0;d=c;f=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<o>>>0){ci[k[g+36>>2]&255](g,b,o)|0;break}b:do if((i[g+75>>0]|0)>-1){e=o;while(1){if(!e){d=o;break b}d=e+-1|0;if((i[b+d>>0]|0)==10)break;else e=d}if((ci[k[g+36>>2]&255](g,b,e)|0)>>>0<e>>>0)break a;d=o-e|0;b=b+e|0;c=k[f>>2]|0}else d=o;while(0);upb(c|0,b|0,d|0)|0;k[f>>2]=(k[f>>2]|0)+d;break}else{do if(d){c=g+74|0;l=i[c>>0]|0;i[c>>0]=l+255|l;c=k[g>>2]|0;if(!(c&8)){k[g+8>>2]=0;k[g+4>>2]=0;l=k[g+44>>2]|0;k[g+28>>2]=l;f=g+20|0;k[f>>2]=l;d=l+(k[g+48>>2]|0)|0;k[e>>2]=d;e=l;break}else{k[g>>2]=c|32;break a}}else{e=g+20|0;d=c;f=e;e=k[e>>2]|0}while(0);c=e;if((d-e|0)>>>0<o>>>0){ci[k[g+36>>2]&255](g,b,o)|0;break}c:do if((i[g+75>>0]|0)>-1){e=o;while(1){if(!e){d=o;break c}d=e+-1|0;if((i[b+d>>0]|0)==10)break;else e=d}if((ci[k[g+36>>2]&255](g,b,e)|0)>>>0<e>>>0)break a;d=o-e|0;b=b+e|0;c=k[f>>2]|0}else d=o;while(0);upb(c|0,b|0,d|0)|0;k[f>>2]=(k[f>>2]|0)+d;break}}else{d=c+4|0;g=k[d>>2]|0;f=k[c>>2]|0;l=g-f|0;e=l+o|0;if(l>>>0>=e>>>0){if(l>>>0>e>>>0?(h=f+e|0,(g|0)!=(h|0)):0)k[d>>2]=h}else{T1(c,o);c=k[j>>2]|0;b=k[n>>2]|0}upb((k[c>>2]|0)+l|0,b|0,o|0)|0}while(0);k[m>>2]=k[n>>2];n=a+20|0;k[n>>2]=(k[n>>2]|0)+o;return}function Ixa(a){a=a|0;var b=0,c=0;b=a+4|0;c=k[b>>2]|0;if(c|0)ggb(c);k[a+12>>2]=0;k[a+8>>2]=0;k[b>>2]=0;return}function Jxa(a){a=a|0;var b=0,c=0,d=0,e=0;d=a+4|0;b=k[d>>2]|0;e=k[a+16>>2]|0;if(!b){c=(e|0)>-1?e:-1;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[d>>2]=b}k[a+8>>2]=b+e;k[a+12>>2]=b;return}function Kxa(a){a=a|0;var b=0,c=0;k[a>>2]=90256;b=a+20|0;c=k[b>>2]|0;if(c|0){Qfb(c)|0;k[b>>2]=0}i[a+32>>0]=0;if(!(i[a+4>>0]|0)){k[a+16>>2]=0;k[a+12>>2]=0;k[a+8>>2]=0}Uh[k[(k[a>>2]|0)+24>>2]&2047](a);ggb(a);return}function Lxa(a){a=a|0;var b=0,c=0;k[a>>2]=90256;b=a+20|0;c=k[b>>2]|0;if(c|0){Qfb(c)|0;k[b>>2]=0}i[a+32>>0]=0;if(!(i[a+4>>0]|0)){k[a+16>>2]=0;k[a+12>>2]=0;k[a+8>>2]=0}Uh[k[(k[a>>2]|0)+24>>2]&2047](a);ggb(a);return}function Mxa(a){a=a|0;Cxa(a);ggb(a);return}function Nxa(a){a=a|0;Cxa(a);ggb(a);return}function Oxa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;h=a+16|0;b=k[h>>2]|0;c=b+3|0;f=a+12|0;d=k[f>>2]|0;if(c>>>0<d>>>0){a=(l[b+1>>0]|0)<<8|(l[b>>0]|0)|(l[b+2>>0]|0)<<16|(l[c>>0]|0)<<24;k[h>>2]=b+4;h=a;return h|0}if(b>>>0>=d>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);b=k[h>>2]|0;d=k[f>>2]|0}g=l[b>>0]|0;b=b+1|0;k[h>>2]=b;if(b>>>0>=d>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);b=k[h>>2]|0;d=k[f>>2]|0}e=l[b>>0]|0;b=b+1|0;k[h>>2]=b;if(b>>>0>=d>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);b=k[h>>2]|0;d=k[f>>2]|0}c=l[b>>0]|0;b=b+1|0;k[h>>2]=b;if(b>>>0>=d>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);b=k[h>>2]|0}a=l[b>>0]|0;k[h>>2]=b+1;h=e<<8|g|c<<16|a<<24;return h|0}function Pxa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;h=a+16|0;b=k[h>>2]|0;c=b+3|0;f=a+12|0;d=k[f>>2]|0;if(c>>>0<d>>>0){a=(l[b+1>>0]|0)<<16|(l[b>>0]|0)<<24|(l[b+2>>0]|0)<<8|(l[c>>0]|0);k[h>>2]=b+4;h=a;return h|0}if(b>>>0>=d>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);b=k[h>>2]|0;d=k[f>>2]|0}g=l[b>>0]|0;b=b+1|0;k[h>>2]=b;if(b>>>0>=d>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);b=k[h>>2]|0;d=k[f>>2]|0}e=l[b>>0]|0;b=b+1|0;k[h>>2]=b;if(b>>>0>=d>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);b=k[h>>2]|0;d=k[f>>2]|0}c=l[b>>0]|0;b=b+1|0;k[h>>2]=b;if(b>>>0>=d>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);b=k[h>>2]|0}a=l[b>>0]|0;k[h>>2]=b+1;h=e<<16|g<<24|c<<8|a;return h|0}function Qxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=a+12|0;c=k[f>>2]|0;d=c+3|0;g=a+8|0;e=b&255;if(d>>>0<(k[g>>2]|0)>>>0){i[c>>0]=e;i[c+1>>0]=b>>>8;i[c+2>>0]=b>>>16;i[d>>0]=b>>>24;b=c+4|0;k[f>>2]=b;if((b|0)!=(k[g>>2]|0))return;Uh[k[(k[a>>2]|0)+20>>2]&2047](a);return}k[f>>2]=c+1;i[c>>0]=e;c=k[f>>2]|0;if(c>>>0>=(k[g>>2]|0)>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=k[f>>2]|0}k[f>>2]=c+1;i[c>>0]=b>>>8;c=k[f>>2]|0;if(c>>>0>=(k[g>>2]|0)>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=k[f>>2]|0}k[f>>2]=c+1;i[c>>0]=b>>>16;c=k[f>>2]|0;if(c>>>0>=(k[g>>2]|0)>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=k[f>>2]|0}k[f>>2]=c+1;i[c>>0]=b>>>24;if((k[f>>2]|0)>>>0<(k[g>>2]|0)>>>0)return;Uh[k[(k[a>>2]|0)+20>>2]&2047](a);return}function Rxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=a+12|0;c=k[f>>2]|0;d=c+3|0;g=a+8|0;e=b>>>24&255;if(d>>>0<(k[g>>2]|0)>>>0){i[c>>0]=e;i[c+1>>0]=b>>>16;i[c+2>>0]=b>>>8;i[d>>0]=b;b=c+4|0;k[f>>2]=b;if((b|0)!=(k[g>>2]|0))return;Uh[k[(k[a>>2]|0)+20>>2]&2047](a);return}k[f>>2]=c+1;i[c>>0]=e;c=k[f>>2]|0;if(c>>>0>=(k[g>>2]|0)>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=k[f>>2]|0}k[f>>2]=c+1;i[c>>0]=b>>>16;c=k[f>>2]|0;if(c>>>0>=(k[g>>2]|0)>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=k[f>>2]|0}k[f>>2]=c+1;i[c>>0]=b>>>8;c=k[f>>2]|0;if(c>>>0>=(k[g>>2]|0)>>>0){Uh[k[(k[a>>2]|0)+20>>2]&2047](a);c=k[f>>2]|0}k[f>>2]=c+1;i[c>>0]=b;if((k[f>>2]|0)>>>0<(k[g>>2]|0)>>>0)return;Uh[k[(k[a>>2]|0)+20>>2]&2047](a);return}function Sxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+16|0;m=n;switch(a|0){case 0:{a=m+4|0;c=ZT(20)|0;k[c>>2]=1;f=c+4|0;k[m>>2]=f;k[a>>2]=15;i[c+19>>0]=0;g=359565;h=f+15|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,m,359581,359592,90);k[a>>2]=0;k[m>>2]=0;m=k[c>>2]|0;k[c>>2]=m+-1;if((m|0)==1)ggb(k[c+-4>>2]|0);r=n;return}case 1:{a=m+4|0;c=ZT(24)|0;k[c>>2]=1;f=c+4|0;k[m>>2]=f;k[a>>2]=16;i[c+20>>0]=0;g=359660;h=f+16|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,m,359581,359592,93);k[a>>2]=0;k[m>>2]=0;m=k[c>>2]|0;k[c>>2]=m+-1;if((m|0)==1)ggb(k[c+-4>>2]|0);r=n;return}case 2:{j=ZT(28)|0;k[j>>2]=1;l=j+4|0;i[j+26>>0]=0;f=l;g=359677;h=f+22|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));if(!b){c=0;d=0;a=22}else{d=b;a:do if(!(d&3)){a=b;e=12}else{a=b;c=d;while(1){if(!(i[a>>0]|0)){a=c;break a}a=a+1|0;c=a;if(!(c&3)){e=12;break}}}while(0);if((e|0)==12){while(1){c=k[a>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))a=a+4|0;else break}if((c&255)<<24>>24)do a=a+1|0;while((i[a>>0]|0)!=0)}a=a-d|0;c=ZT(a+8&-4)|0;k[c>>2]=1;c=c+4|0;i[c+a>>0]=0;upb(c|0,b|0,a|0)|0;d=a;a=a+22|0}k[m>>2]=0;e=m+4|0;k[e>>2]=0;b=ZT(a+8&-4)|0;k[b>>2]=1;f=b+4|0;k[m>>2]=f;k[e>>2]=a;i[f+a>>0]=0;g=l;h=f+22|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));upb(b+26|0,c|0,d|0)|0;Y8(-2,m,359581,359592,97);k[e>>2]=0;k[m>>2]=0;m=k[b>>2]|0;k[b>>2]=m+-1;if((m|0)==1)ggb(k[b+-4>>2]|0);if(c|0?(l=c+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);m=k[j>>2]|0;k[j>>2]=m+-1;if((m|0)==1)ggb(k[j+-4>>2]|0);r=n;return}default:{j=ZT(20)|0;k[j>>2]=1;l=j+4|0;i[j+17>>0]=0;f=l;g=359700;h=f+13|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));if(!b){c=0;d=0;a=13}else{d=b;b:do if(!(d&3)){a=b;e=30}else{a=b;c=d;while(1){if(!(i[a>>0]|0)){a=c;break b}a=a+1|0;c=a;if(!(c&3)){e=30;break}}}while(0);if((e|0)==30){while(1){c=k[a>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))a=a+4|0;else break}if((c&255)<<24>>24)do a=a+1|0;while((i[a>>0]|0)!=0)}a=a-d|0;c=ZT(a+8&-4)|0;k[c>>2]=1;c=c+4|0;i[c+a>>0]=0;upb(c|0,b|0,a|0)|0;d=a;a=a+13|0}k[m>>2]=0;e=m+4|0;k[e>>2]=0;b=ZT(a+8&-4)|0;k[b>>2]=1;f=b+4|0;k[m>>2]=f;k[e>>2]=a;i[f+a>>0]=0;g=l;h=f+13|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));upb(b+17|0,c|0,d|0)|0;Y8(-2,m,359581,359592,102);k[e>>2]=0;k[m>>2]=0;m=k[b>>2]|0;k[b>>2]=m+-1;if((m|0)==1)ggb(k[b+-4>>2]|0);if(c|0?(l=c+-4|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0)ggb(k[c+-8>>2]|0);m=k[j>>2]|0;k[j>>2]=m+-1;if((m|0)==1)ggb(k[j+-4>>2]|0);r=n;return}}}function Txa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0,h=0.0,j=0.0,l=0,m=0.0,n=0.0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+16|0;A=I;B=I+4|0;C=B+1|0;D=B+2|0;E=B+3|0;F=a+76|0;G=a+16|0;q=a+74|0;s=a+8|0;t=a+4|0;u=a+44|0;v=a+28|0;w=a+20|0;x=a+48|0;y=a+36|0;z=a+75|0;a:do{if((c|0)<=0){c=0;H=35;break}c=c+-1|0;h=+o[b+8>>2];n=+o[b+4>>2];m=+o[b>>2];f=n>h?n:h;f=f<m?m:f;j=f;if(j<1.0e-32){i[B>>0]=0;g=0;e=0;d=0}else{j=+Ofb(f,A)*256.0/j;i[B>>0]=~~(h*j);g=(k[A>>2]|0)+128&255;e=~~(m*j)&255;d=~~(n*j)&255}i[C>>0]=d;i[D>>0]=e;i[E>>0]=g;b=b+12|0;d=k[G>>2]|0;e=(d|0)==0;b:do if((k[F>>2]|0)>-1){if(e){d=i[q>>0]|0;i[q>>0]=d+255|d;d=k[a>>2]|0;if(d&8|0){H=23;break a}k[s>>2]=0;k[t>>2]=0;e=k[u>>2]|0;k[v>>2]=e;k[w>>2]=e;d=e+(k[x>>2]|0)|0;k[G>>2]=d}else e=k[w>>2]|0;p=e;if((d-e|0)>>>0<4){d=ci[k[y>>2]&255](a,B,4)|0;break}c:do if((i[z>>0]|0)>-1){d=4;while(1){if(!d){g=4;l=B;d=0;e=p;break c}e=d+-1|0;if((i[B+e>>0]|0)==10)break;else d=e}if((ci[k[y>>2]&255](a,B,d)|0)>>>0<d>>>0)break b;g=4-d|0;l=B+d|0;e=k[w>>2]|0}else{g=4;l=B;d=0;e=p}while(0);upb(e|0,l|0,g|0)|0;k[w>>2]=(k[w>>2]|0)+g;d=d+g|0}else{if(e){d=i[q>>0]|0;i[q>>0]=d+255|d;d=k[a>>2]|0;if(d&8|0){H=10;break a}k[s>>2]=0;k[t>>2]=0;e=k[u>>2]|0;k[v>>2]=e;k[w>>2]=e;d=e+(k[x>>2]|0)|0;k[G>>2]=d}else e=k[w>>2]|0;p=e;if((d-e|0)>>>0<4){d=ci[k[y>>2]&255](a,B,4)|0;break}d:do if((i[z>>0]|0)>-1){d=4;while(1){if(!d){g=4;l=B;d=0;e=p;break d}e=d+-1|0;if((i[B+e>>0]|0)==10)break;else d=e}if((ci[k[y>>2]&255](a,B,d)|0)>>>0<d>>>0)break b;g=4-d|0;l=B+d|0;e=k[w>>2]|0}else{g=4;l=B;d=0;e=p}while(0);upb(e|0,l|0,g|0)|0;k[w>>2]=(k[w>>2]|0)+g;d=d+g|0}while(0)}while(d>>>0>=4);if((H|0)==10)k[a>>2]=d|32;else if((H|0)==23)k[a>>2]=d|32;else if((H|0)==35){r=I;return c|0}Sxa(1,0);H=-1;r=I;return H|0}function Uxa(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a)return;Uxa(k[a>>2]|0);Uxa(k[a+4>>2]|0);b=a+36|0;if((i[b+11>>0]|0)<0)ggb(k[b>>2]|0);b=k[a+24>>2]|0;c=b;if(b|0){d=a+28|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}ggb(a);return}function Vxa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;Wa=r;r=r+272|0;Ta=Wa+240|0;Na=Wa+176|0;Oa=Wa+120|0;Pa=Wa+56|0;Qa=Wa;u=Wa+264|0;Sa=Wa+252|0;Va=a+24|0;b=k[Va>>2]|0;Ua=a+28|0;if((b|0)!=(Ua|0)){h=a+32|0;n=a+28|0;while(1){c=k[b+4>>2]|0;if(!c){d=b;while(1){c=k[d+8>>2]|0;if((k[c>>2]|0)==(d|0))break;else d=c}}else while(1){d=k[c>>2]|0;if(!d)break;else c=d}if((k[Va>>2]|0)==(b|0))k[Va>>2]=c;k[h>>2]=(k[h>>2]|0)+-1;bya(k[n>>2]|0,b);d=b+36|0;if((i[d+11>>0]|0)<0)ggb(k[d>>2]|0);d=k[b+24>>2]|0;e=d;if(d|0){f=b+28|0;g=k[f>>2]|0;if((g|0)!=(d|0))k[f>>2]=g+(~((g+-8-e|0)>>>3)<<3);ggb(d)}ggb(b);if((c|0)==(Ua|0))break;else b=c}}if((i[a+11>>0]|0)<0)b=k[a>>2]|0;else b=a;s=Ufb(b,373005)|0;a:do if(!s){q=Sa+4|0;k[q>>2]=0;s=Sa+8|0;k[s>>2]=0;t=Sa+4|0;k[Sa>>2]=t;b=k[Va>>2]|0;if((b|0)!=(Ua|0)){c=b;o=b;while(1){d=o+16|0;p=Wxa(Sa,t,Ta,d)|0;if(!(k[p>>2]|0)){while(1){b=fgb(80)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b+16>>2]=k[d>>2];Xxa(b+24|0,o+24|0);g=b+36|0;d=o+36|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;if((i[d+11>>0]|0)<0){h=k[d>>2]|0;n=k[o+40>>2]|0;if(n>>>0>4294967279)break;if(n>>>0<11){i[b+47>>0]=n;if(!n)d=g;else{d=g;Ra=37}}else{f=n+16&-16;e=(f|0)==0?1:f;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[g>>2]=d;k[b+44>>2]=f|-2147483648;k[b+40>>2]=n;Ra=37}if((Ra|0)==37){Ra=0;upb(d|0,h|0,n|0)|0}i[d+n>>0]=0}else{k[g>>2]=k[d>>2];k[g+4>>2]=k[d+4>>2];k[g+8>>2]=k[d+8>>2]}d=b+48|0;Qa=o+48|0;k[d>>2]=k[Qa>>2];k[d+4>>2]=k[Qa+4>>2];k[d+8>>2]=k[Qa+8>>2];k[d+12>>2]=k[Qa+12>>2];k[d+16>>2]=k[Qa+16>>2];k[d+20>>2]=k[Qa+20>>2];k[d+24>>2]=k[Qa+24>>2];k[d+28>>2]=k[Qa+28>>2];d=k[Ta>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[p>>2]=b;d=k[k[Sa>>2]>>2]|0;if(d){k[Sa>>2]=d;b=k[p>>2]|0}B4(k[q>>2]|0,b);k[s>>2]=(k[s>>2]|0)+1}b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(Ua|0))break a;else{c=b;o=b}}hob()}}else{t=s+76|0;do if(!(k[s>>2]&16)){d=u+1|0;e=Ta+1|0;Ma=a+12|0;La=a+16|0;f=s+8|0;g=s+4|0;h=s+20|0;n=s+28|0;o=s+36|0;p=s+16|0;q=s+40|0;b:while(1){if((_fb(u,1,2,s)|0)>>>0<2){Ra=70;break}c:do switch(i[d>>0]|0){case -31:break b;case -2:case -17:case -18:case -19:case -20:case -21:case -22:case -23:case -24:case -25:case -26:case -27:case -28:case -29:case -30:case -32:case -41:case -42:case -43:case -44:case -45:case -46:case -47:case -48:case -38:case -35:case -37:case -60:case -62:case -64:{if((_fb(Ta,1,2,s)|0)>>>0<2)b=0;else b=l[Ta>>0]<<8|l[e>>0];b=b+-2-(k[f>>2]|0)+(k[g>>2]|0)|0;c=(k[h>>2]|0)>>>0>(k[n>>2]|0)>>>0;if((k[t>>2]|0)>-1){if(c?(ci[k[o>>2]&255](s,0,0)|0,(k[h>>2]|0)==0):0)break c;k[p>>2]=0;k[n>>2]=0;k[h>>2]=0;if((ci[k[q>>2]&255](s,b,1)|0)<0)break c;k[f>>2]=0;k[g>>2]=0;k[s>>2]=k[s>>2]&-17;break c}else{if(c?(ci[k[o>>2]&255](s,0,0)|0,(k[h>>2]|0)==0):0)break c;k[p>>2]=0;k[n>>2]=0;k[h>>2]=0;if((ci[k[q>>2]&255](s,b,1)|0)<0)break c;k[f>>2]=0;k[g>>2]=0;k[s>>2]=k[s>>2]&-17;break c}}default:{}}while(0);if(k[s>>2]&16|0){Ra=70;break}}if((Ra|0)==70){Qfb(s)|0;break}if((_fb(Ta,1,2,s)|0)>>>0<2){Wa=te(1)|0;Cf(Wa|0,19104,0)}b=l[Ta>>0]<<8|l[e>>0];if(b>>>0<7){Wa=te(1)|0;Cf(Wa|0,19104,0)}e=b+-6|0;d=k[La>>2]|0;c=k[Ma>>2]|0;b=d-c|0;if(e>>>0<=b>>>0){if(e>>>0<b>>>0?(v=c+e|0,(d|0)!=(v|0)):0)k[La>>2]=v}else T1(Ma,e-b|0);b=6-(k[f>>2]|0)+(k[g>>2]|0)|0;c=(k[h>>2]|0)>>>0>(k[n>>2]|0)>>>0;do if((k[t>>2]|0)>-1){if(c?(ci[k[o>>2]&255](s,0,0)|0,(k[h>>2]|0)==0):0)break;k[p>>2]=0;k[n>>2]=0;k[h>>2]=0;if((ci[k[q>>2]&255](s,b,1)|0)>=0){k[f>>2]=0;k[g>>2]=0;k[s>>2]=k[s>>2]&-17}}else{if(c?(ci[k[o>>2]&255](s,0,0)|0,(k[h>>2]|0)==0):0)break;k[p>>2]=0;k[n>>2]=0;k[h>>2]=0;if((ci[k[q>>2]&255](s,b,1)|0)>=0){k[f>>2]=0;k[g>>2]=0;k[s>>2]=k[s>>2]&-17}}while(0);_fb(k[Ma>>2]|0,1,e,s)|0;Qfb(s)|0;h=k[a+12>>2]|0;b=i[h>>0]|0;c=h;if(b<<24>>24==(i[h+1>>0]|0))if(b<<24>>24==73)b=73;else b=b<<24>>24==77?77:0;else b=0;Ka=a+36|0;k[Ka>>2]=b;f=(k[La>>2]|0)-c|0;if(f>>>0<=3)Cf(te(1)|0,19104,0);g=(b|0)==73;b=l[h+2>>0]|0;c=i[h+3>>0]|0;if(g)b=(c&255)<<8|b;else b=c&255|b<<8;d:do if((b&65535)<<16>>16==42){if(f>>>0<=7)Cf(te(1)|0,19104,0);b=l[h+4>>0]|0;c=i[h+5>>0]|0;d=i[h+6>>0]|0;e=i[h+7>>0]|0;if(g)d=(c&255)<<8|b|(d&255)<<16|(e&255)<<24;else d=(c&255)<<16|b<<24|(d&255)<<8|e&255;if(f>>>0<=9)Cf(te(1)|0,19104,0);c=l[h+8>>0]|0;b=i[h+9>>0]|0;if(g)b=(b&255)<<8|c;else b=b&255|c<<8;t=b&65535;if(t|0){u=Oa+48|0;v=Qa+12|0;w=Oa+12|0;x=Qa+24|0;y=Oa+24|0;z=Pa+8|0;A=Pa+20|0;B=Pa+32|0;C=Na+8|0;D=Pa+8|0;E=Na+20|0;F=Na+32|0;G=Ua;H=Na+8|0;I=a+28|0;J=a+32|0;K=Oa+4|0;L=Qa+4|0;M=Pa+12|0;N=Na+12|0;O=Oa+32|0;P=Oa+50|0;Q=Qa+8|0;R=w+11|0;S=Oa+16|0;T=v+11|0;U=Qa+20|0;V=Qa+16|0;W=Pa+16|0;X=A+11|0;Y=Pa+28|0;Z=Pa+24|0;_=Na+16|0;$=E+11|0;aa=Na+28|0;ba=Na+24|0;ca=Na+16|0;da=Pa+16|0;ea=Qa+8|0;fa=Ta+11|0;ga=Ta+4|0;ha=Ta+11|0;ia=Ta+4|0;ja=Ta+11|0;ka=Ta+4|0;la=Ta+4|0;ma=Ta+4|0;na=Ta+11|0;oa=Ta+4|0;pa=Ta+11|0;qa=Ta+4|0;ra=Na+4|0;sa=Na+8|0;ta=Ta+4|0;ua=Na+8|0;va=Ta+4|0;wa=Na+4|0;xa=Na+8|0;ya=Ta+4|0;za=Na+8|0;Aa=Na+4|0;Ba=Na+8|0;Ca=Ta+4|0;Da=Na+8|0;Ea=Na+4|0;Fa=Na+8|0;Ga=Ta+4|0;Ha=Na+8|0;Ia=Ta+11|0;Ja=Ta+4|0;s=0;q=d+2|0;e:while(1){k[Oa>>2]=0;k[Oa+4>>2]=0;k[Oa+8>>2]=0;k[Oa+12>>2]=0;k[Oa+16>>2]=0;k[Oa+20>>2]=0;k[Oa+24>>2]=0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;j[u>>1]=-1;j[P>>1]=0;j[P+2>>1]=0;j[P+4>>1]=0;b=q+1|0;e=k[Ma>>2]|0;d=(k[La>>2]|0)-e|0;if(b>>>0>=d>>>0){Ra=129;break}f=(k[Ka>>2]|0)==73;c=l[e+q>>0]|0;b=i[e+b>>0]|0;if(f)b=(b&255)<<8|c;else b=b&255|c<<8;b=b&65535;j[u>>1]=b;f:do if(b<<16>>16<296){if(b<<16>>16<272){if(b<<16>>16<270){switch(b<<16>>16){case -30871:break f;case -32104:break;default:{Ra=245;break f}}Yxa(Ta,a,q);o=i[Ia>>0]|0;p=o<<24>>24<0;b=k[Ta>>2]|0;lob(w,p?b:Ta,p?k[Ja>>2]|0:o&255);if(p)ggb(b);break}switch(b<<16>>16){case 270:{Yxa(Ta,a,q);o=i[fa>>0]|0;p=o<<24>>24<0;b=k[Ta>>2]|0;lob(w,p?b:Ta,p?k[ga>>2]|0:o&255);if(p)ggb(b);break f}case 271:{Yxa(Ta,a,q);o=i[ha>>0]|0;p=o<<24>>24<0;b=k[Ta>>2]|0;lob(w,p?b:Ta,p?k[ia>>2]|0:o&255);if(p)ggb(b);break f}default:{Ra=245;break f}}}switch(b<<16>>16){case 272:{Yxa(Ta,a,q);o=i[ja>>0]|0;p=o<<24>>24<0;b=k[Ta>>2]|0;lob(w,p?b:Ta,p?k[ka>>2]|0:o&255);if(p)ggb(b);break f}case 274:{b=q+9|0;if(b>>>0>=d>>>0){Ra=144;break e}c=l[e+(q+8)>>0]|0;b=i[e+b>>0]|0;if(f)b=(b&255)<<8|c;else b=b&255|c<<8;j[P>>1]=b;break f}case 282:{Zxa(Ta,a,q);b=k[Ta>>2]|0;c=k[la>>2]|0;_xa(Oa,b,c);d=b;if(b|0){if((c|0)!=(b|0))k[la>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(b)}break f}case 283:{Zxa(Ta,a,q);b=k[Ta>>2]|0;c=k[ma>>2]|0;_xa(Oa,b,c);d=b;if(b|0){if((c|0)!=(b|0))k[ma>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(b)}break f}default:{Ra=245;break f}}}else switch(b<<16>>16){case 296:{b=q+9|0;if(b>>>0>=d>>>0){Ra=160;break e}c=l[e+(q+8)>>0]|0;b=i[e+b>>0]|0;if(f)b=(b&255)<<8|c;else b=b&255|c<<8;j[P>>1]=b;break f}case 305:{Yxa(Ta,a,q);o=i[na>>0]|0;p=o<<24>>24<0;b=k[Ta>>2]|0;lob(w,p?b:Ta,p?k[oa>>2]|0:o&255);if(p)ggb(b);break f}case 306:{Yxa(Ta,a,q);o=i[pa>>0]|0;p=o<<24>>24<0;b=k[Ta>>2]|0;lob(w,p?b:Ta,p?k[qa>>2]|0:o&255);if(p)ggb(b);break f}case 318:{k[Na>>2]=0;k[ra>>2]=0;k[sa>>2]=0;b=$xa(a,q+8|0)|0;o=$xa(a,b)|0;p=$xa(a,b+4|0)|0;k[Ta>>2]=o;k[ta>>2]=p;aya(Na,Ta);p=$xa(a,b+8|0)|0;b=$xa(a,b+12|0)|0;k[Ta>>2]=p;k[va>>2]=b;b=k[ra>>2]|0;if((b|0)==(k[ua>>2]|0)){aya(Na,Ta);c=k[ra>>2]|0}else{o=Ta;p=k[o+4>>2]|0;c=b;k[c>>2]=k[o>>2];k[c+4>>2]=p;c=b+8|0;k[ra>>2]=c}b=k[Na>>2]|0;_xa(Oa,b,c);d=b;if(b|0){if((c|0)!=(b|0))k[ra>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(b)}break f}case 319:{k[Na>>2]=0;k[wa>>2]=0;k[xa>>2]=0;c=$xa(a,q+8|0)|0;p=$xa(a,c)|0;b=$xa(a,c+4|0)|0;k[Ta>>2]=p;k[ya>>2]=b;b=k[wa>>2]|0;if((b|0)==(k[za>>2]|0))aya(Na,Ta);else{n=Ta;o=k[n+4>>2]|0;p=b;k[p>>2]=k[n>>2];k[p+4>>2]=o;k[wa>>2]=(k[wa>>2]|0)+8}p=$xa(a,c+8|0)|0;b=$xa(a,c+12|0)|0;k[Ta>>2]=p;k[ya>>2]=b;b=k[wa>>2]|0;if((b|0)==(k[za>>2]|0))aya(Na,Ta);else{n=Ta;o=k[n+4>>2]|0;p=b;k[p>>2]=k[n>>2];k[p+4>>2]=o;k[wa>>2]=(k[wa>>2]|0)+8}p=$xa(a,c+16|0)|0;b=$xa(a,c+20|0)|0;k[Ta>>2]=p;k[ya>>2]=b;b=k[wa>>2]|0;if((b|0)==(k[za>>2]|0))aya(Na,Ta);else{n=Ta;o=k[n+4>>2]|0;p=b;k[p>>2]=k[n>>2];k[p+4>>2]=o;k[wa>>2]=(k[wa>>2]|0)+8}p=$xa(a,c+24|0)|0;b=$xa(a,c+28|0)|0;k[Ta>>2]=p;k[ya>>2]=b;b=k[wa>>2]|0;if((b|0)==(k[za>>2]|0))aya(Na,Ta);else{n=Ta;o=k[n+4>>2]|0;p=b;k[p>>2]=k[n>>2];k[p+4>>2]=o;k[wa>>2]=(k[wa>>2]|0)+8}p=$xa(a,c+32|0)|0;b=$xa(a,c+36|0)|0;k[Ta>>2]=p;k[ya>>2]=b;b=k[wa>>2]|0;if((b|0)==(k[za>>2]|0))aya(Na,Ta);else{n=Ta;o=k[n+4>>2]|0;p=b;k[p>>2]=k[n>>2];k[p+4>>2]=o;k[wa>>2]=(k[wa>>2]|0)+8}p=$xa(a,c+40|0)|0;b=$xa(a,c+44|0)|0;k[Ta>>2]=p;k[ya>>2]=b;b=k[wa>>2]|0;if((b|0)==(k[za>>2]|0)){aya(Na,Ta);b=k[wa>>2]|0}else{o=Ta;p=k[o+4>>2]|0;k[b>>2]=k[o>>2];k[b+4>>2]=p;b=(k[wa>>2]|0)+8|0;k[wa>>2]=b}_xa(Oa,k[Na>>2]|0,b);b=k[Na>>2]|0;c=b;if(b|0){d=k[wa>>2]|0;if((d|0)!=(b|0))k[wa>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(b)}break f}case 529:{k[Na>>2]=0;k[Aa>>2]=0;k[Ba>>2]=0;b=$xa(a,q+8|0)|0;c=$xa(a,b)|0;p=$xa(a,b+4|0)|0;k[Ta>>2]=c;k[Ca>>2]=p;aya(Na,Ta);p=$xa(a,b+8|0)|0;c=$xa(a,b+12|0)|0;k[Ta>>2]=p;k[Ca>>2]=c;c=k[Aa>>2]|0;if((c|0)==(k[Da>>2]|0))aya(Na,Ta);else{n=Ta;o=k[n+4>>2]|0;p=c;k[p>>2]=k[n>>2];k[p+4>>2]=o;k[Aa>>2]=c+8}p=$xa(a,b+16|0)|0;b=$xa(a,b+20|0)|0;k[Ta>>2]=p;k[Ca>>2]=b;b=k[Aa>>2]|0;if((b|0)==(k[Da>>2]|0)){aya(Na,Ta);c=k[Aa>>2]|0}else{o=Ta;p=k[o+4>>2]|0;c=b;k[c>>2]=k[o>>2];k[c+4>>2]=p;c=b+8|0;k[Aa>>2]=c}b=k[Na>>2]|0;_xa(Oa,b,c);d=b;if(b|0){if((c|0)!=(b|0))k[Aa>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(b)}break f}case 531:{b=q+9|0;if(b>>>0>=d>>>0){Ra=214;break e}c=l[e+(q+8)>>0]|0;b=i[e+b>>0]|0;if(f)b=(b&255)<<8|c;else b=b&255|c<<8;j[P>>1]=b;break f}case 532:{k[Na>>2]=0;k[Ea>>2]=0;k[Fa>>2]=0;c=$xa(a,q+8|0)|0;p=$xa(a,c)|0;b=$xa(a,c+4|0)|0;k[Ta>>2]=p;k[Ga>>2]=b;b=k[Ea>>2]|0;if((b|0)==(k[Ha>>2]|0))aya(Na,Ta);else{n=Ta;o=k[n+4>>2]|0;p=b;k[p>>2]=k[n>>2];k[p+4>>2]=o;k[Ea>>2]=(k[Ea>>2]|0)+8}p=$xa(a,c+8|0)|0;b=$xa(a,c+12|0)|0;k[Ta>>2]=p;k[Ga>>2]=b;b=k[Ea>>2]|0;if((b|0)==(k[Ha>>2]|0))aya(Na,Ta);else{n=Ta;o=k[n+4>>2]|0;p=b;k[p>>2]=k[n>>2];k[p+4>>2]=o;k[Ea>>2]=(k[Ea>>2]|0)+8}p=$xa(a,c+16|0)|0;b=$xa(a,c+20|0)|0;k[Ta>>2]=p;k[Ga>>2]=b;b=k[Ea>>2]|0;if((b|0)==(k[Ha>>2]|0))aya(Na,Ta);else{n=Ta;o=k[n+4>>2]|0;p=b;k[p>>2]=k[n>>2];k[p+4>>2]=o;k[Ea>>2]=(k[Ea>>2]|0)+8}p=$xa(a,c+24|0)|0;b=$xa(a,c+28|0)|0;k[Ta>>2]=p;k[Ga>>2]=b;b=k[Ea>>2]|0;if((b|0)==(k[Ha>>2]|0))aya(Na,Ta);else{n=Ta;o=k[n+4>>2]|0;p=b;k[p>>2]=k[n>>2];k[p+4>>2]=o;k[Ea>>2]=(k[Ea>>2]|0)+8}p=$xa(a,c+32|0)|0;b=$xa(a,c+36|0)|0;k[Ta>>2]=p;k[Ga>>2]=b;b=k[Ea>>2]|0;if((b|0)==(k[Ha>>2]|0))aya(Na,Ta);else{n=Ta;o=k[n+4>>2]|0;p=b;k[p>>2]=k[n>>2];k[p+4>>2]=o;k[Ea>>2]=(k[Ea>>2]|0)+8}p=$xa(a,c+40|0)|0;b=$xa(a,c+44|0)|0;k[Ta>>2]=p;k[Ga>>2]=b;b=k[Ea>>2]|0;if((b|0)==(k[Ha>>2]|0)){aya(Na,Ta);b=k[Ea>>2]|0}else{o=Ta;p=k[o+4>>2]|0;k[b>>2]=k[o>>2];k[b+4>>2]=p;b=(k[Ea>>2]|0)+8|0;k[Ea>>2]=b}_xa(Oa,k[Na>>2]|0,b);b=k[Na>>2]|0;c=b;if(b|0){d=k[Ea>>2]|0;if((d|0)!=(b|0))k[Ea>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(b)}break f}default:{Ra=245;break f}}while(0);if((Ra|0)==245){Ra=0;j[u>>1]=-1}g=j[u>>1]|0;k[Qa>>2]=0;k[L>>2]=0;k[Q>>2]=0;b=(k[K>>2]|0)-(k[Oa>>2]|0)|0;d=b>>3;do if(!d){c=0;b=0}else{if(d>>>0>536870911){Ra=248;break e}c=(b|0)==0?1:b;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[L>>2]=b;k[Qa>>2]=b;k[ea>>2]=b+(d<<3);c=k[Oa>>2]|0;d=(k[K>>2]|0)-c|0;e=b;if((d|0)<=0){c=e;b=e;break}upb(b|0,c|0,d|0)|0;b=b+(d>>3<<3)|0;k[L>>2]=b;c=e}while(0);k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;if((i[R>>0]|0)<0){e=k[w>>2]|0;f=k[S>>2]|0;if(f>>>0>4294967279){Ra=258;break}if(f>>>0<11){i[T>>0]=f;if(!f)b=v;else{b=v;Ra=266}}else{d=f+16&-16;c=(d|0)==0?1:d;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[v>>2]=b;k[U>>2]=d|-2147483648;k[V>>2]=f;Ra=266}if((Ra|0)==266){Ra=0;upb(b|0,e|0,f|0)|0}i[b+f>>0]=0;c=k[Qa>>2]|0;b=k[L>>2]|0}else{k[v>>2]=k[w>>2];k[v+4>>2]=k[w+4>>2];k[v+8>>2]=k[w+8>>2]};k[x>>2]=k[y>>2];k[x+4>>2]=k[y+4>>2];k[x+8>>2]=k[y+8>>2];k[x+12>>2]=k[y+12>>2];k[x+16>>2]=k[y+16>>2];k[x+20>>2]=k[y+20>>2];k[x+24>>2]=k[y+24>>2];k[x+28>>2]=k[y+28>>2];j[Pa>>1]=g;k[z>>2]=0;k[M>>2]=0;k[W>>2]=0;b=b-c|0;d=b>>3;do if(!d){c=0;b=0}else{if(d>>>0>536870911){Ra=270;break e}c=(b|0)==0?1:b;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[M>>2]=b;k[z>>2]=b;k[da>>2]=b+(d<<3);c=k[Qa>>2]|0;d=(k[L>>2]|0)-c|0;e=b;if((d|0)<=0){c=e;b=e;break}upb(b|0,c|0,d|0)|0;b=b+(d>>3<<3)|0;k[M>>2]=b;c=e}while(0);k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;if((i[T>>0]|0)<0){e=k[v>>2]|0;f=k[V>>2]|0;if(f>>>0>4294967279){Ra=280;break}if(f>>>0<11){i[X>>0]=f;if(!f)b=A;else{b=A;Ra=288}}else{d=f+16&-16;c=(d|0)==0?1:d;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[A>>2]=b;k[Y>>2]=d|-2147483648;k[Z>>2]=f;Ra=288}if((Ra|0)==288){Ra=0;upb(b|0,e|0,f|0)|0}i[b+f>>0]=0;c=k[D>>2]|0;b=k[M>>2]|0}else{k[A>>2]=k[v>>2];k[A+4>>2]=k[v+4>>2];k[A+8>>2]=k[v+8>>2]};k[B>>2]=k[x>>2];k[B+4>>2]=k[x+4>>2];k[B+8>>2]=k[x+8>>2];k[B+12>>2]=k[x+12>>2];k[B+16>>2]=k[x+16>>2];k[B+20>>2]=k[x+20>>2];k[B+24>>2]=k[x+24>>2];k[B+28>>2]=k[x+28>>2];k[Na>>2]=m[Pa>>1];k[C>>2]=0;k[N>>2]=0;k[_>>2]=0;b=b-c|0;d=b>>3;do if(d|0){if(d>>>0>536870911){Ra=292;break e}c=(b|0)==0?1:b;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[N>>2]=b;k[C>>2]=b;k[ca>>2]=b+(d<<3);c=k[D>>2]|0;d=(k[M>>2]|0)-c|0;if((d|0)<=0)break;upb(b|0,c|0,d|0)|0;k[N>>2]=b+(d>>3<<3)}while(0);k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;if((i[X>>0]|0)<0){e=k[A>>2]|0;f=k[Z>>2]|0;if(f>>>0>4294967279){Ra=302;break}if(f>>>0<11){i[$>>0]=f;if(!f)b=E;else{b=E;Ra=310}}else{d=f+16&-16;c=(d|0)==0?1:d;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[E>>2]=b;k[aa>>2]=d|-2147483648;k[ba>>2]=f;Ra=310}if((Ra|0)==310){Ra=0;upb(b|0,e|0,f|0)|0}i[b+f>>0]=0}else{k[E>>2]=k[A>>2];k[E+4>>2]=k[A+4>>2];k[E+8>>2]=k[A+8>>2]};k[F>>2]=k[B>>2];k[F+4>>2]=k[B+4>>2];k[F+8>>2]=k[B+8>>2];k[F+12>>2]=k[B+12>>2];k[F+16>>2]=k[B+16>>2];k[F+20>>2]=k[B+20>>2];k[F+24>>2]=k[B+24>>2];k[F+28>>2]=k[B+28>>2];b=k[Ua>>2]|0;do if(b){e=k[Na>>2]|0;while(1){c=k[b+16>>2]|0;if((e|0)<(c|0)){c=k[b>>2]|0;if(!c){Ra=316;break}else b=c}else{if((c|0)>=(e|0)){Ra=321;break}d=b+4|0;c=k[d>>2]|0;if(!c){Ra=320;break}else b=c}}if((Ra|0)==316){Ra=0;k[Ta>>2]=b;p=b;d=b;break}else if((Ra|0)==320){Ra=0;k[Ta>>2]=b;p=b;break}else if((Ra|0)==321){Ra=0;k[Ta>>2]=b;p=b;d=Ta;break}}else{k[Ta>>2]=Ua;p=G;d=Ua}while(0);if(!(k[d>>2]|0)){while(1){b=fgb(80)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b+16>>2]=k[Na>>2];g=b+24|0;k[g>>2]=0;o=b+28|0;k[o>>2]=0;h=b+32|0;k[h>>2]=0;c=(k[N>>2]|0)-(k[H>>2]|0)|0;n=c>>3;do if(n|0){if(n>>>0>536870911){Ra=329;break e}e=(c|0)==0?1:c;while(1){c=fgb(e)|0;if(c|0){f=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){f=0;break}Qh[c&7]()}k[o>>2]=f;k[g>>2]=f;k[h>>2]=f+(n<<3);c=k[H>>2]|0;e=(k[N>>2]|0)-c|0;if((e|0)<=0)break;upb(f|0,c|0,e|0)|0;k[o>>2]=f+(e>>3<<3)}while(0);g=b+36|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;if((i[$>>0]|0)<0){h=k[E>>2]|0;n=k[ba>>2]|0;if(n>>>0>4294967279){Ra=339;break}if(n>>>0<11){i[b+47>>0]=n;if(!n)c=g;else{c=g;Ra=347}}else{f=n+16&-16;e=(f|0)==0?1:f;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[g>>2]=c;k[b+44>>2]=f|-2147483648;k[b+40>>2]=n;Ra=347}if((Ra|0)==347){Ra=0;upb(c|0,h|0,n|0)|0}i[c+n>>0]=0}else{k[g>>2]=k[E>>2];k[g+4>>2]=k[E+4>>2];k[g+8>>2]=k[E+8>>2]}c=b+48|0;k[c>>2]=k[F>>2];k[c+4>>2]=k[F+4>>2];k[c+8>>2]=k[F+8>>2];k[c+12>>2]=k[F+12>>2];k[c+16>>2]=k[F+16>>2];k[c+20>>2]=k[F+20>>2];k[c+24>>2]=k[F+24>>2];k[c+28>>2]=k[F+28>>2];k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=p;k[d>>2]=b;c=k[k[Va>>2]>>2]|0;if(c){k[Va>>2]=c;b=k[d>>2]|0}B4(k[I>>2]|0,b);k[J>>2]=(k[J>>2]|0)+1}if((i[$>>0]|0)<0)ggb(k[E>>2]|0);b=k[C>>2]|0;c=b;if(b|0){d=k[N>>2]|0;if((d|0)!=(b|0))k[N>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(b)}if((i[X>>0]|0)<0)ggb(k[A>>2]|0);b=k[z>>2]|0;c=b;if(b|0){d=k[M>>2]|0;if((d|0)!=(b|0))k[M>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(b)}if((i[T>>0]|0)<0)ggb(k[v>>2]|0);b=k[Qa>>2]|0;c=b;if(b|0){d=k[L>>2]|0;if((d|0)!=(b|0))k[L>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(b)}q=q+12|0;if((i[R>>0]|0)<0)ggb(k[w>>2]|0);b=k[Oa>>2]|0;c=b;if(b|0){d=k[K>>2]|0;if((d|0)!=(b|0))k[K>>2]=d+(~((d+-8-c|0)>>>3)<<3);ggb(b)}s=s+1|0;if(s>>>0>=t>>>0)break d}switch(Ra|0){case 129:Cf(te(1)|0,19104,0);case 144:Cf(te(1)|0,19104,0);case 160:Cf(te(1)|0,19104,0);case 214:Cf(te(1)|0,19104,0);case 248:{ad(426534,426557,304,426811);break}case 258:{hob();break}case 270:{ad(426534,426557,304,426811);break}case 280:{hob();break}case 292:{ad(426534,426557,304,426811);break}case 302:{hob();break}case 329:{ad(426534,426557,304,426811);break}case 339:{hob();break}}}}while(0);q=Sa+4|0;k[q>>2]=0;s=Sa+8|0;k[s>>2]=0;t=Sa+4|0;k[Sa>>2]=t;b=k[Va>>2]|0;if((b|0)==(Ua|0))break a;p=b;c=b;while(1){d=p+16|0;o=Wxa(Sa,t,Ta,d)|0;if(!(k[o>>2]|0)){while(1){b=fgb(80)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b+16>>2]=k[d>>2];Xxa(b+24|0,p+24|0);g=b+36|0;d=p+36|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;if((i[d+11>>0]|0)<0){h=k[d>>2]|0;n=k[p+40>>2]|0;if(n>>>0>4294967279)break;if(n>>>0<11){i[b+47>>0]=n;if(!n)d=g;else{d=g;Ra=394}}else{f=n+16&-16;e=(f|0)==0?1:f;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[g>>2]=d;k[b+44>>2]=f|-2147483648;k[b+40>>2]=n;Ra=394}if((Ra|0)==394){Ra=0;upb(d|0,h|0,n|0)|0}i[d+n>>0]=0}else{k[g>>2]=k[d>>2];k[g+4>>2]=k[d+4>>2];k[g+8>>2]=k[d+8>>2]}d=b+48|0;Qa=p+48|0;k[d>>2]=k[Qa>>2];k[d+4>>2]=k[Qa+4>>2];k[d+8>>2]=k[Qa+8>>2];k[d+12>>2]=k[Qa+12>>2];k[d+16>>2]=k[Qa+16>>2];k[d+20>>2]=k[Qa+20>>2];k[d+24>>2]=k[Qa+24>>2];k[d+28>>2]=k[Qa+28>>2];d=k[Ta>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[o>>2]=b;d=k[k[Sa>>2]>>2]|0;if(d){k[Sa>>2]=d;b=k[o>>2]|0}B4(k[q>>2]|0,b);k[s>>2]=(k[s>>2]|0)+1}b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(Ua|0))break a;else{p=b;c=b}}hob()}else Qfb(s)|0;while(0);q=Sa+4|0;k[q>>2]=0;s=Sa+8|0;k[s>>2]=0;t=Sa+4|0;k[Sa>>2]=t;b=k[Va>>2]|0;if((b|0)!=(Ua|0)){p=b;c=b;while(1){d=p+16|0;o=Wxa(Sa,t,Ta,d)|0;if(!(k[o>>2]|0)){while(1){b=fgb(80)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b+16>>2]=k[d>>2];Xxa(b+24|0,p+24|0);g=b+36|0;d=p+36|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;if((i[d+11>>0]|0)<0){h=k[d>>2]|0;n=k[p+40>>2]|0;if(n>>>0>4294967279)break;if(n>>>0<11){i[b+47>>0]=n;if(!n)d=g;else{d=g;Ra=89}}else{f=n+16&-16;e=(f|0)==0?1:f;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[g>>2]=d;k[b+44>>2]=f|-2147483648;k[b+40>>2]=n;Ra=89}if((Ra|0)==89){Ra=0;upb(d|0,h|0,n|0)|0}i[d+n>>0]=0}else{k[g>>2]=k[d>>2];k[g+4>>2]=k[d+4>>2];k[g+8>>2]=k[d+8>>2]}d=b+48|0;Qa=p+48|0;k[d>>2]=k[Qa>>2];k[d+4>>2]=k[Qa+4>>2];k[d+8>>2]=k[Qa+8>>2];k[d+12>>2]=k[Qa+12>>2];k[d+16>>2]=k[Qa+16>>2];k[d+20>>2]=k[Qa+20>>2];k[d+24>>2]=k[Qa+24>>2];k[d+28>>2]=k[Qa+28>>2];d=k[Ta>>2]|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=d;k[o>>2]=b;d=k[k[Sa>>2]>>2]|0;if(d){k[Sa>>2]=d;b=k[o>>2]|0}B4(k[q>>2]|0,b);k[s>>2]=(k[s>>2]|0)+1}b=k[c+4>>2]|0;if(!b)while(1){b=k[c+8>>2]|0;if((k[b>>2]|0)==(c|0))break;else c=b}else while(1){c=k[b>>2]|0;if(!c)break;else b=c}if((b|0)==(Ua|0))break a;else{p=b;c=b}}hob()}}while(0);if((Va|0)==(Sa|0)){Va=a+32|0;Ua=Sa+4|0;Ua=k[Ua>>2]|0;Uxa(Ua);Va=k[Va>>2]|0;Va=(Va|0)!=0;r=Wa;return Va|0}Uxa(k[Ua>>2]|0);c=a+32|0;k[c>>2]=0;k[Va>>2]=Ua;k[Ua>>2]=0;d=k[Sa>>2]|0;b=Sa+4|0;if((d|0)==(b|0)){Va=c;Ua=b;Ua=k[Ua>>2]|0;Uxa(Ua);Va=k[Va>>2]|0;Va=(Va|0)!=0;r=Wa;return Va|0}t=a+28|0;s=d;e=d;while(1){f=s+16|0;q=Wxa(Va,Ua,Ta,f)|0;if(!(k[q>>2]|0)){while(1){d=fgb(80)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d+16>>2]=k[f>>2];Xxa(d+24|0,s+24|0);n=d+36|0;f=s+36|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;if((i[f+11>>0]|0)<0){o=k[f>>2]|0;p=k[s+40>>2]|0;if(p>>>0>4294967279){Ra=414;break}if(p>>>0<11){i[d+47>>0]=p;if(!p)f=n;else{f=n;Ra=422}}else{h=p+16&-16;g=(h|0)==0?1:h;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}k[n>>2]=f;k[d+44>>2]=h|-2147483648;k[d+40>>2]=p;Ra=422}if((Ra|0)==422){Ra=0;upb(f|0,o|0,p|0)|0}i[f+p>>0]=0}else{k[n>>2]=k[f>>2];k[n+4>>2]=k[f+4>>2];k[n+8>>2]=k[f+8>>2]}f=d+48|0;a=s+48|0;k[f>>2]=k[a>>2];k[f+4>>2]=k[a+4>>2];k[f+8>>2]=k[a+8>>2];k[f+12>>2]=k[a+12>>2];k[f+16>>2]=k[a+16>>2];k[f+20>>2]=k[a+20>>2];k[f+24>>2]=k[a+24>>2];k[f+28>>2]=k[a+28>>2];f=k[Ta>>2]|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=f;k[q>>2]=d;f=k[k[Va>>2]>>2]|0;if(f){k[Va>>2]=f;d=k[q>>2]|0}B4(k[t>>2]|0,d);k[c>>2]=(k[c>>2]|0)+1}d=k[e+4>>2]|0;if(!d)while(1){d=k[e+8>>2]|0;if((k[d>>2]|0)==(e|0))break;else e=d}else while(1){e=k[d>>2]|0;if(!e)break;else d=e}if((d|0)==(b|0)){Ra=431;break}else{s=d;e=d}}if((Ra|0)==414)hob();else if((Ra|0)==431){Va=k[b>>2]|0;Uxa(Va);Va=k[c>>2]|0;Va=(Va|0)!=0;r=Wa;return Va|0}return 0}function Wxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=a+4|0;e=b;if((i|0)!=(b|0)?(h=k[d>>2]|0,f=k[b+16>>2]|0,(h|0)>=(f|0)):0){if((f|0)>=(h|0)){k[c>>2]=e;return c|0}f=b+4|0;a=k[f>>2]|0;g=(a|0)==0;if(g){e=b;while(1){a=k[e+8>>2]|0;if((k[a>>2]|0)==(e|0))break;else e=a}}else while(1){e=k[a>>2]|0;if(!e)break;else a=e}if((a|0)!=(i|0)?(h|0)>=(k[a+16>>2]|0):0){a=k[i>>2]|0;if(!a){k[c>>2]=i;c=i;return c|0}while(1){e=k[a+16>>2]|0;if((h|0)<(e|0)){e=k[a>>2]|0;if(!e){d=34;break}else a=e}else{if((e|0)>=(h|0)){d=39;break}f=a+4|0;e=k[f>>2]|0;if(!e){d=38;break}else a=e}}if((d|0)==34){k[c>>2]=a;c=a;return c|0}else if((d|0)==38){k[c>>2]=a;c=f;return c|0}else if((d|0)==39){k[c>>2]=a;return c|0}}if(g){k[c>>2]=b;c=f;return c|0}else{k[c>>2]=a;c=a;return c|0}}if((k[a>>2]|0)!=(b|0)){a=k[b>>2]|0;if(!a){f=b;while(1){e=k[f+8>>2]|0;if((k[e>>2]|0)==(f|0))f=e;else break}}else{e=a;while(1){f=k[e+4>>2]|0;if(!f)break;else e=f}}d=k[d>>2]|0;if((k[e+16>>2]|0)>=(d|0)){a=k[i>>2]|0;if(!a){k[c>>2]=i;c=i;return c|0}while(1){e=k[a+16>>2]|0;if((d|0)<(e|0)){e=k[a>>2]|0;if(!e){d=15;break}else a=e}else{if((e|0)>=(d|0)){d=20;break}f=a+4|0;e=k[f>>2]|0;if(!e){d=19;break}else a=e}}if((d|0)==15){k[c>>2]=a;c=a;return c|0}else if((d|0)==19){k[c>>2]=a;c=f;return c|0}else if((d|0)==20){k[c>>2]=a;return c|0}}}else a=k[b>>2]|0;if(!a){k[c>>2]=b;c=b;return c|0}else{b=e;k[c>>2]=b;c=b+4|0;return c|0}return 0}function Xxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;k[a>>2]=0;h=a+4|0;k[h>>2]=0;k[a+8>>2]=0;g=b+4|0;c=(k[g>>2]|0)-(k[b>>2]|0)|0;f=c>>3;if(!f)return;if(f>>>0>536870911)ad(426534,426557,304,426811);d=(c|0)==0?1:c;while(1){c=fgb(d)|0;if(c|0){e=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){e=0;break}Qh[c&7]()}k[h>>2]=e;k[a>>2]=e;k[a+8>>2]=e+(f<<3);d=k[b>>2]|0;c=(k[g>>2]|0)-d|0;if((c|0)<=0)return;upb(e|0,d|0,c|0)|0;k[h>>2]=e+(c>>3<<3);return}function Yxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;g=$xa(b,c+4|0)|0;if(g>>>0>4)c=$xa(b,c+8|0)|0;else c=8;d=k[b+12>>2]|0;f=(k[b+16>>2]|0)-d|0;if(c>>>0>f>>>0|(c+g|0)>>>0>f>>>0)Cf(te(1)|0,19104,0);c=d+c|0;f=c+g|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;if(g>>>0>4294967279)ad(426704,426733,1183,426811);if(g>>>0<11){i[a+11>>0]=g;if(!g){g=a;i[g>>0]=0;return}else d=a}else{e=g+16&-16;b=(e|0)==0?1:e;while(1){d=fgb(b)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[a>>2]=d;k[a+8>>2]=e|-2147483648;k[a+4>>2]=g}b=d;while(1){i[b>>0]=i[c>>0]|0;c=c+1|0;if((c|0)==(f|0))break;else b=b+1|0}g=d+g|0;i[g>>0]=0;return}function Zxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=r;r=r+16|0;e=d;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;c=$xa(b,c+8|0)|0;f=$xa(b,c)|0;c=$xa(b,c+4|0)|0;k[e>>2]=f;k[e+4>>2]=c;aya(a,e);r=d;return}function _xa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=c;j=b;g=l-j|0;n=g>>3;h=a+8|0;d=k[h>>2]|0;f=k[a>>2]|0;m=f;if(n>>>0<=d-f>>3>>>0){i=a+4|0;h=k[i>>2]|0;a=h-f>>3;g=n>>>0>a>>>0;a=g?b+(a<<3)|0:c;f=h;if((a|0)==(b|0))d=m;else{e=a+-8|0;d=b;c=m;while(1){k[c>>2]=k[d>>2];k[c+4>>2]=k[d+4>>2];d=d+8|0;if((d|0)==(a|0))break;else c=c+8|0}d=m+(((e-j|0)>>>3)+1<<3)|0}if(g){d=l-a|0;if((d|0)<=0)return;upb(h|0,a|0,d|0)|0;k[i>>2]=(k[i>>2]|0)+(d>>3<<3);return}else{if((f|0)==(d|0))return;k[i>>2]=f+(~((f+-8-d|0)>>>3)<<3);return}}e=f;if(f){d=a+4|0;c=k[d>>2]|0;if((c|0)!=(m|0))k[d>>2]=c+(~((c+-8-f|0)>>>3)<<3);ggb(e);k[h>>2]=0;k[d>>2]=0;k[a>>2]=0;d=0}if(n>>>0>536870911)ad(426534,426557,304,426811);e=d>>2;e=d>>3>>>0<268435455?(e>>>0<n>>>0?n:e):536870911;if(e>>>0>536870911)bob();c=e<<3;c=(c|0)==0?1:c;while(1){d=fgb(c)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}c=a+4|0;k[c>>2]=d;k[a>>2]=d;k[h>>2]=d+(e<<3);if((g|0)<=0)return;upb(d|0,b|0,g|0)|0;k[c>>2]=d+(n<<3);return}function $xa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=b+3|0;c=k[a+12>>2]|0;e=c;if(d>>>0>=((k[a+16>>2]|0)-c|0)>>>0)Cf(te(1)|0,19104,0);c=l[e+b>>0]|0;if((k[a+36>>2]|0)==73){e=(l[e+(b+1)>>0]|0)<<8|c|(l[e+(b+2)>>0]|0)<<16|(l[e+d>>0]|0)<<24;return e|0}else{e=(l[e+(b+1)>>0]|0)<<16|c<<24|(l[e+(b+2)>>0]|0)<<8|(l[e+d>>0]|0);return e|0}return 0}function aya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>3;c=g+1|0;if(c>>>0>536870911)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>2;f=e>>3>>>0<268435455?(f>>>0<c>>>0?c:f):536870911;if(!f)c=0;else{if(f>>>0>536870911){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<3)|0;m=b;b=k[m+4>>2]|0;d=e;k[d>>2]=k[m>>2];k[d+4>>2]=b;d=e+(0-g<<3)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+8;k[l>>2]=c+(f<<3);if(!i)return;ggb(i);return}function bya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;d=k[b>>2]|0;if(d){c=k[b+4>>2]|0;if(!c)c=b;else while(1){d=k[c>>2]|0;if(!d){d=0;break}else c=d}}else{c=b;d=0}j=c+4|0;l=k[((d|0)==0?j:c)>>2]|0;m=(l|0)==0;g=c+8|0;if(!m)k[l+8>>2]=k[g>>2];d=k[g>>2]|0;e=k[d>>2]|0;if((e|0)==(c|0)){k[d>>2]=l;if((c|0)==(a|0)){a=l;e=0}else e=k[d+4>>2]|0}else k[d+4>>2]=l;f=c+12|0;h=(i[f>>0]|0)==0;if((c|0)!=(b|0)){o=b+8|0;d=k[o>>2]|0;k[g>>2]=d;if((k[k[o>>2]>>2]|0)==(b|0))k[d>>2]=c;else k[d+4>>2]=c;d=k[b>>2]|0;k[c>>2]=d;k[d+8>>2]=c;d=k[b+4>>2]|0;k[j>>2]=d;if(d|0)k[d+8>>2]=c;i[f>>0]=i[b+12>>0]|0;a=(a|0)==(b|0)?c:a}if(h|(a|0)==0)return;if(m)j=e;else{i[l+12>>0]=1;return}while(1){f=j+8|0;g=k[f>>2]|0;c=j+12|0;d=(i[c>>0]|0)!=0;if((k[g>>2]|0)==(j|0)){if(d)h=j;else{i[c>>0]=1;i[g+12>>0]=0;e=j+4|0;c=k[e>>2]|0;k[g>>2]=c;if(c|0)k[c+8>>2]=g;d=g+8|0;k[f>>2]=k[d>>2];c=k[d>>2]|0;if((k[c>>2]|0)==(g|0))k[c>>2]=j;else k[c+4>>2]=j;k[e>>2]=g;k[d>>2]=j;h=k[g>>2]|0;a=(a|0)==(g|0)?j:a}f=k[h>>2]|0;e=(f|0)==0;if(!e?(i[f+12>>0]|0)==0:0){c=h;a=f;g=75;break}c=h+4|0;d=k[c>>2]|0;if(d|0?(i[d+12>>0]|0)==0:0){g=66;break}i[h+12>>0]=0;c=k[h+8>>2]|0;d=c+12|0;if((c|0)==(a|0)|(i[d>>0]|0)==0){g=63;break}o=k[c+8>>2]|0;c=(k[o>>2]|0)==(c|0)?o+4|0:o}else{if(d)f=j;else{i[c>>0]=1;i[g+12>>0]=0;o=g+4|0;e=k[o>>2]|0;c=k[e>>2]|0;k[o>>2]=c;if(c|0)k[c+8>>2]=g;c=g+8|0;k[e+8>>2]=k[c>>2];d=k[c>>2]|0;if((k[d>>2]|0)==(g|0))k[d>>2]=e;else k[d+4>>2]=e;k[e>>2]=g;k[c>>2]=e;o=k[j>>2]|0;f=k[o+4>>2]|0;a=(a|0)==(o|0)?j:a}e=k[f>>2]|0;if(e|0?(n=e+12|0,(i[n>>0]|0)==0):0){g=36;break}c=k[f+4>>2]|0;if(c|0?(i[c+12>>0]|0)==0:0){d=f;a=c;g=45;break}i[f+12>>0]=0;c=k[f+8>>2]|0;if((c|0)==(a|0)){g=34;break}if(!(i[c+12>>0]|0)){a=c;g=34;break}o=k[c+8>>2]|0;c=(k[o>>2]|0)==(c|0)?o+4|0:o}j=k[c>>2]|0}do if((g|0)==34){i[a+12>>0]=1;return}else if((g|0)==36){a=k[f+4>>2]|0;if(!a)a=n;else{if(!(i[a+12>>0]|0)){d=f;g=45;break}a=e+12|0}i[a>>0]=1;i[f+12>>0]=0;d=e+4|0;a=k[d>>2]|0;k[f>>2]=a;if(a|0)k[a+8>>2]=f;c=f+8|0;k[e+8>>2]=k[c>>2];a=k[c>>2]|0;if((k[a>>2]|0)==(f|0))k[a>>2]=e;else k[a+4>>2]=e;k[d>>2]=f;k[c>>2]=e;d=e;a=f;g=45}else if((g|0)==63){i[d>>0]=1;return}else if((g|0)==66){if(!e){if(!(i[f+12>>0]|0)){c=h;a=f;g=75;break}d=h+4|0;c=d;d=k[d>>2]|0}i[d+12>>0]=1;i[h+12>>0]=0;a=k[d>>2]|0;k[c>>2]=a;if(a|0)k[a+8>>2]=h;a=h+8|0;k[d+8>>2]=k[a>>2];c=k[a>>2]|0;if((k[c>>2]|0)==(h|0))k[c>>2]=d;else k[c+4>>2]=d;k[d>>2]=h;k[a>>2]=d;c=d;a=h;g=75}while(0);if((g|0)==45){e=k[d+8>>2]|0;o=e+12|0;i[d+12>>0]=i[o>>0]|0;i[o>>0]=1;i[a+12>>0]=1;o=e+4|0;d=k[o>>2]|0;a=k[d>>2]|0;k[o>>2]=a;if(a|0)k[a+8>>2]=e;a=e+8|0;k[d+8>>2]=k[a>>2];c=k[a>>2]|0;if((k[c>>2]|0)==(e|0))k[c>>2]=d;else k[c+4>>2]=d;k[d>>2]=e;k[a>>2]=d;return}else if((g|0)==75){f=k[c+8>>2]|0;d=f+12|0;i[c+12>>0]=i[d>>0]|0;i[d>>0]=1;i[a+12>>0]=1;d=k[f>>2]|0;e=d+4|0;a=k[e>>2]|0;k[f>>2]=a;if(a|0)k[a+8>>2]=f;a=f+8|0;k[d+8>>2]=k[a>>2];c=k[a>>2]|0;if((k[c>>2]|0)==(f|0))k[c>>2]=d;else k[c+4>>2]=d;k[e>>2]=f;k[a>>2]=d;return}}function cya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=a+32|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;k[a+24>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;j[a+48>>1]=-1;f=a+50|0;j[f>>1]=0;j[f+2>>1]=0;j[f+4>>1]=0;f=b+28|0;b=k[f>>2]|0;if(!b)return;else{e=f;d=b}a:while(1){b=d;while(1){if((k[b+16>>2]|0)>=(c|0))break;b=k[b+4>>2]|0;if(!b)break a}d=k[b>>2]|0;if(!d){e=b;break}else e=b}if((e|0)==(f|0))return;if((k[e+16>>2]|0)>(c|0))return;b=e+24|0;if((b|0)!=(a|0))_xa(a,k[b>>2]|0,k[e+28>>2]|0);b=a+12|0;d=e+36|0;if((b|0)!=(d|0)){c=i[d+11>>0]|0;f=c<<24>>24<0;lob(b,f?k[d>>2]|0:d,f?k[e+40>>2]|0:c&255)}a=a+24|0;c=e+48|0;k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];k[a+8>>2]=k[c+8>>2];k[a+12>>2]=k[c+12>>2];k[a+16>>2]=k[c+16>>2];k[a+20>>2]=k[c+20>>2];k[a+24>>2]=k[c+24>>2];k[a+28>>2]=k[c+28>>2];return}function dya(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=c*3|0;f=a+e|0;if((e|0)>24){c=a;a=a+24|0;while(1){e=b+1|0;b=l[b>>0]|0;g=d+(b>>>7<<2)|0;g=l[g>>0]|l[g+1>>0]<<8|l[g+2>>0]<<16|l[g+3>>0]<<24;i[c>>0]=g;i[c+1>>0]=g>>8;i[c+2>>0]=g>>16;i[c+3>>0]=g>>24;g=c+3|0;h=d+((b>>>6&1)<<2)|0;h=l[h>>0]|l[h+1>>0]<<8|l[h+2>>0]<<16|l[h+3>>0]<<24;i[g>>0]=h;i[g+1>>0]=h>>8;i[g+2>>0]=h>>16;i[g+3>>0]=h>>24;g=c+6|0;h=d+((b>>>5&1)<<2)|0;h=l[h>>0]|l[h+1>>0]<<8|l[h+2>>0]<<16|l[h+3>>0]<<24;i[g>>0]=h;i[g+1>>0]=h>>8;i[g+2>>0]=h>>16;i[g+3>>0]=h>>24;g=c+9|0;h=d+((b>>>4&1)<<2)|0;h=l[h>>0]|l[h+1>>0]<<8|l[h+2>>0]<<16|l[h+3>>0]<<24;i[g>>0]=h;i[g+1>>0]=h>>8;i[g+2>>0]=h>>16;i[g+3>>0]=h>>24;g=c+12|0;h=d+((b>>>3&1)<<2)|0;h=l[h>>0]|l[h+1>>0]<<8|l[h+2>>0]<<16|l[h+3>>0]<<24;i[g>>0]=h;i[g+1>>0]=h>>8;i[g+2>>0]=h>>16;i[g+3>>0]=h>>24;g=c+15|0;h=d+((b>>>2&1)<<2)|0;h=l[h>>0]|l[h+1>>0]<<8|l[h+2>>0]<<16|l[h+3>>0]<<24;i[g>>0]=h;i[g+1>>0]=h>>8;i[g+2>>0]=h>>16;i[g+3>>0]=h>>24;g=c+18|0;h=d+((b>>>1&1)<<2)|0;h=l[h>>0]|l[h+1>>0]<<8|l[h+2>>0]<<16|l[h+3>>0]<<24;i[g>>0]=h;i[g+1>>0]=h>>8;i[g+2>>0]=h>>16;i[g+3>>0]=h>>24;c=c+21|0;b=d+((b&1)<<2)|0;b=l[b>>0]|l[b+1>>0]<<8|l[b+2>>0]<<16|l[b+3>>0]<<24;i[c>>0]=b;i[c+1>>0]=b>>8;i[c+2>>0]=b>>16;i[c+3>>0]=b>>24;c=a+24|0;if(c>>>0<f>>>0){h=a;b=e;a=c;c=h}else{b=e;break}}}if(a>>>0>=f>>>0)return;c=(l[b>>0]|0)<<24;b=a;while(1){e=c>>>31;g=i[d+(e<<2)+1>>0]|0;h=i[d+(e<<2)+2>>0]|0;i[b>>0]=i[d+(e<<2)>>0]|0;i[b+1>>0]=g;i[b+2>>0]=h;b=b+3|0;if(b>>>0>=f>>>0)break;else c=c<<1}return}function eya(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;j=a+c|0;if((c|0)>8){h=a+16|0;h=((j>>>0>h>>>0?j:h)+(-9-a)|0)>>>3;f=(h<<3)+8|0;c=a;e=b;g=a+8|0;while(1){k=l[e>>0]|0;i[c>>0]=i[d+(k>>>7)>>0]|0;i[c+1>>0]=i[d+(k>>>6&1)>>0]|0;i[c+2>>0]=i[d+(k>>>5&1)>>0]|0;i[c+3>>0]=i[d+(k>>>4&1)>>0]|0;i[c+4>>0]=i[d+(k>>>3&1)>>0]|0;i[c+5>>0]=i[d+(k>>>2&1)>>0]|0;i[c+6>>0]=i[d+(k>>>1&1)>>0]|0;i[c+7>>0]=i[d+(k&1)>>0]|0;c=g+8|0;if(c>>>0<j>>>0){k=g;e=e+1|0;g=c;c=k}else break}a=a+f|0;b=b+(h+1)|0}if(a>>>0>=j>>>0)return;c=(l[b>>0]|0)<<24;b=a;while(1){i[b>>0]=i[d+(c>>>31)>>0]|0;b=b+1|0;if((b|0)==(j|0))break;else c=c<<1}return}function fya(a){a=a|0;Tva(a);ggb(a);return}function gya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=a+20|0;if((d|0)!=(b|0)){c=k[d>>2]|0;e=a+24|0;k[e>>2]=0;k[d>>2]=0;if(c|0?(g=c+-4|0,f=k[g>>2]|0,k[g>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);c=k[b>>2]|0;if(!c)c=0;else{c=c+-4|0;k[c>>2]=(k[c>>2]|0)+1;c=k[b>>2]|0}k[d>>2]=c;k[e>>2]=k[b+4>>2]}d=a+72|0;c=k[d>>2]|0;if(c|0?(f=c+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){b=k[d>>2]|0;if(b|0){c=k[b+4>>2]|0;if(!c){c=k[a+68>>2]|0;if(!c){c=B1()|0;b=k[d>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,b)}k[d>>2]=0}k[d>>2]=0;g=a+52|0;d=a+40|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[d>>2]|0)<=0)return 1;b=k[a+76>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0));return 1}function hya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;if(!(i[a+92>>0]|0)){e=0;return e|0}c=a+20|0;d=k[c>>2]|0;e=a+24|0;k[e>>2]=0;k[c>>2]=0;if(d|0?(g=d+-4|0,f=k[g>>2]|0,k[g>>2]=f+-1,(f|0)==1):0)ggb(k[d+-8>>2]|0);k[c>>2]=0;k[e>>2]=0;KG(a+36|0,b)|0;g=1;return g|0}function iya(a,b){a=a|0;b=b|0;var c=0;c=a+16|0;a=k[c>>2]|0;k[c>>2]=k[b>>2];return a|0}function jya(a){a=a|0;return k[a+32>>2]|0}function kya(a,b){a=a|0;b=b|0;var c=0,d=0;c=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0;if((k[b+4>>2]|0)>>>0<c>>>0){d=0;return d|0}b=k[b>>2]|0;d=k[a+28>>2]|0;if(!c){d=1;return d|0}a=(b|0)==0?1016759:b;b=(d|0)==0?1016759:d;while(1){if((i[a>>0]|0)!=(i[b>>0]|0)){b=0;c=6;break}c=c+-1|0;if(!c){b=1;c=6;break}else{a=a+1|0;b=b+1|0}}if((c|0)==6)return b|0;return 0}function lya(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;return}function mya(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b)return;c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1)return;ggb(k[b+-8>>2]|0);return}function nya(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90552;c=a+28|0;b=k[c>>2]|0;k[a+32>>2]=0;k[c>>2]=0;if(b|0?(d=b+-4|0,c=k[d>>2]|0,k[d>>2]=c+-1,(c|0)==1):0)ggb(k[b+-8>>2]|0);d=a+12|0;b=k[d>>2]|0;k[a+16>>2]=0;k[d>>2]=0;if(b|0?(c=b+-4|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0)ggb(k[b+-8>>2]|0);d=a+4|0;b=k[d>>2]|0;k[a+8>>2]=0;k[d>>2]=0;if(!b){ggb(a);return}c=b+-4|0;d=k[c>>2]|0;k[c>>2]=d+-1;if((d|0)!=1){ggb(a);return}ggb(k[b+-8>>2]|0);ggb(a);return}function oya(a,b){a=a|0;b=b|0;return (b|0)==0|0}function pya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=a+12|0;if((d|0)==(b|0)){e=a+20|0;k[e>>2]=0;return 1}c=k[d>>2]|0;e=a+16|0;k[e>>2]=0;k[d>>2]=0;if(c|0?(g=c+-4|0,f=k[g>>2]|0,k[g>>2]=f+-1,(f|0)==1):0)ggb(k[c+-8>>2]|0);c=k[b>>2]|0;if(!c)c=0;else{c=c+-4|0;k[c>>2]=(k[c>>2]|0)+1;c=k[b>>2]|0}k[d>>2]=c;k[e>>2]=k[b+4>>2];g=a+20|0;k[g>>2]=0;return 1}function qya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!(i[a+24>>0]|0)){a=0;return a|0}k[a+20>>2]=b;c=k[b>>2]|0;b=b+4|0;if((k[b>>2]|0)!=(c|0))k[b>>2]=c;c=a+12|0;d=k[c>>2]|0;b=a+16|0;k[b>>2]=0;k[c>>2]=0;if(d|0?(e=d+-4|0,a=k[e>>2]|0,k[e>>2]=a+-1,(a|0)==1):0)ggb(k[d+-8>>2]|0);k[c>>2]=0;k[b>>2]=0;e=1;return e|0}function rya(a,b){a=a|0;b=b|0;var c=0;c=k[b+4>>2]|0;k[a>>2]=c;k[a+4>>2]=k[b+8>>2];if(!c)return;c=c+-4|0;k[c>>2]=(k[c>>2]|0)+1;return}function sya(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;return}function tya(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;h=m;e=a+32|0;b=k[e>>2]|0;if(!b){r=m;return}j=ZT(b+33&-4)|0;k[j>>2]=1;l=j+4|0;i[l+(b+25)>>0]=0;b=l;c=359978;d=b+25|0;do{i[b>>0]=i[c>>0]|0;b=b+1|0;c=c+1|0}while((b|0)<(d|0));upb(j+29|0,k[a+28>>2]|0,k[e>>2]|0)|0;k[h>>2]=0;f=h+4|0;k[f>>2]=0;e=l;a:do if(!(e&3)){b=l;g=6}else{a=l;c=82;b=e;while(1){if(!(c<<24>>24))break a;b=a+1|0;d=b;if(!(d&3)){g=6;break a}a=b;c=i[b>>0]|0;b=d}}while(0);if((g|0)==6){while(1){c=k[b>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))b=b+4|0;else break}if((c&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}g=b-e|0;b=ZT(g+8&-4)|0;k[b>>2]=1;e=b+4|0;k[h>>2]=e;k[f>>2]=g;i[e+g>>0]=0;upb(e|0,l|0,g|0)|0;Y8(-10,h,360004,360016,139);k[f>>2]=0;k[h>>2]=0;l=k[b>>2]|0;k[b>>2]=l+-1;if((l|0)==1)ggb(k[b+-4>>2]|0);l=k[j>>2]|0;k[j>>2]=l+-1;if((l|0)!=1){r=m;return}ggb(k[j+-4>>2]|0);r=m;return}function uya(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=r;r=r+80|0;f=n+56|0;j=n;while(1){b=fgb(192)|0;if(b|0){m=b;break}b=k[207666]|0;k[207666]=b+0;if(!b){m=0;break}Qh[b&7]()}k[m>>2]=90616;e=m+4|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;k[e+16>>2]=0;k[e+20>>2]=0;k[m+96>>2]=3;k[m+100>>2]=1e3;p[m+104>>3]=.01;k[m+112>>2]=1;p[m+128>>3]=.1;p[m+120>>3]=.1;p[m+136>>3]=.1;p[m+144>>3]=1.2;p[m+152>>3]=.5;p[m+160>>3]=1.1920928955078125e-07;p[m+168>>3]=50.0;e=m+176|0;k[e>>2]=-1;k[e+4>>2]=0;m9(m+184|0);Uh[k[(k[m>>2]|0)+8>>2]&2047](m);mh[k[(k[m>>2]|0)+68>>2]&15](m,1,0.0,0.0);e=k[(k[m>>2]|0)+72>>2]|0;k[j>>2]=1124007936;l=j+4|0;b=j+8|0;h=j+40|0;c=l;d=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(d|0));k[h>>2]=b;i=j+48|0;g=j+44|0;k[g>>2]=i;k[j+52>>2]=0;k[i>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=j;jh[e&1023](m,f);d=j+36|0;b=k[d>>2]|0;if(b|0?(e=b+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[j+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;j=j+16|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[l>>2]|0)>0){c=k[h>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[l>>2]|0))}b=k[g>>2]|0;if(!((b|0)==(i|0)|(b|0)==0))ggb(k[b+-4>>2]|0);mh[k[(k[m>>2]|0)+60>>2]&15](m,1,.1,1.1920928955078125e-07);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}l=b+4|0;k[l>>2]=1;k[b>>2]=90596;k[b+8>>2]=m;k[a>>2]=b;k[a+4>>2]=m;k[l>>2]=(k[l>>2]|0)+1;a=k[l>>2]|0;k[l>>2]=a+-1;if((a|0)!=1){r=n;return}Uh[k[(k[b>>2]|0)+8>>2]&2047](b);r=n;return}function vya(a){a=a|0;ggb(a);return}function wya(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function xya(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=90616;b=a+184|0;e=(k[b>>2]|0)+28|0;d=k[e>>2]|0;k[e>>2]=d+-1;if((d|0)==1?(c=k[b>>2]|0,c|0):0){rf(c|0)|0;ggb(c)}k[b>>2]=0;zF(a+16|0);d=k[a+4>>2]|0;if(!d)return;b=a+8|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-4-d|0)>>>2)<<2);ggb(d);return}function yya(a){a=a|0;xya(a);ggb(a);return}function zya(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;f=a+48|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[f+28>>2]=0;f=a+176|0;k[f>>2]=-1;k[f+4>>2]=-1;f=k[a+16>>2]|0;g=a+20|0;b=k[g>>2]|0;if((b|0)==(f|0)){g=a+188|0;i[g>>0]=0;g=a+88|0;k[g>>2]=4096;return}do{k[g>>2]=b+-56;e=b+-20|0;c=k[e>>2]|0;if(c|0?(c=c+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[b+-24>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;e=b+-40|0;d=b+-52|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[d>>2]|0)>0){e=k[b+-16>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[b+-12>>2]|0;if(!((c|0)==(b+-8|0)|(c|0)==0))ggb(k[c+-4>>2]|0);b=k[g>>2]|0}while((b|0)!=(f|0));g=a+188|0;i[g>>0]=0;g=a+88|0;k[g>>2]=4096;return}function Aya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+16|0;t=u;g=a+4|0;c=k[g>>2]|0;d=k[a+8>>2]|0;if((c|0)==(d|0)){r=u;return}q=d-c|0;s=q>>2;k[t>>2]=0;d=t+4|0;k[d>>2]=0;n=ZT(16)|0;k[n>>2]=1;l=n+4|0;k[t>>2]=l;k[d>>2]=11;i[n+15>>0]=0;n=361355;o=l+11|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));f=z6(b,t)|0;c=k[t>>2]|0;k[d>>2]=0;k[t>>2]=0;if(c|0?(o=c+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[c+-8>>2]|0);if(Xh[k[(k[f>>2]|0)+12>>2]&1023](f)|0){c=f+32|0;if((k[c>>2]|0)==6){d=t+4|0;e=ZT(36)|0;k[e>>2]=1;l=e+4|0;k[t>>2]=l;k[d>>2]=30;i[e+34>>0]=0;n=401220;o=l+30|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));Y8(-2,t,401251,401262,1064);k[d>>2]=0;k[t>>2]=0;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0)}E6(t,f,k[f+12>>2]|0,k[f+16>>2]|0,13,0,0);hza(f,g);F6(t);if(k[c>>2]&4|0)k[c>>2]=6}j=a+80|0;c=k[j>>2]|0;if(c)if((c|0)!=1)if((c|0)==2){h=361450;m=15}else{k[t>>2]=0;e=t+4|0;k[e>>2]=0;n=ZT(28)|0;k[n>>2]=1;l=n+4|0;k[t>>2]=l;k[e>>2]=22;i[n+26>>0]=0;n=361475;o=l+22|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));c=z6(b,t)|0;d=k[t>>2]|0;k[e>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);iza(c,j)}else{h=361429;m=15}else{h=361441;m=15}if((m|0)==15){k[t>>2]=0;d=t+4|0;k[d>>2]=0;n=ZT(24)|0;k[n>>2]=1;l=n+4|0;k[t>>2]=l;k[d>>2]=19;i[n+23>>0]=0;n=361409;o=l+19|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));g=z6(b,t)|0;c=k[t>>2]|0;k[d>>2]=0;k[t>>2]=0;if(c|0?(o=c+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[c+-8>>2]|0);k[t>>2]=0;f=t+4|0;k[f>>2]=0;e=h;a:do if(!(e&3)){c=h;m=21}else{c=h;d=e;while(1){if(!(i[c>>0]|0)){c=d;break a}c=c+1|0;d=c;if(!(d&3)){m=21;break}}}while(0);if((m|0)==21){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}c=c-e|0;p=ZT(c+8&-4)|0;k[p>>2]=1;p=p+4|0;k[t>>2]=p;k[f>>2]=c;i[p+c>>0]=0;upb(k[t>>2]|0,h|0,c|0)|0;z6(g,t)|0;c=k[t>>2]|0;k[f>>2]=0;k[t>>2]=0;if(c|0?(o=c+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[c+-8>>2]|0)}if(k[j>>2]|0){k[t>>2]=0;p=t+4|0;k[p>>2]=0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[t>>2]=c;k[p>>2]=8;i[d+12>>0]=0;d=c;i[d>>0]=102;i[d+1>>0]=95;i[d+2>>0]=112;i[d+3>>0]=97;c=c+4|0;i[c>>0]=114;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=49;c=z6(b,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);jza(c,a+32|0)|0;k[t>>2]=0;p=t+4|0;k[p>>2]=0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[t>>2]=c;k[p>>2]=8;i[d+12>>0]=0;d=c;i[d>>0]=102;i[d+1>>0]=95;i[d+2>>0]=112;i[d+3>>0]=97;c=c+4|0;i[c>>0]=114;i[c+1>>0]=97;i[c+2>>0]=109;i[c+3>>0]=50;c=z6(b,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);jza(c,a+40|0)|0}k[t>>2]=0;p=t+4|0;k[p>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[t>>2]=c;k[p>>2]=7;i[d+11>>0]=0;i[c>>0]=i[361516]|0;i[c+1>>0]=i[361517]|0;i[c+2>>0]=i[361518]|0;i[c+3>>0]=i[361519]|0;i[c+4>>0]=i[361520]|0;i[c+5>>0]=i[361521]|0;i[c+6>>0]=i[361522]|0;c=z6(b,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);c=jza(c,a+48|0)|0;k[t>>2]=0;p=t+4|0;k[p>>2]=0;o=ZT(12)|0;k[o>>2]=1;d=o+4|0;k[t>>2]=d;k[p>>2]=7;i[o+11>>0]=0;i[d>>0]=i[361524]|0;i[d+1>>0]=i[361525]|0;i[d+2>>0]=i[361526]|0;i[d+3>>0]=i[361527]|0;i[d+4>>0]=i[361528]|0;i[d+5>>0]=i[361529]|0;i[d+6>>0]=i[361530]|0;c=z6(c,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);c=jza(c,a+56|0)|0;k[t>>2]=0;p=t+4|0;k[p>>2]=0;o=ZT(16)|0;k[o>>2]=1;d=o+4|0;k[t>>2]=d;k[p>>2]=8;i[o+12>>0]=0;o=d;i[o>>0]=109;i[o+1>>0]=105;i[o+2>>0]=110;i[o+3>>0]=95;d=d+4|0;i[d>>0]=118;i[d+1>>0]=97;i[d+2>>0]=108;i[d+3>>0]=49;c=z6(c,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);c=jza(c,a+64|0)|0;k[t>>2]=0;p=t+4|0;k[p>>2]=0;o=ZT(16)|0;k[o>>2]=1;d=o+4|0;k[t>>2]=d;k[p>>2]=8;i[o+12>>0]=0;o=d;i[o>>0]=109;i[o+1>>0]=97;i[o+2>>0]=120;i[o+3>>0]=95;d=d+4|0;i[d>>0]=118;i[d+1>>0]=97;i[d+2>>0]=108;i[d+3>>0]=49;c=z6(c,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);jza(c,a+72|0)|0;k[t>>2]=0;e=t+4|0;k[e>>2]=0;n=ZT(20)|0;k[n>>2]=1;l=n+4|0;k[t>>2]=l;k[e>>2]=15;i[n+19>>0]=0;n=370919;o=l+15|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));c=z6(b,t)|0;d=k[t>>2]|0;k[e>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);k[t>>2]=0;p=t+4|0;k[p>>2]=0;n=ZT(8)|0;k[n>>2]=1;o=n+4|0;k[t>>2]=o;k[p>>2]=1;i[n+5>>0]=0;i[o>>0]=123;z6(c,t)|0;c=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(c|0?(o=c+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[c+-8>>2]|0);switch(k[a+112>>2]|0){case 0:{k[t>>2]=0;e=t+4|0;k[e>>2]=0;n=ZT(20)|0;k[n>>2]=1;l=n+4|0;k[t>>2]=l;k[e>>2]=12;i[n+16>>0]=0;n=366905;o=l+12|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));c=z6(b,t)|0;d=k[t>>2]|0;k[e>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);k[t>>2]=0;p=t+4|0;k[p>>2]=0;n=ZT(16)|0;k[n>>2]=1;o=n+4|0;k[t>>2]=o;k[p>>2]=8;i[n+12>>0]=0;n=o;i[n>>0]=66;i[n+1>>0]=65;i[n+2>>0]=67;i[n+3>>0]=75;o=o+4|0;i[o>>0]=80;i[o+1>>0]=82;i[o+2>>0]=79;i[o+3>>0]=80;z6(c,t)|0;c=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(c|0?(o=c+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[c+-8>>2]|0);k[t>>2]=0;p=t+4|0;k[p>>2]=0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[t>>2]=c;k[p>>2]=8;i[d+12>>0]=0;d=c;i[d>>0]=100;i[d+1>>0]=119;i[d+2>>0]=95;i[d+3>>0]=115;c=c+4|0;i[c>>0]=99;i[c+1>>0]=97;i[c+2>>0]=108;i[c+3>>0]=101;c=z6(b,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);jza(c,a+120|0)|0;k[t>>2]=0;e=t+4|0;k[e>>2]=0;n=ZT(20)|0;k[n>>2]=1;l=n+4|0;k[t>>2]=l;k[e>>2]=12;i[n+16>>0]=0;n=361568;o=l+12|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));c=z6(b,t)|0;d=k[t>>2]|0;k[e>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);jza(c,a+128|0)|0;break}case 1:{k[t>>2]=0;e=t+4|0;k[e>>2]=0;n=ZT(20)|0;k[n>>2]=1;l=n+4|0;k[t>>2]=l;k[e>>2]=12;i[n+16>>0]=0;n=366905;o=l+12|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));c=z6(b,t)|0;d=k[t>>2]|0;k[e>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);k[t>>2]=0;p=t+4|0;k[p>>2]=0;n=ZT(12)|0;k[n>>2]=1;o=n+4|0;k[t>>2]=o;k[p>>2]=5;i[n+9>>0]=0;i[o>>0]=i[361581]|0;i[o+1>>0]=i[361582]|0;i[o+2>>0]=i[361583]|0;i[o+3>>0]=i[361584]|0;i[o+4>>0]=i[361585]|0;z6(c,t)|0;c=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(c|0?(o=c+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[c+-8>>2]|0);k[t>>2]=0;p=t+4|0;k[p>>2]=0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[t>>2]=c;k[p>>2]=3;i[d+7>>0]=0;i[c>>0]=i[361587]|0;i[c+1>>0]=i[361588]|0;i[c+2>>0]=i[361589]|0;c=z6(b,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);jza(c,a+136|0)|0;k[t>>2]=0;p=t+4|0;k[p>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[t>>2]=c;k[p>>2]=7;i[d+11>>0]=0;i[c>>0]=i[361591]|0;i[c+1>>0]=i[361592]|0;i[c+2>>0]=i[361593]|0;i[c+3>>0]=i[361594]|0;i[c+4>>0]=i[361595]|0;i[c+5>>0]=i[361596]|0;i[c+6>>0]=i[361597]|0;c=z6(b,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);jza(c,a+144|0)|0;k[t>>2]=0;p=t+4|0;k[p>>2]=0;d=ZT(16)|0;k[d>>2]=1;c=d+4|0;k[t>>2]=c;k[p>>2]=8;i[d+12>>0]=0;d=c;i[d>>0]=100;i[d+1>>0]=119;i[d+2>>0]=95;i[d+3>>0]=109;c=c+4|0;i[c>>0]=105;i[c+1>>0]=110;i[c+2>>0]=117;i[c+3>>0]=115;c=z6(b,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);jza(c,a+152|0)|0;k[t>>2]=0;p=t+4|0;k[p>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[t>>2]=c;k[p>>2]=6;i[d+10>>0]=0;i[c>>0]=i[361608]|0;i[c+1>>0]=i[361609]|0;i[c+2>>0]=i[361610]|0;i[c+3>>0]=i[361611]|0;i[c+4>>0]=i[361612]|0;i[c+5>>0]=i[361613]|0;c=z6(b,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);jza(c,a+160|0)|0;k[t>>2]=0;p=t+4|0;k[p>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[t>>2]=c;k[p>>2]=6;i[d+10>>0]=0;i[c>>0]=i[361615]|0;i[c+1>>0]=i[361616]|0;i[c+2>>0]=i[361617]|0;i[c+3>>0]=i[361618]|0;i[c+4>>0]=i[361619]|0;i[c+5>>0]=i[361620]|0;c=z6(b,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;do if(d|0){o=d+-4|0;p=k[o>>2]|0;k[o>>2]=p+-1;if((p|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);jza(c,a+168|0)|0;break}default:{c=t+4|0;d=ZT(28)|0;k[d>>2]=1;l=d+4|0;k[t>>2]=l;k[c>>2]=23;i[d+27>>0]=0;n=361676;o=l+23|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));Y8(-2,t,361700,360247,1138);k[c>>2]=0;k[t>>2]=0;p=k[d>>2]|0;k[d>>2]=p+-1;if((p|0)==1)ggb(k[d+-4>>2]|0)}}k[t>>2]=0;e=t+4|0;k[e>>2]=0;n=ZT(20)|0;k[n>>2]=1;l=n+4|0;k[t>>2]=l;k[e>>2]=13;i[n+17>>0]=0;n=370605;o=l+13|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));c=z6(b,t)|0;d=k[t>>2]|0;k[e>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);k[t>>2]=0;p=t+4|0;k[p>>2]=0;n=ZT(8)|0;k[n>>2]=1;o=n+4|0;k[t>>2]=o;k[p>>2]=1;i[n+5>>0]=0;i[o>>0]=123;z6(c,t)|0;c=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(c|0?(o=c+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[c+-8>>2]|0);e=a+96|0;c=k[e>>2]|0;if(c&2){k[t>>2]=0;p=t+4|0;k[p>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[t>>2]=c;k[p>>2]=7;i[d+11>>0]=0;i[c>>0]=i[370619]|0;i[c+1>>0]=i[370620]|0;i[c+2>>0]=i[370621]|0;i[c+3>>0]=i[370622]|0;i[c+4>>0]=i[370623]|0;i[c+5>>0]=i[370624]|0;i[c+6>>0]=i[370625]|0;c=z6(b,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);jza(c,a+104|0)|0;c=k[e>>2]|0}if(c&1|0){k[t>>2]=0;e=t+4|0;k[e>>2]=0;n=ZT(16)|0;k[n>>2]=1;l=n+4|0;k[t>>2]=l;k[e>>2]=10;i[n+14>>0]=0;n=375191;o=l+10|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));c=z6(b,t)|0;d=k[t>>2]|0;k[e>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);iza(c,a+100|0)}k[t>>2]=0;p=t+4|0;k[p>>2]=0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[t>>2]=c;k[p>>2]=1;i[d+5>>0]=0;i[c>>0]=125;c=z6(b,t)|0;d=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(d|0?(o=d+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[d+-8>>2]|0);k[t>>2]=0;p=t+4|0;k[p>>2]=0;n=ZT(8)|0;k[n>>2]=1;o=n+4|0;k[t>>2]=o;k[p>>2]=1;i[n+5>>0]=0;i[o>>0]=125;z6(c,t)|0;c=k[t>>2]|0;k[p>>2]=0;k[t>>2]=0;if(c|0?(o=c+-4|0,p=k[o>>2]|0,k[o>>2]=p+-1,(p|0)==1):0)ggb(k[c+-8>>2]|0);p=a+16|0;c=k[p>>2]|0;d=k[c+4>>2]|0;if((d|0)>0)a=k[(k[c+44>>2]|0)+(d+-1<<2)>>2]|0;else a=0;k[t>>2]=0;e=t+4|0;k[e>>2]=0;n=ZT(16)|0;k[n>>2]=1;l=n+4|0;k[t>>2]=l;k[e>>2]=11;i[n+15>>0]=0;n=361367;o=l+11|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));c=z6(b,t)|0;d=k[t>>2]|0;k[e>>2]=0;k[t>>2]=0;do if(d|0){n=d+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[t>>2]=0;o=t+4|0;k[o>>2]=0;m=ZT(8)|0;k[m>>2]=1;n=m+4|0;k[t>>2]=n;k[o>>2]=1;i[m+5>>0]=0;i[n>>0]=91;z6(c,t)|0;c=k[t>>2]|0;k[o>>2]=0;k[t>>2]=0;do if(c|0){n=c+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);g=t+4|0;h=ZT(8)|0;k[h>>2]=1;c=h+4|0;k[t>>2]=c;k[g>>2]=1;i[h+5>>0]=0;i[c>>0]=100;c=k[p>>2]|0;j=k[c+16>>2]|0;f=k[c+4>>2]|0;if((f|0)<3)c=aa(k[c+12>>2]|0,k[c+8>>2]|0)|0;else{e=k[c+40>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0))}A6(b,t,j,aa(c,a)|0);k[g>>2]=0;k[t>>2]=0;o=k[h>>2]|0;k[h>>2]=o+-1;if((o|0)==1)ggb(k[h+-4>>2]|0);k[t>>2]=0;o=t+4|0;k[o>>2]=0;c=ZT(8)|0;k[c>>2]=1;d=c+4|0;k[t>>2]=d;k[o>>2]=1;i[c+5>>0]=0;i[d>>0]=93;d=z6(b,t)|0;c=k[t>>2]|0;k[o>>2]=0;k[t>>2]=0;do if(c|0){n=c+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[t>>2]=0;e=t+4|0;k[e>>2]=0;n=ZT(20)|0;k[n>>2]=1;l=n+4|0;k[t>>2]=l;k[e>>2]=12;i[n+16>>0]=0;n=361379;o=l+12|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));c=z6(d,t)|0;d=k[t>>2]|0;k[e>>2]=0;k[t>>2]=0;do if(d|0){n=d+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[t>>2]=0;o=t+4|0;k[o>>2]=0;m=ZT(8)|0;k[m>>2]=1;n=m+4|0;k[t>>2]=n;k[o>>2]=1;i[m+5>>0]=0;i[n>>0]=91;z6(c,t)|0;c=k[t>>2]|0;k[o>>2]=0;k[t>>2]=0;do if(c|0){n=c+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);g=t+4|0;h=ZT(8)|0;k[h>>2]=1;c=h+4|0;k[t>>2]=c;k[g>>2]=1;i[h+5>>0]=0;i[c>>0]=100;c=k[p>>2]|0;j=k[c+(s*56|0)+16>>2]|0;f=k[c+(s*56|0)+4>>2]|0;if((f|0)<3)c=aa(k[c+(s*56|0)+12>>2]|0,k[c+(s*56|0)+8>>2]|0)|0;else{e=k[c+(s*56|0)+40>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0))}A6(b,t,j,aa(c,a)|0);k[g>>2]=0;k[t>>2]=0;o=k[h>>2]|0;k[h>>2]=o+-1;if((o|0)==1)ggb(k[h+-4>>2]|0);k[t>>2]=0;o=t+4|0;k[o>>2]=0;c=ZT(8)|0;k[c>>2]=1;d=c+4|0;k[t>>2]=d;k[o>>2]=1;i[c+5>>0]=0;i[d>>0]=93;d=z6(b,t)|0;c=k[t>>2]|0;k[o>>2]=0;k[t>>2]=0;do if(c|0){n=c+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);k[t>>2]=0;e=t+4|0;k[e>>2]=0;n=ZT(24)|0;k[n>>2]=1;l=n+4|0;k[t>>2]=l;k[e>>2]=16;i[n+20>>0]=0;n=361392;o=l+16|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));c=z6(d,t)|0;d=k[t>>2]|0;k[e>>2]=0;k[t>>2]=0;do if(d|0){n=d+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[t>>2]=0;o=t+4|0;k[o>>2]=0;m=ZT(8)|0;k[m>>2]=1;n=m+4|0;k[t>>2]=n;k[o>>2]=1;i[m+5>>0]=0;i[n>>0]=91;z6(c,t)|0;c=k[t>>2]|0;k[o>>2]=0;k[t>>2]=0;do if(c|0){n=c+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);g=t+4|0;h=ZT(8)|0;k[h>>2]=1;c=h+4|0;k[t>>2]=c;k[g>>2]=1;i[h+5>>0]=0;i[c>>0]=100;c=s+1|0;d=k[p>>2]|0;j=k[d+(c*56|0)+16>>2]|0;f=k[d+(c*56|0)+4>>2]|0;if((f|0)<3)c=aa(k[d+(c*56|0)+12>>2]|0,k[d+(c*56|0)+8>>2]|0)|0;else{e=k[d+(c*56|0)+40>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0))}A6(b,t,j,aa(c,a)|0);k[g>>2]=0;k[t>>2]=0;o=k[h>>2]|0;k[h>>2]=o+-1;if((o|0)==1)ggb(k[h+-4>>2]|0);k[t>>2]=0;o=t+4|0;k[o>>2]=0;d=ZT(8)|0;k[d>>2]=1;c=d+4|0;k[t>>2]=c;k[o>>2]=1;i[d+5>>0]=0;i[c>>0]=93;c=z6(b,t)|0;d=k[t>>2]|0;k[o>>2]=0;k[t>>2]=0;do if(d|0){n=d+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[t>>2]=0;o=t+4|0;k[o>>2]=0;n=ZT(12)|0;k[n>>2]=1;d=n+4|0;k[t>>2]=d;k[o>>2]=7;i[n+11>>0]=0;i[d>>0]=i[365283]|0;i[d+1>>0]=i[365284]|0;i[d+2>>0]=i[365285]|0;i[d+3>>0]=i[365286]|0;i[d+4>>0]=i[365287]|0;i[d+5>>0]=i[365288]|0;i[d+6>>0]=i[365289]|0;c=z6(c,t)|0;d=k[t>>2]|0;k[o>>2]=0;k[t>>2]=0;do if(d|0){n=d+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;ggb(k[d+-8>>2]|0)}while(0);k[t>>2]=0;o=t+4|0;k[o>>2]=0;m=ZT(8)|0;k[m>>2]=1;n=m+4|0;k[t>>2]=n;k[o>>2]=1;i[m+5>>0]=0;i[n>>0]=91;z6(c,t)|0;c=k[t>>2]|0;k[o>>2]=0;k[t>>2]=0;do if(c|0){n=c+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);if((q|0)>4){l=t+4|0;m=t+4|0;n=t+4|0;j=1;do{k[t>>2]=0;k[l>>2]=0;q=ZT(8)|0;k[q>>2]=1;c=q+4|0;k[t>>2]=c;k[l>>2]=1;i[q+5>>0]=0;i[c>>0]=91;z6(b,t)|0;c=k[t>>2]|0;k[l>>2]=0;k[t>>2]=0;do if(c|0){o=c+-4|0;q=k[o>>2]|0;k[o>>2]=q+-1;if((q|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);g=ZT(8)|0;k[g>>2]=1;c=g+4|0;k[t>>2]=c;k[m>>2]=1;i[g+5>>0]=0;i[c>>0]=100;c=k[p>>2]|0;h=k[c+(j*56|0)+16>>2]|0;f=k[c+(j*56|0)+4>>2]|0;if((f|0)<3)c=aa(k[c+(j*56|0)+12>>2]|0,k[c+(j*56|0)+8>>2]|0)|0;else{e=k[c+(j*56|0)+40>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0))}A6(b,t,h,aa(c,a)|0);k[m>>2]=0;k[t>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0);k[t>>2]=0;k[n>>2]=0;q=ZT(8)|0;k[q>>2]=1;c=q+4|0;k[t>>2]=c;k[n>>2]=1;i[q+5>>0]=0;i[c>>0]=93;z6(b,t)|0;c=k[t>>2]|0;k[n>>2]=0;k[t>>2]=0;do if(c|0){o=c+-4|0;q=k[o>>2]|0;k[o>>2]=q+-1;if((q|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);j=j+1|0}while((j|0)<(s|0))}s=t+4|0;q=ZT(8)|0;k[q>>2]=1;c=q+4|0;k[t>>2]=c;k[s>>2]=1;i[q+5>>0]=0;i[c>>0]=93;z6(b,t)|0;c=k[t>>2]|0;k[s>>2]=0;k[t>>2]=0;do if(c|0){b=c+-4|0;t=k[b>>2]|0;k[b>>2]=t+-1;if((t|0)!=1)break;ggb(k[c+-8>>2]|0)}while(0);r=u;return}function Bya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;S=r;r=r+144|0;N=S+80|0;M=S+24|0;O=S+16|0;P=S;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);k[P>>2]=0;R=P+4|0;k[R>>2]=0;k[P+8>>2]=0;d=k[b>>2]|0;K=b+4|0;e=k6(d,k[K>>2]|0,361355)|0;do if(e|0){if((k[e>>2]&7|0)!=6){c=k[e>>2]|0;if((c&7|0)!=5)break;do if(!d){k[M>>2]=0;k[M+4>>2]=0;k[M+20>>2]=0;k[M+40>>2]=0}else{k[M>>2]=d;k[M+4>>2]=e;if(c&16|0){k[M+20>>2]=e;k[M+12>>2]=0;k[M+40>>2]=1;break}d=e+8|0;KY(k[d>>2]|0,M+8|0);c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[M+40>>2]=c}while(0);k[N>>2]=M;gza(N,P);break}k[M>>2]=1124007936;o=M+4|0;c=M+8|0;m=M+40|0;f=o;j=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(j|0));k[m>>2]=c;q=M+48|0;n=M+44|0;k[n>>2]=q;k[M+52>>2]=0;k[q>>2]=0;k[N>>2]=1124007936;l=N+4|0;c=N+8|0;h=N+40|0;f=l;j=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(j|0));k[h>>2]=c;j=N+48|0;f=N+44|0;k[f>>2]=j;k[N+52>>2]=0;k[j>>2]=0;G6(d,e,M,N);e=N+36|0;c=k[e>>2]|0;if(c|0?(F=c+12|0,L=k[F>>2]|0,k[F>>2]=L+-1,(L|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[N+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;L=N+16|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[l>>2]|0)>0){d=k[h>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[l>>2]|0))}c=k[f>>2]|0;if(!((c|0)==(j|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=N+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[N>>2]=-2113732604;k[e>>2]=P;mY(M,N);e=M+36|0;c=k[e>>2]|0;if(c|0?(F=c+12|0,L=k[F>>2]|0,k[F>>2]=L+-1,(L|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[M+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;L=M+16|0;k[L>>2]=0;k[L+4>>2]=0;k[L+8>>2]=0;k[L+12>>2]=0;if((k[o>>2]|0)>0){d=k[m>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[o>>2]|0))}c=k[n>>2]|0;if(!((c|0)==(q|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}while(0);L=k[(k[a>>2]|0)+72>>2]|0;k[N+8>>2]=0;k[N+12>>2]=0;k[N>>2]=-2130509820;k[N+4>>2]=P;jh[L&1023](a,N);L=(k[a+8>>2]|0)-(k[a+4>>2]|0)>>2;F=k6(k[b>>2]|0,k[K>>2]|0,361409)|0;k[N>>2]=0;D=N+4|0;k[D>>2]=0;J6(F,N,N);a:do if(!(k[D>>2]|0)){c=k6(k[b>>2]|0,k[K>>2]|0,361475)|0;b:do if(!c)c=0;else{switch(k[c>>2]&7){case 1:{c=k[c+8>>2]|0;break b}case 2:break;default:{c=2147483647;break b}}g=+p[c+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;F=c&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}c=~~g}while(0);k[a+80>>2]=c}else{j=k[N>>2]|0;do if((j|0)!=361429){c=(j|0)==0?1016759:j;l=i[c>>0]|0;if(l<<24>>24==83){d=361429;e=c;do{e=e+1|0;d=d+1|0;f=i[e>>0]|0;h=i[d>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=h<<24>>24));if(f<<24>>24==h<<24>>24){c=1;break}}if((j|0)!=361441){if(l<<24>>24==73){d=361441;e=c;do{e=e+1|0;d=d+1|0;f=i[e>>0]|0;h=i[d>>0]|0}while(!(f<<24>>24==0?1:f<<24>>24!=h<<24>>24));if(f<<24>>24==h<<24>>24){c=0;break}}if((j|0)==361450)c=2;else{if(l<<24>>24==71){f=361450;do{c=c+1|0;f=f+1|0;d=i[c>>0]|0;e=i[f>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=e<<24>>24));if(d<<24>>24==e<<24>>24){c=2;break}}k[a+80>>2]=-1;k[M>>2]=0;c=M+4|0;k[c>>2]=0;d=ZT(20)|0;k[d>>2]=1;f=d+4|0;k[M>>2]=f;k[c>>2]=15;i[d+19>>0]=0;e=361459;j=f+15|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(j|0));Y8(-215,M,370462,360247,1187);k[c>>2]=0;k[M>>2]=0;F=k[d>>2]|0;k[d>>2]=F+-1;if((F|0)==1)ggb(k[d+-4>>2]|0);break a}}else c=0}else c=1;while(0);k[a+80>>2]=c}while(0);c=k6(k[b>>2]|0,k[K>>2]|0,361498)|0;c:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break c}case 2:{g=+p[c+8>>3];break c}default:{g=1.e+300;break c}}while(0);d=a+32|0;p[d>>3]=g;c=k6(k[b>>2]|0,k[K>>2]|0,361507)|0;d:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break d}case 2:{g=+p[c+8>>3];break d}default:{g=1.e+300;break d}}while(0);p[a+40>>3]=g;mh[k[(k[a>>2]|0)+68>>2]&15](a,k[a+80>>2]|0,+p[d>>3],g);c=k6(k[b>>2]|0,k[K>>2]|0,361516)|0;e:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break e}case 2:{g=+p[c+8>>3];break e}default:{g=1.e+300;break e}}while(0);p[a+48>>3]=g;c=k6(k[b>>2]|0,k[K>>2]|0,361524)|0;f:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break f}case 2:{g=+p[c+8>>3];break f}default:{g=1.e+300;break f}}while(0);p[a+56>>3]=g;c=k6(k[b>>2]|0,k[K>>2]|0,361532)|0;g:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break g}case 2:{g=+p[c+8>>3];break g}default:{g=1.e+300;break g}}while(0);p[a+64>>3]=g;c=k6(k[b>>2]|0,k[K>>2]|0,361541)|0;h:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break h}case 2:{g=+p[c+8>>3];break h}default:{g=1.e+300;break h}}while(0);p[a+72>>3]=g;y=k[b>>2]|0;x=k6(y,k[K>>2]|0,370919)|0;A=a+96|0;k[A>>2]=3;B=a+100|0;k[B>>2]=1e3;z=a+104|0;p[z>>3]=.01;n=a+112|0;k[n>>2]=1;m=a+120|0;p[m>>3]=.1;o=a+128|0;p[o>>3]=.1;q=a+136|0;p[q>>3]=.1;s=a+144|0;p[s>>3]=1.2;t=a+152|0;p[t>>3]=.5;v=a+160|0;p[v>>3]=1.1920928955078125e-07;w=a+168|0;p[w>>3]=50.0;if(x|0){f=k6(y,x,366905)|0;k[M>>2]=0;C=M+4|0;k[C>>2]=0;J6(f,M,M);f=k[M>>2]|0;i:do if((f|0)==361550)Q=95;else{c=(f|0)==0?1016759:f;h=i[c>>0]|0;if(h<<24>>24==66){d=361550;e=c;do{e=e+1|0;d=d+1|0;j=i[e>>0]|0;l=i[d>>0]|0}while(!(j<<24>>24==0?1:j<<24>>24!=l<<24>>24));if(j<<24>>24==l<<24>>24){Q=95;break}}do if((f|0)!=361581){if(h<<24>>24==82){f=361581;do{c=c+1|0;f=f+1|0;d=i[c>>0]|0;e=i[f>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=e<<24>>24));if(d<<24>>24==e<<24>>24)break}k[O>>2]=0;c=O+4|0;k[c>>2]=0;d=ZT(60)|0;k[d>>2]=1;f=d+4|0;k[O>>2]=f;k[c>>2]=53;i[d+57>>0]=0;e=361622;j=f+53|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(j|0));Y8(-212,O,370462,360247,1225);k[c>>2]=0;k[O>>2]=0;F=k[d>>2]|0;k[d>>2]=F+-1;if((F|0)==1)ggb(k[d+-4>>2]|0);break i}while(0);k[n>>2]=1;c=k6(y,x,361587)|0;j:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break j}case 2:{g=+p[c+8>>3];break j}default:{g=1.e+300;break j}}while(0);p[q>>3]=g;c=k6(y,x,361591)|0;k:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break k}case 2:{g=+p[c+8>>3];break k}default:{g=1.e+300;break k}}while(0);p[s>>3]=g;c=k6(y,x,361599)|0;l:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break l}case 2:{g=+p[c+8>>3];break l}default:{g=1.e+300;break l}}while(0);p[t>>3]=g;c=k6(y,x,361608)|0;m:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break m}case 2:{g=+p[c+8>>3];break m}default:{g=1.e+300;break m}}while(0);p[v>>3]=g;c=k6(y,x,361615)|0;n:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break n}case 2:{g=+p[c+8>>3];break n}default:{g=1.e+300;break n}}while(0);p[w>>3]=g}while(0);if((Q|0)==95){k[n>>2]=0;c=k6(y,x,361559)|0;o:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break o}case 2:{g=+p[c+8>>3];break o}default:{g=1.e+300;break o}}while(0);p[m>>3]=g;c=k6(y,x,361568)|0;p:do if(!c)g=0.0;else switch(k[c>>2]&7){case 1:{g=+(k[c+8>>2]|0);break p}case 2:{g=+p[c+8>>3];break p}default:{g=1.e+300;break p}}while(0);p[o>>3]=g}c=k6(y,x,370605)|0;if(c|0){d=k6(y,c,370619)|0;e=k6(y,c,375191)|0;k[A>>2]=0;if(!d)c=1;else{k[A>>2]=2;switch(k[d>>2]&7){case 1:{g=+(k[d+8>>2]|0);break}case 2:{g=+p[d+8>>3];break}default:g=1.e+300}p[z>>3]=g;c=3}if(e|0){k[A>>2]=c;switch(k[e>>2]&7){case 1:{c=k[e+8>>2]|0;break}case 2:{g=+p[e+8>>3];p[u>>3]=g;c=k[u+4>>2]|0;F=c&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){c=(c|0)<0;g=c?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=c?-0.0:0.0}c=~~g;break}default:c=2147483647}k[B>>2]=c}}c=k[M>>2]|0;k[C>>2]=0;k[M>>2]=0;if(c|0?(E=c+-4|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0)ggb(k[c+-8>>2]|0)}c=k[N>>2]|0;k[D>>2]=0;k[N>>2]=0;if(c|0?(E=c+-4|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0)ggb(k[c+-8>>2]|0);F=a+16|0;c=k[F>>2]|0;d=k[c+4>>2]|0;if((d|0)>0)E=k[(k[c+44>>2]|0)+(d+-1<<2)>>2]|0;else E=0;h=k[b>>2]|0;j=k6(h,k[K>>2]|0,361367)|0;k[M>>2]=0;l=M+4|0;k[l>>2]=0;m=ZT(8)|0;k[m>>2]=1;c=m+4|0;k[M>>2]=c;k[l>>2]=1;i[m+5>>0]=0;i[c>>0]=100;c=k[F>>2]|0;n=k[c+16>>2]|0;f=k[c+4>>2]|0;if((f|0)<3)e=aa(k[c+12>>2]|0,k[c+8>>2]|0)|0;else{d=k[c+40>>2]|0;c=0;e=1;do{e=aa(k[d+(c<<2)>>2]|0,e)|0;c=c+1|0}while((c|0)!=(f|0))}do if((h|0)!=0&(j|0)!=0?(G=k[j>>2]|0,H=G&7,(H|0)!=0):0){k[N>>2]=h;k[N+4>>2]=j;if(!((H+-5|0)>>>0<2&(G&16|0)==0)){k[N+20>>2]=j;k[N+12>>2]=0;k[N+40>>2]=1;break}d=j+8|0;KY(k[d>>2]|0,N+8|0);c=k[j>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[N+40>>2]=c}else Q=168;while(0);if((Q|0)==168){k[N>>2]=0;k[N+4>>2]=0;k[N+20>>2]=0;k[N+40>>2]=0}C6(N,M,n,aa(e,E)|0)|0;k[l>>2]=0;k[M>>2]=0;H=k[m>>2]|0;k[m>>2]=H+-1;if((H|0)==1)ggb(k[m+-4>>2]|0);h=k[b>>2]|0;j=k6(h,k[K>>2]|0,361379)|0;k[M>>2]=0;l=M+4|0;k[l>>2]=0;m=ZT(8)|0;k[m>>2]=1;c=m+4|0;k[M>>2]=c;k[l>>2]=1;i[m+5>>0]=0;i[c>>0]=100;c=k[F>>2]|0;n=k[c+(L*56|0)+16>>2]|0;f=k[c+(L*56|0)+4>>2]|0;if((f|0)<3)e=aa(k[c+(L*56|0)+12>>2]|0,k[c+(L*56|0)+8>>2]|0)|0;else{d=k[c+(L*56|0)+40>>2]|0;c=0;e=1;do{e=aa(k[d+(c<<2)>>2]|0,e)|0;c=c+1|0}while((c|0)!=(f|0))}do if((h|0)!=0&(j|0)!=0?(I=k[j>>2]|0,J=I&7,(J|0)!=0):0){k[N>>2]=h;k[N+4>>2]=j;if(!((J+-5|0)>>>0<2&(I&16|0)==0)){k[N+20>>2]=j;k[N+12>>2]=0;k[N+40>>2]=1;break}d=j+8|0;KY(k[d>>2]|0,N+8|0);c=k[j>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[N+40>>2]=c}else Q=184;while(0);if((Q|0)==184){k[N>>2]=0;k[N+4>>2]=0;k[N+20>>2]=0;k[N+40>>2]=0}C6(N,M,n,aa(e,E)|0)|0;k[l>>2]=0;k[M>>2]=0;J=k[m>>2]|0;k[m>>2]=J+-1;if((J|0)==1)ggb(k[m+-4>>2]|0);h=k[b>>2]|0;j=k6(h,k[K>>2]|0,361392)|0;k[M>>2]=0;l=M+4|0;k[l>>2]=0;m=ZT(8)|0;k[m>>2]=1;c=m+4|0;k[M>>2]=c;k[l>>2]=1;i[m+5>>0]=0;i[c>>0]=100;c=L+1|0;d=k[F>>2]|0;n=k[d+(c*56|0)+16>>2]|0;f=k[d+(c*56|0)+4>>2]|0;if((f|0)<3)e=aa(k[d+(c*56|0)+12>>2]|0,k[d+(c*56|0)+8>>2]|0)|0;else{e=k[d+(c*56|0)+40>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0));e=c}do if((h|0)!=0&(j|0)!=0){c=k[j>>2]|0;d=c&7;if(!d){Q=200;break}k[N>>2]=h;k[N+4>>2]=j;if(!((d+-5|0)>>>0<2&(c&16|0)==0)){k[N+20>>2]=j;k[N+12>>2]=0;k[N+40>>2]=1;break}d=j+8|0;KY(k[d>>2]|0,N+8|0);c=k[j>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}k[N+40>>2]=c}else Q=200;while(0);if((Q|0)==200){k[N>>2]=0;k[N+4>>2]=0;k[N+20>>2]=0;k[N+40>>2]=0}C6(N,M,n,aa(e,E)|0)|0;k[l>>2]=0;k[M>>2]=0;J=k[m>>2]|0;k[m>>2]=J+-1;if((J|0)==1)ggb(k[m+-4>>2]|0);e=k[b>>2]|0;f=k6(e,k[K>>2]|0,365283)|0;do if((e|0)!=0&(f|0)!=0){c=k[f>>2]|0;d=c&7;if(!d){Q=212;break}k[M>>2]=e;k[M+4>>2]=f;if(!((d+-5|0)>>>0<2&(c&16|0)==0)){q=M+20|0;k[q>>2]=f;k[M+12>>2]=0;s=M+40|0;k[s>>2]=1;t=M;break}d=f+8|0;KY(k[d>>2]|0,M+8|0);c=k[f>>2]|0;switch(c&7){case 6:{c=k[(k[d>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[d>>2]|0)+24>>2]|0;break}default:c=(c&7|0)!=0&1}s=M+40|0;k[s>>2]=c;q=M+20|0;t=M}else Q=212;while(0);if((Q|0)==212){k[M>>2]=0;k[M+4>>2]=0;q=M+20|0;k[q>>2]=0;s=M+40|0;k[s>>2]=0;t=M}v=O+4|0;w=N+4|0;x=N+8|0;y=N+40|0;z=N+20|0;A=N+12|0;B=M+12|0;C=M+28|0;D=M+16|0;o=M+24|0;c=1;while(1){if((c|0)>=(L|0))break;j=k[t>>2]|0;l=k[q>>2]|0;k[O>>2]=0;k[v>>2]=0;m=ZT(8)|0;k[m>>2]=1;d=m+4|0;k[O>>2]=d;k[v>>2]=1;i[m+5>>0]=0;i[d>>0]=100;d=k[F>>2]|0;n=k[d+(c*56|0)+16>>2]|0;h=k[d+(c*56|0)+4>>2]|0;if((h|0)<3)f=aa(k[d+(c*56|0)+12>>2]|0,k[d+(c*56|0)+8>>2]|0)|0;else{f=k[d+(c*56|0)+40>>2]|0;e=0;d=1;do{d=aa(k[f+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(h|0));f=d}do if((j|0)!=0&(l|0)!=0){d=k[l>>2]|0;e=d&7;if(!e){Q=228;break}k[N>>2]=j;k[w>>2]=l;if(!((e+-5|0)>>>0<2&(d&16|0)==0)){k[z>>2]=l;k[A>>2]=0;k[y>>2]=1;break}e=l+8|0;KY(k[e>>2]|0,x);d=k[l>>2]|0;switch(d&7){case 6:{d=k[(k[e>>2]|0)+60>>2]|0;break}case 5:{d=k[(k[e>>2]|0)+24>>2]|0;break}default:d=(d&7|0)!=0&1}k[y>>2]=d}else Q=228;while(0);if((Q|0)==228){Q=0;k[N>>2]=0;k[w>>2]=0;k[z>>2]=0;k[y>>2]=0}C6(N,O,n,aa(f,E)|0)|0;k[v>>2]=0;k[O>>2]=0;M=k[m>>2]|0;k[m>>2]=M+-1;if((M|0)==1)ggb(k[m+-4>>2]|0);c=c+1|0;d=k[s>>2]|0;if(!d)continue;e=k[B>>2]|0;do if(e|0){M=(k[q>>2]|0)+(k[e+28>>2]|0)|0;k[q>>2]=M;if(M>>>0<(k[C>>2]|0)>>>0)break;M=k[(k[D>>2]|0)+4>>2]|0;k[D>>2]=M;b=k[M+16>>2]|0;k[q>>2]=b;K=k[e+28>>2]|0;M=k[M+12>>2]|0;k[o>>2]=b;M=b+(aa(K,M)|0)|0;k[C>>2]=M}while(0);k[s>>2]=d+-1}i[a+188>>0]=1;c=k[P>>2]|0;if(!c){r=S;return}d=k[R>>2]|0;if((d|0)!=(c|0))k[R>>2]=d+(~((d+-4-c|0)>>>2)<<2);ggb(c);r=S;return}function Cya(a,b){a=a|0;b=b|0;var c=0;c=ZT(24)|0;k[c>>2]=1;b=c+4|0;k[a>>2]=b;k[a+4>>2]=17;i[c+21>>0]=0;a=b;b=361337;c=a+17|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));return}function Dya(a){a=a|0;var b=0;b=k[a+4>>2]|0;if((b|0)==(k[a+8>>2]|0)){b=0;return b|0}b=k[b>>2]|0;return b|0}function Eya(a){a=a|0;return (i[a+188>>0]|0)!=0|0}function Fya(a){a=a|0;return 0}function Gya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0.0,q=0.0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0.0;Ed=r;r=r+2e3|0;vd=Ed+1392|0;xd=Ed+1168|0;Ad=Ed+1136|0;zd=Ed+1936|0;yd=Ed+40|0;wd=Ed+8|0;sd=Ed+1880|0;md=Ed+1824|0;nd=Ed+1768|0;od=Ed+1712|0;pd=Ed+1656|0;qd=Ed+1600|0;rd=Ed+1584|0;H=Ed+1576|0;K=Ed;Dd=Ed+1520|0;Cd=Ed+1464|0;Bd=Ed+1408|0;k[H>>2]=1e3;p[K>>3]=1.1920928955078125e-07;g=b+4|0;L=k[g>>2]|0;eh[k[(k[L>>2]|0)+44>>2]&255](Dd,L,0,1,1);L=k[g>>2]|0;jh[k[(k[L>>2]|0)+48>>2]&1023](Cd,L);g=k[g>>2]|0;jh[k[(k[g>>2]|0)+76>>2]&1023](Bd,g);g=a+4|0;L=a+8|0;if((k[g>>2]|0)==(k[L>>2]|0)){k[vd>>2]=0;b=vd+4|0;k[b>>2]=0;d=ZT(88)|0;k[d>>2]=1;ed=d+4|0;k[vd>>2]=ed;k[b>>2]=82;i[d+86>>0]=0;la=360711;fd=ed+82|0;do{i[ed>>0]=i[la>>0]|0;ed=ed+1|0;la=la+1|0}while((ed|0)<(fd|0));Y8(-2,vd,360794,360247,661);k[b>>2]=0;k[vd>>2]=0;ud=k[d>>2]|0;k[d>>2]=ud+-1;if((ud|0)==1)ggb(k[d+-4>>2]|0)}if(!(((k[Dd>>2]&4095)+-5|0)>>>0<2?(k[Dd+12>>2]|0)==(k[k[g>>2]>>2]|0):0))Da=7;if((Da|0)==7?(k[vd>>2]=0,ud=vd+4|0,k[ud>>2]=0,e=ZT(188)|0,k[e>>2]=1,td=e+4|0,k[vd>>2]=td,k[ud>>2]=183,i[e+187>>0]=0,upb(td|0,360811,183)|0,Y8(-5,vd,360794,360247,668),k[ud>>2]=0,k[vd>>2]=0,ud=k[e>>2]|0,k[e>>2]=ud+-1,(ud|0)==1):0)ggb(k[e+-4>>2]|0);if(!(((k[Cd>>2]&4095)+-5|0)>>>0<2?(k[Cd+12>>2]|0)==(k[(k[L>>2]|0)+-4>>2]|0):0))Da=12;if((Da|0)==12?(k[vd>>2]=0,ud=vd+4|0,k[ud>>2]=0,f=ZT(192)|0,k[f>>2]=1,td=f+4|0,k[vd>>2]=td,k[ud>>2]=185,i[f+189>>0]=0,upb(td|0,360995,185)|0,Y8(-5,vd,360794,360247,675),k[ud>>2]=0,k[vd>>2]=0,ud=k[f>>2]|0,k[f>>2]=ud+-1,(ud|0)==1):0)ggb(k[f+-4>>2]|0);G=Dd+8|0;y=Cd+8|0;if((k[G>>2]|0)!=(k[y>>2]|0)){k[vd>>2]=0;b=vd+4|0;k[b>>2]=0;d=ZT(60)|0;k[d>>2]=1;ed=d+4|0;k[vd>>2]=ed;k[b>>2]=52;i[d+56>>0]=0;la=361181;fd=ed+52|0;do{i[ed>>0]=i[la>>0]|0;ed=ed+1|0;la=la+1|0}while((ed|0)<(fd|0));Y8(-209,vd,360794,360247,678);k[b>>2]=0;k[vd>>2]=0;ud=k[d>>2]|0;k[d>>2]=ud+-1;if((ud|0)==1)ggb(k[d+-4>>2]|0)}k[xd>>2]=1124007936;E=xd+4|0;b=xd+8|0;B=xd+40|0;ed=E;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[B>>2]=b;F=xd+48|0;C=xd+44|0;k[C>>2]=F;k[xd+52>>2]=0;k[F>>2]=0;k[vd+8>>2]=0;k[vd+12>>2]=0;k[vd>>2]=16842752;k[vd+4>>2]=Bd;g7(Ad,vd);Ca=+p[Ad>>3];D=vd+4|0;ud=D+4|0;k[ud>>2]=0;k[ud+4>>2]=0;k[vd>>2]=33619968;k[D>>2]=xd;SW(Bd,vd,6,1.0/Ca,0.0);KG(Bd,xd)|0;D=(c&1|0)==0;ud=a+16|0;x=k[ud>>2]|0;w=k[x+16>>2]|0;m=k[G>>2]|0;do if(D){d=(c&2|0)!=0;v=k[g>>2]|0;s=k[v>>2]|0;e=k[Dd>>2]&4095;l=d?1.0:0.0;j=(s|0)>0;if(j){b=0;do{td=b<<1;p[w+(td<<3)>>3]=l;p[w+((td|1)<<3)>>3]=0.0;b=b+1|0}while((b|0)!=(s|0))}if(!d){if((m|0)>0){g=k[Dd+16>>2]|0;h=k[k[Dd+44>>2]>>2]|0;e=(e|0)==5;if(j)d=0;else{b=v;break}do{f=g+(aa(h,d)|0)|0;if(e){b=0;do{Ca=+o[f+(b<<2)>>2];td=b<<1;ld=w+(td<<3)|0;p[ld>>3]=Ca+ +p[ld>>3];td=w+((td|1)<<3)|0;p[td>>3]=Ca*Ca+ +p[td>>3];b=b+1|0}while((b|0)!=(s|0))}else{b=0;do{Ca=+p[f+(b<<3)>>3];td=b<<1;ld=w+(td<<3)|0;p[ld>>3]=Ca+ +p[ld>>3];td=w+((td|1)<<3)|0;p[td>>3]=Ca*Ca+ +p[td>>3];b=b+1|0}while((b|0)!=(s|0))}d=d+1|0}while((d|0)!=(m|0))}if(j){n=+(m|0);b=0;do{e=b<<1;d=w+(e<<3)|0;e=w+((e|1)<<3)|0;q=+p[d>>3]/n;l=+p[e>>3]/n-q*q;if(l<2.220446049250313e-16)l=1.0;else l=1.0/+Q(+l);p[d>>3]=l;p[e>>3]=-(q*l);b=b+1|0}while((b|0)!=(s|0));b=v}else b=v}else b=v}else b=k[a+4>>2]|0;while(0);td=a+4|0;w=k[L>>2]|0;A=k[w+-4>>2]|0;e=k[Cd>>2]&4095;X=+p[a+48>>3];z=+p[a+56>>3];q=+p[a+64>>3];t=+p[a+72>>3];f=c>>>2;w=w-b>>2;c=k[x+(w*56|0)+16>>2]|0;x=k[x+((w+1|0)*56|0)+16>>2]|0;w=k[y>>2]|0;if(D){d=(f&1|0)!=0;l=d?1.0:1797693134862315708145274.0e284;n=d?0.0:-1797693134862315708145274.0e284;if((A|0)>0){b=0;do{ld=b<<1;p[x+(ld<<3)>>3]=l;p[c+(ld<<3)>>3]=l;ld=ld|1;p[x+(ld<<3)>>3]=n;p[c+(ld<<3)>>3]=n;b=b+1|0}while((b|0)!=(A|0))}if(!d)Da=39}else Da=39;if((Da|0)==39){if((w|0)>0){m=Cd+16|0;s=Cd+44|0;v=(A|0)>0;j=(e|0)==5;f=(f&1|0)==0;g=vd+4|0;e=0;do{h=(k[m>>2]|0)+(aa(k[k[s>>2]>>2]|0,e)|0)|0;if(v)if(j){d=0;do{l=+o[h+(d<<2)>>2];if(!D){if(f?(ld=d<<1,Ca=l*+p[x+(ld<<3)>>3]+ +p[x+((ld|1)<<3)>>3],Ca<q|Ca>t):0){k[vd>>2]=0;k[g>>2]=0;b=ZT(92)|0;k[b>>2]=1;ed=b+4|0;k[vd>>2]=ed;k[g>>2]=84;i[b+88>>0]=0;la=361234;fd=ed+84|0;do{i[ed>>0]=i[la>>0]|0;ed=ed+1|0;la=la+1|0}while((ed|0)<(fd|0));Y8(-211,vd,361319,360247,634);k[g>>2]=0;k[vd>>2]=0;ld=k[b>>2]|0;k[b>>2]=ld+-1;if((ld|0)==1)ggb(k[b+-4>>2]|0)}}else{ld=d<<1;kd=c+(ld<<3)|0;u=+p[kd>>3];ld=c+((ld|1)<<3)|0;Ca=+p[ld>>3];p[kd>>3]=u>l?l:u;p[ld>>3]=Ca<l?l:Ca}d=d+1|0}while((d|0)<(A|0))}else{d=0;do{l=+p[h+(d<<3)>>3];if(!D){if(f?(ld=d<<1,Ca=l*+p[x+(ld<<3)>>3]+ +p[x+((ld|1)<<3)>>3],Ca<q|Ca>t):0){k[vd>>2]=0;k[g>>2]=0;b=ZT(92)|0;k[b>>2]=1;ed=b+4|0;k[vd>>2]=ed;k[g>>2]=84;i[b+88>>0]=0;la=361234;fd=ed+84|0;do{i[ed>>0]=i[la>>0]|0;ed=ed+1|0;la=la+1|0}while((ed|0)<(fd|0));Y8(-211,vd,361319,360247,634);k[g>>2]=0;k[vd>>2]=0;ld=k[b>>2]|0;k[b>>2]=ld+-1;if((ld|0)==1)ggb(k[b+-4>>2]|0)}}else{ld=d<<1;kd=c+(ld<<3)|0;u=+p[kd>>3];ld=c+((ld|1)<<3)|0;Ca=+p[ld>>3];p[kd>>3]=u>l?l:u;p[ld>>3]=Ca<l?l:Ca}d=d+1|0}while((d|0)<(A|0))}e=e+1|0}while((e|0)<(w|0))}if(D&(A|0)>0){u=X+z;t=z-X;b=0;do{d=b<<1;e=c+(d<<3)|0;l=+p[e>>3];f=d|1;g=c+(f<<3)|0;n=+p[g>>3];q=n-l;if(q<2.220446049250313e-16){l=(u-n-l)*.5;n=1.0}else{n=t/q;l=X-l*n}p[x+(d<<3)>>3]=n;p[x+(f<<3)>>3]=l;Ca=1.0/n;p[e>>3]=Ca;p[g>>3]=-(l*Ca);b=b+1|0}while((b|0)!=(A|0))}}e=xd+36|0;b=k[e>>2]|0;if(b|0?(kd=b+12|0,ld=k[kd>>2]|0,k[kd>>2]=ld+-1,(ld|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[xd+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;ld=xd+16|0;k[ld>>2]=0;k[ld+4>>2]=0;k[ld+8>>2]=0;k[ld+12>>2]=0;if((k[E>>2]|0)>0){d=k[B>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[E>>2]|0))}b=k[C>>2]|0;if(!((b|0)==(F|0)|(b|0)==0))ggb(k[b+-4>>2]|0);if(D?(J=k[td>>2]|0,ld=(k[L>>2]|0)-J|0,I=ld>>2,J,(ld|0)>4):0){m=k[ud>>2]|0;s=I+-1|0;v=a+176|0;j=1;w=k[J>>2]|0;do{b=w;w=k[J+(j<<2)>>2]|0;if((w|0)<=2){if((w|0)>0){t=1.0;Da=85}}else{t=+R(+(+(b|0)),+(1.0/+(w+-1|0)))*.7;Da=85}a:do if((Da|0)==85){Da=0;x=k[m+(j*56|0)+16>>2]|0;y=(j|0)<(s|0);q=+(w|0);c=aa(w,b)|0;if((b|0)<0){b=0;while(1){if(y){ld=x+(b+c<<3)|0;p[ld>>3]=t*(+(b|0)*2.0/q+-1.0)*+p[ld>>3]}b=b+1|0;if((b|0)==(w|0))break a}}h=b+1|0;d=v;g=0;b=k[d>>2]|0;d=k[d+4>>2]|0;while(1){e=0;n=0.0;f=b;do{ld=Epb(f|0,0,-130063606,0)|0;ld=kpb(ld|0,N|0,d|0,0)|0;kd=N;jd=Epb(ld|0,0,-130063606,0)|0;f=kpb(jd|0,N|0,kd|0,0)|0;d=N;l=((+(f>>>0)+4294967296.0*+(ld>>>0))*5.421010862427522e-20+0.0)*2.0+-1.0;ld=x+((aa(e,w)|0)+g<<3)|0;p[ld>>3]=l;l=+P(+l);n=n+l;e=e+1|0}while((e|0)!=(h|0));if(y){l=1.0/(n-l);b=0;do{ld=x+((aa(b,w)|0)+g<<3)|0;p[ld>>3]=l*+p[ld>>3];b=b+1|0}while((b|0)!=(h|0));ld=x+(g+c<<3)|0;p[ld>>3]=t*(+(g|0)*2.0/q+-1.0)*+p[ld>>3]}g=g+1|0;if((g|0)==(w|0))break;else b=f}ld=v;k[ld>>2]=f;k[ld+4>>2]=d}while(0);j=j+1|0}while((j|0)<(I|0))}ld=k[a+96>>2]|0;Ba=k[(ld&1|0?a+100|0:H)>>2]|0;Ba=(Ba|0)<1?1:Ba;Ca=+p[(ld&2|0?a+104|0:K)>>3];Ca=Ca<2.220446049250313e-16?2.220446049250313e-16:Ca;do if(!(k[a+112>>2]|0)){Y=k[Dd>>2]&4095;_=k[Cd>>2]&4095;kd=k[G>>2]|0;jd=aa(Ba,kd)|0;u=+(kd|0);t=u*Ca;id=k[L>>2]|0;hd=k[td>>2]|0;Z=id-hd|0;gd=Z>>2;hd=k[hd>>2]|0;id=k[id+-4>>2]|0;h=(gd|0)==0;if(!h){if(gd>>>0>357913941)ad(426534,426557,304,426811);e=gd*12|0;d=(e|0)==0?1:e;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}f=b+(gd*12|0)|0;zpb(b|0,0,e|0)|0;if(h){ld=0;g=0}else{if(gd>>>0>357913941)ad(426534,426557,304,426811);g=gd*12|0;e=(g|0)==0?1:g;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}zpb(d|0,0,g|0)|0;ld=d;g=d+(gd*12|0)|0}}else{ld=0;b=0;g=0;f=0}k[Ad>>2]=0;v=Ad+4|0;k[v>>2]=0;k[Ad+8>>2]=0;if(!h){if(gd>>>0>76695844)ad(426534,426557,304,426811);e=gd*56|0;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[v>>2]=d;k[Ad>>2]=d;k[Ad+8>>2]=d+(gd*56|0);e=gd;s=d;m=d;while(1){k[s>>2]=1124007936;h=s+8|0;j=s+40|0;ed=s+4|0;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[j>>2]=h;h=s+48|0;k[s+44>>2]=h;k[s+52>>2]=0;k[h>>2]=0;h=m+56|0;e=e+-1|0;if(!e)break;else{s=h;m=h}}k[v>>2]=d+(gd*56|0)}if((Z|0)>0){x=xd+4|0;y=xd+8|0;c=xd+12|0;A=xd+16|0;B=xd+48|0;C=xd+56|0;D=xd+52|0;E=xd+60|0;F=xd+64|0;G=xd+68|0;H=xd+72|0;I=xd+104|0;J=xd+112|0;K=xd+108|0;L=xd+116|0;M=xd+120|0;O=xd+124|0;S=xd+128|0;T=xd+160|0;U=xd+168|0;V=xd+164|0;W=vd+4|0;w=0;do{v=k[(k[td>>2]|0)+(w<<2)>>2]|0;d=b+(w*12|0)|0;e=v+1|0;m=b+(w*12|0)+4|0;s=k[m>>2]|0;j=k[d>>2]|0;h=s-j>>3;do if(e>>>0<=h>>>0){if(e>>>0<h>>>0){d=j+(e<<3)|0;if((s|0)==(d|0))break;k[m>>2]=s+(~((s+-8-d|0)>>>3)<<3)}}else Bla(d,e-h|0);while(0);d=ld+(w*12|0)|0;j=ld+(w*12|0)+4|0;m=k[j>>2]|0;h=k[d>>2]|0;e=m-h>>3;do if(v>>>0>e>>>0)Bla(d,v-e|0);else{if(v>>>0>=e>>>0)break;d=h+(v<<3)|0;if((m|0)==(d|0))break;k[j>>2]=m+(~((m+-8-d|0)>>>3)<<3)}while(0);d=k[Ad>>2]|0;h=k[(k[ud>>2]|0)+(w*56|0)+40>>2]|0;e=k[h+4>>2]|0;h=k[h>>2]|0;k[xd>>2]=0;k[x>>2]=0;k[y>>2]=1124007936;ed=c;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[B>>2]=A;k[D>>2]=C;k[E>>2]=0;k[C>>2]=0;k[F>>2]=1124007936;ed=G;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[I>>2]=H;k[K>>2]=J;k[L>>2]=0;k[J>>2]=0;k[M>>2]=1124007936;ed=O;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[T>>2]=S;k[V>>2]=U;ed=U;fd=ed+56|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[vd>>2]=e;k[W>>2]=h;j1(xd,48,vd,6);fd=k[xd>>2]|0;dh[k[(k[fd>>2]|0)+12>>2]&255](fd,xd,d+(w*56|0)|0,-1);XN(xd);w=w+1|0}while((w|0)<(gd|0));dd=b}else dd=b;k[zd>>2]=1124007936;bd=zd+4|0;b=zd+8|0;_c=zd+40|0;ed=bd;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[_c>>2]=b;cd=zd+48|0;$c=zd+44|0;k[$c>>2]=cd;k[zd+52>>2]=0;k[cd>>2]=0;k[vd>>2]=1;k[vd+4>>2]=kd;G1(zd,2,vd,4);Zc=zd+16|0;Vc=k[Zc>>2]|0;Wc=(kd|0)>0;if(Wc){b=0;do{k[Vc+(b<<2)>>2]=b;b=b+1|0}while((b|0)!=(kd|0))}e=k[a+84>>2]|0;h=e<<1;Xc=yd+8|0;k[yd>>2]=Xc;Yc=yd+4|0;k[Yc>>2]=136;b=Xc;if(h>>>0>136){d=h>>>0>536870911?-1:h<<3;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[yd>>2]=b;d=b}else d=Xc;k[Yc>>2]=h;k[wd>>2]=b;k[wd+4>>2]=b+(e<<3);m=k[Bd+16>>2]|0;if(!m)Uc=0;else{h=k[Bd+4>>2]|0;if((h|0)<3)b=aa(k[Bd+12>>2]|0,k[Bd+8>>2]|0)|0;else{j=k[Bd+40>>2]|0;e=0;b=1;do{b=aa(k[j+(e<<2)>>2]|0,b)|0;e=e+1|0}while((e|0)!=(h|0))}Uc=(b|0)==0?0:m}if((jd|0)>0){Pc=(Uc|0)==0;Qc=a+176|0;Rc=Dd+16|0;Sc=Dd+44|0;Tc=(hd|0)>0;Bc=(Y|0)==5;Cc=sd+4|0;Dc=sd+8|0;Ec=sd+12|0;Fc=sd+16|0;Gc=sd+20|0;Hc=sd+24|0;Ic=sd+28|0;Jc=sd+40|0;Kc=sd+48|0;Lc=sd+44|0;Mc=sd+52|0;Oc=(hd|0)!=0;Nc=vd+4|0;ub=(Z|0)>4;vb=md+4|0;wb=md+8|0;xb=md+12|0;yb=md+16|0;zb=md+20|0;Ab=md+24|0;Bb=md+28|0;Cb=md+40|0;Db=md+48|0;Eb=md+44|0;Fb=md+52|0;Gb=vd+4|0;Hb=vd+4|0;Ib=xd+4|0;Jb=vd+8|0;Kb=vd+12|0;Lb=vd+4|0;Mb=xd+8|0;Nb=xd+12|0;Ob=xd+4|0;Pb=od+4|0;Qb=Pb+4|0;Rb=xd+4|0;Sb=xd+8|0;Tb=xd+12|0;Ub=xd+16|0;Vb=xd+20|0;Wb=xd+24|0;Xb=xd+28|0;Yb=xd+40|0;Zb=xd+48|0;_b=xd+44|0;$b=xd+52|0;ac=vd+4|0;bc=xd+36|0;cc=nd+36|0;dc=nd+16|0;ec=nd+4|0;fc=nd+40|0;gc=nd+44|0;hc=nd+48|0;ic=md+36|0;jc=wd+((gd&1)<<2)|0;kc=md+4|0;lc=md+8|0;mc=md+12|0;nc=md+16|0;oc=md+20|0;pc=md+24|0;qc=md+28|0;rc=md+40|0;sc=md+48|0;tc=md+44|0;uc=md+52|0;Ac=(id|0)!=0;vc=vd+4|0;wc=gd+1|0;xc=Cd+16|0;yc=Cd+44|0;zc=(id|0)>0;x=(_|0)==5;y=md+36|0;c=sd+36|0;A=nd+4|0;B=nd+8|0;C=nd+12|0;D=nd+16|0;E=nd+20|0;F=nd+24|0;G=nd+28|0;H=nd+40|0;I=nd+48|0;J=nd+44|0;K=nd+52|0;L=vd+4|0;M=xd+8|0;O=xd+12|0;S=xd+4|0;T=od+8|0;U=od+12|0;V=od+4|0;W=pd+4|0;Y=W+4|0;Z=od+4|0;_=od+8|0;$=od+12|0;ba=od+16|0;ca=od+20|0;da=od+24|0;ea=od+28|0;fa=od+40|0;ga=od+48|0;ha=od+44|0;ia=od+52|0;ja=vd+4|0;ka=vd+8|0;ma=vd+12|0;na=vd+4|0;oa=xd+8|0;pa=xd+12|0;qa=xd+4|0;ra=a+120|0;sa=pd+8|0;ta=pd+12|0;ua=pd+4|0;va=a+128|0;wa=qd+4|0;xa=wa+4|0;ya=vd+8|0;za=vd+12|0;Aa=vd+4|0;Ba=xd+8|0;Da=xd+12|0;Ea=xd+4|0;Fa=pd+4|0;Ga=Fa+4|0;Ha=pd+4|0;Ia=pd+8|0;Ja=pd+12|0;Ka=pd+16|0;La=pd+20|0;Ma=pd+24|0;Na=pd+28|0;Oa=pd+40|0;Pa=pd+48|0;Qa=pd+44|0;Ra=pd+52|0;Sa=vd+4|0;Ta=vd+4|0;Ua=xd+4|0;Va=vd+8|0;Wa=vd+12|0;Xa=vd+4|0;Ya=xd+8|0;Za=xd+12|0;_a=xd+4|0;$a=rd+4|0;ab=$a+4|0;bb=qd+36|0;cb=qd+16|0;db=qd+4|0;eb=qd+40|0;fb=qd+44|0;gb=qd+48|0;hb=pd+36|0;ib=od+36|0;jb=nd+36|0;kb=dd+((gd+-1|0)*12|0)|0;lb=sd+32|0;mb=md+32|0;nb=pd+32|0;ob=qd+32|0;pb=nd+32|0;qb=od+32|0;rb=md+32|0;sb=nd+32|0;tb=xd+32|0;n=8988465674311578540726371.0e283;l=0.0;b=0;b:do{j=(b|0)%(kd|0)|0;if(Pc)q=1.0;else q=u*+p[Uc+(j<<3)>>3];do if(!j){if(+P(+(n-l))<t)break b;if(!Wc){n=l;l=0.0;break}h=Qc;d=0;e=k[h>>2]|0;h=k[h+4>>2]|0;do{la=Epb(e|0,0,-130063606,0)|0;la=kpb(la|0,N|0,h|0,0)|0;fd=N;ed=Epb(la|0,0,-130063606,0)|0;e=kpb(ed|0,N|0,fd|0,0)|0;h=N;la=Vc+(((la>>>0)%(kd>>>0)|0)<<2)|0;fd=Vc+(((e>>>0)%(kd>>>0)|0)<<2)|0;ed=k[la>>2]|0;k[la>>2]=k[fd>>2];k[fd>>2]=ed;d=d+1|0}while((d|0)!=(kd|0));fd=Qc;k[fd>>2]=e;k[fd+4>>2]=h;n=l;l=0.0}while(0);w=k[Vc+(j<<2)>>2]|0;e=(k[Rc>>2]|0)+(aa(k[k[Sc>>2]>>2]|0,w)|0)|0;h=k[(k[ud>>2]|0)+16>>2]|0;if(Tc){j=k[dd>>2]|0;if(Bc){d=0;do{fd=d<<1;p[j+(d<<3)>>3]=+o[e+(d<<2)>>2]*+p[h+(fd<<3)>>3]+ +p[h+((fd|1)<<3)>>3];d=d+1|0}while((d|0)!=(hd|0));d=j}else{d=0;do{fd=d<<1;p[j+(d<<3)>>3]=+p[e+(d<<3)>>3]*+p[h+(fd<<3)>>3]+ +p[h+((fd|1)<<3)>>3];d=d+1|0}while((d|0)!=(hd|0));d=j}}else d=k[dd>>2]|0;k[sd>>2]=1124007942;k[Cc>>2]=2;k[Dc>>2]=1;k[Ec>>2]=hd;k[Fc>>2]=d;k[Gc>>2]=d;k[Hc>>2]=0;k[Hc+4>>2]=0;k[Hc+8>>2]=0;k[Hc+12>>2]=0;k[Jc>>2]=Dc;k[Lc>>2]=Kc;k[Mc>>2]=0;k[Kc>>2]=0;if(Oc&(d|0)==0){k[vd>>2]=0;k[Nc>>2]=0;d=ZT(36)|0;k[d>>2]=1;ed=d+4|0;k[vd>>2]=ed;k[Nc>>2]=28;i[d+32>>0]=0;la=390609;fd=ed+28|0;do{i[ed>>0]=i[la>>0]|0;ed=ed+1|0;la=la+1|0}while((ed|0)<(fd|0));Y8(-215,vd,390638,390642,410);k[Nc>>2]=0;k[vd>>2]=0;fd=k[d>>2]|0;k[d>>2]=fd+-1;if((fd|0)==1)ggb(k[d+-4>>2]|0);e=k[Ec>>2]|0;h=k[sd>>2]|0;j=k[Lc>>2]|0;d=k[Gc>>2]|0}else{e=hd;h=1124007942;j=Kc}fd=e<<3;k[sd>>2]=h|16384;k[j>>2]=fd;k[j+4>>2]=8;ed=d+(aa(k[Dc>>2]|0,fd)|0)|0;k[Ic>>2]=ed;k[Hc>>2]=ed+(0-fd)+fd;if(ub){v=1;do{e=k[(k[td>>2]|0)+(v<<2)>>2]|0;d=k[dd+(v*12|0)>>2]|0;k[md>>2]=1124007942;k[vb>>2]=2;k[wb>>2]=1;k[xb>>2]=e;k[yb>>2]=d;k[zb>>2]=d;k[Ab>>2]=0;k[Ab+4>>2]=0;k[Ab+8>>2]=0;k[Ab+12>>2]=0;k[Cb>>2]=wb;k[Eb>>2]=Db;k[Fb>>2]=0;k[Db>>2]=0;s=(e|0)!=0;if(s&(d|0)==0){k[vd>>2]=0;k[Gb>>2]=0;d=ZT(36)|0;k[d>>2]=1;ed=d+4|0;k[vd>>2]=ed;k[Gb>>2]=28;i[d+32>>0]=0;la=390609;fd=ed+28|0;do{i[ed>>0]=i[la>>0]|0;ed=ed+1|0;la=la+1|0}while((ed|0)<(fd|0));Y8(-215,vd,390638,390642,410);k[Gb>>2]=0;k[vd>>2]=0;fd=k[d>>2]|0;k[d>>2]=fd+-1;if((fd|0)==1)ggb(k[d+-4>>2]|0);h=k[xb>>2]|0;j=k[md>>2]|0;m=k[Eb>>2]|0;d=k[zb>>2]|0}else{h=e;j=1124007942;m=Db}fd=h<<3;k[md>>2]=j|16384;k[m>>2]=fd;k[m+4>>2]=8;d=d+(aa(k[wb>>2]|0,fd)|0)|0;k[Bb>>2]=d;k[Ab>>2]=d+(0-fd)+fd;d=(k[ud>>2]|0)+(v*56|0)|0;fd=k[Ec>>2]|0;k[vd>>2]=0;k[Hb>>2]=fd;k[xd>>2]=-2147483648;k[Ib>>2]=2147483647;H1(nd,d,vd,xd);k[Jb>>2]=0;k[Kb>>2]=0;k[vd>>2]=16842752;k[Lb>>2]=sd;k[Mb>>2]=0;k[Nb>>2]=0;k[xd>>2]=16842752;k[Ob>>2]=nd;d=Qb;k[d>>2]=0;k[d+4>>2]=0;k[od>>2]=33619968;k[Pb>>2]=md;s_(vd,xd,1.0,49332,0.0,od,0);d=k[ld+(v*12|0)>>2]|0;k[xd>>2]=1124007942;k[Rb>>2]=2;k[Sb>>2]=1;k[Tb>>2]=e;k[Ub>>2]=d;k[Vb>>2]=d;k[Wb>>2]=0;k[Wb+4>>2]=0;k[Wb+8>>2]=0;k[Wb+12>>2]=0;k[Yb>>2]=Sb;k[_b>>2]=Zb;k[$b>>2]=0;k[Zb>>2]=0;if(s&(d|0)==0){k[vd>>2]=0;k[ac>>2]=0;d=ZT(36)|0;k[d>>2]=1;ed=d+4|0;k[vd>>2]=ed;k[ac>>2]=28;i[d+32>>0]=0;la=390609;fd=ed+28|0;do{i[ed>>0]=i[la>>0]|0;ed=ed+1|0;la=la+1|0}while((ed|0)<(fd|0));Y8(-215,vd,390638,390642,410);k[ac>>2]=0;k[vd>>2]=0;fd=k[d>>2]|0;k[d>>2]=fd+-1;if((fd|0)==1)ggb(k[d+-4>>2]|0);e=k[Tb>>2]|0;h=k[xd>>2]|0;j=k[_b>>2]|0;d=k[Vb>>2]|0}else{h=1124007942;j=Zb}fd=e<<3;k[xd>>2]=h|16384;k[j>>2]=fd;k[j+4>>2]=8;d=d+(aa(k[Sb>>2]|0,fd)|0)|0;k[Xb>>2]=d;k[Wb>>2]=d+(0-fd)+fd;d=k[ud>>2]|0;fza(a,md,xd,k[d+(v*56|0)+8>>2]|0,k[d+(v*56|0)+16>>2]|0,k[k[d+(v*56|0)+44>>2]>>2]|0);KG(sd,md)|0;d=k[bc>>2]|0;do if(d|0){ed=d+12|0;fd=k[ed>>2]|0;k[ed>>2]=fd+-1;if((fd|0)!=1)break;e=k[bc>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[tb>>2]|0;if(d|0)break;d=B1()|0;e=k[bc>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[bc>>2]=0}while(0);k[bc>>2]=0;k[Ub>>2]=0;k[Ub+4>>2]=0;k[Ub+8>>2]=0;k[Ub+12>>2]=0;if((k[Rb>>2]|0)>0){e=k[Yb>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Rb>>2]|0))}d=k[_b>>2]|0;if(!((d|0)==(Zb|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[cc>>2]|0;do if(d|0){ed=d+12|0;fd=k[ed>>2]|0;k[ed>>2]=fd+-1;if((fd|0)!=1)break;e=k[cc>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[sb>>2]|0;if(d|0)break;d=B1()|0;e=k[cc>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[cc>>2]=0}while(0);k[cc>>2]=0;k[dc>>2]=0;k[dc+4>>2]=0;k[dc+8>>2]=0;k[dc+12>>2]=0;if((k[ec>>2]|0)>0){e=k[fc>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[ec>>2]|0))}d=k[gc>>2]|0;if(!((d|0)==(hc|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[ic>>2]|0;do if(d|0){ed=d+12|0;fd=k[ed>>2]|0;k[ed>>2]=fd+-1;if((fd|0)!=1)break;e=k[ic>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[rb>>2]|0;if(d|0)break;d=B1()|0;e=k[ic>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[ic>>2]=0}while(0);k[ic>>2]=0;k[yb>>2]=0;k[yb+4>>2]=0;k[yb+8>>2]=0;k[yb+12>>2]=0;if((k[vb>>2]|0)>0){e=k[Cb>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[vb>>2]|0))}d=k[Eb>>2]|0;if(!((d|0)==(Db|0)|(d|0)==0))ggb(k[d+-4>>2]|0);v=v+1|0}while((v|0)<(gd|0))}d=k[jc>>2]|0;k[md>>2]=1124007942;k[kc>>2]=2;k[lc>>2]=1;k[mc>>2]=id;k[nc>>2]=d;k[oc>>2]=d;k[pc>>2]=0;k[pc+4>>2]=0;k[pc+8>>2]=0;k[pc+12>>2]=0;k[rc>>2]=lc;k[tc>>2]=sc;k[uc>>2]=0;k[sc>>2]=0;if(Ac&(d|0)==0){k[vd>>2]=0;k[vc>>2]=0;d=ZT(36)|0;k[d>>2]=1;ed=d+4|0;k[vd>>2]=ed;k[vc>>2]=28;i[d+32>>0]=0;la=390609;fd=ed+28|0;do{i[ed>>0]=i[la>>0]|0;ed=ed+1|0;la=la+1|0}while((ed|0)<(fd|0));Y8(-215,vd,390638,390642,410);k[vc>>2]=0;k[vd>>2]=0;fd=k[d>>2]|0;k[d>>2]=fd+-1;if((fd|0)==1)ggb(k[d+-4>>2]|0);e=k[mc>>2]|0;h=k[md>>2]|0;j=k[tc>>2]|0;m=k[oc>>2]|0;s=k[nc>>2]|0}else{e=id;h=1124007942;j=sc;m=d;s=d}e=e<<3;k[md>>2]=h|16384;k[j>>2]=e;k[j+4>>2]=8;j=m+(aa(k[lc>>2]|0,e)|0)|0;k[qc>>2]=j;k[pc>>2]=j+(0-e)+e;j=k[(k[ud>>2]|0)+(wc*56|0)+16>>2]|0;e=(k[xc>>2]|0)+(aa(k[k[yc>>2]>>2]|0,w)|0)|0;if(zc){h=k[kb>>2]|0;if(x){d=0;do{fd=d<<1;Ca=+o[e+(d<<2)>>2]*+p[j+(fd<<3)>>3]+ +p[j+((fd|1)<<3)>>3]-+p[h+(d<<3)>>3];p[s+(d<<3)>>3]=q*Ca;l=l+Ca*Ca;d=d+1|0}while((d|0)!=(id|0))}else{d=0;do{fd=d<<1;Ca=+p[e+(d<<3)>>3]*+p[j+(fd<<3)>>3]+ +p[j+((fd|1)<<3)>>3]-+p[h+(d<<3)>>3];p[s+(d<<3)>>3]=q*Ca;l=l+Ca*Ca;d=d+1|0}while((d|0)!=(id|0))}}l=q*l;if(ub){v=gd;do{m=v+-2|0;v=v+-1|0;d=k[td>>2]|0;s=k[d+(m<<2)>>2]|0;d=k[d+(v<<2)>>2]|0;e=k[ld+(v*12|0)>>2]|0;k[nd>>2]=1124007942;k[A>>2]=2;k[B>>2]=1;k[C>>2]=d;k[D>>2]=e;k[E>>2]=e;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;k[H>>2]=B;k[J>>2]=I;k[K>>2]=0;k[I>>2]=0;if((d|0)!=0&(e|0)==0){k[vd>>2]=0;k[L>>2]=0;d=ZT(36)|0;k[d>>2]=1;ed=d+4|0;k[vd>>2]=ed;k[L>>2]=28;i[d+32>>0]=0;la=390609;fd=ed+28|0;do{i[ed>>0]=i[la>>0]|0;ed=ed+1|0;la=la+1|0}while((ed|0)<(fd|0));Y8(-215,vd,390638,390642,410);k[L>>2]=0;k[vd>>2]=0;fd=k[d>>2]|0;k[d>>2]=fd+-1;if((fd|0)==1)ggb(k[d+-4>>2]|0);d=k[C>>2]|0;h=k[nd>>2]|0;j=k[J>>2]|0;e=k[E>>2]|0}else{h=1124007942;j=I}fd=d<<3;k[nd>>2]=h|16384;k[j>>2]=fd;k[j+4>>2]=8;d=e+(aa(k[B>>2]|0,fd)|0)|0;k[G>>2]=d;k[F>>2]=d+(0-fd)+fd;k[M>>2]=0;k[O>>2]=0;k[xd>>2]=16842752;k[S>>2]=md;k[T>>2]=0;k[U>>2]=0;k[od>>2]=16842752;k[V>>2]=nd;fd=Y;k[fd>>2]=0;k[fd+4>>2]=0;k[pd>>2]=33619968;k[W>>2]=md;p[vd>>3]=1.0;sU(xd,od,pd,49332,-1,40032,1,vd);fd=s+1|0;m=dd+(m*12|0)|0;d=k[m>>2]|0;k[od>>2]=1124007942;k[Z>>2]=2;k[_>>2]=fd;k[$>>2]=1;k[ba>>2]=d;k[ca>>2]=d;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;k[fa>>2]=_;k[ha>>2]=ga;k[ia>>2]=0;k[ga>>2]=0;if((fd|0)!=0&(d|0)==0){k[vd>>2]=0;k[ja>>2]=0;d=ZT(36)|0;k[d>>2]=1;ed=d+4|0;k[vd>>2]=ed;k[ja>>2]=28;i[d+32>>0]=0;la=390609;fd=ed+28|0;do{i[ed>>0]=i[la>>0]|0;ed=ed+1|0;la=la+1|0}while((ed|0)<(fd|0));Y8(-215,vd,390638,390642,410);k[ja>>2]=0;k[vd>>2]=0;fd=k[d>>2]|0;k[d>>2]=fd+-1;if((fd|0)==1)ggb(k[d+-4>>2]|0);e=k[$>>2]|0;h=k[od>>2]|0;j=k[ha>>2]|0;d=k[ca>>2]|0}else{e=1;h=1124007942;j=ga}fd=e<<3;k[od>>2]=h|16384;k[j>>2]=fd;k[j+4>>2]=8;ed=d+(aa(k[_>>2]|0,fd)|0)|0;k[ea>>2]=ed;k[da>>2]=ed+(0-fd)+fd;p[(k[m>>2]|0)+(s<<3)>>3]=1.0;k[ka>>2]=0;k[ma>>2]=0;k[vd>>2]=16842752;k[na>>2]=od;k[oa>>2]=0;k[pa>>2]=0;k[xd>>2]=16842752;k[qa>>2]=md;X=+p[ra>>3];fd=(k[Ad>>2]|0)+(v*56|0)|0;k[sa>>2]=0;k[ta>>2]=0;k[pd>>2]=16842752;k[ua>>2]=fd;Ca=+p[va>>3];m=xa;k[m>>2]=0;k[m+4>>2]=0;k[qd>>2]=33619968;k[wa>>2]=fd;s_(vd,xd,X,pd,Ca,qd,0);m=(k[ud>>2]|0)+(v*56|0)|0;k[ya>>2]=0;k[za>>2]=0;k[vd>>2]=16842752;k[Aa>>2]=m;k[Ba>>2]=0;k[Da>>2]=0;k[xd>>2]=16842752;k[Ea>>2]=fd;fd=Ga;k[fd>>2]=0;k[fd+4>>2]=0;k[pd>>2]=33619968;k[Fa>>2]=m;sU(vd,xd,pd,49332,-1,39936,0,0);m=(v|0)>1;if(m){d=k[wd+((v&1)<<2)>>2]|0;k[pd>>2]=1124007942;k[Ha>>2]=2;k[Ia>>2]=1;k[Ja>>2]=s;k[Ka>>2]=d;k[La>>2]=d;k[Ma>>2]=0;k[Ma+4>>2]=0;k[Ma+8>>2]=0;k[Ma+12>>2]=0;k[Oa>>2]=Ia;k[Qa>>2]=Pa;k[Ra>>2]=0;k[Pa>>2]=0;if((s|0)!=0&(d|0)==0){k[vd>>2]=0;k[Sa>>2]=0;d=ZT(36)|0;k[d>>2]=1;ed=d+4|0;k[vd>>2]=ed;k[Sa>>2]=28;i[d+32>>0]=0;la=390609;fd=ed+28|0;do{i[ed>>0]=i[la>>0]|0;ed=ed+1|0;la=la+1|0}while((ed|0)<(fd|0));Y8(-215,vd,390638,390642,410);k[Sa>>2]=0;k[vd>>2]=0;fd=k[d>>2]|0;k[d>>2]=fd+-1;if((fd|0)==1)ggb(k[d+-4>>2]|0);e=k[Ja>>2]|0;h=k[pd>>2]|0;j=k[Qa>>2]|0;d=k[La>>2]|0}else{e=s;h=1124007942;j=Pa}fd=e<<3;k[pd>>2]=h|16384;k[j>>2]=fd;k[j+4>>2]=8;d=d+(aa(k[Ia>>2]|0,fd)|0)|0;k[Na>>2]=d;k[Ma>>2]=d+(0-fd)+fd;d=(k[ud>>2]|0)+(v*56|0)|0;k[vd>>2]=0;k[Ta>>2]=s;k[xd>>2]=-2147483648;k[Ua>>2]=2147483647;H1(qd,d,vd,xd);k[Va>>2]=0;k[Wa>>2]=0;k[vd>>2]=16842752;k[Xa>>2]=md;k[Ya>>2]=0;k[Za>>2]=0;k[xd>>2]=16842752;k[_a>>2]=qd;d=ab;k[d>>2]=0;k[d+4>>2]=0;k[rd>>2]=33619968;k[$a>>2]=pd;s_(vd,xd,1.0,49332,0.0,rd,2);KG(md,pd)|0;d=k[bb>>2]|0;do if(d|0){ed=d+12|0;fd=k[ed>>2]|0;k[ed>>2]=fd+-1;if((fd|0)!=1)break;e=k[bb>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[ob>>2]|0;if(d|0)break;d=B1()|0;e=k[bb>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[bb>>2]=0}while(0);k[bb>>2]=0;k[cb>>2]=0;k[cb+4>>2]=0;k[cb+8>>2]=0;k[cb+12>>2]=0;if((k[db>>2]|0)>0){e=k[eb>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[db>>2]|0))}d=k[fb>>2]|0;if(!((d|0)==(gb|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[hb>>2]|0;do if(d|0){ed=d+12|0;fd=k[ed>>2]|0;k[ed>>2]=fd+-1;if((fd|0)!=1)break;e=k[hb>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[nb>>2]|0;if(d|0)break;d=B1()|0;e=k[hb>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[hb>>2]=0}while(0);k[hb>>2]=0;k[Ka>>2]=0;k[Ka+4>>2]=0;k[Ka+8>>2]=0;k[Ka+12>>2]=0;if((k[Ha>>2]|0)>0){e=k[Oa>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Ha>>2]|0))}d=k[Qa>>2]|0;if(!((d|0)==(Pa|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}d=k[ib>>2]|0;do if(d|0){ed=d+12|0;fd=k[ed>>2]|0;k[ed>>2]=fd+-1;if((fd|0)!=1)break;e=k[ib>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[qb>>2]|0;if(d|0)break;d=B1()|0;e=k[ib>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[ib>>2]=0}while(0);k[ib>>2]=0;k[ba>>2]=0;k[ba+4>>2]=0;k[ba+8>>2]=0;k[ba+12>>2]=0;if((k[Z>>2]|0)>0){e=k[fa>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Z>>2]|0))}d=k[ha>>2]|0;if(!((d|0)==(ga|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[jb>>2]|0;do if(d|0){ed=d+12|0;fd=k[ed>>2]|0;k[ed>>2]=fd+-1;if((fd|0)!=1)break;e=k[jb>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[pb>>2]|0;if(d|0)break;d=B1()|0;e=k[jb>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[jb>>2]=0}while(0);k[jb>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[A>>2]|0)>0){e=k[H>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[A>>2]|0))}d=k[J>>2]|0;if(!((d|0)==(I|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}while(m)}d=k[y>>2]|0;do if(d|0){ed=d+12|0;fd=k[ed>>2]|0;k[ed>>2]=fd+-1;if((fd|0)!=1)break;e=k[y>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[mb>>2]|0;if(d|0)break;d=B1()|0;e=k[y>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[y>>2]=0}while(0);k[y>>2]=0;k[nc>>2]=0;k[nc+4>>2]=0;k[nc+8>>2]=0;k[nc+12>>2]=0;if((k[kc>>2]|0)>0){e=k[rc>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[kc>>2]|0))}d=k[tc>>2]|0;if(!((d|0)==(sc|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[c>>2]|0;do if(d|0){ed=d+12|0;fd=k[ed>>2]|0;k[ed>>2]=fd+-1;if((fd|0)!=1)break;e=k[c>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[lb>>2]|0;if(d|0)break;d=B1()|0;e=k[c>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[c>>2]=0}while(0);k[c>>2]=0;k[Fc>>2]=0;k[Fc+4>>2]=0;k[Fc+8>>2]=0;k[Fc+12>>2]=0;if((k[Cc>>2]|0)>0){e=k[Jc>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Cc>>2]|0))}d=k[Lc>>2]|0;if(!((d|0)==(Kc|0)|(d|0)==0))ggb(k[d+-4>>2]|0);b=b+1|0}while((b|0)<(jd|0));d=k[yd>>2]|0}else b=0;b=(b|0)/(kd|0)|0;if((d|0)!=(Xc|0)){if(d|0)ggb(d);k[yd>>2]=Xc;k[Yc>>2]=136}h=zd+36|0;d=k[h>>2]|0;do if(d|0){xd=d+12|0;yd=k[xd>>2]|0;k[xd>>2]=yd+-1;if((yd|0)!=1)break;e=k[h>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[zd+32>>2]|0;if(d|0)break;d=B1()|0;e=k[h>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[h>>2]=0}while(0);k[h>>2]=0;k[Zc>>2]=0;k[Zc+4>>2]=0;k[Zc+8>>2]=0;k[Zc+12>>2]=0;if((k[bd>>2]|0)>0){e=k[_c>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[bd>>2]|0))}d=k[$c>>2]|0;if(!((d|0)==(cd|0)|(d|0)==0))ggb(k[d+-4>>2]|0);zF(Ad);if(ld|0){if((g|0)!=(ld|0))do{d=g;g=g+-12|0;h=k[g>>2]|0;j=h;if(h|0){d=d+-8|0;e=k[d>>2]|0;if((e|0)!=(h|0))k[d>>2]=e+(~((e+-8-j|0)>>>3)<<3);ggb(h)}}while((g|0)!=(ld|0));ggb(ld)}if(!dd)break;if((f|0)!=(dd|0))do{d=f;f=f+-12|0;g=k[f>>2]|0;h=g;if(g|0){d=d+-8|0;e=k[d>>2]|0;if((e|0)!=(g|0))k[d>>2]=e+(~((e+-8-h|0)>>>3)<<3);ggb(g)}}while((f|0)!=(dd|0));ggb(dd)}else{xa=k[G>>2]|0;t=+p[a+144>>3];u=+p[a+152>>3];z=+p[a+160>>3];X=+p[a+168>>3];ya=(k[L>>2]|0)-(k[td>>2]|0)|0;Aa=ya>>2;k[xd>>2]=0;j=xd+4|0;k[j>>2]=0;k[xd+8>>2]=0;m=(Aa|0)==0;if(!m){if(Aa>>>0>76695844)ad(426534,426557,304,426811);d=Aa*56|0;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[j>>2]=b;k[xd>>2]=b;k[xd+8>>2]=b+(Aa*56|0);d=Aa;h=b;g=b;while(1){k[h>>2]=1124007936;e=h+8|0;f=h+40|0;ed=h+4|0;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[f>>2]=e;e=h+48|0;k[h+44>>2]=e;k[h+52>>2]=0;k[e>>2]=0;e=g+56|0;d=d+-1|0;if(!d)break;else{h=e;g=e}}k[j>>2]=b+(Aa*56|0)}k[Ad>>2]=0;j=Ad+4|0;k[j>>2]=0;k[Ad+8>>2]=0;if(!m){if(Aa>>>0>76695844)ad(426534,426557,304,426811);d=Aa*56|0;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[j>>2]=b;k[Ad>>2]=b;k[Ad+8>>2]=b+(Aa*56|0);d=Aa;h=b;g=b;while(1){k[h>>2]=1124007936;e=h+8|0;f=h+40|0;ed=h+4|0;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[f>>2]=e;e=h+48|0;k[h+44>>2]=e;k[h+52>>2]=0;k[e>>2]=0;e=g+56|0;d=d+-1|0;if(!d)break;else{h=e;g=e}}k[j>>2]=b+(Aa*56|0)}k[zd>>2]=0;j=zd+4|0;k[j>>2]=0;k[zd+8>>2]=0;if(m)e=0;else{if(Aa>>>0>76695844)ad(426534,426557,304,426811);d=Aa*56|0;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[j>>2]=b;k[zd>>2]=b;k[zd+8>>2]=b+(Aa*56|0);d=Aa;h=b;g=b;while(1){k[h>>2]=1124007936;e=h+8|0;f=h+40|0;ed=h+4|0;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[f>>2]=e;e=h+48|0;k[h+44>>2]=e;k[h+52>>2]=0;k[e>>2]=0;e=g+56|0;d=d+-1|0;if(!d)break;else{h=e;g=e}}k[j>>2]=b+(Aa*56|0);e=b}za=(ya|0)>0;if(za){j=vd+4|0;m=a+136|0;s=yd+8|0;v=yd+16|0;w=yd+24|0;x=vd+8|0;y=vd+12|0;c=vd+4|0;A=k[xd>>2]|0;B=yd+4|0;C=yd+8|0;D=yd+12|0;E=yd+16|0;F=yd+48|0;G=yd+56|0;H=yd+52|0;I=yd+60|0;J=yd+64|0;K=yd+68|0;L=yd+72|0;M=yd+104|0;O=yd+112|0;S=yd+108|0;T=yd+116|0;U=yd+120|0;V=yd+124|0;W=yd+128|0;Y=yd+160|0;Z=yd+168|0;_=yd+164|0;$=vd+4|0;ba=yd+4|0;ca=yd+8|0;da=yd+12|0;ea=yd+16|0;fa=yd+48|0;ga=yd+56|0;ha=yd+52|0;ia=yd+60|0;ja=yd+64|0;ka=yd+68|0;la=yd+72|0;ma=yd+104|0;na=yd+112|0;oa=yd+108|0;pa=yd+116|0;qa=yd+120|0;ra=yd+124|0;sa=yd+128|0;ta=yd+160|0;ua=yd+168|0;va=yd+164|0;wa=vd+4|0;g=0;h=0;do{g=(k[(k[td>>2]|0)+(h<<2)>>2]|0)+g|0;b=A+(h*56|0)|0;f=k[(k[ud>>2]|0)+(h*56|0)+40>>2]|0;d=k[f+4>>2]|0;f=k[f>>2]|0;do if((k[A+(h*56|0)+4>>2]|0)<3){if((k[A+(h*56|0)+8>>2]|0)!=(f|0)){Da=394;break}if((k[A+(h*56|0)+12>>2]|0)!=(d|0)){Da=394;break}if((k[b>>2]&4095|0)!=6){Da=394;break}if(!(k[A+(h*56|0)+16>>2]|0))Da=394}else Da=394;while(0);if((Da|0)==394){Da=0;k[vd>>2]=f;k[j>>2]=d;G1(b,2,vd,6)}q=+p[m>>3];p[yd>>3]=q;p[s>>3]=q;p[v>>3]=q;p[w>>3]=q;k[vd>>2]=-1056833530;k[c>>2]=yd;k[x>>2]=1;k[y>>2]=4;pY(b,vd,49332);d=k[(k[ud>>2]|0)+(h*56|0)+40>>2]|0;b=k[d+4>>2]|0;d=k[d>>2]|0;k[yd>>2]=0;k[B>>2]=0;k[C>>2]=1124007936;ed=D;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[F>>2]=E;k[H>>2]=G;k[I>>2]=0;k[G>>2]=0;k[J>>2]=1124007936;ed=K;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[M>>2]=L;k[S>>2]=O;k[T>>2]=0;k[O>>2]=0;k[U>>2]=1124007936;ed=V;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[Y>>2]=W;k[_>>2]=Z;ed=Z;fd=ed+56|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[vd>>2]=b;k[$>>2]=d;j1(yd,48,vd,1);b=k[yd>>2]|0;dh[k[(k[b>>2]|0)+12>>2]&255](b,yd,e+(h*56|0)|0,-1);XN(yd);b=k[Ad>>2]|0;f=k[(k[ud>>2]|0)+(h*56|0)+40>>2]|0;d=k[f+4>>2]|0;f=k[f>>2]|0;k[yd>>2]=0;k[ba>>2]=0;k[ca>>2]=1124007936;ed=da;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[fa>>2]=ea;k[ha>>2]=ga;k[ia>>2]=0;k[ga>>2]=0;k[ja>>2]=1124007936;ed=ka;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[ma>>2]=la;k[oa>>2]=na;k[pa>>2]=0;k[na>>2]=0;k[qa>>2]=1124007936;ed=ra;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[ta>>2]=sa;k[va>>2]=ua;ed=ua;fd=ed+56|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[vd>>2]=d;k[wa>>2]=f;j1(yd,48,vd,6);sd=k[yd>>2]|0;dh[k[(k[sd>>2]|0)+12>>2]&255](sd,yd,b+(h*56|0)|0,-1);XN(yd);h=h+1|0}while((h|0)<(Aa|0));b=g<<1}else b=0;ka=65536/(b|0)|0;ka=(ka|0)<1?1:ka;ka=(xa|0)<(ka|0)?xa:ka;ia=(xa+-1+ka|0)/(ka|0)|0;c:do if((Ba|0)>0){ja=wd+4|0;F=(ya|0)>4;G=wd+4|0;H=yd+8|0;I=yd+12|0;J=yd+4|0;K=yd+12|0;L=yd+16|0;M=yd+20|0;O=yd+52|0;S=yd+60|0;T=yd+56|0;U=yd+64|0;V=yd+68|0;W=yd+72|0;Y=yd+76|0;Z=yd+108|0;_=yd+116|0;$=yd+112|0;ba=yd+120|0;ca=yd+4|0;da=Bd+16|0;ea=yd+124|0;fa=yd+128|0;ga=yd+8|0;ha=yd+132|0;b=0;q=8988465674311578540726371.0e283;while(1){p[vd>>3]=0.0;if(za){d=0;do{sd=k[Ad>>2]|0;k[wd>>2]=0;k[wd+4>>2]=0;k[wd+8>>2]=0;k[wd+12>>2]=0;k[wd+16>>2]=0;k[wd+20>>2]=0;k[wd+24>>2]=0;k[wd+28>>2]=0;k[yd>>2]=-1056833530;k[J>>2]=wd;k[H>>2]=1;k[I>>2]=4;pY(sd+(d*56|0)|0,yd,49332);d=d+1|0}while((d|0)<(Aa|0))}k[yd>>2]=90772;k[K>>2]=1124007936;ed=L;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[O>>2]=M;k[T>>2]=S;k[U>>2]=0;k[S>>2]=0;k[V>>2]=1124007936;ed=W;fd=ed+36|0;do{k[ed>>2]=0;ed=ed+4|0}while((ed|0)<(fd|0));k[Z>>2]=Y;k[$>>2]=_;k[ba>>2]=0;k[_>>2]=0;k[ca>>2]=a;KG(K,Dd)|0;KG(V,Cd)|0;k[ea>>2]=k[da>>2];k[fa>>2]=ka;k[ga>>2]=Ad;k[ha>>2]=vd;k[wd>>2]=0;k[ja>>2]=ia;jh[k[(k[yd>>2]|0)+8>>2]&1023](yd,wd);if(F){E=1;d=e;do{B=k[td>>2]|0;A=k[B+(E+-1<<2)>>2]|0;B=k[B+(E<<2)>>2]|0;if((A|0)>=0){C=A+1|0;D=(B|0)>0;c=0;while(1){e=k[ud>>2]|0;sd=k[e+(E*56|0)+40>>2]|0;if(!((k[sd>>2]|0)==(C|0)?(k[sd+4>>2]|0)==(B|0):0)){k[wd>>2]=0;k[G>>2]=0;d=ZT(40)|0;k[d>>2]=1;ed=d+4|0;k[wd>>2]=ed;k[G>>2]=35;i[d+39>>0]=0;la=360631;fd=ed+35|0;do{i[ed>>0]=i[la>>0]|0;ed=ed+1|0;la=la+1|0}while((ed|0)<(fd|0));Y8(-215,wd,360667,360247,1055);k[G>>2]=0;k[wd>>2]=0;sd=k[d>>2]|0;k[d>>2]=sd+-1;if((sd|0)==1)ggb(k[d+-4>>2]|0);e=k[ud>>2]|0;d=k[zd>>2]|0}f=(k[e+(E*56|0)+16>>2]|0)+(aa(k[k[e+(E*56|0)+44>>2]>>2]|0,c)|0)|0;g=k[xd>>2]|0;g=(k[g+(E*56|0)+16>>2]|0)+(aa(k[k[g+(E*56|0)+44>>2]>>2]|0,c)|0)|0;h=k[Ad>>2]|0;h=(k[h+(E*56|0)+16>>2]|0)+(aa(k[k[h+(E*56|0)+44>>2]>>2]|0,c)|0)|0;j=(k[d+(E*56|0)+16>>2]|0)+(aa(k[k[d+(E*56|0)+44>>2]>>2]|0,c)|0)|0;if(D){e=0;do{m=h+(e<<3)|0;Fd=+p[m>>3];s=g+(e<<3)|0;l=+p[s>>3];v=f+(e<<3)|0;n=+p[v>>3];w=(Fd>0.0&1)-(Fd<0.0&1)|0;x=j+e|0;y=aa(i[x>>0]|0,w)|0;do if((y|0)<=0)if((y|0)<0){Fd=u*l;Fd=Fd<z?z:Fd;i[x>>0]=0;p[s>>3]=Fd;p[v>>3]=n+Fd*+(w|0);break}else{i[x>>0]=w;p[v>>3]=n+l*+(w|0);break}else{Fd=t*l;Fd=X<Fd?X:Fd;p[s>>3]=Fd;p[v>>3]=n+Fd*+(w|0)}while(0);p[m>>3]=0.0;e=e+1|0}while((e|0)!=(B|0))}if((c|0)<(A|0))c=c+1|0;else break}}E=E+1|0}while((E|0)<(Aa|0))}else d=e;Fd=q;q=+p[vd>>3];cza(yd);if(+P(+(Fd-q))<Ca)break c;b=b+1|0;if((b|0)>=(Ba|0))break;else e=d}}else b=0;while(0);zF(zd);zF(Ad);zF(xd)}while(0);f=(b|0)>0;i[a+188>>0]=f&1;e=Bd+36|0;b=k[e>>2]|0;if(b|0?(Ad=b+12|0,a=k[Ad>>2]|0,k[Ad>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Bd+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;a=Bd+16|0;d=Bd+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[d>>2]|0)>0){e=k[Bd+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[Bd+44>>2]|0;if(!((b|0)==(Bd+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=Cd+36|0;b=k[e>>2]|0;if(b|0?(a=b+12|0,Bd=k[a>>2]|0,k[a>>2]=Bd+-1,(Bd|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Cd+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;Bd=Cd+16|0;d=Cd+4|0;k[Bd>>2]=0;k[Bd+4>>2]=0;k[Bd+8>>2]=0;k[Bd+12>>2]=0;if((k[d>>2]|0)>0){e=k[Cd+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[Cd+44>>2]|0;if(!((b|0)==(Cd+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=Dd+36|0;b=k[e>>2]|0;if(b|0?(Bd=b+12|0,Cd=k[Bd>>2]|0,k[Bd>>2]=Cd+-1,(Cd|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Dd+32>>2]|0;if(b|0)break;b=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;Cd=Dd+16|0;d=Dd+4|0;k[Cd>>2]=0;k[Cd+4>>2]=0;k[Cd+8>>2]=0;k[Cd+12>>2]=0;if((k[d>>2]|0)>0){e=k[Dd+40>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[Dd+44>>2]|0;if((b|0)==(Dd+48|0)|(b|0)==0){r=Ed;return f|0}ggb(k[b+-4>>2]|0);r=Ed;return f|0}function Hya(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0.0;Ab=r;r=r+1504|0;ib=Ab+1096|0;jb=Ab+1448|0;zb=Ab+1392|0;yb=Ab+1336|0;xb=Ab;kb=Ab+1280|0;fb=Ab+1224|0;gb=Ab+1168|0;hb=Ab+1152|0;if(!(i[a+188>>0]|0)){d=ib+4|0;e=ZT(48)|0;k[e>>2]=1;s=e+4|0;k[ib>>2]=s;k[d>>2]=42;i[e+46>>0]=0;g=360477;t=s+42|0;do{i[s>>0]=i[g>>0]|0;s=s+1|0;g=g+1|0}while((s|0)<(t|0));Y8(-2,ib,372250,360247,245);k[d>>2]=0;k[ib>>2]=0;db=k[e>>2]|0;k[e>>2]=db+-1;if((db|0)==1)ggb(k[e+-4>>2]|0)}do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[zb>>2]=k[h>>2];n=zb+4|0;d=h+4|0;k[n>>2]=k[d>>2];e=zb+8|0;k[e>>2]=k[h+8>>2];k[zb+12>>2]=k[h+12>>2];k[zb+16>>2]=k[h+16>>2];k[zb+20>>2]=k[h+20>>2];k[zb+24>>2]=k[h+24>>2];k[zb+28>>2]=k[h+28>>2];k[zb+32>>2]=k[h+32>>2];b=k[h+36>>2]|0;k[zb+36>>2]=b;g=zb+40|0;k[g>>2]=e;db=zb+48|0;l=zb+44|0;k[l>>2]=db;k[zb+52>>2]=0;k[db>>2]=0;if(b|0){db=b+12|0;k[db>>2]=(k[db>>2]|0)+1}if((k[d>>2]|0)<3){db=k[h+44>>2]|0;d=k[l>>2]|0;k[d>>2]=k[db>>2];k[d+4>>2]=k[db+4>>2];d=zb;break}k[n>>2]=0;x1(zb,k[d>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;b=k[l>>2]|0;d=0;do{k[j+(d<<2)>>2]=k[m+(d<<2)>>2];k[b+(d<<2)>>2]=k[g+(d<<2)>>2];d=d+1|0}while((d|0)<(k[n>>2]|0));d=zb}else d=zb}else{Q1(zb,b,-1);e=zb+8|0;d=zb}while(0);j=k[d>>2]&4095;Za=a+4|0;_a=a+8|0;d=k[Za>>2]|0;n=(k[_a>>2]|0)-d|0;$a=n>>2;Ya=k[e>>2]|0;if((j+-5|0)>>>0<2?(k[zb+12>>2]|0)==(k[d>>2]|0):0)Xa=Za;else{k[ib>>2]=0;d=ib+4|0;k[d>>2]=0;e=ZT(72)|0;k[e>>2]=1;s=e+4|0;k[ib>>2]=s;k[d>>2]=67;i[e+71>>0]=0;g=360520;t=s+67|0;do{i[s>>0]=i[g>>0]|0;s=s+1|0;g=g+1|0}while((s|0)<(t|0));Y8(-215,ib,372250,360247,251);k[d>>2]=0;k[ib>>2]=0;db=k[e>>2]|0;k[e>>2]=db+-1;if((db|0)==1)ggb(k[e+-4>>2]|0);Xa=Za;d=k[Za>>2]|0}h=k[d+($a+-1<<2)>>2]|0;k[yb>>2]=1124007936;cb=yb+4|0;d=yb+8|0;ab=yb+40|0;s=cb;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[ab>>2]=d;db=yb+48|0;bb=yb+44|0;k[bb>>2]=db;k[yb+52>>2]=0;k[db>>2]=0;Wa=a+84|0;d=k[Wa>>2]<<1;e=aa(d,Ya)|0;b=k[a+88>>2]|0;if((e|0)>(b|0)){Ta=(b|0)/(d|0)|0;Ta=(Ta|0)<1?1:Ta;e=aa(Ta,d)|0}else Ta=Ya;g=e+h|0;Ua=xb+8|0;k[xb>>2]=Ua;Va=xb+4|0;k[Va>>2]=136;if(g>>>0>136){b=g>>>0>536870911?-1:g<<3;b=(b|0)==0?1:b;while(1){d=fgb(b)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[xb>>2]=d;Sa=d}else Sa=Ua;k[Va>>2]=g;if(!(k[c>>2]&2031616)){if((Ya|0)!=1?(k[ib>>2]=0,Ra=ib+4|0,k[Ra>>2]=0,q=ZT(12)|0,k[q>>2]=1,Qa=q+4|0,k[ib>>2]=Qa,k[Ra>>2]=6,i[q+10>>0]=0,i[Qa>>0]=i[360588]|0,i[Qa+1>>0]=i[360589]|0,i[Qa+2>>0]=i[360590]|0,i[Qa+3>>0]=i[360591]|0,i[Qa+4>>0]=i[360592]|0,i[Qa+5>>0]=i[360593]|0,Y8(-215,ib,372250,360247,270),k[Ra>>2]=0,k[ib>>2]=0,Ra=k[q>>2]|0,k[q>>2]=Ra+-1,(Ra|0)==1):0)ggb(k[q+-4>>2]|0);JN(ib,Ya,h,j,Sa+(e<<3)|0,0);KG(yb,ib)|0;b=ib+36|0;d=k[b>>2]|0;if(d|0?(Qa=d+12|0,Ra=k[Qa>>2]|0,k[Qa>>2]=Ra+-1,(Ra|0)==1):0){e=k[b>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[ib+32>>2]|0;if(!d){d=B1()|0;e=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[b>>2]=0}k[b>>2]=0;Ra=ib+16|0;e=ib+4|0;k[Ra>>2]=0;k[Ra+4>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;if((k[e>>2]|0)>0){b=k[ib+40>>2]|0;d=0;do{k[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[ib+44>>2]|0;if(!((d|0)==(ib+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}else{c2(c,Ya,h,j,-1,0,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[ib>>2]=k[g>>2];m=ib+4|0;d=g+4|0;k[m>>2]=k[d>>2];Ra=ib+8|0;k[Ra>>2]=k[g+8>>2];k[ib+12>>2]=k[g+12>>2];k[ib+16>>2]=k[g+16>>2];k[ib+20>>2]=k[g+20>>2];k[ib+24>>2]=k[g+24>>2];k[ib+28>>2]=k[g+28>>2];k[ib+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[ib+36>>2]=e;b=ib+40|0;k[b>>2]=Ra;Ra=ib+48|0;j=ib+44|0;k[j>>2]=Ra;k[ib+52>>2]=0;k[Ra>>2]=0;if(e|0){Ra=e+12|0;k[Ra>>2]=(k[Ra>>2]|0)+1}if((k[d>>2]|0)<3){Qa=k[g+44>>2]|0;Ra=k[j>>2]|0;k[Ra>>2]=k[Qa>>2];k[Ra+4>>2]=k[Qa+4>>2];break}k[m>>2]=0;x1(ib,k[d>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[b>>2]|0;b=k[g+44>>2]|0;e=k[j>>2]|0;d=0;do{k[h+(d<<2)>>2]=k[l+(d<<2)>>2];k[e+(d<<2)>>2]=k[b+(d<<2)>>2];d=d+1|0}while((d|0)<(k[m>>2]|0))}}else Q1(ib,c,-1);while(0);KG(yb,ib)|0;b=ib+36|0;d=k[b>>2]|0;if(d|0?(Qa=d+12|0,Ra=k[Qa>>2]|0,k[Qa>>2]=Ra+-1,(Ra|0)==1):0){e=k[b>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[ib+32>>2]|0;if(!d){d=B1()|0;e=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[b>>2]=0}k[b>>2]=0;Ra=ib+16|0;e=ib+4|0;k[Ra>>2]=0;k[Ra+4>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;if((k[e>>2]|0)>0){b=k[ib+40>>2]|0;d=0;do{k[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[ib+44>>2]|0;if(!((d|0)==(ib+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}if((Ya|0)>0){Fa=ib+4|0;Ga=jb+4|0;Ha=kb+12|0;Ia=fb+4|0;Ja=fb+8|0;Ka=fb+12|0;La=fb+16|0;Ma=fb+20|0;Na=fb+24|0;Oa=fb+28|0;Pa=fb+40|0;Qa=fb+48|0;Ra=fb+44|0;y=(n|0)>4;z=ib+4|0;A=jb+4|0;B=gb+36|0;C=gb+16|0;D=gb+4|0;E=gb+40|0;F=gb+44|0;G=gb+48|0;H=fb+36|0;I=kb+36|0;J=kb+16|0;K=kb+4|0;L=kb+40|0;M=kb+44|0;N=kb+48|0;O=jb+4|0;P=jb+8|0;Q=jb+12|0;R=jb+16|0;S=jb+20|0;T=jb+24|0;U=jb+28|0;V=jb+40|0;W=jb+48|0;X=jb+44|0;Y=jb+52|0;Z=ib+4|0;_=jb+36|0;$=a+16|0;ba=ib+4|0;ca=jb+4|0;da=ib+8|0;ea=ib+12|0;fa=ib+4|0;ga=jb+8|0;ha=jb+12|0;ia=jb+4|0;ja=hb+4|0;ka=ja+4|0;la=gb+36|0;ma=gb+16|0;na=gb+4|0;oa=gb+40|0;pa=gb+44|0;qa=gb+48|0;ra=fb+52|0;sa=kb+8|0;ta=kb+32|0;ua=fb+32|0;va=gb+32|0;wa=a+40|0;xa=a+80|0;ya=ib+4|0;za=ib+8|0;Aa=ib+12|0;Ba=ib+4|0;Ca=jb+4|0;Da=Ca+4|0;Ea=gb+32|0;w=a+32|0;x=jb+32|0;v=0;do{a=Ya-v|0;a=(a|0)<(Ta|0)?a:Ta;c=v;v=a+v|0;k[ib>>2]=c;k[Fa>>2]=v;k[jb>>2]=-2147483648;k[Ga>>2]=2147483647;H1(kb,zb,ib,jb);h=k[Ha>>2]|0;k[Ia>>2]=2;k[Ja>>2]=a;k[Ka>>2]=h;k[La>>2]=Sa;k[Ma>>2]=Sa;j=Na+8|0;k[j>>2]=0;k[j+4>>2]=0;k[Pa>>2]=Ja;k[Ra>>2]=Qa;j=h<<3;k[fb>>2]=1124024326;k[Qa>>2]=j;k[ra>>2]=8;l=Sa+(aa(a,j)|0)|0;k[Oa>>2]=l;k[Na>>2]=l+(0-j)+j;j=k[(k[$>>2]|0)+16>>2]|0;l=k[sa>>2]|0;d=(l|0)>0;if((k[kb>>2]&4095|0)==5){if(d?(nb=k[J>>2]|0,ob=k[k[M>>2]>>2]|0,(h|0)>0):0){d=0;do{b=nb+(aa(ob,d)|0)|0;g=Sa+((aa(h,d)|0)<<3)|0;e=0;do{t=e<<1;p[g+(e<<3)>>3]=+o[b+(e<<2)>>2]*+p[j+(t<<3)>>3]+ +p[j+((t|1)<<3)>>3];e=e+1|0}while((e|0)!=(h|0));d=d+1|0}while((d|0)!=(l|0))}}else if(d?(lb=k[J>>2]|0,mb=k[k[M>>2]>>2]|0,(h|0)>0):0){d=0;do{b=lb+(aa(mb,d)|0)|0;g=Sa+((aa(h,d)|0)<<3)|0;e=0;do{t=e<<1;p[g+(e<<3)>>3]=+o[b+(e<<2)>>2]*+p[j+(t<<3)>>3]+ +p[j+((t|1)<<3)>>3];e=e+1|0}while((e|0)!=(h|0));d=d+1|0}while((d|0)!=(l|0))}KG(kb,fb)|0;a:do if(y){q=1;while(1){if(!(q&1))d=0;else d=aa(k[Wa>>2]|0,Ta)|0;e=Sa+(d<<3)|0;d=k[(k[Xa>>2]|0)+(q<<2)>>2]|0;k[jb>>2]=1124007942;k[O>>2]=2;k[P>>2]=a;k[Q>>2]=d;k[R>>2]=e;k[S>>2]=e;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;k[V>>2]=P;k[X>>2]=W;k[Y>>2]=0;k[W>>2]=0;if((e|0)==0&(aa(d,a)|0)!=0){k[ib>>2]=0;k[Z>>2]=0;d=ZT(36)|0;k[d>>2]=1;s=d+4|0;k[ib>>2]=s;k[Z>>2]=28;i[d+32>>0]=0;g=390609;t=s+28|0;do{i[s>>0]=i[g>>0]|0;s=s+1|0;g=g+1|0}while((s|0)<(t|0));Y8(-215,ib,390638,390642,410);k[Z>>2]=0;k[ib>>2]=0;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0);d=k[Q>>2]|0;b=k[jb>>2]|0;g=k[X>>2]|0;e=k[S>>2]|0}else{b=1124007942;g=W}d=d<<3;k[jb>>2]=b|16384;k[g>>2]=d;k[g+4>>2]=8;t=e+(aa(k[P>>2]|0,d)|0)|0;k[U>>2]=t;k[T>>2]=t+(0-d)+d;KG(fb,jb)|0;d=k[_>>2]|0;if(d|0?(s=d+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){e=k[_>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[x>>2]|0;if(d|0)break;d=B1()|0;e=k[_>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[_>>2]=0}k[_>>2]=0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[O>>2]|0)>0){e=k[V>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[O>>2]|0))}d=k[X>>2]|0;if(!((d|0)==(W|0)|(d|0)==0))ggb(k[d+-4>>2]|0);l=(k[$>>2]|0)+(q*56|0)|0;n=k[Ha>>2]|0;k[ib>>2]=0;k[ba>>2]=n;k[jb>>2]=-2147483648;k[ca>>2]=2147483647;H1(gb,l,ib,jb);k[da>>2]=0;k[ea>>2]=0;k[ib>>2]=16842752;k[fa>>2]=kb;k[ga>>2]=0;k[ha>>2]=0;k[jb>>2]=16842752;k[ia>>2]=gb;l=ka;k[l>>2]=0;k[l+4>>2]=0;k[hb>>2]=33619968;k[ja>>2]=fb;s_(ib,jb,1.0,49332,0.0,hb,0);l=k[$>>2]|0;l=(k[l+(q*56|0)+16>>2]|0)+(aa(k[k[l+(q*56|0)+44>>2]>>2]|0,(k[l+(q*56|0)+8>>2]|0)+-1|0)|0)|0;n=k[Ja>>2]|0;m=k[Ka>>2]|0;u=+p[wa>>3];d=k[xa>>2]|0;switch(d|0){case 0:{f=1.0;break}case 1:{f=-+p[w>>3];break}case 2:{f=+p[w>>3];f=-(f*f);break}default:f=0.0}if(!(k[fb>>2]&16384)){k[ib>>2]=0;k[ya>>2]=0;d=ZT(24)|0;k[d>>2]=1;s=d+4|0;k[ib>>2]=s;k[ya>>2]=19;i[d+23>>0]=0;g=360595;t=s+19|0;do{i[s>>0]=i[g>>0]|0;s=s+1|0;g=g+1|0}while((s|0)<(t|0));Y8(-215,ib,360615,360247,392);k[ya>>2]=0;k[ib>>2]=0;t=k[d>>2]|0;k[d>>2]=t+-1;if((t|0)==1)ggb(k[d+-4>>2]|0);d=k[xa>>2]|0}e=(n|0)>0;do if((d|0)!=2){do if(e){g=k[La>>2]|0;h=k[k[Ra>>2]>>2]|0;if((m|0)>0)b=0;else break;do{j=g+(aa(h,b)|0)|0;e=0;do{t=j+(e<<3)|0;p[t>>3]=f*(+p[t>>3]+ +p[l+(e<<3)>>3]);e=e+1|0}while((e|0)!=(m|0));b=b+1|0}while((b|0)!=(n|0))}while(0);if(d|0)eb=124}else{if(!e){eb=124;break}b=k[La>>2]|0;g=k[k[Ra>>2]>>2]|0;if((m|0)>0)e=0;else{eb=124;break}do{h=b+(aa(g,e)|0)|0;d=0;do{eb=h+(d<<3)|0;Bb=+p[eb>>3]+ +p[l+(d<<3)>>3];p[eb>>3]=f*(Bb*Bb);d=d+1|0}while((d|0)!=(m|0));e=e+1|0}while((e|0)!=(n|0));eb=124}while(0);b:do if((eb|0)==124){eb=0;k[za>>2]=0;k[Aa>>2]=0;k[ib>>2]=16842752;k[Ba>>2]=fb;j=Da;k[j>>2]=0;k[j+4>>2]=0;k[jb>>2]=33619968;k[Ca>>2]=fb;XZ(ib,jb);j=(k[fb>>2]&16384|0)!=0;l=aa(j?n:1,m)|0;j=j?1:n;switch(k[xa>>2]|0){case 1:{if((j|0)<=0)break b;b=k[La>>2]|0;g=k[k[Ra>>2]>>2]|0;if((l|0)>0)e=0;else break b;do{h=b+(aa(g,e)|0)|0;d=0;do{t=h+(d<<3)|0;Bb=+p[t>>3];p[t>>3]=u*(1.0-Bb)/(Bb+1.0);d=d+1|0}while((d|0)!=(l|0));e=e+1|0}while((e|0)!=(j|0));break}case 2:{if((j|0)<=0)break b;b=k[La>>2]|0;g=k[k[Ra>>2]>>2]|0;if((l|0)>0)e=0;else break b;do{h=b+(aa(g,e)|0)|0;d=0;do{t=h+(d<<3)|0;p[t>>3]=u*+p[t>>3];d=d+1|0}while((d|0)!=(l|0));e=e+1|0}while((e|0)!=(j|0));break}default:break b}}while(0);KG(kb,fb)|0;d=k[la>>2]|0;do if(d|0){s=d+12|0;t=k[s>>2]|0;k[s>>2]=t+-1;if((t|0)!=1)break;e=k[la>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[Ea>>2]|0;if(d|0)break;d=B1()|0;e=k[la>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[la>>2]=0}while(0);k[la>>2]=0;k[ma>>2]=0;k[ma+4>>2]=0;k[ma+8>>2]=0;k[ma+12>>2]=0;if((k[na>>2]|0)>0){e=k[oa>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[na>>2]|0))}d=k[pa>>2]|0;if(!((d|0)==(qa|0)|(d|0)==0))ggb(k[d+-4>>2]|0);q=q+1|0;if((q|0)>=($a|0))break a}}while(0);k[ib>>2]=c;k[z>>2]=v;k[jb>>2]=-2147483648;k[A>>2]=2147483647;H1(gb,yb,ib,jb);KG(fb,gb)|0;d=k[B>>2]|0;if(d|0?(t=d+12|0,a=k[t>>2]|0,k[t>>2]=a+-1,(a|0)==1):0){e=k[B>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[va>>2]|0;if(!d){d=B1()|0;e=k[B>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[B>>2]=0}k[B>>2]=0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[D>>2]|0)>0){e=k[E>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[D>>2]|0))}d=k[F>>2]|0;if(!((d|0)==(G|0)|(d|0)==0))ggb(k[d+-4>>2]|0);h=k[Ha>>2]|0;j=k[(k[$>>2]|0)+(((k[_a>>2]|0)-(k[Za>>2]|0)>>2)*56|0)+16>>2]|0;l=k[sa>>2]|0;d=(l|0)>0;if((k[fb>>2]&4095|0)==5){if(d?(tb=k[J>>2]|0,ub=k[k[M>>2]>>2]|0,vb=k[La>>2]|0,wb=k[k[Ra>>2]>>2]|0,(h|0)>0):0){d=0;do{b=tb+(aa(ub,d)|0)|0;g=vb+(aa(wb,d)|0)|0;e=0;do{a=e<<1;o[g+(e<<2)>>2]=+p[b+(e<<3)>>3]*+p[j+(a<<3)>>3]+ +p[j+((a|1)<<3)>>3];e=e+1|0}while((e|0)!=(h|0));d=d+1|0}while((d|0)!=(l|0))}}else if(d?(pb=k[J>>2]|0,qb=k[k[M>>2]>>2]|0,rb=k[La>>2]|0,sb=k[k[Ra>>2]>>2]|0,(h|0)>0):0){d=0;do{b=pb+(aa(qb,d)|0)|0;g=rb+(aa(sb,d)|0)|0;e=0;do{a=e<<1;p[g+(e<<3)>>3]=+p[b+(e<<3)>>3]*+p[j+(a<<3)>>3]+ +p[j+((a|1)<<3)>>3];e=e+1|0}while((e|0)!=(h|0));d=d+1|0}while((d|0)!=(l|0))}d=k[H>>2]|0;if(d|0?(t=d+12|0,a=k[t>>2]|0,k[t>>2]=a+-1,(a|0)==1):0){e=k[H>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[ua>>2]|0;if(d|0)break;d=B1()|0;e=k[H>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[H>>2]=0}k[H>>2]=0;k[La>>2]=0;k[La+4>>2]=0;k[La+8>>2]=0;k[La+12>>2]=0;if((k[Ia>>2]|0)>0){e=k[Pa>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Ia>>2]|0))}d=k[Ra>>2]|0;if(!((d|0)==(Qa|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[I>>2]|0;do if(d|0){t=d+12|0;a=k[t>>2]|0;k[t>>2]=a+-1;if((a|0)!=1)break;e=k[I>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[ta>>2]|0;if(d|0)break;d=B1()|0;e=k[I>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[I>>2]=0}while(0);k[I>>2]=0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[K>>2]|0)>0){e=k[L>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[K>>2]|0))}d=k[M>>2]|0;if(!((d|0)==(N|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}while((Ya|0)>(v|0));if((Ya|0)==1){wb=ib;k[wb>>2]=0;k[wb+4>>2]=0;k[jb+8>>2]=0;k[jb+12>>2]=0;k[jb>>2]=16842752;k[jb+4>>2]=yb;D7(jb,0,0,0,ib,49332);f=+((k[ib+4>>2]|0)+(k[ib>>2]|0)|0)}else f=0.0}else f=0.0;d=k[xb>>2]|0;if((d|0)!=(Ua|0)){if(d|0)ggb(d);k[xb>>2]=Ua;k[Va>>2]=136}b=yb+36|0;d=k[b>>2]|0;if(d|0?(wb=d+12|0,xb=k[wb>>2]|0,k[wb>>2]=xb+-1,(xb|0)==1):0){e=k[b>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[yb+32>>2]|0;if(!d){d=B1()|0;e=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[b>>2]=0}k[b>>2]=0;yb=yb+16|0;k[yb>>2]=0;k[yb+4>>2]=0;k[yb+8>>2]=0;k[yb+12>>2]=0;if((k[cb>>2]|0)>0){e=k[ab>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[cb>>2]|0))}d=k[bb>>2]|0;if(!((d|0)==(db|0)|(d|0)==0))ggb(k[d+-4>>2]|0);b=zb+36|0;d=k[b>>2]|0;if(d|0?(xb=d+12|0,yb=k[xb>>2]|0,k[xb>>2]=yb+-1,(yb|0)==1):0){e=k[b>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[zb+32>>2]|0;if(!d){d=B1()|0;e=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[b>>2]=0}k[b>>2]=0;yb=zb+16|0;e=zb+4|0;k[yb>>2]=0;k[yb+4>>2]=0;k[yb+8>>2]=0;k[yb+12>>2]=0;if((k[e>>2]|0)>0){b=k[zb+40>>2]|0;d=0;do{k[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[zb+44>>2]|0;if((d|0)==(zb+48|0)|(d|0)==0){r=Ab;return +f}ggb(k[d+-4>>2]|0);r=Ab;return +f}function Iya(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;b=b>>>0>1?1:b;k[a+112>>2]=b;switch(b|0){case 1:{p[a+136>>3]=c<1.1920928955078125e-07?1.0:c;p[a+160>>3]=d<0.0?0.0:d;return}case 0:{c=!(c<=0.0)?c:.1;c=c<.001?.001:c;p[a+120>>3]=c>1.0?1.0:c;d=d<0.0?.1:d;p[a+128>>3]=d>1.0?1.0:d;return}default:return}}function Jya(a){a=a|0;return k[a+112>>2]|0}function Kya(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;e=m;if(b>>>0>2){f=e+4|0;g=ZT(32)|0;k[g>>2]=1;h=g+4|0;k[e>>2]=h;k[f>>2]=27;i[g+31>>0]=0;j=360427;l=h+27|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-211,e,360455,360247,139);k[f>>2]=0;k[e>>2]=0;l=k[g>>2]|0;k[g>>2]=l+-1;if((l|0)==1)ggb(k[g+-4>>2]|0)}k[a+80>>2]=b;switch(b|0){case 1:{p[a+56>>3]=.95;p[a+48>>3]=-.95;p[a+72>>3]=.98;p[a+64>>3]=-.98;l=+P(+c)<1.1920928955078125e-07;c=l?.6666666666666666:c;if(+P(+d)<1.1920928955078125e-07)d=1.7159;break}case 2:{p[a+56>>3]=1.0;p[a+48>>3]=.05;p[a+72>>3]=1.0;p[a+64>>3]=.02;l=+P(+c)<1.1920928955078125e-07;c=l?1.0:c;if(+P(+d)<1.1920928955078125e-07)d=1.0;break}default:{l=a+48|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;k[l+16>>2]=0;k[l+20>>2]=0;k[l+24>>2]=0;k[l+28>>2]=0;d=0.0;c=1.0}}p[a+32>>3]=c;p[a+40>>3]=d;r=m;return}function Lya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+16|0;s=t;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);n=a+4|0;m=s+4|0;q=m+4|0;k[q>>2]=0;k[q+4>>2]=0;k[s>>2]=-2113732604;k[m>>2]=n;I2(b,s);m=a+8|0;q=(k[m>>2]|0)-(k[n>>2]|0)|0;p=q>>2;o=a+16|0;Y1(o,p+2|0);h=a+84|0;k[h>>2]=0;if((q|0)<=0){r=t;return}j=p+-1|0;l=s+4|0;q=s+4|0;g=0;b=k[n>>2]|0;do{f=k[b+(g<<2)>>2]|0;b=(g|0)>0;if((f|0)<((b&(g|0)<(j|0)?2:1)|0)){a=ZT(108)|0;k[a>>2]=1;c=a+4|0;k[s>>2]=c;k[l>>2]=101;i[a+105>>0]=0;d=360311;e=c+101|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-211,s,360413,360247,228);k[l>>2]=0;k[s>>2]=0;e=k[a>>2]|0;k[a>>2]=e+-1;if((e|0)==1)ggb(k[a+-4>>2]|0)}e=k[h>>2]|0;k[h>>2]=(e|0)<(f|0)?f:e;do if(b){e=k[o>>2]|0;b=e+(g*56|0)|0;a=(k[(k[n>>2]|0)+(g+-1<<2)>>2]|0)+1|0;if(((((k[e+(g*56|0)+4>>2]|0)<3?(k[e+(g*56|0)+8>>2]|0)==(a|0):0)?(k[e+(g*56|0)+12>>2]|0)==(f|0):0)?(k[b>>2]&4095|0)==6:0)?k[e+(g*56|0)+16>>2]|0:0)break;k[s>>2]=a;k[q>>2]=f;G1(b,2,s,6)}while(0);g=g+1|0;b=k[n>>2]|0}while((g|0)<(p|0));c=k[(k[m>>2]|0)+-4>>2]|0;a=k[o>>2]|0;b=k[b>>2]<<1;if(!(((((k[a+4>>2]|0)<3?(k[a+8>>2]|0)==1:0)?(k[a+12>>2]|0)==(b|0):0)?(k[a>>2]&4095|0)==6:0)?(k[a+16>>2]|0)!=0:0)){k[s>>2]=1;k[q>>2]=b;G1(a,2,s,6);a=k[o>>2]|0}b=a+(p*56|0)|0;c=c<<1;if(!(((((k[a+(p*56|0)+4>>2]|0)<3?(k[a+(p*56|0)+8>>2]|0)==1:0)?(k[a+(p*56|0)+12>>2]|0)==(c|0):0)?(k[b>>2]&4095|0)==6:0)?(k[a+(p*56|0)+16>>2]|0)!=0:0)){k[s>>2]=1;k[q>>2]=c;G1(b,2,s,6);a=k[o>>2]|0}p=p+1|0;b=a+(p*56|0)|0;if(((((k[a+(p*56|0)+4>>2]|0)<3?(k[a+(p*56|0)+8>>2]|0)==1:0)?(k[a+(p*56|0)+12>>2]|0)==(c|0):0)?(k[b>>2]&4095|0)==6:0)?k[a+(p*56|0)+16>>2]|0:0){r=t;return}k[s>>2]=1;k[q>>2]=c;G1(b,2,s,6);r=t;return}function Mya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+128|0;g=A+72|0;f=A+56|0;q=A;k[q>>2]=1124024324;z=q+4|0;k[z>>2]=2;s=q+8|0;m=k[b+8>>2]|0;d=k[b+4>>2]|0;e=m-d|0;b=e>>2;k[s>>2]=b;n=q+12|0;k[n>>2]=1;u=q+16|0;k[u>>2]=0;o=q+20|0;k[o>>2]=0;p=q+24|0;k[p>>2]=0;t=q+32|0;k[t>>2]=0;v=q+36|0;k[v>>2]=0;w=q+40|0;k[w>>2]=s;y=q+48|0;x=q+44|0;k[x>>2]=y;k[q+52>>2]=0;k[y>>2]=0;c=d;if((c|0)!=(m|0)){m=g+4|0;k[m>>2]=2;l=g+8|0;k[l>>2]=b;k[g+12>>2]=1;i=g+16|0;k[i>>2]=c;k[g+20>>2]=c;b=g+24|0;h=g+40|0;j=b+8|0;k[j>>2]=0;k[j+4>>2]=0;k[h>>2]=l;l=g+48|0;j=g+44|0;k[j>>2]=l;k[g>>2]=1124024324;k[l>>2]=4;k[g+52>>2]=4;d=d+e|0;k[g+28>>2]=d;k[b>>2]=d+-4+4;d=f+4|0;b=d+4|0;k[b>>2]=0;k[b+4>>2]=0;k[f>>2]=33619968;k[d>>2]=q;mY(g,f);d=g+36|0;b=k[d>>2]|0;if(b|0?(e=b+12|0,f=k[e>>2]|0,k[e>>2]=f+-1,(f|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[g+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;if((k[m>>2]|0)>0){c=k[h>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[m>>2]|0))}b=k[j>>2]|0;if(!((b|0)==(l|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}k[a>>2]=k[q>>2];h=a+4|0;b=k[z>>2]|0;k[h>>2]=b;g=a+8|0;k[g>>2]=k[s>>2];k[a+12>>2]=k[n>>2];k[a+16>>2]=k[u>>2];k[a+20>>2]=k[o>>2];k[a+24>>2]=k[p>>2];k[a+28>>2]=k[q+28>>2];k[a+32>>2]=k[t>>2];c=k[v>>2]|0;k[a+36>>2]=c;d=a+40|0;k[d>>2]=g;s=a+48|0;g=a+44|0;k[g>>2]=s;k[a+52>>2]=0;k[s>>2]=0;if(c){b=c+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[z>>2]|0}if((b|0)>=3){k[h>>2]=0;x1(a,b,0,0,0);if((k[h>>2]|0)>0){f=k[w>>2]|0;d=k[d>>2]|0;e=k[x>>2]|0;c=k[g>>2]|0;b=0;do{k[d+(b<<2)>>2]=k[f+(b<<2)>>2];k[c+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[h>>2]|0))}}else{s=k[x>>2]|0;a=k[g>>2]|0;k[a>>2]=k[s>>2];k[a+4>>2]=k[s+4>>2]}b=k[v>>2]|0;if(b|0?(s=b+12|0,a=k[s>>2]|0,k[s>>2]=a+-1,(a|0)==1):0){c=k[v>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[t>>2]|0;if(!b){b=B1()|0;c=k[v>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[v>>2]=0}k[v>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[z>>2]|0)>0){c=k[w>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[z>>2]|0))}b=k[x>>2]|0;if((b|0)==(y|0)|(b|0)==0){r=A;return}ggb(k[b+-4>>2]|0);r=A;return}function Nya(a,b){a=a|0;b=b|0;b=b+96|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];return}function Oya(a,b){a=a|0;b=b|0;a=a+96|0;k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2];k[a+12>>2]=k[b+12>>2];return}function Pya(a){a=a|0;return +(+p[a+120>>3])}function Qya(a,b){a=a|0;b=+b;p[a+120>>3]=b;return}function Rya(a){a=a|0;return +(+p[a+128>>3])}function Sya(a,b){a=a|0;b=+b;p[a+128>>3]=b;return}function Tya(a){a=a|0;return +(+p[a+136>>3])}function Uya(a,b){a=a|0;b=+b;p[a+136>>3]=b;return}function Vya(a){a=a|0;return +(+p[a+144>>3])}function Wya(a,b){a=a|0;b=+b;p[a+144>>3]=b;return}function Xya(a){a=a|0;return +(+p[a+152>>3])}function Yya(a,b){a=a|0;b=+b;p[a+152>>3]=b;return}function Zya(a){a=a|0;return +(+p[a+160>>3])}function _ya(a,b){a=a|0;b=+b;p[a+160>>3]=b;return}function $ya(a){a=a|0;return +(+p[a+168>>3])}function aza(a,b){a=a|0;b=+b;p[a+168>>3]=b;return}function bza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;if(!((c|0)>-1?(d=k[b+16>>2]|0,(((k[b+20>>2]|0)-d|0)/56|0|0)>(c|0)):0)){d=j+4|0;e=ZT(52)|0;k[e>>2]=1;f=e+4|0;k[j>>2]=f;k[d>>2]=47;i[e+51>>0]=0;g=360188;h=f+47|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,j,360236,360247,1278);k[d>>2]=0;k[j>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);d=k[b+16>>2]|0}k[a>>2]=k[d+(c*56|0)>>2];j=a+4|0;e=d+(c*56|0)+4|0;k[j>>2]=k[e>>2];h=a+8|0;k[h>>2]=k[d+(c*56|0)+8>>2];k[a+12>>2]=k[d+(c*56|0)+12>>2];k[a+16>>2]=k[d+(c*56|0)+16>>2];k[a+20>>2]=k[d+(c*56|0)+20>>2];k[a+24>>2]=k[d+(c*56|0)+24>>2];k[a+28>>2]=k[d+(c*56|0)+28>>2];k[a+32>>2]=k[d+(c*56|0)+32>>2];f=k[d+(c*56|0)+36>>2]|0;k[a+36>>2]=f;g=a+40|0;k[g>>2]=h;h=a+48|0;b=a+44|0;k[b>>2]=h;k[a+52>>2]=0;k[h>>2]=0;if(f|0){h=f+12|0;k[h>>2]=(k[h>>2]|0)+1}if((k[e>>2]|0)<3){a=k[d+(c*56|0)+44>>2]|0;c=k[b>>2]|0;k[c>>2]=k[a>>2];k[c+4>>2]=k[a+4>>2];r=l;return}k[j>>2]=0;x1(a,k[e>>2]|0,0,0,0);if((k[j>>2]|0)<=0){r=l;return}h=k[d+(c*56|0)+40>>2]|0;g=k[g>>2]|0;f=k[d+(c*56|0)+44>>2]|0;e=k[b>>2]|0;d=0;do{k[g+(d<<2)>>2]=k[h+(d<<2)>>2];k[e+(d<<2)>>2]=k[f+(d<<2)>>2];d=d+1|0}while((d|0)<(k[j>>2]|0));r=l;return}function cza(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90772;d=a+104|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+100>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+84|0;c=a+72|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+108>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+112>>2]|0;if(!((b|0)==(a+116|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+48|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+28|0;c=a+16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function dza(a){a=a|0;cza(a);ggb(a);return}function eza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0.0,Yc=0,Zc=0,_c=0,$c=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0.0,jd=0,kd=0,ld=0,md=0.0,nd=0;ld=r;r=r+384|0;Zc=ld;$c=ld+320|0;cd=ld+312|0;dd=ld+256|0;ed=ld+200|0;fd=ld+144|0;gd=ld+88|0;hd=ld+32|0;Vc=ld+16|0;Wc=k[a+20>>2]|0;Xc=1.0/+(Wc|0);jd=a+4|0;bd=k[jd>>2]|0;w=k[bd+4>>2]|0;Yc=k[w>>2]|0;bd=k[bd+8>>2]|0;_c=k[bd+-4>>2]|0;v=k[a+12>>2]&4095;x=k[a+68>>2]&4095;w=bd-w|0;bd=w>>2;f=(bd|0)==0;if(!f){if(bd>>>0>357913941)ad(426534,426557,304,426811);g=bd*12|0;d=(g|0)==0?1:g;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}e=c+(bd*12|0)|0;zpb(c|0,0,g|0)|0;if(f){Uc=0;f=0}else{if(bd>>>0>357913941)ad(426534,426557,304,426811);g=bd*12|0;f=(g|0)==0?1:g;while(1){d=fgb(f)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}zpb(d|0,0,g|0)|0;Uc=d;f=d+(bd*12|0)|0}}else{Uc=0;c=0;f=0;e=0}h=k[jd>>2]|0;m=h+84|0;j=k[m>>2]|0;Tc=a+128|0;g=k[Tc>>2]|0;d=aa(g,j)|0;if(!d){Sc=0;l=0;d=j}else{if(d<<1>>>0>536870911)ad(426534,426557,304,426811);l=d<<4;j=(l|0)==0?1:l;while(1){d=fgb(j)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}zpb(d|0,0,l|0)|0;Sc=d;l=d;d=k[m>>2]|0}k[cd>>2]=l;Rc=Sc+((aa(g,d)|0)<<3)|0;k[cd+4>>2]=Rc;a:do if((w|0)>0){d=0;while(1){s=c+(d*12|0)|0;h=k[(k[h+4>>2]|0)+(d<<2)>>2]|0;j=aa(g,h)|0;l=c+(d*12|0)+4|0;q=k[l>>2]|0;n=k[s>>2]|0;m=q-n>>3;if(j>>>0<=m>>>0){if(j>>>0<m>>>0?(u=n+(j<<3)|0,(q|0)!=(u|0)):0)k[l>>2]=q+(~((q+-8-u|0)>>>3)<<3)}else{Bla(s,j-m|0);h=k[(k[(k[jd>>2]|0)+4>>2]|0)+(d<<2)>>2]|0;g=k[Tc>>2]|0}n=Uc+(d*12|0)|0;g=aa(g,h)|0;h=Uc+(d*12|0)+4|0;m=k[h>>2]|0;l=k[n>>2]|0;j=m-l>>3;if(g>>>0<=j>>>0){if(g>>>0<j>>>0?(t=l+(g<<3)|0,(m|0)!=(t|0)):0)k[h>>2]=m+(~((m+-8-t|0)>>>3)<<3)}else Bla(n,g-j|0);d=d+1|0;if((d|0)>=(bd|0))break a;h=k[jd>>2]|0;g=k[Tc>>2]|0}}while(0);d=k[b>>2]|0;Oc=b+4|0;b:do if((d|0)<(k[Oc>>2]|0)){Pc=a+28|0;Qc=a+56|0;Rc=(Yc|0)>0;Bc=(v|0)==5;Cc=dd+4|0;Dc=dd+8|0;Ec=dd+12|0;Fc=dd+16|0;Gc=dd+20|0;Hc=dd+24|0;Ic=dd+28|0;Jc=dd+40|0;Kc=dd+48|0;Lc=dd+44|0;Mc=dd+52|0;Nc=Zc+4|0;ub=(w|0)>4;vb=ed+4|0;wb=ed+8|0;xb=ed+12|0;yb=ed+16|0;zb=ed+20|0;Ab=ed+24|0;Bb=ed+28|0;Cb=ed+40|0;Db=ed+48|0;Eb=ed+44|0;Fb=ed+52|0;Gb=Zc+4|0;Hb=Zc+4|0;Ib=$c+4|0;Jb=Zc+8|0;Kb=Zc+12|0;Lb=Zc+4|0;Mb=$c+8|0;Nb=$c+12|0;Ob=$c+4|0;Pb=gd+4|0;Qb=Pb+4|0;Rb=$c+4|0;Sb=$c+8|0;Tb=$c+12|0;Ub=$c+16|0;Vb=$c+20|0;Wb=$c+24|0;Xb=$c+28|0;Yb=$c+40|0;Zb=$c+48|0;_b=$c+44|0;$b=$c+52|0;ac=Zc+4|0;bc=$c+36|0;cc=fd+36|0;dc=fd+16|0;ec=fd+4|0;fc=fd+40|0;gc=fd+44|0;hc=fd+48|0;ic=ed+36|0;jc=cd+((bd&1)<<2)|0;kc=ed+4|0;lc=ed+8|0;mc=ed+12|0;nc=ed+16|0;oc=ed+20|0;pc=ed+24|0;qc=ed+28|0;rc=ed+40|0;sc=ed+48|0;tc=ed+44|0;uc=ed+52|0;vc=Zc+4|0;wc=bd+1|0;xc=a+84|0;yc=a+112|0;zc=a+124|0;Ac=(_c|0)>0;E=(x|0)==5;F=ed+36|0;G=dd+36|0;H=fd+4|0;I=fd+8|0;J=fd+12|0;K=fd+16|0;L=fd+20|0;M=fd+24|0;N=fd+28|0;O=fd+40|0;P=fd+48|0;Q=fd+44|0;R=fd+52|0;S=Zc+4|0;T=$c+8|0;U=$c+12|0;V=$c+4|0;W=gd+8|0;X=gd+12|0;Y=gd+4|0;Z=hd+4|0;_=Z+4|0;$=a+8|0;ba=Zc+4|0;ca=$c+4|0;da=$c+4|0;ea=$c+8|0;fa=$c+12|0;ga=$c+16|0;ha=$c+20|0;ia=$c+24|0;ja=$c+28|0;ka=$c+40|0;la=$c+48|0;ma=$c+44|0;na=$c+52|0;oa=Zc+4|0;pa=$c+36|0;qa=Zc+8|0;ra=Zc+12|0;sa=Zc+4|0;ta=$c+8|0;ua=$c+12|0;va=$c+4|0;wa=hd+8|0;xa=hd+12|0;ya=hd+4|0;za=Vc+4|0;Aa=za+4|0;Ba=gd+36|0;Ca=gd+16|0;Da=gd+4|0;Ea=gd+40|0;Fa=gd+44|0;Ga=gd+48|0;Ha=gd+4|0;Ia=gd+8|0;Ja=gd+12|0;Ka=gd+16|0;La=gd+20|0;Ma=gd+24|0;Na=gd+28|0;Oa=gd+40|0;Pa=gd+48|0;Qa=gd+44|0;Ra=gd+52|0;Sa=Zc+4|0;Ta=Zc+4|0;Ua=$c+4|0;Va=Zc+8|0;Wa=Zc+12|0;Xa=Zc+4|0;Ya=$c+8|0;Za=$c+12|0;_a=$c+4|0;$a=Vc+4|0;ab=$a+4|0;bb=hd+36|0;cb=hd+16|0;db=hd+4|0;eb=hd+40|0;fb=hd+44|0;gb=hd+48|0;hb=gd+36|0;ib=fd+36|0;jb=c+((bd+-1|0)*12|0)|0;kb=dd+32|0;lb=ed+32|0;mb=hd+32|0;nb=fd+32|0;ob=gd+32|0;pb=gd+32|0;qb=$c+32|0;rb=ed+32|0;sb=fd+32|0;tb=$c+32|0;y=0.0;D=d;c:while(1){B=k[Tc>>2]|0;x=aa(B,D)|0;w=D;D=D+1|0;B=aa(B,D)|0;B=((Wc|0)<(B|0)?Wc:B)-x|0;j=k[(k[(k[jd>>2]|0)+16>>2]|0)+16>>2]|0;C=(B|0)>0;if(C){l=k[Pc>>2]|0;m=k[k[Qc>>2]>>2]|0;d=k[c>>2]|0;if(Rc){h=0;do{n=l+(aa(m,h+x|0)|0)|0;q=d+((aa(h,Yc)|0)<<3)|0;if(Bc){g=0;do{v=g<<1;p[q+(g<<3)>>3]=+o[n+(g<<2)>>2]*+p[j+(v<<3)>>3]+ +p[j+((v|1)<<3)>>3];g=g+1|0}while((g|0)!=(Yc|0))}else{g=0;do{v=g<<1;p[q+(g<<3)>>3]=+p[n+(g<<3)>>3]*+p[j+(v<<3)>>3]+ +p[j+((v|1)<<3)>>3];g=g+1|0}while((g|0)!=(Yc|0))}h=h+1|0}while((h|0)<(B|0))}}else d=k[c>>2]|0;k[dd>>2]=1124007942;k[Cc>>2]=2;k[Dc>>2]=B;k[Ec>>2]=Yc;k[Fc>>2]=d;k[Gc>>2]=d;k[Hc>>2]=0;k[Hc+4>>2]=0;k[Hc+8>>2]=0;k[Hc+12>>2]=0;k[Jc>>2]=Dc;k[Lc>>2]=Kc;k[Mc>>2]=0;k[Kc>>2]=0;if((aa(B,Yc)|0)!=0&(d|0)==0){k[Zc>>2]=0;k[Nc>>2]=0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[Zc>>2]=g;k[Nc>>2]=28;i[d+32>>0]=0;h=390609;j=g+28|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,Zc,390638,390642,410);k[Nc>>2]=0;k[Zc>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0);g=k[Ec>>2]|0;h=k[dd>>2]|0;j=k[Lc>>2]|0;d=k[Gc>>2]|0}else{g=Yc;h=1124007942;j=Kc}v=g<<3;k[dd>>2]=h|16384;k[j>>2]=v;k[j+4>>2]=8;b=d+(aa(k[Dc>>2]|0,v)|0)|0;k[Ic>>2]=b;k[Hc>>2]=b+(0-v)+v;if(ub){m=1;do{g=k[jd>>2]|0;d=k[(k[g+4>>2]|0)+(m<<2)>>2]|0;h=k[c+(m*12|0)>>2]|0;k[ed>>2]=1124007942;k[vb>>2]=2;k[wb>>2]=B;k[xb>>2]=d;k[yb>>2]=h;k[zb>>2]=h;k[Ab>>2]=0;k[Ab+4>>2]=0;k[Ab+8>>2]=0;k[Ab+12>>2]=0;k[Cb>>2]=wb;k[Eb>>2]=Db;k[Fb>>2]=0;k[Db>>2]=0;if((aa(d,B)|0)!=0&(h|0)==0){k[Zc>>2]=0;k[Gb>>2]=0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[Zc>>2]=g;k[Gb>>2]=28;i[d+32>>0]=0;h=390609;j=g+28|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,Zc,390638,390642,410);k[Gb>>2]=0;k[Zc>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0);d=k[xb>>2]|0;j=k[ed>>2]|0;l=k[Eb>>2]|0;h=k[zb>>2]|0;g=k[jd>>2]|0}else{j=1124007942;l=Db}v=d<<3;k[ed>>2]=j|16384;k[l>>2]=v;k[l+4>>2]=8;d=h+(aa(k[wb>>2]|0,v)|0)|0;k[Bb>>2]=d;k[Ab>>2]=d+(0-v)+v;v=(k[g+16>>2]|0)+(m*56|0)|0;d=k[Ec>>2]|0;k[Zc>>2]=0;k[Hb>>2]=d;k[$c>>2]=-2147483648;k[Ib>>2]=2147483647;H1(fd,v,Zc,$c);k[Jb>>2]=0;k[Kb>>2]=0;k[Zc>>2]=16842752;k[Lb>>2]=dd;k[Mb>>2]=0;k[Nb>>2]=0;k[$c>>2]=16842752;k[Ob>>2]=fd;v=Qb;k[v>>2]=0;k[v+4>>2]=0;k[gd>>2]=33619968;k[Pb>>2]=ed;s_(Zc,$c,1.0,49332,0.0,gd,0);v=k[Cb>>2]|0;d=k[v+4>>2]|0;v=k[v>>2]|0;g=k[Uc+(m*12|0)>>2]|0;k[$c>>2]=1124007942;k[Rb>>2]=2;k[Sb>>2]=v;k[Tb>>2]=d;k[Ub>>2]=g;k[Vb>>2]=g;k[Wb>>2]=0;k[Wb+4>>2]=0;k[Wb+8>>2]=0;k[Wb+12>>2]=0;k[Yb>>2]=Sb;k[_b>>2]=Zb;k[$b>>2]=0;k[Zb>>2]=0;if((aa(v,d)|0)!=0&(g|0)==0){k[Zc>>2]=0;k[ac>>2]=0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[Zc>>2]=g;k[ac>>2]=28;i[d+32>>0]=0;h=390609;j=g+28|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,Zc,390638,390642,443);k[ac>>2]=0;k[Zc>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0);d=k[Tb>>2]|0;h=k[$c>>2]|0;j=k[_b>>2]|0;g=k[Vb>>2]|0}else{h=1124007942;j=Zb}v=d<<3;k[$c>>2]=h|16384;k[j>>2]=v;k[j+4>>2]=8;d=g+(aa(k[Sb>>2]|0,v)|0)|0;k[Xb>>2]=d;k[Wb>>2]=d+(0-v)+v;v=k[jd>>2]|0;d=k[v+16>>2]|0;fza(v,ed,$c,k[d+(m*56|0)+8>>2]|0,k[d+(m*56|0)+16>>2]|0,k[k[d+(m*56|0)+44>>2]>>2]|0);KG(dd,ed)|0;d=k[bc>>2]|0;if(d|0?(b=d+12|0,v=k[b>>2]|0,k[b>>2]=v+-1,(v|0)==1):0){g=k[bc>>2]|0;if(g|0){d=k[g+4>>2]|0;do if(!d){d=k[tb>>2]|0;if(d|0)break;d=B1()|0;g=k[bc>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[bc>>2]=0}k[bc>>2]=0;k[Ub>>2]=0;k[Ub+4>>2]=0;k[Ub+8>>2]=0;k[Ub+12>>2]=0;if((k[Rb>>2]|0)>0){g=k[Yb>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Rb>>2]|0))}d=k[_b>>2]|0;if(!((d|0)==(Zb|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[cc>>2]|0;if(d|0?(b=d+12|0,v=k[b>>2]|0,k[b>>2]=v+-1,(v|0)==1):0){g=k[cc>>2]|0;if(g|0){d=k[g+4>>2]|0;do if(!d){d=k[sb>>2]|0;if(d|0)break;d=B1()|0;g=k[cc>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[cc>>2]=0}k[cc>>2]=0;k[dc>>2]=0;k[dc+4>>2]=0;k[dc+8>>2]=0;k[dc+12>>2]=0;if((k[ec>>2]|0)>0){g=k[fc>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[ec>>2]|0))}d=k[gc>>2]|0;if(!((d|0)==(hc|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[ic>>2]|0;do if(d|0){b=d+12|0;v=k[b>>2]|0;k[b>>2]=v+-1;if((v|0)!=1)break;g=k[ic>>2]|0;if(g|0){d=k[g+4>>2]|0;do if(!d){d=k[rb>>2]|0;if(d|0)break;d=B1()|0;g=k[ic>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[ic>>2]=0}while(0);k[ic>>2]=0;k[yb>>2]=0;k[yb+4>>2]=0;k[yb+8>>2]=0;k[yb+12>>2]=0;if((k[vb>>2]|0)>0){g=k[Cb>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[vb>>2]|0))}d=k[Eb>>2]|0;if(!((d|0)==(Db|0)|(d|0)==0))ggb(k[d+-4>>2]|0);m=m+1|0}while((m|0)<(bd|0))}d=k[jc>>2]|0;k[ed>>2]=1124007942;k[kc>>2]=2;k[lc>>2]=B;k[mc>>2]=_c;k[nc>>2]=d;k[oc>>2]=d;k[pc>>2]=0;k[pc+4>>2]=0;k[pc+8>>2]=0;k[pc+12>>2]=0;k[rc>>2]=lc;k[tc>>2]=sc;k[uc>>2]=0;k[sc>>2]=0;if((aa(B,_c)|0)!=0&(d|0)==0){k[Zc>>2]=0;k[vc>>2]=0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[Zc>>2]=g;k[vc>>2]=28;i[d+32>>0]=0;h=390609;j=g+28|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,Zc,390638,390642,410);k[vc>>2]=0;k[Zc>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0);g=k[mc>>2]|0;h=k[ed>>2]|0;j=k[tc>>2]|0;d=k[oc>>2]|0}else{g=_c;h=1124007942;j=sc}v=g<<3;k[ed>>2]=h|16384;k[j>>2]=v;k[j+4>>2]=8;g=d+(aa(k[lc>>2]|0,v)|0)|0;k[qc>>2]=g;k[pc>>2]=g+(0-v)+v;g=k[jd>>2]|0;q=k[(k[g+16>>2]|0)+(wc*56|0)+16>>2]|0;if(C){s=k[xc>>2]|0;t=k[k[yc>>2]>>2]|0;u=k[jb>>2]|0;b=k[nc>>2]|0;n=k[zc>>2]|0;if(!n){m=0;do{h=s+(aa(t,m+x|0)|0)|0;j=u+((aa(m,_c)|0)<<3)|0;l=b+(aa(v,m)|0)|0;if(Ac)if(E){z=0.0;d=0;do{w=d<<1;A=+o[h+(d<<2)>>2]*+p[q+(w<<3)>>3]+ +p[q+((w|1)<<3)>>3]-+p[j+(d<<3)>>3];p[l+(d<<3)>>3]=Xc*A;z=z+A*A;d=d+1|0}while((d|0)!=(_c|0))}else{z=0.0;d=0;do{w=d<<1;A=+p[h+(d<<3)>>3]*+p[q+(w<<3)>>3]+ +p[q+((w|1)<<3)>>3]-+p[j+(d<<3)>>3];p[l+(d<<3)>>3]=Xc*A;z=z+A*A;d=d+1|0}while((d|0)!=(_c|0))}else z=0.0;y=y+Xc*z;m=m+1|0}while((m|0)<(B|0))}else{m=0;do{h=s+(aa(t,m+x|0)|0)|0;j=u+((aa(m,_c)|0)<<3)|0;l=b+(aa(v,m)|0)|0;A=+p[n+(m+w<<3)>>3];if(Ac)if(E){z=0.0;d=0;do{nd=d<<1;md=+o[h+(d<<2)>>2]*+p[q+(nd<<3)>>3]+ +p[q+((nd|1)<<3)>>3]-+p[j+(d<<3)>>3];p[l+(d<<3)>>3]=A*md;z=z+md*md;d=d+1|0}while((d|0)!=(_c|0))}else{z=0.0;d=0;do{nd=d<<1;md=+p[h+(d<<3)>>3]*+p[q+(nd<<3)>>3]+ +p[q+((nd|1)<<3)>>3]-+p[j+(d<<3)>>3];p[l+(d<<3)>>3]=A*md;z=z+md*md;d=d+1|0}while((d|0)!=(_c|0))}else z=0.0;y=y+A*z;m=m+1|0}while((m|0)<(B|0))}}d:do if(ub){d=bd;while(1){u=d+-1|0;l=d+-2|0;n=k[g+4>>2]|0;t=k[n+(l<<2)>>2]|0;n=k[n+(u<<2)>>2]|0;d=k[Uc+(u*12|0)>>2]|0;k[fd>>2]=1124007942;k[H>>2]=2;k[I>>2]=B;k[J>>2]=n;k[K>>2]=d;k[L>>2]=d;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;k[O>>2]=I;k[Q>>2]=P;k[R>>2]=0;k[P>>2]=0;if((aa(n,B)|0)!=0&(d|0)==0){k[Zc>>2]=0;k[S>>2]=0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[Zc>>2]=g;k[S>>2]=28;i[d+32>>0]=0;h=390609;j=g+28|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,Zc,390638,390642,410);k[S>>2]=0;k[Zc>>2]=0;nd=k[d>>2]|0;k[d>>2]=nd+-1;if((nd|0)==1)ggb(k[d+-4>>2]|0);g=k[J>>2]|0;h=k[fd>>2]|0;j=k[Q>>2]|0;d=k[L>>2]|0}else{g=n;h=1124007942;j=P}s=g<<3;k[fd>>2]=h|16384;k[j>>2]=s;k[j+4>>2]=8;nd=d+(aa(k[I>>2]|0,s)|0)|0;k[N>>2]=nd;k[M>>2]=nd+(0-s)+s;k[T>>2]=0;k[U>>2]=0;k[$c>>2]=16842752;k[V>>2]=ed;k[W>>2]=0;k[X>>2]=0;k[gd>>2]=16842752;k[Y>>2]=fd;s=_;k[s>>2]=0;k[s+4>>2]=0;k[hd>>2]=33619968;k[Z>>2]=ed;p[Zc>>3]=1.0;sU($c,gd,hd,49332,-1,40032,1,Zc);s=(k[jd>>2]|0)+184|0;mpb(k[s>>2]|0)|0;nd=k[$>>2]|0;d=k[nd>>2]|0;if((((k[nd+4>>2]|0)-d|0)/56|0)>>>0<=u>>>0){c=122;break c}k[Zc>>2]=0;k[ba>>2]=t;k[$c>>2]=-2147483648;k[ca>>2]=2147483647;H1(gd,d+(u*56|0)|0,Zc,$c);d=k[c+(l*12|0)>>2]|0;k[$c>>2]=1124007942;k[da>>2]=2;k[ea>>2]=B;k[fa>>2]=t;k[ga>>2]=d;k[ha>>2]=d;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;k[ka>>2]=ea;k[ma>>2]=la;k[na>>2]=0;k[la>>2]=0;q=(aa(t,B)|0)!=0;if(q&(d|0)==0){k[Zc>>2]=0;k[oa>>2]=0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[Zc>>2]=g;k[oa>>2]=28;i[d+32>>0]=0;h=390609;j=g+28|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,Zc,390638,390642,410);k[oa>>2]=0;k[Zc>>2]=0;nd=k[d>>2]|0;k[d>>2]=nd+-1;if((nd|0)==1)ggb(k[d+-4>>2]|0);g=k[fa>>2]|0;h=k[$c>>2]|0;j=k[ma>>2]|0;d=k[ha>>2]|0}else{g=t;h=1124007942;j=la}nd=g<<3;k[$c>>2]=h|16384;k[j>>2]=nd;k[j+4>>2]=8;d=d+(aa(k[ea>>2]|0,nd)|0)|0;k[ja>>2]=d;k[ia>>2]=d+(0-nd)+nd;KG(dd,$c)|0;d=k[pa>>2]|0;if(d|0?(x=d+12|0,nd=k[x>>2]|0,k[x>>2]=nd+-1,(nd|0)==1):0){g=k[pa>>2]|0;if(g|0){d=k[g+4>>2]|0;do if(!d){d=k[qb>>2]|0;if(d|0)break;d=B1()|0;g=k[pa>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[pa>>2]=0}k[pa>>2]=0;k[ga>>2]=0;k[ga+4>>2]=0;k[ga+8>>2]=0;k[ga+12>>2]=0;if((k[da>>2]|0)>0){g=k[ka>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[da>>2]|0))}d=k[ma>>2]|0;if(!((d|0)==(la|0)|(d|0)==0))ggb(k[d+-4>>2]|0);k[qa>>2]=0;k[ra>>2]=0;k[Zc>>2]=16842752;k[sa>>2]=dd;k[ta>>2]=0;k[ua>>2]=0;k[$c>>2]=16842752;k[va>>2]=ed;k[wa>>2]=0;k[xa>>2]=0;k[hd>>2]=16842752;k[ya>>2]=gd;nd=Aa;k[nd>>2]=0;k[nd+4>>2]=0;k[Vc>>2]=33619968;k[za>>2]=gd;s_(Zc,$c,1.0,hd,1.0,Vc,1);nd=k[$>>2]|0;d=k[nd>>2]|0;if((((k[nd+4>>2]|0)-d|0)/56|0)>>>0<=u>>>0){c=141;break c}h=d;h=(k[h+(u*56|0)+16>>2]|0)+(aa(k[k[h+(u*56|0)+44>>2]>>2]|0,t)|0)|0;do if(C){j=k[nc>>2]|0;l=k[k[tc>>2]>>2]|0;if((n|0)>0)d=0;else break;do{m=j+(aa(l,d)|0)|0;g=0;do{nd=h+(g<<3)|0;p[nd>>3]=+p[m+(g<<3)>>3]+ +p[nd>>3];g=g+1|0}while((g|0)!=(n|0));d=d+1|0}while((d|0)<(B|0))}while(0);d=k[Ba>>2]|0;do if(d|0){x=d+12|0;nd=k[x>>2]|0;k[x>>2]=nd+-1;if((nd|0)!=1)break;g=k[Ba>>2]|0;if(g|0){d=k[g+4>>2]|0;do if(!d){d=k[pb>>2]|0;if(d|0)break;d=B1()|0;g=k[Ba>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[Ba>>2]=0}while(0);k[Ba>>2]=0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[Da>>2]|0)>0){g=k[Ea>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Da>>2]|0))}d=k[Fa>>2]|0;if(!((d|0)==(Ga|0)|(d|0)==0))ggb(k[d+-4>>2]|0);lpb(k[s>>2]|0)|0;d=k[cd+((u&1)<<2)>>2]|0;k[gd>>2]=1124007942;k[Ha>>2]=2;k[Ia>>2]=B;k[Ja>>2]=t;k[Ka>>2]=d;k[La>>2]=d;k[Ma>>2]=0;k[Ma+4>>2]=0;k[Ma+8>>2]=0;k[Ma+12>>2]=0;k[Oa>>2]=Ia;k[Qa>>2]=Pa;k[Ra>>2]=0;k[Pa>>2]=0;if(q&(d|0)==0){k[Zc>>2]=0;k[Sa>>2]=0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[Zc>>2]=g;k[Sa>>2]=28;i[d+32>>0]=0;h=390609;j=g+28|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,Zc,390638,390642,410);k[Sa>>2]=0;k[Zc>>2]=0;nd=k[d>>2]|0;k[d>>2]=nd+-1;if((nd|0)==1)ggb(k[d+-4>>2]|0);g=k[Ja>>2]|0;h=k[gd>>2]|0;j=k[Qa>>2]|0;d=k[La>>2]|0}else{g=t;h=1124007942;j=Pa}nd=g<<3;k[gd>>2]=h|16384;k[j>>2]=nd;k[j+4>>2]=8;h=d+(aa(k[Ia>>2]|0,nd)|0)|0;k[Na>>2]=h;k[Ma>>2]=h+(0-nd)+nd;h=(u|0)>1;if(h){d=(k[(k[jd>>2]|0)+16>>2]|0)+(u*56|0)|0;k[Zc>>2]=0;k[Ta>>2]=t;k[$c>>2]=-2147483648;k[Ua>>2]=2147483647;H1(hd,d,Zc,$c);k[Va>>2]=0;k[Wa>>2]=0;k[Zc>>2]=16842752;k[Xa>>2]=ed;k[Ya>>2]=0;k[Za>>2]=0;k[$c>>2]=16842752;k[_a>>2]=hd;d=ab;k[d>>2]=0;k[d+4>>2]=0;k[Vc>>2]=33619968;k[$a>>2]=gd;s_(Zc,$c,1.0,49332,0.0,Vc,2);d=k[bb>>2]|0;do if(d|0){x=d+12|0;nd=k[x>>2]|0;k[x>>2]=nd+-1;if((nd|0)!=1)break;g=k[bb>>2]|0;if(g|0){d=k[g+4>>2]|0;do if(!d){d=k[mb>>2]|0;if(d|0)break;d=B1()|0;g=k[bb>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[bb>>2]=0}while(0);k[bb>>2]=0;k[cb>>2]=0;k[cb+4>>2]=0;k[cb+8>>2]=0;k[cb+12>>2]=0;if((k[db>>2]|0)>0){g=k[eb>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[db>>2]|0))}d=k[fb>>2]|0;if(!((d|0)==(gb|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}KG(ed,gd)|0;d=k[hb>>2]|0;do if(d|0){x=d+12|0;nd=k[x>>2]|0;k[x>>2]=nd+-1;if((nd|0)!=1)break;g=k[hb>>2]|0;if(g|0){d=k[g+4>>2]|0;do if(!d){d=k[ob>>2]|0;if(d|0)break;d=B1()|0;g=k[hb>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[hb>>2]=0}while(0);k[hb>>2]=0;k[Ka>>2]=0;k[Ka+4>>2]=0;k[Ka+8>>2]=0;k[Ka+12>>2]=0;if((k[Ha>>2]|0)>0){g=k[Oa>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Ha>>2]|0))}d=k[Qa>>2]|0;if(!((d|0)==(Pa|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[ib>>2]|0;do if(d|0){x=d+12|0;nd=k[x>>2]|0;k[x>>2]=nd+-1;if((nd|0)!=1)break;g=k[ib>>2]|0;if(g|0){d=k[g+4>>2]|0;do if(!d){d=k[nb>>2]|0;if(d|0)break;d=B1()|0;g=k[ib>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[ib>>2]=0}while(0);k[ib>>2]=0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[H>>2]|0)>0){g=k[O>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[H>>2]|0))}d=k[Q>>2]|0;if(!((d|0)==(P|0)|(d|0)==0))ggb(k[d+-4>>2]|0);if(!h)break d;d=u;g=k[jd>>2]|0}}while(0);d=k[F>>2]|0;if(d|0?(C=d+12|0,nd=k[C>>2]|0,k[C>>2]=nd+-1,(nd|0)==1):0){g=k[F>>2]|0;if(g|0){d=k[g+4>>2]|0;if(!d){d=k[lb>>2]|0;if(!d){d=B1()|0;g=k[F>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[F>>2]=0}k[F>>2]=0;k[nc>>2]=0;k[nc+4>>2]=0;k[nc+8>>2]=0;k[nc+12>>2]=0;if((k[kc>>2]|0)>0){g=k[rc>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[kc>>2]|0))}d=k[tc>>2]|0;if(!((d|0)==(sc|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[G>>2]|0;if(d|0?(C=d+12|0,nd=k[C>>2]|0,k[C>>2]=nd+-1,(nd|0)==1):0){g=k[G>>2]|0;if(g|0){d=k[g+4>>2]|0;do if(!d){d=k[kb>>2]|0;if(d|0)break;d=B1()|0;g=k[G>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,g)}k[G>>2]=0}k[G>>2]=0;k[Fc>>2]=0;k[Fc+4>>2]=0;k[Fc+8>>2]=0;k[Fc+12>>2]=0;if((k[Cc>>2]|0)>0){g=k[Jc>>2]|0;d=0;do{k[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[Cc>>2]|0))}d=k[Lc>>2]|0;if(!((d|0)==(Kc|0)|(d|0)==0))ggb(k[d+-4>>2]|0);if((D|0)>=(k[Oc>>2]|0)){id=y;kd=c;break b}}if((c|0)==122)ad(426635,426557,315,426658);else if((c|0)==141)ad(426635,426557,315,426658)}else{id=0.0;kd=c}while(0);nd=(k[jd>>2]|0)+184|0;mpb(k[nd>>2]|0)|0;jd=k[a+132>>2]|0;p[jd>>3]=id+ +p[jd>>3];lpb(k[nd>>2]|0)|0;if(Sc|0)ggb(Sc);if(Uc|0){if((f|0)!=(Uc|0))do{c=f;f=f+-12|0;g=k[f>>2]|0;h=g;if(g|0){c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(g|0))k[c>>2]=d+(~((d+-8-h|0)>>>3)<<3);ggb(g)}}while((f|0)!=(Uc|0));ggb(Uc)}if(!kd){r=ld;return}if((e|0)!=(kd|0))do{c=e;e=e+-12|0;f=k[e>>2]|0;g=f;if(f|0){c=c+-8|0;d=k[c>>2]|0;if((d|0)!=(f|0))k[c>>2]=d+(~((d+-8-g|0)>>>3)<<3);ggb(f)}}while((e|0)!=(kd|0));ggb(kd);r=ld;return}function fza(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0.0,m=0.0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0;z=r;r=r+32|0;u=z+16|0;v=z;w=e+(aa(d+-1|0,f)|0)|0;y=k[b+8>>2]|0;x=k[b+12>>2]|0;switch(k[a+80>>2]|0){case 0:{if((y|0)<=0){r=z;return}j=k[b+16>>2]|0;h=k[k[b+44>>2]>>2]|0;i=k[c+16>>2]|0;e=k[k[c+44>>2]>>2]|0;if((x|0)>0)d=0;else{r=z;return}do{a=j+(aa(h,d)|0)|0;g=i+(aa(e,d)|0)|0;f=0;do{c=a+(f<<3)|0;p[c>>3]=+p[w+(f<<3)>>3]+ +p[c>>3];p[g+(f<<3)>>3]=1.0;f=f+1|0}while((f|0)!=(x|0));d=d+1|0}while((d|0)!=(y|0));r=z;return}case 2:{m=+p[a+32>>3];m=-(m*m);l=+p[a+40>>3]*m;e=(y|0)>0;if(e?(h=k[b+16>>2]|0,i=k[k[b+44>>2]>>2]|0,j=k[c+16>>2]|0,n=k[k[c+44>>2]>>2]|0,(x|0)>0):0){d=0;do{a=h+(aa(i,d)|0)|0;g=j+(aa(n,d)|0)|0;f=0;do{t=a+(f<<3)|0;A=+p[t>>3]+ +p[w+(f<<3)>>3];p[g+(f<<3)>>3]=l*(A*2.0);p[t>>3]=A*A*m;f=f+1|0}while((f|0)!=(x|0));d=d+1|0}while((d|0)!=(y|0))}k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=16842752;k[u+4>>2]=b;w=v+4|0;t=w+4|0;k[t>>2]=0;k[t+4>>2]=0;k[v>>2]=33619968;k[w>>2]=b;XZ(u,v);if(!e){r=z;return}j=k[b+16>>2]|0;h=k[k[b+44>>2]>>2]|0;i=k[c+16>>2]|0;e=k[k[c+44>>2]>>2]|0;if((x|0)>0)d=0;else{r=z;return}do{a=j+(aa(h,d)|0)|0;g=i+(aa(e,d)|0)|0;f=0;do{c=g+(f<<3)|0;p[c>>3]=+p[a+(f<<3)>>3]*+p[c>>3];f=f+1|0}while((f|0)!=(x|0));d=d+1|0}while((d|0)!=(y|0));r=z;return}default:{l=+p[a+32>>3];e=a+40|0;m=+p[e>>3];h=(y|0)>0;if(h?(o=k[b+16>>2]|0,q=k[k[b+44>>2]>>2]|0,s=k[c+16>>2]|0,t=k[k[c+44>>2]>>2]|0,(x|0)>0):0){d=0;do{a=o+(aa(q,d)|0)|0;g=s+(aa(t,d)|0)|0;f=0;do{n=a+(f<<3)|0;A=l*(+p[n>>3]+ +p[w+(f<<3)>>3]);p[n>>3]=A;A=-+P(+A);p[g+(f<<3)>>3]=A;f=f+1|0}while((f|0)!=(x|0));d=d+1|0}while((d|0)!=(y|0))}k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=16842752;k[u+4>>2]=c;w=v+4|0;t=w+4|0;k[t>>2]=0;k[t+4>>2]=0;k[v>>2]=33619968;k[w>>2]=c;XZ(u,v);l=l*(+p[e>>3]*2.0);if(!h){r=z;return}j=k[b+16>>2]|0;h=k[k[b+44>>2]>>2]|0;i=k[c+16>>2]|0;e=k[k[c+44>>2]>>2]|0;if((x|0)>0)d=0;else{r=z;return}do{a=j+(aa(h,d)|0)|0;g=i+(aa(e,d)|0)|0;f=0;do{c=a+(f<<3)|0;w=g+(f<<3)|0;C=+p[w>>3];B=1.0/(C+1.0);A=B*((+p[c>>3]>0.0?1.0:-1.0)*(m*(1.0-C)));p[w>>3]=B*(l*C*B);p[c>>3]=A;f=f+1|0}while((f|0)!=(x|0));d=d+1|0}while((d|0)!=(y|0));r=z;return}}}function gza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+16|0;n=p+8|0;o=p;g=k[a>>2]|0;l=k[g+40>>2]|0;i[n>>0]=49;i[n+1>>0]=105;i[n+2>>0]=0;l=(l|0)<0?2147483647:l;m=b+4|0;e=k[m>>2]|0;d=k[b>>2]|0;c=e-d>>2;if(l>>>0<=c>>>0){if(l>>>0<c>>>0?(f=d+(l<<2)|0,(e|0)!=(f|0)):0)k[m>>2]=e+(~((e+-4-f|0)>>>2)<<2)}else{U1(b,l-c|0);g=k[a>>2]|0}k[o>>2]=0;h=o+4|0;k[h>>2]=0;f=n;a:do if(!(f&3)){a=n;j=10}else{e=n;c=49;a=f;while(1){if(!(c<<24>>24))break a;a=e+1|0;d=a;if(!(d&3)){j=10;break a}e=a;c=i[a>>0]|0;a=d}}while(0);if((j|0)==10){while(1){c=k[a>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))a=a+4|0;else break}if((c&255)<<24>>24)do a=a+1|0;while((i[a>>0]|0)!=0)}j=a-f|0;a=ZT(j+8&-4)|0;k[a>>2]=1;f=a+4|0;k[o>>2]=f;k[h>>2]=j;i[f+j>>0]=0;upb(f|0,n|0,j|0)|0;n=k[b>>2]|0;C6(g,o,(n|0)==(k[m>>2]|0)?0:n,l<<2)|0;k[h>>2]=0;k[o>>2]=0;o=k[a>>2]|0;k[a>>2]=o+-1;if((o|0)!=1){r=p;return}ggb(k[a+-4>>2]|0);r=p;return}function hza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;h=m+8|0;j=m;i[h>>0]=49;i[h+1>>0]=105;i[h+2>>0]=0;k[j>>2]=0;l=j+4|0;k[l>>2]=0;g=h;a:do if(!(g&3)){c=h;f=5}else{e=h;d=g;c=49;while(1){if(!(c<<24>>24)){c=d;break a}c=e+1|0;d=c;if(!(d&3)){f=5;break a}e=c;c=i[c>>0]|0}}while(0);if((f|0)==5){while(1){d=k[c>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))c=c+4|0;else break}if((d&255)<<24>>24)do c=c+1|0;while((i[c>>0]|0)!=0)}g=c-g|0;c=ZT(g+8&-4)|0;k[c>>2]=1;f=c+4|0;k[j>>2]=f;k[l>>2]=g;i[f+g>>0]=0;upb(f|0,h|0,g|0)|0;h=k[b>>2]|0;b=k[b+4>>2]|0;A6(a,j,(h|0)==(b|0)?0:h,b-h|0);k[l>>2]=0;k[j>>2]=0;l=k[c>>2]|0;k[c>>2]=l+-1;if((l|0)!=1){r=m;return}ggb(k[c+-4>>2]|0);r=m;return}function iza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[a+8>>2]|0,c,k[b>>2]|0);if(!(k[j>>2]&4)){r=l;return}k[j>>2]=6;r=l;return}function jza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;e=l;if(!(Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0)){r=l;return a|0}j=a+32|0;if((k[j>>2]|0)==6){c=e+4|0;d=ZT(36)|0;k[d>>2]=1;f=d+4|0;k[e>>2]=f;k[c>>2]=30;i[d+34>>0]=0;g=401220;h=f+30|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-2,e,401251,401262,1064);k[c>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[a+16>>2]|0))c=0;else{c=k[a+12>>2]|0;c=(c|0)==0?1016759:c}u6(k[a+8>>2]|0,c,+p[b>>3]);if(!(k[j>>2]&4)){r=l;return a|0}k[j>>2]=6;r=l;return a|0}function kza(a){a=a|0;var b=0,c=0,d=0;while(1){b=fgb(280)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[b>>2]=90792;c=b+8|0;k[c>>2]=92848;uHa(b+12|0);k[b+240>>2]=0;k[b+244>>2]=0;zpb(b+92|0,0,144)|0;k[c>>2]=90972;k[b+248>>2]=1;k[b+252>>2]=100;p[b+256>>3]=.95;k[b+264>>2]=0;k[b+268>>2]=0;k[b+272>>2]=0;k[b+84>>2]=0;k[b+76>>2]=1;while(1){c=fgb(16)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c+4|0;k[d>>2]=1;k[c>>2]=91240;k[c+8>>2]=b;k[a>>2]=c;k[a+4>>2]=b;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1)return;Uh[k[(k[c>>2]|0)+8>>2]&2047](c);return}function lza(a){a=a|0;ggb(a);return}function mza(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function nza(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90972;b=k[a+256>>2]|0;if(!b){LGa(a);return}c=a+260|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);LGa(a);return}function oza(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=90972;b=k[a+256>>2]|0;if(!b){LGa(a);ggb(a);return}c=a+260|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);LGa(a);ggb(a);return}function pza(a){a=a|0;NGa(a);return}function qza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+16|0;o=p;n=a+144|0;c=a+148|0;if((k[n>>2]|0)==(k[c>>2]|0)){d=o+4|0;e=ZT(36)|0;k[e>>2]=1;g=e+4|0;k[o>>2]=g;k[d>>2]=28;i[e+32>>0]=0;h=368107;j=g+28|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,o,370627,361962,388);k[d>>2]=0;k[o>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}jh[k[(k[a>>2]|0)+228>>2]&1023](a,b);l=(k[c>>2]|0)-(k[n>>2]|0)|0;m=l>>2;k[o>>2]=0;j=o+4|0;k[j>>2]=0;c=ZT(12)|0;k[c>>2]=1;f=c+4|0;k[o>>2]=f;k[j>>2]=6;i[c+10>>0]=0;i[f>>0]=i[367989]|0;i[f+1>>0]=i[367990]|0;i[f+2>>0]=i[367991]|0;i[f+3>>0]=i[367992]|0;i[f+4>>0]=i[367993]|0;i[f+5>>0]=i[367994]|0;f=z6(b,o)|0;c=k[o>>2]|0;k[j>>2]=0;k[o>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);if(Xh[k[(k[f>>2]|0)+12>>2]&1023](f)|0){e=f+32|0;if((k[e>>2]|0)==6){c=o+4|0;d=ZT(36)|0;k[d>>2]=1;g=d+4|0;k[o>>2]=g;k[c>>2]=30;i[d+34>>0]=0;h=401220;j=g+30|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-2,o,401251,401262,1064);k[c>>2]=0;k[o>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}if(!(k[f+16>>2]|0))c=0;else{c=k[f+12>>2]|0;c=(c|0)==0?1016759:c}p6(k[f+8>>2]|0,c,m);if(k[e>>2]&4|0)k[e>>2]=6}k[o>>2]=0;j=o+4|0;k[j>>2]=0;d=ZT(12)|0;k[d>>2]=1;c=d+4|0;k[o>>2]=c;k[j>>2]=5;i[d+9>>0]=0;i[c>>0]=i[380533]|0;i[c+1>>0]=i[380534]|0;i[c+2>>0]=i[380535]|0;i[c+3>>0]=i[380536]|0;i[c+4>>0]=i[380537]|0;c=z6(f,o)|0;d=k[o>>2]|0;k[j>>2]=0;k[o>>2]=0;if(d|0?(h=d+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[d+-8>>2]|0);k[o>>2]=0;j=o+4|0;k[j>>2]=0;g=ZT(8)|0;k[g>>2]=1;h=g+4|0;k[o>>2]=h;k[j>>2]=1;i[g+5>>0]=0;i[h>>0]=91;z6(c,o)|0;c=k[o>>2]|0;k[j>>2]=0;k[o>>2]=0;if(c|0?(h=c+-4|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0)ggb(k[c+-8>>2]|0);if((l|0)>0){e=o+4|0;f=o+4|0;d=0;do{k[o>>2]=0;k[e>>2]=0;l=ZT(8)|0;k[l>>2]=1;c=l+4|0;k[o>>2]=c;k[e>>2]=1;i[l+5>>0]=0;i[c>>0]=123;z6(b,o)|0;c=k[o>>2]|0;k[e>>2]=0;k[o>>2]=0;if(c|0?(j=c+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[c+-8>>2]|0);Ph[k[(k[a>>2]|0)+240>>2]&511](a,b,k[(k[n>>2]|0)+(d<<2)>>2]|0);k[o>>2]=0;k[f>>2]=0;l=ZT(8)|0;k[l>>2]=1;c=l+4|0;k[o>>2]=c;k[f>>2]=1;i[l+5>>0]=0;i[c>>0]=125;z6(b,o)|0;c=k[o>>2]|0;k[f>>2]=0;k[o>>2]=0;if(c|0?(j=c+-4|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0)ggb(k[c+-8>>2]|0);d=d+1|0}while((d|0)<(m|0))}n=o+4|0;a=ZT(8)|0;k[a>>2]=1;c=a+4|0;k[o>>2]=c;k[n>>2]=1;i[a+5>>0]=0;i[c>>0]=93;z6(b,o)|0;c=k[o>>2]|0;k[n>>2]=0;k[o>>2]=0;if(!c){r=p;return}n=c+-4|0;o=k[n>>2]|0;k[n>>2]=o+-1;if((o|0)!=1){r=p;return}ggb(k[c+-8>>2]|0);r=p;return}function rza(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0;t=r;r=r+64|0;q=t+8|0;s=t;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);e=b+4|0;c=k6(k[b>>2]|0,k[e>>2]|0,367989)|0;a:do if(!c)o=0;else{switch(k[c>>2]&7){case 1:{o=k[c+8>>2]|0;break a}case 2:break;default:{o=2147483647;break a}}d=+p[c+8>>3];p[u>>3]=d;c=k[u+4>>2]|0;o=c&2146435072;if(!(o>>>0>1126170624|(o|0)==1126170624&0>0)){c=(c|0)<0;d=c?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=c?-0.0:0.0}o=~~d}while(0);jh[k[(k[a>>2]|0)+244>>2]&1023](a,b);c=k[b>>2]|0;e=k6(c,k[e>>2]|0,380533)|0;do if((c|0)!=0&(e|0)!=0?(f=k[e>>2]|0,g=f&7,(g|0)!=0):0){k[q>>2]=c;k[q+4>>2]=e;if(!((g+-5|0)>>>0<2&(f&16|0)==0)){k[q+20>>2]=e;k[q+12>>2]=0;k[q+40>>2]=1;b=18;break}c=e+8|0;KY(k[c>>2]|0,q+8|0);b=k[e>>2]|0;switch(b&7){case 6:{c=k[(k[c>>2]|0)+60>>2]|0;break}case 5:{c=k[(k[c>>2]|0)+24>>2]|0;break}default:c=(b&7|0)!=0&1}k[q+40>>2]=c;b=18}else b=17;while(0);if((b|0)==17){k[q>>2]=0;k[q+4>>2]=0;k[q+20>>2]=0;k[q+40>>2]=0;if(!e){c=1;b=22}else b=18}b:do if((b|0)==18){c=k[e>>2]|0;switch(c&7){case 6:{c=k[(k[e+8>>2]|0)+60>>2]|0;break b}case 5:{c=k[(k[e+8>>2]|0)+24>>2]|0;break b}default:{c=(c&7|0)==0;b=22;break b}}}while(0);if((b|0)==22)c=c&1^1;if((o|0)!=(c|0)){c=s+4|0;b=ZT(40)|0;k[b>>2]=1;e=b+4|0;k[s>>2]=e;k[c>>2]=32;i[b+36>>0]=0;f=368011;g=e+32|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,s,401059,361962,434);k[c>>2]=0;k[s>>2]=0;n=k[b>>2]|0;k[b>>2]=n+-1;if((n|0)==1)ggb(k[b+-4>>2]|0)}if((o|0)<=0){r=t;return}g=q+20|0;h=s+4|0;j=q+40|0;l=q+12|0;m=q+28|0;n=q+16|0;b=q+24|0;c=0;do{f=k[q>>2]|0;e=k6(f,k[g>>2]|0,371485)|0;k[s>>2]=f;k[h>>2]=e;Hh[k[(k[a>>2]|0)+256>>2]&511](a,s)|0;c=c+1|0;e=k[j>>2]|0;if(e|0){f=k[l>>2]|0;if(f|0?(v=(k[g>>2]|0)+(k[f+28>>2]|0)|0,k[g>>2]=v,v>>>0>=(k[m>>2]|0)>>>0):0){v=k[(k[n>>2]|0)+4>>2]|0;k[n>>2]=v;w=k[v+16>>2]|0;k[g>>2]=w;f=k[f+28>>2]|0;v=k[v+12>>2]|0;k[b>>2]=w;v=w+(aa(f,v)|0)|0;k[m>>2]=v}k[j>>2]=e+-1}}while((c|0)!=(o|0));r=t;return}function sza(a,b){a=a|0;b=b|0;var c=0;c=ZT(20)|0;k[c>>2]=1;b=c+4|0;k[a>>2]=b;k[a+4>>2]=15;i[c+19>>0]=0;a=b;b=362046;c=a+15|0;do{i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0}while((a|0)<(c|0));return}function tza(a){a=a|0;var b=0;b=k[a+108>>2]|0;a=k[a+112>>2]|0;return ((b|0)==(a|0)?0:a+-1-b|0)|0}function uza(a){a=a|0;return (k[a+144>>2]|0)!=(k[a+148>>2]|0)|0}function vza(a){a=a|0;return 1}function wza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0.0,h=0.0,j=0.0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0;ka=r;r=r+1184|0;fa=ka+1168|0;ga=ka;ha=ka+1112|0;ja=ka+1096|0;Ph[k[(k[a>>2]|0)+152>>2]&511](a,b,c);Y=k[a+244>>2]|0;Y=(Y|0)>-1?Y:1e4;$=a+236|0;c=k[$>>2]|0;b=c+128|0;k[ja>>2]=0;ia=ja+4|0;k[ia>>2]=0;ba=ja+8|0;k[ba>>2]=0;c=c+132|0;d=(k[c>>2]|0)-(k[b>>2]|0)>>2;if(d|0?(eQ(ja,d),e=k[b>>2]|0,f=(k[c>>2]|0)-e|0,(f|0)>0):0){upb(k[ia>>2]|0,e|0,f|0)|0;k[ia>>2]=(k[ia>>2]|0)+(f>>2<<2)}a:do if((Y|0)>0){u=a+84|0;v=a+88|0;w=ga+8|0;x=ga+4|0;y=ha+4|0;z=ha+8|0;A=ha+12|0;B=ha+16|0;C=ha+20|0;D=ha+24|0;E=ha+28|0;F=ha+40|0;G=ha+48|0;H=ha+44|0;I=ha+52|0;J=fa+4|0;K=a+240|0;L=fa+8|0;M=fa+12|0;N=fa+4|0;O=fa+4|0;Q=fa+4|0;R=a+248|0;S=ha+36|0;T=ha+32|0;U=a+144|0;V=a+156|0;W=fa+4|0;X=a+256|0;t=0;while(1){if((Hh[k[(k[a>>2]|0)+164>>2]&511](a,ja)|0)<0){d=0;break a}m=k[$>>2]|0;m=(k[m+132>>2]|0)-(k[m+128>>2]|0)|0;s=m>>2;l=(k[v>>2]|0)-(k[u>>2]|0)>>2;d=l+s|0;k[ga>>2]=w;k[x>>2]=136;if(d>>>0>136){c=d>>>0>536870911?-1:d<<3;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[ga>>2]=b}else b=w;k[x>>2]=d;q=b+(s<<3)|0;k[ha>>2]=1124007941;k[y>>2]=2;k[z>>2]=1;k[A>>2]=l;k[B>>2]=q;k[C>>2]=q;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[F>>2]=z;k[H>>2]=G;k[I>>2]=0;k[G>>2]=0;if((l|0)!=0&(q|0)==0){k[fa>>2]=0;k[J>>2]=0;c=ZT(36)|0;k[c>>2]=1;d=c+4|0;k[fa>>2]=d;k[J>>2]=28;i[c+32>>0]=0;e=390609;f=d+28|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,fa,390638,390642,410);k[J>>2]=0;k[fa>>2]=0;o=k[c>>2]|0;k[c>>2]=o+-1;if((o|0)==1)ggb(k[c+-4>>2]|0);d=k[ha>>2]|0;e=k[H>>2]|0;f=k[C>>2]|0;c=k[A>>2]|0}else{d=1124007941;e=G;f=q;c=l}c=c<<2;k[ha>>2]=d|16384;k[e>>2]=c;k[e+4>>2]=4;e=f+(aa(k[z>>2]|0,c)|0)|0;k[E>>2]=e;k[D>>2]=e+(0-c)+c;c=k[K>>2]|0;e=(c|0)==0?515:258;o=(m|0)>0;if(o){d=t+1|0;c=0;do{m=k[$>>2]|0;l=k[m+4>>2]|0;f=k[(k[l>>2]|0)+32>>2]|0;k[L>>2]=0;k[M>>2]=0;k[fa>>2]=-2130509820;k[N>>2]=u;dh[f&255](l,fa,k[(k[m+128>>2]|0)+(c<<2)>>2]|0,q);m=k[(k[a>>2]|0)+220>>2]|0;k[fa>>2]=t;k[O>>2]=d;h=+wh[m&31](a,fa,ha,e);p[b+(c<<3)>>3]=h;c=c+1|0}while((c|0)<(s|0));c=k[K>>2]|0}b:do switch(c|0){case 0:{if(o){f=k[$>>2]|0;d=k[f+128>>2]|0;e=k[f+92>>2]|0;f=k[f+104>>2]|0;h=0.0;g=0.0;c=0;do{n=k[d+(c<<2)>>2]|0;j=+p[e+(n<<3)>>3];h=h+j;g=g+j*+(+p[b+(c<<3)>>3]!=+(k[f+(n<<2)>>2]|0)&1);c=c+1|0}while((c|0)<(s|0))}else{h=0.0;g=0.0}j=h!=0.0?g/h:g;j=j<1.0e-05?1.0e-05:j;j=j>.99999?.99999:j;j=-+_(+(j/(1.0-j)));h=+Z(+j);if(o){f=k[$>>2]|0;d=k[f+128>>2]|0;e=k[f+92>>2]|0;f=k[f+104>>2]|0;g=0.0;c=0;do{m=k[d+(c<<2)>>2]|0;n=e+(m<<3)|0;la=+p[n>>3];la=+p[b+(c<<3)>>3]!=+(k[f+(m<<2)>>2]|0)?h*la:la;g=g+la;p[n>>3]=la;c=c+1|0}while((c|0)<(s|0))}else g=0.0;f=k[V>>2]|0;c=k[(k[U>>2]|0)+(t<<2)>>2]|0;c:while(1){while(1){d=f+(c<<5)|0;p[d>>3]=+p[d>>3]*j;d=k[f+(c<<5)+16>>2]|0;if((d|0)<0)break;else c=d}while(1){d=k[f+(c<<5)+12>>2]|0;if((d|0)<=-1){j=g;n=49;break b}e=k[f+(d<<5)+20>>2]|0;if((e|0)==(c|0))c=d;else{c=e;continue c}}}}case 3:case 1:{if(o){d=k[$>>2]|0;g=0.0;m=0;c=d;d=k[d+116>>2]|0;do{l=k[(k[c+128>>2]|0)+(m<<2)>>2]|0;h=+p[d+(l<<3)>>3];if(!(+P(+h)==1.0)){k[fa>>2]=0;k[W>>2]=0;c=ZT(40)|0;k[c>>2]=1;d=c+4|0;k[fa>>2]=d;k[W>>2]=35;i[c+39>>0]=0;e=361905;f=d+35|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,fa,361941,361962,268);k[W>>2]=0;k[fa>>2]=0;n=k[c>>2]|0;k[c>>2]=n+-1;if((n|0)==1)ggb(k[c+-4>>2]|0);c=k[$>>2]|0;d=k[c+116>>2]|0;h=+p[d+(l<<3)>>3]}n=(k[c+92>>2]|0)+(l<<3)|0;la=+p[n>>3]*+Z(+-(+p[b+(m<<3)>>3]*h));g=g+la;p[n>>3]=la;m=m+1|0}while((m|0)<(s|0));j=g;n=49}break}case 2:{if(o){m=k[$>>2]|0;e=k[m+128>>2]|0;f=k[X>>2]|0;l=k[m+92>>2]|0;m=k[m+116>>2]|0;g=0.0;d=0;do{c=k[e+(d<<2)>>2]|0;n=f+(d<<3)|0;h=+p[b+(d<<3)>>3]*.5+ +p[n>>3];p[n>>3]=h;h=1.0/(+Z(+(h*-2.0))+1.0);j=1.0-h;la=h*j;la=la<1.1920928955078125e-07?1.1920928955078125e-07:la;p[l+(c<<3)>>3]=la;g=g+la;c=m+(c<<3)|0;if(+p[c>>3]>0.0){h=1.0/h;h=h>10.0?10.0:h}else{h=1.0/j;h=-(h>10.0?10.0:h)}p[c>>3]=h;d=d+1|0}while((d|0)<(s|0));j=g;n=49}break}default:{k[fa>>2]=0;k[Q>>2]=0;c=ZT(28)|0;k[c>>2]=1;d=c+4|0;k[fa>>2]=d;k[Q>>2]=21;i[c+25>>0]=0;e=362024;f=d+21|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-213,fa,361941,361962,309);k[Q>>2]=0;k[fa>>2]=0;m=k[c>>2]|0;k[c>>2]=m+-1;if((m|0)==1)ggb(k[c+-4>>2]|0)}}while(0);if(((n|0)==49?(n=0,j>1.1920928955078125e-07):0)?(ca=k[$>>2]|0,ea=k[ca+128>>2]|0,m=(k[ca+132>>2]|0)-ea|0,da=m>>2,ea,(m|0)>0):0){d=k[ca+92>>2]|0;g=0.0;c=0;do{g=g+ +p[d+(k[ea+(c<<2)>>2]<<3)>>3];c=c+1|0}while((c|0)<(da|0));c=g>2.220446049250313e-16;h=c?1.0/g:0.0;g=c?0.0:1.0;c=0;do{m=d+(k[ea+(c<<2)>>2]<<3)|0;p[m>>3]=g+h*+p[m>>3];c=c+1|0}while((c|0)<(da|0))}la=+p[R>>3];if(!(la<=0.0)&!(la>=1.0)){d:do if(o){e=k[$>>2]|0;d=k[e+128>>2]|0;e=k[e+92>>2]|0;c=0;do{p[b+(c<<3)>>3]=+p[e+(k[d+(c<<2)>>2]<<3)>>3];c=c+1|0}while((c|0)<(s|0));Ngb(b,q);g=1.0-+p[R>>3];c=0;while(1){h=+p[b+(c<<3)>>3];if(g<=0.0)break d;c=c+1|0;if((c|0)>=(s|0)){h=1797693134862315708145274.0e284;break}else g=g-h}}else{Ngb(b,q);h=1797693134862315708145274.0e284}while(0);b=k[ja>>2]|0;c=k[ia>>2]|0;if((c|0)!=(b|0))k[ia>>2]=c+(~((c+-4-b|0)>>>2)<<2);if(o){b=0;do{q=k[$>>2]|0;c=k[(k[q+128>>2]|0)+(b<<2)>>2]|0;k[fa>>2]=c;do if(+p[(k[q+92>>2]|0)+(c<<3)>>3]>=h){d=k[ia>>2]|0;if((d|0)==(k[ba>>2]|0)){Q4(ja,fa);break}else{k[d>>2]=c;k[ia>>2]=d+4;break}}while(0);b=b+1|0}while((b|0)<(s|0))}}b=k[S>>2]|0;if(b|0?(q=b+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){c=k[S>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[T>>2]|0;if(!b){b=B1()|0;c=k[S>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[S>>2]=0}k[S>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[y>>2]|0)>0){c=k[F>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[y>>2]|0))}b=k[H>>2]|0;if(!((b|0)==(G|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[ga>>2]|0;if((b|0)!=(w|0)){if(b|0)ggb(b);k[ga>>2]=w;k[x>>2]=136}t=t+1|0;if((t|0)>=(Y|0)){n=89;break a}}}else n=89;while(0);if((n|0)==89){Uh[k[(k[a>>2]|0)+156>>2]&2047](a);d=1}b=k[ja>>2]|0;if(!b){r=ka;return d|0}c=k[ia>>2]|0;if((c|0)!=(b|0))k[ia>>2]=c+(~((c+-4-b|0)>>>2)<<2);ggb(b);r=ka;return d|0}function xza(a){a=a|0;return k[a+64>>2]|0}function yza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if((b|0)>=2){h=(b|0)>15;h=h?15:b;j=a+64|0;k[j>>2]=h;r=g;return}d=c+4|0;e=ZT(36)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=29;i[e+33>>0]=0;h=370965;j=f+29|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,c,370995,371012,135);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);h=(b|0)>15;h=h?15:b;j=a+64|0;k[j>>2]=h;r=g;return}function zza(a){a=a|0;return k[a+68>>2]|0}function Aza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if((b|0)>=0){h=(b|0)>25;h=h?25:b;j=a+68|0;k[j>>2]=h;r=g;return}d=c+4|0;e=ZT(32)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=24;i[e+28>>0]=0;h=371170;j=f+24|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,c,371195,371012,141);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);h=(b|0)>25;h=h?25:b;j=a+68|0;k[j>>2]=h;r=g;return}function Bza(a){a=a|0;return k[a+72>>2]|0}function Cza(a,b){a=a|0;b=b|0;k[a+72>>2]=(b|0)<1?1:b;return}function Dza(a){a=a|0;return k[a+76>>2]|0}function Eza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if((b|0)>=0){h=(b|0)==1;h=h?0:b;j=a+76|0;k[j>>2]=h;r=g;return}d=c+4|0;e=ZT(112)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=106;i[e+110>>0]=0;h=371247;j=f+106|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,c,371354,371012,153);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);h=(b|0)==1;h=h?0:b;j=a+76|0;k[j>>2]=h;r=g;return}function Fza(a){a=a|0;return (i[a+4>>0]|0)!=0|0}function Gza(a,b){a=a|0;b=b|0;i[a+4>>0]=b&1;return}function Hza(a){a=a|0;return (i[a+5>>0]|0)!=0|0}function Iza(a,b){a=a|0;b=b|0;i[a+5>>0]=b&1;return}function Jza(a){a=a|0;return (i[a+6>>0]|0)!=0|0}function Kza(a,b){a=a|0;b=b|0;i[a+6>>0]=b&1;return}function Lza(a){a=a|0;return +(+o[a+80>>2])}function Mza(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=r;r=r+16|0;c=g;if(!(b<0.0)){j=a+80|0;o[j>>2]=b;r=g;return}d=c+4|0;e=ZT(48)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=41;i[e+45>>0]=0;h=371096;j=f+41|0;do{i[f>>0]=i[h>>0]|0;f=f+1|0;h=h+1|0}while((f|0)<(j|0));Y8(-211,c,371138,371012,161);k[d>>2]=0;k[c>>2]=0;j=k[e>>2]|0;k[e>>2]=j+-1;if((j|0)==1)ggb(k[e+-4>>2]|0);j=a+80|0;o[j>>2]=b;r=g;return}function Nza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=k[b+8>>2];i=a+4|0;e=b+12|0;c=k[e>>2]|0;k[i>>2]=c;f=a+8|0;k[f>>2]=k[b+16>>2];k[a+12>>2]=k[b+20>>2];k[a+16>>2]=k[b+24>>2];k[a+20>>2]=k[b+28>>2];k[a+24>>2]=k[b+32>>2];k[a+28>>2]=k[b+36>>2];k[a+32>>2]=k[b+40>>2];d=k[b+44>>2]|0;k[a+36>>2]=d;g=a+40|0;k[g>>2]=f;f=a+48|0;h=a+44|0;k[h>>2]=f;k[a+52>>2]=0;k[f>>2]=0;if(d){c=d+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[e>>2]|0}if((c|0)<3){b=k[b+52>>2]|0;i=k[h>>2]|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];return}k[i>>2]=0;x1(a,c,0,0,0);if((k[i>>2]|0)<=0)return;f=k[b+48>>2]|0;a=k[g>>2]|0;e=k[b+52>>2]|0;d=k[h>>2]|0;c=0;do{k[a+(c<<2)>>2]=k[f+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0));return}function Oza(a,b){a=a|0;b=b|0;KG(a+8|0,b)|0;return}function Pza(a){a=a|0;return a+144|0}function Qza(a){a=a|0;return a+156|0}function Rza(a){a=a|0;return a+168|0}function Sza(a){a=a|0;return a+180|0}function Tza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0;q=r;r=r+16|0;j=q;TGa(a,b,c);o=a+236|0;b=k[o>>2]|0;b=(k[b+132>>2]|0)-(k[b+128>>2]|0)>>2;p[j>>3]=0.0;Zza(a+256|0,b,j);j=a+240|0;b=k[j>>2]|0;if(b|0){i[a+228>>0]=0;a=k[o>>2]|0;l=(k[a+108>>2]|0)-(k[a+104>>2]|0)|0;n=l>>2;c=a+116|0;a=a+120|0;h=k[a>>2]|0;g=k[c>>2]|0;f=h-g>>3;if(n>>>0<=f>>>0){if(n>>>0<f>>>0?(m=g+(n<<3)|0,(h|0)!=(m|0)):0)k[a>>2]=h+(~((h+-8-m|0)>>>3)<<3)}else{Bla(c,n-f|0);b=k[j>>2]|0}m=(b|0)==2;d=m?-2.0:-1.0;e=m?2.0:1.0;if((l|0)>0){a=k[o>>2]|0;c=k[a+104>>2]|0;a=k[a+116>>2]|0;b=0;do{p[a+(b<<3)>>3]=(k[c+(b<<2)>>2]|0)>0?e:d;b=b+1|0}while((b|0)<(n|0))}}b=k[o>>2]|0;f=k[b+128>>2]|0;o=(k[b+132>>2]|0)-f|0;a=o>>2;if((o|0)<=0){r=q;return}c=k[b+92>>2]|0;d=0.0;b=0;do{d=d+ +p[c+(k[f+(b<<2)>>2]<<3)>>3];b=b+1|0}while((b|0)<(a|0));b=d>2.220446049250313e-16;e=b?1.0/d:0.0;d=b?0.0:1.0;b=0;do{o=c+(k[f+(b<<2)>>2]<<3)|0;p[o>>3]=d+e*+p[o>>3];b=b+1|0}while((b|0)<(a|0));r=q;return}function Uza(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+232|0;c=k[b>>2]|0;if(c|0?(e=c+4|0,d=k[e>>2]|0,k[e>>2]=d+-1,(d|0)==1):0)Uh[k[(k[c>>2]|0)+8>>2]&2047](c);k[b>>2]=0;k[a+236>>2]=0;e=a+256|0;b=k[e>>2]|0;k[e>>2]=0;k[a+260>>2]=0;k[a+264>>2]=0;if(!b)return;ggb(b);return}
function B9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0;m=k[(k[a+484>>2]|0)+24>>2]|0;n=k[m>>2]|0;j=k[m+4>>2]|0;m=k[m+8>>2]|0;h=k[a+112>>2]|0;if((d|0)<1|(h|0)==0)return;else e=0;do{a=h;f=k[c+(e<<2)>>2]|0;g=k[b+(e<<2)>>2]|0;while(1){i[f>>0]=(l[j+(l[g+1>>0]|0)>>0]|0)+(l[n+(l[g>>0]|0)>>0]|0)+(l[m+(l[g+2>>0]|0)>>0]|0);a=a+-1|0;if(!a)break;else{f=f+1|0;g=g+3|0}}e=e+1|0}while((e|0)!=(d|0));return}function C9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0;p=k[(k[a+484>>2]|0)+24>>2]|0;q=k[a+112>>2]|0;n=k[a+120>>2]|0;if((d|0)<=0)return;o=(n|0)>0;if(!q)return;else m=0;do{a=k[c+(m<<2)>>2]|0;if(o){j=q;f=k[b+(m<<2)>>2]|0;while(1){e=0;g=0;h=f;while(1){g=(l[(k[p+(e<<2)>>2]|0)+(l[h>>0]|0)>>0]|0)+g|0;e=e+1|0;if((e|0)==(n|0))break;else h=h+1|0}i[a>>0]=g;j=j+-1|0;if(!j)break;else{a=a+1|0;f=f+n|0}}}else zpb(a|0,0,q|0)|0;m=m+1|0}while((m|0)!=(d|0));return}function D9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=k[a+484>>2]|0;u=k[e+24>>2]|0;v=k[u>>2]|0;t=k[u+4>>2]|0;u=k[u+8>>2]|0;q=k[a+112>>2]|0;if((d|0)<=0)return;w=e+48|0;r=e+52|0;s=e+56|0;p=e+60|0;a=k[w>>2]|0;if(!q){e=0;do{a=a+1&15;e=e+1|0}while((e|0)!=(d|0));k[w>>2]=a;return}else o=0;do{j=k[r>>2]|0;m=k[s>>2]|0;n=k[p>>2]|0;e=q;f=0;g=k[c+(o<<2)>>2]|0;h=k[b+(o<<2)>>2]|0;while(1){i[g>>0]=(l[t+((l[h+1>>0]|0)+(k[m+(a<<6)+(f<<2)>>2]|0))>>0]|0)+(l[v+((l[h>>0]|0)+(k[j+(a<<6)+(f<<2)>>2]|0))>>0]|0)+(l[u+((l[h+2>>0]|0)+(k[n+(a<<6)+(f<<2)>>2]|0))>>0]|0);e=e+-1|0;if(!e)break;else{f=f+1&15;g=g+1|0;h=h+3|0}}a=a+1&15;k[w>>2]=a;o=o+1|0}while((o|0)!=(d|0));return}function E9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;u=k[a+484>>2]|0;v=k[a+120>>2]|0;w=k[a+112>>2]|0;if((d|0)<=0)return;t=u+48|0;m=u+24|0;n=(w|0)==0;if((v|0)>0)e=0;else{a=0;do{zpb(k[c+(a<<2)>>2]|0,0,w|0)|0;k[t>>2]=(k[t>>2]|0)+1&15;a=a+1|0}while((a|0)!=(d|0));return}do{o=c+(e<<2)|0;zpb(k[o>>2]|0,0,w|0)|0;p=k[t>>2]|0;q=b+(e<<2)|0;if(!n){f=0;do{r=k[(k[m>>2]|0)+(f<<2)>>2]|0;s=k[u+52+(f<<2)>>2]|0;a=w;g=k[o>>2]|0;h=0;j=(k[q>>2]|0)+f|0;while(1){i[g>>0]=(l[g>>0]|0)+(l[r+((l[j>>0]|0)+(k[s+(p<<6)+(h<<2)>>2]|0))>>0]|0);a=a+-1|0;if(!a)break;else{g=g+1|0;h=h+1&15;j=j+v|0}}f=f+1|0}while((f|0)!=(v|0))}k[t>>2]=p+1&15;e=e+1|0}while((e|0)!=(d|0));return}function F9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;H=k[a+484>>2]|0;I=k[a+120>>2]|0;J=k[a+112>>2]|0;x=k[a+336>>2]|0;if((d|0)<=0)return;y=(I|0)>0;z=H+84|0;A=H+24|0;B=H+16|0;C=(J|0)==0;D=J+-1|0;E=aa(D,I)|0;F=0-I|0;G=J+1|0;w=0;do{u=c+(w<<2)|0;zpb(k[u>>2]|0,0,J|0)|0;a:do if(y){v=b+(w<<2)|0;if(C){e=(k[z>>2]|0)==0;a=0;while(1){v=k[H+68+(a<<2)>>2]|0;j[(e?v:v+(G<<1)|0)>>1]=0;a=a+1|0;if((a|0)==(I|0))break a}}else r=0;do{e=(k[v>>2]|0)+r|0;f=k[u>>2]|0;a=k[H+68+(r<<2)>>2]|0;if(!(k[z>>2]|0)){s=I;t=1}else{s=F;t=-1;a=a+(G<<1)|0;e=e+E|0;f=f+D|0}p=k[(k[A>>2]|0)+(r<<2)>>2]|0;q=k[(k[B>>2]|0)+(r<<2)>>2]|0;m=0;n=J;o=0;g=0;h=a;while(1){K=h;h=h+(t<<1)|0;L=l[x+((g+8+(j[h>>1]|0)>>4)+(l[e>>0]|0))>>0]|0;g=l[p+L>>0]|0;i[f>>0]=(l[f>>0]|0)+g;g=L-(l[q+g>>0]|0)|0;j[K>>1]=(g*3|0)+o;o=(g*5|0)+m|0;n=n+-1|0;if(!n)break;else{m=g;g=g*7|0;e=e+s|0;f=f+t|0}}L=a+((aa(J,t)|0)<<1)|0;j[L>>1]=o;r=r+1|0}while((r|0)!=(I|0))}while(0);k[z>>2]=(k[z>>2]|0)==0&1;w=w+1|0}while((w|0)!=(d|0));return}function G9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=k[a+484>>2]|0;f=k[e+24>>2]|0;d=a+88|0;if(!(k[d>>2]|0))c=0;else{k[d>>2]=2;c=2}if(!b){k[e+4>>2]=(c|0)==2?231:230;k[e+8>>2]=1519;b=k[a+132>>2]|0;if((b|0)>=1){if((b|0)>256){c=k[a>>2]|0;k[c+20>>2]=59;k[c+24>>2]=256;Uh[k[c>>2]&2047](a)}}else{c=k[a>>2]|0;k[c+20>>2]=58;k[c+24>>2]=1;Uh[k[c>>2]&2047](a)}if((k[d>>2]|0)==2){d=((k[a+112>>2]|0)*6|0)+12|0;c=e+32|0;b=k[c>>2]|0;if(!b){b=ci[k[(k[a+4>>2]|0)+4>>2]&255](a,1,d)|0;k[c>>2]=b}zpb(b|0,0,d|0)|0;if(!(k[e+40>>2]|0))I9a(a);k[e+36>>2]=0}}else{k[e+4>>2]=229;k[e+8>>2]=1518;k[e+28>>2]=1}b=e+28|0;if(!(k[b>>2]|0))return;zpb(k[f>>2]|0,0,4096)|0;zpb(k[f+4>>2]|0,0,4096)|0;zpb(k[f+8>>2]|0,0,4096)|0;zpb(k[f+12>>2]|0,0,4096)|0;zpb(k[f+16>>2]|0,0,4096)|0;zpb(k[f+20>>2]|0,0,4096)|0;zpb(k[f+24>>2]|0,0,4096)|0;zpb(k[f+28>>2]|0,0,4096)|0;zpb(k[f+32>>2]|0,0,4096)|0;zpb(k[f+36>>2]|0,0,4096)|0;zpb(k[f+40>>2]|0,0,4096)|0;zpb(k[f+44>>2]|0,0,4096)|0;zpb(k[f+48>>2]|0,0,4096)|0;zpb(k[f+52>>2]|0,0,4096)|0;zpb(k[f+56>>2]|0,0,4096)|0;zpb(k[f+60>>2]|0,0,4096)|0;zpb(k[f+64>>2]|0,0,4096)|0;zpb(k[f+68>>2]|0,0,4096)|0;zpb(k[f+72>>2]|0,0,4096)|0;zpb(k[f+76>>2]|0,0,4096)|0;zpb(k[f+80>>2]|0,0,4096)|0;zpb(k[f+84>>2]|0,0,4096)|0;zpb(k[f+88>>2]|0,0,4096)|0;zpb(k[f+92>>2]|0,0,4096)|0;zpb(k[f+96>>2]|0,0,4096)|0;zpb(k[f+100>>2]|0,0,4096)|0;zpb(k[f+104>>2]|0,0,4096)|0;zpb(k[f+108>>2]|0,0,4096)|0;zpb(k[f+112>>2]|0,0,4096)|0;zpb(k[f+116>>2]|0,0,4096)|0;zpb(k[f+120>>2]|0,0,4096)|0;zpb(k[f+124>>2]|0,0,4096)|0;k[b>>2]=0;return}function H9a(a){a=a|0;k[(k[a+484>>2]|0)+28>>2]=1;return}function I9a(a){a=a|0;var b=0,c=0,d=0;b=k[a+484>>2]|0;a=ci[k[k[a+4>>2]>>2]&255](a,1,2044)|0;d=a+1020|0;k[b+40>>2]=d;k[d>>2]=0;k[a+1024>>2]=1;k[a+1016>>2]=-1;k[a+1028>>2]=2;k[a+1012>>2]=-2;k[a+1032>>2]=3;k[a+1008>>2]=-3;k[a+1036>>2]=4;k[a+1004>>2]=-4;k[a+1040>>2]=5;k[a+1e3>>2]=-5;k[a+1044>>2]=6;k[a+996>>2]=-6;k[a+1048>>2]=7;k[a+992>>2]=-7;k[a+1052>>2]=8;k[a+988>>2]=-8;k[a+1056>>2]=9;k[a+984>>2]=-9;k[a+1060>>2]=10;k[a+980>>2]=-10;k[a+1064>>2]=11;k[a+976>>2]=-11;k[a+1068>>2]=12;k[a+972>>2]=-12;k[a+1072>>2]=13;k[a+968>>2]=-13;k[a+1076>>2]=14;k[a+964>>2]=-14;k[a+1080>>2]=15;k[a+960>>2]=-15;a=16;b=16;while(1){k[d+(a<<2)>>2]=b;k[d+(0-a<<2)>>2]=0-b;c=a+1|0;if((c|0)==48){a=48;break}else{a=c;b=(c&1^1)+b|0}}do{k[d+(a<<2)>>2]=32;k[d+(0-a<<2)>>2]=-32;a=a+1|0}while((a|0)!=256);return}function J9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,m=0;g=k[(k[a+484>>2]|0)+24>>2]|0;f=k[a+112>>2]|0;if((d|0)<1|(f|0)==0)return;else a=0;do{c=f;e=k[b+(a<<2)>>2]|0;while(1){h=(k[g+((l[e>>0]|0)>>>3<<2)>>2]|0)+((l[e+1>>0]|0)>>>2<<6)+((l[e+2>>0]|0)>>>3<<1)|0;m=j[h>>1]|0;i=m+1<<16>>16;j[h>>1]=i<<16>>16==0?m:i;c=c+-1|0;if(!c)break;else e=e+3|0}a=a+1|0}while((a|0)!=(d|0));return}function K9a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;y=a+484|0;B=k[y>>2]|0;A=a+136|0;k[A>>2]=k[B+16>>2];s=k[B+20>>2]|0;z=ci[k[k[a+4>>2]>>2]&255](a,1,s<<5)|0;k[z>>2]=0;k[z+4>>2]=31;k[z+8>>2]=0;k[z+12>>2]=63;k[z+16>>2]=0;k[z+20>>2]=31;P9a(a,z);if((s|0)>1){b=1;do{if((b<<1|0)>(s|0)){c=0;e=0;f=z;d=0;while(1){g=k[f+24>>2]|0;h=(g|0)>(c|0);d=h?f:d;e=e+1|0;if((e|0)==(b|0))break;else{c=h?g:c;f=f+32|0}}}else{c=0;f=0;g=z;d=0;while(1){e=k[g+28>>2]|0;if((e|0)>(c|0)){x=(k[g+24>>2]|0)>0;d=x?g:d;c=x?e:c}f=f+1|0;if((f|0)==(b|0))break;else g=g+32|0}}if(!d)break;c=z+(b<<5)|0;e=d+4|0;k[z+(b<<5)+4>>2]=k[e>>2];f=d+12|0;k[z+(b<<5)+12>>2]=k[f>>2];g=d+20|0;k[z+(b<<5)+20>>2]=k[g>>2];k[c>>2]=k[d>>2];p=d+8|0;h=z+(b<<5)+8|0;k[h>>2]=k[p>>2];r=d+16|0;l=z+(b<<5)+16|0;k[l>>2]=k[r>>2];m=k[e>>2]|0;n=k[d>>2]|0;v=m-n<<4;o=k[f>>2]|0;p=k[p>>2]|0;w=(o-p|0)*12|0;q=k[g>>2]|0;r=k[r>>2]|0;x=(v|0)>(w|0);switch(((q-r<<3|0)>((x?v:w)|0)?2:(x&1^1)&255)&3){case 0:{x=(n+m|0)/2|0;k[e>>2]=x;k[c>>2]=x+1;break}case 1:{x=(p+o|0)/2|0;k[f>>2]=x;k[h>>2]=x+1;break}case 2:{x=(r+q|0)/2|0;k[g>>2]=x;k[l>>2]=x+1;break}default:{}}P9a(a,d);P9a(a,c);b=b+1|0}while((b|0)<(s|0));if((b|0)<=0){y=b;A=a+132|0;k[A>>2]=y;A=k[a>>2]|0;z=A+20|0;k[z>>2]=98;z=A+24|0;k[z>>2]=y;A=A+4|0;A=k[A>>2]|0;jh[A&1023](a,1);B=B+28|0;k[B>>2]=1;return}}else b=1;x=0;do{r=k[(k[y>>2]|0)+24>>2]|0;g=k[z+(x<<5)>>2]|0;s=k[z+(x<<5)+4>>2]|0;t=k[z+(x<<5)+8>>2]|0;u=k[z+(x<<5)+12>>2]|0;v=k[z+(x<<5)+16>>2]|0;w=k[z+(x<<5)+20>>2]|0;if((g|0)>(s|0)|(t|0)>(u|0)|(v|0)>(w|0)){f=0;e=0;d=0;c=0}else{f=0;e=0;d=0;c=0;while(1){q=k[r+(g<<2)>>2]|0;p=g<<3|4;o=t;while(1){n=o<<2|2;l=q+(o<<6)+(v<<1)|0;m=v;while(1){C=j[l>>1]|0;h=C&65535;if(C<<16>>16){f=(aa(h,m<<3|4)|0)+f|0;e=(aa(h,n)|0)+e|0;d=(aa(h,p)|0)+d|0;c=h+c|0}if((m|0)<(w|0)){l=l+2|0;m=m+1|0}else break}if((o|0)<(u|0))o=o+1|0;else break}if((g|0)<(s|0))g=g+1|0;else break}}C=c>>1;i[(k[k[A>>2]>>2]|0)+x>>0]=(d+C|0)/(c|0)|0;i[(k[(k[A>>2]|0)+4>>2]|0)+x>>0]=(e+C|0)/(c|0)|0;i[(k[(k[A>>2]|0)+8>>2]|0)+x>>0]=(f+C|0)/(c|0)|0;x=x+1|0}while((x|0)!=(b|0));C=a+132|0;k[C>>2]=b;C=k[a>>2]|0;A=C+20|0;k[A>>2]=98;A=C+24|0;k[A>>2]=b;C=C+4|0;C=k[C>>2]|0;jh[C&1023](a,1);C=B+28|0;k[C>>2]=1;return}function L9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=k[a+484>>2]|0;S=k[e+24>>2]|0;T=k[a+112>>2]|0;M=k[a+336>>2]|0;N=k[e+40>>2]|0;Q=k[a+136>>2]|0;O=k[Q>>2]|0;P=k[Q+4>>2]|0;Q=k[Q+8>>2]|0;if((d|0)<=0)return;R=e+36|0;H=e+32|0;I=(T|0)==0;J=T+-1|0;K=J*3|0;L=(T*3|0)+3|0;G=0;do{g=k[b+(G<<2)>>2]|0;f=k[c+(G<<2)>>2]|0;if(!(k[R>>2]|0)){F=3;E=1;e=k[H>>2]|0;h=1}else{F=-3;E=-1;e=(k[H>>2]|0)+(L<<1)|0;f=f+J|0;g=g+K|0;h=0}k[R>>2]=h;if(I){h=0;g=0;f=0}else{A=F+1|0;B=F+2|0;p=0;q=0;w=0;x=0;y=0;h=0;C=0;D=0;z=T;m=0;u=e;while(1){v=u;u=u+(F<<1)|0;r=l[M+((l[g>>0]|0)+(k[N+(m+8+(j[u>>1]|0)>>4<<2)>>2]|0))>>0]|0;s=l[M+((l[g+1>>0]|0)+(k[N+(p+8+(j[v+(A<<1)>>1]|0)>>4<<2)>>2]|0))>>0]|0;t=l[M+((l[g+2>>0]|0)+(k[N+(q+8+(j[v+(B<<1)>>1]|0)>>4<<2)>>2]|0))>>0]|0;n=t>>>3;o=s>>>2;p=r>>>3;q=(k[S+(p<<2)>>2]|0)+(o<<6)+(n<<1)|0;m=j[q>>1]|0;if(!(m<<16>>16)){O9a(a,p,o,n);m=j[q>>1]|0}m=(m&65535)+-1|0;i[f>>0]=m;o=r-(l[O+m>>0]|0)|0;n=s-(l[P+m>>0]|0)|0;m=t-(l[Q+m>>0]|0)|0;j[v>>1]=(o*3|0)+h;h=(o*5|0)+w|0;j[v+2>>1]=(n*3|0)+C;C=(n*5|0)+x|0;j[v+4>>1]=(m*3|0)+D;D=(m*5|0)+y|0;z=z+-1|0;if(!z)break;else{p=n*7|0;q=m*7|0;w=o;x=n;y=m;m=o*7|0;f=f+E|0;g=g+F|0}}g=C;f=D;e=e+((aa(T,F)|0)<<1)|0}j[e>>1]=h;j[e+2>>1]=g;j[e+4>>1]=f;G=G+1|0}while((G|0)!=(d|0));return}function M9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;r=k[(k[a+484>>2]|0)+24>>2]|0;s=k[a+112>>2]|0;if((d|0)<1|(s|0)==0)return;else o=0;do{n=s;p=k[c+(o<<2)>>2]|0;q=k[b+(o<<2)>>2]|0;while(1){f=(l[q>>0]|0)>>>3;g=(l[q+1>>0]|0)>>>2;h=(l[q+2>>0]|0)>>>3;m=(k[r+(f<<2)>>2]|0)+(g<<6)+(h<<1)|0;e=j[m>>1]|0;if(!(e<<16>>16)){O9a(a,f,g,h);e=j[m>>1]|0}i[p>>0]=(e&65535)+255;n=n+-1|0;if(!n)break;else{p=p+1|0;q=q+3|0}}o=o+1|0}while((o|0)!=(d|0));return}function N9a(a){a=a|0;return}function O9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=r;r=r+1408|0;I=M;J=M+1152|0;L=M+1024|0;K=k[(k[a+484>>2]|0)+24>>2]|0;F=b>>2;G=c>>3;H=d>>2;f=F<<5;C=f|4;h=G<<5;D=h|2;n=H<<5;E=n|4;u=k[a+132>>2]|0;f=f|28;g=f+C>>1;h=h|30;m=h+D>>1;n=n|28;o=n+E>>1;if((u|0)>0){s=k[a+136>>2]|0;p=k[s>>2]|0;q=k[s+4>>2]|0;s=k[s+8>>2]|0;t=2147483647;e=0;do{b=l[p+e>>0]|0;do if((b|0)>=(C|0)){if((b|0)>(f|0)){B=b-f<<1;d=b-C<<1;d=aa(d,d)|0;b=aa(B,B)|0;break}if((b|0)>(g|0)){d=b-C<<1;d=aa(d,d)|0;b=0;break}else{d=b-f<<1;d=aa(d,d)|0;b=0;break}}else{B=b-C<<1;d=b-f<<1;d=aa(d,d)|0;b=aa(B,B)|0}while(0);c=l[q+e>>0]|0;do if((c|0)>=(D|0)){if((c|0)>(h|0)){B=(c-h|0)*3|0;c=(c-D|0)*3|0;b=(aa(B,B)|0)+b|0;c=aa(c,c)|0;break}if((c|0)>(m|0)){c=(c-D|0)*3|0;c=aa(c,c)|0;break}else{c=(c-h|0)*3|0;c=aa(c,c)|0;break}}else{B=(c-D|0)*3|0;c=(c-h|0)*3|0;b=(aa(B,B)|0)+b|0;c=aa(c,c)|0}while(0);d=c+d|0;c=l[s+e>>0]|0;do if((c|0)>=(E|0)){if((c|0)>(n|0)){B=c-n|0;c=c-E|0;b=(aa(B,B)|0)+b|0;c=aa(c,c)|0;break}if((c|0)>(o|0)){c=c-E|0;c=aa(c,c)|0;break}else{c=c-n|0;c=aa(c,c)|0;break}}else{B=c-E|0;c=c-n|0;b=(aa(B,B)|0)+b|0;c=aa(c,c)|0}while(0);B=d+c|0;k[I+(e<<2)>>2]=b;t=(B|0)<(t|0)?B:t;e=e+1|0}while((e|0)!=(u|0));b=0;c=0;do{if((k[I+(c<<2)>>2]|0)<=(t|0)){i[J+b>>0]=c;b=b+1|0}c=c+1|0}while((c|0)!=(u|0));B=b}else B=0;b=I;c=127;while(1){k[b>>2]=2147483647;if((c|0)>0){b=b+4|0;c=c+-1|0}else break}if((B|0)>0){q=a+136|0;v=I+128|0;y=L+32|0;w=I+256|0;z=L+64|0;x=I+384|0;A=L+96|0;p=0;do{s=i[J+p>>0]|0;a=s&255;t=k[q>>2]|0;o=C-(l[(k[t>>2]|0)+a>>0]|0)|0;n=o<<1;n=aa(n,n)|0;h=D-(l[(k[t+4>>2]|0)+a>>0]|0)|0;u=h*3|0;n=(aa(u,u)|0)+n|0;a=E-(l[(k[t+8>>2]|0)+a>>0]|0)|0;n=n+(aa(a,a)|0)|0;o=o<<6;h=(h*72|0)+144|0;a=a<<4;t=a+64|0;u=a+192|0;a=a+320|0;d=h;e=n;f=7;g=L;m=I;while(1){if((e|0)<(k[m>>2]|0)){k[m>>2]=e;i[g>>0]=s}b=t+e|0;c=m+4|0;if((b|0)<(k[c>>2]|0)){k[c>>2]=b;i[g+1>>0]=s}b=u+b|0;c=m+8|0;if((b|0)<(k[c>>2]|0)){k[c>>2]=b;i[g+2>>0]=s}b=a+b|0;c=m+12|0;if((b|0)<(k[c>>2]|0)){k[c>>2]=b;i[g+3>>0]=s}e=e+d|0;if((f|0)<=0)break;else{d=d+288|0;f=f+-1|0;g=g+4|0;m=m+16|0}}n=n+(o+256)|0;d=h;e=n;f=7;g=y;m=v;while(1){if((e|0)<(k[m>>2]|0)){k[m>>2]=e;i[g>>0]=s}b=t+e|0;c=m+4|0;if((b|0)<(k[c>>2]|0)){k[c>>2]=b;i[g+1>>0]=s}b=u+b|0;c=m+8|0;if((b|0)<(k[c>>2]|0)){k[c>>2]=b;i[g+2>>0]=s}b=a+b|0;c=m+12|0;if((b|0)<(k[c>>2]|0)){k[c>>2]=b;i[g+3>>0]=s}e=e+d|0;if((f|0)<=0)break;else{d=d+288|0;f=f+-1|0;g=g+4|0;m=m+16|0}}n=n+(o+768)|0;d=h;e=n;f=7;g=z;m=w;while(1){if((e|0)<(k[m>>2]|0)){k[m>>2]=e;i[g>>0]=s}b=t+e|0;c=m+4|0;if((b|0)<(k[c>>2]|0)){k[c>>2]=b;i[g+1>>0]=s}b=u+b|0;c=m+8|0;if((b|0)<(k[c>>2]|0)){k[c>>2]=b;i[g+2>>0]=s}b=a+b|0;c=m+12|0;if((b|0)<(k[c>>2]|0)){k[c>>2]=b;i[g+3>>0]=s}e=e+d|0;if((f|0)<=0)break;else{d=d+288|0;f=f+-1|0;g=g+4|0;m=m+16|0}}d=n+(o+1280)|0;e=7;f=A;g=x;while(1){if((d|0)<(k[g>>2]|0)){k[g>>2]=d;i[f>>0]=s}b=t+d|0;c=g+4|0;if((b|0)<(k[c>>2]|0)){k[c>>2]=b;i[f+1>>0]=s}b=u+b|0;c=g+8|0;if((b|0)<(k[c>>2]|0)){k[c>>2]=b;i[f+2>>0]=s}b=a+b|0;c=g+12|0;if((b|0)<(k[c>>2]|0)){k[c>>2]=b;i[f+3>>0]=s}d=d+h|0;if((e|0)<=0)break;else{h=h+288|0;e=e+-1|0;f=f+4|0;g=g+16|0}}p=p+1|0}while((p|0)!=(B|0))}e=F<<2;g=G<<3;f=H<<2;d=k[K+(e<<2)>>2]|0;b=0;c=L;while(1){J=d+(b+g<<6)+(f<<1)|0;j[J>>1]=(l[c>>0]|0)+1;j[J+2>>1]=(l[c+1>>0]|0)+1;j[J+4>>1]=(l[c+2>>0]|0)+1;j[J+6>>1]=(l[c+3>>0]|0)+1;b=b+1|0;if((b|0)==8)break;else c=c+4|0}d=k[K+((e|1)<<2)>>2]|0;b=0;c=L+32|0;while(1){J=d+(b+g<<6)+(f<<1)|0;j[J>>1]=(l[c>>0]|0)+1;j[J+2>>1]=(l[c+1>>0]|0)+1;j[J+4>>1]=(l[c+2>>0]|0)+1;j[J+6>>1]=(l[c+3>>0]|0)+1;b=b+1|0;if((b|0)==8)break;else c=c+4|0}d=k[K+((e|2)<<2)>>2]|0;b=0;c=L+64|0;while(1){J=d+(b+g<<6)+(f<<1)|0;j[J>>1]=(l[c>>0]|0)+1;j[J+2>>1]=(l[c+1>>0]|0)+1;j[J+4>>1]=(l[c+2>>0]|0)+1;j[J+6>>1]=(l[c+3>>0]|0)+1;b=b+1|0;if((b|0)==8)break;else c=c+4|0}d=k[K+((e|3)<<2)>>2]|0;c=0;b=L+96|0;while(1){L=d+(c+g<<6)+(f<<1)|0;j[L>>1]=(l[b>>0]|0)+1;j[L+2>>1]=(l[b+1>>0]|0)+1;j[L+4>>1]=(l[b+2>>0]|0)+1;j[L+6>>1]=(l[b+3>>0]|0)+1;c=c+1|0;if((c|0)==8)break;else b=b+4|0}r=M;return}function P9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=k[(k[a+484>>2]|0)+24>>2]|0;g=k[b>>2]|0;l=b+4|0;m=k[l>>2]|0;o=b+8|0;n=k[o>>2]|0;r=b+12|0;s=k[r>>2]|0;t=b+16|0;u=k[t>>2]|0;v=b+20|0;h=k[v>>2]|0;i=(n|0)>(s|0);p=(u|0)>(h|0);a:do if((m|0)<=(g|0)|i|p)f=g;else{f=g;b:while(1){e=k[w+(f<<2)>>2]|0;c=n;while(1){a=e+(c<<6)+(u<<1)|0;d=u;while(1){if(j[a>>1]|0)break b;if((d|0)<(h|0)){a=a+2|0;d=d+1|0}else break}if((c|0)<(s|0))c=c+1|0;else break}if((f|0)<(m|0))f=f+1|0;else{f=g;break a}}k[b>>2]=f}while(0);c:do if(!((m|0)<=(f|0)|i|p)){c=m;d:while(1){g=k[w+(c<<2)>>2]|0;d=n;while(1){a=g+(d<<6)+(u<<1)|0;e=u;while(1){if(j[a>>1]|0)break d;if((e|0)<(h|0)){a=a+2|0;e=e+1|0}else break}if((d|0)<(s|0))d=d+1|0;else break}if((c|0)>(f|0))c=c+-1|0;else break c}k[l>>2]=c;m=c}while(0);q=(m|0)<(f|0);e:do if(!((s|0)<=(n|0)|q|p)){d=n;f:while(1){c=f;while(1){a=(k[w+(c<<2)>>2]|0)+(d<<6)+(u<<1)|0;e=u;while(1){if(j[a>>1]|0)break f;if((e|0)<(h|0)){a=a+2|0;e=e+1|0}else break}if((c|0)<(m|0))c=c+1|0;else break}if((d|0)<(s|0))d=d+1|0;else break e}k[o>>2]=d;n=d}while(0);g:do if((s|0)<=(n|0)|q|p)l=s;else{d=s;h:while(1){c=f;while(1){a=(k[w+(c<<2)>>2]|0)+(d<<6)+(u<<1)|0;e=u;while(1){if(j[a>>1]|0)break h;if((e|0)<(h|0)){a=a+2|0;e=e+1|0}else break}if((c|0)<(m|0))c=c+1|0;else break}if((d|0)>(n|0))d=d+-1|0;else{l=s;break g}}k[r>>2]=d;l=d}while(0);g=(l|0)<(n|0);i:do if((h|0)<=(u|0)|q|g)i=u;else{d=u;j:while(1){a=f;while(1){c=n;e=(k[w+(a<<2)>>2]|0)+(n<<6)+(d<<1)|0;while(1){if(j[e>>1]|0)break j;if((c|0)<(l|0)){c=c+1|0;e=e+64|0}else break}if((a|0)<(m|0))a=a+1|0;else break}if((d|0)<(h|0))d=d+1|0;else{i=u;break i}}k[t>>2]=d;i=d}while(0);k:do if(!((h|0)<=(i|0)|q|g)){d=h;l:while(1){a=f;while(1){c=n;e=(k[w+(a<<2)>>2]|0)+(n<<6)+(d<<1)|0;while(1){if(j[e>>1]|0)break l;if((c|0)<(l|0)){c=c+1|0;e=e+64|0}else break}if((a|0)<(m|0))a=a+1|0;else break}if((d|0)>(i|0))d=d+-1|0;else break k}k[v>>2]=d;h=d}while(0);u=m-f<<4;t=(l-n|0)*12|0;v=h-i<<3;v=(aa(t,t)|0)+(aa(u,u)|0)+(aa(v,v)|0)|0;k[b+24>>2]=v;if(q|g|(h|0)<(i|0)){w=0;b=b+28|0;k[b>>2]=w;return}else a=0;while(1){g=k[w+(f<<2)>>2]|0;e=n;while(1){c=i;d=g+(e<<6)+(i<<1)|0;while(1){a=((j[d>>1]|0)!=0&1)+a|0;if((c|0)>=(h|0))break;else{c=c+1|0;d=d+2|0}}if((e|0)<(l|0))e=e+1|0;else break}if((f|0)<(m|0))f=f+1|0;else break}b=b+28|0;k[b>>2]=a;return}function Q9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=k[a+424>>2]|0;if(b|0){l=k[a>>2]|0;k[l+20>>2]=49;Uh[k[l>>2]&2047](a)}do if(k[a+268>>2]|0){b=(k[a+364>>2]|0)==0;c=m+4|0;if(!(k[a+372>>2]|0))if(b){k[c>>2]=275;break}else{k[c>>2]=276;break}else if(b){k[c>>2]=277;break}else{k[c>>2]=278;break}}else k[m+4>>2]=279;while(0);f=a+292|0;if((k[f>>2]|0)<=0){l=m+12|0;k[l>>2]=0;l=m+16|0;k[l>>2]=65536;l=m+20|0;k[l>>2]=0;l=m+24|0;k[l>>2]=0;l=m+28|0;k[l>>2]=11;l=m+32|0;k[l>>2]=-1;l=a+236|0;l=k[l>>2]|0;a=m+68|0;k[a>>2]=l;m=m+72|0;k[m>>2]=0;return}g=a+364|0;h=a+372|0;j=a+4|0;l=a+368|0;e=0;do{d=k[a+296+(e<<2)>>2]|0;if((k[g>>2]|0)==0?(k[h>>2]|0)==0:0){b=k[d+20>>2]|0;if(b>>>0>15){c=k[a>>2]|0;k[c+20>>2]=50;k[c+24>>2]=b;Uh[k[c>>2]&2047](a)}c=m+76+(b<<2)|0;b=k[c>>2]|0;if(!b){b=ci[k[k[j>>2]>>2]&255](a,1,64)|0;k[c>>2]=b}c=b+64|0;do{i[b>>0]=0;b=b+1|0}while((b|0)<(c|0));k[m+36+(e<<2)>>2]=0;k[m+52+(e<<2)>>2]=0}if(k[l>>2]|0){b=k[d+24>>2]|0;if(b>>>0>15){d=k[a>>2]|0;k[d+20>>2]=50;k[d+24>>2]=b;Uh[k[d>>2]&2047](a)}c=m+140+(b<<2)|0;b=k[c>>2]|0;if(!b){b=ci[k[k[j>>2]>>2]&255](a,1,256)|0;k[c>>2]=b}zpb(b|0,0,256)|0}e=e+1|0}while((e|0)<(k[f>>2]|0));l=m+12|0;k[l>>2]=0;l=m+16|0;k[l>>2]=65536;l=m+20|0;k[l>>2]=0;l=m+24|0;k[l>>2]=0;l=m+28|0;k[l>>2]=11;l=m+32|0;k[l>>2]=-1;l=a+236|0;l=k[l>>2]|0;a=m+68|0;k[a>>2]=l;m=m+72|0;k[m>>2]=0;return}function R9a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;h=k[a+424>>2]|0;l=h+12|0;g=k[l>>2]|0;e=(k[h+16>>2]|0)+-1+g&-65536;e=((e|0)<(g|0)?e|32768:e)<<k[h+28>>2];k[l>>2]=e;g=h+32|0;c=k[g>>2]|0;if(e>>>0<=134217727){if(c){if((c|0)>-1){d=h+24|0;e=a+24|0;if(k[d>>2]|0){do{b=k[e>>2]|0;c=k[b>>2]|0;k[b>>2]=c+1;i[c>>0]=0;c=b+4|0;f=(k[c>>2]|0)+-1|0;k[c>>2]=f;if((f|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){f=k[a>>2]|0;k[f+20>>2]=25;Uh[k[f>>2]&2047](a)}f=(k[d>>2]|0)+-1|0;k[d>>2]=f}while((f|0)!=0);c=k[g>>2]|0}b=k[e>>2]|0;f=k[b>>2]|0;k[b>>2]=f+1;i[f>>0]=c;f=b+4|0;g=(k[f>>2]|0)+-1|0;k[f>>2]=g;if((g|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}}}else{g=h+24|0;k[g>>2]=(k[g>>2]|0)+1}e=h+20|0;if(k[e>>2]|0){b=h+24|0;d=a+24|0;if(k[b>>2]|0)do{c=k[d>>2]|0;f=k[c>>2]|0;k[c>>2]=f+1;i[f>>0]=0;f=c+4|0;g=(k[f>>2]|0)+-1|0;k[f>>2]=g;if((g|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}g=(k[b>>2]|0)+-1|0;k[b>>2]=g}while((g|0)!=0);do{b=k[d>>2]|0;f=k[b>>2]|0;k[b>>2]=f+1;i[f>>0]=-1;f=b+4|0;g=(k[f>>2]|0)+-1|0;k[f>>2]=g;if((g|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}b=k[d>>2]|0;f=k[b>>2]|0;k[b>>2]=f+1;i[f>>0]=0;f=b+4|0;g=(k[f>>2]|0)+-1|0;k[f>>2]=g;if((g|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){g=k[a>>2]|0;k[g+20>>2]=25;Uh[k[g>>2]&2047](a)}g=(k[e>>2]|0)+-1|0;k[e>>2]=g}while((g|0)!=0)}}else{e=h+24|0;if((c|0)>-1){d=a+24|0;if(k[e>>2]|0){do{b=k[d>>2]|0;m=k[b>>2]|0;k[b>>2]=m+1;i[m>>0]=0;m=b+4|0;c=(k[m>>2]|0)+-1|0;k[m>>2]=c;if((c|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}m=(k[e>>2]|0)+-1|0;k[e>>2]=m}while((m|0)!=0);c=k[g>>2]|0}b=k[d>>2]|0;m=k[b>>2]|0;k[b>>2]=m+1;i[m>>0]=c+1;c=b+4|0;m=(k[c>>2]|0)+-1|0;k[c>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}if(((k[g>>2]|0)==254?(f=k[d>>2]|0,g=k[f>>2]|0,k[f>>2]=g+1,i[g>>0]=0,g=f+4|0,m=(k[g>>2]|0)+-1|0,k[g>>2]=m,(m|0)==0):0)?(Xh[k[f+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}}m=h+20|0;k[e>>2]=(k[e>>2]|0)+(k[m>>2]|0);k[m>>2]=0}b=k[l>>2]|0;if(!(b&134215680))return;c=h+24|0;d=a+24|0;if(k[c>>2]|0){do{b=k[d>>2]|0;h=k[b>>2]|0;k[b>>2]=h+1;i[h>>0]=0;h=b+4|0;m=(k[h>>2]|0)+-1|0;k[h>>2]=m;if((m|0)==0?(Xh[k[b+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}m=(k[c>>2]|0)+-1|0;k[c>>2]=m}while((m|0)!=0);b=k[l>>2]|0}c=k[d>>2]|0;h=k[c>>2]|0;k[c>>2]=h+1;i[h>>0]=b>>>19;h=c+4|0;m=(k[h>>2]|0)+-1|0;k[h>>2]=m;if((m|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}if(((k[l>>2]&133693440|0)==133693440?(j=k[d>>2]|0,h=k[j>>2]|0,k[j>>2]=h+1,i[h>>0]=0,h=j+4|0,m=(k[h>>2]|0)+-1|0,k[h>>2]=m,(m|0)==0):0)?(Xh[k[j+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}b=k[l>>2]|0;if(!(b&522240))return;c=k[d>>2]|0;j=k[c>>2]|0;k[c>>2]=j+1;i[j>>0]=b>>>11;j=c+4|0;m=(k[j>>2]|0)+-1|0;k[j>>2]=m;if((m|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a)}if((k[l>>2]&522240|0)!=522240)return;b=k[d>>2]|0;l=k[b>>2]|0;k[b>>2]=l+1;i[l>>0]=0;l=b+4|0;m=(k[l>>2]|0)+-1|0;k[l>>2]=m;if(m|0)return;if(Xh[k[b+12>>2]&1023](a)|0)return;m=k[a>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](a);return}function S9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0,o=0,p=0;p=k[a+424>>2]|0;d=a+236|0;if(k[d>>2]|0){e=p+68|0;c=k[e>>2]|0;if(!c){o=p+72|0;X9a(a,k[o>>2]|0);c=k[d>>2]|0;k[e>>2]=c;k[o>>2]=(k[o>>2]|0)+1&7}k[e>>2]=c+-1}n=a+320|0;if((k[n>>2]|0)<=0)return 1;o=a+376|0;m=0;do{d=k[a+324+(m<<2)>>2]|0;h=k[(k[a+296+(d<<2)>>2]|0)+20>>2]|0;c=j[k[b+(m<<2)>>2]>>1]>>k[o>>2];g=p+76+(h<<2)|0;i=p+52+(d<<2)|0;f=(k[g>>2]|0)+(k[i>>2]|0)|0;d=p+36+(d<<2)|0;e=c-(k[d>>2]|0)|0;if(e){k[d>>2]=c;Y9a(a,f,1);if((e|0)>0){Y9a(a,f+1|0,0);c=f+2|0;d=4}else{Y9a(a,f+1|0,1);e=0-e|0;c=f+3|0;d=8}k[i>>2]=d;f=e+-1|0;if(f){Y9a(a,c,1);c=(k[g>>2]|0)+20|0;d=f>>1;if(!d)e=1;else{e=1;do{Y9a(a,c,1);e=e<<1;c=c+1|0;d=d>>1}while((d|0)!=0)}}else e=0;Y9a(a,c,0);if((e|0)>=(1<<l[a+152+h>>0]>>1|0)){if((e|0)>(1<<l[a+168+h>>0]>>1|0))k[i>>2]=(k[i>>2]|0)+8}else k[i>>2]=0;d=c+14|0;c=e>>1;if(c|0)do{Y9a(a,d,(c&f|0)!=0&1);c=c>>1}while((c|0)!=0)}else{Y9a(a,f,0);k[i>>2]=0}m=m+1|0}while((m|0)<(k[n>>2]|0));return 1}function T9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;t=k[a+424>>2]|0;d=a+236|0;if(k[d>>2]|0){e=t+68|0;c=k[e>>2]|0;if(!c){s=t+72|0;X9a(a,k[s>>2]|0);c=k[d>>2]|0;k[e>>2]=c;k[s>>2]=(k[s>>2]|0)+1&7}k[e>>2]=c+-1}q=k[a+384>>2]|0;o=k[b>>2]|0;s=k[(k[a+296>>2]|0)+24>>2]|0;r=a+368|0;c=k[r>>2]|0;p=a+376|0;d=c;while(1){n=j[o+(k[q+(d<<2)>>2]<<1)>>1]|0;e=n<<16>>16;if(n<<16>>16>-1){if(e>>k[p>>2]|0){n=d;break}}else if(0-e>>k[p>>2]|0){n=d;break}d=d+-1|0;if(!d){n=0;break}}m=k[a+364>>2]|0;d=m+-1|0;if((m|0)<=(n|0)){h=t+140+(s<<2)|0;i=t+204|0;m=a+184+s|0;while(1){f=(k[h>>2]|0)+(d*3|0)|0;Y9a(a,f,0);while(1){g=d+1|0;b=j[o+(k[q+(g<<2)>>2]<<1)>>1]|0;c=b<<16>>16;if(b<<16>>16>-1){c=c>>k[p>>2];if(c|0){b=16;break}}else{c=0-c>>k[p>>2];if(c|0){b=18;break}}Y9a(a,f+1|0,0);f=f+3|0;d=g}if((b|0)==16){Y9a(a,f+1|0,1);Y9a(a,i,0);e=c}else if((b|0)==18){Y9a(a,f+1|0,1);Y9a(a,i,1);e=c}c=f+2|0;b=e+-1|0;if(b){Y9a(a,c,1);if((b|0)!=1){Y9a(a,c,1);c=(k[h>>2]|0)+((d|0)<(l[m>>0]|0|0)?189:217)|0;d=b>>2;if(!d)e=2;else{e=2;do{Y9a(a,c,1);e=e<<1;c=c+1|0;d=d>>1}while((d|0)!=0)}}else e=1}else e=0;Y9a(a,c,0);d=c+14|0;c=e>>1;if(c|0)do{Y9a(a,d,(c&b|0)!=0&1);c=c>>1}while((c|0)!=0);if((g|0)<(n|0))d=g;else break}d=g;c=k[r>>2]|0}if((d|0)>=(c|0))return 1;Y9a(a,(k[t+140+(s<<2)>>2]|0)+(d*3|0)|0,1);return 1}function U9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=k[a+424>>2]|0;d=a+236|0;if(k[d>>2]|0){f=e+68|0;c=k[f>>2]|0;if(!c){g=e+72|0;X9a(a,k[g>>2]|0);c=k[d>>2]|0;k[f>>2]=c;k[g>>2]=(k[g>>2]|0)+1&7}k[f>>2]=c+-1}d=e+204|0;e=k[a+376>>2]|0;f=a+320|0;if((k[f>>2]|0)>0)c=0;else return 1;do{Y9a(a,d,(j[k[b+(c<<2)>>2]>>1]|0)>>>e&1);c=c+1|0}while((c|0)<(k[f>>2]|0));return 1}function V9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0;q=k[a+424>>2]|0;d=a+236|0;if(k[d>>2]|0){e=q+68|0;c=k[e>>2]|0;if(!c){p=q+72|0;X9a(a,k[p>>2]|0);c=k[d>>2]|0;k[e>>2]=c;k[p>>2]=(k[p>>2]|0)+1&7}k[e>>2]=c+-1}n=k[a+384>>2]|0;l=k[b>>2]|0;p=k[(k[a+296>>2]|0)+24>>2]|0;o=a+368|0;c=k[o>>2]|0;m=a+376|0;d=c;while(1){b=j[l+(k[n+(d<<2)>>2]<<1)>>1]|0;e=b<<16>>16;if(b<<16>>16>-1){if(e>>k[m>>2]|0){i=10;break}}else if(0-e>>k[m>>2]|0){i=10;break}d=d+-1|0;if(!d){e=0;h=0;break}}a:do if((i|0)==10){g=a+372|0;if((d|0)>0){f=d;while(1){e=b<<16>>16;if(b<<16>>16>-1){if(e>>k[g>>2]|0){e=f;h=d;break a}}else if(0-e>>k[g>>2]|0){e=f;h=d;break a}e=f+-1|0;if((f|0)<=1){h=d;break a}f=e;b=j[l+(k[n+(e<<2)>>2]<<1)>>1]|0}}else{e=d;h=d}}while(0);i=k[a+364>>2]|0;d=i+-1|0;if((i|0)<=(h|0)){f=q+140+(p<<2)|0;g=q+204|0;do{c=(k[f>>2]|0)+(d*3|0)|0;if((d|0)>=(e|0))Y9a(a,c,0);b:while(1){d=d+1|0;i=j[l+(k[n+(d<<2)>>2]<<1)>>1]|0;b=i<<16>>16;if(i<<16>>16>-1){b=b>>k[m>>2];switch(b|0){case 1:{i=23;break b}case 0:break;default:{i=22;break b}}}else{b=0-b>>k[m>>2];switch(b|0){case 1:{i=27;break b}case 0:break;default:{i=25;break b}}}Y9a(a,c+1|0,0);c=c+3|0}if((i|0)==22)Y9a(a,c+2|0,b&1);else if((i|0)==23){Y9a(a,c+1|0,1);Y9a(a,g,0)}else if((i|0)==25)Y9a(a,c+2|0,b&1);else if((i|0)==27){Y9a(a,c+1|0,1);Y9a(a,g,1)}}while((d|0)<(h|0));c=k[o>>2]|0}if((d|0)>=(c|0))return 1;Y9a(a,(k[q+140+(p<<2)>>2]|0)+(d*3|0)|0,1);return 1}function W9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;w=k[a+424>>2]|0;d=a+236|0;if(k[d>>2]|0){e=w+68|0;c=k[e>>2]|0;if(!c){v=w+72|0;X9a(a,k[v>>2]|0);c=k[d>>2]|0;k[e>>2]=c;k[v>>2]=(k[v>>2]|0)+1&7}k[e>>2]=c+-1}s=k[a+384>>2]|0;t=a+320|0;if((k[t>>2]|0)<=0)return 1;u=a+388|0;v=w+204|0;r=0;do{q=k[b+(r<<2)>>2]|0;f=k[a+324+(r<<2)>>2]|0;m=k[a+296+(f<<2)>>2]|0;h=k[m+20>>2]|0;g=w+76+(h<<2)|0;i=w+52+(f<<2)|0;c=(k[g>>2]|0)+(k[i>>2]|0)|0;e=j[q>>1]|0;f=w+36+(f<<2)|0;d=e-(k[f>>2]|0)|0;if(d){k[f>>2]=e;Y9a(a,c,1);if((d|0)>0){Y9a(a,c+1|0,0);c=c+2|0;e=4}else{Y9a(a,c+1|0,1);c=c+3|0;d=0-d|0;e=8}k[i>>2]=e;f=d+-1|0;if(f){Y9a(a,c,1);c=(k[g>>2]|0)+20|0;d=f>>1;if(!d)e=1;else{e=1;do{Y9a(a,c,1);e=e<<1;c=c+1|0;d=d>>1}while((d|0)!=0)}}else e=0;Y9a(a,c,0);if((e|0)>=(1<<l[a+152+h>>0]>>1|0)){if((e|0)>(1<<l[a+168+h>>0]>>1|0))k[i>>2]=(k[i>>2]|0)+8}else k[i>>2]=0;d=c+14|0;c=e>>1;if(c|0)do{Y9a(a,d,(c&f|0)!=0&1);c=c>>1}while((c|0)!=0)}else{Y9a(a,c,0);k[i>>2]=0}c=k[u>>2]|0;if(c|0){p=k[m+24>>2]|0;o=c;while(1){if(j[q+(k[s+(o<<2)>>2]<<1)>>1]|0){x=25;break}d=o+-1|0;if(!d){d=0;break}else o=d}if((x|0)==25){x=0;if((o|0)>0){m=w+140+(p<<2)|0;n=a+184+p|0;d=0;do{f=(k[m>>2]|0)+(d*3|0)|0;Y9a(a,f,0);c=d+1|0;g=j[q+(k[s+(c<<2)>>2]<<1)>>1]|0;e=g<<16>>16;h=f+1|0;if(!(g<<16>>16)){e=h;while(1){Y9a(a,e,0);i=f;f=f+3|0;d=c+1|0;g=j[q+(k[s+(d<<2)>>2]<<1)>>1]|0;e=i+4|0;if(g<<16>>16)break;else c=d}i=c;h=e;e=g<<16>>16}else{i=d;d=c}Y9a(a,h,1);if(g<<16>>16>0)Y9a(a,v,0);else{Y9a(a,v,1);e=0-e|0}c=f+2|0;g=e+-1|0;if(g){Y9a(a,c,1);if((g|0)!=1){Y9a(a,c,1);c=(k[m>>2]|0)+((i|0)<(l[n>>0]|0)?189:217)|0;e=g>>2;if(!e)f=2;else{f=2;do{Y9a(a,c,1);f=f<<1;c=c+1|0;e=e>>1}while((e|0)!=0)}}else f=1}else f=0;Y9a(a,c,0);e=c+14|0;c=f>>1;if(c|0)do{Y9a(a,e,(c&g|0)!=0&1);c=c>>1}while((c|0)!=0)}while((d|0)<(o|0));c=k[u>>2]|0}else d=0}if((d|0)<(c|0))Y9a(a,(k[w+140+(p<<2)>>2]|0)+(d*3|0)|0,1)}r=r+1|0}while((r|0)<(k[t>>2]|0));return 1}function X9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;l=k[a+424>>2]|0;R9a(a);c=a+24|0;d=k[c>>2]|0;h=k[d>>2]|0;k[d>>2]=h+1;i[h>>0]=-1;h=d+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}c=k[c>>2]|0;h=k[c>>2]|0;k[c>>2]=h+1;i[h>>0]=b+208;h=c+4|0;j=(k[h>>2]|0)+-1|0;k[h>>2]=j;if((j|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}d=a+292|0;if((k[d>>2]|0)<=0){a=l+12|0;k[a>>2]=0;a=l+16|0;k[a>>2]=65536;a=l+20|0;k[a>>2]=0;a=l+24|0;k[a>>2]=0;a=l+28|0;k[a>>2]=11;l=l+32|0;k[l>>2]=-1;return}b=a+364|0;e=a+372|0;f=a+368|0;c=0;do{g=k[a+296+(c<<2)>>2]|0;if((k[b>>2]|0)==0?(k[e>>2]|0)==0:0){h=k[l+76+(k[g+20>>2]<<2)>>2]|0;j=h+64|0;do{i[h>>0]=0;h=h+1|0}while((h|0)<(j|0));k[l+36+(c<<2)>>2]=0;k[l+52+(c<<2)>>2]=0}if(k[f>>2]|0)zpb(k[l+140+(k[g+24>>2]<<2)>>2]|0,0,256)|0;c=c+1|0}while((c|0)<(k[d>>2]|0));a=l+12|0;k[a>>2]=0;a=l+16|0;k[a>>2]=65536;a=l+20|0;k[a>>2]=0;a=l+24|0;k[a>>2]=0;a=l+28|0;k[a>>2]=11;l=l+32|0;k[l>>2]=-1;return}function Y9a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;j=k[a+424>>2]|0;g=l[b>>0]|0;h=k[155568+((g&127)<<2)>>2]|0;d=h>>>8;e=h>>16;o=j+16|0;f=(k[o>>2]|0)-e|0;k[o>>2]=f;if((g>>>7|0)==(c|0)){if((f|0)>32767)return;if((f|0)<(e|0)){n=j+12|0;k[n>>2]=(k[n>>2]|0)+f;k[o>>2]=e}d=g&128^d}else{if((f|0)>=(e|0)){n=j+12|0;k[n>>2]=(k[n>>2]|0)+f;k[o>>2]=e}d=g&128^h}i[b>>0]=d;g=j+12|0;h=j+28|0;b=j+32|0;m=j+24|0;n=a+24|0;c=j+20|0;f=k[o>>2]|0;d=k[g>>2]|0;e=k[h>>2]|0;do{f=f<<1;k[o>>2]=f;d=d<<1;k[g>>2]=d;e=e+-1|0;k[h>>2]=e;if(!e){f=d>>19;do if((f|0)>255){d=k[b>>2]|0;if((d|0)>-1){if(k[m>>2]|0){do{d=k[n>>2]|0;e=k[d>>2]|0;k[d>>2]=e+1;i[e>>0]=0;e=d+4|0;j=(k[e>>2]|0)+-1|0;k[e>>2]=j;if((j|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}j=(k[m>>2]|0)+-1|0;k[m>>2]=j}while((j|0)!=0);d=k[b>>2]|0}e=k[n>>2]|0;j=k[e>>2]|0;k[e>>2]=j+1;i[j>>0]=d+1;d=e+4|0;j=(k[d>>2]|0)+-1|0;k[d>>2]=j;if((j|0)==0?(Xh[k[e+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}if(((k[b>>2]|0)==254?(p=k[n>>2]|0,e=k[p>>2]|0,k[p>>2]=e+1,i[e>>0]=0,e=p+4|0,j=(k[e>>2]|0)+-1|0,k[e>>2]=j,(j|0)==0):0)?(Xh[k[p+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}}k[m>>2]=(k[m>>2]|0)+(k[c>>2]|0);k[c>>2]=0;k[b>>2]=f&255}else{if((f|0)==255){k[c>>2]=(k[c>>2]|0)+1;break}d=k[b>>2]|0;if(d){if((d|0)>-1){if(k[m>>2]|0){do{d=k[n>>2]|0;e=k[d>>2]|0;k[d>>2]=e+1;i[e>>0]=0;e=d+4|0;j=(k[e>>2]|0)+-1|0;k[e>>2]=j;if((j|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}j=(k[m>>2]|0)+-1|0;k[m>>2]=j}while((j|0)!=0);d=k[b>>2]|0}e=k[n>>2]|0;j=k[e>>2]|0;k[e>>2]=j+1;i[j>>0]=d;d=e+4|0;j=(k[d>>2]|0)+-1|0;k[d>>2]=j;if((j|0)==0?(Xh[k[e+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}}}else k[m>>2]=(k[m>>2]|0)+1;if(k[c>>2]|0){if(k[m>>2]|0)do{d=k[n>>2]|0;e=k[d>>2]|0;k[d>>2]=e+1;i[e>>0]=0;e=d+4|0;j=(k[e>>2]|0)+-1|0;k[e>>2]=j;if((j|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}j=(k[m>>2]|0)+-1|0;k[m>>2]=j}while((j|0)!=0);do{d=k[n>>2]|0;e=k[d>>2]|0;k[d>>2]=e+1;i[e>>0]=-1;e=d+4|0;j=(k[e>>2]|0)+-1|0;k[e>>2]=j;if((j|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}d=k[n>>2]|0;e=k[d>>2]|0;k[d>>2]=e+1;i[e>>0]=0;e=d+4|0;j=(k[e>>2]|0)+-1|0;k[e>>2]=j;if((j|0)==0?(Xh[k[d+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}j=(k[c>>2]|0)+-1|0;k[c>>2]=j}while((j|0)!=0)}k[b>>2]=f&255}while(0);d=k[g>>2]&524287;k[g>>2]=d;e=(k[h>>2]|0)+8|0;k[h>>2]=e;f=k[o>>2]|0}}while((f|0)<32768);return}function Z9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=a+4|0;c=ci[k[k[f>>2]>>2]&255](a,1,104)|0;k[a+404>>2]=c;k[c>>2]=847;if(!b){f=ci[k[(k[f>>2]|0)+4>>2]&255](a,1,1280)|0;k[c+24>>2]=f;k[c+28>>2]=f+128;k[c+32>>2]=f+256;k[c+36>>2]=f+384;k[c+40>>2]=f+512;k[c+44>>2]=f+640;k[c+48>>2]=f+768;k[c+52>>2]=f+896;k[c+56>>2]=f+1024;k[c+60>>2]=f+1152;k[c+64>>2]=0;return}e=a+76|0;if((k[e>>2]|0)<=0)return;d=c+64|0;b=0;c=k[a+84>>2]|0;while(1){i=k[c+8>>2]|0;j=(k[c+28>>2]|0)+-1+i|0;g=k[c+12>>2]|0;h=(k[c+32>>2]|0)+-1+g|0;g=Sf[k[(k[f>>2]|0)+20>>2]&127](a,1,0,j-((j|0)%(i|0)|0)|0,h-((h|0)%(g|0)|0)|0,g)|0;k[d+(b<<2)>>2]=g;b=b+1|0;if((b|0)>=(k[e>>2]|0))break;else c=c+88|0}return}function _9a(a,b){a=a|0;b=b|0;var c=0,d=0;d=k[a+404>>2]|0;k[d+8>>2]=0;do if((k[a+292>>2]|0)<=1){c=k[a+296>>2]|0;if((k[a+288>>2]|0)==1){k[d+20>>2]=k[c+76>>2];break}else{k[d+20>>2]=k[c+12>>2];break}}else k[d+20>>2]=1;while(0);k[d+12>>2]=0;k[d+16>>2]=0;switch(b|0){case 0:{if(k[d+64>>2]|0){c=k[a>>2]|0;k[c+20>>2]=3;Uh[k[c>>2]&2047](a)}k[d+4>>2]=280;return}case 3:{if(!(k[d+64>>2]|0)){c=k[a>>2]|0;k[c+20>>2]=3;Uh[k[c>>2]&2047](a)}k[d+4>>2]=281;return}case 2:{if(!(k[d+64>>2]|0)){c=k[a>>2]|0;k[c+20>>2]=3;Uh[k[c>>2]&2047](a)}k[d+4>>2]=282;return}default:{d=k[a>>2]|0;k[d+20>>2]=3;Uh[k[d>>2]&2047](a);return}}}function $9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;K=a+404|0;d=k[K>>2]|0;F=(k[a+312>>2]|0)+-1|0;L=a+288|0;I=(k[L>>2]|0)+-1|0;z=d+16|0;f=k[z>>2]|0;A=d+20|0;g=k[A>>2]|0;do if((f|0)<(g|0)){B=d+12|0;e=a+292|0;C=a+420|0;c=d+8|0;D=a+424|0;E=d+24|0;h=g;g=k[B>>2]|0;a:while(1){if(g>>>0>F>>>0)g=h;else{do{i=k[e>>2]|0;if((i|0)>0)if(g>>>0<F>>>0){h=0;y=0;do{q=k[a+296+(y<<2)>>2]|0;r=q+4|0;s=k[(k[C>>2]|0)+4+(k[r>>2]<<2)>>2]|0;t=q+56|0;u=k[t>>2]|0;v=aa(k[q+68>>2]|0,g)|0;w=q+40|0;x=q+60|0;if((k[x>>2]|0)>0){p=q+76|0;n=aa(k[w>>2]|0,f)|0;o=0;i=u;while(1){if((k[c>>2]|0)>>>0>=I>>>0?(o+f|0)>=(k[p>>2]|0):0){zpb(k[d+24+(h<<2)>>2]|0,0,i<<7|0)|0;l=k[t>>2]|0;if((l|0)>0){m=k[d+24+(h+-1<<2)>>2]|0;i=0;do{j[k[d+24+(i+h<<2)>>2]>>1]=j[m>>1]|0;i=i+1|0}while((i|0)!=(l|0))}}else J=14;if(((J|0)==14?(J=0,Eh[s&127](a,q,k[b+(k[r>>2]<<2)>>2]|0,k[d+24+(h<<2)>>2]|0,n,v,u),G=k[t>>2]|0,(G|0)>(u|0)):0)?(zpb(k[d+24+(h+u<<2)>>2]|0,0,G-u<<7|0)|0,H=k[t>>2]|0,(u|0)<(H|0)):0){i=u;do{m=i+h|0;j[k[d+24+(m<<2)>>2]>>1]=j[k[d+24+(m+-1<<2)>>2]>>1]|0;i=i+1|0}while((i|0)!=(H|0))}i=k[t>>2]|0;h=i+h|0;o=o+1|0;if((o|0)>=(k[x>>2]|0))break;else n=(k[w>>2]|0)+n|0}i=k[e>>2]|0}y=y+1|0}while((y|0)<(i|0))}else{h=0;y=0;do{w=k[a+296+(y<<2)>>2]|0;x=w+4|0;q=k[(k[C>>2]|0)+4+(k[x>>2]<<2)>>2]|0;r=w+56|0;s=k[w+72>>2]|0;t=aa(k[w+68>>2]|0,g)|0;u=w+40|0;v=w+60|0;if((k[v>>2]|0)>0){p=w+76|0;n=aa(k[u>>2]|0,f)|0;o=0;while(1){if((k[c>>2]|0)>>>0>=I>>>0?(o+f|0)>=(k[p>>2]|0):0){zpb(k[d+24+(h<<2)>>2]|0,0,k[r>>2]<<7|0)|0;i=k[r>>2]|0;if((i|0)>0){m=k[d+24+(h+-1<<2)>>2]|0;l=0;do{j[k[d+24+(l+h<<2)>>2]>>1]=j[m>>1]|0;l=l+1|0}while((l|0)!=(i|0))}}else{Eh[q&127](a,w,k[b+(k[x>>2]<<2)>>2]|0,k[d+24+(h<<2)>>2]|0,n,t,s);i=k[r>>2]|0;if((i|0)>(s|0)){zpb(k[d+24+(h+s<<2)>>2]|0,0,i-s<<7|0)|0;i=k[r>>2]|0;if((s|0)<(i|0)){l=s;do{m=l+h|0;j[k[d+24+(m<<2)>>2]>>1]=j[k[d+24+(m+-1<<2)>>2]>>1]|0;l=l+1|0}while((l|0)!=(i|0))}}}h=i+h|0;o=o+1|0;if((o|0)>=(k[v>>2]|0))break;else n=(k[u>>2]|0)+n|0}i=k[e>>2]|0}y=y+1|0}while((y|0)<(i|0))}if(!(Hh[k[(k[D>>2]|0)+4>>2]&511](a,E)|0))break a;g=g+1|0}while(g>>>0<=F>>>0);g=k[A>>2]|0}k[B>>2]=0;f=f+1|0;if((f|0)<(g|0)){h=g;g=0}else{J=38;break}}if((J|0)==38){d=k[K>>2]|0;break}k[z>>2]=f;k[B>>2]=g;L=0;return L|0}else{e=a+292|0;c=d+8|0}while(0);k[c>>2]=(k[c>>2]|0)+1;do if((k[e>>2]|0)<=1){c=k[a+296>>2]|0;if((k[d+8>>2]|0)>>>0<((k[L>>2]|0)+-1|0)>>>0){k[d+20>>2]=k[c+12>>2];break}else{k[d+20>>2]=k[c+76>>2];break}}else k[d+20>>2]=1;while(0);k[d+12>>2]=0;k[d+16>>2]=0;L=1;return L|0}function aab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;x=k[a+404>>2]|0;y=(k[a+288>>2]|0)+-1|0;B=a+76|0;if((k[B>>2]|0)<=0){B=bab(a,b)|0;return B|0}s=a+4|0;t=x+8|0;u=a+420|0;q=k[a+84>>2]|0;r=0;while(1){v=q+12|0;w=k[v>>2]|0;p=aa(w,k[t>>2]|0)|0;w=$g[k[(k[s>>2]|0)+32>>2]&127](a,k[x+64+(r<<2)>>2]|0,p,w,1)|0;if((k[t>>2]|0)>>>0<y>>>0)c=k[v>>2]|0;else{p=k[v>>2]|0;c=((k[q+32>>2]|0)>>>0)%(p>>>0)|0;c=(c|0)==0?p:c}l=k[q+28>>2]|0;p=k[q+8>>2]|0;i=(l>>>0)%(p>>>0)|0;i=(i|0)>0?p-i|0:i;m=k[(k[u>>2]|0)+4+(r<<2)>>2]|0;a:do if((c|0)>0){n=b+(r<<2)|0;o=q+40|0;f=i<<7;if((i|0)>0)d=0;else{d=0;while(1){h=aa(k[o>>2]|0,d)|0;Eh[m&127](a,q,k[n>>2]|0,k[w+(d<<2)>>2]|0,h,0,l);d=d+1|0;if((d|0)==(c|0))break a}}do{g=k[w+(d<<2)>>2]|0;h=aa(k[o>>2]|0,d)|0;Eh[m&127](a,q,k[n>>2]|0,g,h,0,l);g=g+(l<<7)|0;zpb(g|0,0,f|0)|0;h=j[g+-128>>1]|0;e=0;do{j[g+(e<<7)>>1]=h;e=e+1|0}while((e|0)!=(i|0));d=d+1|0}while((d|0)!=(c|0))}while(0);b:do if((k[t>>2]|0)==(y|0)?(z=i+l|0,A=(z>>>0)/(p>>>0)|0,(c|0)<(k[v>>2]|0)):0){m=z<<7;i=p+-1|0;l=(p|0)>0;if(p>>>0>z>>>0)while(1){zpb(k[w+(c<<2)>>2]|0,0,m|0)|0;c=c+1|0;if((c|0)>=(k[v>>2]|0))break b}do{d=k[w+(c<<2)>>2]|0;e=k[w+(c+-1<<2)>>2]|0;zpb(d|0,0,m|0)|0;if(l){h=0;while(1){g=j[e+(i<<7)>>1]|0;f=0;do{j[d+(f<<7)>>1]=g;f=f+1|0}while((f|0)!=(p|0));h=h+1|0;if(h>>>0>=A>>>0)break;else{d=d+(p<<7)|0;e=e+(p<<7)|0}}}c=c+1|0}while((c|0)<(k[v>>2]|0))}while(0);r=r+1|0;if((r|0)>=(k[B>>2]|0))break;else q=q+88|0}B=bab(a,b)|0;return B|0}function bab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+16|0;x=D;z=a+404|0;A=k[z>>2]|0;y=a+292|0;b=k[y>>2]|0;if((b|0)>0){d=a+4|0;e=A+8|0;c=0;do{v=k[a+296+(c<<2)>>2]|0;b=k[v+12>>2]|0;w=aa(b,k[e>>2]|0)|0;b=$g[k[(k[d>>2]|0)+32>>2]&127](a,k[A+64+(k[v+4>>2]<<2)>>2]|0,w,b,0)|0;k[x+(c<<2)>>2]=b;c=c+1|0;b=k[y>>2]|0}while((c|0)<(b|0))}v=A+16|0;c=k[v>>2]|0;w=A+20|0;d=k[w>>2]|0;do if((c|0)<(d|0)){q=A+12|0;s=a+312|0;t=a+424|0;u=A+24|0;e=d;b=k[q>>2]|0;d=k[s>>2]|0;a:while(1){if(b>>>0<d>>>0){do{p=k[y>>2]|0;if((p|0)>0){d=0;o=0;do{m=k[a+296+(o<<2)>>2]|0;j=k[m+56>>2]|0;l=aa(j,b)|0;m=k[m+60>>2]|0;if((m|0)>0?(B=k[x+(o<<2)>>2]|0,(j|0)>0):0){n=aa(j,m)|0;e=0;h=d;while(1){f=0;g=(k[B+(e+c<<2)>>2]|0)+(l<<7)|0;i=h;while(1){k[A+24+(i<<2)>>2]=g;f=f+1|0;if((f|0)==(j|0))break;else{g=g+128|0;i=i+1|0}}e=e+1|0;if((e|0)==(m|0))break;else h=j+h|0}d=d+n|0}o=o+1|0}while((o|0)!=(p|0))}if(!(Hh[k[(k[t>>2]|0)+4>>2]&511](a,u)|0))break a;b=b+1|0;d=k[s>>2]|0}while(b>>>0<d>>>0);b=k[w>>2]|0}else b=e;k[q>>2]=0;c=c+1|0;if((c|0)<(b|0)){e=b;b=0}else{C=21;break}}if((C|0)==21){b=k[y>>2]|0;break}k[v>>2]=c;k[q>>2]=b;a=0;r=D;return a|0}while(0);c=A+8|0;k[c>>2]=(k[c>>2]|0)+1;c=k[z>>2]|0;do if((b|0)<=1){b=k[a+296>>2]|0;if((k[c+8>>2]|0)>>>0<((k[a+288>>2]|0)+-1|0)>>>0){k[c+20>>2]=k[b+12>>2];break}else{k[c+20>>2]=k[b+76>>2];break}}else k[c+20>>2]=1;while(0);k[c+12>>2]=0;k[c+16>>2]=0;a=1;r=D;return a|0}function cab(a){a=a|0;return}function dab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;j=k[a+36>>2]|0;h=k[a+28>>2]|0;if((e|0)<1|(h|0)==0)return;while(1){g=k[(k[c>>2]|0)+(d<<2)>>2]|0;a=0;f=k[b>>2]|0;while(1){i[g+a>>0]=i[f>>0]|0;a=a+1|0;if((a|0)==(h|0))break;else f=f+j|0}if((e|0)>1){d=d+1|0;b=b+4|0;e=e+-1|0}else break}return}function eab(a){a=a|0;var b=0,c=0;c=k[a+412>>2]|0;b=ci[k[k[a+4>>2]>>2]&255](a,1,8192)|0;k[c+8>>2]=b;a=0;do{k[b+(a<<2)>>2]=a*19595;k[b+(a+256<<2)>>2]=a*38470;k[b+(a+512<<2)>>2]=(a*7471|0)+32768;c=aa(a,-11059)|0;k[b+(a+768<<2)>>2]=c;c=aa(a,-21709)|0;k[b+(a+1024<<2)>>2]=c;k[b+(a+1280<<2)>>2]=(a<<15)+8421375;c=aa(a,-27439)|0;k[b+(a+1536<<2)>>2]=c;c=aa(a,-5329)|0;k[b+(a+1792<<2)>>2]=c;a=a+1|0}while((a|0)!=256);return}function fab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;j=k[(k[a+412>>2]|0)+8>>2]|0;h=k[a+28>>2]|0;if((e|0)<1|(h|0)==0)return;while(1){g=k[(k[c>>2]|0)+(d<<2)>>2]|0;a=0;f=k[b>>2]|0;while(1){i[g+a>>0]=((k[j+((l[f+1>>0]|0|256)<<2)>>2]|0)+(k[j+((l[f>>0]|0)<<2)>>2]|0)+(k[j+((l[f+2>>0]|0|512)<<2)>>2]|0)|0)>>>16;a=a+1|0;if((a|0)==(h|0))break;else f=f+3|0}if((e|0)>1){d=d+1|0;b=b+4|0;e=e+-1|0}else break}return}function gab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0;l=k[a+28>>2]|0;if((e|0)<=0)return;m=c+4|0;n=c+8|0;if(!l)return;while(1){g=k[(k[c>>2]|0)+(d<<2)>>2]|0;h=k[(k[m>>2]|0)+(d<<2)>>2]|0;j=k[(k[n>>2]|0)+(d<<2)>>2]|0;a=0;f=k[b>>2]|0;while(1){i[g+a>>0]=i[f>>0]|0;i[h+a>>0]=i[f+1>>0]|0;i[j+a>>0]=i[f+2>>0]|0;a=a+1|0;if((a|0)==(l|0))break;else f=f+3|0}if((e|0)>1){d=d+1|0;b=b+4|0;e=e+-1|0}else break}return}function hab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0;m=k[a+28>>2]|0;if((e|0)<=0)return;n=c+4|0;o=c+8|0;if(!m)return;while(1){g=k[(k[c>>2]|0)+(d<<2)>>2]|0;h=k[(k[n>>2]|0)+(d<<2)>>2]|0;j=k[(k[o>>2]|0)+(d<<2)>>2]|0;a=0;f=k[b>>2]|0;while(1){r=i[f+1>>0]|0;q=r&255;p=l[f+2>>0]|0;i[g+a>>0]=(l[f>>0]|0)+128-q;i[h+a>>0]=r;i[j+a>>0]=128-q+p;a=a+1|0;if((a|0)==(m|0))break;else f=f+3|0}if((e|0)>1){d=d+1|0;b=b+4|0;e=e+-1|0}else break}return}function iab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;p=k[(k[a+412>>2]|0)+8>>2]|0;m=k[a+28>>2]|0;if((e|0)<=0)return;n=c+4|0;o=c+8|0;if(!m)return;while(1){g=k[(k[c>>2]|0)+(d<<2)>>2]|0;h=k[(k[n>>2]|0)+(d<<2)>>2]|0;j=k[(k[o>>2]|0)+(d<<2)>>2]|0;a=0;f=k[b>>2]|0;while(1){r=l[f>>0]|0;s=l[f+1>>0]|0;q=l[f+2>>0]|0;i[g+a>>0]=((k[p+((s|256)<<2)>>2]|0)+(k[p+(r<<2)>>2]|0)+(k[p+((q|512)<<2)>>2]|0)|0)>>>16;i[h+a>>0]=((k[p+((s|1024)<<2)>>2]|0)+(k[p+((r|768)<<2)>>2]|0)+(k[p+((q|1280)<<2)>>2]|0)|0)>>>16;i[j+a>>0]=((k[p+((s|1536)<<2)>>2]|0)+(k[p+((r|1280)<<2)>>2]|0)+(k[p+((q|1792)<<2)>>2]|0)|0)>>>16;a=a+1|0;if((a|0)==(m|0))break;else f=f+3|0}if((e|0)>1){d=d+1|0;b=b+4|0;e=e+-1|0}else break}return}function jab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=k[a+76>>2]|0;m=k[a+28>>2]|0;if((e|0)<=0)return;l=(m|0)==0;if((n|0)<=0)return;while(1){j=e;e=e+-1|0;if(!l){h=0;do{a=0;f=k[(k[c+(h<<2)>>2]|0)+(d<<2)>>2]|0;g=(k[b>>2]|0)+h|0;while(1){i[f>>0]=i[g>>0]|0;a=a+1|0;if((a|0)==(m|0))break;else{f=f+1|0;g=g+n|0}}h=h+1|0}while((h|0)!=(n|0))}if((j|0)<=1)break;else{d=d+1|0;b=b+4|0}}return}function kab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;r=k[(k[a+412>>2]|0)+8>>2]|0;n=k[a+28>>2]|0;if((e|0)<=0)return;o=c+4|0;p=c+8|0;q=c+12|0;if(!n)return;while(1){g=k[(k[c>>2]|0)+(d<<2)>>2]|0;h=k[(k[o>>2]|0)+(d<<2)>>2]|0;j=k[(k[p>>2]|0)+(d<<2)>>2]|0;m=k[(k[q>>2]|0)+(d<<2)>>2]|0;a=0;f=k[b>>2]|0;while(1){t=(l[f>>0]|0)^255;u=(l[f+1>>0]|0)^255;s=(l[f+2>>0]|0)^255;i[m+a>>0]=i[f+3>>0]|0;i[g+a>>0]=((k[r+((u|256)<<2)>>2]|0)+(k[r+(t<<2)>>2]|0)+(k[r+((s|512)<<2)>>2]|0)|0)>>>16;i[h+a>>0]=((k[r+((u|1024)<<2)>>2]|0)+(k[r+((t|768)<<2)>>2]|0)+(k[r+((s|1280)<<2)>>2]|0)|0)>>>16;i[j+a>>0]=((k[r+((u|1536)<<2)>>2]|0)+(k[r+((t|1280)<<2)>>2]|0)+(k[r+((s|1792)<<2)>>2]|0)|0)>>>16;a=a+1|0;if((a|0)==(n|0))break;else f=f+4|0}if((e|0)>1){d=d+1|0;b=b+4|0;e=e+-1|0}else break}return}function lab(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,q=0,r=0,s=0,t=0.0,u=0;i=k[a+420>>2]|0;l=a+76|0;if((k[l>>2]|0)<=0)return;q=a+4|0;r=a+232|0;g=0;b=0;h=k[a+84>>2]|0;while(1){c=k[h+36>>2]|0;d=h+40|0;a:do switch((c<<8)+(k[d>>2]|0)|0){case 257:{k[i+44+(g<<2)>>2]=351;b=0;break}case 514:{k[i+44+(g<<2)>>2]=352;b=0;break}case 771:{k[i+44+(g<<2)>>2]=353;b=0;break}case 1028:{k[i+44+(g<<2)>>2]=354;b=0;break}case 1285:{k[i+44+(g<<2)>>2]=355;b=0;break}case 1542:{k[i+44+(g<<2)>>2]=356;b=0;break}case 1799:{k[i+44+(g<<2)>>2]=357;b=0;break}case 2313:{k[i+44+(g<<2)>>2]=358;b=0;break}case 2570:{k[i+44+(g<<2)>>2]=359;b=0;break}case 2827:{k[i+44+(g<<2)>>2]=360;b=0;break}case 3084:{k[i+44+(g<<2)>>2]=361;b=0;break}case 3341:{k[i+44+(g<<2)>>2]=362;b=0;break}case 3598:{k[i+44+(g<<2)>>2]=363;b=0;break}case 3855:{k[i+44+(g<<2)>>2]=364;b=0;break}case 4112:{k[i+44+(g<<2)>>2]=365;b=0;break}case 4104:{k[i+44+(g<<2)>>2]=366;b=0;break}case 3591:{k[i+44+(g<<2)>>2]=367;b=0;break}case 3078:{k[i+44+(g<<2)>>2]=368;b=0;break}case 2565:{k[i+44+(g<<2)>>2]=369;b=0;break}case 2052:{k[i+44+(g<<2)>>2]=370;b=0;break}case 1539:{k[i+44+(g<<2)>>2]=371;b=0;break}case 1026:{k[i+44+(g<<2)>>2]=372;b=0;break}case 513:{k[i+44+(g<<2)>>2]=373;b=0;break}case 2064:{k[i+44+(g<<2)>>2]=374;b=0;break}case 1806:{k[i+44+(g<<2)>>2]=375;b=0;break}case 1548:{k[i+44+(g<<2)>>2]=376;b=0;break}case 1290:{k[i+44+(g<<2)>>2]=377;b=0;break}case 1032:{k[i+44+(g<<2)>>2]=378;b=0;break}case 774:{k[i+44+(g<<2)>>2]=379;b=0;break}case 516:{k[i+44+(g<<2)>>2]=380;b=0;break}case 258:{k[i+44+(g<<2)>>2]=381;b=0;break}case 2056:switch(k[r>>2]|0){case 0:{k[i+44+(g<<2)>>2]=382;b=0;break a}case 1:{k[i+44+(g<<2)>>2]=383;b=1;break a}case 2:{k[i+100+(g<<2)>>2]=384;b=2;break a}default:{f=k[a>>2]|0;k[f+20>>2]=49;Uh[k[f>>2]&2047](a);break a}}default:{f=k[a>>2]|0;k[f+20>>2]=7;k[f+24>>2]=c;k[f+28>>2]=k[d>>2];Uh[k[f>>2]&2047](a)}}while(0);d=k[h+16>>2]|0;c=a+88+(d<<2)|0;if(d>>>0<=3?(n=k[c>>2]|0,(n|0)!=0):0)f=n;else{f=k[a>>2]|0;k[f+20>>2]=54;k[f+24>>2]=d;Uh[k[f>>2]&2047](a);f=k[c>>2]|0}switch(b|0){case 0:{c=i+84+(d<<2)|0;d=k[c>>2]|0;if(!d){d=ci[k[k[q>>2]>>2]&255](a,1,256)|0;k[c>>2]=d}c=0;do{k[d+(c<<2)>>2]=m[f+(c<<1)>>1]<<3;c=c+1|0}while((c|0)!=64);k[i+4+(g<<2)>>2]=103;break}case 1:{c=i+84+(d<<2)|0;d=k[c>>2]|0;if(!d){d=ci[k[k[q>>2]>>2]&255](a,1,256)|0;k[c>>2]=d}c=0;do{e=(aa(j[172800+(c<<1)>>1]|0,m[f+(c<<1)>>1]|0)|0)+1024>>11;k[d+(c<<2)>>2]=e;c=c+1|0}while((c|0)!=64);k[i+4+(g<<2)>>2]=103;break}case 2:{c=i+140+(d<<2)|0;d=k[c>>2]|0;if(!d){d=ci[k[k[q>>2]>>2]&255](a,1,256)|0;k[c>>2]=d}c=0;e=0;while(1){t=+p[23032+(c<<3)>>3];o[d+(e<<2)>>2]=1.0/(+(m[f+(e<<1)>>1]|0)*t*8.0);s=e|1;o[d+(s<<2)>>2]=1.0/(+(m[f+(s<<1)>>1]|0)*t*1.387039845*8.0);s=s+1|0;o[d+(s<<2)>>2]=1.0/(+(m[f+(s<<1)>>1]|0)*t*1.306562965*8.0);s=e|3;o[d+(s<<2)>>2]=1.0/(+(m[f+(s<<1)>>1]|0)*t*1.175875602*8.0);u=s+1|0;o[d+(u<<2)>>2]=1.0/(+(m[f+(u<<1)>>1]|0)*t*8.0);u=s+2|0;o[d+(u<<2)>>2]=1.0/(+(m[f+(u<<1)>>1]|0)*t*.785694958*8.0);s=s+3|0;o[d+(s<<2)>>2]=1.0/(+(m[f+(s<<1)>>1]|0)*t*.5411961*8.0);s=e|7;o[d+(s<<2)>>2]=1.0/(+(m[f+(s<<1)>>1]|0)*t*.275899379*8.0);c=c+1|0;if((c|0)==8)break;else e=e+8|0}k[i+4+(g<<2)>>2]=104;break}default:{u=k[a>>2]|0;k[u+20>>2]=49;Uh[k[u>>2]&2047](a)}}g=g+1|0;if((g|0)>=(k[l>>2]|0))break;else h=h+88|0}return}function mab(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+256|0;o=p;n=k[a+420>>2]|0;m=k[n+44+(k[b+4>>2]<<2)>>2]|0;n=k[n+84+(k[b+16>>2]<<2)>>2]|0;l=c+(e<<2)|0;if(!g){r=p;return}i=b+36|0;b=0;while(1){Ph[m&511](o,l,f);h=0;do{e=k[n+(h<<2)>>2]|0;a=k[o+(h<<2)>>2]|0;c=e>>1;if((a|0)>=0){a=a+c|0;if((a|0)<(e|0))a=0;else a=(a|0)/(e|0)|0}else{a=c-a|0;if((a|0)<(e|0))a=0;else a=(a|0)/(e|0)|0;a=0-a|0}j[d+(b<<7)+(h<<1)>>1]=a;h=h+1|0}while((h|0)!=64);b=b+1|0;if((b|0)==(g|0))break;else f=(k[i>>2]|0)+f|0}r=p;return}function nab(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,l=0,m=0,n=0;n=r;r=r+256|0;m=n;l=k[a+420>>2]|0;i=k[l+100+(k[b+4>>2]<<2)>>2]|0;l=k[l+140+(k[b+16>>2]<<2)>>2]|0;h=c+(e<<2)|0;if(!g){r=n;return}b=b+36|0;a=f;c=0;while(1){Ph[i&511](m,h,a);e=0;do{j[d+(c<<7)+(e<<1)>>1]=~~(+o[m+(e<<2)>>2]*+o[l+(e<<2)>>2]+16384.5)+49152;e=e+1|0}while((e|0)!=64);c=c+1|0;if((c|0)==(g|0))break;else a=(k[b>>2]|0)+a|0}r=n;return}function oab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=k[a+424>>2]|0;d=(b|0)!=0;k[l+8>>2]=d?1521:1520;do if(!(k[a+268>>2]|0)){b=l+4|0;if(d){k[b>>2]=287;break}else{k[b>>2]=288;break}}else{k[l+120>>2]=a;k[l+108>>2]=b;b=(k[a+364>>2]|0)==0;c=l+4|0;do if(!(k[a+372>>2]|0))if(b){k[c>>2]=283;break}else{k[c>>2]=284;break}else{if(b){k[c>>2]=285;break}k[c>>2]=286;b=l+136|0;if(!(k[b>>2]|0)){j=ci[k[k[a+4>>2]>>2]&255](a,1,1e3)|0;k[b>>2]=j}}while(0);k[l+124>>2]=k[(k[a+296>>2]|0)+24>>2];k[l+128>>2]=0;k[l+132>>2]=0}while(0);g=a+292|0;if((k[g>>2]|0)<=0){j=l+12|0;k[j>>2]=0;j=l+16|0;k[j>>2]=0;j=a+236|0;j=k[j>>2]|0;a=l+36|0;k[a>>2]=j;l=l+40|0;k[l>>2]=0;return}h=a+364|0;i=a+372|0;f=a+4|0;j=a+368|0;if(d)e=0;else{b=0;do{c=k[a+296+(b<<2)>>2]|0;if((k[h>>2]|0)==0?(k[i>>2]|0)==0:0){f=k[c+20>>2]|0;xab(a,1,f,l+44+(f<<2)|0);k[l+20+(b<<2)>>2]=0}if(k[j>>2]|0){f=k[c+24>>2]|0;xab(a,0,f,l+60+(f<<2)|0)}b=b+1|0}while((b|0)<(k[g>>2]|0));j=l+12|0;k[j>>2]=0;j=l+16|0;k[j>>2]=0;j=a+236|0;j=k[j>>2]|0;a=l+36|0;k[a>>2]=j;l=l+40|0;k[l>>2]=0;return}do{d=k[a+296+(e<<2)>>2]|0;if((k[h>>2]|0)==0?(k[i>>2]|0)==0:0){b=k[d+20>>2]|0;if(b>>>0>3){c=k[a>>2]|0;k[c+20>>2]=52;k[c+24>>2]=b;Uh[k[c>>2]&2047](a)}c=l+76+(b<<2)|0;b=k[c>>2]|0;if(!b){b=ci[k[k[f>>2]>>2]&255](a,1,1028)|0;k[c>>2]=b}zpb(b|0,0,1028)|0;k[l+20+(e<<2)>>2]=0}if(k[j>>2]|0){b=k[d+24>>2]|0;if(b>>>0>3){d=k[a>>2]|0;k[d+20>>2]=52;k[d+24>>2]=b;Uh[k[d>>2]&2047](a)}c=l+92+(b<<2)|0;b=k[c>>2]|0;if(!b){b=ci[k[k[f>>2]>>2]&255](a,1,1028)|0;k[c>>2]=b}zpb(b|0,0,1028)|0}e=e+1|0}while((e|0)<(k[g>>2]|0));j=l+12|0;k[j>>2]=0;j=l+16|0;k[j>>2]=0;j=a+236|0;j=k[j>>2]|0;a=l+36|0;k[a>>2]=j;l=l+40|0;k[l>>2]=0;return}function pab(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;A=r;r=r+32|0;t=A+16|0;u=A;z=k[a+424>>2]|0;if(k[a+268>>2]|0?(q=z+128|0,b=k[q>>2]|0,b|0):0){o=0;while(1){b=b>>1;if(!b)break;else o=o+1|0}if((o|0)>14){s=k[z+120>>2]|0;n=k[s>>2]|0;k[n+20>>2]=41;Uh[k[n>>2]&2047](s)}b=k[z+124>>2]|0;c=o<<4;s=z+108|0;do if(!(k[s>>2]|0)){m=k[z+60+(b<<2)>>2]|0;d=k[m+(c<<2)>>2]|0;m=i[m+1024+c>>0]|0;c=m<<24>>24;n=z+16|0;b=k[n>>2]|0;if(m<<24>>24==0?(m=k[z+120>>2]|0,j=k[m>>2]|0,k[j+20>>2]=41,Uh[k[j>>2]&2047](m),k[s>>2]|0):0)break;b=b+c|0;m=z+12|0;c=k[m>>2]|((1<<c)+-1&d)<<24-b;if((b|0)>7){g=z+112|0;h=z+116|0;j=z+120|0;f=b;do{B=c>>>16;d=B&255;e=k[g>>2]|0;k[g>>2]=e+1;i[e>>0]=B;e=(k[h>>2]|0)+-1|0;k[h>>2]=e;if(!e){B=k[j>>2]|0;e=k[B+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](B)|0)){B=k[j>>2]|0;C=k[B>>2]|0;k[C+20>>2]=25;Uh[k[C>>2]&2047](B)}k[g>>2]=k[e>>2];k[h>>2]=k[e+4>>2]}if((d|0)==255?(C=k[g>>2]|0,k[g>>2]=C+1,i[C>>0]=0,C=(k[h>>2]|0)+-1|0,k[h>>2]=C,(C|0)==0):0){C=k[j>>2]|0;d=k[C+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](C)|0)){C=k[j>>2]|0;B=k[C>>2]|0;k[B+20>>2]=25;Uh[k[B>>2]&2047](C)}k[g>>2]=k[d>>2];k[h>>2]=k[d+4>>2]}c=c<<8;f=f+-8|0}while((f|0)>7);b=b&7}k[m>>2]=c;k[n>>2]=b}else{C=(k[z+92+(b<<2)>>2]|0)+(c<<2)|0;k[C>>2]=(k[C>>2]|0)+1}while(0);if(o|0?(p=z+16|0,(k[s>>2]|0)==0):0){b=(k[p>>2]|0)+o|0;m=z+12|0;c=(k[q>>2]&(1<<o)+-1)<<24-b|k[m>>2];if((b|0)>7){g=z+112|0;h=z+116|0;j=z+120|0;f=b;do{B=c>>>16;d=B&255;C=k[g>>2]|0;k[g>>2]=C+1;i[C>>0]=B;C=(k[h>>2]|0)+-1|0;k[h>>2]=C;if(!C){C=k[j>>2]|0;e=k[C+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](C)|0)){C=k[j>>2]|0;B=k[C>>2]|0;k[B+20>>2]=25;Uh[k[B>>2]&2047](C)}k[g>>2]=k[e>>2];k[h>>2]=k[e+4>>2]}if((d|0)==255?(C=k[g>>2]|0,k[g>>2]=C+1,i[C>>0]=0,C=(k[h>>2]|0)+-1|0,k[h>>2]=C,(C|0)==0):0){C=k[j>>2]|0;d=k[C+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](C)|0)){C=k[j>>2]|0;B=k[C>>2]|0;k[B+20>>2]=25;Uh[k[B>>2]&2047](C)}k[g>>2]=k[d>>2];k[h>>2]=k[d+4>>2]}c=c<<8;f=f+-8|0}while((f|0)>7);b=b&7}k[m>>2]=c;k[p>>2]=b}k[q>>2]=0;j=z+132|0;b=k[j>>2]|0;a:do if((b|0)!=0&(k[s>>2]|0)==0){m=z+16|0;n=z+12|0;o=z+112|0;p=z+116|0;q=z+120|0;h=k[z+136>>2]|0;c=0;while(1){if(!c){d=k[m>>2]|0;c=d+1|0;d=((l[h>>0]|0)&1)<<23-d|k[n>>2];if((c|0)>7){g=c;do{B=d>>>16;e=B&255;C=k[o>>2]|0;k[o>>2]=C+1;i[C>>0]=B;C=(k[p>>2]|0)+-1|0;k[p>>2]=C;if(!C){C=k[q>>2]|0;f=k[C+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](C)|0)){C=k[q>>2]|0;B=k[C>>2]|0;k[B+20>>2]=25;Uh[k[B>>2]&2047](C)}k[o>>2]=k[f>>2];k[p>>2]=k[f+4>>2]}if((e|0)==255?(C=k[o>>2]|0,k[o>>2]=C+1,i[C>>0]=0,C=(k[p>>2]|0)+-1|0,k[p>>2]=C,(C|0)==0):0){C=k[q>>2]|0;e=k[C+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](C)|0)){C=k[q>>2]|0;B=k[C>>2]|0;k[B+20>>2]=25;Uh[k[B>>2]&2047](C)}k[o>>2]=k[e>>2];k[p>>2]=k[e+4>>2]}d=d<<8;g=g+-8|0}while((g|0)>7);c=c&7}k[n>>2]=d;k[m>>2]=c}b=b+-1|0;if(!b)break a;h=h+1|0;c=k[s>>2]|0}}while(0);k[j>>2]=0};k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;f=a+292|0;if((k[f>>2]|0)<=0){r=A;return}g=a+364|0;h=a+372|0;j=a+368|0;m=a+4|0;e=0;do{d=k[a+296+(e<<2)>>2]|0;if(((k[g>>2]|0)==0?(k[h>>2]|0)==0:0)?(v=k[d+20>>2]|0,w=t+(v<<2)|0,(k[w>>2]|0)==0):0){c=a+120+(v<<2)|0;b=k[c>>2]|0;if(!b){b=ci[k[k[m>>2]>>2]&255](a,0,280)|0;k[b+276>>2]=0;k[c>>2]=b}Aab(a,b,k[z+76+(v<<2)>>2]|0);k[w>>2]=1}if(k[j>>2]|0?(x=k[d+24>>2]|0,y=u+(x<<2)|0,(k[y>>2]|0)==0):0){c=a+136+(x<<2)|0;b=k[c>>2]|0;if(!b){b=ci[k[k[m>>2]>>2]&255](a,0,280)|0;k[b+276>>2]=0;k[c>>2]=b}Aab(a,b,k[z+92+(x<<2)>>2]|0);k[y>>2]=1}e=e+1|0}while((e|0)<(k[f>>2]|0));r=A;return}function qab(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;u=r;r=r+16|0;o=u;s=k[a+424>>2]|0;t=a+24|0;c=k[t>>2]|0;b=k[c>>2]|0;if(!(k[a+268>>2]|0)){e=k[c+4>>2]|0;m=s+12|0;d=k[m>>2]|0;n=s+16|0;c=k[n>>2]|0;j=s+20|0;k[o>>2]=k[j>>2];k[o+4>>2]=k[j+4>>2];k[o+8>>2]=k[j+8>>2];k[o+12>>2]=k[j+12>>2];a:do if((c|0)>0){g=c+7|0;h=127<<17-c|d;while(1){q=h>>>16;f=q&255;s=b;b=s+1|0;i[s>>0]=q;e=e+-1|0;if(!e){e=k[t>>2]|0;if(!(Xh[k[e+12>>2]&1023](a)|0))break;b=k[e>>2]|0;e=k[e+4>>2]|0}if((f|0)==255){s=b;b=s+1|0;i[s>>0]=0;e=e+-1|0;if(!e){e=k[t>>2]|0;if(!(Xh[k[e+12>>2]&1023](a)|0))break;b=k[e>>2]|0;e=k[e+4>>2]|0}}g=g+-8|0;if((g|0)<=7){d=0;c=0;break a}else h=h<<8}e=k[a>>2]|0;k[e+20>>2]=25;Uh[k[e>>2]&2047](a);e=0}else{d=0;c=0}while(0);t=k[t>>2]|0;k[t>>2]=b;k[t+4>>2]=e;k[m>>2]=d;k[n>>2]=c;k[j>>2]=k[o>>2];k[j+4>>2]=k[o+4>>2];k[j+8>>2]=k[o+8>>2];k[j+12>>2]=k[o+12>>2];r=u;return}q=s+112|0;k[q>>2]=b;p=s+116|0;k[p>>2]=k[c+4>>2];m=s+128|0;b=k[m>>2]|0;if(b|0){j=0;while(1){b=b>>1;if(!b)break;else j=j+1|0}if((j|0)>14){o=k[s+120>>2]|0;a=k[o>>2]|0;k[a+20>>2]=41;Uh[k[a>>2]&2047](o)}b=k[s+124>>2]|0;c=j<<4;o=s+108|0;do if(!(k[o>>2]|0)){h=k[s+60+(b<<2)>>2]|0;d=k[h+(c<<2)>>2]|0;h=i[h+1024+c>>0]|0;c=h<<24>>24;a=s+16|0;b=k[a>>2]|0;if(h<<24>>24==0?(h=k[s+120>>2]|0,g=k[h>>2]|0,k[g+20>>2]=41,Uh[k[g>>2]&2047](h),k[o>>2]|0):0)break;b=b+c|0;h=s+12|0;c=k[h>>2]|((1<<c)+-1&d)<<24-b;if((b|0)>7){g=s+120|0;f=b;do{v=c>>>16;d=v&255;e=k[q>>2]|0;k[q>>2]=e+1;i[e>>0]=v;e=(k[p>>2]|0)+-1|0;k[p>>2]=e;if(!e){v=k[g>>2]|0;e=k[v+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](v)|0)){v=k[g>>2]|0;w=k[v>>2]|0;k[w+20>>2]=25;Uh[k[w>>2]&2047](v)}k[q>>2]=k[e>>2];k[p>>2]=k[e+4>>2]}if((d|0)==255?(w=k[q>>2]|0,k[q>>2]=w+1,i[w>>0]=0,w=(k[p>>2]|0)+-1|0,k[p>>2]=w,(w|0)==0):0){w=k[g>>2]|0;d=k[w+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](w)|0)){w=k[g>>2]|0;v=k[w>>2]|0;k[v+20>>2]=25;Uh[k[v>>2]&2047](w)}k[q>>2]=k[d>>2];k[p>>2]=k[d+4>>2]}c=c<<8;f=f+-8|0}while((f|0)>7);b=b&7}k[h>>2]=c;k[a>>2]=b}else{w=(k[s+92+(b<<2)>>2]|0)+(c<<2)|0;k[w>>2]=(k[w>>2]|0)+1}while(0);if(j|0?(n=s+16|0,(k[o>>2]|0)==0):0){b=(k[n>>2]|0)+j|0;h=s+12|0;c=(k[m>>2]&(1<<j)+-1)<<24-b|k[h>>2];if((b|0)>7){g=s+120|0;f=b;do{v=c>>>16;d=v&255;w=k[q>>2]|0;k[q>>2]=w+1;i[w>>0]=v;w=(k[p>>2]|0)+-1|0;k[p>>2]=w;if(!w){w=k[g>>2]|0;e=k[w+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](w)|0)){w=k[g>>2]|0;v=k[w>>2]|0;k[v+20>>2]=25;Uh[k[v>>2]&2047](w)}k[q>>2]=k[e>>2];k[p>>2]=k[e+4>>2]}if((d|0)==255?(w=k[q>>2]|0,k[q>>2]=w+1,i[w>>0]=0,w=(k[p>>2]|0)+-1|0,k[p>>2]=w,(w|0)==0):0){w=k[g>>2]|0;d=k[w+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](w)|0)){w=k[g>>2]|0;v=k[w>>2]|0;k[v+20>>2]=25;Uh[k[v>>2]&2047](w)}k[q>>2]=k[d>>2];k[p>>2]=k[d+4>>2]}c=c<<8;f=f+-8|0}while((f|0)>7);b=b&7}k[h>>2]=c;k[n>>2]=b}k[m>>2]=0;a=s+132|0;b=k[a>>2]|0;b:do if((b|0)!=0&(k[o>>2]|0)==0){j=s+16|0;m=s+12|0;n=s+120|0;h=k[s+136>>2]|0;c=0;while(1){if(!c){d=k[j>>2]|0;c=d+1|0;d=((l[h>>0]|0)&1)<<23-d|k[m>>2];if((c|0)>7){g=c;do{v=d>>>16;e=v&255;w=k[q>>2]|0;k[q>>2]=w+1;i[w>>0]=v;w=(k[p>>2]|0)+-1|0;k[p>>2]=w;if(!w){w=k[n>>2]|0;f=k[w+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](w)|0)){w=k[n>>2]|0;v=k[w>>2]|0;k[v+20>>2]=25;Uh[k[v>>2]&2047](w)}k[q>>2]=k[f>>2];k[p>>2]=k[f+4>>2]}if((e|0)==255?(w=k[q>>2]|0,k[q>>2]=w+1,i[w>>0]=0,w=(k[p>>2]|0)+-1|0,k[p>>2]=w,(w|0)==0):0){w=k[n>>2]|0;e=k[w+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](w)|0)){w=k[n>>2]|0;v=k[w>>2]|0;k[v+20>>2]=25;Uh[k[v>>2]&2047](w)}k[q>>2]=k[e>>2];k[p>>2]=k[e+4>>2]}d=d<<8;g=g+-8|0}while((g|0)>7);c=c&7}k[m>>2]=d;k[j>>2]=c}b=b+-1|0;if(!b)break b;h=h+1|0;c=k[o>>2]|0}}while(0);k[a>>2]=0}zab(s);w=k[t>>2]|0;k[w>>2]=k[q>>2];k[w+4>>2]=k[p>>2];r=u;return}function rab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;x=k[a+424>>2]|0;u=k[a+376>>2]|0;v=a+24|0;o=k[v>>2]|0;w=x+112|0;k[w>>2]=k[o>>2];n=x+116|0;k[n>>2]=k[o+4>>2];o=a+236|0;if(k[o>>2]|0?(k[x+36>>2]|0)==0:0)yab(x,k[x+40>>2]|0);p=a+320|0;if((k[p>>2]|0)>0){q=x+108|0;r=x+16|0;s=x+120|0;t=x+12|0;m=0;do{l=k[a+324+(m<<2)>>2]|0;f=k[a+296+(l<<2)>>2]|0;h=j[k[b+(m<<2)>>2]>>1]>>u;l=x+20+(l<<2)|0;c=h-(k[l>>2]|0)|0;k[l>>2]=h;l=(c>>31)+c|0;c=(c|0)<0?0-c|0:c;if(c){e=0;while(1){d=e+1|0;c=c>>1;if(!c)break;else e=d}if((e|0)>10){h=k[a>>2]|0;k[h+20>>2]=6;Uh[k[h>>2]&2047](a);h=d}else h=d}else h=0;c=k[f+20>>2]|0;do if(!(k[q>>2]|0)){g=k[x+44+(c<<2)>>2]|0;d=k[g+(h<<2)>>2]|0;g=i[g+1024+h>>0]|0;e=g<<24>>24;c=k[r>>2]|0;if(g<<24>>24==0?(g=k[s>>2]|0,f=k[g>>2]|0,k[f+20>>2]=41,Uh[k[f>>2]&2047](g),k[q>>2]|0):0)break;c=c+e|0;d=k[t>>2]|((1<<e)+-1&d)<<24-c;if((c|0)>7){g=c;do{y=d>>>16;e=y&255;f=k[w>>2]|0;k[w>>2]=f+1;i[f>>0]=y;f=(k[n>>2]|0)+-1|0;k[n>>2]=f;if(!f){y=k[s>>2]|0;f=k[y+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](y)|0)){y=k[s>>2]|0;z=k[y>>2]|0;k[z+20>>2]=25;Uh[k[z>>2]&2047](y)}k[w>>2]=k[f>>2];k[n>>2]=k[f+4>>2]}if((e|0)==255?(z=k[w>>2]|0,k[w>>2]=z+1,i[z>>0]=0,z=(k[n>>2]|0)+-1|0,k[n>>2]=z,(z|0)==0):0){z=k[s>>2]|0;e=k[z+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](z)|0)){z=k[s>>2]|0;y=k[z>>2]|0;k[y+20>>2]=25;Uh[k[y>>2]&2047](z)}k[w>>2]=k[e>>2];k[n>>2]=k[e+4>>2]}d=d<<8;g=g+-8|0}while((g|0)>7);c=c&7}k[t>>2]=d;k[r>>2]=c}else{z=(k[x+76+(c<<2)>>2]|0)+(h<<2)|0;k[z>>2]=(k[z>>2]|0)+1}while(0);if(h|0?(k[q>>2]|0)==0:0){c=(k[r>>2]|0)+h|0;d=((1<<h)+-1&l)<<24-c|k[t>>2];if((c|0)>7){g=c;do{y=d>>>16;e=y&255;z=k[w>>2]|0;k[w>>2]=z+1;i[z>>0]=y;z=(k[n>>2]|0)+-1|0;k[n>>2]=z;if(!z){z=k[s>>2]|0;f=k[z+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](z)|0)){z=k[s>>2]|0;y=k[z>>2]|0;k[y+20>>2]=25;Uh[k[y>>2]&2047](z)}k[w>>2]=k[f>>2];k[n>>2]=k[f+4>>2]}if((e|0)==255?(z=k[w>>2]|0,k[w>>2]=z+1,i[z>>0]=0,z=(k[n>>2]|0)+-1|0,k[n>>2]=z,(z|0)==0):0){z=k[s>>2]|0;e=k[z+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](z)|0)){z=k[s>>2]|0;y=k[z>>2]|0;k[y+20>>2]=25;Uh[k[y>>2]&2047](z)}k[w>>2]=k[e>>2];k[n>>2]=k[e+4>>2]}d=d<<8;g=g+-8|0}while((g|0)>7);c=c&7}k[t>>2]=d;k[r>>2]=c}m=m+1|0}while((m|0)<(k[p>>2]|0))}c=k[v>>2]|0;k[c>>2]=k[w>>2];k[c+4>>2]=k[n>>2];c=k[o>>2]|0;if(!c)return 1;e=x+36|0;d=k[e>>2]|0;if(!d){k[e>>2]=c;z=x+40|0;k[z>>2]=(k[z>>2]|0)+1&7}else c=d;k[e>>2]=c+-1;return 1}function sab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;H=k[a+424>>2]|0;E=a+24|0;D=k[E>>2]|0;F=H+112|0;k[F>>2]=k[D>>2];C=H+116|0;k[C>>2]=k[D+4>>2];D=a+236|0;if(k[D>>2]|0?(k[H+36>>2]|0)==0:0)yab(H,k[H+40>>2]|0);s=k[a+368>>2]|0;t=k[a+376>>2]|0;u=k[a+384>>2]|0;q=k[b>>2]|0;c=k[a+364>>2]|0;if((c|0)<=(s|0)){v=H+128|0;r=H+124|0;x=H+108|0;y=H+16|0;z=H+120|0;A=H+12|0;w=H+136|0;B=H+132|0;b=0;while(1){d=j[q+(k[u+(c<<2)>>2]<<1)>>1]|0;e=d<<16>>16;do if(!(d<<16>>16))b=b+1|0;else{if(d<<16>>16<0){p=0-e>>t;d=p;p=~p}else{p=e>>t;d=p}if(!d){b=b+1|0;break}e=k[v>>2]|0;if(e|0){n=0;while(1){e=e>>1;if(!e)break;else n=n+1|0}if((n|0)>14){o=k[z>>2]|0;m=k[o>>2]|0;k[m+20>>2]=41;Uh[k[m>>2]&2047](o)}e=k[r>>2]|0;f=n<<4;do if(!(k[x>>2]|0)){o=k[H+60+(e<<2)>>2]|0;g=k[o+(f<<2)>>2]|0;o=i[o+1024+f>>0]|0;f=o<<24>>24;e=k[y>>2]|0;if(o<<24>>24==0?(o=k[z>>2]|0,m=k[o>>2]|0,k[m+20>>2]=41,Uh[k[m>>2]&2047](o),k[x>>2]|0):0)break;e=e+f|0;f=k[A>>2]|((1<<f)+-1&g)<<24-e;if((e|0)>7){m=e;do{g=f>>>16;h=g&255;o=k[F>>2]|0;k[F>>2]=o+1;i[o>>0]=g;o=(k[C>>2]|0)+-1|0;k[C>>2]=o;if(!o){o=k[z>>2]|0;g=k[o+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](o)|0)){o=k[z>>2]|0;I=k[o>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](o)}k[F>>2]=k[g>>2];k[C>>2]=k[g+4>>2]}do if((h|0)==255){I=k[F>>2]|0;k[F>>2]=I+1;i[I>>0]=0;I=(k[C>>2]|0)+-1|0;k[C>>2]=I;if(I|0)break;I=k[z>>2]|0;g=k[I+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](I)|0)){I=k[z>>2]|0;o=k[I>>2]|0;k[o+20>>2]=25;Uh[k[o>>2]&2047](I)}k[F>>2]=k[g>>2];k[C>>2]=k[g+4>>2]}while(0);f=f<<8;m=m+-8|0}while((m|0)>7);e=e&7}k[A>>2]=f;k[y>>2]=e}else{I=(k[H+92+(e<<2)>>2]|0)+(f<<2)|0;k[I>>2]=(k[I>>2]|0)+1}while(0);if(n|0?(k[x>>2]|0)==0:0){e=(k[y>>2]|0)+n|0;f=(k[v>>2]&(1<<n)+-1)<<24-e|k[A>>2];if((e|0)>7){m=e;do{o=f>>>16;g=o&255;I=k[F>>2]|0;k[F>>2]=I+1;i[I>>0]=o;I=(k[C>>2]|0)+-1|0;k[C>>2]=I;if(!I){I=k[z>>2]|0;h=k[I+24>>2]|0;if(!(Xh[k[h+12>>2]&1023](I)|0)){I=k[z>>2]|0;o=k[I>>2]|0;k[o+20>>2]=25;Uh[k[o>>2]&2047](I)}k[F>>2]=k[h>>2];k[C>>2]=k[h+4>>2]}do if((g|0)==255){I=k[F>>2]|0;k[F>>2]=I+1;i[I>>0]=0;I=(k[C>>2]|0)+-1|0;k[C>>2]=I;if(I|0)break;I=k[z>>2]|0;g=k[I+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](I)|0)){I=k[z>>2]|0;o=k[I>>2]|0;k[o+20>>2]=25;Uh[k[o>>2]&2047](I)}k[F>>2]=k[g>>2];k[C>>2]=k[g+4>>2]}while(0);f=f<<8;m=m+-8|0}while((m|0)>7);e=e&7}k[A>>2]=f;k[y>>2]=e}k[v>>2]=0;e=k[B>>2]|0;a:do if((e|0)!=0&(k[x>>2]|0)==0){o=k[w>>2]|0;f=0;while(1){if(!f){g=k[y>>2]|0;f=g+1|0;g=((l[o>>0]|0)&1)<<23-g|k[A>>2];if((f|0)>7){n=f;do{m=g>>>16;h=m&255;I=k[F>>2]|0;k[F>>2]=I+1;i[I>>0]=m;I=(k[C>>2]|0)+-1|0;k[C>>2]=I;if(!I){I=k[z>>2]|0;m=k[I+24>>2]|0;if(!(Xh[k[m+12>>2]&1023](I)|0)){I=k[z>>2]|0;J=k[I>>2]|0;k[J+20>>2]=25;Uh[k[J>>2]&2047](I)}k[F>>2]=k[m>>2];k[C>>2]=k[m+4>>2]}do if((h|0)==255){J=k[F>>2]|0;k[F>>2]=J+1;i[J>>0]=0;J=(k[C>>2]|0)+-1|0;k[C>>2]=J;if(J|0)break;J=k[z>>2]|0;h=k[J+24>>2]|0;if(!(Xh[k[h+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[h>>2];k[C>>2]=k[h+4>>2]}while(0);g=g<<8;n=n+-8|0}while((n|0)>7);f=f&7}k[A>>2]=g;k[y>>2]=f}e=e+-1|0;if(!e)break a;o=o+1|0;f=k[x>>2]|0}}while(0);k[B>>2]=0}if((b|0)>15){n=b;do{e=k[r>>2]|0;do if(!(k[x>>2]|0)){J=k[H+60+(e<<2)>>2]|0;f=k[J+960>>2]|0;J=i[J+1264>>0]|0;g=J<<24>>24;e=k[y>>2]|0;if(J<<24>>24==0?(J=k[z>>2]|0,I=k[J>>2]|0,k[I+20>>2]=41,Uh[k[I>>2]&2047](J),k[x>>2]|0):0)break;e=e+g|0;f=k[A>>2]|((1<<g)+-1&f)<<24-e;if((e|0)>7){m=e;do{I=f>>>16;g=I&255;J=k[F>>2]|0;k[F>>2]=J+1;i[J>>0]=I;J=(k[C>>2]|0)+-1|0;k[C>>2]=J;if(!J){J=k[z>>2]|0;h=k[J+24>>2]|0;if(!(Xh[k[h+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[h>>2];k[C>>2]=k[h+4>>2]}do if((g|0)==255){J=k[F>>2]|0;k[F>>2]=J+1;i[J>>0]=0;J=(k[C>>2]|0)+-1|0;k[C>>2]=J;if(J|0)break;J=k[z>>2]|0;g=k[J+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[g>>2];k[C>>2]=k[g+4>>2]}while(0);f=f<<8;m=m+-8|0}while((m|0)>7);e=e&7}k[A>>2]=f;k[y>>2]=e}else{J=(k[H+92+(e<<2)>>2]|0)+960|0;k[J>>2]=(k[J>>2]|0)+1}while(0);n=n+-16|0}while((n|0)>15);b=b&15}h=1;while(1){d=d>>1;if(!d)break;else h=h+1|0}if((h|0)>10){J=k[a>>2]|0;k[J+20>>2]=6;Uh[k[J>>2]&2047](a)}d=k[r>>2]|0;b=h+(b<<4)|0;if(k[x>>2]|0){b=(k[H+92+(d<<2)>>2]|0)+(b<<2)|0;k[b>>2]=(k[b>>2]|0)+1;b=0;break}J=k[H+60+(d<<2)>>2]|0;e=k[J+(b<<2)>>2]|0;J=i[J+1024+b>>0]|0;d=J<<24>>24;b=k[y>>2]|0;if(J<<24>>24==0?(J=k[z>>2]|0,I=k[J>>2]|0,k[I+20>>2]=41,Uh[k[I>>2]&2047](J),k[x>>2]|0):0){b=0;break}b=b+d|0;d=k[A>>2]|((1<<d)+-1&e)<<24-b;if((b|0)>7){g=b;do{I=d>>>16;e=I&255;J=k[F>>2]|0;k[F>>2]=J+1;i[J>>0]=I;J=(k[C>>2]|0)+-1|0;k[C>>2]=J;if(!J){J=k[z>>2]|0;f=k[J+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[f>>2];k[C>>2]=k[f+4>>2]}if((e|0)==255?(J=k[F>>2]|0,k[F>>2]=J+1,i[J>>0]=0,J=(k[C>>2]|0)+-1|0,k[C>>2]=J,(J|0)==0):0){J=k[z>>2]|0;e=k[J+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[e>>2];k[C>>2]=k[e+4>>2]}d=d<<8;g=g+-8|0}while((g|0)>7);b=b&7;J=k[x>>2]|0;k[A>>2]=d;k[y>>2]=b;if(J){b=0;break}}else{k[A>>2]=d;k[y>>2]=b}b=b+h|0;d=((1<<h)+-1&p)<<24-b|d;if((b|0)>7){g=b;do{I=d>>>16;e=I&255;J=k[F>>2]|0;k[F>>2]=J+1;i[J>>0]=I;J=(k[C>>2]|0)+-1|0;k[C>>2]=J;if(!J){J=k[z>>2]|0;f=k[J+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[f>>2];k[C>>2]=k[f+4>>2]}do if((e|0)==255){J=k[F>>2]|0;k[F>>2]=J+1;i[J>>0]=0;J=(k[C>>2]|0)+-1|0;k[C>>2]=J;if(J|0)break;J=k[z>>2]|0;e=k[J+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[e>>2];k[C>>2]=k[e+4>>2]}while(0);d=d<<8;g=g+-8|0}while((g|0)>7);b=b&7}k[A>>2]=d;k[y>>2]=b;b=0}while(0);if((c|0)<(s|0))c=c+1|0;else break}if((b|0)>0?(J=(k[v>>2]|0)+1|0,k[v>>2]=J,(J|0)==32767):0){b=k[r>>2]|0;b:do if(!(k[x>>2]|0)){J=k[H+60+(b<<2)>>2]|0;c=k[J+896>>2]|0;J=i[J+1248>>0]|0;d=J<<24>>24;b=k[y>>2]|0;if(J<<24>>24==0?(J=k[z>>2]|0,I=k[J>>2]|0,k[I+20>>2]=41,Uh[k[I>>2]&2047](J),k[x>>2]|0):0){G=154;break}f=b+d|0;b=k[A>>2]|((1<<d)+-1&c)<<24-f;if((f|0)>7){e=f;do{I=b>>>16;c=I&255;J=k[F>>2]|0;k[F>>2]=J+1;i[J>>0]=I;J=(k[C>>2]|0)+-1|0;k[C>>2]=J;if(!J){J=k[z>>2]|0;d=k[J+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[d>>2];k[C>>2]=k[d+4>>2]}if((c|0)==255?(J=k[F>>2]|0,k[F>>2]=J+1,i[J>>0]=0,J=(k[C>>2]|0)+-1|0,k[C>>2]=J,(J|0)==0):0){J=k[z>>2]|0;c=k[J+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[c>>2];k[C>>2]=k[c+4>>2]}b=b<<8;e=e+-8|0}while((e|0)>7);J=k[x>>2]|0;k[A>>2]=b;k[y>>2]=f&7;if(J|0){G=154;break}}else{k[A>>2]=b;k[y>>2]=f}c=k[y>>2]|0;b=c+14|0;c=(k[v>>2]&16383)<<10-c|k[A>>2];if((b|0)>7){f=b;do{I=c>>>16;d=I&255;J=k[F>>2]|0;k[F>>2]=J+1;i[J>>0]=I;J=(k[C>>2]|0)+-1|0;k[C>>2]=J;if(!J){J=k[z>>2]|0;e=k[J+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[e>>2];k[C>>2]=k[e+4>>2]}if((d|0)==255?(J=k[F>>2]|0,k[F>>2]=J+1,i[J>>0]=0,J=(k[C>>2]|0)+-1|0,k[C>>2]=J,(J|0)==0):0){J=k[z>>2]|0;d=k[J+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[d>>2];k[C>>2]=k[d+4>>2]}c=c<<8;f=f+-8|0}while((f|0)>7);b=b&7;d=k[x>>2]|0}else d=0;k[A>>2]=c;k[y>>2]=b;k[v>>2]=0;b=k[B>>2]|0;if((b|0)!=0&(d|0)==0){h=k[w>>2]|0;c=0;while(1){if(!c){d=k[y>>2]|0;c=d+1|0;d=((l[h>>0]|0)&1)<<23-d|k[A>>2];if((c|0)>7){g=c;do{I=d>>>16;e=I&255;J=k[F>>2]|0;k[F>>2]=J+1;i[J>>0]=I;J=(k[C>>2]|0)+-1|0;k[C>>2]=J;if(!J){J=k[z>>2]|0;f=k[J+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[f>>2];k[C>>2]=k[f+4>>2]}do if((e|0)==255){J=k[F>>2]|0;k[F>>2]=J+1;i[J>>0]=0;J=(k[C>>2]|0)+-1|0;k[C>>2]=J;if(J|0)break;J=k[z>>2]|0;e=k[J+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](J)|0)){J=k[z>>2]|0;I=k[J>>2]|0;k[I+20>>2]=25;Uh[k[I>>2]&2047](J)}k[F>>2]=k[e>>2];k[C>>2]=k[e+4>>2]}while(0);d=d<<8;g=g+-8|0}while((g|0)>7);c=c&7}k[A>>2]=d;k[y>>2]=c}b=b+-1|0;if(!b)break b;h=h+1|0;c=k[x>>2]|0}}}else{G=(k[H+92+(b<<2)>>2]|0)+896|0;k[G>>2]=(k[G>>2]|0)+1;G=154}while(0);if((G|0)==154)k[v>>2]=0;k[B>>2]=0}}b=k[E>>2]|0;k[b>>2]=k[F>>2];k[b+4>>2]=k[C>>2];b=k[D>>2]|0;if(!b)return 1;d=H+36|0;c=k[d>>2]|0;if(!c){k[d>>2]=b;J=H+40|0;k[J>>2]=(k[J>>2]|0)+1&7}else b=c;k[d>>2]=b+-1;return 1}function tab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;u=k[a+424>>2]|0;r=k[a+376>>2]|0;s=a+24|0;q=k[s>>2]|0;t=u+112|0;k[t>>2]=k[q>>2];p=u+116|0;k[p>>2]=k[q+4>>2];q=a+236|0;if(k[q>>2]|0?(k[u+36>>2]|0)==0:0)yab(u,k[u+40>>2]|0);h=a+320|0;a=k[h>>2]|0;if((a|0)>0){l=u+16|0;m=u+108|0;n=u+12|0;o=u+120|0;g=0;do{if(!(k[m>>2]|0)){d=k[l>>2]|0;c=d+1|0;d=((j[k[b+(g<<2)>>2]>>1]|0)>>>r&1)<<23-d|k[n>>2];if((c|0)>7){f=c;do{v=d>>>16;a=v&255;e=k[t>>2]|0;k[t>>2]=e+1;i[e>>0]=v;e=(k[p>>2]|0)+-1|0;k[p>>2]=e;if(!e){v=k[o>>2]|0;e=k[v+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](v)|0)){v=k[o>>2]|0;w=k[v>>2]|0;k[w+20>>2]=25;Uh[k[w>>2]&2047](v)}k[t>>2]=k[e>>2];k[p>>2]=k[e+4>>2]}if((a|0)==255?(w=k[t>>2]|0,k[t>>2]=w+1,i[w>>0]=0,w=(k[p>>2]|0)+-1|0,k[p>>2]=w,(w|0)==0):0){w=k[o>>2]|0;a=k[w+24>>2]|0;if(!(Xh[k[a+12>>2]&1023](w)|0)){w=k[o>>2]|0;v=k[w>>2]|0;k[v+20>>2]=25;Uh[k[v>>2]&2047](w)}k[t>>2]=k[a>>2];k[p>>2]=k[a+4>>2]}d=d<<8;f=f+-8|0}while((f|0)>7);c=c&7;a=k[h>>2]|0}k[n>>2]=d;k[l>>2]=c}g=g+1|0}while((g|0)<(a|0))}a=k[s>>2]|0;k[a>>2]=k[t>>2];k[a+4>>2]=k[p>>2];a=k[q>>2]|0;if(!a)return 1;d=u+36|0;c=k[d>>2]|0;if(!c){k[d>>2]=a;w=u+40|0;k[w>>2]=(k[w>>2]|0)+1&7}else a=c;k[d>>2]=a+-1;return 1}function uab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;O=r;r=r+256|0;D=O;N=k[a+424>>2]|0;L=a+24|0;K=k[L>>2]|0;M=N+112|0;k[M>>2]=k[K>>2];J=N+116|0;k[J>>2]=k[K+4>>2];K=a+236|0;if(k[K>>2]|0?(k[N+36>>2]|0)==0:0)yab(N,k[N+40>>2]|0);E=k[a+368>>2]|0;d=k[a+376>>2]|0;F=k[a+384>>2]|0;C=k[b>>2]|0;e=k[a+364>>2]|0;if((e|0)>(E|0)){a=0;b=0;p=N+136|0;s=N+132|0}else{b=e;A=0;while(1){z=j[C+(k[F+(b<<2)>>2]<<1)>>1]|0;B=z<<16>>16;B=(z<<16>>16<0?0-B|0:B)>>d;k[D+(b<<2)>>2]=B;A=(B|0)==1?b:A;if((b|0)>=(E|0))break;else b=b+1|0}B=N+136|0;s=N+132|0;u=N+128|0;v=N+124|0;w=N+108|0;x=N+16|0;y=N+120|0;z=N+12|0;a=0;b=0;d=(k[B>>2]|0)+(k[s>>2]|0)|0;t=e;while(1){q=k[D+(t<<2)>>2]|0;do if(!q)a=a+1|0;else{if((t|0)>(A|0)|(a|0)<16)p=d;else while(1){e=k[u>>2]|0;if(e|0){o=0;while(1){e=e>>1;if(!e)break;else o=o+1|0}if((o|0)>14){p=k[y>>2]|0;n=k[p>>2]|0;k[n+20>>2]=41;Uh[k[n>>2]&2047](p)}e=k[v>>2]|0;f=o<<4;do if(!(k[w>>2]|0)){p=k[N+60+(e<<2)>>2]|0;g=k[p+(f<<2)>>2]|0;p=i[p+1024+f>>0]|0;f=p<<24>>24;e=k[x>>2]|0;if(p<<24>>24==0?(p=k[y>>2]|0,n=k[p>>2]|0,k[n+20>>2]=41,Uh[k[n>>2]&2047](p),k[w>>2]|0):0)break;e=e+f|0;f=k[z>>2]|((1<<f)+-1&g)<<24-e;if((e|0)>7){n=e;do{h=f>>>16;g=h&255;p=k[M>>2]|0;k[M>>2]=p+1;i[p>>0]=h;p=(k[J>>2]|0)+-1|0;k[J>>2]=p;if(!p){p=k[y>>2]|0;h=k[p+24>>2]|0;if(!(Xh[k[h+12>>2]&1023](p)|0)){p=k[y>>2]|0;P=k[p>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](p)}k[M>>2]=k[h>>2];k[J>>2]=k[h+4>>2]}do if((g|0)==255){P=k[M>>2]|0;k[M>>2]=P+1;i[P>>0]=0;P=(k[J>>2]|0)+-1|0;k[J>>2]=P;if(P|0)break;P=k[y>>2]|0;g=k[P+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](P)|0)){P=k[y>>2]|0;p=k[P>>2]|0;k[p+20>>2]=25;Uh[k[p>>2]&2047](P)}k[M>>2]=k[g>>2];k[J>>2]=k[g+4>>2]}while(0);f=f<<8;n=n+-8|0}while((n|0)>7);e=e&7}k[z>>2]=f;k[x>>2]=e}else{P=(k[N+92+(e<<2)>>2]|0)+(f<<2)|0;k[P>>2]=(k[P>>2]|0)+1}while(0);if(o|0?(k[w>>2]|0)==0:0){e=(k[x>>2]|0)+o|0;f=(k[u>>2]&(1<<o)+-1)<<24-e|k[z>>2];if((e|0)>7){n=e;do{p=f>>>16;g=p&255;P=k[M>>2]|0;k[M>>2]=P+1;i[P>>0]=p;P=(k[J>>2]|0)+-1|0;k[J>>2]=P;if(!P){P=k[y>>2]|0;h=k[P+24>>2]|0;if(!(Xh[k[h+12>>2]&1023](P)|0)){P=k[y>>2]|0;p=k[P>>2]|0;k[p+20>>2]=25;Uh[k[p>>2]&2047](P)}k[M>>2]=k[h>>2];k[J>>2]=k[h+4>>2]}do if((g|0)==255){P=k[M>>2]|0;k[M>>2]=P+1;i[P>>0]=0;P=(k[J>>2]|0)+-1|0;k[J>>2]=P;if(P|0)break;P=k[y>>2]|0;g=k[P+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](P)|0)){P=k[y>>2]|0;p=k[P>>2]|0;k[p+20>>2]=25;Uh[k[p>>2]&2047](P)}k[M>>2]=k[g>>2];k[J>>2]=k[g+4>>2]}while(0);f=f<<8;n=n+-8|0}while((n|0)>7);e=e&7}k[z>>2]=f;k[x>>2]=e}k[u>>2]=0;e=k[s>>2]|0;a:do if((e|0)!=0&(k[w>>2]|0)==0){p=k[B>>2]|0;f=0;while(1){if(!f){g=k[x>>2]|0;f=g+1|0;g=((l[p>>0]|0)&1)<<23-g|k[z>>2];if((f|0)>7){o=f;do{n=g>>>16;h=n&255;P=k[M>>2]|0;k[M>>2]=P+1;i[P>>0]=n;P=(k[J>>2]|0)+-1|0;k[J>>2]=P;if(!P){P=k[y>>2]|0;n=k[P+24>>2]|0;if(!(Xh[k[n+12>>2]&1023](P)|0)){P=k[y>>2]|0;Q=k[P>>2]|0;k[Q+20>>2]=25;Uh[k[Q>>2]&2047](P)}k[M>>2]=k[n>>2];k[J>>2]=k[n+4>>2]}do if((h|0)==255){Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=0;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(Q|0)break;Q=k[y>>2]|0;h=k[Q+24>>2]|0;if(!(Xh[k[h+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[h>>2];k[J>>2]=k[h+4>>2]}while(0);g=g<<8;o=o+-8|0}while((o|0)>7);f=f&7}k[z>>2]=g;k[x>>2]=f}e=e+-1|0;if(!e)break a;p=p+1|0;f=k[w>>2]|0}}while(0);k[s>>2]=0}e=k[v>>2]|0;b:do if(!(k[w>>2]|0)){Q=k[N+60+(e<<2)>>2]|0;g=k[Q+960>>2]|0;Q=i[Q+1264>>0]|0;h=Q<<24>>24;e=k[x>>2]|0;if(Q<<24>>24==0?(Q=k[y>>2]|0,P=k[Q>>2]|0,k[P+20>>2]=41,Uh[k[P>>2]&2047](Q),k[w>>2]|0):0){G=82;break}f=e+h|0;e=k[z>>2]|((1<<h)+-1&g)<<24-f;if((f|0)>7){n=f;do{P=e>>>16;g=P&255;Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=P;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(!Q){Q=k[y>>2]|0;h=k[Q+24>>2]|0;if(!(Xh[k[h+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[h>>2];k[J>>2]=k[h+4>>2]}if((g|0)==255?(Q=k[M>>2]|0,k[M>>2]=Q+1,i[Q>>0]=0,Q=(k[J>>2]|0)+-1|0,k[J>>2]=Q,(Q|0)==0):0){Q=k[y>>2]|0;g=k[Q+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[g>>2];k[J>>2]=k[g+4>>2]}e=e<<8;n=n+-8|0}while((n|0)>7);f=f&7;g=k[w>>2]|0}else g=0;k[z>>2]=e;k[x>>2]=f;a=a+-16|0;if((b|0)!=0&(g|0)==0){g=0;while(1){if(!g){n=f+1|0;e=((l[d>>0]|0)&1)<<23-f|e;if((n|0)>7){h=n;do{P=e>>>16;f=P&255;Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=P;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(!Q){Q=k[y>>2]|0;g=k[Q+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[g>>2];k[J>>2]=k[g+4>>2]}do if((f|0)==255){Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=0;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(Q|0)break;Q=k[y>>2]|0;f=k[Q+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[f>>2];k[J>>2]=k[f+4>>2]}while(0);e=e<<8;h=h+-8|0}while((h|0)>7);f=n&7}else f=n;k[z>>2]=e;k[x>>2]=f}b=b+-1|0;if(!b)break b;d=d+1|0;g=k[w>>2]|0}}}else{G=(k[N+92+(e<<2)>>2]|0)+960|0;k[G>>2]=(k[G>>2]|0)+1;G=82}while(0);if((G|0)==82){G=0;a=a+-16|0}d=k[B>>2]|0;if((a|0)<16){b=0;p=d;break}else b=0}if((q|0)>1){i[p+b>>0]=q&1;b=b+1|0;d=p;break}d=k[u>>2]|0;if(d|0){n=0;while(1){d=d>>1;if(!d)break;else n=n+1|0}if((n|0)>14){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=41;Uh[k[P>>2]&2047](Q)}d=k[v>>2]|0;e=n<<4;do if(!(k[w>>2]|0)){Q=k[N+60+(d<<2)>>2]|0;f=k[Q+(e<<2)>>2]|0;Q=i[Q+1024+e>>0]|0;e=Q<<24>>24;d=k[x>>2]|0;if(Q<<24>>24==0?(Q=k[y>>2]|0,P=k[Q>>2]|0,k[P+20>>2]=41,Uh[k[P>>2]&2047](Q),k[w>>2]|0):0)break;d=d+e|0;e=k[z>>2]|((1<<e)+-1&f)<<24-d;if((d|0)>7){h=d;do{P=e>>>16;f=P&255;Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=P;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(!Q){Q=k[y>>2]|0;g=k[Q+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[g>>2];k[J>>2]=k[g+4>>2]}do if((f|0)==255){Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=0;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(Q|0)break;Q=k[y>>2]|0;f=k[Q+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[f>>2];k[J>>2]=k[f+4>>2]}while(0);e=e<<8;h=h+-8|0}while((h|0)>7);d=d&7}k[z>>2]=e;k[x>>2]=d}else{Q=(k[N+92+(d<<2)>>2]|0)+(e<<2)|0;k[Q>>2]=(k[Q>>2]|0)+1}while(0);if(n|0?(k[w>>2]|0)==0:0){d=(k[x>>2]|0)+n|0;e=(k[u>>2]&(1<<n)+-1)<<24-d|k[z>>2];if((d|0)>7){h=d;do{P=e>>>16;f=P&255;Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=P;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(!Q){Q=k[y>>2]|0;g=k[Q+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[g>>2];k[J>>2]=k[g+4>>2]}do if((f|0)==255){Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=0;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(Q|0)break;Q=k[y>>2]|0;f=k[Q+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[f>>2];k[J>>2]=k[f+4>>2]}while(0);e=e<<8;h=h+-8|0}while((h|0)>7);d=d&7}k[z>>2]=e;k[x>>2]=d}k[u>>2]=0;d=k[s>>2]|0;c:do if((d|0)!=0&(k[w>>2]|0)==0){o=k[B>>2]|0;e=0;while(1){if(!e){f=k[x>>2]|0;e=f+1|0;f=((l[o>>0]|0)&1)<<23-f|k[z>>2];if((e|0)>7){n=e;do{P=f>>>16;g=P&255;Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=P;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(!Q){Q=k[y>>2]|0;h=k[Q+24>>2]|0;if(!(Xh[k[h+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[h>>2];k[J>>2]=k[h+4>>2]}do if((g|0)==255){Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=0;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(Q|0)break;Q=k[y>>2]|0;g=k[Q+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[g>>2];k[J>>2]=k[g+4>>2]}while(0);f=f<<8;n=n+-8|0}while((n|0)>7);e=e&7}k[z>>2]=f;k[x>>2]=e}d=d+-1|0;if(!d)break c;o=o+1|0;e=k[w>>2]|0}}while(0);k[s>>2]=0}d=k[v>>2]|0;a=a<<4|1;d:do if(!(k[w>>2]|0)){Q=k[N+60+(d<<2)>>2]|0;e=k[Q+(a<<2)>>2]|0;Q=i[Q+1024+a>>0]|0;d=Q<<24>>24;a=k[x>>2]|0;if(Q<<24>>24==0?(Q=k[y>>2]|0,P=k[Q>>2]|0,k[P+20>>2]=41,Uh[k[P>>2]&2047](Q),k[w>>2]|0):0)break;a=a+d|0;e=k[z>>2]|((1<<d)+-1&e)<<24-a;if((a|0)>7){g=a;do{P=e>>>16;d=P&255;Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=P;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(!Q){Q=k[y>>2]|0;f=k[Q+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[f>>2];k[J>>2]=k[f+4>>2]}if((d|0)==255?(Q=k[M>>2]|0,k[M>>2]=Q+1,i[Q>>0]=0,Q=(k[J>>2]|0)+-1|0,k[J>>2]=Q,(Q|0)==0):0){Q=k[y>>2]|0;d=k[Q+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[d>>2];k[J>>2]=k[d+4>>2]}e=e<<8;g=g+-8|0}while((g|0)>7);a=a&7;Q=k[w>>2]|0;k[z>>2]=e;k[x>>2]=a;if(Q)break}else{k[z>>2]=e;k[x>>2]=a}d=a+1|0;a=((m[C+(k[F+(t<<2)>>2]<<1)>>1]|0)>>>15&65535^1)<<23-a|e;if((d|0)>7){g=d;do{P=a>>>16;e=P&255;Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=P;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(!Q){Q=k[y>>2]|0;f=k[Q+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[f>>2];k[J>>2]=k[f+4>>2]}if((e|0)==255?(Q=k[M>>2]|0,k[M>>2]=Q+1,i[Q>>0]=0,Q=(k[J>>2]|0)+-1|0,k[J>>2]=Q,(Q|0)==0):0){Q=k[y>>2]|0;e=k[Q+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[e>>2];k[J>>2]=k[e+4>>2]}a=a<<8;g=g+-8|0}while((g|0)>7);d=d&7;e=k[w>>2]|0}else e=0;k[z>>2]=a;k[x>>2]=d;if((b|0)!=0&(e|0)==0){h=p;e=0;while(1){if(!e){g=d+1|0;a=((l[h>>0]|0)&1)<<23-d|a;if((g|0)>7){f=g;do{P=a>>>16;d=P&255;Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=P;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(!Q){Q=k[y>>2]|0;e=k[Q+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[e>>2];k[J>>2]=k[e+4>>2]}do if((d|0)==255){Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=0;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(Q|0)break;Q=k[y>>2]|0;d=k[Q+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](Q)|0)){Q=k[y>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[d>>2];k[J>>2]=k[d+4>>2]}while(0);a=a<<8;f=f+-8|0}while((f|0)>7);d=g&7}else d=g;k[z>>2]=a;k[x>>2]=d}b=b+-1|0;if(!b)break d;h=h+1|0;e=k[w>>2]|0}}}else{Q=(k[N+92+(d<<2)>>2]|0)+(a<<2)|0;k[Q>>2]=(k[Q>>2]|0)+1}while(0);a=0;b=0;d=k[B>>2]|0}while(0);if((t|0)<(E|0))t=t+1|0;else{p=B;break}}}if((b|0)!=0|(a|0)>0?(H=N+128|0,c=(k[H>>2]|0)+1|0,k[H>>2]=c,Q=(k[s>>2]|0)+b|0,k[s>>2]=Q,!(Q>>>0<938&(c|0)!=32767|(c|0)==0)):0){n=0;while(1){c=c>>1;if(!c)break;else n=n+1|0}if((n|0)>14){Q=k[N+120>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=41;Uh[k[P>>2]&2047](Q)}c=k[N+124>>2]|0;b=n<<4;q=N+108|0;do if(!(k[q>>2]|0)){Q=k[N+60+(c<<2)>>2]|0;a=k[Q+(b<<2)>>2]|0;Q=i[Q+1024+b>>0]|0;b=Q<<24>>24;h=N+16|0;c=k[h>>2]|0;if(Q<<24>>24==0?(Q=k[N+120>>2]|0,P=k[Q>>2]|0,k[P+20>>2]=41,Uh[k[P>>2]&2047](Q),k[q>>2]|0):0)break;c=c+b|0;g=N+12|0;b=k[g>>2]|((1<<b)+-1&a)<<24-c;if((c|0)>7){f=N+120|0;e=c;do{P=b>>>16;a=P&255;Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=P;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(!Q){Q=k[f>>2]|0;d=k[Q+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](Q)|0)){Q=k[f>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[d>>2];k[J>>2]=k[d+4>>2]}if((a|0)==255?(Q=k[M>>2]|0,k[M>>2]=Q+1,i[Q>>0]=0,Q=(k[J>>2]|0)+-1|0,k[J>>2]=Q,(Q|0)==0):0){Q=k[f>>2]|0;a=k[Q+24>>2]|0;if(!(Xh[k[a+12>>2]&1023](Q)|0)){Q=k[f>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[a>>2];k[J>>2]=k[a+4>>2]}b=b<<8;e=e+-8|0}while((e|0)>7);c=c&7}k[g>>2]=b;k[h>>2]=c}else{Q=(k[N+92+(c<<2)>>2]|0)+(b<<2)|0;k[Q>>2]=(k[Q>>2]|0)+1}while(0);if(n|0?(I=N+16|0,(k[q>>2]|0)==0):0){c=(k[I>>2]|0)+n|0;g=N+12|0;b=(k[H>>2]&(1<<n)+-1)<<24-c|k[g>>2];if((c|0)>7){f=N+120|0;e=c;do{P=b>>>16;a=P&255;Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=P;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(!Q){Q=k[f>>2]|0;d=k[Q+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](Q)|0)){Q=k[f>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[d>>2];k[J>>2]=k[d+4>>2]}if((a|0)==255?(Q=k[M>>2]|0,k[M>>2]=Q+1,i[Q>>0]=0,Q=(k[J>>2]|0)+-1|0,k[J>>2]=Q,(Q|0)==0):0){Q=k[f>>2]|0;a=k[Q+24>>2]|0;if(!(Xh[k[a+12>>2]&1023](Q)|0)){Q=k[f>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[a>>2];k[J>>2]=k[a+4>>2]}b=b<<8;e=e+-8|0}while((e|0)>7);c=c&7}k[g>>2]=b;k[I>>2]=c}k[H>>2]=0;c=k[s>>2]|0;e:do if((c|0)!=0&(k[q>>2]|0)==0){h=N+16|0;n=N+12|0;o=N+120|0;g=k[p>>2]|0;b=0;while(1){if(!b){a=k[h>>2]|0;b=a+1|0;a=((l[g>>0]|0)&1)<<23-a|k[n>>2];if((b|0)>7){f=b;do{P=a>>>16;d=P&255;Q=k[M>>2]|0;k[M>>2]=Q+1;i[Q>>0]=P;Q=(k[J>>2]|0)+-1|0;k[J>>2]=Q;if(!Q){Q=k[o>>2]|0;e=k[Q+24>>2]|0;if(!(Xh[k[e+12>>2]&1023](Q)|0)){Q=k[o>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[e>>2];k[J>>2]=k[e+4>>2]}if((d|0)==255?(Q=k[M>>2]|0,k[M>>2]=Q+1,i[Q>>0]=0,Q=(k[J>>2]|0)+-1|0,k[J>>2]=Q,(Q|0)==0):0){Q=k[o>>2]|0;d=k[Q+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](Q)|0)){Q=k[o>>2]|0;P=k[Q>>2]|0;k[P+20>>2]=25;Uh[k[P>>2]&2047](Q)}k[M>>2]=k[d>>2];k[J>>2]=k[d+4>>2]}a=a<<8;f=f+-8|0}while((f|0)>7);b=b&7}k[n>>2]=a;k[h>>2]=b}c=c+-1|0;if(!c)break e;g=g+1|0;b=k[q>>2]|0}}while(0);k[s>>2]=0}c=k[L>>2]|0;k[c>>2]=k[M>>2];k[c+4>>2]=k[J>>2];c=k[K>>2]|0;if(!c){r=O;return 1}a=N+36|0;b=k[a>>2]|0;if(!b){k[a>>2]=c;Q=N+40|0;k[Q>>2]=(k[Q>>2]|0)+1&7}else c=b;k[a>>2]=c+-1;r=O;return 1}function vab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=k[a+424>>2]|0;f=a+236|0;e=k[f>>2]|0;if(e|0){g=v+36|0;c=k[g>>2]|0;if(!c){d=a+292|0;if((k[d>>2]|0)>0){c=0;do{k[v+20+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0));c=k[f>>2]|0}else c=e;k[g>>2]=c}k[g>>2]=c+-1}m=a+320|0;if((k[m>>2]|0)<=0)return 1;n=a+388|0;o=a+384|0;l=0;do{r=k[a+324+(l<<2)>>2]|0;s=k[a+296+(r<<2)>>2]|0;p=b+(l<<2)|0;q=k[p>>2]|0;r=v+20+(r<<2)|0;f=k[v+76+(k[s+20>>2]<<2)>>2]|0;s=k[v+92+(k[s+24>>2]<<2)>>2]|0;t=k[n>>2]|0;u=k[o>>2]|0;c=(j[q>>1]|0)-(k[r>>2]|0)|0;c=(c|0)<0?0-c|0:c;if(c){e=0;d=c;while(1){c=e+1|0;d=d>>1;if(!d)break;else e=c}if((e|0)>10){i=k[a>>2]|0;k[i+20>>2]=6;Uh[k[i>>2]&2047](a)}}else c=0;i=f+(c<<2)|0;k[i>>2]=(k[i>>2]|0)+1;if((t|0)>=1){i=s+960|0;c=0;h=1;while(1){f=j[q+(k[u+(h<<2)>>2]<<1)>>1]|0;g=f<<16>>16;if(!(f<<16>>16))c=c+1|0;else{d=c+-16|0;e=d>>>4;if((c|0)>15){k[i>>2]=e+1+(k[i>>2]|0);c=d-(e<<4)|0}e=1;d=f<<16>>16<0?0-g|0:g;while(1){d=d>>1;if(!d)break;else e=e+1|0}if((e|0)>10){g=k[a>>2]|0;k[g+20>>2]=6;Uh[k[g>>2]&2047](a)}c=s+(e+(c<<4)<<2)|0;k[c>>2]=(k[c>>2]|0)+1;c=0}if((h|0)==(t|0))break;else h=h+1|0}if((c|0)>0)k[s>>2]=(k[s>>2]|0)+1}k[r>>2]=j[k[p>>2]>>1];l=l+1|0}while((l|0)<(k[m>>2]|0));return 1}function wab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;L=r;r=r+48|0;H=L;K=k[a+424>>2]|0;I=a+24|0;c=k[I>>2]|0;e=k[c>>2]|0;k[H>>2]=e;c=k[c+4>>2]|0;C=H+4|0;k[C>>2]=c;D=H+8|0;E=K+12|0;k[D>>2]=k[E>>2];k[D+4>>2]=k[E+4>>2];k[D+8>>2]=k[E+8>>2];k[D+12>>2]=k[E+12>>2];k[D+16>>2]=k[E+16>>2];k[D+20>>2]=k[E+20>>2];F=H+32|0;k[F>>2]=a;G=a+236|0;if((k[G>>2]|0)!=0?(k[K+36>>2]|0)==0:0){n=k[K+40>>2]|0;g=H+12|0;d=k[g>>2]|0;h=H+8|0;do if((d|0)>0){c=d+7|0;f=k[h>>2]|127<<17-d;d=e;while(1){B=f>>>16;e=B&255;k[H>>2]=d+1;i[d>>0]=B;B=(k[C>>2]|0)+-1|0;k[C>>2]=B;if(!B){B=k[F>>2]|0;d=k[B+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](B)|0)){l=0;c=114;break}k[H>>2]=k[d>>2];k[C>>2]=k[d+4>>2]}if((e|0)==255?(B=k[H>>2]|0,k[H>>2]=B+1,i[B>>0]=0,B=(k[C>>2]|0)+-1|0,k[C>>2]=B,(B|0)==0):0){B=k[F>>2]|0;d=k[B+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](B)|0)){l=0;c=114;break}k[H>>2]=k[d>>2];k[C>>2]=k[d+4>>2]}c=c+-8|0;if((c|0)<=7){c=14;break}f=f<<8;d=k[H>>2]|0}if((c|0)==14){m=k[H>>2]|0;break}else if((c|0)==114){r=L;return l|0}}else m=e;while(0);k[h>>2]=0;k[g>>2]=0;k[H>>2]=m+1;i[m>>0]=-1;B=(k[C>>2]|0)+-1|0;k[C>>2]=B;do if(!B){B=k[F>>2]|0;c=k[B+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](B)|0)){K=0;r=L;return K|0}else{B=k[c>>2]|0;k[H>>2]=B;k[C>>2]=k[c+4>>2];c=B;break}}else c=k[H>>2]|0;while(0);k[H>>2]=c+1;i[c>>0]=n+208;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;e=k[F>>2]|0;do if(!c){c=k[e+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](e)|0)){K=0;r=L;return K|0}else{k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c;break}}while(0);if((k[e+292>>2]|0)>0){d=0;do{k[H+16+(d<<2)>>2]=0;d=d+1|0;e=k[F>>2]|0}while((d|0)<(k[e+292>>2]|0))}}else e=a;z=a+320|0;a:do if((k[z>>2]|0)>0){A=H+12|0;B=H+8|0;d=0;b:while(1){y=k[a+324+(d<<2)>>2]|0;w=k[a+296+(y<<2)>>2]|0;x=b+(d<<2)|0;t=k[x>>2]|0;y=H+16+(y<<2)|0;m=k[K+44+(k[w+20>>2]<<2)>>2]|0;w=k[K+60+(k[w+24>>2]<<2)>>2]|0;u=k[e+388>>2]|0;v=k[e+384>>2]|0;f=(j[t>>1]|0)-(k[y>>2]|0)|0;n=(f>>31)+f|0;f=(f|0)<0?0-f|0:f;if(f){h=0;while(1){g=h+1|0;f=f>>1;if(!f)break;else h=g}if((h|0)>10){s=k[e>>2]|0;k[s+20>>2]=6;Uh[k[s>>2]&2047](e)}}else g=0;l=k[m+(g<<2)>>2]|0;s=i[m+1024+g>>0]|0;h=s<<24>>24;f=k[A>>2]|0;if(!(s<<24>>24)){s=k[e>>2]|0;k[s+20>>2]=41;Uh[k[s>>2]&2047](e)}e=f+h|0;f=k[B>>2]|((1<<h)+-1&l)<<24-e;if((e|0)>7)do{s=f>>>16;h=s&255;c=k[H>>2]|0;k[H>>2]=c+1;i[c>>0]=s;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;if(!c){s=k[F>>2]|0;c=k[s+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](s)|0)){l=0;c=114;break b}k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c}if((h|0)==255){c=k[H>>2]|0;k[H>>2]=c+1;i[c>>0]=0;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;if(!c){s=k[F>>2]|0;c=k[s+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](s)|0)){l=0;c=114;break b}k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c}}f=f<<8;e=e+-8|0}while((e|0)>7);k[B>>2]=f;k[A>>2]=e;if(g){e=e+g|0;f=((1<<g)+-1&n)<<24-e|f;if((e|0)>7)do{s=f>>>16;g=s&255;c=k[H>>2]|0;k[H>>2]=c+1;i[c>>0]=s;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;if(!c){s=k[F>>2]|0;c=k[s+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](s)|0)){l=0;c=114;break b}k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c}if((g|0)==255){c=k[H>>2]|0;k[H>>2]=c+1;i[c>>0]=0;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;if(!c){s=k[F>>2]|0;c=k[s+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](s)|0)){l=0;c=114;break b}k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c}}f=f<<8;e=e+-8|0}while((e|0)>7);k[B>>2]=f;k[A>>2]=e}if((u|0)>=1){q=w+960|0;s=w+1264|0;g=0;p=1;while(1){n=j[t+(k[v+(p<<2)>>2]<<1)>>1]|0;o=n<<16>>16;if(!(n<<16>>16)){g=g+1|0;h=f}else{if((g|0)>15)do{h=k[q>>2]|0;m=i[s>>0]|0;l=m<<24>>24;if(!(m<<24>>24)){m=k[F>>2]|0;M=k[m>>2]|0;k[M+20>>2]=41;Uh[k[M>>2]&2047](m)}e=l+e|0;f=f|((1<<l)+-1&h)<<24-e;if((e|0)>7)do{M=f>>>16;h=M&255;c=k[H>>2]|0;k[H>>2]=c+1;i[c>>0]=M;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;if(!c){M=k[F>>2]|0;c=k[M+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](M)|0)){l=0;c=114;break b}k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c}do if((h|0)==255){c=k[H>>2]|0;k[H>>2]=c+1;i[c>>0]=0;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;if(c|0)break;M=k[F>>2]|0;c=k[M+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](M)|0)){l=0;c=114;break b}k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c}while(0);f=f<<8;e=e+-8|0}while((e|0)>7);k[B>>2]=f;k[A>>2]=e;g=g+-16|0}while((g|0)>15);m=1;h=n<<16>>16<0?0-o|0:o;while(1){h=h>>1;if(!h)break;else m=m+1|0}l=(n<<16>>16>>15<<16>>16)+o|0;if((m|0)>10){M=k[F>>2]|0;o=k[M>>2]|0;k[o+20>>2]=6;Uh[k[o>>2]&2047](M)}M=m+(g<<4)|0;g=k[w+(M<<2)>>2]|0;M=i[w+1024+M>>0]|0;h=M<<24>>24;if(!(M<<24>>24)){M=k[F>>2]|0;o=k[M>>2]|0;k[o+20>>2]=41;Uh[k[o>>2]&2047](M)}e=h+e|0;f=f|((1<<h)+-1&g)<<24-e;if((e|0)>7)do{M=f>>>16;g=M&255;c=k[H>>2]|0;k[H>>2]=c+1;i[c>>0]=M;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;if(!c){M=k[F>>2]|0;c=k[M+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](M)|0)){l=0;c=114;break b}k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c}do if((g|0)==255){c=k[H>>2]|0;k[H>>2]=c+1;i[c>>0]=0;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;if(c|0)break;M=k[F>>2]|0;c=k[M+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](M)|0)){l=0;c=114;break b}k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c}while(0);f=f<<8;e=e+-8|0}while((e|0)>7);k[B>>2]=f;k[A>>2]=e;e=e+m|0;f=((1<<m)+-1&l)<<24-e|f;if((e|0)>7)do{M=f>>>16;g=M&255;c=k[H>>2]|0;k[H>>2]=c+1;i[c>>0]=M;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;if(!c){M=k[F>>2]|0;c=k[M+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](M)|0)){l=0;c=114;break b}k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c}do if((g|0)==255){c=k[H>>2]|0;k[H>>2]=c+1;i[c>>0]=0;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;if(c|0)break;M=k[F>>2]|0;c=k[M+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](M)|0)){l=0;c=114;break b}k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c}while(0);f=f<<8;e=e+-8|0}while((e|0)>7);k[B>>2]=f;k[A>>2]=e;g=0;h=f}if((p|0)<(u|0)){p=p+1|0;f=h}else break}if((g|0)>0){g=k[w>>2]|0;M=i[w+1024>>0]|0;f=M<<24>>24;if(!(M<<24>>24)){M=k[F>>2]|0;w=k[M>>2]|0;k[w+20>>2]=41;Uh[k[w>>2]&2047](M)}e=f+e|0;f=h|((1<<f)+-1&g)<<24-e;if((e|0)>7)do{M=f>>>16;g=M&255;c=k[H>>2]|0;k[H>>2]=c+1;i[c>>0]=M;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;if(!c){M=k[F>>2]|0;c=k[M+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](M)|0)){l=0;c=114;break b}k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c}if((g|0)==255){c=k[H>>2]|0;k[H>>2]=c+1;i[c>>0]=0;c=(k[C>>2]|0)+-1|0;k[C>>2]=c;if(!c){M=k[F>>2]|0;c=k[M+24>>2]|0;if(!(Xh[k[c+12>>2]&1023](M)|0)){l=0;c=114;break b}k[H>>2]=k[c>>2];c=k[c+4>>2]|0;k[C>>2]=c}}f=f<<8;e=e+-8|0}while((e|0)>7);k[B>>2]=f;k[A>>2]=e}}k[y>>2]=j[k[x>>2]>>1];d=d+1|0;if((d|0)>=(k[z>>2]|0)){J=c;break a}e=k[F>>2]|0}if((c|0)==114){r=L;return l|0}}else J=c;while(0);c=k[I>>2]|0;k[c>>2]=k[H>>2];k[c+4>>2]=J;k[E>>2]=k[D>>2];k[E+4>>2]=k[D+4>>2];k[E+8>>2]=k[D+8>>2];k[E+12>>2]=k[D+12>>2];k[E+16>>2]=k[D+16>>2];k[E+20>>2]=k[D+20>>2];c=k[G>>2]|0;if(!c){M=1;r=L;return M|0}e=K+36|0;d=k[e>>2]|0;if(!d){k[e>>2]=c;M=K+40|0;k[M>>2]=(k[M>>2]|0)+1&7}else c=d;k[e>>2]=c+-1;M=1;r=L;return M|0}function xab(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+1296|0;o=q+1028|0;p=q;if(c>>>0>3){n=k[a>>2]|0;k[n+20>>2]=52;k[n+24>>2]=c;Uh[k[n>>2]&2047](a)}j=(b|0)!=0;n=k[(j?a+120+(c<<2)|0:a+136+(c<<2)|0)>>2]|0;if(!n){m=k[a>>2]|0;k[m+20>>2]=52;k[m+24>>2]=c;Uh[k[m>>2]&2047](a)}b=k[d>>2]|0;if(!b){b=ci[k[k[a+4>>2]>>2]&255](a,1,1280)|0;k[d>>2]=b;m=a}else m=a;c=0;g=1;while(1){d=i[n+g>>0]|0;e=d&255;f=e+c|0;if((f|0)>256){h=k[a>>2]|0;k[h+20>>2]=9;Uh[k[h>>2]&2047](m)}if(!(d<<24>>24))h=c;else{zpb(o+c|0,g&255|0,e|0)|0;h=f}g=g+1|0;if((g|0)==17)break;else c=h}i[o+h>>0]=0;d=i[o>>0]|0;if(d<<24>>24){g=d<<24>>24;e=0;c=0;while(1){if((d<<24>>24|0)==(g|0)){d=e;while(1){f=c+1|0;k[p+(c<<2)>>2]=d;c=d+1|0;d=i[o+f>>0]|0;if((d<<24>>24|0)==(g|0)){d=c;c=f}else{e=c;c=f;break}}}if((e|0)>=(1<<g|0)){f=k[a>>2]|0;k[f+20>>2]=9;Uh[k[f>>2]&2047](m)}if(!(d<<24>>24))break;else{g=g+1|0;e=e<<1}}}zpb(b+1024|0,0,256)|0;e=j?15:255;if((h|0)>0)c=0;else{r=q;return}do{f=l[n+17+c>>0]|0;d=b+1024+f|0;if(!(f>>>0<=e>>>0?!(i[d>>0]|0):0)){j=k[a>>2]|0;k[j+20>>2]=9;Uh[k[j>>2]&2047](m)}k[b+(f<<2)>>2]=k[p+(c<<2)>>2];i[d>>0]=i[o+c>>0]|0;c=c+1|0}while((c|0)!=(h|0));r=q;return}function yab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;t=a+128|0;c=k[t>>2]|0;if(!c)c=a+108|0;else{q=0;while(1){c=c>>1;if(!c)break;else q=q+1|0}if((q|0)>14){s=k[a+120>>2]|0;p=k[s>>2]|0;k[p+20>>2]=41;Uh[k[p>>2]&2047](s)}d=k[a+124>>2]|0;e=q<<4;c=a+108|0;do if(!(k[c>>2]|0)){s=k[a+60+(d<<2)>>2]|0;f=k[s+(e<<2)>>2]|0;s=i[s+1024+e>>0]|0;e=s<<24>>24;p=a+16|0;d=k[p>>2]|0;if(s<<24>>24==0?(s=k[a+120>>2]|0,o=k[s>>2]|0,k[o+20>>2]=41,Uh[k[o>>2]&2047](s),k[c>>2]|0):0)break;d=d+e|0;o=a+12|0;e=k[o>>2]|((1<<e)+-1&f)<<24-d;if((d|0)>7){j=a+112|0;m=a+116|0;n=a+120|0;h=d;do{g=e>>>16;f=g&255;s=k[j>>2]|0;k[j>>2]=s+1;i[s>>0]=g;s=(k[m>>2]|0)+-1|0;k[m>>2]=s;if(!s){s=k[n>>2]|0;g=k[s+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](s)|0)){s=k[n>>2]|0;u=k[s>>2]|0;k[u+20>>2]=25;Uh[k[u>>2]&2047](s)}k[j>>2]=k[g>>2];k[m>>2]=k[g+4>>2]}if((f|0)==255?(u=k[j>>2]|0,k[j>>2]=u+1,i[u>>0]=0,u=(k[m>>2]|0)+-1|0,k[m>>2]=u,(u|0)==0):0){u=k[n>>2]|0;f=k[u+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](u)|0)){u=k[n>>2]|0;s=k[u>>2]|0;k[s+20>>2]=25;Uh[k[s>>2]&2047](u)}k[j>>2]=k[f>>2];k[m>>2]=k[f+4>>2]}e=e<<8;h=h+-8|0}while((h|0)>7);d=d&7}k[o>>2]=e;k[p>>2]=d}else{u=(k[a+92+(d<<2)>>2]|0)+(e<<2)|0;k[u>>2]=(k[u>>2]|0)+1}while(0);if(q|0?(r=a+16|0,(k[c>>2]|0)==0):0){d=(k[r>>2]|0)+q|0;o=a+12|0;e=(k[t>>2]&(1<<q)+-1)<<24-d|k[o>>2];if((d|0)>7){j=a+112|0;m=a+116|0;n=a+120|0;h=d;do{s=e>>>16;f=s&255;u=k[j>>2]|0;k[j>>2]=u+1;i[u>>0]=s;u=(k[m>>2]|0)+-1|0;k[m>>2]=u;if(!u){u=k[n>>2]|0;g=k[u+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](u)|0)){u=k[n>>2]|0;s=k[u>>2]|0;k[s+20>>2]=25;Uh[k[s>>2]&2047](u)}k[j>>2]=k[g>>2];k[m>>2]=k[g+4>>2]}if((f|0)==255?(u=k[j>>2]|0,k[j>>2]=u+1,i[u>>0]=0,u=(k[m>>2]|0)+-1|0,k[m>>2]=u,(u|0)==0):0){u=k[n>>2]|0;f=k[u+24>>2]|0;if(!(Xh[k[f+12>>2]&1023](u)|0)){u=k[n>>2]|0;s=k[u>>2]|0;k[s+20>>2]=25;Uh[k[s>>2]&2047](u)}k[j>>2]=k[f>>2];k[m>>2]=k[f+4>>2]}e=e<<8;h=h+-8|0}while((h|0)>7);d=d&7}k[o>>2]=e;k[r>>2]=d}k[t>>2]=0;n=a+132|0;d=k[n>>2]|0;a:do if((d|0)!=0&(k[c>>2]|0)==0){o=a+16|0;p=a+12|0;q=a+112|0;r=a+116|0;s=a+120|0;m=k[a+136>>2]|0;e=0;while(1){if(!e){f=k[o>>2]|0;e=f+1|0;f=((l[m>>0]|0)&1)<<23-f|k[p>>2];if((e|0)>7){j=e;do{h=f>>>16;g=h&255;u=k[q>>2]|0;k[q>>2]=u+1;i[u>>0]=h;u=(k[r>>2]|0)+-1|0;k[r>>2]=u;if(!u){u=k[s>>2]|0;h=k[u+24>>2]|0;if(!(Xh[k[h+12>>2]&1023](u)|0)){u=k[s>>2]|0;v=k[u>>2]|0;k[v+20>>2]=25;Uh[k[v>>2]&2047](u)}k[q>>2]=k[h>>2];k[r>>2]=k[h+4>>2]}if((g|0)==255?(v=k[q>>2]|0,k[q>>2]=v+1,i[v>>0]=0,v=(k[r>>2]|0)+-1|0,k[r>>2]=v,(v|0)==0):0){v=k[s>>2]|0;g=k[v+24>>2]|0;if(!(Xh[k[g+12>>2]&1023](v)|0)){v=k[s>>2]|0;u=k[v>>2]|0;k[u+20>>2]=25;Uh[k[u>>2]&2047](v)}k[q>>2]=k[g>>2];k[r>>2]=k[g+4>>2]}f=f<<8;j=j+-8|0}while((j|0)>7);e=e&7}k[p>>2]=f;k[o>>2]=e}d=d+-1|0;if(!d)break a;m=m+1|0;e=k[c>>2]|0}}while(0);k[n>>2]=0}if(!(k[c>>2]|0)){zab(a);e=a+112|0;f=k[e>>2]|0;k[e>>2]=f+1;i[f>>0]=-1;f=a+116|0;v=(k[f>>2]|0)+-1|0;k[f>>2]=v;if(!v){c=a+120|0;v=k[c>>2]|0;d=k[v+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](v)|0)){v=k[c>>2]|0;u=k[v>>2]|0;k[u+20>>2]=25;Uh[k[u>>2]&2047](v)}c=k[d>>2]|0;k[e>>2]=c;k[f>>2]=k[d+4>>2]}else c=k[e>>2]|0;k[e>>2]=c+1;i[c>>0]=b+208;v=(k[f>>2]|0)+-1|0;k[f>>2]=v;if(!v){c=a+120|0;v=k[c>>2]|0;d=k[v+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](v)|0)){v=k[c>>2]|0;u=k[v>>2]|0;k[u+20>>2]=25;Uh[k[u>>2]&2047](v)}k[e>>2]=k[d>>2];k[f>>2]=k[d+4>>2]}}d=a+120|0;c=k[d>>2]|0;if(k[c+364>>2]|0){k[t>>2]=0;k[a+132>>2]=0;return}if((k[c+292>>2]|0)>0)c=0;else return;do{k[a+20+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[(k[d>>2]|0)+292>>2]|0));return}function zab(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;j=a+16|0;if(k[a+108>>2]|0){l=a+12|0;k[l>>2]=0;k[j>>2]=0;return}c=k[j>>2]|0;b=c+7|0;l=a+12|0;c=127<<17-c|k[l>>2];if((b|0)>7){g=a+112|0;h=a+116|0;f=a+120|0;e=b;do{m=c>>>16;a=m&255;d=k[g>>2]|0;k[g>>2]=d+1;i[d>>0]=m;d=(k[h>>2]|0)+-1|0;k[h>>2]=d;if(!d){m=k[f>>2]|0;d=k[m+24>>2]|0;if(!(Xh[k[d+12>>2]&1023](m)|0)){m=k[f>>2]|0;n=k[m>>2]|0;k[n+20>>2]=25;Uh[k[n>>2]&2047](m)}k[g>>2]=k[d>>2];k[h>>2]=k[d+4>>2]}if((a|0)==255?(n=k[g>>2]|0,k[g>>2]=n+1,i[n>>0]=0,n=(k[h>>2]|0)+-1|0,k[h>>2]=n,(n|0)==0):0){n=k[f>>2]|0;a=k[n+24>>2]|0;if(!(Xh[k[a+12>>2]&1023](n)|0)){n=k[f>>2]|0;m=k[n>>2]|0;k[m+20>>2]=25;Uh[k[m>>2]&2047](n)}k[g>>2]=k[a>>2];k[h>>2]=k[a+4>>2]}c=c<<8;e=e+-8|0}while((e|0)>7);b=b&7}k[l>>2]=c;k[j>>2]=b;n=l;k[n>>2]=0;k[j>>2]=0;return}function Aab(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;p=r;r=r+2096|0;n=p+2056|0;o=p+1028|0;m=p;e=n;f=e+33|0;do{i[e>>0]=0;e=e+1|0}while((e|0)<(f|0));zpb(o|0,0,1028)|0;zpb(m|0,-1,1028)|0;k[c+1024>>2]=1;a:while(1){d=1e9;h=-1;e=0;while(1){f=k[c+(e<<2)>>2]|0;g=(f|0)==0|(f|0)>(d|0);h=g?h:e;e=e+1|0;if((e|0)==257){j=-1;d=1e9;e=0;break}else d=g?d:f}while(1){f=k[c+(e<<2)>>2]|0;g=(e|0)==(h|0)|((f|0)==0|(f|0)>(d|0));j=g?j:e;e=e+1|0;if((e|0)==257)break;else d=g?d:f}if((j|0)<0)break;d=c+(j<<2)|0;e=c+(h<<2)|0;k[e>>2]=(k[e>>2]|0)+(k[d>>2]|0);k[d>>2]=0;d=o+(h<<2)|0;k[d>>2]=(k[d>>2]|0)+1;d=m+(h<<2)|0;e=k[d>>2]|0;if((e|0)>-1)do{d=o+(e<<2)|0;k[d>>2]=(k[d>>2]|0)+1;d=m+(e<<2)|0;e=k[d>>2]|0}while((e|0)>-1);k[d>>2]=j;d=o+(j<<2)|0;k[d>>2]=(k[d>>2]|0)+1;d=k[m+(j<<2)>>2]|0;if((d|0)<=-1)continue;while(1){j=o+(d<<2)|0;k[j>>2]=(k[j>>2]|0)+1;d=k[m+(d<<2)>>2]|0;if((d|0)<=-1)continue a}}d=0;do{e=k[o+(d<<2)>>2]|0;if(e|0){if((e|0)>32){m=k[a>>2]|0;k[m+20>>2]=40;Uh[k[m>>2]&2047](a)}m=n+e|0;i[m>>0]=(i[m>>0]|0)+1<<24>>24}d=d+1|0}while((d|0)!=257);d=32;do{j=n+d|0;e=i[j>>0]|0;if(!(e<<24>>24))d=d+-1|0;else{c=d+-2|0;d=d+-1|0;h=n+d|0;do{f=c;while(1){g=n+f|0;if(!(i[g>>0]|0))f=f+-1|0;else break}i[j>>0]=(e&255)+254;i[h>>0]=(i[h>>0]|0)+1<<24>>24;a=n+(f+1)|0;i[a>>0]=(l[a>>0]|0)+2;i[g>>0]=(i[g>>0]|0)+-1<<24>>24;e=i[j>>0]|0}while(e<<24>>24!=0)}}while((d|0)>16);d=16;while(1){e=n+d|0;f=i[e>>0]|0;if(!(f<<24>>24))d=d+-1|0;else break}i[e>>0]=f+-1<<24>>24;e=b;d=n;f=e+17|0;do{i[e>>0]=i[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(f|0));d=0;f=1;do{e=0;do{if((k[o+(e<<2)>>2]|0)==(f|0)){i[b+17+d>>0]=e;d=d+1|0}e=e+1|0}while((e|0)!=256);f=f+1|0}while((f|0)!=33);k[b+276>>2]=0;r=p;return}function Bab(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;o=k[a+468>>2]|0;p=a+224|0;q=a+412|0;d=k[q>>2]|0;c=(d|0)==0;do if(k[p>>2]|0){m=a+416|0;b=k[m>>2]|0;if(c)if(!b)n=7;else n=11;else if(((b|0)>=(d|0)?(b|0)<=(k[a+436>>2]|0):0)?(k[a+340>>2]|0)==1:0)n=7;else n=11;do if((n|0)==7){b=k[a+420>>2]|0;if(b){b=b+-1|0;if((b|0)!=(k[a+424>>2]|0)){n=11;break}}else b=k[a+424>>2]|0;if((b|0)>13)n=11}while(0);if((n|0)==11){l=k[a>>2]|0;k[l+20>>2]=17;k[l+24>>2]=d;k[l+28>>2]=k[m>>2];k[l+32>>2]=k[a+420>>2];k[l+36>>2]=k[a+424>>2];Uh[k[l>>2]&2047](a)}l=a+340|0;b=k[l>>2]|0;if((b|0)>0){h=a+160|0;e=a+420|0;j=a+424|0;g=0;do{d=k[(k[a+344+(g<<2)>>2]|0)+4>>2]|0;f=k[h>>2]|0;b=k[q>>2]|0;if(b){if((k[f+(d<<8)>>2]|0)<0){b=k[a>>2]|0;k[b+20>>2]=118;k[b+24>>2]=d;k[b+28>>2]=0;jh[k[b+4>>2]&1023](a,-1);b=k[q>>2]|0}}else b=0;if((b|0)<=(k[m>>2]|0))while(1){c=f+(d<<8)+(b<<2)|0;r=k[c>>2]|0;if((k[e>>2]|0)!=(((r|0)<0?0:r)|0)){r=k[a>>2]|0;k[r+20>>2]=118;k[r+24>>2]=d;k[r+28>>2]=b;jh[k[r+4>>2]&1023](a,-1)}k[c>>2]=k[j>>2];if((b|0)<(k[m>>2]|0))b=b+1|0;else break}g=g+1|0;b=k[l>>2]|0}while((g|0)<(b|0))}else e=a+420|0;c=(k[q>>2]|0)==0;d=o+4|0;if(!(k[e>>2]|0))if(c){k[d>>2]=289;j=l;break}else{k[d>>2]=290;j=l;break}else if(c){k[d>>2]=291;j=l;break}else{k[d>>2]=292;j=l;break}}else{if((c?(k[a+420>>2]|0)==0:0)?(k[a+424>>2]|0)==0:0){r=k[a+416>>2]|0;if((r|0)<64?(r|0)!=(k[a+436>>2]|0):0)n=35}else n=35;if((n|0)==35){r=k[a>>2]|0;k[r+20>>2]=125;jh[k[r+4>>2]&1023](a,-1)}k[o+4>>2]=293;b=a+340|0;j=b;b=k[b>>2]|0}while(0);if((b|0)<=0){q=o+8|0;k[q>>2]=0;q=o+12|0;k[q>>2]=0;q=o+16|0;k[q>>2]=-16;q=a+280|0;q=k[q>>2]|0;r=o+52|0;k[r>>2]=q;return}f=a+4|0;g=a+436|0;h=a+420|0;e=0;do{d=k[a+344+(e<<2)>>2]|0;if(k[p>>2]|0)if(!(k[q>>2]|0)){if(!(k[h>>2]|0))n=42}else n=49;else n=42;do if((n|0)==42){n=0;b=k[d+20>>2]|0;if(b>>>0>15){r=k[a>>2]|0;k[r+20>>2]=50;k[r+24>>2]=b;Uh[k[r>>2]&2047](a)}c=o+56+(b<<2)|0;b=k[c>>2]|0;if(!b){b=ci[k[k[f>>2]>>2]&255](a,1,64)|0;k[c>>2]=b}c=b+64|0;do{i[b>>0]=0;b=b+1|0}while((b|0)<(c|0));k[o+20+(e<<2)>>2]=0;k[o+36+(e<<2)>>2]=0;if(!(k[p>>2]|0))if(!(k[g>>2]|0))break;else{n=49;break}else if(!(k[q>>2]|0))break;else{n=49;break}}while(0);if((n|0)==49){n=0;b=k[d+24>>2]|0;if(b>>>0>15){r=k[a>>2]|0;k[r+20>>2]=50;k[r+24>>2]=b;Uh[k[r>>2]&2047](a)}c=o+120+(b<<2)|0;b=k[c>>2]|0;if(!b){b=ci[k[k[f>>2]>>2]&255](a,1,256)|0;k[c>>2]=b}zpb(b|0,0,256)|0}e=e+1|0}while((e|0)<(k[j>>2]|0));q=o+8|0;k[q>>2]=0;q=o+12|0;k[q>>2]=0;q=o+16|0;k[q>>2]=-16;q=a+280|0;q=k[q>>2]|0;r=o+52|0;k[r>>2]=q;return}function Cab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;r=k[a+468>>2]|0;if(k[a+280>>2]|0){d=r+52|0;c=k[d>>2]|0;if(!c){Hab(a);c=k[d>>2]|0}k[d>>2]=c+-1}n=r+16|0;if((k[n>>2]|0)==-1)return 1;o=a+368|0;if((k[o>>2]|0)<=0)return 1;p=a+424|0;m=0;a:while(1){q=k[b+(m<<2)>>2]|0;h=k[a+372+(m<<2)>>2]|0;f=k[(k[a+344+(h<<2)>>2]|0)+20>>2]|0;e=r+56+(f<<2)|0;g=r+36+(h<<2)|0;c=(k[e>>2]|0)+(k[g>>2]|0)|0;if(!(Iab(a,c)|0)){k[g>>2]=0;c=k[r+20+(h<<2)>>2]|0}else{i=Iab(a,c+1|0)|0;d=c+2+i|0;c=Iab(a,d)|0;if(c){d=(k[e>>2]|0)+20|0;if(Iab(a,d)|0)do{c=c<<1;if((c|0)==32768)break a;d=d+1|0}while((Iab(a,d)|0)!=0)}else c=0;do if((c|0)>=(1<<(l[a+232+f>>0]|0)>>1|0)){e=i<<2;if((c|0)>(1<<(l[a+248+f>>0]|0)>>1|0)){k[g>>2]=e+12;break}else{k[g>>2]=e+4;break}}else k[g>>2]=0;while(0);e=d+14|0;d=c>>1;if(d)do{g=(Iab(a,e)|0)==0;c=(g?0:d)|c;d=d>>1}while((d|0)!=0);h=r+20+(h<<2)|0;c=(k[h>>2]|0)+((i|0)==0?c+1|0:~c)|0;k[h>>2]=c}j[q>>1]=c<<k[p>>2];m=m+1|0;if((m|0)>=(k[o>>2]|0)){s=24;break}}if((s|0)==24)return 1;s=k[a>>2]|0;k[s+20>>2]=117;jh[k[s+4>>2]&1023](a,-1);k[n>>2]=-1;return 1}function Dab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0,o=0,p=0,q=0,r=0;e=k[a+468>>2]|0;if(k[a+280>>2]|0){d=e+52|0;c=k[d>>2]|0;if(!c){Hab(a);c=k[d>>2]|0}k[d>>2]=c+-1}q=e+16|0;if((k[q>>2]|0)==-1)return 1;p=k[a+432>>2]|0;m=k[b>>2]|0;i=k[(k[a+344>>2]|0)+24>>2]|0;n=e+120+(i<<2)|0;o=a+416|0;g=e+184|0;h=a+424|0;i=a+264+i|0;d=(k[a+412>>2]|0)+-1|0;a:while(1){c=(k[n>>2]|0)+(d*3|0)|0;if(Iab(a,c)|0){c=20;break}while(1){e=d+1|0;if(Iab(a,c+1|0)|0)break;if((e|0)<(k[o>>2]|0)){c=c+3|0;d=e}else{c=10;break a}}f=Iab(a,g)|0;b=c+2|0;c=Iab(a,b)|0;if(c){if(Iab(a,b)|0){c=c<<1;d=(k[n>>2]|0)+((d|0)<(l[i>>0]|0|0)?189:217)|0;if(Iab(a,d)|0)do{c=c<<1;if((c|0)==32768){c=15;break a}d=d+1|0}while((Iab(a,d)|0)!=0)}else d=b;b=d+14|0;d=c>>1;if(d)do{r=(Iab(a,b)|0)==0;c=(r?0:d)|c;d=d>>1}while((d|0)!=0)}else c=0;j[m+(k[p+(e<<2)>>2]<<1)>>1]=((f|0)==0?c+1|0:~c)<<k[h>>2];if((e|0)<(k[o>>2]|0))d=e;else{c=20;break}}if((c|0)==10){r=k[a>>2]|0;k[r+20>>2]=117;jh[k[r+4>>2]&1023](a,-1);k[q>>2]=-1;return 1}else if((c|0)==15){r=k[a>>2]|0;k[r+20>>2]=117;jh[k[r+4>>2]&1023](a,-1);k[q>>2]=-1;return 1}else if((c|0)==20)return 1;return 0}function Eab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=k[a+468>>2]|0;if(k[a+280>>2]|0){e=d+52|0;c=k[e>>2]|0;if(!c){Hab(a);c=k[e>>2]|0}k[e>>2]=c+-1}d=d+184|0;e=1<<k[a+424>>2];f=a+368|0;if((k[f>>2]|0)>0)c=0;else return 1;do{if(Iab(a,d)|0){g=k[b+(c<<2)>>2]|0;j[g>>1]=m[g>>1]|0|e}c=c+1|0}while((c|0)<(k[f>>2]|0));return 1}function Fab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=k[a+468>>2]|0;if(k[a+280>>2]|0){d=e+52|0;c=k[d>>2]|0;if(!c){Hab(a);c=k[d>>2]|0}k[d>>2]=c+-1}q=e+16|0;if((k[q>>2]|0)==-1)return 1;r=k[a+432>>2]|0;m=k[b>>2]|0;d=k[(k[a+344>>2]|0)+24>>2]|0;o=k[a+424>>2]|0;n=1<<o;o=-1<<o;p=a+416|0;c=k[p>>2]|0;while(1){if(j[m+(k[r+(c<<2)>>2]<<1)>>1]|0)break;c=c+-1|0;if(!c){c=0;break}}l=e+120+(d<<2)|0;g=e+184|0;h=n&65535;i=o&65535;b=(k[a+412>>2]|0)+-1|0;a:while(1){d=(k[l>>2]|0)+(b*3|0)|0;if((b|0)>=(c|0)?(Iab(a,d)|0)!=0:0){e=24;break}while(1){b=b+1|0;f=m+(k[r+(b<<2)>>2]<<1)|0;if(j[f>>1]|0){e=13;break}if(Iab(a,d+1|0)|0){e=18;break}if((b|0)>=(k[p>>2]|0)){e=22;break a}else d=d+3|0}do if((e|0)==13){if(Iab(a,d+2|0)|0){e=j[f>>1]|0;d=e<<16>>16;if(e<<16>>16<0){j[f>>1]=d+o;break}else{j[f>>1]=d+n;break}}}else if((e|0)==18)if(!(Iab(a,g)|0)){j[f>>1]=h;break}else{j[f>>1]=i;break}while(0);if((b|0)>=(k[p>>2]|0)){e=24;break}}if((e|0)==22){r=k[a>>2]|0;k[r+20>>2]=117;jh[k[r+4>>2]&1023](a,-1);k[q>>2]=-1;return 1}else if((e|0)==24)return 1;return 0}function Gab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=k[a+468>>2]|0;if(k[a+280>>2]|0){d=u+52|0;c=k[d>>2]|0;if(!c){Hab(a);c=k[d>>2]|0}k[d>>2]=c+-1}t=u+16|0;if((k[t>>2]|0)==-1)return 1;o=k[a+432>>2]|0;p=a+368|0;if((k[p>>2]|0)<=0)return 1;q=a+436|0;r=u+184|0;n=0;a:while(1){s=k[b+(n<<2)>>2]|0;h=k[a+372+(n<<2)>>2]|0;m=k[a+344+(h<<2)>>2]|0;f=k[m+20>>2]|0;e=u+56+(f<<2)|0;g=u+36+(h<<2)|0;c=(k[e>>2]|0)+(k[g>>2]|0)|0;if(!(Iab(a,c)|0)){k[g>>2]=0;c=k[u+20+(h<<2)>>2]|0}else{i=Iab(a,c+1|0)|0;d=c+2+i|0;c=Iab(a,d)|0;if(c){d=(k[e>>2]|0)+20|0;if(Iab(a,d)|0)do{c=c<<1;if((c|0)==32768){c=13;break a}d=d+1|0}while((Iab(a,d)|0)!=0)}else c=0;do if((c|0)>=(1<<(l[a+232+f>>0]|0)>>1|0)){e=i<<2;if((c|0)>(1<<(l[a+248+f>>0]|0)>>1|0)){k[g>>2]=e+12;break}else{k[g>>2]=e+4;break}}else k[g>>2]=0;while(0);e=d+14|0;d=c>>1;if(d)do{g=(Iab(a,e)|0)==0;c=(g?0:d)|c;d=d>>1}while((d|0)!=0);h=u+20+(h<<2)|0;c=(k[h>>2]|0)+((i|0)==0?c+1|0:~c)|0;k[h>>2]=c}j[s>>1]=c;b:do if(k[q>>2]|0){i=k[m+24>>2]|0;h=u+120+(i<<2)|0;i=a+264+i|0;c=0;while(1){d=(k[h>>2]|0)+(c*3|0)|0;if(Iab(a,d)|0)break b;while(1){g=c+1|0;if(Iab(a,d+1|0)|0)break;if((g|0)<(k[q>>2]|0)){c=g;d=d+3|0}else{c=28;break a}}f=Iab(a,r)|0;d=d+2|0;e=Iab(a,d)|0;if(e){if(Iab(a,d)|0){e=e<<1;d=(k[h>>2]|0)+((c|0)<(l[i>>0]|0|0)?189:217)|0;if(!(Iab(a,d)|0))c=e;else{c=e;do{c=c<<1;if((c|0)==32768){c=33;break a}d=d+1|0}while((Iab(a,d)|0)!=0)}}else c=e;e=d+14|0;d=c>>1;if(d)do{m=(Iab(a,e)|0)==0;c=(m?0:d)|c;d=d>>1}while((d|0)!=0)}else c=0;j[s+(k[o+(g<<2)>>2]<<1)>>1]=(f|0)==0?c+1|0:c^65535;if((g|0)<(k[q>>2]|0))c=g;else break}}while(0);n=n+1|0;if((n|0)>=(k[p>>2]|0)){c=39;break}}if((c|0)==13){u=k[a>>2]|0;k[u+20>>2]=117;jh[k[u+4>>2]&1023](a,-1);k[t>>2]=-1;return 1}else if((c|0)==28){u=k[a>>2]|0;k[u+20>>2]=117;jh[k[u+4>>2]&1023](a,-1);k[t>>2]=-1;return 1}else if((c|0)==33){u=k[a>>2]|0;k[u+20>>2]=117;jh[k[u+4>>2]&1023](a,-1);k[t>>2]=-1;return 1}else if((c|0)==39)return 1;return 0}function Hab(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;h=k[a+468>>2]|0;if(!(Xh[k[(k[a+464>>2]|0)+8>>2]&1023](a)|0)){n=k[a>>2]|0;k[n+20>>2]=25;Uh[k[n>>2]&2047](a)}c=a+340|0;if((k[c>>2]|0)<=0){m=h+8|0;k[m>>2]=0;m=h+12|0;k[m>>2]=0;m=h+16|0;k[m>>2]=-16;m=a+280|0;m=k[m>>2]|0;n=h+52|0;k[n>>2]=m;return}d=a+224|0;e=a+436|0;f=a+412|0;g=a+420|0;b=0;do{j=k[a+344+(b<<2)>>2]|0;if(k[d>>2]|0)if(!(k[f>>2]|0)){if(!(k[g>>2]|0))m=8}else m=11;else m=8;do if((m|0)==8){m=0;l=k[h+56+(k[j+20>>2]<<2)>>2]|0;n=l+64|0;do{i[l>>0]=0;l=l+1|0}while((l|0)<(n|0));k[h+20+(b<<2)>>2]=0;k[h+36+(b<<2)>>2]=0;if(!(k[d>>2]|0))if(!(k[e>>2]|0))break;else{m=11;break}else if(!(k[f>>2]|0))break;else{m=11;break}}while(0);if((m|0)==11){m=0;zpb(k[h+120+(k[j+24>>2]<<2)>>2]|0,0,256)|0}b=b+1|0}while((b|0)<(k[c>>2]|0));m=h+8|0;k[m>>2]=0;m=h+12|0;k[m>>2]=0;m=h+16|0;k[m>>2]=-16;m=a+280|0;m=k[m>>2]|0;n=h+52|0;k[n>>2]=m;return}function Iab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0;d=k[a+468>>2]|0;m=d+12|0;c=k[m>>2]|0;h=d+16|0;if((c|0)<32768){e=a+440|0;g=a+24|0;f=d+8|0;d=k[h>>2]|0;do{c=d+-1|0;k[h>>2]=c;if((d|0)<1){a:do if(!(k[e>>2]|0)){c=k[g>>2]|0;d=c+4|0;if((k[d>>2]|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}k[d>>2]=(k[d>>2]|0)+-1;j=k[c>>2]|0;k[c>>2]=j+1;j=i[j>>0]|0;c=j&255;if(j<<24>>24==-1){b:while(1){c=k[g>>2]|0;d=c+4|0;if((k[d>>2]|0)==0?(Xh[k[c+12>>2]&1023](a)|0)==0:0){j=k[a>>2]|0;k[j+20>>2]=25;Uh[k[j>>2]&2047](a)}k[d>>2]=(k[d>>2]|0)+-1;j=k[c>>2]|0;k[c>>2]=j+1;c=i[j>>0]|0;switch(c<<24>>24){case 0:{c=255;break a}case -1:break;default:break b}}k[e>>2]=c&255;c=0}}else c=0;while(0);k[f>>2]=k[f>>2]<<8|c;c=k[h>>2]|0;d=c+8|0;k[h>>2]=d;if((c|0)<-8){c=c+9|0;k[h>>2]=c;if(!c){k[m>>2]=32768;d=0}else d=c}}else d=c;c=k[m>>2]<<1;k[m>>2]=c}while((c|0)<32768)}else{f=d+8|0;d=k[h>>2]|0}g=l[b>>0]|0;a=k[155568+((g&127)<<2)>>2]|0;h=a>>8;j=a>>16;e=c-j|0;k[m>>2]=e;c=e<<d;d=k[f>>2]|0;if((d|0)>=(c|0)){k[f>>2]=d-c;k[m>>2]=j;c=g&128;if((e|0)<(j|0)){i[b>>0]=c^h;b=g;b=b>>7;return b|0}else{i[b>>0]=c^a;b=g^128;b=b>>7;return b|0}}if((e|0)>=32768){b=g;b=b>>7;return b|0}c=g&128;if((e|0)<(j|0)){i[b>>0]=c^a;b=g^128;b=b>>7;return b|0}else{i[b>>0]=c^h;b=g;b=b>>7;return b|0}return 0}function Jab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;g=a+4|0;h=ci[k[k[g>>2]>>2]&255](a,1,116)|0;k[a+452>>2]=h;k[h>>2]=1522;k[h+8>>2]=1523;k[h+112>>2]=0;if(!b){b=ci[k[(k[g>>2]|0)+4>>2]&255](a,1,1280)|0;k[h+32>>2]=b;k[h+36>>2]=b+128;k[h+40>>2]=b+256;k[h+44>>2]=b+384;k[h+48>>2]=b+512;k[h+52>>2]=b+640;k[h+56>>2]=b+768;k[h+60>>2]=b+896;k[h+64>>2]=b+1024;k[h+68>>2]=b+1152;if(!(k[a+436>>2]|0))zpb(b|0,0,1280)|0;k[h+4>>2]=797;k[h+12>>2]=295;k[h+16>>2]=0;return}e=a+36|0;if((k[e>>2]|0)>0){f=a+224|0;b=h+72|0;c=0;d=k[a+216>>2]|0;while(1){i=k[d+12>>2]|0;l=k[d+8>>2]|0;m=(k[d+28>>2]|0)+-1+l|0;j=(k[d+32>>2]|0)+-1+i|0;i=Sf[k[(k[g>>2]|0)+20>>2]&127](a,1,1,m-((m|0)%(l|0)|0)|0,j-((j|0)%(i|0)|0)|0,(k[f>>2]|0)==0?i:i*3|0)|0;k[b+(c<<2)>>2]=i;c=c+1|0;if((c|0)>=(k[e>>2]|0))break;else d=d+88|0}}else b=h+72|0;k[h+4>>2]=796;k[h+12>>2]=294;k[h+16>>2]=b;return}function Kab(a){a=a|0;var b=0,c=0;k[a+148>>2]=0;c=k[a+452>>2]|0;do if((k[a+340>>2]|0)<=1){b=k[a+344>>2]|0;if((k[a+332>>2]|0)==1){k[c+28>>2]=k[b+76>>2];break}else{k[c+28>>2]=k[b+12>>2];break}}else k[c+28>>2]=1;while(0);k[c+20>>2]=0;k[c+24>>2]=0;return}function Lab(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0;l=k[a+452>>2]|0;if(!(k[l+16>>2]|0)){l=a+156|0;k[l>>2]=0;return}a:do if((k[a+80>>2]|0?k[a+224>>2]|0:0)?(i=a+160|0,k[i>>2]|0):0){b=l+112|0;c=k[b>>2]|0;if(!c){h=a+36|0;c=ci[k[k[a+4>>2]>>2]&255](a,1,(k[h>>2]|0)*24|0)|0;k[b>>2]=c}else h=a+36|0;if((k[h>>2]|0)>0){e=0;f=k[a+216>>2]|0;g=0;while(1){b=k[f+80>>2]|0;if(!b)break a;d=k[b>>2]|0;if(d>>>0<65536|(d&65535)<<16>>16==0)break a;d=k[b+16>>2]|0;if(!((d&65535)<<16>>16))break a;if(d>>>0<65536|(j[b+32>>1]|0)==0)break a;if(!(j[b+4>>1]|0))break a;b=k[i>>2]|0;if((k[b+(g<<8)>>2]|0)<0)break a;m=b+(g<<8)+4|0;k[c+4>>2]=k[m>>2];m=k[m>>2]|0;d=b+(g<<8)+8|0;k[c+8>>2]=k[d>>2];m=k[d>>2]|m;d=b+(g<<8)+12|0;k[c+12>>2]=k[d>>2];d=m|k[d>>2];m=b+(g<<8)+16|0;k[c+16>>2]=k[m>>2];m=d|k[m>>2];d=b+(g<<8)+20|0;k[c+20>>2]=k[d>>2];e=(m|k[d>>2]|0)==0?e:1;g=g+1|0;if((g|0)>=(k[h>>2]|0))break;else{f=f+88|0;c=c+24|0}}if(e|0){k[l+12>>2]=296;m=a+156|0;k[m>>2]=0;return}}}while(0);k[l+12>>2]=294;m=a+156|0;k[m>>2]=0;return}function Mab(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+16|0;x=C;A=a+452|0;y=k[A>>2]|0;B=a+340|0;if((k[B>>2]|0)>0){c=a+4|0;d=a+148|0;b=0;do{u=k[a+344+(b<<2)>>2]|0;w=k[u+12>>2]|0;v=aa(w,k[d>>2]|0)|0;w=$g[k[(k[c>>2]|0)+32>>2]&127](a,k[y+72+(k[u+4>>2]<<2)>>2]|0,v,w,1)|0;k[x+(b<<2)>>2]=w;b=b+1|0}while((b|0)<(k[B>>2]|0))}q=y+24|0;b=k[q>>2]|0;s=y+28|0;c=k[s>>2]|0;a:do if((b|0)<(c|0)){t=y+20|0;u=a+360|0;v=a+468|0;w=y+32|0;e=k[t>>2]|0;d=k[u>>2]|0;b:while(1){if(e>>>0<d>>>0){c=e;do{p=k[B>>2]|0;if((p|0)>0){d=0;o=0;do{m=k[a+344+(o<<2)>>2]|0;j=k[m+56>>2]|0;l=aa(j,c)|0;m=k[m+60>>2]|0;if((m|0)>0?(z=k[x+(o<<2)>>2]|0,(j|0)>0):0){n=aa(j,m)|0;e=0;h=d;while(1){f=0;g=(k[z+(e+b<<2)>>2]|0)+(l<<7)|0;i=h;while(1){k[y+32+(i<<2)>>2]=g;f=f+1|0;if((f|0)==(j|0))break;else{g=g+128|0;i=i+1|0}}e=e+1|0;if((e|0)==(m|0))break;else h=j+h|0}d=d+n|0}o=o+1|0}while((o|0)!=(p|0))}if(!(Hh[k[(k[v>>2]|0)+4>>2]&511](a,w)|0))break b;c=c+1|0;d=k[u>>2]|0}while(c>>>0<d>>>0);c=k[s>>2]|0}k[t>>2]=0;b=b+1|0;if((b|0)<(c|0))e=0;else break a}k[q>>2]=b;k[t>>2]=c;B=0;r=C;return B|0}while(0);e=a+148|0;d=(k[e>>2]|0)+1|0;k[e>>2]=d;e=k[a+332>>2]|0;if(d>>>0>=e>>>0){Uh[k[(k[a+460>>2]|0)+12>>2]&2047](a);B=4;r=C;return B|0}c=k[A>>2]|0;do if((k[B>>2]|0)<=1){b=k[a+344>>2]|0;if(d>>>0<(e+-1|0)>>>0){k[c+28>>2]=k[b+12>>2];break}else{k[c+28>>2]=k[b+76>>2];break}}else k[c+28>>2]=1;while(0);k[c+20>>2]=0;k[c+24>>2]=0;B=3;r=C;return B|0}function Nab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;v=k[a+452>>2]|0;w=a+332|0;x=(k[w>>2]|0)+-1|0;f=a+144|0;g=a+152|0;h=a+460|0;c=a+148|0;u=a+156|0;while(1){d=k[f>>2]|0;e=k[g>>2]|0;if((d|0)>=(e|0)){if((d|0)!=(e|0))break;if((k[c>>2]|0)>>>0>(k[u>>2]|0)>>>0)break}if(!(Xh[k[k[h>>2]>>2]&1023](a)|0)){c=0;i=20;break}}if((i|0)==20)return c|0;q=a+36|0;if((k[q>>2]|0)>0){r=a+4|0;s=a+472|0;o=k[a+216>>2]|0;p=0;while(1){if(k[o+52>>2]|0){c=o+12|0;t=k[c>>2]|0;n=aa(t,k[u>>2]|0)|0;t=$g[k[(k[r>>2]|0)+32>>2]&127](a,k[v+72+(p<<2)>>2]|0,n,t,0)|0;if((k[u>>2]|0)>>>0<x>>>0)h=k[c>>2]|0;else{n=k[c>>2]|0;h=((k[o+32>>2]|0)>>>0)%(n>>>0)|0;h=(h|0)==0?n:h}j=k[(k[s>>2]|0)+4+(p<<2)>>2]|0;if((h|0)>0){l=o+28|0;m=o+40|0;n=o+36|0;g=k[b+(p<<2)>>2]|0;i=0;c=k[l>>2]|0;while(1){if(!c)c=0;else{d=0;e=k[t+(i<<2)>>2]|0;f=0;while(1){eh[j&255](a,o,e,g,d);f=f+1|0;c=k[l>>2]|0;if(f>>>0>=c>>>0)break;else{d=(k[n>>2]|0)+d|0;e=e+128|0}}}i=i+1|0;if((i|0)==(h|0))break;else g=g+(k[m>>2]<<2)|0}}}p=p+1|0;if((p|0)>=(k[q>>2]|0))break;else o=o+88|0}}x=(k[u>>2]|0)+1|0;k[u>>2]=x;x=x>>>0<(k[w>>2]|0)>>>0?3:4;return x|0}function Oab(a){a=a|0;return 0}function Pab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=a+452|0;H=k[M>>2]|0;I=(k[a+360>>2]|0)+-1|0;L=a+332|0;f=k[L>>2]|0;J=f+-1|0;F=H+24|0;d=k[F>>2]|0;G=H+28|0;e=k[G>>2]|0;do if((d|0)<(e|0)){y=H+20|0;z=a+436|0;A=a+468|0;B=H+32|0;C=a+340|0;D=a+472|0;c=a+148|0;E=a+368|0;x=d;d=k[y>>2]|0;a:while(1){if(d>>>0<=I>>>0){do{if(k[z>>2]|0)zpb(k[B>>2]|0,0,k[E>>2]<<7|0)|0;if(!(Hh[k[(k[A>>2]|0)+4>>2]&511](a,B)|0))break a;e=k[C>>2]|0;if((e|0)>0){w=d>>>0<I>>>0;f=0;v=0;do{m=k[a+344+(v<<2)>>2]|0;do if(k[m+52>>2]|0){g=k[m+4>>2]|0;n=k[(k[D>>2]|0)+4+(g<<2)>>2]|0;o=m+56|0;p=k[(w?o:m+72|0)>>2]|0;q=m+40|0;r=aa(k[m+68>>2]|0,d)|0;s=m+60|0;h=k[s>>2]|0;if((h|0)>0){i=k[q>>2]|0;t=m+76|0;u=m+36|0;if((p|0)<=0){f=f+(aa(k[o>>2]|0,h)|0)|0;break}j=(k[b+(g<<2)>>2]|0)+((aa(i,x)|0)<<2)|0;l=0;g=h;e=i;while(1){if(!((k[c>>2]|0)>>>0>=J>>>0?(l+x|0)>=(k[t>>2]|0):0)){e=r;g=0;K=20}if((K|0)==20){while(1){K=0;eh[n&255](a,m,k[H+32+(g+f<<2)>>2]|0,j,e);g=g+1|0;if((g|0)==(p|0))break;else{e=(k[u>>2]|0)+e|0;K=20}}e=k[q>>2]|0;g=k[s>>2]|0}f=(k[o>>2]|0)+f|0;l=l+1|0;if((l|0)>=(g|0))break;else j=j+(e<<2)|0}e=k[C>>2]|0}}else f=(k[m+64>>2]|0)+f|0;while(0);v=v+1|0}while((v|0)<(e|0))}d=d+1|0}while(d>>>0<=I>>>0);e=k[G>>2]|0}k[y>>2]=0;d=x+1|0;if((d|0)<(e|0)){x=d;d=0}else{K=27;break}}if((K|0)==27){f=k[L>>2]|0;break}k[F>>2]=x;k[y>>2]=d;a=0;return a|0}else c=a+148|0;while(0);e=a+156|0;k[e>>2]=(k[e>>2]|0)+1;e=(k[c>>2]|0)+1|0;k[c>>2]=e;if(e>>>0>=f>>>0){Uh[k[(k[a+460>>2]|0)+12>>2]&2047](a);a=4;return a|0}d=k[M>>2]|0;do if((k[a+340>>2]|0)<=1){c=k[a+344>>2]|0;if(e>>>0<(f+-1|0)>>>0){k[d+28>>2]=k[c+12>>2];break}else{k[d+28>>2]=k[c+76>>2];break}}else k[d+28>>2]=1;while(0);k[d+20>>2]=0;k[d+24>>2]=0;a=3;return a|0}function Qab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;ra=r;r=r+128|0;na=ra;oa=k[a+452>>2]|0;pa=a+332|0;qa=(k[pa>>2]|0)+-1|0;l=a+144|0;n=a+152|0;c=a+460|0;d=a+412|0;e=a+148|0;ma=a+156|0;while(1){f=k[l>>2]|0;g=k[n>>2]|0;if((f|0)>(g|0))break;h=k[c>>2]|0;if(k[h+20>>2]|0)break;if((f|0)==(g|0)?(k[e>>2]|0)>>>0>((k[ma>>2]|0)+((k[d>>2]|0)==0&1)|0)>>>0:0)break;if(!(Xh[k[h>>2]&1023](a)|0)){c=0;o=59;break}}if((o|0)==59){r=ra;return c|0}da=a+36|0;if((k[da>>2]|0)>0){ea=a+4|0;fa=oa+112|0;ga=a+472|0;ha=na+4|0;ia=na+18|0;ja=na+32|0;ka=na+16|0;la=na+2|0;$=0;ba=k[a+216>>2]|0;while(1){if(k[ba+52>>2]|0){d=k[ma>>2]|0;e=ba+12|0;f=k[e>>2]|0;if(d>>>0<qa>>>0){c=f<<1;g=0;ca=f}else{ca=((k[ba+32>>2]|0)>>>0)%(f>>>0)|0;ca=(ca|0)==0?f:ca;c=ca;g=1}if(!d){Z=$g[k[(k[ea>>2]|0)+32>>2]&127](a,k[oa+72+($<<2)>>2]|0,0,c,0)|0;c=1}else{Z=aa(f,d+-1|0)|0;Z=$g[k[(k[ea>>2]|0)+32>>2]&127](a,k[oa+72+($<<2)>>2]|0,Z,f+c|0,0)|0;Z=Z+(k[e>>2]<<2)|0;c=0}d=(k[fa>>2]|0)+($*6<<2)|0;e=k[ba+80>>2]|0;o=k[e>>2]|0;l=o&65535;o=o>>>16;f=k[e+16>>2]|0;n=f&65535;h=m[e+32>>1]|0;f=f>>>16;e=m[e+4>>1]|0;_=k[(k[ga>>2]|0)+4+($<<2)>>2]|0;if((ca|0)>0){Y=(c|0)!=0;X=(g|0)!=0;R=ca+-1|0;S=ba+28|0;T=d+4|0;U=d+8|0;V=d+12|0;W=d+16|0;N=d+20|0;O=ba+36|0;P=l*9|0;Q=e<<7;K=e<<8;L=l*5|0;M=f<<7;I=f<<8;J=h<<7;H=h<<8;F=l*36|0;G=n<<7;D=n<<8;E=o<<7;A=o<<8;B=ba+40|0;y=0;z=k[b+($<<2)>>2]|0;while(1){c=k[Z+(y<<2)>>2]|0;if(Y&(y|0)==0)d=c;else d=k[Z+(y+-1<<2)>>2]|0;if(X&(y|0)==(R|0))e=c;else e=k[Z+(y+1<<2)>>2]|0;l=j[d>>1]|0;q=j[c>>1]|0;h=j[e>>1]|0;C=(k[S>>2]|0)+-1|0;u=h;v=q;w=l;x=0;t=0;s=e;while(1){e=na;f=c;g=e+128|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));if(x>>>0<C>>>0){n=j[s+128>>1]|0;o=j[c+128>>1]|0;p=j[d+128>>1]|0}else{n=u;o=v;p=w}g=k[T>>2]|0;if((g|0)!=0&(j[la>>1]|0)==0){e=aa(F,q-o|0)|0;if((e|0)>-1){e=(e+E|0)/(A|0)|0;f=1<<g;if((g|0)>0)e=(e|0)<(f|0)?e:f+-1|0}else{e=(E-e|0)/(A|0)|0;f=1<<g;e=0-((g|0)>0?((e|0)<(f|0)?e:f+-1|0):e)|0}j[la>>1]=e}g=k[U>>2]|0;if((g|0)!=0&(j[ka>>1]|0)==0){e=aa(F,w-u|0)|0;if((e|0)>-1){e=(e+G|0)/(D|0)|0;f=1<<g;if((g|0)>0)e=(e|0)<(f|0)?e:f+-1|0}else{e=(G-e|0)/(D|0)|0;f=1<<g;e=0-((g|0)>0?((e|0)<(f|0)?e:f+-1|0):e)|0}j[ka>>1]=e}g=k[V>>2]|0;if((g|0)!=0&(j[ja>>1]|0)==0){e=aa(P,w-(v<<1)+u|0)|0;if((e|0)>-1){e=(e+J|0)/(H|0)|0;f=1<<g;if((g|0)>0)e=(e|0)<(f|0)?e:f+-1|0}else{e=(J-e|0)/(H|0)|0;f=1<<g;e=0-((g|0)>0?((e|0)<(f|0)?e:f+-1|0):e)|0}j[ja>>1]=e}g=k[W>>2]|0;if((g|0)!=0&(j[ia>>1]|0)==0){e=aa(L,l-h-p+n|0)|0;do if((e|0)>-1){e=(e+M|0)/(I|0)|0;f=1<<g;if((g|0)<=0)break;e=(e|0)<(f|0)?e:f+-1|0}else{e=(M-e|0)/(I|0)|0;l=1<<g;e=0-((g|0)>0?((e|0)<(l|0)?e:l+-1|0):e)|0}while(0);j[ia>>1]=e}g=k[N>>2]|0;if((g|0)!=0&(j[ha>>1]|0)==0){e=aa(P,q-(v<<1)+o|0)|0;do if((e|0)>-1){e=(e+Q|0)/(K|0)|0;f=1<<g;if((g|0)<=0)break;e=(e|0)<(f|0)?e:f+-1|0}else{e=(Q-e|0)/(K|0)|0;q=1<<g;e=0-((g|0)>0?((e|0)<(q|0)?e:q+-1|0):e)|0}while(0);j[ha>>1]=e}eh[_&255](a,ba,na,z,t);x=x+1|0;if(x>>>0>C>>>0)break;else{l=w;q=v;h=u;u=n;v=o;w=p;c=c+128|0;t=(k[O>>2]|0)+t|0;d=d+128|0;s=s+128|0}}y=y+1|0;if((y|0)==(ca|0))break;else z=z+(k[B>>2]<<2)|0}}}$=$+1|0;if(($|0)>=(k[da>>2]|0))break;else ba=ba+88|0}}qa=(k[ma>>2]|0)+1|0;k[ma>>2]=qa;qa=qa>>>0<(k[pa>>2]|0)>>>0?3:4;r=ra;return qa|0}function Rab(a){a=a|0;return}function Sab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=k[a+112>>2]|0;if((e|0)<=0)return;a=(k[b>>2]|0)+(c<<2)|0;while(1){upb(k[d>>2]|0,k[a>>2]|0,f|0)|0;if((e|0)>1){a=a+4|0;d=d+4|0;e=e+-1|0}else break}return}function Tab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;p=k[(k[a+480>>2]|0)+24>>2]|0;m=k[a+112>>2]|0;if((e|0)<=0)return;n=b+4|0;o=b+8|0;if(!m)return;while(1){f=k[(k[b>>2]|0)+(c<<2)>>2]|0;g=k[(k[n>>2]|0)+(c<<2)>>2]|0;h=k[(k[o>>2]|0)+(c<<2)>>2]|0;j=k[d>>2]|0;a=0;do{i[j+a>>0]=((k[p+((l[g+a>>0]|0|256)<<2)>>2]|0)+(k[p+((l[f+a>>0]|0)<<2)>>2]|0)+(k[p+((l[h+a>>0]|0|512)<<2)>>2]|0)|0)>>>16;a=a+1|0}while((a|0)!=(m|0));if((e|0)>1){d=d+4|0;c=c+1|0;e=e+-1|0}else break}return}function Uab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0;p=k[(k[a+480>>2]|0)+24>>2]|0;m=k[a+112>>2]|0;if((e|0)<=0)return;n=b+4|0;o=b+8|0;if(!m)return;while(1){f=k[(k[b>>2]|0)+(c<<2)>>2]|0;g=k[(k[n>>2]|0)+(c<<2)>>2]|0;h=k[(k[o>>2]|0)+(c<<2)>>2]|0;j=k[d>>2]|0;a=0;do{q=l[g+a>>0]|0;i[j+a>>0]=((k[p+((q|256)<<2)>>2]|0)+(k[p+(((l[f+a>>0]|0)+128+q&255)<<2)>>2]|0)+(k[p+((q+128+(l[h+a>>0]|0)&255|512)<<2)>>2]|0)|0)>>>16;a=a+1|0}while((a|0)!=(m|0));if((e|0)>1){d=d+4|0;c=c+1|0;e=e+-1|0}else break}return}function Vab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;q=k[a+480>>2]|0;t=k[a+112>>2]|0;m=k[a+336>>2]|0;n=k[q+8>>2]|0;o=k[q+12>>2]|0;p=k[q+16>>2]|0;q=k[q+20>>2]|0;if((e|0)<=0)return;r=b+4|0;s=b+8|0;if(!t)return;while(1){g=k[(k[b>>2]|0)+(c<<2)>>2]|0;h=k[(k[r>>2]|0)+(c<<2)>>2]|0;j=k[(k[s>>2]|0)+(c<<2)>>2]|0;a=k[d>>2]|0;f=0;while(1){u=l[g+f>>0]|0;v=l[h+f>>0]|0;w=l[j+f>>0]|0;i[a>>0]=i[m+((k[n+(w<<2)>>2]|0)+u)>>0]|0;i[a+1>>0]=i[m+(((k[p+(w<<2)>>2]|0)+(k[q+(v<<2)>>2]|0)>>16)+u)>>0]|0;i[a+2>>0]=i[m+((k[o+(v<<2)>>2]|0)+u)>>0]|0;f=f+1|0;if((f|0)==(t|0))break;else a=a+3|0}if((e|0)>1){d=d+4|0;c=c+1|0;e=e+-1|0}else break}return}function Wab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;h=k[a+112>>2]|0;if((e|0)<1|(h|0)==0)return;while(1){g=k[(k[b>>2]|0)+(c<<2)>>2]|0;a=0;f=k[d>>2]|0;while(1){j=i[g+a>>0]|0;i[f+2>>0]=j;i[f+1>>0]=j;i[f>>0]=j;a=a+1|0;if((a|0)==(h|0))break;else f=f+3|0}if((e|0)>1){d=d+4|0;c=c+1|0;e=e+-1|0}else break}return}function Xab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0;l=k[a+112>>2]|0;if((e|0)<=0)return;m=b+4|0;n=b+8|0;if(!l)return;while(1){g=k[(k[b>>2]|0)+(c<<2)>>2]|0;h=k[(k[m>>2]|0)+(c<<2)>>2]|0;j=k[(k[n>>2]|0)+(c<<2)>>2]|0;a=0;f=k[d>>2]|0;while(1){i[f>>0]=i[g+a>>0]|0;i[f+1>>0]=i[h+a>>0]|0;i[f+2>>0]=i[j+a>>0]|0;a=a+1|0;if((a|0)==(l|0))break;else f=f+3|0}if((e|0)>1){d=d+4|0;c=c+1|0;e=e+-1|0}else break}return}function Yab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0;m=k[a+112>>2]|0;if((e|0)<=0)return;n=b+4|0;o=b+8|0;if(!m)return;while(1){g=k[(k[b>>2]|0)+(c<<2)>>2]|0;h=k[(k[n>>2]|0)+(c<<2)>>2]|0;j=k[(k[o>>2]|0)+(c<<2)>>2]|0;a=0;f=k[d>>2]|0;while(1){r=i[h+a>>0]|0;q=r&255;p=l[j+a>>0]|0;i[f>>0]=(l[g+a>>0]|0)+128+q;i[f+1>>0]=r;i[f+2>>0]=q+128+p;a=a+1|0;if((a|0)==(m|0))break;else f=f+3|0}if((e|0)>1){d=d+4|0;c=c+1|0;e=e+-1|0}else break}return}function Zab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;r=k[a+480>>2]|0;v=k[a+112>>2]|0;n=k[a+336>>2]|0;o=k[r+8>>2]|0;p=k[r+12>>2]|0;q=k[r+16>>2]|0;r=k[r+20>>2]|0;if((e|0)<=0)return;s=b+4|0;t=b+8|0;u=b+12|0;if(!v)return;while(1){g=k[(k[b>>2]|0)+(c<<2)>>2]|0;h=k[(k[s>>2]|0)+(c<<2)>>2]|0;j=k[(k[t>>2]|0)+(c<<2)>>2]|0;m=k[(k[u>>2]|0)+(c<<2)>>2]|0;a=k[d>>2]|0;f=0;while(1){w=l[h+f>>0]|0;y=l[j+f>>0]|0;x=(l[g+f>>0]|0)^255;i[a>>0]=i[n+(x-(k[o+(y<<2)>>2]|0))>>0]|0;i[a+1>>0]=i[n+(x-((k[q+(y<<2)>>2]|0)+(k[r+(w<<2)>>2]|0)>>16))>>0]|0;i[a+2>>0]=i[n+(x-(k[p+(w<<2)>>2]|0))>>0]|0;i[a+3>>0]=i[m+f>>0]|0;f=f+1|0;if((f|0)==(v|0))break;else a=a+4|0}if((e|0)>1){d=d+4|0;c=c+1|0;e=e+-1|0}else break}return}function _ab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=k[a+36>>2]|0;m=k[a+112>>2]|0;if((e|0)<=0)return;l=(m|0)==0;if((n|0)<=0)return;while(1){j=e;e=e+-1|0;if(!l){h=0;do{a=0;f=k[(k[b+(h<<2)>>2]|0)+(c<<2)>>2]|0;g=(k[d>>2]|0)+h|0;while(1){i[g>>0]=i[f>>0]|0;a=a+1|0;if((a|0)==(m|0))break;else{f=f+1|0;g=g+n|0}}h=h+1|0}while((h|0)!=(n|0))}if((j|0)<=1)break;else{d=d+4|0;c=c+1|0}}return}function $ab(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,q=0,r=0,s=0,t=0.0,u=0;i=k[a+472>>2]|0;n=a+36|0;if((k[n>>2]|0)<=0)return;r=a+72|0;g=0;h=k[a+216>>2]|0;d=0;e=0;while(1){b=k[h+36>>2]|0;c=h+40|0;a:do switch((b<<8)+(k[c>>2]|0)|0){case 257:{b=0;f=170;break}case 514:{b=0;f=171;break}case 771:{b=0;f=172;break}case 1028:{b=0;f=173;break}case 1285:{b=0;f=174;break}case 1542:{b=0;f=175;break}case 1799:{b=0;f=176;break}case 2313:{b=0;f=177;break}case 2570:{b=0;f=178;break}case 2827:{b=0;f=179;break}case 3084:{b=0;f=180;break}case 3341:{b=0;f=181;break}case 3598:{b=0;f=182;break}case 3855:{b=0;f=183;break}case 4112:{b=0;f=184;break}case 4104:{b=0;f=185;break}case 3591:{b=0;f=186;break}case 3078:{b=0;f=187;break}case 2565:{b=0;f=188;break}case 2052:{b=0;f=189;break}case 1539:{b=0;f=190;break}case 1026:{b=0;f=191;break}case 513:{b=0;f=192;break}case 2064:{b=0;f=193;break}case 1806:{b=0;f=194;break}case 1548:{b=0;f=195;break}case 1290:{b=0;f=196;break}case 1032:{b=0;f=197;break}case 774:{b=0;f=198;break}case 516:{b=0;f=199;break}case 258:{b=0;f=200;break}case 2056:{b=k[r>>2]|0;switch(b|0){case 0:{b=0;f=201;break a}case 1:{f=202;break a}case 2:{f=203;break a}default:{b=k[a>>2]|0;k[b+20>>2]=49;Uh[k[b>>2]&2047](a);b=d;f=e;break a}}}default:{f=k[a>>2]|0;k[f+20>>2]=7;k[f+24>>2]=b;k[f+28>>2]=k[c>>2];Uh[k[f>>2]&2047](a);b=d;f=e}}while(0);k[i+4+(g<<2)>>2]=f;b:do if((k[h+52>>2]|0?(l=i+44+(g<<2)|0,(k[l>>2]|0)!=(b|0)):0)?(q=k[h+80>>2]|0,q|0):0){k[l>>2]=b;switch(b|0){case 0:{d=k[h+84>>2]|0;c=0;do{k[d+(c<<2)>>2]=m[q+(c<<1)>>1];c=c+1|0}while((c|0)!=64);break}case 1:{d=k[h+84>>2]|0;c=0;do{e=(aa(j[172800+(c<<1)>>1]|0,m[q+(c<<1)>>1]|0)|0)+2048>>12;k[d+(c<<2)>>2]=e;c=c+1|0}while((c|0)!=64);break}case 2:{e=k[h+84>>2]|0;c=0;d=0;while(1){t=+p[23032+(c<<3)>>3];o[e+(d<<2)>>2]=+(m[q+(d<<1)>>1]|0)*t*.125;s=d|1;o[e+(s<<2)>>2]=+(m[q+(s<<1)>>1]|0)*t*1.387039845*.125;s=s+1|0;o[e+(s<<2)>>2]=+(m[q+(s<<1)>>1]|0)*t*1.306562965*.125;s=d|3;o[e+(s<<2)>>2]=+(m[q+(s<<1)>>1]|0)*t*1.175875602*.125;u=s+1|0;o[e+(u<<2)>>2]=+(m[q+(u<<1)>>1]|0)*t*.125;u=s+2|0;o[e+(u<<2)>>2]=+(m[q+(u<<1)>>1]|0)*t*.785694958*.125;s=s+3|0;o[e+(s<<2)>>2]=+(m[q+(s<<1)>>1]|0)*t*.5411961*.125;s=d|7;o[e+(s<<2)>>2]=+(m[q+(s<<1)>>1]|0)*t*.275899379*.125;c=c+1|0;if((c|0)==8)break;else d=d+8|0}break}default:{u=k[a>>2]|0;k[u+20>>2]=49;Uh[k[u>>2]&2047](a);break b}}}while(0);g=g+1|0;if((g|0)>=(k[n>>2]|0))break;else{h=h+88|0;d=b;e=f}}return}function abb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;n=k[a+468>>2]|0;m=a+412|0;e=k[m>>2]|0;c=(e|0)==0;if(!(k[a+224>>2]|0)){if((c?(k[a+420>>2]|0)==0:0)?(k[a+424>>2]|0)==0:0){m=k[a+416>>2]|0;if((k[a+220>>2]|0)!=0|(m|0)<64?(m|0)!=(k[a+436>>2]|0):0)d=44}else d=44;if((d|0)==44){m=k[a>>2]|0;k[m+20>>2]=125;jh[k[m+4>>2]&1023](a,-1)}f=a+436|0;k[n+4>>2]=(k[f>>2]|0)==63?302:301;c=a+340|0;if((k[c>>2]|0)>0){b=0;do{d=k[a+344+(b<<2)>>2]|0;m=k[d+20>>2]|0;fbb(a,1,m,n+64+(m<<2)|0);if(k[f>>2]|0){m=k[d+24>>2]|0;fbb(a,0,m,n+80+(m<<2)|0)}k[n+20+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}d=a+368|0;if((k[d>>2]|0)>0)c=0;else{m=n+12|0;k[m>>2]=0;m=n+8|0;k[m>>2]=0;m=n+36|0;k[m>>2]=0;a=a+280|0;a=k[a>>2]|0;n=n+40|0;k[n>>2]=a;return}do{b=k[a+344+(k[a+372+(c<<2)>>2]<<2)>>2]|0;k[n+96+(c<<2)>>2]=k[n+64+(k[b+20>>2]<<2)>>2];k[n+136+(c<<2)>>2]=k[n+80+(k[b+24>>2]<<2)>>2];a:do if(!(k[b+52>>2]|0))k[n+176+(c<<2)>>2]=0;else{e=k[b+40>>2]|0;b=k[b+36>>2]|0;switch(k[f>>2]|0){case 0:{k[n+176+(c<<2)>>2]=1;break a}case 3:{l=e+-1|0;m=b+-1|0;k[n+176+(c<<2)>>2]=(k[154692+((l>>>0>1?1:l)<<3)+((m>>>0>1?1:m)<<2)>>2]|0)+1;break a}case 8:{l=e+-1|0;m=b+-1|0;k[n+176+(c<<2)>>2]=(k[154708+((l>>>0>2?2:l)*12|0)+((m>>>0>2?2:m)<<2)>>2]|0)+1;break a}case 15:{l=e+-1|0;m=b+-1|0;k[n+176+(c<<2)>>2]=(k[154744+((l>>>0>3?3:l)<<4)+((m>>>0>3?3:m)<<2)>>2]|0)+1;break a}case 24:{l=e+-1|0;m=b+-1|0;k[n+176+(c<<2)>>2]=(k[154808+((l>>>0>4?4:l)*20|0)+((m>>>0>4?4:m)<<2)>>2]|0)+1;break a}case 35:{l=e+-1|0;m=b+-1|0;k[n+176+(c<<2)>>2]=(k[154908+((l>>>0>5?5:l)*24|0)+((m>>>0>5?5:m)<<2)>>2]|0)+1;break a}case 48:{l=e+-1|0;m=b+-1|0;k[n+176+(c<<2)>>2]=(k[155052+((l>>>0>6?6:l)*28|0)+((m>>>0>6?6:m)<<2)>>2]|0)+1;break a}default:{l=e+-1|0;m=b+-1|0;k[n+176+(c<<2)>>2]=(k[155248+((l>>>0>7?7:l)<<5)+((m>>>0>7?7:m)<<2)>>2]|0)+1;break a}}}while(0);c=c+1|0}while((c|0)<(k[d>>2]|0));m=n+12|0;k[m>>2]=0;m=n+8|0;k[m>>2]=0;m=n+36|0;k[m>>2]=0;a=a+280|0;a=k[a>>2]|0;n=n+40|0;k[n>>2]=a;return}j=a+416|0;b=k[j>>2]|0;if(c)if(!b)d=7;else d=11;else if(((b|0)>=(e|0)?(b|0)<=(k[a+436>>2]|0):0)?(k[a+340>>2]|0)==1:0)d=7;else d=11;do if((d|0)==7){b=k[a+420>>2]|0;if(b){b=b+-1|0;if((b|0)!=(k[a+424>>2]|0)){d=11;break}}else b=k[a+424>>2]|0;if((b|0)>13)d=11}while(0);if((d|0)==11){l=k[a>>2]|0;k[l+20>>2]=17;k[l+24>>2]=e;k[l+28>>2]=k[j>>2];k[l+32>>2]=k[a+420>>2];k[l+36>>2]=k[a+424>>2];Uh[k[l>>2]&2047](a)}l=a+340|0;b=k[l>>2]|0;if((b|0)>0){h=a+160|0;g=a+420|0;i=a+424|0;f=0;do{d=k[(k[a+344+(f<<2)>>2]|0)+4>>2]|0;e=k[h>>2]|0;b=k[m>>2]|0;if(b){if((k[e+(d<<8)>>2]|0)<0){b=k[a>>2]|0;k[b+20>>2]=118;k[b+24>>2]=d;k[b+28>>2]=0;jh[k[b+4>>2]&1023](a,-1);b=k[m>>2]|0}}else b=0;if((b|0)<=(k[j>>2]|0))while(1){c=e+(d<<8)+(b<<2)|0;o=k[c>>2]|0;if((k[g>>2]|0)!=(((o|0)<0?0:o)|0)){o=k[a>>2]|0;k[o+20>>2]=118;k[o+24>>2]=d;k[o+28>>2]=b;jh[k[o+4>>2]&1023](a,-1)}k[c>>2]=k[i>>2];if((b|0)<(k[j>>2]|0))b=b+1|0;else break}f=f+1|0;b=k[l>>2]|0}while((f|0)<(b|0))}else g=a+420|0;e=k[m>>2]|0;c=(e|0)==0;d=n+4|0;do if(!(k[g>>2]|0))if(c){k[d>>2]=297;break}else{k[d>>2]=298;break}else if(c){k[d>>2]=299;break}else{k[d>>2]=300;break}while(0);b:do if((b|0)>0){f=n+60|0;b=0;d=e;while(1){c=k[a+344+(b<<2)>>2]|0;if(!d){if(!(k[g>>2]|0)){o=k[c+20>>2]|0;fbb(a,1,o,n+44+(o<<2)|0)}}else{j=k[c+24>>2]|0;o=n+44+(j<<2)|0;fbb(a,0,j,o);k[f>>2]=k[o>>2]}k[n+20+(b<<2)>>2]=0;b=b+1|0;if((b|0)>=(k[l>>2]|0))break b;d=k[m>>2]|0}}while(0);k[n+16>>2]=0;o=n+12|0;k[o>>2]=0;o=n+8|0;k[o>>2]=0;o=n+36|0;k[o>>2]=0;a=a+280|0;a=k[a>>2]|0;o=n+40|0;k[o>>2]=a;return}function bbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+48|0;y=B+20|0;z=B;A=k[a+468>>2]|0;u=k[a+424>>2]|0;f=a+280|0;if(k[f>>2]|0?(d=A+40|0,(k[d>>2]|0)==0):0){w=A+12|0;x=k[a+464>>2]|0;v=x+24|0;k[v>>2]=(k[v>>2]|0)+((k[w>>2]|0)/8|0);k[w>>2]=0;if(!(Xh[k[x+8>>2]&1023](a)|0)){A=0;r=B;return A|0}e=a+340|0;if((k[e>>2]|0)>0){c=0;do{k[A+20+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}k[A+16>>2]=0;k[d>>2]=k[f>>2];if(!(k[a+440>>2]|0))k[A+36>>2]=0}if(!(k[A+36>>2]|0)){k[y+16>>2]=a;s=a+24|0;e=k[s>>2]|0;d=k[e>>2]|0;k[y>>2]=d;c=k[e+4>>2]|0;t=y+4|0;k[t>>2]=c;v=A+8|0;f=k[v>>2]|0;w=A+12|0;g=k[w>>2]|0;x=A+16|0;k[z>>2]=k[x>>2];k[z+4>>2]=k[x+4>>2];k[z+8>>2]=k[x+8>>2];k[z+12>>2]=k[x+12>>2];k[z+16>>2]=k[x+16>>2];q=a+368|0;do if((k[q>>2]|0)>0){o=y+8|0;p=y+12|0;i=0;while(1){m=k[b+(i<<2)>>2]|0;n=k[a+372+(i<<2)>>2]|0;e=k[A+44+(k[(k[a+344+(n<<2)>>2]|0)+20>>2]<<2)>>2]|0;if((g|0)<8){if(!(ibb(y,f,g,0)|0)){c=0;h=27;break}f=k[o>>2]|0;g=k[p>>2]|0;if((g|0)<8){c=1;h=16}else h=14}else h=14;if((h|0)==14){h=0;c=f>>g+-8&255;d=k[e+144+(c<<2)>>2]|0;if(!d){c=9;h=16}else{c=l[e+1168+c>>0]|0;g=g-d|0}}if((h|0)==16){c=jbb(y,f,g,e,c)|0;if((c|0)<0){c=0;h=27;break}g=k[p>>2]|0;f=k[o>>2]|0}if(!c)c=0;else{if((g|0)<(c|0)){if(!(ibb(y,f,g,c)|0)){c=0;h=27;break}g=k[p>>2]|0;f=k[o>>2]|0}g=g-c|0;h=k[155504+(c<<2)>>2]|0;e=f>>g&h;c=e-((e|0)>(k[155504+(c+-1<<2)>>2]|0)?0:h)|0}h=z+4+(n<<2)|0;n=(k[h>>2]|0)+c|0;k[h>>2]=n;j[m>>1]=n<<u;i=i+1|0;if((i|0)>=(k[q>>2]|0)){h=24;break}}if((h|0)==24){e=k[s>>2]|0;d=k[y>>2]|0;c=k[t>>2]|0;break}else if((h|0)==27){r=B;return c|0}}while(0);k[e>>2]=d;k[e+4>>2]=c;k[v>>2]=f;k[w>>2]=g;k[x>>2]=k[z>>2];k[x+4>>2]=k[z+4>>2];k[x+8>>2]=k[z+8>>2];k[x+12>>2]=k[z+12>>2];k[x+16>>2]=k[z+16>>2]}A=A+40|0;k[A>>2]=(k[A>>2]|0)+-1;A=1;r=B;return A|0}function cbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+32|0;x=z;y=k[a+468>>2]|0;e=a+280|0;if(k[e>>2]|0?(f=y+40|0,(k[f>>2]|0)==0):0){v=y+12|0;w=k[a+464>>2]|0;u=w+24|0;k[u>>2]=(k[u>>2]|0)+((k[v>>2]|0)/8|0);k[v>>2]=0;if(!(Xh[k[w+8>>2]&1023](a)|0)){y=0;r=z;return y|0}d=a+340|0;if((k[d>>2]|0)>0){c=0;do{k[y+20+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}k[y+16>>2]=0;k[f>>2]=k[e>>2];if(!(k[a+440>>2]|0))k[y+36>>2]=0}if(!(k[y+36>>2]|0)){o=k[a+416>>2]|0;p=k[a+424>>2]|0;q=k[a+432>>2]|0;w=y+16|0;c=k[w>>2]|0;if(!c){k[x+16>>2]=a;s=a+24|0;u=k[s>>2]|0;k[x>>2]=k[u>>2];t=x+4|0;k[t>>2]=k[u+4>>2];u=y+8|0;d=k[u>>2]|0;v=y+12|0;e=k[v>>2]|0;h=k[b>>2]|0;i=k[y+60>>2]|0;c=k[a+412>>2]|0;a:do if((c|0)<=(o|0)){n=x+8|0;m=x+12|0;g=c;b:while(1){if((e|0)<8){if(!(ibb(x,d,e,0)|0)){c=0;a=35;break}d=k[n>>2]|0;e=k[m>>2]|0;if((e|0)<8){c=1;a=18}else a=16}else a=16;if((a|0)==16){a=0;c=d>>e+-8&255;f=k[i+144+(c<<2)>>2]|0;if(!f){c=9;a=18}else{c=l[i+1168+c>>0]|0;e=e-f|0}}if((a|0)==18){c=jbb(x,d,e,i,c)|0;if((c|0)<0){c=0;a=35;break}e=k[m>>2]|0;d=k[n>>2]|0}b=c>>4;f=c&15;if(!f){switch(b|0){case 0:{c=0;break a}case 15:break;default:{a=26;break b}}c=g+15|0}else{c=b+g|0;if((e|0)<(f|0)){if(!(ibb(x,d,e,f)|0)){c=0;a=35;break}e=k[m>>2]|0;d=k[n>>2]|0}e=e-f|0;g=k[155504+(f<<2)>>2]|0;a=d>>e&g;j[h+(k[q+(c<<2)>>2]<<1)>>1]=a-((a|0)>(k[155504+(f+-1<<2)>>2]|0)?0:g)<<p}if((c|0)<(o|0))g=c+1|0;else{c=0;break a}}if((a|0)==26){f=1<<b;do if((e|0)<(b|0))if(!(ibb(x,d,e,b)|0)){y=0;r=z;return y|0}else{c=k[m>>2]|0;d=k[n>>2]|0;break}else c=e;while(0);e=c-b|0;c=f+-1+(d>>e&k[155504+(b<<2)>>2])|0;break}else if((a|0)==35){r=z;return c|0}}else c=0;while(0);s=k[s>>2]|0;k[s>>2]=k[x>>2];k[s+4>>2]=k[t>>2];k[u>>2]=d;k[v>>2]=e}else c=c+-1|0;k[w>>2]=c}y=y+40|0;k[y>>2]=(k[y>>2]|0)+-1;y=1;r=z;return y|0}function dbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+32|0;s=u;t=k[a+468>>2]|0;n=1<<k[a+424>>2];f=a+280|0;if(k[f>>2]|0?(d=t+40|0,(k[d>>2]|0)==0):0){p=t+12|0;q=k[a+464>>2]|0;o=q+24|0;k[o>>2]=(k[o>>2]|0)+((k[p>>2]|0)/8|0);k[p>>2]=0;if(!(Xh[k[q+8>>2]&1023](a)|0)){t=0;r=u;return t|0}e=a+340|0;if((k[e>>2]|0)>0){c=0;do{k[t+20+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[e>>2]|0))}k[t+16>>2]=0;k[d>>2]=k[f>>2];if(!(k[a+440>>2]|0))k[t+36>>2]=0}k[s+16>>2]=a;l=a+24|0;e=k[l>>2]|0;d=k[e>>2]|0;k[s>>2]=d;c=k[e+4>>2]|0;o=s+4|0;k[o>>2]=c;p=t+8|0;f=k[p>>2]|0;q=t+12|0;g=k[q>>2]|0;i=a+368|0;do if((k[i>>2]|0)>0){a=s+8|0;h=s+12|0;e=0;c=g;while(1){d=k[b+(e<<2)>>2]|0;if((c|0)<1){if(!(ibb(s,f,c,1)|0)){c=0;a=18;break}c=k[h>>2]|0;f=k[a>>2]|0}c=c+-1|0;if(1<<c&f|0)j[d>>1]=m[d>>1]|0|n;e=e+1|0;if((e|0)>=(k[i>>2]|0)){a=16;break}}if((a|0)==16){g=c;e=k[l>>2]|0;d=k[s>>2]|0;c=k[o>>2]|0;break}else if((a|0)==18){r=u;return c|0}}while(0);k[e>>2]=d;k[e+4>>2]=c;k[p>>2]=f;k[q>>2]=g;t=t+40|0;k[t>>2]=(k[t>>2]|0)+-1;t=1;r=u;return t|0}function ebb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=r;r=r+288|0;F=H+256|0;E=H;G=k[a+468>>2]|0;e=a+280|0;if(k[e>>2]|0?(f=G+40|0,(k[f>>2]|0)==0):0){A=G+12|0;B=k[a+464>>2]|0;z=B+24|0;k[z>>2]=(k[z>>2]|0)+((k[A>>2]|0)/8|0);k[A>>2]=0;if(!(Xh[k[B+8>>2]&1023](a)|0)){G=0;r=H;return G|0}d=a+340|0;if((k[d>>2]|0)>0){c=0;do{k[G+20+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}k[G+16>>2]=0;k[f>>2]=k[e>>2];if(!(k[a+440>>2]|0))k[G+36>>2]=0}do if(!(k[G+36>>2]|0)){q=k[a+416>>2]|0;t=k[a+424>>2]|0;s=1<<t;t=-1<<t;u=k[a+432>>2]|0;k[F+16>>2]=a;x=a+24|0;z=k[x>>2]|0;k[F>>2]=k[z>>2];y=F+4|0;k[y>>2]=k[z+4>>2];z=G+8|0;g=k[z>>2]|0;A=G+12|0;d=k[A>>2]|0;B=G+16|0;e=k[B>>2]|0;v=k[b>>2]|0;i=k[G+60>>2]|0;f=k[a+412>>2]|0;o=F+8|0;p=F+12|0;a:do if(!e){c=0;b:while(1){if((d|0)<8){if(!(ibb(F,g,d,0)|0))break a;g=k[o>>2]|0;d=k[p>>2]|0;if((d|0)<8){e=1;w=17}else w=15}else w=15;if((w|0)==15){w=0;e=g>>d+-8&255;b=k[i+144+(e<<2)>>2]|0;if(!b){e=9;w=17}else{e=l[i+1168+e>>0]|0;d=d-b|0}}if((w|0)==17){w=0;d=jbb(F,g,d,i,e)|0;if((d|0)<0)break a;e=d;d=k[p>>2]|0;g=k[o>>2]|0}b=e>>4;switch(e&15){case 0:{if((b|0)==15){e=15;h=0}else break b;break}case 1:{w=21;break}default:{w=k[a>>2]|0;k[w+20>>2]=121;jh[k[w+4>>2]&1023](a,-1);w=21}}if((w|0)==21){w=0;if((d|0)<1){if(!(ibb(F,g,d,1)|0))break a;d=k[p>>2]|0;g=k[o>>2]|0}d=d+-1|0;e=b;h=(1<<d&g|0)==0?t:s}c:while(1){b=v+(k[u+(f<<2)>>2]<<1)|0;do if(!(j[b>>1]|0))if((e|0)<1)break c;else e=e+-1|0;else{if((d|0)<1){if(!(ibb(F,g,d,1)|0))break a;d=k[p>>2]|0;g=k[o>>2]|0}d=d+-1|0;if((1<<d&g|0)!=0?(m=j[b>>1]|0,n=m<<16>>16,(n&s|0)==0):0)if(m<<16>>16>-1){j[b>>1]=n+s;break}else{j[b>>1]=n+t;break}}while(0);b=f+1|0;if((f|0)<(q|0))f=b;else{f=b;break}}if(h){b=k[u+(f<<2)>>2]|0;j[v+(b<<1)>>1]=h;k[E+(c<<2)>>2]=b;c=c+1|0}if((f|0)<(q|0))f=f+1|0;else{e=0;c=g;w=58;break a}}e=1<<b;if(b){if((d|0)<(b|0)){if(!(ibb(F,g,d,b)|0))break;d=k[p>>2]|0;g=k[o>>2]|0}d=d-b|0;e=(g>>d&k[155504+(b<<2)>>2])+e|0;if(!e){e=0;c=g;w=58}else w=46}else w=46}else{c=0;w=46}while(0);d:do if((w|0)==46){while(1){b=v+(k[u+(f<<2)>>2]<<1)|0;do if(j[b>>1]|0){if((d|0)<1){if(!(ibb(F,g,d,1)|0))break d;d=k[p>>2]|0;g=k[o>>2]|0}d=d+-1|0;if((1<<d&g|0)!=0?(C=j[b>>1]|0,D=C<<16>>16,(D&s|0)==0):0)if(C<<16>>16>-1){j[b>>1]=D+s;break}else{j[b>>1]=D+t;break}}while(0);if((f|0)<(q|0))f=f+1|0;else break}e=e+-1|0;c=g;w=58}while(0);if((w|0)==58){E=k[x>>2]|0;k[E>>2]=k[F>>2];k[E+4>>2]=k[y>>2];k[z>>2]=c;k[A>>2]=d;k[B>>2]=e;break}if(!c){G=0;r=H;return G|0}do{c=c+-1|0;j[v+(k[E+(c<<2)>>2]<<1)>>1]=0}while((c|0)!=0);c=0;r=H;return c|0}while(0);G=G+40|0;k[G>>2]=(k[G>>2]|0)+-1;G=1;r=H;return G|0}function fbb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+1296|0;j=u+1028|0;t=u;if(c>>>0>3){s=k[a>>2]|0;k[s+20>>2]=52;k[s+24>>2]=c;Uh[k[s>>2]&2047](a)}q=(b|0)!=0;s=k[(q?a+180+(c<<2)|0:a+196+(c<<2)|0)>>2]|0;if(!s){p=k[a>>2]|0;k[p+20>>2]=52;k[p+24>>2]=c;Uh[k[p>>2]&2047](a)}b=k[d>>2]|0;if(!b){b=ci[k[k[a+4>>2]>>2]&255](a,1,1424)|0;k[d>>2]=b;p=a}else p=a;k[b+140>>2]=s;g=1;c=0;while(1){d=i[s+g>>0]|0;e=d&255;f=e+c|0;if((f|0)>256){o=k[a>>2]|0;k[o+20>>2]=9;Uh[k[o>>2]&2047](p)}if(!(d<<24>>24))f=c;else zpb(j+c|0,g&255|0,e|0)|0;g=g+1|0;if((g|0)==17)break;else c=f}i[j+f>>0]=0;d=i[j>>0]|0;if(!(d<<24>>24)){e=1;c=0}else{e=0;h=d<<24>>24;c=0;while(1){if((d<<24>>24|0)==(h|0)){d=e;while(1){g=c+1|0;k[t+(c<<2)>>2]=d;c=d+1|0;d=i[j+g>>0]|0;if((d<<24>>24|0)==(h|0)){d=c;c=g}else{e=c;c=g;break}}}if((e|0)>=(1<<h|0)){o=k[a>>2]|0;k[o+20>>2]=9;Uh[k[o>>2]&2047](p)}if(!(d<<24>>24)){e=1;c=0;break}else{e=e<<1;h=h+1|0}}}do{d=s+e|0;if(!(i[d>>0]|0))d=-1;else{k[b+72+(e<<2)>>2]=c-(k[t+(c<<2)>>2]|0);d=(l[d>>0]|0)+c|0;c=d;d=k[t+(d+-1<<2)>>2]|0}k[b+(e<<2)>>2]=d;e=e+1|0}while((e|0)!=17);k[b+68>>2]=1048575;zpb(b+144|0,0,1024)|0;o=1;c=0;do{j=s+o|0;if(i[j>>0]|0){m=8-o|0;n=1<<m;h=1;while(1){g=s+17+c|0;d=n;e=k[t+(c<<2)>>2]<<m;while(1){k[b+144+(e<<2)>>2]=o;i[b+1168+e>>0]=i[g>>0]|0;if((d|0)>1){d=d+-1|0;e=e+1|0}else break}c=c+1|0;if((h|0)<(l[j>>0]|0))h=h+1|0;else break}}o=o+1|0}while((o|0)!=9);if(q&(f|0)>0)b=0;else{r=u;return}do{if((l[s+17+b>>0]|0)>15){t=k[a>>2]|0;k[t+20>>2]=9;Uh[k[t>>2]&2047](p)}b=b+1|0}while((b|0)!=(f|0));r=u;return}function gbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+48|0;z=C+20|0;A=C;B=k[a+468>>2]|0;e=a+280|0;if(k[e>>2]|0?(f=B+40|0,(k[f>>2]|0)==0):0){x=B+12|0;y=k[a+464>>2]|0;w=y+24|0;k[w>>2]=(k[w>>2]|0)+((k[x>>2]|0)/8|0);k[x>>2]=0;if(!(Xh[k[y+8>>2]&1023](a)|0)){B=0;r=C;return B|0}d=a+340|0;if((k[d>>2]|0)>0){c=0;do{k[B+20+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}k[B+16>>2]=0;k[f>>2]=k[e>>2];if(!(k[a+440>>2]|0))k[B+36>>2]=0}if(!(k[B+36>>2]|0)){k[z+16>>2]=a;u=a+24|0;e=k[u>>2]|0;d=k[e>>2]|0;k[z>>2]=d;c=k[e+4>>2]|0;v=z+4|0;k[v>>2]=c;w=B+8|0;g=k[w>>2]|0;x=B+12|0;f=k[x>>2]|0;y=B+16|0;k[A>>2]=k[y>>2];k[A+4>>2]=k[y+4>>2];k[A+8>>2]=k[y+8>>2];k[A+12>>2]=k[y+12>>2];k[A+16>>2]=k[y+16>>2];t=a+368|0;do if((k[t>>2]|0)>0){q=z+8|0;s=z+12|0;p=0;a:while(1){m=k[b+(p<<2)>>2]|0;e=k[B+96+(p<<2)>>2]|0;if((f|0)<8){if(!(ibb(z,g,f,0)|0)){c=0;n=64;break}g=k[q>>2]|0;f=k[s>>2]|0;if((f|0)<8){c=1;n=16}else n=14}else n=14;if((n|0)==14){n=0;c=g>>f+-8&255;d=k[e+144+(c<<2)>>2]|0;if(!d){c=9;n=16}else{c=l[e+1168+c>>0]|0;f=f-d|0}}if((n|0)==16){c=jbb(z,g,f,e,c)|0;if((c|0)<0){c=0;n=64;break}g=k[q>>2]|0;f=k[s>>2]|0}o=k[B+136+(p<<2)>>2]|0;i=k[B+176+(p<<2)>>2]|0;d=(c|0)!=0;b:do if(!i)if(d){if((f|0)<(c|0)){if(!(ibb(z,g,f,c)|0)){c=0;n=64;break a}g=k[q>>2]|0;f=k[s>>2]|0}f=f-c|0;e=1;n=46}else{e=1;n=46}else{if(d){if((f|0)<(c|0)){if(!(ibb(z,g,f,c)|0)){c=0;n=64;break a}g=k[q>>2]|0;f=k[s>>2]|0}f=f-c|0;n=k[155504+(c<<2)>>2]|0;h=g>>f&n;c=h-((h|0)>(k[155504+(c+-1<<2)>>2]|0)?0:n)|0}else c=0;h=A+4+(k[a+372+(p<<2)>>2]<<2)|0;n=(k[h>>2]|0)+c|0;k[h>>2]=n;j[m>>1]=n;if((i|0)>1){h=1;do{if((f|0)<8){if(!(ibb(z,g,f,0)|0)){c=0;n=64;break a}g=k[q>>2]|0;f=k[s>>2]|0;if((f|0)<8){c=1;n=30}else n=28}else n=28;if((n|0)==28){n=0;d=g>>f+-8&255;c=k[o+144+(d<<2)>>2]|0;if(!c){c=9;n=30}else{f=f-c|0;c=l[o+1168+d>>0]|0}}if((n|0)==30){n=0;c=jbb(z,g,f,o,c)|0;if((c|0)<0){c=0;n=64;break a}g=k[q>>2]|0;f=k[s>>2]|0}d=c>>4;e=c&15;if(!e){if((d|0)!=15)break b;c=h+15|0}else{c=d+h|0;if((f|0)<(e|0)){if(!(ibb(z,g,f,e)|0)){c=0;n=64;break a}g=k[q>>2]|0;f=k[s>>2]|0}f=f-e|0;h=k[155504+(e<<2)>>2]|0;d=g>>f&h;j[m+(k[153432+(c<<2)>>2]<<1)>>1]=d-((d|0)>(k[155504+(e+-1<<2)>>2]|0)?0:h)}h=c+1|0}while((h|0)<(i|0));if((h|0)<64){e=h;n=46}}else{e=1;n=46}}while(0);c:do if((n|0)==46)while(1){if((f|0)<8){if(!(ibb(z,g,f,0)|0)){c=0;n=64;break a}g=k[q>>2]|0;f=k[s>>2]|0;if((f|0)<8){c=1;n=51}else n=49}else n=49;if((n|0)==49){n=0;c=g>>f+-8&255;d=k[o+144+(c<<2)>>2]|0;if(!d){c=9;n=51}else{c=l[o+1168+c>>0]|0;f=f-d|0}}if((n|0)==51){c=jbb(z,g,f,o,c)|0;if((c|0)<0){c=0;n=64;break a}g=k[q>>2]|0;f=k[s>>2]|0}d=c>>4;c=c&15;if(!c)if((d|0)==15)c=15;else break c;else{if((f|0)<(c|0)){if(!(ibb(z,g,f,c)|0)){c=0;n=64;break a}g=k[q>>2]|0;f=k[s>>2]|0}f=f-c|0;c=d}e=e+1+c|0;if((e|0)>=64)break;else n=46}while(0);p=p+1|0;if((p|0)>=(k[t>>2]|0)){n=61;break}}if((n|0)==61){e=k[u>>2]|0;d=k[z>>2]|0;c=k[v>>2]|0;break}else if((n|0)==64){r=C;return c|0}}while(0);k[e>>2]=d;k[e+4>>2]=c;k[w>>2]=g;k[x>>2]=f;k[y>>2]=k[A>>2];k[y+4>>2]=k[A+4>>2];k[y+8>>2]=k[A+8>>2];k[y+12>>2]=k[A+12>>2];k[y+16>>2]=k[A+16>>2]}B=B+40|0;k[B>>2]=(k[B>>2]|0)+-1;B=1;r=C;return B|0}function hbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+48|0;A=D+20|0;B=D;C=k[a+468>>2]|0;e=a+280|0;if(k[e>>2]|0?(f=C+40|0,(k[f>>2]|0)==0):0){y=C+12|0;z=k[a+464>>2]|0;x=z+24|0;k[x>>2]=(k[x>>2]|0)+((k[y>>2]|0)/8|0);k[y>>2]=0;if(!(Xh[k[z+8>>2]&1023](a)|0)){C=0;r=D;return C|0}d=a+340|0;if((k[d>>2]|0)>0){c=0;do{k[C+20+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}k[C+16>>2]=0;k[f>>2]=k[e>>2];if(!(k[a+440>>2]|0))k[C+36>>2]=0}if(!(k[C+36>>2]|0)){s=k[a+432>>2]|0;t=k[a+436>>2]|0;k[A+16>>2]=a;v=a+24|0;e=k[v>>2]|0;d=k[e>>2]|0;k[A>>2]=d;c=k[e+4>>2]|0;w=A+4|0;k[w>>2]=c;x=C+8|0;g=k[x>>2]|0;y=C+12|0;f=k[y>>2]|0;z=C+16|0;k[B>>2]=k[z>>2];k[B+4>>2]=k[z+4>>2];k[B+8>>2]=k[z+8>>2];k[B+12>>2]=k[z+12>>2];k[B+16>>2]=k[z+16>>2];u=a+368|0;do if((k[u>>2]|0)>0){p=A+8|0;q=A+12|0;o=0;a:while(1){i=k[b+(o<<2)>>2]|0;e=k[C+96+(o<<2)>>2]|0;if((f|0)<8){if(!(ibb(A,g,f,0)|0)){c=0;m=64;break}g=k[p>>2]|0;f=k[q>>2]|0;if((f|0)<8){c=1;m=16}else m=14}else m=14;if((m|0)==14){m=0;c=g>>f+-8&255;d=k[e+144+(c<<2)>>2]|0;if(!d){c=9;m=16}else{c=l[e+1168+c>>0]|0;f=f-d|0}}if((m|0)==16){c=jbb(A,g,f,e,c)|0;if((c|0)<0){c=0;m=64;break}g=k[p>>2]|0;f=k[q>>2]|0}n=k[C+136+(o<<2)>>2]|0;h=k[C+176+(o<<2)>>2]|0;d=(c|0)!=0;b:do if(!h)if(d){if((f|0)<(c|0)){if(!(ibb(A,g,f,c)|0)){c=0;m=64;break a}g=k[p>>2]|0;f=k[q>>2]|0}f=f-c|0;c=1;m=45}else{c=1;m=45}else{if(d){if((f|0)<(c|0)){if(!(ibb(A,g,f,c)|0)){c=0;m=64;break a}g=k[p>>2]|0;f=k[q>>2]|0}f=f-c|0;m=k[155504+(c<<2)>>2]|0;e=g>>f&m;c=e-((e|0)>(k[155504+(c+-1<<2)>>2]|0)?0:m)|0}else c=0;e=B+4+(k[a+372+(o<<2)>>2]<<2)|0;m=(k[e>>2]|0)+c|0;k[e>>2]=m;j[i>>1]=m;if((h|0)>1){c=1;while(1){if((f|0)<8){if(!(ibb(A,g,f,0)|0)){c=0;m=64;break a}g=k[p>>2]|0;f=k[q>>2]|0;if((f|0)<8){d=1;m=30}else m=28}else m=28;if((m|0)==28){m=0;e=g>>f+-8&255;d=k[n+144+(e<<2)>>2]|0;if(!d){d=9;m=30}else{f=f-d|0;d=l[n+1168+e>>0]|0}}if((m|0)==30){m=0;d=jbb(A,g,f,n,d)|0;if((d|0)<0){c=0;m=64;break a}g=k[p>>2]|0;f=k[q>>2]|0}e=d>>4;d=d&15;if(!d){if((e|0)!=15)break b;c=c+15|0}else{c=e+c|0;if((f|0)<(d|0)){if(!(ibb(A,g,f,d)|0)){c=0;m=64;break a}g=k[p>>2]|0;f=k[q>>2]|0}f=f-d|0;m=k[155504+(d<<2)>>2]|0;e=g>>f&m;j[i+(k[s+(c<<2)>>2]<<1)>>1]=e-((e|0)>(k[155504+(d+-1<<2)>>2]|0)?0:m)}c=c+1|0;if((c|0)>=(h|0)){m=45;break}}}else{c=1;m=45}}while(0);c:do if((m|0)==45)if((c|0)<=(t|0)){e=c;do{if((f|0)<8){if(!(ibb(A,g,f,0)|0)){c=0;m=64;break a}g=k[p>>2]|0;f=k[q>>2]|0;if((f|0)<8){c=1;m=51}else m=49}else m=49;if((m|0)==49){m=0;c=g>>f+-8&255;d=k[n+144+(c<<2)>>2]|0;if(!d){c=9;m=51}else{c=l[n+1168+c>>0]|0;f=f-d|0}}if((m|0)==51){c=jbb(A,g,f,n,c)|0;if((c|0)<0){c=0;m=64;break a}g=k[p>>2]|0;f=k[q>>2]|0}d=c>>4;c=c&15;if(!c)if((d|0)==15)c=15;else break c;else{if((f|0)<(c|0)){if(!(ibb(A,g,f,c)|0)){c=0;m=64;break a}g=k[p>>2]|0;f=k[q>>2]|0}f=f-c|0;c=d}e=e+1+c|0}while((e|0)<=(t|0))}while(0);o=o+1|0;if((o|0)>=(k[u>>2]|0)){m=61;break}}if((m|0)==61){e=k[v>>2]|0;d=k[A>>2]|0;c=k[w>>2]|0;break}else if((m|0)==64){r=D;return c|0}}while(0);k[e>>2]=d;k[e+4>>2]=c;k[x>>2]=g;k[y>>2]=f;k[z>>2]=k[B>>2];k[z+4>>2]=k[B+4>>2];k[z+8>>2]=k[B+8>>2];k[z+12>>2]=k[B+12>>2];k[z+16>>2]=k[B+16>>2]}C=C+40|0;k[C>>2]=(k[C>>2]|0)+-1;C=1;r=D;return C|0}function ibb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;e=k[a>>2]|0;n=a+4|0;f=k[n>>2]|0;m=k[a+16>>2]|0;l=m+440|0;a:do if(!(k[l>>2]|0)){if((c|0)<25){j=m+24|0;h=c;b:while(1){if(!f){if(!(Xh[k[(k[j>>2]|0)+12>>2]&1023](m)|0)){e=0;o=19;break}e=k[j>>2]|0;f=k[e+4>>2]|0;e=k[e>>2]|0}f=f+-1|0;g=e+1|0;c=i[e>>0]|0;e=c&255;c:do if(c<<24>>24==-1){e=g;while(1){if(!f){if(!(Xh[k[(k[j>>2]|0)+12>>2]&1023](m)|0)){e=0;o=19;break b}c=k[j>>2]|0;f=k[c+4>>2]|0;c=k[c>>2]|0}else c=e;f=f+-1|0;e=c+1|0;c=i[c>>0]|0;switch(c<<24>>24){case 0:{c=255;break c}case -1:break;default:{o=13;break b}}}}else{c=e;e=g}while(0);b=c|b<<8;c=h+8|0;if((c|0)<25)h=c;else break a}if((o|0)==13){k[l>>2]=c&255;c=h;g=f;o=14;break}else if((o|0)==19)return e|0}}else{g=f;o=14}while(0);if((o|0)==14)if((c|0)<(d|0)){f=m+468|0;if(!(k[(k[f>>2]|0)+36>>2]|0)){o=k[m>>2]|0;k[o+20>>2]=120;jh[k[o+4>>2]&1023](m,-1);k[(k[f>>2]|0)+36>>2]=1}b=b<<25-c;c=25;f=g}else f=g;k[a>>2]=e;k[n>>2]=f;k[a+8>>2]=b;k[a+12>>2]=c;o=1;return o|0}function jbb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;do if((c|0)<(e|0))if(!(ibb(a,b,c,e)|0)){d=-1;return d|0}else{h=a+8|0;g=a+12|0;b=k[h>>2]|0;c=k[g>>2]|0;break}else{g=a+12|0;h=a+8|0}while(0);c=c-e|0;f=b>>c&k[155504+(e<<2)>>2];a:do if((f|0)>(k[d+(e<<2)>>2]|0)){while(1){f=f<<1;if((c|0)<1){if(!(ibb(a,b,c,1)|0)){b=-1;break}b=k[h>>2]|0;c=k[g>>2]|0}c=c+-1|0;f=b>>>c&1|f;e=e+1|0;if((f|0)<=(k[d+(e<<2)>>2]|0))break a}return b|0}while(0);k[h>>2]=b;k[g>>2]=c;if((e|0)>16){d=k[a+16>>2]|0;a=k[d>>2]|0;k[a+20>>2]=121;jh[k[a+4>>2]&1023](d,-1);d=0;return d|0}else{d=l[(k[d+72+(e<<2)>>2]|0)+f+((k[d+140>>2]|0)+17)>>0]|0;return d|0}return 0}function kbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+4|0;i=ci[k[k[l>>2]>>2]&255](a,1,80)|0;c=a+448|0;k[c>>2]=i;k[i>>2]=848;if(b|0){j=k[a>>2]|0;k[j+20>>2]=3;Uh[k[j>>2]&2047](a)}j=a+328|0;d=k[j>>2]|0;if(!(k[(k[a+476>>2]|0)+8>>2]|0)){b=a+36|0;g=d;f=b;b=k[b>>2]|0;c=d}else{if((d|0)<2){d=k[a>>2]|0;k[d+20>>2]=48;Uh[k[d>>2]&2047](a);d=k[j>>2]|0}g=k[c>>2]|0;h=a+36|0;e=ci[k[k[l>>2]>>2]&255](a,1,k[h>>2]<<3)|0;f=g+56|0;k[f>>2]=e;b=k[h>>2]|0;g=g+60|0;k[g>>2]=e+(b<<2);if((b|0)>0){e=d+4|0;c=k[a+216>>2]|0;d=0;while(1){m=aa(k[c+40>>2]|0,k[c+12>>2]|0)|0;m=(m|0)/(k[j>>2]|0)|0;b=aa(m,e)|0;m=(ci[k[k[l>>2]>>2]&255](a,1,b<<3)|0)+(m<<2)|0;k[(k[f>>2]|0)+(d<<2)>>2]=m;k[(k[g>>2]|0)+(d<<2)>>2]=m+(b<<2);d=d+1|0;b=k[h>>2]|0;if((d|0)>=(b|0))break;else c=c+88|0}}c=k[j>>2]|0;g=c+2|0;f=h}if((b|0)<=0)return;e=i+8|0;b=0;d=k[a+216>>2]|0;while(1){m=(aa(k[d+40>>2]|0,k[d+12>>2]|0)|0)/(c|0)|0;i=aa(k[d+36>>2]|0,k[d+28>>2]|0)|0;m=aa(m,g)|0;m=Dg[k[(k[l>>2]|0)+8>>2]&127](a,1,i,m)|0;k[e+(b<<2)>>2]=m;b=b+1|0;if((b|0)>=(k[f>>2]|0))break;d=d+88|0;c=k[j>>2]|0}return}function lbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;r=k[a+448>>2]|0;switch(b|0){case 0:{b=r+4|0;if(!(k[(k[a+476>>2]|0)+8>>2]|0))k[b>>2]=233;else{k[b>>2]=232;l=k[a+328>>2]|0;m=k[a+36>>2]|0;if((m|0)>0){n=r+56|0;o=r+60|0;p=l+2|0;q=l+-2|0;g=k[a+216>>2]|0;h=0;while(1){i=(aa(k[g+40>>2]|0,k[g+12>>2]|0)|0)/(l|0)|0;j=k[(k[n>>2]|0)+(h<<2)>>2]|0;e=k[(k[o>>2]|0)+(h<<2)>>2]|0;f=k[r+8+(h<<2)>>2]|0;a=aa(i,p)|0;if((a|0)>0){b=0;do{d=k[f+(b<<2)>>2]|0;k[e+(b<<2)>>2]=d;k[j+(b<<2)>>2]=d;b=b+1|0}while((b|0)!=(a|0))}a=i<<1;if((i|0)>0){c=aa(i,l)|0;d=aa(i,q)|0;b=0;do{s=b+c|0;t=b+d|0;k[e+(t<<2)>>2]=k[f+(s<<2)>>2];k[e+(s<<2)>>2]=k[f+(t<<2)>>2];b=b+1|0}while((b|0)<(a|0));b=0;do{k[j+(b-i<<2)>>2]=k[j>>2];b=b+1|0}while((b|0)!=(i|0))}h=h+1|0;if((h|0)==(m|0))break;else g=g+88|0}}k[r+64>>2]=0;k[r+68>>2]=0;k[r+76>>2]=0}k[r+48>>2]=0;k[r+52>>2]=0;return}case 2:{k[r+4>>2]=234;return}default:{t=k[a>>2]|0;k[t+20>>2]=3;Uh[k[t>>2]&2047](a);return}}}function mbb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;w=a+448|0;x=k[w>>2]|0;z=x+48|0;do if(!(k[z>>2]|0))if(!(Hh[k[(k[a+452>>2]|0)+12>>2]&511](a,k[x+56+(k[x+64>>2]<<2)>>2]|0)|0))return;else{k[z>>2]=1;y=x+76|0;k[y>>2]=(k[y>>2]|0)+1;break}while(0);y=x+68|0;switch(k[y>>2]|0){case 2:{e=x+52|0;f=x+72|0;Eh[k[(k[a+456>>2]|0)+4>>2]&127](a,k[x+56+(k[x+64>>2]<<2)>>2]|0,e,k[f>>2]|0,b,c,d);if((k[e>>2]|0)>>>0<(k[f>>2]|0)>>>0)return;k[y>>2]=0;if((k[c>>2]|0)>>>0<d>>>0)g=9;else return;break}case 0:{e=x+52|0;f=x+72|0;g=9;break}case 1:{v=x+52|0;u=x+72|0;break}default:return}if((g|0)==9){k[e>>2]=0;m=k[a+328>>2]|0;k[f>>2]=m+-1;if((k[x+76>>2]|0)==(k[a+332>>2]|0)?(r=k[w>>2]|0,s=k[a+36>>2]|0,(s|0)>0):0){n=r+72|0;o=r+64|0;j=k[a+216>>2]|0;l=0;while(1){v=aa(k[j+40>>2]|0,k[j+12>>2]|0)|0;g=(v|0)/(m|0)|0;i=((k[j+48>>2]|0)>>>0)%(v>>>0)|0;i=(i|0)==0?v:i;if(!l)k[n>>2]=((i+-1|0)/(g|0)|0)+1;p=k[(k[r+56+(k[o>>2]<<2)>>2]|0)+(l<<2)>>2]|0;q=g<<1;if((g|0)>0){h=p+(i+-1<<2)|0;g=0;do{k[p+(g+i<<2)>>2]=k[h>>2];g=g+1|0}while((g|0)<(q|0))}l=l+1|0;if((l|0)==(s|0))break;else j=j+88|0}}k[y>>2]=1;v=e;u=f}t=x+64|0;Eh[k[(k[a+456>>2]|0)+4>>2]&127](a,k[x+56+(k[t>>2]<<2)>>2]|0,v,k[u>>2]|0,b,c,d);if((k[v>>2]|0)>>>0<(k[u>>2]|0)>>>0)return;if((k[x+76>>2]|0)==1){f=k[w>>2]|0;e=k[a+328>>2]|0;r=k[a+36>>2]|0;if((r|0)>0){s=f+56|0;o=f+60|0;p=e+1|0;q=e+2|0;g=k[a+216>>2]|0;h=0;while(1){i=(aa(k[g+40>>2]|0,k[g+12>>2]|0)|0)/(e|0)|0;j=k[(k[s>>2]|0)+(h<<2)>>2]|0;l=k[(k[o>>2]|0)+(h<<2)>>2]|0;if((i|0)>0){m=aa(i,p)|0;n=aa(i,q)|0;f=0;do{x=f+m|0;a=f-i|0;k[j+(a<<2)>>2]=k[j+(x<<2)>>2];k[l+(a<<2)>>2]=k[l+(x<<2)>>2];a=f+n|0;k[j+(a<<2)>>2]=k[j+(f<<2)>>2];k[l+(a<<2)>>2]=k[l+(f<<2)>>2];f=f+1|0}while((f|0)!=(i|0))}h=h+1|0;if((h|0)==(r|0))break;else g=g+88|0}}}else e=k[a+328>>2]|0;k[t>>2]=k[t>>2]^1;k[z>>2]=0;k[v>>2]=e+1;k[u>>2]=e+2;k[y>>2]=2;return}function nbb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;f=k[a+448>>2]|0;g=f+48|0;do if(!(k[g>>2]|0)){e=f+8|0;if(!(Hh[k[(k[a+452>>2]|0)+12>>2]&511](a,e)|0))return;else{k[g>>2]=1;break}}else e=f+8|0;while(0);h=k[a+328>>2]|0;f=f+52|0;Eh[k[(k[a+456>>2]|0)+4>>2]&127](a,e,f,h,b,c,d);if((k[f>>2]|0)>>>0<h>>>0)return;k[g>>2]=0;k[f>>2]=0;return}function obb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Eh[k[(k[a+456>>2]|0)+4>>2]&127](a,0,0,0,b,c,d);return}function pbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,m=0,n=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0;d=a;e=0;while(1){q=(k[b+(e<<2)>>2]|0)+c|0;r=l[q>>0]|0;p=l[q+7>>0]|0;g=+(p+r|0);p=r-p|0;j=+(p|0);r=l[q+1>>0]|0;m=l[q+6>>0]|0;f=+(m+r|0);m=r-m|0;r=l[q+2>>0]|0;n=l[q+5>>0]|0;h=+(n+r|0);n=r-n|0;r=l[q+3>>0]|0;q=l[q+4>>0]|0;i=+(q+r|0);s=g+i;i=g-i;g=f+h;o[d>>2]=g+s+-1024.0;o[d+16>>2]=s-g;h=(f-h+i)*.7071067690849304;o[d+8>>2]=i+h;o[d+24>>2]=i-h;h=+(n+r-q|0);i=+(m+p|0);f=(h-i)*.3826834261417389;h=h*.5411961078643799+f;f=i*1.3065630197525024+f;i=+(n+m|0)*.7071067690849304;g=j+i;i=j-i;o[d+20>>2]=i+h;o[d+12>>2]=i-h;o[d+4>>2]=g+f;o[d+28>>2]=g-f;e=e+1|0;if((e|0)==8){d=7;break}else d=d+32|0}while(1){f=+o[a>>2];r=a+224|0;g=+o[r>>2];v=f+g;g=f-g;q=a+32|0;f=+o[q>>2];m=a+192|0;j=+o[m>>2];u=f+j;j=f-j;c=a+64|0;f=+o[c>>2];n=a+160|0;h=+o[n>>2];s=f+h;h=f-h;p=a+96|0;f=+o[p>>2];b=a+128|0;i=+o[b>>2];t=f+i;w=v+t;t=v-t;v=u+s;o[a>>2]=v+w;o[b>>2]=w-v;s=(u-s+t)*.7071067690849304;o[c>>2]=t+s;o[m>>2]=t-s;i=h+(f-i);f=g+j;s=(i-f)*.3826834261417389;i=i*.5411961078643799+s;s=f*1.3065630197525024+s;h=(j+h)*.7071067690849304;j=g+h;h=g-h;o[n>>2]=h+i;o[p>>2]=h-i;o[q>>2]=j+s;o[r>>2]=j-s;if((d|0)>0){a=a+4|0;d=d+-1|0}else break}return}function qbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=a;e=0;while(1){h=(k[b+(e<<2)>>2]|0)+c|0;f=l[h>>0]|0;j=l[h+7>>0]|0;p=j+f|0;j=f-j|0;f=l[h+1>>0]|0;i=l[h+6>>0]|0;o=i+f|0;i=f-i|0;f=l[h+2>>0]|0;g=l[h+5>>0]|0;m=g+f|0;g=f-g|0;f=l[h+3>>0]|0;h=l[h+4>>0]|0;n=h+f|0;q=n+p|0;n=p-n|0;p=m+o|0;k[d>>2]=(p|-1024)+q;k[d+16>>2]=q-p;m=(o-m+n|0)*181>>8;k[d+8>>2]=m+n;k[d+24>>2]=n-m;h=f-h+g|0;f=i+j|0;m=(h-f|0)*98>>8;h=m+(h*139>>8)|0;f=m+(f*334>>8)|0;i=(g+i|0)*181>>8;g=i+j|0;i=j-i|0;k[d+20>>2]=h+i;k[d+12>>2]=i-h;k[d+4>>2]=f+g;k[d+28>>2]=g-f;e=e+1|0;if((e|0)==8){d=7;break}else d=d+32|0}while(1){n=k[a>>2]|0;q=a+224|0;g=k[q>>2]|0;t=g+n|0;g=n-g|0;n=a+32|0;e=k[n>>2]|0;f=a+192|0;i=k[f>>2]|0;r=i+e|0;i=e-i|0;e=a+64|0;m=k[e>>2]|0;h=a+160|0;o=k[h>>2]|0;c=o+m|0;o=m-o|0;m=a+96|0;p=k[m>>2]|0;s=a+128|0;j=k[s>>2]|0;b=j+p|0;u=b+t|0;b=t-b|0;t=c+r|0;k[a>>2]=u+t;k[s>>2]=u-t;c=(r-c+b|0)*181>>8;k[e>>2]=c+b;k[f>>2]=b-c;j=p-j+o|0;p=i+g|0;f=(j-p|0)*98>>8;j=f+(j*139>>8)|0;p=f+(p*334>>8)|0;i=(o+i|0)*181>>8;o=i+g|0;i=g-i|0;k[h>>2]=j+i;k[m>>2]=i-j;k[n>>2]=p+o;k[q>>2]=o-p;if((d|0)>0){a=a+4|0;d=d+-1|0}else break}return}function rbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=a;e=0;while(1){g=(k[b+(e<<2)>>2]|0)+c|0;s=l[g>>0]|0;o=l[g+7>>0]|0;f=o+s|0;r=l[g+1>>0]|0;n=l[g+6>>0]|0;t=n+r|0;q=l[g+2>>0]|0;j=l[g+5>>0]|0;i=j+q|0;m=l[g+3>>0]|0;g=l[g+4>>0]|0;p=g+m|0;h=p+f|0;p=f-p|0;f=i+t|0;i=t-i|0;o=s-o|0;n=r-n|0;j=q-j|0;g=m-g|0;k[d>>2]=(h+f<<2)+-4096;k[d+16>>2]=h-f<<2;f=((p+i|0)*4433|0)+1024|0;k[d+8>>2]=f+(p*6270|0)>>11;i=f+(aa(i,-15137)|0)>>11;k[d+24>>2]=i;i=j+o|0;f=g+n|0;p=((f+i|0)*9633|0)+1024|0;h=aa(g+o|0,-7373)|0;m=aa(j+n|0,-20995)|0;i=p+(aa(i,-3196)|0)|0;f=p+(aa(f,-16069)|0)|0;k[d+4>>2]=h+(o*12299|0)+i>>11;k[d+12>>2]=m+(n*25172|0)+f>>11;k[d+20>>2]=m+(j*16819|0)+i>>11;k[d+28>>2]=h+(g*2446|0)+f>>11;e=e+1|0;if((e|0)==8){d=7;break}else d=d+32|0}while(1){w=k[a>>2]|0;t=a+224|0;g=k[t>>2]|0;c=g+w|0;h=a+32|0;v=k[h>>2]|0;o=a+192|0;i=k[o>>2]|0;x=i+v|0;q=a+64|0;u=k[q>>2]|0;p=a+160|0;n=k[p>>2]|0;s=n+u|0;j=a+96|0;e=k[j>>2]|0;f=a+128|0;r=k[f>>2]|0;m=r+e|0;b=c+2+m|0;m=c-m|0;c=s+x|0;s=x-s|0;g=w-g|0;i=v-i|0;n=u-n|0;r=e-r|0;k[a>>2]=b+c>>2;k[f>>2]=b-c>>2;f=((m+s|0)*4433|0)+16384|0;k[q>>2]=f+(m*6270|0)>>15;s=f+(aa(s,-15137)|0)>>15;k[o>>2]=s;o=n+g|0;s=r+i|0;f=((s+o|0)*9633|0)+16384|0;q=aa(r+g|0,-7373)|0;m=aa(n+i|0,-20995)|0;o=f+(aa(o,-3196)|0)|0;s=f+(aa(s,-16069)|0)|0;k[h>>2]=q+(g*12299|0)+o>>15;k[j>>2]=m+(i*25172|0)+s>>15;k[p>>2]=m+(n*16819|0)+o>>15;k[t>>2]=q+(r*2446|0)+s>>15;if((d|0)>0){a=a+4|0;d=d+-1|0}else break}return}function sbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;zpb(a|0,0,256)|0;d=a;e=0;while(1){n=(k[b+(e<<2)>>2]|0)+c|0;q=l[n>>0]|0;g=l[n+6>>0]|0;m=g+q|0;j=l[n+1>>0]|0;f=l[n+5>>0]|0;o=f+j|0;i=l[n+2>>0]|0;h=l[n+4>>0]|0;p=h+i|0;n=l[n+3>>0]|0;g=q-g|0;f=j-f|0;h=i-h|0;i=p+m|0;k[d>>2]=(n+o+i<<2)+-3584;i=((aa(n,-4)|0)+i|0)*2896|0;j=(m-p|0)*7542|0;p=(o-p|0)*2578|0;k[d+8>>2]=j+1024+p+i>>11;m=((m-o|0)*7223|0)+1024|0;n=m+p+(aa(o-(n<<1)|0,-5793)|0)>>11;k[d+16>>2]=n;k[d+24>>2]=m-j+i>>11;i=(f+g|0)*7663|0;j=(g-f|0)*1395|0;f=aa(h+f|0,-11295)|0;g=(h+g|0)*5027|0;k[d+4>>2]=1024-j+i+g>>11;k[d+12>>2]=j+1024+i+f>>11;k[d+20>>2]=(h*15326|0)+1024+g+f>>11;e=e+1|0;if((e|0)==7){d=0;break}else d=d+32|0}while(1){t=k[a>>2]|0;j=a+192|0;o=k[j>>2]|0;f=o+t|0;h=a+32|0;g=k[h>>2]|0;q=a+160|0;p=k[q>>2]|0;e=p+g|0;s=a+64|0;i=k[s>>2]|0;c=a+128|0;n=k[c>>2]|0;r=n+i|0;m=a+96|0;b=k[m>>2]|0;o=t-o|0;p=g-p|0;n=i-n|0;i=r+f|0;k[a>>2]=((b+e+i|0)*10700|0)+16384>>15;i=((aa(b,-4)|0)+i|0)*3783|0;g=(f-r|0)*9850|0;r=(e-r|0)*3367|0;k[s>>2]=g+16384+r+i>>15;f=((f-e|0)*9434|0)+16384|0;b=f+r+(aa(e-(b<<1)|0,-7566)|0)>>15;k[c>>2]=b;k[j>>2]=f-g+i>>15;j=(p+o|0)*10009|0;i=(o-p|0)*1822|0;p=aa(n+p|0,-14752)|0;o=(n+o|0)*6565|0;k[h>>2]=16384-i+j+o>>15;k[m>>2]=i+16384+j+p>>15;k[q>>2]=(n*20017|0)+16384+o+p>>15;d=d+1|0;if((d|0)==7)break;else a=a+4|0}return}function tbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;zpb(a|0,0,256)|0;d=a;e=0;while(1){g=(k[b+(e<<2)>>2]|0)+c|0;q=l[g>>0]|0;i=l[g+5>>0]|0;n=i+q|0;p=l[g+1>>0]|0;f=l[g+4>>0]|0;j=f+p|0;o=l[g+2>>0]|0;g=l[g+3>>0]|0;m=g+o|0;h=m+n|0;i=q-i|0;f=p-f|0;g=o-g|0;k[d>>2]=(h+j<<2)+-3072;k[d+8>>2]=((n-m|0)*10033|0)+1024>>11;h=(((aa(j,-2)|0)+h|0)*5793|0)+1024>>11;k[d+16>>2]=h;h=((g+i|0)*2998|0)+1024>>11;k[d+4>>2]=h+(f+i<<2);k[d+12>>2]=i-f-g<<2;k[d+20>>2]=h+(g-f<<2);e=e+1|0;if((e|0)==6){d=0;break}else d=d+32|0}while(1){s=k[a>>2]|0;q=a+160|0;j=k[q>>2]|0;b=j+s|0;i=a+32|0;r=k[i>>2]|0;p=a+128|0;o=k[p>>2]|0;g=o+r|0;f=a+64|0;e=k[f>>2]|0;m=a+96|0;n=k[m>>2]|0;c=n+e|0;h=c+b|0;j=s-j|0;o=r-o|0;n=e-n|0;k[a>>2]=((h+g|0)*14564|0)+16384>>15;k[f>>2]=((b-c|0)*17837|0)+16384>>15;h=(((aa(g,-2)|0)+h|0)*10298|0)+16384>>15;k[p>>2]=h;p=(n+j|0)*5331|0;k[i>>2]=((o+j|0)*14564|0)+16384+p>>15;k[m>>2]=((j-o-n|0)*14564|0)+16384>>15;k[q>>2]=((n-o|0)*14564|0)+16384+p>>15;d=d+1|0;if((d|0)==6)break;else a=a+4|0}return}function ubb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0;zpb(a|0,0,256)|0;d=0;e=a;while(1){f=(k[b+(d<<2)>>2]|0)+c|0;o=l[f>>0]|0;h=l[f+4>>0]|0;j=h+o|0;n=l[f+1>>0]|0;g=l[f+3>>0]|0;i=g+n|0;f=l[f+2>>0]|0;m=i+j|0;h=o-h|0;g=n-g|0;k[e>>2]=(m+f<<3)+-5120;f=(m-(f<<2)|0)*2896|0;i=((j-i|0)*6476|0)+512|0;k[e+8>>2]=i+f>>10;k[e+16>>2]=i-f>>10;f=(g+h|0)*6810|0;k[e+4>>2]=(h*4209|0)+512+f>>10;f=(aa(g,-17828)|0)+512+f>>10;k[e+12>>2]=f;d=d+1|0;if((d|0)==5){d=0;break}else e=e+32|0}while(1){p=k[a>>2]|0;n=a+128|0;i=k[n>>2]|0;c=i+p|0;j=a+32|0;e=k[j>>2]|0;o=a+96|0;m=k[o>>2]|0;g=m+e|0;f=a+64|0;h=k[f>>2]|0;b=g+c|0;i=p-i|0;m=e-m|0;k[a>>2]=((b+h|0)*10486|0)+16384>>15;h=(b-(h<<2)|0)*3707|0;g=((c-g|0)*8290|0)+16384|0;k[f>>2]=g+h>>15;k[n>>2]=g-h>>15;n=(m+i|0)*8716|0;k[j>>2]=(i*5387|0)+16384+n>>15;n=(aa(m,-22820)|0)+16384+n>>15;k[o>>2]=n;d=d+1|0;if((d|0)==5)break;else a=a+4|0}return}function vbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;zpb(a|0,0,256)|0;t=(k[b>>2]|0)+c|0;i=l[t>>0]|0;r=l[t+3>>0]|0;s=r+i|0;o=l[t+1>>0]|0;t=l[t+2>>0]|0;h=t+o|0;r=i-r|0;t=o-t|0;k[a>>2]=(h+s<<4)+-8192;o=a+8|0;k[o>>2]=s-h<<4;h=((t+r|0)*4433|0)+256|0;s=a+4|0;k[s>>2]=h+(r*6270|0)>>9;t=h+(aa(t,-15137)|0)>>9;h=a+12|0;k[h>>2]=t;t=a+32|0;r=(k[b+4>>2]|0)+c|0;i=l[r>>0]|0;e=l[r+3>>0]|0;p=e+i|0;x=l[r+1>>0]|0;r=l[r+2>>0]|0;d=r+x|0;e=i-e|0;r=x-r|0;x=(d+p<<4)+-8192|0;k[t>>2]=x;i=a+40|0;k[i>>2]=p-d<<4;d=((r+e|0)*4433|0)+256|0;p=a+36|0;k[p>>2]=d+(e*6270|0)>>9;r=d+(aa(r,-15137)|0)>>9;d=a+44|0;k[d>>2]=r;r=a+64|0;e=(k[b+8>>2]|0)+c|0;g=l[e>>0]|0;q=l[e+3>>0]|0;n=q+g|0;u=l[e+1>>0]|0;e=l[e+2>>0]|0;f=e+u|0;q=g-q|0;e=u-e|0;u=(f+n<<4)+-8192|0;k[r>>2]=u;g=a+72|0;k[g>>2]=n-f<<4;f=((e+q|0)*4433|0)+256|0;q=f+(q*6270|0)>>9;n=a+68|0;k[n>>2]=q;e=f+(aa(e,-15137)|0)>>9;f=a+76|0;k[f>>2]=e;e=(k[b+12>>2]|0)+c|0;y=l[e>>0]|0;j=l[e+3>>0]|0;c=j+y|0;m=l[e+1>>0]|0;e=l[e+2>>0]|0;b=e+m|0;j=y-j|0;e=m-e|0;m=(b+c<<4)+-8192|0;b=c-b<<4;c=((e+j|0)*4433|0)+256|0;j=c+(j*6270|0)>>9;e=c+(aa(e,-15137)|0)>>9;c=a+108|0;k[c>>2]=e;y=k[a>>2]|0;w=y+2+m|0;v=u+x|0;m=y-m|0;u=x-u|0;k[a>>2]=v+w>>2;k[r>>2]=w-v>>2;r=((u+m|0)*4433|0)+16384|0;k[t>>2]=r+(m*6270|0)>>15;u=r+(aa(u,-15137)|0)>>15;k[a+96>>2]=u;u=k[s>>2]|0;r=u+2+j|0;t=k[p>>2]|0;m=q+t|0;j=u-j|0;q=t-q|0;k[s>>2]=m+r>>2;k[n>>2]=r-m>>2;n=((q+j|0)*4433|0)+16384|0;k[p>>2]=n+(j*6270|0)>>15;q=n+(aa(q,-15137)|0)>>15;k[a+100>>2]=q;q=k[o>>2]|0;n=q+2+b|0;p=k[i>>2]|0;j=k[g>>2]|0;m=j+p|0;b=q-b|0;j=p-j|0;k[o>>2]=m+n>>2;k[g>>2]=n-m>>2;g=((j+b|0)*4433|0)+16384|0;k[i>>2]=g+(b*6270|0)>>15;j=g+(aa(j,-15137)|0)>>15;k[a+104>>2]=j;j=k[h>>2]|0;g=j+2+e|0;i=k[d>>2]|0;b=k[f>>2]|0;a=b+i|0;e=j-e|0;b=i-b|0;k[h>>2]=a+g>>2;k[f>>2]=g-a>>2;a=((b+e|0)*4433|0)+16384|0;k[d>>2]=a+(e*6270|0)>>15;b=a+(aa(b,-15137)|0)>>15;k[c>>2]=b;return}function wbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;zpb(a|0,0,256)|0;g=(k[b>>2]|0)+c|0;n=l[g>>0]|0;i=l[g+2>>0]|0;e=i+n|0;g=l[g+1>>0]|0;p=(e+g<<4)+-6144|0;k[a>>2]=p;e=(((aa(g,-2)|0)+e|0)*5793|0)+256>>9;g=a+8|0;k[g>>2]=e;i=((n-i|0)*10033|0)+256>>9;n=a+4|0;k[n>>2]=i;j=a+32|0;d=(k[b+4>>2]|0)+c|0;h=l[d>>0]|0;m=l[d+2>>0]|0;f=m+h|0;d=l[d+1>>0]|0;r=(f+d<<4)+-6144|0;k[j>>2]=r;f=(((aa(d,-2)|0)+f|0)*5793|0)+256>>9;d=a+40|0;k[d>>2]=f;m=((h-m|0)*10033|0)+256>>9;h=a+36|0;k[h>>2]=m;s=(k[b+8>>2]|0)+c|0;q=l[s>>0]|0;b=l[s+2>>0]|0;c=b+q|0;s=l[s+1>>0]|0;o=(c+s<<4)+-6144|0;c=(((aa(s,-2)|0)+c|0)*5793|0)+256>>9;b=((q-b|0)*10033|0)+256>>9;q=o+p|0;k[a>>2]=((q+r|0)*14564|0)+16384>>15;q=(((aa(r,-2)|0)+q|0)*10298|0)+16384>>15;k[a+64>>2]=q;k[j>>2]=((p-o|0)*17837|0)+16384>>15;j=b+i|0;k[n>>2]=((j+m|0)*14564|0)+16384>>15;j=(((aa(m,-2)|0)+j|0)*10298|0)+16384>>15;k[a+68>>2]=j;k[h>>2]=((i-b|0)*17837|0)+16384>>15;b=c+e|0;k[g>>2]=((b+f|0)*14564|0)+16384>>15;b=(((aa(f,-2)|0)+b|0)*10298|0)+16384>>15;k[a+72>>2]=b;k[d>>2]=((e-c|0)*17837|0)+16384>>15;return}function xbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;zpb(a|0,0,256)|0;d=(k[b>>2]|0)+c|0;f=l[d>>0]|0;d=l[d+1>>0]|0;e=d+f|0;d=f-d|0;c=(k[b+4>>2]|0)+c|0;f=l[c>>0]|0;c=l[c+1>>0]|0;b=c+f|0;c=f-c|0;k[a>>2]=(b+e<<4)+-8192;k[a+32>>2]=e-b<<4;k[a+4>>2]=c+d<<4;k[a+36>>2]=d-c<<4;return}function ybb(a,b,c){a=a|0;b=b|0;c=c|0;zpb(a|0,0,256)|0;k[a>>2]=((l[(k[b>>2]|0)+c>>0]|0)<<6)+-8192;return}function zbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=r;r=r+32|0;e=g;d=0;f=a;a:while(1){s=(k[b+(d<<2)>>2]|0)+c|0;w=l[s>>0]|0;i=l[s+8>>0]|0;p=i+w|0;m=l[s+1>>0]|0;j=l[s+7>>0]|0;o=j+m|0;v=l[s+2>>0]|0;n=l[s+6>>0]|0;t=n+v|0;u=l[s+3>>0]|0;h=l[s+5>>0]|0;q=h+u|0;s=l[s+4>>0]|0;i=w-i|0;n=v-n|0;h=u-h|0;u=t+p+q|0;v=s+o|0;k[f>>2]=(u+v<<1)+-2304;u=(((aa(v,-2)|0)+u|0)*5793|0)+2048>>12;k[f+24>>2]=u;o=((aa(s,-2)|0)+o|0)*5793|0;s=((p-t|0)*10887|0)+2048|0;k[f+8>>2]=s+((t-q|0)*8875|0)+o>>12;k[f+16>>2]=s+((q-p|0)*2012|0)-o>>12;k[f+12>>2]=((i-n-h|0)*10033|0)+2048>>12;j=(m-j|0)*10033|0;m=(n+i|0)*7447|0;i=(h+i|0)*3962|0;k[f+4>>2]=j+2048+m+i>>12;h=(n-h|0)*11409|0;j=2048-j|0;k[f+20>>2]=j+m-h>>12;k[f+28>>2]=j+i+h>>12;switch(d|0){case 7:{d=8;f=e;continue a}case 8:{d=7;break a}default:{}}d=d+1|0;f=f+32|0}while(1){A=k[a>>2]|0;u=k[e>>2]|0;i=u+A|0;o=a+32|0;q=k[o>>2]|0;w=a+224|0;t=k[w>>2]|0;j=t+q|0;b=a+64|0;z=k[b>>2]|0;x=a+192|0;p=k[x>>2]|0;f=p+z|0;n=a+96|0;y=k[n>>2]|0;s=a+160|0;v=k[s>>2]|0;h=v+y|0;m=a+128|0;c=k[m>>2]|0;u=A-u|0;p=z-p|0;v=y-v|0;y=f+i+h|0;z=c+j|0;k[a>>2]=((y+z|0)*12945|0)+16384>>15;y=(((aa(z,-2)|0)+y|0)*9154|0)+16384>>15;k[x>>2]=y;j=((aa(c,-2)|0)+j|0)*9154|0;c=((i-f|0)*17203|0)+16384|0;k[b>>2]=c+((f-h|0)*14024|0)+j>>15;k[m>>2]=c+((h-i|0)*3179|0)-j>>15;k[n>>2]=((u-p-v|0)*15855|0)+16384>>15;t=(q-t|0)*15855|0;q=(p+u|0)*11768|0;u=(v+u|0)*6262|0;k[o>>2]=t+16384+q+u>>15;v=(p-v|0)*18029|0;t=16384-t|0;k[s>>2]=t+q-v>>15;k[w>>2]=t+u+v>>15;if((d|0)>0){e=e+4|0;a=a+4|0;d=d+-1|0}else break}r=g;return}function Abb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=r;r=r+64|0;e=g;d=0;f=a;a:while(1){m=(k[b+(d<<2)>>2]|0)+c|0;y=l[m>>0]|0;n=l[m+9>>0]|0;t=n+y|0;x=l[m+1>>0]|0;i=l[m+8>>0]|0;z=i+x|0;w=l[m+2>>0]|0;p=l[m+7>>0]|0;o=p+w|0;v=l[m+3>>0]|0;j=l[m+6>>0]|0;h=j+v|0;u=l[m+4>>0]|0;m=l[m+5>>0]|0;q=m+u|0;s=q+t|0;q=t-q|0;t=h+z|0;h=z-h|0;n=y-n|0;i=x-i|0;p=w-p|0;j=v-j|0;m=u-m|0;k[f>>2]=(t+o+s<<1)+-2560;o=o<<1;o=(aa(t-o|0,-3580)|0)+2048+((s-o|0)*9373|0)>>12;k[f+16>>2]=o;o=(q+h|0)*6810|0;k[f+8>>2]=(q*4209|0)+2048+o>>12;o=(aa(h,-17828)|0)+2048+o>>12;k[f+24>>2]=o;o=m+n|0;h=i-j|0;k[f+20>>2]=o-(h+p)<<1;p=p<<13;k[f+4>>2]=(n*11443|0)+2048+(i*10323|0)+p+(j*5260|0)+(m*1812|0)>>12;h=(h<<12)-p+((o+h|0)*2531|0)|0;i=((n-m|0)*7791|0)+(aa(j+i|0,-4815)|0)+2048|0;k[f+12>>2]=i+h>>12;k[f+28>>2]=i-h>>12;switch(d|0){case 7:{d=8;f=e;continue a}case 9:{d=7;break a}default:{}}d=d+1|0;f=f+32|0}while(1){C=k[a>>2]|0;t=k[e+32>>2]|0;c=t+C|0;p=a+32|0;B=k[p>>2]|0;x=k[e>>2]|0;D=x+B|0;m=a+64|0;A=k[m>>2]|0;z=a+224|0;q=k[z>>2]|0;i=q+A|0;w=a+96|0;f=k[w>>2]|0;s=a+192|0;v=k[s>>2]|0;n=v+f|0;y=a+128|0;b=k[y>>2]|0;o=a+160|0;u=k[o>>2]|0;j=u+b|0;h=j+c|0;j=c-j|0;c=n+D|0;n=D-n|0;t=C-t|0;x=B-x|0;q=A-q|0;v=f-v|0;u=b-u|0;k[a>>2]=((c+i+h|0)*10486|0)+16384>>15;i=i<<1;i=(aa(c-i|0,-4582)|0)+16384+((h-i|0)*11997|0)>>15;k[y>>2]=i;y=(j+n|0)*8716|0;k[m>>2]=(j*5387|0)+16384+y>>15;y=(aa(n,-22820)|0)+16384+y>>15;k[s>>2]=y;s=u+t|0;y=x-v|0;k[o>>2]=((s-(y+q)|0)*10486|0)+16384>>15;q=q*10486|0;k[p>>2]=(t*14647|0)+16384+(x*13213|0)+q+(v*6732|0)+(u*2320|0)>>15;y=(y*5243|0)-q+((s+y|0)*3240|0)|0;x=((t-u|0)*9973|0)+(aa(v+x|0,-6163)|0)+16384|0;k[w>>2]=x+y>>15;k[z>>2]=x-y>>15;if((d|0)>0){e=e+4|0;a=a+4|0;d=d+-1|0}else break}r=g;return}function Bbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=r;r=r+96|0;e=g;d=0;f=a;a:while(1){t=(k[b+(d<<2)>>2]|0)+c|0;z=l[t>>0]|0;w=l[t+10>>0]|0;q=w+z|0;y=l[t+1>>0]|0;v=l[t+9>>0]|0;m=v+y|0;x=l[t+2>>0]|0;s=l[t+8>>0]|0;i=s+x|0;p=l[t+3>>0]|0;n=l[t+7>>0]|0;h=n+p|0;j=l[t+4>>0]|0;o=l[t+6>>0]|0;u=o+j|0;t=l[t+5>>0]|0;w=z-w|0;v=y-v|0;s=x-s|0;n=p-n|0;o=j-o|0;k[f>>2]=(m+q+i+h+u+t<<1)+-2816;t=t<<1;q=q-t|0;m=m-t|0;i=i-t|0;h=h-t|0;t=u-t|0;u=((q+h|0)*11116|0)+((i+t|0)*1649|0)|0;j=(m-h|0)*7587|0;p=(q-m|0)*9746|0;h=(aa(h,-8342)|0)+2048+(aa(t,-11395)|0)+j+u>>12;k[f+8>>2]=h;j=(m*511|0)+2048+(aa(i,-11116)|0)+(t*4813|0)+p+j>>12;k[f+16>>2]=j;u=(aa(q,-13275)|0)+2048+(aa(i,-6461)|0)+p+u>>12;k[f+24>>2]=u;u=(v+w|0)*10538|0;p=(s+w|0)*8756|0;i=(n+w|0)*6263|0;q=aa(s+v|0,-6263)|0;j=aa(n+v|0,-11467)|0;t=aa(o,-8756)|0;m=(n+s|0)*3264|0;s=aa(s,-16294)|0;h=aa(o,-10538)|0;w=(aa(w,-14090)|0)+2048+u+p+i+(o*3264|0)>>12;k[f+4>>2]=w;k[f+12>>2]=(v*10456|0)+2048+u+q+j+t>>12;k[f+20>>2]=s+2048+q+p+m+(o*11467|0)>>12;k[f+28>>2]=(n*10695|0)+2048+m+j+i+h>>12;switch(d|0){case 7:{d=8;f=e;continue a}case 10:{d=7;break a}default:{}}d=d+1|0;f=f+32|0}while(1){D=k[a>>2]|0;c=k[e+64>>2]|0;w=c+D|0;h=a+32|0;C=k[h>>2]|0;i=k[e+32>>2]|0;b=i+C|0;f=a+64|0;B=k[f>>2]|0;o=k[e>>2]|0;p=o+B|0;n=a+96|0;x=k[n>>2]|0;z=a+224|0;u=k[z>>2]|0;A=u+x|0;m=a+128|0;v=k[m>>2]|0;j=a+192|0;s=k[j>>2]|0;q=s+v|0;t=a+160|0;y=k[t>>2]|0;c=D-c|0;i=C-i|0;o=B-o|0;u=x-u|0;s=v-s|0;k[a>>2]=((b+w+p+A+q+y|0)*8666|0)+16384>>15;y=y<<1;w=w-y|0;b=b-y|0;p=p-y|0;A=A-y|0;y=q-y|0;q=((w+A|0)*11759|0)+((p+y|0)*1744|0)|0;v=(b-A|0)*8026|0;x=(w-b|0)*10310|0;A=(aa(A,-8825)|0)+16384+(aa(y,-12054)|0)+v+q>>15;k[f>>2]=A;v=(b*540|0)+16384+(aa(p,-11759)|0)+(y*5091|0)+x+v>>15;k[m>>2]=v;q=(aa(w,-14043)|0)+16384+(aa(p,-6835)|0)+x+q>>15;k[j>>2]=q;j=(i+c|0)*11148|0;q=(o+c|0)*9262|0;x=(u+c|0)*6626|0;p=aa(o+i|0,-6626)|0;w=aa(u+i|0,-12131)|0;m=aa(s,-9262)|0;v=(u+o|0)*3453|0;o=aa(o,-17237)|0;y=aa(s,-11148)|0;c=(aa(c,-14905)|0)+16384+j+q+x+(s*3453|0)>>15;k[h>>2]=c;k[n>>2]=(i*11061|0)+16384+j+p+w+m>>15;k[t>>2]=o+16384+p+q+v+(s*12131|0)>>15;k[z>>2]=(u*11314|0)+16384+v+w+x+y>>15;if((d|0)>0){e=e+4|0;a=a+4|0;d=d+-1|0}else break}r=g;return}function Cbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=r;r=r+128|0;e=g;d=0;f=a;a:while(1){o=(k[b+(d<<2)>>2]|0)+c|0;C=l[o>>0]|0;u=l[o+11>>0]|0;m=u+C|0;B=l[o+1>>0]|0;i=l[o+10>>0]|0;w=i+B|0;A=l[o+2>>0]|0;t=l[o+9>>0]|0;D=t+A|0;z=l[o+3>>0]|0;n=l[o+8>>0]|0;q=n+z|0;y=l[o+4>>0]|0;p=l[o+7>>0]|0;v=p+y|0;x=l[o+5>>0]|0;o=l[o+6>>0]|0;j=o+x|0;h=j+m|0;j=m-j|0;m=w-v|0;s=q+D|0;q=D-q|0;u=C-u|0;i=B-i|0;t=A-t|0;n=z-n|0;p=y-p|0;o=x-o|0;k[f>>2]=(w|-1536)+s+v+h;k[f+24>>2]=j-(m+q);k[f+16>>2]=((h-s|0)*10033|0)+4096>>13;k[f+8>>2]=4096-q+m+((j+q|0)*11190|0)>>13;q=(p+i|0)*4433|0;i=q+(i*6270|0)|0;p=q+(aa(p,-15137)|0)|0;q=(t+u|0)*9191|0;j=(n+u|0)*7053|0;m=aa(n+t|0,-1512)|0;s=aa(t,-19165)|0;h=aa(o,-9191)|0;t=aa(o+t|0,-4433)|0;v=(aa(u,-4758)|0)+4096+q+j+i+(o*1512|0)>>13;k[f+4>>2]=v;k[f+12>>2]=((u-n|0)*10703|0)+4096+p+t>>13;k[f+20>>2]=s+4096+q+m-p+(o*7053|0)>>13;k[f+28>>2]=(n*5946|0)+4096+m+j-i+h>>13;switch(d|0){case 7:{d=8;f=e;continue a}case 11:{d=7;break a}default:{}}d=d+1|0;f=f+32|0}while(1){G=k[a>>2]|0;p=k[e+96>>2]|0;t=p+G|0;o=a+32|0;F=k[o>>2]|0;B=k[e+64>>2]|0;h=B+F|0;u=a+64|0;E=k[u>>2]|0;q=k[e+32>>2]|0;H=q+E|0;s=a+96|0;f=k[s>>2]|0;y=k[e>>2]|0;A=y+f|0;C=a+128|0;b=k[C>>2]|0;D=a+224|0;v=k[D>>2]|0;i=v+b|0;x=a+160|0;c=k[x>>2]|0;j=a+192|0;w=k[j>>2]|0;z=w+c|0;m=z+t|0;z=t-z|0;t=h-i|0;n=A+H|0;A=H-A|0;p=G-p|0;B=F-B|0;q=E-q|0;y=f-y|0;v=b-v|0;w=c-w|0;k[a>>2]=((n+h+i+m|0)*7282|0)+8192>>14;k[j>>2]=((z-(t+A)|0)*7282|0)+8192>>14;k[C>>2]=((m-n|0)*8918|0)+8192>>14;k[u>>2]=((t-A|0)*7282|0)+8192+((z+A|0)*9947|0)>>14;u=(v+B|0)*3941|0;B=u+(B*5573|0)|0;v=u+(aa(v,-13455)|0)|0;u=(q+p|0)*8170|0;A=(y+p|0)*6269|0;z=aa(y+q|0,-1344)|0;t=aa(q,-17036)|0;C=aa(w,-8170)|0;q=aa(w+q|0,-3941)|0;n=(aa(p,-4229)|0)+8192+u+A+B+(w*1344|0)>>14;k[o>>2]=n;k[s>>2]=((p-y|0)*9514|0)+8192+v+q>>14;k[x>>2]=t+8192+u+z-v+(w*6269|0)>>14;k[D>>2]=(y*5285|0)+8192+z+A-B+C>>14;if((d|0)>0){e=e+4|0;a=a+4|0;d=d+-1|0}else break}r=g;return}function Dbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=r;r=r+160|0;e=g;d=0;f=a;a:while(1){q=(k[b+(d<<2)>>2]|0)+c|0;C=l[q>>0]|0;x=l[q+12>>0]|0;m=x+C|0;B=l[q+1>>0]|0;v=l[q+11>>0]|0;h=v+B|0;A=l[q+2>>0]|0;s=l[q+10>>0]|0;t=s+A|0;z=l[q+3>>0]|0;n=l[q+9>>0]|0;j=n+z|0;y=l[q+4>>0]|0;w=l[q+8>>0]|0;o=w+y|0;i=l[q+5>>0]|0;p=l[q+7>>0]|0;u=p+i|0;q=l[q+6>>0]|0;x=C-x|0;v=B-v|0;s=A-s|0;n=z-n|0;w=y-w|0;p=i-p|0;k[f>>2]=m+-1664+h+t+j+o+u+q;q=q<<1;m=m-q|0;h=h-q|0;t=t-q|0;j=j-q|0;o=o-q|0;q=u-q|0;u=(h*8672|0)+4096+(m*11249|0)+(t*4108|0)+(aa(j,-1396)|0)+(aa(o,-6581)|0)+(aa(q,-10258)|0)>>13;k[f+8>>2]=u;u=((m-t|0)*9465|0)+(aa(j-o|0,-3570)|0)+(aa(h-q|0,-2592)|0)|0;q=((m+t|0)*793|0)+(aa(j+o|0,-7678)|0)+((h+q|0)*3989|0)|0;k[f+16>>2]=q+4096+u>>13;k[f+24>>2]=4096-q+u>>13;u=(v+x|0)*10832|0;q=(s+x|0)*9534|0;h=((p+w|0)*2773|0)+((n+x|0)*7682|0)|0;o=((w-p|0)*7682|0)+(aa(s+v|0,-2773)|0)|0;j=aa(n+v|0,-9534)|0;t=aa(w,-19183)|0;m=aa(n+s|0,-5384)|0;s=aa(s,-12879)|0;i=aa(p,-14273)|0;w=(aa(x,-16549)|0)+4096+u+q+(w*2611|0)+h>>13;k[f+4>>2]=w;k[f+12>>2]=(v*6859|0)+4096+u+j+t+o>>13;k[f+20>>2]=s+4096+q+m+(p*18515|0)+o>>13;k[f+28>>2]=(n*18068|0)+4096+m+j+i+h>>13;switch(d|0){case 7:{d=8;f=e;continue a}case 12:{d=7;break a}default:{}}d=d+1|0;f=f+32|0}while(1){G=k[a>>2]|0;i=k[e+128>>2]|0;h=i+G|0;m=a+32|0;F=k[m>>2]|0;n=k[e+96>>2]|0;z=n+F|0;t=a+64|0;E=k[t>>2]|0;s=k[e+64>>2]|0;A=s+E|0;q=a+96|0;D=k[q>>2]|0;x=k[e+32>>2]|0;y=x+D|0;v=a+128|0;f=k[v>>2]|0;j=k[e>>2]|0;p=j+f|0;w=a+160|0;b=k[w>>2]|0;C=a+224|0;u=k[C>>2]|0;c=u+b|0;o=a+192|0;B=k[o>>2]|0;i=G-i|0;n=F-n|0;s=E-s|0;x=D-x|0;j=f-j|0;u=b-u|0;k[a>>2]=((z+h+A+y+p+c+B|0)*6205|0)+8192>>14;B=B<<1;h=h-B|0;z=z-B|0;A=A-B|0;y=y-B|0;p=p-B|0;B=c-B|0;c=(z*6568|0)+8192+(h*8520|0)+(A*3112|0)+(aa(y,-1058)|0)+(aa(p,-4985)|0)+(aa(B,-7770)|0)>>14;k[t>>2]=c;t=((h-A|0)*7169|0)+(aa(y-p|0,-2704)|0)+(aa(z-B|0,-1963)|0)|0;B=((h+A|0)*601|0)+(aa(y+p|0,-5816)|0)+((z+B|0)*3021|0)|0;k[v>>2]=B+8192+t>>14;k[o>>2]=8192-B+t>>14;o=(n+i|0)*8204|0;t=(s+i|0)*7221|0;B=((u+j|0)*2100|0)+((x+i|0)*5819|0)|0;v=((j-u|0)*5819|0)+(aa(s+n|0,-2100)|0)|0;z=aa(x+n|0,-7221)|0;p=aa(j,-14529)|0;y=aa(x+s|0,-4078)|0;s=aa(s,-9754)|0;A=aa(u,-10811)|0;j=(aa(i,-12534)|0)+8192+o+t+(j*1978|0)+B>>14;k[m>>2]=j;k[q>>2]=(n*5195|0)+8192+o+z+p+v>>14;k[w>>2]=s+8192+t+y+(u*14023|0)+v>>14;k[C>>2]=(x*13685|0)+8192+y+z+A+B>>14;if((d|0)>0){e=e+4|0;a=a+4|0;d=d+-1|0}else break}r=g;return}function Ebb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=r;r=r+192|0;e=g;d=0;f=a;a:while(1){m=(k[b+(d<<2)>>2]|0)+c|0;E=l[m>>0]|0;j=l[m+13>>0]|0;w=j+E|0;D=l[m+1>>0]|0;q=l[m+12>>0]|0;x=q+D|0;C=l[m+2>>0]|0;s=l[m+11>>0]|0;F=s+C|0;B=l[m+3>>0]|0;n=l[m+10>>0]|0;o=n+B|0;A=l[m+4>>0]|0;i=l[m+9>>0]|0;t=i+A|0;z=l[m+5>>0]|0;p=l[m+8>>0]|0;h=p+z|0;y=l[m+6>>0]|0;m=l[m+7>>0]|0;u=m+y|0;v=u+w|0;u=w-u|0;w=h+x|0;h=x-h|0;x=t+F|0;t=F-t|0;j=E-j|0;q=D-q|0;s=C-s|0;n=B-n|0;i=A-i|0;p=z-p|0;m=y-m|0;k[f>>2]=o+-1792+x+w+v;o=o<<1;o=(aa(x-o|0,-7223)|0)+4096+((w-o|0)*2578|0)+((v-o|0)*10438|0)>>13;k[f+16>>2]=o;o=(u+h|0)*9058|0;k[f+8>>2]=(t*5027|0)+4096+(u*2237|0)+o>>13;o=(aa(t,-11295)|0)+4096+(aa(h,-14084)|0)+o>>13;k[f+24>>2]=o;o=s+q|0;h=p-i|0;k[f+28>>2]=j-o+n-h-m;n=n<<13;o=(h*11512|0)-n+(aa(o,-1297)|0)|0;h=((m+i|0)*6164|0)+((s+j|0)*9810|0)|0;i=(aa(s,-19447)|0)+4096+(i*9175|0)+o+h>>13;k[f+20>>2]=i;i=((p-m|0)*3826|0)+((q+j|0)*10935|0)|0;o=(aa(q,-3474)|0)+4096+(aa(p,-25148)|0)+o+i>>13;k[f+12>>2]=o;h=(n|4096)+m+(aa(m+j|0,-9232)|0)+i+h>>13;k[f+4>>2]=h;switch(d|0){case 7:{d=8;f=e;continue a}case 13:{d=7;break a}default:{}}d=d+1|0;f=f+32|0}while(1){I=k[a>>2]|0;A=k[e+160>>2]|0;j=A+I|0;F=a+32|0;H=k[F>>2]|0;w=k[e+128>>2]|0;i=w+H|0;p=a+64|0;G=k[p>>2]|0;u=k[e+96>>2]|0;J=u+G|0;z=a+96|0;f=k[z>>2]|0;B=k[e+64>>2]|0;n=B+f|0;E=a+128|0;b=k[E>>2]|0;v=k[e+32>>2]|0;q=v+b|0;D=a+160|0;c=k[D>>2]|0;x=k[e>>2]|0;s=x+c|0;y=a+192|0;h=k[y>>2]|0;t=a+224|0;C=k[t>>2]|0;o=C+h|0;m=o+j|0;o=j-o|0;j=s+i|0;s=i-s|0;i=q+J|0;q=J-q|0;A=I-A|0;w=H-w|0;u=G-u|0;B=f-B|0;v=b-v|0;x=c-x|0;C=h-C|0;k[a>>2]=((i+n+j+m|0)*5350|0)+8192>>14;n=n<<1;n=(aa(i-n|0,-4717)|0)+8192+((j-n|0)*1684|0)+((m-n|0)*6817|0)>>14;k[E>>2]=n;E=(o+s|0)*5915|0;k[p>>2]=(q*3283|0)+8192+(o*1461|0)+E>>14;E=(aa(q,-7376)|0)+8192+(aa(s,-9198)|0)+E>>14;k[y>>2]=E;y=u+w|0;E=x-v|0;k[t>>2]=((A-y+B-E-C|0)*5350|0)+8192>>14;B=B*5350|0;y=(E*7518|0)-B+(aa(y,-847)|0)|0;E=((C+v|0)*4025|0)+((u+A|0)*6406|0)|0;v=(aa(u,-12700)|0)+8192+(v*5992|0)+y+E>>14;k[D>>2]=v;D=((x-C|0)*2499|0)+((w+A|0)*7141|0)|0;y=(aa(w,-2269)|0)+8192+(aa(x,-16423)|0)+y+D>>14;k[z>>2]=y;E=(aa(A,-6029)|0)+8192+B+(aa(C,-679)|0)+D+E>>14;k[F>>2]=E;if((d|0)>0){e=e+4|0;a=a+4|0;d=d+-1|0}else break}r=g;return}function Fbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=r;r=r+224|0;e=g;d=0;f=a;a:while(1){j=(k[b+(d<<2)>>2]|0)+c|0;F=l[j>>0]|0;t=l[j+14>>0]|0;m=t+F|0;E=l[j+1>>0]|0;u=l[j+13>>0]|0;y=u+E|0;D=l[j+2>>0]|0;s=l[j+12>>0]|0;n=s+D|0;C=l[j+3>>0]|0;q=l[j+11>>0]|0;i=q+C|0;z=l[j+4>>0]|0;v=l[j+10>>0]|0;x=v+z|0;B=l[j+5>>0]|0;p=l[j+9>>0]|0;h=p+B|0;A=l[j+6>>0]|0;o=l[j+8>>0]|0;w=o+A|0;j=l[j+7>>0]|0;t=F-t|0;u=E-u|0;s=D-s|0;q=C-q|0;v=z-v|0;p=B-p|0;o=A-o|0;A=x+m+h|0;B=i+y+w|0;z=j+n|0;k[f>>2]=A+-1920+B+z;z=z<<1;z=(aa(B-z|0,-3580)|0)+4096+((A-z|0)*9373|0)>>13;k[f+24>>2]=z;j=((x+y|0)>>>1)+n+(aa(j,-2)|0)|0;n=aa(m-j|0,-748)|0;m=((y-x|0)*6476|0)+((m-i|0)*11332|0)+((w-h|0)*7752|0)+4096|0;i=m+(aa(w-j|0,-18336)|0)+((i-j|0)*12543|0)>>13;k[f+8>>2]=i;k[f+16>>2]=m+n+((h-j|0)*6541|0)>>13;j=s*10033|0;h=((p+q|0)*4712|0)+((v+u|0)*11018|0)+((t-o|0)*11522|0)|0;n=aa(t,-2912)|0;m=aa(u,-17828)|0;i=aa(p,-7121)|0;w=j+4096+(q*3897|0)+(aa(v,-4209)|0)+(o*13930|0)+h>>13;k[f+4>>2]=w;k[f+12>>2]=((t-v-p|0)*11018|0)+4096+((u-q-o|0)*6810|0)>>13;k[f+20>>2]=((t-s-q+p+o|0)*10033|0)+4096>>13;k[f+28>>2]=n+4096+m-j+i+h>>13;switch(d|0){case 7:{d=8;f=e;continue a}case 14:{d=7;break a}default:{}}d=d+1|0;f=f+32|0}while(1){J=k[a>>2]|0;u=k[e+192>>2]|0;D=u+J|0;p=a+32|0;I=k[p>>2]|0;s=k[e+160>>2]|0;i=s+I|0;o=a+64|0;H=k[o>>2]|0;v=k[e+128>>2]|0;B=v+H|0;t=a+96|0;G=k[t>>2]|0;w=k[e+96>>2]|0;n=w+G|0;C=a+128|0;c=k[C>>2]|0;q=k[e+64>>2]|0;j=q+c|0;z=a+160|0;f=k[z>>2]|0;x=k[e+32>>2]|0;A=x+f|0;h=a+192|0;b=k[h>>2]|0;y=k[e>>2]|0;m=y+b|0;F=a+224|0;E=k[F>>2]|0;u=J-u|0;s=I-s|0;v=H-v|0;w=G-w|0;q=c-q|0;x=f-x|0;y=b-y|0;b=j+D+A|0;f=n+i+m|0;c=E+B|0;k[a>>2]=((f+b+c|0)*9321|0)+16384>>15;c=c<<1;c=(aa(f-c|0,-4073)|0)+16384+((b-c|0)*10664|0)>>15;k[h>>2]=c;E=(j+i>>1)+B+(aa(E,-2)|0)|0;B=aa(D-E|0,-852)|0;D=((i-j|0)*7369|0)+((D-n|0)*12893|0)+((m-A|0)*8820|0)+16384|0;n=D+(aa(m-E|0,-20862)|0)+((n-E|0)*14271|0)>>15;k[o>>2]=n;k[C>>2]=D+B+((A-E|0)*7442|0)>>15;C=v*11415|0;E=((x+w|0)*5361|0)+((q+s|0)*12536|0)+((u-y|0)*13109|0)|0;A=aa(u,-3314)|0;B=aa(s,-20284)|0;D=aa(x,-8102)|0;o=C+16384+(w*4434|0)+(aa(q,-4788)|0)+(y*15850|0)+E>>15;k[p>>2]=o;k[t>>2]=((u-q-x|0)*12536|0)+16384+((s-w-y|0)*7748|0)>>15;k[z>>2]=((u-v-w+x+y|0)*11415|0)+16384>>15;k[F>>2]=A+16384+B-C+D+E>>15;if((d|0)>0){e=e+4|0;a=a+4|0;d=d+-1|0}else break}r=g;return}function Gbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;g=r;r=r+256|0;e=g;d=0;f=a;a:while(1){w=(k[b+(d<<2)>>2]|0)+c|0;H=l[w>>0]|0;x=l[w+15>>0]|0;z=x+H|0;G=l[w+1>>0]|0;v=l[w+14>>0]|0;y=v+G|0;F=l[w+2>>0]|0;s=l[w+13>>0]|0;t=s+F|0;E=l[w+3>>0]|0;n=l[w+12>>0]|0;I=n+E|0;D=l[w+4>>0]|0;m=l[w+11>>0]|0;h=m+D|0;C=l[w+5>>0]|0;q=l[w+10>>0]|0;i=q+C|0;B=l[w+6>>0]|0;u=l[w+9>>0]|0;p=u+B|0;A=l[w+7>>0]|0;w=l[w+8>>0]|0;o=w+A|0;j=o+z|0;o=z-o|0;z=p+y|0;p=y-p|0;y=i+t|0;i=t-i|0;t=h+I|0;h=I-h|0;x=H-x|0;v=G-v|0;s=F-s|0;n=E-n|0;m=D-m|0;q=C-q|0;u=B-u|0;w=A-w|0;k[f>>2]=(y+t+z+j<<2)+-8192;k[f+16>>2]=((z-y|0)*4433|0)+1024+((j-t|0)*10703|0)>>11;t=((o-i|0)*11363|0)+((h-p|0)*2260|0)|0;k[f+8>>2]=(i*17799|0)+1024+(p*11893|0)+t>>11;t=(aa(h,-8697)|0)+1024+(aa(o,-1730)|0)+t>>11;k[f+24>>2]=t;t=((u-w|0)*3363|0)+((v+x|0)*11086|0)|0;o=((w+q|0)*5461|0)+((s+x|0)*10217|0)|0;h=((m-w|0)*7350|0)+((n+x|0)*8956|0)|0;p=((u-q|0)*11529|0)+((s+v|0)*1136|0)|0;i=(aa(u+m|0,-10217)|0)+(aa(n+v|0,-5461)|0)|0;j=((q-m|0)*3363|0)+(aa(n+s|0,-11086)|0)|0;u=aa(u,-13631)|0;s=aa(s,-9222)|0;w=(aa(x,-18730)|0)+1024+(w*6387|0)+o+t+h>>11;k[f+4>>2]=w;k[f+12>>2]=(v*589|0)+1024+u+i+p+t>>11;k[f+20>>2]=s+1024+(q*10055|0)+j+p+o>>11;k[f+28>>2]=(n*8728|0)+1024+(m*17760|0)+j+i+h>>11;switch(d|0){case 7:{d=8;f=e;continue a}case 15:{d=7;break a}default:{}}d=d+1|0;f=f+32|0}while(1){L=k[a>>2]|0;q=k[e+224>>2]|0;j=q+L|0;t=a+32|0;K=k[t>>2]|0;u=k[e+192>>2]|0;m=u+K|0;G=a+64|0;J=k[G>>2]|0;y=k[e+160>>2]|0;o=y+J|0;x=a+96|0;f=k[x>>2]|0;D=k[e+128>>2]|0;M=D+f|0;B=a+128|0;b=k[B>>2]|0;E=k[e+96>>2]|0;A=E+b|0;C=a+160|0;c=k[C>>2]|0;z=k[e+64>>2]|0;p=z+c|0;w=a+192|0;h=k[w>>2]|0;v=k[e+32>>2]|0;F=v+h|0;I=a+224|0;i=k[I>>2]|0;s=k[e>>2]|0;H=s+i|0;n=H+j|0;H=j-H|0;j=F+m|0;F=m-F|0;m=p+o|0;p=o-p|0;o=A+M|0;A=M-A|0;q=L-q|0;u=K-u|0;y=J-y|0;D=f-D|0;E=b-E|0;z=c-z|0;v=h-v|0;s=i-s|0;k[a>>2]=o+8+m+j+n>>4;k[B>>2]=((j-m|0)*4433|0)+65536+((n-o|0)*10703|0)>>17;B=((H-p|0)*11363|0)+((A-F|0)*2260|0)|0;k[G>>2]=(p*17799|0)+65536+(F*11893|0)+B>>17;B=(aa(A,-8697)|0)+65536+(aa(H,-1730)|0)+B>>17;k[w>>2]=B;w=((v-s|0)*3363|0)+((u+q|0)*11086|0)|0;B=((s+z|0)*5461|0)+((y+q|0)*10217|0)|0;H=((E-s|0)*7350|0)+((D+q|0)*8956|0)|0;A=((v-z|0)*11529|0)+((y+u|0)*1136|0)|0;G=(aa(v+E|0,-10217)|0)+(aa(D+u|0,-5461)|0)|0;F=((z-E|0)*3363|0)+(aa(D+y|0,-11086)|0)|0;v=aa(v,-13631)|0;y=aa(y,-9222)|0;s=(aa(q,-18730)|0)+65536+(s*6387|0)+B+w+H>>17;k[t>>2]=s;k[x>>2]=(u*589|0)+65536+v+G+A+w>>17;k[C>>2]=y+65536+(z*10055|0)+F+A+B>>17;k[I>>2]=(D*8728|0)+65536+(E*17760|0)+F+G+H>>17;if((d|0)>0){e=e+4|0;a=a+4|0;d=d+-1|0}else break}r=g;return}function Hbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=a;e=0;while(1){t=(k[b+(e<<2)>>2]|0)+c|0;E=l[t>>0]|0;u=l[t+15>>0]|0;w=u+E|0;D=l[t+1>>0]|0;s=l[t+14>>0]|0;v=s+D|0;C=l[t+2>>0]|0;p=l[t+13>>0]|0;q=p+C|0;B=l[t+3>>0]|0;j=l[t+12>>0]|0;F=j+B|0;A=l[t+4>>0]|0;i=l[t+11>>0]|0;f=i+A|0;z=l[t+5>>0]|0;o=l[t+10>>0]|0;g=o+z|0;y=l[t+6>>0]|0;r=l[t+9>>0]|0;n=r+y|0;x=l[t+7>>0]|0;t=l[t+8>>0]|0;m=t+x|0;h=m+w|0;m=w-m|0;w=n+v|0;n=v-n|0;v=g+q|0;g=q-g|0;q=f+F|0;f=F-f|0;u=E-u|0;s=D-s|0;p=C-p|0;j=B-j|0;i=A-i|0;o=z-o|0;r=y-r|0;t=x-t|0;k[d>>2]=(v+q+w+h<<2)+-8192;k[d+16>>2]=((w-v|0)*4433|0)+1024+((h-q|0)*10703|0)>>11;q=((m-g|0)*11363|0)+((f-n|0)*2260|0)|0;k[d+8>>2]=(g*17799|0)+1024+(n*11893|0)+q>>11;q=(aa(f,-8697)|0)+1024+(aa(m,-1730)|0)+q>>11;k[d+24>>2]=q;q=((r-t|0)*3363|0)+((s+u|0)*11086|0)|0;m=((t+o|0)*5461|0)+((p+u|0)*10217|0)|0;f=((i-t|0)*7350|0)+((j+u|0)*8956|0)|0;n=((r-o|0)*11529|0)+((p+s|0)*1136|0)|0;g=(aa(r+i|0,-10217)|0)+(aa(j+s|0,-5461)|0)|0;h=((o-i|0)*3363|0)+(aa(j+p|0,-11086)|0)|0;r=aa(r,-13631)|0;p=aa(p,-9222)|0;t=(aa(u,-18730)|0)+1024+(t*6387|0)+m+q+f>>11;k[d+4>>2]=t;k[d+12>>2]=(s*589|0)+1024+r+g+n+q>>11;k[d+20>>2]=p+1024+(o*10055|0)+h+n+m>>11;k[d+28>>2]=(j*8728|0)+1024+(i*17760|0)+h+g+f>>11;e=e+1|0;if((e|0)==8){d=7;break}else d=d+32|0}while(1){n=k[a>>2]|0;F=a+224|0;u=k[F>>2]|0;r=u+n|0;v=a+32|0;o=k[v>>2]|0;A=a+192|0;w=k[A>>2]|0;m=w+o|0;D=a+64|0;p=k[D>>2]|0;B=a+160|0;y=k[B>>2]|0;t=y+p|0;x=a+96|0;q=k[x>>2]|0;E=a+128|0;C=k[E>>2]|0;z=C+q|0;s=z+r|0;z=r-z|0;r=t+m|0;t=m-t|0;u=n-u|0;w=o-w|0;y=p-y|0;C=q-C|0;k[a>>2]=r+4+s>>3;k[E>>2]=4-r+s>>3;E=(z+t|0)*4433|0;k[D>>2]=(z*6270|0)+32768+E>>16;E=(aa(t,-15137)|0)+32768+E>>16;k[A>>2]=E;A=y+u|0;E=C+w|0;t=(E+A|0)*9633|0;D=aa(C+u|0,-7373)|0;z=aa(y+w|0,-20995)|0;A=t+(aa(A,-3196)|0)|0;E=t+(aa(E,-16069)|0)|0;k[v>>2]=(u*12299|0)+32768+D+A>>16;k[x>>2]=(w*25172|0)+32768+z+E>>16;k[B>>2]=(y*16819|0)+32768+z+A>>16;k[F>>2]=(C*2446|0)+32768+D+E>>16;if((d|0)>0){a=a+4|0;d=d+-1|0}else break}return}function Ibb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=a+224|0;e=d+32|0;do{i[d>>0]=0;d=d+1|0}while((d|0)<(e|0));d=a;e=0;while(1){j=(k[b+(e<<2)>>2]|0)+c|0;C=l[j>>0]|0;h=l[j+13>>0]|0;u=h+C|0;B=l[j+1>>0]|0;p=l[j+12>>0]|0;v=p+B|0;A=l[j+2>>0]|0;q=l[j+11>>0]|0;D=q+A|0;z=l[j+3>>0]|0;m=l[j+10>>0]|0;n=m+z|0;y=l[j+4>>0]|0;g=l[j+9>>0]|0;r=g+y|0;x=l[j+5>>0]|0;o=l[j+8>>0]|0;f=o+x|0;w=l[j+6>>0]|0;j=l[j+7>>0]|0;s=j+w|0;t=s+u|0;s=u-s|0;u=f+v|0;f=v-f|0;v=r+D|0;r=D-r|0;h=C-h|0;p=B-p|0;q=A-q|0;m=z-m|0;g=y-g|0;o=x-o|0;j=w-j|0;k[d>>2]=(v+n+u+t<<2)+-7168;n=n<<1;n=(aa(v-n|0,-7223)|0)+1024+((u-n|0)*2578|0)+((t-n|0)*10438|0)>>11;k[d+16>>2]=n;n=(s+f|0)*9058|0;k[d+8>>2]=(r*5027|0)+1024+(s*2237|0)+n>>11;n=(aa(r,-11295)|0)+1024+(aa(f,-14084)|0)+n>>11;k[d+24>>2]=n;n=q+p|0;f=o-g|0;k[d+28>>2]=h-n+m-f-j<<2;m=m<<13;n=(f*11512|0)-m+(aa(n,-1297)|0)|0;f=((j+g|0)*6164|0)+((q+h|0)*9810|0)|0;g=(aa(q,-19447)|0)+1024+(g*9175|0)+n+f>>11;k[d+20>>2]=g;g=((o-j|0)*3826|0)+((p+h|0)*10935|0)|0;n=(aa(p,-3474)|0)+1024+(aa(o,-25148)|0)+n+g>>11;k[d+12>>2]=n;f=(m|1024)+j+(aa(j+h|0,-9232)|0)+g+f>>11;k[d+4>>2]=f;e=e+1|0;if((e|0)==7){d=7;break}else d=d+32|0}while(1){o=k[a>>2]|0;y=a+192|0;B=k[y>>2]|0;u=B+o|0;w=a+32|0;v=k[w>>2]|0;D=a+160|0;C=k[D>>2]|0;r=C+v|0;p=a+64|0;x=k[p>>2]|0;t=a+128|0;A=k[t>>2]|0;q=A+x|0;z=a+96|0;s=k[z>>2]|0;B=o-B|0;C=v-C|0;A=x-A|0;x=q+u|0;k[a>>2]=((s+r+x|0)*10700|0)+32768>>16;x=((aa(s,-4)|0)+x|0)*3783|0;v=(u-q|0)*9850|0;q=(r-q|0)*3367|0;k[p>>2]=v+32768+q+x>>16;u=((u-r|0)*9434|0)+32768|0;s=u+q+(aa(r-(s<<1)|0,-7566)|0)>>16;k[t>>2]=s;k[y>>2]=u-v+x>>16;y=(C+B|0)*10009|0;x=(B-C|0)*1822|0;C=aa(A+C|0,-14752)|0;B=(A+B|0)*6565|0;k[w>>2]=32768-x+y+B>>16;k[z>>2]=x+32768+y+C>>16;k[D>>2]=(A*20017|0)+32768+B+C>>16;if((d|0)>0){a=a+4|0;d=d+-1|0}else break}return}function Jbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=a+192|0;e=d+64|0;do{i[d>>0]=0;d=d+1|0}while((d|0)<(e|0));d=a;e=0;while(1){n=(k[b+(e<<2)>>2]|0)+c|0;A=l[n>>0]|0;s=l[n+11>>0]|0;j=s+A|0;z=l[n+1>>0]|0;g=l[n+10>>0]|0;u=g+z|0;y=l[n+2>>0]|0;r=l[n+9>>0]|0;B=r+y|0;x=l[n+3>>0]|0;m=l[n+8>>0]|0;p=m+x|0;w=l[n+4>>0]|0;o=l[n+7>>0]|0;t=o+w|0;v=l[n+5>>0]|0;n=l[n+6>>0]|0;h=n+v|0;f=h+j|0;h=j-h|0;j=u-t|0;q=p+B|0;p=B-p|0;s=A-s|0;g=z-g|0;r=y-r|0;m=x-m|0;o=w-o|0;n=v-n|0;k[d>>2]=(q+u+t+f<<2)+-6144;k[d+24>>2]=h-(j+p)<<2;k[d+16>>2]=((f-q|0)*10033|0)+1024>>11;k[d+8>>2]=1024-p+j+((h+p|0)*11190|0)>>11;p=(o+g|0)*4433|0;g=p+(g*6270|0)|0;o=p+(aa(o,-15137)|0)|0;p=(r+s|0)*9191|0;h=(m+s|0)*7053|0;j=aa(m+r|0,-1512)|0;q=aa(r,-19165)|0;f=aa(n,-9191)|0;r=aa(n+r|0,-4433)|0;t=(aa(s,-4758)|0)+1024+p+h+g+(n*1512|0)>>11;k[d+4>>2]=t;k[d+12>>2]=((s-m|0)*10703|0)+1024+o+r>>11;k[d+20>>2]=q+1024+p+j-o+(n*7053|0)>>11;k[d+28>>2]=(m*5946|0)+1024+j+h-g+f>>11;e=e+1|0;if((e|0)==6){d=7;break}else d=d+32|0}while(1){n=k[a>>2]|0;B=a+160|0;w=k[B>>2]|0;q=w+n|0;v=a+32|0;o=k[v>>2]|0;A=a+128|0;z=k[A>>2]|0;t=z+o|0;s=a+64|0;p=k[s>>2]|0;x=a+96|0;y=k[x>>2]|0;r=y+p|0;u=r+q|0;w=n-w|0;z=o-z|0;y=p-y|0;k[a>>2]=((u+t|0)*14564|0)+32768>>16;k[s>>2]=((q-r|0)*17837|0)+32768>>16;u=(((aa(t,-2)|0)+u|0)*10298|0)+32768>>16;k[A>>2]=u;A=(y+w|0)*5331|0;k[v>>2]=((z+w|0)*14564|0)+32768+A>>16;k[x>>2]=((w-z-y|0)*14564|0)+32768>>16;k[B>>2]=((y-z|0)*14564|0)+32768+A>>16;if((d|0)>0){a=a+4|0;d=d+-1|0}else break}return}function Kbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=a+160|0;e=d+96|0;do{i[d>>0]=0;d=d+1|0}while((d|0)<(e|0));d=a;e=0;while(1){j=(k[b+(e<<2)>>2]|0)+c|0;w=l[j>>0]|0;m=l[j+9>>0]|0;r=m+w|0;v=l[j+1>>0]|0;g=l[j+8>>0]|0;x=g+v|0;u=l[j+2>>0]|0;o=l[j+7>>0]|0;n=o+u|0;t=l[j+3>>0]|0;h=l[j+6>>0]|0;f=h+t|0;s=l[j+4>>0]|0;j=l[j+5>>0]|0;p=j+s|0;q=p+r|0;p=r-p|0;r=f+x|0;f=x-f|0;m=w-m|0;g=v-g|0;o=u-o|0;h=t-h|0;j=s-j|0;k[d>>2]=(r+n+q<<2)+-5120;n=n<<1;n=(aa(r-n|0,-3580)|0)+1024+((q-n|0)*9373|0)>>11;k[d+16>>2]=n;n=(p+f|0)*6810|0;k[d+8>>2]=(p*4209|0)+1024+n>>11;n=(aa(f,-17828)|0)+1024+n>>11;k[d+24>>2]=n;n=j+m|0;f=g-h|0;k[d+20>>2]=n-(f+o)<<2;o=o<<13;k[d+4>>2]=(m*11443|0)+1024+(g*10323|0)+o+(h*5260|0)+(j*1812|0)>>11;f=(f<<12)-o+((n+f|0)*2531|0)|0;g=((m-j|0)*7791|0)+(aa(h+g|0,-4815)|0)+1024|0;k[d+12>>2]=g+f>>11;k[d+28>>2]=g-f>>11;e=e+1|0;if((e|0)==5){d=7;break}else d=d+32|0}while(1){m=k[a>>2]|0;w=a+128|0;t=k[w>>2]|0;p=t+m|0;u=a+32|0;n=k[u>>2]|0;x=a+96|0;v=k[x>>2]|0;r=v+n|0;q=a+64|0;s=k[q>>2]|0;o=r+p|0;t=m-t|0;v=n-v|0;k[a>>2]=((o+s|0)*10486|0)+16384>>15;s=(o-(s<<2)|0)*3707|0;r=((p-r|0)*8290|0)+16384|0;k[q>>2]=r+s>>15;k[w>>2]=r-s>>15;w=(v+t|0)*8716|0;k[u>>2]=(t*5387|0)+16384+w>>15;w=(aa(v,-22820)|0)+16384+w>>15;k[x>>2]=w;if((d|0)>0){a=a+4|0;d=d+-1|0}else break}return}function Lbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=a+128|0;e=d+128|0;do{i[d>>0]=0;d=d+1|0}while((d|0)<(e|0));d=a;e=0;while(1){g=(k[b+(e<<2)>>2]|0)+c|0;t=l[g>>0]|0;p=l[g+7>>0]|0;f=p+t|0;s=l[g+1>>0]|0;o=l[g+6>>0]|0;u=o+s|0;r=l[g+2>>0]|0;m=l[g+5>>0]|0;j=m+r|0;n=l[g+3>>0]|0;g=l[g+4>>0]|0;q=g+n|0;h=q+f|0;q=f-q|0;f=j+u|0;j=u-j|0;p=t-p|0;o=s-o|0;m=r-m|0;g=n-g|0;k[d>>2]=(h+f<<3)+-8192;k[d+16>>2]=h-f<<3;f=((q+j|0)*4433|0)+512|0;k[d+8>>2]=f+(q*6270|0)>>10;j=f+(aa(j,-15137)|0)>>10;k[d+24>>2]=j;j=m+p|0;f=g+o|0;q=((f+j|0)*9633|0)+512|0;h=aa(g+p|0,-7373)|0;n=aa(m+o|0,-20995)|0;j=q+(aa(j,-3196)|0)|0;f=q+(aa(f,-16069)|0)|0;k[d+4>>2]=h+(p*12299|0)+j>>10;k[d+12>>2]=n+(o*25172|0)+f>>10;k[d+20>>2]=n+(m*16819|0)+j>>10;k[d+28>>2]=h+(g*2446|0)+f>>10;e=e+1|0;if((e|0)==4){d=7;break}else d=d+32|0}while(1){m=k[a>>2]|0;u=a+96|0;q=k[u>>2]|0;o=m+2+q|0;r=a+32|0;n=k[r>>2]|0;s=a+64|0;t=k[s>>2]|0;p=t+n|0;q=m-q|0;t=n-t|0;k[a>>2]=p+o>>2;k[s>>2]=o-p>>2;s=((t+q|0)*4433|0)+16384|0;k[r>>2]=s+(q*6270|0)>>15;t=s+(aa(t,-15137)|0)>>15;k[u>>2]=t;if((d|0)>0){a=a+4|0;d=d+-1|0}else break}return}function Mbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0;zpb(a|0,0,256)|0;d=a;e=0;while(1){g=(k[b+(e<<2)>>2]|0)+c|0;q=l[g>>0]|0;i=l[g+5>>0]|0;n=i+q|0;p=l[g+1>>0]|0;f=l[g+4>>0]|0;j=f+p|0;o=l[g+2>>0]|0;g=l[g+3>>0]|0;m=g+o|0;h=m+n|0;i=q-i|0;f=p-f|0;g=o-g|0;k[d>>2]=(h+j<<3)+-6144;k[d+8>>2]=((n-m|0)*10033|0)+512>>10;h=(((aa(j,-2)|0)+h|0)*5793|0)+512>>10;k[d+16>>2]=h;h=((g+i|0)*2998|0)+512>>10;k[d+4>>2]=h+(f+i<<3);k[d+12>>2]=i-f-g<<3;k[d+20>>2]=h+(g-f<<3);e=e+1|0;if((e|0)==3)break;else d=d+32|0}p=k[a>>2]|0;o=a+64|0;n=k[o>>2]|0;m=n+p|0;j=a+32|0;i=k[j>>2]|0;k[a>>2]=((m+i|0)*14564|0)+16384>>15;m=(((aa(i,-2)|0)+m|0)*10298|0)+16384>>15;k[o>>2]=m;k[j>>2]=((p-n|0)*17837|0)+16384>>15;j=a+4|0;n=k[j>>2]|0;p=a+68|0;o=k[p>>2]|0;m=o+n|0;i=a+36|0;q=k[i>>2]|0;k[j>>2]=((m+q|0)*14564|0)+16384>>15;m=(((aa(q,-2)|0)+m|0)*10298|0)+16384>>15;k[p>>2]=m;k[i>>2]=((n-o|0)*17837|0)+16384>>15;i=a+8|0;o=k[i>>2]|0;n=a+72|0;p=k[n>>2]|0;m=p+o|0;q=a+40|0;j=k[q>>2]|0;k[i>>2]=((m+j|0)*14564|0)+16384>>15;m=(((aa(j,-2)|0)+m|0)*10298|0)+16384>>15;k[n>>2]=m;k[q>>2]=((o-p|0)*17837|0)+16384>>15;q=a+12|0;p=k[q>>2]|0;o=a+76|0;n=k[o>>2]|0;m=n+p|0;j=a+44|0;i=k[j>>2]|0;k[q>>2]=((m+i|0)*14564|0)+16384>>15;m=(((aa(i,-2)|0)+m|0)*10298|0)+16384>>15;k[o>>2]=m;k[j>>2]=((p-n|0)*17837|0)+16384>>15;j=a+16|0;n=k[j>>2]|0;p=a+80|0;o=k[p>>2]|0;m=o+n|0;i=a+48|0;q=k[i>>2]|0;k[j>>2]=((m+q|0)*14564|0)+16384>>15;m=(((aa(q,-2)|0)+m|0)*10298|0)+16384>>15;k[p>>2]=m;k[i>>2]=((n-o|0)*17837|0)+16384>>15;i=a+20|0;o=k[i>>2]|0;n=a+84|0;p=k[n>>2]|0;m=p+o|0;q=a+52|0;j=k[q>>2]|0;k[i>>2]=((m+j|0)*14564|0)+16384>>15;m=(((aa(j,-2)|0)+m|0)*10298|0)+16384>>15;k[n>>2]=m;k[q>>2]=((o-p|0)*17837|0)+16384>>15;return}function Nbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0;zpb(a|0,0,256)|0;e=(k[b>>2]|0)+c|0;d=l[e>>0]|0;i=l[e+3>>0]|0;g=i+d|0;n=l[e+1>>0]|0;e=l[e+2>>0]|0;f=e+n|0;i=d-i|0;e=n-e|0;n=f+g<<5;k[a>>2]=n+-16384;f=g-f<<5;g=a+8|0;k[g>>2]=f;d=((e+i|0)*4433|0)+128|0;i=d+(i*6270|0)>>8;j=a+4|0;k[j>>2]=i;e=d+(aa(e,-15137)|0)>>8;d=a+12|0;k[d>>2]=e;c=(k[b+4>>2]|0)+c|0;p=l[c>>0]|0;h=l[c+3>>0]|0;o=h+p|0;m=l[c+1>>0]|0;c=l[c+2>>0]|0;b=c+m|0;h=p-h|0;c=m-c|0;m=(b+o<<5)+-16384|0;b=o-b<<5;o=((c+h|0)*4433|0)+128|0;h=o+(h*6270|0)>>8;c=o+(aa(c,-15137)|0)>>8;n=n+-16382|0;k[a>>2]=n+m>>2;k[a+32>>2]=n-m>>2;i=i+2|0;k[j>>2]=i+h>>2;k[a+36>>2]=i-h>>2;f=f|2;k[g>>2]=f+b>>2;k[a+40>>2]=f-b>>2;b=e+2|0;k[d>>2]=b+c>>2;k[a+44>>2]=b-c>>2;return}function Obb(a,b,c){a=a|0;b=b|0;c=c|0;zpb(a|0,0,256)|0;c=(k[b>>2]|0)+c|0;b=l[c>>0]|0;c=l[c+1>>0]|0;k[a>>2]=(c+b<<5)+-8192;k[a+4>>2]=b-c<<5;return}function Pbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;g=r;r=r+256|0;e=g;d=0;f=a;a:while(1){j=(k[b+(d<<2)>>2]|0)+c|0;v=l[j>>0]|0;q=l[j+7>>0]|0;m=q+v|0;u=l[j+1>>0]|0;p=l[j+6>>0]|0;w=p+u|0;t=l[j+2>>0]|0;o=l[j+5>>0]|0;h=o+t|0;n=l[j+3>>0]|0;j=l[j+4>>0]|0;s=j+n|0;i=s+m|0;s=m-s|0;m=h+w|0;h=w-h|0;q=v-q|0;p=u-p|0;o=t-o|0;j=n-j|0;k[f>>2]=(i+m<<2)+-4096;k[f+16>>2]=i-m<<2;m=(s+h|0)*4433|0;k[f+8>>2]=(s*6270|0)+1024+m>>11;m=(aa(h,-15137)|0)+1024+m>>11;k[f+24>>2]=m;m=o+q|0;h=j+p|0;s=(h+m|0)*9633|0;i=aa(j+q|0,-7373)|0;n=aa(o+p|0,-20995)|0;m=s+(aa(m,-3196)|0)|0;h=s+(aa(h,-16069)|0)|0;k[f+4>>2]=(q*12299|0)+1024+i+m>>11;k[f+12>>2]=(p*25172|0)+1024+n+h>>11;k[f+20>>2]=(o*16819|0)+1024+n+m>>11;k[f+28>>2]=(j*2446|0)+1024+i+h>>11;switch(d|0){case 7:{d=8;f=e;continue a}case 15:{d=7;break a}default:{}}d=d+1|0;f=f+32|0}while(1){L=k[a>>2]|0;y=k[e+224>>2]|0;D=y+L|0;f=a+32|0;K=k[f>>2]|0;b=k[e+192>>2]|0;C=b+K|0;u=a+64|0;J=k[u>>2]|0;j=k[e+160>>2]|0;A=j+J|0;i=a+96|0;I=k[i>>2]|0;q=k[e+128>>2]|0;M=q+I|0;o=a+128|0;H=k[o>>2]|0;s=k[e+96>>2]|0;n=s+H|0;p=a+160|0;G=k[p>>2]|0;m=k[e+64>>2]|0;z=m+G|0;h=a+192|0;F=k[h>>2]|0;c=k[e+32>>2]|0;t=c+F|0;w=a+224|0;E=k[w>>2]|0;x=k[e>>2]|0;v=x+E|0;B=v+D|0;v=D-v|0;D=t+C|0;t=C-t|0;C=z+A|0;z=A-z|0;A=n+M|0;n=M-n|0;y=L-y|0;b=K-b|0;j=J-j|0;q=I-q|0;s=H-s|0;m=G-m|0;c=F-c|0;x=E-x|0;k[a>>2]=A+4+C+D+B>>3;k[o>>2]=((D-C|0)*4433|0)+32768+((B-A|0)*10703|0)>>16;o=((v-z|0)*11363|0)+((n-t|0)*2260|0)|0;k[u>>2]=(z*17799|0)+32768+(t*11893|0)+o>>16;o=(aa(n,-8697)|0)+32768+(aa(v,-1730)|0)+o>>16;k[h>>2]=o;h=((c-x|0)*3363|0)+((b+y|0)*11086|0)|0;o=((x+m|0)*5461|0)+((j+y|0)*10217|0)|0;v=((s-x|0)*7350|0)+((q+y|0)*8956|0)|0;n=((c-m|0)*11529|0)+((j+b|0)*1136|0)|0;u=(aa(c+s|0,-10217)|0)+(aa(q+b|0,-5461)|0)|0;t=((m-s|0)*3363|0)+(aa(q+j|0,-11086)|0)|0;c=aa(c,-13631)|0;j=aa(j,-9222)|0;x=(aa(y,-18730)|0)+32768+(x*6387|0)+o+h+v>>16;k[f>>2]=x;k[i>>2]=(b*589|0)+32768+c+u+n+h>>16;k[p>>2]=j+32768+(m*10055|0)+t+n+o>>16;k[w>>2]=(q*8728|0)+32768+(s*17760|0)+t+u+v>>16;if((d|0)>0){e=e+4|0;a=a+4|0;d=d+-1|0}else break}r=g;return}function Qbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=r;r=r+192|0;e=g;zpb(a|0,0,256)|0;d=0;f=a;a:while(1){p=(k[b+(d<<2)>>2]|0)+c|0;t=l[p>>0]|0;i=l[p+6>>0]|0;o=i+t|0;n=l[p+1>>0]|0;h=l[p+5>>0]|0;q=h+n|0;m=l[p+2>>0]|0;j=l[p+4>>0]|0;s=j+m|0;p=l[p+3>>0]|0;i=t-i|0;h=n-h|0;j=m-j|0;m=s+o|0;k[f>>2]=(p+q+m<<2)+-3584;m=((aa(p,-4)|0)+m|0)*2896|0;n=(o-s|0)*7542|0;s=(q-s|0)*2578|0;k[f+8>>2]=n+1024+s+m>>11;o=((o-q|0)*7223|0)+1024|0;p=o+s+(aa(q-(p<<1)|0,-5793)|0)>>11;k[f+16>>2]=p;k[f+24>>2]=o-n+m>>11;m=(h+i|0)*7663|0;n=(i-h|0)*1395|0;h=aa(j+h|0,-11295)|0;i=(j+i|0)*5027|0;k[f+4>>2]=1024-n+m+i>>11;k[f+12>>2]=n+1024+m+h>>11;k[f+20>>2]=(j*15326|0)+1024+i+h>>11;switch(d|0){case 7:{d=8;f=e;continue a}case 13:{d=0;break a}default:{}}d=d+1|0;f=f+32|0}while(1){I=k[a>>2]|0;n=k[e+160>>2]|0;A=n+I|0;t=a+32|0;H=k[t>>2]|0;h=k[e+128>>2]|0;B=h+H|0;w=a+64|0;G=k[w>>2]|0;b=k[e+96>>2]|0;J=b+G|0;m=a+96|0;F=k[m>>2]|0;o=k[e+64>>2]|0;y=o+F|0;s=a+128|0;E=k[s>>2]|0;c=k[e+32>>2]|0;v=c+E|0;q=a+160|0;D=k[q>>2]|0;i=k[e>>2]|0;u=i+D|0;j=a+192|0;C=k[j>>2]|0;f=a+224|0;p=k[f>>2]|0;x=p+C|0;z=x+A|0;x=A-x|0;A=u+B|0;u=B-u|0;B=v+J|0;v=J-v|0;n=I-n|0;h=H-h|0;b=G-b|0;o=F-o|0;c=E-c|0;i=D-i|0;p=C-p|0;k[a>>2]=((B+y+A+z|0)*5350|0)+16384>>15;y=y<<1;y=(aa(B-y|0,-4717)|0)+16384+((A-y|0)*1684|0)+((z-y|0)*6817|0)>>15;k[s>>2]=y;s=(x+u|0)*5915|0;k[w>>2]=(v*3283|0)+16384+(x*1461|0)+s>>15;s=(aa(v,-7376)|0)+16384+(aa(u,-9198)|0)+s>>15;k[j>>2]=s;j=b+h|0;s=i-c|0;k[f>>2]=((n-j+o-s-p|0)*5350|0)+16384>>15;o=o*5350|0;j=(s*7518|0)-o+(aa(j,-847)|0)|0;s=((p+c|0)*4025|0)+((b+n|0)*6406|0)|0;c=(aa(b,-12700)|0)+16384+(c*5992|0)+j+s>>15;k[q>>2]=c;q=((i-p|0)*2499|0)+((h+n|0)*7141|0)|0;j=(aa(h,-2269)|0)+16384+(aa(i,-16423)|0)+j+q>>15;k[m>>2]=j;s=(aa(n,-6029)|0)+16384+o+(aa(p,-679)|0)+q+s>>15;k[t>>2]=s;d=d+1|0;if((d|0)==7)break;else{e=e+4|0;a=a+4|0}}r=g;return}function Rbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=r;r=r+128|0;e=g;zpb(a|0,0,256)|0;d=0;f=a;a:while(1){i=(k[b+(d<<2)>>2]|0)+c|0;t=l[i>>0]|0;m=l[i+5>>0]|0;p=m+t|0;s=l[i+1>>0]|0;h=l[i+4>>0]|0;n=h+s|0;q=l[i+2>>0]|0;i=l[i+3>>0]|0;o=i+q|0;j=o+p|0;m=t-m|0;h=s-h|0;i=q-i|0;k[f>>2]=(j+n<<2)+-3072;k[f+8>>2]=((p-o|0)*10033|0)+1024>>11;j=(((aa(n,-2)|0)+j|0)*5793|0)+1024>>11;k[f+16>>2]=j;j=((i+m|0)*2998|0)+1024>>11;k[f+4>>2]=j+(h+m<<2);k[f+12>>2]=m-h-i<<2;k[f+20>>2]=j+(i-h<<2);switch(d|0){case 7:{d=8;f=e;continue a}case 11:{d=0;break a}default:{}}d=d+1|0;f=f+32|0}while(1){G=k[a>>2]|0;u=k[e+96>>2]|0;c=u+G|0;v=a+32|0;F=k[v>>2]|0;q=k[e+64>>2]|0;A=q+F|0;h=a+64|0;E=k[h>>2]|0;f=k[e+32>>2]|0;H=f+E|0;b=a+96|0;D=k[b>>2]|0;n=k[e>>2]|0;p=n+D|0;s=a+128|0;C=k[s>>2]|0;t=a+224|0;i=k[t>>2]|0;z=i+C|0;m=a+160|0;B=k[m>>2]|0;y=a+192|0;j=k[y>>2]|0;o=j+B|0;x=o+c|0;o=c-o|0;c=A-z|0;w=p+H|0;p=H-p|0;u=G-u|0;q=F-q|0;f=E-f|0;n=D-n|0;i=C-i|0;j=B-j|0;k[a>>2]=((w+A+z+x|0)*7282|0)+16384>>15;k[y>>2]=((o-(c+p)|0)*7282|0)+16384>>15;k[s>>2]=((x-w|0)*8918|0)+16384>>15;k[h>>2]=((c-p|0)*7282|0)+16384+((o+p|0)*9947|0)>>15;h=(i+q|0)*3941|0;q=h+(q*5573|0)|0;i=h+(aa(i,-13455)|0)|0;h=(f+u|0)*8170|0;p=(n+u|0)*6269|0;o=aa(n+f|0,-1344)|0;c=aa(f,-17036)|0;s=aa(j,-8170)|0;f=aa(j+f|0,-3941)|0;w=(aa(u,-4229)|0)+16384+h+p+q+(j*1344|0)>>15;k[v>>2]=w;k[b>>2]=((u-n|0)*9514|0)+16384+i+f>>15;k[m>>2]=c+16384+h+o-i+(j*6269|0)>>15;k[t>>2]=(n*5285|0)+16384+o+p-q+s>>15;d=d+1|0;if((d|0)==6)break;else{e=e+4|0;a=a+4|0}}r=g;return}function Sbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=r;r=r+64|0;e=g;zpb(a|0,0,256)|0;d=0;f=a;a:while(1){h=(k[b+(d<<2)>>2]|0)+c|0;q=l[h>>0]|0;j=l[h+4>>0]|0;n=j+q|0;p=l[h+1>>0]|0;i=l[h+3>>0]|0;m=i+p|0;h=l[h+2>>0]|0;o=m+n|0;j=q-j|0;i=p-i|0;k[f>>2]=(o+h<<2)+-2560;h=(o-(h<<2)|0)*2896|0;m=((n-m|0)*6476|0)+1024|0;k[f+8>>2]=m+h>>11;k[f+16>>2]=m-h>>11;h=(i+j|0)*6810|0;k[f+4>>2]=(j*4209|0)+1024+h>>11;h=(aa(i,-17828)|0)+1024+h>>11;k[f+12>>2]=h;switch(d|0){case 7:{d=8;f=e;continue a}case 9:{d=0;break a}default:{}}d=d+1|0;f=f+32|0}while(1){C=k[a>>2]|0;i=k[e+32>>2]|0;x=i+C|0;b=a+32|0;B=k[b>>2]|0;o=k[e>>2]|0;D=o+B|0;t=a+64|0;A=k[t>>2]|0;q=a+224|0;c=k[q>>2]|0;v=c+A|0;n=a+96|0;z=k[n>>2]|0;h=a+192|0;m=k[h>>2]|0;s=m+z|0;p=a+128|0;y=k[p>>2]|0;f=a+160|0;j=k[f>>2]|0;u=j+y|0;w=u+x|0;u=x-u|0;x=s+D|0;s=D-s|0;i=C-i|0;o=B-o|0;c=A-c|0;m=z-m|0;j=y-j|0;k[a>>2]=((x+v+w|0)*10486|0)+16384>>15;v=v<<1;v=(aa(x-v|0,-4582)|0)+16384+((w-v|0)*11997|0)>>15;k[p>>2]=v;p=(u+s|0)*8716|0;k[t>>2]=(u*5387|0)+16384+p>>15;p=(aa(s,-22820)|0)+16384+p>>15;k[h>>2]=p;h=j+i|0;p=o-m|0;k[f>>2]=((h-(p+c)|0)*10486|0)+16384>>15;c=c*10486|0;k[b>>2]=(i*14647|0)+16384+(o*13213|0)+c+(m*6732|0)+(j*2320|0)>>15;p=(p*5243|0)-c+((h+p|0)*3240|0)|0;o=((i-j|0)*9973|0)+(aa(m+o|0,-6163)|0)+16384|0;k[n>>2]=o+p>>15;k[q>>2]=o-p>>15;d=d+1|0;if((d|0)==5)break;else{e=e+4|0;a=a+4|0}}r=g;return}function Tbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;zpb(a|0,0,256)|0;d=a;e=0;while(1){f=(k[b+(e<<2)>>2]|0)+c|0;m=l[f>>0]|0;h=l[f+3>>0]|0;i=h+m|0;j=l[f+1>>0]|0;f=l[f+2>>0]|0;g=f+j|0;h=m-h|0;f=j-f|0;k[d>>2]=(g+i<<3)+-4096;k[d+8>>2]=i-g<<3;g=((f+h|0)*4433|0)+512|0;k[d+4>>2]=g+(h*6270|0)>>10;f=g+(aa(f,-15137)|0)>>10;k[d+12>>2]=f;e=e+1|0;if((e|0)==8){d=0;break}else d=d+32|0}while(1){w=k[a>>2]|0;m=a+224|0;p=k[m>>2]|0;r=p+w|0;o=a+32|0;v=k[o>>2]|0;f=a+192|0;n=k[f>>2]|0;x=n+v|0;h=a+64|0;u=k[h>>2]|0;g=a+160|0;c=k[g>>2]|0;j=c+u|0;e=a+96|0;t=k[e>>2]|0;q=a+128|0;i=k[q>>2]|0;b=i+t|0;s=r+2+b|0;b=r-b|0;r=j+x|0;j=x-j|0;p=w-p|0;n=v-n|0;c=u-c|0;i=t-i|0;k[a>>2]=s+r>>2;k[q>>2]=s-r>>2;q=((b+j|0)*4433|0)+16384|0;k[h>>2]=q+(b*6270|0)>>15;j=q+(aa(j,-15137)|0)>>15;k[f>>2]=j;f=c+p|0;j=i+n|0;q=((j+f|0)*9633|0)+16384|0;h=aa(i+p|0,-7373)|0;b=aa(c+n|0,-20995)|0;f=q+(aa(f,-3196)|0)|0;j=q+(aa(j,-16069)|0)|0;k[o>>2]=h+(p*12299|0)+f>>15;k[e>>2]=b+(n*25172|0)+j>>15;k[g>>2]=b+(c*16819|0)+f>>15;k[m>>2]=h+(i*2446|0)+j>>15;d=d+1|0;if((d|0)==4)break;else a=a+4|0}return}function Ubb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;zpb(a|0,0,256)|0;o=(k[b>>2]|0)+c|0;g=l[o>>0]|0;n=l[o+2>>0]|0;u=n+g|0;o=l[o+1>>0]|0;k[a>>2]=(u+o<<3)+-3072;u=(((aa(o,-2)|0)+u|0)*5793|0)+512>>10;o=a+8|0;k[o>>2]=u;u=a+4|0;k[u>>2]=((g-n|0)*10033|0)+512>>10;n=a+32|0;g=(k[b+4>>2]|0)+c|0;j=l[g>>0]|0;y=l[g+2>>0]|0;p=y+j|0;g=l[g+1>>0]|0;k[n>>2]=(p+g<<3)+-3072;p=(((aa(g,-2)|0)+p|0)*5793|0)+512>>10;g=a+40|0;k[g>>2]=p;p=a+36|0;k[p>>2]=((j-y|0)*10033|0)+512>>10;y=a+64|0;j=(k[b+8>>2]|0)+c|0;e=l[j>>0]|0;m=l[j+2>>0]|0;s=m+e|0;j=l[j+1>>0]|0;k[y>>2]=(s+j<<3)+-3072;s=(((aa(j,-2)|0)+s|0)*5793|0)+512>>10;j=a+72|0;k[j>>2]=s;s=a+68|0;k[s>>2]=((e-m|0)*10033|0)+512>>10;m=a+96|0;e=(k[b+12>>2]|0)+c|0;h=l[e>>0]|0;x=l[e+2>>0]|0;q=x+h|0;e=l[e+1>>0]|0;w=(q+e<<3)+-3072|0;k[m>>2]=w;q=(((aa(e,-2)|0)+q|0)*5793|0)+512>>10;e=a+104|0;k[e>>2]=q;q=a+100|0;k[q>>2]=((h-x|0)*10033|0)+512>>10;x=a+128|0;h=(k[b+16>>2]|0)+c|0;r=l[h>>0]|0;f=l[h+2>>0]|0;D=f+r|0;h=l[h+1>>0]|0;t=(D+h<<3)+-3072|0;k[x>>2]=t;D=(((aa(h,-2)|0)+D|0)*5793|0)+512>>10;h=a+136|0;k[h>>2]=D;f=((r-f|0)*10033|0)+512>>10;r=a+132|0;k[r>>2]=f;c=(k[b+20>>2]|0)+c|0;D=l[c>>0]|0;i=l[c+2>>0]|0;A=i+D|0;c=l[c+1>>0]|0;v=(A+c<<3)+-3072|0;A=(((aa(c,-2)|0)+A|0)*5793|0)+512>>10;c=a+168|0;k[c>>2]=A;i=((D-i|0)*10033|0)+512>>10;D=k[a>>2]|0;A=v+D|0;C=k[n>>2]|0;d=t+C|0;B=k[y>>2]|0;z=w+B|0;b=z+A|0;v=D-v|0;t=C-t|0;w=B-w|0;k[a>>2]=((b+d|0)*14564|0)+16384>>15;k[y>>2]=((A-z|0)*17837|0)+16384>>15;b=(((aa(d,-2)|0)+b|0)*10298|0)+16384>>15;k[x>>2]=b;x=(w+v|0)*5331|0;k[n>>2]=((t+v|0)*14564|0)+16384+x>>15;k[m>>2]=((v-t-w|0)*14564|0)+16384>>15;k[a+160>>2]=((w-t|0)*14564|0)+16384+x>>15;x=k[u>>2]|0;t=i+x|0;w=k[p>>2]|0;m=f+w|0;v=k[s>>2]|0;n=k[q>>2]|0;b=n+v|0;d=b+t|0;i=x-i|0;f=w-f|0;n=v-n|0;k[u>>2]=((d+m|0)*14564|0)+16384>>15;k[s>>2]=((t-b|0)*17837|0)+16384>>15;d=(((aa(m,-2)|0)+d|0)*10298|0)+16384>>15;k[r>>2]=d;r=(n+i|0)*5331|0;k[p>>2]=((f+i|0)*14564|0)+16384+r>>15;k[q>>2]=((i-f-n|0)*14564|0)+16384>>15;k[a+164>>2]=((n-f|0)*14564|0)+16384+r>>15;r=k[o>>2]|0;f=k[c>>2]|0;n=f+r|0;q=k[g>>2]|0;a=k[h>>2]|0;i=a+q|0;p=k[j>>2]|0;d=k[e>>2]|0;m=d+p|0;b=m+n|0;f=r-f|0;a=q-a|0;d=p-d|0;k[o>>2]=((b+i|0)*14564|0)+16384>>15;k[j>>2]=((n-m|0)*17837|0)+16384>>15;b=(((aa(i,-2)|0)+b|0)*10298|0)+16384>>15;k[h>>2]=b;b=(d+f|0)*5331|0;k[g>>2]=((a+f|0)*14564|0)+16384+b>>15;k[e>>2]=((f-a-d|0)*14564|0)+16384>>15;k[c>>2]=((d-a|0)*14564|0)+16384+b>>15;return}function Vbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0;zpb(a|0,0,256)|0;m=(k[b>>2]|0)+c|0;h=l[m>>0]|0;m=l[m+1>>0]|0;r=(m+h<<3)+-2048|0;k[a>>2]=r;m=h-m<<3;h=a+4|0;k[h>>2]=m;n=a+32|0;j=(k[b+4>>2]|0)+c|0;d=l[j>>0]|0;j=l[j+1>>0]|0;q=(j+d<<3)+-2048|0;k[n>>2]=q;j=d-j<<3;d=a+36|0;k[d>>2]=j;o=a+64|0;i=(k[b+8>>2]|0)+c|0;f=l[i>>0]|0;i=l[i+1>>0]|0;g=(i+f<<3)+-2048|0;k[o>>2]=g;i=f-i<<3;f=a+68|0;k[f>>2]=i;e=(k[b+12>>2]|0)+c|0;p=l[e>>0]|0;e=l[e+1>>0]|0;c=(e+p<<3)+-2048|0;e=p-e<<3;p=c+r|0;b=g+q|0;c=r-c|0;g=q-g|0;k[a>>2]=b+p;k[o>>2]=p-b;b=((g+c|0)*4433|0)+4096|0;k[n>>2]=b+(c*6270|0)>>13;g=b+(aa(g,-15137)|0)>>13;k[a+96>>2]=g;g=e+m|0;b=i+j|0;e=m-e|0;c=j-i|0;k[h>>2]=b+g;k[f>>2]=g-b;b=((c+e|0)*4433|0)+4096|0;k[d>>2]=b+(e*6270|0)>>13;c=b+(aa(c,-15137)|0)>>13;k[a+100>>2]=c;return}function Wbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;zpb(a|0,0,256)|0;d=l[(k[b>>2]|0)+c>>0]|0;c=l[(k[b+4>>2]|0)+c>>0]|0;k[a>>2]=(c+d<<5)+-8192;k[a+32>>2]=d-c<<5;return}function Xbb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,p=0,q=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0;q=r;r=r+256|0;f=q;p=k[a+336>>2]|0;m=f;l=k[b+84>>2]|0;g=8;while(1){h=j[c+16>>1]|0;a=j[c+32>>1]|0;b=j[c+48>>1]|0;if(!((h|a)<<16>>16))if(!(b<<16>>16))if((((j[c+64>>1]|0)==0?(j[c+80>>1]|0)==0:0)?(j[c+96>>1]|0)==0:0)?(j[c+112>>1]|0)==0:0){s=+(j[c>>1]|0)*+o[l>>2];o[m>>2]=s;o[m+32>>2]=s;o[m+64>>2]=s;o[m+96>>2]=s;o[m+128>>2]=s;o[m+160>>2]=s;o[m+192>>2]=s;o[m+224>>2]=s}else{a=0;b=0;n=9}else{a=0;n=9}else n=9;if((n|0)==9){n=0;t=+(j[c>>1]|0)*+o[l>>2];z=+(a<<16>>16)*+o[l+64>>2];y=+(j[c+64>>1]|0)*+o[l+128>>2];v=+(j[c+96>>1]|0)*+o[l+192>>2];x=t+y;y=t-y;t=z+v;v=(z-v)*1.4142135381698608-t;z=x+t;t=x-t;x=y+v;v=y-v;y=+(h<<16>>16)*+o[l+32>>2];w=+(b<<16>>16)*+o[l+96>>2];B=+(j[c+80>>1]|0)*+o[l+160>>2];s=+(j[c+112>>1]|0)*+o[l+224>>2];u=w+B;w=B-w;B=y+s;s=y-s;y=u+B;A=(w+s)*1.8477590084075928;w=A-w*2.613126039505005-y;u=(B-u)*1.4142135381698608-w;s=A-s*1.0823922157287598-u;o[m>>2]=z+y;o[m+224>>2]=z-y;o[m+32>>2]=x+w;o[m+192>>2]=x-w;o[m+64>>2]=v+u;o[m+160>>2]=v-u;o[m+96>>2]=t+s;o[m+128>>2]=t-s}if((g|0)>1){m=m+4|0;l=l+4|0;c=c+2|0;g=g+-1|0}else{a=0;break}}while(1){n=(k[d+(a<<2)>>2]|0)+e|0;u=+o[f>>2]+128.5;v=+o[f+16>>2];w=u+v;v=u-v;u=+o[f+8>>2];y=+o[f+24>>2];A=u+y;y=(u-y)*1.4142135381698608-A;u=w+A;A=w-A;w=v+y;y=v-y;v=+o[f+20>>2];x=+o[f+12>>2];z=v+x;x=v-x;v=+o[f+4>>2];B=+o[f+28>>2];s=v+B;B=v-B;v=z+s;t=(x+B)*1.8477590084075928;x=t-x*2.613126039505005-v;z=(s-z)*1.4142135381698608-x;B=t-B*1.0823922157287598-z;i[n>>0]=i[p+(~~(u+v)&1023)>>0]|0;i[n+7>>0]=i[p+(~~(u-v)&1023)>>0]|0;i[n+1>>0]=i[p+(~~(w+x)&1023)>>0]|0;i[n+6>>0]=i[p+(~~(w-x)&1023)>>0]|0;i[n+2>>0]=i[p+(~~(y+z)&1023)>>0]|0;i[n+5>>0]=i[p+(~~(y-z)&1023)>>0]|0;i[n+3>>0]=i[p+(~~(A+B)&1023)>>0]|0;i[n+4>>0]=i[p+(~~(A-B)&1023)>>0]|0;a=a+1|0;if((a|0)==8)break;else f=f+32|0}r=q;return}function Ybb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;p=r;r=r+256|0;n=p;m=k[a+336>>2]|0;l=n;h=k[b+84>>2]|0;f=8;while(1){g=j[c+16>>1]|0;a=j[c+32>>1]|0;b=j[c+48>>1]|0;if(!((g|a)<<16>>16))if(!(b<<16>>16))if((((j[c+64>>1]|0)==0?(j[c+80>>1]|0)==0:0)?(j[c+96>>1]|0)==0:0)?(j[c+112>>1]|0)==0:0){g=aa(j[c>>1]|0,k[h>>2]|0)|0;k[l>>2]=g;k[l+32>>2]=g;k[l+64>>2]=g;k[l+96>>2]=g;k[l+128>>2]=g;k[l+160>>2]=g;k[l+192>>2]=g;k[l+224>>2]=g}else{a=0;b=0;o=9}else{a=0;o=9}else o=9;if((o|0)==9){o=0;s=aa(j[c>>1]|0,k[h>>2]|0)|0;v=aa(a<<16>>16,k[h+64>>2]|0)|0;u=aa(j[c+64>>1]|0,k[h+128>>2]|0)|0;q=aa(j[c+96>>1]|0,k[h+192>>2]|0)|0;t=u+s|0;u=s-u|0;a=q+v|0;q=((v-q|0)*362>>8)-a|0;v=a+t|0;a=t-a|0;t=q+u|0;q=u-q|0;u=aa(g<<16>>16,k[h+32>>2]|0)|0;s=aa(b<<16>>16,k[h+96>>2]|0)|0;x=aa(j[c+80>>1]|0,k[h+160>>2]|0)|0;w=aa(j[c+112>>1]|0,k[h+224>>2]|0)|0;b=x+s|0;s=x-s|0;x=w+u|0;w=u-w|0;u=x+b|0;g=(w+s|0)*473>>8;s=((aa(s,-669)|0)>>8)-u+g|0;b=((x-b|0)*362>>8)-s|0;g=b+((w*277>>8)-g)|0;k[l>>2]=u+v;k[l+224>>2]=v-u;k[l+32>>2]=s+t;k[l+192>>2]=t-s;k[l+64>>2]=b+q;k[l+160>>2]=q-b;k[l+128>>2]=g+a;k[l+96>>2]=a-g}if((f|0)>1){l=l+4|0;h=h+4|0;c=c+2|0;f=f+-1|0}else break}l=m+128|0;h=0;c=n;while(1){f=(k[d+(h<<2)>>2]|0)+e|0;g=k[c+4>>2]|0;a=k[c+8>>2]|0;b=k[c+12>>2]|0;if(!(g|a))if(!b)if((((k[c+16>>2]|0)==0?(k[c+20>>2]|0)==0:0)?(k[c+24>>2]|0)==0:0)?(k[c+28>>2]|0)==0:0){x=i[l+((k[c>>2]|0)>>>5&1023)>>0]|0;i[f>>0]=x;zpb(f+1|0,x|0,7)|0}else{a=0;b=0;o=19}else{a=0;o=19}else o=19;if((o|0)==19){o=0;u=k[c>>2]|0;t=k[c+16>>2]|0;s=t+u|0;t=u-t|0;u=k[c+24>>2]|0;w=u+a|0;u=((a-u|0)*362>>8)-w|0;n=w+s|0;w=s-w|0;s=u+t|0;u=t-u|0;t=k[c+20>>2]|0;v=b+t|0;t=t-b|0;m=k[c+28>>2]|0;b=m+g|0;m=g-m|0;q=b+v|0;x=(m+t|0)*473>>8;t=((aa(t,-669)|0)>>8)-q+x|0;v=((b-v|0)*362>>8)-t|0;x=v+((m*277>>8)-x)|0;i[f>>0]=i[l+((q+n|0)>>>5&1023)>>0]|0;i[f+7>>0]=i[l+((n-q|0)>>>5&1023)>>0]|0;i[f+1>>0]=i[l+((t+s|0)>>>5&1023)>>0]|0;i[f+6>>0]=i[l+((s-t|0)>>>5&1023)>>0]|0;i[f+2>>0]=i[l+((v+u|0)>>>5&1023)>>0]|0;i[f+5>>0]=i[l+((u-v|0)>>>5&1023)>>0]|0;i[f+4>>0]=i[l+((x+w|0)>>>5&1023)>>0]|0;i[f+3>>0]=i[l+((w-x|0)>>>5&1023)>>0]|0}h=h+1|0;if((h|0)==8)break;else c=c+32|0}r=p;return}function Zbb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;p=r;r=r+256|0;n=p;m=k[a+336>>2]|0;l=n;h=k[b+84>>2]|0;f=8;while(1){g=j[c+16>>1]|0;a=j[c+32>>1]|0;b=j[c+48>>1]|0;if(!((g|a)<<16>>16))if(!(b<<16>>16))if((((j[c+64>>1]|0)==0?(j[c+80>>1]|0)==0:0)?(j[c+96>>1]|0)==0:0)?(j[c+112>>1]|0)==0:0){g=aa(k[h>>2]<<2,j[c>>1]|0)|0;k[l>>2]=g;k[l+32>>2]=g;k[l+64>>2]=g;k[l+96>>2]=g;k[l+128>>2]=g;k[l+160>>2]=g;k[l+192>>2]=g;k[l+224>>2]=g}else{a=0;b=0;o=9}else{a=0;o=9}else o=9;if((o|0)==9){o=0;a=aa(a<<16>>16,k[h+64>>2]|0)|0;q=aa(j[c+96>>1]|0,k[h+192>>2]|0)|0;z=(q+a|0)*4433|0;a=z+(a*6270|0)|0;q=z+(aa(q,-15137)|0)|0;z=aa(k[h+128>>2]<<13,j[c+64>>1]|0)|0;v=aa(k[h>>2]<<13,j[c>>1]|0)|0|1024;t=z+v|0;z=v-z|0;v=t+a|0;a=t-a|0;t=z+q|0;q=z-q|0;z=aa(j[c+112>>1]|0,k[h+224>>2]|0)|0;y=aa(j[c+80>>1]|0,k[h+160>>2]|0)|0;w=aa(b<<16>>16,k[h+96>>2]|0)|0;u=aa(g<<16>>16,k[h+32>>2]|0)|0;s=w+z|0;b=u+y|0;x=(b+s|0)*9633|0;s=x+(aa(s,-16069)|0)|0;b=x+(aa(b,-3196)|0)|0;x=aa(u+z|0,-7373)|0;g=x+(z*2446|0)+s|0;u=x+(u*12299|0)+b|0;x=aa(w+y|0,-20995)|0;b=x+(y*16819|0)+b|0;s=x+(w*25172|0)+s|0;k[l>>2]=u+v>>11;k[l+224>>2]=v-u>>11;k[l+32>>2]=s+t>>11;k[l+192>>2]=t-s>>11;k[l+64>>2]=b+q>>11;k[l+160>>2]=q-b>>11;k[l+96>>2]=g+a>>11;k[l+128>>2]=a-g>>11}if((f|0)>1){l=l+4|0;h=h+4|0;c=c+2|0;f=f+-1|0}else break}l=m+128|0;h=0;c=n;while(1){f=(k[d+(h<<2)>>2]|0)+e|0;g=k[c+4>>2]|0;a=k[c+8>>2]|0;b=k[c+12>>2]|0;if(!(g|a))if(!b)if((((k[c+16>>2]|0)==0?(k[c+20>>2]|0)==0:0)?(k[c+24>>2]|0)==0:0)?(k[c+28>>2]|0)==0:0){z=i[l+(((k[c>>2]|0)+16|0)>>>5&1023)>>0]|0;i[f>>0]=z;zpb(f+1|0,z|0,7)|0}else{a=0;b=0;o=19}else{a=0;o=19}else o=19;if((o|0)==19){o=0;w=k[c+24>>2]|0;s=(w+a|0)*4433|0;y=s+(a*6270|0)|0;w=s+(aa(w,-15137)|0)|0;s=(k[c>>2]|0)+16|0;z=k[c+16>>2]|0;u=s+z<<13;z=s-z<<13;s=u+y|0;y=u-y|0;u=z+w|0;w=z-w|0;z=k[c+28>>2]|0;n=k[c+20>>2]|0;v=b+z|0;x=g+n|0;t=(x+v|0)*9633|0;v=t+(aa(v,-16069)|0)|0;x=t+(aa(x,-3196)|0)|0;t=aa(g+z|0,-7373)|0;z=t+(z*2446|0)+v|0;t=t+(g*12299|0)+x|0;q=aa(b+n|0,-20995)|0;x=q+(n*16819|0)+x|0;v=q+(b*25172|0)+v|0;i[f>>0]=i[l+((t+s|0)>>>18&1023)>>0]|0;i[f+7>>0]=i[l+((s-t|0)>>>18&1023)>>0]|0;i[f+1>>0]=i[l+((v+u|0)>>>18&1023)>>0]|0;i[f+6>>0]=i[l+((u-v|0)>>>18&1023)>>0]|0;i[f+2>>0]=i[l+((x+w|0)>>>18&1023)>>0]|0;i[f+5>>0]=i[l+((w-x|0)>>>18&1023)>>0]|0;i[f+3>>0]=i[l+((z+y|0)>>>18&1023)>>0]|0;i[f+4>>0]=i[l+((y-z|0)>>>18&1023)>>0]|0}h=h+1|0;if((h|0)==8)break;else c=c+32|0}r=p;return}function _bb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;m=r;r=r+208|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){c=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;x=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;o=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;v=aa(j[a+96>>1]|0,k[g+192>>2]|0)|0;w=(o-v|0)*7223|0;p=(x-o|0)*2578|0;t=(aa(o,-15083)|0)+c+p+w|0;n=v+x|0;q=(n*10438|0)+c|0;v=w+(aa(v,-637)|0)+q|0;q=p+(aa(x,-20239)|0)+q|0;x=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;p=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;w=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;y=(p+x|0)*7663|0;u=(x-p|0)*1395|0;p=aa(w+p|0,-11295)|0;s=y+u+p|0;x=(w+x|0)*5027|0;u=x+(y-u)|0;p=x+(w*15326|0)+p|0;k[h>>2]=u+v>>11;k[h+168>>2]=v-u>>11;k[h+28>>2]=s+t>>11;k[h+140>>2]=t-s>>11;k[h+56>>2]=p+q>>11;k[h+112>>2]=q-p>>11;k[h+84>>2]=((o-n|0)*11585|0)+c>>11;b=b+1|0;if((b|0)==7)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){y=(k[d+(a<<2)>>2]|0)+e|0;x=(k[f>>2]<<13)+131072|0;l=k[f+8>>2]|0;v=k[f+16>>2]|0;o=k[f+24>>2]|0;n=(v-o|0)*7223|0;u=(l-v|0)*2578|0;q=(aa(v,-15083)|0)+x+u+n|0;w=o+l|0;t=(w*10438|0)+x|0;o=n+(aa(o,-637)|0)+t|0;t=u+(aa(l,-20239)|0)+t|0;l=k[f+4>>2]|0;u=k[f+12>>2]|0;n=k[f+20>>2]|0;h=(u+l|0)*7663|0;p=(l-u|0)*1395|0;u=aa(n+u|0,-11295)|0;s=h+p+u|0;l=(n+l|0)*5027|0;p=h-p+l|0;u=l+(n*15326|0)+u|0;i[y>>0]=i[b+((p+o|0)>>>18&1023)>>0]|0;i[y+6>>0]=i[b+((o-p|0)>>>18&1023)>>0]|0;i[y+1>>0]=i[b+((s+q|0)>>>18&1023)>>0]|0;i[y+5>>0]=i[b+((q-s|0)>>>18&1023)>>0]|0;i[y+2>>0]=i[b+((u+t|0)>>>18&1023)>>0]|0;i[y+4>>0]=i[b+((t-u|0)>>>18&1023)>>0]|0;i[y+3>>0]=i[b+((((v-w|0)*11585|0)+x|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==7)break;else f=f+28|0}r=m;return}function $bb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;m=r;r=r+144|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){p=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;n=aa((k[g+128>>2]|0)*5793|0,j[a+64>>1]|0)|0;u=n+p|0;p=(aa(n,-2)|0)+p>>11;n=aa((k[g+64>>2]|0)*10033|0,j[a+32>>1]|0)|0;s=n+u|0;n=u-n|0;u=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;t=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;o=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;c=(o+u|0)*2998|0;q=c+(t+u<<13)|0;c=c+(o-t<<13)|0;o=u-t-o<<2;k[h>>2]=q+s>>11;k[h+120>>2]=s-q>>11;k[h+24>>2]=o+p;k[h+96>>2]=p-o;k[h+48>>2]=c+n>>11;k[h+72>>2]=n-c>>11;b=b+1|0;if((b|0)==6)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){u=(k[d+(a<<2)>>2]|0)+e|0;s=(k[f>>2]<<13)+131072|0;p=(k[f+16>>2]|0)*5793|0;h=s+p|0;p=s-p-p|0;s=(k[f+8>>2]|0)*10033|0;n=h+s|0;s=h-s|0;h=k[f+4>>2]|0;l=k[f+12>>2]|0;q=k[f+20>>2]|0;t=(q+h|0)*2998|0;o=t+(l+h<<13)|0;t=t+(q-l<<13)|0;q=h-l-q<<13;i[u>>0]=i[b+((o+n|0)>>>18&1023)>>0]|0;i[u+5>>0]=i[b+((n-o|0)>>>18&1023)>>0]|0;i[u+1>>0]=i[b+((q+p|0)>>>18&1023)>>0]|0;i[u+4>>0]=i[b+((p-q|0)>>>18&1023)>>0]|0;i[u+2>>0]=i[b+((t+s|0)>>>18&1023)>>0]|0;i[u+3>>0]=i[b+((s-t|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==6)break;else f=f+24|0}r=m;return}function acb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;m=r;r=r+112|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){c=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;n=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;p=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;o=(p+n|0)*6476|0;p=n-p|0;n=(p*2896|0)+c|0;q=n+o|0;o=n-o|0;c=(aa(p,-11584)|0)+c|0;p=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;n=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;s=(n+p|0)*6810|0;p=s+(p*4209|0)|0;n=s+(aa(n,-17828)|0)|0;k[h>>2]=p+q>>11;k[h+80>>2]=q-p>>11;k[h+20>>2]=n+o>>11;k[h+60>>2]=o-n>>11;k[h+40>>2]=c>>11;b=b+1|0;if((b|0)==5)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){s=(k[d+(a<<2)>>2]|0)+e|0;q=(k[f>>2]<<13)+131072|0;p=k[f+8>>2]|0;n=k[f+16>>2]|0;o=(n+p|0)*6476|0;n=p-n|0;p=(n*2896|0)+q|0;l=p+o|0;o=p-o|0;q=(aa(n,-11584)|0)+q|0;n=k[f+4>>2]|0;p=k[f+12>>2]|0;h=(p+n|0)*6810|0;n=h+(n*4209|0)|0;p=h+(aa(p,-17828)|0)|0;i[s>>0]=i[b+((n+l|0)>>>18&1023)>>0]|0;i[s+4>>0]=i[b+((l-n|0)>>>18&1023)>>0]|0;i[s+1>>0]=i[b+((p+o|0)>>>18&1023)>>0]|0;i[s+3>>0]=i[b+((o-p|0)>>>18&1023)>>0]|0;i[s+2>>0]=i[b+(q>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==5)break;else f=f+20|0}r=m;return}function bcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;q=k[b+84>>2]|0;f=aa(j[c>>1]|0,k[q>>2]|0)|0;r=aa(j[c+32>>1]|0,k[q+64>>2]|0)|0;m=r+f<<2;r=f-r<<2;f=aa(j[c+16>>1]|0,k[q+32>>2]|0)|0;p=aa(j[c+48>>1]|0,k[q+96>>2]|0)|0;h=((p+f|0)*4433|0)+1024|0;f=h+(f*6270|0)>>11;p=h+(aa(p,-15137)|0)>>11;h=aa(j[c+2>>1]|0,k[q+4>>2]|0)|0;l=aa(j[c+34>>1]|0,k[q+68>>2]|0)|0;t=l+h<<2;l=h-l<<2;h=aa(j[c+18>>1]|0,k[q+36>>2]|0)|0;o=aa(j[c+50>>1]|0,k[q+100>>2]|0)|0;w=((o+h|0)*4433|0)+1024|0;h=w+(h*6270|0)>>11;o=w+(aa(o,-15137)|0)>>11;w=h+t|0;h=t-h|0;t=o+l|0;o=l-o|0;l=aa(j[c+4>>1]|0,k[q+8>>2]|0)|0;g=aa(j[c+36>>1]|0,k[q+72>>2]|0)|0;s=g+l<<2;g=l-g<<2;l=aa(j[c+20>>1]|0,k[q+40>>2]|0)|0;n=aa(j[c+52>>1]|0,k[q+104>>2]|0)|0;u=((n+l|0)*4433|0)+1024|0;l=u+(l*6270|0)>>11;n=u+(aa(n,-15137)|0)>>11;u=l+s|0;l=s-l|0;s=n+g|0;n=g-n|0;g=aa(j[c+6>>1]|0,k[q+12>>2]|0)|0;b=aa(j[c+38>>1]|0,k[q+76>>2]|0)|0;v=b+g<<2;b=g-b<<2;g=aa(j[c+22>>1]|0,k[q+44>>2]|0)|0;q=aa(j[c+54>>1]|0,k[q+108>>2]|0)|0;y=((q+g|0)*4433|0)+1024|0;g=y+(g*6270|0)>>11;q=y+(aa(q,-15137)|0)>>11;y=g+v|0;g=v-g|0;v=q+b|0;q=b-q|0;b=(k[a+336>>2]|0)+128|0;c=(k[d>>2]|0)+e|0;a=f+m+16|0;x=a+u<<13;u=a-u<<13;a=(y+w|0)*4433|0;w=a+(w*6270|0)|0;a=a+(aa(y,-15137)|0)|0;i[c>>0]=i[b+((w+x|0)>>>18&1023)>>0]|0;i[c+3>>0]=i[b+((x-w|0)>>>18&1023)>>0]|0;i[c+1>>0]=i[b+((a+u|0)>>>18&1023)>>0]|0;i[c+2>>0]=i[b+((u-a|0)>>>18&1023)>>0]|0;c=(k[d+4>>2]|0)+e|0;a=p+r+16|0;u=a+s<<13;s=a-s<<13;a=(v+t|0)*4433|0;t=a+(t*6270|0)|0;a=a+(aa(v,-15137)|0)|0;i[c>>0]=i[b+((t+u|0)>>>18&1023)>>0]|0;i[c+3>>0]=i[b+((u-t|0)>>>18&1023)>>0]|0;i[c+1>>0]=i[b+((a+s|0)>>>18&1023)>>0]|0;i[c+2>>0]=i[b+((s-a|0)>>>18&1023)>>0]|0;c=(k[d+8>>2]|0)+e|0;a=r-p+16|0;p=a+n<<13;n=a-n<<13;a=(q+o|0)*4433|0;o=a+(o*6270|0)|0;a=a+(aa(q,-15137)|0)|0;i[c>>0]=i[b+((o+p|0)>>>18&1023)>>0]|0;i[c+3>>0]=i[b+((p-o|0)>>>18&1023)>>0]|0;i[c+1>>0]=i[b+((a+n|0)>>>18&1023)>>0]|0;i[c+2>>0]=i[b+((n-a|0)>>>18&1023)>>0]|0;e=(k[d+12>>2]|0)+e|0;c=m-f+16|0;f=c+l<<13;c=c-l<<13;d=(g+h|0)*4433|0;a=d+(h*6270|0)|0;d=d+(aa(g,-15137)|0)|0;i[e>>0]=i[b+((a+f|0)>>>18&1023)>>0]|0;i[e+3>>0]=i[b+((f-a|0)>>>18&1023)>>0]|0;i[e+1>>0]=i[b+((d+c|0)>>>18&1023)>>0]|0;i[e+2>>0]=i[b+((c-d|0)>>>18&1023)>>0]|0;return}function ccb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=k[b+84>>2]|0;m=aa(k[g>>2]<<13,j[c>>1]|0)|0|1024;h=aa((k[g+64>>2]|0)*5793|0,j[c+32>>1]|0)|0;l=h+m|0;m=(aa(h,-2)|0)+m|0;h=aa((k[g+32>>2]|0)*10033|0,j[c+16>>1]|0)|0;n=aa(k[g+4>>2]<<13,j[c+2>>1]|0)|0|1024;b=aa((k[g+68>>2]|0)*5793|0,j[c+34>>1]|0)|0;f=b+n|0;n=(aa(b,-2)|0)+n|0;b=aa((k[g+36>>2]|0)*10033|0,j[c+18>>1]|0)|0;p=aa(k[g+8>>2]<<13,j[c+4>>1]|0)|0|1024;q=aa((k[g+72>>2]|0)*5793|0,j[c+36>>1]|0)|0;o=q+p|0;p=(aa(q,-2)|0)+p|0;g=aa((k[g+40>>2]|0)*10033|0,j[c+20>>1]|0)|0;q=g+o>>11;g=o-g>>11;p=p>>11;c=(k[a+336>>2]|0)+128|0;a=(k[d>>2]|0)+e|0;o=((h+l|0)>>>11<<13)+131072|0;r=o+(q*5793|0)|0;o=(aa(q,-11586)|0)+o|0;q=(b+f>>11)*10033|0;i[a>>0]=i[c+((r+q|0)>>>18&1023)>>0]|0;i[a+2>>0]=i[c+((r-q|0)>>>18&1023)>>0]|0;i[a+1>>0]=i[c+(o>>>18&1023)>>0]|0;a=(k[d+4>>2]|0)+e|0;m=(m>>>11<<13)+131072|0;o=m+(p*5793|0)|0;m=(aa(p,-11586)|0)+m|0;n=(n>>11)*10033|0;i[a>>0]=i[c+((o+n|0)>>>18&1023)>>0]|0;i[a+2>>0]=i[c+((o-n|0)>>>18&1023)>>0]|0;i[a+1>>0]=i[c+(m>>>18&1023)>>0]|0;e=(k[d+8>>2]|0)+e|0;d=((l-h|0)>>>11<<13)+131072|0;a=d+(g*5793|0)|0;d=(aa(g,-11586)|0)+d|0;b=(f-b>>11)*10033|0;i[e>>0]=i[c+((a+b|0)>>>18&1023)>>0]|0;i[e+2>>0]=i[c+((a-b|0)>>>18&1023)>>0]|0;i[e+1>>0]=i[c+(d>>>18&1023)>>0]|0;return}function dcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=(k[a+336>>2]|0)+128|0;g=k[b+84>>2]|0;f=aa(j[c>>1]|0,k[g>>2]|0)|0;b=aa(j[c+16>>1]|0,k[g+32>>2]|0)|0;f=f+4|0;h=b+f|0;b=f-b|0;f=aa(j[c+2>>1]|0,k[g+4>>2]|0)|0;c=aa(j[c+18>>1]|0,k[g+36>>2]|0)|0;g=c+f|0;c=f-c|0;f=(k[d>>2]|0)+e|0;i[f>>0]=i[a+((g+h|0)>>>3&1023)>>0]|0;i[f+1>>0]=i[a+((h-g|0)>>>3&1023)>>0]|0;e=(k[d+4>>2]|0)+e|0;i[e>>0]=i[a+((c+b|0)>>>3&1023)>>0]|0;i[e+1>>0]=i[a+((b-c|0)>>>3&1023)>>0]|0;return}function ecb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;c=(k[a+336>>2]|0)+128+(((aa(j[c>>1]|0,k[k[b+84>>2]>>2]|0)|0)+4|0)>>>3&1023)|0;i[(k[d>>2]|0)+e>>0]=i[c>>0]|0;return}function fcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=r;r=r+288|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){q=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;x=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;o=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;c=aa((k[g+192>>2]|0)*5793|0,j[a+96>>1]|0)|0;w=c+q|0;c=q-c-c|0;q=x-o|0;t=c+(q*5793|0)|0;c=(aa(q,-11586)|0)+c|0;q=(o+x|0)*10887|0;x=x*8875|0;o=o*2012|0;v=q-o+w|0;q=w-q+x|0;o=w-x+o|0;x=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;w=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;s=aa(j[a+112>>1]|0,k[g+224>>2]|0)|0;y=aa(aa(k[g+96>>2]|0,-10033)|0,j[a+48>>1]|0)|0;p=(w+x|0)*7447|0;n=(s+x|0)*3962|0;u=p-y+n|0;z=(w-s|0)*11409|0;p=y-z+p|0;n=z+y+n|0;s=(x-w-s|0)*10033|0;k[h>>2]=u+v>>11;k[h+256>>2]=v-u>>11;k[h+32>>2]=s+t>>11;k[h+224>>2]=t-s>>11;k[h+64>>2]=p+q>>11;k[h+192>>2]=q-p>>11;k[h+96>>2]=n+o>>11;k[h+160>>2]=o-n>>11;k[h+128>>2]=c>>11;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){z=(k[d+(a<<2)>>2]|0)+e|0;u=(k[f>>2]<<13)+131072|0;n=k[f+8>>2]|0;w=k[f+16>>2]|0;y=(k[f+24>>2]|0)*5793|0;o=y+u|0;y=u-y-y|0;u=n-w|0;s=y+(u*5793|0)|0;y=(aa(u,-11586)|0)+y|0;u=(w+n|0)*10887|0;n=n*8875|0;w=w*2012|0;p=u-w+o|0;u=o-u+n|0;w=o-n+w|0;n=k[f+4>>2]|0;o=k[f+20>>2]|0;t=k[f+28>>2]|0;l=aa(k[f+12>>2]|0,-10033)|0;v=(o+n|0)*7447|0;x=(t+n|0)*3962|0;q=v-l+x|0;h=(o-t|0)*11409|0;v=l-h+v|0;x=h+l+x|0;t=(n-o-t|0)*10033|0;i[z>>0]=i[b+((q+p|0)>>>18&1023)>>0]|0;i[z+8>>0]=i[b+((p-q|0)>>>18&1023)>>0]|0;i[z+1>>0]=i[b+((t+s|0)>>>18&1023)>>0]|0;i[z+7>>0]=i[b+((s-t|0)>>>18&1023)>>0]|0;i[z+2>>0]=i[b+((v+u|0)>>>18&1023)>>0]|0;i[z+6>>0]=i[b+((u-v|0)>>>18&1023)>>0]|0;i[z+3>>0]=i[b+((x+w|0)>>>18&1023)>>0]|0;i[z+5>>0]=i[b+((w-x|0)>>>18&1023)>>0]|0;i[z+4>>0]=i[b+(y>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==9)break;else f=f+32|0}r=m;return}function gcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=r;r=r+320|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){s=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;n=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;u=(n*9373|0)+s|0;x=(aa(n,-3580)|0)+s|0;s=(aa(n,-11586)|0)+s>>11;n=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;p=aa(j[a+96>>1]|0,k[g+192>>2]|0)|0;w=(p+n|0)*6810|0;n=w+(n*4209|0)|0;p=w+(aa(p,-17828)|0)|0;w=n+u|0;n=u-n|0;u=p+x|0;p=x-p|0;x=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;y=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;t=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;q=aa(j[a+112>>1]|0,k[g+224>>2]|0)|0;o=q+y|0;q=y-q|0;y=q*2531|0;z=t<<13;A=o*7791|0;c=y+z|0;v=A+(x*11443|0)+c|0;c=(x*1812|0)-A+c|0;o=o*4815|0;y=z-y-(q<<12)|0;q=x-t-q<<2;t=(x*10323|0)-o-y|0;o=y+((x*5260|0)-o)|0;k[h>>2]=v+w>>11;k[h+288>>2]=w-v>>11;k[h+32>>2]=t+u>>11;k[h+256>>2]=u-t>>11;k[h+64>>2]=q+s;k[h+224>>2]=s-q;k[h+96>>2]=o+p>>11;k[h+192>>2]=p-o>>11;k[h+128>>2]=c+n>>11;k[h+160>>2]=n-c>>11;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){A=(k[d+(a<<2)>>2]|0)+e|0;y=(k[f>>2]<<13)+131072|0;u=k[f+16>>2]|0;s=y+(u*9373|0)|0;o=y+(aa(u,-3580)|0)|0;u=y+(aa(u,-11586)|0)|0;y=k[f+8>>2]|0;w=k[f+24>>2]|0;p=(w+y|0)*6810|0;y=p+(y*4209|0)|0;w=p+(aa(w,-17828)|0)|0;p=y+s|0;y=s-y|0;s=w+o|0;w=o-w|0;o=k[f+4>>2]|0;n=k[f+12>>2]|0;v=k[f+20>>2]<<13;t=k[f+28>>2]|0;x=t+n|0;t=n-t|0;n=t*2531|0;l=x*7791|0;z=n+v|0;q=l+(o*11443|0)+z|0;z=(o*1812|0)-l+z|0;x=x*4815|0;n=v-n-(t<<12)|0;v=(o-t<<13)-v|0;t=(o*10323|0)-x-n|0;x=n+((o*5260|0)-x)|0;i[A>>0]=i[b+((q+p|0)>>>18&1023)>>0]|0;i[A+9>>0]=i[b+((p-q|0)>>>18&1023)>>0]|0;i[A+1>>0]=i[b+((t+s|0)>>>18&1023)>>0]|0;i[A+8>>0]=i[b+((s-t|0)>>>18&1023)>>0]|0;i[A+2>>0]=i[b+((v+u|0)>>>18&1023)>>0]|0;i[A+7>>0]=i[b+((u-v|0)>>>18&1023)>>0]|0;i[A+3>>0]=i[b+((x+w|0)>>>18&1023)>>0]|0;i[A+6>>0]=i[b+((w-x|0)>>>18&1023)>>0]|0;i[A+4>>0]=i[b+((z+y|0)>>>18&1023)>>0]|0;i[A+5>>0]=i[b+((y-z|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==10)break;else f=f+32|0}r=m;return}function hcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;m=r;r=r+352|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){c=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;z=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;A=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;t=aa(j[a+96>>1]|0,k[g+192>>2]|0)|0;x=(A-t|0)*20862|0;q=(A-z|0)*3529|0;o=t+z|0;w=o-A|0;y=(w*11116|0)+c|0;v=q+(aa(A,-14924)|0)+x+y|0;x=x+(t*17333|0)+y|0;q=q+(aa(z,-12399)|0)+y|0;o=y+(aa(o,-9467)|0)|0;t=o+(aa(t,-6461)|0)|0;o=(A*15929|0)+(aa(z,-11395)|0)+o|0;c=(aa(w,-11585)|0)+c|0;w=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;z=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;A=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;y=aa(j[a+112>>1]|0,k[g+224>>2]|0)|0;C=z+w|0;n=(A+C+y|0)*3264|0;C=C*7274|0;s=(A+w|0)*5492|0;p=n+((y+w|0)*3e3|0)|0;w=C+(aa(w,-7562)|0)+s+p|0;u=n+(aa(A+z|0,-9527)|0)|0;s=s+(aa(A,-9766)|0)+u|0;B=aa(y+z|0,-14731)|0;u=C+(z*16984|0)+B+u|0;p=B+(y*17223|0)+p|0;n=(A*8203|0)+(aa(z,-12019)|0)+(aa(y,-13802)|0)+n|0;k[h>>2]=w+x>>11;k[h+320>>2]=x-w>>11;k[h+32>>2]=u+v>>11;k[h+288>>2]=v-u>>11;k[h+64>>2]=s+t>>11;k[h+256>>2]=t-s>>11;k[h+96>>2]=p+q>>11;k[h+224>>2]=q-p>>11;k[h+128>>2]=n+o>>11;k[h+192>>2]=o-n>>11;k[h+160>>2]=c>>11;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){C=(k[d+(a<<2)>>2]|0)+e|0;B=(k[f>>2]<<13)+131072|0;o=k[f+8>>2]|0;n=k[f+16>>2]|0;v=k[f+24>>2]|0;q=(n-v|0)*20862|0;x=(n-o|0)*3529|0;z=v+o|0;s=z-n|0;p=(s*11116|0)+B|0;t=x+(aa(n,-14924)|0)+q+p|0;q=q+(v*17333|0)+p|0;x=x+(aa(o,-12399)|0)+p|0;z=p+(aa(z,-9467)|0)|0;v=z+(aa(v,-6461)|0)|0;z=(n*15929|0)+(aa(o,-11395)|0)+z|0;B=(aa(s,-11585)|0)+B|0;s=k[f+4>>2]|0;o=k[f+12>>2]|0;n=k[f+20>>2]|0;p=k[f+28>>2]|0;h=o+s|0;A=(h+n+p|0)*3264|0;h=h*7274|0;w=(n+s|0)*5492|0;y=A+((p+s|0)*3e3|0)|0;s=h+(aa(s,-7562)|0)+w+y|0;u=A+(aa(n+o|0,-9527)|0)|0;w=w+(aa(n,-9766)|0)+u|0;l=aa(p+o|0,-14731)|0;u=h+(o*16984|0)+l+u|0;y=l+(p*17223|0)+y|0;A=(n*8203|0)+(aa(o,-12019)|0)+(aa(p,-13802)|0)+A|0;i[C>>0]=i[b+((s+q|0)>>>18&1023)>>0]|0;i[C+10>>0]=i[b+((q-s|0)>>>18&1023)>>0]|0;i[C+1>>0]=i[b+((u+t|0)>>>18&1023)>>0]|0;i[C+9>>0]=i[b+((t-u|0)>>>18&1023)>>0]|0;i[C+2>>0]=i[b+((w+v|0)>>>18&1023)>>0]|0;i[C+8>>0]=i[b+((v-w|0)>>>18&1023)>>0]|0;i[C+3>>0]=i[b+((y+x|0)>>>18&1023)>>0]|0;i[C+7>>0]=i[b+((x-y|0)>>>18&1023)>>0]|0;i[C+4>>0]=i[b+((A+z|0)>>>18&1023)>>0]|0;i[C+6>>0]=i[b+((z-A|0)>>>18&1023)>>0]|0;i[C+5>>0]=i[b+(B>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==11)break;else f=f+32|0}r=m;return}function icb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;m=r;r=r+384|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){n=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;A=aa((k[g+128>>2]|0)*10033|0,j[a+64>>1]|0)|0;z=A+n|0;A=n-A|0;u=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;s=aa(k[g+192>>2]<<13,j[a+96>>1]|0)|0;p=(u<<13)-s|0;w=p+n|0;p=n-p|0;n=s+(u*11190|0)|0;y=n+z|0;n=z-n|0;s=(u*2998|0)-s|0;u=s+A|0;s=A-s|0;A=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;z=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;o=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;v=aa(j[a+112>>1]|0,k[g+224>>2]|0)|0;C=z*10703|0;B=aa(z,-4433)|0;t=o+A|0;c=(v+t|0)*7053|0;t=c+(t*2139|0)|0;x=C+(A*2295|0)+t|0;q=aa(v+o|0,-8565)|0;t=(aa(o,-12112)|0)+B+q+t|0;q=(v*12998|0)-C+c+q|0;c=B+(aa(A,-5540)|0)+(aa(v,-16244)|0)+c|0;v=A-v|0;o=z-o|0;z=(v+o|0)*4433|0;v=z+(v*6270|0)|0;o=z+(aa(o,-15137)|0)|0;k[h>>2]=x+y>>11;k[h+352>>2]=y-x>>11;k[h+32>>2]=v+w>>11;k[h+320>>2]=w-v>>11;k[h+64>>2]=t+u>>11;k[h+288>>2]=u-t>>11;k[h+96>>2]=q+s>>11;k[h+256>>2]=s-q>>11;k[h+128>>2]=o+p>>11;k[h+224>>2]=p-o>>11;k[h+160>>2]=c+n>>11;k[h+192>>2]=n-c>>11;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){C=(k[d+(a<<2)>>2]|0)+e|0;A=(k[f>>2]<<13)+131072|0;n=(k[f+16>>2]|0)*10033|0;o=A+n|0;n=A-n|0;u=k[f+8>>2]|0;w=k[f+24>>2]<<13;y=(u<<13)-w|0;s=y+A|0;y=A-y|0;A=w+(u*11190|0)|0;p=A+o|0;A=o-A|0;w=(u*2998|0)-w|0;u=w+n|0;w=n-w|0;n=k[f+4>>2]|0;o=k[f+12>>2]|0;z=k[f+20>>2]|0;t=k[f+28>>2]|0;h=o*10703|0;l=aa(o,-4433)|0;v=z+n|0;B=(v+t|0)*7053|0;v=B+(v*2139|0)|0;q=h+(n*2295|0)+v|0;x=aa(t+z|0,-8565)|0;v=(aa(z,-12112)|0)+l+x+v|0;x=(t*12998|0)-h+B+x|0;B=l+(aa(n,-5540)|0)+(aa(t,-16244)|0)+B|0;t=n-t|0;z=o-z|0;o=(t+z|0)*4433|0;t=o+(t*6270|0)|0;z=o+(aa(z,-15137)|0)|0;i[C>>0]=i[b+((q+p|0)>>>18&1023)>>0]|0;i[C+11>>0]=i[b+((p-q|0)>>>18&1023)>>0]|0;i[C+1>>0]=i[b+((t+s|0)>>>18&1023)>>0]|0;i[C+10>>0]=i[b+((s-t|0)>>>18&1023)>>0]|0;i[C+2>>0]=i[b+((v+u|0)>>>18&1023)>>0]|0;i[C+9>>0]=i[b+((u-v|0)>>>18&1023)>>0]|0;i[C+3>>0]=i[b+((x+w|0)>>>18&1023)>>0]|0;i[C+8>>0]=i[b+((w-x|0)>>>18&1023)>>0]|0;i[C+4>>0]=i[b+((z+y|0)>>>18&1023)>>0]|0;i[C+7>>0]=i[b+((y-z|0)>>>18&1023)>>0]|0;i[C+5>>0]=i[b+((B+A|0)>>>18&1023)>>0]|0;i[C+6>>0]=i[b+((A-B|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==12)break;else f=f+32|0}r=m;return}function jcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;m=r;r=r+416|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){c=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;n=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;t=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;o=aa(j[a+96>>1]|0,k[g+192>>2]|0)|0;s=o+t|0;o=t-o|0;t=s*9465|0;x=(o*793|0)+c|0;B=t+(n*11249|0)+x|0;x=(n*4108|0)-t+x|0;t=s*2592|0;q=(o*3989|0)+c|0;z=(n*8672|0)-t+q|0;q=t+(aa(n,-10258)|0)+q|0;s=s*3570|0;t=c+(aa(o,-7678)|0)|0;v=(aa(n,-1396)|0)-s+t|0;t=s+(aa(n,-6581)|0)+t|0;s=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;F=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;D=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;C=aa(j[a+112>>1]|0,k[g+224>>2]|0)|0;y=(F+s|0)*10832|0;w=(D+s|0)*9534|0;p=C+s|0;E=p*7682|0;A=y+(aa(s,-16549)|0)+w+E|0;H=aa(D+F|0,-2773)|0;G=aa(C+F|0,-9534)|0;y=y+(F*6859|0)+H+G|0;u=aa(C+D|0,-5384)|0;w=H+(aa(D,-12879)|0)+w+u|0;u=G+(C*18068|0)+E+u|0;p=p*2773|0;E=(D-F|0)*7682|0;s=(aa(F,-3818)|0)+(s*2611|0)+E+p|0;p=E+(D*3150|0)+(aa(C,-14273)|0)+p|0;k[h>>2]=A+B>>11;k[h+384>>2]=B-A>>11;k[h+32>>2]=y+z>>11;k[h+352>>2]=z-y>>11;k[h+64>>2]=w+x>>11;k[h+320>>2]=x-w>>11;k[h+96>>2]=u+v>>11;k[h+288>>2]=v-u>>11;k[h+128>>2]=s+t>>11;k[h+256>>2]=t-s>>11;k[h+160>>2]=p+q>>11;k[h+224>>2]=q-p>>11;k[h+192>>2]=((o-n|0)*11585|0)+c>>11;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){H=(k[d+(a<<2)>>2]|0)+e|0;G=(k[f>>2]<<13)+131072|0;F=k[f+8>>2]|0;A=k[f+16>>2]|0;E=k[f+24>>2]|0;B=E+A|0;E=A-E|0;A=B*9465|0;w=(E*793|0)+G|0;s=A+(F*11249|0)+w|0;w=(F*4108|0)-A+w|0;A=B*2592|0;C=(E*3989|0)+G|0;u=(F*8672|0)-A+C|0;C=A+(aa(F,-10258)|0)+C|0;B=B*3570|0;A=G+(aa(E,-7678)|0)|0;y=(aa(F,-1396)|0)-B+A|0;A=B+(aa(F,-6581)|0)+A|0;B=k[f+4>>2]|0;n=k[f+12>>2]|0;p=k[f+20>>2]|0;q=k[f+28>>2]|0;v=(n+B|0)*10832|0;x=(p+B|0)*9534|0;D=q+B|0;o=D*7682|0;t=v+(aa(B,-16549)|0)+x+o|0;h=aa(p+n|0,-2773)|0;l=aa(q+n|0,-9534)|0;v=v+(n*6859|0)+h+l|0;z=aa(q+p|0,-5384)|0;x=h+(aa(p,-12879)|0)+x+z|0;z=l+(q*18068|0)+o+z|0;D=D*2773|0;o=(p-n|0)*7682|0;B=(aa(n,-3818)|0)+(B*2611|0)+o+D|0;D=o+(p*3150|0)+(aa(q,-14273)|0)+D|0;i[H>>0]=i[b+((t+s|0)>>>18&1023)>>0]|0;i[H+12>>0]=i[b+((s-t|0)>>>18&1023)>>0]|0;i[H+1>>0]=i[b+((v+u|0)>>>18&1023)>>0]|0;i[H+11>>0]=i[b+((u-v|0)>>>18&1023)>>0]|0;i[H+2>>0]=i[b+((x+w|0)>>>18&1023)>>0]|0;i[H+10>>0]=i[b+((w-x|0)>>>18&1023)>>0]|0;i[H+3>>0]=i[b+((z+y|0)>>>18&1023)>>0]|0;i[H+9>>0]=i[b+((y-z|0)>>>18&1023)>>0]|0;i[H+4>>0]=i[b+((B+A|0)>>>18&1023)>>0]|0;i[H+8>>0]=i[b+((A-B|0)>>>18&1023)>>0]|0;i[H+5>>0]=i[b+((D+C|0)>>>18&1023)>>0]|0;i[H+7>>0]=i[b+((C-D|0)>>>18&1023)>>0]|0;i[H+6>>0]=i[b+((((E-F|0)*11585|0)+G|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==13)break;else f=f+32|0}r=m;return}function kcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=r;r=r+448|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){u=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;s=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;y=(s*10438|0)+u|0;w=(s*2578|0)+u|0;c=(aa(s,-7223)|0)+u|0;u=(aa(s,-11586)|0)+u>>11;s=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;A=aa(j[a+96>>1]|0,k[g+192>>2]|0)|0;p=(A+s|0)*9058|0;n=p+(s*2237|0)|0;p=p+(aa(A,-14084)|0)|0;s=(aa(A,-11295)|0)+(s*5027|0)|0;A=n+y|0;n=y-n|0;y=p+w|0;p=w-p|0;w=s+c|0;s=c-s|0;c=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;D=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;B=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;t=aa(j[a+112>>1]|0,k[g+224>>2]|0)|0;q=t<<13;F=B+c|0;x=(D+c|0)*10935|0;E=F*9810|0;z=x+(aa(c,-9232)|0)+E+q|0;F=F*6164|0;C=c-D|0;o=(C*3826|0)-q|0;c=F+(aa(c,-8693)|0)+o|0;v=(aa(B+D|0,-1297)|0)-q|0;x=x+(aa(D,-3474)|0)+v|0;v=E+(aa(B,-19447)|0)+v|0;E=(B-D|0)*11512|0;q=E+(aa(B,-13850)|0)+F+q|0;o=E+(D*5529|0)+o|0;t=C-B+t<<2;k[h>>2]=z+A>>11;k[h+416>>2]=A-z>>11;k[h+32>>2]=x+y>>11;k[h+384>>2]=y-x>>11;k[h+64>>2]=v+w>>11;k[h+352>>2]=w-v>>11;k[h+96>>2]=t+u;k[h+320>>2]=u-t;k[h+128>>2]=q+s>>11;k[h+288>>2]=s-q>>11;k[h+160>>2]=o+p>>11;k[h+256>>2]=p-o>>11;k[h+192>>2]=c+n>>11;k[h+224>>2]=n-c>>11;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){F=(k[d+(a<<2)>>2]|0)+e|0;z=(k[f>>2]<<13)+131072|0;x=k[f+16>>2]|0;t=z+(x*10438|0)|0;v=z+(x*2578|0)|0;E=z+(aa(x,-7223)|0)|0;x=z+(aa(x,-11586)|0)|0;z=k[f+8>>2]|0;q=k[f+24>>2]|0;B=(q+z|0)*9058|0;D=B+(z*2237|0)|0;B=B+(aa(q,-14084)|0)|0;z=(aa(q,-11295)|0)+(z*5027|0)|0;q=D+t|0;D=t-D|0;t=B+v|0;B=v-B|0;v=z+E|0;z=E-z|0;E=k[f+4>>2]|0;n=k[f+12>>2]|0;p=k[f+20>>2]|0;y=k[f+28>>2]<<13;A=p+E|0;u=(n+E|0)*10935|0;l=A*9810|0;s=u+(aa(E,-9232)|0)+l+y|0;A=A*6164|0;o=E-n|0;C=(o*3826|0)-y|0;E=A+(aa(E,-8693)|0)+C|0;w=(aa(p+n|0,-1297)|0)-y|0;u=u+(aa(n,-3474)|0)+w|0;w=l+(aa(p,-19447)|0)+w|0;l=(p-n|0)*11512|0;A=y+(aa(p,-13850)|0)+l+A|0;C=l+(n*5529|0)+C|0;y=(o-p<<13)+y|0;i[F>>0]=i[b+((s+q|0)>>>18&1023)>>0]|0;i[F+13>>0]=i[b+((q-s|0)>>>18&1023)>>0]|0;i[F+1>>0]=i[b+((u+t|0)>>>18&1023)>>0]|0;i[F+12>>0]=i[b+((t-u|0)>>>18&1023)>>0]|0;i[F+2>>0]=i[b+((w+v|0)>>>18&1023)>>0]|0;i[F+11>>0]=i[b+((v-w|0)>>>18&1023)>>0]|0;i[F+3>>0]=i[b+((y+x|0)>>>18&1023)>>0]|0;i[F+10>>0]=i[b+((x-y|0)>>>18&1023)>>0]|0;i[F+4>>0]=i[b+((A+z|0)>>>18&1023)>>0]|0;i[F+9>>0]=i[b+((z-A|0)>>>18&1023)>>0]|0;i[F+5>>0]=i[b+((C+B|0)>>>18&1023)>>0]|0;i[F+8>>0]=i[b+((B-C|0)>>>18&1023)>>0]|0;i[F+6>>0]=i[b+((E+D|0)>>>18&1023)>>0]|0;i[F+7>>0]=i[b+((D-E|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==14)break;else f=f+32|0}r=m;return}function lcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=r;r=r+480|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){c=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;t=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;x=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;u=aa(j[a+96>>1]|0,k[g+192>>2]|0)|0;z=(aa(u,-3580)|0)+c|0;D=(u*9373|0)+c|0;c=(aa(u,-11586)|0)+c|0;u=t-x|0;x=x+t|0;E=x*10958|0;v=u*374|0;t=t*11795|0;B=v+E+D|0;v=t-E+v+z|0;E=x*4482|0;o=aa(u,-3271)|0;q=D-E+o|0;o=E-t+o+z|0;x=x*6476|0;t=u*2896|0;z=t+x+z|0;t=D-x+t|0;x=c+(u*5792|0)|0;c=(aa(u,-11584)|0)+c|0;u=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;D=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;E=aa((k[g+160>>2]|0)*10033|0,j[a+80>>1]|0)|0;C=aa(j[a+112>>1]|0,k[g+224>>2]|0)|0;s=D-C|0;F=(s+u|0)*6810|0;y=F+(u*4209|0)|0;s=F+(aa(s,-17828)|0)|0;F=aa(D,-6810)|0;D=aa(D,-11018)|0;w=u-C|0;n=(w*11522|0)+E|0;A=(C*20131|0)-D+n|0;n=F+(aa(u,-9113)|0)+n|0;w=(w*10033|0)-E|0;p=(C+u|0)*4712|0;u=F+(u*3897|0)-E+p|0;p=E+D+(aa(C,-7121)|0)+p|0;k[h>>2]=A+B>>11;k[h+448>>2]=B-A>>11;k[h+32>>2]=y+z>>11;k[h+416>>2]=z-y>>11;k[h+64>>2]=w+x>>11;k[h+384>>2]=x-w>>11;k[h+96>>2]=u+v>>11;k[h+352>>2]=v-u>>11;k[h+128>>2]=s+t>>11;k[h+320>>2]=t-s>>11;k[h+160>>2]=p+q>>11;k[h+288>>2]=q-p>>11;k[h+192>>2]=n+o>>11;k[h+256>>2]=o-n>>11;k[h+224>>2]=c>>11;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){F=(k[d+(a<<2)>>2]|0)+e|0;E=(k[f>>2]<<13)+131072|0;y=k[f+8>>2]|0;u=k[f+16>>2]|0;x=k[f+24>>2]|0;s=(aa(x,-3580)|0)+E|0;n=(x*9373|0)+E|0;E=(aa(x,-11586)|0)+E|0;x=y-u|0;u=u+y|0;l=u*10958|0;w=x*374|0;y=y*11795|0;p=w+l+n|0;w=y-l+w+s|0;l=u*4482|0;C=aa(x,-3271)|0;A=n-l+C|0;C=l-y+C+s|0;u=u*6476|0;y=x*2896|0;s=y+u+s|0;y=n-u+y|0;u=E+(x*5792|0)|0;E=(aa(x,-11584)|0)+E|0;x=k[f+4>>2]|0;n=k[f+12>>2]|0;l=(k[f+20>>2]|0)*10033|0;o=k[f+28>>2]|0;z=n-o|0;h=(z+x|0)*6810|0;t=h+(x*4209|0)|0;z=h+(aa(z,-17828)|0)|0;h=aa(n,-6810)|0;n=aa(n,-11018)|0;v=x-o|0;D=(v*11522|0)+l|0;q=(o*20131|0)-n+D|0;D=h+(aa(x,-9113)|0)+D|0;v=(v*10033|0)-l|0;B=(o+x|0)*4712|0;x=h+(x*3897|0)-l+B|0;B=l+n+(aa(o,-7121)|0)+B|0;i[F>>0]=i[b+((q+p|0)>>>18&1023)>>0]|0;i[F+14>>0]=i[b+((p-q|0)>>>18&1023)>>0]|0;i[F+1>>0]=i[b+((t+s|0)>>>18&1023)>>0]|0;i[F+13>>0]=i[b+((s-t|0)>>>18&1023)>>0]|0;i[F+2>>0]=i[b+((v+u|0)>>>18&1023)>>0]|0;i[F+12>>0]=i[b+((u-v|0)>>>18&1023)>>0]|0;i[F+3>>0]=i[b+((x+w|0)>>>18&1023)>>0]|0;i[F+11>>0]=i[b+((w-x|0)>>>18&1023)>>0]|0;i[F+4>>0]=i[b+((z+y|0)>>>18&1023)>>0]|0;i[F+10>>0]=i[b+((y-z|0)>>>18&1023)>>0]|0;i[F+5>>0]=i[b+((B+A|0)>>>18&1023)>>0]|0;i[F+9>>0]=i[b+((A-B|0)>>>18&1023)>>0]|0;i[F+6>>0]=i[b+((D+C|0)>>>18&1023)>>0]|0;i[F+8>>0]=i[b+((C-D|0)>>>18&1023)>>0]|0;i[F+7>>0]=i[b+(E>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==15)break;else f=f+32|0}r=m;return}function mcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=r;r=r+512|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){s=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;w=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;c=w*10703|0;w=w*4433|0;A=c+s|0;c=s-c|0;y=w+s|0;w=s-w|0;s=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;u=aa(j[a+96>>1]|0,k[g+192>>2]|0)|0;o=s-u|0;C=o*2260|0;o=o*11363|0;n=o+(u*20995|0)|0;p=C+(s*7373|0)|0;s=o+(aa(s,-4926)|0)|0;u=C+(aa(u,-4176)|0)|0;C=n+A|0;n=A-n|0;A=p+y|0;p=y-p|0;y=s+w|0;s=w-s|0;w=u+c|0;u=c-u|0;c=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;o=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;E=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;G=aa(j[a+112>>1]|0,k[g+224>>2]|0)|0;D=E+c|0;z=(o+c|0)*11086|0;x=D*10217|0;q=(G+c|0)*8956|0;t=(c-G|0)*7350|0;D=D*5461|0;v=(c-o|0)*3363|0;B=z+(aa(c,-18730)|0)+x+q|0;c=v+(aa(c,-15038)|0)+D+t|0;J=(E+o|0)*1136|0;F=(E-o|0)*11529|0;H=G+o|0;I=aa(H,-5461)|0;z=z+(o*589|0)+J+I|0;H=aa(H,-10217)|0;o=v+(o*16154|0)+F+H|0;v=aa(G+E|0,-11086)|0;x=J+(aa(E,-9222)|0)+x+v|0;v=I+(G*8728|0)+q+v|0;q=(G-E|0)*3363|0;t=H+(G*25733|0)+t+q|0;q=F+(aa(E,-6278)|0)+D+q|0;k[h>>2]=B+C>>11;k[h+480>>2]=C-B>>11;k[h+32>>2]=z+A>>11;k[h+448>>2]=A-z>>11;k[h+64>>2]=x+y>>11;k[h+416>>2]=y-x>>11;k[h+96>>2]=v+w>>11;k[h+384>>2]=w-v>>11;k[h+128>>2]=t+u>>11;k[h+352>>2]=u-t>>11;k[h+160>>2]=q+s>>11;k[h+320>>2]=s-q>>11;k[h+192>>2]=o+p>>11;k[h+288>>2]=p-o>>11;k[h+224>>2]=c+n>>11;k[h+256>>2]=n-c>>11;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){J=(k[d+(a<<2)>>2]|0)+e|0;D=(k[f>>2]<<13)+131072|0;z=k[f+16>>2]|0;I=z*10703|0;z=z*4433|0;v=D+I|0;I=D-I|0;x=D+z|0;z=D-z|0;D=k[f+8>>2]|0;B=k[f+24>>2]|0;G=D-B|0;t=G*2260|0;G=G*11363|0;H=G+(B*20995|0)|0;F=t+(D*7373|0)|0;D=G+(aa(D,-4926)|0)|0;B=t+(aa(B,-4176)|0)|0;t=H+v|0;H=v-H|0;v=F+x|0;F=x-F|0;x=D+z|0;D=z-D|0;z=B+I|0;B=I-B|0;I=k[f+4>>2]|0;G=k[f+12>>2]|0;q=k[f+20>>2]|0;o=k[f+28>>2]|0;s=q+I|0;w=(G+I|0)*11086|0;y=s*10217|0;E=(o+I|0)*8956|0;C=(I-o|0)*7350|0;s=s*5461|0;A=(I-G|0)*3363|0;u=w+(aa(I,-18730)|0)+y+E|0;I=A+(aa(I,-15038)|0)+s+C|0;h=(q+G|0)*1136|0;p=(q-G|0)*11529|0;n=o+G|0;l=aa(n,-5461)|0;w=w+(G*589|0)+h+l|0;n=aa(n,-10217)|0;G=A+(G*16154|0)+p+n|0;A=aa(o+q|0,-11086)|0;y=h+(aa(q,-9222)|0)+y+A|0;A=l+(o*8728|0)+E+A|0;E=(o-q|0)*3363|0;C=n+(o*25733|0)+C+E|0;E=p+(aa(q,-6278)|0)+s+E|0;i[J>>0]=i[b+((u+t|0)>>>18&1023)>>0]|0;i[J+15>>0]=i[b+((t-u|0)>>>18&1023)>>0]|0;i[J+1>>0]=i[b+((w+v|0)>>>18&1023)>>0]|0;i[J+14>>0]=i[b+((v-w|0)>>>18&1023)>>0]|0;i[J+2>>0]=i[b+((y+x|0)>>>18&1023)>>0]|0;i[J+13>>0]=i[b+((x-y|0)>>>18&1023)>>0]|0;i[J+3>>0]=i[b+((A+z|0)>>>18&1023)>>0]|0;i[J+12>>0]=i[b+((z-A|0)>>>18&1023)>>0]|0;i[J+4>>0]=i[b+((C+B|0)>>>18&1023)>>0]|0;i[J+11>>0]=i[b+((B-C|0)>>>18&1023)>>0]|0;i[J+5>>0]=i[b+((E+D|0)>>>18&1023)>>0]|0;i[J+10>>0]=i[b+((D-E|0)>>>18&1023)>>0]|0;i[J+6>>0]=i[b+((G+F|0)>>>18&1023)>>0]|0;i[J+9>>0]=i[b+((F-G|0)>>>18&1023)>>0]|0;i[J+7>>0]=i[b+((I+H|0)>>>18&1023)>>0]|0;i[J+8>>0]=i[b+((H-I|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==16)break;else f=f+32|0}r=m;return}function ncb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;p=r;r=r+256|0;f=p;n=k[a+336>>2]|0;m=f;l=k[b+84>>2]|0;g=8;while(1){h=j[c+16>>1]|0;a=j[c+32>>1]|0;b=j[c+48>>1]|0;if(!((h|a)<<16>>16))if(!(b<<16>>16))if((((j[c+64>>1]|0)==0?(j[c+80>>1]|0)==0:0)?(j[c+96>>1]|0)==0:0)?(j[c+112>>1]|0)==0:0){h=aa(k[l>>2]<<2,j[c>>1]|0)|0;k[m>>2]=h;k[m+32>>2]=h;k[m+64>>2]=h;k[m+96>>2]=h;k[m+128>>2]=h;k[m+160>>2]=h;k[m+192>>2]=h;k[m+224>>2]=h}else{a=0;b=0;o=9}else{a=0;o=9}else o=9;if((o|0)==9){o=0;a=aa(a<<16>>16,k[l+64>>2]|0)|0;q=aa(j[c+96>>1]|0,k[l+192>>2]|0)|0;z=(q+a|0)*4433|0;a=z+(a*6270|0)|0;q=z+(aa(q,-15137)|0)|0;z=aa(k[l+128>>2]<<13,j[c+64>>1]|0)|0;v=aa(k[l>>2]<<13,j[c>>1]|0)|0|1024;t=z+v|0;z=v-z|0;v=t+a|0;a=t-a|0;t=z+q|0;q=z-q|0;z=aa(j[c+112>>1]|0,k[l+224>>2]|0)|0;y=aa(j[c+80>>1]|0,k[l+160>>2]|0)|0;w=aa(b<<16>>16,k[l+96>>2]|0)|0;u=aa(h<<16>>16,k[l+32>>2]|0)|0;s=w+z|0;b=u+y|0;x=(b+s|0)*9633|0;s=x+(aa(s,-16069)|0)|0;b=x+(aa(b,-3196)|0)|0;x=aa(u+z|0,-7373)|0;h=x+(z*2446|0)+s|0;u=x+(u*12299|0)+b|0;x=aa(w+y|0,-20995)|0;b=x+(y*16819|0)+b|0;s=x+(w*25172|0)+s|0;k[m>>2]=u+v>>11;k[m+224>>2]=v-u>>11;k[m+32>>2]=s+t>>11;k[m+192>>2]=t-s>>11;k[m+64>>2]=b+q>>11;k[m+160>>2]=q-b>>11;k[m+96>>2]=h+a>>11;k[m+128>>2]=a-h>>11}if((g|0)>1){m=m+4|0;l=l+4|0;c=c+2|0;g=g+-1|0}else break}b=n+128|0;a=0;while(1){z=(k[d+(a<<2)>>2]|0)+e|0;t=(k[f>>2]<<13)+131072|0;n=k[f+16>>2]|0;y=n*10703|0;n=n*4433|0;g=t+y|0;y=t-y|0;l=t+n|0;n=t-n|0;t=k[f+8>>2]|0;q=k[f+24>>2]|0;w=t-q|0;A=w*2260|0;w=w*11363|0;x=w+(q*20995|0)|0;v=A+(t*7373|0)|0;t=w+(aa(t,-4926)|0)|0;q=A+(aa(q,-4176)|0)|0;A=x+g|0;x=g-x|0;g=v+l|0;v=l-v|0;l=t+n|0;t=n-t|0;n=q+y|0;q=y-q|0;y=k[f+4>>2]|0;w=k[f+12>>2]|0;C=k[f+20>>2]|0;E=k[f+28>>2]|0;B=C+y|0;h=(w+y|0)*11086|0;m=B*10217|0;u=(E+y|0)*8956|0;s=(y-E|0)*7350|0;B=B*5461|0;o=(y-w|0)*3363|0;c=h+(aa(y,-18730)|0)+m+u|0;y=o+(aa(y,-15038)|0)+B+s|0;H=(C+w|0)*1136|0;D=(C-w|0)*11529|0;F=E+w|0;G=aa(F,-5461)|0;h=h+(w*589|0)+H+G|0;F=aa(F,-10217)|0;w=o+(w*16154|0)+D+F|0;o=aa(E+C|0,-11086)|0;m=H+(aa(C,-9222)|0)+m+o|0;o=G+(E*8728|0)+u+o|0;u=(E-C|0)*3363|0;s=F+(E*25733|0)+s+u|0;u=D+(aa(C,-6278)|0)+B+u|0;i[z>>0]=i[b+((c+A|0)>>>18&1023)>>0]|0;i[z+15>>0]=i[b+((A-c|0)>>>18&1023)>>0]|0;i[z+1>>0]=i[b+((h+g|0)>>>18&1023)>>0]|0;i[z+14>>0]=i[b+((g-h|0)>>>18&1023)>>0]|0;i[z+2>>0]=i[b+((m+l|0)>>>18&1023)>>0]|0;i[z+13>>0]=i[b+((l-m|0)>>>18&1023)>>0]|0;i[z+3>>0]=i[b+((o+n|0)>>>18&1023)>>0]|0;i[z+12>>0]=i[b+((n-o|0)>>>18&1023)>>0]|0;i[z+4>>0]=i[b+((s+q|0)>>>18&1023)>>0]|0;i[z+11>>0]=i[b+((q-s|0)>>>18&1023)>>0]|0;i[z+5>>0]=i[b+((u+t|0)>>>18&1023)>>0]|0;i[z+10>>0]=i[b+((t-u|0)>>>18&1023)>>0]|0;i[z+6>>0]=i[b+((w+v|0)>>>18&1023)>>0]|0;i[z+9>>0]=i[b+((v-w|0)>>>18&1023)>>0]|0;i[z+7>>0]=i[b+((y+x|0)>>>18&1023)>>0]|0;i[z+8>>0]=i[b+((x-y|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==8)break;else f=f+32|0}r=p;return}function ocb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;m=r;r=r+224|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){c=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;x=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;o=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;v=aa(j[a+96>>1]|0,k[g+192>>2]|0)|0;w=(o-v|0)*7223|0;p=(x-o|0)*2578|0;t=(aa(o,-15083)|0)+c+p+w|0;n=v+x|0;q=(n*10438|0)+c|0;v=w+(aa(v,-637)|0)+q|0;q=p+(aa(x,-20239)|0)+q|0;x=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;p=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;w=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;y=(p+x|0)*7663|0;u=(x-p|0)*1395|0;p=aa(w+p|0,-11295)|0;s=y+u+p|0;x=(w+x|0)*5027|0;u=x+(y-u)|0;p=x+(w*15326|0)+p|0;k[h>>2]=u+v>>11;k[h+192>>2]=v-u>>11;k[h+32>>2]=s+t>>11;k[h+160>>2]=t-s>>11;k[h+64>>2]=p+q>>11;k[h+128>>2]=q-p>>11;k[h+96>>2]=((o-n|0)*11585|0)+c>>11;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){y=(k[d+(a<<2)>>2]|0)+e|0;s=(k[f>>2]<<13)+131072|0;p=k[f+16>>2]|0;h=s+(p*10438|0)|0;n=s+(p*2578|0)|0;x=s+(aa(p,-7223)|0)|0;p=s+(aa(p,-11586)|0)|0;s=k[f+8>>2]|0;g=k[f+24>>2]|0;u=(g+s|0)*9058|0;w=u+(s*2237|0)|0;u=u+(aa(g,-14084)|0)|0;s=(aa(g,-11295)|0)+(s*5027|0)|0;g=w+h|0;w=h-w|0;h=u+n|0;u=n-u|0;n=s+x|0;s=x-s|0;x=k[f+4>>2]|0;B=k[f+12>>2]|0;z=k[f+20>>2]|0;q=k[f+28>>2]<<13;t=z+x|0;l=(B+x|0)*10935|0;C=t*9810|0;c=l+(aa(x,-9232)|0)+C+q|0;t=t*6164|0;A=x-B|0;v=(A*3826|0)-q|0;x=t+(aa(x,-8693)|0)+v|0;o=(aa(z+B|0,-1297)|0)-q|0;l=l+(aa(B,-3474)|0)+o|0;o=C+(aa(z,-19447)|0)+o|0;C=(z-B|0)*11512|0;t=q+(aa(z,-13850)|0)+C+t|0;v=C+(B*5529|0)+v|0;q=(A-z<<13)+q|0;i[y>>0]=i[b+((c+g|0)>>>18&1023)>>0]|0;i[y+13>>0]=i[b+((g-c|0)>>>18&1023)>>0]|0;i[y+1>>0]=i[b+((l+h|0)>>>18&1023)>>0]|0;i[y+12>>0]=i[b+((h-l|0)>>>18&1023)>>0]|0;i[y+2>>0]=i[b+((o+n|0)>>>18&1023)>>0]|0;i[y+11>>0]=i[b+((n-o|0)>>>18&1023)>>0]|0;i[y+3>>0]=i[b+((q+p|0)>>>18&1023)>>0]|0;i[y+10>>0]=i[b+((p-q|0)>>>18&1023)>>0]|0;i[y+4>>0]=i[b+((t+s|0)>>>18&1023)>>0]|0;i[y+9>>0]=i[b+((s-t|0)>>>18&1023)>>0]|0;i[y+5>>0]=i[b+((v+u|0)>>>18&1023)>>0]|0;i[y+8>>0]=i[b+((u-v|0)>>>18&1023)>>0]|0;i[y+6>>0]=i[b+((x+w|0)>>>18&1023)>>0]|0;i[y+7>>0]=i[b+((w-x|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==7)break;else f=f+32|0}r=m;return}function pcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=r;r=r+192|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){p=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;n=aa((k[g+128>>2]|0)*5793|0,j[a+64>>1]|0)|0;u=n+p|0;p=(aa(n,-2)|0)+p>>11;n=aa((k[g+64>>2]|0)*10033|0,j[a+32>>1]|0)|0;s=n+u|0;n=u-n|0;u=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;t=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;o=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;c=(o+u|0)*2998|0;q=c+(t+u<<13)|0;c=c+(o-t<<13)|0;o=u-t-o<<2;k[h>>2]=q+s>>11;k[h+160>>2]=s-q>>11;k[h+32>>2]=o+p;k[h+128>>2]=p-o;k[h+64>>2]=c+n>>11;k[h+96>>2]=n-c>>11;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){u=(k[d+(a<<2)>>2]|0)+e|0;s=(k[f>>2]<<13)+131072|0;y=(k[f+16>>2]|0)*10033|0;x=s+y|0;y=s-y|0;h=k[f+8>>2]|0;n=k[f+24>>2]<<13;p=(h<<13)-n|0;g=p+s|0;p=s-p|0;s=n+(h*11190|0)|0;w=s+x|0;s=x-s|0;n=(h*2998|0)-n|0;h=n+y|0;n=y-n|0;y=k[f+4>>2]|0;x=k[f+12>>2]|0;q=k[f+20>>2]|0;c=k[f+28>>2]|0;A=x*10703|0;z=aa(x,-4433)|0;l=q+y|0;t=(l+c|0)*7053|0;l=t+(l*2139|0)|0;v=A+(y*2295|0)+l|0;o=aa(c+q|0,-8565)|0;l=(aa(q,-12112)|0)+z+o+l|0;o=(c*12998|0)-A+t+o|0;t=z+(aa(y,-5540)|0)+(aa(c,-16244)|0)+t|0;c=y-c|0;q=x-q|0;x=(c+q|0)*4433|0;c=x+(c*6270|0)|0;q=x+(aa(q,-15137)|0)|0;i[u>>0]=i[b+((v+w|0)>>>18&1023)>>0]|0;i[u+11>>0]=i[b+((w-v|0)>>>18&1023)>>0]|0;i[u+1>>0]=i[b+((c+g|0)>>>18&1023)>>0]|0;i[u+10>>0]=i[b+((g-c|0)>>>18&1023)>>0]|0;i[u+2>>0]=i[b+((l+h|0)>>>18&1023)>>0]|0;i[u+9>>0]=i[b+((h-l|0)>>>18&1023)>>0]|0;i[u+3>>0]=i[b+((o+n|0)>>>18&1023)>>0]|0;i[u+8>>0]=i[b+((n-o|0)>>>18&1023)>>0]|0;i[u+4>>0]=i[b+((q+p|0)>>>18&1023)>>0]|0;i[u+7>>0]=i[b+((p-q|0)>>>18&1023)>>0]|0;i[u+5>>0]=i[b+((t+s|0)>>>18&1023)>>0]|0;i[u+6>>0]=i[b+((s-t|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==6)break;else f=f+32|0}r=m;return}function qcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;m=r;r=r+160|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){c=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;n=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;p=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;o=(p+n|0)*6476|0;p=n-p|0;n=(p*2896|0)+c|0;q=n+o|0;o=n-o|0;c=(aa(p,-11584)|0)+c|0;p=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;n=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;s=(n+p|0)*6810|0;p=s+(p*4209|0)|0;n=s+(aa(n,-17828)|0)|0;k[h>>2]=p+q>>11;k[h+128>>2]=q-p>>11;k[h+32>>2]=n+o>>11;k[h+96>>2]=o-n>>11;k[h+64>>2]=c>>11;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){s=(k[d+(a<<2)>>2]|0)+e|0;p=(k[f>>2]<<13)+131072|0;h=k[f+16>>2]|0;g=p+(h*9373|0)|0;v=p+(aa(h,-3580)|0)|0;h=p+(aa(h,-11586)|0)|0;p=k[f+8>>2]|0;n=k[f+24>>2]|0;u=(n+p|0)*6810|0;p=u+(p*4209|0)|0;n=u+(aa(n,-17828)|0)|0;u=p+g|0;p=g-p|0;g=n+v|0;n=v-n|0;v=k[f+4>>2]|0;w=k[f+12>>2]|0;l=k[f+20>>2]<<13;c=k[f+28>>2]|0;o=c+w|0;c=w-c|0;w=c*2531|0;x=o*7791|0;q=w+l|0;t=x+(v*11443|0)+q|0;q=(v*1812|0)-x+q|0;o=o*4815|0;w=l-w-(c<<12)|0;l=(v-c<<13)-l|0;c=(v*10323|0)-o-w|0;o=w+((v*5260|0)-o)|0;i[s>>0]=i[b+((t+u|0)>>>18&1023)>>0]|0;i[s+9>>0]=i[b+((u-t|0)>>>18&1023)>>0]|0;i[s+1>>0]=i[b+((c+g|0)>>>18&1023)>>0]|0;i[s+8>>0]=i[b+((g-c|0)>>>18&1023)>>0]|0;i[s+2>>0]=i[b+((l+h|0)>>>18&1023)>>0]|0;i[s+7>>0]=i[b+((h-l|0)>>>18&1023)>>0]|0;i[s+3>>0]=i[b+((o+n|0)>>>18&1023)>>0]|0;i[s+6>>0]=i[b+((n-o|0)>>>18&1023)>>0]|0;i[s+4>>0]=i[b+((q+p|0)>>>18&1023)>>0]|0;i[s+5>>0]=i[b+((p-q|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==5)break;else f=f+32|0}r=m;return}function rcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;m=r;r=r+128|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){o=aa(j[a>>1]|0,k[g>>2]|0)|0;n=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;p=n+o<<2;n=o-n<<2;o=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;c=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;q=((c+o|0)*4433|0)+1024|0;o=q+(o*6270|0)>>11;c=q+(aa(c,-15137)|0)>>11;k[h>>2]=o+p;k[h+96>>2]=p-o;k[h+32>>2]=c+n;k[h+64>>2]=n-c;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){q=(k[d+(a<<2)>>2]|0)+e|0;o=k[f+8>>2]|0;l=k[f+24>>2]|0;s=(l+o|0)*4433|0;o=s+(o*6270|0)|0;l=s+(aa(l,-15137)|0)|0;s=(k[f>>2]|0)+16|0;p=k[f+16>>2]|0;c=s+p<<13;p=s-p<<13;s=c+o|0;o=c-o|0;c=p+l|0;l=p-l|0;p=k[f+28>>2]|0;v=k[f+20>>2]|0;t=k[f+12>>2]|0;g=k[f+4>>2]|0;h=t+p|0;n=g+v|0;u=(n+h|0)*9633|0;h=u+(aa(h,-16069)|0)|0;n=u+(aa(n,-3196)|0)|0;u=aa(g+p|0,-7373)|0;p=u+(p*2446|0)+h|0;g=u+(g*12299|0)+n|0;u=aa(t+v|0,-20995)|0;n=u+(v*16819|0)+n|0;h=u+(t*25172|0)+h|0;i[q>>0]=i[b+((g+s|0)>>>18&1023)>>0]|0;i[q+7>>0]=i[b+((s-g|0)>>>18&1023)>>0]|0;i[q+1>>0]=i[b+((h+c|0)>>>18&1023)>>0]|0;i[q+6>>0]=i[b+((c-h|0)>>>18&1023)>>0]|0;i[q+2>>0]=i[b+((n+l|0)>>>18&1023)>>0]|0;i[q+5>>0]=i[b+((l-n|0)>>>18&1023)>>0]|0;i[q+3>>0]=i[b+((p+o|0)>>>18&1023)>>0]|0;i[q+4>>0]=i[b+((o-p|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==4)break;else f=f+32|0}r=m;return}function scb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;m=r;r=r+80|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){c=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;n=aa((k[g+64>>2]|0)*5793|0,j[a+32>>1]|0)|0;o=n+c|0;c=(aa(n,-2)|0)+c|0;n=aa((k[g+32>>2]|0)*10033|0,j[a+16>>1]|0)|0;k[h>>2]=n+o>>11;k[h+48>>2]=o-n>>11;k[h+24>>2]=c>>11;b=b+1|0;if((b|0)==6)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){o=(k[d+(a<<2)>>2]|0)+e|0;l=(k[f>>2]<<13)+131072|0;c=(k[f+16>>2]|0)*5793|0;s=l+c|0;c=l-c-c|0;l=(k[f+8>>2]|0)*10033|0;p=s+l|0;l=s-l|0;s=k[f+4>>2]|0;q=k[f+12>>2]|0;h=k[f+20>>2]|0;n=(h+s|0)*2998|0;g=n+(q+s<<13)|0;n=n+(h-q<<13)|0;h=s-q-h<<13;i[o>>0]=i[b+((g+p|0)>>>18&1023)>>0]|0;i[o+5>>0]=i[b+((p-g|0)>>>18&1023)>>0]|0;i[o+1>>0]=i[b+((h+c|0)>>>18&1023)>>0]|0;i[o+4>>0]=i[b+((c-h|0)>>>18&1023)>>0]|0;i[o+2>>0]=i[b+((n+l|0)>>>18&1023)>>0]|0;i[o+3>>0]=i[b+((l-n|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==3)break;else f=f+24|0}r=m;return}function tcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0;g=k[b+84>>2]|0;m=aa(j[c>>1]|0,k[g>>2]|0)|0;f=aa(j[c+16>>1]|0,k[g+32>>2]|0)|0;b=aa(j[c+2>>1]|0,k[g+4>>2]|0)|0;h=aa(j[c+18>>1]|0,k[g+36>>2]|0)|0;o=h+b|0;h=b-h|0;b=aa(j[c+4>>1]|0,k[g+8>>2]|0)|0;l=aa(j[c+20>>1]|0,k[g+40>>2]|0)|0;n=l+b|0;l=b-l|0;b=aa(j[c+6>>1]|0,k[g+12>>2]|0)|0;g=aa(j[c+22>>1]|0,k[g+44>>2]|0)|0;q=g+b|0;g=b-g|0;b=(k[a+336>>2]|0)+128|0;c=(k[d>>2]|0)+e|0;a=f+m+4|0;p=a+n<<13;n=a-n<<13;a=(q+o|0)*4433|0;o=a+(o*6270|0)|0;a=a+(aa(q,-15137)|0)|0;i[c>>0]=i[b+((o+p|0)>>>16&1023)>>0]|0;i[c+3>>0]=i[b+((p-o|0)>>>16&1023)>>0]|0;i[c+1>>0]=i[b+((a+n|0)>>>16&1023)>>0]|0;i[c+2>>0]=i[b+((n-a|0)>>>16&1023)>>0]|0;e=(k[d+4>>2]|0)+e|0;c=m-f+4|0;f=c+l<<13;c=c-l<<13;d=(g+h|0)*4433|0;a=d+(h*6270|0)|0;d=d+(aa(g,-15137)|0)|0;i[e>>0]=i[b+((a+f|0)>>>16&1023)>>0]|0;i[e+3>>0]=i[b+((f-a|0)>>>16&1023)>>0]|0;i[e+1>>0]=i[b+((d+c|0)>>>16&1023)>>0]|0;i[e+2>>0]=i[b+((c-d|0)>>>16&1023)>>0]|0;return}function ucb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=(k[a+336>>2]|0)+128|0;f=k[b+84>>2]|0;e=(k[d>>2]|0)+e|0;b=(aa(j[c>>1]|0,k[f>>2]|0)|0)+4|0;d=aa(j[c+2>>1]|0,k[f+4>>2]|0)|0;i[e>>0]=i[a+((d+b|0)>>>3&1023)>>0]|0;i[e+1>>0]=i[a+((b-d|0)>>>3&1023)>>0]|0;return}function vcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=r;r=r+512|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){s=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;w=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;c=w*10703|0;w=w*4433|0;A=c+s|0;c=s-c|0;y=w+s|0;w=s-w|0;s=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;u=aa(j[a+96>>1]|0,k[g+192>>2]|0)|0;o=s-u|0;C=o*2260|0;o=o*11363|0;n=o+(u*20995|0)|0;p=C+(s*7373|0)|0;s=o+(aa(s,-4926)|0)|0;u=C+(aa(u,-4176)|0)|0;C=n+A|0;n=A-n|0;A=p+y|0;p=y-p|0;y=s+w|0;s=w-s|0;w=u+c|0;u=c-u|0;c=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;o=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;E=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;G=aa(j[a+112>>1]|0,k[g+224>>2]|0)|0;D=E+c|0;z=(o+c|0)*11086|0;x=D*10217|0;q=(G+c|0)*8956|0;t=(c-G|0)*7350|0;D=D*5461|0;v=(c-o|0)*3363|0;B=z+(aa(c,-18730)|0)+x+q|0;c=v+(aa(c,-15038)|0)+D+t|0;J=(E+o|0)*1136|0;F=(E-o|0)*11529|0;H=G+o|0;I=aa(H,-5461)|0;z=z+(o*589|0)+J+I|0;H=aa(H,-10217)|0;o=v+(o*16154|0)+F+H|0;v=aa(G+E|0,-11086)|0;x=J+(aa(E,-9222)|0)+x+v|0;v=I+(G*8728|0)+q+v|0;q=(G-E|0)*3363|0;t=H+(G*25733|0)+t+q|0;q=F+(aa(E,-6278)|0)+D+q|0;k[h>>2]=B+C>>11;k[h+480>>2]=C-B>>11;k[h+32>>2]=z+A>>11;k[h+448>>2]=A-z>>11;k[h+64>>2]=x+y>>11;k[h+416>>2]=y-x>>11;k[h+96>>2]=v+w>>11;k[h+384>>2]=w-v>>11;k[h+128>>2]=t+u>>11;k[h+352>>2]=u-t>>11;k[h+160>>2]=q+s>>11;k[h+320>>2]=s-q>>11;k[h+192>>2]=o+p>>11;k[h+288>>2]=p-o>>11;k[h+224>>2]=c+n>>11;k[h+256>>2]=n-c>>11;b=b+1|0;if((b|0)==8)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){J=(k[d+(a<<2)>>2]|0)+e|0;H=k[f+8>>2]|0;F=k[f+24>>2]|0;B=(F+H|0)*4433|0;H=B+(H*6270|0)|0;F=B+(aa(F,-15137)|0)|0;B=(k[f>>2]|0)+16|0;I=k[f+16>>2]|0;D=B+I<<13;I=B-I<<13;B=D+H|0;H=D-H|0;D=I+F|0;F=I-F|0;I=k[f+28>>2]|0;y=k[f+20>>2]|0;A=k[f+12>>2]|0;C=k[f+4>>2]|0;E=A+I|0;G=C+y|0;z=(G+E|0)*9633|0;E=z+(aa(E,-16069)|0)|0;G=z+(aa(G,-3196)|0)|0;z=aa(C+I|0,-7373)|0;I=z+(I*2446|0)+E|0;C=z+(C*12299|0)+G|0;z=aa(A+y|0,-20995)|0;G=z+(y*16819|0)+G|0;E=z+(A*25172|0)+E|0;i[J>>0]=i[b+((C+B|0)>>>18&1023)>>0]|0;i[J+7>>0]=i[b+((B-C|0)>>>18&1023)>>0]|0;i[J+1>>0]=i[b+((E+D|0)>>>18&1023)>>0]|0;i[J+6>>0]=i[b+((D-E|0)>>>18&1023)>>0]|0;i[J+2>>0]=i[b+((G+F|0)>>>18&1023)>>0]|0;i[J+5>>0]=i[b+((F-G|0)>>>18&1023)>>0]|0;i[J+3>>0]=i[b+((I+H|0)>>>18&1023)>>0]|0;i[J+4>>0]=i[b+((H-I|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==16)break;else f=f+32|0}r=m;return}function wcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=r;r=r+400|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){u=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;s=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;y=(s*10438|0)+u|0;w=(s*2578|0)+u|0;c=(aa(s,-7223)|0)+u|0;u=(aa(s,-11586)|0)+u>>11;s=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;A=aa(j[a+96>>1]|0,k[g+192>>2]|0)|0;p=(A+s|0)*9058|0;n=p+(s*2237|0)|0;p=p+(aa(A,-14084)|0)|0;s=(aa(A,-11295)|0)+(s*5027|0)|0;A=n+y|0;n=y-n|0;y=p+w|0;p=w-p|0;w=s+c|0;s=c-s|0;c=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;D=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;B=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;t=aa(j[a+112>>1]|0,k[g+224>>2]|0)|0;q=t<<13;F=B+c|0;x=(D+c|0)*10935|0;E=F*9810|0;z=x+(aa(c,-9232)|0)+E+q|0;F=F*6164|0;C=c-D|0;o=(C*3826|0)-q|0;c=F+(aa(c,-8693)|0)+o|0;v=(aa(B+D|0,-1297)|0)-q|0;x=x+(aa(D,-3474)|0)+v|0;v=E+(aa(B,-19447)|0)+v|0;E=(B-D|0)*11512|0;q=E+(aa(B,-13850)|0)+F+q|0;o=E+(D*5529|0)+o|0;t=C-B+t<<2;k[h>>2]=z+A>>11;k[h+364>>2]=A-z>>11;k[h+28>>2]=x+y>>11;k[h+336>>2]=y-x>>11;k[h+56>>2]=v+w>>11;k[h+308>>2]=w-v>>11;k[h+84>>2]=t+u;k[h+280>>2]=u-t;k[h+112>>2]=q+s>>11;k[h+252>>2]=s-q>>11;k[h+140>>2]=o+p>>11;k[h+224>>2]=p-o>>11;k[h+168>>2]=c+n>>11;k[h+196>>2]=n-c>>11;b=b+1|0;if((b|0)==7)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){F=(k[d+(a<<2)>>2]|0)+e|0;E=(k[f>>2]<<13)+131072|0;u=k[f+8>>2]|0;C=k[f+16>>2]|0;w=k[f+24>>2]|0;v=(C-w|0)*7223|0;B=(u-C|0)*2578|0;y=(aa(C,-15083)|0)+E+B+v|0;D=w+u|0;A=(D*10438|0)+E|0;w=v+(aa(w,-637)|0)+A|0;A=B+(aa(u,-20239)|0)+A|0;u=k[f+4>>2]|0;B=k[f+12>>2]|0;v=k[f+20>>2]|0;t=(B+u|0)*7663|0;x=(u-B|0)*1395|0;B=aa(v+B|0,-11295)|0;z=t+x+B|0;u=(v+u|0)*5027|0;x=t-x+u|0;B=u+(v*15326|0)+B|0;i[F>>0]=i[b+((x+w|0)>>>18&1023)>>0]|0;i[F+6>>0]=i[b+((w-x|0)>>>18&1023)>>0]|0;i[F+1>>0]=i[b+((z+y|0)>>>18&1023)>>0]|0;i[F+5>>0]=i[b+((y-z|0)>>>18&1023)>>0]|0;i[F+2>>0]=i[b+((B+A|0)>>>18&1023)>>0]|0;i[F+4>>0]=i[b+((A-B|0)>>>18&1023)>>0]|0;i[F+3>>0]=i[b+((((C-D|0)*11585|0)+E|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==14)break;else f=f+28|0}r=m;return}function xcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;m=r;r=r+288|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){n=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;A=aa((k[g+128>>2]|0)*10033|0,j[a+64>>1]|0)|0;z=A+n|0;A=n-A|0;u=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;s=aa(k[g+192>>2]<<13,j[a+96>>1]|0)|0;p=(u<<13)-s|0;w=p+n|0;p=n-p|0;n=s+(u*11190|0)|0;y=n+z|0;n=z-n|0;s=(u*2998|0)-s|0;u=s+A|0;s=A-s|0;A=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;z=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;o=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;v=aa(j[a+112>>1]|0,k[g+224>>2]|0)|0;C=z*10703|0;B=aa(z,-4433)|0;t=o+A|0;c=(v+t|0)*7053|0;t=c+(t*2139|0)|0;x=C+(A*2295|0)+t|0;q=aa(v+o|0,-8565)|0;t=(aa(o,-12112)|0)+B+q+t|0;q=(v*12998|0)-C+c+q|0;c=B+(aa(A,-5540)|0)+(aa(v,-16244)|0)+c|0;v=A-v|0;o=z-o|0;z=(v+o|0)*4433|0;v=z+(v*6270|0)|0;o=z+(aa(o,-15137)|0)|0;k[h>>2]=x+y>>11;k[h+264>>2]=y-x>>11;k[h+24>>2]=v+w>>11;k[h+240>>2]=w-v>>11;k[h+48>>2]=t+u>>11;k[h+216>>2]=u-t>>11;k[h+72>>2]=q+s>>11;k[h+192>>2]=s-q>>11;k[h+96>>2]=o+p>>11;k[h+168>>2]=p-o>>11;k[h+120>>2]=c+n>>11;k[h+144>>2]=n-c>>11;b=b+1|0;if((b|0)==6)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){C=(k[d+(a<<2)>>2]|0)+e|0;A=(k[f>>2]<<13)+131072|0;y=(k[f+16>>2]|0)*5793|0;u=A+y|0;y=A-y-y|0;A=(k[f+8>>2]|0)*10033|0;w=u+A|0;A=u-A|0;u=k[f+4>>2]|0;v=k[f+12>>2]|0;z=k[f+20>>2]|0;B=(z+u|0)*2998|0;x=B+(v+u<<13)|0;B=B+(z-v<<13)|0;z=u-v-z<<13;i[C>>0]=i[b+((x+w|0)>>>18&1023)>>0]|0;i[C+5>>0]=i[b+((w-x|0)>>>18&1023)>>0]|0;i[C+1>>0]=i[b+((z+y|0)>>>18&1023)>>0]|0;i[C+4>>0]=i[b+((y-z|0)>>>18&1023)>>0]|0;i[C+2>>0]=i[b+((B+A|0)>>>18&1023)>>0]|0;i[C+3>>0]=i[b+((A-B|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==12)break;else f=f+24|0}r=m;return}function ycb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=r;r=r+208|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){s=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;n=aa(j[a+64>>1]|0,k[g+128>>2]|0)|0;u=(n*9373|0)+s|0;x=(aa(n,-3580)|0)+s|0;s=(aa(n,-11586)|0)+s>>11;n=aa(j[a+32>>1]|0,k[g+64>>2]|0)|0;p=aa(j[a+96>>1]|0,k[g+192>>2]|0)|0;w=(p+n|0)*6810|0;n=w+(n*4209|0)|0;p=w+(aa(p,-17828)|0)|0;w=n+u|0;n=u-n|0;u=p+x|0;p=x-p|0;x=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;y=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;t=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;q=aa(j[a+112>>1]|0,k[g+224>>2]|0)|0;o=q+y|0;q=y-q|0;y=q*2531|0;z=t<<13;A=o*7791|0;c=y+z|0;v=A+(x*11443|0)+c|0;c=(x*1812|0)-A+c|0;o=o*4815|0;y=z-y-(q<<12)|0;q=x-t-q<<2;t=(x*10323|0)-o-y|0;o=y+((x*5260|0)-o)|0;k[h>>2]=v+w>>11;k[h+180>>2]=w-v>>11;k[h+20>>2]=t+u>>11;k[h+160>>2]=u-t>>11;k[h+40>>2]=q+s;k[h+140>>2]=s-q;k[h+60>>2]=o+p>>11;k[h+120>>2]=p-o>>11;k[h+80>>2]=c+n>>11;k[h+100>>2]=n-c>>11;b=b+1|0;if((b|0)==5)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){A=(k[d+(a<<2)>>2]|0)+e|0;z=(k[f>>2]<<13)+131072|0;y=k[f+8>>2]|0;w=k[f+16>>2]|0;x=(w+y|0)*6476|0;w=y-w|0;y=(w*2896|0)+z|0;v=y+x|0;x=y-x|0;z=(aa(w,-11584)|0)+z|0;w=k[f+4>>2]|0;y=k[f+12>>2]|0;u=(y+w|0)*6810|0;w=u+(w*4209|0)|0;y=u+(aa(y,-17828)|0)|0;i[A>>0]=i[b+((w+v|0)>>>18&1023)>>0]|0;i[A+4>>0]=i[b+((v-w|0)>>>18&1023)>>0]|0;i[A+1>>0]=i[b+((y+x|0)>>>18&1023)>>0]|0;i[A+3>>0]=i[b+((x-y|0)>>>18&1023)>>0]|0;i[A+2>>0]=i[b+(z>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==10)break;else f=f+20|0}r=m;return}function zcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;p=r;r=r+128|0;f=p;n=k[a+336>>2]|0;m=f;l=k[b+84>>2]|0;g=4;while(1){h=j[c+16>>1]|0;a=j[c+32>>1]|0;b=j[c+48>>1]|0;if(!((h|a)<<16>>16))if(!(b<<16>>16))if((((j[c+64>>1]|0)==0?(j[c+80>>1]|0)==0:0)?(j[c+96>>1]|0)==0:0)?(j[c+112>>1]|0)==0:0){h=aa(k[l>>2]<<2,j[c>>1]|0)|0;k[m>>2]=h;k[m+16>>2]=h;k[m+32>>2]=h;k[m+48>>2]=h;k[m+64>>2]=h;k[m+80>>2]=h;k[m+96>>2]=h;k[m+112>>2]=h}else{a=0;b=0;o=9}else{a=0;o=9}else o=9;if((o|0)==9){o=0;a=aa(a<<16>>16,k[l+64>>2]|0)|0;q=aa(j[c+96>>1]|0,k[l+192>>2]|0)|0;z=(q+a|0)*4433|0;a=z+(a*6270|0)|0;q=z+(aa(q,-15137)|0)|0;z=aa(k[l+128>>2]<<13,j[c+64>>1]|0)|0;v=aa(k[l>>2]<<13,j[c>>1]|0)|0|1024;t=z+v|0;z=v-z|0;v=t+a|0;a=t-a|0;t=z+q|0;q=z-q|0;z=aa(j[c+112>>1]|0,k[l+224>>2]|0)|0;y=aa(j[c+80>>1]|0,k[l+160>>2]|0)|0;w=aa(b<<16>>16,k[l+96>>2]|0)|0;u=aa(h<<16>>16,k[l+32>>2]|0)|0;s=w+z|0;b=u+y|0;x=(b+s|0)*9633|0;s=x+(aa(s,-16069)|0)|0;b=x+(aa(b,-3196)|0)|0;x=aa(u+z|0,-7373)|0;h=x+(z*2446|0)+s|0;u=x+(u*12299|0)+b|0;x=aa(w+y|0,-20995)|0;b=x+(y*16819|0)+b|0;s=x+(w*25172|0)+s|0;k[m>>2]=u+v>>11;k[m+112>>2]=v-u>>11;k[m+16>>2]=s+t>>11;k[m+96>>2]=t-s>>11;k[m+32>>2]=b+q>>11;k[m+80>>2]=q-b>>11;k[m+48>>2]=h+a>>11;k[m+64>>2]=a-h>>11}if((g|0)>1){m=m+4|0;l=l+4|0;c=c+2|0;g=g+-1|0}else break}b=n+128|0;a=0;while(1){z=(k[d+(a<<2)>>2]|0)+e|0;w=(k[f>>2]|0)+16|0;x=k[f+8>>2]|0;v=w+x<<13;x=w-x<<13;w=k[f+4>>2]|0;y=k[f+12>>2]|0;u=(y+w|0)*4433|0;w=u+(w*6270|0)|0;y=u+(aa(y,-15137)|0)|0;i[z>>0]=i[b+((w+v|0)>>>18&1023)>>0]|0;i[z+3>>0]=i[b+((v-w|0)>>>18&1023)>>0]|0;i[z+1>>0]=i[b+((y+x|0)>>>18&1023)>>0]|0;i[z+2>>0]=i[b+((x-y|0)>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==8)break;else f=f+16|0}r=p;return}function Acb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;m=r;r=r+80|0;f=m;l=k[a+336>>2]|0;h=f;g=k[b+84>>2]|0;a=c;b=0;while(1){p=aa(k[g>>2]<<13,j[a>>1]|0)|0|1024;n=aa((k[g+128>>2]|0)*5793|0,j[a+64>>1]|0)|0;u=n+p|0;p=(aa(n,-2)|0)+p>>11;n=aa((k[g+64>>2]|0)*10033|0,j[a+32>>1]|0)|0;s=n+u|0;n=u-n|0;u=aa(j[a+16>>1]|0,k[g+32>>2]|0)|0;t=aa(j[a+48>>1]|0,k[g+96>>2]|0)|0;o=aa(j[a+80>>1]|0,k[g+160>>2]|0)|0;c=(o+u|0)*2998|0;q=c+(t+u<<13)|0;c=c+(o-t<<13)|0;o=u-t-o<<2;k[h>>2]=q+s>>11;k[h+60>>2]=s-q>>11;k[h+12>>2]=o+p;k[h+48>>2]=p-o;k[h+24>>2]=c+n>>11;k[h+36>>2]=n-c>>11;b=b+1|0;if((b|0)==3)break;else{h=h+4|0;g=g+4|0;a=a+2|0}}b=l+128|0;a=0;while(1){u=(k[d+(a<<2)>>2]|0)+e|0;t=(k[f>>2]<<13)+131072|0;s=k[f+8>>2]|0;q=t+(s*5793|0)|0;t=(aa(s,-11586)|0)+t|0;s=(k[f+4>>2]|0)*10033|0;i[u>>0]=i[b+((q+s|0)>>>18&1023)>>0]|0;i[u+2>>0]=i[b+((q-s|0)>>>18&1023)>>0]|0;i[u+1>>0]=i[b+(t>>>18&1023)>>0]|0;a=a+1|0;if((a|0)==6)break;else f=f+12|0}r=m;return}function Bcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0;h=k[b+84>>2]|0;f=aa(j[c>>1]|0,k[h>>2]|0)|0;m=aa(j[c+32>>1]|0,k[h+64>>2]|0)|0;g=m+f<<13;m=f-m<<13;f=aa(j[c+16>>1]|0,k[h+32>>2]|0)|0;l=aa(j[c+48>>1]|0,k[h+96>>2]|0)|0;p=(l+f|0)*4433|0;f=p+(f*6270|0)|0;l=p+(aa(l,-15137)|0)|0;p=aa(j[c+2>>1]|0,k[h+4>>2]|0)|0;b=aa(j[c+34>>1]|0,k[h+68>>2]|0)|0;n=b+p<<13;b=p-b<<13;p=aa(j[c+18>>1]|0,k[h+36>>2]|0)|0;h=aa(j[c+50>>1]|0,k[h+100>>2]|0)|0;o=(h+p|0)*4433|0;c=o+(p*6270|0)|0;h=o+(aa(h,-15137)|0)|0;o=c+n|0;c=n-c|0;n=h+b|0;h=b-h|0;b=(k[a+336>>2]|0)+128|0;a=(k[d>>2]|0)+e|0;p=f+g+32768|0;i[a>>0]=i[b+((p+o|0)>>>16&1023)>>0]|0;i[a+1>>0]=i[b+((p-o|0)>>>16&1023)>>0]|0;a=(k[d+4>>2]|0)+e|0;o=l+m+32768|0;i[a>>0]=i[b+((o+n|0)>>>16&1023)>>0]|0;i[a+1>>0]=i[b+((o-n|0)>>>16&1023)>>0]|0;a=(k[d+8>>2]|0)+e|0;l=m-l+32768|0;i[a>>0]=i[b+((l+h|0)>>>16&1023)>>0]|0;i[a+1>>0]=i[b+((l-h|0)>>>16&1023)>>0]|0;e=(k[d+12>>2]|0)+e|0;d=g-f+32768|0;i[e>>0]=i[b+((d+c|0)>>>16&1023)>>0]|0;i[e+1>>0]=i[b+((d-c|0)>>>16&1023)>>0]|0;return}function Ccb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=(k[a+336>>2]|0)+128|0;f=k[b+84>>2]|0;b=(aa(j[c>>1]|0,k[f>>2]|0)|0)+4|0;c=aa(j[c+16>>1]|0,k[f+32>>2]|0)|0;i[(k[d>>2]|0)+e>>0]=i[a+((c+b|0)>>>3&1023)>>0]|0;i[(k[d+4>>2]|0)+e>>0]=i[a+((b-c|0)>>>3&1023)>>0]|0;return}function Dcb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;u=r;r=r+96|0;t=u+56|0;p=u+40|0;o=u+32|0;s=u+24|0;q=u+8|0;n=u;g=u+72|0;h=u+64|0;j=u+76|0;l=h+4|0;m=g;f=0;while(1){k[g>>2]=j;k[n>>2]=423843;k[n+4>>2]=7;if(!(Ge(33,n|0)|0))c=0;else{c=7;break}while(1){k[q>>2]=0;k[q+4>>2]=h;k[q+8>>2]=0;ne(265,q|0)|0;e=k[g>>2]|0;d=k[l>>2]^m^e;v=k[206798]|0;k[206798]=v+1;k[s>>2]=v;k[s+4>>2]=d;kfb(e,20,423848,s)|0;k[o>>2]=k[g>>2];k[o+4>>2]=0;if(Ge(33,o|0)|0)break;d=c+1|0;if((c|0)<100)c=d;else{c=d;break}}d=k[g>>2]|0;if((c|0)>99){c=7;break}if(!d){c=14;break}k[p>>2]=d;k[p+4>>2]=32962;k[p+8>>2]=384;e=fe(5,p|0)|0;if(e>>>0<=4294963200){if((e|0)>-1){c=15;break}}else{if(!(k[206783]|0))c=827176;else{c=(Fpb()|0)+64|0;c=k[c>>2]|0}k[c>>2]=0-e}f=f+1|0;if((f|0)>=100){c=14;break}}if((c|0)==7)c=14;else if((c|0)==15?(v=Tfb(e,423840)|0,k[t>>2]=d,_d(10,t|0)|0,k[b+12>>2]=v,v|0):0){k[b>>2]=204;v=b+4|0;k[v>>2]=205;v=b+8|0;k[v>>2]=849;r=u;return}if((c|0)==14)k[b+12>>2]=0;c=k[a>>2]|0;k[c+20>>2]=65;c=c+24|0;d=c+80|0;do{i[c>>0]=0;c=c+1|0}while((c|0)<(d|0));Uh[k[k[a>>2]>>2]&2047](a);k[b>>2]=204;v=b+4|0;k[v>>2]=205;v=b+8|0;k[v>>2]=849;r=u;return}function Ecb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;h=b+12|0;i=k[h>>2]|0;b=i+20|0;f=i+28|0;g=(k[b>>2]|0)>>>0>(k[f>>2]|0)>>>0;do if((k[i+76>>2]|0)>-1){if(g?(ci[k[i+36>>2]&255](i,0,0)|0,(k[b>>2]|0)==0):0){j=10;break}k[i+16>>2]=0;k[f>>2]=0;k[b>>2]=0;if((ci[k[i+40>>2]&255](i,d,0)|0)<0)j=10;else{k[i+8>>2]=0;k[i+4>>2]=0;k[i>>2]=k[i>>2]&-17}}else{if(g?(ci[k[i+36>>2]&255](i,0,0)|0,(k[b>>2]|0)==0):0){j=10;break}k[i+16>>2]=0;k[f>>2]=0;k[b>>2]=0;if((ci[k[i+40>>2]&255](i,d,0)|0)<0)j=10;else{k[i+8>>2]=0;k[i+4>>2]=0;k[i>>2]=k[i>>2]&-17}}while(0);if((j|0)==10){j=k[a>>2]|0;k[j+20>>2]=67;Uh[k[j>>2]&2047](a)}if((_fb(c,1,e,k[h>>2]|0)|0)==(e|0))return;j=k[a>>2]|0;k[j+20>>2]=66;Uh[k[j>>2]&2047](a);return}function Fcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0;h=b+12|0;j=k[h>>2]|0;b=j+20|0;f=j+28|0;g=(k[b>>2]|0)>>>0>(k[f>>2]|0)>>>0;do if((k[j+76>>2]|0)>-1){if(g?(ci[k[j+36>>2]&255](j,0,0)|0,(k[b>>2]|0)==0):0){l=10;break}k[j+16>>2]=0;k[f>>2]=0;k[b>>2]=0;if((ci[k[j+40>>2]&255](j,d,0)|0)<0)l=10;else{k[j+8>>2]=0;k[j+4>>2]=0;k[j>>2]=k[j>>2]&-17}}else{if(g?(ci[k[j+36>>2]&255](j,0,0)|0,(k[b>>2]|0)==0):0){l=10;break}k[j+16>>2]=0;k[f>>2]=0;k[b>>2]=0;if((ci[k[j+40>>2]&255](j,d,0)|0)<0)l=10;else{k[j+8>>2]=0;k[j+4>>2]=0;k[j>>2]=k[j>>2]&-17}}while(0);if((l|0)==10){l=k[a>>2]|0;k[l+20>>2]=67;Uh[k[l>>2]&2047](a)}h=k[h>>2]|0;g=h+16|0;b=k[g>>2]|0;f=(b|0)==0;a:do if((k[h+76>>2]|0)>-1){do if(f){b=h+74|0;l=i[b>>0]|0;i[b>>0]=l+255|l;b=k[h>>2]|0;if(!(b&8)){k[h+8>>2]=0;k[h+4>>2]=0;l=k[h+44>>2]|0;k[h+28>>2]=l;j=h+20|0;k[j>>2]=l;b=l+(k[h+48>>2]|0)|0;k[g>>2]=b;g=l;break}else{k[h>>2]=b|32;b=0;break a}}else{g=h+20|0;j=g;g=k[g>>2]|0}while(0);f=g;if((b-g|0)>>>0<e>>>0){b=ci[k[h+36>>2]&255](h,c,e)|0;break}b:do if((i[h+75>>0]|0)>-1){b=e;while(1){if(!b){h=e;g=c;b=0;break b}g=b+-1|0;if((i[c+g>>0]|0)==10)break;else b=g}if((ci[k[h+36>>2]&255](h,c,b)|0)>>>0<b>>>0)break a;h=e-b|0;g=c+b|0;f=k[j>>2]|0}else{h=e;g=c;b=0}while(0);upb(f|0,g|0,h|0)|0;k[j>>2]=(k[j>>2]|0)+h;b=b+h|0}else{do if(f){b=h+74|0;l=i[b>>0]|0;i[b>>0]=l+255|l;b=k[h>>2]|0;if(!(b&8)){k[h+8>>2]=0;k[h+4>>2]=0;l=k[h+44>>2]|0;k[h+28>>2]=l;j=h+20|0;k[j>>2]=l;b=l+(k[h+48>>2]|0)|0;k[g>>2]=b;g=l;break}else{k[h>>2]=b|32;b=0;break a}}else{g=h+20|0;j=g;g=k[g>>2]|0}while(0);f=g;if((b-g|0)>>>0<e>>>0){b=ci[k[h+36>>2]&255](h,c,e)|0;break}c:do if((i[h+75>>0]|0)>-1){b=e;while(1){if(!b){h=e;g=c;b=0;break c}g=b+-1|0;if((i[c+g>>0]|0)==10)break;else b=g}if((ci[k[h+36>>2]&255](h,c,b)|0)>>>0<b>>>0)break a;h=e-b|0;g=c+b|0;f=k[j>>2]|0}else{h=e;g=c;b=0}while(0);upb(f|0,g|0,h|0)|0;k[j>>2]=(k[j>>2]|0)+h;b=b+h|0}while(0);if((b|0)==(e|0))return;e=k[a>>2]|0;k[e+20>>2]=68;Uh[k[e>>2]&2047](a);return}function Gcb(a,b){a=a|0;b=b|0;Qfb(k[b+12>>2]|0)|0;return}function Hcb(a,b,c){a=a|0;b=b|0;c=c|0;if(!a){a=0;return a|0}if((4294967295/(c>>>0)|0)>>>0<=b>>>0){Vcb(a,410826);a=0;return a|0}b=aa(c,b)|0;if(b|0){c=k[a+688>>2]|0;if(!c)b=fgb(b)|0;else b=Hh[c&511](a,b)|0;if(b|0){a=b;return a|0}}Vcb(a,412758);a=0;return a|0}function Icb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==0|(b|0)==0)return;c=k[a+692>>2]|0;if(!c){ggb(b);return}else{jh[c&1023](a,b);return}}function Jcb(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+1152|0;n=4;l=fgb(40)|0;k[l>>2]=0;g=o+1024|0;m=o+156|0;h=o;zpb(m|0,0,868)|0;k[m+716>>2]=1e6;k[m+720>>2]=1e6;k[m+724>>2]=1e3;k[m+728>>2]=8e6;k[m+684>>2]=0;j=m+688|0;k[j>>2]=0;k[m+692>>2]=0;k[m+176>>2]=0;k[m+168>>2]=0;k[m+172>>2]=0;n=npb(h,1,l|0,n|0)|0;l=N;y=0;a=y;y=0;if((a|0)!=0&(z|0)!=0){b=Cpb(k[a>>2]|0,n|0,l|0)|0;if(!b)dd(a|0,z|0);N=z}else b=-1;if((b|0)==1)a=N;else a=0;while(1){if(a|0){a=0;b=22;break}d=m+160|0;k[d>>2]=h;e=m+164|0;k[e>>2]=0;f=m+156|0;k[f>>2]=826;if(!(k[m+212>>2]&131072)){a=k[j>>2]|0;if(!a){y=0;a=uc(777,868)|0;b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,n|0,l|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){a=N;continue}}else{y=0;a=ec(a|0,m|0,868)|0;b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,n|0,l|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){a=N;continue}}if(a|0){b=21;break}y=0;Ib(824,m|0,412758);a=y;y=0;if((a|0)!=0&(z|0)!=0){b=Cpb(k[a>>2]|0,n|0,l|0)|0;if(!b)dd(a|0,z|0);N=z}else b=-1;if((b|0)==1){a=N;continue}else{b=20;break}}else{i[g>>0]=65;i[g+1>>0]=112;i[g+2>>0]=112;i[g+3>>0]=108;i[g+4>>0]=105;i[g+5>>0]=99;i[g+6>>0]=97;i[g+7>>0]=116;i[g+8>>0]=105;i[g+9>>0]=111;i[g+10>>0]=110;i[g+11>>0]=32;i[g+12>>0]=98;i[g+13>>0]=117;i[g+14>>0]=105;i[g+15>>0]=108;i[g+16>>0]=116;i[g+17>>0]=32;i[g+18>>0]=119;i[g+19>>0]=105;i[g+20>>0]=116;i[g+21>>0]=104;i[g+22>>0]=32;i[g+23>>0]=108;i[g+24>>0]=105;i[g+25>>0]=98;i[g+26>>0]=112;i[g+27>>0]=110;i[g+28>>0]=103;i[g+29>>0]=45;i[g+30>>0]=49;i[g+31>>0]=46;i[g+32>>0]=54;i[g+33>>0]=46;i[g+34>>0]=49;i[g+35>>0]=57;i[g+36>>0]=0;a=36;b=410868;c=32;do{b=b+1|0;f=a;a=a+1|0;i[g+f>>0]=c;c=i[b>>0]|0}while(a>>>0<127&c<<24>>24!=0);i[g+a>>0]=0;if(a>>>0<128){if((a|0)==127)a=127;else{b=a;c=410861;d=49;while(1){c=c+1|0;a=b+1|0;i[g+b>>0]=d;d=i[c>>0]|0;if(!(a>>>0<127&d<<24>>24!=0))break;else b=a}}i[g+a>>0]=0}y=0;Ib(824,m|0,g|0);a=y;y=0;if((a|0)!=0&(z|0)!=0){b=Cpb(k[a>>2]|0,n|0,l|0)|0;if(!b)dd(a|0,z|0);N=z}else b=-1;if((b|0)==1){a=N;continue}else{b=12;break}}}if((b|0)==12){m=0;ggb(n|0);r=o;return m|0}else if((b|0)==20){m=0;ggb(n|0);r=o;return m|0}else if((b|0)==21){k[m+256>>2]=150;k[m+260>>2]=850;k[m+264>>2]=a;k[d>>2]=0;k[e>>2]=0;k[f>>2]=0;upb(a|0,m|0,868)|0;m=a;ggb(n|0);r=o;return m|0}else if((b|0)==22){ggb(n|0);r=o;return a|0}return 0}function Kcb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,m=0,n=0,o=0;if((a|0)==0|(b|0)==0)return;o=b+136|0;e=k[o>>2]|0;do if(e){n=b+232|0;if(!(c&16384&k[n>>2]))o=n;else{if((d|0)!=-1){e=k[e+(d*28|0)+4>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);k[(k[o>>2]|0)+(d*28|0)+4>>2]=0;o=n;break}m=b+128|0;if((k[m>>2]|0)>0){e=k[e+4>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);if((k[m>>2]|0)>1){e=a+692|0;f=1;do{g=k[(k[o>>2]|0)+(f*28|0)+4>>2]|0;do if(g|0){h=k[e>>2]|0;if(!h){ggb(g);break}else{jh[h&1023](a,g);break}}while(0);f=f+1|0}while((f|0)<(k[m>>2]|0))}g=a;e=k[o>>2]|0}else g=a;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](g,e);break}}while(0);k[o>>2]=0;k[m>>2]=0;o=n}}else o=b+232|0;while(0);e=k[o>>2]|0;if(c&8192&e){e=b+8|0;k[e>>2]=k[e>>2]&-17;e=b+156|0;f=k[e>>2]|0;do if(f|0){g=k[a+692>>2]|0;if(!g){ggb(f);break}else{jh[g&1023](a,f);break}}while(0);k[e>>2]=0;j[b+22>>1]=0;e=k[o>>2]|0}if(c&256&e){h=b+256|0;e=k[h>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);e=b+260|0;f=k[e>>2]|0;do if(f|0){g=k[a+692>>2]|0;if(!g){ggb(f);break}else{jh[g&1023](a,f);break}}while(0);k[h>>2]=0;k[e>>2]=0;e=b+8|0;k[e>>2]=k[e>>2]&-16385;e=k[o>>2]|0}if(c&128&e){h=b+208|0;e=k[h>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);e=b+220|0;f=k[e>>2]|0;do if(f|0){g=k[a+692>>2]|0;if(!g){ggb(f);break}else{jh[g&1023](a,f);break}}while(0);k[h>>2]=0;k[e>>2]=0;n=b+224|0;e=k[n>>2]|0;if(e|0){m=b+229|0;if(i[m>>0]|0){e=k[e>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);if((l[m>>0]|0)>1){e=a+692|0;f=1;do{g=k[(k[n>>2]|0)+(f<<2)>>2]|0;do if(g|0){h=k[e>>2]|0;if(!h){ggb(g);break}else{jh[h&1023](a,g);break}}while(0);f=f+1|0}while((f|0)<(l[m>>0]|0))}e=k[n>>2]|0}do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);k[n>>2]=0}e=b+8|0;k[e>>2]=k[e>>2]&-1025;e=k[o>>2]|0}if(c&16&e|0){h=b+116|0;e=k[h>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);e=b+120|0;f=k[e>>2]|0;do if(f|0){g=k[a+692>>2]|0;if(!g){ggb(f);break}else{jh[g&1023](a,f);break}}while(0);k[h>>2]=0;k[e>>2]=0;n=b+8|0;k[n>>2]=k[n>>2]&-4097}n=b+244|0;e=k[n>>2]|0;do if(e|0?c&32&k[o>>2]|0:0){if((d|0)!=-1){e=k[e+(d<<4)>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);e=k[(k[n>>2]|0)+(d<<4)+8>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);n=k[n>>2]|0;k[n+(d<<4)>>2]=0;k[n+(d<<4)+8>>2]=0;break}m=b+248|0;if((k[m>>2]|0)>0){e=k[e>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);e=k[(k[n>>2]|0)+8>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);if((k[m>>2]|0)>1){g=a+692|0;h=1;do{e=k[(k[n>>2]|0)+(h<<4)>>2]|0;do if(e|0){f=k[g>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);e=k[(k[n>>2]|0)+(h<<4)+8>>2]|0;do if(e|0){f=k[g>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);h=h+1|0}while((h|0)<(k[m>>2]|0))}g=a;e=k[n>>2]|0}else g=a;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](g,e);break}}while(0);k[n>>2]=0;k[m>>2]=0;n=b+8|0;k[n>>2]=k[n>>2]&-8193}while(0);n=b+236|0;e=k[n>>2]|0;do if(e|0?c&512&k[o>>2]|0:0){if((d|0)!=-1){e=k[e+(d*20|0)+8>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);k[(k[n>>2]|0)+(d*20|0)+8>>2]=0;break}m=b+240|0;if((k[m>>2]|0)>0){e=k[e+8>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);if((k[m>>2]|0)>1){e=a+692|0;f=1;do{g=k[(k[n>>2]|0)+(f*20|0)+8>>2]|0;do if(g|0){h=k[e>>2]|0;if(!h){ggb(g);break}else{jh[h&1023](a,g);break}}while(0);f=f+1|0}while((f|0)<(k[m>>2]|0))}g=a;e=k[n>>2]|0}else g=a;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](g,e);break}}while(0);k[n>>2]=0;k[m>>2]=0}while(0);e=k[o>>2]|0;if(c&8&e){e=b+204|0;f=k[e>>2]|0;do if(f|0){g=k[a+692>>2]|0;if(!g){ggb(f);break}else{jh[g&1023](a,f);break}}while(0);k[e>>2]=0;e=b+8|0;k[e>>2]=k[e>>2]&-65;e=k[o>>2]|0}if(c&4096&e){e=b+16|0;f=k[e>>2]|0;do if(f|0){g=k[a+692>>2]|0;if(!g){ggb(f);break}else{jh[g&1023](a,f);break}}while(0);k[e>>2]=0;e=b+8|0;k[e>>2]=k[e>>2]&-9;j[b+20>>1]=0;e=k[o>>2]|0}if(c&64&e){n=b+264|0;f=k[n>>2]|0;if(f){m=b+4|0;if(!(k[m>>2]|0))g=a;else{e=k[f>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);if((k[m>>2]|0)>>>0>1){e=a+692|0;f=1;do{g=k[(k[n>>2]|0)+(f<<2)>>2]|0;do if(g|0){h=k[e>>2]|0;if(!h){ggb(g);break}else{jh[h&1023](a,g);break}}while(0);f=f+1|0}while(f>>>0<(k[m>>2]|0)>>>0)}g=a;f=k[n>>2]|0}do if(f|0){e=k[a+692>>2]|0;if(!e){ggb(f);break}else{jh[e&1023](g,f);break}}while(0);k[n>>2]=0;e=k[o>>2]|0}b=b+8|0;k[b>>2]=k[b>>2]&-32769}k[o>>2]=e&~((d|0)==-1?c:c&-16929);return}function Lcb(a,b){a=a|0;b=b|0;a=a+248|0;a:do if(!(k[a>>2]|0))do switch(b|0){case -7:{k[a>>2]=411045;break a}case 1:{k[a>>2]=410915;break a}case 2:{k[a>>2]=410943;break a}case -1:{k[a>>2]=410965;break a}case -2:{k[a>>2]=410979;break a}case -3:{k[a>>2]=411002;break a}case -4:{k[a>>2]=420017;break a}case -5:{k[a>>2]=413906;break a}case -6:{k[a>>2]=411020;break a}default:{k[a>>2]=410887;break a}}while(0);while(0);return}function Mcb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0;if(!b)return;c=b+40|0;d=a+792|0;e=c+76|0;do{k[c>>2]=k[d>>2];c=c+4|0;d=d+4|0}while((c|0)<(e|0));e=j[b+114>>1]|0;c=e&65535;if(!(c&32768)){d=b+8|0;a=k[d>>2]|0;c=(c&128|0)==0?a&-2049:a|2048;c=(e&2)==0?c&-5:c|4;k[d>>2]=c;if(!(e&1)){k[d>>2]=c&-2;return}else{k[d>>2]=c|1;return}}h=b+8|0;i=k[h>>2]&-6150;k[h>>2]=i;g=b+232|0;l=k[g>>2]|0;if(l&16|0){m=b+116|0;c=k[m>>2]|0;f=(a|0)==0;do if(!(f|(c|0)==0)){d=k[a+692>>2]|0;if(!d){ggb(c);break}else{jh[d&1023](a,c);break}}while(0);d=b+120|0;e=k[d>>2]|0;do if(!(f|(e|0)==0)){c=k[a+692>>2]|0;if(!c){ggb(e);break}else{jh[c&1023](a,e);break}}while(0);k[m>>2]=0;k[d>>2]=0;k[h>>2]=i}k[g>>2]=l&-17;return}function Ncb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=k[a+24>>2]|0;d=k[b+24>>2]|0;if((e|0)<(d-c|0)|(e|0)>(d+c|0))return 0;d=k[a+28>>2]|0;e=k[b+28>>2]|0;if((d|0)<(e-c|0)|(d|0)>(e+c|0))return 0;d=k[a>>2]|0;e=k[b>>2]|0;if((d|0)<(e-c|0)|(d|0)>(e+c|0))return 0;d=k[a+4>>2]|0;e=k[b+4>>2]|0;if((d|0)<(e-c|0)|(d|0)>(e+c|0))return 0;d=k[a+8>>2]|0;e=k[b+8>>2]|0;if((d|0)<(e-c|0)|(d|0)>(e+c|0))return 0;d=k[a+12>>2]|0;e=k[b+12>>2]|0;if((d|0)<(e-c|0)|(d|0)>(e+c|0))return 0;d=k[a+16>>2]|0;e=k[b+16>>2]|0;if((d|0)<(e-c|0)|(d|0)>(e+c|0))return 0;else{d=k[a+20>>2]|0;e=k[b+20>>2]|0;return ((d|0)<(e-c|0)|(d|0)>(e+c|0))&1^1|0}return 0}function Ocb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0;g=b+74|0;d=j[g>>1]|0;e=d&65535;if(e&32768|0)return;if(c>>>0>3){Pcb(a,b,411258,c,411263);return}if(e&4){d=k[b+72>>2]|0;if((d&65535|0)==(c|0))d=d>>>16&65535;else{Pcb(a,b,411258,c,411293);return}}e=d&65535;if(e&32|0){Wcb(a,411324);return}if((e&2|0)!=0?(Ncb(156024,b+4|0,100)|0)==0:0){Zcb(a,411359,2);d=j[g>>1]|0}do if(d&1){e=k[b>>2]|0;if((e|0?(f=+O(+(+(e|0)*1.0e5/45455.0+.5)),f<=2147483647.0&f>=-2147483648.0):0)?(~~f+-95e3|0)>>>0<=1e4:0)break;Zcb(a,411111,2);d=j[g>>1]|0}while(0);j[b+72>>1]=c;d=d&65535;e=b+4|0;k[e>>2]=k[39006];k[e+4>>2]=k[39007];k[e+8>>2]=k[39008];k[e+12>>2]=k[39009];k[e+16>>2]=k[39010];k[e+20>>2]=k[39011];k[e+24>>2]=k[39012];k[e+28>>2]=k[39013];e=b+36|0;a=156056;c=e+36|0;do{k[e>>2]=k[a>>2];e=e+4|0;a=a+4|0}while((e|0)<(c|0));k[b>>2]=45455;j[g>>1]=d|231;return}function Pcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,k=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+224|0;t=v+24|0;s=v;u=(b|0)!=0;if(u){h=b+74|0;j[h>>1]=m[h>>1]|0|32768}i[t>>0]=112;i[t+1>>0]=114;i[t+2>>0]=111;i[t+3>>0]=102;i[t+4>>0]=105;i[t+5>>0]=108;i[t+6>>0]=101;i[t+7>>0]=32;i[t+8>>0]=39;i[t+9>>0]=0;if((c|0)!=0?(g=i[c>>0]|0,g<<24>>24!=0):0){h=9;while(1){c=c+1|0;b=h+1|0;i[t+h>>0]=g;g=i[c>>0]|0;if(!(b>>>0<87&g<<24>>24!=0))break;else h=b}i[t+b>>0]=0;if(b>>>0<196)if((b|0)==195){b=195;k=10}else{g=411390;h=39;k=9}}else{i[t+9>>0]=0;b=9;g=411390;h=39;k=9}if((k|0)==9)while(1){g=g+1|0;c=b+1|0;i[t+b>>0]=h;h=i[g>>0]|0;if(!(c>>>0<195&h<<24>>24!=0)){b=c;k=10;break}else{b=c;k=9}}if((k|0)==10)i[t+b>>0]=0;c=d>>>24;if(((((c&223)+-65|0)>>>0<26|((c|0)==32|(c+-48|0)>>>0<10)?(l=d>>>16,n=l&255,((l&223)+-65|0)>>>0<26|((n|0)==32|(n+-48|0)>>>0<10)):0)?(o=d>>>8,p=o&255,((o&223)+-65|0)>>>0<26|((p|0)==32|(p+-48|0)>>>0<10)):0)?(q=d&255,((d&223)+-65|0)>>>0<26|((q|0)==32|(q+-48|0)>>>0<10)):0){s=t+b|0;i[s>>0]=39;i[s+1>>0]=(c+-32|0)>>>0<95?c&255:63;i[s+2>>0]=(n+-32|0)>>>0<95?l&255:63;i[s+3>>0]=(p+-32|0)>>>0<95?o&255:63;i[s+4>>0]=(q+-32|0)>>>0<95?d&255:63;i[s+5>>0]=39;i[t+(b+6)>>0]=58;i[t+(b+7)>>0]=32;b=b+8|0}else{g=s+23|0;i[g>>0]=0;h=0;c=0;while(1){if(!((d|0)!=0|(h|0)<1))break;c=i[412648+(d&15)>>0]|0;g=g+-1|0;i[g>>0]=c;if(g>>>0>s>>>0){h=h+1|0;d=d>>>4}else break}do if(b>>>0<196){if((b|0)!=195&c<<24>>24!=0){do{g=g+1|0;s=b;b=b+1|0;i[t+s>>0]=c;c=i[g>>0]|0}while(b>>>0<195&c<<24>>24!=0);i[t+b>>0]=0;if(b>>>0>=196)break}else i[t+b>>0]=0;if((b|0)==195)b=195;else{c=411394;d=104;while(1){c=c+1|0;g=b+1|0;i[t+b>>0]=d;d=i[c>>0]|0;if(!(g>>>0<195&d<<24>>24!=0)){b=g;break}else b=g}}i[t+b>>0]=0}while(0)}if(b>>>0>=196){u=u?2:1;Zcb(a,t,u);r=v;return}if((e|0)!=0?(f=i[e>>0]|0,b>>>0<195&f<<24>>24!=0):0)while(1){e=e+1|0;c=b+1|0;i[t+b>>0]=f;f=i[e>>0]|0;if(!(c>>>0<195&f<<24>>24!=0)){b=c;break}else b=c}i[t+b>>0]=0;u=u?2:1;Zcb(a,t,u);r=v;return}function Qcb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,l=0;if(b){if((b|0)<0){Vcb(a,412135);j=1}else j=0;if((b+7&-8)>>>0>536870904){Vcb(a,412163);j=1}}else{Vcb(a,412107);j=1}if((k[a+716>>2]|0)>>>0<b>>>0){Vcb(a,412210);j=1}if(c){if((c|0)<0){Vcb(a,412278);j=1}}else{Vcb(a,412249);j=1}if((k[a+720>>2]|0)>>>0<c>>>0){Vcb(a,412307);j=1}switch(d|0){case 1:case 2:case 4:case 8:case 16:break;default:{Vcb(a,412347);j=1}}c=e|4;if(e>>>0>6|(c|0)==5){Vcb(a,412373);j=1}if(!(!((d|0)>8&(e|0)==3)?!((d|0)<8&((e|0)==4|(c|0)==6)):0)){Vcb(a,412400);j=1}if((f|0)>1){Vcb(a,412449);j=1}if(g){Vcb(a,412482);j=1}b=a+208|0;if(k[b>>2]&4096|0?k[a+676>>2]|0:0)Vcb(a,416543);if(h){if(!(((h|0)==64?(k[a+676>>2]&4|0)!=0:0)?(i=k[b>>2]|0,(c|0)==6&(i&4096|0)==0):0)){Vcb(a,412517);j=1;i=k[b>>2]|0}if(!(i&4096))l=j;else{Vcb(a,412547);Ucb(a,412577)}}else l=j;if((l|0)==1)Ucb(a,412577);else return}function Rcb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=k[c>>2]|0;f=k[d>>2]|0;a:do if(f>>>0<b>>>0)while(1){switch(i[a+f>>0]|0){case 43:{g=4;break}case 45:{g=132;break}case 46:{g=16;break}case 48:{g=8;break}case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:{g=264;break}case 101:case 69:{g=32;break}default:break a}b:do switch((g|e&3)&63){case 4:{if(e&60|0)break a;e=g|e;break}case 16:{if(e&16|0)break a;if(!(e&8)){e=e&448|g|1;break b}else{e=g|e;break b}}case 8:{e=((e&16|0)==0?e:e&384|17)|g|64;break}case 32:{if(!(e&8))break a;e=e&448|2;break}case 9:{e=e|g|64;break}case 33:{if(!(e&8))break a;e=e&448|2;break}case 6:{if(e&60|0)break a;e=e|4;break}case 10:{e=e|72;break}default:break a}while(0);f=f+1|0;if(f>>>0>=b>>>0)break a}while(0);k[c>>2]=e;k[d>>2]=f;return e>>>3&1|0}function Scb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;b=a+484|0;c=k[b>>2]|0;h=(a|0)==0;do if(!(h|(c|0)==0)){d=k[a+692>>2]|0;if(!d){ggb(c);break}else{jh[d&1023](a,c);break}}while(0);k[b>>2]=0;g=a+488|0;b=k[g>>2]|0;if(b|0){e=8-(k[a+476>>2]|0)|0;f=1<<e;if((e|0)!=31){b=k[b>>2]|0;do if(!(h|(b|0)==0)){c=k[a+692>>2]|0;if(!c){ggb(b);break}else{jh[c&1023](a,b);break}}while(0);if((f|0)>1){b=a+692|0;c=1;do{d=k[(k[g>>2]|0)+(c<<2)>>2]|0;do if(!(h|(d|0)==0)){e=k[b>>2]|0;if(!e){ggb(d);break}else{jh[e&1023](a,d);break}}while(0);c=c+1|0}while((c|0)!=(f|0))}b=k[g>>2]|0}do if(!(h|(b|0)==0)){c=k[a+692>>2]|0;if(!c){ggb(b);break}else{jh[c&1023](a,b);break}}while(0);k[g>>2]=0}b=a+492|0;c=k[b>>2]|0;do if(!(h|(c|0)==0)){d=k[a+692>>2]|0;if(!d){ggb(c);break}else{jh[d&1023](a,c);break}}while(0);k[b>>2]=0;b=a+496|0;c=k[b>>2]|0;do if(!(h|(c|0)==0)){d=k[a+692>>2]|0;if(!d){ggb(c);break}else{jh[d&1023](a,c);break}}while(0);k[b>>2]=0;g=a+500|0;b=k[g>>2]|0;if(b|0){e=8-(k[a+476>>2]|0)|0;f=1<<e;if((e|0)!=31){b=k[b>>2]|0;do if(!(h|(b|0)==0)){c=k[a+692>>2]|0;if(!c){ggb(b);break}else{jh[c&1023](a,b);break}}while(0);if((f|0)>1){b=a+692|0;c=1;do{d=k[(k[g>>2]|0)+(c<<2)>>2]|0;do if(!(h|(d|0)==0)){e=k[b>>2]|0;if(!e){ggb(d);break}else{jh[e&1023](a,d);break}}while(0);c=c+1|0}while((c|0)!=(f|0))}b=k[g>>2]|0}do if(!(h|(b|0)==0)){c=k[a+692>>2]|0;if(!c){ggb(b);break}else{jh[c&1023](a,b);break}}while(0);k[g>>2]=0}g=a+504|0;b=k[g>>2]|0;if(!b)return;e=8-(k[a+476>>2]|0)|0;f=1<<e;if((e|0)==31)c=b;else{b=k[b>>2]|0;do if(!(h|(b|0)==0)){c=k[a+692>>2]|0;if(!c){ggb(b);break}else{jh[c&1023](a,b);break}}while(0);if((f|0)>1){b=a+692|0;c=1;do{d=k[(k[g>>2]|0)+(c<<2)>>2]|0;do if(!(h|(d|0)==0)){e=k[b>>2]|0;if(!e){ggb(d);break}else{jh[e&1023](a,d);break}}while(0);c=c+1|0}while((c|0)!=(f|0))}c=k[g>>2]|0}do if(!(h|(c|0)==0)){b=k[a+692>>2]|0;if(!b){ggb(c);break}else{jh[b&1023](a,c);break}}while(0);k[g>>2]=0;return}function Tcb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;p=8-c|0;q=1<<p;r=(1<<16-c)+-1|0;h=1.0/+(r|0);n=1<<15-c;f=q<<2;o=(a|0)==0;do if(!o){if(!f)Ucb(a,412758);e=k[a+688>>2]|0;if(!e)e=fgb(f)|0;else e=Hh[e&511](a,f)|0;if(!e)Ucb(a,412758);else{zpb(e|0,0,f|0)|0;l=e;break}}else l=0;while(0);k[b>>2]=l;g=+(d|0)*1.0e-05;c=(c|0)==0;i=a+688|0;if((d+-95e3|0)>>>0>1e4){f=0;while(1){if(!o){e=k[i>>2]|0;if(!e)e=fgb(512)|0;else e=Hh[e&511](a,512)|0;if(!e){e=15;break}}else e=0;k[l+(f<<2)>>2]=e;b=0;do{d=~~+O(+(+R(+(h*+(((b<<p)+f|0)>>>0)),+g)*65535.0+.5))&65535;j[e+(b<<1)>>1]=d;b=b+1|0}while((b|0)!=256);f=f+1|0;if(f>>>0>=q>>>0){e=29;break}}if((e|0)==15)Ucb(a,412758);else if((e|0)==29)return}else m=0;while(1){if(!o){e=k[i>>2]|0;if(!e)e=fgb(512)|0;else e=Hh[e&511](a,512)|0;if(!e){e=24;break}}else e=0;k[l+(m<<2)>>2]=e;if(c){b=0;do{j[e+(b<<1)>>1]=(b<<p)+m;b=b+1|0}while((b|0)!=256)}else{b=0;do{j[e+(b<<1)>>1]=(((((b<<p)+m|0)*65535|0)+n|0)>>>0)/(r>>>0)|0;b=b+1|0}while((b|0)!=256)}m=m+1|0;if(m>>>0>=q>>>0){e=29;break}}if((e|0)==24)Ucb(a,412758);else if((e|0)==29)return}function Ucb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=(a|0)==0;if(!f?(c=k[a+168>>2]|0,c|0):0)jh[c&1023](a,b);k[g>>2]=b|0?b:412621;Zfb(165912,412631,g)|0;d=i[165987]|0;b=d<<24>>24==10;do if((k[41497]|0)<0){if(!b){b=k[41483]|0;c=k[41482]|0;if(b>>>0<c>>>0){k[41483]=b+1;i[b>>0]=10;break}}else c=k[41482]|0;i[g>>0]=10;do if(!c){d=j[82993]|0;b=(d&65535)<<24>>24;i[165986]=b+255|b;b=k[41478]|0;if(!(b&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;c=e+(k[41490]|0)|0;k[41482]=c;b=(d&65535)>>>8&255;h=14;break}else{k[41478]=b|32;break}}else{e=k[41483]|0;b=d;h=14}while(0);do if((h|0)==14)if(e>>>0>=c>>>0|b<<24>>24==10){ci[k[165948>>2]&255](165912,g,1)|0;break}else{k[41483]=e+1;i[e>>0]=10;break}while(0)}else{if(!b){b=k[41483]|0;c=k[41482]|0;if(b>>>0<c>>>0){k[41483]=b+1;i[b>>0]=10;break}}else c=k[41482]|0;i[g>>0]=10;do if(!c){d=j[82993]|0;b=(d&65535)<<24>>24;i[165986]=b+255|b;b=k[41478]|0;if(!(b&8)){k[41480]=0;k[41479]=0;e=k[41489]|0;k[41485]=e;k[41483]=e;c=e+(k[41490]|0)|0;k[41482]=c;b=(d&65535)>>>8&255;h=27;break}else{k[41478]=b|32;break}}else{e=k[41483]|0;b=d;h=27}while(0);do if((h|0)==27)if(e>>>0>=c>>>0|b<<24>>24==10){ci[k[165948>>2]&255](165912,g,1)|0;break}else{k[41483]=e+1;i[e>>0]=10;break}while(0)}while(0);if(f)Ne();c=k[a+156>>2]|0;if(!c)Ne();b=k[a+160>>2]|0;if(!b)Ne();jh[c&1023](b,1);Ne()}function Vcb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;g=r;r=r+16|0;e=g;if(a){if((i[b>>0]|0)==35)if((i[b+1>>0]|0)!=32)if((i[b+2>>0]|0)!=32)if((i[b+3>>0]|0)!=32)if((i[b+4>>0]|0)!=32)if((i[b+5>>0]|0)!=32)if((i[b+6>>0]|0)!=32)if((i[b+7>>0]|0)!=32)if((i[b+8>>0]|0)!=32)if((i[b+9>>0]|0)!=32)if((i[b+10>>0]|0)!=32)if((i[b+11>>0]|0)!=32)if((i[b+12>>0]|0)!=32)if((i[b+13>>0]|0)==32)c=13;else c=(i[b+14>>0]|0)==32?14:15;else c=12;else c=11;else c=10;else c=9;else c=8;else c=7;else c=6;else c=5;else c=4;else c=3;else c=2;else c=1;else c=0;d=k[a+172>>2]|0;if(d){jh[d&1023](a,b+c|0);r=g;return}}else c=0;k[e>>2]=b+c;Zfb(165912,412665,e)|0;d=i[165987]|0;c=d<<24>>24==10;if((k[41497]|0)<0){if(!c){c=k[41483]|0;a=k[41482]|0;if(c>>>0<a>>>0){k[41483]=c+1;i[c>>0]=10;r=g;return}}else a=k[41482]|0;i[e>>0]=10;do if(!a){d=j[82993]|0;c=(d&65535)<<24>>24;i[165986]=c+255|c;c=k[41478]|0;if(!(c&8)){k[41480]=0;k[41479]=0;b=k[41489]|0;k[41485]=b;k[41483]=b;a=b+(k[41490]|0)|0;k[41482]=a;c=(d&65535)>>>8&255;f=17;break}else{k[41478]=c|32;break}}else{b=k[41483]|0;c=d;f=17}while(0);do if((f|0)==17)if(b>>>0>=a>>>0|c<<24>>24==10){ci[k[165948>>2]&255](165912,e,1)|0;break}else{k[41483]=b+1;i[b>>0]=10;break}while(0);r=g;return}else{if(!c){c=k[41483]|0;a=k[41482]|0;if(c>>>0<a>>>0){k[41483]=c+1;i[c>>0]=10;r=g;return}}else a=k[41482]|0;i[e>>0]=10;do if(!a){d=j[82993]|0;c=(d&65535)<<24>>24;i[165986]=c+255|c;c=k[41478]|0;if(!(c&8)){k[41480]=0;k[41479]=0;b=k[41489]|0;k[41485]=b;k[41483]=b;a=b+(k[41490]|0)|0;k[41482]=a;c=(d&65535)>>>8&255;f=30;break}else{k[41478]=c|32;break}}else{b=k[41483]|0;c=d;f=30}while(0);do if((f|0)==30)if(b>>>0>=a>>>0|c<<24>>24==10){ci[k[165948>>2]&255](165912,e,1)|0;break}else{k[41483]=b+1;i[b>>0]=10;break}while(0);r=g;return}}function Wcb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=r;r=r+224|0;e=f;c=(k[a+208>>2]&32768|0)!=0;if(!(k[a+212>>2]&1048576)){if(!c)Ucb(a,b);if(!(k[a+376>>2]|0))Ucb(a,b);else Ycb(a,b)}if(c?(d=k[a+376>>2]|0,d|0):0){Xcb(d,e,b);Vcb(a,e);r=f;return}Vcb(a,b);r=f;return}function Xcb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=a>>>24;if((d+-65|0)>>>0>57|(d+-91|0)>>>0<6){i[b>>0]=91;i[b+1>>0]=i[421592+(a>>>28)>>0]|0;i[b+2>>0]=i[421592+(d&15)>>0]|0;i[b+3>>0]=93;e=4}else{i[b>>0]=d;e=1}d=a>>>16;f=d&255;if((f+-65|0)>>>0>57|(f+-91|0)>>>0<6){i[b+(e+1)>>0]=i[421592+(a>>>20&15)>>0]|0;f=e+3|0;i[b+(e|2)>>0]=i[421592+(d&15)>>0]|0;i[b+f>>0]=93;d=91}else{f=e;d=d&255}i[b+e>>0]=d;e=f+1|0;d=a>>>8;g=d&255;if((g+-65|0)>>>0>57|(g+-91|0)>>>0<6){i[b+(f+2)>>0]=i[421592+(a>>>12&15)>>0]|0;g=f+4|0;i[b+(f+3)>>0]=i[421592+(d&15)>>0]|0;i[b+g>>0]=93;f=g;d=91}else{f=e;d=d&255}i[b+e>>0]=d;e=f+1|0;g=a&255;if((g+-65|0)>>>0>57|(g+-91|0)>>>0<6){i[b+(f+2)>>0]=i[421592+(a>>>4&15)>>0]|0;d=f+4|0;i[b+(f+3)>>0]=i[421592+(a&15)>>0]|0;i[b+d>>0]=93;f=d;d=91}else{f=e;d=a&255}i[b+e>>0]=d;d=f+1|0;if(!c){i[b+d>>0]=0;return}i[b+d>>0]=58;i[b+(f+2)>>0]=32;a=0;d=f+3|0;while(1){e=i[c+a>>0]|0;if(!(e<<24>>24))break;a=a+1|0;f=d+1|0;i[b+d>>0]=e;if((a|0)>=195){d=f;break}else d=f}i[b+d>>0]=0;return}function Ycb(a,b){a=a|0;b=b|0;var c=0;c=r;r=r+224|0;if(!a)Ucb(0,b);else{Xcb(k[a+376>>2]|0,c,b);Ucb(a,c)}}function Zcb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=r;r=r+224|0;d=e;if(k[a+208>>2]&32768|0){if((c|0)<2){Xcb(k[a+376>>2]|0,d,b);Vcb(a,d);r=e;return}if(!(k[a+212>>2]&1048576))Ycb(a,b);Xcb(k[a+376>>2]|0,d,b);Vcb(a,d);r=e;return}d=k[a+212>>2]|0;if((c|0)<1){if(!(d&2097152))Ucb(a,b);Vcb(a,b);r=e;return}else{if(!(d&4194304))Ucb(a,b);Vcb(a,b);r=e;return}}function _cb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+160|0;i=4;h=fgb(40)|0;k[h>>2]=0;e=l;if(!a){ggb(h|0);r=l;return}f=a+160|0;g=k[f>>2]|0;d=a+164|0;if(g|0?!((g|0)==(a|0)|(k[d>>2]|0)==0):0){h=npb(e,1,h|0,i|0)|0;i=N;y=0;c=y;y=0;if((c|0)!=0&(z|0)!=0){b=Cpb(k[c>>2]|0,h|0,i|0)|0;if(!b)dd(c|0,z|0);N=z}else b=-1;if((b|0)==1)b=N;else b=0;while(1){if(b|0)break;k[f>>2]=e;k[d>>2]=0;k[a+156>>2]=826;b=k[a+692>>2]|0;if(!b){y=0;rc(1459,g|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,h|0,i|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){b=N;continue}else{j=11;break}}else{y=0;Ib(b|0,a|0,g|0);b=y;y=0;if((b|0)!=0&(z|0)!=0){c=Cpb(k[b>>2]|0,h|0,i|0)|0;if(!c)dd(b|0,z|0);N=z}else c=-1;if((c|0)==1){b=N;continue}else{j=9;break}}}}k[d>>2]=0;k[f>>2]=0;k[a+156>>2]=0;ggb(h|0);r=l;return}function $cb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=r;r=r+880|0;h=j;if(!a){r=j;return}i=k[a>>2]|0;if(!i){r=j;return}do if(c|0?(d=k[c>>2]|0,d|0):0){k[c>>2]=0;Kcb(i,d,32767,-1);zpb(d|0,0,268)|0;c=k[i+692>>2]|0;if(!c){ggb(d);break}else{jh[c&1023](i,d);break}}while(0);do if(b|0?(e=k[b>>2]|0,e|0):0){k[b>>2]=0;Kcb(i,e,32767,-1);zpb(e|0,0,268)|0;c=k[i+692>>2]|0;if(!c){ggb(e);break}else{jh[c&1023](i,e);break}}while(0);k[a>>2]=0;Scb(i);c=i+696|0;b=k[c>>2]|0;do if(b|0){d=k[i+692>>2]|0;if(!d){ggb(b);break}else{jh[d&1023](i,b);break}}while(0);k[c>>2]=0;c=i+772|0;b=k[c>>2]|0;do if(b|0){d=k[i+692>>2]|0;if(!d){ggb(b);break}else{jh[d&1023](i,b);break}}while(0);k[c>>2]=0;c=i+756|0;b=k[c>>2]|0;do if(b|0){d=k[i+692>>2]|0;if(!d){ggb(b);break}else{jh[d&1023](i,b);break}}while(0);k[c>>2]=0;c=i+604|0;b=k[c>>2]|0;do if(b|0){d=k[i+692>>2]|0;if(!d){ggb(b);break}else{jh[d&1023](i,b);break}}while(0);k[c>>2]=0;c=i+608|0;b=k[c>>2]|0;do if(b|0){d=k[i+692>>2]|0;if(!d){ggb(b);break}else{jh[d&1023](i,b);break}}while(0);k[c>>2]=0;a=i+644|0;c=k[a>>2]|0;if(c&4096){c=i+408|0;b=k[c>>2]|0;do if(b|0){d=k[i+692>>2]|0;if(!d){ggb(b);break}else{jh[d&1023](i,b);break}}while(0);k[c>>2]=0;c=k[a>>2]|0}b=c&-4097;k[a>>2]=b;if(!(c&8192))c=b;else{c=i+520|0;b=k[c>>2]|0;do if(b|0){d=k[i+692>>2]|0;if(!d){ggb(b);break}else{jh[d&1023](i,b);break}}while(0);k[c>>2]=0;c=k[a>>2]|0}k[a>>2]=c&-8193;a=i+252|0;c=k[a>>2]|0;if(c|0?(f=i+260|0,g=k[f>>2]|0,g|0):0){b=k[c+52>>2]|0;d=i+264|0;if(!b)b=g;else{jh[g&1023](k[d>>2]|0,b);b=k[f>>2]|0;c=k[a>>2]|0}jh[b&1023](k[d>>2]|0,c);k[a>>2]=0}c=i+560|0;b=k[c>>2]|0;do if(b|0){d=k[i+692>>2]|0;if(!d){ggb(b);break}else{jh[d&1023](i,b);break}}while(0);k[c>>2]=0;c=i+740|0;b=k[c>>2]|0;do if(b|0){d=k[i+692>>2]|0;if(!d){ggb(b);break}else{jh[d&1023](i,b);break}}while(0);k[c>>2]=0;b=i+664|0;d=k[b>>2]|0;do if(d|0){c=k[i+692>>2]|0;if(!c){ggb(d);break}else{jh[c&1023](i,d);break}}while(0);k[b>>2]=0;upb(h|0,i|0,868)|0;zpb(i|0,0,868)|0;c=k[h+692>>2]|0;if(!c)ggb(i);else jh[c&1023](h,i);_cb(h);r=j;return}function adb(a,b,c){a=a|0;b=b|0;c=c|0;if(!a)return;if((_fb(b,1,c,k[a+188>>2]|0)|0)==(c|0))return;else Ucb(a,413222)}function bdb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0;ca=r;r=r+16|0;Z=ca;ba=a+384|0;e=k[ba>>2]|0;if(!e)Ucb(a,413452);_=a+212|0;if((k[_>>2]&16448|0)==16384)Ucb(a,413468);$=a+216|0;f=k[$>>2]|0;do if(f&4096|0){w=b+8|0;if((i[w>>0]|0)!=3){e=e+1|0;if((f&33554432|0)==0|(j[a+420>>1]|0)==0){cdb(b,e,0);break}else{cdb(b,e,a+524|0);break}}p=e+1|0;t=k[a+408>>2]|0;q=k[a+520>>2]|0;o=j[a+420>>1]|0;s=o&65535;u=k[b>>2]|0;F=j[w>>1]|0;e=(F&65535)>>>8&255;if((F&255)<<24>>24==3){v=b+9|0;if((e&255)>=8){if(e<<24>>24!=8)break}else{switch(e<<24>>24){case 1:{if(u|0){e=0;f=p+u|0;g=p+((u+-1|0)>>>3)|0;h=u+7&7^7;while(1){f=f+-1|0;i[f>>0]=(l[g>>0]&1<<h|0)!=0&1;n=(h|0)==7;e=e+1|0;if((e|0)==(u|0))break;else{g=n?g+-1|0:g;h=n?0:h+1|0}}}break}case 2:{if(u|0){e=0;f=p+u|0;g=p+((u+-1|0)>>>2)|0;h=(u<<1)+6&6^6;while(1){f=f+-1|0;i[f>>0]=(l[g>>0]|0)>>>h&3;n=(h|0)==6;e=e+1|0;if((e|0)==(u|0))break;else{g=n?g+-1|0:g;h=n?0:h+2|0}}}break}case 4:{if(u|0){e=0;f=p+u|0;g=p+((u+-1|0)>>>1)|0;h=u<<2&4;while(1){f=f+-1|0;i[f>>0]=(l[g>>0]|0)>>>h&15;n=(h|0)==4;e=e+1|0;if((e|0)==(u|0))break;else{g=n?g+-1|0:g;h=n?0:h+4|0}}}break}default:{}}i[v>>0]=8;i[b+11>>0]=8;k[b+4>>2]=u}f=p+u+-1|0;if(!(o<<16>>16)){h=u*3|0;if(u|0){g=0;e=p+h|0;while(1){i[e+-1>>0]=i[t+((l[f>>0]|0)*3|0)+2>>0]|0;i[e+-2>>0]=i[t+((l[f>>0]|0)*3|0)+1>>0]|0;e=e+-3|0;i[e>>0]=i[t+((l[f>>0]|0)*3|0)>>0]|0;g=g+1|0;if((g|0)==(u|0))break;else f=f+-1|0}}i[v>>0]=8;i[b+11>>0]=24;k[b+4>>2]=h;i[w>>0]=2;i[b+10>>0]=3;break}n=u<<2;if(u|0){h=0;g=p+n|0;while(1){e=l[f>>0]|0;if(e>>>0<s>>>0)e=i[q+e>>0]|0;else e=-1;i[g+-1>>0]=e;i[g+-2>>0]=i[t+((l[f>>0]|0)*3|0)+2>>0]|0;i[g+-3>>0]=i[t+((l[f>>0]|0)*3|0)+1>>0]|0;g=g+-4|0;i[g>>0]=i[t+((l[f>>0]|0)*3|0)>>0]|0;h=h+1|0;if((h|0)==(u|0))break;else f=f+-1|0}}i[v>>0]=8;i[b+11>>0]=32;k[b+4>>2]=n;i[w>>0]=6;i[b+10>>0]=4}}while(0);e=k[$>>2]|0;a:do if((e&262272|0)==262144){switch(i[b+8>>0]|0){case 4:case 6:break;default:break a}Qdb(b,(k[ba>>2]|0)+1|0,0);e=k[$>>2]|0}while(0);do if((e&6291456|0)!=0?(A=(k[ba>>2]|0)+1|0,G=b+8|0,y=j[G>>1]|0,x=y&65535,(x&3|0)==2):0){C=m[a+670>>1]|0;D=m[a+672>>1]|0;E=32768-C-D|0;F=k[b>>2]|0;e=(x&4|0)!=0;b:do if((y&-256)<<16>>16==2048){t=k[a+492>>2]|0;if(t|0?(z=k[a+496>>2]|0,z|0):0){if(!F){f=0;break}u=a+484|0;if(e){s=A;o=A;p=0;f=0;while(1){e=i[s>>0]|0;g=i[s+1>>0]|0;q=s+3|0;h=i[s+2>>0]|0;n=e&255;if(e<<24>>24==g<<24>>24?e<<24>>24==h<<24>>24:0){g=k[u>>2]|0;if(g)e=i[g+n>>0]|0}else{e=t+(((aa(l[z+n>>0]|0,C)|0)+16384+(aa(l[z+(g&255)>>0]|0,D)|0)+(aa(l[z+(h&255)>>0]|0,E)|0)|0)>>>15)|0;f=f|1;e=i[e>>0]|0}i[o>>0]=e;i[o+1>>0]=i[q>>0]|0;p=p+1|0;if((p|0)==(F|0))break b;else{s=s+4|0;o=o+2|0}}}else{q=A;o=A;p=0;f=0;while(1){e=i[q>>0]|0;g=i[q+1>>0]|0;h=i[q+2>>0]|0;q=q+3|0;n=e&255;if(e<<24>>24==g<<24>>24?e<<24>>24==h<<24>>24:0){g=k[u>>2]|0;if(g)e=i[g+n>>0]|0}else{e=t+(((aa(l[z+n>>0]|0,C)|0)+16384+(aa(l[z+(g&255)>>0]|0,D)|0)+(aa(l[z+(h&255)>>0]|0,E)|0)|0)>>>15)|0;f=f|1;e=i[e>>0]|0}i[o>>0]=e;p=p+1|0;if((p|0)==(F|0))break b;else o=o+1|0}}}if(F)if(e){p=A;n=A;o=0;f=0;while(1){e=i[p>>0]|0;g=i[p+1>>0]|0;h=i[p+2>>0]|0;if(!(e<<24>>24==g<<24>>24?e<<24>>24==h<<24>>24:0)){f=f|1;e=((aa(g&255,D)|0)+(aa(e&255,C)|0)+(aa(h&255,E)|0)|0)>>>15&255}i[n>>0]=e;i[n+1>>0]=i[p+3>>0]|0;o=o+1|0;if((o|0)==(F|0))break;else{p=p+4|0;n=n+2|0}}}else{p=A;n=A;o=0;f=0;while(1){e=i[p>>0]|0;g=i[p+1>>0]|0;h=i[p+2>>0]|0;if(!(e<<24>>24==g<<24>>24?e<<24>>24==h<<24>>24:0)){f=f|1;e=((aa(g&255,D)|0)+(aa(e&255,C)|0)+(aa(h&255,E)|0)|0)>>>15&255}i[n>>0]=e;o=o+1|0;if((o|0)==(F|0))break;else{p=p+3|0;n=n+1|0}}}else f=0}else{x=k[a+504>>2]|0;if(x|0?(B=k[a+500>>2]|0,B|0):0){if(!F){f=0;break}y=a+488|0;z=a+476|0;if(e){w=A;t=A;u=0;f=0;while(1){e=i[w>>0]|0;g=i[w+1>>0]|0;q=e&255;s=g&255;A=q<<8|s;h=l[w+2>>0]|0;n=l[w+3>>0]|0;v=w+6|0;o=l[w+4>>0]|0;p=l[w+5>>0]|0;if((A|0)==(h<<8|n|0)?(A|0)==(o<<8|p|0):0){h=k[y>>2]|0;if(h){e=j[(k[h+(s>>>(k[z>>2]|0)<<2)>>2]|0)+(q<<1)>>1]|0;g=e&255;e=(e&65535)>>>8&255}}else{g=k[z>>2]|0;e=(aa(m[(k[x+(s>>>g<<2)>>2]|0)+(q<<1)>>1]|0,C)|0)+16384+(aa(m[(k[x+(n>>>g<<2)>>2]|0)+(h<<1)>>1]|0,D)|0)+(aa(m[(k[x+(p>>>g<<2)>>2]|0)+(o<<1)>>1]|0,E)|0)|0;e=j[(k[B+((e>>>15&255)>>>g<<2)>>2]|0)+((e>>>23&255)<<1)>>1]|0;g=e&255;e=(e&65535)>>>8&255;f=f|1}i[t>>0]=e;i[t+1>>0]=g;i[t+2>>0]=i[v>>0]|0;i[t+3>>0]=i[w+7>>0]|0;u=u+1|0;if((u|0)==(F|0))break b;else{w=w+8|0;t=t+4|0}}}else{v=A;t=A;u=0;f=0;while(1){e=i[v>>0]|0;g=i[v+1>>0]|0;q=e&255;s=g&255;A=q<<8|s;h=l[v+2>>0]|0;n=l[v+3>>0]|0;o=l[v+4>>0]|0;p=l[v+5>>0]|0;v=v+6|0;if((A|0)==(h<<8|n|0)?(A|0)==(o<<8|p|0):0){h=k[y>>2]|0;if(h){e=j[(k[h+(s>>>(k[z>>2]|0)<<2)>>2]|0)+(q<<1)>>1]|0;g=e&255;e=(e&65535)>>>8&255}}else{g=k[z>>2]|0;e=(aa(m[(k[x+(s>>>g<<2)>>2]|0)+(q<<1)>>1]|0,C)|0)+16384+(aa(m[(k[x+(n>>>g<<2)>>2]|0)+(h<<1)>>1]|0,D)|0)+(aa(m[(k[x+(p>>>g<<2)>>2]|0)+(o<<1)>>1]|0,E)|0)|0;e=j[(k[B+((e>>>15&255)>>>g<<2)>>2]|0)+((e>>>23&255)<<1)>>1]|0;g=e&255;e=(e&65535)>>>8&255;f=f|1}i[t>>0]=e;i[t+1>>0]=g;u=u+1|0;if((u|0)==(F|0))break b;else t=t+2|0}}}if(F)if(e){g=0;h=A;e=A;f=0;while(1){z=l[e>>0]<<8|l[e+1>>0];A=l[e+2>>0]<<8|l[e+3>>0];B=l[e+4>>0]<<8|l[e+5>>0];f=(z|0)==(A|0)&(z|0)==(B|0)&1^1|f;B=(aa(z,C)|0)+16384+(aa(A,D)|0)+(aa(B,E)|0)|0;i[h>>0]=B>>>23;i[h+1>>0]=B>>>15;i[h+2>>0]=i[e+6>>0]|0;i[h+3>>0]=i[e+7>>0]|0;g=g+1|0;if((g|0)==(F|0))break;else{h=h+4|0;e=e+8|0}}}else{g=0;h=A;e=A;f=0;while(1){z=l[e>>0]<<8|l[e+1>>0];A=l[e+2>>0]<<8|l[e+3>>0];B=l[e+4>>0]<<8|l[e+5>>0];f=(z|0)==(A|0)&(z|0)==(B|0)&1^1|f;B=(aa(z,C)|0)+16384+(aa(A,D)|0)+(aa(B,E)|0)|0;i[h>>0]=B>>>23;i[h+1>>0]=B>>>15;g=g+1|0;if((g|0)==(F|0))break;else{h=h+2|0;e=e+6|0}}}else f=0}while(0);E=b+10|0;e=(l[E>>0]|0)+254|0;i[E>>0]=e;E=j[G>>1]|0;i[G>>0]=E&253;e=aa((E&65535)>>>8&65535,e&255)|0;i[b+11>>0]=e;e=e&255;if(e>>>0>7)e=aa(e>>>3,F)|0;else e=((aa(e,F)|0)+7|0)>>>3;k[b+4>>2]=e;if(!f){d=k[$>>2]|0;break}i[a+668>>0]=1;e=k[$>>2]|0;if((e&6291456|0)==4194304){Vcb(a,413486);e=k[$>>2]|0}if((e&6291456|0)==2097152)Ucb(a,413486);else d=e}else d=e;while(0);if((d&16384|0)!=0?(k[a+208>>2]&2048|0)==0:0){ddb(b,(k[ba>>2]|0)+1|0);d=k[$>>2]|0}c:do if(d&128|0){e=(k[ba>>2]|0)+1|0;u=k[a+484>>2]|0;s=k[a+492>>2]|0;t=k[a+496>>2]|0;A=k[a+488>>2]|0;y=k[a+500>>2]|0;z=k[a+504>>2]|0;B=k[a+476>>2]|0;q=k[_>>2]&8192;f=(q|0)==0;q=q>>>13;C=k[b>>2]|0;G=j[b+8>>1]|0;d=(G&65535)>>>8&255;switch((G&255)<<24>>24){case 0:{switch(d<<24>>24){case 1:{if(!C)break c;h=a+452|0;n=m[a+532>>1]|0;f=0;g=7;while(1){d=l[e>>0]|0;if((d>>>g&1|0)==(n|0))i[e>>0]=m[h>>1]<<g|d&32639>>>(7-g|0);d=(g|0)==0;f=f+1|0;if((f|0)==(C|0))break;else{g=d?7:g+-1|0;e=d?e+1|0:e}}break}case 2:{d=(C|0)!=0;if(!u){if(!d)break c;h=a+452|0;n=m[a+532>>1]|0;f=0;g=6;while(1){d=l[e>>0]|0;if((d>>>g&3|0)==(n|0))i[e>>0]=m[h>>1]<<g|d&16191>>>(6-g|0);d=(g|0)==0;f=f+1|0;if((f|0)==(C|0))break c;else{g=d?6:g+-2|0;e=d?e+1|0:e}}}if(!d)break c;n=a+452|0;o=m[a+532>>1]|0;g=0;h=6;while(1){d=l[e>>0]|0;f=d>>>h&3;if((f|0)==(o|0))d=m[n>>1]<<h&255|d&16191>>>(6-h|0);else d=(l[u+(f<<2|f|f<<4|f<<6)>>0]|0)>>>6<<h|d&16191>>>(6-h|0);i[e>>0]=d;d=(h|0)==0;g=g+1|0;if((g|0)==(C|0))break;else{h=d?6:h+-2|0;e=d?e+1|0:e}}break}case 4:{d=(C|0)!=0;if(!u){if(!d)break c;h=a+452|0;n=m[a+532>>1]|0;f=0;g=4;while(1){d=l[e>>0]|0;if((d>>>g&15|0)==(n|0))i[e>>0]=m[h>>1]<<g|d&3855>>>(4-g|0);d=(g|0)==0;f=f+1|0;if((f|0)==(C|0))break c;else{g=d?4:g+-4|0;e=d?e+1|0:e}}}if(!d)break c;n=a+452|0;o=m[a+532>>1]|0;g=0;h=4;while(1){d=l[e>>0]|0;f=d>>>h&15;if((f|0)==(o|0))d=m[n>>1]<<h&255|d&3855>>>(4-h|0);else d=(l[u+(f<<4|f)>>0]|0)>>>4<<h|d&3855>>>(4-h|0);i[e>>0]=d;d=(h|0)==0;g=g+1|0;if((g|0)==(C|0))break;else{h=d?4:h+-4|0;e=d?e+1|0:e}}break}case 8:{d=(C|0)!=0;if(!u){if(!d)break c;f=a+452|0;g=m[a+532>>1]|0;d=e;e=0;while(1){if((l[d>>0]|0)==(g|0))i[d>>0]=j[f>>1];e=e+1|0;if((e|0)==(C|0))break c;else d=d+1|0}}if(!d)break c;g=a+452|0;h=m[a+532>>1]|0;f=0;while(1){d=l[e>>0]|0;if((d|0)==(h|0))d=j[g>>1]&255;else d=i[u+d>>0]|0;i[e>>0]=d;f=f+1|0;if((f|0)==(C|0))break;else e=e+1|0}break}case 16:{d=(C|0)!=0;if(!A){if(!d)break c;g=a+452|0;h=m[a+532>>1]|0;d=e;e=0;while(1){f=d+1|0;if((l[d>>0]<<8|l[f>>0]|0)==(h|0)){M=j[g>>1]|0;i[d>>0]=(M&65535)>>>8;i[f>>0]=M}e=e+1|0;if((e|0)==(C|0))break;else d=d+2|0}}else{if(!d)break c;n=a+452|0;o=m[a+532>>1]|0;g=0;while(1){d=l[e>>0]|0;h=e+1|0;f=l[h>>0]|0;if((d<<8|f|0)==(o|0))d=n;else d=(k[A+(f>>>B<<2)>>2]|0)+(d<<1)|0;M=j[d>>1]|0;i[e>>0]=(M&65535)>>>8;i[h>>0]=M;g=g+1|0;if((g|0)==(C|0))break;else e=e+2|0}}break}default:break c}break}case 2:{if(d<<24>>24!=8){d=(C|0)!=0;if(!A){if(!d)break c;p=a+528|0;q=a+446|0;s=a+448|0;t=m[a+526>>1]|0;o=0;while(1){d=e+1|0;f=e+2|0;g=e+3|0;h=e+4|0;n=e+5|0;if((l[e>>0]<<8|l[d>>0]|0)==(t|0)?(M=k[p>>2]|0,(l[f>>0]<<8|l[g>>0]|0)==(M&65535|0)?(l[h>>0]<<8|l[n>>0]|0)==(M>>>16|0):0):0){M=j[q>>1]|0;i[e>>0]=(M&65535)>>>8;i[d>>0]=M;M=k[s>>2]|0;i[f>>0]=(M&65535)>>>8;i[g>>0]=M;i[h>>0]=M>>>24;i[n>>0]=M>>>16}o=o+1|0;if((o|0)==(C|0))break c;else e=e+6|0}}if(!d)break c;w=a+528|0;x=a+446|0;y=a+448|0;z=m[a+526>>1]|0;v=0;while(1){g=l[e>>0]|0;h=e+1|0;n=l[h>>0]|0;o=e+2|0;p=e+3|0;q=e+4|0;s=l[q>>0]|0;u=e+5|0;t=l[u>>0]|0;d=i[o>>0]|0;if((g<<8|n|0)==(z|0)){d=d&255;f=i[p>>0]|0;L=k[w>>2]|0;if((s<<8|t|0)==(L>>>16|0)?(f&255|d<<8|0)==(L&65535|0):0){d=j[x>>1]|0;i[e>>0]=(d&65535)>>>8;i[h>>0]=d;d=k[y>>2]|0;i[o>>0]=(d&65535)>>>8;i[p>>0]=d;i[q>>0]=d>>>24;d=d>>>16&255}else M=176}else{d=d&255;f=i[p>>0]|0;M=176}if((M|0)==176){M=0;L=j[(k[A+(n>>>B<<2)>>2]|0)+(g<<1)>>1]|0;i[e>>0]=(L&65535)>>>8;i[h>>0]=L;d=j[(k[A+((f&255)>>>B<<2)>>2]|0)+(d<<1)>>1]|0;i[o>>0]=(d&65535)>>>8;i[p>>0]=d;d=j[(k[A+(t>>>B<<2)>>2]|0)+(s<<1)>>1]|0;i[q>>0]=(d&65535)>>>8;d=d&255}i[u>>0]=d;v=v+1|0;if((v|0)==(C|0))break c;else e=e+6|0}}d=(C|0)!=0;if(!u){if(!d)break c;f=a+528|0;g=a+446|0;h=a+448|0;n=m[a+526>>1]|0;d=0;while(1){if(((l[e>>0]|0)==(n|0)?(H=e+1|0,I=k[f>>2]|0,(l[H>>0]|0)==(I&65535|0)):0)?(J=e+2|0,(l[J>>0]|0)==(I>>>16|0)):0){i[e>>0]=j[g>>1];M=k[h>>2]|0;i[H>>0]=M;i[J>>0]=M>>>16}d=d+1|0;if((d|0)==(C|0))break c;else e=e+3|0}}if(!d)break c;n=a+528|0;o=a+446|0;p=a+448|0;q=m[a+526>>1]|0;d=0;while(1){f=l[e>>0]|0;g=e+1|0;h=l[g>>0]|0;if(((f|0)==(q|0)?(K=k[n>>2]|0,(h|0)==(K&65535|0)):0)?(L=e+2|0,(l[L>>0]|0)==(K>>>16|0)):0){i[e>>0]=j[o>>1];M=k[p>>2]|0;i[g>>0]=M;i[L>>0]=M>>>16}else{i[e>>0]=i[u+f>>0]|0;i[g>>0]=i[u+h>>0]|0;M=e+2|0;i[M>>0]=i[u+(l[M>>0]|0)>>0]|0}d=d+1|0;if((d|0)==(C|0))break;else e=e+3|0}break}case 4:if(d<<24>>24==8){d=(C|0)!=0;if(!((u|0)!=0&((s|0)!=0&(t|0)!=0))){if(!d)break c;g=a+452|0;f=0;d=e;while(1){e=i[d+1>>0]|0;switch(e<<24>>24){case 0:{i[d>>0]=j[g>>1];break}case -1:break;default:{M=e&255;M=(aa(l[d>>0]|0,M)|0)+128+(aa(m[g>>1]|0,M^255)|0)|0;i[d>>0]=((M>>>8&255)+M|0)>>>8}}f=f+1|0;if((f|0)==(C|0))break c;else d=d+2|0}}if(!d)break c;g=a+462|0;h=a+452|0;if(!q){f=0;while(1){M=i[e+1>>0]|0;d=M&255;switch(M<<24>>24){case -1:{i[e>>0]=i[u+(l[e>>0]|0)>>0]|0;break}case 0:{i[e>>0]=j[h>>1];break}default:{M=(aa(l[t+(l[e>>0]|0)>>0]|0,d)|0)+128+(aa(m[g>>1]|0,d^255)|0)|0;i[e>>0]=i[s+(((M>>>8&255)+M|0)>>>8&255)>>0]|0}}f=f+1|0;if((f|0)==(C|0))break c;else e=e+2|0}}else{f=0;while(1){M=i[e+1>>0]|0;d=M&255;switch(M<<24>>24){case -1:{i[e>>0]=i[u+(l[e>>0]|0)>>0]|0;break}case 0:{i[e>>0]=j[h>>1];break}default:{M=(aa(l[t+(l[e>>0]|0)>>0]|0,d)|0)+128+(aa(m[g>>1]|0,d^255)|0)|0;i[e>>0]=((M>>>8&255)+M|0)>>>8}}f=f+1|0;if((f|0)==(C|0))break c;else e=e+2|0}}}else{d=(C|0)!=0;if(!((A|0)!=0&(y|0)!=0&(z|0)!=0)){if(!d)break c;g=a+452|0;f=0;d=e;while(1){e=l[d+2>>0]<<8|l[d+3>>0];switch((e&65535)<<16>>16){case 0:{M=j[g>>1]|0;i[d>>0]=(M&65535)>>>8;i[d+1>>0]=M;break}case -1:break;default:{M=d+1|0;L=(aa(l[d>>0]<<8|l[M>>0],e)|0)+((aa(m[g>>1]|0,e^65535)|0)+32768)|0;L=(L>>>16)+L|0;i[d>>0]=L>>>24;i[M>>0]=L>>>16}}f=f+1|0;if((f|0)==(C|0))break c;else d=d+4|0}}if(!d)break c;g=a+462|0;h=a+452|0;if(f){f=0;while(1){d=l[e+2>>0]<<8|l[e+3>>0];switch((d&65535)<<16>>16){case -1:{M=e+1|0;L=j[(k[A+((l[M>>0]|0)>>>B<<2)>>2]|0)+(l[e>>0]<<1)>>1]|0;i[e>>0]=(L&65535)>>>8;i[M>>0]=L;break}case 0:{M=j[h>>1]|0;i[e>>0]=(M&65535)>>>8;i[e+1>>0]=M;break}default:{M=e+1|0;L=(aa(m[(k[z+((l[M>>0]|0)>>>B<<2)>>2]|0)+(l[e>>0]<<1)>>1]|0,d)|0)+32768+(aa(m[g>>1]|0,d^65535)|0)|0;L=(L>>>16)+L|0;L=j[(k[y+((L>>>16&255)>>>B<<2)>>2]|0)+(L>>>24<<1)>>1]|0;i[e>>0]=(L&65535)>>>8;i[M>>0]=L}}f=f+1|0;if((f|0)==(C|0))break c;else e=e+4|0}}else{f=0;while(1){d=l[e+2>>0]<<8|l[e+3>>0];switch((d&65535)<<16>>16){case -1:{M=e+1|0;L=j[(k[A+((l[M>>0]|0)>>>B<<2)>>2]|0)+(l[e>>0]<<1)>>1]|0;i[e>>0]=(L&65535)>>>8;i[M>>0]=L;break}case 0:{M=j[h>>1]|0;i[e>>0]=(M&65535)>>>8;i[e+1>>0]=M;break}default:{M=e+1|0;L=(aa(m[(k[z+((l[M>>0]|0)>>>B<<2)>>2]|0)+(l[e>>0]<<1)>>1]|0,d)|0)+32768+(aa(m[g>>1]|0,d^65535)|0)|0;L=(L>>>16)+L|0;i[e>>0]=L>>>24;i[M>>0]=L>>>16}}f=f+1|0;if((f|0)==(C|0))break c;else e=e+4|0}}}case 6:{if(d<<24>>24==8){d=(C|0)!=0;if(!((u|0)!=0&((s|0)!=0&(t|0)!=0))){if(!d)break c;g=a+446|0;h=a+448|0;f=0;d=e;while(1){e=i[d+3>>0]|0;switch(e<<24>>24){case 0:{i[d>>0]=j[g>>1];M=k[h>>2]|0;i[d+1>>0]=M;i[d+2>>0]=M>>>16;break}case -1:break;default:{J=e&255;L=J^255;M=(aa(l[d>>0]|0,J)|0)+128+(aa(m[g>>1]|0,L)|0)|0;i[d>>0]=((M>>>8&255)+M|0)>>>8;M=d+1|0;I=aa(l[M>>0]|0,J)|0;K=k[h>>2]|0;I=I+128+(aa(K&65535,L)|0)|0;i[M>>0]=((I>>>8&255)+I|0)>>>8;M=d+2|0;L=(aa(l[M>>0]|0,J)|0)+128+(aa(K>>>16,L)|0)|0;i[M>>0]=((L>>>8&255)+L|0)>>>8}}f=f+1|0;if((f|0)==(C|0))break c;else d=d+4|0}}if(!d)break c;g=a+456|0;h=a+458|0;n=a+460|0;o=a+446|0;p=a+448|0;if(!q){f=0;while(1){d=i[e+3>>0]|0;switch(d<<24>>24){case -1:{i[e>>0]=i[u+(l[e>>0]|0)>>0]|0;M=e+1|0;i[M>>0]=i[u+(l[M>>0]|0)>>0]|0;M=e+2|0;i[M>>0]=i[u+(l[M>>0]|0)>>0]|0;break}case 0:{i[e>>0]=j[o>>1];M=k[p>>2]|0;i[e+1>>0]=M;i[e+2>>0]=M>>>16;break}default:{K=d&255;L=K^255;M=(aa(l[t+(l[e>>0]|0)>>0]|0,K)|0)+128+(aa(m[g>>1]|0,L)|0)|0;i[e>>0]=i[s+(((M>>>8&255)+M|0)>>>8&255)>>0]|0;M=e+1|0;J=(aa(l[t+(l[M>>0]|0)>>0]|0,K)|0)+128+(aa(m[h>>1]|0,L)|0)|0;i[M>>0]=i[s+(((J>>>8&255)+J|0)>>>8&255)>>0]|0;M=e+2|0;L=(aa(l[t+(l[M>>0]|0)>>0]|0,K)|0)+128+(aa(m[n>>1]|0,L)|0)|0;i[M>>0]=i[s+(((L>>>8&255)+L|0)>>>8&255)>>0]|0}}f=f+1|0;if((f|0)==(C|0))break c;else e=e+4|0}}else{f=0;while(1){d=i[e+3>>0]|0;switch(d<<24>>24){case -1:{i[e>>0]=i[u+(l[e>>0]|0)>>0]|0;M=e+1|0;i[M>>0]=i[u+(l[M>>0]|0)>>0]|0;M=e+2|0;i[M>>0]=i[u+(l[M>>0]|0)>>0]|0;break}case 0:{i[e>>0]=j[o>>1];M=k[p>>2]|0;i[e+1>>0]=M;i[e+2>>0]=M>>>16;break}default:{K=d&255;L=K^255;M=(aa(l[t+(l[e>>0]|0)>>0]|0,K)|0)+128+(aa(m[g>>1]|0,L)|0)|0;i[e>>0]=((M>>>8&255)+M|0)>>>8;M=e+1|0;J=(aa(l[t+(l[M>>0]|0)>>0]|0,K)|0)+128+(aa(m[h>>1]|0,L)|0)|0;i[M>>0]=((J>>>8&255)+J|0)>>>8;M=e+2|0;L=(aa(l[t+(l[M>>0]|0)>>0]|0,K)|0)+128+(aa(m[n>>1]|0,L)|0)|0;i[M>>0]=((L>>>8&255)+L|0)>>>8}}f=f+1|0;if((f|0)==(C|0))break c;else e=e+4|0}}}d=(C|0)!=0;if(!((A|0)!=0&(y|0)!=0&(z|0)!=0)){if(!d)break c;g=a+446|0;h=a+448|0;f=0;d=e;while(1){e=l[d+6>>0]<<8|l[d+7>>0];switch((e&65535)<<16>>16){case 0:{M=j[g>>1]|0;i[d>>0]=(M&65535)>>>8;i[d+1>>0]=M;M=k[h>>2]|0;i[d+2>>0]=(M&65535)>>>8;i[d+3>>0]=M;i[d+4>>0]=M>>>24;i[d+5>>0]=M>>>16;break}case -1:break;default:{J=d+1|0;F=d+2|0;H=d+3|0;G=l[F>>0]<<8|l[H>>0];K=d+4|0;M=d+5|0;I=l[K>>0]<<8|l[M>>0];L=e^65535;E=(aa(l[d>>0]<<8|l[J>>0],e)|0)+32768+(aa(m[g>>1]|0,L)|0)|0;E=(E>>>16)+E|0;i[d>>0]=E>>>24;i[J>>0]=E>>>16;G=aa(G,e)|0;J=k[h>>2]|0;G=G+32768+(aa(J&65535,L)|0)|0;G=(G>>>16)+G|0;i[F>>0]=G>>>24;i[H>>0]=G>>>16;L=(aa(I,e)|0)+32768+(aa(J>>>16,L)|0)|0;L=(L>>>16)+L|0;i[K>>0]=L>>>24;i[M>>0]=L>>>16}}f=f+1|0;if((f|0)==(C|0))break c;else d=d+8|0}}if(!d)break c;x=a+456|0;s=(q|0)==0;t=a+458|0;u=a+460|0;v=a+446|0;w=a+448|0;q=0;while(1){o=l[e+6>>0]<<8|l[e+7>>0];switch((o&65535)<<16>>16){case -1:{L=e+1|0;K=j[(k[A+((l[L>>0]|0)>>>B<<2)>>2]|0)+(l[e>>0]<<1)>>1]|0;i[e>>0]=(K&65535)>>>8;i[L>>0]=K;L=e+2|0;K=e+3|0;M=j[(k[A+((l[K>>0]|0)>>>B<<2)>>2]|0)+(l[L>>0]<<1)>>1]|0;i[L>>0]=(M&65535)>>>8;i[K>>0]=M;K=e+4|0;M=e+5|0;L=j[(k[A+((l[M>>0]|0)>>>B<<2)>>2]|0)+(l[K>>0]<<1)>>1]|0;i[K>>0]=(L&65535)>>>8;i[M>>0]=L;break}case 0:{M=j[v>>1]|0;i[e>>0]=(M&65535)>>>8;i[e+1>>0]=M;M=k[w>>2]|0;i[e+2>>0]=(M&65535)>>>8;i[e+3>>0]=M;i[e+4>>0]=M>>>24;i[e+5>>0]=M>>>16;break}default:{h=e+1|0;p=o^65535;g=(aa(m[(k[z+((l[h>>0]|0)>>>B<<2)>>2]|0)+(l[e>>0]<<1)>>1]|0,o)|0)+32768+(aa(m[x>>1]|0,p)|0)|0;g=(g>>>16)+g|0;d=g>>>16;g=g>>>24;if(s){d=j[(k[y+((d&255)>>>B<<2)>>2]|0)+(g<<1)>>1]|0;f=d&255;d=(d&65535)>>>8&255}else{f=d&255;d=g&255}i[e>>0]=d;i[h>>0]=f;h=e+2|0;n=e+3|0;g=(aa(m[(k[z+((l[n>>0]|0)>>>B<<2)>>2]|0)+(l[h>>0]<<1)>>1]|0,o)|0)+32768+(aa(m[t>>1]|0,p)|0)|0;g=(g>>>16)+g|0;d=g>>>16;g=g>>>24;if(s){d=j[(k[y+((d&255)>>>B<<2)>>2]|0)+(g<<1)>>1]|0;f=d&255;d=(d&65535)>>>8&255}else{f=d&255;d=g&255}i[h>>0]=d;i[n>>0]=f;h=e+4|0;n=e+5|0;g=(aa(m[(k[z+((l[n>>0]|0)>>>B<<2)>>2]|0)+(l[h>>0]<<1)>>1]|0,o)|0)+32768+(aa(m[u>>1]|0,p)|0)|0;g=(g>>>16)+g|0;d=g>>>16;g=g>>>24;if(s){d=j[(k[y+((d&255)>>>B<<2)>>2]|0)+(g<<1)>>1]|0;f=d&255;d=(d&65535)>>>8&255}else{f=d&255;d=g&255}i[h>>0]=d;i[n>>0]=f}}q=q+1|0;if((q|0)==(C|0))break c;else e=e+8|0}}default:break c}}while(0);d=k[$>>2]|0;d:do if((d&6299648|0)==8192){if(d&128){if(j[a+420>>1]|0)break;d=i[a+427>>0]|0;if(d&4)break}else d=i[a+427>>0]|0;if(d<<24>>24!=3){d=(k[ba>>2]|0)+1|0;h=k[a+476>>2]|0;o=k[a+484>>2]|0;n=k[a+488>>2]|0;p=k[b>>2]|0;g=b+9|0;M=i[g>>0]|0;if(!((o|0)!=0&(M&255)<9)?!((n|0)!=0&M<<24>>24==16):0)break;M=j[b+8>>1]|0;e=(M&65535)>>>8&255;switch((M&255)<<24>>24){case 2:{f=(p|0)!=0;if(e<<24>>24==8){if(f)e=0;else break d;while(1){i[d>>0]=i[o+(l[d>>0]|0)>>0]|0;M=d+1|0;i[M>>0]=i[o+(l[M>>0]|0)>>0]|0;M=d+2|0;i[M>>0]=i[o+(l[M>>0]|0)>>0]|0;e=e+1|0;if((e|0)==(p|0))break;else d=d+3|0}}else{if(f)e=0;else break d;while(1){L=d+1|0;K=j[(k[n+((l[L>>0]|0)>>>h<<2)>>2]|0)+(l[d>>0]<<1)>>1]|0;i[d>>0]=(K&65535)>>>8;i[L>>0]=K;L=d+2|0;K=d+3|0;M=j[(k[n+((l[K>>0]|0)>>>h<<2)>>2]|0)+(l[L>>0]<<1)>>1]|0;i[L>>0]=(M&65535)>>>8;i[K>>0]=M;K=d+4|0;M=d+5|0;L=j[(k[n+((l[M>>0]|0)>>>h<<2)>>2]|0)+(l[K>>0]<<1)>>1]|0;i[K>>0]=(L&65535)>>>8;i[M>>0]=L;e=e+1|0;if((e|0)==(p|0))break;else d=d+6|0}}break}case 6:{f=(p|0)!=0;if(e<<24>>24==8){if(f)e=0;else break d;while(1){i[d>>0]=i[o+(l[d>>0]|0)>>0]|0;M=d+1|0;i[M>>0]=i[o+(l[M>>0]|0)>>0]|0;M=d+2|0;i[M>>0]=i[o+(l[M>>0]|0)>>0]|0;e=e+1|0;if((e|0)==(p|0))break;else d=d+4|0}}else{if(f)e=0;else break d;while(1){L=d+1|0;K=j[(k[n+((l[L>>0]|0)>>>h<<2)>>2]|0)+(l[d>>0]<<1)>>1]|0;i[d>>0]=(K&65535)>>>8;i[L>>0]=K;L=d+2|0;K=d+3|0;M=j[(k[n+((l[K>>0]|0)>>>h<<2)>>2]|0)+(l[L>>0]<<1)>>1]|0;i[L>>0]=(M&65535)>>>8;i[K>>0]=M;K=d+4|0;M=d+5|0;L=j[(k[n+((l[M>>0]|0)>>>h<<2)>>2]|0)+(l[K>>0]<<1)>>1]|0;i[K>>0]=(L&65535)>>>8;i[M>>0]=L;e=e+1|0;if((e|0)==(p|0))break;else d=d+8|0}}break}case 4:{f=(p|0)!=0;if(e<<24>>24==8){if(f)e=0;else break d;while(1){i[d>>0]=i[o+(l[d>>0]|0)>>0]|0;e=e+1|0;if((e|0)==(p|0))break;else d=d+2|0}}else{if(f)e=0;else break d;while(1){M=d+1|0;L=j[(k[n+((l[M>>0]|0)>>>h<<2)>>2]|0)+(l[d>>0]<<1)>>1]|0;i[d>>0]=(L&65535)>>>8;i[M>>0]=L;e=e+1|0;if((e|0)==(p|0))break;else d=d+4|0}}break}case 0:{if(e<<24>>24==2){if(!p)break d;else{e=0;f=d}while(1){J=l[f>>0]|0;K=J&192;I=J&48;L=J&12;M=J&3;i[f>>0]=(l[o+(I<<2|I|I>>>2|I>>>4)>>0]|0)>>>2&48|l[o+(J>>>6|K|K>>>2|K>>>4)>>0]&192|(l[o+(L<<2|L|L<<4|L>>>2)>>0]|0)>>>4&12|(l[o+(M<<4|M|M<<6|M<<2)>>0]|0)>>>6;e=e+4|0;if(e>>>0>=p>>>0)break;else f=f+1|0}e=i[g>>0]|0}switch(e<<24>>24){case 4:{if(!p)break d;else e=0;while(1){M=l[d>>0]|0;L=M&15;i[d>>0]=(l[o+(L<<4|L)>>0]|0)>>>4|l[o+(M&240|M>>>4)>>0]&240;e=e+2|0;if(e>>>0>=p>>>0)break;else d=d+1|0}break}case 8:{if(!p)break d;else e=0;while(1){i[d>>0]=i[o+(l[d>>0]|0)>>0]|0;e=e+1|0;if((e|0)==(p|0))break;else d=d+1|0}break}case 16:{if(!p)break d;else e=0;while(1){M=d+1|0;L=j[(k[n+((l[M>>0]|0)>>>h<<2)>>2]|0)+(l[d>>0]<<1)>>1]|0;i[d>>0]=(L&65535)>>>8;i[M>>0]=L;e=e+1|0;if((e|0)==(p|0))break;else d=d+2|0}break}default:break d}break}default:break d}}}while(0);d=k[$>>2]|0;e:do if((d&262272|0)==262272){switch(i[b+8>>0]|0){case 4:case 6:break;default:break e}Qdb(b,(k[ba>>2]|0)+1|0,0);d=k[$>>2]|0}while(0);f:do if(d&8388608|0?(N=b+8|0,i[N>>0]&4):0){n=(k[ba>>2]|0)+1|0;e=k[b>>2]|0;d=j[N>>1]|0;f=d&65535;g:do if(f&4|0)switch(((d&65535)>>>8&255)<<24>>24){case 8:{g=k[a+492>>2]|0;if(!g)break g;d=f&2;f=d+2|0;if(!e)break f;d=n+(d|1)|0;while(1){i[d>>0]=i[g+(l[d>>0]|0)>>0]|0;e=e+-1|0;if(!e)break f;else d=d+f|0}}case 16:{g=k[a+500>>2]|0;h=k[a+476>>2]|0;if(!g)break g;d=f<<1&4;f=d+4|0;if(!e)break f;d=n+(d|2)|0;while(1){N=d+1|0;M=j[(k[g+((l[N>>0]|0)>>>h<<2)>>2]|0)+(l[d>>0]<<1)>>1]|0;i[d>>0]=(M&65535)>>>8;i[N>>0]=M;e=e+-1|0;if(!e)break f;else d=d+f|0}}default:break g}while(0);Vcb(a,413525)}while(0);d=k[$>>2]|0;if((d&67108864|0)!=0?(O=(k[ba>>2]|0)+1|0,P=b+9|0,(i[P>>0]|0)==16):0){g=b+4|0;N=k[g>>2]|0;f=O+N|0;if((N|0)>0){e=O;d=O;while(1){O=l[d>>0]|0;i[e>>0]=(((((l[d+1>>0]|0)-O|0)*65535|0)+8388480|0)>>>24)+O;d=d+2|0;if(d>>>0>=f>>>0)break;else e=e+1|0}d=k[$>>2]|0}i[P>>0]=8;P=l[b+10>>0]|0;i[b+11>>0]=P<<3;P=aa(k[b>>2]|0,P)|0;k[g>>2]=P}if((d&1024|0)!=0?(Q=(k[ba>>2]|0)+1|0,R=b+9|0,(i[R>>0]|0)==16):0){g=b+4|0;P=k[g>>2]|0;f=Q+P|0;if((P|0)>0){e=Q;d=Q;while(1){i[e>>0]=i[d>>0]|0;d=d+2|0;if(d>>>0>=f>>>0)break;else e=e+1|0}d=k[$>>2]|0}i[R>>0]=8;R=l[b+10>>0]|0;i[b+11>>0]=R<<3;R=aa(k[b>>2]|0,R)|0;k[g>>2]=R}do if(d&64){d=(k[ba>>2]|0)+1|0;n=k[a+604>>2]|0;h=k[a+608>>2]|0;q=k[b>>2]|0;o=b+9|0;h:do if((i[o>>0]|0)==8){p=b+8|0;e=j[p>>1]|0;f=e&255;g=(n|0)!=0;e=(e&65535)>>>8&255;if(g&f<<24>>24==2){if(q){e=d;f=0;while(1){i[e>>0]=i[n+((l[d+1>>0]|0)>>>3<<5|(l[d>>0]|0)>>>3<<10|(l[d+2>>0]|0)>>>3)>>0]|0;f=f+1|0;if((f|0)==(q|0))break;else{e=e+1|0;d=d+3|0}}e=i[o>>0]|0}i[p>>0]=3;i[b+10>>0]=1;i[b+11>>0]=e;d=e&255;if((e&255)>7)d=aa(d>>>3,q)|0;else d=((aa(d,q)|0)+7|0)>>>3;k[b+4>>2]=d;break}if(!(g&f<<24>>24==6)){if((q|0)!=0&((h|0)!=0&f<<24>>24==3))e=0;else break;while(1){i[d>>0]=i[h+(l[d>>0]|0)>>0]|0;e=e+1|0;if((e|0)==(q|0))break h;else d=d+1|0}}if(q){f=d;e=0;while(1){i[d>>0]=i[n+((l[f+1>>0]|0)>>>3<<5|(l[f>>0]|0)>>>3<<10|(l[f+2>>0]|0)>>>3)>>0]|0;e=e+1|0;if((e|0)==(q|0))break;else{f=f+4|0;d=d+1|0}}e=i[o>>0]|0}i[p>>0]=3;i[b+10>>0]=1;i[b+11>>0]=e;d=e&255;if((e&255)>7)d=aa(d>>>3,q)|0;else d=((aa(d,q)|0)+7|0)>>>3;k[b+4>>2]=d}while(0);if(!(k[b+4>>2]|0))Ucb(a,413562);else{c=k[$>>2]|0;break}}else c=d;while(0);if(((c&512|0)!=0?(T=(k[ba>>2]|0)+1|0,U=b+9|0,(i[U>>0]|0)==8):0)?(S=k[b+8>>2]|0,(S&255)<<24>>24!=3):0){d=S>>>16&255;g=b+4|0;e=k[g>>2]|0;f=T+e|0;if((e|0)>0){d=f;c=f+e|0;do{d=d+-1|0;T=i[d>>0]|0;i[c+-1>>0]=T;c=c+-2|0;i[c>>0]=T}while(c>>>0>d>>>0);c=k[$>>2]|0;e=k[g>>2]|0;d=i[b+10>>0]|0}k[g>>2]=e<<1;i[U>>0]=16;i[b+11>>0]=(d&255)<<4}if((c&16384|0)!=0?(k[a+208>>2]&2048|0)!=0:0){ddb(b,(k[ba>>2]|0)+1|0);c=k[$>>2]|0}if(c&32){Pdb(b,(k[ba>>2]|0)+1|0);c=k[$>>2]|0}i:do if(c&524288|0){c=(k[ba>>2]|0)+1|0;f=k[b>>2]|0;U=j[b+8>>1]|0;e=(U&65535)>>>8&255;switch((U&255)<<24>>24){case 6:{c=c+(k[b+4>>2]|0)|0;d=(f|0)!=0;if(e<<24>>24==8){if(d)d=0;else break i;while(1){U=c+-1|0;i[U>>0]=l[U>>0]^255;d=d+1|0;if((d|0)==(f|0))break;else c=c+-4|0}}else{if(d)d=0;else break i;while(1){U=c+-1|0;i[U>>0]=l[U>>0]^255;U=c+-2|0;i[U>>0]=l[U>>0]^255;d=d+1|0;if((d|0)==(f|0))break;else c=c+-8|0}}break}case 4:{c=c+(k[b+4>>2]|0)|0;d=(f|0)!=0;if(e<<24>>24==8){if(d)d=0;else break i;while(1){U=c+-1|0;i[U>>0]=l[U>>0]^255;d=d+1|0;if((d|0)==(f|0))break;else c=c+-2|0}}else{if(d)d=0;else break i;while(1){U=c+-1|0;i[U>>0]=l[U>>0]^255;U=c+-2|0;i[U>>0]=l[U>>0]^255;d=d+1|0;if((d|0)==(f|0))break;else c=c+-4|0}}break}default:break i}}while(0);c=k[$>>2]|0;if((c&8|0)!=0?(Y=(k[ba>>2]|0)+1|0,U=j[b+8>>1]|0,W=U&255,V=(U&65535)>>>8,X=V&255,(U&255)<<24>>24!=3):0){f=V&65535;if(!(W&2)){c=1;d=l[a+516>>0]|0}else{d=l[a+513>>0]|0;k[Z+4>>2]=f-(l[a+514>>0]|0);k[Z+8>>2]=f-(l[a+515>>0]|0);c=3}k[Z>>2]=f-d;if(!(W&4))g=c;else{k[Z+(c<<2)>>2]=f-(l[a+517>>0]|0);g=c+1|0}e=0;c=0;do{d=Z+(e<<2)|0;W=k[d>>2]|0;if((W|0)>0&(W|0)<(f|0))c=1;else k[d>>2]=0;e=e+1|0}while((e|0)<(g|0));j:do if(c|0)switch(X<<24>>24){case 2:{Z=k[b+4>>2]|0;d=Y+Z|0;if((Z|0)>0)c=Y;else break j;do{i[c>>0]=(l[c>>0]|0)>>>1&85;c=c+1|0}while(c>>>0<d>>>0);break}case 4:{X=k[b+4>>2]|0;f=Y+X|0;d=k[Z>>2]|0;e=15>>>d;e=e<<4|e;if((X|0)>0)c=Y;else break j;do{i[c>>0]=(l[c>>0]|0)>>>d&e;c=c+1|0}while(c>>>0<f>>>0);break}case 8:{X=k[b+4>>2]|0;f=Y+X|0;if((X|0)>0){e=0;c=Y}else break j;while(1){d=e+1|0;i[c>>0]=(l[c>>0]|0)>>>(k[Z+(e<<2)>>2]|0);c=c+1|0;if(c>>>0>=f>>>0)break;else e=(d|0)>=(g|0)?0:d}break}case 16:{X=k[b+4>>2]|0;e=Y+X|0;if((X|0)>0){c=0;d=Y}else break j;while(1){Y=d+1|0;X=(l[d>>0]<<8|l[Y>>0])>>>(k[Z+(c<<2)>>2]|0);c=c+1|0;i[d>>0]=X>>>8;d=d+2|0;i[Y>>0]=X;if(d>>>0>=e>>>0)break;else c=(c|0)>=(g|0)?0:c}break}default:break j}while(0);c=k[$>>2]|0}do if(c&4|0){d=(k[ba>>2]|0)+1|0;h=b+9|0;c=i[h>>0]|0;if((c&255)>=8)break;n=k[b>>2]|0;k:do switch(c<<24>>24){case 1:{if(!n)break k;f=n+7&7^7;g=d+n|0;c=d+((n+-1|0)>>>3)|0;d=0;while(1){g=g+-1|0;i[g>>0]=(l[c>>0]|0)>>>f&1;e=(f|0)==7;d=d+1|0;if((d|0)==(n|0))break;else{f=e?0:f+1|0;c=e?c+-1|0:c}}break}case 2:{if(!n)break k;f=(n<<1)+6&6^6;g=d+n|0;c=d+((n+-1|0)>>>2)|0;d=0;while(1){g=g+-1|0;i[g>>0]=(l[c>>0]|0)>>>f&3;e=(f|0)==6;d=d+1|0;if((d|0)==(n|0))break;else{f=e?0:f+2|0;c=e?c+-1|0:c}}break}case 4:{if(!n)break k;f=n<<2&4;g=d+n|0;c=d+((n+-1|0)>>>1)|0;d=0;while(1){g=g+-1|0;i[g>>0]=(l[c>>0]|0)>>>f&15;e=(f|0)==4;d=d+1|0;if((d|0)==(n|0))break;else{f=e?0:4;c=e?c+-1|0:c}}break}default:{}}while(0);i[h>>0]=8;Z=l[b+10>>0]|0;i[b+11>>0]=Z<<3;Z=aa(Z,n)|0;k[b+4>>2]=Z}while(0);n=b+8|0;do if((k[n>>2]&255)<<24>>24==3){if((k[a+416>>2]|0)<=-1)break;Sdb(a,b)}while(0);c=k[$>>2]|0;if(c&1){Rdb(b,(k[ba>>2]|0)+1|0);c=k[$>>2]|0}l:do if(c&65536){e=(k[ba>>2]|0)+1|0;d=i[b+9>>0]|0;if((d&255)>=8)break;f=k[b+4>>2]|0;g=e+f|0;switch(d<<24>>24){case 1:{d=416179;break}case 2:{d=415667;break}case 4:{d=415923;break}default:break l}if((f|0)>0)c=e;else break;do{i[c>>0]=i[d+(l[c>>0]|0)>>0]|0;c=c+1|0}while(c>>>0<g>>>0);c=k[$>>2]|0}while(0);m:do if(c&32768|0){d=(k[ba>>2]|0)+1|0;h=j[a+436>>1]|0;e=k[_>>2]|0;g=k[b>>2]|0;f=(h&65535)>>>8&255;h=h&255;_=k[n>>2]|0;c=(_&65535)>>>8&255;switch((_&255)<<24>>24){case 0:switch(c<<24>>24){case 8:{c=d+g|0;d=c+g|0;if(!(e&128)){if(g|0){e=d;d=0;do{c=c+-1|0;i[e+-1>>0]=i[c>>0]|0;e=e+-2|0;i[e>>0]=h;d=d+1|0}while((d|0)!=(g|0))}i[b+10>>0]=2;i[b+11>>0]=16;k[b+4>>2]=g<<1;break m}else{i[d+-1>>0]=h;if(g>>>0>1){e=d;d=1;do{c=c+-1|0;_=e;e=e+-2|0;i[e>>0]=i[c>>0]|0;d=d+1|0;i[_+-3>>0]=h}while((d|0)!=(g|0))}i[b+10>>0]=2;i[b+11>>0]=16;k[b+4>>2]=g<<1;break m}}case 16:{_=g<<1;c=d+_|0;d=c+_|0;if(!(e&128)){if(g|0){e=d;d=0;do{i[e+-1>>0]=i[c+-1>>0]|0;c=c+-2|0;i[e+-2>>0]=i[c>>0]|0;i[e+-3>>0]=h;e=e+-4|0;i[e>>0]=f;d=d+1|0}while((d|0)!=(g|0))}i[b+10>>0]=2;i[b+11>>0]=32;k[b+4>>2]=g<<2;break m}else{i[d+-1>>0]=h;i[d+-2>>0]=f;if(g>>>0>1){e=d;d=1;do{i[e+-3>>0]=i[c+-1>>0]|0;c=c+-2|0;_=e;e=e+-4|0;i[e>>0]=i[c>>0]|0;d=d+1|0;i[_+-5>>0]=h;i[_+-6>>0]=f}while((d|0)!=(g|0))}i[b+10>>0]=2;i[b+11>>0]=32;k[b+4>>2]=g<<2;break m}}default:break m}case 2:switch(c<<24>>24){case 8:{c=d+(g*3|0)|0;d=c+g|0;if(!(e&128)){if(g|0){e=d;d=0;do{i[e+-1>>0]=i[c+-1>>0]|0;i[e+-2>>0]=i[c+-2>>0]|0;c=c+-3|0;i[e+-3>>0]=i[c>>0]|0;e=e+-4|0;i[e>>0]=h;d=d+1|0}while((d|0)!=(g|0))}i[b+10>>0]=4;i[b+11>>0]=32;k[b+4>>2]=g<<2;break m}else{i[d+-1>>0]=h;if(g>>>0>1){e=d;d=1;do{i[e+-2>>0]=i[c+-1>>0]|0;i[e+-3>>0]=i[c+-2>>0]|0;c=c+-3|0;_=e;e=e+-4|0;i[e>>0]=i[c>>0]|0;d=d+1|0;i[_+-5>>0]=h}while((d|0)!=(g|0))}i[b+10>>0]=4;i[b+11>>0]=32;k[b+4>>2]=g<<2;break m}}case 16:{c=d+(g*6|0)|0;d=c+(g<<1)|0;if(!(e&128)){if(g|0){e=0;do{i[d+-1>>0]=i[c+-1>>0]|0;i[d+-2>>0]=i[c+-2>>0]|0;i[d+-3>>0]=i[c+-3>>0]|0;i[d+-4>>0]=i[c+-4>>0]|0;i[d+-5>>0]=i[c+-5>>0]|0;c=c+-6|0;i[d+-6>>0]=i[c>>0]|0;i[d+-7>>0]=h;d=d+-8|0;i[d>>0]=f;e=e+1|0}while((e|0)!=(g|0))}i[b+10>>0]=4;i[b+11>>0]=64;k[b+4>>2]=g<<3;break m}else{i[d+-1>>0]=h;i[d+-2>>0]=f;if(g>>>0>1){e=1;do{i[d+-3>>0]=i[c+-1>>0]|0;i[d+-4>>0]=i[c+-2>>0]|0;i[d+-5>>0]=i[c+-3>>0]|0;i[d+-6>>0]=i[c+-4>>0]|0;i[d+-7>>0]=i[c+-5>>0]|0;c=c+-6|0;_=d;d=d+-8|0;i[d>>0]=i[c>>0]|0;e=e+1|0;i[_+-9>>0]=h;i[_+-10>>0]=f}while((e|0)!=(g|0))}i[b+10>>0]=4;i[b+11>>0]=64;k[b+4>>2]=g<<3;break m}}default:break m}default:break m}}while(0);n:do if(k[$>>2]&131072|0){c=(k[ba>>2]|0)+1|0;f=k[b>>2]|0;_=k[n>>2]|0;e=(_&65535)>>>8&255;switch((_&255)<<24>>24){case 6:{c=c+(k[b+4>>2]|0)|0;d=(f|0)!=0;if(e<<24>>24==8){if(d)d=0;else break n;do{Z=c+-1|0;_=i[Z>>0]|0;Y=c+-2|0;i[Z>>0]=i[Y>>0]|0;Z=c+-3|0;i[Y>>0]=i[Z>>0]|0;c=c+-4|0;i[Z>>0]=i[c>>0]|0;i[c>>0]=_;d=d+1|0}while((d|0)!=(f|0))}else{if(d)d=0;else break n;do{Z=c+-1|0;Y=i[Z>>0]|0;W=c+-2|0;_=i[W>>0]|0;X=c+-3|0;i[Z>>0]=i[X>>0]|0;Z=c+-4|0;i[W>>0]=i[Z>>0]|0;W=c+-5|0;i[X>>0]=i[W>>0]|0;X=c+-6|0;i[Z>>0]=i[X>>0]|0;Z=c+-7|0;i[W>>0]=i[Z>>0]|0;c=c+-8|0;i[X>>0]=i[c>>0]|0;i[Z>>0]=Y;i[c>>0]=_;d=d+1|0}while((d|0)!=(f|0))}break}case 4:{c=c+(k[b+4>>2]|0)|0;d=(f|0)!=0;if(e<<24>>24==8){if(d)d=0;else break n;do{Z=c+-1|0;_=i[Z>>0]|0;c=c+-2|0;i[Z>>0]=i[c>>0]|0;i[c>>0]=_;d=d+1|0}while((d|0)!=(f|0))}else{if(d)d=0;else break n;do{W=c+-1|0;Y=i[W>>0]|0;X=c+-2|0;_=i[X>>0]|0;Z=c+-3|0;i[W>>0]=i[Z>>0]|0;c=c+-4|0;i[X>>0]=i[c>>0]|0;i[Z>>0]=Y;i[c>>0]=_;d=d+1|0}while((d|0)!=(f|0))}break}default:break n}}while(0);c=k[$>>2]|0;do if(c&16){if((i[b+9>>0]|0)!=16)break;e=aa(l[b+10>>0]|0,k[b>>2]|0)|0;if(!e)break;else{c=0;d=(k[ba>>2]|0)+1|0}while(1){Z=i[d>>0]|0;_=d+1|0;i[d>>0]=i[_>>0]|0;i[_>>0]=Z;c=c+1|0;if((c|0)==(e|0))break;else d=d+2|0}c=k[$>>2]|0}while(0);if(!(c&1048576)){r=ca;return}c=k[a+192>>2]|0;if(c|0)Ph[c&511](a,b,(k[ba>>2]|0)+1|0);c=j[a+204>>1]|0;d=c&255;c=(c&65535)>>>8&255;if(d<<24>>24)i[b+9>>0]=d;d=b+10|0;if(!(c<<24>>24))c=i[d>>0]|0;else i[d>>0]=c;c=aa(c&255,l[b+9>>0]|0)|0;i[b+11>>0]=c;c=c&255;d=k[b>>2]|0;if(c>>>0>7)c=aa(c>>>3,d)|0;else c=((aa(c,d)|0)+7|0)>>>3;k[b+4>>2]=c;r=ca;return}function cdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=k[a>>2]|0;A=a+8|0;e=j[A>>1]|0;d=e&255;e=(e&65535)>>>8&255;if(d<<24>>24){if(!((c|0)!=0&d<<24>>24==2))return;z=a+9|0;switch(e<<24>>24){case 8:{if(B|0){p=j[c+2>>1]&255;q=j[c+4>>1]&255;o=j[c+6>>1]&255;h=0;n=b+(B<<2)|0;c=b+(k[a+4>>2]|0)|0;do{e=c+-1|0;d=n+-1|0;f=c+-2|0;c=c+-3|0;if(((i[c>>0]|0)==p<<24>>24?(i[f>>0]|0)==q<<24>>24:0)?(i[e>>0]|0)==o<<24>>24:0)g=0;else g=-1;i[d>>0]=g;i[n+-2>>0]=i[e>>0]|0;i[n+-3>>0]=i[f>>0]|0;n=n+-4|0;i[n>>0]=i[c>>0]|0;h=h+1|0}while((h|0)!=(B|0))}break}case 16:{d=j[c+2>>1]|0;u=(d&65535)>>>8&65535;e=j[c+4>>1]|0;v=(e&65535)>>>8&65535;c=j[c+6>>1]|0;t=(c&65535)>>>8&65535;if(B|0){s=d&255;r=e&255;q=c&255;o=0;p=b+(k[a+4>>2]|0)|0;h=b+(B<<3)|0;do{g=p+-1|0;d=h+-1|0;e=p;p=p+-6|0;n=e+-5|0;if((((((l[p>>0]|0)==(u|0)?(i[n>>0]|0)==s<<24>>24:0)?(w=e+-4|0,(l[w>>0]|0)==(v|0)):0)?(x=e+-3|0,(i[x>>0]|0)==r<<24>>24):0)?(y=e+-2|0,(l[y>>0]|0)==(t|0)):0)?(i[g>>0]|0)==q<<24>>24:0){i[d>>0]=0;i[h+-2>>0]=0;c=y;f=x;d=w}else{i[d>>0]=-1;i[h+-2>>0]=-1;c=e+-2|0;f=e+-3|0;d=e+-4|0}i[h+-3>>0]=i[g>>0]|0;i[h+-4>>0]=i[c>>0]|0;i[h+-5>>0]=i[f>>0]|0;i[h+-6>>0]=i[d>>0]|0;i[h+-7>>0]=i[n>>0]|0;h=h+-8|0;i[h>>0]=i[p>>0]|0;o=o+1|0}while((o|0)!=(B|0))}break}default:{}}i[A>>0]=6;i[a+10>>0]=4;d=l[z>>0]<<2;i[a+11>>0]=d;d=d&252;if(d>>>0>7)d=aa(d>>>3,B)|0;else d=((aa(d,B)|0)+7|0)>>>3;k[a+4>>2]=d;return}n=(c|0)!=0;if(n)d=m[c+8>>1]|0;else d=0;o=a+9|0;if((e&255)<8){switch(e<<24>>24){case 1:{d=0-(d&1)&255;if(B){e=b+((B+-1|0)>>>3)|0;c=b+B|0;f=0;g=B+7&7^7;while(1){c=c+-1|0;i[c>>0]=((l[e>>0]&1<<g|0)!=0)<<31>>31;h=(g|0)==7;f=f+1|0;if((f|0)==(B|0))break;else{e=h?e+-1|0:e;g=h?0:g+1|0}}}break}case 2:{d=(d&3)*85|0;if(B){e=b+B|0;c=0;f=b+((B+-1|0)>>>2)|0;g=(B<<1)+6&6^6;while(1){e=e+-1|0;h=(l[f>>0]|0)>>>g&3;i[e>>0]=h<<2|h|h<<4|h<<6;h=(g|0)==6;c=c+1|0;if((c|0)==(B|0))break;else{f=h?f+-1|0:f;g=h?0:g+2|0}}}break}case 4:{d=(d&15)*17|0;if(B){c=b+B|0;f=0;g=b+((B+-1|0)>>>1)|0;e=B<<2&4;while(1){c=c+-1|0;z=(l[g>>0]|0)>>>e&15;i[c>>0]=z<<4|z;e=(e|0)==4;f=f+1|0;if((f|0)==(B|0))break;else{g=e?g+-1|0:g;e=e?0:4}}}break}default:{}}i[o>>0]=8;i[a+11>>0]=8;k[a+4>>2]=B;e=8}if(!n)return;switch(e<<24>>24){case 8:{if(B|0){f=d&255;e=0;c=b+(B<<1)|0;d=b+B|0;do{d=d+-1|0;b=c;c=c+-2|0;i[b+-1>>0]=((i[d>>0]|0)!=f<<24>>24)<<31>>31;i[c>>0]=i[d>>0]|0;e=e+1|0}while((e|0)!=(B|0))}break}case 16:{e=k[a+4>>2]|0;if(B|0){n=d>>>8&255;h=d&255;f=0;g=b+(e<<1)|0;c=b+e|0;do{e=c+-1|0;d=g+-1|0;c=c+-2|0;if((i[c>>0]|0)==n<<24>>24?(i[e>>0]|0)==h<<24>>24:0){i[d>>0]=0;i[g+-2>>0]=0}else{i[d>>0]=-1;i[g+-2>>0]=-1}i[g+-3>>0]=i[e>>0]|0;g=g+-4|0;i[g>>0]=i[c>>0]|0;f=f+1|0}while((f|0)!=(B|0))}break}default:{}}i[A>>0]=4;i[a+10>>0]=2;d=l[o>>0]<<1;i[a+11>>0]=d;d=d&254;if(d>>>0>7)d=aa(d>>>3,B)|0;else d=((aa(d,B)|0)+7|0)>>>3;k[a+4>>2]=d;return}function ddb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=k[a>>2]|0;c=i[a+9>>0]|0;if((c&255)<=7)return;e=a+8|0;d=i[e>>0]|0;if(d&2)return;a:do switch(d<<24>>24){case 0:{if(c<<24>>24==8){c=b+f+-1|0;if(!f)break a;b=c+(f<<1)|0;d=0;while(1){i[b>>0]=i[c>>0]|0;i[b+-1>>0]=i[c>>0]|0;i[b+-2>>0]=i[c>>0]|0;d=d+1|0;if((d|0)==(f|0))break;else{b=b+-3|0;c=c+-1|0}}}else{c=b+(f<<1)+-1|0;if(!f)break a;b=c+(f<<2)|0;d=0;while(1){i[b>>0]=i[c>>0]|0;g=c+-1|0;i[b+-1>>0]=i[g>>0]|0;i[b+-2>>0]=i[c>>0]|0;i[b+-3>>0]=i[g>>0]|0;i[b+-4>>0]=i[c>>0]|0;i[b+-5>>0]=i[g>>0]|0;d=d+1|0;if((d|0)==(f|0))break;else{b=b+-6|0;c=c+-2|0}}}break}case 4:{if(c<<24>>24==8){d=f<<1;c=b+d+-1|0;if(!f)break a;b=c+d|0;d=0;while(1){g=c+-1|0;i[b>>0]=i[c>>0]|0;i[b+-1>>0]=i[g>>0]|0;i[b+-2>>0]=i[g>>0]|0;i[b+-3>>0]=i[g>>0]|0;d=d+1|0;if((d|0)==(f|0))break;else{b=b+-4|0;c=c+-2|0}}}else{d=f<<2;c=b+d+-1|0;if(!f)break a;b=c;c=c+d|0;d=0;while(1){i[c>>0]=i[b>>0]|0;h=b+-2|0;i[c+-1>>0]=i[b+-1>>0]|0;i[c+-2>>0]=i[h>>0]|0;g=b+-3|0;i[c+-3>>0]=i[g>>0]|0;i[c+-4>>0]=i[h>>0]|0;i[c+-5>>0]=i[g>>0]|0;i[c+-6>>0]=i[h>>0]|0;i[c+-7>>0]=i[g>>0]|0;d=d+1|0;if((d|0)==(f|0))break;else{b=b+-4|0;c=c+-8|0}}}break}default:{}}while(0);h=a+10|0;c=(l[h>>0]|0)+2|0;i[h>>0]=c;h=j[e>>1]|0;i[e>>0]=h&65535|2;c=aa((h&65535)>>>8&65535,c&255)|0;i[a+11>>0]=c;c=c&255;if(c>>>0>7)c=aa(c>>>3,f)|0;else c=((aa(c,f)|0)+7|0)>>>3;k[a+4>>2]=c;return}function edb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0;j=r;r=r+16|0;c=j;i=a+768|0;k[i>>2]=33;b=k[a+184>>2]|0;if(!b)Ucb(a,413195);Ph[b&511](a,c,8);d=(l[c+1>>0]|0)<<16|(l[c>>0]|0)<<24|(l[c+2>>0]|0)<<8|(l[c+3>>0]|0);if((d|0)<0)Ucb(a,413598);e=c+4|0;f=l[e>>0]|0;n=f<<24;g=l[c+5>>0]|0;h=l[c+6>>0]|0;b=l[c+7>>0]|0;k[a+376>>2]=g<<16|n|h<<8|b;c=a+404|0;k[c>>2]=0;m=k[a+212>>2]|0;if((n&536870912|0)==0?(m&2048|0)==0:(m&768|0)!=768){n=yeb(0,e,4)|0;k[c>>2]=n}if((b+-65|0)>>>0>57|(b+-91|0)>>>0<6)Ycb(a,413686);if((h+-65|0)>>>0>57|(h+-91|0)>>>0<6)Ycb(a,413686);if((g+-65|0)>>>0>57|(g+-91|0)>>>0<6)Ycb(a,413686);if((f+-65|0)>>>0>57|(f+-91|0)>>>0<6)Ycb(a,413686);else{k[i>>2]=65;r=j;return d|0}return 0}function fdb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0;o=r;r=r+1024|0;n=o;a:do if(b|0){if(!a)while(1){b=b-(b>>>0<1024?b:1024)|0;if(!b)break a}g=a+184|0;h=a+376|0;i=a+212|0;j=a+404|0;while(1){d=b>>>0<1024?b:1024;b=b-d|0;c=k[g>>2]|0;if(!c)break;Ph[c&511](a,n,d);f=k[i>>2]|0;if(d|0?((k[h>>2]&536870912|0)==0?(f&2048|0)==0:(f&768|0)!=768):0){e=n;f=k[j>>2]|0;while(1){c=(d|0)==0?-1:d;f=yeb(f,e,c)|0;d=d-c|0;if(!d)break;else e=e+c|0}k[j>>2]=f}if(!b)break a}Ucb(a,413195)}while(0);b=a+376|0;j=(k[b>>2]&536870912|0)==0;f=a+212|0;c=k[f>>2]|0;k[a+768>>2]=129;d=k[a+184>>2]|0;e=(d|0)==0;do if(j)if(!e){Ph[d&511](a,n,4);if(!(c&2048))break;else{m=19;break}}else Ucb(a,413195);else if(!e){Ph[d&511](a,n,4);if((c&768|0)==768){m=19;break}else break}else Ucb(a,413195);while(0);if((m|0)==19){n=0;r=o;return n|0}if(((l[n+1>>0]|0)<<16|(l[n>>0]|0)<<24|(l[n+2>>0]|0)<<8|(l[n+3>>0]|0)|0)==(k[a+404>>2]|0)){n=0;r=o;return n|0}c=k[b>>2]|0;b=k[f>>2]|0;if(!(c&536870912)){if(!(b&1024))Ycb(a,413705)}else if(b&512|0)Ycb(a,413705);Xcb(c,n,413705);Vcb(a,n);n=1;r=o;return n|0}function gdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0;o=r;r=r+16|0;n=o;d=a+208|0;e=k[d>>2]|0;if(e&1|0)Ycb(a,413715);if((c|0)!=13)Ycb(a,413728);k[d>>2]=e|1;c=k[a+184>>2]|0;if(!c)Ucb(a,413195);Ph[c&511](a,n,13);m=k[a+212>>2]|0;if((k[a+376>>2]&536870912|0)==0?(m&2048|0)==0:(m&768|0)!=768){m=a+404|0;j=yeb(k[m>>2]|0,n,13)|0;k[m>>2]=j}fdb(a,0)|0;e=(l[n+1>>0]|0)<<16|(l[n>>0]|0)<<24|(l[n+2>>0]|0)<<8|(l[n+3>>0]|0);if((e|0)<0)Ucb(a,413598);f=(l[n+5>>0]|0)<<16|(l[n+4>>0]|0)<<24|(l[n+6>>0]|0)<<8|(l[n+7>>0]|0);if((f|0)<0)Ucb(a,413598);s=i[n+8>>0]|0;g=s&255;c=i[n+9>>0]|0;h=c&255;p=i[n+10>>0]|0;j=p&255;q=i[n+11>>0]|0;m=q&255;n=i[n+12>>0]|0;d=n&255;k[a+348>>2]=e;k[a+352>>2]=f;i[a+428>>0]=s;i[a+424>>0]=n;i[a+427>>0]=c;i[a+680>>0]=q;i[a+712>>0]=p;switch(c<<24>>24){case 6:{i[a+431>>0]=4;c=4;break}case 4:{i[a+431>>0]=2;c=2;break}case 2:{i[a+431>>0]=3;c=3;break}default:{i[a+431>>0]=1;c=1}}c=aa(c,g)|0;i[a+430>>0]=c;c=c&255;if(c>>>0>7){q=aa(c>>>3,e)|0;s=a+364|0;k[s>>2]=q;Ndb(a,b,e,f,g,h,d,j,m);r=o;return}else{q=((aa(c,e)|0)+7|0)>>>3;s=a+364|0;k[s>>2]=q;Ndb(a,b,e,f,g,h,d,j,m);r=o;return}}function hdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+992|0;y=A+768|0;u=A;d=a+208|0;e=k[d>>2]|0;if(!(e&1))Ycb(a,413736);if(e&2|0)Ycb(a,413749);if(e&4|0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,y,413715);Vcb(a,y);r=A;return}k[d>>2]=e|2;q=a+427|0;d=i[q>>0]|0;if(!(d&2)){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413759);Xcb(k[a+376>>2]|0,y,413759);Vcb(a,y);r=A;return}if(!(c>>>0<769&((c>>>0)%3|0|0)==0)){fdb(a,c)|0;if((i[q>>0]|0)==3)Ycb(a,413728);if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,y,413728);Vcb(a,y);r=A;return}e=(c|0)/3|0;if(d<<24>>24==3)d=1<<l[a+428>>0];else d=256;s=(e|0)>(d|0)?d:e;t=(s|0)>0;a:do if(t){f=y+1|0;g=y+2|0;h=a+184|0;m=a+376|0;n=a+212|0;o=a+404|0;d=0;e=u;while(1){p=k[h>>2]|0;if(!p)break;Ph[p&511](a,y,3);p=k[n>>2]|0;if((k[m>>2]&536870912|0)==0?(p&2048|0)==0:(p&768|0)!=768){p=yeb(k[o>>2]|0,y,3)|0;k[o>>2]=p}i[e>>0]=i[y>>0]|0;i[e+1>>0]=i[f>>0]|0;i[e+2>>0]=i[g>>0]|0;d=d+1|0;if((d|0)>=(s|0))break a;else e=e+3|0}Ucb(a,413195)}while(0);fdb(a,(aa(s,-3)|0)+c|0)|0;h=(b|0)==0;do if(!((a|0)==0|h)){if((i[q>>0]|0)==3)d=1<<l[a+428>>0];else d=256;if((s|0)<0|(d|0)<(s|0))if((i[b+25>>0]|0)==3)Ucb(a,415250);else{Vcb(a,415250);break}if((s|0)==0?(k[a+676>>2]&1|0)==0:0)Ucb(a,415273);g=b+232|0;d=k[g>>2]|0;if(d&4096){d=b+16|0;e=k[d>>2]|0;do if(e|0){f=k[a+692>>2]|0;if(!f){ggb(e);break}else{jh[f&1023](a,e);break}}while(0);k[d>>2]=0;d=b+8|0;k[d>>2]=k[d>>2]&-9;j[b+20>>1]=0;d=k[g>>2]|0}k[g>>2]=d&-4097;d=k[a+688>>2]|0;if(!d)d=fgb(768)|0;else d=Hh[d&511](a,768)|0;if(!d)Ucb(a,412758);zpb(d|0,0,768)|0;k[a+408>>2]=d;if(t)upb(d|0,u|0,s*3|0)|0;k[b+16>>2]=d;u=s&65535;j[a+412>>1]=u;j[b+20>>1]=u;u=b+232|0;k[u>>2]=k[u>>2]|4096;u=b+8|0;k[u>>2]=k[u>>2]|8}while(0);f=a+420|0;do if(!(j[f>>1]|0)){if(h){r=A;return}d=b+8|0;e=k[d>>2]|0;if(!(e&16)){v=d;w=e}else{j[f>>1]=0;z=58}}else{j[f>>1]=0;if(!h){d=b+8|0;z=58;break}if(!(k[a+212>>2]&1048576))Ycb(a,413784);Xcb(k[a+376>>2]|0,y,413784);Vcb(a,y);r=A;return}while(0);do if((z|0)==58){j[b+22>>1]=0;if(!(k[a+212>>2]&1048576))Ycb(a,413784);else{Xcb(k[a+376>>2]|0,y,413784);Vcb(a,y);v=d;w=k[d>>2]|0;break}}while(0);do if(w&64)if(!(k[a+212>>2]&1048576))Ycb(a,413803);else{Xcb(k[a+376>>2]|0,y,413803);Vcb(a,y);x=k[v>>2]|0;break}else x=w;while(0);if(!(x&32)){r=A;return}if(!(k[a+212>>2]&1048576))Ycb(a,413822);Xcb(k[a+376>>2]|0,y,413822);Vcb(a,y);r=A;return}function idb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0.0,o=0,p=0,q=0;q=r;r=r+224|0;o=q+4|0;e=q;f=a+208|0;d=k[f>>2]|0;if(!(d&1))Ycb(a,413736);if(d&6|0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,o,413715);Vcb(a,o);r=q;return}if((c|0)!=4){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,o,413728);Vcb(a,o);r=q;return}c=k[a+184>>2]|0;if(!c)Ucb(a,413195);Ph[c&511](a,e,4);i=a+376|0;m=a+212|0;h=k[m>>2]|0;if((k[i>>2]&536870912|0)==0?(h&2048|0)==0:(h&768|0)!=768){h=a+404|0;g=yeb(k[h>>2]|0,e,4)|0;k[h>>2]=g}if(fdb(a,0)|0){r=q;return}g=(l[e+1>>0]|0)<<16|(l[e>>0]|0)<<24|(l[e+2>>0]|0)<<8|(l[e+3>>0]|0);g=(g|0)>-1?g:-1;a:do if((g+-16|0)>>>0<=624999984){h=(k[f>>2]&32768|0)==0;d=a+866|0;c=j[d>>1]|0;if(h|(c&8)==0){if(c<<16>>16>=0){e=a+792|0;do if(c&1){f=k[e>>2]|0;if((!((g|0)==0|(f|0)==0)?(n=+O(+(+(f|0)*1.0e5/+(g|0)+.5)),n<=2147483647.0&n>=-2147483648.0):0)?(~~n+-95e3|0)>>>0<=1e4:0)break;if(c&32){Zcb(a,411111,2);break a}if(!h){Xcb(k[i>>2]|0,o,411068);Vcb(a,o);break}if(!(k[m>>2]&2097152))Ucb(a,411068);else{Vcb(a,411068);break}}while(0);k[e>>2]=g;j[d>>1]=c&65535|9}}else{e=413749;p=32}}else{c=a+866|0;e=411143;d=c;c=j[c>>1]|0;p=32}while(0);do if((p|0)==32){j[d>>1]=c&65535|32768;if(k[f>>2]&32768|0){Xcb(k[i>>2]|0,o,e);Vcb(a,o);break}if(!(k[m>>2]&4194304))Ucb(a,e);else{Vcb(a,e);break}}while(0);Mcb(a,b);r=q;return}function jdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+224|0;q=w+4|0;t=w;d=k[a+208>>2]|0;if(!(d&1))Ycb(a,413736);if(d&6|0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,q,413715);Vcb(a,q);r=w;return}v=(b|0)==0;if(!v?k[b+8>>2]&2|0:0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413749);Xcb(k[a+376>>2]|0,q,413749);Vcb(a,q);r=w;return}p=a+427|0;if((i[p>>0]|0)==3){n=8;d=3}else{n=i[a+428>>0]|0;d=l[a+431>>0]|0}if(c>>>0>4|(d|0)!=(c|0)){if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,q,413728);Vcb(a,q);fdb(a,c)|0;r=w;return}o=t+3|0;s=t+2|0;u=t+1|0;zpb(t|0,n|0,4)|0;d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,t,c);j=a+376|0;m=a+212|0;h=k[m>>2]|0;if(c|0?((k[j>>2]&536870912|0)==0?(h&2048|0)==0:(h&768|0)!=768):0){h=a+404|0;e=t;f=k[h>>2]|0;g=c;while(1){d=(g|0)==0?-1:g;f=yeb(f,e,d)|0;g=g-d|0;if(!g)break;else e=e+d|0}k[h>>2]=f}if(fdb(a,0)|0){r=w;return}a:do if(c|0){d=0;while(1){if(((i[t+d>>0]|0)+-1&255)>=(n&255))break;d=d+1|0;if(d>>>0>=c>>>0)break a}if(!(k[m>>2]&1048576))Ycb(a,413728);Xcb(k[j>>2]|0,q,413728);Vcb(a,q);r=w;return}while(0);h=i[t>>0]|0;if(!(i[p>>0]&2)){i[a+511>>0]=h;g=i[u>>0]|0;f=h;d=h}else{g=i[o>>0]|0;f=i[s>>0]|0;d=i[u>>0]|0}e=a+508|0;i[e>>0]=h;i[a+509>>0]=d;i[a+510>>0]=f;i[a+512>>0]=g;if((a|0)==0|v){r=w;return}a=b+148|0;i[a>>0]=i[e>>0]|0;i[a+1>>0]=i[e+1>>0]|0;i[a+2>>0]=i[e+2>>0]|0;i[a+3>>0]=i[e+3>>0]|0;i[a+4>>0]=i[e+4>>0]|0;b=b+8|0;k[b>>2]=k[b>>2]|2;r=w;return}function kdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0.0,h=0,i=0,n=0,o=0.0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0;S=r;r=r+288|0;P=S+32|0;f=S+248|0;Q=S;e=k[a+208>>2]|0;if(!(e&1))Ycb(a,413736);if(e&6|0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,P,413715);Vcb(a,P);r=S;return}if((c|0)!=32){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,P,413728);Vcb(a,P);r=S;return}c=k[a+184>>2]|0;if(!c)Ucb(a,413195);Ph[c&511](a,f,32);c=a+376|0;e=a+212|0;N=k[e>>2]|0;if((k[c>>2]&536870912|0)==0?(N&2048|0)==0:(N&768|0)!=768){N=a+404|0;M=yeb(k[N>>2]|0,f,32)|0;k[N>>2]=M}if(fdb(a,0)|0){r=S;return}N=(l[f+1>>0]|0)<<16|(l[f>>0]|0)<<24|(l[f+2>>0]|0)<<8|(l[f+3>>0]|0);C=Q+24|0;k[C>>2]=(N|0)>-1?N:-1;N=(l[f+5>>0]|0)<<16|(l[f+4>>0]|0)<<24|(l[f+6>>0]|0)<<8|(l[f+7>>0]|0);z=Q+28|0;k[z>>2]=(N|0)>-1?N:-1;N=(l[f+9>>0]|0)<<16|(l[f+8>>0]|0)<<24|(l[f+10>>0]|0)<<8|(l[f+11>>0]|0);k[Q>>2]=(N|0)>-1?N:-1;N=(l[f+13>>0]|0)<<16|(l[f+12>>0]|0)<<24|(l[f+14>>0]|0)<<8|(l[f+15>>0]|0);N=(N|0)>-1?N:-1;h=Q+4|0;k[h>>2]=N;D=(l[f+17>>0]|0)<<16|(l[f+16>>0]|0)<<24|(l[f+18>>0]|0)<<8|(l[f+19>>0]|0);D=(D|0)>-1?D:-1;k[Q+8>>2]=D;G=(l[f+21>>0]|0)<<16|(l[f+20>>0]|0)<<24|(l[f+22>>0]|0)<<8|(l[f+23>>0]|0);G=(G|0)>-1?G:-1;k[Q+12>>2]=G;H=(l[f+25>>0]|0)<<16|(l[f+24>>0]|0)<<24|(l[f+26>>0]|0)<<8|(l[f+27>>0]|0);H=(H|0)>-1?H:-1;k[Q+16>>2]=H;J=(l[f+29>>0]|0)<<16|(l[f+28>>0]|0)<<24|(l[f+30>>0]|0)<<8|(l[f+31>>0]|0);J=(J|0)>-1?J:-1;k[Q+20>>2]=J;f=k[C>>2]|0;z=k[z>>2]|0;C=k[Q>>2]|0;if((J|0)==-1|((f|0)==-1|(z|0)==-1|(C|0)==-1|(N|0)==-1|(D|0)==-1|(G|0)==-1|(H|0)==-1)){if(!(k[e>>2]&1048576))Ycb(a,413841);Xcb(k[c>>2]|0,P,413841);Vcb(a,P);r=S;return}M=a+866|0;N=m[M>>1]|0;if(N&32768|0){r=S;return}if(N&16|0){j[M>>1]=N|32768;Mcb(a,b);if(!(k[e>>2]&1048576))Ycb(a,413749);Xcb(k[c>>2]|0,P,413749);Vcb(a,P);r=S;return}L=N|16;j[M>>1]=L;a:do if((((C>>>0<=1e5?(E=k[h>>2]|0,F=1e5-C|0,!((E|0)<0|(F|0)<(E|0)|D>>>0>1e5)):0)?(I=1e5-D|0,!((G|0)<0|(I|0)<(G|0)|H>>>0>1e5)):0)?(K=1e5-H|0,!((J|0)<0|(K|0)<(J|0)|f>>>0>1e5)):0)?!((z|0)<5|(z|0)>(1e5-f|0)):0){c=D-H|0;t=E-J|0;e=(c|0)==0;u=(t|0)==0;do if(!(e|u)){d=+O(+(+(c|0)*+(t|0)/7.0+.5));if(d<=2147483647.0&d>=-2147483648.0){q=~~d;break}else{w=N|32784;w=w&65535;j[M>>1]=w;Ucb(a,411219)}}else q=0;while(0);i=G-J|0;v=C-H|0;n=(i|0)==0;w=(v|0)==0;do if(!(w|n)){d=+O(+(+(v|0)*+(i|0)/7.0+.5));if(d<=2147483647.0&d>=-2147483648.0){p=~~d;break}else{s=N|32784;s=s&65535;j[M>>1]=s;Ucb(a,411219)}}else p=0;while(0);s=q-p|0;p=z-J|0;q=(p|0)==0;do if(!(e|q)){d=+O(+(+(c|0)*+(p|0)/7.0+.5));if(d<=2147483647.0&d>=-2147483648.0){y=~~d;break}else{h=N|32784;h=h&65535;j[M>>1]=h;Ucb(a,411219)}}else y=0;while(0);f=f-H|0;h=(f|0)==0;do if(!(n|h)){d=+O(+(+(i|0)*+(f|0)/7.0+.5));if(d<=2147483647.0&d>=-2147483648.0){x=~~d;break}else{n=N|32784;n=n&65535;j[M>>1]=n;Ucb(a,411219)}}else x=0;while(0);c=y-x|0;if(c){e=(z|0)==0|(s|0)==0;if(e)i=0;else{d=+O(+(+(z|0)*+(s|0)/+(c|0)+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}i=~~d}if((i|0)<=(z|0)){R=115;break}do if(!(u|h)){d=+O(+(+(t|0)*+(f|0)/7.0+.5));if(d<=2147483647.0&d>=-2147483648.0){B=~~d;break}else{y=N|32784;y=y&65535;j[M>>1]=y;Ucb(a,411219)}}else B=0;while(0);do if(!(w|q)){d=+O(+(+(v|0)*+(p|0)/7.0+.5));if(d<=2147483647.0&d>=-2147483648.0){A=~~d;break}else{y=N|32784;y=y&65535;j[M>>1]=y;Ucb(a,411219)}}else A=0;while(0);c=B-A|0;if(!c){R=115;break}if(e)e=0;else{d=+O(+(+(z|0)*+(s|0)/+(c|0)+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}e=~~d}if((e|0)<=(z|0)){R=115;break}U=+O(+(1.0e10/+(z|0)+.5));g=+(i|0);T=+O(+(1.0e10/g+.5));o=+(e|0);d=+O(+(1.0e10/o+.5));f=(U<=2147483647.0&U>=-2147483648.0?~~U:0)-(T<=2147483647.0&T>=-2147483648.0?~~T:0)+(d<=2147483647.0&d>=-2147483648.0?0-~~d|0:0)|0;if((f|0)<1|(i|0)==0){R=115;break}if(!C)y=0;else{d=+O(+(+(C|0)*1.0e5/g+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}y=~~d}if(!E)x=0;else{d=+O(+(+(E|0)*1.0e5/g+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}x=~~d}c=F-E|0;if(!c)w=0;else{d=+O(+(+(c|0)*1.0e5/g+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}w=~~d}if(!e){R=115;break}if(!D)v=0;else{d=+O(+(+(D|0)*1.0e5/o+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}v=~~d}if(!G)u=0;else{d=+O(+(+(G|0)*1.0e5/o+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}u=~~d}c=I-G|0;if(!c)t=0;else{d=+O(+(+(c|0)*1.0e5/o+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}t=~~d}if(!H)s=0;else{d=+O(+(+(f|0)*+(H|0)/1.0e5+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}s=~~d}if(!J)q=0;else{d=+O(+(+(f|0)*+(J|0)/1.0e5+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}q=~~d}c=K-J|0;if(!c)p=0;else{d=+O(+(+(f|0)*+(c|0)/1.0e5+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}p=~~d}h=x+y+w|0;if(!h){R=115;break}if(!y)c=0;else{d=+O(+(+(y|0)*1.0e5/+(h|0)+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}c=~~d}k[P>>2]=c;e=P+4|0;if(!x)c=0;else{d=+O(+(+(x|0)*1.0e5/+(h|0)+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}c=~~d}k[e>>2]=c;f=u+v+t|0;e=P+8|0;if(!f){R=115;break}if(!v)c=0;else{d=+O(+(+(v|0)*1.0e5/+(f|0)+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}c=~~d}k[e>>2]=c;e=P+12|0;if(!u)c=0;else{d=+O(+(+(u|0)*1.0e5/+(f|0)+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}c=~~d}k[e>>2]=c;f=f+h|0;i=v+y|0;n=u+x|0;h=q+s+p|0;e=P+16|0;if(!h){R=115;break}if(!s)c=0;else{d=+O(+(+(s|0)*1.0e5/+(h|0)+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}c=~~d}k[e>>2]=c;e=P+20|0;if(!q)c=0;else{d=+O(+(+(q|0)*1.0e5/+(h|0)+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}c=~~d}k[e>>2]=c;f=f+h|0;c=i+s|0;e=P+24|0;if(!f){R=115;break}if(!c)c=0;else{d=+O(+(+(c|0)*1.0e5/+(f|0)+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}c=~~d}k[e>>2]=c;c=n+q|0;e=P+28|0;if(!c)c=0;else{d=+O(+(+(c|0)*1.0e5/+(f|0)+.5));if(!(d<=2147483647.0&d>=-2147483648.0)){R=115;break}c=~~d}k[e>>2]=c;if(!(Ncb(Q,P,5)|0)){R=123;break}if(N&32768|0)break;c=a+796|0;do if(N&2|0){if(Ncb(Q,c,100)|0)break;j[M>>1]=N|32784;Wcb(a,411168);break a}while(0);k[c>>2]=k[Q>>2];k[c+4>>2]=k[Q+4>>2];k[c+8>>2]=k[Q+8>>2];k[c+12>>2]=k[Q+12>>2];k[c+16>>2]=k[Q+16>>2];k[c+20>>2]=k[Q+20>>2];k[c+24>>2]=k[Q+24>>2];k[c+28>>2]=k[Q+28>>2];k[a+828>>2]=y;k[a+832>>2]=x;k[a+836>>2]=w;k[a+840>>2]=v;k[a+844>>2]=u;k[a+848>>2]=t;k[a+852>>2]=s;k[a+856>>2]=q;k[a+860>>2]=p;Q=(Ncb(Q,156024,1e3)|0)==0;j[M>>1]=Q?L&65469|2:N|82}else R=115}else R=115;while(0);if((R|0)==115)R=123;if((R|0)==123){j[M>>1]=N|32784;Wcb(a,411196)}Mcb(a,b);r=S;return}function ldb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=r;r=r+224|0;g=i+2|0;h=i;d=k[a+208>>2]|0;if(!(d&1))Ycb(a,413736);if(d&6|0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,g,413715);Vcb(a,g);r=i;return}if((c|0)!=1){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,g,413728);Vcb(a,g);r=i;return}c=k[a+184>>2]|0;if(!c)Ucb(a,413195);Ph[c&511](a,h,1);c=a+376|0;d=a+212|0;f=k[d>>2]|0;if((k[c>>2]&536870912|0)==0?(f&2048|0)==0:(f&768|0)!=768){f=a+404|0;e=yeb(k[f>>2]|0,h,1)|0;k[f>>2]=e}if(fdb(a,0)|0){r=i;return}e=a+866|0;f=m[e>>1]|0;if(f&32768|0){r=i;return}if(!(f&4)){Ocb(a,a+792|0,l[h>>0]|0);Mcb(a,b);r=i;return}j[e>>1]=f|32768;Mcb(a,b);if(!(k[d>>2]&1048576))Ycb(a,413856);Xcb(k[c>>2]|0,g,413856);Vcb(a,g);r=i;return}function mdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;T=r;r=r+1664|0;q=T+1460|0;S=T+1246|0;Q=T+4|0;O=T+1164|0;s=T+1032|0;t=T+8|0;u=T;k[Q>>2]=c;N=a+208|0;d=k[N>>2]|0;if(!(d&1))Ycb(a,413736);if(d&6|0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,S,413715);Vcb(a,S);r=T;return}if(c>>>0<9){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413874);Xcb(k[a+376>>2]|0,S,413874);Vcb(a,S);r=T;return}M=a+792|0;R=a+866|0;d=m[R>>1]|0;if(d&32768|0){fdb(a,c)|0;r=T;return}a:do if(!(d&4)){n=c>>>0<81?c:81;d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,O,n);K=a+376|0;L=a+212|0;J=k[L>>2]|0;if(n|0?((k[K>>2]&536870912|0)==0?(J&2048|0)==0:(J&768|0)!=768):0){h=a+404|0;e=O;f=k[h>>2]|0;g=n;while(1){d=(g|0)==0?-1:g;f=yeb(f,e,d)|0;g=g-d|0;if(!g)break;else e=e+d|0}k[h>>2]=f}c=c-n|0;k[Q>>2]=c;d=0;do{if(!(i[O+d>>0]|0))break;d=d+1|0}while(d>>>0<80&d>>>0<n>>>0);do if((d+-1|0)>>>0<79){J=d+1|0;if(J>>>0<n>>>0?(i[O+J>>0]|0)==0:0){d=d+2|0;if(ndb(a,1766015824)|0){d=k[a+248>>2]|0;break}k[u>>2]=132;k[a+224>>2]=O+d;k[a+228>>2]=n-d;odb(a,t,Q,s,u,0);b:do if(!(k[u>>2]|0)){d=l[s+3>>0]|0;I=l[s+1>>0]<<16|l[s>>0]<<24|l[s+2>>0]<<8|d;if(I>>>0<132){Pcb(a,M,O,I,413874);c=0;d=0;P=155;break}g=l[a+427>>0]|0;if(!((d&3|0)==0|(l[s+8>>0]|0)<4)){Pcb(a,M,O,I,411398);c=0;d=0;P=155;break}h=s+128|0;n=s+129|0;o=s+130|0;p=s+131|0;d=l[n>>0]<<16|l[h>>0]<<24|l[o>>0]<<8|l[p>>0];if(d>>>0<=357913930?((d*12|0)+132|0)>>>0<=I>>>0:0){d=l[s+65>>0]<<16|l[s+64>>0]<<24|l[s+66>>0]<<8|l[s+67>>0];if(d>>>0>65534){Pcb(a,M,O,d,411433);c=0;d=0;P=155;break}if(d>>>0>3)Pcb(a,0,O,d,411458);d=l[s+37>>0]<<16|l[s+36>>0]<<24|l[s+38>>0]<<8|l[s+39>>0];if((d|0)!=1633907568){Pcb(a,M,O,d,411487);c=0;d=0;P=155;break}d=i[s+68>>0]|0;do if(!(d<<24>>24)){d=i[s+69>>0]|0;if(d<<24>>24){c=0;P=43;break}d=i[s+70>>0]|0;if(d<<24>>24!=-10){c=246;P=43;break}d=i[s+71>>0]|0;if(d<<24>>24!=-42){c=214;P=43;break}d=i[s+72>>0]|0;if(d<<24>>24){c=0;P=43;break}d=i[s+73>>0]|0;if(d<<24>>24!=1){c=1;P=43;break}d=i[s+74>>0]|0;if(d<<24>>24){c=0;P=43;break}d=i[s+75>>0]|0;if(d<<24>>24){c=0;P=43;break}d=i[s+76>>0]|0;if(d<<24>>24){c=0;P=43;break}d=i[s+77>>0]|0;if(d<<24>>24){c=0;P=43;break}d=i[s+78>>0]|0;if(d<<24>>24!=-45){c=211;P=43;break}d=i[s+79>>0]|0;if(d<<24>>24!=45){c=45;P=43}}else{c=0;P=43}while(0);do if((P|0)==43){if((d&255|0)==(c|0))break;i[q>>0]=112;i[q+1>>0]=114;i[q+2>>0]=111;i[q+3>>0]=102;i[q+4>>0]=105;i[q+5>>0]=108;i[q+6>>0]=101;i[q+7>>0]=32;i[q+8>>0]=39;i[q+9>>0]=0;d=i[O>>0]|0;do if(d<<24>>24){e=9;f=O;c=d;while(1){f=f+1|0;d=e+1|0;i[q+e>>0]=c;c=i[f>>0]|0;if(!(d>>>0<87&c<<24>>24!=0))break;else e=d}i[q+d>>0]=0;if(d>>>0>=196)break;if((d|0)==195){d=195;P=50}else{e=411390;f=39;P=49}}else{i[q+9>>0]=0;d=9;e=411390;f=39;P=49}while(0);if((P|0)==49)while(1){e=e+1|0;c=d+1|0;i[q+d>>0]=f;f=i[e>>0]|0;if(!(c>>>0<195&f<<24>>24!=0)){d=c;P=50;break}else{d=c;P=49}}if((P|0)==50)i[q+d>>0]=0;c=S+23|0;i[c>>0]=0;f=0;e=0;while(1){if((f|0)>=1)break;c=c+-1|0;i[c>>0]=48;if(c>>>0>S>>>0){f=f+1|0;e=48}else{e=48;break}}c:do if(d>>>0<196){if((d|0)!=195&e<<24>>24!=0){do{c=c+1|0;H=d;d=d+1|0;i[q+H>>0]=e;e=i[c>>0]|0}while(d>>>0<195&e<<24>>24!=0);i[q+d>>0]=0;if(d>>>0>=196){P=62;break}}else i[q+d>>0]=0;do if((d|0)==195){i[q+195>>0]=0;d=195}else{c=411394;e=104;do{c=c+1|0;H=d;d=d+1|0;i[q+H>>0]=e;e=i[c>>0]|0}while(d>>>0<195&e<<24>>24!=0);i[q+d>>0]=0;if(d>>>0>=196)break c;if((d|0)==195){d=195;break}else{c=411505;f=80}while(1){c=c+1|0;e=d+1|0;i[q+d>>0]=f;f=i[c>>0]|0;if(!(e>>>0<195&f<<24>>24!=0)){d=e;break}else d=e}}while(0);i[q+d>>0]=0}else P=62;while(0);do if(!(k[N>>2]&32768))if(!(k[L>>2]&4194304))Ucb(a,q);else{Vcb(a,q);break}else{Xcb(k[K>>2]|0,S,q);Vcb(a,S)}while(0)}while(0);d=l[s+17>>0]<<16|l[s+16>>0]<<24|l[s+18>>0]<<8|l[s+19>>0];d:do if((d|0)<1380401696){switch(d|0){case 1196573017:break;default:{P=78;break d}}if(!(g&2))break;Pcb(a,M,O,1196573017,411578);c=0;d=0;P=155;break b}else{switch(d|0){case 1380401696:break;default:{P=78;break d}}if(g&2|0)break;Pcb(a,M,O,1380401696,411531);c=0;d=0;P=155;break b}while(0);if((P|0)==78){Pcb(a,M,O,d,411620);c=0;d=0;P=155;break}d=l[s+13>>0]<<16|l[s+12>>0]<<24|l[s+14>>0]<<8|l[s+15>>0];e:do if((d|0)<1852662636){if((d|0)<1818848875){switch(d|0){case 1633842036:break;default:{P=83;break e}}Pcb(a,M,O,1633842036,411652);c=0;d=0;P=155;break b}if((d|0)>=1835955314)switch(d|0){case 1835955314:break e;default:{P=83;break e}}switch(d|0){case 1818848875:break;default:{P=83;break e}}Pcb(a,M,O,1818848875,411690);c=0;d=0;P=155;break b}else{if((d|0)>=1935896178)if((d|0)<1936744803)switch(d|0){case 1935896178:break e;default:{P=83;break e}}else switch(d|0){case 1936744803:break e;default:{P=83;break e}}if((d|0)>=1886549106)switch(d|0){case 1886549106:break e;default:{P=83;break e}}switch(d|0){case 1852662636:break;default:{P=83;break e}}Pcb(a,0,O,1852662636,411730)}while(0);if((P|0)==83)Pcb(a,0,O,d,411770);d=l[s+21>>0]<<16|l[s+20>>0]<<24|l[s+22>>0]<<8|l[s+23>>0];if((d|0)<1482250784)switch(d|0){case 1281450528:break;default:P=85}else switch(d|0){case 1482250784:break;default:P=85}if((P|0)==85){Pcb(a,M,O,d,411801);c=0;d=0;P=155;break}h=i[h>>0]|0;g=i[n>>0]|0;f=i[o>>0]|0;e=i[p>>0]|0;H=a+756|0;c=k[H>>2]|0;do if(c){d=a+760|0;if((k[d>>2]|0)>>>0>=I>>>0){G=c;break}k[H>>2]=0;k[d>>2]=0;d=k[a+692>>2]|0;if(!d){ggb(c);d=a;P=92;break}else{jh[d&1023](a,c);d=a;P=92;break}}else{d=a;P=92}while(0);if((P|0)==92){if(!I){c=0;d=418736;P=155;break}c=k[a+688>>2]|0;if(!c)d=fgb(I)|0;else d=Hh[c&511](d,I)|0;if(!d){c=0;d=418736;P=155;break}k[H>>2]=d;k[a+760>>2]=I;G=d}upb(G|0,s|0,132)|0;e=((g&255)<<16|(h&255)<<24|(f&255)<<8|e&255)*12|0;k[u>>2]=e;f=G+132|0;odb(a,t,Q,f,u,0);if(k[u>>2]|0){c=0;d=k[a+248>>2]|0;P=155;break}g=l[G+129>>0]<<16|l[G+128>>0]<<24|l[G+130>>0]<<8|l[G+131>>0];f:do if(g|0){d=0;c=f;while(1){h=l[c+1>>0]<<16|l[c>>0]<<24|l[c+2>>0]<<8|l[c+3>>0];F=l[c+7>>0]|0;n=l[c+5>>0]<<16|l[c+4>>0]<<24|l[c+6>>0]<<8|F;o=l[c+9>>0]<<16|l[c+8>>0]<<24|l[c+10>>0]<<8|l[c+11>>0];if(F&3|0)Pcb(a,0,O,h,411829);if(I>>>0<n>>>0|o>>>0>(I-n|0)>>>0)break;d=d+1|0;if(d>>>0>=g>>>0)break f;else c=c+12|0}Pcb(a,M,O,h,411871);c=0;d=0;P=155;break b}while(0);k[u>>2]=I+-132-e;odb(a,t,Q,f+e|0,u,1);d=k[Q>>2]|0;c=(d|0)==0;if(!c?(k[L>>2]&1048576|0)==0:0){c=0;d=413884;P=155;break}if(k[u>>2]|0){c=0;d=413906;P=155;break}if(!c)if(!a)Vcb(0,413884);else{Xcb(k[K>>2]|0,S,413884);Vcb(a,S)}fdb(a,d)|0;d=k[a+272>>2]|0;g:do if((i[a+612>>0]&48)!=48){g=l[G+85>>0]<<16|l[G+84>>0]<<24|l[G+86>>0]<<8|l[G+87>>0];h=G+88|0;n=G+89|0;o=G+90|0;p=G+91|0;q=G+92|0;s=G+93|0;t=G+94|0;u=G+95|0;v=G+96|0;w=G+97|0;x=G+98|0;y=G+99|0;z=G+1|0;A=G+2|0;B=G+3|0;C=G+64|0;D=G+65|0;E=G+66|0;F=G+67|0;c=65536;e=0;f=0;h:while(1){do if((g|0)==(k[156092+(f<<5)+12>>2]|0)){if((l[n>>0]<<16|l[h>>0]<<24|l[o>>0]<<8|l[p>>0]|0)!=(k[156092+(f<<5)+16>>2]|0))break;if((l[s>>0]<<16|l[q>>0]<<24|l[t>>0]<<8|l[u>>0]|0)!=(k[156092+(f<<5)+20>>2]|0))break;if((l[w>>0]<<16|l[v>>0]<<24|l[x>>0]<<8|l[y>>0]|0)!=(k[156092+(f<<5)+24>>2]|0))break;if(!e){c=l[D>>0]<<16|l[C>>0]<<24|l[E>>0]<<8|l[F>>0];e=l[z>>0]<<16|l[G>>0]<<24|l[A>>0]<<8|l[B>>0]}if((e|0)!=(k[156092+(f<<5)+8>>2]|0))break;if((c|0)==(m[156092+(f<<5)+30>>1]|0))break h}while(0);f=f+1|0;if(f>>>0>=7)break g}if(!d)d=xeb(1,G,e)|0;do if((d|0)==(k[156092+(f<<5)>>2]|0)){B=yeb(0,G,e)|0;if((B|0)!=(k[156092+(f<<5)+4>>2]|0))break;do if((f+-5|0)>>>0>=2){if((f+-4|0)>>>0>=3)break;if(k[N>>2]&32768|0){Xcb(k[K>>2]|0,S,411932);Vcb(a,S);break}if(!(k[L>>2]&2097152))Ucb(a,411932);else{Vcb(a,411932);break}}else Zcb(a,411903,2);while(0);Ocb(a,M,l[D>>0]<<16|l[C>>0]<<24|l[E>>0]<<8|l[F>>0]);break g}while(0);if(k[N>>2]&32768|0){Xcb(k[K>>2]|0,S,411975);Vcb(a,S);break}if(!(k[L>>2]&2097152))Ucb(a,411975);else{Vcb(a,411975);break}}while(0);i:do if(b|0){Kcb(a,b,16,0);do if(!J)k[b+116>>2]=0;else{do if(!a)P=148;else{d=k[a+688>>2]|0;if(!d){P=148;break}d=Hh[d&511](a,J)|0}while(0);if((P|0)==148)d=fgb(J)|0;k[b+116>>2]=d;if(!d)break;upb(d|0,O|0,J|0)|0;k[b+124>>2]=I;k[b+120>>2]=G;k[H>>2]=0;O=b+232|0;k[O>>2]=k[O>>2]|16;O=b+8|0;k[O>>2]=k[O>>2]|4096;Mcb(a,b);break i}while(0);j[R>>1]=m[R>>1]|32768;Mcb(a,b);c=1;d=418736;P=155;break b}while(0);k[a+220>>2]=0;e=0;c=1;d=0;break}Pcb(a,M,O,d,411413);c=0;d=0;P=155}else{c=0;d=k[a+248>>2]|0;P=155}while(0);if((P|0)==155){k[a+220>>2]=0;e=1}if(!e){r=T;return}if(c|0)break a;c=k[Q>>2]|0;P=161;break a}else d=413928}else d=413916;while(0);P=161}else{d=413856;P=161}while(0);if((P|0)==161)fdb(a,c)|0;j[R>>1]=m[R>>1]|32768;Mcb(a,b);if(!d){r=T;return}if(!(k[a+212>>2]&1048576))Ycb(a,d);Xcb(k[a+376>>2]|0,S,d);Vcb(a,S);r=T;return}function ndb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+288|0;c=j+64|0;d=j;g=a+220|0;e=k[g>>2]|0;if(e|0){i[d>>0]=e>>>24;i[d+1>>0]=e>>>16;i[d+2>>0]=e>>>8;i[d+3>>0]=e;i[d+4>>0]=32;i[d+5>>0]=117;i[d+6>>0]=115;i[d+7>>0]=105;i[d+8>>0]=110;i[d+9>>0]=103;i[d+10>>0]=32;i[d+11>>0]=122;i[d+12>>0]=115;i[d+13>>0]=116;i[d+14>>0]=114;i[d+15>>0]=101;i[d+16>>0]=97;i[d+17>>0]=109;i[d+18>>0]=0;Xcb(k[a+376>>2]|0,c,d);Vcb(a,c);k[g>>2]=0}k[a+224>>2]=0;k[a+228>>2]=0;k[a+236>>2]=0;k[a+240>>2]=0;f=a+212|0;do if(!(k[f>>2]&2)){c=a+248|0;k[c>>2]=0;d=a+256|0;e=k[d>>2]|0;if(!e){k[d>>2]=151;k[a+264>>2]=0;e=151}d=a+260|0;if(!(k[d>>2]|0))k[d>>2]=851;d=ci[e&255](k[a+264>>2]|0,1,7116)|0;if(!d)d=-4;else{k[a+252>>2]=d;k[d+52>>2]=0;k[d+8>>2]=1;k[d+36>>2]=15;k[d+40>>2]=0;k[d+44>>2]=0;k[d+48>>2]=0;k[d+28>>2]=0;k[a+244>>2]=0;k[a+232>>2]=0;k[c>>2]=0;k[a+272>>2]=1;k[d>>2]=0;k[d+4>>2]=0;k[d+12>>2]=0;k[d+20>>2]=32768;k[d+32>>2]=0;k[d+56>>2]=0;k[d+60>>2]=0;h=d+1328|0;k[d+108>>2]=h;k[d+80>>2]=h;k[d+76>>2]=h;k[d+7104>>2]=1;k[d+7108>>2]=-1;k[f>>2]=k[f>>2]|2;h=15}}else{d=k[a+252>>2]|0;if(!d){d=-2;c=a+248|0;break}k[d+40>>2]=0;k[d+44>>2]=0;k[d+48>>2]=0;k[d+28>>2]=0;k[a+244>>2]=0;k[a+232>>2]=0;k[a+248>>2]=0;c=k[d+8>>2]|0;if(c|0)k[a+272>>2]=c&1;k[d>>2]=0;k[d+4>>2]=0;k[d+12>>2]=0;k[d+20>>2]=32768;k[d+32>>2]=0;k[d+56>>2]=0;k[d+60>>2]=0;h=d+1328|0;k[d+108>>2]=h;k[d+80>>2]=h;k[d+76>>2]=h;k[d+7104>>2]=1;k[d+7108>>2]=-1;h=15}while(0);if((h|0)==15){k[g>>2]=b;h=0;r=j;return h|0}if(k[c>>2]|0){h=d;r=j;return h|0}if((d|0)==-4){k[c>>2]=420017;h=-4;r=j;return h|0}else{k[c>>2]=410979;h=-2;r=j;return h|0}return 0}function odb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;t=a+376|0;if((k[a+220>>2]|0)!=(k[t>>2]|0)){k[a+248>>2]=413951;return}q=a+224|0;k[a+236>>2]=d;o=a+240|0;k[o>>2]=0;p=a+228|0;j=f|0?4:2;l=a+184|0;m=a+212|0;n=a+404|0;d=1024;while(1){if(!(k[p>>2]|0)){i=k[c>>2]|0;d=d>>>0>i>>>0?i:d;k[c>>2]=i-d;if(d|0){f=k[l>>2]|0;if(!f){u=6;break}Ph[f&511](a,b,d);i=k[m>>2]|0;if((k[t>>2]&536870912|0)==0?(i&2048|0)==0:(i&768|0)!=768){g=b;h=k[n>>2]|0;i=d;while(1){f=(i|0)==0?-1:i;h=yeb(h,g,f)|0;i=i-f|0;if(!i)break;else g=g+f|0}k[n>>2]=h}}k[q>>2]=b;k[p>>2]=d}if(!(k[o>>2]|0)){i=k[e>>2]|0;k[e>>2]=0;k[o>>2]=i}f=Neb(q,(k[c>>2]|0)==0?j:0)|0;if(f|0){u=15;break}if(k[e>>2]|0)continue;if(!(k[o>>2]|0)){v=0;r=0;s=0;break}}if((u|0)==6)Ucb(a,413195);else if((u|0)==15){v=f;r=k[o>>2]|0;s=k[e>>2]|0}k[e>>2]=s+r;k[o>>2]=0;d=a+248|0;if(k[d>>2]|0)return;do switch(v|0){case -7:{k[d>>2]=411045;return}case 1:{k[d>>2]=410915;return}case 2:{k[d>>2]=410943;return}case -1:{k[d>>2]=410965;return}case -2:{k[d>>2]=410979;return}case -3:{k[d>>2]=411002;return}case -4:{k[d>>2]=420017;return}case -5:{k[d>>2]=413906;return}case -6:{k[d>>2]=411020;return}default:{k[d>>2]=410887;return}}while(0)}function pdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+224|0;C=D;d=a+724|0;e=k[d>>2]|0;switch(e|0){case 0:break;case 1:{fdb(a,c)|0;r=D;return}default:A=3}if((A|0)==3?(B=e+-1|0,k[d>>2]=B,(B|0)==1):0){Vcb(a,413969);fdb(a,c)|0;r=D;return}B=a+208|0;d=k[B>>2]|0;if(!(d&1))Ycb(a,413736);if(d&4|0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,C,413715);Vcb(a,C);r=D;return}f=c+1|0;g=a+756|0;e=k[g>>2]|0;do if(e){d=a+760|0;if((k[d>>2]|0)>>>0<f>>>0){k[g>>2]=0;k[d>>2]=0;d=k[a+692>>2]|0;if(!d){ggb(e);d=a;A=17;break}else{jh[d&1023](a,e);d=a;A=17;break}}}else{d=a;A=17}while(0);do if((A|0)==17){if(f|0){e=k[a+688>>2]|0;if(!e)d=fgb(f)|0;else d=Hh[e&511](d,f)|0;if(d|0){k[g>>2]=d;k[a+760>>2]=f;e=d;break}}fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,418736);Xcb(k[a+376>>2]|0,C,418736);Vcb(a,C);r=D;return}while(0);d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,e,c);y=a+376|0;z=a+212|0;x=k[z>>2]|0;if(c|0?((k[y>>2]&536870912|0)==0?(x&2048|0)==0:(x&768|0)!=768):0){m=a+404|0;f=e;g=k[m>>2]|0;h=c;while(1){d=(h|0)==0?-1:h;g=yeb(g,f,d)|0;h=h-d|0;if(!h)break;else f=f+d|0}k[m>>2]=g}if(fdb(a,0)|0){r=D;return}f=e+c|0;i[f>>0]=0;d=e;while(1){g=d+1|0;if(!(i[d>>0]|0))break;else d=g}if(g>>>0>(f+-2|0)>>>0){Vcb(a,414002);r=D;return}f=d+2|0;n=i[g>>0]|0;m=n<<24>>24==8;u=m?6:10;q=e;s=q-f+c|0;if((s>>>0)%(u>>>0)|0|0){Vcb(a,414023);r=D;return}v=(s>>>0)/(u>>>0)|0;if(v>>>0>429496729){Vcb(a,414049);r=D;return}w=v*10|0;if(a|0){if(w|0){t=a+688|0;d=k[t>>2]|0;if(!d)x=fgb(w)|0;else x=Hh[d&511](a,w)|0;if(x|0){a:do if(u>>>0<=s>>>0){d=0;g=f;while(1){f=x+(d*10|0)|0;if(m){j[f>>1]=l[g>>0]|0;j[x+(d*10|0)+2>>1]=l[g+1>>0]|0;j[x+(d*10|0)+4>>1]=l[g+2>>0]|0;h=g+4|0;f=l[g+3>>0]|0}else{j[f>>1]=l[g>>0]<<8|l[g+1>>0];j[x+(d*10|0)+2>>1]=l[g+2>>0]<<8|l[g+3>>0];j[x+(d*10|0)+4>>1]=l[g+4>>0]<<8|l[g+5>>0];h=g+8|0;f=(l[g+6>>0]<<8|l[g+7>>0])&65535}j[x+(d*10|0)+6>>1]=f;j[x+(d*10|0)+8>>1]=l[h>>0]<<8|l[h+1>>0];d=d+1|0;if((d|0)>=(v|0))break a;g=h+2|0}}while(0);b:do if(b|0){c=b+244|0;h=k[c>>2]|0;p=b+248|0;g=k[p>>2]|0;if((g|0)<0)Ucb(a,412800);m=(g|0)!=0;if((h|0)==0&m)Ucb(a,412800);do if((g|0)!=2147483647){d=g+1|0;if(d>>>0>268435455)break;d=d<<4;if(!d)break;f=k[t>>2]|0;if(!f)o=fgb(d)|0;else o=Hh[f&511](a,d)|0;if(!o)break;d=g<<4;if(m)upb(o|0,h|0,d|0)|0;d=o+d|0;f=d+16|0;do{i[d>>0]=0;d=d+1|0}while((d|0)<(f|0));d=k[c>>2]|0;do if(d|0){f=k[a+692>>2]|0;if(!f){ggb(d);break}else{jh[f&1023](a,d);break}}while(0);k[c>>2]=o;m=b+232|0;k[m>>2]=k[m>>2]|32;m=k[p>>2]|0;h=b+8|0;if((e|0)==0|(x|0)==0)if(!(k[z>>2]&4194304))Ucb(a,415473);else{Vcb(a,415473);break b}i[o+(m<<4)+4>>0]=n;c:do if(!(q&3)){d=e;A=84}else{f=e;d=q;while(1){if(!(i[f>>0]|0))break c;f=f+1|0;d=f;if(!(d&3)){d=f;A=84;break}}}while(0);if((A|0)==84){while(1){f=k[d>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))d=d+4|0;else break}if((f&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}f=d-q+1|0;do if(!f){k[o+(m<<4)>>2]=0;A=107}else{d=k[t>>2]|0;if(!d)d=fgb(f)|0;else d=Hh[d&511](a,f)|0;g=o+(m<<4)|0;k[g>>2]=d;if(!d){A=107;break}upb(d|0,e|0,f|0)|0;if(u>>>0>s>>>0)Ucb(a,412772);d=k[t>>2]|0;if(!d)d=fgb(w)|0;else d=Hh[d&511](a,w)|0;k[o+(m<<4)+8>>2]=d;if(d|0){k[o+(m<<4)+12>>2]=v;upb(d|0,x|0,w|0)|0;k[h>>2]=k[h>>2]|8192;k[p>>2]=(k[p>>2]|0)+1;break}d=k[g>>2]|0;do if(d|0){e=k[a+692>>2]|0;if(!e){ggb(d);break}else{jh[e&1023](a,d);break}}while(0);k[g>>2]=0;A=107}while(0);do if((A|0)==107){if(k[B>>2]&32768|0){Xcb(k[y>>2]|0,C,415500);Vcb(a,C);break}if(!(k[z>>2]&4194304))Ucb(a,415500);else{Vcb(a,415500);break}}while(0);if(x|0)break b;r=D;return}while(0);if(k[B>>2]&32768|0){Xcb(k[y>>2]|0,C,415452);Vcb(a,C);break}if(!(k[z>>2]&4194304))Ucb(a,415452);else{Vcb(a,415452);break}}while(0);d=k[a+692>>2]|0;if(!d){ggb(x);r=D;return}else{jh[d&1023](a,x);r=D;return}}}Vcb(a,412758)}Vcb(a,414069);r=D;return}function qdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0;p=r;r=r+480|0;d=p+264|0;o=p+8|0;f=p;e=k[a+208>>2]|0;if(!(e&1))Ycb(a,413736);if(e&4|0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,d,413715);Vcb(a,d);r=p;return}n=(b|0)==0;if(!n?k[b+8>>2]&16|0:0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413749);Xcb(k[a+376>>2]|0,d,413749);Vcb(a,d);r=p;return}switch(i[a+427>>0]|0){case 0:{if((c|0)!=2){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,d,413728);Vcb(a,d);r=p;return}d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,f,2);c=k[a+212>>2]|0;if((k[a+376>>2]&536870912|0)==0?(c&2048|0)==0:(c&768|0)!=768){c=a+404|0;h=yeb(k[c>>2]|0,f,2)|0;k[c>>2]=h}d=a+420|0;j[d>>1]=1;j[a+532>>1]=l[f>>0]<<8|l[f+1>>0];break}case 2:{if((c|0)!=6){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,d,413728);Vcb(a,d);r=p;return}d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,f,6);c=k[a+212>>2]|0;if((k[a+376>>2]&536870912|0)==0?(c&2048|0)==0:(c&768|0)!=768){c=a+404|0;h=yeb(k[c>>2]|0,f,6)|0;k[c>>2]=h}d=a+420|0;j[d>>1]=1;j[a+526>>1]=l[f>>0]<<8|l[f+1>>0];j[a+528>>1]=l[f+2>>0]<<8|l[f+3>>0];j[a+530>>1]=l[f+4>>0]<<8|l[f+5>>0];break}case 3:{if(!(e&2)){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,d,413715);Vcb(a,d);r=p;return}if(c>>>0>256?1:(c+-1|0)>>>0>=(m[a+412>>1]|0)>>>0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,d,413728);Vcb(a,d);r=p;return}d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,o,c);h=k[a+212>>2]|0;if(c|0?((k[a+376>>2]&536870912|0)==0?(h&2048|0)==0:(h&768|0)!=768):0){h=a+404|0;e=o;f=k[h>>2]|0;g=c;while(1){d=(g|0)==0?-1:g;f=yeb(f,e,d)|0;g=g-d|0;if(!g)break;else e=e+d|0}k[h>>2]=f}d=a+420|0;j[d>>1]=c;break}default:{fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,414105);Xcb(k[a+376>>2]|0,d,414105);Vcb(a,d);r=p;return}}if(fdb(a,0)|0){j[d>>1]=0;r=p;return}f=j[d>>1]|0;e=f&65535;if((a|0)==0|n){r=p;return}Kcb(a,b,8192,0);d=k[a+688>>2]|0;if(!d)d=fgb(256)|0;else d=Hh[d&511](a,256)|0;if(!d)Ucb(a,412758);k[b+156>>2]=d;k[a+520>>2]=d;if((e+-1|0)>>>0<256)upb(d|0,o|0,e|0)|0;d=j[b+24>>1]|0;a:do if((d&255)<16){e=1<<(d&255);switch(((d&65535)>>>8&255)<<24>>24){case 0:{if((m[a+532>>1]|0)<(e|0))break a;break}case 2:{if(((m[a+526>>1]|0)<(e|0)?(m[a+528>>1]|0)<(e|0):0)?(m[a+530>>1]|0)<(e|0):0)break a;break}default:break a}Vcb(a,415402)}while(0);o=b+160|0;a=a+524|0;j[o>>1]=j[a>>1]|0;j[o+2>>1]=j[a+2>>1]|0;j[o+4>>1]=j[a+4>>1]|0;j[o+6>>1]=j[a+6>>1]|0;j[o+8>>1]=j[a+8>>1]|0;j[b+22>>1]=f<<16>>16==0?1:f;a=b+8|0;k[a>>2]=k[a>>2]|16;b=b+232|0;k[b>>2]=k[b>>2]|8192;r=p;return}function rdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+224|0;q=t+6|0;s=t;d=k[a+208>>2]|0;if(!(d&1))Ycb(a,413736);if((d&4|0)==0?(m=a+427|0,e=i[m>>0]|0,f=e<<24>>24==3,!((d&2|0)==0&f)):0){p=(b|0)!=0;if(p?k[b+8>>2]&32|0:0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413749);Xcb(k[a+376>>2]|0,q,413749);Vcb(a,q);r=t;return}if(((f?1:(e&2)<<1|2)|0)!=(c|0)){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,q,413728);Vcb(a,q);r=t;return}d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,s,c);n=a+376|0;o=a+212|0;h=k[o>>2]|0;if(c|0?((k[n>>2]&536870912|0)==0?(h&2048|0)==0:(h&768|0)!=768):0){h=a+404|0;f=s;g=k[h>>2]|0;e=c;while(1){d=(e|0)==0?-1:e;g=yeb(g,f,d)|0;e=e-d|0;if(!e)break;else f=f+d|0}k[h>>2]=g}if(fdb(a,0)|0){r=t;return}d=i[m>>0]|0;do if(d<<24>>24==3){e=i[s>>0]|0;if(!p){r=t;return}d=j[b+20>>1]|0;if(!(d<<16>>16)){g=0;h=0;c=0;d=0}else{f=e&255;if(f>>>0<(d&65535)>>>0){d=k[a+408>>2]|0;g=l[d+(f*3|0)+2>>0]|0;h=0;c=l[d+(f*3|0)>>0]|0;d=l[d+(f*3|0)+1>>0]|0;break}if(!(k[o>>2]&1048576))Ycb(a,414132);Xcb(k[n>>2]|0,q,414132);Vcb(a,q);r=t;return}}else{f=((l[s>>0]|0)<<8|(l[s+1>>0]|0))&65535;if(!(d&2)){e=0;g=f;h=f;c=f;d=f}else{e=0;g=((l[s+4>>0]|0)<<8|(l[s+5>>0]|0))&65535;h=0;c=f;d=((l[s+2>>0]|0)<<8|(l[s+3>>0]|0))&65535}}while(0);if((a|0)==0|(b|0)==0){r=t;return}i[b+170>>0]=e;j[b+172>>1]=c;j[b+174>>1]=d;j[b+176>>1]=g;j[b+178>>1]=h;b=b+8|0;k[b>>2]=k[b>>2]|32;r=t;return}fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,q,413715);Vcb(a,q);r=t;return}function sdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+736|0;p=s+512|0;q=s;d=k[a+208>>2]|0;if(!(d&1))Ycb(a,413736);if((d&6|0)!=2){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,p,413715);Vcb(a,p);r=s;return}n=(b|0)==0;if(!n?k[b+8>>2]&64|0:0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413749);Xcb(k[a+376>>2]|0,p,413749);Vcb(a,p);r=s;return}o=c>>>1;if(c>>>0>513?1:(o|0)!=(m[a+412>>1]|0|0)){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,p,413728);Vcb(a,p);r=s;return}a:do if(o|0){c=p+1|0;e=a+184|0;f=a+376|0;g=a+212|0;h=a+404|0;d=0;while(1){i=k[e>>2]|0;if(!i)break;Ph[i&511](a,p,2);i=k[g>>2]|0;if((k[f>>2]&536870912|0)==0?(i&2048|0)==0:(i&768|0)!=768){i=yeb(k[h>>2]|0,p,2)|0;k[h>>2]=i}j[q+(d<<1)>>1]=(l[p>>0]|0)<<8|(l[c>>0]|0);d=d+1|0;if((d|0)==(o|0))break a}Ucb(a,413195)}while(0);if((fdb(a,0)|0)!=0|((a|0)==0|n)){r=s;return}g=b+20|0;if(((j[g>>1]|0)+-1&65535)>255){Vcb(a,414852);r=s;return}f=b+232|0;d=k[f>>2]|0;if(d&8){d=b+204|0;c=k[d>>2]|0;do if(c|0){e=k[a+692>>2]|0;if(!e){ggb(c);break}else{jh[e&1023](a,c);break}}while(0);k[d>>2]=0;d=b+8|0;k[d>>2]=k[d>>2]&-65;d=k[f>>2]|0}k[f>>2]=d&-9;d=k[a+688>>2]|0;if(!d)e=fgb(512)|0;else e=Hh[d&511](a,512)|0;if(!e){Vcb(a,412758);k[b+204>>2]=0;Vcb(a,414898);r=s;return}k[b+204>>2]=e;d=b+232|0;k[d>>2]=k[d>>2]|8;d=j[g>>1]|0;if(d<<16>>16){c=d&65535;d=0;do{j[e+(d<<1)>>1]=j[q+(d<<1)>>1]|0;d=d+1|0}while((d|0)!=(c|0))}q=b+8|0;k[q>>2]=k[q>>2]|64;r=s;return}function tdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;h=r;r=r+224|0;f=h+10|0;g=h;d=k[a+208>>2]|0;if(!(d&1))Ycb(a,413736);if(d&4|0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,f,413715);Vcb(a,f);r=h;return}e=(b|0)==0;if(!e?k[b+8>>2]&128|0:0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413749);Xcb(k[a+376>>2]|0,f,413749);Vcb(a,f);r=h;return}if((c|0)!=9){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,f,413728);Vcb(a,f);r=h;return}d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,g,9);f=k[a+212>>2]|0;if((k[a+376>>2]&536870912|0)==0?(f&2048|0)==0:(f&768|0)!=768){f=a+404|0;c=yeb(k[f>>2]|0,g,9)|0;k[f>>2]=c}if((fdb(a,0)|0)!=0|((a|0)==0|e)){r=h;return}a=i[g+8>>0]|0;f=(l[g+5>>0]|0)<<16|(l[g+4>>0]|0)<<24|(l[g+6>>0]|0)<<8|(l[g+7>>0]|0);k[b+192>>2]=(l[g+1>>0]|0)<<16|(l[g>>0]|0)<<24|(l[g+2>>0]|0)<<8|(l[g+3>>0]|0);k[b+196>>2]=f;i[b+200>>0]=a;g=b+8|0;k[g>>2]=k[g>>2]|128;r=h;return}function udb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+224|0;e=j+10|0;h=j;d=k[a+208>>2]|0;if(!(d&1))Ycb(a,413736);if(d&4|0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,e,413715);Vcb(a,e);r=j;return}g=(b|0)==0;if(!g?k[b+8>>2]&256|0:0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413749);Xcb(k[a+376>>2]|0,e,413749);Vcb(a,e);r=j;return}if((c|0)!=9){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,e,413728);Vcb(a,e);r=j;return}d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,h,9);f=k[a+212>>2]|0;if((k[a+376>>2]&536870912|0)==0?(f&2048|0)==0:(f&768|0)!=768){f=a+404|0;e=yeb(k[f>>2]|0,h,9)|0;k[f>>2]=e}if(fdb(a,0)|0){r=j;return}d=l[h>>0]|0;c=(l[h+1>>0]|0)<<16|d<<24|(l[h+2>>0]|0)<<8|(l[h+3>>0]|0);e=l[h+4>>0]|0;f=(l[h+5>>0]|0)<<16|e<<24|(l[h+6>>0]|0)<<8|(l[h+7>>0]|0);if((a|0)==0|g){r=j;return}h=i[h+8>>0]|0;k[b+180>>2]=(d&128|0)==0?c:0-(0-c&2147483647)|0;k[b+184>>2]=(e&128|0)==0?f:0-(0-f&2147483647)|0;i[b+188>>0]=h;h=b+8|0;k[h>>2]=k[h>>2]|256;r=j;return}function vdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+224|0;y=D+4|0;x=D;d=k[a+208>>2]|0;if(!(d&1))Ycb(a,413736);if(d&4|0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,y,413715);Vcb(a,y);r=D;return}p=(b|0)==0;if(!p?k[b+8>>2]&1024|0:0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413749);Xcb(k[a+376>>2]|0,y,413749);Vcb(a,y);r=D;return}f=c+1|0;g=a+756|0;e=k[g>>2]|0;do if(e){d=a+760|0;if((k[d>>2]|0)>>>0<f>>>0){k[g>>2]=0;k[d>>2]=0;d=k[a+692>>2]|0;if(!d){ggb(e);d=a;C=18;break}else{jh[d&1023](a,e);d=a;C=18;break}}}else{d=a;C=18}while(0);do if((C|0)==18){if(f|0){e=k[a+688>>2]|0;if(!e)d=fgb(f)|0;else d=Hh[e&511](d,f)|0;if(d|0){k[g>>2]=d;k[a+760>>2]=f;e=d;break}}fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,418736);Xcb(k[a+376>>2]|0,y,418736);Vcb(a,y);r=D;return}while(0);d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,e,c);m=a+376|0;n=a+212|0;B=k[n>>2]|0;if(c|0?((k[m>>2]&536870912|0)==0?(B&2048|0)==0:(B&768|0)!=768):0){j=a+404|0;f=e;g=k[j>>2]|0;h=c;while(1){d=(h|0)==0?-1:h;g=yeb(g,f,d)|0;h=h-d|0;if(!h)break;else f=f+d|0}k[j>>2]=g}if(fdb(a,0)|0){r=D;return}g=e+c|0;i[g>>0]=0;f=e;while(1){d=f+1|0;if(!(i[f>>0]|0))break;else f=d}if(g>>>0<=(f+12|0)>>>0){if(!(k[n>>2]&1048576))Ycb(a,413728);Xcb(k[m>>2]|0,y,413728);Vcb(a,y);r=D;return}t=l[d>>0]|0;q=l[f+2>>0]<<16|t<<24|l[f+3>>0]<<8|l[f+4>>0];q=(t&128|0)==0?q:0-(0-q&2147483647)|0;t=l[f+5>>0]|0;s=l[f+6>>0]<<16|t<<24|l[f+7>>0]<<8|l[f+8>>0];s=(t&128|0)==0?s:0-(0-s&2147483647)|0;t=i[f+9>>0]|0;u=i[f+10>>0]|0;v=f+11|0;if((t<<24>>24!=0|u<<24>>24==2?(t+-1&255)>1|u<<24>>24==3:0)?t<<24>>24!=3|u<<24>>24==4:0){h=(t&255)>3;do if(h)if(!(k[n>>2]&1048576))Ycb(a,414170);else{Xcb(k[m>>2]|0,y,414170);Vcb(a,y);o=v;break}else o=v;while(0);while(1)if(!(i[o>>0]|0))break;else o=o+1|0;z=u&255;w=z<<2;if(a|0){if(u<<24>>24){A=a+688|0;d=k[A>>2]|0;if(!d)B=fgb(w)|0;else B=Hh[d&511](a,w)|0;if(B|0){f=0;d=o;a:do{d=d+1|0;k[B+(f<<2)>>2]=d;if(d>>>0>g>>>0){C=65;break}while(1){if(!(i[d>>0]|0))break;d=d+1|0;if(d>>>0>g>>>0){C=65;break a}}f=f+1|0}while((f|0)<(z|0));if((C|0)==65){d=k[a+692>>2]|0;if(!d)ggb(B);else jh[d&1023](a,B);if(!(k[n>>2]&1048576))Ycb(a,414197);Xcb(k[m>>2]|0,y,414197);Vcb(a,y);r=D;return}b:do if(!(p|(e|0)==0)){g=e;c:do if(!(g&3)){d=e;C=76}else{f=e;d=g;while(1){if(!(i[f>>0]|0))break c;f=f+1|0;d=f;if(!(d&3)){d=f;C=76;break}}}while(0);if((C|0)==76){while(1){f=k[d>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))d=d+4|0;else break}if((f&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}c=d-g+1|0;if(h)Ucb(a,414938);h=0;while(1){j=k[B+(h<<2)>>2]|0;if(!j){C=99;break}g=j;d:do if(!(g&3)){d=j;C=89}else{f=j;d=g;while(1){if(!(i[f>>0]|0))break d;f=f+1|0;d=f;if(!(d&3)){d=f;C=89;break}}}while(0);if((C|0)==89){C=0;while(1){f=k[d>>2]|0;if(!((f&-2139062144^-2139062144)&f+-16843009))d=d+4|0;else break}if((f&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}d=d-g|0;k[y>>2]=0;k[x>>2]=0;if(!(Rcb(j,d,y,x)|0)){C=97;break}p=k[x>>2]|0;if((p|0)!=(d|0)?i[j+p>>0]|0:0){C=97;break}h=h+1|0;if(!(k[y>>2]|0)){C=99;break}if((h|0)>=(z|0)){C=100;break}}if((C|0)==97)Ucb(a,414965);else if((C|0)==99)Ucb(a,414965);else if((C|0)==100){do if(c|0){d=k[A>>2]|0;if(!d)d=fgb(c)|0;else d=Hh[d&511](a,c)|0;if(!d)break;k[b+208>>2]=d;upb(d|0,e|0,c|0)|0;k[b+212>>2]=q;k[b+216>>2]=s;i[b+228>>0]=t;i[b+229>>0]=u;f=v;e:do if(!(f&3)){d=v;C=109}else{e=v;d=f;while(1){if(!(i[e>>0]|0))break e;e=e+1|0;d=e;if(!(d&3)){d=e;C=109;break}}}while(0);if((C|0)==109){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}e=d-f+1|0;do if(e|0){d=k[A>>2]|0;if(!d)d=fgb(e)|0;else d=Hh[d&511](a,e)|0;if(!d)break;k[b+220>>2]=d;upb(d|0,v|0,e|0)|0;e=w+4|0;d=k[A>>2]|0;if(!d)d=fgb(e)|0;else d=Hh[d&511](a,e)|0;if(!d){Vcb(a,412758);k[b+224>>2]=0;Vcb(a,415071);break b}j=b+224|0;k[j>>2]=d;zpb(d|0,0,e|0)|0;g=0;while(1){h=B+(g<<2)|0;d=k[h>>2]|0;f=d;f:do if(!(f&3))C=129;else{e=d;d=f;while(1){if(!(i[e>>0]|0))break f;e=e+1|0;d=e;if(!(d&3)){d=e;C=129;break}}}while(0);if((C|0)==129){C=0;while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}e=d-f+1|0;if(e){d=k[A>>2]|0;if(!d)d=fgb(e)|0;else d=Hh[d&511](a,e)|0;if(!d)C=139}else C=139;if((C|0)==139){C=0;Vcb(a,412758);d=0}k[(k[j>>2]|0)+(g<<2)>>2]=d;d=k[(k[j>>2]|0)+(g<<2)>>2]|0;if(!d){C=141;break}upb(d|0,k[h>>2]|0,e|0)|0;g=g+1|0;if((g|0)>=(z|0)){C=143;break}}if((C|0)==141){Vcb(a,415107);break b}else if((C|0)==143){C=b+8|0;k[C>>2]=k[C>>2]|1024;b=b+232|0;k[b>>2]=k[b>>2]|128;break b}}while(0);Vcb(a,412758);k[b+220>>2]=0;Vcb(a,415036);break b}while(0);Vcb(a,412758);k[b+208>>2]=0;Vcb(a,414999);break}}while(0);d=k[a+692>>2]|0;if(!d){ggb(B);r=D;return}else{jh[d&1023](a,B);r=D;return}}}Vcb(a,412758)}if(!(k[n>>2]&1048576))Ycb(a,418736);Xcb(k[m>>2]|0,y,418736);Vcb(a,y);r=D;return}if(!(k[n>>2]&1048576))Ycb(a,414146);Xcb(k[m>>2]|0,y,414146);Vcb(a,y);r=D;return}function wdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+240|0;u=w+12|0;v=w+8|0;l=w+4|0;m=w;d=k[a+208>>2]|0;if(!(d&1))Ycb(a,413736);if(d&4|0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413715);Xcb(k[a+376>>2]|0,u,413715);Vcb(a,u);r=w;return}o=(b|0)==0;if(!o?k[b+8>>2]&16384|0:0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413749);Xcb(k[a+376>>2]|0,u,413749);Vcb(a,u);r=w;return}if(c>>>0<4){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,u,413728);Vcb(a,u);r=w;return}f=c+1|0;g=a+756|0;e=k[g>>2]|0;do if(e){d=a+760|0;if((k[d>>2]|0)>>>0<f>>>0){k[g>>2]=0;k[d>>2]=0;d=k[a+692>>2]|0;if(!d){ggb(e);d=a;t=22;break}else{jh[d&1023](a,e);d=a;t=22;break}}}else{d=a;t=22}while(0);do if((t|0)==22){if(f|0){e=k[a+688>>2]|0;if(!e)d=fgb(f)|0;else d=Hh[e&511](d,f)|0;if(d|0){k[g>>2]=d;k[a+760>>2]=f;e=d;break}}if(!(k[a+212>>2]&1048576))Ycb(a,418736);Xcb(k[a+376>>2]|0,u,418736);Vcb(a,u);fdb(a,c)|0;r=w;return}while(0);d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,e,c);q=a+376|0;s=a+212|0;j=k[s>>2]|0;if(c|0?((k[q>>2]&536870912|0)==0?(j&2048|0)==0:(j&768|0)!=768):0){j=a+404|0;f=e;g=k[j>>2]|0;h=c;while(1){d=(h|0)==0?-1:h;g=yeb(g,f,d)|0;h=h-d|0;if(!h)break;else f=f+d|0}k[j>>2]=g}i[e+c>>0]=0;if(fdb(a,0)|0){r=w;return}if(((i[e>>0]|0)+-1&255)>=2){if(!(k[s>>2]&1048576))Ycb(a,414210);Xcb(k[q>>2]|0,u,414210);Vcb(a,u);r=w;return}k[l>>2]=1;k[m>>2]=0;if((Rcb(e,c,m,l)|0?(n=k[l>>2]|0,n>>>0<c>>>0):0)?(p=n+1|0,k[l>>2]=p,(i[e+n>>0]|0)==0):0){if((k[m>>2]&392|0)!=264){if(!(k[s>>2]&1048576))Ycb(a,414240);Xcb(k[q>>2]|0,u,414240);Vcb(a,u);r=w;return}k[m>>2]=0;n=(Rcb(e,c,m,l)|0)!=0;if(!(n&(k[l>>2]|0)==(c|0))){if(!(k[s>>2]&1048576))Ycb(a,414259);Xcb(k[q>>2]|0,u,414259);Vcb(a,u);r=w;return}if((k[m>>2]&392|0)!=264){if(!(k[s>>2]&1048576))Ycb(a,414277);Xcb(k[q>>2]|0,u,414277);Vcb(a,u);r=w;return}j=i[e>>0]|0;c=e+1|0;l=e+p|0;if((a|0)==0|o){r=w;return}if(((j&255)+-1|0)>>>0>1)Ucb(a,415146);f=c;a:do if(!(f&3)){d=c;t=66}else{e=c;d=f;while(1){if(!(i[e>>0]|0))break a;e=e+1|0;d=e;if(!(d&3)){d=e;t=66;break}}}while(0);if((t|0)==66){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}g=d-f|0;if(!g)Ucb(a,415164);if((i[c>>0]|0)==45)Ucb(a,415164);k[u>>2]=0;k[v>>2]=0;do if(Rcb(c,g,u,v)|0){p=k[v>>2]|0;if((p|0)!=(g|0)?i[c+p>>0]|0:0)break;if(!(k[u>>2]|0))Ucb(a,415164);f=l;b:do if(!(f&3)){d=l;t=82}else{d=l;e=f;while(1){if(!(i[d>>0]|0)){d=e;break b}d=d+1|0;e=d;if(!(e&3)){t=82;break}}}while(0);if((t|0)==82){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}h=d-f|0;if(!h)Ucb(a,415183);if((i[l>>0]|0)==45)Ucb(a,415183);k[u>>2]=0;k[v>>2]=0;do if(Rcb(l,h,u,v)|0){v=k[v>>2]|0;if((v|0)!=(h|0)?i[l+v>>0]|0:0)break;if(!(k[u>>2]|0))Ucb(a,415183);i[b+252>>0]=j;e=g+1|0;do if(e|0){f=a+688|0;d=k[f>>2]|0;if(!d)d=fgb(e)|0;else d=Hh[d&511](a,e)|0;if(!d)break;g=b+256|0;k[g>>2]=d;upb(d|0,c|0,e|0)|0;e=h+1|0;do if(e|0){d=k[f>>2]|0;if(!d)d=fgb(e)|0;else d=Hh[d&511](a,e)|0;if(!d)break;k[b+260>>2]=d;upb(d|0,l|0,e|0)|0;a=b+8|0;k[a>>2]=k[a>>2]|16384;a=b+232|0;k[a>>2]=k[a>>2]|256;r=w;return}while(0);Vcb(a,412758);k[b+260>>2]=0;d=k[g>>2]|0;do if(d|0){e=k[a+692>>2]|0;if(!e){ggb(d);break}else{jh[e&1023](a,d);break}}while(0);k[g>>2]=0;Vcb(a,415203);r=w;return}while(0);Vcb(a,412758);k[b+256>>2]=0;Vcb(a,415203);r=w;return}while(0);Ucb(a,415183)}while(0);Ucb(a,415164)}if(!(k[s>>2]&1048576))Ycb(a,414223);Xcb(k[q>>2]|0,u,414223);Vcb(a,u);r=w;return}function xdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+224|0;d=q+8|0;n=q;o=a+208|0;e=k[o>>2]|0;if(!(e&1))Ycb(a,413736);p=(b|0)==0;if(!p?k[b+8>>2]&512|0:0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413749);Xcb(k[a+376>>2]|0,d,413749);Vcb(a,d);r=q;return}if(e&4|0)k[o>>2]=e|8;if((c|0)!=7){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,413728);Xcb(k[a+376>>2]|0,d,413728);Vcb(a,d);r=q;return}c=k[a+184>>2]|0;if(!c)Ucb(a,413195);Ph[c&511](a,n,7);m=k[a+212>>2]|0;if((k[a+376>>2]&536870912|0)==0?(m&2048|0)==0:(m&768|0)!=768){m=a+404|0;h=yeb(k[m>>2]|0,n,7)|0;k[m>>2]=h}if(fdb(a,0)|0){r=q;return}e=i[n+6>>0]|0;f=i[n+5>>0]|0;g=i[n+4>>0]|0;h=i[n+3>>0]|0;m=i[n+2>>0]|0;d=(l[n>>0]|0)<<8|(l[n+1>>0]|0);if((a|0)==0|p){r=q;return}if(k[o>>2]&512|0){r=q;return}c=(h&255)<<8&65535|m&255;if(!((m+-1&255)>11|(h+-1&255)>30)?!((g&255)>23|(f&255)>59|(e&255)>60):0){a=Apb(e&255|0,0,48)|0;p=N|((f&255)<<8&65535|g&255)&65535;n=Apb(c&65535|0,0,16)|0;p=p|N;n=a|n|d;a=b+140|0;o=a;j[o>>1]=n;j[o+2>>1]=n>>>16;a=a+4|0;j[a>>1]=p;j[a+2>>1]=p>>>16;b=b+8|0;k[b>>2]=k[b>>2]|512;r=q;return}Vcb(a,415374);r=q;return}function ydb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0;n=r;r=r+256|0;h=n+28|0;m=n;d=a+724|0;e=k[d>>2]|0;switch(e|0){case 0:break;case 1:{fdb(a,c)|0;r=n;return}default:l=3}if((l|0)==3?(j=e+-1|0,k[d>>2]=j,(j|0)==1):0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,414297);Xcb(k[a+376>>2]|0,h,414297);Vcb(a,h);r=n;return}d=a+208|0;e=k[d>>2]|0;if(!(e&1))Ycb(a,413736);if(e&4|0)k[d>>2]=e|8;f=c+1|0;g=a+756|0;e=k[g>>2]|0;do if(e){d=a+760|0;if((k[d>>2]|0)>>>0<f>>>0){k[g>>2]=0;k[d>>2]=0;d=k[a+692>>2]|0;if(!d){ggb(e);d=a;l=17;break}else{jh[d&1023](a,e);d=a;l=17;break}}else j=e}else{d=a;l=17}while(0);do if((l|0)==17){if(f|0){e=k[a+688>>2]|0;if(!e)d=fgb(f)|0;else d=Hh[e&511](d,f)|0;if(d|0){k[g>>2]=d;k[a+760>>2]=f;j=d;break}}d=a+376|0;Xcb(k[d>>2]|0,h,414321);Vcb(a,h);if(!(k[a+212>>2]&1048576))Ycb(a,418736);Xcb(k[d>>2]|0,h,418736);Vcb(a,h);r=n;return}while(0);d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,j,c);h=k[a+212>>2]|0;if(c|0?((k[a+376>>2]&536870912|0)==0?(h&2048|0)==0:(h&768|0)!=768):0){h=a+404|0;e=j;f=k[h>>2]|0;g=c;while(1){d=(g|0)==0?-1:g;f=yeb(f,e,d)|0;g=g-d|0;if(!g)break;else e=e+d|0}k[h>>2]=f}if(fdb(a,0)|0){r=n;return}e=j+c|0;i[e>>0]=0;d=j;while(1){f=d+1|0;if(!(i[d>>0]|0))break;else d=f}d=(d|0)==(e|0)?d:f;k[m>>2]=-1;k[m+4>>2]=j;k[m+20>>2]=0;k[m+24>>2]=0;k[m+16>>2]=0;k[m+8>>2]=d;f=d;a:do if(!(f&3))l=38;else{e=f;while(1){if(!(i[d>>0]|0)){d=e;break a}d=d+1|0;e=d;if(!(e&3)){l=38;break}}}while(0);if((l|0)==38){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}k[m+12>>2]=d-f;if(!(Odb(a,b,m)|0)){r=n;return}Vcb(a,414355);r=n;return}function zdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+256|0;p=q+28|0;o=q;d=a+724|0;e=k[d>>2]|0;switch(e|0){case 0:break;case 1:{fdb(a,c)|0;r=q;return}default:f=3}if((f|0)==3?(n=e+-1|0,k[d>>2]=n,(n|0)==1):0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,414297);Xcb(k[a+376>>2]|0,p,414297);Vcb(a,p);r=q;return}d=a+208|0;e=k[d>>2]|0;if(!(e&1))Ycb(a,413736);if(e&4|0)k[d>>2]=e|8;n=a+756|0;d=k[n>>2]|0;do if(d){e=a+760|0;if((k[e>>2]|0)>>>0<c>>>0){k[n>>2]=0;k[e>>2]=0;e=k[a+692>>2]|0;if(!e){ggb(d);e=a;f=17;break}else{jh[e&1023](a,d);e=a;f=17;break}}}else{e=a;f=17}while(0);do if((f|0)==17){if(c|0){d=k[a+688>>2]|0;if(!d)d=fgb(c)|0;else d=Hh[d&511](e,c)|0;if(d|0){k[n>>2]=d;k[a+760>>2]=c;break}}fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,418736);Xcb(k[a+376>>2]|0,p,418736);Vcb(a,p);r=q;return}while(0);e=k[a+184>>2]|0;if(!e)Ucb(a,413195);Ph[e&511](a,d,c);l=a+376|0;m=a+212|0;j=k[m>>2]|0;if(c|0?((k[l>>2]&536870912|0)==0?(j&2048|0)==0:(j&768|0)!=768):0){j=a+404|0;f=d;g=k[j>>2]|0;h=c;while(1){e=(h|0)==0?-1:h;g=yeb(g,f,e)|0;h=h-e|0;if(!h)break;else f=f+e|0}k[j>>2]=g}if(fdb(a,0)|0){r=q;return}do if(c){e=0;do{if(!(i[d+e>>0]|0))break;e=e+1|0}while(e>>>0<c>>>0);if((e+-1|0)>>>0<=78)if((e+3|0)>>>0<=c>>>0)if(!(i[d+(e+1)>>0]|0)){k[p>>2]=-1;d=e+2|0;if((Adb(a,c,d,p)|0)==1){n=k[n>>2]|0;c=k[p>>2]|0;i[n+(c+d)>>0]=0;k[o>>2]=0;k[o+4>>2]=n;k[o+8>>2]=n+e+2;k[o+12>>2]=c;k[o+16>>2]=0;k[o+20>>2]=0;k[o+24>>2]=0;if(Odb(a,b,o)|0){d=420017;break}r=q;return}else{d=k[a+248>>2]|0;if(d|0)break;r=q;return}}else d=414397;else d=413906;else d=413916}else d=413916;while(0);if(!(k[m>>2]&1048576))Ycb(a,d);Xcb(k[l>>2]|0,p,d);Vcb(a,p);r=q;return}function Adb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+1024|0;x=y;f=k[a+728>>2]|0;switch(f|0){case -1:case 0:{f=-1;e=c+1|0;break}default:{e=c+1|0;if(f>>>0<e>>>0){e=a+248|0;if(k[e>>2]|0){x=-4;r=y;return x|0}k[e>>2]=420017;x=-4;r=y;return x|0}}}e=f-e|0;if(e>>>0<(k[d>>2]|0)>>>0)k[d>>2]=e;w=a+376|0;e=ndb(a,k[w>>2]|0)|0;switch(e|0){case 0:{u=b-c|0;t=a+756|0;v=a+220|0;a:do if((k[v>>2]|0)==(k[w>>2]|0)){e=k[d>>2]|0;m=a+224|0;k[m>>2]=(k[t>>2]|0)+c;o=a+228|0;q=a+240|0;n=a+236|0;k[o>>2]=u;k[n>>2]=x;f=e>>>0<1024?e:1024;k[q>>2]=f;f=e-f|0;e=Neb(m,(f|0)==0?4:0)|0;if(!e){e=f;while(1){e=e+(k[q>>2]|0)|0;k[n>>2]=x;f=e>>>0<1024?e:1024;k[q>>2]=f;f=e-f|0;e=Neb(m,(f|0)==0?4:0)|0;if(!e)e=f;else break}}k[n>>2]=0;b=k[o>>2]|0;f=(k[q>>2]|0)+f|0;if(f|0)k[d>>2]=(k[d>>2]|0)-f;f=u-b|0;p=a+248|0;b:do if(k[p>>2]|0){if((e|0)!=1)break a}else do switch(e|0){case -7:{k[p>>2]=411045;e=-7;break a}case 1:{k[p>>2]=410915;break b}case 2:{k[p>>2]=410943;e=2;break a}case -1:{k[p>>2]=410965;e=-1;break a}case -2:{k[p>>2]=410979;e=-2;break a}case -3:{k[p>>2]=411002;e=-3;break a}case -4:{k[p>>2]=420017;e=-4;break a}case -5:{k[p>>2]=413906;e=-5;break a}case -6:{k[p>>2]=411020;e=-6;break a}default:{k[p>>2]=410887;break a}}while(0);while(0);e=k[a+252>>2]|0;if(!e)e=-7;else{k[e+40>>2]=0;k[e+44>>2]=0;k[e+48>>2]=0;k[e+28>>2]=0;k[a+244>>2]=0;k[a+232>>2]=0;k[p>>2]=0;b=k[e+8>>2]|0;if(b|0)k[a+272>>2]=b&1;k[e>>2]=0;k[e+4>>2]=0;k[e+12>>2]=0;k[e+20>>2]=32768;k[e+32>>2]=0;k[e+56>>2]=0;k[e+60>>2]=0;j=e+1328|0;k[e+108>>2]=j;k[e+80>>2]=j;k[e+76>>2]=j;k[e+7104>>2]=1;k[e+7108>>2]=-1;j=k[d>>2]|0;l=c+1+j|0;do if(l|0){e=k[a+688>>2]|0;if(!e)g=fgb(l)|0;else g=Hh[e&511](a,l)|0;if(!g)if(!(k[p>>2]|0))break;else{e=-4;break a}e=g+c|0;c:do if((k[v>>2]|0)==(k[w>>2]|0)){b=k[d>>2]|0;k[m>>2]=(k[t>>2]|0)+c;k[o>>2]=0;k[q>>2]=0;h=(e|0)==0;if(h){k[o>>2]=f;k[n>>2]=x;e=b>>>0<1024?b:1024;k[q>>2]=e;b=b-e|0;e=Neb(m,(b|0)==0?4:0)|0;if(!e){do{e=b+(k[q>>2]|0)|0;k[n>>2]=x;b=e>>>0<1024?e:1024;k[q>>2]=b;b=e-b|0;e=Neb(m,(b|0)==0?4:0)|0}while((e|0)==0);s=41}else s=42}else{k[n>>2]=e;k[o>>2]=f;k[q>>2]=b;e=Neb(m,4)|0;if(!e){do e=Neb(m,4)|0;while(!(e|0));b=0;s=41}else b=0}if((s|0)==41)if(h)s=42;if((s|0)==42)k[n>>2]=0;h=k[o>>2]|0;b=(k[q>>2]|0)+b|0;if(b|0)k[d>>2]=(k[d>>2]|0)-b;f=f-h|0;d:do if(k[p>>2]|0){if((e|0)!=1)break c}else do switch(e|0){case -7:{k[p>>2]=411045;e=-7;break c}case 1:{k[p>>2]=410915;break d}case 2:{k[p>>2]=410943;e=2;break c}case -1:{k[p>>2]=410965;e=-1;break c}case -2:{k[p>>2]=410979;e=-2;break c}case -3:{k[p>>2]=411002;e=-3;break c}case -4:{k[p>>2]=420017;e=-4;break c}case -5:{k[p>>2]=413906;e=-5;break c}case -6:{k[p>>2]=411020;e=-6;break c}default:{k[p>>2]=410887;break c}}while(0);while(0);if((j|0)==(k[d>>2]|0)){i[g+(j+c)>>0]=0;e=k[t>>2]|0;if(c|0)upb(g|0,e|0,c|0)|0;k[t>>2]=g;k[a+760>>2]=l;g=e;e=1}else e=-7}else{k[p>>2]=413951;e=-2}while(0);do if(!((a|0)==0|(g|0)==0)){b=k[a+692>>2]|0;if(!b){ggb(g);break}else{jh[b&1023](a,g);break}}while(0);if((u|0)==(f|0)|(e|0)!=1)break a;if(!(k[a+212>>2]&1048576))Ycb(a,413884);else{Xcb(k[w>>2]|0,x,413884);Vcb(a,x);e=1;break a}}while(0);k[p>>2]=420017;e=-4}}else{k[a+248>>2]=413951;e=-2}while(0);k[v>>2]=0;x=e;r=y;return x|0}case 1:{x=-7;r=y;return x|0}default:{x=e;r=y;return x|0}}return 0}function Bdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+256|0;q=s+28|0;o=s;d=a+724|0;e=k[d>>2]|0;switch(e|0){case 0:break;case 1:{fdb(a,c)|0;r=s;return}default:p=3}if((p|0)==3?(n=e+-1|0,k[d>>2]=n,(n|0)==1):0){fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,414297);Xcb(k[a+376>>2]|0,q,414297);Vcb(a,q);r=s;return}d=a+208|0;e=k[d>>2]|0;if(!(e&1))Ycb(a,413736);if(e&4|0)k[d>>2]=e|8;f=c+1|0;n=a+756|0;e=k[n>>2]|0;do if(e){d=a+760|0;if((k[d>>2]|0)>>>0<f>>>0){k[n>>2]=0;k[d>>2]=0;d=k[a+692>>2]|0;if(!d){ggb(e);d=a;p=17;break}else{jh[d&1023](a,e);d=a;p=17;break}}}else{d=a;p=17}while(0);do if((p|0)==17){if(f|0){e=k[a+688>>2]|0;if(!e)d=fgb(f)|0;else d=Hh[e&511](d,f)|0;if(d|0){k[n>>2]=d;k[a+760>>2]=f;e=d;break}}d=a+376|0;Xcb(k[d>>2]|0,q,414321);Vcb(a,q);fdb(a,c)|0;if(!(k[a+212>>2]&1048576))Ycb(a,418736);Xcb(k[d>>2]|0,q,418736);Vcb(a,q);r=s;return}while(0);d=k[a+184>>2]|0;if(!d)Ucb(a,413195);Ph[d&511](a,e,c);l=a+376|0;m=a+212|0;j=k[m>>2]|0;if(c|0?((k[l>>2]&536870912|0)==0?(j&2048|0)==0:(j&768|0)!=768):0){j=a+404|0;f=e;g=k[j>>2]|0;h=c;while(1){d=(h|0)==0?-1:h;g=yeb(g,f,d)|0;h=h-d|0;if(!h)break;else f=f+d|0}k[j>>2]=g}if(fdb(a,0)|0){r=s;return}a:do if(c){d=0;do{if(!(i[e+d>>0]|0))break;d=d+1|0}while(d>>>0<c>>>0);if((d+-1|0)>>>0<=78)if((d+5|0)>>>0>c>>>0)d=413906;else{f=i[e+(d+1)>>0]|0;switch(f<<24>>24){case 0:break;case 1:{if(i[e+(d+2)>>0]|0){d=414422;break a}break}default:{d=414422;break a}}j=f<<24>>24!=0;k[q>>2]=0;h=d+3|0;b:do if(h>>>0<c>>>0){d=h;do{if(!(i[e+d>>0]|0))break b;d=d+1|0}while(d>>>0<c>>>0)}else d=h;while(0);g=d+1|0;c:do if(g>>>0<c>>>0){d=g;do{if(!(i[e+d>>0]|0))break c;d=d+1|0}while(d>>>0<c>>>0)}else d=g;while(0);f=d+1|0;do if(j|f>>>0>c>>>0)if(j&f>>>0<c>>>0){k[q>>2]=-1;if((Adb(a,c,f,q)|0)!=1){d=k[a+248>>2]|0;if(!d){p=52;break}else break}else{e=k[n>>2]|0;p=52;break}}else d=413906;else{k[q>>2]=c-f;p=52}while(0);if((p|0)==52){i[e+((k[q>>2]|0)+f)>>0]=0;k[o>>2]=j?2:1;k[o+4>>2]=e;k[o+20>>2]=e+h;k[o+24>>2]=e+g;k[o+8>>2]=e+f;k[o+12>>2]=0;k[o+16>>2]=k[q>>2];if(!(Odb(a,b,o)|0)){r=s;return}else d=420017}}else d=413916}else d=413916;while(0);if(!(k[m>>2]&1048576))Ycb(a,d);Xcb(k[l>>2]|0,q,d);Vcb(a,q);r=s;return}function Cdb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+224|0;s=t;e=a+652|0;do if(!(k[e>>2]|0)){if(!d)d=k[a+656>>2]|0;switch(d|0){case 3:{f=15;break}case 2:{if(!(k[a+376>>2]&536870912))f=16;else f=15;break}default:f=16}if((f|0)==15){p=(Ddb(a,c)|0)==0;d=p?1:d;f=17;break}else if((f|0)==16){fdb(a,c)|0;f=17;break}}else if(Ddb(a,c)|0){e=Hh[k[e>>2]&511](a,a+732|0)|0;if((e|0)<0)Ycb(a,414443);if(!e)if((d|0)<2)if((k[a+656>>2]|0)<2){Xcb(k[a+376>>2]|0,s,414463);Vcb(a,s);if(!(k[a+212>>2]&2097152))Ucb(a,414485);else{Vcb(a,414485);f=18;break}}else f=18;else f=17;else o=1}else o=0;while(0);if((f|0)==17)switch(d|0){case 3:{f=19;break}case 2:{f=18;break}default:o=0}if((f|0)==18)if(!(k[a+376>>2]&536870912))o=0;else f=19;a:do if((f|0)==19){d=a+724|0;e=k[d>>2]|0;switch(e|0){case 1:{o=0;break a}case 2:{k[d>>2]=1;if(!(k[a+212>>2]&1048576))Ycb(a,414297);else{Xcb(k[a+376>>2]|0,s,414297);Vcb(a,s);o=0;break a}break}case 0:break;default:k[d>>2]=e+-1}j=a+732|0;if(!((a|0)==0|(b|0)==0)){g=b+236|0;c=k[g>>2]|0;p=b+240|0;e=k[p>>2]|0;if((e|0)<0)Ucb(a,412800);f=(e|0)!=0;if((c|0)==0&f)Ucb(a,412800);if(((e|0)!=2147483647?(h=e+1|0,h>>>0<=214748364):0)?(m=h*20|0,m|0):0){n=a+688|0;d=k[n>>2]|0;if(!d)h=fgb(m)|0;else h=Hh[d&511](a,m)|0;if(h|0){d=e*20|0;if(f)upb(h|0,c|0,d|0)|0;d=h+d|0;e=d+20|0;do{i[d>>0]=0;d=d+1|0}while((d|0)<(e|0));d=k[g>>2]|0;do if(d|0){e=k[a+692>>2]|0;if(!e){ggb(d);break}else{jh[e&1023](a,d);break}}while(0);k[g>>2]=h;f=b+232|0;k[f>>2]=k[f>>2]|512;f=k[p>>2]|0;g=a+208|0;k[h+(f*20|0)>>2]=k[j>>2];i[h+(f*20|0)+4>>0]=0;d=(l[a+748>>0]|0)&11;if(!d){if(k[g>>2]&32768|0)Ucb(a,415595);if(!(k[a+212>>2]&2097152))Ucb(a,415543);Vcb(a,415543);d=k[g>>2]&11;if(!d)Ucb(a,415595);else q=d}else q=d;while(1){d=q&0-q;if((q|0)==(d|0))break;else q=d^q}i[h+(f*20|0)+16>>0]=q;c=a+744|0;e=k[c>>2]|0;do if(e){d=k[n>>2]|0;if(!d)d=fgb(e)|0;else d=Hh[d&511](a,e)|0;k[h+(f*20|0)+8>>2]=d;if(d|0){upb(d|0,k[a+740>>2]|0,k[c>>2]|0)|0;k[h+(f*20|0)+12>>2]=k[c>>2];break}if(k[g>>2]&32768|0){Xcb(k[a+376>>2]|0,s,415638);Vcb(a,s);o=1;break a}if(!(k[a+212>>2]&4194304))Ucb(a,415638);else{Vcb(a,415638);o=1;break a}}else{k[h+(f*20|0)+8>>2]=0;k[h+(f*20|0)+12>>2]=0}while(0);k[p>>2]=(k[p>>2]|0)+1;o=1;break}}if(k[a+208>>2]&32768|0){Xcb(k[a+376>>2]|0,s,415519);Vcb(a,s);o=1;break}if(!(k[a+212>>2]&4194304))Ucb(a,415519);else{Vcb(a,415519);o=1;break}}else o=1}while(0);d=a+740|0;e=k[d>>2]|0;do if(e|0){c=k[a+692>>2]|0;if(!c){ggb(e);break}else{jh[c&1023](a,e);break}}while(0);k[d>>2]=0;if(o|0){r=t;return}if(!(k[a+376>>2]&536870912))Ycb(a,414561);else{r=t;return}}function Ddb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;g=r;r=r+224|0;f=g;e=a+740|0;c=k[e>>2]|0;if(c|0){d=k[a+692>>2]|0;if(!d)ggb(c);else jh[d&1023](a,c);k[e>>2]=0}c=k[a+728>>2]|0;switch(c|0){case -1:case 0:{c=8;break}default:if(c>>>0<b>>>0){d=0;c=16}else c=8}do if((c|0)==8){d=k[a+376>>2]|0;i[a+732>>0]=d>>>24;i[a+733>>0]=d>>>16;i[a+734>>0]=d>>>8;i[a+735>>0]=d;i[a+736>>0]=0;k[a+744>>2]=b;i[a+748>>0]=k[a+208>>2];if(!b){k[e>>2]=0;break}c=k[a+688>>2]|0;if(!c)c=fgb(b)|0;else c=Hh[c&511](a,b)|0;if(!c){Vcb(a,412758);c=0}k[e>>2]=c;d=c;c=16}while(0);if((c|0)==16){c=(b|0)!=0;if(c&(d|0)==0){fdb(a,b)|0;if(!(k[a+212>>2]&1048576))Ycb(a,414586);Xcb(k[a+376>>2]|0,f,414586);Vcb(a,f);a=0;r=g;return a|0}if(c){c=k[a+184>>2]|0;if(!c)Ucb(a,413195);Ph[c&511](a,d,b);f=k[a+212>>2]|0;if((k[a+376>>2]&536870912|0)==0?(f&2048|0)==0:(f&768|0)!=768){f=a+404|0;e=k[f>>2]|0;while(1){c=(b|0)==0?-1:b;e=yeb(e,d,c)|0;b=b-c|0;if(!b)break;else d=d+c|0}k[f>>2]=e}}}fdb(a,0)|0;a=1;r=g;return a|0}function Edb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;u=i[a+435>>0]|0;v=u&255;w=(k[a+384>>2]|0)+1|0;t=k[a+348>>2]|0;g=i[a+425>>0]|0;s=g&255;if(!(u<<24>>24))Ucb(a,414622);d=k[a+396>>2]|0;if(d|0){if((u&255)>7)e=aa(t,v>>>3)|0;else e=((aa(t,v)|0)+7|0)>>>3;if((d|0)!=(e|0))Ucb(a,414647)}if(!t)Ucb(a,414683);r=aa(t,v)|0;e=r&7;do if(e){d=aa(t,v>>>3)|0;d=b+((u&255)>7?d:(r+7|0)>>>3)+-1|0;f=i[d>>0]|0;if(!(k[a+216>>2]&65536)){o=d;n=255>>>e;h=f;break}else{o=d;n=255<<e;h=f;break}}else{o=0;n=0;h=0}while(0);a:do if((i[a+424>>0]|0)!=0?(m=k[a+216>>2]|0,(g&255)<6&(m&2|0)!=0):0){switch(c|0){case 0:{d=s&1;break}case 1:{if(!(s&1)){x=64;break a}else d=1;break}default:{x=64;break a}}d=d<<3-((s+1|0)>>>1)&7;if(t>>>0<=d>>>0)return;if((u&255)<8){a=8/(v>>>0)|0;d=(c|0)!=0;do if(!(m&65536))if(d){d=156352+((u<<24>>24==1?0:u<<24>>24==2?1:2)*12|0)+(s>>>1<<2)|0;break}else{d=156460+((u<<24>>24==1?0:u<<24>>24==2?1:2)*24|0)+(s<<2)|0;break}else if(d){d=156316+((u<<24>>24==1?0:u<<24>>24==2?1:2)*12|0)+(s>>>1<<2)|0;break}else{d=156388+((u<<24>>24==1?0:u<<24>>24==2?1:2)*24|0)+(s<<2)|0;break}while(0);e=b;f=w;g=t;d=k[d>>2]|0;while(1){switch((d&255)<<24>>24){case 0:break;case -1:{i[e>>0]=i[f>>0]|0;break}default:i[e>>0]=l[f>>0]&d|l[e>>0]&(d^255)}d=d>>>8|d<<24;if(g>>>0<=a>>>0)break a;else{e=e+1|0;f=f+1|0;g=g-a|0}}}if(v&7|0)Ucb(a,414708);m=v>>>3;d=aa(d,m)|0;e=(aa(t,m)|0)-d|0;f=b+d|0;d=w+d|0;g=m<<((6-s|0)>>>1);g=(c|0)==0?m:g>>>0>e>>>0?e:g;m=m<<((7-s|0)>>>1);switch(g|0){case 1:{i[f>>0]=i[d>>0]|0;if(e>>>0<=m>>>0)return;do{f=f+m|0;d=d+m|0;e=e-m|0;i[f>>0]=i[d>>0]|0}while(e>>>0>m>>>0);return}case 2:{do{i[f>>0]=i[d>>0]|0;i[f+1>>0]=i[d+1>>0]|0;if(e>>>0<=m>>>0){x=67;break}d=d+m|0;f=f+m|0;e=e-m|0}while(e>>>0>1);if((x|0)==67)return;i[f>>0]=i[d>>0]|0;return}case 3:{i[f>>0]=i[d>>0]|0;i[f+1>>0]=i[d+1>>0]|0;i[f+2>>0]=i[d+2>>0]|0;if(e>>>0<=m>>>0)return;do{d=d+m|0;f=f+m|0;e=e-m|0;i[f>>0]=i[d>>0]|0;i[f+1>>0]=i[d+1>>0]|0;i[f+2>>0]=i[d+2>>0]|0}while(e>>>0>m>>>0);return}default:{if((g>>>0<16?(p=f,(p&1|0)==0):0)?(q=d|m,((q|g)&1|0)==0):0)if(!((q|p|g)&3)){h=(m-g|0)>>>2;do{a=g;do{b=d;d=d+4|0;w=f;f=f+4|0;k[w>>2]=k[b>>2];a=a+-4|0}while((a|0)!=0);f=f+(h<<2)|0;d=d+(h<<2)|0;w=e;e=e-m|0;if(w>>>0<=m>>>0){x=67;break}}while(g>>>0<=e>>>0);if((x|0)==67)return;while(1){i[f>>0]=i[d>>0]|0;e=e+-1|0;if(!e)break;else{f=f+1|0;d=d+1|0}}return}else{h=(m-g|0)>>>1;do{a=g;do{b=d;d=d+2|0;w=f;f=f+2|0;j[w>>1]=j[b>>1]|0;a=a+-2|0}while((a|0)!=0);f=f+(h<<1)|0;d=d+(h<<1)|0;w=e;e=e-m|0;if(w>>>0<=m>>>0){x=67;break}}while(g>>>0<=e>>>0);if((x|0)==67)return;while(1){i[f>>0]=i[d>>0]|0;e=e+-1|0;if(!e)break;else{f=f+1|0;d=d+1|0}}return}upb(f|0,d|0,g|0)|0;if(e>>>0<=m>>>0)return;do{d=d+m|0;f=f+m|0;e=e-m|0;g=g>>>0>e>>>0?e:g;upb(f|0,d|0,g|0)|0}while(e>>>0>m>>>0);return}}}else x=64;while(0);if((x|0)==64){x=aa(t,v>>>3)|0;upb(b|0,w|0,((u&255)>7?x:(r+7|0)>>>3)|0)|0}if(!o)return;i[o>>0]=l[o>>0]&(n^255)|h&255&n;return}function Fdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=k[a+4>>2]|0;c=((l[a+11>>0]|0)+7|0)>>>3;if(c>>>0>=e>>>0)return;d=0-c|0;a=c;c=b+c|0;while(1){i[c>>0]=(l[c+d>>0]|0)+(l[c>>0]|0);a=a+1|0;if((a|0)==(e|0))break;else c=c+1|0}return}function Gdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=k[a+4>>2]|0;if(!e)return;else{d=0;a=c}while(1){i[b>>0]=(l[a>>0]|0)+(l[b>>0]|0);d=d+1|0;if((d|0)==(e|0))break;else{b=b+1|0;a=a+1|0}}return}function Hdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=((l[a+11>>0]|0)+7|0)>>>3;g=(k[a+4>>2]|0)-f|0;if(!f)a=c;else{a=b;d=c;e=0;while(1){i[a>>0]=((l[d>>0]|0)>>>1&255)+(l[a>>0]|0);e=e+1|0;if((e|0)==(f|0))break;else{a=a+1|0;d=d+1|0}}b=b+f|0;a=c+f|0}if(!g)return;e=0-f|0;d=b;b=0;while(1){i[d>>0]=(((l[d+e>>0]|0)+(l[a>>0]|0)|0)>>>1)+(l[d>>0]|0);b=b+1|0;if((b|0)==(g|0))break;else{d=d+1|0;a=a+1|0}}return}function Idb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0;e=k[a+4>>2]|0;f=b+e|0;d=l[c>>0]|0;a=(l[b>>0]|0)+d|0;i[b>>0]=a;if((e|0)<=1)return;e=a;a=b+1|0;do{c=c+1|0;b=e&255;h=d;d=l[c>>0]|0;g=d-h|0;n=b-h|0;j=(g|0)<0?0-g|0:g;m=(n|0)<0?0-n|0:n;n=g+n|0;g=(m|0)<(j|0);e=((((n|0)<0?0-n|0:n)|0)<((g?m:j)|0)?h:g?d:b)+(l[a>>0]|0)|0;i[a>>0]=e;a=a+1|0}while(a>>>0<f>>>0);return}function Jdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0;g=((l[a+11>>0]|0)+7|0)>>>3;f=b+g|0;if(g){e=c;while(1){c=e+1|0;d=b+1|0;i[b>>0]=(l[e>>0]|0)+(l[b>>0]|0);if(d>>>0<f>>>0){e=c;b=d}else{b=d;break}}}e=f+((k[a+4>>2]|0)-g)|0;if(b>>>0>=e>>>0)return;d=0-g|0;while(1){h=l[c+d>>0]|0;g=l[b+d>>0]|0;f=l[c>>0]|0;a=f-h|0;n=g-h|0;j=(a|0)<0?0-a|0:a;m=(n|0)<0?0-n|0:n;n=a+n|0;a=(m|0)<(j|0);i[b>>0]=((((n|0)<0?0-n|0:n)|0)<((a?m:j)|0)?h:a?f:g)+(l[b>>0]|0);b=b+1|0;if((b|0)==(e|0))break;else c=c+1|0}return}function Kdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=r;r=r+1248|0;E=F+1024|0;j=F;w=a+224|0;x=a+236|0;k[x>>2]=b;y=a+240|0;k[y>>2]=0;c=(b|0)==0?0:c;z=a+228|0;C=(b|0)!=0;t=a+400|0;D=a+376|0;l=a+764|0;m=a+756|0;n=a+760|0;o=a+688|0;p=a+184|0;u=a+212|0;q=a+404|0;s=a+692|0;a:do if(C){g=c;b:while(1){if(!(k[z>>2]|0)){c=k[t>>2]|0;while(1){if(c|0)break;fdb(a,0)|0;c=edb(a)|0;k[t>>2]=c;if((k[D>>2]|0)!=1229209940){v=30;break b}}f=k[l>>2]|0;f=f>>>0>c>>>0?c:f;b=k[m>>2]|0;do if(b)if((k[n>>2]|0)>>>0<f>>>0){k[m>>2]=0;k[n>>2]=0;c=k[s>>2]|0;if(!c){ggb(b);v=10;break}else{jh[c&1023](a,b);v=10;break}}else i=b;else v=10;while(0);if((v|0)==10){v=0;if(!f){v=42;break}c=k[o>>2]|0;if(!c)c=fgb(f)|0;else c=Hh[c&511](a,f)|0;if(!c){v=42;break}k[m>>2]=c;k[n>>2]=f;i=c}c=k[p>>2]|0;if(!c){v=17;break}Ph[c&511](a,i,f);j=k[u>>2]|0;if(f|0?((k[D>>2]&536870912|0)==0?(j&2048|0)==0:(j&768|0)!=768):0){b=i;d=k[q>>2]|0;e=f;while(1){c=(e|0)==0?-1:e;d=yeb(d,b,c)|0;e=e-c|0;if(!e)break;else b=b+c|0}k[q>>2]=d}k[t>>2]=(k[t>>2]|0)-f;k[w>>2]=i;k[z>>2]=f}k[y>>2]=g;c=Neb(w,0)|0;g=k[y>>2]|0;k[y>>2]=0;switch(c|0){case 1:{A=g;v=51;break a}case 0:break;default:{B=c;break a}}if(!g){v=80;break}}if((v|0)==17)Ucb(a,413195);else if((v|0)==30)Ucb(a,414743);else if((v|0)==42)Ycb(a,414321);else if((v|0)==80){r=F;return}}else{g=c;c:while(1){if(!(k[z>>2]|0)){c=k[t>>2]|0;while(1){if(c|0)break;fdb(a,0)|0;c=edb(a)|0;k[t>>2]=c;if((k[D>>2]|0)!=1229209940){v=30;break c}}f=k[l>>2]|0;f=f>>>0>c>>>0?c:f;b=k[m>>2]|0;do if(b)if((k[n>>2]|0)>>>0<f>>>0){k[m>>2]=0;k[n>>2]=0;c=k[s>>2]|0;if(!c){ggb(b);v=36;break}else{jh[c&1023](a,b);v=36;break}}else h=b;else v=36;while(0);if((v|0)==36){v=0;if(!f){v=42;break}c=k[o>>2]|0;if(!c)c=fgb(f)|0;else c=Hh[c&511](a,f)|0;if(!c){v=42;break}k[m>>2]=c;k[n>>2]=f;h=c}c=k[p>>2]|0;if(!c){v=44;break}Ph[c&511](a,h,f);i=k[u>>2]|0;if(f|0?((k[D>>2]&536870912|0)==0?(i&2048|0)==0:(i&768|0)!=768):0){b=h;d=k[q>>2]|0;e=f;while(1){c=(e|0)==0?-1:e;d=yeb(d,b,c)|0;e=e-c|0;if(!e)break;else b=b+c|0}k[q>>2]=d}k[t>>2]=(k[t>>2]|0)-f;k[w>>2]=h;k[z>>2]=f}k[x>>2]=j;k[y>>2]=1024;c=Neb(w,0)|0;g=1024-(k[y>>2]|0)+g|0;k[y>>2]=0;switch(c|0){case 1:{A=g;v=51;break a}case 0:break;default:{B=c;break a}}if(!g){v=80;break}}if((v|0)==30)Ucb(a,414743);else if((v|0)==42)Ycb(a,414321);else if((v|0)==44)Ucb(a,413195);else if((v|0)==80){r=F;return}}while(0);if((v|0)==51){k[x>>2]=0;c=a+208|0;k[c>>2]=k[c>>2]|8;c=k[u>>2]|0;k[u>>2]=c|8;if(!((k[z>>2]|0)==0?!(k[t>>2]|0):0))v=53;do if((v|0)==53)if(!(c&1048576))Ycb(a,414765);else{Xcb(k[D>>2]|0,E,414765);Vcb(a,E);break}while(0);if(!A){r=F;return}if(C)Ucb(a,414743);if(!(k[u>>2]&1048576))Ycb(a,414787);Xcb(k[D>>2]|0,E,414787);Vcb(a,E);r=F;return}b=a+248|0;c=k[b>>2]|0;d:do if(!c)do switch(B|0){case -7:{k[b>>2]=411045;c=411045;break d}case 1:{k[b>>2]=410915;c=410915;break d}case 2:{k[b>>2]=410943;c=410943;break d}case -1:{k[b>>2]=410965;c=410965;break d}case -2:{k[b>>2]=410979;c=410979;break d}case -3:{k[b>>2]=411002;c=411002;break d}case -4:{k[b>>2]=420017;c=420017;break d}case -5:{k[b>>2]=413906;c=413906;break d}case -6:{k[b>>2]=411020;c=411020;break d}default:{k[b>>2]=410887;c=410887;break d}}while(0);while(0);if(C)Ycb(a,c);if(!(k[a+212>>2]&1048576))Ycb(a,c);Xcb(k[D>>2]|0,E,c);Vcb(a,E);r=F;return}function Ldb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0;b=a+372|0;n=(k[b>>2]|0)+1|0;k[b>>2]=n;o=a+356|0;if(n>>>0<(k[o>>2]|0)>>>0)return;a:do if(i[a+424>>0]|0?(k[b>>2]=0,zpb(k[a+380>>2]|0,0,(k[a+364>>2]|0)+1|0)|0,m=a+425|0,d=(i[m>>0]|0)+1<<24>>24,i[m>>0]=d,c=d&255,(d&255)<=6):0){h=(k[a+348>>2]|0)+-1|0;n=a+368|0;do if(!(k[a+216>>2]&2)){j=(k[a+352>>2]|0)+-1|0;while(1){g=l[418535+c>>0]|0;b=h+g-(l[418542+c>>0]|0)|0;f=d&255;e=l[418549+f>>0]|0;f=j+e-(l[418556+f>>0]|0)|0;if(!(e>>>0>f>>>0|g>>>0>b>>>0)){c=9;break}d=d+1<<24>>24;i[m>>0]=d;if((d&255)>6){c=11;break}else c=d&255}if((c|0)==9){k[o>>2]=(f>>>0)/(e>>>0)|0;b=(b>>>0)/(g>>>0)|0;break}else if((c|0)==11){k[o>>2]=(f>>>0)/(e>>>0)|0;k[n>>2]=(b>>>0)/(g>>>0)|0;break a}}else{b=l[418535+c>>0]|0;b=((h+b-(l[418542+c>>0]|0)|0)>>>0)/(b>>>0)|0}while(0);k[n>>2]=b;return}while(0);b=a+212|0;if((k[b>>2]&8|0)==0?(Kdb(a,0,0),k[a+236>>2]=0,p=k[b>>2]|0,q=a+208|0,(p&8|0)==0):0){k[q>>2]=k[q>>2]|8;k[b>>2]=p|8}b=a+220|0;if((k[b>>2]|0)!=1229209940)return;k[a+224>>2]=0;k[a+228>>2]=0;k[b>>2]=0;fdb(a,k[a+400>>2]|0)|0;return}function Mdb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0.0,h=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;t=a+792|0;b=k[t>>2]|0;B=a+480|0;e=k[B>>2]|0;d=(e|0)!=0;do if(!b)if(d){g=+O(+(1.0e10/+(e|0)+.5));k[t>>2]=g<=2147483647.0&g>=-2147483648.0?~~g:0;b=0;d=e;break}else{k[t>>2]=1e5;k[B>>2]=1e5;b=0;d=1e5;break}else{g=+(b|0);if(!d){g=+O(+(1.0e10/g+.5));d=g<=2147483647.0&g>=-2147483648.0?~~g:0;k[B>>2]=d;b=0;break}g=+O(+(g*+(e|0)/1.0e5+.5));if(g<=2147483647.0&g>=-2147483648.0)b=(~~g+-95e3|0)>>>0>1e4;else b=1;b=b&1;d=e}while(0);F=a+866|0;e=(m[F>>1]|1)&65535;j[F>>1]=e;F=a+216|0;E=k[F>>2]|0;b=(b|0)==0?E&-8193:E|8192;k[F>>2]=b;if((b&262272|0)==262144){b=b&-41943297;k[F>>2]=b;E=a+212|0;k[E>>2]=k[E>>2]&-8193;j[a+420>>1]=0}if((d+-95e3|0)>>>0<=1e4){b=b&-8388609;k[F>>2]=b;E=a+212|0;k[E>>2]=k[E>>2]&-8193}do if(b&6291456|0?!((i[a+669>>0]|0)!=0|(e&2)==0):0){d=k[a+832>>2]|0;e=k[a+844>>2]|0;h=k[a+856>>2]|0;o=e+d+h|0;if((o|0)<1|(d|0)<0)Ucb(a,412073);do if(d){g=+O(+(+(d|0)*32768.0/+(o|0)+.5));if(g<=2147483647.0&g>=-2147483648.0){c=~~g;break}else Ucb(a,412073)}else c=0;while(0);if((e|0)<0|c>>>0>32768)Ucb(a,412073);do if(e){g=+O(+(+(e|0)*32768.0/+(o|0)+.5));if(g<=2147483647.0&g>=-2147483648.0){p=~~g;break}else Ucb(a,412073)}else p=0;while(0);if((h|0)<0|p>>>0>32768)Ucb(a,412073);if(h){g=+O(+(+(h|0)*32768.0/+(o|0)+.5));if(!(g<=2147483647.0&g>=-2147483648.0))Ucb(a,412073);d=~~g;if(d>>>0<32769)f=d;else Ucb(a,412073)}else f=0;d=p+c+f|0;if((d|0)>=32770)Ucb(a,412073);e=(d|0)==32769?-1:(d|0)<32768&1;do if(e){if(!((p|0)<(c|0)|(p|0)<(f|0))){d=e+p|0;break}if((c|0)<(p|0)|(c|0)<(f|0)){f=e+f|0;d=p;break}else{d=p;c=e+c|0;break}}else d=p;while(0);if((d+c+f|0)==32768){j[a+670>>1]=c;j[a+672>>1]=d;break}else Ucb(a,412031)}while(0);if(!(b&256)){if(((b&16512|0)==16512?(q=j[a+446>>1]|0,r=k[a+448>>2]|0,q<<16>>16==(r&65535)<<16>>16):0)?q<<16>>16==(r>>>16&65535)<<16>>16:0){E=a+208|0;k[E>>2]=k[E>>2]|2048;j[a+452>>1]=q}}else if(!(i[a+427>>0]&2)){E=a+208|0;k[E>>2]=k[E>>2]|2048}E=a+427|0;d=i[E>>0]|0;if(d<<24>>24==3){o=j[a+420>>1]|0;p=o<<16>>16==0;a:do if(p){c=0;D=52}else{f=k[a+520>>2]|0;h=o&65535;e=0;c=0;while(1){d=i[f+e>>0]|0;if(d<<24>>24!=-1)if(!(d<<24>>24))c=1;else break a;e=e+1|0;if((e|0)>=(h|0)){D=52;break}}}while(0);if((D|0)==52){d=b&-8388609;k[F>>2]=d;y=a+212|0;k[y>>2]=k[y>>2]&-8193;b=b&-8388993;if(!c)k[F>>2]=b;else b=d}if(((b&4352|0)==4352?(y=l[a+444>>0]|0,r=k[a+408>>2]|0,j[a+446>>1]=l[r+(y*3|0)>>0]|0,j[a+448>>1]=l[r+(y*3|0)+1>>0]|0,j[a+450>>1]=l[r+(y*3|0)+2>>0]|0,(b&34078720|0)==524288):0)?(s=o&65535,!p):0){c=k[a+520>>2]|0;b=0;do{y=c+b|0;i[y>>0]=l[y>>0]^255;b=b+1|0}while((b|0)!=(s|0));b=k[F>>2]|0}}else{if(!(d&4)){y=(j[a+420>>1]|0)==0;c=b&-8388609;k[F>>2]=c;s=a+212|0;k[s>>2]=k[s>>2]&-8193;b=b&-8388993;if(y)k[F>>2]=b;else b=c}if((d&2)==0&(b&4352|0)==4352){c=m[a+452>>1]|0;d=m[a+532>>1]|0;switch(i[a+428>>0]|0){case 1:{d=d*255|0;c=c*255|0;break}case 2:{d=d*85|0;c=c*85|0;break}case 4:{d=d*17|0;c=c*17|0;break}default:{}}y=c&65535;j[a+450>>1]=y;j[a+448>>1]=y;j[a+446>>1]=y;if(!(b&33554432)){y=d&65535;j[a+530>>1]=y;j[a+528>>1]=y;j[a+526>>1]=y}}}if((b&896|0)==640?(i[a+428>>0]|0)!=16:0){s=a+446|0;j[s>>1]=(((m[s>>1]|0)*255|0)+32895|0)>>>16;s=a+448|0;y=k[s>>2]|0;j[s>>1]=(((y&65535)*255|0)+32895|0)>>>16;j[a+450>>1]=(((y>>>16)*255|0)+32895|0)>>>16;y=a+452|0;j[y>>1]=(((m[y>>1]|0)*255|0)+32895|0)>>>16}if((b&384|0)==128&(b&67109888|0)!=0?(i[a+428>>0]|0)==16:0){s=a+446|0;j[s>>1]=(m[s>>1]|0)*257;s=a+448|0;y=k[s>>2]|0;j[s>>1]=(y&65535)*257;j[a+450>>1]=(y>>>16)*257;y=a+452|0;j[y>>1]=(m[y>>1]|0)*257}y=a+454|0;s=a+444|0;j[y>>1]=j[s>>1]|0;j[y+2>>1]=j[s+2>>1]|0;j[y+4>>1]=j[s+4>>1]|0;j[y+6>>1]=j[s+6>>1]|0;j[y+8>>1]=j[s+8>>1]|0;do if(!(b&8192)){if(b&6291456|0){if(((k[t>>2]|0)+-95e3|0)>>>0>1e4){D=87;break}if(((k[B>>2]|0)+-95e3|0)>>>0>1e4){D=87;break}}c=(b&128|0)==0;if(!c){if(((k[t>>2]|0)+-95e3|0)>>>0>1e4){D=87;break}if(((k[B>>2]|0)+-95e3|0)>>>0>1e4){D=87;break}if((i[a+438>>0]|0)==3?((k[a+440>>2]|0)+-95e3|0)>>>0>1e4:0){D=87;break}}if(b&8388608|0?((k[B>>2]|0)+-95e3|0)>>>0>1e4:0){D=87;break}if(!c?(i[E>>0]|0)==3:0){C=j[a+420>>1]|0;o=C&65535;p=k[a+408>>2]|0;c=j[a+446>>1]|0;q=c&255;d=k[a+448>>2]|0;r=d&255;e=d>>>16;s=e&255;if(C<<16>>16){n=a+520|0;h=c&255;f=d&255;c=e&255;b=0;do{d=(k[n>>2]|0)+b|0;e=i[d>>0]|0;switch(e<<24>>24){case 0:{i[p+(b*3|0)>>0]=q;i[p+(b*3|0)+1>>0]=r;i[p+(b*3|0)+2>>0]=s;break}case -1:break;default:{C=p+(b*3|0)|0;B=e&255;B=(aa(B^255,h)|0)+128+(aa(l[C>>0]|0,B)|0)|0;i[C>>0]=((B>>>8&255)+B|0)>>>8;C=p+(b*3|0)+1|0;B=l[d>>0]|0;B=(aa(B,l[C>>0]|0)|0)+128+(aa(B^255,f)|0)|0;i[C>>0]=((B>>>8&255)+B|0)>>>8;C=p+(b*3|0)+2|0;B=l[d>>0]|0;B=(aa(B,l[C>>0]|0)|0)+128+(aa(B^255,c)|0)|0;i[C>>0]=((B>>>8&255)+B|0)>>>8}}b=b+1|0}while((b|0)!=(o|0));b=k[F>>2]|0}b=b&-129;k[F>>2]=b}}else D=87;while(0);do if((D|0)==87){s=a+428|0;b=i[s>>0]|0;y=a+484|0;if(!((k[y>>2]|0)==0?!(k[a+488>>2]|0):0)){Vcb(a,412595);Scb(a)}b:do if((b&255)<9){b=k[B>>2]|0;do if((b|0)>0){c=k[t>>2]|0;if(c|0?(w=+O(+(1.0e15/+(c|0)/+(b|0)+.5)),!(!(w>=-2147483648.0)|!(w<=2147483647.0))):0){c=~~w;break}c=0}else c=1e5;while(0);e=a+688|0;b=k[e>>2]|0;if(!b)d=fgb(256)|0;else d=Hh[b&511](a,256)|0;if(!d)Ucb(a,412758);k[y>>2]=d;if((c+-95e3|0)>>>0>1e4){g=+(c|0)*1.0e-05;c=0;do{if((c+-1|0)>>>0<254)b=~~+O(+(+R(+(+(c|0)/255.0),+g)*255.0+.5))&255;else b=c&255;i[d+c>>0]=b;c=c+1|0}while((c|0)!=256)}else{b=0;do{i[d+b>>0]=b;b=b+1|0}while((b|0)!=256)}if(k[F>>2]&6291584|0){x=+O(+(1.0e10/+(k[t>>2]|0)+.5));c=x<=2147483647.0&x>=-2147483648.0?~~x:0;b=k[e>>2]|0;if(!b)d=fgb(256)|0;else d=Hh[b&511](a,256)|0;if(!d)Ucb(a,412758);k[a+496>>2]=d;if((c+-95e3|0)>>>0>1e4){g=+(c|0)*1.0e-05;c=0;do{if((c+-1|0)>>>0<254)b=~~+O(+(+R(+(+(c|0)/255.0),+g)*255.0+.5))&255;else b=c&255;i[d+c>>0]=b;c=c+1|0}while((c|0)!=256)}else{b=0;do{i[d+b>>0]=b;b=b+1|0}while((b|0)!=256)}b=k[B>>2]|0;if((b|0)>0){x=+O(+(1.0e10/+(b|0)+.5));c=x<=2147483647.0&x>=-2147483648.0?~~x:0}else c=k[t>>2]|0;b=k[e>>2]|0;if(!b)d=fgb(256)|0;else d=Hh[b&511](a,256)|0;if(!d)Ucb(a,412758);k[a+492>>2]=d;if((c+-95e3|0)>>>0<=1e4){b=0;while(1){i[d+b>>0]=b;b=b+1|0;if((b|0)==256)break b}}g=+(c|0)*1.0e-05;c=0;do{if((c+-1|0)>>>0<254)b=~~+O(+(+R(+(+(c|0)/255.0),+g)*255.0+.5))&255;else b=c&255;i[d+c>>0]=b;c=c+1|0}while((c|0)!=256)}}else{if(!(i[E>>0]&2))b=i[a+511>>0]|0;else{r=k[a+508>>2]|0;b=r&255;q=(r&65535)>>>8&255;b=(q&255)>(b&255)?q:b;r=r>>>16&255;b=(r&255)>(b&255)?r:b}r=(b+-1&255)<15?16-(b&255)&255:0;q=k[F>>2]&67109888;r=(q|0)!=0&(r&255)<5?5:r;r=((r&255)>8?8:r)&255;k[a+476>>2]=r;d=a+488|0;c=k[B>>2]|0;b=(c|0)>0;do if(!q){do if(b){b=k[t>>2]|0;if(b|0?(x=+O(+(1.0e15/+(b|0)/+(c|0)+.5)),!(!(x>=-2147483648.0)|!(x<=2147483647.0))):0){b=~~x;break}b=0}else b=1e5;while(0);Tcb(a,d,r,b)}else{if(b){g=+O(+(+(c|0)*(+(k[t>>2]|0)*1.0e-05)+.5));g=g<=2147483647.0&g>=-2147483648.0?+(~~g|0)*1.0e-05:0.0}else g=1.0;q=8-r|0;o=1<<q;e=16-r|0;c=o<<2;if(!c)Ucb(a,412758);f=a+688|0;b=k[f>>2]|0;if(!b)p=fgb(c)|0;else p=Hh[b&511](a,c)|0;if(!p)Ucb(a,412758);zpb(p|0,0,c|0)|0;k[d>>2]=p;d=(a|0)==0;c=0;do{if(!d){b=k[f>>2]|0;if(!b)b=fgb(512)|0;else b=Hh[b&511](a,512)|0;if(!b){D=154;break}}else b=0;k[p+(c<<2)>>2]=b;c=c+1|0}while(c>>>0<o>>>0);if((D|0)==154)Ucb(a,412758);f=(1<<e)+-1|0;h=255>>>r;b=0;e=0;do{d=e*257|0;c=d&65535;d=((((aa(~~+O(+(+R(+(+(d+128|0)/65535.0),+g)*65535.0+.5))&65535,f)|0)+32768|0)>>>0)/65535|0)+1|0;if(b>>>0<d>>>0){do{j[(k[p+((b&h)<<2)>>2]|0)+(b>>>q<<1)>>1]=c;b=b+1|0}while((b|0)!=(d|0));b=d}e=e+1|0}while((e|0)!=255);c=o<<8;if(b>>>0>=c>>>0)break;do{j[(k[p+((b&h)<<2)>>2]|0)+(b>>>q<<1)>>1]=-1;b=b+1|0}while((b|0)!=(c|0))}while(0);if(k[F>>2]&6291584|0){x=+O(+(1.0e10/+(k[t>>2]|0)+.5));Tcb(a,a+504|0,r,x<=2147483647.0&x>=-2147483648.0?~~x:0);b=k[B>>2]|0;if((b|0)>0){x=+O(+(1.0e10/+(b|0)+.5));b=x<=2147483647.0&x>=-2147483648.0?~~x:0}else b=k[t>>2]|0;Tcb(a,a+500|0,r,b)}}while(0);b=k[F>>2]|0;if(!(b&128)){if((i[E>>0]|0)!=3)break;if(!((b&4096|0)==0|(b&6291456|0)==0))break;e=k[a+408>>2]|0;D=j[a+412>>1]|0;f=D&65535;if(D<<16>>16){d=k[y>>2]|0;c=0;do{D=e+(c*3|0)|0;i[D>>0]=i[d+(l[D>>0]|0)>>0]|0;D=e+(c*3|0)+1|0;i[D>>0]=i[d+(l[D>>0]|0)>>0]|0;D=e+(c*3|0)+2|0;i[D>>0]=i[d+(l[D>>0]|0)>>0]|0;c=c+1|0}while((c|0)!=(f|0))}b=b&-8193;k[F>>2]=b;break}if(b&6291456|0)Vcb(a,413336);if((i[E>>0]|0)==3){u=k[a+408>>2]|0;p=j[a+412>>1]|0;v=p&65535;c:do switch(i[a+438>>0]|0){case 2:{d=m[a+446>>1]|0;C=k[y>>2]|0;t=k[a+448>>2]|0;e=t&65535;t=t>>>16;h=k[a+496>>2]|0;c=i[h+d>>0]|0;d=i[C+d>>0]|0;b=i[h+t>>0]|0;h=i[h+e>>0]|0;e=i[C+e>>0]|0;t=i[C+t>>0]|0;break}case 1:{b=k[B>>2]|0;D=181;break}case 3:{D=k[a+440>>2]|0;g=+(D|0);A=+O(+(1.0e10/g+.5));b=A<=2147483647.0&A>=-2147483648.0?~~A:0;c=k[B>>2]|0;if((D|0)!=0&(c|0)!=0?(A=+O(+(1.0e15/g/+(c|0)+.5)),n=~~A,!(!(A>=-2147483648.0)|!(A<=2147483647.0))):0){c=j[a+446>>1]|0;if((n+-95e3|0)>>>0<=1e4){D=192;break c}}else{n=0;c=j[a+446>>1]|0}if(((c&65535)+-1|0)>>>0<254)d=~~+O(+(+R(+(+(c&65535)/255.0),+(+(n|0)*1.0e-05))*255.0+.5))&255;else d=c&255;o=k[a+448>>2]|0;f=o&65535;h=o>>>16;if(((o&65535)+-1|0)>>>0<254)e=~~+O(+(+R(+(+(f&65535)/255.0),+(+(n|0)*1.0e-05))*255.0+.5))&255;else e=o&255;if((h+-1|0)>>>0<254){t=~~+O(+(+R(+(+(h&65535)/255.0),+(+(n|0)*1.0e-05))*255.0+.5))&255;h=o;D=193;break c}else{t=h&255;h=o;D=193;break c}}default:{b=1e5;D=181}}while(0);if((D|0)==181){c=j[a+446>>1]|0;D=192}if((D|0)==192){h=k[a+448>>2]|0;d=c&255;e=h&255;t=h>>>16&255;f=h&65535;D=193}do if((D|0)==193){if((b+-95e3|0)>>>0<=1e4){c=c&255;b=h>>>16&255;h=h&255;break}if(((c&65535)+-1|0)>>>0<254)c=~~+O(+(+R(+(+(c&65535)/255.0),+(+(b|0)*1.0e-05))*255.0+.5))&255;else c=c&255;if(((f&65535)+-1|0)>>>0<254)h=~~+O(+(+R(+(+(f&65535)/255.0),+(+(b|0)*1.0e-05))*255.0+.5))&255;else h=f&255;f=j[a+450>>1]|0;if(((f&65535)+-1|0)>>>0<254){b=~~+O(+(+R(+(+(f&65535)/255.0),+(+(b|0)*1.0e-05))*255.0+.5))&255;break}else{b=f&255;break}}while(0);if(p<<16>>16){q=a+420|0;r=a+520|0;s=a+496|0;o=c&255;p=a+492|0;n=h&255;c=b&255;b=0;do{d:do if((b|0)<(m[q>>1]|0)){f=(k[r>>2]|0)+b|0;h=i[f>>0]|0;switch(h<<24>>24){case -1:{D=210;break d}case 0:{i[u+(b*3|0)>>0]=d;i[u+(b*3|0)+1>>0]=e;i[u+(b*3|0)+2>>0]=t;break d}default:{C=u+(b*3|0)|0;I=k[s>>2]|0;B=h&255;B=(aa(B^255,o)|0)+128+(aa(l[I+(l[C>>0]|0)>>0]|0,B)|0)|0;h=k[p>>2]|0;i[C>>0]=i[h+(((B>>>8&255)+B|0)>>>8&255)>>0]|0;C=u+(b*3|0)+1|0;B=l[f>>0]|0;B=(aa(B,l[I+(l[C>>0]|0)>>0]|0)|0)+128+(aa(B^255,n)|0)|0;i[C>>0]=i[h+(((B>>>8&255)+B|0)>>>8&255)>>0]|0;C=u+(b*3|0)+2|0;B=l[f>>0]|0;B=(aa(B,l[I+(l[C>>0]|0)>>0]|0)|0)+128+(aa(B^255,c)|0)|0;i[C>>0]=i[h+(((B>>>8&255)+B|0)>>>8&255)>>0]|0;break d}}}else D=210;while(0);if((D|0)==210){D=0;I=u+(b*3|0)|0;C=k[y>>2]|0;i[I>>0]=i[C+(l[I>>0]|0)>>0]|0;I=u+(b*3|0)+1|0;i[I>>0]=i[C+(l[I>>0]|0)>>0]|0;I=u+(b*3|0)+2|0;i[I>>0]=i[C+(l[I>>0]|0)>>0]|0}b=b+1|0}while((b|0)!=(v|0))}b=k[F>>2]&-8321;k[F>>2]=b;break}p=a+438|0;e:do switch(i[p>>0]|0){case 1:{v=k[B>>2]|0;C=1e5;break}case 2:{I=k[t>>2]|0;g=+(I|0);A=+O(+(1.0e10/g+.5));c=A<=2147483647.0&A>=-2147483648.0?~~A:0;b=k[B>>2]|0;if((I|0)!=0&(b|0)!=0?(z=+O(+(1.0e15/g/+(b|0)+.5)),!(!(z>=-2147483648.0)|!(z<=2147483647.0))):0){v=c;C=~~z;break e}v=c;C=0;break}case 3:{I=k[a+440>>2]|0;g=+(I|0);z=+O(+(1.0e10/g+.5));c=z<=2147483647.0&z>=-2147483648.0?~~z:0;b=k[B>>2]|0;if((I|0)!=0&(b|0)!=0?(A=+O(+(1.0e15/g/+(b|0)+.5)),!(!(A>=-2147483648.0)|!(A<=2147483647.0))):0){v=c;C=~~A;break e}v=c;C=0;break}default:Ucb(a,413389)}while(0);e=(v+-95e3|0)>>>0>1e4;o=(C+-95e3|0)>>>0>1e4;if(e){b=j[a+452>>1]|0;c=(b&65535)+-1|0;if((i[s>>0]|0)!=8){if(c>>>0<65534)b=~~+O(+(+R(+(+(b&65535)/65535.0),+(+(v|0)*1.0e-05))*65535.0+.5))&65535}else{if(c>>>0<254)b=~~+O(+(+R(+(+(b&65535)/255.0),+(+(v|0)*1.0e-05))*255.0+.5))&255;else b=b&255;b=b&255}j[a+462>>1]=b}if(o){d=a+452|0;b=j[d>>1]|0;c=(b&65535)+-1|0;do if((i[s>>0]|0)==8){if(c>>>0<254)b=~~+O(+(+R(+(+(b&65535)/255.0),+(+(C|0)*1.0e-05))*255.0+.5))&255;else b=b&255;b=b&255}else{if(c>>>0>=65534)break;b=~~+O(+(+R(+(+(b&65535)/65535.0),+(+(C|0)*1.0e-05))*65535.0+.5))&65535}while(0);j[d>>1]=b}f=a+446|0;c=j[f>>1]|0;n=a+448|0;h=k[n>>2]|0;b=h&65535;do if(c<<16>>16==b<<16>>16?(u=a+450|0,c<<16>>16==(h>>>16&65535)<<16>>16):0){if(c<<16>>16!=(j[a+452>>1]|0)){D=243;break}I=j[a+462>>1]|0;j[a+460>>1]=I;j[a+458>>1]=I;j[a+456>>1]=I;j[u>>1]=c;j[n>>1]=c}else D=243;while(0);do if((D|0)==243){if(e){d=(c&65535)+-1|0;do if((i[s>>0]|0)==8){if(d>>>0<254)d=~~+O(+(+R(+(+(c&65535)/255.0),+(+(v|0)*1.0e-05))*255.0+.5))&255;else d=c&255;j[a+456>>1]=d&255;if(((h&65535)+-1|0)>>>0<254)d=~~+O(+(+R(+(+(b&65535)/255.0),+(+(v|0)*1.0e-05))*255.0+.5))&255;else d=h&255;j[a+458>>1]=d&255;d=j[a+450>>1]|0;if(((d&65535)+-1|0)>>>0<254)d=~~+O(+(+R(+(+(d&65535)/255.0),+(+(v|0)*1.0e-05))*255.0+.5))&255;else d=d&255;d=d&255}else{if(d>>>0<65534)d=~~+O(+(+R(+(+(c&65535)/65535.0),+(+(v|0)*1.0e-05))*65535.0+.5))&65535;else d=c;j[a+456>>1]=d;if(((h&65535)+-1|0)>>>0<65534)d=~~+O(+(+R(+(+(b&65535)/65535.0),+(+(v|0)*1.0e-05))*65535.0+.5))&65535;else d=b;j[a+458>>1]=d;d=j[a+450>>1]|0;if(((d&65535)+-1|0)>>>0>=65534)break;d=~~+O(+(+R(+(+(d&65535)/65535.0),+(+(v|0)*1.0e-05))*65535.0+.5))&65535}while(0);j[a+460>>1]=d}if(!o)break;d=(c&65535)+-1|0;do if((i[s>>0]|0)==8){if(d>>>0<254)c=~~+O(+(+R(+(+(c&65535)/255.0),+(+(C|0)*1.0e-05))*255.0+.5))&255;else c=c&255;j[f>>1]=c&255;if(((h&65535)+-1|0)>>>0<254)b=~~+O(+(+R(+(+(b&65535)/255.0),+(+(C|0)*1.0e-05))*255.0+.5))&255;else b=h&255;j[n>>1]=b&255;d=a+450|0;b=j[d>>1]|0;if(((b&65535)+-1|0)>>>0<254)b=~~+O(+(+R(+(+(b&65535)/255.0),+(+(C|0)*1.0e-05))*255.0+.5))&255;else b=b&255;c=b&255;b=d}else{if(d>>>0<65534)c=~~+O(+(+R(+(+(c&65535)/65535.0),+(+(C|0)*1.0e-05))*65535.0+.5))&65535;j[f>>1]=c;if(((h&65535)+-1|0)>>>0<65534)b=~~+O(+(+R(+(+(b&65535)/65535.0),+(+(C|0)*1.0e-05))*65535.0+.5))&65535;j[n>>1]=b;b=a+450|0;c=j[b>>1]|0;if(((c&65535)+-1|0)>>>0>=65534)break;c=~~+O(+(+R(+(+(c&65535)/65535.0),+(+(C|0)*1.0e-05))*65535.0+.5))&65535}while(0);j[b>>1]=c}while(0);i[p>>0]=1;b=k[F>>2]|0}while(0);if((b&4104|0)==8?(i[E>>0]|0)==3:0){h=j[a+412>>1]|0;p=h&65535;I=k[a+508>>2]|0;d=8-(I&255)|0;o=b&-9;k[F>>2]=o;h=h<<16>>16!=0;e=(I&65535)>>>8;f=I>>>16;n=f&255;if((I&255)<<24>>24!=0&(d|0)>0&h){c=k[a+408>>2]|0;b=0;do{I=c+(b*3|0)|0;i[I>>0]=(l[I>>0]|0)>>>d;b=b+1|0}while((b|0)!=(p|0))}d=8-(e&65535)|0;if(e<<16>>16!=0&(d|0)>0&h){c=k[a+408>>2]|0;b=0;do{I=c+(b*3|0)+1|0;i[I>>0]=(l[I>>0]|0)>>>d;b=b+1|0}while((b|0)!=(p|0))}d=8-(f&255)|0;if(n<<24>>24!=0&(d|0)>0&h){c=k[a+408>>2]|0;b=0;do{I=c+(b*3|0)+2|0;i[I>>0]=(l[I>>0]|0)>>>d;b=b+1|0}while((b|0)!=(p|0));e=o}else e=o}else e=b;o=a+424|0;I=k[o>>2]|0;d=I>>>8&255;f=I>>>24&255;b=k[a+352>>2]|0;h=k[a+348>>2]|0;if(!((I&255)<<24>>24)){c=b;b=h}else{I=l[418535+d>>0]|0;c=(e&2|0)==0?(b+7|0)>>>3:b;b=((h+-1+I-(l[418542+d>>0]|0)|0)>>>0)/(I>>>0)|0}k[a+356>>2]=c;k[a+368>>2]=b;b=l[a+430>>0]|0;if(e&4)b=(l[a+428>>0]|0)<8?8:b;c=(e&4096|0)==0;f:do if(!c)switch(f<<24>>24){case 3:{b=(j[a+420>>1]|0)==0?24:32;break f}case 0:{b=(b>>>0<8?8:b)<<((j[a+420>>1]|0)!=0&1);break f}case 2:{if(!(j[a+420>>1]|0))break f;b=(b<<2>>>0)/3|0;break f}default:break f}while(0);do if(e&512)if(c){d=e&-513;k[F>>2]=d;break}else{b=b<<((l[a+428>>0]|0)<16&1);d=e;break}else d=e;while(0);c=(d&32768|0)==0;g:do if(!c)switch(f<<24>>24){case 0:{b=(b|0)<9?16:32;break g}case 3:case 2:{b=(b|0)<33?32:64;break g}default:break g}while(0);do if(d&16384){if(f<<24>>24==4|c&((d&4096|0)==0|(j[a+420>>1]|0)==0)^1){b=(b|0)<17?32:64;break}c=f<<24>>24==6;if((b|0)<9){b=c?32:24;break}else{b=c?64:48;break}}while(0);if(d&1048576){I=j[a+204>>1]|0;I=aa((I&65535)>>>8&65535,I&255)|0;b=(I|0)>(b|0)?I:b}i[a+434>>0]=b;i[a+435>>0]=0;f=h+7&-8;h=aa(f,b>>>3)|0;f=(aa(f,b)|0)>>>3;f=(b+7>>3)+49+((b|0)>7?h:f)|0;h=a+752|0;do if(f>>>0>(k[h>>2]|0)>>>0){n=a+696|0;b=k[n>>2]|0;d=(a|0)==0;do if(!(d|(b|0)==0)){c=k[a+692>>2]|0;if(!c){ggb(b);break}else{jh[c&1023](a,b);break}}while(0);e=a+772|0;c=k[e>>2]|0;do if(!(d|(c|0)==0)){b=k[a+692>>2]|0;if(!b){ggb(c);break}else{jh[b&1023](a,c);break}}while(0);b=(f|0)==0;do if(i[o>>0]|0){if(b)Ucb(a,412758);c=a+688|0;b=k[c>>2]|0;if(!b)b=fgb(f)|0;else b=Hh[b&511](a,f)|0;if(!b)Ucb(a,412758);else{zpb(b|0,0,f|0)|0;G=c;H=b;break}}else{if(b)Ucb(a,412758);c=a+688|0;b=k[c>>2]|0;if(!b)b=fgb(f)|0;else b=Hh[b&511](a,f)|0;if(b|0){G=c;H=b;break}Ucb(a,412758)}while(0);k[n>>2]=H;b=k[G>>2]|0;if(!b)b=fgb(f)|0;else b=Hh[b&511](a,f)|0;if(!b)Ucb(a,412758);else{k[e>>2]=b;I=(k[n>>2]|0)+32|0;k[a+384>>2]=I+(0-(I&15))+-1;I=b+32|0;k[a+380>>2]=I+(0-(I&15))+-1;k[h>>2]=f;break}}while(0);b=k[a+364>>2]|0;if((b|0)==-1)Ucb(a,414807);zpb(k[a+380>>2]|0,0,b+1|0)|0;b=a+756|0;c=k[b>>2]|0;do if(c|0){k[a+760>>2]=0;k[b>>2]=0;b=k[a+692>>2]|0;if(!b){ggb(c);break}else{jh[b&1023](a,c);break}}while(0);if(!(ndb(a,1229209940)|0)){I=a+212|0;k[I>>2]=k[I>>2]|64;return}else Ucb(a,k[a+248>>2]|0)}function Ndb(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var m=0,n=0;if((a|0)==0|(b|0)==0)return;k[b>>2]=c;k[b+4>>2]=d;m=b+24|0;i[m>>0]=e;n=b+25|0;i[n>>0]=f;i[b+26>>0]=h;i[b+27>>0]=j;i[b+28>>0]=g;Qcb(a,c,d,e&255,f&255,g&255,h&255,j&255);d=i[n>>0]|0;if(d<<24>>24!=3){e=b+29|0;a=d&2|1;i[e>>0]=a;if(d&4){a=a+1<<24>>24;i[e>>0]=a}}else{i[b+29>>0]=1;a=1}a=aa(l[m>>0]|0,a&255)|0;i[b+30>>0]=a;a=a&255;if(a>>>0>7)a=aa(a>>>3,c)|0;else a=((aa(a,c)|0)+7|0)>>>3;k[b+12>>2]=a;return}function Odb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+224|0;u=w;if((c|0)==0|((a|0)==0|(b|0)==0)){v=0;r=w;return v|0}o=b+132|0;v=b+128|0;g=k[v>>2]|0;do if((k[o>>2]|0)>(g|0))f=k[b+136>>2]|0;else{if((g|0)!=2147483647){m=(g+1|0)<2147483639?g+9&-8:2147483647;n=b+136|0;h=k[n>>2]|0;j=m-g|0;if((g|0)<0|(j|0)<1)Ucb(a,412800);l=(g|0)>0;if((h|0)==0&l)Ucb(a,412800);if(!((2147483647-g|0)<(j|0)|m>>>0>153391689)?(d=m*28|0,d|0):0){e=k[a+688>>2]|0;if(!e)f=fgb(d)|0;else f=Hh[e&511](a,d)|0;if(f|0){d=g*28|0;if(l)upb(f|0,h|0,d|0)|0;zpb(f+d|0,0,j*28|0)|0;d=k[n>>2]|0;do if(d|0){e=k[a+692>>2]|0;if(!e){ggb(d);break}else{jh[e&1023](a,d);break}}while(0);k[n>>2]=f;g=b+232|0;k[g>>2]=k[g>>2]|16384;k[o>>2]=m;g=k[v>>2]|0;break}}}if(k[a+208>>2]&32768|0){Xcb(k[a+376>>2]|0,u,415289);Vcb(a,u);v=1;r=w;return v|0}if(!(k[a+212>>2]&4194304))Ucb(a,415289);Vcb(a,415289);v=1;r=w;return v|0}while(0);s=f+(g*28|0)|0;q=c+4|0;d=k[q>>2]|0;if(!d){v=0;r=w;return v|0}o=k[c>>2]|0;if((o+1|0)>>>0>3){if(k[a+208>>2]&32768|0){Xcb(k[a+376>>2]|0,u,415310);Vcb(a,u);v=0;r=w;return v|0}if(!(k[a+212>>2]&4194304))Ucb(a,415310);Vcb(a,415310);v=0;r=w;return v|0}h=d;a:do if(!(h&3))t=36;else{e=d;d=h;while(1){if(!(i[e>>0]|0))break a;e=e+1|0;d=e;if(!(d&3)){d=e;t=36;break}}}while(0);if((t|0)==36){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}n=d-h|0;if((o|0)>=1){d=k[c+20>>2]|0;if(!d)j=0;else{h=d;b:do if(!(h&3))t=46;else{e=d;d=h;while(1){if(!(i[e>>0]|0))break b;e=e+1|0;d=e;if(!(d&3)){d=e;t=46;break}}}while(0);if((t|0)==46){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}j=d-h|0}d=k[c+24>>2]|0;if(!d)m=0;else{h=d;c:do if(!(h&3))t=56;else{e=d;d=h;while(1){if(!(i[e>>0]|0))break c;e=e+1|0;d=e;if(!(d&3)){d=e;t=56;break}}}while(0);if((t|0)==56){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}m=d-h|0}}else{m=0;j=0}b=c+8|0;d=k[b>>2]|0;if((d|0)!=0?(p=i[d>>0]|0,p<<24>>24!=0):0){l=d;d:do if(!(l&3))t=71;else{h=d;e=p;d=l;while(1){if(!(e<<24>>24))break d;e=h+1|0;d=e;if(!(d&3)){d=e;t=71;break d}h=e;e=i[e>>0]|0}}while(0);if((t|0)==71){while(1){e=k[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((i[d>>0]|0)!=0)}k[s>>2]=o;h=d-l|0}else t=64;do if((t|0)==64)if((o|0)>0){k[s>>2]=1;h=0;break}else{k[s>>2]=-1;h=0;break}while(0);d=n+4+j+m+h|0;if(d){e=k[a+688>>2]|0;if(!e)d=fgb(d)|0;else d=Hh[e&511](a,d)|0;e=f+(g*28|0)+4|0;k[e>>2]=d;if(d|0){upb(d|0,k[q>>2]|0,n|0)|0;i[(k[e>>2]|0)+n>>0]=0;if((k[c>>2]|0)>0){d=(k[e>>2]|0)+n+1|0;u=f+(g*28|0)+20|0;k[u>>2]=d;upb(d|0,k[c+20>>2]|0,j|0)|0;i[(k[u>>2]|0)+j>>0]=0;u=(k[u>>2]|0)+j+1|0;d=f+(g*28|0)+24|0;k[d>>2]=u;upb(u|0,k[c+24>>2]|0,m|0)|0;i[(k[d>>2]|0)+m>>0]=0;d=(k[d>>2]|0)+m|0}else{k[f+(g*28|0)+20>>2]=0;k[f+(g*28|0)+24>>2]=0;d=(k[e>>2]|0)+n|0}d=d+1|0;e=f+(g*28|0)+8|0;k[e>>2]=d;if(h){upb(d|0,k[b>>2]|0,h|0)|0;d=k[e>>2]|0}i[d+h>>0]=0;u=(k[s>>2]|0)>0;k[f+(g*28|0)+12>>2]=u?0:h;k[f+(g*28|0)+16>>2]=u?h:0;k[v>>2]=(k[v>>2]|0)+1;v=0;r=w;return v|0}}else k[f+(g*28|0)+4>>2]=0;if(k[a+208>>2]&32768|0){Xcb(k[a+376>>2]|0,u,415348);Vcb(a,u);v=1;r=w;return v|0}if(!(k[a+212>>2]&4194304))Ucb(a,415348);Vcb(a,415348);v=1;r=w;return v|0}function Pdb(a,b){a=a|0;b=b|0;var c=0,d=0;c=j[a+8>>1]|0;switch((c&255)<<24>>24){case 0:{c=k[a+4>>2]|0;if(!c)return;else a=0;while(1){i[b>>0]=(l[b>>0]|0)^255;a=a+1|0;if((a|0)==(c|0))break;else b=b+1|0}return}case 4:switch(((c&65535)>>>8&255)<<24>>24){case 8:{c=k[a+4>>2]|0;if(!c)return;else a=0;while(1){i[b>>0]=(l[b>>0]|0)^255;a=a+2|0;if(a>>>0>=c>>>0)break;else b=b+2|0}return}case 16:{c=k[a+4>>2]|0;if(!c)return;else a=0;while(1){i[b>>0]=(l[b>>0]|0)^255;d=b+1|0;i[d>>0]=(l[d>>0]|0)^255;a=a+4|0;if(a>>>0>=c>>>0)break;else b=b+4|0}return}default:return}default:return}}function Qdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;j=a+4|0;e=k[j>>2]|0;g=b+e|0;h=a+10|0;switch(i[h>>0]|0){case 2:{switch(i[a+9>>0]|0){case 8:{f=(c|0)==0;d=b+1|0;c=f?d:b;d=f?b+2|0:d;if(d>>>0<g>>>0){f=(b+(e+-1-d)|0)>>>1;e=c;while(1){i[e>>0]=i[d>>0]|0;d=d+2|0;if(d>>>0>=g>>>0)break;else e=e+1|0}c=c+(f+1)|0}i[a+11>>0]=8;break}case 16:{f=(c|0)==0;d=b+2|0;c=f?d:b;d=f?b+4|0:d;if(d>>>0<g>>>0){f=(b+(e+-1-d)|0)>>>2<<1;e=c;while(1){i[e>>0]=i[d>>0]|0;i[e+1>>0]=i[d+1>>0]|0;d=d+4|0;if(d>>>0>=g>>>0)break;else e=e+2|0}c=c+(f+2)|0}i[a+11>>0]=16;break}default:return}i[h>>0]=1;d=a+8|0;if((i[d>>0]|0)==4)i[d>>0]=0;break}case 4:{switch(i[a+9>>0]|0){case 8:{d=(c|0)==0;c=d?b+3|0:b;d=d?b+4|0:b+1|0;if(d>>>0<g>>>0){f=((b+(e+-1-d)|0)>>>2)*3|0;e=c;while(1){i[e>>0]=i[d>>0]|0;i[e+1>>0]=i[d+1>>0]|0;i[e+2>>0]=i[d+2>>0]|0;d=d+4|0;if(d>>>0>=g>>>0)break;else e=e+3|0}c=c+(f+3)|0}i[a+11>>0]=24;break}case 16:{d=(c|0)==0;c=d?b+6|0:b;d=d?b+8|0:b+2|0;if(d>>>0<g>>>0){f=((b+(e+-1-d)|0)>>>3)*6|0;e=c;while(1){i[e>>0]=i[d>>0]|0;i[e+1>>0]=i[d+1>>0]|0;i[e+2>>0]=i[d+2>>0]|0;i[e+3>>0]=i[d+3>>0]|0;i[e+4>>0]=i[d+4>>0]|0;i[e+5>>0]=i[d+5>>0]|0;d=d+8|0;if(d>>>0>=g>>>0)break;else e=e+6|0}c=c+(f+6)|0}i[a+11>>0]=48;break}default:return}i[h>>0]=3;d=a+8|0;if((i[d>>0]|0)==6)i[d>>0]=2;break}default:return}k[j>>2]=c-b;return}function Rdb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=j[a+8>>1]|0;d=c&255;if(!(d&2))return;e=k[a>>2]|0;switch(((c&65535)>>>8&255)<<24>>24){case 8:switch(d<<24>>24){case 2:{if(!e)return;else a=0;while(1){c=i[b>>0]|0;d=b+2|0;i[b>>0]=i[d>>0]|0;i[d>>0]=c;a=a+1|0;if((a|0)==(e|0))break;else b=b+3|0}return}case 6:{if(!e)return;else a=0;while(1){c=i[b>>0]|0;d=b+2|0;i[b>>0]=i[d>>0]|0;i[d>>0]=c;a=a+1|0;if((a|0)==(e|0))break;else b=b+4|0}return}default:return}case 16:switch(d<<24>>24){case 2:{if(!e)return;else a=0;while(1){c=i[b>>0]|0;f=b+4|0;i[b>>0]=i[f>>0]|0;i[f>>0]=c;f=b+1|0;c=i[f>>0]|0;d=b+5|0;i[f>>0]=i[d>>0]|0;i[d>>0]=c;a=a+1|0;if((a|0)==(e|0))break;else b=b+6|0}return}case 6:{if(!e)return;else a=0;while(1){d=i[b>>0]|0;c=b+4|0;i[b>>0]=i[c>>0]|0;i[c>>0]=d;c=b+1|0;d=i[c>>0]|0;f=b+5|0;i[c>>0]=i[f>>0]|0;i[f>>0]=d;a=a+1|0;if((a|0)==(e|0))break;else b=b+8|0}return}default:return}default:return}}function Sdb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;g=j[a+412>>1]|0;e=i[b+9>>0]|0;if(g<<16>>16==0|(g&65535|0)>=(1<<(e&255)|0))return;c=(aa(k[b>>2]|0,0-(l[b+11>>0]|0)|0)|0)&7;g=k[a+384>>2]|0;d=k[b+4>>2]|0;b=g+d|0;switch(e<<24>>24){case 1:{if((d|0)<=0)return;d=a+416|0;while(1){if((l[b>>0]|0)>>>c|0)k[d>>2]=1;b=b+-1|0;if(b>>>0<=g>>>0)break;else c=0}return}case 2:{if((d|0)<=0)return;f=a+416|0;d=k[f>>2]|0;while(1){a=i[b>>0]|0;e=(a&255)>>>c&3;if((e|0)>(d|0)){k[f>>2]=e;a=i[b>>0]|0;d=e}e=(a&255)>>>c>>>2&3;if((e|0)>(d|0)){k[f>>2]=e;a=i[b>>0]|0;d=e}e=(a&255)>>>c>>>4&3;if((e|0)>(d|0)){k[f>>2]=e;a=i[b>>0]|0;d=e}c=(a&255)>>>c>>>6&3;if((c|0)>(d|0)){k[f>>2]=c;d=c}b=b+-1|0;if(b>>>0<=g>>>0)break;else c=0}return}case 4:{if((d|0)<=0)return;f=a+416|0;d=k[f>>2]|0;while(1){a=i[b>>0]|0;e=(a&255)>>>c&15;if((e|0)>(d|0)){k[f>>2]=e;a=i[b>>0]|0;d=e}c=(a&255)>>>c>>>4&15;if((c|0)>(d|0)){k[f>>2]=c;d=c}b=b+-1|0;if(b>>>0<=g>>>0)break;else c=0}return}case 8:{if((d|0)<=0)return;a=a+416|0;d=k[a>>2]|0;while(1){c=l[b>>0]|0;if((c|0)>(d|0))k[a>>2]=c;else c=d;b=b+-1|0;if(b>>>0<=g>>>0)break;else d=c}return}default:return}}function Tdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;if(!a)return;g=k[a+188>>2]|0;f=g+16|0;d=k[f>>2]|0;e=(d|0)==0;a:do if((k[g+76>>2]|0)>-1){do if(e){d=g+74|0;h=i[d>>0]|0;i[d>>0]=h+255|h;d=k[g>>2]|0;if(!(d&8)){k[g+8>>2]=0;k[g+4>>2]=0;e=k[g+44>>2]|0;k[g+28>>2]=e;h=g+20|0;k[h>>2]=e;d=e+(k[g+48>>2]|0)|0;k[f>>2]=d;f=e;break}else{k[g>>2]=d|32;d=0;break a}}else{f=g+20|0;h=f;f=k[f>>2]|0}while(0);e=f;if((d-f|0)>>>0<c>>>0){d=ci[k[g+36>>2]&255](g,b,c)|0;break}b:do if((i[g+75>>0]|0)>-1){d=c;while(1){if(!d){g=c;f=b;d=0;break b}f=d+-1|0;if((i[b+f>>0]|0)==10)break;else d=f}if((ci[k[g+36>>2]&255](g,b,d)|0)>>>0<d>>>0)break a;g=c-d|0;f=b+d|0;e=k[h>>2]|0}else{g=c;f=b;d=0}while(0);upb(e|0,f|0,g|0)|0;k[h>>2]=(k[h>>2]|0)+g;d=d+g|0}else{do if(e){d=g+74|0;h=i[d>>0]|0;i[d>>0]=h+255|h;d=k[g>>2]|0;if(!(d&8)){k[g+8>>2]=0;k[g+4>>2]=0;e=k[g+44>>2]|0;k[g+28>>2]=e;h=g+20|0;k[h>>2]=e;d=e+(k[g+48>>2]|0)|0;k[f>>2]=d;f=e;break}else{k[g>>2]=d|32;d=0;break a}}else{f=g+20|0;h=f;f=k[f>>2]|0}while(0);e=f;if((d-f|0)>>>0<c>>>0){d=ci[k[g+36>>2]&255](g,b,c)|0;break}c:do if((i[g+75>>0]|0)>-1){d=c;while(1){if(!d){g=c;f=b;d=0;break c}f=d+-1|0;if((i[b+f>>0]|0)==10)break;else d=f}if((ci[k[g+36>>2]&255](g,b,d)|0)>>>0<d>>>0)break a;g=c-d|0;f=b+d|0;e=k[h>>2]|0}else{g=c;f=b;d=0}while(0);upb(e|0,f|0,g|0)|0;k[h>>2]=(k[h>>2]|0)+g;d=d+g|0}while(0);if((d|0)==(c|0))return;else Ucb(a,416463)}function Udb(a){a=a|0;if(!a)return;Rfb(k[a+188>>2]|0)|0;return}function Vdb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+16|0;p=q;e=i[b>>0]|0;m=(e&255)<<24;h=i[b+1>>0]|0;g=i[b+2>>0]|0;f=i[b+3>>0]|0;if(!a){r=q;return}if((d|0)<0)Ucb(a,416874);o=a+768|0;k[o>>2]=34;i[p>>0]=d>>>24;i[p+1>>0]=d>>>16;i[p+2>>0]=d>>>8;i[p+3>>0]=d;j=p+4|0;i[j>>0]=e;i[p+5>>0]=h;i[p+6>>0]=g;i[p+7>>0]=f;n=a+180|0;b=k[n>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,p,8);l=a+376|0;k[l>>2]=(h&255)<<16|m|(g&255)<<8|f&255;f=a+404|0;k[f>>2]=0;e=a+212|0;h=k[e>>2]|0;if((m&536870912|0)==0?(h&2048|0)==0:(h&768|0)!=768){b=yeb(0,j,4)|0;k[f>>2]=b}else b=0;k[o>>2]=66;if((c|0)!=0&(d|0)!=0){b=k[n>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,c,d);m=k[e>>2]|0;b=k[f>>2]|0;if((k[l>>2]&536870912|0)==0?(m&2048|0)==0:(m&768|0)!=768){while(1){e=(d|0)==0?-1:d;b=yeb(b,c,e)|0;d=d-e|0;if(!d)break;else c=c+e|0}k[f>>2]=b}}k[o>>2]=130;i[p>>0]=b>>>24;i[p+1>>0]=b>>>16;i[p+2>>0]=b>>>8;i[p+3>>0]=b;b=k[n>>2]|0;if(!b)Ucb(a,416435);Ph[b&511](a,p,4);r=q;return}
function Xna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,l=0,n=0,q=0,s=0,t=0.0,v=0.0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;na=r;r=r+1040|0;ma=na+8|0;s=na;ha=k[a+40>>2]|0;ga=k[ha+4>>2]|0;ha=k[ha>>2]|0;ja=k[b+40>>2]|0;ia=k[ja+4>>2]|0;ja=k[ja>>2]|0;w=(k[a>>2]|0)>>>3;x=w&511;ka=x+1|0;la=k[a+16>>2]|0;n=k[a+48>>2]|0;l=0;do{h=+p[g+((l&3)<<3)>>3];p[u>>3]=h;a=k[u+4>>2]|0;fa=a&2146435072;if(!(fa>>>0>1126170624|(fa|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}fa=~~h;j[ma+(l<<1)>>1]=fa>>>0<65536?fa:(fa|0)>0?65535:0;l=l+1|0}while((l|0)!=(ka|0));da=n>>>1;ea=ga+-1|0;ca=(ea|0)<0?0:ea;fa=ha+-1|0;ba=(fa|0)<0?0:fa;if((aa(ha,ga)|0)<=0){a=s+4|0;l=ZT(24)|0;k[l>>2]=1;n=l+4|0;k[s>>2]=n;k[a>>2]=16;i[l+20>>0]=0;g=335628;q=n+16|0;do{i[n>>0]=i[g>>0]|0;n=n+1|0;g=g+1|0}while((n|0)<(q|0));Y8(-215,s,338432,335515,3832);k[a>>2]=0;k[s>>2]=0;$=k[l>>2]|0;k[l>>2]=$+-1;if(($|0)==1)ggb(k[l+-4>>2]|0)}if((ja|0)<=0){r=na;return}$=b+16|0;Y=b+44|0;Z=c+16|0;W=c+44|0;X=d+16|0;P=d+44|0;Q=(ia|0)<0;R=(f|0)==5;V=R&(ka|0)!=3;S=(x|0)==0;T=(f|0)==0;U=(f|0)==1;O=w&65535;H=da+1|0;I=da+2|0;J=da+3|0;K=da+4|0;L=da+5|0;M=da+6|0;N=da+7|0;E=(x<<1)+2|0;D=0;do{F=(k[Z>>2]|0)+(aa(k[k[W>>2]>>2]|0,D)|0)|0;G=(k[X>>2]|0)+(aa(k[k[P>>2]>>2]|0,D)|0)|0;if(!Q){C=0;B=(k[$>>2]|0)+(aa(k[k[Y>>2]>>2]|0,D)|0)|0;l=0;n=0;while(1){do if((C|0)<(ia|0)){a=C<<1;if((j[F+(a<<1)>>1]|0)>>>0>=ca>>>0)if(n){_=21;break}else{g=C;a=B;n=0;break}else{a=(j[F+((a|1)<<1)>>1]|0)>>>0<ba>>>0;_=19;break}}else{a=n^1;_=19}while(0);do if((_|0)==19){_=0;if(n^a)if(a){if(V){g=C;a=B+((aa(C-l|0,ka)|0)<<1)|0;l=C;n=1;break}a=(C|0)>(l|0);if(S){if(a){d=B;w=l}else{g=l;a=B;l=C;n=1;break}while(1){n=w<<1;a=j[F+(n<<1)>>1]|0;g=a<<16>>16;n=j[F+((n|1)<<1)>>1]|0;q=n<<16>>16;do if(T)if(n<<16>>16<-1|a<<16>>16>-2&(g|0)<(ga|0)&(q|0)<(ha|0)^1){a=j[ma>>1]|0;break}else{a=e+(m[G+(w<<1)>>1]<<2<<2)|0;_=83;break}else{s=e+(m[G+(w<<1)>>1]<<2<<2)|0;if(U){_=a<<16>>16>-1?((g|0)<(ga|0)?g:ea):0;b=g+1|0;a=a<<16>>16>-2?((b|0)<(ga|0)?b:ea):0;b=q+1|0;g=aa(n<<16>>16>-1?((q|0)<(ha|0)?q:fa):0,da)|0;n=aa(n<<16>>16>-2?((b|0)<(ha|0)?b:fa):0,da)|0;b=j[la+(n+a<<1)>>1]|0;n=j[la+(n+_<<1)>>1]|0;q=j[la+(g+a<<1)>>1]|0;g=j[la+(g+_<<1)>>1]|0;a=s;_=95}else{a=s;_=83}}while(0);do if((_|0)==83){s=uY(g,ga,f)|0;b=uY(g+1|0,ga,f)|0;n=uY(q,ha,f)|0;q=uY(q+1|0,ha,f)|0;if((n|s|0)>-1){g=la+((aa(n,da)|0)+s<<1)|0;g=j[g>>1]|0}else g=j[ma>>1]|0;if((n|b|0)>-1){c=la+((aa(n,da)|0)+b<<1)|0;c=j[c>>1]|0}else c=j[ma>>1]|0;if((q|s|0)>-1){n=la+((aa(q,da)|0)+s<<1)|0;n=j[n>>1]|0}else n=j[ma>>1]|0;if((q|b|0)>-1){b=la+((aa(q,da)|0)+b<<1)|0;b=j[b>>1]|0;q=c;_=95;break}else{b=j[ma>>1]|0;q=c;_=95;break}}while(0);if((_|0)==95){_=0;h=+(g&65535)*+o[a>>2]+ +(q&65535)*+o[a+4>>2]+ +(n&65535)*+o[a+8>>2]+ +(b&65535)*+o[a+12>>2];a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;a=(a>>>0<65536?a:(a|0)>0?65535:0)&65535}j[d>>1]=a;w=w+1|0;if((w|0)==(C|0))break;else d=d+2|0}g=C;a=B+(C-l<<1)|0;l=C;n=1;break}else{if(!a){g=l;a=B;l=C;n=1;break}x=B+(ka<<1)|0;w=aa(E,C+-1-l|0)|0;d=B;while(1){n=l<<1;a=j[F+(n<<1)>>1]|0;g=a<<16>>16;n=j[F+((n|1)<<1)>>1]|0;b=n<<16>>16;do if(T)if(n<<16>>16<-1|a<<16>>16>-2&(g|0)<(ga|0)&(b|0)<(ha|0)^1){a=0;do{j[d+(a<<1)>>1]=j[ma+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(ka|0))}else{q=e+(m[G+(l<<1)>>1]<<2<<2)|0;_=106;break}else{q=e+(m[G+(l<<1)>>1]<<2<<2)|0;if(U){B=g+1|0;s=b+1|0;_=la+((aa(n<<16>>16>-1?((b|0)<(ha|0)?b:fa):0,da)|0)<<1)|0;c=aa(a<<16>>16>-1?((g|0)<(ga|0)?g:ea):0,ka)|0;b=aa(a<<16>>16>-2?((B|0)<(ga|0)?B:ea):0,ka)|0;a=la+((aa(n<<16>>16>-2?((s|0)<(ha|0)?s:fa):0,da)|0)<<1)|0;s=a+(b<<1)|0;a=a+(c<<1)|0;b=_+(b<<1)|0;c=_+(c<<1)|0;_=116}else _=106}while(0);do if((_|0)==106){_=0;if(R?!(g>>>0<ea>>>0&b>>>0<fa>>>0):0)break;s=uY(g,ga,f)|0;g=uY(g+1|0,ga,f)|0;a=uY(b,ha,f)|0;n=uY(b+1|0,ha,f)|0;if((a|s|0)>-1)c=la+((aa(a,da)|0)<<1)+((aa(s,ka)|0)<<1)|0;else c=ma;if((a|g|0)>-1)b=la+((aa(a,da)|0)<<1)+((aa(g,ka)|0)<<1)|0;else b=ma;if((n|s|0)>-1)a=la+((aa(n,da)|0)<<1)+((aa(s,ka)|0)<<1)|0;else a=ma;if((n|g|0)<=-1){s=ma;_=116;break}s=la+((aa(n,da)|0)<<1)+((aa(g,ka)|0)<<1)|0;_=116}while(0);if((_|0)==116){_=0;v=+o[q>>2];y=+o[q+4>>2];z=+o[q+8>>2];t=+o[q+12>>2];g=0;do{h=+(m[c+(g<<1)>>1]|0)*v+ +(m[b+(g<<1)>>1]|0)*y+ +(m[a+(g<<1)>>1]|0)*z+ +(m[s+(g<<1)>>1]|0)*t;n=(o[u>>2]=h,k[u>>2]|0);do if((n&2130706432)>>>0<=1249902592){n=(n|0)<0;h=n?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(!(h==0.0))break;h=n?-0.0:0.0}while(0);B=~~h;j[d+(g<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;g=g+1|0}while((g|0)!=(ka|0))}l=l+1|0;if((l|0)==(C|0))break;else d=d+(ka<<1)|0}g=C;a=x+w|0;l=C;n=1;break}}else _=21;else{g=C;a=B}}while(0);a:do if((_|0)==21){_=0;switch(O&511){case 0:{if((C|0)>(l|0)){n=l;g=B}else{g=l;a=B;l=C;n=0;break a}while(1){x=n<<1;a=e+(m[G+(n<<1)>>1]<<2<<2)|0;x=la+((aa(j[F+((x|1)<<1)>>1]|0,da)|0)<<1)+(j[F+(x<<1)>>1]<<1)|0;h=+(m[x>>1]|0)*+o[a>>2]+ +(m[x+2>>1]|0)*+o[a+4>>2]+ +(m[x+(da<<1)>>1]|0)*+o[a+8>>2]+ +(m[x+(H<<1)>>1]|0)*+o[a+12>>2];a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}x=~~h;j[g>>1]=x>>>0<65536?x:(x|0)>0?65535:0;n=n+1|0;if((n|0)==(C|0))break;else g=g+2|0}g=C;a=B+(C-l<<1)|0;l=C;n=0;break a}case 1:{if((C|0)<=(l|0)){g=l;a=B;l=C;n=0;break a}q=C-l|0;n=B;while(1){a=l<<1;x=e+(m[G+(l<<1)>>1]<<2<<2)|0;a=la+((aa(j[F+((a|1)<<1)>>1]|0,da)|0)<<1)+(j[F+(a<<1)>>1]<<1<<1)|0;y=+o[x>>2];z=+o[x+4>>2];A=+o[x+8>>2];h=+o[x+12>>2];t=+(m[a>>1]|0)*y+ +(m[a+4>>1]|0)*z+ +(m[a+(da<<1)>>1]|0)*A+ +(m[a+(I<<1)>>1]|0)*h;h=y*+(m[a+2>>1]|0)+z*+(m[a+6>>1]|0)+A*+(m[a+(H<<1)>>1]|0)+h*+(m[a+(J<<1)>>1]|0);a=(o[u>>2]=t,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(t==0.0)t=a?-0.0:0.0}a=~~t;j[n>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}x=~~h;j[n+2>>1]=x>>>0<65536?x:(x|0)>0?65535:0;l=l+1|0;if((l|0)==(C|0))break;else n=n+4|0}g=C;a=B+(q<<1<<1)|0;l=C;n=0;break a}case 2:{if((C|0)<=(l|0)){g=l;a=B;l=C;n=0;break a}q=C-l|0;n=B;while(1){a=l<<1;x=e+(m[G+(l<<1)>>1]<<2<<2)|0;a=la+((aa(j[F+((a|1)<<1)>>1]|0,da)|0)<<1)+((j[F+(a<<1)>>1]|0)*3<<1)|0;y=+o[x>>2];z=+o[x+4>>2];A=+o[x+8>>2];h=+o[x+12>>2];v=+(m[a>>1]|0)*y+ +(m[a+6>>1]|0)*z+ +(m[a+(da<<1)>>1]|0)*A+ +(m[a+(J<<1)>>1]|0)*h;t=y*+(m[a+2>>1]|0)+z*+(m[a+8>>1]|0)+A*+(m[a+(H<<1)>>1]|0)+h*+(m[a+(K<<1)>>1]|0);h=y*+(m[a+4>>1]|0)+z*+(m[a+10>>1]|0)+A*+(m[a+(I<<1)>>1]|0)+h*+(m[a+(L<<1)>>1]|0);a=(o[u>>2]=v,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;v=a?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(v==0.0)v=a?-0.0:0.0}a=~~v;j[n>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=t,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(t==0.0)t=a?-0.0:0.0}a=~~t;j[n+2>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}x=~~h;j[n+4>>1]=x>>>0<65536?x:(x|0)>0?65535:0;l=l+1|0;if((l|0)==(C|0))break;else n=n+6|0}g=C;a=B+(q*3<<1)|0;l=C;n=0;break a}case 3:{if((C|0)<=(l|0)){g=l;a=B;l=C;n=0;break a}q=C-l|0;g=B;while(1){n=l<<1;a=e+(m[G+(l<<1)>>1]<<2<<2)|0;n=la+((aa(j[F+((n|1)<<1)>>1]|0,da)|0)<<1)+(j[F+(n<<1)>>1]<<2<<1)|0;v=+o[a>>2];y=+o[a+4>>2];z=+o[a+8>>2];A=+o[a+12>>2];t=+(m[n>>1]|0)*v+ +(m[n+8>>1]|0)*y+ +(m[n+(da<<1)>>1]|0)*z+ +(m[n+(K<<1)>>1]|0)*A;h=v*+(m[n+2>>1]|0)+y*+(m[n+10>>1]|0)+z*+(m[n+(H<<1)>>1]|0)+A*+(m[n+(L<<1)>>1]|0);a=(o[u>>2]=t,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(t==0.0)t=a?-0.0:0.0}a=~~t;j[g>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;j[g+2>>1]=a>>>0<65536?a:(a|0)>0?65535:0;t=+(m[n+4>>1]|0)*v+ +(m[n+12>>1]|0)*y+ +(m[n+(I<<1)>>1]|0)*z+ +(m[n+(M<<1)>>1]|0)*A;h=v*+(m[n+6>>1]|0)+y*+(m[n+14>>1]|0)+z*+(m[n+(J<<1)>>1]|0)+A*+(m[n+(N<<1)>>1]|0);a=(o[u>>2]=t,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(t==0.0)t=a?-0.0:0.0}a=~~t;j[g+4>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}x=~~h;j[g+6>>1]=x>>>0<65536?x:(x|0)>0?65535:0;l=l+1|0;if((l|0)==(C|0))break;else g=g+8|0}g=C;a=B+(q<<2<<1)|0;l=C;n=0;break a}default:{if((C|0)<=(l|0)){g=l;a=B;l=C;n=0;break a}b=B+(ka<<1)|0;s=aa(E,C+-1-l|0)|0;q=B;while(1){g=l<<1;n=e+(m[G+(l<<1)>>1]<<2<<2)|0;g=la+((aa(j[F+((g|1)<<1)>>1]|0,da)|0)<<1)+((aa(j[F+(g<<1)>>1]|0,ka)|0)<<1)|0;t=+o[n>>2];v=+o[n+4>>2];y=+o[n+8>>2];z=+o[n+12>>2];n=0;do{a=n+da|0;h=+(m[g+(n<<1)>>1]|0)*t+ +(m[g+(n+ka<<1)>>1]|0)*v+ +(m[g+(a<<1)>>1]|0)*y+ +(m[g+(a+ka<<1)>>1]|0)*z;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}B=~~h;j[q+(n<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;n=n+1|0}while((n|0)!=(ka|0));l=l+1|0;if((l|0)==(C|0))break;else q=q+(ka<<1)|0}g=C;a=b+s|0;l=C;n=0;break a}}}while(0);if((g|0)<(ia|0)){C=g+1|0;B=a}else break}}D=D+1|0}while((D|0)!=(ja|0));r=na;return}function Yna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,l=0,n=0,q=0,s=0,t=0.0,v=0.0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;na=r;r=r+1040|0;ma=na+8|0;s=na;ha=k[a+40>>2]|0;ga=k[ha+4>>2]|0;ha=k[ha>>2]|0;ja=k[b+40>>2]|0;ia=k[ja+4>>2]|0;ja=k[ja>>2]|0;w=(k[a>>2]|0)>>>3;x=w&511;ka=x+1|0;la=k[a+16>>2]|0;n=k[a+48>>2]|0;l=0;do{h=+p[g+((l&3)<<3)>>3];p[u>>3]=h;a=k[u+4>>2]|0;fa=a&2146435072;if(!(fa>>>0>1126170624|(fa|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}fa=~~h;j[ma+(l<<1)>>1]=(fa+32768|0)>>>0<65536?fa:(fa|0)>0?32767:32768;l=l+1|0}while((l|0)!=(ka|0));da=n>>>1;ea=ga+-1|0;ca=(ea|0)<0?0:ea;fa=ha+-1|0;ba=(fa|0)<0?0:fa;if((aa(ha,ga)|0)<=0){a=s+4|0;l=ZT(24)|0;k[l>>2]=1;n=l+4|0;k[s>>2]=n;k[a>>2]=16;i[l+20>>0]=0;g=335628;q=n+16|0;do{i[n>>0]=i[g>>0]|0;n=n+1|0;g=g+1|0}while((n|0)<(q|0));Y8(-215,s,338432,335515,3832);k[a>>2]=0;k[s>>2]=0;$=k[l>>2]|0;k[l>>2]=$+-1;if(($|0)==1)ggb(k[l+-4>>2]|0)}if((ja|0)<=0){r=na;return}$=b+16|0;Y=b+44|0;Z=c+16|0;W=c+44|0;X=d+16|0;P=d+44|0;Q=(ia|0)<0;R=(f|0)==5;V=R&(ka|0)!=3;S=(x|0)==0;T=(f|0)==0;U=(f|0)==1;O=w&65535;H=da+1|0;I=da+2|0;J=da+3|0;K=da+4|0;L=da+5|0;M=da+6|0;N=da+7|0;F=(x<<1)+2|0;D=0;do{G=(k[Z>>2]|0)+(aa(k[k[W>>2]>>2]|0,D)|0)|0;E=(k[X>>2]|0)+(aa(k[k[P>>2]>>2]|0,D)|0)|0;if(!Q){C=0;B=(k[$>>2]|0)+(aa(k[k[Y>>2]>>2]|0,D)|0)|0;l=0;n=0;while(1){do if((C|0)<(ia|0)){a=C<<1;if((j[G+(a<<1)>>1]|0)>>>0>=ca>>>0)if(n){_=21;break}else{g=C;a=B;n=0;break}else{a=(j[G+((a|1)<<1)>>1]|0)>>>0<ba>>>0;_=19;break}}else{a=n^1;_=19}while(0);do if((_|0)==19){_=0;if(n^a)if(a){if(V){g=C;a=B+((aa(C-l|0,ka)|0)<<1)|0;l=C;n=1;break}a=(C|0)>(l|0);if(S){if(a){d=B;w=l}else{g=l;a=B;l=C;n=1;break}while(1){n=w<<1;a=j[G+(n<<1)>>1]|0;g=a<<16>>16;n=j[G+((n|1)<<1)>>1]|0;q=n<<16>>16;do if(T)if(n<<16>>16<-1|a<<16>>16>-2&(g|0)<(ga|0)&(q|0)<(ha|0)^1){a=j[ma>>1]|0;break}else{a=e+(m[E+(w<<1)>>1]<<2<<2)|0;_=83;break}else{s=e+(m[E+(w<<1)>>1]<<2<<2)|0;if(U){_=a<<16>>16>-1?((g|0)<(ga|0)?g:ea):0;b=g+1|0;a=a<<16>>16>-2?((b|0)<(ga|0)?b:ea):0;b=q+1|0;g=aa(n<<16>>16>-1?((q|0)<(ha|0)?q:fa):0,da)|0;n=aa(n<<16>>16>-2?((b|0)<(ha|0)?b:fa):0,da)|0;b=j[la+(n+a<<1)>>1]|0;n=j[la+(n+_<<1)>>1]|0;q=j[la+(g+a<<1)>>1]|0;g=j[la+(g+_<<1)>>1]|0;a=s;_=95}else{a=s;_=83}}while(0);do if((_|0)==83){s=uY(g,ga,f)|0;b=uY(g+1|0,ga,f)|0;n=uY(q,ha,f)|0;q=uY(q+1|0,ha,f)|0;if((n|s|0)>-1){g=la+((aa(n,da)|0)+s<<1)|0;g=j[g>>1]|0}else g=j[ma>>1]|0;if((n|b|0)>-1){c=la+((aa(n,da)|0)+b<<1)|0;c=j[c>>1]|0}else c=j[ma>>1]|0;if((q|s|0)>-1){n=la+((aa(q,da)|0)+s<<1)|0;n=j[n>>1]|0}else n=j[ma>>1]|0;if((q|b|0)>-1){b=la+((aa(q,da)|0)+b<<1)|0;b=j[b>>1]|0;q=c;_=95;break}else{b=j[ma>>1]|0;q=c;_=95;break}}while(0);if((_|0)==95){_=0;h=+(g<<16>>16)*+o[a>>2]+ +(q<<16>>16)*+o[a+4>>2]+ +(n<<16>>16)*+o[a+8>>2]+ +(b<<16>>16)*+o[a+12>>2];a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;a=((a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768)&65535}j[d>>1]=a;w=w+1|0;if((w|0)==(C|0))break;else d=d+2|0}g=C;a=B+(C-l<<1)|0;l=C;n=1;break}else{if(!a){g=l;a=B;l=C;n=1;break}x=B+(ka<<1)|0;w=aa(F,C+-1-l|0)|0;d=B;while(1){n=l<<1;a=j[G+(n<<1)>>1]|0;g=a<<16>>16;n=j[G+((n|1)<<1)>>1]|0;b=n<<16>>16;do if(T)if(n<<16>>16<-1|a<<16>>16>-2&(g|0)<(ga|0)&(b|0)<(ha|0)^1){a=0;do{j[d+(a<<1)>>1]=j[ma+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(ka|0))}else{q=e+(m[E+(l<<1)>>1]<<2<<2)|0;_=106;break}else{q=e+(m[E+(l<<1)>>1]<<2<<2)|0;if(U){B=g+1|0;s=b+1|0;_=la+((aa(n<<16>>16>-1?((b|0)<(ha|0)?b:fa):0,da)|0)<<1)|0;c=aa(a<<16>>16>-1?((g|0)<(ga|0)?g:ea):0,ka)|0;b=aa(a<<16>>16>-2?((B|0)<(ga|0)?B:ea):0,ka)|0;a=la+((aa(n<<16>>16>-2?((s|0)<(ha|0)?s:fa):0,da)|0)<<1)|0;s=a+(b<<1)|0;a=a+(c<<1)|0;b=_+(b<<1)|0;c=_+(c<<1)|0;_=116}else _=106}while(0);do if((_|0)==106){_=0;if(R?!(g>>>0<ea>>>0&b>>>0<fa>>>0):0)break;s=uY(g,ga,f)|0;g=uY(g+1|0,ga,f)|0;a=uY(b,ha,f)|0;n=uY(b+1|0,ha,f)|0;if((a|s|0)>-1)c=la+((aa(a,da)|0)<<1)+((aa(s,ka)|0)<<1)|0;else c=ma;if((a|g|0)>-1)b=la+((aa(a,da)|0)<<1)+((aa(g,ka)|0)<<1)|0;else b=ma;if((n|s|0)>-1)a=la+((aa(n,da)|0)<<1)+((aa(s,ka)|0)<<1)|0;else a=ma;if((n|g|0)<=-1){s=ma;_=116;break}s=la+((aa(n,da)|0)<<1)+((aa(g,ka)|0)<<1)|0;_=116}while(0);if((_|0)==116){_=0;v=+o[q>>2];y=+o[q+4>>2];z=+o[q+8>>2];t=+o[q+12>>2];g=0;do{h=+(j[c+(g<<1)>>1]|0)*v+ +(j[b+(g<<1)>>1]|0)*y+ +(j[a+(g<<1)>>1]|0)*z+ +(j[s+(g<<1)>>1]|0)*t;n=(o[u>>2]=h,k[u>>2]|0);do if((n&2130706432)>>>0<=1249902592){n=(n|0)<0;h=n?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(!(h==0.0))break;h=n?-0.0:0.0}while(0);B=~~h;j[d+(g<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;g=g+1|0}while((g|0)!=(ka|0))}l=l+1|0;if((l|0)==(C|0))break;else d=d+(ka<<1)|0}g=C;a=x+w|0;l=C;n=1;break}}else _=21;else{g=C;a=B}}while(0);a:do if((_|0)==21){_=0;switch(O&511){case 0:{if((C|0)>(l|0)){n=l;g=B}else{g=l;a=B;l=C;n=0;break a}while(1){x=n<<1;a=e+(m[E+(n<<1)>>1]<<2<<2)|0;x=la+((aa(j[G+((x|1)<<1)>>1]|0,da)|0)<<1)+(j[G+(x<<1)>>1]<<1)|0;h=+(j[x>>1]|0)*+o[a>>2]+ +(j[x+2>>1]|0)*+o[a+4>>2]+ +(j[x+(da<<1)>>1]|0)*+o[a+8>>2]+ +(j[x+(H<<1)>>1]|0)*+o[a+12>>2];a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}x=~~h;j[g>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;n=n+1|0;if((n|0)==(C|0))break;else g=g+2|0}g=C;a=B+(C-l<<1)|0;l=C;n=0;break a}case 1:{if((C|0)<=(l|0)){g=l;a=B;l=C;n=0;break a}q=C-l|0;n=B;while(1){a=l<<1;x=e+(m[E+(l<<1)>>1]<<2<<2)|0;a=la+((aa(j[G+((a|1)<<1)>>1]|0,da)|0)<<1)+(j[G+(a<<1)>>1]<<1<<1)|0;y=+o[x>>2];z=+o[x+4>>2];A=+o[x+8>>2];h=+o[x+12>>2];t=+(j[a>>1]|0)*y+ +(j[a+4>>1]|0)*z+ +(j[a+(da<<1)>>1]|0)*A+ +(j[a+(I<<1)>>1]|0)*h;h=y*+(j[a+2>>1]|0)+z*+(j[a+6>>1]|0)+A*+(j[a+(H<<1)>>1]|0)+h*+(j[a+(J<<1)>>1]|0);a=(o[u>>2]=t,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(t==0.0)t=a?-0.0:0.0}a=~~t;j[n>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}x=~~h;j[n+2>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;l=l+1|0;if((l|0)==(C|0))break;else n=n+4|0}g=C;a=B+(q<<1<<1)|0;l=C;n=0;break a}case 2:{if((C|0)<=(l|0)){g=l;a=B;l=C;n=0;break a}q=C-l|0;n=B;while(1){a=l<<1;x=e+(m[E+(l<<1)>>1]<<2<<2)|0;a=la+((aa(j[G+((a|1)<<1)>>1]|0,da)|0)<<1)+((j[G+(a<<1)>>1]|0)*3<<1)|0;y=+o[x>>2];z=+o[x+4>>2];A=+o[x+8>>2];h=+o[x+12>>2];v=+(j[a>>1]|0)*y+ +(j[a+6>>1]|0)*z+ +(j[a+(da<<1)>>1]|0)*A+ +(j[a+(J<<1)>>1]|0)*h;t=y*+(j[a+2>>1]|0)+z*+(j[a+8>>1]|0)+A*+(j[a+(H<<1)>>1]|0)+h*+(j[a+(K<<1)>>1]|0);h=y*+(j[a+4>>1]|0)+z*+(j[a+10>>1]|0)+A*+(j[a+(I<<1)>>1]|0)+h*+(j[a+(L<<1)>>1]|0);a=(o[u>>2]=v,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;v=a?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(v==0.0)v=a?-0.0:0.0}a=~~v;j[n>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=t,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(t==0.0)t=a?-0.0:0.0}a=~~t;j[n+2>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}x=~~h;j[n+4>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;l=l+1|0;if((l|0)==(C|0))break;else n=n+6|0}g=C;a=B+(q*3<<1)|0;l=C;n=0;break a}case 3:{if((C|0)<=(l|0)){g=l;a=B;l=C;n=0;break a}q=C-l|0;g=B;while(1){n=l<<1;a=e+(m[E+(l<<1)>>1]<<2<<2)|0;n=la+((aa(j[G+((n|1)<<1)>>1]|0,da)|0)<<1)+(j[G+(n<<1)>>1]<<2<<1)|0;v=+o[a>>2];y=+o[a+4>>2];z=+o[a+8>>2];A=+o[a+12>>2];t=+(j[n>>1]|0)*v+ +(j[n+8>>1]|0)*y+ +(j[n+(da<<1)>>1]|0)*z+ +(j[n+(K<<1)>>1]|0)*A;h=v*+(j[n+2>>1]|0)+y*+(j[n+10>>1]|0)+z*+(j[n+(H<<1)>>1]|0)+A*+(j[n+(L<<1)>>1]|0);a=(o[u>>2]=t,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(t==0.0)t=a?-0.0:0.0}a=~~t;j[g>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}a=~~h;j[g+2>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;t=+(j[n+4>>1]|0)*v+ +(j[n+12>>1]|0)*y+ +(j[n+(I<<1)>>1]|0)*z+ +(j[n+(M<<1)>>1]|0)*A;h=v*+(j[n+6>>1]|0)+y*+(j[n+14>>1]|0)+z*+(j[n+(J<<1)>>1]|0)+A*+(j[n+(N<<1)>>1]|0);a=(o[u>>2]=t,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(t==0.0)t=a?-0.0:0.0}a=~~t;j[g+4>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}x=~~h;j[g+6>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;l=l+1|0;if((l|0)==(C|0))break;else g=g+8|0}g=C;a=B+(q<<2<<1)|0;l=C;n=0;break a}default:{if((C|0)<=(l|0)){g=l;a=B;l=C;n=0;break a}b=B+(ka<<1)|0;s=aa(F,C+-1-l|0)|0;q=B;while(1){g=l<<1;n=e+(m[E+(l<<1)>>1]<<2<<2)|0;g=la+((aa(j[G+((g|1)<<1)>>1]|0,da)|0)<<1)+((aa(j[G+(g<<1)>>1]|0,ka)|0)<<1)|0;t=+o[n>>2];v=+o[n+4>>2];y=+o[n+8>>2];z=+o[n+12>>2];n=0;do{a=n+da|0;h=+(j[g+(n<<1)>>1]|0)*t+ +(j[g+(n+ka<<1)>>1]|0)*v+ +(j[g+(a<<1)>>1]|0)*y+ +(j[g+(a+ka<<1)>>1]|0)*z;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}B=~~h;j[q+(n<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;n=n+1|0}while((n|0)!=(ka|0));l=l+1|0;if((l|0)==(C|0))break;else q=q+(ka<<1)|0}g=C;a=b+s|0;l=C;n=0;break a}}}while(0);if((g|0)<(ia|0)){C=g+1|0;B=a}else break}}D=D+1|0}while((D|0)!=(ja|0));r=na;return}function Zna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,l=0,n=0,q=0,s=0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0;la=r;r=r+2064|0;ka=la+8|0;q=la;fa=k[a+40>>2]|0;ea=k[fa+4>>2]|0;fa=k[fa>>2]|0;ha=k[b+40>>2]|0;ga=k[ha+4>>2]|0;ha=k[ha>>2]|0;s=(k[a>>2]|0)>>>3;u=s&511;ia=u+1|0;ja=k[a+16>>2]|0;h=k[a+48>>2]|0;a=0;do{o[ka+(a<<2)>>2]=+p[g+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(ia|0));ba=h>>>2;ca=ea+-1|0;$=(ca|0)<0?0:ca;da=fa+-1|0;_=(da|0)<0?0:da;if((aa(fa,ea)|0)<=0){a=q+4|0;h=ZT(24)|0;k[h>>2]=1;g=h+4|0;k[q>>2]=g;k[a>>2]=16;i[h+20>>0]=0;l=335628;n=g+16|0;do{i[g>>0]=i[l>>0]|0;g=g+1|0;l=l+1|0}while((g|0)<(n|0));Y8(-215,q,338432,335515,3832);k[a>>2]=0;k[q>>2]=0;Z=k[h>>2]|0;k[h>>2]=Z+-1;if((Z|0)==1)ggb(k[h+-4>>2]|0)}if((ha|0)<=0){r=la;return}Z=b+16|0;X=b+44|0;Y=c+16|0;V=c+44|0;W=d+16|0;O=d+44|0;P=(ga|0)<0;Q=(f|0)==5;U=Q&(ia|0)!=3;R=(u|0)==0;S=(f|0)==0;T=(f|0)==1;N=s&65535;G=ba+1|0;H=ba+2|0;I=ba+3|0;J=ba+4|0;K=ba+5|0;L=ba+6|0;M=ba+7|0;D=(u<<2)+4|0;C=0;do{E=(k[Y>>2]|0)+(aa(k[k[V>>2]>>2]|0,C)|0)|0;F=(k[W>>2]|0)+(aa(k[k[O>>2]>>2]|0,C)|0)|0;if(!P){B=0;c=(k[Z>>2]|0)+(aa(k[k[X>>2]>>2]|0,C)|0)|0;u=0;g=0;while(1){do if((B|0)<(ga|0)){a=B<<1;if((j[E+(a<<1)>>1]|0)>>>0>=$>>>0)if(g){A=18;break}else{l=B;a=c;h=u;g=0;break}else{a=(j[E+((a|1)<<1)>>1]|0)>>>0<_>>>0;A=16;break}}else{a=g^1;A=16}while(0);do if((A|0)==16){A=0;if(g^a)if(a){if(U){l=B;a=c+((aa(B-u|0,ia)|0)<<2)|0;h=B;g=1;break}a=(B|0)>(u|0);if(R){if(a){b=c;d=u}else{l=u;a=c;h=B;g=1;break}while(1){h=d<<1;a=j[E+(h<<1)>>1]|0;g=a<<16>>16;h=j[E+((h|1)<<1)>>1]|0;q=h<<16>>16;do if(S)if(h<<16>>16<-1|a<<16>>16>-2&(g|0)<(ea|0)&(q|0)<(fa|0)^1){t=+o[ka>>2];break}else{a=e+(m[F+(d<<1)>>1]<<2<<2)|0;A=47;break}else{l=e+(m[F+(d<<1)>>1]<<2<<2)|0;if(T){A=a<<16>>16>-1?((g|0)<(ea|0)?g:ca):0;z=g+1|0;z=a<<16>>16>-2?((z|0)<(ea|0)?z:ca):0;y=q+1|0;a=aa(h<<16>>16>-1?((q|0)<(fa|0)?q:da):0,ba)|0;y=aa(h<<16>>16>-2?((y|0)<(fa|0)?y:da):0,ba)|0;x=+o[ja+(y+z<<2)>>2];t=+o[ja+(y+A<<2)>>2];w=+o[ja+(a+z<<2)>>2];v=+o[ja+(a+A<<2)>>2];a=l;A=59}else{a=l;A=47}}while(0);do if((A|0)==47){l=uY(g,ea,f)|0;n=uY(g+1|0,ea,f)|0;h=uY(q,fa,f)|0;g=uY(q+1|0,fa,f)|0;if((h|l|0)>-1){A=ja+((aa(h,ba)|0)+l<<2)|0;v=+o[A>>2]}else v=+o[ka>>2];if((h|n|0)>-1){A=ja+((aa(h,ba)|0)+n<<2)|0;w=+o[A>>2]}else w=+o[ka>>2];if((g|l|0)>-1){A=ja+((aa(g,ba)|0)+l<<2)|0;t=+o[A>>2]}else t=+o[ka>>2];if((g|n|0)>-1){A=ja+((aa(g,ba)|0)+n<<2)|0;x=+o[A>>2];A=59;break}else{x=+o[ka>>2];A=59;break}}while(0);if((A|0)==59){A=0;t=v*+o[a>>2]+w*+o[a+4>>2]+t*+o[a+8>>2]+x*+o[a+12>>2]}o[b>>2]=t;d=d+1|0;if((d|0)==(B|0))break;else b=b+4|0}l=B;a=c+(B-u<<2)|0;h=B;g=1;break}else{if(!a){l=u;a=c;h=B;g=1;break}z=c+(ia<<2)|0;y=aa(D,B+-1-u|0)|0;while(1){h=u<<1;a=j[E+(h<<1)>>1]|0;g=a<<16>>16;h=j[E+((h|1)<<1)>>1]|0;q=h<<16>>16;do if(S)if(h<<16>>16<-1|a<<16>>16>-2&(g|0)<(ea|0)&(q|0)<(fa|0)^1){a=0;do{k[c+(a<<2)>>2]=k[ka+(a<<2)>>2];a=a+1|0}while((a|0)!=(ia|0))}else{l=e+(m[F+(u<<1)>>1]<<2<<2)|0;A=67;break}else{l=e+(m[F+(u<<1)>>1]<<2<<2)|0;if(T){b=g+1|0;s=q+1|0;A=ja+((aa(h<<16>>16>-1?((q|0)<(fa|0)?q:da):0,ba)|0)<<2)|0;d=aa(a<<16>>16>-1?((g|0)<(ea|0)?g:ca):0,ia)|0;q=aa(a<<16>>16>-2?((b|0)<(ea|0)?b:ca):0,ia)|0;a=ja+((aa(h<<16>>16>-2?((s|0)<(fa|0)?s:da):0,ba)|0)<<2)|0;s=a+(q<<2)|0;a=a+(d<<2)|0;q=A+(q<<2)|0;d=A+(d<<2)|0;A=77}else A=67}while(0);do if((A|0)==67){A=0;if(Q?!(g>>>0<ca>>>0&q>>>0<da>>>0):0)break;n=uY(g,ea,f)|0;g=uY(g+1|0,ea,f)|0;a=uY(q,fa,f)|0;h=uY(q+1|0,fa,f)|0;if((a|n|0)>-1)b=ja+((aa(a,ba)|0)<<2)+((aa(n,ia)|0)<<2)|0;else b=ka;if((a|g|0)>-1)q=ja+((aa(a,ba)|0)<<2)+((aa(g,ia)|0)<<2)|0;else q=ka;if((h|n|0)>-1)a=ja+((aa(h,ba)|0)<<2)+((aa(n,ia)|0)<<2)|0;else a=ka;if((h|g|0)<=-1){s=ka;d=b;A=77;break}s=ja+((aa(h,ba)|0)<<2)+((aa(g,ia)|0)<<2)|0;d=b;A=77}while(0);if((A|0)==77){A=0;g=l+4|0;n=l+8|0;b=l+12|0;h=0;do{o[c+(h<<2)>>2]=+o[d+(h<<2)>>2]*+o[l>>2]+ +o[q+(h<<2)>>2]*+o[g>>2]+ +o[a+(h<<2)>>2]*+o[n>>2]+ +o[s+(h<<2)>>2]*+o[b>>2];h=h+1|0}while((h|0)!=(ia|0))}u=u+1|0;if((u|0)==(B|0))break;else c=c+(ia<<2)|0}l=B;a=z+y|0;h=B;g=1;break}}else A=18;else{l=B;a=c;h=u}}while(0);a:do if((A|0)==18){A=0;switch(N&511){case 0:{if((B|0)>(u|0)){a=u;h=c}else{l=u;a=c;h=B;g=0;break a}while(1){y=a<<1;z=e+(m[F+(a<<1)>>1]<<2<<2)|0;y=ja+((aa(j[E+((y|1)<<1)>>1]|0,ba)|0)<<2)+(j[E+(y<<1)>>1]<<2)|0;o[h>>2]=+o[y>>2]*+o[z>>2]+ +o[y+4>>2]*+o[z+4>>2]+ +o[y+(ba<<2)>>2]*+o[z+8>>2]+ +o[y+(G<<2)>>2]*+o[z+12>>2];a=a+1|0;if((a|0)==(B|0))break;else h=h+4|0}l=B;a=c+(B-u<<2)|0;h=B;g=0;break a}case 1:{if((B|0)<=(u|0)){l=u;a=c;h=B;g=0;break a}g=B-u|0;a=u;h=c;while(1){z=a<<1;y=e+(m[F+(a<<1)>>1]<<2<<2)|0;z=ja+((aa(j[E+((z|1)<<1)>>1]|0,ba)|0)<<2)+(j[E+(z<<1)>>1]<<1<<2)|0;ma=+o[y>>2];t=+o[y+4>>2];v=+o[y+8>>2];w=+o[y+12>>2];x=ma*+o[z+4>>2]+t*+o[z+12>>2]+v*+o[z+(G<<2)>>2]+w*+o[z+(I<<2)>>2];o[h>>2]=+o[z>>2]*ma+ +o[z+8>>2]*t+ +o[z+(ba<<2)>>2]*v+ +o[z+(H<<2)>>2]*w;o[h+4>>2]=x;a=a+1|0;if((a|0)==(B|0))break;else h=h+8|0}l=B;a=c+(g<<1<<2)|0;h=B;g=0;break a}case 2:{if((B|0)<=(u|0)){l=u;a=c;h=B;g=0;break a}g=B-u|0;a=u;h=c;while(1){z=a<<1;y=e+(m[F+(a<<1)>>1]<<2<<2)|0;z=ja+((aa(j[E+((z|1)<<1)>>1]|0,ba)|0)<<2)+((j[E+(z<<1)>>1]|0)*3<<2)|0;na=+o[y>>2];t=+o[y+4>>2];v=+o[y+8>>2];w=+o[y+12>>2];x=na*+o[z+4>>2]+t*+o[z+16>>2]+v*+o[z+(G<<2)>>2]+w*+o[z+(J<<2)>>2];ma=na*+o[z+8>>2]+t*+o[z+20>>2]+v*+o[z+(H<<2)>>2]+w*+o[z+(K<<2)>>2];o[h>>2]=+o[z>>2]*na+ +o[z+12>>2]*t+ +o[z+(ba<<2)>>2]*v+ +o[z+(I<<2)>>2]*w;o[h+4>>2]=x;o[h+8>>2]=ma;a=a+1|0;if((a|0)==(B|0))break;else h=h+12|0}l=B;a=c+(g*3<<2)|0;h=B;g=0;break a}case 3:{if((B|0)<=(u|0)){l=u;a=c;h=B;g=0;break a}g=B-u|0;h=c;a=u;while(1){z=a<<1;d=e+(m[F+(a<<1)>>1]<<2<<2)|0;z=ja+((aa(j[E+((z|1)<<1)>>1]|0,ba)|0)<<2)+(j[E+(z<<1)>>1]<<2<<2)|0;na=+o[d>>2];s=d+4|0;ma=+o[s>>2];u=d+8|0;x=+o[u>>2];y=d+12|0;w=+o[y>>2];v=na*+o[z+4>>2]+ma*+o[z+20>>2]+x*+o[z+(G<<2)>>2]+w*+o[z+(K<<2)>>2];o[h>>2]=+o[z>>2]*na+ +o[z+16>>2]*ma+ +o[z+(ba<<2)>>2]*x+ +o[z+(J<<2)>>2]*w;o[h+4>>2]=v;v=+o[d>>2];w=+o[s>>2];x=+o[u>>2];ma=+o[y>>2];na=v*+o[z+12>>2]+w*+o[z+28>>2]+x*+o[z+(I<<2)>>2]+ma*+o[z+(M<<2)>>2];o[h+8>>2]=+o[z+8>>2]*v+ +o[z+24>>2]*w+ +o[z+(H<<2)>>2]*x+ +o[z+(L<<2)>>2]*ma;o[h+12>>2]=na;a=a+1|0;if((a|0)==(B|0))break;else h=h+16|0}l=B;a=c+(g<<2<<2)|0;h=B;g=0;break a}default:{if((B|0)<=(u|0)){l=u;a=c;h=B;g=0;break a}s=c+(ia<<2)|0;d=aa(D,B+-1-u|0)|0;h=u;while(1){l=h<<1;g=e+(m[F+(h<<1)>>1]<<2<<2)|0;l=ja+((aa(j[E+((l|1)<<1)>>1]|0,ba)|0)<<2)+((aa(j[E+(l<<1)>>1]|0,ia)|0)<<2)|0;n=g+4|0;q=g+8|0;b=g+12|0;a=0;do{z=a+ba|0;o[c+(a<<2)>>2]=+o[l+(a<<2)>>2]*+o[g>>2]+ +o[l+(a+ia<<2)>>2]*+o[n>>2]+ +o[l+(z<<2)>>2]*+o[q>>2]+ +o[l+(z+ia<<2)>>2]*+o[b>>2];a=a+1|0}while((a|0)!=(ia|0));h=h+1|0;if((h|0)==(B|0))break;else c=c+(ia<<2)|0}l=B;a=s+d|0;h=B;g=0;break a}}}while(0);if((l|0)<(ga|0)){B=l+1|0;c=a;u=h}else break}}C=C+1|0}while((C|0)!=(ha|0));r=la;return}function _na(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,l=0,n=0,q=0,s=0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0.0;ka=r;r=r+4112|0;ja=ka;q=ka+4096|0;ea=k[a+40>>2]|0;da=k[ea+4>>2]|0;ea=k[ea>>2]|0;ga=k[b+40>>2]|0;fa=k[ga+4>>2]|0;ga=k[ga>>2]|0;s=(k[a>>2]|0)>>>3;u=s&511;ha=u+1|0;ia=k[a+16>>2]|0;h=k[a+48>>2]|0;a=0;do{p[ja+(a<<3)>>3]=+p[g+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(ha|0));$=h>>>3;ba=da+-1|0;_=(ba|0)<0?0:ba;ca=ea+-1|0;Z=(ca|0)<0?0:ca;if((aa(ea,da)|0)<=0){a=q+4|0;h=ZT(24)|0;k[h>>2]=1;g=h+4|0;k[q>>2]=g;k[a>>2]=16;i[h+20>>0]=0;l=335628;n=g+16|0;do{i[g>>0]=i[l>>0]|0;g=g+1|0;l=l+1|0}while((g|0)<(n|0));Y8(-215,q,338432,335515,3832);k[a>>2]=0;k[q>>2]=0;Y=k[h>>2]|0;k[h>>2]=Y+-1;if((Y|0)==1)ggb(k[h+-4>>2]|0)}if((ga|0)<=0){r=ka;return}Y=b+16|0;W=b+44|0;X=c+16|0;U=c+44|0;V=d+16|0;N=d+44|0;O=(fa|0)<0;P=(f|0)==5;T=P&(ha|0)!=3;Q=(u|0)==0;R=(f|0)==0;S=(f|0)==1;M=s&65535;F=$+1|0;G=$+2|0;H=$+3|0;I=$+4|0;J=$+5|0;K=$+6|0;L=$+7|0;C=(u<<3)+8|0;B=0;do{D=(k[X>>2]|0)+(aa(k[k[U>>2]>>2]|0,B)|0)|0;E=(k[V>>2]|0)+(aa(k[k[N>>2]>>2]|0,B)|0)|0;if(!O){A=0;l=(k[Y>>2]|0)+(aa(k[k[W>>2]>>2]|0,B)|0)|0;y=0;g=0;while(1){do if((A|0)<(fa|0)){a=A<<1;if((j[D+(a<<1)>>1]|0)>>>0>=_>>>0)if(g){z=18;break}else{b=A;a=l;h=y;g=0;break}else{a=(j[D+((a|1)<<1)>>1]|0)>>>0<Z>>>0;z=16;break}}else{a=g^1;z=16}while(0);do if((z|0)==16){z=0;if(g^a)if(a){if(T){b=A;a=l+((aa(A-y|0,ha)|0)<<3)|0;h=A;g=1;break}a=(A|0)>(y|0);if(Q){if(a){c=l;d=y}else{b=y;a=l;h=A;g=1;break}while(1){h=d<<1;a=j[D+(h<<1)>>1]|0;g=a<<16>>16;h=j[D+((h|1)<<1)>>1]|0;b=h<<16>>16;do if(R)if(h<<16>>16<-1|a<<16>>16>-2&(g|0)<(da|0)&(b|0)<(ea|0)^1){t=+p[ja>>3];break}else{a=e+(m[E+(d<<1)>>1]<<2<<2)|0;z=47;break}else{n=e+(m[E+(d<<1)>>1]<<2<<2)|0;if(S){z=a<<16>>16>-1?((g|0)<(da|0)?g:ba):0;u=g+1|0;u=a<<16>>16>-2?((u|0)<(da|0)?u:ba):0;s=b+1|0;a=aa(h<<16>>16>-1?((b|0)<(ea|0)?b:ca):0,$)|0;s=aa(h<<16>>16>-2?((s|0)<(ea|0)?s:ca):0,$)|0;x=+p[ia+(s+u<<3)>>3];t=+p[ia+(s+z<<3)>>3];w=+p[ia+(a+u<<3)>>3];v=+p[ia+(a+z<<3)>>3];a=n;z=59}else{a=n;z=47}}while(0);do if((z|0)==47){n=uY(g,da,f)|0;q=uY(g+1|0,da,f)|0;h=uY(b,ea,f)|0;g=uY(b+1|0,ea,f)|0;if((h|n|0)>-1){z=ia+((aa(h,$)|0)+n<<3)|0;v=+p[z>>3]}else v=+p[ja>>3];if((h|q|0)>-1){z=ia+((aa(h,$)|0)+q<<3)|0;w=+p[z>>3]}else w=+p[ja>>3];if((g|n|0)>-1){z=ia+((aa(g,$)|0)+n<<3)|0;t=+p[z>>3]}else t=+p[ja>>3];if((g|q|0)>-1){z=ia+((aa(g,$)|0)+q<<3)|0;x=+p[z>>3];z=59;break}else{x=+p[ja>>3];z=59;break}}while(0);if((z|0)==59){z=0;t=v*+o[a>>2]+w*+o[a+4>>2]+t*+o[a+8>>2]+x*+o[a+12>>2]}p[c>>3]=t;d=d+1|0;if((d|0)==(A|0))break;else c=c+8|0}b=A;a=l+(A-y<<3)|0;h=A;g=1;break}else{if(!a){b=y;a=l;h=A;g=1;break}u=l+(ha<<3)|0;s=aa(C,A+-1-y|0)|0;d=y;while(1){h=d<<1;a=j[D+(h<<1)>>1]|0;g=a<<16>>16;h=j[D+((h|1)<<1)>>1]|0;b=h<<16>>16;do if(R)if(h<<16>>16<-1|a<<16>>16>-2&(g|0)<(da|0)&(b|0)<(ea|0)^1){a=0;do{p[l+(a<<3)>>3]=+p[ja+(a<<3)>>3];a=a+1|0}while((a|0)!=(ha|0))}else{n=e+(m[E+(d<<1)>>1]<<2<<2)|0;z=67;break}else{n=e+(m[E+(d<<1)>>1]<<2<<2)|0;if(S){q=g+1|0;y=b+1|0;z=ia+((aa(h<<16>>16>-1?((b|0)<(ea|0)?b:ca):0,$)|0)<<3)|0;c=aa(a<<16>>16>-1?((g|0)<(da|0)?g:ba):0,ha)|0;b=aa(a<<16>>16>-2?((q|0)<(da|0)?q:ba):0,ha)|0;a=ia+((aa(h<<16>>16>-2?((y|0)<(ea|0)?y:ca):0,$)|0)<<3)|0;g=a+(b<<3)|0;a=a+(c<<3)|0;b=z+(b<<3)|0;c=z+(c<<3)|0;z=77}else z=67}while(0);do if((z|0)==67){z=0;if(P?!(g>>>0<ba>>>0&b>>>0<ca>>>0):0)break;q=uY(g,da,f)|0;g=uY(g+1|0,da,f)|0;a=uY(b,ea,f)|0;h=uY(b+1|0,ea,f)|0;if((a|q|0)>-1)c=ia+((aa(a,$)|0)<<3)+((aa(q,ha)|0)<<3)|0;else c=ja;if((a|g|0)>-1)b=ia+((aa(a,$)|0)<<3)+((aa(g,ha)|0)<<3)|0;else b=ja;if((h|q|0)>-1)a=ia+((aa(h,$)|0)<<3)+((aa(q,ha)|0)<<3)|0;else a=ja;if((h|g|0)<=-1){g=ja;z=77;break}g=ia+((aa(h,$)|0)<<3)+((aa(g,ha)|0)<<3)|0;z=77}while(0);if((z|0)==77){z=0;v=+o[n>>2];w=+o[n+4>>2];x=+o[n+8>>2];t=+o[n+12>>2];h=0;do{p[l+(h<<3)>>3]=+p[c+(h<<3)>>3]*v+ +p[b+(h<<3)>>3]*w+ +p[a+(h<<3)>>3]*x+ +p[g+(h<<3)>>3]*t;h=h+1|0}while((h|0)!=(ha|0))}d=d+1|0;if((d|0)==(A|0))break;else l=l+(ha<<3)|0}b=A;a=u+s|0;h=A;g=1;break}}else z=18;else{b=A;a=l;h=y}}while(0);a:do if((z|0)==18){z=0;switch(M&511){case 0:{if((A|0)>(y|0)){a=y;h=l}else{b=y;a=l;h=A;g=0;break a}while(1){s=a<<1;u=e+(m[E+(a<<1)>>1]<<2<<2)|0;s=ia+((aa(j[D+((s|1)<<1)>>1]|0,$)|0)<<3)+(j[D+(s<<1)>>1]<<3)|0;p[h>>3]=+p[s>>3]*+o[u>>2]+ +p[s+8>>3]*+o[u+4>>2]+ +p[s+($<<3)>>3]*+o[u+8>>2]+ +p[s+(F<<3)>>3]*+o[u+12>>2];a=a+1|0;if((a|0)==(A|0))break;else h=h+8|0}b=A;a=l+(A-y<<3)|0;h=A;g=0;break a}case 1:{if((A|0)<=(y|0)){b=y;a=l;h=A;g=0;break a}g=A-y|0;a=y;h=l;while(1){y=a<<1;u=e+(m[E+(a<<1)>>1]<<2<<2)|0;y=ia+((aa(j[D+((y|1)<<1)>>1]|0,$)|0)<<3)+(j[D+(y<<1)>>1]<<1<<3)|0;la=+o[u>>2];t=+o[u+4>>2];v=+o[u+8>>2];w=+o[u+12>>2];x=la*+p[y+8>>3]+t*+p[y+24>>3]+v*+p[y+(F<<3)>>3]+w*+p[y+(H<<3)>>3];p[h>>3]=+p[y>>3]*la+ +p[y+16>>3]*t+ +p[y+($<<3)>>3]*v+ +p[y+(G<<3)>>3]*w;p[h+8>>3]=x;a=a+1|0;if((a|0)==(A|0))break;else h=h+16|0}b=A;a=l+(g<<1<<3)|0;h=A;g=0;break a}case 2:{if((A|0)<=(y|0)){b=y;a=l;h=A;g=0;break a}g=A-y|0;a=y;h=l;while(1){y=a<<1;u=e+(m[E+(a<<1)>>1]<<2<<2)|0;y=ia+((aa(j[D+((y|1)<<1)>>1]|0,$)|0)<<3)+((j[D+(y<<1)>>1]|0)*3<<3)|0;ma=+o[u>>2];t=+o[u+4>>2];v=+o[u+8>>2];w=+o[u+12>>2];x=ma*+p[y+8>>3]+t*+p[y+32>>3]+v*+p[y+(F<<3)>>3]+w*+p[y+(I<<3)>>3];la=ma*+p[y+16>>3]+t*+p[y+40>>3]+v*+p[y+(G<<3)>>3]+w*+p[y+(J<<3)>>3];p[h>>3]=+p[y>>3]*ma+ +p[y+24>>3]*t+ +p[y+($<<3)>>3]*v+ +p[y+(H<<3)>>3]*w;p[h+8>>3]=x;p[h+16>>3]=la;a=a+1|0;if((a|0)==(A|0))break;else h=h+24|0}b=A;a=l+(g*3<<3)|0;h=A;g=0;break a}case 3:{if((A|0)<=(y|0)){b=y;a=l;h=A;g=0;break a}g=A-y|0;h=l;a=y;while(1){y=a<<1;u=e+(m[E+(a<<1)>>1]<<2<<2)|0;y=ia+((aa(j[D+((y|1)<<1)>>1]|0,$)|0)<<3)+(j[D+(y<<1)>>1]<<2<<3)|0;v=+o[u>>2];w=+o[u+4>>2];x=+o[u+8>>2];la=+o[u+12>>2];ma=v*+p[y+8>>3]+w*+p[y+40>>3]+x*+p[y+(F<<3)>>3]+la*+p[y+(J<<3)>>3];p[h>>3]=+p[y>>3]*v+ +p[y+32>>3]*w+ +p[y+($<<3)>>3]*x+ +p[y+(I<<3)>>3]*la;p[h+8>>3]=ma;ma=v*+p[y+24>>3]+w*+p[y+56>>3]+x*+p[y+(H<<3)>>3]+la*+p[y+(L<<3)>>3];p[h+16>>3]=+p[y+16>>3]*v+ +p[y+48>>3]*w+ +p[y+(G<<3)>>3]*x+ +p[y+(K<<3)>>3]*la;p[h+24>>3]=ma;a=a+1|0;if((a|0)==(A|0))break;else h=h+32|0}b=A;a=l+(g<<2<<3)|0;h=A;g=0;break a}default:{if((A|0)<=(y|0)){b=y;a=l;h=A;g=0;break a}q=l+(ha<<3)|0;n=aa(C,A+-1-y|0)|0;h=y;while(1){g=h<<1;a=e+(m[E+(h<<1)>>1]<<2<<2)|0;g=ia+((aa(j[D+((g|1)<<1)>>1]|0,$)|0)<<3)+((aa(j[D+(g<<1)>>1]|0,ha)|0)<<3)|0;t=+o[a>>2];v=+o[a+4>>2];w=+o[a+8>>2];x=+o[a+12>>2];a=0;do{y=a+$|0;p[l+(a<<3)>>3]=+p[g+(a<<3)>>3]*t+ +p[g+(a+ha<<3)>>3]*v+ +p[g+(y<<3)>>3]*w+ +p[g+(y+ha<<3)>>3]*x;a=a+1|0}while((a|0)!=(ha|0));h=h+1|0;if((h|0)==(A|0))break;else l=l+(ha<<3)|0}b=A;a=q+n|0;h=A;g=0;break a}}}while(0);if((b|0)<(fa|0)){A=b+1|0;l=a;y=h}else break}}B=B+1|0}while((B|0)!=(ga|0));r=ka;return}function $na(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+16|0;H=J;E=k[a+40>>2]|0;I=k[E+4>>2]|0;E=k[E>>2]|0;n=k[b+40>>2]|0;f=k[n+4>>2]|0;n=k[n>>2]|0;q=(k[a>>2]|0)>>>3&511;F=q+1|0;G=k[a+16>>2]|0;D=k[a+48>>2]|0;g=+p[e>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}m=~~g;m=(m>>>0<256?m:(m|0)>0?255:0)&255;g=+p[e+8>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}l=~~g;l=(l>>>0<256?l:(l|0)>0?255:0)&255;g=+p[e+16>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}h=~~g;h=(h>>>0<256?h:(h|0)>0?255:0)&255;g=+p[e+24>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}C=~~g;i[H>>0]=m;i[H+1>>0]=l;i[H+2>>0]=h;i[H+3>>0]=C>>>0<256?C:(C|0)>0?255:0;if(k[b>>2]&16384){C=(k[c>>2]&16384|0)!=0;f=aa(C?n:1,f)|0;if(C)C=1;else o=15}else o=15;if((o|0)==15)if((n|0)>0)C=n;else{r=J;return}B=b+16|0;z=b+44|0;A=c+16|0;y=c+44|0;b=(q|0)==0;c=(f|0)>0;q=I+-1|0;s=E+-1|0;t=(F|0)==3;v=(F|0)==4;w=(d|0)==5;o=0;do{n=(k[B>>2]|0)+(aa(k[k[z>>2]>>2]|0,o)|0)|0;x=(k[A>>2]|0)+(aa(k[k[y>>2]>>2]|0,o)|0)|0;a:do if(b){if(c){m=i[H>>0]|0;switch(d|0){case 1:{e=0;do{l=e<<1;a=j[x+(l<<1)>>1]|0;h=a<<16>>16;l=j[x+((l|1)<<1)>>1]|0;m=l<<16>>16;if(h>>>0<I>>>0&m>>>0<E>>>0)a=(aa(m,D)|0)+h|0;else a=(aa(l<<16>>16>-1?((m|0)<(E|0)?m:s):0,D)|0)+(a<<16>>16>-1?((h|0)<(I|0)?h:q):0)|0;i[n+e>>0]=i[G+a>>0]|0;e=e+1|0}while((e|0)!=(f|0));break}case 0:{l=0;do{h=l<<1;a=j[x+(h<<1)>>1]|0;h=j[x+((h|1)<<1)>>1]|0;if(a>>>0<I>>>0&h>>>0<E>>>0){a=G+((aa(h,D)|0)+a)|0;a=i[a>>0]|0}else a=m;i[n+l>>0]=a;l=l+1|0}while((l|0)!=(f|0));break}default:{a=0;do{l=a<<1;h=j[x+(l<<1)>>1]|0;l=j[x+((l|1)<<1)>>1]|0;if(!(h>>>0<I>>>0&l>>>0<E>>>0)){if(!w){e=uY(h,I,d)|0;e=G+((aa(uY(l,E,d)|0,D)|0)+e)|0;i[n+a>>0]=i[e>>0]|0}}else{e=G+((aa(l,D)|0)+h)|0;i[n+a>>0]=i[e>>0]|0}a=a+1|0}while((a|0)!=(f|0))}}}}else if(c){if(w){l=n;m=0;while(1){a=m<<1;h=j[x+(a<<1)>>1]|0;a=j[x+((a|1)<<1)>>1]|0;do if(h>>>0<I>>>0&a>>>0<E>>>0){a=G+(aa(a,D)|0)|0;if(t){n=a+(h*3|0)|0;i[l>>0]=i[n>>0]|0;i[l+1>>0]=i[n+1>>0]|0;i[l+2>>0]=i[n+2>>0]|0;break}if(v){n=a+(h<<2)|0;i[l>>0]=i[n>>0]|0;i[l+1>>0]=i[n+1>>0]|0;i[l+2>>0]=i[n+2>>0]|0;i[l+3>>0]=i[n+3>>0]|0;break}h=a+(aa(h,F)|0)|0;a=0;do{i[l+a>>0]=i[h+a>>0]|0;a=a+1|0}while((a|0)!=(F|0))}while(0);m=m+1|0;if((m|0)==(f|0))break a;else l=l+F|0}}else{e=n;n=0}while(1){h=n<<1;a=j[x+(h<<1)>>1]|0;m=a<<16>>16;h=j[x+((h|1)<<1)>>1]|0;l=h<<16>>16;b:do if(m>>>0<I>>>0&l>>>0<E>>>0){a=G+(aa(l,D)|0)|0;if(t){m=a+(m*3|0)|0;i[e>>0]=i[m>>0]|0;i[e+1>>0]=i[m+1>>0]|0;i[e+2>>0]=i[m+2>>0]|0;break}if(v){m=a+(m<<2)|0;i[e>>0]=i[m>>0]|0;i[e+1>>0]=i[m+1>>0]|0;i[e+2>>0]=i[m+2>>0]|0;i[e+3>>0]=i[m+3>>0]|0;break}h=a+(aa(m,F)|0)|0;a=0;do{i[e+a>>0]=i[h+a>>0]|0;a=a+1|0}while((a|0)!=(F|0))}else{switch(d|0){case 5:break b;case 1:{a=G+(aa(h<<16>>16>-1?((l|0)<(E|0)?l:s):0,D)|0)+(aa(a<<16>>16>-1?((m|0)<(I|0)?m:q):0,F)|0)|0;break}case 0:{a=H;break}default:{a=uY(m,I,d)|0;a=G+(aa(uY(l,E,d)|0,D)|0)+(aa(a,F)|0)|0}}h=0;do{i[e+h>>0]=i[a+h>>0]|0;h=h+1|0}while((h|0)!=(F|0))}while(0);n=n+1|0;if((n|0)==(f|0))break;else e=e+F|0}}while(0);o=o+1|0}while((o|0)!=(C|0));r=J;return}function aoa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+16|0;H=J;E=k[a+40>>2]|0;I=k[E+4>>2]|0;E=k[E>>2]|0;n=k[b+40>>2]|0;f=k[n+4>>2]|0;n=k[n>>2]|0;q=(k[a>>2]|0)>>>3&511;F=q+1|0;G=k[a+16>>2]|0;D=k[a+48>>2]|0;g=+p[e>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}m=~~g;m=((m+128|0)>>>0<256?m:(m|0)>0?127:128)&255;g=+p[e+8>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}l=~~g;l=((l+128|0)>>>0<256?l:(l|0)>0?127:128)&255;g=+p[e+16>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}h=~~g;h=((h+128|0)>>>0<256?h:(h|0)>0?127:128)&255;g=+p[e+24>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}C=~~g;i[H>>0]=m;i[H+1>>0]=l;i[H+2>>0]=h;i[H+3>>0]=(C+128|0)>>>0<256?C:(C|0)>0?127:128;if(k[b>>2]&16384){C=(k[c>>2]&16384|0)!=0;f=aa(C?n:1,f)|0;if(C)C=1;else o=15}else o=15;if((o|0)==15)if((n|0)>0)C=n;else{r=J;return}B=b+16|0;z=b+44|0;A=c+16|0;y=c+44|0;b=(q|0)==0;c=(f|0)>0;q=I+-1|0;s=E+-1|0;t=(F|0)==3;v=(F|0)==4;w=(d|0)==5;o=0;do{n=(k[B>>2]|0)+(aa(k[k[z>>2]>>2]|0,o)|0)|0;x=(k[A>>2]|0)+(aa(k[k[y>>2]>>2]|0,o)|0)|0;a:do if(b){if(c){m=i[H>>0]|0;switch(d|0){case 1:{e=0;do{l=e<<1;a=j[x+(l<<1)>>1]|0;h=a<<16>>16;l=j[x+((l|1)<<1)>>1]|0;m=l<<16>>16;if(h>>>0<I>>>0&m>>>0<E>>>0)a=(aa(m,D)|0)+h|0;else a=(aa(l<<16>>16>-1?((m|0)<(E|0)?m:s):0,D)|0)+(a<<16>>16>-1?((h|0)<(I|0)?h:q):0)|0;i[n+e>>0]=i[G+a>>0]|0;e=e+1|0}while((e|0)!=(f|0));break}case 0:{l=0;do{h=l<<1;a=j[x+(h<<1)>>1]|0;h=j[x+((h|1)<<1)>>1]|0;if(a>>>0<I>>>0&h>>>0<E>>>0){a=G+((aa(h,D)|0)+a)|0;a=i[a>>0]|0}else a=m;i[n+l>>0]=a;l=l+1|0}while((l|0)!=(f|0));break}default:{a=0;do{l=a<<1;h=j[x+(l<<1)>>1]|0;l=j[x+((l|1)<<1)>>1]|0;if(!(h>>>0<I>>>0&l>>>0<E>>>0)){if(!w){e=uY(h,I,d)|0;e=G+((aa(uY(l,E,d)|0,D)|0)+e)|0;i[n+a>>0]=i[e>>0]|0}}else{e=G+((aa(l,D)|0)+h)|0;i[n+a>>0]=i[e>>0]|0}a=a+1|0}while((a|0)!=(f|0))}}}}else if(c){if(w){l=n;m=0;while(1){a=m<<1;h=j[x+(a<<1)>>1]|0;a=j[x+((a|1)<<1)>>1]|0;do if(h>>>0<I>>>0&a>>>0<E>>>0){a=G+(aa(a,D)|0)|0;if(t){n=a+(h*3|0)|0;i[l>>0]=i[n>>0]|0;i[l+1>>0]=i[n+1>>0]|0;i[l+2>>0]=i[n+2>>0]|0;break}if(v){n=a+(h<<2)|0;i[l>>0]=i[n>>0]|0;i[l+1>>0]=i[n+1>>0]|0;i[l+2>>0]=i[n+2>>0]|0;i[l+3>>0]=i[n+3>>0]|0;break}h=a+(aa(h,F)|0)|0;a=0;do{i[l+a>>0]=i[h+a>>0]|0;a=a+1|0}while((a|0)!=(F|0))}while(0);m=m+1|0;if((m|0)==(f|0))break a;else l=l+F|0}}else{e=n;n=0}while(1){h=n<<1;a=j[x+(h<<1)>>1]|0;m=a<<16>>16;h=j[x+((h|1)<<1)>>1]|0;l=h<<16>>16;b:do if(m>>>0<I>>>0&l>>>0<E>>>0){a=G+(aa(l,D)|0)|0;if(t){m=a+(m*3|0)|0;i[e>>0]=i[m>>0]|0;i[e+1>>0]=i[m+1>>0]|0;i[e+2>>0]=i[m+2>>0]|0;break}if(v){m=a+(m<<2)|0;i[e>>0]=i[m>>0]|0;i[e+1>>0]=i[m+1>>0]|0;i[e+2>>0]=i[m+2>>0]|0;i[e+3>>0]=i[m+3>>0]|0;break}h=a+(aa(m,F)|0)|0;a=0;do{i[e+a>>0]=i[h+a>>0]|0;a=a+1|0}while((a|0)!=(F|0))}else{switch(d|0){case 5:break b;case 1:{a=G+(aa(h<<16>>16>-1?((l|0)<(E|0)?l:s):0,D)|0)+(aa(a<<16>>16>-1?((m|0)<(I|0)?m:q):0,F)|0)|0;break}case 0:{a=H;break}default:{a=uY(m,I,d)|0;a=G+(aa(uY(l,E,d)|0,D)|0)+(aa(a,F)|0)|0}}h=0;do{i[e+h>>0]=i[a+h>>0]|0;h=h+1|0}while((h|0)!=(F|0))}while(0);n=n+1|0;if((n|0)==(f|0))break;else e=e+F|0}}while(0);o=o+1|0}while((o|0)!=(C|0));r=J;return}function boa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0,i=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+16|0;H=J;E=k[a+40>>2]|0;I=k[E+4>>2]|0;E=k[E>>2]|0;m=k[b+40>>2]|0;f=k[m+4>>2]|0;m=k[m>>2]|0;o=(k[a>>2]|0)>>>3&511;F=o+1|0;G=k[a+16>>2]|0;D=(k[a+48>>2]|0)>>>1;g=+p[e>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}l=~~g;l=(l>>>0<65536?l:(l|0)>0?65535:0)&65535;g=+p[e+8>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}i=~~g;i=(i>>>0<65536?i:(i|0)>0?65535:0)&65535;g=+p[e+16>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}h=~~g;h=(h>>>0<65536?h:(h|0)>0?65535:0)&65535;g=+p[e+24>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}C=~~g;j[H>>1]=l;j[H+2>>1]=i;j[H+4>>1]=h;j[H+6>>1]=C>>>0<65536?C:(C|0)>0?65535:0;if(k[b>>2]&16384){C=(k[c>>2]&16384|0)!=0;f=aa(C?m:1,f)|0;if(C)C=1;else n=15}else n=15;if((n|0)==15)if((m|0)>0)C=m;else{r=J;return}B=b+16|0;z=b+44|0;A=c+16|0;y=c+44|0;b=(o|0)==0;c=(f|0)>0;o=I+-1|0;q=E+-1|0;s=(d|0)==1;t=(F|0)==3;v=(F|0)==4;w=(d|0)==5;n=0;do{m=(k[B>>2]|0)+(aa(k[k[z>>2]>>2]|0,n)|0)|0;x=(k[A>>2]|0)+(aa(k[k[y>>2]>>2]|0,n)|0)|0;a:do if(b){if(c){h=j[H>>1]|0;if(s){e=0;while(1){i=e<<1;a=j[x+(i<<1)>>1]|0;h=a<<16>>16;i=j[x+((i|1)<<1)>>1]|0;l=i<<16>>16;if(h>>>0<I>>>0&l>>>0<E>>>0)a=(aa(l,D)|0)+h|0;else a=(aa(i<<16>>16>-1?((l|0)<(E|0)?l:q):0,D)|0)+(a<<16>>16>-1?((h|0)<(I|0)?h:o):0)|0;j[m+(e<<1)>>1]=j[G+(a<<1)>>1]|0;e=e+1|0;if((e|0)==(f|0))break a}}else a=0;do{l=a<<1;i=j[x+(l<<1)>>1]|0;l=j[x+((l|1)<<1)>>1]|0;b:do if(i>>>0<I>>>0&l>>>0<E>>>0){e=G+((aa(l,D)|0)+i<<1)|0;j[m+(a<<1)>>1]=j[e>>1]|0}else switch(d|0){case 5:break b;case 0:{j[m+(a<<1)>>1]=h;break b}default:{e=G+((uY(i,I,d)|0)+(aa(uY(l,E,d)|0,D)|0)<<1)|0;j[m+(a<<1)>>1]=j[e>>1]|0;break b}}while(0);a=a+1|0}while((a|0)!=(f|0))}}else if(c){if(w){i=m;l=0;while(1){a=l<<1;h=j[x+(a<<1)>>1]|0;a=j[x+((a|1)<<1)>>1]|0;do if(h>>>0<I>>>0&a>>>0<E>>>0){a=G+((aa(a,D)|0)<<1)|0;if(t){m=a+(h*3<<1)|0;j[i>>1]=j[m>>1]|0;j[i+2>>1]=j[m+2>>1]|0;j[i+4>>1]=j[m+4>>1]|0;break}if(v){m=a+(h<<2<<1)|0;j[i>>1]=j[m>>1]|0;j[i+2>>1]=j[m+2>>1]|0;j[i+4>>1]=j[m+4>>1]|0;j[i+6>>1]=j[m+6>>1]|0;break}h=a+((aa(h,F)|0)<<1)|0;a=0;do{j[i+(a<<1)>>1]=j[h+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(F|0))}while(0);l=l+1|0;if((l|0)==(f|0))break a;else i=i+(F<<1)|0}}else{e=m;m=0}while(1){h=m<<1;a=j[x+(h<<1)>>1]|0;l=a<<16>>16;h=j[x+((h|1)<<1)>>1]|0;i=h<<16>>16;c:do if(l>>>0<I>>>0&i>>>0<E>>>0){a=G+((aa(i,D)|0)<<1)|0;if(t){l=a+(l*3<<1)|0;j[e>>1]=j[l>>1]|0;j[e+2>>1]=j[l+2>>1]|0;j[e+4>>1]=j[l+4>>1]|0;break}if(v){l=a+(l<<2<<1)|0;j[e>>1]=j[l>>1]|0;j[e+2>>1]=j[l+2>>1]|0;j[e+4>>1]=j[l+4>>1]|0;j[e+6>>1]=j[l+6>>1]|0;break}h=a+((aa(l,F)|0)<<1)|0;a=0;do{j[e+(a<<1)>>1]=j[h+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(F|0))}else{switch(d|0){case 5:break c;case 1:{a=G+((aa(h<<16>>16>-1?((i|0)<(E|0)?i:q):0,D)|0)<<1)+((aa(a<<16>>16>-1?((l|0)<(I|0)?l:o):0,F)|0)<<1)|0;break}case 0:{a=H;break}default:{a=uY(l,I,d)|0;a=G+((aa(uY(i,E,d)|0,D)|0)<<1)+((aa(a,F)|0)<<1)|0}}h=0;do{j[e+(h<<1)>>1]=j[a+(h<<1)>>1]|0;h=h+1|0}while((h|0)!=(F|0))}while(0);m=m+1|0;if((m|0)==(f|0))break;else e=e+(F<<1)|0}}while(0);n=n+1|0}while((n|0)!=(C|0));r=J;return}function coa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0,i=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+16|0;H=J;E=k[a+40>>2]|0;I=k[E+4>>2]|0;E=k[E>>2]|0;m=k[b+40>>2]|0;f=k[m+4>>2]|0;m=k[m>>2]|0;o=(k[a>>2]|0)>>>3&511;F=o+1|0;G=k[a+16>>2]|0;D=(k[a+48>>2]|0)>>>1;g=+p[e>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}l=~~g;l=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;g=+p[e+8>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}i=~~g;i=((i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768)&65535;g=+p[e+16>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}h=~~g;h=((h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768)&65535;g=+p[e+24>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}C=~~g;j[H>>1]=l;j[H+2>>1]=i;j[H+4>>1]=h;j[H+6>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;if(k[b>>2]&16384){C=(k[c>>2]&16384|0)!=0;f=aa(C?m:1,f)|0;if(C)C=1;else n=15}else n=15;if((n|0)==15)if((m|0)>0)C=m;else{r=J;return}B=b+16|0;z=b+44|0;A=c+16|0;y=c+44|0;b=(o|0)==0;c=(f|0)>0;o=I+-1|0;q=E+-1|0;s=(d|0)==1;t=(F|0)==3;v=(F|0)==4;w=(d|0)==5;n=0;do{m=(k[B>>2]|0)+(aa(k[k[z>>2]>>2]|0,n)|0)|0;x=(k[A>>2]|0)+(aa(k[k[y>>2]>>2]|0,n)|0)|0;a:do if(b){if(c){h=j[H>>1]|0;if(s){e=0;while(1){i=e<<1;a=j[x+(i<<1)>>1]|0;h=a<<16>>16;i=j[x+((i|1)<<1)>>1]|0;l=i<<16>>16;if(h>>>0<I>>>0&l>>>0<E>>>0)a=(aa(l,D)|0)+h|0;else a=(aa(i<<16>>16>-1?((l|0)<(E|0)?l:q):0,D)|0)+(a<<16>>16>-1?((h|0)<(I|0)?h:o):0)|0;j[m+(e<<1)>>1]=j[G+(a<<1)>>1]|0;e=e+1|0;if((e|0)==(f|0))break a}}else a=0;do{l=a<<1;i=j[x+(l<<1)>>1]|0;l=j[x+((l|1)<<1)>>1]|0;b:do if(i>>>0<I>>>0&l>>>0<E>>>0){e=G+((aa(l,D)|0)+i<<1)|0;j[m+(a<<1)>>1]=j[e>>1]|0}else switch(d|0){case 5:break b;case 0:{j[m+(a<<1)>>1]=h;break b}default:{e=G+((uY(i,I,d)|0)+(aa(uY(l,E,d)|0,D)|0)<<1)|0;j[m+(a<<1)>>1]=j[e>>1]|0;break b}}while(0);a=a+1|0}while((a|0)!=(f|0))}}else if(c){if(w){i=m;l=0;while(1){a=l<<1;h=j[x+(a<<1)>>1]|0;a=j[x+((a|1)<<1)>>1]|0;do if(h>>>0<I>>>0&a>>>0<E>>>0){a=G+((aa(a,D)|0)<<1)|0;if(t){m=a+(h*3<<1)|0;j[i>>1]=j[m>>1]|0;j[i+2>>1]=j[m+2>>1]|0;j[i+4>>1]=j[m+4>>1]|0;break}if(v){m=a+(h<<2<<1)|0;j[i>>1]=j[m>>1]|0;j[i+2>>1]=j[m+2>>1]|0;j[i+4>>1]=j[m+4>>1]|0;j[i+6>>1]=j[m+6>>1]|0;break}h=a+((aa(h,F)|0)<<1)|0;a=0;do{j[i+(a<<1)>>1]=j[h+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(F|0))}while(0);l=l+1|0;if((l|0)==(f|0))break a;else i=i+(F<<1)|0}}else{e=m;m=0}while(1){h=m<<1;a=j[x+(h<<1)>>1]|0;l=a<<16>>16;h=j[x+((h|1)<<1)>>1]|0;i=h<<16>>16;c:do if(l>>>0<I>>>0&i>>>0<E>>>0){a=G+((aa(i,D)|0)<<1)|0;if(t){l=a+(l*3<<1)|0;j[e>>1]=j[l>>1]|0;j[e+2>>1]=j[l+2>>1]|0;j[e+4>>1]=j[l+4>>1]|0;break}if(v){l=a+(l<<2<<1)|0;j[e>>1]=j[l>>1]|0;j[e+2>>1]=j[l+2>>1]|0;j[e+4>>1]=j[l+4>>1]|0;j[e+6>>1]=j[l+6>>1]|0;break}h=a+((aa(l,F)|0)<<1)|0;a=0;do{j[e+(a<<1)>>1]=j[h+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(F|0))}else{switch(d|0){case 5:break c;case 1:{a=G+((aa(h<<16>>16>-1?((i|0)<(E|0)?i:q):0,D)|0)<<1)+((aa(a<<16>>16>-1?((l|0)<(I|0)?l:o):0,F)|0)<<1)|0;break}case 0:{a=H;break}default:{a=uY(l,I,d)|0;a=G+((aa(uY(i,E,d)|0,D)|0)<<1)+((aa(a,F)|0)<<1)|0}}h=0;do{j[e+(h<<1)>>1]=j[a+(h<<1)>>1]|0;h=h+1|0}while((h|0)!=(F|0))}while(0);m=m+1|0;if((m|0)==(f|0))break;else e=e+(F<<1)|0}}while(0);n=n+1|0}while((n|0)!=(C|0));r=J;return}function doa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0,i=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=r;r=r+16|0;H=J;E=k[a+40>>2]|0;I=k[E+4>>2]|0;E=k[E>>2]|0;m=k[b+40>>2]|0;f=k[m+4>>2]|0;m=k[m>>2]|0;o=(k[a>>2]|0)>>>3&511;F=o+1|0;G=k[a+16>>2]|0;D=(k[a+48>>2]|0)>>>2;g=+p[e>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}l=~~g;g=+p[e+8>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}i=~~g;g=+p[e+16>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}h=~~g;g=+p[e+24>>3];p[u>>3]=g;a=k[u+4>>2]|0;C=a&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){a=(a|0)<0;g=a?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=a?-0.0:0.0}k[H>>2]=l;k[H+4>>2]=i;k[H+8>>2]=h;k[H+12>>2]=~~g;if(k[b>>2]&16384){C=(k[c>>2]&16384|0)!=0;f=aa(C?m:1,f)|0;if(C)C=1;else n=15}else n=15;if((n|0)==15)if((m|0)>0)C=m;else{r=J;return}B=b+16|0;z=b+44|0;A=c+16|0;y=c+44|0;b=(o|0)==0;c=(f|0)>0;o=I+-1|0;q=E+-1|0;s=(d|0)==1;t=(F|0)==3;v=(F|0)==4;w=(d|0)==5;n=0;do{m=(k[B>>2]|0)+(aa(k[k[z>>2]>>2]|0,n)|0)|0;x=(k[A>>2]|0)+(aa(k[k[y>>2]>>2]|0,n)|0)|0;a:do if(b){if(c){h=k[H>>2]|0;if(s){e=0;while(1){i=e<<1;a=j[x+(i<<1)>>1]|0;h=a<<16>>16;i=j[x+((i|1)<<1)>>1]|0;l=i<<16>>16;if(h>>>0<I>>>0&l>>>0<E>>>0)a=(aa(l,D)|0)+h|0;else a=(aa(i<<16>>16>-1?((l|0)<(E|0)?l:q):0,D)|0)+(a<<16>>16>-1?((h|0)<(I|0)?h:o):0)|0;k[m+(e<<2)>>2]=k[G+(a<<2)>>2];e=e+1|0;if((e|0)==(f|0))break a}}else a=0;do{l=a<<1;i=j[x+(l<<1)>>1]|0;l=j[x+((l|1)<<1)>>1]|0;b:do if(i>>>0<I>>>0&l>>>0<E>>>0){e=G+((aa(l,D)|0)+i<<2)|0;k[m+(a<<2)>>2]=k[e>>2]}else switch(d|0){case 5:break b;case 0:{k[m+(a<<2)>>2]=h;break b}default:{e=G+((uY(i,I,d)|0)+(aa(uY(l,E,d)|0,D)|0)<<2)|0;k[m+(a<<2)>>2]=k[e>>2];break b}}while(0);a=a+1|0}while((a|0)!=(f|0))}}else if(c){if(w){i=m;l=0;while(1){a=l<<1;h=j[x+(a<<1)>>1]|0;a=j[x+((a|1)<<1)>>1]|0;do if(h>>>0<I>>>0&a>>>0<E>>>0){a=G+((aa(a,D)|0)<<2)|0;if(t){m=a+(h*3<<2)|0;k[i>>2]=k[m>>2];k[i+4>>2]=k[m+4>>2];k[i+8>>2]=k[m+8>>2];break}if(v){m=a+(h<<2<<2)|0;k[i>>2]=k[m>>2];k[i+4>>2]=k[m+4>>2];k[i+8>>2]=k[m+8>>2];k[i+12>>2]=k[m+12>>2];break}h=a+((aa(h,F)|0)<<2)|0;a=0;do{k[i+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)!=(F|0))}while(0);l=l+1|0;if((l|0)==(f|0))break a;else i=i+(F<<2)|0}}else{e=m;m=0}while(1){h=m<<1;a=j[x+(h<<1)>>1]|0;l=a<<16>>16;h=j[x+((h|1)<<1)>>1]|0;i=h<<16>>16;c:do if(l>>>0<I>>>0&i>>>0<E>>>0){a=G+((aa(i,D)|0)<<2)|0;if(t){l=a+(l*3<<2)|0;k[e>>2]=k[l>>2];k[e+4>>2]=k[l+4>>2];k[e+8>>2]=k[l+8>>2];break}if(v){l=a+(l<<2<<2)|0;k[e>>2]=k[l>>2];k[e+4>>2]=k[l+4>>2];k[e+8>>2]=k[l+8>>2];k[e+12>>2]=k[l+12>>2];break}h=a+((aa(l,F)|0)<<2)|0;a=0;do{k[e+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)!=(F|0))}else{switch(d|0){case 5:break c;case 1:{a=G+((aa(h<<16>>16>-1?((i|0)<(E|0)?i:q):0,D)|0)<<2)+((aa(a<<16>>16>-1?((l|0)<(I|0)?l:o):0,F)|0)<<2)|0;break}case 0:{a=H;break}default:{a=uY(l,I,d)|0;a=G+((aa(uY(i,E,d)|0,D)|0)<<2)+((aa(a,F)|0)<<2)|0}}h=0;do{k[e+(h<<2)>>2]=k[a+(h<<2)>>2];h=h+1|0}while((h|0)!=(F|0))}while(0);m=m+1|0;if((m|0)==(f|0))break;else e=e+(F<<2)|0}}while(0);n=n+1|0}while((n|0)!=(C|0));r=J;return}function eoa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0;I=r;r=r+16|0;G=I;D=k[a+40>>2]|0;H=k[D+4>>2]|0;D=k[D>>2]|0;g=k[b+40>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;i=(k[a>>2]|0)>>>3&511;E=i+1|0;F=k[a+16>>2]|0;C=(k[a+48>>2]|0)>>>2;L=+p[e+8>>3];K=+p[e+16>>3];J=+p[e+24>>3];o[G>>2]=+p[e>>3];o[G+4>>2]=L;o[G+8>>2]=K;o[G+12>>2]=J;if(k[b>>2]&16384){B=(k[c>>2]&16384|0)!=0;f=aa(B?g:1,f)|0;if(B)g=1;else h=3}else h=3;if((h|0)==3)if((g|0)<=0){r=I;return}B=b+16|0;z=b+44|0;A=c+16|0;y=c+44|0;m=(i|0)==0;n=(f|0)>0;q=H+-1|0;s=D+-1|0;t=(d|0)==1;u=(E|0)==3;v=(E|0)==4;w=(d|0)==5;l=0;do{i=(k[B>>2]|0)+(aa(k[k[z>>2]>>2]|0,l)|0)|0;x=(k[A>>2]|0)+(aa(k[k[y>>2]>>2]|0,l)|0)|0;a:do if(m){if(n){e=k[G>>2]|0;if(t){a=0;while(1){b=a<<1;e=j[x+(b<<1)>>1]|0;h=e<<16>>16;b=j[x+((b|1)<<1)>>1]|0;c=b<<16>>16;if(h>>>0<H>>>0&c>>>0<D>>>0){c=F+((aa(c,C)|0)+h<<2)|0;k[i+(a<<2)>>2]=k[c>>2]}else{c=F+((aa(b<<16>>16>-1?((c|0)<(D|0)?c:s):0,C)|0)+(e<<16>>16>-1?((h|0)<(H|0)?h:q):0)<<2)|0;k[i+(a<<2)>>2]=k[c>>2]}a=a+1|0;if((a|0)==(f|0))break a}}else a=0;do{b=a<<1;h=j[x+(b<<1)>>1]|0;b=j[x+((b|1)<<1)>>1]|0;b:do if(h>>>0<H>>>0&b>>>0<D>>>0){c=F+((aa(b,C)|0)+h<<2)|0;k[i+(a<<2)>>2]=k[c>>2]}else switch(d|0){case 5:break b;case 0:{k[i+(a<<2)>>2]=e;break b}default:{c=F+((uY(h,H,d)|0)+(aa(uY(b,D,d)|0,C)|0)<<2)|0;k[i+(a<<2)>>2]=k[c>>2];break b}}while(0);a=a+1|0}while((a|0)!=(f|0))}}else if(n){if(w){h=i;b=0;while(1){a=b<<1;e=j[x+(a<<1)>>1]|0;a=j[x+((a|1)<<1)>>1]|0;do if(e>>>0<H>>>0&a>>>0<D>>>0){a=F+((aa(a,C)|0)<<2)|0;if(u){i=a+(e*3<<2)|0;k[h>>2]=k[i>>2];k[h+4>>2]=k[i+4>>2];k[h+8>>2]=k[i+8>>2];break}if(v){i=a+(e<<2<<2)|0;k[h>>2]=k[i>>2];k[h+4>>2]=k[i+4>>2];k[h+8>>2]=k[i+8>>2];k[h+12>>2]=k[i+12>>2];break}e=a+((aa(e,E)|0)<<2)|0;a=0;do{k[h+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)!=(E|0))}while(0);b=b+1|0;if((b|0)==(f|0))break a;else h=h+(E<<2)|0}}else c=0;while(1){e=c<<1;a=j[x+(e<<1)>>1]|0;b=a<<16>>16;e=j[x+((e|1)<<1)>>1]|0;h=e<<16>>16;c:do if(b>>>0<H>>>0&h>>>0<D>>>0){a=F+((aa(h,C)|0)<<2)|0;if(u){b=a+(b*3<<2)|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];k[i+8>>2]=k[b+8>>2];break}if(v){b=a+(b<<2<<2)|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];k[i+8>>2]=k[b+8>>2];k[i+12>>2]=k[b+12>>2];break}e=a+((aa(b,E)|0)<<2)|0;a=0;do{k[i+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)!=(E|0))}else{switch(d|0){case 5:break c;case 1:{a=F+((aa(e<<16>>16>-1?((h|0)<(D|0)?h:s):0,C)|0)<<2)+((aa(a<<16>>16>-1?((b|0)<(H|0)?b:q):0,E)|0)<<2)|0;break}case 0:{a=G;break}default:{a=uY(b,H,d)|0;a=F+((aa(uY(h,D,d)|0,C)|0)<<2)+((aa(a,E)|0)<<2)|0}}e=0;do{k[i+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)!=(E|0))}while(0);c=c+1|0;if((c|0)==(f|0))break;else i=i+(E<<2)|0}}while(0);l=l+1|0}while((l|0)!=(g|0));r=I;return}function foa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0.0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0;I=r;r=r+32|0;G=I;D=k[a+40>>2]|0;H=k[D+4>>2]|0;D=k[D>>2]|0;g=k[b+40>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;i=(k[a>>2]|0)>>>3&511;E=i+1|0;F=k[a+16>>2]|0;C=(k[a+48>>2]|0)>>>3;K=+p[e+8>>3];J=+p[e+16>>3];l=+p[e+24>>3];p[G>>3]=+p[e>>3];p[G+8>>3]=K;p[G+16>>3]=J;p[G+24>>3]=l;if(k[b>>2]&16384){B=(k[c>>2]&16384|0)!=0;f=aa(B?g:1,f)|0;if(B)g=1;else h=3}else h=3;if((h|0)==3)if((g|0)<=0){r=I;return}B=b+16|0;z=b+44|0;A=c+16|0;y=c+44|0;n=(i|0)==0;o=(f|0)>0;q=H+-1|0;s=D+-1|0;t=(d|0)==1;u=(E|0)==3;v=(E|0)==4;w=(d|0)==5;m=0;do{i=(k[B>>2]|0)+(aa(k[k[z>>2]>>2]|0,m)|0)|0;x=(k[A>>2]|0)+(aa(k[k[y>>2]>>2]|0,m)|0)|0;a:do if(n){if(o){l=+p[G>>3];if(t){c=0;while(1){h=c<<1;a=j[x+(h<<1)>>1]|0;e=a<<16>>16;h=j[x+((h|1)<<1)>>1]|0;b=h<<16>>16;if(e>>>0<H>>>0&b>>>0<D>>>0)a=(aa(b,C)|0)+e|0;else a=(aa(h<<16>>16>-1?((b|0)<(D|0)?b:s):0,C)|0)+(a<<16>>16>-1?((e|0)<(H|0)?e:q):0)|0;p[i+(c<<3)>>3]=+p[F+(a<<3)>>3];c=c+1|0;if((c|0)==(f|0))break a}}else a=0;do{h=a<<1;e=j[x+(h<<1)>>1]|0;h=j[x+((h|1)<<1)>>1]|0;b:do if(e>>>0<H>>>0&h>>>0<D>>>0){c=F+((aa(h,C)|0)+e<<3)|0;p[i+(a<<3)>>3]=+p[c>>3]}else switch(d|0){case 5:break b;case 0:{p[i+(a<<3)>>3]=l;break b}default:{c=F+((uY(e,H,d)|0)+(aa(uY(h,D,d)|0,C)|0)<<3)|0;p[i+(a<<3)>>3]=+p[c>>3];break b}}while(0);a=a+1|0}while((a|0)!=(f|0))}}else if(o){if(w){h=i;b=0;while(1){a=b<<1;e=j[x+(a<<1)>>1]|0;a=j[x+((a|1)<<1)>>1]|0;do if(e>>>0<H>>>0&a>>>0<D>>>0){a=F+((aa(a,C)|0)<<3)|0;if(u){i=a+(e*3<<3)|0;p[h>>3]=+p[i>>3];p[h+8>>3]=+p[i+8>>3];p[h+16>>3]=+p[i+16>>3];break}if(v){i=a+(e<<2<<3)|0;p[h>>3]=+p[i>>3];p[h+8>>3]=+p[i+8>>3];p[h+16>>3]=+p[i+16>>3];p[h+24>>3]=+p[i+24>>3];break}e=a+((aa(e,E)|0)<<3)|0;a=0;do{p[h+(a<<3)>>3]=+p[e+(a<<3)>>3];a=a+1|0}while((a|0)!=(E|0))}while(0);b=b+1|0;if((b|0)==(f|0))break a;else h=h+(E<<3)|0}}else{c=i;i=0}while(1){e=i<<1;a=j[x+(e<<1)>>1]|0;b=a<<16>>16;e=j[x+((e|1)<<1)>>1]|0;h=e<<16>>16;c:do if(b>>>0<H>>>0&h>>>0<D>>>0){a=F+((aa(h,C)|0)<<3)|0;if(u){b=a+(b*3<<3)|0;p[c>>3]=+p[b>>3];p[c+8>>3]=+p[b+8>>3];p[c+16>>3]=+p[b+16>>3];break}if(v){b=a+(b<<2<<3)|0;p[c>>3]=+p[b>>3];p[c+8>>3]=+p[b+8>>3];p[c+16>>3]=+p[b+16>>3];p[c+24>>3]=+p[b+24>>3];break}e=a+((aa(b,E)|0)<<3)|0;a=0;do{p[c+(a<<3)>>3]=+p[e+(a<<3)>>3];a=a+1|0}while((a|0)!=(E|0))}else{switch(d|0){case 5:break c;case 1:{a=F+((aa(e<<16>>16>-1?((h|0)<(D|0)?h:s):0,C)|0)<<3)+((aa(a<<16>>16>-1?((b|0)<(H|0)?b:q):0,E)|0)<<3)|0;break}case 0:{a=G;break}default:{a=uY(b,H,d)|0;a=F+((aa(uY(h,D,d)|0,C)|0)<<3)+((aa(a,E)|0)<<3)|0}}e=0;do{p[c+(e<<3)>>3]=+p[a+(e<<3)>>3];e=e+1|0}while((e|0)!=(E|0))}while(0);i=i+1|0;if((i|0)==(f|0))break;else c=c+(E<<3)|0}}while(0);m=m+1|0}while((m|0)!=(g|0));r=I;return}function goa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0,n=0,p=0,q=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0;ba=r;r=r+368|0;$=ba+312|0;_=ba+256|0;Z=ba+200|0;X=ba+144|0;V=ba+32|0;v=ba+24|0;w=ba+16|0;D=ba;do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[$>>2]=k[l>>2];s=$+4|0;a=l+4|0;k[s>>2]=k[a>>2];Y=$+8|0;k[Y>>2]=k[l+8>>2];k[$+12>>2]=k[l+12>>2];k[$+16>>2]=k[l+16>>2];k[$+20>>2]=k[l+20>>2];k[$+24>>2]=k[l+24>>2];k[$+28>>2]=k[l+28>>2];k[$+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[$+36>>2]=g;h=$+40|0;k[h>>2]=Y;Y=$+48|0;p=$+44|0;k[p>>2]=Y;k[$+52>>2]=0;k[Y>>2]=0;if(g|0){Y=g+12|0;k[Y>>2]=(k[Y>>2]|0)+1}if((k[a>>2]|0)<3){U=k[l+44>>2]|0;Y=k[p>>2]|0;k[Y>>2]=k[U>>2];k[Y+4>>2]=k[U+4>>2];break}k[s>>2]=0;x1($,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[l+40>>2]|0;n=k[h>>2]|0;h=k[l+44>>2]|0;g=k[p>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[q+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else Q1($,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){n=k[b+4>>2]|0;k[_>>2]=k[n>>2];s=_+4|0;g=n+4|0;k[s>>2]=k[g>>2];Y=_+8|0;k[Y>>2]=k[n+8>>2];k[_+12>>2]=k[n+12>>2];k[_+16>>2]=k[n+16>>2];k[_+20>>2]=k[n+20>>2];k[_+24>>2]=k[n+24>>2];k[_+28>>2]=k[n+28>>2];k[_+32>>2]=k[n+32>>2];a=k[n+36>>2]|0;k[_+36>>2]=a;h=_+40|0;k[h>>2]=Y;Y=_+48|0;p=_+44|0;k[p>>2]=Y;k[_+52>>2]=0;k[Y>>2]=0;if(a|0){Y=a+12|0;k[Y>>2]=(k[Y>>2]|0)+1}if((k[g>>2]|0)<3){Y=k[n+44>>2]|0;a=k[p>>2]|0;k[a>>2]=k[Y>>2];k[a+4>>2]=k[Y+4>>2];a=_;break}k[s>>2]=0;x1(_,k[g>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[n+40>>2]|0;l=k[h>>2]|0;h=k[n+44>>2]|0;g=k[p>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[q+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0));a=_}else a=_}else{Q1(_,b,-1);a=_}while(0);k[Z>>2]=1124007936;S=Z+4|0;x=Z+8|0;R=Z+40|0;l=S;s=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(s|0));k[R>>2]=x;U=Z+48|0;T=Z+44|0;k[T>>2]=U;k[Z+52>>2]=0;k[U>>2]=0;k[X>>2]=1124007936;O=X+4|0;M=X+8|0;N=X+40|0;l=O;s=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(s|0));k[N>>2]=M;Q=X+48|0;P=X+44|0;k[P>>2]=Q;k[X+52>>2]=0;k[Q>>2]=0;Y=$+40|0;C=k[Y>>2]|0;E=k[C+4>>2]|0;C=k[C>>2]|0;q=$;s=_;p=k[$>>2]&4095;n=k[a>>2]&4095;if((p|0)==11?(n|1|0)==3|f:0)K=34;else K=21;do if((K|0)==21){if((n|0)==11){if((p|1|0)==3|f){K=35;break}}else if((p|0)==5&(n|0)==5){K=34;break}if((p|0)==13){if(!(k[_+16>>2]|0)){K=34;break}h=k[_+4>>2]|0;if((h|0)<3)a=aa(k[_+12>>2]|0,k[_+8>>2]|0)|0;else{l=k[_+40>>2]|0;g=0;a=1;do{a=aa(k[l+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a){K=34;break}}k[V>>2]=0;L=V+4|0;k[L>>2]=0;a=ZT(260)|0;k[a>>2]=1;K=a+4|0;k[V>>2]=K;k[L>>2]=255;i[a+259>>0]=0;upb(K|0,338446,255)|0;Y8(-215,V,338702,335515,4789);k[L>>2]=0;k[V>>2]=0;L=k[a>>2]|0;k[a>>2]=L+-1;if((L|0)==1)ggb(k[a+-4>>2]|0);K=34}while(0);if((K|0)==34)if((n|0)==11)K=35;else{L=s;J=q}if((K|0)==35){p=11;L=q;J=s}I=(p|0)==11;e=(e|0)<1?(I?13:11):e;F=(e|0)==11;G=(e|0)==5;H=(e|0)==13;switch(e|0){case 5:case 11:case 13:break;default:{k[V>>2]=0;a=V+4|0;k[a>>2]=0;g=ZT(76)|0;k[g>>2]=1;l=g+4|0;k[V>>2]=l;k[a>>2]=71;i[g+75>>0]=0;h=338714;s=l+71|0;do{i[l>>0]=i[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(s|0));Y8(-215,V,338702,335515,4799);k[a>>2]=0;k[V>>2]=0;B=k[g>>2]|0;k[g>>2]=B+-1;if((B|0)==1)ggb(k[g+-4>>2]|0)}}k[v>>2]=E;k[v+4>>2]=C;x2(c,v,e,0);do if((k[c>>2]&2031616|0)==65536){l=k[c+4>>2]|0;k[V>>2]=k[l>>2];b=V+4|0;a=l+4|0;k[b>>2]=k[a>>2];B=V+8|0;k[B>>2]=k[l+8>>2];k[V+12>>2]=k[l+12>>2];k[V+16>>2]=k[l+16>>2];k[V+20>>2]=k[l+20>>2];k[V+24>>2]=k[l+24>>2];k[V+28>>2]=k[l+28>>2];k[V+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[V+36>>2]=g;h=V+40|0;k[h>>2]=B;B=V+48|0;q=V+44|0;k[q>>2]=B;k[V+52>>2]=0;k[B>>2]=0;if(g|0){B=g+12|0;k[B>>2]=(k[B>>2]|0)+1}if((k[a>>2]|0)<3){A=k[l+44>>2]|0;B=k[q>>2]|0;k[B>>2]=k[A>>2];k[B+4>>2]=k[A+4>>2];break}k[b>>2]=0;x1(V,k[a>>2]|0,0,0,0);if((k[b>>2]|0)>0){s=k[l+40>>2]|0;n=k[h>>2]|0;h=k[l+44>>2]|0;g=k[q>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[s+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[b>>2]|0))}}else Q1(V,c,-1);while(0);KG(Z,V)|0;h=V+36|0;a=k[h>>2]|0;if(a|0?(A=a+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[V+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;B=V+16|0;g=V+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[g>>2]|0)>0){h=k[V+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[V+44>>2]|0;if(!((a|0)==(V+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);if((e|0)!=13&(f^1)){k[w>>2]=E;k[w+4>>2]=C;x2(d,w,F?2:5,0);do if((k[d>>2]&2031616|0)==65536){l=k[d+4>>2]|0;k[V>>2]=k[l>>2];b=V+4|0;a=l+4|0;k[b>>2]=k[a>>2];B=V+8|0;k[B>>2]=k[l+8>>2];k[V+12>>2]=k[l+12>>2];k[V+16>>2]=k[l+16>>2];k[V+20>>2]=k[l+20>>2];k[V+24>>2]=k[l+24>>2];k[V+28>>2]=k[l+28>>2];k[V+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[V+36>>2]=g;h=V+40|0;k[h>>2]=B;B=V+48|0;q=V+44|0;k[q>>2]=B;k[V+52>>2]=0;k[B>>2]=0;if(g|0){B=g+12|0;k[B>>2]=(k[B>>2]|0)+1}if((k[a>>2]|0)<3){A=k[l+44>>2]|0;B=k[q>>2]|0;k[B>>2]=k[A>>2];k[B+4>>2]=k[A+4>>2];break}k[b>>2]=0;x1(V,k[a>>2]|0,0,0,0);if((k[b>>2]|0)>0){s=k[l+40>>2]|0;n=k[h>>2]|0;h=k[l+44>>2]|0;g=k[q>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[s+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[b>>2]|0))}}else Q1(V,d,-1);while(0);KG(X,V)|0;h=V+36|0;a=k[h>>2]|0;if(a|0?(A=a+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[V+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;B=V+16|0;g=V+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[g>>2]|0)>0){h=k[V+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[V+44>>2]|0;if(!((a|0)==(V+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else b2(d);do if((p|0)==(e|0))K=90;else{if(f?I&H|(p|0)==13&F:0){K=90;break}b=(p|0)==5;if(b&H){h=J;k[V>>2]=k[h>>2];A=V+4|0;a=h+4|0;k[A>>2]=k[a>>2];C=V+8|0;k[C>>2]=k[h+8>>2];k[V+12>>2]=k[h+12>>2];x=V+16|0;k[x>>2]=k[h+16>>2];k[V+20>>2]=k[h+20>>2];k[V+24>>2]=k[h+24>>2];k[V+28>>2]=k[h+28>>2];d=V+32|0;k[d>>2]=k[h+32>>2];y=V+36|0;g=k[h+36>>2]|0;k[y>>2]=g;z=V+40|0;k[z>>2]=C;C=V+48|0;B=V+44|0;k[B>>2]=C;k[V+52>>2]=0;k[C>>2]=0;if(g|0){f=g+12|0;k[f>>2]=(k[f>>2]|0)+1}if((k[a>>2]|0)>=3){k[A>>2]=0;x1(V,k[a>>2]|0,0,0,0);if((k[A>>2]|0)>0){l=k[h+40>>2]|0;n=k[z>>2]|0;g=k[h+44>>2]|0;h=k[B>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[l+(a<<2)>>2];k[h+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[A>>2]|0))}}else{I=k[h+44>>2]|0;f=k[B>>2]|0;k[f>>2]=k[I>>2];k[f+4>>2]=k[I+4>>2]}a=V+56|0;l=L;k[a>>2]=k[l>>2];v=V+60|0;g=l+4|0;k[v>>2]=k[g>>2];w=V+64|0;k[w>>2]=k[l+8>>2];k[V+68>>2]=k[l+12>>2];s=V+72|0;k[s>>2]=k[l+16>>2];k[V+76>>2]=k[l+20>>2];k[V+80>>2]=k[l+24>>2];k[V+84>>2]=k[l+28>>2];q=V+88|0;k[q>>2]=k[l+32>>2];b=V+92|0;h=k[l+36>>2]|0;k[b>>2]=h;e=V+96|0;k[e>>2]=w;w=V+104|0;c=V+100|0;k[c>>2]=w;k[V+108>>2]=0;k[w>>2]=0;if(h|0){f=h+12|0;k[f>>2]=(k[f>>2]|0)+1}if((k[g>>2]|0)>=3){k[v>>2]=0;x1(a,k[g>>2]|0,0,0,0);if((k[v>>2]|0)>0){n=k[l+40>>2]|0;p=k[e>>2]|0;g=k[l+44>>2]|0;h=k[c>>2]|0;a=0;do{k[p+(a<<2)>>2]=k[n+(a<<2)>>2];k[h+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else{I=k[l+44>>2]|0;f=k[c>>2]|0;k[f>>2]=k[I>>2];k[f+4>>2]=k[I+4>>2]}a=D+4|0;f=a+4|0;k[f>>2]=0;k[f+4>>2]=0;k[D>>2]=33619968;k[a>>2]=Z;GV(V,2,D);a=k[b>>2]|0;if(a|0?(I=a+12|0,f=k[I>>2]|0,k[I>>2]=f+-1,(f|0)==1):0){g=k[b>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[q>>2]|0;if(a|0)break;a=B1()|0;g=k[b>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[b>>2]=0}k[b>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[v>>2]|0)>0){g=k[e>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[v>>2]|0))}a=k[c>>2]|0;if(!((a|0)==(w|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[y>>2]|0;do if(a|0){I=a+12|0;f=k[I>>2]|0;k[I>>2]=f+-1;if((f|0)!=1)break;g=k[y>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[d>>2]|0;if(a|0)break;a=B1()|0;g=k[y>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[y>>2]=0}while(0);k[y>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[A>>2]|0)>0){g=k[z>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[B>>2]|0;if(!((a|0)==(C|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break}e=(p|0)==13;if(e&G){k[V>>2]=k[Z>>2];A=V+4|0;a=k[S>>2]|0;k[A>>2]=a;B=V+8|0;k[B>>2]=k[x>>2];k[V+12>>2]=k[Z+12>>2];d=V+16|0;k[d>>2]=k[Z+16>>2];k[V+20>>2]=k[Z+20>>2];k[V+24>>2]=k[Z+24>>2];k[V+28>>2]=k[Z+28>>2];w=V+32|0;k[w>>2]=k[Z+32>>2];x=V+36|0;g=k[Z+36>>2]|0;k[x>>2]=g;y=V+40|0;k[y>>2]=B;B=V+48|0;z=V+44|0;k[z>>2]=B;k[V+52>>2]=0;k[B>>2]=0;if(g){a=g+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[S>>2]|0}if((a|0)>=3){k[A>>2]=0;x1(V,a,0,0,0);if((k[A>>2]|0)>0){g=k[R>>2]|0;h=k[y>>2]|0;l=k[T>>2]|0;n=k[z>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[g+(a<<2)>>2];k[n+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[A>>2]|0))}}else{I=k[T>>2]|0;f=k[z>>2]|0;k[f>>2]=k[I>>2];k[f+4>>2]=k[I+4>>2]}h=V+56|0;k[h>>2]=k[X>>2];e=V+60|0;a=k[O>>2]|0;k[e>>2]=a;c=V+64|0;k[c>>2]=k[M>>2];k[V+68>>2]=k[X+12>>2];q=V+72|0;k[q>>2]=k[X+16>>2];k[V+76>>2]=k[X+20>>2];k[V+80>>2]=k[X+24>>2];k[V+84>>2]=k[X+28>>2];p=V+88|0;k[p>>2]=k[X+32>>2];s=V+92|0;g=k[X+36>>2]|0;k[s>>2]=g;b=V+96|0;k[b>>2]=c;c=V+104|0;v=V+100|0;k[v>>2]=c;k[V+108>>2]=0;k[c>>2]=0;if(g){a=g+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[O>>2]|0}if((a|0)>=3){k[e>>2]=0;x1(h,a,0,0,0);if((k[e>>2]|0)>0){g=k[N>>2]|0;h=k[b>>2]|0;l=k[P>>2]|0;n=k[v>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[g+(a<<2)>>2];k[n+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[e>>2]|0))}}else{I=k[P>>2]|0;f=k[v>>2]|0;k[f>>2]=k[I>>2];k[f+4>>2]=k[I+4>>2]}EV(J,V);a=k[s>>2]|0;do if(a|0){I=a+12|0;f=k[I>>2]|0;k[I>>2]=f+-1;if((f|0)!=1)break;g=k[s>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[p>>2]|0;if(a|0)break;a=B1()|0;g=k[s>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[s>>2]=0}while(0);k[s>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[e>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[v>>2]|0;if(!((a|0)==(c|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[x>>2]|0;do if(a|0){I=a+12|0;f=k[I>>2]|0;k[I>>2]=f+-1;if((f|0)!=1)break;g=k[x>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[w>>2]|0;if(a|0)break;a=B1()|0;g=k[x>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[x>>2]=0}while(0);k[x>>2]=0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[A>>2]|0)>0){g=k[y>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break}s=J;a:do if(k[s>>2]&16384){p=L;q=p+16|0;if(k[q>>2]|0){h=k[p+4>>2]|0;if((h|0)<3)a=aa(k[p+12>>2]|0,k[p+8>>2]|0)|0;else{l=k[p+40>>2]|0;g=0;a=1;do{a=aa(k[l+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(a|0?(k[p>>2]&16384|0)==0:0){K=173;break}}if(k[Z>>2]&16384){n=X+16|0;do if(k[n>>2]|0){h=k[O>>2]|0;if((h|0)<3)a=aa(k[X+12>>2]|0,k[M>>2]|0)|0;else{l=k[N>>2]|0;g=0;a=1;do{a=aa(k[l+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)break;if(!(k[X>>2]&16384)){K=173;break a}}while(0);a=p;E=aa(C,E)|0;C=1}else K=173}else K=173;while(0);if((K|0)==173){if((C|0)<=0)break;q=L;a=q;q=q+16|0;n=X+16|0}D=s+16|0;B=s+44|0;z=a+44|0;A=Z+16|0;y=b&F;x=(E|0)>0;d=e&F;w=I&G;c=I&H;v=V+4|0;e=0;do{s=(k[D>>2]|0)+(aa(k[k[B>>2]>>2]|0,e)|0)|0;l=(k[q>>2]|0)+(aa(k[k[z>>2]>>2]|0,e)|0)|0;b=(k[A>>2]|0)+(aa(k[k[T>>2]>>2]|0,e)|0)|0;p=(k[n>>2]|0)+(aa(k[k[P>>2]>>2]|0,e)|0)|0;b:do if(y)if(f){if(x)g=0;else break;do{t=+o[s+(g<<2)>>2];a=(o[u>>2]=t,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(!(t==0.0))break;t=a?-0.0:0.0}while(0);a=~~t;j[b+(g<<2)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;t=+o[l+(g<<2)>>2];a=(o[u>>2]=t,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(!(t==0.0))break;t=a?-0.0:0.0}while(0);I=~~t;j[b+((g<<1|1)<<1)>>1]=(I+32768|0)>>>0<65536?I:(I|0)>0?32767:32768;g=g+1|0}while((g|0)!=(E|0))}else{if(x)h=0;else break;do{t=+o[s+(h<<2)>>2]*32.0;a=(o[u>>2]=t,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(!(t==0.0))break;t=a?-0.0:0.0}while(0);g=~~t;t=+o[l+(h<<2)>>2]*32.0;a=(o[u>>2]=t,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(!(t==0.0))break;t=a?-0.0:0.0}while(0);I=~~t;H=g>>5;j[b+(h<<2)>>1]=(H+32768|0)>>>0<65536?H:(H|0)>0?32767:32768;H=I>>5;j[b+((h<<1|1)<<1)>>1]=(H+32768|0)>>>0<65536?H:(H|0)>0?32767:32768;j[p+(h<<1)>>1]=I<<5&992|g&31;h=h+1|0}while((h|0)!=(E|0))}else{if(!d){if(w){if(!x)break;if(!l){a=0;while(1){o[b+(a<<2)>>2]=+(j[s+(a<<2)>>1]|0);o[p+(a<<2)>>2]=+(j[s+((a<<1|1)<<1)>>1]|0);a=a+1|0;if((a|0)==(E|0))break b}}else{a=0;while(1){I=m[l+(a<<1)>>1]|0;o[b+(a<<2)>>2]=+(j[s+(a<<2)>>1]|0)+ +(I&31|0)*.03125;o[p+(a<<2)>>2]=+(I>>>5&31|0)*.03125+ +(j[s+((a<<1|1)<<1)>>1]|0);a=a+1|0;if((a|0)==(E|0))break b}}}if(!c){k[V>>2]=0;k[v>>2]=0;a=ZT(56)|0;k[a>>2]=1;l=a+4|0;k[V>>2]=l;k[v>>2]=48;i[a+52>>0]=0;h=338786;s=l+48|0;do{i[l>>0]=i[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(s|0));Y8(-213,V,338702,335515,5220);k[v>>2]=0;k[V>>2]=0;I=k[a>>2]|0;k[a>>2]=I+-1;if((I|0)==1)ggb(k[a+-4>>2]|0);break}if(!x)break;if(!l){a=0;while(1){I=a<<1;o[b+(I<<2)>>2]=+(j[s+(a<<2)>>1]|0);I=I|1;o[b+(I<<2)>>2]=+(j[s+(I<<1)>>1]|0);a=a+1|0;if((a|0)==(E|0))break b}}else{a=0;while(1){H=m[l+(a<<1)>>1]|0;I=a<<1;o[b+(I<<2)>>2]=+(j[s+(a<<2)>>1]|0)+ +(H&31|0)*.03125;I=I|1;o[b+(I<<2)>>2]=+(H>>>5&31|0)*.03125+ +(j[s+(I<<1)>>1]|0);a=a+1|0;if((a|0)==(E|0))break b}}}if(f){if(x)h=0;else break;do{g=h<<1;t=+o[s+(g<<2)>>2];a=(o[u>>2]=t,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(!(t==0.0))break;t=a?-0.0:0.0}while(0);a=~~t;j[b+(h<<2)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g|1;t=+o[s+(g<<2)>>2];a=(o[u>>2]=t,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(!(t==0.0))break;t=a?-0.0:0.0}while(0);I=~~t;j[b+(g<<1)>>1]=(I+32768|0)>>>0<65536?I:(I|0)>0?32767:32768;h=h+1|0}while((h|0)!=(E|0))}else{if(x)l=0;else break;do{g=l<<1;t=+o[s+(g<<2)>>2]*32.0;a=(o[u>>2]=t,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(!(t==0.0))break;t=a?-0.0:0.0}while(0);h=~~t;g=g|1;t=+o[s+(g<<2)>>2]*32.0;a=(o[u>>2]=t,k[u>>2]|0);do if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;t=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(!(t==0.0))break;t=a?-0.0:0.0}while(0);I=~~t;H=h>>5;j[b+(l<<2)>>1]=(H+32768|0)>>>0<65536?H:(H|0)>0?32767:32768;H=I>>5;j[b+(g<<1)>>1]=(H+32768|0)>>>0<65536?H:(H|0)>0?32767:32768;j[p+(l<<1)>>1]=I<<5&992|h&31;l=l+1|0}while((l|0)!=(E|0))}}while(0);e=e+1|0}while((e|0)<(C|0))}while(0);if((K|0)==90?(K=V+4|0,f=K+4|0,k[f>>2]=0,k[f+4>>2]=0,k[V>>2]=33619968,k[K>>2]=Z,SW(J,V,k[Z>>2]&4095,1.0,0.0),k[X+16>>2]|0):0){l=k[O>>2]|0;if((l|0)<3)a=aa(k[X+12>>2]|0,k[M>>2]|0)|0;else{h=k[N>>2]|0;g=0;a=1;do{a=aa(k[h+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(l|0))}if(a|0?(W=L,((k[W>>2]^k[X>>2])&4095|0)==0):0){M=V+4|0;L=M+4|0;k[L>>2]=0;k[L+4>>2]=0;k[V>>2]=33619968;k[M>>2]=X;mY(W,V)}}h=X+36|0;a=k[h>>2]|0;if(a|0?(V=a+12|0,W=k[V>>2]|0,k[V>>2]=W+-1,(W|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[X+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;X=X+16|0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[O>>2]|0)>0){g=k[N>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[O>>2]|0))}a=k[P>>2]|0;if(!((a|0)==(Q|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=Z+36|0;a=k[h>>2]|0;if(a|0?(W=a+12|0,X=k[W>>2]|0,k[W>>2]=X+-1,(X|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[Z+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;Z=Z+16|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[S>>2]|0)>0){g=k[R>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[S>>2]|0))}a=k[T>>2]|0;if(!((a|0)==(U|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=_+36|0;a=k[h>>2]|0;if(a|0?(X=a+12|0,Z=k[X>>2]|0,k[X>>2]=Z+-1,(Z|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[_+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;Z=_+16|0;g=_+4|0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[g>>2]|0)>0){h=k[_+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[_+44>>2]|0;if(!((a|0)==(_+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=$+36|0;a=k[h>>2]|0;do if(a|0){Z=a+12|0;_=k[Z>>2]|0;k[Z>>2]=_+-1;if((_|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[$+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;_=$+16|0;h=$+4|0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[h>>2]|0)>0){g=k[Y>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[$+44>>2]|0;if((a|0)==($+48|0)|(a|0)==0){r=ba;return}ggb(k[a+-4>>2]|0);r=ba;return}function hoa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0;S=r;r=r+1536|0;M=S+176|0;R=S+1472|0;Q=S+1416|0;x=S+1352|0;P=S+1360|0;O=S+1296|0;N=S+232|0;K=S+224|0;L=S;do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[R>>2]=k[l>>2];q=R+4|0;a=l+4|0;k[q>>2]=k[a>>2];J=R+8|0;k[J>>2]=k[l+8>>2];k[R+12>>2]=k[l+12>>2];k[R+16>>2]=k[l+16>>2];k[R+20>>2]=k[l+20>>2];k[R+24>>2]=k[l+24>>2];k[R+28>>2]=k[l+28>>2];k[R+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[R+36>>2]=h;j=R+40|0;k[j>>2]=J;J=R+48|0;n=R+44|0;k[n>>2]=J;k[R+52>>2]=0;k[J>>2]=0;if(h|0){J=h+12|0;k[J>>2]=(k[J>>2]|0)+1}if((k[a>>2]|0)<3){I=k[l+44>>2]|0;J=k[n>>2]|0;k[J>>2]=k[I>>2];k[J+4>>2]=k[I+4>>2];break}k[q>>2]=0;x1(R,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(R,a,-1);while(0);do if((k[c>>2]&2031616|0)==65536){m=k[c+4>>2]|0;k[Q>>2]=k[m>>2];q=Q+4|0;h=m+4|0;k[q>>2]=k[h>>2];J=Q+8|0;k[J>>2]=k[m+8>>2];k[Q+12>>2]=k[m+12>>2];k[Q+16>>2]=k[m+16>>2];k[Q+20>>2]=k[m+20>>2];k[Q+24>>2]=k[m+24>>2];k[Q+28>>2]=k[m+28>>2];k[Q+32>>2]=k[m+32>>2];a=k[m+36>>2]|0;k[Q+36>>2]=a;j=Q+40|0;k[j>>2]=J;J=Q+48|0;n=Q+44|0;k[n>>2]=J;k[Q+52>>2]=0;k[J>>2]=0;if(a|0){J=a+12|0;k[J>>2]=(k[J>>2]|0)+1}if((k[h>>2]|0)<3){I=k[m+44>>2]|0;J=k[n>>2]|0;k[J>>2]=k[I>>2];k[J+4>>2]=k[I+4>>2];break}k[q>>2]=0;x1(Q,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[m+40>>2]|0;l=k[j>>2]|0;j=k[m+44>>2]|0;h=k[n>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(Q,c,-1);while(0);a=k[d>>2]|0;h=k[d+4>>2]|0;if(!(aa(h,a)|0)){a=k[R+40>>2]|0;h=k[a>>2]|0;a=k[a+4>>2]|0}k[x>>2]=a;k[x+4>>2]=h;x2(b,x,k[R>>2]&4095,0);do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[P>>2]=k[l>>2];q=P+4|0;a=l+4|0;k[q>>2]=k[a>>2];J=P+8|0;k[J>>2]=k[l+8>>2];k[P+12>>2]=k[l+12>>2];k[P+16>>2]=k[l+16>>2];k[P+20>>2]=k[l+20>>2];k[P+24>>2]=k[l+24>>2];k[P+28>>2]=k[l+28>>2];k[P+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[P+36>>2]=h;j=P+40|0;k[j>>2]=J;J=P+48|0;n=P+44|0;k[n>>2]=J;k[P+52>>2]=0;k[J>>2]=0;if(h|0){J=h+12|0;k[J>>2]=(k[J>>2]|0)+1}if((k[a>>2]|0)<3){I=k[l+44>>2]|0;J=k[n>>2]|0;k[J>>2]=k[I>>2];k[J+4>>2]=k[I+4>>2];break}k[q>>2]=0;x1(P,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(P,b,-1);while(0);b=R+12|0;if(!((k[b>>2]|0)>0?(k[R+8>>2]|0)>0:0)){k[M>>2]=0;a=M+4|0;k[a>>2]=0;h=ZT(36)|0;k[h>>2]=1;l=h+4|0;k[M>>2]=l;k[a>>2]=28;i[h+32>>0]=0;j=338835;n=l+28|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(n|0));Y8(-215,M,338864,335515,5584);k[a>>2]=0;k[M>>2]=0;J=k[h>>2]|0;k[h>>2]=J+-1;if((J|0)==1)ggb(k[h+-4>>2]|0)}I=P+16|0;J=R+16|0;if((k[I>>2]|0)==(k[J>>2]|0)){k[O>>2]=1124007936;o=O+4|0;a=O+8|0;m=O+40|0;l=o;n=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(n|0));k[m>>2]=a;n=O+48|0;l=O+44|0;k[l>>2]=n;k[O+52>>2]=0;k[n>>2]=0;j=M+4|0;a=j+4|0;k[a>>2]=0;k[a+4>>2]=0;k[M>>2]=33619968;k[j>>2]=O;mY(R,M);KG(R,O)|0;j=O+36|0;a=k[j>>2]|0;if(a|0?(G=a+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[O+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;H=O+16|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[o>>2]|0)>0){h=k[m>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[l>>2]|0;if(!((a|0)==(n|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}E=O+4|0;k[E>>2]=2;G=O+8|0;k[G>>2]=2;k[O+12>>2]=3;B=O+16|0;k[B>>2]=M;k[O+20>>2]=M;z=O+24|0;C=O+40|0;F=z+8|0;k[F>>2]=0;k[F+4>>2]=0;k[C>>2]=G;G=O+48|0;F=O+44|0;k[F>>2]=G;k[O>>2]=1124024326;k[G>>2]=24;k[O+52>>2]=8;k[O+28>>2]=M+48;k[z>>2]=M+48;z=e&7;z=(z|0)==3?1:z;if((((k[Q>>2]&4095)+-5|0)>>>0<2?(k[Q+8>>2]|0)==2:0)?(k[Q+12>>2]|0)==3:0)a=1124024326;else{k[N>>2]=0;a=N+4|0;k[a>>2]=0;h=ZT(84)|0;k[h>>2]=1;l=h+4|0;k[N>>2]=l;k[a>>2]=76;i[h+80>>0]=0;j=338875;n=l+76|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(n|0));Y8(-215,N,338864,335515,5594);k[a>>2]=0;k[N>>2]=0;H=k[h>>2]|0;k[h>>2]=H+-1;if((H|0)==1)ggb(k[h+-4>>2]|0);a=k[O>>2]|0}H=N+4|0;D=H+4|0;k[D>>2]=0;k[D+4>>2]=0;k[N>>2]=33619968;k[H>>2]=O;SW(Q,N,a&4095,1.0,0.0);if(!(e&16)){v=+p[M>>3];D=M+32|0;U=+p[D>>3];A=M+8|0;T=+p[A>>3];H=M+24|0;s=+p[H>>3];t=v*U-T*s;t=t!=0.0?1.0/t:0.0;U=U*t;v=v*t;p[M>>3]=U;t=-t;T=T*t;p[A>>3]=T;t=s*t;p[H>>3]=t;p[D>>3]=v;D=M+16|0;s=+p[D>>3];H=M+40|0;w=+p[H>>3];p[D>>3]=-(U*s)-T*w;p[H>>3]=-(s*t)-v*w}d=P+12|0;l=k[d>>2]|0;j=l<<1;e=N+8|0;k[N>>2]=e;y=N+4|0;k[y>>2]=264;if(j>>>0>264){h=j>>>0>1073741823?-1:j<<2;h=(h|0)==0?1:h;while(1){a=fgb(h)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[N>>2]=a}else a=e;k[y>>2]=j;x=a+(l<<2)|0;if((l|0)>0){v=+p[M>>3];w=+p[M+24>>3];l=k[d>>2]|0;j=0;do{t=+(j|0);s=t*v*1024.0;p[u>>3]=s;h=k[u+4>>2]|0;H=h&2146435072;if(!(H>>>0>1126170624|(H|0)==1126170624&0>0)){h=(h|0)<0;s=h?s+-4503599627370496.0+4503599627370496.0:s+4503599627370496.0+-4503599627370496.0;if(s==0.0)s=h?-0.0:0.0}k[a+(j<<2)>>2]=~~s;s=t*w*1024.0;p[u>>3]=s;h=k[u+4>>2]|0;H=h&2146435072;if(!(H>>>0>1126170624|(H|0)==1126170624&0>0)){h=(h|0)<0;s=h?s+-4503599627370496.0+4503599627370496.0:s+4503599627370496.0+-4503599627370496.0;if(s==0.0)s=h?-0.0:0.0}k[x+(j<<2)>>2]=~~s;j=j+1|0}while((j|0)<(l|0))}c=P+8|0;l=k[c>>2]|0;k[K>>2]=0;k[K+4>>2]=l;k[L>>2]=86724;l=L+4|0;k[l>>2]=k[R>>2];q=L+8|0;H=R+4|0;h=k[H>>2]|0;k[q>>2]=h;o=L+12|0;k[o>>2]=k[R+8>>2];k[L+16>>2]=k[b>>2];k[L+20>>2]=k[J>>2];k[L+24>>2]=k[R+20>>2];k[L+28>>2]=k[R+24>>2];k[L+32>>2]=k[R+28>>2];A=R+32|0;k[L+36>>2]=k[A>>2];D=R+36|0;j=k[D>>2]|0;k[L+40>>2]=j;m=L+44|0;k[m>>2]=o;b=L+52|0;o=L+48|0;k[o>>2]=b;k[L+56>>2]=0;k[b>>2]=0;if(j){h=j+12|0;k[h>>2]=(k[h>>2]|0)+1;h=k[H>>2]|0}if((h|0)>=3){k[q>>2]=0;x1(l,h,0,0,0);if((k[q>>2]|0)>0){n=k[R+40>>2]|0;l=k[m>>2]|0;m=k[R+44>>2]|0;j=k[o>>2]|0;h=0;do{k[l+(h<<2)>>2]=k[n+(h<<2)>>2];k[j+(h<<2)>>2]=k[m+(h<<2)>>2];h=h+1|0}while((h|0)<(k[q>>2]|0))}}else{q=k[R+44>>2]|0;b=k[o>>2]|0;k[b>>2]=k[q>>2];k[b+4>>2]=k[q+4>>2]}m=L+60|0;k[m>>2]=k[P>>2];q=L+64|0;b=P+4|0;h=k[b>>2]|0;k[q>>2]=h;n=L+68|0;k[n>>2]=k[c>>2];k[L+72>>2]=k[d>>2];k[L+76>>2]=k[I>>2];k[L+80>>2]=k[P+20>>2];k[L+84>>2]=k[P+24>>2];k[L+88>>2]=k[P+28>>2];c=P+32|0;k[L+92>>2]=k[c>>2];d=P+36|0;j=k[d>>2]|0;k[L+96>>2]=j;l=L+100|0;k[l>>2]=n;n=L+108|0;o=L+104|0;k[o>>2]=n;k[L+112>>2]=0;k[n>>2]=0;if(j){h=j+12|0;k[h>>2]=(k[h>>2]|0)+1;h=k[b>>2]|0}if((h|0)>=3){k[q>>2]=0;x1(m,h,0,0,0);if((k[q>>2]|0)>0){n=k[P+40>>2]|0;l=k[l>>2]|0;m=k[P+44>>2]|0;j=k[o>>2]|0;h=0;do{k[l+(h<<2)>>2]=k[n+(h<<2)>>2];k[j+(h<<2)>>2]=k[m+(h<<2)>>2];h=h+1|0}while((h|0)<(k[q>>2]|0))}}else{n=k[P+44>>2]|0;q=k[o>>2]|0;k[q>>2]=k[n>>2];k[q+4>>2]=k[n+4>>2]}k[L+116>>2]=z;k[L+120>>2]=f;p[L+128>>3]=+p[g>>3];p[L+136>>3]=+p[g+8>>3];p[L+144>>3]=+p[g+16>>3];p[L+152>>3]=+p[g+24>>3];k[L+160>>2]=a;k[L+164>>2]=x;k[L+168>>2]=M;jh[k[(k[L>>2]|0)+8>>2]&1023](L,K);ioa(L);a=k[N>>2]|0;if((a|0)!=(e|0)){if(a|0)ggb(a);k[N>>2]=e;k[y>>2]=264}j=O+36|0;a=k[j>>2]|0;if(a|0?(M=a+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[O+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[E>>2]|0)>0){h=k[C>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[E>>2]|0))}a=k[F>>2]|0;if(!((a|0)==(G|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[d>>2]|0;do if(a|0){N=a+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;h=k[d>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[c>>2]|0;if(a|0)break;a=B1()|0;h=k[d>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[d>>2]=0}while(0);k[d>>2]=0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[b>>2]|0)>0){h=k[P+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[P+44>>2]|0;if(!((a|0)==(P+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=Q+36|0;a=k[j>>2]|0;do if(a|0){O=a+12|0;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1)break;h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[Q+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}while(0);k[j>>2]=0;P=Q+16|0;h=Q+4|0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[h>>2]|0)>0){j=k[Q+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[Q+44>>2]|0;if(!((a|0)==(Q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[D>>2]|0;do if(a|0){P=a+12|0;Q=k[P>>2]|0;k[P>>2]=Q+-1;if((Q|0)!=1)break;h=k[D>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[A>>2]|0;if(a|0)break;a=B1()|0;h=k[D>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[D>>2]=0}while(0);k[D>>2]=0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[H>>2]|0)>0){h=k[R+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[H>>2]|0))}a=k[R+44>>2]|0;if((a|0)==(R+48|0)|(a|0)==0){r=S;return}ggb(k[a+-4>>2]|0);r=S;return}function ioa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86724;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function joa(a){a=a|0;ioa(a);ggb(a);return}function koa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0.0,i=0,l=0,m=0,n=0.0,o=0.0,q=0.0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0;sb=r;r=r+24912|0;jb=sb+8520|0;lb=sb+328|0;mb=sb+272|0;nb=sb+216|0;ob=sb+160|0;pb=sb+104|0;qb=sb+88|0;rb=sb+72|0;eb=sb+56|0;fb=sb;gb=a+116|0;hb=(k[gb>>2]|0)==0?512:16;ib=a+60|0;c=k[a+68>>2]|0;db=4096/(((c|0)<32?c:32)|0)|0;kb=a+72|0;cb=k[kb>>2]|0;db=(cb|0)<(db|0)?cb:db;cb=4096/(db|0)|0;cb=(c|0)<(cb|0)?c:cb;c=k[b>>2]|0;M=b+4|0;if((c|0)>=(k[M>>2]|0)){r=sb;return}N=mb+4|0;O=mb+8|0;P=mb+12|0;Q=mb+16|0;R=mb+20|0;S=mb+24|0;T=mb+28|0;U=mb+40|0;V=mb+48|0;W=mb+44|0;X=nb+4|0;Y=nb+8|0;Z=nb+40|0;_=nb+48|0;$=nb+44|0;ba=nb+52|0;ca=pb+4|0;da=pb+8|0;ea=pb+12|0;fa=a+4|0;ga=pb+8|0;ha=pb+12|0;ia=pb+4|0;ja=qb+4|0;ka=ja+4|0;la=rb+8|0;ma=rb+12|0;na=rb+4|0;oa=fb+4|0;pa=fb+8|0;qa=fb+40|0;ra=fb+48|0;sa=fb+44|0;ta=fb+52|0;ua=eb+8|0;va=eb+12|0;wa=eb+4|0;xa=a+120|0;ya=a+128|0;za=fb+36|0;Aa=fb+16|0;Ba=ob+36|0;Ca=ob+16|0;Da=ob+4|0;Ea=ob+40|0;Fa=ob+44|0;Ga=ob+48|0;Ha=nb+36|0;Ia=nb+16|0;Ja=mb+36|0;Ka=pb+4|0;La=pb+8|0;Ma=pb+12|0;Na=pb+16|0;Oa=pb+20|0;Pa=pb+24|0;Qa=pb+28|0;Ra=pb+40|0;Sa=pb+48|0;Ta=pb+44|0;Ua=qb+8|0;Va=qb+12|0;Wa=qb+4|0;Xa=rb+4|0;Ya=Xa+4|0;Za=eb+8|0;_a=eb+12|0;$a=eb+4|0;ab=fb+8|0;bb=fb+12|0;I=fb+4|0;J=pb+36|0;K=a+168|0;L=a+160|0;A=a+164|0;B=mb+52|0;C=pb+52|0;D=fb+32|0;E=mb+32|0;F=nb+32|0;G=ob+32|0;H=pb+32|0;b=k[kb>>2]|0;do{if((b|0)>0){z=0;do{y=b-z|0;y=(y|0)<(db|0)?y:db;x=(k[M>>2]|0)-c|0;x=(x|0)<(cb|0)?x:cb;k[N>>2]=2;k[O>>2]=x;k[P>>2]=y;k[Q>>2]=jb;k[R>>2]=jb;b=S+8|0;k[b>>2]=0;k[b+4>>2]=0;k[U>>2]=O;k[W>>2]=V;b=y<<2;k[mb>>2]=1124024331;k[V>>2]=b;k[B>>2]=4;a=jb+(aa(x,b)|0)|0;k[T>>2]=a;k[S>>2]=a+(0-b)+b;k[nb>>2]=1124007936;b=X;a=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(a|0));k[Z>>2]=Y;k[$>>2]=_;k[ba>>2]=0;k[_>>2]=0;k[pb>>2]=z;k[ca>>2]=c;k[da>>2]=y;k[ea>>2]=x;I1(ob,ib,pb);if((x|0)>0){b=k[K>>2]|0;n=+p[b+8>>3];o=+p[b+16>>3];q=+p[b+32>>3];s=+p[b+40>>3];b=k[gb>>2]|0;t=(b|0)==0;v=(y|0)>0;m=0;do{e=aa(m,y)|0;w=jb+(e<<1<<1)|0;h=+(m+c|0);d=(h*n+o)*1024.0;p[u>>3]=d;a=k[u+4>>2]|0;l=a&2146435072;if(!(l>>>0>1126170624|(l|0)==1126170624&0>0)){a=(a|0)<0;d=a?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=a?-0.0:0.0}l=~~d+hb|0;d=(h*q+s)*1024.0;p[u>>3]=d;a=k[u+4>>2]|0;i=a&2146435072;if(!(i>>>0>1126170624|(i|0)==1126170624&0>0)){a=(a|0)<0;d=a?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=a?-0.0:0.0}i=~~d+hb|0;if(t){if(v){e=k[L>>2]|0;f=k[A>>2]|0;a=0;do{tb=a+z|0;ub=(k[e+(tb<<2)>>2]|0)+l>>10;tb=(k[f+(tb<<2)>>2]|0)+i>>10;g=a<<1;j[w+(g<<1)>>1]=(ub+32768|0)>>>0<65536?ub:(ub|0)>0?32767:32768;j[w+((g|1)<<1)>>1]=(tb+32768|0)>>>0<65536?tb:(tb|0)>0?32767:32768;a=a+1|0}while((a|0)<(y|0))}}else{e=lb+(e<<1)|0;if(v){f=k[L>>2]|0;g=k[A>>2]|0;a=0;do{tb=a+z|0;ub=(k[f+(tb<<2)>>2]|0)+l|0;tb=(k[g+(tb<<2)>>2]|0)+i|0;wb=ub>>10;vb=a<<1;j[w+(vb<<1)>>1]=(wb+32768|0)>>>0<65536?wb:(wb|0)>0?32767:32768;wb=tb>>10;j[w+((vb|1)<<1)>>1]=(wb+32768|0)>>>0<65536?wb:(wb|0)>0?32767:32768;j[e+(a<<1)>>1]=tb&992|ub>>>5&31;a=a+1|0}while((a|0)<(y|0))}}m=m+1|0}while((m|0)<(x|0))}else b=k[gb>>2]|0;if(!b){k[ga>>2]=0;k[ha>>2]=0;k[pb>>2]=16842752;k[ia>>2]=fa;b=ka;k[b>>2]=0;k[b+4>>2]=0;k[qb>>2]=33619968;k[ja>>2]=ob;k[la>>2]=0;k[ma>>2]=0;k[rb>>2]=16842752;k[na>>2]=mb;k[fb>>2]=1124007936;b=oa;a=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(a|0));k[qa>>2]=pa;k[sa>>2]=ra;k[ta>>2]=0;k[ra>>2]=0;k[ua>>2]=0;k[va>>2]=0;k[eb>>2]=16842752;k[wa>>2]=fb;Jna(pb,qb,rb,eb,0,k[xa>>2]|0,ya);b=k[za>>2]|0;if(b|0?(vb=b+12|0,wb=k[vb>>2]|0,k[vb>>2]=wb+-1,(wb|0)==1):0){a=k[za>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[D>>2]|0;if(!b){b=B1()|0;a=k[za>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[za>>2]=0}k[za>>2]=0;k[Aa>>2]=0;k[Aa+4>>2]=0;k[Aa+8>>2]=0;k[Aa+12>>2]=0;if((k[oa>>2]|0)>0){a=k[qa>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[oa>>2]|0))}b=k[sa>>2]|0;if(!((b|0)==(ra|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{k[Ka>>2]=2;k[La>>2]=x;k[Ma>>2]=y;k[Na>>2]=lb;k[Oa>>2]=lb;wb=Pa+8|0;k[wb>>2]=0;k[wb+4>>2]=0;k[Ra>>2]=La;k[Ta>>2]=Sa;wb=y<<1;k[pb>>2]=1124024322;k[Sa>>2]=wb;k[C>>2]=2;vb=lb+(aa(x,wb)|0)|0;k[Qa>>2]=vb;k[Pa>>2]=vb+(0-wb)+wb;k[Ua>>2]=0;k[Va>>2]=0;k[qb>>2]=16842752;k[Wa>>2]=fa;wb=Ya;k[wb>>2]=0;k[wb+4>>2]=0;k[rb>>2]=33619968;k[Xa>>2]=ob;k[Za>>2]=0;k[_a>>2]=0;k[eb>>2]=16842752;k[$a>>2]=mb;k[ab>>2]=0;k[bb>>2]=0;k[fb>>2]=16842752;k[I>>2]=pb;Jna(qb,rb,eb,fb,b,k[xa>>2]|0,ya);b=k[J>>2]|0;if(b|0?(vb=b+12|0,wb=k[vb>>2]|0,k[vb>>2]=wb+-1,(wb|0)==1):0){a=k[J>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[H>>2]|0;if(!b){b=B1()|0;a=k[J>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[J>>2]=0}k[J>>2]=0;k[Na>>2]=0;k[Na+4>>2]=0;k[Na+8>>2]=0;k[Na+12>>2]=0;if((k[Ka>>2]|0)>0){a=k[Ra>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ka>>2]|0))}b=k[Ta>>2]|0;if(!((b|0)==(Sa|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}b=k[Ba>>2]|0;if(b|0?(vb=b+12|0,wb=k[vb>>2]|0,k[vb>>2]=wb+-1,(wb|0)==1):0){a=k[Ba>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[G>>2]|0;if(!b){b=B1()|0;a=k[Ba>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[Ba>>2]=0}k[Ba>>2]=0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[Da>>2]|0)>0){a=k[Ea>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Da>>2]|0))}b=k[Fa>>2]|0;if(!((b|0)==(Ga|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Ha>>2]|0;if(b|0?(vb=b+12|0,wb=k[vb>>2]|0,k[vb>>2]=wb+-1,(wb|0)==1):0){a=k[Ha>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[F>>2]|0;if(!b){b=B1()|0;a=k[Ha>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[Ha>>2]=0}k[Ha>>2]=0;k[Ia>>2]=0;k[Ia+4>>2]=0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;if((k[X>>2]|0)>0){a=k[Z>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[X>>2]|0))}b=k[$>>2]|0;if(!((b|0)==(_|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Ja>>2]|0;if(b|0?(vb=b+12|0,wb=k[vb>>2]|0,k[vb>>2]=wb+-1,(wb|0)==1):0){a=k[Ja>>2]|0;if(a|0){b=k[a+4>>2]|0;do if(!b){b=k[E>>2]|0;if(b|0)break;b=B1()|0;a=k[Ja>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[Ja>>2]=0}k[Ja>>2]=0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[N>>2]|0)>0){a=k[U>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[N>>2]|0))}b=k[W>>2]|0;if(!((b|0)==(V|0)|(b|0)==0))ggb(k[b+-4>>2]|0);z=z+db|0;b=k[kb>>2]|0}while((b|0)>(z|0))}c=c+cb|0}while((c|0)<(k[M>>2]|0));r=sb;return}function loa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+480|0;D=I+160|0;H=I+424|0;G=I+360|0;s=I+416|0;F=I+304|0;E=I+248|0;B=I+232|0;C=I;if(!(F2(a)|0)){h=D+4|0;j=ZT(24)|0;k[j>>2]=1;n=j+4|0;k[D>>2]=n;k[h>>2]=16;i[j+20>>0]=0;l=338977;q=n+16|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(q|0));Y8(-215,D,338994,335515,6101);k[h>>2]=0;k[D>>2]=0;A=k[j>>2]|0;k[j>>2]=A+-1;if((A|0)==1)ggb(k[j+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[H>>2]=k[l>>2];q=H+4|0;a=l+4|0;k[q>>2]=k[a>>2];A=H+8|0;k[A>>2]=k[l+8>>2];k[H+12>>2]=k[l+12>>2];k[H+16>>2]=k[l+16>>2];k[H+20>>2]=k[l+20>>2];k[H+24>>2]=k[l+24>>2];k[H+28>>2]=k[l+28>>2];k[H+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[H+36>>2]=h;j=H+40|0;k[j>>2]=A;A=H+48|0;n=H+44|0;k[n>>2]=A;k[H+52>>2]=0;k[A>>2]=0;if(h|0){A=h+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[a>>2]|0)<3){z=k[l+44>>2]|0;A=k[n>>2]|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];break}k[q>>2]=0;x1(H,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(H,a,-1);while(0);do if((k[c>>2]&2031616|0)==65536){m=k[c+4>>2]|0;k[G>>2]=k[m>>2];q=G+4|0;a=m+4|0;k[q>>2]=k[a>>2];A=G+8|0;k[A>>2]=k[m+8>>2];k[G+12>>2]=k[m+12>>2];k[G+16>>2]=k[m+16>>2];k[G+20>>2]=k[m+20>>2];k[G+24>>2]=k[m+24>>2];k[G+28>>2]=k[m+28>>2];k[G+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[G+36>>2]=h;j=G+40|0;k[j>>2]=A;A=G+48|0;n=G+44|0;k[n>>2]=A;k[G+52>>2]=0;k[A>>2]=0;if(h|0){A=h+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[a>>2]|0)<3){z=k[m+44>>2]|0;A=k[n>>2]|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];break}k[q>>2]=0;x1(G,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[m+40>>2]|0;l=k[j>>2]|0;j=k[m+44>>2]|0;h=k[n>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(G,c,-1);while(0);a=k[d>>2]|0;h=k[d+4>>2]|0;if(!(aa(h,a)|0)){a=k[H+40>>2]|0;h=k[a>>2]|0;a=k[a+4>>2]|0}k[s>>2]=a;k[s+4>>2]=h;x2(b,s,k[H>>2]&4095,0);do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[F>>2]=k[l>>2];q=F+4|0;a=l+4|0;k[q>>2]=k[a>>2];A=F+8|0;k[A>>2]=k[l+8>>2];k[F+12>>2]=k[l+12>>2];c=F+16|0;k[c>>2]=k[l+16>>2];k[F+20>>2]=k[l+20>>2];k[F+24>>2]=k[l+24>>2];k[F+28>>2]=k[l+28>>2];k[F+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[F+36>>2]=h;j=F+40|0;k[j>>2]=A;A=F+48|0;n=F+44|0;k[n>>2]=A;k[F+52>>2]=0;k[A>>2]=0;if(h|0){A=h+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[a>>2]|0)<3){z=k[l+44>>2]|0;A=k[n>>2]|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];break}k[q>>2]=0;x1(F,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else{Q1(F,b,-1);c=F+16|0}while(0);A=H+16|0;if((k[c>>2]|0)==(k[A>>2]|0)){k[E>>2]=1124007936;o=E+4|0;a=E+8|0;m=E+40|0;n=o;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[m>>2]=a;n=E+48|0;l=E+44|0;k[l>>2]=n;k[E+52>>2]=0;k[n>>2]=0;j=D+4|0;a=j+4|0;k[a>>2]=0;k[a+4>>2]=0;k[D>>2]=33619968;k[j>>2]=E;mY(H,D);KG(H,E)|0;j=E+36|0;a=k[j>>2]|0;if(a|0?(y=a+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[E+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;z=E+16|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[o>>2]|0)>0){h=k[m>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[l>>2]|0;if(!((a|0)==(n|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}v=E+4|0;k[v>>2]=2;x=E+8|0;k[x>>2]=3;k[E+12>>2]=3;t=E+16|0;k[t>>2]=D;k[E+20>>2]=D;s=E+24|0;u=E+40|0;w=s+8|0;k[w>>2]=0;k[w+4>>2]=0;k[u>>2]=x;x=E+48|0;w=E+44|0;k[w>>2]=x;k[E>>2]=1124024326;k[x>>2]=24;k[E+52>>2]=8;k[E+28>>2]=D+72;k[s>>2]=D+72;s=e&7;s=(s|0)==3?1:s;if((((k[G>>2]&4095)+-5|0)>>>0<2?(k[G+8>>2]|0)==3:0)?(k[G+12>>2]|0)==3:0)a=1124024326;else{k[B>>2]=0;a=B+4|0;k[a>>2]=0;h=ZT(84)|0;k[h>>2]=1;n=h+4|0;k[B>>2]=n;k[a>>2]=76;i[h+80>>0]=0;l=339010;q=n+76|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(q|0));Y8(-215,B,338994,335515,6120);k[a>>2]=0;k[B>>2]=0;z=k[h>>2]|0;k[h>>2]=z+-1;if((z|0)==1)ggb(k[h+-4>>2]|0);a=k[E>>2]|0}z=B+4|0;y=z+4|0;k[y>>2]=0;k[y+4>>2]=0;k[B>>2]=33619968;k[z>>2]=E;SW(G,B,a&4095,1.0,0.0);if(!(e&16)){k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=16842752;k[B+4>>2]=E;z=C+4|0;y=z+4|0;k[y>>2]=0;k[y+4>>2]=0;k[C>>2]=33619968;k[z>>2]=E;+CZ(B,C,0)}q=F+8|0;j=k[q>>2]|0;k[B>>2]=0;k[B+4>>2]=j;k[C>>2]=86744;j=C+4|0;k[j>>2]=k[H>>2];o=C+8|0;z=H+4|0;a=k[z>>2]|0;k[o>>2]=a;b=C+12|0;k[b>>2]=k[H+8>>2];k[C+16>>2]=k[H+12>>2];k[C+20>>2]=k[A>>2];k[C+24>>2]=k[H+20>>2];k[C+28>>2]=k[H+24>>2];k[C+32>>2]=k[H+28>>2];e=H+32|0;k[C+36>>2]=k[e>>2];y=H+36|0;h=k[y>>2]|0;k[C+40>>2]=h;l=C+44|0;k[l>>2]=b;b=C+52|0;n=C+48|0;k[n>>2]=b;k[C+56>>2]=0;k[b>>2]=0;if(h){a=h+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[z>>2]|0}if((a|0)>=3){k[o>>2]=0;x1(j,a,0,0,0);if((k[o>>2]|0)>0){m=k[H+40>>2]|0;j=k[l>>2]|0;l=k[H+44>>2]|0;h=k[n>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[h+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[o>>2]|0))}}else{d=k[H+44>>2]|0;b=k[n>>2]|0;k[b>>2]=k[d>>2];k[b+4>>2]=k[d+4>>2]}j=C+60|0;k[j>>2]=k[F>>2];o=C+64|0;b=F+4|0;a=k[b>>2]|0;k[o>>2]=a;m=C+68|0;k[m>>2]=k[q>>2];k[C+72>>2]=k[F+12>>2];k[C+76>>2]=k[F+16>>2];k[C+80>>2]=k[F+20>>2];k[C+84>>2]=k[F+24>>2];k[C+88>>2]=k[F+28>>2];q=F+32|0;k[C+92>>2]=k[q>>2];d=F+36|0;h=k[d>>2]|0;k[C+96>>2]=h;l=C+100|0;k[l>>2]=m;m=C+108|0;n=C+104|0;k[n>>2]=m;k[C+112>>2]=0;k[m>>2]=0;if(h){a=h+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[b>>2]|0}if((a|0)>=3){k[o>>2]=0;x1(j,a,0,0,0);if((k[o>>2]|0)>0){m=k[F+40>>2]|0;j=k[l>>2]|0;l=k[F+44>>2]|0;h=k[n>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[h+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[o>>2]|0))}}else{m=k[F+44>>2]|0;o=k[n>>2]|0;k[o>>2]=k[m>>2];k[o+4>>2]=k[m+4>>2]}k[C+116>>2]=D;k[C+120>>2]=s;k[C+124>>2]=f;p[C+128>>3]=+p[g>>3];p[C+136>>3]=+p[g+8>>3];p[C+144>>3]=+p[g+16>>3];p[C+152>>3]=+p[g+24>>3];jh[k[(k[C>>2]|0)+8>>2]&1023](C,B);moa(C);j=E+36|0;a=k[j>>2]|0;if(a|0?(g=a+12|0,D=k[g>>2]|0,k[g>>2]=D+-1,(D|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[E+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){h=k[u>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[v>>2]|0))}a=k[w>>2]|0;if(!((a|0)==(x|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[d>>2]|0;if(a|0?(D=a+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){h=k[d>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[q>>2]|0;if(a|0)break;a=B1()|0;h=k[d>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[d>>2]=0}k[d>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[b>>2]|0)>0){h=k[F+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[F+44>>2]|0;if(!((a|0)==(F+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=G+36|0;a=k[j>>2]|0;do if(a|0){E=a+12|0;F=k[E>>2]|0;k[E>>2]=F+-1;if((F|0)!=1)break;h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[G+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}while(0);k[j>>2]=0;F=G+16|0;h=G+4|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[h>>2]|0)>0){j=k[G+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[G+44>>2]|0;if(!((a|0)==(G+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[y>>2]|0;do if(a|0){F=a+12|0;G=k[F>>2]|0;k[F>>2]=G+-1;if((G|0)!=1)break;h=k[y>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[e>>2]|0;if(a|0)break;a=B1()|0;h=k[y>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[y>>2]=0}while(0);k[y>>2]=0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[z>>2]|0)>0){h=k[H+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[z>>2]|0))}a=k[H+44>>2]|0;if((a|0)==(H+48|0)|(a|0)==0){r=I;return}ggb(k[a+-4>>2]|0);r=I;return}function moa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86744;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function noa(a){a=a|0;moa(a);ggb(a);return}function ooa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0,g=0,h=0,i=0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0,Cb=0;zb=r;r=r+6480|0;rb=zb+2376|0;sb=zb+328|0;tb=zb+272|0;ub=zb+216|0;vb=zb+160|0;wb=zb+104|0;xb=zb+88|0;yb=zb+72|0;nb=zb+56|0;ob=zb;pb=a+60|0;qb=k[a+72>>2]|0;c=k[a+68>>2]|0;mb=1024/(((c|0)<16?c:16)|0)|0;mb=(qb|0)<(mb|0)?qb:mb;lb=1024/(mb|0)|0;lb=(c|0)<(lb|0)?c:lb;c=k[b>>2]|0;R=b+4|0;if((c|0)>=(k[R>>2]|0)){r=zb;return}S=(qb|0)>0;T=tb+4|0;U=tb+8|0;V=tb+12|0;W=tb+16|0;X=tb+20|0;Y=tb+24|0;Z=tb+28|0;_=tb+40|0;$=tb+48|0;ba=tb+44|0;ca=ub+4|0;da=ub+8|0;ea=ub+40|0;fa=ub+48|0;ga=ub+44|0;ha=ub+52|0;ia=wb+4|0;ja=wb+8|0;ka=wb+12|0;la=a+120|0;ma=a+4|0;na=wb+8|0;oa=wb+12|0;pa=wb+4|0;qa=xb+4|0;ra=qa+4|0;sa=yb+8|0;ta=yb+12|0;ua=yb+4|0;va=ob+4|0;wa=ob+8|0;xa=ob+40|0;ya=ob+48|0;za=ob+44|0;Aa=ob+52|0;Ba=nb+8|0;Ca=nb+12|0;Da=nb+4|0;Ea=a+124|0;Fa=a+128|0;Ga=ob+36|0;Ha=ob+16|0;Ia=vb+36|0;Ja=vb+16|0;Ka=vb+4|0;La=vb+40|0;Ma=vb+44|0;Na=vb+48|0;Oa=ub+36|0;Pa=ub+16|0;Qa=tb+36|0;Ra=wb+4|0;Sa=wb+8|0;Ta=wb+12|0;Ua=wb+16|0;Va=wb+20|0;Wa=wb+24|0;Xa=wb+28|0;Ya=wb+40|0;Za=wb+48|0;_a=wb+44|0;$a=xb+8|0;ab=xb+12|0;bb=xb+4|0;cb=yb+4|0;db=cb+4|0;eb=nb+8|0;fb=nb+12|0;gb=nb+4|0;hb=ob+8|0;ib=ob+12|0;jb=ob+4|0;kb=wb+36|0;J=a+116|0;K=tb+52|0;L=wb+52|0;M=ob+32|0;N=tb+32|0;O=ub+32|0;P=vb+32|0;Q=wb+32|0;do{if(S){I=0;do{H=qb-I|0;H=(H|0)<(mb|0)?H:mb;G=(k[R>>2]|0)-c|0;G=(G|0)<(lb|0)?G:lb;k[T>>2]=2;k[U>>2]=G;k[V>>2]=H;k[W>>2]=rb;k[X>>2]=rb;b=Y+8|0;k[b>>2]=0;k[b+4>>2]=0;k[_>>2]=U;k[ba>>2]=$;b=H<<2;k[tb>>2]=1124024331;k[$>>2]=b;k[K>>2]=4;a=rb+(aa(G,b)|0)|0;k[Z>>2]=a;k[Y>>2]=a+(0-b)+b;k[ub>>2]=1124007936;b=ca;a=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(a|0));k[ea>>2]=da;k[ga>>2]=fa;k[ha>>2]=0;k[fa>>2]=0;k[wb>>2]=I;k[ia>>2]=c;k[ja>>2]=H;k[ka>>2]=G;I1(vb,pb,wb);if((G|0)>0){b=k[J>>2]|0;l=+p[b>>3];x=+(I|0);m=x*l;n=+p[b+8>>3];o=+p[b+16>>3];q=+p[b+24>>3];s=x*q;t=+p[b+32>>3];v=+p[b+40>>3];w=+p[b+48>>3];x=x*w;y=+p[b+56>>3];z=+p[b+64>>3];b=k[la>>2]|0;A=(b|0)==0;B=(H|0)>0;i=0;do{a=aa(i,H)|0;C=rb+(a<<1<<1)|0;F=+(i+c|0);D=o+(m+F*n);E=v+(s+F*t);F=z+(x+F*y);if(A){if(B){g=0;do{e=+(g|0);Ab=F+e*w;Ab=Ab!=0.0?1.0/Ab:0.0;d=Ab*(D+e*l);d=d<2147483647.0?d:2147483647.0;d=d>-2147483648.0?d:-2147483648.0;e=Ab*(E+e*q);e=e<2147483647.0?e:2147483647.0;e=e>-2147483648.0?e:-2147483648.0;p[u>>3]=d;a=k[u+4>>2]|0;h=a&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){a=(a|0)<0;d=a?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=a?-0.0:0.0}f=~~d;p[u>>3]=e;a=k[u+4>>2]|0;h=a&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){a=(a|0)<0;d=a?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=a?-0.0:0.0}else d=e;a=~~d;h=g<<1;j[C+(h<<1)>>1]=(f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768;j[C+((h|1)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)<(H|0))}}else{h=sb+(a<<1)|0;if(B){g=0;do{d=+(g|0);Ab=F+d*w;Ab=Ab!=0.0?32.0/Ab:0.0;e=Ab*(D+d*l);e=e<2147483647.0?e:2147483647.0;e=e>-2147483648.0?e:-2147483648.0;d=Ab*(E+d*q);d=d<2147483647.0?d:2147483647.0;d=d>-2147483648.0?d:-2147483648.0;p[u>>3]=e;a=k[u+4>>2]|0;f=a&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){a=(a|0)<0;e=a?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=a?-0.0:0.0}f=~~e;p[u>>3]=d;a=k[u+4>>2]|0;Bb=a&2146435072;if(!(Bb>>>0>1126170624|(Bb|0)==1126170624&0>0)){a=(a|0)<0;d=a?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=a?-0.0:0.0}Bb=~~d;Cb=f>>5;a=g<<1;j[C+(a<<1)>>1]=(Cb+32768|0)>>>0<65536?Cb:(Cb|0)>0?32767:32768;Cb=Bb>>5;j[C+((a|1)<<1)>>1]=(Cb+32768|0)>>>0<65536?Cb:(Cb|0)>0?32767:32768;j[h+(g<<1)>>1]=Bb<<5&992|f&31;g=g+1|0}while((g|0)<(H|0))}}i=i+1|0}while((i|0)<(G|0))}else b=k[la>>2]|0;if(!b){k[na>>2]=0;k[oa>>2]=0;k[wb>>2]=16842752;k[pa>>2]=ma;b=ra;k[b>>2]=0;k[b+4>>2]=0;k[xb>>2]=33619968;k[qa>>2]=vb;k[sa>>2]=0;k[ta>>2]=0;k[yb>>2]=16842752;k[ua>>2]=tb;k[ob>>2]=1124007936;b=va;a=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(a|0));k[xa>>2]=wa;k[za>>2]=ya;k[Aa>>2]=0;k[ya>>2]=0;k[Ba>>2]=0;k[Ca>>2]=0;k[nb>>2]=16842752;k[Da>>2]=ob;Jna(wb,xb,yb,nb,0,k[Ea>>2]|0,Fa);b=k[Ga>>2]|0;if(b|0?(Bb=b+12|0,Cb=k[Bb>>2]|0,k[Bb>>2]=Cb+-1,(Cb|0)==1):0){a=k[Ga>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[M>>2]|0;if(!b){b=B1()|0;a=k[Ga>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[Ga>>2]=0}k[Ga>>2]=0;k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ha+8>>2]=0;k[Ha+12>>2]=0;if((k[va>>2]|0)>0){a=k[xa>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[va>>2]|0))}b=k[za>>2]|0;if(!((b|0)==(ya|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{k[Ra>>2]=2;k[Sa>>2]=G;k[Ta>>2]=H;k[Ua>>2]=sb;k[Va>>2]=sb;Cb=Wa+8|0;k[Cb>>2]=0;k[Cb+4>>2]=0;k[Ya>>2]=Sa;k[_a>>2]=Za;Cb=H<<1;k[wb>>2]=1124024322;k[Za>>2]=Cb;k[L>>2]=2;Bb=sb+(aa(G,Cb)|0)|0;k[Xa>>2]=Bb;k[Wa>>2]=Bb+(0-Cb)+Cb;k[$a>>2]=0;k[ab>>2]=0;k[xb>>2]=16842752;k[bb>>2]=ma;Cb=db;k[Cb>>2]=0;k[Cb+4>>2]=0;k[yb>>2]=33619968;k[cb>>2]=vb;k[eb>>2]=0;k[fb>>2]=0;k[nb>>2]=16842752;k[gb>>2]=tb;k[hb>>2]=0;k[ib>>2]=0;k[ob>>2]=16842752;k[jb>>2]=wb;Jna(xb,yb,nb,ob,b,k[Ea>>2]|0,Fa);b=k[kb>>2]|0;if(b|0?(Bb=b+12|0,Cb=k[Bb>>2]|0,k[Bb>>2]=Cb+-1,(Cb|0)==1):0){a=k[kb>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[Q>>2]|0;if(!b){b=B1()|0;a=k[kb>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[kb>>2]=0}k[kb>>2]=0;k[Ua>>2]=0;k[Ua+4>>2]=0;k[Ua+8>>2]=0;k[Ua+12>>2]=0;if((k[Ra>>2]|0)>0){a=k[Ya>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ra>>2]|0))}b=k[_a>>2]|0;if(!((b|0)==(Za|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}b=k[Ia>>2]|0;if(b|0?(Bb=b+12|0,Cb=k[Bb>>2]|0,k[Bb>>2]=Cb+-1,(Cb|0)==1):0){a=k[Ia>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[P>>2]|0;if(!b){b=B1()|0;a=k[Ia>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[Ia>>2]=0}k[Ia>>2]=0;k[Ja>>2]=0;k[Ja+4>>2]=0;k[Ja+8>>2]=0;k[Ja+12>>2]=0;if((k[Ka>>2]|0)>0){a=k[La>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ka>>2]|0))}b=k[Ma>>2]|0;if(!((b|0)==(Na|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Oa>>2]|0;if(b|0?(Bb=b+12|0,Cb=k[Bb>>2]|0,k[Bb>>2]=Cb+-1,(Cb|0)==1):0){a=k[Oa>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[O>>2]|0;if(!b){b=B1()|0;a=k[Oa>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[Oa>>2]=0}k[Oa>>2]=0;k[Pa>>2]=0;k[Pa+4>>2]=0;k[Pa+8>>2]=0;k[Pa+12>>2]=0;if((k[ca>>2]|0)>0){a=k[ea>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ca>>2]|0))}b=k[ga>>2]|0;if(!((b|0)==(fa|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Qa>>2]|0;if(b|0?(Bb=b+12|0,Cb=k[Bb>>2]|0,k[Bb>>2]=Cb+-1,(Cb|0)==1):0){a=k[Qa>>2]|0;if(a|0){b=k[a+4>>2]|0;do if(!b){b=k[N>>2]|0;if(b|0)break;b=B1()|0;a=k[Qa>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[Qa>>2]=0}k[Qa>>2]=0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[T>>2]|0)>0){a=k[_>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[T>>2]|0))}b=k[ba>>2]|0;if(!((b|0)==($|0)|(b|0)==0))ggb(k[b+-4>>2]|0);I=I+mb|0}while((qb|0)>(I|0))}c=c+lb|0}while((c|0)<(k[R>>2]|0));r=zb;return}function poa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0;H=r;r=r+384|0;G=H+320|0;F=H+264|0;g=H+208|0;t=H+152|0;s=H+96|0;q=H+80|0;l=H+64|0;m=H+48|0;n=H+32|0;o=H;M1(G,a,0,1,0,0);M1(F,b,0,1,0,0);k[g>>2]=k[F>>2];y=g+4|0;E=F+4|0;a=k[E>>2]|0;k[y>>2]=a;A=g+8|0;k[A>>2]=k[F+8>>2];k[g+12>>2]=k[F+12>>2];v=g+16|0;C=F+16|0;k[v>>2]=k[C>>2];k[g+20>>2]=k[F+20>>2];k[g+24>>2]=k[F+24>>2];k[g+28>>2]=k[F+28>>2];u=g+32|0;B=F+32|0;k[u>>2]=k[B>>2];w=g+36|0;D=F+36|0;b=k[D>>2]|0;k[w>>2]=b;x=g+40|0;k[x>>2]=A;A=g+48|0;z=g+44|0;k[z>>2]=A;k[g+52>>2]=0;k[A>>2]=0;if(b){a=b+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[E>>2]|0}if((a|0)>=3){k[y>>2]=0;x1(g,a,0,0,0);if((k[y>>2]|0)>0){b=k[F+40>>2]|0;g=k[x>>2]|0;h=k[F+44>>2]|0;j=k[z>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[b+(a<<2)>>2];k[j+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[y>>2]|0))}}else{h=k[F+44>>2]|0;j=k[z>>2]|0;k[j>>2]=k[h>>2];k[j+4>>2]=k[h+4>>2]}M1(t,c,0,1,0,0);M1(s,d,0,1,0,0);if(!(((k[F>>2]^k[G>>2])&4095|0)==0?(c=k[F+40>>2]|0,d=k[t+40>>2]|0,(k[c>>2]|0)==(k[d>>2]|0)?(k[c+4>>2]|0)==(k[d+4>>2]|0):0):0)){k[q>>2]=0;a=q+4|0;k[a>>2]=0;b=ZT(60)|0;k[b>>2]=1;g=b+4|0;k[q>>2]=g;k[a>>2]=53;i[b+57>>0]=0;h=339383;j=g+53|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,q,339437,335515,6405);k[a>>2]=0;k[q>>2]=0;d=k[b>>2]|0;k[b>>2]=d+-1;if((d|0)==1)ggb(k[b+-4>>2]|0)}k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=G;d=l+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[l>>2]=33619968;k[d>>2]=F;k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=t;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=s;K=+p[f+8>>3];J=+p[f+16>>3];I=+p[f+24>>3];p[o>>3]=+p[f>>3];p[o+8>>3]=K;p[o+16>>3]=J;p[o+24>>3]=I;Jna(q,l,m,n,e&7,e&8|0?0:5,o);if((k[v>>2]|0)!=(k[C>>2]|0)){k[q>>2]=0;a=q+4|0;k[a>>2]=0;b=ZT(28)|0;k[b>>2]=1;g=b+4|0;k[q>>2]=g;k[a>>2]=21;i[b+25>>0]=0;h=339445;j=g+21|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,q,339437,335515,6409);k[a>>2]=0;k[q>>2]=0;q=k[b>>2]|0;k[b>>2]=q+-1;if((q|0)==1)ggb(k[b+-4>>2]|0)}g=s+36|0;a=k[g>>2]|0;if(a|0?(f=a+12|0,q=k[f>>2]|0,k[f>>2]=q+-1,(q|0)==1):0){b=k[g>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[s+32>>2]|0;if(!a){a=B1()|0;b=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[g>>2]=0}k[g>>2]=0;q=s+16|0;b=s+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[b>>2]|0)>0){g=k[s+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[s+44>>2]|0;if(!((a|0)==(s+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=t+36|0;a=k[g>>2]|0;if(a|0?(q=a+12|0,s=k[q>>2]|0,k[q>>2]=s+-1,(s|0)==1):0){b=k[g>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[t+32>>2]|0;if(!a){a=B1()|0;b=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[g>>2]=0}k[g>>2]=0;s=t+16|0;b=t+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[b>>2]|0)>0){g=k[t+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[t+44>>2]|0;if(!((a|0)==(t+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[w>>2]|0;if(a|0?(s=a+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){b=k[w>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[u>>2]|0;if(!a){a=B1()|0;b=k[w>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[w>>2]=0}k[w>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[y>>2]|0)>0){b=k[x>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[y>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(A|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[D>>2]|0;if(a|0?(z=a+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){b=k[D>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[B>>2]|0;if(a|0)break;a=B1()|0;b=k[D>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[D>>2]=0}k[D>>2]=0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[E>>2]|0)>0){b=k[F+40>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[E>>2]|0))}a=k[F+44>>2]|0;if(!((a|0)==(F+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=G+36|0;a=k[g>>2]|0;if(a|0?(E=a+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){b=k[g>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[G+32>>2]|0;if(a|0)break;a=B1()|0;b=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[g>>2]=0}k[g>>2]=0;F=G+16|0;b=G+4|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[b>>2]|0)>0){g=k[G+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[G+44>>2]|0;if((a|0)==(G+48|0)|(a|0)==0){r=H;return}ggb(k[a+-4>>2]|0);r=H;return}function qoa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0.0;d=d<=0.0?1.3450000286102295:d;if((b|0)>0)e=0;else return;do{f=+o[a+(e<<2)>>2];o[c+(e<<2)>>2]=f<d?1.0:d/f;e=e+1|0}while((e|0)!=(b|0));return}function roa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0.0;d=d==0.0?.3350532650947571:1.0/d;if((b|0)>0)e=0;else return;do{f=+o[a+(e<<2)>>2];f=+Z(+-(d*(d*(f*f))));o[c+(e<<2)>>2]=f;e=e+1|0}while((e|0)!=(b|0));return}function soa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0;d=d==0.0?.7143877744674683:1.0/d;if((b|0)>0)e=0;else return;do{o[c+(e<<2)>>2]=1.0/(d*+o[a+(e<<2)>>2]+1.0);e=e+1|0}while((e|0)!=(b|0));return}function toa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((b|0)>0)d=0;else return;do{e=+o[a+(d<<2)>>2];e=1.0/+Q(+(e*e*.5+1.0));o[c+(d<<2)>>2]=e;d=d+1|0}while((d|0)!=(b|0));return}function uoa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((b|0)>0)d=0;else return;do{e=+P(+(+o[a+(d<<2)>>2]));o[c+(d<<2)>>2]=1.0/(e<1.0e-06?1.0e-06:e);d=d+1|0}while((d|0)!=(b|0));return}function voa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,p=0.0,q=0.0;e=(b|0)>0;if(c)if(e){j=0.0;e=0;k=0.0;i=0.0;h=0.0;f=0.0;g=0.0;do{l=+o[c+(e<<2)>>2];q=+o[a+(e<<3)>>2];n=l*q;g=g+n;m=+o[a+(e<<3)+4>>2];p=l*m;k=k+p;i=i+q*n;h=h+m*p;f=f+n*m;j=j+l;e=e+1|0}while((e|0)!=(b|0))}else{j=0.0;g=0.0;k=0.0;i=0.0;h=0.0;f=0.0}else{if(e){e=0;k=0.0;i=0.0;h=0.0;f=0.0;g=0.0;do{p=+o[a+(e<<3)>>2];g=g+p;q=+o[a+(e<<3)+4>>2];k=k+q;i=i+p*p;h=h+q*q;f=f+p*q;e=e+1|0}while((e|0)!=(b|0))}else{g=0.0;k=0.0;i=0.0;h=0.0;f=0.0}j=+(b|0)}p=g/j;q=k/j;n=+Y(+((f/j-q*p)*2.0),+(i/j-p*p-(h/j-q*q)))*.5;m=+S(+n);o[d>>2]=m;n=+T(+n);o[d+4>>2]=n;o[d+8>>2]=p;o[d+12>>2]=q;return}function woa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0.0,j=0.0,l=0.0,m=0.0,n=0.0,p=0.0,q=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,R=0.0,S=0.0,T=0.0;O=r;r=r+304|0;t=O+264|0;J=O+228|0;K=O+216|0;N=O+160|0;M=O+104|0;L=O+48|0;G=O+32|0;H=O+16|0;I=O;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;e=J;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));e=(b|0)>0;if(c)if(e){e=0;j=0.0;s=0.0;l=0.0;n=0.0;p=0.0;q=0.0;m=0.0;i=0.0;h=0.0;g=0.0;do{T=+o[a+(e*12|0)>>2];S=+o[a+(e*12|0)+4>>2];R=+o[a+(e*12|0)+8>>2];P=+o[c+(e<<2)>>2];p=p+T*T*P;i=i+T*S*P;g=g+T*R*P;q=q+S*S*P;h=h+S*R*P;m=m+R*R*P;s=s+T*P;l=l+S*P;n=n+R*P;j=j+P;e=e+1|0}while((e|0)!=(b|0))}else{j=0.0;s=0.0;l=0.0;n=0.0;p=0.0;q=0.0;m=0.0;i=0.0;h=0.0;g=0.0}else{if(e){e=0;j=0.0;l=0.0;n=0.0;p=0.0;q=0.0;m=0.0;i=0.0;h=0.0;g=0.0;do{R=+o[a+(e*12|0)>>2];S=+o[a+(e*12|0)+4>>2];T=+o[a+(e*12|0)+8>>2];p=p+R*R;i=i+R*S;g=g+R*T;q=q+S*S;h=h+S*T;m=m+T*T;j=j+R;l=l+S;n=n+T;e=e+1|0}while((e|0)!=(b|0));s=j}else{s=0.0;l=0.0;n=0.0;p=0.0;q=0.0;m=0.0;i=0.0;h=0.0;g=0.0}j=+(b|0)}R=s/j;S=l/j;T=n/j;p=p/j-R*R;q=q/j-S*S;m=m/j-T*T;o[t>>2]=m+q;s=-(i/j-R*S);o[t+4>>2]=s;n=-(g/j-R*T);o[t+8>>2]=n;o[t+12>>2]=s;o[t+16>>2]=p+m;m=-(h/j-S*T);o[t+20>>2]=m;o[t+24>>2]=n;o[t+28>>2]=m;o[t+32>>2]=q+p;D=N+4|0;k[D>>2]=2;F=N+8|0;k[F>>2]=3;k[N+12>>2]=3;B=N+16|0;k[B>>2]=t;k[N+20>>2]=t;y=N+24|0;C=N+40|0;E=y+8|0;k[E>>2]=0;k[E+4>>2]=0;k[C>>2]=F;F=N+48|0;E=N+44|0;k[E>>2]=F;k[N>>2]=1124024325;k[F>>2]=12;k[N+52>>2]=4;k[N+28>>2]=t+36;k[y>>2]=t+36;y=M+4|0;k[y>>2]=2;A=M+8|0;k[A>>2]=3;k[M+12>>2]=3;w=M+16|0;k[w>>2]=J;k[M+20>>2]=J;t=M+24|0;x=M+40|0;z=t+8|0;k[z>>2]=0;k[z+4>>2]=0;k[x>>2]=A;A=M+48|0;z=M+44|0;k[z>>2]=A;k[M>>2]=1124024325;k[A>>2]=12;k[M+52>>2]=4;k[M+28>>2]=J+36;k[t>>2]=J+36;t=L+4|0;k[t>>2]=2;v=L+8|0;k[v>>2]=3;k[L+12>>2]=1;a=L+16|0;k[a>>2]=K;k[L+20>>2]=K;c=L+24|0;b=L+40|0;u=c+8|0;k[u>>2]=0;k[u+4>>2]=0;k[b>>2]=v;v=L+48|0;u=L+44|0;k[u>>2]=v;k[L>>2]=1124024325;k[v>>2]=4;k[L+52>>2]=4;k[L+28>>2]=K+12;k[c>>2]=K+12;k[G+8>>2]=0;k[G+12>>2]=0;k[G>>2]=16842752;k[G+4>>2]=N;c=H+4|0;e=c+4|0;k[e>>2]=0;k[e+4>>2]=0;k[H>>2]=33619968;k[c>>2]=L;c=I+4|0;e=c+4|0;k[e>>2]=0;k[e+4>>2]=0;k[I>>2]=33619968;k[c>>2]=M;FZ(G,H,I);q=+o[K>>2];m=+o[K+4>>2];p=+o[K+8>>2];c=J+((q<m?(q<p?0:2):m<p?1:2)*3<<2)|0;p=+o[c>>2];m=p;q=+o[c+4>>2];n=q;s=+o[c+8>>2];P=s;P=+Q(+(m*m+n*n+P*P));P=P<1.0e-06?1.0e-06:P;o[d>>2]=p/P;o[d+4>>2]=q/P;o[d+8>>2]=s/P;o[d+12>>2]=R;o[d+16>>2]=S;o[d+20>>2]=T;c=L+36|0;e=k[c>>2]|0;if(e|0?(J=e+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){f=k[c>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[L+32>>2]|0;if(!e){e=B1()|0;f=k[c>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[c>>2]=0}k[c>>2]=0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[t>>2]|0)>0){f=k[b>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[t>>2]|0))}e=k[u>>2]|0;if(!((e|0)==(v|0)|(e|0)==0))ggb(k[e+-4>>2]|0);c=M+36|0;e=k[c>>2]|0;if(e|0?(K=e+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){f=k[c>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[M+32>>2]|0;if(!e){e=B1()|0;f=k[c>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[c>>2]=0}k[c>>2]=0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[y>>2]|0)>0){f=k[x>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[y>>2]|0))}e=k[z>>2]|0;if(!((e|0)==(A|0)|(e|0)==0))ggb(k[e+-4>>2]|0);c=N+36|0;e=k[c>>2]|0;if(e|0?(L=e+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){f=k[c>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[N+32>>2]|0;if(!e){e=B1()|0;f=k[c>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[c>>2]=0}k[c>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[D>>2]|0)>0){f=k[C>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[D>>2]|0))}e=k[E>>2]|0;if((e|0)==(F|0)|(e|0)==0){r=O;return}ggb(k[e+-4>>2]|0);r=O;return}function xoa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86764;d=a+276|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+272>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+256|0;c=a+244|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+280>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+284>>2]|0;if(!((b|0)==(a+288|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+216|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+212>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+196|0;c=a+184|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+220>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+224>>2]|0;if(!((b|0)==(a+228|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+156|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+152>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+136|0;d=a+124|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+160>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+164>>2]|0;if(!((b|0)==(a+168|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function yoa(a){a=a|0;xoa(a);ggb(a);return}function zoa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0;Va=r;r=r+848|0;Aa=Va+368|0;Ba=Va+144|0;Ca=Va+128|0;Da=Va+120|0;t=Va+112|0;w=Va+832|0;u=Va+824|0;v=Va+816|0;va=Va+688|0;wa=Va+624|0;xa=Va+104|0;ya=Va+8|0;za=Va;Ua=Va+512|0;Ta=Va+500|0;Sa=Va+488|0;Ra=Va+476|0;Qa=Va+464|0;Ga=Va+760|0;Ia=Va+704|0;Ja=Va+632|0;Oa=Va+568|0;do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[Aa>>2]=k[l>>2];s=Aa+4|0;b=l+4|0;k[s>>2]=k[b>>2];Pa=Aa+8|0;k[Pa>>2]=k[l+8>>2];k[Aa+12>>2]=k[l+12>>2];k[Aa+16>>2]=k[l+16>>2];k[Aa+20>>2]=k[l+20>>2];k[Aa+24>>2]=k[l+24>>2];k[Aa+28>>2]=k[l+28>>2];k[Aa+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[Aa+36>>2]=g;h=Aa+40|0;k[h>>2]=Pa;Pa=Aa+48|0;n=Aa+44|0;k[n>>2]=Pa;k[Aa+52>>2]=0;k[Pa>>2]=0;if(g|0){Pa=g+12|0;k[Pa>>2]=(k[Pa>>2]|0)+1}if((k[b>>2]|0)<3){Na=k[l+44>>2]|0;Pa=k[n>>2]|0;k[Pa>>2]=k[Na>>2];k[Pa+4>>2]=k[Na+4>>2];break}k[s>>2]=0;x1(Aa,k[b>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;b=0;do{k[m+(b<<2)>>2]=k[q+(b<<2)>>2];k[g+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[s>>2]|0))}}else Q1(Aa,b,-1);while(0);Eoa(Ua,Aa);h=Aa+36|0;b=k[h>>2]|0;if(b|0?(Na=b+12|0,Pa=k[Na>>2]|0,k[Na>>2]=Pa+-1,(Pa|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[Aa+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;Pa=Aa+16|0;g=Aa+4|0;k[Pa>>2]=0;k[Pa+4>>2]=0;k[Pa+8>>2]=0;k[Pa+12>>2]=0;if((k[g>>2]|0)>0){h=k[Aa+40>>2]|0;b=0;do{k[h+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[g>>2]|0))}b=k[Aa+44>>2]|0;if(!((b|0)==(Aa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);Pa=Ua+16|0;if(k[Pa>>2]|0){h=k[Ua+4>>2]|0;if((h|0)<3)b=aa(k[Ua+12>>2]|0,k[Ua+8>>2]|0)|0;else{l=k[Ua+40>>2]|0;g=0;b=1;do{b=aa(k[l+(g<<2)>>2]|0,b)|0;g=g+1|0}while((g|0)!=(h|0))}if(!b)Ea=29}else Ea=29;if((Ea|0)==29){k[Aa>>2]=0;b=Aa+4|0;k[b>>2]=0;g=ZT(40)|0;k[g>>2]=1;x=g+4|0;k[Aa>>2]=x;k[b>>2]=35;i[g+39>>0]=0;h=340060;G=x+35|0;do{i[x>>0]=i[h>>0]|0;x=x+1|0;h=h+1|0}while((x|0)<(G|0));Y8(-215,Aa,386843,339828,416);k[b>>2]=0;k[Aa>>2]=0;Na=k[g>>2]|0;k[g>>2]=Na+-1;if((Na|0)==1)ggb(k[g+-4>>2]|0)}g=a+4|0;Na=Aa+4|0;Ma=Na+4|0;k[Ma>>2]=0;k[Ma+4>>2]=0;k[Aa>>2]=33619968;k[Na>>2]=g;SW(Ua,Aa,6,1.0,0.0);k[Ta>>2]=0;Na=Ta+4|0;k[Na>>2]=0;k[Ta+8>>2]=0;k[Sa>>2]=0;Ma=Sa+4|0;k[Ma>>2]=0;k[Sa+8>>2]=0;k[Ra>>2]=0;La=Ra+4|0;k[La>>2]=0;k[Ra+8>>2]=0;k[Qa>>2]=0;Ka=Qa+4|0;k[Ka>>2]=0;k[Qa+8>>2]=0;ua=a+312|0;i[ua>>0]=(k[d>>2]&2031616|0)!=0&1;Fa=a+313|0;i[Fa>>0]=(k[e>>2]&2031616|0)!=0&1;sa=a+328|0;if((k[sa>>2]|0)<2)b=0;else b=(k[f>>2]&2031616|0)!=0&1;Ha=a+314|0;i[Ha>>0]=b;qa=+p[a+352>>3];y=qa*3.141592653589793/180.0;p[Da>>3]=y;qa=qa/180.0;y=+p[a+344>>3]/+T(+y);p[t>>3]=y;k[w>>2]=0;ta=w+4|0;k[ta>>2]=0;k[w+8>>2]=0;ra=a+320|0;y=+p[ra>>3];if(y!=1.0){k[Aa>>2]=1124007936;q=Aa+4|0;b=Aa+8|0;m=Aa+40|0;x=q;G=x+36|0;do{k[x>>2]=0;x=x+4|0}while((x|0)<(G|0));k[m>>2]=b;n=Aa+48|0;l=Aa+44|0;k[l>>2]=n;k[Aa+52>>2]=0;k[n>>2]=0;F=+p[a+336>>3];F=y<1.0?F/y:F;h=~~+$(+(F*3.7169221888498387))>>>0<<1|1;k[Ba+8>>2]=0;k[Ba+12>>2]=0;k[Ba>>2]=16842752;k[Ba+4>>2]=g;b=Ca+4|0;pa=b+4|0;k[pa>>2]=0;k[pa+4>>2]=0;k[Ca>>2]=33619968;k[b>>2]=Aa;k[u>>2]=h;k[u+4>>2]=h;uua(Ba,Ca,u,F,0.0,4);k[Ba+8>>2]=0;k[Ba+12>>2]=0;k[Ba>>2]=16842752;k[Ba+4>>2]=Aa;h=Ca+4|0;b=h+4|0;k[b>>2]=0;k[b+4>>2]=0;k[Ca>>2]=-2113863674;k[h>>2]=a+60;k[v>>2]=0;k[v+4>>2]=0;F=+p[ra>>3];Rla(Ba,Ca,v,F,F,1);k[Ba>>2]=k[a+376>>2];Foa(a,t,Ba,w);h=Aa+36|0;b=k[h>>2]|0;if(b|0?(oa=b+12|0,pa=k[oa>>2]|0,k[oa>>2]=pa+-1,(pa|0)==1):0){g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[Aa+32>>2]|0;if(!b){b=B1()|0;g=k[h>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}k[h>>2]=0;pa=Aa+16|0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[q>>2]|0)>0){g=k[m>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[q>>2]|0))}b=k[l>>2]|0;if(!((b|0)==(n|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}else{Goa(a+60|0,g)|0;k[Aa>>2]=k[a+376>>2];Foa(a,t,Aa,w)}oa=a+296|0;F=+Pfb(+(k[oa>>2]|0));m=a+300|0;F=(F+ +Pfb(+(k[m>>2]|0)))*5.0*.5+1.041392685158225;p[a+304>>3]=F;pa=~~(-F/+Pfb(qa));l=k[a+100>>2]|0;h=k[l+4>>2]|0;l=k[l>>2]|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=1124007936;b=Ba+16|0;g=Ba+48|0;x=Ba+12|0;G=x+36|0;do{k[x>>2]=0;x=x+4|0}while((x|0)<(G|0));k[g>>2]=b;b=Ba+56|0;k[Ba+52>>2]=b;k[Ba+60>>2]=0;k[b>>2]=0;k[Ba+64>>2]=1124007936;b=Ba+72|0;g=Ba+104|0;x=Ba+68|0;G=x+36|0;do{k[x>>2]=0;x=x+4|0}while((x|0)<(G|0));k[g>>2]=b;b=Ba+112|0;k[Ba+108>>2]=b;k[Ba+116>>2]=0;k[b>>2]=0;k[Ba+120>>2]=1124007936;b=Ba+128|0;g=Ba+160|0;x=Ba+124|0;G=x+36|0;do{k[x>>2]=0;x=x+4|0}while((x|0)<(G|0));k[g>>2]=b;x=Ba+168|0;k[Ba+164>>2]=x;G=x+56|0;do{k[x>>2]=0;x=x+4|0}while((x|0)<(G|0));k[Aa>>2]=h;k[Aa+4>>2]=l;j1(Ba,48,Aa,0);q=k[Ba>>2]|0;dh[k[(k[q>>2]|0)+12>>2]&255](q,Ba,a+240|0,0);XN(Ba);q=k[oa>>2]|0;l=aa(k[m>>2]|0,q)|0;k[va>>2]=0;na=va+4|0;k[na>>2]=0;k[va+8>>2]=0;if(!l){b=0;g=0;ma=0}else{if(l>>>0>134217727)ad(426534,426557,304,426811);m=l<<5;h=(m|0)==0?1:m;while(1){g=fgb(h)|0;if(g|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){g=0;break}Qh[b&7]()}k[va>>2]=g;k[va+8>>2]=g+(l<<5);ma=g+m|0;zpb(g|0,0,m|0)|0;k[na>>2]=ma;b=g}la=k[ta>>2]|0;ja=k[w>>2]|0;ha=la-ja|0;ia=(ha|0)/12|0;ka=ja;a:do if(!ha)b=g;else{H=a+256|0;I=a+176|0;J=a+368|0;K=a+360|0;L=ya+8|0;M=ya+16|0;N=ya+24|0;O=ya+32|0;P=Aa+4|0;R=Aa+8|0;S=Aa+12|0;U=Ta+8|0;V=Qa+8|0;W=ya+88|0;X=Ra+8|0;Y=Sa+8|0;Z=Aa+4|0;_=Aa+88|0;ba=Aa+80|0;ca=Aa+32|0;da=Aa+72|0;ea=Aa+64|0;fa=Aa+8|0;ga=Aa+16|0;ha=Aa+24|0;g=0;l=b;w=b;n=b;m=b;while(1){G=(aa(q,k[ka+(g*12|0)+4>>2]|0)|0)+(k[ka+(g*12|0)>>2]|0)|0;if((i[(k[H>>2]|0)+G>>0]|0)==0?+p[(k[I>>2]|0)+(G<<3)>>3]!=-1024.0:0){Hoa(a,ka+(g*12|0)|0,va,wa,xa,Da);v=k[wa>>2]|0;if((v|0)<(pa|0))h=w;else{y=+p[xa>>3];F=+p[Da>>3];Ioa(va,v,y,F,qa,ya);p[za>>3]=-1.0;h=k[sa>>2]|0;b:do if((h|0)>0){p[Ba>>3]=y;D=+p[M>>3]-+p[ya>>3];E=+p[N>>3]-+p[L>>3];E=+Q(+(D*D+E*E));c:do if(!(+(v|0)/(E*+p[O>>3])>=+p[J>>3])){s=k[w>>2]|0;B=+(s|0);q=k[w+4>>2]|0;C=+(q|0);u=w+16|0;if((v|0)>0){q=0;t=0;z=0.0;A=0.0;h=w;while(1){i[k[h+(q<<5)+8>>2]>>0]=0;D=+(k[n+(q<<5)>>2]|0)-B;E=+(k[n+(q<<5)+4>>2]|0)-C;E=+Q(+(D*D+E*E));if(E<+p[O>>3]){y=+p[n+(q<<5)+16>>3]-+p[u>>3];if(y<=-3.141592653589793)do y=y+6.283185307179586;while(y<=-3.141592653589793);if(y>3.141592653589793)do y=y+-6.283185307179586;while(y>3.141592653589793);t=t+1|0;z=z+y*y;y=A+y}else y=A;q=q+1|0;if((q|0)==(v|0))break;else{A=y;h=n}}h=n;s=k[n>>2]|0;q=k[n+4>>2]|0}else{t=0;z=0.0;y=0.0;h=w}E=+(t|0);D=y/E;E=+Q(+(D*D+(z-y*(D*2.0))/E))*2.0;p[Ca>>3]=E;k[Aa>>2]=s;k[Z>>2]=q;Hoa(a,Aa,va,wa,Ba,Ca);q=k[wa>>2]|0;d:do if((q|0)>=2){E=+p[Ba>>3];Ioa(va,q,E,F,qa,ya);y=+p[ya>>3];z=+p[L>>3];A=+p[M>>3];B=+p[N>>3];C=A-y;D=B-z;D=+Q(+(C*C+D*D));if(+(q|0)/(D*+p[O>>3])<+p[J>>3]){D=+(k[m>>2]|0);C=+(k[m+4>>2]|0);y=y-D;z=z-C;z=y*y+z*z;A=A-D;y=B-C;y=A*A+y*y;y=z>y?z:y;m=q;while(1){y=y*.5625;h=0;do{A=+(k[l+(h<<5)>>2]|0)-D;B=+(k[l+(h<<5)+4>>2]|0)-C;if(A*A+B*B>y){i[k[l+(h<<5)+8>>2]>>0]=0;x=b+(h<<5)|0;m=m+-1|0;G=b+(m<<5)|0;k[Aa>>2]=k[x>>2];k[Aa+4>>2]=k[x+4>>2];k[Aa+8>>2]=k[x+8>>2];k[Aa+12>>2]=k[x+12>>2];k[Aa+16>>2]=k[x+16>>2];k[Aa+20>>2]=k[x+20>>2];k[Aa+24>>2]=k[x+24>>2];k[Aa+28>>2]=k[x+28>>2];k[x>>2]=k[G>>2];k[x+4>>2]=k[G+4>>2];k[x+8>>2]=k[G+8>>2];k[x+12>>2]=k[G+12>>2];k[x+16>>2]=k[G+16>>2];k[x+20>>2]=k[G+20>>2];k[x+24>>2]=k[G+24>>2];k[x+28>>2]=k[G+28>>2];k[G>>2]=k[Aa>>2];k[G+4>>2]=k[Aa+4>>2];k[G+8>>2]=k[Aa+8>>2];k[G+12>>2]=k[Aa+12>>2];k[G+16>>2]=k[Aa+16>>2];k[G+20>>2]=k[Aa+20>>2];k[G+24>>2]=k[Aa+24>>2];k[G+28>>2]=k[Aa+28>>2];k[wa>>2]=m;h=h+-1|0}h=h+1|0}while((h|0)<(m|0));if((m|0)<2){l=b;m=b;n=b;h=b;break d}Ioa(va,m,E,F,qa,ya);A=+p[M>>3]-+p[ya>>3];B=+p[N>>3]-+p[L>>3];B=+Q(+(A*A+B*B));if(!(+(m|0)/(B*+p[O>>3])<+p[J>>3])){l=b;m=b;n=b;h=b;break}else l=b}}s=h;h=k[sa>>2]|0;break c}while(0);break b}else s=w;while(0);if((h|0)>1){y=+Loa(a,ya);z=+p[K>>3];if(!(y>z)){x=Aa;h=ya;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));z=+p[_>>3]*.5;p[_>>3]=z;p[ba>>3]=z*3.141592653589793;z=+Loa(a,Aa);if(z>y){x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}z=+p[_>>3]*.5;p[_>>3]=z;p[ba>>3]=z*3.141592653589793;z=+Loa(a,Aa);if(z>y){x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}z=+p[_>>3]*.5;p[_>>3]=z;p[ba>>3]=z*3.141592653589793;z=+Loa(a,Aa);if(z>y){x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}z=+p[_>>3]*.5;p[_>>3]=z;p[ba>>3]=z*3.141592653589793;z=+Loa(a,Aa);if(z>y){x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}z=+p[_>>3]*.5;p[_>>3]=z;p[ba>>3]=z*3.141592653589793;z=+Loa(a,Aa);if(z>y){x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}do if(!(y>+p[K>>3])){x=Aa;h=ya;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));z=+p[ca>>3]+-.5;do if(z>=.5){p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[ca>>3]+-.5;do if(z>=.5){p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[ca>>3]+-.5;do if(z>=.5){p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[ca>>3]+-.5;do if(z>=.5){p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[ca>>3]+-.5;do if(z>=.5){p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);if(y>+p[K>>3])break;x=Aa;h=ya;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));z=+p[ca>>3]+-.5;do if(z>=.5){E=+p[da>>3]*.25;p[Aa>>3]=+p[Aa>>3]-E;F=+p[ea>>3]*.25;p[fa>>3]=+p[fa>>3]+F;p[ga>>3]=+p[ga>>3]-E;p[ha>>3]=+p[ha>>3]+F;p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[ca>>3]+-.5;do if(z>=.5){E=+p[da>>3]*.25;p[Aa>>3]=+p[Aa>>3]-E;F=+p[ea>>3]*.25;p[fa>>3]=+p[fa>>3]+F;p[ga>>3]=+p[ga>>3]-E;p[ha>>3]=+p[ha>>3]+F;p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[ca>>3]+-.5;do if(z>=.5){E=+p[da>>3]*.25;p[Aa>>3]=+p[Aa>>3]-E;F=+p[ea>>3]*.25;p[fa>>3]=+p[fa>>3]+F;p[ga>>3]=+p[ga>>3]-E;p[ha>>3]=+p[ha>>3]+F;p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[ca>>3]+-.5;do if(z>=.5){E=+p[da>>3]*.25;p[Aa>>3]=+p[Aa>>3]-E;F=+p[ea>>3]*.25;p[fa>>3]=+p[fa>>3]+F;p[ga>>3]=+p[ga>>3]-E;p[ha>>3]=+p[ha>>3]+F;p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[ca>>3]+-.5;do if(z>=.5){E=+p[da>>3]*.25;p[Aa>>3]=+p[Aa>>3]-E;F=+p[ea>>3]*.25;p[fa>>3]=+p[fa>>3]+F;p[ga>>3]=+p[ga>>3]-E;p[ha>>3]=+p[ha>>3]+F;p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);if(y>+p[K>>3])break;x=Aa;h=ya;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));z=+p[ca>>3]+-.5;do if(z>=.5){E=+p[da>>3]*.25;p[Aa>>3]=+p[Aa>>3]+E;F=+p[ea>>3]*.25;p[fa>>3]=+p[fa>>3]-F;p[ga>>3]=+p[ga>>3]+E;p[ha>>3]=+p[ha>>3]-F;p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[ca>>3]+-.5;do if(z>=.5){E=+p[da>>3]*.25;p[Aa>>3]=+p[Aa>>3]+E;F=+p[ea>>3]*.25;p[fa>>3]=+p[fa>>3]-F;p[ga>>3]=+p[ga>>3]+E;p[ha>>3]=+p[ha>>3]-F;p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[ca>>3]+-.5;do if(z>=.5){E=+p[da>>3]*.25;p[Aa>>3]=+p[Aa>>3]+E;F=+p[ea>>3]*.25;p[fa>>3]=+p[fa>>3]-F;p[ga>>3]=+p[ga>>3]+E;p[ha>>3]=+p[ha>>3]-F;p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[ca>>3]+-.5;do if(z>=.5){E=+p[da>>3]*.25;p[Aa>>3]=+p[Aa>>3]+E;F=+p[ea>>3]*.25;p[fa>>3]=+p[fa>>3]-F;p[ga>>3]=+p[ga>>3]+E;p[ha>>3]=+p[ha>>3]-F;p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[ca>>3]+-.5;do if(z>=.5){E=+p[da>>3]*.25;p[Aa>>3]=+p[Aa>>3]+E;F=+p[ea>>3]*.25;p[fa>>3]=+p[fa>>3]-F;p[ga>>3]=+p[ga>>3]+E;p[ha>>3]=+p[ha>>3]-F;p[ca>>3]=z;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);if(y>+p[K>>3])break;x=Aa;h=ya;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));do if(+p[ca>>3]+-.5>=.5){z=+p[_>>3]*.5;p[_>>3]=z;p[ba>>3]=z*3.141592653589793;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);do if(+p[ca>>3]+-.5>=.5){z=+p[_>>3]*.5;p[_>>3]=z;p[ba>>3]=z*3.141592653589793;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);do if(+p[ca>>3]+-.5>=.5){z=+p[_>>3]*.5;p[_>>3]=z;p[ba>>3]=z*3.141592653589793;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);do if(+p[ca>>3]+-.5>=.5){z=+p[_>>3]*.5;p[_>>3]=z;p[ba>>3]=z*3.141592653589793;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);if(!(+p[ca>>3]+-.5>=.5))break;z=+p[_>>3]*.5;p[_>>3]=z;p[ba>>3]=z*3.141592653589793;z=+Loa(a,Aa);if(!(z>y))break;x=ya;h=Aa;G=x+96|0;do{k[x>>2]=k[h>>2];x=x+4|0;h=h+4|0}while((x|0)<(G|0));y=z}while(0);z=+p[K>>3]}p[za>>3]=y;if(!(y<=z))Ea=168;else h=s}else{y=-1.0;Ea=168}}else{s=w;y=-1.0;Ea=168}while(0);do if((Ea|0)==168){Ea=0;z=+p[ya>>3]+.5;p[ya>>3]=z;B=+p[L>>3]+.5;p[L>>3]=B;C=+p[M>>3]+.5;p[M>>3]=C;D=+p[N>>3]+.5;p[N>>3]=D;A=+p[ra>>3];if(A!=1.0){z=z/A;p[ya>>3]=z;B=B/A;p[L>>3]=B;C=C/A;p[M>>3]=C;F=D/A;p[N>>3]=F;p[O>>3]=+p[O>>3]/A;A=F}else A=D;o[Aa>>2]=z;o[P>>2]=B;o[R>>2]=C;o[S>>2]=A;h=k[Na>>2]|0;if((h|0)==(k[U>>2]|0))Joa(Ta,Aa);else{o[h>>2]=z;o[h+4>>2]=B;o[h+8>>2]=C;o[h+12>>2]=A;k[Na>>2]=h+16}G=j[ua>>1]|0;h=(G&65535)>>>8&255;do if((G&255)<<24>>24){q=k[Ma>>2]|0;if((q|0)==(k[Y>>2]|0)){Koa(Sa,O);h=i[Fa>>0]|0;break}else{p[q>>3]=+p[O>>3];k[Ma>>2]=q+8;break}}while(0);do if(h<<24>>24){h=k[La>>2]|0;if((h|0)==(k[X>>2]|0)){Koa(Ra,W);break}else{p[h>>3]=+p[W>>3];k[La>>2]=h+8;break}}while(0);if(!(i[Ha>>0]|0)){h=s;break}if((k[sa>>2]|0)<=1){h=s;break}h=k[Ka>>2]|0;if((h|0)==(k[V>>2]|0)){Koa(Qa,za);h=s;break}else{p[h>>3]=y;k[Ka>>2]=h+8;h=s;break}}while(0)}}else h=w;g=g+1|0;if(g>>>0>=ia>>>0)break a;q=k[oa>>2]|0;w=h}}while(0);g=b;if(b|0){if((ma|0)!=(b|0))k[na>>2]=ma+(~((ma+-32-g|0)>>>5)<<5);ggb(b)}b=ja;if(ja|0){if((la|0)!=(ka|0))k[ta>>2]=la+(~(((la+-12-ja|0)>>>0)/12|0)*12|0);ggb(b)}k[Ga>>2]=1124024349;v=Ga+4|0;k[v>>2]=2;x=Ga+8|0;Ea=k[Na>>2]|0;b=k[Ta>>2]|0;g=Ea-b|0;k[x>>2]=g>>4;k[Ga+12>>2]=1;s=Ga+16|0;k[s>>2]=0;h=Ga+20|0;k[h>>2]=0;l=Ga+24|0;k[l>>2]=0;q=Ga+32|0;k[q>>2]=0;t=Ga+36|0;k[t>>2]=0;u=Ga+40|0;k[u>>2]=x;x=Ga+48|0;w=Ga+44|0;k[w>>2]=x;m=Ga+52|0;k[m>>2]=0;k[x>>2]=0;n=b;if((n|0)!=(Ea|0)){k[m>>2]=16;k[x>>2]=16;k[s>>2]=n;k[h>>2]=n;Ea=b+g|0;k[l>>2]=Ea;k[Ga+28>>2]=Ea}mY(Ga,c);b=k[t>>2]|0;if(b|0?(c=b+12|0,Ga=k[c>>2]|0,k[c>>2]=Ga+-1,(Ga|0)==1):0){g=k[t>>2]|0;if(g|0){b=k[g+4>>2]|0;if(!b){b=k[q>>2]|0;if(!b){b=B1()|0;g=k[t>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[t>>2]=0}k[t>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[v>>2]|0)>0){g=k[u>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[v>>2]|0))}b=k[w>>2]|0;if(!((b|0)==(x|0)|(b|0)==0))ggb(k[b+-4>>2]|0);do if(i[ua>>0]|0){k[Ia>>2]=1124024326;v=Ia+4|0;k[v>>2]=2;x=Ia+8|0;Ga=k[Ma>>2]|0;b=k[Sa>>2]|0;g=Ga-b|0;k[x>>2]=g>>3;k[Ia+12>>2]=1;s=Ia+16|0;k[s>>2]=0;h=Ia+20|0;k[h>>2]=0;l=Ia+24|0;k[l>>2]=0;q=Ia+32|0;k[q>>2]=0;t=Ia+36|0;k[t>>2]=0;u=Ia+40|0;k[u>>2]=x;x=Ia+48|0;w=Ia+44|0;k[w>>2]=x;m=Ia+52|0;k[m>>2]=0;k[x>>2]=0;n=b;if((n|0)!=(Ga|0)){k[m>>2]=8;k[x>>2]=8;k[s>>2]=n;k[h>>2]=n;Ga=b+g|0;k[l>>2]=Ga;k[Ia+28>>2]=Ga}mY(Ia,d);b=k[t>>2]|0;do if(b|0){Ia=b+12|0;d=k[Ia>>2]|0;k[Ia>>2]=d+-1;if((d|0)!=1)break;g=k[t>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[q>>2]|0;if(b|0)break;b=B1()|0;g=k[t>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[t>>2]=0}while(0);k[t>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[v>>2]|0)>0){g=k[u>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[v>>2]|0))}b=k[w>>2]|0;if((b|0)==(x|0)|(b|0)==0)break;ggb(k[b+-4>>2]|0)}while(0);do if(i[Fa>>0]|0){k[Ja>>2]=1124024326;v=Ja+4|0;k[v>>2]=2;x=Ja+8|0;d=k[La>>2]|0;b=k[Ra>>2]|0;g=d-b|0;k[x>>2]=g>>3;k[Ja+12>>2]=1;s=Ja+16|0;k[s>>2]=0;h=Ja+20|0;k[h>>2]=0;l=Ja+24|0;k[l>>2]=0;q=Ja+32|0;k[q>>2]=0;t=Ja+36|0;k[t>>2]=0;u=Ja+40|0;k[u>>2]=x;x=Ja+48|0;w=Ja+44|0;k[w>>2]=x;m=Ja+52|0;k[m>>2]=0;k[x>>2]=0;n=b;if((n|0)!=(d|0)){k[m>>2]=8;k[x>>2]=8;k[s>>2]=n;k[h>>2]=n;d=b+g|0;k[l>>2]=d;k[Ja+28>>2]=d}mY(Ja,e);b=k[t>>2]|0;do if(b|0){Ja=b+12|0;e=k[Ja>>2]|0;k[Ja>>2]=e+-1;if((e|0)!=1)break;g=k[t>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[q>>2]|0;if(b|0)break;b=B1()|0;g=k[t>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[t>>2]=0}while(0);k[t>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[v>>2]|0)>0){g=k[u>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[v>>2]|0))}b=k[w>>2]|0;if((b|0)==(x|0)|(b|0)==0)break;ggb(k[b+-4>>2]|0)}while(0);do if(i[Ha>>0]|0){k[Oa>>2]=1124024326;v=Oa+4|0;k[v>>2]=2;x=Oa+8|0;e=k[Ka>>2]|0;b=k[Qa>>2]|0;g=e-b|0;k[x>>2]=g>>3;k[Oa+12>>2]=1;s=Oa+16|0;k[s>>2]=0;h=Oa+20|0;k[h>>2]=0;l=Oa+24|0;k[l>>2]=0;q=Oa+32|0;k[q>>2]=0;t=Oa+36|0;k[t>>2]=0;u=Oa+40|0;k[u>>2]=x;x=Oa+48|0;w=Oa+44|0;k[w>>2]=x;m=Oa+52|0;k[m>>2]=0;k[x>>2]=0;n=b;if((n|0)!=(e|0)){k[m>>2]=8;k[x>>2]=8;k[s>>2]=n;k[h>>2]=n;e=b+g|0;k[l>>2]=e;k[Oa+28>>2]=e}mY(Oa,f);b=k[t>>2]|0;do if(b|0){Oa=b+12|0;f=k[Oa>>2]|0;k[Oa>>2]=f+-1;if((f|0)!=1)break;g=k[t>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[q>>2]|0;if(b|0)break;b=B1()|0;g=k[t>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[t>>2]=0}while(0);k[t>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[v>>2]|0)>0){g=k[u>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[v>>2]|0))}b=k[w>>2]|0;if((b|0)==(x|0)|(b|0)==0)break;ggb(k[b+-4>>2]|0)}while(0);b=k[Qa>>2]|0;g=b;if(b|0){h=k[Ka>>2]|0;if((h|0)!=(b|0))k[Ka>>2]=h+(~((h+-8-g|0)>>>3)<<3);ggb(b)}b=k[Ra>>2]|0;g=b;if(b|0){h=k[La>>2]|0;if((h|0)!=(b|0))k[La>>2]=h+(~((h+-8-g|0)>>>3)<<3);ggb(b)}b=k[Sa>>2]|0;g=b;if(b|0){h=k[Ma>>2]|0;if((h|0)!=(b|0))k[Ma>>2]=h+(~((h+-8-g|0)>>>3)<<3);ggb(b)}b=k[Ta>>2]|0;g=b;if(b|0){h=k[Na>>2]|0;if((h|0)!=(b|0))k[Na>>2]=h+(~((h+-16-g|0)>>>4)<<4);ggb(b)}h=Ua+36|0;b=k[h>>2]|0;do if(b|0){Sa=b+12|0;Ta=k[Sa>>2]|0;k[Sa>>2]=Ta+-1;if((Ta|0)!=1)break;g=k[h>>2]|0;if(g|0){b=k[g+4>>2]|0;do if(!b){b=k[Ua+32>>2]|0;if(b|0)break;b=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,g)}k[h>>2]=0}while(0);k[h>>2]=0;h=Ua+4|0;k[Pa>>2]=0;k[Pa+4>>2]=0;k[Pa+8>>2]=0;k[Pa+12>>2]=0;if((k[h>>2]|0)>0){g=k[Ua+40>>2]|0;b=0;do{k[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[h>>2]|0))}b=k[Ua+44>>2]|0;if((b|0)==(Ua+48|0)|(b|0)==0){r=Va;return}ggb(k[b+-4>>2]|0);r=Va;return}function Aoa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0.0,n=0.0,q=0,s=0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;O=r;r=r+240|0;H=O+176|0;N=O+120|0;I=O+96|0;B=O+32|0;C=O+112|0;D=O+88|0;E=O;if(!(G2(b)|0)){if((S1(b,-1)|0)&4088|0?((S1(b,-1)|0)&4088|0)!=16:0)G=4}else G=4;if((G|0)==4){a=H+4|0;d=ZT(76)|0;k[d>>2]=1;f=d+4|0;k[H>>2]=f;k[a>>2]=69;i[d+73>>0]=0;e=339977;g=f+69|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,H,340047,339828,1157);k[a>>2]=0;k[H>>2]=0;M=k[d>>2]|0;k[d>>2]=M+-1;if((M|0)==1)ggb(k[d+-4>>2]|0)}k[N>>2]=1124007936;K=N+4|0;q=N+8|0;J=N+40|0;f=K;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[J>>2]=q;M=N+48|0;L=N+44|0;k[L>>2]=M;k[N+52>>2]=0;k[M>>2]=0;if((S1(b,-1)|0)&4088){if(((S1(b,-1)|0)&4088|0)==16){A=H+4|0;z=A+4|0;k[z>>2]=0;k[z+4>>2]=0;k[H>>2]=33619968;k[A>>2]=N;$aa(b,H,6,0)}}else KG(N,J2(b,-1)|0)|0;k[I>>2]=0;s=I+4|0;k[s>>2]=0;k[I+8>>2]=0;l=I+8|0;Doa(I,N);a=k[s>>2]|0;if((a|0)==(k[l>>2]|0)){Doa(I,N);e=k[s>>2]|0}else{k[a>>2]=k[N>>2];j=a+4|0;k[j>>2]=k[K>>2];A=a+8|0;k[A>>2]=k[q>>2];k[a+12>>2]=k[N+12>>2];k[a+16>>2]=k[N+16>>2];k[a+20>>2]=k[N+20>>2];k[a+24>>2]=k[N+24>>2];k[a+28>>2]=k[N+28>>2];k[a+32>>2]=k[N+32>>2];d=k[N+36>>2]|0;k[a+36>>2]=d;e=a+40|0;k[e>>2]=A;A=a+48|0;g=a+44|0;k[g>>2]=A;k[a+52>>2]=0;k[A>>2]=0;if(d|0){A=d+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[K>>2]|0)>=3){k[j>>2]=0;x1(a,k[K>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[J>>2]|0;e=k[e>>2]|0;f=k[L>>2]|0;d=k[g>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[h+(a<<2)>>2];k[d+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else{z=k[L>>2]|0;A=k[g>>2]|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2]}e=(k[s>>2]|0)+56|0;k[s>>2]=e}if((e|0)==(k[l>>2]|0))Doa(I,N);else{k[e>>2]=k[N>>2];j=e+4|0;k[j>>2]=k[K>>2];A=e+8|0;k[A>>2]=k[q>>2];k[e+12>>2]=k[N+12>>2];k[e+16>>2]=k[N+16>>2];k[e+20>>2]=k[N+20>>2];k[e+24>>2]=k[N+24>>2];k[e+28>>2]=k[N+28>>2];k[e+32>>2]=k[N+32>>2];a=k[N+36>>2]|0;k[e+36>>2]=a;d=e+40|0;k[d>>2]=A;A=e+48|0;g=e+44|0;k[g>>2]=A;k[e+52>>2]=0;k[A>>2]=0;if(a|0){A=a+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[K>>2]|0)>=3){k[j>>2]=0;x1(e,k[K>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[J>>2]|0;e=k[d>>2]|0;f=k[L>>2]|0;d=k[g>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[h+(a<<2)>>2];k[d+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else{z=k[L>>2]|0;A=k[g>>2]|0;k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2]}k[s>>2]=(k[s>>2]|0)+56}k[B+8>>2]=0;k[B+12>>2]=0;k[B>>2]=17104896;k[B+4>>2]=I;k[H>>2]=0;a=H+4|0;k[a>>2]=0;k[H+8>>2]=0;B2(B,H);A=k[H>>2]|0;a=k[a>>2]|0;GV((A|0)==(a|0)?0:A,(a-A|0)/56|0,b);zF(H);k[H>>2]=1124007936;A=H+4|0;a=H+8|0;y=H+40|0;f=A;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[y>>2]=a;z=H+48|0;x=H+44|0;k[x>>2]=z;k[H+52>>2]=0;k[z>>2]=0;do if((k[c>>2]&2031616|0)==65536){f=k[c+4>>2]|0;k[B>>2]=k[f>>2];l=B+4|0;a=f+4|0;k[l>>2]=k[a>>2];w=B+8|0;k[w>>2]=k[f+8>>2];k[B+12>>2]=k[f+12>>2];k[B+16>>2]=k[f+16>>2];k[B+20>>2]=k[f+20>>2];k[B+24>>2]=k[f+24>>2];k[B+28>>2]=k[f+28>>2];k[B+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[B+36>>2]=d;e=B+40|0;k[e>>2]=w;w=B+48|0;h=B+44|0;k[h>>2]=w;k[B+52>>2]=0;k[w>>2]=0;if(d|0){w=d+12|0;k[w>>2]=(k[w>>2]|0)+1}if((k[a>>2]|0)<3){c=k[f+44>>2]|0;w=k[h>>2]|0;k[w>>2]=k[c>>2];k[w+4>>2]=k[c+4>>2];break}k[l>>2]=0;x1(B,k[a>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[j+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[l>>2]|0))}}else Q1(B,c,-1);while(0);KG(H,B)|0;e=B+36|0;a=k[e>>2]|0;if(a|0?(c=a+12|0,w=k[c>>2]|0,k[c>>2]=w+-1,(w|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[B+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;w=B+16|0;d=B+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[d>>2]|0)>0){e=k[B+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[B+44>>2]|0;if(!((a|0)==(B+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=y2(H,4,-1,1)|0;if((f|0)>0){g=H+16|0;h=H+12|0;j=B+4|0;l=j+4|0;q=C+4|0;s=D+4|0;c=E+16|0;w=E+24|0;e=0;do{do if((k[H>>2]&16384|0)==0?(F=k[y>>2]|0,(k[F>>2]|0)!=1):0){a=k[g>>2]|0;d=k[x>>2]|0;if((k[F+4>>2]|0)==1){a=a+(aa(k[d>>2]|0,e)|0)|0;break}else{P=k[h>>2]|0;Q=(e|0)/(P|0)|0;P=e-(aa(Q,P)|0)|0;a=a+(aa(k[d>>2]|0,Q)|0)+(P<<4)|0;break}}else G=70;while(0);if((G|0)==70){G=0;a=(k[g>>2]|0)+(e<<4)|0}n=+o[a>>2];t=+o[a+4>>2];m=+o[a+8>>2];v=+o[a+12>>2];a=J2(b,-1)|0;Q=l;k[Q>>2]=0;k[Q+4>>2]=0;k[B>>2]=50397184;k[j>>2]=a;a=(o[u>>2]=n,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;n=a?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=a?-0.0:0.0}d=~~n;a=(o[u>>2]=t,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;n=a?t+-8388608.0+8388608.0:t+8388608.0+-8388608.0;if(n==0.0)n=a?-0.0:0.0}else n=t;k[C>>2]=d;k[q>>2]=~~n;a=(o[u>>2]=m,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}d=~~m;a=(o[u>>2]=v,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}else m=v;k[D>>2]=d;k[s>>2]=~~m;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;p[c>>3]=255.0;p[w>>3]=0.0;Gfa(B,C,D,E,1,8,0);e=e+1|0}while((e|0)<(f|0))}e=H+36|0;a=k[e>>2]|0;if(a|0?(P=a+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[H+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;Q=H+16|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[A>>2]|0)>0){d=k[y>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[x>>2]|0;if(!((a|0)==(z|0)|(a|0)==0))ggb(k[a+-4>>2]|0);zF(I);e=N+36|0;a=k[e>>2]|0;if(a|0?(P=a+12|0,Q=k[P>>2]|0,k[P>>2]=Q+-1,(Q|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[N+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;Q=N+16|0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[K>>2]|0)>0){d=k[J>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[K>>2]|0))}a=k[L>>2]|0;if((a|0)==(M|0)|(a|0)==0){r=O;return}ggb(k[a+-4>>2]|0);r=O;return}function Boa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0.0,n=0.0,q=0.0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;Y=r;r=r+864|0;J=Y+808|0;X=Y+752|0;h=Y+280|0;W=Y+688|0;j=Y+56|0;V=Y+624|0;U=Y+568|0;A=Y+744|0;B=Y+680|0;R=Y;C=Y+560|0;D=Y+552|0;K=Y+536|0;H=Y+520|0;I=Y+504|0;a=k[b>>2]|0;f=b+4|0;g=k[f>>2]|0;if((k[e>>2]&2031616|0)!=0?(R1(J,e,-1),(k[J>>2]|0)!=(k[b>>2]|0)?1:(k[J+4>>2]|0)!=(k[f>>2]|0)):0){R1(J,e,-1);a=k[J>>2]|0;g=k[J+4>>2]|0}if(!(aa(g,a)|0)){f=J+4|0;b=ZT(16)|0;k[b>>2]=1;s=b+4|0;k[J>>2]=s;k[f>>2]=9;i[b+13>>0]=0;l=339802;t=s+9|0;do{i[s>>0]=i[l>>0]|0;s=s+1|0;l=l+1|0}while((s|0)<(t|0));Y8(-215,J,339812,339828,1196);k[f>>2]=0;k[J>>2]=0;T=k[b>>2]|0;k[b>>2]=T+-1;if((T|0)==1)ggb(k[b+-4>>2]|0)}k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=1124007936;f=h+16|0;b=h+48|0;s=h+12|0;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[b>>2]=f;f=h+56|0;k[h+52>>2]=f;k[h+60>>2]=0;k[f>>2]=0;k[h+64>>2]=1124007936;f=h+72|0;b=h+104|0;s=h+68|0;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[b>>2]=f;f=h+112|0;k[h+108>>2]=f;k[h+116>>2]=0;k[f>>2]=0;k[h+120>>2]=1124007936;f=h+128|0;b=h+160|0;s=h+124|0;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[b>>2]=f;s=h+168|0;k[h+164>>2]=s;t=s+56|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[J>>2]=a;k[J+4>>2]=g;j1(h,48,J,0);Coa(X,h);XN(h);k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=1124007936;f=j+16|0;b=j+48|0;s=j+12|0;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[b>>2]=f;f=j+56|0;k[j+52>>2]=f;k[j+60>>2]=0;k[f>>2]=0;k[j+64>>2]=1124007936;f=j+72|0;b=j+104|0;s=j+68|0;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[b>>2]=f;f=j+112|0;k[j+108>>2]=f;k[j+116>>2]=0;k[f>>2]=0;k[j+120>>2]=1124007936;f=j+128|0;b=j+160|0;s=j+124|0;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[b>>2]=f;s=j+168|0;k[j+164>>2]=s;t=s+56|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[J>>2]=a;k[J+4>>2]=g;j1(j,48,J,0);Coa(W,j);XN(j);k[V>>2]=1124007936;S=V+4|0;a=V+8|0;P=V+40|0;s=S;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[P>>2]=a;T=V+48|0;Q=V+44|0;k[Q>>2]=T;k[V+52>>2]=0;k[T>>2]=0;k[U>>2]=1124007936;N=U+4|0;a=U+8|0;L=U+40|0;s=N;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[L>>2]=a;O=U+48|0;M=U+44|0;k[M>>2]=O;k[U+52>>2]=0;k[O>>2]=0;do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[J>>2]=k[g>>2];c=J+4|0;a=g+4|0;k[c>>2]=k[a>>2];G=J+8|0;k[G>>2]=k[g+8>>2];k[J+12>>2]=k[g+12>>2];k[J+16>>2]=k[g+16>>2];k[J+20>>2]=k[g+20>>2];k[J+24>>2]=k[g+24>>2];k[J+28>>2]=k[g+28>>2];k[J+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[J+36>>2]=f;b=J+40|0;k[b>>2]=G;G=J+48|0;j=J+44|0;k[j>>2]=G;k[J+52>>2]=0;k[G>>2]=0;if(f|0){G=f+12|0;k[G>>2]=(k[G>>2]|0)+1}if((k[a>>2]|0)<3){F=k[g+44>>2]|0;G=k[j>>2]|0;k[G>>2]=k[F>>2];k[G+4>>2]=k[F+4>>2];break}k[c>>2]=0;x1(J,k[a>>2]|0,0,0,0);if((k[c>>2]|0)>0){l=k[g+40>>2]|0;h=k[b>>2]|0;b=k[g+44>>2]|0;f=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[l+(a<<2)>>2];k[f+(a<<2)>>2]=k[b+(a<<2)>>2];a=a+1|0}while((a|0)<(k[c>>2]|0))}}else Q1(J,c,-1);while(0);KG(V,J)|0;b=J+36|0;a=k[b>>2]|0;if(a|0?(F=a+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){f=k[b>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[J+32>>2]|0;if(!a){a=B1()|0;f=k[b>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[b>>2]=0}k[b>>2]=0;G=J+16|0;f=J+4|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[f>>2]|0)>0){b=k[J+40>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[J+44>>2]|0;if(!((a|0)==(J+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[J>>2]=k[g>>2];c=J+4|0;a=g+4|0;k[c>>2]=k[a>>2];G=J+8|0;k[G>>2]=k[g+8>>2];k[J+12>>2]=k[g+12>>2];k[J+16>>2]=k[g+16>>2];k[J+20>>2]=k[g+20>>2];k[J+24>>2]=k[g+24>>2];k[J+28>>2]=k[g+28>>2];k[J+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[J+36>>2]=f;b=J+40|0;k[b>>2]=G;G=J+48|0;j=J+44|0;k[j>>2]=G;k[J+52>>2]=0;k[G>>2]=0;if(f|0){G=f+12|0;k[G>>2]=(k[G>>2]|0)+1}if((k[a>>2]|0)<3){F=k[g+44>>2]|0;G=k[j>>2]|0;k[G>>2]=k[F>>2];k[G+4>>2]=k[F+4>>2];break}k[c>>2]=0;x1(J,k[a>>2]|0,0,0,0);if((k[c>>2]|0)>0){l=k[g+40>>2]|0;h=k[b>>2]|0;b=k[g+44>>2]|0;f=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[l+(a<<2)>>2];k[f+(a<<2)>>2]=k[b+(a<<2)>>2];a=a+1|0}while((a|0)<(k[c>>2]|0))}}else Q1(J,d,-1);while(0);KG(U,J)|0;b=J+36|0;a=k[b>>2]|0;if(a|0?(F=a+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){f=k[b>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[J+32>>2]|0;if(!a){a=B1()|0;f=k[b>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[b>>2]=0}k[b>>2]=0;G=J+16|0;f=J+4|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[f>>2]|0)>0){b=k[J+40>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[J+44>>2]|0;if(!((a|0)==(J+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=y2(V,4,-1,1)|0;z=y2(U,4,-1,1)|0;if((h|0)>0){j=V+16|0;l=V+12|0;c=J+4|0;s=c+4|0;t=A+4|0;d=B+4|0;w=R+8|0;x=R+16|0;y=R+24|0;g=0;do{do if(!(k[V>>2]&16384)){f=k[P>>2]|0;if((k[f>>2]|0)==1){E=k[j>>2]|0;a=E;m=+o[E+(g<<4)+8>>2];n=+o[E+(g<<4)>>2];q=+o[E+(g<<4)+4>>2];E=69;break}b=k[j>>2]|0;a=k[Q>>2]|0;if((k[f+4>>2]|0)==1)a=b+(aa(k[a>>2]|0,g)|0)|0;else{G=k[l>>2]|0;F=(g|0)/(G|0)|0;G=g-(aa(F,G)|0)|0;a=b+(aa(k[a>>2]|0,F)|0)+(G<<4)|0}n=+o[a>>2];a=k[Q>>2]|0;if((k[f+4>>2]|0)==1)a=b+(aa(k[a>>2]|0,g)|0)|0;else{G=k[l>>2]|0;F=(g|0)/(G|0)|0;G=g-(aa(F,G)|0)|0;a=b+(aa(k[a>>2]|0,F)|0)+(G<<4)|0}q=+o[a+4>>2];a=k[Q>>2]|0;if((k[f+4>>2]|0)==1)a=b+(aa(k[a>>2]|0,g)|0)|0;else{G=k[l>>2]|0;F=(g|0)/(G|0)|0;G=g-(aa(F,G)|0)|0;a=b+(aa(k[a>>2]|0,F)|0)+(G<<4)|0}m=+o[a+8>>2];a=k[Q>>2]|0;if((k[f+4>>2]|0)==1){a=b+(aa(k[a>>2]|0,g)|0)|0;break}else{G=k[l>>2]|0;F=(g|0)/(G|0)|0;G=g-(aa(F,G)|0)|0;a=b+(aa(k[a>>2]|0,F)|0)+(G<<4)|0;break}}else{E=k[j>>2]|0;a=E;m=+o[E+(g<<4)+8>>2];n=+o[E+(g<<4)>>2];q=+o[E+(g<<4)+4>>2];E=69}while(0);if((E|0)==69){E=0;a=a+(g<<4)|0}v=+o[a+12>>2];a=s;k[a>>2]=0;k[a+4>>2]=0;k[J>>2]=-2097086464;k[c>>2]=X;a=(o[u>>2]=n,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;n=a?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=a?-0.0:0.0}f=~~n;a=(o[u>>2]=q,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;n=a?q+-8388608.0+8388608.0:q+8388608.0+-8388608.0;if(n==0.0)n=a?-0.0:0.0}else n=q;k[A>>2]=f;k[t>>2]=~~n;a=(o[u>>2]=m,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}f=~~m;a=(o[u>>2]=v,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}else m=v;k[B>>2]=f;k[d>>2]=~~m;p[R>>3]=255.0;p[w>>3]=255.0;p[x>>3]=255.0;p[y>>3]=255.0;Gfa(J,A,B,R,1,8,0);g=g+1|0}while((g|0)<(h|0))}if((z|0)>0){h=U+16|0;j=U+12|0;l=J+4|0;c=l+4|0;s=C+4|0;t=D+4|0;d=R+8|0;w=R+16|0;x=R+24|0;g=0;do{do if(!(k[U>>2]&16384)){f=k[L>>2]|0;if((k[f>>2]|0)==1){E=k[h>>2]|0;a=E;m=+o[E+(g<<4)+8>>2];n=+o[E+(g<<4)>>2];q=+o[E+(g<<4)+4>>2];E=99;break}b=k[h>>2]|0;a=k[M>>2]|0;if((k[f+4>>2]|0)==1)a=b+(aa(k[a>>2]|0,g)|0)|0;else{G=k[j>>2]|0;F=(g|0)/(G|0)|0;G=g-(aa(F,G)|0)|0;a=b+(aa(k[a>>2]|0,F)|0)+(G<<4)|0}n=+o[a>>2];a=k[M>>2]|0;if((k[f+4>>2]|0)==1)a=b+(aa(k[a>>2]|0,g)|0)|0;else{G=k[j>>2]|0;F=(g|0)/(G|0)|0;G=g-(aa(F,G)|0)|0;a=b+(aa(k[a>>2]|0,F)|0)+(G<<4)|0}q=+o[a+4>>2];a=k[M>>2]|0;if((k[f+4>>2]|0)==1)a=b+(aa(k[a>>2]|0,g)|0)|0;else{G=k[j>>2]|0;F=(g|0)/(G|0)|0;G=g-(aa(F,G)|0)|0;a=b+(aa(k[a>>2]|0,F)|0)+(G<<4)|0}m=+o[a+8>>2];a=k[M>>2]|0;if((k[f+4>>2]|0)==1){a=b+(aa(k[a>>2]|0,g)|0)|0;break}else{G=k[j>>2]|0;F=(g|0)/(G|0)|0;G=g-(aa(F,G)|0)|0;a=b+(aa(k[a>>2]|0,F)|0)+(G<<4)|0;break}}else{E=k[h>>2]|0;a=E;m=+o[E+(g<<4)+8>>2];n=+o[E+(g<<4)>>2];q=+o[E+(g<<4)+4>>2];E=99}while(0);if((E|0)==99){E=0;a=a+(g<<4)|0}v=+o[a+12>>2];a=c;k[a>>2]=0;k[a+4>>2]=0;k[J>>2]=-2097086464;k[l>>2]=W;a=(o[u>>2]=n,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;n=a?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=a?-0.0:0.0}f=~~n;a=(o[u>>2]=q,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;n=a?q+-8388608.0+8388608.0:q+8388608.0+-8388608.0;if(n==0.0)n=a?-0.0:0.0}else n=q;k[C>>2]=f;k[s>>2]=~~n;a=(o[u>>2]=m,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}f=~~m;a=(o[u>>2]=v,k[u>>2]|0);do if((a&2130706432)>>>0>1249902592)m=v;else{a=(a|0)<0;m=a?v+-8388608.0+8388608.0:v+8388608.0+-8388608.0;if(!(m==0.0))break;m=a?-0.0:0.0}while(0);k[D>>2]=f;k[t>>2]=~~m;p[R>>3]=255.0;p[d>>3]=255.0;p[w>>3]=255.0;p[x>>3]=255.0;Gfa(J,C,D,R,1,8,0);g=g+1|0}while((g|0)<(z|0))}k[R>>2]=1124007936;F=R+4|0;a=R+8|0;D=R+40|0;s=F;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[D>>2]=a;G=R+48|0;E=R+44|0;k[E>>2]=G;k[R+52>>2]=0;k[G>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;k[K>>2]=-2130640896;k[K+4>>2]=X;k[H+8>>2]=0;k[H+12>>2]=0;k[H>>2]=-2130640896;k[H+4>>2]=W;C=I+4|0;B=C+4|0;k[B>>2]=0;k[B+4>>2]=0;k[I>>2]=33619968;k[C>>2]=R;k[J>>2]=101;aU(K,H,I,49332,J,1,11);k[J+8>>2]=0;k[J+12>>2]=0;k[J>>2]=16842752;k[J+4>>2]=R;H=o7(J)|0;if(k[e>>2]&2031616|0){if(((S1(e,-1)|0)&4088|0)!=16){k[J>>2]=0;a=J+4|0;k[a>>2]=0;f=ZT(28)|0;k[f>>2]=1;s=f+4|0;k[J>>2]=s;k[a>>2]=22;i[f+26>>0]=0;l=339893;t=s+22|0;do{i[s>>0]=i[l>>0]|0;s=s+1|0;l=l+1|0}while((s|0)<(t|0));Y8(-215,J,339812,339828,1229);k[a>>2]=0;k[J>>2]=0;I=k[f>>2]|0;k[f>>2]=I+-1;if((I|0)==1)ggb(k[f+-4>>2]|0)}b=J2(e,-1)|0;k[J>>2]=k[b>>2];A=J+4|0;a=b+4|0;k[A>>2]=k[a>>2];C=J+8|0;k[C>>2]=k[b+8>>2];k[J+12>>2]=k[b+12>>2];x=J+16|0;k[x>>2]=k[b+16>>2];k[J+20>>2]=k[b+20>>2];k[J+24>>2]=k[b+24>>2];k[J+28>>2]=k[b+28>>2];w=J+32|0;k[w>>2]=k[b+32>>2];y=J+36|0;f=k[b+36>>2]|0;k[y>>2]=f;z=J+40|0;k[z>>2]=C;C=J+48|0;B=J+44|0;k[B>>2]=C;k[J+52>>2]=0;k[C>>2]=0;if(f|0){e=f+12|0;k[e>>2]=(k[e>>2]|0)+1}if((k[a>>2]|0)>=3){k[A>>2]=0;x1(J,k[a>>2]|0,0,0,0);if((k[A>>2]|0)>0){g=k[b+40>>2]|0;h=k[z>>2]|0;f=k[b+44>>2]|0;b=k[B>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[g+(a<<2)>>2];k[b+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[A>>2]|0))}}else{I=k[b+44>>2]|0;e=k[B>>2]|0;k[e>>2]=k[I>>2];k[e+4>>2]=k[I+4>>2]}if(!(((k[J>>2]&16384|0)!=0?(k[X>>2]&16384|0)!=0:0)?(k[W>>2]&16384|0)!=0:0)){k[K>>2]=0;a=K+4|0;k[a>>2]=0;f=ZT(68)|0;k[f>>2]=1;s=f+4|0;k[K>>2]=s;k[a>>2]=60;i[f+64>>0]=0;l=339916;t=s+60|0;do{i[s>>0]=i[l>>0]|0;s=s+1|0;l=l+1|0}while((s|0)<(t|0));Y8(-215,K,339812,339828,1231);k[a>>2]=0;k[K>>2]=0;K=k[f>>2]|0;k[f>>2]=K+-1;if((K|0)==1)ggb(k[f+-4>>2]|0)}j=X+4|0;l=X+8|0;c=X+12|0;s=X+16|0;t=W+16|0;d=X+40|0;h=0;while(1){b=k[j>>2]|0;if((b|0)<3)a=aa(k[c>>2]|0,k[l>>2]|0)|0;else{g=k[d>>2]|0;f=0;a=1;do{a=aa(k[g+(f<<2)>>2]|0,a)|0;f=f+1|0}while((f|0)!=(b|0))}if(h>>>0>=a>>>0)break;a=i[(k[s>>2]|0)+h>>0]|0;f=i[(k[t>>2]|0)+h>>0]|0;if((f|a)<<24>>24){K=h*3|0;i[(k[x>>2]|0)+K>>0]=(a<<24>>24!=0)<<31>>31;i[(k[x>>2]|0)+(K+1)>>0]=0;i[(k[x>>2]|0)+(K+2)>>0]=(f<<24>>24!=0)<<31>>31}h=h+1|0}a=k[y>>2]|0;do if(a|0){J=a+12|0;K=k[J>>2]|0;k[J>>2]=K+-1;if((K|0)!=1)break;f=k[y>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[w>>2]|0;if(a|0)break;a=B1()|0;f=k[y>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[y>>2]=0}while(0);k[y>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;if((k[A>>2]|0)>0){f=k[z>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[B>>2]|0;if(!((a|0)==(C|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}b=R+36|0;a=k[b>>2]|0;if(a|0?(J=a+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){f=k[b>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[R+32>>2]|0;if(a|0)break;a=B1()|0;f=k[b>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[b>>2]=0}k[b>>2]=0;R=R+16|0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[F>>2]|0)>0){f=k[D>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[F>>2]|0))}a=k[E>>2]|0;if(!((a|0)==(G|0)|(a|0)==0))ggb(k[a+-4>>2]|0);b=U+36|0;a=k[b>>2]|0;if(a|0?(K=a+12|0,R=k[K>>2]|0,k[K>>2]=R+-1,(R|0)==1):0){f=k[b>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[U+32>>2]|0;if(a|0)break;a=B1()|0;f=k[b>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[b>>2]=0}k[b>>2]=0;U=U+16|0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[N>>2]|0)>0){f=k[L>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[N>>2]|0))}a=k[M>>2]|0;if(!((a|0)==(O|0)|(a|0)==0))ggb(k[a+-4>>2]|0);b=V+36|0;a=k[b>>2]|0;do if(a|0){R=a+12|0;U=k[R>>2]|0;k[R>>2]=U+-1;if((U|0)!=1)break;f=k[b>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[V+32>>2]|0;if(a|0)break;a=B1()|0;f=k[b>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[b>>2]=0}while(0);k[b>>2]=0;V=V+16|0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[S>>2]|0)>0){f=k[P>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[S>>2]|0))}a=k[Q>>2]|0;if(!((a|0)==(T|0)|(a|0)==0))ggb(k[a+-4>>2]|0);b=W+36|0;a=k[b>>2]|0;do if(a|0){U=a+12|0;V=k[U>>2]|0;k[U>>2]=V+-1;if((V|0)!=1)break;f=k[b>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[W+32>>2]|0;if(a|0)break;a=B1()|0;f=k[b>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[b>>2]=0}while(0);k[b>>2]=0;V=W+16|0;f=W+4|0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[f>>2]|0)>0){b=k[W+40>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[W+44>>2]|0;if(!((a|0)==(W+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);b=X+36|0;a=k[b>>2]|0;do if(a|0){V=a+12|0;W=k[V>>2]|0;k[V>>2]=W+-1;if((W|0)!=1)break;f=k[b>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[X+32>>2]|0;if(a|0)break;a=B1()|0;f=k[b>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[b>>2]=0}while(0);k[b>>2]=0;W=X+16|0;f=X+4|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[f>>2]|0)>0){b=k[X+40>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[X+44>>2]|0;if((a|0)==(X+48|0)|(a|0)==0){r=Y;return H|0}ggb(k[a+-4>>2]|0);r=Y;return H|0}function Coa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a+8|0;d=a+40|0;e=a+4|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;f=a+48|0;k[a+44>>2]=f;k[a+52>>2]=0;k[f>>2]=0;k[a>>2]=1124007936;f=k[b>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,b,a,0);return}function Doa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;o=a+4|0;c=k[a>>2]|0;h=((k[o>>2]|0)-c|0)/56|0;d=h+1|0;if(d>>>0>76695844)ad(426534,426557,304,426811);p=a+8|0;n=((k[p>>2]|0)-c|0)/56|0;e=n<<1;e=n>>>0<38347922?(e>>>0<d>>>0?d:e):76695844;if(!e)c=0;else{if(e>>>0>76695844){p=te(4)|0;k[p>>2]=172664;Cf(p|0,28816,1287)}d=e*56|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}m=c+(h*56|0)|0;d=m;n=c+(e*56|0)|0;k[m>>2]=k[b>>2];l=c+(h*56|0)+4|0;g=b+4|0;e=k[g>>2]|0;k[l>>2]=e;q=c+(h*56|0)+8|0;k[q>>2]=k[b+8>>2];k[c+(h*56|0)+12>>2]=k[b+12>>2];k[c+(h*56|0)+16>>2]=k[b+16>>2];k[c+(h*56|0)+20>>2]=k[b+20>>2];k[c+(h*56|0)+24>>2]=k[b+24>>2];k[c+(h*56|0)+28>>2]=k[b+28>>2];k[c+(h*56|0)+32>>2]=k[b+32>>2];f=k[b+36>>2]|0;k[c+(h*56|0)+36>>2]=f;i=c+(h*56|0)+40|0;k[i>>2]=q;q=c+(h*56|0)+48|0;j=c+(h*56|0)+44|0;k[j>>2]=q;k[c+(h*56|0)+52>>2]=0;k[q>>2]=0;if(!f)c=e;else{c=f+12|0;k[c>>2]=(k[c>>2]|0)+1;c=k[g>>2]|0}if((c|0)>=3){k[l>>2]=0;x1(m,k[g>>2]|0,0,0,0);if((k[l>>2]|0)>0){h=k[b+40>>2]|0;g=k[i>>2]|0;f=k[b+44>>2]|0;e=k[j>>2]|0;c=0;do{k[g+(c<<2)>>2]=k[h+(c<<2)>>2];k[e+(c<<2)>>2]=k[f+(c<<2)>>2];c=c+1|0}while((c|0)<(k[l>>2]|0))}}else{b=k[b+44>>2]|0;q=k[j>>2]|0;k[q>>2]=k[b>>2];k[q+4>>2]=k[b+4>>2]}f=m+56|0;e=k[a>>2]|0;c=k[o>>2]|0;while(1){if((c|0)==(e|0))break;q=d+-56|0;b=c+-56|0;AF(q,b);c=b;d=q}i=k[a>>2]|0;k[a>>2]=d;c=k[o>>2]|0;k[o>>2]=f;k[p>>2]=n;h=i;while(1){if((h|0)==(c|0))break;g=c+-56|0;f=c+-20|0;d=k[f>>2]|0;if(d|0?(p=d+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[c+-24>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;d=c+-40|0;e=c+-52|0;f=c+-16|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;d=0;while(1){if((d|0)>=(k[e>>2]|0))break;k[(k[f>>2]|0)+(d<<2)>>2]=0;d=d+1|0}d=k[c+-12>>2]|0;if((d|0)==(c+-8|0)|(d|0)==0){c=g;continue}ggb(k[d+-4>>2]|0);c=g}if(!i)return;ggb(i);return}function Eoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a+8|0;d=a+40|0;e=a+4|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;f=a+48|0;k[a+44>>2]=f;k[a+52>>2]=0;k[f>>2]=0;k[a>>2]=1124007942;Goa(a,b)|0;return}function Foa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0.0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+192|0;D=I+168|0;s=I;t=I+112|0;C=I+56|0;o=a+100|0;f=k[o>>2]|0;g=k[f+4>>2]|0;f=k[f>>2]|0;k[s>>2]=1124007936;n=s+4|0;e=s+8|0;j=s+40|0;h=n;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[j>>2]=e;m=s+48|0;h=s+44|0;k[h>>2]=m;k[s+52>>2]=0;k[m>>2]=0;k[D>>2]=f;q=D+4|0;k[q>>2]=g;G1(s,2,D,6);w=a+120|0;KG(w,s)|0;g=s+36|0;e=k[g>>2]|0;if(e|0?(F=e+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[s+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;G=s+16|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[n>>2]|0)>0){f=k[j>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[n>>2]|0))}e=k[h>>2]|0;if(!((e|0)==(m|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=k[o>>2]|0;f=k[g+4>>2]|0;g=k[g>>2]|0;k[s>>2]=1124007936;n=s+4|0;e=s+8|0;j=s+40|0;h=n;m=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(m|0));k[j>>2]=e;m=s+48|0;h=s+44|0;k[h>>2]=m;k[s+52>>2]=0;k[m>>2]=0;k[D>>2]=g;k[q>>2]=f;G1(s,2,D,6);o=a+180|0;KG(o,s)|0;g=s+36|0;e=k[g>>2]|0;if(e|0?(F=e+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[s+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;G=s+16|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[n>>2]|0)>0){f=k[j>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[n>>2]|0))}e=k[h>>2]|0;if(!((e|0)==(m|0)|(e|0)==0))ggb(k[e+-4>>2]|0);u=a+176|0;k[u>>2]=k[a+136>>2];G=a+236|0;k[G>>2]=k[a+196>>2];v=a+116|0;k[v>>2]=k[a+76>>2];F=a+296|0;k[F>>2]=k[a+72>>2];g=k[a+68>>2]|0;E=a+300|0;k[E>>2]=g;k[D>>2]=g+-1;k[D+4>>2]=g;k[s>>2]=-2147483648;k[s+4>>2]=2147483647;H1(t,w,D,s);p[s>>3]=-1024.0;k[D>>2]=-1056833530;k[D+4>>2]=s;k[D+8>>2]=1;k[D+12>>2]=1;pY(t,D,49332);g=t+36|0;e=k[g>>2]|0;if(e|0?(n=e+12|0,q=k[n>>2]|0,k[n>>2]=q+-1,(q|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[t+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;q=t+16|0;f=t+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[f>>2]|0)>0){g=k[t+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[t+44>>2]|0;if(!((e|0)==(t+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);g=k[F>>2]|0;k[D>>2]=-2147483648;k[D+4>>2]=2147483647;k[s>>2]=g+-1;k[s+4>>2]=g;H1(C,w,D,s);p[s>>3]=-1024.0;k[D>>2]=-1056833530;k[D+4>>2]=s;k[D+8>>2]=1;k[D+12>>2]=1;pY(C,D,49332);g=C+36|0;e=k[g>>2]|0;if(e|0?(s=e+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[C+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;t=C+16|0;f=C+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[f>>2]|0)>0){g=k[C+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[C+44>>2]|0;if(!((e|0)==(C+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);if(!(((k[a+60>>2]&16384|0)!=0?(k[o>>2]&16384|0)!=0:0)?(k[w>>2]&16384|0)!=0:0)){e=D+4|0;f=ZT(84)|0;k[f>>2]=1;h=f+4|0;k[D>>2]=h;k[e>>2]=78;i[f+82>>0]=0;g=340190;m=h+78|0;do{i[h>>0]=i[g>>0]|0;h=h+1|0;g=g+1|0}while((h|0)<(m|0));Y8(-215,D,340269,339828,558);k[e>>2]=0;k[D>>2]=0;D=k[f>>2]|0;k[f>>2]=D+-1;if((D|0)==1)ggb(k[f+-4>>2]|0)}q=k[E>>2]|0;s=k[F>>2]|0;if((q|0)>1){n=s+-1|0;o=q+-1|0;l=-1.0;m=0;do{e=aa(s,m)|0;g=n+e|0;a:do if((e|0)<(g|0)){h=k[v>>2]|0;j=k[G>>2]|0;while(1){while(1){D=s+e|0;B=+p[h+(D+1<<3)>>3]-+p[h+(e<<3)>>3];f=e;e=e+1|0;y=+p[h+(e<<3)>>3]-+p[h+(D<<3)>>3];x=B+y;y=B-y;B=+Q(+((x*x+y*y)*.25));p[j+(f<<3)>>3]=B;if(!(B<=+p[b>>3])){A=y;y=+P(+-A);z=+P(+x);if(!(y>=z)){z=y/(z+2.220446049250313e-16);y=z*z;y=90.0-z*(y*(y*(8.914000511169434-y*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{z=z/(y+2.220446049250313e-16);y=z*z;y=z*(y*(y*(8.914000511169434-y*2.539724588394165)+-18.66744613647461)+57.283626556396484)}A=A>-0.0?180.0-y:y;p[(k[u>>2]|0)+(f<<3)>>3]=(x<0.0?360.0-A:A)*.017453292519943295;if(B>l)break}else p[(k[u>>2]|0)+(f<<3)>>3]=-1024.0;if((e|0)>=(g|0))break a}if((e|0)<(g|0))l=B;else{l=B;break}}}while(0);m=m+1|0}while((m|0)!=(o|0))}else l=-1.0;e=aa(q,s)|0;if(!e){q=0;o=0}else{if(e>>>0>357913941)ad(426534,426557,304,426811);g=e*12|0;f=(g|0)==0?1:g;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}zpb(e|0,0,g|0)|0;q=e;o=e+g|0}m=(o-q|0)/12|0;n=d+8|0;e=k[n>>2]|0;j=k[d>>2]|0;f=j;do if(m>>>0<=((e-j|0)/12|0)>>>0){n=d+4|0;b=k[n>>2]|0;e=(b-j|0)/12|0;j=m>>>0>e>>>0;e=q+(e*12|0)|0;h=j?e:o;m=b;if((h|0)!=(q|0)){g=q;do{k[f>>2]=k[g>>2];k[f+4>>2]=k[g+4>>2];k[f+8>>2]=k[g+8>>2];g=g+12|0;f=f+12|0}while((g|0)!=(h|0))}if(!j){if((m|0)==(f|0))break;k[n>>2]=m+(~(((m+-12-f|0)>>>0)/12|0)*12|0);break}if((h|0)!=(o|0)){f=k[n>>2]|0;do{k[f>>2]=k[e>>2];k[f+4>>2]=k[e+4>>2];k[f+8>>2]=k[e+8>>2];e=e+12|0;f=(k[n>>2]|0)+12|0;k[n>>2]=f}while((e|0)!=(o|0))}}else{h=j;if(j){e=d+4|0;g=k[e>>2]|0;if((g|0)!=(f|0))k[e>>2]=g+(~(((g+-12-j|0)>>>0)/12|0)*12|0);ggb(h);k[n>>2]=0;k[e>>2]=0;k[d>>2]=0;e=0}if(m>>>0>357913941)ad(426534,426557,304,426811);b=(e|0)/12|0;h=b<<1;h=b>>>0<178956970?(h>>>0<m>>>0?m:h):357913941;if(h>>>0>357913941)bob();f=h*12|0;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}g=d+4|0;k[g>>2]=e;k[d>>2]=e;k[n>>2]=e+(h*12|0);if((q|0)==(o|0))break;else f=q;do{k[e>>2]=k[f>>2];k[e+4>>2]=k[f+4>>2];k[e+8>>2]=k[f+8>>2];f=f+12|0;e=(k[g>>2]|0)+12|0;k[g>>2]=e}while((f|0)!=(o|0))}while(0);if(q|0)ggb(q);f=k[c>>2]|0;do if(!f){C=0;e=0}else{if(f>>>0>1073741823)ad(426534,426557,304,426811);g=f<<2;g=(g|0)==0?1:g;while(1){e=fgb(g)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}g=e;while(1){k[g>>2]=0;f=f+-1|0;if(!f)break;else g=g+4|0}f=k[c>>2]|0;if(!f){C=0;break}if(f>>>0>1073741823)ad(426534,426557,304,426811);h=f<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}g=h;while(1){k[g>>2]=0;f=f+-1|0;if(!f){C=h;break}else g=g+4|0}}while(0);if(l>0.0)l=+(((k[c>>2]|0)+-1|0)>>>0)/l;else l=0.0;f=k[E>>2]|0;do if((f|0)>1){a=k[F>>2]|0;n=f+-1|0;if((a|0)<=1)break;o=a+-1|0;q=a+-1|0;h=0;j=0;while(1){f=0;g=(k[G>>2]|0)+((aa(a,h)|0)<<3)|0;m=j;while(1){s=~~(l*+p[g>>3]);t=C+(s<<2)|0;u=k[t>>2]|0;v=k[d>>2]|0;w=v+(m*12|0)|0;if(!u)k[e+(s<<2)>>2]=w;else k[u+8>>2]=w;k[t>>2]=w;k[w>>2]=f;k[v+(m*12|0)+4>>2]=h;k[v+(m*12|0)+8>>2]=0;f=f+1|0;if((f|0)==(o|0))break;else{g=g+8|0;m=m+1|0}}h=h+1|0;if((h|0)==(n|0))break;else j=q+j|0}}while(0);g=k[c>>2]|0;while(1){g=g+-1|0;if((g|0)<=0)break;if(k[e+(g<<2)>>2]|0){H=138;break}}if((H|0)==138){f=k[C+(g<<2)>>2]|0;do{j=g;g=g+-1|0;h=k[e+(g<<2)>>2]|0;if(h){k[f+8>>2]=h;f=k[C+(g<<2)>>2]|0}}while((j|0)>1)}if(C|0)ggb(C);if(!e){r=I;return}ggb(e);r=I;return}function Goa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=r;r=r+64|0;e=f;c=k[b>>2]|0;if((c&4095|0)==6){KG(a,b)|0;e=a;r=f;return e|0}if((c&7|0)!=6){d=e+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[e>>2]=-2113863674;k[d>>2]=a;SW(b,e,6,1.0,0.0);e=a;r=f;return e|0}p4(e,b,k[b+4>>2]|0);d=Goa(a,e)|0;c=e+36|0;a=k[c>>2]|0;if(a|0?(a=a+12|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[e+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;c=e+16|0;b=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[b>>2]|0)>0){c=k[e+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[e+44>>2]|0;if(!((a|0)==(e+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=d;r=f;return e|0}function Hoa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,j=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;k[d>>2]=1;v=k[b>>2]|0;w=k[c>>2]|0;k[w>>2]=v;y=k[b+4>>2]|0;k[w+4>>2]=y;x=a+296|0;v=(aa(k[x>>2]|0,y)|0)+v|0;y=a+256|0;b=(k[y>>2]|0)+v|0;k[w+8>>2]=b;z=a+176|0;g=+p[(k[z>>2]|0)+(v<<3)>>3];p[e>>3]=g;p[w+16>>3]=g;A=a+236|0;p[w+24>>3]=+p[(k[A>>2]|0)+(v<<3)>>3];g=+p[e>>3];i[b>>0]=1;b=k[d>>2]|0;if((b|0)<=0)return;m=+T(+g);j=+S(+g);w=a+300|0;g=m;v=0;a=k[c>>2]|0;do{t=k[a+(v<<5)>>2]|0;u=t+-1|0;u=(u|0)<0?0:u;t=t+1|0;n=k[x>>2]|0;s=n+-1|0;t=(s|0)<(t|0)?s:t;s=k[a+(v<<5)+4>>2]|0;h=s+-1|0;h=(h|0)<0?0:h;s=s+1|0;r=(k[w>>2]|0)+-1|0;s=(r|0)<(s|0)?r:s;a:do if(!((h|0)>(s|0)|(u|0)>(t|0))){o=k[y>>2]|0;while(1){r=u;q=(aa(n,h)|0)+u|0;while(1){n=o+q|0;if(!((q|0)<0|(i[n>>0]|0)==1)?(B=+p[(k[z>>2]|0)+(q<<3)>>3],!(B==-1024.0)):0){l=+p[e>>3]-B;l=l<0.0?-l:l;if(l>4.71238898038469){l=l+-6.283185307179586;if(l<0.0)l=-l}if(l<=+p[f>>3]){i[n>>0]=1;b=k[d>>2]|0;a=k[c>>2]|0;k[a+(b<<5)>>2]=r;k[a+(b<<5)+4>>2]=h;n=k[y>>2]|0;k[a+(b<<5)+8>>2]=n+q;p[a+(b<<5)+24>>3]=+p[(k[A>>2]|0)+(q<<3)>>3];o=(k[z>>2]|0)+(q<<3)|0;p[a+(b<<5)+16>>3]=+p[o>>3];b=(k[d>>2]|0)+1|0;k[d>>2]=b;l=+p[o>>3];j=j+ +S(+l);g=g+ +T(+l);l=+P(+j);m=+P(+g);if(!(l>=m)){m=l/(m+2.220446049250313e-16);l=m*m;l=90.0-m*(l*(l*(8.914000511169434-l*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{m=m/(l+2.220446049250313e-16);l=m*m;l=m*(l*(l*(8.914000511169434-l*2.539724588394165)+-18.66744613647461)+57.283626556396484)}m=j<0.0?180.0-l:l;p[e>>3]=(g<0.0?360.0-m:m)*.017453292519943295}else n=o}else n=o;if((r|0)<(t|0)){r=r+1|0;o=n;q=q+1|0}else break}if((h|0)>=(s|0))break a;h=h+1|0;o=n;n=k[x>>2]|0}}while(0);v=v+1|0}while((v|0)<(b|0));return}function Ioa(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=f|0;var g=0,h=0.0,j=0.0,l=0.0,m=0.0,n=0,o=0,q=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0;B=r;r=r+16|0;x=B;y=(b|0)>0;if(y){n=k[a>>2]|0;g=0;j=0.0;l=0.0;h=0.0;do{A=+p[n+(g<<5)+24>>3];l=l+ +(k[n+(g<<5)>>2]|0)*A;h=h+ +(k[n+(g<<5)+4>>2]|0)*A;j=j+A;g=g+1|0}while((g|0)!=(b|0));if(!(j>0.0))o=5}else{j=0.0;l=0.0;h=0.0;o=5}if((o|0)==5){s=x+4|0;g=ZT(12)|0;k[g>>2]=1;q=g+4|0;k[x>>2]=q;k[s>>2]=7;i[g+11>>0]=0;i[q>>0]=i[371708]|0;i[q+1>>0]=i[371709]|0;i[q+2>>0]=i[371710]|0;i[q+3>>0]=i[371711]|0;i[q+4>>0]=i[371712]|0;i[q+5>>0]=i[371713]|0;i[q+6>>0]=i[371714]|0;Y8(-215,x,340096,339828,702);k[s>>2]=0;k[x>>2]=0;s=k[g>>2]|0;k[g>>2]=s+-1;if((s|0)==1)ggb(k[g+-4>>2]|0)}A=l/j;z=h/j;do if(y){n=k[a>>2]|0;g=0;h=0.0;j=0.0;l=0.0;do{v=+(k[n+(g<<5)>>2]|0)-A;w=+(k[n+(g<<5)+4>>2]|0)-z;u=+p[n+(g<<5)+24>>3];h=h+u*(w*w);j=j+v*v*u;l=l-u*(v*w);g=g+1|0}while((g|0)!=(b|0));if(!(h==0.0)?(v=+P(+h),w=v>0.0?v:0.0,!(v/(w<2.2250738585072014e-308?2.2250738585072014e-308:w)<=2.220446049250313e-14)):0){m=h;break}if(!(j==0.0)?(v=+P(+j),w=v>0.0?v:0.0,!(v/(w<2.2250738585072014e-308?2.2250738585072014e-308:w)<=2.220446049250313e-14)):0){m=h;break}if(!(l==0.0)?(v=+P(+l),w=v>0.0?v:0.0,!(v/(w<2.2250738585072014e-308?2.2250738585072014e-308:w)<=2.220446049250313e-14)):0)m=h;else o=17}else{h=0.0;j=0.0;l=0.0;o=17}while(0);if((o|0)==17){g=x+4|0;n=ZT(76)|0;k[n>>2]=1;o=n+4|0;k[x>>2]=o;k[g>>2]=71;i[n+75>>0]=0;q=340108;s=o+71|0;do{i[o>>0]=i[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(s|0));Y8(-215,x,340180,339828,767);k[g>>2]=0;k[x>>2]=0;x=k[n>>2]|0;k[n>>2]=x+-1;if((x|0)==1)ggb(k[n+-4>>2]|0);m=h}h=m-j;h=(j+m-+Q(+(l*(l*4.0)+h*h)))*.5;if(+P(+m)>+P(+j)){m=h-m;h=+P(+l);j=+P(+m);if(!(h>=j)){w=h/(j+2.220446049250313e-16);h=w*w;h=90.0-w*(h*(h*(8.914000511169434-h*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{w=j/(h+2.220446049250313e-16);h=w*w;h=w*(h*(h*(8.914000511169434-h*2.539724588394165)+-18.66744613647461)+57.283626556396484)}h=l<0.0?180.0-h:h;h=m<0.0?360.0-h:h}else{m=h-j;h=+P(+m);j=+P(+l);if(!(h>=j)){w=h/(j+2.220446049250313e-16);h=w*w;h=90.0-w*(h*(h*(8.914000511169434-h*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{w=j/(h+2.220446049250313e-16);h=w*w;h=w*(h*(h*(8.914000511169434-h*2.539724588394165)+-18.66744613647461)+57.283626556396484)}h=m<0.0?180.0-h:h;h=l<0.0?360.0-h:h}j=h*.017453292519943295;h=j-c;if(h<=-3.141592653589793)do h=h+6.283185307179586;while(h<=-3.141592653589793);if(h>3.141592653589793)do h=h+-6.283185307179586;while(h>3.141592653589793);x=+P(+h)>d;u=x?j+3.141592653589793:j;v=+S(+u);w=+T(+u);if(y){n=k[a>>2]|0;m=0.0;l=0.0;g=0;j=0.0;h=0.0;do{t=+(k[n+(g<<5)>>2]|0)-A;C=+(k[n+(g<<5)+4>>2]|0)-z;c=v*t+w*C;t=v*C-w*t;if(!(c>l)){if(c<m)m=c}else l=c;if(!(t>j)){if(t<h)h=t}else j=t;g=g+1|0}while((g|0)!=(b|0))}else{m=0.0;l=0.0;j=0.0;h=0.0}p[f>>3]=v*m+A;p[f+8>>3]=w*m+z;p[f+16>>3]=v*l+A;p[f+24>>3]=w*l+z;C=j-h;g=f+32|0;p[g>>3]=C;p[f+40>>3]=A;p[f+48>>3]=z;p[f+56>>3]=u;p[f+64>>3]=v;p[f+72>>3]=w;p[f+80>>3]=d;p[f+88>>3]=e;if(!(C<1.0)){r=B;return}p[g>>3]=1.0;r=B;return}function Joa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=a+4|0;c=k[l>>2]|0;m=k[a>>2]|0;f=c-m>>4;d=f+1|0;if(d>>>0>268435455)ad(426534,426557,304,426811);j=m;h=c;i=a+8|0;g=(k[i>>2]|0)-m|0;e=g>>3;e=g>>4>>>0<134217727?(e>>>0<d>>>0?d:e):268435455;if(!e)d=0;else{if(e>>>0>268435455){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=e<<4;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c}c=d+(f<<4)|0;g=d+(e<<4)|0;k[c>>2]=k[b>>2];k[d+(f<<4)+4>>2]=k[b+4>>2];k[d+(f<<4)+8>>2]=k[b+8>>2];k[d+(f<<4)+12>>2]=k[b+12>>2];f=c+16|0;if((h|0)!=(j|0)){b=h+-16|0;d=h;e=c;do{h=e;e=e+-16|0;n=d;d=d+-16|0;k[e>>2]=k[d>>2];k[h+-12>>2]=k[n+-12>>2];k[h+-8>>2]=k[n+-8>>2];k[h+-4>>2]=k[n+-4>>2]}while((d|0)!=(j|0));c=c+(~((b-m|0)>>>4)<<4)|0}k[a>>2]=c;k[l>>2]=f;k[i>>2]=g;if(!m)return;ggb(m);return}function Koa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>3;c=g+1|0;if(c>>>0>536870911)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>2;f=e>>3>>>0<268435455?(f>>>0<c>>>0?c:f):536870911;if(!f)c=0;else{if(f>>>0>536870911){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<3)|0;p[e>>3]=+p[b>>3];d=e+(0-g<<3)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+8;k[l>>2]=c+(f<<3);if(!i)return;ggb(i);return}function Loa(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0.0,f=0.0,g=0.0,h=0,j=0.0,l=0,m=0.0,n=0.0,o=0,q=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0;G=r;r=r+16|0;o=G;c=+p[b+32>>3];e=+p[b+72>>3];f=+p[b+64>>3];while(1){d=fgb(48)|0;if(d|0){F=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){F=0;break}Qh[d&7]()}l=F+48|0;x=F+8|0;d=x;h=d+40|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(h|0));C=c*.5;m=e*C;C=C*f;n=+p[b>>3];k[F>>2]=~~(n-m);u=+p[b+8>>3];D=F+4|0;k[D>>2]=~~(C+u);i[x>>0]=0;g=+p[b+16>>3];h=F+12|0;k[h>>2]=~~(g-m);j=+p[b+24>>3];z=F+16|0;k[z>>2]=~~(C+j);q=F+20|0;i[q>>0]=0;s=F+24|0;k[s>>2]=~~(m+g);E=F+28|0;k[E>>2]=~~(j-C);t=F+32|0;i[t>>0]=0;v=F+36|0;k[v>>2]=~~(m+n);d=F+40|0;k[d>>2]=~~(u-C);w=F+44|0;i[w>>0]=0;k[o>>2]=269;Noa(F,l,o);D=k[D>>2]|0;z=k[z>>2]|0;y=(D|0)>(z|0)?h:F;z=(D|0)<(z|0)?h:F;E=k[E>>2]|0;y=(k[y+4>>2]|0)>(E|0)?s:y;z=(k[z+4>>2]|0)<(E|0)?s:z;d=k[d>>2]|0;y=(k[y+4>>2]|0)>(d|0)?v:y;z=(k[z+4>>2]|0)<(d|0)?v:z;i[y+8>>0]=1;d=(i[x>>0]|0)==0?F:0;if(!(i[q>>0]|0))if(!d)d=h;else d=(k[d>>2]|0)>(k[h>>2]|0)?h:d;if(!(i[t>>0]|0))if(!d)d=s;else d=(k[d>>2]|0)>(k[s>>2]|0)?s:d;if(!(i[w>>0]|0))if(!d)l=v;else l=(k[d>>2]|0)>(k[v>>2]|0)?v:d;else l=d;i[l+8>>0]=1;d=(i[x>>0]|0)==0?F:0;if(!(i[q>>0]|0))if(!d)d=h;else d=(k[d>>2]|0)<(k[h>>2]|0)?h:d;if(!(i[t>>0]|0))if(!d)d=s;else d=(k[d>>2]|0)<(k[s>>2]|0)?s:d;if(!(i[w>>0]|0))if(!d)o=v;else o=(k[d>>2]|0)<(k[v>>2]|0)?v:d;else o=d;i[o+8>>0]=1;d=(i[x>>0]|0)==0?F:0;if(!(i[q>>0]|0))if(!d)d=h;else d=(k[d>>2]|0)>(k[h>>2]|0)?h:d;if(!(i[t>>0]|0))if(!d)d=s;else d=(k[d>>2]|0)>(k[s>>2]|0)?s:d;if(!(i[w>>0]|0))if(!d)d=v;else d=(k[d>>2]|0)>(k[v>>2]|0)?v:d;i[d+8>>0]=1;q=k[y+4>>2]|0;E=k[l+4>>2]|0;if((q|0)==(E|0))f=0.0;else f=+(((k[y>>2]|0)-(k[l>>2]|0)|0)/(q-E|0)|0|0);d=k[d>>2]|0;if((E|0)==(d|0))C=0.0;else C=+(((k[l>>2]|0)-d|0)/(E-d|0)|0|0);D=k[o+4>>2]|0;if((q|0)==(D|0))e=0.0;else e=+(((k[y>>2]|0)-(k[o>>2]|0)|0)/(q-D|0)|0|0);if((D|0)==(d|0))u=0.0;else u=+(((k[o>>2]|0)-d|0)/(D-d|0)|0|0);c=+(k[y>>2]|0);y=k[z+4>>2]|0;if((q|0)<=(y|0)){z=a+300|0;A=a+296|0;B=a+176|0;m=+p[b+56>>3];n=+p[b+80>>3];h=0;o=0;j=c;g=c;s=0;d=0;while(1){if((q|0)>=0?(q|0)<(k[z>>2]|0):0){w=k[A>>2]|0;l=~~g;x=~~j;if((l|0)>(x|0))l=s;else{v=l;t=(aa(w,q)|0)+l|0;while(1){do if((v|0)>-1&(v|0)<(w|0)){d=d+1|0;if((t|0)<0){o=d;l=s;break}c=+p[(k[B>>2]|0)+(t<<3)>>3];if(c==-1024.0){o=d;l=s;break}c=m-c;c=c<0.0?-c:c;do if(c>4.71238898038469){c=c+-6.283185307179586;if(!(c<0.0))break;c=-c}while(0);if(!(c<=n)){o=d;l=s;break}l=s+1|0;h=l;o=d}else l=s;while(0);if((v|0)<(x|0)){v=v+1|0;s=l;t=t+1|0}else break}}f=(q|0)<(E|0)?f:C;e=(q|0)<(D|0)?e:u;c=j+e;g=g+f}else{c=j;l=s}if((q|0)<(y|0)){q=q+1|0;j=c;s=l}else break}d=b+88|0;if(!((o|0)==0|(h|0)==0)){if((o|0)==(h|0)){C=-+p[a+304>>3];C=C-+(o|0)*+Pfb(+p[d>>3]);ggb(F);r=G;return +C}j=+p[d>>3];g=1.0-j;u=j/g;m=+(o|0);n=+(h|0);c=n+1.0;if(c>15.0){e=(c+-.5)*+_(+c)+.918938533204673-c;e=e+c*.5*+_(+(c*+Nfb(1.0/c)+1.0/(+R(+c,6.0)*810.0)))}else e=+Ooa(c);f=+(o-h|0);c=f+1.0;if(c>15.0){C=(c+-.5)*+_(+c)+.918938533204673-c;c=C+c*.5*+_(+(c*+Nfb(1.0/c)+1.0/(+R(+c,6.0)*810.0)))}else c=+Ooa(c);e=m+1.0-e-c+n*+_(+j)+ +_(+g)*f;c=+Z(+e);do if(!(c==0.0)){g=+P(+c);C=g>0.0?g:0.0;if(g/(C<2.2250738585072014e-308?2.2250738585072014e-308:C)<=2.220446049250313e-14)break;l=a+304|0;if((o|0)>(h|0)){d=h;j=c;while(1){h=d+1|0;e=+(o-d|0);C=e/+(h|0);f=u*C;g=c*f;c=j+g;if(C<1.0){n=g*((1.0-+R(+f,+e))/(1.0-f)+-1.0);C=-+Pfb(c);if((o|0)>(h|0)?!(n<c*(+P(+(C-+p[l>>3]))*.1)):0){d=h;j=c;c=g;continue}else break}else if((o|0)>(h|0)){d=h;j=c;c=g;continue}else break}}C=-+Pfb(c);C=C-+p[l>>3];ggb(F);r=G;return +C}while(0);c=+p[a+304>>3];if(n>m*j){C=-e/2.302585092994046-c;ggb(F);r=G;return +C}else{C=-c;ggb(F);r=G;return +C}}}C=-+p[a+304>>3];ggb(F);r=G;return +C}function Moa(a,b){a=a|0;b=b|0;var c=0,d=0;c=k[a>>2]|0;d=k[b>>2]|0;if((c|0)==(d|0)){d=(k[a+4>>2]|0)<(k[b+4>>2]|0);return d|0}else{d=(c|0)<(d|0);return d|0}return 0}function Noa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;t=r;r=r+16|0;s=t;a:while(1){m=b;n=b+-12|0;o=b+-8|0;p=b+-4|0;while(1){b:while(1){l=a;d=m-l|0;switch((d|0)/12|0|0){case 2:{q=5;break a}case 3:{q=7;break a}case 4:{q=8;break a}case 5:{q=9;break a}case 1:case 0:{q=53;break a}default:{}}if((d|0)<84){q=11;break a}g=a+(((d>>>0)/24|0)*12|0)|0;if((d|0)>11988){d=(d>>>0)/48|0;d=Roa(a,a+(d*12|0)|0,g,g+(d*12|0)|0,n,c)|0}else d=Poa(a,g,n,c)|0;if(Hh[k[c>>2]&511](a,g)|0){f=n;break}else e=n;while(1){f=e+-12|0;if((a|0)==(f|0))break;if(Hh[k[c>>2]&511](f,g)|0){q=36;break b}else e=f}d=a+12|0;if(!(Hh[k[c>>2]&511](a,n)|0)){if((d|0)==(n|0)){q=53;break a}while(1){if(Hh[k[c>>2]&511](a,d)|0)break;d=d+12|0;if((d|0)==(n|0)){q=53;break a}}h=k[d>>2]|0;f=d+4|0;j=k[f>>2]|0;g=d+8|0;l=i[g>>0]|0;k[d>>2]=k[n>>2];k[f>>2]=k[o>>2];i[g>>0]=i[p>>0]|0;k[n>>2]=h;k[o>>2]=j;i[p>>0]=l;d=d+12|0}if((d|0)==(n|0)){q=53;break a}else e=n;while(1){while(1){g=d+12|0;if(Hh[k[c>>2]&511](a,d)|0)break;else d=g}while(1){f=e+-12|0;if(Hh[k[c>>2]&511](a,f)|0)e=f;else break}if(d>>>0>=f>>>0){a=d;continue b}h=k[d>>2]|0;v=d+4|0;j=k[v>>2]|0;u=d+8|0;l=i[u>>0]|0;k[d>>2]=k[f>>2];d=e+-8|0;k[v>>2]=k[d>>2];e=e+-4|0;i[u>>0]=i[e>>0]|0;k[f>>2]=h;k[d>>2]=j;i[e>>0]=l;e=f;d=g}}if((q|0)==36){q=0;w=k[a>>2]|0;v=a+4|0;h=k[v>>2]|0;x=a+8|0;u=i[x>>0]|0;k[a>>2]=k[f>>2];j=e+-8|0;k[v>>2]=k[j>>2];v=e+-4|0;i[x>>0]=i[v>>0]|0;k[f>>2]=w;k[j>>2]=h;i[v>>0]=u;d=d+1|0}e=a+12|0;c:do if(e>>>0<f>>>0){j=g;while(1){while(1){h=e+12|0;if(Hh[k[c>>2]&511](e,j)|0)e=h;else break}while(1){g=f+-12|0;if(Hh[k[c>>2]&511](g,j)|0)break;else f=g}if(e>>>0>g>>>0){f=j;g=e;break c}u=k[e>>2]|0;z=e+4|0;v=k[z>>2]|0;y=e+8|0;x=i[y>>0]|0;k[e>>2]=k[g>>2];w=f+-8|0;k[z>>2]=k[w>>2];f=f+-4|0;i[y>>0]=i[f>>0]|0;k[g>>2]=u;k[w>>2]=v;i[f>>0]=x;j=(j|0)==(e|0)?g:j;f=g;e=h;d=d+1|0}}else{f=g;g=e}while(0);if((g|0)!=(f|0)?Hh[k[c>>2]&511](f,g)|0:0){v=k[g>>2]|0;z=g+4|0;w=k[z>>2]|0;u=g+8|0;y=i[u>>0]|0;k[g>>2]=k[f>>2];x=f+4|0;k[z>>2]=k[x>>2];z=f+8|0;i[u>>0]=i[z>>0]|0;k[f>>2]=v;k[x>>2]=w;i[z>>0]=y;d=d+1|0}if(!d){d=Soa(a,g,c)|0;e=g+12|0;if(Soa(e,b,c)|0){q=52;break}if(d){a=e;continue}}z=g;if((z-l|0)>=(m-z|0)){q=51;break}Noa(a,g,c);a=g+12|0}if((q|0)==51){q=0;Noa(g+12|0,b,c);b=g;continue}else if((q|0)==52){q=0;if(d){q=53;break}else{b=g;continue}}}if((q|0)==5){if(!(Hh[k[c>>2]&511](n,a)|0)){r=t;return}x=k[a>>2]|0;v=a+4|0;y=k[v>>2]|0;w=a+8|0;z=i[w>>0]|0;k[a>>2]=k[n>>2];k[v>>2]=k[o>>2];i[w>>0]=i[p>>0]|0;k[n>>2]=x;k[o>>2]=y;i[p>>0]=z;r=t;return}else if((q|0)==7){Poa(a,a+12|0,n,c)|0;r=t;return}else if((q|0)==8){Qoa(a,a+12|0,a+24|0,n,c)|0;r=t;return}else if((q|0)==9){Roa(a,a+12|0,a+24|0,a+36|0,n,c)|0;r=t;return}else if((q|0)==11){d=a+24|0;Poa(a,a+12|0,d,c)|0;e=a+36|0;if((e|0)==(b|0)){r=t;return}j=s+4|0;l=s+8|0;while(1){if(Hh[k[c>>2]&511](e,d)|0){k[s>>2]=k[e>>2];k[j>>2]=k[e+4>>2];i[l>>0]=i[e+8>>0]|0;f=e;while(1){k[f>>2]=k[d>>2];g=d+4|0;k[f+4>>2]=k[g>>2];h=d+8|0;i[f+8>>0]=i[h>>0]|0;if((d|0)==(a|0))break;f=d+-12|0;if(Hh[k[c>>2]&511](s,f)|0){z=d;d=f;f=z}else break}k[d>>2]=k[s>>2];k[g>>2]=k[j>>2];i[h>>0]=i[l>>0]|0}d=e+12|0;if((d|0)==(b|0))break;else{z=e;e=d;d=z}}r=t;return}else if((q|0)==53){r=t;return}}function Ooa(a){a=+a;var b=0.0;b=a+5.5;return +((a+.5)*+_(+b)-b-+_(+(a+0.0))-+_(+(a+1.0))-+_(+(a+2.0))-+_(+(a+3.0))-+_(+(a+4.0))-+_(+(a+5.0))-+_(+(a+6.0))+ +_(+(a*80916.6278952+75122.633153+a*a*36308.2951477+ +R(+a,3.0)*8687.24529705+ +R(+a,4.0)*1168.92649479+ +R(+a,5.0)*83.8676043424+ +R(+a,6.0)*2.50662827511)))}function Poa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=Hh[k[d>>2]&511](b,a)|0;e=Hh[k[d>>2]&511](c,b)|0;if(!m){if(!e){d=0;return d|0}g=k[b>>2]|0;f=b+4|0;h=k[f>>2]|0;e=b+8|0;l=i[e>>0]|0;k[b>>2]=k[c>>2];j=c+4|0;k[f>>2]=k[j>>2];m=c+8|0;i[e>>0]=i[m>>0]|0;k[c>>2]=g;k[j>>2]=h;i[m>>0]=l;if(!(Hh[k[d>>2]&511](b,a)|0)){d=1;return d|0}m=k[a>>2]|0;j=a+4|0;c=k[j>>2]|0;l=a+8|0;d=i[l>>0]|0;k[a>>2]=k[b>>2];k[j>>2]=k[f>>2];i[l>>0]=i[e>>0]|0;k[b>>2]=m;k[f>>2]=c;i[e>>0]=d;d=2;return d|0}h=k[a>>2]|0;g=a+4|0;j=k[g>>2]|0;l=a+8|0;m=i[l>>0]|0;if(e){k[a>>2]=k[c>>2];b=c+4|0;k[g>>2]=k[b>>2];d=c+8|0;i[l>>0]=i[d>>0]|0;k[c>>2]=h;k[b>>2]=j;i[d>>0]=m;d=1;return d|0}k[a>>2]=k[b>>2];f=b+4|0;k[g>>2]=k[f>>2];e=b+8|0;i[l>>0]=i[e>>0]|0;k[b>>2]=h;k[f>>2]=j;i[e>>0]=m;if(!(Hh[k[d>>2]&511](c,b)|0)){d=1;return d|0}j=k[b>>2]|0;l=k[f>>2]|0;m=i[e>>0]|0;k[b>>2]=k[c>>2];b=c+4|0;k[f>>2]=k[b>>2];d=c+8|0;i[e>>0]=i[d>>0]|0;k[c>>2]=j;k[b>>2]=l;i[d>>0]=m;d=2;return d|0}function Qoa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;h=Poa(a,b,c,e)|0;if(!(Hh[k[e>>2]&511](d,c)|0)){j=h;return j|0}o=k[c>>2]|0;j=c+4|0;n=k[j>>2]|0;g=c+8|0;l=i[g>>0]|0;k[c>>2]=k[d>>2];m=d+4|0;k[j>>2]=k[m>>2];f=d+8|0;i[g>>0]=i[f>>0]|0;k[d>>2]=o;k[m>>2]=n;i[f>>0]=l;if(!(Hh[k[e>>2]&511](c,b)|0)){o=h+1|0;return o|0}m=k[b>>2]|0;d=b+4|0;n=k[d>>2]|0;f=b+8|0;o=i[f>>0]|0;k[b>>2]=k[c>>2];k[d>>2]=k[j>>2];i[f>>0]=i[g>>0]|0;k[c>>2]=m;k[j>>2]=n;i[g>>0]=o;if(!(Hh[k[e>>2]&511](b,a)|0)){o=h+2|0;return o|0}m=k[a>>2]|0;j=a+4|0;n=k[j>>2]|0;l=a+8|0;o=i[l>>0]|0;k[a>>2]=k[b>>2];k[j>>2]=k[d>>2];i[l>>0]=i[f>>0]|0;k[b>>2]=m;k[d>>2]=n;i[f>>0]=o;o=h+3|0;return o|0}function Roa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;m=Qoa(a,b,c,d,f)|0;if(!(Hh[k[f>>2]&511](e,d)|0))return m|0;p=k[d>>2]|0;g=d+4|0;o=k[g>>2]|0;h=d+8|0;j=i[h>>0]|0;k[d>>2]=k[e>>2];n=e+4|0;k[g>>2]=k[n>>2];l=e+8|0;i[h>>0]=i[l>>0]|0;k[e>>2]=p;k[n>>2]=o;i[l>>0]=j;if(!(Hh[k[f>>2]&511](d,c)|0)){p=m+1|0;return p|0}n=k[c>>2]|0;j=c+4|0;o=k[j>>2]|0;l=c+8|0;p=i[l>>0]|0;k[c>>2]=k[d>>2];k[j>>2]=k[g>>2];i[l>>0]=i[h>>0]|0;k[d>>2]=n;k[g>>2]=o;i[h>>0]=p;if(!(Hh[k[f>>2]&511](c,b)|0)){p=m+2|0;return p|0}n=k[b>>2]|0;e=b+4|0;o=k[e>>2]|0;g=b+8|0;p=i[g>>0]|0;k[b>>2]=k[c>>2];k[e>>2]=k[j>>2];i[g>>0]=i[l>>0]|0;k[c>>2]=n;k[j>>2]=o;i[l>>0]=p;if(!(Hh[k[f>>2]&511](b,a)|0)){p=m+3|0;return p|0}n=k[a>>2]|0;c=a+4|0;o=k[c>>2]|0;f=a+8|0;p=i[f>>0]|0;k[a>>2]=k[b>>2];k[c>>2]=k[e>>2];i[f>>0]=i[g>>0]|0;k[b>>2]=n;k[e>>2]=o;i[g>>0]=p;p=m+4|0;return p|0}function Soa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;l=o;switch((b-a|0)/12|0|0){case 2:{d=b+-12|0;if(!(Hh[k[c>>2]&511](d,a)|0)){b=1;r=o;return b|0}m=k[a>>2]|0;j=a+4|0;n=k[j>>2]|0;l=a+8|0;c=i[l>>0]|0;k[a>>2]=k[d>>2];a=b+-8|0;k[j>>2]=k[a>>2];b=b+-4|0;i[l>>0]=i[b>>0]|0;k[d>>2]=m;k[a>>2]=n;i[b>>0]=c;b=1;r=o;return b|0}case 3:{Poa(a,a+12|0,b+-12|0,c)|0;b=1;r=o;return b|0}case 4:{Qoa(a,a+12|0,a+24|0,b+-12|0,c)|0;b=1;r=o;return b|0}case 5:{Roa(a,a+12|0,a+24|0,a+36|0,b+-12|0,c)|0;b=1;r=o;return b|0}case 1:case 0:{b=1;r=o;return b|0}default:{e=a+24|0;Poa(a,a+12|0,e,c)|0;d=a+36|0;a:do if((d|0)==(b|0)){e=1;d=0}else{m=l+4|0;n=l+8|0;f=0;while(1){if(Hh[k[c>>2]&511](d,e)|0){k[l>>2]=k[d>>2];k[m>>2]=k[d+4>>2];i[n>>0]=i[d+8>>0]|0;g=d;while(1){k[g>>2]=k[e>>2];h=e+4|0;k[g+4>>2]=k[h>>2];j=e+8|0;i[g+8>>0]=i[j>>0]|0;if((e|0)==(a|0))break;g=e+-12|0;if(Hh[k[c>>2]&511](l,g)|0){j=e;e=g;g=j}else break}k[e>>2]=k[l>>2];k[h>>2]=k[m>>2];i[j>>0]=i[n>>0]|0;e=f+1|0;g=d+12|0;if((e|0)==8){e=0;d=(g|0)==(b|0);break a}else{f=e;e=g}}else e=d+12|0;if((e|0)==(b|0)){e=1;d=0;break}else{j=d;d=e;e=j}}}while(0);b=d|e;r=o;return b|0}}return 0}function Toa(a){a=a|0;ggb(a);return}function Uoa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Voa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0;u=r;r=r+48|0;j=u+16|0;n=u+8|0;t=u;l=u+32|0;q=u+24|0;o[l>>2]=0.0;m=l+4|0;o[m>>2]=0.0;o[q>>2]=0.0;s=q+4|0;o[s>>2]=0.0;v=k[c>>2]|0;i=((f|0)==0?d:f)+-1|0;if(!(Xoa(c,d,f,a,v+(e<<3)|0,v+(((e|0)==0?d:e)+-1<<3)|0,v+(f<<3)|0,v+(i<<3)|0,l,q)|0)){v=0;r=u;return v|0}v=((f+1|0)>>>0)%(d>>>0)|0;e=k[c>>2]|0;Yoa(e+(f<<3)|0,e+(i<<3)|0,j,n,t);y=+p[j>>3];h=+o[l>>2];w=+p[n>>3];g=+o[m>>2];z=+p[t>>3];x=z+(y*h+w*g);w=z+(y*+o[e+(v<<3)>>2]+w*+o[e+(v<<3)+4>>2]);if(((x>0.0?1:(x<0.0)<<31>>31)|0)==((w>0.0?1:(w<0.0)<<31>>31)|0)){o[b>>2]=h;o[b+4>>2]=g;v=1;r=u;return v|0}else{k[b>>2]=k[q>>2];k[b+4>>2]=k[s>>2];v=1;r=u;return v|0}return 0}function Woa(a,b,c,d,e){a=+a;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;w=((b|0)==0?d:b)+-1|0;n=+o[c+(w<<3)>>2];p=+o[c+(w<<3)+4>>2];q=+o[c+(b<<3)>>2];r=+o[c+(b<<3)+4>>2];t=+Y(+(r-p),+(q-n))*180.0/3.141592653589793;t=t<0.0?t+360.0:t;b=((b+1|0)>>>0)%(d>>>0)|0;l=+o[c+(b<<3)>>2];m=+o[c+(b<<3)+4>>2];u=+Y(+(r-m),+(q-l))*180.0/3.141592653589793;u=u<0.0?u+360.0:u;d=((e|0)==0?d:e)+-1|0;i=+o[c+(d<<3)>>2];j=+o[c+(d<<3)+4>>2];k=+o[c+(e<<3)>>2];g=+o[c+(e<<3)+4>>2];h=+Y(+(g-j),+(k-i))*180.0/3.141592653589793;h=h<0.0?h+360.0:h;if(!(_oa(h,t,u)|0)){f=h+(h>180.0?-180.0:180.0);if(!(_oa(f,t,u)|0)){if(_oa(a,t,u)|0){w=1;return w|0}s=+P(+(a-t));f=+P(+a);t=+P(+t);f=f>1.0?f:1.0;if(s<=(f<t?t:f)*1.0e-05?(s=+P(+(a-h)),t=+P(+h),!(s<=(f<t?t:f)*1.0e-05)):0){w=1;return w|0}t=+P(+(a-u));u=+P(+u);if(t<=(f<u?u:f)*1.0e-05?(u=+P(+(a-h)),a=+P(+h),!(u<=(f<a?a:f)*1.0e-05)):0){w=1;return w|0}}else v=3}else{f=h;v=3}do if((v|0)==3){if(!(_oa(a,t,f)|0)?(h=+P(+(a-t)),s=+P(+a),t=+P(+t),s=s>1.0?s:1.0,!(h<=(s<t?t:s)*1.0e-05)):0){if(!(_oa(a,u,f)|0)?(t=+P(+(a-u)),a=+P(+u),!(t<=(s<a?a:s)*1.0e-05)):0)break;s=i-k;t=j-g;a=+Q(+(s*s+t*t));w=a!=0.0;u=+P(+(s*(g-m)-t*(k-l)))/a;a=+P(+(s*(g-r)-t*(k-q)))/a;w=(w?u:0.0)>(w?a:0.0)?2:1;return w|0}s=i-k;t=j-g;a=+Q(+(s*s+t*t));w=a!=0.0;u=+P(+(s*(g-p)-t*(k-n)))/a;a=+P(+(s*(g-r)-t*(k-q)))/a;w=(w?u:0.0)>(w?a:0.0)?2:1;return w|0}while(0);w=3;return w|0}function Xoa(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var l=0.0,m=0.0,n=0.0,q=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0;G=r;r=r+32|0;F=G+12|0;E=G;Zoa(F,e,f);Zoa(E,g,h);g=k[a>>2]|0;v=+o[g+(c<<3)>>2];l=+o[g+(c<<3)+4>>2];h=((c|0)==0?b:c)+-1|0;u=+o[g+(h<<3)>>2]-v;n=+o[g+(h<<3)+4>>2]-l;s=+Q(+(u*u+n*n));v=+P(+(u*(l-+o[g+(d<<3)+4>>2])-n*(v-+o[g+(d<<3)>>2])))/s;g=k[E>>2]|0;n=+p[g>>3];l=+p[g+8>>3];u=+Q(+(n*n+l*l));u=(s!=0.0?v*2.0:0.0)*u;h=k[F>>2]|0;v=+p[h>>3];s=+p[h+8>>3];t=+p[g+16>>3];q=-+p[h+16>>3];m=-t-u;z=v*l;A=s*n;B=z-A;C=+P(+B);do if(!(C<=(C>1.0?C:1.0)*1.0e-05)){D=l*q;l=s*m;o[i>>2]=(D-l)/B;y=v*m;w=n*q;x=y-w;b=i+4|0;o[b>>2]=x/B;m=u-t;q=s*m;o[j>>2]=(D-q)/B;m=v*m;n=m-w;a=j+4|0;o[a>>2]=n/B;B=+P(+z);A=+P(+A);B=B>1.0?B:1.0;if(!(C<=(B<A?A:B)*1.0e-05))d=1;else{B=+P(+(l-D));C=+P(+l);l=+P(+D);C=C>1.0?C:1.0;if(!(B<=(C<l?l:C)*1.0e-05?(A=+P(+x),C=+P(+y),B=+P(+w),C=C>1.0?C:1.0,A<=(C<B?B:C)*1.0e-05):0)){C=+P(+(q-D));D=+P(+q);D=D>1.0?D:1.0;if(!(C<=(D<l?l:D)*1.0e-05)){d=1;break}B=+P(+n);D=+P(+m);C=+P(+w);D=D>1.0?D:1.0;if(!(B<=(D<C?C:D)*1.0e-05)){d=1;break}}k[i>>2]=k[e>>2];k[b>>2]=k[e+4>>2];k[j>>2]=k[f>>2];k[a>>2]=k[f+4>>2];d=1}}else d=0;while(0);c=g;if(g|0){a=E+4|0;b=k[a>>2]|0;if((b|0)!=(g|0))k[a>>2]=b+(~((b+-8-c|0)>>>3)<<3);ggb(g)}if(!h){r=G;return d|0}a=F+4|0;b=k[a>>2]|0;if((b|0)!=(h|0))k[a>>2]=b+(~((b+-8-h|0)>>>3)<<3);ggb(h);r=G;return d|0}function Yoa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0.0,h=0.0,j=0.0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;w=r;r=r+16|0;u=w;f=+o[a>>2];t=a+4|0;j=+o[t>>2];g=+o[b>>2];v=b+4|0;h=+o[v>>2];z=+P(+(f-g));x=+P(+f);y=+P(+g);x=x>1.0?x:1.0;if(z<=(x<y?y:x)*1.0e-05?(x=+P(+(j-h)),z=+P(+j),y=+P(+h),z=z>1.0?z:1.0,x<=(z<y?y:z)*1.0e-05):0){l=u+4|0;m=ZT(36)|0;k[m>>2]=1;n=m+4|0;k[u>>2]=n;k[l>>2]=29;i[m+33>>0]=0;q=341091;s=n+29|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(s|0));Y8(-215,u,341121,340777,1440);k[l>>2]=0;k[u>>2]=0;u=k[m>>2]|0;k[m>>2]=u+-1;if((u|0)==1)ggb(k[m+-4>>2]|0);j=+o[t>>2];h=+o[v>>2];g=+o[b>>2];f=+o[a>>2]}p[c>>3]=h-j;z=f-g;p[d>>3]=z;p[e>>3]=z*-j-f*+p[c>>3];r=w;return}function Zoa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=r;r=r+32|0;i=h+16|0;e=h+8|0;f=h;k[a>>2]=0;g=a+4|0;k[g>>2]=0;k[a+8>>2]=0;Yoa(b,c,i,e,f);d=a+8|0;Koa(a,i);c=k[g>>2]|0;b=k[d>>2]|0;if((c|0)==(b|0)){Koa(a,e);c=k[g>>2]|0;b=k[d>>2]|0}else{p[c>>3]=+p[e>>3];c=c+8|0;k[g>>2]=c}if((c|0)==(b|0)){Koa(a,f);r=h;return}else{p[c>>3]=+p[f>>3];k[g>>2]=c+8;r=h;return}}function _oa(a,b,c){a=+a;b=+b;c=+c;var d=0.0,e=0;d=b-c;if(!(+P(+d)>180.0))if(((~~d|0)%180|0|0)>0){e=a<b&c<a;return e|0}else{e=b<a&a<c;return e|0}if(b>c){if(b<a){if(a<360.0){e=1;return e|0}b=+P(+(a+-360.0));d=+P(+a);d=d>1.0?d:1.0;if(b<=(d<360.0?360.0:d)*1.0e-05){e=1;return e|0}}if(!(a>0.0)?(b=+P(+(0.0-a)),d=+P(+a),!(b<=(d>1.0?d:1.0)*1.0e-05)):0){e=0;return e|0}e=a<c;return e|0}else{if(c<a){if(a<360.0){e=1;return e|0}c=+P(+(a+-360.0));d=+P(+a);d=d>1.0?d:1.0;if(c<=(d<360.0?360.0:d)*1.0e-05){e=1;return e|0}}if(!(a>0.0)?(c=+P(+(0.0-a)),d=+P(+a),!(c<=(d>1.0?d:1.0)*1.0e-05)):0){e=0;return e|0}e=a<b;return e|0}return 0}function $oa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0.0,h=0.0,j=0.0,l=0.0,m=0.0,n=0.0,q=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0;Ta=r;r=r+1344|0;Qa=Ta+256|0;Ia=Ta+312|0;Ja=Ta+248|0;Sa=Ta+192|0;Ka=Ta+136|0;La=Ta+8|0;Ma=Ta+120|0;Ea=Ta+104|0;Fa=Ta;Ga=Ta+88|0;E=S1(b,-1)|0;F=E&7;B=E&4088;R1(Ja,b,-1);if((k[Ja>>2]|0)>=1?(Ha=Ja+4|0,(k[Ha>>2]|0)>=1):0){do if((k[b>>2]&2031616|0)==65536){v=k[b+4>>2]|0;k[Sa>>2]=k[v>>2];A=Sa+4|0;b=v+4|0;k[A>>2]=k[b>>2];Ra=Sa+8|0;k[Ra>>2]=k[v+8>>2];k[Sa+12>>2]=k[v+12>>2];k[Sa+16>>2]=k[v+16>>2];k[Sa+20>>2]=k[v+20>>2];k[Sa+24>>2]=k[v+24>>2];k[Sa+28>>2]=k[v+28>>2];k[Sa+32>>2]=k[v+32>>2];d=k[v+36>>2]|0;k[Sa+36>>2]=d;e=Sa+40|0;k[e>>2]=Ra;Ra=Sa+48|0;y=Sa+44|0;k[y>>2]=Ra;k[Sa+52>>2]=0;k[Ra>>2]=0;if(d|0){Ra=d+12|0;k[Ra>>2]=(k[Ra>>2]|0)+1}if((k[b>>2]|0)<3){Pa=k[v+44>>2]|0;Ra=k[y>>2]|0;k[Ra>>2]=k[Pa>>2];k[Ra+4>>2]=k[Pa+4>>2];break}k[A>>2]=0;x1(Sa,k[b>>2]|0,0,0,0);if((k[A>>2]|0)>0){z=k[v+40>>2]|0;x=k[e>>2]|0;e=k[v+44>>2]|0;d=k[y>>2]|0;b=0;do{k[x+(b<<2)>>2]=k[z+(b<<2)>>2];k[d+(b<<2)>>2]=k[e+(b<<2)>>2];b=b+1|0}while((b|0)<(k[A>>2]|0))}}else Q1(Sa,b,-1);while(0);if((F|1|0)==5&(y2(Sa,2,-1,1)|0)>-1){zpb(a|0,0,192)|0;z=y2(Sa,2,-1,1)|0;Ra=k[Sa>>2]|0;e=(Ra&7|0)==5;B=Sa+16|0;A=k[B>>2]|0;if((Ra&6|0)!=4){k[Qa>>2]=0;b=Qa+4|0;k[b>>2]=0;d=ZT(60)|0;k[d>>2]=1;v=d+4|0;k[Qa>>2]=v;k[b>>2]=54;i[d+58>>0]=0;x=341152;y=v+54|0;do{i[v>>0]=i[x>>0]|0;v=v+1|0;x=x+1|0}while((v|0)<(y|0));Y8(-215,Qa,341207,341222,101);k[b>>2]=0;k[Qa>>2]=0;Ra=k[d>>2]|0;k[d>>2]=Ra+-1;if((Ra|0)==1)ggb(k[d+-4>>2]|0)}if(z|0){b=z+-1|0;if(e){u=+o[A+(b<<3)+4>>2];D=+o[A+(b<<3)>>2]}else{u=+(k[A+(b<<3)+4>>2]|0);D=+(k[A+(b<<3)>>2]|0)}g=D*D;f=u*u;if((z|0)>0)if(e){b=0;s=0.0;t=0.0;q=0.0;n=0.0;w=0.0;C=0.0;l=0.0;j=0.0;m=0.0;h=0.0;do{K=D;D=+o[A+(b<<3)>>2];M=u;u=+o[A+(b<<3)+4>>2];G=g;g=D*D;J=f;f=u*u;I=K*u-M*D;L=K+D;H=M+u;s=s+I;Va=L*I;t=t+Va;Ua=H*I;q=q+Ua;n=n+I*(g+K*L);h=h+I*(K*(M+H)+D*(u+H));m=m+I*(f+M*H);j=j+(G+g)*Va;w=w+(J+f)*Ua;l=l+I*(G*(M*3.0+u)+K*(D*2.0)*H+g*(M+u*3.0));C=C+I*(f*(K+D*3.0)+(J*(K*3.0+D)+L*(M*(u*2.0))));b=b+1|0}while((b|0)!=(z|0));D=w;g=m;f=h}else{b=0;s=0.0;t=0.0;q=0.0;n=0.0;w=0.0;C=0.0;l=0.0;j=0.0;m=0.0;h=0.0;do{M=D;D=+(k[A+(b<<3)>>2]|0);Va=u;u=+(k[A+(b<<3)+4>>2]|0);I=g;g=D*D;L=f;f=u*u;K=M*u-Va*D;Ua=M+D;J=Va+u;s=s+K;G=Ua*K;t=t+G;H=J*K;q=q+H;n=n+K*(g+M*Ua);h=h+K*(M*(Va+J)+D*(u+J));m=m+K*(f+Va*J);j=j+(I+g)*G;w=w+(L+f)*H;l=l+K*(I*(Va*3.0+u)+M*(D*2.0)*J+g*(Va+u*3.0));C=C+K*(f*(M+D*3.0)+(L*(M*3.0+D)+Ua*(Va*(u*2.0))));b=b+1|0}while((b|0)!=(z|0));D=w;g=m;f=h}else{s=0.0;t=0.0;q=0.0;n=0.0;D=0.0;C=0.0;l=0.0;j=0.0;g=0.0;f=0.0}if(+P(+s)>1.1920928955078125e-07){Ra=s>0.0;u=Ra?.16666666666666666:-.16666666666666666;m=Ra?.08333333333333333:-.08333333333333333;Va=Ra?.05:-.05;Ua=Ra?.016666666666666666:-.016666666666666666;h=s*(Ra?.5:-.5);p[a>>3]=h;w=t*u;p[a+8>>3]=w;u=q*u;p[a+16>>3]=u;t=n*m;p[a+24>>3]=t;s=f*(Ra?.041666666666666664:-.041666666666666664);p[a+32>>3]=s;q=g*m;p[a+40>>3]=q;n=j*Va;p[a+48>>3]=n;m=l*Ua;p[a+56>>3]=m;l=C*Ua;p[a+64>>3]=l;j=D*Va;p[a+72>>3]=j;if(+P(+h)>2.220446049250313e-16){h=1.0/h;f=h*w;g=h*u}else{f=0.0;g=0.0;h=0.0}K=w*f;G=t-K;I=w*g;H=s-I;Ua=u*g;J=q-Ua;p[a+80>>3]=G;p[a+88>>3]=H;p[a+96>>3]=J;K=n-f*(K+G*3.0);p[a+104>>3]=K;M=H+H;L=m-f*(u*f+M)-g*G;p[a+112>>3]=L;M=l-g*(I+M)-f*J;p[a+120>>3]=M;Ua=j-g*(Ua+J*3.0);p[a+128>>3]=Ua;I=h*h;Va=I*+Q(+(+P(+h)));p[a+136>>3]=I*G;p[a+144>>3]=I*H;p[a+152>>3]=I*J;p[a+160>>3]=K*Va;p[a+168>>3]=L*Va;p[a+176>>3]=M*Va;p[a+184>>3]=Ua*Va}}e=Sa+36|0;b=k[e>>2]|0;if(b|0?(Ra=b+12|0,a=k[Ra>>2]|0,k[Ra>>2]=a+-1,(a|0)==1):0){d=k[e>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[Sa+32>>2]|0;if(!b){b=B1()|0;d=k[e>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[e>>2]=0}k[e>>2]=0;e=Sa+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[e>>2]|0)>0){d=k[Sa+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[Sa+44>>2]|0;if(!((b|0)==(Sa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);r=Ta;return}if(B|0){k[Qa>>2]=0;b=Qa+4|0;k[b>>2]=0;d=ZT(48)|0;k[d>>2]=1;v=d+4|0;k[Qa>>2]=v;k[b>>2]=43;i[d+47>>0]=0;x=341291;y=v+43|0;do{i[v>>0]=i[x>>0]|0;v=v+1|0;x=x+1|0}while((v|0)<(y|0));Y8(-5,Qa,341335,341222,578);k[b>>2]=0;k[Qa>>2]=0;Ra=k[d>>2]|0;k[d>>2]=Ra+-1;if((Ra|0)==1)ggb(k[d+-4>>2]|0)}a:do if((F|0)==0|c)wa=813;else switch(E&7){case 2:{wa=814;break a}case 3:{wa=815;break a}case 5:{wa=816;break a}case 6:{wa=817;break a}default:{k[Qa>>2]=0;Ra=Qa+4|0;k[Ra>>2]=0;b=ZT(8)|0;k[b>>2]=1;Pa=b+4|0;k[Qa>>2]=Pa;k[Ra>>2]=0;i[Pa>>0]=0;Y8(-210,Qa,341335,341222,657);k[Ra>>2]=0;k[Qa>>2]=0;Ra=k[b>>2]|0;k[b>>2]=Ra+-1;if((Ra|0)==1)ggb(k[b+-4>>2]|0);wa=0;break a}}while(0);k[Qa>>2]=k[Sa>>2];Ba=Qa+4|0;Ra=Sa+4|0;b=k[Ra>>2]|0;k[Ba>>2]=b;Da=Qa+8|0;k[Da>>2]=k[Sa+8>>2];k[Qa+12>>2]=k[Sa+12>>2];ya=Qa+16|0;Oa=Sa+16|0;k[ya>>2]=k[Oa>>2];k[Qa+20>>2]=k[Sa+20>>2];k[Qa+24>>2]=k[Sa+24>>2];k[Qa+28>>2]=k[Sa+28>>2];xa=Qa+32|0;Na=Sa+32|0;k[xa>>2]=k[Na>>2];za=Qa+36|0;Pa=Sa+36|0;d=k[Pa>>2]|0;k[za>>2]=d;Aa=Qa+40|0;k[Aa>>2]=Da;Da=Qa+48|0;Ca=Qa+44|0;k[Ca>>2]=Da;k[Qa+52>>2]=0;k[Da>>2]=0;if(d){b=d+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[Ra>>2]|0}if((b|0)>=3){k[Ba>>2]=0;x1(Qa,b,0,0,0);if((k[Ba>>2]|0)>0){d=k[Sa+40>>2]|0;e=k[Aa>>2]|0;v=k[Sa+44>>2]|0;x=k[Ca>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[d+(b<<2)>>2];k[x+(b<<2)>>2]=k[v+(b<<2)>>2];b=b+1|0}while((b|0)<(k[Ba>>2]|0))}}else{ua=k[Sa+44>>2]|0;va=k[Ca>>2]|0;k[va>>2]=k[ua>>2];k[va+4>>2]=k[ua+4>>2]}b=k[Ha>>2]|0;if((b|0)>0){y=La+4|0;z=La+8|0;A=La+12|0;B=La+4|0;E=La+8|0;F=La+12|0;N=La+16|0;O=La+20|0;R=La+24|0;S=La+28|0;T=La+40|0;U=La+48|0;V=La+44|0;W=La+52|0;X=Ma+8|0;Y=Ma+12|0;Z=Ma+4|0;_=Ea+8|0;$=Ea+12|0;ba=Ea+4|0;ca=Ga+4|0;da=ca+4|0;ea=La+36|0;fa=La+8|0;ga=La+16|0;ha=La+24|0;ia=La+32|0;ja=La+40|0;ka=La+48|0;la=La+56|0;ma=La+64|0;na=La+72|0;oa=Ka+36|0;pa=Ka+16|0;qa=Ka+4|0;ra=Ka+40|0;sa=Ka+44|0;ta=Ka+48|0;ua=La+32|0;va=Ka+32|0;x=0;C=0.0;w=0.0;u=0.0;t=0.0;s=0.0;q=0.0;n=0.0;m=0.0;l=0.0;j=0.0;d=k[Ja>>2]|0;do{v=b-x|0;v=(v|0)<32?v:32;if((d|0)>0){M=+(x|0);e=0;do{b=d-e|0;b=(b|0)<32?b:32;k[La>>2]=e;k[y>>2]=x;k[z>>2]=b;k[A>>2]=v;I1(Ka,Qa,La);if(c){k[B>>2]=2;k[E>>2]=v;k[F>>2]=b;k[N>>2]=Ia;k[O>>2]=Ia;d=R+8|0;k[d>>2]=0;k[d+4>>2]=0;k[T>>2]=E;k[V>>2]=U;k[La>>2]=1124024320;k[U>>2]=b;k[W>>2]=1;d=Ia+(aa(v,b)|0)|0;k[S>>2]=d;k[R>>2]=d+(0-b)+b;k[X>>2]=0;k[Y>>2]=0;k[Ma>>2]=16842752;k[Z>>2]=Ka;p[Fa>>3]=0.0;k[Ea>>2]=-1056833530;k[ba>>2]=Fa;k[_>>2]=1;k[$>>2]=1;b=da;k[b>>2]=0;k[b+4>>2]=0;k[Ga>>2]=33619968;k[ca>>2]=La;oV(Ma,Ea,Ga,5);KG(Ka,La)|0;b=k[ea>>2]|0;if(b|0?(b=b+12|0,d=k[b>>2]|0,k[b>>2]=d+-1,(d|0)==1):0){d=k[ea>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[ua>>2]|0;if(b|0)break;b=B1()|0;d=k[ea>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[ea>>2]=0}k[ea>>2]=0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[B>>2]|0)>0){d=k[T>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[B>>2]|0))}b=k[V>>2]|0;if(!((b|0)==(U|0)|(b|0)==0))ggb(k[b+-4>>2]|0)}jh[wa&1023](Ka,La);f=+p[La>>3];if(c){f=f*.00392156862745098;p[La>>3]=f;g=+p[fa>>3]*.00392156862745098;p[fa>>3]=g;h=+p[ga>>3]*.00392156862745098;p[ga>>3]=h;D=+p[ha>>3]*.00392156862745098;p[ha>>3]=D;G=+p[ia>>3]*.00392156862745098;p[ia>>3]=G;H=+p[ja>>3]*.00392156862745098;p[ja>>3]=H;I=+p[ka>>3]*.00392156862745098;p[ka>>3]=I;J=+p[la>>3]*.00392156862745098;p[la>>3]=J;K=+p[ma>>3]*.00392156862745098;p[ma>>3]=K;L=+p[na>>3]*.00392156862745098;p[na>>3]=L}else{g=+p[fa>>3];h=+p[ga>>3];D=+p[ha>>3];G=+p[ia>>3];H=+p[ja>>3];I=+p[ka>>3];J=+p[la>>3];K=+p[ma>>3];L=+p[na>>3]}Ua=+(e|0);Ya=Ua*f;Va=M*f;C=C+f;f=g+Ya;j=j+f;Xa=Va+h;w=w+Xa;u=u+(D+Ua*(Ya+g*2.0));Xa=Ua*Xa;Wa=M*g;t=t+(Wa+(G+Xa));s=s+(H+M*(Va+h*2.0));q=q+(I+Ua*(D*3.0+Ua*(Ya+g*3.0)));n=n+(M*D+(J+Ua*(Xa+(Wa+G)*2.0)));m=m+(Ua*H+(K+M*(M*f+(Ua*h+G)*2.0)));l=l+(M*(M*(Va+h*3.0)+H*3.0)+L);b=k[oa>>2]|0;if(b|0?(b=b+12|0,d=k[b>>2]|0,k[b>>2]=d+-1,(d|0)==1):0){d=k[oa>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[va>>2]|0;if(b|0)break;b=B1()|0;d=k[oa>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[oa>>2]=0}k[oa>>2]=0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[qa>>2]|0)>0){d=k[ra>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[qa>>2]|0))}b=k[sa>>2]|0;if(!((b|0)==(ta|0)|(b|0)==0))ggb(k[b+-4>>2]|0);e=e+32|0;d=k[Ja>>2]|0}while((d|0)>(e|0));b=k[Ha>>2]|0}x=x+32|0}while((b|0)>(x|0))}else{C=0.0;w=0.0;u=0.0;t=0.0;s=0.0;q=0.0;n=0.0;m=0.0;l=0.0;j=0.0}b=k[za>>2]|0;if(b|0?(Ma=b+12|0,Qa=k[Ma>>2]|0,k[Ma>>2]=Qa+-1,(Qa|0)==1):0){d=k[za>>2]|0;if(d|0){b=k[d+4>>2]|0;if(!b){b=k[xa>>2]|0;if(!b){b=B1()|0;d=k[za>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[za>>2]=0}k[za>>2]=0;k[ya>>2]=0;k[ya+4>>2]=0;k[ya+8>>2]=0;k[ya+12>>2]=0;if((k[Ba>>2]|0)>0){d=k[Aa>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ba>>2]|0))}b=k[Ca>>2]|0;if(!((b|0)==(Da|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[Pa>>2]|0;if(b|0?(Ma=b+12|0,Qa=k[Ma>>2]|0,k[Ma>>2]=Qa+-1,(Qa|0)==1):0){d=k[Pa>>2]|0;if(d|0){b=k[d+4>>2]|0;do if(!b){b=k[Na>>2]|0;if(b|0)break;b=B1()|0;d=k[Pa>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,d)}k[Pa>>2]=0}k[Pa>>2]=0;k[Oa>>2]=0;k[Oa+4>>2]=0;k[Oa+8>>2]=0;k[Oa+12>>2]=0;if((k[Ra>>2]|0)>0){d=k[Sa+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[Ra>>2]|0))}b=k[Sa+44>>2]|0;if(!((b|0)==(Sa+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);if(+P(+C)>2.220446049250313e-16){h=1.0/C;f=j*h;g=w*h}else{f=0.0;g=0.0;h=0.0}Ua=j*f;J=u-Ua;L=j*g;K=t-L;Ya=w*g;M=s-Ya;Ua=q-f*(Ua+J*3.0);Wa=K+K;Va=n-f*(w*f+Wa)-g*J;Wa=m-g*(L+Wa)-f*M;Ya=l-g*(Ya+M*3.0);L=h*h;Xa=L*+Q(+(+P(+h)));p[a>>3]=C;p[a+8>>3]=j;p[a+16>>3]=w;p[a+24>>3]=u;p[a+32>>3]=t;p[a+40>>3]=s;p[a+48>>3]=q;p[a+56>>3]=n;p[a+64>>3]=m;p[a+72>>3]=l;p[a+80>>3]=J;p[a+88>>3]=K;p[a+96>>3]=M;p[a+104>>3]=Ua;p[a+112>>3]=Va;p[a+120>>3]=Wa;p[a+128>>3]=Ya;p[a+136>>3]=L*J;p[a+144>>3]=L*K;p[a+152>>3]=L*M;p[a+160>>3]=Xa*Ua;p[a+168>>3]=Xa*Va;p[a+176>>3]=Xa*Wa;p[a+184>>3]=Xa*Ya;r=Ta;return}zpb(a|0,0,192)|0;r=Ta;return}function apa(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,l=0.0,m=0.0,n=0.0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;C=k[a+40>>2]|0;A=k[C+4>>2]|0;C=k[C>>2]|0;if((C|0)>0?(B=k[a+16>>2]|0,D=k[k[a+44>>2]>>2]|0,(A|0)>0):0){a=0;P=0;Q=0;M=0;O=0;K=0;L=0;I=0;J=0;G=0;H=0;E=0;F=0;y=0;z=0;t=0;u=0;T=0;U=0;R=0;S=0;do{v=B+(aa(D,a)|0)|0;o=0;q=0;r=0;s=0;w=0;x=0;do{W=j[v+(s<<1)>>1]|0;V=aa(W,s)|0;r=W+r|0;q=V+q|0;V=aa(V,s)|0;o=V+o|0;V=aa(V,s)|0;w=kpb(V|0,((V|0)<0)<<31>>31|0,w|0,x|0)|0;x=N;s=s+1|0}while((s|0)!=(A|0));v=aa(r,a)|0;X=aa(a,a)|0;V=((v|0)<0)<<31>>31;W=Epb(v|0,V|0,X|0,0)|0;T=kpb(T|0,U|0,W|0,N|0)|0;U=N;W=((q|0)<0)<<31>>31;s=Epb(q|0,W|0,X|0,0)|0;R=kpb(R|0,S|0,s|0,N|0)|0;S=N;s=((o|0)<0)<<31>>31;Y=Epb(o|0,s|0,a|0,((a|0)<0)<<31>>31|0)|0;P=kpb(P|0,Q|0,Y|0,N|0)|0;Q=N;M=kpb(M|0,O|0,w|0,x|0)|0;O=N;x=aa(r,X)|0;K=kpb(K|0,L|0,x|0,((x|0)<0)<<31>>31|0)|0;L=N;x=aa(q,a)|0;I=kpb(I|0,J|0,x|0,((x|0)<0)<<31>>31|0)|0;J=N;G=kpb(G|0,H|0,o|0,s|0)|0;H=N;E=kpb(E|0,F|0,v|0,V|0)|0;F=N;y=kpb(y|0,z|0,q|0,W|0)|0;z=N;t=kpb(t|0,u|0,r|0,((r|0)<0)<<31>>31|0)|0;u=N;a=a+1|0}while((a|0)!=(C|0));n=+(t>>>0)+4294967296.0*+(u|0);m=+(y>>>0)+4294967296.0*+(z|0);l=+(E>>>0)+4294967296.0*+(F|0);i=+(G>>>0)+4294967296.0*+(H|0);h=+(I>>>0)+4294967296.0*+(J|0);g=+(K>>>0)+4294967296.0*+(L|0);f=+(M>>>0)+4294967296.0*+(O|0);e=+(P>>>0)+4294967296.0*+(Q|0);d=+(R>>>0)+4294967296.0*+(S|0);c=+(T>>>0)+4294967296.0*+(U|0)}else{n=0.0;m=0.0;l=0.0;i=0.0;h=0.0;g=0.0;f=0.0;e=0.0;d=0.0;c=0.0}p[b>>3]=n;p[b+8>>3]=m;p[b+16>>3]=l;p[b+24>>3]=i;p[b+32>>3]=h;p[b+40>>3]=g;p[b+48>>3]=f;p[b+56>>3]=e;p[b+64>>3]=d;p[b+72>>3]=c;return}function bpa(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,l=0,m=0.0,n=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0;y=k[a+40>>2]|0;w=k[y+4>>2]|0;y=k[y>>2]|0;a:do if((y|0)>0){x=k[a+16>>2]|0;v=k[k[a+44>>2]>>2]|0;if((w|0)>0){u=0;e=0.0;f=0.0;g=0.0;t=0.0;c=0.0;d=0.0;i=0.0;h=0.0;j=0.0;n=0.0}else{a=0;e=0.0;f=0.0;g=0.0;c=0.0;d=0.0;h=0.0;while(1){t=+(a|0)*0.0;s=+(aa(a,a)|0);e=s*t+e;s=s*0.0;f=s+f;g=t+g;c=s+c;d=t+d;h=t+h;a=a+1|0;if((a|0)==(y|0)){n=0.0;m=0.0;j=0.0;i=0.0;break a}}}while(1){l=x+(aa(v,u)|0)|0;m=0.0;q=0.0;r=0.0;s=0.0;a=0;do{B=+o[l+(a<<2)>>2];A=+(a|0);z=A*B;s=s+B;r=r+z;z=A*z;q=q+z;m=m+A*z;a=a+1|0}while((a|0)!=(w|0));A=+(u|0);B=A*s;z=+(aa(u,u)|0);e=z*B+e;f=z*r+f;g=A*q+g;m=m+t;c=z*s+c;d=A*r+d;i=q+i;h=B+h;j=r+j;n=s+n;u=u+1|0;if((u|0)==(y|0))break;else t=m}}else{n=0.0;m=0.0;g=0.0;f=0.0;e=0.0;j=0.0;h=0.0;i=0.0;d=0.0;c=0.0}while(0);p[b>>3]=n;p[b+8>>3]=j;p[b+16>>3]=h;p[b+24>>3]=i;p[b+32>>3]=d;p[b+40>>3]=c;p[b+48>>3]=m;p[b+56>>3]=g;p[b+64>>3]=f;p[b+72>>3]=e;return}function cpa(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;x=k[a+40>>2]|0;v=k[x+4>>2]|0;x=k[x>>2]|0;a:do if((x|0)>0){w=k[a+16>>2]|0;u=k[k[a+44>>2]>>2]|0;if((v|0)>0){t=0;e=0.0;f=0.0;g=0.0;s=0.0;c=0.0;d=0.0;i=0.0;h=0.0;j=0.0;n=0.0}else{a=0;e=0.0;f=0.0;g=0.0;c=0.0;d=0.0;h=0.0;while(1){s=+(a|0)*0.0;r=+(aa(a,a)|0);e=r*s+e;r=r*0.0;f=r+f;g=s+g;c=r+c;d=s+d;h=s+h;a=a+1|0;if((a|0)==(x|0)){n=0.0;m=0.0;j=0.0;i=0.0;break a}}}while(1){l=w+(aa(u,t)|0)|0;m=0.0;o=0.0;q=0.0;r=0.0;a=0;do{A=+p[l+(a<<3)>>3];z=+(a|0);y=z*A;r=r+A;q=q+y;y=z*y;o=o+y;m=m+z*y;a=a+1|0}while((a|0)!=(v|0));z=+(t|0);A=z*r;y=+(aa(t,t)|0);e=y*A+e;f=y*q+f;g=z*o+g;m=m+s;c=y*r+c;d=z*q+d;i=o+i;h=A+h;j=q+j;n=r+n;t=t+1|0;if((t|0)==(x|0))break;else s=m}}else{n=0.0;m=0.0;g=0.0;f=0.0;e=0.0;j=0.0;h=0.0;i=0.0;d=0.0;c=0.0}while(0);p[b>>3]=n;p[b+8>>3]=j;p[b+16>>3]=h;p[b+24>>3]=i;p[b+32>>3]=d;p[b+40>>3]=c;p[b+48>>3]=m;p[b+56>>3]=g;p[b+64>>3]=f;p[b+72>>3]=e;return}function dpa(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,m=0.0,n=0.0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;z=k[a+40>>2]|0;y=k[z+4>>2]|0;z=k[z>>2]|0;if((z|0)>0?(w=k[a+16>>2]|0,x=k[k[a+44>>2]>>2]|0,(y|0)>0):0){a=0;I=0;H=0;G=0;F=0;E=0;D=0;C=0;B=0;A=0;v=0;do{u=w+(aa(x,a)|0)|0;o=0;q=0;r=0;s=0;t=0;do{K=l[u+t>>0]|0;J=aa(K,t)|0;s=K+s|0;r=J+r|0;J=aa(J,t)|0;q=J+q|0;o=(aa(J,t)|0)+o|0;t=t+1|0}while((t|0)!=(y|0));K=aa(s,a)|0;J=aa(a,a)|0;I=I+(aa(K,J)|0)|0;H=H+(aa(r,J)|0)|0;G=G+(aa(q,a)|0)|0;F=F+o|0;E=E+(aa(s,J)|0)|0;D=D+(aa(r,a)|0)|0;C=C+q|0;B=B+K|0;A=A+r|0;v=v+s|0;a=a+1|0}while((a|0)!=(z|0));n=+(v|0);m=+(A|0);j=+(B|0);i=+(C|0);h=+(D|0);g=+(E|0);f=+(F|0);e=+(G|0);d=+(H|0);c=+(I|0)}else{n=0.0;m=0.0;j=0.0;i=0.0;h=0.0;g=0.0;f=0.0;e=0.0;d=0.0;c=0.0}p[b>>3]=n;p[b+8>>3]=m;p[b+16>>3]=j;p[b+24>>3]=i;p[b+32>>3]=h;p[b+40>>3]=g;p[b+48>>3]=f;p[b+56>>3]=e;p[b+64>>3]=d;p[b+72>>3]=c;return}function epa(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,l=0.0,n=0.0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;C=k[a+40>>2]|0;A=k[C+4>>2]|0;C=k[C>>2]|0;if((C|0)>0?(B=k[a+16>>2]|0,D=k[k[a+44>>2]>>2]|0,(A|0)>0):0){a=0;P=0;Q=0;M=0;O=0;K=0;L=0;I=0;J=0;G=0;H=0;E=0;F=0;y=0;z=0;t=0;u=0;T=0;U=0;R=0;S=0;do{v=B+(aa(D,a)|0)|0;o=0;q=0;r=0;s=0;w=0;x=0;do{W=m[v+(s<<1)>>1]|0;V=aa(W,s)|0;r=W+r|0;q=V+q|0;V=aa(V,s)|0;o=V+o|0;V=aa(V,s)|0;w=kpb(V|0,((V|0)<0)<<31>>31|0,w|0,x|0)|0;x=N;s=s+1|0}while((s|0)!=(A|0));v=aa(r,a)|0;X=aa(a,a)|0;V=((v|0)<0)<<31>>31;W=Epb(v|0,V|0,X|0,0)|0;T=kpb(T|0,U|0,W|0,N|0)|0;U=N;W=((q|0)<0)<<31>>31;s=Epb(q|0,W|0,X|0,0)|0;R=kpb(R|0,S|0,s|0,N|0)|0;S=N;s=((o|0)<0)<<31>>31;Y=Epb(o|0,s|0,a|0,((a|0)<0)<<31>>31|0)|0;P=kpb(P|0,Q|0,Y|0,N|0)|0;Q=N;M=kpb(M|0,O|0,w|0,x|0)|0;O=N;x=aa(r,X)|0;K=kpb(K|0,L|0,x|0,((x|0)<0)<<31>>31|0)|0;L=N;x=aa(q,a)|0;I=kpb(I|0,J|0,x|0,((x|0)<0)<<31>>31|0)|0;J=N;G=kpb(G|0,H|0,o|0,s|0)|0;H=N;E=kpb(E|0,F|0,v|0,V|0)|0;F=N;y=kpb(y|0,z|0,q|0,W|0)|0;z=N;t=kpb(t|0,u|0,r|0,((r|0)<0)<<31>>31|0)|0;u=N;a=a+1|0}while((a|0)!=(C|0));n=+(t>>>0)+4294967296.0*+(u|0);l=+(y>>>0)+4294967296.0*+(z|0);j=+(E>>>0)+4294967296.0*+(F|0);i=+(G>>>0)+4294967296.0*+(H|0);h=+(I>>>0)+4294967296.0*+(J|0);g=+(K>>>0)+4294967296.0*+(L|0);f=+(M>>>0)+4294967296.0*+(O|0);e=+(P>>>0)+4294967296.0*+(Q|0);d=+(R>>>0)+4294967296.0*+(S|0);c=+(T>>>0)+4294967296.0*+(U|0)}else{n=0.0;l=0.0;j=0.0;i=0.0;h=0.0;g=0.0;f=0.0;e=0.0;d=0.0;c=0.0}p[b>>3]=n;p[b+8>>3]=l;p[b+16>>3]=j;p[b+24>>3]=i;p[b+32>>3]=h;p[b+40>>3]=g;p[b+48>>3]=f;p[b+56>>3]=e;p[b+64>>3]=d;p[b+72>>3]=c;return}function fpa(a){a=a|0;ggb(a);return}function gpa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function hpa(a){a=a|0;ggb(a);return}function ipa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,r=0.0;o=aa(k[a+4>>2]|0,e)|0;q=aa(e,d)|0;if((o|0)==(e|0)){if((q|0)>0)a=0;else return;do{p[c+(a<<3)>>3]=+p[b+(a<<3)>>3];a=a+1|0}while((a|0)!=(q|0));return}if((e|0)<=0)return;i=e<<1;j=q-i|0;l=(j|0)<0;m=(o|0)>(e|0);n=(i|0)<(o|0);h=0;while(1){a:do if(l)a=0;else{if(n)a=0;else{a=0;while(1){g=b+(a<<3)|0;f=+p[g+(e<<3)>>3];r=+p[g>>3];p[c+(a<<3)>>3]=f<r?r:f;r=+p[g+(i<<3)>>3];p[c+(a+e<<3)>>3]=f<r?r:f;a=a+i|0;if((a|0)>(j|0))break a}}do{g=b+(a<<3)|0;f=+p[g+(e<<3)>>3];d=i;do{r=+p[g+(d<<3)>>3];f=f<r?r:f;d=d+e|0}while((d|0)<(o|0));r=+p[g>>3];p[c+(a<<3)>>3]=f<r?r:f;r=+p[g+(d<<3)>>3];p[c+(a+e<<3)>>3]=f<r?r:f;a=a+i|0}while((a|0)<=(j|0))}while(0);b:do if((a|0)<(q|0)){if(!m)while(1){p[c+(a<<3)>>3]=+p[b+(a<<3)>>3];a=a+e|0;if((a|0)>=(q|0))break b}do{g=b+(a<<3)|0;f=+p[g>>3];d=e;do{r=+p[g+(d<<3)>>3];f=f<r?r:f;d=d+e|0}while((d|0)<(o|0));p[c+(a<<3)>>3]=f;a=a+e|0}while((a|0)<(q|0))}while(0);h=h+1|0;if((h|0)==(e|0))break;else{c=c+8|0;b=b+8|0}}return}function jpa(a){a=a|0;ggb(a);return}function kpa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function lpa(a){a=a|0;ggb(a);return}function mpa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0.0;p=aa(k[a+4>>2]|0,e)|0;q=aa(e,d)|0;if((p|0)==(e|0)){if((q|0)>0)a=0;else return;do{k[c+(a<<2)>>2]=k[b+(a<<2)>>2];a=a+1|0}while((a|0)!=(q|0));return}if((e|0)<=0)return;i=e<<1;j=q-i|0;l=(j|0)<0;m=(p|0)>(e|0);n=(i|0)<(p|0);h=0;while(1){a:do if(l)a=0;else{if(n)a=0;else{a=0;while(1){g=b+(a<<2)|0;f=+o[g+(e<<2)>>2];r=+o[g>>2];o[c+(a<<2)>>2]=f<r?r:f;r=+o[g+(i<<2)>>2];o[c+(a+e<<2)>>2]=f<r?r:f;a=a+i|0;if((a|0)>(j|0))break a}}do{g=b+(a<<2)|0;f=+o[g+(e<<2)>>2];d=i;do{r=+o[g+(d<<2)>>2];f=f<r?r:f;d=d+e|0}while((d|0)<(p|0));r=+o[g>>2];o[c+(a<<2)>>2]=f<r?r:f;r=+o[g+(d<<2)>>2];o[c+(a+e<<2)>>2]=f<r?r:f;a=a+i|0}while((a|0)<=(j|0))}while(0);b:do if((a|0)<(q|0)){if(!m)while(1){k[c+(a<<2)>>2]=k[b+(a<<2)>>2];a=a+e|0;if((a|0)>=(q|0))break b}do{g=b+(a<<2)|0;f=+o[g>>2];d=e;do{r=+o[g+(d<<2)>>2];f=f<r?r:f;d=d+e|0}while((d|0)<(p|0));o[c+(a<<2)>>2]=f;a=a+e|0}while((a|0)<(q|0))}while(0);h=h+1|0;if((h|0)==(e|0))break;else{c=c+4|0;b=b+4|0}}return}function npa(a){a=a|0;ggb(a);return}function opa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function ppa(a){a=a|0;ggb(a);return}function qpa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;p=aa(k[a+4>>2]|0,e)|0;q=aa(e,d)|0;if((p|0)==(e|0)){if((q|0)>0)a=0;else return;do{j[c+(a<<1)>>1]=j[b+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(q|0));return}if((e|0)<=0)return;i=e<<1;l=q-i|0;m=(l|0)<0;n=(p|0)>(e|0);o=(i|0)<(p|0);h=0;while(1){a:do if(m)a=0;else{if(o)a=0;else{a=0;while(1){f=b+(a<<1)|0;g=j[f+(e<<1)>>1]|0;d=j[f>>1]|0;j[c+(a<<1)>>1]=g<<16>>16<d<<16>>16?d:g;f=j[f+(i<<1)>>1]|0;j[c+(a+e<<1)>>1]=g<<16>>16<f<<16>>16?f:g;a=a+i|0;if((a|0)>(l|0))break a}}do{g=b+(a<<1)|0;d=j[g+(e<<1)>>1]|0;f=i;do{r=j[g+(f<<1)>>1]|0;d=d<<16>>16<r<<16>>16?r:d;f=f+e|0}while((f|0)<(p|0));r=j[g>>1]|0;j[c+(a<<1)>>1]=d<<16>>16<r<<16>>16?r:d;r=j[g+(f<<1)>>1]|0;j[c+(a+e<<1)>>1]=d<<16>>16<r<<16>>16?r:d;a=a+i|0}while((a|0)<=(l|0))}while(0);b:do if((a|0)<(q|0)){if(!n)while(1){j[c+(a<<1)>>1]=j[b+(a<<1)>>1]|0;a=a+e|0;if((a|0)>=(q|0))break b}do{g=b+(a<<1)|0;d=j[g>>1]|0;f=e;do{r=j[g+(f<<1)>>1]|0;d=d<<16>>16<r<<16>>16?r:d;f=f+e|0}while((f|0)<(p|0));j[c+(a<<1)>>1]=d;a=a+e|0}while((a|0)<(q|0))}while(0);h=h+1|0;if((h|0)==(e|0))break;else{c=c+2|0;b=b+2|0}}return}function rpa(a){a=a|0;ggb(a);return}function spa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function tpa(a){a=a|0;ggb(a);return}function upa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;p=aa(k[a+4>>2]|0,e)|0;q=aa(e,d)|0;if((p|0)==(e|0)){if((q|0)>0)a=0;else return;do{j[c+(a<<1)>>1]=j[b+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(q|0));return}if((e|0)<=0)return;i=e<<1;l=q-i|0;m=(l|0)<0;n=(p|0)>(e|0);o=(i|0)<(p|0);h=0;while(1){a:do if(m)a=0;else{if(o)a=0;else{a=0;while(1){f=b+(a<<1)|0;g=j[f+(e<<1)>>1]|0;d=j[f>>1]|0;j[c+(a<<1)>>1]=(g&65535)<(d&65535)?d:g;f=j[f+(i<<1)>>1]|0;j[c+(a+e<<1)>>1]=(g&65535)<(f&65535)?f:g;a=a+i|0;if((a|0)>(l|0))break a}}do{g=b+(a<<1)|0;d=j[g+(e<<1)>>1]|0;f=i;do{r=j[g+(f<<1)>>1]|0;d=(d&65535)<(r&65535)?r:d;f=f+e|0}while((f|0)<(p|0));r=j[g>>1]|0;j[c+(a<<1)>>1]=(d&65535)<(r&65535)?r:d;r=j[g+(f<<1)>>1]|0;j[c+(a+e<<1)>>1]=(d&65535)<(r&65535)?r:d;a=a+i|0}while((a|0)<=(l|0))}while(0);b:do if((a|0)<(q|0)){if(!n)while(1){j[c+(a<<1)>>1]=j[b+(a<<1)>>1]|0;a=a+e|0;if((a|0)>=(q|0))break b}do{g=b+(a<<1)|0;d=j[g>>1]|0;f=e;do{r=j[g+(f<<1)>>1]|0;d=(d&65535)<(r&65535)?r:d;f=f+e|0}while((f|0)<(p|0));j[c+(a<<1)>>1]=d;a=a+e|0}while((a|0)<(q|0))}while(0);h=h+1|0;if((h|0)==(e|0))break;else{c=c+2|0;b=b+2|0}}return}function vpa(a){a=a|0;ggb(a);return}function wpa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function xpa(a){a=a|0;ggb(a);return}function ypa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;q=aa(k[a+4>>2]|0,e)|0;r=aa(e,d)|0;if((q|0)==(e|0)){if((r|0)>0)a=0;else return;do{i[c+a>>0]=i[b+a>>0]|0;a=a+1|0}while((a|0)!=(r|0));return}if((e|0)<=0)return;j=e<<1;m=r-j|0;n=(m|0)<0;o=(q|0)>(e|0);p=(j|0)<(q|0);h=0;while(1){a:do if(n)a=0;else{if(p)a=0;else{a=0;while(1){d=b+a|0;g=l[d+e>>0]|0;f=256-g|0;i[c+a>>0]=(l[352559+((l[d>>0]|0)+f)>>0]|0)+g;i[c+(a+e)>>0]=(l[352559+((l[d+j>>0]|0)+f)>>0]|0)+g;a=a+j|0;if((a|0)>(m|0))break a}}do{g=b+a|0;d=i[g+e>>0]|0;f=j;while(1){d=d&255;d=(l[352559+(256-d+(l[g+f>>0]|0))>>0]|0)+d|0;f=f+e|0;if((f|0)>=(q|0))break;else d=d&255}s=256-(d&255)|0;i[c+a>>0]=(l[352559+((l[g>>0]|0)+s)>>0]|0)+d;i[c+(a+e)>>0]=(l[352559+((l[g+f>>0]|0)+s)>>0]|0)+d;a=a+j|0}while((a|0)<=(m|0))}while(0);b:do if((a|0)<(r|0)){if(!o)while(1){i[c+a>>0]=i[b+a>>0]|0;a=a+e|0;if((a|0)>=(r|0))break b}do{g=b+a|0;d=i[g>>0]|0;f=e;do{s=d&255;d=(l[352559+(256-s+(l[g+f>>0]|0))>>0]|0)+s&255;f=f+e|0}while((f|0)<(q|0));i[c+a>>0]=d;a=a+e|0}while((a|0)<(r|0))}while(0);h=h+1|0;if((h|0)==(e|0))break;else{c=c+1|0;b=b+1|0}}return}function zpa(a){a=a|0;ggb(a);return}function Apa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Bpa(a){a=a|0;ggb(a);return}function Cpa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,r=0.0;o=aa(k[a+4>>2]|0,e)|0;q=aa(e,d)|0;if((o|0)==(e|0)){if((q|0)>0)a=0;else return;do{p[c+(a<<3)>>3]=+p[b+(a<<3)>>3];a=a+1|0}while((a|0)!=(q|0));return}if((e|0)<=0)return;i=e<<1;j=q-i|0;l=(j|0)<0;m=(o|0)>(e|0);n=(i|0)<(o|0);h=0;while(1){a:do if(l)a=0;else{if(n)a=0;else{a=0;while(1){g=b+(a<<3)|0;f=+p[g+(e<<3)>>3];r=+p[g>>3];p[c+(a<<3)>>3]=r<f?r:f;r=+p[g+(i<<3)>>3];p[c+(a+e<<3)>>3]=r<f?r:f;a=a+i|0;if((a|0)>(j|0))break a}}do{g=b+(a<<3)|0;f=+p[g+(e<<3)>>3];d=i;do{r=+p[g+(d<<3)>>3];f=r<f?r:f;d=d+e|0}while((d|0)<(o|0));r=+p[g>>3];p[c+(a<<3)>>3]=r<f?r:f;r=+p[g+(d<<3)>>3];p[c+(a+e<<3)>>3]=r<f?r:f;a=a+i|0}while((a|0)<=(j|0))}while(0);b:do if((a|0)<(q|0)){if(!m)while(1){p[c+(a<<3)>>3]=+p[b+(a<<3)>>3];a=a+e|0;if((a|0)>=(q|0))break b}do{g=b+(a<<3)|0;f=+p[g>>3];d=e;do{r=+p[g+(d<<3)>>3];f=r<f?r:f;d=d+e|0}while((d|0)<(o|0));p[c+(a<<3)>>3]=f;a=a+e|0}while((a|0)<(q|0))}while(0);h=h+1|0;if((h|0)==(e|0))break;else{c=c+8|0;b=b+8|0}}return}function Dpa(a){a=a|0;ggb(a);return}function Epa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Fpa(a){a=a|0;ggb(a);return}function Gpa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0.0;p=aa(k[a+4>>2]|0,e)|0;q=aa(e,d)|0;if((p|0)==(e|0)){if((q|0)>0)a=0;else return;do{k[c+(a<<2)>>2]=k[b+(a<<2)>>2];a=a+1|0}while((a|0)!=(q|0));return}if((e|0)<=0)return;i=e<<1;j=q-i|0;l=(j|0)<0;m=(p|0)>(e|0);n=(i|0)<(p|0);h=0;while(1){a:do if(l)a=0;else{if(n)a=0;else{a=0;while(1){g=b+(a<<2)|0;f=+o[g+(e<<2)>>2];r=+o[g>>2];o[c+(a<<2)>>2]=r<f?r:f;r=+o[g+(i<<2)>>2];o[c+(a+e<<2)>>2]=r<f?r:f;a=a+i|0;if((a|0)>(j|0))break a}}do{g=b+(a<<2)|0;f=+o[g+(e<<2)>>2];d=i;do{r=+o[g+(d<<2)>>2];f=r<f?r:f;d=d+e|0}while((d|0)<(p|0));r=+o[g>>2];o[c+(a<<2)>>2]=r<f?r:f;r=+o[g+(d<<2)>>2];o[c+(a+e<<2)>>2]=r<f?r:f;a=a+i|0}while((a|0)<=(j|0))}while(0);b:do if((a|0)<(q|0)){if(!m)while(1){k[c+(a<<2)>>2]=k[b+(a<<2)>>2];a=a+e|0;if((a|0)>=(q|0))break b}do{g=b+(a<<2)|0;f=+o[g>>2];d=e;do{r=+o[g+(d<<2)>>2];f=r<f?r:f;d=d+e|0}while((d|0)<(p|0));o[c+(a<<2)>>2]=f;a=a+e|0}while((a|0)<(q|0))}while(0);h=h+1|0;if((h|0)==(e|0))break;else{c=c+4|0;b=b+4|0}}return}function Hpa(a){a=a|0;ggb(a);return}function Ipa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Jpa(a){a=a|0;ggb(a);return}function Kpa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;p=aa(k[a+4>>2]|0,e)|0;q=aa(e,d)|0;if((p|0)==(e|0)){if((q|0)>0)a=0;else return;do{j[c+(a<<1)>>1]=j[b+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(q|0));return}if((e|0)<=0)return;i=e<<1;l=q-i|0;m=(l|0)<0;n=(p|0)>(e|0);o=(i|0)<(p|0);h=0;while(1){a:do if(m)a=0;else{if(o)a=0;else{a=0;while(1){f=b+(a<<1)|0;g=j[f+(e<<1)>>1]|0;d=j[f>>1]|0;j[c+(a<<1)>>1]=d<<16>>16<g<<16>>16?d:g;f=j[f+(i<<1)>>1]|0;j[c+(a+e<<1)>>1]=f<<16>>16<g<<16>>16?f:g;a=a+i|0;if((a|0)>(l|0))break a}}do{g=b+(a<<1)|0;d=j[g+(e<<1)>>1]|0;f=i;do{r=j[g+(f<<1)>>1]|0;d=r<<16>>16<d<<16>>16?r:d;f=f+e|0}while((f|0)<(p|0));r=j[g>>1]|0;j[c+(a<<1)>>1]=r<<16>>16<d<<16>>16?r:d;r=j[g+(f<<1)>>1]|0;j[c+(a+e<<1)>>1]=r<<16>>16<d<<16>>16?r:d;a=a+i|0}while((a|0)<=(l|0))}while(0);b:do if((a|0)<(q|0)){if(!n)while(1){j[c+(a<<1)>>1]=j[b+(a<<1)>>1]|0;a=a+e|0;if((a|0)>=(q|0))break b}do{g=b+(a<<1)|0;d=j[g>>1]|0;f=e;do{r=j[g+(f<<1)>>1]|0;d=r<<16>>16<d<<16>>16?r:d;f=f+e|0}while((f|0)<(p|0));j[c+(a<<1)>>1]=d;a=a+e|0}while((a|0)<(q|0))}while(0);h=h+1|0;if((h|0)==(e|0))break;else{c=c+2|0;b=b+2|0}}return}function Lpa(a){a=a|0;ggb(a);return}function Mpa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Npa(a){a=a|0;ggb(a);return}function Opa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;p=aa(k[a+4>>2]|0,e)|0;q=aa(e,d)|0;if((p|0)==(e|0)){if((q|0)>0)a=0;else return;do{j[c+(a<<1)>>1]=j[b+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(q|0));return}if((e|0)<=0)return;i=e<<1;l=q-i|0;m=(l|0)<0;n=(p|0)>(e|0);o=(i|0)<(p|0);h=0;while(1){a:do if(m)a=0;else{if(o)a=0;else{a=0;while(1){f=b+(a<<1)|0;g=j[f+(e<<1)>>1]|0;d=j[f>>1]|0;j[c+(a<<1)>>1]=(d&65535)<(g&65535)?d:g;f=j[f+(i<<1)>>1]|0;j[c+(a+e<<1)>>1]=(f&65535)<(g&65535)?f:g;a=a+i|0;if((a|0)>(l|0))break a}}do{g=b+(a<<1)|0;d=j[g+(e<<1)>>1]|0;f=i;do{r=j[g+(f<<1)>>1]|0;d=(r&65535)<(d&65535)?r:d;f=f+e|0}while((f|0)<(p|0));r=j[g>>1]|0;j[c+(a<<1)>>1]=(r&65535)<(d&65535)?r:d;r=j[g+(f<<1)>>1]|0;j[c+(a+e<<1)>>1]=(r&65535)<(d&65535)?r:d;a=a+i|0}while((a|0)<=(l|0))}while(0);b:do if((a|0)<(q|0)){if(!n)while(1){j[c+(a<<1)>>1]=j[b+(a<<1)>>1]|0;a=a+e|0;if((a|0)>=(q|0))break b}do{g=b+(a<<1)|0;d=j[g>>1]|0;f=e;do{r=j[g+(f<<1)>>1]|0;d=(r&65535)<(d&65535)?r:d;f=f+e|0}while((f|0)<(p|0));j[c+(a<<1)>>1]=d;a=a+e|0}while((a|0)<(q|0))}while(0);h=h+1|0;if((h|0)==(e|0))break;else{c=c+2|0;b=b+2|0}}return}function Ppa(a){a=a|0;ggb(a);return}function Qpa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Rpa(a){a=a|0;ggb(a);return}function Spa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;q=aa(k[a+4>>2]|0,e)|0;r=aa(e,d)|0;if((q|0)==(e|0)){if((r|0)>0)a=0;else return;do{i[c+a>>0]=i[b+a>>0]|0;a=a+1|0}while((a|0)!=(r|0));return}if((e|0)<=0)return;j=e<<1;m=r-j|0;n=(m|0)<0;o=(q|0)>(e|0);p=(j|0)<(q|0);h=0;while(1){a:do if(n)a=0;else{if(p)a=0;else{a=0;while(1){g=b+a|0;d=l[g+e>>0]|0;f=d|256;i[c+a>>0]=d-(l[352559+(f-(l[g>>0]|0))>>0]|0);i[c+(a+e)>>0]=d-(l[352559+(f-(l[g+j>>0]|0))>>0]|0);a=a+j|0;if((a|0)>(m|0))break a}}do{g=b+a|0;d=i[g+e>>0]|0;f=j;while(1){d=d&255;d=d-(l[352559+((d|256)-(l[g+f>>0]|0))>>0]|0)|0;f=f+e|0;if((f|0)>=(q|0))break;else d=d&255}s=d&255|256;i[c+a>>0]=d-(l[352559+(s-(l[g>>0]|0))>>0]|0);i[c+(a+e)>>0]=d-(l[352559+(s-(l[g+f>>0]|0))>>0]|0);a=a+j|0}while((a|0)<=(m|0))}while(0);b:do if((a|0)<(r|0)){if(!o)while(1){i[c+a>>0]=i[b+a>>0]|0;a=a+e|0;if((a|0)>=(r|0))break b}do{g=b+a|0;d=i[g>>0]|0;f=e;do{s=d&255;d=s-(l[352559+((s|256)-(l[g+f>>0]|0))>>0]|0)&255;f=f+e|0}while((f|0)<(q|0));i[c+a>>0]=d;a=a+e|0}while((a|0)<(r|0))}while(0);h=h+1|0;if((h|0)==(e|0))break;else{c=c+1|0;b=b+1|0}}return}function Tpa(a){a=a|0;ggb(a);return}function Upa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Vpa(a){a=a|0;ggb(a);return}function Wpa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0.0,j=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0;A=k[a+4>>2]|0;y=d>>>3;z=(A|0)>1;if(z&(e|0)>1){q=f+-4|0;r=(f|0)<4;s=(A|0)>2;t=y<<1;u=f&-4;w=e+-2|0;v=w>>>1;x=v<<1;v=c+(aa(y,(v<<4)+16|0)|0)|0;d=b+(x+2<<2)|0;o=b;while(1){a:do if(r)a=0;else{m=k[o+4>>2]|0;n=k[o>>2]|0;if(!s){b=k[o+8>>2]|0;a=0;while(1){B=m+(a<<3)|0;g=+p[B>>3];h=+p[B+8>>3];i=+p[B+16>>3];j=+p[B+24>>3];B=n+(a<<3)|0;C=+p[B>>3];p[c+(a<<3)>>3]=g<C?C:g;C=+p[B+8>>3];p[c+((a|1)<<3)>>3]=h<C?C:h;C=+p[B+16>>3];p[c+((a|2)<<3)>>3]=i<C?C:i;C=+p[B+24>>3];p[c+((a|3)<<3)>>3]=j<C?C:j;B=b+(a<<3)|0;C=+p[B>>3];l=a+y|0;p[c+(l<<3)>>3]=g<C?C:g;g=+p[B+8>>3];p[c+(l+1<<3)>>3]=h<g?g:h;h=+p[B+16>>3];p[c+(l+2<<3)>>3]=i<h?h:i;i=+p[B+24>>3];p[c+(l+3<<3)>>3]=j<i?i:j;a=a+4|0;if((a|0)>(q|0)){a=u;break a}}}l=k[o+(A<<2)>>2]|0;b=0;do{a=m+(b<<3)|0;g=+p[a+24>>3];h=+p[a+16>>3];i=+p[a+8>>3];j=+p[a>>3];a=2;do{B=(k[o+(a<<2)>>2]|0)+(b<<3)|0;C=+p[B>>3];j=j<C?C:j;C=+p[B+8>>3];i=i<C?C:i;C=+p[B+16>>3];h=h<C?C:h;C=+p[B+24>>3];g=g<C?C:g;a=a+1|0}while((a|0)!=(A|0));a=n+(b<<3)|0;C=+p[a>>3];p[c+(b<<3)>>3]=j<C?C:j;C=+p[a+8>>3];p[c+((b|1)<<3)>>3]=i<C?C:i;C=+p[a+16>>3];p[c+((b|2)<<3)>>3]=h<C?C:h;C=+p[a+24>>3];p[c+((b|3)<<3)>>3]=g<C?C:g;a=l+(b<<3)|0;C=+p[a>>3];B=b+y|0;p[c+(B<<3)>>3]=j<C?C:j;C=+p[a+8>>3];p[c+(B+1<<3)>>3]=i<C?C:i;C=+p[a+16>>3];p[c+(B+2<<3)>>3]=h<C?C:h;C=+p[a+24>>3];p[c+(B+3<<3)>>3]=g<C?C:g;b=b+4|0}while((b|0)<=(q|0));a=u}while(0);b:do if((a|0)<(f|0)){m=k[o+4>>2]|0;n=k[o>>2]|0;if(!s){b=k[o+8>>2]|0;while(1){C=+p[m+(a<<3)>>3];j=+p[n+(a<<3)>>3];p[c+(a<<3)>>3]=C<j?j:C;j=+p[b+(a<<3)>>3];p[c+(a+y<<3)>>3]=C<j?j:C;a=a+1|0;if((a|0)==(f|0))break b}}l=k[o+(A<<2)>>2]|0;do{g=+p[m+(a<<3)>>3];b=2;do{C=+p[(k[o+(b<<2)>>2]|0)+(a<<3)>>3];g=g<C?C:g;b=b+1|0}while((b|0)!=(A|0));C=+p[n+(a<<3)>>3];p[c+(a<<3)>>3]=g<C?C:g;C=+p[l+(a<<3)>>3];p[c+(a+y<<3)>>3]=g<C?C:g;a=a+1|0}while((a|0)!=(f|0))}while(0);e=e+-2|0;if((e|0)<=1)break;else{c=c+(t<<3)|0;o=o+8|0}}c=v;a=w-x|0}else{d=b;a=e}if((a|0)<=0)return;m=f+-4|0;n=(f|0)<4;o=f&-4;l=d;e=c;while(1){c:do if(n)d=0;else{b=k[l>>2]|0;if(z)d=0;else{d=0;while(1){B=b+(d<<3)|0;i=+p[B+8>>3];j=+p[B+16>>3];C=+p[B+24>>3];p[e+(d<<3)>>3]=+p[B>>3];p[e+((d|1)<<3)>>3]=i;p[e+((d|2)<<3)>>3]=j;p[e+((d|3)<<3)>>3]=C;d=d+4|0;if((d|0)>(m|0)){d=o;break c}}}do{c=b+(d<<3)|0;g=+p[c+24>>3];h=+p[c+16>>3];i=+p[c+8>>3];j=+p[c>>3];c=1;do{B=(k[l+(c<<2)>>2]|0)+(d<<3)|0;C=+p[B>>3];j=j<C?C:j;C=+p[B+8>>3];i=i<C?C:i;C=+p[B+16>>3];h=h<C?C:h;C=+p[B+24>>3];g=g<C?C:g;c=c+1|0}while((c|0)!=(A|0));p[e+(d<<3)>>3]=j;p[e+((d|1)<<3)>>3]=i;p[e+((d|2)<<3)>>3]=h;p[e+((d|3)<<3)>>3]=g;d=d+4|0}while((d|0)<=(m|0));d=o}while(0);d:do if((d|0)<(f|0)){b=k[l>>2]|0;if(!z)while(1){p[e+(d<<3)>>3]=+p[b+(d<<3)>>3];d=d+1|0;if((d|0)==(f|0))break d}do{g=+p[b+(d<<3)>>3];c=1;do{C=+p[(k[l+(c<<2)>>2]|0)+(d<<3)>>3];g=g<C?C:g;c=c+1|0}while((c|0)!=(A|0));p[e+(d<<3)>>3]=g;d=d+1|0}while((d|0)!=(f|0))}while(0);if((a|0)>1){l=l+4|0;a=a+-1|0;e=e+(y<<3)|0}else break}return}function Xpa(a){a=a|0;ggb(a);return}function Ypa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Zpa(a){a=a|0;ggb(a);return}function _pa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0.0,j=0.0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0;A=k[a+4>>2]|0;y=d>>>2;z=(A|0)>1;if(z&(e|0)>1){q=f+-4|0;r=(f|0)<4;s=(A|0)>2;t=y<<1;u=f&-4;w=e+-2|0;v=w>>>1;x=v<<1;v=c+(aa(y,(v<<3)+8|0)|0)|0;d=b+(x+2<<2)|0;p=b;while(1){a:do if(r)a=0;else{m=k[p+4>>2]|0;n=k[p>>2]|0;if(!s){b=k[p+8>>2]|0;a=0;while(1){B=m+(a<<2)|0;g=+o[B>>2];h=+o[B+4>>2];i=+o[B+8>>2];j=+o[B+12>>2];B=n+(a<<2)|0;C=+o[B>>2];o[c+(a<<2)>>2]=g<C?C:g;C=+o[B+4>>2];o[c+((a|1)<<2)>>2]=h<C?C:h;C=+o[B+8>>2];o[c+((a|2)<<2)>>2]=i<C?C:i;C=+o[B+12>>2];o[c+((a|3)<<2)>>2]=j<C?C:j;B=b+(a<<2)|0;C=+o[B>>2];l=a+y|0;o[c+(l<<2)>>2]=g<C?C:g;g=+o[B+4>>2];o[c+(l+1<<2)>>2]=h<g?g:h;h=+o[B+8>>2];o[c+(l+2<<2)>>2]=i<h?h:i;i=+o[B+12>>2];o[c+(l+3<<2)>>2]=j<i?i:j;a=a+4|0;if((a|0)>(q|0)){a=u;break a}}}l=k[p+(A<<2)>>2]|0;b=0;do{a=m+(b<<2)|0;g=+o[a+12>>2];h=+o[a+8>>2];i=+o[a+4>>2];j=+o[a>>2];a=2;do{B=(k[p+(a<<2)>>2]|0)+(b<<2)|0;C=+o[B>>2];j=j<C?C:j;C=+o[B+4>>2];i=i<C?C:i;C=+o[B+8>>2];h=h<C?C:h;C=+o[B+12>>2];g=g<C?C:g;a=a+1|0}while((a|0)!=(A|0));a=n+(b<<2)|0;C=+o[a>>2];o[c+(b<<2)>>2]=j<C?C:j;C=+o[a+4>>2];o[c+((b|1)<<2)>>2]=i<C?C:i;C=+o[a+8>>2];o[c+((b|2)<<2)>>2]=h<C?C:h;C=+o[a+12>>2];o[c+((b|3)<<2)>>2]=g<C?C:g;a=l+(b<<2)|0;C=+o[a>>2];B=b+y|0;o[c+(B<<2)>>2]=j<C?C:j;C=+o[a+4>>2];o[c+(B+1<<2)>>2]=i<C?C:i;C=+o[a+8>>2];o[c+(B+2<<2)>>2]=h<C?C:h;C=+o[a+12>>2];o[c+(B+3<<2)>>2]=g<C?C:g;b=b+4|0}while((b|0)<=(q|0));a=u}while(0);b:do if((a|0)<(f|0)){m=k[p+4>>2]|0;n=k[p>>2]|0;if(!s){b=k[p+8>>2]|0;while(1){C=+o[m+(a<<2)>>2];j=+o[n+(a<<2)>>2];o[c+(a<<2)>>2]=C<j?j:C;j=+o[b+(a<<2)>>2];o[c+(a+y<<2)>>2]=C<j?j:C;a=a+1|0;if((a|0)==(f|0))break b}}l=k[p+(A<<2)>>2]|0;do{g=+o[m+(a<<2)>>2];b=2;do{C=+o[(k[p+(b<<2)>>2]|0)+(a<<2)>>2];g=g<C?C:g;b=b+1|0}while((b|0)!=(A|0));C=+o[n+(a<<2)>>2];o[c+(a<<2)>>2]=g<C?C:g;C=+o[l+(a<<2)>>2];o[c+(a+y<<2)>>2]=g<C?C:g;a=a+1|0}while((a|0)!=(f|0))}while(0);e=e+-2|0;if((e|0)<=1)break;else{c=c+(t<<2)|0;p=p+8|0}}c=v;a=w-x|0}else{d=b;a=e}if((a|0)<=0)return;m=f+-4|0;n=(f|0)<4;p=f&-4;l=d;e=c;while(1){c:do if(n)d=0;else{b=k[l>>2]|0;if(z)d=0;else{d=0;while(1){v=b+(d<<2)|0;w=k[v+4>>2]|0;x=k[v+8>>2]|0;B=k[v+12>>2]|0;k[e+(d<<2)>>2]=k[v>>2];k[e+((d|1)<<2)>>2]=w;k[e+((d|2)<<2)>>2]=x;k[e+((d|3)<<2)>>2]=B;d=d+4|0;if((d|0)>(m|0)){d=p;break c}}}do{c=b+(d<<2)|0;g=+o[c+12>>2];h=+o[c+8>>2];i=+o[c+4>>2];j=+o[c>>2];c=1;do{B=(k[l+(c<<2)>>2]|0)+(d<<2)|0;C=+o[B>>2];j=j<C?C:j;C=+o[B+4>>2];i=i<C?C:i;C=+o[B+8>>2];h=h<C?C:h;C=+o[B+12>>2];g=g<C?C:g;c=c+1|0}while((c|0)!=(A|0));o[e+(d<<2)>>2]=j;o[e+((d|1)<<2)>>2]=i;o[e+((d|2)<<2)>>2]=h;o[e+((d|3)<<2)>>2]=g;d=d+4|0}while((d|0)<=(m|0));d=p}while(0);d:do if((d|0)<(f|0)){b=k[l>>2]|0;if(!z)while(1){k[e+(d<<2)>>2]=k[b+(d<<2)>>2];d=d+1|0;if((d|0)==(f|0))break d}do{g=+o[b+(d<<2)>>2];c=1;do{C=+o[(k[l+(c<<2)>>2]|0)+(d<<2)>>2];g=g<C?C:g;c=c+1|0}while((c|0)!=(A|0));o[e+(d<<2)>>2]=g;d=d+1|0}while((d|0)!=(f|0))}while(0);if((a|0)>1){l=l+4|0;a=a+-1|0;e=e+(y<<2)|0}else break}return}function $pa(a){a=a|0;ggb(a);return}function aqa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function bqa(a){a=a|0;ggb(a);return}function cqa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;A=k[a+4>>2]|0;y=d>>>1;z=(A|0)>1;if(z&(e|0)>1){q=f+-4|0;r=(f|0)<4;s=(A|0)>2;t=y<<1;u=f&-4;w=e+-2|0;v=w>>>1;x=v<<1;v=c+(aa(y,(v<<2)+4|0)|0)|0;d=b+(x+2<<2)|0;p=b;o=e;while(1){a:do if(r)a=0;else{m=k[p+4>>2]|0;n=k[p>>2]|0;if(!s){b=k[p+8>>2]|0;a=0;while(1){i=m+(a<<1)|0;B=j[i>>1]|0;e=j[i+2>>1]|0;g=j[i+4>>1]|0;i=j[i+6>>1]|0;h=n+(a<<1)|0;C=j[h>>1]|0;j[c+(a<<1)>>1]=B<<16>>16<C<<16>>16?C:B;C=j[h+2>>1]|0;j[c+((a|1)<<1)>>1]=e<<16>>16<C<<16>>16?C:e;C=j[h+4>>1]|0;j[c+((a|2)<<1)>>1]=g<<16>>16<C<<16>>16?C:g;h=j[h+6>>1]|0;j[c+((a|3)<<1)>>1]=i<<16>>16<h<<16>>16?h:i;h=b+(a<<1)|0;C=j[h>>1]|0;l=a+y|0;j[c+(l<<1)>>1]=B<<16>>16<C<<16>>16?C:B;B=j[h+2>>1]|0;j[c+(l+1<<1)>>1]=e<<16>>16<B<<16>>16?B:e;e=j[h+4>>1]|0;j[c+(l+2<<1)>>1]=g<<16>>16<e<<16>>16?e:g;h=j[h+6>>1]|0;j[c+(l+3<<1)>>1]=i<<16>>16<h<<16>>16?h:i;a=a+4|0;if((a|0)>(q|0)){a=u;break a}}}l=k[p+(A<<2)>>2]|0;i=0;do{g=m+(i<<1)|0;a=j[g+6>>1]|0;b=j[g+4>>1]|0;e=j[g+2>>1]|0;g=j[g>>1]|0;h=2;do{C=(k[p+(h<<2)>>2]|0)+(i<<1)|0;B=j[C>>1]|0;g=g<<16>>16<B<<16>>16?B:g;B=j[C+2>>1]|0;e=e<<16>>16<B<<16>>16?B:e;B=j[C+4>>1]|0;b=b<<16>>16<B<<16>>16?B:b;C=j[C+6>>1]|0;a=a<<16>>16<C<<16>>16?C:a;h=h+1|0}while((h|0)!=(A|0));B=n+(i<<1)|0;h=j[B>>1]|0;j[c+(i<<1)>>1]=g<<16>>16<h<<16>>16?h:g;h=j[B+2>>1]|0;j[c+((i|1)<<1)>>1]=e<<16>>16<h<<16>>16?h:e;h=j[B+4>>1]|0;j[c+((i|2)<<1)>>1]=b<<16>>16<h<<16>>16?h:b;B=j[B+6>>1]|0;j[c+((i|3)<<1)>>1]=a<<16>>16<B<<16>>16?B:a;B=l+(i<<1)|0;h=j[B>>1]|0;C=i+y|0;j[c+(C<<1)>>1]=g<<16>>16<h<<16>>16?h:g;h=j[B+2>>1]|0;j[c+(C+1<<1)>>1]=e<<16>>16<h<<16>>16?h:e;h=j[B+4>>1]|0;j[c+(C+2<<1)>>1]=b<<16>>16<h<<16>>16?h:b;B=j[B+6>>1]|0;j[c+(C+3<<1)>>1]=a<<16>>16<B<<16>>16?B:a;i=i+4|0}while((i|0)<=(q|0));a=u}while(0);b:do if((a|0)<(f|0)){h=k[p+4>>2]|0;i=k[p>>2]|0;if(!s){b=k[p+8>>2]|0;while(1){C=j[h+(a<<1)>>1]|0;B=j[i+(a<<1)>>1]|0;j[c+(a<<1)>>1]=C<<16>>16<B<<16>>16?B:C;B=j[b+(a<<1)>>1]|0;j[c+(a+y<<1)>>1]=C<<16>>16<B<<16>>16?B:C;a=a+1|0;if((a|0)==(f|0))break b}}g=k[p+(A<<2)>>2]|0;do{b=j[h+(a<<1)>>1]|0;e=2;do{C=j[(k[p+(e<<2)>>2]|0)+(a<<1)>>1]|0;b=b<<16>>16<C<<16>>16?C:b;e=e+1|0}while((e|0)!=(A|0));C=j[i+(a<<1)>>1]|0;j[c+(a<<1)>>1]=b<<16>>16<C<<16>>16?C:b;C=j[g+(a<<1)>>1]|0;j[c+(a+y<<1)>>1]=b<<16>>16<C<<16>>16?C:b;a=a+1|0}while((a|0)!=(f|0))}while(0);o=o+-2|0;if((o|0)<=1)break;else{c=c+(t<<1)|0;p=p+8|0}}c=v;a=w-x|0}else{d=b;a=e}if((a|0)<=0)return;n=f+-4|0;o=(f|0)<4;p=f&-4;m=d;l=c;while(1){c:do if(o)d=0;else{i=k[m>>2]|0;if(z)g=0;else{d=0;while(1){w=i+(d<<1)|0;x=j[w+2>>1]|0;B=j[w+4>>1]|0;C=j[w+6>>1]|0;j[l+(d<<1)>>1]=j[w>>1]|0;j[l+((d|1)<<1)>>1]=x;j[l+((d|2)<<1)>>1]=B;j[l+((d|3)<<1)>>1]=C;d=d+4|0;if((d|0)>(n|0)){d=p;break c}}}do{e=i+(g<<1)|0;d=j[e+6>>1]|0;c=j[e+4>>1]|0;b=j[e+2>>1]|0;e=j[e>>1]|0;h=1;do{C=(k[m+(h<<2)>>2]|0)+(g<<1)|0;B=j[C>>1]|0;e=e<<16>>16<B<<16>>16?B:e;B=j[C+2>>1]|0;b=b<<16>>16<B<<16>>16?B:b;B=j[C+4>>1]|0;c=c<<16>>16<B<<16>>16?B:c;C=j[C+6>>1]|0;d=d<<16>>16<C<<16>>16?C:d;h=h+1|0}while((h|0)!=(A|0));j[l+(g<<1)>>1]=e;j[l+((g|1)<<1)>>1]=b;j[l+((g|2)<<1)>>1]=c;j[l+((g|3)<<1)>>1]=d;g=g+4|0}while((g|0)<=(n|0));d=p}while(0);d:do if((d|0)<(f|0)){e=k[m>>2]|0;if(!z)while(1){j[l+(d<<1)>>1]=j[e+(d<<1)>>1]|0;d=d+1|0;if((d|0)==(f|0))break d}do{c=j[e+(d<<1)>>1]|0;b=1;do{C=j[(k[m+(b<<2)>>2]|0)+(d<<1)>>1]|0;c=c<<16>>16<C<<16>>16?C:c;b=b+1|0}while((b|0)!=(A|0));j[l+(d<<1)>>1]=c;d=d+1|0}while((d|0)!=(f|0))}while(0);if((a|0)>1){m=m+4|0;a=a+-1|0;l=l+(y<<1)|0}else break}return}function dqa(a){a=a|0;ggb(a);return}function eqa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function fqa(a){a=a|0;ggb(a);return}function gqa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;A=k[a+4>>2]|0;y=d>>>1;z=(A|0)>1;if(z&(e|0)>1){q=f+-4|0;r=(f|0)<4;s=(A|0)>2;t=y<<1;u=f&-4;w=e+-2|0;v=w>>>1;x=v<<1;v=c+(aa(y,(v<<2)+4|0)|0)|0;d=b+(x+2<<2)|0;p=b;o=e;while(1){a:do if(r)a=0;else{m=k[p+4>>2]|0;n=k[p>>2]|0;if(!s){b=k[p+8>>2]|0;a=0;while(1){i=m+(a<<1)|0;B=j[i>>1]|0;e=j[i+2>>1]|0;g=j[i+4>>1]|0;i=j[i+6>>1]|0;h=n+(a<<1)|0;C=j[h>>1]|0;j[c+(a<<1)>>1]=(B&65535)<(C&65535)?C:B;C=j[h+2>>1]|0;j[c+((a|1)<<1)>>1]=(e&65535)<(C&65535)?C:e;C=j[h+4>>1]|0;j[c+((a|2)<<1)>>1]=(g&65535)<(C&65535)?C:g;h=j[h+6>>1]|0;j[c+((a|3)<<1)>>1]=(i&65535)<(h&65535)?h:i;h=b+(a<<1)|0;C=j[h>>1]|0;l=a+y|0;j[c+(l<<1)>>1]=(B&65535)<(C&65535)?C:B;B=j[h+2>>1]|0;j[c+(l+1<<1)>>1]=(e&65535)<(B&65535)?B:e;e=j[h+4>>1]|0;j[c+(l+2<<1)>>1]=(g&65535)<(e&65535)?e:g;h=j[h+6>>1]|0;j[c+(l+3<<1)>>1]=(i&65535)<(h&65535)?h:i;a=a+4|0;if((a|0)>(q|0)){a=u;break a}}}l=k[p+(A<<2)>>2]|0;i=0;do{g=m+(i<<1)|0;a=j[g+6>>1]|0;b=j[g+4>>1]|0;e=j[g+2>>1]|0;g=j[g>>1]|0;h=2;do{C=(k[p+(h<<2)>>2]|0)+(i<<1)|0;B=j[C>>1]|0;g=(g&65535)<(B&65535)?B:g;B=j[C+2>>1]|0;e=(e&65535)<(B&65535)?B:e;B=j[C+4>>1]|0;b=(b&65535)<(B&65535)?B:b;C=j[C+6>>1]|0;a=(a&65535)<(C&65535)?C:a;h=h+1|0}while((h|0)!=(A|0));B=n+(i<<1)|0;h=j[B>>1]|0;j[c+(i<<1)>>1]=(g&65535)<(h&65535)?h:g;h=j[B+2>>1]|0;j[c+((i|1)<<1)>>1]=(e&65535)<(h&65535)?h:e;h=j[B+4>>1]|0;j[c+((i|2)<<1)>>1]=(b&65535)<(h&65535)?h:b;B=j[B+6>>1]|0;j[c+((i|3)<<1)>>1]=(a&65535)<(B&65535)?B:a;B=l+(i<<1)|0;h=j[B>>1]|0;C=i+y|0;j[c+(C<<1)>>1]=(g&65535)<(h&65535)?h:g;h=j[B+2>>1]|0;j[c+(C+1<<1)>>1]=(e&65535)<(h&65535)?h:e;h=j[B+4>>1]|0;j[c+(C+2<<1)>>1]=(b&65535)<(h&65535)?h:b;B=j[B+6>>1]|0;j[c+(C+3<<1)>>1]=(a&65535)<(B&65535)?B:a;i=i+4|0}while((i|0)<=(q|0));a=u}while(0);b:do if((a|0)<(f|0)){h=k[p+4>>2]|0;i=k[p>>2]|0;if(!s){b=k[p+8>>2]|0;while(1){C=j[h+(a<<1)>>1]|0;B=j[i+(a<<1)>>1]|0;j[c+(a<<1)>>1]=(C&65535)<(B&65535)?B:C;B=j[b+(a<<1)>>1]|0;j[c+(a+y<<1)>>1]=(C&65535)<(B&65535)?B:C;a=a+1|0;if((a|0)==(f|0))break b}}g=k[p+(A<<2)>>2]|0;do{b=j[h+(a<<1)>>1]|0;e=2;do{C=j[(k[p+(e<<2)>>2]|0)+(a<<1)>>1]|0;b=(b&65535)<(C&65535)?C:b;e=e+1|0}while((e|0)!=(A|0));C=j[i+(a<<1)>>1]|0;j[c+(a<<1)>>1]=(b&65535)<(C&65535)?C:b;C=j[g+(a<<1)>>1]|0;j[c+(a+y<<1)>>1]=(b&65535)<(C&65535)?C:b;a=a+1|0}while((a|0)!=(f|0))}while(0);o=o+-2|0;if((o|0)<=1)break;else{c=c+(t<<1)|0;p=p+8|0}}c=v;a=w-x|0}else{d=b;a=e}if((a|0)<=0)return;n=f+-4|0;o=(f|0)<4;p=f&-4;m=d;l=c;while(1){c:do if(o)d=0;else{i=k[m>>2]|0;if(z)g=0;else{d=0;while(1){w=i+(d<<1)|0;x=j[w+2>>1]|0;B=j[w+4>>1]|0;C=j[w+6>>1]|0;j[l+(d<<1)>>1]=j[w>>1]|0;j[l+((d|1)<<1)>>1]=x;j[l+((d|2)<<1)>>1]=B;j[l+((d|3)<<1)>>1]=C;d=d+4|0;if((d|0)>(n|0)){d=p;break c}}}do{e=i+(g<<1)|0;d=j[e+6>>1]|0;c=j[e+4>>1]|0;b=j[e+2>>1]|0;e=j[e>>1]|0;h=1;do{C=(k[m+(h<<2)>>2]|0)+(g<<1)|0;B=j[C>>1]|0;e=(e&65535)<(B&65535)?B:e;B=j[C+2>>1]|0;b=(b&65535)<(B&65535)?B:b;B=j[C+4>>1]|0;c=(c&65535)<(B&65535)?B:c;C=j[C+6>>1]|0;d=(d&65535)<(C&65535)?C:d;h=h+1|0}while((h|0)!=(A|0));j[l+(g<<1)>>1]=e;j[l+((g|1)<<1)>>1]=b;j[l+((g|2)<<1)>>1]=c;j[l+((g|3)<<1)>>1]=d;g=g+4|0}while((g|0)<=(n|0));d=p}while(0);d:do if((d|0)<(f|0)){e=k[m>>2]|0;if(!z)while(1){j[l+(d<<1)>>1]=j[e+(d<<1)>>1]|0;d=d+1|0;if((d|0)==(f|0))break d}do{c=j[e+(d<<1)>>1]|0;b=1;do{C=j[(k[m+(b<<2)>>2]|0)+(d<<1)>>1]|0;c=(c&65535)<(C&65535)?C:c;b=b+1|0}while((b|0)!=(A|0));j[l+(d<<1)>>1]=c;d=d+1|0}while((d|0)!=(f|0))}while(0);if((a|0)>1){m=m+4|0;a=a+-1|0;l=l+(y<<1)|0}else break}return}function hqa(a){a=a|0;ggb(a);return}function iqa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function jqa(a){a=a|0;ggb(a);return}function kqa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;z=k[a+4>>2]|0;A=(z|0)>1;if(A&(e|0)>1){q=f+-4|0;r=(f|0)<4;s=(z|0)>2;t=d<<1;u=f&-4;x=e+-2|0;y=x&-2;w=y+2|0;v=c+(aa(w,d)|0)|0;p=b;o=e;while(1){if(r)a=0;else{n=p+4|0;m=0;do{a=(k[n>>2]|0)+m|0;e=i[a>>0]|0;h=i[a+1>>0]|0;g=i[a+2>>0]|0;a=i[a+3>>0]|0;if(s){j=2;do{B=(k[p+(j<<2)>>2]|0)+m|0;e=e&255;e=(l[352559+(256-e+(l[B>>0]|0))>>0]|0)+e&255;h=h&255;h=(l[352559+(256-h+(l[B+1>>0]|0))>>0]|0)+h&255;g=g&255;g=(l[352559+(256-g+(l[B+2>>0]|0))>>0]|0)+g&255;a=a&255;a=(l[352559+(256-a+(l[B+3>>0]|0))>>0]|0)+a&255;j=j+1|0}while((j|0)!=(z|0));j=g;g=z}else{j=g;g=2}B=(k[p>>2]|0)+m|0;F=e&255;G=256-F|0;i[c+m>>0]=(l[352559+((l[B>>0]|0)+G)>>0]|0)+F;D=h&255;E=256-D|0;i[c+(m|1)>>0]=(l[352559+((l[B+1>>0]|0)+E)>>0]|0)+D;e=j&255;C=256-e|0;i[c+(m|2)>>0]=(l[352559+((l[B+2>>0]|0)+C)>>0]|0)+e;j=a&255;h=256-j|0;i[c+(m|3)>>0]=(l[352559+((l[B+3>>0]|0)+h)>>0]|0)+j;g=(k[p+(g<<2)>>2]|0)+m|0;B=m+d|0;i[c+B>>0]=(l[352559+((l[g>>0]|0)+G)>>0]|0)+F;i[c+(B+1)>>0]=(l[352559+((l[g+1>>0]|0)+E)>>0]|0)+D;i[c+(B+2)>>0]=(l[352559+((l[g+2>>0]|0)+C)>>0]|0)+e;i[c+(B+3)>>0]=(l[352559+((l[g+3>>0]|0)+h)>>0]|0)+j;m=m+4|0}while((m|0)<=(q|0));a=u}a:do if((a|0)<(f|0)){j=p+4|0;if(!s){e=p+8|0;while(1){G=l[(k[j>>2]|0)+a>>0]|0;F=256-G|0;i[c+a>>0]=(l[352559+((l[(k[p>>2]|0)+a>>0]|0)+F)>>0]|0)+G;i[c+(a+d)>>0]=(l[352559+((l[(k[e>>2]|0)+a>>0]|0)+F)>>0]|0)+G;a=a+1|0;if((a|0)==(f|0))break a}}h=p+(z<<2)|0;do{e=i[(k[j>>2]|0)+a>>0]|0;g=2;while(1){e=e&255;e=(l[352559+(256-e+(l[(k[p+(g<<2)>>2]|0)+a>>0]|0))>>0]|0)+e|0;g=g+1|0;if((g|0)==(z|0))break;else e=e&255}G=256-(e&255)|0;i[c+a>>0]=(l[352559+((l[(k[p>>2]|0)+a>>0]|0)+G)>>0]|0)+e;i[c+(a+d)>>0]=(l[352559+((l[(k[h>>2]|0)+a>>0]|0)+G)>>0]|0)+e;a=a+1|0}while((a|0)!=(f|0))}while(0);o=o+-2|0;if((o|0)<=1)break;else{c=c+t|0;p=p+8|0}}c=v;b=b+(w<<2)|0;a=x-y|0}else a=e;if((a|0)<=0)return;o=f+-4|0;p=(f|0)<4;q=f&-4;n=b;m=c;while(1){b:do if(p)b=0;else{if(A)h=0;else{b=0;while(1){D=(k[n>>2]|0)+b|0;E=i[D+1>>0]|0;F=i[D+2>>0]|0;G=i[D+3>>0]|0;i[m+b>>0]=i[D>>0]|0;i[m+(b|1)>>0]=E;i[m+(b|2)>>0]=F;i[m+(b|3)>>0]=G;b=b+4|0;if((b|0)>(o|0)){b=q;break b}}}do{g=(k[n>>2]|0)+h|0;b=i[g+3>>0]|0;c=i[g+2>>0]|0;e=i[g+1>>0]|0;g=i[g>>0]|0;j=1;do{F=(k[n+(j<<2)>>2]|0)+h|0;G=g&255;g=(l[352559+(256-G+(l[F>>0]|0))>>0]|0)+G&255;G=e&255;e=(l[352559+(256-G+(l[F+1>>0]|0))>>0]|0)+G&255;G=c&255;c=(l[352559+(256-G+(l[F+2>>0]|0))>>0]|0)+G&255;G=b&255;b=(l[352559+(256-G+(l[F+3>>0]|0))>>0]|0)+G&255;j=j+1|0}while((j|0)!=(z|0));i[m+h>>0]=g;i[m+(h|1)>>0]=e;i[m+(h|2)>>0]=c;i[m+(h|3)>>0]=b;h=h+4|0}while((h|0)<=(o|0));b=q}while(0);c:do if((b|0)<(f|0)){if(!A)while(1){i[m+b>>0]=i[(k[n>>2]|0)+b>>0]|0;b=b+1|0;if((b|0)==(f|0))break c}do{c=i[(k[n>>2]|0)+b>>0]|0;e=1;do{G=c&255;c=(l[352559+(256-G+(l[(k[n+(e<<2)>>2]|0)+b>>0]|0))>>0]|0)+G&255;e=e+1|0}while((e|0)!=(z|0));i[m+b>>0]=c;b=b+1|0}while((b|0)!=(f|0))}while(0);if((a|0)>1){n=n+4|0;a=a+-1|0;m=m+d|0}else break}return}function lqa(a){a=a|0;ggb(a);return}function mqa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function nqa(a){a=a|0;ggb(a);return}function oqa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0.0,j=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0;A=k[a+4>>2]|0;y=d>>>3;z=(A|0)>1;if(z&(e|0)>1){q=f+-4|0;r=(f|0)<4;s=(A|0)>2;t=y<<1;u=f&-4;w=e+-2|0;v=w>>>1;x=v<<1;v=c+(aa(y,(v<<4)+16|0)|0)|0;d=b+(x+2<<2)|0;o=b;while(1){a:do if(r)a=0;else{m=k[o+4>>2]|0;n=k[o>>2]|0;if(!s){b=k[o+8>>2]|0;a=0;while(1){B=m+(a<<3)|0;g=+p[B>>3];h=+p[B+8>>3];i=+p[B+16>>3];j=+p[B+24>>3];B=n+(a<<3)|0;C=+p[B>>3];p[c+(a<<3)>>3]=C<g?C:g;C=+p[B+8>>3];p[c+((a|1)<<3)>>3]=C<h?C:h;C=+p[B+16>>3];p[c+((a|2)<<3)>>3]=C<i?C:i;C=+p[B+24>>3];p[c+((a|3)<<3)>>3]=C<j?C:j;B=b+(a<<3)|0;C=+p[B>>3];l=a+y|0;p[c+(l<<3)>>3]=C<g?C:g;g=+p[B+8>>3];p[c+(l+1<<3)>>3]=g<h?g:h;h=+p[B+16>>3];p[c+(l+2<<3)>>3]=h<i?h:i;i=+p[B+24>>3];p[c+(l+3<<3)>>3]=i<j?i:j;a=a+4|0;if((a|0)>(q|0)){a=u;break a}}}l=k[o+(A<<2)>>2]|0;b=0;do{a=m+(b<<3)|0;g=+p[a+24>>3];h=+p[a+16>>3];i=+p[a+8>>3];j=+p[a>>3];a=2;do{B=(k[o+(a<<2)>>2]|0)+(b<<3)|0;C=+p[B>>3];j=C<j?C:j;C=+p[B+8>>3];i=C<i?C:i;C=+p[B+16>>3];h=C<h?C:h;C=+p[B+24>>3];g=C<g?C:g;a=a+1|0}while((a|0)!=(A|0));a=n+(b<<3)|0;C=+p[a>>3];p[c+(b<<3)>>3]=C<j?C:j;C=+p[a+8>>3];p[c+((b|1)<<3)>>3]=C<i?C:i;C=+p[a+16>>3];p[c+((b|2)<<3)>>3]=C<h?C:h;C=+p[a+24>>3];p[c+((b|3)<<3)>>3]=C<g?C:g;a=l+(b<<3)|0;C=+p[a>>3];B=b+y|0;p[c+(B<<3)>>3]=C<j?C:j;C=+p[a+8>>3];p[c+(B+1<<3)>>3]=C<i?C:i;C=+p[a+16>>3];p[c+(B+2<<3)>>3]=C<h?C:h;C=+p[a+24>>3];p[c+(B+3<<3)>>3]=C<g?C:g;b=b+4|0}while((b|0)<=(q|0));a=u}while(0);b:do if((a|0)<(f|0)){m=k[o+4>>2]|0;n=k[o>>2]|0;if(!s){b=k[o+8>>2]|0;while(1){C=+p[m+(a<<3)>>3];j=+p[n+(a<<3)>>3];p[c+(a<<3)>>3]=j<C?j:C;j=+p[b+(a<<3)>>3];p[c+(a+y<<3)>>3]=j<C?j:C;a=a+1|0;if((a|0)==(f|0))break b}}l=k[o+(A<<2)>>2]|0;do{g=+p[m+(a<<3)>>3];b=2;do{C=+p[(k[o+(b<<2)>>2]|0)+(a<<3)>>3];g=C<g?C:g;b=b+1|0}while((b|0)!=(A|0));C=+p[n+(a<<3)>>3];p[c+(a<<3)>>3]=C<g?C:g;C=+p[l+(a<<3)>>3];p[c+(a+y<<3)>>3]=C<g?C:g;a=a+1|0}while((a|0)!=(f|0))}while(0);e=e+-2|0;if((e|0)<=1)break;else{c=c+(t<<3)|0;o=o+8|0}}c=v;a=w-x|0}else{d=b;a=e}if((a|0)<=0)return;m=f+-4|0;n=(f|0)<4;o=f&-4;l=d;e=c;while(1){c:do if(n)d=0;else{b=k[l>>2]|0;if(z)d=0;else{d=0;while(1){B=b+(d<<3)|0;i=+p[B+8>>3];j=+p[B+16>>3];C=+p[B+24>>3];p[e+(d<<3)>>3]=+p[B>>3];p[e+((d|1)<<3)>>3]=i;p[e+((d|2)<<3)>>3]=j;p[e+((d|3)<<3)>>3]=C;d=d+4|0;if((d|0)>(m|0)){d=o;break c}}}do{c=b+(d<<3)|0;g=+p[c+24>>3];h=+p[c+16>>3];i=+p[c+8>>3];j=+p[c>>3];c=1;do{B=(k[l+(c<<2)>>2]|0)+(d<<3)|0;C=+p[B>>3];j=C<j?C:j;C=+p[B+8>>3];i=C<i?C:i;C=+p[B+16>>3];h=C<h?C:h;C=+p[B+24>>3];g=C<g?C:g;c=c+1|0}while((c|0)!=(A|0));p[e+(d<<3)>>3]=j;p[e+((d|1)<<3)>>3]=i;p[e+((d|2)<<3)>>3]=h;p[e+((d|3)<<3)>>3]=g;d=d+4|0}while((d|0)<=(m|0));d=o}while(0);d:do if((d|0)<(f|0)){b=k[l>>2]|0;if(!z)while(1){p[e+(d<<3)>>3]=+p[b+(d<<3)>>3];d=d+1|0;if((d|0)==(f|0))break d}do{g=+p[b+(d<<3)>>3];c=1;do{C=+p[(k[l+(c<<2)>>2]|0)+(d<<3)>>3];g=C<g?C:g;c=c+1|0}while((c|0)!=(A|0));p[e+(d<<3)>>3]=g;d=d+1|0}while((d|0)!=(f|0))}while(0);if((a|0)>1){l=l+4|0;a=a+-1|0;e=e+(y<<3)|0}else break}return}function pqa(a){a=a|0;ggb(a);return}function qqa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function rqa(a){a=a|0;ggb(a);return}function sqa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0.0,i=0.0,j=0.0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0;A=k[a+4>>2]|0;y=d>>>2;z=(A|0)>1;if(z&(e|0)>1){q=f+-4|0;r=(f|0)<4;s=(A|0)>2;t=y<<1;u=f&-4;w=e+-2|0;v=w>>>1;x=v<<1;v=c+(aa(y,(v<<3)+8|0)|0)|0;d=b+(x+2<<2)|0;p=b;while(1){a:do if(r)a=0;else{m=k[p+4>>2]|0;n=k[p>>2]|0;if(!s){b=k[p+8>>2]|0;a=0;while(1){B=m+(a<<2)|0;g=+o[B>>2];h=+o[B+4>>2];i=+o[B+8>>2];j=+o[B+12>>2];B=n+(a<<2)|0;C=+o[B>>2];o[c+(a<<2)>>2]=C<g?C:g;C=+o[B+4>>2];o[c+((a|1)<<2)>>2]=C<h?C:h;C=+o[B+8>>2];o[c+((a|2)<<2)>>2]=C<i?C:i;C=+o[B+12>>2];o[c+((a|3)<<2)>>2]=C<j?C:j;B=b+(a<<2)|0;C=+o[B>>2];l=a+y|0;o[c+(l<<2)>>2]=C<g?C:g;g=+o[B+4>>2];o[c+(l+1<<2)>>2]=g<h?g:h;h=+o[B+8>>2];o[c+(l+2<<2)>>2]=h<i?h:i;i=+o[B+12>>2];o[c+(l+3<<2)>>2]=i<j?i:j;a=a+4|0;if((a|0)>(q|0)){a=u;break a}}}l=k[p+(A<<2)>>2]|0;b=0;do{a=m+(b<<2)|0;g=+o[a+12>>2];h=+o[a+8>>2];i=+o[a+4>>2];j=+o[a>>2];a=2;do{B=(k[p+(a<<2)>>2]|0)+(b<<2)|0;C=+o[B>>2];j=C<j?C:j;C=+o[B+4>>2];i=C<i?C:i;C=+o[B+8>>2];h=C<h?C:h;C=+o[B+12>>2];g=C<g?C:g;a=a+1|0}while((a|0)!=(A|0));a=n+(b<<2)|0;C=+o[a>>2];o[c+(b<<2)>>2]=C<j?C:j;C=+o[a+4>>2];o[c+((b|1)<<2)>>2]=C<i?C:i;C=+o[a+8>>2];o[c+((b|2)<<2)>>2]=C<h?C:h;C=+o[a+12>>2];o[c+((b|3)<<2)>>2]=C<g?C:g;a=l+(b<<2)|0;C=+o[a>>2];B=b+y|0;o[c+(B<<2)>>2]=C<j?C:j;C=+o[a+4>>2];o[c+(B+1<<2)>>2]=C<i?C:i;C=+o[a+8>>2];o[c+(B+2<<2)>>2]=C<h?C:h;C=+o[a+12>>2];o[c+(B+3<<2)>>2]=C<g?C:g;b=b+4|0}while((b|0)<=(q|0));a=u}while(0);b:do if((a|0)<(f|0)){m=k[p+4>>2]|0;n=k[p>>2]|0;if(!s){b=k[p+8>>2]|0;while(1){C=+o[m+(a<<2)>>2];j=+o[n+(a<<2)>>2];o[c+(a<<2)>>2]=j<C?j:C;j=+o[b+(a<<2)>>2];o[c+(a+y<<2)>>2]=j<C?j:C;a=a+1|0;if((a|0)==(f|0))break b}}l=k[p+(A<<2)>>2]|0;do{g=+o[m+(a<<2)>>2];b=2;do{C=+o[(k[p+(b<<2)>>2]|0)+(a<<2)>>2];g=C<g?C:g;b=b+1|0}while((b|0)!=(A|0));C=+o[n+(a<<2)>>2];o[c+(a<<2)>>2]=C<g?C:g;C=+o[l+(a<<2)>>2];o[c+(a+y<<2)>>2]=C<g?C:g;a=a+1|0}while((a|0)!=(f|0))}while(0);e=e+-2|0;if((e|0)<=1)break;else{c=c+(t<<2)|0;p=p+8|0}}c=v;a=w-x|0}else{d=b;a=e}if((a|0)<=0)return;m=f+-4|0;n=(f|0)<4;p=f&-4;l=d;e=c;while(1){c:do if(n)d=0;else{b=k[l>>2]|0;if(z)d=0;else{d=0;while(1){v=b+(d<<2)|0;w=k[v+4>>2]|0;x=k[v+8>>2]|0;B=k[v+12>>2]|0;k[e+(d<<2)>>2]=k[v>>2];k[e+((d|1)<<2)>>2]=w;k[e+((d|2)<<2)>>2]=x;k[e+((d|3)<<2)>>2]=B;d=d+4|0;if((d|0)>(m|0)){d=p;break c}}}do{c=b+(d<<2)|0;g=+o[c+12>>2];h=+o[c+8>>2];i=+o[c+4>>2];j=+o[c>>2];c=1;do{B=(k[l+(c<<2)>>2]|0)+(d<<2)|0;C=+o[B>>2];j=C<j?C:j;C=+o[B+4>>2];i=C<i?C:i;C=+o[B+8>>2];h=C<h?C:h;C=+o[B+12>>2];g=C<g?C:g;c=c+1|0}while((c|0)!=(A|0));o[e+(d<<2)>>2]=j;o[e+((d|1)<<2)>>2]=i;o[e+((d|2)<<2)>>2]=h;o[e+((d|3)<<2)>>2]=g;d=d+4|0}while((d|0)<=(m|0));d=p}while(0);d:do if((d|0)<(f|0)){b=k[l>>2]|0;if(!z)while(1){k[e+(d<<2)>>2]=k[b+(d<<2)>>2];d=d+1|0;if((d|0)==(f|0))break d}do{g=+o[b+(d<<2)>>2];c=1;do{C=+o[(k[l+(c<<2)>>2]|0)+(d<<2)>>2];g=C<g?C:g;c=c+1|0}while((c|0)!=(A|0));o[e+(d<<2)>>2]=g;d=d+1|0}while((d|0)!=(f|0))}while(0);if((a|0)>1){l=l+4|0;a=a+-1|0;e=e+(y<<2)|0}else break}return}function tqa(a){a=a|0;ggb(a);return}function uqa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function vqa(a){a=a|0;ggb(a);return}function wqa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;A=k[a+4>>2]|0;y=d>>>1;z=(A|0)>1;if(z&(e|0)>1){q=f+-4|0;r=(f|0)<4;s=(A|0)>2;t=y<<1;u=f&-4;w=e+-2|0;v=w>>>1;x=v<<1;v=c+(aa(y,(v<<2)+4|0)|0)|0;d=b+(x+2<<2)|0;p=b;o=e;while(1){a:do if(r)a=0;else{m=k[p+4>>2]|0;n=k[p>>2]|0;if(!s){b=k[p+8>>2]|0;a=0;while(1){i=m+(a<<1)|0;B=j[i>>1]|0;e=j[i+2>>1]|0;g=j[i+4>>1]|0;i=j[i+6>>1]|0;h=n+(a<<1)|0;C=j[h>>1]|0;j[c+(a<<1)>>1]=C<<16>>16<B<<16>>16?C:B;C=j[h+2>>1]|0;j[c+((a|1)<<1)>>1]=C<<16>>16<e<<16>>16?C:e;C=j[h+4>>1]|0;j[c+((a|2)<<1)>>1]=C<<16>>16<g<<16>>16?C:g;h=j[h+6>>1]|0;j[c+((a|3)<<1)>>1]=h<<16>>16<i<<16>>16?h:i;h=b+(a<<1)|0;C=j[h>>1]|0;l=a+y|0;j[c+(l<<1)>>1]=C<<16>>16<B<<16>>16?C:B;B=j[h+2>>1]|0;j[c+(l+1<<1)>>1]=B<<16>>16<e<<16>>16?B:e;e=j[h+4>>1]|0;j[c+(l+2<<1)>>1]=e<<16>>16<g<<16>>16?e:g;h=j[h+6>>1]|0;j[c+(l+3<<1)>>1]=h<<16>>16<i<<16>>16?h:i;a=a+4|0;if((a|0)>(q|0)){a=u;break a}}}l=k[p+(A<<2)>>2]|0;i=0;do{g=m+(i<<1)|0;a=j[g+6>>1]|0;b=j[g+4>>1]|0;e=j[g+2>>1]|0;g=j[g>>1]|0;h=2;do{C=(k[p+(h<<2)>>2]|0)+(i<<1)|0;B=j[C>>1]|0;g=B<<16>>16<g<<16>>16?B:g;B=j[C+2>>1]|0;e=B<<16>>16<e<<16>>16?B:e;B=j[C+4>>1]|0;b=B<<16>>16<b<<16>>16?B:b;C=j[C+6>>1]|0;a=C<<16>>16<a<<16>>16?C:a;h=h+1|0}while((h|0)!=(A|0));B=n+(i<<1)|0;h=j[B>>1]|0;j[c+(i<<1)>>1]=h<<16>>16<g<<16>>16?h:g;h=j[B+2>>1]|0;j[c+((i|1)<<1)>>1]=h<<16>>16<e<<16>>16?h:e;h=j[B+4>>1]|0;j[c+((i|2)<<1)>>1]=h<<16>>16<b<<16>>16?h:b;B=j[B+6>>1]|0;j[c+((i|3)<<1)>>1]=B<<16>>16<a<<16>>16?B:a;B=l+(i<<1)|0;h=j[B>>1]|0;C=i+y|0;j[c+(C<<1)>>1]=h<<16>>16<g<<16>>16?h:g;h=j[B+2>>1]|0;j[c+(C+1<<1)>>1]=h<<16>>16<e<<16>>16?h:e;h=j[B+4>>1]|0;j[c+(C+2<<1)>>1]=h<<16>>16<b<<16>>16?h:b;B=j[B+6>>1]|0;j[c+(C+3<<1)>>1]=B<<16>>16<a<<16>>16?B:a;i=i+4|0}while((i|0)<=(q|0));a=u}while(0);b:do if((a|0)<(f|0)){h=k[p+4>>2]|0;i=k[p>>2]|0;if(!s){b=k[p+8>>2]|0;while(1){C=j[h+(a<<1)>>1]|0;B=j[i+(a<<1)>>1]|0;j[c+(a<<1)>>1]=B<<16>>16<C<<16>>16?B:C;B=j[b+(a<<1)>>1]|0;j[c+(a+y<<1)>>1]=B<<16>>16<C<<16>>16?B:C;a=a+1|0;if((a|0)==(f|0))break b}}g=k[p+(A<<2)>>2]|0;do{b=j[h+(a<<1)>>1]|0;e=2;do{C=j[(k[p+(e<<2)>>2]|0)+(a<<1)>>1]|0;b=C<<16>>16<b<<16>>16?C:b;e=e+1|0}while((e|0)!=(A|0));C=j[i+(a<<1)>>1]|0;j[c+(a<<1)>>1]=C<<16>>16<b<<16>>16?C:b;C=j[g+(a<<1)>>1]|0;j[c+(a+y<<1)>>1]=C<<16>>16<b<<16>>16?C:b;a=a+1|0}while((a|0)!=(f|0))}while(0);o=o+-2|0;if((o|0)<=1)break;else{c=c+(t<<1)|0;p=p+8|0}}c=v;a=w-x|0}else{d=b;a=e}if((a|0)<=0)return;n=f+-4|0;o=(f|0)<4;p=f&-4;m=d;l=c;while(1){c:do if(o)d=0;else{i=k[m>>2]|0;if(z)g=0;else{d=0;while(1){w=i+(d<<1)|0;x=j[w+2>>1]|0;B=j[w+4>>1]|0;C=j[w+6>>1]|0;j[l+(d<<1)>>1]=j[w>>1]|0;j[l+((d|1)<<1)>>1]=x;j[l+((d|2)<<1)>>1]=B;j[l+((d|3)<<1)>>1]=C;d=d+4|0;if((d|0)>(n|0)){d=p;break c}}}do{e=i+(g<<1)|0;d=j[e+6>>1]|0;c=j[e+4>>1]|0;b=j[e+2>>1]|0;e=j[e>>1]|0;h=1;do{C=(k[m+(h<<2)>>2]|0)+(g<<1)|0;B=j[C>>1]|0;e=B<<16>>16<e<<16>>16?B:e;B=j[C+2>>1]|0;b=B<<16>>16<b<<16>>16?B:b;B=j[C+4>>1]|0;c=B<<16>>16<c<<16>>16?B:c;C=j[C+6>>1]|0;d=C<<16>>16<d<<16>>16?C:d;h=h+1|0}while((h|0)!=(A|0));j[l+(g<<1)>>1]=e;j[l+((g|1)<<1)>>1]=b;j[l+((g|2)<<1)>>1]=c;j[l+((g|3)<<1)>>1]=d;g=g+4|0}while((g|0)<=(n|0));d=p}while(0);d:do if((d|0)<(f|0)){e=k[m>>2]|0;if(!z)while(1){j[l+(d<<1)>>1]=j[e+(d<<1)>>1]|0;d=d+1|0;if((d|0)==(f|0))break d}do{c=j[e+(d<<1)>>1]|0;b=1;do{C=j[(k[m+(b<<2)>>2]|0)+(d<<1)>>1]|0;c=C<<16>>16<c<<16>>16?C:c;b=b+1|0}while((b|0)!=(A|0));j[l+(d<<1)>>1]=c;d=d+1|0}while((d|0)!=(f|0))}while(0);if((a|0)>1){m=m+4|0;a=a+-1|0;l=l+(y<<1)|0}else break}return}function xqa(a){a=a|0;ggb(a);return}function yqa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function zqa(a){a=a|0;ggb(a);return}function Aqa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;A=k[a+4>>2]|0;y=d>>>1;z=(A|0)>1;if(z&(e|0)>1){q=f+-4|0;r=(f|0)<4;s=(A|0)>2;t=y<<1;u=f&-4;w=e+-2|0;v=w>>>1;x=v<<1;v=c+(aa(y,(v<<2)+4|0)|0)|0;d=b+(x+2<<2)|0;p=b;o=e;while(1){a:do if(r)a=0;else{m=k[p+4>>2]|0;n=k[p>>2]|0;if(!s){b=k[p+8>>2]|0;a=0;while(1){i=m+(a<<1)|0;B=j[i>>1]|0;e=j[i+2>>1]|0;g=j[i+4>>1]|0;i=j[i+6>>1]|0;h=n+(a<<1)|0;C=j[h>>1]|0;j[c+(a<<1)>>1]=(C&65535)<(B&65535)?C:B;C=j[h+2>>1]|0;j[c+((a|1)<<1)>>1]=(C&65535)<(e&65535)?C:e;C=j[h+4>>1]|0;j[c+((a|2)<<1)>>1]=(C&65535)<(g&65535)?C:g;h=j[h+6>>1]|0;j[c+((a|3)<<1)>>1]=(h&65535)<(i&65535)?h:i;h=b+(a<<1)|0;C=j[h>>1]|0;l=a+y|0;j[c+(l<<1)>>1]=(C&65535)<(B&65535)?C:B;B=j[h+2>>1]|0;j[c+(l+1<<1)>>1]=(B&65535)<(e&65535)?B:e;e=j[h+4>>1]|0;j[c+(l+2<<1)>>1]=(e&65535)<(g&65535)?e:g;h=j[h+6>>1]|0;j[c+(l+3<<1)>>1]=(h&65535)<(i&65535)?h:i;a=a+4|0;if((a|0)>(q|0)){a=u;break a}}}l=k[p+(A<<2)>>2]|0;i=0;do{g=m+(i<<1)|0;a=j[g+6>>1]|0;b=j[g+4>>1]|0;e=j[g+2>>1]|0;g=j[g>>1]|0;h=2;do{C=(k[p+(h<<2)>>2]|0)+(i<<1)|0;B=j[C>>1]|0;g=(B&65535)<(g&65535)?B:g;B=j[C+2>>1]|0;e=(B&65535)<(e&65535)?B:e;B=j[C+4>>1]|0;b=(B&65535)<(b&65535)?B:b;C=j[C+6>>1]|0;a=(C&65535)<(a&65535)?C:a;h=h+1|0}while((h|0)!=(A|0));B=n+(i<<1)|0;h=j[B>>1]|0;j[c+(i<<1)>>1]=(h&65535)<(g&65535)?h:g;h=j[B+2>>1]|0;j[c+((i|1)<<1)>>1]=(h&65535)<(e&65535)?h:e;h=j[B+4>>1]|0;j[c+((i|2)<<1)>>1]=(h&65535)<(b&65535)?h:b;B=j[B+6>>1]|0;j[c+((i|3)<<1)>>1]=(B&65535)<(a&65535)?B:a;B=l+(i<<1)|0;h=j[B>>1]|0;C=i+y|0;j[c+(C<<1)>>1]=(h&65535)<(g&65535)?h:g;h=j[B+2>>1]|0;j[c+(C+1<<1)>>1]=(h&65535)<(e&65535)?h:e;h=j[B+4>>1]|0;j[c+(C+2<<1)>>1]=(h&65535)<(b&65535)?h:b;B=j[B+6>>1]|0;j[c+(C+3<<1)>>1]=(B&65535)<(a&65535)?B:a;i=i+4|0}while((i|0)<=(q|0));a=u}while(0);b:do if((a|0)<(f|0)){h=k[p+4>>2]|0;i=k[p>>2]|0;if(!s){b=k[p+8>>2]|0;while(1){C=j[h+(a<<1)>>1]|0;B=j[i+(a<<1)>>1]|0;j[c+(a<<1)>>1]=(B&65535)<(C&65535)?B:C;B=j[b+(a<<1)>>1]|0;j[c+(a+y<<1)>>1]=(B&65535)<(C&65535)?B:C;a=a+1|0;if((a|0)==(f|0))break b}}g=k[p+(A<<2)>>2]|0;do{b=j[h+(a<<1)>>1]|0;e=2;do{C=j[(k[p+(e<<2)>>2]|0)+(a<<1)>>1]|0;b=(C&65535)<(b&65535)?C:b;e=e+1|0}while((e|0)!=(A|0));C=j[i+(a<<1)>>1]|0;j[c+(a<<1)>>1]=(C&65535)<(b&65535)?C:b;C=j[g+(a<<1)>>1]|0;j[c+(a+y<<1)>>1]=(C&65535)<(b&65535)?C:b;a=a+1|0}while((a|0)!=(f|0))}while(0);o=o+-2|0;if((o|0)<=1)break;else{c=c+(t<<1)|0;p=p+8|0}}c=v;a=w-x|0}else{d=b;a=e}if((a|0)<=0)return;n=f+-4|0;o=(f|0)<4;p=f&-4;m=d;l=c;while(1){c:do if(o)d=0;else{i=k[m>>2]|0;if(z)g=0;else{d=0;while(1){w=i+(d<<1)|0;x=j[w+2>>1]|0;B=j[w+4>>1]|0;C=j[w+6>>1]|0;j[l+(d<<1)>>1]=j[w>>1]|0;j[l+((d|1)<<1)>>1]=x;j[l+((d|2)<<1)>>1]=B;j[l+((d|3)<<1)>>1]=C;d=d+4|0;if((d|0)>(n|0)){d=p;break c}}}do{e=i+(g<<1)|0;d=j[e+6>>1]|0;c=j[e+4>>1]|0;b=j[e+2>>1]|0;e=j[e>>1]|0;h=1;do{C=(k[m+(h<<2)>>2]|0)+(g<<1)|0;B=j[C>>1]|0;e=(B&65535)<(e&65535)?B:e;B=j[C+2>>1]|0;b=(B&65535)<(b&65535)?B:b;B=j[C+4>>1]|0;c=(B&65535)<(c&65535)?B:c;C=j[C+6>>1]|0;d=(C&65535)<(d&65535)?C:d;h=h+1|0}while((h|0)!=(A|0));j[l+(g<<1)>>1]=e;j[l+((g|1)<<1)>>1]=b;j[l+((g|2)<<1)>>1]=c;j[l+((g|3)<<1)>>1]=d;g=g+4|0}while((g|0)<=(n|0));d=p}while(0);d:do if((d|0)<(f|0)){e=k[m>>2]|0;if(!z)while(1){j[l+(d<<1)>>1]=j[e+(d<<1)>>1]|0;d=d+1|0;if((d|0)==(f|0))break d}do{c=j[e+(d<<1)>>1]|0;b=1;do{C=j[(k[m+(b<<2)>>2]|0)+(d<<1)>>1]|0;c=(C&65535)<(c&65535)?C:c;b=b+1|0}while((b|0)!=(A|0));j[l+(d<<1)>>1]=c;d=d+1|0}while((d|0)!=(f|0))}while(0);if((a|0)>1){m=m+4|0;a=a+-1|0;l=l+(y<<1)|0}else break}return}function Bqa(a){a=a|0;ggb(a);return}function Cqa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Dqa(a){a=a|0;ggb(a);return}function Eqa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;z=k[a+4>>2]|0;A=(z|0)>1;if(A&(e|0)>1){q=f+-4|0;r=(f|0)<4;s=(z|0)>2;t=d<<1;u=f&-4;x=e+-2|0;y=x&-2;w=y+2|0;v=c+(aa(w,d)|0)|0;p=b;o=e;while(1){if(r)a=0;else{n=p+4|0;m=0;do{a=(k[n>>2]|0)+m|0;e=i[a>>0]|0;h=i[a+1>>0]|0;g=i[a+2>>0]|0;a=i[a+3>>0]|0;if(s){j=2;do{B=(k[p+(j<<2)>>2]|0)+m|0;e=e&255;e=e-(l[352559+((e|256)-(l[B>>0]|0))>>0]|0)&255;h=h&255;h=h-(l[352559+((h|256)-(l[B+1>>0]|0))>>0]|0)&255;g=g&255;g=g-(l[352559+((g|256)-(l[B+2>>0]|0))>>0]|0)&255;a=a&255;a=a-(l[352559+((a|256)-(l[B+3>>0]|0))>>0]|0)&255;j=j+1|0}while((j|0)!=(z|0));j=g;g=z}else{j=g;g=2}B=(k[p>>2]|0)+m|0;H=e&255;G=H|256;i[c+m>>0]=H-(l[352559+(G-(l[B>>0]|0))>>0]|0);F=h&255;E=F|256;i[c+(m|1)>>0]=F-(l[352559+(E-(l[B+1>>0]|0))>>0]|0);D=j&255;C=D|256;i[c+(m|2)>>0]=D-(l[352559+(C-(l[B+2>>0]|0))>>0]|0);e=a&255;h=e|256;i[c+(m|3)>>0]=e-(l[352559+(h-(l[B+3>>0]|0))>>0]|0);j=(k[p+(g<<2)>>2]|0)+m|0;B=m+d|0;i[c+B>>0]=H-(l[352559+(G-(l[j>>0]|0))>>0]|0);i[c+(B+1)>>0]=F-(l[352559+(E-(l[j+1>>0]|0))>>0]|0);i[c+(B+2)>>0]=D-(l[352559+(C-(l[j+2>>0]|0))>>0]|0);i[c+(B+3)>>0]=e-(l[352559+(h-(l[j+3>>0]|0))>>0]|0);m=m+4|0}while((m|0)<=(q|0));a=u}a:do if((a|0)<(f|0)){j=p+4|0;if(!s){e=p+8|0;while(1){G=l[(k[j>>2]|0)+a>>0]|0;H=G|256;i[c+a>>0]=G-(l[352559+(H-(l[(k[p>>2]|0)+a>>0]|0))>>0]|0);i[c+(a+d)>>0]=G-(l[352559+(H-(l[(k[e>>2]|0)+a>>0]|0))>>0]|0);a=a+1|0;if((a|0)==(f|0))break a}}h=p+(z<<2)|0;do{e=i[(k[j>>2]|0)+a>>0]|0;g=2;while(1){e=e&255;e=e-(l[352559+((e|256)-(l[(k[p+(g<<2)>>2]|0)+a>>0]|0))>>0]|0)|0;g=g+1|0;if((g|0)==(z|0))break;else e=e&255}H=e&255|256;i[c+a>>0]=e-(l[352559+(H-(l[(k[p>>2]|0)+a>>0]|0))>>0]|0);i[c+(a+d)>>0]=e-(l[352559+(H-(l[(k[h>>2]|0)+a>>0]|0))>>0]|0);a=a+1|0}while((a|0)!=(f|0))}while(0);o=o+-2|0;if((o|0)<=1)break;else{c=c+t|0;p=p+8|0}}c=v;b=b+(w<<2)|0;a=x-y|0}else a=e;if((a|0)<=0)return;o=f+-4|0;p=(f|0)<4;q=f&-4;n=b;m=c;while(1){b:do if(p)b=0;else{if(A)h=0;else{b=0;while(1){E=(k[n>>2]|0)+b|0;F=i[E+1>>0]|0;G=i[E+2>>0]|0;H=i[E+3>>0]|0;i[m+b>>0]=i[E>>0]|0;i[m+(b|1)>>0]=F;i[m+(b|2)>>0]=G;i[m+(b|3)>>0]=H;b=b+4|0;if((b|0)>(o|0)){b=q;break b}}}do{g=(k[n>>2]|0)+h|0;b=i[g+3>>0]|0;c=i[g+2>>0]|0;e=i[g+1>>0]|0;g=i[g>>0]|0;j=1;do{H=(k[n+(j<<2)>>2]|0)+h|0;G=g&255;g=G-(l[352559+((G|256)-(l[H>>0]|0))>>0]|0)&255;G=e&255;e=G-(l[352559+((G|256)-(l[H+1>>0]|0))>>0]|0)&255;G=c&255;c=G-(l[352559+((G|256)-(l[H+2>>0]|0))>>0]|0)&255;G=b&255;b=G-(l[352559+((G|256)-(l[H+3>>0]|0))>>0]|0)&255;j=j+1|0}while((j|0)!=(z|0));i[m+h>>0]=g;i[m+(h|1)>>0]=e;i[m+(h|2)>>0]=c;i[m+(h|3)>>0]=b;h=h+4|0}while((h|0)<=(o|0));b=q}while(0);c:do if((b|0)<(f|0)){if(!A)while(1){i[m+b>>0]=i[(k[n>>2]|0)+b>>0]|0;b=b+1|0;if((b|0)==(f|0))break c}do{c=i[(k[n>>2]|0)+b>>0]|0;e=1;do{H=c&255;c=H-(l[352559+((H|256)-(l[(k[n+(e<<2)>>2]|0)+b>>0]|0))>>0]|0)&255;e=e+1|0}while((e|0)!=(z|0));i[m+b>>0]=c;b=b+1|0}while((b|0)!=(f|0))}while(0);if((a|0)>1){n=n+4|0;a=a+-1|0;m=m+d|0}else break}return}function Fqa(a){a=a|0;ggb(a);return}function Gqa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Hqa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=87876;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function Iqa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=87876;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Jqa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;w=k[a+20>>2]|0;v=k[a+32>>2]|0;a=(k[a+24>>2]|0)-w|0;u=a>>3;q=aa(g,f)|0;if((e|0)<=0)return;r=(a|0)>0;s=q+-4|0;t=(q|0)<4;n=(a|0)>8;o=q&-4;while(1){if(r){a=0;do{i=(k[b+(k[w+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[w+(a<<3)>>2]|0,g)|0)<<3)|0;k[v+(a<<2)>>2]=i;a=a+1|0}while((a|0)<(u|0))}a:do if(t)a=0;else{i=k[v>>2]|0;if(n)a=0;else{a=0;while(1){f=i+(a<<3)|0;j=+p[f+8>>3];l=+p[f+16>>3];m=+p[f+24>>3];p[c+(a<<3)>>3]=+p[f>>3];p[c+((a|1)<<3)>>3]=j;p[c+((a|2)<<3)>>3]=l;p[c+((a|3)<<3)>>3]=m;a=a+4|0;if((a|0)>(s|0)){a=o;break a}}}do{f=i+(a<<3)|0;h=+p[f+24>>3];j=+p[f+16>>3];l=+p[f+8>>3];m=+p[f>>3];f=1;do{y=(k[v+(f<<2)>>2]|0)+(a<<3)|0;x=+p[y>>3];m=m<x?x:m;x=+p[y+8>>3];l=l<x?x:l;x=+p[y+16>>3];j=j<x?x:j;x=+p[y+24>>3];h=h<x?x:h;f=f+1|0}while((f|0)<(u|0));p[c+(a<<3)>>3]=m;p[c+((a|1)<<3)>>3]=l;p[c+((a|2)<<3)>>3]=j;p[c+((a|3)<<3)>>3]=h;a=a+4|0}while((a|0)<=(s|0));a=o}while(0);b:do if((a|0)<(q|0)){i=k[v>>2]|0;if(!n)while(1){p[c+(a<<3)>>3]=+p[i+(a<<3)>>3];a=a+1|0;if((a|0)==(q|0))break b}do{h=+p[i+(a<<3)>>3];f=1;do{x=+p[(k[v+(f<<2)>>2]|0)+(a<<3)>>3];h=h<x?x:h;f=f+1|0}while((f|0)<(u|0));p[c+(a<<3)>>3]=h;a=a+1|0}while((a|0)!=(q|0))}while(0);if((e|0)>1){e=e+-1|0;b=b+4|0;c=c+d|0}else break}return}function Kqa(a){a=a|0;ggb(a);return}function Lqa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Mqa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=87900;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function Nqa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=87900;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Oqa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,l=0.0,m=0.0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;w=k[a+20>>2]|0;v=k[a+32>>2]|0;a=(k[a+24>>2]|0)-w|0;u=a>>3;q=aa(g,f)|0;if((e|0)<=0)return;r=(a|0)>0;s=q+-4|0;t=(q|0)<4;n=(a|0)>8;p=q&-4;while(1){if(r){a=0;do{i=(k[b+(k[w+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[w+(a<<3)>>2]|0,g)|0)<<2)|0;k[v+(a<<2)>>2]=i;a=a+1|0}while((a|0)<(u|0))}a:do if(t)a=0;else{i=k[v>>2]|0;if(n)a=0;else{a=0;while(1){z=i+(a<<2)|0;y=k[z+4>>2]|0;x=k[z+8>>2]|0;f=k[z+12>>2]|0;k[c+(a<<2)>>2]=k[z>>2];k[c+((a|1)<<2)>>2]=y;k[c+((a|2)<<2)>>2]=x;k[c+((a|3)<<2)>>2]=f;a=a+4|0;if((a|0)>(s|0)){a=p;break a}}}do{f=i+(a<<2)|0;h=+o[f+12>>2];j=+o[f+8>>2];l=+o[f+4>>2];m=+o[f>>2];f=1;do{z=(k[v+(f<<2)>>2]|0)+(a<<2)|0;A=+o[z>>2];m=m<A?A:m;A=+o[z+4>>2];l=l<A?A:l;A=+o[z+8>>2];j=j<A?A:j;A=+o[z+12>>2];h=h<A?A:h;f=f+1|0}while((f|0)<(u|0));o[c+(a<<2)>>2]=m;o[c+((a|1)<<2)>>2]=l;o[c+((a|2)<<2)>>2]=j;o[c+((a|3)<<2)>>2]=h;a=a+4|0}while((a|0)<=(s|0));a=p}while(0);b:do if((a|0)<(q|0)){i=k[v>>2]|0;if(!n)while(1){k[c+(a<<2)>>2]=k[i+(a<<2)>>2];a=a+1|0;if((a|0)==(q|0))break b}do{h=+o[i+(a<<2)>>2];f=1;do{A=+o[(k[v+(f<<2)>>2]|0)+(a<<2)>>2];h=h<A?A:h;f=f+1|0}while((f|0)<(u|0));o[c+(a<<2)>>2]=h;a=a+1|0}while((a|0)!=(q|0))}while(0);if((e|0)>1){e=e+-1|0;b=b+4|0;c=c+d|0}else break}return}function Pqa(a){a=a|0;ggb(a);return}function Qqa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Rqa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=87924;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function Sqa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=87924;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Tqa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;w=k[a+20>>2]|0;v=k[a+32>>2]|0;a=(k[a+24>>2]|0)-w|0;u=a>>3;q=aa(g,f)|0;if((e|0)<=0)return;r=(a|0)>0;s=q+-4|0;t=(q|0)<4;o=(a|0)>8;p=q&-4;n=b;while(1){if(r){a=0;do{m=(k[n+(k[w+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[w+(a<<3)>>2]|0,g)|0)<<1)|0;k[v+(a<<2)>>2]=m;a=a+1|0}while((a|0)<(u|0))}a:do if(t)a=0;else{m=k[v>>2]|0;if(o)a=0;else{a=0;while(1){b=m+(a<<1)|0;h=j[b+2>>1]|0;i=j[b+4>>1]|0;l=j[b+6>>1]|0;j[c+(a<<1)>>1]=j[b>>1]|0;j[c+((a|1)<<1)>>1]=h;j[c+((a|2)<<1)>>1]=i;j[c+((a|3)<<1)>>1]=l;a=a+4|0;if((a|0)>(s|0)){a=p;break a}}}do{i=m+(a<<1)|0;f=j[i+6>>1]|0;b=j[i+4>>1]|0;h=j[i+2>>1]|0;i=j[i>>1]|0;l=1;do{x=(k[v+(l<<2)>>2]|0)+(a<<1)|0;y=j[x>>1]|0;i=i<<16>>16<y<<16>>16?y:i;y=j[x+2>>1]|0;h=h<<16>>16<y<<16>>16?y:h;y=j[x+4>>1]|0;b=b<<16>>16<y<<16>>16?y:b;x=j[x+6>>1]|0;f=f<<16>>16<x<<16>>16?x:f;l=l+1|0}while((l|0)<(u|0));j[c+(a<<1)>>1]=i;j[c+((a|1)<<1)>>1]=h;j[c+((a|2)<<1)>>1]=b;j[c+((a|3)<<1)>>1]=f;a=a+4|0}while((a|0)<=(s|0));a=p}while(0);b:do if((a|0)<(q|0)){h=k[v>>2]|0;if(!o)while(1){j[c+(a<<1)>>1]=j[h+(a<<1)>>1]|0;a=a+1|0;if((a|0)==(q|0))break b}do{f=j[h+(a<<1)>>1]|0;b=1;do{y=j[(k[v+(b<<2)>>2]|0)+(a<<1)>>1]|0;f=f<<16>>16<y<<16>>16?y:f;b=b+1|0}while((b|0)<(u|0));j[c+(a<<1)>>1]=f;a=a+1|0}while((a|0)!=(q|0))}while(0);if((e|0)>1){e=e+-1|0;n=n+4|0;c=c+d|0}else break}return}function Uqa(a){a=a|0;ggb(a);return}function Vqa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Wqa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=87948;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function Xqa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=87948;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Yqa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;w=k[a+20>>2]|0;v=k[a+32>>2]|0;a=(k[a+24>>2]|0)-w|0;u=a>>3;q=aa(g,f)|0;if((e|0)<=0)return;r=(a|0)>0;s=q+-4|0;t=(q|0)<4;o=(a|0)>8;p=q&-4;n=b;while(1){if(r){a=0;do{m=(k[n+(k[w+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[w+(a<<3)>>2]|0,g)|0)<<1)|0;k[v+(a<<2)>>2]=m;a=a+1|0}while((a|0)<(u|0))}a:do if(t)a=0;else{m=k[v>>2]|0;if(o)a=0;else{a=0;while(1){b=m+(a<<1)|0;h=j[b+2>>1]|0;i=j[b+4>>1]|0;l=j[b+6>>1]|0;j[c+(a<<1)>>1]=j[b>>1]|0;j[c+((a|1)<<1)>>1]=h;j[c+((a|2)<<1)>>1]=i;j[c+((a|3)<<1)>>1]=l;a=a+4|0;if((a|0)>(s|0)){a=p;break a}}}do{i=m+(a<<1)|0;f=j[i+6>>1]|0;b=j[i+4>>1]|0;h=j[i+2>>1]|0;i=j[i>>1]|0;l=1;do{x=(k[v+(l<<2)>>2]|0)+(a<<1)|0;y=j[x>>1]|0;i=(i&65535)<(y&65535)?y:i;y=j[x+2>>1]|0;h=(h&65535)<(y&65535)?y:h;y=j[x+4>>1]|0;b=(b&65535)<(y&65535)?y:b;x=j[x+6>>1]|0;f=(f&65535)<(x&65535)?x:f;l=l+1|0}while((l|0)<(u|0));j[c+(a<<1)>>1]=i;j[c+((a|1)<<1)>>1]=h;j[c+((a|2)<<1)>>1]=b;j[c+((a|3)<<1)>>1]=f;a=a+4|0}while((a|0)<=(s|0));a=p}while(0);b:do if((a|0)<(q|0)){h=k[v>>2]|0;if(!o)while(1){j[c+(a<<1)>>1]=j[h+(a<<1)>>1]|0;a=a+1|0;if((a|0)==(q|0))break b}do{f=j[h+(a<<1)>>1]|0;b=1;do{y=j[(k[v+(b<<2)>>2]|0)+(a<<1)>>1]|0;f=(f&65535)<(y&65535)?y:f;b=b+1|0}while((b|0)<(u|0));j[c+(a<<1)>>1]=f;a=a+1|0}while((a|0)!=(q|0))}while(0);if((e|0)>1){e=e+-1|0;n=n+4|0;c=c+d|0}else break}return}function Zqa(a){a=a|0;ggb(a);return}function _qa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function $qa(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=87972;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function ara(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=87972;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function bra(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;w=k[a+20>>2]|0;v=k[a+32>>2]|0;a=(k[a+24>>2]|0)-w|0;u=a>>3;q=aa(g,f)|0;if((e|0)<=0)return;r=(a|0)>0;s=q+-4|0;t=(q|0)<4;o=(a|0)>8;p=q&-4;n=b;while(1){if(r){a=0;do{m=(k[n+(k[w+(a<<3)+4>>2]<<2)>>2]|0)+(aa(k[w+(a<<3)>>2]|0,g)|0)|0;k[v+(a<<2)>>2]=m;a=a+1|0}while((a|0)<(u|0))}a:do if(t)a=0;else{if(o)j=0;else{a=0;while(1){b=(k[v>>2]|0)+a|0;h=i[b+1>>0]|0;j=i[b+2>>0]|0;m=i[b+3>>0]|0;i[c+a>>0]=i[b>>0]|0;i[c+(a|1)>>0]=h;i[c+(a|2)>>0]=j;i[c+(a|3)>>0]=m;a=a+4|0;if((a|0)>(s|0)){a=p;break a}}}do{h=(k[v>>2]|0)+j|0;a=i[h+3>>0]|0;f=i[h+2>>0]|0;b=i[h+1>>0]|0;h=i[h>>0]|0;m=1;do{y=(k[v+(m<<2)>>2]|0)+j|0;x=h&255;h=(l[352559+(256-x+(l[y>>0]|0))>>0]|0)+x&255;x=b&255;b=(l[352559+(256-x+(l[y+1>>0]|0))>>0]|0)+x&255;x=f&255;f=(l[352559+(256-x+(l[y+2>>0]|0))>>0]|0)+x&255;x=a&255;a=(l[352559+(256-x+(l[y+3>>0]|0))>>0]|0)+x&255;m=m+1|0}while((m|0)<(u|0));i[c+j>>0]=h;i[c+(j|1)>>0]=b;i[c+(j|2)>>0]=f;i[c+(j|3)>>0]=a;j=j+4|0}while((j|0)<=(s|0));a=p}while(0);b:do if((a|0)<(q|0)){if(!o)while(1){i[c+a>>0]=i[(k[v>>2]|0)+a>>0]|0;a=a+1|0;if((a|0)==(q|0))break b}do{f=i[(k[v>>2]|0)+a>>0]|0;b=1;do{y=f&255;f=(l[352559+(256-y+(l[(k[v+(b<<2)>>2]|0)+a>>0]|0))>>0]|0)+y&255;b=b+1|0}while((b|0)<(u|0));i[c+a>>0]=f;a=a+1|0}while((a|0)!=(q|0))}while(0);if((e|0)>1){n=n+4|0;c=c+d|0;e=e+-1|0}else break}return}function cra(a){a=a|0;ggb(a);return}function dra(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function era(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=87996;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function fra(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=87996;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function gra(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;w=k[a+20>>2]|0;v=k[a+32>>2]|0;a=(k[a+24>>2]|0)-w|0;u=a>>3;q=aa(g,f)|0;if((e|0)<=0)return;r=(a|0)>0;s=q+-4|0;t=(q|0)<4;n=(a|0)>8;o=q&-4;while(1){if(r){a=0;do{i=(k[b+(k[w+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[w+(a<<3)>>2]|0,g)|0)<<3)|0;k[v+(a<<2)>>2]=i;a=a+1|0}while((a|0)<(u|0))}a:do if(t)a=0;else{i=k[v>>2]|0;if(n)a=0;else{a=0;while(1){f=i+(a<<3)|0;j=+p[f+8>>3];l=+p[f+16>>3];m=+p[f+24>>3];p[c+(a<<3)>>3]=+p[f>>3];p[c+((a|1)<<3)>>3]=j;p[c+((a|2)<<3)>>3]=l;p[c+((a|3)<<3)>>3]=m;a=a+4|0;if((a|0)>(s|0)){a=o;break a}}}do{f=i+(a<<3)|0;h=+p[f+24>>3];j=+p[f+16>>3];l=+p[f+8>>3];m=+p[f>>3];f=1;do{y=(k[v+(f<<2)>>2]|0)+(a<<3)|0;x=+p[y>>3];m=x<m?x:m;x=+p[y+8>>3];l=x<l?x:l;x=+p[y+16>>3];j=x<j?x:j;x=+p[y+24>>3];h=x<h?x:h;f=f+1|0}while((f|0)<(u|0));p[c+(a<<3)>>3]=m;p[c+((a|1)<<3)>>3]=l;p[c+((a|2)<<3)>>3]=j;p[c+((a|3)<<3)>>3]=h;a=a+4|0}while((a|0)<=(s|0));a=o}while(0);b:do if((a|0)<(q|0)){i=k[v>>2]|0;if(!n)while(1){p[c+(a<<3)>>3]=+p[i+(a<<3)>>3];a=a+1|0;if((a|0)==(q|0))break b}do{h=+p[i+(a<<3)>>3];f=1;do{x=+p[(k[v+(f<<2)>>2]|0)+(a<<3)>>3];h=x<h?x:h;f=f+1|0}while((f|0)<(u|0));p[c+(a<<3)>>3]=h;a=a+1|0}while((a|0)!=(q|0))}while(0);if((e|0)>1){e=e+-1|0;b=b+4|0;c=c+d|0}else break}return}function hra(a){a=a|0;ggb(a);return}function ira(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function jra(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=88020;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function kra(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=88020;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function lra(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,l=0.0,m=0.0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;w=k[a+20>>2]|0;v=k[a+32>>2]|0;a=(k[a+24>>2]|0)-w|0;u=a>>3;q=aa(g,f)|0;if((e|0)<=0)return;r=(a|0)>0;s=q+-4|0;t=(q|0)<4;n=(a|0)>8;p=q&-4;while(1){if(r){a=0;do{i=(k[b+(k[w+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[w+(a<<3)>>2]|0,g)|0)<<2)|0;k[v+(a<<2)>>2]=i;a=a+1|0}while((a|0)<(u|0))}a:do if(t)a=0;else{i=k[v>>2]|0;if(n)a=0;else{a=0;while(1){z=i+(a<<2)|0;y=k[z+4>>2]|0;x=k[z+8>>2]|0;f=k[z+12>>2]|0;k[c+(a<<2)>>2]=k[z>>2];k[c+((a|1)<<2)>>2]=y;k[c+((a|2)<<2)>>2]=x;k[c+((a|3)<<2)>>2]=f;a=a+4|0;if((a|0)>(s|0)){a=p;break a}}}do{f=i+(a<<2)|0;h=+o[f+12>>2];j=+o[f+8>>2];l=+o[f+4>>2];m=+o[f>>2];f=1;do{z=(k[v+(f<<2)>>2]|0)+(a<<2)|0;A=+o[z>>2];m=A<m?A:m;A=+o[z+4>>2];l=A<l?A:l;A=+o[z+8>>2];j=A<j?A:j;A=+o[z+12>>2];h=A<h?A:h;f=f+1|0}while((f|0)<(u|0));o[c+(a<<2)>>2]=m;o[c+((a|1)<<2)>>2]=l;o[c+((a|2)<<2)>>2]=j;o[c+((a|3)<<2)>>2]=h;a=a+4|0}while((a|0)<=(s|0));a=p}while(0);b:do if((a|0)<(q|0)){i=k[v>>2]|0;if(!n)while(1){k[c+(a<<2)>>2]=k[i+(a<<2)>>2];a=a+1|0;if((a|0)==(q|0))break b}do{h=+o[i+(a<<2)>>2];f=1;do{A=+o[(k[v+(f<<2)>>2]|0)+(a<<2)>>2];h=A<h?A:h;f=f+1|0}while((f|0)<(u|0));o[c+(a<<2)>>2]=h;a=a+1|0}while((a|0)!=(q|0))}while(0);if((e|0)>1){e=e+-1|0;b=b+4|0;c=c+d|0}else break}return}function mra(a){a=a|0;ggb(a);return}function nra(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function ora(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=88044;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function pra(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=88044;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function qra(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;w=k[a+20>>2]|0;v=k[a+32>>2]|0;a=(k[a+24>>2]|0)-w|0;u=a>>3;q=aa(g,f)|0;if((e|0)<=0)return;r=(a|0)>0;s=q+-4|0;t=(q|0)<4;o=(a|0)>8;p=q&-4;n=b;while(1){if(r){a=0;do{m=(k[n+(k[w+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[w+(a<<3)>>2]|0,g)|0)<<1)|0;k[v+(a<<2)>>2]=m;a=a+1|0}while((a|0)<(u|0))}a:do if(t)a=0;else{m=k[v>>2]|0;if(o)a=0;else{a=0;while(1){b=m+(a<<1)|0;h=j[b+2>>1]|0;i=j[b+4>>1]|0;l=j[b+6>>1]|0;j[c+(a<<1)>>1]=j[b>>1]|0;j[c+((a|1)<<1)>>1]=h;j[c+((a|2)<<1)>>1]=i;j[c+((a|3)<<1)>>1]=l;a=a+4|0;if((a|0)>(s|0)){a=p;break a}}}do{i=m+(a<<1)|0;f=j[i+6>>1]|0;b=j[i+4>>1]|0;h=j[i+2>>1]|0;i=j[i>>1]|0;l=1;do{x=(k[v+(l<<2)>>2]|0)+(a<<1)|0;y=j[x>>1]|0;i=y<<16>>16<i<<16>>16?y:i;y=j[x+2>>1]|0;h=y<<16>>16<h<<16>>16?y:h;y=j[x+4>>1]|0;b=y<<16>>16<b<<16>>16?y:b;x=j[x+6>>1]|0;f=x<<16>>16<f<<16>>16?x:f;l=l+1|0}while((l|0)<(u|0));j[c+(a<<1)>>1]=i;j[c+((a|1)<<1)>>1]=h;j[c+((a|2)<<1)>>1]=b;j[c+((a|3)<<1)>>1]=f;a=a+4|0}while((a|0)<=(s|0));a=p}while(0);b:do if((a|0)<(q|0)){h=k[v>>2]|0;if(!o)while(1){j[c+(a<<1)>>1]=j[h+(a<<1)>>1]|0;a=a+1|0;if((a|0)==(q|0))break b}do{f=j[h+(a<<1)>>1]|0;b=1;do{y=j[(k[v+(b<<2)>>2]|0)+(a<<1)>>1]|0;f=y<<16>>16<f<<16>>16?y:f;b=b+1|0}while((b|0)<(u|0));j[c+(a<<1)>>1]=f;a=a+1|0}while((a|0)!=(q|0))}while(0);if((e|0)>1){e=e+-1|0;n=n+4|0;c=c+d|0}else break}return}function rra(a){a=a|0;ggb(a);return}function sra(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function tra(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=88068;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function ura(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=88068;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function vra(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;w=k[a+20>>2]|0;v=k[a+32>>2]|0;a=(k[a+24>>2]|0)-w|0;u=a>>3;q=aa(g,f)|0;if((e|0)<=0)return;r=(a|0)>0;s=q+-4|0;t=(q|0)<4;o=(a|0)>8;p=q&-4;n=b;while(1){if(r){a=0;do{m=(k[n+(k[w+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[w+(a<<3)>>2]|0,g)|0)<<1)|0;k[v+(a<<2)>>2]=m;a=a+1|0}while((a|0)<(u|0))}a:do if(t)a=0;else{m=k[v>>2]|0;if(o)a=0;else{a=0;while(1){b=m+(a<<1)|0;h=j[b+2>>1]|0;i=j[b+4>>1]|0;l=j[b+6>>1]|0;j[c+(a<<1)>>1]=j[b>>1]|0;j[c+((a|1)<<1)>>1]=h;j[c+((a|2)<<1)>>1]=i;j[c+((a|3)<<1)>>1]=l;a=a+4|0;if((a|0)>(s|0)){a=p;break a}}}do{i=m+(a<<1)|0;f=j[i+6>>1]|0;b=j[i+4>>1]|0;h=j[i+2>>1]|0;i=j[i>>1]|0;l=1;do{x=(k[v+(l<<2)>>2]|0)+(a<<1)|0;y=j[x>>1]|0;i=(y&65535)<(i&65535)?y:i;y=j[x+2>>1]|0;h=(y&65535)<(h&65535)?y:h;y=j[x+4>>1]|0;b=(y&65535)<(b&65535)?y:b;x=j[x+6>>1]|0;f=(x&65535)<(f&65535)?x:f;l=l+1|0}while((l|0)<(u|0));j[c+(a<<1)>>1]=i;j[c+((a|1)<<1)>>1]=h;j[c+((a|2)<<1)>>1]=b;j[c+((a|3)<<1)>>1]=f;a=a+4|0}while((a|0)<=(s|0));a=p}while(0);b:do if((a|0)<(q|0)){h=k[v>>2]|0;if(!o)while(1){j[c+(a<<1)>>1]=j[h+(a<<1)>>1]|0;a=a+1|0;if((a|0)==(q|0))break b}do{f=j[h+(a<<1)>>1]|0;b=1;do{y=j[(k[v+(b<<2)>>2]|0)+(a<<1)>>1]|0;f=(y&65535)<(f&65535)?y:f;b=b+1|0}while((b|0)<(u|0));j[c+(a<<1)>>1]=f;a=a+1|0}while((a|0)!=(q|0))}while(0);if((e|0)>1){e=e+-1|0;n=n+4|0;c=c+d|0}else break}return}function wra(a){a=a|0;ggb(a);return}function xra(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function yra(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=88092;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function zra(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=88092;b=k[a+32>>2]|0;c=b;if(b|0){d=a+36|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Ara(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;w=k[a+20>>2]|0;v=k[a+32>>2]|0;a=(k[a+24>>2]|0)-w|0;u=a>>3;q=aa(g,f)|0;if((e|0)<=0)return;r=(a|0)>0;s=q+-4|0;t=(q|0)<4;o=(a|0)>8;p=q&-4;n=b;while(1){if(r){a=0;do{m=(k[n+(k[w+(a<<3)+4>>2]<<2)>>2]|0)+(aa(k[w+(a<<3)>>2]|0,g)|0)|0;k[v+(a<<2)>>2]=m;a=a+1|0}while((a|0)<(u|0))}a:do if(t)a=0;else{if(o)j=0;else{a=0;while(1){b=(k[v>>2]|0)+a|0;h=i[b+1>>0]|0;j=i[b+2>>0]|0;m=i[b+3>>0]|0;i[c+a>>0]=i[b>>0]|0;i[c+(a|1)>>0]=h;i[c+(a|2)>>0]=j;i[c+(a|3)>>0]=m;a=a+4|0;if((a|0)>(s|0)){a=p;break a}}}do{h=(k[v>>2]|0)+j|0;a=i[h+3>>0]|0;f=i[h+2>>0]|0;b=i[h+1>>0]|0;h=i[h>>0]|0;m=1;do{x=(k[v+(m<<2)>>2]|0)+j|0;y=h&255;h=y-(l[352559+((y|256)-(l[x>>0]|0))>>0]|0)&255;y=b&255;b=y-(l[352559+((y|256)-(l[x+1>>0]|0))>>0]|0)&255;y=f&255;f=y-(l[352559+((y|256)-(l[x+2>>0]|0))>>0]|0)&255;y=a&255;a=y-(l[352559+((y|256)-(l[x+3>>0]|0))>>0]|0)&255;m=m+1|0}while((m|0)<(u|0));i[c+j>>0]=h;i[c+(j|1)>>0]=b;i[c+(j|2)>>0]=f;i[c+(j|3)>>0]=a;j=j+4|0}while((j|0)<=(s|0));a=p}while(0);b:do if((a|0)<(q|0)){if(!o)while(1){i[c+a>>0]=i[(k[v>>2]|0)+a>>0]|0;a=a+1|0;if((a|0)==(q|0))break b}do{f=i[(k[v>>2]|0)+a>>0]|0;b=1;do{y=f&255;f=y-(l[352559+((y|256)-(l[(k[v+(b<<2)>>2]|0)+a>>0]|0))>>0]|0)&255;b=b+1|0}while((b|0)<(u|0));i[c+a>>0]=f;a=a+1|0}while((a|0)!=(q|0))}while(0);if((e|0)>1){n=n+4|0;c=c+d|0;e=e+-1|0}else break}return}function Bra(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0.0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0.0,Z=0.0,_=0.0;X=r;r=r+192|0;v=X+48|0;M=X+40|0;u=X+32|0;R=X;Q=X+136|0;W=X+80|0;V=X+72|0;U=X+64|0;T=X+56|0;do if((k[d>>2]&2031616|0)==65536){l=k[d+4>>2]|0;k[W>>2]=k[l>>2];s=W+4|0;d=l+4|0;k[s>>2]=k[d>>2];S=W+8|0;k[S>>2]=k[l+8>>2];k[W+12>>2]=k[l+12>>2];k[W+16>>2]=k[l+16>>2];k[W+20>>2]=k[l+20>>2];k[W+24>>2]=k[l+24>>2];k[W+28>>2]=k[l+28>>2];k[W+32>>2]=k[l+32>>2];j=k[l+36>>2]|0;k[W+36>>2]=j;t=W+40|0;k[t>>2]=S;S=W+48|0;n=W+44|0;k[n>>2]=S;k[W+52>>2]=0;k[S>>2]=0;if(j|0){S=j+12|0;k[S>>2]=(k[S>>2]|0)+1}if((k[d>>2]|0)<3){O=k[l+44>>2]|0;S=k[n>>2]|0;k[S>>2]=k[O>>2];k[S+4>>2]=k[O+4>>2];S=t;break}k[s>>2]=0;x1(W,k[d>>2]|0,0,0,0);if((k[s>>2]|0)>0){o=k[l+40>>2]|0;q=k[t>>2]|0;l=k[l+44>>2]|0;j=k[n>>2]|0;d=0;do{k[q+(d<<2)>>2]=k[o+(d<<2)>>2];k[j+(d<<2)>>2]=k[l+(d<<2)>>2];d=d+1|0}while((d|0)<(k[s>>2]|0));S=t}else S=t}else{Q1(W,d,-1);S=W+40|0}while(0);d=k[e>>2]|0;I=e+4|0;j=k[I>>2]|0;O=k[S>>2]|0;N=k[O+4>>2]|0;O=k[O>>2]|0;d=(d|0)==-1?(N|0)/2|0:d;j=(j|0)==-1?(O|0)/2|0:j;if(!((d|0)>-1&(d|0)<(N|0)?(j|0)>-1&(j|0)<(O|0):0)){k[R>>2]=0;l=R+4|0;k[l>>2]=0;n=ZT(60)|0;k[n>>2]=1;J=n+4|0;k[R>>2]=J;k[l>>2]=52;i[n+56>>0]=0;K=344955;L=J+52|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345008,345024,363);k[l>>2]=0;k[R>>2]=0;O=k[n>>2]|0;k[n>>2]=O+-1;if((O|0)==1)ggb(k[n+-4>>2]|0)}k[e>>2]=d;k[I>>2]=j;k[V>>2]=0;G=V+4|0;k[G>>2]=0;k[U>>2]=0;N=U+4|0;k[N>>2]=0;k[T>>2]=0;O=T+4|0;k[O>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;k[R>>2]=16842752;k[R+4>>2]=W;L=o7(R)|0;H=W+8|0;j=k[H>>2]|0;o=k[W+12>>2]|0;L=(L|0)==(aa(o,j)|0);e=k[e>>2]|0;if(L){l=c&7;n=(e|0)<0?(o|0)/2|0:e;t=(b|0)==0;s=(b|1|0)==1;if(!s){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(44)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=39;i[j+43>>0]=0;K=341371;L=J+39|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,341411,341434,856);k[d>>2]=0;k[R>>2]=0;P=k[j>>2]|0;k[j>>2]=P+-1;if((P|0)==1)ggb(k[j+-4>>2]|0)}q=(l|0)==0;a:do if(t){if(q){while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=86836;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=86856;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=119;break}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=119;break}switch(c&7){case 2:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=86876;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=86896;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=119;break a}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=119;break a}case 3:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=86916;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=86936;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=119;break a}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=119;break a}case 5:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=86956;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=86976;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=119;break a}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=119;break a}case 6:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=86996;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87016;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=119;break a}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=119;break a}default:{P=115;break a}}}else{if(q){while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87036;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87056;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=119;break}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=119;break}switch(c&7){case 2:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87076;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87096;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=119;break a}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=119;break a}case 3:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87116;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87136;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=119;break a}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=119;break a}case 5:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87156;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87176;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=119;break a}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=119;break a}case 6:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87196;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87216;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=119;break a}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=119;break a}default:{P=115;break a}}}while(0);if((P|0)==115){k[u>>2]=c;$8(R,341501,u);Y8(-213,R,341411,341434,894);d=k[R>>2]|0;k[R+4>>2]=0;k[R>>2]=0;if(d|0?(O=d+-4|0,P=k[O>>2]|0,k[O>>2]=P+-1,(P|0)==1):0)ggb(k[d+-8>>2]|0);l=0;j=0}else if((P|0)==119)if(!j){l=j;j=d}else{l=j+4|0;k[l>>2]=(k[l>>2]|0)+1;l=j;j=d}d=k[V>>2]|0;k[V>>2]=l;k[G>>2]=j;if(d|0?(O=d+4|0,P=k[O>>2]|0,k[O>>2]=P+-1,(P|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;if(l|0?(O=d+4|0,P=k[O>>2]|0,k[O>>2]=P+-1,(P|0)==1):0)Uh[k[(k[l>>2]|0)+8>>2]&2047](d);o=k[H>>2]|0;n=k[I>>2]|0;n=(n|0)<0?(o|0)/2|0:n;if(!s){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(44)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=39;i[j+43>>0]=0;K=341371;L=J+39|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,343169,341434,903);k[d>>2]=0;k[R>>2]=0;P=k[j>>2]|0;k[j>>2]=P+-1;if((P|0)==1)ggb(k[j+-4>>2]|0)}b:do if(t){if(q){while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87236;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87260;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=230;break}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=230;break}switch(c&7){case 2:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87280;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87304;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=230;break b}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=230;break b}case 3:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87324;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87348;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=230;break b}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=230;break b}case 5:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87368;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87392;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=230;break b}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=230;break b}case 6:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87412;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87436;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=230;break b}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=230;break b}default:{P=226;break b}}}else{if(q){while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87456;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87480;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=230;break}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=230;break}switch(c&7){case 2:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87500;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87524;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=230;break b}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=230;break b}case 3:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87544;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87568;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=230;break b}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=230;break b}case 5:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87588;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87612;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=230;break b}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=230;break b}case 6:{while(1){d=fgb(16)|0;if(d|0){l=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}k[l>>2]=87632;k[l+4>>2]=o;k[l+8>>2]=n;while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}O=d+4|0;k[O>>2]=1;k[d>>2]=87656;k[d+8>>2]=l;j=d;k[O>>2]=(k[O>>2]|0)+1;P=k[O>>2]|0;k[O>>2]=P+-1;if((P|0)!=1){d=l;P=230;break b}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;P=230;break b}default:{P=226;break b}}}while(0);if((P|0)==226){k[M>>2]=c;$8(R,341501,M);Y8(-213,R,343169,341434,941);d=k[R>>2]|0;k[R+4>>2]=0;k[R>>2]=0;if(d|0?(O=d+-4|0,P=k[O>>2]|0,k[O>>2]=P+-1,(P|0)==1):0)ggb(k[d+-8>>2]|0);l=0;j=0}else if((P|0)==230)if(!j){l=j;j=d}else{l=j+4|0;k[l>>2]=(k[l>>2]|0)+1;l=j;j=d}d=k[U>>2]|0;k[U>>2]=l;k[N>>2]=j;if(d|0?(O=d+4|0,P=k[O>>2]|0,k[O>>2]=P+-1,(P|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=l;if(l|0?(O=d+4|0,P=k[O>>2]|0,k[O>>2]=P+-1,(P|0)==1):0)Uh[k[(k[l>>2]|0)+8>>2]&2047](d)}else{t=k[I>>2]|0;k[Q>>2]=k[W>>2];s=Q+4|0;l=W+4|0;d=k[l>>2]|0;k[s>>2]=d;N=Q+8|0;k[N>>2]=j;k[Q+12>>2]=o;k[Q+16>>2]=k[W+16>>2];k[Q+20>>2]=k[W+20>>2];k[Q+24>>2]=k[W+24>>2];k[Q+28>>2]=k[W+28>>2];k[Q+32>>2]=k[W+32>>2];j=k[W+36>>2]|0;k[Q+36>>2]=j;u=Q+40|0;k[u>>2]=N;N=Q+48|0;q=Q+44|0;k[q>>2]=N;k[Q+52>>2]=0;k[N>>2]=0;if(j){d=j+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[l>>2]|0}if((d|0)>=3){k[s>>2]=0;x1(Q,d,0,0,0);if((k[s>>2]|0)>0){l=k[W+40>>2]|0;n=k[u>>2]|0;o=k[W+44>>2]|0;j=k[q>>2]|0;d=0;do{k[n+(d<<2)>>2]=k[l+(d<<2)>>2];k[j+(d<<2)>>2]=k[o+(d<<2)>>2];d=d+1|0}while((d|0)<(k[s>>2]|0))}}else{M=k[W+44>>2]|0;N=k[q>>2]|0;k[N>>2]=k[M>>2];k[N+4>>2]=k[M+4>>2]}n=c&7;N=k[u>>2]|0;M=k[N+4>>2]|0;N=k[N>>2]|0;e=(e|0)==-1?(M|0)/2|0:e;q=(t|0)==-1?(N|0)/2|0:t;if(!((e|0)>-1&(e|0)<(M|0)?(q|0)>-1&(q|0)<(N|0):0)){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(60)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=52;i[j+56>>0]=0;K=344955;L=J+52|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345008,345024,363);k[d>>2]=0;k[R>>2]=0;N=k[j>>2]|0;k[j>>2]=N+-1;if((N|0)==1)ggb(k[j+-4>>2]|0)}l=(b|0)==0;if((b|1|0)!=1){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(44)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=39;i[j+43>>0]=0;K=341371;L=J+39|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345098,341434,951);k[d>>2]=0;k[R>>2]=0;N=k[j>>2]|0;k[j>>2]=N+-1;if((N|0)==1)ggb(k[j+-4>>2]|0)}d=(n|0)==0;c:do if(l){if(d){while(1){l=fgb(48)|0;if(l|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}M=l+4|0;k[M>>2]=-1;k[M+4>>2]=-1;k[M+8>>2]=-1;k[l>>2]=88092;n=l+20|0;o=l+24|0;s=l+32|0;t=l+36|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[n+16>>2]=0;k[n+20>>2]=0;k[l+12>>2]=e;k[l+16>>2]=q;L=k[Q+40>>2]|0;N=k[L>>2]|0;k[M>>2]=k[L+4>>2];k[l+8>>2]=N;if(k[Q>>2]&4095|0){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(28)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=23;i[j+27>>0]=0;K=345220;L=J+23|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345244,341434,791);k[d>>2]=0;k[R>>2]=0;N=k[j>>2]|0;k[j>>2]=N+-1;if((N|0)==1)ggb(k[j+-4>>2]|0)}k[R>>2]=0;q=R+4|0;k[q>>2]=0;k[R+8>>2]=0;Tja(Q,n,R);d=(k[o>>2]|0)-(k[n>>2]|0)>>3;o=k[t>>2]|0;n=k[s>>2]|0;j=o-n>>2;if(d>>>0<=j>>>0){if(d>>>0<j>>>0?(C=n+(d<<2)|0,(o|0)!=(C|0)):0)k[t>>2]=o+(~((o+-4-C|0)>>>2)<<2)}else vaa(s,d-j|0);d=k[R>>2]|0;if(d|0){if((k[q>>2]|0)!=(d|0))k[q>>2]=d;ggb(d)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}M=d+4|0;k[M>>2]=1;k[d>>2]=87676;k[d+8>>2]=l;j=d;k[M>>2]=(k[M>>2]|0)+1;N=k[M>>2]|0;k[M>>2]=N+-1;if((N|0)!=1){o=j;break}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);o=j;break}switch(c&7){case 2:{while(1){l=fgb(48)|0;if(l|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}M=l+4|0;k[M>>2]=-1;k[M+4>>2]=-1;k[M+8>>2]=-1;k[l>>2]=88068;n=l+20|0;o=l+24|0;s=l+32|0;t=l+36|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[n+16>>2]=0;k[n+20>>2]=0;k[l+12>>2]=e;k[l+16>>2]=q;L=k[Q+40>>2]|0;N=k[L>>2]|0;k[M>>2]=k[L+4>>2];k[l+8>>2]=N;if(k[Q>>2]&4095|0){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(28)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=23;i[j+27>>0]=0;K=345220;L=J+23|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345244,341434,791);k[d>>2]=0;k[R>>2]=0;N=k[j>>2]|0;k[j>>2]=N+-1;if((N|0)==1)ggb(k[j+-4>>2]|0)}k[R>>2]=0;q=R+4|0;k[q>>2]=0;k[R+8>>2]=0;Tja(Q,n,R);d=(k[o>>2]|0)-(k[n>>2]|0)>>3;o=k[t>>2]|0;n=k[s>>2]|0;j=o-n>>2;if(d>>>0<=j>>>0){if(d>>>0<j>>>0?(D=n+(d<<2)|0,(o|0)!=(D|0)):0)k[t>>2]=o+(~((o+-4-D|0)>>>2)<<2)}else vaa(s,d-j|0);d=k[R>>2]|0;if(d|0){if((k[q>>2]|0)!=(d|0))k[q>>2]=d;ggb(d)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}M=d+4|0;k[M>>2]=1;k[d>>2]=87696;k[d+8>>2]=l;j=d;k[M>>2]=(k[M>>2]|0)+1;N=k[M>>2]|0;k[M>>2]=N+-1;if((N|0)!=1){o=j;break c}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);o=j;break c}case 3:{while(1){l=fgb(48)|0;if(l|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}M=l+4|0;k[M>>2]=-1;k[M+4>>2]=-1;k[M+8>>2]=-1;k[l>>2]=88044;n=l+20|0;o=l+24|0;s=l+32|0;t=l+36|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[n+16>>2]=0;k[n+20>>2]=0;k[l+12>>2]=e;k[l+16>>2]=q;L=k[Q+40>>2]|0;N=k[L>>2]|0;k[M>>2]=k[L+4>>2];k[l+8>>2]=N;if(k[Q>>2]&4095|0){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(28)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=23;i[j+27>>0]=0;K=345220;L=J+23|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345244,341434,791);k[d>>2]=0;k[R>>2]=0;N=k[j>>2]|0;k[j>>2]=N+-1;if((N|0)==1)ggb(k[j+-4>>2]|0)}k[R>>2]=0;q=R+4|0;k[q>>2]=0;k[R+8>>2]=0;Tja(Q,n,R);d=(k[o>>2]|0)-(k[n>>2]|0)>>3;o=k[t>>2]|0;n=k[s>>2]|0;j=o-n>>2;if(d>>>0<=j>>>0){if(d>>>0<j>>>0?(E=n+(d<<2)|0,(o|0)!=(E|0)):0)k[t>>2]=o+(~((o+-4-E|0)>>>2)<<2)}else vaa(s,d-j|0);d=k[R>>2]|0;if(d|0){if((k[q>>2]|0)!=(d|0))k[q>>2]=d;ggb(d)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}M=d+4|0;k[M>>2]=1;k[d>>2]=87716;k[d+8>>2]=l;j=d;k[M>>2]=(k[M>>2]|0)+1;N=k[M>>2]|0;k[M>>2]=N+-1;if((N|0)!=1){o=j;break c}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);o=j;break c}case 5:{while(1){l=fgb(48)|0;if(l|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}M=l+4|0;k[M>>2]=-1;k[M+4>>2]=-1;k[M+8>>2]=-1;k[l>>2]=88020;n=l+20|0;o=l+24|0;s=l+32|0;t=l+36|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[n+16>>2]=0;k[n+20>>2]=0;k[l+12>>2]=e;k[l+16>>2]=q;L=k[Q+40>>2]|0;N=k[L>>2]|0;k[M>>2]=k[L+4>>2];k[l+8>>2]=N;if(k[Q>>2]&4095|0){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(28)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=23;i[j+27>>0]=0;K=345220;L=J+23|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345244,341434,791);k[d>>2]=0;k[R>>2]=0;N=k[j>>2]|0;k[j>>2]=N+-1;if((N|0)==1)ggb(k[j+-4>>2]|0)}k[R>>2]=0;q=R+4|0;k[q>>2]=0;k[R+8>>2]=0;Tja(Q,n,R);d=(k[o>>2]|0)-(k[n>>2]|0)>>3;o=k[t>>2]|0;n=k[s>>2]|0;j=o-n>>2;if(d>>>0<=j>>>0){if(d>>>0<j>>>0?(F=n+(d<<2)|0,(o|0)!=(F|0)):0)k[t>>2]=o+(~((o+-4-F|0)>>>2)<<2)}else vaa(s,d-j|0);d=k[R>>2]|0;if(d|0){if((k[q>>2]|0)!=(d|0))k[q>>2]=d;ggb(d)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}M=d+4|0;k[M>>2]=1;k[d>>2]=87736;k[d+8>>2]=l;j=d;k[M>>2]=(k[M>>2]|0)+1;N=k[M>>2]|0;k[M>>2]=N+-1;if((N|0)!=1){o=j;break c}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);o=j;break c}case 6:{while(1){l=fgb(48)|0;if(l|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}M=l+4|0;k[M>>2]=-1;k[M+4>>2]=-1;k[M+8>>2]=-1;k[l>>2]=87996;n=l+20|0;o=l+24|0;s=l+32|0;t=l+36|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[n+16>>2]=0;k[n+20>>2]=0;k[l+12>>2]=e;k[l+16>>2]=q;L=k[Q+40>>2]|0;N=k[L>>2]|0;k[M>>2]=k[L+4>>2];k[l+8>>2]=N;if(k[Q>>2]&4095|0){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(28)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=23;i[j+27>>0]=0;K=345220;L=J+23|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345244,341434,791);k[d>>2]=0;k[R>>2]=0;N=k[j>>2]|0;k[j>>2]=N+-1;if((N|0)==1)ggb(k[j+-4>>2]|0)}k[R>>2]=0;q=R+4|0;k[q>>2]=0;k[R+8>>2]=0;Tja(Q,n,R);d=(k[o>>2]|0)-(k[n>>2]|0)>>3;o=k[t>>2]|0;n=k[s>>2]|0;j=o-n>>2;if(d>>>0<=j>>>0){if(d>>>0<j>>>0?(w=n+(d<<2)|0,(o|0)!=(w|0)):0)k[t>>2]=o+(~((o+-4-w|0)>>>2)<<2)}else vaa(s,d-j|0);d=k[R>>2]|0;if(d|0){if((k[q>>2]|0)!=(d|0))k[q>>2]=d;ggb(d)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}M=d+4|0;k[M>>2]=1;k[d>>2]=87756;k[d+8>>2]=l;j=d;k[M>>2]=(k[M>>2]|0)+1;N=k[M>>2]|0;k[M>>2]=N+-1;if((N|0)!=1){o=j;break c}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);o=j;break c}default:{P=479;break c}}}else{if(d){while(1){l=fgb(48)|0;if(l|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}M=l+4|0;k[M>>2]=-1;k[M+4>>2]=-1;k[M+8>>2]=-1;k[l>>2]=87972;n=l+20|0;o=l+24|0;s=l+32|0;t=l+36|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[n+16>>2]=0;k[n+20>>2]=0;k[l+12>>2]=e;k[l+16>>2]=q;L=k[Q+40>>2]|0;N=k[L>>2]|0;k[M>>2]=k[L+4>>2];k[l+8>>2]=N;if(k[Q>>2]&4095|0){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(28)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=23;i[j+27>>0]=0;K=345220;L=J+23|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345244,341434,791);k[d>>2]=0;k[R>>2]=0;N=k[j>>2]|0;k[j>>2]=N+-1;if((N|0)==1)ggb(k[j+-4>>2]|0)}k[R>>2]=0;q=R+4|0;k[q>>2]=0;k[R+8>>2]=0;Tja(Q,n,R);d=(k[o>>2]|0)-(k[n>>2]|0)>>3;o=k[t>>2]|0;n=k[s>>2]|0;j=o-n>>2;if(d>>>0<=j>>>0){if(d>>>0<j>>>0?(x=n+(d<<2)|0,(o|0)!=(x|0)):0)k[t>>2]=o+(~((o+-4-x|0)>>>2)<<2)}else vaa(s,d-j|0);d=k[R>>2]|0;if(d|0){if((k[q>>2]|0)!=(d|0))k[q>>2]=d;ggb(d)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}M=d+4|0;k[M>>2]=1;k[d>>2]=87776;k[d+8>>2]=l;j=d;k[M>>2]=(k[M>>2]|0)+1;N=k[M>>2]|0;k[M>>2]=N+-1;if((N|0)!=1){o=j;break}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);o=j;break}switch(c&7){case 2:{while(1){l=fgb(48)|0;if(l|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}M=l+4|0;k[M>>2]=-1;k[M+4>>2]=-1;k[M+8>>2]=-1;k[l>>2]=87948;n=l+20|0;o=l+24|0;s=l+32|0;t=l+36|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[n+16>>2]=0;k[n+20>>2]=0;k[l+12>>2]=e;k[l+16>>2]=q;L=k[Q+40>>2]|0;N=k[L>>2]|0;k[M>>2]=k[L+4>>2];k[l+8>>2]=N;if(k[Q>>2]&4095|0){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(28)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=23;i[j+27>>0]=0;K=345220;L=J+23|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345244,341434,791);k[d>>2]=0;k[R>>2]=0;N=k[j>>2]|0;k[j>>2]=N+-1;if((N|0)==1)ggb(k[j+-4>>2]|0)}k[R>>2]=0;q=R+4|0;k[q>>2]=0;k[R+8>>2]=0;Tja(Q,n,R);d=(k[o>>2]|0)-(k[n>>2]|0)>>3;o=k[t>>2]|0;n=k[s>>2]|0;j=o-n>>2;if(d>>>0<=j>>>0){if(d>>>0<j>>>0?(y=n+(d<<2)|0,(o|0)!=(y|0)):0)k[t>>2]=o+(~((o+-4-y|0)>>>2)<<2)}else vaa(s,d-j|0);d=k[R>>2]|0;if(d|0){if((k[q>>2]|0)!=(d|0))k[q>>2]=d;ggb(d)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}M=d+4|0;k[M>>2]=1;k[d>>2]=87796;k[d+8>>2]=l;j=d;k[M>>2]=(k[M>>2]|0)+1;N=k[M>>2]|0;k[M>>2]=N+-1;if((N|0)!=1){o=j;break c}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);o=j;break c}case 3:{while(1){l=fgb(48)|0;if(l|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}M=l+4|0;k[M>>2]=-1;k[M+4>>2]=-1;k[M+8>>2]=-1;k[l>>2]=87924;n=l+20|0;o=l+24|0;s=l+32|0;t=l+36|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[n+16>>2]=0;k[n+20>>2]=0;k[l+12>>2]=e;k[l+16>>2]=q;L=k[Q+40>>2]|0;N=k[L>>2]|0;k[M>>2]=k[L+4>>2];k[l+8>>2]=N;if(k[Q>>2]&4095|0){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(28)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=23;i[j+27>>0]=0;K=345220;L=J+23|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345244,341434,791);k[d>>2]=0;k[R>>2]=0;N=k[j>>2]|0;k[j>>2]=N+-1;if((N|0)==1)ggb(k[j+-4>>2]|0)}k[R>>2]=0;q=R+4|0;k[q>>2]=0;k[R+8>>2]=0;Tja(Q,n,R);d=(k[o>>2]|0)-(k[n>>2]|0)>>3;o=k[t>>2]|0;n=k[s>>2]|0;j=o-n>>2;if(d>>>0<=j>>>0){if(d>>>0<j>>>0?(z=n+(d<<2)|0,(o|0)!=(z|0)):0)k[t>>2]=o+(~((o+-4-z|0)>>>2)<<2)}else vaa(s,d-j|0);d=k[R>>2]|0;if(d|0){if((k[q>>2]|0)!=(d|0))k[q>>2]=d;ggb(d)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}M=d+4|0;k[M>>2]=1;k[d>>2]=87816;k[d+8>>2]=l;j=d;k[M>>2]=(k[M>>2]|0)+1;N=k[M>>2]|0;k[M>>2]=N+-1;if((N|0)!=1){o=j;break c}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);o=j;break c}case 5:{while(1){l=fgb(48)|0;if(l|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}M=l+4|0;k[M>>2]=-1;k[M+4>>2]=-1;k[M+8>>2]=-1;k[l>>2]=87900;n=l+20|0;o=l+24|0;s=l+32|0;t=l+36|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[n+16>>2]=0;k[n+20>>2]=0;k[l+12>>2]=e;k[l+16>>2]=q;L=k[Q+40>>2]|0;N=k[L>>2]|0;k[M>>2]=k[L+4>>2];k[l+8>>2]=N;if(k[Q>>2]&4095|0){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(28)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=23;i[j+27>>0]=0;K=345220;L=J+23|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345244,341434,791);k[d>>2]=0;k[R>>2]=0;N=k[j>>2]|0;k[j>>2]=N+-1;if((N|0)==1)ggb(k[j+-4>>2]|0)}k[R>>2]=0;q=R+4|0;k[q>>2]=0;k[R+8>>2]=0;Tja(Q,n,R);d=(k[o>>2]|0)-(k[n>>2]|0)>>3;o=k[t>>2]|0;n=k[s>>2]|0;j=o-n>>2;if(d>>>0<=j>>>0){if(d>>>0<j>>>0?(A=n+(d<<2)|0,(o|0)!=(A|0)):0)k[t>>2]=o+(~((o+-4-A|0)>>>2)<<2)}else vaa(s,d-j|0);d=k[R>>2]|0;if(d|0){if((k[q>>2]|0)!=(d|0))k[q>>2]=d;ggb(d)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}M=d+4|0;k[M>>2]=1;k[d>>2]=87836;k[d+8>>2]=l;j=d;k[M>>2]=(k[M>>2]|0)+1;N=k[M>>2]|0;k[M>>2]=N+-1;if((N|0)!=1){o=j;break c}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);o=j;break c}case 6:{while(1){l=fgb(48)|0;if(l|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){l=0;break}Qh[d&7]()}M=l+4|0;k[M>>2]=-1;k[M+4>>2]=-1;k[M+8>>2]=-1;k[l>>2]=87876;n=l+20|0;o=l+24|0;s=l+32|0;t=l+36|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[n+16>>2]=0;k[n+20>>2]=0;k[l+12>>2]=e;k[l+16>>2]=q;L=k[Q+40>>2]|0;N=k[L>>2]|0;k[M>>2]=k[L+4>>2];k[l+8>>2]=N;if(k[Q>>2]&4095|0){k[R>>2]=0;d=R+4|0;k[d>>2]=0;j=ZT(28)|0;k[j>>2]=1;J=j+4|0;k[R>>2]=J;k[d>>2]=23;i[j+27>>0]=0;K=345220;L=J+23|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,R,345244,341434,791);k[d>>2]=0;k[R>>2]=0;N=k[j>>2]|0;k[j>>2]=N+-1;if((N|0)==1)ggb(k[j+-4>>2]|0)}k[R>>2]=0;q=R+4|0;k[q>>2]=0;k[R+8>>2]=0;Tja(Q,n,R);d=(k[o>>2]|0)-(k[n>>2]|0)>>3;o=k[t>>2]|0;n=k[s>>2]|0;j=o-n>>2;if(d>>>0<=j>>>0){if(d>>>0<j>>>0?(B=n+(d<<2)|0,(o|0)!=(B|0)):0)k[t>>2]=o+(~((o+-4-B|0)>>>2)<<2)}else vaa(s,d-j|0);d=k[R>>2]|0;if(d|0){if((k[q>>2]|0)!=(d|0))k[q>>2]=d;ggb(d)}while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}M=d+4|0;k[M>>2]=1;k[d>>2]=87856;k[d+8>>2]=l;j=d;k[M>>2]=(k[M>>2]|0)+1;N=k[M>>2]|0;k[M>>2]=N+-1;if((N|0)!=1){o=j;break c}Uh[k[(k[d>>2]|0)+8>>2]&2047](d);o=j;break c}default:{P=479;break c}}}while(0);if((P|0)==479){k[v>>2]=c;$8(R,341501,v);Y8(-213,R,345098,341434,979);d=k[R>>2]|0;k[R+4>>2]=0;k[R>>2]=0;if(d|0?(N=d+-4|0,P=k[N>>2]|0,k[N>>2]=P+-1,(P|0)==1):0)ggb(k[d+-8>>2]|0);o=0;l=0}n=Q+36|0;d=k[n>>2]|0;if(d|0?(N=d+12|0,P=k[N>>2]|0,k[N>>2]=P+-1,(P|0)==1):0){j=k[n>>2]|0;if(j|0){d=k[j+4>>2]|0;if(!d){d=k[Q+32>>2]|0;if(!d){d=B1()|0;j=k[n>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,j)}k[n>>2]=0}k[n>>2]=0;P=Q+16|0;n=Q+4|0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[n>>2]|0)>0){j=k[u>>2]|0;d=0;do{k[j+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[n>>2]|0))}d=k[Q+44>>2]|0;if(!((d|0)==(Q+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);if(o|0){P=o+4|0;k[P>>2]=(k[P>>2]|0)+1}d=k[T>>2]|0;k[T>>2]=o;k[O>>2]=l;if(d|0?(O=d+4|0,P=k[O>>2]|0,k[O>>2]=P+-1,(P|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=o;if(o|0?(O=d+4|0,P=k[O>>2]|0,k[O>>2]=P+-1,(P|0)==1):0)Uh[k[(k[o>>2]|0)+8>>2]&2047](d)}Z=+p[h>>3];p[R>>3]=Z;Y=+p[h+8>>3];e=R+8|0;p[e>>3]=Y;m=+p[h+16>>3];u=R+16|0;p[u>>3]=m;_=+p[h+24>>3];t=R+24|0;p[t>>3]=_;do if(_==1797693134862315708145274.0e284&(((f|0)==0|(g|0)==0)&Z==1797693134862315708145274.0e284&Y==1797693134862315708145274.0e284&m==1797693134862315708145274.0e284)){n=c&7;d=(n|0)==0;j=(n|2|0)==2;l=(n|0)==3;n=(n|0)==5;s=c&255;switch(s&7){case 0:case 2:case 3:case 5:case 6:break;default:{k[Q>>2]=0;o=Q+4|0;k[o>>2]=0;q=ZT(96)|0;k[q>>2]=1;J=q+4|0;k[Q>>2]=J;k[o>>2]=90;i[q+94>>0]=0;K=346674;L=J+90|0;do{i[J>>0]=i[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Y8(-215,Q,346765,341434,1010);k[o>>2]=0;k[Q>>2]=0;Q=k[q>>2]|0;k[q>>2]=Q+-1;if((Q|0)==1)ggb(k[q+-4>>2]|0)}}if(b|0){_=j?0.0:l?-32768.0:n?-3402823466385288598117041.0e14:-1797693134862315708145274.0e284;p[R>>3]=_;p[e>>3]=_;p[u>>3]=_;p[t>>3]=_;break}switch(s&7){case 0:case 2:{m=d?255.0:65535.0;break}default:m=l?32767.0:n?3402823466385288598117041.0e14:1797693134862315708145274.0e284}p[R>>3]=m;p[e>>3]=m;p[u>>3]=m;p[t>>3]=m}while(0);while(1){d=fgb(200)|0;if(d|0){j=d;break}d=k[207666]|0;k[207666]=d+0;if(!d){j=0;break}Qh[d&7]()}qga(j,T,V,U,c,c,c,f,g,R);while(1){d=fgb(16)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[d+4>>2]=1;k[d>>2]=72040;k[d+8>>2]=j;k[a>>2]=d;k[a+4>>2]=j;d=k[T>>2]|0;if(d|0?(a=d+4|0,T=k[a>>2]|0,k[a>>2]=T+-1,(T|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=k[U>>2]|0;if(d|0?(T=d+4|0,U=k[T>>2]|0,k[T>>2]=U+-1,(U|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);d=k[V>>2]|0;if(d|0?(U=d+4|0,V=k[U>>2]|0,k[U>>2]=V+-1,(V|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);l=W+36|0;d=k[l>>2]|0;if(d|0?(U=d+12|0,V=k[U>>2]|0,k[U>>2]=V+-1,(V|0)==1):0){j=k[l>>2]|0;if(j|0){d=k[j+4>>2]|0;if(!d){d=k[W+32>>2]|0;if(!d){d=B1()|0;j=k[l>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,j)}k[l>>2]=0}k[l>>2]=0;V=W+16|0;l=W+4|0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[l>>2]|0)>0){j=k[S>>2]|0;d=0;do{k[j+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[l>>2]|0))}d=k[W+44>>2]|0;if((d|0)==(W+48|0)|(d|0)==0){r=X;return}ggb(k[d+-4>>2]|0);r=X;return}function Cra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0.0,l=0,m=0,n=0,o=0,q=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+16|0;q=z;if(b>>>0>=3){e=q+4|0;f=ZT(76)|0;k[f>>2]=1;n=f+4|0;k[q>>2]=n;k[e>>2]=69;i[f+73>>0]=0;g=346788;o=n+69|0;do{i[n>>0]=i[g>>0]|0;n=n+1|0;g=g+1|0}while((n|0)<(o|0));Y8(-215,q,346858,341434,1034);k[e>>2]=0;k[q>>2]=0;y=k[f>>2]|0;k[f>>2]=y+-1;if((y|0)==1)ggb(k[f+-4>>2]|0)}h=k[d>>2]|0;x=d+4|0;l=k[x>>2]|0;e=k[c>>2]|0;y=c+4|0;f=k[y>>2]|0;h=(h|0)==-1?(e|0)/2|0:h;l=(l|0)==-1?(f|0)/2|0:l;if(!((h|0)>-1&(h|0)<(e|0)?(l|0)>-1&(l|0)<(f|0):0)){e=q+4|0;f=ZT(60)|0;k[f>>2]=1;n=f+4|0;k[q>>2]=n;k[e>>2]=52;i[f+56>>0]=0;g=344955;o=n+52|0;do{i[n>>0]=i[g>>0]|0;n=n+1|0;g=g+1|0}while((n|0)<(o|0));Y8(-215,q,345008,345024,363);k[e>>2]=0;k[q>>2]=0;v=k[f>>2]|0;k[f>>2]=v+-1;if((v|0)==1)ggb(k[f+-4>>2]|0);e=k[c>>2]|0;f=k[y>>2]|0}k[d>>2]=h;k[x>>2]=l;m=(e|0)==1&(f|0)==1?0:b;if((m|0)==2){h=(f|0)/2|0;g=(e|0)/2|0;if((f+1|0)>>>0>2){t=+(h|0);t=1.0/(t*t)}else t=0.0}else{t=0.0;g=0;h=0}k[a>>2]=1124007936;l=a+8|0;b=a+40|0;n=a+4|0;o=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(o|0));k[b>>2]=l;o=a+48|0;v=a+44|0;k[v>>2]=o;k[a+52>>2]=0;k[o>>2]=0;k[q>>2]=f;k[q+4>>2]=e;G1(a,2,q,0);if((k[y>>2]|0)<=0){r=z;return}q=a+16|0;s=+(g|0);a=aa(h,h)|0;if(!m){h=0;e=k[c>>2]|0;do{g=(k[q>>2]|0)+(aa(k[k[v>>2]>>2]|0,h)|0)|0;if((e|0)>0){zpb(g|0,1,e|0)|0;f=e;e=k[c>>2]|0}else f=0;if((f|0)<(e|0))do{i[g+f>>0]=0;f=f+1|0;e=k[c>>2]|0}while((f|0)<(e|0));h=h+1|0}while((h|0)<(k[y>>2]|0));r=z;return}o=(m|0)==1;m=0;do{l=k[q>>2]|0;b=aa(k[k[v>>2]>>2]|0,m)|0;n=l+b|0;do if(o)if((m|0)==(k[x>>2]|0)){e=0;f=k[c>>2]|0;w=33;break}else{e=k[d>>2]|0;f=e+1|0;w=31;break}else{e=m-h|0;if((((e|0)>-1?e:0-e|0)|0)<=(h|0)){j=s*+Q(+(t*+(a-(aa(e,e)|0)|0)));p[u>>3]=j;e=k[u+4>>2]|0;w=e&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){e=(e|0)<0;j=e?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(j==0.0)j=e?-0.0:0.0}f=~~j;e=g-f|0;f=f+g|0;w=k[c>>2]|0;f=(w|0)<=(f|0)?w:f+1|0;if((e|0)<0){e=0;w=33}else w=31}else e=0}while(0);if((w|0)==31)if((e|0)>0){zpb(n|0,0,e|0)|0;w=33}else{e=0;w=33}if((w|0)==33){w=0;if((f|0)>(e|0)){zpb(l+(e+b)|0,1,f-e|0)|0;e=f}}if((e|0)<(k[c>>2]|0))do{i[n+e>>0]=0;e=e+1|0}while((e|0)<(k[c>>2]|0));m=m+1|0}while((m|0)<(k[y>>2]|0));r=z;return}function Dra(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;ia=r;r=r+624|0;ga=ia+560|0;ha=ia+504|0;v=ia+496|0;w=ia+488|0;x=ia+480|0;y=ia+472|0;C=ia+408|0;ea=ia+416|0;_=ia+400|0;$=ia;ba=ia+344|0;ca=ia+288|0;da=ia+232|0;do if((k[d>>2]&2031616|0)==65536){m=k[d+4>>2]|0;k[ha>>2]=k[m>>2];s=ha+4|0;d=m+4|0;k[s>>2]=k[d>>2];fa=ha+8|0;k[fa>>2]=k[m+8>>2];k[ha+12>>2]=k[m+12>>2];t=ha+16|0;k[t>>2]=k[m+16>>2];k[ha+20>>2]=k[m+20>>2];k[ha+24>>2]=k[m+24>>2];k[ha+28>>2]=k[m+28>>2];k[ha+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[ha+36>>2]=j;l=ha+40|0;k[l>>2]=fa;fa=ha+48|0;o=ha+44|0;k[o>>2]=fa;k[ha+52>>2]=0;k[fa>>2]=0;if(j|0){fa=j+12|0;k[fa>>2]=(k[fa>>2]|0)+1}if((k[d>>2]|0)<3){X=k[m+44>>2]|0;fa=k[o>>2]|0;k[fa>>2]=k[X>>2];k[fa+4>>2]=k[X+4>>2];fa=t;break}k[s>>2]=0;x1(ha,k[d>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;d=0;do{k[n+(d<<2)>>2]=k[q+(d<<2)>>2];k[j+(d<<2)>>2]=k[l+(d<<2)>>2];d=d+1|0}while((d|0)<(k[s>>2]|0));fa=t}else fa=t}else{Q1(ha,d,-1);fa=ha+16|0}while(0);if(k[fa>>2]|0){l=k[ha+4>>2]|0;if((l|0)<3)d=aa(k[ha+12>>2]|0,k[ha+8>>2]|0)|0;else{m=k[ha+40>>2]|0;j=0;d=1;do{d=aa(k[m+(j<<2)>>2]|0,d)|0;j=j+1|0}while((j|0)!=(l|0))}if(d){q=k[ha+40>>2]|0;o=k[q+4>>2]|0;q=k[q>>2]|0}else{o=3;q=3}}else{o=3;q=3}d=k[e>>2]|0;X=e+4|0;j=k[X>>2]|0;d=(d|0)==-1?(o|0)/2|0:d;j=(j|0)==-1?(q|0)/2|0:j;if(!((d|0)>-1&(d|0)<(o|0)?(j|0)>-1&(j|0)<(q|0):0)){k[ga>>2]=0;l=ga+4|0;k[l>>2]=0;m=ZT(60)|0;k[m>>2]=1;A=m+4|0;k[ga>>2]=A;k[l>>2]=52;i[m+56>>0]=0;n=344955;B=A+52|0;do{i[A>>0]=i[n>>0]|0;A=A+1|0;n=n+1|0}while((A|0)<(B|0));Y8(-215,ga,345008,345024,363);k[l>>2]=0;k[ga>>2]=0;W=k[m>>2]|0;k[m>>2]=W+-1;if((W|0)==1)ggb(k[m+-4>>2]|0)}k[e>>2]=d;k[X>>2]=j;if((f|0)!=0?(Y=ha+8|0,Z=ha+12|0,u=aa(k[Z>>2]|0,k[Y>>2]|0)|0,(u|0)!=1):0){if(k[fa>>2]|0){m=k[ha+4>>2]|0;if((m|0)<3)d=u;else{l=k[ha+40>>2]|0;j=0;d=1;do{d=aa(k[l+(j<<2)>>2]|0,d)|0;j=j+1|0}while((j|0)!=(m|0))}if(d){if((f|0)>1?(k[ga+8>>2]=0,k[ga+12>>2]=0,k[ga>>2]=16842752,k[ga+4>>2]=ha,W=o7(ga)|0,(W|0)==(aa(k[Z>>2]|0,k[Y>>2]|0)|0)):0){d=aa(k[e>>2]|0,f)|0;l=aa(k[X>>2]|0,f)|0;k[e>>2]=d;k[X>>2]=l;W=f+-1|0;V=(aa(o+-1|0,W)|0)+o|0;W=(aa(q+-1|0,W)|0)+q|0;k[x>>2]=V;k[x+4>>2]=W;k[y>>2]=d;k[y+4>>2]=l;Cra(ga,0,x,y);KG(ha,ga)|0;l=ga+36|0;d=k[l>>2]|0;if(d|0?(V=d+12|0,W=k[V>>2]|0,k[V>>2]=W+-1,(W|0)==1):0){j=k[l>>2]|0;if(j|0){d=k[j+4>>2]|0;if(!d){d=k[ga+32>>2]|0;if(!d){d=B1()|0;j=k[l>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,j)}k[l>>2]=0}k[l>>2]=0;W=ga+16|0;j=ga+4|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[j>>2]|0)>0){l=k[ga+40>>2]|0;d=0;do{k[l+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[ga+44>>2]|0;if(!((d|0)==(ga+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);f=1}}else z=30}else z=30;if((z|0)==30){l=f<<1|1;k[v>>2]=l;k[v+4>>2]=l;k[w>>2]=-1;k[w+4>>2]=-1;Cra(ga,0,v,w);KG(ha,ga)|0;l=ga+36|0;d=k[l>>2]|0;if(d|0?(V=d+12|0,W=k[V>>2]|0,k[V>>2]=W+-1,(W|0)==1):0){j=k[l>>2]|0;if(j|0){d=k[j+4>>2]|0;if(!d){d=k[ga+32>>2]|0;if(!d){d=B1()|0;j=k[l>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,j)}k[l>>2]=0}k[l>>2]=0;W=ga+16|0;j=ga+4|0;k[W>>2]=0;k[W+4>>2]=0;k[W+8>>2]=0;k[W+12>>2]=0;if((k[j>>2]|0)>0){l=k[ga+40>>2]|0;d=0;do{k[l+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[ga+44>>2]|0;if(!((d|0)==(ga+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);k[e>>2]=f;k[X>>2]=f;f=1}do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[ga>>2]=k[l>>2];q=ga+4|0;d=l+4|0;k[q>>2]=k[d>>2];W=ga+8|0;k[W>>2]=k[l+8>>2];k[ga+12>>2]=k[l+12>>2];k[ga+16>>2]=k[l+16>>2];k[ga+20>>2]=k[l+20>>2];k[ga+24>>2]=k[l+24>>2];k[ga+28>>2]=k[l+28>>2];k[ga+32>>2]=k[l+32>>2];j=k[l+36>>2]|0;k[ga+36>>2]=j;s=ga+40|0;k[s>>2]=W;W=ga+48|0;m=ga+44|0;k[m>>2]=W;k[ga+52>>2]=0;k[W>>2]=0;if(j|0){W=j+12|0;k[W>>2]=(k[W>>2]|0)+1}if((k[d>>2]|0)<3){W=k[l+44>>2]|0;u=k[m>>2]|0;k[u>>2]=k[W>>2];k[u+4>>2]=k[W+4>>2];u=ga;break}k[q>>2]=0;x1(ga,k[d>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[l+40>>2]|0;o=k[s>>2]|0;l=k[l+44>>2]|0;j=k[m>>2]|0;d=0;do{k[o+(d<<2)>>2]=k[n+(d<<2)>>2];k[j+(d<<2)>>2]=k[l+(d<<2)>>2];d=d+1|0}while((d|0)<(k[q>>2]|0));u=ga}else u=ga}else{Q1(ga,b,-1);s=ga+40|0;u=ga}while(0);V=k[s>>2]|0;W=k[V>>2]|0;k[C>>2]=k[V+4>>2];k[C+4>>2]=W;x2(c,C,k[u>>2]&4095,0);do if((k[c>>2]&2031616|0)==65536){m=k[c+4>>2]|0;k[ea>>2]=k[m>>2];t=ea+4|0;d=m+4|0;k[t>>2]=k[d>>2];W=ea+8|0;k[W>>2]=k[m+8>>2];k[ea+12>>2]=k[m+12>>2];k[ea+16>>2]=k[m+16>>2];k[ea+20>>2]=k[m+20>>2];k[ea+24>>2]=k[m+24>>2];k[ea+28>>2]=k[m+28>>2];k[ea+32>>2]=k[m+32>>2];j=k[m+36>>2]|0;k[ea+36>>2]=j;l=ea+40|0;k[l>>2]=W;W=ea+48|0;o=ea+44|0;k[o>>2]=W;k[ea+52>>2]=0;k[W>>2]=0;if(j|0){W=j+12|0;k[W>>2]=(k[W>>2]|0)+1}if((k[d>>2]|0)<3){V=k[m+44>>2]|0;W=k[o>>2]|0;k[W>>2]=k[V>>2];k[W+4>>2]=k[V+4>>2];break}k[t>>2]=0;x1(ea,k[d>>2]|0,0,0,0);if((k[t>>2]|0)>0){q=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;j=k[o>>2]|0;d=0;do{k[n+(d<<2)>>2]=k[q+(d<<2)>>2];k[j+(d<<2)>>2]=k[l+(d<<2)>>2];d=d+1|0}while((d|0)<(k[t>>2]|0))}}else Q1(ea,c,-1);while(0);k[_>>2]=0;k[_+4>>2]=1;k[ba>>2]=k[u>>2];P=ba+4|0;W=ga+4|0;d=k[W>>2]|0;k[P>>2]=d;R=ba+8|0;k[R>>2]=k[ga+8>>2];k[ba+12>>2]=k[ga+12>>2];K=ba+16|0;U=ga+16|0;k[K>>2]=k[U>>2];k[ba+20>>2]=k[ga+20>>2];k[ba+24>>2]=k[ga+24>>2];k[ba+28>>2]=k[ga+28>>2];I=ba+32|0;T=ga+32|0;k[I>>2]=k[T>>2];L=ba+36|0;V=ga+36|0;j=k[V>>2]|0;k[L>>2]=j;M=ba+40|0;k[M>>2]=R;R=ba+48|0;Q=ba+44|0;k[Q>>2]=R;k[ba+52>>2]=0;k[R>>2]=0;if(j){d=j+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[W>>2]|0}if((d|0)>=3){k[P>>2]=0;x1(ba,d,0,0,0);if((k[P>>2]|0)>0){j=k[ga+40>>2]|0;l=k[M>>2]|0;m=k[ga+44>>2]|0;n=k[Q>>2]|0;d=0;do{k[l+(d<<2)>>2]=k[j+(d<<2)>>2];k[n+(d<<2)>>2]=k[m+(d<<2)>>2];d=d+1|0}while((d|0)<(k[P>>2]|0))}}else{O=k[ga+44>>2]|0;S=k[Q>>2]|0;k[S>>2]=k[O>>2];k[S+4>>2]=k[O+4>>2]}k[ca>>2]=k[ea>>2];F=ca+4|0;S=ea+4|0;d=k[S>>2]|0;k[F>>2]=d;H=ca+8|0;k[H>>2]=k[ea+8>>2];k[ca+12>>2]=k[ea+12>>2];c=ca+16|0;N=ea+16|0;k[c>>2]=k[N>>2];k[ca+20>>2]=k[ea+20>>2];k[ca+24>>2]=k[ea+24>>2];k[ca+28>>2]=k[ea+28>>2];C=ca+32|0;J=ea+32|0;k[C>>2]=k[J>>2];D=ca+36|0;O=ea+36|0;j=k[O>>2]|0;k[D>>2]=j;E=ca+40|0;k[E>>2]=H;H=ca+48|0;G=ca+44|0;k[G>>2]=H;k[ca+52>>2]=0;k[H>>2]=0;if(j){d=j+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[S>>2]|0}if((d|0)>=3){k[F>>2]=0;x1(ca,d,0,0,0);if((k[F>>2]|0)>0){j=k[ea+40>>2]|0;l=k[E>>2]|0;m=k[ea+44>>2]|0;n=k[G>>2]|0;d=0;do{k[l+(d<<2)>>2]=k[j+(d<<2)>>2];k[n+(d<<2)>>2]=k[m+(d<<2)>>2];d=d+1|0}while((d|0)<(k[F>>2]|0))}}else{A=k[ea+44>>2]|0;B=k[G>>2]|0;k[B>>2]=k[A>>2];k[B+4>>2]=k[A+4>>2]}k[da>>2]=k[ha>>2];b=da+4|0;l=ha+4|0;d=k[l>>2]|0;k[b>>2]=d;z=da+8|0;k[z>>2]=k[Y>>2];k[da+12>>2]=k[Z>>2];v=da+16|0;k[v>>2]=k[fa>>2];k[da+20>>2]=k[ha+20>>2];k[da+24>>2]=k[ha+24>>2];k[da+28>>2]=k[ha+28>>2];u=da+32|0;k[u>>2]=k[ha+32>>2];w=da+36|0;m=ha+36|0;j=k[m>>2]|0;k[w>>2]=j;x=da+40|0;k[x>>2]=z;z=da+48|0;y=da+44|0;k[y>>2]=z;k[da+52>>2]=0;k[z>>2]=0;if(j){d=j+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[l>>2]|0}if((d|0)>=3){k[b>>2]=0;x1(da,d,0,0,0);if((k[b>>2]|0)>0){j=k[ha+40>>2]|0;l=k[x>>2]|0;n=k[ha+44>>2]|0;o=k[y>>2]|0;d=0;do{k[l+(d<<2)>>2]=k[j+(d<<2)>>2];k[o+(d<<2)>>2]=k[n+(d<<2)>>2];d=d+1|0}while((d|0)<(k[b>>2]|0))}}else{Y=k[ha+44>>2]|0;Z=k[y>>2]|0;k[Z>>2]=k[Y>>2];k[Z+4>>2]=k[Y+4>>2]}t=k[e>>2]|0;o=k[X>>2]|0;k[$>>2]=88116;q=$+4|0;k[q>>2]=1124007936;d=$+12|0;j=$+44|0;A=$+8|0;B=A+36|0;do{k[A>>2]=0;A=A+4|0}while((A|0)<(B|0));k[j>>2]=d;n=$+52|0;k[$+48>>2]=n;k[$+56>>2]=0;k[n>>2]=0;n=$+60|0;k[n>>2]=1124007936;d=$+68|0;j=$+100|0;A=$+64|0;B=A+36|0;do{k[A>>2]=0;A=A+4|0}while((A|0)<(B|0));k[j>>2]=d;d=$+108|0;k[$+104>>2]=d;k[$+112>>2]=0;k[d>>2]=0;d=$+128|0;k[d>>2]=1124007936;j=$+136|0;l=$+168|0;A=$+132|0;B=A+36|0;do{k[A>>2]=0;A=A+4|0}while((A|0)<(B|0));k[l>>2]=j;e=$+176|0;k[$+172>>2]=e;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;p[$+200>>3]=+p[h>>3];p[$+208>>3]=+p[h+8>>3];p[$+216>>3]=+p[h+16>>3];p[$+224>>3]=+p[h+24>>3];KG(q,ba)|0;KG(n,ca)|0;k[$+116>>2]=1;k[$+120>>2]=f;k[$+124>>2]=a;KG(d,da)|0;k[$+184>>2]=t;k[$+188>>2]=o;k[$+192>>2]=g;k[$+196>>2]=g;jh[k[(k[$>>2]|0)+8>>2]&1023]($,_);Era($);d=k[w>>2]|0;if(d|0?(g=d+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){j=k[w>>2]|0;if(j|0){d=k[j+4>>2]|0;do if(!d){d=k[u>>2]|0;if(d|0)break;d=B1()|0;j=k[w>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,j)}k[w>>2]=0}k[w>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[b>>2]|0)>0){j=k[x>>2]|0;d=0;do{k[j+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[b>>2]|0))}d=k[y>>2]|0;if(!((d|0)==(z|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[D>>2]|0;do if(d|0){g=d+12|0;h=k[g>>2]|0;k[g>>2]=h+-1;if((h|0)!=1)break;j=k[D>>2]|0;if(j|0){d=k[j+4>>2]|0;do if(!d){d=k[C>>2]|0;if(d|0)break;d=B1()|0;j=k[D>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,j)}k[D>>2]=0}while(0);k[D>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[F>>2]|0)>0){j=k[E>>2]|0;d=0;do{k[j+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[F>>2]|0))}d=k[G>>2]|0;if(!((d|0)==(H|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[L>>2]|0;do if(d|0){g=d+12|0;h=k[g>>2]|0;k[g>>2]=h+-1;if((h|0)!=1)break;j=k[L>>2]|0;if(j|0){d=k[j+4>>2]|0;do if(!d){d=k[I>>2]|0;if(d|0)break;d=B1()|0;j=k[L>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,j)}k[L>>2]=0}while(0);k[L>>2]=0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[P>>2]|0)>0){j=k[M>>2]|0;d=0;do{k[j+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[P>>2]|0))}d=k[Q>>2]|0;if(!((d|0)==(R|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[O>>2]|0;do if(d|0){g=d+12|0;h=k[g>>2]|0;k[g>>2]=h+-1;if((h|0)!=1)break;j=k[O>>2]|0;if(j|0){d=k[j+4>>2]|0;do if(!d){d=k[J>>2]|0;if(d|0)break;d=B1()|0;j=k[O>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,j)}k[O>>2]=0}while(0);k[O>>2]=0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[S>>2]|0)>0){j=k[ea+40>>2]|0;d=0;do{k[j+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[S>>2]|0))}d=k[ea+44>>2]|0;if(!((d|0)==(ea+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[V>>2]|0;do if(d|0){h=d+12|0;ea=k[h>>2]|0;k[h>>2]=ea+-1;if((ea|0)!=1)break;j=k[V>>2]|0;if(j|0){d=k[j+4>>2]|0;do if(!d){d=k[T>>2]|0;if(d|0)break;d=B1()|0;j=k[V>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,j)}k[V>>2]=0}while(0);k[V>>2]=0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[W>>2]|0)>0){j=k[s>>2]|0;d=0;do{k[j+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[W>>2]|0))}d=k[ga+44>>2]|0;if(!((d|0)==(ga+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0)}else{I2(b,c);m=ha+36|0}d=k[m>>2]|0;if(d|0?(ea=d+12|0,ga=k[ea>>2]|0,k[ea>>2]=ga+-1,(ga|0)==1):0){l=ha+36|0;j=k[l>>2]|0;if(j|0){d=k[j+4>>2]|0;if(!d){d=k[ha+32>>2]|0;if(!d){d=B1()|0;j=k[l>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,j)}k[l>>2]=0}k[m>>2]=0;l=ha+4|0;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=0;k[fa+12>>2]=0;if((k[l>>2]|0)>0){j=k[ha+40>>2]|0;d=0;do{k[j+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[l>>2]|0))}d=k[ha+44>>2]|0;if((d|0)==(ha+48|0)|(d|0)==0){r=ia;return}ggb(k[d+-4>>2]|0);r=ia;return}function Era(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=88116;d=a+164|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+160>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+144|0;c=a+132|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+168>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+172>>2]|0;if(!((b|0)==(a+176|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+20|0;d=a+8|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+44>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Fra(a){a=a|0;Era(a);ggb(a);return}function Gra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;n=r;r=r+160|0;h=n+152|0;i=n+136|0;m=n+72|0;l=n+8|0;g=n+128|0;f=n+64|0;j=n;e=a+4|0;o=k[a+12>>2]|0;c=aa(o,k[b>>2]|0)|0;d=k[a+116>>2]|0;c=(c|0)/(d|0)|0;c=(o|0)<(c|0)?o:c;d=(aa(k[b+4>>2]|0,o)|0)/(d|0)|0;d=(o|0)<(d|0)?o:d;k[h>>2]=c;k[h+4>>2]=d;k[i>>2]=-2147483648;k[i+4>>2]=2147483647;H1(m,e,h,i);k[h>>2]=c;k[h+4>>2]=d;k[i>>2]=-2147483648;k[i+4>>2]=2147483647;H1(l,a+60|0,h,i);d=k[a+124>>2]|0;e=k[e>>2]&4095;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=a+128;k[g>>2]=k[a+184>>2];k[g+4>>2]=k[a+188>>2];Bra(h,d,e,i,g,k[a+192>>2]|0,k[a+196>>2]|0,a+200|0);g=k[h+4>>2]|0;e=k[(k[g>>2]|0)+20>>2]|0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=-1;k[i+12>>2]=-1;k[f>>2]=0;k[f+4>>2]=0;Lg[e&255](g,m,l,i,f,0);a=a+120|0;if((k[a>>2]|0)>1){c=i+4|0;d=i+8|0;e=i+12|0;f=j+4|0;b=1;do{o=k[(k[g>>2]|0)+20>>2]|0;k[i>>2]=0;k[c>>2]=0;k[d>>2]=-1;k[e>>2]=-1;k[j>>2]=0;k[f>>2]=0;Lg[o&255](g,l,l,i,j,0);b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[h>>2]|0;if(b|0?(j=b+4|0,o=k[j>>2]|0,k[j>>2]=o+-1,(o|0)==1):0)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);c=l+36|0;b=k[c>>2]|0;if(b|0?(j=b+12|0,o=k[j>>2]|0,k[j>>2]=o+-1,(o|0)==1):0){a=k[c>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[l+32>>2]|0;if(!b){b=B1()|0;a=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[c>>2]=0}k[c>>2]=0;o=l+16|0;c=l+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[c>>2]|0)>0){a=k[l+40>>2]|0;b=0;do{k[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[l+44>>2]|0;if(!((b|0)==(l+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);c=m+36|0;b=k[c>>2]|0;if(b|0?(l=b+12|0,o=k[l>>2]|0,k[l>>2]=o+-1,(o|0)==1):0){a=k[c>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[m+32>>2]|0;if(!b){b=B1()|0;a=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[c>>2]=0}k[c>>2]=0;o=m+16|0;a=m+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[a>>2]|0)>0){c=k[m+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[a>>2]|0))}b=k[m+44>>2]|0;if((b|0)==(m+48|0)|(b|0)==0){r=n;return}ggb(k[b+-4>>2]|0);r=n;return}function Hra(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+80|0;p=q+16|0;n=q+8|0;o=q;if((d|0)<0|((c|0)>=(a|0)|((a|0)<1|(b|0)<1|(c|0)<0))|(d|0)>=(b|0)|(e|0)==100){f=p+4|0;g=ZT(112)|0;k[g>>2]=1;h=g+4|0;k[p>>2]=h;k[f>>2]=107;i[g+111>>0]=0;j=346949;m=h+107|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));Y8(-215,p,347057,341434,1943);k[f>>2]=0;k[p>>2]=0;m=k[g>>2]|0;k[g>>2]=m+-1;if((m|0)==1)ggb(k[g+-4>>2]|0)}j=aa(b,a)|0;m=ZT((j<<2)+56|0)|0;k[m>>2]=a;k[m+4>>2]=b;k[m+8>>2]=c;k[m+12>>2]=d;k[m+20>>2]=(e|0)<2?e:100;f=m+16|0;k[f>>2]=m+24;if((e|0)==100)if((j|0)>0)Vd();else{r=q;return m|0}k[n>>2]=a;k[n+4>>2]=b;k[o>>2]=c;k[o+4>>2]=d;Cra(p,e,n,o);if((j|0)>0){h=k[p+16>>2]|0;g=k[f>>2]|0;f=0;do{k[g+(f<<2)>>2]=l[h+f>>0];f=f+1|0}while((f|0)!=(j|0))}h=p+36|0;f=k[h>>2]|0;if(f|0?(n=f+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[p+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;o=p+16|0;g=p+4|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[g>>2]|0)>0){h=k[p+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[p+44>>2]|0;if(!((f|0)==(p+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);r=q;return m|0}function Ira(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+256|0;j=z+248|0;y=z+192|0;w=z+136|0;t=z+80|0;l=z+64|0;m=z+48|0;n=z+32|0;h=z;M1(y,a,0,1,0,0);M1(w,b,0,1,0,0);k[t>>2]=1124007936;q=t+4|0;g=t+8|0;o=t+40|0;d=q;f=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(f|0));k[o>>2]=g;u=t+48|0;s=t+44|0;k[s>>2]=u;k[t+52>>2]=0;k[u>>2]=0;x=y+40|0;e=k[x>>2]|0;v=w+40|0;f=k[v>>2]|0;if(!(((k[e>>2]|0)==(k[f>>2]|0)?(k[e+4>>2]|0)==(k[f+4>>2]|0):0)?!((k[w>>2]^k[y>>2])&4095|0):0)){k[j>>2]=0;a=j+4|0;k[a>>2]=0;b=ZT(60)|0;k[b>>2]=1;d=b+4|0;k[j>>2]=d;k[a>>2]=52;i[b+56>>0]=0;e=347086;f=d+52|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,j,347139,341434,2013);k[a>>2]=0;k[j>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0)}if(!c){d=t+36|0;a=k[d>>2]|0;if(a|0?(g=a+12|0,c=k[g>>2]|0,k[g>>2]=c+-1,(c|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[t+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;c=t+16|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[q>>2]|0)>0){b=k[o>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[q>>2]|0));b=1;a=1}else{b=1;a=1}}else{b=k[c+8>>2]|0;a=k[c+12>>2]|0;f=c+4|0;e=k[f>>2]|0;d=k[c>>2]|0;if(!(((((k[q>>2]|0)<3?(k[g>>2]|0)==(e|0):0)?(k[t+12>>2]|0)==(d|0):0)?(k[t>>2]&4095|0)==0:0)?(k[t+16>>2]|0)!=0:0)){k[j>>2]=e;k[j+4>>2]=d;G1(t,2,j,0);e=k[f>>2]|0;d=k[c>>2]|0}g=aa(d,e)|0;if((g|0)>0){e=c+16|0;f=t+16|0;d=0;do{i[(k[f>>2]|0)+d>>0]=(k[(k[e>>2]|0)+(d<<2)>>2]|0)!=0&1;d=d+1|0}while((d|0)!=(g|0))}}k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=y;d=m+4|0;c=d+4|0;k[c>>2]=0;k[c+4>>2]=0;k[m>>2]=33619968;k[d>>2]=w;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=t;p[h>>3]=1797693134862315708145274.0e284;p[h+8>>3]=1797693134862315708145274.0e284;p[h+16>>3]=1797693134862315708145274.0e284;p[h+24>>3]=1797693134862315708145274.0e284;k[j>>2]=b;k[j+4>>2]=a;Dra(1,l,m,n,j,1,1,h);d=t+36|0;a=k[d>>2]|0;if(a|0?(m=a+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[t+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;t=t+16|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[q>>2]|0)>0){b=k[o>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[q>>2]|0))}a=k[s>>2]|0;if(!((a|0)==(u|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=w+36|0;a=k[d>>2]|0;if(a|0?(t=a+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[w+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;u=w+16|0;d=w+4|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[d>>2]|0)>0){b=k[v>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[w+44>>2]|0;if(!((a|0)==(w+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=y+36|0;a=k[d>>2]|0;if(a|0?(v=a+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;w=y+16|0;d=y+4|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[d>>2]|0)>0){b=k[x>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[y+44>>2]|0;if((a|0)==(y+48|0)|(a|0)==0){r=z;return}ggb(k[a+-4>>2]|0);r=z;return}function Jra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+128|0;s=t+72|0;n=t+64|0;q=t+8|0;p=t;if(!d){f=s+4|0;e=ZT(36)|0;k[e>>2]=1;g=e+4|0;k[s>>2]=g;k[f>>2]=29;i[e+33>>0]=0;h=347276;j=g+29|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,s,347306,347314,1232);k[f>>2]=0;k[s>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[s>>2]=k[g>>2];m=s+4|0;a=g+4|0;k[m>>2]=k[a>>2];l=s+8|0;k[l>>2]=k[g+8>>2];k[s+12>>2]=k[g+12>>2];k[s+16>>2]=k[g+16>>2];k[s+20>>2]=k[g+20>>2];k[s+24>>2]=k[g+24>>2];k[s+28>>2]=k[g+28>>2];k[s+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[s+36>>2]=e;f=s+40|0;k[f>>2]=l;l=s+48|0;j=s+44|0;k[j>>2]=l;k[s+52>>2]=0;k[l>>2]=0;if(e|0){l=e+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[a>>2]|0)<3){l=k[g+44>>2]|0;m=k[j>>2]|0;k[m>>2]=k[l>>2];k[m+4>>2]=k[l+4>>2];break}k[m>>2]=0;x1(s,k[a>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[l+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0))}}else Q1(s,a,-1);while(0);e=k[c>>2]|0;a=k[c+4>>2]|0;if(!(aa(a,e)|0)){e=((k[s+12>>2]|0)+1|0)/2|0;a=((k[s+8>>2]|0)+1|0)/2|0}k[n>>2]=e;k[n+4>>2]=a;x2(b,n,k[s>>2]&4095,0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[q>>2]=k[g>>2];m=q+4|0;a=g+4|0;k[m>>2]=k[a>>2];n=q+8|0;k[n>>2]=k[g+8>>2];k[q+12>>2]=k[g+12>>2];k[q+16>>2]=k[g+16>>2];k[q+20>>2]=k[g+20>>2];k[q+24>>2]=k[g+24>>2];k[q+28>>2]=k[g+28>>2];k[q+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[q+36>>2]=e;f=q+40|0;k[f>>2]=n;n=q+48|0;j=q+44|0;k[j>>2]=n;k[q+52>>2]=0;k[n>>2]=0;if(e|0){n=e+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[a>>2]|0)<3){b=k[g+44>>2]|0;n=k[j>>2]|0;k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];break}k[m>>2]=0;x1(q,k[a>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[l+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0))}}else Q1(q,b,-1);while(0);switch(k[s>>2]&7){case 0:{o=297;break}case 3:{o=298;break}case 2:{o=299;break}case 5:{o=300;break}case 6:{o=301;break}default:{k[p>>2]=0;b=p+4|0;k[b>>2]=0;n=ZT(8)|0;k[n>>2]=1;n=n+4|0;k[p>>2]=n;k[b>>2]=0;i[n>>0]=0;Y8(-210,p,347306,347314,1268);HF(p)}}Ph[o&511](s,q,d);f=q+36|0;a=k[f>>2]|0;if(a|0?(d=a+12|0,p=k[d>>2]|0,k[d>>2]=p+-1,(p|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;p=q+16|0;e=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[e>>2]|0)>0){f=k[q+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[q+44>>2]|0;if(!((a|0)==(q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=s+36|0;a=k[f>>2]|0;if(a|0?(p=a+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[s+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;q=s+16|0;e=s+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[e>>2]|0)>0){f=k[s+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[s+44>>2]|0;if((a|0)==(s+48|0)|(a|0)==0){r=t;return}ggb(k[a+-4>>2]|0);r=t;return}function Kra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=r;r=r+30816|0;O=P+29744|0;K=P+15408|0;L=P+1072|0;N=P+8|0;l=P;M=a+16|0;if(k[M>>2]|0){f=k[a+4>>2]|0;if((f|0)<3)d=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{g=k[a+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}if(!d)o=7}else o=7;if((o|0)==7){d=O+4|0;e=ZT(20)|0;k[e>>2]=1;f=e+4|0;k[O>>2]=f;k[d>>2]=13;i[e+17>>0]=0;g=347384;h=f+13|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,O,347398,347314,856);k[d>>2]=0;k[O>>2]=0;J=k[e>>2]|0;k[e>>2]=J+-1;if((J|0)==1)ggb(k[e+-4>>2]|0)}D=k[a+40>>2]|0;n=k[D+4>>2]|0;D=k[D>>2]|0;E=k[b+40>>2]|0;g=k[E+4>>2]|0;E=k[E>>2]|0;p=(k[a>>2]|0)>>>3;F=(p&511)+1|0;G=aa(F,g)|0;H=G+15&-16;f=(H*5|0)+16|0;I=O+8|0;k[O>>2]=I;J=O+4|0;k[J>>2]=264;d=I;if(f>>>0>264){e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[O>>2]=d}k[J>>2]=f;A=d+15&-16;B=N+8|0;k[N>>2]=B;C=N+4|0;k[C>>2]=264;if(G>>>0>264){e=G>>>0>1073741823?-1:G<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[N>>2]=d;z=d}else z=B;k[C>>2]=G;if(!(((n|0)>0&(D|0)>0?(y=(g<<1)-n|0,(((y|0)>-1?y:0-y|0)|0)<3):0)?(y=(E<<1)-D|0,(((y|0)>-1?y:0-y|0)|0)<3):0))o=25;if((o|0)==25?(k[l>>2]=0,y=l+4|0,k[y>>2]=0,m=ZT(136)|0,k[m>>2]=1,x=m+4|0,k[l>>2]=x,k[y>>2]=129,i[m+133>>0]=0,upb(x|0,347407,129)|0,Y8(-215,l,347398,347314,871),k[y>>2]=0,k[l>>2]=0,y=k[m>>2]|0,k[m>>2]=y+-1,(y|0)==1):0)ggb(k[m+-4>>2]|0);f=((n+-3|0)/2|0)+1|0;f=(g|0)<(f|0)?g:f;g=(f<<1)+-2|0;e=0;do{h=aa(uY(e+-2|0,n,c)|0,F)|0;l=aa(uY(g+e|0,n,c)|0,F)|0;m=aa(e,F)|0;d=0;do{y=d+m|0;k[K+(y<<2)>>2]=d+h;k[L+(y<<2)>>2]=d+l;d=d+1|0}while((d|0)!=(F|0));e=e+1|0}while((e|0)<7);x=aa(F,f)|0;y=(G|0)>0;if(y){e=F<<1;d=0;do{w=(aa(e,(d|0)/(F|0)|0)|0)+((d|0)%(F|0)|0)|0;k[z+(d<<2)>>2]=w;d=d+1|0}while((d|0)!=(G|0))}if((E|0)>0){w=b+16|0;v=b+44|0;u=a+44|0;t=p&65535;b=F<<1;a=F*3|0;q=F<<2;d=-2;p=0;do{s=(k[w>>2]|0)+(aa(k[k[v>>2]>>2]|0,p)|0)|0;o=p<<1;n=o+2|0;if((d|0)<=(n|0)){l=d;while(1){g=A+((aa((l+2|0)%5|0,H)|0)<<2)|0;h=uY(l,D,c)|0;h=(k[M>>2]|0)+(aa(k[k[u>>2]>>2]|0,h)|0)|0;d=F;f=K;e=0;while(1){if((e|0)<(d|0))do{k[g+(e<<2)>>2]=((j[h+(k[f+(e+a<<2)>>2]<<1)>>1]|0)+(j[h+(k[f+(e+F<<2)>>2]<<1)>>1]|0)<<2)+((j[h+(k[f+(e+b<<2)>>2]<<1)>>1]|0)*6|0)+(j[h+(k[f+(e<<2)>>2]<<1)>>1]|0)+(j[h+(k[f+(e+q<<2)>>2]<<1)>>1]|0);e=e+1|0}while((e|0)!=(d|0));else d=e;if((d|0)==(G|0))break;switch(t&511){case 0:{if((d|0)<(x|0)){do{m=d<<1;k[g+(d<<2)>>2]=(j[h+(m+-2<<1)>>1]|0)+((j[h+(m<<1)>>1]|0)*6|0)+((j[h+((m|1)<<1)>>1]|0)+(j[h+(m+-1<<1)>>1]|0)<<2)+(j[h+(m+2<<1)>>1]|0);d=d+1|0}while((d|0)<(x|0));e=x}else e=d;break}case 2:{if((d|0)<(x|0)){do{e=h+(d<<1<<1)|0;f=(j[e+-10>>1]|0)+((j[e+2>>1]|0)*6|0)+((j[e+8>>1]|0)+(j[e+-4>>1]|0)<<2)+(j[e+14>>1]|0)|0;m=(j[e+-8>>1]|0)+((j[e+4>>1]|0)*6|0)+((j[e+10>>1]|0)+(j[e+-2>>1]|0)<<2)+(j[e+16>>1]|0)|0;k[g+(d<<2)>>2]=(j[e+-12>>1]|0)+((j[e>>1]|0)*6|0)+((j[e+6>>1]|0)+(j[e+-6>>1]|0)<<2)+(j[e+12>>1]|0);k[g+(d+1<<2)>>2]=f;k[g+(d+2<<2)>>2]=m;d=d+3|0}while((d|0)<(x|0));e=d}else e=d;break}case 3:{if((d|0)<(x|0)){do{f=h+(d<<1<<1)|0;m=(j[f+-14>>1]|0)+((j[f+2>>1]|0)*6|0)+((j[f+10>>1]|0)+(j[f+-6>>1]|0)<<2)+(j[f+18>>1]|0)|0;k[g+(d<<2)>>2]=(j[f+-16>>1]|0)+((j[f>>1]|0)*6|0)+((j[f+8>>1]|0)+(j[f+-8>>1]|0)<<2)+(j[f+16>>1]|0);k[g+(d+1<<2)>>2]=m;m=(j[f+-10>>1]|0)+((j[f+6>>1]|0)*6|0)+((j[f+14>>1]|0)+(j[f+-2>>1]|0)<<2)+(j[f+22>>1]|0)|0;k[g+(d+2<<2)>>2]=(j[f+-12>>1]|0)+((j[f+4>>1]|0)*6|0)+((j[f+12>>1]|0)+(j[f+-4>>1]|0)<<2)+(j[f+20>>1]|0);k[g+(d+3<<2)>>2]=m;d=d+4|0}while((d|0)<(x|0));e=d}else e=d;break}default:if((d|0)<(x|0)){do{m=k[z+(d<<2)>>2]|0;k[g+(d<<2)>>2]=(j[h+(m-b<<1)>>1]|0)+((j[h+(m<<1)>>1]|0)*6|0)+((j[h+(m+F<<1)>>1]|0)+(j[h+(m-F<<1)>>1]|0)<<2)+(j[h+(m+b<<1)>>1]|0);d=d+1|0}while((d|0)<(x|0));e=x}else e=d}d=G;f=L+(0-e<<2)|0}d=l+1|0;if((l|0)<(n|0))l=d;else break}}l=A+((aa((o|0)%5|0,H)|0)<<2)|0;m=A+((aa((o|1|0)%5|0,H)|0)<<2)|0;g=A+((aa((n|0)%5|0,H)|0)<<2)|0;h=A+((aa((o+3|0)%5|0,H)|0)<<2)|0;f=A+((aa((o+4|0)%5|0,H)|0)<<2)|0;if(y){e=0;do{j[s+(e<<1)>>1]=(((k[g+(e<<2)>>2]|0)*6|0)+128+(k[l+(e<<2)>>2]|0)+((k[h+(e<<2)>>2]|0)+(k[m+(e<<2)>>2]|0)<<2)+(k[f+(e<<2)>>2]|0)|0)>>>8;e=e+1|0}while((e|0)!=(G|0))}p=p+1|0}while((p|0)<(E|0))}d=k[N>>2]|0;if((d|0)!=(B|0)){if(d|0)ggb(d);k[N>>2]=B;k[C>>2]=264}d=k[O>>2]|0;if((d|0)==(I|0)){r=P;return}if(d|0)ggb(d);k[O>>2]=I;k[J>>2]=264;r=P;return}function Lra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;Q=r;r=r+30816|0;P=Q+29744|0;L=Q+15408|0;M=Q+1072|0;O=Q+8|0;l=Q;N=a+16|0;if(k[N>>2]|0){f=k[a+4>>2]|0;if((f|0)<3)d=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{g=k[a+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}if(!d)p=7}else p=7;if((p|0)==7){d=P+4|0;e=ZT(20)|0;k[e>>2]=1;f=e+4|0;k[P>>2]=f;k[d>>2]=13;i[e+17>>0]=0;g=347384;h=f+13|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,P,347398,347314,856);k[d>>2]=0;k[P>>2]=0;K=k[e>>2]|0;k[e>>2]=K+-1;if((K|0)==1)ggb(k[e+-4>>2]|0)}E=k[a+40>>2]|0;o=k[E+4>>2]|0;E=k[E>>2]|0;F=k[b+40>>2]|0;g=k[F+4>>2]|0;F=k[F>>2]|0;q=(k[a>>2]|0)>>>3;G=(q&511)+1|0;H=aa(G,g)|0;I=H+15&-16;f=(I*5|0)+16|0;J=P+8|0;k[P>>2]=J;K=P+4|0;k[K>>2]=264;d=J;if(f>>>0>264){e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[P>>2]=d}k[K>>2]=f;B=d+15&-16;C=O+8|0;k[O>>2]=C;D=O+4|0;k[D>>2]=264;if(H>>>0>264){e=H>>>0>1073741823?-1:H<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[O>>2]=d;A=d}else A=C;k[D>>2]=H;if(!(((o|0)>0&(E|0)>0?(z=(g<<1)-o|0,(((z|0)>-1?z:0-z|0)|0)<3):0)?(z=(F<<1)-E|0,(((z|0)>-1?z:0-z|0)|0)<3):0))p=25;if((p|0)==25?(k[l>>2]=0,z=l+4|0,k[z>>2]=0,n=ZT(136)|0,k[n>>2]=1,y=n+4|0,k[l>>2]=y,k[z>>2]=129,i[n+133>>0]=0,upb(y|0,347407,129)|0,Y8(-215,l,347398,347314,871),k[z>>2]=0,k[l>>2]=0,z=k[n>>2]|0,k[n>>2]=z+-1,(z|0)==1):0)ggb(k[n+-4>>2]|0);f=((o+-3|0)/2|0)+1|0;f=(g|0)<(f|0)?g:f;g=(f<<1)+-2|0;e=0;do{h=aa(uY(e+-2|0,o,c)|0,G)|0;l=aa(uY(g+e|0,o,c)|0,G)|0;n=aa(e,G)|0;d=0;do{z=d+n|0;k[L+(z<<2)>>2]=d+h;k[M+(z<<2)>>2]=d+l;d=d+1|0}while((d|0)!=(G|0));e=e+1|0}while((e|0)<7);y=aa(G,f)|0;z=(H|0)>0;if(z){e=G<<1;d=0;do{x=(aa(e,(d|0)/(G|0)|0)|0)+((d|0)%(G|0)|0)|0;k[A+(d<<2)>>2]=x;d=d+1|0}while((d|0)!=(H|0))}if((F|0)>0){x=b+16|0;w=b+44|0;v=a+44|0;u=q&65535;b=G<<1;a=G*3|0;s=G<<2;d=-2;q=0;do{t=(k[x>>2]|0)+(aa(k[k[w>>2]>>2]|0,q)|0)|0;p=q<<1;o=p+2|0;if((d|0)<=(o|0)){l=d;while(1){g=B+((aa((l+2|0)%5|0,I)|0)<<2)|0;h=uY(l,E,c)|0;h=(k[N>>2]|0)+(aa(k[k[v>>2]>>2]|0,h)|0)|0;d=G;f=L;e=0;while(1){if((e|0)<(d|0))do{k[g+(e<<2)>>2]=((m[h+(k[f+(e+a<<2)>>2]<<1)>>1]|0)+(m[h+(k[f+(e+G<<2)>>2]<<1)>>1]|0)<<2)+((m[h+(k[f+(e+b<<2)>>2]<<1)>>1]|0)*6|0)+(m[h+(k[f+(e<<2)>>2]<<1)>>1]|0)+(m[h+(k[f+(e+s<<2)>>2]<<1)>>1]|0);e=e+1|0}while((e|0)!=(d|0));else d=e;if((d|0)==(H|0))break;switch(u&511){case 0:{if((d|0)<(y|0)){do{n=d<<1;k[g+(d<<2)>>2]=(m[h+(n+-2<<1)>>1]|0)+((m[h+(n<<1)>>1]|0)*6|0)+((m[h+((n|1)<<1)>>1]|0)+(m[h+(n+-1<<1)>>1]|0)<<2)+(m[h+(n+2<<1)>>1]|0);d=d+1|0}while((d|0)<(y|0));e=y}else e=d;break}case 2:{if((d|0)<(y|0)){do{e=h+(d<<1<<1)|0;f=(m[e+-10>>1]|0)+((m[e+2>>1]|0)*6|0)+((m[e+8>>1]|0)+(m[e+-4>>1]|0)<<2)+(m[e+14>>1]|0)|0;n=(m[e+-8>>1]|0)+((m[e+4>>1]|0)*6|0)+((m[e+10>>1]|0)+(m[e+-2>>1]|0)<<2)+(m[e+16>>1]|0)|0;k[g+(d<<2)>>2]=(m[e+-12>>1]|0)+((m[e>>1]|0)*6|0)+((m[e+6>>1]|0)+(m[e+-6>>1]|0)<<2)+(m[e+12>>1]|0);k[g+(d+1<<2)>>2]=f;k[g+(d+2<<2)>>2]=n;d=d+3|0}while((d|0)<(y|0));e=d}else e=d;break}case 3:{if((d|0)<(y|0)){do{f=h+(d<<1<<1)|0;n=(m[f+-14>>1]|0)+((m[f+2>>1]|0)*6|0)+((m[f+10>>1]|0)+(m[f+-6>>1]|0)<<2)+(m[f+18>>1]|0)|0;k[g+(d<<2)>>2]=(m[f+-16>>1]|0)+((m[f>>1]|0)*6|0)+((m[f+8>>1]|0)+(m[f+-8>>1]|0)<<2)+(m[f+16>>1]|0);k[g+(d+1<<2)>>2]=n;n=(m[f+-10>>1]|0)+((m[f+6>>1]|0)*6|0)+((m[f+14>>1]|0)+(m[f+-2>>1]|0)<<2)+(m[f+22>>1]|0)|0;k[g+(d+2<<2)>>2]=(m[f+-12>>1]|0)+((m[f+4>>1]|0)*6|0)+((m[f+12>>1]|0)+(m[f+-4>>1]|0)<<2)+(m[f+20>>1]|0);k[g+(d+3<<2)>>2]=n;d=d+4|0}while((d|0)<(y|0));e=d}else e=d;break}default:if((d|0)<(y|0)){do{n=k[A+(d<<2)>>2]|0;k[g+(d<<2)>>2]=(m[h+(n-b<<1)>>1]|0)+((m[h+(n<<1)>>1]|0)*6|0)+((m[h+(n+G<<1)>>1]|0)+(m[h+(n-G<<1)>>1]|0)<<2)+(m[h+(n+b<<1)>>1]|0);d=d+1|0}while((d|0)<(y|0));e=y}else e=d}d=H;f=M+(0-e<<2)|0}d=l+1|0;if((l|0)<(o|0))l=d;else break}}l=B+((aa((p|0)%5|0,I)|0)<<2)|0;n=B+((aa((p|1|0)%5|0,I)|0)<<2)|0;g=B+((aa((o|0)%5|0,I)|0)<<2)|0;h=B+((aa((p+3|0)%5|0,I)|0)<<2)|0;f=B+((aa((p+4|0)%5|0,I)|0)<<2)|0;if(z){e=0;do{j[t+(e<<1)>>1]=(((k[g+(e<<2)>>2]|0)*6|0)+128+(k[l+(e<<2)>>2]|0)+((k[h+(e<<2)>>2]|0)+(k[n+(e<<2)>>2]|0)<<2)+(k[f+(e<<2)>>2]|0)|0)>>>8;e=e+1|0}while((e|0)!=(H|0))}q=q+1|0}while((q|0)<(F|0))}d=k[O>>2]|0;if((d|0)!=(C|0)){if(d|0)ggb(d);k[O>>2]=C;k[D>>2]=264}d=k[P>>2]|0;if((d|0)==(J|0)){r=Q;return}if(d|0)ggb(d);k[P>>2]=J;k[K>>2]=264;r=Q;return}function Mra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0;P=r;r=r+30816|0;O=P+29744|0;K=P+15408|0;L=P+1072|0;N=P+8|0;j=P;M=a+16|0;if(k[M>>2]|0){f=k[a+4>>2]|0;if((f|0)<3)d=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{g=k[a+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}if(!d)n=7}else n=7;if((n|0)==7){d=O+4|0;e=ZT(20)|0;k[e>>2]=1;f=e+4|0;k[O>>2]=f;k[d>>2]=13;i[e+17>>0]=0;g=347384;h=f+13|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,O,347398,347314,856);k[d>>2]=0;k[O>>2]=0;J=k[e>>2]|0;k[e>>2]=J+-1;if((J|0)==1)ggb(k[e+-4>>2]|0)}D=k[a+40>>2]|0;m=k[D+4>>2]|0;D=k[D>>2]|0;E=k[b+40>>2]|0;g=k[E+4>>2]|0;E=k[E>>2]|0;p=(k[a>>2]|0)>>>3;F=(p&511)+1|0;G=aa(F,g)|0;H=G+15&-16;f=(H*5|0)+16|0;I=O+8|0;k[O>>2]=I;J=O+4|0;k[J>>2]=264;d=I;if(f>>>0>264){e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[O>>2]=d}k[J>>2]=f;A=d+15&-16;B=N+8|0;k[N>>2]=B;C=N+4|0;k[C>>2]=264;if(G>>>0>264){e=G>>>0>1073741823?-1:G<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[N>>2]=d;z=d}else z=B;k[C>>2]=G;if(!(((m|0)>0&(D|0)>0?(y=(g<<1)-m|0,(((y|0)>-1?y:0-y|0)|0)<3):0)?(y=(E<<1)-D|0,(((y|0)>-1?y:0-y|0)|0)<3):0))n=25;if((n|0)==25?(k[j>>2]=0,y=j+4|0,k[y>>2]=0,l=ZT(136)|0,k[l>>2]=1,x=l+4|0,k[j>>2]=x,k[y>>2]=129,i[l+133>>0]=0,upb(x|0,347407,129)|0,Y8(-215,j,347398,347314,871),k[y>>2]=0,k[j>>2]=0,y=k[l>>2]|0,k[l>>2]=y+-1,(y|0)==1):0)ggb(k[l+-4>>2]|0);f=((m+-3|0)/2|0)+1|0;f=(g|0)<(f|0)?g:f;g=(f<<1)+-2|0;e=0;do{h=aa(uY(e+-2|0,m,c)|0,F)|0;j=aa(uY(g+e|0,m,c)|0,F)|0;l=aa(e,F)|0;d=0;do{y=d+l|0;k[K+(y<<2)>>2]=d+h;k[L+(y<<2)>>2]=d+j;d=d+1|0}while((d|0)!=(F|0));e=e+1|0}while((e|0)<7);x=aa(F,f)|0;y=(G|0)>0;if(y){e=F<<1;d=0;do{w=(aa(e,(d|0)/(F|0)|0)|0)+((d|0)%(F|0)|0)|0;k[z+(d<<2)>>2]=w;d=d+1|0}while((d|0)!=(G|0))}if((E|0)>0){w=b+16|0;v=b+44|0;u=a+44|0;t=p&65535;b=F<<1;a=F*3|0;q=F<<2;d=-2;p=0;do{s=(k[w>>2]|0)+(aa(k[k[v>>2]>>2]|0,p)|0)|0;n=p<<1;m=n+2|0;if((d|0)<=(m|0)){j=d;while(1){g=A+((aa((j+2|0)%5|0,H)|0)<<2)|0;h=uY(j,D,c)|0;h=(k[M>>2]|0)+(aa(k[k[u>>2]>>2]|0,h)|0)|0;d=F;f=K;e=0;while(1){if((e|0)<(d|0))do{o[g+(e<<2)>>2]=+o[h+(k[f+(e<<2)>>2]<<2)>>2]+(+o[h+(k[f+(e+b<<2)>>2]<<2)>>2]*6.0+(+o[h+(k[f+(e+F<<2)>>2]<<2)>>2]+ +o[h+(k[f+(e+a<<2)>>2]<<2)>>2])*4.0)+ +o[h+(k[f+(e+q<<2)>>2]<<2)>>2];e=e+1|0}while((e|0)!=(d|0));else d=e;if((d|0)==(G|0))break;switch(t&511){case 0:{if((d|0)<(x|0)){do{l=d<<1;o[g+(d<<2)>>2]=+o[h+(l+2<<2)>>2]+(+o[h+(l+-2<<2)>>2]+(+o[h+(l<<2)>>2]*6.0+(+o[h+(l+-1<<2)>>2]+ +o[h+((l|1)<<2)>>2])*4.0));d=d+1|0}while((d|0)<(x|0));e=x}else e=d;break}case 2:{if((d|0)<(x|0)){do{l=h+(d<<1<<2)|0;R=+o[l+28>>2]+(+o[l+-20>>2]+(+o[l+4>>2]*6.0+(+o[l+-8>>2]+ +o[l+16>>2])*4.0));Q=+o[l+32>>2]+(+o[l+-16>>2]+(+o[l+8>>2]*6.0+(+o[l+-4>>2]+ +o[l+20>>2])*4.0));o[g+(d<<2)>>2]=+o[l+24>>2]+(+o[l+-24>>2]+(+o[l>>2]*6.0+(+o[l+-12>>2]+ +o[l+12>>2])*4.0));o[g+(d+1<<2)>>2]=R;o[g+(d+2<<2)>>2]=Q;d=d+3|0}while((d|0)<(x|0));e=d}else e=d;break}case 3:{if((d|0)<(x|0)){do{l=h+(d<<1<<2)|0;R=+o[l+36>>2]+(+o[l+-28>>2]+(+o[l+4>>2]*6.0+(+o[l+-12>>2]+ +o[l+20>>2])*4.0));o[g+(d<<2)>>2]=+o[l+32>>2]+(+o[l+-32>>2]+(+o[l>>2]*6.0+(+o[l+-16>>2]+ +o[l+16>>2])*4.0));o[g+(d+1<<2)>>2]=R;R=+o[l+44>>2]+(+o[l+-20>>2]+(+o[l+12>>2]*6.0+(+o[l+-4>>2]+ +o[l+28>>2])*4.0));o[g+(d+2<<2)>>2]=+o[l+40>>2]+(+o[l+-24>>2]+(+o[l+8>>2]*6.0+(+o[l+-8>>2]+ +o[l+24>>2])*4.0));o[g+(d+3<<2)>>2]=R;d=d+4|0}while((d|0)<(x|0));e=d}else e=d;break}default:if((d|0)<(x|0)){do{l=k[z+(d<<2)>>2]|0;o[g+(d<<2)>>2]=+o[h+(l+b<<2)>>2]+(+o[h+(l-b<<2)>>2]+(+o[h+(l<<2)>>2]*6.0+(+o[h+(l-F<<2)>>2]+ +o[h+(l+F<<2)>>2])*4.0));d=d+1|0}while((d|0)<(x|0));e=x}else e=d}d=G;f=L+(0-e<<2)|0}d=j+1|0;if((j|0)<(m|0))j=d;else break}}j=A+((aa((n|0)%5|0,H)|0)<<2)|0;l=A+((aa((n|1|0)%5|0,H)|0)<<2)|0;g=A+((aa((m|0)%5|0,H)|0)<<2)|0;h=A+((aa((n+3|0)%5|0,H)|0)<<2)|0;f=A+((aa((n+4|0)%5|0,H)|0)<<2)|0;if(y){e=0;do{o[s+(e<<2)>>2]=(+o[f+(e<<2)>>2]+(+o[j+(e<<2)>>2]+(+o[g+(e<<2)>>2]*6.0+(+o[l+(e<<2)>>2]+ +o[h+(e<<2)>>2])*4.0)))*.00390625;e=e+1|0}while((e|0)!=(G|0))}p=p+1|0}while((p|0)<(E|0))}d=k[N>>2]|0;if((d|0)!=(B|0)){if(d|0)ggb(d);k[N>>2]=B;k[C>>2]=264}d=k[O>>2]|0;if((d|0)==(I|0)){r=P;return}if(d|0)ggb(d);k[O>>2]=I;k[J>>2]=264;r=P;return}function Nra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0;P=r;r=r+30848|0;O=P;K=P+16504|0;L=P+2168|0;N=P+1104|0;j=P+1096|0;M=a+16|0;if(k[M>>2]|0){f=k[a+4>>2]|0;if((f|0)<3)d=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{g=k[a+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}if(!d)n=7}else n=7;if((n|0)==7){d=O+4|0;e=ZT(20)|0;k[e>>2]=1;f=e+4|0;k[O>>2]=f;k[d>>2]=13;i[e+17>>0]=0;g=347384;h=f+13|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,O,347398,347314,856);k[d>>2]=0;k[O>>2]=0;J=k[e>>2]|0;k[e>>2]=J+-1;if((J|0)==1)ggb(k[e+-4>>2]|0)}D=k[a+40>>2]|0;m=k[D+4>>2]|0;D=k[D>>2]|0;E=k[b+40>>2]|0;g=k[E+4>>2]|0;E=k[E>>2]|0;o=(k[a>>2]|0)>>>3;F=(o&511)+1|0;G=aa(F,g)|0;H=G+15&-16;f=(H*5|0)+16|0;I=O+8|0;k[O>>2]=I;J=O+4|0;k[J>>2]=136;d=I;if(f>>>0>136){e=f>>>0>536870911?-1:f<<3;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[O>>2]=d}k[J>>2]=f;A=d+15&-16;B=N+8|0;k[N>>2]=B;C=N+4|0;k[C>>2]=264;if(G>>>0>264){e=G>>>0>1073741823?-1:G<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[N>>2]=d;z=d}else z=B;k[C>>2]=G;if(!(((m|0)>0&(D|0)>0?(y=(g<<1)-m|0,(((y|0)>-1?y:0-y|0)|0)<3):0)?(y=(E<<1)-D|0,(((y|0)>-1?y:0-y|0)|0)<3):0))n=25;if((n|0)==25?(k[j>>2]=0,y=j+4|0,k[y>>2]=0,l=ZT(136)|0,k[l>>2]=1,x=l+4|0,k[j>>2]=x,k[y>>2]=129,i[l+133>>0]=0,upb(x|0,347407,129)|0,Y8(-215,j,347398,347314,871),k[y>>2]=0,k[j>>2]=0,y=k[l>>2]|0,k[l>>2]=y+-1,(y|0)==1):0)ggb(k[l+-4>>2]|0);f=((m+-3|0)/2|0)+1|0;f=(g|0)<(f|0)?g:f;g=(f<<1)+-2|0;e=0;do{h=aa(uY(e+-2|0,m,c)|0,F)|0;j=aa(uY(g+e|0,m,c)|0,F)|0;l=aa(e,F)|0;d=0;do{y=d+l|0;k[K+(y<<2)>>2]=d+h;k[L+(y<<2)>>2]=d+j;d=d+1|0}while((d|0)!=(F|0));e=e+1|0}while((e|0)<7);x=aa(F,f)|0;y=(G|0)>0;if(y){e=F<<1;d=0;do{w=(aa(e,(d|0)/(F|0)|0)|0)+((d|0)%(F|0)|0)|0;k[z+(d<<2)>>2]=w;d=d+1|0}while((d|0)!=(G|0))}if((E|0)>0){w=b+16|0;v=b+44|0;u=a+44|0;t=o&65535;b=F<<1;a=F*3|0;q=F<<2;d=-2;o=0;do{s=(k[w>>2]|0)+(aa(k[k[v>>2]>>2]|0,o)|0)|0;n=o<<1;m=n+2|0;if((d|0)<=(m|0)){j=d;while(1){g=A+((aa((j+2|0)%5|0,H)|0)<<3)|0;h=uY(j,D,c)|0;h=(k[M>>2]|0)+(aa(k[k[u>>2]>>2]|0,h)|0)|0;d=F;f=K;e=0;while(1){if((e|0)<(d|0))do{p[g+(e<<3)>>3]=+p[h+(k[f+(e<<2)>>2]<<3)>>3]+(+p[h+(k[f+(e+b<<2)>>2]<<3)>>3]*6.0+(+p[h+(k[f+(e+F<<2)>>2]<<3)>>3]+ +p[h+(k[f+(e+a<<2)>>2]<<3)>>3])*4.0)+ +p[h+(k[f+(e+q<<2)>>2]<<3)>>3];e=e+1|0}while((e|0)!=(d|0));else d=e;if((d|0)==(G|0))break;switch(t&511){case 0:{if((d|0)<(x|0)){do{l=d<<1;p[g+(d<<3)>>3]=+p[h+(l+2<<3)>>3]+(+p[h+(l+-2<<3)>>3]+(+p[h+(l<<3)>>3]*6.0+(+p[h+(l+-1<<3)>>3]+ +p[h+((l|1)<<3)>>3])*4.0));d=d+1|0}while((d|0)<(x|0));e=x}else e=d;break}case 2:{if((d|0)<(x|0)){do{l=h+(d<<1<<3)|0;R=+p[l+56>>3]+(+p[l+-40>>3]+(+p[l+8>>3]*6.0+(+p[l+-16>>3]+ +p[l+32>>3])*4.0));Q=+p[l+64>>3]+(+p[l+-32>>3]+(+p[l+16>>3]*6.0+(+p[l+-8>>3]+ +p[l+40>>3])*4.0));p[g+(d<<3)>>3]=+p[l+48>>3]+(+p[l+-48>>3]+(+p[l>>3]*6.0+(+p[l+-24>>3]+ +p[l+24>>3])*4.0));p[g+(d+1<<3)>>3]=R;p[g+(d+2<<3)>>3]=Q;d=d+3|0}while((d|0)<(x|0));e=d}else e=d;break}case 3:{if((d|0)<(x|0)){do{l=h+(d<<1<<3)|0;R=+p[l+72>>3]+(+p[l+-56>>3]+(+p[l+8>>3]*6.0+(+p[l+-24>>3]+ +p[l+40>>3])*4.0));p[g+(d<<3)>>3]=+p[l+64>>3]+(+p[l+-64>>3]+(+p[l>>3]*6.0+(+p[l+-32>>3]+ +p[l+32>>3])*4.0));p[g+(d+1<<3)>>3]=R;R=+p[l+88>>3]+(+p[l+-40>>3]+(+p[l+24>>3]*6.0+(+p[l+-8>>3]+ +p[l+56>>3])*4.0));p[g+(d+2<<3)>>3]=+p[l+80>>3]+(+p[l+-48>>3]+(+p[l+16>>3]*6.0+(+p[l+-16>>3]+ +p[l+48>>3])*4.0));p[g+(d+3<<3)>>3]=R;d=d+4|0}while((d|0)<(x|0));e=d}else e=d;break}default:if((d|0)<(x|0)){do{l=k[z+(d<<2)>>2]|0;p[g+(d<<3)>>3]=+p[h+(l+b<<3)>>3]+(+p[h+(l-b<<3)>>3]+(+p[h+(l<<3)>>3]*6.0+(+p[h+(l-F<<3)>>3]+ +p[h+(l+F<<3)>>3])*4.0));d=d+1|0}while((d|0)<(x|0));e=x}else e=d}d=G;f=L+(0-e<<2)|0}d=j+1|0;if((j|0)<(m|0))j=d;else break}}j=A+((aa((n|0)%5|0,H)|0)<<3)|0;l=A+((aa((n|1|0)%5|0,H)|0)<<3)|0;g=A+((aa((m|0)%5|0,H)|0)<<3)|0;h=A+((aa((n+3|0)%5|0,H)|0)<<3)|0;f=A+((aa((n+4|0)%5|0,H)|0)<<3)|0;if(y){e=0;do{p[s+(e<<3)>>3]=(+p[f+(e<<3)>>3]+(+p[j+(e<<3)>>3]+(+p[g+(e<<3)>>3]*6.0+(+p[l+(e<<3)>>3]+ +p[h+(e<<3)>>3])*4.0)))*.00390625;e=e+1|0}while((e|0)!=(G|0))}o=o+1|0}while((o|0)<(E|0))}d=k[N>>2]|0;if((d|0)!=(B|0)){if(d|0)ggb(d);k[N>>2]=B;k[C>>2]=264}d=k[O>>2]|0;if((d|0)==(I|0)){r=P;return}if(d|0)ggb(d);k[O>>2]=I;k[J>>2]=136;r=P;return}function Ora(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=r;r=r+30816|0;O=P+29744|0;K=P+15408|0;L=P+1072|0;N=P+8|0;j=P;M=a+16|0;if(k[M>>2]|0){f=k[a+4>>2]|0;if((f|0)<3)d=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{g=k[a+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}if(!d)o=7}else o=7;if((o|0)==7){d=O+4|0;e=ZT(20)|0;k[e>>2]=1;f=e+4|0;k[O>>2]=f;k[d>>2]=13;i[e+17>>0]=0;g=347384;h=f+13|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,O,347398,347314,856);k[d>>2]=0;k[O>>2]=0;J=k[e>>2]|0;k[e>>2]=J+-1;if((J|0)==1)ggb(k[e+-4>>2]|0)}D=k[a+40>>2]|0;n=k[D+4>>2]|0;D=k[D>>2]|0;E=k[b+40>>2]|0;g=k[E+4>>2]|0;E=k[E>>2]|0;p=(k[a>>2]|0)>>>3;F=(p&511)+1|0;G=aa(F,g)|0;H=G+15&-16;f=(H*5|0)+16|0;I=O+8|0;k[O>>2]=I;J=O+4|0;k[J>>2]=264;d=I;if(f>>>0>264){e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[O>>2]=d}k[J>>2]=f;A=d+15&-16;B=N+8|0;k[N>>2]=B;C=N+4|0;k[C>>2]=264;if(G>>>0>264){e=G>>>0>1073741823?-1:G<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[N>>2]=d;z=d}else z=B;k[C>>2]=G;if(!(((n|0)>0&(D|0)>0?(y=(g<<1)-n|0,(((y|0)>-1?y:0-y|0)|0)<3):0)?(y=(E<<1)-D|0,(((y|0)>-1?y:0-y|0)|0)<3):0))o=25;if((o|0)==25?(k[j>>2]=0,y=j+4|0,k[y>>2]=0,m=ZT(136)|0,k[m>>2]=1,x=m+4|0,k[j>>2]=x,k[y>>2]=129,i[m+133>>0]=0,upb(x|0,347407,129)|0,Y8(-215,j,347398,347314,871),k[y>>2]=0,k[j>>2]=0,y=k[m>>2]|0,k[m>>2]=y+-1,(y|0)==1):0)ggb(k[m+-4>>2]|0);f=((n+-3|0)/2|0)+1|0;f=(g|0)<(f|0)?g:f;g=(f<<1)+-2|0;e=0;do{h=aa(uY(e+-2|0,n,c)|0,F)|0;j=aa(uY(g+e|0,n,c)|0,F)|0;m=aa(e,F)|0;d=0;do{y=d+m|0;k[K+(y<<2)>>2]=d+h;k[L+(y<<2)>>2]=d+j;d=d+1|0}while((d|0)!=(F|0));e=e+1|0}while((e|0)<7);x=aa(F,f)|0;y=(G|0)>0;if(y){e=F<<1;d=0;do{w=(aa(e,(d|0)/(F|0)|0)|0)+((d|0)%(F|0)|0)|0;k[z+(d<<2)>>2]=w;d=d+1|0}while((d|0)!=(G|0))}if((E|0)>0){w=b+16|0;v=b+44|0;u=a+44|0;t=p&65535;b=F<<1;a=F*3|0;q=F<<2;d=-2;p=0;do{s=(k[w>>2]|0)+(aa(k[k[v>>2]>>2]|0,p)|0)|0;o=p<<1;n=o+2|0;if((d|0)<=(n|0)){j=d;while(1){g=A+((aa((j+2|0)%5|0,H)|0)<<2)|0;h=uY(j,D,c)|0;h=(k[M>>2]|0)+(aa(k[k[u>>2]>>2]|0,h)|0)|0;d=F;f=K;e=0;while(1){if((e|0)<(d|0))do{k[g+(e<<2)>>2]=((l[h+(k[f+(e+a<<2)>>2]|0)>>0]|0)+(l[h+(k[f+(e+F<<2)>>2]|0)>>0]|0)<<2)+((l[h+(k[f+(e+b<<2)>>2]|0)>>0]|0)*6|0)+(l[h+(k[f+(e<<2)>>2]|0)>>0]|0)+(l[h+(k[f+(e+q<<2)>>2]|0)>>0]|0);e=e+1|0}while((e|0)!=(d|0));else d=e;if((d|0)==(G|0))break;switch(t&511){case 0:{if((d|0)<(x|0)){do{m=d<<1;k[g+(d<<2)>>2]=(l[h+(m+-2)>>0]|0)+((l[h+m>>0]|0)*6|0)+((l[h+(m|1)>>0]|0)+(l[h+(m+-1)>>0]|0)<<2)+(l[h+(m+2)>>0]|0);d=d+1|0}while((d|0)<(x|0));e=x}else e=d;break}case 2:{if((d|0)<(x|0)){do{e=h+(d<<1)|0;f=(l[e+-5>>0]|0)+((l[e+1>>0]|0)*6|0)+((l[e+4>>0]|0)+(l[e+-2>>0]|0)<<2)+(l[e+7>>0]|0)|0;m=(l[e+-4>>0]|0)+((l[e+2>>0]|0)*6|0)+((l[e+5>>0]|0)+(l[e+-1>>0]|0)<<2)+(l[e+8>>0]|0)|0;k[g+(d<<2)>>2]=(l[e+-6>>0]|0)+((l[e>>0]|0)*6|0)+((l[e+3>>0]|0)+(l[e+-3>>0]|0)<<2)+(l[e+6>>0]|0);k[g+(d+1<<2)>>2]=f;k[g+(d+2<<2)>>2]=m;d=d+3|0}while((d|0)<(x|0));e=d}else e=d;break}case 3:{if((d|0)<(x|0)){do{f=h+(d<<1)|0;m=(l[f+-7>>0]|0)+((l[f+1>>0]|0)*6|0)+((l[f+5>>0]|0)+(l[f+-3>>0]|0)<<2)+(l[f+9>>0]|0)|0;k[g+(d<<2)>>2]=(l[f+-8>>0]|0)+((l[f>>0]|0)*6|0)+((l[f+4>>0]|0)+(l[f+-4>>0]|0)<<2)+(l[f+8>>0]|0);k[g+(d+1<<2)>>2]=m;m=(l[f+-5>>0]|0)+((l[f+3>>0]|0)*6|0)+((l[f+7>>0]|0)+(l[f+-1>>0]|0)<<2)+(l[f+11>>0]|0)|0;k[g+(d+2<<2)>>2]=(l[f+-6>>0]|0)+((l[f+2>>0]|0)*6|0)+((l[f+6>>0]|0)+(l[f+-2>>0]|0)<<2)+(l[f+10>>0]|0);k[g+(d+3<<2)>>2]=m;d=d+4|0}while((d|0)<(x|0));e=d}else e=d;break}default:if((d|0)<(x|0)){do{m=k[z+(d<<2)>>2]|0;k[g+(d<<2)>>2]=(l[h+(m-b)>>0]|0)+((l[h+m>>0]|0)*6|0)+((l[h+(m+F)>>0]|0)+(l[h+(m-F)>>0]|0)<<2)+(l[h+(m+b)>>0]|0);d=d+1|0}while((d|0)<(x|0));e=x}else e=d}d=G;f=L+(0-e<<2)|0}d=j+1|0;if((j|0)<(n|0))j=d;else break}}j=A+((aa((o|0)%5|0,H)|0)<<2)|0;m=A+((aa((o|1|0)%5|0,H)|0)<<2)|0;g=A+((aa((n|0)%5|0,H)|0)<<2)|0;h=A+((aa((o+3|0)%5|0,H)|0)<<2)|0;f=A+((aa((o+4|0)%5|0,H)|0)<<2)|0;if(y){e=0;do{i[s+e>>0]=(((k[g+(e<<2)>>2]|0)*6|0)+128+(k[j+(e<<2)>>2]|0)+((k[h+(e<<2)>>2]|0)+(k[m+(e<<2)>>2]|0)<<2)+(k[f+(e<<2)>>2]|0)|0)>>>8;e=e+1|0}while((e|0)!=(G|0))}p=p+1|0}while((p|0)<(E|0))}d=k[N>>2]|0;if((d|0)!=(B|0)){if(d|0)ggb(d);k[N>>2]=B;k[C>>2]=264}d=k[O>>2]|0;if((d|0)==(I|0)){r=P;return}if(d|0)ggb(d);k[O>>2]=I;k[J>>2]=264;r=P;return}function Pra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+128|0;s=t+72|0;n=t+64|0;q=t+8|0;p=t;if((d|0)!=4){f=s+4|0;e=ZT(36)|0;k[e>>2]=1;g=e+4|0;k[s>>2]=g;k[f>>2]=28;i[e+32>>0]=0;h=347537;j=g+28|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,s,347566,347314,1335);k[f>>2]=0;k[s>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[s>>2]=k[g>>2];m=s+4|0;a=g+4|0;k[m>>2]=k[a>>2];l=s+8|0;k[l>>2]=k[g+8>>2];k[s+12>>2]=k[g+12>>2];k[s+16>>2]=k[g+16>>2];k[s+20>>2]=k[g+20>>2];k[s+24>>2]=k[g+24>>2];k[s+28>>2]=k[g+28>>2];k[s+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[s+36>>2]=e;f=s+40|0;k[f>>2]=l;l=s+48|0;j=s+44|0;k[j>>2]=l;k[s+52>>2]=0;k[l>>2]=0;if(e|0){l=e+12|0;k[l>>2]=(k[l>>2]|0)+1}if((k[a>>2]|0)<3){l=k[g+44>>2]|0;m=k[j>>2]|0;k[m>>2]=k[l>>2];k[m+4>>2]=k[l+4>>2];break}k[m>>2]=0;x1(s,k[a>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[l+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0))}}else Q1(s,a,-1);while(0);e=k[c>>2]|0;a=k[c+4>>2]|0;if(!(aa(a,e)|0)){e=k[s+12>>2]<<1;a=k[s+8>>2]<<1}k[n>>2]=e;k[n+4>>2]=a;x2(b,n,k[s>>2]&4095,0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[q>>2]=k[g>>2];m=q+4|0;a=g+4|0;k[m>>2]=k[a>>2];n=q+8|0;k[n>>2]=k[g+8>>2];k[q+12>>2]=k[g+12>>2];k[q+16>>2]=k[g+16>>2];k[q+20>>2]=k[g+20>>2];k[q+24>>2]=k[g+24>>2];k[q+28>>2]=k[g+28>>2];k[q+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[q+36>>2]=e;f=q+40|0;k[f>>2]=n;n=q+48|0;j=q+44|0;k[j>>2]=n;k[q+52>>2]=0;k[n>>2]=0;if(e|0){n=e+12|0;k[n>>2]=(k[n>>2]|0)+1}if((k[a>>2]|0)<3){b=k[g+44>>2]|0;n=k[j>>2]|0;k[n>>2]=k[b>>2];k[n+4>>2]=k[b+4>>2];break}k[m>>2]=0;x1(q,k[a>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[j>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[l+(a<<2)>>2];k[e+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[m>>2]|0))}}else Q1(q,b,-1);while(0);switch(k[s>>2]&7){case 0:{o=302;break}case 3:{o=303;break}case 2:{o=304;break}case 5:{o=305;break}case 6:{o=306;break}default:{k[p>>2]=0;b=p+4|0;k[b>>2]=0;n=ZT(8)|0;k[n>>2]=1;n=n+4|0;k[p>>2]=n;k[b>>2]=0;i[n>>0]=0;Y8(-210,p,347566,347314,1372);HF(p)}}Ph[o&511](s,q,d);f=q+36|0;a=k[f>>2]|0;if(a|0?(d=a+12|0,p=k[d>>2]|0,k[d>>2]=p+-1,(p|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;p=q+16|0;e=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[e>>2]|0)>0){f=k[q+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[q+44>>2]|0;if(!((a|0)==(q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=s+36|0;a=k[f>>2]|0;if(a|0?(p=a+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[s+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;q=s+16|0;e=s+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[e>>2]|0)>0){f=k[s+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[s+44>>2]|0;if((a|0)==(s+48|0)|(a|0)==0){r=t;return}ggb(k[a+-4>>2]|0);r=t;return}function Qra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;L=r;r=r+2144|0;K=L+1072|0;H=L+8|0;m=L;D=k[a+40>>2]|0;f=k[D+4>>2]|0;D=k[D>>2]|0;E=k[b+40>>2]|0;l=k[E+4>>2]|0;E=k[E>>2]|0;F=((k[a>>2]|0)>>>3&511)+1|0;G=(aa(F,l+1|0)|0)+15&-16;e=(G*3|0)+16|0;I=K+8|0;k[K>>2]=I;J=K+4|0;k[J>>2]=264;c=I;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[K>>2]=c}k[J>>2]=e;A=c+15&-16;h=aa(F,f)|0;B=H+8|0;k[H>>2]=B;C=H+4|0;k[C>>2]=264;if(h>>>0>264){d=h>>>0>1073741823?-1:h<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[H>>2]=c;z=c}else z=B;k[C>>2]=h;y=l-(f<<1)|0;if(!((((y|0)>-1?y:0-y|0)|0)==((l|0)%2|0|0)?(y=E-(D<<1)|0,(((y|0)>-1?y:0-y|0)|0)==((E|0)%2|0|0)):0)){k[m>>2]=0;c=m+4|0;k[c>>2]=0;d=ZT(124)|0;k[d>>2]=1;e=d+4|0;k[m>>2]=e;k[c>>2]=119;i[d+123>>0]=0;f=347572;g=e+119|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,m,347692,347314,994);k[c>>2]=0;k[m>>2]=0;y=k[d>>2]|0;k[d>>2]=y+-1;if((y|0)==1)ggb(k[d+-4>>2]|0)}y=aa(F,l)|0;if((h|0)>0){d=F<<1;c=0;do{x=(aa(d,(c|0)/(F|0)|0)|0)+((c|0)%(F|0)|0)|0;k[z+(c<<2)>>2]=x;c=c+1|0}while((c|0)!=(h|0))}if((D|0)>0){v=E+-1|0;w=(y|0)>0;x=(h|0)==(F|0);s=h-F|0;t=(F|0)<(s|0);u=k[b+16>>2]|0;p=k[b+44>>2]|0;q=k[a+16>>2]|0;a=k[a+44>>2]|0;n=(E|0)==1;o=E<<1;c=-1;l=0;do{b=l<<1;h=k[p>>2]|0;m=u+(aa(h,b)|0)|0;b=b|1;b=u+(aa(h,(v|0)<(b|0)?v:b)|0)|0;h=l;l=l+1|0;if((c|0)<=(l|0)){f=c;while(1){c=f+1|0;g=A+((aa((c|0)%3|0,G)|0)<<2)|0;d=f<<1;e=d>>>0<E>>>0;if(e|n)d=e?d:0;else do d=(d|0)<0?0-d|0:-2-d+o|0;while(d>>>0>=E>>>0);e=q+(aa(k[a>>2]|0,(d|0)/2|0)|0)|0;if(!x){d=0;do{O=k[z+(d<<2)>>2]|0;M=j[e+(d<<1)>>1]|0;N=j[e+(d+F<<1)>>1]|0;k[g+(O<<2)>>2]=(N<<1)+(M*6|0);k[g+(O+F<<2)>>2]=N+M<<2;O=d+s|0;M=k[z+(O<<2)>>2]|0;N=j[e+(O<<1)>>1]|0;k[g+(M<<2)>>2]=(N*7|0)+(j[e+(O-F<<1)>>1]|0);k[g+(M+F<<2)>>2]=N<<3;d=d+1|0}while((d|0)!=(F|0));if(t){d=F;do{O=k[z+(d<<2)>>2]|0;N=j[e+(d<<1)>>1]|0;M=j[e+(d+F<<1)>>1]|0;k[g+(O<<2)>>2]=(N*6|0)+(j[e+(d-F<<1)>>1]|0)+M;k[g+(O+F<<2)>>2]=M+N<<2;d=d+1|0}while((d|0)!=(s|0))}}else{d=0;do{O=j[e+(d<<1)>>1]<<3;k[g+(d+F<<2)>>2]=O;k[g+(d<<2)>>2]=O;d=d+1|0}while((d|0)!=(F|0))}if((f|0)>(h|0))break;else f=c}}f=A+((aa((h|0)%3|0,G)|0)<<2)|0;g=A+((aa((l|0)%3|0,G)|0)<<2)|0;e=A+((aa((h+2|0)%3|0,G)|0)<<2)|0;if(w){d=0;do{N=k[g+(d<<2)>>2]|0;M=k[e+(d<<2)>>2]|0;O=((N*6|0)+32+M+(k[f+(d<<2)>>2]|0)|0)>>>6&65535;j[b+(d<<1)>>1]=((M+N<<2)+32|0)>>>6;j[m+(d<<1)>>1]=O;d=d+1|0}while((d|0)!=(y|0))}}while((l|0)!=(D|0))}c=k[H>>2]|0;if((c|0)!=(B|0)){if(c|0)ggb(c);k[H>>2]=B;k[C>>2]=264}c=k[K>>2]|0;if((c|0)==(I|0)){r=L;return}if(c|0)ggb(c);k[K>>2]=I;k[J>>2]=264;r=L;return}function Rra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;M=r;r=r+2144|0;L=M+1072|0;I=M+8|0;n=M;E=k[a+40>>2]|0;f=k[E+4>>2]|0;E=k[E>>2]|0;F=k[b+40>>2]|0;l=k[F+4>>2]|0;F=k[F>>2]|0;G=((k[a>>2]|0)>>>3&511)+1|0;H=(aa(G,l+1|0)|0)+15&-16;e=(H*3|0)+16|0;J=L+8|0;k[L>>2]=J;K=L+4|0;k[K>>2]=264;c=J;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[L>>2]=c}k[K>>2]=e;B=c+15&-16;h=aa(G,f)|0;C=I+8|0;k[I>>2]=C;D=I+4|0;k[D>>2]=264;if(h>>>0>264){d=h>>>0>1073741823?-1:h<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[I>>2]=c;A=c}else A=C;k[D>>2]=h;z=l-(f<<1)|0;if(!((((z|0)>-1?z:0-z|0)|0)==((l|0)%2|0|0)?(z=F-(E<<1)|0,(((z|0)>-1?z:0-z|0)|0)==((F|0)%2|0|0)):0)){k[n>>2]=0;c=n+4|0;k[c>>2]=0;d=ZT(124)|0;k[d>>2]=1;e=d+4|0;k[n>>2]=e;k[c>>2]=119;i[d+123>>0]=0;f=347572;g=e+119|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,n,347692,347314,994);k[c>>2]=0;k[n>>2]=0;z=k[d>>2]|0;k[d>>2]=z+-1;if((z|0)==1)ggb(k[d+-4>>2]|0)}z=aa(G,l)|0;if((h|0)>0){d=G<<1;c=0;do{y=(aa(d,(c|0)/(G|0)|0)|0)+((c|0)%(G|0)|0)|0;k[A+(c<<2)>>2]=y;c=c+1|0}while((c|0)!=(h|0))}if((E|0)>0){w=F+-1|0;x=(z|0)>0;y=(h|0)==(G|0);t=h-G|0;u=(G|0)<(t|0);v=k[b+16>>2]|0;q=k[b+44>>2]|0;s=k[a+16>>2]|0;a=k[a+44>>2]|0;o=(F|0)==1;p=F<<1;c=-1;l=0;do{b=l<<1;h=k[q>>2]|0;n=v+(aa(h,b)|0)|0;b=b|1;b=v+(aa(h,(w|0)<(b|0)?w:b)|0)|0;h=l;l=l+1|0;if((c|0)<=(l|0)){f=c;while(1){c=f+1|0;g=B+((aa((c|0)%3|0,H)|0)<<2)|0;d=f<<1;e=d>>>0<F>>>0;if(e|o)d=e?d:0;else do d=(d|0)<0?0-d|0:-2-d+p|0;while(d>>>0>=F>>>0);e=s+(aa(k[a>>2]|0,(d|0)/2|0)|0)|0;if(!y){d=0;do{P=k[A+(d<<2)>>2]|0;N=m[e+(d<<1)>>1]|0;O=m[e+(d+G<<1)>>1]|0;k[g+(P<<2)>>2]=(O<<1)+(N*6|0);k[g+(P+G<<2)>>2]=O+N<<2;P=d+t|0;N=k[A+(P<<2)>>2]|0;O=m[e+(P<<1)>>1]|0;k[g+(N<<2)>>2]=(O*7|0)+(m[e+(P-G<<1)>>1]|0);k[g+(N+G<<2)>>2]=O<<3;d=d+1|0}while((d|0)!=(G|0));if(u){d=G;do{P=k[A+(d<<2)>>2]|0;O=m[e+(d<<1)>>1]|0;N=m[e+(d+G<<1)>>1]|0;k[g+(P<<2)>>2]=(O*6|0)+(m[e+(d-G<<1)>>1]|0)+N;k[g+(P+G<<2)>>2]=N+O<<2;d=d+1|0}while((d|0)!=(t|0))}}else{d=0;do{P=(m[e+(d<<1)>>1]|0)<<3;k[g+(d+G<<2)>>2]=P;k[g+(d<<2)>>2]=P;d=d+1|0}while((d|0)!=(G|0))}if((f|0)>(h|0))break;else f=c}}f=B+((aa((h|0)%3|0,H)|0)<<2)|0;g=B+((aa((l|0)%3|0,H)|0)<<2)|0;e=B+((aa((h+2|0)%3|0,H)|0)<<2)|0;if(x){d=0;do{O=k[g+(d<<2)>>2]|0;N=k[e+(d<<2)>>2]|0;P=((O*6|0)+32+N+(k[f+(d<<2)>>2]|0)|0)>>>6&65535;j[b+(d<<1)>>1]=((N+O<<2)+32|0)>>>6;j[n+(d<<1)>>1]=P;d=d+1|0}while((d|0)!=(z|0))}}while((l|0)!=(E|0))}c=k[I>>2]|0;if((c|0)!=(C|0)){if(c|0)ggb(c);k[I>>2]=C;k[D>>2]=264}c=k[L>>2]|0;if((c|0)==(J|0)){r=M;return}if(c|0)ggb(c);k[L>>2]=J;k[K>>2]=264;r=M;return}function Sra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0.0;M=r;r=r+2144|0;L=M+1072|0;I=M+8|0;l=M;E=k[a+40>>2]|0;f=k[E+4>>2]|0;E=k[E>>2]|0;F=k[b+40>>2]|0;j=k[F+4>>2]|0;F=k[F>>2]|0;G=((k[a>>2]|0)>>>3&511)+1|0;H=(aa(G,j+1|0)|0)+15&-16;e=(H*3|0)+16|0;J=L+8|0;k[L>>2]=J;K=L+4|0;k[K>>2]=264;c=J;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[L>>2]=c}k[K>>2]=e;B=c+15&-16;h=aa(G,f)|0;C=I+8|0;k[I>>2]=C;D=I+4|0;k[D>>2]=264;if(h>>>0>264){d=h>>>0>1073741823?-1:h<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[I>>2]=c;A=c}else A=C;k[D>>2]=h;z=j-(f<<1)|0;if(!((((z|0)>-1?z:0-z|0)|0)==((j|0)%2|0|0)?(z=F-(E<<1)|0,(((z|0)>-1?z:0-z|0)|0)==((F|0)%2|0|0)):0)){k[l>>2]=0;c=l+4|0;k[c>>2]=0;d=ZT(124)|0;k[d>>2]=1;e=d+4|0;k[l>>2]=e;k[c>>2]=119;i[d+123>>0]=0;f=347572;g=e+119|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,l,347692,347314,994);k[c>>2]=0;k[l>>2]=0;z=k[d>>2]|0;k[d>>2]=z+-1;if((z|0)==1)ggb(k[d+-4>>2]|0)}z=aa(G,j)|0;if((h|0)>0){d=G<<1;c=0;do{y=(aa(d,(c|0)/(G|0)|0)|0)+((c|0)%(G|0)|0)|0;k[A+(c<<2)>>2]=y;c=c+1|0}while((c|0)!=(h|0))}if((E|0)>0){w=F+-1|0;x=(z|0)>0;y=(h|0)==(G|0);t=h-G|0;u=(G|0)<(t|0);v=k[b+16>>2]|0;q=k[k[b+44>>2]>>2]|0;s=k[a+16>>2]|0;m=k[a+44>>2]|0;n=(F|0)==1;p=F<<1;c=-1;l=0;do{a=l<<1;b=v+(aa(q,a)|0)|0;a=a|1;a=v+(aa(q,(w|0)<(a|0)?w:a)|0)|0;j=l;l=l+1|0;a:do if((c|0)<=(l|0)){h=k[m>>2]|0;if(y){f=c;while(1){c=f+1|0;g=B+((aa((c|0)%3|0,H)|0)<<2)|0;d=f<<1;e=d>>>0<F>>>0;if(e|n)d=e?d:0;else do d=(d|0)<0?0-d|0:-2-d+p|0;while(d>>>0>=F>>>0);e=s+(aa(h,(d|0)/2|0)|0)|0;d=0;do{N=+o[e+(d<<2)>>2]*8.0;o[g+(d+G<<2)>>2]=N;o[g+(d<<2)>>2]=N;d=d+1|0}while((d|0)!=(G|0));if((f|0)>(j|0))break a;else f=c}}else f=c;while(1){c=f+1|0;g=B+((aa((c|0)%3|0,H)|0)<<2)|0;d=f<<1;e=d>>>0<F>>>0;if(e|n)d=e?d:0;else do d=(d|0)<0?0-d|0:-2-d+p|0;while(d>>>0>=F>>>0);e=s+(aa(h,(d|0)/2|0)|0)|0;d=0;do{P=k[A+(d<<2)>>2]|0;Q=+o[e+(d<<2)>>2];N=+o[e+(d+G<<2)>>2];o[g+(P<<2)>>2]=Q*6.0+N*2.0;o[g+(P+G<<2)>>2]=(Q+N)*4.0;P=d+t|0;O=k[A+(P<<2)>>2]|0;N=+o[e+(P<<2)>>2];o[g+(O<<2)>>2]=+o[e+(P-G<<2)>>2]+N*7.0;o[g+(O+G<<2)>>2]=N*8.0;d=d+1|0}while((d|0)!=(G|0));if(u){d=G;do{P=k[A+(d<<2)>>2]|0;N=+o[e+(d<<2)>>2];Q=+o[e+(d+G<<2)>>2];o[g+(P<<2)>>2]=Q+(+o[e+(d-G<<2)>>2]+N*6.0);o[g+(P+G<<2)>>2]=(N+Q)*4.0;d=d+1|0}while((d|0)!=(t|0))}if((f|0)>(j|0))break;else f=c}}while(0);f=B+((aa((j|0)%3|0,H)|0)<<2)|0;g=B+((aa((l|0)%3|0,H)|0)<<2)|0;e=B+((aa((j+2|0)%3|0,H)|0)<<2)|0;if(x){d=0;do{R=+o[g+(d<<2)>>2];N=+o[e+(d<<2)>>2];Q=(N+(R*6.0+ +o[f+(d<<2)>>2]))*.015625;o[a+(d<<2)>>2]=(R+N)*4.0*.015625;o[b+(d<<2)>>2]=Q;d=d+1|0}while((d|0)!=(z|0))}}while((l|0)!=(E|0))}c=k[I>>2]|0;if((c|0)!=(C|0)){if(c|0)ggb(c);k[I>>2]=C;k[D>>2]=264}c=k[L>>2]|0;if((c|0)==(J|0)){r=M;return}if(c|0)ggb(c);k[L>>2]=J;k[K>>2]=264;r=M;return}function Tra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0.0;M=r;r=r+2176|0;L=M;I=M+1104|0;l=M+1096|0;E=k[a+40>>2]|0;f=k[E+4>>2]|0;E=k[E>>2]|0;F=k[b+40>>2]|0;j=k[F+4>>2]|0;F=k[F>>2]|0;G=((k[a>>2]|0)>>>3&511)+1|0;H=(aa(G,j+1|0)|0)+15&-16;e=(H*3|0)+16|0;J=L+8|0;k[L>>2]=J;K=L+4|0;k[K>>2]=136;c=J;if(e>>>0>136){d=e>>>0>536870911?-1:e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[L>>2]=c}k[K>>2]=e;B=c+15&-16;h=aa(G,f)|0;C=I+8|0;k[I>>2]=C;D=I+4|0;k[D>>2]=264;if(h>>>0>264){d=h>>>0>1073741823?-1:h<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[I>>2]=c;A=c}else A=C;k[D>>2]=h;z=j-(f<<1)|0;if(!((((z|0)>-1?z:0-z|0)|0)==((j|0)%2|0|0)?(z=F-(E<<1)|0,(((z|0)>-1?z:0-z|0)|0)==((F|0)%2|0|0)):0)){k[l>>2]=0;c=l+4|0;k[c>>2]=0;d=ZT(124)|0;k[d>>2]=1;e=d+4|0;k[l>>2]=e;k[c>>2]=119;i[d+123>>0]=0;f=347572;g=e+119|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,l,347692,347314,994);k[c>>2]=0;k[l>>2]=0;z=k[d>>2]|0;k[d>>2]=z+-1;if((z|0)==1)ggb(k[d+-4>>2]|0)}z=aa(G,j)|0;if((h|0)>0){d=G<<1;c=0;do{y=(aa(d,(c|0)/(G|0)|0)|0)+((c|0)%(G|0)|0)|0;k[A+(c<<2)>>2]=y;c=c+1|0}while((c|0)!=(h|0))}if((E|0)>0){w=F+-1|0;x=(z|0)>0;y=(h|0)==(G|0);t=h-G|0;u=(G|0)<(t|0);v=k[b+16>>2]|0;q=k[k[b+44>>2]>>2]|0;s=k[a+16>>2]|0;m=k[a+44>>2]|0;n=(F|0)==1;o=F<<1;c=-1;l=0;do{a=l<<1;b=v+(aa(q,a)|0)|0;a=a|1;a=v+(aa(q,(w|0)<(a|0)?w:a)|0)|0;j=l;l=l+1|0;a:do if((c|0)<=(l|0)){h=k[m>>2]|0;if(y){f=c;while(1){c=f+1|0;g=B+((aa((c|0)%3|0,H)|0)<<3)|0;d=f<<1;e=d>>>0<F>>>0;if(e|n)d=e?d:0;else do d=(d|0)<0?0-d|0:-2-d+o|0;while(d>>>0>=F>>>0);e=s+(aa(h,(d|0)/2|0)|0)|0;d=0;do{N=+p[e+(d<<3)>>3]*8.0;p[g+(d+G<<3)>>3]=N;p[g+(d<<3)>>3]=N;d=d+1|0}while((d|0)!=(G|0));if((f|0)>(j|0))break a;else f=c}}else f=c;while(1){c=f+1|0;g=B+((aa((c|0)%3|0,H)|0)<<3)|0;d=f<<1;e=d>>>0<F>>>0;if(e|n)d=e?d:0;else do d=(d|0)<0?0-d|0:-2-d+o|0;while(d>>>0>=F>>>0);e=s+(aa(h,(d|0)/2|0)|0)|0;d=0;do{P=k[A+(d<<2)>>2]|0;Q=+p[e+(d<<3)>>3];N=+p[e+(d+G<<3)>>3];p[g+(P<<3)>>3]=Q*6.0+N*2.0;p[g+(P+G<<3)>>3]=(Q+N)*4.0;P=d+t|0;O=k[A+(P<<2)>>2]|0;N=+p[e+(P<<3)>>3];p[g+(O<<3)>>3]=+p[e+(P-G<<3)>>3]+N*7.0;p[g+(O+G<<3)>>3]=N*8.0;d=d+1|0}while((d|0)!=(G|0));if(u){d=G;do{P=k[A+(d<<2)>>2]|0;N=+p[e+(d<<3)>>3];Q=+p[e+(d+G<<3)>>3];p[g+(P<<3)>>3]=Q+(+p[e+(d-G<<3)>>3]+N*6.0);p[g+(P+G<<3)>>3]=(N+Q)*4.0;d=d+1|0}while((d|0)!=(t|0))}if((f|0)>(j|0))break;else f=c}}while(0);f=B+((aa((j|0)%3|0,H)|0)<<3)|0;g=B+((aa((l|0)%3|0,H)|0)<<3)|0;e=B+((aa((j+2|0)%3|0,H)|0)<<3)|0;if(x){d=0;do{R=+p[g+(d<<3)>>3];N=+p[e+(d<<3)>>3];Q=(N+(R*6.0+ +p[f+(d<<3)>>3]))*.015625;p[a+(d<<3)>>3]=(R+N)*4.0*.015625;p[b+(d<<3)>>3]=Q;d=d+1|0}while((d|0)!=(z|0))}}while((l|0)!=(E|0))}c=k[I>>2]|0;if((c|0)!=(C|0)){if(c|0)ggb(c);k[I>>2]=C;k[D>>2]=264}c=k[L>>2]|0;if((c|0)==(J|0)){r=M;return}if(c|0)ggb(c);k[L>>2]=J;k[K>>2]=136;r=M;return}function Ura(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;L=r;r=r+2144|0;K=L+1072|0;H=L+8|0;j=L;D=k[a+40>>2]|0;f=k[D+4>>2]|0;D=k[D>>2]|0;E=k[b+40>>2]|0;h=k[E+4>>2]|0;E=k[E>>2]|0;F=((k[a>>2]|0)>>>3&511)+1|0;G=(aa(F,h+1|0)|0)+15&-16;e=(G*3|0)+16|0;I=K+8|0;k[K>>2]=I;J=K+4|0;k[J>>2]=264;c=I;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[K>>2]=c}k[J>>2]=e;A=c+15&-16;m=aa(F,f)|0;B=H+8|0;k[H>>2]=B;C=H+4|0;k[C>>2]=264;if(m>>>0>264){d=m>>>0>1073741823?-1:m<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[H>>2]=c;z=c}else z=B;k[C>>2]=m;y=h-(f<<1)|0;if(!((((y|0)>-1?y:0-y|0)|0)==((h|0)%2|0|0)?(y=E-(D<<1)|0,(((y|0)>-1?y:0-y|0)|0)==((E|0)%2|0|0)):0)){k[j>>2]=0;c=j+4|0;k[c>>2]=0;d=ZT(124)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[c>>2]=119;i[d+123>>0]=0;f=347572;g=e+119|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,j,347692,347314,994);k[c>>2]=0;k[j>>2]=0;y=k[d>>2]|0;k[d>>2]=y+-1;if((y|0)==1)ggb(k[d+-4>>2]|0)}y=aa(F,h)|0;if((m|0)>0){d=F<<1;c=0;do{x=(aa(d,(c|0)/(F|0)|0)|0)+((c|0)%(F|0)|0)|0;k[z+(c<<2)>>2]=x;c=c+1|0}while((c|0)!=(m|0))}if((D|0)>0){x=b+16|0;t=b+44|0;u=E+-1|0;v=(y|0)>0;w=a+16|0;q=a+44|0;s=(m|0)==(F|0);a=m-F|0;n=(F|0)<(a|0);o=(E|0)==1;p=E<<1;c=-1;j=0;do{b=j<<1;g=k[x>>2]|0;h=k[k[t>>2]>>2]|0;m=g+(aa(h,b)|0)|0;b=b|1;b=g+(aa(h,(u|0)<(b|0)?u:b)|0)|0;h=j;j=j+1|0;a:do if((c|0)<=(j|0)){if(s){f=c;while(1){c=f+1|0;g=A+((aa((c|0)%3|0,G)|0)<<2)|0;d=f<<1;e=d>>>0<E>>>0;if(e|o)d=e?d:0;else do d=(d|0)<0?0-d|0:-2-d+p|0;while(d>>>0>=E>>>0);e=(k[w>>2]|0)+(aa(k[k[q>>2]>>2]|0,(d|0)/2|0)|0)|0;d=0;do{M=(l[e+d>>0]|0)<<3;k[g+(d+F<<2)>>2]=M;k[g+(d<<2)>>2]=M;d=d+1|0}while((d|0)!=(F|0));if((f|0)>(h|0))break a;else f=c}}else f=c;while(1){c=f+1|0;g=A+((aa((c|0)%3|0,G)|0)<<2)|0;d=f<<1;e=d>>>0<E>>>0;if(e|o)d=e?d:0;else do d=(d|0)<0?0-d|0:-2-d+p|0;while(d>>>0>=E>>>0);e=(k[w>>2]|0)+(aa(k[k[q>>2]>>2]|0,(d|0)/2|0)|0)|0;d=0;do{O=k[z+(d<<2)>>2]|0;M=l[e+d>>0]|0;N=l[e+(d+F)>>0]|0;k[g+(O<<2)>>2]=(N<<1)+(M*6|0);k[g+(O+F<<2)>>2]=N+M<<2;O=d+a|0;M=k[z+(O<<2)>>2]|0;N=l[e+O>>0]|0;k[g+(M<<2)>>2]=(N*7|0)+(l[e+(O-F)>>0]|0);k[g+(M+F<<2)>>2]=N<<3;d=d+1|0}while((d|0)!=(F|0));if(n){d=F;do{O=k[z+(d<<2)>>2]|0;N=l[e+d>>0]|0;M=l[e+(d+F)>>0]|0;k[g+(O<<2)>>2]=(N*6|0)+(l[e+(d-F)>>0]|0)+M;k[g+(O+F<<2)>>2]=M+N<<2;d=d+1|0}while((d|0)!=(a|0))}if((f|0)>(h|0))break;else f=c}}while(0);f=A+((aa((h|0)%3|0,G)|0)<<2)|0;g=A+((aa((j|0)%3|0,G)|0)<<2)|0;e=A+((aa((h+2|0)%3|0,G)|0)<<2)|0;if(v){d=0;do{N=k[g+(d<<2)>>2]|0;M=k[e+(d<<2)>>2]|0;O=((N*6|0)+32+M+(k[f+(d<<2)>>2]|0)|0)>>>6&255;i[b+d>>0]=((M+N<<2)+32|0)>>>6;i[m+d>>0]=O;d=d+1|0}while((d|0)!=(y|0))}}while((j|0)!=(D|0))}c=k[H>>2]|0;if((c|0)!=(B|0)){if(c|0)ggb(c);k[H>>2]=B;k[C>>2]=264}c=k[K>>2]|0;if((c|0)==(I|0)){r=L;return}if(c|0)ggb(c);k[K>>2]=I;k[J>>2]=264;r=L;return}function Vra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;p=r;r=r+96|0;o=p+40|0;l=p+24|0;m=p+8|0;n=p;if((a2(a)|0)<3?(k[b>>2]&2031616|0)==720896:0){A2(o,a);c2(b,c+1|0,1,0,-1,0,0);D2(M2(b,0)|0,o);if((c|0)>=1){d=l+8|0;e=l+12|0;f=l+4|0;g=m+4|0;h=g+4|0;i=n+4|0;a=1;while(1){j=M2(b,a+-1|0)|0;k[d>>2]=0;k[e>>2]=0;k[l>>2]=17432576;k[f>>2]=j;j=M2(b,a)|0;q=h;k[q>>2]=0;k[q+4>>2]=0;k[m>>2]=34209792;k[g>>2]=j;k[n>>2]=0;k[i>>2]=0;Jra(l,m,n,4);if((a|0)<(c|0))a=a+1|0;else break}}f=o+24|0;a=k[f>>2]|0;if(a|0?(n=a+8|0,q=k[n>>2]|0,k[n>>2]=q+-1,(q|0)==1):0){q=k[f>>2]|0;n=k[q+4>>2]|0;jh[k[(k[n>>2]|0)+16>>2]&1023](n,q);k[f>>2]=0}d=o+4|0;if((k[d>>2]|0)>0){e=k[o+32>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}k[f>>2]=0;a=k[o+36>>2]|0;if(!((a|0)==(o+40|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=p;return}do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[o>>2]=k[g>>2];j=o+4|0;a=g+4|0;k[j>>2]=k[a>>2];q=o+8|0;k[q>>2]=k[g+8>>2];k[o+12>>2]=k[g+12>>2];k[o+16>>2]=k[g+16>>2];k[o+20>>2]=k[g+20>>2];k[o+24>>2]=k[g+24>>2];k[o+28>>2]=k[g+28>>2];k[o+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[o+36>>2]=d;e=o+40|0;k[e>>2]=q;q=o+48|0;i=o+44|0;k[i>>2]=q;k[o+52>>2]=0;k[q>>2]=0;if(d|0){q=d+12|0;k[q>>2]=(k[q>>2]|0)+1}if((k[a>>2]|0)<3){j=k[g+44>>2]|0;q=k[i>>2]|0;k[q>>2]=k[j>>2];k[q+4>>2]=k[j+4>>2];break}k[j>>2]=0;x1(o,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[g+40>>2]|0;f=k[e>>2]|0;e=k[g+44>>2]|0;d=k[i>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else Q1(o,a,-1);while(0);c2(b,c+1|0,1,0,-1,0,0);KG(J2(b,0)|0,o)|0;if((c|0)>=1){d=l+8|0;e=l+12|0;f=l+4|0;g=m+4|0;h=g+4|0;i=n+4|0;a=1;while(1){q=J2(b,a+-1|0)|0;k[d>>2]=0;k[e>>2]=0;k[l>>2]=16842752;k[f>>2]=q;q=J2(b,a)|0;j=h;k[j>>2]=0;k[j+4>>2]=0;k[m>>2]=33619968;k[g>>2]=q;k[n>>2]=0;k[i>>2]=0;Jra(l,m,n,4);if((a|0)<(c|0))a=a+1|0;else break}}e=o+36|0;a=k[e>>2]|0;if(a|0?(n=a+12|0,q=k[n>>2]|0,k[n>>2]=q+-1,(q|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[o+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;q=o+16|0;d=o+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[d>>2]|0)>0){e=k[o+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[o+44>>2]|0;if(!((a|0)==(o+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=p;return}function Wra(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,m=0,n=0,p=0.0,q=0.0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;U=r;r=r+128|0;T=U+72|0;S=U+16|0;B=U+8|0;D=U;do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[T>>2]=k[h>>2];s=T+4|0;a=h+4|0;k[s>>2]=k[a>>2];R=T+8|0;k[R>>2]=k[h+8>>2];k[T+12>>2]=k[h+12>>2];k[T+16>>2]=k[h+16>>2];k[T+20>>2]=k[h+20>>2];k[T+24>>2]=k[h+24>>2];k[T+28>>2]=k[h+28>>2];k[T+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[T+36>>2]=f;g=T+40|0;k[g>>2]=R;R=T+48|0;m=T+44|0;k[m>>2]=R;k[T+52>>2]=0;k[R>>2]=0;if(f|0){R=f+12|0;k[R>>2]=(k[R>>2]|0)+1}if((k[a>>2]|0)<3){R=k[h+44>>2]|0;a=k[m>>2]|0;k[a>>2]=k[R>>2];k[a+4>>2]=k[R+4>>2];a=T;break}k[s>>2]=0;x1(T,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[m>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[n+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0));a=T}else a=T}else{Q1(T,a,-1);a=T}while(0);Q=k[a>>2]|0;A=Q&7;Q=Q>>>3;C=Q&511;R=C+1|0;e=(e|0)<0?A:e&7;if((R|2|0)!=3){k[S>>2]=0;a=S+4|0;k[a>>2]=0;f=ZT(24)|0;k[f>>2]=1;g=f+4|0;k[S>>2]=g;k[a>>2]=18;i[f+22>>0]=0;h=347806;j=g+18|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,S,347825,347839,372);k[a>>2]=0;k[S>>2]=0;P=k[f>>2]|0;k[f>>2]=P+-1;if((P|0)==1)ggb(k[f+-4>>2]|0)}k[B>>2]=k[b>>2];k[B+4>>2]=k[b+4>>2];x2(d,B,(R<<3)+-8|e,0);do if((k[d>>2]&2031616|0)==65536){h=k[d+4>>2]|0;k[S>>2]=k[h>>2];s=S+4|0;a=h+4|0;k[s>>2]=k[a>>2];P=S+8|0;k[P>>2]=k[h+8>>2];k[S+12>>2]=k[h+12>>2];k[S+16>>2]=k[h+16>>2];k[S+20>>2]=k[h+20>>2];k[S+24>>2]=k[h+24>>2];k[S+28>>2]=k[h+28>>2];k[S+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[S+36>>2]=f;g=S+40|0;k[g>>2]=P;P=S+48|0;m=S+44|0;k[m>>2]=P;k[S+52>>2]=0;k[P>>2]=0;if(f|0){P=f+12|0;k[P>>2]=(k[P>>2]|0)+1}if((k[a>>2]|0)<3){O=k[h+44>>2]|0;P=k[m>>2]|0;k[P>>2]=k[O>>2];k[P+4>>2]=k[O+4>>2];break}k[s>>2]=0;x1(S,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){n=k[h+40>>2]|0;j=k[g>>2]|0;g=k[h+44>>2]|0;f=k[m>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[n+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else Q1(S,d,-1);while(0);a:do if(!(e|A)){h=k[T+16>>2]|0;N=k[T+48>>2]|0;n=k[T+40>>2]|0;j=k[n+4>>2]|0;n=k[n>>2]|0;f=k[S+16>>2]|0;O=k[S+48>>2]|0;P=k[S+40>>2]|0;L=k[P+4>>2]|0;P=k[P>>2]|0;t=+o[c>>2]-+(L+-1|0)*.5;w=+o[c+4>>2]-+(P+-1|0)*.5;m=~~t;m=m-(+(m|0)>t&1)|0;s=~~w;s=s-(+(s|0)>w&1)|0;t=t-+(m|0);w=w-+(s|0);q=1.0-t;v=1.0-w;p=q*v*65536.0;a=(o[u>>2]=p,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;p=a?p+-8388608.0+8388608.0:p+8388608.0+-8388608.0;if(p==0.0)p=a?-0.0:0.0}M=~~p;p=t*v*65536.0;a=(o[u>>2]=p,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;p=a?p+-8388608.0+8388608.0:p+8388608.0+-8388608.0;if(p==0.0)p=a?-0.0:0.0}K=~~p;p=q*w*65536.0;a=(o[u>>2]=p,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;p=a?p+-8388608.0+8388608.0:p+8388608.0+-8388608.0;if(p==0.0)p=a?-0.0:0.0}J=~~p;p=t*w*65536.0;a=(o[u>>2]=p,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;p=a?p+-8388608.0+8388608.0:p+8388608.0+-8388608.0;if(p==0.0)p=a?-0.0:0.0}I=~~p;p=v*65536.0;a=(o[u>>2]=p,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;p=a?p+-8388608.0+8388608.0:p+8388608.0+-8388608.0;if(p==0.0)p=a?-0.0:0.0}H=~~p;p=w*65536.0;a=(o[u>>2]=p,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;p=a?p+-8388608.0+8388608.0:p+8388608.0+-8388608.0;if(p==0.0)p=a?-0.0:0.0}G=~~p;do if((m|0)>-1){g=j-L|0;if(!((s|0)>-1&(m|0)<(g|0)&(s|0)<(n-P|0))){a=h+(aa(m,R)|0)|0;F=0;break}n=aa(L,R)|0;if((P|0)<=0)break a;h=h+((aa(s,N)|0)+(aa(m,R)|0))|0;j=n+-2|0;m=((j|0)>1?j:1)+2&-2;g=0;while(1){if((n|0)<2)a=0;else{a=0;do{C=aa(l[h+a>>0]|0,M)|0;G=a+R|0;D=aa(l[h+G>>0]|0,K)|0;H=a+N|0;c=aa(l[h+H>>0]|0,J)|0;L=H+R|0;E=aa(l[h+L>>0]|0,I)|0;Q=a|1;F=aa(l[h+Q>>0]|0,M)|0;G=aa(l[h+(G+1)>>0]|0,K)|0;H=aa(l[h+(H+1)>>0]|0,J)|0;L=aa(l[h+(L+1)>>0]|0,I)|0;i[f+a>>0]=(C+32768+D+c+E|0)>>>16;i[f+Q>>0]=(F+32768+G+H+L|0)>>>16;a=a+2|0}while((a|0)<=(j|0));a=m}if((a|0)<(n|0))do{G=aa(l[h+a>>0]|0,M)|0;H=aa(l[h+(a+R)>>0]|0,K)|0;Q=a+N|0;L=aa(l[h+Q>>0]|0,J)|0;Q=(G+32768+H+L+(aa(l[h+(Q+R)>>0]|0,I)|0)|0)>>>16&255;i[f+a>>0]=Q;a=a+1|0}while((a|0)<(n|0));g=g+1|0;if((g|0)==(P|0))break a;else{h=h+N|0;f=f+O|0}}}else{F=0-m|0;a=h;g=j-L|0;F=(L|0)<(F|0)?L:F}while(0);h=j-m|0;j=h+-1|0;if((g|0)>(m|0))c=L;else{E=a+(aa(j,R)|0)|0;c=(h|0)<1;a=c?E:a;c=c?0:j}h=(s|0)>-1;g=a+(aa(s,N)|0)|0;E=h?0:0-s|0;a=h?g:a;g=n-s|0;h=g+-1|0;if((n-P|0)>(s|0))e=P;else{D=a+(aa(h,N)|0)|0;e=(g|0)<1;a=e?D:a;e=e?0:h}if((P|0)>0){A=0-N|0;b=aa(F,R)|0;d=(F|0)>0;B=aa(c,R)|0;C=(b|0)<(B|0);D=(c|0)<(L|0);s=0;m=a+(aa(F,(Q|-512)^511)|0)|0;while(1){j=m+N|0;n=(s|0)<(e|0);j=(s|0)>=(E|0)&n?j:j+A|0;if(d){h=0;do{g=h+b|0;a=aa(l[m+g>>0]|0,H)|0;g=(a+32768+(aa(l[j+g>>0]|0,G)|0)|0)>>>16&255;a=0;do{Q=f+((aa(a,R)|0)+h)|0;i[Q>>0]=g;a=a+1|0}while((a|0)!=(F|0));a=h+B|0;if(D){g=aa(l[j+a>>0]|0,G)|0;g=((aa(l[m+a>>0]|0,H)|0)+32768+g|0)>>>16&255;a=c;do{Q=f+((aa(a,R)|0)+h)|0;i[Q>>0]=g;a=a+1|0}while((a|0)!=(L|0))}h=h+1|0}while((h|0)!=(R|0))}else{h=0;do{a=h+B|0;if((c|0)<(L|0)){g=aa(l[j+a>>0]|0,G)|0;g=((aa(l[m+a>>0]|0,H)|0)+32768+g|0)>>>16&255;a=c;do{Q=f+((aa(a,R)|0)+h)|0;i[Q>>0]=g;a=a+1|0}while((a|0)<(L|0))}h=h+1|0}while((h|0)!=(R|0))}if(C){a=b;do{V=aa(l[m+a>>0]|0,M)|0;Q=a+R|0;g=aa(l[m+Q>>0]|0,K)|0;h=aa(l[j+a>>0]|0,J)|0;Q=(V+32768+g+h+(aa(l[j+Q>>0]|0,I)|0)|0)>>>16&255;i[f+a>>0]=Q;a=a+1|0}while((a|0)!=(B|0))}s=s+1|0;if((s|0)==(P|0))break;else{f=f+O|0;m=n?j:m}}}}else{a=(e|0)==5;if((A|0)==0&a){a=k[T+16>>2]|0;I=k[T+48>>2]|0;n=k[T+40>>2]|0;j=k[n+4>>2]|0;n=k[n>>2]|0;h=k[S+16>>2]|0;m=k[S+48>>2]|0;H=k[S+40>>2]|0;G=k[H+4>>2]|0;H=k[H>>2]|0;q=+o[c>>2]-+(G+-1|0)*.5;g=H+-1|0;p=+o[c+4>>2]-+(g|0)*.5;e=~~q;e=e-(+(e|0)>q&1)|0;A=~~p;A=A-(+(A|0)>p&1)|0;f=(e|0)>-1;if(((C|0)==0&f?(e+G|0)<(j|0)&(A|0)>-1:0)?(H|0)>0&((G|0)>0&(A+H|0)<(n|0)):0){w=q-+(e|0);v=p-+(A|0);p=w<9.999999747378752e-05?9.999999747378752e-05:w;w=1.0-v;x=p*w;y=v*p;z=p;z=(1.0-z)/z;m=m>>>2;if(!H)break;t=1.0-p;j=a+((aa(A,I)|0)+e)|0;while(1){a=j;j=j+I|0;f=0;p=t*(w*+(l[a>>0]|0)+v*+(l[j>>0]|0));while(1){V=f;f=f+1|0;q=x*+(l[a+f>>0]|0)+y*+(l[a+(f+I)>>0]|0);o[h+(V<<2)>>2]=p+q;if((f|0)==(G|0))break;else p=z*q}if(!g)break a;else{h=h+(m<<2)|0;g=g+-1|0}}}y=q-+(e|0);q=p-+(A|0);x=1.0-y;t=1.0-q;v=x*t;w=y*t;x=x*q;y=y*q;F=m>>>2;do if(f){f=j-G|0;if(!((e|0)<(f|0)&(A|0)>-1&(A|0)<(n-H|0))){a=a+(aa(e,R)|0)|0;E=0;break}j=aa(G,R)|0;if((H|0)<=0)break a;m=(j|0)<2;n=j+-2|0;s=j&-2;g=a+((aa(A,I)|0)+(aa(e,R)|0))|0;f=0;while(1){if(m)a=0;else{a=0;do{O=a+R|0;P=a+I|0;Q=P+R|0;V=a|1;z=v*+(l[g+V>>0]|0)+w*+(l[g+(O+1)>>0]|0)+x*+(l[g+(P+1)>>0]|0)+y*+(l[g+(Q+1)>>0]|0);o[h+(a<<2)>>2]=v*+(l[g+a>>0]|0)+w*+(l[g+O>>0]|0)+x*+(l[g+P>>0]|0)+y*+(l[g+Q>>0]|0);o[h+(V<<2)>>2]=z;a=a+2|0}while((a|0)<=(n|0));a=s}if((a|0)<(j|0))do{V=a+I|0;o[h+(a<<2)>>2]=v*+(l[g+a>>0]|0)+w*+(l[g+(a+R)>>0]|0)+x*+(l[g+V>>0]|0)+y*+(l[g+(V+R)>>0]|0);a=a+1|0}while((a|0)!=(j|0));f=f+1|0;if((f|0)==(H|0))break a;else{g=g+I|0;h=h+(F<<2)|0}}}else{E=0-e|0;f=j-G|0;E=(G|0)<(E|0)?G:E}while(0);g=j-e|0;j=g+-1|0;if((f|0)>(e|0))D=G;else{V=a+(aa(j,R)|0)|0;D=(g|0)<1;a=D?V:a;D=D?0:j}g=(A|0)>-1;f=a+(aa(A,I)|0)|0;c=g?0:0-A|0;a=g?f:a;f=n-A|0;g=f+-1|0;if((n-H|0)>(A|0))s=H;else{V=a+(aa(g,I)|0)|0;s=(f|0)<1;a=s?V:a;s=s?0:g}if((H|0)<=0)break;e=0-I|0;A=aa(E,R)|0;b=(E|0)>0;d=aa(D,R)|0;B=(D|0)<(G|0);C=(A|0)<(d|0);n=0;j=a+(aa(E,(Q|-512)^511)|0)|0;while(1){g=j+I|0;m=(n|0)<(s|0);g=(n|0)>=(c|0)&m?g:g+e|0;if(b){f=0;do{a=f+A|0;p=t*+(l[j+a>>0]|0)+q*+(l[g+a>>0]|0);a=0;do{V=h+((aa(a,R)|0)+f<<2)|0;o[V>>2]=p;a=a+1|0}while((a|0)!=(E|0));V=f+d|0;p=t*+(l[j+V>>0]|0)+q*+(l[g+V>>0]|0);if(B){a=D;do{V=h+((aa(a,R)|0)+f<<2)|0;o[V>>2]=p;a=a+1|0}while((a|0)!=(G|0))}f=f+1|0}while((f|0)!=(R|0))}else{a=0;do{V=a+d|0;p=t*+(l[j+V>>0]|0)+q*+(l[g+V>>0]|0);if(B){f=D;do{V=h+((aa(f,R)|0)+a<<2)|0;o[V>>2]=p;f=f+1|0}while((f|0)!=(G|0))}a=a+1|0}while((a|0)!=(R|0))}if(C){a=A;do{V=a+R|0;o[h+(a<<2)>>2]=v*+(l[j+a>>0]|0)+w*+(l[j+V>>0]|0)+x*+(l[g+a>>0]|0)+y*+(l[g+V>>0]|0);a=a+1|0}while((a|0)!=(d|0))}n=n+1|0;if((n|0)==(H|0))break a;else{h=h+(F<<2)|0;j=m?g:j}}}if(!((A|0)==5&a)){k[D>>2]=0;a=D+4|0;k[a>>2]=0;f=ZT(56)|0;k[f>>2]=1;g=f+4|0;k[D>>2]=g;k[a>>2]=51;i[f+55>>0]=0;h=347909;j=g+51|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-210,D,347825,347839,418);k[a>>2]=0;k[D>>2]=0;V=k[f>>2]|0;k[f>>2]=V+-1;if((V|0)==1)ggb(k[f+-4>>2]|0);break}f=k[T+16>>2]|0;e=k[T+40>>2]|0;h=k[e+4>>2]|0;e=k[e>>2]|0;a=k[S+16>>2]|0;J=k[S+40>>2]|0;G=k[J+4>>2]|0;J=k[J>>2]|0;y=+o[c>>2]-+(G+-1|0)*.5;q=+o[c+4>>2]-+(J+-1|0)*.5;m=~~y;m=m-(+(m|0)>y&1)|0;s=~~q;s=s-(+(s|0)>q&1)|0;y=y-+(m|0);q=q-+(s|0);x=1.0-y;t=1.0-q;v=x*t;w=y*t;x=x*q;y=y*q;H=(k[T+48>>2]|0)>>>2;I=(k[S+48>>2]|0)>>>2;do if((m|0)>-1){g=h-G|0;if(!((s|0)>-1&(m|0)<(g|0)&(s|0)<(e-J|0))){D=R<<2;f=f+(aa(m,D)|0)|0;F=0;break}g=f+((aa(s,H)|0)+(aa(m,R)|0)<<2)|0;j=aa(G,R)|0;if((J|0)<=0)break a;if((j|0)<2){h=(j|0)==1;f=0;while(1){if(h)o[a>>2]=v*+o[g>>2]+w*+o[g+(R<<2)>>2]+x*+o[g+(H<<2)>>2]+y*+o[g+(H+R<<2)>>2];f=f+1|0;if((f|0)==(J|0))break a;else{g=g+(H<<2)|0;a=a+(I<<2)|0}}}m=j+-2|0;n=((m|0)>1?m:1)+2&-2;s=(n|0)<(j|0);h=0;while(1){f=0;do{O=f+R|0;P=f+H|0;Q=P+R|0;V=f|1;z=v*+o[g+(V<<2)>>2]+w*+o[g+(O+1<<2)>>2]+x*+o[g+(P+1<<2)>>2]+y*+o[g+(Q+1<<2)>>2];o[a+(f<<2)>>2]=v*+o[g+(f<<2)>>2]+w*+o[g+(O<<2)>>2]+x*+o[g+(P<<2)>>2]+y*+o[g+(Q<<2)>>2];o[a+(V<<2)>>2]=z;f=f+2|0}while((f|0)<=(m|0));if(s){f=n;do{V=f+H|0;o[a+(f<<2)>>2]=v*+o[g+(f<<2)>>2]+w*+o[g+(f+R<<2)>>2]+x*+o[g+(V<<2)>>2]+y*+o[g+(V+R<<2)>>2];f=f+1|0}while((f|0)!=(j|0))}h=h+1|0;if((h|0)==(J|0))break a;else{g=g+(H<<2)|0;a=a+(I<<2)|0}}}else{F=0-m|0;g=h-G|0;F=(G|0)<(F|0)?G:F;D=R<<2}while(0);n=H<<2;h=h-m|0;j=h+-1|0;if((g|0)>(m|0))c=G;else{V=f+(aa(j,D)|0)|0;c=(h|0)<1;f=c?V:f;c=c?0:j}h=(s|0)>-1;g=f+(aa(s,n)|0)|0;E=h?0:0-s|0;f=h?g:f;g=e-s|0;h=g+-1|0;if((e-J|0)>(s|0))s=J;else{V=f+(aa(h,n)|0)|0;s=(g|0)<1;f=s?V:f;s=s?0:h}if((J|0)>0){B=0-H|0;C=aa(F,R)|0;e=(F|0)>0;A=aa(c,R)|0;b=(c|0)<(G|0);d=(C|0)<(A|0);n=0;j=f+(aa(F,0-D|0)|0)|0;while(1){h=j+(H<<2)|0;m=(n|0)<(s|0);h=(n|0)>=(E|0)&m?h:h+(B<<2)|0;if(!e){if(b){f=0;do{g=f+A|0;p=t*+o[j+(g<<2)>>2]+q*+o[h+(g<<2)>>2];g=c;do{V=a+((aa(g,R)|0)+f<<2)|0;o[V>>2]=p;g=g+1|0}while((g|0)!=(G|0));f=f+1|0}while((f|0)!=(R|0))}}else{g=0;do{f=g+C|0;p=t*+o[j+(f<<2)>>2]+q*+o[h+(f<<2)>>2];f=0;do{V=a+((aa(f,R)|0)+g<<2)|0;o[V>>2]=p;f=f+1|0}while((f|0)!=(F|0));V=g+A|0;p=t*+o[j+(V<<2)>>2]+q*+o[h+(V<<2)>>2];if(b){f=c;do{V=a+((aa(f,R)|0)+g<<2)|0;o[V>>2]=p;f=f+1|0}while((f|0)!=(G|0))}g=g+1|0}while((g|0)!=(R|0))}if(d){f=C;do{V=f+R|0;o[a+(f<<2)>>2]=v*+o[j+(f<<2)>>2]+w*+o[j+(V<<2)>>2]+x*+o[h+(f<<2)>>2]+y*+o[h+(V<<2)>>2];f=f+1|0}while((f|0)!=(A|0))}n=n+1|0;if((n|0)==(J|0))break;else{a=a+(I<<2)|0;j=m?h:j}}}}while(0);g=S+36|0;a=k[g>>2]|0;if(a|0?(R=a+12|0,V=k[R>>2]|0,k[R>>2]=V+-1,(V|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[S+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;V=S+16|0;f=S+4|0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[f>>2]|0)>0){g=k[S+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[S+44>>2]|0;if(!((a|0)==(S+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=T+36|0;a=k[g>>2]|0;if(a|0?(S=a+12|0,V=k[S>>2]|0,k[S>>2]=V+-1,(V|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[T+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;V=T+16|0;f=T+4|0;k[V>>2]=0;k[V+4>>2]=0;k[V+8>>2]=0;k[V+12>>2]=0;if((k[f>>2]|0)>0){g=k[T+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[T+44>>2]|0;if((a|0)==(T+48|0)|(a|0)==0){r=U;return}ggb(k[a+-4>>2]|0);r=U;return}function Xra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+8|0;e=k[i>>2]|0;j=a+4|0;c=k[j>>2]|0;if(((e-c|0)/12|0)>>>0>=b>>>0){do{k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;c=(k[j>>2]|0)+12|0;k[j>>2]=c;b=b+-1|0}while((b|0)!=0);return}d=k[a>>2]|0;f=(c-d|0)/12|0;c=f+b|0;if(c>>>0>357913941)ad(426534,426557,304,426811);g=(e-d|0)/12|0;h=g<<1;h=g>>>0<178956970?(h>>>0<c>>>0?c:h):357913941;if(!h)c=0;else{if(h>>>0>357913941){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=h*12|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}g=c+(f*12|0)|0;d=g;f=g;do{k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;d=f+12|0;f=d;b=b+-1|0}while((b|0)!=0);d=k[a>>2]|0;e=(k[j>>2]|0)-d|0;b=g+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)upb(b|0,d|0,e|0)|0;k[a>>2]=b;k[j>>2]=f;k[i>>2]=c+(h*12|0);if(!d)return;ggb(d);return}function Yra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0.0,g=0.0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0.0,v=0.0;s=r;r=r+64|0;q=s+8|0;p=s;do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[q>>2]=k[j>>2];n=q+4|0;a=j+4|0;k[n>>2]=k[a>>2];m=q+8|0;k[m>>2]=k[j+8>>2];k[q+12>>2]=k[j+12>>2];k[q+16>>2]=k[j+16>>2];k[q+20>>2]=k[j+20>>2];k[q+24>>2]=k[j+24>>2];k[q+28>>2]=k[j+28>>2];k[q+32>>2]=k[j+32>>2];c=k[j+36>>2]|0;k[q+36>>2]=c;d=q+40|0;k[d>>2]=m;m=q+48|0;l=q+44|0;k[l>>2]=m;k[q+52>>2]=0;k[m>>2]=0;if(c|0){m=c+12|0;k[m>>2]=(k[m>>2]|0)+1}if((k[a>>2]|0)<3){n=k[j+44>>2]|0;a=k[l>>2]|0;k[a>>2]=k[n>>2];k[a+4>>2]=k[n+4>>2];a=q;break}k[n>>2]=0;x1(q,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[j+40>>2]|0;h=k[d>>2]|0;d=k[j+44>>2]|0;c=k[l>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[m+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0));a=q}else a=q}else{Q1(q,a,-1);a=q}while(0);m=y2(q,2,-1,1)|0;l=k[a>>2]&7;if(!((m|0)>-1&(l|1|0)==5)){k[p>>2]=0;a=p+4|0;k[a>>2]=0;c=ZT(56)|0;k[c>>2]=1;d=c+4|0;k[p>>2]=d;k[a>>2]=50;i[c+54>>0]=0;h=348341;j=d+50|0;do{i[d>>0]=i[h>>0]|0;d=d+1|0;h=h+1|0}while((d|0)<(j|0));Y8(-215,p,348464,348392,281);k[a>>2]=0;k[p>>2]=0;p=k[c>>2]|0;k[c>>2]=p+-1;if((p|0)==1)ggb(k[c+-4>>2]|0)}if((m|0)>=2){h=b?m+-1|0:0;j=k[q+16>>2]|0;if((l|0)==5){e=0.0;c=0;d=k[j+(h<<3)>>2]|0;a=k[j+(h<<3)+4>>2]|0;do{b=d;d=k[j+(c<<3)>>2]|0;p=a;a=k[j+(c<<3)+4>>2]|0;g=(k[u>>2]=d,+o[u>>2]);g=g-(k[u>>2]=b,+o[u>>2]);f=(k[u>>2]=a,+o[u>>2]);f=f-(k[u>>2]=p,+o[u>>2]);e=e+ +Q(+(f*f+g*g));c=c+1|0}while((c|0)!=(m|0))}else{e=0.0;a=0;g=+(k[j+(h<<3)>>2]|0);f=+(k[j+(h<<3)+4>>2]|0);do{t=g;g=+(k[j+(a<<3)>>2]|0);v=f;f=+(k[j+(a<<3)+4>>2]|0);t=g-t;v=f-v;e=e+ +Q(+(v*v+t*t));a=a+1|0}while((a|0)!=(m|0))}}else e=0.0;d=q+36|0;a=k[d>>2]|0;if(a|0?(b=a+12|0,p=k[b>>2]|0,k[b>>2]=p+-1,(p|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;p=q+16|0;c=q+4|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[c>>2]|0)>0){d=k[q+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[q+44>>2]|0;if((a|0)==(q+48|0)|(a|0)==0){r=s;return +e}ggb(k[a+-4>>2]|0);r=s;return +e}function Zra(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0.0,s=0.0;p=r;r=r+64|0;n=p+8|0;m=p;do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[n>>2]=k[g>>2];l=n+4|0;a=g+4|0;k[l>>2]=k[a>>2];j=n+8|0;k[j>>2]=k[g+8>>2];k[n+12>>2]=k[g+12>>2];k[n+16>>2]=k[g+16>>2];k[n+20>>2]=k[g+20>>2];k[n+24>>2]=k[g+24>>2];k[n+28>>2]=k[g+28>>2];k[n+32>>2]=k[g+32>>2];d=k[g+36>>2]|0;k[n+36>>2]=d;e=n+40|0;k[e>>2]=j;j=n+48|0;h=n+44|0;k[h>>2]=j;k[n+52>>2]=0;k[j>>2]=0;if(d|0){j=d+12|0;k[j>>2]=(k[j>>2]|0)+1}if((k[a>>2]|0)<3){l=k[g+44>>2]|0;a=k[h>>2]|0;k[a>>2]=k[l>>2];k[a+4>>2]=k[l+4>>2];a=n;break}k[l>>2]=0;x1(n,k[a>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;f=k[e>>2]|0;e=k[g+44>>2]|0;d=k[h>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[j+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[l>>2]|0));a=n}else a=n}else{Q1(n,a,-1);a=n}while(0);j=y2(n,2,-1,1)|0;a=k[a>>2]&7;if(!((j|0)>-1&(a|1|0)==5)){k[m>>2]=0;d=m+4|0;k[d>>2]=0;e=ZT(60)|0;k[e>>2]=1;f=e+4|0;k[m>>2]=f;k[d>>2]=52;i[e+56>>0]=0;g=348474;h=f+52|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,m,348527,348392,314);k[d>>2]=0;k[m>>2]=0;m=k[e>>2]|0;k[e>>2]=m+-1;if((m|0)==1)ggb(k[e+-4>>2]|0)}if(j){d=(a|0)==5;g=k[n+16>>2]|0;a=j+-1|0;if(d){f=k[g+(a<<3)>>2]|0;a=k[g+(a<<3)+4>>2]|0}else{f=(o[u>>2]=+(k[g+(a<<3)>>2]|0),k[u>>2]|0);a=(o[u>>2]=+(k[g+(a<<3)+4>>2]|0),k[u>>2]|0)}if((j|0)>0)if(d){c=0.0;e=0;d=f;do{l=d;d=k[g+(e<<3)>>2]|0;m=a;a=k[g+(e<<3)+4>>2]|0;s=(k[u>>2]=l,+o[u>>2]);s=s*(k[u>>2]=a,+o[u>>2]);q=(k[u>>2]=m,+o[u>>2]);c=c+(s-q*(k[u>>2]=d,+o[u>>2]));e=e+1|0}while((e|0)!=(j|0))}else{c=0.0;e=0;d=f;do{s=+(k[g+(e<<3)>>2]|0);q=+(k[g+(e<<3)+4>>2]|0);l=d;d=(o[u>>2]=s,k[u>>2]|0);m=a;a=(o[u>>2]=q,k[u>>2]|0);q=(k[u>>2]=l,+o[u>>2])*q;c=c+(q-(k[u>>2]=m,+o[u>>2])*s);e=e+1|0}while((e|0)!=(j|0))}else c=0.0;c=c*.5;if(!b)c=+P(+c)}else c=0.0;e=n+36|0;a=k[e>>2]|0;if(a|0?(m=a+12|0,b=k[m>>2]|0,k[m>>2]=b+-1,(b|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;b=n+16|0;d=n+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[d>>2]|0)>0){e=k[n+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[n+44>>2]|0;if((a|0)==(n+48|0)|(a|0)==0){r=p;return +c}ggb(k[a+-4>>2]|0);r=p;return +c}function _ra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0.0,m=0.0,n=0.0,q=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,R=0,S=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;qa=r;r=r+2592|0;pa=qa+2528|0;S=qa+2232|0;_=qa+2192|0;oa=qa+1096|0;na=qa;ma=qa+2472|0;ja=qa+2416|0;ea=qa+2360|0;N=qa+2304|0;O=qa+2288|0;R=qa+2272|0;do if((k[b>>2]&2031616|0)==65536){e=k[b+4>>2]|0;k[pa>>2]=k[e>>2];j=pa+4|0;b=e+4|0;k[j>>2]=k[b>>2];la=pa+8|0;k[la>>2]=k[e+8>>2];k[pa+12>>2]=k[e+12>>2];k[pa+16>>2]=k[e+16>>2];k[pa+20>>2]=k[e+20>>2];k[pa+24>>2]=k[e+24>>2];k[pa+28>>2]=k[e+28>>2];k[pa+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[pa+36>>2]=c;d=pa+40|0;k[d>>2]=la;la=pa+48|0;g=pa+44|0;k[g>>2]=la;k[pa+52>>2]=0;k[la>>2]=0;if(c|0){la=c+12|0;k[la>>2]=(k[la>>2]|0)+1}if((k[b>>2]|0)<3){la=k[e+44>>2]|0;b=k[g>>2]|0;k[b>>2]=k[la>>2];k[b+4>>2]=k[la+4>>2];b=pa;break}k[j>>2]=0;x1(pa,k[b>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0));b=pa}else b=pa}else{Q1(pa,b,-1);b=pa}while(0);H=y2(pa,2,-1,1)|0;d=k[b>>2]&7;if(!((H|0)>-1&(d|1|0)==5)){k[S>>2]=0;b=S+4|0;k[b>>2]=0;c=ZT(52)|0;k[c>>2]=1;e=c+4|0;k[S>>2]=e;k[b>>2]=46;i[c+50>>0]=0;f=348539;g=e+46|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,S,348586,348392,345);k[b>>2]=0;k[S>>2]=0;la=k[c>>2]|0;k[c>>2]=la+-1;if((la|0)==1)ggb(k[c+-4>>2]|0)};k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;if((H|0)<5){k[S>>2]=0;b=S+4|0;k[b>>2]=0;c=ZT(60)|0;k[c>>2]=1;e=c+4|0;k[S>>2]=e;k[b>>2]=52;i[c+56>>0]=0;f=348597;g=e+52|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-201,S,348586,348392,350);k[b>>2]=0;k[S>>2]=0;la=k[c>>2]|0;k[c>>2]=la+-1;if((la|0)==1)ggb(k[c+-4>>2]|0)}F=(d|0)==5;ka=pa+16|0;G=k[ka>>2]|0;la=pa+44|0;e=H*5|0;ha=oa+8|0;k[oa>>2]=ha;ia=oa+4|0;k[ia>>2]=136;if(e>>>0>136){c=e>>>0>536870911?-1:e<<3;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[oa>>2]=b}else b=ha;k[ia>>2]=e;fa=na+8|0;k[na>>2]=fa;ga=na+4|0;k[ga>>2]=136;if(H>>>0>136){d=H>>>0>536870911?-1:H<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[na>>2]=c}else c=fa;k[ga>>2]=H;ba=ma+4|0;k[ba>>2]=2;da=ma+8|0;k[da>>2]=H;k[ma+12>>2]=5;$=ma+16|0;k[$>>2]=b;k[ma+20>>2]=b;W=ma+24|0;aa=ma+40|0;ca=W+8|0;k[ca>>2]=0;k[ca+4>>2]=0;k[aa>>2]=da;da=ma+48|0;ca=ma+44|0;k[ca>>2]=da;k[ma>>2]=1124024326;k[da>>2]=40;k[ma+52>>2]=8;Z=b+(e<<3)|0;k[ma+28>>2]=Z;k[W>>2]=Z+-40+40;W=ja+4|0;k[W>>2]=2;Z=ja+8|0;k[Z>>2]=H;k[ja+12>>2]=1;U=ja+16|0;k[U>>2]=c;k[ja+20>>2]=c;K=ja+24|0;V=ja+40|0;X=K+8|0;k[X>>2]=0;k[X+4>>2]=0;k[V>>2]=Z;Z=ja+48|0;X=ja+44|0;k[X>>2]=Z;k[ja>>2]=1124024326;k[Z>>2]=8;k[ja+52>>2]=8;A=c+(H<<3)|0;k[ja+28>>2]=A;B=A+-8+8|0;k[K>>2]=B;K=ea+4|0;k[K>>2]=2;M=ea+8|0;k[M>>2]=5;k[ea+12>>2]=1;I=ea+16|0;k[I>>2]=S;k[ea+20>>2]=S;D=ea+24|0;J=ea+40|0;L=D+8|0;k[L>>2]=0;k[L+4>>2]=0;k[J>>2]=M;M=ea+48|0;L=ea+44|0;k[L>>2]=M;k[ea>>2]=1124024326;k[M>>2]=8;k[ea+52>>2]=8;k[ea+28>>2]=S+40;k[D>>2]=S+40;D=(H|0)>0;if(D){if(F){d=0;m=0.0;l=0.0;do{m=m+ +o[G+(d<<3)>>2];l=l+ +o[G+(d<<3)+4>>2];d=d+1|0}while((d|0)!=(H|0))}else{d=0;m=0.0;l=0.0;do{m=m+ +(k[G+(d<<3)>>2]|0);l=l+ +(k[G+(d<<3)+4>>2]|0);d=d+1|0}while((d|0)!=(H|0))}E=+(H|0);m=m/E;l=l/E;if(F){d=0;do{C=+o[G+(d<<3)>>2]-m;E=+o[G+(d<<3)+4>>2]-l;p[c+(d<<3)>>3]=1.0e4;z=d*5|0;p[b+(z<<3)>>3]=-(C*C);p[b+(z+1<<3)>>3]=-(E*E);p[b+(z+2<<3)>>3]=-(E*C);p[b+(z+3<<3)>>3]=C;p[b+(z+4<<3)>>3]=E;d=d+1|0}while((d|0)!=(H|0));E=m;C=l}else{d=0;do{C=+(k[G+(d<<3)>>2]|0)-m;E=+(k[G+(d<<3)+4>>2]|0)-l;p[c+(d<<3)>>3]=1.0e4;z=d*5|0;p[b+(z<<3)>>3]=-(C*C);p[b+(z+1<<3)>>3]=-(E*E);p[b+(z+2<<3)>>3]=-(E*C);p[b+(z+3<<3)>>3]=C;p[b+(z+4<<3)>>3]=E;d=d+1|0}while((d|0)!=(H|0));E=m;C=l}}else{C=0.0/+(H|0);E=C}k[N+8>>2]=0;k[N+12>>2]=0;k[N>>2]=16842752;k[N+4>>2]=ma;k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=ja;j=R+4|0;v=j+4|0;k[v>>2]=0;k[v+4>>2]=0;k[R>>2]=33619968;k[j>>2]=ea;NZ(N,O,R,1)|0;j=N+4|0;k[j>>2]=2;v=N+8|0;k[v>>2]=2;k[N+12>>2]=2;f=N+16|0;k[f>>2]=b;k[N+20>>2]=b;h=N+24|0;g=N+40|0;u=h+8|0;k[u>>2]=0;k[u+4>>2]=0;k[g>>2]=v;v=N+48|0;u=N+44|0;k[u>>2]=v;k[N>>2]=1124024326;k[v>>2]=16;k[N+52>>2]=8;k[N+28>>2]=b+32;k[h>>2]=b+32;KG(ma,N)|0;h=N+36|0;d=k[h>>2]|0;if(d|0?(y=d+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){e=k[h>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[N+32>>2]|0;if(!d){d=B1()|0;e=k[h>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[h>>2]=0}k[h>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[j>>2]|0)>0){e=k[g>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[u>>2]|0;if(!((d|0)==(v|0)|(d|0)==0))ggb(k[d+-4>>2]|0);j=N+4|0;k[j>>2]=2;v=N+8|0;k[v>>2]=2;k[N+12>>2]=1;f=N+16|0;k[f>>2]=c;k[N+20>>2]=c;h=N+24|0;g=N+40|0;u=h+8|0;k[u>>2]=0;k[u+4>>2]=0;k[g>>2]=v;v=N+48|0;u=N+44|0;k[u>>2]=v;k[N>>2]=1124024326;k[v>>2]=8;k[N+52>>2]=8;k[N+28>>2]=c+16;k[h>>2]=c+16;KG(ja,N)|0;h=N+36|0;d=k[h>>2]|0;if(d|0?(y=d+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){e=k[h>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[N+32>>2]|0;if(!d){d=B1()|0;e=k[h>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[h>>2]=0}k[h>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[j>>2]|0)>0){e=k[g>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[u>>2]|0;if(!((d|0)==(v|0)|(d|0)==0))ggb(k[d+-4>>2]|0);j=N+4|0;k[j>>2]=2;v=N+8|0;k[v>>2]=2;k[N+12>>2]=1;f=N+16|0;k[f>>2]=_;k[N+20>>2]=_;h=N+24|0;g=N+40|0;u=h+8|0;k[u>>2]=0;k[u+4>>2]=0;k[g>>2]=v;v=N+48|0;u=N+44|0;k[u>>2]=v;k[N>>2]=1124024326;k[v>>2]=8;k[N+52>>2]=8;z=_+16|0;k[N+28>>2]=z;k[h>>2]=z;KG(ea,N)|0;h=N+36|0;d=k[h>>2]|0;if(d|0?(x=d+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){e=k[h>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[N+32>>2]|0;if(!d){d=B1()|0;e=k[h>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[h>>2]=0}k[h>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[j>>2]|0)>0){e=k[g>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[u>>2]|0;if(!((d|0)==(v|0)|(d|0)==0))ggb(k[d+-4>>2]|0);p[b>>3]=+p[S>>3]*2.0;x=S+16|0;t=+p[x>>3];p[b+16>>3]=t;p[b+8>>3]=t;y=S+8|0;p[b+24>>3]=+p[y>>3]*2.0;w=S+24|0;p[c>>3]=+p[w>>3];p[c+8>>3]=+p[S+32>>3];k[N+8>>2]=0;k[N+12>>2]=0;k[N>>2]=16842752;k[N+4>>2]=ma;k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=ja;j=R+4|0;v=j+4|0;k[v>>2]=0;k[v+4>>2]=0;k[R>>2]=33619968;k[j>>2]=ea;NZ(N,O,R,1)|0;j=N+4|0;k[j>>2]=2;v=N+8|0;k[v>>2]=H;k[N+12>>2]=3;f=N+16|0;k[f>>2]=b;k[N+20>>2]=b;h=N+24|0;g=N+40|0;u=h+8|0;k[u>>2]=0;k[u+4>>2]=0;k[g>>2]=v;v=N+48|0;u=N+44|0;k[u>>2]=v;k[N>>2]=1124024326;k[v>>2]=24;k[N+52>>2]=8;d=b+(H*3<<3)|0;k[N+28>>2]=d;k[h>>2]=d+-24+24;KG(ma,N)|0;h=N+36|0;d=k[h>>2]|0;if(d|0?(d=d+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){e=k[h>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[N+32>>2]|0;if(d|0)break;d=B1()|0;e=k[h>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[h>>2]=0}k[h>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[j>>2]|0)>0){e=k[g>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[u>>2]|0;if(!((d|0)==(v|0)|(d|0)==0))ggb(k[d+-4>>2]|0);j=N+4|0;k[j>>2]=2;v=N+8|0;k[v>>2]=H;k[N+12>>2]=1;g=N+16|0;k[g>>2]=c;k[N+20>>2]=c;f=N+24|0;h=N+40|0;u=f+8|0;k[u>>2]=0;k[u+4>>2]=0;k[h>>2]=v;v=N+48|0;u=N+44|0;k[u>>2]=v;k[N>>2]=1124024326;k[v>>2]=8;k[N+52>>2]=8;k[N+28>>2]=A;k[f>>2]=B;KG(ja,N)|0;f=N+36|0;d=k[f>>2]|0;do if(d|0){A=d+12|0;B=k[A>>2]|0;k[A>>2]=B+-1;if((B|0)!=1)break;e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[N+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}while(0);k[f>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[j>>2]|0)>0){e=k[h>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[u>>2]|0;if(!((d|0)==(v|0)|(d|0)==0))ggb(k[d+-4>>2]|0);j=N+4|0;k[j>>2]=2;v=N+8|0;k[v>>2]=3;k[N+12>>2]=1;g=N+16|0;k[g>>2]=S;k[N+20>>2]=S;f=N+24|0;h=N+40|0;u=f+8|0;k[u>>2]=0;k[u+4>>2]=0;k[h>>2]=v;v=N+48|0;u=N+44|0;k[u>>2]=v;k[N>>2]=1124024326;k[v>>2]=8;k[N+52>>2]=8;k[N+28>>2]=w;k[f>>2]=w;KG(ea,N)|0;f=N+36|0;d=k[f>>2]|0;do if(d|0){A=d+12|0;B=k[A>>2]|0;k[A>>2]=B+-1;if((B|0)!=1)break;e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;do if(!d){d=k[N+32>>2]|0;if(d|0)break;d=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}while(0);k[f>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[j>>2]|0)>0){e=k[h>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[u>>2]|0;if(!((d|0)==(v|0)|(d|0)==0))ggb(k[d+-4>>2]|0);if(D){l=+p[_>>3];m=+p[_+8>>3];if(F){d=0;do{s=+o[G+(d<<3)>>2]-E;t=+o[G+(d<<3)+4>>2]-C;p[c+(d<<3)>>3]=1.0;s=s-l;F=d*3|0;p[b+(F<<3)>>3]=s*s;t=t-m;p[b+(F+1<<3)>>3]=t*t;p[b+(F+2<<3)>>3]=s*t;d=d+1|0}while((d|0)!=(H|0))}else{d=0;do{s=+(k[G+(d<<3)>>2]|0)-E;t=+(k[G+(d<<3)+4>>2]|0)-C;p[c+(d<<3)>>3]=1.0;s=s-l;F=d*3|0;p[b+(F<<3)>>3]=s*s;t=t-m;p[b+(F+1<<3)>>3]=t*t;p[b+(F+2<<3)>>3]=s*t;d=d+1|0}while((d|0)!=(H|0))}}k[N+8>>2]=0;k[N+12>>2]=0;k[N>>2]=16842752;k[N+4>>2]=ma;k[O+8>>2]=0;k[O+12>>2]=0;k[O>>2]=16842752;k[O+4>>2]=ja;H=R+4|0;G=H+4|0;k[G>>2]=0;k[G+4>>2]=0;k[R>>2]=33619968;k[H>>2]=ea;NZ(N,O,R,1)|0;n=+p[x>>3];s=+p[y>>3];m=+p[S>>3];l=s-m;t=+Y(+n,+l)*-.5;p[_+32>>3]=t;if(+P(+n)>1.0e-08)q=n/+T(+(t*-2.0));else q=l;m=m+s;l=+P(+(m-q));if(l>1.0e-08)n=+Q(+(2.0/l));else n=l;p[z>>3]=n;l=+P(+(q+m));if(l>1.0e-08)l=+Q(+(2.0/l));p[_+24>>3]=l;o[a>>2]=E+ +p[_>>3];o[a+4>>2]=C+ +p[_+8>>3];m=n*2.0;c=a+8|0;o[c>>2]=m;l=l*2.0;b=a+12|0;o[b>>2]=l;if(m>l){o[c>>2]=l;o[b>>2]=m;l=t*180.0/3.141592653589793+90.0;b=a+16|0;o[b>>2]=l}else{a=a+16|0;b=a;l=+o[a>>2]}if(l<-180.0){l=l+360.0;o[b>>2]=l}if(l>360.0)o[b>>2]=l+-360.0;d=ea+36|0;b=k[d>>2]|0;do if(b|0){_=b+12|0;a=k[_>>2]|0;k[_>>2]=a+-1;if((a|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ea+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;k[I>>2]=0;k[I+4>>2]=0;k[I+8>>2]=0;k[I+12>>2]=0;if((k[K>>2]|0)>0){c=k[J>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[K>>2]|0))}b=k[L>>2]|0;if(!((b|0)==(M|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=ja+36|0;b=k[d>>2]|0;do if(b|0){a=b+12|0;ea=k[a>>2]|0;k[a>>2]=ea+-1;if((ea|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ja+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[W>>2]|0)>0){c=k[V>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[W>>2]|0))}b=k[X>>2]|0;if(!((b|0)==(Z|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=ma+36|0;b=k[d>>2]|0;do if(b|0){ea=b+12|0;ja=k[ea>>2]|0;k[ea>>2]=ja+-1;if((ja|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[ma+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;if((k[ba>>2]|0)>0){c=k[aa>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[ba>>2]|0))}b=k[ca>>2]|0;if(!((b|0)==(da|0)|(b|0)==0))ggb(k[b+-4>>2]|0);b=k[na>>2]|0;if((b|0)!=(fa|0)){if(b|0)ggb(b);k[na>>2]=fa;k[ga>>2]=136}b=k[oa>>2]|0;if((b|0)!=(ha|0)){if(b|0)ggb(b);k[oa>>2]=ha;k[ia>>2]=136}d=pa+36|0;b=k[d>>2]|0;do if(b|0){na=b+12|0;oa=k[na>>2]|0;k[na>>2]=oa+-1;if((oa|0)!=1)break;c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;do if(!b){b=k[pa+32>>2]|0;if(b|0)break;b=B1()|0;c=k[d>>2]|0}while(0);jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}while(0);k[d>>2]=0;d=pa+4|0;k[ka>>2]=0;k[ka+4>>2]=0;k[ka+8>>2]=0;k[ka+12>>2]=0;if((k[d>>2]|0)>0){c=k[pa+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[la>>2]|0;if((b|0)==(pa+48|0)|(b|0)==0){r=qa;return}ggb(k[b+-4>>2]|0);r=qa;return}function $ra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+64|0;j=l;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[j>>2]=k[f>>2];i=j+4|0;b=f+4|0;k[i>>2]=k[b>>2];h=j+8|0;k[h>>2]=k[f+8>>2];k[j+12>>2]=k[f+12>>2];k[j+16>>2]=k[f+16>>2];k[j+20>>2]=k[f+20>>2];k[j+24>>2]=k[f+24>>2];k[j+28>>2]=k[f+28>>2];k[j+32>>2]=k[f+32>>2];c=k[f+36>>2]|0;k[j+36>>2]=c;d=j+40|0;k[d>>2]=h;h=j+48|0;g=j+44|0;k[g>>2]=h;k[j+52>>2]=0;k[h>>2]=0;if(c|0){h=c+12|0;k[h>>2]=(k[h>>2]|0)+1}if((k[b>>2]|0)<3){i=k[f+44>>2]|0;b=k[g>>2]|0;k[b>>2]=k[i>>2];k[b+4>>2]=k[i+4>>2];b=j;break}k[i>>2]=0;x1(j,k[b>>2]|0,0,0,0);if((k[i>>2]|0)>0){h=k[f+40>>2]|0;e=k[d>>2]|0;d=k[f+44>>2]|0;c=k[g>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[h+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[i>>2]|0));b=j}else b=j}else{Q1(j,b,-1);b=j}while(0);if(!(k[b>>2]&7))asa(a,j);else bsa(a,j);d=j+36|0;b=k[d>>2]|0;if(b|0?(i=b+12|0,a=k[i>>2]|0,k[i>>2]=a+-1,(a|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[j+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;a=j+16|0;c=j+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[c>>2]|0)>0){d=k[j+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[j+44>>2]|0;if((b|0)==(j+48|0)|(b|0)==0){r=l;return}ggb(k[b+-4>>2]|0);r=l;return}function asa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+16|0;c=x;u=k[b>>2]|0;if(!((u&6)>>>0<2&(u&4088|0)==0)){d=c+4|0;e=ZT(48)|0;k[e>>2]=1;f=e+4|0;k[c>>2]=f;k[d>>2]=43;i[e+47>>0]=0;g=348671;h=f+43|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,c,348715,348392,576);k[d>>2]=0;k[c>>2]=0;u=k[e>>2]|0;k[e>>2]=u+-1;if((u|0)==1)ggb(k[e+-4>>2]|0)}t=k[b+40>>2]|0;s=k[t+4>>2]|0;t=k[t>>2]|0;if((t|0)<=0){w=s;t=-1;u=-1;v=0;s=(w|0)<(s|0);t=s?t:0;w=s?w:0;u=u+1|0;u=u-w|0;v=v-t|0;k[a>>2]=w;w=a+4|0;k[w>>2]=t;w=a+8|0;k[w>>2]=u;w=a+12|0;k[w>>2]=v;r=x;return}u=k[b+16>>2]|0;q=k[k[b+44>>2]>>2]|0;n=-1;c=-1;o=0;p=-1;d=s;do{f=u+(aa(q,o)|0)|0;m=f;j=m+3&-4;l=j;m=j-m|0;m=(m|0)>(s|0)?s:m;a:do if((m|0)>0){g=0;while(1){if(i[f+g>>0]|0)break;e=g+1|0;if((e|0)<(m|0))g=e;else{e=0;break a}}e=1;c=(g|0)>(c|0)?g:c;d=(g|0)<(d|0)?g:d}else e=0;while(0);if((s|0)>(m|0)){g=d-m|0;h=c-m|0;c=s-m|0;f=g+-4|0;b:do if((g|0)<4)d=0;else{d=0;do{if(k[l+d>>2]|0)break b;d=d+4|0}while((d|0)<=(f|0))}while(0);c:do if((d|0)<(g|0)){f=d;while(1){if(i[l+f>>0]|0)break;d=f+1|0;if((d|0)<(g|0))f=d;else{j=g;break c}}e=1;d=f;j=f;h=(f|0)>(h|0)?f:h}else j=g;while(0);b=d+-1|0;b=(b|0)<(h|0)?h:b;do{c=c+-1|0;f=(c|0)>(b|0);g=(c&3|0)==3;if(g|f^1){w=22;break}}while((i[l+c>>0]|0)==0);d:do if((w|0)==22){w=0;if(f&g?(v=b+3|0,(c|0)>(v|0)):0)do{if(k[l+c+-3>>2]|0)break d;c=c+-4|0}while((c|0)>(v|0))}while(0);e:do if((c|0)>(b|0))while(1){if(i[l+c>>0]|0){e=1;break e}c=c+-1|0;if((c|0)<=(b|0)){f=c;w=29;break}}else{f=c;w=29}while(0);f:do if((w|0)==29){w=0;if(!e){c=d&-4;d=f+-3|0;g:do if((c|0)<=(d|0))do{if(k[l+c>>2]|0)break g;c=c+4|0}while((c|0)<=(d|0));while(0);if((c|0)>(f|0)){e=0;c=h}else while(1){if(i[l+c>>0]|0){e=1;c=h;break f}if((c|0)<(f|0))c=c+1|0;else{e=0;c=h;break}}}else c=h}while(0);d=j+m|0;c=c+m|0}m=(e|0)==0;p=m?p:o;n=m?n:(n|0)<0?o:n;o=o+1|0}while((o|0)!=(t|0));w=d;t=n;u=c;v=p+1|0;s=(w|0)<(s|0);t=s?t:0;w=s?w:0;u=u+1|0;u=u-w|0;v=v-t|0;k[a>>2]=w;w=a+4|0;k[w>>2]=t;w=a+8|0;k[w>>2]=u;w=a+12|0;k[w>>2]=v;r=x;return}function bsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0.0,p=0.0,q=0.0,s=0.0;m=r;r=r+16|0;d=m;l=y2(b,2,-1,1)|0;j=k[b>>2]&7;if(!((l|0)>-1&(j|1|0)==5)){e=d+4|0;c=ZT(60)|0;k[c>>2]=1;f=c+4|0;k[d>>2]=f;k[e>>2]=52;i[c+56>>0]=0;g=348474;h=f+52|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,d,348650,348392,458);k[e>>2]=0;k[d>>2]=0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)==1)ggb(k[c+-4>>2]|0)}if(!l){k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;r=m;return}h=k[b+16>>2]|0;b=k[h>>2]|0;g=k[h+4>>2]|0;if((j|0)!=5)if((l|0)>1){e=b;d=g;c=b;f=1;b=g;do{g=k[h+(f<<3)>>2]|0;j=k[h+(f<<3)+4>>2]|0;e=(e|0)>(g|0)?g:e;c=(c|0)<(g|0)?g:c;d=(d|0)>(j|0)?j:d;b=(b|0)<(j|0)?j:b;f=f+1|0}while((f|0)!=(l|0))}else{e=b;d=g;c=b;b=g}else{f=b>>31&2147483647^b;b=g>>31&2147483647^g;if((l|0)>1){g=1;e=b;c=f;d=f;do{f=k[h+(g<<3)>>2]|0;j=k[h+(g<<3)+4>>2]|0;f=f>>31&2147483647^f;j=j>>31&2147483647^j;d=(d|0)>(f|0)?f:d;c=(c|0)<(f|0)?f:c;e=(e|0)>(j|0)?j:e;b=(b|0)<(j|0)?j:b;g=g+1|0}while((g|0)!=(l|0))}else{d=f;e=b;c=f}s=(k[u>>2]=d>>31&2147483647^d,+o[u>>2]);l=~~s;q=(k[u>>2]=e>>31&2147483647^e,+o[u>>2]);d=~~q;p=(k[u>>2]=c>>31&2147483647^c,+o[u>>2]);c=~~p;n=(k[u>>2]=b>>31&2147483647^b,+o[u>>2]);b=~~n;e=l-(+(l|0)>s&1)|0;d=d-(+(d|0)>q&1)|0;c=c-(+(c|0)>p&1)|0;b=b-(+(b|0)>n&1)|0}k[a>>2]=e;k[a+4>>2]=d;k[a+8>>2]=c+1-e;k[a+12>>2]=b+1-d;r=m;return}function csa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+1344|0;s=t;q=t+1288|0;p=t+1232|0;m=t+1144|0;n=t+1124|0;d=t+1096|0;l=m+56|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((b|0)!=0?(c=k[b>>2]|0,(c&-65536|0)==1117323264):0){if((c&4094|0)!=12){c=s+4|0;d=ZT(32)|0;k[d>>2]=1;h=d+4|0;k[s>>2]=h;k[c>>2]=25;i[d+29>>0]=0;j=348732;l=h+25|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,s,348758,348392,1031);k[c>>2]=0;k[s>>2]=0;n=k[d>>2]|0;k[d>>2]=n+-1;if((n|0)==1)ggb(k[d+-4>>2]|0)}n=(k[b+4>>2]|0)>87&1;m=b}else o=8;a:do if((o|0)==8){g=G9(b,d,0,0)|0;c=k[g>>2]|0;switch(c&4095){case 13:case 12:{if(g){if(!((((c&-65536|0)==1111621632?(k[g+24>>2]|0)>0:0)?(k[g+20>>2]|0)>0:0)?(k[g+16>>2]|0)!=0:0)){c=p;o=17}}else{c=s+4|0;d=ZT(52)|0;k[d>>2]=1;h=d+4|0;k[s>>2]=h;k[c>>2]=45;i[d+49>>0]=0;j=356299;l=h+45|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,s,356345,356363,47);k[c>>2]=0;k[s>>2]=0;o=k[d>>2]|0;k[d>>2]=o+-1;if((o|0)==1)ggb(k[d+-4>>2]|0);c=p;o=17}if((o|0)==17){d=s+4|0;b=ZT(40)|0;k[b>>2]=1;h=b+4|0;k[s>>2]=h;k[d>>2]=33;i[b+37>>0]=0;j=356430;l=h+33|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,s,356345,356363,54);k[d>>2]=0;k[s>>2]=0;l=k[b>>2]|0;k[b>>2]=l+-1;if((l|0)==1)ggb(k[b+-4>>2]|0);c=k[g>>2]|0}if((c&4088|0)==0?(k[g+24>>2]|0)==2:0){if(!(((c&-65536|0)==1111621632?(k[g+20>>2]|0)>0:0)?(k[g+16>>2]|0)!=0:0)){k[s>>2]=0;c=G9(g,p,s,1)|0;if(k[s>>2]|0){d=q+4|0;b=ZT(28)|0;k[b>>2]=1;h=b+4|0;k[q>>2]=h;k[d>>2]=20;i[b+24>>0]=0;j=382518;l=h+20|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-24,q,235189,233613,2727);k[d>>2]=0;k[q>>2]=0;l=k[b>>2]|0;k[b>>2]=l+-1;if((l|0)==1)ggb(k[b+-4>>2]|0)}g=c}if((g|0)!=(p|0)){l=p+12|0;j=k[l>>2]|0;k[p>>2]=k[g>>2];k[p+4>>2]=k[g+4>>2];k[p+8>>2]=k[g+8>>2];k[p+12>>2]=k[g+12>>2];k[p+16>>2]=k[g+16>>2];k[p+20>>2]=k[g+20>>2];k[p+24>>2]=k[g+24>>2];k[p+8>>2]=0;k[l>>2]=j}b=k[g>>2]|0;c=aa((b>>>3&511)+1|0,k[g+24>>2]|0)|0;d=k[g+20>>2]|0;if(!((c|0)>1&(c&1|0)==0)?(e=aa(d,c)|0,f=(e|0)/2|0,!((e+1|0)>>>0<3|(f|0)==(d|0))):0){if(!(b&16384)){c=s+4|0;d=ZT(80)|0;k[d>>2]=1;h=d+4|0;k[s>>2]=h;k[c>>2]=72;i[d+76>>0]=0;j=235199;l=h+72|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-13,s,235189,233613,2758);k[c>>2]=0;k[s>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}if(f>>>0>e>>>0){c=s+4|0;d=ZT(28)|0;k[d>>2]=1;h=d+4|0;k[s>>2]=h;k[c>>2]=22;i[d+26>>0]=0;j=235272;l=h+22|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-211,s,235189,233613,2761);k[c>>2]=0;k[s>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}c=(e|0)/(f|0)|0;if((aa(c,f)|0)!=(e|0)){d=s+4|0;b=ZT(84)|0;k[b>>2]=1;h=b+4|0;k[s>>2]=h;k[d>>2]=78;i[b+82>>0]=0;j=235110;l=h+78|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,s,235189,233613,2767);k[d>>2]=0;k[s>>2]=0;l=k[b>>2]|0;k[b>>2]=l+-1;if((l|0)==1)ggb(k[b+-4>>2]|0)}k[p+20>>2]=f;l=aa(1212424721>>>(k[g>>2]<<2&28)&15,c)|0;k[p+4>>2]=l}else{k[p+20>>2]=d;k[p+4>>2]=k[g+4>>2]}b=(c|0)/2|0;if((b<<1|0)!=(c|0)){c=s+4|0;d=ZT(68)|0;k[d>>2]=1;h=d+4|0;k[s>>2]=h;k[c>>2]=62;i[d+66>>0]=0;j=235295;l=h+62|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-15,s,235189,233613,2777);k[c>>2]=0;k[s>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}k[p+24>>2]=b;f=k[g>>2]&-4089|8;k[p>>2]=f;g=p}else f=c;e=f&4095;if((f&4094|0)!=12){c=s+4|0;d=ZT(92)|0;k[d>>2]=1;h=d+4|0;k[s>>2]=h;k[c>>2]=87;i[d+91>>0]=0;j=356464;l=h+87|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-210,s,356345,356363,63);k[c>>2]=0;k[s>>2]=0;l=k[d>>2]|0;k[d>>2]=l+-1;if((l|0)==1)ggb(k[d+-4>>2]|0)}b=g+24|0;c=k[b>>2]|0;if((c|0)!=1?(k[g+20>>2]|0)!=1:0)o=60;else if(!(k[g>>2]&16384))o=60;if((o|0)==60){c=s+4|0;d=ZT(80)|0;k[d>>2]=1;h=d+4|0;k[s>>2]=h;k[c>>2]=75;i[d+79>>0]=0;j=356552;l=h+75|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-5,s,356345,356363,68);k[c>>2]=0;k[s>>2]=0;o=k[d>>2]|0;k[d>>2]=o+-1;if((o|0)==1)ggb(k[d+-4>>2]|0);c=k[b>>2]|0}MY(e,88,(f>>>3&511)+1<<(47696>>>(f<<1&14)&3),k[g+16>>2]|0,aa(k[g+20>>2]|0,c)|0,m,n)|0;n=0;break a}case 1:case 0:break;default:{c=s+4|0;d=ZT(64)|0;k[d>>2]=1;h=d+4|0;k[s>>2]=h;k[c>>2]=56;i[d+60>>0]=0;j=348773;l=h+56|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-210,s,348758,348392,1051);k[c>>2]=0;k[s>>2]=0;o=k[d>>2]|0;k[d>>2]=o+-1;if((o|0)==1)ggb(k[d+-4>>2]|0)}}if(!g){n=0;m=0}else{M1(q,g,0,1,0,0);asa(s,q);f=k[s>>2]|0;g=k[s+4>>2]|0;h=k[s+8>>2]|0;e=k[s+12>>2]|0;b=q+36|0;c=k[b>>2]|0;if(c|0?(p=c+12|0,s=k[p>>2]|0,k[p>>2]=s+-1,(s|0)==1):0){d=k[b>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[b>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[b>>2]=0}k[b>>2]=0;s=q+16|0;d=q+4|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[d>>2]|0)>0){b=k[q+40>>2]|0;c=0;do{k[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[q+44>>2]|0;if(!((c|0)==(q+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0);q=f;p=h;s=e;o=g;k[a>>2]=q;q=a+4|0;k[q>>2]=o;q=a+8|0;k[q>>2]=p;a=a+12|0;k[a>>2]=s;r=t;return}}while(0);if(!(k[m+24>>2]|0)){e=0;b=0;d=0;c=0}else{j=s+8|0;k[s>>2]=j;l=s+4|0;k[l>>2]=136;M1(p,m,0,0,0,s);bsa(q,p);e=k[q>>2]|0;c=k[q+4>>2]|0;b=k[q+8>>2]|0;d=k[q+12>>2]|0;h=p+36|0;f=k[h>>2]|0;if(f|0?(o=f+12|0,q=k[o>>2]|0,k[o>>2]=q+-1,(q|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[p+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;q=p+16|0;g=p+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[g>>2]|0)>0){h=k[p+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[p+44>>2]|0;if(!((f|0)==(p+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);f=k[s>>2]|0;if((f|0)!=(j|0)){if(f|0)ggb(f);k[s>>2]=j;k[l>>2]=136}}if(!n){q=e;p=b;s=d;o=c;k[a>>2]=q;q=a+4|0;k[q>>2]=o;q=a+8|0;k[q>>2]=p;a=a+12|0;k[a>>2]=s;r=t;return}k[m+56>>2]=e;k[m+60>>2]=c;k[m+64>>2]=b;k[m+68>>2]=d;q=e;p=b;s=d;o=c;k[a>>2]=q;q=a+4|0;k[q>>2]=o;q=a+8|0;k[q>>2]=p;a=a+12|0;k[a>>2]=s;r=t;return}function dsa(a){a=a|0;ggb(a);return}function esa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function fsa(a){a=a|0;ggb(a);return}function gsa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0;i=aa(k[a+4>>2]|0,e)|0;h=aa(d+-1|0,e)|0;if((e|0)<=0)return;a=(h|0)>0;if((i|0)<=0){if(a){g=0;a=b}else{zpb(c|0,0,e<<3|0)|0;return}while(1){p[c>>3]=0.0;d=0;f=0.0;do{f=f+(+p[a+(d+i<<3)>>3]-+p[a+(d<<3)>>3]);d=d+e|0;p[c+(d<<3)>>3]=f}while((d|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;a=a+8|0}}return}if(a){g=0;d=b}else{g=0;d=b;while(1){a=0;f=0.0;do{f=f+ +p[d+(a<<3)>>3];a=a+e|0}while((a|0)<(i|0));p[c>>3]=f;g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+8|0}}return}while(1){a=0;f=0.0;do{f=f+ +p[d+(a<<3)>>3];a=a+e|0}while((a|0)<(i|0));p[c>>3]=f;a=0;do{f=f+(+p[d+(a+i<<3)>>3]-+p[d+(a<<3)>>3]);a=a+e|0;p[c+(a<<3)>>3]=f}while((a|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+8|0}}return}function hsa(a){a=a|0;ggb(a);return}function isa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function jsa(a){a=a|0;ggb(a);return}function ksa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0;i=aa(k[a+4>>2]|0,e)|0;h=aa(d+-1|0,e)|0;if((e|0)<=0)return;a=(h|0)>0;if((i|0)<=0){if(a){g=0;a=b}else{zpb(c|0,0,e<<3|0)|0;return}while(1){p[c>>3]=0.0;d=0;f=0.0;do{f=f+(+o[a+(d+i<<2)>>2]-+o[a+(d<<2)>>2]);d=d+e|0;p[c+(d<<3)>>3]=f}while((d|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;a=a+4|0}}return}if(a){g=0;d=b}else{g=0;d=b;while(1){a=0;f=0.0;do{f=f+ +o[d+(a<<2)>>2];a=a+e|0}while((a|0)<(i|0));p[c>>3]=f;g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+4|0}}return}while(1){a=0;f=0.0;do{f=f+ +o[d+(a<<2)>>2];a=a+e|0}while((a|0)<(i|0));p[c>>3]=f;a=0;do{f=f+(+o[d+(a+i<<2)>>2]-+o[d+(a<<2)>>2]);a=a+e|0;p[c+(a<<3)>>3]=f}while((a|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+4|0}}return}function lsa(a){a=a|0;ggb(a);return}function msa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function nsa(a){a=a|0;ggb(a);return}function osa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0;i=aa(k[a+4>>2]|0,e)|0;h=aa(d+-1|0,e)|0;if((e|0)<=0)return;a=(h|0)>0;if((i|0)<=0){if(a){g=0;a=b}else{zpb(c|0,0,e<<3|0)|0;return}while(1){p[c>>3]=0.0;d=0;f=0.0;do{f=f+ +((j[a+(d+i<<1)>>1]|0)-(j[a+(d<<1)>>1]|0)|0);d=d+e|0;p[c+(d<<3)>>3]=f}while((d|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;a=a+2|0}}return}if(a){g=0;d=b}else{g=0;d=b;while(1){a=0;f=0.0;do{f=f+ +(j[d+(a<<1)>>1]|0);a=a+e|0}while((a|0)<(i|0));p[c>>3]=f;g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+2|0}}return}while(1){a=0;f=0.0;do{f=f+ +(j[d+(a<<1)>>1]|0);a=a+e|0}while((a|0)<(i|0));p[c>>3]=f;a=0;do{f=f+ +((j[d+(a+i<<1)>>1]|0)-(j[d+(a<<1)>>1]|0)|0);a=a+e|0;p[c+(a<<3)>>3]=f}while((a|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+2|0}}return}function psa(a){a=a|0;ggb(a);return}function qsa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function rsa(a){a=a|0;ggb(a);return}
function d_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;g=j;if((d|0)<0){h=(d|0)==-1;i[g>>0]=((h<<31>>31)+128|0)>>>0<256?h<<31>>31:-128;i[g+1>>0]=(d<<1&2^2)+255;i[g+2>>0]=127;i[g+3>>0]=1;i[g+4>>0]=h&1;if((c|0)>0){f=0;do{d=i[a+f>>0]|0;e=d<<24>>24;if(((d<<24>>24>-1?e:0-e|0)|0)<3)e=i[g+(e+2)>>0]|0;else e=0;i[b+f>>0]=e;f=f+1|0}while((f|0)!=(c|0))}r=j;return}if((c|0)<=0){r=j;return}if((d|0)>1)g=0;else{e=0;do{d=i[a+e>>0]|0;h=d<<24>>24;i[b+e>>0]=(h+128|0)>>>0<256?h:d<<24>>24>0?127:128;e=e+1|0}while((e|0)!=(c|0));r=j;return}do{e=i[a+g>>0]|0;f=1;h=d;do{f=aa((h&1|0)==0?1:e,f)|0;e=aa(e,e)|0;h=h>>1}while((h|0)>1);h=aa(f,e)|0;i[b+g>>0]=(h+128|0)>>>0<256?h:(h|0)>0?127:128;g=g+1|0}while((g|0)!=(c|0));r=j;return}function e_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=r;r=r+16|0;g=i;if((d|0)<0){h=(d|0)==-1;j[g>>1]=h?0:h<<31>>31;d=d<<1&2;f=(d^2)+-1|0;j[g+2>>1]=f>>>0<65536?f:(d|0)==0?65535:0;j[g+4>>1]=-1;j[g+6>>1]=1;j[g+8>>1]=h&1;if((c|0)>0){f=0;do{e=j[a+(f<<1)>>1]|0;if((e&65535)<3)e=j[g+((e&65535)+2<<1)>>1]|0;else e=0;j[b+(f<<1)>>1]=e;f=f+1|0}while((f|0)!=(c|0))}r=i;return}if((c|0)<=0){r=i;return}if((d|0)>1)g=0;else{e=0;do{j[b+(e<<1)>>1]=j[a+(e<<1)>>1]|0;e=e+1|0}while((e|0)!=(c|0));r=i;return}do{e=m[a+(g<<1)>>1]|0;f=1;h=d;do{f=aa((h&1|0)==0?1:e,f)|0;e=aa(e,e)|0;h=h>>1}while((h|0)>1);h=aa(f,e)|0;j[b+(g<<1)>>1]=h>>>0>65535?65535:h;g=g+1|0}while((g|0)!=(c|0));r=i;return}function f_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=r;r=r+16|0;g=i;if((d|0)<0){h=(d|0)==-1;j[g>>1]=((h<<31>>31)+32768|0)>>>0<65536?h<<31>>31:-32768;j[g+2>>1]=(d<<1&2^2)+65535;j[g+4>>1]=32767;j[g+6>>1]=1;j[g+8>>1]=h&1;if((c|0)>0){f=0;do{d=j[a+(f<<1)>>1]|0;e=d<<16>>16;if(((d<<16>>16>-1?e:0-e|0)|0)<3)e=j[g+(e+2<<1)>>1]|0;else e=0;j[b+(f<<1)>>1]=e;f=f+1|0}while((f|0)!=(c|0))}r=i;return}if((c|0)<=0){r=i;return}if((d|0)>1)g=0;else{e=0;do{d=j[a+(e<<1)>>1]|0;h=d<<16>>16;j[b+(e<<1)>>1]=(h+32768|0)>>>0<65536?h:d<<16>>16>0?32767:32768;e=e+1|0}while((e|0)!=(c|0));r=i;return}do{e=j[a+(g<<1)>>1]|0;f=1;h=d;do{f=aa((h&1|0)==0?1:e,f)|0;e=aa(e,e)|0;h=h>>1}while((h|0)>1);h=aa(f,e)|0;j[b+(g<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;g=g+1|0}while((g|0)!=(c|0));r=i;return}function g_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=r;r=r+32|0;g=i;if((d|0)<0){h=(d|0)==-1;k[g>>2]=h<<31>>31;k[g+4>>2]=(d<<1&2^2)+-1;k[g+8>>2]=2147483647;k[g+12>>2]=1;k[g+16>>2]=h&1;if((c|0)>0){f=0;do{e=k[a+(f<<2)>>2]|0;if((((e|0)>-1?e:0-e|0)|0)<3)e=k[g+(e+2<<2)>>2]|0;else e=0;k[b+(f<<2)>>2]=e;f=f+1|0}while((f|0)!=(c|0))}r=i;return}if((c|0)<=0){r=i;return}if((d|0)>1)g=0;else{e=0;do{k[b+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)!=(c|0));r=i;return}do{e=k[a+(g<<2)>>2]|0;f=1;h=d;do{f=aa((h&1|0)==0?1:e,f)|0;e=aa(e,e)|0;h=h>>1}while((h|0)>1);h=aa(f,e)|0;k[b+(g<<2)>>2]=h;g=g+1|0}while((g|0)!=(c|0));r=i;return}function h_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,h=0;h=(d|0)>-1?d:0-d|0;if((c|0)<=0)return;e=(h|0)>1;if((d|0)<0){if(e)d=0;else{d=0;do{o[b+(d<<2)>>2]=1.0/+o[a+(d<<2)>>2];d=d+1|0}while((d|0)!=(c|0));return}do{f=1.0/+o[a+(d<<2)>>2];g=1.0;e=h;do{g=(e&1|0)==0?g:f*g;f=f*f;e=e>>1}while((e|0)>1);o[b+(d<<2)>>2]=f*g;d=d+1|0}while((d|0)!=(c|0));return}else{if(e)d=0;else{d=0;do{k[b+(d<<2)>>2]=k[a+(d<<2)>>2];d=d+1|0}while((d|0)!=(c|0));return}do{f=+o[a+(d<<2)>>2];g=1.0;e=h;do{g=(e&1|0)==0?g:f*g;f=f*f;e=e>>1}while((e|0)>1);o[b+(d<<2)>>2]=f*g;d=d+1|0}while((d|0)!=(c|0));return}}function i_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,h=0;h=(d|0)>-1?d:0-d|0;if((c|0)<=0)return;e=(h|0)>1;if((d|0)<0){if(e)d=0;else{d=0;do{p[b+(d<<3)>>3]=1.0/+p[a+(d<<3)>>3];d=d+1|0}while((d|0)!=(c|0));return}do{f=1.0/+p[a+(d<<3)>>3];g=1.0;e=h;do{g=(e&1|0)==0?g:f*g;f=f*f;e=e>>1}while((e|0)>1);p[b+(d<<3)>>3]=f*g;d=d+1|0}while((d|0)!=(c|0));return}else{if(e)d=0;else{d=0;do{p[b+(d<<3)>>3]=+p[a+(d<<3)>>3];d=d+1|0}while((d|0)!=(c|0));return}do{f=+p[a+(d<<3)>>3];g=1.0;e=h;do{g=(e&1|0)==0?g:f*g;f=f*f;e=e>>1}while((e|0)>1);p[b+(d<<3)>>3]=f*g;d=d+1|0}while((d|0)!=(c|0));return}}function j_(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+224|0;y=z+168|0;w=z+160|0;s=z+104|0;m=z+72|0;n=z+56|0;t=z;p[u>>3]=b;l=k[u>>2]|0;q=k[u+4>>2]|0;do if((k[a>>2]&2031616|0)==65536){e=k[a+4>>2]|0;k[y>>2]=k[e>>2];i=y+4|0;a=e+4|0;k[i>>2]=k[a>>2];x=y+8|0;k[x>>2]=k[e+8>>2];k[y+12>>2]=k[e+12>>2];k[y+16>>2]=k[e+16>>2];k[y+20>>2]=k[e+20>>2];k[y+24>>2]=k[e+24>>2];k[y+28>>2]=k[e+28>>2];k[y+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[y+36>>2]=c;d=y+40|0;k[d>>2]=x;x=y+48|0;g=y+44|0;k[g>>2]=x;k[y+52>>2]=0;k[x>>2]=0;if(c|0){x=c+12|0;k[x>>2]=(k[x>>2]|0)+1}if((k[a>>2]|0)<3){j=k[e+44>>2]|0;x=k[g>>2]|0;k[x>>2]=k[j>>2];k[x+4>>2]=k[j+4>>2];x=i;break}k[i>>2]=0;x1(y,k[a>>2]|0,0,0,0);if((k[i>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[i>>2]|0));x=i}else x=i}else{Q1(y,a,-1);x=y+4|0}while(0);a=k[x>>2]|0;if((a|0)>2){k[w>>2]=y;k[w+4>>2]=0;h=s+40|0;l=s+48|0;i=s+44|0;a=s+52|0;j=s+4|0;c=s+8|0;d=j;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[h>>2]=c;k[i>>2]=l;k[a>>2]=0;k[l>>2]=0;k[s>>2]=1124007936;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;k[m+16>>2]=0;k[m+20>>2]=0;k[m+24>>2]=0;k[m+28>>2]=0;z1(m,w,s,0,-1);c=m+16|0;d=m+4|0;e=n+8|0;f=n+12|0;g=n+4|0;a=0;while(1){if(a>>>0>=(k[c>>2]|0)>>>0){e=1;break}w=k[d>>2]|0;k[e>>2]=0;k[f>>2]=0;k[n>>2]=16842752;k[g>>2]=w;if(!(j_(n,b)|0)){e=0;break}A1(m);a=a+1|0}d=s+36|0;a=k[d>>2]|0;if(a|0?(v=a+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[s+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;w=s+16|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[j>>2]|0)>0){c=k[h>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[i>>2]|0;if(!((a|0)==(l|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else{d=k[y>>2]|0;e=d&7;k[w>>2]=-1;s=w+4|0;k[s>>2]=-1;a:do if(e>>>0<5){if(b>2147483647.0)h=2147483647;else{h=~~b;h=h+-1+(+(h|0)<b&1)|0}g=k[47752+(e<<2)>>2]|0;k[t>>2]=d;n=t+4|0;k[n>>2]=a;s=t+8|0;k[s>>2]=k[y+8>>2];k[t+12>>2]=k[y+12>>2];j=t+16|0;k[j>>2]=k[y+16>>2];k[t+20>>2]=k[y+20>>2];k[t+24>>2]=k[y+24>>2];k[t+28>>2]=k[y+28>>2];i=t+32|0;k[i>>2]=k[y+32>>2];l=t+36|0;c=k[y+36>>2]|0;k[l>>2]=c;m=t+40|0;k[m>>2]=s;s=t+48|0;q=t+44|0;k[q>>2]=s;k[t+52>>2]=0;k[s>>2]=0;if(c){a=c+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[x>>2]|0}if((a|0)>=3){k[n>>2]=0;x1(t,k[y+4>>2]|0,0,0,0);if((k[n>>2]|0)>0){c=k[y+40>>2]|0;d=k[m>>2]|0;e=k[y+44>>2]|0;f=k[q>>2]|0;a=0;do{k[d+(a<<2)>>2]=k[c+(a<<2)>>2];k[f+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else{f=k[y+44>>2]|0;v=k[q>>2]|0;k[v>>2]=k[f>>2];k[v+4>>2]=k[f+4>>2]}Dg[g&127](t,w,0,h)|0;a=k[l>>2]|0;if(a|0?(t=a+12|0,v=k[t>>2]|0,k[t>>2]=v+-1,(v|0)==1):0){c=k[l>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[i>>2]|0;if(!a){a=B1()|0;c=k[l>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[l>>2]=0}k[l>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[n>>2]|0)>0){c=k[m>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[q>>2]|0;if((a|0)==(s|0)|(a|0)==0)v=70;else{ggb(k[a+-4>>2]|0);v=70}}else{m=(d>>>3&511)+1|0;n=k[y+12>>2]|0;c=k[y+8>>2]|0;a=Epb(c|0,((c|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;a=Epb(a|0,N|0,m|0,0)|0;if((d&16384|0)!=0?(a|0)==(a|0)&(((a|0)<0)<<31>>31|0)==(N|0):0)c=1;else a=aa(m,n)|0;f=k[y+16>>2]|0;d=k[y+48>>2]|0;if((e|0)==5){i=d>>>2;h=(o[u>>2]=b>3402823466385288598117041.0e14?3402823466385288598117041.0e14:b,k[u>>2]|0);h=h>>31&2147483647^h;if((a|0)<=0){v=70;break}g=0;e=c;c=-1;while(1){if(!e){v=70;break a}else d=0;e=e+-1|0;do{t=k[f+(d<<2)>>2]|0;t=t>>31&2147483647^t;if(!((t|0)>-1&(t|0)<(h|0))){v=60;break}d=d+1|0}while((d|0)<(a|0));if((v|0)==60){v=0;t=(d+g|0)/(m|0)|0;c=(t|0)%(n|0)|0;k[w>>2]=c;k[s>>2]=(t|0)/(n|0)|0}if((c|0)>=0){v=71;break}else{g=g+a|0;f=f+(i<<2)|0}}}else{j=d>>>3;i=opb(l|0,q|0,63)|0;i=i^l;h=N&2147483647^q;if((a|0)<=0){v=70;break}g=0;d=-1;while(1){if(!c){v=70;break a}else e=0;c=c+-1|0;do{q=f+(e<<3)|0;t=k[q>>2]|0;q=k[q+4>>2]|0;l=opb(t|0,q|0,63)|0;t=l^t;q=N&2147483647^q;if(!(((q|0)>-1|(q|0)==-1&t>>>0>4294967295)&((q|0)<(h|0)|(q|0)==(h|0)&t>>>0<i>>>0))){v=67;break}e=e+1|0}while((e|0)<(a|0));if((v|0)==67){v=0;t=(e+g|0)/(m|0)|0;d=(t|0)%(n|0)|0;k[w>>2]=d;k[s>>2]=(t|0)/(n|0)|0}if((d|0)>=0){v=71;break}else{f=f+(j<<3)|0;g=g+a|0}}}}while(0);if((v|0)==70)if((k[w>>2]|0)>-1)v=71;else a=1;if((v|0)==71)a=0;e=a}d=y+36|0;a=k[d>>2]|0;if(a|0?(v=a+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;w=y+16|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[x>>2]|0)>0){c=k[y+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[x>>2]|0))}a=k[y+44>>2]|0;if((a|0)==(y+48|0)|(a|0)==0){r=z;return e|0}ggb(k[a+-4>>2]|0);r=z;return e|0}function k_(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,p=0,q=0;q=r;r=r+112|0;p=q+48|0;l=q+40|0;m=q+32|0;n=q;if(((S1(a,-1)|0)&7|0)!=5){d=p+4|0;c=ZT(28)|0;k[c>>2]=1;e=c+4|0;k[p>>2]=e;k[d>>2]=20;i[c+24>>0]=0;f=214824;g=e+20|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,p,214845,214521,1755);k[d>>2]=0;k[p>>2]=0;j=k[c>>2]|0;k[c>>2]=j+-1;if((j|0)==1)ggb(k[c+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){e=k[a+4>>2]|0;k[p>>2]=k[e>>2];j=p+4|0;a=e+4|0;k[j>>2]=k[a>>2];h=p+8|0;k[h>>2]=k[e+8>>2];k[p+12>>2]=k[e+12>>2];k[p+16>>2]=k[e+16>>2];k[p+20>>2]=k[e+20>>2];k[p+24>>2]=k[e+24>>2];k[p+28>>2]=k[e+28>>2];k[p+32>>2]=k[e+32>>2];c=k[e+36>>2]|0;k[p+36>>2]=c;d=p+40|0;k[d>>2]=h;h=p+48|0;g=p+44|0;k[g>>2]=h;k[p+52>>2]=0;k[h>>2]=0;if(c|0){h=c+12|0;k[h>>2]=(k[h>>2]|0)+1}if((k[a>>2]|0)<3){h=k[e+44>>2]|0;j=k[g>>2]|0;k[j>>2]=k[h>>2];k[j+4>>2]=k[h+4>>2];break}k[j>>2]=0;x1(p,k[a>>2]|0,0,0,0);if((k[j>>2]|0)>0){h=k[e+40>>2]|0;f=k[d>>2]|0;d=k[e+44>>2]|0;c=k[g>>2]|0;a=0;do{k[f+(a<<2)>>2]=k[h+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[j>>2]|0))}}else Q1(p,a,-1);while(0);k[l>>2]=p;k[l+4>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[n+16>>2]=0;k[n+20>>2]=0;k[n+24>>2]=0;k[n+28>>2]=0;z1(n,l,0,m,-1);f=aa(((k[p>>2]|0)>>>3&511)+1|0,k[n+20>>2]|0)|0;g=n+16|0;a:do if(!f){a=0;while(1){if(a>>>0>=(k[g>>2]|0)>>>0)break a;A1(n);a=a+1|0}}else{a=0;while(1){if(a>>>0>=(k[g>>2]|0)>>>0)break a;d=k[m>>2]|0;c=0;do{e=d+(c<<2)|0;if((k[e>>2]&2147483647)>>>0>2139095040)o[e>>2]=b;c=c+1|0}while((c|0)!=(f|0));A1(n);a=a+1|0}}while(0);d=p+36|0;a=k[d>>2]|0;if(a|0?(m=a+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[p+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;n=p+16|0;c=p+4|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[c>>2]|0)>0){d=k[p+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[p+44>>2]|0;if((a|0)==(p+48|0)|(a|0)==0){r=q;return}ggb(k[a+-4>>2]|0);r=q;return}function l_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+336|0;A=B+272|0;z=B+216|0;y=B+160|0;t=B+104|0;m=B+48|0;n=B+32|0;j=B+16|0;l=B;M1(A,a,0,1,0,0);M1(z,b,0,1,0,0);k[y>>2]=1124007936;w=y+4|0;a=y+8|0;u=y+40|0;e=w;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[u>>2]=a;x=y+48|0;v=y+44|0;k[v>>2]=x;k[y+52>>2]=0;k[x>>2]=0;k[t>>2]=1124007936;q=t+4|0;a=t+8|0;o=t+40|0;e=q;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[o>>2]=a;s=t+48|0;p=t+44|0;k[p>>2]=s;k[t+52>>2]=0;k[s>>2]=0;h=(c|0)!=0;do if(h){M1(m,c,0,1,0,0);KG(y,m)|0;c=m+36|0;a=k[c>>2]|0;if(a|0?(f=a+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[m+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;g=m+16|0;b=m+4|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[b>>2]|0)>0){c=k[m+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[m+44>>2]|0;if(!((a|0)==(m+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=k[u>>2]|0;g=k[A+40>>2]|0;if(((k[f>>2]|0)==(k[g>>2]|0)?(k[f+4>>2]|0)==(k[g+4>>2]|0):0)?((k[A>>2]^k[y>>2])&4095|0)==0:0)break;k[m>>2]=0;a=m+4|0;k[a>>2]=0;b=ZT(56)|0;k[b>>2]=1;e=b+4|0;k[m>>2]=e;k[a>>2]=48;i[b+52>>0]=0;c=214855;f=e+48|0;do{i[e>>0]=i[c>>0]|0;e=e+1|0;c=c+1|0}while((e|0)<(f|0));Y8(-215,m,214904,214521,1822);k[a>>2]=0;k[m>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0)}while(0);g=(d|0)!=0;do if(g){M1(m,d,0,1,0,0);KG(t,m)|0;c=m+36|0;a=k[c>>2]|0;if(a|0?(f=a+12|0,d=k[f>>2]|0,k[f>>2]=d+-1,(d|0)==1):0){a=k[c>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[m+32>>2]|0;if(!b){b=B1()|0;a=k[c>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[c>>2]=0}k[c>>2]=0;d=m+16|0;b=m+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[b>>2]|0)>0){c=k[m+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[m+44>>2]|0;if(!((a|0)==(m+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=k[o>>2]|0;d=k[A+40>>2]|0;if(((k[f>>2]|0)==(k[d>>2]|0)?(k[f+4>>2]|0)==(k[d+4>>2]|0):0)?((k[A>>2]^k[t>>2])&4095|0)==0:0)break;k[m>>2]=0;a=m+4|0;k[a>>2]=0;b=ZT(60)|0;k[b>>2]=1;e=b+4|0;k[m>>2]=e;k[a>>2]=52;i[b+56>>0]=0;c=214918;f=e+52|0;do{i[e>>0]=i[c>>0]|0;e=e+1|0;c=c+1|0}while((e|0)<(f|0));Y8(-215,m,214904,214521,1827);k[a>>2]=0;k[m>>2]=0;d=k[b>>2]|0;k[b>>2]=d+-1;if((d|0)==1)ggb(k[b+-4>>2]|0)}while(0);do if(h)if(g){k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=A;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=z;h=j+4|0;d=h+4|0;k[d>>2]=0;k[d+4>>2]=0;k[j>>2]=33619968;k[h>>2]=y;h=l+4|0;d=h+4|0;k[d>>2]=0;k[d+4>>2]=0;k[l>>2]=33619968;k[h>>2]=t;WZ(m,n,j,l,0);break}else{k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=A;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=z;l=j+4|0;h=l+4|0;k[h>>2]=0;k[h+4>>2]=0;k[j>>2]=33619968;k[l>>2]=y;UZ(m,n,j);break}else{k[m+8>>2]=0;k[m+12>>2]=0;k[m>>2]=16842752;k[m+4>>2]=A;k[n+8>>2]=0;k[n+12>>2]=0;k[n>>2]=16842752;k[n+4>>2]=z;l=j+4|0;h=l+4|0;k[h>>2]=0;k[h+4>>2]=0;k[j>>2]=33619968;k[l>>2]=t;VZ(m,n,j,0)}while(0);c=t+36|0;a=k[c>>2]|0;if(a|0?(m=a+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[t+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;t=t+16|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[q>>2]|0)>0){b=k[o>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[q>>2]|0))}a=k[p>>2]|0;if(!((a|0)==(s|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=y+36|0;a=k[c>>2]|0;if(a|0?(s=a+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;y=y+16|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[w>>2]|0)>0){b=k[u>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[v>>2]|0;if(!((a|0)==(x|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=z+36|0;a=k[c>>2]|0;if(a|0?(x=a+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[z+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;y=z+16|0;b=z+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[b>>2]|0)>0){c=k[z+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[z+44>>2]|0;if(!((a|0)==(z+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=A+36|0;a=k[c>>2]|0;if(a|0?(y=a+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[A+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;z=A+16|0;b=A+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[b>>2]|0)>0){c=k[A+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[A+44>>2]|0;if((a|0)==(A+48|0)|(a|0)==0){r=B;return}ggb(k[a+-4>>2]|0);r=B;return}function m_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+144|0;l=m+88|0;j=m+32|0;g=m+16|0;h=m;M1(l,a,0,1,0,0);M1(j,b,0,1,0,0);a:do if(((k[j>>2]^k[l>>2])&4095|0)==0?(c=k[l+40>>2]|0,d=k[c+-4>>2]|0,e=k[j+40>>2]|0,(d|0)==(k[e+-4>>2]|0)):0){if((d|0)==2){if((k[c>>2]|0)!=(k[e>>2]|0)){f=9;break}if((k[c+4>>2]|0)==(k[e+4>>2]|0))break;else{f=9;break}}if((d|0)>0){a=0;do{if((k[c+(a<<2)>>2]|0)!=(k[e+(a<<2)>>2]|0)){f=9;break a}a=a+1|0}while((a|0)<(d|0))}}else f=9;while(0);if((f|0)==9){k[g>>2]=0;a=g+4|0;k[a>>2]=0;b=ZT(56)|0;k[b>>2]=1;c=b+4|0;k[g>>2]=c;k[a>>2]=48;i[b+52>>0]=0;d=214971;e=c+48|0;do{i[c>>0]=i[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));Y8(-215,g,215020,214521,1874);k[a>>2]=0;k[g>>2]=0;f=k[b>>2]|0;k[b>>2]=f+-1;if((f|0)==1)ggb(k[b+-4>>2]|0)}k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=l;c=h+4|0;a=c+4|0;k[a>>2]=0;k[a+4>>2]=0;k[h>>2]=33619968;k[c>>2]=j;YZ(g,h);c=j+36|0;a=k[c>>2]|0;if(a|0?(g=a+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[j+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;h=j+16|0;b=j+4|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[b>>2]|0)>0){c=k[j+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[j+44>>2]|0;if(!((a|0)==(j+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);c=l+36|0;a=k[c>>2]|0;if(a|0?(h=a+12|0,j=k[h>>2]|0,k[h>>2]=j+-1,(j|0)==1):0){b=k[c>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;b=k[c>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[c>>2]=0}k[c>>2]=0;j=l+16|0;b=l+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[b>>2]|0)>0){c=k[l+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[l+44>>2]|0;if((a|0)==(l+48|0)|(a|0)==0){r=m;return}ggb(k[a+-4>>2]|0);r=m;return}function n_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0.0,g=0.0,h=0.0,j=0,l=0,m=0.0,n=0,q=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+112|0;A=C+56|0;B=C;do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[B>>2]=k[l>>2];s=B+4|0;a=l+4|0;k[s>>2]=k[a>>2];z=B+8|0;k[z>>2]=k[l+8>>2];k[B+12>>2]=k[l+12>>2];k[B+16>>2]=k[l+16>>2];k[B+20>>2]=k[l+20>>2];k[B+24>>2]=k[l+24>>2];k[B+28>>2]=k[l+28>>2];k[B+32>>2]=k[l+32>>2];c=k[l+36>>2]|0;k[B+36>>2]=c;d=B+40|0;k[d>>2]=z;z=B+48|0;n=B+44|0;k[n>>2]=z;k[B+52>>2]=0;k[z>>2]=0;if(c|0){z=c+12|0;k[z>>2]=(k[z>>2]|0)+1}if((k[a>>2]|0)<3){z=k[l+44>>2]|0;w=k[n>>2]|0;k[w>>2]=k[z>>2];k[w+4>>2]=k[z+4>>2];w=B;break}k[s>>2]=0;x1(B,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[l+40>>2]|0;j=k[d>>2]|0;d=k[l+44>>2]|0;c=k[n>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[q+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0));w=B}else w=B}else{Q1(B,a,-1);w=B}while(0);n=k[w>>2]&4095;v=(n|0)==5;if((n+-5|0)>>>0>=2){k[A>>2]=0;a=A+4|0;k[a>>2]=0;c=ZT(40)|0;k[c>>2]=1;d=c+4|0;k[A>>2]=d;k[a>>2]=34;i[c+38>>0]=0;j=215032;l=d+34|0;do{i[d>>0]=i[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(l|0));Y8(-215,A,215067,214521,1924);k[a>>2]=0;k[A>>2]=0;z=k[c>>2]|0;k[c>>2]=z+-1;if((z|0)==1)ggb(k[c+-4>>2]|0)}z=B+40|0;s=k[z>>2]|0;q=k[s+4>>2]|0;s=k[s>>2]|0;if((!((q+-3|0)>>>0<2&(s|0)==1)?!((q|0)==1&(s+-3|0)>>>0<2):0)?(k[A>>2]=0,s=A+4|0,k[s>>2]=0,u=ZT(136)|0,k[u>>2]=1,q=u+4|0,k[A>>2]=q,k[s>>2]=130,i[u+134>>0]=0,upb(q|0,215078,130)|0,Y8(-215,A,215067,214521,1928),k[s>>2]=0,k[A>>2]=0,s=k[u>>2]|0,k[u>>2]=s+-1,(s|0)==1):0)ggb(k[u+-4>>2]|0);k[A>>2]=3;k[A+4>>2]=1;P1(b,2,A,n,-1,1,96);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[A>>2]=k[j>>2];s=A+4|0;a=j+4|0;k[s>>2]=k[a>>2];u=A+8|0;k[u>>2]=k[j+8>>2];k[A+12>>2]=k[j+12>>2];k[A+16>>2]=k[j+16>>2];k[A+20>>2]=k[j+20>>2];k[A+24>>2]=k[j+24>>2];k[A+28>>2]=k[j+28>>2];k[A+32>>2]=k[j+32>>2];c=k[j+36>>2]|0;k[A+36>>2]=c;d=A+40|0;k[d>>2]=u;u=A+48|0;n=A+44|0;k[n>>2]=u;k[A+52>>2]=0;k[u>>2]=0;if(c|0){u=c+12|0;k[u>>2]=(k[u>>2]|0)+1}if((k[a>>2]|0)<3){b=k[j+44>>2]|0;u=k[n>>2]|0;k[u>>2]=k[b>>2];k[u+4>>2]=k[b+4>>2];break}k[s>>2]=0;x1(A,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[j+40>>2]|0;l=k[d>>2]|0;d=k[j+44>>2]|0;c=k[n>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[q+(a<<2)>>2];k[c+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else Q1(A,b,-1);while(0);n=k[B+12>>2]|0;a=(n+(k[B+8>>2]|0)|0)==5;if(v){if(a){l=0;e=+o[k[B+16>>2]>>2]}else{l=-1;e=1.0}c=l+1|0;do if(!(k[w>>2]&16384)){d=k[z>>2]|0;if((k[d>>2]|0)==1){y=k[B+16>>2]|0;a=y;g=+o[y+(l+2<<2)>>2];f=+o[y+(c<<2)>>2];y=41;break}j=k[B+16>>2]|0;a=k[B+44>>2]|0;if((k[d+4>>2]|0)==1)a=j+(aa(k[a>>2]|0,c)|0)|0;else{v=(c|0)/(n|0)|0;w=c-(aa(v,n)|0)|0;a=j+(aa(k[a>>2]|0,v)|0)+(w<<2)|0}f=+o[a>>2];a=l+2|0;c=k[B+44>>2]|0;if((k[d+4>>2]|0)==1)a=j+(aa(k[c>>2]|0,a)|0)|0;else{w=(a|0)/(n|0)|0;a=a-(aa(w,n)|0)|0;a=j+(aa(k[c>>2]|0,w)|0)+(a<<2)|0}g=+o[a>>2];a=l+3|0;c=k[B+44>>2]|0;if((k[d+4>>2]|0)==1){a=j+(aa(k[c>>2]|0,a)|0)|0;break}else{w=(a|0)/(n|0)|0;a=a-(aa(w,n)|0)|0;a=j+(aa(k[c>>2]|0,w)|0)+(a<<2)|0;break}}else{y=k[B+16>>2]|0;a=y;g=+o[y+(l+2<<2)>>2];f=+o[y+(c<<2)>>2];y=41}while(0);if((y|0)==41)a=a+(l+3<<2)|0;t=+o[a>>2]}else{if(a){l=0;e=+p[k[B+16>>2]>>3]}else{l=-1;e=1.0}c=l+1|0;do if(!(k[w>>2]&16384)){d=k[z>>2]|0;if((k[d>>2]|0)==1){y=k[B+16>>2]|0;a=y;g=+p[y+(l+2<<3)>>3];f=+p[y+(c<<3)>>3];y=58;break}j=k[B+16>>2]|0;a=k[B+44>>2]|0;if((k[d+4>>2]|0)==1)a=j+(aa(k[a>>2]|0,c)|0)|0;else{v=(c|0)/(n|0)|0;w=c-(aa(v,n)|0)|0;a=j+(aa(k[a>>2]|0,v)|0)+(w<<3)|0}f=+p[a>>3];a=l+2|0;c=k[B+44>>2]|0;if((k[d+4>>2]|0)==1)a=j+(aa(k[c>>2]|0,a)|0)|0;else{w=(a|0)/(n|0)|0;a=a-(aa(w,n)|0)|0;a=j+(aa(k[c>>2]|0,w)|0)+(a<<3)|0}g=+p[a>>3];a=l+3|0;c=k[B+44>>2]|0;if((k[d+4>>2]|0)==1){a=j+(aa(k[c>>2]|0,a)|0)|0;break}else{w=(a|0)/(n|0)|0;a=a-(aa(w,n)|0)|0;a=j+(aa(k[c>>2]|0,w)|0)+(a<<3)|0;break}}else{y=k[B+16>>2]|0;a=y;g=+p[y+(l+2<<3)>>3];f=+p[y+(c<<3)>>3];y=58}while(0);if((y|0)==58)a=a+(l+3<<3)|0;t=+p[a>>3]}do if(e==0.0){if(!(f==0.0)){e=g*g-f*4.0*t;if(!(e>=0.0)){x=0.0;l=0;e=0.0;f=0.0;break}e=+Q(+e);x=(e-g)*.5;m=(g+e)*-.5;l=+P(+x)>+P(+m);m=l?x:m;x=0.0;l=e>0.0?2:1;e=t/m;f=m/f;break}if(g==0.0){x=0.0;l=(t==0.0)<<31>>31;e=0.0;f=0.0;break}else{x=0.0;l=1;e=0.0;f=-t/g;break}}else{x=1.0/e;m=f*x;e=g*x;h=(m*m-e*3.0)*.1111111111111111;e=(t*x*27.0+(m*(m*(m*2.0))-e*(m*9.0)))*.018518518518518517;f=h*(h*h);g=f-e*e;if(g>0.0){h=+Q(+h)*-2.0;t=+V(+(e/+Q(+f)))*.3333333333333333;f=m*.3333333333333333;x=h*+S(+(t+4.1887902047863905))-f;l=3;e=h*+S(+(t+2.0943951023931953))-f;f=h*+S(+t)-f;break}if(!(g==0.0)){f=+R(+(+Q(+-g)+ +P(+e)),.3333333333333333);f=e>0.0?-f:f;x=0.0;l=1;e=0.0;f=f+h/f-m*.3333333333333333;break}if(!(e>=0.0)){x=+R(+-e,.3333333333333333);f=m/3.0;e=-x-f;f=x*2.0-f}else{x=+R(+e,.3333333333333333);f=m/3.0;e=x-f;f=x*-2.0-f}w=f==e;x=0.0;l=w?1:2;e=w?0.0:e}while(0);w=k[A>>2]|0;c=(w&16384|0)==0;j=A+16|0;if((w&4095|0)==5){a=k[j>>2]|0;o[a>>2]=f;do if(c){d=k[A+40>>2]|0;if((k[d>>2]|0)==1){o[a+4>>2]=e;y=86;break}a=k[j>>2]|0;c=k[A+44>>2]|0;if((k[d+4>>2]|0)==1)a=a+(k[c>>2]|0)|0;else{w=k[A+12>>2]|0;v=(w+1|0)>>>0<3?w:0;w=1-(aa(v,w)|0)|0;a=a+(aa(v,k[c>>2]|0)|0)+(w<<2)|0}o[a>>2]=e;a=k[j>>2]|0;c=k[A+44>>2]|0;if((k[d+4>>2]|0)==1){a=a+(k[c>>2]<<1)|0;break}else{w=k[A+12>>2]|0;v=2/(w|0)|0;w=2-(aa(v,w)|0)|0;a=a+(aa(k[c>>2]|0,v)|0)+(w<<2)|0;break}}else{o[a+4>>2]=e;y=86}while(0);if((y|0)==86)a=a+8|0;o[a>>2]=x}else{a=k[j>>2]|0;p[a>>3]=f;do if(c){d=k[A+40>>2]|0;if((k[d>>2]|0)==1){p[a+8>>3]=e;y=98;break}a=k[j>>2]|0;c=k[A+44>>2]|0;if((k[d+4>>2]|0)==1)a=a+(k[c>>2]|0)|0;else{w=k[A+12>>2]|0;v=(w+1|0)>>>0<3?w:0;w=1-(aa(v,w)|0)|0;a=a+(aa(v,k[c>>2]|0)|0)+(w<<3)|0}p[a>>3]=e;a=k[j>>2]|0;c=k[A+44>>2]|0;if((k[d+4>>2]|0)==1){a=a+(k[c>>2]<<1)|0;break}else{w=k[A+12>>2]|0;v=2/(w|0)|0;w=2-(aa(v,w)|0)|0;a=a+(aa(k[c>>2]|0,v)|0)+(w<<3)|0;break}}else{p[a+8>>3]=e;y=98}while(0);if((y|0)==98)a=a+16|0;p[a>>3]=x}d=A+36|0;a=k[d>>2]|0;if(a|0?(w=a+12|0,y=k[w>>2]|0,k[w>>2]=y+-1,(y|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[A+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;d=A+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[d>>2]|0)>0){c=k[A+40>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[A+44>>2]|0;if(!((a|0)==(A+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=B+36|0;a=k[d>>2]|0;if(a|0?(y=a+12|0,A=k[y>>2]|0,k[y>>2]=A+-1,(A|0)==1):0){c=k[d>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[B+32>>2]|0;if(!a){a=B1()|0;c=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[d>>2]=0}k[d>>2]=0;A=B+16|0;d=B+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[d>>2]|0)>0){c=k[z>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[B+44>>2]|0;if((a|0)==(B+48|0)|(a|0)==0){r=C;return l|0}ggb(k[a+-4>>2]|0);r=C;return l|0}function o_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0,h=0,i=0,j=0.0,l=0.0,m=0.0,n=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;t=c+-4|0;if((c|0)<4)d=0;else{n=0;do{g=+o[a+(n<<2)>>2];q=n|1;j=+o[a+(q<<2)>>2];r=n|2;l=+o[a+(r<<2)>>2];s=n|3;m=+o[a+(s<<2)>>2];d=(o[u>>2]=g,k[u>>2]|0);g=(d&2130706432)>>>0>1149239296?((d|0)<0?-192.0e3:192.0e3):g*92.33248261689366;d=(o[u>>2]=j,k[u>>2]|0);j=(d&2130706432)>>>0>1149239296?((d|0)<0?-192.0e3:192.0e3):j*92.33248261689366;d=(o[u>>2]=l,k[u>>2]|0);l=(d&2130706432)>>>0>1149239296?((d|0)<0?-192.0e3:192.0e3):l*92.33248261689366;d=(o[u>>2]=m,k[u>>2]|0);m=(d&2130706432)>>>0>1149239296?((d|0)<0?-192.0e3:192.0e3):m*92.33248261689366;p[u>>3]=g;d=k[u+4>>2]|0;i=d&2146435072;if(!(i>>>0>1126170624|(i|0)==1126170624&0>0)){d=(d|0)<0;e=d?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=d?-0.0:0.0}else e=g;i=~~e;p[u>>3]=j;d=k[u+4>>2]|0;h=d&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){d=(d|0)<0;e=d?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=d?-0.0:0.0}else e=j;h=~~e;p[u>>3]=l;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;e=d?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=d?-0.0:0.0}else e=l;f=~~e;p[u>>3]=m;d=k[u+4>>2]|0;v=d&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){d=(d|0)<0;e=d?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=d?-0.0:0.0}else e=m;w=~~e;g=(g-+(i|0))*.015625;j=(j-+(h|0))*.015625;l=(l-+(f|0))*.015625;m=(m-+(w|0))*.015625;C=i>>6;B=C+127|0;A=h>>6;z=A+127|0;y=f>>6;x=y+127|0;d=w>>6;v=d+127|0;g=+p[11888+((i&63)<<3)>>3]*(k[u>>2]=(B>>>0>255?((C|0)<-127?0:255):B)<<23,+o[u>>2])*(g*(g*(g*(g+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);j=+p[11888+((h&63)<<3)>>3]*(k[u>>2]=(z>>>0>255?((A|0)<-127?0:255):z)<<23,+o[u>>2])*(j*(j*(j*(j+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);o[b+(n<<2)>>2]=g;o[b+(q<<2)>>2]=j;l=+p[11888+((f&63)<<3)>>3]*(k[u>>2]=(x>>>0>255?((y|0)<-127?0:255):x)<<23,+o[u>>2])*(l*(l*(l*(l+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);m=+p[11888+((w&63)<<3)>>3]*(k[u>>2]=(v>>>0>255?((d|0)<-127?0:255):v)<<23,+o[u>>2])*(m*(m*(m*(m+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);o[b+(r<<2)>>2]=l;o[b+(s<<2)>>2]=m;n=n+4|0}while((n|0)<=(t|0));d=c&-4}if((d|0)>=(c|0))return;do{g=+o[a+(d<<2)>>2];f=(o[u>>2]=g,k[u>>2]|0);g=(f&2130706432)>>>0>1149239296?((f|0)<0?-192.0e3:192.0e3):g*92.33248261689366;p[u>>3]=g;f=k[u+4>>2]|0;C=f&2146435072;if(!(C>>>0>1126170624|(C|0)==1126170624&0>0)){f=(f|0)<0;e=f?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=f?-0.0:0.0}else e=g;A=~~e;B=A>>6;C=B+127|0;m=(g-+(A|0))*.015625;o[b+(d<<2)>>2]=+p[11888+((A&63)<<3)>>3]*(k[u>>2]=(C>>>0>255?((B|0)<-127?0:255):C)<<23,+o[u>>2])*(m*(m*(m*(m+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);d=d+1|0}while((d|0)!=(c|0));return}function p_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0,h=0,i=0,j=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;s=c+-4|0;if((c|0)<4)d=0;else{n=0;do{g=+p[a+(n<<3)>>3];o=n|1;j=+p[a+(o<<3)>>3];q=n|2;l=+p[a+(q<<3)>>3];r=n|3;m=+p[a+(r<<3)>>3];p[u>>3]=g;d=opb(k[u>>2]|0,k[u+4>>2]|0,52)|0;g=(d&2046)>>>0>1033?((d|0)<0?-192.0e3:192.0e3):g*92.33248261689366;p[u>>3]=j;d=opb(k[u>>2]|0,k[u+4>>2]|0,52)|0;j=(d&2046)>>>0>1033?((d|0)<0?-192.0e3:192.0e3):j*92.33248261689366;p[u>>3]=l;d=opb(k[u>>2]|0,k[u+4>>2]|0,52)|0;l=(d&2046)>>>0>1033?((d|0)<0?-192.0e3:192.0e3):l*92.33248261689366;p[u>>3]=m;d=opb(k[u>>2]|0,k[u+4>>2]|0,52)|0;m=(d&2046)>>>0>1033?((d|0)<0?-192.0e3:192.0e3):m*92.33248261689366;p[u>>3]=g;d=k[u+4>>2]|0;i=d&2146435072;if(!(i>>>0>1126170624|(i|0)==1126170624&0>0)){d=(d|0)<0;e=d?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=d?-0.0:0.0}else e=g;i=~~e;p[u>>3]=j;d=k[u+4>>2]|0;h=d&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){d=(d|0)<0;e=d?j+-4503599627370496.0+4503599627370496.0:j+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=d?-0.0:0.0}else e=j;h=~~e;p[u>>3]=l;d=k[u+4>>2]|0;f=d&2146435072;if(!(f>>>0>1126170624|(f|0)==1126170624&0>0)){d=(d|0)<0;e=d?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=d?-0.0:0.0}else e=l;f=~~e;p[u>>3]=m;d=k[u+4>>2]|0;t=d&2146435072;if(!(t>>>0>1126170624|(t|0)==1126170624&0>0)){d=(d|0)<0;e=d?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=d?-0.0:0.0}else e=m;t=~~e;g=(g-+(i|0))*.015625;j=(j-+(h|0))*.015625;l=(l-+(f|0))*.015625;m=(m-+(t|0))*.015625;A=i>>6;B=A+1023|0;B=Apb((B>>>0>2047?((A|0)<-1023?0:2047):B)|0,0,52)|0;A=N;y=h>>6;z=y+1023|0;z=Apb((z>>>0>2047?((y|0)<-1023?0:2047):z)|0,0,52)|0;y=N;w=f>>6;x=w+1023|0;x=Apb((x>>>0>2047?((w|0)<-1023?0:2047):x)|0,0,52)|0;w=N;d=t>>6;v=d+1023|0;v=Apb((v>>>0>2047?((d|0)<-1023?0:2047):v)|0,0,52)|0;d=N;k[u>>2]=B;k[u+4>>2]=A;g=+p[11888+((i&63)<<3)>>3]*+p[u>>3]*(g*(g*(g*(g*(g*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);k[u>>2]=z;k[u+4>>2]=y;j=+p[11888+((h&63)<<3)>>3]*+p[u>>3]*(j*(j*(j*(j*(j*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);p[b+(n<<3)>>3]=g;p[b+(o<<3)>>3]=j;k[u>>2]=x;k[u+4>>2]=w;l=+p[11888+((f&63)<<3)>>3]*+p[u>>3]*(l*(l*(l*(l*(l*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);k[u>>2]=v;k[u+4>>2]=d;m=+p[11888+((t&63)<<3)>>3]*+p[u>>3]*(m*(m*(m*(m*(m*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);p[b+(q<<3)>>3]=l;p[b+(r<<3)>>3]=m;n=n+4|0}while((n|0)<=(s|0));d=c&-4}if((d|0)>=(c|0))return;do{g=+p[a+(d<<3)>>3];p[u>>3]=g;f=opb(k[u>>2]|0,k[u+4>>2]|0,52)|0;g=(f&2046)>>>0>1033?((f|0)<0?-192.0e3:192.0e3):g*92.33248261689366;p[u>>3]=g;f=k[u+4>>2]|0;B=f&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){f=(f|0)<0;e=f?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=f?-0.0:0.0}else e=g;B=~~e;A=B>>6;z=A+1023|0;z=Apb((z>>>0>2047?((A|0)<-1023?0:2047):z)|0,0,52)|0;A=N;m=(g-+(B|0))*.015625;k[u>>2]=z;k[u+4>>2]=A;p[b+(d<<3)>>3]=+p[11888+((B&63)<<3)>>3]*+p[u>>3]*(m*(m*(m*(m*(m*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);d=d+1|0}while((d|0)!=(c|0));return}function q_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0.0,h=0.0,i=0,j=0.0,l=0.0,m=0,n=0,q=0,r=0.0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0;e=c+-4|0;if((c|0)<4)d=0;else{d=0;do{t=k[a+(d<<2)>>2]|0;q=d|1;w=k[a+(q<<2)>>2]|0;v=t>>>14&510;x=w>>>14&510;i=d|2;z=k[a+(i<<2)>>2]|0;f=d|3;y=k[a+(f<<2)>>2]|0;s=((k[u>>2]=t&32767|1065353216,+o[u>>2])+-1.0)*+p[16+((v|1)<<3)>>3];r=((k[u>>2]=w&32767|1065353216,+o[u>>2])+-1.0)*+p[16+((x|1)<<3)>>3];n=z>>>14&510;m=y>>>14&510;l=+p[16+(n<<3)>>3]+ +((z>>>23&255)+-127|0)*.6931471805599453;h=+p[16+(m<<3)>>3]+ +((y>>>23&255)+-127|0)*.6931471805599453;j=((k[u>>2]=z&32767|1065353216,+o[u>>2])+-1.0)*+p[16+((n|1)<<3)>>3];g=((k[u>>2]=y&32767|1065353216,+o[u>>2])+-1.0)*+p[16+((m|1)<<3)>>3];s=s+ +o[47804+(((v|0)==510&1)<<2)>>2];r=r+ +o[47804+(((x|0)==510&1)<<2)>>2];r=+p[16+(x<<3)>>3]+ +((w>>>23&255)+-127|0)*.6931471805599453+r*(r*(r*.3333333432674408+-.5)+1.0);o[b+(d<<2)>>2]=+p[16+(v<<3)>>3]+ +((t>>>23&255)+-127|0)*.6931471805599453+s*(s*(s*.3333333432674408+-.5)+1.0);o[b+(q<<2)>>2]=r;j=j+ +o[47804+(((n|0)==510&1)<<2)>>2];g=g+ +o[47804+(((m|0)==510&1)<<2)>>2];o[b+(i<<2)>>2]=l+j*(j*(j*.3333333432674408+-.5)+1.0);o[b+(f<<2)>>2]=h+g*(g*(g*.3333333432674408+-.5)+1.0);d=d+4|0}while((d|0)<=(e|0));d=c&-4}if((d|0)>=(c|0))return;do{z=k[a+(d<<2)>>2]|0;y=z>>>14&510;s=+o[47804+(((y|0)==510&1)<<2)>>2]+ +p[16+((y|1)<<3)>>3]*((k[u>>2]=z&32767|1065353216,+o[u>>2])+-1.0);o[b+(d<<2)>>2]=+p[16+(y<<3)>>3]+ +((z>>>23&255)+-127|0)*.6931471805599453+s*(s*(s*.3333333432674408+-.5)+1.0);d=d+1|0}while((d|0)!=(c|0));return}function r_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0.0,h=0.0,i=0.0,j=0,l=0.0,m=0.0,n=0.0,o=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0;e=c+-4|0;if((c|0)<4)d=0;else{d=0;do{o=a+(d<<3)|0;r=d|1;A=a+(r<<3)|0;j=k[A>>2]|0;B=k[o+4>>2]|0;A=k[A+4>>2]|0;k[u>>2]=k[o>>2];k[u+4>>2]=B&4095|1072693248;v=+p[u>>3];k[u>>2]=j;k[u+4>>2]=A&4095|1072693248;j=d|2;o=a+(j<<3)|0;f=d|3;z=a+(f<<3)|0;q=k[z>>2]|0;y=B>>>11&510;x=A>>>11&510;w=+p[16+(y<<3)>>3]+ +((B>>>20&2047)+-1023|0)*.6931471805599453;s=+p[16+(x<<3)>>3]+ +((A>>>20&2047)+-1023|0)*.6931471805599453;A=k[o+4>>2]|0;z=k[z+4>>2]|0;v=(v+-1.0)*+p[16+((y|1)<<3)>>3];g=(+p[u>>3]+-1.0)*+p[16+((x|1)<<3)>>3];k[u>>2]=k[o>>2];k[u+4>>2]=A&4095|1072693248;m=+p[u>>3];k[u>>2]=q;k[u+4>>2]=z&4095|1072693248;q=A>>>11&510;o=z>>>11&510;n=+p[16+(q<<3)>>3]+ +((A>>>20&2047)+-1023|0)*.6931471805599453;i=+p[16+(o<<3)>>3]+ +((z>>>20&2047)+-1023|0)*.6931471805599453;m=+p[16+((q|1)<<3)>>3]*(m+-1.0);h=+p[16+((o|1)<<3)>>3]*(+p[u>>3]+-1.0);v=v+ +p[12400+(((y|0)==510&1)<<3)>>3];t=v*v;g=g+ +p[12400+(((x|0)==510&1)<<3)>>3];l=g*g;p[b+(d<<3)>>3]=w+(t*(t*(t*(-.16666666666666666-t*.125)+-.25)+-.5)+v*(t*(t*(t*.14285714285714288+.2)+.3333333333333333)+1.0));p[b+(r<<3)>>3]=s+(l*(l*(l*(-.16666666666666666-l*.125)+-.25)+-.5)+g*(l*(l*(l*.14285714285714288+.2)+.3333333333333333)+1.0));m=m+ +p[12400+(((q|0)==510&1)<<3)>>3];l=m*m;h=h+ +p[12400+(((o|0)==510&1)<<3)>>3];g=h*h;p[b+(j<<3)>>3]=n+(l*(l*(l*(-.16666666666666666-l*.125)+-.25)+-.5)+m*(l*(l*(l*.14285714285714288+.2)+.3333333333333333)+1.0));p[b+(f<<3)>>3]=i+(g*(g*(g*(-.16666666666666666-g*.125)+-.25)+-.5)+h*(g*(g*(g*.14285714285714288+.2)+.3333333333333333)+1.0));d=d+4|0}while((d|0)<=(e|0));d=c&-4}if((d|0)>=(c|0))return;do{A=a+(d<<3)|0;B=k[A+4>>2]|0;k[u>>2]=k[A>>2];k[u+4>>2]=B&4095|1072693248;A=B>>>11&510;v=+p[12400+(((A|0)==510&1)<<3)>>3]+ +p[16+((A|1)<<3)>>3]*(+p[u>>3]+-1.0);w=v*v;p[b+(d<<3)>>3]=+p[16+(A<<3)>>3]+ +((B>>>20&2047)+-1023|0)*.6931471805599453+(w*(w*(w*(-.16666666666666666-w*.125)+-.25)+-.5)+v*(w*(w*(w*.14285714285714288+.2)+.3333333333333333)+1.0));d=d+1|0}while((d|0)!=(c|0));return}function s_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0,hb=0,ib=0;_a=r;r=r+1440|0;Za=_a+1376|0;Ya=_a+1320|0;Xa=_a+1264|0;Wa=_a+1208|0;Qa=_a+1120|0;Pa=_a+72|0;Oa=_a;x=_a+1200|0;y=_a+1192|0;Ja=_a+1184|0;Ka=_a+1176|0;La=_a+1112|0;Ma=_a+64|0;Na=_a+56|0;do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[Za>>2]=k[l>>2];s=Za+4|0;a=l+4|0;k[s>>2]=k[a>>2];Va=Za+8|0;k[Va>>2]=k[l+8>>2];k[Za+12>>2]=k[l+12>>2];k[Za+16>>2]=k[l+16>>2];k[Za+20>>2]=k[l+20>>2];k[Za+24>>2]=k[l+24>>2];k[Za+28>>2]=k[l+28>>2];k[Za+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[Za+36>>2]=h;j=Za+40|0;k[j>>2]=Va;Va=Za+48|0;n=Za+44|0;k[n>>2]=Va;k[Za+52>>2]=0;k[Va>>2]=0;if(h|0){Va=h+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[a>>2]|0)<3){Ta=k[l+44>>2]|0;Va=k[n>>2]|0;k[Va>>2]=k[Ta>>2];k[Va+4>>2]=k[Ta+4>>2];break}k[s>>2]=0;x1(Za,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[q+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else Q1(Za,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){m=k[b+4>>2]|0;k[Ya>>2]=k[m>>2];s=Ya+4|0;h=m+4|0;k[s>>2]=k[h>>2];Va=Ya+8|0;k[Va>>2]=k[m+8>>2];k[Ya+12>>2]=k[m+12>>2];k[Ya+16>>2]=k[m+16>>2];k[Ya+20>>2]=k[m+20>>2];k[Ya+24>>2]=k[m+24>>2];k[Ya+28>>2]=k[m+28>>2];k[Ya+32>>2]=k[m+32>>2];a=k[m+36>>2]|0;k[Ya+36>>2]=a;j=Ya+40|0;k[j>>2]=Va;Va=Ya+48|0;n=Ya+44|0;k[n>>2]=Va;k[Ya+52>>2]=0;k[Va>>2]=0;if(a|0){Va=a+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[h>>2]|0)<3){Ta=k[m+44>>2]|0;Va=k[n>>2]|0;k[Va>>2]=k[Ta>>2];k[Va+4>>2]=k[Ta+4>>2];break}k[s>>2]=0;x1(Ya,k[h>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[m+40>>2]|0;l=k[j>>2]|0;j=k[m+44>>2]|0;h=k[n>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[q+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else Q1(Ya,b,-1);while(0);do if(e!=0.0){if((k[d>>2]&2031616|0)!=65536){Q1(Xa,d,-1);break}l=k[d+4>>2]|0;k[Xa>>2]=k[l>>2];s=Xa+4|0;a=l+4|0;k[s>>2]=k[a>>2];Va=Xa+8|0;k[Va>>2]=k[l+8>>2];k[Xa+12>>2]=k[l+12>>2];k[Xa+16>>2]=k[l+16>>2];k[Xa+20>>2]=k[l+20>>2];k[Xa+24>>2]=k[l+24>>2];k[Xa+28>>2]=k[l+28>>2];k[Xa+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[Xa+36>>2]=h;j=Xa+40|0;k[j>>2]=Va;Va=Xa+48|0;n=Xa+44|0;k[n>>2]=Va;k[Xa+52>>2]=0;k[Va>>2]=0;if(h|0){Va=h+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[a>>2]|0)<3){Ta=k[l+44>>2]|0;Va=k[n>>2]|0;k[Va>>2]=k[Ta>>2];k[Va+4>>2]=k[Ta+4>>2];break}k[s>>2]=0;x1(Xa,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[q+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else{k[Xa>>2]=1124007936;a=Xa+8|0;h=Xa+40|0;n=Xa+4|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[h>>2]=a;Va=Xa+48|0;k[Xa+44>>2]=Va;k[Xa+52>>2]=0;k[Va>>2]=0}while(0);Va=Za+40|0;v=k[Va>>2]|0;u=k[v+4>>2]|0;v=k[v>>2]|0;t=k[Za>>2]|0;w=t&4095;if(!((w|0)==(k[Ya>>2]&4095|0)?((t&4087)+-5|0)>>>0<2:0)){k[Wa>>2]=0;a=Wa+4|0;k[a>>2]=0;h=ZT(104)|0;k[h>>2]=1;n=h+4|0;k[Wa>>2]=n;k[a>>2]=98;i[h+102>>0]=0;m=215313;q=n+98|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,Wa,215412,215417,893);k[a>>2]=0;k[Wa>>2]=0;Ta=k[h>>2]|0;k[h>>2]=Ta+-1;if((Ta|0)==1)ggb(k[h+-4>>2]|0)}switch(g&3){case 0:{l=k[Ya+12>>2]|0;a=k[Ya+8>>2]|0;if((u|0)==(a|0)){Ia=u;Sa=l;Ra=v}else{k[Wa>>2]=0;h=Wa+4|0;k[h>>2]=0;j=ZT(24)|0;k[j>>2]=1;n=j+4|0;k[Wa>>2]=n;k[h>>2]=19;i[j+23>>0]=0;m=215482;q=n+19|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,Wa,215412,215417,900);k[h>>2]=0;k[Wa>>2]=0;Ta=k[j>>2]|0;k[j>>2]=Ta+-1;if((Ta|0)==1)ggb(k[j+-4>>2]|0);Ia=a;Sa=l;Ra=v}break}case 1:{l=k[Ya+12>>2]|0;a=k[Ya+8>>2]|0;if((v|0)==(a|0)){Ia=v;Sa=l;Ra=u}else{k[Wa>>2]=0;h=Wa+4|0;k[h>>2]=0;j=ZT(28)|0;k[j>>2]=1;n=j+4|0;k[Wa>>2]=n;k[h>>2]=20;i[j+24>>0]=0;m=215502;q=n+20|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,Wa,215412,215417,905);k[h>>2]=0;k[Wa>>2]=0;Ta=k[j>>2]|0;k[j>>2]=Ta+-1;if((Ta|0)==1)ggb(k[j+-4>>2]|0);Ia=a;Sa=l;Ra=u}break}case 2:{l=k[Ya+8>>2]|0;a=k[Ya+12>>2]|0;if((u|0)==(a|0)){Ia=u;Sa=l;Ra=v}else{k[Wa>>2]=0;h=Wa+4|0;k[h>>2]=0;j=ZT(24)|0;k[j>>2]=1;n=j+4|0;k[Wa>>2]=n;k[h>>2]=19;i[j+23>>0]=0;m=215482;q=n+19|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,Wa,215412,215417,910);k[h>>2]=0;k[Wa>>2]=0;Ta=k[j>>2]|0;k[j>>2]=Ta+-1;if((Ta|0)==1)ggb(k[j+-4>>2]|0);Ia=a;Sa=l;Ra=v}break}case 3:{l=k[Ya+8>>2]|0;a=k[Ya+12>>2]|0;if((v|0)==(a|0)){Ia=v;Sa=l;Ra=u}else{k[Wa>>2]=0;h=Wa+4|0;k[h>>2]=0;j=ZT(28)|0;k[j>>2]=1;n=j+4|0;k[Wa>>2]=n;k[h>>2]=20;i[j+24>>0]=0;m=215502;q=n+20|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,Wa,215412,215417,915);k[h>>2]=0;k[Wa>>2]=0;Ta=k[j>>2]|0;k[j>>2]=Ta+-1;if((Ta|0)==1)ggb(k[j+-4>>2]|0);Ia=a;Sa=l;Ra=u}break}default:{}}Ta=Xa+16|0;a:do if(k[Ta>>2]|0){j=k[Xa+4>>2]|0;if((j|0)<3)a=aa(k[Xa+12>>2]|0,k[Xa+8>>2]|0)|0;else{l=k[Xa+40>>2]|0;h=0;a=1;do{a=aa(k[l+(h<<2)>>2]|0,a)|0;h=h+1|0}while((h|0)!=(j|0))}if(a|0){do if((k[Xa>>2]&4095|0)==(w|0)){a=k[Xa+8>>2]|0;if(!(g&4)){if((a|0)!=(Ra|0))break;if((k[Xa+12>>2]|0)==(Sa|0))break a;else break}else{if((a|0)!=(Sa|0))break;if((k[Xa+12>>2]|0)==(Ra|0))break a;else break}}while(0);k[Wa>>2]=0;Ha=Wa+4|0;k[Ha>>2]=0;a=ZT(184)|0;k[a>>2]=1;Ga=a+4|0;k[Wa>>2]=Ga;k[Ha>>2]=178;i[a+182>>0]=0;upb(Ga|0,215523,178)|0;Y8(-215,Wa,215412,215417,923);k[Ha>>2]=0;k[Wa>>2]=0;Ha=k[a>>2]|0;k[a>>2]=Ha+-1;if((Ha|0)==1)ggb(k[a+-4>>2]|0)}}while(0);c2(f,Ra,Sa,w,-1,0,0);do if((k[f>>2]&2031616|0)==65536){l=k[f+4>>2]|0;k[Wa>>2]=k[l>>2];s=Wa+4|0;a=l+4|0;k[s>>2]=k[a>>2];Ha=Wa+8|0;k[Ha>>2]=k[l+8>>2];k[Wa+12>>2]=k[l+12>>2];k[Wa+16>>2]=k[l+16>>2];k[Wa+20>>2]=k[l+20>>2];k[Wa+24>>2]=k[l+24>>2];k[Wa+28>>2]=k[l+28>>2];k[Wa+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[Wa+36>>2]=h;j=Wa+40|0;k[j>>2]=Ha;Ha=Wa+48|0;n=Wa+44|0;k[n>>2]=Ha;k[Wa+52>>2]=0;k[Ha>>2]=0;if(h|0){Ha=h+12|0;k[Ha>>2]=(k[Ha>>2]|0)+1}if((k[a>>2]|0)<3){Ga=k[l+44>>2]|0;Ha=k[n>>2]|0;k[Ha>>2]=k[Ga>>2];k[Ha+4>>2]=k[Ga+4>>2];break}k[s>>2]=0;x1(Wa,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[q+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else Q1(Wa,f,-1);while(0);if((g&4|0)!=0?(k[Ta>>2]|0)==(k[Wa+16>>2]|0):0){k[Qa+8>>2]=0;k[Qa+12>>2]=0;k[Qa>>2]=16842752;k[Qa+4>>2]=Xa;Ha=Pa+4|0;Ga=Ha+4|0;k[Ga>>2]=0;k[Ga+4>>2]=0;k[Pa>>2]=33619968;k[Ha>>2]=Xa;$1(Qa,Pa);g=g&-5}b:do if((Ia+-2|0)>>>0<3&(g|0)==0?(Ia|0)==(Ra|0)|(Ia|0)==(Sa|0):0){switch(t&4095){case 5:{j=k[Wa+16>>2]|0;h=k[Za+16>>2]|0;m=k[Ya+16>>2]|0;d=k[Ta>>2]|0;l=k[Wa+48>>2]|0;L=l>>>2;n=k[Za+48>>2]|0;J=n>>>2;q=k[Ya+48>>2]|0;K=q>>>2;a=(d|0)==0;s=k[Xa+48>>2]|0;B=a?0:s>>>2;a=a?428740:d;switch(Ia|0){case 2:{if(!((Sa|0)!=2|(m|0)==(j|0))){if((Ra|0)<=0)break b;q=m+(K<<2)|0;s=m+4|0;n=m+(K+1<<2)|0;l=0;while(1){bb=+o[h>>2];ab=+o[h+4>>2];$a=bb*+o[s>>2]+ab*+o[n>>2];o[j>>2]=(bb*+o[m>>2]+ab*+o[q>>2])*c+ +o[a>>2]*e;o[j+4>>2]=$a*c+ +o[a+4>>2]*e;l=l+1|0;if((l|0)==(Ra|0))break b;else{j=j+(L<<2)|0;h=h+(J<<2)|0;a=a+(B<<2)|0}}}if((h|0)!=(j|0)){q=(a|0)==428740;d=q&1^1;q=q?1:B;if((Sa|0)<=0)break b;s=h+4|0;b=h+(J<<2)|0;n=h+(J+1<<2)|0;l=m;m=0;while(1){$a=+o[l>>2];ab=+o[l+(K<<2)>>2];bb=$a*+o[b>>2]+ab*+o[n>>2];o[j>>2]=(+o[h>>2]*$a+ +o[s>>2]*ab)*c+ +o[a>>2]*e;o[j+(L<<2)>>2]=bb*c+ +o[a+(q<<2)>>2]*e;m=m+1|0;if((m|0)==(Sa|0))break b;else{l=l+4|0;j=j+4|0;a=a+(d<<2)|0}}}break}case 3:{if(!((Sa|0)!=3|(m|0)==(j|0))){if((Ra|0)<=0)break b;s=m+(K<<2)|0;q=K<<1;b=m+(q<<2)|0;d=m+4|0;g=m+(K+1<<2)|0;f=m+((q|1)<<2)|0;t=m+8|0;n=m+(K+2<<2)|0;q=m+(q+2<<2)|0;l=0;while(1){db=+o[h>>2];cb=+o[h+4>>2];$a=+o[h+8>>2];ab=db*+o[d>>2]+cb*+o[g>>2]+$a*+o[f>>2];bb=db*+o[t>>2]+cb*+o[n>>2]+$a*+o[q>>2];o[j>>2]=(db*+o[m>>2]+cb*+o[s>>2]+$a*+o[b>>2])*c+ +o[a>>2]*e;o[j+4>>2]=ab*c+ +o[a+4>>2]*e;o[j+8>>2]=bb*c+ +o[a+8>>2]*e;l=l+1|0;if((l|0)==(Ra|0))break b;else{h=h+(J<<2)|0;j=j+(L<<2)|0;a=a+(B<<2)|0}}}if((h|0)!=(j|0)){g=(a|0)==428740;y=g&1^1;g=g?1:B;if((Sa|0)<=0)break b;f=h+4|0;t=h+8|0;u=K<<1;v=h+(J<<2)|0;w=h+(J+1<<2)|0;x=h+(J+2<<2)|0;s=J<<1;n=h+(s<<2)|0;q=h+((s|1)<<2)|0;s=h+(s+2<<2)|0;b=g<<1;d=L<<1;l=0;while(1){$a=+o[m>>2];ab=+o[m+(K<<2)>>2];bb=+o[m+(u<<2)>>2];cb=$a*+o[v>>2]+ab*+o[w>>2]+bb*+o[x>>2];db=$a*+o[n>>2]+ab*+o[q>>2]+bb*+o[s>>2];o[j>>2]=(+o[h>>2]*$a+ +o[f>>2]*ab+ +o[t>>2]*bb)*c+ +o[a>>2]*e;o[j+(L<<2)>>2]=cb*c+ +o[a+(g<<2)>>2]*e;o[j+(d<<2)>>2]=db*c+ +o[a+(b<<2)>>2]*e;l=l+1|0;if((l|0)==(Sa|0))break b;else{m=m+4|0;j=j+4|0;a=a+(y<<2)|0}}}break}case 4:{if(!((Sa|0)!=4|(m|0)==(j|0))){if((Ra|0)<=0)break b;b=m+(K<<2)|0;q=K<<1;d=m+(q<<2)|0;s=K*3|0;g=m+(s<<2)|0;f=m+4|0;t=m+(K+1<<2)|0;u=m+((q|1)<<2)|0;v=m+(s+1<<2)|0;w=m+8|0;x=m+(K+2<<2)|0;y=m+(q+2<<2)|0;z=m+(s+2<<2)|0;A=m+12|0;n=m+(K+3<<2)|0;q=m+(q+3<<2)|0;s=m+(s+3<<2)|0;l=0;while(1){fb=+o[h>>2];eb=+o[h+4>>2];$a=+o[h+8>>2];ab=+o[h+12>>2];bb=fb*+o[f>>2]+eb*+o[t>>2]+$a*+o[u>>2]+ab*+o[v>>2];cb=fb*+o[w>>2]+eb*+o[x>>2]+$a*+o[y>>2]+ab*+o[z>>2];db=fb*+o[A>>2]+eb*+o[n>>2]+$a*+o[q>>2]+ab*+o[s>>2];o[j>>2]=(fb*+o[m>>2]+eb*+o[b>>2]+$a*+o[d>>2]+ab*+o[g>>2])*c+ +o[a>>2]*e;o[j+4>>2]=bb*c+ +o[a+4>>2]*e;o[j+8>>2]=cb*c+ +o[a+8>>2]*e;o[j+12>>2]=db*c+ +o[a+12>>2]*e;l=l+1|0;if((l|0)==(Ra|0))break b;else{h=h+(J<<2)|0;j=j+(L<<2)|0;a=a+(B<<2)|0}}}if((h|0)!=(j|0)){u=(a|0)==428740;I=u&1^1;u=u?1:B;if((Sa|0)<=0)break b;v=h+4|0;w=h+8|0;x=K<<1;y=h+12|0;z=K*3|0;A=h+(J<<2)|0;B=h+(J+1<<2)|0;C=h+(J+2<<2)|0;D=h+(J+3<<2)|0;H=J<<1;E=h+(H<<2)|0;F=h+((H|1)<<2)|0;G=h+(H+2<<2)|0;H=h+(H+3<<2)|0;b=J*3|0;n=h+(b<<2)|0;q=h+(b+1<<2)|0;s=h+(b+2<<2)|0;b=h+(b+3<<2)|0;d=u<<1;g=L<<1;f=u*3|0;t=L*3|0;l=0;while(1){$a=+o[m>>2];ab=+o[m+(K<<2)>>2];bb=+o[m+(x<<2)>>2];cb=+o[m+(z<<2)>>2];db=$a*+o[A>>2]+ab*+o[B>>2]+bb*+o[C>>2]+cb*+o[D>>2];eb=$a*+o[E>>2]+ab*+o[F>>2]+bb*+o[G>>2]+cb*+o[H>>2];fb=$a*+o[n>>2]+ab*+o[q>>2]+bb*+o[s>>2]+cb*+o[b>>2];o[j>>2]=(+o[h>>2]*$a+ +o[v>>2]*ab+ +o[w>>2]*bb+ +o[y>>2]*cb)*c+ +o[a>>2]*e;o[j+(L<<2)>>2]=db*c+ +o[a+(u<<2)>>2]*e;o[j+(g<<2)>>2]=eb*c+ +o[a+(d<<2)>>2]*e;o[j+(t<<2)>>2]=fb*c+ +o[a+(f<<2)>>2]*e;l=l+1|0;if((l|0)==(Sa|0))break b;else{m=m+4|0;j=j+4|0;a=a+(I<<2)|0}}}break}default:{}}if((w|0)==6){b=d;a=s;s=d}else{Ua=135;break b}break}case 6:{s=k[Ta>>2]|0;l=k[Wa+48>>2]|0;n=k[Za+48>>2]|0;q=k[Ya+48>>2]|0;b=s;a=k[Xa+48>>2]|0;m=k[Ya+16>>2]|0;j=k[Wa+16>>2]|0;h=k[Za+16>>2]|0;break}default:{Ua=135;break b}}L=l>>>3;J=n>>>3;K=q>>>3;B=(b|0)==0?0:a>>>3;a=(s|0)==0?427736:s;switch(Ia|0){case 2:{if(!((Sa|0)!=2|(m|0)==(j|0))){if((Ra|0)<=0)break b;q=m+(K<<3)|0;s=m+8|0;n=m+(K+1<<3)|0;l=j;j=h;h=0;while(1){db=+p[j>>3];eb=+p[j+8>>3];fb=db*+p[s>>3]+eb*+p[n>>3];p[l>>3]=(db*+p[m>>3]+eb*+p[q>>3])*c+ +p[a>>3]*e;p[l+8>>3]=fb*c+ +p[a+8>>3]*e;h=h+1|0;if((h|0)==(Ra|0))break b;else{l=l+(L<<3)|0;j=j+(J<<3)|0;a=a+(B<<3)|0}}}if((h|0)==(j|0)){Ua=135;break b}q=(a|0)==427736;d=q&1^1;q=q?1:B;if((Sa|0)<=0)break b;s=h+8|0;b=h+(J<<3)|0;n=h+(J+1<<3)|0;l=j;j=0;while(1){db=+p[m>>3];eb=+p[m+(K<<3)>>3];fb=db*+p[b>>3]+eb*+p[n>>3];p[l>>3]=(+p[h>>3]*db+ +p[s>>3]*eb)*c+ +p[a>>3]*e;p[l+(L<<3)>>3]=fb*c+ +p[a+(q<<3)>>3]*e;j=j+1|0;if((j|0)==(Sa|0))break;else{m=m+8|0;l=l+8|0;a=a+(d<<3)|0}}break}case 3:{if(!((Sa|0)!=3|(m|0)==(j|0))){if((Ra|0)<=0)break b;s=m+(K<<3)|0;q=K<<1;b=m+(q<<3)|0;d=m+8|0;g=m+(K+1<<3)|0;f=m+((q|1)<<3)|0;t=m+16|0;n=m+(K+2<<3)|0;q=m+(q+2<<3)|0;l=0;while(1){bb=+p[h>>3];cb=+p[h+8>>3];db=+p[h+16>>3];eb=bb*+p[d>>3]+cb*+p[g>>3]+db*+p[f>>3];fb=bb*+p[t>>3]+cb*+p[n>>3]+db*+p[q>>3];p[j>>3]=(bb*+p[m>>3]+cb*+p[s>>3]+db*+p[b>>3])*c+ +p[a>>3]*e;p[j+8>>3]=eb*c+ +p[a+8>>3]*e;p[j+16>>3]=fb*c+ +p[a+16>>3]*e;l=l+1|0;if((l|0)==(Ra|0))break b;else{h=h+(J<<3)|0;j=j+(L<<3)|0;a=a+(B<<3)|0}}}if((h|0)==(j|0)){Ua=135;break b}g=(a|0)==427736;y=g&1^1;g=g?1:B;if((Sa|0)<=0)break b;f=h+8|0;t=h+16|0;u=K<<1;v=h+(J<<3)|0;w=h+(J+1<<3)|0;x=h+(J+2<<3)|0;s=J<<1;n=h+(s<<3)|0;q=h+((s|1)<<3)|0;s=h+(s+2<<3)|0;b=g<<1;d=L<<1;l=0;while(1){bb=+p[m>>3];cb=+p[m+(K<<3)>>3];db=+p[m+(u<<3)>>3];eb=bb*+p[v>>3]+cb*+p[w>>3]+db*+p[x>>3];fb=bb*+p[n>>3]+cb*+p[q>>3]+db*+p[s>>3];p[j>>3]=(+p[h>>3]*bb+ +p[f>>3]*cb+ +p[t>>3]*db)*c+ +p[a>>3]*e;p[j+(L<<3)>>3]=eb*c+ +p[a+(g<<3)>>3]*e;p[j+(d<<3)>>3]=fb*c+ +p[a+(b<<3)>>3]*e;l=l+1|0;if((l|0)==(Sa|0))break;else{m=m+8|0;j=j+8|0;a=a+(y<<3)|0}}break}case 4:{if(!((Sa|0)!=4|(m|0)==(j|0))){if((Ra|0)<=0)break b;b=m+(K<<3)|0;q=K<<1;d=m+(q<<3)|0;s=K*3|0;g=m+(s<<3)|0;f=m+8|0;t=m+(K+1<<3)|0;u=m+((q|1)<<3)|0;v=m+(s+1<<3)|0;w=m+16|0;x=m+(K+2<<3)|0;y=m+(q+2<<3)|0;z=m+(s+2<<3)|0;A=m+24|0;n=m+(K+3<<3)|0;q=m+(q+3<<3)|0;s=m+(s+3<<3)|0;l=0;while(1){$a=+p[h>>3];ab=+p[h+8>>3];bb=+p[h+16>>3];cb=+p[h+24>>3];db=$a*+p[f>>3]+ab*+p[t>>3]+bb*+p[u>>3]+cb*+p[v>>3];eb=$a*+p[w>>3]+ab*+p[x>>3]+bb*+p[y>>3]+cb*+p[z>>3];fb=$a*+p[A>>3]+ab*+p[n>>3]+bb*+p[q>>3]+cb*+p[s>>3];p[j>>3]=($a*+p[m>>3]+ab*+p[b>>3]+bb*+p[d>>3]+cb*+p[g>>3])*c+ +p[a>>3]*e;p[j+8>>3]=db*c+ +p[a+8>>3]*e;p[j+16>>3]=eb*c+ +p[a+16>>3]*e;p[j+24>>3]=fb*c+ +p[a+24>>3]*e;l=l+1|0;if((l|0)==(Ra|0))break b;else{h=h+(J<<3)|0;j=j+(L<<3)|0;a=a+(B<<3)|0}}}if((Sa|0)>16|(h|0)==(j|0)){Ua=135;break b}v=(a|0)==427736;u=v?1:B;v=v&1^1;if((Sa|0)<=0)break b;w=h+8|0;x=h+16|0;y=K<<1;z=h+24|0;A=K*3|0;B=h+(J<<3)|0;C=h+(J+1<<3)|0;D=h+(J+2<<3)|0;E=h+(J+3<<3)|0;I=J<<1;F=h+(I<<3)|0;G=h+((I|1)<<3)|0;H=h+(I+2<<3)|0;I=h+(I+3<<3)|0;b=J*3|0;n=h+(b<<3)|0;q=h+(b+1<<3)|0;s=h+(b+2<<3)|0;b=h+(b+3<<3)|0;d=u<<1;g=L<<1;f=u*3|0;t=L*3|0;l=0;while(1){$a=+p[m>>3];ab=+p[m+(K<<3)>>3];bb=+p[m+(y<<3)>>3];cb=+p[m+(A<<3)>>3];db=$a*+p[B>>3]+ab*+p[C>>3]+bb*+p[D>>3]+cb*+p[E>>3];eb=$a*+p[F>>3]+ab*+p[G>>3]+bb*+p[H>>3]+cb*+p[I>>3];fb=$a*+p[n>>3]+ab*+p[q>>3]+bb*+p[s>>3]+cb*+p[b>>3];p[j>>3]=(+p[h>>3]*$a+ +p[w>>3]*ab+ +p[x>>3]*bb+ +p[z>>3]*cb)*c+ +p[a>>3]*e;p[j+(L<<3)>>3]=db*c+ +p[a+(u<<3)>>3]*e;p[j+(g<<3)>>3]=eb*c+ +p[a+(d<<3)>>3]*e;p[j+(t<<3)>>3]=fb*c+ +p[a+(f<<3)>>3]*e;l=l+1|0;if((l|0)==(Sa|0))break;else{m=m+8|0;j=j+8|0;a=a+(v<<3)|0}}break}default:{Ua=135;break b}}}else Ua=135;while(0);if((Ua|0)==135){j=k[Ya+48>>2]|0;k[Qa>>2]=1124007936;Ga=Qa+4|0;a=Qa+8|0;Ea=Qa+40|0;n=Ga;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[Ea>>2]=a;Ha=Qa+48|0;Fa=Qa+44|0;k[Fa>>2]=Ha;k[Qa+52>>2]=0;k[Ha>>2]=0;Aa=k[Ta>>2]|0;s=Xa+48|0;Ba=(Aa|0)==0?0:k[s>>2]|0;Ca=Pa+8|0;k[Pa>>2]=Ca;Da=Pa+4|0;k[Da>>2]=1032;switch(t&4095){case 5:{ua=2;va=102;za=1;break}case 6:{ua=3;va=103;za=2;break}case 13:{ua=4;va=104;za=3;break}case 14:{Ua=141;break}default:{k[Oa>>2]=0;a=Oa+4|0;k[a>>2]=0;h=ZT(24)|0;k[h>>2]=1;n=h+4|0;k[Oa>>2]=n;k[a>>2]=16;i[h+20>>0]=0;m=215702;q=n+16|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,Oa,215412,215417,1223);k[a>>2]=0;k[Oa>>2]=0;Ua=k[h>>2]|0;k[h>>2]=Ua+-1;if((Ua|0)==1)ggb(k[h+-4>>2]|0);Ua=141}}if((Ua|0)==141){ua=5;va=105;za=4}Ua=k[Wa+16>>2]|0;xa=Za+16|0;a=k[xa>>2]|0;if((Ua|0)!=(a|0)?(Ua|0)!=(k[Ya+16>>2]|0):0){b=0;ya=Wa}else{b=aa(aa(Ra,(t>>>3&511)+1<<(47696>>>(w<<1&14)&3))|0,Sa)|0;ya=Qa}h=(Sa|0)==1;if(((Ia|0)==1|h)&(g&2|0)==0?(k[Ya>>2]&16384|0)!=0:0){if(h)h=0;else h=(t>>>3&511)+1<<(47696>>>(w<<1&14)&3);wa=h;m=g|2}else{wa=j;m=g}if((Ra|0)<65)if((Ia|0)<10001)Ua=155;else Ua=153;else if((Ia|0)<11|(Ia|0)<10001&(Sa|0)<65)Ua=155;else Ua=153;do if((Ua|0)==153){if((Sa|0)<129?(Ia|0)<129&(Ra|0)<129:0){Ua=155;break}qa=t&7;pa=(t>>>3&511)+1<<(47696>>>(qa<<1)&3);qa=pa<<((qa|0)==5&1);ra=(m&1|0)!=0;sa=Za+48|0;oa=k[sa>>2]|0;na=ra?pa:oa;oa=ra?oa:pa;ta=(m&2|0)!=0;ma=ta?pa:wa;la=ta?wa:pa;if(k[Ta>>2]|0){j=k[Xa+4>>2]|0;if((j|0)<3)a=aa(k[Xa+12>>2]|0,k[Xa+8>>2]|0)|0;else{l=k[Xa+40>>2]|0;h=0;a=1;do{a=aa(k[l+(h<<2)>>2]|0,a)|0;h=h+1|0}while((h|0)!=(j|0))}if(a){l=(m&4|0)==0;ka=k[s>>2]|0;ja=l?pa:ka;ka=l?ka:pa;l=m}else Ua=188}else Ua=188;if((Ua|0)==188){ja=0;ka=0;l=m&-5}a=(Ra|0)<128?Ra:128;h=(Sa|0)<128?Sa:128;ia=16384/(a|0)|0;ha=16384/(h|0)|0;ia=(ha|0)<(ia|0)?ha:ia;ia=(Ia|0)<(ia|0)?Ia:ia;if((aa(ia,a)|0)>16384)a=16384/(ia|0)|0;if((aa(ia,h)|0)>16384)h=16384/(ia|0)|0;j=((ia|0)/8|0)+ia|0;m=aa(h+2+((h|0)/8|0)&-2,j+1|0)|0;n=aa(m,pa)|0;m=aa(m,qa)|0;if(ra){q=aa(aa(j+2&-2,pa)|0,a+1+((a|0)/8|0)|0)|0;s=l&-2}else{q=0;s=l}l=n+b+m+q|0;do if((k[Da>>2]|0)>>>0<l>>>0){j=k[Pa>>2]|0;if((j|0)!=(Ca|0)){if(j|0)ggb(j);k[Pa>>2]=Ca;k[Da>>2]=1032}if(l>>>0<=1032){ha=Ca;break}while(1){j=fgb(l)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}k[Pa>>2]=j;k[Da>>2]=l;ha=j}else{k[Da>>2]=l;ha=k[Pa>>2]|0}while(0);ga=ha+m|0;fa=ga+n|0;ea=ra?fa:0;if(b|0){JN(Oa,Ra,Sa,w,fa+q|0,0);KG(Qa,Oa)|0;m=Oa+36|0;j=k[m>>2]|0;do if(j|0){ca=j+12|0;da=k[ca>>2]|0;k[ca>>2]=da+-1;if((da|0)!=1)break;l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[Oa+32>>2]|0;if(j|0)break;j=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}while(0);k[m>>2]=0;da=Oa+16|0;l=Oa+4|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[l>>2]|0)>0){m=k[Oa+40>>2]|0;j=0;do{k[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[l>>2]|0))}j=k[Oa+44>>2]|0;if(!((j|0)==(Oa+48|0)|(j|0)==0))ggb(k[j+-4>>2]|0)}if((Ra|0)<=0)break;M=Ra<<3;N=(Sa|0)>0;O=ya+16|0;P=ya+44|0;Q=ya+48|0;R=Sa<<3;S=(ia|0)<(Ia|0);T=(Ia|0)>0;U=Na+4|0;V=Ya+16|0;W=Ia<<3;ca=ra&(ea|0)!=0;X=(pa|0)==4;da=pa&65535;Y=pa>>>2;Z=Ja+4|0;_=Ka+4|0;$=La+4|0;ba=Ma+4|0;L=0;j=s;do{K=L+a|0;if((K|0)<(Ra|0)?((K<<3)+a|0)<=(M|0):0)K=a;else K=Ra-L|0;if(N){H=Aa+(aa(L,ka)|0)|0;I=aa(L,na)|0;J=(K|0)>0;G=0;do{m=k[Q>>2]|0;E=aa(G,pa)|0;l=(k[O>>2]|0)+(aa(m,L)|0)+E|0;F=H+(aa(G,ja)|0)|0;D=G+h|0;if((D|0)<(Sa|0)?((D<<3)+h|0)<=(R|0):0)D=h;else D=Sa-G|0;j=j&15;B=aa(D,qa)|0;C=S?ha:l;B=S?B:m;if(T){z=aa(G,la)|0;A=(D|0)<(Sa|0);y=0;do{m=(k[xa>>2]|0)+I+(aa(y,oa)|0)|0;w=k[sa>>2]|0;l=(k[V>>2]|0)+(aa(y,ma)|0)+z|0;x=y+ia|0;if((x|0)<(Ia|0)?((x<<3)+ia|0)<=(W|0):0)x=ia;else x=Ia-y|0;c:do if(ra){if(!ca){t=m;u=K;v=x;break}t=aa(x,pa)|0;if(!J){w=t;t=fa;u=x;v=K;break}if(X){q=m;s=fa;b=0;n=x;m=K;while(1){if((n|0)>0){m=0;n=q;while(1){k[s+(m<<2)>>2]=k[n>>2];m=m+1|0;if((m|0)>=(x|0)){m=K;n=x;break}else n=n+w|0}}b=b+1|0;if((b|0)>=(m|0)){w=t;t=ea;u=x;v=K;break c}else{q=q+4|0;s=s+t|0}}}f=(x|0)>0;d=x<<2;g=x<<1;switch(da&8191){case 16:{n=fa;q=0;while(1){if(f){s=m;b=0;while(1){v=k[s+4>>2]|0;k[n+(b<<2)>>2]=k[s>>2];k[n+((b|1)<<2)>>2]=v;v=k[s+12>>2]|0;k[n+((b|2)<<2)>>2]=k[s+8>>2];k[n+((b|3)<<2)>>2]=v;b=b+4|0;if((b|0)>=(d|0))break;else s=s+w|0}}q=q+1|0;if((q|0)==(K|0)){w=t;t=ea;u=x;v=K;break}else{m=m+pa|0;n=n+t|0}}break}case 8:{n=fa;q=0;while(1){if(f){s=m;b=0;while(1){v=k[s+4>>2]|0;k[n+(b<<2)>>2]=k[s>>2];k[n+((b|1)<<2)>>2]=v;b=b+2|0;if((b|0)>=(g|0))break;else s=s+w|0}}q=q+1|0;if((q|0)==(K|0)){w=t;t=ea;u=x;v=K;break}else{m=m+pa|0;n=n+t|0}}break}default:{w=t;t=fa;u=x;v=K;break c}}}else{t=m;u=x;v=K}while(0);d:do if(A){q=ta?D:x;f=ta?x:D;m=aa(f,pa)|0;f=aa(f,Y)|0;if(!q){l=ga;break}b=f+-4|0;if((f|0)<4){b=(f|0)>0;s=ga;while(1){q=q+-1|0;if(b){n=0;do{k[s+(n<<2)>>2]=k[l+(n<<2)>>2];n=n+1|0}while((n|0)!=(f|0))}if(!q){l=ga;break d}else{s=s+m|0;l=l+wa|0}}}d=f&-4;g=(d|0)<(f|0);s=ga;while(1){n=0;do{ib=n|1;gb=k[l+(ib<<2)>>2]|0;k[s+(n<<2)>>2]=k[l+(n<<2)>>2];k[s+(ib<<2)>>2]=gb;ib=n|2;gb=n|3;hb=k[l+(gb<<2)>>2]|0;k[s+(ib<<2)>>2]=k[l+(ib<<2)>>2];k[s+(gb<<2)>>2]=hb;n=n+4|0}while((n|0)<=(b|0));q=q+-1|0;if(g){n=d;do{k[s+(n<<2)>>2]=k[l+(n<<2)>>2];n=n+1|0}while((n|0)!=(f|0))}if(!q){l=ga;break}else{s=s+m|0;l=l+wa|0}}}else m=wa;while(0);if(S){k[Ja>>2]=u;k[Z>>2]=v;k[Ka>>2]=D;k[_>>2]=K;Gh[va&127](t,w,l,m,C,B,Ja,Ka,j)}else{k[La>>2]=u;k[$>>2]=v;k[Ma>>2]=D;k[ba>>2]=K;sg[za&7](t,w,l,m,F,Ba,C,B,La,Ma,c,e,j)}j=j|16;y=x+y|0}while((Ia|0)>(y|0))}if(S){hb=(k[O>>2]|0)+(aa(k[k[P>>2]>>2]|0,L)|0)+E|0;ib=k[Q>>2]|0;k[Na>>2]=D;k[U>>2]=K;Yh[ua&7](F,Ba,C,B,hb,ib,Na,c,e,j)}G=D+G|0}while((Sa|0)>(G|0))}L=K+L|0}while((Ra|0)>(L|0))}while(0);if((Ua|0)==155){if(b){if((k[Da>>2]|0)>>>0<b>>>0){a=k[Pa>>2]|0;if((a|0)!=(Ca|0)){if(a|0)ggb(a);k[Pa>>2]=Ca;k[Da>>2]=1032}if(b>>>0>1032){while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[Pa>>2]=a;k[Da>>2]=b}else a=Ca}else{k[Da>>2]=b;a=k[Pa>>2]|0}JN(Oa,Ra,Sa,w,a,0);KG(Qa,Oa)|0;j=Oa+36|0;a=k[j>>2]|0;if(a|0?(hb=a+12|0,ib=k[hb>>2]|0,k[hb>>2]=ib+-1,(ib|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[Oa+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;ib=Oa+16|0;h=Oa+4|0;k[ib>>2]=0;k[ib+4>>2]=0;k[ib+8>>2]=0;k[ib+12>>2]=0;if((k[h>>2]|0)>0){j=k[Oa+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[Oa+44>>2]|0;if(!((a|0)==(Oa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[xa>>2]|0}Ua=k[Za+48>>2]|0;gb=k[Ya+16>>2]|0;hb=k[ya+16>>2]|0;ib=k[ya+48>>2]|0;k[x>>2]=u;k[x+4>>2]=v;k[y>>2]=Sa;k[y+4>>2]=Ra;sg[za&7](a,Ua,gb,wa,Aa,Ba,hb,ib,x,y,c,e,m)}if((ya|0)!=(Wa|0)){ib=Oa+4|0;hb=ib+4|0;k[hb>>2]=0;k[hb+4>>2]=0;k[Oa>>2]=33619968;k[ib>>2]=Wa;mY(ya,Oa)}a=k[Pa>>2]|0;if((a|0)!=(Ca|0)){if(a|0)ggb(a);k[Pa>>2]=Ca;k[Da>>2]=1032}j=Qa+36|0;a=k[j>>2]|0;if(a|0?(hb=a+12|0,ib=k[hb>>2]|0,k[hb>>2]=ib+-1,(ib|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[Qa+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;ib=Qa+16|0;k[ib>>2]=0;k[ib+4>>2]=0;k[ib+8>>2]=0;k[ib+12>>2]=0;if((k[Ga>>2]|0)>0){h=k[Ea>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Ga>>2]|0))}a=k[Fa>>2]|0;if(!((a|0)==(Ha|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}j=Wa+36|0;a=k[j>>2]|0;if(a|0?(hb=a+12|0,ib=k[hb>>2]|0,k[hb>>2]=ib+-1,(ib|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[Wa+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;ib=Wa+16|0;h=Wa+4|0;k[ib>>2]=0;k[ib+4>>2]=0;k[ib+8>>2]=0;k[ib+12>>2]=0;if((k[h>>2]|0)>0){j=k[Wa+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[Wa+44>>2]|0;if(!((a|0)==(Wa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=Xa+36|0;a=k[j>>2]|0;if(a|0?(hb=a+12|0,ib=k[hb>>2]|0,k[hb>>2]=ib+-1,(ib|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[Xa+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;j=Xa+4|0;k[Ta>>2]=0;k[Ta+4>>2]=0;k[Ta+8>>2]=0;k[Ta+12>>2]=0;if((k[j>>2]|0)>0){h=k[Xa+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[Xa+44>>2]|0;if(!((a|0)==(Xa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=Ya+36|0;a=k[j>>2]|0;if(a|0?(hb=a+12|0,ib=k[hb>>2]|0,k[hb>>2]=ib+-1,(ib|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[Ya+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;ib=Ya+16|0;h=Ya+4|0;k[ib>>2]=0;k[ib+4>>2]=0;k[ib+8>>2]=0;k[ib+12>>2]=0;if((k[h>>2]|0)>0){j=k[Ya+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[Ya+44>>2]|0;if(!((a|0)==(Ya+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=Za+36|0;a=k[j>>2]|0;if(a|0?(hb=a+12|0,ib=k[hb>>2]|0,k[hb>>2]=ib+-1,(ib|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[Za+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;ib=Za+16|0;j=Za+4|0;k[ib>>2]=0;k[ib+4>>2]=0;k[ib+8>>2]=0;k[ib+12>>2]=0;if((k[j>>2]|0)>0){h=k[Va>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[Za+44>>2]|0;if((a|0)==(Za+48|0)|(a|0)==0){r=_a;return}ggb(k[a+-4>>2]|0);r=_a;return}function t_(a,b,c,d,e,f,g,h,i,j,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;l=+l;m=+m;n=n|0;var o=0.0,q=0.0,s=0.0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0;U=r;r=r+2192|0;T=U+1096|0;J=U;t=k[i>>2]|0;v=k[i+4>>2]|0;M=k[j>>2]|0;Q=k[j+4>>2]|0;R=T+8|0;k[T>>2]=R;S=T+4|0;k[S>>2]=136;w=b>>>3;L=d>>>3;i=f>>>3;P=h>>>3;if(!e){N=0;O=0}else{O=(n&4|0)==0;N=O?1:i;O=O?i:1}do if(n&1)if(b>>>0>15&(v|0)>1){if(v>>>0<=136){k[S>>2]=v;j=w;f=1;i=R;t=v;h=v;A=12;break}j=v>>>0>536870911?-1:v<<3;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}k[T>>2]=i;k[S>>2]=v;K=1;t=v;A=64}else{j=w;f=1;i=0;t=v;h=136;A=12}else{j=1;f=w;i=0;h=136;A=12}while(0);if((A|0)==12)if((t|0)==1){y=J+8|0;k[J>>2]=y;z=J+4|0;k[z>>2]=136;if(b>>>0>15&(v|0)>1){if(h>>>0<Q>>>0)if(Q>>>0>136){j=Q>>>0>536870911?-1:Q<<3;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}k[T>>2]=i;k[S>>2]=Q}else i=R;else{k[S>>2]=Q;i=R}if((Q|0)>0){j=0;do{K=a+((aa(j,w)|0)<<3)|0;p[i+(j<<3)>>3]=+p[K>>3];j=j+1|0}while((j|0)!=(Q|0));x=i}else x=i}else x=a;if(d>>>0>15){if(M>>>0>136){j=M>>>0>536870911?-1:M<<3;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}k[J>>2]=i}else i=y;k[z>>2]=M;if((M|0)>0){j=0;do{K=c+((aa(j,L)|0)<<3)|0;p[i+(j<<3)>>3]=+p[K>>3];j=j+1|0}while((j|0)!=(M|0));w=i}else w=i}else w=c;a:do if((Q|0)>0){v=N<<1;if((M|0)<2){if((M|0)==1){j=g;f=0;i=e}else break;while(1){o=+p[x+(f<<3)>>3]*l*+p[w>>3];if(i)o=o+ +p[i>>3]*m;p[j>>3]=o;f=f+1|0;if((f|0)==(Q|0))break a;else{j=j+(P<<3)|0;i=i+(O<<3)|0}}}d=M+-2|0;n=((d|0)>1?d:1)>>>1;b=aa(v,n)|0;n=(n<<1)+2|0;if((n|0)>=(M|0)){i=0;while(1){s=+p[x+(i<<3)>>3]*l;j=e;f=0;while(1){q=s*+p[w+(f<<3)>>3];h=f|1;o=s*+p[w+(h<<3)>>3];if(!j)p[g+(f<<3)>>3]=q;else{p[g+(f<<3)>>3]=q+ +p[j>>3]*m;o=o+ +p[j+(N<<3)>>3]*m}p[g+(h<<3)>>3]=o;f=f+2|0;if((f|0)>(d|0))break;else j=j+(v<<3)|0}i=i+1|0;if((i|0)==(Q|0))break a;g=g+(P<<3)|0;e=e+(O<<3)|0}}i=0;t=e;e=e+(v<<3)|0;while(1){s=+p[x+(i<<3)>>3]*l;j=t;f=0;while(1){q=s*+p[w+(f<<3)>>3];h=f|1;o=s*+p[w+(h<<3)>>3];if(!j)p[g+(f<<3)>>3]=q;else{p[g+(f<<3)>>3]=q+ +p[j>>3]*m;o=o+ +p[j+(N<<3)>>3]*m}p[g+(h<<3)>>3]=o;f=f+2|0;if((f|0)>(d|0))break;else j=j+(v<<3)|0}j=e+(b<<3)|0;f=n;while(1){o=s*+p[w+(f<<3)>>3];if(j)o=o+ +p[j>>3]*m;p[g+(f<<3)>>3]=o;f=f+1|0;if((f|0)==(M|0))break;else j=j+(N<<3)|0}i=i+1|0;if((i|0)==(Q|0))break a;g=g+(P<<3)|0;t=t+(O<<3)|0;e=e+(O<<3)|0}}while(0);i=k[J>>2]|0;if((i|0)!=(y|0)){if(i|0)ggb(i);k[J>>2]=y;k[z>>2]=136}}else{w=j;K=f;A=64}b:do if((A|0)==64){if(n&2|0){if((Q|0)<=0)break;x=(i|0)==0;y=(M|0)>0;z=t+-4|0;A=(t|0)<4;B=t&-4;E=x|(t|0)<1;C=(t|0)>0;D=(B|0)<(t|0);I=l*0.0;d=a;v=0;while(1){if(E)n=x?d:i;else{j=0;do{J=d+((aa(j,w)|0)<<3)|0;p[i+(j<<3)>>3]=+p[J>>3];j=j+1|0}while((j|0)!=(t|0));n=i}c:do if(y){if(A){if(C){f=c;h=e;b=0}else{j=e;f=0;while(1){if(!j)o=I;else o=I+ +p[j>>3]*m;p[g+(f<<3)>>3]=o;f=f+1|0;if((f|0)==(M|0))break c;else j=j+(N<<3)|0}}while(1){o=0.0;j=0;do{o=o+ +p[n+(j<<3)>>3]*+p[f+(j<<3)>>3];j=j+1|0}while((j|0)!=(t|0));o=(o+0.0)*l;if(h)o=o+ +p[h>>3]*m;p[g+(b<<3)>>3]=o;b=b+1|0;if((b|0)==(M|0))break c;else{f=f+(L<<3)|0;h=h+(N<<3)|0}}}if(D){f=c;h=e;b=0}else{f=c;h=e;b=0;while(1){o=0.0;q=0.0;s=0.0;u=0.0;j=0;do{u=u+ +p[n+(j<<3)>>3]*+p[f+(j<<3)>>3];J=j|1;s=s+ +p[n+(J<<3)>>3]*+p[f+(J<<3)>>3];J=j|2;q=q+ +p[n+(J<<3)>>3]*+p[f+(J<<3)>>3];J=j|3;o=o+ +p[n+(J<<3)>>3]*+p[f+(J<<3)>>3];j=j+4|0}while((j|0)<=(z|0));o=(o+(q+(s+u)))*l;if(h)o=o+ +p[h>>3]*m;p[g+(b<<3)>>3]=o;b=b+1|0;if((b|0)==(M|0))break c;else{f=f+(L<<3)|0;h=h+(N<<3)|0}}}while(1){q=0.0;s=0.0;u=0.0;o=0.0;j=0;do{o=o+ +p[n+(j<<3)>>3]*+p[f+(j<<3)>>3];J=j|1;u=u+ +p[n+(J<<3)>>3]*+p[f+(J<<3)>>3];J=j|2;s=s+ +p[n+(J<<3)>>3]*+p[f+(J<<3)>>3];J=j|3;q=q+ +p[n+(J<<3)>>3]*+p[f+(J<<3)>>3];j=j+4|0}while((j|0)<=(z|0));j=B;do{o=o+ +p[n+(j<<3)>>3]*+p[f+(j<<3)>>3];j=j+1|0}while((j|0)!=(t|0));o=(q+(s+(u+o)))*l;if(h)o=o+ +p[h>>3]*m;p[g+(b<<3)>>3]=o;b=b+1|0;if((b|0)==(M|0))break;else{f=f+(L<<3)|0;h=h+(N<<3)|0}}}while(0);v=v+1|0;if((v|0)==(Q|0))break b;else{d=d+(K<<3)|0;g=g+(P<<3)|0;e=e+(O<<3)|0}}}F=M<<3;if(F>>>0<1601){if((Q|0)<=0)break;y=(i|0)==0;z=M+-4|0;A=(M|0)<4;B=(t|0)>0;C=N<<2;D=N<<1;E=N*3|0;n=z>>>2;F=(n<<2)+4|0;G=y|(t|0)<1;I=l*0.0;x=a;v=0;d=e;n=e+(aa(N,(n<<5)+32|0)|0)|0;while(1){if(G)b=y?x:i;else{j=0;do{J=x+((aa(j,w)|0)<<3)|0;p[i+(j<<3)>>3]=+p[J>>3];j=j+1|0}while((j|0)!=(t|0));b=i}d:do if(A){j=d;f=0}else{if(B){h=d;e=0}else{j=d;f=0;while(1){if(!j){p[g+(f<<3)>>3]=I;p[g+((f|1)<<3)>>3]=I;p[g+((f|2)<<3)>>3]=I;p[g+((f|3)<<3)>>3]=I}else{p[g+(f<<3)>>3]=I+ +p[j>>3]*m;p[g+((f|1)<<3)>>3]=I+ +p[j+(N<<3)>>3]*m;p[g+((f|2)<<3)>>3]=I+ +p[j+(D<<3)>>3]*m;p[g+((f|3)<<3)>>3]=I+ +p[j+(E<<3)>>3]*m}f=f+4|0;if((f|0)>(z|0)){j=n;f=F;break d}else j=j+(C<<3)|0}}while(1){q=0.0;s=0.0;u=0.0;o=0.0;j=c+(e<<3)|0;f=0;while(1){V=+p[b+(f<<3)>>3];o=o+V*+p[j>>3];u=u+V*+p[j+8>>3];s=s+V*+p[j+16>>3];q=q+V*+p[j+24>>3];f=f+1|0;if((f|0)==(t|0))break;else j=j+(L<<3)|0}o=o*l;if(!h){p[g+(e<<3)>>3]=o;p[g+((e|1)<<3)>>3]=u*l;p[g+((e|2)<<3)>>3]=s*l;p[g+((e|3)<<3)>>3]=q*l}else{p[g+(e<<3)>>3]=o+ +p[h>>3]*m;p[g+((e|1)<<3)>>3]=u*l+ +p[h+(N<<3)>>3]*m;p[g+((e|2)<<3)>>3]=s*l+ +p[h+(D<<3)>>3]*m;p[g+((e|3)<<3)>>3]=q*l+ +p[h+(E<<3)>>3]*m}e=e+4|0;if((e|0)>(z|0)){j=n;f=F;break}else h=h+(C<<3)|0}}while(0);e:do if((f|0)<(M|0)){if(!B)while(1){if(!j)o=I;else o=I+ +p[j>>3]*m;p[g+(f<<3)>>3]=o;f=f+1|0;if((f|0)==(M|0))break e;else j=j+(N<<3)|0}while(1){o=0.0;h=c+(f<<3)|0;e=0;while(1){o=o+ +p[b+(e<<3)>>3]*+p[h>>3];e=e+1|0;if((e|0)==(t|0))break;else h=h+(L<<3)|0}o=o*l;if(j)o=o+ +p[j>>3]*m;p[g+(f<<3)>>3]=o;f=f+1|0;if((f|0)==(M|0))break;else j=j+(N<<3)|0}}while(0);v=v+1|0;if((v|0)==(Q|0))break b;else{x=x+(K<<3)|0;g=g+(P<<3)|0;d=d+(O<<3)|0;n=n+(O<<3)|0}}}G=J+8|0;k[J>>2]=G;H=J+4|0;k[H>>2]=136;if(M>>>0>136){f=M>>>0>536870911?-1:M<<3;f=(f|0)==0?1:f;while(1){j=fgb(f)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}k[J>>2]=j}else j=G;k[H>>2]=M;if((Q|0)>0){x=(i|0)==0;y=(M|0)>0;z=(t|0)>0;A=M+-4|0;B=(M|0)<4;C=M&-4;E=x|(t|0)<1;D=(C|0)<(M|0);d=a;v=0;while(1){if(E)n=x?d:i;else{f=0;do{a=d+((aa(f,w)|0)<<3)|0;p[i+(f<<3)>>3]=+p[a>>3];f=f+1|0}while((f|0)!=(t|0));n=i}if(y)zpb(j|0,0,F|0)|0;f:do if(z){if(B){if(y){f=c;h=0}else break;while(1){o=+p[n+(h<<3)>>3];b=0;do{a=j+(b<<3)|0;p[a>>3]=+p[a>>3]+o*+p[f+(b<<3)>>3];b=b+1|0}while((b|0)!=(M|0));h=h+1|0;if((h|0)==(t|0))break f;else f=f+(L<<3)|0}}if(D){h=c;b=0}else{f=c;b=0;while(1){o=+p[n+(b<<3)>>3];h=0;do{W=j+(h<<3)|0;Y=h|1;X=j+(Y<<3)|0;V=+p[X>>3]+o*+p[f+(Y<<3)>>3];p[W>>3]=+p[W>>3]+o*+p[f+(h<<3)>>3];p[X>>3]=V;X=h|2;W=j+(X<<3)|0;Y=h|3;a=j+(Y<<3)|0;V=+p[a>>3]+o*+p[f+(Y<<3)>>3];p[W>>3]=+p[W>>3]+o*+p[f+(X<<3)>>3];p[a>>3]=V;h=h+4|0}while((h|0)<=(A|0));b=b+1|0;if((b|0)==(t|0))break f;else f=f+(L<<3)|0}}while(1){o=+p[n+(b<<3)>>3];f=0;do{X=j+(f<<3)|0;a=f|1;W=j+(a<<3)|0;V=+p[W>>3]+o*+p[h+(a<<3)>>3];p[X>>3]=+p[X>>3]+o*+p[h+(f<<3)>>3];p[W>>3]=V;W=f|2;X=j+(W<<3)|0;a=f|3;Y=j+(a<<3)|0;V=+p[Y>>3]+o*+p[h+(a<<3)>>3];p[X>>3]=+p[X>>3]+o*+p[h+(W<<3)>>3];p[Y>>3]=V;f=f+4|0}while((f|0)<=(A|0));f=C;do{Y=j+(f<<3)|0;p[Y>>3]=+p[Y>>3]+o*+p[h+(f<<3)>>3];f=f+1|0}while((f|0)!=(M|0));b=b+1|0;if((b|0)==(t|0))break;else h=h+(L<<3)|0}}while(0);if(!e){if(y){f=0;do{p[g+(f<<3)>>3]=+p[j+(f<<3)>>3]*l;f=f+1|0}while((f|0)!=(M|0))}}else if(y){f=0;h=e;while(1){p[g+(f<<3)>>3]=+p[j+(f<<3)>>3]*l+ +p[h>>3]*m;f=f+1|0;if((f|0)==(M|0))break;else h=h+(N<<3)|0}}v=v+1|0;if((v|0)==(Q|0))break;else{d=d+(K<<3)|0;g=g+(P<<3)|0;e=e+(O<<3)|0}}}if((j|0)!=(G|0)){ggb(j);k[J>>2]=G;k[H>>2]=136}}while(0);i=k[T>>2]|0;if((i|0)==(R|0)){r=U;return}if(i|0)ggb(i);k[T>>2]=R;k[S>>2]=136;r=U;return}function u_(a,b,c,d,e,f,g,h,i,j,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;l=+l;m=+m;n=n|0;var q=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0;$=r;r=r+2256|0;_=$+1160|0;Q=$;q=k[i>>2]|0;w=k[i+4>>2]|0;X=k[j>>2]|0;W=k[j+4>>2]|0;Y=_+8|0;zpb(Y|0,0,1088)|0;k[_>>2]=Y;Z=_+4|0;k[Z>>2]=136;x=b>>>3;S=d>>>3;i=f>>>3;V=h>>>3;if(!e){U=0;T=0}else{T=(n&4|0)==0;U=T?1:i;T=T?i:1}do if(n&1)if(b>>>0>15&(w|0)>1){if(w>>>0<=136){k[Z>>2]=w;i=x;j=1;h=Y;q=w;f=w;H=12;break}j=w>>>0>536870911?-1:w<<3;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}zpb(i|0,0,w<<3|0)|0;k[_>>2]=i;k[Z>>2]=w;R=1;h=i;q=w;H=51}else{i=x;j=1;h=0;q=w;f=136;H=12}else{i=1;j=x;h=0;f=136;H=12}while(0);if((H|0)==12)if((q|0)==1){F=Q+8|0;zpb(F|0,0,1088)|0;k[Q>>2]=F;G=Q+4|0;k[G>>2]=136;if(b>>>0>15&(w|0)>1){if(f>>>0<W>>>0)if(W>>>0>136){j=W>>>0>536870911?-1:W<<3;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}zpb(i|0,0,W<<3|0)|0;k[_>>2]=i;k[Z>>2]=W}else i=Y;else{k[Z>>2]=W;i=Y}if((W|0)>0){j=0;do{M=a+((aa(j,x)|0)<<3)|0;N=k[M+4>>2]|0;R=i+(j<<3)|0;k[R>>2]=k[M>>2];k[R+4>>2]=N;j=j+1|0}while((j|0)!=(W|0));a=i}else a=i}if(d>>>0>15){if(X>>>0>136){j=X>>>0>536870911?-1:X<<3;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}zpb(i|0,0,X<<3|0)|0;k[Q>>2]=i}else i=F;k[G>>2]=X;if((X|0)>0){j=0;do{M=c+((aa(j,S)|0)<<3)|0;N=k[M+4>>2]|0;R=i+(j<<3)|0;k[R>>2]=k[M>>2];k[R+4>>2]=N;j=j+1|0}while((j|0)!=(X|0));E=i}else E=i}else{E=c;i=F}if((W|0)>0){d=U<<1;x=(X|0)<2;B=X+-2|0;q=B>>>1;D=(q<<1)+2|0;n=e;w=0;b=g;q=e+(aa(U,(q<<4)+16|0)|0)|0;while(1){y=+o[a+(w<<3)>>2]*l;z=+o[a+(w<<3)+4>>2]*l;if(x){i=n;j=0}else{j=n;f=0;while(1){P=+o[E+(f<<3)>>2];v=+o[E+(f<<3)+4>>2];u=y*P-z*v;v=z*P+y*v;h=f|1;P=+o[E+(h<<3)>>2];t=+o[E+(h<<3)+4>>2];s=y*P-z*t;t=z*P+y*t;i=b+(f<<3)|0;if(!j){o[i>>2]=u;o[b+(f<<3)+4>>2]=v}else{P=v+ +o[j+4>>2]*m;o[i>>2]=u+ +o[j>>2]*m;o[b+(f<<3)+4>>2]=P;t=t+ +o[j+(U<<3)+4>>2]*m;s=s+ +o[j+(U<<3)>>2]*m}o[b+(h<<3)>>2]=s;o[b+(h<<3)+4>>2]=t;f=f+2|0;if((f|0)>(B|0)){i=q;j=D;break}else j=j+(d<<3)|0}}if((j|0)<(X|0))while(1){P=+o[E+(j<<3)>>2];t=+o[E+(j<<3)+4>>2];s=y*P-z*t;t=z*P+y*t;if(i){t=t+ +o[i+4>>2]*m;s=s+ +o[i>>2]*m}o[b+(j<<3)>>2]=s;o[b+(j<<3)+4>>2]=t;j=j+1|0;if((j|0)==(X|0))break;else i=i+(U<<3)|0}w=w+1|0;if((w|0)==(W|0))break;else{n=n+(T<<3)|0;b=b+(V<<3)|0;q=q+(T<<3)|0}}i=k[Q>>2]|0}if((i|0)!=(F|0)){if(i|0)ggb(i);k[Q>>2]=F;k[G>>2]=136}}else{x=i;R=j;H=51}a:do if((H|0)==51){if(n&2|0){if((W|0)<=0)break;D=(h|0)==0;E=q+-4|0;F=(q|0)<4;G=q&-4;I=D|(q|0)<1;H=(X|0)>0;d=e;B=0;w=g;while(1){if(I)j=D?a:h;else{i=0;do{e=a+((aa(i,x)|0)<<3)|0;g=k[e+4>>2]|0;Q=h+(i<<3)|0;k[Q>>2]=k[e>>2];k[Q+4>>2]=g;i=i+1|0}while((i|0)!=(q|0));j=h}if(H){f=c;b=d;n=0;while(1){if(F){i=0;u=0.0;A=0.0;y=0.0;s=0.0;t=0.0;C=0.0;z=0.0;v=0.0}else{i=0;u=0.0;A=0.0;y=0.0;s=0.0;t=0.0;C=0.0;z=0.0;v=0.0;do{O=+o[j+(i<<3)>>2];ba=+o[j+(i<<3)+4>>2];L=+o[f+(i<<3)>>2];P=+o[f+(i<<3)+4>>2];s=s+(O*L-ba*P);t=t+(ba*L+O*P);Q=i|1;P=+o[j+(Q<<3)>>2];O=+o[j+(Q<<3)+4>>2];L=+o[f+(Q<<3)>>2];ba=+o[f+(Q<<3)+4>>2];y=y+(P*L-O*ba);v=v+(O*L+P*ba);Q=i|2;ba=+o[j+(Q<<3)>>2];P=+o[j+(Q<<3)+4>>2];L=+o[f+(Q<<3)>>2];O=+o[f+(Q<<3)+4>>2];A=A+(ba*L-P*O);z=z+(P*L+ba*O);Q=i|3;O=+o[j+(Q<<3)>>2];ba=+o[j+(Q<<3)+4>>2];L=+o[f+(Q<<3)>>2];P=+o[f+(Q<<3)+4>>2];u=u+(O*L-ba*P);C=C+(ba*L+O*P);i=i+4|0}while((i|0)<=(E|0));i=G}if((i|0)<(q|0))do{P=+o[j+(i<<3)>>2];L=+o[j+(i<<3)+4>>2];O=+o[f+(i<<3)>>2];ba=+o[f+(i<<3)+4>>2];s=s+(P*O-L*ba);t=t+(L*O+P*ba);i=i+1|0}while((i|0)!=(q|0));s=(u+(A+(y+s)))*l;t=(C+(z+(v+t)))*l;if(b){t=t+ +o[b+4>>2]*m;s=s+ +o[b>>2]*m}o[w+(n<<3)>>2]=s;o[w+(n<<3)+4>>2]=t;n=n+1|0;if((n|0)==(X|0))break;else{f=f+(S<<3)|0;b=b+(U<<3)|0}}}B=B+1|0;if((B|0)==(W|0))break a;else{a=a+(R<<3)|0;d=d+(T<<3)|0;w=w+(V<<3)|0}}}if(X<<3>>>0<1601){if((W|0)<=0)break;E=(h|0)==0;F=X+-4|0;G=(X|0)<4;H=(q|0)>0;I=U<<2;J=U<<1;K=U*3|0;w=F>>>2;M=(w<<2)+4|0;N=E|(q|0)<1;O=l*0.0;P=O;B=e;D=0;d=g;w=e+(aa(U,(w<<5)+32|0)|0)|0;while(1){if(N)n=E?a:h;else{i=0;do{e=a+((aa(i,x)|0)<<3)|0;g=k[e+4>>2]|0;Q=h+(i<<3)|0;k[Q>>2]=k[e>>2];k[Q+4>>2]=g;i=i+1|0}while((i|0)!=(q|0));n=h}if(G){i=B;j=0}else{f=B;b=0;while(1){if(H){i=c+(b<<3)|0;j=0;t=0.0;A=0.0;C=0.0;z=0.0;y=0.0;v=0.0;u=0.0;s=0.0;while(1){L=+o[n+(j<<3)>>2];da=+o[n+(j<<3)+4>>2];ba=+o[i>>2];ca=+o[i+4>>2];z=z+(L*ba-da*ca);s=s+(da*ba+L*ca);ca=+o[i+8>>2];ba=+o[i+12>>2];C=C+(L*ca-da*ba);u=u+(da*ca+L*ba);ba=+o[i+16>>2];ca=+o[i+20>>2];A=A+(L*ba-da*ca);v=v+(da*ba+L*ca);ca=+o[i+24>>2];ba=+o[i+28>>2];t=t+(L*ca-da*ba);y=y+(da*ca+L*ba);j=j+1|0;if((j|0)==(q|0)){L=t;t=z;break}else i=i+(S<<3)|0}}else{L=0.0;A=0.0;C=0.0;t=0.0;y=0.0;v=0.0;u=0.0;s=0.0}t=t*l;s=s*l;if(!f){o[d+(b<<3)>>2]=t;o[d+(b<<3)+4>>2]=s;Q=b|1;o[d+(Q<<3)>>2]=C*l;o[d+(Q<<3)+4>>2]=u*l;Q=b|2;o[d+(Q<<3)>>2]=A*l;o[d+(Q<<3)+4>>2]=v*l;Q=b|3;o[d+(Q<<3)>>2]=L*l;o[d+(Q<<3)+4>>2]=y*l}else{da=s+ +o[f+4>>2]*m;o[d+(b<<3)>>2]=t+ +o[f>>2]*m;o[d+(b<<3)+4>>2]=da;Q=b|1;da=u*l+ +o[f+(U<<3)+4>>2]*m;o[d+(Q<<3)>>2]=C*l+ +o[f+(U<<3)>>2]*m;o[d+(Q<<3)+4>>2]=da;Q=b|2;da=v*l+ +o[f+(J<<3)+4>>2]*m;o[d+(Q<<3)>>2]=A*l+ +o[f+(J<<3)>>2]*m;o[d+(Q<<3)+4>>2]=da;Q=b|3;da=y*l+ +o[f+(K<<3)+4>>2]*m;o[d+(Q<<3)>>2]=L*l+ +o[f+(K<<3)>>2]*m;o[d+(Q<<3)+4>>2]=da}b=b+4|0;if((b|0)>(F|0)){i=w;j=M;break}else f=f+(I<<3)|0}}b:do if((j|0)<(X|0)){if(!H)while(1){if(!i){s=P;t=P}else{s=O+ +o[i+4>>2]*m;t=O+ +o[i>>2]*m}o[d+(j<<3)>>2]=t;o[d+(j<<3)+4>>2]=s;j=j+1|0;if((j|0)==(X|0))break b;else i=i+(U<<3)|0}while(1){f=c+(j<<3)|0;b=0;s=0.0;t=0.0;while(1){ca=+o[n+(b<<3)>>2];L=+o[n+(b<<3)+4>>2];ba=+o[f>>2];da=+o[f+4>>2];s=s+(ca*ba-L*da);t=t+(L*ba+ca*da);b=b+1|0;if((b|0)==(q|0))break;else f=f+(S<<3)|0}s=s*l;t=t*l;if(i){t=t+ +o[i+4>>2]*m;s=s+ +o[i>>2]*m}o[d+(j<<3)>>2]=s;o[d+(j<<3)+4>>2]=t;j=j+1|0;if((j|0)==(X|0))break;else i=i+(U<<3)|0}}while(0);D=D+1|0;if((D|0)==(W|0))break a;else{a=a+(R<<3)|0;B=B+(T<<3)|0;d=d+(V<<3)|0;w=w+(T<<3)|0}}}M=Q+8|0;zpb(M|0,0,1152)|0;k[Q>>2]=M;N=Q+4|0;k[N>>2]=72;if(X>>>0>72){j=X>>>0>268435455?-1:X<<4;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}zpb(i|0,0,X<<4|0)|0;k[Q>>2]=i}else i=M;k[N>>2]=X;if((W|0)>0){D=(h|0)==0;E=(X|0)>0;F=(q|0)>0;G=X+-4|0;H=(X|0)<4;I=X<<4;J=X&-4;K=D|(q|0)<1;d=e;B=0;w=g;while(1){if(K)b=D?a:h;else{j=0;do{n=a+((aa(j,x)|0)<<3)|0;e=k[n+4>>2]|0;g=h+(j<<3)|0;k[g>>2]=k[n>>2];k[g+4>>2]=e;j=j+1|0}while((j|0)!=(q|0));b=h}if(E)zpb(i|0,0,I|0)|0;if(F){f=c;n=0;while(1){s=+o[b+(n<<3)>>2];t=+o[b+(n<<3)+4>>2];if(H)j=0;else{j=0;do{da=+o[f+(j<<3)>>2];L=+o[f+(j<<3)+4>>2];e=i+(j<<4)|0;g=i+(j<<4)+8|0;ba=+p[g>>3]+(t*da+s*L);ea=j|1;ca=+o[f+(ea<<3)>>2];O=+o[f+(ea<<3)+4>>2];fa=i+(ea<<4)|0;ea=i+(ea<<4)+8|0;P=+p[fa>>3]+(s*ca-t*O);O=+p[ea>>3]+(t*ca+s*O);p[e>>3]=+p[e>>3]+(s*da-t*L);p[g>>3]=ba;p[fa>>3]=P;p[ea>>3]=O;ea=j|2;O=+o[f+(ea<<3)>>2];P=+o[f+(ea<<3)+4>>2];fa=i+(ea<<4)|0;ea=i+(ea<<4)+8|0;ba=+p[ea>>3]+(t*O+s*P);g=j|3;L=+o[f+(g<<3)>>2];da=+o[f+(g<<3)+4>>2];e=i+(g<<4)|0;g=i+(g<<4)+8|0;ca=+p[e>>3]+(s*L-t*da);da=+p[g>>3]+(t*L+s*da);p[fa>>3]=+p[fa>>3]+(s*O-t*P);p[ea>>3]=ba;p[e>>3]=ca;p[g>>3]=da;j=j+4|0}while((j|0)<=(G|0));j=J}if((j|0)<(X|0))do{ca=+o[f+(j<<3)>>2];da=+o[f+(j<<3)+4>>2];fa=i+(j<<4)|0;p[fa>>3]=+p[fa>>3]+(s*ca-t*da);fa=i+(j<<4)+8|0;p[fa>>3]=+p[fa>>3]+(t*ca+s*da);j=j+1|0}while((j|0)!=(X|0));n=n+1|0;if((n|0)==(q|0))break;else f=f+(S<<3)|0}}if(!d){if(E){j=0;do{da=+p[i+(j<<4)+8>>3]*l;o[w+(j<<3)>>2]=+p[i+(j<<4)>>3]*l;o[w+(j<<3)+4>>2]=da;j=j+1|0}while((j|0)!=(X|0))}}else if(E){j=0;f=d;while(1){da=+p[i+(j<<4)+8>>3]*l+ +o[f+4>>2]*m;o[w+(j<<3)>>2]=+p[i+(j<<4)>>3]*l+ +o[f>>2]*m;o[w+(j<<3)+4>>2]=da;j=j+1|0;if((j|0)==(X|0))break;else f=f+(U<<3)|0}}B=B+1|0;if((B|0)==(W|0))break;else{a=a+(R<<3)|0;d=d+(T<<3)|0;w=w+(V<<3)|0}}i=k[Q>>2]|0}if((i|0)!=(M|0)){if(i|0)ggb(i);k[Q>>2]=M;k[N>>2]=72}}while(0);i=k[_>>2]|0;if((i|0)==(Y|0)){r=$;return}if(i|0)ggb(i);k[_>>2]=Y;k[Z>>2]=136;r=$;return}function v_(a,b,c,d,e,f,g,h,i,j,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;l=+l;m=+m;n=n|0;var o=0.0,q=0.0,s=0.0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0.0,ba=0.0,ca=0,da=0;Z=r;r=r+2320|0;Y=Z+1160|0;O=Z;t=k[i>>2]|0;v=k[i+4>>2]|0;S=k[j>>2]|0;V=k[j+4>>2]|0;W=Y+8|0;zpb(W|0,0,1152)|0;k[Y>>2]=W;X=Y+4|0;k[X>>2]=72;y=b>>>4;Q=d>>>4;i=f>>>4;U=h>>>4;if(!e){R=0;T=0}else{T=(n&4|0)==0;R=T?1:i;T=T?i:1}do if(n&1)if(b>>>0>31&(v|0)>1){if(v>>>0<=72){k[X>>2]=v;i=y;j=1;h=W;t=v;f=v;G=12;break}j=v>>>0>268435455?-1:v<<4;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}zpb(i|0,0,v<<4|0)|0;k[Y>>2]=i;k[X>>2]=v;P=1;h=i;t=v;G=57}else{i=y;j=1;h=0;t=v;f=72;G=12}else{i=1;j=y;h=0;f=72;G=12}while(0);if((G|0)==12)if((t|0)==1){E=O+8|0;zpb(E|0,0,1152)|0;k[O>>2]=E;F=O+4|0;k[F>>2]=72;if(b>>>0>31&(v|0)>1){if(f>>>0<V>>>0)if(V>>>0>72){j=V>>>0>268435455?-1:V<<4;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}zpb(i|0,0,V<<4|0)|0;k[Y>>2]=i;k[X>>2]=V}else i=W;else{k[X>>2]=V;i=W}if((V|0)>0){j=0;do{P=i+(j<<4)|0;M=a+((aa(j,y)|0)<<4)|0;k[P>>2]=k[M>>2];k[P+4>>2]=k[M+4>>2];k[P+8>>2]=k[M+8>>2];k[P+12>>2]=k[M+12>>2];j=j+1|0}while((j|0)!=(V|0));D=i}else D=i}else D=a;if(d>>>0>31){if(S>>>0>72){j=S>>>0>268435455?-1:S<<4;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}zpb(i|0,0,S<<4|0)|0;k[O>>2]=i}else i=E;k[F>>2]=S;if((S|0)>0){j=0;do{P=i+(j<<4)|0;M=c+((aa(j,Q)|0)<<4)|0;k[P>>2]=k[M>>2];k[P+4>>2]=k[M+4>>2];k[P+8>>2]=k[M+8>>2];k[P+12>>2]=k[M+12>>2];j=j+1|0}while((j|0)!=(S|0))}}else i=c;a:do if((V|0)>0){y=R<<1;A=S+-2|0;if((S|0)<2){t=(S|0)==1;f=e;h=0;j=g;while(1){q=+p[D+(h<<4)>>3]*l;s=+p[D+(h<<4)+8>>3]*l;if(t){J=+p[i>>3];N=+p[i+8>>3];o=q*J-s*N;q=s*J+q*N;if(f){q=q+ +p[f+8>>3]*m;o=o+ +p[f>>3]*m}p[j>>3]=o;p[j+8>>3]=q}h=h+1|0;if((h|0)==(V|0))break a;else{f=f+(T<<4)|0;j=j+(U<<4)|0}}}b=A>>>1;a=(b<<1)+2|0;B=(a|0)<(S|0);v=e;d=0;n=g;b=e+(aa(R,(b<<5)+32|0)|0)|0;while(1){w=+p[D+(d<<4)>>3]*l;x=+p[D+(d<<4)+8>>3]*l;f=v;h=0;while(1){N=+p[i+(h<<4)>>3];u=+p[i+(h<<4)+8>>3];s=w*N-x*u;u=x*N+w*u;t=h|1;N=+p[i+(t<<4)>>3];q=+p[i+(t<<4)+8>>3];o=w*N-x*q;q=x*N+w*q;j=n+(h<<4)|0;if(!f){p[j>>3]=s;p[n+(h<<4)+8>>3]=u}else{N=u+ +p[f+8>>3]*m;p[j>>3]=s+ +p[f>>3]*m;p[n+(h<<4)+8>>3]=N;q=q+ +p[f+(R<<4)+8>>3]*m;o=o+ +p[f+(R<<4)>>3]*m}p[n+(t<<4)>>3]=o;p[n+(t<<4)+8>>3]=q;h=h+2|0;if((h|0)>(A|0))break;else f=f+(y<<4)|0}if(B){j=b;f=a;while(1){N=+p[i+(f<<4)>>3];q=+p[i+(f<<4)+8>>3];o=w*N-x*q;q=x*N+w*q;if(j){q=q+ +p[j+8>>3]*m;o=o+ +p[j>>3]*m}p[n+(f<<4)>>3]=o;p[n+(f<<4)+8>>3]=q;f=f+1|0;if((f|0)==(S|0))break;else j=j+(R<<4)|0}}d=d+1|0;if((d|0)==(V|0))break;else{v=v+(T<<4)|0;n=n+(U<<4)|0;b=b+(T<<4)|0}}}while(0);i=k[O>>2]|0;if((i|0)!=(E|0)){if(i|0)ggb(i);k[O>>2]=E;k[F>>2]=72}}else{y=i;P=j;G=57}b:do if((G|0)==57){if(n&2|0){if((V|0)<=0)break;B=(h|0)==0;D=t+-4|0;E=(t|0)<4;F=t&-4;H=B|(t|0)<1;G=(S|0)>0;d=e;A=0;v=g;while(1){if(H)j=B?a:h;else{i=0;do{O=h+(i<<4)|0;g=a+((aa(i,y)|0)<<4)|0;k[O>>2]=k[g>>2];k[O+4>>2]=k[g+4>>2];k[O+8>>2]=k[g+8>>2];k[O+12>>2]=k[g+12>>2];i=i+1|0}while((i|0)!=(t|0));j=h}if(G){f=c;b=d;n=0;while(1){if(E){i=0;s=0.0;z=0.0;w=0.0;o=0.0;q=0.0;C=0.0;x=0.0;u=0.0}else{i=0;s=0.0;z=0.0;w=0.0;o=0.0;q=0.0;C=0.0;x=0.0;u=0.0;do{J=+p[j+(i<<4)>>3];$=+p[j+(i<<4)+8>>3];_=+p[f+(i<<4)>>3];N=+p[f+(i<<4)+8>>3];o=o+(J*_-$*N);q=q+($*_+J*N);O=i|1;N=+p[j+(O<<4)>>3];J=+p[j+(O<<4)+8>>3];_=+p[f+(O<<4)>>3];$=+p[f+(O<<4)+8>>3];w=w+(N*_-J*$);u=u+(J*_+N*$);O=i|2;$=+p[j+(O<<4)>>3];N=+p[j+(O<<4)+8>>3];_=+p[f+(O<<4)>>3];J=+p[f+(O<<4)+8>>3];z=z+($*_-N*J);x=x+(N*_+$*J);O=i|3;J=+p[j+(O<<4)>>3];$=+p[j+(O<<4)+8>>3];_=+p[f+(O<<4)>>3];N=+p[f+(O<<4)+8>>3];s=s+(J*_-$*N);C=C+($*_+J*N);i=i+4|0}while((i|0)<=(D|0));i=F}if((i|0)<(t|0))do{_=+p[j+(i<<4)>>3];J=+p[j+(i<<4)+8>>3];N=+p[f+(i<<4)>>3];$=+p[f+(i<<4)+8>>3];o=o+(_*N-J*$);q=q+(J*N+_*$);i=i+1|0}while((i|0)!=(t|0));o=(s+(z+(w+o)))*l;q=(C+(x+(u+q)))*l;if(b){q=q+ +p[b+8>>3]*m;o=o+ +p[b>>3]*m}p[v+(n<<4)>>3]=o;p[v+(n<<4)+8>>3]=q;n=n+1|0;if((n|0)==(S|0))break;else{f=f+(Q<<4)|0;b=b+(R<<4)|0}}}A=A+1|0;if((A|0)==(V|0))break b;else{a=a+(P<<4)|0;d=d+(T<<4)|0;v=v+(U<<4)|0}}}K=S<<4;if(K>>>0<1601){if((V|0)<=0)break;D=(h|0)==0;E=S+-4|0;F=(S|0)<4;G=(t|0)>0;H=R<<2;I=R<<1;K=R*3|0;v=E>>>2;L=(v<<2)+4|0;M=D|(t|0)<1;N=l*0.0;A=e;B=0;d=g;v=e+(aa(R,(v<<6)+64|0)|0)|0;while(1){if(M)n=D?a:h;else{i=0;do{O=h+(i<<4)|0;g=a+((aa(i,y)|0)<<4)|0;k[O>>2]=k[g>>2];k[O+4>>2]=k[g+4>>2];k[O+8>>2]=k[g+8>>2];k[O+12>>2]=k[g+12>>2];i=i+1|0}while((i|0)!=(t|0));n=h}if(F){i=A;j=0}else{f=A;b=0;while(1){if(G){i=c+(b<<4)|0;j=0;z=0.0;q=0.0;C=0.0;x=0.0;o=0.0;w=0.0;u=0.0;s=0.0;while(1){_=+p[n+(j<<4)>>3];ba=+p[n+(j<<4)+8>>3];$=+p[i>>3];J=+p[i+8>>3];z=z+(_*$-ba*J);o=o+(ba*$+_*J);J=+p[i+16>>3];$=+p[i+24>>3];x=x+(_*J-ba*$);s=s+(ba*J+_*$);$=+p[i+32>>3];J=+p[i+40>>3];C=C+(_*$-ba*J);u=u+(ba*$+_*J);J=+p[i+48>>3];$=+p[i+56>>3];q=q+(_*J-ba*$);w=w+(ba*J+_*$);j=j+1|0;if((j|0)==(t|0)){J=q;break}else i=i+(Q<<4)|0}}else{z=0.0;J=0.0;C=0.0;x=0.0;o=0.0;w=0.0;u=0.0;s=0.0}q=z*l;o=o*l;if(!f){p[d+(b<<4)>>3]=q;p[d+(b<<4)+8>>3]=o;O=b|1;p[d+(O<<4)>>3]=x*l;p[d+(O<<4)+8>>3]=s*l;O=b|2;p[d+(O<<4)>>3]=C*l;p[d+(O<<4)+8>>3]=u*l;O=b|3;p[d+(O<<4)>>3]=J*l;p[d+(O<<4)+8>>3]=w*l}else{ba=o+ +p[f+8>>3]*m;p[d+(b<<4)>>3]=q+ +p[f>>3]*m;p[d+(b<<4)+8>>3]=ba;O=b|1;ba=s*l+ +p[f+(R<<4)+8>>3]*m;p[d+(O<<4)>>3]=x*l+ +p[f+(R<<4)>>3]*m;p[d+(O<<4)+8>>3]=ba;O=b|2;ba=u*l+ +p[f+(I<<4)+8>>3]*m;p[d+(O<<4)>>3]=C*l+ +p[f+(I<<4)>>3]*m;p[d+(O<<4)+8>>3]=ba;O=b|3;ba=w*l+ +p[f+(K<<4)+8>>3]*m;p[d+(O<<4)>>3]=J*l+ +p[f+(K<<4)>>3]*m;p[d+(O<<4)+8>>3]=ba}b=b+4|0;if((b|0)>(E|0)){i=v;j=L;break}else f=f+(H<<4)|0}}c:do if((j|0)<(S|0)){if(!G)while(1){if(!i){o=N;q=N}else{o=N+ +p[i+8>>3]*m;q=N+ +p[i>>3]*m}p[d+(j<<4)>>3]=q;p[d+(j<<4)+8>>3]=o;j=j+1|0;if((j|0)==(S|0))break c;else i=i+(R<<4)|0}while(1){f=c+(j<<4)|0;b=0;o=0.0;q=0.0;while(1){$=+p[n+(b<<4)>>3];J=+p[n+(b<<4)+8>>3];_=+p[f>>3];ba=+p[f+8>>3];o=o+($*_-J*ba);q=q+(J*_+$*ba);b=b+1|0;if((b|0)==(t|0))break;else f=f+(Q<<4)|0}o=o*l;q=q*l;if(i){q=q+ +p[i+8>>3]*m;o=o+ +p[i>>3]*m}p[d+(j<<4)>>3]=o;p[d+(j<<4)+8>>3]=q;j=j+1|0;if((j|0)==(S|0))break;else i=i+(R<<4)|0}}while(0);B=B+1|0;if((B|0)==(V|0))break b;else{a=a+(P<<4)|0;A=A+(T<<4)|0;d=d+(U<<4)|0;v=v+(T<<4)|0}}}L=O+8|0;zpb(L|0,0,1152)|0;k[O>>2]=L;M=O+4|0;k[M>>2]=72;if(S>>>0>72){j=S>>>0>268435455?-1:S<<4;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}zpb(i|0,0,K|0)|0;k[O>>2]=i}else i=L;k[M>>2]=S;if((V|0)>0){B=(h|0)==0;D=(S|0)>0;E=(t|0)>0;F=S+-4|0;G=(S|0)<4;H=S&-4;I=B|(t|0)<1;d=e;A=0;v=g;while(1){if(I)b=B?a:h;else{j=0;do{g=h+(j<<4)|0;e=a+((aa(j,y)|0)<<4)|0;k[g>>2]=k[e>>2];k[g+4>>2]=k[e+4>>2];k[g+8>>2]=k[e+8>>2];k[g+12>>2]=k[e+12>>2];j=j+1|0}while((j|0)!=(t|0));b=h}if(D)zpb(i|0,0,K|0)|0;if(E){f=c;n=0;while(1){o=+p[b+(n<<4)>>3];q=+p[b+(n<<4)+8>>3];if(G)j=0;else{j=0;do{ba=+p[f+(j<<4)>>3];C=+p[f+(j<<4)+8>>3];e=i+(j<<4)|0;g=i+(j<<4)+8|0;_=+p[g>>3]+(q*ba+o*C);ca=j|1;$=+p[f+(ca<<4)>>3];J=+p[f+(ca<<4)+8>>3];da=i+(ca<<4)|0;ca=i+(ca<<4)+8|0;N=+p[da>>3]+(o*$-q*J);J=+p[ca>>3]+(q*$+o*J);p[e>>3]=+p[e>>3]+(o*ba-q*C);p[g>>3]=_;p[da>>3]=N;p[ca>>3]=J;ca=j|2;J=+p[f+(ca<<4)>>3];N=+p[f+(ca<<4)+8>>3];da=i+(ca<<4)|0;ca=i+(ca<<4)+8|0;_=+p[ca>>3]+(q*J+o*N);g=j|3;C=+p[f+(g<<4)>>3];ba=+p[f+(g<<4)+8>>3];e=i+(g<<4)|0;g=i+(g<<4)+8|0;$=+p[e>>3]+(o*C-q*ba);ba=+p[g>>3]+(q*C+o*ba);p[da>>3]=+p[da>>3]+(o*J-q*N);p[ca>>3]=_;p[e>>3]=$;p[g>>3]=ba;j=j+4|0}while((j|0)<=(F|0));j=H}if((j|0)<(S|0))do{$=+p[f+(j<<4)>>3];ba=+p[f+(j<<4)+8>>3];da=i+(j<<4)|0;p[da>>3]=+p[da>>3]+(o*$-q*ba);da=i+(j<<4)+8|0;p[da>>3]=q*$+o*ba+ +p[da>>3];j=j+1|0}while((j|0)!=(S|0));n=n+1|0;if((n|0)==(t|0))break;else f=f+(Q<<4)|0}}if(!d){if(D){j=0;do{ba=+p[i+(j<<4)+8>>3]*l;p[v+(j<<4)>>3]=+p[i+(j<<4)>>3]*l;p[v+(j<<4)+8>>3]=ba;j=j+1|0}while((j|0)!=(S|0))}}else if(D){j=0;f=d;while(1){ba=+p[i+(j<<4)+8>>3]*l+ +p[f+8>>3]*m;p[v+(j<<4)>>3]=+p[i+(j<<4)>>3]*l+ +p[f>>3]*m;p[v+(j<<4)+8>>3]=ba;j=j+1|0;if((j|0)==(S|0))break;else f=f+(R<<4)|0}}A=A+1|0;if((A|0)==(V|0))break;else{a=a+(P<<4)|0;d=d+(T<<4)|0;v=v+(U<<4)|0}}i=k[O>>2]|0}if((i|0)!=(L|0)){if(i|0)ggb(i);k[O>>2]=L;k[M>>2]=72}}while(0);i=k[Y>>2]|0;if((i|0)==(W|0)){r=Z;return}if(i|0)ggb(i);k[Y>>2]=W;k[X>>2]=72;r=Z;return}function w_(a,b,c,d,e,f,g,h,i,j,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;l=+l;m=+m;n=n|0;var q=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0;W=r;r=r+2160|0;V=W+1096|0;L=W;u=k[i>>2]|0;v=k[i+4>>2]|0;O=k[j>>2]|0;S=k[j+4>>2]|0;T=V+8|0;k[V>>2]=T;U=V+4|0;k[U>>2]=264;x=b>>>2;N=d>>>2;i=f>>>2;R=h>>>2;if(!e){P=0;Q=0}else{Q=(n&4|0)==0;P=Q?1:i;Q=Q?i:1}do if(n&1)if(b>>>0>7&(v|0)>1){if(v>>>0<=264){k[U>>2]=v;j=x;f=1;i=T;u=v;h=v;B=12;break}j=v>>>0>1073741823?-1:v<<2;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}k[V>>2]=i;k[U>>2]=v;M=1;u=v;B=64}else{j=x;f=1;i=0;u=v;h=264;B=12}else{j=1;f=x;i=0;h=264;B=12}while(0);if((B|0)==12)if((u|0)==1){z=L+8|0;k[L>>2]=z;A=L+4|0;k[A>>2]=264;if(b>>>0>7&(v|0)>1){if(h>>>0<S>>>0)if(S>>>0>264){j=S>>>0>1073741823?-1:S<<2;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}k[V>>2]=i;k[U>>2]=S}else i=T;else{k[U>>2]=S;i=T}if((S|0)>0){j=0;do{M=a+((aa(j,x)|0)<<2)|0;k[i+(j<<2)>>2]=k[M>>2];j=j+1|0}while((j|0)!=(S|0));y=i}else y=i}else y=a;if(d>>>0>7){if(O>>>0>264){j=O>>>0>1073741823?-1:O<<2;j=(j|0)==0?1:j;while(1){i=fgb(j)|0;if(i|0)break;i=k[207666]|0;k[207666]=i+0;if(!i){i=0;break}Qh[i&7]()}k[L>>2]=i}else i=z;k[A>>2]=O;if((O|0)>0){j=0;do{M=c+((aa(j,N)|0)<<2)|0;k[i+(j<<2)>>2]=k[M>>2];j=j+1|0}while((j|0)!=(O|0));x=i}else x=i}else x=c;a:do if((S|0)>0){v=P<<1;if((O|0)<2){if((O|0)==1){j=g;f=0;i=e}else break;while(1){q=+o[y+(f<<2)>>2]*l*+o[x>>2];if(i)q=q+ +o[i>>2]*m;o[j>>2]=q;f=f+1|0;if((f|0)==(S|0))break a;else{j=j+(R<<2)|0;i=i+(Q<<2)|0}}}d=O+-2|0;n=((d|0)>1?d:1)>>>1;b=aa(v,n)|0;n=(n<<1)+2|0;if((n|0)>=(O|0)){i=0;while(1){t=+o[y+(i<<2)>>2]*l;j=e;f=0;while(1){s=t*+o[x+(f<<2)>>2];h=f|1;q=t*+o[x+(h<<2)>>2];if(!j)o[g+(f<<2)>>2]=s;else{o[g+(f<<2)>>2]=s+ +o[j>>2]*m;q=q+ +o[j+(P<<2)>>2]*m}o[g+(h<<2)>>2]=q;f=f+2|0;if((f|0)>(d|0))break;else j=j+(v<<2)|0}i=i+1|0;if((i|0)==(S|0))break a;g=g+(R<<2)|0;e=e+(Q<<2)|0}}i=0;u=e;e=e+(v<<2)|0;while(1){t=+o[y+(i<<2)>>2]*l;j=u;f=0;while(1){s=t*+o[x+(f<<2)>>2];h=f|1;q=t*+o[x+(h<<2)>>2];if(!j)o[g+(f<<2)>>2]=s;else{o[g+(f<<2)>>2]=s+ +o[j>>2]*m;q=q+ +o[j+(P<<2)>>2]*m}o[g+(h<<2)>>2]=q;f=f+2|0;if((f|0)>(d|0))break;else j=j+(v<<2)|0}j=e+(b<<2)|0;f=n;while(1){q=t*+o[x+(f<<2)>>2];if(j)q=q+ +o[j>>2]*m;o[g+(f<<2)>>2]=q;f=f+1|0;if((f|0)==(O|0))break;else j=j+(P<<2)|0}i=i+1|0;if((i|0)==(S|0))break a;g=g+(R<<2)|0;u=u+(Q<<2)|0;e=e+(Q<<2)|0}}while(0);i=k[L>>2]|0;if((i|0)!=(z|0)){if(i|0)ggb(i);k[L>>2]=z;k[A>>2]=264}}else{x=j;M=f;B=64}b:do if((B|0)==64){if(n&2|0){if((S|0)<=0)break;y=(i|0)==0;z=(O|0)>0;A=u+-4|0;B=(u|0)<4;C=u&-4;F=y|(u|0)<1;D=(u|0)>0;E=(C|0)<(u|0);H=l*0.0;d=a;v=0;while(1){if(F)n=y?d:i;else{j=0;do{L=d+((aa(j,x)|0)<<2)|0;k[i+(j<<2)>>2]=k[L>>2];j=j+1|0}while((j|0)!=(u|0));n=i}c:do if(z){if(!B){f=c;h=e;b=0;while(1){s=0.0;t=0.0;w=0.0;q=0.0;j=0;do{q=q+ +o[n+(j<<2)>>2]*+o[f+(j<<2)>>2];L=j|1;w=w+ +o[n+(L<<2)>>2]*+o[f+(L<<2)>>2];L=j|2;t=t+ +o[n+(L<<2)>>2]*+o[f+(L<<2)>>2];L=j|3;s=s+ +o[n+(L<<2)>>2]*+o[f+(L<<2)>>2];j=j+4|0}while((j|0)<=(A|0));if(E){j=C;do{q=q+ +o[n+(j<<2)>>2]*+o[f+(j<<2)>>2];j=j+1|0}while((j|0)!=(u|0))}q=(s+(t+(w+q)))*l;if(h)q=q+ +o[h>>2]*m;o[g+(b<<2)>>2]=q;b=b+1|0;if((b|0)==(O|0))break c;else{f=f+(N<<2)|0;h=h+(P<<2)|0}}}if(D){f=c;h=e;b=0}else{j=e;f=0;while(1){if(!j)q=H;else q=H+ +o[j>>2]*m;o[g+(f<<2)>>2]=q;f=f+1|0;if((f|0)==(O|0))break c;else j=j+(P<<2)|0}}while(1){q=0.0;j=0;do{q=q+ +o[n+(j<<2)>>2]*+o[f+(j<<2)>>2];j=j+1|0}while((j|0)!=(u|0));q=(q+0.0)*l;if(h)q=q+ +o[h>>2]*m;o[g+(b<<2)>>2]=q;b=b+1|0;if((b|0)==(O|0))break;else{f=f+(N<<2)|0;h=h+(P<<2)|0}}}while(0);v=v+1|0;if((v|0)==(S|0))break b;else{d=d+(M<<2)|0;g=g+(R<<2)|0;e=e+(Q<<2)|0}}}if(O<<2>>>0<1601){if((S|0)<=0)break;z=(i|0)==0;A=O+-4|0;B=(O|0)<4;C=(u|0)>0;D=P<<2;E=P<<1;F=P*3|0;n=A>>>2;G=(n<<2)+4|0;I=z|(u|0)<1;H=l*0.0;K=H;y=a;v=0;d=e;n=e+(aa(P,(n<<4)+16|0)|0)|0;while(1){if(I)b=z?y:i;else{j=0;do{L=y+((aa(j,x)|0)<<2)|0;k[i+(j<<2)>>2]=k[L>>2];j=j+1|0}while((j|0)!=(u|0));b=i}d:do if(B){j=d;f=0}else{if(C){h=d;e=0}else{j=d;f=0;while(1){if(!j){o[g+(f<<2)>>2]=K;o[g+((f|1)<<2)>>2]=K;o[g+((f|2)<<2)>>2]=K;o[g+((f|3)<<2)>>2]=K}else{o[g+(f<<2)>>2]=H+ +o[j>>2]*m;o[g+((f|1)<<2)>>2]=H+ +o[j+(P<<2)>>2]*m;o[g+((f|2)<<2)>>2]=H+ +o[j+(E<<2)>>2]*m;o[g+((f|3)<<2)>>2]=H+ +o[j+(F<<2)>>2]*m}f=f+4|0;if((f|0)>(A|0)){j=n;f=G;break d}else j=j+(D<<2)|0}}while(1){s=0.0;t=0.0;w=0.0;q=0.0;j=c+(e<<2)|0;f=0;while(1){X=+o[b+(f<<2)>>2];q=q+X*+o[j>>2];w=w+X*+o[j+4>>2];t=t+X*+o[j+8>>2];s=s+X*+o[j+12>>2];f=f+1|0;if((f|0)==(u|0))break;else j=j+(N<<2)|0}q=q*l;if(!h){o[g+(e<<2)>>2]=q;o[g+((e|1)<<2)>>2]=w*l;o[g+((e|2)<<2)>>2]=t*l;o[g+((e|3)<<2)>>2]=s*l}else{o[g+(e<<2)>>2]=q+ +o[h>>2]*m;o[g+((e|1)<<2)>>2]=w*l+ +o[h+(P<<2)>>2]*m;o[g+((e|2)<<2)>>2]=t*l+ +o[h+(E<<2)>>2]*m;o[g+((e|3)<<2)>>2]=s*l+ +o[h+(F<<2)>>2]*m}e=e+4|0;if((e|0)>(A|0)){j=n;f=G;break}else h=h+(D<<2)|0}}while(0);e:do if((f|0)<(O|0)){if(!C)while(1){if(!j)q=H;else q=H+ +o[j>>2]*m;o[g+(f<<2)>>2]=q;f=f+1|0;if((f|0)==(O|0))break e;else j=j+(P<<2)|0}while(1){q=0.0;h=c+(f<<2)|0;e=0;while(1){q=q+ +o[b+(e<<2)>>2]*+o[h>>2];e=e+1|0;if((e|0)==(u|0))break;else h=h+(N<<2)|0}q=q*l;if(j)q=q+ +o[j>>2]*m;o[g+(f<<2)>>2]=q;f=f+1|0;if((f|0)==(O|0))break;else j=j+(P<<2)|0}}while(0);v=v+1|0;if((v|0)==(S|0))break b;else{y=y+(M<<2)|0;g=g+(R<<2)|0;d=d+(Q<<2)|0;n=n+(Q<<2)|0}}}I=L+8|0;k[L>>2]=I;J=L+4|0;k[J>>2]=136;if(O>>>0>136){f=O>>>0>536870911?-1:O<<3;f=(f|0)==0?1:f;while(1){j=fgb(f)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}k[L>>2]=j}else j=I;k[J>>2]=O;if((S|0)>0){y=(i|0)==0;z=(O|0)>0;A=(u|0)>0;B=O+-4|0;C=(O|0)<4;D=O<<3;E=O&-4;G=y|(u|0)<1;F=(E|0)<(O|0);d=a;v=0;while(1){if(G)n=y?d:i;else{f=0;do{a=d+((aa(f,x)|0)<<2)|0;k[i+(f<<2)>>2]=k[a>>2];f=f+1|0}while((f|0)!=(u|0));n=i}if(z)zpb(j|0,0,D|0)|0;f:do if(A){if(C){if(z){f=c;h=0}else break;while(1){q=+o[n+(h<<2)>>2];b=0;do{a=j+(b<<3)|0;p[a>>3]=+p[a>>3]+q*+o[f+(b<<2)>>2];b=b+1|0}while((b|0)!=(O|0));h=h+1|0;if((h|0)==(u|0))break f;else f=f+(N<<2)|0}}if(F){h=c;b=0}else{f=c;b=0;while(1){q=+o[n+(b<<2)>>2];h=0;do{Y=j+(h<<3)|0;_=h|1;Z=j+(_<<3)|0;X=+p[Z>>3]+q*+o[f+(_<<2)>>2];p[Y>>3]=+p[Y>>3]+q*+o[f+(h<<2)>>2];p[Z>>3]=X;Z=h|2;Y=j+(Z<<3)|0;_=h|3;a=j+(_<<3)|0;X=+p[a>>3]+q*+o[f+(_<<2)>>2];p[Y>>3]=+p[Y>>3]+q*+o[f+(Z<<2)>>2];p[a>>3]=X;h=h+4|0}while((h|0)<=(B|0));b=b+1|0;if((b|0)==(u|0))break f;else f=f+(N<<2)|0}}while(1){q=+o[n+(b<<2)>>2];f=0;do{Z=j+(f<<3)|0;a=f|1;Y=j+(a<<3)|0;X=+p[Y>>3]+q*+o[h+(a<<2)>>2];p[Z>>3]=+p[Z>>3]+q*+o[h+(f<<2)>>2];p[Y>>3]=X;Y=f|2;Z=j+(Y<<3)|0;a=f|3;_=j+(a<<3)|0;X=+p[_>>3]+q*+o[h+(a<<2)>>2];p[Z>>3]=+p[Z>>3]+q*+o[h+(Y<<2)>>2];p[_>>3]=X;f=f+4|0}while((f|0)<=(B|0));f=E;do{_=j+(f<<3)|0;p[_>>3]=+p[_>>3]+q*+o[h+(f<<2)>>2];f=f+1|0}while((f|0)!=(O|0));b=b+1|0;if((b|0)==(u|0))break;else h=h+(N<<2)|0}}while(0);if(!e){if(z){f=0;do{o[g+(f<<2)>>2]=+p[j+(f<<3)>>3]*l;f=f+1|0}while((f|0)!=(O|0))}}else if(z){f=0;h=e;while(1){o[g+(f<<2)>>2]=+p[j+(f<<3)>>3]*l+ +o[h>>2]*m;f=f+1|0;if((f|0)==(O|0))break;else h=h+(P<<2)|0}}v=v+1|0;if((v|0)==(S|0))break;else{d=d+(M<<2)|0;g=g+(R<<2)|0;e=e+(Q<<2)|0}}}if((j|0)!=(I|0)){ggb(j);k[L>>2]=I;k[J>>2]=136}}while(0);i=k[V>>2]|0;if((i|0)==(T|0)){r=W;return}if(i|0)ggb(i);k[V>>2]=T;k[U>>2]=264;r=W;return}function x_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0;P=r;r=r+1104|0;O=P;j=k[g>>2]|0;l=k[g+4>>2]|0;N=k[h>>2]|0;K=k[h+4>>2]|0;L=O+8|0;k[O>>2]=L;M=O+4|0;k[M>>2]=136;s=i&16;b=b>>>3;J=d>>>3;I=f>>>3;if(!(i&1)){H=1;G=0;F=L}else{if(l>>>0>136){h=l>>>0>536870911?-1:l<<3;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[O>>2]=g}else g=L;k[M>>2]=l;H=b;b=1;G=g;j=l;F=g}g=(K|0)>0;if(!(i&2)){if(g){C=(G|0)==0;D=N+-4|0;E=(N|0)<4;x=(s|0)==0;y=(j|0)>0;z=N&-4;B=(j|0)<1|C;A=(D>>>2<<5)+32|0;v=e;w=0;u=a;while(1){a=e+((aa(I,w)|0)<<3)|0;if(B)t=C?u:G;else{g=0;do{t=u+((aa(g,H)|0)<<3)|0;p[G+(g<<3)>>3]=+p[t>>3];g=g+1|0}while((g|0)!=(j|0));t=G}a:do if(E)g=0;else{if(!x){if(y)h=0;else{g=z;break}while(1){f=v+((h|3)<<3)|0;l=v+((h|2)<<3)|0;i=v+((h|1)<<3)|0;s=v+(h<<3)|0;g=c+(h<<3)|0;m=+p[f>>3];n=+p[l>>3];o=+p[i>>3];q=+p[s>>3];d=0;while(1){Q=+p[t+(d<<3)>>3];q=q+Q*+p[g>>3];o=o+Q*+p[g+8>>3];n=n+Q*+p[g+16>>3];m=m+Q*+p[g+24>>3];d=d+1|0;if((d|0)==(j|0))break;else g=g+(J<<3)|0}p[s>>3]=q;p[i>>3]=o;p[l>>3]=n;p[f>>3]=m;h=h+4|0;if((h|0)>(D|0)){g=z;break a}}}if(y)h=0;else{zpb(a|0,0,A|0)|0;g=z;break}do{g=c+(h<<3)|0;m=0.0;n=0.0;o=0.0;q=0.0;d=0;while(1){Q=+p[t+(d<<3)>>3];q=q+Q*+p[g>>3];o=o+Q*+p[g+8>>3];n=n+Q*+p[g+16>>3];m=m+Q*+p[g+24>>3];d=d+1|0;if((d|0)==(j|0))break;else g=g+(J<<3)|0}p[v+(h<<3)>>3]=q;p[v+((h|1)<<3)>>3]=o;p[v+((h|2)<<3)>>3]=n;p[v+((h|3)<<3)>>3]=m;h=h+4|0}while((h|0)<=(D|0));g=z}while(0);b:do if((N|0)>(g|0)){if(!x){if(!y)break;while(1){f=v+(g<<3)|0;h=c+(g<<3)|0;m=+p[f>>3];d=0;while(1){m=m+ +p[t+(d<<3)>>3]*+p[h>>3];d=d+1|0;if((d|0)==(j|0))break;else h=h+(J<<3)|0}p[f>>3]=m;g=g+1|0;if((g|0)==(N|0))break b}}if(!y){zpb(a+(g<<3)|0,0,N-g<<3|0)|0;break}do{h=c+(g<<3)|0;m=0.0;d=0;while(1){m=m+ +p[t+(d<<3)>>3]*+p[h>>3];d=d+1|0;if((d|0)==(j|0))break;else h=h+(J<<3)|0}p[v+(g<<3)>>3]=m;g=g+1|0}while((g|0)!=(N|0))}while(0);w=w+1|0;if((w|0)==(K|0))break;else{v=v+(I<<3)|0;u=u+(b<<3)|0}}}}else if(g){A=(G|0)==0;B=(N|0)>0;t=(s|0)==0;u=j+-2|0;v=(j|0)<2;w=j&-2;z=(j|0)<1|A;x=(j|0)>0;y=(w|0)<(j|0);i=e;s=0;while(1){if(z)l=A?a:G;else{g=0;do{e=a+((aa(g,H)|0)<<3)|0;p[G+(g<<3)>>3]=+p[e>>3];g=g+1|0}while((g|0)!=(j|0));l=G}c:do if(B){if(t){if(v){h=c;d=0;while(1){if(x){m=0.0;g=0;do{m=m+ +p[l+(g<<3)>>3]*+p[h+(g<<3)>>3];g=g+1|0}while((g|0)!=(j|0))}else m=0.0;p[i+(d<<3)>>3]=m+0.0;d=d+1|0;if((d|0)==(N|0))break c;else h=h+(J<<3)|0}}else{h=c;d=0}while(1){n=0.0;m=0.0;g=0;do{m=m+ +p[l+(g<<3)>>3]*+p[h+(g<<3)>>3];e=g|1;n=n+ +p[l+(e<<3)>>3]*+p[h+(e<<3)>>3];g=g+2|0}while((g|0)<=(u|0));if(y){g=w;do{m=m+ +p[l+(g<<3)>>3]*+p[h+(g<<3)>>3];g=g+1|0}while((g|0)!=(j|0))}p[i+(d<<3)>>3]=n+m;d=d+1|0;if((d|0)==(N|0))break c;else h=h+(J<<3)|0}}if(v){if(x){g=c;h=0}else{g=0;while(1){e=i+(g<<3)|0;p[e>>3]=+p[e>>3]+0.0;g=g+1|0;if((g|0)==(N|0))break c}}while(1){f=i+(h<<3)|0;m=+p[f>>3];d=0;do{m=m+ +p[l+(d<<3)>>3]*+p[g+(d<<3)>>3];d=d+1|0}while((d|0)!=(j|0));p[f>>3]=m+0.0;h=h+1|0;if((h|0)==(N|0))break c;else g=g+(J<<3)|0}}if(y){h=c;d=0}else{g=c;h=0;while(1){f=i+(h<<3)|0;m=0.0;n=+p[f>>3];d=0;do{n=n+ +p[l+(d<<3)>>3]*+p[g+(d<<3)>>3];e=d|1;m=m+ +p[l+(e<<3)>>3]*+p[g+(e<<3)>>3];d=d+2|0}while((d|0)<=(u|0));p[f>>3]=m+n;h=h+1|0;if((h|0)==(N|0))break c;else g=g+(J<<3)|0}}while(1){f=i+(d<<3)|0;n=0.0;m=+p[f>>3];g=0;do{m=m+ +p[l+(g<<3)>>3]*+p[h+(g<<3)>>3];e=g|1;n=n+ +p[l+(e<<3)>>3]*+p[h+(e<<3)>>3];g=g+2|0}while((g|0)<=(u|0));g=w;do{m=m+ +p[l+(g<<3)>>3]*+p[h+(g<<3)>>3];g=g+1|0}while((g|0)!=(j|0));p[f>>3]=n+m;d=d+1|0;if((d|0)==(N|0))break;else h=h+(J<<3)|0}}while(0);s=s+1|0;if((s|0)==(K|0))break;else{i=i+(I<<3)|0;a=a+(b<<3)|0}}}if((F|0)==(L|0)){r=P;return}ggb(F);k[O>>2]=L;k[M>>2]=136;r=P;return}function y_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0.0,n=0.0,q=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0.0,V=0.0;R=r;r=r+1104|0;Q=R;j=k[g>>2]|0;l=k[g+4>>2]|0;N=k[h>>2]|0;M=k[h+4>>2]|0;O=Q+8|0;zpb(O|0,0,1088)|0;k[Q>>2]=O;P=Q+4|0;k[P>>2]=136;q=i&16;b=b>>>3;L=d>>>3;K=f>>>4;if(!(i&1)){J=1;g=0}else{if(l>>>0>136){h=l>>>0>536870911?-1:l<<3;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}zpb(g|0,0,l<<3|0)|0;k[Q>>2]=g}else g=O;k[P>>2]=l;J=b;b=1;j=l}h=(M|0)>0;if(!(i&2)){if(h){E=(g|0)==0;F=N+-4|0;G=(N|0)<4;A=(q|0)==0;B=(j|0)>0;C=N&-4;D=(j|0)<1|E;y=e;z=0;while(1){l=e+((aa(K,z)|0)<<4)|0;if(D)q=E?a:g;else{h=0;do{q=a+((aa(h,J)|0)<<3)|0;H=k[q+4>>2]|0;I=g+(h<<3)|0;k[I>>2]=k[q>>2];k[I+4>>2]=H;h=h+1|0}while((h|0)!=(j|0));q=g}if(G)h=0;else{f=0;do{if(A){n=0.0;t=0.0;v=0.0;x=0.0;w=0.0;u=0.0;s=0.0;m=0.0}else{H=f|1;I=f|2;i=f|3;n=+p[y+(H<<4)>>3];t=+p[y+(f<<4)>>3];v=+p[y+(i<<4)>>3];x=+p[y+(I<<4)>>3];w=+p[y+(i<<4)+8>>3];u=+p[y+(H<<4)+8>>3];s=+p[y+(I<<4)+8>>3];m=+p[y+(f<<4)+8>>3]}if(B){h=c+(f<<3)|0;d=0;while(1){T=+o[q+(d<<3)>>2];V=+o[q+(d<<3)+4>>2];S=+o[h>>2];U=+o[h+4>>2];t=t+(T*S-V*U);m=m+(V*S+T*U);U=+o[h+8>>2];S=+o[h+12>>2];n=n+(T*U-V*S);u=u+(V*U+T*S);S=+o[h+16>>2];U=+o[h+20>>2];x=x+(T*S-V*U);s=s+(V*S+T*U);U=+o[h+24>>2];S=+o[h+28>>2];v=v+(T*U-V*S);w=w+(V*U+T*S);d=d+1|0;if((d|0)==(j|0))break;else h=h+(L<<3)|0}}p[y+(f<<4)>>3]=t;p[y+(f<<4)+8>>3]=m;I=f|1;p[y+(I<<4)>>3]=n;p[y+(I<<4)+8>>3]=u;I=f|2;p[y+(I<<4)>>3]=x;p[y+(I<<4)+8>>3]=s;I=f|3;p[y+(I<<4)>>3]=v;p[y+(I<<4)+8>>3]=w;f=f+4|0}while((f|0)<=(F|0));h=C}a:do if((N|0)>(h|0)){if(!A){if(!B)break;while(1){i=y+(h<<4)+8|0;l=y+(h<<4)|0;d=c+(h<<3)|0;f=0;m=+p[l>>3];n=+p[i>>3];while(1){U=+o[q+(f<<3)>>2];S=+o[q+(f<<3)+4>>2];T=+o[d>>2];V=+o[d+4>>2];m=m+(U*T-S*V);n=n+(S*T+U*V);f=f+1|0;if((f|0)==(j|0))break;else d=d+(L<<3)|0}p[l>>3]=m;p[i>>3]=n;h=h+1|0;if((h|0)==(N|0))break a}}if(!B){zpb(l+(h<<4)|0,0,N-h<<4|0)|0;break}do{d=c+(h<<3)|0;f=0;m=0.0;n=0.0;while(1){U=+o[q+(f<<3)>>2];S=+o[q+(f<<3)+4>>2];T=+o[d>>2];V=+o[d+4>>2];m=m+(U*T-S*V);n=n+(S*T+U*V);f=f+1|0;if((f|0)==(j|0))break;else d=d+(L<<3)|0}p[y+(h<<4)>>3]=m;p[y+(h<<4)+8>>3]=n;h=h+1|0}while((h|0)!=(N|0))}while(0);z=z+1|0;if((z|0)==(M|0))break;else{a=a+(b<<3)|0;y=y+(K<<4)|0}}}}else if(h){I=(g|0)==0;A=(q|0)==0;B=j+-2|0;C=(j|0)<2;D=j&-2;H=(j|0)<1|I;E=(N|0)>0;F=(j|0)>0;G=(D|0)<(j|0);y=e;z=0;while(1){if(H)q=I?a:g;else{h=0;do{i=a+((aa(h,J)|0)<<3)|0;q=k[i+4>>2]|0;e=g+(h<<3)|0;k[e>>2]=k[i>>2];k[e+4>>2]=q;h=h+1|0}while((h|0)!=(j|0));q=g}b:do if(E)if(A){if(C){d=c;f=0;while(1){if(F){h=0;n=0.0;m=0.0;do{U=+o[q+(h<<3)>>2];S=+o[q+(h<<3)+4>>2];T=+o[d+(h<<3)>>2];V=+o[d+(h<<3)+4>>2];n=n+(U*T-S*V);m=m+(S*T+U*V);h=h+1|0}while((h|0)!=(j|0))}else{n=0.0;m=0.0}p[y+(f<<4)>>3]=n+0.0;p[y+(f<<4)+8>>3]=m+0.0;f=f+1|0;if((f|0)==(N|0))break b;else d=d+(L<<3)|0}}else{d=c;f=0}while(1){h=0;s=0.0;n=0.0;m=0.0;t=0.0;do{S=+o[q+(h<<3)>>2];V=+o[q+(h<<3)+4>>2];T=+o[d+(h<<3)>>2];U=+o[d+(h<<3)+4>>2];n=n+(S*T-V*U);m=m+(V*T+S*U);e=h|1;U=+o[q+(e<<3)>>2];S=+o[q+(e<<3)+4>>2];T=+o[d+(e<<3)>>2];V=+o[d+(e<<3)+4>>2];s=s+(U*T-S*V);t=t+(S*T+U*V);h=h+2|0}while((h|0)<=(B|0));if(G){h=D;do{U=+o[q+(h<<3)>>2];S=+o[q+(h<<3)+4>>2];T=+o[d+(h<<3)>>2];V=+o[d+(h<<3)+4>>2];n=n+(U*T-S*V);m=m+(S*T+U*V);h=h+1|0}while((h|0)!=(j|0))}p[y+(f<<4)>>3]=s+n;p[y+(f<<4)+8>>3]=t+m;f=f+1|0;if((f|0)==(N|0))break;else d=d+(L<<3)|0}}else{if(C){d=c;f=0;while(1){i=y+(f<<4)+8|0;l=y+(f<<4)|0;n=+p[l>>3];m=+p[i>>3];if(F){h=0;do{U=+o[q+(h<<3)>>2];S=+o[q+(h<<3)+4>>2];T=+o[d+(h<<3)>>2];V=+o[d+(h<<3)+4>>2];n=n+(U*T-S*V);m=m+(S*T+U*V);h=h+1|0}while((h|0)!=(j|0))}p[l>>3]=n+0.0;p[i>>3]=m+0.0;f=f+1|0;if((f|0)==(N|0))break b;else d=d+(L<<3)|0}}else{d=c;f=0}while(1){i=y+(f<<4)+8|0;l=y+(f<<4)|0;h=0;s=0.0;n=+p[l>>3];m=+p[i>>3];t=0.0;do{S=+o[q+(h<<3)>>2];V=+o[q+(h<<3)+4>>2];T=+o[d+(h<<3)>>2];U=+o[d+(h<<3)+4>>2];n=n+(S*T-V*U);m=m+(V*T+S*U);e=h|1;U=+o[q+(e<<3)>>2];S=+o[q+(e<<3)+4>>2];T=+o[d+(e<<3)>>2];V=+o[d+(e<<3)+4>>2];s=s+(U*T-S*V);t=t+(S*T+U*V);h=h+2|0}while((h|0)<=(B|0));if(G){h=D;do{U=+o[q+(h<<3)>>2];S=+o[q+(h<<3)+4>>2];T=+o[d+(h<<3)>>2];V=+o[d+(h<<3)+4>>2];n=n+(U*T-S*V);m=m+(S*T+U*V);h=h+1|0}while((h|0)!=(j|0))}p[l>>3]=s+n;p[i>>3]=t+m;f=f+1|0;if((f|0)==(N|0))break;else d=d+(L<<3)|0}}while(0);z=z+1|0;if((z|0)==(M|0))break;else{a=a+(b<<3)|0;y=y+(K<<4)|0}}}g=k[Q>>2]|0;if((g|0)==(O|0)){r=R;return}if(g|0)ggb(g);k[Q>>2]=O;k[P>>2]=136;r=R;return}function z_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0.0,n=0.0,o=0,q=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0;W=r;r=r+1168|0;V=W;j=k[g>>2]|0;l=k[g+4>>2]|0;S=k[h>>2]|0;R=k[h+4>>2]|0;T=V+8|0;zpb(T|0,0,1152)|0;k[V>>2]=T;U=V+4|0;k[U>>2]=72;o=i&16;b=b>>>4;Q=d>>>4;P=f>>>4;if(!(i&1)){O=1;g=0}else{if(l>>>0>72){h=l>>>0>268435455?-1:l<<4;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}zpb(g|0,0,l<<4|0)|0;k[V>>2]=g}else g=T;k[U>>2]=l;O=b;b=1;j=l}h=(R|0)>0;if(!(i&2)){if(h){L=(g|0)==0;M=S+-4|0;N=(S|0)<4;G=(o|0)==0;H=(j|0)>0;I=S&-4;K=(j|0)<1|L;J=(M>>>2<<6)+64|0;D=a;E=e;F=0;while(1){B=e+((aa(P,F)|0)<<4)|0;if(K)C=L?D:g;else{h=0;do{C=g+(h<<4)|0;A=D+((aa(h,O)|0)<<4)|0;k[C>>2]=k[A>>2];k[C+4>>2]=k[A+4>>2];k[C+8>>2]=k[A+8>>2];k[C+12>>2]=k[A+12>>2];h=h+1|0}while((h|0)!=(j|0));C=g}a:do if(N)h=0;else{if(!G){if(H)d=0;else{h=I;break}while(1){i=E+(d<<4)|0;A=E+(d<<4)+8|0;y=d|1;l=E+(y<<4)|0;y=E+(y<<4)+8|0;z=d|2;a=E+(z<<4)|0;z=E+(z<<4)+8|0;x=d|3;o=E+(x<<4)|0;x=E+(x<<4)+8|0;h=c+(d<<4)|0;f=0;m=+p[l>>3];n=+p[i>>3];q=+p[o>>3];s=+p[a>>3];t=+p[x>>3];u=+p[y>>3];v=+p[z>>3];w=+p[A>>3];while(1){Y=+p[C+(f<<4)>>3];_=+p[C+(f<<4)+8>>3];X=+p[h>>3];Z=+p[h+8>>3];n=n+(Y*X-_*Z);w=w+(_*X+Y*Z);Z=+p[h+16>>3];X=+p[h+24>>3];m=m+(Y*Z-_*X);u=u+(_*Z+Y*X);X=+p[h+32>>3];Z=+p[h+40>>3];s=s+(Y*X-_*Z);v=v+(_*X+Y*Z);Z=+p[h+48>>3];X=+p[h+56>>3];q=q+(Y*Z-_*X);t=t+(_*Z+Y*X);f=f+1|0;if((f|0)==(j|0))break;else h=h+(Q<<4)|0}p[i>>3]=n;p[A>>3]=w;p[l>>3]=m;p[y>>3]=u;p[a>>3]=s;p[z>>3]=v;p[o>>3]=q;p[x>>3]=t;d=d+4|0;if((d|0)>(M|0)){h=I;break a}}}if(H)d=0;else{zpb(B|0,0,J|0)|0;h=I;break}do{h=c+(d<<4)|0;f=0;m=0.0;n=0.0;q=0.0;s=0.0;t=0.0;u=0.0;v=0.0;w=0.0;while(1){Z=+p[C+(f<<4)>>3];X=+p[C+(f<<4)+8>>3];_=+p[h>>3];Y=+p[h+8>>3];n=n+(Z*_-X*Y);w=w+(X*_+Z*Y);Y=+p[h+16>>3];_=+p[h+24>>3];m=m+(Z*Y-X*_);u=u+(X*Y+Z*_);_=+p[h+32>>3];Y=+p[h+40>>3];s=s+(Z*_-X*Y);v=v+(X*_+Z*Y);Y=+p[h+48>>3];_=+p[h+56>>3];q=q+(Z*Y-X*_);t=t+(X*Y+Z*_);f=f+1|0;if((f|0)==(j|0))break;else h=h+(Q<<4)|0}p[E+(d<<4)>>3]=n;p[E+(d<<4)+8>>3]=w;A=d|1;p[E+(A<<4)>>3]=m;p[E+(A<<4)+8>>3]=u;A=d|2;p[E+(A<<4)>>3]=s;p[E+(A<<4)+8>>3]=v;A=d|3;p[E+(A<<4)>>3]=q;p[E+(A<<4)+8>>3]=t;d=d+4|0}while((d|0)<=(M|0));h=I}while(0);b:do if((S|0)>(h|0)){if(!G){if(!H)break;while(1){i=E+(h<<4)+8|0;l=E+(h<<4)|0;d=c+(h<<4)|0;f=0;m=+p[l>>3];n=+p[i>>3];while(1){Z=+p[C+(f<<4)>>3];X=+p[C+(f<<4)+8>>3];Y=+p[d>>3];_=+p[d+8>>3];m=m+(Z*Y-X*_);n=n+(X*Y+Z*_);f=f+1|0;if((f|0)==(j|0))break;else d=d+(Q<<4)|0}p[l>>3]=m;p[i>>3]=n;h=h+1|0;if((h|0)==(S|0))break b}}if(!H){zpb(B+(h<<4)|0,0,S-h<<4|0)|0;break}do{d=c+(h<<4)|0;f=0;m=0.0;n=0.0;while(1){Z=+p[C+(f<<4)>>3];X=+p[C+(f<<4)+8>>3];Y=+p[d>>3];_=+p[d+8>>3];m=m+(Z*Y-X*_);n=n+(X*Y+Z*_);f=f+1|0;if((f|0)==(j|0))break;else d=d+(Q<<4)|0}p[E+(h<<4)>>3]=m;p[E+(h<<4)+8>>3]=n;h=h+1|0}while((h|0)!=(S|0))}while(0);F=F+1|0;if((F|0)==(R|0))break;else{D=D+(b<<4)|0;E=E+(P<<4)|0}}}}else if(h){H=(g|0)==0;z=(o|0)==0;A=j+-2|0;B=(j|0)<2;C=j&-2;G=(j|0)<1|H;D=(S|0)>0;E=(j|0)>0;F=(C|0)<(j|0);x=e;y=0;while(1){if(G)o=H?a:g;else{h=0;do{e=g+(h<<4)|0;N=a+((aa(h,O)|0)<<4)|0;k[e>>2]=k[N>>2];k[e+4>>2]=k[N+4>>2];k[e+8>>2]=k[N+8>>2];k[e+12>>2]=k[N+12>>2];h=h+1|0}while((h|0)!=(j|0));o=g}c:do if(D)if(z){if(B){d=c;f=0;while(1){if(E){h=0;n=0.0;m=0.0;do{Z=+p[o+(h<<4)>>3];X=+p[o+(h<<4)+8>>3];Y=+p[d+(h<<4)>>3];_=+p[d+(h<<4)+8>>3];n=n+(Z*Y-X*_);m=m+(X*Y+Z*_);h=h+1|0}while((h|0)!=(j|0))}else{n=0.0;m=0.0}p[x+(f<<4)>>3]=n+0.0;p[x+(f<<4)+8>>3]=m+0.0;f=f+1|0;if((f|0)==(S|0))break c;else d=d+(Q<<4)|0}}else{d=c;f=0}while(1){h=0;q=0.0;n=0.0;m=0.0;s=0.0;do{X=+p[o+(h<<4)>>3];_=+p[o+(h<<4)+8>>3];Y=+p[d+(h<<4)>>3];Z=+p[d+(h<<4)+8>>3];n=n+(X*Y-_*Z);m=m+(_*Y+X*Z);e=h|1;Z=+p[o+(e<<4)>>3];X=+p[o+(e<<4)+8>>3];Y=+p[d+(e<<4)>>3];_=+p[d+(e<<4)+8>>3];q=q+(Z*Y-X*_);s=s+(X*Y+Z*_);h=h+2|0}while((h|0)<=(A|0));if(F){h=C;do{Z=+p[o+(h<<4)>>3];X=+p[o+(h<<4)+8>>3];Y=+p[d+(h<<4)>>3];_=+p[d+(h<<4)+8>>3];n=n+(Z*Y-X*_);m=m+(X*Y+Z*_);h=h+1|0}while((h|0)!=(j|0))}p[x+(f<<4)>>3]=q+n;p[x+(f<<4)+8>>3]=s+m;f=f+1|0;if((f|0)==(S|0))break;else d=d+(Q<<4)|0}}else{if(B){d=c;f=0;while(1){i=x+(f<<4)+8|0;l=x+(f<<4)|0;n=+p[l>>3];m=+p[i>>3];if(E){h=0;do{Z=+p[o+(h<<4)>>3];X=+p[o+(h<<4)+8>>3];Y=+p[d+(h<<4)>>3];_=+p[d+(h<<4)+8>>3];n=n+(Z*Y-X*_);m=m+(X*Y+Z*_);h=h+1|0}while((h|0)!=(j|0))}p[l>>3]=n+0.0;p[i>>3]=m+0.0;f=f+1|0;if((f|0)==(S|0))break c;else d=d+(Q<<4)|0}}else{d=c;f=0}while(1){i=x+(f<<4)+8|0;l=x+(f<<4)|0;h=0;q=0.0;n=+p[l>>3];m=+p[i>>3];s=0.0;do{X=+p[o+(h<<4)>>3];_=+p[o+(h<<4)+8>>3];Y=+p[d+(h<<4)>>3];Z=+p[d+(h<<4)+8>>3];n=n+(X*Y-_*Z);m=m+(_*Y+X*Z);e=h|1;Z=+p[o+(e<<4)>>3];X=+p[o+(e<<4)+8>>3];Y=+p[d+(e<<4)>>3];_=+p[d+(e<<4)+8>>3];q=q+(Z*Y-X*_);s=s+(X*Y+Z*_);h=h+2|0}while((h|0)<=(A|0));if(F){h=C;do{Z=+p[o+(h<<4)>>3];X=+p[o+(h<<4)+8>>3];Y=+p[d+(h<<4)>>3];_=+p[d+(h<<4)+8>>3];n=n+(Z*Y-X*_);m=m+(X*Y+Z*_);h=h+1|0}while((h|0)!=(j|0))}p[l>>3]=q+n;p[i>>3]=s+m;f=f+1|0;if((f|0)==(S|0))break;else d=d+(Q<<4)|0}}while(0);y=y+1|0;if((y|0)==(R|0))break;else{a=a+(b<<4)|0;x=x+(P<<4)|0}}}g=k[V>>2]|0;if((g|0)==(T|0)){r=W;return}if(g|0)ggb(g);k[V>>2]=T;k[U>>2]=72;r=W;return}function A_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,l=0,m=0.0,n=0.0,q=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0;Q=r;r=r+1072|0;P=Q;j=k[g>>2]|0;l=k[g+4>>2]|0;O=k[h>>2]|0;L=k[h+4>>2]|0;M=P+8|0;k[P>>2]=M;N=P+4|0;k[N>>2]=264;t=i&16;b=b>>>2;K=d>>>2;J=f>>>3;if(!(i&1)){I=1;H=0;G=M}else{if(l>>>0>264){h=l>>>0>1073741823?-1:l<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[P>>2]=g}else g=M;k[N>>2]=l;I=b;b=1;H=g;j=l;G=g}g=(L|0)>0;if(!(i&2)){if(g){D=(H|0)==0;E=O+-4|0;F=(O|0)<4;y=(t|0)==0;z=(j|0)>0;A=O&-4;C=(j|0)<1|D;B=(E>>>2<<5)+32|0;w=e;x=0;v=a;while(1){a=e+((aa(J,x)|0)<<3)|0;if(C)u=D?v:H;else{g=0;do{u=v+((aa(g,I)|0)<<2)|0;k[H+(g<<2)>>2]=k[u>>2];g=g+1|0}while((g|0)!=(j|0));u=H}a:do if(F)g=0;else{if(!y){if(z)h=0;else{g=A;break}while(1){f=w+((h|3)<<3)|0;l=w+((h|2)<<3)|0;i=w+((h|1)<<3)|0;t=w+(h<<3)|0;g=c+(h<<2)|0;m=+p[f>>3];n=+p[l>>3];q=+p[i>>3];s=+p[t>>3];d=0;while(1){R=+o[u+(d<<2)>>2];s=s+R*+o[g>>2];q=q+R*+o[g+4>>2];n=n+R*+o[g+8>>2];m=m+R*+o[g+12>>2];d=d+1|0;if((d|0)==(j|0))break;else g=g+(K<<2)|0}p[t>>3]=s;p[i>>3]=q;p[l>>3]=n;p[f>>3]=m;h=h+4|0;if((h|0)>(E|0)){g=A;break a}}}if(z)h=0;else{zpb(a|0,0,B|0)|0;g=A;break}do{g=c+(h<<2)|0;m=0.0;n=0.0;q=0.0;s=0.0;d=0;while(1){R=+o[u+(d<<2)>>2];s=s+R*+o[g>>2];q=q+R*+o[g+4>>2];n=n+R*+o[g+8>>2];m=m+R*+o[g+12>>2];d=d+1|0;if((d|0)==(j|0))break;else g=g+(K<<2)|0}p[w+(h<<3)>>3]=s;p[w+((h|1)<<3)>>3]=q;p[w+((h|2)<<3)>>3]=n;p[w+((h|3)<<3)>>3]=m;h=h+4|0}while((h|0)<=(E|0));g=A}while(0);b:do if((O|0)>(g|0)){if(!y){if(!z)break;while(1){f=w+(g<<3)|0;h=c+(g<<2)|0;m=+p[f>>3];d=0;while(1){m=m+ +o[u+(d<<2)>>2]*+o[h>>2];d=d+1|0;if((d|0)==(j|0))break;else h=h+(K<<2)|0}p[f>>3]=m;g=g+1|0;if((g|0)==(O|0))break b}}if(!z){zpb(a+(g<<3)|0,0,O-g<<3|0)|0;break}do{h=c+(g<<2)|0;m=0.0;d=0;while(1){m=m+ +o[u+(d<<2)>>2]*+o[h>>2];d=d+1|0;if((d|0)==(j|0))break;else h=h+(K<<2)|0}p[w+(g<<3)>>3]=m;g=g+1|0}while((g|0)!=(O|0))}while(0);x=x+1|0;if((x|0)==(L|0))break;else{w=w+(J<<3)|0;v=v+(b<<2)|0}}}}else if(g){B=(H|0)==0;C=(O|0)>0;u=(t|0)==0;v=j+-2|0;w=(j|0)<2;x=j&-2;A=(j|0)<1|B;y=(j|0)>0;z=(x|0)<(j|0);i=e;t=0;while(1){if(A)l=B?a:H;else{g=0;do{e=a+((aa(g,I)|0)<<2)|0;k[H+(g<<2)>>2]=k[e>>2];g=g+1|0}while((g|0)!=(j|0));l=H}c:do if(C){if(u){if(w){h=c;d=0;while(1){if(y){m=0.0;g=0;do{m=m+ +o[l+(g<<2)>>2]*+o[h+(g<<2)>>2];g=g+1|0}while((g|0)!=(j|0))}else m=0.0;p[i+(d<<3)>>3]=m+0.0;d=d+1|0;if((d|0)==(O|0))break c;else h=h+(K<<2)|0}}else{h=c;d=0}while(1){n=0.0;m=0.0;g=0;do{m=m+ +o[l+(g<<2)>>2]*+o[h+(g<<2)>>2];e=g|1;n=n+ +o[l+(e<<2)>>2]*+o[h+(e<<2)>>2];g=g+2|0}while((g|0)<=(v|0));if(z){g=x;do{m=m+ +o[l+(g<<2)>>2]*+o[h+(g<<2)>>2];g=g+1|0}while((g|0)!=(j|0))}p[i+(d<<3)>>3]=n+m;d=d+1|0;if((d|0)==(O|0))break c;else h=h+(K<<2)|0}}if(w){if(y){g=c;h=0}else{g=0;while(1){e=i+(g<<3)|0;p[e>>3]=+p[e>>3]+0.0;g=g+1|0;if((g|0)==(O|0))break c}}while(1){f=i+(h<<3)|0;m=+p[f>>3];d=0;do{m=m+ +o[l+(d<<2)>>2]*+o[g+(d<<2)>>2];d=d+1|0}while((d|0)!=(j|0));p[f>>3]=m+0.0;h=h+1|0;if((h|0)==(O|0))break c;else g=g+(K<<2)|0}}if(z){h=c;d=0}else{g=c;h=0;while(1){f=i+(h<<3)|0;m=0.0;n=+p[f>>3];d=0;do{n=n+ +o[l+(d<<2)>>2]*+o[g+(d<<2)>>2];e=d|1;m=m+ +o[l+(e<<2)>>2]*+o[g+(e<<2)>>2];d=d+2|0}while((d|0)<=(v|0));p[f>>3]=m+n;h=h+1|0;if((h|0)==(O|0))break c;else g=g+(K<<2)|0}}while(1){f=i+(d<<3)|0;n=0.0;m=+p[f>>3];g=0;do{m=m+ +o[l+(g<<2)>>2]*+o[h+(g<<2)>>2];e=g|1;n=n+ +o[l+(e<<2)>>2]*+o[h+(e<<2)>>2];g=g+2|0}while((g|0)<=(v|0));g=x;do{m=m+ +o[l+(g<<2)>>2]*+o[h+(g<<2)>>2];g=g+1|0}while((g|0)!=(j|0));p[f>>3]=n+m;d=d+1|0;if((d|0)==(O|0))break;else h=h+(K<<2)|0}}while(0);t=t+1|0;if((t|0)==(L|0))break;else{i=i+(J<<3)|0;a=a+(b<<2)|0}}}if((G|0)==(M|0)){r=Q;return}ggb(G);k[P>>2]=M;k[N>>2]=264;r=Q;return}function B_(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;y=k[g>>2]|0;l=k[g+4>>2]|0;g=b>>>3;x=d>>>3;w=f>>>3;if(!a){v=0;u=0;a=0}else{u=(j&4|0)==0;v=u?1:g;u=u?g:1}if(!l)return;j=v<<1;m=v*3|0;n=v<<2;o=(y|0)<4;q=y+-4|0;t=(q|0)>3?q:3;r=t+4&-4;t=t>>>2;s=aa(n,t)|0;t=(t<<2)+4|0;f=a;d=a+(n<<3)|0;while(1){l=l+-1|0;if(!f){if(o)g=0;else{g=0;do{b=g|1;z=+p[c+(b<<3)>>3]*h;p[e+(g<<3)>>3]=+p[c+(g<<3)>>3]*h;p[e+(b<<3)>>3]=z;b=g|2;a=g|3;z=+p[c+(a<<3)>>3]*h;p[e+(b<<3)>>3]=+p[c+(b<<3)>>3]*h;p[e+(a<<3)>>3]=z;g=g+4|0}while((g|0)<=(q|0));g=r}if((g|0)<(y|0))do{p[e+(g<<3)>>3]=+p[c+(g<<3)>>3]*h;g=g+1|0}while((g|0)!=(y|0))}else{if(o){b=f;g=0}else{g=0;b=f;while(1){A=g|1;z=+p[c+(A<<3)>>3]*h+ +p[b+(v<<3)>>3]*i;p[e+(g<<3)>>3]=+p[c+(g<<3)>>3]*h+ +p[b>>3]*i;p[e+(A<<3)>>3]=z;A=g|2;a=g|3;z=+p[c+(a<<3)>>3]*h+ +p[b+(m<<3)>>3]*i;p[e+(A<<3)>>3]=+p[c+(A<<3)>>3]*h+ +p[b+(j<<3)>>3]*i;p[e+(a<<3)>>3]=z;g=g+4|0;if((g|0)>(q|0))break;else b=b+(n<<3)|0}b=d+(s<<3)|0;g=t}if((g|0)<(y|0))while(1){p[e+(g<<3)>>3]=+p[c+(g<<3)>>3]*h+ +p[b>>3]*i;g=g+1|0;if((g|0)==(y|0))break;else b=b+(v<<3)|0}}if(!l)break;else{c=c+(x<<3)|0;e=e+(w<<3)|0;f=f+(u<<3)|0;d=d+(u<<3)|0}}return}function C_(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;var l=0,m=0,n=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0;x=k[g>>2]|0;l=k[g+4>>2]|0;g=b>>>3;w=d>>>4;v=f>>>3;if(!a){u=0;t=0;a=0}else{t=(j&4|0)==0;u=t?1:g;t=t?g:1}if(!l)return;j=u<<1;m=u*3|0;n=u<<2;q=(x|0)<4;r=x+-4|0;d=r>>>2;s=(d<<2)+4|0;f=a;d=a+(aa(u,(d<<5)+32|0)|0)|0;while(1){l=l+-1|0;if(!f){if(q)g=0;else{g=0;do{b=g|1;y=+p[c+(b<<4)>>3]*h;z=+p[c+(b<<4)+8>>3]*h;A=+p[c+(g<<4)+8>>3]*h;o[e+(g<<3)>>2]=+p[c+(g<<4)>>3]*h;o[e+(g<<3)+4>>2]=A;o[e+(b<<3)>>2]=y;o[e+(b<<3)+4>>2]=z;b=g|2;a=g|3;z=+p[c+(a<<4)>>3]*h;y=+p[c+(a<<4)+8>>3]*h;A=+p[c+(b<<4)+8>>3]*h;o[e+(b<<3)>>2]=+p[c+(b<<4)>>3]*h;o[e+(b<<3)+4>>2]=A;o[e+(a<<3)>>2]=z;o[e+(a<<3)+4>>2]=y;g=g+4|0}while((g|0)<=(r|0));g=s}if((g|0)<(x|0))do{A=+p[c+(g<<4)+8>>3]*h;o[e+(g<<3)>>2]=+p[c+(g<<4)>>3]*h;o[e+(g<<3)+4>>2]=A;g=g+1|0}while((g|0)!=(x|0))}else{if(q){g=f;b=0}else{g=f;b=0;while(1){B=b|1;A=+p[c+(B<<4)>>3]*h+ +o[g+(u<<3)>>2]*i;z=+p[c+(B<<4)+8>>3]*h+ +o[g+(u<<3)+4>>2]*i;y=+p[c+(b<<4)+8>>3]*h+ +o[g+4>>2]*i;o[e+(b<<3)>>2]=+p[c+(b<<4)>>3]*h+ +o[g>>2]*i;o[e+(b<<3)+4>>2]=y;o[e+(B<<3)>>2]=A;o[e+(B<<3)+4>>2]=z;B=b|2;a=b|3;z=+p[c+(a<<4)>>3]*h+ +o[g+(m<<3)>>2]*i;A=+p[c+(a<<4)+8>>3]*h+ +o[g+(m<<3)+4>>2]*i;y=+p[c+(B<<4)+8>>3]*h+ +o[g+(j<<3)+4>>2]*i;o[e+(B<<3)>>2]=+p[c+(B<<4)>>3]*h+ +o[g+(j<<3)>>2]*i;o[e+(B<<3)+4>>2]=y;o[e+(a<<3)>>2]=z;o[e+(a<<3)+4>>2]=A;b=b+4|0;if((b|0)>(r|0)){g=d;b=s;break}else g=g+(n<<3)|0}}if((b|0)<(x|0))while(1){A=+p[c+(b<<4)+8>>3]*h+ +o[g+4>>2]*i;o[e+(b<<3)>>2]=+p[c+(b<<4)>>3]*h+ +o[g>>2]*i;o[e+(b<<3)+4>>2]=A;b=b+1|0;if((b|0)==(x|0))break;else g=g+(u<<3)|0}}if(!l)break;else{c=c+(w<<4)|0;e=e+(v<<3)|0;f=f+(t<<3)|0;d=d+(t<<3)|0}}return}function D_(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0;w=k[g>>2]|0;l=k[g+4>>2]|0;g=b>>>4;v=d>>>4;u=f>>>4;if(!a){t=0;s=0;a=0}else{s=(j&4|0)==0;t=s?1:g;s=s?g:1}if(!l)return;j=t<<1;m=t*3|0;n=t<<2;o=(w|0)<4;q=w+-4|0;d=q>>>2;r=(d<<2)+4|0;f=a;d=a+(aa(t,(d<<6)+64|0)|0)|0;while(1){l=l+-1|0;if(!f){if(o)g=0;else{g=0;do{x=+p[c+(g<<4)+8>>3]*h;b=g|1;y=+p[c+(b<<4)>>3]*h;z=+p[c+(b<<4)+8>>3]*h;p[e+(g<<4)>>3]=+p[c+(g<<4)>>3]*h;p[e+(g<<4)+8>>3]=x;p[e+(b<<4)>>3]=y;p[e+(b<<4)+8>>3]=z;b=g|2;z=+p[c+(b<<4)+8>>3]*h;a=g|3;y=+p[c+(a<<4)>>3]*h;x=+p[c+(a<<4)+8>>3]*h;p[e+(b<<4)>>3]=+p[c+(b<<4)>>3]*h;p[e+(b<<4)+8>>3]=z;p[e+(a<<4)>>3]=y;p[e+(a<<4)+8>>3]=x;g=g+4|0}while((g|0)<=(q|0));g=r}if((g|0)<(w|0))do{z=+p[c+(g<<4)+8>>3]*h;p[e+(g<<4)>>3]=+p[c+(g<<4)>>3]*h;p[e+(g<<4)+8>>3]=z;g=g+1|0}while((g|0)!=(w|0))}else{if(o){b=0;g=f}else{g=0;b=f;while(1){A=g|1;z=+p[c+(g<<4)+8>>3]*h+ +p[b+8>>3]*i;y=+p[c+(A<<4)>>3]*h+ +p[b+(t<<4)>>3]*i;x=+p[c+(A<<4)+8>>3]*h+ +p[b+(t<<4)+8>>3]*i;p[e+(g<<4)>>3]=+p[c+(g<<4)>>3]*h+ +p[b>>3]*i;p[e+(g<<4)+8>>3]=z;p[e+(A<<4)>>3]=y;p[e+(A<<4)+8>>3]=x;A=g|2;a=g|3;x=+p[c+(A<<4)+8>>3]*h+ +p[b+(j<<4)+8>>3]*i;y=+p[c+(a<<4)>>3]*h+ +p[b+(m<<4)>>3]*i;z=+p[c+(a<<4)+8>>3]*h+ +p[b+(m<<4)+8>>3]*i;p[e+(A<<4)>>3]=+p[c+(A<<4)>>3]*h+ +p[b+(j<<4)>>3]*i;p[e+(A<<4)+8>>3]=x;p[e+(a<<4)>>3]=y;p[e+(a<<4)+8>>3]=z;g=g+4|0;if((g|0)>(q|0)){b=r;g=d;break}else b=b+(n<<4)|0}}if((b|0)<(w|0))while(1){z=+p[c+(b<<4)+8>>3]*h+ +p[g+8>>3]*i;p[e+(b<<4)>>3]=+p[c+(b<<4)>>3]*h+ +p[g>>3]*i;p[e+(b<<4)+8>>3]=z;b=b+1|0;if((b|0)==(w|0))break;else g=g+(t<<4)|0}}if(!l)break;else{f=f+(s<<4)|0;c=c+(v<<4)|0;e=e+(u<<4)|0;d=d+(s<<4)|0}}return}function E_(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;var l=0,m=0,n=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0;z=k[g>>2]|0;l=k[g+4>>2]|0;g=b>>>2;y=d>>>3;x=f>>>2;if(!a){w=0;v=0;a=0}else{v=(j&4|0)==0;w=v?1:g;v=v?g:1}if(!l)return;j=w<<1;m=w*3|0;n=w<<2;q=(z|0)<4;r=z+-4|0;u=(r|0)>3?r:3;s=u+4&-4;u=u>>>2;t=aa(n,u)|0;u=(u<<2)+4|0;f=a;d=a+(n<<2)|0;while(1){l=l+-1|0;if(!f){if(q)g=0;else{g=0;do{b=g|1;A=+p[c+(b<<3)>>3]*h;o[e+(g<<2)>>2]=+p[c+(g<<3)>>3]*h;o[e+(b<<2)>>2]=A;b=g|2;a=g|3;A=+p[c+(a<<3)>>3]*h;o[e+(b<<2)>>2]=+p[c+(b<<3)>>3]*h;o[e+(a<<2)>>2]=A;g=g+4|0}while((g|0)<=(r|0));g=s}if((g|0)<(z|0))do{o[e+(g<<2)>>2]=+p[c+(g<<3)>>3]*h;g=g+1|0}while((g|0)!=(z|0))}else{if(q){b=f;g=0}else{g=0;b=f;while(1){B=g|1;A=+p[c+(B<<3)>>3]*h+ +o[b+(w<<2)>>2]*i;o[e+(g<<2)>>2]=+p[c+(g<<3)>>3]*h+ +o[b>>2]*i;o[e+(B<<2)>>2]=A;B=g|2;a=g|3;A=+p[c+(a<<3)>>3]*h+ +o[b+(m<<2)>>2]*i;o[e+(B<<2)>>2]=+p[c+(B<<3)>>3]*h+ +o[b+(j<<2)>>2]*i;o[e+(a<<2)>>2]=A;g=g+4|0;if((g|0)>(r|0))break;else b=b+(n<<2)|0}b=d+(t<<2)|0;g=u}if((g|0)<(z|0))while(1){o[e+(g<<2)>>2]=+p[c+(g<<3)>>3]*h+ +o[b>>2]*i;g=g+1|0;if((g|0)==(z|0))break;else b=b+(w<<2)|0}}if(!l)break;else{c=c+(y<<3)|0;e=e+(x<<2)|0;f=f+(v<<2)|0;d=d+(v<<2)|0}}return}function F_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0.0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=r;r=r+1408|0;G=M+1392|0;F=M+1384|0;L=M+1328|0;K=M+1272|0;s=M+1264|0;J=M+1208|0;H=M;E=M+1152|0;y=M+1096|0;do if((k[a>>2]&2031616|0)==65536){h=k[a+4>>2]|0;k[L>>2]=k[h>>2];n=L+4|0;a=h+4|0;k[n>>2]=k[a>>2];I=L+8|0;k[I>>2]=k[h+8>>2];k[L+12>>2]=k[h+12>>2];k[L+16>>2]=k[h+16>>2];k[L+20>>2]=k[h+20>>2];k[L+24>>2]=k[h+24>>2];k[L+28>>2]=k[h+28>>2];k[L+32>>2]=k[h+32>>2];d=k[h+36>>2]|0;k[L+36>>2]=d;e=L+40|0;k[e>>2]=I;I=L+48|0;l=L+44|0;k[l>>2]=I;k[L+52>>2]=0;k[I>>2]=0;if(d|0){I=d+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[a>>2]|0)<3){A=k[h+44>>2]|0;I=k[l>>2]|0;k[I>>2]=k[A>>2];k[I+4>>2]=k[A+4>>2];break}k[n>>2]=0;x1(L,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[e>>2]|0;e=k[h+44>>2]|0;d=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(L,a,-1);while(0);do if((k[c>>2]&2031616|0)==65536){l=k[c+4>>2]|0;k[K>>2]=k[l>>2];c=K+4|0;e=l+4|0;k[c>>2]=k[e>>2];a=K+8|0;k[a>>2]=k[l+8>>2];q=K+12|0;k[q>>2]=k[l+12>>2];k[K+16>>2]=k[l+16>>2];k[K+20>>2]=k[l+20>>2];k[K+24>>2]=k[l+24>>2];k[K+28>>2]=k[l+28>>2];k[K+32>>2]=k[l+32>>2];d=k[l+36>>2]|0;k[K+36>>2]=d;h=K+40|0;k[h>>2]=a;I=K+48|0;m=K+44|0;k[m>>2]=I;k[K+52>>2]=0;k[I>>2]=0;if(d|0){I=d+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[e>>2]|0)<3){A=k[l+44>>2]|0;I=k[m>>2]|0;k[I>>2]=k[A>>2];k[I+4>>2]=k[A+4>>2];break}k[c>>2]=0;x1(K,k[e>>2]|0,0,0,0);if((k[c>>2]|0)>0){n=k[l+40>>2]|0;j=k[h>>2]|0;h=k[l+44>>2]|0;e=k[m>>2]|0;d=0;do{k[j+(d<<2)>>2]=k[n+(d<<2)>>2];k[e+(d<<2)>>2]=k[h+(d<<2)>>2];d=d+1|0}while((d|0)<(k[c>>2]|0))}}else{Q1(K,c,-1);q=K+12|0;a=K+8|0}while(0);u=k[L>>2]|0;v=u&7;u=u>>>3&511;A=u+1|0;z=k[a>>2]|0;I=k[q>>2]|0;t=u+2|0;if(!((A|0)==(I|0)|(t|0)==(I|0))){k[G>>2]=0;a=G+4|0;k[a>>2]=0;d=ZT(40)|0;k[d>>2]=1;e=d+4|0;k[G>>2]=e;k[a>>2]=34;i[d+38>>0]=0;h=215719;l=e+34|0;do{i[e>>0]=i[h>>0]|0;e=e+1|0;h=h+1|0}while((e|0)<(l|0));Y8(-215,G,215754,215417,1947);k[a>>2]=0;k[G>>2]=0;I=k[d>>2]|0;k[d>>2]=I+-1;if((I|0)==1)ggb(k[d+-4>>2]|0)}I=L+40|0;w=k[I>>2]|0;x=k[w>>2]|0;k[s>>2]=k[w+4>>2];k[s+4>>2]=x;x2(b,s,(z<<3)+-8|v,0);do if((k[b>>2]&2031616|0)==65536){h=k[b+4>>2]|0;k[J>>2]=k[h>>2];n=J+4|0;a=h+4|0;k[n>>2]=k[a>>2];x=J+8|0;k[x>>2]=k[h+8>>2];k[J+12>>2]=k[h+12>>2];k[J+16>>2]=k[h+16>>2];k[J+20>>2]=k[h+20>>2];k[J+24>>2]=k[h+24>>2];k[J+28>>2]=k[h+28>>2];k[J+32>>2]=k[h+32>>2];d=k[h+36>>2]|0;k[J+36>>2]=d;e=J+40|0;k[e>>2]=x;x=J+48|0;l=J+44|0;k[l>>2]=x;k[J+52>>2]=0;k[x>>2]=0;if(d|0){x=d+12|0;k[x>>2]=(k[x>>2]|0)+1}if((k[a>>2]|0)<3){w=k[h+44>>2]|0;x=k[l>>2]|0;k[x>>2]=k[w>>2];k[x+4>>2]=k[w+4>>2];break}k[n>>2]=0;x1(J,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[h+40>>2]|0;j=k[e>>2]|0;e=k[h+44>>2]|0;d=k[l>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0))}}else Q1(J,b,-1);while(0);s=(v|2|0)==6;l=s?6:5;w=H+8|0;k[H>>2]=w;x=H+4|0;k[x>>2]=136;b=k[K>>2]|0;if((k[q>>2]|0)==(t|0)&((b&16384|0)!=0&(b&4095|0)==(l|0)))m=k[K+16>>2]|0;else{e=aa(t,z)|0;if(e>>>0>136){d=e>>>0>536870911?-1:e<<3;d=(d|0)==0?1:d;while(1){a=fgb(d)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[H>>2]=a;m=a}else m=w;k[x>>2]=e;JN(E,z,t,l,m,0);n=E+16|0;j=k[n>>2]|0;c=E+44|0;b=E+4|0;h=k[b>>2]|0;if((h|0)<3)d=aa(k[E+12>>2]|0,k[E+8>>2]|0)|0;else{e=k[E+40>>2]|0;a=0;d=1;do{d=aa(k[e+(a<<2)>>2]|0,d)|0;a=a+1|0}while((a|0)!=(h|0))}if((h|0)>0)a=k[(k[c>>2]|0)+(h+-1<<2)>>2]|0;else a=0;zpb(j|0,0,aa(a,d)|0)|0;a=k[q>>2]|0;if((a|0)!=(t|0)){k[G>>2]=-2147483648;k[G+4>>2]=2147483647;k[F>>2]=0;k[F+4>>2]=a;H1(y,E,G,F);e=G+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[G>>2]=33619968;k[e>>2]=y;SW(K,G,l,1.0,0.0);e=y+36|0;a=k[e>>2]|0;if(a|0?(l=a+12|0,t=k[l>>2]|0,k[l>>2]=t+-1,(t|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;t=y+16|0;d=y+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[d>>2]|0)>0){e=k[y+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[y+44>>2]|0;if(!((a|0)==(y+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else{y=G+4|0;t=y+4|0;k[t>>2]=0;k[t+4>>2]=0;k[G>>2]=33619968;k[y>>2]=E;SW(K,G,l,1.0,0.0)}KG(K,E)|0;e=E+36|0;a=k[e>>2]|0;if(a|0?(t=a+12|0,y=k[t>>2]|0,k[t>>2]=y+-1,(y|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[E+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[b>>2]|0)>0){d=k[E+40>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[c>>2]|0;if(!((a|0)==(E+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}a:do if((A|0)==(z|0)){f=s?2.220446049250313e-16:1.1920928955078125e-07;a=K+16|0;if(u|0){h=k[a>>2]|0;j=k[k[K+44>>2]>>2]|0;if(s){d=0;while(1){e=h+(aa(j,d)|0)|0;a=0;while(1){if((d|0)!=(a|0)?+P(+(+p[e+(a<<3)>>3]))>f:0){a=47812;D=105;break a}if((a|0)<(u|0))a=a+1|0;else break}if((d|0)<(u|0))d=d+1|0;else{a=47844;D=105;break a}}}else{d=0;while(1){e=h+(aa(j,d)|0)|0;a=0;while(1){if((d|0)!=(a|0)?+P(+(+o[e+(a<<2)>>2]))>f:0){a=47812;D=105;break a}if((a|0)<(u|0))a=a+1|0;else break}if((d|0)<(u|0))d=d+1|0;else{a=47844;D=105;break a}}}}if(s){a=k[a>>2]|0;f=+p[a>>3];do if((k[K>>2]&16384|0)==0?(C=k[K+40>>2]|0,(k[C>>2]|0)!=1):0){d=k[K+44>>2]|0;if((k[C+4>>2]|0)==1){a=a+(k[d>>2]|0)|0;break}else{F=k[q>>2]|0;E=(F+1|0)>>>0<3?F:0;F=1-(aa(E,F)|0)|0;a=a+(aa(E,k[d>>2]|0)|0)+(F<<3)|0;break}}else D=94;while(0);if((D|0)==94)a=a+8|0;g=+p[a>>3]}else{a=k[a>>2]|0;f=+o[a>>2];do if((k[K>>2]&16384|0)==0?(B=k[K+40>>2]|0,(k[B>>2]|0)!=1):0){d=k[K+44>>2]|0;if((k[B+4>>2]|0)==1){a=a+(k[d>>2]|0)|0;break}else{F=k[q>>2]|0;E=(F+1|0)>>>0<3?F:0;F=1-(aa(E,F)|0)|0;a=a+(aa(E,k[d>>2]|0)|0)+(F<<2)|0;break}}else D=87;while(0);if((D|0)==87)a=a+4|0;g=+o[a>>2]}F=G+4|0;E=F+4|0;k[E>>2]=0;k[E+4>>2]=0;k[G>>2]=33619968;k[F>>2]=J;SW(L,G,k[J>>2]&4095,f,g)}else{a=47812;D=105}while(0);if((D|0)==105){j=k[a+(v<<2)>>2]|0;if(!j){k[G>>2]=0;a=G+4|0;k[a>>2]=0;d=ZT(16)|0;k[d>>2]=1;e=d+4|0;k[G>>2]=e;k[a>>2]=9;i[d+13>>0]=0;h=335726;l=e+9|0;do{i[e>>0]=i[h>>0]|0;e=e+1|0;h=h+1|0}while((e|0)<(l|0));Y8(-215,G,215754,215417,2003);k[a>>2]=0;k[G>>2]=0;D=k[d>>2]|0;k[d>>2]=D+-1;if((D|0)==1)ggb(k[d+-4>>2]|0)}k[G>>2]=L;k[G+4>>2]=J;k[G+8>>2]=0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;k[E+16>>2]=0;k[E+20>>2]=0;k[E+24>>2]=0;k[E+28>>2]=0;z1(E,G,0,F,-1);d=k[E+20>>2]|0;e=E+16|0;h=F+4|0;a=0;while(1){if(a>>>0>=(k[e>>2]|0)>>>0)break;Lg[j&255](k[F>>2]|0,k[h>>2]|0,m,d,A,z);A1(E);a=a+1|0}}a=k[H>>2]|0;if((a|0)!=(w|0)){if(a|0)ggb(a);k[H>>2]=w;k[x>>2]=136}e=J+36|0;a=k[e>>2]|0;if(a|0?(G=a+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[J+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;H=J+16|0;d=J+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[d>>2]|0)>0){e=k[J+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[J+44>>2]|0;if(!((a|0)==(J+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=K+36|0;a=k[e>>2]|0;if(a|0?(H=a+12|0,J=k[H>>2]|0,k[H>>2]=J+-1,(J|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[K+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;J=K+16|0;d=K+4|0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[d>>2]|0)>0){e=k[K+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[K+44>>2]|0;if(!((a|0)==(K+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=L+36|0;a=k[e>>2]|0;if(a|0?(J=a+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;do if(!a){a=k[L+32>>2]|0;if(a|0)break;a=B1()|0;d=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;K=L+16|0;e=L+4|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[e>>2]|0)>0){d=k[I>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[L+44>>2]|0;if((a|0)==(L+48|0)|(a|0)==0){r=M;return}ggb(k[a+-4>>2]|0);r=M;return}function G_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,j=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,v=0;switch(e|0){case 2:{p=d<<1;if((d|0)<=0)return;n=c+8|0;e=c+16|0;d=c+20|0;m=0;do{g=+o[n>>2]+ +o[c>>2]*+(l[a+m>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=(h>>>0<256?h:(h|0)>0?255:0)&255;j=m|1;g=+o[d>>2]+ +o[e>>2]*+(l[a+j>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}v=~~g;i[b+m>>0]=h;i[b+j>>0]=v>>>0<256?v:(v|0)>0?255:0;m=m+2|0}while((m|0)<(p|0));return}case 3:{t=d*3|0;if((d|0)<=0)return;d=c+12|0;p=c+20|0;q=c+28|0;r=c+40|0;s=c+44|0;e=0;do{g=+o[d>>2]+ +o[c>>2]*+(l[a+e>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}m=~~g;m=(m>>>0<256?m:(m|0)>0?255:0)&255;n=e+1|0;g=+o[q>>2]+ +o[p>>2]*+(l[a+n>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=(h>>>0<256?h:(h|0)>0?255:0)&255;j=e+2|0;g=+o[s>>2]+ +o[r>>2]*+(l[a+j>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}v=~~g;i[b+e>>0]=m;i[b+n>>0]=h;i[b+j>>0]=v>>>0<256?v:(v|0)>0?255:0;e=e+3|0}while((e|0)<(t|0));return}case 4:{v=d<<2;if((d|0)<=0)return;s=c+16|0;t=c+24|0;e=c+36|0;d=c+48|0;p=c+56|0;q=c+72|0;r=c+76|0;n=0;do{g=+o[s>>2]+ +o[c>>2]*+(l[a+n>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=(h>>>0<256?h:(h|0)>0?255:0)&255;j=n|1;g=+o[e>>2]+ +o[t>>2]*+(l[a+j>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}m=~~g;i[b+n>>0]=h;i[b+j>>0]=m>>>0<256?m:(m|0)>0?255:0;m=n|2;g=+o[p>>2]+ +o[d>>2]*+(l[a+m>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=(h>>>0<256?h:(h|0)>0?255:0)&255;j=n|3;g=+o[r>>2]+ +o[q>>2]*+(l[a+j>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}f=~~g;i[b+m>>0]=h;i[b+j>>0]=f>>>0<256?f:(f|0)>0?255:0;n=n+4|0}while((n|0)<(v|0));return}default:{if((d|0)<=0)return;n=e+1|0;if((e|0)>0)m=0;else return;while(1){h=c;j=0;while(1){g=+(l[a+j>>0]|0)*+o[h+(j<<2)>>2]+ +o[h+(e<<2)>>2];f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}v=~~g;i[b+j>>0]=v>>>0<256?v:(v|0)>0?255:0;j=j+1|0;if((j|0)==(e|0))break;else h=h+(n<<2)|0}m=m+1|0;if((m|0)==(d|0))break;else{a=a+e|0;b=b+e|0}}return}}}function H_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0;switch(e|0){case 2:{n=d<<1;if((d|0)<=0)return;m=c+8|0;e=c+16|0;d=c+20|0;l=0;do{g=+o[m>>2]+ +o[c>>2]*+(i[a+l>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=((h+128|0)>>>0<256?h:(h|0)>0?127:128)&255;j=l|1;g=+o[d>>2]+ +o[e>>2]*+(i[a+j>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}t=~~g;i[b+l>>0]=h;i[b+j>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;l=l+2|0}while((l|0)<(n|0));return}case 3:{s=d*3|0;if((d|0)<=0)return;d=c+12|0;n=c+20|0;p=c+28|0;q=c+40|0;r=c+44|0;e=0;do{g=+o[d>>2]+ +o[c>>2]*+(i[a+e>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}l=~~g;l=((l+128|0)>>>0<256?l:(l|0)>0?127:128)&255;m=e+1|0;g=+o[p>>2]+ +o[n>>2]*+(i[a+m>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=((h+128|0)>>>0<256?h:(h|0)>0?127:128)&255;j=e+2|0;g=+o[r>>2]+ +o[q>>2]*+(i[a+j>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}t=~~g;i[b+e>>0]=l;i[b+m>>0]=h;i[b+j>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;e=e+3|0}while((e|0)<(s|0));return}case 4:{t=d<<2;if((d|0)<=0)return;r=c+16|0;s=c+24|0;e=c+36|0;d=c+48|0;n=c+56|0;p=c+72|0;q=c+76|0;m=0;do{g=+o[r>>2]+ +o[c>>2]*+(i[a+m>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=((h+128|0)>>>0<256?h:(h|0)>0?127:128)&255;j=m|1;g=+o[e>>2]+ +o[s>>2]*+(i[a+j>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}l=~~g;i[b+m>>0]=h;i[b+j>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;l=m|2;g=+o[n>>2]+ +o[d>>2]*+(i[a+l>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=((h+128|0)>>>0<256?h:(h|0)>0?127:128)&255;j=m|3;g=+o[q>>2]+ +o[p>>2]*+(i[a+j>>0]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}f=~~g;i[b+l>>0]=h;i[b+j>>0]=(f+128|0)>>>0<256?f:(f|0)>0?127:128;m=m+4|0}while((m|0)<(t|0));return}default:{if((d|0)<=0)return;m=e+1|0;if((e|0)>0)l=0;else return;while(1){h=c;j=0;while(1){g=+(i[a+j>>0]|0)*+o[h+(j<<2)>>2]+ +o[h+(e<<2)>>2];f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}t=~~g;i[b+j>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;j=j+1|0;if((j|0)==(e|0))break;else h=h+(m<<2)|0}l=l+1|0;if((l|0)==(d|0))break;else{a=a+e|0;b=b+e|0}}return}}}function I_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0,l=0,n=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0,x=0.0,y=0.0;switch(e|0){case 2:{n=d<<1;if((d|0)<=0)return;q=+o[c>>2];r=+o[c+8>>2];s=+o[c+16>>2];p=+o[c+20>>2];l=0;do{g=r+q*+(m[a+(l<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}i=~~g;i=(i>>>0<65536?i:(i|0)>0?65535:0)&65535;h=l|1;g=p+s*+(m[a+(h<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}c=~~g;j[b+(l<<1)>>1]=i;j[b+(h<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;l=l+2|0}while((l|0)<(n|0));return}case 3:{w=d*3|0;if((d|0)<=0)return;q=+o[c>>2];r=+o[c+12>>2];s=+o[c+20>>2];t=+o[c+28>>2];v=+o[c+40>>2];p=+o[c+44>>2];e=0;do{g=r+q*+(m[a+(e<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}l=~~g;l=(l>>>0<65536?l:(l|0)>0?65535:0)&65535;n=e+1|0;g=t+s*+(m[a+(n<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=(h>>>0<65536?h:(h|0)>0?65535:0)&65535;i=e+2|0;g=p+v*+(m[a+(i<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}c=~~g;j[b+(e<<1)>>1]=l;j[b+(n<<1)>>1]=h;j[b+(i<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;e=e+3|0}while((e|0)<(w|0));return}case 4:{e=d<<2;if((d|0)<=0)return;y=+o[c>>2];q=+o[c+16>>2];r=+o[c+24>>2];s=+o[c+36>>2];t=+o[c+48>>2];v=+o[c+56>>2];x=+o[c+72>>2];p=+o[c+76>>2];n=0;do{g=q+y*+(m[a+(n<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=(h>>>0<65536?h:(h|0)>0?65535:0)&65535;i=n|1;g=s+r*+(m[a+(i<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}l=~~g;j[b+(n<<1)>>1]=h;j[b+(i<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;l=n|2;g=v+t*+(m[a+(l<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=(h>>>0<65536?h:(h|0)>0?65535:0)&65535;i=n|3;g=p+x*+(m[a+(i<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}c=~~g;j[b+(l<<1)>>1]=h;j[b+(i<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;n=n+4|0}while((n|0)<(e|0));return}default:{if((d|0)<=0)return;n=e+1|0;if((e|0)>0)l=0;else return;while(1){h=c;i=0;while(1){g=+(m[a+(i<<1)>>1]|0)*+o[h+(i<<2)>>2]+ +o[h+(e<<2)>>2];f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}w=~~g;j[b+(i<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;i=i+1|0;if((i|0)==(e|0))break;else h=h+(n<<2)|0}l=l+1|0;if((l|0)==(d|0))break;else{a=a+(e<<1)|0;b=b+(e<<1)|0}}return}}}function J_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0,l=0,m=0,n=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,v=0,w=0.0,x=0.0;switch(e|0){case 2:{m=d<<1;if((d|0)<=0)return;p=+o[c>>2];q=+o[c+8>>2];r=+o[c+16>>2];n=+o[c+20>>2];l=0;do{g=q+p*+(j[a+(l<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=((h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768)&65535;i=l|1;g=n+r*+(j[a+(i<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}c=~~g;j[b+(l<<1)>>1]=h;j[b+(i<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;l=l+2|0}while((l|0)<(m|0));return}case 3:{v=d*3|0;if((d|0)<=0)return;p=+o[c>>2];q=+o[c+12>>2];r=+o[c+20>>2];s=+o[c+28>>2];t=+o[c+40>>2];n=+o[c+44>>2];e=0;do{g=q+p*+(j[a+(e<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}l=~~g;l=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;m=e+1|0;g=s+r*+(j[a+(m<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=((h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768)&65535;i=e+2|0;g=n+t*+(j[a+(i<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}c=~~g;j[b+(e<<1)>>1]=l;j[b+(m<<1)>>1]=h;j[b+(i<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;e=e+3|0}while((e|0)<(v|0));return}case 4:{e=d<<2;if((d|0)<=0)return;x=+o[c>>2];p=+o[c+16>>2];q=+o[c+24>>2];r=+o[c+36>>2];s=+o[c+48>>2];t=+o[c+56>>2];w=+o[c+72>>2];n=+o[c+76>>2];m=0;do{g=p+x*+(j[a+(m<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=((h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768)&65535;i=m|1;g=r+q*+(j[a+(i<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}l=~~g;j[b+(m<<1)>>1]=h;j[b+(i<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;l=m|2;g=t+s*+(j[a+(l<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;h=((h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768)&65535;i=m|3;g=n+w*+(j[a+(i<<1)>>1]|0);f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}c=~~g;j[b+(l<<1)>>1]=h;j[b+(i<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;m=m+4|0}while((m|0)<(e|0));return}default:{if((d|0)<=0)return;m=e+1|0;if((e|0)>0)l=0;else return;while(1){h=c;i=0;while(1){g=+(j[a+(i<<1)>>1]|0)*+o[h+(i<<2)>>2]+ +o[h+(e<<2)>>2];f=(o[u>>2]=g,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;g=f?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=f?-0.0:0.0}v=~~g;j[b+(i<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;i=i+1|0;if((i|0)==(e|0))break;else h=h+(m<<2)|0}l=l+1|0;if((l|0)==(d|0))break;else{a=a+(e<<1)|0;b=b+(e<<1)|0}}return}}}function K_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0,j=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,v=0.0,w=0.0;switch(e|0){case 2:{l=d<<1;if((d|0)<=0)return;n=+p[c>>3];o=+p[c+16>>3];q=+p[c+32>>3];m=+p[c+40>>3];j=0;do{g=o+n*+(k[a+(j<<2)>>2]|0);p[u>>3]=g;f=k[u+4>>2]|0;c=f&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){f=(f|0)<0;g=f?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=f?-0.0:0.0}i=~~g;h=j|1;g=m+q*+(k[a+(h<<2)>>2]|0);p[u>>3]=g;f=k[u+4>>2]|0;c=f&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){f=(f|0)<0;g=f?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=f?-0.0:0.0}k[b+(j<<2)>>2]=i;k[b+(h<<2)>>2]=~~g;j=j+2|0}while((j|0)<(l|0));return}case 3:{t=d*3|0;if((d|0)<=0)return;n=+p[c>>3];o=+p[c+24>>3];q=+p[c+40>>3];r=+p[c+56>>3];s=+p[c+80>>3];m=+p[c+88>>3];e=0;do{g=o+n*+(k[a+(e<<2)>>2]|0);p[u>>3]=g;f=k[u+4>>2]|0;c=f&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){f=(f|0)<0;g=f?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=f?-0.0:0.0}j=~~g;l=e+1|0;g=r+q*+(k[a+(l<<2)>>2]|0);p[u>>3]=g;f=k[u+4>>2]|0;c=f&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){f=(f|0)<0;g=f?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;i=e+2|0;g=m+s*+(k[a+(i<<2)>>2]|0);p[u>>3]=g;f=k[u+4>>2]|0;c=f&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){f=(f|0)<0;g=f?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=f?-0.0:0.0}k[b+(e<<2)>>2]=j;k[b+(l<<2)>>2]=h;k[b+(i<<2)>>2]=~~g;e=e+3|0}while((e|0)<(t|0));return}case 4:{e=d<<2;if((d|0)<=0)return;w=+p[c>>3];n=+p[c+32>>3];o=+p[c+48>>3];q=+p[c+72>>3];r=+p[c+96>>3];s=+p[c+112>>3];v=+p[c+144>>3];m=+p[c+152>>3];l=0;do{g=n+w*+(k[a+(l<<2)>>2]|0);p[u>>3]=g;f=k[u+4>>2]|0;c=f&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){f=(f|0)<0;g=f?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;i=l|1;g=q+o*+(k[a+(i<<2)>>2]|0);p[u>>3]=g;f=k[u+4>>2]|0;c=f&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){f=(f|0)<0;g=f?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=f?-0.0:0.0}k[b+(l<<2)>>2]=h;k[b+(i<<2)>>2]=~~g;j=l|2;g=s+r*+(k[a+(j<<2)>>2]|0);p[u>>3]=g;f=k[u+4>>2]|0;c=f&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){f=(f|0)<0;g=f?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=f?-0.0:0.0}h=~~g;i=l|3;g=m+v*+(k[a+(i<<2)>>2]|0);p[u>>3]=g;f=k[u+4>>2]|0;c=f&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){f=(f|0)<0;g=f?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=f?-0.0:0.0}k[b+(j<<2)>>2]=h;k[b+(i<<2)>>2]=~~g;l=l+4|0}while((l|0)<(e|0));return}default:{if((d|0)<=0)return;l=e+1|0;if((e|0)>0)j=0;else return;while(1){h=c;i=0;while(1){g=+(k[a+(i<<2)>>2]|0)*+p[h+(i<<3)>>3]+ +p[h+(e<<3)>>3];p[u>>3]=g;f=k[u+4>>2]|0;t=f&2146435072;if(!(t>>>0>1126170624|(t|0)==1126170624&0>0)){f=(f|0)<0;g=f?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=f?-0.0:0.0}k[b+(i<<2)>>2]=~~g;i=i+1|0;if((i|0)==(e|0))break;else h=h+(l<<3)|0}j=j+1|0;if((j|0)==(d|0))break;else{a=a+(e<<2)|0;b=b+(e<<2)|0}}return}}}function L_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,p=0,q=0;switch(e|0){case 2:{j=d<<1;if((d|0)<=0)return;g=c+8|0;h=c+16|0;i=c+20|0;f=0;do{l=f|1;m=+o[h>>2]*+o[a+(l<<2)>>2]+ +o[i>>2];o[b+(f<<2)>>2]=+o[c>>2]*+o[a+(f<<2)>>2]+ +o[g>>2];o[b+(l<<2)>>2]=m;f=f+2|0}while((f|0)<(j|0));return}case 3:{e=d*3|0;if((d|0)<=0)return;g=c+12|0;h=c+20|0;i=c+28|0;j=c+40|0;k=c+44|0;f=0;do{d=f+1|0;n=+o[h>>2]*+o[a+(d<<2)>>2]+ +o[i>>2];l=f+2|0;m=+o[j>>2]*+o[a+(l<<2)>>2]+ +o[k>>2];o[b+(f<<2)>>2]=+o[c>>2]*+o[a+(f<<2)>>2]+ +o[g>>2];o[b+(d<<2)>>2]=n;o[b+(l<<2)>>2]=m;f=f+3|0}while((f|0)<(e|0));return}case 4:{l=d<<2;if((d|0)<=0)return;e=c+16|0;d=c+24|0;g=c+36|0;h=c+48|0;i=c+56|0;j=c+72|0;k=c+76|0;f=0;do{q=f|1;n=+o[d>>2]*+o[a+(q<<2)>>2]+ +o[g>>2];o[b+(f<<2)>>2]=+o[c>>2]*+o[a+(f<<2)>>2]+ +o[e>>2];o[b+(q<<2)>>2]=n;q=f|2;p=f|3;n=+o[j>>2]*+o[a+(p<<2)>>2]+ +o[k>>2];o[b+(q<<2)>>2]=+o[h>>2]*+o[a+(q<<2)>>2]+ +o[i>>2];o[b+(p<<2)>>2]=n;f=f+4|0}while((f|0)<(l|0));return}default:{if((d|0)<=0)return;k=e+1|0;if((e|0)>0){j=a;g=b;i=0}else return;while(1){f=c;h=0;while(1){o[g+(h<<2)>>2]=+o[j+(h<<2)>>2]*+o[f+(h<<2)>>2]+ +o[f+(e<<2)>>2];h=h+1|0;if((h|0)==(e|0))break;else f=f+(k<<2)|0}i=i+1|0;if((i|0)==(d|0))break;else{j=j+(e<<2)|0;g=g+(e<<2)|0}}return}}}function M_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,q=0;switch(e|0){case 2:{j=d<<1;if((d|0)<=0)return;g=c+16|0;h=c+32|0;i=c+40|0;f=0;do{l=f|1;m=+p[h>>3]*+p[a+(l<<3)>>3]+ +p[i>>3];p[b+(f<<3)>>3]=+p[c>>3]*+p[a+(f<<3)>>3]+ +p[g>>3];p[b+(l<<3)>>3]=m;f=f+2|0}while((f|0)<(j|0));return}case 3:{e=d*3|0;if((d|0)<=0)return;g=c+24|0;h=c+40|0;i=c+56|0;j=c+80|0;k=c+88|0;f=0;do{d=f+1|0;n=+p[h>>3]*+p[a+(d<<3)>>3]+ +p[i>>3];l=f+2|0;m=+p[j>>3]*+p[a+(l<<3)>>3]+ +p[k>>3];p[b+(f<<3)>>3]=+p[c>>3]*+p[a+(f<<3)>>3]+ +p[g>>3];p[b+(d<<3)>>3]=n;p[b+(l<<3)>>3]=m;f=f+3|0}while((f|0)<(e|0));return}case 4:{l=d<<2;if((d|0)<=0)return;e=c+32|0;d=c+48|0;g=c+72|0;h=c+96|0;i=c+112|0;j=c+144|0;k=c+152|0;f=0;do{q=f|1;n=+p[d>>3]*+p[a+(q<<3)>>3]+ +p[g>>3];p[b+(f<<3)>>3]=+p[c>>3]*+p[a+(f<<3)>>3]+ +p[e>>3];p[b+(q<<3)>>3]=n;q=f|2;o=f|3;n=+p[j>>3]*+p[a+(o<<3)>>3]+ +p[k>>3];p[b+(q<<3)>>3]=+p[h>>3]*+p[a+(q<<3)>>3]+ +p[i>>3];p[b+(o<<3)>>3]=n;f=f+4|0}while((f|0)<(l|0));return}default:{if((d|0)<=0)return;k=e+1|0;if((e|0)>0){j=a;g=b;i=0}else return;while(1){f=c;h=0;while(1){p[g+(h<<3)>>3]=+p[j+(h<<3)>>3]*+p[f+(h<<3)>>3]+ +p[f+(e<<3)>>3];h=h+1|0;if((h|0)==(e|0))break;else f=f+(k<<3)|0}i=i+1|0;if((i|0)==(d|0))break;else{j=j+(e<<3)|0;g=g+(e<<3)|0}}return}}}function N_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,j=0,m=0,n=0,p=0,q=0.0,r=0.0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;if((e|0)==2&(f|0)==2){t=d<<1;if((d|0)<=0)return;n=c+4|0;p=c+8|0;e=c+12|0;f=c+16|0;d=c+20|0;m=0;do{q=+(l[a+m>>0]|0);s=m|1;r=+(l[a+s>>0]|0);h=+o[p>>2]+(q*+o[c>>2]+r*+o[n>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}j=~~h;j=(j>>>0<256?j:(j|0)>0?255:0)&255;h=+o[d>>2]+(q*+o[e>>2]+r*+o[f>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}M=~~h;i[b+m>>0]=j;i[b+s>>0]=M>>>0<256?M:(M|0)>0?255:0;m=m+2|0}while((m|0)<(t|0));return}g=(e|0)==3;if(g&(f|0)==3){D=d*3|0;if((d|0)<=0)return;p=c+4|0;e=c+8|0;f=c+12|0;d=c+16|0;s=c+20|0;t=c+24|0;w=c+28|0;x=c+32|0;y=c+36|0;z=c+40|0;A=c+44|0;n=0;do{q=+(l[a+n>>0]|0);B=n+1|0;r=+(l[a+B>>0]|0);C=n+2|0;v=+(l[a+C>>0]|0);h=+o[f>>2]+(q*+o[c>>2]+r*+o[p>>2]+v*+o[e>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}m=~~h;m=(m>>>0<256?m:(m|0)>0?255:0)&255;h=+o[w>>2]+(q*+o[d>>2]+r*+o[s>>2]+v*+o[t>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}j=~~h;j=(j>>>0<256?j:(j|0)>0?255:0)&255;h=+o[A>>2]+(q*+o[x>>2]+r*+o[y>>2]+v*+o[z>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}M=~~h;i[b+n>>0]=m;i[b+B>>0]=j;i[b+C>>0]=M>>>0<256?M:(M|0)>0?255:0;n=n+3|0}while((n|0)<(D|0));return}if(g&(f|0)==1){if((d|0)<=0)return;m=c+4|0;n=c+8|0;p=c+12|0;j=0;while(1){h=+o[p>>2]+(+o[c>>2]*+(l[a>>0]|0)+ +o[m>>2]*+(l[a+1>>0]|0)+ +o[n>>2]*+(l[a+2>>0]|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}M=~~h;i[b+j>>0]=M>>>0<256?M:(M|0)>0?255:0;j=j+1|0;if((j|0)==(d|0))break;else a=a+3|0}return}if((e|0)==4&(f|0)==4){M=d<<2;if((d|0)<=0)return;p=c+4|0;e=c+8|0;f=c+12|0;d=c+16|0;s=c+20|0;t=c+24|0;w=c+28|0;x=c+32|0;y=c+36|0;z=c+40|0;A=c+44|0;B=c+48|0;C=c+52|0;D=c+56|0;F=c+60|0;G=c+64|0;H=c+68|0;I=c+72|0;J=c+76|0;n=0;do{q=+(l[a+n>>0]|0);m=n|1;r=+(l[a+m>>0]|0);K=n|2;v=+(l[a+K>>0]|0);L=n|3;E=+(l[a+L>>0]|0);h=+o[d>>2]+(q*+o[c>>2]+r*+o[p>>2]+v*+o[e>>2]+E*+o[f>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}j=~~h;j=(j>>>0<256?j:(j|0)>0?255:0)&255;h=+o[y>>2]+(q*+o[s>>2]+r*+o[t>>2]+v*+o[w>>2]+E*+o[x>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}g=~~h;i[b+n>>0]=j;i[b+m>>0]=g>>>0<256?g:(g|0)>0?255:0;h=+o[D>>2]+(q*+o[z>>2]+r*+o[A>>2]+v*+o[B>>2]+E*+o[C>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}j=~~h;j=(j>>>0<256?j:(j|0)>0?255:0)&255;h=+o[J>>2]+(q*+o[F>>2]+r*+o[G>>2]+v*+o[H>>2]+E*+o[I>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}m=~~h;i[b+K>>0]=j;i[b+L>>0]=m>>>0<256?m:(m|0)>0?255:0;n=n+4|0}while((n|0)<(M|0));return}if((d|0)<=0)return;p=e+1|0;if((f|0)<=0)return;if((e|0)>0)n=0;else{m=0;while(1){a=0;j=c;while(1){h=+o[j+(e<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}M=~~h;i[b+a>>0]=M>>>0<256?M:(M|0)>0?255:0;a=a+1|0;if((a|0)==(f|0))break;else j=j+(p<<2)|0}m=m+1|0;if((m|0)==(d|0))break;else b=b+f|0}return}while(1){j=0;m=c;while(1){g=0;h=+o[m+(e<<2)>>2];do{h=h+ +o[m+(g<<2)>>2]*+(l[a+g>>0]|0);g=g+1|0}while((g|0)!=(e|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}M=~~h;i[b+j>>0]=M>>>0<256?M:(M|0)>0?255:0;j=j+1|0;if((j|0)==(f|0))break;else m=m+(p<<2)|0}n=n+1|0;if((n|0)==(d|0))break;else{b=b+f|0;a=a+e|0}}return}function O_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,j=0,l=0,m=0,n=0,p=0.0,q=0.0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;if((e|0)==2&(f|0)==2){s=d<<1;if((d|0)<=0)return;m=c+4|0;n=c+8|0;e=c+12|0;f=c+16|0;d=c+20|0;l=0;do{p=+(i[a+l>>0]|0);r=l|1;q=+(i[a+r>>0]|0);h=+o[n>>2]+(p*+o[c>>2]+q*+o[m>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}j=~~h;j=((j+128|0)>>>0<256?j:(j|0)>0?127:128)&255;h=+o[d>>2]+(p*+o[e>>2]+q*+o[f>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}L=~~h;i[b+l>>0]=j;i[b+r>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;l=l+2|0}while((l|0)<(s|0));return}g=(e|0)==3;if(g&(f|0)==3){C=d*3|0;if((d|0)<=0)return;n=c+4|0;e=c+8|0;f=c+12|0;d=c+16|0;r=c+20|0;s=c+24|0;v=c+28|0;w=c+32|0;x=c+36|0;y=c+40|0;z=c+44|0;m=0;do{p=+(i[a+m>>0]|0);A=m+1|0;q=+(i[a+A>>0]|0);B=m+2|0;t=+(i[a+B>>0]|0);h=+o[f>>2]+(p*+o[c>>2]+q*+o[n>>2]+t*+o[e>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}l=~~h;l=((l+128|0)>>>0<256?l:(l|0)>0?127:128)&255;h=+o[v>>2]+(p*+o[d>>2]+q*+o[r>>2]+t*+o[s>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}j=~~h;j=((j+128|0)>>>0<256?j:(j|0)>0?127:128)&255;h=+o[z>>2]+(p*+o[w>>2]+q*+o[x>>2]+t*+o[y>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}L=~~h;i[b+m>>0]=l;i[b+A>>0]=j;i[b+B>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;m=m+3|0}while((m|0)<(C|0));return}if(g&(f|0)==1){if((d|0)<=0)return;l=c+4|0;m=c+8|0;n=c+12|0;j=0;while(1){h=+o[n>>2]+(+o[c>>2]*+(i[a>>0]|0)+ +o[l>>2]*+(i[a+1>>0]|0)+ +o[m>>2]*+(i[a+2>>0]|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}L=~~h;i[b+j>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;j=j+1|0;if((j|0)==(d|0))break;else a=a+3|0}return}if((e|0)==4&(f|0)==4){L=d<<2;if((d|0)<=0)return;n=c+4|0;e=c+8|0;f=c+12|0;d=c+16|0;r=c+20|0;s=c+24|0;v=c+28|0;w=c+32|0;x=c+36|0;y=c+40|0;z=c+44|0;A=c+48|0;B=c+52|0;C=c+56|0;E=c+60|0;F=c+64|0;G=c+68|0;H=c+72|0;I=c+76|0;m=0;do{p=+(i[a+m>>0]|0);l=m|1;q=+(i[a+l>>0]|0);J=m|2;t=+(i[a+J>>0]|0);K=m|3;D=+(i[a+K>>0]|0);h=+o[d>>2]+(p*+o[c>>2]+q*+o[n>>2]+t*+o[e>>2]+D*+o[f>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}j=~~h;j=((j+128|0)>>>0<256?j:(j|0)>0?127:128)&255;h=+o[x>>2]+(p*+o[r>>2]+q*+o[s>>2]+t*+o[v>>2]+D*+o[w>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}g=~~h;i[b+m>>0]=j;i[b+l>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;h=+o[C>>2]+(p*+o[y>>2]+q*+o[z>>2]+t*+o[A>>2]+D*+o[B>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}j=~~h;j=((j+128|0)>>>0<256?j:(j|0)>0?127:128)&255;h=+o[I>>2]+(p*+o[E>>2]+q*+o[F>>2]+t*+o[G>>2]+D*+o[H>>2]);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}l=~~h;i[b+J>>0]=j;i[b+K>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;m=m+4|0}while((m|0)<(L|0));return}if((d|0)<=0)return;n=e+1|0;if((f|0)<=0)return;if((e|0)>0)m=0;else{l=0;while(1){a=0;j=c;while(1){h=+o[j+(e<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}L=~~h;i[b+a>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;a=a+1|0;if((a|0)==(f|0))break;else j=j+(n<<2)|0}l=l+1|0;if((l|0)==(d|0))break;else b=b+f|0}return}while(1){j=0;l=c;while(1){g=0;h=+o[l+(e<<2)>>2];do{h=h+ +o[l+(g<<2)>>2]*+(i[a+g>>0]|0);g=g+1|0}while((g|0)!=(e|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}L=~~h;i[b+j>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;j=j+1|0;if((j|0)==(f|0))break;else l=l+(n<<2)|0}m=m+1|0;if((m|0)==(d|0))break;else{b=b+f|0;a=a+e|0}}return}function P_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,l=0,n=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0;if((e|0)==2&(f|0)==2){y=d<<1;if((d|0)<=0)return;r=+o[c>>2];t=+o[c+4>>2];v=+o[c+8>>2];w=+o[c+12>>2];x=+o[c+16>>2];q=+o[c+20>>2];l=0;do{n=+(m[a+(l<<1)>>1]|0);s=l|1;p=+(m[a+(s<<1)>>1]|0);h=v+(r*n+t*p);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;i=(i>>>0<65536?i:(i|0)>0?65535:0)&65535;h=q+(w*n+x*p);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}c=~~h;j[b+(l<<1)>>1]=i;j[b+(s<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;l=l+2|0}while((l|0)<(y|0));return}g=(e|0)==3;if(g&(f|0)==3){f=d*3|0;if((d|0)<=0)return;t=+o[c>>2];v=+o[c+4>>2];w=+o[c+8>>2];x=+o[c+12>>2];z=+o[c+16>>2];A=+o[c+20>>2];B=+o[c+24>>2];C=+o[c+28>>2];D=+o[c+32>>2];E=+o[c+36>>2];F=+o[c+40>>2];r=+o[c+44>>2];s=0;do{n=+(m[a+(s<<1)>>1]|0);y=s+1|0;p=+(m[a+(y<<1)>>1]|0);e=s+2|0;q=+(m[a+(e<<1)>>1]|0);h=x+(t*n+v*p+w*q);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}l=~~h;l=(l>>>0<65536?l:(l|0)>0?65535:0)&65535;h=C+(z*n+A*p+B*q);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;i=(i>>>0<65536?i:(i|0)>0?65535:0)&65535;h=r+(D*n+E*p+F*q);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}c=~~h;j[b+(s<<1)>>1]=l;j[b+(y<<1)>>1]=i;j[b+(e<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;s=s+3|0}while((s|0)<(f|0));return}if(g&(f|0)==1){if((d|0)<=0)return;p=+o[c>>2];q=+o[c+4>>2];r=+o[c+8>>2];n=+o[c+12>>2];i=0;while(1){h=n+(p*+(m[a>>1]|0)+q*+(m[a+2>>1]|0)+r*+(m[a+4>>1]|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}c=~~h;j[b+(i<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;i=i+1|0;if((i|0)==(d|0))break;else a=a+6|0}return}if((e|0)==4&(f|0)==4){f=d<<2;if((d|0)<=0)return;v=+o[c>>2];w=+o[c+4>>2];x=+o[c+8>>2];z=+o[c+12>>2];A=+o[c+16>>2];B=+o[c+20>>2];C=+o[c+24>>2];D=+o[c+28>>2];E=+o[c+32>>2];F=+o[c+36>>2];G=+o[c+40>>2];H=+o[c+44>>2];I=+o[c+48>>2];J=+o[c+52>>2];K=+o[c+56>>2];L=+o[c+60>>2];M=+o[c+64>>2];N=+o[c+68>>2];O=+o[c+72>>2];t=+o[c+76>>2];s=0;do{n=+(m[a+(s<<1)>>1]|0);l=s|1;p=+(m[a+(l<<1)>>1]|0);y=s|2;q=+(m[a+(y<<1)>>1]|0);e=s|3;r=+(m[a+(e<<1)>>1]|0);h=A+(v*n+w*p+x*q+z*r);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;i=(i>>>0<65536?i:(i|0)>0?65535:0)&65535;h=F+(B*n+C*p+D*q+E*r);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}g=~~h;j[b+(s<<1)>>1]=i;j[b+(l<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;h=K+(G*n+H*p+I*q+J*r);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;i=(i>>>0<65536?i:(i|0)>0?65535:0)&65535;h=t+(L*n+M*p+N*q+O*r);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}c=~~h;j[b+(y<<1)>>1]=i;j[b+(e<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;s=s+4|0}while((s|0)<(f|0));return}if((d|0)<=0)return;y=e+1|0;if((f|0)<=0)return;if((e|0)>0)s=0;else{l=0;while(1){a=0;i=c;while(1){h=+o[i+(e<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}s=~~h;j[b+(a<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+1|0;if((a|0)==(f|0))break;else i=i+(y<<2)|0}l=l+1|0;if((l|0)==(d|0))break;else b=b+(f<<1)|0}return}while(1){i=0;l=c;while(1){g=0;h=+o[l+(e<<2)>>2];do{h=h+ +o[l+(g<<2)>>2]*+(m[a+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(e|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}g=~~h;j[b+(i<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;i=i+1|0;if((i|0)==(f|0))break;else l=l+(y<<2)|0}s=s+1|0;if((s|0)==(d|0))break;else{b=b+(f<<1)|0;a=a+(e<<1)|0}}return}function Q_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,l=0,m=0.0,n=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0;if((e|0)==2&(f|0)==2){x=d<<1;if((d|0)<=0)return;q=+o[c>>2];s=+o[c+4>>2];t=+o[c+8>>2];v=+o[c+12>>2];w=+o[c+16>>2];p=+o[c+20>>2];l=0;do{m=+(j[a+(l<<1)>>1]|0);r=l|1;n=+(j[a+(r<<1)>>1]|0);h=t+(q*m+s*n);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;i=((i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768)&65535;h=p+(v*m+w*n);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}c=~~h;j[b+(l<<1)>>1]=i;j[b+(r<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;l=l+2|0}while((l|0)<(x|0));return}g=(e|0)==3;if(g&(f|0)==3){f=d*3|0;if((d|0)<=0)return;s=+o[c>>2];t=+o[c+4>>2];v=+o[c+8>>2];w=+o[c+12>>2];y=+o[c+16>>2];z=+o[c+20>>2];A=+o[c+24>>2];B=+o[c+28>>2];C=+o[c+32>>2];D=+o[c+36>>2];E=+o[c+40>>2];q=+o[c+44>>2];r=0;do{m=+(j[a+(r<<1)>>1]|0);x=r+1|0;n=+(j[a+(x<<1)>>1]|0);e=r+2|0;p=+(j[a+(e<<1)>>1]|0);h=w+(s*m+t*n+v*p);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}l=~~h;l=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;h=B+(y*m+z*n+A*p);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;i=((i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768)&65535;h=q+(C*m+D*n+E*p);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}c=~~h;j[b+(r<<1)>>1]=l;j[b+(x<<1)>>1]=i;j[b+(e<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;r=r+3|0}while((r|0)<(f|0));return}if(g&(f|0)==1){if((d|0)<=0)return;n=+o[c>>2];p=+o[c+4>>2];q=+o[c+8>>2];m=+o[c+12>>2];i=0;while(1){h=m+(n*+(j[a>>1]|0)+p*+(j[a+2>>1]|0)+q*+(j[a+4>>1]|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}c=~~h;j[b+(i<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;i=i+1|0;if((i|0)==(d|0))break;else a=a+6|0}return}if((e|0)==4&(f|0)==4){f=d<<2;if((d|0)<=0)return;t=+o[c>>2];v=+o[c+4>>2];w=+o[c+8>>2];y=+o[c+12>>2];z=+o[c+16>>2];A=+o[c+20>>2];B=+o[c+24>>2];C=+o[c+28>>2];D=+o[c+32>>2];E=+o[c+36>>2];F=+o[c+40>>2];G=+o[c+44>>2];H=+o[c+48>>2];I=+o[c+52>>2];J=+o[c+56>>2];K=+o[c+60>>2];L=+o[c+64>>2];M=+o[c+68>>2];N=+o[c+72>>2];s=+o[c+76>>2];r=0;do{m=+(j[a+(r<<1)>>1]|0);l=r|1;n=+(j[a+(l<<1)>>1]|0);x=r|2;p=+(j[a+(x<<1)>>1]|0);e=r|3;q=+(j[a+(e<<1)>>1]|0);h=z+(t*m+v*n+w*p+y*q);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;i=((i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768)&65535;h=E+(A*m+B*n+C*p+D*q);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}g=~~h;j[b+(r<<1)>>1]=i;j[b+(l<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;h=J+(F*m+G*n+H*p+I*q);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;i=((i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768)&65535;h=s+(K*m+L*n+M*p+N*q);g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}c=~~h;j[b+(x<<1)>>1]=i;j[b+(e<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;r=r+4|0}while((r|0)<(f|0));return}if((d|0)<=0)return;x=e+1|0;if((f|0)<=0)return;if((e|0)>0)r=0;else{l=0;while(1){a=0;i=c;while(1){h=+o[i+(e<<2)>>2];g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}r=~~h;j[b+(a<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;a=a+1|0;if((a|0)==(f|0))break;else i=i+(x<<2)|0}l=l+1|0;if((l|0)==(d|0))break;else b=b+(f<<1)|0}return}while(1){i=0;l=c;while(1){g=0;h=+o[l+(e<<2)>>2];do{h=h+ +o[l+(g<<2)>>2]*+(j[a+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(e|0));g=(o[u>>2]=h,k[u>>2]|0);if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;h=g?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=g?-0.0:0.0}g=~~h;j[b+(i<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;i=i+1|0;if((i|0)==(f|0))break;else l=l+(x<<2)|0}r=r+1|0;if((r|0)==(d|0))break;else{b=b+(f<<1)|0;a=a+(e<<1)|0}}return}function R_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0;if((e|0)==2&(f|0)==2){w=d<<1;if((d|0)<=0)return;o=+p[c>>3];r=+p[c+8>>3];s=+p[c+16>>3];t=+p[c+24>>3];v=+p[c+32>>3];n=+p[c+40>>3];j=0;do{l=+(k[a+(j<<2)>>2]|0);q=j|1;m=+(k[a+(q<<2)>>2]|0);h=s+(o*l+r*m);p[u>>3]=h;g=k[u+4>>2]|0;c=g&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){g=(g|0)<0;h=g?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;h=n+(t*l+v*m);p[u>>3]=h;g=k[u+4>>2]|0;c=g&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){g=(g|0)<0;h=g?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=g?-0.0:0.0}k[b+(j<<2)>>2]=i;k[b+(q<<2)>>2]=~~h;j=j+2|0}while((j|0)<(w|0));return}g=(e|0)==3;if(g&(f|0)==3){f=d*3|0;if((d|0)<=0)return;r=+p[c>>3];s=+p[c+8>>3];t=+p[c+16>>3];v=+p[c+24>>3];x=+p[c+32>>3];y=+p[c+40>>3];z=+p[c+48>>3];A=+p[c+56>>3];B=+p[c+64>>3];C=+p[c+72>>3];D=+p[c+80>>3];o=+p[c+88>>3];q=0;do{l=+(k[a+(q<<2)>>2]|0);w=q+1|0;m=+(k[a+(w<<2)>>2]|0);e=q+2|0;n=+(k[a+(e<<2)>>2]|0);h=v+(r*l+s*m+t*n);p[u>>3]=h;g=k[u+4>>2]|0;c=g&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){g=(g|0)<0;h=g?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=g?-0.0:0.0}j=~~h;h=A+(x*l+y*m+z*n);p[u>>3]=h;g=k[u+4>>2]|0;c=g&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){g=(g|0)<0;h=g?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;h=o+(B*l+C*m+D*n);p[u>>3]=h;g=k[u+4>>2]|0;c=g&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){g=(g|0)<0;h=g?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=g?-0.0:0.0}k[b+(q<<2)>>2]=j;k[b+(w<<2)>>2]=i;k[b+(e<<2)>>2]=~~h;q=q+3|0}while((q|0)<(f|0));return}if(g&(f|0)==1){if((d|0)<=0)return;m=+p[c>>3];n=+p[c+8>>3];o=+p[c+16>>3];l=+p[c+24>>3];i=0;while(1){h=l+(m*+(k[a>>2]|0)+n*+(k[a+4>>2]|0)+o*+(k[a+8>>2]|0));p[u>>3]=h;g=k[u+4>>2]|0;c=g&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){g=(g|0)<0;h=g?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=g?-0.0:0.0}k[b+(i<<2)>>2]=~~h;i=i+1|0;if((i|0)==(d|0))break;else a=a+12|0}return}if((e|0)==4&(f|0)==4){f=d<<2;if((d|0)<=0)return;s=+p[c>>3];t=+p[c+8>>3];v=+p[c+16>>3];x=+p[c+24>>3];y=+p[c+32>>3];z=+p[c+40>>3];A=+p[c+48>>3];B=+p[c+56>>3];C=+p[c+64>>3];D=+p[c+72>>3];E=+p[c+80>>3];F=+p[c+88>>3];G=+p[c+96>>3];H=+p[c+104>>3];I=+p[c+112>>3];J=+p[c+120>>3];K=+p[c+128>>3];L=+p[c+136>>3];M=+p[c+144>>3];r=+p[c+152>>3];q=0;do{l=+(k[a+(q<<2)>>2]|0);j=q|1;m=+(k[a+(j<<2)>>2]|0);w=q|2;n=+(k[a+(w<<2)>>2]|0);e=q|3;o=+(k[a+(e<<2)>>2]|0);h=y+(s*l+t*m+v*n+x*o);p[u>>3]=h;g=k[u+4>>2]|0;c=g&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){g=(g|0)<0;h=g?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;h=D+(z*l+A*m+B*n+C*o);p[u>>3]=h;g=k[u+4>>2]|0;c=g&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){g=(g|0)<0;h=g?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=g?-0.0:0.0}k[b+(q<<2)>>2]=i;k[b+(j<<2)>>2]=~~h;h=I+(E*l+F*m+G*n+H*o);p[u>>3]=h;g=k[u+4>>2]|0;c=g&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){g=(g|0)<0;h=g?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=g?-0.0:0.0}i=~~h;h=r+(J*l+K*m+L*n+M*o);p[u>>3]=h;g=k[u+4>>2]|0;c=g&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){g=(g|0)<0;h=g?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=g?-0.0:0.0}k[b+(w<<2)>>2]=i;k[b+(e<<2)>>2]=~~h;q=q+4|0}while((q|0)<(f|0));return}if((d|0)<=0)return;w=e+1|0;if((f|0)<=0)return;if((e|0)>0)q=0;else{j=0;while(1){a=0;i=c;while(1){h=+p[i+(e<<3)>>3];p[u>>3]=h;g=k[u+4>>2]|0;q=g&2146435072;if(!(q>>>0>1126170624|(q|0)==1126170624&0>0)){g=(g|0)<0;h=g?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=g?-0.0:0.0}k[b+(a<<2)>>2]=~~h;a=a+1|0;if((a|0)==(f|0))break;else i=i+(w<<3)|0}j=j+1|0;if((j|0)==(d|0))break;else b=b+(f<<2)|0}return}while(1){i=0;j=c;while(1){g=0;h=+p[j+(e<<3)>>3];do{h=h+ +p[j+(g<<3)>>3]*+(k[a+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(e|0));p[u>>3]=h;g=k[u+4>>2]|0;N=g&2146435072;if(!(N>>>0>1126170624|(N|0)==1126170624&0>0)){g=(g|0)<0;h=g?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=g?-0.0:0.0}k[b+(i<<2)>>2]=~~h;i=i+1|0;if((i|0)==(f|0))break;else j=j+(w<<3)|0}q=q+1|0;if((q|0)==(d|0))break;else{b=b+(f<<2)|0;a=a+(e<<2)|0}}return}function S_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0;if((e|0)==2&(f|0)==2){e=d<<1;if((d|0)<=0)return;h=c+4|0;i=c+8|0;j=c+12|0;l=c+16|0;m=c+20|0;g=0;do{C=+o[a+(g<<2)>>2];A=g|1;B=+o[a+(A<<2)>>2];n=+o[m>>2]+(C*+o[j>>2]+B*+o[l>>2]);o[b+(g<<2)>>2]=+o[i>>2]+(C*+o[c>>2]+B*+o[h>>2]);o[b+(A<<2)>>2]=n;g=g+2|0}while((g|0)<(e|0));return}g=(e|0)==3;if(g&(f|0)==3){s=d*3|0;if((d|0)<=0)return;h=c+4|0;i=c+8|0;j=c+12|0;l=c+16|0;m=c+20|0;e=c+24|0;f=c+28|0;d=c+32|0;p=c+36|0;q=c+40|0;r=c+44|0;g=0;do{E=+o[a+(g<<2)>>2];z=g+1|0;D=+o[a+(z<<2)>>2];A=g+2|0;n=+o[a+(A<<2)>>2];B=+o[f>>2]+(E*+o[l>>2]+D*+o[m>>2]+n*+o[e>>2]);C=+o[r>>2]+(E*+o[d>>2]+D*+o[p>>2]+n*+o[q>>2]);o[b+(g<<2)>>2]=+o[j>>2]+(E*+o[c>>2]+D*+o[h>>2]+n*+o[i>>2]);o[b+(z<<2)>>2]=B;o[b+(A<<2)>>2]=C;g=g+3|0}while((g|0)<(s|0));return}if(g&(f|0)==1){if((d|0)<=0)return;j=c+4|0;l=c+8|0;i=c+12|0;g=a;h=0;while(1){o[b+(h<<2)>>2]=+o[i>>2]+(+o[c>>2]*+o[g>>2]+ +o[j>>2]*+o[g+4>>2]+ +o[l>>2]*+o[g+8>>2]);h=h+1|0;if((h|0)==(d|0))break;else g=g+12|0}return}if((e|0)==4&(f|0)==4){A=d<<2;if((d|0)<=0)return;h=c+4|0;i=c+8|0;j=c+12|0;l=c+16|0;m=c+20|0;e=c+24|0;f=c+28|0;d=c+32|0;p=c+36|0;q=c+40|0;r=c+44|0;s=c+48|0;t=c+52|0;u=c+56|0;v=c+60|0;w=c+64|0;x=c+68|0;y=c+72|0;z=c+76|0;g=0;do{n=+o[a+(g<<2)>>2];H=g|1;B=+o[a+(H<<2)>>2];G=g|2;C=+o[a+(G<<2)>>2];F=g|3;D=+o[a+(F<<2)>>2];E=+o[p>>2]+(n*+o[m>>2]+B*+o[e>>2]+C*+o[f>>2]+D*+o[d>>2]);o[b+(g<<2)>>2]=+o[l>>2]+(n*+o[c>>2]+B*+o[h>>2]+C*+o[i>>2]+D*+o[j>>2]);o[b+(H<<2)>>2]=E;E=+o[z>>2]+(n*+o[v>>2]+B*+o[w>>2]+C*+o[x>>2]+D*+o[y>>2]);o[b+(G<<2)>>2]=+o[u>>2]+(n*+o[q>>2]+B*+o[r>>2]+C*+o[s>>2]+D*+o[t>>2]);o[b+(F<<2)>>2]=E;g=g+4|0}while((g|0)<(A|0));return}if((d|0)<=0)return;m=e+1|0;if((f|0)<=0)return;if((e|0)>0){j=a;l=0}else{i=0;while(1){g=0;h=c;while(1){k[b+(g<<2)>>2]=k[h+(e<<2)>>2];g=g+1|0;if((g|0)==(f|0))break;else h=h+(m<<2)|0}i=i+1|0;if((i|0)==(d|0))break;else b=b+(f<<2)|0}return}while(1){h=0;i=c;while(1){g=0;n=+o[i+(e<<2)>>2];do{n=n+ +o[i+(g<<2)>>2]*+o[j+(g<<2)>>2];g=g+1|0}while((g|0)!=(e|0));o[b+(h<<2)>>2]=n;h=h+1|0;if((h|0)==(f|0))break;else i=i+(m<<2)|0}l=l+1|0;if((l|0)==(d|0))break;else{b=b+(f<<2)|0;j=j+(e<<2)|0}}return}function T_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0;if((e|0)==2&(f|0)==2){e=d<<1;if((d|0)<=0)return;h=c+8|0;i=c+16|0;j=c+24|0;k=c+32|0;l=c+40|0;g=0;do{B=+p[a+(g<<3)>>3];z=g|1;A=+p[a+(z<<3)>>3];m=+p[l>>3]+(B*+p[j>>3]+A*+p[k>>3]);p[b+(g<<3)>>3]=+p[i>>3]+(B*+p[c>>3]+A*+p[h>>3]);p[b+(z<<3)>>3]=m;g=g+2|0}while((g|0)<(e|0));return}g=(e|0)==3;if(g&(f|0)==3){r=d*3|0;if((d|0)<=0)return;h=c+8|0;i=c+16|0;j=c+24|0;k=c+32|0;l=c+40|0;e=c+48|0;f=c+56|0;d=c+64|0;n=c+72|0;o=c+80|0;q=c+88|0;g=0;do{D=+p[a+(g<<3)>>3];y=g+1|0;C=+p[a+(y<<3)>>3];z=g+2|0;m=+p[a+(z<<3)>>3];A=+p[f>>3]+(D*+p[k>>3]+C*+p[l>>3]+m*+p[e>>3]);B=+p[q>>3]+(D*+p[d>>3]+C*+p[n>>3]+m*+p[o>>3]);p[b+(g<<3)>>3]=+p[j>>3]+(D*+p[c>>3]+C*+p[h>>3]+m*+p[i>>3]);p[b+(y<<3)>>3]=A;p[b+(z<<3)>>3]=B;g=g+3|0}while((g|0)<(r|0));return}if(g&(f|0)==1){if((d|0)<=0)return;j=c+8|0;k=c+16|0;i=c+24|0;g=a;h=0;while(1){p[b+(h<<3)>>3]=+p[i>>3]+(+p[c>>3]*+p[g>>3]+ +p[j>>3]*+p[g+8>>3]+ +p[k>>3]*+p[g+16>>3]);h=h+1|0;if((h|0)==(d|0))break;else g=g+24|0}return}if((e|0)==4&(f|0)==4){z=d<<2;if((d|0)<=0)return;h=c+8|0;i=c+16|0;j=c+24|0;k=c+32|0;l=c+40|0;e=c+48|0;f=c+56|0;d=c+64|0;n=c+72|0;o=c+80|0;q=c+88|0;r=c+96|0;s=c+104|0;t=c+112|0;u=c+120|0;v=c+128|0;w=c+136|0;x=c+144|0;y=c+152|0;g=0;do{m=+p[a+(g<<3)>>3];G=g|1;A=+p[a+(G<<3)>>3];F=g|2;B=+p[a+(F<<3)>>3];E=g|3;C=+p[a+(E<<3)>>3];D=+p[n>>3]+(m*+p[l>>3]+A*+p[e>>3]+B*+p[f>>3]+C*+p[d>>3]);p[b+(g<<3)>>3]=+p[k>>3]+(m*+p[c>>3]+A*+p[h>>3]+B*+p[i>>3]+C*+p[j>>3]);p[b+(G<<3)>>3]=D;D=+p[y>>3]+(m*+p[u>>3]+A*+p[v>>3]+B*+p[w>>3]+C*+p[x>>3]);p[b+(F<<3)>>3]=+p[t>>3]+(m*+p[o>>3]+A*+p[q>>3]+B*+p[r>>3]+C*+p[s>>3]);p[b+(E<<3)>>3]=D;g=g+4|0}while((g|0)<(z|0));return}if((d|0)<=0)return;l=e+1|0;if((f|0)<=0)return;if((e|0)>0){j=a;k=0}else{i=0;while(1){g=0;h=c;while(1){p[b+(g<<3)>>3]=+p[h+(e<<3)>>3];g=g+1|0;if((g|0)==(f|0))break;else h=h+(l<<3)|0}i=i+1|0;if((i|0)==(d|0))break;else b=b+(f<<3)|0}return}while(1){h=0;i=c;while(1){g=0;m=+p[i+(e<<3)>>3];do{m=m+ +p[i+(g<<3)>>3]*+p[j+(g<<3)>>3];g=g+1|0}while((g|0)!=(e|0));p[b+(h<<3)>>3]=m;h=h+1|0;if((h|0)==(f|0))break;else i=i+(l<<3)|0}k=k+1|0;if((k|0)==(d|0))break;else{b=b+(f<<3)|0;j=j+(e<<3)|0}}return}function U_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0;i=(f|0)==2;if((e|0)==2&i){w=d<<1;if((d|0)<=0)return;r=+p[c+48>>3];s=+p[c+56>>3];t=+p[c+64>>3];h=c+8|0;i=c+16|0;n=c+24|0;q=c+32|0;u=c+40|0;g=0;do{v=g|1;l=+o[a+(g<<2)>>2];m=+o[a+(v<<2)>>2];j=t+(r*l+s*m);if(+P(+j)>1.1920928955078125e-07){j=1.0/j;k=j*(+p[i>>3]+(l*+p[c>>3]+m*+p[h>>3]));j=j*(+p[u>>3]+(l*+p[n>>3]+m*+p[q>>3]))}else{k=0.0;j=0.0}o[b+(v<<2)>>2]=j;o[b+(g<<2)>>2]=k;g=g+2|0}while((g|0)<(w|0));return}h=(e|0)==3;if(h&(f|0)==3){D=d*3|0;if((d|0)<=0)return;t=+p[c+96>>3];x=+p[c+104>>3];y=+p[c+112>>3];z=+p[c+120>>3];h=c+8|0;i=c+16|0;n=c+24|0;q=c+32|0;u=c+40|0;v=c+48|0;w=c+56|0;e=c+64|0;f=c+72|0;d=c+80|0;A=c+88|0;g=0;do{B=g+1|0;C=g+2|0;m=+o[a+(g<<2)>>2];r=+o[a+(B<<2)>>2];s=+o[a+(C<<2)>>2];j=z+(t*m+x*r+y*s);if(+P(+j)>1.1920928955078125e-07){j=1.0/j;k=j*(+p[n>>3]+(m*+p[c>>3]+r*+p[h>>3]+s*+p[i>>3]));l=j*(+p[w>>3]+(m*+p[q>>3]+r*+p[u>>3]+s*+p[v>>3]));j=j*(+p[A>>3]+(m*+p[e>>3]+r*+p[f>>3]+s*+p[d>>3]))}else{k=0.0;l=0.0;j=0.0}o[b+(C<<2)>>2]=j;o[b+(B<<2)>>2]=l;o[b+(g<<2)>>2]=k;g=g+3|0}while((g|0)<(D|0));return}g=(d|0)>0;if(h&i){if(!g)return;r=+p[c+64>>3];s=+p[c+72>>3];t=+p[c+80>>3];x=+p[c+88>>3];i=c+8|0;n=c+16|0;q=c+24|0;u=c+32|0;v=c+40|0;w=c+48|0;e=c+56|0;g=b;h=0;while(1){j=+o[a>>2];k=+o[a+4>>2];l=+o[a+8>>2];m=x+(r*j+s*k+t*l);if(+P(+m)>1.1920928955078125e-07){z=1.0/m;o[g>>2]=z*(+p[q>>3]+(j*+p[c>>3]+k*+p[i>>3]+l*+p[n>>3]));o[g+4>>2]=z*(+p[e>>3]+(j*+p[u>>3]+k*+p[v>>3]+l*+p[w>>3]))}else{o[g+4>>2]=0.0;o[g>>2]=0.0}h=h+1|0;if((h|0)==(d|0))break;else{a=a+12|0;g=g+8|0}}return}if(!g)return;w=e+1|0;u=c+((aa(w,f)|0)<<3)|0;l=+p[u+(e<<3)>>3];g=(f|0)>0;v=f<<2;if((e|0)>0){if(g){n=b;q=0}else return;while(1){h=aa(q,f)|0;g=0;k=l;do{k=k+ +p[u+(g<<3)>>3]*+o[a+(g<<2)>>2];g=g+1|0}while((g|0)!=(e|0));if(+P(+k)>1.1920928955078125e-07){g=0;h=c;while(1){j=+p[h+(e<<3)>>3];i=0;do{j=j+ +p[h+(i<<3)>>3]*+o[a+(i<<2)>>2];i=i+1|0}while((i|0)!=(e|0));o[n+(g<<2)>>2]=k*j;g=g+1|0;if((g|0)==(f|0))break;else h=h+(w<<3)|0}}else zpb(b+(h<<2)|0,0,v|0)|0;q=q+1|0;if((q|0)==(d|0))break;else{a=a+(e<<2)|0;n=n+(f<<2)|0}}return}else{if(!(+P(+l)>1.1920928955078125e-07)){if(g)g=0;else return;do{zpb(b+((aa(g,f)|0)<<2)|0,0,v|0)|0;g=g+1|0}while((g|0)!=(d|0));return}if(g){i=b;a=0}else return;while(1){g=0;h=c;while(1){o[i+(g<<2)>>2]=l*+p[h+(e<<3)>>3];g=g+1|0;if((g|0)==(f|0))break;else h=h+(w<<3)|0}a=a+1|0;if((a|0)==(d|0))break;else i=i+(f<<2)|0}return}}function V_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0;i=(f|0)==2;if((e|0)==2&i){e=d<<1;if((d|0)<=0)return;h=c+48|0;i=c+56|0;j=c+64|0;n=c+8|0;o=c+16|0;q=c+24|0;r=c+32|0;s=c+40|0;g=0;do{k=+p[a+(g<<3)>>3];t=g|1;l=+p[a+(t<<3)>>3];m=+p[j>>3]+(k*+p[h>>3]+l*+p[i>>3]);if(+P(+m)>1.1920928955078125e-07){u=1.0/m;p[b+(g<<3)>>3]=u*(+p[o>>3]+(k*+p[c>>3]+l*+p[n>>3]));k=u*(+p[s>>3]+(k*+p[q>>3]+l*+p[r>>3]))}else{p[b+(g<<3)>>3]=0.0;k=0.0}p[b+(t<<3)>>3]=k;g=g+2|0}while((g|0)<(e|0));return}h=(e|0)==3;if(h&(f|0)==3){A=d*3|0;if((d|0)<=0)return;i=c+96|0;j=c+104|0;n=c+112|0;o=c+120|0;q=c+8|0;r=c+16|0;s=c+24|0;t=c+32|0;e=c+40|0;f=c+48|0;v=c+56|0;w=c+64|0;d=c+72|0;x=c+80|0;y=c+88|0;h=0;do{k=+p[a+(h<<3)>>3];g=h+1|0;l=+p[a+(g<<3)>>3];z=h+2|0;m=+p[a+(z<<3)>>3];u=+p[o>>3]+(k*+p[i>>3]+l*+p[j>>3]+m*+p[n>>3]);if(+P(+u)>1.1920928955078125e-07){u=1.0/u;p[b+(h<<3)>>3]=u*(+p[s>>3]+(k*+p[c>>3]+l*+p[q>>3]+m*+p[r>>3]));p[b+(g<<3)>>3]=u*(+p[v>>3]+(k*+p[t>>3]+l*+p[e>>3]+m*+p[f>>3]));k=u*(+p[y>>3]+(k*+p[w>>3]+l*+p[d>>3]+m*+p[x>>3]))}else{p[b+(g<<3)>>3]=0.0;p[b+(h<<3)>>3]=0.0;k=0.0}p[b+(z<<3)>>3]=k;h=h+3|0}while((h|0)<(A|0));return}g=(d|0)>0;if(h&i){if(!g)return;j=c+64|0;n=c+72|0;o=c+80|0;q=c+88|0;r=c+8|0;s=c+16|0;t=c+24|0;e=c+32|0;f=c+40|0;v=c+48|0;w=c+56|0;i=a;g=b;h=0;while(1){k=+p[i>>3];l=+p[i+8>>3];m=+p[i+16>>3];u=+p[q>>3]+(k*+p[j>>3]+l*+p[n>>3]+m*+p[o>>3]);if(+P(+u)>1.1920928955078125e-07){u=1.0/u;p[g>>3]=u*(+p[t>>3]+(k*+p[c>>3]+l*+p[r>>3]+m*+p[s>>3]));k=u*(+p[w>>3]+(k*+p[e>>3]+l*+p[f>>3]+m*+p[v>>3]))}else{p[g>>3]=0.0;k=0.0}p[g+8>>3]=k;h=h+1|0;if((h|0)==(d|0))break;else{i=i+24|0;g=g+16|0}}return}if(!g)return;r=e+1|0;q=c+((aa(r,f)|0)<<3)|0;s=q+(e<<3)|0;g=(f|0)>0;t=f<<3;if((e|0)<=0){if(g){i=b;j=0}else return;while(1){k=+p[s>>3];if(+P(+k)>1.1920928955078125e-07){g=0;h=c;while(1){p[i+(g<<3)>>3]=k*+p[h+(e<<3)>>3];g=g+1|0;if((g|0)==(f|0))break;else h=h+(r<<3)|0}}else zpb(b+((aa(j,f)|0)<<3)|0,0,t|0)|0;j=j+1|0;if((j|0)==(d|0))break;else i=i+(f<<3)|0}return}if(g){j=a;n=b;o=0}else return;while(1){h=aa(o,f)|0;g=0;l=+p[s>>3];do{l=l+ +p[q+(g<<3)>>3]*+p[j+(g<<3)>>3];g=g+1|0}while((g|0)!=(e|0));if(+P(+l)>1.1920928955078125e-07){g=0;h=c;while(1){k=+p[h+(e<<3)>>3];i=0;do{k=k+ +p[h+(i<<3)>>3]*+p[j+(i<<3)>>3];i=i+1|0}while((i|0)!=(e|0));p[n+(g<<3)>>3]=l*k;g=g+1|0;if((g|0)==(f|0))break;else h=h+(r<<3)|0}}else zpb(b+(h<<3)|0,0,t|0)|0;o=o+1|0;if((o|0)==(d|0))break;else{j=j+(e<<3)|0;n=n+(f<<3)|0}}return}function W_(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+256|0;C=D+8|0;t=D;B=D+192|0;A=D+136|0;u=D+128|0;v=D+112|0;w=D+96|0;x=D+64|0;p[t>>3]=b;q=S1(a,-1)|0;s=q&7;y=(q>>>3&511)+1|0;if((q|0)!=(S1(c,-1)|0)){e=C+4|0;f=ZT(28)|0;k[f>>2]=1;g=f+4|0;k[C>>2]=g;k[e>>2]=20;i[f+24>>0]=0;h=215838;j=g+20|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,C,215859,215417,2318);k[e>>2]=0;k[C>>2]=0;z=k[f>>2]|0;k[f>>2]=z+-1;if((z|0)==1)ggb(k[f+-4>>2]|0)}if(s>>>0<5){p[C>>3]=+p[t>>3];p[C+8>>3]=1.0;p[C+16>>3]=0.0;sU(a,c,d,49332,s,40128,1,C);r=D;return}do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[C>>2]=k[g>>2];m=C+4|0;e=g+4|0;k[m>>2]=k[e>>2];z=C+8|0;k[z>>2]=k[g+8>>2];k[C+12>>2]=k[g+12>>2];k[C+16>>2]=k[g+16>>2];k[C+20>>2]=k[g+20>>2];k[C+24>>2]=k[g+24>>2];k[C+28>>2]=k[g+28>>2];k[C+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[C+36>>2]=f;a=C+40|0;k[a>>2]=z;z=C+48|0;j=C+44|0;k[j>>2]=z;k[C+52>>2]=0;k[z>>2]=0;if(f|0){z=f+12|0;k[z>>2]=(k[z>>2]|0)+1}if((k[e>>2]|0)<3){m=k[g+44>>2]|0;z=k[j>>2]|0;k[z>>2]=k[m>>2];k[z+4>>2]=k[m+4>>2];break}k[m>>2]=0;x1(C,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[a>>2]|0;a=k[g+44>>2]|0;f=k[j>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else Q1(C,a,-1);while(0);do if((k[c>>2]&2031616|0)==65536){a=k[c+4>>2]|0;k[B>>2]=k[a>>2];l=B+4|0;e=a+4|0;k[l>>2]=k[e>>2];z=B+8|0;k[z>>2]=k[a+8>>2];k[B+12>>2]=k[a+12>>2];k[B+16>>2]=k[a+16>>2];k[B+20>>2]=k[a+20>>2];k[B+24>>2]=k[a+24>>2];k[B+28>>2]=k[a+28>>2];k[B+32>>2]=k[a+32>>2];f=k[a+36>>2]|0;k[B+36>>2]=f;m=B+40|0;k[m>>2]=z;z=B+48|0;g=B+44|0;k[g>>2]=z;k[B+52>>2]=0;k[z>>2]=0;if(f|0){z=f+12|0;k[z>>2]=(k[z>>2]|0)+1}if((k[e>>2]|0)<3){c=k[a+44>>2]|0;z=k[g>>2]|0;k[z>>2]=k[c>>2];k[z+4>>2]=k[c+4>>2];break}k[l>>2]=0;x1(B,k[e>>2]|0,0,0,0);if((k[l>>2]|0)>0){h=k[a+40>>2]|0;j=k[m>>2]|0;a=k[a+44>>2]|0;f=k[g>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[l>>2]|0))}}else{Q1(B,c,-1);m=B+40|0}while(0);z=C+40|0;e=k[z>>2]|0;a=k[e+-4>>2]|0;g=k[m>>2]|0;a:do if((a|0)==(k[g+-4>>2]|0)){if((a|0)==2){if((k[e>>2]|0)!=(k[g>>2]|0)){n=32;break}if((k[e+4>>2]|0)==(k[g+4>>2]|0))break;else{n=32;break}}if((a|0)>0){f=0;do{if((k[e+(f<<2)>>2]|0)!=(k[g+(f<<2)>>2]|0)){n=32;break a}f=f+1|0}while((f|0)<(a|0))}}else n=32;while(0);if((n|0)==32){k[A>>2]=0;e=A+4|0;k[e>>2]=0;f=ZT(28)|0;k[f>>2]=1;g=f+4|0;k[A>>2]=g;k[e>>2]=22;i[f+26>>0]=0;h=215868;j=g+22|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,A,215859,215417,2330);k[e>>2]=0;k[A>>2]=0;n=k[f>>2]|0;k[f>>2]=n+-1;if((n|0)==1)ggb(k[f+-4>>2]|0);e=k[z>>2]|0}n=C+4|0;P1(d,k[n>>2]|0,e,q,-1,0,0);do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[A>>2]=k[g>>2];c=A+4|0;e=g+4|0;k[c>>2]=k[e>>2];d=A+8|0;k[d>>2]=k[g+8>>2];k[A+12>>2]=k[g+12>>2];k[A+16>>2]=k[g+16>>2];k[A+20>>2]=k[g+20>>2];k[A+24>>2]=k[g+24>>2];k[A+28>>2]=k[g+28>>2];k[A+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[A+36>>2]=f;a=A+40|0;k[a>>2]=d;d=A+48|0;j=A+44|0;k[j>>2]=d;k[A+52>>2]=0;k[d>>2]=0;if(f|0){d=f+12|0;k[d>>2]=(k[d>>2]|0)+1}if((k[e>>2]|0)<3){q=k[g+44>>2]|0;d=k[j>>2]|0;k[d>>2]=k[q>>2];k[d+4>>2]=k[q+4>>2];break}k[c>>2]=0;x1(A,k[e>>2]|0,0,0,0);if((k[c>>2]|0)>0){l=k[g+40>>2]|0;h=k[a>>2]|0;a=k[g+44>>2]|0;f=k[j>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[c>>2]|0))}}else Q1(A,d,-1);while(0);o[u>>2]=+p[t>>3];l=(s|0)==5;j=l?u:t;l=l?151:150;if(((k[C>>2]&16384|0)!=0?(k[B>>2]&16384|0)!=0:0)?(k[A>>2]&16384|0)!=0:0){a=k[n>>2]|0;if((a|0)<3)e=aa(k[C+12>>2]|0,k[C+8>>2]|0)|0;else{g=k[z>>2]|0;f=0;e=1;do{e=aa(k[g+(f<<2)>>2]|0,e)|0;f=f+1|0}while((f|0)!=(a|0))}y=aa(e,y)|0;eh[l&255](k[C+16>>2]|0,k[B+16>>2]|0,k[A+16>>2]|0,y,j)}else{k[v>>2]=C;k[v+4>>2]=B;k[v+8>>2]=A;k[v+12>>2]=0;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;k[x+16>>2]=0;k[x+20>>2]=0;k[x+24>>2]=0;k[x+28>>2]=0;z1(x,v,0,w,-1);f=aa(k[x+20>>2]|0,y)|0;a=x+16|0;g=w+4|0;h=w+8|0;e=0;while(1){if(e>>>0>=(k[a>>2]|0)>>>0)break;eh[l&255](k[w>>2]|0,k[g>>2]|0,k[h>>2]|0,f,j);A1(x);e=e+1|0}}a=A+36|0;e=k[a>>2]|0;if(e|0?(x=e+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){f=k[a>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[A+32>>2]|0;if(!e){e=B1()|0;f=k[a>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[a>>2]=0}k[a>>2]=0;y=A+16|0;f=A+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[f>>2]|0)>0){a=k[A+40>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[A+44>>2]|0;if(!((e|0)==(A+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);a=B+36|0;e=k[a>>2]|0;if(e|0?(y=e+12|0,A=k[y>>2]|0,k[y>>2]=A+-1,(A|0)==1):0){f=k[a>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[B+32>>2]|0;if(!e){e=B1()|0;f=k[a>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[a>>2]=0}k[a>>2]=0;A=B+16|0;a=B+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[a>>2]|0)>0){f=k[m>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[a>>2]|0))}e=k[B+44>>2]|0;if(!((e|0)==(B+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);a=C+36|0;e=k[a>>2]|0;if(e|0?(A=e+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){f=k[a>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[C+32>>2]|0;if(e|0)break;e=B1()|0;f=k[a>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[a>>2]=0}k[a>>2]=0;B=C+16|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[n>>2]|0)>0){f=k[z>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[n>>2]|0))}e=k[C+44>>2]|0;if(!((e|0)==(C+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);r=D;return}function X_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0,i=0.0,j=0;g=+o[e>>2];f=d+-4|0;if((d|0)<4)e=0;else{e=0;do{j=e|1;i=g*+o[a+(j<<2)>>2]+ +o[b+(j<<2)>>2];o[c+(e<<2)>>2]=g*+o[a+(e<<2)>>2]+ +o[b+(e<<2)>>2];o[c+(j<<2)>>2]=i;j=e|2;h=e|3;i=g*+o[a+(h<<2)>>2]+ +o[b+(h<<2)>>2];o[c+(j<<2)>>2]=g*+o[a+(j<<2)>>2]+ +o[b+(j<<2)>>2];o[c+(h<<2)>>2]=i;e=e+4|0}while((e|0)<=(f|0));e=d&-4}if((e|0)>=(d|0))return;do{o[c+(e<<2)>>2]=g*+o[a+(e<<2)>>2]+ +o[b+(e<<2)>>2];e=e+1|0}while((e|0)!=(d|0));return}function Y_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0,i=0.0,j=0;g=+p[e>>3];f=d+-4|0;if((d|0)<4)e=0;else{e=0;do{j=e|1;i=g*+p[a+(j<<3)>>3]+ +p[b+(j<<3)>>3];p[c+(e<<3)>>3]=g*+p[a+(e<<3)>>3]+ +p[b+(e<<3)>>3];p[c+(j<<3)>>3]=i;j=e|2;h=e|3;i=g*+p[a+(h<<3)>>3]+ +p[b+(h<<3)>>3];p[c+(j<<3)>>3]=g*+p[a+(j<<3)>>3]+ +p[b+(j<<3)>>3];p[c+(h<<3)>>3]=i;e=e+4|0}while((e|0)<=(f|0));e=d&-4}if((e|0)>=(d|0))return;do{p[c+(e<<3)>>3]=g*+p[a+(e<<3)>>3]+ +p[b+(e<<3)>>3];e=e+1|0}while((e|0)!=(d|0));return}function Z_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=r;r=r+320|0;O=P+256|0;N=P+200|0;M=P+144|0;L=P+24|0;C=P+136|0;F=P;G=P+80|0;u=P+16|0;f=k[a>>2]&2031616;if((f|0)!=327680){do if((f|0)==65536){l=k[a+4>>2]|0;k[O>>2]=k[l>>2];p=O+4|0;f=l+4|0;k[p>>2]=k[f>>2];K=O+8|0;k[K>>2]=k[l+8>>2];k[O+12>>2]=k[l+12>>2];k[O+16>>2]=k[l+16>>2];k[O+20>>2]=k[l+20>>2];k[O+24>>2]=k[l+24>>2];k[O+28>>2]=k[l+28>>2];k[O+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[O+36>>2]=g;h=O+40|0;k[h>>2]=K;K=O+48|0;n=O+44|0;k[n>>2]=K;k[O+52>>2]=0;k[K>>2]=0;if(g|0){K=g+12|0;k[K>>2]=(k[K>>2]|0)+1}if((k[f>>2]|0)<3){J=k[l+44>>2]|0;K=k[n>>2]|0;k[K>>2]=k[J>>2];k[K+4>>2]=k[J+4>>2];break}k[p>>2]=0;x1(O,k[f>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;f=0;do{k[m+(f<<2)>>2]=k[o+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[p>>2]|0))}}else Q1(O,a,-1);while(0);k[N>>2]=1124007936;C=N+4|0;f=N+8|0;x=N+40|0;A=C;B=A+36|0;do{k[A>>2]=0;A=A+4|0}while((A|0)<(B|0));k[x>>2]=f;D=N+48|0;y=N+44|0;k[y>>2]=D;k[N+52>>2]=0;k[D>>2]=0;w=d&8;m=(w|0)!=0;w=w>>>3;if((w|0)==(d>>>4&1|0)){k[M>>2]=0;f=M+4|0;k[f>>2]=0;g=ZT(68)|0;k[g>>2]=1;A=g+4|0;k[M>>2]=A;k[f>>2]=63;i[g+67>>0]=0;z=215992;B=A+63|0;do{i[A>>0]=i[z>>0]|0;A=A+1|0;z=z+1|0}while((A|0)<(B|0));Y8(-215,M,215891,215417,2452);k[f>>2]=0;k[M>>2]=0;K=k[g>>2]|0;k[g>>2]=K+-1;if((K|0)==1)ggb(k[g+-4>>2]|0)}t=k[O>>2]|0;l=O+8|0;f=k[l>>2]|0;h=O+12|0;g=k[h>>2]|0;v=m?f:g;if((v|0)<=0){k[M>>2]=0;f=M+4|0;k[f>>2]=0;g=ZT(20)|0;k[g>>2]=1;A=g+4|0;k[M>>2]=A;k[f>>2]=12;i[g+16>>0]=0;z=216056;B=A+12|0;do{i[A>>0]=i[z>>0]|0;A=A+1|0;z=z+1|0}while((A|0)<(B|0));Y8(-215,M,215891,215417,2456);k[f>>2]=0;k[M>>2]=0;K=k[g>>2]|0;k[g>>2]=K+-1;if((K|0)==1)ggb(k[g+-4>>2]|0);g=k[h>>2]|0;f=k[l>>2]|0}s=m?g:1;q=m?1:f;if(d&2){do if((k[c>>2]&2031616|0)==65536){l=k[c+4>>2]|0;k[M>>2]=k[l>>2];p=M+4|0;f=l+4|0;k[p>>2]=k[f>>2];K=M+8|0;k[K>>2]=k[l+8>>2];k[M+12>>2]=k[l+12>>2];k[M+16>>2]=k[l+16>>2];k[M+20>>2]=k[l+20>>2];k[M+24>>2]=k[l+24>>2];k[M+28>>2]=k[l+28>>2];k[M+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[M+36>>2]=g;h=M+40|0;k[h>>2]=K;K=M+48|0;n=M+44|0;k[n>>2]=K;k[M+52>>2]=0;k[K>>2]=0;if(g|0){K=g+12|0;k[K>>2]=(k[K>>2]|0)+1}if((k[f>>2]|0)<3){J=k[l+44>>2]|0;K=k[n>>2]|0;k[K>>2]=k[J>>2];k[K+4>>2]=k[J+4>>2];break}k[p>>2]=0;x1(M,k[f>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;f=0;do{k[m+(f<<2)>>2]=k[o+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[p>>2]|0))}}else Q1(M,c,-1);while(0);KG(N,M)|0;h=M+36|0;f=k[h>>2]|0;if(f|0?(J=f+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[M+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;K=M+16|0;g=M+4|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[g>>2]|0)>0){h=k[M+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[M+44>>2]|0;if(!((f|0)==(M+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);f=((e|0)>-1?e:t)&7;g=k[N>>2]|0;K=g&7;f=f>>>0<K>>>0?K:f;f=(f|0)<5?5:f;K=k[x>>2]|0;if(!((k[K>>2]|0)==(q|0)?(k[K+4>>2]|0)==(s|0):0)){k[M>>2]=0;g=M+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;A=h+4|0;k[M>>2]=A;k[g>>2]=19;i[h+23>>0]=0;z=216069;B=A+19|0;do{i[A>>0]=i[z>>0]|0;A=A+1|0;z=z+1|0}while((A|0)<(B|0));Y8(-215,M,215891,215417,2463);k[g>>2]=0;k[M>>2]=0;K=k[h>>2]|0;k[h>>2]=K+-1;if((K|0)==1)ggb(k[h+-4>>2]|0);g=k[N>>2]|0}if((g&4095|0)!=(f|0)){J=k[x>>2]|0;K=k[J>>2]|0;k[u>>2]=k[J+4>>2];k[u+4>>2]=K;x2(c,u,f,0);do if((k[c>>2]&2031616|0)==65536){m=k[c+4>>2]|0;k[M>>2]=k[m>>2];q=M+4|0;g=m+4|0;k[q>>2]=k[g>>2];c=M+8|0;k[c>>2]=k[m+8>>2];k[M+12>>2]=k[m+12>>2];k[M+16>>2]=k[m+16>>2];k[M+20>>2]=k[m+20>>2];k[M+24>>2]=k[m+24>>2];k[M+28>>2]=k[m+28>>2];k[M+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[M+36>>2]=h;l=M+40|0;k[l>>2]=c;c=M+48|0;o=M+44|0;k[o>>2]=c;k[M+52>>2]=0;k[c>>2]=0;if(h|0){c=h+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[g>>2]|0)<3){K=k[m+44>>2]|0;c=k[o>>2]|0;k[c>>2]=k[K>>2];k[c+4>>2]=k[K+4>>2];break}k[q>>2]=0;x1(M,k[g>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[m+40>>2]|0;n=k[l>>2]|0;l=k[m+44>>2]|0;h=k[o>>2]|0;g=0;do{k[n+(g<<2)>>2]=k[p+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else Q1(M,c,-1);while(0);l=L+4|0;g=l+4|0;k[g>>2]=0;k[g+4>>2]=0;k[L>>2]=33619968;k[l>>2]=M;SW(N,L,f,1.0,0.0);KG(N,M)|0;l=M+36|0;g=k[l>>2]|0;if(g|0?(K=g+12|0,c=k[K>>2]|0,k[K>>2]=c+-1,(c|0)==1):0){h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;do if(!g){g=k[M+32>>2]|0;if(g|0)break;g=B1()|0;h=k[l>>2]|0}while(0);jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}k[l>>2]=0;c=M+16|0;h=M+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[h>>2]|0)>0){l=k[M+40>>2]|0;g=0;do{k[l+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[M+44>>2]|0;if(!((g|0)==(M+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0)}}else{f=((e|0)>-1?e:t)&7;f=f>>>0<5?5:f;T2(a,c,w^1,1,f);do if((k[c>>2]&2031616|0)==65536){n=k[c+4>>2]|0;k[M>>2]=k[n>>2];q=M+4|0;h=n+4|0;k[q>>2]=k[h>>2];c=M+8|0;k[c>>2]=k[n+8>>2];k[M+12>>2]=k[n+12>>2];k[M+16>>2]=k[n+16>>2];k[M+20>>2]=k[n+20>>2];k[M+24>>2]=k[n+24>>2];k[M+28>>2]=k[n+28>>2];k[M+32>>2]=k[n+32>>2];g=k[n+36>>2]|0;k[M+36>>2]=g;l=M+40|0;k[l>>2]=c;c=M+48|0;o=M+44|0;k[o>>2]=c;k[M+52>>2]=0;k[c>>2]=0;if(g|0){c=g+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[h>>2]|0)<3){K=k[n+44>>2]|0;c=k[o>>2]|0;k[c>>2]=k[K>>2];k[c+4>>2]=k[K+4>>2];break}k[q>>2]=0;x1(M,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[n+40>>2]|0;m=k[l>>2]|0;l=k[n+44>>2]|0;h=k[o>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[p+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else Q1(M,c,-1);while(0);KG(N,M)|0;l=M+36|0;g=k[l>>2]|0;if(g|0?(K=g+12|0,c=k[K>>2]|0,k[K>>2]=c+-1,(c|0)==1):0){h=k[l>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[M+32>>2]|0;if(!g){g=B1()|0;h=k[l>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[l>>2]=0}k[l>>2]=0;c=M+16|0;h=M+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[h>>2]|0)>0){l=k[M+40>>2]|0;g=0;do{k[l+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[M+44>>2]|0;if(!((g|0)==(M+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0)}k[M+8>>2]=0;k[M+12>>2]=0;k[M>>2]=16842752;k[M+4>>2]=O;k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=N;if(!(d&4))j=1.0;else j=1.0/+(v|0);__(M,b,(d&1^1|0)!=(w|0),L,j,f);h=N+36|0;f=k[h>>2]|0;if(f|0?(L=f+12|0,M=k[L>>2]|0,k[L>>2]=M+-1,(M|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[N+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;N=N+16|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[C>>2]|0)>0){g=k[x>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[C>>2]|0))}f=k[y>>2]|0;if(!((f|0)==(D|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=O+36|0;f=k[h>>2]|0;if(f|0?(M=f+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[O+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;N=O+16|0;g=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[g>>2]|0)>0){h=k[O+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[O+44>>2]|0;if(!((f|0)==(O+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);r=P;return}k[N>>2]=0;x=N+4|0;k[x>>2]=0;k[N+8>>2]=0;B2(a,N);g=k[N>>2]|0;f=g;if((k[x>>2]|0)==(g|0)){k[O>>2]=0;f=O+4|0;k[f>>2]=0;g=ZT(20)|0;k[g>>2]=1;A=g+4|0;k[O>>2]=A;k[f>>2]=14;i[g+18>>0]=0;z=215928;B=A+14|0;do{i[A>>0]=i[z>>0]|0;A=A+1|0;z=z+1|0}while((A|0)<(B|0));Y8(-215,O,215891,215417,2407);k[f>>2]=0;k[O>>2]=0;K=k[g>>2]|0;k[g>>2]=K+-1;if((K|0)==1)ggb(k[g+-4>>2]|0);g=k[N>>2]|0;f=g}E=k[f+40>>2]|0;y=k[E+4>>2]|0;E=k[E>>2]|0;D=k[f>>2]|0;w=D&4095;D=((e|0)>-1?e:D)&7;m=(S1(c,-1)|0)&7;D=D>>>0<m>>>0?m:D;D=(D|0)<5?5:D;m=k[x>>2]|0;h=(m-g|0)/56|0;l=aa(E,y)|0;k[M>>2]=1124007936;J=M+4|0;g=M+8|0;H=M+40|0;A=J;B=A+36|0;do{k[A>>2]=0;A=A+4|0}while((A|0)<(B|0));k[H>>2]=g;K=M+48|0;I=M+44|0;k[I>>2]=K;k[M+52>>2]=0;k[K>>2]=0;k[O>>2]=h;k[O+4>>2]=l;G1(M,2,O,w);if((f|0)!=(m|0)){m=M+16|0;n=L+4|0;o=n+4|0;p=O+36|0;q=O+16|0;s=O+4|0;a=O+40|0;t=O+44|0;u=O+48|0;e=O+4|0;v=O+32|0;l=0;while(1){B=k[f+40>>2]|0;if(!(((k[B>>2]|0)==(E|0)?(k[B+4>>2]|0)==(y|0):0)?(k[f>>2]&4095|0)==(w|0):0)){k[O>>2]=0;k[e>>2]=0;g=ZT(56)|0;k[g>>2]=1;A=g+4|0;k[O>>2]=A;k[e>>2]=48;i[g+52>>0]=0;z=215943;B=A+48|0;do{i[A>>0]=i[z>>0]|0;A=A+1|0;z=z+1|0}while((A|0)<(B|0));Y8(-215,O,215891,215417,2419);k[e>>2]=0;k[O>>2]=0;B=k[g>>2]|0;k[g>>2]=B+-1;if((B|0)==1)ggb(k[g+-4>>2]|0)}JN(O,E,y,w,(k[m>>2]|0)+(aa(k[k[I>>2]>>2]|0,l)|0)|0,0);g=o;k[g>>2]=0;k[g+4>>2]=0;k[L>>2]=33619968;k[n>>2]=O;mY(f,L);g=k[p>>2]|0;if(g|0?(A=g+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){h=k[p>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[v>>2]|0;if(!g){g=B1()|0;h=k[p>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[p>>2]=0}k[p>>2]=0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[s>>2]|0)>0){h=k[a>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[s>>2]|0))}g=k[t>>2]|0;if(!((g|0)==(u|0)|(g|0)==0))ggb(k[g+-4>>2]|0);f=f+56|0;if((f|0)==(k[x>>2]|0))break;else l=l+1|0}}k[O>>2]=1124007936;t=O+4|0;f=O+8|0;s=O+40|0;A=t;B=A+36|0;do{k[A>>2]=0;A=A+4|0}while((A|0)<(B|0));k[s>>2]=f;u=O+48|0;a=O+44|0;k[a>>2]=u;k[O+52>>2]=0;k[u>>2]=0;q=(d&2|0)==0;if(!q){R1(L,c,-1);if(!((k[L>>2]|0)==(y|0)?(k[L+4>>2]|0)==(E|0):0)){k[L>>2]=0;f=L+4|0;k[f>>2]=0;g=ZT(28)|0;k[g>>2]=1;A=g+4|0;k[L>>2]=A;k[f>>2]=20;i[g+24>>0]=0;z=215907;B=A+20|0;do{i[A>>0]=i[z>>0]|0;A=A+1|0;z=z+1|0}while((A|0)<(B|0));Y8(-215,L,215891,215417,2427);k[f>>2]=0;k[L>>2]=0;B=k[g>>2]|0;k[g>>2]=B+-1;if((B|0)==1)ggb(k[g+-4>>2]|0)}if((k[O>>2]&4095|0)==(D|0))f=c;else{do if((k[c>>2]&2031616|0)==65536){l=k[c+4>>2]|0;k[L>>2]=k[l>>2];p=L+4|0;f=l+4|0;k[p>>2]=k[f>>2];B=L+8|0;k[B>>2]=k[l+8>>2];k[L+12>>2]=k[l+12>>2];k[L+16>>2]=k[l+16>>2];k[L+20>>2]=k[l+20>>2];k[L+24>>2]=k[l+24>>2];k[L+28>>2]=k[l+28>>2];k[L+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[L+36>>2]=g;h=L+40|0;k[h>>2]=B;B=L+48|0;n=L+44|0;k[n>>2]=B;k[L+52>>2]=0;k[B>>2]=0;if(g|0){B=g+12|0;k[B>>2]=(k[B>>2]|0)+1}if((k[f>>2]|0)<3){A=k[l+44>>2]|0;B=k[n>>2]|0;k[B>>2]=k[A>>2];k[B+4>>2]=k[A+4>>2];break}k[p>>2]=0;x1(L,k[f>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;f=0;do{k[m+(f<<2)>>2]=k[o+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[p>>2]|0))}}else Q1(L,c,-1);while(0);KG(O,L)|0;h=L+36|0;f=k[h>>2]|0;if(f|0?(A=f+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[L+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;B=L+16|0;g=L+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[g>>2]|0)>0){h=k[L+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[L+44>>2]|0;if(!((f|0)==(L+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);A=k[s>>2]|0;B=k[A>>2]|0;k[C>>2]=k[A+4>>2];k[C+4>>2]=B;x2(c,C,D,0);do if((k[c>>2]&2031616|0)==65536){l=k[c+4>>2]|0;k[L>>2]=k[l>>2];p=L+4|0;f=l+4|0;k[p>>2]=k[f>>2];C=L+8|0;k[C>>2]=k[l+8>>2];k[L+12>>2]=k[l+12>>2];k[L+16>>2]=k[l+16>>2];k[L+20>>2]=k[l+20>>2];k[L+24>>2]=k[l+24>>2];k[L+28>>2]=k[l+28>>2];k[L+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[L+36>>2]=g;h=L+40|0;k[h>>2]=C;C=L+48|0;n=L+44|0;k[n>>2]=C;k[L+52>>2]=0;k[C>>2]=0;if(g|0){C=g+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[f>>2]|0)<3){B=k[l+44>>2]|0;C=k[n>>2]|0;k[C>>2]=k[B>>2];k[C+4>>2]=k[B+4>>2];break}k[p>>2]=0;x1(L,k[f>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;f=0;do{k[m+(f<<2)>>2]=k[o+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[p>>2]|0))}}else Q1(L,c,-1);while(0);h=F+4|0;f=h+4|0;k[f>>2]=0;k[f+4>>2]=0;k[F>>2]=33619968;k[h>>2]=L;SW(O,F,D,1.0,0.0);KG(O,L)|0;h=L+36|0;f=k[h>>2]|0;if(f|0?(B=f+12|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[L+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;C=L+16|0;g=L+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[g>>2]|0)>0){h=k[L+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[L+44>>2]|0;if(!((f|0)==(L+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);f=c}do if((k[f>>2]&2031616|0)==65536){l=k[c+4>>2]|0;k[G>>2]=k[l>>2];p=G+4|0;f=l+4|0;k[p>>2]=k[f>>2];C=G+8|0;k[C>>2]=k[l+8>>2];k[G+12>>2]=k[l+12>>2];k[G+16>>2]=k[l+16>>2];k[G+20>>2]=k[l+20>>2];k[G+24>>2]=k[l+24>>2];k[G+28>>2]=k[l+28>>2];k[G+32>>2]=k[l+32>>2];g=k[l+36>>2]|0;k[G+36>>2]=g;h=G+40|0;k[h>>2]=C;C=G+48|0;n=G+44|0;k[n>>2]=C;k[G+52>>2]=0;k[C>>2]=0;if(g|0){C=g+12|0;k[C>>2]=(k[C>>2]|0)+1}if((k[f>>2]|0)<3){B=k[l+44>>2]|0;C=k[n>>2]|0;k[C>>2]=k[B>>2];k[C+4>>2]=k[B+4>>2];break}k[p>>2]=0;x1(G,k[f>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;f=0;do{k[m+(f<<2)>>2]=k[o+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[p>>2]|0))}}else Q1(G,c,-1);while(0);_1(L,G,1,1);KG(O,L)|0;h=L+36|0;f=k[h>>2]|0;if(f|0?(B=f+12|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[L+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;C=L+16|0;g=L+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[g>>2]|0)>0){h=k[L+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[L+44>>2]|0;if(!((f|0)==(L+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=G+36|0;f=k[h>>2]|0;if(f|0?(B=f+12|0,C=k[B>>2]|0,k[B>>2]=C+-1,(C|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[G+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;C=G+16|0;g=G+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[g>>2]|0)>0){h=k[G+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[G+44>>2]|0;if(!((f|0)==(G+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}k[L+8>>2]=0;k[L+12>>2]=0;k[L>>2]=16842752;k[L+4>>2]=M;G=F+4|0;C=G+4|0;k[C>>2]=0;k[C+4>>2]=0;k[F>>2]=50397184;k[G>>2]=O;Z_(L,b,F,d&-25|8,D);if(q){_1(L,O,1,E);KG(O,L)|0;h=L+36|0;f=k[h>>2]|0;if(f|0?(b=f+12|0,d=k[b>>2]|0,k[b>>2]=d+-1,(d|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[L+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;d=L+16|0;g=L+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[g>>2]|0)>0){h=k[L+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[L+44>>2]|0;if(!((f|0)==(L+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);mY(O,c)}h=O+36|0;f=k[h>>2]|0;if(f|0?(d=f+12|0,L=k[d>>2]|0,k[d>>2]=L+-1,(L|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[O+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;O=O+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[t>>2]|0)>0){g=k[s>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[t>>2]|0))}f=k[a>>2]|0;if(!((f|0)==(u|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=M+36|0;f=k[h>>2]|0;if(f|0?(L=f+12|0,O=k[L>>2]|0,k[L>>2]=O+-1,(O|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[M+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;O=M+16|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[J>>2]|0)>0){g=k[H>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[J>>2]|0))}f=k[I>>2]|0;if(!((f|0)==(K|0)|(f|0)==0))ggb(k[f+-4>>2]|0);zF(N);r=P;return}function __(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=r;r=r+352|0;F=G+288|0;E=G+232|0;D=G+176|0;C=G+120|0;v=G+104|0;w=G+88|0;x=G+72|0;A=G+16|0;y=G;do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[F>>2]=k[j>>2];o=F+4|0;a=j+4|0;k[o>>2]=k[a>>2];B=F+8|0;k[B>>2]=k[j+8>>2];k[F+12>>2]=k[j+12>>2];k[F+16>>2]=k[j+16>>2];k[F+20>>2]=k[j+20>>2];k[F+24>>2]=k[j+24>>2];k[F+28>>2]=k[j+28>>2];k[F+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[F+36>>2]=g;h=F+40|0;k[h>>2]=B;B=F+48|0;m=F+44|0;k[m>>2]=B;k[F+52>>2]=0;k[B>>2]=0;if(g|0){B=g+12|0;k[B>>2]=(k[B>>2]|0)+1}if((k[a>>2]|0)<3){z=k[j+44>>2]|0;B=k[m>>2]|0;k[B>>2]=k[z>>2];k[B+4>>2]=k[z+4>>2];break}k[o>>2]=0;x1(F,k[a>>2]|0,0,0,0);if((k[o>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[o>>2]|0))}}else Q1(F,a,-1);while(0);do if((k[d>>2]&2031616|0)==65536){l=k[d+4>>2]|0;k[E>>2]=k[l>>2];o=E+4|0;g=l+4|0;k[o>>2]=k[g>>2];B=E+8|0;k[B>>2]=k[l+8>>2];k[E+12>>2]=k[l+12>>2];k[E+16>>2]=k[l+16>>2];k[E+20>>2]=k[l+20>>2];k[E+24>>2]=k[l+24>>2];k[E+28>>2]=k[l+28>>2];k[E+32>>2]=k[l+32>>2];a=k[l+36>>2]|0;k[E+36>>2]=a;h=E+40|0;k[h>>2]=B;B=E+48|0;m=E+44|0;k[m>>2]=B;k[E+52>>2]=0;k[B>>2]=0;if(a|0){B=a+12|0;k[B>>2]=(k[B>>2]|0)+1}if((k[g>>2]|0)<3){B=k[l+44>>2]|0;l=k[m>>2]|0;k[l>>2]=k[B>>2];k[l+4>>2]=k[B+4>>2];l=E;break}k[o>>2]=0;x1(E,k[g>>2]|0,0,0,0);if((k[o>>2]|0)>0){n=k[l+40>>2]|0;j=k[h>>2]|0;h=k[l+44>>2]|0;g=k[m>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[o>>2]|0));l=E}else l=E}else{Q1(E,d,-1);l=E}while(0);B=k[F>>2]|0;s=B&4095;q=((f|0)>-1?f:B)&7;z=k[l>>2]&7;q=q>>>0<z>>>0?z:q;q=(q|0)<5?5:q;if(B&4088|0){k[D>>2]=0;a=D+4|0;k[a>>2]=0;g=ZT(24)|0;k[g>>2]=1;j=g+4|0;k[D>>2]=j;k[a>>2]=19;i[g+23>>0]=0;h=244345;m=j+19|0;do{i[j>>0]=i[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(m|0));Y8(-215,D,216089,215417,2783);k[a>>2]=0;k[D>>2]=0;B=k[g>>2]|0;k[g>>2]=B+-1;if((B|0)==1)ggb(k[g+-4>>2]|0)}B=E+16|0;if(k[B>>2]|0){h=k[E+4>>2]|0;if((h|0)<3)a=aa(k[E+12>>2]|0,k[E+8>>2]|0)|0;else{j=k[E+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(a|0){a=k[l>>2]|0;if(!(((a&4088|0)==0?(z=k[E+8>>2]|0,(z|0)==1?1:(z|0)==(k[F+8>>2]|0)):0)?(z=k[E+12>>2]|0,(z|0)==1?1:(z|0)==(k[F+12>>2]|0)):0)){k[D>>2]=0;a=D+4|0;k[a>>2]=0;g=ZT(120)|0;k[g>>2]=1;j=g+4|0;k[D>>2]=j;k[a>>2]=115;i[g+119>>0]=0;h=216103;m=j+115|0;do{i[j>>0]=i[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(m|0));Y8(-215,D,216089,215417,2789);k[a>>2]=0;k[D>>2]=0;z=k[g>>2]|0;k[g>>2]=z+-1;if((z|0)==1)ggb(k[g+-4>>2]|0);a=k[l>>2]|0}if((a&4095|0)!=(q|0)){z=D+4|0;p=z+4|0;k[p>>2]=0;k[p+4>>2]=0;k[D>>2]=33619968;k[z>>2]=E;SW(E,D,q,1.0,0.0)}}}f=F+12|0;p=F+8|0;z=c?k[f>>2]|0:k[p>>2]|0;c2(b,z,z,q,-1,0,0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[D>>2]=k[j>>2];o=D+4|0;a=j+4|0;k[o>>2]=k[a>>2];z=D+8|0;k[z>>2]=k[j+8>>2];k[D+12>>2]=k[j+12>>2];d=D+16|0;k[d>>2]=k[j+16>>2];k[D+20>>2]=k[j+20>>2];k[D+24>>2]=k[j+24>>2];k[D+28>>2]=k[j+28>>2];k[D+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[D+36>>2]=g;h=D+40|0;k[h>>2]=z;z=D+48|0;m=D+44|0;k[m>>2]=z;k[D+52>>2]=0;k[z>>2]=0;if(g|0){z=g+12|0;k[z>>2]=(k[z>>2]|0)+1}if((k[a>>2]|0)<3){b=k[j+44>>2]|0;z=k[m>>2]|0;k[z>>2]=k[b>>2];k[z+4>>2]=k[b+4>>2];break}k[o>>2]=0;x1(D,k[a>>2]|0,0,0,0);if((k[o>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[o>>2]|0))}}else{Q1(D,b,-1);d=D+16|0}while(0);z=F+16|0;do if((k[z>>2]|0)==(k[d>>2]|0))u=50;else{if(((s|0)==(q|0)?(k[D+12>>2]|0)>99:0)?((k[f>>2]|0)>99?(k[D+8>>2]|0)>99:0)&(k[p>>2]|0)>99:0){u=50;break}a=(s|0)==0;h=(q|0)==5;do if(!(a&h)){g=(q|0)==6;if(a&g){t=c?17:16;break}a=(s|0)==2;if(a&h){t=c?19:18;break}if(a&g){t=c?21:20;break}a=(s|0)==3;if(a&h){t=c?23:22;break}if(a&g){t=c?25:24;break}a=(s|0)==5;if(a&h){t=c?27:26;break}if(a&g){t=c?29:28;break}if((s|0)==6&g)t=c?31:30;else{k[C>>2]=0;c=C+4|0;k[c>>2]=0;A=ZT(8)|0;k[A>>2]=1;A=A+4|0;k[C>>2]=A;k[c>>2]=0;i[A>>0]=0;Y8(-210,C,216089,215417,2884);S8(C)}}else t=c?15:14;while(0);ah[t&31](F,D,E,e);A=C+4|0;c=A+4|0;k[c>>2]=0;k[c+4>>2]=0;k[C>>2]=50397184;k[A>>2]=D;S2(C,0)}while(0);if((u|0)==50){k[C>>2]=1124007936;s=C+4|0;a=C+8|0;o=C+40|0;j=s;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[o>>2]=a;b=C+48|0;q=C+44|0;k[q>>2]=b;k[C+52>>2]=0;k[b>>2]=0;do if(k[B>>2]|0){h=k[E+4>>2]|0;if((h|0)<3)a=aa(k[E+12>>2]|0,k[E+8>>2]|0)|0;else{j=k[E+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(a){t=k[E+40>>2]|0;u=k[F+40>>2]|0;if((k[t>>2]|0)==(k[u>>2]|0)?(k[t+4>>2]|0)==(k[u+4>>2]|0):0){k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=16842752;k[v+4>>2]=F;k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=E;a=x+4|0;u=a+4|0;k[u>>2]=0;k[u+4>>2]=0;k[x>>2]=33619968;k[a>>2]=C;sU(v,w,x,49332,-1,39968,0,0);a=C;break}else{k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=16842752;k[v+4>>2]=E;p=k[p>>2]|0;t=k[E+8>>2]|0;u=k[f>>2]|0;a=k[E+12>>2]|0;f=w+4|0;n=f+4|0;k[n>>2]=0;k[n+4>>2]=0;k[w>>2]=33619968;k[f>>2]=C;sY(v,(p|0)/(t|0)|0,(u|0)/(a|0)|0,w);k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=16842752;k[v+4>>2]=F;k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=C;a=x+4|0;u=a+4|0;k[u>>2]=0;k[u+4>>2]=0;k[x>>2]=33619968;k[a>>2]=C;sU(v,w,x,49332,-1,39968,0,0);a=C;break}}else a=F}else a=F;while(0);k[v+8>>2]=0;k[v+12>>2]=0;k[v>>2]=16842752;k[v+4>>2]=a;k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=a;k[A>>2]=1124007936;n=A+4|0;a=A+8|0;l=A+40|0;j=n;m=j+36|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(m|0));k[l>>2]=a;m=A+48|0;j=A+44|0;k[j>>2]=m;k[A+52>>2]=0;k[m>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;k[x>>2]=16842752;k[x+4>>2]=A;h=y+4|0;a=h+4|0;k[a>>2]=0;k[a+4>>2]=0;k[y>>2]=33619968;k[h>>2]=D;s_(v,w,e,x,0.0,y,c?1:2);h=A+36|0;a=k[h>>2]|0;if(a|0?(y=a+12|0,c=k[y>>2]|0,k[y>>2]=c+-1,(c|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[A+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;A=A+16|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[n>>2]|0)>0){g=k[l>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[j>>2]|0;if(!((a|0)==(m|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=C+36|0;a=k[h>>2]|0;if(a|0?(c=a+12|0,A=k[c>>2]|0,k[c>>2]=A+-1,(A|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[C+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;C=C+16|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[s>>2]|0)>0){g=k[o>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[s>>2]|0))}a=k[q>>2]|0;if(!((a|0)==(b|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}h=D+36|0;a=k[h>>2]|0;if(a|0?(A=a+12|0,C=k[A>>2]|0,k[A>>2]=C+-1,(C|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[D+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;h=D+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[h>>2]|0)>0){g=k[D+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[D+44>>2]|0;if(!((a|0)==(D+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=E+36|0;a=k[h>>2]|0;if(a|0?(C=a+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[E+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;h=E+4|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[h>>2]|0)>0){g=k[E+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[E+44>>2]|0;if(!((a|0)==(E+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=F+36|0;a=k[h>>2]|0;if(a|0?(D=a+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[F+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;h=F+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[h>>2]|0)>0){g=k[F+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[F+44>>2]|0;if((a|0)==(F+48|0)|(a|0)==0){r=G;return}ggb(k[a+-4>>2]|0);r=G;return}function $_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0,h=0.0,i=0.0,j=0,m=0,n=0,p=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;H=r;r=r+1040|0;F=H;G=k[a+16>>2]|0;x=k[b+16>>2]|0;j=k[c+16>>2]|0;E=k[a+48>>2]|0;D=(k[b+48>>2]|0)>>>2;m=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>2:0;f=k[c+12>>2]|0;A=k[a+40>>2]|0;z=k[A+4>>2]|0;A=k[A>>2]|0;B=F+8|0;k[F>>2]=B;C=F+4|0;k[C>>2]=1032;c=(j|0)!=0;f=(f|0)<(z|0);a=c&f?A*20|0:A<<2;if(a>>>0>1032){while(1){b=fgb(a)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b;y=b}else y=B;k[C>>2]=a;a:do if(c){do if(f){a=y+(A<<2)|0;if((A|0)<=0)if(!a){w=14;break a}else{j=a;v=a;m=m|0?4:0;break}else b=0;do{u=j+((aa(b,m)|0)<<2)|0;u=k[u>>2]|0;v=b<<2;k[a+((v|3)<<2)>>2]=u;k[a+((v|2)<<2)>>2]=u;k[a+((v|1)<<2)>>2]=u;k[a+(v<<2)>>2]=u;b=b+1|0}while((b|0)!=(A|0));j=a;v=a;m=m|0?4:0}else v=0;while(0);if((z|0)>0){s=(v|0)!=0;t=(A|0)>0;u=z+-4|0;p=d*0.0;n=x;q=0;while(1){if(s){if(t){b=0;do{c=G+((aa(b,E)|0)+q)|0;f=v+((aa(b,m)|0)<<2)|0;o[y+(b<<2)>>2]=+(l[c>>0]|0)-+o[f>>2];b=b+1|0}while((b|0)!=(A|0))}}else if(t){b=0;do{c=G+((aa(b,E)|0)+q)|0;f=j+((aa(b,m)|0)+q<<2)|0;o[y+(b<<2)>>2]=+(l[c>>0]|0)-+o[f>>2];b=b+1|0}while((b|0)!=(A|0))}b:do if((q|0)>(u|0))b=q;else{if(t)b=q;else{b=q;while(1){o[n+(b<<2)>>2]=p;o[n+(b+1<<2)>>2]=p;o[n+(b+2<<2)>>2]=p;o[n+(b+3<<2)>>2]=p;b=b+4|0;if((b|0)>(u|0))break b}}do{a=s?v:j+(b<<2)|0;c=G+b|0;e=0.0;g=0.0;h=0.0;i=0.0;f=0;while(1){I=+o[y+(f<<2)>>2];i=i+I*(+(l[c>>0]|0)-+o[a>>2]);h=h+I*(+(l[c+1>>0]|0)-+o[a+4>>2]);g=g+I*(+(l[c+2>>0]|0)-+o[a+8>>2]);e=e+I*(+(l[c+3>>0]|0)-+o[a+12>>2]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(m<<2)|0;c=c+E|0}}o[n+(b<<2)>>2]=i*d;o[n+(b+1<<2)>>2]=h*d;o[n+(b+2<<2)>>2]=g*d;o[n+(b+3<<2)>>2]=e*d;b=b+4|0}while((b|0)<=(u|0))}while(0);c:do if((b|0)<(z|0)){if(!t)if(s)while(1){o[n+(b<<2)>>2]=p;b=b+1|0;if((b|0)==(z|0))break c}else while(1){o[n+(b<<2)>>2]=p;b=b+1|0;if((b|0)==(z|0))break c}if(s)do{a=G+b|0;e=0.0;c=v;f=0;while(1){e=e+ +o[y+(f<<2)>>2]*(+(l[a>>0]|0)-+o[c>>2]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+E|0;c=c+(m<<2)|0}}o[n+(b<<2)>>2]=e*d;b=b+1|0}while((b|0)!=(z|0));else do{a=G+b|0;e=0.0;c=j+(b<<2)|0;f=0;while(1){e=e+ +o[y+(f<<2)>>2]*(+(l[a>>0]|0)-+o[c>>2]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+E|0;c=c+(m<<2)|0}}o[n+(b<<2)>>2]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);q=q+1|0;if((q|0)==(z|0))break;else n=n+(D<<2)|0}}}else w=14;while(0);if((w|0)==14?(z|0)>0:0){m=(A|0)>0;n=z+-4|0;p=d*0.0;f=x;j=0;while(1){if(m){b=0;do{x=G+((aa(b,E)|0)+j)|0;o[y+(b<<2)>>2]=+(l[x>>0]|0);b=b+1|0}while((b|0)!=(A|0))}d:do if((j|0)>(n|0))b=j;else{if(m)b=j;else{b=j;while(1){o[f+(b<<2)>>2]=p;o[f+(b+1<<2)>>2]=p;o[f+(b+2<<2)>>2]=p;o[f+(b+3<<2)>>2]=p;b=b+4|0;if((b|0)>(n|0))break d}}do{a=G+b|0;e=0.0;g=0.0;h=0.0;i=0.0;c=0;while(1){I=+o[y+(c<<2)>>2];i=i+I*+(l[a>>0]|0);h=h+I*+(l[a+1>>0]|0);g=g+I*+(l[a+2>>0]|0);e=e+I*+(l[a+3>>0]|0);c=c+1|0;if((c|0)==(A|0))break;else a=a+E|0}o[f+(b<<2)>>2]=i*d;o[f+(b+1<<2)>>2]=h*d;o[f+(b+2<<2)>>2]=g*d;o[f+(b+3<<2)>>2]=e*d;b=b+4|0}while((b|0)<=(n|0))}while(0);e:do if((b|0)<(z|0)){if(!m)while(1){o[f+(b<<2)>>2]=p;b=b+1|0;if((b|0)==(z|0))break e}do{a=G+b|0;e=0.0;c=0;while(1){e=e+ +o[y+(c<<2)>>2]*+(l[a>>0]|0);c=c+1|0;if((c|0)==(A|0))break;else a=a+E|0}o[f+(b<<2)>>2]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);j=j+1|0;if((j|0)==(z|0))break;else f=f+(D<<2)|0}}if((y|0)==(B|0)){r=H;return}ggb(y);k[F>>2]=B;k[C>>2]=1032;r=H;return}function a$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,p=0,q=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;N=r;r=r+1056|0;G=N+1040|0;H=N;M=k[a+16>>2]|0;g=k[b+16>>2]|0;F=k[c+16>>2]|0;L=k[a+48>>2]|0;K=(k[b+48>>2]|0)>>>2;E=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>2:0;f=k[c+12>>2]|0;J=k[a+40>>2]|0;I=k[J+4>>2]|0;J=k[J>>2]|0;if(!F){if((J|0)<=0){r=N;return}i=I+-4|0;j=(I|0)<4;m=I&-4;n=(I|0)>0;p=(m|0)<(I|0);h=0;f=g;while(1){g=M+(aa(h,L)|0)|0;if(j){a=h;do{c=M+(aa(a,L)|0)|0;if(n){b=0;e=0.0;do{e=e+ +(l[g+b>>0]|0)*+(l[c+b>>0]|0);b=b+1|0}while((b|0)!=(I|0))}else e=0.0;o[f+(a<<2)>>2]=e*d;a=a+1|0}while((a|0)!=(J|0))}else{a=h;do{c=M+(aa(a,L)|0)|0;b=0;e=0.0;do{F=b|1;G=b|2;H=b|3;e=e+(+(l[g+b>>0]|0)*+(l[c+b>>0]|0)+ +(l[g+F>>0]|0)*+(l[c+F>>0]|0)+ +(l[g+G>>0]|0)*+(l[c+G>>0]|0)+ +(l[g+H>>0]|0)*+(l[c+H>>0]|0));b=b+4|0}while((b|0)<=(i|0));if(p){b=m;do{e=e+ +(l[g+b>>0]|0)*+(l[c+b>>0]|0);b=b+1|0}while((b|0)!=(I|0))}o[f+(a<<2)>>2]=e*d;a=a+1|0}while((a|0)!=(J|0))}h=h+1|0;if((h|0)==(J|0))break;else f=f+(K<<2)|0}r=N;return}B=(f|0)==(I|0)?4:0;c=I<<2;C=H+8|0;k[H>>2]=C;D=H+4|0;k[D>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[H>>2]=b}else b=C;k[D>>2]=c;if((J|0)>0){p=(f|0)<(I|0);s=(I|0)>0;t=G+12|0;v=G+8|0;w=G+4|0;x=I+-4|0;y=(I|0)<4;z=I&-4;m=aa(B,z)|0;A=G+m|0;n=0;j=g;m=F+m|0;while(1){a=M+(aa(n,L)|0)|0;f=F+((aa(n,E)|0)<<2)|0;if(p)if(s){c=0;do{o[b+(c<<2)>>2]=+(l[a+c>>0]|0)-+o[f>>2];c=c+1|0}while((c|0)!=(I|0));c=24}else{i=n;c=25}else if(s){c=0;do{o[b+(c<<2)>>2]=+(l[a+c>>0]|0)-+o[f+(c<<2)>>2];c=c+1|0}while((c|0)!=(I|0));c=24}else{g=n;h=m;c=34}if((c|0)==24)if(p){i=n;c=25}else{g=n;h=m;c=34}if((c|0)==25)while(1){h=M+(aa(i,L)|0)|0;c=F+((aa(i,E)|0)<<2)|0;c=k[c>>2]|0;k[t>>2]=c;k[v>>2]=c;k[w>>2]=c;k[G>>2]=c;a:do if(y){e=0.0;c=G;a=0}else{e=0.0;g=G;f=0;q=(k[u>>2]=c,+o[u>>2]);while(1){O=f|1;a=f|2;c=f|3;e=e+(+o[b+(f<<2)>>2]*(+(l[h+f>>0]|0)-q)+ +o[b+(O<<2)>>2]*(+(l[h+O>>0]|0)-+o[g+4>>2])+ +o[b+(a<<2)>>2]*(+(l[h+a>>0]|0)-+o[g+8>>2])+ +o[b+(c<<2)>>2]*(+(l[h+c>>0]|0)-+o[g+12>>2]));c=f+4|0;a=g+(B<<2)|0;if((c|0)>(x|0)){c=A;a=z;break a}g=a;f=c;q=+o[a>>2]}}while(0);if((a|0)<(I|0))while(1){e=e+ +o[b+(a<<2)>>2]*(+(l[h+a>>0]|0)-+o[c>>2]);a=a+1|0;if((a|0)==(I|0))break;else c=c+4|0}o[j+(i<<2)>>2]=e*d;i=i+1|0;if((i|0)==(J|0))break;else c=25}else if((c|0)==34)while(1){f=M+(aa(g,L)|0)|0;c=F+((aa(g,E)|0)<<2)|0;if(y){e=0.0;a=0}else{e=0.0;a=0;while(1){P=a|1;i=a|2;O=a|3;e=e+(+o[b+(a<<2)>>2]*(+(l[f+a>>0]|0)-+o[c>>2])+ +o[b+(P<<2)>>2]*(+(l[f+P>>0]|0)-+o[c+4>>2])+ +o[b+(i<<2)>>2]*(+(l[f+i>>0]|0)-+o[c+8>>2])+ +o[b+(O<<2)>>2]*(+(l[f+O>>0]|0)-+o[c+12>>2]));a=a+4|0;if((a|0)>(x|0)){c=h;a=z;break}else c=c+(B<<2)|0}}if((a|0)<(I|0))while(1){e=e+ +o[b+(a<<2)>>2]*(+(l[f+a>>0]|0)-+o[c>>2]);a=a+1|0;if((a|0)==(I|0))break;else c=c+4|0}o[j+(g<<2)>>2]=e*d;g=g+1|0;if((g|0)==(J|0))break;else{h=h+(E<<2)|0;c=34}}n=n+1|0;if((n|0)==(J|0))break;else{j=j+(K<<2)|0;m=m+(E<<2)|0}}}if((b|0)!=(C|0)){ggb(b);k[H>>2]=C;k[D>>2]=1032}r=N;return}function b$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0,h=0.0,i=0.0,j=0,m=0,n=0,o=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;H=r;r=r+1040|0;F=H;G=k[a+16>>2]|0;x=k[b+16>>2]|0;j=k[c+16>>2]|0;E=k[a+48>>2]|0;D=(k[b+48>>2]|0)>>>3;m=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>3:0;f=k[c+12>>2]|0;A=k[a+40>>2]|0;z=k[A+4>>2]|0;A=k[A>>2]|0;B=F+8|0;k[F>>2]=B;C=F+4|0;k[C>>2]=1032;c=(j|0)!=0;f=(f|0)<(z|0);a=c&f?A*40|0:A<<3;if(a>>>0>1032){while(1){b=fgb(a)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b;y=b}else y=B;k[C>>2]=a;a:do if(c){do if(f){a=y+(A<<3)|0;if((A|0)<=0)if(!a){w=14;break a}else{j=a;v=a;m=m|0?4:0;break}else b=0;do{v=j+((aa(b,m)|0)<<3)|0;o=+p[v>>3];v=b<<2;p[a+((v|3)<<3)>>3]=o;p[a+((v|2)<<3)>>3]=o;p[a+((v|1)<<3)>>3]=o;p[a+(v<<3)>>3]=o;b=b+1|0}while((b|0)!=(A|0));j=a;v=a;m=m|0?4:0}else v=0;while(0);if((z|0)>0){s=(v|0)!=0;t=(A|0)>0;u=z+-4|0;o=d*0.0;n=x;q=0;while(1){if(s){if(t){b=0;do{c=G+((aa(b,E)|0)+q)|0;f=v+((aa(b,m)|0)<<3)|0;p[y+(b<<3)>>3]=+(l[c>>0]|0)-+p[f>>3];b=b+1|0}while((b|0)!=(A|0))}}else if(t){b=0;do{c=G+((aa(b,E)|0)+q)|0;f=j+((aa(b,m)|0)+q<<3)|0;p[y+(b<<3)>>3]=+(l[c>>0]|0)-+p[f>>3];b=b+1|0}while((b|0)!=(A|0))}b:do if((q|0)>(u|0))b=q;else{if(t)b=q;else{b=q;while(1){p[n+(b<<3)>>3]=o;p[n+(b+1<<3)>>3]=o;p[n+(b+2<<3)>>3]=o;p[n+(b+3<<3)>>3]=o;b=b+4|0;if((b|0)>(u|0))break b}}do{a=s?v:j+(b<<3)|0;c=G+b|0;e=0.0;g=0.0;h=0.0;i=0.0;f=0;while(1){I=+p[y+(f<<3)>>3];i=i+I*(+(l[c>>0]|0)-+p[a>>3]);h=h+I*(+(l[c+1>>0]|0)-+p[a+8>>3]);g=g+I*(+(l[c+2>>0]|0)-+p[a+16>>3]);e=e+I*(+(l[c+3>>0]|0)-+p[a+24>>3]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(m<<3)|0;c=c+E|0}}p[n+(b<<3)>>3]=i*d;p[n+(b+1<<3)>>3]=h*d;p[n+(b+2<<3)>>3]=g*d;p[n+(b+3<<3)>>3]=e*d;b=b+4|0}while((b|0)<=(u|0))}while(0);c:do if((b|0)<(z|0)){if(!t)if(s)while(1){p[n+(b<<3)>>3]=o;b=b+1|0;if((b|0)==(z|0))break c}else while(1){p[n+(b<<3)>>3]=o;b=b+1|0;if((b|0)==(z|0))break c}if(s)do{a=G+b|0;e=0.0;c=v;f=0;while(1){e=e+ +p[y+(f<<3)>>3]*(+(l[a>>0]|0)-+p[c>>3]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+E|0;c=c+(m<<3)|0}}p[n+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(z|0));else do{a=G+b|0;e=0.0;c=j+(b<<3)|0;f=0;while(1){e=e+ +p[y+(f<<3)>>3]*(+(l[a>>0]|0)-+p[c>>3]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+E|0;c=c+(m<<3)|0}}p[n+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);q=q+1|0;if((q|0)==(z|0))break;else n=n+(D<<3)|0}}}else w=14;while(0);if((w|0)==14?(z|0)>0:0){m=(A|0)>0;n=z+-4|0;o=d*0.0;f=x;j=0;while(1){if(m){b=0;do{x=G+((aa(b,E)|0)+j)|0;p[y+(b<<3)>>3]=+(l[x>>0]|0);b=b+1|0}while((b|0)!=(A|0))}d:do if((j|0)>(n|0))b=j;else{if(m)b=j;else{b=j;while(1){p[f+(b<<3)>>3]=o;p[f+(b+1<<3)>>3]=o;p[f+(b+2<<3)>>3]=o;p[f+(b+3<<3)>>3]=o;b=b+4|0;if((b|0)>(n|0))break d}}do{a=G+b|0;e=0.0;g=0.0;h=0.0;i=0.0;c=0;while(1){I=+p[y+(c<<3)>>3];i=i+I*+(l[a>>0]|0);h=h+I*+(l[a+1>>0]|0);g=g+I*+(l[a+2>>0]|0);e=e+I*+(l[a+3>>0]|0);c=c+1|0;if((c|0)==(A|0))break;else a=a+E|0}p[f+(b<<3)>>3]=i*d;p[f+(b+1<<3)>>3]=h*d;p[f+(b+2<<3)>>3]=g*d;p[f+(b+3<<3)>>3]=e*d;b=b+4|0}while((b|0)<=(n|0))}while(0);e:do if((b|0)<(z|0)){if(!m)while(1){p[f+(b<<3)>>3]=o;b=b+1|0;if((b|0)==(z|0))break e}do{a=G+b|0;e=0.0;c=0;while(1){e=e+ +p[y+(c<<3)>>3]*+(l[a>>0]|0);c=c+1|0;if((c|0)==(A|0))break;else a=a+E|0}p[f+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);j=j+1|0;if((j|0)==(z|0))break;else f=f+(D<<3)|0}}if((y|0)==(B|0)){r=H;return}ggb(y);k[F>>2]=B;k[C>>2]=1032;r=H;return}function c$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;L=r;r=r+1072|0;E=L;F=L+32|0;K=k[a+16>>2]|0;g=k[b+16>>2]|0;D=k[c+16>>2]|0;J=k[a+48>>2]|0;I=(k[b+48>>2]|0)>>>3;C=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>3:0;f=k[c+12>>2]|0;H=k[a+40>>2]|0;G=k[H+4>>2]|0;H=k[H>>2]|0;if(!D){if((H|0)<=0){r=L;return}i=G+-4|0;j=(G|0)<4;m=G&-4;n=(G|0)>0;o=(m|0)<(G|0);h=0;f=g;while(1){g=K+(aa(h,J)|0)|0;if(j){a=h;do{c=K+(aa(a,J)|0)|0;if(n){b=0;e=0.0;do{e=e+ +(l[g+b>>0]|0)*+(l[c+b>>0]|0);b=b+1|0}while((b|0)!=(G|0))}else e=0.0;p[f+(a<<3)>>3]=e*d;a=a+1|0}while((a|0)!=(H|0))}else{a=h;do{c=K+(aa(a,J)|0)|0;b=0;e=0.0;do{D=b|1;E=b|2;F=b|3;e=e+(+(l[g+b>>0]|0)*+(l[c+b>>0]|0)+ +(l[g+D>>0]|0)*+(l[c+D>>0]|0)+ +(l[g+E>>0]|0)*+(l[c+E>>0]|0)+ +(l[g+F>>0]|0)*+(l[c+F>>0]|0));b=b+4|0}while((b|0)<=(i|0));if(o){b=m;do{e=e+ +(l[g+b>>0]|0)*+(l[c+b>>0]|0);b=b+1|0}while((b|0)!=(G|0))}p[f+(a<<3)>>3]=e*d;a=a+1|0}while((a|0)!=(H|0))}h=h+1|0;if((h|0)==(H|0))break;else f=f+(I<<3)|0}r=L;return}z=(f|0)==(G|0)?4:0;c=G<<3;A=F+8|0;k[F>>2]=A;B=F+4|0;k[B>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b}else b=A;k[B>>2]=c;if((H|0)>0){n=(f|0)<(G|0);o=(G|0)>0;s=E+24|0;t=E+16|0;u=E+8|0;v=G+-4|0;w=(G|0)<4;j=v>>>2;x=(j<<2)+4|0;j=aa(z,(j<<3)+8|0)|0;y=E+j|0;m=0;j=D+j|0;while(1){a=K+(aa(m,J)|0)|0;f=D+((aa(m,C)|0)<<3)|0;if(n)if(o){c=0;do{p[b+(c<<3)>>3]=+(l[a+c>>0]|0)-+p[f>>3];c=c+1|0}while((c|0)!=(G|0));c=24}else{i=m;c=25}else if(o){c=0;do{p[b+(c<<3)>>3]=+(l[a+c>>0]|0)-+p[f+(c<<3)>>3];c=c+1|0}while((c|0)!=(G|0));c=24}else{h=m;i=j;c=33}if((c|0)==24)if(n){i=m;c=25}else{h=m;i=j;c=33}if((c|0)==25)while(1){h=K+(aa(i,J)|0)|0;f=D+((aa(i,C)|0)<<3)|0;q=+p[f>>3];p[s>>3]=q;p[t>>3]=q;p[u>>3]=q;p[E>>3]=q;a:do if(w){e=0.0;c=E;a=0}else{e=0.0;f=E;c=0;while(1){N=c|1;M=c|2;a=c|3;e=e+(+p[b+(c<<3)>>3]*(+(l[h+c>>0]|0)-q)+ +p[b+(N<<3)>>3]*(+(l[h+N>>0]|0)-+p[f+8>>3])+ +p[b+(M<<3)>>3]*(+(l[h+M>>0]|0)-+p[f+16>>3])+ +p[b+(a<<3)>>3]*(+(l[h+a>>0]|0)-+p[f+24>>3]));c=c+4|0;a=f+(z<<3)|0;if((c|0)>(v|0)){c=y;a=x;break a}f=a;q=+p[a>>3]}}while(0);if((a|0)<(G|0))while(1){e=e+ +p[b+(a<<3)>>3]*(+(l[h+a>>0]|0)-+p[c>>3]);a=a+1|0;if((a|0)==(G|0))break;else c=c+8|0}p[g+(i<<3)>>3]=e*d;i=i+1|0;if((i|0)==(H|0))break;else c=25}else if((c|0)==33)while(1){f=K+(aa(h,J)|0)|0;c=D+((aa(h,C)|0)<<3)|0;if(w){e=0.0;a=0}else{e=0.0;a=0;while(1){O=a|1;M=a|2;N=a|3;e=e+(+p[b+(a<<3)>>3]*(+(l[f+a>>0]|0)-+p[c>>3])+ +p[b+(O<<3)>>3]*(+(l[f+O>>0]|0)-+p[c+8>>3])+ +p[b+(M<<3)>>3]*(+(l[f+M>>0]|0)-+p[c+16>>3])+ +p[b+(N<<3)>>3]*(+(l[f+N>>0]|0)-+p[c+24>>3]));a=a+4|0;if((a|0)>(v|0)){c=i;a=x;break}else c=c+(z<<3)|0}}if((a|0)<(G|0))while(1){e=e+ +p[b+(a<<3)>>3]*(+(l[f+a>>0]|0)-+p[c>>3]);a=a+1|0;if((a|0)==(G|0))break;else c=c+8|0}p[g+(h<<3)>>3]=e*d;h=h+1|0;if((h|0)==(H|0))break;else{i=i+(C<<3)|0;c=33}}m=m+1|0;if((m|0)==(H|0))break;else{g=g+(I<<3)|0;j=j+(C<<3)|0}}}if((b|0)!=(A|0)){ggb(b);k[F>>2]=A;k[B>>2]=1032}r=L;return}function d$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0,h=0.0,i=0.0,j=0,l=0,n=0,p=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;H=r;r=r+1040|0;F=H;G=k[a+16>>2]|0;x=k[b+16>>2]|0;j=k[c+16>>2]|0;E=(k[a+48>>2]|0)>>>1;D=(k[b+48>>2]|0)>>>2;l=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>2:0;f=k[c+12>>2]|0;A=k[a+40>>2]|0;z=k[A+4>>2]|0;A=k[A>>2]|0;B=F+8|0;k[F>>2]=B;C=F+4|0;k[C>>2]=1032;c=(j|0)!=0;f=(f|0)<(z|0);a=c&f?A*20|0:A<<2;if(a>>>0>1032){while(1){b=fgb(a)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b;y=b}else y=B;k[C>>2]=a;a:do if(c){do if(f){a=y+(A<<2)|0;if((A|0)<=0)if(!a){w=14;break a}else{j=a;v=a;l=l|0?4:0;break}else b=0;do{u=j+((aa(b,l)|0)<<2)|0;u=k[u>>2]|0;v=b<<2;k[a+((v|3)<<2)>>2]=u;k[a+((v|2)<<2)>>2]=u;k[a+((v|1)<<2)>>2]=u;k[a+(v<<2)>>2]=u;b=b+1|0}while((b|0)!=(A|0));j=a;v=a;l=l|0?4:0}else v=0;while(0);if((z|0)>0){s=(v|0)!=0;t=(A|0)>0;u=z+-4|0;p=d*0.0;n=x;q=0;while(1){if(s){if(t){b=0;do{c=G+((aa(b,E)|0)+q<<1)|0;f=v+((aa(b,l)|0)<<2)|0;o[y+(b<<2)>>2]=+(m[c>>1]|0)-+o[f>>2];b=b+1|0}while((b|0)!=(A|0))}}else if(t){b=0;do{c=G+((aa(b,E)|0)+q<<1)|0;f=j+((aa(b,l)|0)+q<<2)|0;o[y+(b<<2)>>2]=+(m[c>>1]|0)-+o[f>>2];b=b+1|0}while((b|0)!=(A|0))}b:do if((q|0)>(u|0))b=q;else{if(t)b=q;else{b=q;while(1){o[n+(b<<2)>>2]=p;o[n+(b+1<<2)>>2]=p;o[n+(b+2<<2)>>2]=p;o[n+(b+3<<2)>>2]=p;b=b+4|0;if((b|0)>(u|0))break b}}do{a=s?v:j+(b<<2)|0;c=G+(b<<1)|0;e=0.0;g=0.0;h=0.0;i=0.0;f=0;while(1){I=+o[y+(f<<2)>>2];i=i+I*(+(m[c>>1]|0)-+o[a>>2]);h=h+I*(+(m[c+2>>1]|0)-+o[a+4>>2]);g=g+I*(+(m[c+4>>1]|0)-+o[a+8>>2]);e=e+I*(+(m[c+6>>1]|0)-+o[a+12>>2]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(l<<2)|0;c=c+(E<<1)|0}}o[n+(b<<2)>>2]=i*d;o[n+(b+1<<2)>>2]=h*d;o[n+(b+2<<2)>>2]=g*d;o[n+(b+3<<2)>>2]=e*d;b=b+4|0}while((b|0)<=(u|0))}while(0);c:do if((b|0)<(z|0)){if(!t)if(s)while(1){o[n+(b<<2)>>2]=p;b=b+1|0;if((b|0)==(z|0))break c}else while(1){o[n+(b<<2)>>2]=p;b=b+1|0;if((b|0)==(z|0))break c}if(s)do{a=G+(b<<1)|0;e=0.0;c=v;f=0;while(1){e=e+ +o[y+(f<<2)>>2]*(+(m[a>>1]|0)-+o[c>>2]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(E<<1)|0;c=c+(l<<2)|0}}o[n+(b<<2)>>2]=e*d;b=b+1|0}while((b|0)!=(z|0));else do{a=G+(b<<1)|0;e=0.0;c=j+(b<<2)|0;f=0;while(1){e=e+ +o[y+(f<<2)>>2]*(+(m[a>>1]|0)-+o[c>>2]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(E<<1)|0;c=c+(l<<2)|0}}o[n+(b<<2)>>2]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);q=q+1|0;if((q|0)==(z|0))break;else n=n+(D<<2)|0}}}else w=14;while(0);if((w|0)==14?(z|0)>0:0){l=(A|0)>0;n=z+-4|0;p=d*0.0;f=x;j=0;while(1){if(l){b=0;do{x=G+((aa(b,E)|0)+j<<1)|0;o[y+(b<<2)>>2]=+(m[x>>1]|0);b=b+1|0}while((b|0)!=(A|0))}d:do if((j|0)>(n|0))b=j;else{if(l)b=j;else{b=j;while(1){o[f+(b<<2)>>2]=p;o[f+(b+1<<2)>>2]=p;o[f+(b+2<<2)>>2]=p;o[f+(b+3<<2)>>2]=p;b=b+4|0;if((b|0)>(n|0))break d}}do{a=G+(b<<1)|0;e=0.0;g=0.0;h=0.0;i=0.0;c=0;while(1){I=+o[y+(c<<2)>>2];i=i+I*+(m[a>>1]|0);h=h+I*+(m[a+2>>1]|0);g=g+I*+(m[a+4>>1]|0);e=e+I*+(m[a+6>>1]|0);c=c+1|0;if((c|0)==(A|0))break;else a=a+(E<<1)|0}o[f+(b<<2)>>2]=i*d;o[f+(b+1<<2)>>2]=h*d;o[f+(b+2<<2)>>2]=g*d;o[f+(b+3<<2)>>2]=e*d;b=b+4|0}while((b|0)<=(n|0))}while(0);e:do if((b|0)<(z|0)){if(!l)while(1){o[f+(b<<2)>>2]=p;b=b+1|0;if((b|0)==(z|0))break e}do{a=G+(b<<1)|0;e=0.0;c=0;while(1){e=e+ +o[y+(c<<2)>>2]*+(m[a>>1]|0);c=c+1|0;if((c|0)==(A|0))break;else a=a+(E<<1)|0}o[f+(b<<2)>>2]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);j=j+1|0;if((j|0)==(z|0))break;else f=f+(D<<2)|0}}if((y|0)==(B|0)){r=H;return}ggb(y);k[F>>2]=B;k[C>>2]=1032;r=H;return}function e$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,n=0,p=0,q=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;N=r;r=r+1056|0;G=N+1040|0;H=N;M=k[a+16>>2]|0;g=k[b+16>>2]|0;F=k[c+16>>2]|0;L=(k[a+48>>2]|0)>>>1;K=(k[b+48>>2]|0)>>>2;E=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>2:0;f=k[c+12>>2]|0;J=k[a+40>>2]|0;I=k[J+4>>2]|0;J=k[J>>2]|0;if(!F){if((J|0)<=0){r=N;return}i=I+-4|0;j=(I|0)<4;l=I&-4;n=(I|0)>0;p=(l|0)<(I|0);h=0;f=g;while(1){g=M+((aa(h,L)|0)<<1)|0;if(j){a=h;do{c=M+((aa(a,L)|0)<<1)|0;if(n){b=0;e=0.0;do{e=e+ +(m[g+(b<<1)>>1]|0)*+(m[c+(b<<1)>>1]|0);b=b+1|0}while((b|0)!=(I|0))}else e=0.0;o[f+(a<<2)>>2]=e*d;a=a+1|0}while((a|0)!=(J|0))}else{a=h;do{c=M+((aa(a,L)|0)<<1)|0;b=0;e=0.0;do{F=b|1;G=b|2;H=b|3;e=e+(+(m[g+(b<<1)>>1]|0)*+(m[c+(b<<1)>>1]|0)+ +(m[g+(F<<1)>>1]|0)*+(m[c+(F<<1)>>1]|0)+ +(m[g+(G<<1)>>1]|0)*+(m[c+(G<<1)>>1]|0)+ +(m[g+(H<<1)>>1]|0)*+(m[c+(H<<1)>>1]|0));b=b+4|0}while((b|0)<=(i|0));if(p){b=l;do{e=e+ +(m[g+(b<<1)>>1]|0)*+(m[c+(b<<1)>>1]|0);b=b+1|0}while((b|0)!=(I|0))}o[f+(a<<2)>>2]=e*d;a=a+1|0}while((a|0)!=(J|0))}h=h+1|0;if((h|0)==(J|0))break;else f=f+(K<<2)|0}r=N;return}B=(f|0)==(I|0)?4:0;c=I<<2;C=H+8|0;k[H>>2]=C;D=H+4|0;k[D>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[H>>2]=b}else b=C;k[D>>2]=c;if((J|0)>0){p=(f|0)<(I|0);s=(I|0)>0;t=G+12|0;v=G+8|0;w=G+4|0;x=I+-4|0;y=(I|0)<4;z=I&-4;l=aa(B,z)|0;A=G+l|0;n=0;j=g;l=F+l|0;while(1){a=M+((aa(n,L)|0)<<1)|0;f=F+((aa(n,E)|0)<<2)|0;if(p)if(s){c=0;do{o[b+(c<<2)>>2]=+(m[a+(c<<1)>>1]|0)-+o[f>>2];c=c+1|0}while((c|0)!=(I|0));c=24}else{i=n;c=25}else if(s){c=0;do{o[b+(c<<2)>>2]=+(m[a+(c<<1)>>1]|0)-+o[f+(c<<2)>>2];c=c+1|0}while((c|0)!=(I|0));c=24}else{g=n;h=l;c=34}if((c|0)==24)if(p){i=n;c=25}else{g=n;h=l;c=34}if((c|0)==25)while(1){h=M+((aa(i,L)|0)<<1)|0;c=F+((aa(i,E)|0)<<2)|0;c=k[c>>2]|0;k[t>>2]=c;k[v>>2]=c;k[w>>2]=c;k[G>>2]=c;a:do if(y){e=0.0;c=G;a=0}else{e=0.0;g=G;f=0;q=(k[u>>2]=c,+o[u>>2]);while(1){O=f|1;a=f|2;c=f|3;e=e+(+o[b+(f<<2)>>2]*(+(m[h+(f<<1)>>1]|0)-q)+ +o[b+(O<<2)>>2]*(+(m[h+(O<<1)>>1]|0)-+o[g+4>>2])+ +o[b+(a<<2)>>2]*(+(m[h+(a<<1)>>1]|0)-+o[g+8>>2])+ +o[b+(c<<2)>>2]*(+(m[h+(c<<1)>>1]|0)-+o[g+12>>2]));c=f+4|0;a=g+(B<<2)|0;if((c|0)>(x|0)){c=A;a=z;break a}g=a;f=c;q=+o[a>>2]}}while(0);if((a|0)<(I|0))while(1){e=e+ +o[b+(a<<2)>>2]*(+(m[h+(a<<1)>>1]|0)-+o[c>>2]);a=a+1|0;if((a|0)==(I|0))break;else c=c+4|0}o[j+(i<<2)>>2]=e*d;i=i+1|0;if((i|0)==(J|0))break;else c=25}else if((c|0)==34)while(1){f=M+((aa(g,L)|0)<<1)|0;c=F+((aa(g,E)|0)<<2)|0;if(y){e=0.0;a=0}else{e=0.0;a=0;while(1){P=a|1;i=a|2;O=a|3;e=e+(+o[b+(a<<2)>>2]*(+(m[f+(a<<1)>>1]|0)-+o[c>>2])+ +o[b+(P<<2)>>2]*(+(m[f+(P<<1)>>1]|0)-+o[c+4>>2])+ +o[b+(i<<2)>>2]*(+(m[f+(i<<1)>>1]|0)-+o[c+8>>2])+ +o[b+(O<<2)>>2]*(+(m[f+(O<<1)>>1]|0)-+o[c+12>>2]));a=a+4|0;if((a|0)>(x|0)){c=h;a=z;break}else c=c+(B<<2)|0}}if((a|0)<(I|0))while(1){e=e+ +o[b+(a<<2)>>2]*(+(m[f+(a<<1)>>1]|0)-+o[c>>2]);a=a+1|0;if((a|0)==(I|0))break;else c=c+4|0}o[j+(g<<2)>>2]=e*d;g=g+1|0;if((g|0)==(J|0))break;else{h=h+(E<<2)|0;c=34}}n=n+1|0;if((n|0)==(J|0))break;else{j=j+(K<<2)|0;l=l+(E<<2)|0}}}if((b|0)!=(C|0)){ggb(b);k[H>>2]=C;k[D>>2]=1032}r=N;return}function f$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0,h=0.0,i=0.0,j=0,l=0,n=0,o=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;H=r;r=r+1040|0;F=H;G=k[a+16>>2]|0;x=k[b+16>>2]|0;j=k[c+16>>2]|0;E=(k[a+48>>2]|0)>>>1;D=(k[b+48>>2]|0)>>>3;l=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>3:0;f=k[c+12>>2]|0;A=k[a+40>>2]|0;z=k[A+4>>2]|0;A=k[A>>2]|0;B=F+8|0;k[F>>2]=B;C=F+4|0;k[C>>2]=1032;c=(j|0)!=0;f=(f|0)<(z|0);a=c&f?A*40|0:A<<3;if(a>>>0>1032){while(1){b=fgb(a)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b;y=b}else y=B;k[C>>2]=a;a:do if(c){do if(f){a=y+(A<<3)|0;if((A|0)<=0)if(!a){w=14;break a}else{j=a;v=a;l=l|0?4:0;break}else b=0;do{v=j+((aa(b,l)|0)<<3)|0;o=+p[v>>3];v=b<<2;p[a+((v|3)<<3)>>3]=o;p[a+((v|2)<<3)>>3]=o;p[a+((v|1)<<3)>>3]=o;p[a+(v<<3)>>3]=o;b=b+1|0}while((b|0)!=(A|0));j=a;v=a;l=l|0?4:0}else v=0;while(0);if((z|0)>0){s=(v|0)!=0;t=(A|0)>0;u=z+-4|0;o=d*0.0;n=x;q=0;while(1){if(s){if(t){b=0;do{c=G+((aa(b,E)|0)+q<<1)|0;f=v+((aa(b,l)|0)<<3)|0;p[y+(b<<3)>>3]=+(m[c>>1]|0)-+p[f>>3];b=b+1|0}while((b|0)!=(A|0))}}else if(t){b=0;do{c=G+((aa(b,E)|0)+q<<1)|0;f=j+((aa(b,l)|0)+q<<3)|0;p[y+(b<<3)>>3]=+(m[c>>1]|0)-+p[f>>3];b=b+1|0}while((b|0)!=(A|0))}b:do if((q|0)>(u|0))b=q;else{if(t)b=q;else{b=q;while(1){p[n+(b<<3)>>3]=o;p[n+(b+1<<3)>>3]=o;p[n+(b+2<<3)>>3]=o;p[n+(b+3<<3)>>3]=o;b=b+4|0;if((b|0)>(u|0))break b}}do{a=s?v:j+(b<<3)|0;c=G+(b<<1)|0;e=0.0;g=0.0;h=0.0;i=0.0;f=0;while(1){I=+p[y+(f<<3)>>3];i=i+I*(+(m[c>>1]|0)-+p[a>>3]);h=h+I*(+(m[c+2>>1]|0)-+p[a+8>>3]);g=g+I*(+(m[c+4>>1]|0)-+p[a+16>>3]);e=e+I*(+(m[c+6>>1]|0)-+p[a+24>>3]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(l<<3)|0;c=c+(E<<1)|0}}p[n+(b<<3)>>3]=i*d;p[n+(b+1<<3)>>3]=h*d;p[n+(b+2<<3)>>3]=g*d;p[n+(b+3<<3)>>3]=e*d;b=b+4|0}while((b|0)<=(u|0))}while(0);c:do if((b|0)<(z|0)){if(!t)if(s)while(1){p[n+(b<<3)>>3]=o;b=b+1|0;if((b|0)==(z|0))break c}else while(1){p[n+(b<<3)>>3]=o;b=b+1|0;if((b|0)==(z|0))break c}if(s)do{a=G+(b<<1)|0;e=0.0;c=v;f=0;while(1){e=e+ +p[y+(f<<3)>>3]*(+(m[a>>1]|0)-+p[c>>3]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(E<<1)|0;c=c+(l<<3)|0}}p[n+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(z|0));else do{a=G+(b<<1)|0;e=0.0;c=j+(b<<3)|0;f=0;while(1){e=e+ +p[y+(f<<3)>>3]*(+(m[a>>1]|0)-+p[c>>3]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(E<<1)|0;c=c+(l<<3)|0}}p[n+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);q=q+1|0;if((q|0)==(z|0))break;else n=n+(D<<3)|0}}}else w=14;while(0);if((w|0)==14?(z|0)>0:0){l=(A|0)>0;n=z+-4|0;o=d*0.0;f=x;j=0;while(1){if(l){b=0;do{x=G+((aa(b,E)|0)+j<<1)|0;p[y+(b<<3)>>3]=+(m[x>>1]|0);b=b+1|0}while((b|0)!=(A|0))}d:do if((j|0)>(n|0))b=j;else{if(l)b=j;else{b=j;while(1){p[f+(b<<3)>>3]=o;p[f+(b+1<<3)>>3]=o;p[f+(b+2<<3)>>3]=o;p[f+(b+3<<3)>>3]=o;b=b+4|0;if((b|0)>(n|0))break d}}do{a=G+(b<<1)|0;e=0.0;g=0.0;h=0.0;i=0.0;c=0;while(1){I=+p[y+(c<<3)>>3];i=i+I*+(m[a>>1]|0);h=h+I*+(m[a+2>>1]|0);g=g+I*+(m[a+4>>1]|0);e=e+I*+(m[a+6>>1]|0);c=c+1|0;if((c|0)==(A|0))break;else a=a+(E<<1)|0}p[f+(b<<3)>>3]=i*d;p[f+(b+1<<3)>>3]=h*d;p[f+(b+2<<3)>>3]=g*d;p[f+(b+3<<3)>>3]=e*d;b=b+4|0}while((b|0)<=(n|0))}while(0);e:do if((b|0)<(z|0)){if(!l)while(1){p[f+(b<<3)>>3]=o;b=b+1|0;if((b|0)==(z|0))break e}do{a=G+(b<<1)|0;e=0.0;c=0;while(1){e=e+ +p[y+(c<<3)>>3]*+(m[a>>1]|0);c=c+1|0;if((c|0)==(A|0))break;else a=a+(E<<1)|0}p[f+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);j=j+1|0;if((j|0)==(z|0))break;else f=f+(D<<3)|0}}if((y|0)==(B|0)){r=H;return}ggb(y);k[F>>2]=B;k[C>>2]=1032;r=H;return}function g$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,n=0,o=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;L=r;r=r+1072|0;E=L;F=L+32|0;K=k[a+16>>2]|0;g=k[b+16>>2]|0;D=k[c+16>>2]|0;J=(k[a+48>>2]|0)>>>1;I=(k[b+48>>2]|0)>>>3;C=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>3:0;f=k[c+12>>2]|0;H=k[a+40>>2]|0;G=k[H+4>>2]|0;H=k[H>>2]|0;if(!D){if((H|0)<=0){r=L;return}i=G+-4|0;j=(G|0)<4;l=G&-4;n=(G|0)>0;o=(l|0)<(G|0);h=0;f=g;while(1){g=K+((aa(h,J)|0)<<1)|0;if(j){a=h;do{c=K+((aa(a,J)|0)<<1)|0;if(n){b=0;e=0.0;do{e=e+ +(m[g+(b<<1)>>1]|0)*+(m[c+(b<<1)>>1]|0);b=b+1|0}while((b|0)!=(G|0))}else e=0.0;p[f+(a<<3)>>3]=e*d;a=a+1|0}while((a|0)!=(H|0))}else{a=h;do{c=K+((aa(a,J)|0)<<1)|0;b=0;e=0.0;do{D=b|1;E=b|2;F=b|3;e=e+(+(m[g+(b<<1)>>1]|0)*+(m[c+(b<<1)>>1]|0)+ +(m[g+(D<<1)>>1]|0)*+(m[c+(D<<1)>>1]|0)+ +(m[g+(E<<1)>>1]|0)*+(m[c+(E<<1)>>1]|0)+ +(m[g+(F<<1)>>1]|0)*+(m[c+(F<<1)>>1]|0));b=b+4|0}while((b|0)<=(i|0));if(o){b=l;do{e=e+ +(m[g+(b<<1)>>1]|0)*+(m[c+(b<<1)>>1]|0);b=b+1|0}while((b|0)!=(G|0))}p[f+(a<<3)>>3]=e*d;a=a+1|0}while((a|0)!=(H|0))}h=h+1|0;if((h|0)==(H|0))break;else f=f+(I<<3)|0}r=L;return}z=(f|0)==(G|0)?4:0;c=G<<3;A=F+8|0;k[F>>2]=A;B=F+4|0;k[B>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b}else b=A;k[B>>2]=c;if((H|0)>0){n=(f|0)<(G|0);o=(G|0)>0;s=E+24|0;t=E+16|0;u=E+8|0;v=G+-4|0;w=(G|0)<4;j=v>>>2;x=(j<<2)+4|0;j=aa(z,(j<<3)+8|0)|0;y=E+j|0;l=0;j=D+j|0;while(1){a=K+((aa(l,J)|0)<<1)|0;f=D+((aa(l,C)|0)<<3)|0;if(n)if(o){c=0;do{p[b+(c<<3)>>3]=+(m[a+(c<<1)>>1]|0)-+p[f>>3];c=c+1|0}while((c|0)!=(G|0));c=24}else{i=l;c=25}else if(o){c=0;do{p[b+(c<<3)>>3]=+(m[a+(c<<1)>>1]|0)-+p[f+(c<<3)>>3];c=c+1|0}while((c|0)!=(G|0));c=24}else{h=l;i=j;c=33}if((c|0)==24)if(n){i=l;c=25}else{h=l;i=j;c=33}if((c|0)==25)while(1){h=K+((aa(i,J)|0)<<1)|0;f=D+((aa(i,C)|0)<<3)|0;q=+p[f>>3];p[s>>3]=q;p[t>>3]=q;p[u>>3]=q;p[E>>3]=q;a:do if(w){e=0.0;c=E;a=0}else{e=0.0;f=E;c=0;while(1){N=c|1;M=c|2;a=c|3;e=e+(+p[b+(c<<3)>>3]*(+(m[h+(c<<1)>>1]|0)-q)+ +p[b+(N<<3)>>3]*(+(m[h+(N<<1)>>1]|0)-+p[f+8>>3])+ +p[b+(M<<3)>>3]*(+(m[h+(M<<1)>>1]|0)-+p[f+16>>3])+ +p[b+(a<<3)>>3]*(+(m[h+(a<<1)>>1]|0)-+p[f+24>>3]));c=c+4|0;a=f+(z<<3)|0;if((c|0)>(v|0)){c=y;a=x;break a}f=a;q=+p[a>>3]}}while(0);if((a|0)<(G|0))while(1){e=e+ +p[b+(a<<3)>>3]*(+(m[h+(a<<1)>>1]|0)-+p[c>>3]);a=a+1|0;if((a|0)==(G|0))break;else c=c+8|0}p[g+(i<<3)>>3]=e*d;i=i+1|0;if((i|0)==(H|0))break;else c=25}else if((c|0)==33)while(1){f=K+((aa(h,J)|0)<<1)|0;c=D+((aa(h,C)|0)<<3)|0;if(w){e=0.0;a=0}else{e=0.0;a=0;while(1){O=a|1;M=a|2;N=a|3;e=e+(+p[b+(a<<3)>>3]*(+(m[f+(a<<1)>>1]|0)-+p[c>>3])+ +p[b+(O<<3)>>3]*(+(m[f+(O<<1)>>1]|0)-+p[c+8>>3])+ +p[b+(M<<3)>>3]*(+(m[f+(M<<1)>>1]|0)-+p[c+16>>3])+ +p[b+(N<<3)>>3]*(+(m[f+(N<<1)>>1]|0)-+p[c+24>>3]));a=a+4|0;if((a|0)>(v|0)){c=i;a=x;break}else c=c+(z<<3)|0}}if((a|0)<(G|0))while(1){e=e+ +p[b+(a<<3)>>3]*(+(m[f+(a<<1)>>1]|0)-+p[c>>3]);a=a+1|0;if((a|0)==(G|0))break;else c=c+8|0}p[g+(h<<3)>>3]=e*d;h=h+1|0;if((h|0)==(H|0))break;else{i=i+(C<<3)|0;c=33}}l=l+1|0;if((l|0)==(H|0))break;else{g=g+(I<<3)|0;j=j+(C<<3)|0}}}if((b|0)!=(A|0)){ggb(b);k[F>>2]=A;k[B>>2]=1032}r=L;return}function h$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0,h=0.0,i=0.0,l=0,m=0,n=0,p=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;H=r;r=r+1040|0;F=H;G=k[a+16>>2]|0;x=k[b+16>>2]|0;l=k[c+16>>2]|0;E=(k[a+48>>2]|0)>>>1;D=(k[b+48>>2]|0)>>>2;m=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>2:0;f=k[c+12>>2]|0;A=k[a+40>>2]|0;z=k[A+4>>2]|0;A=k[A>>2]|0;B=F+8|0;k[F>>2]=B;C=F+4|0;k[C>>2]=1032;c=(l|0)!=0;f=(f|0)<(z|0);a=c&f?A*20|0:A<<2;if(a>>>0>1032){while(1){b=fgb(a)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b;y=b}else y=B;k[C>>2]=a;a:do if(c){do if(f){a=y+(A<<2)|0;if((A|0)<=0)if(!a){w=14;break a}else{l=a;v=a;m=m|0?4:0;break}else b=0;do{u=l+((aa(b,m)|0)<<2)|0;u=k[u>>2]|0;v=b<<2;k[a+((v|3)<<2)>>2]=u;k[a+((v|2)<<2)>>2]=u;k[a+((v|1)<<2)>>2]=u;k[a+(v<<2)>>2]=u;b=b+1|0}while((b|0)!=(A|0));l=a;v=a;m=m|0?4:0}else v=0;while(0);if((z|0)>0){s=(v|0)!=0;t=(A|0)>0;u=z+-4|0;p=d*0.0;n=x;q=0;while(1){if(s){if(t){b=0;do{c=G+((aa(b,E)|0)+q<<1)|0;f=v+((aa(b,m)|0)<<2)|0;o[y+(b<<2)>>2]=+(j[c>>1]|0)-+o[f>>2];b=b+1|0}while((b|0)!=(A|0))}}else if(t){b=0;do{c=G+((aa(b,E)|0)+q<<1)|0;f=l+((aa(b,m)|0)+q<<2)|0;o[y+(b<<2)>>2]=+(j[c>>1]|0)-+o[f>>2];b=b+1|0}while((b|0)!=(A|0))}b:do if((q|0)>(u|0))b=q;else{if(t)b=q;else{b=q;while(1){o[n+(b<<2)>>2]=p;o[n+(b+1<<2)>>2]=p;o[n+(b+2<<2)>>2]=p;o[n+(b+3<<2)>>2]=p;b=b+4|0;if((b|0)>(u|0))break b}}do{a=s?v:l+(b<<2)|0;c=G+(b<<1)|0;e=0.0;g=0.0;h=0.0;i=0.0;f=0;while(1){I=+o[y+(f<<2)>>2];i=i+I*(+(j[c>>1]|0)-+o[a>>2]);h=h+I*(+(j[c+2>>1]|0)-+o[a+4>>2]);g=g+I*(+(j[c+4>>1]|0)-+o[a+8>>2]);e=e+I*(+(j[c+6>>1]|0)-+o[a+12>>2]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(m<<2)|0;c=c+(E<<1)|0}}o[n+(b<<2)>>2]=i*d;o[n+(b+1<<2)>>2]=h*d;o[n+(b+2<<2)>>2]=g*d;o[n+(b+3<<2)>>2]=e*d;b=b+4|0}while((b|0)<=(u|0))}while(0);c:do if((b|0)<(z|0)){if(!t)if(s)while(1){o[n+(b<<2)>>2]=p;b=b+1|0;if((b|0)==(z|0))break c}else while(1){o[n+(b<<2)>>2]=p;b=b+1|0;if((b|0)==(z|0))break c}if(s)do{a=G+(b<<1)|0;e=0.0;c=v;f=0;while(1){e=e+ +o[y+(f<<2)>>2]*(+(j[a>>1]|0)-+o[c>>2]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(E<<1)|0;c=c+(m<<2)|0}}o[n+(b<<2)>>2]=e*d;b=b+1|0}while((b|0)!=(z|0));else do{a=G+(b<<1)|0;e=0.0;c=l+(b<<2)|0;f=0;while(1){e=e+ +o[y+(f<<2)>>2]*(+(j[a>>1]|0)-+o[c>>2]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(E<<1)|0;c=c+(m<<2)|0}}o[n+(b<<2)>>2]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);q=q+1|0;if((q|0)==(z|0))break;else n=n+(D<<2)|0}}}else w=14;while(0);if((w|0)==14?(z|0)>0:0){m=(A|0)>0;n=z+-4|0;p=d*0.0;f=x;l=0;while(1){if(m){b=0;do{x=G+((aa(b,E)|0)+l<<1)|0;o[y+(b<<2)>>2]=+(j[x>>1]|0);b=b+1|0}while((b|0)!=(A|0))}d:do if((l|0)>(n|0))b=l;else{if(m)b=l;else{b=l;while(1){o[f+(b<<2)>>2]=p;o[f+(b+1<<2)>>2]=p;o[f+(b+2<<2)>>2]=p;o[f+(b+3<<2)>>2]=p;b=b+4|0;if((b|0)>(n|0))break d}}do{a=G+(b<<1)|0;e=0.0;g=0.0;h=0.0;i=0.0;c=0;while(1){I=+o[y+(c<<2)>>2];i=i+I*+(j[a>>1]|0);h=h+I*+(j[a+2>>1]|0);g=g+I*+(j[a+4>>1]|0);e=e+I*+(j[a+6>>1]|0);c=c+1|0;if((c|0)==(A|0))break;else a=a+(E<<1)|0}o[f+(b<<2)>>2]=i*d;o[f+(b+1<<2)>>2]=h*d;o[f+(b+2<<2)>>2]=g*d;o[f+(b+3<<2)>>2]=e*d;b=b+4|0}while((b|0)<=(n|0))}while(0);e:do if((b|0)<(z|0)){if(!m)while(1){o[f+(b<<2)>>2]=p;b=b+1|0;if((b|0)==(z|0))break e}do{a=G+(b<<1)|0;e=0.0;c=0;while(1){e=e+ +o[y+(c<<2)>>2]*+(j[a>>1]|0);c=c+1|0;if((c|0)==(A|0))break;else a=a+(E<<1)|0}o[f+(b<<2)>>2]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);l=l+1|0;if((l|0)==(z|0))break;else f=f+(D<<2)|0}}if((y|0)==(B|0)){r=H;return}ggb(y);k[F>>2]=B;k[C>>2]=1032;r=H;return}function i$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,p=0,q=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;N=r;r=r+1056|0;G=N+1040|0;H=N;M=k[a+16>>2]|0;g=k[b+16>>2]|0;F=k[c+16>>2]|0;L=(k[a+48>>2]|0)>>>1;K=(k[b+48>>2]|0)>>>2;E=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>2:0;f=k[c+12>>2]|0;J=k[a+40>>2]|0;I=k[J+4>>2]|0;J=k[J>>2]|0;if(!F){if((J|0)<=0){r=N;return}i=I+-4|0;l=(I|0)<4;m=I&-4;n=(I|0)>0;p=(m|0)<(I|0);h=0;f=g;while(1){g=M+((aa(h,L)|0)<<1)|0;if(l){a=h;do{c=M+((aa(a,L)|0)<<1)|0;if(n){b=0;e=0.0;do{e=e+ +(j[g+(b<<1)>>1]|0)*+(j[c+(b<<1)>>1]|0);b=b+1|0}while((b|0)!=(I|0))}else e=0.0;o[f+(a<<2)>>2]=e*d;a=a+1|0}while((a|0)!=(J|0))}else{a=h;do{c=M+((aa(a,L)|0)<<1)|0;b=0;e=0.0;do{F=b|1;G=b|2;H=b|3;e=e+(+(j[g+(b<<1)>>1]|0)*+(j[c+(b<<1)>>1]|0)+ +(j[g+(F<<1)>>1]|0)*+(j[c+(F<<1)>>1]|0)+ +(j[g+(G<<1)>>1]|0)*+(j[c+(G<<1)>>1]|0)+ +(j[g+(H<<1)>>1]|0)*+(j[c+(H<<1)>>1]|0));b=b+4|0}while((b|0)<=(i|0));if(p){b=m;do{e=e+ +(j[g+(b<<1)>>1]|0)*+(j[c+(b<<1)>>1]|0);b=b+1|0}while((b|0)!=(I|0))}o[f+(a<<2)>>2]=e*d;a=a+1|0}while((a|0)!=(J|0))}h=h+1|0;if((h|0)==(J|0))break;else f=f+(K<<2)|0}r=N;return}B=(f|0)==(I|0)?4:0;c=I<<2;C=H+8|0;k[H>>2]=C;D=H+4|0;k[D>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[H>>2]=b}else b=C;k[D>>2]=c;if((J|0)>0){p=(f|0)<(I|0);s=(I|0)>0;t=G+12|0;v=G+8|0;w=G+4|0;x=I+-4|0;y=(I|0)<4;z=I&-4;m=aa(B,z)|0;A=G+m|0;n=0;l=g;m=F+m|0;while(1){a=M+((aa(n,L)|0)<<1)|0;f=F+((aa(n,E)|0)<<2)|0;if(p)if(s){c=0;do{o[b+(c<<2)>>2]=+(j[a+(c<<1)>>1]|0)-+o[f>>2];c=c+1|0}while((c|0)!=(I|0));c=24}else{i=n;c=25}else if(s){c=0;do{o[b+(c<<2)>>2]=+(j[a+(c<<1)>>1]|0)-+o[f+(c<<2)>>2];c=c+1|0}while((c|0)!=(I|0));c=24}else{g=n;h=m;c=34}if((c|0)==24)if(p){i=n;c=25}else{g=n;h=m;c=34}if((c|0)==25)while(1){h=M+((aa(i,L)|0)<<1)|0;c=F+((aa(i,E)|0)<<2)|0;c=k[c>>2]|0;k[t>>2]=c;k[v>>2]=c;k[w>>2]=c;k[G>>2]=c;a:do if(y){e=0.0;c=G;a=0}else{e=0.0;g=G;f=0;q=(k[u>>2]=c,+o[u>>2]);while(1){O=f|1;a=f|2;c=f|3;e=e+(+o[b+(f<<2)>>2]*(+(j[h+(f<<1)>>1]|0)-q)+ +o[b+(O<<2)>>2]*(+(j[h+(O<<1)>>1]|0)-+o[g+4>>2])+ +o[b+(a<<2)>>2]*(+(j[h+(a<<1)>>1]|0)-+o[g+8>>2])+ +o[b+(c<<2)>>2]*(+(j[h+(c<<1)>>1]|0)-+o[g+12>>2]));c=f+4|0;a=g+(B<<2)|0;if((c|0)>(x|0)){c=A;a=z;break a}g=a;f=c;q=+o[a>>2]}}while(0);if((a|0)<(I|0))while(1){e=e+ +o[b+(a<<2)>>2]*(+(j[h+(a<<1)>>1]|0)-+o[c>>2]);a=a+1|0;if((a|0)==(I|0))break;else c=c+4|0}o[l+(i<<2)>>2]=e*d;i=i+1|0;if((i|0)==(J|0))break;else c=25}else if((c|0)==34)while(1){f=M+((aa(g,L)|0)<<1)|0;c=F+((aa(g,E)|0)<<2)|0;if(y){e=0.0;a=0}else{e=0.0;a=0;while(1){P=a|1;i=a|2;O=a|3;e=e+(+o[b+(a<<2)>>2]*(+(j[f+(a<<1)>>1]|0)-+o[c>>2])+ +o[b+(P<<2)>>2]*(+(j[f+(P<<1)>>1]|0)-+o[c+4>>2])+ +o[b+(i<<2)>>2]*(+(j[f+(i<<1)>>1]|0)-+o[c+8>>2])+ +o[b+(O<<2)>>2]*(+(j[f+(O<<1)>>1]|0)-+o[c+12>>2]));a=a+4|0;if((a|0)>(x|0)){c=h;a=z;break}else c=c+(B<<2)|0}}if((a|0)<(I|0))while(1){e=e+ +o[b+(a<<2)>>2]*(+(j[f+(a<<1)>>1]|0)-+o[c>>2]);a=a+1|0;if((a|0)==(I|0))break;else c=c+4|0}o[l+(g<<2)>>2]=e*d;g=g+1|0;if((g|0)==(J|0))break;else{h=h+(E<<2)|0;c=34}}n=n+1|0;if((n|0)==(J|0))break;else{l=l+(K<<2)|0;m=m+(E<<2)|0}}}if((b|0)!=(C|0)){ggb(b);k[H>>2]=C;k[D>>2]=1032}r=N;return}function j$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0,h=0.0,i=0.0,l=0,m=0,n=0,o=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;H=r;r=r+1040|0;F=H;G=k[a+16>>2]|0;x=k[b+16>>2]|0;l=k[c+16>>2]|0;E=(k[a+48>>2]|0)>>>1;D=(k[b+48>>2]|0)>>>3;m=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>3:0;f=k[c+12>>2]|0;A=k[a+40>>2]|0;z=k[A+4>>2]|0;A=k[A>>2]|0;B=F+8|0;k[F>>2]=B;C=F+4|0;k[C>>2]=1032;c=(l|0)!=0;f=(f|0)<(z|0);a=c&f?A*40|0:A<<3;if(a>>>0>1032){while(1){b=fgb(a)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b;y=b}else y=B;k[C>>2]=a;a:do if(c){do if(f){a=y+(A<<3)|0;if((A|0)<=0)if(!a){w=14;break a}else{l=a;v=a;m=m|0?4:0;break}else b=0;do{v=l+((aa(b,m)|0)<<3)|0;o=+p[v>>3];v=b<<2;p[a+((v|3)<<3)>>3]=o;p[a+((v|2)<<3)>>3]=o;p[a+((v|1)<<3)>>3]=o;p[a+(v<<3)>>3]=o;b=b+1|0}while((b|0)!=(A|0));l=a;v=a;m=m|0?4:0}else v=0;while(0);if((z|0)>0){s=(v|0)!=0;t=(A|0)>0;u=z+-4|0;o=d*0.0;n=x;q=0;while(1){if(s){if(t){b=0;do{c=G+((aa(b,E)|0)+q<<1)|0;f=v+((aa(b,m)|0)<<3)|0;p[y+(b<<3)>>3]=+(j[c>>1]|0)-+p[f>>3];b=b+1|0}while((b|0)!=(A|0))}}else if(t){b=0;do{c=G+((aa(b,E)|0)+q<<1)|0;f=l+((aa(b,m)|0)+q<<3)|0;p[y+(b<<3)>>3]=+(j[c>>1]|0)-+p[f>>3];b=b+1|0}while((b|0)!=(A|0))}b:do if((q|0)>(u|0))b=q;else{if(t)b=q;else{b=q;while(1){p[n+(b<<3)>>3]=o;p[n+(b+1<<3)>>3]=o;p[n+(b+2<<3)>>3]=o;p[n+(b+3<<3)>>3]=o;b=b+4|0;if((b|0)>(u|0))break b}}do{a=s?v:l+(b<<3)|0;c=G+(b<<1)|0;e=0.0;g=0.0;h=0.0;i=0.0;f=0;while(1){I=+p[y+(f<<3)>>3];i=i+I*(+(j[c>>1]|0)-+p[a>>3]);h=h+I*(+(j[c+2>>1]|0)-+p[a+8>>3]);g=g+I*(+(j[c+4>>1]|0)-+p[a+16>>3]);e=e+I*(+(j[c+6>>1]|0)-+p[a+24>>3]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(m<<3)|0;c=c+(E<<1)|0}}p[n+(b<<3)>>3]=i*d;p[n+(b+1<<3)>>3]=h*d;p[n+(b+2<<3)>>3]=g*d;p[n+(b+3<<3)>>3]=e*d;b=b+4|0}while((b|0)<=(u|0))}while(0);c:do if((b|0)<(z|0)){if(!t)if(s)while(1){p[n+(b<<3)>>3]=o;b=b+1|0;if((b|0)==(z|0))break c}else while(1){p[n+(b<<3)>>3]=o;b=b+1|0;if((b|0)==(z|0))break c}if(s)do{a=G+(b<<1)|0;e=0.0;c=v;f=0;while(1){e=e+ +p[y+(f<<3)>>3]*(+(j[a>>1]|0)-+p[c>>3]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(E<<1)|0;c=c+(m<<3)|0}}p[n+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(z|0));else do{a=G+(b<<1)|0;e=0.0;c=l+(b<<3)|0;f=0;while(1){e=e+ +p[y+(f<<3)>>3]*(+(j[a>>1]|0)-+p[c>>3]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(E<<1)|0;c=c+(m<<3)|0}}p[n+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);q=q+1|0;if((q|0)==(z|0))break;else n=n+(D<<3)|0}}}else w=14;while(0);if((w|0)==14?(z|0)>0:0){m=(A|0)>0;n=z+-4|0;o=d*0.0;f=x;l=0;while(1){if(m){b=0;do{x=G+((aa(b,E)|0)+l<<1)|0;p[y+(b<<3)>>3]=+(j[x>>1]|0);b=b+1|0}while((b|0)!=(A|0))}d:do if((l|0)>(n|0))b=l;else{if(m)b=l;else{b=l;while(1){p[f+(b<<3)>>3]=o;p[f+(b+1<<3)>>3]=o;p[f+(b+2<<3)>>3]=o;p[f+(b+3<<3)>>3]=o;b=b+4|0;if((b|0)>(n|0))break d}}do{a=G+(b<<1)|0;e=0.0;g=0.0;h=0.0;i=0.0;c=0;while(1){I=+p[y+(c<<3)>>3];i=i+I*+(j[a>>1]|0);h=h+I*+(j[a+2>>1]|0);g=g+I*+(j[a+4>>1]|0);e=e+I*+(j[a+6>>1]|0);c=c+1|0;if((c|0)==(A|0))break;else a=a+(E<<1)|0}p[f+(b<<3)>>3]=i*d;p[f+(b+1<<3)>>3]=h*d;p[f+(b+2<<3)>>3]=g*d;p[f+(b+3<<3)>>3]=e*d;b=b+4|0}while((b|0)<=(n|0))}while(0);e:do if((b|0)<(z|0)){if(!m)while(1){p[f+(b<<3)>>3]=o;b=b+1|0;if((b|0)==(z|0))break e}do{a=G+(b<<1)|0;e=0.0;c=0;while(1){e=e+ +p[y+(c<<3)>>3]*+(j[a>>1]|0);c=c+1|0;if((c|0)==(A|0))break;else a=a+(E<<1)|0}p[f+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);l=l+1|0;if((l|0)==(z|0))break;else f=f+(D<<3)|0}}if((y|0)==(B|0)){r=H;return}ggb(y);k[F>>2]=B;k[C>>2]=1032;r=H;return}function k$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;L=r;r=r+1072|0;E=L;F=L+32|0;K=k[a+16>>2]|0;g=k[b+16>>2]|0;D=k[c+16>>2]|0;J=(k[a+48>>2]|0)>>>1;I=(k[b+48>>2]|0)>>>3;C=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>3:0;f=k[c+12>>2]|0;H=k[a+40>>2]|0;G=k[H+4>>2]|0;H=k[H>>2]|0;if(!D){if((H|0)<=0){r=L;return}i=G+-4|0;l=(G|0)<4;m=G&-4;n=(G|0)>0;o=(m|0)<(G|0);h=0;f=g;while(1){g=K+((aa(h,J)|0)<<1)|0;if(l){a=h;do{c=K+((aa(a,J)|0)<<1)|0;if(n){b=0;e=0.0;do{e=e+ +(j[g+(b<<1)>>1]|0)*+(j[c+(b<<1)>>1]|0);b=b+1|0}while((b|0)!=(G|0))}else e=0.0;p[f+(a<<3)>>3]=e*d;a=a+1|0}while((a|0)!=(H|0))}else{a=h;do{c=K+((aa(a,J)|0)<<1)|0;b=0;e=0.0;do{D=b|1;E=b|2;F=b|3;e=e+(+(j[g+(b<<1)>>1]|0)*+(j[c+(b<<1)>>1]|0)+ +(j[g+(D<<1)>>1]|0)*+(j[c+(D<<1)>>1]|0)+ +(j[g+(E<<1)>>1]|0)*+(j[c+(E<<1)>>1]|0)+ +(j[g+(F<<1)>>1]|0)*+(j[c+(F<<1)>>1]|0));b=b+4|0}while((b|0)<=(i|0));if(o){b=m;do{e=e+ +(j[g+(b<<1)>>1]|0)*+(j[c+(b<<1)>>1]|0);b=b+1|0}while((b|0)!=(G|0))}p[f+(a<<3)>>3]=e*d;a=a+1|0}while((a|0)!=(H|0))}h=h+1|0;if((h|0)==(H|0))break;else f=f+(I<<3)|0}r=L;return}z=(f|0)==(G|0)?4:0;c=G<<3;A=F+8|0;k[F>>2]=A;B=F+4|0;k[B>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b}else b=A;k[B>>2]=c;if((H|0)>0){n=(f|0)<(G|0);o=(G|0)>0;s=E+24|0;t=E+16|0;u=E+8|0;v=G+-4|0;w=(G|0)<4;l=v>>>2;x=(l<<2)+4|0;l=aa(z,(l<<3)+8|0)|0;y=E+l|0;m=0;l=D+l|0;while(1){a=K+((aa(m,J)|0)<<1)|0;f=D+((aa(m,C)|0)<<3)|0;if(n)if(o){c=0;do{p[b+(c<<3)>>3]=+(j[a+(c<<1)>>1]|0)-+p[f>>3];c=c+1|0}while((c|0)!=(G|0));c=24}else{i=m;c=25}else if(o){c=0;do{p[b+(c<<3)>>3]=+(j[a+(c<<1)>>1]|0)-+p[f+(c<<3)>>3];c=c+1|0}while((c|0)!=(G|0));c=24}else{h=m;i=l;c=33}if((c|0)==24)if(n){i=m;c=25}else{h=m;i=l;c=33}if((c|0)==25)while(1){h=K+((aa(i,J)|0)<<1)|0;f=D+((aa(i,C)|0)<<3)|0;q=+p[f>>3];p[s>>3]=q;p[t>>3]=q;p[u>>3]=q;p[E>>3]=q;a:do if(w){e=0.0;c=E;a=0}else{e=0.0;f=E;c=0;while(1){N=c|1;M=c|2;a=c|3;e=e+(+p[b+(c<<3)>>3]*(+(j[h+(c<<1)>>1]|0)-q)+ +p[b+(N<<3)>>3]*(+(j[h+(N<<1)>>1]|0)-+p[f+8>>3])+ +p[b+(M<<3)>>3]*(+(j[h+(M<<1)>>1]|0)-+p[f+16>>3])+ +p[b+(a<<3)>>3]*(+(j[h+(a<<1)>>1]|0)-+p[f+24>>3]));c=c+4|0;a=f+(z<<3)|0;if((c|0)>(v|0)){c=y;a=x;break a}f=a;q=+p[a>>3]}}while(0);if((a|0)<(G|0))while(1){e=e+ +p[b+(a<<3)>>3]*(+(j[h+(a<<1)>>1]|0)-+p[c>>3]);a=a+1|0;if((a|0)==(G|0))break;else c=c+8|0}p[g+(i<<3)>>3]=e*d;i=i+1|0;if((i|0)==(H|0))break;else c=25}else if((c|0)==33)while(1){f=K+((aa(h,J)|0)<<1)|0;c=D+((aa(h,C)|0)<<3)|0;if(w){e=0.0;a=0}else{e=0.0;a=0;while(1){O=a|1;M=a|2;N=a|3;e=e+(+p[b+(a<<3)>>3]*(+(j[f+(a<<1)>>1]|0)-+p[c>>3])+ +p[b+(O<<3)>>3]*(+(j[f+(O<<1)>>1]|0)-+p[c+8>>3])+ +p[b+(M<<3)>>3]*(+(j[f+(M<<1)>>1]|0)-+p[c+16>>3])+ +p[b+(N<<3)>>3]*(+(j[f+(N<<1)>>1]|0)-+p[c+24>>3]));a=a+4|0;if((a|0)>(v|0)){c=i;a=x;break}else c=c+(z<<3)|0}}if((a|0)<(G|0))while(1){e=e+ +p[b+(a<<3)>>3]*(+(j[f+(a<<1)>>1]|0)-+p[c>>3]);a=a+1|0;if((a|0)==(G|0))break;else c=c+8|0}p[g+(h<<3)>>3]=e*d;h=h+1|0;if((h|0)==(H|0))break;else{i=i+(C<<3)|0;c=33}}m=m+1|0;if((m|0)==(H|0))break;else{g=g+(I<<3)|0;l=l+(C<<3)|0}}}if((b|0)!=(A|0)){ggb(b);k[F>>2]=A;k[B>>2]=1032}r=L;return}function l$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0,h=0.0,i=0.0,j=0,l=0,m=0,n=0.0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0;G=r;r=r+1040|0;E=G;F=k[a+16>>2]|0;w=k[b+16>>2]|0;j=k[c+16>>2]|0;D=(k[a+48>>2]|0)>>>2;C=(k[b+48>>2]|0)>>>2;l=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>2:0;f=k[c+12>>2]|0;z=k[a+40>>2]|0;y=k[z+4>>2]|0;z=k[z>>2]|0;A=E+8|0;k[E>>2]=A;B=E+4|0;k[B>>2]=1032;c=(j|0)!=0;f=(f|0)<(y|0);a=c&f?z*20|0:z<<2;if(a>>>0>1032){while(1){b=fgb(a)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[E>>2]=b;x=b}else x=A;k[B>>2]=a;a:do if(c){do if(f){a=x+(z<<2)|0;if((z|0)<=0)if(!a){v=14;break a}else{j=a;u=a;l=l|0?4:0;break}else b=0;do{t=j+((aa(b,l)|0)<<2)|0;t=k[t>>2]|0;u=b<<2;k[a+((u|3)<<2)>>2]=t;k[a+((u|2)<<2)>>2]=t;k[a+((u|1)<<2)>>2]=t;k[a+(u<<2)>>2]=t;b=b+1|0}while((b|0)!=(z|0));j=a;u=a;l=l|0?4:0}else u=0;while(0);if((y|0)>0){q=(u|0)!=0;s=(z|0)>0;t=y+-4|0;n=d*0.0;m=w;p=0;while(1){if(q){if(s){b=0;do{c=F+((aa(b,D)|0)+p<<2)|0;f=u+((aa(b,l)|0)<<2)|0;o[x+(b<<2)>>2]=+o[c>>2]-+o[f>>2];b=b+1|0}while((b|0)!=(z|0))}}else if(s){b=0;do{c=F+((aa(b,D)|0)+p<<2)|0;f=j+((aa(b,l)|0)+p<<2)|0;o[x+(b<<2)>>2]=+o[c>>2]-+o[f>>2];b=b+1|0}while((b|0)!=(z|0))}b:do if((p|0)>(t|0))b=p;else{if(s)b=p;else{b=p;while(1){o[m+(b<<2)>>2]=n;o[m+(b+1<<2)>>2]=n;o[m+(b+2<<2)>>2]=n;o[m+(b+3<<2)>>2]=n;b=b+4|0;if((b|0)>(t|0))break b}}do{a=q?u:j+(b<<2)|0;c=F+(b<<2)|0;e=0.0;g=0.0;h=0.0;i=0.0;f=0;while(1){H=+o[x+(f<<2)>>2];i=i+H*(+o[c>>2]-+o[a>>2]);h=h+H*(+o[c+4>>2]-+o[a+4>>2]);g=g+H*(+o[c+8>>2]-+o[a+8>>2]);e=e+H*(+o[c+12>>2]-+o[a+12>>2]);f=f+1|0;if((f|0)==(z|0))break;else{a=a+(l<<2)|0;c=c+(D<<2)|0}}o[m+(b<<2)>>2]=i*d;o[m+(b+1<<2)>>2]=h*d;o[m+(b+2<<2)>>2]=g*d;o[m+(b+3<<2)>>2]=e*d;b=b+4|0}while((b|0)<=(t|0))}while(0);c:do if((b|0)<(y|0)){if(!s)if(q)while(1){o[m+(b<<2)>>2]=n;b=b+1|0;if((b|0)==(y|0))break c}else while(1){o[m+(b<<2)>>2]=n;b=b+1|0;if((b|0)==(y|0))break c}if(q)do{a=F+(b<<2)|0;e=0.0;c=u;f=0;while(1){e=e+ +o[x+(f<<2)>>2]*(+o[a>>2]-+o[c>>2]);f=f+1|0;if((f|0)==(z|0))break;else{a=a+(D<<2)|0;c=c+(l<<2)|0}}o[m+(b<<2)>>2]=e*d;b=b+1|0}while((b|0)!=(y|0));else do{a=F+(b<<2)|0;e=0.0;c=j+(b<<2)|0;f=0;while(1){e=e+ +o[x+(f<<2)>>2]*(+o[a>>2]-+o[c>>2]);f=f+1|0;if((f|0)==(z|0))break;else{a=a+(D<<2)|0;c=c+(l<<2)|0}}o[m+(b<<2)>>2]=e*d;b=b+1|0}while((b|0)!=(y|0))}while(0);p=p+1|0;if((p|0)==(y|0))break;else m=m+(C<<2)|0}}}else v=14;while(0);if((v|0)==14?(y|0)>0:0){l=(z|0)>0;m=y+-4|0;n=d*0.0;f=w;j=0;while(1){if(l){b=0;do{w=F+((aa(b,D)|0)+j<<2)|0;k[x+(b<<2)>>2]=k[w>>2];b=b+1|0}while((b|0)!=(z|0))}d:do if((j|0)>(m|0))b=j;else{if(l)b=j;else{b=j;while(1){o[f+(b<<2)>>2]=n;o[f+(b+1<<2)>>2]=n;o[f+(b+2<<2)>>2]=n;o[f+(b+3<<2)>>2]=n;b=b+4|0;if((b|0)>(m|0))break d}}do{a=F+(b<<2)|0;e=0.0;g=0.0;h=0.0;i=0.0;c=0;while(1){H=+o[x+(c<<2)>>2];i=i+H*+o[a>>2];h=h+H*+o[a+4>>2];g=g+H*+o[a+8>>2];e=e+H*+o[a+12>>2];c=c+1|0;if((c|0)==(z|0))break;else a=a+(D<<2)|0}o[f+(b<<2)>>2]=i*d;o[f+(b+1<<2)>>2]=h*d;o[f+(b+2<<2)>>2]=g*d;o[f+(b+3<<2)>>2]=e*d;b=b+4|0}while((b|0)<=(m|0))}while(0);e:do if((b|0)<(y|0)){if(!l)while(1){o[f+(b<<2)>>2]=n;b=b+1|0;if((b|0)==(y|0))break e}do{a=F+(b<<2)|0;e=0.0;c=0;while(1){e=e+ +o[x+(c<<2)>>2]*+o[a>>2];c=c+1|0;if((c|0)==(z|0))break;else a=a+(D<<2)|0}o[f+(b<<2)>>2]=e*d;b=b+1|0}while((b|0)!=(y|0))}while(0);j=j+1|0;if((j|0)==(y|0))break;else f=f+(C<<2)|0}}if((x|0)==(A|0)){r=G;return}ggb(x);k[E>>2]=A;k[B>>2]=1032;r=G;return}function m$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0.0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;M=r;r=r+1056|0;F=M+1040|0;G=M;L=k[a+16>>2]|0;g=k[b+16>>2]|0;E=k[c+16>>2]|0;K=(k[a+48>>2]|0)>>>2;J=(k[b+48>>2]|0)>>>2;D=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>2:0;f=k[c+12>>2]|0;I=k[a+40>>2]|0;H=k[I+4>>2]|0;I=k[I>>2]|0;if(!E){if((I|0)<=0){r=M;return}i=H+-4|0;j=(H|0)<4;l=H&-4;m=(H|0)>0;n=(l|0)<(H|0);h=0;f=g;while(1){g=L+((aa(h,K)|0)<<2)|0;if(j){a=h;do{c=L+((aa(a,K)|0)<<2)|0;if(m){b=0;e=0.0;do{e=e+ +o[g+(b<<2)>>2]*+o[c+(b<<2)>>2];b=b+1|0}while((b|0)!=(H|0))}else e=0.0;o[f+(a<<2)>>2]=e*d;a=a+1|0}while((a|0)!=(I|0))}else{a=h;do{c=L+((aa(a,K)|0)<<2)|0;b=0;e=0.0;do{E=b|1;F=b|2;G=b|3;e=e+(+o[g+(b<<2)>>2]*+o[c+(b<<2)>>2]+ +o[g+(E<<2)>>2]*+o[c+(E<<2)>>2]+ +o[g+(F<<2)>>2]*+o[c+(F<<2)>>2]+ +o[g+(G<<2)>>2]*+o[c+(G<<2)>>2]);b=b+4|0}while((b|0)<=(i|0));if(n){b=l;do{e=e+ +o[g+(b<<2)>>2]*+o[c+(b<<2)>>2];b=b+1|0}while((b|0)!=(H|0))}o[f+(a<<2)>>2]=e*d;a=a+1|0}while((a|0)!=(I|0))}h=h+1|0;if((h|0)==(I|0))break;else f=f+(J<<2)|0}r=M;return}A=(f|0)==(H|0)?4:0;c=H<<2;B=G+8|0;k[G>>2]=B;C=G+4|0;k[C>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[G>>2]=b}else b=B;k[C>>2]=c;if((I|0)>0){n=(f|0)<(H|0);q=(H|0)>0;s=F+12|0;t=F+8|0;v=F+4|0;w=H+-4|0;x=(H|0)<4;y=H&-4;l=aa(A,y)|0;z=F+l|0;m=0;j=g;l=E+l|0;while(1){a=L+((aa(m,K)|0)<<2)|0;f=E+((aa(m,D)|0)<<2)|0;if(n)if(q){c=0;do{o[b+(c<<2)>>2]=+o[a+(c<<2)>>2]-+o[f>>2];c=c+1|0}while((c|0)!=(H|0));c=24}else{i=m;c=25}else if(q){c=0;do{o[b+(c<<2)>>2]=+o[a+(c<<2)>>2]-+o[f+(c<<2)>>2];c=c+1|0}while((c|0)!=(H|0));c=24}else{g=m;h=l;c=34}if((c|0)==24)if(n){i=m;c=25}else{g=m;h=l;c=34}if((c|0)==25)while(1){h=L+((aa(i,K)|0)<<2)|0;c=E+((aa(i,D)|0)<<2)|0;c=k[c>>2]|0;k[s>>2]=c;k[t>>2]=c;k[v>>2]=c;k[F>>2]=c;a:do if(x){e=0.0;c=F;a=0}else{e=0.0;g=F;f=0;p=(k[u>>2]=c,+o[u>>2]);while(1){N=f|1;a=f|2;c=f|3;e=e+(+o[b+(f<<2)>>2]*(+o[h+(f<<2)>>2]-p)+ +o[b+(N<<2)>>2]*(+o[h+(N<<2)>>2]-+o[g+4>>2])+ +o[b+(a<<2)>>2]*(+o[h+(a<<2)>>2]-+o[g+8>>2])+ +o[b+(c<<2)>>2]*(+o[h+(c<<2)>>2]-+o[g+12>>2]));c=f+4|0;a=g+(A<<2)|0;if((c|0)>(w|0)){c=z;a=y;break a}g=a;f=c;p=+o[a>>2]}}while(0);if((a|0)<(H|0))while(1){e=e+ +o[b+(a<<2)>>2]*(+o[h+(a<<2)>>2]-+o[c>>2]);a=a+1|0;if((a|0)==(H|0))break;else c=c+4|0}o[j+(i<<2)>>2]=e*d;i=i+1|0;if((i|0)==(I|0))break;else c=25}else if((c|0)==34)while(1){f=L+((aa(g,K)|0)<<2)|0;c=E+((aa(g,D)|0)<<2)|0;if(x){e=0.0;a=0}else{e=0.0;a=0;while(1){O=a|1;i=a|2;N=a|3;e=e+(+o[b+(a<<2)>>2]*(+o[f+(a<<2)>>2]-+o[c>>2])+ +o[b+(O<<2)>>2]*(+o[f+(O<<2)>>2]-+o[c+4>>2])+ +o[b+(i<<2)>>2]*(+o[f+(i<<2)>>2]-+o[c+8>>2])+ +o[b+(N<<2)>>2]*(+o[f+(N<<2)>>2]-+o[c+12>>2]));a=a+4|0;if((a|0)>(w|0)){c=h;a=y;break}else c=c+(A<<2)|0}}if((a|0)<(H|0))while(1){e=e+ +o[b+(a<<2)>>2]*(+o[f+(a<<2)>>2]-+o[c>>2]);a=a+1|0;if((a|0)==(H|0))break;else c=c+4|0}o[j+(g<<2)>>2]=e*d;g=g+1|0;if((g|0)==(I|0))break;else{h=h+(D<<2)|0;c=34}}m=m+1|0;if((m|0)==(I|0))break;else{j=j+(J<<2)|0;l=l+(D<<2)|0}}}if((b|0)!=(B|0)){ggb(b);k[G>>2]=B;k[C>>2]=1032}r=M;return}function n$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0,h=0.0,i=0.0,j=0,l=0,m=0,n=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;H=r;r=r+1040|0;F=H;G=k[a+16>>2]|0;x=k[b+16>>2]|0;j=k[c+16>>2]|0;E=(k[a+48>>2]|0)>>>2;D=(k[b+48>>2]|0)>>>3;l=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>3:0;f=k[c+12>>2]|0;A=k[a+40>>2]|0;z=k[A+4>>2]|0;A=k[A>>2]|0;B=F+8|0;k[F>>2]=B;C=F+4|0;k[C>>2]=1032;c=(j|0)!=0;f=(f|0)<(z|0);a=c&f?A*40|0:A<<3;if(a>>>0>1032){while(1){b=fgb(a)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b;y=b}else y=B;k[C>>2]=a;a:do if(c){do if(f){a=y+(A<<3)|0;if((A|0)<=0)if(!a){w=14;break a}else{j=a;v=a;l=l|0?4:0;break}else b=0;do{v=j+((aa(b,l)|0)<<3)|0;n=+p[v>>3];v=b<<2;p[a+((v|3)<<3)>>3]=n;p[a+((v|2)<<3)>>3]=n;p[a+((v|1)<<3)>>3]=n;p[a+(v<<3)>>3]=n;b=b+1|0}while((b|0)!=(A|0));j=a;v=a;l=l|0?4:0}else v=0;while(0);if((z|0)>0){s=(v|0)!=0;t=(A|0)>0;u=z+-4|0;n=d*0.0;m=x;q=0;while(1){if(s){if(t){b=0;do{c=G+((aa(b,E)|0)+q<<2)|0;f=v+((aa(b,l)|0)<<3)|0;p[y+(b<<3)>>3]=+o[c>>2]-+p[f>>3];b=b+1|0}while((b|0)!=(A|0))}}else if(t){b=0;do{c=G+((aa(b,E)|0)+q<<2)|0;f=j+((aa(b,l)|0)+q<<3)|0;p[y+(b<<3)>>3]=+o[c>>2]-+p[f>>3];b=b+1|0}while((b|0)!=(A|0))}b:do if((q|0)>(u|0))b=q;else{if(t)b=q;else{b=q;while(1){p[m+(b<<3)>>3]=n;p[m+(b+1<<3)>>3]=n;p[m+(b+2<<3)>>3]=n;p[m+(b+3<<3)>>3]=n;b=b+4|0;if((b|0)>(u|0))break b}}do{a=s?v:j+(b<<3)|0;c=G+(b<<2)|0;e=0.0;g=0.0;h=0.0;i=0.0;f=0;while(1){I=+p[y+(f<<3)>>3];i=i+I*(+o[c>>2]-+p[a>>3]);h=h+I*(+o[c+4>>2]-+p[a+8>>3]);g=g+I*(+o[c+8>>2]-+p[a+16>>3]);e=e+I*(+o[c+12>>2]-+p[a+24>>3]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(l<<3)|0;c=c+(E<<2)|0}}p[m+(b<<3)>>3]=i*d;p[m+(b+1<<3)>>3]=h*d;p[m+(b+2<<3)>>3]=g*d;p[m+(b+3<<3)>>3]=e*d;b=b+4|0}while((b|0)<=(u|0))}while(0);c:do if((b|0)<(z|0)){if(!t)if(s)while(1){p[m+(b<<3)>>3]=n;b=b+1|0;if((b|0)==(z|0))break c}else while(1){p[m+(b<<3)>>3]=n;b=b+1|0;if((b|0)==(z|0))break c}if(s)do{a=G+(b<<2)|0;e=0.0;c=v;f=0;while(1){e=e+ +p[y+(f<<3)>>3]*(+o[a>>2]-+p[c>>3]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(E<<2)|0;c=c+(l<<3)|0}}p[m+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(z|0));else do{a=G+(b<<2)|0;e=0.0;c=j+(b<<3)|0;f=0;while(1){e=e+ +p[y+(f<<3)>>3]*(+o[a>>2]-+p[c>>3]);f=f+1|0;if((f|0)==(A|0))break;else{a=a+(E<<2)|0;c=c+(l<<3)|0}}p[m+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);q=q+1|0;if((q|0)==(z|0))break;else m=m+(D<<3)|0}}}else w=14;while(0);if((w|0)==14?(z|0)>0:0){l=(A|0)>0;m=z+-4|0;n=d*0.0;f=x;j=0;while(1){if(l){b=0;do{x=G+((aa(b,E)|0)+j<<2)|0;p[y+(b<<3)>>3]=+o[x>>2];b=b+1|0}while((b|0)!=(A|0))}d:do if((j|0)>(m|0))b=j;else{if(l)b=j;else{b=j;while(1){p[f+(b<<3)>>3]=n;p[f+(b+1<<3)>>3]=n;p[f+(b+2<<3)>>3]=n;p[f+(b+3<<3)>>3]=n;b=b+4|0;if((b|0)>(m|0))break d}}do{a=G+(b<<2)|0;e=0.0;g=0.0;h=0.0;i=0.0;c=0;while(1){I=+p[y+(c<<3)>>3];i=i+I*+o[a>>2];h=h+I*+o[a+4>>2];g=g+I*+o[a+8>>2];e=e+I*+o[a+12>>2];c=c+1|0;if((c|0)==(A|0))break;else a=a+(E<<2)|0}p[f+(b<<3)>>3]=i*d;p[f+(b+1<<3)>>3]=h*d;p[f+(b+2<<3)>>3]=g*d;p[f+(b+3<<3)>>3]=e*d;b=b+4|0}while((b|0)<=(m|0))}while(0);e:do if((b|0)<(z|0)){if(!l)while(1){p[f+(b<<3)>>3]=n;b=b+1|0;if((b|0)==(z|0))break e}do{a=G+(b<<2)|0;e=0.0;c=0;while(1){e=e+ +p[y+(c<<3)>>3]*+o[a>>2];c=c+1|0;if((c|0)==(A|0))break;else a=a+(E<<2)|0}p[f+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(z|0))}while(0);j=j+1|0;if((j|0)==(z|0))break;else f=f+(D<<3)|0}}if((y|0)==(B|0)){r=H;return}ggb(y);k[F>>2]=B;k[C>>2]=1032;r=H;return}function o$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;L=r;r=r+1072|0;E=L;F=L+32|0;K=k[a+16>>2]|0;g=k[b+16>>2]|0;D=k[c+16>>2]|0;J=(k[a+48>>2]|0)>>>2;I=(k[b+48>>2]|0)>>>3;C=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>3:0;f=k[c+12>>2]|0;H=k[a+40>>2]|0;G=k[H+4>>2]|0;H=k[H>>2]|0;if(!D){if((H|0)<=0){r=L;return}i=G+-4|0;j=(G|0)<4;l=G&-4;m=(G|0)>0;n=(l|0)<(G|0);h=0;f=g;while(1){g=K+((aa(h,J)|0)<<2)|0;if(j){a=h;do{c=K+((aa(a,J)|0)<<2)|0;if(m){b=0;e=0.0;do{e=e+ +o[g+(b<<2)>>2]*+o[c+(b<<2)>>2];b=b+1|0}while((b|0)!=(G|0))}else e=0.0;p[f+(a<<3)>>3]=e*d;a=a+1|0}while((a|0)!=(H|0))}else{a=h;do{c=K+((aa(a,J)|0)<<2)|0;b=0;e=0.0;do{D=b|1;E=b|2;F=b|3;e=e+(+o[g+(b<<2)>>2]*+o[c+(b<<2)>>2]+ +o[g+(D<<2)>>2]*+o[c+(D<<2)>>2]+ +o[g+(E<<2)>>2]*+o[c+(E<<2)>>2]+ +o[g+(F<<2)>>2]*+o[c+(F<<2)>>2]);b=b+4|0}while((b|0)<=(i|0));if(n){b=l;do{e=e+ +o[g+(b<<2)>>2]*+o[c+(b<<2)>>2];b=b+1|0}while((b|0)!=(G|0))}p[f+(a<<3)>>3]=e*d;a=a+1|0}while((a|0)!=(H|0))}h=h+1|0;if((h|0)==(H|0))break;else f=f+(I<<3)|0}r=L;return}z=(f|0)==(G|0)?4:0;c=G<<3;A=F+8|0;k[F>>2]=A;B=F+4|0;k[B>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[F>>2]=b}else b=A;k[B>>2]=c;if((H|0)>0){m=(f|0)<(G|0);n=(G|0)>0;s=E+24|0;t=E+16|0;u=E+8|0;v=G+-4|0;w=(G|0)<4;j=v>>>2;x=(j<<2)+4|0;j=aa(z,(j<<3)+8|0)|0;y=E+j|0;l=0;j=D+j|0;while(1){a=K+((aa(l,J)|0)<<2)|0;f=D+((aa(l,C)|0)<<3)|0;if(m)if(n){c=0;do{p[b+(c<<3)>>3]=+o[a+(c<<2)>>2]-+p[f>>3];c=c+1|0}while((c|0)!=(G|0));c=24}else{i=l;c=25}else if(n){c=0;do{p[b+(c<<3)>>3]=+o[a+(c<<2)>>2]-+p[f+(c<<3)>>3];c=c+1|0}while((c|0)!=(G|0));c=24}else{h=l;i=j;c=33}if((c|0)==24)if(m){i=l;c=25}else{h=l;i=j;c=33}if((c|0)==25)while(1){h=K+((aa(i,J)|0)<<2)|0;f=D+((aa(i,C)|0)<<3)|0;q=+p[f>>3];p[s>>3]=q;p[t>>3]=q;p[u>>3]=q;p[E>>3]=q;a:do if(w){e=0.0;c=E;a=0}else{e=0.0;f=E;c=0;while(1){N=c|1;M=c|2;a=c|3;e=e+(+p[b+(c<<3)>>3]*(+o[h+(c<<2)>>2]-q)+ +p[b+(N<<3)>>3]*(+o[h+(N<<2)>>2]-+p[f+8>>3])+ +p[b+(M<<3)>>3]*(+o[h+(M<<2)>>2]-+p[f+16>>3])+ +p[b+(a<<3)>>3]*(+o[h+(a<<2)>>2]-+p[f+24>>3]));c=c+4|0;a=f+(z<<3)|0;if((c|0)>(v|0)){c=y;a=x;break a}f=a;q=+p[a>>3]}}while(0);if((a|0)<(G|0))while(1){e=e+ +p[b+(a<<3)>>3]*(+o[h+(a<<2)>>2]-+p[c>>3]);a=a+1|0;if((a|0)==(G|0))break;else c=c+8|0}p[g+(i<<3)>>3]=e*d;i=i+1|0;if((i|0)==(H|0))break;else c=25}else if((c|0)==33)while(1){f=K+((aa(h,J)|0)<<2)|0;c=D+((aa(h,C)|0)<<3)|0;if(w){e=0.0;a=0}else{e=0.0;a=0;while(1){O=a|1;M=a|2;N=a|3;e=e+(+p[b+(a<<3)>>3]*(+o[f+(a<<2)>>2]-+p[c>>3])+ +p[b+(O<<3)>>3]*(+o[f+(O<<2)>>2]-+p[c+8>>3])+ +p[b+(M<<3)>>3]*(+o[f+(M<<2)>>2]-+p[c+16>>3])+ +p[b+(N<<3)>>3]*(+o[f+(N<<2)>>2]-+p[c+24>>3]));a=a+4|0;if((a|0)>(v|0)){c=i;a=x;break}else c=c+(z<<3)|0}}if((a|0)<(G|0))while(1){e=e+ +p[b+(a<<3)>>3]*(+o[f+(a<<2)>>2]-+p[c>>3]);a=a+1|0;if((a|0)==(G|0))break;else c=c+8|0}p[g+(h<<3)>>3]=e*d;h=h+1|0;if((h|0)==(H|0))break;else{i=i+(C<<3)|0;c=33}}l=l+1|0;if((l|0)==(H|0))break;else{g=g+(I<<3)|0;j=j+(C<<3)|0}}}if((b|0)!=(A|0)){ggb(b);k[F>>2]=A;k[B>>2]=1032}r=L;return}function p$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0,h=0.0,i=0.0,j=0,l=0,m=0,n=0.0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0;G=r;r=r+1040|0;E=G;F=k[a+16>>2]|0;w=k[b+16>>2]|0;j=k[c+16>>2]|0;D=(k[a+48>>2]|0)>>>3;C=(k[b+48>>2]|0)>>>3;l=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>3:0;f=k[c+12>>2]|0;z=k[a+40>>2]|0;y=k[z+4>>2]|0;z=k[z>>2]|0;A=E+8|0;k[E>>2]=A;B=E+4|0;k[B>>2]=1032;c=(j|0)!=0;f=(f|0)<(y|0);a=c&f?z*40|0:z<<3;if(a>>>0>1032){while(1){b=fgb(a)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[E>>2]=b;x=b}else x=A;k[B>>2]=a;a:do if(c){do if(f){a=x+(z<<3)|0;if((z|0)<=0)if(!a){v=14;break a}else{j=a;u=a;l=l|0?4:0;break}else b=0;do{u=j+((aa(b,l)|0)<<3)|0;n=+p[u>>3];u=b<<2;p[a+((u|3)<<3)>>3]=n;p[a+((u|2)<<3)>>3]=n;p[a+((u|1)<<3)>>3]=n;p[a+(u<<3)>>3]=n;b=b+1|0}while((b|0)!=(z|0));j=a;u=a;l=l|0?4:0}else u=0;while(0);if((y|0)>0){q=(u|0)!=0;s=(z|0)>0;t=y+-4|0;n=d*0.0;m=w;o=0;while(1){if(q){if(s){b=0;do{c=F+((aa(b,D)|0)+o<<3)|0;f=u+((aa(b,l)|0)<<3)|0;p[x+(b<<3)>>3]=+p[c>>3]-+p[f>>3];b=b+1|0}while((b|0)!=(z|0))}}else if(s){b=0;do{c=F+((aa(b,D)|0)+o<<3)|0;f=j+((aa(b,l)|0)+o<<3)|0;p[x+(b<<3)>>3]=+p[c>>3]-+p[f>>3];b=b+1|0}while((b|0)!=(z|0))}b:do if((o|0)>(t|0))b=o;else{if(s)b=o;else{b=o;while(1){p[m+(b<<3)>>3]=n;p[m+(b+1<<3)>>3]=n;p[m+(b+2<<3)>>3]=n;p[m+(b+3<<3)>>3]=n;b=b+4|0;if((b|0)>(t|0))break b}}do{a=q?u:j+(b<<3)|0;c=F+(b<<3)|0;e=0.0;g=0.0;h=0.0;i=0.0;f=0;while(1){H=+p[x+(f<<3)>>3];i=i+H*(+p[c>>3]-+p[a>>3]);h=h+H*(+p[c+8>>3]-+p[a+8>>3]);g=g+H*(+p[c+16>>3]-+p[a+16>>3]);e=e+H*(+p[c+24>>3]-+p[a+24>>3]);f=f+1|0;if((f|0)==(z|0))break;else{a=a+(l<<3)|0;c=c+(D<<3)|0}}p[m+(b<<3)>>3]=i*d;p[m+(b+1<<3)>>3]=h*d;p[m+(b+2<<3)>>3]=g*d;p[m+(b+3<<3)>>3]=e*d;b=b+4|0}while((b|0)<=(t|0))}while(0);c:do if((b|0)<(y|0)){if(!s)if(q)while(1){p[m+(b<<3)>>3]=n;b=b+1|0;if((b|0)==(y|0))break c}else while(1){p[m+(b<<3)>>3]=n;b=b+1|0;if((b|0)==(y|0))break c}if(q)do{a=F+(b<<3)|0;e=0.0;c=u;f=0;while(1){e=e+ +p[x+(f<<3)>>3]*(+p[a>>3]-+p[c>>3]);f=f+1|0;if((f|0)==(z|0))break;else{a=a+(D<<3)|0;c=c+(l<<3)|0}}p[m+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(y|0));else do{a=F+(b<<3)|0;e=0.0;c=j+(b<<3)|0;f=0;while(1){e=e+ +p[x+(f<<3)>>3]*(+p[a>>3]-+p[c>>3]);f=f+1|0;if((f|0)==(z|0))break;else{a=a+(D<<3)|0;c=c+(l<<3)|0}}p[m+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(y|0))}while(0);o=o+1|0;if((o|0)==(y|0))break;else m=m+(C<<3)|0}}}else v=14;while(0);if((v|0)==14?(y|0)>0:0){l=(z|0)>0;m=y+-4|0;n=d*0.0;f=w;j=0;while(1){if(l){b=0;do{w=F+((aa(b,D)|0)+j<<3)|0;p[x+(b<<3)>>3]=+p[w>>3];b=b+1|0}while((b|0)!=(z|0))}d:do if((j|0)>(m|0))b=j;else{if(l)b=j;else{b=j;while(1){p[f+(b<<3)>>3]=n;p[f+(b+1<<3)>>3]=n;p[f+(b+2<<3)>>3]=n;p[f+(b+3<<3)>>3]=n;b=b+4|0;if((b|0)>(m|0))break d}}do{a=F+(b<<3)|0;e=0.0;g=0.0;h=0.0;i=0.0;c=0;while(1){H=+p[x+(c<<3)>>3];i=i+H*+p[a>>3];h=h+H*+p[a+8>>3];g=g+H*+p[a+16>>3];e=e+H*+p[a+24>>3];c=c+1|0;if((c|0)==(z|0))break;else a=a+(D<<3)|0}p[f+(b<<3)>>3]=i*d;p[f+(b+1<<3)>>3]=h*d;p[f+(b+2<<3)>>3]=g*d;p[f+(b+3<<3)>>3]=e*d;b=b+4|0}while((b|0)<=(m|0))}while(0);e:do if((b|0)<(y|0)){if(!l)while(1){p[f+(b<<3)>>3]=n;b=b+1|0;if((b|0)==(y|0))break e}do{a=F+(b<<3)|0;e=0.0;c=0;while(1){e=e+ +p[x+(c<<3)>>3]*+p[a>>3];c=c+1|0;if((c|0)==(z|0))break;else a=a+(D<<3)|0}p[f+(b<<3)>>3]=e*d;b=b+1|0}while((b|0)!=(y|0))}while(0);j=j+1|0;if((j|0)==(y|0))break;else f=f+(C<<3)|0}}if((x|0)==(A|0)){r=G;return}ggb(x);k[E>>2]=A;k[B>>2]=1032;r=G;return}function q$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;K=r;r=r+1072|0;D=K;E=K+32|0;J=k[a+16>>2]|0;g=k[b+16>>2]|0;C=k[c+16>>2]|0;I=(k[a+48>>2]|0)>>>3;H=(k[b+48>>2]|0)>>>3;B=(k[c+8>>2]|0)>1?(k[c+48>>2]|0)>>>3:0;f=k[c+12>>2]|0;G=k[a+40>>2]|0;F=k[G+4>>2]|0;G=k[G>>2]|0;if(!C){if((G|0)<=0){r=K;return}i=F+-4|0;j=(F|0)<4;l=F&-4;m=(F|0)>0;n=(l|0)<(F|0);h=0;f=g;while(1){g=J+((aa(h,I)|0)<<3)|0;if(j){a=h;do{c=J+((aa(a,I)|0)<<3)|0;if(m){b=0;e=0.0;do{e=e+ +p[g+(b<<3)>>3]*+p[c+(b<<3)>>3];b=b+1|0}while((b|0)!=(F|0))}else e=0.0;p[f+(a<<3)>>3]=e*d;a=a+1|0}while((a|0)!=(G|0))}else{a=h;do{c=J+((aa(a,I)|0)<<3)|0;b=0;e=0.0;do{C=b|1;D=b|2;E=b|3;e=e+(+p[g+(b<<3)>>3]*+p[c+(b<<3)>>3]+ +p[g+(C<<3)>>3]*+p[c+(C<<3)>>3]+ +p[g+(D<<3)>>3]*+p[c+(D<<3)>>3]+ +p[g+(E<<3)>>3]*+p[c+(E<<3)>>3]);b=b+4|0}while((b|0)<=(i|0));if(n){b=l;do{e=e+ +p[g+(b<<3)>>3]*+p[c+(b<<3)>>3];b=b+1|0}while((b|0)!=(F|0))}p[f+(a<<3)>>3]=e*d;a=a+1|0}while((a|0)!=(G|0))}h=h+1|0;if((h|0)==(G|0))break;else f=f+(H<<3)|0}r=K;return}z=(f|0)==(F|0)?4:0;c=F<<3;A=E+8|0;k[E>>2]=A;y=E+4|0;k[y>>2]=1032;if(c>>>0>1032){while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[E>>2]=b}else b=A;k[y>>2]=c;if((G|0)>0){m=(f|0)<(F|0);n=(F|0)>0;q=D+24|0;s=D+16|0;t=D+8|0;u=F+-4|0;v=(F|0)<4;j=u>>>2;w=(j<<2)+4|0;j=aa(z,(j<<3)+8|0)|0;x=D+j|0;l=0;j=C+j|0;while(1){a=J+((aa(l,I)|0)<<3)|0;f=C+((aa(l,B)|0)<<3)|0;if(m)if(n){c=0;do{p[b+(c<<3)>>3]=+p[a+(c<<3)>>3]-+p[f>>3];c=c+1|0}while((c|0)!=(F|0));c=24}else{i=l;c=25}else if(n){c=0;do{p[b+(c<<3)>>3]=+p[a+(c<<3)>>3]-+p[f+(c<<3)>>3];c=c+1|0}while((c|0)!=(F|0));c=24}else{h=l;i=j;c=33}if((c|0)==24)if(m){i=l;c=25}else{h=l;i=j;c=33}if((c|0)==25)while(1){h=J+((aa(i,I)|0)<<3)|0;f=C+((aa(i,B)|0)<<3)|0;o=+p[f>>3];p[q>>3]=o;p[s>>3]=o;p[t>>3]=o;p[D>>3]=o;a:do if(v){e=0.0;c=D;a=0}else{e=0.0;f=D;c=0;while(1){M=c|1;L=c|2;a=c|3;e=e+(+p[b+(c<<3)>>3]*(+p[h+(c<<3)>>3]-o)+ +p[b+(M<<3)>>3]*(+p[h+(M<<3)>>3]-+p[f+8>>3])+ +p[b+(L<<3)>>3]*(+p[h+(L<<3)>>3]-+p[f+16>>3])+ +p[b+(a<<3)>>3]*(+p[h+(a<<3)>>3]-+p[f+24>>3]));c=c+4|0;a=f+(z<<3)|0;if((c|0)>(u|0)){c=x;a=w;break a}f=a;o=+p[a>>3]}}while(0);if((a|0)<(F|0))while(1){e=e+ +p[b+(a<<3)>>3]*(+p[h+(a<<3)>>3]-+p[c>>3]);a=a+1|0;if((a|0)==(F|0))break;else c=c+8|0}p[g+(i<<3)>>3]=e*d;i=i+1|0;if((i|0)==(G|0))break;else c=25}else if((c|0)==33)while(1){f=J+((aa(h,I)|0)<<3)|0;c=C+((aa(h,B)|0)<<3)|0;if(v){e=0.0;a=0}else{e=0.0;a=0;while(1){N=a|1;L=a|2;M=a|3;e=e+(+p[b+(a<<3)>>3]*(+p[f+(a<<3)>>3]-+p[c>>3])+ +p[b+(N<<3)>>3]*(+p[f+(N<<3)>>3]-+p[c+8>>3])+ +p[b+(L<<3)>>3]*(+p[f+(L<<3)>>3]-+p[c+16>>3])+ +p[b+(M<<3)>>3]*(+p[f+(M<<3)>>3]-+p[c+24>>3]));a=a+4|0;if((a|0)>(u|0)){c=i;a=w;break}else c=c+(z<<3)|0}}if((a|0)<(F|0))while(1){e=e+ +p[b+(a<<3)>>3]*(+p[f+(a<<3)>>3]-+p[c>>3]);a=a+1|0;if((a|0)==(F|0))break;else c=c+8|0}p[g+(h<<3)>>3]=e*d;h=h+1|0;if((h|0)==(G|0))break;else{i=i+(B<<3)|0;c=33}}l=l+1|0;if((l|0)==(G|0))break;else{g=g+(H<<3)|0;j=j+(B<<3)|0}}}if((b|0)!=(A|0)){ggb(b);k[E>>2]=A;k[y>>2]=1032}r=K;return}function r$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0.0;v=r;r=r+112|0;u=v+56|0;q=v+40|0;s=v+32|0;t=v;do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[u>>2]=k[f>>2];l=u+4|0;b=f+4|0;k[l>>2]=k[b>>2];j=u+8|0;k[j>>2]=k[f+8>>2];k[u+12>>2]=k[f+12>>2];k[u+16>>2]=k[f+16>>2];k[u+20>>2]=k[f+20>>2];k[u+24>>2]=k[f+24>>2];k[u+28>>2]=k[f+28>>2];k[u+32>>2]=k[f+32>>2];c=k[f+36>>2]|0;k[u+36>>2]=c;d=u+40|0;k[d>>2]=j;j=u+48|0;h=u+44|0;k[h>>2]=j;k[u+52>>2]=0;k[j>>2]=0;if(c|0){j=c+12|0;k[j>>2]=(k[j>>2]|0)+1}if((k[b>>2]|0)<3){l=k[f+44>>2]|0;h=k[h>>2]|0;k[h>>2]=k[l>>2];k[h+4>>2]=k[l+4>>2];h=u;break}k[l>>2]=0;x1(u,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[f+40>>2]|0;g=k[d>>2]|0;d=k[f+44>>2]|0;c=k[h>>2]|0;b=0;do{k[g+(b<<2)>>2]=k[j+(b<<2)>>2];k[c+(b<<2)>>2]=k[d+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0));h=u}else h=u}else{Q1(u,b,-1);h=u}while(0);b=k[a>>2]|0;j=(b>>>3&511)+1|0;d=b&7;l=k[47876+(d<<2)>>2]|0;a:do if(((k[h>>2]^b)&4095|0)==0?(m=k[u+40>>2]|0,n=k[m+-4>>2]|0,o=k[a+40>>2]|0,(n|0)==(k[o+-4>>2]|0)):0){if((n|0)!=2)if((n|0)>0){c=0;while(1){if((k[m+(c<<2)>>2]|0)!=(k[o+(c<<2)>>2]|0)){p=19;break a}c=c+1|0;if((c|0)>=(n|0)){c=1;break}}}else c=1;else{if((k[m>>2]|0)!=(k[o>>2]|0)){p=19;break}c=(k[m+4>>2]|0)==(k[o+4>>2]|0)}if(!((d|0)!=7&c))p=19}else p=19;while(0);if((p|0)==19){k[q>>2]=0;b=q+4|0;k[b>>2]=0;c=ZT(60)|0;k[c>>2]=1;d=c+4|0;k[q>>2]=d;k[b>>2]=53;i[c+57>>0]=0;f=216337;g=d+53|0;do{i[d>>0]=i[f>>0]|0;d=d+1|0;f=f+1|0}while((d|0)<(g|0));Y8(-215,q,216391,215417,3244);k[b>>2]=0;k[q>>2]=0;p=k[c>>2]|0;k[c>>2]=p+-1;if((p|0)==1)ggb(k[c+-4>>2]|0);b=k[a>>2]|0}if((b&16384|0)!=0?(k[h>>2]&16384|0)!=0:0){d=k[a+4>>2]|0;if((d|0)<3)b=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{f=k[a+40>>2]|0;c=0;b=1;do{b=aa(k[f+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(d|0))}t=aa(b,j)|0;e=+Ug[l&31](k[a+16>>2]|0,k[u+16>>2]|0,t)}else{k[q>>2]=a;k[q+4>>2]=u;k[q+8>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;k[t+16>>2]=0;k[t+20>>2]=0;k[t+24>>2]=0;k[t+28>>2]=0;z1(t,q,0,s,-1);c=aa(k[t+20>>2]|0,j)|0;d=t+16|0;f=s+4|0;b=0;e=0.0;while(1){if(b>>>0>=(k[d>>2]|0)>>>0)break;w=e+ +Ug[l&31](k[s>>2]|0,k[f>>2]|0,c);A1(t);b=b+1|0;e=w}}d=u+36|0;b=k[d>>2]|0;if(b|0?(t=b+12|0,a=k[t>>2]|0,k[t>>2]=a+-1,(a|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[u+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;a=u+16|0;c=u+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[c>>2]|0)>0){d=k[u+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[u+44>>2]|0;if((b|0)==(u+48|0)|(b|0)==0){r=v;return +e}ggb(k[b+-4>>2]|0);r=v;return +e}function s$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0,i=0;f=c+-4|0;if((c|0)<4){d=0.0;e=0}else{e=0;d=0.0;do{i=e|1;h=e|2;g=e|3;d=d+(+(l[a+e>>0]|0)*+(l[b+e>>0]|0)+ +(l[a+i>>0]|0)*+(l[b+i>>0]|0)+ +(l[a+h>>0]|0)*+(l[b+h>>0]|0)+ +(l[a+g>>0]|0)*+(l[b+g>>0]|0));e=e+4|0}while((e|0)<=(f|0));e=c&-4}if((e|0)>=(c|0)){d=d+0.0;return +d}do{d=d+ +(l[a+e>>0]|0)*+(l[b+e>>0]|0);e=e+1|0}while((e|0)!=(c|0));d=d+0.0;return +d}function t$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0,j=0;f=c+-4|0;if((c|0)<4){d=0.0;e=0}else{e=0;d=0.0;do{j=e|1;h=e|2;g=e|3;d=d+(+(i[a+e>>0]|0)*+(i[b+e>>0]|0)+ +(i[a+j>>0]|0)*+(i[b+j>>0]|0)+ +(i[a+h>>0]|0)*+(i[b+h>>0]|0)+ +(i[a+g>>0]|0)*+(i[b+g>>0]|0));e=e+4|0}while((e|0)<=(f|0));e=c&-4}if((e|0)>=(c|0)){d=d+0.0;return +d}do{d=d+ +(i[a+e>>0]|0)*+(i[b+e>>0]|0);e=e+1|0}while((e|0)!=(c|0));d=d+0.0;return +d}function u$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0,i=0;f=c+-4|0;if((c|0)<4){d=0.0;e=0}else{e=0;d=0.0;do{i=e|1;h=e|2;g=e|3;d=d+(+(m[a+(e<<1)>>1]|0)*+(m[b+(e<<1)>>1]|0)+ +(m[a+(i<<1)>>1]|0)*+(m[b+(i<<1)>>1]|0)+ +(m[a+(h<<1)>>1]|0)*+(m[b+(h<<1)>>1]|0)+ +(m[a+(g<<1)>>1]|0)*+(m[b+(g<<1)>>1]|0));e=e+4|0}while((e|0)<=(f|0));e=c&-4}if((e|0)>=(c|0))return +d;do{d=d+ +(m[a+(e<<1)>>1]|0)*+(m[b+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(c|0));return +d}function v$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0,i=0;f=c+-4|0;if((c|0)<4){d=0.0;e=0}else{e=0;d=0.0;do{i=e|1;h=e|2;g=e|3;d=d+(+(j[a+(e<<1)>>1]|0)*+(j[b+(e<<1)>>1]|0)+ +(j[a+(i<<1)>>1]|0)*+(j[b+(i<<1)>>1]|0)+ +(j[a+(h<<1)>>1]|0)*+(j[b+(h<<1)>>1]|0)+ +(j[a+(g<<1)>>1]|0)*+(j[b+(g<<1)>>1]|0));e=e+4|0}while((e|0)<=(f|0));e=c&-4}if((e|0)>=(c|0))return +d;do{d=d+ +(j[a+(e<<1)>>1]|0)*+(j[b+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(c|0));return +d}function w$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0,i=0;f=c+-4|0;if((c|0)<4){d=0.0;e=0}else{e=0;d=0.0;do{i=e|1;h=e|2;g=e|3;d=d+(+(k[a+(e<<2)>>2]|0)*+(k[b+(e<<2)>>2]|0)+ +(k[a+(i<<2)>>2]|0)*+(k[b+(i<<2)>>2]|0)+ +(k[a+(h<<2)>>2]|0)*+(k[b+(h<<2)>>2]|0)+ +(k[a+(g<<2)>>2]|0)*+(k[b+(g<<2)>>2]|0));e=e+4|0}while((e|0)<=(f|0));e=c&-4}if((e|0)>=(c|0))return +d;do{d=d+ +(k[a+(e<<2)>>2]|0)*+(k[b+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(c|0));return +d}function x$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0,i=0;f=c+-4|0;if((c|0)<4){d=0.0;e=0}else{e=0;d=0.0;do{i=e|1;h=e|2;g=e|3;d=d+(+o[a+(e<<2)>>2]*+o[b+(e<<2)>>2]+ +o[a+(i<<2)>>2]*+o[b+(i<<2)>>2]+ +o[a+(h<<2)>>2]*+o[b+(h<<2)>>2]+ +o[a+(g<<2)>>2]*+o[b+(g<<2)>>2]);e=e+4|0}while((e|0)<=(f|0));e=c&-4}if((e|0)>=(c|0)){d=d+0.0;return +d}do{d=d+ +o[a+(e<<2)>>2]*+o[b+(e<<2)>>2];e=e+1|0}while((e|0)!=(c|0));d=d+0.0;return +d}function y$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0,i=0;f=c+-4|0;if((c|0)<4){d=0.0;e=0}else{e=0;d=0.0;do{i=e|1;h=e|2;g=e|3;d=d+(+p[a+(e<<3)>>3]*+p[b+(e<<3)>>3]+ +p[a+(i<<3)>>3]*+p[b+(i<<3)>>3]+ +p[a+(h<<3)>>3]*+p[b+(h<<3)>>3]+ +p[a+(g<<3)>>3]*+p[b+(g<<3)>>3]);e=e+4|0}while((e|0)<=(f|0));e=c&-4}if((e|0)>=(c|0))return +d;do{d=d+ +p[a+(e<<3)>>3]*+p[b+(e<<3)>>3];e=e+1|0}while((e|0)!=(c|0));return +d}function z$(a){a=a|0;var b=0,c=0,d=0;d=a+148|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+144>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+128|0;c=a+116|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+152>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+156>>2]|0;if(!((b|0)==(a+160|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+92|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+88>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+72|0;c=a+60|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+96>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+100>>2]|0;if(!((b|0)==(a+104|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+36|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;c=a+16|0;d=a+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[d>>2]|0)>0){c=k[a+40>>2]|0;b=0;do{k[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[d>>2]|0))}b=k[a+44>>2]|0;if((b|0)==(a+48|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function A$(a){a=a|0;return}function B$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=r;r=r+656|0;D=F+312|0;C=F+256|0;E=F+592|0;v=F+32|0;u=F+536|0;f=F;if(!(Hh[k[(k[a>>2]|0)+8>>2]&511](a,b)|0)){k[E>>2]=1124007936;y=E+4|0;a=E+8|0;w=E+40|0;s=y;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[w>>2]=a;z=E+48|0;x=E+44|0;k[x>>2]=z;k[E+52>>2]=0;k[z>>2]=0;a=k[b>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,b,E,-1);a=c;m=k[a>>2]|0;a=k[a+4>>2]|0;t=d;s=k[t+4>>2]|0;o=D;k[o>>2]=k[t>>2];k[o+4>>2]=s;o=C;k[o>>2]=m;k[o+4>>2]=a;H1(u,E,C,D);k[D>>2]=1124007936;o=D+4|0;a=D+8|0;m=D+40|0;s=o;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[m>>2]=a;q=D+48|0;n=D+44|0;k[n>>2]=q;k[D+52>>2]=0;k[q>>2]=0;k[C>>2]=1124007936;j=C+4|0;a=C+8|0;h=C+40|0;s=j;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[h>>2]=a;l=C+48|0;i=C+44|0;k[i>>2]=l;k[C+52>>2]=0;k[l>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[f+28>>2]=0;Z$(v,48028,0,u,D,C,1.0,1.0,f);t=v;a=k[t+4>>2]|0;s=e;k[s>>2]=k[t>>2];k[s+4>>2]=a;KG(e+8|0,v+8|0)|0;KG(e+64|0,v+64|0)|0;KG(e+120|0,v+120|0)|0;s=e+176|0;a=v+176|0;t=s+48|0;do{k[s>>2]=k[a>>2];s=s+4|0;a=a+4|0}while((s|0)<(t|0));XN(v);g=C+36|0;a=k[g>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[C+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;C=C+16|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[j>>2]|0)>0){f=k[h>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[i>>2]|0;if(!((a|0)==(l|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=D+36|0;a=k[g>>2]|0;if(a|0?(d=a+12|0,C=k[d>>2]|0,k[d>>2]=C+-1,(C|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[D+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[o>>2]|0)>0){f=k[m>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[n>>2]|0;if(!((a|0)==(q|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=u+36|0;a=k[g>>2]|0;if(a|0?(C=a+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[u+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;D=u+16|0;f=u+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[f>>2]|0)>0){g=k[u+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[u+44>>2]|0;if(!((a|0)==(u+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=E+36|0;a=k[g>>2]|0;if(a|0?(C=a+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[E+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;E=E+16|0;k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;if((k[y>>2]|0)>0){f=k[w>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[y>>2]|0))}a=k[x>>2]|0;if(!((a|0)==(z|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=F;return}f=k[b>>2]|0;g=k[b+4>>2]|0;k[C>>2]=1124007936;y=C+4|0;a=C+8|0;w=C+40|0;s=y;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[w>>2]=a;z=C+48|0;x=C+44|0;k[x>>2]=z;k[C+52>>2]=0;k[z>>2]=0;k[E>>2]=1124007936;o=E+4|0;a=E+8|0;m=E+40|0;s=o;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[m>>2]=a;q=E+48|0;n=E+44|0;k[n>>2]=q;k[E+52>>2]=0;k[q>>2]=0;k[v>>2]=1124007936;j=v+4|0;a=v+8|0;h=v+40|0;s=j;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[h>>2]=a;l=v+48|0;i=v+44|0;k[i>>2]=l;k[v+52>>2]=0;k[l>>2]=0;Z$(D,f,g,C,E,v,+p[b+176>>3],+p[b+184>>3],b+192|0);B=D;A=k[B+4>>2]|0;u=e;k[u>>2]=k[B>>2];k[u+4>>2]=A;u=e+8|0;KG(u,D+8|0)|0;A=e+64|0;KG(A,D+64|0)|0;B=e+120|0;KG(B,D+120|0)|0;s=e+176|0;a=D+176|0;t=s+48|0;do{k[s>>2]=k[a>>2];s=s+4|0;a=a+4|0}while((s|0)<(t|0));XN(D);g=v+36|0;a=k[g>>2]|0;if(a|0?(s=a+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[v+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;v=v+16|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[j>>2]|0)>0){f=k[h>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[i>>2]|0;if(!((a|0)==(l|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=E+36|0;a=k[g>>2]|0;if(a|0?(t=a+12|0,v=k[t>>2]|0,k[t>>2]=v+-1,(v|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[E+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;v=E+16|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[o>>2]|0)>0){f=k[m>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[n>>2]|0;if(!((a|0)==(q|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=C+36|0;a=k[g>>2]|0;if(a|0?(t=a+12|0,v=k[t>>2]|0,k[t>>2]=v+-1,(v|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[C+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;v=C+16|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[y>>2]|0)>0){f=k[w>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[y>>2]|0))}a=k[x>>2]|0;if(!((a|0)==(z|0)|(a|0)==0))ggb(k[a+-4>>2]|0);if(k[b+24>>2]|0){a=c;z=k[a>>2]|0;a=k[a+4>>2]|0;x=d;y=k[x+4>>2]|0;g=D;k[g>>2]=k[x>>2];k[g+4>>2]=y;g=C;k[g>>2]=z;k[g+4>>2]=a;H1(E,b+8|0,C,D);KG(u,E)|0;g=E+36|0;a=k[g>>2]|0;if(a|0?(y=a+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[E+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;z=E+16|0;f=E+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[f>>2]|0)>0){g=k[E+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[E+44>>2]|0;if(!((a|0)==(E+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}if(k[b+80>>2]|0){a=c;z=k[a>>2]|0;a=k[a+4>>2]|0;x=d;y=k[x+4>>2]|0;g=D;k[g>>2]=k[x>>2];k[g+4>>2]=y;g=C;k[g>>2]=z;k[g+4>>2]=a;H1(E,b+64|0,C,D);KG(A,E)|0;g=E+36|0;a=k[g>>2]|0;if(a|0?(z=a+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[E+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;A=E+16|0;f=E+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[f>>2]|0)>0){g=k[E+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[E+44>>2]|0;if(!((a|0)==(E+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}if(!(k[b+136>>2]|0)){r=F;return}a=c;c=k[a>>2]|0;a=k[a+4>>2]|0;A=d;d=k[A+4>>2]|0;g=D;k[g>>2]=k[A>>2];k[g+4>>2]=d;g=C;k[g>>2]=c;k[g+4>>2]=a;H1(E,b+120|0,C,D);KG(B,E)|0;g=E+36|0;a=k[g>>2]|0;if(a|0?(C=a+12|0,D=k[C>>2]|0,k[C>>2]=D+-1,(D|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;do if(!a){a=k[E+32>>2]|0;if(a|0)break;a=B1()|0;f=k[g>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;D=E+16|0;f=E+4|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[f>>2]|0)>0){g=k[E+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[E+44>>2]|0;if(!((a|0)==(E+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=F;return}function C$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=r;r=r+656|0;D=E+256|0;A=E+32|0;C=E+592|0;z=E+536|0;l=E+480|0;e=E;if(!(Hh[k[(k[a>>2]|0)+8>>2]&511](a,b)|0)){k[D>>2]=1124007936;w=D+4|0;a=D+8|0;u=D+40|0;s=w;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[u>>2]=a;x=D+48|0;v=D+44|0;k[v>>2]=x;k[D+52>>2]=0;k[x>>2]=0;o=k[b>>2]|0;dh[k[(k[o>>2]|0)+12>>2]&255](o,b,D,-1);J1(C,D,c);k[z>>2]=1124007936;o=z+4|0;a=z+8|0;m=z+40|0;s=o;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[m>>2]=a;q=z+48|0;n=z+44|0;k[n>>2]=q;k[z+52>>2]=0;k[q>>2]=0;k[l>>2]=1124007936;i=l+4|0;a=l+8|0;g=l+40|0;s=i;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[g>>2]=a;j=l+48|0;h=l+44|0;k[h>>2]=j;k[l+52>>2]=0;k[j>>2]=0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;k[e+16>>2]=0;k[e+20>>2]=0;k[e+24>>2]=0;k[e+28>>2]=0;Z$(A,48028,0,C,z,l,1.0,1.0,e);t=A;a=k[t+4>>2]|0;s=d;k[s>>2]=k[t>>2];k[s+4>>2]=a;KG(d+8|0,A+8|0)|0;KG(d+64|0,A+64|0)|0;KG(d+120|0,A+120|0)|0;s=d+176|0;a=A+176|0;t=s+48|0;do{k[s>>2]=k[a>>2];s=s+4|0;a=a+4|0}while((s|0)<(t|0));XN(A);f=l+36|0;a=k[f>>2]|0;if(a|0?(b=a+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;c=l+16|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[i>>2]|0)>0){e=k[g>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[i>>2]|0))}a=k[h>>2]|0;if(!((a|0)==(j|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=z+36|0;a=k[f>>2]|0;if(a|0?(b=a+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[z+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;c=z+16|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[o>>2]|0)>0){e=k[m>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[n>>2]|0;if(!((a|0)==(q|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=C+36|0;a=k[f>>2]|0;if(a|0?(b=a+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[C+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;c=C+16|0;e=C+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[e>>2]|0)>0){f=k[C+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[C+44>>2]|0;if(!((a|0)==(C+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=D+36|0;a=k[f>>2]|0;if(a|0?(c=a+12|0,C=k[c>>2]|0,k[c>>2]=C+-1,(C|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[D+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[w>>2]|0)>0){e=k[u>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[v>>2]|0;if(!((a|0)==(x|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=E;return}e=k[b>>2]|0;f=k[b+4>>2]|0;k[A>>2]=1124007936;w=A+4|0;a=A+8|0;u=A+40|0;s=w;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[u>>2]=a;x=A+48|0;v=A+44|0;k[v>>2]=x;k[A+52>>2]=0;k[x>>2]=0;k[C>>2]=1124007936;n=C+4|0;a=C+8|0;l=C+40|0;s=n;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[l>>2]=a;o=C+48|0;m=C+44|0;k[m>>2]=o;k[C+52>>2]=0;k[o>>2]=0;k[z>>2]=1124007936;i=z+4|0;a=z+8|0;g=z+40|0;s=i;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[g>>2]=a;j=z+48|0;h=z+44|0;k[h>>2]=j;k[z+52>>2]=0;k[j>>2]=0;Z$(D,e,f,A,C,z,+p[b+176>>3],+p[b+184>>3],b+192|0);B=D;y=k[B+4>>2]|0;q=d;k[q>>2]=k[B>>2];k[q+4>>2]=y;q=d+8|0;KG(q,D+8|0)|0;y=d+64|0;KG(y,D+64|0)|0;B=d+120|0;KG(B,D+120|0)|0;s=d+176|0;a=D+176|0;t=s+48|0;do{k[s>>2]=k[a>>2];s=s+4|0;a=a+4|0}while((s|0)<(t|0));XN(D);f=z+36|0;a=k[f>>2]|0;if(a|0?(s=a+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[z+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;z=z+16|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[i>>2]|0)>0){e=k[g>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[i>>2]|0))}a=k[h>>2]|0;if(!((a|0)==(j|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=C+36|0;a=k[f>>2]|0;if(a|0?(t=a+12|0,z=k[t>>2]|0,k[t>>2]=z+-1,(z|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[C+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;C=C+16|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[n>>2]|0)>0){e=k[l>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[m>>2]|0;if(!((a|0)==(o|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=A+36|0;a=k[f>>2]|0;if(a|0?(z=a+12|0,C=k[z>>2]|0,k[z>>2]=C+-1,(C|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[A+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;C=A+16|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[w>>2]|0)>0){e=k[u>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[v>>2]|0;if(!((a|0)==(x|0)|(a|0)==0))ggb(k[a+-4>>2]|0);if(k[b+24>>2]|0){J1(D,b+8|0,c);KG(q,D)|0;f=D+36|0;a=k[f>>2]|0;if(a|0?(A=a+12|0,C=k[A>>2]|0,k[A>>2]=C+-1,(C|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[D+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;C=D+16|0;e=D+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[e>>2]|0)>0){f=k[D+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[D+44>>2]|0;if(!((a|0)==(D+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}if(k[b+80>>2]|0){J1(D,b+64|0,c);KG(y,D)|0;f=D+36|0;a=k[f>>2]|0;if(a|0?(A=a+12|0,C=k[A>>2]|0,k[A>>2]=C+-1,(C|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;do if(!a){a=k[D+32>>2]|0;if(a|0)break;a=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;C=D+16|0;e=D+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[e>>2]|0)>0){f=k[D+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[D+44>>2]|0;if(!((a|0)==(D+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}if(!(k[b+136>>2]|0)){r=E;return}J1(D,b+120|0,c);KG(B,D)|0;f=D+36|0;a=k[f>>2]|0;if(a|0?(c=a+12|0,C=k[c>>2]|0,k[c>>2]=C+-1,(C|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;do if(!a){a=k[D+32>>2]|0;if(a|0)break;a=B1()|0;e=k[f>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;C=D+16|0;e=D+4|0;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;if((k[e>>2]|0)>0){f=k[D+40>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[D+44>>2]|0;if(!((a|0)==(D+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=E;return}function D$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+112|0;f=o+88|0;g=o+72|0;h=o+56|0;l=o;k[l>>2]=1124007936;n=l+4|0;a=l+8|0;m=l+40|0;d=n;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[m>>2]=a;j=l+48|0;i=l+44|0;k[i>>2]=j;k[l+52>>2]=0;k[j>>2]=0;e=k[b>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,b,l,-1);k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=l;e=h+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[h>>2]=33619968;k[e>>2]=c;sU(f,g,h,49332,-1,39936,0,0);e=l+36|0;a=k[e>>2]|0;if(a|0?(b=a+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[n>>2]|0)>0){d=k[m>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[i>>2]|0;if((a|0)==(j|0)|(a|0)==0){r=o;return}ggb(k[a+-4>>2]|0);r=o;return}function E$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+112|0;f=o+88|0;g=o+72|0;h=o+56|0;l=o;k[l>>2]=1124007936;n=l+4|0;a=l+8|0;m=l+40|0;d=n;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[m>>2]=a;j=l+48|0;i=l+44|0;k[i>>2]=j;k[l+52>>2]=0;k[j>>2]=0;e=k[b>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,b,l,-1);k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=l;e=h+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[h>>2]=33619968;k[e>>2]=c;sU(f,g,h,49332,-1,39968,0,0);e=l+36|0;a=k[e>>2]|0;if(a|0?(b=a+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[n>>2]|0)>0){d=k[m>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[i>>2]|0;if((a|0)==(j|0)|(a|0)==0){r=o;return}ggb(k[a+-4>>2]|0);r=o;return}function F$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+176|0;f=u+160|0;g=u+144|0;h=u+128|0;n=u+72|0;i=u+56|0;p=u;k[p>>2]=1124007936;t=p+4|0;a=p+8|0;o=p+40|0;d=t;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[o>>2]=a;s=p+48|0;q=p+44|0;k[q>>2]=s;k[p+52>>2]=0;k[s>>2]=0;m=k[b>>2]|0;dh[k[(k[m>>2]|0)+12>>2]&255](m,b,p,-1);k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=p;k[n>>2]=1124007936;m=n+4|0;a=n+8|0;j=n+40|0;d=m;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[j>>2]=a;l=n+48|0;e=n+44|0;k[e>>2]=l;k[n+52>>2]=0;k[l>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=n;d=i+4|0;a=d+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[d>>2]=c;s_(f,g,1.0,h,0.0,i,0);d=n+36|0;a=k[d>>2]|0;if(a|0?(i=a+12|0,c=k[i>>2]|0,k[i>>2]=c+-1,(c|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;n=n+16|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[m>>2]|0)>0){b=k[j>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[e>>2]|0;if(!((a|0)==(l|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=p+36|0;a=k[d>>2]|0;if(a|0?(m=a+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[p+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;p=p+16|0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[t>>2]|0)>0){b=k[o>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[t>>2]|0))}a=k[q>>2]|0;if((a|0)==(s|0)|(a|0)==0){r=u;return}ggb(k[a+-4>>2]|0);r=u;return}function G$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0;q=r;r=r+112|0;f=q;g=q+96|0;h=q+80|0;i=q+64|0;n=q+8|0;k[n>>2]=1124007936;o=n+4|0;a=n+8|0;l=n+40|0;d=o;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[l>>2]=a;m=n+48|0;j=n+44|0;k[j>>2]=m;k[n+52>>2]=0;k[m>>2]=0;e=k[b>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,b,n,-1);k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=c;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=n;e=i+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[e>>2]=c;p[f>>3]=1.0;sU(g,h,i,49332,-1,40064,1,f);e=n+36|0;a=k[e>>2]|0;if(a|0?(b=a+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;n=n+16|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[o>>2]|0)>0){d=k[l>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[j>>2]|0;if((a|0)==(m|0)|(a|0)==0){r=q;return}ggb(k[a+-4>>2]|0);r=q;return}function H$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+112|0;f=p+104|0;g=p+88|0;h=p+72|0;i=p+56|0;n=p;k[n>>2]=1124007936;o=n+4|0;a=n+8|0;l=n+40|0;d=o;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[l>>2]=a;m=n+48|0;j=n+44|0;k[j>>2]=m;k[n+52>>2]=0;k[m>>2]=0;e=k[b>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,b,n,-1);k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=c;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=n;e=i+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[e>>2]=c;k[f>>2]=98;aU(g,h,i,49332,f,1,9);e=n+36|0;a=k[e>>2]|0;if(a|0?(b=a+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;n=n+16|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[o>>2]|0)>0){d=k[l>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[j>>2]|0;if((a|0)==(m|0)|(a|0)==0){r=p;return}ggb(k[a+-4>>2]|0);r=p;return}function I$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+112|0;f=p+104|0;g=p+88|0;h=p+72|0;i=p+56|0;n=p;k[n>>2]=1124007936;o=n+4|0;a=n+8|0;l=n+40|0;d=o;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[l>>2]=a;m=n+48|0;j=n+44|0;k[j>>2]=m;k[n+52>>2]=0;k[m>>2]=0;e=k[b>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,b,n,-1);k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=c;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=n;e=i+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[e>>2]=c;k[f>>2]=100;aU(g,h,i,49332,f,1,10);e=n+36|0;a=k[e>>2]|0;if(a|0?(b=a+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;n=n+16|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[o>>2]|0)>0){d=k[l>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[j>>2]|0;if((a|0)==(m|0)|(a|0)==0){r=p;return}ggb(k[a+-4>>2]|0);r=p;return}function J$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+112|0;f=p+104|0;g=p+88|0;h=p+72|0;i=p+56|0;n=p;k[n>>2]=1124007936;o=n+4|0;a=n+8|0;l=n+40|0;d=o;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[l>>2]=a;m=n+48|0;j=n+44|0;k[j>>2]=m;k[n+52>>2]=0;k[m>>2]=0;e=k[b>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,b,n,-1);k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=c;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=n;e=i+4|0;a=e+4|0;k[a>>2]=0;k[a+4>>2]=0;k[i>>2]=33619968;k[e>>2]=c;k[f>>2]=101;aU(g,h,i,49332,f,1,11);e=n+36|0;a=k[e>>2]|0;if(a|0?(b=a+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;n=n+16|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[o>>2]|0)>0){d=k[l>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[j>>2]|0;if((a|0)==(m|0)|(a|0)==0){r=p;return}ggb(k[a+-4>>2]|0);r=p;return}function K$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+144|0;i=x;v=x+88|0;q=x+32|0;e=k[c>>2]|0;if((e|0)!=(a|0)){dh[k[(k[e>>2]|0)+52>>2]&255](e,b,c,d);r=x;return};k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;k[i+16>>2]=0;k[i+20>>2]=0;k[i+24>>2]=0;k[i+28>>2]=0;k[v>>2]=1124007936;w=v+4|0;a=v+8|0;s=v+40|0;e=w;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[s>>2]=a;u=v+48|0;t=v+44|0;k[t>>2]=u;k[v+52>>2]=0;k[u>>2]=0;k[q>>2]=1124007936;o=q+4|0;a=q+8|0;m=q+40|0;e=o;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[m>>2]=a;n=q+48|0;l=q+44|0;k[l>>2]=n;k[q+52>>2]=0;k[n>>2]=0;a=k[b>>2]|0;do if((a|0)==48272){if(k[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){j=6;break}KG(v,b+8|0)|0;h=+p[b+176>>3];b=b+192|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];k[i+8>>2]=k[b+8>>2];k[i+12>>2]=k[b+12>>2];k[i+16>>2]=k[b+16>>2];k[i+20>>2]=k[b+20>>2];k[i+24>>2]=k[b+24>>2];k[i+28>>2]=k[b+28>>2]}else j=6;while(0);if((j|0)==6){dh[k[(k[a>>2]|0)+12>>2]&255](a,b,v,-1);h=1.0}a=k[c>>2]|0;do if((a|0)==48272){if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){j=11;break}KG(q,c+8|0)|0;g=+p[c+176>>3];p[i>>3]=+p[c+192>>3]+ +p[i>>3];b=i+8|0;p[b>>3]=+p[c+200>>3]+ +p[b>>3];b=i+16|0;p[b>>3]=+p[c+208>>3]+ +p[b>>3];b=i+24|0;p[b>>3]=+p[c+216>>3]+ +p[b>>3]}else j=11;while(0);if((j|0)==11){dh[k[(k[a>>2]|0)+12>>2]&255](a,c,q,-1);g=1.0}G0(d,v,q,h,g,i);f=q+36|0;a=k[f>>2]|0;if(a|0?(i=a+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;q=q+16|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[o>>2]|0)>0){e=k[m>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[l>>2]|0;if(!((a|0)==(n|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=v+36|0;a=k[f>>2]|0;if(a|0?(o=a+12|0,q=k[o>>2]|0,k[o>>2]=q+-1,(q|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[v+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;v=v+16|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[w>>2]|0)>0){e=k[s>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[t>>2]|0;if(!((a|0)==(u|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=x;return}function L$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+112|0;l=q+56|0;j=q;k[l>>2]=1124007936;o=l+4|0;a=l+8|0;m=l+40|0;e=o;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[m>>2]=a;p=l+48|0;n=l+44|0;k[n>>2]=p;k[l+52>>2]=0;k[p>>2]=0;i=k[b>>2]|0;dh[k[(k[i>>2]|0)+12>>2]&255](i,b,l,-1);k[j>>2]=1124007936;i=j+4|0;a=j+8|0;g=j+40|0;e=i;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[g>>2]=a;h=j+48|0;f=j+44|0;k[f>>2]=h;k[j+52>>2]=0;k[h>>2]=0;G0(d,l,j,1.0,0.0,c);e=j+36|0;a=k[e>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[j+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;j=j+16|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[i>>2]|0)>0){b=k[g>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[i>>2]|0))}a=k[f>>2]|0;if(!((a|0)==(h|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=l+36|0;a=k[e>>2]|0;if(a|0?(i=a+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[o>>2]|0)>0){b=k[m>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[n>>2]|0;if((a|0)==(p|0)|(a|0)==0){r=q;return}ggb(k[a+-4>>2]|0);r=q;return}function M$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0;x=r;r=r+144|0;i=x;v=x+88|0;q=x+32|0;e=k[c>>2]|0;if((e|0)!=(a|0)){dh[k[(k[e>>2]|0)+60>>2]&255](e,b,c,d);r=x;return};k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;k[i+16>>2]=0;k[i+20>>2]=0;k[i+24>>2]=0;k[i+28>>2]=0;k[v>>2]=1124007936;w=v+4|0;a=v+8|0;s=v+40|0;e=w;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[s>>2]=a;u=v+48|0;t=v+44|0;k[t>>2]=u;k[v+52>>2]=0;k[u>>2]=0;k[q>>2]=1124007936;o=q+4|0;a=q+8|0;m=q+40|0;e=o;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[m>>2]=a;n=q+48|0;l=q+44|0;k[l>>2]=n;k[q+52>>2]=0;k[n>>2]=0;a=k[b>>2]|0;do if((a|0)==48272){if(k[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){j=6;break}KG(v,b+8|0)|0;h=+p[b+176>>3];b=b+192|0;k[i>>2]=k[b>>2];k[i+4>>2]=k[b+4>>2];k[i+8>>2]=k[b+8>>2];k[i+12>>2]=k[b+12>>2];k[i+16>>2]=k[b+16>>2];k[i+20>>2]=k[b+20>>2];k[i+24>>2]=k[b+24>>2];k[i+28>>2]=k[b+28>>2]}else j=6;while(0);if((j|0)==6){dh[k[(k[a>>2]|0)+12>>2]&255](a,b,v,-1);h=1.0}a=k[c>>2]|0;do if((a|0)==48272){if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){j=11;break}KG(q,c+8|0)|0;g=-+p[c+176>>3];p[i>>3]=+p[i>>3]-+p[c+192>>3];b=i+8|0;p[b>>3]=+p[b>>3]-+p[c+200>>3];b=i+16|0;p[b>>3]=+p[b>>3]-+p[c+208>>3];b=i+24|0;p[b>>3]=+p[b>>3]-+p[c+216>>3]}else j=11;while(0);if((j|0)==11){dh[k[(k[a>>2]|0)+12>>2]&255](a,c,q,-1);g=-1.0}G0(d,v,q,h,g,i);f=q+36|0;a=k[f>>2]|0;if(a|0?(i=a+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;q=q+16|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[o>>2]|0)>0){e=k[m>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[l>>2]|0;if(!((a|0)==(n|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=v+36|0;a=k[f>>2]|0;if(a|0?(o=a+12|0,q=k[o>>2]|0,k[o>>2]=q+-1,(q|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[v+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;v=v+16|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[w>>2]|0)>0){e=k[s>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[t>>2]|0;if(!((a|0)==(u|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=x;return}function N$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+112|0;l=q+56|0;j=q;k[l>>2]=1124007936;o=l+4|0;a=l+8|0;m=l+40|0;e=o;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[m>>2]=a;p=l+48|0;n=l+44|0;k[n>>2]=p;k[l+52>>2]=0;k[p>>2]=0;i=k[c>>2]|0;dh[k[(k[i>>2]|0)+12>>2]&255](i,c,l,-1);k[j>>2]=1124007936;i=j+4|0;a=j+8|0;g=j+40|0;e=i;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[g>>2]=a;h=j+48|0;f=j+44|0;k[f>>2]=h;k[j+52>>2]=0;k[h>>2]=0;G0(d,l,j,-1.0,0.0,b);e=j+36|0;a=k[e>>2]|0;if(a|0?(b=a+12|0,d=k[b>>2]|0,k[b>>2]=d+-1,(d|0)==1):0){c=k[e>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[j+32>>2]|0;if(!a){a=B1()|0;c=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[e>>2]=0}k[e>>2]=0;j=j+16|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[i>>2]|0)>0){c=k[g>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[i>>2]|0))}a=k[f>>2]|0;if(!((a|0)==(h|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=l+36|0;a=k[e>>2]|0;if(a|0?(i=a+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){c=k[e>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;c=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[e>>2]=0}k[e>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[o>>2]|0)>0){c=k[m>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[n>>2]|0;if((a|0)==(p|0)|(a|0)==0){r=q;return}ggb(k[a+-4>>2]|0);r=q;return}function O$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+112|0;t=w+56|0;o=w;f=k[c>>2]|0;if((f|0)!=(a|0)){kh[k[(k[f>>2]|0)+68>>2]&7](f,b,c,d,e);r=w;return}k[t>>2]=1124007936;v=t+4|0;f=t+8|0;q=t+40|0;g=v;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[q>>2]=f;u=t+48|0;s=t+44|0;k[s>>2]=u;k[t+52>>2]=0;k[u>>2]=0;k[o>>2]=1124007936;n=o+4|0;f=o+8|0;l=o+40|0;g=n;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[l>>2]=f;m=o+48|0;j=o+44|0;k[j>>2]=m;k[o+52>>2]=0;k[m>>2]=0;f=k[b>>2]|0;do if((f|0)==48512?(k[b+4>>2]|0)==47:0){if(k[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){i=15;break}do if((a|0)==48272){if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){i=13;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){e=+p[c+176>>3]*e;KG(o,c+8|0)|0}else i=13}else i=13;while(0);if((i|0)==13)dh[k[(k[a>>2]|0)+12>>2]&255](a,c,o,-1);A0(d,47,o,b+8|0,e/+p[b+176>>3])}else i=15;while(0);if((i|0)==15){do if((f|0)==48272){if(k[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){i=23;break}if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){KG(t,b+8|0)|0;e=+p[b+176>>3]*e}else i=23}else i=23;while(0);if((i|0)==23)dh[k[(k[f>>2]|0)+12>>2]&255](f,b,t,-1);f=k[c>>2]|0;do if((f|0)==48272){if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){i=36;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){KG(o,c+8|0)|0;f=42;e=e*+p[c+176>>3]}else i=36}else if((f|0)==48512?(k[c+4>>2]|0)==47:0){if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){i=36;break}KG(o,c+8|0)|0;f=47;e=e/+p[c+176>>3]}else i=36;while(0);if((i|0)==36){dh[k[(k[f>>2]|0)+12>>2]&255](f,c,o,-1);f=42}A0(d,f,t,o,e)}h=o+36|0;f=k[h>>2]|0;if(f|0?(d=f+12|0,i=k[d>>2]|0,k[d>>2]=i+-1,(i|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[o+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;o=o+16|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[n>>2]|0)>0){g=k[l>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[n>>2]|0))}f=k[j>>2]|0;if(!((f|0)==(m|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=t+36|0;f=k[h>>2]|0;if(f|0?(n=f+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[t+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;t=t+16|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[v>>2]|0)>0){g=k[q>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[v>>2]|0))}f=k[s>>2]|0;if(!((f|0)==(u|0)|(f|0)==0))ggb(k[f+-4>>2]|0);r=w;return}function P$(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+144|0;m=s+88|0;l=s+32|0;g=s;k[m>>2]=1124007936;q=m+4|0;a=m+8|0;n=m+40|0;e=q;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[n>>2]=a;p=m+48|0;o=m+44|0;k[o>>2]=p;k[m+52>>2]=0;k[p>>2]=0;j=k[b>>2]|0;dh[k[(k[j>>2]|0)+12>>2]&255](j,b,m,-1);k[l>>2]=1124007936;j=l+4|0;a=l+8|0;h=l+40|0;e=j;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[h>>2]=a;i=l+48|0;f=l+44|0;k[f>>2]=i;k[l+52>>2]=0;k[i>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g+16>>2]=0;k[g+20>>2]=0;k[g+24>>2]=0;k[g+28>>2]=0;G0(d,m,l,c,0.0,g);e=l+36|0;a=k[e>>2]|0;if(a|0?(g=a+12|0,d=k[g>>2]|0,k[g>>2]=d+-1,(d|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[j>>2]|0)>0){b=k[h>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[f>>2]|0;if(!((a|0)==(i|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=m+36|0;a=k[e>>2]|0;if(a|0?(j=a+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[m+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;m=m+16|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[q>>2]|0)>0){b=k[n>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[q>>2]|0))}a=k[o>>2]|0;if((a|0)==(p|0)|(a|0)==0){r=s;return}ggb(k[a+-4>>2]|0);r=s;return}function Q$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+112|0;v=w+56|0;o=w;f=k[c>>2]|0;if((f|0)!=(a|0)){kh[k[(k[f>>2]|0)+76>>2]&7](f,b,c,d,e);r=w;return}h=k[b>>2]|0;do if((h|0)==48512?(k[b+4>>2]|0)==47:0){if(k[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if((a|0)==48512?(k[c+4>>2]|0)==47:0){if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;A0(d,47,c+8|0,b+8|0,+p[b+176>>3]/+p[c+176>>3]);r=w;return}}while(0);k[v>>2]=1124007936;t=v+4|0;f=v+8|0;q=v+40|0;a=t;g=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(g|0));k[q>>2]=f;u=v+48|0;s=v+44|0;k[s>>2]=u;k[v+52>>2]=0;k[u>>2]=0;k[o>>2]=1124007936;n=o+4|0;f=o+8|0;l=o+40|0;a=n;g=a+36|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(g|0));k[l>>2]=f;m=o+48|0;j=o+44|0;k[j>>2]=m;k[o+52>>2]=0;k[m>>2]=0;do if((h|0)==48272){if(k[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){i=17;break}if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){KG(v,b+8|0)|0;e=+p[b+176>>3]*e}else i=17}else i=17;while(0);if((i|0)==17)dh[k[(k[h>>2]|0)+12>>2]&255](h,b,v,-1);f=k[c>>2]|0;do if((f|0)==48272){if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){i=30;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){KG(o,c+8|0)|0;f=47;e=e/+p[c+176>>3]}else i=30}else if((f|0)==48512?(k[c+4>>2]|0)==47:0){if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){i=30;break}KG(o,c+8|0)|0;f=42;e=e/+p[c+176>>3]}else i=30;while(0);if((i|0)==30){dh[k[(k[f>>2]|0)+12>>2]&255](f,c,o,-1);f=47}A0(d,f,v,o,e);g=o+36|0;f=k[g>>2]|0;if(f|0?(d=f+12|0,i=k[d>>2]|0,k[d>>2]=i+-1,(i|0)==1):0){a=k[g>>2]|0;if(a|0){f=k[a+4>>2]|0;if(!f){f=k[o+32>>2]|0;if(!f){f=B1()|0;a=k[g>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,a)}k[g>>2]=0}k[g>>2]=0;o=o+16|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[n>>2]|0)>0){a=k[l>>2]|0;f=0;do{k[a+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[n>>2]|0))}f=k[j>>2]|0;if(!((f|0)==(m|0)|(f|0)==0))ggb(k[f+-4>>2]|0);g=v+36|0;f=k[g>>2]|0;if(f|0?(n=f+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){a=k[g>>2]|0;if(a|0){f=k[a+4>>2]|0;if(!f){f=k[v+32>>2]|0;if(!f){f=B1()|0;a=k[g>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,a)}k[g>>2]=0}k[g>>2]=0;v=v+16|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[t>>2]|0)>0){a=k[q>>2]|0;f=0;do{k[a+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[t>>2]|0))}f=k[s>>2]|0;if(!((f|0)==(u|0)|(f|0)==0))ggb(k[f+-4>>2]|0);r=w;return}function R$(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+112|0;l=q+56|0;j=q;k[l>>2]=1124007936;o=l+4|0;a=l+8|0;m=l+40|0;e=o;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[m>>2]=a;p=l+48|0;n=l+44|0;k[n>>2]=p;k[l+52>>2]=0;k[p>>2]=0;i=k[c>>2]|0;dh[k[(k[i>>2]|0)+12>>2]&255](i,c,l,-1);k[j>>2]=1124007936;i=j+4|0;a=j+8|0;g=j+40|0;e=i;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[g>>2]=a;h=j+48|0;f=j+44|0;k[f>>2]=h;k[j+52>>2]=0;k[h>>2]=0;A0(d,47,l,j,b);e=j+36|0;a=k[e>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){c=k[e>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[j+32>>2]|0;if(!a){a=B1()|0;c=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[e>>2]=0}k[e>>2]=0;j=j+16|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[i>>2]|0)>0){c=k[g>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[i>>2]|0))}a=k[f>>2]|0;if(!((a|0)==(h|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=l+36|0;a=k[e>>2]|0;if(a|0?(i=a+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){c=k[e>>2]|0;if(c|0){a=k[c+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;c=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,c)}k[e>>2]=0}k[e>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[o>>2]|0)>0){c=k[m>>2]|0;a=0;do{k[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[n>>2]|0;if((a|0)==(p|0)|(a|0)==0){r=q;return}ggb(k[a+-4>>2]|0);r=q;return}function S$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+112|0;j=p+56|0;i=p;k[j>>2]=1124007936;n=j+4|0;a=j+8|0;l=j+40|0;d=n;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[l>>2]=a;o=j+48|0;m=j+44|0;k[m>>2]=o;k[j+52>>2]=0;k[o>>2]=0;h=k[b>>2]|0;dh[k[(k[h>>2]|0)+12>>2]&255](h,b,j,-1);k[i>>2]=1124007936;h=i+4|0;a=i+8|0;f=i+40|0;d=h;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[f>>2]=a;g=i+48|0;e=i+44|0;k[e>>2]=g;k[i+52>>2]=0;k[g>>2]=0;A0(c,97,j,i,1.0);d=i+36|0;a=k[d>>2]|0;if(a|0?(b=a+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[i+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;i=i+16|0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;if((k[h>>2]|0)>0){b=k[f>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[e>>2]|0;if(!((a|0)==(g|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=j+36|0;a=k[d>>2]|0;if(a|0?(h=a+12|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[j+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;j=j+16|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[n>>2]|0)>0){b=k[l>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[m>>2]|0;if((a|0)==(o|0)|(a|0)==0){r=p;return}ggb(k[a+-4>>2]|0);r=p;return}function T$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+64|0;g=l;k[g>>2]=1124007936;j=g+4|0;a=g+8|0;h=g+40|0;d=j;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[h>>2]=a;i=g+48|0;f=g+44|0;k[f>>2]=i;k[g+52>>2]=0;k[i>>2]=0;e=k[b>>2]|0;dh[k[(k[e>>2]|0)+12>>2]&255](e,b,g,-1);y0(c,g,1.0);e=g+36|0;a=k[e>>2]|0;if(a|0?(b=a+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[g+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;g=g+16|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[j>>2]|0)>0){d=k[h>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[f>>2]|0;if((a|0)==(i|0)|(a|0)==0){r=l;return}ggb(k[a+-4>>2]|0);r=l;return}function U$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+432|0;n=B+32|0;j=B;A=B+368|0;v=B+312|0;o=B+256|0;e=k[c>>2]|0;if((e|0)!=(a|0)){dh[k[(k[e>>2]|0)+92>>2]&255](e,b,c,d);r=B;return}k[A>>2]=1124007936;y=A+4|0;a=A+8|0;w=A+40|0;g=y;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[w>>2]=a;z=A+48|0;x=A+44|0;k[x>>2]=z;k[A+52>>2]=0;k[z>>2]=0;k[v>>2]=1124007936;t=v+4|0;a=v+8|0;q=v+40|0;g=t;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[q>>2]=a;u=v+48|0;s=v+44|0;k[s>>2]=u;k[v+52>>2]=0;k[u>>2]=0;a=k[b>>2]|0;a:do if((a|0)==48268){f=+p[b+176>>3];KG(A,b+8|0)|0;a=1}else{do if((a|0)==48272){if(k[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){f=+p[b+176>>3];KG(A,b+8|0)|0;a=0;break a}}while(0);dh[k[(k[a>>2]|0)+12>>2]&255](a,b,A,-1);a=0;f=1.0}while(0);e=k[c>>2]|0;b:do if((e|0)==48268){f=f*+p[c+176>>3];KG(v,c+8|0)|0;a=a|2}else{do if((e|0)==48272){if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){f=f*+p[c+176>>3];KG(v,c+8|0)|0;break b}}while(0);dh[k[(k[e>>2]|0)+12>>2]&255](e,c,v,-1)}while(0);k[o>>2]=1124007936;l=o+4|0;e=o+8|0;c=o+40|0;g=l;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[c>>2]=e;m=o+48|0;i=o+44|0;k[i>>2]=m;k[o+52>>2]=0;k[m>>2]=0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;k[j+20>>2]=0;k[j+24>>2]=0;k[j+28>>2]=0;Z$(n,48276,a,A,v,o,f,1.0,j);h=n;a=k[h+4>>2]|0;g=d;k[g>>2]=k[h>>2];k[g+4>>2]=a;KG(d+8|0,n+8|0)|0;KG(d+64|0,n+64|0)|0;KG(d+120|0,n+120|0)|0;g=d+176|0;a=n+176|0;h=g+48|0;do{k[g>>2]=k[a>>2];g=g+4|0;a=a+4|0}while((g|0)<(h|0));XN(n);b=o+36|0;a=k[b>>2]|0;if(a|0?(j=a+12|0,n=k[j>>2]|0,k[j>>2]=n+-1,(n|0)==1):0){e=k[b>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[o+32>>2]|0;if(!a){a=B1()|0;e=k[b>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[b>>2]=0}k[b>>2]=0;o=o+16|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[l>>2]|0)>0){e=k[c>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[i>>2]|0;if(!((a|0)==(m|0)|(a|0)==0))ggb(k[a+-4>>2]|0);b=v+36|0;a=k[b>>2]|0;if(a|0?(n=a+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){e=k[b>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[v+32>>2]|0;if(!a){a=B1()|0;e=k[b>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[b>>2]=0}k[b>>2]=0;v=v+16|0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[t>>2]|0)>0){e=k[q>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[t>>2]|0))}a=k[s>>2]|0;if(!((a|0)==(u|0)|(a|0)==0))ggb(k[a+-4>>2]|0);b=A+36|0;a=k[b>>2]|0;if(a|0?(u=a+12|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0){e=k[b>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[A+32>>2]|0;if(!a){a=B1()|0;e=k[b>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[b>>2]=0}k[b>>2]=0;A=A+16|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[y>>2]|0)>0){e=k[w>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[y>>2]|0))}a=k[x>>2]|0;if(!((a|0)==(z|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=B;return}function V$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=r;r=r+64|0;h=m;k[h>>2]=1124007936;l=h+4|0;a=h+8|0;i=h+40|0;e=l;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[i>>2]=a;j=h+48|0;g=h+44|0;k[g>>2]=j;k[h+52>>2]=0;k[j>>2]=0;f=k[b>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,b,h,-1);Y$(d,c,h);f=h+36|0;a=k[f>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[h+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;h=h+16|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[l>>2]|0)>0){e=k[i>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[g>>2]|0;if((a|0)==(j|0)|(a|0)==0){r=m;return}ggb(k[a+-4>>2]|0);r=m;return}function W$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;if(k[c+24>>2]|0){f=k[c+12>>2]|0;if((f|0)<3)b=aa(k[c+20>>2]|0,k[c+16>>2]|0)|0;else{e=k[c+48>>2]|0;d=0;b=1;do{b=aa(k[e+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(f|0))}if(b|0){f=k[c+48>>2]|0;c=k[f>>2]|0;k[a>>2]=k[f+4>>2];k[a+4>>2]=c;return}}if(k[c+80>>2]|0){e=k[c+68>>2]|0;if((e|0)<3)b=aa(k[c+76>>2]|0,k[c+72>>2]|0)|0;else{f=k[c+104>>2]|0;d=0;b=1;do{b=aa(k[f+(d<<2)>>2]|0,b)|0;d=d+1|0}while((d|0)!=(e|0))}if(b|0){f=k[c+160>>2]|0;c=k[f>>2]|0;k[a>>2]=k[f+4>>2];k[a+4>>2]=c;return}}f=k[c+104>>2]|0;c=k[f>>2]|0;k[a>>2]=k[f+4>>2];k[a+4>>2]=c;return}function X$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(k[b+24>>2]|0){d=k[b+12>>2]|0;if((d|0)<3)a=aa(k[b+20>>2]|0,k[b+16>>2]|0)|0;else{e=k[b+48>>2]|0;c=0;a=1;do{a=aa(k[e+(c<<2)>>2]|0,a)|0;c=c+1|0}while((c|0)!=(d|0))}if(a|0){b=b+8|0;b=k[b>>2]|0;b=b&4095;return b|0}}if(k[b+80>>2]|0){d=k[b+68>>2]|0;if((d|0)<3)a=aa(k[b+76>>2]|0,k[b+72>>2]|0)|0;else{e=k[b+104>>2]|0;c=0;a=1;do{a=aa(k[e+(c<<2)>>2]|0,a)|0;c=c+1|0}while((c|0)!=(d|0))}if(a|0){b=b+120|0;b=k[b>>2]|0;b=b&4095;return b|0}}b=b+64|0;b=k[b>>2]|0;b=b&4095;return b|0}function Y$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+368|0;f=u+32|0;o=u+312|0;l=u+256|0;e=u;k[o>>2]=1124007936;t=o+4|0;d=o+8|0;p=o+40|0;g=t;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[p>>2]=d;s=o+48|0;q=o+44|0;k[q>>2]=s;k[o+52>>2]=0;k[s>>2]=0;k[l>>2]=1124007936;m=l+4|0;d=l+8|0;i=l+40|0;g=m;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[i>>2]=d;n=l+48|0;j=l+44|0;k[j>>2]=n;k[l+52>>2]=0;k[n>>2]=0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;k[e+16>>2]=0;k[e+20>>2]=0;k[e+24>>2]=0;k[e+28>>2]=0;Z$(f,47908,b,c,o,l,1.0,0.0,e);h=f;d=k[h+4>>2]|0;g=a;k[g>>2]=k[h>>2];k[g+4>>2]=d;KG(a+8|0,f+8|0)|0;KG(a+64|0,f+64|0)|0;KG(a+120|0,f+120|0)|0;g=a+176|0;d=f+176|0;h=g+48|0;do{k[g>>2]=k[d>>2];g=g+4|0;d=d+4|0}while((g|0)<(h|0));XN(f);b=l+36|0;d=k[b>>2]|0;if(d|0?(g=d+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){a=k[b>>2]|0;if(a|0){d=k[a+4>>2]|0;if(!d){d=k[l+32>>2]|0;if(!d){d=B1()|0;a=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,a)}k[b>>2]=0}k[b>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[m>>2]|0)>0){a=k[i>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[m>>2]|0))}d=k[j>>2]|0;if(!((d|0)==(n|0)|(d|0)==0))ggb(k[d+-4>>2]|0);b=o+36|0;d=k[b>>2]|0;if(d|0?(m=d+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){a=k[b>>2]|0;if(a|0){d=k[a+4>>2]|0;if(!d){d=k[o+32>>2]|0;if(!d){d=B1()|0;a=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,a)}k[b>>2]=0}k[b>>2]=0;o=o+16|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[t>>2]|0)>0){a=k[p>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[t>>2]|0))}d=k[q>>2]|0;if((d|0)==(s|0)|(d|0)==0){r=u;return}ggb(k[d+-4>>2]|0);r=u;return}function Z$(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;var j=0,l=0,m=0,n=0,o=0;k[a>>2]=b;k[a+4>>2]=c;b=a+8|0;k[b>>2]=k[d>>2];o=a+12|0;c=d+4|0;k[o>>2]=k[c>>2];m=a+16|0;k[m>>2]=k[d+8>>2];k[a+20>>2]=k[d+12>>2];k[a+24>>2]=k[d+16>>2];k[a+28>>2]=k[d+20>>2];k[a+32>>2]=k[d+24>>2];k[a+36>>2]=k[d+28>>2];k[a+40>>2]=k[d+32>>2];j=k[d+36>>2]|0;k[a+44>>2]=j;l=a+48|0;k[l>>2]=m;m=a+56|0;n=a+52|0;k[n>>2]=m;k[a+60>>2]=0;k[m>>2]=0;if(j|0){m=j+12|0;k[m>>2]=(k[m>>2]|0)+1}if((k[c>>2]|0)>=3){k[o>>2]=0;x1(b,k[c>>2]|0,0,0,0);if((k[o>>2]|0)>0){m=k[d+40>>2]|0;l=k[l>>2]|0;j=k[d+44>>2]|0;c=k[n>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[m+(b<<2)>>2];k[c+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[o>>2]|0))}}else{d=k[d+44>>2]|0;o=k[n>>2]|0;k[o>>2]=k[d>>2];k[o+4>>2]=k[d+4>>2]}c=a+64|0;k[c>>2]=k[e>>2];d=a+68|0;j=e+4|0;k[d>>2]=k[j>>2];o=a+72|0;k[o>>2]=k[e+8>>2];k[a+76>>2]=k[e+12>>2];k[a+80>>2]=k[e+16>>2];k[a+84>>2]=k[e+20>>2];k[a+88>>2]=k[e+24>>2];k[a+92>>2]=k[e+28>>2];k[a+96>>2]=k[e+32>>2];b=k[e+36>>2]|0;k[a+100>>2]=b;l=a+104|0;k[l>>2]=o;o=a+112|0;n=a+108|0;k[n>>2]=o;k[a+116>>2]=0;k[o>>2]=0;if(b|0){o=b+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[j>>2]|0)>=3){k[d>>2]=0;x1(c,k[j>>2]|0,0,0,0);if((k[d>>2]|0)>0){m=k[e+40>>2]|0;l=k[l>>2]|0;j=k[e+44>>2]|0;c=k[n>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[m+(b<<2)>>2];k[c+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[d>>2]|0))}}else{o=k[e+44>>2]|0;e=k[n>>2]|0;k[e>>2]=k[o>>2];k[e+4>>2]=k[o+4>>2]}b=a+120|0;k[b>>2]=k[f>>2];d=a+124|0;c=f+4|0;k[d>>2]=k[c>>2];e=a+128|0;k[e>>2]=k[f+8>>2];k[a+132>>2]=k[f+12>>2];k[a+136>>2]=k[f+16>>2];k[a+140>>2]=k[f+20>>2];k[a+144>>2]=k[f+24>>2];k[a+148>>2]=k[f+28>>2];k[a+152>>2]=k[f+32>>2];j=k[f+36>>2]|0;k[a+156>>2]=j;l=a+160|0;k[l>>2]=e;e=a+168|0;n=a+164|0;k[n>>2]=e;k[a+172>>2]=0;k[e>>2]=0;if(j|0){e=j+12|0;k[e>>2]=(k[e>>2]|0)+1}if((k[c>>2]|0)<3){e=k[f+44>>2]|0;f=k[n>>2]|0;k[f>>2]=k[e>>2];k[f+4>>2]=k[e+4>>2];f=a+176|0;p[f>>3]=g;f=a+184|0;p[f>>3]=h;h=+p[i>>3];f=a+192|0;p[f>>3]=h;f=i+8|0;h=+p[f>>3];f=a+200|0;p[f>>3]=h;f=i+16|0;h=+p[f>>3];f=a+208|0;p[f>>3]=h;i=i+24|0;h=+p[i>>3];i=a+216|0;p[i>>3]=h;return}k[d>>2]=0;x1(b,k[c>>2]|0,0,0,0);if((k[d>>2]|0)<=0){f=a+176|0;p[f>>3]=g;f=a+184|0;p[f>>3]=h;h=+p[i>>3];f=a+192|0;p[f>>3]=h;f=i+8|0;h=+p[f>>3];f=a+200|0;p[f>>3]=h;f=i+16|0;h=+p[f>>3];f=a+208|0;p[f>>3]=h;i=i+24|0;h=+p[i>>3];i=a+216|0;p[i>>3]=h;return}m=k[f+40>>2]|0;l=k[l>>2]|0;j=k[f+44>>2]|0;c=k[n>>2]|0;b=0;do{k[l+(b<<2)>>2]=k[m+(b<<2)>>2];k[c+(b<<2)>>2]=k[j+(b<<2)>>2];b=b+1|0}while((b|0)<(k[d>>2]|0));f=a+176|0;p[f>>3]=g;f=a+184|0;p[f>>3]=h;h=+p[i>>3];f=a+192|0;p[f>>3]=h;f=i+8|0;h=+p[f>>3];f=a+200|0;p[f>>3]=h;f=i+16|0;h=+p[f>>3];f=a+208|0;p[f>>3]=h;i=i+24|0;h=+p[i>>3];i=a+216|0;p[i>>3]=h;return}function _$(a){a=a|0;ggb(a);return}function $$(a,b){a=a|0;b=b|0;return 0}function a0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+96|0;l=o+32|0;g=o+16|0;h=o;k[l>>2]=1124007936;n=l+4|0;a=l+8|0;m=l+40|0;e=n;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[m>>2]=a;j=l+48|0;i=l+44|0;k[i>>2]=j;k[l+52>>2]=0;k[j>>2]=0;if((d|0)!=-1?(k[b+8>>2]&4095|0)!=(d|0):0)a=l;else a=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b+8;f=h+4|0;e=f+4|0;k[e>>2]=0;k[e+4>>2]=0;k[h>>2]=33619968;k[f>>2]=a;+CZ(g,h,k[b+4>>2]|0);if((k[a+16>>2]|0)!=(k[c+16>>2]|0)){b=g+4|0;h=b+4|0;k[h>>2]=0;k[h+4>>2]=0;k[g>>2]=33619968;k[b>>2]=c;SW(a,g,d,1.0,0.0)}f=l+36|0;a=k[f>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[n>>2]|0)>0){e=k[m>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[i>>2]|0;if((a|0)==(j|0)|(a|0)==0){r=o;return}ggb(k[a+-4>>2]|0);r=o;return}function b0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+320|0;i=p+32|0;o=p+256|0;h=p;e=k[c>>2]|0;if(!((k[b>>2]|0)==47908&(e|0)==48028))if((a|0)==(e|0)){U$(e,b,c,d);r=p;return}else{dh[k[(k[e>>2]|0)+92>>2]&255](e,b,c,d);r=p;return}g=k[b+4>>2]|0;b=b+8|0;a=c+8|0;k[o>>2]=1124007936;m=o+4|0;e=o+8|0;j=o+40|0;c=m;f=c+36|0;do{k[c>>2]=0;c=c+4|0}while((c|0)<(f|0));k[j>>2]=e;n=o+48|0;l=o+44|0;k[l>>2]=n;k[o+52>>2]=0;k[n>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[h+28>>2]=0;Z$(i,48032,g,b,a,o,1.0,1.0,h);f=i;e=k[f+4>>2]|0;c=d;k[c>>2]=k[f>>2];k[c+4>>2]=e;KG(d+8|0,i+8|0)|0;KG(d+64|0,i+64|0)|0;KG(d+120|0,i+120|0)|0;c=d+176|0;e=i+176|0;f=c+48|0;do{k[c>>2]=k[e>>2];c=c+4|0;e=e+4|0}while((c|0)<(f|0));XN(i);b=o+36|0;e=k[b>>2]|0;if(e|0?(h=e+12|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0){a=k[b>>2]|0;if(a|0){e=k[a+4>>2]|0;if(!e){e=k[o+32>>2]|0;if(!e){e=B1()|0;a=k[b>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[b>>2]=0}k[b>>2]=0;o=o+16|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[m>>2]|0)>0){a=k[j>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[m>>2]|0))}e=k[l>>2]|0;if(!((e|0)==(n|0)|(e|0)==0))ggb(k[e+-4>>2]|0);r=p;return}function c0(a){a=a|0;ggb(a);return}function d0(a,b){a=a|0;b=b|0;return 0}function e0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+112|0;n=p+48|0;g=p+32|0;h=p+16|0;i=p;k[n>>2]=1124007936;o=n+4|0;a=n+8|0;l=n+40|0;e=o;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[l>>2]=a;m=n+48|0;j=n+44|0;k[j>>2]=m;k[n+52>>2]=0;k[m>>2]=0;if((d|0)!=-1?(k[b+8>>2]&4095|0)!=(d|0):0)a=n;else a=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b+8;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b+64;f=i+4|0;e=f+4|0;k[e>>2]=0;k[e+4>>2]=0;k[i>>2]=33619968;k[f>>2]=a;NZ(g,h,i,k[b+4>>2]|0)|0;if((k[a+16>>2]|0)!=(k[c+16>>2]|0)){b=g+4|0;i=b+4|0;k[i>>2]=0;k[i+4>>2]=0;k[g>>2]=33619968;k[b>>2]=c;SW(a,g,d,1.0,0.0)}f=n+36|0;a=k[f>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;n=n+16|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[o>>2]|0)>0){e=k[l>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[j>>2]|0;if((a|0)==(m|0)|(a|0)==0){r=p;return}ggb(k[a+-4>>2]|0);r=p;return}function f0(a){a=a|0;ggb(a);return}function g0(a,b){a=a|0;b=b|0;return 1}function h0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+16|0;j=l;h=b+8|0;if((d|0)!=-1?(e=k[h>>2]|0,(e&4095|0)!=(d|0)):0){if((e^d)&4088|0){a=j+4|0;b=ZT(40)|0;k[b>>2]=1;e=b+4|0;k[j>>2]=e;k[a>>2]=34;i[b+38>>0]=0;f=216566;g=e+34|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-215,j,216601,216608,1198);k[a>>2]=0;k[j>>2]=0;g=k[b>>2]|0;k[b>>2]=g+-1;if((g|0)==1)ggb(k[b+-4>>2]|0)}g=j+4|0;f=g+4|0;k[f>>2]=0;k[f+4>>2]=0;k[j>>2]=33619968;k[g>>2]=c;SW(h,j,d,1.0,0.0);r=l;return}KG(c,h)|0;r=l;return}function i0(a){a=a|0;ggb(a);return}function j0(a,b){a=a|0;b=b|0;return 0}function k0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0.0,u=0.0;s=r;r=r+128|0;o=s+64|0;g=s+48|0;h=s+32|0;i=s+16|0;j=s;k[o>>2]=1124007936;q=o+4|0;a=o+8|0;m=o+40|0;e=q;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[m>>2]=a;n=o+48|0;l=o+44|0;k[l>>2]=n;k[o+52>>2]=0;k[n>>2]=0;if((d|0)!=-1?(k[b+8>>2]&4095|0)!=(d|0):0)a=o;else a=c;k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b+8;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b+64;u=+p[b+176>>3];k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b+120;t=+p[b+184>>3];f=j+4|0;e=f+4|0;k[e>>2]=0;k[e+4>>2]=0;k[j>>2]=33619968;k[f>>2]=a;s_(g,h,u,i,t,j,k[b+4>>2]|0);if((k[a+16>>2]|0)!=(k[c+16>>2]|0)){b=g+4|0;j=b+4|0;k[j>>2]=0;k[j+4>>2]=0;k[g>>2]=33619968;k[b>>2]=c;SW(a,g,d,1.0,0.0)}f=o+36|0;a=k[f>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[o+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;o=o+16|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[q>>2]|0)>0){e=k[m>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[q>>2]|0))}a=k[l>>2]|0;if((a|0)==(n|0)|(a|0)==0){r=s;return}ggb(k[a+-4>>2]|0);r=s;return}function l0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+256|0;n=o+32|0;i=o;f=k[b>>2]|0;j=(f|0)==48028;e=k[c>>2]|0;l=(e|0)==48028;g=j?1.0:+p[b+176>>3];h=l?1.0:+p[c+176>>3];a:do if((f|0)==48276?((k[b+136>>2]|0)==0?1:+p[b+184>>3]==0.0):0){do if(!l){if((e|0)!=48272)if((e|0)==48268)break;else{m=13;break a}if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break a;if(!(+p[c+192>>3]==0.0))break a;if(!(+p[c+200>>3]==0.0))break a;if(!(+p[c+208>>3]==0.0))break a;if(!(+p[c+216>>3]==0.0))break a}while(0);a=((e|0)==48268?4:0)|k[b+4>>2]&-5;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;k[i+16>>2]=0;k[i+20>>2]=0;k[i+24>>2]=0;k[i+28>>2]=0;Z$(n,48276,a,b+8|0,b+64|0,c+8|0,g,h,i);a=n;f=k[a+4>>2]|0;e=d;k[e>>2]=k[a>>2];k[e+4>>2]=f;KG(d+8|0,n+8|0)|0;KG(d+64|0,n+64|0)|0;KG(d+120|0,n+120|0)|0;e=d+176|0;f=n+176|0;a=e+48|0;do{k[e>>2]=k[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(a|0));XN(n);r=o;return}else m=13;while(0);b:do if(((m|0)==13?(e|0)==48276:0)?((k[c+136>>2]|0)==0?1:+p[c+184>>3]==0.0):0){do if(!j){if((f|0)!=48272)if((f|0)==48268)break;else break b;if(k[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break b;if(!(+p[b+192>>3]==0.0))break b;if(!(+p[b+200>>3]==0.0))break b;if(!(+p[b+208>>3]==0.0))break b;if(!(+p[b+216>>3]==0.0))break b}while(0);a=((f|0)==48268?4:0)|k[c+4>>2]&-5;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;k[i+16>>2]=0;k[i+20>>2]=0;k[i+24>>2]=0;k[i+28>>2]=0;Z$(n,48276,a,c+8|0,c+64|0,b+8|0,h,g,i);a=n;f=k[a+4>>2]|0;e=d;k[e>>2]=k[a>>2];k[e+4>>2]=f;KG(d+8|0,n+8|0)|0;KG(d+64|0,n+64|0)|0;KG(d+120|0,n+120|0)|0;e=d+176|0;f=n+176|0;a=e+48|0;do{k[e>>2]=k[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(a|0));XN(n);r=o;return}while(0);if((a|0)==(e|0)){K$(e,b,c,d);r=o;return}else{dh[k[(k[e>>2]|0)+52>>2]&255](e,b,c,d);r=o;return}}function m0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0,j=0,l=0,m=0,n=0,o=0;o=r;r=r+256|0;n=o+32|0;i=o;f=k[b>>2]|0;j=(f|0)==48028;e=k[c>>2]|0;l=(e|0)==48028;g=j?1.0:+p[b+176>>3];h=l?1.0:+p[c+176>>3];a:do if((f|0)==48276?((k[b+136>>2]|0)==0?1:+p[b+184>>3]==0.0):0){do if(!l){if((e|0)!=48272)if((e|0)==48268)break;else{m=13;break a}if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break a;if(!(+p[c+192>>3]==0.0))break a;if(!(+p[c+200>>3]==0.0))break a;if(!(+p[c+208>>3]==0.0))break a;if(!(+p[c+216>>3]==0.0))break a}while(0);a=((e|0)==48268?4:0)|k[b+4>>2]&-5;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;k[i+16>>2]=0;k[i+20>>2]=0;k[i+24>>2]=0;k[i+28>>2]=0;Z$(n,48276,a,b+8|0,b+64|0,c+8|0,g,-h,i);a=n;f=k[a+4>>2]|0;e=d;k[e>>2]=k[a>>2];k[e+4>>2]=f;KG(d+8|0,n+8|0)|0;KG(d+64|0,n+64|0)|0;KG(d+120|0,n+120|0)|0;e=d+176|0;f=n+176|0;a=e+48|0;do{k[e>>2]=k[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(a|0));XN(n);r=o;return}else m=13;while(0);b:do if(((m|0)==13?(e|0)==48276:0)?((k[c+136>>2]|0)==0?1:+p[c+184>>3]==0.0):0){do if(!j){if((f|0)!=48272)if((f|0)==48268)break;else break b;if(k[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break b;if(!(+p[b+192>>3]==0.0))break b;if(!(+p[b+200>>3]==0.0))break b;if(!(+p[b+208>>3]==0.0))break b;if(!(+p[b+216>>3]==0.0))break b}while(0);a=((f|0)==48268?4:0)|k[c+4>>2]&-5;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;k[i+16>>2]=0;k[i+20>>2]=0;k[i+24>>2]=0;k[i+28>>2]=0;Z$(n,48276,a,c+8|0,c+64|0,b+8|0,-h,g,i);a=n;f=k[a+4>>2]|0;e=d;k[e>>2]=k[a>>2];k[e+4>>2]=f;KG(d+8|0,n+8|0)|0;KG(d+64|0,n+64|0)|0;KG(d+120|0,n+120|0)|0;e=d+176|0;f=n+176|0;a=e+48|0;do{k[e>>2]=k[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(a|0));XN(n);r=o;return}while(0);if((a|0)==(e|0)){M$(e,b,c,d);r=o;return}else{dh[k[(k[e>>2]|0)+60>>2]&255](e,b,c,d);r=o;return}}function n0(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0;a=b;f=k[a+4>>2]|0;e=d;k[e>>2]=k[a>>2];k[e+4>>2]=f;KG(d+8|0,b+8|0)|0;KG(d+64|0,b+64|0)|0;KG(d+120|0,b+120|0)|0;e=d+176|0;f=e;a=b+176|0;b=f+48|0;do{k[f>>2]=k[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(b|0));p[e>>3]=+p[e>>3]*c;d=d+184|0;p[d>>3]=+p[d>>3]*c;return}function o0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;e=b;d=k[e+4>>2]|0;a=c;k[a>>2]=k[e>>2];k[a+4>>2]=d;a=c+8|0;KG(a,b+8|0)|0;d=c+64|0;KG(d,b+64|0)|0;KG(c+120|0,b+120|0)|0;e=c+176|0;f=b+176|0;g=e+48|0;do{k[e>>2]=k[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(g|0));g=k[b+4>>2]|0;k[c+4>>2]=(g<<1&2|g&4|g>>>1&1)^7;g=k[a>>2]|0;k[a>>2]=k[d>>2];k[d>>2]=g;g=c+12|0;a=c+68|0;d=k[g>>2]|0;k[g>>2]=k[a>>2];k[a>>2]=d;a=c+16|0;d=c+72|0;g=k[a>>2]|0;k[a>>2]=k[d>>2];k[d>>2]=g;g=c+20|0;e=c+76|0;f=k[g>>2]|0;k[g>>2]=k[e>>2];k[e>>2]=f;e=c+24|0;f=c+80|0;g=k[e>>2]|0;k[e>>2]=k[f>>2];k[f>>2]=g;f=c+28|0;g=c+84|0;e=k[f>>2]|0;k[f>>2]=k[g>>2];k[g>>2]=e;g=c+32|0;e=c+88|0;f=k[g>>2]|0;k[g>>2]=k[e>>2];k[e>>2]=f;e=c+36|0;f=c+92|0;g=k[e>>2]|0;k[e>>2]=k[f>>2];k[f>>2]=g;f=c+40|0;g=c+96|0;e=k[f>>2]|0;k[f>>2]=k[g>>2];k[g>>2]=e;g=c+44|0;e=c+100|0;f=k[g>>2]|0;k[g>>2]=k[e>>2];k[e>>2]=f;e=c+48|0;f=c+104|0;g=k[e>>2]|0;k[e>>2]=k[f>>2];k[f>>2]=g;g=c+52|0;b=c+108|0;h=k[g>>2]|0;l=k[b>>2]|0;k[g>>2]=l;k[b>>2]=h;i=c+56|0;j=c+112|0;n=k[i>>2]|0;k[i>>2]=k[j>>2];k[j>>2]=n;n=c+60|0;c=c+116|0;m=k[n>>2]|0;k[n>>2]=k[c>>2];k[c>>2]=m;if((l|0)==(j|0)){k[g>>2]=i;k[e>>2]=a}if((h|0)!=(i|0))return;k[b>>2]=j;k[f>>2]=d;return}function p0(a){a=a|0;ggb(a);return}function q0(a,b){a=a|0;b=b|0;return 1}function r0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0.0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=r;r=r+128|0;o=y;w=y+72|0;q=y+56|0;s=y+40|0;n=y+24|0;k[w>>2]=1124007936;x=w+4|0;a=w+8|0;u=w+40|0;e=x;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[u>>2]=a;v=w+48|0;t=w+44|0;k[t>>2]=v;k[w+52>>2]=0;k[v>>2]=0;if((d|0)!=-1?(k[b+8>>2]&4095|0)!=(d|0):0)l=w;else l=c;f=b+64|0;j=b+192|0;a:do if(!(k[b+80>>2]|0)){do if((+p[b+200>>3]==0.0?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){g=+p[b+176>>3];if((k[l+16>>2]|0)==(k[c+16>>2]|0)?!(+P(+g)!=1.0):0)break;s=o+4|0;q=s+4|0;k[q>>2]=0;k[q+4>>2]=0;k[o>>2]=33619968;k[s>>2]=c;SW(b+8|0,o,d,g,+p[j>>3]);break a}while(0);g=+p[b+176>>3];if(g==1.0){k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=b+8;k[q>>2]=-1056833530;k[q+4>>2]=j;k[q+8>>2]=1;k[q+12>>2]=4;m=s+4|0;b=m+4|0;k[b>>2]=0;k[b+4>>2]=0;k[s>>2]=33619968;k[m>>2]=l;sU(o,q,s,49332,-1,39936,0,0);m=39;break}if(g==-1.0){k[o>>2]=-1056833530;k[o+4>>2]=j;k[o+8>>2]=1;k[o+12>>2]=4;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=b+8;m=s+4|0;b=m+4|0;k[b>>2]=0;k[b+4>>2]=0;k[s>>2]=33619968;k[m>>2]=l;sU(o,q,s,49332,-1,39968,0,0);m=39;break}else{m=b+8|0;b=o+4|0;n=b+4|0;k[n>>2]=0;k[n+4>>2]=0;k[o>>2]=33619968;k[b>>2]=l;SW(m,o,k[m>>2]&4095,g,0.0);k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=l;k[q>>2]=-1056833530;k[q+4>>2]=j;k[q+8>>2]=1;k[q+12>>2]=4;m=s+4|0;b=m+4|0;k[b>>2]=0;k[b+4>>2]=0;k[s>>2]=33619968;k[m>>2]=l;sU(o,q,s,49332,-1,39936,0,0);m=39;break}}else{g=+p[j>>3];e=b+200|0;a=+p[e>>3]==0.0;if(g==0.0&a?(h=+p[b+208>>3],h==0.0):0){if(+p[b+216>>3]!=0.0){i=h;m=10}}else m=8;if((m|0)==8?a:0){i=+p[b+208>>3];m=10}if(((m|0)==10?i==0.0:0)?+p[b+216>>3]==0.0:0){k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=b+8;h=+p[b+176>>3];k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=f;i=+p[b+184>>3];m=n+4|0;b=m+4|0;k[b>>2]=0;k[b+4>>2]=0;k[n>>2]=33619968;k[m>>2]=l;p[o>>3]=h;p[o+8>>3]=i;p[o+16>>3]=g;sU(q,s,n,49332,-1,40128,1,o);m=39;break}g=+p[b+176>>3];h=+p[b+184>>3];a=h==1.0;do if(g==1.0){if(a){k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=b+8;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=f;n=s+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[s>>2]=33619968;k[n>>2]=l;sU(o,q,s,49332,-1,39936,0,0);break}if(h==-1.0){k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=b+8;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=f;n=s+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[s>>2]=33619968;k[n>>2]=l;sU(o,q,s,49332,-1,39968,0,0);break}else{k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=f;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=b+8;n=s+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[s>>2]=33619968;k[n>>2]=l;W_(o,h,q,s);break}}else{if(!a){k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=b+8;k[s+8>>2]=0;k[s+12>>2]=0;k[s>>2]=16842752;k[s+4>>2]=f;m=n+4|0;d=m+4|0;k[d>>2]=0;k[d+4>>2]=0;k[n>>2]=33619968;k[m>>2]=l;p[o>>3]=g;p[o+8>>3]=h;p[o+16>>3]=0.0;sU(q,s,n,49332,-1,40128,1,o);break}if(g==-1.0){k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=f;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=b+8;n=s+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[s>>2]=33619968;k[n>>2]=l;sU(o,q,s,49332,-1,39968,0,0);break}else{k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=b+8;k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=f;n=s+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[s>>2]=33619968;k[n>>2]=l;W_(o,g,q,s);break}}while(0);if((+p[e>>3]==0.0?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){m=39;break}k[o+8>>2]=0;k[o+12>>2]=0;k[o>>2]=16842752;k[o+4>>2]=l;k[q>>2]=-1056833530;k[q+4>>2]=j;k[q+8>>2]=1;k[q+12>>2]=4;m=s+4|0;b=m+4|0;k[b>>2]=0;k[b+4>>2]=0;k[s>>2]=33619968;k[m>>2]=l;sU(o,q,s,49332,-1,39936,0,0);m=39}while(0);if((m|0)==39?(k[l+16>>2]|0)!=(k[c+16>>2]|0):0){b=o+4|0;s=b+4|0;k[s>>2]=0;k[s+4>>2]=0;k[o>>2]=33619968;k[b>>2]=c;SW(l,o,k[c>>2]&4095,1.0,0.0)}f=w+36|0;a=k[f>>2]|0;if(a|0?(b=a+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[w+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;w=w+16|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[x>>2]|0)>0){e=k[u>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[x>>2]|0))}a=k[t>>2]|0;if((a|0)==(v|0)|(a|0)==0){r=y;return}ggb(k[a+-4>>2]|0);r=y;return}function s0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;f=b;a=k[f+4>>2]|0;e=d;k[e>>2]=k[f>>2];k[e+4>>2]=a;KG(d+8|0,b+8|0)|0;KG(d+64|0,b+64|0)|0;KG(d+120|0,b+120|0)|0;e=d+176|0;a=b+176|0;b=e+48|0;do{k[e>>2]=k[a>>2];e=e+4|0;a=a+4|0}while((e|0)<(b|0));f=d+192|0;p[f>>3]=+p[c>>3]+ +p[f>>3];f=d+200|0;p[f>>3]=+p[c+8>>3]+ +p[f>>3];f=d+208|0;p[f>>3]=+p[c+16>>3]+ +p[f>>3];f=d+216|0;p[f>>3]=+p[c+24>>3]+ +p[f>>3];return}function t0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0.0;a=c;f=k[a+4>>2]|0;e=d;k[e>>2]=k[a>>2];k[e+4>>2]=f;KG(d+8|0,c+8|0)|0;KG(d+64|0,c+64|0)|0;KG(d+120|0,c+120|0)|0;e=d+176|0;f=e;a=c+176|0;c=f+48|0;do{k[f>>2]=k[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(c|0));p[e>>3]=-+p[e>>3];c=d+184|0;p[c>>3]=-+p[c>>3];c=d+192|0;e=d+200|0;i=+p[b+8>>3]-+p[e>>3];f=d+208|0;h=+p[b+16>>3]-+p[f>>3];d=d+216|0;g=+p[b+24>>3]-+p[d>>3];p[c>>3]=+p[b>>3]-+p[c>>3];p[e>>3]=i;p[f>>3]=h;p[d>>3]=g;return}function u0(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0;a=b;f=k[a+4>>2]|0;e=d;k[e>>2]=k[a>>2];k[e+4>>2]=f;KG(d+8|0,b+8|0)|0;KG(d+64|0,b+64|0)|0;KG(d+120|0,b+120|0)|0;e=d+176|0;f=e;a=b+176|0;b=f+48|0;do{k[f>>2]=k[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(b|0));p[e>>3]=+p[e>>3]*c;f=d+184|0;p[f>>3]=+p[f>>3]*c;f=d+192|0;p[f>>3]=+p[f>>3]*c;f=d+200|0;p[f>>3]=+p[f>>3]*c;f=d+208|0;p[f>>3]=+p[f>>3]*c;d=d+216|0;p[d>>3]=+p[d>>3]*c;return}function v0(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=r;r=r+64|0;l=n;do if((k[c>>2]|0)==48272){if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){g=c+8|0;k[l>>2]=1124007936;m=l+4|0;a=l+8|0;i=l+40|0;e=m;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[i>>2]=a;j=l+48|0;h=l+44|0;k[h>>2]=j;k[l+52>>2]=0;k[j>>2]=0;A0(d,47,g,l,b/+p[c+176>>3]);f=l+36|0;a=k[f>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[m>>2]|0)>0){e=k[i>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[h>>2]|0;if(!((a|0)==(j|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=n;return}}while(0);R$(0,b,c,d);r=n;return}function w0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0,i=0.0,j=0.0,l=0.0;h=r;r=r+32|0;e=h;f=b+64|0;g=(k[b+80>>2]|0)==0;if(!g?(d=+p[b+184>>3],!(d==0.0)):0){i=d;j=+p[b+176>>3];a=8}else a=4;do if((a|0)==4){d=+p[b+176>>3];if(+P(+d)==1.0){l=-(+p[b+200>>3]*d);i=-(+p[b+208>>3]*d);j=-(+p[b+216>>3]*d);p[e>>3]=-(+p[b+192>>3]*d);p[e+8>>3]=l;p[e+16>>3]=i;p[e+24>>3]=j;z0(c,b+8|0,e);r=h;return}else{if(g)break;i=+p[b+184>>3];j=d;a=8;break}}while(0);if((a|0)==8?j+i==0.0&j*i==-1.0:0){A0(c,97,b+8|0,f,1.0);r=h;return}S$(0,b,c);r=h;return}function x0(a,b,c){a=a|0;b=b|0;c=c|0;do if((k[b>>2]|0)==48272){if(k[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){y0(c,b+8|0,+p[b+176>>3]);return}}while(0);T$(0,b,c);return}function y0(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;u=r;r=r+368|0;f=u+32|0;o=u+312|0;l=u+256|0;e=u;k[o>>2]=1124007936;t=o+4|0;d=o+8|0;p=o+40|0;g=t;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[p>>2]=d;s=o+48|0;q=o+44|0;k[q>>2]=s;k[o+52>>2]=0;k[s>>2]=0;k[l>>2]=1124007936;m=l+4|0;d=l+8|0;i=l+40|0;g=m;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[i>>2]=d;n=l+48|0;j=l+44|0;k[j>>2]=n;k[l+52>>2]=0;k[n>>2]=0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;k[e+16>>2]=0;k[e+20>>2]=0;k[e+24>>2]=0;k[e+28>>2]=0;Z$(f,48268,0,b,o,l,c,0.0,e);h=f;d=k[h+4>>2]|0;g=a;k[g>>2]=k[h>>2];k[g+4>>2]=d;KG(a+8|0,f+8|0)|0;KG(a+64|0,f+64|0)|0;KG(a+120|0,f+120|0)|0;g=a+176|0;d=f+176|0;h=g+48|0;do{k[g>>2]=k[d>>2];g=g+4|0;d=d+4|0}while((g|0)<(h|0));XN(f);b=l+36|0;d=k[b>>2]|0;if(d|0?(g=d+12|0,h=k[g>>2]|0,k[g>>2]=h+-1,(h|0)==1):0){a=k[b>>2]|0;if(a|0){d=k[a+4>>2]|0;if(!d){d=k[l+32>>2]|0;if(!d){d=B1()|0;a=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,a)}k[b>>2]=0}k[b>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[m>>2]|0)>0){a=k[i>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[m>>2]|0))}d=k[j>>2]|0;if(!((d|0)==(n|0)|(d|0)==0))ggb(k[d+-4>>2]|0);b=o+36|0;d=k[b>>2]|0;if(d|0?(m=d+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){a=k[b>>2]|0;if(a|0){d=k[a+4>>2]|0;if(!d){d=k[o+32>>2]|0;if(!d){d=B1()|0;a=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,a)}k[b>>2]=0}k[b>>2]=0;o=o+16|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[t>>2]|0)>0){a=k[p>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[t>>2]|0))}d=k[q>>2]|0;if((d|0)==(s|0)|(d|0)==0){r=u;return}ggb(k[d+-4>>2]|0);r=u;return}function z0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+336|0;e=t;n=t+280|0;j=t+224|0;k[n>>2]=1124007936;q=n+4|0;d=n+8|0;o=n+40|0;f=q;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[o>>2]=d;s=n+48|0;p=n+44|0;k[p>>2]=s;k[n+52>>2]=0;k[s>>2]=0;k[j>>2]=1124007936;l=j+4|0;d=j+8|0;h=j+40|0;f=l;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[h>>2]=d;m=j+48|0;i=j+44|0;k[i>>2]=m;k[j+52>>2]=0;k[m>>2]=0;Z$(e,48512,97,b,n,j,1.0,0.0,c);g=e;d=k[g+4>>2]|0;f=a;k[f>>2]=k[g>>2];k[f+4>>2]=d;KG(a+8|0,e+8|0)|0;KG(a+64|0,e+64|0)|0;KG(a+120|0,e+120|0)|0;f=a+176|0;d=e+176|0;g=f+48|0;do{k[f>>2]=k[d>>2];f=f+4|0;d=d+4|0}while((f|0)<(g|0));XN(e);b=j+36|0;d=k[b>>2]|0;if(d|0?(f=d+12|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0){a=k[b>>2]|0;if(a|0){d=k[a+4>>2]|0;if(!d){d=k[j+32>>2]|0;if(!d){d=B1()|0;a=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,a)}k[b>>2]=0}k[b>>2]=0;j=j+16|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[l>>2]|0)>0){a=k[h>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[l>>2]|0))}d=k[i>>2]|0;if(!((d|0)==(m|0)|(d|0)==0))ggb(k[d+-4>>2]|0);b=n+36|0;d=k[b>>2]|0;if(d|0?(l=d+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){a=k[b>>2]|0;if(a|0){d=k[a+4>>2]|0;if(!d){d=k[n+32>>2]|0;if(!d){d=B1()|0;a=k[b>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,a)}k[b>>2]=0}k[b>>2]=0;n=n+16|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[q>>2]|0)>0){a=k[o>>2]|0;d=0;do{k[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[q>>2]|0))}d=k[p>>2]|0;if((d|0)==(s|0)|(d|0)==0){r=t;return}ggb(k[d+-4>>2]|0);r=t;return}function A0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+320|0;h=q+32|0;m=q+256|0;g=q;k[m>>2]=1124007936;p=m+4|0;f=m+8|0;l=m+40|0;i=p;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[l>>2]=f;o=m+48|0;n=m+44|0;k[n>>2]=o;k[m+52>>2]=0;k[o>>2]=0;j=k[d+16>>2]|0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g+16>>2]=0;k[g+20>>2]=0;k[g+24>>2]=0;k[g+28>>2]=0;Z$(h,48512,b<<24>>24,c,d,m,e,+((j|0)!=0&1),g);j=h;f=k[j+4>>2]|0;i=a;k[i>>2]=k[j>>2];k[i+4>>2]=f;KG(a+8|0,h+8|0)|0;KG(a+64|0,h+64|0)|0;KG(a+120|0,h+120|0)|0;i=a+176|0;f=h+176|0;j=i+48|0;do{k[i>>2]=k[f>>2];i=i+4|0;f=f+4|0}while((i|0)<(j|0));XN(h);b=m+36|0;f=k[b>>2]|0;if(f|0?(i=f+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){a=k[b>>2]|0;if(a|0){f=k[a+4>>2]|0;if(!f){f=k[m+32>>2]|0;if(!f){f=B1()|0;a=k[b>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,a)}k[b>>2]=0}k[b>>2]=0;m=m+16|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[p>>2]|0)>0){a=k[l>>2]|0;f=0;do{k[a+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[p>>2]|0))}f=k[n>>2]|0;if((f|0)==(o|0)|(f|0)==0){r=q;return}ggb(k[f+-4>>2]|0);r=q;return}function B0(a){a=a|0;ggb(a);return}function C0(a,b){a=a|0;b=b|0;return 1}function D0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0.0;v=r;r=r+128|0;l=v;e=v+104|0;f=v+88|0;q=v+32|0;g=v+16|0;k[q>>2]=1124007936;u=q+4|0;a=q+8|0;o=q+40|0;m=u;n=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(n|0));k[o>>2]=a;t=q+48|0;s=q+44|0;k[s>>2]=t;k[q+52>>2]=0;k[t>>2]=0;if((d|0)!=-1?(k[b+8>>2]&4095|0)!=(d|0):0)j=q;else j=c;a:do switch(k[b+4>>2]|0){case 42:{k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+8;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b+64;n=g+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[g>>2]=33619968;k[n>>2]=j;p[l>>3]=+p[b+176>>3];sU(e,f,g,49332,-1,40032,1,l);break}case 47:if(!(k[b+80>>2]|0)){w=+p[b+176>>3];k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+8;n=f+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[f>>2]=33619968;k[n>>2]=j;p[l>>3]=w;sU(e,e,f,49332,-1,40096,1,l);break a}else{k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+8;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b+64;n=g+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[g>>2]=33619968;k[n>>2]=j;p[l>>3]=+p[b+176>>3];sU(e,f,g,49332,-1,40064,1,l);break a}case 38:if(!(k[b+80>>2]|0)){k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+8;k[f>>2]=-1056833530;k[f+4>>2]=b+192;k[f+8>>2]=1;k[f+12>>2]=4;n=g+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[g>>2]=33619968;k[n>>2]=j;k[l>>2]=98;aU(e,f,g,49332,l,1,9);break a}else{k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+8;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b+64;n=g+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[g>>2]=33619968;k[n>>2]=j;k[l>>2]=98;aU(e,f,g,49332,l,1,9);break a}case 124:if(!(k[b+80>>2]|0)){k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+8;k[f>>2]=-1056833530;k[f+4>>2]=b+192;k[f+8>>2]=1;k[f+12>>2]=4;n=g+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[g>>2]=33619968;k[n>>2]=j;k[l>>2]=100;aU(e,f,g,49332,l,1,10);break a}else{k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+8;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b+64;n=g+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[g>>2]=33619968;k[n>>2]=j;k[l>>2]=100;aU(e,f,g,49332,l,1,10);break a}case 94:if(!(k[b+80>>2]|0)){k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+8;k[f>>2]=-1056833530;k[f+4>>2]=b+192;k[f+8>>2]=1;k[f+12>>2]=4;n=g+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[g>>2]=33619968;k[n>>2]=j;k[l>>2]=101;aU(e,f,g,49332,l,1,11);break a}else{k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+8;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b+64;n=g+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[g>>2]=33619968;k[n>>2]=j;k[l>>2]=101;aU(e,f,g,49332,l,1,11);break a}case 126:{if(!(k[b+80>>2]|0)){k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+8;n=f+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[f>>2]=33619968;k[n>>2]=j;k[l>>2]=99;aU(e,e,f,49332,l,1,12)}else h=27;break}case 109:{n=l+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=33619968;k[n>>2]=j;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+8;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b+64;aU(e,f,l,49332,39904,0,13);break}case 110:{k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=b+8;k[e>>2]=-1056833530;k[e+4>>2]=b+192;k[e+8>>2]=1;k[e+12>>2]=1;n=f+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[f>>2]=33619968;k[n>>2]=j;aU(l,e,f,49332,39904,0,13);break}case 77:{n=l+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=33619968;k[n>>2]=j;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+8;k[f+8>>2]=0;k[f+12>>2]=0;k[f>>2]=16842752;k[f+4>>2]=b+64;aU(e,f,l,49332,39872,0,14);break}case 78:{k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=b+8;k[e>>2]=-1056833530;k[e+4>>2]=b+192;k[e+8>>2]=1;k[e+12>>2]=1;n=f+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[f>>2]=33619968;k[n>>2]=j;aU(l,e,f,49332,39872,0,14);break}case 97:if(!(k[b+80>>2]|0)){k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=b+8;k[e>>2]=-1056833530;k[e+4>>2]=b+192;k[e+8>>2]=1;k[e+12>>2]=4;n=f+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[f>>2]=33619968;k[n>>2]=j;sU(l,e,f,49332,-1,4e4,0,0);break a}else{k[l+8>>2]=0;k[l+12>>2]=0;k[l>>2]=16842752;k[l+4>>2]=b+8;k[e+8>>2]=0;k[e+12>>2]=0;k[e>>2]=16842752;k[e+4>>2]=b+64;n=f+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[f>>2]=33619968;k[n>>2]=j;sU(l,e,f,49332,-1,4e4,0,0);break a}default:h=27}while(0);if((h|0)==27){k[l>>2]=0;a=l+4|0;k[a>>2]=0;e=ZT(24)|0;k[e>>2]=1;m=e+4|0;k[l>>2]=m;k[a>>2]=17;i[e+21>>0]=0;f=216732;n=m+17|0;do{i[m>>0]=i[f>>0]|0;m=m+1|0;f=f+1|0}while((m|0)<(n|0));Y8(-2,l,216601,216608,1356);k[a>>2]=0;k[l>>2]=0;n=k[e>>2]|0;k[e>>2]=n+-1;if((n|0)==1)ggb(k[e+-4>>2]|0)}if((k[j+16>>2]|0)!=(k[c+16>>2]|0)){n=l+4|0;m=n+4|0;k[m>>2]=0;k[m+4>>2]=0;k[l>>2]=33619968;k[n>>2]=c;SW(j,l,d,1.0,0.0)}f=q+36|0;a=k[f>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;q=q+16|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[u>>2]|0)>0){e=k[o>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[u>>2]|0))}a=k[s>>2]|0;if((a|0)==(t|0)|(a|0)==0){r=v;return}ggb(k[a+-4>>2]|0);r=v;return}function E0(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0;switch(k[b+4>>2]|0){case 47:case 42:{a=b;f=k[a+4>>2]|0;e=d;k[e>>2]=k[a>>2];k[e+4>>2]=f;KG(d+8|0,b+8|0)|0;KG(d+64|0,b+64|0)|0;KG(d+120|0,b+120|0)|0;e=d+176|0;f=e;a=b+176|0;d=f+48|0;do{k[f>>2]=k[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(d|0));p[e>>3]=+p[e>>3]*c;return}default:{P$(0,b,c,d);return}}}function F0(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0.0;n=r;r=r+96|0;l=n+32|0;g=n;do if((k[c+4>>2]|0)==47){if(k[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;k[l>>2]=1124007936;m=l+4|0;a=l+8|0;i=l+40|0;e=m;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[i>>2]=a;j=l+48|0;h=l+44|0;k[h>>2]=j;k[l+52>>2]=0;k[j>>2]=0;o=+p[c+176>>3];k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g+16>>2]=0;k[g+20>>2]=0;k[g+24>>2]=0;k[g+28>>2]=0;G0(d,c+8|0,l,b/o,0.0,g);f=l+36|0;a=k[f>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[l+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[m>>2]|0)>0){e=k[i>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[h>>2]|0;if(!((a|0)==(j|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=n;return}while(0);R$(0,b,c,d);r=n;return}function G0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+288|0;h=q;m=q+224|0;k[m>>2]=1124007936;p=m+4|0;g=m+8|0;l=m+40|0;i=p;j=i+36|0;do{k[i>>2]=0;i=i+4|0}while((i|0)<(j|0));k[l>>2]=g;o=m+48|0;n=m+44|0;k[n>>2]=o;k[m+52>>2]=0;k[o>>2]=0;Z$(h,48272,0,b,c,m,d,e,f);j=h;g=k[j+4>>2]|0;i=a;k[i>>2]=k[j>>2];k[i+4>>2]=g;KG(a+8|0,h+8|0)|0;KG(a+64|0,h+64|0)|0;KG(a+120|0,h+120|0)|0;i=a+176|0;g=h+176|0;j=i+48|0;do{k[i>>2]=k[g>>2];i=i+4|0;g=g+4|0}while((i|0)<(j|0));XN(h);b=m+36|0;g=k[b>>2]|0;if(g|0?(i=g+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){a=k[b>>2]|0;if(a|0){g=k[a+4>>2]|0;if(!g){g=k[m+32>>2]|0;if(!g){g=B1()|0;a=k[b>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,a)}k[b>>2]=0}k[b>>2]=0;m=m+16|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[p>>2]|0)>0){a=k[l>>2]|0;g=0;do{k[a+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[p>>2]|0))}g=k[n>>2]|0;if((g|0)==(o|0)|(g|0)==0){r=q;return}ggb(k[g+-4>>2]|0);r=q;return}function H0(a){a=a|0;ggb(a);return}function I0(a,b){a=a|0;b=b|0;return 0}function J0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0;q=r;r=r+96|0;m=q+32|0;i=q+16|0;h=q;k[m>>2]=1124007936;o=m+4|0;a=m+8|0;n=m+40|0;e=o;g=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(g|0));k[n>>2]=a;l=m+48|0;j=m+44|0;k[j>>2]=l;k[m+52>>2]=0;k[l>>2]=0;if((d|0)!=-1?(k[b+8>>2]&4095|0)!=(d|0):0)a=m;else a=c;k[i+8>>2]=0;k[i+12>>2]=0;k[i>>2]=16842752;k[i+4>>2]=b+8;g=h+4|0;e=g+4|0;k[e>>2]=0;k[e+4>>2]=0;k[h>>2]=33619968;k[g>>2]=a;$1(i,h);f=+p[b+176>>3];if(f!=1.0?1:(k[a+16>>2]|0)!=(k[c+16>>2]|0)){b=i+4|0;h=b+4|0;k[h>>2]=0;k[h+4>>2]=0;k[i>>2]=33619968;k[b>>2]=c;SW(a,i,d,f,0.0)}g=m+36|0;a=k[g>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){e=k[g>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[m+32>>2]|0;if(!a){a=B1()|0;e=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[g>>2]=0}k[g>>2]=0;m=m+16|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[o>>2]|0)>0){e=k[n>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[j>>2]|0;if((a|0)==(l|0)|(a|0)==0){r=q;return}ggb(k[a+-4>>2]|0);r=q;return}function K0(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0;a=b;f=k[a+4>>2]|0;e=d;k[e>>2]=k[a>>2];k[e+4>>2]=f;KG(d+8|0,b+8|0)|0;KG(d+64|0,b+64|0)|0;KG(d+120|0,b+120|0)|0;e=d+176|0;f=e;a=b+176|0;d=f+48|0;do{k[f>>2]=k[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(d|0));p[e>>3]=+p[e>>3]*c;return}function L0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+368|0;n=v+88|0;u=v+32|0;m=v+312|0;d=v;e=+p[b+176>>3];j=b+8|0;if(!(e==1.0)){k[n>>2]=1124007936;i=n+4|0;a=n+8|0;g=n+40|0;b=i;f=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(f|0));k[g>>2]=a;h=n+48|0;f=n+44|0;k[f>>2]=h;k[n+52>>2]=0;k[h>>2]=0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;k[u+16>>2]=0;k[u+20>>2]=0;k[u+24>>2]=0;k[u+28>>2]=0;G0(c,j,n,e,0.0,u);d=n+36|0;a=k[d>>2]|0;if(a|0?(t=a+12|0,u=k[t>>2]|0,k[t>>2]=u+-1,(u|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;u=n+16|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[i>>2]|0)>0){b=k[g>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[i>>2]|0))}a=k[f>>2]|0;if(!((a|0)==(h|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=v;return}k[u>>2]=1124007936;s=u+4|0;a=u+8|0;o=u+40|0;b=s;f=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(f|0));k[o>>2]=a;t=u+48|0;q=u+44|0;k[q>>2]=t;k[u+52>>2]=0;k[t>>2]=0;k[m>>2]=1124007936;i=m+4|0;a=m+8|0;g=m+40|0;b=i;f=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(f|0));k[g>>2]=a;l=m+48|0;h=m+44|0;k[h>>2]=l;k[m+52>>2]=0;k[l>>2]=0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;k[d+16>>2]=0;k[d+20>>2]=0;k[d+24>>2]=0;k[d+28>>2]=0;Z$(n,48028,0,j,u,m,1.0,0.0,d);f=n;a=k[f+4>>2]|0;b=c;k[b>>2]=k[f>>2];k[b+4>>2]=a;KG(c+8|0,n+8|0)|0;KG(c+64|0,n+64|0)|0;KG(c+120|0,n+120|0)|0;b=c+176|0;a=n+176|0;f=b+48|0;do{k[b>>2]=k[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(f|0));XN(n);d=m+36|0;a=k[d>>2]|0;if(a|0?(c=a+12|0,n=k[c>>2]|0,k[c>>2]=n+-1,(n|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[m+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;n=m+16|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[i>>2]|0)>0){b=k[g>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[i>>2]|0))}a=k[h>>2]|0;if(!((a|0)==(l|0)|(a|0)==0))ggb(k[a+-4>>2]|0);d=u+36|0;a=k[d>>2]|0;if(a|0?(m=a+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){b=k[d>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[u+32>>2]|0;if(!a){a=B1()|0;b=k[d>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[d>>2]=0}k[d>>2]=0;u=u+16|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[s>>2]|0)>0){b=k[o>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[s>>2]|0))}a=k[q>>2]|0;if(!((a|0)==(t|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=v;return}function M0(a){a=a|0;ggb(a);return}function N0(a,b){a=a|0;b=b|0;return 1}function O0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+112|0;n=p+48|0;g=p+32|0;h=p+16|0;i=p;k[n>>2]=1124007936;o=n+4|0;a=n+8|0;l=n+40|0;e=o;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[l>>2]=a;m=n+48|0;j=n+44|0;k[j>>2]=m;k[n+52>>2]=0;k[m>>2]=0;a=(d|0)==-1|(d|0)==0?c:n;if(!(k[b+80>>2]|0)){k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b+8;k[h>>2]=-1056833530;k[h+4>>2]=b+176;k[h+8>>2]=1;k[h+12>>2]=1;f=i+4|0;e=f+4|0;k[e>>2]=0;k[e+4>>2]=0;k[i>>2]=33619968;k[f>>2]=a;oV(g,h,i,k[b+4>>2]|0)}else{k[g+8>>2]=0;k[g+12>>2]=0;k[g>>2]=16842752;k[g+4>>2]=b+8;k[h+8>>2]=0;k[h+12>>2]=0;k[h>>2]=16842752;k[h+4>>2]=b+64;f=i+4|0;e=f+4|0;k[e>>2]=0;k[e+4>>2]=0;k[i>>2]=33619968;k[f>>2]=a;oV(g,h,i,k[b+4>>2]|0)}if((k[a+16>>2]|0)!=(k[c+16>>2]|0)){b=g+4|0;i=b+4|0;k[i>>2]=0;k[i+4>>2]=0;k[g>>2]=33619968;k[b>>2]=c;SW(a,g,d,1.0,0.0)}f=n+36|0;a=k[f>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){e=k[f>>2]|0;if(e|0){a=k[e+4>>2]|0;if(!a){a=k[n+32>>2]|0;if(!a){a=B1()|0;e=k[f>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,e)}k[f>>2]=0}k[f>>2]=0;n=n+16|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[o>>2]|0)>0){e=k[l>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[j>>2]|0;if((a|0)==(m|0)|(a|0)==0){r=p;return}ggb(k[a+-4>>2]|0);r=p;return}function P0(a){a=a|0;ggb(a);return}function Q0(a,b){a=a|0;b=b|0;return 0}function R0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0;l=r;r=r+64|0;j=l+32|0;h=l;e=(d|0)==-1?k[b+8>>2]&4095:d;g=b+12|0;a=k[g>>2]|0;d=k[b+48>>2]|0;do if((a|0)<3){f=k[d+4>>2]|0;d=k[d>>2]|0;a=e&4095;if(((((k[c+4>>2]|0)<3?(k[c+8>>2]|0)==(d|0):0)?(k[c+12>>2]|0)==(f|0):0)?(k[c>>2]&4095|0)==(a|0):0)?k[c+16>>2]|0:0)break;k[j>>2]=d;k[j+4>>2]=f;G1(c,2,j,a)}else G1(c,a,d,e);while(0);a=k[b+4>>2]|0;if((a|0)==73&(k[g>>2]|0)<3){g=j+4|0;f=g+4|0;k[f>>2]=0;k[f+4>>2]=0;k[j>>2]=50397184;k[g>>2]=c;p[h>>3]=+p[b+176>>3];c=h+8|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;k[c+16>>2]=0;k[c+20>>2]=0;R2(j,h);r=l;return}switch(a|0){case 48:{k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;k[j+20>>2]=0;k[j+24>>2]=0;k[j+28>>2]=0;oY(c,j);r=l;return}case 49:{p[j>>3]=+p[b+176>>3];b=j+8|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[b+16>>2]=0;k[b+20>>2]=0;oY(c,j);r=l;return}default:{a=j+4|0;d=ZT(36)|0;k[d>>2]=1;e=d+4|0;k[j>>2]=e;k[a>>2]=31;i[d+35>>0]=0;f=216827;g=e+31|0;do{i[e>>0]=i[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(g|0));Y8(-2,j,216601,216608,1575);k[a>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0);r=l;return}}}function S0(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0;a=b;f=k[a+4>>2]|0;e=d;k[e>>2]=k[a>>2];k[e+4>>2]=f;KG(d+8|0,b+8|0)|0;KG(d+64|0,b+64|0)|0;KG(d+120|0,b+120|0)|0;e=d+176|0;f=e;a=b+176|0;d=f+48|0;do{k[f>>2]=k[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(d|0));p[e>>3]=+p[e>>3]*c;return}function T0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;k[a>>2]=48028;k[a+4>>2]=0;c=a+8|0;k[c>>2]=k[b>>2];i=a+12|0;e=b+4|0;k[i>>2]=k[e>>2];g=a+16|0;k[g>>2]=k[b+8>>2];k[a+20>>2]=k[b+12>>2];k[a+24>>2]=k[b+16>>2];k[a+28>>2]=k[b+20>>2];k[a+32>>2]=k[b+24>>2];k[a+36>>2]=k[b+28>>2];k[a+40>>2]=k[b+32>>2];d=k[b+36>>2]|0;k[a+44>>2]=d;f=a+48|0;k[f>>2]=g;g=a+56|0;h=a+52|0;k[h>>2]=g;k[a+60>>2]=0;k[g>>2]=0;if(d|0){g=d+12|0;k[g>>2]=(k[g>>2]|0)+1}if((k[e>>2]|0)>=3){k[i>>2]=0;x1(c,k[e>>2]|0,0,0,0);if((k[i>>2]|0)>0){g=k[b+40>>2]|0;f=k[f>>2]|0;e=k[b+44>>2]|0;d=k[h>>2]|0;c=0;do{k[f+(c<<2)>>2]=k[g+(c<<2)>>2];k[d+(c<<2)>>2]=k[e+(c<<2)>>2];c=c+1|0}while((c|0)<(k[i>>2]|0))}}else{g=k[b+44>>2]|0;i=k[h>>2]|0;k[i>>2]=k[g>>2];k[i+4>>2]=k[g+4>>2]}k[a+64>>2]=1124007936;c=a+72|0;d=a+104|0;e=a+68|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;c=a+112|0;k[a+108>>2]=c;k[a+116>>2]=0;k[c>>2]=0;k[a+120>>2]=1124007936;c=a+128|0;d=a+160|0;e=a+124|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;e=a+168|0;k[a+164>>2]=e;k[a+172>>2]=0;k[e>>2]=0;p[a+176>>3]=1.0;e=a+184|0;f=e+40|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));return}function U0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=r;r=r+64|0;l=m;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;f=a+12|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;f=a+68|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;f=a+124|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;f=a+168|0;k[a+164>>2]=f;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[l>>2]=1124007936;j=l+4|0;d=l+8|0;h=l+40|0;f=j;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[h>>2]=d;i=l+48|0;g=l+44|0;k[g>>2]=i;k[l+52>>2]=0;k[i>>2]=0;G0(a,b,l,1.0,0.0,c);f=l+36|0;d=k[f>>2]|0;if(d|0?(b=d+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[l+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[j>>2]|0)>0){e=k[h>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[g>>2]|0;if((d|0)==(i|0)|(d|0)==0){r=m;return}ggb(k[d+-4>>2]|0);r=m;return}function V0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=r;r=r+64|0;l=m;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;f=a+12|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;f=a+68|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;f=a+124|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;f=a+168|0;k[a+164>>2]=f;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[l>>2]=1124007936;j=l+4|0;d=l+8|0;h=l+40|0;f=j;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[h>>2]=d;i=l+48|0;g=l+44|0;k[g>>2]=i;k[l+52>>2]=0;k[i>>2]=0;G0(a,c,l,1.0,0.0,b);f=l+36|0;d=k[f>>2]|0;if(d|0?(b=d+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[l+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[j>>2]|0)>0){e=k[h>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[g>>2]|0;if((d|0)==(i|0)|(d|0)==0){r=m;return}ggb(k[d+-4>>2]|0);r=m;return}function W0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=r;r=r+224|0;f=h;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;g=a+168|0;k[a+164>>2]=g;i=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));i=k[b>>2]|0;g=k[(k[i>>2]|0)+52>>2]|0;T0(f,c);dh[g&255](i,b,f,a);XN(f);r=h;return}function X0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=r;r=r+224|0;f=h;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;g=a+168|0;k[a+164>>2]=g;i=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));i=k[c>>2]|0;g=k[(k[i>>2]|0)+52>>2]|0;T0(f,b);dh[g&255](i,c,f,a);XN(f);r=h;return}function Y0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0.0,q=0.0,s=0.0;n=r;r=r+96|0;m=n+32|0;h=n;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;f=a+12|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;f=a+68|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;f=a+124|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;f=a+168|0;k[a+164>>2]=f;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[m>>2]=1124007936;l=m+4|0;d=m+8|0;i=m+40|0;f=l;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[i>>2]=d;j=m+48|0;g=m+44|0;k[g>>2]=j;k[m+52>>2]=0;k[j>>2]=0;s=-+p[c+8>>3];q=-+p[c+16>>3];o=-+p[c+24>>3];p[h>>3]=-+p[c>>3];p[h+8>>3]=s;p[h+16>>3]=q;p[h+24>>3]=o;G0(a,b,m,1.0,0.0,h);f=m+36|0;d=k[f>>2]|0;if(d|0?(c=d+12|0,h=k[c>>2]|0,k[c>>2]=h+-1,(h|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[m+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;m=m+16|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[l>>2]|0)>0){e=k[i>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[l>>2]|0))}d=k[g>>2]|0;if((d|0)==(j|0)|(d|0)==0){r=n;return}ggb(k[d+-4>>2]|0);r=n;return}function Z0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=r;r=r+64|0;l=m;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;f=a+12|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;f=a+68|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;f=a+124|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;f=a+168|0;k[a+164>>2]=f;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[l>>2]=1124007936;j=l+4|0;d=l+8|0;h=l+40|0;f=j;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[h>>2]=d;i=l+48|0;g=l+44|0;k[g>>2]=i;k[l+52>>2]=0;k[i>>2]=0;G0(a,c,l,-1.0,0.0,b);f=l+36|0;d=k[f>>2]|0;if(d|0?(b=d+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[l+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[j>>2]|0)>0){e=k[h>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[j>>2]|0))}d=k[g>>2]|0;if((d|0)==(i|0)|(d|0)==0){r=m;return}ggb(k[d+-4>>2]|0);r=m;return}function _0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=r;r=r+224|0;f=h;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;g=a+168|0;k[a+164>>2]=g;i=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));i=k[c>>2]|0;g=k[(k[i>>2]|0)+60>>2]|0;T0(f,b);dh[g&255](i,f,c,a);XN(f);r=h;return}function $0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=r;r=r+96|0;l=m+32|0;g=m;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;c=a+16|0;d=a+48|0;e=a+12|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;c=a+56|0;k[a+52>>2]=c;k[a+60>>2]=0;k[c>>2]=0;k[a+64>>2]=1124007936;c=a+72|0;d=a+104|0;e=a+68|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;c=a+112|0;k[a+108>>2]=c;k[a+116>>2]=0;k[c>>2]=0;k[a+120>>2]=1124007936;c=a+128|0;d=a+160|0;e=a+124|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;e=a+168|0;k[a+164>>2]=e;f=e+56|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[l>>2]=1124007936;j=l+4|0;c=l+8|0;h=l+40|0;e=j;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[h>>2]=c;i=l+48|0;f=l+44|0;k[f>>2]=i;k[l+52>>2]=0;k[i>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;k[g+16>>2]=0;k[g+20>>2]=0;k[g+24>>2]=0;k[g+28>>2]=0;G0(a,b,l,-1.0,0.0,g);e=l+36|0;c=k[e>>2]|0;if(c|0?(b=c+12|0,g=k[b>>2]|0,k[b>>2]=g+-1,(g|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[l+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;l=l+16|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[j>>2]|0)>0){d=k[h>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[j>>2]|0))}c=k[f>>2]|0;if((c|0)==(i|0)|(c|0)==0){r=m;return}ggb(k[c+-4>>2]|0);r=m;return}function a1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+320|0;g=p+32|0;f=p;o=p+256|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;e=a+16|0;d=a+48|0;h=a+12|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[d>>2]=e;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;h=a+68|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;h=a+124|0;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[e>>2]=d;h=a+168|0;k[a+164>>2]=h;i=h+56|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[o>>2]=1124007936;m=o+4|0;d=o+8|0;j=o+40|0;h=m;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[j>>2]=d;n=o+48|0;l=o+44|0;k[l>>2]=n;k[o+52>>2]=0;k[n>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[f+28>>2]=0;Z$(g,48276,0,b,c,o,1.0,1.0,f);i=g;d=k[i+4>>2]|0;h=a;k[h>>2]=k[i>>2];k[h+4>>2]=d;KG(a+8|0,g+8|0)|0;KG(a+64|0,g+64|0)|0;KG(a+120|0,g+120|0)|0;h=a+176|0;d=g+176|0;i=h+48|0;do{k[h>>2]=k[d>>2];h=h+4|0;d=d+4|0}while((h|0)<(i|0));XN(g);a=o+36|0;d=k[a>>2]|0;if(d|0?(h=d+12|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0){e=k[a>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[o+32>>2]|0;if(!d){d=B1()|0;e=k[a>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[a>>2]=0}k[a>>2]=0;o=o+16|0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[m>>2]|0)>0){e=k[j>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[m>>2]|0))}d=k[l>>2]|0;if((d|0)==(n|0)|(d|0)==0){r=p;return}ggb(k[d+-4>>2]|0);r=p;return}function b1(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=r;r=r+96|0;m=n+32|0;h=n;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;f=a+12|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;f=a+68|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;f=a+124|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;f=a+168|0;k[a+164>>2]=f;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[m>>2]=1124007936;l=m+4|0;d=m+8|0;i=m+40|0;f=l;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[i>>2]=d;j=m+48|0;g=m+44|0;k[g>>2]=j;k[m+52>>2]=0;k[j>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[h+28>>2]=0;G0(a,b,m,c,0.0,h);f=m+36|0;d=k[f>>2]|0;if(d|0?(b=d+12|0,h=k[b>>2]|0,k[b>>2]=h+-1,(h|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[m+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;m=m+16|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[l>>2]|0)>0){e=k[i>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[l>>2]|0))}d=k[g>>2]|0;if((d|0)==(j|0)|(d|0)==0){r=n;return}ggb(k[d+-4>>2]|0);r=n;return}function c1(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=r;r=r+96|0;m=n+32|0;h=n;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;f=a+12|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;f=a+68|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;f=a+124|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;f=a+168|0;k[a+164>>2]=f;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[m>>2]=1124007936;l=m+4|0;d=m+8|0;i=m+40|0;f=l;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[i>>2]=d;j=m+48|0;g=m+44|0;k[g>>2]=j;k[m+52>>2]=0;k[j>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[h+28>>2]=0;G0(a,c,m,b,0.0,h);f=m+36|0;d=k[f>>2]|0;if(d|0?(c=d+12|0,h=k[c>>2]|0,k[c>>2]=h+-1,(h|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[m+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;m=m+16|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[l>>2]|0)>0){e=k[i>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[l>>2]|0))}d=k[g>>2]|0;if((d|0)==(j|0)|(d|0)==0){r=n;return}ggb(k[d+-4>>2]|0);r=n;return}function d1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=r;r=r+224|0;f=h;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;g=a+168|0;k[a+164>>2]=g;i=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));i=k[b>>2]|0;g=k[(k[i>>2]|0)+92>>2]|0;T0(f,c);dh[g&255](i,b,f,a);XN(f);r=h;return}function e1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=r;r=r+224|0;f=h;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;i=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));k[e>>2]=d;g=a+168|0;k[a+164>>2]=g;i=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(i|0));i=k[c>>2]|0;g=k[(k[i>>2]|0)+92>>2]|0;T0(f,b);dh[g&255](i,f,c,a);XN(f);r=h;return}function f1(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=r;r=r+96|0;m=n+32|0;h=n;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;f=a+12|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+56|0;k[a+52>>2]=d;k[a+60>>2]=0;k[d>>2]=0;k[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;f=a+68|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;d=a+112|0;k[a+108>>2]=d;k[a+116>>2]=0;k[d>>2]=0;k[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;f=a+124|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[e>>2]=d;f=a+168|0;k[a+164>>2]=f;g=f+56|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[m>>2]=1124007936;l=m+4|0;d=m+8|0;i=m+40|0;f=l;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[i>>2]=d;j=m+48|0;g=m+44|0;k[g>>2]=j;k[m+52>>2]=0;k[j>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[h+28>>2]=0;G0(a,b,m,1.0/c,0.0,h);f=m+36|0;d=k[f>>2]|0;if(d|0?(b=d+12|0,h=k[b>>2]|0,k[b>>2]=h+-1,(h|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[m+32>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;m=m+16|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[l>>2]|0)>0){e=k[i>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[l>>2]|0))}d=k[g>>2]|0;if((d|0)==(j|0)|(d|0)==0){r=n;return}ggb(k[d+-4>>2]|0);r=n;return}function g1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;l=r;r=r+64|0;j=l;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;c=a+16|0;d=a+48|0;e=a+12|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;c=a+56|0;k[a+52>>2]=c;k[a+60>>2]=0;k[c>>2]=0;k[a+64>>2]=1124007936;c=a+72|0;d=a+104|0;e=a+68|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;c=a+112|0;k[a+108>>2]=c;k[a+116>>2]=0;k[c>>2]=0;k[a+120>>2]=1124007936;c=a+128|0;d=a+160|0;e=a+124|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;e=a+168|0;k[a+164>>2]=e;f=e+56|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[j>>2]=1124007936;i=j+4|0;c=j+8|0;g=j+40|0;e=i;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[g>>2]=c;h=j+48|0;f=j+44|0;k[f>>2]=h;k[j+52>>2]=0;k[h>>2]=0;A0(a,47,b,j,1.0);e=j+36|0;c=k[e>>2]|0;if(c|0?(a=c+12|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[j+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;j=j+16|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[i>>2]|0)>0){d=k[g>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[i>>2]|0))}c=k[f>>2]|0;if((c|0)==(h|0)|(c|0)==0){r=l;return}ggb(k[c+-4>>2]|0);r=l;return}function h1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+368|0;g=v+32|0;q=v+312|0;m=v+256|0;f=v;k[q>>2]=1124007936;u=q+4|0;e=q+8|0;p=q+40|0;h=u;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[p>>2]=e;t=q+48|0;s=q+44|0;k[s>>2]=t;k[q+52>>2]=0;k[t>>2]=0;k[m>>2]=1124007936;n=m+4|0;e=m+8|0;j=m+40|0;h=n;i=h+36|0;do{k[h>>2]=0;h=h+4|0}while((h|0)<(i|0));k[j>>2]=e;o=m+48|0;l=m+44|0;k[l>>2]=o;k[m+52>>2]=0;k[o>>2]=0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;k[f+16>>2]=0;k[f+20>>2]=0;k[f+24>>2]=0;k[f+28>>2]=0;Z$(g,48980,b,c,q,m,d,1.0,f);i=g;e=k[i+4>>2]|0;h=a;k[h>>2]=k[i>>2];k[h+4>>2]=e;KG(a+8|0,g+8|0)|0;KG(a+64|0,g+64|0)|0;KG(a+120|0,g+120|0)|0;h=a+176|0;e=g+176|0;i=h+48|0;do{k[h>>2]=k[e>>2];h=h+4|0;e=e+4|0}while((h|0)<(i|0));XN(g);b=m+36|0;e=k[b>>2]|0;if(e|0?(h=e+12|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0){a=k[b>>2]|0;if(a|0){e=k[a+4>>2]|0;if(!e){e=k[m+32>>2]|0;if(!e){e=B1()|0;a=k[b>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[b>>2]=0}k[b>>2]=0;m=m+16|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[n>>2]|0)>0){a=k[j>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[n>>2]|0))}e=k[l>>2]|0;if(!((e|0)==(o|0)|(e|0)==0))ggb(k[e+-4>>2]|0);b=q+36|0;e=k[b>>2]|0;if(e|0?(n=e+12|0,o=k[n>>2]|0,k[n>>2]=o+-1,(o|0)==1):0){a=k[b>>2]|0;if(a|0){e=k[a+4>>2]|0;if(!e){e=k[q+32>>2]|0;if(!e){e=B1()|0;a=k[b>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[b>>2]=0}k[b>>2]=0;q=q+16|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[u>>2]|0)>0){a=k[p>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[u>>2]|0))}e=k[s>>2]|0;if((e|0)==(t|0)|(e|0)==0){r=v;return}ggb(k[e+-4>>2]|0);r=v;return}function i1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;n=r;r=r+224|0;m=n;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=1124007936;e=a+16|0;f=a+48|0;g=a+12|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[f>>2]=e;e=a+56|0;k[a+52>>2]=e;k[a+60>>2]=0;k[e>>2]=0;k[a+64>>2]=1124007936;e=a+72|0;f=a+104|0;g=a+68|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[f>>2]=e;e=a+112|0;k[a+108>>2]=e;k[a+116>>2]=0;k[e>>2]=0;k[a+120>>2]=1124007936;e=a+128|0;f=a+160|0;g=a+124|0;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[f>>2]=e;g=a+168|0;k[a+164>>2]=g;h=g+56|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));e=k[c>>2]&2031616;if((e|0)==393216){l=k[c+4>>2]|0;j=k[l>>2]|0;i=k[(k[j>>2]|0)+68>>2]|0;T0(m,b);kh[i&7](j,m,l,a,d);XN(m);r=n;return}do if((e|0)==65536){h=k[c+4>>2]|0;k[m>>2]=k[h>>2];l=m+4|0;e=h+4|0;k[l>>2]=k[e>>2];j=m+8|0;k[j>>2]=k[h+8>>2];k[m+12>>2]=k[h+12>>2];k[m+16>>2]=k[h+16>>2];k[m+20>>2]=k[h+20>>2];k[m+24>>2]=k[h+24>>2];k[m+28>>2]=k[h+28>>2];k[m+32>>2]=k[h+32>>2];f=k[h+36>>2]|0;k[m+36>>2]=f;g=m+40|0;k[g>>2]=j;j=m+48|0;i=m+44|0;k[i>>2]=j;k[m+52>>2]=0;k[j>>2]=0;if(f|0){j=f+12|0;k[j>>2]=(k[j>>2]|0)+1}if((k[e>>2]|0)<3){j=k[h+44>>2]|0;l=k[i>>2]|0;k[l>>2]=k[j>>2];k[l+4>>2]=k[j+4>>2];break}k[l>>2]=0;x1(m,k[e>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[h+40>>2]|0;c=k[g>>2]|0;g=k[h+44>>2]|0;f=k[i>>2]|0;e=0;do{k[c+(e<<2)>>2]=k[j+(e<<2)>>2];k[f+(e<<2)>>2]=k[g+(e<<2)>>2];e=e+1|0}while((e|0)<(k[l>>2]|0))}}else Q1(m,c,-1);while(0);A0(a,42,b,m,d);g=m+36|0;e=k[g>>2]|0;if(e|0?(a=e+12|0,b=k[a>>2]|0,k[a>>2]=b+-1,(b|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[m+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;b=m+16|0;f=m+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[f>>2]|0)>0){g=k[m+40>>2]|0;e=0;do{k[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[m+44>>2]|0;if(!((e|0)==(m+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0);r=n;return}function j1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0;v=r;r=r+432|0;j=v+32|0;u=v+376|0;g=v+312|0;t=v+320|0;n=v+256|0;i=v;if(!(k[107189]|0)){f=b9()|0;mpb(k[f>>2]|0)|0;if(!(k[107189]|0)){while(1){e=fgb(4)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}k[e>>2]=48872;k[107189]=e}lpb(k[f>>2]|0)|0}h=k[107189]|0;k[g>>2]=k[c>>2];k[g+4>>2]=k[c+4>>2];YN(u,g,d,-286331154,0);k[t>>2]=1124007936;q=t+4|0;e=t+8|0;o=t+40|0;f=q;c=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(c|0));k[o>>2]=e;s=t+48|0;p=t+44|0;k[p>>2]=s;k[t+52>>2]=0;k[s>>2]=0;k[n>>2]=1124007936;l=n+4|0;e=n+8|0;d=n+40|0;f=l;c=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(c|0));k[d>>2]=e;m=n+48|0;g=n+44|0;k[g>>2]=m;k[n+52>>2]=0;k[m>>2]=0;k[i>>2]=0;k[i+4>>2]=0;k[i+8>>2]=0;k[i+12>>2]=0;k[i+16>>2]=0;k[i+20>>2]=0;k[i+24>>2]=0;k[i+28>>2]=0;Z$(j,h,b,u,t,n,1.0,0.0,i);c=j;e=k[c+4>>2]|0;f=a;k[f>>2]=k[c>>2];k[f+4>>2]=e;KG(a+8|0,j+8|0)|0;KG(a+64|0,j+64|0)|0;KG(a+120|0,j+120|0)|0;f=a+176|0;e=j+176|0;c=f+48|0;do{k[f>>2]=k[e>>2];f=f+4|0;e=e+4|0}while((f|0)<(c|0));XN(j);c=n+36|0;e=k[c>>2]|0;if(e|0?(i=e+12|0,j=k[i>>2]|0,k[i>>2]=j+-1,(j|0)==1):0){f=k[c>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[n+32>>2]|0;if(!e){e=B1()|0;f=k[c>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[c>>2]=0}k[c>>2]=0;n=n+16|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[l>>2]|0)>0){f=k[d>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[l>>2]|0))}e=k[g>>2]|0;if(!((e|0)==(m|0)|(e|0)==0))ggb(k[e+-4>>2]|0);c=t+36|0;e=k[c>>2]|0;if(e|0?(m=e+12|0,n=k[m>>2]|0,k[m>>2]=n+-1,(n|0)==1):0){f=k[c>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[t+32>>2]|0;if(!e){e=B1()|0;f=k[c>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[c>>2]=0}k[c>>2]=0;t=t+16|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[q>>2]|0)>0){f=k[o>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[q>>2]|0))}e=k[p>>2]|0;if(!((e|0)==(s|0)|(e|0)==0))ggb(k[e+-4>>2]|0);c=u+36|0;e=k[c>>2]|0;if(e|0?(s=e+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){f=k[c>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[u+32>>2]|0;if(!e){e=B1()|0;f=k[c>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[c>>2]=0}k[c>>2]=0;t=u+16|0;f=u+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[f>>2]|0)>0){c=k[u+40>>2]|0;e=0;do{k[c+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[u+44>>2]|0;if((e|0)==(u+48|0)|(e|0)==0){r=v;return}ggb(k[e+-4>>2]|0);r=v;return}function k1(a){a=a|0;return}function l1(a,b,c){a=a|0;b=b|0;c=c|0;return}function m1(a,b){a=a|0;b=b|0;if(k[b+8>>2]|0)return;if(k[b+12>>2]|0)return;jh[k[(k[a>>2]|0)+16>>2]&1023](a,b);return}function n1(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+288|0;v=D+160|0;C=D+104|0;B=D+48|0;u=D+40|0;z=D+32|0;A=D;if(!b){r=D;return}l=k[b+16>>2]|0;a:do if((d|0)>0){o=d+-2|0;p=C+4|0;if(!f){j=0;while(1){b=e+(j<<2)|0;a=k[b>>2]|0;if((a|0)<=-1){a=ZT(32)|0;k[a>>2]=1;s=a+4|0;k[C>>2]=s;k[p>>2]=24;i[a+28>>0]=0;m=216945;t=s+24|0;do{i[s>>0]=i[m>>0]|0;s=s+1|0;m=m+1|0}while((s|0)<(t|0));Y8(-215,C,217281,216975,78);k[p>>2]=0;k[C>>2]=0;y=k[a>>2]|0;k[a>>2]=y+-1;if((y|0)==1)ggb(k[a+-4>>2]|0);a=k[b>>2]|0}if(!a)break a;k[v+(j<<2)>>2]=a;j=j+1|0;if((j|0)>=(d|0)){a=l;q=18;break a}}}else{n=0;a=l}while(1){j=e+(n<<2)|0;b=k[j>>2]|0;if((b|0)<=-1){b=ZT(32)|0;k[b>>2]=1;s=b+4|0;k[C>>2]=s;k[p>>2]=24;i[b+28>>0]=0;m=216945;t=s+24|0;do{i[s>>0]=i[m>>0]|0;s=s+1|0;m=m+1|0}while((s|0)<(t|0));Y8(-215,C,217281,216975,78);k[p>>2]=0;k[C>>2]=0;y=k[b>>2]|0;k[b>>2]=y+-1;if((y|0)==1)ggb(k[b+-4>>2]|0);b=k[j>>2]|0}if(!b)break a;if((n|0)>(o|0))j=1;else j=k[g+(n<<2)>>2]|0;a=a+(aa(j,k[f+(n<<2)>>2]|0)|0)|0;k[v+(n<<2)>>2]=b;n=n+1|0;if((n|0)>=(d|0)){q=18;break}}}else{a=l;q=18}while(0);if((q|0)==18){x=C+4|0;b=C+8|0;e=C+16|0;j=C+20|0;q=C+40|0;s=x;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[q>>2]=b;y=C+48|0;w=C+44|0;k[w>>2]=y;k[C+52>>2]=0;k[y>>2]=0;k[C>>2]=1124007936;k[e>>2]=a;k[j>>2]=a;x1(C,d,v,g,1);y1(C);p=B+4|0;a=B+8|0;n=B+16|0;b=B+20|0;o=B+40|0;s=p;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[o>>2]=a;f=B+48|0;m=B+44|0;k[m>>2]=f;k[B+52>>2]=0;k[f>>2]=0;k[B>>2]=1124007936;k[n>>2]=c;k[b>>2]=c;x1(B,d,v,h,1);y1(B);k[u>>2]=C;k[u+4>>2]=B;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;k[A+16>>2]=0;k[A+20>>2]=0;k[A+24>>2]=0;k[A+28>>2]=0;z1(A,u,0,z,2);b=k[A+20>>2]|0;j=A+16|0;if(k[j>>2]|0){l=z+4|0;a=0;do{upb(k[l>>2]|0,k[z>>2]|0,b|0)|0;a=a+1|0;A1(A)}while(a>>>0<(k[j>>2]|0)>>>0)}j=B+36|0;a=k[j>>2]|0;if(a|0?(z=a+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){a=k[j>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[B+32>>2]|0;if(!b){b=B1()|0;a=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[j>>2]=0}k[j>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[p>>2]|0)>0){b=k[o>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[p>>2]|0))}a=k[m>>2]|0;if(!((a|0)==(f|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=C+36|0;a=k[j>>2]|0;if(a|0?(A=a+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){b=k[j>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[C+32>>2]|0;if(!a){a=B1()|0;b=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[j>>2]=0}k[j>>2]=0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[x>>2]|0)>0){b=k[q>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[x>>2]|0))}a=k[w>>2]|0;if(!((a|0)==(y|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}r=D;return}function o1(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+288|0;v=D+160|0;C=D+104|0;B=D+48|0;u=D+40|0;z=D+32|0;A=D;if(!b){r=D;return}l=k[b+16>>2]|0;a:do if((d|0)>0){o=d+-2|0;p=C+4|0;if(!f){j=0;while(1){b=e+(j<<2)|0;a=k[b>>2]|0;if((a|0)<=-1){a=ZT(32)|0;k[a>>2]=1;s=a+4|0;k[C>>2]=s;k[p>>2]=24;i[a+28>>0]=0;m=216945;t=s+24|0;do{i[s>>0]=i[m>>0]|0;s=s+1|0;m=m+1|0}while((s|0)<(t|0));Y8(-215,C,217274,216975,109);k[p>>2]=0;k[C>>2]=0;y=k[a>>2]|0;k[a>>2]=y+-1;if((y|0)==1)ggb(k[a+-4>>2]|0);a=k[b>>2]|0}if(!a)break a;k[v+(j<<2)>>2]=a;j=j+1|0;if((j|0)>=(d|0)){a=l;q=18;break a}}}else{n=0;a=l}while(1){j=e+(n<<2)|0;b=k[j>>2]|0;if((b|0)<=-1){b=ZT(32)|0;k[b>>2]=1;s=b+4|0;k[C>>2]=s;k[p>>2]=24;i[b+28>>0]=0;m=216945;t=s+24|0;do{i[s>>0]=i[m>>0]|0;s=s+1|0;m=m+1|0}while((s|0)<(t|0));Y8(-215,C,217274,216975,109);k[p>>2]=0;k[C>>2]=0;y=k[b>>2]|0;k[b>>2]=y+-1;if((y|0)==1)ggb(k[b+-4>>2]|0);b=k[j>>2]|0}if(!b)break a;if((n|0)>(o|0))j=1;else j=k[g+(n<<2)>>2]|0;a=a+(aa(j,k[f+(n<<2)>>2]|0)|0)|0;k[v+(n<<2)>>2]=b;n=n+1|0;if((n|0)>=(d|0)){q=18;break}}}else{a=l;q=18}while(0);if((q|0)==18){x=C+4|0;b=C+8|0;e=C+16|0;j=C+20|0;q=C+40|0;s=x;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[q>>2]=b;y=C+48|0;w=C+44|0;k[w>>2]=y;k[C+52>>2]=0;k[y>>2]=0;k[C>>2]=1124007936;k[e>>2]=c;k[j>>2]=c;x1(C,d,v,h,1);y1(C);p=B+4|0;b=B+8|0;n=B+16|0;j=B+20|0;o=B+40|0;s=p;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[o>>2]=b;f=B+48|0;m=B+44|0;k[m>>2]=f;k[B+52>>2]=0;k[f>>2]=0;k[B>>2]=1124007936;k[n>>2]=a;k[j>>2]=a;x1(B,d,v,g,1);y1(B);k[u>>2]=C;k[u+4>>2]=B;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;k[A+16>>2]=0;k[A+20>>2]=0;k[A+24>>2]=0;k[A+28>>2]=0;z1(A,u,0,z,2);b=k[A+20>>2]|0;j=A+16|0;if(k[j>>2]|0){l=z+4|0;a=0;do{upb(k[l>>2]|0,k[z>>2]|0,b|0)|0;a=a+1|0;A1(A)}while(a>>>0<(k[j>>2]|0)>>>0)}j=B+36|0;a=k[j>>2]|0;if(a|0?(z=a+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){a=k[j>>2]|0;if(a|0){b=k[a+4>>2]|0;if(!b){b=k[B+32>>2]|0;if(!b){b=B1()|0;a=k[j>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,a)}k[j>>2]=0}k[j>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[p>>2]|0)>0){b=k[o>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[p>>2]|0))}a=k[m>>2]|0;if(!((a|0)==(f|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=C+36|0;a=k[j>>2]|0;if(a|0?(A=a+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){b=k[j>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[C+32>>2]|0;if(!a){a=B1()|0;b=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[j>>2]=0}k[j>>2]=0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[x>>2]|0)>0){b=k[q>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[x>>2]|0))}a=k[w>>2]|0;if(!((a|0)==(y|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}r=D;return}function p1(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+288|0;w=C+160|0;B=C+104|0;A=C+48|0;x=C+40|0;y=C+32|0;z=C;if(!((b|0)!=0&(c|0)!=0)){r=C;return}a=k[b+16>>2]|0;o=k[c+16>>2]|0;a:do if((d|0)>0){n=(h|0)==0;q=d+-2|0;u=B+4|0;if(!f){m=0;l=o;while(1){c=e+(m<<2)|0;b=k[c>>2]|0;if((b|0)<=-1){b=ZT(32)|0;k[b>>2]=1;s=b+4|0;k[B>>2]=s;k[u>>2]=24;i[b+28>>0]=0;p=216945;t=s+24|0;do{i[s>>0]=i[p>>0]|0;s=s+1|0;p=p+1|0}while((s|0)<(t|0));Y8(-215,B,216970,216975,140);k[u>>2]=0;k[B>>2]=0;t=k[b>>2]|0;k[b>>2]=t+-1;if((t|0)==1)ggb(k[b+-4>>2]|0);b=k[c>>2]|0}if(!b)break a;if(!n){if((m|0)>(q|0))c=1;else c=k[j+(m<<2)>>2]|0;l=l+(aa(c,k[h+(m<<2)>>2]|0)|0)|0}k[w+(m<<2)>>2]=b;m=m+1|0;if((m|0)>=(d|0)){c=a;v=31;break a}}}if(n){c=0;while(1){b=e+(c<<2)|0;l=k[b>>2]|0;if((l|0)<=-1){l=ZT(32)|0;k[l>>2]=1;s=l+4|0;k[B>>2]=s;k[u>>2]=24;i[l+28>>0]=0;p=216945;t=s+24|0;do{i[s>>0]=i[p>>0]|0;s=s+1|0;p=p+1|0}while((s|0)<(t|0));Y8(-215,B,216970,216975,140);k[u>>2]=0;k[B>>2]=0;t=k[l>>2]|0;k[l>>2]=t+-1;if((t|0)==1)ggb(k[l+-4>>2]|0);l=k[b>>2]|0}if(!l)break a;if((c|0)>(q|0))b=1;else b=k[g+(c<<2)>>2]|0;a=a+(aa(b,k[f+(c<<2)>>2]|0)|0)|0;k[w+(c<<2)>>2]=l;c=c+1|0;if((c|0)>=(d|0)){c=a;l=o;v=31;break}}}else{n=0;l=o;while(1){c=e+(n<<2)|0;b=k[c>>2]|0;if((b|0)<=-1){b=ZT(32)|0;k[b>>2]=1;s=b+4|0;k[B>>2]=s;k[u>>2]=24;i[b+28>>0]=0;p=216945;t=s+24|0;do{i[s>>0]=i[p>>0]|0;s=s+1|0;p=p+1|0}while((s|0)<(t|0));Y8(-215,B,216970,216975,140);k[u>>2]=0;k[B>>2]=0;t=k[b>>2]|0;k[b>>2]=t+-1;if((t|0)==1)ggb(k[b+-4>>2]|0);b=k[c>>2]|0}if(!b)break a;c=k[f+(n<<2)>>2]|0;if((n|0)>(q|0))m=1;else{c=aa(k[g+(n<<2)>>2]|0,c)|0;m=k[j+(n<<2)>>2]|0}a=a+c|0;l=l+(aa(m,k[h+(n<<2)>>2]|0)|0)|0;k[w+(n<<2)>>2]=b;n=n+1|0;if((n|0)>=(d|0)){c=a;v=31;break}}}}else{c=a;l=o;v=31}while(0);if((v|0)==31){e=B+4|0;a=B+8|0;h=B+16|0;b=B+20|0;q=B+40|0;s=e;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[q>>2]=a;v=B+48|0;u=B+44|0;k[u>>2]=v;k[B+52>>2]=0;k[v>>2]=0;k[B>>2]=1124007936;k[h>>2]=c;k[b>>2]=c;x1(B,d,w,g,1);y1(B);f=A+4|0;a=A+8|0;n=A+16|0;b=A+20|0;o=A+40|0;s=f;t=s+36|0;do{k[s>>2]=0;s=s+4|0}while((s|0)<(t|0));k[o>>2]=a;p=A+48|0;m=A+44|0;k[m>>2]=p;k[A+52>>2]=0;k[p>>2]=0;k[A>>2]=1124007936;k[n>>2]=l;k[b>>2]=l;x1(A,d,w,j,1);y1(A);k[x>>2]=B;k[x+4>>2]=A;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;k[z+16>>2]=0;k[z+20>>2]=0;k[z+24>>2]=0;k[z+28>>2]=0;z1(z,x,0,y,2);l=k[z+20>>2]|0;b=z+16|0;if(k[b>>2]|0){c=y+4|0;a=0;do{upb(k[c>>2]|0,k[y>>2]|0,l|0)|0;a=a+1|0;A1(z)}while(a>>>0<(k[b>>2]|0)>>>0)}b=A+36|0;a=k[b>>2]|0;if(a|0?(y=a+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){l=k[b>>2]|0;if(l|0){a=k[l+4>>2]|0;if(!a){a=k[A+32>>2]|0;if(!a){a=B1()|0;l=k[b>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[b>>2]=0}k[b>>2]=0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;if((k[f>>2]|0)>0){l=k[o>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[m>>2]|0;if(!((a|0)==(p|0)|(a|0)==0))ggb(k[a+-4>>2]|0);b=B+36|0;a=k[b>>2]|0;if(a|0?(z=a+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){l=k[b>>2]|0;if(l|0){a=k[l+4>>2]|0;if(!a){a=k[B+32>>2]|0;if(!a){a=B1()|0;l=k[b>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[b>>2]=0}k[b>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[e>>2]|0)>0){l=k[q>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[u>>2]|0;if(!((a|0)==(v|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}r=C;return}function q1(a,b){a=a|0;b=b|0;if(i[427768]|0)return 428760;i[427768]=1;k[107190]=48992;return 428760}function r1(a){a=a|0;return -1}function s1(a){a=a|0;return -1}function t1(a,b){a=a|0;b=b|0;return}function u1(a){a=a|0;return}function v1(a){a=a|0;return}function w1(a){a=a|0;ggb(a);return}function x1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=r;r=r+16|0;y=z;if(b>>>0>=33){f=y+4|0;g=ZT(40)|0;k[g>>2]=1;n=g+4|0;k[y>>2]=n;k[f>>2]=33;i[g+37>>0]=0;o=233146;p=n+33|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-215,y,233180,216975,279);k[f>>2]=0;k[y>>2]=0;x=k[g>>2]|0;k[g>>2]=x+-1;if((x|0)==1)ggb(k[g+-4>>2]|0)}x=a+4|0;if((k[x>>2]|0)!=(b|0)){f=a+44|0;g=k[f>>2]|0;h=a+48|0;if((g|0)!=(h|0)){if(g|0)ggb(k[g+-4>>2]|0);k[f>>2]=h;k[a+40>>2]=a+8}if((b|0)>2){v=ZT(b<<3|4)|0;k[f>>2]=v;v=v+(b<<2)+4|0;k[a+40>>2]=v;k[v+-4>>2]=b;k[a+12>>2]=-1;k[a+8>>2]=-1}}k[x>>2]=b;if(!c){r=z;return}s=k[a>>2]|0;l=s&7;s=(s>>>3&511)+1<<(47696>>>(l<<1)&3);l=1212424721>>>(l<<2)&15;h=b+-1|0;if((b|0)<=0){r=z;return}t=a+40|0;u=a+44|0;j=y+4|0;m=y+4|0;v=y+4|0;if(!d){f=s;while(1){g=k[c+(h<<2)>>2]|0;if((g|0)<=-1?(w=ZT(12)|0,k[w>>2]=1,q=w+4|0,k[y>>2]=q,k[v>>2]=6,i[w+10>>0]=0,i[q>>0]=i[233188]|0,i[q+1>>0]=i[233189]|0,i[q+2>>0]=i[233190]|0,i[q+3>>0]=i[233191]|0,i[q+4>>0]=i[233192]|0,i[q+5>>0]=i[233193]|0,Y8(-215,y,233180,216975,306),k[v>>2]=0,k[y>>2]=0,q=k[w>>2]|0,k[w>>2]=q+-1,(q|0)==1):0)ggb(k[w+-4>>2]|0);k[(k[t>>2]|0)+(h<<2)>>2]=g;if(e){k[(k[u>>2]|0)+(h<<2)>>2]=f;f=Epb(g|0,((g|0)<0)<<31>>31|0,f|0,0)|0;if(!((f|0)==(f|0)&(N|0)==0)){g=ZT(56)|0;k[g>>2]=1;n=g+4|0;k[y>>2]=n;k[j>>2]=51;i[g+55>>0]=0;o=233195;p=n+51|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-211,y,233180,216975,323);k[j>>2]=0;k[y>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0)}}if((h|0)>0)h=h+-1|0;else break}}else{j=h;while(1){f=k[c+(j<<2)>>2]|0;if((f|0)<=-1?(q=ZT(12)|0,k[q>>2]=1,w=q+4|0,k[y>>2]=w,k[v>>2]=6,i[q+10>>0]=0,i[w>>0]=i[233188]|0,i[w+1>>0]=i[233189]|0,i[w+2>>0]=i[233190]|0,i[w+3>>0]=i[233191]|0,i[w+4>>0]=i[233192]|0,i[w+5>>0]=i[233193]|0,Y8(-215,y,233180,216975,306),k[v>>2]=0,k[y>>2]=0,w=k[q>>2]|0,k[q>>2]=w+-1,(w|0)==1):0)ggb(k[q+-4>>2]|0);k[(k[t>>2]|0)+(j<<2)>>2]=f;g=d+(j<<2)|0;if(((k[g>>2]|0)>>>0)%(l>>>0)|0|0){f=ZT(36)|0;k[f>>2]=1;n=f+4|0;k[y>>2]=n;k[m>>2]=31;i[f+35>>0]=0;o=217242;p=n+31|0;do{i[n>>0]=i[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Y8(-13,y,233180,216975,313);k[m>>2]=0;k[y>>2]=0;w=k[f>>2]|0;k[f>>2]=w+-1;if((w|0)==1)ggb(k[f+-4>>2]|0)}if((j|0)<(h|0))f=k[g>>2]|0;else f=s;k[(k[u>>2]|0)+(j<<2)>>2]=f;if((j|0)>0)j=j+-1|0;else break}}if((b|0)!=1){r=z;return}k[x>>2]=2;k[a+12>>2]=1;k[(k[u>>2]|0)+4>>2]=s;r=z;return}function y1(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;g=k[a+4>>2]|0;i=k[a+40>>2]|0;a:do if((g|0)>0){b=0;do{if((k[i+(b<<2)>>2]|0)>1)break a;b=b+1|0}while((b|0)<(g|0))}else b=0;while(0);h=k[a+44>>2]|0;c=g;do{d=c;c=c+-1|0;if((c|0)<=(b|0))break;f=aa(k[i+(c<<2)>>2]|0,k[h+(c<<2)>>2]|0)|0}while(f>>>0>=(k[h+(d+-2<<2)>>2]|0)>>>0);e=k[i>>2]|0;e=Epb(e|0,((e|0)<0)<<31>>31|0,k[h>>2]|0,0)|0;f=k[a>>2]|0;k[a>>2]=(c|0)<=(b|0)&((e|0)==(e|0)&(N|0)==0)?f|16384:f&-16385;if((g|0)>2){k[a+12>>2]=-1;k[a+8>>2]=-1}b=k[a+36>>2]|0;if(!b)b=a+16|0;else{f=k[b+16>>2]|0;b=a+16|0;k[b>>2]=f;k[a+20>>2]=f}c=k[b>>2]|0;if(!c){k[a+28>>2]=0;k[a+24>>2]=0;return}d=k[i>>2]|0;e=k[h>>2]|0;b=(k[a+20>>2]|0)+(aa(e,d)|0)|0;k[a+28>>2]=b;if((d|0)<=0){k[a+24>>2]=b;return}f=g+-1|0;b=c+(aa(k[h+(f<<2)>>2]|0,k[i+(f<<2)>>2]|0)|0)|0;a=a+24|0;k[a>>2]=b;if((g|0)<=1)return;b=b+(aa(e,d+-1|0)|0)|0;if((f|0)!=1){c=1;do{b=b+(aa(k[h+(c<<2)>>2]|0,(k[i+(c<<2)>>2]|0)+-1|0)|0)|0;c=c+1|0}while((c|0)!=(f|0))}k[a>>2]=b;return}function z1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=r;r=r+64|0;F=G;if(!((b|0)!=0?(c|0)!=0|(d|0)!=0:0)){g=F+4|0;f=ZT(36)|0;k[f>>2]=1;A=f+4|0;k[F>>2]=A;k[g>>2]=29;i[f+33>>0]=0;z=217126;B=A+29|0;do{i[A>>0]=i[z>>0]|0;A=A+1|0;z=z+1|0}while((A|0)<(B|0));Y8(-215,F,403227,216975,4400);k[g>>2]=0;k[F>>2]=0;E=k[f>>2]|0;k[f>>2]=E+-1;if((E|0)==1)ggb(k[f+-4>>2]|0)}k[a>>2]=b;p=a+8|0;k[p>>2]=d;E=a+4|0;k[E>>2]=c;C=a+12|0;k[C>>2]=e;s=a+16|0;k[s>>2]=0;D=a+20|0;k[D>>2]=0;if((e|0)<0){e=0;while(1)if(!(k[b+(e<<2)>>2]|0))break;else e=e+1|0;k[C>>2]=e;if((e|0)>=1001){e=F+4|0;f=ZT(20)|0;k[f>>2]=1;A=f+4|0;k[F>>2]=A;k[e>>2]=15;i[f+19>>0]=0;z=217156;B=A+15|0;do{i[A>>0]=i[z>>0]|0;A=A+1|0;z=z+1|0}while((A|0)<(B|0));Y8(-215,F,403227,216975,4415);k[e>>2]=0;k[F>>2]=0;B=k[f>>2]|0;k[f>>2]=B+-1;if((B|0)==1)ggb(k[f+-4>>2]|0);e=k[C>>2]|0}}q=a+24|0;k[q>>2]=0;if((e|0)>0){m=F+4|0;n=F+4|0;o=F+4|0;j=-1;g=-1;d=0;l=0;while(1){e=k[(k[a>>2]|0)+(l<<2)>>2]|0;if(!e){e=ZT(20)|0;k[e>>2]=1;A=e+4|0;k[F>>2]=A;k[m>>2]=14;i[e+18>>0]=0;z=217172;B=A+14|0;do{i[A>>0]=i[z>>0]|0;A=A+1|0;z=z+1|0}while((A|0)<(B|0));Y8(-215,F,403227,216975,4422);k[m>>2]=0;k[F>>2]=0;B=k[e>>2]|0;k[e>>2]=B+-1;if((B|0)==1)ggb(k[e+-4>>2]|0);e=k[(k[a>>2]|0)+(l<<2)>>2]|0}f=k[p>>2]|0;if(!f)f=e+16|0;else{B=e+16|0;k[f+(l<<2)>>2]=k[B>>2];f=B}if(k[f>>2]|0){a:do if((g|0)<0){f=k[e+4>>2]|0;if((f|0)>0){g=k[e+40>>2]|0;d=0;while(1){if((k[g+(d<<2)>>2]|0)>1){g=l;break a}d=d+1|0;if((d|0)>=(f|0)){g=l;break}}}else{g=l;d=0}}else{c=k[e+40>>2]|0;b=k[c+-4>>2]|0;h=k[(k[(k[a>>2]|0)+(g<<2)>>2]|0)+40>>2]|0;b:do if((b|0)==(k[h+-4>>2]|0)){if((b|0)==2){if((k[c>>2]|0)!=(k[h>>2]|0))break;if((k[c+4>>2]|0)==(k[h+4>>2]|0)){f=j;break a}else break}if((b|0)>0)f=0;else{f=j;break a}while(1){if((k[c+(f<<2)>>2]|0)!=(k[h+(f<<2)>>2]|0))break b;f=f+1|0;if((f|0)>=(b|0)){f=j;break a}}}while(0);f=ZT(32)|0;k[f>>2]=1;A=f+4|0;k[F>>2]=A;k[o>>2]=26;i[f+30>>0]=0;z=217187;B=A+26|0;do{i[A>>0]=i[z>>0]|0;A=A+1|0;z=z+1|0}while((A|0)<(B|0));Y8(-215,F,403227,216975,4442);k[o>>2]=0;k[F>>2]=0;B=k[f>>2]|0;k[f>>2]=B+-1;if((B|0)==1)ggb(k[f+-4>>2]|0);f=j}while(0);if(!(k[e>>2]&16384)){c=f+-1|0;j=e+44|0;h=k[j>>2]|0;b=k[e+4>>2]|0;if((b|0)>0)b=k[h+(b+-1<<2)>>2]|0;else b=0;if((k[h+(c<<2)>>2]|0)!=(b|0)){b=ZT(32)|0;k[b>>2]=1;A=b+4|0;k[F>>2]=A;k[n>>2]=27;i[b+31>>0]=0;z=217214;B=A+27|0;do{i[A>>0]=i[z>>0]|0;A=A+1|0;z=z+1|0}while((A|0)<(B|0));Y8(-215,F,403227,216975,4446);k[n>>2]=0;k[F>>2]=0;B=k[b>>2]|0;k[b>>2]=B+-1;if((B|0)==1)ggb(k[b+-4>>2]|0)}b=e+40|0;while(1){if((c|0)<=(d|0))break;B=k[j>>2]|0;A=aa(k[(k[b>>2]|0)+(c<<2)>>2]|0,k[B+(c<<2)>>2]|0)|0;e=c+-1|0;if(A>>>0<(k[B+(e<<2)>>2]|0)>>>0)break;else c=e}h=k[q>>2]|0;k[q>>2]=(h|0)<(c|0)?c:h;h=d}else h=d}else{f=j;h=d}l=l+1|0;e=k[C>>2]|0;if((l|0)>=(e|0))break;else{j=f;d=h}}if((g|0)>-1){c=f+-1|0;b=k[(k[(k[a>>2]|0)+(g<<2)>>2]|0)+40>>2]|0;f=k[q>>2]|0;g=k[b+(c<<2)>>2]|0;while(1){k[D>>2]=g;if((c|0)<=(f|0))break;d=c+-1|0;B=k[b+(d<<2)>>2]|0;g=Epb(B|0,((B|0)<0)<<31>>31|0,g|0,0)|0;if(!((g|0)==(g|0)&(N|0)==(((g|0)<0)<<31>>31|0)))break;else c=d}f=(c|0)==(h|0)?0:c;k[q>>2]=f;k[s>>2]=1;if((f|0)>0){g=1;do{B=f;f=f+-1|0;g=aa(g,k[b+(f<<2)>>2]|0)|0;k[s>>2]=g}while((B|0)>1)}}else t=55}else t=55;if((t|0)==55)k[q>>2]=0;k[a+28>>2]=0;if(!((k[E>>2]|0)!=0&(e|0)>0)){r=G;return}c=F+4|0;b=F+4|0;h=F+8|0;j=F+40|0;l=F+48|0;m=F+44|0;n=F+52|0;o=F+36|0;p=F+16|0;q=F+32|0;s=F+36|0;t=F+16|0;u=F+4|0;v=F+40|0;w=F+44|0;x=F+48|0;y=F+32|0;d=0;do{e=k[(k[a>>2]|0)+(d<<2)>>2]|0;if(!e){e=ZT(20)|0;k[e>>2]=1;A=e+4|0;k[F>>2]=A;k[c>>2]=14;i[e+18>>0]=0;z=217172;B=A+14|0;do{i[A>>0]=i[z>>0]|0;A=A+1|0;z=z+1|0}while((A|0)<(B|0));Y8(-215,F,403227,216975,4483);k[c>>2]=0;k[F>>2]=0;B=k[e>>2]|0;k[e>>2]=B+-1;if((B|0)==1)ggb(k[e+-4>>2]|0);e=k[(k[a>>2]|0)+(d<<2)>>2]|0}f=k[e+16>>2]|0;g=(k[E>>2]|0)+(d*56|0)|0;if(!f){k[F>>2]=1124007936;A=b;B=A+36|0;do{k[A>>2]=0;A=A+4|0}while((A|0)<(B|0));k[j>>2]=h;k[m>>2]=l;k[n>>2]=0;k[l>>2]=0;KG(g,F)|0;e=k[o>>2]|0;if(e|0?(A=e+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){f=k[o>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[q>>2]|0;if(!e){e=B1()|0;f=k[o>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[o>>2]=0}k[o>>2]=0;k[p>>2]=0;k[p+4>>2]=0;k[p+8>>2]=0;k[p+12>>2]=0;if((k[b>>2]|0)>0){f=k[j>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[b>>2]|0))}e=k[m>>2]|0;if(!((e|0)==(l|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}else{JN(F,1,k[D>>2]|0,k[e>>2]&4095,f,0);KG(g,F)|0;e=k[s>>2]|0;if(e|0?(A=e+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){f=k[s>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[y>>2]|0;if(!e){e=B1()|0;f=k[s>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[s>>2]=0}k[s>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[u>>2]|0)>0){f=k[v>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[u>>2]|0))}e=k[w>>2]|0;if(!((e|0)==(x|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}d=d+1|0}while((d|0)<(k[C>>2]|0));r=G;return}function A1(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+28|0;b=k[c>>2]|0;if(b>>>0>=((k[a+16>>2]|0)+-1|0)>>>0)return;n=b+1|0;k[c>>2]=n;m=k[a+24>>2]|0;if((m|0)!=1){h=k[a+12>>2]|0;if((h|0)<=0)return;i=a+8|0;j=a+4|0;l=(n|0)>0&(m|0)>0;g=0;do{b=k[(k[a>>2]|0)+(g<<2)>>2]|0;c=k[b+16>>2]|0;if(c|0){if(l){f=k[b+40>>2]|0;e=k[b+44>>2]|0;d=m;b=n;do{o=d;d=d+-1|0;p=k[f+(d<<2)>>2]|0;q=b;b=(b|0)/(p|0)|0;p=q-(aa(b,p)|0)|0;c=c+(aa(p,k[e+(d<<2)>>2]|0)|0)|0}while((b|0)>0&(o|0)>1)}b=k[i>>2]|0;if(b|0)k[b+(g<<2)>>2]=c;b=k[j>>2]|0;if(b|0)k[b+(g*56|0)+16>>2]=c}g=g+1|0}while((g|0)!=(h|0));return}d=a+8|0;c=k[d>>2]|0;a:do if(c|0?(e=k[a+12>>2]|0,(e|0)>0):0){b=0;while(1){c=c+(b<<2)|0;if(k[c>>2]|0){q=k[(k[a>>2]|0)+(b<<2)>>2]|0;q=(k[q+16>>2]|0)+(aa(n,k[k[q+44>>2]>>2]|0)|0)|0;k[c>>2]=q}b=b+1|0;if((b|0)>=(e|0))break a;c=k[d>>2]|0}}while(0);c=k[a+4>>2]|0;if(!c)return;d=k[a+12>>2]|0;if((d|0)<=0)return;b=0;do{e=c+(b*56|0)+16|0;if(k[e>>2]|0){q=k[(k[a>>2]|0)+(b<<2)>>2]|0;q=(k[q+16>>2]|0)+(aa(n,k[k[q+44>>2]>>2]|0)|0)|0;k[e>>2]=q}b=b+1|0}while((b|0)!=(d|0));return}function B1(){var a=0,b=0;a=k[107191]|0;if(a|0){b=a;return b|0}if(!(k[107192]|0)){a=b9()|0;mpb(k[a>>2]|0)|0;if(!(k[107192]|0)){while(1){b=fgb(4)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;Qh[b&7]()}k[b>>2]=49024;k[107192]=b}lpb(k[a>>2]|0)|0}b=k[107192]|0;k[107191]=b;return b|0}function C1(a){a=a|0;ggb(a);return}function D1(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0;o=r;r=r+16|0;n=o;g=(d>>>3&511)+1<<(47696>>>(d<<1&14)&3);h=b+-1|0;a:do if((b|0)>0){m=n+4|0;if(!f)while(1){g=aa(k[c+(h<<2)>>2]|0,g)|0;if((h|0)>0)h=h+-1|0;else break a}if(!e)while(1){k[f+(h<<2)>>2]=g;g=aa(k[c+(h<<2)>>2]|0,g)|0;if((h|0)>0)h=h+-1|0;else break a}while(1){b=f+(h<<2)|0;d=k[b>>2]|0;if((d|0)!=2147483647)if(g>>>0>d>>>0){g=ZT(24)|0;k[g>>2]=1;j=g+4|0;k[n>>2]=j;k[m>>2]=16;i[g+20>>0]=0;d=217086;l=j+16|0;do{i[j>>0]=i[d>>0]|0;j=j+1|0;d=d+1|0}while((j|0)<(l|0));Y8(-215,n,426947,216975,182);k[m>>2]=0;k[n>>2]=0;l=k[g>>2]|0;k[g>>2]=l+-1;if((l|0)==1)ggb(k[g+-4>>2]|0);g=k[b>>2]|0}else g=d;else k[b>>2]=g;g=aa(k[c+(h<<2)>>2]|0,g)|0;if((h|0)>0)h=h+-1|0;else break}}while(0);b=(e|0)!=0;if(b)d=e;else d=ZT(g)|0;while(1){h=fgb(52)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[h+4>>2]=a;k[h>>2]=a;j=h+8|0;l=j+44|0;do{k[j>>2]=0;j=j+4|0}while((j|0)<(l|0));k[h+20>>2]=d;k[h+16>>2]=d;k[h+24>>2]=g;if(!b){r=o;return h|0}k[h+28>>2]=32;r=o;return h|0}function E1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return (b|0)!=0|0}function F1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;h=r;r=r+16|0;g=h;if(!b){r=h;return}if(k[b+8>>2]|0){a=g+4|0;c=ZT(24)|0;k[c>>2]=1;d=c+4|0;k[g>>2]=d;k[a>>2]=17;i[c+21>>0]=0;e=217040;f=d+17|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,g,217058,216975,211);k[a>>2]=0;k[g>>2]=0;f=k[c>>2]|0;k[c>>2]=f+-1;if((f|0)==1)ggb(k[c+-4>>2]|0)}if(k[b+12>>2]|0){a=g+4|0;c=ZT(24)|0;k[c>>2]=1;d=c+4|0;k[g>>2]=d;k[a>>2]=16;i[c+20>>0]=0;e=217069;f=d+16|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,g,217058,216975,212);k[a>>2]=0;k[g>>2]=0;f=k[c>>2]|0;k[c>>2]=f+-1;if((f|0)==1)ggb(k[c+-4>>2]|0)}if(!(k[b+28>>2]&32)){a=b+20|0;c=k[a>>2]|0;if(c|0)ggb(k[c+-4>>2]|0);k[a>>2]=0}k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if(k[b+44>>2]|0){k[g>>2]=0;a=g+4|0;k[a>>2]=0;c=ZT(20)|0;k[c>>2]=1;d=c+4|0;k[g>>2]=d;k[a>>2]=13;i[c+17>>0]=0;e=233056;f=d+13|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-215,g,233070,233080,77);k[a>>2]=0;k[g>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)==1)ggb(k[c+-4>>2]|0)}c=b+16|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;k[c+16>>2]=0;k[c+20>>2]=0;k[c+24>>2]=0;c=k[b+48>>2]|0;do if(c|0?(j=c+8|0,k[j>>2]=(k[j>>2]|0)+-1,l=c+12|0,k[l>>2]=(k[l>>2]|0)+-1,(k[l>>2]|0)==0):0){if(k[c+44>>2]|0){a=k[c+4>>2]|0;if(!a)a=B1()|0;jh[k[(k[a>>2]|0)+24>>2]&1023](a,c);if(k[l>>2]|0)break}if(!(k[j>>2]|0)){l=k[c+4>>2]|0;jh[k[(k[l>>2]|0)+16>>2]&1023](l,c)}}while(0);ggb(b);r=h;return}function G1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+16|0;o=p;if(!(b>>>0<33&(c|0)!=0)){e=o+4|0;f=ZT(40)|0;k[f>>2]=1;g=f+4|0;k[o>>2]=g;k[e>>2]=35;i[f+39>>0]=0;j=233425;l=g+35|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-215,o,389997,216975,386);k[e>>2]=0;k[o>>2]=0;m=k[f>>2]|0;k[f>>2]=m+-1;if((m|0)==1)ggb(k[f+-4>>2]|0)}j=d&4095;f=a+16|0;do if(k[f>>2]|0){m=k[a+4>>2]|0;if((m|0)!=(b|0)?!((b|0)==1&(m|0)<3):0)break;if((j|0)==(k[a>>2]&4095|0)){if((b|0)==2)if((k[a+8>>2]|0)==(k[c>>2]|0)?(k[a+12>>2]|0)==(k[c+4>>2]|0):0){r=p;return}else h=13;else if((b|0)>0)h=13;else d=0;a:do if((h|0)==13){e=k[a+40>>2]|0;d=0;do{if((k[e+(d<<2)>>2]|0)!=(k[c+(d<<2)>>2]|0))break a;d=d+1|0}while((d|0)<(b|0))}while(0);if((d|0)==(b|0)){if((b|0)>1){r=p;return}if((k[(k[a+40>>2]|0)+4>>2]|0)==1){r=p;return}}}}while(0);m=a+36|0;d=k[m>>2]|0;if(d|0?(h=d+12|0,l=k[h>>2]|0,k[h>>2]=l+-1,(l|0)==1):0){e=k[m>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[a+32>>2]|0;if(!d){d=B1()|0;e=k[m>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[m>>2]=0}k[m>>2]=0;h=a+4|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[h>>2]|0)>0){e=k[a+40>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[h>>2]|0))}if(!b){r=p;return}k[a>>2]=j|1124007936;x1(a,b,c,0,1);f=k[h>>2]|0;if((f|0)<3)d=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{g=k[a+40>>2]|0;e=0;d=1;do{d=aa(k[g+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(f|0))}if(d|0){c=k[a+32>>2]|0;d=B1()|0;c=(c|0)==0?d:c;d=a+44|0;c=si[k[(k[c>>2]|0)+8>>2]&15](c,k[h>>2]|0,k[a+40>>2]|0,j,0,k[d>>2]|0,0,0)|0;k[m>>2]=c;if((c|0)==0?(k[o>>2]=0,c=o+4|0,k[c>>2]=0,n=ZT(12)|0,k[n>>2]=1,b=n+4|0,k[o>>2]=b,k[c>>2]=6,i[n+10>>0]=0,i[b>>0]=i[233461]|0,i[b+1>>0]=i[233462]|0,i[b+2>>0]=i[233463]|0,i[b+3>>0]=i[233464]|0,i[b+4>>0]=i[233465]|0,i[b+5>>0]=i[233466]|0,Y8(-215,o,389997,216975,418),k[c>>2]=0,k[o>>2]=0,c=k[n>>2]|0,k[n>>2]=c+-1,(c|0)==1):0)ggb(k[n+-4>>2]|0);n=k[a>>2]|0;if((k[(k[d>>2]|0)+((k[h>>2]|0)+-1<<2)>>2]|0)!=((n>>>3&511)+1<<(47696>>>(n<<1&14)&3)|0)){d=o+4|0;e=ZT(48)|0;k[e>>2]=1;g=e+4|0;k[o>>2]=g;k[d>>2]=43;i[e+47>>0]=0;j=233468;l=g+43|0;do{i[g>>0]=i[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(l|0));Y8(-215,o,389997,216975,426);k[d>>2]=0;k[o>>2]=0;o=k[e>>2]|0;k[e>>2]=o+-1;if((o|0)==1)ggb(k[e+-4>>2]|0)}}d=k[m>>2]|0;if(d|0){o=d+12|0;k[o>>2]=(k[o>>2]|0)+1}y1(a);r=p;return}function H1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+1168|0;A=D+1152|0;C=D+56|0;B=D;k[a>>2]=1124007936;w=a+4|0;x=a+8|0;y=a+12|0;s=a+16|0;o=a+32|0;t=a+36|0;v=a+40|0;p=w;q=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(q|0));k[v>>2]=x;h=a+48|0;l=a+44|0;k[l>>2]=h;k[a+52>>2]=0;k[h>>2]=0;j=b+4|0;e=k[j>>2]|0;if((e|0)>1)g=e;else{e=A+4|0;f=ZT(16)|0;k[f>>2]=1;p=f+4|0;k[A>>2]=p;k[e>>2]=11;i[f+15>>0]=0;n=217310;q=p+11|0;do{i[p>>0]=i[n>>0]|0;p=p+1|0;n=n+1|0}while((p|0)<(q|0));Y8(-215,A,390638,216975,454);k[e>>2]=0;k[A>>2]=0;q=k[f>>2]|0;k[f>>2]=q+-1;if((q|0)==1)ggb(k[f+-4>>2]|0);g=k[j>>2]|0}if((g|0)<=2){KG(a,b)|0;f=k[c>>2]|0;g=c+4|0;e=k[g>>2]|0;if((f|0)!=-2147483648|(e|0)!=2147483647?(f|0?1:(e|0)!=(k[x>>2]|0)):0){if(!(!((f|0)<0|(f|0)>(e|0))?(e|0)<=(k[b+8>>2]|0):0)){e=A+4|0;f=ZT(88)|0;k[f>>2]=1;p=f+4|0;k[A>>2]=p;k[e>>2]=83;i[f+87>>0]=0;n=217322;q=p+83|0;do{i[p>>0]=i[n>>0]|0;p=p+1|0;n=n+1|0}while((p|0)<(q|0));Y8(-215,A,390638,216975,469);k[e>>2]=0;k[A>>2]=0;C=k[f>>2]|0;k[f>>2]=C+-1;if((C|0)==1)ggb(k[f+-4>>2]|0);f=k[c>>2]|0;e=k[g>>2]|0}k[x>>2]=e-f;C=aa(f,k[h>>2]|0)|0;k[s>>2]=(k[s>>2]|0)+C;k[a>>2]=k[a>>2]|32768}f=k[d>>2]|0;h=d+4|0;e=k[h>>2]|0;if((f|0)!=-2147483648|(e|0)!=2147483647?(f|0?1:(e|0)!=(k[y>>2]|0)):0){if(!((f|0)<0|(f|0)>(e|0))?(e|0)<=(k[b+12>>2]|0):0)g=f;else{e=A+4|0;f=ZT(88)|0;k[f>>2]=1;p=f+4|0;k[A>>2]=p;k[e>>2]=83;i[f+87>>0]=0;n=217406;q=p+83|0;do{i[p>>0]=i[n>>0]|0;p=p+1|0;n=n+1|0}while((p|0)<(q|0));Y8(-215,A,390638,216975,477);k[e>>2]=0;k[A>>2]=0;C=k[f>>2]|0;k[f>>2]=C+-1;if((C|0)==1)ggb(k[f+-4>>2]|0);g=k[d>>2]|0;e=k[h>>2]|0}f=e-g|0;k[y>>2]=f;e=k[w>>2]|0;if((e|0)>0)e=k[(k[l>>2]|0)+(e+-1<<2)>>2]|0;else e=0;C=aa(e,g)|0;k[s>>2]=(k[s>>2]|0)+C;k[a>>2]=((f|0)<(k[b+12>>2]|0)?-49153:-32769)&k[a>>2]|32768}e=k[x>>2]|0;if((e|0)!=1){if((e|0)>=1)m=78}else{k[a>>2]=k[a>>2]|16384;m=78}if((m|0)==78?(k[y>>2]|0)>=1:0){r=D;return}e=k[t>>2]|0;if(e|0?(C=e+12|0,a=k[C>>2]|0,k[C>>2]=a+-1,(a|0)==1):0){f=k[t>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[o>>2]|0;if(!e){e=B1()|0;f=k[t>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[t>>2]=0}k[t>>2]=0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;if((k[w>>2]|0)>0){f=k[v>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[w>>2]|0))}k[y>>2]=0;k[x>>2]=0;r=D;return}v=C+8|0;zpb(v|0,0,1088)|0;k[C>>2]=v;w=C+4|0;k[w>>2]=136;if(g>>>0>136){f=g>>>0>536870911?-1:g<<3;f=(f|0)==0?1:f;while(1){e=fgb(f)|0;if(e|0)break;e=k[207666]|0;k[207666]=e+0;if(!e){e=0;break}Qh[e&7]()}zpb(e|0,0,g<<3|0)|0;k[C>>2]=e}else e=v;k[w>>2]=g;y=c;x=k[y+4>>2]|0;k[e>>2]=k[y>>2];k[e+4>>2]=x;e=k[C>>2]|0;x=d;y=k[x+4>>2]|0;f=e+8|0;k[f>>2]=k[x>>2];k[f+4>>2]=y;f=k[j>>2]|0;if((f|0)>2){g=2;do{f=e+(g<<3)|0;k[f>>2]=-2147483648;k[f+4>>2]=2147483647;g=g+1|0;f=k[j>>2]|0;e=k[C>>2]|0}while((g|0)<(f|0))}k[B>>2]=1124007936;s=B+4|0;g=B+8|0;m=B+16|0;d=B+40|0;p=s;q=p+36|0;do{k[p>>2]=0;p=p+4|0}while((p|0)<(q|0));k[d>>2]=g;t=B+48|0;o=B+44|0;k[o>>2]=t;k[B+52>>2]=0;k[t>>2]=0;if((e|0)==0?(k[A>>2]=0,y=A+4|0,k[y>>2]=0,u=ZT(12)|0,k[u>>2]=1,x=u+4|0,k[A>>2]=x,k[y>>2]=6,i[u+10>>0]=0,i[x>>0]=i[217490]|0,i[x+1>>0]=i[217491]|0,i[x+2>>0]=i[217492]|0,i[x+3>>0]=i[217493]|0,i[x+4>>0]=i[217494]|0,i[x+5>>0]=i[217495]|0,Y8(-215,A,390638,216975,541),k[y>>2]=0,k[A>>2]=0,y=k[u>>2]|0,k[u>>2]=y+-1,(y|0)==1):0)ggb(k[u+-4>>2]|0);if((f|0)>0){j=b+40|0;l=A+4|0;c=0;do{h=e+(c<<3)|0;g=k[h>>2]|0;h=k[h+4>>2]|0;do if(!((g|0)==-2147483648&(h|0)==2147483647)){if((g|0)>-1&(g|0)<(h|0)?(h|0)<=(k[(k[j>>2]|0)+(c<<2)>>2]|0):0)break;k[A>>2]=0;k[l>>2]=0;g=ZT(84)|0;k[g>>2]=1;p=g+4|0;k[A>>2]=p;k[l>>2]=76;i[g+80>>0]=0;n=217497;q=p+76|0;do{i[p>>0]=i[n>>0]|0;p=p+1|0;n=n+1|0}while((p|0)<(q|0));Y8(-215,A,390638,216975,545);k[l>>2]=0;k[A>>2]=0;y=k[g>>2]|0;k[g>>2]=y+-1;if((y|0)==1)ggb(k[g+-4>>2]|0)}while(0);c=c+1|0}while((c|0)<(f|0));KG(B,b)|0;g=0;do{c=e+(g<<3)|0;h=k[c>>2]|0;c=k[c+4>>2]|0;if((h|0)!=-2147483648|(c|0)!=2147483647?(z=(k[d>>2]|0)+(g<<2)|0,h|0?1:(c|0)!=(k[z>>2]|0)):0){k[z>>2]=c-h;b=aa(k[(k[o>>2]|0)+(g<<2)>>2]|0,h)|0;k[m>>2]=(k[m>>2]|0)+b;k[B>>2]=k[B>>2]|32768}g=g+1|0}while((g|0)!=(f|0))}else KG(B,b)|0;f=k[s>>2]|0;c=k[d>>2]|0;a:do if((f|0)>0){e=0;do{if((k[c+(e<<2)>>2]|0)>1)break a;e=e+1|0}while((e|0)<(f|0))}else e=0;while(0);h=k[o>>2]|0;do{g=f;f=f+-1|0;if((f|0)<=(e|0))break;b=aa(k[c+(f<<2)>>2]|0,k[h+(f<<2)>>2]|0)|0}while(b>>>0>=(k[h+(g+-2<<2)>>2]|0)>>>0);b=k[c>>2]|0;b=Epb(b|0,((b|0)<0)<<31>>31|0,k[h>>2]|0,0)|0;g=k[B>>2]|0;k[B>>2]=(f|0)<=(e|0)&((b|0)==(b|0)&(N|0)==0)?g|16384:g&-16385;KG(a,B)|0;g=B+36|0;e=k[g>>2]|0;if(e|0?(b=e+12|0,a=k[b>>2]|0,k[b>>2]=a+-1,(a|0)==1):0){f=k[g>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[B+32>>2]|0;if(!e){e=B1()|0;f=k[g>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[g>>2]=0}k[g>>2]=0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[s>>2]|0)>0){f=k[d>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[s>>2]|0))}e=k[o>>2]|0;if(!((e|0)==(t|0)|(e|0)==0))ggb(k[e+-4>>2]|0);e=k[C>>2]|0;if((e|0)!=(v|0)){if(e|0)ggb(e);k[C>>2]=v;k[w>>2]=136}r=D;return}function I1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+16|0;o=B;d=k[b>>2]|0;k[a>>2]=d;y=a+4|0;k[y>>2]=2;z=a+8|0;t=c+12|0;k[z>>2]=k[t>>2];A=a+12|0;p=c+8|0;k[A>>2]=k[p>>2];v=a+16|0;m=c+4|0;q=b+44|0;e=(k[b+16>>2]|0)+(aa(k[k[q>>2]>>2]|0,k[m>>2]|0)|0)|0;k[v>>2]=e;k[a+20>>2]=k[b+20>>2];k[a+24>>2]=k[b+24>>2];k[a+28>>2]=k[b+28>>2];u=a+32|0;k[u>>2]=k[b+32>>2];w=a+36|0;k[w>>2]=k[b+36>>2];x=a+40|0;k[x>>2]=z;l=a+48|0;s=a+44|0;k[s>>2]=l;k[a+52>>2]=0;k[l>>2]=0;if((k[b+4>>2]|0)>=3){d=o+4|0;e=ZT(16)|0;k[e>>2]=1;f=e+4|0;k[o>>2]=f;k[d>>2]=11;i[e+15>>0]=0;g=233283;h=f+11|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,o,390638,216975,501);k[d>>2]=0;k[o>>2]=0;l=k[e>>2]|0;k[e>>2]=l+-1;if((l|0)==1)ggb(k[e+-4>>2]|0);d=k[a>>2]|0;e=k[v>>2]|0}g=k[p>>2]|0;l=b+12|0;h=k[l>>2]|0;f=k[t>>2]|0;k[a>>2]=((f|0)==1?16384:0)|((g|0)<(h|0)?-16385:-1)&d;j=(d>>>3&511)+1<<(47696>>>(d<<1&14)&3);c=k[c>>2]|0;e=e+(aa(j,c)|0)|0;k[v>>2]=e;if(!((!((c|g|0)<0|(g+c|0)>(h|0))?(n=k[m>>2]|0,(n|f|0)>-1):0)?(f+n|0)<=(k[b+8>>2]|0):0)){d=o+4|0;e=ZT(132)|0;k[e>>2]=1;f=e+4|0;k[o>>2]=f;k[d>>2]=124;i[e+128>>0]=0;g=233300;h=f+124|0;do{i[f>>0]=i[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Y8(-215,o,390638,216975,508);k[d>>2]=0;k[o>>2]=0;o=k[e>>2]|0;k[e>>2]=o+-1;if((o|0)==1)ggb(k[e+-4>>2]|0)}d=k[w>>2]|0;if(d|0){o=d+12|0;k[o>>2]=(k[o>>2]|0)+1}if(!((k[p>>2]|0)>=(k[l>>2]|0)?(k[t>>2]|0)>=(k[b+8>>2]|0):0))k[a>>2]=k[a>>2]|32768;t=k[s>>2]|0;k[t>>2]=k[k[q>>2]>>2];k[t+4>>2]=j;if((k[z>>2]|0)>=1?(k[A>>2]|0)>=1:0){r=B;return}d=k[w>>2]|0;if(d|0?(s=d+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){e=k[w>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[u>>2]|0;if(!d){d=B1()|0;e=k[w>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[w>>2]=0}k[w>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[y>>2]|0)>0){e=k[x>>2]|0;d=0;do{k[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[y>>2]|0))}k[A>>2]=0;k[z>>2]=0;r=B;return}function J1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+16|0;d=m;e=b+4|0;if((k[e>>2]|0)>=3){f=d+4|0;g=ZT(16)|0;k[g>>2]=1;h=g+4|0;k[d>>2]=h;k[f>>2]=9;i[g+13>>0]=0;j=217574;l=h+9|0;do{i[h>>0]=i[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(l|0));Y8(-215,d,217584,216975,684);k[f>>2]=0;k[d>>2]=0;l=k[g>>2]|0;k[g>>2]=l+-1;if((l|0)==1)ggb(k[g+-4>>2]|0)}AF(a,b);d=k[e>>2]|0;if((d|0)>0)f=k[(k[b+44>>2]|0)+(d+-1<<2)>>2]|0;else f=0;d=k[b+12>>2]|0;e=k[b+8>>2]|0;if((c|0)>-1){d=d-c|0;l=aa(f,c)|0;c=a+16|0;k[c>>2]=(k[c>>2]|0)+l;d=(e|0)<(d|0)?e:d}else{l=e+c|0;j=a+16|0;c=(k[j>>2]|0)+(aa(k[k[b+44>>2]>>2]|0,0-c|0)|0)|0;k[j>>2]=c;d=(d|0)<(l|0)?d:l}c=a+8|0;k[c>>2]=d;l=k[a+40>>2]|0;k[l>>2]=d;k[a+12>>2]=1;k[l+4>>2]=1;l=k[a+44>>2]|0;k[l>>2]=(k[l>>2]|0)+((d|0)>1?f:0);d=k[a>>2]|0;d=(k[c>>2]|0)>1?d&-16385:d|16384;k[a>>2]=d;b=k[b+40>>2]|0;if(!((k[b>>2]|0)!=1?1:(k[b+4>>2]|0)!=1)){r=m;return}k[a>>2]=d|32768;r=m;return}function K1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;s=r;r=r+144|0;j=s+120|0;l=s+112|0;q=s+56|0;p=s;if((b|0)<=-1){c=j+4|0;d=ZT(24)|0;k[d>>2]=1;f=d+4|0;k[j>>2]=f;k[c>>2]=16;i[d+20>>0]=0;e=217589;h=f+16|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(h|0));Y8(-215,j,217606,216975,755);k[c>>2]=0;k[j>>2]=0;o=k[d>>2]|0;k[d>>2]=o+-1;if((o|0)==1)ggb(k[d+-4>>2]|0)}if((k[a>>2]&32768|0)==0?(o=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,b)|0)|0,o>>>0<=(k[a+28>>2]|0)>>>0):0){r=s;return}n=a+40|0;c=k[n>>2]|0;o=k[c>>2]|0;if(o>>>0>=b>>>0){r=s;return}k[c>>2]=(b|0)<1?1:b;f=a+4|0;g=k[f>>2]|0;if((g|0)<3)c=aa(k[a+12>>2]|0,k[a+8>>2]|0)|0;else{e=k[n>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(g|0))}if((g|0)>0)d=k[(k[a+44>>2]|0)+(g+-1<<2)>>2]|0;else d=0;c=aa(d,c)|0;if(c>>>0<64){g=((aa(c+63|0,b)|0)>>>0)/(c>>>0)|0;k[k[n>>2]>>2]=g;g=k[f>>2]|0}d=k[n>>2]|0;e=k[a>>2]&4095;k[q>>2]=1124007936;m=q+4|0;c=q+8|0;b=q+40|0;f=m;h=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(h|0));k[b>>2]=c;h=q+48|0;f=q+44|0;k[f>>2]=h;k[q+52>>2]=0;k[h>>2]=0;G1(q,g,d,e);k[k[n>>2]>>2]=o;if((o|0)>0){k[j>>2]=0;k[j+4>>2]=o;k[l>>2]=-2147483648;k[l+4>>2]=2147483647;H1(p,q,j,l);e=j+4|0;c=e+4|0;k[c>>2]=0;k[c+4>>2]=0;k[j>>2]=33619968;k[e>>2]=p;mY(a,j);e=p+36|0;c=k[e>>2]|0;if(c|0?(j=c+12|0,l=k[j>>2]|0,k[j>>2]=l+-1,(l|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[p+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;l=p+16|0;d=p+4|0;k[l>>2]=0;k[l+4>>2]=0;k[l+8>>2]=0;k[l+12>>2]=0;if((k[d>>2]|0)>0){e=k[p+40>>2]|0;c=0;do{k[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[d>>2]|0))}c=k[p+44>>2]|0;if(!((c|0)==(p+48|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}KG(a,q)|0;k[k[n>>2]>>2]=o;e=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,o)|0)|0;k[a+24>>2]=e;e=q+36|0;c=k[e>>2]|0;if(c|0?(a=c+12|0,p=k[a>>2]|0,k[a>>2]=p+-1,(p|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[q+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;q=q+16|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[m>>2]|0)>0){d=k[b>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[m>>2]|0))}c=k[f>>2]|0;if(!((c|0)==(h|0)|(c|0)==0))ggb(k[c+-4>>2]|0);r=s;return}
function lka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72392;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function mka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72392;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function nka(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,l=0.0,m=0.0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0;x=+o[a+56>>2];u=k[a+20>>2]|0;v=k[a+32>>2]|0;w=k[a+44>>2]|0;a=(k[a+24>>2]|0)-u|0;t=a>>3;s=aa(g,f)|0;if((e|0)<=0)return;n=(a|0)>0;p=s+-4|0;q=(s|0)<4;r=s&-4;while(1){if(n){a=0;do{f=(k[b+(k[u+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[u+(a<<3)>>2]|0,g)|0)<<1)|0;k[w+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(t|0))}a:do if(q)a=0;else{if(n)a=0;else{a=0;while(1){o[c+(a<<2)>>2]=x;o[c+((a|1)<<2)>>2]=x;o[c+((a|2)<<2)>>2]=x;o[c+((a|3)<<2)>>2]=x;a=a+4|0;if((a|0)>(p|0)){a=r;break a}}}do{h=x;i=x;l=x;m=x;f=0;do{y=(k[w+(f<<2)>>2]|0)+(a<<1)|0;z=+o[v+(f<<2)>>2];m=m+z*+(j[y>>1]|0);l=l+z*+(j[y+2>>1]|0);i=i+z*+(j[y+4>>1]|0);h=h+z*+(j[y+6>>1]|0);f=f+1|0}while((f|0)<(t|0));o[c+(a<<2)>>2]=m;o[c+((a|1)<<2)>>2]=l;o[c+((a|2)<<2)>>2]=i;o[c+((a|3)<<2)>>2]=h;a=a+4|0}while((a|0)<=(p|0));a=r}while(0);b:do if((a|0)<(s|0)){if(!n)while(1){o[c+(a<<2)>>2]=x;a=a+1|0;if((a|0)==(s|0))break b}do{h=x;f=0;do{h=h+ +o[v+(f<<2)>>2]*+(j[(k[w+(f<<2)>>2]|0)+(a<<1)>>1]|0);f=f+1|0}while((f|0)<(t|0));o[c+(a<<2)>>2]=h;a=a+1|0}while((a|0)!=(s|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function oka(a){a=a|0;ggb(a);return}function pka(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function qka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72416;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function rka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72416;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function ska(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,l=0.0,m=0.0,n=0.0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0.0;C=+o[a+56>>2];z=k[a+20>>2]|0;A=k[a+32>>2]|0;B=k[a+44>>2]|0;a=(k[a+24>>2]|0)-z|0;y=a>>3;x=aa(g,f)|0;if((e|0)<=0)return;p=(a|0)>0;q=x+-4|0;r=(x|0)<4;s=x&-4;f=(o[u>>2]=C,k[u>>2]|0);t=(f&2130706432)>>>0>1249902592;f=(f|0)<0;n=f?C+-8388608.0+8388608.0:C+8388608.0+-8388608.0;v=n==0.0;w=f?-0.0:0.0;while(1){if(p){a=0;do{f=(k[b+(k[z+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[z+(a<<3)>>2]|0,g)|0)<<1)|0;k[B+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(y|0))}a:do if(r)a=0;else{if(p)f=0;else{f=~~(t|v^1?(t?C:n):w);f=((f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768)&65535;a=0;while(1){j[c+(a<<1)>>1]=f;j[c+((a|1)<<1)>>1]=f;j[c+((a|2)<<1)>>1]=f;j[c+((a|3)<<1)>>1]=f;a=a+4|0;if((a|0)>(q|0)){a=s;break a}}}do{h=C;i=C;l=C;m=C;a=0;do{D=(k[B+(a<<2)>>2]|0)+(f<<1)|0;E=+o[A+(a<<2)>>2];m=m+E*+(j[D>>1]|0);l=l+E*+(j[D+2>>1]|0);i=i+E*+(j[D+4>>1]|0);h=h+E*+(j[D+6>>1]|0);a=a+1|0}while((a|0)<(y|0));a=(o[u>>2]=m,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}a=~~m;j[c+(f<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=l,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;l=a?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;j[c+((f|1)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=i,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;i=a?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=a?-0.0:0.0}a=~~i;j[c+((f|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}D=~~h;j[c+((f|3)<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;f=f+4|0}while((f|0)<=(q|0));a=s}while(0);b:do if((a|0)<(x|0)){if(!p){f=~~(t|v^1?(t?C:n):w);f=((f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768)&65535;while(1){j[c+(a<<1)>>1]=f;a=a+1|0;if((a|0)==(x|0))break b}}do{h=C;f=0;do{h=h+ +o[A+(f<<2)>>2]*+(j[(k[B+(f<<2)>>2]|0)+(a<<1)>>1]|0);f=f+1|0}while((f|0)<(y|0));f=(o[u>>2]=h,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;h=f?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=f?-0.0:0.0}D=~~h;j[c+(a<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function tka(a){a=a|0;ggb(a);return}function uka(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function vka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72440;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function wka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72440;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function xka(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,l=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0;x=+p[a+56>>3];u=k[a+20>>2]|0;v=k[a+32>>2]|0;w=k[a+44>>2]|0;a=(k[a+24>>2]|0)-u|0;t=a>>3;s=aa(g,f)|0;if((e|0)<=0)return;n=(a|0)>0;o=s+-4|0;q=(s|0)<4;r=s&-4;while(1){if(n){a=0;do{f=(k[b+(k[u+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[u+(a<<3)>>2]|0,g)|0)<<1)|0;k[w+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(t|0))}a:do if(q)a=0;else{if(n)a=0;else{a=0;while(1){p[c+(a<<3)>>3]=x;p[c+((a|1)<<3)>>3]=x;p[c+((a|2)<<3)>>3]=x;p[c+((a|3)<<3)>>3]=x;a=a+4|0;if((a|0)>(o|0)){a=r;break a}}}do{h=x;i=x;j=x;l=x;f=0;do{y=(k[w+(f<<2)>>2]|0)+(a<<1)|0;z=+p[v+(f<<3)>>3];l=l+z*+(m[y>>1]|0);j=j+z*+(m[y+2>>1]|0);i=i+z*+(m[y+4>>1]|0);h=h+z*+(m[y+6>>1]|0);f=f+1|0}while((f|0)<(t|0));p[c+(a<<3)>>3]=l;p[c+((a|1)<<3)>>3]=j;p[c+((a|2)<<3)>>3]=i;p[c+((a|3)<<3)>>3]=h;a=a+4|0}while((a|0)<=(o|0));a=r}while(0);b:do if((a|0)<(s|0)){if(!n)while(1){p[c+(a<<3)>>3]=x;a=a+1|0;if((a|0)==(s|0))break b}do{h=x;f=0;do{h=h+ +p[v+(f<<3)>>3]*+(m[(k[w+(f<<2)>>2]|0)+(a<<1)>>1]|0);f=f+1|0}while((f|0)<(t|0));p[c+(a<<3)>>3]=h;a=a+1|0}while((a|0)!=(s|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function yka(a){a=a|0;ggb(a);return}function zka(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Aka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72464;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function Bka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72464;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Cka(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,l=0.0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0;x=+o[a+56>>2];u=k[a+20>>2]|0;v=k[a+32>>2]|0;w=k[a+44>>2]|0;a=(k[a+24>>2]|0)-u|0;t=a>>3;s=aa(g,f)|0;if((e|0)<=0)return;n=(a|0)>0;p=s+-4|0;q=(s|0)<4;r=s&-4;while(1){if(n){a=0;do{f=(k[b+(k[u+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[u+(a<<3)>>2]|0,g)|0)<<1)|0;k[w+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(t|0))}a:do if(q)a=0;else{if(n)a=0;else{a=0;while(1){o[c+(a<<2)>>2]=x;o[c+((a|1)<<2)>>2]=x;o[c+((a|2)<<2)>>2]=x;o[c+((a|3)<<2)>>2]=x;a=a+4|0;if((a|0)>(p|0)){a=r;break a}}}do{h=x;i=x;j=x;l=x;f=0;do{y=(k[w+(f<<2)>>2]|0)+(a<<1)|0;z=+o[v+(f<<2)>>2];l=l+z*+(m[y>>1]|0);j=j+z*+(m[y+2>>1]|0);i=i+z*+(m[y+4>>1]|0);h=h+z*+(m[y+6>>1]|0);f=f+1|0}while((f|0)<(t|0));o[c+(a<<2)>>2]=l;o[c+((a|1)<<2)>>2]=j;o[c+((a|2)<<2)>>2]=i;o[c+((a|3)<<2)>>2]=h;a=a+4|0}while((a|0)<=(p|0));a=r}while(0);b:do if((a|0)<(s|0)){if(!n)while(1){o[c+(a<<2)>>2]=x;a=a+1|0;if((a|0)==(s|0))break b}do{h=x;f=0;do{h=h+ +o[v+(f<<2)>>2]*+(m[(k[w+(f<<2)>>2]|0)+(a<<1)>>1]|0);f=f+1|0}while((f|0)<(t|0));o[c+(a<<2)>>2]=h;a=a+1|0}while((a|0)!=(s|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function Dka(a){a=a|0;ggb(a);return}function Eka(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Fka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72488;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function Gka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72488;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Hka(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,l=0.0,n=0.0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0.0;D=+o[a+56>>2];A=k[a+20>>2]|0;B=k[a+32>>2]|0;C=k[a+44>>2]|0;a=(k[a+24>>2]|0)-A|0;z=a>>3;y=aa(g,f)|0;if((e|0)<=0)return;q=(a|0)>0;r=y+-4|0;s=(y|0)<4;t=y&-4;f=(o[u>>2]=D,k[u>>2]|0);v=(f&2130706432)>>>0>1249902592;f=(f|0)<0;p=f?D+-8388608.0+8388608.0:D+8388608.0+-8388608.0;w=p==0.0;x=f?-0.0:0.0;while(1){if(q){a=0;do{f=(k[b+(k[A+(a<<3)+4>>2]<<2)>>2]|0)+((aa(k[A+(a<<3)>>2]|0,g)|0)<<1)|0;k[C+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(z|0))}a:do if(s)a=0;else{if(q)f=0;else{f=~~(v|w^1?(v?D:p):x);f=(f>>>0<65536?f:(f|0)>0?65535:0)&65535;a=0;while(1){j[c+(a<<1)>>1]=f;j[c+((a|1)<<1)>>1]=f;j[c+((a|2)<<1)>>1]=f;j[c+((a|3)<<1)>>1]=f;a=a+4|0;if((a|0)>(r|0)){a=t;break a}}}do{h=D;i=D;l=D;n=D;a=0;do{E=(k[C+(a<<2)>>2]|0)+(f<<1)|0;F=+o[B+(a<<2)>>2];n=n+F*+(m[E>>1]|0);l=l+F*+(m[E+2>>1]|0);i=i+F*+(m[E+4>>1]|0);h=h+F*+(m[E+6>>1]|0);a=a+1|0}while((a|0)<(z|0));a=(o[u>>2]=n,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;n=a?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=a?-0.0:0.0}a=~~n;j[c+(f<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=l,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;l=a?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=a?-0.0:0.0}a=~~l;j[c+((f|1)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=i,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;i=a?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=a?-0.0:0.0}a=~~i;j[c+((f|2)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}E=~~h;j[c+((f|3)<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;f=f+4|0}while((f|0)<=(r|0));a=t}while(0);b:do if((a|0)<(y|0)){if(!q){f=~~(v|w^1?(v?D:p):x);f=(f>>>0<65536?f:(f|0)>0?65535:0)&65535;while(1){j[c+(a<<1)>>1]=f;a=a+1|0;if((a|0)==(y|0))break b}}do{h=D;f=0;do{h=h+ +o[B+(f<<2)>>2]*+(m[(k[C+(f<<2)>>2]|0)+(a<<1)>>1]|0);f=f+1|0}while((f|0)<(z|0));f=(o[u>>2]=h,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;h=f?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=f?-0.0:0.0}E=~~h;j[c+(a<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;a=a+1|0}while((a|0)!=(y|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function Ika(a){a=a|0;ggb(a);return}function Jka(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Kka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72512;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function Lka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72512;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Mka(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0;x=+p[a+56>>3];u=k[a+20>>2]|0;v=k[a+32>>2]|0;w=k[a+44>>2]|0;a=(k[a+24>>2]|0)-u|0;t=a>>3;s=aa(g,f)|0;if((e|0)<=0)return;n=(a|0)>0;o=s+-4|0;q=(s|0)<4;r=s&-4;while(1){if(n){a=0;do{f=(k[b+(k[u+(a<<3)+4>>2]<<2)>>2]|0)+(aa(k[u+(a<<3)>>2]|0,g)|0)|0;k[w+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(t|0))}a:do if(q)a=0;else{if(n)a=0;else{a=0;while(1){p[c+(a<<3)>>3]=x;p[c+((a|1)<<3)>>3]=x;p[c+((a|2)<<3)>>3]=x;p[c+((a|3)<<3)>>3]=x;a=a+4|0;if((a|0)>(o|0)){a=r;break a}}}do{h=x;i=x;j=x;m=x;f=0;do{y=(k[w+(f<<2)>>2]|0)+a|0;z=+p[v+(f<<3)>>3];m=m+z*+(l[y>>0]|0);j=j+z*+(l[y+1>>0]|0);i=i+z*+(l[y+2>>0]|0);h=h+z*+(l[y+3>>0]|0);f=f+1|0}while((f|0)<(t|0));p[c+(a<<3)>>3]=m;p[c+((a|1)<<3)>>3]=j;p[c+((a|2)<<3)>>3]=i;p[c+((a|3)<<3)>>3]=h;a=a+4|0}while((a|0)<=(o|0));a=r}while(0);b:do if((a|0)<(s|0)){if(!n)while(1){p[c+(a<<3)>>3]=x;a=a+1|0;if((a|0)==(s|0))break b}do{h=x;f=0;do{h=h+ +p[v+(f<<3)>>3]*+(l[(k[w+(f<<2)>>2]|0)+a>>0]|0);f=f+1|0}while((f|0)<(t|0));p[c+(a<<3)>>3]=h;a=a+1|0}while((a|0)!=(s|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function Nka(a){a=a|0;ggb(a);return}function Oka(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Pka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72536;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function Qka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72536;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Rka(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,m=0.0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0;x=+o[a+56>>2];u=k[a+20>>2]|0;v=k[a+32>>2]|0;w=k[a+44>>2]|0;a=(k[a+24>>2]|0)-u|0;t=a>>3;s=aa(g,f)|0;if((e|0)<=0)return;n=(a|0)>0;p=s+-4|0;q=(s|0)<4;r=s&-4;while(1){if(n){a=0;do{f=(k[b+(k[u+(a<<3)+4>>2]<<2)>>2]|0)+(aa(k[u+(a<<3)>>2]|0,g)|0)|0;k[w+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(t|0))}a:do if(q)a=0;else{if(n)a=0;else{a=0;while(1){o[c+(a<<2)>>2]=x;o[c+((a|1)<<2)>>2]=x;o[c+((a|2)<<2)>>2]=x;o[c+((a|3)<<2)>>2]=x;a=a+4|0;if((a|0)>(p|0)){a=r;break a}}}do{h=x;i=x;j=x;m=x;f=0;do{y=(k[w+(f<<2)>>2]|0)+a|0;z=+o[v+(f<<2)>>2];m=m+z*+(l[y>>0]|0);j=j+z*+(l[y+1>>0]|0);i=i+z*+(l[y+2>>0]|0);h=h+z*+(l[y+3>>0]|0);f=f+1|0}while((f|0)<(t|0));o[c+(a<<2)>>2]=m;o[c+((a|1)<<2)>>2]=j;o[c+((a|2)<<2)>>2]=i;o[c+((a|3)<<2)>>2]=h;a=a+4|0}while((a|0)<=(p|0));a=r}while(0);b:do if((a|0)<(s|0)){if(!n)while(1){o[c+(a<<2)>>2]=x;a=a+1|0;if((a|0)==(s|0))break b}do{h=x;f=0;do{h=h+ +o[v+(f<<2)>>2]*+(l[(k[w+(f<<2)>>2]|0)+a>>0]|0);f=f+1|0}while((f|0)<(t|0));o[c+(a<<2)>>2]=h;a=a+1|0}while((a|0)!=(s|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function Ska(a){a=a|0;ggb(a);return}function Tka(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Uka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72560;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function Vka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72560;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Wka(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,m=0.0,n=0.0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0.0;D=+o[a+56>>2];A=k[a+20>>2]|0;B=k[a+32>>2]|0;C=k[a+44>>2]|0;a=(k[a+24>>2]|0)-A|0;z=a>>3;y=aa(g,f)|0;if((e|0)<=0)return;q=(a|0)>0;r=y+-4|0;s=(y|0)<4;t=y&-4;f=(o[u>>2]=D,k[u>>2]|0);v=(f&2130706432)>>>0>1249902592;f=(f|0)<0;p=f?D+-8388608.0+8388608.0:D+8388608.0+-8388608.0;w=p==0.0;x=f?-0.0:0.0;while(1){if(q){a=0;do{f=(k[b+(k[A+(a<<3)+4>>2]<<2)>>2]|0)+(aa(k[A+(a<<3)>>2]|0,g)|0)|0;k[C+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(z|0))}a:do if(s)a=0;else{if(q)f=0;else{f=~~(v|w^1?(v?D:p):x);f=((f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768)&65535;a=0;while(1){j[c+(a<<1)>>1]=f;j[c+((a|1)<<1)>>1]=f;j[c+((a|2)<<1)>>1]=f;j[c+((a|3)<<1)>>1]=f;a=a+4|0;if((a|0)>(r|0)){a=t;break a}}}do{h=D;i=D;m=D;n=D;a=0;do{E=(k[C+(a<<2)>>2]|0)+f|0;F=+o[B+(a<<2)>>2];n=n+F*+(l[E>>0]|0);m=m+F*+(l[E+1>>0]|0);i=i+F*+(l[E+2>>0]|0);h=h+F*+(l[E+3>>0]|0);a=a+1|0}while((a|0)<(z|0));a=(o[u>>2]=n,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;n=a?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=a?-0.0:0.0}a=~~n;j[c+(f<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=m,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}a=~~m;j[c+((f|1)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=i,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;i=a?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=a?-0.0:0.0}a=~~i;j[c+((f|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}E=~~h;j[c+((f|3)<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;f=f+4|0}while((f|0)<=(r|0));a=t}while(0);b:do if((a|0)<(y|0)){if(!q){f=~~(v|w^1?(v?D:p):x);f=((f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768)&65535;while(1){j[c+(a<<1)>>1]=f;a=a+1|0;if((a|0)==(y|0))break b}}do{h=D;f=0;do{h=h+ +o[B+(f<<2)>>2]*+(l[(k[C+(f<<2)>>2]|0)+a>>0]|0);f=f+1|0}while((f|0)<(z|0));f=(o[u>>2]=h,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;h=f?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=f?-0.0:0.0}E=~~h;j[c+(a<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;a=a+1|0}while((a|0)!=(y|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function Xka(a){a=a|0;ggb(a);return}function Yka(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Zka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72584;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function _ka(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72584;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function $ka(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,m=0.0,n=0.0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0.0;D=+o[a+56>>2];A=k[a+20>>2]|0;B=k[a+32>>2]|0;C=k[a+44>>2]|0;a=(k[a+24>>2]|0)-A|0;z=a>>3;y=aa(g,f)|0;if((e|0)<=0)return;q=(a|0)>0;r=y+-4|0;s=(y|0)<4;t=y&-4;f=(o[u>>2]=D,k[u>>2]|0);v=(f&2130706432)>>>0>1249902592;f=(f|0)<0;p=f?D+-8388608.0+8388608.0:D+8388608.0+-8388608.0;w=p==0.0;x=f?-0.0:0.0;while(1){if(q){a=0;do{f=(k[b+(k[A+(a<<3)+4>>2]<<2)>>2]|0)+(aa(k[A+(a<<3)>>2]|0,g)|0)|0;k[C+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(z|0))}a:do if(s)a=0;else{if(q)f=0;else{f=~~(v|w^1?(v?D:p):x);f=(f>>>0<65536?f:(f|0)>0?65535:0)&65535;a=0;while(1){j[c+(a<<1)>>1]=f;j[c+((a|1)<<1)>>1]=f;j[c+((a|2)<<1)>>1]=f;j[c+((a|3)<<1)>>1]=f;a=a+4|0;if((a|0)>(r|0)){a=t;break a}}}do{h=D;i=D;m=D;n=D;a=0;do{E=(k[C+(a<<2)>>2]|0)+f|0;F=+o[B+(a<<2)>>2];n=n+F*+(l[E>>0]|0);m=m+F*+(l[E+1>>0]|0);i=i+F*+(l[E+2>>0]|0);h=h+F*+(l[E+3>>0]|0);a=a+1|0}while((a|0)<(z|0));a=(o[u>>2]=n,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;n=a?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=a?-0.0:0.0}a=~~n;j[c+(f<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=m,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}a=~~m;j[c+((f|1)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=i,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;i=a?i+-8388608.0+8388608.0:i+8388608.0+-8388608.0;if(i==0.0)i=a?-0.0:0.0}a=~~i;j[c+((f|2)<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}E=~~h;j[c+((f|3)<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;f=f+4|0}while((f|0)<=(r|0));a=t}while(0);b:do if((a|0)<(y|0)){if(!q){f=~~(v|w^1?(v?D:p):x);f=(f>>>0<65536?f:(f|0)>0?65535:0)&65535;while(1){j[c+(a<<1)>>1]=f;a=a+1|0;if((a|0)==(y|0))break b}}do{h=D;f=0;do{h=h+ +o[B+(f<<2)>>2]*+(l[(k[C+(f<<2)>>2]|0)+a>>0]|0);f=f+1|0}while((f|0)<(z|0));f=(o[u>>2]=h,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;h=f?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=f?-0.0:0.0}E=~~h;j[c+(a<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;a=a+1|0}while((a|0)!=(y|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function ala(a){a=a|0;ggb(a);return}function bla(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function cla(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72608;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}d=k[a+20>>2]|0;if(!d)return;b=a+24|0;c=k[b>>2]|0;if((c|0)!=(d|0))k[b>>2]=c+(~((c+-8-d|0)>>>3)<<3);ggb(d);return}function dla(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=72608;b=k[a+44>>2]|0;c=b;if(b|0){d=a+48|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}b=k[a+32>>2]|0;if(b|0){c=a+36|0;if((k[c>>2]|0)!=(b|0))k[c>>2]=b;ggb(b)}b=k[a+20>>2]|0;if(!b){ggb(a);return}c=a+24|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function ela(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,j=0.0,m=0.0,n=0.0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0.0;D=+o[a+56>>2];A=k[a+20>>2]|0;B=k[a+32>>2]|0;C=k[a+44>>2]|0;a=(k[a+24>>2]|0)-A|0;z=a>>3;y=aa(g,f)|0;if((e|0)<=0)return;q=(a|0)>0;r=y+-4|0;s=(y|0)<4;t=y&-4;f=(o[u>>2]=D,k[u>>2]|0);v=(f&2130706432)>>>0>1249902592;f=(f|0)<0;p=f?D+-8388608.0+8388608.0:D+8388608.0+-8388608.0;w=p==0.0;x=f?-0.0:0.0;while(1){if(q){a=0;do{f=(k[b+(k[A+(a<<3)+4>>2]<<2)>>2]|0)+(aa(k[A+(a<<3)>>2]|0,g)|0)|0;k[C+(a<<2)>>2]=f;a=a+1|0}while((a|0)<(z|0))}a:do if(s)a=0;else{if(q)f=0;else{f=~~(v|w^1?(v?D:p):x);f=(f>>>0<256?f:(f|0)>0?255:0)&255;a=0;while(1){i[c+a>>0]=f;i[c+(a|1)>>0]=f;i[c+(a|2)>>0]=f;i[c+(a|3)>>0]=f;a=a+4|0;if((a|0)>(r|0)){a=t;break a}}}do{h=D;j=D;m=D;n=D;a=0;do{E=(k[C+(a<<2)>>2]|0)+f|0;F=+o[B+(a<<2)>>2];n=n+F*+(l[E>>0]|0);m=m+F*+(l[E+1>>0]|0);j=j+F*+(l[E+2>>0]|0);h=h+F*+(l[E+3>>0]|0);a=a+1|0}while((a|0)<(z|0));a=(o[u>>2]=n,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;n=a?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=a?-0.0:0.0}a=~~n;i[c+f>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(o[u>>2]=m,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;m=a?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=a?-0.0:0.0}a=~~m;i[c+(f|1)>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(o[u>>2]=j,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;j=a?j+-8388608.0+8388608.0:j+8388608.0+-8388608.0;if(j==0.0)j=a?-0.0:0.0}a=~~j;i[c+(f|2)>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(o[u>>2]=h,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;h=a?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=a?-0.0:0.0}E=~~h;i[c+(f|3)>>0]=E>>>0<256?E:(E|0)>0?255:0;f=f+4|0}while((f|0)<=(r|0));a=t}while(0);b:do if((a|0)<(y|0)){if(!q){f=~~(v|w^1?(v?D:p):x);f=(f>>>0<256?f:(f|0)>0?255:0)&255;while(1){i[c+a>>0]=f;a=a+1|0;if((a|0)==(y|0))break b}}do{h=D;f=0;do{h=h+ +o[B+(f<<2)>>2]*+(l[(k[C+(f<<2)>>2]|0)+a>>0]|0);f=f+1|0}while((f|0)<(z|0));f=(o[u>>2]=h,k[u>>2]|0);if((f&2130706432)>>>0<=1249902592){f=(f|0)<0;h=f?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=f?-0.0:0.0}E=~~h;i[c+a>>0]=E>>>0<256?E:(E|0)>0?255:0;a=a+1|0}while((a|0)!=(y|0))}while(0);if((e|0)>1){b=b+4|0;c=c+d|0;e=e+-1|0}else break}return}function fla(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=r;r=r+416|0;K=P+360|0;H=P+304|0;G=P+288|0;F=P+272|0;C=P+264|0;D=P+256|0;B=P+32|0;O=P+192|0;N=P+128|0;s=P+248|0;M=P+64|0;v=P+184|0;w=P+120|0;t=P+56|0;u=P+48|0;E=P;J=P+40|0;p[B>>3]=f;do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[O>>2]=k[l>>2];q=O+4|0;a=l+4|0;k[q>>2]=k[a>>2];L=O+8|0;k[L>>2]=k[l+8>>2];k[O+12>>2]=k[l+12>>2];k[O+16>>2]=k[l+16>>2];k[O+20>>2]=k[l+20>>2];k[O+24>>2]=k[l+24>>2];k[O+28>>2]=k[l+28>>2];k[O+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[O+36>>2]=h;j=O+40|0;k[j>>2]=L;L=O+48|0;n=O+44|0;k[n>>2]=L;k[O+52>>2]=0;k[L>>2]=0;if(h|0){L=h+12|0;k[L>>2]=(k[L>>2]|0)+1}if((k[a>>2]|0)<3){I=k[l+44>>2]|0;L=k[n>>2]|0;k[L>>2]=k[I>>2];k[L+4>>2]=k[I+4>>2];break}k[q>>2]=0;x1(O,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(O,a,-1);while(0);do if((k[d>>2]&2031616|0)==65536){m=k[d+4>>2]|0;k[N>>2]=k[m>>2];q=N+4|0;h=m+4|0;k[q>>2]=k[h>>2];L=N+8|0;k[L>>2]=k[m+8>>2];k[N+12>>2]=k[m+12>>2];k[N+16>>2]=k[m+16>>2];k[N+20>>2]=k[m+20>>2];k[N+24>>2]=k[m+24>>2];k[N+28>>2]=k[m+28>>2];k[N+32>>2]=k[m+32>>2];a=k[m+36>>2]|0;k[N+36>>2]=a;j=N+40|0;k[j>>2]=L;L=N+48|0;n=N+44|0;k[n>>2]=L;k[N+52>>2]=0;k[L>>2]=0;if(a|0){L=a+12|0;k[L>>2]=(k[L>>2]|0)+1}if((k[h>>2]|0)<3){I=k[m+44>>2]|0;L=k[n>>2]|0;k[L>>2]=k[I>>2];k[L+4>>2]=k[I+4>>2];break}k[q>>2]=0;x1(N,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[m+40>>2]|0;l=k[j>>2]|0;j=k[m+44>>2]|0;h=k[n>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(N,d,-1);while(0);I=k[O>>2]|0;L=O+40|0;A=k[L>>2]|0;d=k[A>>2]|0;k[s>>2]=k[A+4>>2];k[s+4>>2]=d;d=((c|0)<0?I:c)&7;x2(b,s,I&4088|d,0);do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[M>>2]=k[l>>2];q=M+4|0;a=l+4|0;k[q>>2]=k[a>>2];I=M+8|0;k[I>>2]=k[l+8>>2];k[M+12>>2]=k[l+12>>2];k[M+16>>2]=k[l+16>>2];k[M+20>>2]=k[l+20>>2];k[M+24>>2]=k[l+24>>2];k[M+28>>2]=k[l+28>>2];k[M+32>>2]=k[l+32>>2];h=k[l+36>>2]|0;k[M+36>>2]=h;j=M+40|0;k[j>>2]=I;I=M+48|0;n=M+44|0;k[n>>2]=I;k[M+52>>2]=0;k[I>>2]=0;if(h|0){I=h+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[a>>2]|0)<3){A=k[l+44>>2]|0;I=k[n>>2]|0;k[I>>2]=k[A>>2];k[I+4>>2]=k[A+4>>2];break}k[q>>2]=0;x1(M,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;h=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(M,b,-1);while(0);z=k[e>>2]|0;A=k[e+4>>2]|0;I=N+40|0;y=k[I>>2]|0;x=k[y+4>>2]|0;y=k[y>>2]|0;z=(z|0)==-1?(x|0)/2|0:z;A=(A|0)==-1?(y|0)/2|0:A;if(!((z|0)>-1&(z|0)<(x|0)?(A|0)>-1&(A|0)<(y|0):0)){k[K>>2]=0;a=K+4|0;k[a>>2]=0;h=ZT(60)|0;k[h>>2]=1;l=h+4|0;k[K>>2]=l;k[a>>2]=52;i[h+56>>0]=0;j=344955;n=l+52|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(n|0));Y8(-215,K,345008,345024,363);k[a>>2]=0;k[K>>2]=0;y=k[h>>2]|0;k[h>>2]=y+-1;if((y|0)==1)ggb(k[h+-4>>2]|0)}h=k[N+12>>2]|0;l=k[N+8>>2]|0;if((aa(l,h)|0)>49){k[H>>2]=1124007936;o=H+4|0;a=H+8|0;m=H+40|0;l=o;n=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(n|0));k[m>>2]=a;n=H+48|0;l=H+44|0;k[l>>2]=n;k[H+52>>2]=0;k[n>>2]=0;if((k[O>>2]&4088|0)!=0&+p[B>>3]!=0.0){h=k[M>>2]|0;a=h&7;if((a+-5|0)>>>0<2?(k[O+16>>2]|0)!=(k[M+16>>2]|0):0)KG(H,M)|0;else{a=(a|0)==6?6:5;E=k[M+40>>2]|0;J=k[E+4>>2]|0;k[K>>2]=k[E>>2];k[K+4>>2]=J;G1(H,2,K,a|h&4088)}E=k[L>>2]|0;J=k[E>>2]|0;k[v>>2]=k[E+4>>2];k[v+4>>2]=J;J=k[O>>2]&4088|a;k[w>>2]=z;k[w+4>>2]=A;Wua(O,N,H,v,J,w,0.0,g);k[K+8>>2]=0;k[K+12>>2]=0;k[K>>2]=16842752;k[K+4>>2]=H;k[G>>2]=-1056833530;k[G+4>>2]=B;k[G+8>>2]=1;k[G+12>>2]=1;g=F+4|0;J=g+4|0;k[J>>2]=0;k[J+4>>2]=0;k[F>>2]=33619968;k[g>>2]=H;sU(K,G,F,49332,-1,39936,0,0);if((k[H+16>>2]|0)!=(k[M+16>>2]|0)){g=K+4|0;J=g+4|0;k[J>>2]=0;k[J+4>>2]=0;k[K>>2]=33619968;k[g>>2]=M;SW(H,K,k[M>>2]&4095,1.0,0.0)}}else{a=M+16|0;if((k[O+16>>2]|0)==(k[a>>2]|0)){F=k[M+40>>2]|0;G=k[F+4>>2]|0;J=k[M>>2]&4095;k[K>>2]=k[F>>2];k[K+4>>2]=G;G1(H,2,K,J)}else KG(H,M)|0;G=k[L>>2]|0;J=k[G>>2]|0;k[t>>2]=k[G+4>>2];k[t+4>>2]=J;J=k[O>>2]&4088|d;k[u>>2]=z;k[u+4>>2]=A;Wua(O,N,H,t,J,u,+p[B>>3],g);if((k[H+16>>2]|0)!=(k[a>>2]|0)){g=K+4|0;J=g+4|0;k[J>>2]=0;k[J+4>>2]=0;k[K>>2]=33619968;k[g>>2]=M;mY(H,K)}}j=H+36|0;a=k[j>>2]|0;if(a|0?(g=a+12|0,K=k[g>>2]|0,k[g>>2]=K+-1,(K|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[H+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;K=H+16|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[o>>2]|0)>0){h=k[m>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[o>>2]|0))}a=k[l>>2]|0;if(!((a|0)==(n|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else{q=k[O>>2]|0;x=q&4095;d=k[M>>2]|0;y=d&4095;f=+p[B>>3];k[E>>2]=0;k[E+4>>2]=0;k[E+8>>2]=0;k[E+12>>2]=0;k[E+16>>2]=0;k[E+20>>2]=0;k[E+24>>2]=0;k[E+28>>2]=0;v=g&-17;k[K>>2]=k[N>>2];o=K+4|0;j=N+4|0;a=k[j>>2]|0;k[o>>2]=a;B=K+8|0;k[B>>2]=l;k[K+12>>2]=h;k[K+16>>2]=k[N+16>>2];k[K+20>>2]=k[N+20>>2];k[K+24>>2]=k[N+24>>2];k[K+28>>2]=k[N+28>>2];k[K+32>>2]=k[N+32>>2];h=k[N+36>>2]|0;k[K+36>>2]=h;l=K+40|0;k[l>>2]=B;B=K+48|0;n=K+44|0;k[n>>2]=B;k[K+52>>2]=0;k[B>>2]=0;if(h){a=h+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[j>>2]|0}if((a|0)>=3){k[o>>2]=0;x1(K,a,0,0,0);if((k[o>>2]|0)>0){m=k[I>>2]|0;j=k[l>>2]|0;l=k[N+44>>2]|0;h=k[n>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[m+(a<<2)>>2];k[h+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[o>>2]|0))}}else{w=k[N+44>>2]|0;B=k[n>>2]|0;k[B>>2]=k[w>>2];k[B+4>>2]=k[w+4>>2]}if((d^q)&4088|0){k[H>>2]=0;a=H+4|0;k[a>>2]=0;h=ZT(32)|0;k[h>>2]=1;l=h+4|0;k[H>>2]=l;k[a>>2]=25;i[h+29>>0]=0;j=254464;n=l+25|0;do{i[l>>0]=i[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(n|0));Y8(-215,H,256789,247404,4536);k[a>>2]=0;k[H>>2]=0;B=k[h>>2]|0;k[h>>2]=B+-1;if((B|0)==1)ggb(k[h+-4>>2]|0)}k[H>>2]=k[K>>2];c=H+4|0;w=K+4|0;a=k[w>>2]|0;k[c>>2]=a;s=H+8|0;k[s>>2]=k[K+8>>2];k[H+12>>2]=k[K+12>>2];o=H+16|0;t=K+16|0;k[o>>2]=k[t>>2];k[H+20>>2]=k[K+20>>2];k[H+24>>2]=k[K+24>>2];k[H+28>>2]=k[K+28>>2];n=H+32|0;e=K+32|0;k[n>>2]=k[e>>2];q=H+36|0;u=K+36|0;h=k[u>>2]|0;k[q>>2]=h;d=H+40|0;k[d>>2]=s;s=H+48|0;b=H+44|0;k[b>>2]=s;k[H+52>>2]=0;k[s>>2]=0;if(h){a=h+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[w>>2]|0}if((a|0)>=3){k[c>>2]=0;x1(H,a,0,0,0);if((k[c>>2]|0)>0){h=k[K+40>>2]|0;j=k[d>>2]|0;l=k[K+44>>2]|0;m=k[b>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[h+(a<<2)>>2];k[m+(a<<2)>>2]=k[l+(a<<2)>>2];a=a+1|0}while((a|0)<(k[c>>2]|0))}}else{m=k[K+44>>2]|0;B=k[b>>2]|0;k[B>>2]=k[m>>2];k[B+4>>2]=k[m+4>>2]}k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=H;k[C>>2]=z;k[C+4>>2]=A;Vja(G,x,y,F,C,f);k[F>>2]=0;k[F+4>>2]=0;k[D>>2]=0;k[D+4>>2]=0;while(1){a=fgb(200)|0;if(a|0){l=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){l=0;break}Qh[a&7]()}qga(l,G,F,D,x,y,x,v,-1,E);while(1){a=fgb(16)|0;if(a|0){j=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){j=0;break}Qh[a&7]()}k[j+4>>2]=1;k[j>>2]=72040;k[j+8>>2]=l;a=k[G>>2]|0;if(a|0?(G=a+4|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);a=k[q>>2]|0;if(a|0?(G=a+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){h=k[q>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[n>>2]|0;if(!a){a=B1()|0;h=k[q>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[q>>2]=0}k[q>>2]=0;k[o>>2]=0;k[o+4>>2]=0;k[o+8>>2]=0;k[o+12>>2]=0;if((k[c>>2]|0)>0){h=k[d>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[b>>2]|0;if(!((a|0)==(s|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[u>>2]|0;if(a|0?(G=a+12|0,H=k[G>>2]|0,k[G>>2]=H+-1,(H|0)==1):0){h=k[u>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[e>>2]|0;if(a|0)break;a=B1()|0;h=k[u>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[u>>2]=0}k[u>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[w>>2]|0)>0){h=k[K+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[K+44>>2]|0;if(!((a|0)==(K+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);H=k[(k[l>>2]|0)+20>>2]|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=-1;k[K+12>>2]=-1;k[J>>2]=0;k[J+4>>2]=0;Lg[H&255](l,O,M,K,J,(g&16|0)!=0);if(j|0?(g=j+4|0,K=k[g>>2]|0,k[g>>2]=K+-1,(K|0)==1):0)Uh[k[(k[j>>2]|0)+8>>2]&2047](j)}j=M+36|0;a=k[j>>2]|0;if(a|0?(g=a+12|0,K=k[g>>2]|0,k[g>>2]=K+-1,(K|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[M+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;K=M+16|0;h=M+4|0;k[K>>2]=0;k[K+4>>2]=0;k[K+8>>2]=0;k[K+12>>2]=0;if((k[h>>2]|0)>0){j=k[M+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[M+44>>2]|0;if(!((a|0)==(M+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=N+36|0;a=k[j>>2]|0;if(a|0?(K=a+12|0,M=k[K>>2]|0,k[K>>2]=M+-1,(M|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[N+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;M=N+16|0;j=N+4|0;k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=0;k[M+12>>2]=0;if((k[j>>2]|0)>0){h=k[I>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[N+44>>2]|0;if(!((a|0)==(N+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=O+36|0;a=k[j>>2]|0;if(a|0?(M=a+12|0,N=k[M>>2]|0,k[M>>2]=N+-1,(N|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[O+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;N=O+16|0;j=O+4|0;k[N>>2]=0;k[N+4>>2]=0;k[N+8>>2]=0;k[N+12>>2]=0;if((k[j>>2]|0)>0){h=k[L>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[O+44>>2]|0;if((a|0)==(O+48|0)|(a|0)==0){r=P;return}ggb(k[a+-4>>2]|0);r=P;return}function gla(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;var i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+320|0;B=C+264|0;A=C+208|0;z=C+152|0;q=C+88|0;y=C+96|0;s=C+80|0;t=C+64|0;u=C+48|0;v=C+40|0;w=C;x=C+32|0;do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[B>>2]=k[l>>2];p=B+4|0;a=l+4|0;k[p>>2]=k[a>>2];o=B+8|0;k[o>>2]=k[l+8>>2];k[B+12>>2]=k[l+12>>2];k[B+16>>2]=k[l+16>>2];k[B+20>>2]=k[l+20>>2];k[B+24>>2]=k[l+24>>2];k[B+28>>2]=k[l+28>>2];k[B+32>>2]=k[l+32>>2];i=k[l+36>>2]|0;k[B+36>>2]=i;j=B+40|0;k[j>>2]=o;o=B+48|0;n=B+44|0;k[n>>2]=o;k[B+52>>2]=0;k[o>>2]=0;if(i|0){o=i+12|0;k[o>>2]=(k[o>>2]|0)+1}if((k[a>>2]|0)<3){o=k[l+44>>2]|0;p=k[n>>2]|0;k[p>>2]=k[o>>2];k[p+4>>2]=k[o+4>>2];break}k[p>>2]=0;x1(B,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;i=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[i+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(B,a,-1);while(0);do if((k[d>>2]&2031616|0)==65536){m=k[d+4>>2]|0;k[A>>2]=k[m>>2];p=A+4|0;i=m+4|0;k[p>>2]=k[i>>2];d=A+8|0;k[d>>2]=k[m+8>>2];k[A+12>>2]=k[m+12>>2];k[A+16>>2]=k[m+16>>2];k[A+20>>2]=k[m+20>>2];k[A+24>>2]=k[m+24>>2];k[A+28>>2]=k[m+28>>2];k[A+32>>2]=k[m+32>>2];a=k[m+36>>2]|0;k[A+36>>2]=a;j=A+40|0;k[j>>2]=d;d=A+48|0;n=A+44|0;k[n>>2]=d;k[A+52>>2]=0;k[d>>2]=0;if(a|0){d=a+12|0;k[d>>2]=(k[d>>2]|0)+1}if((k[i>>2]|0)<3){p=k[m+44>>2]|0;d=k[n>>2]|0;k[d>>2]=k[p>>2];k[d+4>>2]=k[p+4>>2];break}k[p>>2]=0;x1(A,k[i>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[m+40>>2]|0;l=k[j>>2]|0;j=k[m+44>>2]|0;i=k[n>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[o+(a<<2)>>2];k[i+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(A,d,-1);while(0);do if((k[e>>2]&2031616|0)==65536){l=k[e+4>>2]|0;k[z>>2]=k[l>>2];p=z+4|0;a=l+4|0;k[p>>2]=k[a>>2];e=z+8|0;k[e>>2]=k[l+8>>2];k[z+12>>2]=k[l+12>>2];k[z+16>>2]=k[l+16>>2];k[z+20>>2]=k[l+20>>2];k[z+24>>2]=k[l+24>>2];k[z+28>>2]=k[l+28>>2];k[z+32>>2]=k[l+32>>2];i=k[l+36>>2]|0;k[z+36>>2]=i;j=z+40|0;k[j>>2]=e;e=z+48|0;n=z+44|0;k[n>>2]=e;k[z+52>>2]=0;k[e>>2]=0;if(i|0){e=i+12|0;k[e>>2]=(k[e>>2]|0)+1}if((k[a>>2]|0)<3){d=k[l+44>>2]|0;e=k[n>>2]|0;k[e>>2]=k[d>>2];k[e+4>>2]=k[d+4>>2];break}k[p>>2]=0;x1(z,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;i=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[i+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(z,e,-1);while(0);e=k[B>>2]|0;d=B+40|0;o=k[d>>2]|0;p=k[o>>2]|0;k[q>>2]=k[o+4>>2];k[q+4>>2]=p;x2(b,q,e&4088|((c|0)<0?e:c)&7,0);do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[y>>2]=k[l>>2];p=y+4|0;a=l+4|0;k[p>>2]=k[a>>2];c=y+8|0;k[c>>2]=k[l+8>>2];k[y+12>>2]=k[l+12>>2];k[y+16>>2]=k[l+16>>2];k[y+20>>2]=k[l+20>>2];k[y+24>>2]=k[l+24>>2];k[y+28>>2]=k[l+28>>2];k[y+32>>2]=k[l+32>>2];i=k[l+36>>2]|0;k[y+36>>2]=i;j=y+40|0;k[j>>2]=c;c=y+48|0;n=y+44|0;k[n>>2]=c;k[y+52>>2]=0;k[c>>2]=0;if(i|0){c=i+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[a>>2]|0)<3){c=k[l+44>>2]|0;a=k[n>>2]|0;k[a>>2]=k[c>>2];k[a+4>>2]=k[c+4>>2];a=y;break}k[p>>2]=0;x1(y,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[l+40>>2]|0;m=k[j>>2]|0;j=k[l+44>>2]|0;i=k[n>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[o+(a<<2)>>2];k[i+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0));a=y}else a=y}else{Q1(y,b,-1);a=y}while(0);c=k[B>>2]&4095;a=k[a>>2]&4095;k[t+8>>2]=0;k[t+12>>2]=0;k[t>>2]=16842752;k[t+4>>2]=A;k[u+8>>2]=0;k[u+12>>2]=0;k[u>>2]=16842752;k[u+4>>2]=z;k[v>>2]=k[f>>2];k[v+4>>2]=k[f+4>>2];k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;k[w+16>>2]=0;k[w+20>>2]=0;k[w+24>>2]=0;k[w+28>>2]=0;Qja(s,c,a,t,u,v,g,h&-17,-1,w);a=k[s+4>>2]|0;f=k[(k[a>>2]|0)+20>>2]|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=-1;k[t+12>>2]=-1;k[x>>2]=0;k[x+4>>2]=0;Lg[f&255](a,B,y,t,x,(h&16|0)!=0);a=k[s>>2]|0;if(a|0?(f=a+4|0,h=k[f>>2]|0,k[f>>2]=h+-1,(h|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);j=y+36|0;a=k[j>>2]|0;if(a|0?(f=a+12|0,h=k[f>>2]|0,k[f>>2]=h+-1,(h|0)==1):0){i=k[j>>2]|0;if(i|0){a=k[i+4>>2]|0;if(!a){a=k[y+32>>2]|0;if(!a){a=B1()|0;i=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,i)}k[j>>2]=0}k[j>>2]=0;h=y+16|0;i=y+4|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[i>>2]|0)>0){j=k[y+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[i>>2]|0))}a=k[y+44>>2]|0;if(!((a|0)==(y+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=z+36|0;a=k[j>>2]|0;if(a|0?(h=a+12|0,y=k[h>>2]|0,k[h>>2]=y+-1,(y|0)==1):0){i=k[j>>2]|0;if(i|0){a=k[i+4>>2]|0;if(!a){a=k[z+32>>2]|0;if(!a){a=B1()|0;i=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,i)}k[j>>2]=0}k[j>>2]=0;y=z+16|0;i=z+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[i>>2]|0)>0){j=k[z+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[i>>2]|0))}a=k[z+44>>2]|0;if(!((a|0)==(z+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=A+36|0;a=k[j>>2]|0;if(a|0?(y=a+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){i=k[j>>2]|0;if(i|0){a=k[i+4>>2]|0;if(!a){a=k[A+32>>2]|0;if(!a){a=B1()|0;i=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,i)}k[j>>2]=0}k[j>>2]=0;z=A+16|0;i=A+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[i>>2]|0)>0){j=k[A+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[i>>2]|0))}a=k[A+44>>2]|0;if(!((a|0)==(A+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=B+36|0;a=k[j>>2]|0;if(a|0?(z=a+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){i=k[j>>2]|0;if(i|0){a=k[i+4>>2]|0;do if(!a){a=k[B+32>>2]|0;if(a|0)break;a=B1()|0;i=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,i)}k[j>>2]=0}k[j>>2]=0;A=B+16|0;j=B+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[j>>2]|0)>0){i=k[d>>2]|0;a=0;do{k[i+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[B+44>>2]|0;if((a|0)==(B+48|0)|(a|0)==0){r=C;return}ggb(k[a+-4>>2]|0);r=C;return}function hla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0.0,h=0,j=0,l=0,m=0.0,n=0.0,p=0,q=0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0,I=0,J=0;J=r;r=r+64|0;I=J+8|0;s=J;do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[I>>2]=k[j>>2];q=I+4|0;a=j+4|0;k[q>>2]=k[a>>2];H=I+8|0;k[H>>2]=k[j+8>>2];k[I+12>>2]=k[j+12>>2];k[I+16>>2]=k[j+16>>2];k[I+20>>2]=k[j+20>>2];k[I+24>>2]=k[j+24>>2];k[I+28>>2]=k[j+28>>2];k[I+32>>2]=k[j+32>>2];d=k[j+36>>2]|0;k[I+36>>2]=d;e=I+40|0;k[e>>2]=H;H=I+48|0;l=I+44|0;k[l>>2]=H;k[I+52>>2]=0;k[H>>2]=0;if(d|0){H=d+12|0;k[H>>2]=(k[H>>2]|0)+1}if((k[a>>2]|0)<3){H=k[j+44>>2]|0;a=k[l>>2]|0;k[a>>2]=k[H>>2];k[a+4>>2]=k[H+4>>2];a=I;break}k[q>>2]=0;x1(I,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){p=k[j+40>>2]|0;h=k[e>>2]|0;e=k[j+44>>2]|0;d=k[l>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[p+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0));a=I}else a=I}else{Q1(I,a,-1);a=I}while(0);H=y2(I,2,-1,1)|0;l=k[a>>2]&7;if(!((H|0)>-1&(l|1|0)==5)){k[s>>2]=0;a=s+4|0;k[a>>2]=0;d=ZT(56)|0;k[d>>2]=1;e=d+4|0;k[s>>2]=e;k[a>>2]=50;i[d+54>>0]=0;h=256960;j=e+50|0;do{i[e>>0]=i[h>>0]|0;e=e+1|0;h=h+1|0}while((e|0)<(j|0));Y8(-215,s,257011,256890,101);k[a>>2]=0;k[s>>2]=0;E=k[d>>2]|0;k[d>>2]=E+-1;if((E|0)==1)ggb(k[d+-4>>2]|0)}G=+o[b>>2];a=(o[u>>2]=G,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?G+-8388608.0+8388608.0:G+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}else f=G;E=~~f;F=+o[b+4>>2];a=(o[u>>2]=F,k[u>>2]|0);if((a&2130706432)>>>0<=1249902592){a=(a|0)<0;f=a?F+-8388608.0+8388608.0:F+8388608.0+-8388608.0;if(f==0.0)f=a?-0.0:0.0}else f=F;s=~~f;a:do if(!H)f=c?-1797693134862315708145274.0e284:-1.0;else{h=(l|0)==5;b=k[I+16>>2]|0;d=H+-1|0;p=k[b+(d<<3)>>2]|0;if(+(E|0)==G&((h|c)^1)&+(s|0)==F){if((H|0)>0){q=0;a=0;l=k[b+(d<<3)+4>>2]|0;do{e=p;p=k[b+(q<<3)>>2]|0;h=l;l=k[b+(q<<3)+4>>2]|0;d=(l|0)>(s|0);if((s|0)<(h|0))if(d)j=29;else j=28;else if(d)j=28;else j=29;if((j|0)==28){j=0;if((E|0)>(e|0)&(p|0)<(E|0))j=29;else{d=(aa(p-e|0,s-h|0)|0)-(aa(l-h|0,E-e|0)|0)|0;if(!d){f=0.0;break a}a=((((l|0)<(h|0)?0-d|0:d)|0)>0&1)+a|0}}if((j|0)==29)if((s|0)==(l|0)){if((E|0)==(p|0)){f=0.0;break a}if((s|0)==(h|0)){if(!((E|0)<(e|0)|(E|0)>(p|0))){f=0.0;break a}if(!((E|0)>(e|0)|(p|0)>(E|0))){f=0.0;break a}}}q=q+1|0}while((q|0)<(H|0))}else a=0;f=+((a<<1&2)+-1|0);break}a=k[b+(d<<3)+4>>2]|0;if(h)e=a;else{p=(o[u>>2]=+(p|0),k[u>>2]|0);e=(o[u>>2]=+(a|0),k[u>>2]|0)}a=(H|0)>0;if(!c){if(a)if(h){h=0;a=0;do{d=p;p=k[b+(h<<3)>>2]|0;c=e;e=k[b+(h<<3)+4>>2]|0;m=(k[u>>2]=c,+o[u>>2]);g=(k[u>>2]=e,+o[u>>2]);if((!(m<=F)|!(g<=F)?!(m>F&g>F):0)?(n=(k[u>>2]=d,+o[u>>2]),t=(k[u>>2]=p,+o[u>>2]),!(n<G&t<G)):0){f=(t-n)*(F-m)-(g-m)*(G-n);if(f==0.0){f=0.0;break a}a=((g<m?-f:f)>0.0&1)+a|0}else if(F==g){g=(k[u>>2]=p,+o[u>>2]);if(G==g){f=0.0;break a}if(F==m){f=(k[u>>2]=d,+o[u>>2]);if(!(!(f<=G)|!(G<=g))){f=0.0;break a}if(!(!(g<=G)|!(G<=f))){f=0.0;break a}}}h=h+1|0}while((h|0)<(H|0))}else{h=0;a=0;do{g=+(k[b+(h<<3)>>2]|0);m=+(k[b+(h<<3)+4>>2]|0);d=p;p=(o[u>>2]=g,k[u>>2]|0);c=e;e=(o[u>>2]=m,k[u>>2]|0);n=(k[u>>2]=c,+o[u>>2]);if((!(n<=F)|!(m<=F)?!(n>F&m>F):0)?(v=(k[u>>2]=d,+o[u>>2]),!(v<G&g<G)):0){f=(g-v)*(F-n)-(m-n)*(G-v);if(f==0.0){f=0.0;break a}a=((m<n?-f:f)>0.0&1)+a|0}else if(F==m){if(G==g){f=0.0;break a}if(F==n){f=(k[u>>2]=d,+o[u>>2]);if(!(!(f<=G)|!(G<=g))){f=0.0;break a}if(!(!(g<=G)|!(G<=f))){f=0.0;break a}}}h=h+1|0}while((h|0)<(H|0))}else a=0;f=+((a<<1&2)+-1|0);break}b:do if(a)if(h){C=3402823466385288598117041.0e14;D=1.0;d=0;a=0;while(1){E=p;p=k[b+(d<<3)>>2]|0;c=e;e=k[b+(d<<3)+4>>2]|0;n=(k[u>>2]=p,+o[u>>2]);t=(k[u>>2]=E,+o[u>>2]);v=n-t;w=(k[u>>2]=e,+o[u>>2]);x=(k[u>>2]=c,+o[u>>2]);y=w-x;z=y;A=G-t;B=F-x;g=G-n;m=F-w;do if(!(v*A+z*B<=0.0))if(!(v*g+z*m>=0.0)){g=v*B-A*z;f=v*v+z*z;g=g*g;break}else{f=1.0;g=g*g+m*m;break}else{f=1.0;g=A*A+B*B}while(0);if(D*g<C*f){if(g==0.0)break b}else{g=C;f=D}if((!(x<=F)|!(w<=F)?!(x>F&w>F):0)?!(t<G&n<G):0){D=v*B-A*z;a=((y<0.0?-D:D)>0.0&1)+a|0}d=d+1|0;if((d|0)>=(H|0))break;else{C=g;D=f}}}else{C=3402823466385288598117041.0e14;D=1.0;d=0;a=0;while(1){n=+(k[b+(d<<3)>>2]|0);t=+(k[b+(d<<3)+4>>2]|0);E=p;p=(o[u>>2]=n,k[u>>2]|0);c=e;e=(o[u>>2]=t,k[u>>2]|0);v=(k[u>>2]=E,+o[u>>2]);w=n-v;x=(k[u>>2]=c,+o[u>>2]);y=t-x;z=y;A=G-v;B=F-x;g=G-n;m=F-t;do if(!(w*A+z*B<=0.0))if(!(w*g+z*m>=0.0)){g=w*B-A*z;f=w*w+z*z;g=g*g;break}else{f=1.0;g=g*g+m*m;break}else{f=1.0;g=A*A+B*B}while(0);if(D*g<C*f){if(g==0.0)break b}else{g=C;f=D}if((!(x<=F)|!(t<=F)?!(x>F&t>F):0)?!(v<G&n<G):0){D=w*B-A*z;a=((y<0.0?-D:D)>0.0&1)+a|0}d=d+1|0;if((d|0)>=(H|0))break;else{C=g;D=f}}}else{g=3402823466385288598117041.0e14;f=1.0;a=0}while(0);f=+Q(+(g/f));f=(a&1|0)==0?-f:f}while(0);e=I+36|0;a=k[e>>2]|0;if(a|0?(c=a+12|0,H=k[c>>2]|0,k[c>>2]=H+-1,(H|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[I+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;H=I+16|0;d=I+4|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[d>>2]|0)>0){e=k[I+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[I+44>>2]|0;if((a|0)==(I+48|0)|(a|0)==0){r=J;return +f}ggb(k[a+-4>>2]|0);r=J;return +f}function ila(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;m=r;r=r+48|0;j=m+32|0;h=m;k[a>>2]=1124007936;c=a+8|0;d=a+40|0;f=a+4|0;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[d>>2]=c;g=a+48|0;k[a+44>>2]=g;k[a+52>>2]=0;k[g>>2]=0;g=(k[b+16>>2]|0)==0;f=k[b+4>>2]|0;do if(!g){if((f|0)<3)c=aa(k[b+12>>2]|0,k[b+8>>2]|0)|0;else{e=k[b+40>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0))}if(c){if(((k[b>>2]&4095|0)==6?(k[b+8>>2]|0)==1:0)?(k[b+12>>2]|0)==65:0)break;k[j>>2]=0;c=j+4|0;k[c>>2]=0;d=ZT(80)|0;k[d>>2]=1;f=d+4|0;k[j>>2]=f;k[c>>2]=72;i[d+76>>0]=0;e=257184;g=f+72|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-5,j,257257,257261,96);k[c>>2]=0;k[j>>2]=0;j=k[d>>2]|0;k[d>>2]=j+-1;if((j|0)==1)ggb(k[d+-4>>2]|0)}else l=7}else l=7;while(0);if((l|0)==7){if(!((((f|0)<3?(k[b+8>>2]|0)==1:0)?(k[b+12>>2]|0)==65:0)?!((k[b>>2]&4095|0)!=6|g):0)){k[j>>2]=1;k[j+4>>2]=65;G1(b,2,j,6)}k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[h+24>>2]=0;k[h+28>>2]=0;k[j>>2]=-1056833530;k[j+4>>2]=h;k[j+8>>2]=1;k[j+12>>2]=4;pY(b,j,49332)}KG(a,b)|0;c=k[a+16>>2]|0;d=a+56|0;k[d>>2]=c;k[a+60>>2]=c+40;k[a+64>>2]=c+160;if(+p[c>>3]>0.0){jla(a,0);c=k[d>>2]|0}if(+p[c+8>>3]>0.0){jla(a,1);c=k[d>>2]|0}if(+p[c+16>>3]>0.0){jla(a,2);c=k[d>>2]|0}if(+p[c+24>>3]>0.0){jla(a,3);c=k[d>>2]|0}if(!(+p[c+32>>3]>0.0)){r=m;return}jla(a,4);r=m;return}function jla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0.0,q=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0;u=r;r=r+16|0;g=u;if(!(+p[(k[a+56>>2]|0)+(b<<3)>>3]>0.0)){r=u;return}c=(k[a+64>>2]|0)+(b*9<<3)|0;d=c+32|0;B=+p[d>>3];e=c+64|0;z=+p[e>>3];f=c+40|0;x=+p[f>>3];h=c+56|0;A=+p[h>>3];j=c+8|0;l=c+24|0;y=+p[l>>3];m=c+48|0;o=+p[m>>3];n=c+16|0;o=+p[n>>3]*(A*y-B*o)+(+p[c>>3]*(B*z-x*A)-+p[j>>3]*(z*y-x*o));p[a+432+(b<<3)>>3]=o;if(!(o>2.220446049250313e-16)){q=g+4|0;s=ZT(52)|0;k[s>>2]=1;t=s+4|0;k[g>>2]=t;k[q>>2]=45;i[s+49>>0]=0;v=257330;w=t+45|0;do{i[t>>0]=i[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Y8(-215,g,257376,257261,216);k[q>>2]=0;k[g>>2]=0;w=k[s>>2]|0;k[s>>2]=w+-1;if((w|0)==1)ggb(k[s+-4>>2]|0)}p[a+72+(b*72|0)>>3]=(+p[d>>3]*+p[e>>3]-+p[f>>3]*+p[h>>3])/o;p[a+72+(b*72|0)+24>>3]=-(+p[l>>3]*+p[e>>3]-+p[f>>3]*+p[m>>3])/o;p[a+72+(b*72|0)+48>>3]=(+p[l>>3]*+p[h>>3]-+p[d>>3]*+p[m>>3])/o;p[a+72+(b*72|0)+8>>3]=-(+p[j>>3]*+p[e>>3]-+p[n>>3]*+p[h>>3])/o;p[a+72+(b*72|0)+32>>3]=(+p[c>>3]*+p[e>>3]-+p[n>>3]*+p[m>>3])/o;p[a+72+(b*72|0)+56>>3]=-(+p[c>>3]*+p[h>>3]-+p[j>>3]*+p[m>>3])/o;p[a+72+(b*72|0)+16>>3]=(+p[j>>3]*+p[f>>3]-+p[n>>3]*+p[d>>3])/o;p[a+72+(b*72|0)+40>>3]=-(+p[c>>3]*+p[f>>3]-+p[n>>3]*+p[l>>3])/o;p[a+72+(b*72|0)+64>>3]=(+p[c>>3]*+p[d>>3]-+p[j>>3]*+p[l>>3])/o;r=u;return}function kla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0.0,q=0.0,s=0.0;n=r;r=r+16|0;l=n;if(!(+p[(k[a+56>>2]|0)+(b<<3)>>3]>0.0)){d=0.0;r=n;return +d}m=a+432+(b<<3)|0;d=+p[m>>3];if(!(d>2.220446049250313e-16)){e=l+4|0;f=ZT(60)|0;k[f>>2]=1;g=f+4|0;k[l>>2]=g;k[e>>2]=55;i[f+59>>0]=0;h=257400;j=g+55|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-215,l,369779,257261,122);k[e>>2]=0;k[l>>2]=0;l=k[f>>2]|0;k[f>>2]=l+-1;if((l|0)==1)ggb(k[f+-4>>2]|0);d=+p[m>>3]}m=(k[a+60>>2]|0)+(b*3<<3)|0;s=+p[c>>3]-+p[m>>3];q=+p[c+8>>3]-+p[m+8>>3];o=+p[c+16>>3]-+p[m+16>>3];d=1.0/+Q(+d)*+Z(+((s*(s*+p[a+72+(b*72|0)>>3]+q*+p[a+72+(b*72|0)+24>>3]+o*+p[a+72+(b*72|0)+48>>3])+q*(s*+p[a+72+(b*72|0)+8>>3]+q*+p[a+72+(b*72|0)+32>>3]+o*+p[a+72+(b*72|0)+56>>3])+o*(s*+p[a+72+(b*72|0)+16>>3]+q*+p[a+72+(b*72|0)+40>>3]+o*+p[a+72+(b*72|0)+64>>3]))*-.5));r=n;return +d}function lla(a){a=a|0;var b=0,c=0.0,d=0.0,e=0,f=0.0,g=0,h=0,i=0,j=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;i=a+56|0;j=a+972|0;l=a+60|0;m=a+64|0;h=0;do{b=k[a+952+(h<<2)>>2]|0;if(!b)p[(k[i>>2]|0)+(h<<3)>>3]=0.0;else{u=+(b|0);p[(k[i>>2]|0)+(h<<3)>>3]=u/+(k[j>>2]|0);w=(k[l>>2]|0)+(h*3<<3)|0;c=+p[a+472+(h*24|0)>>3]/u;p[w>>3]=c;v=w+8|0;p[v>>3]=+p[a+472+(h*24|0)+8>>3]/u;g=w+16|0;p[g>>3]=+p[a+472+(h*24|0)+16>>3]/u;b=(k[m>>2]|0)+(h*9<<3)|0;c=+p[a+592+(h*72|0)>>3]/u-c*c;p[b>>3]=c;r=+p[a+592+(h*72|0)+8>>3]/u-+p[w>>3]*+p[v>>3];p[b+8>>3]=r;t=+p[a+592+(h*72|0)+16>>3]/u-+p[w>>3]*+p[g>>3];p[b+16>>3]=t;q=+p[a+592+(h*72|0)+24>>3]/u-+p[v>>3]*+p[w>>3];p[b+24>>3]=q;d=+p[v>>3];d=+p[a+592+(h*72|0)+32>>3]/u-d*d;e=b+32|0;p[e>>3]=d;o=+p[a+592+(h*72|0)+40>>3]/u-+p[v>>3]*+p[g>>3];p[b+40>>3]=o;n=+p[a+592+(h*72|0)+48>>3]/u-+p[g>>3]*+p[w>>3];p[b+48>>3]=n;s=+p[a+592+(h*72|0)+56>>3]/u-+p[g>>3]*+p[v>>3];p[b+56>>3]=s;f=+p[g>>3];f=+p[a+592+(h*72|0)+64>>3]/u-f*f;g=b+64|0;p[g>>3]=f;if(t*(s*q-d*n)+(c*(f*d-o*s)-r*(f*q-o*n))<=2.220446049250313e-16){p[b>>3]=c+.01;p[e>>3]=d+.01;p[g>>3]=f+.01}jla(a,h)}h=h+1|0}while((h|0)!=5);return}function mla(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,m=0,n=0,q=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0,Cb=0.0,Db=0.0,Eb=0.0;ub=r;r=r+2512|0;db=ub+2040|0;eb=ub+1984|0;fb=ub+2456|0;ab=ub+2444|0;bb=ub+2432|0;nb=ub+2360|0;mb=ub+2304|0;hb=ub+2248|0;tb=ub+2192|0;sb=ub+1008|0;qb=ub+32|0;ob=ub+2136|0;y=ub+2416|0;gb=ub+2080|0;cb=ub;do if((k[a>>2]&2031616|0)==65536){m=k[a+4>>2]|0;k[tb>>2]=k[m>>2];t=tb+4|0;a=m+4|0;k[t>>2]=k[a>>2];rb=tb+8|0;k[rb>>2]=k[m+8>>2];k[tb+12>>2]=k[m+12>>2];k[tb+16>>2]=k[m+16>>2];k[tb+20>>2]=k[m+20>>2];k[tb+24>>2]=k[m+24>>2];k[tb+28>>2]=k[m+28>>2];k[tb+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[tb+36>>2]=h;j=tb+40|0;k[j>>2]=rb;rb=tb+48|0;q=tb+44|0;k[q>>2]=rb;k[tb+52>>2]=0;k[rb>>2]=0;if(h|0){rb=h+12|0;k[rb>>2]=(k[rb>>2]|0)+1}if((k[a>>2]|0)<3){pb=k[m+44>>2]|0;rb=k[q>>2]|0;k[rb>>2]=k[pb>>2];k[rb+4>>2]=k[pb+4>>2];break}k[t>>2]=0;x1(tb,k[a>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[m+40>>2]|0;n=k[j>>2]|0;j=k[m+44>>2]|0;h=k[q>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[s+(a<<2)>>2];k[h+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[t>>2]|0))}}else Q1(tb,a,-1);while(0);V=J2(b,-1)|0;q=J2(d,-1)|0;n=J2(e,-1)|0;rb=tb+16|0;if(k[rb>>2]|0){m=k[tb+4>>2]|0;if((m|0)<3)a=aa(k[tb+12>>2]|0,k[tb+8>>2]|0)|0;else{j=k[tb+40>>2]|0;h=0;a=1;do{a=aa(k[j+(h<<2)>>2]|0,a)|0;h=h+1|0}while((h|0)!=(m|0))}if(!a)$a=16}else $a=16;if(($a|0)==16){k[db>>2]=0;a=db+4|0;k[a>>2]=0;h=ZT(20)|0;k[h>>2]=1;S=h+4|0;k[db>>2]=S;k[a>>2]=14;i[h+18>>0]=0;R=257456;T=S+14|0;do{i[S>>0]=i[R>>0]|0;S=S+1|0;R=R+1|0}while((S|0)<(T|0));Y8(-5,db,257471,257261,538);k[a>>2]=0;k[db>>2]=0;pb=k[h>>2]|0;k[h>>2]=pb+-1;if((pb|0)==1)ggb(k[h+-4>>2]|0)}if((k[tb>>2]&4095|0)!=16){k[db>>2]=0;a=db+4|0;k[a>>2]=0;h=ZT(36)|0;k[h>>2]=1;S=h+4|0;k[db>>2]=S;k[a>>2]=28;i[h+32>>0]=0;R=257479;T=S+28|0;do{i[S>>0]=i[R>>0]|0;S=S+1|0;R=R+1|0}while((S|0)<(T|0));Y8(-5,db,257471,257261,540);k[a>>2]=0;k[db>>2]=0;pb=k[h>>2]|0;k[h>>2]=pb+-1;if((pb|0)==1)ggb(k[h+-4>>2]|0)}ila(sb,q);ila(qb,n);pb=tb+40|0;h=k[pb>>2]|0;j=k[h+4>>2]|0;h=k[h>>2]|0;k[ob>>2]=1124007936;kb=ob+4|0;a=ob+8|0;ib=ob+40|0;S=kb;T=S+36|0;do{k[S>>2]=0;S=S+4|0}while((S|0)<(T|0));k[ib>>2]=a;lb=ob+48|0;jb=ob+44|0;k[jb>>2]=lb;k[ob+52>>2]=0;k[lb>>2]=0;k[db>>2]=h;U=db+4|0;k[U>>2]=j;G1(ob,2,db,4);if((g|1|0)==1){if(!g){j=k[pb>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[c>>2]|0;k[y>>2]=m;n=y+4|0;q=k[c+4>>2]|0;k[n>>2]=q;s=y+8|0;t=k[c+8>>2]|0;k[s>>2]=t;b=y+12|0;a=k[c+12>>2]|0;k[b>>2]=a;if(!(((((k[V+4>>2]|0)<3?(k[V+8>>2]|0)==(j|0):0)?(k[V+12>>2]|0)==(h|0):0)?(k[V>>2]&4095|0)==0:0)?(k[V+16>>2]|0)!=0:0)){k[db>>2]=j;k[U>>2]=h;G1(V,2,db,0)}p[eb>>3]=0.0;k[db>>2]=-1056833530;k[db+4>>2]=eb;k[db+8>>2]=1;k[db+12>>2]=1;pY(V,db,49332);Za=(m|0)>0?m:0;k[y>>2]=Za;_a=(q|0)>0?q:0;k[n>>2]=_a;Za=h-Za|0;k[s>>2]=(Za|0)<(t|0)?Za:t;j=j-_a|0;k[b>>2]=(j|0)<(a|0)?j:a;I1(fb,V,y);p[eb>>3]=3.0;j=eb+8|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;k[j+20>>2]=0;k[db>>2]=-1056833530;k[db+4>>2]=eb;k[db+8>>2]=1;k[db+12>>2]=4;pY(fb,db,49332);j=fb+36|0;a=k[j>>2]|0;if(a|0?(Za=a+12|0,_a=k[Za>>2]|0,k[Za>>2]=_a+-1,(_a|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[fb+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;_a=fb+16|0;h=fb+4|0;k[_a>>2]=0;k[_a+4>>2]=0;k[_a+8>>2]=0;k[_a+12>>2]=0;if((k[h>>2]|0)>0){j=k[fb+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[fb+44>>2]|0;if(!((a|0)==(fb+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else nla(tb,V);k[eb>>2]=1124007936;O=eb+4|0;a=eb+8|0;M=eb+40|0;S=O;T=S+36|0;do{k[S>>2]=0;S=S+4|0}while((S|0)<(T|0));k[M>>2]=a;Q=eb+48|0;N=eb+44|0;k[N>>2]=Q;k[eb+52>>2]=0;k[Q>>2]=0;k[fb>>2]=1124007936;K=fb+4|0;a=fb+8|0;I=fb+40|0;S=K;T=S+36|0;do{k[S>>2]=0;S=S+4|0}while((S|0)<(T|0));k[I>>2]=a;L=fb+48|0;J=fb+44|0;k[J>>2]=L;k[fb+52>>2]=0;k[L>>2]=0;k[ab>>2]=0;H=ab+4|0;k[H>>2]=0;k[ab+8>>2]=0;k[bb>>2]=0;G=bb+4|0;k[G>>2]=0;k[bb+8>>2]=0;n=tb+8|0;a=k[n>>2]|0;if((a|0)>0){q=tb+12|0;s=V+16|0;t=V+44|0;b=tb+44|0;d=db+4|0;e=db+8|0;c=bb+8|0;y=db+4|0;z=db+8|0;A=ab+8|0;h=k[q>>2]|0;m=0;do{if((h|0)>0){j=0;do{_a=(k[s>>2]|0)+(aa(k[k[t>>2]>>2]|0,m)|0)+j|0;switch(i[_a>>0]|0){case 2:case 0:{a=(k[rb>>2]|0)+(aa(k[k[b>>2]>>2]|0,m)|0)|0;u=+(l[a+(j*3|0)>>0]|0);o[db>>2]=u;v=+(l[a+(j*3|0)+1>>0]|0);o[y>>2]=v;w=+(l[a+(j*3|0)+2>>0]|0);o[z>>2]=w;a=k[H>>2]|0;if((a|0)==(k[A>>2]|0))ola(ab,db);else{o[a>>2]=u;o[a+4>>2]=v;o[a+8>>2]=w;k[H>>2]=a+12}break}default:{a=(k[rb>>2]|0)+(aa(k[k[b>>2]>>2]|0,m)|0)|0;u=+(l[a+(j*3|0)>>0]|0);o[db>>2]=u;v=+(l[a+(j*3|0)+1>>0]|0);o[d>>2]=v;w=+(l[a+(j*3|0)+2>>0]|0);o[e>>2]=w;a=k[G>>2]|0;if((a|0)==(k[c>>2]|0))ola(bb,db);else{o[a>>2]=u;o[a+4>>2]=v;o[a+8>>2]=w;k[G>>2]=a+12}}}j=j+1|0;h=k[q>>2]|0}while((j|0)<(h|0));a=k[n>>2]|0}m=m+1|0}while((m|0)<(a|0));Za=k[ab>>2]|0;_a=k[H>>2]|0;h=_a;a=Za;if((Za|0)!=(_a|0)?(k[bb>>2]|0)!=(k[G>>2]|0):0){d=H;e=ab}else $a=64}else $a=64;if(($a|0)==64){k[db>>2]=0;a=db+4|0;k[a>>2]=0;h=ZT(48)|0;k[h>>2]=1;S=h+4|0;k[db>>2]=S;k[a>>2]=42;i[h+46>>0]=0;R=257508;T=S+42|0;do{i[S>>0]=i[R>>0]|0;S=S+1|0;R=R+1|0}while((S|0)<(T|0));Y8(-215,db,257551,257261,379);k[a>>2]=0;k[db>>2]=0;_a=k[h>>2]|0;k[h>>2]=_a+-1;if((_a|0)==1)ggb(k[h+-4>>2]|0);d=H;e=ab;a=k[ab>>2]|0;h=k[H>>2]|0}_a=h-a|0;n=a;k[nb>>2]=1124007941;D=nb+4|0;k[D>>2]=2;s=nb+8|0;k[s>>2]=(_a|0)/12|0;j=nb+12|0;k[j>>2]=3;B=nb+16|0;k[B>>2]=n;q=nb+20|0;k[q>>2]=n;t=nb+24|0;b=nb+28|0;C=nb+40|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;k[C>>2]=s;F=nb+48|0;E=nb+44|0;k[E>>2]=F;k[nb+52>>2]=0;k[F>>2]=0;if((a|0)==0&(_a|0)!=0){k[db>>2]=0;a=db+4|0;k[a>>2]=0;h=ZT(36)|0;k[h>>2]=1;S=h+4|0;k[db>>2]=S;k[a>>2]=28;i[h+32>>0]=0;R=390609;T=S+28|0;do{i[S>>0]=i[R>>0]|0;S=S+1|0;R=R+1|0}while((S|0)<(T|0));Y8(-215,db,390638,390642,410);k[a>>2]=0;k[db>>2]=0;_a=k[h>>2]|0;k[h>>2]=_a+-1;if((_a|0)==1)ggb(k[h+-4>>2]|0);h=k[j>>2]|0;j=k[nb>>2]|0;m=k[E>>2]|0;a=k[q>>2]|0}else{h=3;j=1124007941;m=F;a=n}Za=h<<2;k[nb>>2]=j|16384;k[m>>2]=Za;k[m+4>>2]=4;_a=a+(aa(k[s>>2]|0,Za)|0)|0;k[b>>2]=_a;k[t>>2]=_a+(0-Za)+Za;k[db+8>>2]=0;k[db+12>>2]=0;k[db>>2]=16842752;k[db+4>>2]=nb;Za=mb+4|0;_a=Za+4|0;k[_a>>2]=0;k[_a+4>>2]=0;k[mb>>2]=50397184;k[Za>>2]=eb;+xZ(db,5,mb,1,10,0.0,0,2,49332);Za=k[bb>>2]|0;_a=(k[G>>2]|0)-Za|0;a=Za;k[mb>>2]=1124007941;y=mb+4|0;k[y>>2]=2;q=mb+8|0;k[q>>2]=(_a|0)/12|0;j=mb+12|0;k[j>>2]=3;b=mb+16|0;k[b>>2]=a;n=mb+20|0;k[n>>2]=a;s=mb+24|0;t=mb+28|0;c=mb+40|0;k[s>>2]=0;k[s+4>>2]=0;k[s+8>>2]=0;k[s+12>>2]=0;k[c>>2]=q;A=mb+48|0;z=mb+44|0;k[z>>2]=A;k[mb+52>>2]=0;k[A>>2]=0;if((Za|0)==0&(_a|0)!=0){k[db>>2]=0;a=db+4|0;k[a>>2]=0;h=ZT(36)|0;k[h>>2]=1;S=h+4|0;k[db>>2]=S;k[a>>2]=28;i[h+32>>0]=0;R=390609;T=S+28|0;do{i[S>>0]=i[R>>0]|0;S=S+1|0;R=R+1|0}while((S|0)<(T|0));Y8(-215,db,390638,390642,410);k[a>>2]=0;k[db>>2]=0;_a=k[h>>2]|0;k[h>>2]=_a+-1;if((_a|0)==1)ggb(k[h+-4>>2]|0);h=k[j>>2]|0;j=k[mb>>2]|0;m=k[z>>2]|0;a=k[n>>2]|0}else{h=3;j=1124007941;m=A}_a=h<<2;k[mb>>2]=j|16384;k[m>>2]=_a;k[m+4>>2]=4;j=a+(aa(k[q>>2]|0,_a)|0)|0;k[t>>2]=j;k[s>>2]=j+(0-_a)+_a;k[db+8>>2]=0;k[db+12>>2]=0;k[db>>2]=16842752;k[db+4>>2]=mb;j=hb+4|0;a=j+4|0;k[a>>2]=0;k[a+4>>2]=0;k[hb>>2]=50397184;k[j>>2]=fb;+xZ(db,5,hb,1,10,0.0,0,2,49332);zpb(sb+472|0,0,504)|0;j=k[e>>2]|0;a=(k[d>>2]|0)-j|0;if((a|0)>0){m=k[eb+16>>2]|0;n=k[N>>2]|0;q=sb+972|0;h=(a>>>0)/12|0;a=0;do{_a=m+(aa(k[n>>2]|0,a)|0)|0;_a=k[_a>>2]|0;v=+o[j+(a*12|0)>>2];w=+o[j+(a*12|0)+4>>2];x=+o[j+(a*12|0)+8>>2];Za=sb+472+(_a*24|0)|0;p[Za>>3]=v+ +p[Za>>3];Za=sb+472+(_a*24|0)+8|0;p[Za>>3]=w+ +p[Za>>3];Za=sb+472+(_a*24|0)+16|0;p[Za>>3]=x+ +p[Za>>3];Za=sb+592+(_a*72|0)|0;p[Za>>3]=v*v+ +p[Za>>3];u=v*w;Za=sb+592+(_a*72|0)+8|0;p[Za>>3]=u+ +p[Za>>3];v=v*x;Za=sb+592+(_a*72|0)+16|0;p[Za>>3]=v+ +p[Za>>3];Za=sb+592+(_a*72|0)+24|0;p[Za>>3]=u+ +p[Za>>3];Za=sb+592+(_a*72|0)+32|0;p[Za>>3]=w*w+ +p[Za>>3];w=w*x;Za=sb+592+(_a*72|0)+40|0;p[Za>>3]=w+ +p[Za>>3];Za=sb+592+(_a*72|0)+48|0;p[Za>>3]=v+ +p[Za>>3];Za=sb+592+(_a*72|0)+56|0;p[Za>>3]=w+ +p[Za>>3];Za=sb+592+(_a*72|0)+64|0;p[Za>>3]=x*x+ +p[Za>>3];_a=sb+952+(_a<<2)|0;k[_a>>2]=(k[_a>>2]|0)+1;k[q>>2]=(k[q>>2]|0)+1;a=a+1|0}while((a|0)<(h|0))}lla(sb);zpb(qb+472|0,0,504)|0;j=k[bb>>2]|0;a=(k[G>>2]|0)-j|0;if((a|0)>0){m=k[fb+16>>2]|0;n=k[J>>2]|0;q=qb+972|0;h=(a>>>0)/12|0;a=0;do{_a=m+(aa(k[n>>2]|0,a)|0)|0;_a=k[_a>>2]|0;v=+o[j+(a*12|0)>>2];w=+o[j+(a*12|0)+4>>2];x=+o[j+(a*12|0)+8>>2];Za=qb+472+(_a*24|0)|0;p[Za>>3]=v+ +p[Za>>3];Za=qb+472+(_a*24|0)+8|0;p[Za>>3]=w+ +p[Za>>3];Za=qb+472+(_a*24|0)+16|0;p[Za>>3]=x+ +p[Za>>3];Za=qb+592+(_a*72|0)|0;p[Za>>3]=v*v+ +p[Za>>3];u=v*w;Za=qb+592+(_a*72|0)+8|0;p[Za>>3]=u+ +p[Za>>3];v=v*x;Za=qb+592+(_a*72|0)+16|0;p[Za>>3]=v+ +p[Za>>3];Za=qb+592+(_a*72|0)+24|0;p[Za>>3]=u+ +p[Za>>3];Za=qb+592+(_a*72|0)+32|0;p[Za>>3]=w*w+ +p[Za>>3];w=w*x;Za=qb+592+(_a*72|0)+40|0;p[Za>>3]=w+ +p[Za>>3];Za=qb+592+(_a*72|0)+48|0;p[Za>>3]=v+ +p[Za>>3];Za=qb+592+(_a*72|0)+56|0;p[Za>>3]=w+ +p[Za>>3];Za=qb+592+(_a*72|0)+64|0;p[Za>>3]=x*x+ +p[Za>>3];_a=qb+952+(_a<<2)|0;k[_a>>2]=(k[_a>>2]|0)+1;k[q>>2]=(k[q>>2]|0)+1;a=a+1|0}while((a|0)<(h|0))}lla(qb);j=mb+36|0;a=k[j>>2]|0;if(a|0?(Za=a+12|0,_a=k[Za>>2]|0,k[Za>>2]=_a+-1,(_a|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[mb+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[y>>2]|0)>0){h=k[c>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[y>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(A|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=nb+36|0;a=k[j>>2]|0;if(a|0?(Za=a+12|0,_a=k[Za>>2]|0,k[Za>>2]=_a+-1,(_a|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[nb+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[D>>2]|0)>0){h=k[C>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[D>>2]|0))}a=k[E>>2]|0;if(!((a|0)==(F|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[bb>>2]|0;h=a;if(a|0){j=k[G>>2]|0;if((j|0)!=(a|0))k[G>>2]=j+(~(((j+-12-h|0)>>>0)/12|0)*12|0);ggb(a)}a=k[ab>>2]|0;h=a;if(a|0){j=k[H>>2]|0;if((j|0)!=(a|0))k[H>>2]=j+(~(((j+-12-h|0)>>>0)/12|0)*12|0);ggb(a)}j=fb+36|0;a=k[j>>2]|0;do if(a|0){Za=a+12|0;_a=k[Za>>2]|0;k[Za>>2]=_a+-1;if((_a|0)!=1)break;h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[fb+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}while(0);k[j>>2]=0;_a=fb+16|0;k[_a>>2]=0;k[_a+4>>2]=0;k[_a+8>>2]=0;k[_a+12>>2]=0;if((k[K>>2]|0)>0){h=k[I>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[K>>2]|0))}a=k[J>>2]|0;if(!((a|0)==(L|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=eb+36|0;a=k[j>>2]|0;do if(a|0){Za=a+12|0;_a=k[Za>>2]|0;k[Za>>2]=_a+-1;if((_a|0)!=1)break;h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[eb+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}while(0);k[j>>2]=0;_a=eb+16|0;k[_a>>2]=0;k[_a+4>>2]=0;k[_a+8>>2]=0;k[_a+12>>2]=0;if((k[O>>2]|0)>0){h=k[M>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[O>>2]|0))}a=k[N>>2]|0;if(!((a|0)==(Q|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}if((f|0)>=1){if((g|0)==2)nla(tb,V);Ra=tb+8|0;b=k[Ra>>2]|0;Sa=tb+12|0;d=k[Sa>>2]|0;if((b|0)>0){n=(d|0)>0;q=k[rb>>2]|0;s=k[tb+44>>2]|0;t=d+-1|0;m=0;u=0.0;do{a:do if(n){h=k[s>>2]|0;j=q+(aa(h,m)|0)|0;h=q+(aa(h,m+-1|0)|0)|0;if((m|0)>0)a=0;else{a=0;while(1){if((a|0)>0){_a=a+-1|0;v=+(l[j+(a*3|0)>>0]|0)-+(l[j+(_a*3|0)>>0]|0);w=+(l[j+(a*3|0)+1>>0]|0)-+(l[j+(_a*3|0)+1>>0]|0);x=+(l[j+(a*3|0)+2>>0]|0)-+(l[j+(_a*3|0)+2>>0]|0);u=u+(v*v+0.0+w*w+x*x)}a=a+1|0;if((a|0)==(d|0))break a}}do{v=+(l[j+(a*3|0)>>0]|0);w=+(l[j+(a*3|0)+1>>0]|0);x=+(l[j+(a*3|0)+2>>0]|0);if((a|0)>0){_a=a+-1|0;Ab=v-+(l[j+(_a*3|0)>>0]|0);zb=w-+(l[j+(_a*3|0)+1>>0]|0);yb=x-+(l[j+(_a*3|0)+2>>0]|0);xb=v-+(l[h+(_a*3|0)>>0]|0);wb=w-+(l[h+(_a*3|0)+1>>0]|0);vb=x-+(l[h+(_a*3|0)+2>>0]|0);u=u+(Ab*Ab+0.0+zb*zb+yb*yb)+(xb*xb+0.0+wb*wb+vb*vb)}yb=v-+(l[h+(a*3|0)>>0]|0);zb=w-+(l[h+(a*3|0)+1>>0]|0);Ab=x-+(l[h+(a*3|0)+2>>0]|0);u=u+(yb*yb+0.0+zb*zb+Ab*Ab);_a=a;a=a+1|0;if((_a|0)<(t|0)){yb=v-+(l[h+(a*3|0)>>0]|0);zb=w-+(l[h+(a*3|0)+1>>0]|0);Ab=x-+(l[h+(a*3|0)+2>>0]|0);u=u+(yb*yb+0.0+zb*zb+Ab*Ab)}}while((a|0)!=(d|0))}while(0);m=m+1|0}while((m|0)!=(b|0));if(!(u<=2.220446049250313e-16))x=1.0/(u*2.0/+((aa(b,-3)|0)+2+(aa(d,(b<<2)+-3|0)|0)|0));else x=0.0}else x=0.0;k[nb>>2]=1124007936;Za=nb+4|0;a=nb+8|0;Xa=nb+40|0;S=Za;T=S+36|0;do{k[S>>2]=0;S=S+4|0}while((S|0)<(T|0));k[Xa>>2]=a;_a=nb+48|0;Ya=nb+44|0;k[Ya>>2]=_a;k[nb+52>>2]=0;k[_a>>2]=0;k[mb>>2]=1124007936;Ua=mb+4|0;j=mb+8|0;Ta=mb+40|0;S=Ua;T=S+36|0;do{k[S>>2]=0;S=S+4|0}while((S|0)<(T|0));k[Ta>>2]=j;Wa=mb+48|0;Va=mb+44|0;k[Va>>2]=Wa;k[mb+52>>2]=0;k[Wa>>2]=0;k[hb>>2]=1124007936;Oa=hb+4|0;m=hb+8|0;Na=hb+40|0;S=Oa;T=S+36|0;do{k[S>>2]=0;S=S+4|0}while((S|0)<(T|0));k[Na>>2]=m;Qa=hb+48|0;Pa=hb+44|0;k[Pa>>2]=Qa;k[hb+52>>2]=0;k[Qa>>2]=0;k[gb>>2]=1124007936;Ka=gb+4|0;n=gb+8|0;Ja=gb+40|0;S=Ka;T=S+36|0;do{k[S>>2]=0;S=S+4|0}while((S|0)<(T|0));k[Ja>>2]=n;Ma=gb+48|0;La=gb+44|0;k[La>>2]=Ma;k[gb+52>>2]=0;k[Ma>>2]=0;k[db>>2]=b;k[U>>2]=d;G1(nb,2,db,6);h=k[Ra>>2]|0;a=k[Sa>>2]|0;if(!(((((k[Ua>>2]|0)<3?(k[j>>2]|0)==(h|0):0)?(k[mb+12>>2]|0)==(a|0):0)?(k[mb>>2]&4095|0)==6:0)?(k[mb+16>>2]|0)!=0:0)){k[db>>2]=h;k[U>>2]=a;G1(mb,2,db,6);h=k[Ra>>2]|0;a=k[Sa>>2]|0}if(!(((((k[Oa>>2]|0)<3?(k[m>>2]|0)==(h|0):0)?(k[hb+12>>2]|0)==(a|0):0)?(k[hb>>2]&4095|0)==6:0)?(k[hb+16>>2]|0)!=0:0)){k[db>>2]=h;k[U>>2]=a;G1(hb,2,db,6);h=k[Ra>>2]|0;a=k[Sa>>2]|0}if(!(((((k[Ka>>2]|0)<3?(k[n>>2]|0)==(h|0):0)?(k[gb+12>>2]|0)==(a|0):0)?(k[gb>>2]&4095|0)==6:0)?(k[gb+16>>2]|0)!=0:0)){k[db>>2]=h;k[U>>2]=a;G1(gb,2,db,6);h=k[Ra>>2]|0}if((h|0)>0){q=tb+44|0;s=nb+16|0;t=mb+16|0;b=hb+16|0;d=gb+16|0;n=k[Sa>>2]|0;e=(n|0)>0;m=0;do{if(e){c=(m|0)>0;a=k[rb>>2]|0;z=k[k[q>>2]>>2]|0;y=a+(aa(z,m)|0)|0;z=a+(aa(z,m+-1|0)|0)|0;a=0;do{u=+(l[y+(a*3|0)>>0]|0);v=+(l[y+(a*3|0)+1>>0]|0);w=+(l[y+(a*3|0)+2>>0]|0);j=a+-1|0;do if((a|0)>0){yb=u-+(l[y+(j*3|0)>>0]|0);zb=v-+(l[y+(j*3|0)+1>>0]|0);Ab=w-+(l[y+(j*3|0)+2>>0]|0);Ab=+Z(+-(x*(yb*yb+0.0+zb*zb+Ab*Ab)))*50.0;$a=(k[s>>2]|0)+(aa(k[k[Ya>>2]>>2]|0,m)|0)+(a<<3)|0;p[$a>>3]=Ab;if(c){yb=u-+(l[z+(j*3|0)>>0]|0);zb=v-+(l[z+(j*3|0)+1>>0]|0);Ab=w-+(l[z+(j*3|0)+2>>0]|0);Ab=+Z(+-(x*(yb*yb+0.0+zb*zb+Ab*Ab)))*35.35533966440824;$a=(k[t>>2]|0)+(aa(k[k[Va>>2]>>2]|0,m)|0)+(a<<3)|0;p[$a>>3]=Ab;$a=188;break}else{$a=(k[t>>2]|0)+(aa(k[k[Va>>2]>>2]|0,m)|0)+(a<<3)|0;p[$a>>3]=0.0;$a=187;break}}else{$a=(k[s>>2]|0)+(aa(k[k[Ya>>2]>>2]|0,m)|0)+(a<<3)|0;p[$a>>3]=0.0;$a=(k[t>>2]|0)+(aa(k[k[Va>>2]>>2]|0,m)|0)+(a<<3)|0;p[$a>>3]=0.0;if(c)$a=188;else $a=187}while(0);if(($a|0)==187){j=(k[b>>2]|0)+(aa(k[k[Pa>>2]>>2]|0,m)|0)+(a<<3)|0;p[j>>3]=0.0;j=a+1|0;$a=190}else if(($a|0)==188){$a=0;yb=u-+(l[z+(a*3|0)>>0]|0);zb=v-+(l[z+(a*3|0)+1>>0]|0);Ab=w-+(l[z+(a*3|0)+2>>0]|0);Ab=+Z(+-(x*(yb*yb+0.0+zb*zb+Ab*Ab)))*50.0;j=(k[b>>2]|0)+(aa(k[k[Pa>>2]>>2]|0,m)|0)+(a<<3)|0;p[j>>3]=Ab;j=a+1|0;if((j|0)<(n|0)){yb=u-+(l[z+(j*3|0)>>0]|0);zb=v-+(l[z+(j*3|0)+1>>0]|0);Ab=w-+(l[z+(j*3|0)+2>>0]|0);Ab=+Z(+-(x*(yb*yb+0.0+zb*zb+Ab*Ab)))*35.35533966440824;a=(k[d>>2]|0)+(aa(k[k[La>>2]>>2]|0,m)|0)+(a<<3)|0;p[a>>3]=Ab;a=j}else $a=190}if(($a|0)==190){$a=0;a=(k[d>>2]|0)+(aa(k[k[La>>2]>>2]|0,m)|0)+(a<<3)|0;p[a>>3]=0.0;a=j}}while((a|0)<(n|0))}m=m+1|0}while((m|0)!=(h|0))}b:do if((f|0)>0){ia=tb+44|0;ja=V+16|0;ka=V+44|0;la=db+8|0;ma=db+16|0;na=ob+16|0;oa=db+8|0;pa=db+16|0;qa=sb+472|0;ra=qb+472|0;sa=qb+972|0;ta=sb+972|0;ua=cb+12|0;va=cb+24|0;wa=cb+4|0;xa=cb+8|0;ya=sb+56|0;za=db+8|0;Aa=db+16|0;Ba=qb+56|0;Ca=db+8|0;Da=db+16|0;Ea=nb+16|0;Fa=mb+16|0;Ga=hb+16|0;Ha=gb+16|0;Ia=V+8|0;V=V+12|0;W=cb+12|0;X=cb+16|0;Y=cb+20|0;$=db+4|0;ba=eb+4|0;ca=eb+8|0;da=bb+4|0;ea=bb+4|0;fa=bb+4|0;ga=eb+8|0;ha=db+4|0;a=0;c:while(1){k[cb>>2]=0;k[cb+4>>2]=0;k[cb+8>>2]=0;k[cb+12>>2]=0;k[cb+16>>2]=0;k[cb+20>>2]=0;k[cb+24>>2]=0;k[cb+28>>2]=0;if((h|0)>0){j=k[Sa>>2]|0;n=0;do{if((j|0)>0){m=0;do{U=(k[rb>>2]|0)+(aa(k[k[ia>>2]>>2]|0,n)|0)|0;u=+(l[U+(m*3|0)>>0]|0);v=+(l[U+(m*3|0)+1>>0]|0);w=+(l[U+(m*3|0)+2>>0]|0);U=(k[ja>>2]|0)+(aa(k[k[ka>>2]>>2]|0,n)|0)+m|0;switch(i[U>>0]|0){case 2:case 0:{p[db>>3]=u;p[oa>>3]=v;p[pa>>3]=w;Ab=+kla(sb,0,db);Ab=Ab>0.0?Ab:0.0;p[db>>3]=u;p[oa>>3]=v;p[pa>>3]=w;zb=+kla(sb,1,db);h=zb>Ab;Ab=h?zb:Ab;p[db>>3]=u;p[oa>>3]=v;p[pa>>3]=w;zb=+kla(sb,2,db);U=zb>Ab;Ab=U?zb:Ab;p[db>>3]=u;p[oa>>3]=v;p[pa>>3]=w;zb=+kla(sb,3,db);g=zb>Ab;p[db>>3]=u;p[oa>>3]=v;p[pa>>3]=w;yb=+kla(sb,4,db);h=yb>(g?zb:Ab)?4:g?3:U?2:h&1;break}default:{p[db>>3]=u;p[la>>3]=v;p[ma>>3]=w;Ab=+kla(qb,0,db);Ab=Ab>0.0?Ab:0.0;p[db>>3]=u;p[la>>3]=v;p[ma>>3]=w;zb=+kla(qb,1,db);h=zb>Ab;Ab=h?zb:Ab;p[db>>3]=u;p[la>>3]=v;p[ma>>3]=w;zb=+kla(qb,2,db);U=zb>Ab;Ab=U?zb:Ab;p[db>>3]=u;p[la>>3]=v;p[ma>>3]=w;zb=+kla(qb,3,db);g=zb>Ab;p[db>>3]=u;p[la>>3]=v;p[ma>>3]=w;yb=+kla(qb,4,db);h=yb>(g?zb:Ab)?4:g?3:U?2:h&1}}j=(k[na>>2]|0)+(aa(k[k[jb>>2]>>2]|0,n)|0)+(m<<2)|0;k[j>>2]=h;m=m+1|0;j=k[Sa>>2]|0}while((m|0)<(j|0));h=k[Ra>>2]|0}n=n+1|0}while((n|0)<(h|0))}zpb(qa|0,0,504)|0;zpb(ra|0,0,504)|0;U=0;j=h;do{if((j|0)>0){q=qb+472+(U*24|0)|0;s=qb+472+(U*24|0)+8|0;t=qb+472+(U*24|0)+16|0;b=qb+592+(U*72|0)|0;d=qb+592+(U*72|0)+8|0;e=qb+592+(U*72|0)+16|0;c=qb+592+(U*72|0)+24|0;y=qb+592+(U*72|0)+32|0;z=qb+592+(U*72|0)+40|0;A=qb+592+(U*72|0)+48|0;B=qb+592+(U*72|0)+56|0;C=qb+592+(U*72|0)+64|0;D=qb+952+(U<<2)|0;E=sb+472+(U*24|0)|0;F=sb+472+(U*24|0)+8|0;G=sb+472+(U*24|0)+16|0;H=sb+592+(U*72|0)|0;I=sb+592+(U*72|0)+8|0;J=sb+592+(U*72|0)+16|0;K=sb+592+(U*72|0)+24|0;L=sb+592+(U*72|0)+32|0;M=sb+592+(U*72|0)+40|0;N=sb+592+(U*72|0)+48|0;O=sb+592+(U*72|0)+56|0;Q=sb+592+(U*72|0)+64|0;R=sb+952+(U<<2)|0;j=k[Sa>>2]|0;S=(j|0)>0;g=0;while(1){if(S){m=k[na>>2]|0;n=k[jb>>2]|0;T=0;do{Bb=m+(aa(k[n>>2]|0,g)|0)+(T<<2)|0;d:do if((k[Bb>>2]|0)==(U|0)){Bb=(k[ja>>2]|0)+(aa(k[k[ka>>2]>>2]|0,g)|0)+T|0;switch(i[Bb>>0]|0){case 2:case 0:{Bb=(k[rb>>2]|0)+(aa(k[k[ia>>2]>>2]|0,g)|0)|0;yb=+(l[Bb+(T*3|0)>>0]|0);zb=+(l[Bb+(T*3|0)+1>>0]|0);Ab=+(l[Bb+(T*3|0)+2>>0]|0);p[E>>3]=yb+ +p[E>>3];p[F>>3]=zb+ +p[F>>3];p[G>>3]=Ab+ +p[G>>3];p[H>>3]=yb*yb+ +p[H>>3];xb=yb*zb;p[I>>3]=xb+ +p[I>>3];yb=yb*Ab;p[J>>3]=yb+ +p[J>>3];p[K>>3]=xb+ +p[K>>3];p[L>>3]=zb*zb+ +p[L>>3];zb=zb*Ab;p[M>>3]=zb+ +p[M>>3];p[N>>3]=yb+ +p[N>>3];p[O>>3]=zb+ +p[O>>3];p[Q>>3]=Ab*Ab+ +p[Q>>3];k[R>>2]=(k[R>>2]|0)+1;k[ta>>2]=(k[ta>>2]|0)+1;break d}default:{Bb=(k[rb>>2]|0)+(aa(k[k[ia>>2]>>2]|0,g)|0)|0;yb=+(l[Bb+(T*3|0)>>0]|0);zb=+(l[Bb+(T*3|0)+1>>0]|0);Ab=+(l[Bb+(T*3|0)+2>>0]|0);p[q>>3]=yb+ +p[q>>3];p[s>>3]=zb+ +p[s>>3];p[t>>3]=Ab+ +p[t>>3];p[b>>3]=yb*yb+ +p[b>>3];xb=yb*zb;p[d>>3]=xb+ +p[d>>3];yb=yb*Ab;p[e>>3]=yb+ +p[e>>3];p[c>>3]=xb+ +p[c>>3];p[y>>3]=zb*zb+ +p[y>>3];zb=zb*Ab;p[z>>3]=zb+ +p[z>>3];p[A>>3]=yb+ +p[A>>3];p[B>>3]=zb+ +p[B>>3];p[C>>3]=Ab*Ab+ +p[C>>3];k[D>>2]=(k[D>>2]|0)+1;k[sa>>2]=(k[sa>>2]|0)+1;break d}}}while(0);T=T+1|0}while((T|0)!=(j|0))}g=g+1|0;if((g|0)>=(h|0)){j=h;break}}}U=U+1|0}while((U|0)!=5);lla(sb);lla(qb);m=k[Sa>>2]|0;n=k[Ra>>2]|0;q=aa(n,m)|0;if(q|0){if(q>>>0>107374182){$a=228;break}j=q*40|0;j=(j|0)==0?1:j;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}Bb=h;k[cb>>2]=Bb;k[wa>>2]=Bb;k[xa>>2]=h+(q*40|0)}s=((aa(n+m|0,-3)|0)+(aa(m<<2,n)|0)<<1)+6|0;t=k[ua>>2]|0;h=t;do if((k[Y>>2]|0)-t>>4>>>0<s>>>0){q=(k[X>>2]|0)-t|0;n=q>>4;if(!s)m=0;else{if(s>>>0>268435455){$a=237;break c}j=s<<4;j=(j|0)==0?1:j;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}m=h}j=m+(n<<4)|0;h=j+(0-n<<4)|0;if((q|0)>0)upb(h|0,t|0,q|0)|0;k[ua>>2]=h;k[X>>2]=j;k[Y>>2]=m+(s<<4);if(!t)break;ggb(t)}while(0);p[va>>3]=0.0;j=k[Ra>>2]|0;if((j|0)>0){h=k[Sa>>2]|0;e=0;do{if((h|0)>0){b=(e|0)>0;d=0;do{S=db;T=S+40|0;do{k[S>>2]=0;S=S+4|0}while((S|0)<(T|0));h=k[wa>>2]|0;Bb=k[xa>>2]|0;j=Bb;do if((h|0)==(Bb|0)){s=k[cb>>2]|0;q=h-s|0;n=(q|0)/40|0;h=n+1|0;if(h>>>0>107374182){$a=254;break c}Bb=(j-s|0)/40|0;m=Bb<<1;m=Bb>>>0<53687091?(m>>>0<h>>>0?h:m):107374182;if(!m)h=0;else{if(m>>>0>107374182){$a=257;break c}j=m*40|0;j=(j|0)==0?1:j;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}}j=h+(n*40|0)|0;n=h+(m*40|0)|0;S=j;R=db;T=S+40|0;do{k[S>>2]=k[R>>2];S=S+4|0;R=R+4|0}while((S|0)<(T|0));m=j+40|0;j=j+(((q|0)/-40|0)*40|0)|0;h=j;if((q|0)>0)upb(j|0,s|0,q|0)|0;k[cb>>2]=h;k[wa>>2]=m;k[xa>>2]=n;if(!s){q=m;break}ggb(s);q=m}else{S=h;R=db;T=S+40|0;do{k[S>>2]=k[R>>2];S=S+4|0;R=R+4|0}while((S|0)<(T|0));q=h+40|0;k[wa>>2]=q;h=k[cb>>2]|0}while(0);n=q-h|0;s=(n|0)/40|0;t=s+-1|0;j=(k[rb>>2]|0)+(aa(k[k[ia>>2]>>2]|0,e)|0)|0;m=(k[ja>>2]|0)+(aa(k[k[ka>>2]>>2]|0,e)|0)+d|0;m=i[m>>0]|0;if((m&-2)<<24>>24==2){Eb=+(l[j+(d*3|0)>>0]|0);Db=+(l[j+(d*3|0)+1>>0]|0);Cb=+(l[j+(d*3|0)+2>>0]|0);Ab=+p[k[ya>>2]>>3];p[db>>3]=Eb;p[za>>3]=Db;p[Aa>>3]=Cb;zb=+kla(sb,0,db);yb=+p[(k[ya>>2]|0)+8>>3];p[db>>3]=Eb;p[za>>3]=Db;p[Aa>>3]=Cb;xb=+kla(sb,1,db);wb=+p[(k[ya>>2]|0)+16>>3];p[db>>3]=Eb;p[za>>3]=Db;p[Aa>>3]=Cb;vb=+kla(sb,2,db);x=+p[(k[ya>>2]|0)+24>>3];p[db>>3]=Eb;p[za>>3]=Db;p[Aa>>3]=Cb;w=+kla(sb,3,db);u=+p[(k[ya>>2]|0)+32>>3];p[db>>3]=Eb;p[za>>3]=Db;p[Aa>>3]=Cb;u=-+_(+(Ab*zb+0.0+yb*xb+wb*vb+x*w+u*+kla(sb,4,db)));w=+p[k[Ba>>2]>>3];p[db>>3]=Eb;p[Ca>>3]=Db;p[Da>>3]=Cb;x=+kla(qb,0,db);vb=+p[(k[Ba>>2]|0)+8>>3];p[db>>3]=Eb;p[Ca>>3]=Db;p[Da>>3]=Cb;wb=+kla(qb,1,db);xb=+p[(k[Ba>>2]|0)+16>>3];p[db>>3]=Eb;p[Ca>>3]=Db;p[Da>>3]=Cb;yb=+kla(qb,2,db);zb=+p[(k[Ba>>2]|0)+24>>3];p[db>>3]=Eb;p[Ca>>3]=Db;p[Da>>3]=Cb;Ab=+kla(qb,3,db);v=+p[(k[Ba>>2]|0)+32>>3];p[db>>3]=Eb;p[Ca>>3]=Db;p[Da>>3]=Cb;v=-+_(+(w*x+0.0+vb*wb+xb*yb+zb*Ab+v*+kla(qb,4,db)))}else{Bb=m<<24>>24==0;u=Bb?0.0:450.0;v=Bb?450.0:0.0}if(!((n|0)>0?((q-h|0)/40|0|0)>=(s|0):0)){k[db>>2]=0;k[$>>2]=0;h=ZT(32)|0;k[h>>2]=1;S=h+4|0;k[db>>2]=S;k[$>>2]=26;i[h+30>>0]=0;R=257560;T=S+26|0;do{i[S>>0]=i[R>>0]|0;S=S+1|0;R=R+1|0}while((S|0)<(T|0));Y8(-215,db,257753,257603,141);k[$>>2]=0;k[db>>2]=0;Bb=k[h>>2]|0;k[h>>2]=Bb+-1;if((Bb|0)==1)ggb(k[h+-4>>2]|0);h=k[cb>>2]|0}Bb=h+(t*40|0)+24|0;Db=+p[Bb>>3];U=Db>0.0;Eb=U?v:v-Db;Db=U?Db+u:u;p[va>>3]=+p[va>>3]+(Db<Eb?Db:Eb);p[Bb>>3]=Db-Eb;do if((d|0)<=0){if(b)$a=279}else{h=(k[Ea>>2]|0)+(aa(k[k[Ya>>2]>>2]|0,e)|0)+(d<<3)|0;Eb=+p[h>>3];h=s+-2|0;pla(cb,t,h,Eb,Eb);if(!b)break;$a=(k[Fa>>2]|0)+(aa(k[k[Va>>2]>>2]|0,e)|0)+(d<<3)|0;Eb=+p[$a>>3];pla(cb,t,h-(k[Sa>>2]|0)|0,Eb,Eb);$a=279}while(0);do if(($a|0)==279){$a=0;h=(k[Ga>>2]|0)+(aa(k[k[Pa>>2]>>2]|0,e)|0)+(d<<3)|0;Eb=+p[h>>3];pla(cb,t,t-(k[Sa>>2]|0)|0,Eb,Eb);h=k[Sa>>2]|0;if((d|0)>=(h+-1|0))break;Bb=(k[Ha>>2]|0)+(aa(k[k[La>>2]>>2]|0,e)|0)+(d<<3)|0;Eb=+p[Bb>>3];pla(cb,t,s-h|0,Eb,Eb)}while(0);d=d+1|0;h=k[Sa>>2]|0}while((d|0)<(h|0));j=k[Ra>>2]|0}e=e+1|0}while((e|0)<(j|0));G=k[W>>2]|0}else G=h;k[db>>2]=db;F=k[cb>>2]|0;k[eb>>2]=0;k[ba>>2]=0;k[ca>>2]=0;h=(k[wa>>2]|0)-F|0;if((h|0)>0){n=(h>>>0)/40|0;j=db;m=0;do{h=F+(m*40|0)|0;k[F+(m*40|0)+12>>2]=0;u=+p[F+(m*40|0)+24>>3];if(u!=0.0){k[j>>2]=h;k[F+(m*40|0)+16>>2]=1;i[F+(m*40|0)+32>>0]=u<0.0&1;j=h;h=-1}else h=0;k[F+(m*40|0)+4>>2]=h;m=m+1|0}while((m|0)<(n|0));h=k[db>>2]|0}else{j=db;h=db}k[j>>2]=db;k[db>>2]=0;do if((h|0)!=(db|0)){m=h;E=0;h=0;while(1){n=-1;z=m;while(1){k[fb>>2]=z;if(!(k[z+4>>2]|0))m=z;else{c=i[z+32>>0]|0;m=k[z+8>>2]|0;e:do if(!m)m=n;else{y=c&255;while(1){q=m^y;do if(!(+p[G+(q<<4)+8>>3]==0.0)){d=k[G+(m<<4)>>2]|0;s=F+(d*40|0)|0;k[ab>>2]=s;e=F+(d*40|0)+4|0;t=F+(d*40|0)+32|0;if(!(k[e>>2]|0)){i[t>>0]=c;k[e>>2]=m^1;Bb=k[fb>>2]|0;k[F+(d*40|0)+12>>2]=k[Bb+12>>2];k[F+(d*40|0)+16>>2]=(k[Bb+16>>2]|0)+1;if(k[s>>2]|0)break;k[s>>2]=db;k[j>>2]=s;j=s;break}if((i[t>>0]|0)!=c<<24>>24){m=q;break e}t=F+(d*40|0)+16|0;q=k[fb>>2]|0;b=(k[q+16>>2]|0)+1|0;if((k[t>>2]|0)<=(b|0))break;s=F+(d*40|0)+12|0;q=k[q+12>>2]|0;if((k[s>>2]|0)>(q|0))break;k[e>>2]=m^1;k[s>>2]=q;k[t>>2]=b}while(0);m=k[G+(m<<4)+4>>2]|0;if(!m){m=n;break}}}while(0);if((m|0)>0)break;n=m;m=k[fb>>2]|0}z=k[z>>2]|0;k[m>>2]=0;if((z|0)==(db|0)){$a=309;break}}if(($a|0)==309){$a=0;if((n|0)<1)break;else{z=db;m=n}}b=G+(m<<4)+8|0;u=+p[b>>3];if(!(u>0.0)){k[bb>>2]=0;k[da>>2]=0;h=ZT(20)|0;k[h>>2]=1;S=h+4|0;k[bb>>2]=S;k[da>>2]=13;i[h+17>>0]=0;R=257672;T=S+13|0;do{i[S>>0]=i[R>>0]|0;S=S+1|0;R=R+1|0}while((S|0)<(T|0));Y8(-215,bb,257686,257603,244);k[da>>2]=0;k[bb>>2]=0;Bb=k[h>>2]|0;k[h>>2]=Bb+-1;if((Bb|0)==1)ggb(k[h+-4>>2]|0)}t=m^1;s=G+(t<<4)|0;h=k[s>>2]|0;k[fb>>2]=F+(h*40|0);n=k[F+(h*40|0)+4>>2]|0;if((n|0)>=0)do{Eb=+p[G+((n^1)<<4)+8>>3];u=u>Eb?Eb:u;if(!(u>0.0)){k[bb>>2]=0;k[fa>>2]=0;h=ZT(20)|0;k[h>>2]=1;S=h+4|0;k[bb>>2]=S;k[fa>>2]=13;i[h+17>>0]=0;R=257672;T=S+13|0;do{i[S>>0]=i[R>>0]|0;S=S+1|0;R=R+1|0}while((S|0)<(T|0));Y8(-215,bb,257686,257603,254);k[fa>>2]=0;k[bb>>2]=0;Bb=k[h>>2]|0;k[h>>2]=Bb+-1;if((Bb|0)==1)ggb(k[h+-4>>2]|0)}h=k[G+(n<<4)>>2]|0;k[fb>>2]=F+(h*40|0);n=k[F+(h*40|0)+4>>2]|0}while((n|0)>=0);Eb=+P(+(+p[F+(h*40|0)+24>>3]));u=u>Eb?Eb:u;if(!(u>0.0)){k[bb>>2]=0;k[ea>>2]=0;h=ZT(20)|0;k[h>>2]=1;S=h+4|0;k[bb>>2]=S;k[ea>>2]=13;i[h+17>>0]=0;R=257672;T=S+13|0;do{i[S>>0]=i[R>>0]|0;S=S+1|0;R=R+1|0}while((S|0)<(T|0));Y8(-215,bb,257686,257603,258);k[ea>>2]=0;k[bb>>2]=0;Bb=k[h>>2]|0;k[h>>2]=Bb+-1;if((Bb|0)==1)ggb(k[h+-4>>2]|0)}q=G+(m<<4)|0;h=k[q>>2]|0;k[fb>>2]=F+(h*40|0);m=k[F+(h*40|0)+4>>2]|0;if((m|0)>=0)do{Eb=+p[G+(m<<4)+8>>3];u=u>Eb?Eb:u;if(!(u>0.0)){k[bb>>2]=0;k[fa>>2]=0;h=ZT(20)|0;k[h>>2]=1;S=h+4|0;k[bb>>2]=S;k[fa>>2]=13;i[h+17>>0]=0;R=257672;T=S+13|0;do{i[S>>0]=i[R>>0]|0;S=S+1|0;R=R+1|0}while((S|0)<(T|0));Y8(-215,bb,257686,257603,254);k[fa>>2]=0;k[bb>>2]=0;Bb=k[h>>2]|0;k[h>>2]=Bb+-1;if((Bb|0)==1)ggb(k[h+-4>>2]|0)}h=k[G+(m<<4)>>2]|0;k[fb>>2]=F+(h*40|0);m=k[F+(h*40|0)+4>>2]|0}while((m|0)>=0);Eb=+P(+(+p[F+(h*40|0)+24>>3]));u=u>Eb?Eb:u;if(!(u>0.0)){k[bb>>2]=0;k[ea>>2]=0;h=ZT(20)|0;k[h>>2]=1;S=h+4|0;k[bb>>2]=S;k[ea>>2]=13;i[h+17>>0]=0;R=257672;T=S+13|0;do{i[S>>0]=i[R>>0]|0;S=S+1|0;R=R+1|0}while((S|0)<(T|0));Y8(-215,bb,257686,257603,258);k[ea>>2]=0;k[bb>>2]=0;Bb=k[h>>2]|0;k[h>>2]=Bb+-1;if((Bb|0)==1)ggb(k[h+-4>>2]|0)}p[b>>3]=+p[b>>3]-u;h=G+(t<<4)+8|0;p[h>>3]=u+ +p[h>>3];p[va>>3]=u+ +p[va>>3];h=k[s>>2]|0;m=F+(h*40|0)|0;k[fb>>2]=m;n=k[F+(h*40|0)+4>>2]|0;if((n|0)>=0)do{Bb=G+(n<<4)+8|0;p[Bb>>3]=u+ +p[Bb>>3];Bb=G+((n^1)<<4)+8|0;Eb=+p[Bb>>3]-u;p[Bb>>3]=Eb;if(Eb==0.0){h=k[ba>>2]|0;if((h|0)==(k[ga>>2]|0))qla(eb,fb);else{k[h>>2]=m;k[ba>>2]=(k[ba>>2]|0)+4}k[(k[fb>>2]|0)+4>>2]=-2}h=k[G+(n<<4)>>2]|0;m=F+(h*40|0)|0;k[fb>>2]=m;n=k[F+(h*40|0)+4>>2]|0}while((n|0)>=0);Bb=F+(h*40|0)+24|0;Eb=+p[Bb>>3]-u;p[Bb>>3]=Eb;if(Eb==0.0){h=k[ba>>2]|0;if((h|0)==(k[ga>>2]|0))qla(eb,fb);else{k[h>>2]=m;k[ba>>2]=(k[ba>>2]|0)+4}k[(k[fb>>2]|0)+4>>2]=-2}h=k[q>>2]|0;n=F+(h*40|0)|0;k[fb>>2]=n;m=k[F+(h*40|0)+4>>2]|0;if((m|0)>=0)do{Bb=G+((m^1)<<4)+8|0;p[Bb>>3]=u+ +p[Bb>>3];Bb=G+(m<<4)+8|0;Eb=+p[Bb>>3]-u;p[Bb>>3]=Eb;if(Eb==0.0){h=k[ba>>2]|0;if((h|0)==(k[ga>>2]|0))qla(eb,fb);else{k[h>>2]=n;k[ba>>2]=(k[ba>>2]|0)+4}k[(k[fb>>2]|0)+4>>2]=-2}h=k[G+(m<<4)>>2]|0;n=F+(h*40|0)|0;k[fb>>2]=n;m=k[F+(h*40|0)+4>>2]|0}while((m|0)>=0);Bb=F+(h*40|0)+24|0;Eb=u+ +p[Bb>>3];p[Bb>>3]=Eb;if(Eb==0.0){h=k[ba>>2]|0;if((h|0)==(k[ga>>2]|0))qla(eb,fb);else{k[h>>2]=n;k[ba>>2]=(k[ba>>2]|0)+4}k[(k[fb>>2]|0)+4>>2]=-2}E=E+1|0;h=k[eb>>2]|0;m=k[ba>>2]|0;f:do if((h|0)!=(m|0))do{while(1){m=m+-4|0;C=k[m>>2]|0;k[ba>>2]=m;D=i[C+32>>0]|0;B=C+8|0;n=k[B>>2]|0;if(!n){$a=342;break}A=D&255^1;c=2147483647;q=0;while(1){g:do if(+p[G+((A^n)<<4)+8>>3]==0.0)s=c;else{b=k[G+(n<<4)>>2]|0;t=F+(b*40|0)|0;k[ab>>2]=t;if((i[F+(b*40|0)+32>>0]|0)!=D<<24>>24){s=c;break}if(!(k[F+(b*40|0)+4>>2]|0)){s=c;break}y=F+(b*40|0)+12|0;h:do if((k[y>>2]|0)==(E|0)){s=0;$a=348}else{s=0;e=t;d=y;while(1){b=k[e+4>>2]|0;s=s+1|0;if((b|0)<0)break;b=k[G+(b<<4)>>2]|0;e=F+(b*40|0)|0;k[ab>>2]=e;d=F+(b*40|0)+12|0;if((k[d>>2]|0)==(E|0)){$a=348;break h}}if((b|0)==-2){s=c;break g}k[d>>2]=E;k[e+16>>2]=1}while(0);if(($a|0)==348){$a=0;s=(k[F+(b*40|0)+16>>2]|0)+s|0}d=s+1|0;if((d|0)==2147483647){s=c;break}s=(d|0)<(c|0);q=s?n:q;s=s?d:c;k[ab>>2]=t;if((k[y>>2]|0)==(E|0))break;else b=y;do{k[b>>2]=E;d=d+-1|0;k[t+16>>2]=d;Bb=k[G+(k[t+4>>2]<<4)>>2]|0;t=F+(Bb*40|0)|0;b=F+(Bb*40|0)+12|0}while((k[b>>2]|0)!=(E|0));k[ab>>2]=t}while(0);n=k[G+(n<<4)+4>>2]|0;if(!n)break;else c=s}k[C+4>>2]=q;n=C+12|0;if((q|0)<=0)break;k[n>>2]=E;k[C+16>>2]=s;if((h|0)==(m|0))break f}if(($a|0)==342){$a=0;k[C+4>>2]=0;n=C+12|0}k[n>>2]=0;n=k[B>>2]|0;if(n){q=D&255^1;do{Bb=k[G+(n<<4)>>2]|0;h=F+(Bb*40|0)|0;k[ab>>2]=h;m=k[F+(Bb*40|0)+4>>2]|0;do if(m|0?(i[F+(Bb*40|0)+32>>0]|0)==D<<24>>24:0){do if(+p[G+((q^n)<<4)+8>>3]!=0.0){if(k[h>>2]|0)break;k[h>>2]=db;k[j>>2]=h;j=h}while(0);if((m|0)<=0)break;if((F+((k[G+(m<<4)>>2]|0)*40|0)|0)!=(C|0))break;h=k[ba>>2]|0;if((h|0)==(k[ga>>2]|0)){qla(eb,ab);h=k[ab>>2]|0}else{Bb=k[ab>>2]|0;k[h>>2]=Bb;k[ba>>2]=(k[ba>>2]|0)+4;h=Bb}k[h+4>>2]=-2}while(0);n=k[G+(n<<4)+4>>2]|0}while((n|0)!=0);h=k[eb>>2]|0;m=k[ba>>2]|0}}while((h|0)!=(m|0));while(0);if((z|0)==(db|0))break;else m=z}if(!h)break;j=k[ba>>2]|0;if((j|0)!=(h|0))k[ba>>2]=j+(~((j+-4-h|0)>>>2)<<2);ggb(h)}while(0);h=k[Ia>>2]|0;if((h|0)>0){j=k[V>>2]|0;b=0;do{if((j|0)>0){t=0;do{n=k[ja>>2]|0;m=k[k[ka>>2]>>2]|0;Bb=n+(aa(m,b)|0)+t|0;do if((i[Bb>>0]&-2)<<24>>24==2){s=(aa(j,b)|0)+t|0;do if((s|0)>-1){h=k[cb>>2]|0;if((((k[wa>>2]|0)-h|0)/40|0|0)<=(s|0)){$a=406;break}q=h;j=m;h=n}else $a=406;while(0);if(($a|0)==406){$a=0;k[db>>2]=0;k[ha>>2]=0;h=ZT(32)|0;k[h>>2]=1;S=h+4|0;k[db>>2]=S;k[ha>>2]=26;i[h+30>>0]=0;R=257560;T=S+26|0;do{i[S>>0]=i[R>>0]|0;S=S+1|0;R=R+1|0}while((S|0)<(T|0));Y8(-215,db,257587,257603,381);k[ha>>2]=0;k[db>>2]=0;Bb=k[h>>2]|0;k[h>>2]=Bb+-1;if((Bb|0)==1)ggb(k[h+-4>>2]|0);q=k[cb>>2]|0;j=k[k[ka>>2]>>2]|0;h=k[ja>>2]|0}h=h+(aa(j,b)|0)+t|0;if(!(i[q+(s*40|0)+32>>0]|0)){i[h>>0]=3;break}else{i[h>>0]=2;break}}while(0);t=t+1|0;j=k[V>>2]|0}while((t|0)<(j|0));h=k[Ia>>2]|0}b=b+1|0}while((b|0)<(h|0))}h=k[W>>2]|0;j=h;if(h|0){m=k[X>>2]|0;if((m|0)!=(h|0))k[X>>2]=m+(~((m+-16-j|0)>>>4)<<4);ggb(h)}h=k[cb>>2]|0;j=h;if(h|0){m=k[wa>>2]|0;if((m|0)!=(h|0))k[wa>>2]=m+(~(((m+-40-j|0)>>>0)/40|0)*40|0);ggb(h)}a=a+1|0;if((a|0)>=(f|0))break b;h=k[Ra>>2]|0}if(($a|0)==228){Bb=te(4)|0;k[Bb>>2]=172664;Cf(Bb|0,28816,1287)}else if(($a|0)==237){Bb=te(4)|0;k[Bb>>2]=172664;Cf(Bb|0,28816,1287)}else if(($a|0)==254)ad(426534,426557,304,426811);else if(($a|0)==257){Bb=te(4)|0;k[Bb>>2]=172664;Cf(Bb|0,28816,1287)}}while(0);j=gb+36|0;a=k[j>>2]|0;if(a|0?(fb=a+12|0,Bb=k[fb>>2]|0,k[fb>>2]=Bb+-1,(Bb|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[gb+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;Bb=gb+16|0;k[Bb>>2]=0;k[Bb+4>>2]=0;k[Bb+8>>2]=0;k[Bb+12>>2]=0;if((k[Ka>>2]|0)>0){h=k[Ja>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Ka>>2]|0))}a=k[La>>2]|0;if(!((a|0)==(Ma|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=hb+36|0;a=k[j>>2]|0;if(a|0?(gb=a+12|0,Bb=k[gb>>2]|0,k[gb>>2]=Bb+-1,(Bb|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[hb+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;Bb=hb+16|0;k[Bb>>2]=0;k[Bb+4>>2]=0;k[Bb+8>>2]=0;k[Bb+12>>2]=0;if((k[Oa>>2]|0)>0){h=k[Na>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Oa>>2]|0))}a=k[Pa>>2]|0;if(!((a|0)==(Qa|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=mb+36|0;a=k[j>>2]|0;do if(a|0){hb=a+12|0;Bb=k[hb>>2]|0;k[hb>>2]=Bb+-1;if((Bb|0)!=1)break;h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[mb+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}while(0);k[j>>2]=0;Bb=mb+16|0;k[Bb>>2]=0;k[Bb+4>>2]=0;k[Bb+8>>2]=0;k[Bb+12>>2]=0;if((k[Ua>>2]|0)>0){h=k[Ta>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Ua>>2]|0))}a=k[Va>>2]|0;if(!((a|0)==(Wa|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=nb+36|0;a=k[j>>2]|0;do if(a|0){mb=a+12|0;Bb=k[mb>>2]|0;k[mb>>2]=Bb+-1;if((Bb|0)!=1)break;h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[nb+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}while(0);k[j>>2]=0;Bb=nb+16|0;k[Bb>>2]=0;k[Bb+4>>2]=0;k[Bb+8>>2]=0;k[Bb+12>>2]=0;if((k[Za>>2]|0)>0){h=k[Xa>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Za>>2]|0))}a=k[Ya>>2]|0;if(!((a|0)==(_a|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}j=ob+36|0;a=k[j>>2]|0;if(a|0?(nb=a+12|0,Bb=k[nb>>2]|0,k[nb>>2]=Bb+-1,(Bb|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[ob+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;Bb=ob+16|0;k[Bb>>2]=0;k[Bb+4>>2]=0;k[Bb+8>>2]=0;k[Bb+12>>2]=0;if((k[kb>>2]|0)>0){h=k[ib>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[kb>>2]|0))}a=k[jb>>2]|0;if(!((a|0)==(lb|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=qb+36|0;a=k[j>>2]|0;if(a|0?(ob=a+12|0,Bb=k[ob>>2]|0,k[ob>>2]=Bb+-1,(Bb|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[qb+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;Bb=qb+16|0;h=qb+4|0;k[Bb>>2]=0;k[Bb+4>>2]=0;k[Bb+8>>2]=0;k[Bb+12>>2]=0;if((k[h>>2]|0)>0){j=k[qb+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[qb+44>>2]|0;if(!((a|0)==(qb+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=sb+36|0;a=k[j>>2]|0;if(a|0?(qb=a+12|0,Bb=k[qb>>2]|0,k[qb>>2]=Bb+-1,(Bb|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[sb+32>>2]|0;if(!a){a=B1()|0;h=k[j>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;Bb=sb+16|0;h=sb+4|0;k[Bb>>2]=0;k[Bb+4>>2]=0;k[Bb+8>>2]=0;k[Bb+12>>2]=0;if((k[h>>2]|0)>0){j=k[sb+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[sb+44>>2]|0;if(!((a|0)==(sb+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);j=tb+36|0;a=k[j>>2]|0;if(a|0?(sb=a+12|0,Bb=k[sb>>2]|0,k[sb>>2]=Bb+-1,(Bb|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[tb+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;j=tb+4|0;k[rb>>2]=0;k[rb+4>>2]=0;k[rb+8>>2]=0;k[rb+12>>2]=0;if((k[j>>2]|0)>0){h=k[pb>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[tb+44>>2]|0;if((a|0)==(tb+48|0)|(a|0)==0){r=ub;return}ggb(k[a+-4>>2]|0);r=ub;return}function nla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+16|0;q=t;s=b+16|0;if(k[s>>2]|0){g=k[b+4>>2]|0;if((g|0)<3)d=aa(k[b+12>>2]|0,k[b+8>>2]|0)|0;else{f=k[b+40>>2]|0;e=0;d=1;do{d=aa(k[f+(e<<2)>>2]|0,d)|0;e=e+1|0}while((e|0)!=(g|0))}if(!d)h=7}else h=7;if((h|0)==7){d=q+4|0;e=ZT(20)|0;k[e>>2]=1;m=e+4|0;k[q>>2]=m;k[d>>2]=13;i[e+17>>0]=0;n=257768;o=m+13|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-5,q,257782,257261,325);k[d>>2]=0;k[q>>2]=0;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0)}if(k[b>>2]&4095|0){d=q+4|0;e=ZT(32)|0;k[e>>2]=1;m=e+4|0;k[q>>2]=m;k[d>>2]=27;i[e+31>>0]=0;n=257792;o=m+27|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-5,q,257782,257261,327);k[d>>2]=0;k[q>>2]=0;p=k[e>>2]|0;k[e>>2]=p+-1;if((p|0)==1)ggb(k[e+-4>>2]|0)}p=b+12|0;if((k[p>>2]|0)==(k[a+12>>2]|0)?(j=b+8|0,c=k[j>>2]|0,(c|0)==(k[a+8>>2]|0)):0)h=j;else{c=q+4|0;d=ZT(48)|0;k[d>>2]=1;m=d+4|0;k[q>>2]=m;k[c>>2]=43;i[d+47>>0]=0;n=257820;o=m+43|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-5,q,257782,257261,329);k[c>>2]=0;k[q>>2]=0;o=k[d>>2]|0;k[d>>2]=o+-1;if((o|0)==1)ggb(k[d+-4>>2]|0);c=b+8|0;h=c;c=k[c>>2]|0}if((c|0)<=0){r=t;return}f=b+44|0;g=q+4|0;e=0;c=k[p>>2]|0;do{if((c|0)>0){d=0;do{b=(k[s>>2]|0)+(aa(k[k[f>>2]>>2]|0,e)|0)+d|0;if((l[b>>0]|0)>=4){c=ZT(80)|0;k[c>>2]=1;m=c+4|0;k[q>>2]=m;k[g>>2]=74;i[c+78>>0]=0;n=257864;o=m+74|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-5,q,257782,257261,337);k[g>>2]=0;k[q>>2]=0;b=k[c>>2]|0;k[c>>2]=b+-1;if((b|0)==1)ggb(k[c+-4>>2]|0);c=k[p>>2]|0}d=d+1|0}while((d|0)<(c|0))}e=e+1|0}while((e|0)<(k[h>>2]|0));r=t;return}function ola(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0;l=a+4|0;c=k[l>>2]|0;m=k[a>>2]|0;h=(c-m|0)/12|0;d=h+1|0;if(d>>>0>357913941)ad(426534,426557,304,426811);j=m;e=c;i=a+8|0;g=((k[i>>2]|0)-m|0)/12|0;f=g<<1;f=g>>>0<178956970?(f>>>0<d>>>0?d:f):357913941;if(!f)d=0;else{if(f>>>0>357913941){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=f*12|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c}c=d+(h*12|0)|0;g=d+(f*12|0)|0;k[c>>2]=k[b>>2];k[d+(h*12|0)+4>>2]=k[b+4>>2];k[d+(h*12|0)+8>>2]=k[b+8>>2];f=c+12|0;if((e|0)!=(j|0))while(1){d=c+-12|0;h=e;e=e+-12|0;k[d>>2]=k[e>>2];k[c+-8>>2]=k[h+-8>>2];k[c+-4>>2]=k[h+-4>>2];if((e|0)==(j|0)){c=d;break}else c=d}k[a>>2]=c;k[l>>2]=f;k[i>>2]=g;if(!m)return;ggb(m);return}function pla(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0;u=r;r=r+32|0;s=u+16|0;t=u;if(!((b|0)>-1?(((k[a+4>>2]|0)-(k[a>>2]|0)|0)/40|0|0)>(b|0):0)){f=s+4|0;g=ZT(32)|0;k[g>>2]=1;j=g+4|0;k[s>>2]=j;k[f>>2]=26;i[g+30>>0]=0;l=257560;m=j+26|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,s,257694,257603,116);k[f>>2]=0;k[s>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0)}if(!((c|0)>-1?(((k[a+4>>2]|0)-(k[a>>2]|0)|0)/40|0|0)>(c|0):0)){f=s+4|0;g=ZT(32)|0;k[g>>2]=1;j=g+4|0;k[s>>2]=j;k[f>>2]=26;i[g+30>>0]=0;l=257703;m=j+26|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,s,257694,257603,117);k[f>>2]=0;k[s>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0)}if(!(d>=0.0&e>=0.0)){f=s+4|0;g=ZT(20)|0;k[g>>2]=1;j=g+4|0;k[s>>2]=j;k[f>>2]=15;i[g+19>>0]=0;l=257730;m=j+15|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,s,257694,257603,118);k[f>>2]=0;k[s>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0)}if((b|0)==(c|0)?(q=s+4|0,h=ZT(12)|0,k[h>>2]=1,o=h+4|0,k[s>>2]=o,k[q>>2]=6,i[h+10>>0]=0,i[o>>0]=i[257746]|0,i[o+1>>0]=i[257747]|0,i[o+2>>0]=i[257748]|0,i[o+3>>0]=i[257749]|0,i[o+4>>0]=i[257750]|0,i[o+5>>0]=i[257751]|0,Y8(-215,s,257694,257603,119),k[q>>2]=0,k[s>>2]=0,q=k[h>>2]|0,k[h>>2]=q+-1,(q|0)==1):0)ggb(k[h+-4>>2]|0);n=a+12|0;o=a+16|0;f=k[o>>2]|0;g=k[n>>2]|0;q=a+20|0;if((f|0)==(g|0)){g=(k[q>>2]|0)-f|0;if(g>>4>>>0<2){m=g>>3;m=m>>>0<2?2:m;if(!m)g=0;else{if(m>>>0>268435455){u=te(4)|0;k[u>>2]=172664;Cf(u|0,28816,1287)}g=m<<4;g=(g|0)==0?1:g;while(1){f=fgb(g)|0;if(f|0)break;f=k[207666]|0;k[207666]=f+0;if(!f){f=0;break}Qh[f&7]()}g=f};k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;f=g+16|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;f=g+32|0;h=k[n>>2]|0;j=(k[o>>2]|0)-h|0;l=g+(0-(j>>4)<<4)|0;if((j|0)>0)upb(l|0,h|0,j|0)|0;k[n>>2]=l;k[o>>2]=f;k[q>>2]=g+(m<<4);if(h){ggb(h);f=k[o>>2]|0}}else{k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;f=(k[o>>2]|0)+16|0;k[o>>2]=f;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;f=(k[o>>2]|0)+16|0;k[o>>2]=f}g=k[n>>2]|0}k[s>>2]=c;m=(k[a>>2]|0)+(b*40|0)+8|0;k[s+4>>2]=k[m>>2];p[s+8>>3]=d;k[m>>2]=f-g>>4;if((f|0)==(k[q>>2]|0)){rla(n,s);g=k[o>>2]|0;f=g}else{g=f;k[g>>2]=k[s>>2];k[g+4>>2]=k[s+4>>2];k[g+8>>2]=k[s+8>>2];k[g+12>>2]=k[s+12>>2];g=(k[o>>2]|0)+16|0;k[o>>2]=g;f=g}k[t>>2]=b;c=(k[a>>2]|0)+(c*40|0)+8|0;k[t+4>>2]=k[c>>2];p[t+8>>3]=e;k[c>>2]=f-(k[n>>2]|0)>>4;if((g|0)==(k[q>>2]|0)){rla(n,t);r=u;return}else{k[g>>2]=k[t>>2];k[g+4>>2]=k[t+4>>2];k[g+8>>2]=k[t+8>>2];k[g+12>>2]=k[t+12>>2];k[o>>2]=(k[o>>2]|0)+16;r=u;return}}function qla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>2;c=g+1|0;if(c>>>0>1073741823)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>1;f=e>>2>>>0<536870911?(f>>>0<c>>>0?c:f):1073741823;if(!f)c=0;else{if(f>>>0>1073741823){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<2)|0;k[e>>2]=k[b>>2];d=e+(0-g<<2)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+4;k[l>>2]=c+(f<<2);if(!i)return;ggb(i);return}function rla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>4;c=g+1|0;if(c>>>0>268435455)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>3;f=e>>4>>>0<134217727?(f>>>0<c>>>0?c:f):268435455;if(!f)c=0;else{if(f>>>0>268435455){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<4;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<4)|0;k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2];k[e+12>>2]=k[b+12>>2];d=e+(0-g<<4)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+16;k[l>>2]=c+(f<<4);if(!i)return;ggb(i);return}function sla(){var a=0,b=0;a=r;r=r+48|0;b=a;k[b>>2]=0;k[b+4>>2]=40;k[b+16>>2]=333622;k[b+12>>2]=0;k[b+8>>2]=0;k[b+20>>2]=774;k[b+24>>2]=1457;k[b+36>>2]=775;k[b+28>>2]=268;k[b+32>>2]=199;N5(b);k[120744]=k[107193];ud(1449,482976,x|0)|0;r=a;return}function tla(a){a=a|0;if((a|0)!=0?(k[a>>2]&-65536|0)==1111818240:0)a=(k[a+4>>2]|0)!=0;else a=0;return a&1|0}function ula(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0;j=r;r=r+16|0;g=j;if((a|0)==0?(h=g+4|0,b=ZT(8)|0,k[b>>2]=1,f=b+4|0,k[g>>2]=f,k[h>>2]=0,i[f>>0]=0,Y8(-27,g,334049,333645,2721),k[h>>2]=0,k[g>>2]=0,h=k[b>>2]|0,k[b>>2]=h+-1,(h|0)==1):0)ggb(k[b+-4>>2]|0);h=k[a>>2]|0;if(!h){r=j;return}if(!((k[h>>2]&-65536|0)==1111818240?(c=h+4|0,(k[c>>2]|0)!=0):0)){b=g+4|0;c=ZT(32)|0;k[c>>2]=1;d=c+4|0;k[g>>2]=d;k[b>>2]=24;i[c+28>>0]=0;e=333783;f=d+24|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-5,g,334049,333645,2728);k[b>>2]=0;k[g>>2]=0;g=k[c>>2]|0;k[c>>2]=g+-1;if((g|0)==1)ggb(k[c+-4>>2]|0);c=h+4|0}k[a>>2]=0;b=k[c>>2]|0;if((b|0)!=0?(k[b>>2]&-65536|0)==1111752704:0)I9(c);else{L9(b);k[c>>2]=0}b=h+264|0;c=k[b>>2]|0;if(c|0){ggb(k[c+-4>>2]|0);k[b>>2]=0}ggb(k[h+-4>>2]|0);r=j;return}function vla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0;y=r;r=r+272|0;v=y+136|0;w=y+8|0;t=y;x=ZT(544)|0;d=k6(a,b,389384)|0;a:do if(!d)g=0;else{switch(k[d>>2]&7){case 1:{g=k[d+8>>2]|0;break a}case 2:break;default:{g=2147483647;break a}}e=+p[d+8>>3];p[u>>3]=e;d=k[u+4>>2]|0;q=d&2146435072;if(!(q>>>0>1126170624|(q|0)==1126170624&0>0)){d=(d|0)<0;e=d?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=d?-0.0:0.0}g=~~e}while(0);d=k6(a,b,333931)|0;b:do if(!d)f=0;else{switch(k[d>>2]&7){case 1:{f=k[d+8>>2]|0;break b}case 2:break;default:{f=2147483647;break b}}e=+p[d+8>>3];p[u>>3]=e;d=k[u+4>>2]|0;q=d&2146435072;if(!(q>>>0>1126170624|(q|0)==1126170624&0>0)){d=(d|0)<0;e=d?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=d?-0.0:0.0}f=~~e}while(0);d=k6(a,b,333942)|0;c:do if(!d)d=0;else{switch(k[d>>2]&7){case 1:{d=k[d+8>>2]|0;break c}case 2:break;default:{d=2147483647;break c}}e=+p[d+8>>3];p[u>>3]=e;d=k[u+4>>2]|0;q=d&2146435072;if(!(q>>>0>1126170624|(q|0)==1126170624&0>0)){d=(d|0)<0;e=d?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=d?-0.0:0.0}d=~~e}while(0);q=(f|0)!=0;o=(d|0)!=0;k[x>>2]=g|(q?1024:0)|(o?2048:0)|1111818240;do if(g){s=s6(a,k6(a,b,333958)|0)|0;k[x+4>>2]=s;if(s|0?(k[s>>2]&-65536|0)==1111752704:0)break;d=v+4|0;f=ZT(28)|0;k[f>>2]=1;l=f+4|0;k[v>>2]=l;k[d>>2]=22;i[f+26>>0]=0;m=334001;n=l+22|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-2,v,333989,333645,3800);k[d>>2]=0;k[v>>2]=0;s=k[f>>2]|0;k[f>>2]=s+-1;if((s|0)==1)ggb(k[f+-4>>2]|0)}else{d=s6(a,k6(a,b,333954)|0)|0;k[v>>2]=d;if(((d|0)!=0?(k[d>>2]&-65536|0)==1111687168:0)?(k[d+16>>2]|0)!=0:0){h=d;j=d}else{d=t+4|0;f=ZT(24)|0;k[f>>2]=1;l=f+4|0;k[t>>2]=l;k[d>>2]=16;i[f+20>>0]=0;m=333972;n=l+16|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-2,t,333989,333645,3779);k[d>>2]=0;k[t>>2]=0;n=k[f>>2]|0;k[f>>2]=n+-1;if((n|0)==1)ggb(k[f+-4>>2]|0);j=k[v>>2]|0;h=j}g=h+4|0;d=k[g>>2]|0;if((d|0)>0){f=0;do{k[w+(f<<2)>>2]=k[h+20+(f<<3)>>2];f=f+1|0;d=k[g>>2]|0}while((f|0)<(d|0))}n=x+268|0;D9(n,d,w,k[h>>2]|0,k[h+16>>2]|0)|0;k[x+4>>2]=n;k[x+276>>2]=k[h+8>>2];d:do if(j|0){d=k[j>>2]&-65536;if((d|0)>=1111687168){switch(d|0){case 1111687168:break;default:break d}if(!(k[j+16>>2]|0))break;d=k[j+8>>2]|0;if(!d)break;k[d>>2]=(k[d>>2]|0)+1;break}switch(d|0){case 1111621632:break;default:break d}if((((k[j+24>>2]|0)>0?(k[j+20>>2]|0)>0:0)?k[j+16>>2]|0:0)?(s=k[j+8>>2]|0,s|0):0)k[s>>2]=(k[s>>2]|0)+1}while(0);B9(v)}while(0);if(!o){r=y;return x|0}o=N9(k[x+4>>2]|0,v)|0;j=(o|0)>0;if(j){d=0;f=0;do{d=d+1+(k[v+(f<<2)>>2]|0)|0;f=f+1|0}while((f|0)!=(o|0))}else d=0;f=k6(a,b,333963)|0;if(!f){g=t+4|0;h=ZT(32)|0;k[h>>2]=1;l=h+4|0;k[t>>2]=l;k[g>>2]=24;i[h+28>>0]=0;m=334024;n=l+24|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-2,t,333989,333645,3817);k[g>>2]=0;k[t>>2]=0;t=k[h>>2]|0;k[h>>2]=t+-1;if((t|0)==1)ggb(k[h+-4>>2]|0)}n6(a,f,w);if(!q){d=ZT(d+o<<2)|0;g=x+264|0;k[g>>2]=d;if(j?(c=d+(o<<2)|0,k[d>>2]=c,o6(a,w,(k[v>>2]|0)+1|0,c,333970),(o|0)!=1):0){d=v;f=1;do{c=c+((k[d>>2]|0)+1<<2)|0;k[(k[g>>2]|0)+(f<<2)>>2]=c;d=v+(f<<2)|0;o6(a,w,(k[d>>2]|0)+1|0,c,333970);f=f+1|0}while((f|0)!=(o|0))}}else{if(j){d=x+8|0;c=0;do{o6(a,w,2,d+(c<<3)|0,333970);c=c+1|0}while((c|0)!=(o|0))}k[x+264>>2]=0}r=y;return x|0}function wla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;h=r;r=r+128|0;g=h;g6(a,b,6,333622);i=k[c>>2]|0;b=i&1024;f=(b|0)==0;d=i&2048;e=(d|0)==0;p6(a,389384,i&1);p6(a,333931,b>>>10);p6(a,333942,d>>>11);d=c+4|0;b=k[d>>2]|0;if((b|0)!=0?(k[b>>2]&-65536|0)==1111752704:0)w6(a,333958,b,0,0);else w6(a,333954,c+268|0,0,0);if(e){_4(a);r=h;return}e=N9(k[d>>2]|0,g)|0;g6(a,333963,13,0);d=(e|0)>0;if(f){if(d){b=c+264|0;d=0;do{h6(a,k[(k[b>>2]|0)+(d<<2)>>2]|0,(k[g+(d<<2)>>2]|0)+1|0,333970);d=d+1|0}while((d|0)!=(e|0))}}else if(d){b=c+8|0;d=0;do{h6(a,b+(d<<3)|0,2,333970);d=d+1|0}while((d|0)!=(e|0))}_4(a);_4(a);r=h;return}function xla(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;z=r;r=r+400|0;w=z+272|0;x=z+264|0;l=z+136|0;b=z+8|0;y=z;k[y>>2]=0;if(((a|0)!=0?(k[a>>2]&-65536|0)==1111818240:0)?(c=a+4|0,d=k[c>>2]|0,(d|0)!=0):0)f=8;else{c=w+4|0;d=ZT(32)|0;k[d>>2]=1;s=d+4|0;k[w>>2]=s;k[c>>2]=27;i[d+31>>0]=0;t=333716;u=s+27|0;do{i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(u|0));Y8(-5,w,333634,333645,3116);k[c>>2]=0;k[w>>2]=0;v=k[d>>2]|0;k[d>>2]=v+-1;if((v|0)==1)ggb(k[d+-4>>2]|0);c=a+4|0;d=k[c>>2]|0;if(!d){h=0;d=0}else f=8}if((f|0)==8)h=(k[d>>2]&-65536|0)==1111752704;g=N9(d,l)|0;ula(y);f=h&1;if(g>>>0>32){d=w+4|0;e=ZT(44)|0;k[e>>2]=1;s=e+4|0;k[w>>2]=s;k[d>>2]=36;i[e+40>>0]=0;t=333881;u=s+36|0;do{i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(u|0));Y8(-19,w,333918,333645,2662);k[d>>2]=0;k[w>>2]=0;v=k[e>>2]|0;k[e>>2]=v+-1;if((v|0)==1)ggb(k[e+-4>>2]|0)}v=ZT(544)|0;k[v>>2]=f|1111818240;k[v+264>>2]=0;d=v+4|0;k[d>>2]=0;if(h){u=H9(g,l,5)|0;k[d>>2]=u}else{u=D9(v+268|0,g,l,5,0)|0;k[d>>2]=u;z9(u)}k[y>>2]=v;d=k[a>>2]|0;if(!(d&2048)){w=k[c>>2]|0;x=v+4|0;x=k[x>>2]|0;wY(w,x);y=k[y>>2]|0;r=z;return y|0}e=d&1024;do if(!e){b=k[a+264>>2]|0;if(!b){b=x+4|0;d=ZT(24)|0;k[d>>2]=1;s=d+4|0;k[x>>2]=s;k[b>>2]=19;i[d+23>>0]=0;t=333744;u=s+19|0;do{i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(u|0));Y8(-27,x,333764,333645,3181);k[b>>2]=0;k[x>>2]=0;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0);b=0;d=0;e=w;f=26}else{d=0;e=w;f=26}}else{if((g|0)>0)d=0;else{d=e;e=w;f=26;break}do{k[b+(d<<2)>>2]=a+8+(d<<3);d=d+1|0}while((d|0)!=(g|0));if(!v){d=e;g=w;f=28}else{d=e;e=w;f=26}}while(0);if((f|0)==26)if((k[v>>2]&-65536|0)==1111818240?(m=k[v+4>>2]|0,(m|0)!=0):0){h=d;g=e;d=m}else{g=e;f=28}if((f|0)==28){e=x+4|0;f=ZT(32)|0;k[f>>2]=1;s=f+4|0;k[x>>2]=s;k[e>>2]=24;i[f+28>>0]=0;t=333783;u=s+24|0;do{i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(u|0));Y8(-5,x,333764,333645,3184);k[e>>2]=0;k[x>>2]=0;u=k[f>>2]|0;k[f>>2]=u+-1;if((u|0)==1)ggb(k[f+-4>>2]|0);h=d;d=k[v+4>>2]|0}q=N9(d,w)|0;f=(q|0)>0;if(f){d=0;e=0;do{d=d+1+(k[w+(e<<2)>>2]|0)|0;e=e+1|0}while((e|0)!=(q|0))}else d=0;if(!h){p=v+264|0;e=k[p>>2]|0;if(!e){e=ZT(d+q<<2)|0;k[p>>2]=e}if(f){m=x+4|0;n=x+4|0;l=e+(q<<2)|0;a=0;while(1){h=b+(a<<2)|0;if(!(k[h>>2]|0)){d=ZT(40)|0;k[d>>2]=1;s=d+4|0;k[x>>2]=s;k[m>>2]=32;i[d+36>>0]=0;t=333808;u=s+32|0;do{i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(u|0));Y8(-27,x,333764,333645,3219);k[m>>2]=0;k[x>>2]=0;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0)}f=w+(a<<2)|0;d=k[f>>2]|0;if((d|0)>=0){j=-3402823466385288598117041.0e14;e=0;while(1){A=j;j=+o[(k[h>>2]|0)+(e<<2)>>2];if(j<=A){d=ZT(44)|0;k[d>>2]=1;s=d+4|0;k[x>>2]=s;k[n>>2]=39;i[d+43>>0]=0;t=333841;u=s+39|0;do{i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(u|0));Y8(-211,x,333764,333645,3225);k[n>>2]=0;k[x>>2]=0;u=k[d>>2]|0;k[d>>2]=u+-1;if((u|0)==1)ggb(k[d+-4>>2]|0);d=k[f>>2]|0}o[l+(e<<2)>>2]=j;if((e|0)>=(d|0))break;else e=e+1|0}}k[(k[p>>2]|0)+(a<<2)>>2]=l;a=a+1|0;if((a|0)>=(q|0))break;else l=l+(d+1<<2)|0}}k[v>>2]=k[v>>2]&-3073|2048}else{if(f){h=x+4|0;f=0;do{e=b+(f<<2)|0;d=k[e>>2]|0;if(!d){d=ZT(40)|0;k[d>>2]=1;s=d+4|0;k[x>>2]=s;k[h>>2]=32;i[d+36>>0]=0;t=333808;u=s+32|0;do{i[s>>0]=i[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(u|0));Y8(-27,x,333764,333645,3195);k[h>>2]=0;k[x>>2]=0;w=k[d>>2]|0;k[d>>2]=w+-1;if((w|0)==1)ggb(k[d+-4>>2]|0);d=k[e>>2]|0;e=d}else e=d;k[v+8+(f<<3)>>2]=k[e>>2];k[v+8+(f<<3)+4>>2]=k[d+4>>2];f=f+1|0}while((f|0)<(q|0))}k[v>>2]=k[v>>2]|3072}w=k[c>>2]|0;x=v+4|0;x=k[x>>2]|0;wY(w,x);y=k[y>>2]|0;r=z;return y|0}function yla(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0;pa=r;r=r+1424|0;ka=pa;T=pa+400|0;oa=pa+288|0;z=pa+344|0;na=pa+232|0;ia=pa+176|0;ma=pa+160|0;la=pa+148|0;ja=pa+136|0;I=pa+128|0;do if((k[d>>2]&2031616|0)==65536){s=k[d+4>>2]|0;k[oa>>2]=k[s>>2];w=oa+4|0;d=s+4|0;k[w>>2]=k[d>>2];ha=oa+8|0;k[ha>>2]=k[s+8>>2];k[oa+12>>2]=k[s+12>>2];k[oa+16>>2]=k[s+16>>2];k[oa+20>>2]=k[s+20>>2];k[oa+24>>2]=k[s+24>>2];k[oa+28>>2]=k[s+28>>2];k[oa+32>>2]=k[s+32>>2];n=k[s+36>>2]|0;k[oa+36>>2]=n;q=oa+40|0;k[q>>2]=ha;ha=oa+48|0;u=oa+44|0;k[u>>2]=ha;k[oa+52>>2]=0;k[ha>>2]=0;if(n|0){ha=n+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[d>>2]|0)<3){ga=k[s+44>>2]|0;ha=k[u>>2]|0;k[ha>>2]=k[ga>>2];k[ha+4>>2]=k[ga+4>>2];break}k[w>>2]=0;x1(oa,k[d>>2]|0,0,0,0);if((k[w>>2]|0)>0){v=k[s+40>>2]|0;t=k[q>>2]|0;q=k[s+44>>2]|0;n=k[u>>2]|0;d=0;do{k[t+(d<<2)>>2]=k[v+(d<<2)>>2];k[n+(d<<2)>>2]=k[q+(d<<2)>>2];d=d+1|0}while((d|0)<(k[w>>2]|0))}}else Q1(oa,d,-1);while(0);M=(f|0)>0;if(!(M&(g|0)!=0)){k[ka>>2]=0;d=ka+4|0;k[d>>2]=0;n=ZT(28)|0;k[n>>2]=1;q=n+4|0;k[ka>>2]=q;k[d>>2]=20;i[n+24>>0]=0;s=334063;t=q+20|0;do{i[q>>0]=i[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(t|0));Y8(-215,ka,334084,333645,1323);k[d>>2]=0;k[ka>>2]=0;ha=k[n>>2]|0;k[n>>2]=ha+-1;if((ha|0)==1)ggb(k[n+-4>>2]|0)}do if((k[e>>2]&2031616|0)==65536){s=k[e+4>>2]|0;k[z>>2]=k[s>>2];v=z+4|0;d=s+4|0;k[v>>2]=k[d>>2];ha=z+8|0;k[ha>>2]=k[s+8>>2];k[z+12>>2]=k[s+12>>2];y=z+16|0;k[y>>2]=k[s+16>>2];k[z+20>>2]=k[s+20>>2];k[z+24>>2]=k[s+24>>2];k[z+28>>2]=k[s+28>>2];k[z+32>>2]=k[s+32>>2];x=z+36|0;n=k[s+36>>2]|0;k[x>>2]=n;q=z+40|0;k[q>>2]=ha;ha=z+48|0;w=z+44|0;k[w>>2]=ha;k[z+52>>2]=0;k[ha>>2]=0;if(n|0){ha=n+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[d>>2]|0)<3){t=k[s+44>>2]|0;s=k[w>>2]|0;k[s>>2]=k[t>>2];k[s+4>>2]=k[t+4>>2];s=x;t=y;break}k[v>>2]=0;x1(z,k[d>>2]|0,0,0,0);if((k[v>>2]|0)>0){u=k[s+40>>2]|0;t=k[q>>2]|0;n=k[s+44>>2]|0;q=k[w>>2]|0;d=0;do{k[t+(d<<2)>>2]=k[u+(d<<2)>>2];k[q+(d<<2)>>2]=k[n+(d<<2)>>2];d=d+1|0}while((d|0)<(k[v>>2]|0));s=x;t=y}else{s=x;t=y}}else{Q1(z,e,-1);w=z+44|0;s=z+36|0;t=z+16|0}while(0);F=k[t>>2]|0;d=k[s>>2]|0;if(d|0?(ga=d+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){q=z+36|0;n=k[q>>2]|0;if(n|0){d=k[n+4>>2]|0;if(!d){d=k[z+32>>2]|0;if(!d){d=B1()|0;n=k[q>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,n)}k[q>>2]=0}k[s>>2]=0;q=z+4|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[q>>2]|0)>0){n=k[z+40>>2]|0;d=0;do{k[n+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[q>>2]|0))}d=k[w>>2]|0;if(!((d|0)==(z+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);P1(e,f,g,5,-1,0,0);do if((k[e>>2]&2031616|0)==65536){s=k[e+4>>2]|0;k[na>>2]=k[s>>2];w=na+4|0;d=s+4|0;k[w>>2]=k[d>>2];x=na+8|0;k[x>>2]=k[s+8>>2];y=na+12|0;k[y>>2]=k[s+12>>2];z=na+16|0;k[z>>2]=k[s+16>>2];e=na+20|0;k[e>>2]=k[s+20>>2];g=na+24|0;k[g>>2]=k[s+24>>2];C=na+28|0;k[C>>2]=k[s+28>>2];D=na+32|0;k[D>>2]=k[s+32>>2];E=na+36|0;n=k[s+36>>2]|0;k[E>>2]=n;q=na+40|0;k[q>>2]=x;ha=na+48|0;u=na+44|0;k[u>>2]=ha;k[na+52>>2]=0;k[ha>>2]=0;if(n|0){ha=n+12|0;k[ha>>2]=(k[ha>>2]|0)+1}if((k[d>>2]|0)<3){ha=k[s+44>>2]|0;d=k[u>>2]|0;k[d>>2]=k[ha>>2];k[d+4>>2]=k[ha+4>>2];d=na;ha=w;v=y;ga=z;w=z;u=e;t=g;n=C;q=D;fa=E;s=E;break}k[w>>2]=0;x1(na,k[d>>2]|0,0,0,0);if((k[w>>2]|0)>0){v=k[s+40>>2]|0;t=k[q>>2]|0;q=k[s+44>>2]|0;n=k[u>>2]|0;d=0;do{k[t+(d<<2)>>2]=k[v+(d<<2)>>2];k[n+(d<<2)>>2]=k[q+(d<<2)>>2];d=d+1|0}while((d|0)<(k[w>>2]|0));d=na;ha=w;v=y;ga=z;w=z;u=e;t=g;n=C;q=D;fa=E;s=E}else{d=na;ha=w;v=y;ga=z;w=z;u=e;t=g;n=C;q=D;fa=E;s=E}}else{Q1(na,e,-1);w=na+16|0;s=na+36|0;d=na;ha=na+4|0;x=na+8|0;v=na+12|0;ga=w;u=na+20|0;t=na+24|0;n=na+28|0;q=na+32|0;fa=s}while(0);k[ia>>2]=k[d>>2];da=ia+4|0;d=k[ha>>2]|0;k[da>>2]=d;ba=ia+8|0;k[ba>>2]=k[x>>2];k[ia+12>>2]=k[v>>2];ca=ia+16|0;k[ca>>2]=k[w>>2];k[ia+20>>2]=k[u>>2];k[ia+24>>2]=k[t>>2];k[ia+28>>2]=k[n>>2];Y=ia+32|0;k[Y>>2]=k[q>>2];_=ia+36|0;n=k[s>>2]|0;k[_>>2]=n;Z=ia+40|0;k[Z>>2]=ba;ba=ia+48|0;$=ia+44|0;k[$>>2]=ba;k[ia+52>>2]=0;k[ba>>2]=0;if(n){d=n+12|0;k[d>>2]=(k[d>>2]|0)+1;d=k[ha>>2]|0}if((d|0)>=3){k[da>>2]=0;x1(ia,k[na+4>>2]|0,0,0,0);if((k[da>>2]|0)>0){n=k[na+40>>2]|0;q=k[Z>>2]|0;s=k[na+44>>2]|0;t=k[$>>2]|0;d=0;do{k[q+(d<<2)>>2]=k[n+(d<<2)>>2];k[t+(d<<2)>>2]=k[s+(d<<2)>>2];d=d+1|0}while((d|0)<(k[da>>2]|0))}}else{X=k[na+44>>2]|0;ea=k[$>>2]|0;k[ea>>2]=k[X>>2];k[ea+4>>2]=k[X+4>>2]}k[ia>>2]=k[ia>>2]&-4096|4;if((F|0)==(k[ga>>2]|0)&j){ea=ka+4|0;X=ea+4|0;k[X>>2]=0;k[X+4>>2]=0;k[ka>>2]=33619968;k[ea>>2]=ia;SW(na,ka,4,1.0,0.0)}else{k[ka>>2]=0;k[ka+4>>2]=0;k[ka+8>>2]=0;k[ka+12>>2]=0;k[ka+16>>2]=0;k[ka+20>>2]=0;k[ka+24>>2]=0;k[ka+28>>2]=0;oY(na,ka)}k[ma>>2]=0;W=ma+4|0;k[W>>2]=0;k[ma+8>>2]=0;k[la>>2]=0;V=la+4|0;k[V>>2]=0;k[la+8>>2]=0;k[ja>>2]=0;U=ja+4|0;k[U>>2]=0;k[ja+8>>2]=0;k[I>>2]=0;u=I+4|0;k[u>>2]=0;ea=oa+16|0;if(k[ea>>2]|0){q=k[oa+4>>2]|0;if((q|0)<3)d=aa(k[oa+12>>2]|0,k[oa+8>>2]|0)|0;else{s=k[oa+40>>2]|0;n=0;d=1;do{d=aa(k[s+(n<<2)>>2]|0,d)|0;n=n+1|0}while((n|0)!=(q|0))}if(d|0?k[oa>>2]&4095|0:0){k[ka>>2]=0;d=ka+4|0;k[d>>2]=0;n=ZT(44)|0;k[n>>2]=1;q=n+4|0;k[ka>>2]=q;k[d>>2]=38;i[n+42>>0]=0;s=334093;t=q+38|0;do{i[q>>0]=i[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(t|0));Y8(-215,ka,334084,333645,1340);k[d>>2]=0;k[ka>>2]=0;X=k[n>>2]|0;k[n>>2]=X+-1;if((X|0)==1)ggb(k[n+-4>>2]|0)}}X=na+40|0;zla(a,b,c,oa,f,k[X>>2]|0,h,ma,la,I,ja);g=k[ja>>2]|0;switch(k[a>>2]&7){case 0:{a=k[I>>2]|0;t=k[u>>2]|0;c=k[ma>>2]|0;z=k[la>>2]|0;J=k[ca>>2]|0;u=k[c+(f<<2)>>2]|0;h=k[z+((f<<1|1)<<2)>>2]|0;k[ka>>2]=0;K=ka+4|0;k[K>>2]=0;k[ka+8>>2]=0;k[T>>2]=1123876864;k[T+4>>2]=0;Ala(ia,T,f,g,ka);I=k[ka>>2]|0;switch(f|0){case 1:{D=k[z>>2]|0;C=k[z+4>>2]|0;zpb(T|0,0,1024)|0;a:do if(!t)d=0;else{d=k[c>>2]|0;y=(D|0)==1;z=D<<1;e=(a|0)<4;g=a+-4|0;if((a|0)<=0){v=a&-4;w=aa(D,v)|0;while(1){t=t+-1|0;do if(!u){do if(y){if(e){n=0;break}else{q=0;n=d}while(1){f=l[d+(q|1)>>0]|0;n=T+(l[n>>0]<<2)|0;k[n>>2]=(k[n>>2]|0)+1;n=T+(f<<2)|0;k[n>>2]=(k[n>>2]|0)+1;n=l[d+(q|3)>>0]|0;f=T+(l[d+(q|2)>>0]<<2)|0;k[f>>2]=(k[f>>2]|0)+1;n=T+(n<<2)|0;k[n>>2]=(k[n>>2]|0)+1;n=q+4|0;if((n|0)>(g|0))break;else{q=n;n=d+n|0}}n=v;d=d+v|0}else{if(e){n=0;break}else{n=d;q=0}while(1){f=l[n+D>>0]|0;S=T+(l[n>>0]<<2)|0;k[S>>2]=(k[S>>2]|0)+1;f=T+(f<<2)|0;k[f>>2]=(k[f>>2]|0)+1;n=n+z|0;f=l[n+D>>0]|0;S=T+(l[n>>0]<<2)|0;k[S>>2]=(k[S>>2]|0)+1;f=T+(f<<2)|0;k[f>>2]=(k[f>>2]|0)+1;q=q+4|0;if((q|0)>(g|0))break;else n=n+z|0}n=v;d=d+w|0}while(0);if((a|0)<=(n|0))break;s=a-n|0;q=d;while(1){f=T+(l[q>>0]<<2)|0;k[f>>2]=(k[f>>2]|0)+1;n=n+1|0;if((n|0)==(a|0))break;else q=q+D|0}d=d+(aa(D,s)|0)|0}while(0);if(!t){d=0;break a}else{u=u+h|0;d=d+C|0}}}v=aa(D,a)|0;w=a&-4;x=aa(D,w)|0;while(1){t=t+-1|0;do if(!u){do if(y){if(e){n=0;break}else{q=0;n=d}while(1){f=l[d+(q|1)>>0]|0;n=T+(l[n>>0]<<2)|0;k[n>>2]=(k[n>>2]|0)+1;n=T+(f<<2)|0;k[n>>2]=(k[n>>2]|0)+1;n=l[d+(q|3)>>0]|0;f=T+(l[d+(q|2)>>0]<<2)|0;k[f>>2]=(k[f>>2]|0)+1;n=T+(n<<2)|0;k[n>>2]=(k[n>>2]|0)+1;n=q+4|0;if((n|0)>(g|0))break;else{q=n;n=d+n|0}}n=w;d=d+w|0}else{if(e){n=0;break}else{n=d;q=0}while(1){f=l[n+D>>0]|0;S=T+(l[n>>0]<<2)|0;k[S>>2]=(k[S>>2]|0)+1;f=T+(f<<2)|0;k[f>>2]=(k[f>>2]|0)+1;n=n+z|0;f=l[n+D>>0]|0;S=T+(l[n>>0]<<2)|0;k[S>>2]=(k[S>>2]|0)+1;f=T+(f<<2)|0;k[f>>2]=(k[f>>2]|0)+1;q=q+4|0;if((q|0)>(g|0))break;else n=n+z|0}n=w;d=d+x|0}while(0);if((a|0)<=(n|0))break;s=a-n|0;q=d;while(1){f=T+(l[q>>0]<<2)|0;k[f>>2]=(k[f>>2]|0)+1;n=n+1|0;if((n|0)==(a|0))break;else q=q+D|0}d=d+(aa(D,s)|0)|0}else{n=d;q=0;while(1){if(i[u+q>>0]|0){f=T+(l[n>>0]<<2)|0;k[f>>2]=(k[f>>2]|0)+1}q=q+1|0;if((q|0)==(a|0))break;else n=n+D|0}d=d+v|0}while(0);if(!t){d=0;break}else{u=u+h|0;d=d+C|0}}}while(0);do{n=k[I+(d<<2)>>2]|0;if(n>>>0<1073741824){f=J+n|0;k[f>>2]=(k[f>>2]|0)+(k[T+(d<<2)>>2]|0)}d=d+1|0}while((d|0)!=256);L=158;break}case 2:{e=k[z>>2]|0;g=k[z+4>>2]|0;C=k[z+8>>2]|0;x=k[z+12>>2]|0;if((t|0)!=0&(a|0)>0){z=a+-1|0;y=aa(e,z)|0;z=aa(C,z)|0;w=k[c>>2]|0;v=k[c+4>>2]|0;while(1){t=t+-1|0;if(!u){d=w;n=v;q=0;while(1){s=(k[I+((l[n>>0]|256)<<2)>>2]|0)+(k[I+(l[d>>0]<<2)>>2]|0)|0;if(s>>>0<1073741824){T=J+s|0;k[T>>2]=(k[T>>2]|0)+1}q=q+1|0;if((q|0)==(a|0))break;else{d=d+e|0;n=n+C|0}}}else{d=w;n=v;q=0;while(1){do if(i[u+q>>0]|0){s=(k[I+((l[n>>0]|256)<<2)>>2]|0)+(k[I+(l[d>>0]<<2)>>2]|0)|0;if(s>>>0>=1073741824)break;T=J+s|0;k[T>>2]=(k[T>>2]|0)+1}while(0);q=q+1|0;if((q|0)==(a|0))break;else{d=d+e|0;n=n+C|0}}}if(!t){L=157;break}else{w=w+y+e+g|0;v=v+z+C+x|0;u=u+h|0}}}else L=157;break}case 3:{D=k[z>>2]|0;E=k[z+4>>2]|0;F=k[z+8>>2]|0;j=k[z+12>>2]|0;b=k[z+16>>2]|0;z=k[z+20>>2]|0;if((t|0)!=0&(a|0)>0){C=a+-1|0;e=aa(b,C)|0;g=aa(F,C)|0;C=aa(D,C)|0;x=k[c+8>>2]|0;y=k[c+4>>2]|0;w=k[c>>2]|0;while(1){t=t+-1|0;if(!u){d=x;n=y;q=w;s=0;while(1){v=(k[I+((l[n>>0]|256)<<2)>>2]|0)+(k[I+(l[q>>0]<<2)>>2]|0)+(k[I+((l[d>>0]|512)<<2)>>2]|0)|0;if(v>>>0<1073741824){T=J+v|0;k[T>>2]=(k[T>>2]|0)+1}s=s+1|0;if((s|0)==(a|0))break;else{d=d+b|0;n=n+F|0;q=q+D|0}}}else{d=x;n=y;q=w;s=0;while(1){do if(i[u+s>>0]|0){v=(k[I+((l[n>>0]|256)<<2)>>2]|0)+(k[I+(l[q>>0]<<2)>>2]|0)+(k[I+((l[d>>0]|512)<<2)>>2]|0)|0;if(v>>>0>=1073741824)break;T=J+v|0;k[T>>2]=(k[T>>2]|0)+1}while(0);s=s+1|0;if((s|0)==(a|0))break;else{d=d+b|0;n=n+F|0;q=q+D|0}}}if(!t){L=157;break}else{x=x+e+b+z|0;y=y+g+F+j|0;w=w+C+D+E|0;u=u+h|0}}}else L=157;break}default:if(!t)L=157;else{x=(f|0)==0;y=(a|0)>0;w=t;while(1){w=w+-1|0;do if(!u)if(y){if(M)v=0;else{if(!x)break;k[J>>2]=a+(k[J>>2]|0);break}do{d=0;n=J;do{s=c+(d<<2)|0;t=k[s>>2]|0;q=k[I+((l[t>>0]|d<<8)<<2)>>2]|0;if(q>>>0>1073741823)break;n=n+q|0;k[s>>2]=t+(k[z+(d<<1<<2)>>2]|0);d=d+1|0}while((d|0)<(f|0));do if((d|0)==(f|0))k[n>>2]=(k[n>>2]|0)+1;else{if((d|0)>=(f|0))break;do{T=c+(d<<2)|0;k[T>>2]=(k[T>>2]|0)+(k[z+(d<<1<<2)>>2]|0);d=d+1|0}while((d|0)!=(f|0))}while(0);v=v+1|0}while((v|0)!=(a|0));L=154}else L=154;else if(y){if(M)v=0;else{if(!x)break;k[J>>2]=a+(k[J>>2]|0);break}while(1){b:do if(!(i[u+v>>0]|0)){d=0;n=J}else{d=0;n=J;do{s=c+(d<<2)|0;t=k[s>>2]|0;q=k[I+((l[t>>0]|d<<8)<<2)>>2]|0;if(q>>>0>1073741823)break b;n=n+q|0;k[s>>2]=t+(k[z+(d<<1<<2)>>2]|0);d=d+1|0}while((d|0)<(f|0))}while(0);do if((d|0)==(f|0))k[n>>2]=(k[n>>2]|0)+1;else{if((d|0)>=(f|0))break;do{T=c+(d<<2)|0;k[T>>2]=(k[T>>2]|0)+(k[z+(d<<1<<2)>>2]|0);d=d+1|0}while((d|0)!=(f|0))}while(0);v=v+1|0;if((v|0)==(a|0)){L=154;break}}}else L=154;while(0);if((L|0)==154?(L=0,M):0){d=0;do{T=c+(d<<2)|0;k[T>>2]=(k[T>>2]|0)+(k[z+((d<<1|1)<<2)>>2]|0);d=d+1|0}while((d|0)!=(f|0))}if(!w){L=157;break}else u=u+h|0}}}if((L|0)==157?I|0:0)L=158;if((L|0)==158){d=k[K>>2]|0;if((d|0)!=(I|0))k[K>>2]=d+(~((d+-4-I|0)>>>2)<<2);ggb(I)}break}case 2:{S=k[I>>2]|0;s=k[u>>2]|0;P=k[ma>>2]|0;e=k[la>>2]|0;Q=k[ca>>2]|0;u=k[P+(f<<2)>>2]|0;R=k[e+((f<<1|1)<<2)>>2]|0;if(M){J=k[$>>2]|0;K=f<<2;upb(ka|0,k[Z>>2]|0,K|0)|0;upb(T|0,J|0,K|0)|0}switch(f|0){case 1:{B=+p[g>>3];A=+p[g+8>>3];x=k[ka>>2]|0;y=k[e>>2]|0;v=k[e+4>>2]|0;if(s|0?(S|0)>0:0){w=aa(y,S+-1|0)|0;t=k[P>>2]|0;while(1){s=s+-1|0;if(!u){d=0;n=t;while(1){O=A+B*+(m[n>>1]|0);T=~~O;T=T-(+(T|0)>O&1)|0;q=Q+(T<<2)|0;if(T>>>0<x>>>0)k[q>>2]=(k[q>>2]|0)+1;d=d+1|0;if((d|0)==(S|0))break;else n=n+(y<<1)|0}}else{d=0;n=t;while(1){do if(i[u+d>>0]|0){O=A+B*+(m[n>>1]|0);T=~~O;T=T-(+(T|0)>O&1)|0;q=Q+(T<<2)|0;if(T>>>0>=x>>>0)break;k[q>>2]=(k[q>>2]|0)+1}while(0);d=d+1|0;if((d|0)==(S|0))break;else n=n+(y<<1)|0}}if(!s)break;else{u=u+R|0;t=t+(w<<1)+(y<<1)+(v<<1)|0}}}break}case 2:{B=+p[g>>3];G=+p[g+8>>3];H=+p[g+16>>3];A=+p[g+24>>3];C=k[ka>>2]|0;D=k[ka+4>>2]|0;E=k[e>>2]|0;F=k[e+4>>2]|0;j=k[e+8>>2]|0;g=k[e+12>>2]|0;y=k[T>>2]|0;if((s|0)!=0&(S|0)>0){e=S+-1|0;z=aa(E,e)|0;e=aa(j,e)|0;x=k[P>>2]|0;w=k[P+4>>2]|0;while(1){s=s+-1|0;if(!u){d=x;n=w;q=0;while(1){O=G+B*+(m[d>>1]|0);t=~~O;t=t-(+(t|0)>O&1)|0;O=A+H*+(m[n>>1]|0);v=~~O;v=v-(+(v|0)>O&1)|0;if(t>>>0<C>>>0&v>>>0<D>>>0){T=Q+(aa(t,y)|0)+(v<<2)|0;k[T>>2]=(k[T>>2]|0)+1}q=q+1|0;if((q|0)==(S|0))break;else{d=d+(E<<1)|0;n=n+(j<<1)|0}}}else{d=x;n=w;q=0;while(1){do if(i[u+q>>0]|0){O=G+B*+(m[d>>1]|0);t=~~O;t=t-(+(t|0)>O&1)|0;O=A+H*+(m[n>>1]|0);v=~~O;v=v-(+(v|0)>O&1)|0;if(!(t>>>0<C>>>0&v>>>0<D>>>0))break;T=Q+(aa(t,y)|0)+(v<<2)|0;k[T>>2]=(k[T>>2]|0)+1}while(0);q=q+1|0;if((q|0)==(S|0))break;else{d=d+(E<<1)|0;n=n+(j<<1)|0}}}if(!s)break;else{x=x+(z<<1)+(E<<1)+(F<<1)|0;w=w+(e<<1)+(j<<1)+(g<<1)|0;u=u+R|0}}}break}case 3:{B=+p[g>>3];G=+p[g+8>>3];H=+p[g+16>>3];N=+p[g+24>>3];O=+p[g+32>>3];A=+p[g+40>>3];c=k[ka>>2]|0;h=k[ka+4>>2]|0;a=k[ka+8>>2]|0;I=k[e>>2]|0;J=k[e+4>>2]|0;K=k[e+8>>2]|0;L=k[e+12>>2]|0;M=k[e+16>>2]|0;j=k[e+20>>2]|0;b=k[T>>2]|0;g=k[T+4>>2]|0;if(s|0){C=(S|0)>0;D=aa(S,I)|0;E=aa(S,K)|0;F=aa(S,M)|0;d=k[P>>2]|0;n=k[P+4>>2]|0;q=k[P+8>>2]|0;while(1){s=s+-1|0;if(!u){if(C){t=d;v=n;w=q;x=0;while(1){qa=G+B*+(m[t>>1]|0);y=~~qa;y=y-(+(y|0)>qa&1)|0;qa=N+H*+(m[v>>1]|0);z=~~qa;z=z-(+(z|0)>qa&1)|0;qa=A+O*+(m[w>>1]|0);e=~~qa;e=e-(+(e|0)>qa&1)|0;if(y>>>0<c>>>0&z>>>0<h>>>0&e>>>0<a>>>0){T=Q+(aa(y,b)|0)+(aa(z,g)|0)+(e<<2)|0;k[T>>2]=(k[T>>2]|0)+1}x=x+1|0;if((x|0)==(S|0))break;else{t=t+(I<<1)|0;v=v+(K<<1)|0;w=w+(M<<1)|0}}d=d+(D<<1)|0;n=n+(E<<1)|0;q=q+(F<<1)|0}}else if(C){t=d;v=n;w=q;x=0;while(1){do if(i[u+x>>0]|0){qa=G+B*+(m[t>>1]|0);y=~~qa;y=y-(+(y|0)>qa&1)|0;qa=N+H*+(m[v>>1]|0);z=~~qa;z=z-(+(z|0)>qa&1)|0;qa=A+O*+(m[w>>1]|0);e=~~qa;e=e-(+(e|0)>qa&1)|0;if(!(y>>>0<c>>>0&z>>>0<h>>>0&e>>>0<a>>>0))break;T=Q+(aa(y,b)|0)+(aa(z,g)|0)+(e<<2)|0;k[T>>2]=(k[T>>2]|0)+1}while(0);x=x+1|0;if((x|0)==(S|0))break;else{t=t+(I<<1)|0;v=v+(K<<1)|0;w=w+(M<<1)|0}}d=d+(D<<1)|0;n=n+(E<<1)|0;q=q+(F<<1)|0}if(!s)break;else{d=d+(J<<1)|0;n=n+(L<<1)|0;q=q+(j<<1)|0;u=u+R|0}}}break}default:if(s|0){y=(f|0)==0;z=(S|0)>0;while(1){s=s+-1|0;do if(!u)if(z){if(M)x=0;else{if(!y)break;k[Q>>2]=S+(k[Q>>2]|0);break}do{n=Q;d=0;do{q=P+(d<<2)|0;t=k[q>>2]|0;v=d<<1;qa=+(m[t>>1]|0)*+p[g+(v<<3)>>3]+ +p[g+((v|1)<<3)>>3];w=~~qa;w=w-(+(w|0)>qa&1)|0;if(w>>>0>=(k[ka+(d<<2)>>2]|0)>>>0)break;k[q>>2]=t+(k[e+(v<<2)>>2]<<1);n=n+(aa(k[T+(d<<2)>>2]|0,w)|0)|0;d=d+1|0}while((d|0)<(f|0));do if((d|0)==(f|0))k[n>>2]=(k[n>>2]|0)+1;else{if((d|0)>=(f|0))break;do{L=P+(d<<2)|0;k[L>>2]=(k[L>>2]|0)+(k[e+(d<<1<<2)>>2]<<1);d=d+1|0}while((d|0)!=(f|0))}while(0);x=x+1|0}while((x|0)!=(S|0));L=230}else L=230;else if(z){if(M)x=0;else{if(!y)break;k[Q>>2]=S+(k[Q>>2]|0);break}while(1){c:do if(!(i[u+x>>0]|0)){n=Q;d=0}else{n=Q;d=0;do{q=P+(d<<2)|0;t=k[q>>2]|0;v=d<<1;qa=+(m[t>>1]|0)*+p[g+(v<<3)>>3]+ +p[g+((v|1)<<3)>>3];w=~~qa;w=w-(+(w|0)>qa&1)|0;if(w>>>0>=(k[ka+(d<<2)>>2]|0)>>>0)break c;k[q>>2]=t+(k[e+(v<<2)>>2]<<1);n=n+(aa(k[T+(d<<2)>>2]|0,w)|0)|0;d=d+1|0}while((d|0)<(f|0))}while(0);do if((d|0)==(f|0))k[n>>2]=(k[n>>2]|0)+1;else{if((d|0)>=(f|0))break;do{L=P+(d<<2)|0;k[L>>2]=(k[L>>2]|0)+(k[e+(d<<1<<2)>>2]<<1);d=d+1|0}while((d|0)!=(f|0))}while(0);x=x+1|0;if((x|0)==(S|0)){L=230;break}}}else L=230;while(0);if((L|0)==230?(L=0,M):0){d=0;do{K=P+(d<<2)|0;k[K>>2]=(k[K>>2]|0)+(k[e+((d<<1|1)<<2)>>2]<<1);d=d+1|0}while((d|0)!=(f|0))}if(!s)break;else u=u+R|0}}}break}case 5:{S=k[I>>2]|0;s=k[u>>2]|0;P=k[ma>>2]|0;e=k[la>>2]|0;Q=k[ca>>2]|0;u=k[P+(f<<2)>>2]|0;R=k[e+((f<<1|1)<<2)>>2]|0;if(M){J=k[$>>2]|0;K=f<<2;upb(ka|0,k[Z>>2]|0,K|0)|0;upb(T|0,J|0,K|0)|0}switch(f|0){case 1:{B=+p[g>>3];A=+p[g+8>>3];x=k[ka>>2]|0;y=k[e>>2]|0;v=k[e+4>>2]|0;if(s|0?(S|0)>0:0){w=aa(y,S+-1|0)|0;t=k[P>>2]|0;while(1){s=s+-1|0;if(!u){d=0;n=t;while(1){qa=A+B*+o[n>>2];T=~~qa;T=T-(+(T|0)>qa&1)|0;q=Q+(T<<2)|0;if(T>>>0<x>>>0)k[q>>2]=(k[q>>2]|0)+1;d=d+1|0;if((d|0)==(S|0))break;else n=n+(y<<2)|0}}else{d=0;n=t;while(1){do if(i[u+d>>0]|0){qa=A+B*+o[n>>2];T=~~qa;T=T-(+(T|0)>qa&1)|0;q=Q+(T<<2)|0;if(T>>>0>=x>>>0)break;k[q>>2]=(k[q>>2]|0)+1}while(0);d=d+1|0;if((d|0)==(S|0))break;else n=n+(y<<2)|0}}if(!s)break;else{u=u+R|0;t=t+(w<<2)+(y<<2)+(v<<2)|0}}}break}case 2:{B=+p[g>>3];G=+p[g+8>>3];H=+p[g+16>>3];A=+p[g+24>>3];C=k[ka>>2]|0;D=k[ka+4>>2]|0;E=k[e>>2]|0;F=k[e+4>>2]|0;j=k[e+8>>2]|0;g=k[e+12>>2]|0;y=k[T>>2]|0;if((s|0)!=0&(S|0)>0){e=S+-1|0;z=aa(E,e)|0;e=aa(j,e)|0;x=k[P>>2]|0;w=k[P+4>>2]|0;while(1){s=s+-1|0;if(!u){d=x;n=w;q=0;while(1){qa=G+B*+o[d>>2];t=~~qa;t=t-(+(t|0)>qa&1)|0;qa=A+H*+o[n>>2];v=~~qa;v=v-(+(v|0)>qa&1)|0;if(t>>>0<C>>>0&v>>>0<D>>>0){T=Q+(aa(t,y)|0)+(v<<2)|0;k[T>>2]=(k[T>>2]|0)+1}q=q+1|0;if((q|0)==(S|0))break;else{d=d+(E<<2)|0;n=n+(j<<2)|0}}}else{d=x;n=w;q=0;while(1){do if(i[u+q>>0]|0){qa=G+B*+o[d>>2];t=~~qa;t=t-(+(t|0)>qa&1)|0;qa=A+H*+o[n>>2];v=~~qa;v=v-(+(v|0)>qa&1)|0;if(!(t>>>0<C>>>0&v>>>0<D>>>0))break;T=Q+(aa(t,y)|0)+(v<<2)|0;k[T>>2]=(k[T>>2]|0)+1}while(0);q=q+1|0;if((q|0)==(S|0))break;else{d=d+(E<<2)|0;n=n+(j<<2)|0}}}if(!s)break;else{x=x+(z<<2)+(E<<2)+(F<<2)|0;w=w+(e<<2)+(j<<2)+(g<<2)|0;u=u+R|0}}}break}case 3:{B=+p[g>>3];G=+p[g+8>>3];H=+p[g+16>>3];N=+p[g+24>>3];O=+p[g+32>>3];A=+p[g+40>>3];c=k[ka>>2]|0;h=k[ka+4>>2]|0;a=k[ka+8>>2]|0;I=k[e>>2]|0;J=k[e+4>>2]|0;K=k[e+8>>2]|0;L=k[e+12>>2]|0;M=k[e+16>>2]|0;j=k[e+20>>2]|0;b=k[T>>2]|0;g=k[T+4>>2]|0;if(s|0){C=(S|0)>0;D=aa(S,I)|0;E=aa(S,K)|0;F=aa(S,M)|0;d=k[P>>2]|0;n=k[P+4>>2]|0;q=k[P+8>>2]|0;while(1){s=s+-1|0;if(!u){if(C){t=d;v=n;w=q;x=0;while(1){qa=G+B*+o[t>>2];y=~~qa;y=y-(+(y|0)>qa&1)|0;qa=N+H*+o[v>>2];z=~~qa;z=z-(+(z|0)>qa&1)|0;qa=A+O*+o[w>>2];e=~~qa;e=e-(+(e|0)>qa&1)|0;if(y>>>0<c>>>0&z>>>0<h>>>0&e>>>0<a>>>0){T=Q+(aa(y,b)|0)+(aa(z,g)|0)+(e<<2)|0;k[T>>2]=(k[T>>2]|0)+1}x=x+1|0;if((x|0)==(S|0))break;else{t=t+(I<<2)|0;v=v+(K<<2)|0;w=w+(M<<2)|0}}d=d+(D<<2)|0;n=n+(E<<2)|0;q=q+(F<<2)|0}}else if(C){t=d;v=n;w=q;x=0;while(1){do if(i[u+x>>0]|0){qa=G+B*+o[t>>2];y=~~qa;y=y-(+(y|0)>qa&1)|0;qa=N+H*+o[v>>2];z=~~qa;z=z-(+(z|0)>qa&1)|0;qa=A+O*+o[w>>2];e=~~qa;e=e-(+(e|0)>qa&1)|0;if(!(y>>>0<c>>>0&z>>>0<h>>>0&e>>>0<a>>>0))break;T=Q+(aa(y,b)|0)+(aa(z,g)|0)+(e<<2)|0;k[T>>2]=(k[T>>2]|0)+1}while(0);x=x+1|0;if((x|0)==(S|0))break;else{t=t+(I<<2)|0;v=v+(K<<2)|0;w=w+(M<<2)|0}}d=d+(D<<2)|0;n=n+(E<<2)|0;q=q+(F<<2)|0}if(!s)break;else{d=d+(J<<2)|0;n=n+(L<<2)|0;q=q+(j<<2)|0;u=u+R|0}}}break}default:if(s|0){y=(f|0)==0;z=(S|0)>0;while(1){s=s+-1|0;do if(!u)if(z){if(M)x=0;else{if(!y)break;k[Q>>2]=S+(k[Q>>2]|0);break}do{n=Q;d=0;do{q=P+(d<<2)|0;t=k[q>>2]|0;v=d<<1;qa=+o[t>>2]*+p[g+(v<<3)>>3]+ +p[g+((v|1)<<3)>>3];w=~~qa;w=w-(+(w|0)>qa&1)|0;if(w>>>0>=(k[ka+(d<<2)>>2]|0)>>>0)break;k[q>>2]=t+(k[e+(v<<2)>>2]<<2);n=n+(aa(k[T+(d<<2)>>2]|0,w)|0)|0;d=d+1|0}while((d|0)<(f|0));do if((d|0)==(f|0))k[n>>2]=(k[n>>2]|0)+1;else{if((d|0)>=(f|0))break;do{L=P+(d<<2)|0;k[L>>2]=(k[L>>2]|0)+(k[e+(d<<1<<2)>>2]<<2);d=d+1|0}while((d|0)!=(f|0))}while(0);x=x+1|0}while((x|0)!=(S|0));L=302}else L=302;else if(z){if(M)x=0;else{if(!y)break;k[Q>>2]=S+(k[Q>>2]|0);break}while(1){d:do if(!(i[u+x>>0]|0)){n=Q;d=0}else{n=Q;d=0;do{q=P+(d<<2)|0;t=k[q>>2]|0;v=d<<1;qa=+o[t>>2]*+p[g+(v<<3)>>3]+ +p[g+((v|1)<<3)>>3];w=~~qa;w=w-(+(w|0)>qa&1)|0;if(w>>>0>=(k[ka+(d<<2)>>2]|0)>>>0)break d;k[q>>2]=t+(k[e+(v<<2)>>2]<<2);n=n+(aa(k[T+(d<<2)>>2]|0,w)|0)|0;d=d+1|0}while((d|0)<(f|0))}while(0);do if((d|0)==(f|0))k[n>>2]=(k[n>>2]|0)+1;else{if((d|0)>=(f|0))break;do{L=P+(d<<2)|0;k[L>>2]=(k[L>>2]|0)+(k[e+(d<<1<<2)>>2]<<2);d=d+1|0}while((d|0)!=(f|0))}while(0);x=x+1|0;if((x|0)==(S|0)){L=302;break}}}else L=302;while(0);if((L|0)==302?(L=0,M):0){d=0;do{K=P+(d<<2)|0;k[K>>2]=(k[K>>2]|0)+(k[e+((d<<1|1)<<2)>>2]<<2);d=d+1|0}while((d|0)!=(f|0))}if(!s)break;else u=u+R|0}}}break}default:{k[ka>>2]=0;T=ka+4|0;k[T>>2]=0;d=ZT(8)|0;k[d>>2]=1;f=d+4|0;k[ka>>2]=f;k[T>>2]=0;i[f>>0]=0;Y8(-210,ka,334084,333645,1354);k[T>>2]=0;k[ka>>2]=0;T=k[d>>2]|0;k[d>>2]=T+-1;if((T|0)==1)ggb(k[d+-4>>2]|0)}}d=ka+4|0;n=d+4|0;k[n>>2]=0;k[n+4>>2]=0;k[ka>>2]=33619968;k[d>>2]=na;SW(ia,ka,5,1.0,0.0);d=k[ja>>2]|0;n=d;if(d|0){q=k[U>>2]|0;if((q|0)!=(d|0))k[U>>2]=q+(~((q+-8-n|0)>>>3)<<3);ggb(d)}d=k[la>>2]|0;n=d;if(d|0){q=k[V>>2]|0;if((q|0)!=(d|0))k[V>>2]=q+(~((q+-4-n|0)>>>2)<<2);ggb(d)}d=k[ma>>2]|0;n=d;if(d|0){q=k[W>>2]|0;if((q|0)!=(d|0))k[W>>2]=q+(~((q+-4-n|0)>>>2)<<2);ggb(d)}d=k[_>>2]|0;if(d|0?(la=d+12|0,ma=k[la>>2]|0,k[la>>2]=ma+-1,(ma|0)==1):0){n=k[_>>2]|0;if(n|0){d=k[n+4>>2]|0;do if(!d){d=k[Y>>2]|0;if(d|0)break;d=B1()|0;n=k[_>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,n)}k[_>>2]=0}k[_>>2]=0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;if((k[da>>2]|0)>0){n=k[Z>>2]|0;d=0;do{k[n+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[da>>2]|0))}d=k[$>>2]|0;if(!((d|0)==(ba|0)|(d|0)==0))ggb(k[d+-4>>2]|0);d=k[fa>>2]|0;if(d|0?(la=d+12|0,ma=k[la>>2]|0,k[la>>2]=ma+-1,(ma|0)==1):0){q=na+36|0;n=k[q>>2]|0;if(n|0){d=k[n+4>>2]|0;do if(!d){d=k[na+32>>2]|0;if(d|0)break;d=B1()|0;n=k[q>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,n)}k[q>>2]=0}k[fa>>2]=0;k[ga>>2]=0;k[ga+4>>2]=0;k[ga+8>>2]=0;k[ga+12>>2]=0;if((k[ha>>2]|0)>0){n=k[X>>2]|0;d=0;do{k[n+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[ha>>2]|0))}d=k[na+44>>2]|0;if(!((d|0)==(na+48|0)|(d|0)==0))ggb(k[d+-4>>2]|0);q=oa+36|0;d=k[q>>2]|0;do if(d|0){ma=d+12|0;na=k[ma>>2]|0;k[ma>>2]=na+-1;if((na|0)!=1)break;n=k[q>>2]|0;if(n|0){d=k[n+4>>2]|0;do if(!d){d=k[oa+32>>2]|0;if(d|0)break;d=B1()|0;n=k[q>>2]|0}while(0);jh[k[(k[d>>2]|0)+24>>2]&1023](d,n)}k[q>>2]=0}while(0);k[q>>2]=0;q=oa+4|0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[q>>2]|0)>0){n=k[oa+40>>2]|0;d=0;do{k[n+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[q>>2]|0))}d=k[oa+44>>2]|0;if((d|0)==(oa+48|0)|(d|0)==0){r=pa;return}ggb(k[d+-4>>2]|0);r=pa;return}function zla(a,b,c,d,e,f,g,h,j,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;m=m|0;var n=0,q=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0,T=0;T=r;r=r+16|0;S=T;H=(c|0)!=0;if(!(H|(b|0)==(e|0))){n=S+4|0;q=ZT(40)|0;k[q>>2]=1;D=q+4|0;k[S>>2]=D;k[n>>2]=32;i[q+36>>0]=0;E=334132;F=D+32|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,S,334165,333645,122);k[n>>2]=0;k[S>>2]=0;M=k[q>>2]|0;k[q>>2]=M+-1;if((M|0)==1)ggb(k[q+-4>>2]|0)}K=k[a+40>>2]|0;G=k[K>>2]|0;k[l>>2]=k[K+4>>2];K=l+4|0;k[K>>2]=G;G=k[a>>2]|0;L=G&7;G=1212424721>>>(G<<2&28)&15;n=e+1|0;q=h+4|0;u=k[q>>2]|0;t=k[h>>2]|0;s=u-t>>2;if(n>>>0<=s>>>0){if(n>>>0<s>>>0?(x=t+(n<<2)|0,(u|0)!=(x|0)):0)k[q>>2]=u+(~((u+-4-x|0)>>>2)<<2)}else vaa(h,n-s|0);n=n<<1;q=j+4|0;u=k[q>>2]|0;t=k[j>>2]|0;s=u-t>>2;if(n>>>0<=s>>>0){if(n>>>0<s>>>0?(y=t+(n<<2)|0,(u|0)!=(y|0)):0)k[q>>2]=u+(~((u+-4-y|0)>>>2)<<2)}else U1(j,n-s|0);M=(e|0)>0;if(M){y=S+4|0;z=(b|0)>0;A=S+4|0;B=S+4|0;C=S+4|0;x=0;u=1;do{a:do if(!H)if(!(k[a+(x*56|0)>>2]&4088)){n=x;q=0}else{n=ZT(32)|0;k[n>>2]=1;D=n+4|0;k[S>>2]=D;k[C>>2]=25;i[n+29>>0]=0;E=334183;F=D+25|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,S,334165,333645,137);k[C>>2]=0;k[S>>2]=0;F=k[n>>2]|0;k[n>>2]=F+-1;if((F|0)==1)ggb(k[n+-4>>2]|0);n=x;q=0}else{q=k[c+(x<<2)>>2]|0;if((q|0)<=-1?(J=ZT(12)|0,k[J>>2]=1,F=J+4|0,k[S>>2]=F,k[y>>2]=6,i[J+10>>0]=0,i[F>>0]=i[334209]|0,i[F+1>>0]=i[334210]|0,i[F+2>>0]=i[334211]|0,i[F+3>>0]=i[334212]|0,i[F+4>>0]=i[334213]|0,i[F+5>>0]=i[334214]|0,Y8(-215,S,334165,333645,142),k[y>>2]=0,k[S>>2]=0,F=k[J>>2]|0,k[J>>2]=F+-1,(F|0)==1):0)ggb(k[J+-4>>2]|0);if(z){n=0;s=q;while(1){q=(k[a+(n*56|0)>>2]|0)>>>3&511;if((s|0)<=(q|0)){q=s;break a}q=s+-1-q|0;n=n+1|0;if((n|0)<(b|0))s=q;else break}}else n=0;s=ZT(16)|0;k[s>>2]=1;D=s+4|0;k[S>>2]=D;k[A>>2]=11;i[s+15>>0]=0;E=334216;F=D+11|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,S,334165,333645,146);k[A>>2]=0;k[S>>2]=0;F=k[s>>2]|0;k[s>>2]=F+-1;if((F|0)==1)ggb(k[s+-4>>2]|0)}while(0);s=a+(n*56|0)|0;F=k[a+(n*56|0)+40>>2]|0;if(((k[F>>2]|0)==(k[K>>2]|0)?(k[F+4>>2]|0)==(k[l>>2]|0):0)?(I=k[s>>2]|0,(I&7|0)==(L|0)):0)s=I;else{t=ZT(64)|0;k[t>>2]=1;D=t+4|0;k[S>>2]=D;k[B>>2]=56;i[t+60>>0]=0;E=334228;F=D+56|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,S,334165,333645,149);k[B>>2]=0;k[S>>2]=0;F=k[t>>2]|0;k[t>>2]=F+-1;if((F|0)==1)ggb(k[t+-4>>2]|0);s=k[s>>2]|0}u=u&(s&16384|0)!=0;D=(k[a+(n*56|0)+16>>2]|0)+(aa(q,G)|0)|0;k[(k[h>>2]|0)+(x<<2)>>2]=D;D=(s>>>3&511)+1|0;F=x<<1;E=k[j>>2]|0;k[E+(F<<2)>>2]=D;D=(((k[a+(n*56|0)+48>>2]|0)>>>0)/(G>>>0)|0)-(aa(D,k[l>>2]|0)|0)|0;k[E+((F|1)<<2)>>2]=D;x=x+1|0}while((x|0)<(e|0))}else u=1;x=d+16|0;do if(!(k[x>>2]|0)){if(u)N=54}else{s=k[d+4>>2]|0;if((s|0)<3)n=aa(k[d+12>>2]|0,k[d+8>>2]|0)|0;else{t=k[d+40>>2]|0;q=0;n=1;do{n=aa(k[t+(q<<2)>>2]|0,n)|0;q=q+1|0}while((q|0)!=(s|0))}if(!n)if(u){N=54;break}else break;J=k[d+40>>2]|0;if(((k[J>>2]|0)==(k[K>>2]|0)?(k[J+4>>2]|0)==(k[l>>2]|0):0)?(k[d>>2]&4088|0)==0:0)q=d;else{n=S+4|0;q=ZT(52)|0;k[q>>2]=1;D=q+4|0;k[S>>2]=D;k[n>>2]=45;i[q+49>>0]=0;E=334285;F=D+45|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,S,334165,333645,159);k[n>>2]=0;k[S>>2]=0;J=k[q>>2]|0;k[q>>2]=J+-1;if((J|0)==1)ggb(k[q+-4>>2]|0);q=d}if(u)n=(k[q>>2]&16384|0)!=0;else n=0;k[(k[h>>2]|0)+(e<<2)>>2]=k[x>>2];h=e<<1;j=k[j>>2]|0;k[j+(h<<2)>>2]=1;k[j+((h|1)<<2)>>2]=((k[d+48>>2]|0)>>>0)/((1212424721>>>(k[q>>2]<<2&28)&15)>>>0)|0;if(n)N=54}while(0);if((N|0)==54){N=aa(k[l>>2]|0,k[K>>2]|0)|0;k[l>>2]=N;k[K>>2]=1}if(!g){if(L|0){n=S+4|0;q=ZT(20)|0;k[q>>2]=1;D=q+4|0;k[S>>2]=D;k[n>>2]=14;i[q+18>>0]=0;E=403519;F=D+14|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,S,334165,333645,176);k[n>>2]=0;k[S>>2]=0;S=k[q>>2]|0;k[q>>2]=S+-1;if((S|0)==1)ggb(k[q+-4>>2]|0)}n=e<<1;q=m+4|0;u=k[q>>2]|0;t=k[m>>2]|0;s=u-t>>3;if(n>>>0<=s>>>0){if(n>>>0<s>>>0?(P=t+(n<<3)|0,(u|0)!=(P|0)):0)k[q>>2]=u+(~((u+-8-P|0)>>>3)<<3)}else Bla(m,n-s|0);if(!M){r=T;return}q=k[m>>2]|0;n=0;do{m=n<<1;p[q+(m<<3)>>3]=+(k[f+(n<<2)>>2]|0)*.00390625;p[q+((m|1)<<3)>>3]=0.0;n=n+1|0}while((n|0)!=(e|0));r=T;return}n=e<<1;q=m+4|0;u=k[q>>2]|0;t=k[m>>2]|0;s=u-t>>3;if(n>>>0<=s>>>0){if(n>>>0<s>>>0?(O=t+(n<<3)|0,(u|0)!=(O|0)):0)k[q>>2]=u+(~((u+-8-O|0)>>>3)<<3)}else Bla(m,n-s|0);if(!M){r=T;return}t=S+4|0;s=0;do{q=g+(s<<2)|0;n=k[q>>2]|0;if((n|0)!=0?(Q=+o[n>>2],R=+o[n+4>>2],Q<R):0){v=Q;w=R}else{n=ZT(48)|0;k[n>>2]=1;D=n+4|0;k[S>>2]=D;k[t>>2]=40;i[n+44>>0]=0;E=334331;F=D+40|0;do{i[D>>0]=i[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));Y8(-215,S,334165,333645,190);k[t>>2]=0;k[S>>2]=0;P=k[n>>2]|0;k[n>>2]=P+-1;if((P|0)==1)ggb(k[n+-4>>2]|0);P=k[q>>2]|0;v=+o[P>>2];w=+o[P+4>>2]}w=+(k[f+(s<<2)>>2]|0)/(w-v);P=s<<1;O=k[m>>2]|0;p[O+(P<<3)>>3]=w;p[O+((P|1)<<3)>>3]=-(v*w);s=s+1|0}while((s|0)<(e|0));r=T;return}function Ala(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0.0,n=0.0,o=0,q=0.0;j=c<<8;l=e+4|0;h=k[l>>2]|0;g=k[e>>2]|0;f=h-g>>2;if(j>>>0<=f>>>0){if(j>>>0<f>>>0?(i=g+(j<<2)|0,(h|0)!=(i|0)):0)k[l>>2]=h+(~((h+-4-i|0)>>>2)<<2)}else{r4(e,j-f|0);g=k[e>>2]|0}if((c|0)<=0)return;o=k[a+40>>2]|0;l=k[a+44>>2]|0;if(!(k[b+4>>2]|0)){f=0;do{i=f<<1;m=+p[d+(i<<3)>>3];n=+p[d+((i|1)<<3)>>3];i=k[o+(f<<2)>>2]|0;e=k[l+(f<<2)>>2]|0;j=f<<8;h=0;do{q=n+m*+(h|0);a=~~q;a=a-(+(a|0)>q&1)|0;b=aa(a,e)|0;k[g+(h+j<<2)>>2]=a>>>0<i>>>0?b:1073741824;h=h+1|0}while((h|0)!=256);f=f+1|0}while((f|0)!=(c|0));return}else{f=0;do{i=f<<1;m=+p[d+(i<<3)>>3];n=+p[d+((i|1)<<3)>>3];i=k[o+(f<<2)>>2]|0;e=k[l+(f<<2)>>2]|0;j=f<<8;h=0;do{q=n+m*+(h|0);a=~~q;a=a-(+(a|0)>q&1)|0;b=aa(a,e)|0;k[g+(h+j<<2)>>2]=a>>>0<i>>>0?b:1073741824;h=h+1|0}while((h|0)!=256);f=f+1|0}while((f|0)!=(c|0));return}}function Bla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;j=a+8|0;d=k[j>>2]|0;l=a+4|0;c=k[l>>2]|0;if(d-c>>3>>>0>=b>>>0){zpb(c|0,0,b<<3|0)|0;k[l>>2]=c+(b<<3);return}i=k[a>>2]|0;h=c-i|0;g=h>>3;c=g+b|0;if(c>>>0>536870911)ad(426534,426557,304,426811);e=d-i|0;f=e>>2;f=e>>3>>>0<268435455?(f>>>0<c>>>0?c:f):536870911;if(!f)c=0;else{if(f>>>0>536870911){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<3)|0;zpb(e|0,0,b<<3|0)|0;d=e+(0-g<<3)|0;if((h|0)>0)upb(d|0,i|0,h|0)|0;k[a>>2]=d;k[l>>2]=e+(b<<3);k[j>>2]=c+(f<<3);if(!i)return;ggb(i);return}function Cla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,m=0,n=0,o=0;m=r;r=r+1024|0;j=m;zpb(j|0,0,1024)|0;f=k[a+4>>2]|0;i=k[f+48>>2]|0;d=k[b>>2]|0;g=(k[b+4>>2]|0)-d|0;c=(k[f>>2]&16384|0)!=0;h=aa(c?g:1,k[f+12>>2]|0)|0;d=(k[f+16>>2]|0)+(aa(k[k[f+44>>2]>>2]|0,d)|0)|0;g=c?1:g;c=g+-1|0;a:do if(g|0){e=h+-4|0;if((h|0)<4){e=(h|0)>0;while(1){if(e){b=0;do{g=j+((l[d+b>>0]|0)<<2)|0;k[g>>2]=(k[g>>2]|0)+1;b=b+1|0}while((b|0)!=(h|0))}if(!c)break a;else{d=d+i|0;c=c+-1|0}}}f=h&-4;g=(f|0)<(h|0);while(1){b=0;do{n=l[d+(b|1)>>0]|0;o=j+((l[d+b>>0]|0)<<2)|0;k[o>>2]=(k[o>>2]|0)+1;n=j+(n<<2)|0;k[n>>2]=(k[n>>2]|0)+1;n=l[d+(b|3)>>0]|0;o=j+((l[d+(b|2)>>0]|0)<<2)|0;k[o>>2]=(k[o>>2]|0)+1;n=j+(n<<2)|0;k[n>>2]=(k[n>>2]|0)+1;b=b+4|0}while((b|0)<=(e|0));if(g){b=f;do{o=j+((l[d+b>>0]|0)<<2)|0;k[o>>2]=(k[o>>2]|0)+1;b=b+1|0}while((b|0)!=(h|0))}if(!c)break;else{d=d+i|0;c=c+-1|0}}}while(0);d=k[a+12>>2]|0;mpb(k[d>>2]|0)|0;c=k[a+8>>2]|0;b=0;do{o=c+(b<<2)|0;k[o>>2]=(k[o>>2]|0)+(k[j+(b<<2)>>2]|0);b=b+1|0}while((b|0)!=256);lpb(k[d>>2]|0)|0;r=m;return}function Dla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0;d=k[a+4>>2]|0;m=k[d+48>>2]|0;f=k[a+8>>2]|0;n=k[f+48>>2]|0;c=k[d+12>>2]|0;e=k[b>>2]|0;b=(k[b+4>>2]|0)-e|0;j=k[a+12>>2]|0;if(!(k[d>>2]&16384))h=c;else{g=(k[f>>2]&16384|0)!=0;h=aa(g?b:1,c)|0;b=g?1:b}d=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,e)|0)|0;c=(k[f+16>>2]|0)+(aa(k[k[f+44>>2]>>2]|0,e)|0)|0;a=b+-1|0;if(!b)return;e=h+-4|0;if((h|0)<4){e=(h|0)>0;while(1){if(e){b=0;do{i[c+b>>0]=k[j+((l[d+b>>0]|0)<<2)>>2];b=b+1|0}while((b|0)!=(h|0))}if(!a)break;else{d=d+m|0;c=c+n|0;a=a+-1|0}}return}f=h&-4;g=(f|0)<(h|0);while(1){b=0;do{q=b|1;o=k[j+((l[d+q>>0]|0)<<2)>>2]|0;i[c+b>>0]=k[j+((l[d+b>>0]|0)<<2)>>2];i[c+q>>0]=o;q=b|2;o=b|3;p=k[j+((l[d+o>>0]|0)<<2)>>2]|0;i[c+q>>0]=k[j+((l[d+q>>0]|0)<<2)>>2];i[c+o>>0]=p;b=b+4|0}while((b|0)<=(e|0));if(g){b=f;do{i[c+b>>0]=k[j+((l[d+b>>0]|0)<<2)>>2];b=b+1|0}while((b|0)!=(h|0))}if(!a)break;else{d=d+m|0;c=c+n|0;a=a+-1|0}}return}function Ela(a){a=a|0;ggb(a);return}function Fla(a){a=a|0;ggb(a);return}function Gla(a,b,c,d,e,f,g){a=a|0;b=+b;c=+c;d=d|0;e=e|0;f=+f;g=+g;var h=0,j=0,l=0,m=0,n=0,q=0.0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0;W=r;r=r+3216|0;Q=W;V=W+2152|0;P=W+2136|0;U=W+1072|0;R=W+8|0;q=1.0/b;if(k[a>>2]&4095|0){h=Q+4|0;j=ZT(28)|0;k[j>>2]=1;l=j+4|0;k[Q>>2]=l;k[h>>2]=21;i[j+25>>0]=0;m=334881;n=l+21|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,Q,334985,334918,86);k[h>>2]=0;k[Q>>2]=0;M=k[j>>2]|0;k[j>>2]=M+-1;if((M|0)==1)ggb(k[j+-4>>2]|0)}G=k[a+16>>2]|0;H=k[a+48>>2]|0;I=k[a+12>>2]|0;F=k[a+8>>2]|0;if(g<f){h=Q+4|0;j=ZT(48)|0;k[j>>2]=1;l=j+4|0;k[Q>>2]=l;k[h>>2]=40;i[j+44>>0]=0;m=335004;n=l+40|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-5,Q,334985,334918,94);k[h>>2]=0;k[Q>>2]=0;M=k[j>>2]|0;k[j>>2]=M+-1;if((M|0)==1)ggb(k[j+-4>>2]|0)}g=(g-f)/c;p[u>>3]=g;h=k[u+4>>2]|0;M=h&2146435072;if(!(M>>>0>1126170624|(M|0)==1126170624&0>0)){h=(h|0)<0;g=h?g+-4503599627370496.0+4503599627370496.0:g+4503599627370496.0+-4503599627370496.0;if(g==0.0)g=h?-0.0:0.0}A=~~g;g=+(F+I<<1|1|0)/b;h=(o[u>>2]=g,k[u>>2]|0);if((h&2130706432)>>>0<=1249902592){h=(h|0)<0;g=h?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=h?-0.0:0.0}B=~~g;m=A+2|0;J=B+2|0;a=aa(J,m)|0;L=V+8|0;k[V>>2]=L;M=V+4|0;k[M>>2]=264;if(a>>>0>264){j=a>>>0>1073741823?-1:a<<2;j=(j|0)==0?1:j;while(1){h=fgb(j)|0;if(h|0)break;h=k[207666]|0;k[207666]=h+0;if(!h){h=0;break}Qh[h&7]()}k[V>>2]=h}else h=L;k[M>>2]=a;k[P>>2]=0;C=P+4|0;k[C>>2]=0;k[P+8>>2]=0;D=U+8|0;k[U>>2]=D;E=U+4|0;k[E>>2]=264;l=A>>>0>264;if(l){a=A>>>0>1073741823?-1:A<<2;a=(a|0)==0?1:a;while(1){j=fgb(a)|0;if(j|0)break;j=k[207666]|0;k[207666]=j+0;if(!j){j=0;break}Qh[j&7]()}k[U>>2]=j}else j=D;k[E>>2]=A;y=R+8|0;k[R>>2]=y;z=R+4|0;k[z>>2]=264;if(l){l=A>>>0>1073741823?-1:A<<2;l=(l|0)==0?1:l;while(1){a=fgb(l)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[R>>2]=a}else a=y;k[z>>2]=A;zpb(h|0,0,aa(m<<2,J)|0)|0;x=(A|0)>0;if(x){g=f;l=0;while(1){t=g;s=q*+T(+t);o[j+(l<<2)>>2]=s;t=q*+S(+t);o[a+(l<<2)>>2]=t;l=l+1|0;if((l|0)==(A|0))break;else g=g+c}}if((F|0)>0?(K=((B+-1|0)/2|0)+1|0,(I|0)>0):0){v=0;do{w=aa(v,H)|0;q=+(v|0);if(x){m=0;do{if(i[G+(m+w)>>0]|0){s=+(m|0);n=0;do{g=s*+o[a+(n<<2)>>2]+q*+o[j+(n<<2)>>2];l=(o[u>>2]=g,k[u>>2]|0);do if((l&2130706432)>>>0<=1249902592){l=(l|0)<0;g=l?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(!(g==0.0))break;g=l?-0.0:0.0}while(0);n=n+1|0;l=h+(K+(aa(n,J)|0)+~~g<<2)|0;k[l>>2]=(k[l>>2]|0)+1}while((n|0)!=(A|0))}m=m+1|0}while((m|0)!=(I|0))}v=v+1|0}while((v|0)!=(F|0))}if((B|0)>0?(N=-2-B|0,O=P+8|0,x):0){a=0;do{j=0;do{j=j+1|0;I=(aa(j,J)|0)+a|0;l=I+1|0;k[Q>>2]=l;K=k[h+(l<<2)>>2]|0;do if(((((K|0)>(d|0)?(K|0)>(k[h+(I<<2)>>2]|0):0)?(K|0)>=(k[h+(I+2<<2)>>2]|0):0)?(K|0)>(k[h+(N+l<<2)>>2]|0):0)?(K|0)>=(k[h+(J+l<<2)>>2]|0):0){m=k[C>>2]|0;if((m|0)==(k[O>>2]|0)){Q4(P,Q);break}else{k[m>>2]=l;k[C>>2]=m+4;break}}while(0)}while((j|0)<(A|0));a=a+1|0}while((a|0)<(B|0))}w=k[P>>2]|0;x=k[C>>2]|0;k[Q>>2]=h;Jla(w,x,Q);v=w;P=x-v|0;n=P>>2;t=1.0/+(J|0);if((P|0)>0){g=+(B+-1|0)*.5;j=Q+4|0;a=e+4|0;l=e+8|0;h=0;do{P=k[w+(h<<2)>>2]|0;q=t*+(P|0);m=~~q;m=m-(+(m|0)>q&1)|0;q=(+(P+-1-(aa(m,J)|0)|0)-g)*b;s=f+ +(m+-1|0)*c;o[Q>>2]=q;o[j>>2]=s;m=k[a>>2]|0;if((m|0)==(k[l>>2]|0))Ila(e,Q);else{o[m>>2]=q;o[m+4>>2]=s;k[a>>2]=m+8}h=h+1|0}while((h|0)<(n|0))}h=k[R>>2]|0;if((h|0)!=(y|0)){if(h|0)ggb(h);k[R>>2]=y;k[z>>2]=264}h=k[U>>2]|0;if((h|0)!=(D|0)){if(h|0)ggb(h);k[U>>2]=D;k[E>>2]=264}if(w|0){if((x|0)!=(w|0))k[C>>2]=x+(~((x+-4-v|0)>>>2)<<2);ggb(w)}h=k[V>>2]|0;if((h|0)==(L|0)){r=W;return}if(h|0)ggb(h);k[V>>2]=L;k[M>>2]=264;r=W;return}function Hla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=a+4|0;h=k[a>>2]|0;i=(k[g>>2]|0)-h|0;e=(i|0)/12|0;c=e+1|0;if(c>>>0>357913941)ad(426534,426557,304,426811);j=a+8|0;d=((k[j>>2]|0)-h|0)/12|0;f=d<<1;f=d>>>0<178956970?(f>>>0<c>>>0?c:f):357913941;if(!f)c=0;else{if(f>>>0>357913941){j=te(4)|0;k[j>>2]=172664;Cf(j|0,28816,1287)}d=f*12|0;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(e*12|0)|0;k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2];d=e+(((i|0)/-12|0)*12|0)|0;if((i|0)>0)upb(d|0,h|0,i|0)|0;k[a>>2]=d;k[g>>2]=e+12;k[j>>2]=c+(f*12|0);if(!h)return;ggb(h);return}function Ila(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;l=a+4|0;c=k[l>>2]|0;m=k[a>>2]|0;f=c-m>>3;d=f+1|0;if(d>>>0>536870911)ad(426534,426557,304,426811);j=m;h=c;i=a+8|0;g=(k[i>>2]|0)-m|0;e=g>>2;e=g>>3>>>0<268435455?(e>>>0<d>>>0?d:e):536870911;if(!e)d=0;else{if(e>>>0>536870911){m=te(4)|0;k[m>>2]=172664;Cf(m|0,28816,1287)}d=e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}d=c}c=d+(f<<3)|0;g=d+(e<<3)|0;k[c>>2]=k[b>>2];k[d+(f<<3)+4>>2]=k[b+4>>2];f=c+8|0;if((h|0)!=(j|0)){b=h+-8|0;d=h;e=c;do{h=e;e=e+-8|0;n=d;d=d+-8|0;k[e>>2]=k[d>>2];k[h+-4>>2]=k[n+-4>>2]}while((d|0)!=(j|0));c=c+(~((b-m|0)>>>3)<<3)|0}k[a>>2]=c;k[l>>2]=f;k[i>>2]=g;if(!m)return;ggb(m);return}function Jla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a:while(1){p=b;r=b+-4|0;while(1){b:while(1){o=a;d=p-o|0;e=d>>2;switch(e|0){case 2:{q=5;break a}case 3:{q=8;break a}case 4:{q=22;break a}case 5:{q=23;break a}case 1:case 0:{q=111;break a}default:{}}if((d|0)<124){q=25;break a}g=a+(((e|0)/2|0)<<2)|0;do if((d|0)>3996){d=(e|0)/4|0;d=Lla(a,a+(d<<2)|0,g,g+(d<<2)|0,r,c)|0;e=k[c>>2]|0}else{i=k[g>>2]|0;j=k[a>>2]|0;m=k[c>>2]|0;e=k[m+(i<<2)>>2]|0;l=m+(j<<2)|0;d=k[l>>2]|0;if((e|0)>(d|0))h=1;else h=(i|0)<(j|0)&(e|0)==(d|0);f=k[r>>2]|0;d=k[m+(f<<2)>>2]|0;if((d|0)>(e|0))d=1;else d=(f|0)<(i|0)&(d|0)==(e|0);if(!h){if(!d){d=0;e=m;break}k[g>>2]=f;k[r>>2]=i;d=k[g>>2]|0;e=k[a>>2]|0;l=k[m+(d<<2)>>2]|0;n=k[m+(e<<2)>>2]|0;if((l|0)<=(n|0)?!((d|0)<(e|0)&(l|0)==(n|0)):0){d=1;e=m;break}k[a>>2]=d;k[g>>2]=e;d=2;e=m;break}if(d){k[a>>2]=f;k[r>>2]=j;d=1;e=m;break}k[a>>2]=i;k[g>>2]=j;d=k[r>>2]|0;i=k[m+(d<<2)>>2]|0;n=k[l>>2]|0;if((i|0)<=(n|0)?!((d|0)<(j|0)&(i|0)==(n|0)):0){d=1;e=m;break}k[g>>2]=d;k[r>>2]=j;d=2;e=m}while(0);n=k[a>>2]|0;l=k[g>>2]|0;f=k[e+(n<<2)>>2]|0;e=k[e+(l<<2)>>2]|0;if((f|0)>(e|0)){e=r;break}if((n|0)<(l|0)&(f|0)==(e|0)){e=r;break}m=k[c>>2]|0;f=m+(l<<2)|0;e=r;while(1){e=e+-4|0;if((a|0)==(e|0))break;h=k[e>>2]|0;i=k[m+(h<<2)>>2]|0;j=k[f>>2]|0;if((i|0)>(j|0)){q=89;break b}if((h|0)<(l|0)&(i|0)==(j|0)){q=89;break b}}d=a+4|0;g=k[r>>2]|0;h=k[m+(n<<2)>>2]|0;o=k[m+(g<<2)>>2]|0;if((h|0)<=(o|0)?!((n|0)<(g|0)&(h|0)==(o|0)):0){if((d|0)==(r|0)){q=111;break a}while(1){e=k[d>>2]|0;f=k[m+(e<<2)>>2]|0;if((h|0)>(f|0))break;if((n|0)<(e|0)&(h|0)==(f|0))break;d=d+4|0;if((d|0)==(r|0)){q=111;break a}}k[d>>2]=g;k[r>>2]=e;d=d+4|0}if((d|0)==(r|0)){q=111;break a}l=k[c>>2]|0;e=r;while(1){i=k[a>>2]|0;g=k[d>>2]|0;j=k[l+(i<<2)>>2]|0;f=k[l+(g<<2)>>2]|0;c:do if((j|0)<=(f|0))do{if((i|0)<(g|0)&(j|0)==(f|0))break c;d=d+4|0;g=k[d>>2]|0;f=k[l+(g<<2)>>2]|0}while((j|0)<=(f|0));while(0);while(1){e=e+-4|0;f=k[e>>2]|0;h=k[l+(f<<2)>>2]|0;if((j|0)>(h|0))continue;if(!((i|0)<(f|0)&(j|0)==(h|0)))break}if(d>>>0>=e>>>0){a=d;continue b}k[d>>2]=f;k[e>>2]=g;d=d+4|0}}if((q|0)==89){q=0;k[a>>2]=h;k[e>>2]=n;d=d+1|0}f=a+4|0;d:do if(f>>>0<e>>>0){n=k[c>>2]|0;while(1){l=k[g>>2]|0;m=k[n+(l<<2)>>2]|0;while(1){j=k[f>>2]|0;i=k[n+(j<<2)>>2]|0;if((i|0)<=(m|0)?!((j|0)<(l|0)&(i|0)==(m|0)):0)break;f=f+4|0}do{e=e+-4|0;h=k[e>>2]|0;i=k[n+(h<<2)>>2]|0;if((i|0)>(m|0))break}while(!((h|0)<(l|0)&(i|0)==(m|0)));if(f>>>0>e>>>0){h=f;break d}k[f>>2]=h;k[e>>2]=j;g=(g|0)==(f|0)?e:g;f=f+4|0;d=d+1|0}}else h=f;while(0);do if((h|0)!=(g|0)){e=k[g>>2]|0;f=k[h>>2]|0;n=k[c>>2]|0;m=k[n+(e<<2)>>2]|0;n=k[n+(f<<2)>>2]|0;if((m|0)<=(n|0)?!((e|0)<(f|0)&(m|0)==(n|0)):0)break;k[h>>2]=e;k[g>>2]=f;d=d+1|0}while(0);if(!d){d=Mla(a,h,c)|0;e=h+4|0;if(Mla(e,b,c)|0){q=110;break}if(d){a=e;continue}}n=h;if((n-o|0)>=(p-n|0)){q=109;break}Jla(a,h,c);a=h+4|0}if((q|0)==109){q=0;Jla(h+4|0,b,c);b=h;continue}else if((q|0)==110){q=0;if(d){q=111;break}else{b=h;continue}}}if((q|0)==5){b=k[r>>2]|0;d=k[a>>2]|0;c=k[c>>2]|0;q=k[c+(b<<2)>>2]|0;c=k[c+(d<<2)>>2]|0;if((q|0)<=(c|0)?!((b|0)<(d|0)&(q|0)==(c|0)):0)return;k[a>>2]=b;k[r>>2]=d;return}else if((q|0)==8){l=a+4|0;g=k[l>>2]|0;i=k[a>>2]|0;j=k[c>>2]|0;d=k[j+(g<<2)>>2]|0;h=j+(i<<2)|0;b=k[h>>2]|0;if((d|0)>(b|0))e=1;else e=(g|0)<(i|0)&(d|0)==(b|0);f=k[r>>2]|0;b=k[j+(f<<2)>>2]|0;if((b|0)>(d|0))b=1;else b=(f|0)<(g|0)&(b|0)==(d|0);if(!e){if(!b)return;k[l>>2]=f;k[r>>2]=g;b=k[l>>2]|0;d=k[a>>2]|0;r=k[j+(b<<2)>>2]|0;c=k[j+(d<<2)>>2]|0;if((r|0)<=(c|0)?!((b|0)<(d|0)&(r|0)==(c|0)):0)return;k[a>>2]=b;k[l>>2]=d;return}if(b){k[a>>2]=f;k[r>>2]=i;return}k[a>>2]=g;k[l>>2]=i;a=k[r>>2]|0;q=k[j+(a<<2)>>2]|0;c=k[h>>2]|0;if((q|0)<=(c|0)?!((a|0)<(i|0)&(q|0)==(c|0)):0)return;k[l>>2]=a;k[r>>2]=i;return}else if((q|0)==22){Kla(a,a+4|0,a+8|0,r,k[c>>2]|0)|0;return}else if((q|0)==23){Lla(a,a+4|0,a+8|0,a+12|0,r,c)|0;return}else if((q|0)==25){e=a+8|0;l=a+4|0;f=k[l>>2]|0;m=k[a>>2]|0;g=k[c>>2]|0;i=k[g+(f<<2)>>2]|0;n=g+(m<<2)|0;d=k[n>>2]|0;if((i|0)>(d|0))h=1;else h=(f|0)<(m|0)&(i|0)==(d|0);j=k[e>>2]|0;g=g+(j<<2)|0;d=k[g>>2]|0;if((d|0)>(i|0))d=1;else d=(j|0)<(f|0)&(d|0)==(i|0);do if(!h)if(d){k[l>>2]=j;k[e>>2]=f;q=k[g>>2]|0;r=k[n>>2]|0;if((q|0)<=(r|0)?!((j|0)<(m|0)&(q|0)==(r|0)):0)break;k[a>>2]=j;k[l>>2]=m}else f=j;else{if(d){k[a>>2]=j;k[e>>2]=m;f=m;break}k[a>>2]=f;k[l>>2]=m;q=k[g>>2]|0;r=k[n>>2]|0;if((q|0)<=(r|0)?!((j|0)<(m|0)&(q|0)==(r|0)):0){f=j;break}k[l>>2]=j;k[e>>2]=m;f=m}while(0);d=a+12|0;if((d|0)==(b|0))return;j=k[c>>2]|0;i=d;d=f;while(1){h=k[i>>2]|0;g=j+(h<<2)|0;r=k[g>>2]|0;c=k[j+(d<<2)>>2]|0;if(!((r|0)<=(c|0)?!((h|0)<(d|0)&(r|0)==(c|0)):0)){k[i>>2]=d;e:do if((e|0)==(a|0))d=a;else while(1){d=e;e=e+-4|0;f=k[e>>2]|0;r=k[g>>2]|0;c=k[j+(f<<2)>>2]|0;if((r|0)<=(c|0)?!((h|0)<(f|0)&(r|0)==(c|0)):0)break e;k[d>>2]=f;if((e|0)==(a|0)){d=a;break}}while(0);k[d>>2]=h}d=i+4|0;if((d|0)==(b|0))break;c=k[i>>2]|0;e=i;i=d;d=c}return}else if((q|0)==111)return}function Kla(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0;m=k[b>>2]|0;l=k[a>>2]|0;i=k[e+(m<<2)>>2]|0;j=e+(l<<2)|0;f=k[j>>2]|0;if((i|0)>(f|0))h=1;else h=(m|0)<(l|0)&(i|0)==(f|0);g=k[c>>2]|0;f=k[e+(g<<2)>>2]|0;if((f|0)>(i|0))f=1;else f=(g|0)<(m|0)&(f|0)==(i|0);do if(!h)if(f){k[b>>2]=g;k[c>>2]=m;f=k[b>>2]|0;g=k[a>>2]|0;j=k[e+(f<<2)>>2]|0;l=k[e+(g<<2)>>2]|0;if((j|0)<=(l|0)?!((f|0)<(g|0)&(j|0)==(l|0)):0){h=1;g=m;break}k[a>>2]=f;k[b>>2]=g;h=2;g=k[c>>2]|0}else h=0;else{if(f){k[a>>2]=g;k[c>>2]=l;h=1;g=l;break}k[a>>2]=m;k[b>>2]=l;g=k[c>>2]|0;i=k[e+(g<<2)>>2]|0;m=k[j>>2]|0;if((i|0)<=(m|0)?!((g|0)<(l|0)&(i|0)==(m|0)):0){h=1;break}k[b>>2]=g;k[c>>2]=l;h=2;g=l}while(0);f=k[d>>2]|0;l=k[e+(f<<2)>>2]|0;m=k[e+(g<<2)>>2]|0;if((l|0)<=(m|0)?!((f|0)<(g|0)&(l|0)==(m|0)):0){b=h;return b|0}k[c>>2]=f;k[d>>2]=g;f=k[c>>2]|0;g=k[b>>2]|0;m=k[e+(f<<2)>>2]|0;d=k[e+(g<<2)>>2]|0;if((m|0)<=(d|0)?!((f|0)<(g|0)&(m|0)==(d|0)):0){b=h+1|0;return b|0}k[b>>2]=f;k[c>>2]=g;f=k[b>>2]|0;g=k[a>>2]|0;c=k[e+(f<<2)>>2]|0;e=k[e+(g<<2)>>2]|0;if((c|0)<=(e|0)?!((f|0)<(g|0)&(c|0)==(e|0)):0){b=h+2|0;return b|0}k[a>>2]=f;k[b>>2]=g;b=h+3|0;return b|0}function Lla(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0;j=Kla(a,b,c,d,k[f>>2]|0)|0;g=k[e>>2]|0;h=k[d>>2]|0;i=k[f>>2]|0;l=k[i+(g<<2)>>2]|0;f=k[i+(h<<2)>>2]|0;if((l|0)<=(f|0)?!((g|0)<(h|0)&(l|0)==(f|0)):0){l=j;return l|0}k[d>>2]=g;k[e>>2]=h;f=k[d>>2]|0;e=k[c>>2]|0;h=k[i+(f<<2)>>2]|0;l=k[i+(e<<2)>>2]|0;if((h|0)<=(l|0)?!((f|0)<(e|0)&(h|0)==(l|0)):0){l=j+1|0;return l|0}k[c>>2]=f;k[d>>2]=e;f=k[c>>2]|0;e=k[b>>2]|0;d=k[i+(f<<2)>>2]|0;l=k[i+(e<<2)>>2]|0;if((d|0)<=(l|0)?!((f|0)<(e|0)&(d|0)==(l|0)):0){l=j+2|0;return l|0}k[b>>2]=f;k[c>>2]=e;f=k[b>>2]|0;e=k[a>>2]|0;c=k[i+(f<<2)>>2]|0;l=k[i+(e<<2)>>2]|0;if((c|0)<=(l|0)?!((f|0)<(e|0)&(c|0)==(l|0)):0){l=j+3|0;return l|0}k[a>>2]=f;k[b>>2]=e;l=j+4|0;return l|0}function Mla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=k[d>>2]|0;f=k[a>>2]|0;b=k[c>>2]|0;c=k[b+(e<<2)>>2]|0;b=k[b+(f<<2)>>2]|0;if((c|0)<=(b|0)?!((e|0)<(f|0)&(c|0)==(b|0)):0){a=1;return a|0}k[a>>2]=e;k[d>>2]=f;a=1;return a|0}case 3:{n=a+4|0;j=b+-4|0;h=k[n>>2]|0;l=k[a>>2]|0;m=k[c>>2]|0;f=k[m+(h<<2)>>2]|0;i=m+(l<<2)|0;d=k[i>>2]|0;if((f|0)>(d|0))e=1;else e=(h|0)<(l|0)&(f|0)==(d|0);g=k[j>>2]|0;d=k[m+(g<<2)>>2]|0;if((d|0)>(f|0))d=1;else d=(g|0)<(h|0)&(d|0)==(f|0);if(!e){if(!d){a=1;return a|0}k[n>>2]=g;k[j>>2]=h;d=k[n>>2]|0;e=k[a>>2]|0;c=k[m+(d<<2)>>2]|0;b=k[m+(e<<2)>>2]|0;if((c|0)<=(b|0)?!((d|0)<(e|0)&(c|0)==(b|0)):0){a=1;return a|0}k[a>>2]=d;k[n>>2]=e;a=1;return a|0}if(d){k[a>>2]=g;k[j>>2]=l;a=1;return a|0}k[a>>2]=h;k[n>>2]=l;d=k[j>>2]|0;b=k[m+(d<<2)>>2]|0;a=k[i>>2]|0;if((b|0)<=(a|0)?!((d|0)<(l|0)&(b|0)==(a|0)):0){a=1;return a|0}k[n>>2]=d;k[j>>2]=l;a=1;return a|0}case 4:{Kla(a,a+4|0,a+8|0,b+-4|0,k[c>>2]|0)|0;a=1;return a|0}case 5:{Lla(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;a=1;return a|0}case 1:case 0:{a=1;return a|0}default:{f=a+8|0;l=a+4|0;g=k[l>>2]|0;m=k[a>>2]|0;e=k[c>>2]|0;i=k[e+(g<<2)>>2]|0;n=e+(m<<2)|0;d=k[n>>2]|0;if((i|0)>(d|0))h=1;else h=(g|0)<(m|0)&(i|0)==(d|0);j=k[f>>2]|0;e=e+(j<<2)|0;d=k[e>>2]|0;if((d|0)>(i|0))d=1;else d=(j|0)<(g|0)&(d|0)==(i|0);do if(!h)if(d){k[l>>2]=j;k[f>>2]=g;i=k[e>>2]|0;n=k[n>>2]|0;if((i|0)<=(n|0)?!((j|0)<(m|0)&(i|0)==(n|0)):0)break;k[a>>2]=j;k[l>>2]=m}else g=j;else{if(d){k[a>>2]=j;k[f>>2]=m;g=m;break}k[a>>2]=g;k[l>>2]=m;i=k[e>>2]|0;n=k[n>>2]|0;if((i|0)<=(n|0)?!((j|0)<(m|0)&(i|0)==(n|0)):0){g=j;break}k[l>>2]=j;k[f>>2]=m;g=m}while(0);d=a+12|0;a:do if((d|0)==(b|0)){e=1;d=0}else{l=k[c>>2]|0;j=d;e=0;d=g;while(1){i=k[j>>2]|0;h=l+(i<<2)|0;n=k[h>>2]|0;c=k[l+(d<<2)>>2]|0;if((n|0)<=(c|0)?!((i|0)<(d|0)&(n|0)==(c|0)):0)d=j+4|0;else{k[j>>2]=d;b:do if((f|0)==(a|0))d=a;else while(1){d=f;f=f+-4|0;g=k[f>>2]|0;n=k[h>>2]|0;c=k[l+(g<<2)>>2]|0;if((n|0)<=(c|0)?!((i|0)<(g|0)&(n|0)==(c|0)):0)break b;k[d>>2]=g;if((f|0)==(a|0)){d=a;break}}while(0);k[d>>2]=i;e=e+1|0;d=j+4|0;if((e|0)==8){e=0;d=(d|0)==(b|0);break a}}if((d|0)==(b|0)){e=1;d=0;break a}c=k[j>>2]|0;f=j;j=d;d=c}}while(0);a=d|e;return a|0}}return 0}function Nla(a){a=a|0;ggb(a);return}function Ola(a){a=a|0;var b=0,c=0;b=r;r=r+16|0;c=b;k[c>>2]=k[a+8>>2];B9(c);if(!a){r=b;return}Uh[k[(k[a>>2]|0)+4>>2]&2047](a);r=b;return}function Pla(){var a=0;if(((((Qla(1,0)|0)!=0?(Qla(1,1)|0)!=0:0)?(Qla(2,0)|0)!=0:0)?(Qla(2,1)|0)!=0:0)?(Qla(4,0)|0)!=0:0)a=(Qla(4,1)|0)!=0&1;else a=0;i[1012629]=a;return}function Qla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0.0,g=0.0,h=0.0,l=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0.0,Z=0;X=r;r=r+1072|0;l=X+1064|0;W=X;switch(a|0){case 1:{N=810660;P=1004176;O=2;break}case 2:{N=482980;P=840336;O=4;break}case 4:{N=548516;P=873104;O=8;break}default:{c=l+4|0;d=ZT(44)|0;k[d>>2]=1;n=d+4|0;k[l>>2]=n;k[c>>2]=38;i[d+42>>0]=0;q=335461;s=n+38|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(s|0));Y8(-5,l,335500,335515,224);k[c>>2]=0;k[l>>2]=0;U=k[d>>2]|0;k[d>>2]=U+-1;if((U|0)==1)ggb(k[d+-4>>2]|0);N=0;P=0;O=0}}Q=1012630+a|0;if(i[Q>>0]|0){W=N;V=P;W=b?V:W;r=X;return W|0}R=W+8|0;k[W>>2]=R;U=W+4|0;k[U>>2]=256;switch(a|0){case 1:{c=0;d=R;while(1){h=+(c|0)*.03125;o[d>>2]=1.0-h;o[d+4>>2]=h;c=c+1|0;if((c|0)==32){M=R;break}else d=d+8|0}break}case 2:{c=0;d=R;while(1){h=+(c|0)*.03125;f=h+1.0;f=f*(f*(3.75-f*.75)+-6.0)+3.0;o[d>>2]=f;g=h*(h*(h*1.25+-2.25))+1.0;o[d+4>>2]=g;h=1.0-h;h=h*(h*(h*1.25+-2.25))+1.0;o[d+8>>2]=h;o[d+12>>2]=1.0-f-g-h;c=c+1|0;if((c|0)==32){M=R;break}else d=d+16|0}break}case 4:{d=0;a=R;while(1){e=+(d|0)*.03125;if(e<1.1920928955078125e-07){k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;k[a+16>>2]=0;k[a+20>>2]=0;k[a+24>>2]=0;k[a+28>>2]=0;o[a+12>>2]=1.0}else{f=e+3.0;h=-f*3.141592653589793*.25;g=+T(+h);h=+S(+h);c=0;e=0.0;do{Y=-(f-+(c|0))*3.141592653589793*.25;Y=(g*+p[16144+(c<<4)>>3]+h*+p[16144+(c<<4)+8>>3])/(Y*Y);o[a+(c<<2)>>2]=Y;e=e+Y;c=c+1|0}while((c|0)!=8);Y=1.0/e;o[a>>2]=Y*+o[a>>2];M=a+4|0;o[M>>2]=Y*+o[M>>2];M=a+8|0;o[M>>2]=Y*+o[M>>2];M=a+12|0;o[M>>2]=Y*+o[M>>2];M=a+16|0;o[M>>2]=Y*+o[M>>2];M=a+20|0;o[M>>2]=Y*+o[M>>2];M=a+24|0;o[M>>2]=Y*+o[M>>2];M=a+28|0;o[M>>2]=Y*+o[M>>2]}d=d+1|0;if((d|0)==32){M=R;break}else a=a+32|0}break}default:{k[l>>2]=0;c=l+4|0;k[c>>2]=0;d=ZT(36)|0;k[d>>2]=1;n=d+4|0;k[l>>2]=n;k[c>>2]=28;i[d+32>>0]=0;q=335584;s=n+28|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(s|0));Y8(-5,l,335613,335515,207);k[c>>2]=0;k[l>>2]=0;M=k[d>>2]|0;k[d>>2]=M+-1;if((M|0)==1)ggb(k[d+-4>>2]|0);M=k[W>>2]|0}}D=(O|0)==0;E=aa(O,O)|0;F=O>>>1;G=F+2|0;H=E<<5;L=E<<10;y=0;z=N;A=P;while(1){I=y<<5;J=(y|0)<16&1;K=aa(y,O)|0;x=0;B=z;C=A;while(1){w=x+I|0;i[1012638+(w<<1)>>0]=(x|0)<16&1;i[1012638+(w<<1)+1>>0]=J;if(!D){q=aa(x,O)|0;c=0;n=0;do{f=+o[M+(n+K<<2)>>2];s=aa(n,O)|0;l=0;do{e=f*+o[M+(l+q<<2)>>2];a=l+s|0;o[B+(a<<2)>>2]=e;e=e*32768.0;d=(o[u>>2]=e,k[u>>2]|0);if((d&2130706432)>>>0<=1249902592){d=(d|0)<0;e=d?e+-8388608.0+8388608.0:e+8388608.0+-8388608.0;if(e==0.0)e=d?-0.0:0.0}w=~~e;w=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;j[C+(a<<1)>>1]=w;c=(w<<16>>16)+c|0;l=l+1|0}while((l|0)<(O|0));n=n+1|0}while((n|0)<(O|0));if((c|0)!=32768)V=31}else{c=0;V=31}do if((V|0)==31){V=0;a=F;l=F;n=F;d=F;v=F;while(1){w=aa(v,O)|0;s=a;q=F;while(1){a=j[C+(q+w<<1)>>1]|0;t=C+((aa(s,O)|0)+d<<1)|0;if(a<<16>>16<(j[t>>1]|0)){t=q;a=v}else{Z=C+((aa(n,O)|0)+l<<1)|0;Z=a<<16>>16>(j[Z>>1]|0);t=d;a=s;l=Z?q:l;n=Z?v:n}q=q+1|0;if((q|0)>=(G|0))break;else{s=a;d=t}}v=v+1|0;if((v|0)>=(G|0))break;else d=t}d=c+-32768|0;if((c|0)<32768){Z=C+((aa(n,O)|0)+l<<1)|0;j[Z>>1]=(m[Z>>1]|0)-d;break}else{Z=C+((aa(a,O)|0)+t<<1)|0;j[Z>>1]=(m[Z>>1]|0)-d;break}}while(0);x=x+1|0;if((x|0)==32)break;else{B=B+(E<<2)|0;C=C+(E<<1)|0}}y=y+1|0;if((y|0)==32)break;else{z=z+(H<<2)|0;A=A+(H<<1)|0}}c=aa(aa(O,-1024)|0,O)|0;d=N+(L<<2)+(c<<2)|0;c=P+(L<<1)+(c<<1)|0;i[Q>>0]=1;if((M|0)!=(R|0)){if(M|0)ggb(M);k[W>>2]=R;k[U>>2]=264}Z=d;W=c;Z=b?W:Z;r=X;return Z|0}function Rla(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;var g=0,h=0,l=0.0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0.0,$=0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0;ga=r;r=r+2464|0;da=ga+1328|0;ca=ga+264|0;E=ga;K=ga+256|0;fa=ga+192|0;z=ga+248|0;ea=ga+136|0;R1(K,a,-1);D=K+4|0;if((aa(k[D>>2]|0,k[K>>2]|0)|0)<=0){g=da+4|0;h=ZT(24)|0;k[h>>2]=1;n=h+4|0;k[da>>2]=n;k[g>>2]=16;i[h+20>>0]=0;q=335628;y=n+16|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(y|0));Y8(-215,da,335645,335515,3229);k[g>>2]=0;k[da>>2]=0;$=k[h>>2]|0;k[h>>2]=$+-1;if(($|0)==1)ggb(k[h+-4>>2]|0)}g=k[c>>2]|0;$=c+4|0;h=k[$>>2]|0;if((aa(h,g)|0)<=0?!(d>0.0&e>0.0):0){g=da+4|0;h=ZT(64)|0;k[h>>2]=1;n=h+4|0;k[da>>2]=n;k[g>>2]=56;i[h+60>>0]=0;q=335652;y=n+56|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(y|0));Y8(-215,da,335645,335515,3230);k[g>>2]=0;k[da>>2]=0;Z=k[h>>2]|0;k[h>>2]=Z+-1;if((Z|0)==1)ggb(k[h+-4>>2]|0);g=k[c>>2]|0;h=k[$>>2]|0}if(!(aa(h,g)|0)){l=+(k[K>>2]|0)*d;p[u>>3]=l;g=k[u+4>>2]|0;Z=g&2146435072;if(!(Z>>>0>1126170624|(Z|0)==1126170624&0>0)){g=(g|0)<0;l=g?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=g?-0.0:0.0}h=~~l;l=+(k[D>>2]|0)*e;p[u>>3]=l;g=k[u+4>>2]|0;Z=g&2146435072;if(!(Z>>>0>1126170624|(Z|0)==1126170624&0>0)){g=(g|0)<0;l=g?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=g?-0.0:0.0}Z=~~l;k[c>>2]=h;k[$>>2]=Z;if((aa(Z,h)|0)>0)_=e;else{g=da+4|0;h=ZT(24)|0;k[h>>2]=1;n=h+4|0;k[da>>2]=n;k[g>>2]=16;i[h+20>>0]=0;q=335709;y=n+16|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(y|0));Y8(-215,da,335645,335515,3235);k[g>>2]=0;k[da>>2]=0;Z=k[h>>2]|0;k[h>>2]=Z+-1;if((Z|0)==1)ggb(k[h+-4>>2]|0);_=e}}else{d=+(g|0)/+(k[K>>2]|0);_=+(h|0)/+(k[D>>2]|0)}Z=S1(a,-1)|0;y=Z&7;Z=(Z>>>3&511)+1|0;Y=1.0/d;ba=1.0/_;p[u>>3]=Y;g=k[u+4>>2]|0;X=g&2146435072;if(!(X>>>0>1126170624|(X|0)==1126170624&0>0)){g=(g|0)<0;l=g?Y+-4503599627370496.0+4503599627370496.0:Y+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=g?-0.0:0.0}else l=Y;C=~~l;p[u>>3]=ba;g=k[u+4>>2]|0;X=g&2146435072;if(!(X>>>0>1126170624|(X|0)==1126170624&0>0)){g=(g|0)<0;l=g?ba+-4503599627370496.0+4503599627370496.0:ba+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=g?-0.0:0.0}else l=ba;B=~~l;if(+P(+(Y-+(C|0)))<2.220446049250313e-16)w=+P(+(ba-+(B|0)))<2.220446049250313e-16;else w=0;do if((k[a>>2]&2031616|0)==65536){m=k[a+4>>2]|0;k[fa>>2]=k[m>>2];t=fa+4|0;g=m+4|0;k[t>>2]=k[g>>2];X=fa+8|0;k[X>>2]=k[m+8>>2];k[fa+12>>2]=k[m+12>>2];k[fa+16>>2]=k[m+16>>2];k[fa+20>>2]=k[m+20>>2];k[fa+24>>2]=k[m+24>>2];k[fa+28>>2]=k[m+28>>2];k[fa+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[fa+36>>2]=h;a=fa+40|0;k[a>>2]=X;X=fa+48|0;q=fa+44|0;k[q>>2]=X;k[fa+52>>2]=0;k[X>>2]=0;if(h|0){X=h+12|0;k[X>>2]=(k[X>>2]|0)+1}if((k[g>>2]|0)<3){X=k[m+44>>2]|0;v=k[q>>2]|0;k[v>>2]=k[X>>2];k[v+4>>2]=k[X+4>>2];v=fa;break}k[t>>2]=0;x1(fa,k[g>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[m+40>>2]|0;n=k[a>>2]|0;a=k[m+44>>2]|0;h=k[q>>2]|0;g=0;do{k[n+(g<<2)>>2]=k[s+(g<<2)>>2];k[h+(g<<2)>>2]=k[a+(g<<2)>>2];g=g+1|0}while((g|0)<(k[t>>2]|0));v=fa}else v=fa}else{Q1(fa,a,-1);v=fa}while(0);k[z>>2]=k[c>>2];k[z+4>>2]=k[$>>2];x2(b,z,k[v>>2]&4095,0);do if((k[b>>2]&2031616|0)==65536){m=k[b+4>>2]|0;k[ea>>2]=k[m>>2];t=ea+4|0;g=m+4|0;k[t>>2]=k[g>>2];X=ea+8|0;k[X>>2]=k[m+8>>2];k[ea+12>>2]=k[m+12>>2];k[ea+16>>2]=k[m+16>>2];k[ea+20>>2]=k[m+20>>2];k[ea+24>>2]=k[m+24>>2];k[ea+28>>2]=k[m+28>>2];k[ea+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[ea+36>>2]=h;a=ea+40|0;k[a>>2]=X;X=ea+48|0;q=ea+44|0;k[q>>2]=X;k[ea+52>>2]=0;k[X>>2]=0;if(h|0){X=h+12|0;k[X>>2]=(k[X>>2]|0)+1}if((k[g>>2]|0)<3){W=k[m+44>>2]|0;X=k[q>>2]|0;k[X>>2]=k[W>>2];k[X+4>>2]=k[W+4>>2];break}k[t>>2]=0;x1(ea,k[g>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[m+40>>2]|0;n=k[a>>2]|0;a=k[m+44>>2]|0;h=k[q>>2]|0;g=0;do{k[n+(g<<2)>>2]=k[s+(g<<2)>>2];k[h+(g<<2)>>2]=k[a+(g<<2)>>2];g=g+1|0}while((g|0)<(k[t>>2]|0))}}else Q1(ea,b,-1);while(0);m=k[K>>2]|0;g=k[D>>2]|0;t=k[c>>2]|0;q=k[$>>2]|0;a:do if(!((t|0)==(m|0)&(q|0)==(g|0))){switch(f|0){case 0:{w=fa+40|0;a=k[(k[w>>2]|0)+4>>2]|0;b=ea+40|0;q=k[b>>2]|0;n=k[q+4>>2]|0;q=k[q>>2]|0;z=da+8|0;k[da>>2]=z;B=da+4|0;k[B>>2]=264;if(n>>>0>264){h=n>>>0>1073741823?-1:n<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[da>>2]=g}else g=z;k[B>>2]=n;v=fa+4|0;h=k[v>>2]|0;if((h|0)>0)m=k[(k[fa+44>>2]|0)+(h+-1<<2)>>2]|0;else m=0;y=m>>>2;if((n|0)>0){a=a+-1|0;h=0;do{_=Y*+(h|0);$=~~_;$=$-(+($|0)>_&1)|0;$=aa((a|0)<($|0)?a:$,m)|0;k[g+(h<<2)>>2]=$;h=h+1|0}while((h|0)!=(n|0));h=k[v>>2]|0}k[ca>>2]=0;k[ca+4>>2]=q;k[E>>2]=86556;m=E+4|0;k[m>>2]=k[fa>>2];t=E+8|0;k[t>>2]=h;$=E+12|0;k[$>>2]=k[fa+8>>2];k[E+16>>2]=k[fa+12>>2];k[E+20>>2]=k[fa+16>>2];k[E+24>>2]=k[fa+20>>2];k[E+28>>2]=k[fa+24>>2];k[E+32>>2]=k[fa+28>>2];k[E+36>>2]=k[fa+32>>2];a=k[fa+36>>2]|0;k[E+40>>2]=a;n=E+44|0;k[n>>2]=$;$=E+52|0;s=E+48|0;k[s>>2]=$;k[E+56>>2]=0;k[$>>2]=0;if(a){h=a+12|0;k[h>>2]=(k[h>>2]|0)+1;h=k[v>>2]|0}if((h|0)>=3){k[t>>2]=0;x1(m,h,0,0,0);if((k[t>>2]|0)>0){q=k[w>>2]|0;m=k[n>>2]|0;n=k[fa+44>>2]|0;a=k[s>>2]|0;h=0;do{k[m+(h<<2)>>2]=k[q+(h<<2)>>2];k[a+(h<<2)>>2]=k[n+(h<<2)>>2];h=h+1|0}while((h|0)<(k[t>>2]|0))}}else{Z=k[fa+44>>2]|0;$=k[s>>2]|0;k[$>>2]=k[Z>>2];k[$+4>>2]=k[Z+4>>2]}n=E+60|0;k[n>>2]=k[ea>>2];v=E+64|0;a=ea+4|0;h=k[a>>2]|0;k[v>>2]=h;$=E+68|0;k[$>>2]=k[ea+8>>2];k[E+72>>2]=k[ea+12>>2];k[E+76>>2]=k[ea+16>>2];k[E+80>>2]=k[ea+20>>2];k[E+84>>2]=k[ea+24>>2];k[E+88>>2]=k[ea+28>>2];k[E+92>>2]=k[ea+32>>2];m=k[ea+36>>2]|0;k[E+96>>2]=m;s=E+100|0;k[s>>2]=$;$=E+108|0;t=E+104|0;k[t>>2]=$;k[E+112>>2]=0;k[$>>2]=0;if(m){h=m+12|0;k[h>>2]=(k[h>>2]|0)+1;h=k[a>>2]|0}if((h|0)>=3){k[v>>2]=0;x1(n,h,0,0,0);if((k[v>>2]|0)>0){q=k[b>>2]|0;m=k[s>>2]|0;n=k[ea+44>>2]|0;a=k[t>>2]|0;h=0;do{k[m+(h<<2)>>2]=k[q+(h<<2)>>2];k[a+(h<<2)>>2]=k[n+(h<<2)>>2];h=h+1|0}while((h|0)<(k[v>>2]|0))}}else{Z=k[ea+44>>2]|0;$=k[t>>2]|0;k[$>>2]=k[Z>>2];k[$+4>>2]=k[Z+4>>2]}k[E+116>>2]=g;k[E+120>>2]=y;p[E+128>>3]=ba;jh[k[(k[E>>2]|0)+8>>2]&1023](E,ca);Sla(E);g=k[da>>2]|0;if((g|0)!=(z|0)){if(g|0)ggb(g);k[da>>2]=z;k[B>>2]=264}break a}case 1:{J=(B|0)==2&((C|0)==2&w)?3:1;break}default:J=f}X=(J|0)==3;if(ba>=1.0&(Y>=1.0&X)){if(w){m=aa(B,C)|0;v=((k[fa+48>>2]|0)>>>0)/((1212424721>>>(k[v>>2]<<2&28)&15)>>>0)|0;a=(aa(t,Z)|0)+m|0;w=da+8|0;k[da>>2]=w;b=da+4|0;k[b>>2]=264;if(a>>>0>264){h=a>>>0>1073741823?-1:a<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[da>>2]=g}else g=w;k[b>>2]=a;s=g+(m<<2)|0;t=k[85888+(y<<2)>>2]|0;if(!(109>>>y&1)){k[ca>>2]=0;h=ca+4|0;k[h>>2]=0;a=ZT(16)|0;k[a>>2]=1;n=a+4|0;k[ca>>2]=n;k[h>>2]=9;i[a+13>>0]=0;q=335726;y=n+9|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(y|0));Y8(-215,ca,335645,335515,3317);k[h>>2]=0;k[ca>>2]=0;ca=k[a>>2]|0;k[a>>2]=ca+-1;if((ca|0)==1)ggb(k[a+-4>>2]|0)}if((B|0)>0&(C|0)>0){h=0;m=0;while(1){q=aa(m,v)|0;a=0;n=h;while(1){ca=(aa(a,Z)|0)+q|0;k[g+(n<<2)>>2]=ca;a=a+1|0;if((a|0)==(C|0))break;else n=n+1|0}m=m+1|0;if((m|0)==(B|0))break;else h=C+h|0}}a=k[c>>2]|0;if((a|0)>0){q=0;do{m=aa(q,Z)|0;n=aa(m,C)|0;h=0;do{k[s+(h+m<<2)>>2]=h+n;h=h+1|0}while((h|0)!=(Z|0));q=q+1|0}while((q|0)!=(a|0))}Lg[t&255](fa,ea,g,s,C,B);g=k[da>>2]|0;if((g|0)!=(w|0)){if(g|0)ggb(g);k[da>>2]=w;k[b>>2]=264}break}z=k[85920+(y<<2)>>2]|0;if(!((109>>>y&1|0)!=0&Z>>>0<5)){k[da>>2]=0;g=da+4|0;k[g>>2]=0;h=ZT(28)|0;k[h>>2]=1;n=h+4|0;k[da>>2]=n;k[g>>2]=20;i[h+24>>0]=0;q=335736;y=n+20|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(y|0));Y8(-215,da,335645,335515,3336);k[g>>2]=0;k[da>>2]=0;X=k[h>>2]|0;k[h>>2]=X+-1;if((X|0)==1)ggb(k[h+-4>>2]|0);m=k[K>>2]|0;g=k[D>>2]|0}a=g+m<<1;b=da+8|0;k[da>>2]=b;y=da+4|0;k[y>>2]=93;if(a>>>0>93){h=a>>>0>357913941?-1:a*12|0;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[da>>2]=g;w=g}else w=b;k[y>>2]=a;v=w+((m<<1)*12|0)|0;t=Tla(m,k[c>>2]|0,Z,Y,w)|0;n=Tla(k[D>>2]|0,k[$>>2]|0,1,ba,v)|0;a=(k[$>>2]|0)+1|0;q=ca+8|0;k[ca>>2]=q;s=ca+4|0;k[s>>2]=264;if(a>>>0>264){h=a>>>0>1073741823?-1:a<<2;h=(h|0)==0?1:h;while(1){g=fgb(h)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}k[ca>>2]=g;m=g}else m=q;k[s>>2]=a;if((n|0)>0){g=0;h=0;do{if(!((h|0)!=0?(k[v+(h*12|0)+4>>2]|0)==(k[v+((h+-1|0)*12|0)+4>>2]|0):0)){k[m+(g<<2)>>2]=h;g=g+1|0}h=h+1|0}while((h|0)!=(n|0))}else g=0;k[m+(g<<2)>>2]=n;Eh[z&127](fa,ea,w,t,v,n,m);g=k[ca>>2]|0;if((g|0)!=(q|0)){if(g|0)ggb(g);k[ca>>2]=q;k[s>>2]=264}g=k[da>>2]|0;if((g|0)!=(b|0)){if(g|0)ggb(g);k[da>>2]=b;k[y>>2]=93}break}s=aa(t,Z)|0;V=(y|0)==0;W=(J|0)==2;do if(W){h=4;g=85952+(y<<2)|0;n=147}else{if((J|0)==4){h=8;g=85984+(y<<2)|0;n=147;break}if((J|2|0)==3){h=2;g=86016+(y<<2)|0;n=147;break}k[da>>2]=0;g=da+4|0;k[g>>2]=0;h=ZT(36)|0;k[h>>2]=1;n=h+4|0;k[da>>2]=n;k[g>>2]=28;i[h+32>>0]=0;q=335584;y=n+28|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(y|0));Y8(-5,da,335645,335515,3374);k[g>>2]=0;k[da>>2]=0;U=k[h>>2]|0;k[h>>2]=U+-1;if((U|0)==1)ggb(k[h+-4>>2]|0);h=0;m=0;n=148}while(0);if((n|0)==147){g=k[g>>2]|0;a=h>>>1;if(!g){m=a;n=148}else{U=g;g=q;m=a}}if((n|0)==148){k[da>>2]=0;g=da+4|0;k[g>>2]=0;a=ZT(16)|0;k[a>>2]=1;n=a+4|0;k[da>>2]=n;k[g>>2]=9;i[a+13>>0]=0;q=335726;y=n+9|0;do{i[n>>0]=i[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(y|0));Y8(-215,da,335645,335515,3377);k[g>>2]=0;k[da>>2]=0;U=k[a>>2]|0;k[a>>2]=U+-1;if((U|0)==1)ggb(k[a+-4>>2]|0);U=0;g=k[$>>2]|0}n=aa(g+s|0,h<<2|4)|0;Q=da+8|0;k[da>>2]=Q;R=da+4|0;k[R>>2]=1032;if(n>>>0>1032){while(1){a=fgb(n)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[da>>2]=a}else a=Q;k[R>>2]=n;N=a+(s<<2)|0;O=N+(g<<2)|0;M=aa(h,s)|0;L=O+(M<<2)|0;M=O+(M<<1)|0;I=k[c>>2]|0;if((I|0)>0){b=m+-1|0;y=ca+4|0;z=ca+8|0;B=ca+12|0;C=(h|0)>0;f=aa(h,Z)|0;D=(J|0)==4;c=ca+16|0;F=ca+20|0;G=ca+24|0;H=ca+28|0;v=k[K>>2]|0;w=v+-1|0;q=0;n=t;t=0;while(1){l=+(t|0);if(X){l=Y*l;g=~~l;g=g-(+(g|0)>l&1)|0;l=+(t+1|0)-d*+(g+1|0);if(!(l<=0.0)){K=~~l;l=l-+(K-(+(K|0)>l&1)|0)}else l=0.0}else{l=Y*(l+.5)+-.5;g=~~l;g=g-(+(g|0)>l&1)|0;l=l-+(g|0)}b:do if((g|0)<(b|0)){q=t+1|0;if((g|0)<0){switch(J|0){case 2:case 4:{E=q;break b}default:{}}l=0.0;E=q;g=0}else E=q}else E=q;while(0);c:do if((g+m|0)>=(v|0)){n=(t|0)<(n|0)?t:n;if((g|0)<(w|0))break;switch(J|0){case 2:case 4:break c;default:{}}l=0.0;g=w}while(0);q=aa(g,Z)|0;s=aa(t,Z)|0;g=0;do{k[a+(g+s<<2)>>2]=g+q;g=g+1|0}while((g|0)!=(Z|0));do if(W){A=l+1.0;A=A*(A*(3.75-A*.75)+-6.0)+3.0;o[ca>>2]=A;e=l*(l*(l*1.25+-2.25))+1.0;o[y>>2]=e;l=1.0-l;l=l*(l*(l*1.25+-2.25))+1.0;o[z>>2]=l;o[B>>2]=1.0-A-e-l;l=A}else{if(!D){A=1.0-l;o[ca>>2]=A;o[y>>2]=l;e=l;l=A;break}if(l<1.1920928955078125e-07){k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;k[ca+16>>2]=0;k[ca+20>>2]=0;k[ca+24>>2]=0;k[ca+28>>2]=0;o[B>>2]=1.0;e=0.0;l=0.0;break}e=l+3.0;A=-e*3.141592653589793*.25;x=+T(+A);A=+S(+A);g=0;l=0.0;do{ha=-(e-+(g|0))*3.141592653589793*.25;ha=(x*+p[16144+(g<<4)>>3]+A*+p[16144+(g<<4)+8>>3])/(ha*ha);o[ca+(g<<2)>>2]=ha;l=l+ha;g=g+1|0}while((g|0)!=8);ha=1.0/l;l=ha*+o[ca>>2];o[ca>>2]=l;e=ha*+o[y>>2];o[y>>2]=e;o[z>>2]=ha*+o[z>>2];o[B>>2]=ha*+o[B>>2];o[c>>2]=ha*+o[c>>2];o[F>>2]=ha*+o[F>>2];o[G>>2]=ha*+o[G>>2];o[H>>2]=ha*+o[H>>2]}while(0);do if(V){d:do if(C){s=aa(f,t)|0;l=l*2048.0;g=(o[u>>2]=l,k[u>>2]|0);do if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;l=g?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(!(l==0.0))break;l=g?-0.0:0.0}while(0);g=~~l;j[O+(s<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;l=e;g=1;while(1){l=l*2048.0;q=(o[u>>2]=l,k[u>>2]|0);do if((q&2130706432)>>>0<=1249902592){q=(q|0)<0;l=q?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(!(l==0.0))break;l=q?-0.0:0.0}while(0);K=~~l;j[O+(g+s<<1)>>1]=(K+32768|0)>>>0<65536?K:(K|0)>0?32767:32768;g=g+1|0;if((g|0)==(h|0)){g=h;break d}l=+o[ca+(g<<2)>>2]}}else g=0;while(0);if((g|0)>=(f|0))break;q=aa(f,t)|0;do{K=g+q|0;j[O+(K<<1)>>1]=j[O+(K-h<<1)>>1]|0;g=g+1|0}while((g|0)<(f|0))}else{if(C){q=aa(f,t)|0;g=0;do{k[O+(g+q<<2)>>2]=k[ca+(g<<2)>>2];g=g+1|0}while((g|0)!=(h|0));g=h}else g=0;if((g|0)>=(f|0))break;q=aa(f,t)|0;do{K=g+q|0;k[O+(K<<2)>>2]=k[O+(K-h<<2)>>2];g=g+1|0}while((g|0)<(f|0))}while(0);t=t+1|0;if((t|0)==(I|0))break;else q=E}g=k[$>>2]|0}else{E=0;n=t}if((g|0)>0){B=ca+4|0;C=ca+8|0;f=ca+12|0;D=(h|0)>0;v=(J|0)==4;w=ca+16|0;b=ca+20|0;y=ca+24|0;z=ca+28|0;t=k[$>>2]|0;s=0;do{l=+(s|0);if(X){l=ba*l;g=~~l;g=g-(+(g|0)>l&1)|0;l=+(s+1|0)-_*+(g+1|0);if(!(l<=0.0)){$=~~l;l=l-+($-(+($|0)>l&1)|0)}else l=0.0}else{l=ba*(l+.5)+-.5;g=~~l;g=g-(+(g|0)>l&1)|0;l=l-+(g|0)}k[N+(s<<2)>>2]=g;do if(W){ha=l+1.0;ha=ha*(ha*(3.75-ha*.75)+-6.0)+3.0;o[ca>>2]=ha;d=l*(l*(l*1.25+-2.25))+1.0;o[B>>2]=d;l=1.0-l;l=l*(l*(l*1.25+-2.25))+1.0;o[C>>2]=l;o[f>>2]=1.0-ha-d-l;l=ha}else{if(!v){ha=1.0-l;o[ca>>2]=ha;o[B>>2]=l;d=l;l=ha;break}if(l<1.1920928955078125e-07){k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;k[ca+16>>2]=0;k[ca+20>>2]=0;k[ca+24>>2]=0;k[ca+28>>2]=0;o[f>>2]=1.0;d=0.0;l=0.0;break}d=l+3.0;x=-d*3.141592653589793*.25;e=+T(+x);x=+S(+x);g=0;l=0.0;do{ha=-(d-+(g|0))*3.141592653589793*.25;ha=(e*+p[16144+(g<<4)>>3]+x*+p[16144+(g<<4)+8>>3])/(ha*ha);o[ca+(g<<2)>>2]=ha;l=l+ha;g=g+1|0}while((g|0)!=8);ha=1.0/l;l=ha*+o[ca>>2];o[ca>>2]=l;d=ha*+o[B>>2];o[B>>2]=d;o[C>>2]=ha*+o[C>>2];o[f>>2]=ha*+o[f>>2];o[w>>2]=ha*+o[w>>2];o[b>>2]=ha*+o[b>>2];o[y>>2]=ha*+o[y>>2];o[z>>2]=ha*+o[z>>2]}while(0);e:do if(V){if(!D)break;q=aa(s,h)|0;l=l*2048.0;g=(o[u>>2]=l,k[u>>2]|0);do if((g&2130706432)>>>0<=1249902592){g=(g|0)<0;l=g?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(!(l==0.0))break;l=g?-0.0:0.0}while(0);g=~~l;j[M+(q<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;l=d;g=1;while(1){l=l*2048.0;m=(o[u>>2]=l,k[u>>2]|0);do if((m&2130706432)>>>0<=1249902592){m=(m|0)<0;l=m?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(!(l==0.0))break;l=m?-0.0:0.0}while(0);$=~~l;j[M+(g+q<<1)>>1]=($+32768|0)>>>0<65536?$:($|0)>0?32767:32768;g=g+1|0;if((g|0)==(h|0))break e;l=+o[ca+(g<<2)>>2]}}else{if(!D)break;m=aa(s,h)|0;g=0;do{k[L+(g+m<<2)>>2]=k[ca+(g<<2)>>2];g=g+1|0}while((g|0)!=(h|0))}while(0);s=s+1|0}while((s|0)<(t|0))}Gh[U&127](fa,ea,a,O,N,V?M:L,E,n,h);g=k[da>>2]|0;if((g|0)!=(Q|0)){if(g|0)ggb(g);k[da>>2]=Q;k[R>>2]=1032}}else{ca=da+4|0;$=ca+4|0;k[$>>2]=0;k[$+4>>2]=0;k[da>>2]=33619968;k[ca>>2]=ea;mY(fa,da)}while(0);a=ea+36|0;g=k[a>>2]|0;if(g|0?(ca=g+12|0,da=k[ca>>2]|0,k[ca>>2]=da+-1,(da|0)==1):0){h=k[a>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[ea+32>>2]|0;if(!g){g=B1()|0;h=k[a>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[a>>2]=0}k[a>>2]=0;da=ea+16|0;h=ea+4|0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[h>>2]|0)>0){a=k[ea+40>>2]|0;g=0;do{k[a+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[ea+44>>2]|0;if(!((g|0)==(ea+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);a=fa+36|0;g=k[a>>2]|0;if(g|0?(da=g+12|0,ea=k[da>>2]|0,k[da>>2]=ea+-1,(ea|0)==1):0){h=k[a>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[fa+32>>2]|0;if(!g){g=B1()|0;h=k[a>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[a>>2]=0}k[a>>2]=0;ea=fa+16|0;h=fa+4|0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[h>>2]|0)>0){a=k[fa+40>>2]|0;g=0;do{k[a+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[fa+44>>2]|0;if((g|0)==(fa+48|0)|(g|0)==0){r=ga;return}ggb(k[g+-4>>2]|0);r=ga;return}function Sla(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86556;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Tla(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0.0,g=0,h=0,i=0,j=0.0,l=0,m=0.0,n=0,p=0,q=0.0;if((b|0)<=0){e=0;return e|0}q=+(a|0);p=a+-1|0;a=0;n=0;do{f=+(n|0)*d;j=f+d;m=q-f;m=m<d?m:d;h=~~f;h=(+(h|0)<f&1)+h|0;l=~~j;l=l-(+(l|0)>j&1)|0;l=(p|0)<(l|0)?p:l;h=(l|0)<(h|0)?l:h;f=+(h|0)-f;if(f>.001){i=aa(n,c)|0;k[e+(a*12|0)+4>>2]=i;i=aa(h+-1|0,c)|0;k[e+(a*12|0)>>2]=i;o[e+(a*12|0)+8>>2]=f/m;a=a+1|0}if((h|0)<(l|0)){i=aa(n,c)|0;f=1.0/m;g=a;while(1){k[e+(g*12|0)+4>>2]=i;a=aa(h,c)|0;k[e+(g*12|0)>>2]=a;a=g+1|0;o[e+(g*12|0)+8>>2]=f;h=h+1|0;if((h|0)>=(l|0))break;else g=a}}f=j-+(l|0);if(f>.001){i=aa(n,c)|0;k[e+(a*12|0)+4>>2]=i;l=aa(l,c)|0;k[e+(a*12|0)>>2]=l;j=f>1.0?1.0:f;o[e+(a*12|0)+8>>2]=(m<j?m:j)/m;a=a+1|0}n=n+1|0}while((n|0)!=(b|0));return a|0}function Ula(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86136;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);jma(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);jma(A);r=C;return}function Vla(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86116;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);gma(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);gma(A);r=C;return}function Wla(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86096;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);dma(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);dma(A);r=C;return}function Xla(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86076;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);ama(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);ama(A);r=C;return}function Yla(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86056;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Zla(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Zla(A);r=C;return}function Zla(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86056;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function _la(a){a=a|0;Zla(a);ggb(a);return}function $la(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,i=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0;T=r;r=r+1296|0;S=T;N=T+1224|0;O=T+1160|0;P=T+1096|0;K=((k[a+4>>2]|0)>>>3&511)+1|0;L=a+140|0;h=(k[L>>2]|0)+15&-16;M=a+148|0;i=k[M>>2]|0;e=aa(h,i)|0;Q=S+8|0;k[S>>2]=Q;R=S+4|0;k[R>>2]=136;if(e>>>0>136){d=e>>>0>536870911?-1:e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[S>>2]=c}else c=Q;k[R>>2]=e;d=N;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=O;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((i|0)>0){zpb(P|0,-1,i<<2|0)|0;d=0;do{J=c+((aa(d,h)|0)<<3)|0;k[O+(d<<2)>>2]=J;d=d+1|0}while((d|0)!=(i|0))}d=k[b>>2]|0;J=b+4|0;if((d|0)<(k[J>>2]|0)){w=(k[a+128>>2]|0)+((aa(d,i)|0)<<2)|0;B=a+120|0;C=a+116|0;D=a+124|0;E=a+156|0;F=a+76|0;G=a+108|0;H=a+136|0;I=a+20|0;A=a+48|0;x=h<<3;y=k[O>>2]|0;z=k[O+4>>2]|0;c=i;while(1){a:do if((c|0)>0){i=(k[(k[B>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;j=c;e=0;b=c;h=0;while(1){c=i+h|0;a=k[H>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(h|0)?h:e;b:do if((c|0)<(b|0)){while(1){if((a|0)==(k[P+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break b}if((c|0)>(h|0)){upb(k[O+(h<<2)>>2]|0,k[O+(c<<2)>>2]|0,x|0)|0;b=k[M>>2]|0}}while(0);j=(h|0)<(j|0)&(c|0)==(b|0)?h:j;v=(k[I>>2]|0)+(aa(k[k[A>>2]>>2]|0,a)|0)|0;k[N+(h<<2)>>2]=v;k[P+(h<<2)>>2]=a;h=h+1|0;if((h|0)>=(b|0))break;else e=c}if((b|0)>(j|0)){u=N+(j<<2)|0;v=O+(j<<2)|0;t=b-j|0;q=k[C>>2]|0;m=k[D>>2]|0;s=k[L>>2]|0;n=k[E>>2]|0;c:do if((t|0)<2)c=0;else{c=t+-1|0;e=k[u>>2]|0;h=k[v>>2]|0;if((n|0)<=0){l=(s|0)>0;j=0;while(1){j=j+1|0;a=e;e=k[u+(j<<2)>>2]|0;i=h;h=k[v+(j<<2)>>2]|0;if(l){b=0;do{U=k[q+(b<<2)>>2]|0;p[i+(b<<3)>>3]=+p[a+(U<<3)>>3];p[h+(b<<3)>>3]=+p[e+(U<<3)>>3];b=b+1|0}while((b|0)!=(s|0))}if((j|0)==(c|0))break c}}l=(n|0)<(s|0);j=0;do{j=j+1|0;a=e;e=k[u+(j<<2)>>2]|0;i=h;h=k[v+(j<<2)>>2]|0;b=0;do{V=k[q+(b<<2)>>2]|0;U=b<<1;W=+o[m+(U<<2)>>2];f=+o[m+((U|1)<<2)>>2];U=V+K|0;g=W*+p[e+(V<<3)>>3]+f*+p[e+(U<<3)>>3];p[i+(b<<3)>>3]=W*+p[a+(V<<3)>>3]+f*+p[a+(U<<3)>>3];p[h+(b<<3)>>3]=g;b=b+1|0}while((b|0)!=(n|0));if(l){b=n;do{V=k[q+(b<<2)>>2]|0;p[i+(b<<3)>>3]=+p[a+(V<<3)>>3];p[h+(b<<3)>>3]=+p[e+(V<<3)>>3];b=b+1|0}while((b|0)!=(s|0))}}while((j|0)!=(c|0))}while(0);if((c|0)<(t|0)){if((n|0)<=0){h=(s|0)>0;while(1){b=k[u+(c<<2)>>2]|0;a=k[v+(c<<2)>>2]|0;if(h){e=0;do{p[a+(e<<3)>>3]=+p[b+(k[q+(e<<2)>>2]<<3)>>3];e=e+1|0}while((e|0)!=(s|0))}c=c+1|0;if((c|0)==(t|0))break a}}h=(n|0)<(s|0);do{b=k[u+(c<<2)>>2]|0;a=k[v+(c<<2)>>2]|0;e=0;do{U=k[q+(e<<2)>>2]|0;V=e<<1;p[a+(e<<3)>>3]=+p[b+(U<<3)>>3]*+o[m+(V<<2)>>2]+ +p[b+(U+K<<3)>>3]*+o[m+((V|1)<<2)>>2];e=e+1|0}while((e|0)!=(n|0));if(h){e=n;do{p[a+(e<<3)>>3]=+p[b+(k[q+(e<<2)>>2]<<3)>>3];e=e+1|0}while((e|0)!=(s|0))}c=c+1|0}while((c|0)!=(t|0))}}}while(0);b=(k[F>>2]|0)+(aa(k[G>>2]|0,d)|0)|0;a=k[L>>2]|0;f=+o[w>>2];g=+o[w+4>>2];e=a+-4|0;if((a|0)<4)c=0;else{c=0;do{U=c|1;W=f*+p[y+(U<<3)>>3]+g*+p[z+(U<<3)>>3];p[b+(c<<3)>>3]=f*+p[y+(c<<3)>>3]+g*+p[z+(c<<3)>>3];p[b+(U<<3)>>3]=W;U=c|2;V=c|3;W=f*+p[y+(V<<3)>>3]+g*+p[z+(V<<3)>>3];p[b+(U<<3)>>3]=f*+p[y+(U<<3)>>3]+g*+p[z+(U<<3)>>3];p[b+(V<<3)>>3]=W;c=c+4|0}while((c|0)<=(e|0));c=a&-4}if((c|0)<(a|0))do{p[b+(c<<3)>>3]=f*+p[y+(c<<3)>>3]+g*+p[z+(c<<3)>>3];c=c+1|0}while((c|0)!=(a|0));d=d+1|0;c=k[M>>2]|0;if((d|0)>=(k[J>>2]|0))break;else w=w+(c<<2)|0}c=k[S>>2]|0}if((c|0)==(Q|0)){r=T;return}if(c|0)ggb(c);k[S>>2]=Q;k[R>>2]=136;r=T;return}function ama(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86076;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function bma(a){a=a|0;ama(a);ggb(a);return}function cma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0;S=r;r=r+1264|0;R=S+192|0;M=S+128|0;N=S+64|0;O=S;J=((k[a+4>>2]|0)>>>3&511)+1|0;K=a+140|0;h=(k[K>>2]|0)+15&-16;L=a+148|0;i=k[L>>2]|0;e=aa(h,i)|0;P=R+8|0;k[R>>2]=P;Q=R+4|0;k[Q>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[R>>2]=c}else c=P;k[Q>>2]=e;d=M;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=N;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((i|0)>0){zpb(O|0,-1,i<<2|0)|0;d=0;do{I=c+((aa(d,h)|0)<<2)|0;k[N+(d<<2)>>2]=I;d=d+1|0}while((d|0)!=(i|0))}d=k[b>>2]|0;I=b+4|0;if((d|0)<(k[I>>2]|0)){v=(k[a+128>>2]|0)+((aa(d,i)|0)<<2)|0;A=a+120|0;B=a+116|0;C=a+124|0;D=a+156|0;E=a+76|0;F=a+108|0;G=a+136|0;H=a+20|0;z=a+48|0;w=h<<2;x=k[N>>2]|0;y=k[N+4>>2]|0;c=i;while(1){a:do if((c|0)>0){i=(k[(k[A>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;j=c;e=0;b=c;h=0;while(1){c=i+h|0;a=k[G>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(h|0)?h:e;b:do if((c|0)<(b|0)){while(1){if((a|0)==(k[O+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break b}if((c|0)>(h|0)){upb(k[N+(h<<2)>>2]|0,k[N+(c<<2)>>2]|0,w|0)|0;b=k[L>>2]|0}}while(0);j=(h|0)<(j|0)&(c|0)==(b|0)?h:j;u=(k[H>>2]|0)+(aa(k[k[z>>2]>>2]|0,a)|0)|0;k[M+(h<<2)>>2]=u;k[O+(h<<2)>>2]=a;h=h+1|0;if((h|0)>=(b|0))break;else e=c}if((b|0)>(j|0)){t=M+(j<<2)|0;u=N+(j<<2)|0;s=b-j|0;p=k[B>>2]|0;m=k[C>>2]|0;q=k[K>>2]|0;n=k[D>>2]|0;c:do if((s|0)<2)c=0;else{c=s+-1|0;e=k[t>>2]|0;h=k[u>>2]|0;if((n|0)<=0){l=(q|0)>0;j=0;while(1){j=j+1|0;a=e;e=k[t+(j<<2)>>2]|0;i=h;h=k[u+(j<<2)>>2]|0;if(l){b=0;do{T=k[p+(b<<2)>>2]|0;k[i+(b<<2)>>2]=k[a+(T<<2)>>2];k[h+(b<<2)>>2]=k[e+(T<<2)>>2];b=b+1|0}while((b|0)!=(q|0))}if((j|0)==(c|0))break c}}l=(n|0)<(q|0);j=0;do{j=j+1|0;a=e;e=k[t+(j<<2)>>2]|0;i=h;h=k[u+(j<<2)>>2]|0;b=0;do{U=k[p+(b<<2)>>2]|0;T=b<<1;V=+o[m+(T<<2)>>2];f=+o[m+((T|1)<<2)>>2];T=U+J|0;g=V*+o[e+(U<<2)>>2]+f*+o[e+(T<<2)>>2];o[i+(b<<2)>>2]=V*+o[a+(U<<2)>>2]+f*+o[a+(T<<2)>>2];o[h+(b<<2)>>2]=g;b=b+1|0}while((b|0)!=(n|0));if(l){b=n;do{U=k[p+(b<<2)>>2]|0;k[i+(b<<2)>>2]=k[a+(U<<2)>>2];k[h+(b<<2)>>2]=k[e+(U<<2)>>2];b=b+1|0}while((b|0)!=(q|0))}}while((j|0)!=(c|0))}while(0);if((c|0)<(s|0)){if((n|0)<=0){h=(q|0)>0;while(1){b=k[t+(c<<2)>>2]|0;a=k[u+(c<<2)>>2]|0;if(h){e=0;do{k[a+(e<<2)>>2]=k[b+(k[p+(e<<2)>>2]<<2)>>2];e=e+1|0}while((e|0)!=(q|0))}c=c+1|0;if((c|0)==(s|0))break a}}h=(n|0)<(q|0);do{b=k[t+(c<<2)>>2]|0;a=k[u+(c<<2)>>2]|0;e=0;do{T=k[p+(e<<2)>>2]|0;U=e<<1;o[a+(e<<2)>>2]=+o[b+(T<<2)>>2]*+o[m+(U<<2)>>2]+ +o[b+(T+J<<2)>>2]*+o[m+((U|1)<<2)>>2];e=e+1|0}while((e|0)!=(n|0));if(h){e=n;do{k[a+(e<<2)>>2]=k[b+(k[p+(e<<2)>>2]<<2)>>2];e=e+1|0}while((e|0)!=(q|0))}c=c+1|0}while((c|0)!=(s|0))}}}while(0);b=(k[E>>2]|0)+(aa(k[F>>2]|0,d)|0)|0;a=k[K>>2]|0;f=+o[v>>2];g=+o[v+4>>2];e=a+-4|0;if((a|0)<4)c=0;else{c=0;do{T=c|1;V=f*+o[x+(T<<2)>>2]+g*+o[y+(T<<2)>>2];o[b+(c<<2)>>2]=f*+o[x+(c<<2)>>2]+g*+o[y+(c<<2)>>2];o[b+(T<<2)>>2]=V;T=c|2;U=c|3;V=f*+o[x+(U<<2)>>2]+g*+o[y+(U<<2)>>2];o[b+(T<<2)>>2]=f*+o[x+(T<<2)>>2]+g*+o[y+(T<<2)>>2];o[b+(U<<2)>>2]=V;c=c+4|0}while((c|0)<=(e|0));c=a&-4}if((c|0)<(a|0))do{o[b+(c<<2)>>2]=f*+o[x+(c<<2)>>2]+g*+o[y+(c<<2)>>2];c=c+1|0}while((c|0)!=(a|0));d=d+1|0;c=k[L>>2]|0;if((d|0)>=(k[I>>2]|0))break;else v=v+(c<<2)|0}c=k[R>>2]|0}if((c|0)==(P|0)){r=S;return}if(c|0)ggb(c);k[R>>2]=P;k[Q>>2]=264;r=S;return}function dma(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86096;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function ema(a){a=a|0;dma(a);ggb(a);return}function fma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,i=0,l=0,m=0,n=0,p=0,q=0.0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;W=r;r=r+1264|0;V=W+192|0;Q=W+128|0;R=W+64|0;S=W;N=((k[a+4>>2]|0)>>>3&511)+1|0;O=a+140|0;h=(k[O>>2]|0)+15&-16;P=a+148|0;i=k[P>>2]|0;e=aa(h,i)|0;T=V+8|0;k[V>>2]=T;U=V+4|0;k[U>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[V>>2]=c}else c=T;k[U>>2]=e;d=Q;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=R;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((i|0)>0){zpb(S|0,-1,i<<2|0)|0;d=0;do{M=c+((aa(d,h)|0)<<2)|0;k[R+(d<<2)>>2]=M;d=d+1|0}while((d|0)!=(i|0))}d=k[b>>2]|0;M=b+4|0;if((d|0)<(k[M>>2]|0)){z=(k[a+128>>2]|0)+((aa(d,i)|0)<<2)|0;E=a+120|0;F=a+116|0;G=a+124|0;H=a+156|0;I=a+76|0;J=a+108|0;K=a+136|0;L=a+20|0;D=a+48|0;A=h<<2;B=k[R>>2]|0;C=k[R+4>>2]|0;c=i;while(1){a:do if((c|0)>0){i=(k[(k[E>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;l=c;e=0;b=c;h=0;while(1){c=i+h|0;a=k[K>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(h|0)?h:e;b:do if((c|0)<(b|0)){while(1){if((a|0)==(k[S+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break b}if((c|0)>(h|0)){upb(k[R+(h<<2)>>2]|0,k[R+(c<<2)>>2]|0,A|0)|0;b=k[P>>2]|0}}while(0);l=(h|0)<(l|0)&(c|0)==(b|0)?h:l;y=(k[L>>2]|0)+(aa(k[k[D>>2]>>2]|0,a)|0)|0;k[Q+(h<<2)>>2]=y;k[S+(h<<2)>>2]=a;h=h+1|0;if((h|0)>=(b|0))break;else e=c}if((b|0)>(l|0)){x=Q+(l<<2)|0;y=R+(l<<2)|0;w=b-l|0;t=k[F>>2]|0;n=k[G>>2]|0;v=k[O>>2]|0;p=k[H>>2]|0;c:do if((w|0)<2)c=0;else{c=w+-1|0;e=k[x>>2]|0;h=k[y>>2]|0;if((p|0)<=0){m=(v|0)>0;l=0;while(1){l=l+1|0;a=e;e=k[x+(l<<2)>>2]|0;i=h;h=k[y+(l<<2)>>2]|0;if(m){b=0;do{X=k[t+(b<<2)>>2]|0;o[i+(b<<2)>>2]=+(j[a+(X<<1)>>1]|0);o[h+(b<<2)>>2]=+(j[e+(X<<1)>>1]|0);b=b+1|0}while((b|0)!=(v|0))}if((l|0)==(c|0))break c}}m=(p|0)<(v|0);l=0;do{l=l+1|0;a=e;e=k[x+(l<<2)>>2]|0;i=h;h=k[y+(l<<2)>>2]|0;b=0;do{Y=k[t+(b<<2)>>2]|0;X=b<<1;g=+o[n+(X<<2)>>2];q=+o[n+((X|1)<<2)>>2];X=Y+N|0;s=g*+(j[e+(Y<<1)>>1]|0)+q*+(j[e+(X<<1)>>1]|0);o[i+(b<<2)>>2]=g*+(j[a+(Y<<1)>>1]|0)+q*+(j[a+(X<<1)>>1]|0);o[h+(b<<2)>>2]=s;b=b+1|0}while((b|0)!=(p|0));if(m){b=p;do{Y=k[t+(b<<2)>>2]|0;o[i+(b<<2)>>2]=+(j[a+(Y<<1)>>1]|0);o[h+(b<<2)>>2]=+(j[e+(Y<<1)>>1]|0);b=b+1|0}while((b|0)!=(v|0))}}while((l|0)!=(c|0))}while(0);if((c|0)<(w|0)){if((p|0)<=0){h=(v|0)>0;while(1){b=k[x+(c<<2)>>2]|0;a=k[y+(c<<2)>>2]|0;if(h){e=0;do{o[a+(e<<2)>>2]=+(j[b+(k[t+(e<<2)>>2]<<1)>>1]|0);e=e+1|0}while((e|0)!=(v|0))}c=c+1|0;if((c|0)==(w|0))break a}}h=(p|0)<(v|0);do{b=k[x+(c<<2)>>2]|0;a=k[y+(c<<2)>>2]|0;e=0;do{X=k[t+(e<<2)>>2]|0;Y=e<<1;o[a+(e<<2)>>2]=+(j[b+(X<<1)>>1]|0)*+o[n+(Y<<2)>>2]+ +(j[b+(X+N<<1)>>1]|0)*+o[n+((Y|1)<<2)>>2];e=e+1|0}while((e|0)!=(p|0));if(h){e=p;do{o[a+(e<<2)>>2]=+(j[b+(k[t+(e<<2)>>2]<<1)>>1]|0);e=e+1|0}while((e|0)!=(v|0))}c=c+1|0}while((c|0)!=(w|0))}}}while(0);i=(k[I>>2]|0)+(aa(k[J>>2]|0,d)|0)|0;l=k[O>>2]|0;q=+o[z>>2];s=+o[z+4>>2];h=l+-4|0;if((l|0)<4)c=0;else{a=0;do{g=q*+o[B+(a<<2)>>2]+s*+o[C+(a<<2)>>2];e=a|1;f=q*+o[B+(e<<2)>>2]+s*+o[C+(e<<2)>>2];c=(o[u>>2]=g,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;g=c?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=c?-0.0:0.0}c=~~g;j[i+(a<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;c=(o[u>>2]=f,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;f=c?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=c?-0.0:0.0}b=~~f;j[i+(e<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;e=a|2;g=q*+o[B+(e<<2)>>2]+s*+o[C+(e<<2)>>2];b=a|3;f=q*+o[B+(b<<2)>>2]+s*+o[C+(b<<2)>>2];c=(o[u>>2]=g,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;g=c?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=c?-0.0:0.0}c=~~g;j[i+(e<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;c=(o[u>>2]=f,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;f=c?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=c?-0.0:0.0}Y=~~f;j[i+(b<<1)>>1]=(Y+32768|0)>>>0<65536?Y:(Y|0)>0?32767:32768;a=a+4|0}while((a|0)<=(h|0));c=l&-4}if((c|0)<(l|0))do{f=q*+o[B+(c<<2)>>2]+s*+o[C+(c<<2)>>2];e=(o[u>>2]=f,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;f=e?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=e?-0.0:0.0}Y=~~f;j[i+(c<<1)>>1]=(Y+32768|0)>>>0<65536?Y:(Y|0)>0?32767:32768;c=c+1|0}while((c|0)!=(l|0));d=d+1|0;c=k[P>>2]|0;if((d|0)>=(k[M>>2]|0))break;else z=z+(c<<2)|0}c=k[V>>2]|0}if((c|0)==(T|0)){r=W;return}if(c|0)ggb(c);k[V>>2]=T;k[U>>2]=264;r=W;return}function gma(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86116;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function hma(a){a=a|0;gma(a);ggb(a);return}function ima(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,i=0,l=0,n=0,p=0,q=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;X=r;r=r+1264|0;W=X+192|0;R=X+128|0;S=X+64|0;T=X;O=((k[a+4>>2]|0)>>>3&511)+1|0;P=a+140|0;h=(k[P>>2]|0)+15&-16;Q=a+148|0;i=k[Q>>2]|0;e=aa(h,i)|0;U=W+8|0;k[W>>2]=U;V=W+4|0;k[V>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[W>>2]=c}else c=U;k[V>>2]=e;d=R;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=S;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((i|0)>0){zpb(T|0,-1,i<<2|0)|0;d=0;do{N=c+((aa(d,h)|0)<<2)|0;k[S+(d<<2)>>2]=N;d=d+1|0}while((d|0)!=(i|0))}d=k[b>>2]|0;N=b+4|0;if((d|0)<(k[N>>2]|0)){A=(k[a+128>>2]|0)+((aa(d,i)|0)<<2)|0;F=a+120|0;G=a+116|0;H=a+124|0;I=a+156|0;J=a+76|0;K=a+108|0;L=a+136|0;M=a+20|0;E=a+48|0;B=h<<2;C=k[S>>2]|0;D=k[S+4>>2]|0;c=i;while(1){a:do if((c|0)>0){i=(k[(k[F>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;l=c;e=0;b=c;h=0;while(1){c=i+h|0;a=k[L>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(h|0)?h:e;b:do if((c|0)<(b|0)){while(1){if((a|0)==(k[T+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break b}if((c|0)>(h|0)){upb(k[S+(h<<2)>>2]|0,k[S+(c<<2)>>2]|0,B|0)|0;b=k[Q>>2]|0}}while(0);l=(h|0)<(l|0)&(c|0)==(b|0)?h:l;z=(k[M>>2]|0)+(aa(k[k[E>>2]>>2]|0,a)|0)|0;k[R+(h<<2)>>2]=z;k[T+(h<<2)>>2]=a;h=h+1|0;if((h|0)>=(b|0))break;else e=c}if((b|0)>(l|0)){y=R+(l<<2)|0;z=S+(l<<2)|0;x=b-l|0;v=k[G>>2]|0;p=k[H>>2]|0;w=k[P>>2]|0;q=k[I>>2]|0;c:do if((x|0)<2)c=0;else{c=x+-1|0;e=k[y>>2]|0;h=k[z>>2]|0;if((q|0)<=0){n=(w|0)>0;l=0;while(1){l=l+1|0;a=e;e=k[y+(l<<2)>>2]|0;i=h;h=k[z+(l<<2)>>2]|0;if(n){b=0;do{Y=k[v+(b<<2)>>2]|0;o[i+(b<<2)>>2]=+(m[a+(Y<<1)>>1]|0);o[h+(b<<2)>>2]=+(m[e+(Y<<1)>>1]|0);b=b+1|0}while((b|0)!=(w|0))}if((l|0)==(c|0))break c}}n=(q|0)<(w|0);l=0;do{l=l+1|0;a=e;e=k[y+(l<<2)>>2]|0;i=h;h=k[z+(l<<2)>>2]|0;b=0;do{Z=k[v+(b<<2)>>2]|0;Y=b<<1;g=+o[p+(Y<<2)>>2];s=+o[p+((Y|1)<<2)>>2];Y=Z+O|0;t=g*+(m[e+(Z<<1)>>1]|0)+s*+(m[e+(Y<<1)>>1]|0);o[i+(b<<2)>>2]=g*+(m[a+(Z<<1)>>1]|0)+s*+(m[a+(Y<<1)>>1]|0);o[h+(b<<2)>>2]=t;b=b+1|0}while((b|0)!=(q|0));if(n){b=q;do{Z=k[v+(b<<2)>>2]|0;o[i+(b<<2)>>2]=+(m[a+(Z<<1)>>1]|0);o[h+(b<<2)>>2]=+(m[e+(Z<<1)>>1]|0);b=b+1|0}while((b|0)!=(w|0))}}while((l|0)!=(c|0))}while(0);if((c|0)<(x|0)){if((q|0)<=0){h=(w|0)>0;while(1){b=k[y+(c<<2)>>2]|0;a=k[z+(c<<2)>>2]|0;if(h){e=0;do{o[a+(e<<2)>>2]=+(m[b+(k[v+(e<<2)>>2]<<1)>>1]|0);e=e+1|0}while((e|0)!=(w|0))}c=c+1|0;if((c|0)==(x|0))break a}}h=(q|0)<(w|0);do{b=k[y+(c<<2)>>2]|0;a=k[z+(c<<2)>>2]|0;e=0;do{Y=k[v+(e<<2)>>2]|0;Z=e<<1;o[a+(e<<2)>>2]=+(m[b+(Y<<1)>>1]|0)*+o[p+(Z<<2)>>2]+ +(m[b+(Y+O<<1)>>1]|0)*+o[p+((Z|1)<<2)>>2];e=e+1|0}while((e|0)!=(q|0));if(h){e=q;do{o[a+(e<<2)>>2]=+(m[b+(k[v+(e<<2)>>2]<<1)>>1]|0);e=e+1|0}while((e|0)!=(w|0))}c=c+1|0}while((c|0)!=(x|0))}}}while(0);i=(k[J>>2]|0)+(aa(k[K>>2]|0,d)|0)|0;l=k[P>>2]|0;s=+o[A>>2];t=+o[A+4>>2];h=l+-4|0;if((l|0)<4)c=0;else{a=0;do{g=s*+o[C+(a<<2)>>2]+t*+o[D+(a<<2)>>2];e=a|1;f=s*+o[C+(e<<2)>>2]+t*+o[D+(e<<2)>>2];c=(o[u>>2]=g,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;g=c?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=c?-0.0:0.0}c=~~g;j[i+(a<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;c=(o[u>>2]=f,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;f=c?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=c?-0.0:0.0}b=~~f;j[i+(e<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;e=a|2;g=s*+o[C+(e<<2)>>2]+t*+o[D+(e<<2)>>2];b=a|3;f=s*+o[C+(b<<2)>>2]+t*+o[D+(b<<2)>>2];c=(o[u>>2]=g,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;g=c?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=c?-0.0:0.0}c=~~g;j[i+(e<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;c=(o[u>>2]=f,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;f=c?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=c?-0.0:0.0}Z=~~f;j[i+(b<<1)>>1]=Z>>>0<65536?Z:(Z|0)>0?65535:0;a=a+4|0}while((a|0)<=(h|0));c=l&-4}if((c|0)<(l|0))do{f=s*+o[C+(c<<2)>>2]+t*+o[D+(c<<2)>>2];e=(o[u>>2]=f,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;f=e?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=e?-0.0:0.0}Z=~~f;j[i+(c<<1)>>1]=Z>>>0<65536?Z:(Z|0)>0?65535:0;c=c+1|0}while((c|0)!=(l|0));d=d+1|0;c=k[Q>>2]|0;if((d|0)>=(k[N>>2]|0))break;else A=A+(c<<2)|0}c=k[W>>2]|0}if((c|0)==(U|0)){r=X;return}if(c|0)ggb(c);k[W>>2]=U;k[V>>2]=264;r=X;return}function jma(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86136;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function kma(a){a=a|0;jma(a);ggb(a);return}function lma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;S=r;r=r+1264|0;R=S+192|0;M=S+128|0;N=S+64|0;O=S;J=((k[a+4>>2]|0)>>>3&511)+1|0;K=a+140|0;f=(k[K>>2]|0)+15&-16;L=a+148|0;g=k[L>>2]|0;e=aa(f,g)|0;P=R+8|0;k[R>>2]=P;Q=R+4|0;k[Q>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[R>>2]=c}else c=P;k[Q>>2]=e;d=M;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=N;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((g|0)>0){zpb(O|0,-1,g<<2|0)|0;d=0;do{I=c+((aa(d,f)|0)<<2)|0;k[N+(d<<2)>>2]=I;d=d+1|0}while((d|0)!=(g|0))}d=k[b>>2]|0;I=b+4|0;if((d|0)<(k[I>>2]|0)){v=(k[a+128>>2]|0)+((aa(d,g)|0)<<1)|0;A=a+120|0;B=a+116|0;C=a+124|0;D=a+156|0;E=a+76|0;F=a+108|0;G=a+136|0;H=a+20|0;z=a+48|0;w=f<<2;x=k[N>>2]|0;y=k[N+4>>2]|0;c=g;while(1){a:do if((c|0)>0){g=(k[(k[A>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;h=c;e=0;b=c;f=0;while(1){c=g+f|0;a=k[G>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(f|0)?f:e;b:do if((c|0)<(b|0)){while(1){if((a|0)==(k[O+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break b}if((c|0)>(f|0)){upb(k[N+(f<<2)>>2]|0,k[N+(c<<2)>>2]|0,w|0)|0;b=k[L>>2]|0}}while(0);h=(f|0)<(h|0)&(c|0)==(b|0)?f:h;u=(k[H>>2]|0)+(aa(k[k[z>>2]>>2]|0,a)|0)|0;k[M+(f<<2)>>2]=u;k[O+(f<<2)>>2]=a;f=f+1|0;if((f|0)>=(b|0))break;else e=c}if((b|0)>(h|0)){t=M+(h<<2)|0;u=N+(h<<2)|0;s=b-h|0;p=k[B>>2]|0;n=k[C>>2]|0;q=k[K>>2]|0;o=k[D>>2]|0;c:do if((s|0)<2)c=0;else{c=s+-1|0;e=k[t>>2]|0;f=k[u>>2]|0;if((o|0)<=0){m=(q|0)>0;h=0;while(1){h=h+1|0;a=e;e=k[t+(h<<2)>>2]|0;g=f;f=k[u+(h<<2)>>2]|0;if(m){b=0;do{T=k[p+(b<<2)>>2]|0;k[g+(b<<2)>>2]=l[a+T>>0]<<11;k[f+(b<<2)>>2]=l[e+T>>0]<<11;b=b+1|0}while((b|0)!=(q|0))}if((h|0)==(c|0))break c}}m=(o|0)<(q|0);h=0;do{h=h+1|0;a=e;e=k[t+(h<<2)>>2]|0;g=f;f=k[u+(h<<2)>>2]|0;b=0;do{X=k[p+(b<<2)>>2]|0;V=b<<1;T=j[n+(V<<1)>>1]|0;V=j[n+((V|1)<<1)>>1]|0;U=aa(l[a+X>>0]|0,T)|0;W=X+J|0;U=(aa(l[a+W>>0]|0,V)|0)+U|0;T=aa(l[e+X>>0]|0,T)|0;T=(aa(l[e+W>>0]|0,V)|0)+T|0;k[g+(b<<2)>>2]=U;k[f+(b<<2)>>2]=T;b=b+1|0}while((b|0)!=(o|0));if(m){b=o;do{X=k[p+(b<<2)>>2]|0;k[g+(b<<2)>>2]=l[a+X>>0]<<11;k[f+(b<<2)>>2]=l[e+X>>0]<<11;b=b+1|0}while((b|0)!=(q|0))}}while((h|0)!=(c|0))}while(0);if((c|0)<(s|0)){if((o|0)<=0){f=(q|0)>0;while(1){b=k[t+(c<<2)>>2]|0;a=k[u+(c<<2)>>2]|0;if(f){e=0;do{k[a+(e<<2)>>2]=l[b+(k[p+(e<<2)>>2]|0)>>0]<<11;e=e+1|0}while((e|0)!=(q|0))}c=c+1|0;if((c|0)==(s|0))break a}}f=(o|0)<(q|0);do{b=k[t+(c<<2)>>2]|0;a=k[u+(c<<2)>>2]|0;e=0;do{W=k[p+(e<<2)>>2]|0;V=e<<1;X=aa(j[n+(V<<1)>>1]|0,l[b+W>>0]|0)|0;X=(aa(j[n+((V|1)<<1)>>1]|0,l[b+(W+J)>>0]|0)|0)+X|0;k[a+(e<<2)>>2]=X;e=e+1|0}while((e|0)!=(o|0));if(f){e=o;do{k[a+(e<<2)>>2]=l[b+(k[p+(e<<2)>>2]|0)>>0]<<11;e=e+1|0}while((e|0)!=(q|0))}c=c+1|0}while((c|0)!=(s|0))}}}while(0);h=(k[E>>2]|0)+(aa(k[F>>2]|0,d)|0)|0;m=k[K>>2]|0;f=j[v>>1]|0;g=j[v+2>>1]|0;e=m+-4|0;if((m|0)<4)c=0;else{b=f<<16>>16;a=g<<16>>16;c=0;do{X=(aa(k[x+(c<<2)>>2]>>4,b)|0)>>>16;X=(X+2+((aa(k[y+(c<<2)>>2]>>4,a)|0)>>>16)|0)>>>2&255;i[h+c>>0]=X;X=c|1;W=(aa(k[x+(X<<2)>>2]>>4,b)|0)>>>16;W=(W+2+((aa(k[y+(X<<2)>>2]>>4,a)|0)>>>16)|0)>>>2&255;i[h+X>>0]=W;X=c|2;W=(aa(k[x+(X<<2)>>2]>>4,b)|0)>>>16;W=(W+2+((aa(k[y+(X<<2)>>2]>>4,a)|0)>>>16)|0)>>>2&255;i[h+X>>0]=W;X=c|3;W=(aa(k[x+(X<<2)>>2]>>4,b)|0)>>>16;W=(W+2+((aa(k[y+(X<<2)>>2]>>4,a)|0)>>>16)|0)>>>2&255;i[h+X>>0]=W;c=c+4|0}while((c|0)<=(e|0));c=m&-4}if((c|0)<(m|0)){b=f<<16>>16;e=g<<16>>16;do{X=(aa(k[x+(c<<2)>>2]>>4,b)|0)>>>16;X=(X+2+((aa(k[y+(c<<2)>>2]>>4,e)|0)>>>16)|0)>>>2&255;i[h+c>>0]=X;c=c+1|0}while((c|0)!=(m|0))}d=d+1|0;c=k[L>>2]|0;if((d|0)>=(k[I>>2]|0))break;else v=v+(c<<1)|0}c=k[R>>2]|0}if((c|0)==(P|0)){r=S;return}if(c|0)ggb(c);k[R>>2]=P;k[Q>>2]=264;r=S;return}function mma(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86236;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Dma(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Dma(A);r=C;return}function nma(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86216;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Ama(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Ama(A);r=C;return}function oma(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86196;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);xma(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);xma(A);r=C;return}function pma(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86176;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);uma(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);uma(A);r=C;return}function qma(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86156;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);rma(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);rma(A);r=C;return}function rma(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86156;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function sma(a){a=a|0;rma(a);ggb(a);return}function tma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0.0,i=0.0,j=0.0,l=0.0,m=0.0,n=0.0,q=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0.0;pa=r;r=r+1296|0;oa=pa;ja=pa+1224|0;ka=pa+1160|0;la=pa+1096|0;ga=((k[a+4>>2]|0)>>>3&511)+1|0;ha=a+140|0;f=(k[ha>>2]|0)+15&-16;ia=a+148|0;s=k[ia>>2]|0;e=aa(f,s)|0;ma=oa+8|0;k[oa>>2]=ma;na=oa+4|0;k[na>>2]=136;if(e>>>0>136){d=e>>>0>536870911?-1:e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[oa>>2]=c}else c=ma;k[na>>2]=e;d=ja;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=ka;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((s|0)>0){zpb(la|0,-1,s<<2|0)|0;d=0;do{fa=c+((aa(d,f)|0)<<3)|0;k[ka+(d<<2)>>2]=fa;d=d+1|0}while((d|0)!=(s|0))}d=k[b>>2]|0;fa=b+4|0;if((d|0)<(k[fa>>2]|0)){I=(k[a+128>>2]|0)+((aa(d,s)|0)<<2)|0;W=a+120|0;X=a+116|0;Y=a+124|0;Z=a+132|0;_=a+152|0;$=a+156|0;ba=a+76|0;ca=a+108|0;da=a+136|0;ea=a+20|0;V=a+48|0;J=f<<3;K=ga*3|0;L=ga<<1;M=ga<<2;N=k[ka>>2]|0;O=k[ka+4>>2]|0;P=k[ka+8>>2]|0;Q=k[ka+12>>2]|0;R=k[ka+16>>2]|0;S=k[ka+20>>2]|0;T=k[ka+24>>2]|0;U=k[ka+28>>2]|0;c=s;while(1){if((c|0)>0){s=(k[(k[W>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;t=c;e=0;b=c;f=0;while(1){c=s+f|0;a=k[da>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(f|0)?f:e;a:do if((c|0)<(b|0)){while(1){if((a|0)==(k[la+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break a}if((c|0)>(f|0)){upb(k[ka+(f<<2)>>2]|0,k[ka+(c<<2)>>2]|0,J|0)|0;b=k[ia>>2]|0}}while(0);t=(f|0)<(t|0)&(c|0)==(b|0)?f:t;H=(k[ea>>2]|0)+(aa(k[k[V>>2]>>2]|0,a)|0)|0;k[ja+(f<<2)>>2]=H;k[la+(f<<2)>>2]=a;f=f+1|0;if((f|0)>=(b|0))break;else e=c}if((b|0)>(t|0)){G=ja+(t<<2)|0;H=ka+(t<<2)|0;A=b-t|0;B=k[X>>2]|0;C=k[Z>>2]|0;D=k[ha>>2]|0;E=k[_>>2]|0;F=k[$>>2]|0;if((A|0)>0){w=0-(D<<3)|0;x=F<<3;v=0;c=k[Y>>2]|0;while(1){y=k[G+(v<<2)>>2]|0;z=k[H+(v<<2)>>2]|0;u=E;e=0;while(1){if((u|0)>(e|0)){t=u-e|0;f=c;while(1){s=k[B+(e<<2)>>2]|0;g=0.0;a=0;do{b=(aa(a+-3|0,ga)|0)+s|0;if(b>>>0>=C>>>0){while(1)if((b|0)<0)b=b+ga|0;else break;while(1)if((b|0)<(C|0))break;else b=b-ga|0}g=g+ +p[y+(b<<3)>>3]*+o[f+(a<<2)>>2];a=a+1|0}while((a|0)!=8);p[z+(e<<3)>>3]=g;e=e+1|0;if((e|0)==(u|0))break;else f=f+32|0}e=u;c=c+(t<<3<<2)|0}if((u|0)==(D|0))break;if((e|0)>=(F|0)){u=D;continue}a=aa(e,-8)|0;b=c;while(1){u=k[B+(e<<2)>>2]|0;p[z+(e<<3)>>3]=+p[y+(u-K<<3)>>3]*+o[b>>2]+ +p[y+(u-L<<3)>>3]*+o[b+4>>2]+ +p[y+(u-ga<<3)>>3]*+o[b+8>>2]+ +p[y+(u<<3)>>3]*+o[b+12>>2]+ +p[y+(u+ga<<3)>>3]*+o[b+16>>2]+ +p[y+(u+L<<3)>>3]*+o[b+20>>2]+ +p[y+(u+K<<3)>>3]*+o[b+24>>2]+ +p[y+(u+M<<3)>>3]*+o[b+28>>2];e=e+1|0;if((e|0)>=(F|0))break;else b=b+32|0}u=D;e=F;c=c+(x<<2)+(a<<2)|0}v=v+1|0;if((v|0)==(A|0)){u=39;break}else c=c+(w<<2)|0}}else a=D}else u=39}else u=39;if((u|0)==39){u=0;a=k[ha>>2]|0}b=(k[ba>>2]|0)+(aa(k[ca>>2]|0,d)|0)|0;e=a+-4|0;if((a|0)<4)c=0;else{g=+o[I>>2];h=+o[I+4>>2];i=+o[I+8>>2];j=+o[I+12>>2];l=+o[I+16>>2];m=+o[I+20>>2];n=+o[I+24>>2];q=+o[I+28>>2];c=0;do{F=c|1;G=c|2;H=c|3;sa=g*+p[N+(F<<3)>>3]+h*+p[O+(F<<3)>>3]+i*+p[P+(F<<3)>>3]+j*+p[Q+(F<<3)>>3]+l*+p[R+(F<<3)>>3]+m*+p[S+(F<<3)>>3]+n*+p[T+(F<<3)>>3]+q*+p[U+(F<<3)>>3];ra=g*+p[N+(G<<3)>>3]+h*+p[O+(G<<3)>>3]+i*+p[P+(G<<3)>>3]+j*+p[Q+(G<<3)>>3]+l*+p[R+(G<<3)>>3]+m*+p[S+(G<<3)>>3]+n*+p[T+(G<<3)>>3]+q*+p[U+(G<<3)>>3];qa=g*+p[N+(H<<3)>>3]+h*+p[O+(H<<3)>>3]+i*+p[P+(H<<3)>>3]+j*+p[Q+(H<<3)>>3]+l*+p[R+(H<<3)>>3]+m*+p[S+(H<<3)>>3]+n*+p[T+(H<<3)>>3]+q*+p[U+(H<<3)>>3];p[b+(c<<3)>>3]=g*+p[N+(c<<3)>>3]+h*+p[O+(c<<3)>>3]+i*+p[P+(c<<3)>>3]+j*+p[Q+(c<<3)>>3]+l*+p[R+(c<<3)>>3]+m*+p[S+(c<<3)>>3]+n*+p[T+(c<<3)>>3]+q*+p[U+(c<<3)>>3];p[b+(F<<3)>>3]=sa;p[b+(G<<3)>>3]=ra;p[b+(H<<3)>>3]=qa;c=c+4|0}while((c|0)<=(e|0));c=a&-4}if((c|0)<(a|0)){g=+o[I>>2];h=+o[I+4>>2];i=+o[I+8>>2];j=+o[I+12>>2];l=+o[I+16>>2];m=+o[I+20>>2];n=+o[I+24>>2];q=+o[I+28>>2];do{p[b+(c<<3)>>3]=+p[N+(c<<3)>>3]*g+ +p[O+(c<<3)>>3]*h+ +p[P+(c<<3)>>3]*i+ +p[Q+(c<<3)>>3]*j+ +p[R+(c<<3)>>3]*l+ +p[S+(c<<3)>>3]*m+ +p[T+(c<<3)>>3]*n+ +p[U+(c<<3)>>3]*q;c=c+1|0}while((c|0)!=(a|0))}d=d+1|0;c=k[ia>>2]|0;if((d|0)>=(k[fa>>2]|0))break;else I=I+(c<<2)|0}c=k[oa>>2]|0}if((c|0)==(ma|0)){r=pa;return}if(c|0)ggb(c);k[oa>>2]=ma;k[na>>2]=136;r=pa;return}function uma(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86176;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function vma(a){a=a|0;uma(a);ggb(a);return}function wma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0.0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0;ha=r;r=r+1264|0;ga=ha+192|0;ba=ha+128|0;ca=ha+64|0;da=ha;Z=((k[a+4>>2]|0)>>>3&511)+1|0;_=a+140|0;f=(k[_>>2]|0)+15&-16;$=a+148|0;g=k[$>>2]|0;e=aa(f,g)|0;ea=ga+8|0;k[ga>>2]=ea;fa=ga+4|0;k[fa>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[ga>>2]=c}else c=ea;k[fa>>2]=e;d=ba;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=ca;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((g|0)>0){zpb(da|0,-1,g<<2|0)|0;d=0;do{Y=c+((aa(d,f)|0)<<2)|0;k[ca+(d<<2)>>2]=Y;d=d+1|0}while((d|0)!=(g|0))}d=k[b>>2]|0;Y=b+4|0;if((d|0)<(k[Y>>2]|0)){A=(k[a+128>>2]|0)+((aa(d,g)|0)<<2)|0;O=a+120|0;P=a+116|0;Q=a+124|0;R=a+132|0;S=a+152|0;T=a+156|0;U=a+76|0;V=a+108|0;W=a+136|0;X=a+20|0;N=a+48|0;B=f<<2;C=Z*3|0;D=Z<<1;E=Z<<2;F=k[ca>>2]|0;G=k[ca+4>>2]|0;H=k[ca+8>>2]|0;I=k[ca+12>>2]|0;J=k[ca+16>>2]|0;K=k[ca+20>>2]|0;L=k[ca+24>>2]|0;M=k[ca+28>>2]|0;c=g;while(1){if((c|0)>0){g=(k[(k[O>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;h=c;e=0;b=c;f=0;while(1){c=g+f|0;a=k[W>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(f|0)?f:e;a:do if((c|0)<(b|0)){while(1){if((a|0)==(k[da+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break a}if((c|0)>(f|0)){upb(k[ca+(f<<2)>>2]|0,k[ca+(c<<2)>>2]|0,B|0)|0;b=k[$>>2]|0}}while(0);h=(f|0)<(h|0)&(c|0)==(b|0)?f:h;z=(k[X>>2]|0)+(aa(k[k[N>>2]>>2]|0,a)|0)|0;k[ba+(f<<2)>>2]=z;k[da+(f<<2)>>2]=a;f=f+1|0;if((f|0)>=(b|0))break;else e=c}if((b|0)>(h|0)){y=ba+(h<<2)|0;z=ca+(h<<2)|0;t=b-h|0;u=k[P>>2]|0;v=k[R>>2]|0;m=k[_>>2]|0;w=k[S>>2]|0;x=k[T>>2]|0;if((t|0)>0){l=0-(m<<3)|0;p=x<<3;j=0;c=k[Q>>2]|0;while(1){q=k[y+(j<<2)>>2]|0;s=k[z+(j<<2)>>2]|0;i=w;e=0;while(1){if((i|0)>(e|0)){h=i-e|0;f=c;while(1){g=k[u+(e<<2)>>2]|0;n=0.0;a=0;do{b=(aa(a+-3|0,Z)|0)+g|0;if(b>>>0>=v>>>0){while(1)if((b|0)<0)b=b+Z|0;else break;while(1)if((b|0)<(v|0))break;else b=b-Z|0}n=n+ +o[q+(b<<2)>>2]*+o[f+(a<<2)>>2];a=a+1|0}while((a|0)!=8);o[s+(e<<2)>>2]=n;e=e+1|0;if((e|0)==(i|0))break;else f=f+32|0}e=i;c=c+(h<<3<<2)|0}if((i|0)==(m|0))break;if((e|0)>=(x|0)){i=m;continue}a=aa(e,-8)|0;b=c;while(1){i=k[u+(e<<2)>>2]|0;o[s+(e<<2)>>2]=+o[q+(i-C<<2)>>2]*+o[b>>2]+ +o[q+(i-D<<2)>>2]*+o[b+4>>2]+ +o[q+(i-Z<<2)>>2]*+o[b+8>>2]+ +o[q+(i<<2)>>2]*+o[b+12>>2]+ +o[q+(i+Z<<2)>>2]*+o[b+16>>2]+ +o[q+(i+D<<2)>>2]*+o[b+20>>2]+ +o[q+(i+C<<2)>>2]*+o[b+24>>2]+ +o[q+(i+E<<2)>>2]*+o[b+28>>2];e=e+1|0;if((e|0)>=(x|0))break;else b=b+32|0}i=m;e=x;c=c+(p<<2)+(a<<2)|0}j=j+1|0;if((j|0)==(t|0)){p=39;break}else c=c+(l<<2)|0}}}else p=39}else p=39;if((p|0)==39){p=0;m=k[_>>2]|0}l=(k[U>>2]|0)+(aa(k[V>>2]|0,d)|0)|0;e=m+-4|0;if((m|0)<4)c=0;else{b=A+4|0;a=A+8|0;f=A+12|0;g=A+16|0;h=A+20|0;i=A+24|0;j=A+28|0;c=0;do{ra=+o[A>>2];x=c|1;y=c|2;z=c|3;qa=+o[b>>2];pa=+o[a>>2];oa=+o[f>>2];na=+o[g>>2];ma=+o[h>>2];la=+o[i>>2];ka=+o[j>>2];ja=ra*+o[F+(x<<2)>>2]+qa*+o[G+(x<<2)>>2]+pa*+o[H+(x<<2)>>2]+oa*+o[I+(x<<2)>>2]+na*+o[J+(x<<2)>>2]+ma*+o[K+(x<<2)>>2]+la*+o[L+(x<<2)>>2]+ka*+o[M+(x<<2)>>2];ia=ra*+o[F+(y<<2)>>2]+qa*+o[G+(y<<2)>>2]+pa*+o[H+(y<<2)>>2]+oa*+o[I+(y<<2)>>2]+na*+o[J+(y<<2)>>2]+ma*+o[K+(y<<2)>>2]+la*+o[L+(y<<2)>>2]+ka*+o[M+(y<<2)>>2];n=ra*+o[F+(z<<2)>>2]+qa*+o[G+(z<<2)>>2]+pa*+o[H+(z<<2)>>2]+oa*+o[I+(z<<2)>>2]+na*+o[J+(z<<2)>>2]+ma*+o[K+(z<<2)>>2]+la*+o[L+(z<<2)>>2]+ka*+o[M+(z<<2)>>2];o[l+(c<<2)>>2]=ra*+o[F+(c<<2)>>2]+qa*+o[G+(c<<2)>>2]+pa*+o[H+(c<<2)>>2]+oa*+o[I+(c<<2)>>2]+na*+o[J+(c<<2)>>2]+ma*+o[K+(c<<2)>>2]+la*+o[L+(c<<2)>>2]+ka*+o[M+(c<<2)>>2];o[l+(x<<2)>>2]=ja;o[l+(y<<2)>>2]=ia;o[l+(z<<2)>>2]=n;c=c+4|0}while((c|0)<=(e|0));c=m&-4}if((c|0)<(m|0)){e=A+4|0;b=A+8|0;a=A+12|0;f=A+16|0;g=A+20|0;h=A+24|0;i=A+28|0;do{o[l+(c<<2)>>2]=+o[F+(c<<2)>>2]*+o[A>>2]+ +o[G+(c<<2)>>2]*+o[e>>2]+ +o[H+(c<<2)>>2]*+o[b>>2]+ +o[I+(c<<2)>>2]*+o[a>>2]+ +o[J+(c<<2)>>2]*+o[f>>2]+ +o[K+(c<<2)>>2]*+o[g>>2]+ +o[L+(c<<2)>>2]*+o[h>>2]+ +o[M+(c<<2)>>2]*+o[i>>2];c=c+1|0}while((c|0)!=(m|0))}d=d+1|0;c=k[$>>2]|0;if((d|0)>=(k[Y>>2]|0))break;else A=A+(c<<2)|0}c=k[ga>>2]|0}if((c|0)==(ea|0)){r=ha;return}if(c|0)ggb(c);k[ga>>2]=ea;k[fa>>2]=264;r=ha;return}function xma(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86196;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function yma(a){a=a|0;xma(a);ggb(a);return}function zma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0,i=0,l=0.0,m=0.0,n=0.0,p=0.0,q=0.0,s=0.0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;ua=r;r=r+1264|0;ta=ua+192|0;oa=ua+128|0;pa=ua+64|0;qa=ua;la=((k[a+4>>2]|0)>>>3&511)+1|0;ma=a+140|0;f=(k[ma>>2]|0)+15&-16;na=a+148|0;h=k[na>>2]|0;e=aa(f,h)|0;ra=ta+8|0;k[ta>>2]=ra;sa=ta+4|0;k[sa>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[ta>>2]=c}else c=ra;k[sa>>2]=e;d=oa;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=pa;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((h|0)>0){zpb(qa|0,-1,h<<2|0)|0;d=0;do{ka=c+((aa(d,f)|0)<<2)|0;k[pa+(d<<2)>>2]=ka;d=d+1|0}while((d|0)!=(h|0))}d=k[b>>2]|0;ka=b+4|0;if((d|0)<(k[ka>>2]|0)){N=(k[a+128>>2]|0)+((aa(d,h)|0)<<2)|0;$=a+120|0;ba=a+116|0;ca=a+124|0;da=a+132|0;ea=a+152|0;fa=a+156|0;ga=a+76|0;ha=a+108|0;ia=a+136|0;ja=a+20|0;_=a+48|0;O=f<<2;P=la*3|0;Q=la<<1;R=la<<2;S=k[pa>>2]|0;T=k[pa+4>>2]|0;U=k[pa+8>>2]|0;V=k[pa+12>>2]|0;W=k[pa+16>>2]|0;X=k[pa+20>>2]|0;Y=k[pa+24>>2]|0;Z=k[pa+28>>2]|0;c=h;while(1){if((c|0)>0){h=(k[(k[$>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;i=c;e=0;b=c;f=0;while(1){c=h+f|0;a=k[ia>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(f|0)?f:e;a:do if((c|0)<(b|0)){while(1){if((a|0)==(k[qa+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break a}if((c|0)>(f|0)){upb(k[pa+(f<<2)>>2]|0,k[pa+(c<<2)>>2]|0,O|0)|0;b=k[na>>2]|0}}while(0);i=(f|0)<(i|0)&(c|0)==(b|0)?f:i;J=(k[ja>>2]|0)+(aa(k[k[_>>2]>>2]|0,a)|0)|0;k[oa+(f<<2)>>2]=J;k[qa+(f<<2)>>2]=a;f=f+1|0;if((f|0)>=(b|0))break;else e=c}if((b|0)>(i|0)){I=oa+(i<<2)|0;J=pa+(i<<2)|0;C=b-i|0;D=k[ba>>2]|0;E=k[da>>2]|0;F=k[ma>>2]|0;G=k[ea>>2]|0;H=k[fa>>2]|0;if((C|0)>0){y=0-(F<<3)|0;z=H<<3;x=0;c=k[ca>>2]|0;while(1){A=k[I+(x<<2)>>2]|0;B=k[J+(x<<2)>>2]|0;w=G;e=0;while(1){if((w|0)>(e|0)){i=w-e|0;f=c;while(1){h=k[D+(e<<2)>>2]|0;g=0.0;a=0;do{b=(aa(a+-3|0,la)|0)+h|0;if(b>>>0>=E>>>0){while(1)if((b|0)<0)b=b+la|0;else break;while(1)if((b|0)<(E|0))break;else b=b-la|0}g=g+ +(j[A+(b<<1)>>1]|0)*+o[f+(a<<2)>>2];a=a+1|0}while((a|0)!=8);o[B+(e<<2)>>2]=g;e=e+1|0;if((e|0)==(w|0))break;else f=f+32|0}e=w;c=c+(i<<3<<2)|0}if((w|0)==(F|0))break;if((e|0)>=(H|0)){w=F;continue}a=aa(e,-8)|0;b=c;while(1){w=k[D+(e<<2)>>2]|0;o[B+(e<<2)>>2]=+(j[A+(w-P<<1)>>1]|0)*+o[b>>2]+ +(j[A+(w-Q<<1)>>1]|0)*+o[b+4>>2]+ +(j[A+(w-la<<1)>>1]|0)*+o[b+8>>2]+ +(j[A+(w<<1)>>1]|0)*+o[b+12>>2]+ +(j[A+(w+la<<1)>>1]|0)*+o[b+16>>2]+ +(j[A+(w+Q<<1)>>1]|0)*+o[b+20>>2]+ +(j[A+(w+P<<1)>>1]|0)*+o[b+24>>2]+ +(j[A+(w+R<<1)>>1]|0)*+o[b+28>>2];e=e+1|0;if((e|0)>=(H|0))break;else b=b+32|0}w=F;e=H;c=c+(z<<2)+(a<<2)|0}x=x+1|0;if((x|0)==(C|0)){w=39;break}else c=c+(y<<2)|0}}}else w=39}else w=39;if((w|0)==39){w=0;F=k[ma>>2]|0}i=(k[ga>>2]|0)+(aa(k[ha>>2]|0,d)|0)|0;f=F+-4|0;if((F|0)<4)c=0;else{q=+o[N>>2];p=+o[N+20>>2];s=+o[N+4>>2];t=+o[N+8>>2];v=+o[N+12>>2];K=+o[N+16>>2];L=+o[N+24>>2];M=+o[N+28>>2];a=0;do{e=a|1;b=a|2;h=a|3;n=q*+o[S+(a<<2)>>2]+s*+o[T+(a<<2)>>2]+t*+o[U+(a<<2)>>2]+v*+o[V+(a<<2)>>2]+K*+o[W+(a<<2)>>2]+p*+o[X+(a<<2)>>2]+L*+o[Y+(a<<2)>>2]+M*+o[Z+(a<<2)>>2];m=q*+o[S+(e<<2)>>2]+s*+o[T+(e<<2)>>2]+t*+o[U+(e<<2)>>2]+v*+o[V+(e<<2)>>2]+K*+o[W+(e<<2)>>2]+p*+o[X+(e<<2)>>2]+L*+o[Y+(e<<2)>>2]+M*+o[Z+(e<<2)>>2];l=q*+o[S+(b<<2)>>2]+s*+o[T+(b<<2)>>2]+t*+o[U+(b<<2)>>2]+v*+o[V+(b<<2)>>2]+K*+o[W+(b<<2)>>2]+p*+o[X+(b<<2)>>2]+L*+o[Y+(b<<2)>>2]+M*+o[Z+(b<<2)>>2];g=q*+o[S+(h<<2)>>2]+s*+o[T+(h<<2)>>2]+t*+o[U+(h<<2)>>2]+v*+o[V+(h<<2)>>2]+K*+o[W+(h<<2)>>2]+p*+o[X+(h<<2)>>2]+L*+o[Y+(h<<2)>>2]+M*+o[Z+(h<<2)>>2];c=(o[u>>2]=n,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;n=c?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=c?-0.0:0.0}c=~~n;j[i+(a<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;c=(o[u>>2]=m,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;m=c?m+-8388608.0+8388608.0:m+8388608.0+-8388608.0;if(m==0.0)m=c?-0.0:0.0}c=~~m;j[i+(e<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}c=~~l;j[i+(b<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;c=(o[u>>2]=g,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;g=c?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=c?-0.0:0.0}J=~~g;j[i+(h<<1)>>1]=(J+32768|0)>>>0<65536?J:(J|0)>0?32767:32768;a=a+4|0}while((a|0)<=(f|0));c=F&-4}if((c|0)<(F|0)){l=+o[N>>2];m=+o[N+4>>2];n=+o[N+8>>2];p=+o[N+12>>2];q=+o[N+16>>2];s=+o[N+20>>2];t=+o[N+24>>2];v=+o[N+28>>2];do{g=+o[S+(c<<2)>>2]*l+ +o[T+(c<<2)>>2]*m+ +o[U+(c<<2)>>2]*n+ +o[V+(c<<2)>>2]*p+ +o[W+(c<<2)>>2]*q+ +o[X+(c<<2)>>2]*s+ +o[Y+(c<<2)>>2]*t+ +o[Z+(c<<2)>>2]*v;e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}J=~~g;j[i+(c<<1)>>1]=(J+32768|0)>>>0<65536?J:(J|0)>0?32767:32768;c=c+1|0}while((c|0)!=(F|0))}d=d+1|0;c=k[na>>2]|0;if((d|0)>=(k[ka>>2]|0))break;else N=N+(c<<2)|0}c=k[ta>>2]|0}if((c|0)==(ra|0)){r=ua;return}if(c|0)ggb(c);k[ta>>2]=ra;k[sa>>2]=264;r=ua;return}function Ama(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86216;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Bma(a){a=a|0;Ama(a);ggb(a);return}function Cma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0,i=0,l=0.0,n=0.0,p=0.0,q=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;va=r;r=r+1264|0;ua=va+192|0;pa=va+128|0;qa=va+64|0;ra=va;ma=((k[a+4>>2]|0)>>>3&511)+1|0;na=a+140|0;f=(k[na>>2]|0)+15&-16;oa=a+148|0;h=k[oa>>2]|0;e=aa(f,h)|0;sa=ua+8|0;k[ua>>2]=sa;ta=ua+4|0;k[ta>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[ua>>2]=c}else c=sa;k[ta>>2]=e;d=pa;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=qa;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((h|0)>0){zpb(ra|0,-1,h<<2|0)|0;d=0;do{la=c+((aa(d,f)|0)<<2)|0;k[qa+(d<<2)>>2]=la;d=d+1|0}while((d|0)!=(h|0))}d=k[b>>2]|0;la=b+4|0;if((d|0)<(k[la>>2]|0)){O=(k[a+128>>2]|0)+((aa(d,h)|0)<<2)|0;ba=a+120|0;ca=a+116|0;da=a+124|0;ea=a+132|0;fa=a+152|0;ga=a+156|0;ha=a+76|0;ia=a+108|0;ja=a+136|0;ka=a+20|0;$=a+48|0;P=f<<2;Q=ma*3|0;R=ma<<1;S=ma<<2;T=k[qa>>2]|0;U=k[qa+4>>2]|0;V=k[qa+8>>2]|0;W=k[qa+12>>2]|0;X=k[qa+16>>2]|0;Y=k[qa+20>>2]|0;Z=k[qa+24>>2]|0;_=k[qa+28>>2]|0;c=h;while(1){if((c|0)>0){h=(k[(k[ba>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;i=c;e=0;b=c;f=0;while(1){c=h+f|0;a=k[ja>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(f|0)?f:e;a:do if((c|0)<(b|0)){while(1){if((a|0)==(k[ra+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break a}if((c|0)>(f|0)){upb(k[qa+(f<<2)>>2]|0,k[qa+(c<<2)>>2]|0,P|0)|0;b=k[oa>>2]|0}}while(0);i=(f|0)<(i|0)&(c|0)==(b|0)?f:i;K=(k[ka>>2]|0)+(aa(k[k[$>>2]>>2]|0,a)|0)|0;k[pa+(f<<2)>>2]=K;k[ra+(f<<2)>>2]=a;f=f+1|0;if((f|0)>=(b|0))break;else e=c}if((b|0)>(i|0)){J=pa+(i<<2)|0;K=qa+(i<<2)|0;D=b-i|0;E=k[ca>>2]|0;F=k[ea>>2]|0;G=k[na>>2]|0;H=k[fa>>2]|0;I=k[ga>>2]|0;if((D|0)>0){z=0-(G<<3)|0;A=I<<3;y=0;c=k[da>>2]|0;while(1){B=k[J+(y<<2)>>2]|0;C=k[K+(y<<2)>>2]|0;x=H;e=0;while(1){if((x|0)>(e|0)){i=x-e|0;f=c;while(1){h=k[E+(e<<2)>>2]|0;g=0.0;a=0;do{b=(aa(a+-3|0,ma)|0)+h|0;if(b>>>0>=F>>>0){while(1)if((b|0)<0)b=b+ma|0;else break;while(1)if((b|0)<(F|0))break;else b=b-ma|0}g=g+ +(m[B+(b<<1)>>1]|0)*+o[f+(a<<2)>>2];a=a+1|0}while((a|0)!=8);o[C+(e<<2)>>2]=g;e=e+1|0;if((e|0)==(x|0))break;else f=f+32|0}e=x;c=c+(i<<3<<2)|0}if((x|0)==(G|0))break;if((e|0)>=(I|0)){x=G;continue}a=aa(e,-8)|0;b=c;while(1){x=k[E+(e<<2)>>2]|0;o[C+(e<<2)>>2]=+(m[B+(x-Q<<1)>>1]|0)*+o[b>>2]+ +(m[B+(x-R<<1)>>1]|0)*+o[b+4>>2]+ +(m[B+(x-ma<<1)>>1]|0)*+o[b+8>>2]+ +(m[B+(x<<1)>>1]|0)*+o[b+12>>2]+ +(m[B+(x+ma<<1)>>1]|0)*+o[b+16>>2]+ +(m[B+(x+R<<1)>>1]|0)*+o[b+20>>2]+ +(m[B+(x+Q<<1)>>1]|0)*+o[b+24>>2]+ +(m[B+(x+S<<1)>>1]|0)*+o[b+28>>2];e=e+1|0;if((e|0)>=(I|0))break;else b=b+32|0}x=G;e=I;c=c+(A<<2)+(a<<2)|0}y=y+1|0;if((y|0)==(D|0)){x=39;break}else c=c+(z<<2)|0}}}else x=39}else x=39;if((x|0)==39){x=0;G=k[na>>2]|0}i=(k[ha>>2]|0)+(aa(k[ia>>2]|0,d)|0)|0;f=G+-4|0;if((G|0)<4)c=0;else{s=+o[O>>2];q=+o[O+20>>2];t=+o[O+4>>2];v=+o[O+8>>2];w=+o[O+12>>2];L=+o[O+16>>2];M=+o[O+24>>2];N=+o[O+28>>2];a=0;do{e=a|1;b=a|2;h=a|3;p=s*+o[T+(a<<2)>>2]+t*+o[U+(a<<2)>>2]+v*+o[V+(a<<2)>>2]+w*+o[W+(a<<2)>>2]+L*+o[X+(a<<2)>>2]+q*+o[Y+(a<<2)>>2]+M*+o[Z+(a<<2)>>2]+N*+o[_+(a<<2)>>2];n=s*+o[T+(e<<2)>>2]+t*+o[U+(e<<2)>>2]+v*+o[V+(e<<2)>>2]+w*+o[W+(e<<2)>>2]+L*+o[X+(e<<2)>>2]+q*+o[Y+(e<<2)>>2]+M*+o[Z+(e<<2)>>2]+N*+o[_+(e<<2)>>2];l=s*+o[T+(b<<2)>>2]+t*+o[U+(b<<2)>>2]+v*+o[V+(b<<2)>>2]+w*+o[W+(b<<2)>>2]+L*+o[X+(b<<2)>>2]+q*+o[Y+(b<<2)>>2]+M*+o[Z+(b<<2)>>2]+N*+o[_+(b<<2)>>2];g=s*+o[T+(h<<2)>>2]+t*+o[U+(h<<2)>>2]+v*+o[V+(h<<2)>>2]+w*+o[W+(h<<2)>>2]+L*+o[X+(h<<2)>>2]+q*+o[Y+(h<<2)>>2]+M*+o[Z+(h<<2)>>2]+N*+o[_+(h<<2)>>2];c=(o[u>>2]=p,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;p=c?p+-8388608.0+8388608.0:p+8388608.0+-8388608.0;if(p==0.0)p=c?-0.0:0.0}c=~~p;j[i+(a<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;c=(o[u>>2]=n,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;n=c?n+-8388608.0+8388608.0:n+8388608.0+-8388608.0;if(n==0.0)n=c?-0.0:0.0}c=~~n;j[i+(e<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;c=(o[u>>2]=l,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;l=c?l+-8388608.0+8388608.0:l+8388608.0+-8388608.0;if(l==0.0)l=c?-0.0:0.0}c=~~l;j[i+(b<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;c=(o[u>>2]=g,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;g=c?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=c?-0.0:0.0}K=~~g;j[i+(h<<1)>>1]=K>>>0<65536?K:(K|0)>0?65535:0;a=a+4|0}while((a|0)<=(f|0));c=G&-4}if((c|0)<(G|0)){l=+o[O>>2];n=+o[O+4>>2];p=+o[O+8>>2];q=+o[O+12>>2];s=+o[O+16>>2];t=+o[O+20>>2];v=+o[O+24>>2];w=+o[O+28>>2];do{g=+o[T+(c<<2)>>2]*l+ +o[U+(c<<2)>>2]*n+ +o[V+(c<<2)>>2]*p+ +o[W+(c<<2)>>2]*q+ +o[X+(c<<2)>>2]*s+ +o[Y+(c<<2)>>2]*t+ +o[Z+(c<<2)>>2]*v+ +o[_+(c<<2)>>2]*w;e=(o[u>>2]=g,k[u>>2]|0);if((e&2130706432)>>>0<=1249902592){e=(e|0)<0;g=e?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=e?-0.0:0.0}K=~~g;j[i+(c<<1)>>1]=K>>>0<65536?K:(K|0)>0?65535:0;c=c+1|0}while((c|0)!=(G|0))}d=d+1|0;c=k[oa>>2]|0;if((d|0)>=(k[la>>2]|0))break;else O=O+(c<<2)|0}c=k[ua>>2]|0}if((c|0)==(sa|0)){r=va;return}if(c|0)ggb(c);k[ua>>2]=sa;k[ta>>2]=264;r=va;return}function Dma(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86236;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Ema(a){a=a|0;Dma(a);ggb(a);return}function Fma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;ja=r;r=r+1264|0;ia=ja+192|0;da=ja+128|0;ea=ja+64|0;fa=ja;$=((k[a+4>>2]|0)>>>3&511)+1|0;ba=a+140|0;f=(k[ba>>2]|0)+15&-16;ca=a+148|0;g=k[ca>>2]|0;e=aa(f,g)|0;ga=ia+8|0;k[ia>>2]=ga;ha=ia+4|0;k[ha>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[ia>>2]=c}else c=ga;k[ha>>2]=e;d=da;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=ea;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((g|0)>0){zpb(fa|0,-1,g<<2|0)|0;d=0;do{_=c+((aa(d,f)|0)<<2)|0;k[ea+(d<<2)>>2]=_;d=d+1|0}while((d|0)!=(g|0))}d=k[b>>2]|0;_=b+4|0;if((d|0)<(k[_>>2]|0)){C=(k[a+128>>2]|0)+((aa(d,g)|0)<<1)|0;Q=a+120|0;R=a+116|0;S=a+124|0;T=a+132|0;U=a+152|0;V=a+156|0;W=a+76|0;X=a+108|0;Y=a+136|0;Z=a+20|0;P=a+48|0;D=f<<2;E=$*3|0;F=$<<1;G=$<<2;H=k[ea>>2]|0;I=k[ea+4>>2]|0;J=k[ea+8>>2]|0;K=k[ea+12>>2]|0;L=k[ea+16>>2]|0;M=k[ea+20>>2]|0;N=k[ea+24>>2]|0;O=k[ea+28>>2]|0;c=g;while(1){if((c|0)>0){g=(k[(k[Q>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;h=c;e=0;b=c;f=0;while(1){c=g+f|0;a=k[Y>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(f|0)?f:e;a:do if((c|0)<(b|0)){while(1){if((a|0)==(k[fa+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break a}if((c|0)>(f|0)){upb(k[ea+(f<<2)>>2]|0,k[ea+(c<<2)>>2]|0,D|0)|0;b=k[ca>>2]|0}}while(0);h=(f|0)<(h|0)&(c|0)==(b|0)?f:h;B=(k[Z>>2]|0)+(aa(k[k[P>>2]>>2]|0,a)|0)|0;k[da+(f<<2)>>2]=B;k[fa+(f<<2)>>2]=a;f=f+1|0;if((f|0)>=(b|0))break;else e=c}if((b|0)>(h|0)){A=da+(h<<2)|0;B=ea+(h<<2)|0;v=b-h|0;w=k[R>>2]|0;x=k[T>>2]|0;p=k[ba>>2]|0;y=k[U>>2]|0;z=k[V>>2]|0;if((v|0)>0){q=0-(p<<3)|0;s=z<<3;o=0;c=k[S>>2]|0;while(1){t=k[A+(o<<2)>>2]|0;u=k[B+(o<<2)>>2]|0;n=y;e=0;while(1){if((n|0)>(e|0)){m=n-e|0;g=c;while(1){h=k[w+(e<<2)>>2]|0;a=0;f=0;do{b=(aa(f+-3|0,$)|0)+h|0;if(b>>>0>=x>>>0){while(1)if((b|0)<0)b=b+$|0;else break;while(1)if((b|0)<(x|0))break;else b=b-$|0}a=(aa(j[g+(f<<1)>>1]|0,l[t+b>>0]|0)|0)+a|0;f=f+1|0}while((f|0)!=8);k[u+(e<<2)>>2]=a;e=e+1|0;if((e|0)==(n|0))break;else g=g+16|0}e=n;c=c+(m<<3<<1)|0}if((n|0)==(p|0))break;if((e|0)>=(z|0)){n=p;continue}a=aa(e,-8)|0;b=c;while(1){n=k[w+(e<<2)>>2]|0;m=aa(j[b>>1]|0,l[t+(n-E)>>0]|0)|0;m=(aa(j[b+2>>1]|0,l[t+(n-F)>>0]|0)|0)+m|0;m=m+(aa(j[b+4>>1]|0,l[t+(n-$)>>0]|0)|0)|0;m=m+(aa(j[b+6>>1]|0,l[t+n>>0]|0)|0)|0;m=m+(aa(j[b+8>>1]|0,l[t+(n+$)>>0]|0)|0)|0;m=m+(aa(j[b+10>>1]|0,l[t+(n+F)>>0]|0)|0)|0;m=m+(aa(j[b+12>>1]|0,l[t+(n+E)>>0]|0)|0)|0;n=m+(aa(j[b+14>>1]|0,l[t+(n+G)>>0]|0)|0)|0;k[u+(e<<2)>>2]=n;e=e+1|0;if((e|0)>=(z|0))break;else b=b+16|0}n=p;e=z;c=c+(s<<1)+(a<<1)|0}o=o+1|0;if((o|0)==(v|0)){q=39;break}else c=c+(q<<1)|0}}}else q=39}else q=39;if((q|0)==39){q=0;p=k[ba>>2]|0}o=(k[W>>2]|0)+(aa(k[X>>2]|0,d)|0)|0;e=p+-4|0;if((p|0)<4)c=0;else{b=C+2|0;a=C+4|0;f=C+6|0;g=C+8|0;h=C+10|0;m=C+12|0;n=C+14|0;c=0;do{A=j[C>>1]|0;v=aa(k[H+(c<<2)>>2]|0,A)|0;x=c|1;w=aa(k[H+(x<<2)>>2]|0,A)|0;z=c|2;y=aa(k[H+(z<<2)>>2]|0,A)|0;B=c|3;A=aa(k[H+(B<<2)>>2]|0,A)|0;u=j[b>>1]|0;v=(aa(k[I+(c<<2)>>2]|0,u)|0)+v|0;w=(aa(k[I+(x<<2)>>2]|0,u)|0)+w|0;y=(aa(k[I+(z<<2)>>2]|0,u)|0)+y|0;A=(aa(k[I+(B<<2)>>2]|0,u)|0)+A|0;u=j[a>>1]|0;v=(aa(k[J+(c<<2)>>2]|0,u)|0)+v|0;w=(aa(k[J+(x<<2)>>2]|0,u)|0)+w|0;y=(aa(k[J+(z<<2)>>2]|0,u)|0)+y|0;A=(aa(k[J+(B<<2)>>2]|0,u)|0)+A|0;u=j[f>>1]|0;v=(aa(k[K+(c<<2)>>2]|0,u)|0)+v|0;w=(aa(k[K+(x<<2)>>2]|0,u)|0)+w|0;y=(aa(k[K+(z<<2)>>2]|0,u)|0)+y|0;A=(aa(k[K+(B<<2)>>2]|0,u)|0)+A|0;u=j[g>>1]|0;v=(aa(k[L+(c<<2)>>2]|0,u)|0)+v|0;w=(aa(k[L+(x<<2)>>2]|0,u)|0)+w|0;y=(aa(k[L+(z<<2)>>2]|0,u)|0)+y|0;A=(aa(k[L+(B<<2)>>2]|0,u)|0)+A|0;u=j[h>>1]|0;v=(aa(k[M+(c<<2)>>2]|0,u)|0)+v|0;w=(aa(k[M+(x<<2)>>2]|0,u)|0)+w|0;y=(aa(k[M+(z<<2)>>2]|0,u)|0)+y|0;A=(aa(k[M+(B<<2)>>2]|0,u)|0)+A|0;u=j[m>>1]|0;v=(aa(k[N+(c<<2)>>2]|0,u)|0)+v|0;w=(aa(k[N+(x<<2)>>2]|0,u)|0)+w|0;y=(aa(k[N+(z<<2)>>2]|0,u)|0)+y|0;A=(aa(k[N+(B<<2)>>2]|0,u)|0)+A|0;u=j[n>>1]|0;v=(aa(k[O+(c<<2)>>2]|0,u)|0)+v|0;w=(aa(k[O+(x<<2)>>2]|0,u)|0)+w|0;y=(aa(k[O+(z<<2)>>2]|0,u)|0)+y|0;A=(aa(k[O+(B<<2)>>2]|0,u)|0)+A|0;v=v+2097152>>22;i[o+c>>0]=v>>>0<256?v:(v|0)>0?255:0;w=w+2097152>>22;i[o+x>>0]=w>>>0<256?w:(w|0)>0?255:0;y=y+2097152>>22;i[o+z>>0]=y>>>0<256?y:(y|0)>0?255:0;A=A+2097152>>22;i[o+B>>0]=A>>>0<256?A:(A|0)>0?255:0;c=c+4|0}while((c|0)<=(e|0));c=p&-4}if((c|0)<(p|0)){e=C+2|0;b=C+4|0;a=C+6|0;f=C+8|0;g=C+10|0;h=C+12|0;m=C+14|0;do{v=aa(j[C>>1]|0,k[H+(c<<2)>>2]|0)|0;w=aa(j[e>>1]|0,k[I+(c<<2)>>2]|0)|0;x=aa(j[b>>1]|0,k[J+(c<<2)>>2]|0)|0;y=aa(j[a>>1]|0,k[K+(c<<2)>>2]|0)|0;z=aa(j[f>>1]|0,k[L+(c<<2)>>2]|0)|0;A=aa(j[g>>1]|0,k[M+(c<<2)>>2]|0)|0;B=aa(j[h>>1]|0,k[N+(c<<2)>>2]|0)|0;B=v+2097152+w+x+y+z+A+B+(aa(j[m>>1]|0,k[O+(c<<2)>>2]|0)|0)>>22;i[o+c>>0]=B>>>0<256?B:(B|0)>0?255:0;c=c+1|0}while((c|0)!=(p|0))}d=d+1|0;c=k[ca>>2]|0;if((d|0)>=(k[_>>2]|0))break;else C=C+(c<<1)|0}c=k[ia>>2]|0}if((c|0)==(ga|0)){r=ja;return}if(c|0)ggb(c);k[ia>>2]=ga;k[ha>>2]=264;r=ja;return}function Gma(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86336;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Xma(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Xma(A);r=C;return}function Hma(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86316;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Uma(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Uma(A);r=C;return}function Ima(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86296;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Rma(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Rma(A);r=C;return}function Jma(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86276;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Oma(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Oma(A);r=C;return}function Kma(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=r;r=r+176|0;B=C+168|0;z=C+160|0;A=C;n=a+40|0;x=k[n>>2]|0;v=k[x>>2]|0;s=b+40|0;y=k[s>>2]|0;w=k[y>>2]|0;q=k[a>>2]|0;t=(q>>>3&511)+1|0;x=aa(t,k[x+4>>2]|0)|0;y=aa(k[y+4>>2]|0,t)|0;u=aa(t,g)|0;t=aa(t,h)|0;k[z>>2]=0;k[z+4>>2]=w;k[A>>2]=86256;m=A+4|0;k[m>>2]=q;q=A+8|0;h=a+4|0;g=k[h>>2]|0;k[q>>2]=g;D=A+12|0;k[D>>2]=k[a+8>>2];k[A+16>>2]=k[a+12>>2];k[A+20>>2]=k[a+16>>2];k[A+24>>2]=k[a+20>>2];k[A+28>>2]=k[a+24>>2];k[A+32>>2]=k[a+28>>2];k[A+36>>2]=k[a+32>>2];l=k[a+36>>2]|0;k[A+40>>2]=l;o=A+44|0;k[o>>2]=D;D=A+52|0;p=A+48|0;k[p>>2]=D;k[A+56>>2]=0;k[D>>2]=0;if(l){g=l+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[q>>2]=0;x1(m,g,0,0,0);if((k[q>>2]|0)>0){n=k[n>>2]|0;m=k[o>>2]|0;l=k[a+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[q>>2]|0))}}else{q=k[a+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[q>>2];k[D+4>>2]=k[q+4>>2]}m=A+60|0;k[m>>2]=k[b>>2];a=A+64|0;l=b+4|0;g=k[l>>2]|0;k[a>>2]=g;D=A+68|0;k[D>>2]=k[b+8>>2];k[A+72>>2]=k[b+12>>2];k[A+76>>2]=k[b+16>>2];k[A+80>>2]=k[b+20>>2];k[A+84>>2]=k[b+24>>2];k[A+88>>2]=k[b+28>>2];k[A+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[A+96>>2]=h;o=A+100|0;k[o>>2]=D;D=A+108|0;p=A+104|0;k[p>>2]=D;k[A+112>>2]=0;k[D>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[l>>2]|0}if((g|0)>=3){k[a>>2]=0;x1(m,g,0,0,0);if((k[a>>2]|0)>0){n=k[s>>2]|0;m=k[o>>2]|0;l=k[b+44>>2]|0;h=k[p>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[n+(g<<2)>>2];k[h+(g<<2)>>2]=k[l+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0))}}else{b=k[b+44>>2]|0;D=k[p>>2]|0;k[D>>2]=k[b>>2];k[D+4>>2]=k[b+4>>2]}k[A+116>>2]=c;k[A+120>>2]=e;k[A+124>>2]=d;k[A+128>>2]=f;k[A+132>>2]=x;k[A+136>>2]=v;k[A+140>>2]=y;k[A+144>>2]=w;k[A+148>>2]=j;k[A+152>>2]=u;k[A+156>>2]=t;if((j|0)<17){D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Lma(A);r=C;return}k[B>>2]=0;g=B+4|0;k[g>>2]=0;h=ZT(24)|0;k[h>>2]=1;l=h+4|0;k[B>>2]=l;k[g>>2]=18;i[h+22>>0]=0;m=335889;n=l+18|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,B,335908,335515,1695);k[g>>2]=0;k[B>>2]=0;D=k[h>>2]|0;k[h>>2]=D+-1;if((D|0)==1)ggb(k[h+-4>>2]|0);D=k[A>>2]|0;D=D+8|0;D=k[D>>2]|0;jh[D&1023](A,z);Lma(A);r=C;return}function Lma(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86256;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Mma(a){a=a|0;Lma(a);ggb(a);return}function Nma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0.0,i=0.0,j=0.0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;ga=r;r=r+1296|0;fa=ga;$=ga+1224|0;ba=ga+1160|0;ca=ga+1096|0;Y=((k[a+4>>2]|0)>>>3&511)+1|0;Z=a+140|0;f=(k[Z>>2]|0)+15&-16;_=a+148|0;l=k[_>>2]|0;e=aa(f,l)|0;da=fa+8|0;k[fa>>2]=da;ea=fa+4|0;k[ea>>2]=136;if(e>>>0>136){d=e>>>0>536870911?-1:e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[fa>>2]=c}else c=da;k[ea>>2]=e;d=$;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=ba;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((l|0)>0){zpb(ca|0,-1,l<<2|0)|0;d=0;do{X=c+((aa(d,f)|0)<<3)|0;k[ba+(d<<2)>>2]=X;d=d+1|0}while((d|0)!=(l|0))}d=k[b>>2]|0;X=b+4|0;if((d|0)<(k[X>>2]|0)){E=(k[a+128>>2]|0)+((aa(d,l)|0)<<2)|0;N=a+120|0;O=a+116|0;P=a+124|0;Q=a+132|0;R=a+152|0;S=a+156|0;T=a+76|0;U=a+108|0;V=a+136|0;W=a+20|0;M=a+48|0;F=f<<3;G=Y<<1;H=Y*3|0;I=k[ba>>2]|0;J=k[ba+4>>2]|0;K=k[ba+8>>2]|0;L=k[ba+12>>2]|0;c=l;while(1){if((c|0)>0){l=(k[(k[N>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;m=c;e=0;b=c;f=0;while(1){c=l+f|0;a=k[V>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(f|0)?f:e;a:do if((c|0)<(b|0)){while(1){if((a|0)==(k[ca+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break a}if((c|0)>(f|0)){upb(k[ba+(f<<2)>>2]|0,k[ba+(c<<2)>>2]|0,F|0)|0;b=k[_>>2]|0}}while(0);m=(f|0)<(m|0)&(c|0)==(b|0)?f:m;D=(k[W>>2]|0)+(aa(k[k[M>>2]>>2]|0,a)|0)|0;k[$+(f<<2)>>2]=D;k[ca+(f<<2)>>2]=a;f=f+1|0;if((f|0)>=(b|0))break;else e=c}if((b|0)>(m|0)){C=$+(m<<2)|0;D=ba+(m<<2)|0;x=b-m|0;y=k[O>>2]|0;z=k[Q>>2]|0;b=k[Z>>2]|0;A=k[R>>2]|0;B=k[S>>2]|0;if((x|0)>0){t=0-(b<<2)|0;u=B<<2;c=k[P>>2]|0;s=0;while(1){v=k[C+(s<<2)>>2]|0;w=k[D+(s<<2)>>2]|0;q=A;e=0;while(1){if((q|0)>(e|0)){n=q-e|0;m=c;while(1){a=k[y+(e<<2)>>2]|0;l=a-Y|0;if(l>>>0<z>>>0)f=l;else{f=l;while(1)if((f|0)<0)f=f+Y|0;else break;while(1)if((f|0)<(z|0))break;else f=f-Y|0}g=+p[v+(f<<3)>>3]*+o[m>>2]+0.0;if(a>>>0>=z>>>0){while(1)if((a|0)<0)a=a+Y|0;else break;while(1)if((a|0)<(z|0))break;else a=a-Y|0}g=g+ +p[v+(a<<3)>>3]*+o[m+4>>2];a=G+l|0;if(a>>>0>=z>>>0){while(1)if((a|0)<0)a=a+Y|0;else break;while(1)if((a|0)<(z|0))break;else a=a-Y|0}g=g+ +p[v+(a<<3)>>3]*+o[m+8>>2];a=H+l|0;if(a>>>0>=z>>>0){while(1)if((a|0)<0)a=a+Y|0;else break;while(1)if((a|0)<(z|0))break;else a=a-Y|0}p[w+(e<<3)>>3]=g+ +p[v+(a<<3)>>3]*+o[m+12>>2];e=e+1|0;if((e|0)==(q|0))break;else m=m+16|0}e=q;c=c+(n<<2<<2)|0}if((q|0)==(b|0))break;if((e|0)>=(B|0)){q=b;continue}f=aa(e,-4)|0;a=c;while(1){q=k[y+(e<<2)>>2]|0;p[w+(e<<3)>>3]=+p[v+(q-Y<<3)>>3]*+o[a>>2]+ +p[v+(q<<3)>>3]*+o[a+4>>2]+ +p[v+(q+Y<<3)>>3]*+o[a+8>>2]+ +p[v+(q+G<<3)>>3]*+o[a+12>>2];e=e+1|0;if((e|0)>=(B|0))break;else a=a+16|0}q=b;e=B;c=c+(u<<2)+(f<<2)|0}s=s+1|0;if((s|0)==(x|0)){n=46;break}else c=c+(t<<2)|0}}}else n=46}else n=46;if((n|0)==46){n=0;b=k[Z>>2]|0}e=(k[T>>2]|0)+(aa(k[U>>2]|0,d)|0)|0;g=+o[E>>2];h=+o[E+4>>2];i=+o[E+8>>2];j=+o[E+12>>2];if((b|0)>0){c=0;do{p[e+(c<<3)>>3]=g*+p[I+(c<<3)>>3]+h*+p[J+(c<<3)>>3]+i*+p[K+(c<<3)>>3]+j*+p[L+(c<<3)>>3];c=c+1|0}while((c|0)!=(b|0))}d=d+1|0;c=k[_>>2]|0;if((d|0)>=(k[X>>2]|0))break;else E=E+(c<<2)|0}c=k[fa>>2]|0}if((c|0)==(da|0)){r=ga;return}if(c|0)ggb(c);k[fa>>2]=da;k[ea>>2]=136;r=ga;return}function Oma(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86276;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Pma(a){a=a|0;Oma(a);ggb(a);return}function Qma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0.0,i=0.0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0;fa=r;r=r+1264|0;ea=fa+192|0;_=fa+128|0;$=fa+64|0;ba=fa;X=((k[a+4>>2]|0)>>>3&511)+1|0;Y=a+140|0;f=(k[Y>>2]|0)+15&-16;Z=a+148|0;l=k[Z>>2]|0;e=aa(f,l)|0;ca=ea+8|0;k[ea>>2]=ca;da=ea+4|0;k[da>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[ea>>2]=c}else c=ca;k[da>>2]=e;d=_;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=$;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((l|0)>0){zpb(ba|0,-1,l<<2|0)|0;d=0;do{W=c+((aa(d,f)|0)<<2)|0;k[$+(d<<2)>>2]=W;d=d+1|0}while((d|0)!=(l|0))}d=k[b>>2]|0;W=b+4|0;if((d|0)<(k[W>>2]|0)){D=(k[a+128>>2]|0)+((aa(d,l)|0)<<2)|0;M=a+120|0;N=a+116|0;O=a+124|0;P=a+132|0;Q=a+152|0;R=a+156|0;S=a+76|0;T=a+108|0;U=a+136|0;V=a+20|0;L=a+48|0;E=f<<2;F=X<<1;G=X*3|0;H=k[$>>2]|0;I=k[$+4>>2]|0;J=k[$+8>>2]|0;K=k[$+12>>2]|0;c=l;while(1){if((c|0)>0){l=(k[(k[M>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;m=c;e=0;b=c;f=0;while(1){c=l+f|0;a=k[U>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(f|0)?f:e;a:do if((c|0)<(b|0)){while(1){if((a|0)==(k[ba+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break a}if((c|0)>(f|0)){upb(k[$+(f<<2)>>2]|0,k[$+(c<<2)>>2]|0,E|0)|0;b=k[Z>>2]|0}}while(0);m=(f|0)<(m|0)&(c|0)==(b|0)?f:m;C=(k[V>>2]|0)+(aa(k[k[L>>2]>>2]|0,a)|0)|0;k[_+(f<<2)>>2]=C;k[ba+(f<<2)>>2]=a;f=f+1|0;if((f|0)>=(b|0))break;else e=c}if((b|0)>(m|0)){B=_+(m<<2)|0;C=$+(m<<2)|0;w=b-m|0;x=k[N>>2]|0;y=k[P>>2]|0;b=k[Y>>2]|0;z=k[Q>>2]|0;A=k[R>>2]|0;if((w|0)>0){s=0-(b<<2)|0;t=A<<2;c=k[O>>2]|0;q=0;while(1){u=k[B+(q<<2)>>2]|0;v=k[C+(q<<2)>>2]|0;p=z;e=0;while(1){if((p|0)>(e|0)){n=p-e|0;m=c;while(1){a=k[x+(e<<2)>>2]|0;l=a-X|0;if(l>>>0<y>>>0)f=l;else{f=l;while(1)if((f|0)<0)f=f+X|0;else break;while(1)if((f|0)<(y|0))break;else f=f-X|0}g=+o[u+(f<<2)>>2]*+o[m>>2]+0.0;if(a>>>0>=y>>>0){while(1)if((a|0)<0)a=a+X|0;else break;while(1)if((a|0)<(y|0))break;else a=a-X|0}g=g+ +o[u+(a<<2)>>2]*+o[m+4>>2];a=F+l|0;if(a>>>0>=y>>>0){while(1)if((a|0)<0)a=a+X|0;else break;while(1)if((a|0)<(y|0))break;else a=a-X|0}g=g+ +o[u+(a<<2)>>2]*+o[m+8>>2];a=G+l|0;if(a>>>0>=y>>>0){while(1)if((a|0)<0)a=a+X|0;else break;while(1)if((a|0)<(y|0))break;else a=a-X|0}o[v+(e<<2)>>2]=g+ +o[u+(a<<2)>>2]*+o[m+12>>2];e=e+1|0;if((e|0)==(p|0))break;else m=m+16|0}e=p;c=c+(n<<2<<2)|0}if((p|0)==(b|0))break;if((e|0)>=(A|0)){p=b;continue}f=aa(e,-4)|0;a=c;while(1){p=k[x+(e<<2)>>2]|0;o[v+(e<<2)>>2]=+o[u+(p-X<<2)>>2]*+o[a>>2]+ +o[u+(p<<2)>>2]*+o[a+4>>2]+ +o[u+(p+X<<2)>>2]*+o[a+8>>2]+ +o[u+(p+F<<2)>>2]*+o[a+12>>2];e=e+1|0;if((e|0)>=(A|0))break;else a=a+16|0}p=b;e=A;c=c+(t<<2)+(f<<2)|0}q=q+1|0;if((q|0)==(w|0)){n=46;break}else c=c+(s<<2)|0}}}else n=46}else n=46;if((n|0)==46){n=0;b=k[Y>>2]|0}e=(k[S>>2]|0)+(aa(k[T>>2]|0,d)|0)|0;g=+o[D>>2];h=+o[D+4>>2];i=+o[D+8>>2];j=+o[D+12>>2];if((b|0)>0){c=0;do{o[e+(c<<2)>>2]=g*+o[H+(c<<2)>>2]+h*+o[I+(c<<2)>>2]+i*+o[J+(c<<2)>>2]+j*+o[K+(c<<2)>>2];c=c+1|0}while((c|0)!=(b|0))}d=d+1|0;c=k[Z>>2]|0;if((d|0)>=(k[W>>2]|0))break;else D=D+(c<<2)|0}c=k[ea>>2]|0}if((c|0)==(ca|0)){r=fa;return}if(c|0)ggb(c);k[ea>>2]=ca;k[da>>2]=264;r=fa;return}function Rma(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86296;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Sma(a){a=a|0;Rma(a);ggb(a);return}function Tma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0.0,i=0.0,l=0.0,m=0.0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;ia=r;r=r+1264|0;ha=ia+192|0;ca=ia+128|0;da=ia+64|0;ea=ia;_=((k[a+4>>2]|0)>>>3&511)+1|0;$=a+140|0;f=(k[$>>2]|0)+15&-16;ba=a+148|0;n=k[ba>>2]|0;e=aa(f,n)|0;fa=ha+8|0;k[ha>>2]=fa;ga=ha+4|0;k[ga>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[ha>>2]=c}else c=fa;k[ga>>2]=e;d=ca;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=da;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((n|0)>0){zpb(ea|0,-1,n<<2|0)|0;d=0;do{Z=c+((aa(d,f)|0)<<2)|0;k[da+(d<<2)>>2]=Z;d=d+1|0}while((d|0)!=(n|0))}d=k[b>>2]|0;Z=b+4|0;if((d|0)<(k[Z>>2]|0)){G=(k[a+128>>2]|0)+((aa(d,n)|0)<<2)|0;P=a+120|0;Q=a+116|0;R=a+124|0;S=a+132|0;T=a+152|0;U=a+156|0;V=a+76|0;W=a+108|0;X=a+136|0;Y=a+20|0;O=a+48|0;H=f<<2;I=_<<1;J=_*3|0;K=k[da>>2]|0;L=k[da+4>>2]|0;M=k[da+8>>2]|0;N=k[da+12>>2]|0;c=n;while(1){if((c|0)>0){n=(k[(k[P>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;p=c;e=0;b=c;f=0;while(1){c=n+f|0;a=k[X>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(f|0)?f:e;a:do if((c|0)<(b|0)){while(1){if((a|0)==(k[ea+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break a}if((c|0)>(f|0)){upb(k[da+(f<<2)>>2]|0,k[da+(c<<2)>>2]|0,H|0)|0;b=k[ba>>2]|0}}while(0);p=(f|0)<(p|0)&(c|0)==(b|0)?f:p;F=(k[Y>>2]|0)+(aa(k[k[O>>2]>>2]|0,a)|0)|0;k[ca+(f<<2)>>2]=F;k[ea+(f<<2)>>2]=a;f=f+1|0;if((f|0)>=(b|0))break;else e=c}if((b|0)>(p|0)){E=ca+(p<<2)|0;F=da+(p<<2)|0;z=b-p|0;A=k[Q>>2]|0;B=k[S>>2]|0;a=k[$>>2]|0;C=k[T>>2]|0;D=k[U>>2]|0;if((z|0)>0){v=0-(a<<2)|0;w=D<<2;c=k[R>>2]|0;t=0;while(1){x=k[E+(t<<2)>>2]|0;y=k[F+(t<<2)>>2]|0;s=C;e=0;while(1){if((s|0)>(e|0)){q=s-e|0;p=c;while(1){b=k[A+(e<<2)>>2]|0;n=b-_|0;if(n>>>0<B>>>0)f=n;else{f=n;while(1)if((f|0)<0)f=f+_|0;else break;while(1)if((f|0)<(B|0))break;else f=f-_|0}g=+(j[x+(f<<1)>>1]|0)*+o[p>>2]+0.0;if(b>>>0>=B>>>0){while(1)if((b|0)<0)b=b+_|0;else break;while(1)if((b|0)<(B|0))break;else b=b-_|0}g=g+ +(j[x+(b<<1)>>1]|0)*+o[p+4>>2];b=I+n|0;if(b>>>0>=B>>>0){while(1)if((b|0)<0)b=b+_|0;else break;while(1)if((b|0)<(B|0))break;else b=b-_|0}g=g+ +(j[x+(b<<1)>>1]|0)*+o[p+8>>2];b=J+n|0;if(b>>>0>=B>>>0){while(1)if((b|0)<0)b=b+_|0;else break;while(1)if((b|0)<(B|0))break;else b=b-_|0}o[y+(e<<2)>>2]=g+ +(j[x+(b<<1)>>1]|0)*+o[p+12>>2];e=e+1|0;if((e|0)==(s|0))break;else p=p+16|0}e=s;c=c+(q<<2<<2)|0}if((s|0)==(a|0))break;if((e|0)>=(D|0)){s=a;continue}f=aa(e,-4)|0;b=c;while(1){s=k[A+(e<<2)>>2]|0;o[y+(e<<2)>>2]=+(j[x+(s-_<<1)>>1]|0)*+o[b>>2]+ +(j[x+(s<<1)>>1]|0)*+o[b+4>>2]+ +(j[x+(s+_<<1)>>1]|0)*+o[b+8>>2]+ +(j[x+(s+I<<1)>>1]|0)*+o[b+12>>2];e=e+1|0;if((e|0)>=(D|0))break;else b=b+16|0}s=a;e=D;c=c+(w<<2)+(f<<2)|0}t=t+1|0;if((t|0)==(z|0)){q=46;break}else c=c+(v<<2)|0}}}else q=46}else q=46;if((q|0)==46){q=0;a=k[$>>2]|0}b=(k[V>>2]|0)+(aa(k[W>>2]|0,d)|0)|0;h=+o[G>>2];i=+o[G+4>>2];l=+o[G+8>>2];m=+o[G+12>>2];if((a|0)>0){e=0;do{g=h*+o[K+(e<<2)>>2]+i*+o[L+(e<<2)>>2]+l*+o[M+(e<<2)>>2]+m*+o[N+(e<<2)>>2];c=(o[u>>2]=g,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;g=c?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=c?-0.0:0.0}F=~~g;j[b+(e<<1)>>1]=(F+32768|0)>>>0<65536?F:(F|0)>0?32767:32768;e=e+1|0}while((e|0)!=(a|0))}d=d+1|0;c=k[ba>>2]|0;if((d|0)>=(k[Z>>2]|0))break;else G=G+(c<<2)|0}c=k[ha>>2]|0}if((c|0)==(fa|0)){r=ia;return}if(c|0)ggb(c);k[ha>>2]=fa;k[ga>>2]=264;r=ia;return}function Uma(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86316;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Vma(a){a=a|0;Uma(a);ggb(a);return}function Wma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0.0,i=0.0,l=0.0,n=0.0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;ja=r;r=r+1264|0;ia=ja+192|0;da=ja+128|0;ea=ja+64|0;fa=ja;$=((k[a+4>>2]|0)>>>3&511)+1|0;ba=a+140|0;f=(k[ba>>2]|0)+15&-16;ca=a+148|0;p=k[ca>>2]|0;e=aa(f,p)|0;ga=ia+8|0;k[ia>>2]=ga;ha=ia+4|0;k[ha>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[ia>>2]=c}else c=ga;k[ha>>2]=e;d=da;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=ea;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((p|0)>0){zpb(fa|0,-1,p<<2|0)|0;d=0;do{_=c+((aa(d,f)|0)<<2)|0;k[ea+(d<<2)>>2]=_;d=d+1|0}while((d|0)!=(p|0))}d=k[b>>2]|0;_=b+4|0;if((d|0)<(k[_>>2]|0)){H=(k[a+128>>2]|0)+((aa(d,p)|0)<<2)|0;Q=a+120|0;R=a+116|0;S=a+124|0;T=a+132|0;U=a+152|0;V=a+156|0;W=a+76|0;X=a+108|0;Y=a+136|0;Z=a+20|0;P=a+48|0;I=f<<2;J=$<<1;K=$*3|0;L=k[ea>>2]|0;M=k[ea+4>>2]|0;N=k[ea+8>>2]|0;O=k[ea+12>>2]|0;c=p;while(1){if((c|0)>0){p=(k[(k[Q>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;q=c;e=0;b=c;f=0;while(1){c=p+f|0;a=k[Y>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(f|0)?f:e;a:do if((c|0)<(b|0)){while(1){if((a|0)==(k[fa+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break a}if((c|0)>(f|0)){upb(k[ea+(f<<2)>>2]|0,k[ea+(c<<2)>>2]|0,I|0)|0;b=k[ca>>2]|0}}while(0);q=(f|0)<(q|0)&(c|0)==(b|0)?f:q;G=(k[Z>>2]|0)+(aa(k[k[P>>2]>>2]|0,a)|0)|0;k[da+(f<<2)>>2]=G;k[fa+(f<<2)>>2]=a;f=f+1|0;if((f|0)>=(b|0))break;else e=c}if((b|0)>(q|0)){F=da+(q<<2)|0;G=ea+(q<<2)|0;A=b-q|0;B=k[R>>2]|0;C=k[T>>2]|0;a=k[ba>>2]|0;D=k[U>>2]|0;E=k[V>>2]|0;if((A|0)>0){w=0-(a<<2)|0;x=E<<2;c=k[S>>2]|0;v=0;while(1){y=k[F+(v<<2)>>2]|0;z=k[G+(v<<2)>>2]|0;t=D;e=0;while(1){if((t|0)>(e|0)){s=t-e|0;q=c;while(1){b=k[B+(e<<2)>>2]|0;p=b-$|0;if(p>>>0<C>>>0)f=p;else{f=p;while(1)if((f|0)<0)f=f+$|0;else break;while(1)if((f|0)<(C|0))break;else f=f-$|0}g=+(m[y+(f<<1)>>1]|0)*+o[q>>2]+0.0;if(b>>>0>=C>>>0){while(1)if((b|0)<0)b=b+$|0;else break;while(1)if((b|0)<(C|0))break;else b=b-$|0}g=g+ +(m[y+(b<<1)>>1]|0)*+o[q+4>>2];b=J+p|0;if(b>>>0>=C>>>0){while(1)if((b|0)<0)b=b+$|0;else break;while(1)if((b|0)<(C|0))break;else b=b-$|0}g=g+ +(m[y+(b<<1)>>1]|0)*+o[q+8>>2];b=K+p|0;if(b>>>0>=C>>>0){while(1)if((b|0)<0)b=b+$|0;else break;while(1)if((b|0)<(C|0))break;else b=b-$|0}o[z+(e<<2)>>2]=g+ +(m[y+(b<<1)>>1]|0)*+o[q+12>>2];e=e+1|0;if((e|0)==(t|0))break;else q=q+16|0}e=t;c=c+(s<<2<<2)|0}if((t|0)==(a|0))break;if((e|0)>=(E|0)){t=a;continue}f=aa(e,-4)|0;b=c;while(1){t=k[B+(e<<2)>>2]|0;o[z+(e<<2)>>2]=+(m[y+(t-$<<1)>>1]|0)*+o[b>>2]+ +(m[y+(t<<1)>>1]|0)*+o[b+4>>2]+ +(m[y+(t+$<<1)>>1]|0)*+o[b+8>>2]+ +(m[y+(t+J<<1)>>1]|0)*+o[b+12>>2];e=e+1|0;if((e|0)>=(E|0))break;else b=b+16|0}t=a;e=E;c=c+(x<<2)+(f<<2)|0}v=v+1|0;if((v|0)==(A|0)){s=46;break}else c=c+(w<<2)|0}}}else s=46}else s=46;if((s|0)==46){s=0;a=k[ba>>2]|0}b=(k[W>>2]|0)+(aa(k[X>>2]|0,d)|0)|0;h=+o[H>>2];i=+o[H+4>>2];l=+o[H+8>>2];n=+o[H+12>>2];if((a|0)>0){e=0;do{g=h*+o[L+(e<<2)>>2]+i*+o[M+(e<<2)>>2]+l*+o[N+(e<<2)>>2]+n*+o[O+(e<<2)>>2];c=(o[u>>2]=g,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;g=c?g+-8388608.0+8388608.0:g+8388608.0+-8388608.0;if(g==0.0)g=c?-0.0:0.0}G=~~g;j[b+(e<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;e=e+1|0}while((e|0)!=(a|0))}d=d+1|0;c=k[ca>>2]|0;if((d|0)>=(k[_>>2]|0))break;else H=H+(c<<2)|0}c=k[ia>>2]|0}if((c|0)==(ga|0)){r=ja;return}if(c|0)ggb(c);k[ia>>2]=ga;k[ha>>2]=264;r=ja;return}function Xma(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86336;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Yma(a){a=a|0;Xma(a);ggb(a);return}function Zma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0;da=r;r=r+1264|0;ca=da+192|0;Y=da+128|0;Z=da+64|0;_=da;V=((k[a+4>>2]|0)>>>3&511)+1|0;W=a+140|0;f=(k[W>>2]|0)+15&-16;X=a+148|0;g=k[X>>2]|0;e=aa(f,g)|0;$=ca+8|0;k[ca>>2]=$;ba=ca+4|0;k[ba>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[ca>>2]=c}else c=$;k[ba>>2]=e;d=Y;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=Z;e=d+64|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));if((g|0)>0){zpb(_|0,-1,g<<2|0)|0;d=0;do{U=c+((aa(d,f)|0)<<2)|0;k[Z+(d<<2)>>2]=U;d=d+1|0}while((d|0)!=(g|0))}d=k[b>>2]|0;U=b+4|0;if((d|0)<(k[U>>2]|0)){B=(k[a+128>>2]|0)+((aa(d,g)|0)<<1)|0;K=a+120|0;L=a+116|0;M=a+124|0;N=a+132|0;O=a+152|0;P=a+156|0;Q=a+76|0;R=a+108|0;S=a+136|0;T=a+20|0;J=a+48|0;C=f<<2;D=V<<1;E=V*3|0;F=k[Z>>2]|0;G=k[Z+4>>2]|0;H=k[Z+8>>2]|0;I=k[Z+12>>2]|0;c=g;while(1){if((c|0)>0){g=(k[(k[K>>2]|0)+(d<<2)>>2]|0)+1+((c|0)/-2|0)|0;h=c;e=0;b=c;f=0;while(1){c=g+f|0;a=k[S>>2]|0;a=(c|0)>-1?((c|0)<(a|0)?c:a+-1|0):0;c=(e|0)<(f|0)?f:e;a:do if((c|0)<(b|0)){while(1){if((a|0)==(k[_+(c<<2)>>2]|0))break;c=c+1|0;if((c|0)>=(b|0))break a}if((c|0)>(f|0)){upb(k[Z+(f<<2)>>2]|0,k[Z+(c<<2)>>2]|0,C|0)|0;b=k[X>>2]|0}}while(0);h=(f|0)<(h|0)&(c|0)==(b|0)?f:h;A=(k[T>>2]|0)+(aa(k[k[J>>2]>>2]|0,a)|0)|0;k[Y+(f<<2)>>2]=A;k[_+(f<<2)>>2]=a;f=f+1|0;if((f|0)>=(b|0))break;else e=c}if((b|0)>(h|0)){z=Y+(h<<2)|0;A=Z+(h<<2)|0;u=b-h|0;v=k[L>>2]|0;w=k[N>>2]|0;h=k[W>>2]|0;x=k[O>>2]|0;y=k[P>>2]|0;if((u|0)>0){p=0-(h<<2)|0;q=y<<2;c=k[M>>2]|0;o=0;while(1){s=k[z+(o<<2)>>2]|0;t=k[A+(o<<2)>>2]|0;n=x;e=0;while(1){if((n|0)>(e|0)){m=n-e|0;g=c;while(1){b=k[v+(e<<2)>>2]|0;f=b-V|0;if(f>>>0<w>>>0)a=f;else{a=f;while(1)if((a|0)<0)a=a+V|0;else break;while(1)if((a|0)<(w|0))break;else a=a-V|0}a=aa(j[g>>1]|0,l[s+a>>0]|0)|0;if(b>>>0>=w>>>0){while(1)if((b|0)<0)b=b+V|0;else break;while(1)if((b|0)<(w|0))break;else b=b-V|0}a=(aa(j[g+2>>1]|0,l[s+b>>0]|0)|0)+a|0;b=D+f|0;if(b>>>0>=w>>>0){while(1)if((b|0)<0)b=b+V|0;else break;while(1)if((b|0)<(w|0))break;else b=b-V|0}a=(aa(j[g+4>>1]|0,l[s+b>>0]|0)|0)+a|0;b=E+f|0;if(b>>>0>=w>>>0){while(1)if((b|0)<0)b=b+V|0;else break;while(1)if((b|0)<(w|0))break;else b=b-V|0}f=(aa(j[g+6>>1]|0,l[s+b>>0]|0)|0)+a|0;k[t+(e<<2)>>2]=f;e=e+1|0;if((e|0)==(n|0))break;else g=g+8|0}e=n;c=c+(m<<2<<1)|0}if((n|0)==(h|0))break;if((e|0)>=(y|0)){n=h;continue}a=aa(e,-4)|0;b=c;while(1){n=k[v+(e<<2)>>2]|0;m=aa(j[b>>1]|0,l[s+(n-V)>>0]|0)|0;m=(aa(j[b+2>>1]|0,l[s+n>>0]|0)|0)+m|0;m=m+(aa(j[b+4>>1]|0,l[s+(n+V)>>0]|0)|0)|0;n=m+(aa(j[b+6>>1]|0,l[s+(n+D)>>0]|0)|0)|0;k[t+(e<<2)>>2]=n;e=e+1|0;if((e|0)>=(y|0))break;else b=b+8|0}n=h;e=y;c=c+(q<<1)+(a<<1)|0}o=o+1|0;if((o|0)==(u|0)){m=46;break}else c=c+(p<<1)|0}}}else m=46}else m=46;if((m|0)==46){m=0;h=k[W>>2]|0}e=(k[Q>>2]|0)+(aa(k[R>>2]|0,d)|0)|0;b=j[B>>1]|0;a=j[B+2>>1]|0;f=j[B+4>>1]|0;g=j[B+6>>1]|0;if((h|0)>0){c=0;do{y=aa(k[F+(c<<2)>>2]|0,b)|0;z=aa(k[G+(c<<2)>>2]|0,a)|0;A=aa(k[H+(c<<2)>>2]|0,f)|0;A=y+2097152+z+A+(aa(k[I+(c<<2)>>2]|0,g)|0)>>22;i[e+c>>0]=A>>>0<256?A:(A|0)>0?255:0;c=c+1|0}while((c|0)!=(h|0))}d=d+1|0;c=k[X>>2]|0;if((d|0)>=(k[U>>2]|0))break;else B=B+(c<<1)|0}c=k[ca>>2]|0}if((c|0)==($|0)){r=da;return}if(c|0)ggb(c);k[ca>>2]=$;k[ba>>2]=264;r=da;return}function _ma(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0;h=r;r=r+48|0;i=h+32|0;j=h;l=k[b+8>>2]|0;k[i>>2]=0;k[i+4>>2]=l;k[j>>2]=86436;k[j+4>>2]=a;k[j+8>>2]=b;k[j+12>>2]=c;k[j+20>>2]=d;k[j+16>>2]=e;k[j+24>>2]=f;k[j+28>>2]=g;mna(j,i);r=h;return}function $ma(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0;h=r;r=r+48|0;i=h+32|0;j=h;l=k[b+8>>2]|0;k[i>>2]=0;k[i+4>>2]=l;k[j>>2]=86416;k[j+4>>2]=a;k[j+8>>2]=b;k[j+12>>2]=c;k[j+20>>2]=d;k[j+16>>2]=e;k[j+24>>2]=f;k[j+28>>2]=g;kna(j,i);r=h;return}function ana(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0;h=r;r=r+48|0;i=h+32|0;j=h;l=k[b+8>>2]|0;k[i>>2]=0;k[i+4>>2]=l;k[j>>2]=86396;k[j+4>>2]=a;k[j+8>>2]=b;k[j+12>>2]=c;k[j+20>>2]=d;k[j+16>>2]=e;k[j+24>>2]=f;k[j+28>>2]=g;ina(j,i);r=h;return}function bna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0;h=r;r=r+48|0;i=h+32|0;j=h;l=k[b+8>>2]|0;k[i>>2]=0;k[i+4>>2]=l;k[j>>2]=86376;k[j+4>>2]=a;k[j+8>>2]=b;k[j+12>>2]=c;k[j+20>>2]=d;k[j+16>>2]=e;k[j+24>>2]=f;k[j+28>>2]=g;gna(j,i);r=h;return}function cna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,l=0;h=r;r=r+48|0;i=h+32|0;j=h;l=k[b+8>>2]|0;k[i>>2]=0;k[i+4>>2]=l;k[j>>2]=86356;k[j+4>>2]=a;k[j+8>>2]=b;k[j+12>>2]=c;k[j+20>>2]=d;k[j+16>>2]=e;k[j+24>>2]=f;k[j+28>>2]=g;ena(j,i);r=h;return}function dna(a){a=a|0;ggb(a);return}function ena(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0,i=0,j=0.0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0;G=r;r=r+1104|0;F=G;B=a+8|0;C=k[B>>2]|0;f=(k[C>>2]|0)>>>3;A=(f&511)+1|0;C=aa(A,k[(k[C+40>>2]|0)+4>>2]|0)|0;e=C<<1;D=F+8|0;k[F>>2]=D;E=F+4|0;k[E>>2]=136;if(e>>>0>136){d=e>>>0>536870911?-1:e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[F>>2]=c;x=c}else x=D;k[E>>2]=e;v=k[a+12>>2]|0;w=k[a+20>>2]|0;z=x+(C<<3)|0;u=k[a+28>>2]|0;e=k[u+(k[b>>2]<<2)>>2]|0;u=k[u+(k[b+4>>2]<<2)>>2]|0;d=a+16|0;c=k[(k[d>>2]|0)+(e*12|0)+4>>2]|0;y=(C|0)>0;if(y)zpb(z|0,0,C<<3|0)|0;a:do if((e|0)<(u|0)){t=k[d>>2]|0;s=k[a+4>>2]|0;q=k[s+16>>2]|0;s=k[k[s+44>>2]>>2]|0;n=f&65535;l=(w|0)>0;m=C<<3;while(1){j=+o[t+(e*12|0)+8>>2];i=k[t+(e*12|0)+4>>2]|0;h=q+(aa(s,k[t+(e*12|0)>>2]|0)|0)|0;if(y)zpb(x|0,0,m|0)|0;switch(n&511){case 0:{if(l){d=0;do{f=x+(k[v+(d*12|0)+4>>2]<<3)|0;p[f>>3]=+p[f>>3]+ +o[v+(d*12|0)+8>>2]*+p[h+(k[v+(d*12|0)>>2]<<3)>>3];d=d+1|0}while((d|0)!=(w|0))}break}case 1:{if(l){d=0;do{b=k[v+(d*12|0)>>2]|0;f=k[v+(d*12|0)+4>>2]|0;H=+o[v+(d*12|0)+8>>2];a=x+(f<<3)|0;f=x+(f+1<<3)|0;g=+p[f>>3]+H*+p[h+(b+1<<3)>>3];p[a>>3]=+p[a>>3]+H*+p[h+(b<<3)>>3];p[f>>3]=g;d=d+1|0}while((d|0)!=(w|0))}break}case 2:{if(l){d=0;do{I=k[v+(d*12|0)>>2]|0;f=k[v+(d*12|0)+4>>2]|0;J=+o[v+(d*12|0)+8>>2];b=x+(f<<3)|0;a=x+(f+1<<3)|0;g=+p[a>>3]+J*+p[h+(I+1<<3)>>3];f=x+(f+2<<3)|0;H=+p[f>>3]+J*+p[h+(I+2<<3)>>3];p[b>>3]=+p[b>>3]+J*+p[h+(I<<3)>>3];p[a>>3]=g;p[f>>3]=H;d=d+1|0}while((d|0)!=(w|0))}break}case 3:{if(l){d=0;do{a=k[v+(d*12|0)>>2]|0;I=k[v+(d*12|0)+4>>2]|0;H=+o[v+(d*12|0)+8>>2];b=x+(I<<3)|0;f=x+(I+1<<3)|0;J=+p[f>>3]+H*+p[h+(a+1<<3)>>3];p[b>>3]=+p[b>>3]+H*+p[h+(a<<3)>>3];p[f>>3]=J;f=x+(I+2<<3)|0;I=x+(I+3<<3)|0;J=+p[I>>3]+H*+p[h+(a+3<<3)>>3];p[f>>3]=+p[f>>3]+H*+p[h+(a+2<<3)>>3];p[I>>3]=J;d=d+1|0}while((d|0)!=(w|0))}break}default:if(l){b=0;do{a=k[v+(b*12|0)>>2]|0;f=k[v+(b*12|0)+4>>2]|0;g=+o[v+(b*12|0)+8>>2];d=0;do{I=x+(d+f<<3)|0;p[I>>3]=+p[I>>3]+g*+p[h+(d+a<<3)>>3];d=d+1|0}while((d|0)!=(A|0));b=b+1|0}while((b|0)!=(w|0))}}if((i|0)==(c|0)){if(y){d=0;do{I=z+(d<<3)|0;p[I>>3]=+p[I>>3]+j*+p[x+(d<<3)>>3];d=d+1|0}while((d|0)!=(C|0))}}else{d=k[B>>2]|0;d=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;if(y){c=0;do{I=z+(c<<3)|0;p[d+(c<<3)>>3]=+p[I>>3];p[I>>3]=j*+p[x+(c<<3)>>3];c=c+1|0}while((c|0)!=(C|0));c=i}else c=i}e=e+1|0;if((e|0)==(u|0))break a}}while(0);d=k[B>>2]|0;d=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;if(y){c=0;do{p[d+(c<<3)>>3]=+p[z+(c<<3)>>3];c=c+1|0}while((c|0)!=(C|0))}c=k[F>>2]|0;if((c|0)==(D|0)){r=G;return}if(c|0)ggb(c);k[F>>2]=D;k[E>>2]=136;r=G;return}function fna(a){a=a|0;ggb(a);return}function gna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0.0,h=0,i=0,j=0.0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0;F=r;r=r+1072|0;E=F;A=a+8|0;B=k[A>>2]|0;f=(k[B>>2]|0)>>>3;z=(f&511)+1|0;B=aa(z,k[(k[B+40>>2]|0)+4>>2]|0)|0;e=B<<1;C=E+8|0;k[E>>2]=C;D=E+4|0;k[D>>2]=264;if(e>>>0>264){d=e>>>0>1073741823?-1:e<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[E>>2]=c;w=c}else w=C;k[D>>2]=e;u=k[a+12>>2]|0;v=k[a+20>>2]|0;y=w+(B<<2)|0;t=k[a+28>>2]|0;e=k[t+(k[b>>2]<<2)>>2]|0;t=k[t+(k[b+4>>2]<<2)>>2]|0;d=a+16|0;c=k[(k[d>>2]|0)+(e*12|0)+4>>2]|0;x=(B|0)>0;if(x)zpb(y|0,0,B<<2|0)|0;a:do if((e|0)<(t|0)){s=k[d>>2]|0;q=k[a+4>>2]|0;p=k[q+16>>2]|0;q=k[k[q+44>>2]>>2]|0;n=f&65535;l=(v|0)>0;m=B<<2;while(1){j=+o[s+(e*12|0)+8>>2];i=k[s+(e*12|0)+4>>2]|0;h=p+(aa(q,k[s+(e*12|0)>>2]|0)|0)|0;if(x)zpb(w|0,0,m|0)|0;switch(n&511){case 0:{if(l){d=0;do{f=w+(k[u+(d*12|0)+4>>2]<<2)|0;o[f>>2]=+o[f>>2]+ +o[u+(d*12|0)+8>>2]*+o[h+(k[u+(d*12|0)>>2]<<2)>>2];d=d+1|0}while((d|0)!=(v|0))}break}case 1:{if(l){d=0;do{b=k[u+(d*12|0)>>2]|0;f=k[u+(d*12|0)+4>>2]|0;G=+o[u+(d*12|0)+8>>2];a=w+(f<<2)|0;f=w+(f+1<<2)|0;g=+o[f>>2]+G*+o[h+(b+1<<2)>>2];o[a>>2]=+o[a>>2]+G*+o[h+(b<<2)>>2];o[f>>2]=g;d=d+1|0}while((d|0)!=(v|0))}break}case 2:{if(l){d=0;do{H=k[u+(d*12|0)>>2]|0;f=k[u+(d*12|0)+4>>2]|0;I=+o[u+(d*12|0)+8>>2];b=w+(f<<2)|0;a=w+(f+1<<2)|0;g=+o[a>>2]+I*+o[h+(H+1<<2)>>2];f=w+(f+2<<2)|0;G=+o[f>>2]+I*+o[h+(H+2<<2)>>2];o[b>>2]=+o[b>>2]+I*+o[h+(H<<2)>>2];o[a>>2]=g;o[f>>2]=G;d=d+1|0}while((d|0)!=(v|0))}break}case 3:{if(l){d=0;do{a=k[u+(d*12|0)>>2]|0;H=k[u+(d*12|0)+4>>2]|0;G=+o[u+(d*12|0)+8>>2];b=w+(H<<2)|0;f=w+(H+1<<2)|0;I=+o[f>>2]+G*+o[h+(a+1<<2)>>2];o[b>>2]=+o[b>>2]+G*+o[h+(a<<2)>>2];o[f>>2]=I;f=w+(H+2<<2)|0;H=w+(H+3<<2)|0;I=+o[H>>2]+G*+o[h+(a+3<<2)>>2];o[f>>2]=+o[f>>2]+G*+o[h+(a+2<<2)>>2];o[H>>2]=I;d=d+1|0}while((d|0)!=(v|0))}break}default:if(l){b=0;do{a=k[u+(b*12|0)>>2]|0;f=k[u+(b*12|0)+4>>2]|0;g=+o[u+(b*12|0)+8>>2];d=0;do{H=w+(d+f<<2)|0;o[H>>2]=+o[H>>2]+g*+o[h+(d+a<<2)>>2];d=d+1|0}while((d|0)!=(z|0));b=b+1|0}while((b|0)!=(v|0))}}if((i|0)==(c|0)){if(x){d=0;do{H=y+(d<<2)|0;o[H>>2]=+o[H>>2]+j*+o[w+(d<<2)>>2];d=d+1|0}while((d|0)!=(B|0))}}else{d=k[A>>2]|0;d=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;if(x){c=0;do{H=y+(c<<2)|0;k[d+(c<<2)>>2]=k[H>>2];o[H>>2]=j*+o[w+(c<<2)>>2];c=c+1|0}while((c|0)!=(B|0));c=i}else c=i}e=e+1|0;if((e|0)==(t|0))break a}}while(0);d=k[A>>2]|0;d=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,c)|0)|0;if(x){c=0;do{k[d+(c<<2)>>2]=k[y+(c<<2)>>2];c=c+1|0}while((c|0)!=(B|0))}c=k[E>>2]|0;if((c|0)==(C|0)){r=F;return}if(c|0)ggb(c);k[E>>2]=C;k[D>>2]=264;r=F;return}function hna(a){a=a|0;ggb(a);return}function ina(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,i=0,l=0.0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0.0;H=r;r=r+1072|0;G=H;B=a+8|0;D=k[B>>2]|0;g=(k[D>>2]|0)>>>3;A=(g&511)+1|0;D=aa(A,k[(k[D+40>>2]|0)+4>>2]|0)|0;f=D<<1;E=G+8|0;k[G>>2]=E;F=G+4|0;k[F>>2]=264;if(f>>>0>264){e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[G>>2]=c;y=c}else y=E;k[F>>2]=f;w=k[a+12>>2]|0;x=k[a+20>>2]|0;C=y+(D<<2)|0;v=k[a+28>>2]|0;f=k[v+(k[b>>2]<<2)>>2]|0;v=k[v+(k[b+4>>2]<<2)>>2]|0;e=a+16|0;c=k[(k[e>>2]|0)+(f*12|0)+4>>2]|0;z=(D|0)>0;if(z)zpb(C|0,0,D<<2|0)|0;a:do if((f|0)<(v|0)){t=k[e>>2]|0;s=k[a+4>>2]|0;q=k[s+16>>2]|0;s=k[k[s+44>>2]>>2]|0;p=g&65535;m=(x|0)>0;n=D<<2;while(1){l=+o[t+(f*12|0)+8>>2];i=k[t+(f*12|0)+4>>2]|0;h=q+(aa(s,k[t+(f*12|0)>>2]|0)|0)|0;if(z)zpb(y|0,0,n|0)|0;switch(p&511){case 0:{if(m){e=0;do{g=y+(k[w+(e*12|0)+4>>2]<<2)|0;o[g>>2]=+o[g>>2]+ +o[w+(e*12|0)+8>>2]*+(j[h+(k[w+(e*12|0)>>2]<<1)>>1]|0);e=e+1|0}while((e|0)!=(x|0))}break}case 1:{if(m){e=0;do{b=k[w+(e*12|0)>>2]|0;g=k[w+(e*12|0)+4>>2]|0;I=+o[w+(e*12|0)+8>>2];a=y+(g<<2)|0;g=y+(g+1<<2)|0;d=+o[g>>2]+I*+(j[h+(b+1<<1)>>1]|0);o[a>>2]=+o[a>>2]+I*+(j[h+(b<<1)>>1]|0);o[g>>2]=d;e=e+1|0}while((e|0)!=(x|0))}break}case 2:{if(m){e=0;do{J=k[w+(e*12|0)>>2]|0;g=k[w+(e*12|0)+4>>2]|0;K=+o[w+(e*12|0)+8>>2];b=y+(g<<2)|0;a=y+(g+1<<2)|0;d=+o[a>>2]+K*+(j[h+(J+1<<1)>>1]|0);g=y+(g+2<<2)|0;I=+o[g>>2]+K*+(j[h+(J+2<<1)>>1]|0);o[b>>2]=+o[b>>2]+K*+(j[h+(J<<1)>>1]|0);o[a>>2]=d;o[g>>2]=I;e=e+1|0}while((e|0)!=(x|0))}break}case 3:{if(m){e=0;do{a=k[w+(e*12|0)>>2]|0;J=k[w+(e*12|0)+4>>2]|0;I=+o[w+(e*12|0)+8>>2];b=y+(J<<2)|0;g=y+(J+1<<2)|0;K=+o[g>>2]+I*+(j[h+(a+1<<1)>>1]|0);o[b>>2]=+o[b>>2]+I*+(j[h+(a<<1)>>1]|0);o[g>>2]=K;g=y+(J+2<<2)|0;J=y+(J+3<<2)|0;K=+o[J>>2]+I*+(j[h+(a+3<<1)>>1]|0);o[g>>2]=+o[g>>2]+I*+(j[h+(a+2<<1)>>1]|0);o[J>>2]=K;e=e+1|0}while((e|0)!=(x|0))}break}default:if(m){b=0;do{a=k[w+(b*12|0)>>2]|0;g=k[w+(b*12|0)+4>>2]|0;d=+o[w+(b*12|0)+8>>2];e=0;do{J=y+(e+g<<2)|0;o[J>>2]=+o[J>>2]+d*+(j[h+(e+a<<1)>>1]|0);e=e+1|0}while((e|0)!=(A|0));b=b+1|0}while((b|0)!=(x|0))}}if((i|0)==(c|0)){if(z){e=0;do{J=C+(e<<2)|0;o[J>>2]=+o[J>>2]+l*+o[y+(e<<2)>>2];e=e+1|0}while((e|0)!=(D|0))}}else{b=k[B>>2]|0;b=(k[b+16>>2]|0)+(aa(k[k[b+44>>2]>>2]|0,c)|0)|0;if(z){e=0;do{a=C+(e<<2)|0;d=+o[a>>2];c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}J=~~d;j[b+(e<<1)>>1]=(J+32768|0)>>>0<65536?J:(J|0)>0?32767:32768;o[a>>2]=l*+o[y+(e<<2)>>2];e=e+1|0}while((e|0)!=(D|0));c=i}else c=i}f=f+1|0;if((f|0)==(v|0))break a}}while(0);f=k[B>>2]|0;f=(k[f+16>>2]|0)+(aa(k[k[f+44>>2]>>2]|0,c)|0)|0;if(z){e=0;do{d=+o[C+(e<<2)>>2];c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}J=~~d;j[f+(e<<1)>>1]=(J+32768|0)>>>0<65536?J:(J|0)>0?32767:32768;e=e+1|0}while((e|0)!=(D|0))}c=k[G>>2]|0;if((c|0)==(E|0)){r=H;return}if(c|0)ggb(c);k[G>>2]=E;k[F>>2]=264;r=H;return}function jna(a){a=a|0;ggb(a);return}function kna(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,i=0,l=0.0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0.0;I=r;r=r+1072|0;H=I;C=a+8|0;E=k[C>>2]|0;g=(k[E>>2]|0)>>>3;B=(g&511)+1|0;E=aa(B,k[(k[E+40>>2]|0)+4>>2]|0)|0;f=E<<1;F=H+8|0;k[H>>2]=F;G=H+4|0;k[G>>2]=264;if(f>>>0>264){e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[H>>2]=c;z=c}else z=F;k[G>>2]=f;x=k[a+12>>2]|0;y=k[a+20>>2]|0;D=z+(E<<2)|0;w=k[a+28>>2]|0;f=k[w+(k[b>>2]<<2)>>2]|0;w=k[w+(k[b+4>>2]<<2)>>2]|0;e=a+16|0;c=k[(k[e>>2]|0)+(f*12|0)+4>>2]|0;A=(E|0)>0;if(A)zpb(D|0,0,E<<2|0)|0;a:do if((f|0)<(w|0)){v=k[e>>2]|0;t=k[a+4>>2]|0;s=k[t+16>>2]|0;t=k[k[t+44>>2]>>2]|0;q=g&65535;n=(y|0)>0;p=E<<2;while(1){l=+o[v+(f*12|0)+8>>2];i=k[v+(f*12|0)+4>>2]|0;h=s+(aa(t,k[v+(f*12|0)>>2]|0)|0)|0;if(A)zpb(z|0,0,p|0)|0;switch(q&511){case 0:{if(n){e=0;do{g=z+(k[x+(e*12|0)+4>>2]<<2)|0;o[g>>2]=+o[g>>2]+ +o[x+(e*12|0)+8>>2]*+(m[h+(k[x+(e*12|0)>>2]<<1)>>1]|0);e=e+1|0}while((e|0)!=(y|0))}break}case 1:{if(n){e=0;do{b=k[x+(e*12|0)>>2]|0;g=k[x+(e*12|0)+4>>2]|0;J=+o[x+(e*12|0)+8>>2];a=z+(g<<2)|0;g=z+(g+1<<2)|0;d=+o[g>>2]+J*+(m[h+(b+1<<1)>>1]|0);o[a>>2]=+o[a>>2]+J*+(m[h+(b<<1)>>1]|0);o[g>>2]=d;e=e+1|0}while((e|0)!=(y|0))}break}case 2:{if(n){e=0;do{K=k[x+(e*12|0)>>2]|0;g=k[x+(e*12|0)+4>>2]|0;L=+o[x+(e*12|0)+8>>2];b=z+(g<<2)|0;a=z+(g+1<<2)|0;d=+o[a>>2]+L*+(m[h+(K+1<<1)>>1]|0);g=z+(g+2<<2)|0;J=+o[g>>2]+L*+(m[h+(K+2<<1)>>1]|0);o[b>>2]=+o[b>>2]+L*+(m[h+(K<<1)>>1]|0);o[a>>2]=d;o[g>>2]=J;e=e+1|0}while((e|0)!=(y|0))}break}case 3:{if(n){e=0;do{a=k[x+(e*12|0)>>2]|0;K=k[x+(e*12|0)+4>>2]|0;J=+o[x+(e*12|0)+8>>2];b=z+(K<<2)|0;g=z+(K+1<<2)|0;L=+o[g>>2]+J*+(m[h+(a+1<<1)>>1]|0);o[b>>2]=+o[b>>2]+J*+(m[h+(a<<1)>>1]|0);o[g>>2]=L;g=z+(K+2<<2)|0;K=z+(K+3<<2)|0;L=+o[K>>2]+J*+(m[h+(a+3<<1)>>1]|0);o[g>>2]=+o[g>>2]+J*+(m[h+(a+2<<1)>>1]|0);o[K>>2]=L;e=e+1|0}while((e|0)!=(y|0))}break}default:if(n){b=0;do{a=k[x+(b*12|0)>>2]|0;g=k[x+(b*12|0)+4>>2]|0;d=+o[x+(b*12|0)+8>>2];e=0;do{K=z+(e+g<<2)|0;o[K>>2]=+o[K>>2]+d*+(m[h+(e+a<<1)>>1]|0);e=e+1|0}while((e|0)!=(B|0));b=b+1|0}while((b|0)!=(y|0))}}if((i|0)==(c|0)){if(A){e=0;do{K=D+(e<<2)|0;o[K>>2]=+o[K>>2]+l*+o[z+(e<<2)>>2];e=e+1|0}while((e|0)!=(E|0))}}else{b=k[C>>2]|0;b=(k[b+16>>2]|0)+(aa(k[k[b+44>>2]>>2]|0,c)|0)|0;if(A){e=0;do{a=D+(e<<2)|0;d=+o[a>>2];c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}K=~~d;j[b+(e<<1)>>1]=K>>>0<65536?K:(K|0)>0?65535:0;o[a>>2]=l*+o[z+(e<<2)>>2];e=e+1|0}while((e|0)!=(E|0));c=i}else c=i}f=f+1|0;if((f|0)==(w|0))break a}}while(0);f=k[C>>2]|0;f=(k[f+16>>2]|0)+(aa(k[k[f+44>>2]>>2]|0,c)|0)|0;if(A){e=0;do{d=+o[D+(e<<2)>>2];c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}K=~~d;j[f+(e<<1)>>1]=K>>>0<65536?K:(K|0)>0?65535:0;e=e+1|0}while((e|0)!=(E|0))}c=k[H>>2]|0;if((c|0)==(F|0)){r=I;return}if(c|0)ggb(c);k[H>>2]=F;k[G>>2]=264;r=I;return}function lna(a){a=a|0;ggb(a);return}function mna(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0.0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0.0;H=r;r=r+1072|0;G=H;B=a+8|0;D=k[B>>2]|0;g=(k[D>>2]|0)>>>3;A=(g&511)+1|0;D=aa(A,k[(k[D+40>>2]|0)+4>>2]|0)|0;f=D<<1;E=G+8|0;k[G>>2]=E;F=G+4|0;k[F>>2]=264;if(f>>>0>264){e=f>>>0>1073741823?-1:f<<2;e=(e|0)==0?1:e;while(1){c=fgb(e)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}k[G>>2]=c;y=c}else y=E;k[F>>2]=f;w=k[a+12>>2]|0;x=k[a+20>>2]|0;C=y+(D<<2)|0;t=k[a+28>>2]|0;e=k[t+(k[b>>2]<<2)>>2]|0;t=k[t+(k[b+4>>2]<<2)>>2]|0;v=a+16|0;c=k[(k[v>>2]|0)+(e*12|0)+4>>2]|0;z=(D|0)>0;if(z)zpb(C|0,0,D<<2|0)|0;a:do if((e|0)<(t|0)){s=a+4|0;q=g&65535;n=(x|0)>0;p=D<<2;m=e;while(1){g=k[v>>2]|0;j=+o[g+(m*12|0)+8>>2];h=k[g+(m*12|0)+4>>2]|0;a=k[s>>2]|0;g=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,k[g+(m*12|0)>>2]|0)|0)|0;if(z)zpb(y|0,0,p|0)|0;switch(q&511){case 0:{if(n){e=0;do{a=y+(k[w+(e*12|0)+4>>2]<<2)|0;o[a>>2]=+o[a>>2]+ +o[w+(e*12|0)+8>>2]*+(l[g+(k[w+(e*12|0)>>2]|0)>>0]|0);e=e+1|0}while((e|0)!=(x|0))}break}case 1:{if(n){e=0;do{f=k[w+(e*12|0)>>2]|0;a=k[w+(e*12|0)+4>>2]|0;I=+o[w+(e*12|0)+8>>2];b=y+(a<<2)|0;a=y+(a+1<<2)|0;d=+o[a>>2]+I*+(l[g+(f+1)>>0]|0);o[b>>2]=+o[b>>2]+I*+(l[g+f>>0]|0);o[a>>2]=d;e=e+1|0}while((e|0)!=(x|0))}break}case 2:{if(n){e=0;do{J=k[w+(e*12|0)>>2]|0;a=k[w+(e*12|0)+4>>2]|0;K=+o[w+(e*12|0)+8>>2];f=y+(a<<2)|0;b=y+(a+1<<2)|0;d=+o[b>>2]+K*+(l[g+(J+1)>>0]|0);a=y+(a+2<<2)|0;I=+o[a>>2]+K*+(l[g+(J+2)>>0]|0);o[f>>2]=+o[f>>2]+K*+(l[g+J>>0]|0);o[b>>2]=d;o[a>>2]=I;e=e+1|0}while((e|0)!=(x|0))}break}case 3:{if(n){e=0;do{b=k[w+(e*12|0)>>2]|0;J=k[w+(e*12|0)+4>>2]|0;I=+o[w+(e*12|0)+8>>2];f=y+(J<<2)|0;a=y+(J+1<<2)|0;K=+o[a>>2]+I*+(l[g+(b+1)>>0]|0);o[f>>2]=+o[f>>2]+I*+(l[g+b>>0]|0);o[a>>2]=K;a=y+(J+2<<2)|0;J=y+(J+3<<2)|0;K=+o[J>>2]+I*+(l[g+(b+3)>>0]|0);o[a>>2]=+o[a>>2]+I*+(l[g+(b+2)>>0]|0);o[J>>2]=K;e=e+1|0}while((e|0)!=(x|0))}break}default:if(n){f=0;do{b=k[w+(f*12|0)>>2]|0;a=k[w+(f*12|0)+4>>2]|0;d=+o[w+(f*12|0)+8>>2];e=0;do{J=y+(e+a<<2)|0;o[J>>2]=+o[J>>2]+d*+(l[g+(e+b)>>0]|0);e=e+1|0}while((e|0)!=(A|0));f=f+1|0}while((f|0)!=(x|0))}}if((h|0)==(c|0)){if(z){e=0;do{J=C+(e<<2)|0;o[J>>2]=+o[J>>2]+j*+o[y+(e<<2)>>2];e=e+1|0}while((e|0)!=(D|0))}}else{f=k[B>>2]|0;f=(k[f+16>>2]|0)+(aa(k[k[f+44>>2]>>2]|0,c)|0)|0;if(z){e=0;do{b=C+(e<<2)|0;d=+o[b>>2];c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}J=~~d;i[f+e>>0]=J>>>0<256?J:(J|0)>0?255:0;o[b>>2]=j*+o[y+(e<<2)>>2];e=e+1|0}while((e|0)!=(D|0));c=h}else c=h}m=m+1|0;if((m|0)==(t|0))break a}}while(0);f=k[B>>2]|0;f=(k[f+16>>2]|0)+(aa(k[k[f+44>>2]>>2]|0,c)|0)|0;if(z){e=0;do{d=+o[C+(e<<2)>>2];c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}J=~~d;i[f+e>>0]=J>>>0<256?J:(J|0)>0?255:0;e=e+1|0}while((e|0)!=(D|0))}c=k[G>>2]|0;if((c|0)==(E|0)){r=H;return}if(c|0)ggb(c);k[G>>2]=E;k[F>>2]=264;r=H;return}function nna(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+144|0;q=t+136|0;s=t;p=b+8|0;j=k[p>>2]|0;k[q>>2]=0;k[q+4>>2]=j;k[s>>2]=86536;j=s+4|0;k[j>>2]=k[a>>2];o=s+8|0;h=a+4|0;g=k[h>>2]|0;k[o>>2]=g;l=s+12|0;k[l>>2]=k[a+8>>2];k[s+16>>2]=k[a+12>>2];k[s+20>>2]=k[a+16>>2];k[s+24>>2]=k[a+20>>2];k[s+28>>2]=k[a+24>>2];k[s+32>>2]=k[a+28>>2];k[s+36>>2]=k[a+32>>2];i=k[a+36>>2]|0;k[s+40>>2]=i;m=s+44|0;k[m>>2]=l;l=s+52|0;n=s+48|0;k[n>>2]=l;k[s+56>>2]=0;k[l>>2]=0;if(i){g=i+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[o>>2]=0;x1(j,g,0,0,0);if((k[o>>2]|0)>0){l=k[a+40>>2]|0;j=k[m>>2]|0;i=k[a+44>>2]|0;h=k[n>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[l+(g<<2)>>2];k[h+(g<<2)>>2]=k[i+(g<<2)>>2];g=g+1|0}while((g|0)<(k[o>>2]|0))}}else{a=k[a+44>>2]|0;o=k[n>>2]|0;k[o>>2]=k[a>>2];k[o+4>>2]=k[a+4>>2]}l=s+60|0;k[l>>2]=k[b>>2];a=s+64|0;i=b+4|0;g=k[i>>2]|0;k[a>>2]=g;m=s+68|0;k[m>>2]=k[p>>2];k[s+72>>2]=k[b+12>>2];k[s+76>>2]=k[b+16>>2];k[s+80>>2]=k[b+20>>2];k[s+84>>2]=k[b+24>>2];k[s+88>>2]=k[b+28>>2];k[s+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[s+96>>2]=h;j=s+100|0;k[j>>2]=m;p=s+108|0;m=s+104|0;k[m>>2]=p;k[s+112>>2]=0;k[p>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[i>>2]|0}if((g|0)<3){p=k[b+44>>2]|0;b=k[m>>2]|0;k[b>>2]=k[p>>2];k[b+4>>2]=k[p+4>>2];b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);Ena(s);r=t;return}k[a>>2]=0;x1(l,g,0,0,0);if((k[a>>2]|0)<=0){b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);Ena(s);r=t;return}l=k[b+40>>2]|0;j=k[j>>2]|0;i=k[b+44>>2]|0;h=k[m>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[l+(g<<2)>>2];k[h+(g<<2)>>2]=k[i+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0));b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);Ena(s);r=t;return}function ona(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+144|0;q=t+136|0;s=t;p=b+8|0;j=k[p>>2]|0;k[q>>2]=0;k[q+4>>2]=j;k[s>>2]=86516;j=s+4|0;k[j>>2]=k[a>>2];o=s+8|0;h=a+4|0;g=k[h>>2]|0;k[o>>2]=g;l=s+12|0;k[l>>2]=k[a+8>>2];k[s+16>>2]=k[a+12>>2];k[s+20>>2]=k[a+16>>2];k[s+24>>2]=k[a+20>>2];k[s+28>>2]=k[a+24>>2];k[s+32>>2]=k[a+28>>2];k[s+36>>2]=k[a+32>>2];i=k[a+36>>2]|0;k[s+40>>2]=i;m=s+44|0;k[m>>2]=l;l=s+52|0;n=s+48|0;k[n>>2]=l;k[s+56>>2]=0;k[l>>2]=0;if(i){g=i+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[o>>2]=0;x1(j,g,0,0,0);if((k[o>>2]|0)>0){l=k[a+40>>2]|0;j=k[m>>2]|0;i=k[a+44>>2]|0;h=k[n>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[l+(g<<2)>>2];k[h+(g<<2)>>2]=k[i+(g<<2)>>2];g=g+1|0}while((g|0)<(k[o>>2]|0))}}else{a=k[a+44>>2]|0;o=k[n>>2]|0;k[o>>2]=k[a>>2];k[o+4>>2]=k[a+4>>2]}l=s+60|0;k[l>>2]=k[b>>2];a=s+64|0;i=b+4|0;g=k[i>>2]|0;k[a>>2]=g;m=s+68|0;k[m>>2]=k[p>>2];k[s+72>>2]=k[b+12>>2];k[s+76>>2]=k[b+16>>2];k[s+80>>2]=k[b+20>>2];k[s+84>>2]=k[b+24>>2];k[s+88>>2]=k[b+28>>2];k[s+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[s+96>>2]=h;j=s+100|0;k[j>>2]=m;p=s+108|0;m=s+104|0;k[m>>2]=p;k[s+112>>2]=0;k[p>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[i>>2]|0}if((g|0)<3){p=k[b+44>>2]|0;b=k[m>>2]|0;k[b>>2]=k[p>>2];k[b+4>>2]=k[p+4>>2];b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);Bna(s);r=t;return}k[a>>2]=0;x1(l,g,0,0,0);if((k[a>>2]|0)<=0){b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);Bna(s);r=t;return}l=k[b+40>>2]|0;j=k[j>>2]|0;i=k[b+44>>2]|0;h=k[m>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[l+(g<<2)>>2];k[h+(g<<2)>>2]=k[i+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0));b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);Bna(s);r=t;return}function pna(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+144|0;q=t+136|0;s=t;p=b+8|0;j=k[p>>2]|0;k[q>>2]=0;k[q+4>>2]=j;k[s>>2]=86496;j=s+4|0;k[j>>2]=k[a>>2];o=s+8|0;h=a+4|0;g=k[h>>2]|0;k[o>>2]=g;l=s+12|0;k[l>>2]=k[a+8>>2];k[s+16>>2]=k[a+12>>2];k[s+20>>2]=k[a+16>>2];k[s+24>>2]=k[a+20>>2];k[s+28>>2]=k[a+24>>2];k[s+32>>2]=k[a+28>>2];k[s+36>>2]=k[a+32>>2];i=k[a+36>>2]|0;k[s+40>>2]=i;m=s+44|0;k[m>>2]=l;l=s+52|0;n=s+48|0;k[n>>2]=l;k[s+56>>2]=0;k[l>>2]=0;if(i){g=i+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[o>>2]=0;x1(j,g,0,0,0);if((k[o>>2]|0)>0){l=k[a+40>>2]|0;j=k[m>>2]|0;i=k[a+44>>2]|0;h=k[n>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[l+(g<<2)>>2];k[h+(g<<2)>>2]=k[i+(g<<2)>>2];g=g+1|0}while((g|0)<(k[o>>2]|0))}}else{a=k[a+44>>2]|0;o=k[n>>2]|0;k[o>>2]=k[a>>2];k[o+4>>2]=k[a+4>>2]}l=s+60|0;k[l>>2]=k[b>>2];a=s+64|0;i=b+4|0;g=k[i>>2]|0;k[a>>2]=g;m=s+68|0;k[m>>2]=k[p>>2];k[s+72>>2]=k[b+12>>2];k[s+76>>2]=k[b+16>>2];k[s+80>>2]=k[b+20>>2];k[s+84>>2]=k[b+24>>2];k[s+88>>2]=k[b+28>>2];k[s+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[s+96>>2]=h;j=s+100|0;k[j>>2]=m;p=s+108|0;m=s+104|0;k[m>>2]=p;k[s+112>>2]=0;k[p>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[i>>2]|0}if((g|0)<3){p=k[b+44>>2]|0;b=k[m>>2]|0;k[b>>2]=k[p>>2];k[b+4>>2]=k[p+4>>2];b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);yna(s);r=t;return}k[a>>2]=0;x1(l,g,0,0,0);if((k[a>>2]|0)<=0){b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);yna(s);r=t;return}l=k[b+40>>2]|0;j=k[j>>2]|0;i=k[b+44>>2]|0;h=k[m>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[l+(g<<2)>>2];k[h+(g<<2)>>2]=k[i+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0));b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);yna(s);r=t;return}function qna(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+144|0;q=t+136|0;s=t;p=b+8|0;j=k[p>>2]|0;k[q>>2]=0;k[q+4>>2]=j;k[s>>2]=86476;j=s+4|0;k[j>>2]=k[a>>2];o=s+8|0;h=a+4|0;g=k[h>>2]|0;k[o>>2]=g;l=s+12|0;k[l>>2]=k[a+8>>2];k[s+16>>2]=k[a+12>>2];k[s+20>>2]=k[a+16>>2];k[s+24>>2]=k[a+20>>2];k[s+28>>2]=k[a+24>>2];k[s+32>>2]=k[a+28>>2];k[s+36>>2]=k[a+32>>2];i=k[a+36>>2]|0;k[s+40>>2]=i;m=s+44|0;k[m>>2]=l;l=s+52|0;n=s+48|0;k[n>>2]=l;k[s+56>>2]=0;k[l>>2]=0;if(i){g=i+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[o>>2]=0;x1(j,g,0,0,0);if((k[o>>2]|0)>0){l=k[a+40>>2]|0;j=k[m>>2]|0;i=k[a+44>>2]|0;h=k[n>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[l+(g<<2)>>2];k[h+(g<<2)>>2]=k[i+(g<<2)>>2];g=g+1|0}while((g|0)<(k[o>>2]|0))}}else{a=k[a+44>>2]|0;o=k[n>>2]|0;k[o>>2]=k[a>>2];k[o+4>>2]=k[a+4>>2]}l=s+60|0;k[l>>2]=k[b>>2];a=s+64|0;i=b+4|0;g=k[i>>2]|0;k[a>>2]=g;m=s+68|0;k[m>>2]=k[p>>2];k[s+72>>2]=k[b+12>>2];k[s+76>>2]=k[b+16>>2];k[s+80>>2]=k[b+20>>2];k[s+84>>2]=k[b+24>>2];k[s+88>>2]=k[b+28>>2];k[s+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[s+96>>2]=h;j=s+100|0;k[j>>2]=m;p=s+108|0;m=s+104|0;k[m>>2]=p;k[s+112>>2]=0;k[p>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[i>>2]|0}if((g|0)<3){p=k[b+44>>2]|0;b=k[m>>2]|0;k[b>>2]=k[p>>2];k[b+4>>2]=k[p+4>>2];b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);vna(s);r=t;return}k[a>>2]=0;x1(l,g,0,0,0);if((k[a>>2]|0)<=0){b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);vna(s);r=t;return}l=k[b+40>>2]|0;j=k[j>>2]|0;i=k[b+44>>2]|0;h=k[m>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[l+(g<<2)>>2];k[h+(g<<2)>>2]=k[i+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0));b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);vna(s);r=t;return}function rna(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;t=r;r=r+144|0;q=t+136|0;s=t;p=b+8|0;j=k[p>>2]|0;k[q>>2]=0;k[q+4>>2]=j;k[s>>2]=86456;j=s+4|0;k[j>>2]=k[a>>2];o=s+8|0;h=a+4|0;g=k[h>>2]|0;k[o>>2]=g;l=s+12|0;k[l>>2]=k[a+8>>2];k[s+16>>2]=k[a+12>>2];k[s+20>>2]=k[a+16>>2];k[s+24>>2]=k[a+20>>2];k[s+28>>2]=k[a+24>>2];k[s+32>>2]=k[a+28>>2];k[s+36>>2]=k[a+32>>2];i=k[a+36>>2]|0;k[s+40>>2]=i;m=s+44|0;k[m>>2]=l;l=s+52|0;n=s+48|0;k[n>>2]=l;k[s+56>>2]=0;k[l>>2]=0;if(i){g=i+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[o>>2]=0;x1(j,g,0,0,0);if((k[o>>2]|0)>0){l=k[a+40>>2]|0;j=k[m>>2]|0;i=k[a+44>>2]|0;h=k[n>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[l+(g<<2)>>2];k[h+(g<<2)>>2]=k[i+(g<<2)>>2];g=g+1|0}while((g|0)<(k[o>>2]|0))}}else{a=k[a+44>>2]|0;o=k[n>>2]|0;k[o>>2]=k[a>>2];k[o+4>>2]=k[a+4>>2]}l=s+60|0;k[l>>2]=k[b>>2];a=s+64|0;i=b+4|0;g=k[i>>2]|0;k[a>>2]=g;m=s+68|0;k[m>>2]=k[p>>2];k[s+72>>2]=k[b+12>>2];k[s+76>>2]=k[b+16>>2];k[s+80>>2]=k[b+20>>2];k[s+84>>2]=k[b+24>>2];k[s+88>>2]=k[b+28>>2];k[s+92>>2]=k[b+32>>2];h=k[b+36>>2]|0;k[s+96>>2]=h;j=s+100|0;k[j>>2]=m;p=s+108|0;m=s+104|0;k[m>>2]=p;k[s+112>>2]=0;k[p>>2]=0;if(h){g=h+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[i>>2]|0}if((g|0)<3){p=k[b+44>>2]|0;b=k[m>>2]|0;k[b>>2]=k[p>>2];k[b+4>>2]=k[p+4>>2];b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);sna(s);r=t;return}k[a>>2]=0;x1(l,g,0,0,0);if((k[a>>2]|0)<=0){b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);sna(s);r=t;return}l=k[b+40>>2]|0;j=k[j>>2]|0;i=k[b+44>>2]|0;h=k[m>>2]|0;g=0;do{k[j+(g<<2)>>2]=k[l+(g<<2)>>2];k[h+(g<<2)>>2]=k[i+(g<<2)>>2];g=g+1|0}while((g|0)<(k[a>>2]|0));b=s+116|0;k[b>>2]=e;e=s+120|0;k[e>>2]=f;f=s+124|0;k[f>>2]=c;f=s+128|0;k[f>>2]=d;f=k[s>>2]|0;f=f+8|0;f=k[f>>2]|0;jh[f&1023](s,q);sna(s);r=t;return}function sna(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86456;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function tna(a){a=a|0;sna(a);ggb(a);return}function una(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=k[a+44>>2]|0;N=k[P+4>>2]|0;P=k[P>>2]|0;G=((k[a+4>>2]|0)>>>3&511)+1|0;H=a+116|0;L=k[H>>2]|0;I=a+120|0;J=k[I>>2]|0;K=aa(J,L)|0;L=aa((N|0)/(L|0)|0,G)|0;M=aa(G,k[(k[a+100>>2]|0)+4>>2]|0)|0;N=aa(G,N)|0;O=k[b>>2]|0;b=k[b+4>>2]|0;if((b|0)<=(O|0))return;x=k[a+76>>2]|0;y=k[a+108>>2]|0;z=a+20|0;A=a+48|0;B=a+128|0;D=K+-4|0;E=(K|0)<4;F=1.0/+(K|0);r=a+124|0;s=(M|0)>0;t=M<<3;u=K&-4;v=(u|0)<(K|0);w=(K|0)>0;n=b-O|0;m=O;q=0;while(1){a=x+(aa(O+q|0,y)|0)|0;o=x+(aa(y,m)|0)|0;l=aa(J,m)|0;b=(l+J|0)<=(P|0)?L:0;a:do if((l|0)<(P|0)){b:do if((b|0)>0){g=(k[z>>2]|0)+(aa(k[k[A>>2]>>2]|0,l)|0)|0;h=k[B>>2]|0;if(E){f=0;while(1){d=g+(k[h+(f<<2)>>2]<<3)|0;if(w){e=k[r>>2]|0;c=0.0;a=0;do{c=c+ +p[d+(k[e+(a<<2)>>2]<<3)>>3];a=a+1|0}while((a|0)!=(K|0))}else c=0.0;p[o+(f<<3)>>3]=F*c;f=f+1|0;if((f|0)==(b|0))break b}}f=k[r>>2]|0;e=0;do{d=g+(k[h+(e<<2)>>2]<<3)|0;c=0.0;a=0;do{c=c+(+p[d+(k[f+(a<<2)>>2]<<3)>>3]+ +p[d+(k[f+((a|1)<<2)>>2]<<3)>>3]+ +p[d+(k[f+((a|2)<<2)>>2]<<3)>>3]+ +p[d+(k[f+((a|3)<<2)>>2]<<3)>>3]);a=a+4|0}while((a|0)<=(D|0));if(v){a=u;do{c=c+ +p[d+(k[f+(a<<2)>>2]<<3)>>3];a=a+1|0}while((a|0)!=(K|0))}p[o+(e<<3)>>3]=F*c;e=e+1|0}while((e|0)!=(b|0))}else b=0;while(0);if((b|0)<(M|0)){j=k[B>>2]|0;i=k[I>>2]|0;if((i|0)<=0)while(1){a=o+(b<<3)|0;if((k[j+(b<<2)>>2]|0)>=(N|0))p[a>>3]=0.0;p[a>>3]=C;b=b+1|0;if((b|0)==(M|0))break a}do{h=k[j+(b<<2)>>2]|0;if((h|0)<(N|0)){g=0;d=0;c=0.0;do{a=g+l|0;if((a|0)>=(P|0))break;e=(k[z>>2]|0)+(aa(k[k[A>>2]>>2]|0,a)|0)+(h<<3)|0;f=aa(k[H>>2]|0,G)|0;if((f|0)>0){a=0;do{c=c+ +p[e+(a<<3)>>3];d=d+1|0;a=a+G|0}while((a+h|0)<(N|0)&(a|0)<(f|0))}g=g+1|0}while((g|0)<(i|0));a=o+(b<<3)|0}else{a=o+(b<<3)|0;p[a>>3]=0.0;d=0;c=0.0}p[a>>3]=c/+(d|0);b=b+1|0}while((b|0)!=(M|0))}}else if(s)zpb(a|0,0,t|0)|0;while(0);q=q+1|0;if((q|0)==(n|0))break;else m=m+1|0}return}function vna(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86476;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function wna(a){a=a|0;vna(a);ggb(a);return}function xna(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0;P=k[a+44>>2]|0;N=k[P+4>>2]|0;P=k[P>>2]|0;F=((k[a+4>>2]|0)>>>3&511)+1|0;G=a+116|0;L=k[G>>2]|0;H=a+120|0;I=k[H>>2]|0;J=aa(I,L)|0;K=1.0/+(J|0);L=aa((N|0)/(L|0)|0,F)|0;M=aa(F,k[(k[a+100>>2]|0)+4>>2]|0)|0;N=aa(F,N)|0;O=k[b>>2]|0;b=k[b+4>>2]|0;if((b|0)<=(O|0))return;x=k[a+76>>2]|0;y=k[a+108>>2]|0;z=a+20|0;A=a+48|0;B=a+128|0;D=J+-4|0;E=(J|0)<4;r=a+124|0;s=(M|0)>0;t=M<<2;u=J&-4;v=(u|0)<(J|0);w=(J|0)>0;n=b-O|0;m=O;q=0;while(1){a=x+(aa(O+q|0,y)|0)|0;p=x+(aa(y,m)|0)|0;l=aa(I,m)|0;b=(l+I|0)<=(P|0)?L:0;a:do if((l|0)<(P|0)){b:do if((b|0)>0){g=(k[z>>2]|0)+(aa(k[k[A>>2]>>2]|0,l)|0)|0;h=k[B>>2]|0;if(E){f=0;while(1){d=g+(k[h+(f<<2)>>2]<<2)|0;if(w){e=k[r>>2]|0;c=0.0;a=0;do{c=c+ +o[d+(k[e+(a<<2)>>2]<<2)>>2];a=a+1|0}while((a|0)!=(J|0))}else c=0.0;o[p+(f<<2)>>2]=K*c;f=f+1|0;if((f|0)==(b|0))break b}}f=k[r>>2]|0;e=0;do{d=g+(k[h+(e<<2)>>2]<<2)|0;c=0.0;a=0;do{c=c+(+o[d+(k[f+(a<<2)>>2]<<2)>>2]+ +o[d+(k[f+((a|1)<<2)>>2]<<2)>>2]+ +o[d+(k[f+((a|2)<<2)>>2]<<2)>>2]+ +o[d+(k[f+((a|3)<<2)>>2]<<2)>>2]);a=a+4|0}while((a|0)<=(D|0));if(v){a=u;do{c=c+ +o[d+(k[f+(a<<2)>>2]<<2)>>2];a=a+1|0}while((a|0)!=(J|0))}o[p+(e<<2)>>2]=K*c;e=e+1|0}while((e|0)!=(b|0))}else b=0;while(0);if((b|0)<(M|0)){j=k[B>>2]|0;i=k[H>>2]|0;if((i|0)<=0)while(1){a=p+(b<<2)|0;if((k[j+(b<<2)>>2]|0)>=(N|0))o[a>>2]=0.0;o[a>>2]=C;b=b+1|0;if((b|0)==(M|0))break a}do{h=k[j+(b<<2)>>2]|0;if((h|0)<(N|0)){g=0;d=0;c=0.0;do{a=g+l|0;if((a|0)>=(P|0))break;e=(k[z>>2]|0)+(aa(k[k[A>>2]>>2]|0,a)|0)+(h<<2)|0;f=aa(k[G>>2]|0,F)|0;if((f|0)>0){a=0;do{c=c+ +o[e+(a<<2)>>2];d=d+1|0;a=a+F|0}while((a+h|0)<(N|0)&(a|0)<(f|0))}g=g+1|0}while((g|0)<(i|0));a=p+(b<<2)|0}else{a=p+(b<<2)|0;o[a>>2]=0.0;d=0;c=0.0}o[a>>2]=c/+(d|0);b=b+1|0}while((b|0)!=(M|0))}}else if(s)zpb(a|0,0,t|0)|0;while(0);q=q+1|0;if((q|0)==(n|0))break;else m=m+1|0}return}function yna(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86496;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function zna(a){a=a|0;yna(a);ggb(a);return}function Ana(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0,h=0,l=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0;W=r;r=r+16|0;O=W;V=k[a+44>>2]|0;T=k[V+4>>2]|0;V=k[V>>2]|0;K=(k[a+4>>2]|0)>>>3;L=(K&511)+1|0;M=a+116|0;J=k[M>>2]|0;N=a+120|0;e=k[N>>2]|0;P=aa(e,J)|0;Q=1.0/+(P|0);R=aa((T|0)/(J|0)|0,L)|0;S=aa(L,k[(k[a+100>>2]|0)+4>>2]|0)|0;T=aa(L,T)|0;U=k[a+52>>2]|0;a:do if((J|0)==2&(e|0)==2){switch(K&511){case 2:case 0:{c=1;break a}default:{}}c=(L|0)==4&1}else c=0;while(0);d=k[b>>2]|0;C=b+4|0;if((d|0)>=(k[C>>2]|0)){r=W;return}D=a+76|0;E=a+108|0;F=a+20|0;G=a+48|0;H=a+128|0;I=P+-4|0;J=(P|0)<4;w=a+124|0;x=(S|0)>0;y=S<<1;z=P&-4;A=(z|0)<(P|0);B=(P|0)>0;t=c<<24>>24==0;v=O+4|0;b=d;a=e;while(1){q=(k[D>>2]|0)+(aa(k[E>>2]|0,b)|0)|0;p=aa(a,b)|0;l=(p+a|0)<=(V|0)?R:0;b:do if((p|0)<(V|0)){c=(k[F>>2]|0)+(aa(k[k[G>>2]>>2]|0,p)|0)|0;c:do if(!t){d=c+U|0;switch(K&511){case 0:{if((l|0)>0)a=0;else{a=0;s=21;break c}while(1){m=a<<1;n=m|1;j[q+(a<<1)>>1]=((j[c+(m<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[d+(m<<1)>>1]|0)+(j[d+(n<<1)>>1]|0)|0)>>>2;a=a+1|0;if((a|0)==(l|0)){a=l;break c}}}case 2:{if((l|0)>0)a=0;else{a=0;s=21;break c}while(1){s=a<<1;m=s+3|0;j[q+(a<<1)>>1]=((j[c+(s<<1)>>1]|0)+2+(j[c+(m<<1)>>1]|0)+(j[d+(s<<1)>>1]|0)+(j[d+(m<<1)>>1]|0)|0)>>>2;m=s|1;n=s+4|0;j[q+(a+1<<1)>>1]=((j[c+(m<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[d+(m<<1)>>1]|0)+(j[d+(n<<1)>>1]|0)|0)>>>2;n=s+2|0;s=s+5|0;j[q+(a+2<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(s<<1)>>1]|0)+(j[d+(n<<1)>>1]|0)+(j[d+(s<<1)>>1]|0)|0)>>>2;a=a+3|0;if((a|0)>=(l|0)){s=21;break c}}}case 3:break;default:{a=ZT(12)|0;k[a>>2]=1;s=a+4|0;k[O>>2]=s;k[v>>2]=7;i[a+11>>0]=0;i[s>>0]=i[337886]|0;i[s+1>>0]=i[337887]|0;i[s+2>>0]=i[337888]|0;i[s+3>>0]=i[337889]|0;i[s+4>>0]=i[337890]|0;i[s+5>>0]=i[337891]|0;i[s+6>>0]=i[337892]|0;Y8(-215,O,369779,335515,2381);k[v>>2]=0;k[O>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}}if((l|0)>0){a=0;do{s=a<<1;n=s|4;j[q+(a<<1)>>1]=((j[c+(s<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[d+(s<<1)>>1]|0)+(j[d+(n<<1)>>1]|0)|0)>>>2;n=s|1;m=s|5;j[q+((a|1)<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(m<<1)>>1]|0)+(j[d+(n<<1)>>1]|0)+(j[d+(m<<1)>>1]|0)|0)>>>2;m=s|2;n=s|6;j[q+((a|2)<<1)>>1]=((j[c+(m<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[d+(m<<1)>>1]|0)+(j[d+(n<<1)>>1]|0)|0)>>>2;n=s|3;s=s|7;j[q+((a|3)<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(s<<1)>>1]|0)+(j[d+(n<<1)>>1]|0)+(j[d+(s<<1)>>1]|0)|0)>>>2;a=a+4|0}while((a|0)<(l|0));a=l+3&-4;s=21}else{a=0;s=21}}else{a=0;s=21}while(0);d:do if((s|0)==21){s=0;if((a|0)<(l|0)){g=(k[F>>2]|0)+(aa(k[k[G>>2]>>2]|0,p)|0)|0;h=k[H>>2]|0;if(J)while(1){d=g+(k[h+(a<<2)>>2]<<1)|0;if(B){e=k[w>>2]|0;f=0.0;c=0;do{f=f+ +(j[d+(k[e+(c<<2)>>2]<<1)>>1]|0);c=c+1|0}while((c|0)!=(P|0))}else f=0.0;f=Q*f;c=(o[u>>2]=f,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;f=c?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=c?-0.0:0.0}n=~~f;j[q+(a<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;a=a+1|0;if((a|0)==(l|0)){a=l;break d}}e=k[w>>2]|0;do{d=g+(k[h+(a<<2)>>2]<<1)|0;f=0.0;c=0;do{f=f+ +((j[d+(k[e+((c|1)<<2)>>2]<<1)>>1]|0)+(j[d+(k[e+(c<<2)>>2]<<1)>>1]|0)+(j[d+(k[e+((c|2)<<2)>>2]<<1)>>1]|0)+(j[d+(k[e+((c|3)<<2)>>2]<<1)>>1]|0)|0);c=c+4|0}while((c|0)<=(I|0));if(A){c=z;do{f=f+ +(j[d+(k[e+(c<<2)>>2]<<1)>>1]|0);c=c+1|0}while((c|0)!=(P|0))}f=Q*f;c=(o[u>>2]=f,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;f=c?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=c?-0.0:0.0}n=~~f;j[q+(a<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;a=a+1|0}while((a|0)!=(l|0));a=l}}while(0);if((a|0)<(S|0)){n=k[H>>2]|0;m=k[N>>2]|0;if((m|0)<=0)while(1){c=q+(a<<1)|0;if((k[n+(a<<2)>>2]|0)>=(T|0))j[c>>1]=0;j[c>>1]=-32768;a=a+1|0;if((a|0)==(S|0))break b}do{l=k[n+(a<<2)>>2]|0;e:do if((l|0)<(T|0)){h=0;c=0;f=0.0;do{d=h+p|0;if((d|0)>=(V|0))break e;e=(k[F>>2]|0)+(aa(k[k[G>>2]>>2]|0,d)|0)+(l<<1)|0;g=aa(k[M>>2]|0,L)|0;if((g|0)>0){d=0;do{f=f+ +(j[e+(d<<1)>>1]|0);c=c+1|0;d=d+L|0}while((d+l|0)<(T|0)&(d|0)<(g|0))}h=h+1|0}while((h|0)<(m|0))}else{j[q+(a<<1)>>1]=0;c=0;f=0.0}while(0);f=f/+(c|0);c=(o[u>>2]=f,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;f=c?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=c?-0.0:0.0}l=~~f;j[q+(a<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;a=a+1|0}while((a|0)!=(S|0))}}else if(x)zpb(q|0,0,y|0)|0;while(0);b=b+1|0;if((b|0)>=(k[C>>2]|0))break;a=k[N>>2]|0}r=W;return}function Bna(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86516;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Cna(a){a=a|0;Bna(a);ggb(a);return}function Dna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0,g=0,h=0,l=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0;X=r;r=r+16|0;P=X;W=k[a+44>>2]|0;U=k[W+4>>2]|0;W=k[W>>2]|0;L=(k[a+4>>2]|0)>>>3;M=(L&511)+1|0;N=a+116|0;K=k[N>>2]|0;O=a+120|0;e=k[O>>2]|0;Q=aa(e,K)|0;R=1.0/+(Q|0);S=aa((U|0)/(K|0)|0,M)|0;T=aa(M,k[(k[a+100>>2]|0)+4>>2]|0)|0;U=aa(M,U)|0;V=k[a+52>>2]|0;a:do if((K|0)==2&(e|0)==2){switch(L&511){case 2:case 0:{c=1;break a}default:{}}c=(M|0)==4&1}else c=0;while(0);d=k[b>>2]|0;D=b+4|0;if((d|0)>=(k[D>>2]|0)){r=X;return}E=a+76|0;F=a+108|0;G=a+20|0;H=a+48|0;I=a+128|0;J=Q+-4|0;K=(Q|0)<4;x=a+124|0;y=(T|0)>0;z=T<<1;A=Q&-4;B=(A|0)<(Q|0);C=(Q|0)>0;v=c<<24>>24==0;w=P+4|0;b=d;a=e;while(1){s=(k[E>>2]|0)+(aa(k[F>>2]|0,b)|0)|0;q=aa(a,b)|0;l=(q+a|0)<=(W|0)?S:0;b:do if((q|0)<(W|0)){c=(k[G>>2]|0)+(aa(k[k[H>>2]>>2]|0,q)|0)|0;c:do if(!v){d=c+V|0;switch(L&511){case 0:{if((l|0)>0)a=0;else{a=0;t=21;break c}while(1){n=a<<1;p=n|1;j[s+(a<<1)>>1]=((m[c+(n<<1)>>1]|0)+2+(m[c+(p<<1)>>1]|0)+(m[d+(n<<1)>>1]|0)+(m[d+(p<<1)>>1]|0)|0)>>>2;a=a+1|0;if((a|0)==(l|0)){a=l;break c}}}case 2:{if((l|0)>0)a=0;else{a=0;t=21;break c}while(1){t=a<<1;n=t+3|0;j[s+(a<<1)>>1]=((m[c+(t<<1)>>1]|0)+2+(m[c+(n<<1)>>1]|0)+(m[d+(t<<1)>>1]|0)+(m[d+(n<<1)>>1]|0)|0)>>>2;n=t|1;p=t+4|0;j[s+(a+1<<1)>>1]=((m[c+(n<<1)>>1]|0)+2+(m[c+(p<<1)>>1]|0)+(m[d+(n<<1)>>1]|0)+(m[d+(p<<1)>>1]|0)|0)>>>2;p=t+2|0;t=t+5|0;j[s+(a+2<<1)>>1]=((m[c+(p<<1)>>1]|0)+2+(m[c+(t<<1)>>1]|0)+(m[d+(p<<1)>>1]|0)+(m[d+(t<<1)>>1]|0)|0)>>>2;a=a+3|0;if((a|0)>=(l|0)){t=21;break c}}}case 3:break;default:{a=ZT(12)|0;k[a>>2]=1;t=a+4|0;k[P>>2]=t;k[w>>2]=7;i[a+11>>0]=0;i[t>>0]=i[337886]|0;i[t+1>>0]=i[337887]|0;i[t+2>>0]=i[337888]|0;i[t+3>>0]=i[337889]|0;i[t+4>>0]=i[337890]|0;i[t+5>>0]=i[337891]|0;i[t+6>>0]=i[337892]|0;Y8(-215,P,369779,335515,2381);k[w>>2]=0;k[P>>2]=0;t=k[a>>2]|0;k[a>>2]=t+-1;if((t|0)==1)ggb(k[a+-4>>2]|0)}}if((l|0)>0){a=0;do{t=a<<1;p=t|4;j[s+(a<<1)>>1]=((m[c+(t<<1)>>1]|0)+2+(m[c+(p<<1)>>1]|0)+(m[d+(t<<1)>>1]|0)+(m[d+(p<<1)>>1]|0)|0)>>>2;p=t|1;n=t|5;j[s+((a|1)<<1)>>1]=((m[c+(p<<1)>>1]|0)+2+(m[c+(n<<1)>>1]|0)+(m[d+(p<<1)>>1]|0)+(m[d+(n<<1)>>1]|0)|0)>>>2;n=t|2;p=t|6;j[s+((a|2)<<1)>>1]=((m[c+(n<<1)>>1]|0)+2+(m[c+(p<<1)>>1]|0)+(m[d+(n<<1)>>1]|0)+(m[d+(p<<1)>>1]|0)|0)>>>2;p=t|3;t=t|7;j[s+((a|3)<<1)>>1]=((m[c+(p<<1)>>1]|0)+2+(m[c+(t<<1)>>1]|0)+(m[d+(p<<1)>>1]|0)+(m[d+(t<<1)>>1]|0)|0)>>>2;a=a+4|0}while((a|0)<(l|0));a=l+3&-4;t=21}else{a=0;t=21}}else{a=0;t=21}while(0);d:do if((t|0)==21){t=0;if((a|0)<(l|0)){g=(k[G>>2]|0)+(aa(k[k[H>>2]>>2]|0,q)|0)|0;h=k[I>>2]|0;if(K)while(1){d=g+(k[h+(a<<2)>>2]<<1)|0;if(C){e=k[x>>2]|0;f=0.0;c=0;do{f=f+ +(m[d+(k[e+(c<<2)>>2]<<1)>>1]|0);c=c+1|0}while((c|0)!=(Q|0))}else f=0.0;f=R*f;c=(o[u>>2]=f,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;f=c?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=c?-0.0:0.0}p=~~f;j[s+(a<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;a=a+1|0;if((a|0)==(l|0)){a=l;break d}}e=k[x>>2]|0;do{d=g+(k[h+(a<<2)>>2]<<1)|0;f=0.0;c=0;do{f=f+ +((m[d+(k[e+((c|1)<<2)>>2]<<1)>>1]|0)+(m[d+(k[e+(c<<2)>>2]<<1)>>1]|0)+(m[d+(k[e+((c|2)<<2)>>2]<<1)>>1]|0)+(m[d+(k[e+((c|3)<<2)>>2]<<1)>>1]|0)|0);c=c+4|0}while((c|0)<=(J|0));if(B){c=A;do{f=f+ +(m[d+(k[e+(c<<2)>>2]<<1)>>1]|0);c=c+1|0}while((c|0)!=(Q|0))}f=R*f;c=(o[u>>2]=f,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;f=c?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=c?-0.0:0.0}p=~~f;j[s+(a<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;a=a+1|0}while((a|0)!=(l|0));a=l}}while(0);if((a|0)<(T|0)){p=k[I>>2]|0;n=k[O>>2]|0;if((n|0)<=0)while(1){c=s+(a<<1)|0;if((k[p+(a<<2)>>2]|0)>=(U|0))j[c>>1]=0;j[c>>1]=0;a=a+1|0;if((a|0)==(T|0))break b}do{l=k[p+(a<<2)>>2]|0;e:do if((l|0)<(U|0)){h=0;c=0;f=0.0;do{d=h+q|0;if((d|0)>=(W|0))break e;e=(k[G>>2]|0)+(aa(k[k[H>>2]>>2]|0,d)|0)+(l<<1)|0;g=aa(k[N>>2]|0,M)|0;if((g|0)>0){d=0;do{f=f+ +(m[e+(d<<1)>>1]|0);c=c+1|0;d=d+M|0}while((d+l|0)<(U|0)&(d|0)<(g|0))}h=h+1|0}while((h|0)<(n|0))}else{j[s+(a<<1)>>1]=0;c=0;f=0.0}while(0);f=f/+(c|0);c=(o[u>>2]=f,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;f=c?f+-8388608.0+8388608.0:f+8388608.0+-8388608.0;if(f==0.0)f=c?-0.0:0.0}l=~~f;j[s+(a<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;a=a+1|0}while((a|0)!=(T|0))}}else if(y)zpb(s|0,0,z|0)|0;while(0);b=b+1|0;if((b|0)>=(k[D>>2]|0))break;a=k[O>>2]|0}r=X;return}function Ena(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=86536;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Fna(a){a=a|0;Ena(a);ggb(a);return}function Gna(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0;V=r;r=r+16|0;N=V;U=k[a+44>>2]|0;S=k[U+4>>2]|0;U=k[U>>2]|0;J=(k[a+4>>2]|0)>>>3;K=(J&511)+1|0;L=a+116|0;I=k[L>>2]|0;M=a+120|0;f=k[M>>2]|0;O=aa(f,I)|0;P=1.0/+(O|0);Q=aa((S|0)/(I|0)|0,K)|0;R=aa(K,k[(k[a+100>>2]|0)+4>>2]|0)|0;S=aa(K,S)|0;T=k[a+52>>2]|0;a:do if((I|0)==2&(f|0)==2){switch(J&511){case 2:case 0:{c=1;break a}default:{}}c=(K|0)==4&1}else c=0;while(0);e=k[b>>2]|0;B=b+4|0;if((e|0)>=(k[B>>2]|0)){r=V;return}C=a+76|0;D=a+108|0;E=a+20|0;F=a+48|0;G=a+128|0;H=O+-4|0;I=(O|0)<4;w=a+124|0;x=(R|0)>0;y=O&-4;z=(O|0)>0;A=(y|0)<(O|0);t=c<<24>>24==0;v=N+4|0;b=e;a=f;while(1){p=(k[C>>2]|0)+(aa(k[D>>2]|0,b)|0)|0;q=aa(a,b)|0;h=(q+a|0)<=(U|0)?Q:0;if((q|0)<(U|0)){c=(k[E>>2]|0)+(aa(k[k[F>>2]>>2]|0,q)|0)|0;b:do if(!t){e=c+T|0;switch(J&511){case 0:{if((h|0)>0)a=0;else{a=0;s=21;break b}while(1){m=a<<1;n=m|1;i[p+a>>0]=((l[c+m>>0]|0)+2+(l[c+n>>0]|0)+(l[e+m>>0]|0)+(l[e+n>>0]|0)|0)>>>2;a=a+1|0;if((a|0)==(h|0)){a=h;break b}}}case 2:{if((h|0)>0)a=0;else{a=0;s=21;break b}while(1){s=a<<1;m=s+3|0;i[p+a>>0]=((l[c+s>>0]|0)+2+(l[c+m>>0]|0)+(l[e+s>>0]|0)+(l[e+m>>0]|0)|0)>>>2;m=s|1;n=s+4|0;i[p+(a+1)>>0]=((l[c+m>>0]|0)+2+(l[c+n>>0]|0)+(l[e+m>>0]|0)+(l[e+n>>0]|0)|0)>>>2;n=s+2|0;s=s+5|0;i[p+(a+2)>>0]=((l[c+n>>0]|0)+2+(l[c+s>>0]|0)+(l[e+n>>0]|0)+(l[e+s>>0]|0)|0)>>>2;a=a+3|0;if((a|0)>=(h|0)){s=21;break b}}}case 3:break;default:{a=ZT(12)|0;k[a>>2]=1;s=a+4|0;k[N>>2]=s;k[v>>2]=7;i[a+11>>0]=0;i[s>>0]=i[337886]|0;i[s+1>>0]=i[337887]|0;i[s+2>>0]=i[337888]|0;i[s+3>>0]=i[337889]|0;i[s+4>>0]=i[337890]|0;i[s+5>>0]=i[337891]|0;i[s+6>>0]=i[337892]|0;Y8(-215,N,369779,335515,2381);k[v>>2]=0;k[N>>2]=0;s=k[a>>2]|0;k[a>>2]=s+-1;if((s|0)==1)ggb(k[a+-4>>2]|0)}}if((h|0)>0){a=0;do{s=a<<1;n=s|4;i[p+a>>0]=((l[c+s>>0]|0)+2+(l[c+n>>0]|0)+(l[e+s>>0]|0)+(l[e+n>>0]|0)|0)>>>2;n=s|1;m=s|5;i[p+(a|1)>>0]=((l[c+n>>0]|0)+2+(l[c+m>>0]|0)+(l[e+n>>0]|0)+(l[e+m>>0]|0)|0)>>>2;m=s|2;n=s|6;i[p+(a|2)>>0]=((l[c+m>>0]|0)+2+(l[c+n>>0]|0)+(l[e+m>>0]|0)+(l[e+n>>0]|0)|0)>>>2;n=s|3;s=s|7;i[p+(a|3)>>0]=((l[c+n>>0]|0)+2+(l[c+s>>0]|0)+(l[e+n>>0]|0)+(l[e+s>>0]|0)|0)>>>2;a=a+4|0}while((a|0)<(h|0));a=h+3&-4;s=21}else{a=0;s=21}}else{a=0;s=21}while(0);c:do if((s|0)==21){s=0;if((a|0)<(h|0)){if(I)while(1){f=(k[E>>2]|0)+(aa(k[k[F>>2]>>2]|0,q)|0)|0;f=f+(k[(k[G>>2]|0)+(a<<2)>>2]|0)|0;if(z){g=k[w>>2]|0;c=0;e=0;do{c=(l[f+(k[g+(e<<2)>>2]|0)>>0]|0)+c|0;e=e+1|0}while((e|0)!=(O|0))}else c=0;d=P*+(c|0);c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}n=~~d;i[p+a>>0]=n>>>0<256?n:(n|0)>0?255:0;a=a+1|0;if((a|0)==(h|0)){a=h;break c}}do{f=(k[E>>2]|0)+(aa(k[k[F>>2]>>2]|0,q)|0)|0;f=f+(k[(k[G>>2]|0)+(a<<2)>>2]|0)|0;g=k[w>>2]|0;c=0;e=0;do{c=(l[f+(k[g+(e<<2)>>2]|0)>>0]|0)+c+(l[f+(k[g+((e|1)<<2)>>2]|0)>>0]|0)+(l[f+(k[g+((e|2)<<2)>>2]|0)>>0]|0)+(l[f+(k[g+((e|3)<<2)>>2]|0)>>0]|0)|0;e=e+4|0}while((e|0)<=(H|0));if(A){e=y;do{c=(l[f+(k[g+(e<<2)>>2]|0)>>0]|0)+c|0;e=e+1|0}while((e|0)!=(O|0))}d=P*+(c|0);c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}n=~~d;i[p+a>>0]=n>>>0<256?n:(n|0)>0?255:0;a=a+1|0}while((a|0)!=(h|0));a=h}}while(0);if((a|0)<(R|0))do{m=k[(k[G>>2]|0)+(a<<2)>>2]|0;d:do if((m|0)<(S|0)){n=k[M>>2]|0;if((n|0)<1){e=0;c=0}else{j=0;e=0;c=0;do{f=j+q|0;if((f|0)>=(U|0))break d;g=(k[E>>2]|0)+(aa(k[k[F>>2]>>2]|0,f)|0)+m|0;h=aa(k[L>>2]|0,K)|0;if((h|0)>0){f=0;do{c=(l[g+f>>0]|0)+c|0;e=e+1|0;f=f+K|0}while((f+m|0)<(S|0)&(f|0)<(h|0))}j=j+1|0}while((j|0)<(n|0))}}else{i[p+a>>0]=0;e=0;c=0}while(0);d=+(c|0)/+(e|0);c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}n=~~d;i[p+a>>0]=n>>>0<256?n:(n|0)>0?255:0;a=a+1|0}while((a|0)!=(R|0))}else if(x)zpb(p|0,0,R|0)|0;b=b+1|0;if((b|0)>=(k[B>>2]|0))break;a=k[M>>2]|0}r=V;return}function Hna(a){a=a|0;Sla(a);ggb(a);return}function Ina(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;A=k[(k[a+100>>2]|0)+4>>2]|0;c=k[a+8>>2]|0;if((c|0)>0)z=k[(k[a+48>>2]|0)+(c+-1<<2)>>2]|0;else z=0;c=k[b>>2]|0;q=b+4|0;if((c|0)>=(k[q>>2]|0))return;r=a+76|0;s=a+108|0;t=a+128|0;u=(k[k[a+44>>2]>>2]|0)+-1|0;v=a+20|0;w=a+48|0;x=(A|0)>0;y=a+116|0;l=a+120|0;m=A+-2|0;n=(A|0)<2;o=A&-2;do{e=(k[r>>2]|0)+(aa(k[s>>2]|0,c)|0)|0;B=+(c|0)*+p[t>>3];h=~~B;h=h-(+(h|0)>B&1)|0;h=(k[v>>2]|0)+(aa((u|0)<(h|0)?u:h,k[k[w>>2]>>2]|0)|0)|0;switch(z|0){case 1:{if(n)b=0;else{b=0;do{d=k[y>>2]|0;g=b|1;f=i[h+(k[d+(g<<2)>>2]|0)>>0]|0;i[e+b>>0]=i[h+(k[d+(b<<2)>>2]|0)>>0]|0;i[e+g>>0]=f;b=b+2|0}while((b|0)<=(m|0));b=o}if((b|0)<(A|0))do{i[e+b>>0]=i[h+(k[(k[y>>2]|0)+(b<<2)>>2]|0)>>0]|0;b=b+1|0}while((b|0)!=(A|0));break}case 2:{if(x){a=k[y>>2]|0;b=0;do{j[e+(b<<1)>>1]=j[h+(k[a+(b<<2)>>2]|0)>>1]|0;b=b+1|0}while((b|0)!=(A|0))}break}case 3:{if(x){b=e;a=0;while(1){g=h+(k[(k[y>>2]|0)+(a<<2)>>2]|0)|0;i[b>>0]=i[g>>0]|0;i[b+1>>0]=i[g+1>>0]|0;i[b+2>>0]=i[g+2>>0]|0;a=a+1|0;if((a|0)==(A|0))break;else b=b+3|0}}break}case 4:{if(x){a=k[y>>2]|0;b=0;do{k[e+(b<<2)>>2]=k[h+(k[a+(b<<2)>>2]|0)>>2];b=b+1|0}while((b|0)!=(A|0))}break}case 6:{if(x){d=k[y>>2]|0;b=e;a=0;while(1){g=h+(k[d+(a<<2)>>2]|0)|0;j[b>>1]=j[g>>1]|0;j[b+2>>1]=j[g+2>>1]|0;j[b+4>>1]=j[g+4>>1]|0;a=a+1|0;if((a|0)==(A|0))break;else b=b+6|0}}break}case 8:{if(x){d=k[y>>2]|0;b=e;a=0;while(1){g=h+(k[d+(a<<2)>>2]|0)|0;k[b>>2]=k[g>>2];k[b+4>>2]=k[g+4>>2];a=a+1|0;if((a|0)==(A|0))break;else b=b+8|0}}break}case 12:{if(x){d=k[y>>2]|0;b=e;a=0;while(1){g=h+(k[d+(a<<2)>>2]|0)|0;k[b>>2]=k[g>>2];k[b+4>>2]=k[g+4>>2];k[b+8>>2]=k[g+8>>2];a=a+1|0;if((a|0)==(A|0))break;else b=b+12|0}}break}default:if(x){g=k[y>>2]|0;f=0;b=k[l>>2]|0;while(1){d=h+(k[g+(f<<2)>>2]|0)|0;if((b|0)>0){a=0;do{k[e+(a<<2)>>2]=k[d+(a<<2)>>2];a=a+1|0;b=k[l>>2]|0}while((a|0)<(b|0))}f=f+1|0;if((f|0)==(A|0))break;else e=e+z|0}}}c=c+1|0}while((c|0)<(k[q>>2]|0));return}function Jna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=r;r=r+368|0;y=D;w=D+360|0;C=D+304|0;B=D+240|0;A=D+184|0;s=D+296|0;z=D+128|0;x=D+72|0;R1(w,c,-1);if((aa(k[w+4>>2]|0,k[w>>2]|0)|0)<=0){h=y+4|0;j=ZT(28)|0;k[j>>2]=1;n=j+4|0;k[y>>2]=n;k[h>>2]=23;i[j+27>>0]=0;m=338184;q=n+23|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,y,338208,335515,4672);k[h>>2]=0;k[y>>2]=0;w=k[j>>2]|0;k[j>>2]=w+-1;if((w|0)==1)ggb(k[j+-4>>2]|0)}if(!(G2(d)|0)?(R1(y,d,-1),R1(C,c,-1),!((k[y>>2]|0)==(k[C>>2]|0)?(k[y+4>>2]|0)==(k[C+4>>2]|0):0)):0){h=y+4|0;j=ZT(52)|0;k[j>>2]=1;n=j+4|0;k[y>>2]=n;k[h>>2]=47;i[j+51>>0]=0;m=338214;q=n+47|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,y,338208,335515,4673);k[h>>2]=0;k[y>>2]=0;w=k[j>>2]|0;k[j>>2]=w+-1;if((w|0)==1)ggb(k[j+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){l=k[a+4>>2]|0;k[C>>2]=k[l>>2];q=C+4|0;h=l+4|0;k[q>>2]=k[h>>2];w=C+8|0;k[w>>2]=k[l+8>>2];k[C+12>>2]=k[l+12>>2];k[C+16>>2]=k[l+16>>2];k[C+20>>2]=k[l+20>>2];k[C+24>>2]=k[l+24>>2];k[C+28>>2]=k[l+28>>2];k[C+32>>2]=k[l+32>>2];j=k[l+36>>2]|0;k[C+36>>2]=j;a=C+40|0;k[a>>2]=w;w=C+48|0;n=C+44|0;k[n>>2]=w;k[C+52>>2]=0;k[w>>2]=0;if(j|0){w=j+12|0;k[w>>2]=(k[w>>2]|0)+1}if((k[h>>2]|0)<3){u=k[l+44>>2]|0;w=k[n>>2]|0;k[w>>2]=k[u>>2];k[w+4>>2]=k[u+4>>2];break}k[q>>2]=0;x1(C,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[l+40>>2]|0;m=k[a>>2]|0;a=k[l+44>>2]|0;j=k[n>>2]|0;h=0;do{k[m+(h<<2)>>2]=k[o+(h<<2)>>2];k[j+(h<<2)>>2]=k[a+(h<<2)>>2];h=h+1|0}while((h|0)<(k[q>>2]|0))}}else Q1(C,a,-1);while(0);do if((k[c>>2]&2031616|0)==65536){l=k[c+4>>2]|0;k[B>>2]=k[l>>2];q=B+4|0;h=l+4|0;k[q>>2]=k[h>>2];w=B+8|0;k[w>>2]=k[l+8>>2];k[B+12>>2]=k[l+12>>2];k[B+16>>2]=k[l+16>>2];k[B+20>>2]=k[l+20>>2];k[B+24>>2]=k[l+24>>2];k[B+28>>2]=k[l+28>>2];k[B+32>>2]=k[l+32>>2];j=k[l+36>>2]|0;k[B+36>>2]=j;a=B+40|0;k[a>>2]=w;w=B+48|0;n=B+44|0;k[n>>2]=w;k[B+52>>2]=0;k[w>>2]=0;if(j|0){w=j+12|0;k[w>>2]=(k[w>>2]|0)+1}if((k[h>>2]|0)<3){u=k[l+44>>2]|0;w=k[n>>2]|0;k[w>>2]=k[u>>2];k[w+4>>2]=k[u+4>>2];break}k[q>>2]=0;x1(B,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[l+40>>2]|0;m=k[a>>2]|0;a=k[l+44>>2]|0;j=k[n>>2]|0;h=0;do{k[m+(h<<2)>>2]=k[o+(h<<2)>>2];k[j+(h<<2)>>2]=k[a+(h<<2)>>2];h=h+1|0}while((h|0)<(k[q>>2]|0))}}else Q1(B,c,-1);while(0);do if((k[d>>2]&2031616|0)==65536){l=k[d+4>>2]|0;k[A>>2]=k[l>>2];q=A+4|0;h=l+4|0;k[q>>2]=k[h>>2];w=A+8|0;k[w>>2]=k[l+8>>2];k[A+12>>2]=k[l+12>>2];k[A+16>>2]=k[l+16>>2];k[A+20>>2]=k[l+20>>2];k[A+24>>2]=k[l+24>>2];k[A+28>>2]=k[l+28>>2];k[A+32>>2]=k[l+32>>2];j=k[l+36>>2]|0;k[A+36>>2]=j;a=A+40|0;k[a>>2]=w;w=A+48|0;n=A+44|0;k[n>>2]=w;k[A+52>>2]=0;k[w>>2]=0;if(j|0){w=j+12|0;k[w>>2]=(k[w>>2]|0)+1}if((k[h>>2]|0)<3){u=k[l+44>>2]|0;w=k[n>>2]|0;k[w>>2]=k[u>>2];k[w+4>>2]=k[u+4>>2];break}k[q>>2]=0;x1(A,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[l+40>>2]|0;m=k[a>>2]|0;a=k[l+44>>2]|0;j=k[n>>2]|0;h=0;do{k[m+(h<<2)>>2]=k[o+(h<<2)>>2];k[j+(h<<2)>>2]=k[a+(h<<2)>>2];h=h+1|0}while((h|0)<(k[q>>2]|0))}}else Q1(A,d,-1);while(0);w=B+40|0;t=k[w>>2]|0;u=k[t>>2]|0;k[s>>2]=k[t+4>>2];k[s+4>>2]=u;x2(b,s,k[C>>2]&4095,0);do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[z>>2]=k[l>>2];q=z+4|0;h=l+4|0;k[q>>2]=k[h>>2];u=z+8|0;k[u>>2]=k[l+8>>2];k[z+12>>2]=k[l+12>>2];c=z+16|0;k[c>>2]=k[l+16>>2];k[z+20>>2]=k[l+20>>2];k[z+24>>2]=k[l+24>>2];k[z+28>>2]=k[l+28>>2];k[z+32>>2]=k[l+32>>2];j=k[l+36>>2]|0;k[z+36>>2]=j;a=z+40|0;k[a>>2]=u;u=z+48|0;n=z+44|0;k[n>>2]=u;k[z+52>>2]=0;k[u>>2]=0;if(j|0){u=j+12|0;k[u>>2]=(k[u>>2]|0)+1}if((k[h>>2]|0)<3){t=k[l+44>>2]|0;u=k[n>>2]|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];break}k[q>>2]=0;x1(z,k[h>>2]|0,0,0,0);if((k[q>>2]|0)>0){o=k[l+40>>2]|0;m=k[a>>2]|0;a=k[l+44>>2]|0;j=k[n>>2]|0;h=0;do{k[m+(h<<2)>>2]=k[o+(h<<2)>>2];k[j+(h<<2)>>2]=k[a+(h<<2)>>2];h=h+1|0}while((h|0)<(k[q>>2]|0))}}else{Q1(z,b,-1);c=z+16|0}while(0);u=C+16|0;if((k[c>>2]|0)==(k[u>>2]|0)){k[x>>2]=1124007936;o=x+4|0;h=x+8|0;m=x+40|0;n=o;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[m>>2]=h;n=x+48|0;l=x+44|0;k[l>>2]=n;k[x+52>>2]=0;k[n>>2]=0;a=y+4|0;h=a+4|0;k[h>>2]=0;k[h+4>>2]=0;k[y>>2]=33619968;k[a>>2]=x;mY(C,y);KG(C,x)|0;a=x+36|0;h=k[a>>2]|0;if(h|0?(s=h+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){j=k[a>>2]|0;if(j|0){h=k[j+4>>2]|0;if(!h){h=k[x+32>>2]|0;if(!h){h=B1()|0;j=k[a>>2]|0}}jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[a>>2]=0}k[a>>2]=0;t=x+16|0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[o>>2]|0)>0){j=k[m>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[o>>2]|0))}h=k[l>>2]|0;if(!((h|0)==(n|0)|(h|0)==0))ggb(k[h+-4>>2]|0)}a=(e|0)==3?1:e;h=k[C>>2]&7;l=(h|0)==0;switch(a|0){case 0:{a=k[86568+(h<<2)>>2]|0;if((h|0)==7){k[y>>2]=0;h=y+4|0;k[h>>2]=0;j=ZT(16)|0;k[j>>2]=1;n=j+4|0;k[y>>2]=n;k[h>>2]=11;i[j+15>>0]=0;m=338262;q=n+11|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,y,338208,335515,4739);k[h>>2]=0;k[y>>2]=0;t=k[j>>2]|0;k[j>>2]=t+-1;if((t|0)==1)ggb(k[j+-4>>2]|0);t=0;e=a;h=0}else{t=0;e=a;h=0}break}case 1:{h=86600+(h<<2)|0;v=72;break}case 2:{h=86632+(h<<2)|0;v=72;break}case 4:{h=86664+(h<<2)|0;v=72;break}default:{k[y>>2]=0;h=y+4|0;k[h>>2]=0;j=ZT(36)|0;k[j>>2]=1;n=j+4|0;k[y>>2]=n;k[h>>2]=28;i[j+32>>0]=0;m=335584;q=n+28|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-5,y,338208,335515,4750);k[h>>2]=0;k[y>>2]=0;v=k[j>>2]|0;k[j>>2]=v+-1;if((v|0)==1)ggb(k[j+-4>>2]|0);v=73}}if((v|0)==72){h=k[h>>2]|0;if(!h)v=73;else v=76}if((v|0)==73){k[y>>2]=0;h=y+4|0;k[h>>2]=0;j=ZT(16)|0;k[j>>2]=1;n=j+4|0;k[y>>2]=n;k[h>>2]=10;i[j+14>>0]=0;m=338274;q=n+10|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,y,338208,335515,4751);k[h>>2]=0;k[y>>2]=0;v=k[j>>2]|0;k[j>>2]=v+-1;if((v|0)==1)ggb(k[j+-4>>2]|0);h=0;v=76}if((v|0)==76){t=Qla(a,l)|0;e=0}j=B;s=A;a=k[B>>2]|0;b=a&4095;d=(b|0)==11;q=k[A>>2]|0;if(d)if((q&4094|0)!=2?(k[A+16>>2]|0)!=0:0){n=k[A+4>>2]|0;if((n|0)<3)l=aa(k[A+12>>2]|0,k[A+8>>2]|0)|0;else{o=k[A+40>>2]|0;m=0;l=1;do{l=aa(k[o+(m<<2)>>2]|0,l)|0;m=m+1|0}while((m|0)!=(n|0))}if(l)v=85;else v=93}else v=93;else v=85;do if((v|0)==85){q=q&4095;if((q|0)==11){if((a&4094|0)==2){v=93;break}if(!(k[B+16>>2]|0)){v=93;break}n=k[B+4>>2]|0;if((n|0)<3)l=aa(k[B+12>>2]|0,k[B+8>>2]|0)|0;else{o=k[w>>2]|0;m=0;l=1;do{l=aa(k[o+(m<<2)>>2]|0,l)|0;m=m+1|0}while((m|0)!=(n|0))}if(!l){v=93;break}}switch(a&4095){case 11:case 13:{if(k[A+16>>2]|0){n=k[A+4>>2]|0;if((n|0)<3)l=aa(k[A+12>>2]|0,k[A+8>>2]|0)|0;else{o=k[A+40>>2]|0;m=0;l=1;do{l=aa(k[o+(m<<2)>>2]|0,l)|0;m=m+1|0}while((m|0)!=(n|0))}if(l)v=101}break}default:v=101}if((v|0)==101)if(!((b|0)==5&(q|0)==5)){k[y>>2]=0;a=y+4|0;k[a>>2]=0;l=ZT(132)|0;k[l>>2]=1;n=l+4|0;k[y>>2]=n;k[a>>2]=126;i[l+130>>0]=0;m=338285;q=n+126|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,y,338208,335515,4766);k[a>>2]=0;k[y>>2]=0;b=k[l>>2]|0;k[l>>2]=b+-1;if((b|0)==1)ggb(k[l+-4>>2]|0);a=k[B>>2]|0}a=(a&4088|0)==0;l=s}while(0);if((v|0)==93){a=0;l=d?s:j;j=d?j:s}k[y>>2]=86704;k[y+4>>2]=C;k[y+8>>2]=z;k[y+12>>2]=j;k[y+16>>2]=l;k[y+20>>2]=f;p[y+24>>3]=+p[g>>3];p[y+32>>3]=+p[g+8>>3];p[y+40>>3]=+p[g+16>>3];p[y+48>>3]=+p[g+24>>3];k[y+56>>2]=a&1;k[y+60>>2]=e;k[y+64>>2]=h;k[y+68>>2]=t;l=k[z+8>>2]|0;k[x>>2]=0;k[x+4>>2]=l;l=z+4|0;Lna(y,x);a=z+36|0;h=k[a>>2]|0;if(h|0?(x=h+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){j=k[a>>2]|0;if(j|0){h=k[j+4>>2]|0;if(!h){h=k[z+32>>2]|0;if(!h){h=B1()|0;j=k[a>>2]|0}}jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[a>>2]=0}k[a>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[l>>2]|0)>0){j=k[z+40>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[l>>2]|0))}h=k[z+44>>2]|0;if(!((h|0)==(z+48|0)|(h|0)==0))ggb(k[h+-4>>2]|0);a=A+36|0;h=k[a>>2]|0;if(h|0?(y=h+12|0,z=k[y>>2]|0,k[y>>2]=z+-1,(z|0)==1):0){j=k[a>>2]|0;if(j|0){h=k[j+4>>2]|0;if(!h){h=k[A+32>>2]|0;if(!h){h=B1()|0;j=k[a>>2]|0}}jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[a>>2]=0}k[a>>2]=0;z=A+16|0;j=A+4|0;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;if((k[j>>2]|0)>0){a=k[A+40>>2]|0;h=0;do{k[a+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[j>>2]|0))}h=k[A+44>>2]|0;if(!((h|0)==(A+48|0)|(h|0)==0))ggb(k[h+-4>>2]|0);a=B+36|0;h=k[a>>2]|0;if(h|0?(z=h+12|0,A=k[z>>2]|0,k[z>>2]=A+-1,(A|0)==1):0){j=k[a>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[B+32>>2]|0;if(h|0)break;h=B1()|0;j=k[a>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[a>>2]=0}k[a>>2]=0;A=B+16|0;a=B+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[a>>2]|0)>0){j=k[w>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[a>>2]|0))}h=k[B+44>>2]|0;if(!((h|0)==(B+48|0)|(h|0)==0))ggb(k[h+-4>>2]|0);a=C+36|0;h=k[a>>2]|0;if(h|0?(A=h+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){j=k[a>>2]|0;if(j|0){h=k[j+4>>2]|0;do if(!h){h=k[C+32>>2]|0;if(h|0)break;h=B1()|0;j=k[a>>2]|0}while(0);jh[k[(k[h>>2]|0)+24>>2]&1023](h,j)}k[a>>2]=0}k[a>>2]=0;a=C+4|0;k[u>>2]=0;k[u+4>>2]=0;k[u+8>>2]=0;k[u+12>>2]=0;if((k[a>>2]|0)>0){j=k[C+40>>2]|0;h=0;do{k[j+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(k[a>>2]|0))}h=k[C+44>>2]|0;if((h|0)==(C+48|0)|(h|0)==0){r=D;return}ggb(k[h+-4>>2]|0);r=D;return}function Kna(a){a=a|0;ggb(a);return}function Lna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0.0,i=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0;lb=r;r=r+416|0;Wa=lb+352|0;hb=lb+296|0;eb=lb+240|0;Xa=lb+184|0;Ya=lb+72|0;Za=lb+16|0;_a=lb+128|0;$a=lb;Ua=a+8|0;Sa=k[Ua>>2]|0;jb=k[Sa+8>>2]|0;Va=a+12|0;g=k[k[Va>>2]>>2]&7;Ta=16384/(((jb|0)<128?jb:128)|0)|0;Sa=k[Sa+12>>2]|0;Ta=(Sa|0)<(Ta|0)?Sa:Ta;Sa=16384/(Ta|0)|0;Sa=(jb|0)<(Sa|0)?jb:Sa;k[hb>>2]=1124007936;jb=hb+4|0;c=hb+8|0;gb=hb+40|0;d=jb;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[gb>>2]=c;kb=hb+48|0;ib=hb+44|0;k[ib>>2]=kb;k[hb+52>>2]=0;k[kb>>2]=0;k[Wa>>2]=Sa;f=Wa+4|0;k[f>>2]=Ta;G1(hb,2,Wa,11);k[eb>>2]=1124007936;fb=eb+4|0;c=eb+8|0;cb=eb+40|0;d=fb;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[cb>>2]=c;db=eb+48|0;bb=eb+44|0;k[bb>>2]=db;k[eb+52>>2]=0;k[db>>2]=0;Ra=a+60|0;if(!(k[Ra>>2]|0)){k[Wa>>2]=Sa;k[f>>2]=Ta;G1(eb,2,Wa,2)}c=k[b>>2]|0;ka=b+4|0;d=k[ka>>2]|0;if((c|0)<(d|0)){la=Xa+4|0;ma=Xa+8|0;na=Xa+12|0;oa=Ya+4|0;pa=Ya+8|0;qa=Ya+12|0;ra=Za+4|0;sa=Za+8|0;ta=Za+12|0;ua=a+64|0;va=a+4|0;wa=a+68|0;xa=a+20|0;ya=a+24|0;za=Ya+36|0;Aa=Ya+16|0;Ba=Ya+4|0;Ca=Ya+40|0;Da=Ya+44|0;Ea=Ya+48|0;Fa=Xa+16|0;Ga=Xa+44|0;Ha=a+16|0;Ia=$a+4|0;Ja=$a+8|0;Ka=$a+12|0;La=Za+36|0;Ma=Za+16|0;Na=Za+4|0;Oa=Za+40|0;Pa=Za+44|0;Qa=Za+48|0;R=a+56|0;S=Xa+36|0;T=Xa+4|0;U=Xa+40|0;V=Xa+48|0;W=Wa+36|0;X=Wa+16|0;Y=Wa+4|0;Z=Wa+40|0;_=Wa+44|0;$=Wa+48|0;ba=Za+4|0;ca=Za+8|0;da=Za+12|0;ea=Ya+36|0;fa=Ya+16|0;ga=Ya+4|0;ha=Ya+40|0;ia=Ya+44|0;ja=Ya+48|0;O=(g|0)==5;P=Ya+4|0;Q=Ya+8|0;z=Ya+12|0;A=Za+4|0;B=A+4|0;C=_a+36|0;D=_a+16|0;E=_a+4|0;F=_a+40|0;G=_a+44|0;H=_a+48|0;I=Za+32|0;J=Ya+32|0;K=Wa+32|0;L=Xa+32|0;M=Ya+32|0;N=_a+32|0;y=c;c=k[Ua>>2]|0;do{e=k[c+12>>2]|0;if((e|0)>0){x=0;do{w=d-y|0;w=(w|0)<(Sa|0)?w:Sa;v=e-x|0;v=(v|0)<(Ta|0)?v:Ta;k[Xa>>2]=x;k[la>>2]=y;k[ma>>2]=v;k[na>>2]=w;I1(Wa,c,Xa);k[Ya>>2]=0;k[oa>>2]=0;k[pa>>2]=v;k[qa>>2]=w;I1(Xa,hb,Ya);if(!(k[Ra>>2]|0)){k[Za>>2]=0;k[ra>>2]=0;k[sa>>2]=v;k[ta>>2]=w;I1(Ya,eb,Za);if((w|0)>0){n=(v|0)>0;p=x<<1;i=0;do{g=(k[Fa>>2]|0)+(aa(k[k[Ga>>2]>>2]|0,i)|0)|0;q=(k[Aa>>2]|0)+(aa(k[k[Da>>2]>>2]|0,i)|0)|0;c=k[Va>>2]|0;if((k[c>>2]&4095|0)==11?(k[k[Ha>>2]>>2]&4094|0)==2:0){k[$a>>2]=x;k[Ia>>2]=y;k[Ja>>2]=v;k[Ka>>2]=w;I1(Za,c,$a);KG(Xa,Za)|0;c=k[La>>2]|0;if(c|0?(s=c+12|0,t=k[s>>2]|0,k[s>>2]=t+-1,(t|0)==1):0){d=k[La>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[I>>2]|0;if(c|0)break;c=B1()|0;d=k[La>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[La>>2]=0}k[La>>2]=0;k[Ma>>2]=0;k[Ma+4>>2]=0;k[Ma+8>>2]=0;k[Ma+12>>2]=0;if((k[Na>>2]|0)>0){d=k[Oa>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Na>>2]|0))}c=k[Pa>>2]|0;if(!((c|0)==(Qa|0)|(c|0)==0))ggb(k[c+-4>>2]|0);d=k[Ha>>2]|0;d=(k[d+16>>2]|0)+(aa(k[k[d+44>>2]>>2]|0,i+y|0)|0)+(x<<1)|0;if(n){c=0;do{j[q+(c<<1)>>1]=(m[d+(c<<1)>>1]|0)&1023;c=c+1|0}while((c|0)<(v|0))}}else ab=81;do if((ab|0)==81){ab=0;d=i+y|0;c=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,d)|0)|0;if(!(k[R>>2]|0)){b=c+(p<<2)|0;if(n)f=0;else break;do{a=f<<1;h=+o[b+(a<<2)>>2]*32.0;c=(o[u>>2]=h,k[u>>2]|0);do if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;h=c?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(!(h==0.0))break;h=c?-0.0:0.0}while(0);d=~~h;e=a|1;h=+o[b+(e<<2)>>2]*32.0;c=(o[u>>2]=h,k[u>>2]|0);do if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;h=c?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(!(h==0.0))break;h=c?-0.0:0.0}while(0);t=~~h;s=d>>5;j[g+(a<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=t>>5;j[g+(e<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;j[q+(f<<1)>>1]=t<<5&992|d&31;f=f+1|0}while((f|0)<(v|0))}else{b=c+(x<<2)|0;f=k[Ha>>2]|0;f=(k[f+16>>2]|0)+(aa(k[k[f+44>>2]>>2]|0,d)|0)+(x<<2)|0;if(n)e=0;else break;do{h=+o[b+(e<<2)>>2]*32.0;c=(o[u>>2]=h,k[u>>2]|0);do if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;h=c?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(!(h==0.0))break;h=c?-0.0:0.0}while(0);d=~~h;h=+o[f+(e<<2)>>2]*32.0;c=(o[u>>2]=h,k[u>>2]|0);do if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;h=c?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(!(h==0.0))break;h=c?-0.0:0.0}while(0);t=~~h;a=d>>5;s=e<<1;j[g+(s<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=t>>5;j[g+((s|1)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;j[q+(e<<1)>>1]=t<<5&992|d&31;e=e+1|0}while((e|0)<(v|0))}}while(0);i=i+1|0}while((i|0)<(w|0))}Eh[k[ua>>2]&127](k[va>>2]|0,Wa,Xa,Ya,k[wa>>2]|0,k[xa>>2]|0,ya);c=k[za>>2]|0;if(c|0?(v=c+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){d=k[za>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[J>>2]|0;if(!c){c=B1()|0;d=k[za>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[za>>2]=0}k[za>>2]=0;k[Aa>>2]=0;k[Aa+4>>2]=0;k[Aa+8>>2]=0;k[Aa+12>>2]=0;if((k[Ba>>2]|0)>0){d=k[Ca>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Ba>>2]|0))}c=k[Da>>2]|0;if(!((c|0)==(Ea|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}else{b=k[Va>>2]|0;do if((k[b>>2]&4095|0)==11){c=k[Ha>>2]|0;if(k[c+16>>2]|0){f=k[c+4>>2]|0;if((f|0)<3)c=aa(k[c+12>>2]|0,k[c+8>>2]|0)|0;else{e=k[c+40>>2]|0;d=0;c=1;do{c=aa(k[e+(d<<2)>>2]|0,c)|0;d=d+1|0}while((d|0)!=(f|0))}if(c|0){ab=28;break}}k[Za>>2]=x;k[ba>>2]=y;k[ca>>2]=v;k[da>>2]=w;I1(Ya,b,Za);KG(Xa,Ya)|0;c=k[ea>>2]|0;if(c|0?(v=c+12|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0){d=k[ea>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[M>>2]|0;if(!c){c=B1()|0;d=k[ea>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[ea>>2]=0}k[ea>>2]=0;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=0;k[fa+12>>2]=0;if((k[ga>>2]|0)>0){d=k[ha>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[ga>>2]|0))}c=k[ia>>2]|0;if(!((c|0)==(ja|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}else ab=28;while(0);a:do if((ab|0)==28){ab=0;if(!O){if((w|0)<=0)break;n=k[Fa>>2]|0;p=k[b+16>>2]|0;q=x<<1;c=k[Ha>>2]|0;s=k[c+16>>2]|0;if((v|0)<=0)break;i=k[k[Ga>>2]>>2]|0;g=k[k[b+44>>2]>>2]|0;e=k[k[c+44>>2]>>2]|0;d=0;while(1){f=n+(aa(i,d)|0)|0;a=d+y|0;b=p+(aa(g,a)|0)+(q<<1)|0;a=s+(aa(e,a)|0)+(x<<1)|0;c=0;do{mb=(m[a+(c<<1)>>1]|0)&1023;t=c<<1;j[f+(t<<1)>>1]=(l[1012638+(mb<<1)>>0]|0)+(m[b+(t<<1)>>1]|0);t=t|1;j[f+(t<<1)>>1]=(l[1012638+(mb<<1)+1>>0]|0)+(m[b+(t<<1)>>1]|0);c=c+1|0}while((c|0)<(v|0));d=d+1|0;if((d|0)>=(w|0))break a}}if(k[R>>2]|0){if((w|0)<=0)break;q=k[Fa>>2]|0;s=k[k[Ga>>2]>>2]|0;t=k[b+16>>2]|0;b=k[k[b+44>>2]>>2]|0;g=k[Ha>>2]|0;a=k[g+16>>2]|0;g=k[k[g+44>>2]>>2]|0;if((v|0)>0)e=0;else break;while(1){i=q+(aa(s,e)|0)|0;p=e+y|0;n=t+(aa(b,p)|0)+(x<<2)|0;p=a+(aa(g,p)|0)+(x<<2)|0;f=0;do{h=+o[n+(f<<2)>>2];c=(o[u>>2]=h,k[u>>2]|0);do if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;h=c?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(!(h==0.0))break;h=c?-0.0:0.0}while(0);c=~~h;d=f<<1;j[i+(d<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;h=+o[p+(f<<2)>>2];c=(o[u>>2]=h,k[u>>2]|0);do if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;h=c?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(!(h==0.0))break;h=c?-0.0:0.0}while(0);mb=~~h;j[i+((d|1)<<1)>>1]=(mb+32768|0)>>>0<65536?mb:(mb|0)>0?32767:32768;f=f+1|0}while((f|0)<(v|0));e=e+1|0;if((e|0)>=(w|0))break a}}k[Ya>>2]=x;k[P>>2]=y;k[Q>>2]=v;k[z>>2]=w;I1(_a,b,Ya);c=B;k[c>>2]=0;k[c+4>>2]=0;k[Za>>2]=33619968;k[A>>2]=Xa;SW(_a,Za,k[Xa>>2]&7,1.0,0.0);c=k[C>>2]|0;if(c|0?(w=c+12|0,mb=k[w>>2]|0,k[w>>2]=mb+-1,(mb|0)==1):0){d=k[C>>2]|0;if(d|0){c=k[d+4>>2]|0;do if(!c){c=k[N>>2]|0;if(c|0)break;c=B1()|0;d=k[C>>2]|0}while(0);jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[C>>2]=0}k[C>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[E>>2]|0)>0){d=k[F>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[E>>2]|0))}c=k[G>>2]|0;if(!((c|0)==(H|0)|(c|0)==0))ggb(k[c+-4>>2]|0)}while(0);eh[k[Ra>>2]&255](k[va>>2]|0,Wa,Xa,k[xa>>2]|0,ya)}c=k[S>>2]|0;if(c|0?(w=c+12|0,mb=k[w>>2]|0,k[w>>2]=mb+-1,(mb|0)==1):0){d=k[S>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[L>>2]|0;if(!c){c=B1()|0;d=k[S>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[S>>2]=0}k[S>>2]=0;k[Fa>>2]=0;k[Fa+4>>2]=0;k[Fa+8>>2]=0;k[Fa+12>>2]=0;if((k[T>>2]|0)>0){d=k[U>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[T>>2]|0))}c=k[Ga>>2]|0;if(!((c|0)==(V|0)|(c|0)==0))ggb(k[c+-4>>2]|0);c=k[W>>2]|0;if(c|0?(w=c+12|0,mb=k[w>>2]|0,k[w>>2]=mb+-1,(mb|0)==1):0){d=k[W>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[K>>2]|0;if(!c){c=B1()|0;d=k[W>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[W>>2]=0}k[W>>2]=0;k[X>>2]=0;k[X+4>>2]=0;k[X+8>>2]=0;k[X+12>>2]=0;if((k[Y>>2]|0)>0){d=k[Z>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[Y>>2]|0))}c=k[_>>2]|0;if(!((c|0)==($|0)|(c|0)==0))ggb(k[c+-4>>2]|0);x=x+Ta|0;c=k[Ua>>2]|0;e=k[c+12>>2]|0;d=k[ka>>2]|0}while((e|0)>(x|0))}y=y+Sa|0}while((y|0)<(d|0))}e=eb+36|0;c=k[e>>2]|0;if(c|0?(ab=c+12|0,mb=k[ab>>2]|0,k[ab>>2]=mb+-1,(mb|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[eb+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;mb=eb+16|0;k[mb>>2]=0;k[mb+4>>2]=0;k[mb+8>>2]=0;k[mb+12>>2]=0;if((k[fb>>2]|0)>0){d=k[cb>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[fb>>2]|0))}c=k[bb>>2]|0;if(!((c|0)==(db|0)|(c|0)==0))ggb(k[c+-4>>2]|0);e=hb+36|0;c=k[e>>2]|0;if(c|0?(fb=c+12|0,mb=k[fb>>2]|0,k[fb>>2]=mb+-1,(mb|0)==1):0){d=k[e>>2]|0;if(d|0){c=k[d+4>>2]|0;if(!c){c=k[hb+32>>2]|0;if(!c){c=B1()|0;d=k[e>>2]|0}}jh[k[(k[c>>2]|0)+24>>2]&1023](c,d)}k[e>>2]=0}k[e>>2]=0;mb=hb+16|0;k[mb>>2]=0;k[mb+4>>2]=0;k[mb+8>>2]=0;k[mb+12>>2]=0;if((k[jb>>2]|0)>0){d=k[gb>>2]|0;c=0;do{k[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(k[jb>>2]|0))}c=k[ib>>2]|0;if((c|0)==(kb|0)|(c|0)==0){r=lb;return}ggb(k[c+-4>>2]|0);r=lb;return}function Mna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;Aa=r;r=r+48|0;xa=Aa+32|0;ya=Aa;va=k[a+40>>2]|0;ua=k[va+4>>2]|0;va=k[va>>2]|0;t=k[b+40>>2]|0;s=k[t+4>>2]|0;t=k[t>>2]|0;v=(k[a>>2]|0)>>>3;wa=(v&511)+1|0;w=k[a+16>>2]|0;ta=k[a+48>>2]|0;h=+p[g>>3];p[u>>3]=h;a=k[u+4>>2]|0;sa=a&2146435072;if(!(sa>>>0>1126170624|(sa|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}q=~~h;q=(q>>>0<256?q:(q|0)>0?255:0)&255;h=+p[g+8>>3];p[u>>3]=h;a=k[u+4>>2]|0;sa=a&2146435072;if(!(sa>>>0>1126170624|(sa|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}o=~~h;o=(o>>>0<256?o:(o|0)>0?255:0)&255;h=+p[g+16>>3];p[u>>3]=h;a=k[u+4>>2]|0;sa=a&2146435072;if(!(sa>>>0>1126170624|(sa|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}n=~~h;n=(n>>>0<256?n:(n|0)>0?255:0)&255;h=+p[g+24>>3];p[u>>3]=h;a=k[u+4>>2]|0;sa=a&2146435072;if(!(sa>>>0>1126170624|(sa|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}sa=~~h;i[xa>>0]=q;i[xa+1>>0]=o;i[xa+2>>0]=n;i[xa+3>>0]=sa>>>0<256?sa:(sa|0)>0?255:0;sa=(f|0)!=5?f:4;ra=ua+-7|0;ra=(ra|0)<0?0:ra;qa=va+-7|0;qa=(qa|0)<0?0:qa;if((k[b>>2]&16384|0)!=0?(k[c>>2]&16384|0)!=0:0){pa=(k[d>>2]&16384|0)!=0;a=aa(pa?t:1,s)|0;if(pa)t=1;else za=16}else{a=s;za=16}if((za|0)==16)if((t|0)<=0){r=Aa;return}pa=b+16|0;na=b+44|0;oa=c+16|0;la=c+44|0;ma=d+16|0;ba=d+44|0;ca=(a|0)>0;da=wa<<1;ea=wa*3|0;fa=wa<<2;ga=wa*5|0;ha=wa*6|0;ia=wa*7|0;ja=ta<<3;ka=1-ja|0;_=(f|0)==5;$=(sa|0)==0;S=(v|-512)^511;T=ya+4|0;U=ya+8|0;V=ya+12|0;W=ya+16|0;X=ya+20|0;Y=ya+24|0;Z=ya+28|0;R=0;n=w;do{N=k[pa>>2]|0;O=aa(k[k[na>>2]>>2]|0,R)|0;P=(k[oa>>2]|0)+(aa(k[k[la>>2]>>2]|0,R)|0)|0;Q=(k[ma>>2]|0)+(aa(k[k[ba>>2]>>2]|0,R)|0)|0;if(ca){L=0;M=N+O|0;while(1){q=N+(O+(aa(wa,L)|0))|0;c=L<<1;o=j[P+(c<<1)>>1]|0;b=o<<16>>16;g=b+-3|0;c=j[P+((c|1)<<1)>>1]|0;s=c+-3|0;K=e+(m[Q+(L<<1)>>1]<<6<<1)|0;if(g>>>0<ra>>>0&s>>>0<qa>>>0){c=0;g=n+(aa(s,ta)|0)+(aa(g,wa)|0)|0;while(1){o=0;q=0;s=g;b=K;while(1){D=aa(j[b>>1]|0,l[s>>0]|0)|0;E=aa(j[b+2>>1]|0,l[s+wa>>0]|0)|0;F=aa(j[b+4>>1]|0,l[s+da>>0]|0)|0;G=aa(j[b+6>>1]|0,l[s+ea>>0]|0)|0;H=aa(j[b+8>>1]|0,l[s+fa>>0]|0)|0;I=aa(j[b+10>>1]|0,l[s+ga>>0]|0)|0;J=aa(j[b+12>>1]|0,l[s+ha>>0]|0)|0;q=D+q+E+F+G+H+I+J+(aa(j[b+14>>1]|0,l[s+ia>>0]|0)|0)|0;o=o+1|0;if((o|0)==8)break;else{s=s+ta|0;b=b+16|0}}J=q+16384>>15;i[M+c>>0]=J>>>0<256?J:(J|0)>0?255:0;c=c+1|0;if((c|0)==(wa|0))break;else g=g+ja+ka|0}}else{if(!(_?!(b>>>0<ua>>>0&c>>>0<va>>>0):0))za=27;do if((za|0)==27){za=0;if($?(c+5|0)<1|o<<16>>16>-5&(g|0)<(ua|0)&(s|0)<(va|0)^1:0){upb(q|0,xa|0,wa|0)|0;break}J=aa(uY(g,ua,sa)|0,wa)|0;D=uY(s,va,sa)|0;k[ya>>2]=D;D=aa(uY(b+-2|0,ua,sa)|0,wa)|0;E=uY(c+-2|0,va,sa)|0;k[T>>2]=E;E=aa(uY(b+-1|0,ua,sa)|0,wa)|0;F=uY(c+-1|0,va,sa)|0;k[U>>2]=F;F=aa(uY(b,ua,sa)|0,wa)|0;G=uY(c,va,sa)|0;k[V>>2]=G;G=aa(uY(b+1|0,ua,sa)|0,wa)|0;H=uY(c+1|0,va,sa)|0;k[W>>2]=H;H=aa(uY(b+2|0,ua,sa)|0,wa)|0;I=uY(c+2|0,va,sa)|0;k[X>>2]=I;I=aa(uY(b+3|0,ua,sa)|0,wa)|0;C=uY(c+3|0,va,sa)|0;k[Y>>2]=C;C=aa(uY(b+4|0,ua,sa)|0,wa)|0;f=uY(c+4|0,va,sa)|0;k[Z>>2]=f;f=(J|0)>-1;v=(D|0)>-1;w=(E|0)>-1;x=(F|0)>-1;y=(G|0)>-1;z=(H|0)>-1;A=(I|0)>-1;B=(C|0)>-1;o=0;d=n;while(1){c=l[xa+o>>0]|0;q=c<<15;if(f){s=0;b=K;while(1){Ba=k[ya+(s<<2)>>2]|0;g=d+(aa(Ba,ta)|0)|0;do if((Ba|0)>=0){q=(aa((l[g+J>>0]|0)-c|0,j[b>>1]|0)|0)+q|0;if(v)q=(aa((l[g+D>>0]|0)-c|0,j[b+2>>1]|0)|0)+q|0;if(w)q=(aa((l[g+E>>0]|0)-c|0,j[b+4>>1]|0)|0)+q|0;if(x)q=(aa((l[g+F>>0]|0)-c|0,j[b+6>>1]|0)|0)+q|0;if(y)q=(aa((l[g+G>>0]|0)-c|0,j[b+8>>1]|0)|0)+q|0;if(z)q=(aa((l[g+H>>0]|0)-c|0,j[b+10>>1]|0)|0)+q|0;if(A)q=(aa((l[g+I>>0]|0)-c|0,j[b+12>>1]|0)|0)+q|0;if(!B)break;q=(aa((l[g+C>>0]|0)-c|0,j[b+14>>1]|0)|0)+q|0}while(0);s=s+1|0;if((s|0)==8)break;else b=b+16|0}}else{s=0;b=K;while(1){Ba=k[ya+(s<<2)>>2]|0;g=d+(aa(Ba,ta)|0)|0;do if((Ba|0)>=0){if(v)q=(aa((l[g+D>>0]|0)-c|0,j[b+2>>1]|0)|0)+q|0;if(w)q=(aa((l[g+E>>0]|0)-c|0,j[b+4>>1]|0)|0)+q|0;if(x)q=(aa((l[g+F>>0]|0)-c|0,j[b+6>>1]|0)|0)+q|0;if(y)q=(aa((l[g+G>>0]|0)-c|0,j[b+8>>1]|0)|0)+q|0;if(z)q=(aa((l[g+H>>0]|0)-c|0,j[b+10>>1]|0)|0)+q|0;if(A)q=(aa((l[g+I>>0]|0)-c|0,j[b+12>>1]|0)|0)+q|0;if(!B)break;q=(aa((l[g+C>>0]|0)-c|0,j[b+14>>1]|0)|0)+q|0}while(0);s=s+1|0;if((s|0)==8)break;else b=b+16|0}}Ba=q+16384>>15;i[M+o>>0]=Ba>>>0<256?Ba:(Ba|0)>0?255:0;o=o+1|0;if((o|0)==(wa|0))break;d=d+1|0}n=n+wa+S|0}while(0)}L=L+1|0;if((L|0)==(a|0))break;else M=M+wa|0}}R=R+1|0}while((R|0)!=(t|0));r=Aa;return}function Nna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,l=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;za=r;r=r+48|0;wa=za+32|0;xa=za;ua=k[a+40>>2]|0;ta=k[ua+4>>2]|0;ua=k[ua>>2]|0;s=k[b+40>>2]|0;q=k[s+4>>2]|0;s=k[s>>2]|0;t=(k[a>>2]|0)>>>3;v=t&511;va=v+1|0;w=k[a+16>>2]|0;sa=(k[a+48>>2]|0)>>>1;h=+p[g>>3];p[u>>3]=h;a=k[u+4>>2]|0;ra=a&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}n=~~h;n=(n>>>0<65536?n:(n|0)>0?65535:0)&65535;h=+p[g+8>>3];p[u>>3]=h;a=k[u+4>>2]|0;ra=a&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}l=~~h;l=(l>>>0<65536?l:(l|0)>0?65535:0)&65535;h=+p[g+16>>3];p[u>>3]=h;a=k[u+4>>2]|0;ra=a&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}i=~~h;i=(i>>>0<65536?i:(i|0)>0?65535:0)&65535;h=+p[g+24>>3];p[u>>3]=h;a=k[u+4>>2]|0;ra=a&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}ra=~~h;j[wa>>1]=n;j[wa+2>>1]=l;j[wa+4>>1]=i;j[wa+6>>1]=ra>>>0<65536?ra:(ra|0)>0?65535:0;ra=(f|0)!=5?f:4;qa=ta+-7|0;qa=(qa|0)<0?0:qa;pa=ua+-7|0;pa=(pa|0)<0?0:pa;if((k[b>>2]&16384|0)!=0?(k[c>>2]&16384|0)!=0:0){oa=(k[d>>2]&16384|0)!=0;a=aa(oa?s:1,q)|0;if(oa)s=1;else ya=16}else{a=q;ya=16}if((ya|0)==16)if((s|0)<=0){r=za;return}oa=b+16|0;ma=b+44|0;na=c+16|0;ka=c+44|0;la=d+16|0;$=d+44|0;ba=(a|0)>0;ca=va<<1;da=va*3|0;ea=va<<2;fa=va*5|0;ga=va*6|0;ha=va*7|0;ia=sa<<3;ja=1-ia|0;Z=(f|0)==5;_=(ra|0)==0;Y=(t|-512)^511;Q=(v<<1)+2|0;R=xa+4|0;S=xa+8|0;T=xa+12|0;U=xa+16|0;V=xa+20|0;W=xa+24|0;X=xa+28|0;P=0;i=w;do{L=k[oa>>2]|0;M=aa(k[k[ma>>2]>>2]|0,P)|0;N=(k[na>>2]|0)+(aa(k[k[ka>>2]>>2]|0,P)|0)|0;O=(k[la>>2]|0)+(aa(k[k[$>>2]>>2]|0,P)|0)|0;if(ba){J=0;K=L+M|0;while(1){n=L+(M+(aa(Q,J)|0))|0;c=J<<1;l=j[N+(c<<1)>>1]|0;b=l<<16>>16;g=b+-3|0;c=j[N+((c|1)<<1)>>1]|0;q=c+-3|0;I=e+(m[O+(J<<1)>>1]<<6<<2)|0;if(g>>>0<qa>>>0&q>>>0<pa>>>0){b=0;q=i+((aa(q,sa)|0)<<1)+((aa(g,va)|0)<<1)|0;do{l=0;h=0.0;n=q;g=I;while(1){h=h+(+(m[n>>1]|0)*+o[g>>2]+ +(m[n+(va<<1)>>1]|0)*+o[g+4>>2]+ +(m[n+(ca<<1)>>1]|0)*+o[g+8>>2]+ +(m[n+(da<<1)>>1]|0)*+o[g+12>>2]+ +(m[n+(ea<<1)>>1]|0)*+o[g+16>>2]+ +(m[n+(fa<<1)>>1]|0)*+o[g+20>>2]+ +(m[n+(ga<<1)>>1]|0)*+o[g+24>>2]+ +(m[n+(ha<<1)>>1]|0)*+o[g+28>>2]);l=l+1|0;if((l|0)==8)break;else{n=n+(sa<<1)|0;g=g+32|0}}q=q+(ia<<1)+(ja<<1)|0;l=(o[u>>2]=h,k[u>>2]|0);if((l&2130706432)>>>0<=1249902592){l=(l|0)<0;h=l?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=l?-0.0:0.0}H=~~h;j[K+(b<<1)>>1]=H>>>0<65536?H:(H|0)>0?65535:0;b=b+1|0}while((b|0)!=(va|0))}else{if(!(Z?!(b>>>0<ta>>>0&c>>>0<ua>>>0):0))ya=30;do if((ya|0)==30){ya=0;if(_?(c+5|0)<1|l<<16>>16>-5&(g|0)<(ta|0)&(q|0)<(ua|0)^1:0){upb(n|0,wa|0,Q|0)|0;break}H=aa(uY(g,ta,ra)|0,va)|0;B=uY(q,ua,ra)|0;k[xa>>2]=B;B=aa(uY(b+-2|0,ta,ra)|0,va)|0;C=uY(c+-2|0,ua,ra)|0;k[R>>2]=C;C=aa(uY(b+-1|0,ta,ra)|0,va)|0;D=uY(c+-1|0,ua,ra)|0;k[S>>2]=D;D=aa(uY(b,ta,ra)|0,va)|0;E=uY(c,ua,ra)|0;k[T>>2]=E;E=aa(uY(b+1|0,ta,ra)|0,va)|0;F=uY(c+1|0,ua,ra)|0;k[U>>2]=F;F=aa(uY(b+2|0,ta,ra)|0,va)|0;G=uY(c+2|0,ua,ra)|0;k[V>>2]=G;G=aa(uY(b+3|0,ta,ra)|0,va)|0;A=uY(c+3|0,ua,ra)|0;k[W>>2]=A;A=aa(uY(b+4|0,ta,ra)|0,va)|0;c=uY(c+4|0,ua,ra)|0;k[X>>2]=c;c=(H|0)>-1;d=(B|0)>-1;f=(C|0)>-1;t=(D|0)>-1;v=(E|0)>-1;w=(F|0)>-1;y=(G|0)>-1;z=(A|0)>-1;l=0;b=i;while(1){x=+(m[wa+(l<<1)>>1]|0);if(c){h=x;g=0;q=I;while(1){Aa=k[xa+(g<<2)>>2]|0;n=b+((aa(Aa,sa)|0)<<1)|0;do if((Aa|0)>=0){h=h+ +o[q>>2]*(+(m[n+(H<<1)>>1]|0)-x);if(d)h=h+ +o[q+4>>2]*(+(m[n+(B<<1)>>1]|0)-x);if(f)h=h+ +o[q+8>>2]*(+(m[n+(C<<1)>>1]|0)-x);if(t)h=h+ +o[q+12>>2]*(+(m[n+(D<<1)>>1]|0)-x);if(v)h=h+ +o[q+16>>2]*(+(m[n+(E<<1)>>1]|0)-x);if(w)h=h+ +o[q+20>>2]*(+(m[n+(F<<1)>>1]|0)-x);if(y)h=h+ +o[q+24>>2]*(+(m[n+(G<<1)>>1]|0)-x);if(!z)break;h=h+ +o[q+28>>2]*(+(m[n+(A<<1)>>1]|0)-x)}while(0);g=g+1|0;if((g|0)==8)break;else q=q+32|0}}else{h=x;g=0;q=I;while(1){Aa=k[xa+(g<<2)>>2]|0;n=b+((aa(Aa,sa)|0)<<1)|0;do if((Aa|0)>=0){if(d)h=h+ +o[q+4>>2]*(+(m[n+(B<<1)>>1]|0)-x);if(f)h=h+ +o[q+8>>2]*(+(m[n+(C<<1)>>1]|0)-x);if(t)h=h+ +o[q+12>>2]*(+(m[n+(D<<1)>>1]|0)-x);if(v)h=h+ +o[q+16>>2]*(+(m[n+(E<<1)>>1]|0)-x);if(w)h=h+ +o[q+20>>2]*(+(m[n+(F<<1)>>1]|0)-x);if(y)h=h+ +o[q+24>>2]*(+(m[n+(G<<1)>>1]|0)-x);if(!z)break;h=h+ +o[q+28>>2]*(+(m[n+(A<<1)>>1]|0)-x)}while(0);g=g+1|0;if((g|0)==8)break;else q=q+32|0}}n=(o[u>>2]=h,k[u>>2]|0);if((n&2130706432)>>>0<=1249902592){n=(n|0)<0;h=n?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=n?-0.0:0.0}Aa=~~h;j[K+(l<<1)>>1]=Aa>>>0<65536?Aa:(Aa|0)>0?65535:0;l=l+1|0;if((l|0)==(va|0))break;b=b+2|0}i=i+(va<<1)+(Y<<1)|0}while(0)}J=J+1|0;if((J|0)==(a|0))break;else K=K+(va<<1)|0}}P=P+1|0}while((P|0)!=(s|0));r=za;return}function Ona(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,l=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;za=r;r=r+48|0;wa=za+32|0;xa=za;ua=k[a+40>>2]|0;ta=k[ua+4>>2]|0;ua=k[ua>>2]|0;s=k[b+40>>2]|0;q=k[s+4>>2]|0;s=k[s>>2]|0;t=(k[a>>2]|0)>>>3;v=t&511;va=v+1|0;w=k[a+16>>2]|0;sa=(k[a+48>>2]|0)>>>1;h=+p[g>>3];p[u>>3]=h;a=k[u+4>>2]|0;ra=a&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}n=~~h;n=((n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768)&65535;h=+p[g+8>>3];p[u>>3]=h;a=k[u+4>>2]|0;ra=a&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}l=~~h;l=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;h=+p[g+16>>3];p[u>>3]=h;a=k[u+4>>2]|0;ra=a&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}i=~~h;i=((i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768)&65535;h=+p[g+24>>3];p[u>>3]=h;a=k[u+4>>2]|0;ra=a&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}ra=~~h;j[wa>>1]=n;j[wa+2>>1]=l;j[wa+4>>1]=i;j[wa+6>>1]=(ra+32768|0)>>>0<65536?ra:(ra|0)>0?32767:32768;ra=(f|0)!=5?f:4;qa=ta+-7|0;qa=(qa|0)<0?0:qa;pa=ua+-7|0;pa=(pa|0)<0?0:pa;if((k[b>>2]&16384|0)!=0?(k[c>>2]&16384|0)!=0:0){oa=(k[d>>2]&16384|0)!=0;a=aa(oa?s:1,q)|0;if(oa)s=1;else ya=16}else{a=q;ya=16}if((ya|0)==16)if((s|0)<=0){r=za;return}oa=b+16|0;ma=b+44|0;na=c+16|0;ka=c+44|0;la=d+16|0;$=d+44|0;ba=(a|0)>0;ca=va<<1;da=va*3|0;ea=va<<2;fa=va*5|0;ga=va*6|0;ha=va*7|0;ia=sa<<3;ja=1-ia|0;Z=(f|0)==5;_=(ra|0)==0;Y=(t|-512)^511;Q=(v<<1)+2|0;R=xa+4|0;S=xa+8|0;T=xa+12|0;U=xa+16|0;V=xa+20|0;W=xa+24|0;X=xa+28|0;P=0;i=w;do{L=k[oa>>2]|0;M=aa(k[k[ma>>2]>>2]|0,P)|0;N=(k[na>>2]|0)+(aa(k[k[ka>>2]>>2]|0,P)|0)|0;O=(k[la>>2]|0)+(aa(k[k[$>>2]>>2]|0,P)|0)|0;if(ba){J=0;K=L+M|0;while(1){n=L+(M+(aa(Q,J)|0))|0;c=J<<1;l=j[N+(c<<1)>>1]|0;b=l<<16>>16;g=b+-3|0;c=j[N+((c|1)<<1)>>1]|0;q=c+-3|0;I=e+(m[O+(J<<1)>>1]<<6<<2)|0;if(g>>>0<qa>>>0&q>>>0<pa>>>0){b=0;q=i+((aa(q,sa)|0)<<1)+((aa(g,va)|0)<<1)|0;do{l=0;h=0.0;n=q;g=I;while(1){h=h+(+(j[n>>1]|0)*+o[g>>2]+ +(j[n+(va<<1)>>1]|0)*+o[g+4>>2]+ +(j[n+(ca<<1)>>1]|0)*+o[g+8>>2]+ +(j[n+(da<<1)>>1]|0)*+o[g+12>>2]+ +(j[n+(ea<<1)>>1]|0)*+o[g+16>>2]+ +(j[n+(fa<<1)>>1]|0)*+o[g+20>>2]+ +(j[n+(ga<<1)>>1]|0)*+o[g+24>>2]+ +(j[n+(ha<<1)>>1]|0)*+o[g+28>>2]);l=l+1|0;if((l|0)==8)break;else{n=n+(sa<<1)|0;g=g+32|0}}q=q+(ia<<1)+(ja<<1)|0;l=(o[u>>2]=h,k[u>>2]|0);if((l&2130706432)>>>0<=1249902592){l=(l|0)<0;h=l?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=l?-0.0:0.0}H=~~h;j[K+(b<<1)>>1]=(H+32768|0)>>>0<65536?H:(H|0)>0?32767:32768;b=b+1|0}while((b|0)!=(va|0))}else{if(!(Z?!(b>>>0<ta>>>0&c>>>0<ua>>>0):0))ya=30;do if((ya|0)==30){ya=0;if(_?(c+5|0)<1|l<<16>>16>-5&(g|0)<(ta|0)&(q|0)<(ua|0)^1:0){upb(n|0,wa|0,Q|0)|0;break}H=aa(uY(g,ta,ra)|0,va)|0;B=uY(q,ua,ra)|0;k[xa>>2]=B;B=aa(uY(b+-2|0,ta,ra)|0,va)|0;C=uY(c+-2|0,ua,ra)|0;k[R>>2]=C;C=aa(uY(b+-1|0,ta,ra)|0,va)|0;D=uY(c+-1|0,ua,ra)|0;k[S>>2]=D;D=aa(uY(b,ta,ra)|0,va)|0;E=uY(c,ua,ra)|0;k[T>>2]=E;E=aa(uY(b+1|0,ta,ra)|0,va)|0;F=uY(c+1|0,ua,ra)|0;k[U>>2]=F;F=aa(uY(b+2|0,ta,ra)|0,va)|0;G=uY(c+2|0,ua,ra)|0;k[V>>2]=G;G=aa(uY(b+3|0,ta,ra)|0,va)|0;A=uY(c+3|0,ua,ra)|0;k[W>>2]=A;A=aa(uY(b+4|0,ta,ra)|0,va)|0;c=uY(c+4|0,ua,ra)|0;k[X>>2]=c;c=(H|0)>-1;d=(B|0)>-1;f=(C|0)>-1;t=(D|0)>-1;v=(E|0)>-1;w=(F|0)>-1;y=(G|0)>-1;z=(A|0)>-1;l=0;b=i;while(1){x=+(j[wa+(l<<1)>>1]|0);if(c){h=x;g=0;q=I;while(1){Aa=k[xa+(g<<2)>>2]|0;n=b+((aa(Aa,sa)|0)<<1)|0;do if((Aa|0)>=0){h=h+ +o[q>>2]*(+(j[n+(H<<1)>>1]|0)-x);if(d)h=h+ +o[q+4>>2]*(+(j[n+(B<<1)>>1]|0)-x);if(f)h=h+ +o[q+8>>2]*(+(j[n+(C<<1)>>1]|0)-x);if(t)h=h+ +o[q+12>>2]*(+(j[n+(D<<1)>>1]|0)-x);if(v)h=h+ +o[q+16>>2]*(+(j[n+(E<<1)>>1]|0)-x);if(w)h=h+ +o[q+20>>2]*(+(j[n+(F<<1)>>1]|0)-x);if(y)h=h+ +o[q+24>>2]*(+(j[n+(G<<1)>>1]|0)-x);if(!z)break;h=h+ +o[q+28>>2]*(+(j[n+(A<<1)>>1]|0)-x)}while(0);g=g+1|0;if((g|0)==8)break;else q=q+32|0}}else{h=x;g=0;q=I;while(1){Aa=k[xa+(g<<2)>>2]|0;n=b+((aa(Aa,sa)|0)<<1)|0;do if((Aa|0)>=0){if(d)h=h+ +o[q+4>>2]*(+(j[n+(B<<1)>>1]|0)-x);if(f)h=h+ +o[q+8>>2]*(+(j[n+(C<<1)>>1]|0)-x);if(t)h=h+ +o[q+12>>2]*(+(j[n+(D<<1)>>1]|0)-x);if(v)h=h+ +o[q+16>>2]*(+(j[n+(E<<1)>>1]|0)-x);if(w)h=h+ +o[q+20>>2]*(+(j[n+(F<<1)>>1]|0)-x);if(y)h=h+ +o[q+24>>2]*(+(j[n+(G<<1)>>1]|0)-x);if(!z)break;h=h+ +o[q+28>>2]*(+(j[n+(A<<1)>>1]|0)-x)}while(0);g=g+1|0;if((g|0)==8)break;else q=q+32|0}}n=(o[u>>2]=h,k[u>>2]|0);if((n&2130706432)>>>0<=1249902592){n=(n|0)<0;h=n?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=n?-0.0:0.0}Aa=~~h;j[K+(l<<1)>>1]=(Aa+32768|0)>>>0<65536?Aa:(Aa|0)>0?32767:32768;l=l+1|0;if((l|0)==(va|0))break;b=b+2|0}i=i+(va<<1)+(Y<<1)|0}while(0)}J=J+1|0;if((J|0)==(a|0))break;else K=K+(va<<1)|0}}P=P+1|0}while((P|0)!=(s|0));r=za;return}function Pna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,l=0,n=0,q=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0.0,Aa=0;ya=r;r=r+48|0;va=ya+32|0;wa=ya;ta=k[a+40>>2]|0;sa=k[ta+4>>2]|0;ta=k[ta>>2]|0;i=k[b+40>>2]|0;h=k[i+4>>2]|0;i=k[i>>2]|0;l=(k[a>>2]|0)>>>3;n=l&511;ua=n+1|0;q=k[a+16>>2]|0;ra=(k[a+48>>2]|0)>>>2;za=+p[g+8>>3];s=+p[g+16>>3];t=+p[g+24>>3];o[va>>2]=+p[g>>3];o[va+4>>2]=za;o[va+8>>2]=s;o[va+12>>2]=t;qa=(f|0)!=5?f:4;pa=sa+-7|0;pa=(pa|0)<0?0:pa;oa=ta+-7|0;oa=(oa|0)<0?0:oa;if((k[b>>2]&16384|0)!=0?(k[c>>2]&16384|0)!=0:0){na=(k[d>>2]&16384|0)!=0;a=aa(na?i:1,h)|0;if(na)i=1;else xa=4}else{a=h;xa=4}if((xa|0)==4)if((i|0)<=0){r=ya;return}na=b+16|0;la=b+44|0;ma=c+16|0;ja=c+44|0;ka=d+16|0;_=d+44|0;$=(a|0)>0;ba=ua<<1;ca=ua*3|0;da=ua<<2;ea=ua*5|0;fa=ua*6|0;ga=ua*7|0;ha=ra<<3;ia=1-ha|0;Y=(f|0)==5;Z=(qa|0)==0;X=(l|-512)^511;P=(n<<2)+4|0;Q=wa+4|0;R=wa+8|0;S=wa+12|0;T=wa+16|0;U=wa+20|0;V=wa+24|0;W=wa+28|0;O=0;g=q;do{K=k[na>>2]|0;L=aa(k[k[la>>2]>>2]|0,O)|0;M=(k[ma>>2]|0)+(aa(k[k[ja>>2]>>2]|0,O)|0)|0;N=(k[ka>>2]|0)+(aa(k[k[_>>2]>>2]|0,O)|0)|0;if($){I=0;J=K+L|0;while(1){b=K+(L+(aa(P,I)|0))|0;l=I<<1;h=j[M+(l<<1)>>1]|0;f=h<<16>>16;c=f+-3|0;l=j[M+((l|1)<<1)>>1]|0;d=l+-3|0;H=e+(m[N+(I<<1)>>1]<<6<<2)|0;if(c>>>0<pa>>>0&d>>>0<oa>>>0){f=0;b=g+((aa(d,ra)|0)<<2)+((aa(c,ua)|0)<<2)|0;while(1){h=0;s=0.0;c=b;d=H;while(1){s=s+(+o[c>>2]*+o[d>>2]+ +o[c+(ua<<2)>>2]*+o[d+4>>2]+ +o[c+(ba<<2)>>2]*+o[d+8>>2]+ +o[c+(ca<<2)>>2]*+o[d+12>>2]+ +o[c+(da<<2)>>2]*+o[d+16>>2]+ +o[c+(ea<<2)>>2]*+o[d+20>>2]+ +o[c+(fa<<2)>>2]*+o[d+24>>2]+ +o[c+(ga<<2)>>2]*+o[d+28>>2]);h=h+1|0;if((h|0)==8)break;else{c=c+(ra<<2)|0;d=d+32|0}}o[J+(f<<2)>>2]=s;f=f+1|0;if((f|0)==(ua|0))break;else b=b+(ha<<2)+(ia<<2)|0}}else{if(!(Y?!(f>>>0<sa>>>0&l>>>0<ta>>>0):0))xa=15;do if((xa|0)==15){xa=0;if(Z?(l+5|0)<1|h<<16>>16>-5&(c|0)<(sa|0)&(d|0)<(ta|0)^1:0){upb(b|0,va|0,P|0)|0;break}G=aa(uY(c,sa,qa)|0,ua)|0;A=uY(d,ta,qa)|0;k[wa>>2]=A;A=aa(uY(f+-2|0,sa,qa)|0,ua)|0;B=uY(l+-2|0,ta,qa)|0;k[Q>>2]=B;B=aa(uY(f+-1|0,sa,qa)|0,ua)|0;C=uY(l+-1|0,ta,qa)|0;k[R>>2]=C;C=aa(uY(f,sa,qa)|0,ua)|0;D=uY(l,ta,qa)|0;k[S>>2]=D;D=aa(uY(f+1|0,sa,qa)|0,ua)|0;E=uY(l+1|0,ta,qa)|0;k[T>>2]=E;E=aa(uY(f+2|0,sa,qa)|0,ua)|0;F=uY(l+2|0,ta,qa)|0;k[U>>2]=F;F=aa(uY(f+3|0,sa,qa)|0,ua)|0;z=uY(l+3|0,ta,qa)|0;k[V>>2]=z;z=aa(uY(f+4|0,sa,qa)|0,ua)|0;l=uY(l+4|0,ta,qa)|0;k[W>>2]=l;l=(G|0)>-1;n=(A|0)>-1;q=(B|0)>-1;u=(C|0)>-1;v=(D|0)>-1;w=(E|0)>-1;x=(F|0)>-1;y=(z|0)>-1;h=0;f=g;while(1){t=+o[va+(h<<2)>>2];if(l){s=t;c=0;d=H;while(1){Aa=k[wa+(c<<2)>>2]|0;b=f+((aa(Aa,ra)|0)<<2)|0;do if((Aa|0)>=0){s=s+(+o[b+(G<<2)>>2]-t)*+o[d>>2];if(n)s=s+(+o[b+(A<<2)>>2]-t)*+o[d+4>>2];if(q)s=s+(+o[b+(B<<2)>>2]-t)*+o[d+8>>2];if(u)s=s+(+o[b+(C<<2)>>2]-t)*+o[d+12>>2];if(v)s=s+(+o[b+(D<<2)>>2]-t)*+o[d+16>>2];if(w)s=s+(+o[b+(E<<2)>>2]-t)*+o[d+20>>2];if(x)s=s+(+o[b+(F<<2)>>2]-t)*+o[d+24>>2];if(!y)break;s=s+(+o[b+(z<<2)>>2]-t)*+o[d+28>>2]}while(0);c=c+1|0;if((c|0)==8)break;else d=d+32|0}}else{s=t;c=0;d=H;while(1){Aa=k[wa+(c<<2)>>2]|0;b=f+((aa(Aa,ra)|0)<<2)|0;do if((Aa|0)>=0){if(n)s=s+(+o[b+(A<<2)>>2]-t)*+o[d+4>>2];if(q)s=s+(+o[b+(B<<2)>>2]-t)*+o[d+8>>2];if(u)s=s+(+o[b+(C<<2)>>2]-t)*+o[d+12>>2];if(v)s=s+(+o[b+(D<<2)>>2]-t)*+o[d+16>>2];if(w)s=s+(+o[b+(E<<2)>>2]-t)*+o[d+20>>2];if(x)s=s+(+o[b+(F<<2)>>2]-t)*+o[d+24>>2];if(!y)break;s=s+(+o[b+(z<<2)>>2]-t)*+o[d+28>>2]}while(0);c=c+1|0;if((c|0)==8)break;else d=d+32|0}}o[J+(h<<2)>>2]=s;h=h+1|0;if((h|0)==(ua|0))break;f=f+4|0}g=g+(ua<<2)+(X<<2)|0}while(0)}I=I+1|0;if((I|0)==(a|0))break;else J=J+(ua<<2)|0}}O=O+1|0}while((O|0)!=(i|0));r=ya;return}function Qna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,l=0,n=0,q=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0.0,Aa=0;ya=r;r=r+64|0;va=ya;wa=ya+32|0;ta=k[a+40>>2]|0;sa=k[ta+4>>2]|0;ta=k[ta>>2]|0;i=k[b+40>>2]|0;h=k[i+4>>2]|0;i=k[i>>2]|0;l=(k[a>>2]|0)>>>3;n=l&511;ua=n+1|0;q=k[a+16>>2]|0;ra=(k[a+48>>2]|0)>>>3;za=+p[g+8>>3];s=+p[g+16>>3];t=+p[g+24>>3];p[va>>3]=+p[g>>3];p[va+8>>3]=za;p[va+16>>3]=s;p[va+24>>3]=t;qa=(f|0)!=5?f:4;pa=sa+-7|0;pa=(pa|0)<0?0:pa;oa=ta+-7|0;oa=(oa|0)<0?0:oa;if((k[b>>2]&16384|0)!=0?(k[c>>2]&16384|0)!=0:0){na=(k[d>>2]&16384|0)!=0;a=aa(na?i:1,h)|0;if(na)i=1;else xa=4}else{a=h;xa=4}if((xa|0)==4)if((i|0)<=0){r=ya;return}na=b+16|0;la=b+44|0;ma=c+16|0;ja=c+44|0;ka=d+16|0;_=d+44|0;$=(a|0)>0;ba=ua<<1;ca=ua*3|0;da=ua<<2;ea=ua*5|0;fa=ua*6|0;ga=ua*7|0;ha=ra<<3;ia=1-ha|0;Y=(f|0)==5;Z=(qa|0)==0;X=(l|-512)^511;P=(n<<3)+8|0;Q=wa+4|0;R=wa+8|0;S=wa+12|0;T=wa+16|0;U=wa+20|0;V=wa+24|0;W=wa+28|0;O=0;g=q;do{K=k[na>>2]|0;L=aa(k[k[la>>2]>>2]|0,O)|0;M=(k[ma>>2]|0)+(aa(k[k[ja>>2]>>2]|0,O)|0)|0;N=(k[ka>>2]|0)+(aa(k[k[_>>2]>>2]|0,O)|0)|0;if($){I=0;J=K+L|0;while(1){b=K+(L+(aa(P,I)|0))|0;l=I<<1;h=j[M+(l<<1)>>1]|0;f=h<<16>>16;c=f+-3|0;l=j[M+((l|1)<<1)>>1]|0;d=l+-3|0;H=e+(m[N+(I<<1)>>1]<<6<<2)|0;if(c>>>0<pa>>>0&d>>>0<oa>>>0){f=0;b=g+((aa(d,ra)|0)<<3)+((aa(c,ua)|0)<<3)|0;while(1){h=0;s=0.0;c=b;d=H;while(1){s=s+(+p[c>>3]*+o[d>>2]+ +p[c+(ua<<3)>>3]*+o[d+4>>2]+ +p[c+(ba<<3)>>3]*+o[d+8>>2]+ +p[c+(ca<<3)>>3]*+o[d+12>>2]+ +p[c+(da<<3)>>3]*+o[d+16>>2]+ +p[c+(ea<<3)>>3]*+o[d+20>>2]+ +p[c+(fa<<3)>>3]*+o[d+24>>2]+ +p[c+(ga<<3)>>3]*+o[d+28>>2]);h=h+1|0;if((h|0)==8)break;else{c=c+(ra<<3)|0;d=d+32|0}}p[J+(f<<3)>>3]=s;f=f+1|0;if((f|0)==(ua|0))break;else b=b+(ha<<3)+(ia<<3)|0}}else{if(!(Y?!(f>>>0<sa>>>0&l>>>0<ta>>>0):0))xa=15;do if((xa|0)==15){xa=0;if(Z?(l+5|0)<1|h<<16>>16>-5&(c|0)<(sa|0)&(d|0)<(ta|0)^1:0){upb(b|0,va|0,P|0)|0;break}G=aa(uY(c,sa,qa)|0,ua)|0;A=uY(d,ta,qa)|0;k[wa>>2]=A;A=aa(uY(f+-2|0,sa,qa)|0,ua)|0;B=uY(l+-2|0,ta,qa)|0;k[Q>>2]=B;B=aa(uY(f+-1|0,sa,qa)|0,ua)|0;C=uY(l+-1|0,ta,qa)|0;k[R>>2]=C;C=aa(uY(f,sa,qa)|0,ua)|0;D=uY(l,ta,qa)|0;k[S>>2]=D;D=aa(uY(f+1|0,sa,qa)|0,ua)|0;E=uY(l+1|0,ta,qa)|0;k[T>>2]=E;E=aa(uY(f+2|0,sa,qa)|0,ua)|0;F=uY(l+2|0,ta,qa)|0;k[U>>2]=F;F=aa(uY(f+3|0,sa,qa)|0,ua)|0;z=uY(l+3|0,ta,qa)|0;k[V>>2]=z;z=aa(uY(f+4|0,sa,qa)|0,ua)|0;l=uY(l+4|0,ta,qa)|0;k[W>>2]=l;l=(G|0)>-1;n=(A|0)>-1;q=(B|0)>-1;u=(C|0)>-1;v=(D|0)>-1;w=(E|0)>-1;x=(F|0)>-1;y=(z|0)>-1;h=0;f=g;while(1){t=+p[va+(h<<3)>>3];if(l){s=t;c=0;d=H;while(1){Aa=k[wa+(c<<2)>>2]|0;b=f+((aa(Aa,ra)|0)<<3)|0;do if((Aa|0)>=0){s=s+(+p[b+(G<<3)>>3]-t)*+o[d>>2];if(n)s=s+(+p[b+(A<<3)>>3]-t)*+o[d+4>>2];if(q)s=s+(+p[b+(B<<3)>>3]-t)*+o[d+8>>2];if(u)s=s+(+p[b+(C<<3)>>3]-t)*+o[d+12>>2];if(v)s=s+(+p[b+(D<<3)>>3]-t)*+o[d+16>>2];if(w)s=s+(+p[b+(E<<3)>>3]-t)*+o[d+20>>2];if(x)s=s+(+p[b+(F<<3)>>3]-t)*+o[d+24>>2];if(!y)break;s=s+(+p[b+(z<<3)>>3]-t)*+o[d+28>>2]}while(0);c=c+1|0;if((c|0)==8)break;else d=d+32|0}}else{s=t;c=0;d=H;while(1){Aa=k[wa+(c<<2)>>2]|0;b=f+((aa(Aa,ra)|0)<<3)|0;do if((Aa|0)>=0){if(n)s=s+(+p[b+(A<<3)>>3]-t)*+o[d+4>>2];if(q)s=s+(+p[b+(B<<3)>>3]-t)*+o[d+8>>2];if(u)s=s+(+p[b+(C<<3)>>3]-t)*+o[d+12>>2];if(v)s=s+(+p[b+(D<<3)>>3]-t)*+o[d+16>>2];if(w)s=s+(+p[b+(E<<3)>>3]-t)*+o[d+20>>2];if(x)s=s+(+p[b+(F<<3)>>3]-t)*+o[d+24>>2];if(!y)break;s=s+(+p[b+(z<<3)>>3]-t)*+o[d+28>>2]}while(0);c=c+1|0;if((c|0)==8)break;else d=d+32|0}}p[J+(h<<3)>>3]=s;h=h+1|0;if((h|0)==(ua|0))break;f=f+8|0}g=g+(ua<<3)+(X<<3)|0}while(0)}I=I+1|0;if((I|0)==(a|0))break;else J=J+(ua<<3)|0}}O=O+1|0}while((O|0)!=(i|0));r=ya;return}function Rna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;za=r;r=r+32|0;wa=za+16|0;xa=za;ua=k[a+40>>2]|0;ta=k[ua+4>>2]|0;ua=k[ua>>2]|0;t=k[b+40>>2]|0;s=k[t+4>>2]|0;t=k[t>>2]|0;v=(k[a>>2]|0)>>>3;va=(v&511)+1|0;w=k[a+16>>2]|0;sa=k[a+48>>2]|0;h=+p[g>>3];p[u>>3]=h;a=k[u+4>>2]|0;ra=a&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}q=~~h;q=(q>>>0<256?q:(q|0)>0?255:0)&255;h=+p[g+8>>3];p[u>>3]=h;a=k[u+4>>2]|0;ra=a&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}o=~~h;o=(o>>>0<256?o:(o|0)>0?255:0)&255;h=+p[g+16>>3];p[u>>3]=h;a=k[u+4>>2]|0;ra=a&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}n=~~h;n=(n>>>0<256?n:(n|0)>0?255:0)&255;h=+p[g+24>>3];p[u>>3]=h;a=k[u+4>>2]|0;ra=a&2146435072;if(!(ra>>>0>1126170624|(ra|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}ra=~~h;i[wa>>0]=q;i[wa+1>>0]=o;i[wa+2>>0]=n;i[wa+3>>0]=ra>>>0<256?ra:(ra|0)>0?255:0;ra=(f|0)!=5?f:4;qa=ta+-3|0;qa=(qa|0)<0?0:qa;pa=ua+-3|0;pa=(pa|0)<0?0:pa;if((k[b>>2]&16384|0)!=0?(k[c>>2]&16384|0)!=0:0){oa=(k[d>>2]&16384|0)!=0;a=aa(oa?t:1,s)|0;if(oa)t=1;else ya=16}else{a=s;ya=16}if((ya|0)==16)if((t|0)<=0){r=za;return}oa=b+16|0;ma=b+44|0;na=c+16|0;ka=c+44|0;la=d+16|0;fa=d+44|0;ga=(a|0)>0;ha=va<<1;ia=va*3|0;ja=(aa(sa,-3)|0)+1|0;da=(f|0)==5;ea=(ra|0)==0;_=(v|-512)^511;$=xa+4|0;ba=xa+8|0;ca=xa+12|0;Z=0;n=w;do{V=k[oa>>2]|0;W=aa(k[k[ma>>2]>>2]|0,Z)|0;X=(k[na>>2]|0)+(aa(k[k[ka>>2]>>2]|0,Z)|0)|0;Y=(k[la>>2]|0)+(aa(k[k[fa>>2]>>2]|0,Z)|0)|0;if(ga){T=0;U=V+W|0;while(1){o=V+(W+(aa(va,T)|0))|0;g=T<<1;q=j[X+(g<<1)>>1]|0;s=q+-1|0;g=j[X+((g|1)<<1)>>1]|0;F=g+-1|0;S=e+(m[Y+(T<<1)>>1]<<4<<1)|0;if(s>>>0<qa>>>0&F>>>0<pa>>>0){g=S+2|0;b=S+4|0;c=S+6|0;d=S+8|0;f=S+10|0;v=S+12|0;w=S+14|0;x=S+16|0;y=S+18|0;z=S+20|0;A=S+22|0;B=S+24|0;C=S+26|0;D=S+28|0;E=S+30|0;o=n+(aa(F,sa)|0)+(aa(s,va)|0)|0;q=0;while(1){Aa=aa(j[S>>1]|0,l[o>>0]|0)|0;s=aa(j[g>>1]|0,l[o+va>>0]|0)|0;F=aa(j[b>>1]|0,l[o+ha>>0]|0)|0;G=aa(j[c>>1]|0,l[o+ia>>0]|0)|0;o=o+sa|0;H=aa(j[d>>1]|0,l[o>>0]|0)|0;I=aa(j[f>>1]|0,l[o+va>>0]|0)|0;J=aa(j[v>>1]|0,l[o+ha>>0]|0)|0;K=aa(j[w>>1]|0,l[o+ia>>0]|0)|0;o=o+sa|0;L=aa(j[x>>1]|0,l[o>>0]|0)|0;M=aa(j[y>>1]|0,l[o+va>>0]|0)|0;N=aa(j[z>>1]|0,l[o+ha>>0]|0)|0;O=aa(j[A>>1]|0,l[o+ia>>0]|0)|0;o=o+sa|0;P=aa(j[B>>1]|0,l[o>>0]|0)|0;Q=aa(j[C>>1]|0,l[o+va>>0]|0)|0;R=aa(j[D>>1]|0,l[o+ha>>0]|0)|0;R=Aa+16384+s+F+G+H+I+J+K+L+M+N+O+P+Q+R+(aa(j[E>>1]|0,l[o+ia>>0]|0)|0)>>15;i[U+q>>0]=R>>>0<256?R:(R|0)>0?255:0;q=q+1|0;if((q|0)==(va|0))break;else o=o+ja|0}}else{if(!(da?!(q>>>0<ta>>>0&g>>>0<ua>>>0):0))ya=25;do if((ya|0)==25){ya=0;if(ea?(g+3|0)<1|((g|0)>(ua|0)|((q|0)>(ta|0)|(q+3|0)<1)):0){upb(o|0,wa|0,va|0)|0;break}R=aa(uY(s,ta,ra)|0,va)|0;P=uY(F,ua,ra)|0;k[xa>>2]=P;P=aa(uY(q,ta,ra)|0,va)|0;Q=uY(g,ua,ra)|0;k[$>>2]=Q;Q=aa(uY(q+1|0,ta,ra)|0,va)|0;O=uY(g+1|0,ua,ra)|0;k[ba>>2]=O;O=aa(uY(q+2|0,ta,ra)|0,va)|0;C=uY(g+2|0,ua,ra)|0;k[ca>>2]=C;C=S+8|0;z=C+8|0;w=z+8|0;f=w+2|0;v=w+4|0;w=w+6|0;x=z+2|0;y=z+4|0;z=z+6|0;A=C+2|0;B=C+4|0;C=C+6|0;D=S+2|0;E=S+4|0;F=S+6|0;J=S+16|0;H=S+24|0;G=H+4|0;H=H+6|0;I=J+4|0;J=J+6|0;K=(R|0)>-1;L=(P|0)>-1;M=(Q|0)>-1;N=(O|0)>-1;o=0;d=n;while(1){c=l[wa+o>>0]|0;q=c<<15;do if(!K){g=k[xa>>2]|0;s=d+(aa(g,sa)|0)|0;g=(g|0)<0;if(L){do if(!g){q=(aa((l[s+P>>0]|0)-c|0,j[D>>1]|0)|0)+q|0;if(M)q=(aa((l[s+Q>>0]|0)-c|0,j[E>>1]|0)|0)+q|0;if(!N)break;q=(aa((l[s+O>>0]|0)-c|0,j[F>>1]|0)|0)+q|0}while(0);Aa=k[$>>2]|0;g=d+(aa(Aa,sa)|0)|0;do if((Aa|0)>=0){q=(aa((l[g+P>>0]|0)-c|0,j[A>>1]|0)|0)+q|0;if(M)q=(aa((l[g+Q>>0]|0)-c|0,j[B>>1]|0)|0)+q|0;if(!N)break;q=(aa((l[g+O>>0]|0)-c|0,j[C>>1]|0)|0)+q|0}while(0);Aa=k[ba>>2]|0;g=d+(aa(Aa,sa)|0)|0;do if((Aa|0)>=0){q=(aa((l[g+P>>0]|0)-c|0,j[x>>1]|0)|0)+q|0;if(M)q=(aa((l[g+Q>>0]|0)-c|0,j[y>>1]|0)|0)+q|0;if(!N)break;q=(aa((l[g+O>>0]|0)-c|0,j[z>>1]|0)|0)+q|0}while(0);Aa=k[ca>>2]|0;g=d+(aa(Aa,sa)|0)|0;if((Aa|0)<0)break;q=(aa((l[g+P>>0]|0)-c|0,j[f>>1]|0)|0)+q|0;if(M)q=(aa((l[g+Q>>0]|0)-c|0,j[v>>1]|0)|0)+q|0;if(!N)break;q=(aa((l[g+O>>0]|0)-c|0,j[w>>1]|0)|0)+q|0;break}else{do if(!g){if(M)q=(aa((l[s+Q>>0]|0)-c|0,j[E>>1]|0)|0)+q|0;if(!N)break;q=(aa((l[s+O>>0]|0)-c|0,j[F>>1]|0)|0)+q|0}while(0);Aa=k[$>>2]|0;g=d+(aa(Aa,sa)|0)|0;do if((Aa|0)>=0){if(M)q=(aa((l[g+Q>>0]|0)-c|0,j[B>>1]|0)|0)+q|0;if(!N)break;q=(aa((l[g+O>>0]|0)-c|0,j[C>>1]|0)|0)+q|0}while(0);Aa=k[ba>>2]|0;g=d+(aa(Aa,sa)|0)|0;do if((Aa|0)>=0){if(M)q=(aa((l[g+Q>>0]|0)-c|0,j[I>>1]|0)|0)+q|0;if(!N)break;q=(aa((l[g+O>>0]|0)-c|0,j[J>>1]|0)|0)+q|0}while(0);Aa=k[ca>>2]|0;g=d+(aa(Aa,sa)|0)|0;if((Aa|0)<0)break;if(M)q=(aa((l[g+Q>>0]|0)-c|0,j[G>>1]|0)|0)+q|0;if(!N)break;q=(aa((l[g+O>>0]|0)-c|0,j[H>>1]|0)|0)+q|0;break}}else{s=0;b=S;while(1){Aa=k[xa+(s<<2)>>2]|0;g=d+(aa(Aa,sa)|0)|0;do if((Aa|0)>=0){q=(aa((l[g+R>>0]|0)-c|0,j[b>>1]|0)|0)+q|0;if(L)q=(aa((l[g+P>>0]|0)-c|0,j[b+2>>1]|0)|0)+q|0;if(M)q=(aa((l[g+Q>>0]|0)-c|0,j[b+4>>1]|0)|0)+q|0;if(!N)break;q=(aa((l[g+O>>0]|0)-c|0,j[b+6>>1]|0)|0)+q|0}while(0);s=s+1|0;if((s|0)==4)break;else b=b+8|0}}while(0);Aa=q+16384>>15;i[U+o>>0]=Aa>>>0<256?Aa:(Aa|0)>0?255:0;o=o+1|0;if((o|0)==(va|0))break;d=d+1|0}n=n+va+_|0}while(0)}T=T+1|0;if((T|0)==(a|0))break;else U=U+va|0}}Z=Z+1|0}while((Z|0)!=(t|0));r=za;return}function Sna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,l=0,n=0,q=0,s=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;Va=r;r=r+32|0;Sa=Va+16|0;Ta=Va;Qa=k[a+40>>2]|0;Pa=k[Qa+4>>2]|0;Qa=k[Qa>>2]|0;s=k[b+40>>2]|0;q=k[s+4>>2]|0;s=k[s>>2]|0;t=(k[a>>2]|0)>>>3;D=t&511;Ra=D+1|0;M=k[a+16>>2]|0;Oa=(k[a+48>>2]|0)>>>1;h=+p[g>>3];p[u>>3]=h;a=k[u+4>>2]|0;Na=a&2146435072;if(!(Na>>>0>1126170624|(Na|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}n=~~h;n=(n>>>0<65536?n:(n|0)>0?65535:0)&65535;h=+p[g+8>>3];p[u>>3]=h;a=k[u+4>>2]|0;Na=a&2146435072;if(!(Na>>>0>1126170624|(Na|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}l=~~h;l=(l>>>0<65536?l:(l|0)>0?65535:0)&65535;h=+p[g+16>>3];p[u>>3]=h;a=k[u+4>>2]|0;Na=a&2146435072;if(!(Na>>>0>1126170624|(Na|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}i=~~h;i=(i>>>0<65536?i:(i|0)>0?65535:0)&65535;h=+p[g+24>>3];p[u>>3]=h;a=k[u+4>>2]|0;Na=a&2146435072;if(!(Na>>>0>1126170624|(Na|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}Na=~~h;j[Sa>>1]=n;j[Sa+2>>1]=l;j[Sa+4>>1]=i;j[Sa+6>>1]=Na>>>0<65536?Na:(Na|0)>0?65535:0;Na=(f|0)!=5?f:4;Ma=Pa+-3|0;Ma=(Ma|0)<0?0:Ma;La=Qa+-3|0;La=(La|0)<0?0:La;if((k[b>>2]&16384|0)!=0?(k[c>>2]&16384|0)!=0:0){Ka=(k[d>>2]&16384|0)!=0;a=aa(Ka?s:1,q)|0;if(Ka)s=1;else Ua=16}else{a=q;Ua=16}if((Ua|0)==16)if((s|0)<=0){r=Va;return}Ka=b+16|0;Ia=b+44|0;Ja=c+16|0;Ga=c+44|0;Ha=d+16|0;Ba=d+44|0;Ca=(a|0)>0;Da=Ra<<1;Ea=Ra*3|0;Fa=(aa(Oa,-3)|0)+1|0;za=(f|0)==5;Aa=(Na|0)==0;ya=(t|-512)^511;ua=(D<<1)+2|0;va=Ta+4|0;wa=Ta+8|0;xa=Ta+12|0;ta=0;i=M;do{pa=k[Ka>>2]|0;qa=aa(k[k[Ia>>2]>>2]|0,ta)|0;ra=(k[Ja>>2]|0)+(aa(k[k[Ga>>2]>>2]|0,ta)|0)|0;sa=(k[Ha>>2]|0)+(aa(k[k[Ba>>2]>>2]|0,ta)|0)|0;if(Ca){na=0;oa=pa+qa|0;while(1){n=pa+(qa+(aa(ua,na)|0))|0;b=na<<1;q=j[ra+(b<<1)>>1]|0;l=q+-1|0;b=j[ra+((b|1)<<1)>>1]|0;g=b+-1|0;ma=e+(m[sa+(na<<1)>>1]<<4<<2)|0;if(l>>>0<Ma>>>0&g>>>0<La>>>0){n=i+((aa(g,Oa)|0)<<1)+((aa(l,Ra)|0)<<1)|0;w=+o[ma>>2];x=+o[ma+4>>2];y=+o[ma+8>>2];z=+o[ma+12>>2];A=+o[ma+16>>2];B=+o[ma+20>>2];C=+o[ma+24>>2];E=+o[ma+28>>2];F=+o[ma+32>>2];G=+o[ma+36>>2];H=+o[ma+40>>2];I=+o[ma+44>>2];J=+o[ma+48>>2];K=+o[ma+52>>2];L=+o[ma+56>>2];v=+o[ma+60>>2];g=0;do{la=n+(Oa<<1)|0;ma=la+(Oa<<1)|0;l=ma+(Oa<<1)|0;h=+(m[n>>1]|0)*w+ +(m[n+(Ra<<1)>>1]|0)*x+ +(m[n+(Da<<1)>>1]|0)*y+ +(m[n+(Ea<<1)>>1]|0)*z+(+(m[la>>1]|0)*A+ +(m[la+(Ra<<1)>>1]|0)*B+ +(m[la+(Da<<1)>>1]|0)*C+ +(m[la+(Ea<<1)>>1]|0)*E)+(+(m[ma>>1]|0)*F+ +(m[ma+(Ra<<1)>>1]|0)*G+ +(m[ma+(Da<<1)>>1]|0)*H+ +(m[ma+(Ea<<1)>>1]|0)*I)+(+(m[l>>1]|0)*J+ +(m[l+(Ra<<1)>>1]|0)*K+ +(m[l+(Da<<1)>>1]|0)*L+ +(m[l+(Ea<<1)>>1]|0)*v);n=l+(Fa<<1)|0;l=(o[u>>2]=h,k[u>>2]|0);if((l&2130706432)>>>0<=1249902592){l=(l|0)<0;h=l?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=l?-0.0:0.0}ma=~~h;j[oa+(g<<1)>>1]=ma>>>0<65536?ma:(ma|0)>0?65535:0;g=g+1|0}while((g|0)!=(Ra|0))}else{if(!(za?!(q>>>0<Pa>>>0&b>>>0<Qa>>>0):0))Ua=28;do if((Ua|0)==28){Ua=0;if(Aa?(b+3|0)<1|((b|0)>(Qa|0)|((q|0)>(Pa|0)|(q+3|0)<1)):0){upb(n|0,Sa|0,ua|0)|0;break}la=aa(uY(l,Pa,Na)|0,Ra)|0;d=uY(g,Qa,Na)|0;k[Ta>>2]=d;ja=aa(uY(q,Pa,Na)|0,Ra)|0;t=uY(b,Qa,Na)|0;k[va>>2]=t;ka=aa(uY(q+1|0,Pa,Na)|0,Ra)|0;M=uY(b+1|0,Qa,Na)|0;k[wa>>2]=M;ia=aa(uY(q+2|0,Pa,Na)|0,Ra)|0;O=uY(b+2|0,Qa,Na)|0;k[xa>>2]=O;c=aa(d,Oa)|0;d=(d|0)<0;X=ma+16|0;f=aa(t,Oa)|0;t=(t|0)<0;U=X+16|0;D=aa(M,Oa)|0;M=(M|0)<0;R=U+16|0;N=aa(O,Oa)|0;O=(O|0)<0;P=R+4|0;Q=R+8|0;R=R+12|0;S=U+4|0;T=U+8|0;U=U+12|0;V=X+4|0;W=X+8|0;X=X+12|0;Y=ma+4|0;Z=ma+8|0;_=ma+12|0;da=ma+32|0;ba=ma+48|0;$=ba+8|0;ba=ba+12|0;ca=da+8|0;da=da+12|0;ea=(la|0)>-1;fa=(ja|0)>-1;ga=(ka|0)>-1;ha=(ia|0)>-1;l=0;b=i;while(1){v=+(m[Sa+(l<<1)>>1]|0);do if(!ea){n=b+(c<<1)|0;if(fa){do if(d)h=v;else{h=v+ +o[Y>>2]*(+(m[n+(ja<<1)>>1]|0)-v);if(ga)h=h+ +o[Z>>2]*(+(m[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[_>>2]*(+(m[n+(ia<<1)>>1]|0)-v)}while(0);n=b+(f<<1)|0;do if(!t){h=h+ +o[V>>2]*(+(m[n+(ja<<1)>>1]|0)-v);if(ga)h=h+ +o[W>>2]*(+(m[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[X>>2]*(+(m[n+(ia<<1)>>1]|0)-v)}while(0);n=b+(D<<1)|0;do if(!M){h=h+ +o[S>>2]*(+(m[n+(ja<<1)>>1]|0)-v);if(ga)h=h+ +o[T>>2]*(+(m[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[U>>2]*(+(m[n+(ia<<1)>>1]|0)-v)}while(0);n=b+(N<<1)|0;if(O)break;h=h+ +o[P>>2]*(+(m[n+(ja<<1)>>1]|0)-v);if(ga)h=h+ +o[Q>>2]*(+(m[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[R>>2]*(+(m[n+(ia<<1)>>1]|0)-v);break}else{do if(d)h=v;else{if(ga)h=v+ +o[Z>>2]*(+(m[n+(ka<<1)>>1]|0)-v);else h=v;if(!ha)break;h=h+ +o[_>>2]*(+(m[n+(ia<<1)>>1]|0)-v)}while(0);n=b+(f<<1)|0;do if(!t){if(ga)h=h+ +o[W>>2]*(+(m[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[X>>2]*(+(m[n+(ia<<1)>>1]|0)-v)}while(0);n=b+(D<<1)|0;do if(!M){if(ga)h=h+ +o[ca>>2]*(+(m[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[da>>2]*(+(m[n+(ia<<1)>>1]|0)-v)}while(0);n=b+(N<<1)|0;if(O)break;if(ga)h=h+ +o[$>>2]*(+(m[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[ba>>2]*(+(m[n+(ia<<1)>>1]|0)-v);break}}else{h=v;g=0;q=ma;while(1){Wa=k[Ta+(g<<2)>>2]|0;n=b+((aa(Wa,Oa)|0)<<1)|0;do if((Wa|0)>=0){h=h+ +o[q>>2]*(+(m[n+(la<<1)>>1]|0)-v);if(fa)h=h+ +o[q+4>>2]*(+(m[n+(ja<<1)>>1]|0)-v);if(ga)h=h+ +o[q+8>>2]*(+(m[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[q+12>>2]*(+(m[n+(ia<<1)>>1]|0)-v)}while(0);g=g+1|0;if((g|0)==4)break;else q=q+16|0}}while(0);n=(o[u>>2]=h,k[u>>2]|0);if((n&2130706432)>>>0<=1249902592){n=(n|0)<0;h=n?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=n?-0.0:0.0}Wa=~~h;j[oa+(l<<1)>>1]=Wa>>>0<65536?Wa:(Wa|0)>0?65535:0;l=l+1|0;if((l|0)==(Ra|0))break;b=b+2|0}i=i+(Ra<<1)+(ya<<1)|0}while(0)}na=na+1|0;if((na|0)==(a|0))break;else oa=oa+(Ra<<1)|0}}ta=ta+1|0}while((ta|0)!=(s|0));r=Va;return}function Tna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,l=0,n=0,q=0,s=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;Va=r;r=r+32|0;Sa=Va+16|0;Ta=Va;Qa=k[a+40>>2]|0;Pa=k[Qa+4>>2]|0;Qa=k[Qa>>2]|0;s=k[b+40>>2]|0;q=k[s+4>>2]|0;s=k[s>>2]|0;t=(k[a>>2]|0)>>>3;B=t&511;Ra=B+1|0;M=k[a+16>>2]|0;Oa=(k[a+48>>2]|0)>>>1;h=+p[g>>3];p[u>>3]=h;a=k[u+4>>2]|0;Na=a&2146435072;if(!(Na>>>0>1126170624|(Na|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}n=~~h;n=((n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768)&65535;h=+p[g+8>>3];p[u>>3]=h;a=k[u+4>>2]|0;Na=a&2146435072;if(!(Na>>>0>1126170624|(Na|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}l=~~h;l=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;h=+p[g+16>>3];p[u>>3]=h;a=k[u+4>>2]|0;Na=a&2146435072;if(!(Na>>>0>1126170624|(Na|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}i=~~h;i=((i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768)&65535;h=+p[g+24>>3];p[u>>3]=h;a=k[u+4>>2]|0;Na=a&2146435072;if(!(Na>>>0>1126170624|(Na|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}Na=~~h;j[Sa>>1]=n;j[Sa+2>>1]=l;j[Sa+4>>1]=i;j[Sa+6>>1]=(Na+32768|0)>>>0<65536?Na:(Na|0)>0?32767:32768;Na=(f|0)!=5?f:4;Ma=Pa+-3|0;Ma=(Ma|0)<0?0:Ma;La=Qa+-3|0;La=(La|0)<0?0:La;if((k[b>>2]&16384|0)!=0?(k[c>>2]&16384|0)!=0:0){Ka=(k[d>>2]&16384|0)!=0;a=aa(Ka?s:1,q)|0;if(Ka)s=1;else Ua=16}else{a=q;Ua=16}if((Ua|0)==16)if((s|0)<=0){r=Va;return}Ka=b+16|0;Ia=b+44|0;Ja=c+16|0;Ga=c+44|0;Ha=d+16|0;Ba=d+44|0;Ca=(a|0)>0;Da=Ra<<1;Ea=Ra*3|0;Fa=(aa(Oa,-3)|0)+1|0;za=(f|0)==5;Aa=(Na|0)==0;ya=(t|-512)^511;ua=(B<<1)+2|0;va=Ta+4|0;wa=Ta+8|0;xa=Ta+12|0;ta=0;i=M;do{pa=k[Ka>>2]|0;qa=aa(k[k[Ia>>2]>>2]|0,ta)|0;ra=(k[Ja>>2]|0)+(aa(k[k[Ga>>2]>>2]|0,ta)|0)|0;sa=(k[Ha>>2]|0)+(aa(k[k[Ba>>2]>>2]|0,ta)|0)|0;if(Ca){na=0;oa=pa+qa|0;while(1){n=pa+(qa+(aa(ua,na)|0))|0;b=na<<1;q=j[ra+(b<<1)>>1]|0;l=q+-1|0;b=j[ra+((b|1)<<1)>>1]|0;g=b+-1|0;ma=e+(m[sa+(na<<1)>>1]<<4<<2)|0;if(l>>>0<Ma>>>0&g>>>0<La>>>0){n=i+((aa(g,Oa)|0)<<1)+((aa(l,Ra)|0)<<1)|0;w=+o[ma>>2];x=+o[ma+4>>2];y=+o[ma+8>>2];z=+o[ma+12>>2];A=+o[ma+16>>2];C=+o[ma+20>>2];D=+o[ma+24>>2];E=+o[ma+28>>2];F=+o[ma+32>>2];G=+o[ma+36>>2];H=+o[ma+40>>2];I=+o[ma+44>>2];J=+o[ma+48>>2];K=+o[ma+52>>2];L=+o[ma+56>>2];v=+o[ma+60>>2];g=0;do{la=n+(Oa<<1)|0;ma=la+(Oa<<1)|0;l=ma+(Oa<<1)|0;h=+(j[n>>1]|0)*w+ +(j[n+(Ra<<1)>>1]|0)*x+ +(j[n+(Da<<1)>>1]|0)*y+ +(j[n+(Ea<<1)>>1]|0)*z+(+(j[la>>1]|0)*A+ +(j[la+(Ra<<1)>>1]|0)*C+ +(j[la+(Da<<1)>>1]|0)*D+ +(j[la+(Ea<<1)>>1]|0)*E)+(+(j[ma>>1]|0)*F+ +(j[ma+(Ra<<1)>>1]|0)*G+ +(j[ma+(Da<<1)>>1]|0)*H+ +(j[ma+(Ea<<1)>>1]|0)*I)+(+(j[l>>1]|0)*J+ +(j[l+(Ra<<1)>>1]|0)*K+ +(j[l+(Da<<1)>>1]|0)*L+ +(j[l+(Ea<<1)>>1]|0)*v);n=l+(Fa<<1)|0;l=(o[u>>2]=h,k[u>>2]|0);if((l&2130706432)>>>0<=1249902592){l=(l|0)<0;h=l?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=l?-0.0:0.0}ma=~~h;j[oa+(g<<1)>>1]=(ma+32768|0)>>>0<65536?ma:(ma|0)>0?32767:32768;g=g+1|0}while((g|0)!=(Ra|0))}else{if(!(za?!(q>>>0<Pa>>>0&b>>>0<Qa>>>0):0))Ua=28;do if((Ua|0)==28){Ua=0;if(Aa?(b+3|0)<1|((b|0)>(Qa|0)|((q|0)>(Pa|0)|(q+3|0)<1)):0){upb(n|0,Sa|0,ua|0)|0;break}la=aa(uY(l,Pa,Na)|0,Ra)|0;d=uY(g,Qa,Na)|0;k[Ta>>2]=d;ja=aa(uY(q,Pa,Na)|0,Ra)|0;t=uY(b,Qa,Na)|0;k[va>>2]=t;ka=aa(uY(q+1|0,Pa,Na)|0,Ra)|0;M=uY(b+1|0,Qa,Na)|0;k[wa>>2]=M;ia=aa(uY(q+2|0,Pa,Na)|0,Ra)|0;O=uY(b+2|0,Qa,Na)|0;k[xa>>2]=O;c=aa(d,Oa)|0;d=(d|0)<0;X=ma+16|0;f=aa(t,Oa)|0;t=(t|0)<0;U=X+16|0;B=aa(M,Oa)|0;M=(M|0)<0;R=U+16|0;N=aa(O,Oa)|0;O=(O|0)<0;P=R+4|0;Q=R+8|0;R=R+12|0;S=U+4|0;T=U+8|0;U=U+12|0;V=X+4|0;W=X+8|0;X=X+12|0;Y=ma+4|0;Z=ma+8|0;_=ma+12|0;da=ma+32|0;ba=ma+48|0;$=ba+8|0;ba=ba+12|0;ca=da+8|0;da=da+12|0;ea=(la|0)>-1;fa=(ja|0)>-1;ga=(ka|0)>-1;ha=(ia|0)>-1;l=0;b=i;while(1){v=+(j[Sa+(l<<1)>>1]|0);do if(!ea){n=b+(c<<1)|0;if(fa){do if(d)h=v;else{h=v+ +o[Y>>2]*(+(j[n+(ja<<1)>>1]|0)-v);if(ga)h=h+ +o[Z>>2]*(+(j[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[_>>2]*(+(j[n+(ia<<1)>>1]|0)-v)}while(0);n=b+(f<<1)|0;do if(!t){h=h+ +o[V>>2]*(+(j[n+(ja<<1)>>1]|0)-v);if(ga)h=h+ +o[W>>2]*(+(j[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[X>>2]*(+(j[n+(ia<<1)>>1]|0)-v)}while(0);n=b+(B<<1)|0;do if(!M){h=h+ +o[S>>2]*(+(j[n+(ja<<1)>>1]|0)-v);if(ga)h=h+ +o[T>>2]*(+(j[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[U>>2]*(+(j[n+(ia<<1)>>1]|0)-v)}while(0);n=b+(N<<1)|0;if(O)break;h=h+ +o[P>>2]*(+(j[n+(ja<<1)>>1]|0)-v);if(ga)h=h+ +o[Q>>2]*(+(j[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[R>>2]*(+(j[n+(ia<<1)>>1]|0)-v);break}else{do if(d)h=v;else{if(ga)h=v+ +o[Z>>2]*(+(j[n+(ka<<1)>>1]|0)-v);else h=v;if(!ha)break;h=h+ +o[_>>2]*(+(j[n+(ia<<1)>>1]|0)-v)}while(0);n=b+(f<<1)|0;do if(!t){if(ga)h=h+ +o[W>>2]*(+(j[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[X>>2]*(+(j[n+(ia<<1)>>1]|0)-v)}while(0);n=b+(B<<1)|0;do if(!M){if(ga)h=h+ +o[ca>>2]*(+(j[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[da>>2]*(+(j[n+(ia<<1)>>1]|0)-v)}while(0);n=b+(N<<1)|0;if(O)break;if(ga)h=h+ +o[$>>2]*(+(j[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[ba>>2]*(+(j[n+(ia<<1)>>1]|0)-v);break}}else{h=v;g=0;q=ma;while(1){Wa=k[Ta+(g<<2)>>2]|0;n=b+((aa(Wa,Oa)|0)<<1)|0;do if((Wa|0)>=0){h=h+ +o[q>>2]*(+(j[n+(la<<1)>>1]|0)-v);if(fa)h=h+ +o[q+4>>2]*(+(j[n+(ja<<1)>>1]|0)-v);if(ga)h=h+ +o[q+8>>2]*(+(j[n+(ka<<1)>>1]|0)-v);if(!ha)break;h=h+ +o[q+12>>2]*(+(j[n+(ia<<1)>>1]|0)-v)}while(0);g=g+1|0;if((g|0)==4)break;else q=q+16|0}}while(0);n=(o[u>>2]=h,k[u>>2]|0);if((n&2130706432)>>>0<=1249902592){n=(n|0)<0;h=n?h+-8388608.0+8388608.0:h+8388608.0+-8388608.0;if(h==0.0)h=n?-0.0:0.0}Wa=~~h;j[oa+(l<<1)>>1]=(Wa+32768|0)>>>0<65536?Wa:(Wa|0)>0?32767:32768;l=l+1|0;if((l|0)==(Ra|0))break;b=b+2|0}i=i+(Ra<<1)+(ya<<1)|0}while(0)}na=na+1|0;if((na|0)==(a|0))break;else oa=oa+(Ra<<1)|0}}ta=ta+1|0}while((ta|0)!=(s|0));r=Va;return}function Una(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,l=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0.0;Ba=r;r=r+16|0;Aa=Ba;ya=k[a+40>>2]|0;xa=k[ya+4>>2]|0;ya=k[ya>>2]|0;i=k[b+40>>2]|0;h=k[i+4>>2]|0;i=k[i>>2]|0;n=(k[a>>2]|0)>>>3;q=n&511;za=q+1|0;s=k[a+16>>2]|0;wa=(k[a+48>>2]|0)>>>2;Ca=+p[g+8>>3];E=+p[g+16>>3];F=+p[g+24>>3];o[Aa>>2]=+p[g>>3];o[Aa+4>>2]=Ca;o[Aa+8>>2]=E;o[Aa+12>>2]=F;va=(f|0)!=5?f:4;ua=xa+-3|0;ua=(ua|0)<0?0:ua;ta=ya+-3|0;ta=(ta|0)<0?0:ta;if((k[b>>2]&16384|0)!=0?(k[c>>2]&16384|0)!=0:0){sa=(k[d>>2]&16384|0)!=0;a=aa(sa?i:1,h)|0;if(sa)i=1;else l=4}else{a=h;l=4}if((l|0)==4)if((i|0)<=0){r=Ba;return}sa=b+16|0;qa=b+44|0;ra=c+16|0;oa=c+44|0;pa=d+16|0;ja=d+44|0;ka=(a|0)>0;la=za<<1;ma=za*3|0;na=(aa(wa,-3)|0)+1|0;ha=(f|0)==5;ia=(va|0)==0;ga=(n|-512)^511;fa=(q<<2)+4|0;ea=0;g=s;do{$=k[sa>>2]|0;ba=aa(k[k[qa>>2]>>2]|0,ea)|0;ca=(k[ra>>2]|0)+(aa(k[k[oa>>2]>>2]|0,ea)|0)|0;da=(k[pa>>2]|0)+(aa(k[k[ja>>2]>>2]|0,ea)|0)|0;if(ka){Z=0;_=$+ba|0;while(1){h=$+(ba+(aa(fa,Z)|0))|0;b=Z<<1;l=j[ca+(b<<1)>>1]|0;C=l+-1|0;b=j[ca+((b|1)<<1)>>1]|0;D=b+-1|0;Y=e+(m[da+(Z<<1)>>1]<<4<<2)|0;do if(C>>>0<ua>>>0&D>>>0<ta>>>0){c=Y+4|0;d=Y+8|0;f=Y+12|0;n=Y+16|0;q=Y+20|0;s=Y+24|0;t=Y+28|0;u=Y+32|0;v=Y+36|0;w=Y+40|0;x=Y+44|0;y=Y+48|0;z=Y+52|0;A=Y+56|0;B=Y+60|0;h=g+((aa(D,wa)|0)<<2)+((aa(C,za)|0)<<2)|0;l=0;while(1){W=h+(wa<<2)|0;X=W+(wa<<2)|0;b=X+(wa<<2)|0;o[_+(l<<2)>>2]=+o[h>>2]*+o[Y>>2]+ +o[h+(za<<2)>>2]*+o[c>>2]+ +o[h+(la<<2)>>2]*+o[d>>2]+ +o[h+(ma<<2)>>2]*+o[f>>2]+(+o[W>>2]*+o[n>>2]+ +o[W+(za<<2)>>2]*+o[q>>2]+ +o[W+(la<<2)>>2]*+o[s>>2]+ +o[W+(ma<<2)>>2]*+o[t>>2])+(+o[X>>2]*+o[u>>2]+ +o[X+(za<<2)>>2]*+o[v>>2]+ +o[X+(la<<2)>>2]*+o[w>>2]+ +o[X+(ma<<2)>>2]*+o[x>>2])+(+o[b>>2]*+o[y>>2]+ +o[b+(za<<2)>>2]*+o[z>>2]+ +o[b+(la<<2)>>2]*+o[A>>2]+ +o[b+(ma<<2)>>2]*+o[B>>2]);l=l+1|0;if((l|0)==(za|0))break;else h=b+(na<<2)|0}}else{if(ha?!(l>>>0<xa>>>0&b>>>0<ya>>>0):0)break;if(ia?(b+3|0)<1|((b|0)>(ya|0)|((l|0)>(xa|0)|(l+3|0)<1)):0){upb(h|0,Aa|0,fa|0)|0;break}X=aa(uY(C,xa,va)|0,za)|0;d=uY(D,ya,va)|0;V=aa(uY(l,xa,va)|0,za)|0;q=uY(b,ya,va)|0;W=aa(uY(l+1|0,xa,va)|0,za)|0;u=uY(b+1|0,ya,va)|0;U=aa(uY(l+2|0,xa,va)|0,za)|0;x=uY(b+2|0,ya,va)|0;c=aa(d,wa)|0;d=(d|0)<0;f=Y+16|0;n=aa(q,wa)|0;q=(q|0)<0;s=f+16|0;t=aa(u,wa)|0;u=(u|0)<0;v=s+16|0;w=aa(x,wa)|0;x=(x|0)<0;y=v+4|0;z=v+8|0;A=v+12|0;B=s+4|0;C=s+8|0;D=s+12|0;G=f+4|0;H=f+8|0;I=f+12|0;J=Y+4|0;K=Y+8|0;L=Y+12|0;P=Y+32|0;N=Y+48|0;M=N+8|0;N=N+12|0;O=P+8|0;P=P+12|0;Q=(X|0)>-1;R=(V|0)>-1;S=(W|0)>-1;T=(U|0)>-1;h=0;b=g;while(1){F=+o[Aa+(h<<2)>>2];l=b+(c<<2)|0;do if(Q){if(!d){E=F+(+o[l+(X<<2)>>2]-F)*+o[Y>>2];if(R)E=E+(+o[l+(V<<2)>>2]-F)*+o[J>>2];if(S)E=E+(+o[l+(W<<2)>>2]-F)*+o[K>>2];if(T)E=E+(+o[l+(U<<2)>>2]-F)*+o[L>>2]}else E=F;l=b+(n<<2)|0;if(!q){E=E+(+o[l+(X<<2)>>2]-F)*+o[f>>2];if(R)E=E+(+o[l+(V<<2)>>2]-F)*+o[G>>2];if(S)E=E+(+o[l+(W<<2)>>2]-F)*+o[H>>2];if(T)E=E+(+o[l+(U<<2)>>2]-F)*+o[I>>2]}l=b+(t<<2)|0;if(!u){E=E+(+o[l+(X<<2)>>2]-F)*+o[s>>2];if(R)E=E+(+o[l+(V<<2)>>2]-F)*+o[B>>2];if(S)E=E+(+o[l+(W<<2)>>2]-F)*+o[C>>2];if(T)E=E+(+o[l+(U<<2)>>2]-F)*+o[D>>2]}l=b+(w<<2)|0;if(!x){E=E+(+o[l+(X<<2)>>2]-F)*+o[v>>2];if(R)E=E+(+o[l+(V<<2)>>2]-F)*+o[y>>2];if(S)E=E+(+o[l+(W<<2)>>2]-F)*+o[z>>2];if(T)E=E+(+o[l+(U<<2)>>2]-F)*+o[A>>2]}}else if(R){if(!d){E=F+(+o[l+(V<<2)>>2]-F)*+o[J>>2];if(S)E=E+(+o[l+(W<<2)>>2]-F)*+o[K>>2];if(T)E=E+(+o[l+(U<<2)>>2]-F)*+o[L>>2]}else E=F;l=b+(n<<2)|0;if(!q){E=E+(+o[l+(V<<2)>>2]-F)*+o[G>>2];if(S)E=E+(+o[l+(W<<2)>>2]-F)*+o[H>>2];if(T)E=E+(+o[l+(U<<2)>>2]-F)*+o[I>>2]}l=b+(t<<2)|0;if(!u){E=E+(+o[l+(V<<2)>>2]-F)*+o[B>>2];if(S)E=E+(+o[l+(W<<2)>>2]-F)*+o[C>>2];if(T)E=E+(+o[l+(U<<2)>>2]-F)*+o[D>>2]}l=b+(w<<2)|0;if(x)break;E=E+(+o[l+(V<<2)>>2]-F)*+o[y>>2];if(S)E=E+(+o[l+(W<<2)>>2]-F)*+o[z>>2];if(!T)break;E=E+(+o[l+(U<<2)>>2]-F)*+o[A>>2];break}else{if(!d){if(S)E=F+(+o[l+(W<<2)>>2]-F)*+o[K>>2];else E=F;if(T)E=E+(+o[l+(U<<2)>>2]-F)*+o[L>>2]}else E=F;l=b+(n<<2)|0;if(!q){if(S)E=E+(+o[l+(W<<2)>>2]-F)*+o[H>>2];if(T)E=E+(+o[l+(U<<2)>>2]-F)*+o[I>>2]}l=b+(t<<2)|0;if(!u){if(S)E=E+(+o[l+(W<<2)>>2]-F)*+o[O>>2];if(T)E=E+(+o[l+(U<<2)>>2]-F)*+o[P>>2]}l=b+(w<<2)|0;if(x)break;if(S)E=E+(+o[l+(W<<2)>>2]-F)*+o[M>>2];if(!T)break;E=E+(+o[l+(U<<2)>>2]-F)*+o[N>>2];break}while(0);o[_+(h<<2)>>2]=E;h=h+1|0;if((h|0)==(za|0))break;b=b+4|0}g=g+(za<<2)+(ga<<2)|0}while(0);Z=Z+1|0;if((Z|0)==(a|0))break;else _=_+(za<<2)|0}}ea=ea+1|0}while((ea|0)!=(i|0));r=Ba;return}function Vna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,l=0,n=0,q=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0;Ta=r;r=r+48|0;Qa=Ta;Ra=Ta+32|0;Oa=k[a+40>>2]|0;Na=k[Oa+4>>2]|0;Oa=k[Oa>>2]|0;i=k[b+40>>2]|0;h=k[i+4>>2]|0;i=k[i>>2]|0;l=(k[a>>2]|0)>>>3;n=l&511;Pa=n+1|0;q=k[a+16>>2]|0;Ma=(k[a+48>>2]|0)>>>3;F=+p[g+8>>3];G=+p[g+16>>3];H=+p[g+24>>3];p[Qa>>3]=+p[g>>3];p[Qa+8>>3]=F;p[Qa+16>>3]=G;p[Qa+24>>3]=H;La=(f|0)!=5?f:4;Ka=Na+-3|0;Ka=(Ka|0)<0?0:Ka;Ja=Oa+-3|0;Ja=(Ja|0)<0?0:Ja;if((k[b>>2]&16384|0)!=0?(k[c>>2]&16384|0)!=0:0){Ia=(k[d>>2]&16384|0)!=0;a=aa(Ia?i:1,h)|0;if(Ia)i=1;else Sa=4}else{a=h;Sa=4}if((Sa|0)==4)if((i|0)<=0){r=Ta;return}Ia=b+16|0;Ga=b+44|0;Ha=c+16|0;Ea=c+44|0;Fa=d+16|0;za=d+44|0;Aa=(a|0)>0;Ba=Pa<<1;Ca=Pa*3|0;Da=(aa(Ma,-3)|0)+1|0;xa=(f|0)==5;ya=(La|0)==0;wa=(l|-512)^511;sa=(n<<3)+8|0;ta=Ra+4|0;ua=Ra+8|0;va=Ra+12|0;ra=0;g=q;do{na=k[Ia>>2]|0;oa=aa(k[k[Ga>>2]>>2]|0,ra)|0;pa=(k[Ha>>2]|0)+(aa(k[k[Ea>>2]>>2]|0,ra)|0)|0;qa=(k[Fa>>2]|0)+(aa(k[k[za>>2]>>2]|0,ra)|0)|0;if(Aa){la=0;ma=na+oa|0;while(1){b=na+(oa+(aa(sa,la)|0))|0;f=la<<1;d=j[pa+(f<<1)>>1]|0;h=d+-1|0;f=j[pa+((f|1)<<1)>>1]|0;c=f+-1|0;ka=e+(m[qa+(la<<1)>>1]<<4<<2)|0;if(h>>>0<Ka>>>0&c>>>0<Ja>>>0){h=g+((aa(c,Ma)|0)<<3)+((aa(h,Pa)|0)<<3)|0;t=+o[ka>>2];u=+o[ka+4>>2];v=+o[ka+8>>2];w=+o[ka+12>>2];x=+o[ka+16>>2];y=+o[ka+20>>2];z=+o[ka+24>>2];A=+o[ka+28>>2];B=+o[ka+32>>2];C=+o[ka+36>>2];D=+o[ka+40>>2];E=+o[ka+44>>2];F=+o[ka+48>>2];G=+o[ka+52>>2];H=+o[ka+56>>2];s=+o[ka+60>>2];b=0;while(1){ja=h+(Ma<<3)|0;ka=ja+(Ma<<3)|0;c=ka+(Ma<<3)|0;p[ma+(b<<3)>>3]=+p[h>>3]*t+ +p[h+(Pa<<3)>>3]*u+ +p[h+(Ba<<3)>>3]*v+ +p[h+(Ca<<3)>>3]*w+(+p[ja>>3]*x+ +p[ja+(Pa<<3)>>3]*y+ +p[ja+(Ba<<3)>>3]*z+ +p[ja+(Ca<<3)>>3]*A)+(+p[ka>>3]*B+ +p[ka+(Pa<<3)>>3]*C+ +p[ka+(Ba<<3)>>3]*D+ +p[ka+(Ca<<3)>>3]*E)+(+p[c>>3]*F+ +p[c+(Pa<<3)>>3]*G+ +p[c+(Ba<<3)>>3]*H+ +p[c+(Ca<<3)>>3]*s);b=b+1|0;if((b|0)==(Pa|0))break;else h=c+(Da<<3)|0}}else{if(!(xa?!(d>>>0<Na>>>0&f>>>0<Oa>>>0):0))Sa=13;do if((Sa|0)==13){Sa=0;if(ya?(f+3|0)<1|((f|0)>(Oa|0)|((d|0)>(Na|0)|(d+3|0)<1)):0){upb(b|0,Qa|0,sa|0)|0;break}ja=aa(uY(h,Na,La)|0,Pa)|0;n=uY(c,Oa,La)|0;k[Ra>>2]=n;ha=aa(uY(d,Na,La)|0,Pa)|0;I=uY(f,Oa,La)|0;k[ta>>2]=I;ia=aa(uY(d+1|0,Na,La)|0,Pa)|0;K=uY(f+1|0,Oa,La)|0;k[ua>>2]=K;ga=aa(uY(d+2|0,Na,La)|0,Pa)|0;M=uY(f+2|0,Oa,La)|0;k[va>>2]=M;l=aa(n,Ma)|0;n=(n|0)<0;V=ka+16|0;q=aa(I,Ma)|0;I=(I|0)<0;S=V+16|0;J=aa(K,Ma)|0;K=(K|0)<0;P=S+16|0;L=aa(M,Ma)|0;M=(M|0)<0;N=P+4|0;O=P+8|0;P=P+12|0;Q=S+4|0;R=S+8|0;S=S+12|0;T=V+4|0;U=V+8|0;V=V+12|0;W=ka+4|0;X=ka+8|0;Y=ka+12|0;ba=ka+32|0;_=ka+48|0;Z=_+8|0;_=_+12|0;$=ba+8|0;ba=ba+12|0;ca=(ja|0)>-1;da=(ha|0)>-1;ea=(ia|0)>-1;fa=(ga|0)>-1;h=0;f=g;while(1){t=+p[Qa+(h<<3)>>3];do if(!ca){b=f+(l<<3)|0;if(da){if(!n){s=t+(+p[b+(ha<<3)>>3]-t)*+o[W>>2];if(ea)s=s+(+p[b+(ia<<3)>>3]-t)*+o[X>>2];if(fa)s=s+(+p[b+(ga<<3)>>3]-t)*+o[Y>>2]}else s=t;b=f+(q<<3)|0;if(!I){s=s+(+p[b+(ha<<3)>>3]-t)*+o[T>>2];if(ea)s=s+(+p[b+(ia<<3)>>3]-t)*+o[U>>2];if(fa)s=s+(+p[b+(ga<<3)>>3]-t)*+o[V>>2]}b=f+(J<<3)|0;do if(!K){s=s+(+p[b+(ha<<3)>>3]-t)*+o[Q>>2];if(ea)s=s+(+p[b+(ia<<3)>>3]-t)*+o[R>>2];if(!fa)break;s=s+(+p[b+(ga<<3)>>3]-t)*+o[S>>2]}while(0);b=f+(L<<3)|0;if(M)break;s=s+(+p[b+(ha<<3)>>3]-t)*+o[N>>2];if(ea)s=s+(+p[b+(ia<<3)>>3]-t)*+o[O>>2];if(!fa)break;s=s+(+p[b+(ga<<3)>>3]-t)*+o[P>>2];break}else{if(!n){if(ea)s=t+(+p[b+(ia<<3)>>3]-t)*+o[X>>2];else s=t;if(fa)s=s+(+p[b+(ga<<3)>>3]-t)*+o[Y>>2]}else s=t;b=f+(q<<3)|0;if(!I){if(ea)s=s+(+p[b+(ia<<3)>>3]-t)*+o[U>>2];if(fa)s=s+(+p[b+(ga<<3)>>3]-t)*+o[V>>2]}b=f+(J<<3)|0;do if(!K){if(ea)s=s+(+p[b+(ia<<3)>>3]-t)*+o[$>>2];if(!fa)break;s=s+(+p[b+(ga<<3)>>3]-t)*+o[ba>>2]}while(0);b=f+(L<<3)|0;if(M)break;if(ea)s=s+(+p[b+(ia<<3)>>3]-t)*+o[Z>>2];if(!fa)break;s=s+(+p[b+(ga<<3)>>3]-t)*+o[_>>2];break}}else{s=t;c=0;d=ka;while(1){Ua=k[Ra+(c<<2)>>2]|0;b=f+((aa(Ua,Ma)|0)<<3)|0;if((Ua|0)>=0){s=s+(+p[b+(ja<<3)>>3]-t)*+o[d>>2];if(da)s=s+(+p[b+(ha<<3)>>3]-t)*+o[d+4>>2];if(ea)s=s+(+p[b+(ia<<3)>>3]-t)*+o[d+8>>2];if(fa)s=s+(+p[b+(ga<<3)>>3]-t)*+o[d+12>>2]}c=c+1|0;if((c|0)==4)break;else d=d+16|0}}while(0);p[ma+(h<<3)>>3]=s;h=h+1|0;if((h|0)==(Pa|0))break;f=f+8|0}g=g+(Pa<<3)+(wa<<3)|0}while(0)}la=la+1|0;if((la|0)==(a|0))break;else ma=ma+(Pa<<3)|0}}ra=ra+1|0}while((ra|0)!=(i|0));r=Ta;return}function Wna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;ia=r;r=r+528|0;ha=ia+8|0;s=ia;ca=k[a+40>>2]|0;ba=k[ca+4>>2]|0;ca=k[ca>>2]|0;ea=k[b+40>>2]|0;da=k[ea+4>>2]|0;ea=k[ea>>2]|0;v=(k[a>>2]|0)>>>3;t=v&511;fa=t+1|0;ga=k[a+16>>2]|0;$=k[a+48>>2]|0;n=0;do{h=+p[g+((n&3)<<3)>>3];p[u>>3]=h;a=k[u+4>>2]|0;_=a&2146435072;if(!(_>>>0>1126170624|(_|0)==1126170624&0>0)){a=(a|0)<0;h=a?h+-4503599627370496.0+4503599627370496.0:h+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=a?-0.0:0.0}_=~~h;i[ha+n>>0]=_>>>0<256?_:(_|0)>0?255:0;n=n+1|0}while((n|0)!=(fa|0));Z=ba+-1|0;Y=(Z|0)<0?0:Z;_=ca+-1|0;X=(_|0)<0?0:_;if((aa(ca,ba)|0)<=0){a=s+4|0;n=ZT(24)|0;k[n>>2]=1;g=n+4|0;k[s>>2]=g;k[a>>2]=16;i[n+20>>0]=0;o=335628;q=g+16|0;do{i[g>>0]=i[o>>0]|0;g=g+1|0;o=o+1|0}while((g|0)<(q|0));Y8(-215,s,338432,335515,3832);k[a>>2]=0;k[s>>2]=0;V=k[n>>2]|0;k[n>>2]=V+-1;if((V|0)==1)ggb(k[n+-4>>2]|0)}if((ea|0)<=0){r=ia;return}V=b+16|0;T=b+44|0;U=c+16|0;R=c+44|0;S=d+16|0;N=d+44|0;O=(da|0)<0;P=(f|0)==5;Q=P&(fa|0)!=3;K=(t|0)==0;L=(f|0)==0;M=(f|0)==1;J=v&65535;A=$+1|0;B=$+2|0;C=$+3|0;D=$+4|0;E=$+5|0;F=$+6|0;G=$+7|0;z=0;do{H=(k[U>>2]|0)+(aa(k[k[R>>2]>>2]|0,z)|0)|0;I=(k[S>>2]|0)+(aa(k[k[N>>2]>>2]|0,z)|0)|0;if(!O){y=0;x=(k[V>>2]|0)+(aa(k[k[T>>2]>>2]|0,z)|0)|0;t=0;g=0;while(1){do if((y|0)<(da|0)){a=y<<1;if((j[H+(a<<1)>>1]|0)>>>0>=Y>>>0)if(g){W=21;break}else{o=y;a=x;n=t;g=0;break}else{a=(j[H+((a|1)<<1)>>1]|0)>>>0<X>>>0;W=19;break}}else{a=g^1;W=19}while(0);do if((W|0)==19){W=0;if(g^a)if(a){if(Q){o=y;a=x+(aa(y-t|0,fa)|0)|0;n=y;g=1;break}a=(y|0)>(t|0);if(!K){if(!a){o=t;a=x;n=y;g=1;break}w=y+-1-t|0;v=x;while(1){n=t<<1;a=j[H+(n<<1)>>1]|0;g=a<<16>>16;n=j[H+((n|1)<<1)>>1]|0;o=n<<16>>16;do if(L)if(n<<16>>16<-1|a<<16>>16>-2&(g|0)<(ba|0)&(o|0)<(ca|0)^1){a=0;do{i[v+a>>0]=i[ha+a>>0]|0;a=a+1|0}while((a|0)!=(fa|0))}else{a=e+(m[I+(t<<1)>>1]<<2<<1)|0;W=70;break}else{q=e+(m[I+(t<<1)>>1]<<2<<1)|0;if(M){c=g+1|0;b=o+1|0;W=ga+(aa(n<<16>>16>-1?((o|0)<(ca|0)?o:_):0,$)|0)|0;d=aa(a<<16>>16>-1?((g|0)<(ba|0)?g:Z):0,fa)|0;c=aa(a<<16>>16>-2?((c|0)<(ba|0)?c:Z):0,fa)|0;b=ga+(aa(n<<16>>16>-2?((b|0)<(ca|0)?b:_):0,$)|0)|0;s=b+c|0;b=b+d|0;c=W+c|0;d=W+d|0;a=q;W=73}else{a=q;W=70}}while(0);do if((W|0)==70){W=0;if(P?!(g>>>0<Z>>>0&o>>>0<_>>>0):0)break;q=uY(g,ba,f)|0;n=uY(g+1|0,ba,f)|0;g=uY(o,ca,f)|0;o=uY(o+1|0,ca,f)|0;W=ga+(aa(g,$)|0)|0;d=aa(q,fa)|0;c=aa(n,fa)|0;b=ga+(aa(o,$)|0)|0;s=(o|n|0)>-1?b+c|0:ha;b=(o|q|0)>-1?b+d|0:ha;c=(g|n|0)>-1?W+c|0:ha;d=(g|q|0)>-1?W+d|0:ha;W=73}while(0);if((W|0)==73){W=0;g=a+2|0;o=a+4|0;q=a+6|0;n=0;do{la=aa(j[a>>1]|0,l[d+n>>0]|0)|0;ka=aa(j[g>>1]|0,l[c+n>>0]|0)|0;ja=aa(j[o>>1]|0,l[b+n>>0]|0)|0;ja=la+16384+ka+ja+(aa(j[q>>1]|0,l[s+n>>0]|0)|0)>>15;i[v+n>>0]=ja>>>0<256?ja:(ja|0)>0?255:0;n=n+1|0}while((n|0)!=(fa|0))}t=t+1|0;if((t|0)==(y|0))break;else v=v+fa|0}o=y;a=x+fa+(aa(fa,w)|0)|0;n=y;g=1;break}if(a){c=x;d=t;while(1){n=d<<1;a=j[H+(n<<1)>>1]|0;g=a<<16>>16;n=j[H+((n|1)<<1)>>1]|0;o=n<<16>>16;do if(L)if(n<<16>>16<-1|a<<16>>16>-2&(g|0)<(ba|0)&(o|0)<(ca|0)^1){a=i[ha>>0]|0;break}else{a=e+(m[I+(d<<1)>>1]<<2<<1)|0;W=50;break}else{q=e+(m[I+(d<<1)>>1]<<2<<1)|0;if(M){W=a<<16>>16>-1?((g|0)<(ba|0)?g:Z):0;s=g+1|0;a=a<<16>>16>-2?((s|0)<(ba|0)?s:Z):0;s=o+1|0;g=aa(n<<16>>16>-1?((o|0)<(ca|0)?o:_):0,$)|0;n=aa(n<<16>>16>-2?((s|0)<(ca|0)?s:_):0,$)|0;s=i[ga+(n+a)>>0]|0;n=i[ga+(n+W)>>0]|0;o=i[ga+(g+a)>>0]|0;g=i[ga+(g+W)>>0]|0;a=q;W=62}else{a=q;W=50}}while(0);do if((W|0)==50){q=uY(g,ba,f)|0;s=uY(g+1|0,ba,f)|0;n=uY(o,ca,f)|0;o=uY(o+1|0,ca,f)|0;if((n|q|0)>-1){g=ga+((aa(n,$)|0)+q)|0;g=i[g>>0]|0}else g=i[ha>>0]|0;if((n|s|0)>-1){b=ga+((aa(n,$)|0)+s)|0;b=i[b>>0]|0}else b=i[ha>>0]|0;if((o|q|0)>-1){n=ga+((aa(o,$)|0)+q)|0;n=i[n>>0]|0}else n=i[ha>>0]|0;if((o|s|0)>-1){s=ga+((aa(o,$)|0)+s)|0;s=i[s>>0]|0;o=b;W=62;break}else{s=i[ha>>0]|0;o=b;W=62;break}}while(0);if((W|0)==62){W=0;ja=aa(j[a>>1]|0,g&255)|0;ka=aa(j[a+2>>1]|0,o&255)|0;la=aa(j[a+4>>1]|0,n&255)|0;a=ja+16384+ka+la+(aa(j[a+6>>1]|0,s&255)|0)>>15;a=(a>>>0<256?a:(a|0)>0?255:0)&255}i[c>>0]=a;d=d+1|0;if((d|0)==(y|0))break;else c=c+1|0}o=y;a=x+(y-t)|0;n=y;g=1}else{o=t;a=x;n=y;g=1}}else W=21;else{o=y;a=x;n=t}}while(0);a:do if((W|0)==21){W=0;switch(J&511){case 0:{if((y|0)>(t|0)){a=t;n=x}else{o=t;a=x;n=y;g=0;break a}while(1){la=a<<1;ka=e+(m[I+(a<<1)>>1]<<2<<1)|0;la=ga+(aa(j[H+((la|1)<<1)>>1]|0,$)|0)+(j[H+(la<<1)>>1]|0)|0;v=aa(j[ka>>1]|0,l[la>>0]|0)|0;w=aa(j[ka+2>>1]|0,l[la+1>>0]|0)|0;ja=aa(j[ka+4>>1]|0,l[la+$>>0]|0)|0;la=v+16384+w+ja+(aa(j[ka+6>>1]|0,l[la+A>>0]|0)|0)>>15;i[n>>0]=la>>>0<256?la:(la|0)>0?255:0;a=a+1|0;if((a|0)==(y|0))break;else n=n+1|0}o=y;a=x+(y-t)|0;n=y;g=0;break a}case 1:{if((y|0)<=(t|0)){o=t;a=x;n=y;g=0;break a}g=y-t|0;a=t;n=x;while(1){b=a<<1;la=e+(m[I+(a<<1)>>1]<<2<<1)|0;b=ga+(aa(j[H+((b|1)<<1)>>1]|0,$)|0)+(j[H+(b<<1)>>1]<<1)|0;w=j[la>>1]|0;c=aa(w,l[b>>0]|0)|0;ja=j[la+2>>1]|0;d=aa(ja,l[b+2>>0]|0)|0;ka=j[la+4>>1]|0;t=aa(ka,l[b+$>>0]|0)|0;la=j[la+6>>1]|0;v=aa(la,l[b+B>>0]|0)|0;w=aa(l[b+1>>0]|0,w)|0;ja=aa(l[b+3>>0]|0,ja)|0;ka=aa(l[b+A>>0]|0,ka)|0;la=aa(l[b+C>>0]|0,la)|0;v=c+16384+d+t+v>>15;i[n>>0]=v>>>0<256?v:(v|0)>0?255:0;la=w+16384+ja+ka+la>>15;i[n+1>>0]=la>>>0<256?la:(la|0)>0?255:0;a=a+1|0;if((a|0)==(y|0))break;else n=n+2|0}o=y;a=x+(g<<1)|0;n=y;g=0;break a}case 2:{if((y|0)<=(t|0)){o=t;a=x;n=y;g=0;break a}g=y-t|0;a=t;n=x;while(1){ma=a<<1;la=e+(m[I+(a<<1)>>1]<<2<<1)|0;ma=ga+(aa(j[H+((ma|1)<<1)>>1]|0,$)|0)+((j[H+(ma<<1)>>1]|0)*3|0)|0;w=j[la>>1]|0;o=aa(w,l[ma>>0]|0)|0;ja=j[la+2>>1]|0;q=aa(ja,l[ma+3>>0]|0)|0;ka=j[la+4>>1]|0;s=aa(ka,l[ma+$>>0]|0)|0;la=j[la+6>>1]|0;b=aa(la,l[ma+C>>0]|0)|0;c=aa(l[ma+1>>0]|0,w)|0;d=aa(l[ma+4>>0]|0,ja)|0;t=aa(l[ma+A>>0]|0,ka)|0;v=aa(l[ma+D>>0]|0,la)|0;w=aa(l[ma+2>>0]|0,w)|0;ja=aa(l[ma+5>>0]|0,ja)|0;ka=aa(l[ma+B>>0]|0,ka)|0;la=aa(l[ma+E>>0]|0,la)|0;b=o+16384+q+s+b>>15;i[n>>0]=b>>>0<256?b:(b|0)>0?255:0;v=c+16384+d+t+v>>15;i[n+1>>0]=v>>>0<256?v:(v|0)>0?255:0;la=w+16384+ja+ka+la>>15;i[n+2>>0]=la>>>0<256?la:(la|0)>0?255:0;a=a+1|0;if((a|0)==(y|0))break;else n=n+3|0}o=y;a=x+(g*3|0)|0;n=y;g=0;break a}case 3:{if((y|0)<=(t|0)){o=t;a=x;n=y;g=0;break a}g=y-t|0;n=x;a=t;while(1){c=a<<1;ja=e+(m[I+(a<<1)>>1]<<2<<1)|0;c=ga+(aa(j[H+((c|1)<<1)>>1]|0,$)|0)+(j[H+(c<<1)>>1]<<2)|0;w=j[ja>>1]|0;o=aa(w,l[c>>0]|0)|0;ka=ja+2|0;v=j[ka>>1]|0;q=aa(v,l[c+4>>0]|0)|0;la=ja+4|0;t=j[la>>1]|0;s=aa(t,l[c+$>>0]|0)|0;ma=ja+6|0;d=j[ma>>1]|0;b=aa(d,l[c+D>>0]|0)|0;w=aa(l[c+1>>0]|0,w)|0;v=aa(l[c+5>>0]|0,v)|0;t=aa(l[c+A>>0]|0,t)|0;d=aa(l[c+E>>0]|0,d)|0;b=o+16384+q+s+b>>15;i[n>>0]=b>>>0<256?b:(b|0)>0?255:0;d=w+16384+v+t+d>>15;i[n+1>>0]=d>>>0<256?d:(d|0)>0?255:0;ja=j[ja>>1]|0;d=aa(ja,l[c+2>>0]|0)|0;ka=j[ka>>1]|0;t=aa(ka,l[c+6>>0]|0)|0;la=j[la>>1]|0;v=aa(la,l[c+B>>0]|0)|0;ma=j[ma>>1]|0;w=aa(ma,l[c+F>>0]|0)|0;ja=aa(l[c+3>>0]|0,ja)|0;ka=aa(l[c+7>>0]|0,ka)|0;la=aa(l[c+C>>0]|0,la)|0;ma=aa(l[c+G>>0]|0,ma)|0;w=d+16384+t+v+w>>15;i[n+2>>0]=w>>>0<256?w:(w|0)>0?255:0;ma=ja+16384+ka+la+ma>>15;i[n+3>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;a=a+1|0;if((a|0)==(y|0))break;else n=n+4|0}o=y;a=x+(g<<2)|0;n=y;g=0;break a}default:{if((y|0)<=(t|0)){o=t;a=x;n=y;g=0;break a}d=y+-1-t|0;c=x;n=t;while(1){o=n<<1;g=e+(m[I+(n<<1)>>1]<<2<<1)|0;o=ga+(aa(j[H+((o|1)<<1)>>1]|0,$)|0)+(aa(j[H+(o<<1)>>1]|0,fa)|0)|0;q=g+2|0;s=g+4|0;b=g+6|0;a=0;do{ja=aa(j[g>>1]|0,l[o+a>>0]|0)|0;ka=aa(j[q>>1]|0,l[o+(a+fa)>>0]|0)|0;ma=a+$|0;la=aa(j[s>>1]|0,l[o+ma>>0]|0)|0;ma=ja+16384+ka+la+(aa(j[b>>1]|0,l[o+(ma+fa)>>0]|0)|0)>>15;i[c+a>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;a=a+1|0}while((a|0)!=(fa|0));n=n+1|0;if((n|0)==(y|0))break;else c=c+fa|0}o=y;a=x+fa+(aa(fa,d)|0)|0;n=y;g=0;break a}}}while(0);if((o|0)<(da|0)){y=o+1|0;x=a;t=n}else break}}z=z+1|0}while((z|0)!=(ea|0));r=ia;return}
function w0a(a){a=a|0;var b=0,c=0,d=0;d=a+92|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+88>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+72|0;c=a+60|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+96>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+100>>2]|0;if(!((b|0)==(a+104|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+36|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+16|0;c=a+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+44>>2]|0;if((b|0)==(a+48|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function x0a(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=k[a>>2]|0;if(!b)return;g=a+4|0;c=k[g>>2]|0;if((c|0)!=(b|0)){do{k[g>>2]=c+-56;f=c+-20|0;d=k[f>>2]|0;if(d|0?(d=d+12|0,e=k[d>>2]|0,k[d>>2]=e+-1,(e|0)==1):0){e=k[f>>2]|0;if(e|0){d=k[e+4>>2]|0;if(!d){d=k[c+-24>>2]|0;if(!d){d=B1()|0;e=k[f>>2]|0}}jh[k[(k[d>>2]|0)+24>>2]&1023](d,e)}k[f>>2]=0}k[f>>2]=0;f=c+-40|0;e=c+-52|0;k[f>>2]=0;k[f+4>>2]=0;k[f+8>>2]=0;k[f+12>>2]=0;if((k[e>>2]|0)>0){f=k[c+-16>>2]|0;d=0;do{k[f+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(k[e>>2]|0))}d=k[c+-12>>2]|0;if(!((d|0)==(c+-8|0)|(d|0)==0))ggb(k[d+-4>>2]|0);c=k[g>>2]|0}while((c|0)!=(b|0));b=k[a>>2]|0}ggb(b);return}function y0a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0.0,m=0,n=0.0,q=0.0,s=0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;la=r;r=r+528|0;ha=la+504|0;fa=la+32|0;$=la;ga=la+488|0;ia=la+376|0;z=la+368|0;ka=la+312|0;A=la+496|0;ja=la+256|0;B=c+4|0;da=(k[B>>2]|0)-(k[c>>2]|0)>>2;C=S1(a,-1)|0;D=C&7;if((da|0)!=1?(da|0)!=((C>>>3&511)+1|0):0){g=ha+4|0;h=ZT(24)|0;k[h>>2]=1;ca=h+4|0;k[ha>>2]=ca;k[g>>2]=19;i[h+23>>0]=0;ba=394198;da=ca+19|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394218,394239,115);k[g>>2]=0;k[ha>>2]=0;da=k[h>>2]|0;k[h>>2]=da+-1;if((da|0)==1)ggb(k[h+-4>>2]|0)}R1(z,a,-1);do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[ka>>2]=k[j>>2];x=ka+4|0;a=j+4|0;k[x>>2]=k[a>>2];da=ka+8|0;k[da>>2]=k[j+8>>2];k[ka+12>>2]=k[j+12>>2];k[ka+16>>2]=k[j+16>>2];k[ka+20>>2]=k[j+20>>2];k[ka+24>>2]=k[j+24>>2];k[ka+28>>2]=k[j+28>>2];k[ka+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[ka+36>>2]=g;h=ka+40|0;k[h>>2]=da;da=ka+48|0;s=ka+44|0;k[s>>2]=da;k[ka+52>>2]=0;k[da>>2]=0;if(g|0){da=g+12|0;k[da>>2]=(k[da>>2]|0)+1}if((k[a>>2]|0)<3){da=k[j+44>>2]|0;y=k[s>>2]|0;k[y>>2]=k[da>>2];k[y+4>>2]=k[da+4>>2];y=ka;break}k[x>>2]=0;x1(ka,k[a>>2]|0,0,0,0);if((k[x>>2]|0)>0){w=k[j+40>>2]|0;m=k[h>>2]|0;h=k[j+44>>2]|0;g=k[s>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[w+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[x>>2]|0));y=ka}else y=ka}else{Q1(ka,a,-1);y=ka}while(0);k[A>>2]=k[z>>2];k[A+4>>2]=k[z+4>>2];x2(b,A,k[y>>2]&4095,0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[ja>>2]=k[j>>2];x=ja+4|0;a=j+4|0;k[x>>2]=k[a>>2];da=ja+8|0;k[da>>2]=k[j+8>>2];k[ja+12>>2]=k[j+12>>2];k[ja+16>>2]=k[j+16>>2];k[ja+20>>2]=k[j+20>>2];k[ja+24>>2]=k[j+24>>2];k[ja+28>>2]=k[j+28>>2];k[ja+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[ja+36>>2]=g;h=ja+40|0;k[h>>2]=da;da=ja+48|0;s=ja+44|0;k[s>>2]=da;k[ja+52>>2]=0;k[da>>2]=0;if(g|0){da=g+12|0;k[da>>2]=(k[da>>2]|0)+1}if((k[a>>2]|0)<3){ca=k[j+44>>2]|0;da=k[s>>2]|0;k[da>>2]=k[ca>>2];k[da+4>>2]=k[ca+4>>2];break}k[x>>2]=0;x1(ja,k[a>>2]|0,0,0,0);if((k[x>>2]|0)>0){w=k[j+40>>2]|0;m=k[h>>2]|0;h=k[j+44>>2]|0;g=k[s>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[w+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[x>>2]|0))}}else Q1(ja,b,-1);while(0);a:do switch(f|0){case 4:{if(D|0){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(60)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=54;i[g+58>>0]=0;ba=394396;da=ca+54|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-5,ha,394218,394239,142);k[a>>2]=0;k[ha>>2]=0;ia=k[g>>2]|0;k[g>>2]=ia+-1;if((ia|0)==1)ggb(k[g+-4>>2]|0);break a}I=k[c>>2]|0;a=(k[B>>2]|0)-I>>2;g=k[y>>2]|0;switch(g>>>3&511){case 0:{x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150556;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;m=ia+96|0;k[m>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if(!(g&4088))a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;s=ia+76|0;k[s>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[s>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;s=ia+88|0;k[s>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;t=+(h|0)/+(g|0);j=~~(65025.0/t+1.0);h=k[y>>2]|0;g=k[m>>2]|0;a=h-g>>2;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(L=g+(j<<2)|0,(h|0)!=(L|0)):0)k[y>>2]=h+(~((h+-4-L|0)>>>2)<<2)}else U1(m,j-a|0);if((j|0)>0){q=+o[I>>2];q=q*q;h=k[m>>2]|0;g=0;do{l=+Z(+(-(t*+(g|0))/q));p[u>>3]=l;a=k[u+4>>2]&2147483647;n=+(k[s>>2]|0);l=n*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[h+(g<<2)>>2]=+(da|0)<n*.001?0:da;g=g+1|0}while((g|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=55}else ea=55;if((ea|0)==55){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150556;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-4-g|0)>>>2)<<2);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[ia+44>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}case 1:{if((a|0)==1){x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150536;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;m=ia+96|0;k[m>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==8)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;s=ia+76|0;k[s>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[s>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;s=ia+88|0;k[s>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;t=+(h|0)/+(g|0);j=~~(130050.0/t+1.0);h=k[y>>2]|0;g=k[m>>2]|0;a=h-g>>2;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(W=g+(j<<2)|0,(h|0)!=(W|0)):0)k[y>>2]=h+(~((h+-4-W|0)>>>2)<<2)}else U1(m,j-a|0);if((j|0)>0){q=+o[I>>2];q=q*q*2.0;h=k[m>>2]|0;g=0;do{l=+Z(+(-(t*+(g|0))/q));p[u>>3]=l;a=k[u+4>>2]&2147483647;n=+(k[s>>2]|0);l=n*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[h+(g<<2)>>2]=+(da|0)<n*.001?0:da;g=g+1|0}while((g|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=103}else ea=103;if((ea|0)==103){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150536;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-4-g|0)>>>2)<<2);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}z=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=z;k[ia>>2]=150516;z=ia+4|0;k[z>>2]=ka;b=ia+8|0;k[b>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;C=ia+16|0;a=ia+20|0;B=ia+52|0;ca=C;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[B>>2]=a;D=ia+60|0;c=ia+56|0;k[c>>2]=D;k[ia+64>>2]=0;k[D>>2]=0;y=ia+96|0;k[y>>2]=0;A=ia+100|0;k[A>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==8)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[z>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;x=ia+76|0;k[x>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[x>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;x=ia+88|0;k[x>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;v=+(h|0)/+(g|0);w=~~(130050.0/v+1.0);h=k[A>>2]|0;g=k[y>>2]|0;a=h-g>>3;if(w>>>0<=a>>>0){if(w>>>0<a>>>0?(_=g+(w<<3)|0,(h|0)!=(_|0)):0)k[A>>2]=h+(~((h+-8-_|0)>>>3)<<3)}else V1(y,w-a|0);if((w|0)>0){m=I+4|0;j=0;do{s=(k[y>>2]|0)+(j<<3)|0;n=-(v*+(j|0));q=+(k[x>>2]|0);t=q*.001;l=+o[I>>2];l=+Z(+(n/(l*l*2.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}g=~~l;h=+(g|0)<t;l=+o[m>>2];l=+Z(+(n/(l*l*2.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}ba=~~l;$=+(ba|0)<t;e=h?0:g;ca=h?0:0;da=s;k[da>>2]=e;k[da+4>>2]=($?0:ba)|ca;j=j+1|0}while((j|0)!=(w|0))}s=k[b>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=153}else ea=153;if((ea|0)==153){m=k[z>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150516;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[A>>2]|0;if((h|0)!=(a|0))k[A>>2]=h+(~((h+-8-g|0)>>>3)<<3);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[C>>2]|0)>0){g=k[B>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[C>>2]|0))}a=k[c>>2]|0;if(!((a|0)==(D|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}case 2:{if((a|0)==1){x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150496;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;m=ia+96|0;k[m>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==16)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;s=ia+76|0;k[s>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[s>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;s=ia+88|0;k[s>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;t=+(h|0)/+(g|0);j=~~(195075.0/t+1.0);h=k[y>>2]|0;g=k[m>>2]|0;a=h-g>>2;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(E=g+(j<<2)|0,(h|0)!=(E|0)):0)k[y>>2]=h+(~((h+-4-E|0)>>>2)<<2)}else U1(m,j-a|0);if((j|0)>0){q=+o[I>>2];q=q*q*3.0;h=k[m>>2]|0;g=0;do{l=+Z(+(-(t*+(g|0))/q));p[u>>3]=l;a=k[u+4>>2]&2147483647;n=+(k[s>>2]|0);l=n*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[h+(g<<2)>>2]=+(da|0)<n*.001?0:da;g=g+1|0}while((g|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=201}else ea=201;if((ea|0)==201){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150496;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-4-g|0)>>>2)<<2);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}A=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=A;k[ia>>2]=150476;A=ia+4|0;k[A>>2]=ka;z=ia+8|0;k[z>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;D=ia+16|0;a=ia+20|0;c=ia+52|0;ca=D;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[c>>2]=a;f=ia+60|0;C=ia+56|0;k[C>>2]=f;k[ia+64>>2]=0;k[f>>2]=0;b=ia+96|0;k[b>>2]=0;B=ia+100|0;k[B>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==16)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[A>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;y=ia+76|0;k[y>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[y>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;y=ia+88|0;k[y>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;v=+(h|0)/+(g|0);x=~~(195075.0/v+1.0);h=k[B>>2]|0;g=k[b>>2]|0;a=(h-g|0)/12|0;if(x>>>0<=a>>>0){if(x>>>0<a>>>0?(F=g+(x*12|0)|0,(h|0)!=(F|0)):0)k[B>>2]=h+(~(((h+-12-F|0)>>>0)/12|0)*12|0)}else W1(b,x-a|0);if((x|0)>0){m=I+4|0;s=I+8|0;j=0;do{w=k[b>>2]|0;n=-(v*+(j|0));q=+(k[y>>2]|0);t=q*.001;l=+o[I>>2];l=+Z(+(n/(l*l*3.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}h=~~l;h=+(h|0)<t?0:h;l=+o[m>>2];l=+Z(+(n/(l*l*3.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}g=~~l;g=+(g|0)<t?0:g;l=+o[s>>2];l=+Z(+(n/(l*l*3.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[w+(j*12|0)>>2]=h;k[w+(j*12|0)+4>>2]=g;k[w+(j*12|0)+8>>2]=+(da|0)<t?0:da;j=j+1|0}while((j|0)!=(x|0))}s=k[z>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=254}else ea=254;if((ea|0)==254){m=k[A>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150476;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[B>>2]|0;if((h|0)!=(a|0))k[B>>2]=h+(~(((h+-12-g|0)>>>0)/12|0)*12|0);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[D>>2]|0)>0){g=k[c>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[D>>2]|0))}a=k[C>>2]|0;if(!((a|0)==(f|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}case 3:{if((a|0)!=1){x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150436;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;s=ia+96|0;k[s>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==24)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;m=ia+76|0;k[m>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[m>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;m=ia+88|0;k[m>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;l=+(h|0)/+(g|0);j=~~(260100.0/l+1.0);h=k[y>>2]|0;g=k[s>>2]|0;a=h-g>>4;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(H=g+(j<<4)|0,(h|0)!=(H|0)):0)k[y>>2]=h+(~((h+-16-H|0)>>>4)<<4)}else X1(s,j-a|0);if((j|0)>0){a=0;do{da=(k[s>>2]|0)+(a<<4)|0;y1a(ha,l*+(a|0),I,k[m>>2]|0);k[da>>2]=k[ha>>2];k[da+4>>2]=k[ha+4>>2];k[da+8>>2]=k[ha+8>>2];k[da+12>>2]=k[ha+12>>2];a=a+1|0}while((a|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=346}else ea=346;if((ea|0)==346){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150436;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-16-g|0)>>>4)<<4);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150456;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;m=ia+96|0;k[m>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==24)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;s=ia+76|0;k[s>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[s>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;s=ia+88|0;k[s>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;t=+(h|0)/+(g|0);j=~~(260100.0/t+1.0);h=k[y>>2]|0;g=k[m>>2]|0;a=h-g>>2;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(G=g+(j<<2)|0,(h|0)!=(G|0)):0)k[y>>2]=h+(~((h+-4-G|0)>>>2)<<2)}else U1(m,j-a|0);if((j|0)>0){q=+o[I>>2];q=q*q*4.0;h=k[m>>2]|0;g=0;do{l=+Z(+(-(t*+(g|0))/q));p[u>>3]=l;a=k[u+4>>2]&2147483647;n=+(k[s>>2]|0);l=n*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[h+(g<<2)>>2]=+(da|0)<n*.001?0:da;g=g+1|0}while((g|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=302}else ea=302;if((ea|0)==302){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150456;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-4-g|0)>>>2)<<2);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}default:{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(72)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=65;i[g+69>>0]=0;ba=394308;da=ca+65|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-5,ha,394374,394239,100);k[a>>2]=0;k[ha>>2]=0;ia=k[g>>2]|0;k[g>>2]=ia+-1;if((ia|0)==1)ggb(k[g+-4>>2]|0);break a}}}case 2:switch(C&7){case 0:{E=k[c>>2]|0;a=(k[B>>2]|0)-E>>2;g=k[y>>2]|0;switch(g>>>3&511){case 0:{x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150416;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;m=ia+96|0;k[m>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if(!(g&4088))a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;s=ia+76|0;k[s>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[s>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;s=ia+88|0;k[s>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;t=+(h|0)/+(g|0);j=~~(255.0/t+1.0);h=k[y>>2]|0;g=k[m>>2]|0;a=h-g>>2;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(I=g+(j<<2)|0,(h|0)!=(I|0)):0)k[y>>2]=h+(~((h+-4-I|0)>>>2)<<2)}else U1(m,j-a|0);if((j|0)>0){q=+o[E>>2];q=q*q;h=k[m>>2]|0;g=0;do{l=t*+(g|0);l=+Z(+(-(l*l)/q));p[u>>3]=l;a=k[u+4>>2]&2147483647;n=+(k[s>>2]|0);l=n*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[h+(g<<2)>>2]=+(da|0)<n*.001?0:da;g=g+1|0}while((g|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=401}else ea=401;if((ea|0)==401){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150416;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-4-g|0)>>>2)<<2);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[ia+44>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}case 1:{if((a|0)==1){x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150396;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;m=ia+96|0;k[m>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==8)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;s=ia+76|0;k[s>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[s>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;s=ia+88|0;k[s>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;t=+(h|0)/+(g|0);j=~~(510.0/t+1.0);h=k[y>>2]|0;g=k[m>>2]|0;a=h-g>>2;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(J=g+(j<<2)|0,(h|0)!=(J|0)):0)k[y>>2]=h+(~((h+-4-J|0)>>>2)<<2)}else U1(m,j-a|0);if((j|0)>0){q=+o[E>>2];q=q*q*2.0;h=k[m>>2]|0;g=0;do{l=t*+(g|0);l=+Z(+(-(l*l)/q));p[u>>3]=l;a=k[u+4>>2]&2147483647;n=+(k[s>>2]|0);l=n*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[h+(g<<2)>>2]=+(da|0)<n*.001?0:da;g=g+1|0}while((g|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=449}else ea=449;if((ea|0)==449){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150396;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-4-g|0)>>>2)<<2);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}z=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=z;k[ia>>2]=150376;z=ia+4|0;k[z>>2]=ka;b=ia+8|0;k[b>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;C=ia+16|0;a=ia+20|0;B=ia+52|0;ca=C;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[B>>2]=a;D=ia+60|0;c=ia+56|0;k[c>>2]=D;k[ia+64>>2]=0;k[D>>2]=0;y=ia+96|0;k[y>>2]=0;A=ia+100|0;k[A>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==8)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[z>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;x=ia+76|0;k[x>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[x>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;x=ia+88|0;k[x>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;v=+(h|0)/+(g|0);w=~~(510.0/v+1.0);h=k[A>>2]|0;g=k[y>>2]|0;a=h-g>>3;if(w>>>0<=a>>>0){if(w>>>0<a>>>0?(K=g+(w<<3)|0,(h|0)!=(K|0)):0)k[A>>2]=h+(~((h+-8-K|0)>>>3)<<3)}else V1(y,w-a|0);if((w|0)>0){m=E+4|0;j=0;do{n=v*+(j|0);s=(k[y>>2]|0)+(j<<3)|0;n=-(n*n);q=+(k[x>>2]|0);t=q*.001;l=+o[E>>2];l=+Z(+(n/(l*l*2.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}g=~~l;h=+(g|0)<t;l=+o[m>>2];l=+Z(+(n/(l*l*2.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}ba=~~l;$=+(ba|0)<t;e=h?0:g;ca=h?0:0;da=s;k[da>>2]=e;k[da+4>>2]=($?0:ba)|ca;j=j+1|0}while((j|0)!=(w|0))}s=k[b>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=499}else ea=499;if((ea|0)==499){m=k[z>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150376;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[A>>2]|0;if((h|0)!=(a|0))k[A>>2]=h+(~((h+-8-g|0)>>>3)<<3);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[C>>2]|0)>0){g=k[B>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[C>>2]|0))}a=k[c>>2]|0;if(!((a|0)==(D|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}case 2:{if((a|0)==1){x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150356;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;m=ia+96|0;k[m>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==16)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;s=ia+76|0;k[s>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[s>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;s=ia+88|0;k[s>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;t=+(h|0)/+(g|0);j=~~(765.0/t+1.0);h=k[y>>2]|0;g=k[m>>2]|0;a=h-g>>2;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(M=g+(j<<2)|0,(h|0)!=(M|0)):0)k[y>>2]=h+(~((h+-4-M|0)>>>2)<<2)}else U1(m,j-a|0);if((j|0)>0){q=+o[E>>2];q=q*q*3.0;h=k[m>>2]|0;g=0;do{l=t*+(g|0);l=+Z(+(-(l*l)/q));p[u>>3]=l;a=k[u+4>>2]&2147483647;n=+(k[s>>2]|0);l=n*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[h+(g<<2)>>2]=+(da|0)<n*.001?0:da;g=g+1|0}while((g|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=547}else ea=547;if((ea|0)==547){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150356;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-4-g|0)>>>2)<<2);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}A=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=A;k[ia>>2]=150336;A=ia+4|0;k[A>>2]=ka;z=ia+8|0;k[z>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;D=ia+16|0;a=ia+20|0;c=ia+52|0;ca=D;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[c>>2]=a;f=ia+60|0;C=ia+56|0;k[C>>2]=f;k[ia+64>>2]=0;k[f>>2]=0;b=ia+96|0;k[b>>2]=0;B=ia+100|0;k[B>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==16)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[A>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;y=ia+76|0;k[y>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[y>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;y=ia+88|0;k[y>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;v=+(h|0)/+(g|0);x=~~(765.0/v+1.0);h=k[B>>2]|0;g=k[b>>2]|0;a=(h-g|0)/12|0;if(x>>>0<=a>>>0){if(x>>>0<a>>>0?(O=g+(x*12|0)|0,(h|0)!=(O|0)):0)k[B>>2]=h+(~(((h+-12-O|0)>>>0)/12|0)*12|0)}else W1(b,x-a|0);if((x|0)>0){m=E+4|0;s=E+8|0;j=0;do{n=v*+(j|0);w=k[b>>2]|0;n=-(n*n);q=+(k[y>>2]|0);t=q*.001;l=+o[E>>2];l=+Z(+(n/(l*l*3.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}h=~~l;h=+(h|0)<t?0:h;l=+o[m>>2];l=+Z(+(n/(l*l*3.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}g=~~l;g=+(g|0)<t?0:g;l=+o[s>>2];l=+Z(+(n/(l*l*3.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[w+(j*12|0)>>2]=h;k[w+(j*12|0)+4>>2]=g;k[w+(j*12|0)+8>>2]=+(da|0)<t?0:da;j=j+1|0}while((j|0)!=(x|0))}s=k[z>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=600}else ea=600;if((ea|0)==600){m=k[A>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150336;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[B>>2]|0;if((h|0)!=(a|0))k[B>>2]=h+(~(((h+-12-g|0)>>>0)/12|0)*12|0);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[D>>2]|0)>0){g=k[c>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[D>>2]|0))}a=k[C>>2]|0;if(!((a|0)==(f|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}case 3:{if((a|0)!=1){x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150296;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;s=ia+96|0;k[s>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==24)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;m=ia+76|0;k[m>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[m>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;m=ia+88|0;k[m>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;l=+(h|0)/+(g|0);j=~~(1020.0/l+1.0);h=k[y>>2]|0;g=k[s>>2]|0;a=h-g>>4;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(Q=g+(j<<4)|0,(h|0)!=(Q|0)):0)k[y>>2]=h+(~((h+-16-Q|0)>>>4)<<4)}else X1(s,j-a|0);if((j|0)>0){a=0;do{da=(k[s>>2]|0)+(a<<4)|0;j1a(ha,l*+(a|0),E,k[m>>2]|0);k[da>>2]=k[ha>>2];k[da+4>>2]=k[ha+4>>2];k[da+8>>2]=k[ha+8>>2];k[da+12>>2]=k[ha+12>>2];a=a+1|0}while((a|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=692}else ea=692;if((ea|0)==692){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150296;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-16-g|0)>>>4)<<4);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150316;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;m=ia+96|0;k[m>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==24)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;s=ia+76|0;k[s>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);a=k[s>>2]|0;a=2147483647/((aa(a*255|0,a)|0)>>>0)|0;s=ia+88|0;k[s>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;t=+(h|0)/+(g|0);j=~~(1020.0/t+1.0);h=k[y>>2]|0;g=k[m>>2]|0;a=h-g>>2;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(P=g+(j<<2)|0,(h|0)!=(P|0)):0)k[y>>2]=h+(~((h+-4-P|0)>>>2)<<2)}else U1(m,j-a|0);if((j|0)>0){q=+o[E>>2];q=q*q*4.0;h=k[m>>2]|0;g=0;do{l=t*+(g|0);l=+Z(+(-(l*l)/q));p[u>>3]=l;a=k[u+4>>2]&2147483647;n=+(k[s>>2]|0);l=n*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[h+(g<<2)>>2]=+(da|0)<n*.001?0:da;g=g+1|0}while((g|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=648}else ea=648;if((ea|0)==648){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150316;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-4-g|0)>>>2)<<2);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}default:{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(72)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=65;i[g+69>>0]=0;ba=394308;da=ca+65|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-5,ha,394374,394239,100);k[a>>2]=0;k[ha>>2]=0;ia=k[g>>2]|0;k[g>>2]=ia+-1;if((ia|0)==1)ggb(k[g+-4>>2]|0);break a}}}case 2:{E=k[c>>2]|0;a=(k[B>>2]|0)-E>>2;g=k[y>>2]|0;switch(g>>>3&511){case 0:{x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150276;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;m=ia+96|0;k[m>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if(!(g&4088))a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;s=ia+76|0;k[s>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);s=k[s>>2]|0;a=((s|0)<0)<<31>>31;a=spb(-1,2147483647,Epb(Epb(s|0,a|0,65535,0)|0,N|0,s|0,a|0)|0,N|0)|0;s=N;da=s>>>0>0|(s|0)==0&a>>>0>2147483647;s=ia+88|0;k[s>>2]=da?2147483647:a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;t=+(h|0)/+(g|0);j=~~(65535.0/t+1.0);h=k[y>>2]|0;g=k[m>>2]|0;a=h-g>>2;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(R=g+(j<<2)|0,(h|0)!=(R|0)):0)k[y>>2]=h+(~((h+-4-R|0)>>>2)<<2)}else U1(m,j-a|0);if((j|0)>0){q=+o[E>>2];q=q*q;h=k[m>>2]|0;g=0;do{l=t*+(g|0);l=+Z(+(-(l*l)/q));p[u>>3]=l;a=k[u+4>>2]&2147483647;n=+(k[s>>2]|0);l=n*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[h+(g<<2)>>2]=+(da|0)<n*.001?0:da;g=g+1|0}while((g|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=743}else ea=743;if((ea|0)==743){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150276;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-4-g|0)>>>2)<<2);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[ia+44>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}case 1:{if((a|0)==1){x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150256;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;m=ia+96|0;k[m>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==8)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;s=ia+76|0;k[s>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);s=k[s>>2]|0;a=((s|0)<0)<<31>>31;da=Epb(s|0,a|0,65535,0)|0;a=Epb(da|0,N|0,s|0,a|0)|0;a=spb(-1,2147483647,a|0,N|0)|0;s=N;da=s>>>0>0|(s|0)==0&a>>>0>2147483647;a=da?2147483647:a;s=ia+88|0;k[s>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;t=+(h|0)/+(g|0);j=~~(131070.0/t+1.0);h=k[y>>2]|0;g=k[m>>2]|0;a=h-g>>2;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(S=g+(j<<2)|0,(h|0)!=(S|0)):0)k[y>>2]=h+(~((h+-4-S|0)>>>2)<<2)}else U1(m,j-a|0);if((j|0)>0){q=+o[E>>2];q=q*q*2.0;h=k[m>>2]|0;g=0;do{l=t*+(g|0);l=+Z(+(-(l*l)/q));p[u>>3]=l;a=k[u+4>>2]&2147483647;n=+(k[s>>2]|0);l=n*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[h+(g<<2)>>2]=+(da|0)<n*.001?0:da;g=g+1|0}while((g|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=791}else ea=791;if((ea|0)==791){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150256;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-4-g|0)>>>2)<<2);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}z=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=z;k[ia>>2]=150236;z=ia+4|0;k[z>>2]=ka;b=ia+8|0;k[b>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;C=ia+16|0;a=ia+20|0;B=ia+52|0;ca=C;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[B>>2]=a;D=ia+60|0;c=ia+56|0;k[c>>2]=D;k[ia+64>>2]=0;k[D>>2]=0;y=ia+96|0;k[y>>2]=0;A=ia+100|0;k[A>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==8)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[z>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;x=ia+76|0;k[x>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);x=k[x>>2]|0;a=((x|0)<0)<<31>>31;da=Epb(x|0,a|0,65535,0)|0;a=Epb(da|0,N|0,x|0,a|0)|0;a=spb(-1,2147483647,a|0,N|0)|0;x=N;da=x>>>0>0|(x|0)==0&a>>>0>2147483647;a=da?2147483647:a;x=ia+88|0;k[x>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;v=+(h|0)/+(g|0);w=~~(131070.0/v+1.0);h=k[A>>2]|0;g=k[y>>2]|0;a=h-g>>3;if(w>>>0<=a>>>0){if(w>>>0<a>>>0?(T=g+(w<<3)|0,(h|0)!=(T|0)):0)k[A>>2]=h+(~((h+-8-T|0)>>>3)<<3)}else V1(y,w-a|0);if((w|0)>0){m=E+4|0;j=0;do{n=v*+(j|0);s=(k[y>>2]|0)+(j<<3)|0;n=-(n*n);q=+(k[x>>2]|0);t=q*.001;l=+o[E>>2];l=+Z(+(n/(l*l*2.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}g=~~l;h=+(g|0)<t;l=+o[m>>2];l=+Z(+(n/(l*l*2.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}ba=~~l;$=+(ba|0)<t;e=h?0:g;ca=h?0:0;da=s;k[da>>2]=e;k[da+4>>2]=($?0:ba)|ca;j=j+1|0}while((j|0)!=(w|0))}s=k[b>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=841}else ea=841;if((ea|0)==841){m=k[z>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150236;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[A>>2]|0;if((h|0)!=(a|0))k[A>>2]=h+(~((h+-8-g|0)>>>3)<<3);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[C>>2]|0)>0){g=k[B>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[C>>2]|0))}a=k[c>>2]|0;if(!((a|0)==(D|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}case 2:{if((a|0)==1){x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150216;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;m=ia+96|0;k[m>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==16)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;s=ia+76|0;k[s>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);s=k[s>>2]|0;a=((s|0)<0)<<31>>31;da=Epb(s|0,a|0,65535,0)|0;a=Epb(da|0,N|0,s|0,a|0)|0;a=spb(-1,2147483647,a|0,N|0)|0;s=N;da=s>>>0>0|(s|0)==0&a>>>0>2147483647;a=da?2147483647:a;s=ia+88|0;k[s>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;t=+(h|0)/+(g|0);j=~~(196605.0/t+1.0);h=k[y>>2]|0;g=k[m>>2]|0;a=h-g>>2;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(U=g+(j<<2)|0,(h|0)!=(U|0)):0)k[y>>2]=h+(~((h+-4-U|0)>>>2)<<2)}else U1(m,j-a|0);if((j|0)>0){q=+o[E>>2];q=q*q*3.0;h=k[m>>2]|0;g=0;do{l=t*+(g|0);l=+Z(+(-(l*l)/q));p[u>>3]=l;a=k[u+4>>2]&2147483647;n=+(k[s>>2]|0);l=n*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[h+(g<<2)>>2]=+(da|0)<n*.001?0:da;g=g+1|0}while((g|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=889}else ea=889;if((ea|0)==889){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150216;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-4-g|0)>>>2)<<2);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}A=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=A;k[ia>>2]=150196;A=ia+4|0;k[A>>2]=ka;z=ia+8|0;k[z>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;D=ia+16|0;a=ia+20|0;c=ia+52|0;ca=D;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[c>>2]=a;f=ia+60|0;C=ia+56|0;k[C>>2]=f;k[ia+64>>2]=0;k[f>>2]=0;b=ia+96|0;k[b>>2]=0;B=ia+100|0;k[B>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==16)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[A>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;y=ia+76|0;k[y>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);y=k[y>>2]|0;a=((y|0)<0)<<31>>31;da=Epb(y|0,a|0,65535,0)|0;a=Epb(da|0,N|0,y|0,a|0)|0;a=spb(-1,2147483647,a|0,N|0)|0;y=N;da=y>>>0>0|(y|0)==0&a>>>0>2147483647;a=da?2147483647:a;y=ia+88|0;k[y>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;v=+(h|0)/+(g|0);x=~~(196605.0/v+1.0);h=k[B>>2]|0;g=k[b>>2]|0;a=(h-g|0)/12|0;if(x>>>0<=a>>>0){if(x>>>0<a>>>0?(V=g+(x*12|0)|0,(h|0)!=(V|0)):0)k[B>>2]=h+(~(((h+-12-V|0)>>>0)/12|0)*12|0)}else W1(b,x-a|0);if((x|0)>0){m=E+4|0;s=E+8|0;j=0;do{n=v*+(j|0);w=k[b>>2]|0;n=-(n*n);q=+(k[y>>2]|0);t=q*.001;l=+o[E>>2];l=+Z(+(n/(l*l*3.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}h=~~l;h=+(h|0)<t?0:h;l=+o[m>>2];l=+Z(+(n/(l*l*3.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}g=~~l;g=+(g|0)<t?0:g;l=+o[s>>2];l=+Z(+(n/(l*l*3.0)));p[u>>3]=l;a=k[u+4>>2]&2147483647;l=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[w+(j*12|0)>>2]=h;k[w+(j*12|0)+4>>2]=g;k[w+(j*12|0)+8>>2]=+(da|0)<t?0:da;j=j+1|0}while((j|0)!=(x|0))}s=k[z>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=942}else ea=942;if((ea|0)==942){m=k[A>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150196;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[B>>2]|0;if((h|0)!=(a|0))k[B>>2]=h+(~(((h+-12-g|0)>>>0)/12|0)*12|0);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[D>>2]|0)>0){g=k[c>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[D>>2]|0))}a=k[C>>2]|0;if(!((a|0)==(f|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}case 3:{if((a|0)!=1){x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150156;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;s=ia+96|0;k[s>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==24)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;m=ia+76|0;k[m>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);m=k[m>>2]|0;a=((m|0)<0)<<31>>31;da=Epb(m|0,a|0,65535,0)|0;a=Epb(da|0,N|0,m|0,a|0)|0;a=spb(-1,2147483647,a|0,N|0)|0;m=N;da=m>>>0>0|(m|0)==0&a>>>0>2147483647;a=da?2147483647:a;m=ia+88|0;k[m>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;l=+(h|0)/+(g|0);j=~~(262140.0/l+1.0);h=k[y>>2]|0;g=k[s>>2]|0;a=h-g>>4;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(Y=g+(j<<4)|0,(h|0)!=(Y|0)):0)k[y>>2]=h+(~((h+-16-Y|0)>>>4)<<4)}else X1(s,j-a|0);if((j|0)>0){a=0;do{da=(k[s>>2]|0)+(a<<4)|0;W0a(ha,l*+(a|0),E,k[m>>2]|0);k[da>>2]=k[ha>>2];k[da+4>>2]=k[ha+4>>2];k[da+8>>2]=k[ha+8>>2];k[da+12>>2]=k[ha+12>>2];a=a+1|0}while((a|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=1034}else ea=1034;if((ea|0)==1034){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150156;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-16-g|0)>>>4)<<4);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}x=k[ka+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=x;k[ia>>2]=150176;x=ia+4|0;k[x>>2]=ka;w=ia+8|0;k[w>>2]=ja;j=ia+12|0;k[j>>2]=1124007936;A=ia+16|0;a=ia+20|0;b=ia+52|0;ca=A;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[b>>2]=a;B=ia+60|0;z=ia+56|0;k[z>>2]=B;k[ia+64>>2]=0;k[B>>2]=0;m=ia+96|0;k[m>>2]=0;y=ia+100|0;k[y>>2]=0;k[ia+104>>2]=0;if((g&4088|0)==24)a=ka;else{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(48)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=40;i[g+44>>0]=0;ba=394650;da=ca+40|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,110);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[x>>2]|0}ca=(d|0)/2|0;k[ia+80>>2]=ca;da=(e|0)/2|0;k[ia+84>>2]=da;h=ia+72|0;k[h>>2]=ca<<1|1;s=ia+76|0;k[s>>2]=da<<1|1;da=ca+da|0;k[ia+68>>2]=da;k[ha+8>>2]=0;k[ha+12>>2]=0;k[ha>>2]=16842752;k[ha+4>>2]=a;a=fa+4|0;ca=a+4|0;k[ca>>2]=0;k[ca+4>>2]=0;k[fa>>2]=33619968;k[a>>2]=j;k[$>>2]=0;k[$+4>>2]=0;k[$+8>>2]=0;k[$+12>>2]=0;k[$+16>>2]=0;k[$+20>>2]=0;k[$+24>>2]=0;k[$+28>>2]=0;vY(ha,fa,da,da,da,da,4,$);s=k[s>>2]|0;a=((s|0)<0)<<31>>31;da=Epb(s|0,a|0,65535,0)|0;a=Epb(da|0,N|0,s|0,a|0)|0;a=spb(-1,2147483647,a|0,N|0)|0;s=N;da=s>>>0>0|(s|0)==0&a>>>0>2147483647;a=da?2147483647:a;s=ia+88|0;k[s>>2]=a;a=k[h>>2]|0;if((a|0)>=46341){k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(36)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=30;i[g+34>>0]=0;ba=394809;da=ca+30|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-215,ha,394691,394719,127);k[a>>2]=0;k[ha>>2]=0;da=k[g>>2]|0;k[g>>2]=da+-1;if((da|0)==1)ggb(k[g+-4>>2]|0);a=k[h>>2]|0}g=aa(a,a)|0;a=0;while(1){h=1<<a;if((h|0)<(g|0))a=a+1|0;else break}k[ia+92>>2]=a;t=+(h|0)/+(g|0);j=~~(262140.0/t+1.0);h=k[y>>2]|0;g=k[m>>2]|0;a=h-g>>2;if(j>>>0<=a>>>0){if(j>>>0<a>>>0?(X=g+(j<<2)|0,(h|0)!=(X|0)):0)k[y>>2]=h+(~((h+-4-X|0)>>>2)<<2)}else U1(m,j-a|0);if((j|0)>0){q=+o[E>>2];q=q*q*4.0;h=k[m>>2]|0;g=0;do{l=t*+(g|0);l=+Z(+(-(l*l)/q));p[u>>3]=l;a=k[u+4>>2]&2147483647;n=+(k[s>>2]|0);l=n*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:l);p[u>>3]=l;a=k[u+4>>2]|0;da=a&2146435072;if(!(da>>>0>1126170624|(da|0)==1126170624&0>0)){a=(a|0)<0;l=a?l+-4503599627370496.0+4503599627370496.0:l+4503599627370496.0+-4503599627370496.0;if(l==0.0)l=a?-0.0:0.0}da=~~l;k[h+(g<<2)>>2]=+(da|0)<n*.001?0:da;g=g+1|0}while((g|0)!=(j|0))}s=k[w>>2]|0;if(k[s+16>>2]|0){h=k[s+4>>2]|0;if((h|0)<3)a=aa(k[s+12>>2]|0,k[s+8>>2]|0)|0;else{j=k[s+40>>2]|0;g=0;a=1;do{a=aa(k[j+(g<<2)>>2]|0,a)|0;g=g+1|0}while((g|0)!=(h|0))}if(!a)ea=990}else ea=990;if((ea|0)==990){m=k[x>>2]|0;j=k[m+40>>2]|0;h=k[j+4>>2]|0;j=k[j>>2]|0;m=k[m>>2]&4095;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=1124007936;a=fa+16|0;g=fa+48|0;ca=fa+12|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+56|0;k[fa+52>>2]=a;k[fa+60>>2]=0;k[a>>2]=0;k[fa+64>>2]=1124007936;a=fa+72|0;g=fa+104|0;ca=fa+68|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;a=fa+112|0;k[fa+108>>2]=a;k[fa+116>>2]=0;k[a>>2]=0;k[fa+120>>2]=1124007936;a=fa+128|0;g=fa+160|0;ca=fa+124|0;da=ca+36|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[g>>2]=a;ca=fa+168|0;k[fa+164>>2]=ca;da=ca+56|0;do{k[ca>>2]=0;ca=ca+4|0}while((ca|0)<(da|0));k[ha>>2]=h;k[ha+4>>2]=j;j1(fa,48,ha,m);ha=k[fa>>2]|0;dh[k[(k[ha>>2]|0)+12>>2]&255](ha,fa,s,-1);XN(fa)}jh[k[(k[ia>>2]|0)+8>>2]&1023](ia,ga);k[ia>>2]=150176;a=k[ia+96>>2]|0;g=a;if(a|0){h=k[y>>2]|0;if((h|0)!=(a|0))k[y>>2]=h+(~((h+-4-g|0)>>>2)<<2);ggb(a)}h=ia+48|0;a=k[h>>2]|0;if(a|0?(ga=a+12|0,ha=k[ga>>2]|0,k[ga>>2]=ha+-1,(ha|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ia+44>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ia+28|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[A>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[A>>2]|0))}a=k[z>>2]|0;if(!((a|0)==(B|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break a}default:{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(72)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=65;i[g+69>>0]=0;ba=394308;da=ca+65|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-5,ha,394374,394239,100);k[a>>2]=0;k[ha>>2]=0;ia=k[g>>2]|0;k[g>>2]=ia+-1;if((ia|0)==1)ggb(k[g+-4>>2]|0);break a}}}default:{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(72)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=66;i[g+70>>0]=0;ba=394451;da=ca+66|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-5,ha,394218,394239,159);k[a>>2]=0;k[ha>>2]=0;ia=k[g>>2]|0;k[g>>2]=ia+-1;if((ia|0)==1)ggb(k[g+-4>>2]|0);break a}}default:{k[ha>>2]=0;a=ha+4|0;k[a>>2]=0;g=ZT(68)|0;k[g>>2]=1;ca=g+4|0;k[ha>>2]=ca;k[a>>2]=61;i[g+65>>0]=0;ba=394518;da=ca+61|0;do{i[ca>>0]=i[ba>>0]|0;ca=ca+1|0;ba=ba+1|0}while((ca|0)<(da|0));Y8(-5,ha,394218,394239,164);k[a>>2]=0;k[ha>>2]=0;ia=k[g>>2]|0;k[g>>2]=ia+-1;if((ia|0)==1)ggb(k[g+-4>>2]|0)}}while(0);h=ja+36|0;a=k[h>>2]|0;if(a|0?(ha=a+12|0,ia=k[ha>>2]|0,k[ha>>2]=ia+-1,(ia|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[ja+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ia=ja+16|0;g=ja+4|0;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=0;k[ia+12>>2]=0;if((k[g>>2]|0)>0){h=k[ja+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[ja+44>>2]|0;if(!((a|0)==(ja+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=ka+36|0;a=k[h>>2]|0;if(a|0?(ia=a+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[ka+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;ja=ka+16|0;g=ka+4|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[g>>2]|0)>0){h=k[ka+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[ka+44>>2]|0;if((a|0)==(ka+48|0)|(a|0)==0){r=la;return}ggb(k[a+-4>>2]|0);r=la;return}function z0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150556;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function A0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150536;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function B0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150516;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function C0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150496;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function D0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150476;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~(((e+-12-c|0)>>>0)/12|0)*12|0);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function E0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150456;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function F0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150436;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function G0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150416;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function H0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150396;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function I0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150376;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function J0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150356;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function K0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150336;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~(((e+-12-c|0)>>>0)/12|0)*12|0);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function L0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150316;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function M0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150296;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function N0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150276;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function O0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150256;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function P0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150236;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function Q0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150216;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function R0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150196;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~(((e+-12-c|0)>>>0)/12|0)*12|0);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function S0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150176;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function T0a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150156;b=k[a+96>>2]|0;c=b;if(b|0){d=a+100|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);ggb(b)}d=a+48|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+44>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+28|0;c=a+16|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+52>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+56>>2]|0;if((b|0)==(a+60|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function U0a(a){a=a|0;T0a(a);ggb(a);return}function V0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;$=k[b>>2]|0;Y=k[b+4>>2]|0;Z=a+76|0;_=k[Z>>2]|0;c=aa(_,_)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}X=a+72|0;d=aa(aa(_,k[X>>2]|0)|0,_)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}W=a+4|0;f=k[W>>2]|0;e=aa(aa(_,k[f+12>>2]|0)|0,_)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if(($|0)<(Y|0)){P=a+84|0;Q=a+68|0;R=a+28|0;S=a+56|0;T=a+92|0;U=a+96|0;V=a+8|0;O=a+80|0;a=-1;M=$;e=f;do{if((k[e+12>>2]|0)>0){L=(M|0)==($|0);K=0;do{f=k[P>>2]|0;I=M-f|0;J=K-f|0;if(!K){e=k[Z>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+M|0;s=aa(_,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[X>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(_,a)|0,_)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[X>>2]|0}while((a|0)<(e|0))}o=k[P>>2]|0;n=r-o|0;o=q-o|0;f=k[O>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=a+M|0;h=n+a|0;i=k[R>>2]|0;l=k[S>>2]|0;while(1){E=k[Q>>2]|0;D=E+f|0;H=o+f+E|0;G=k[l>>2]|0;C=i+(aa(G,g+E|0)|0)|0;E=i+(aa(G,h+E|0)|0)|0;G=(m[C+(D<<3)>>1]|0)-(m[E+(H<<3)>>1]|0)|0;F=(m[C+(D<<3)+2>>1]|0)-(m[E+(H<<3)+2>>1]|0)|0;e=(m[C+(D<<3)+4>>1]|0)-(m[E+(H<<3)+4>>1]|0)|0;H=(m[C+(D<<3)+6>>1]|0)-(m[E+(H<<3)+6>>1]|0)|0;H=((F|0)>-1?F:0-F|0)+((G|0)>-1?G:0-G|0)+((e|0)>-1?e:0-e|0)+((H|0)>-1?H:0-H|0)|0;k[p>>2]=H+(k[p>>2]|0);e=c+((aa(aa(_,(k[O>>2]|0)+f|0)|0,_)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+H;e=k[O>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[X>>2]|0}e=c+((aa(aa(_,e+-1|0)|0,_)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[Z>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;H=57}else{a=0;w=0;v=0;u=0;t=0;s=0;r=0;q=0;p=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}else{e=k[Q>>2]|0;if(L){z=e+$|0;x=e+K+(k[O>>2]|0)|0;y=z-f|0;e=k[Z>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(_,a)|0,_)|0)<<2)|0;w=d+((aa(aa(_,K)|0,_)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(_,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{l=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=u+o|0;H=k[O>>2]|0;e=0-H|0;if((H|0)<(e|0))e=0;else{h=k[R>>2]|0;i=k[S>>2]|0;f=e;e=0;while(1){H=k[i>>2]|0;D=h+(aa(H,f+z|0)|0)|0;H=h+(aa(H,p+f|0)|0)|0;F=(m[D+(x<<3)>>1]|0)-(m[H+(g<<3)>>1]|0)|0;E=(m[D+(x<<3)+2>>1]|0)-(m[H+(g<<3)+2>>1]|0)|0;G=(m[D+(x<<3)+4>>1]|0)-(m[H+(g<<3)+4>>1]|0)|0;H=(m[D+(x<<3)+6>>1]|0)-(m[H+(g<<3)+6>>1]|0)|0;e=((E|0)>-1?E:0-E|0)+((F|0)>-1?F:0-F|0)+((G|0)>-1?G:0-G|0)+((H|0)>-1?H:0-H|0)+e|0;k[l>>2]=e;if((f|0)<(k[O>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[Z>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{H=e+M|0;y=e+K|0;i=k[O>>2]|0;h=y+i|0;F=H-f|0;y=y-f+i|0;z=k[R>>2]|0;A=k[S>>2]|0;l=k[A>>2]|0;g=z+(aa(l,H+~i|0)|0)|0;f=z+(aa(l,H+i|0)|0)|0;e=k[Z>>2]|0;if((e|0)>0){B=F+-1|0;C=m[f+(h<<3)>>1]|0;D=m[f+(h<<3)+2>>1]|0;E=m[f+(h<<3)+4>>1]|0;u=m[f+(h<<3)+6>>1]|0;v=m[g+(h<<3)>>1]|0;w=m[g+(h<<3)+2>>1]|0;x=m[g+(h<<3)+4>>1]|0;r=m[g+(h<<3)+6>>1]|0;s=c+((aa(aa(_,a)|0,_)|0)<<2)|0;t=d+((aa(aa(_,K)|0,_)|0)<<2)|0;f=0;while(1){p=aa(_,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=z+(aa(l,B+f-i|0)|0)|0;h=z+(aa(l,f+F+i|0)|0)|0;g=0;do{G=o+(g<<2)|0;l=n+(g<<2)|0;k[l>>2]=(k[l>>2]|0)-(k[G>>2]|0);ea=y+g|0;H=p+(g<<2)|0;da=C-(m[h+(ea<<3)>>1]|0)|0;ca=D-(m[h+(ea<<3)+2>>1]|0)|0;ba=E-(m[h+(ea<<3)+4>>1]|0)|0;i=u-(m[h+(ea<<3)+6>>1]|0)|0;ha=v-(m[q+(ea<<3)>>1]|0)|0;ga=w-(m[q+(ea<<3)+2>>1]|0)|0;fa=x-(m[q+(ea<<3)+4>>1]|0)|0;ea=r-(m[q+(ea<<3)+6>>1]|0)|0;i=(k[H>>2]|0)-((ha|0)>-1?ha:0-ha|0)-((ga|0)>-1?ga:0-ga|0)-((fa|0)>-1?fa:0-fa|0)-((ea|0)>-1?ea:0-ea|0)+((da|0)>-1?da:0-da|0)+((ca|0)>-1?ca:0-ca|0)+((ba|0)>-1?ba:0-ba|0)+((i|0)>-1?i:0-i|0)|0;k[G>>2]=i;k[l>>2]=i+(k[l>>2]|0);k[H>>2]=k[G>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;i=k[O>>2]|0;l=k[A>>2]|0}e=k[Z>>2]|0}}a=(a+1|0)%(k[X>>2]|0)|0;H=57}if((H|0)==57){H=0;if((e|0)>0){C=k[Q>>2]|0;D=k[R>>2]|0;E=k[k[S>>2]>>2]|0;A=k[T>>2]|0;B=k[U>>2]|0;z=0;h=0;g=0;o=0;n=0;s=0;r=0;w=0;v=0;f=0;x=0;l=0;i=0;q=0;p=0;u=0;t=0;do{F=D+(aa(E,I+z+C|0)|0)|0;G=b+((aa(_,z)|0)<<2)|0;y=0;do{ga=k[G+(y<<2)>>2]>>A;ia=k[B+(ga<<4)>>2]|0;ca=k[B+(ga<<4)+4>>2]|0;ea=k[B+(ga<<4)+8>>2]|0;ga=k[B+(ga<<4)+12>>2]|0;da=J+y+C|0;fa=j[F+(da<<3)+2>>1]|0;ha=j[F+(da<<3)+4>>1]|0;ja=j[F+(da<<3)+6>>1]|0;ba=((ia|0)<0)<<31>>31;da=Epb(m[F+(da<<3)>>1]|0|0,0,ia|0,ba|0)|0;u=kpb(u|0,t|0,da|0,N|0)|0;t=N;da=((ca|0)<0)<<31>>31;fa=Epb(fa&65535|0,0,ca|0,da|0)|0;q=kpb(q|0,p|0,fa|0,N|0)|0;p=N;fa=((ea|0)<0)<<31>>31;ha=Epb(ha&65535|0,0,ea|0,fa|0)|0;l=kpb(l|0,i|0,ha|0,N|0)|0;i=N;ha=((ga|0)<0)<<31>>31;ja=Epb(ja&65535|0,0,ga|0,ha|0)|0;f=kpb(f|0,x|0,ja|0,N|0)|0;x=N;w=kpb(w|0,v|0,ia|0,ba|0)|0;v=N;s=kpb(s|0,r|0,ca|0,da|0)|0;r=N;o=kpb(o|0,n|0,ea|0,fa|0)|0;n=N;h=kpb(h|0,g|0,ga|0,ha|0)|0;g=N;y=y+1|0}while((y|0)!=(e|0));z=z+1|0}while((z|0)!=(e|0));e=x}else{w=0;v=0;u=0;t=0;s=0;r=0;q=0;p=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}ea=Bpb(w|0,v|0,2,0)|0;ea=kpb(ea|0,N|0,u|0,t|0)|0;ea=spb(ea|0,N|0,w|0,v|0)|0;da=N;ha=Bpb(s|0,r|0,2,0)|0;ha=kpb(ha|0,N|0,q|0,p|0)|0;ha=spb(ha|0,N|0,s|0,r|0)|0;ca=N;ja=Bpb(o|0,n|0,2,0)|0;ja=kpb(ja|0,N|0,l|0,i|0)|0;ja=spb(ja|0,N|0,o|0,n|0)|0;ia=N;fa=Bpb(h|0,g|0,2,0)|0;fa=kpb(fa|0,N|0,f|0,e|0)|0;fa=spb(fa|0,N|0,h|0,g|0)|0;ga=N;e=k[V>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,M)|0)+(K<<3)|0;fa=Apb((ga>>>0<0|(ga|0)==0&fa>>>0<65536?fa&65535:((ga|0)>0|(ga|0)==0&fa>>>0>0)<<31>>31)&65535|0,0,48)|0;ga=N;ha=Apb((ca>>>0<0|(ca|0)==0&ha>>>0<65536?ha&65535:((ca|0)>0|(ca|0)==0&ha>>>0>0)<<31>>31)&65535|0,0,16)|0;ha=(da>>>0<0|(da|0)==0&ea>>>0<65536?ea&65535:((da|0)>0|(da|0)==0&ea>>>0>0)<<31>>31)&65535|fa|ha;ja=ga|N|(ia>>>0<0|(ia|0)==0&ja>>>0<65536?ja&65535:((ia|0)>0|(ia|0)==0&ja>>>0>0)<<31>>31)&65535;ia=e;j[ia>>1]=ha;j[ia+2>>1]=ha>>>16;e=e+4|0;j[e>>1]=ja;j[e+2>>1]=ja>>>16;K=K+1|0;e=k[W>>2]|0}while((K|0)<(k[e+12>>2]|0))}M=M+1|0}while((M|0)!=(Y|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function W0a(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0.0,f=0.0,g=0.0,h=0;f=-(b*b);e=+(d|0);g=e*.001;b=+o[c>>2];b=+Z(+(f/(b*b*4.0)));p[u>>3]=b;d=k[u+4>>2]&2147483647;b=e*(d>>>0>2146435072|(d|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:b);p[u>>3]=b;d=k[u+4>>2]|0;h=d&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(b==0.0)b=d?-0.0:0.0}d=~~b;k[a>>2]=+(d|0)<g?0:d;b=+o[c+4>>2];b=+Z(+(f/(b*b*4.0)));p[u>>3]=b;d=k[u+4>>2]&2147483647;b=e*(d>>>0>2146435072|(d|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:b);p[u>>3]=b;d=k[u+4>>2]|0;h=d&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(b==0.0)b=d?-0.0:0.0}d=~~b;k[a+4>>2]=+(d|0)<g?0:d;b=+o[c+8>>2];b=+Z(+(f/(b*b*4.0)));p[u>>3]=b;d=k[u+4>>2]&2147483647;b=e*(d>>>0>2146435072|(d|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:b);p[u>>3]=b;d=k[u+4>>2]|0;h=d&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(b==0.0)b=d?-0.0:0.0}d=~~b;k[a+8>>2]=+(d|0)<g?0:d;b=+o[c+12>>2];b=+Z(+(f/(b*b*4.0)));p[u>>3]=b;d=k[u+4>>2]&2147483647;b=e*(d>>>0>2146435072|(d|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:b);p[u>>3]=b;d=k[u+4>>2]|0;h=d&2146435072;if(h>>>0>1126170624|(h|0)==1126170624&0>0){f=b;c=~~f;f=+(c|0);h=f<g;c=h?0:c;h=a+12|0;k[h>>2]=c;return}d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(!(b==0.0)){f=b;c=~~f;f=+(c|0);h=f<g;c=h?0:c;h=a+12|0;k[h>>2]=c;return}f=d?-0.0:0.0;c=~~f;f=+(c|0);h=f<g;c=h?0:c;h=a+12|0;k[h>>2]=c;return}function X0a(a){a=a|0;S0a(a);ggb(a);return}function Y0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;Z=k[b>>2]|0;W=k[b+4>>2]|0;X=a+76|0;Y=k[X>>2]|0;c=aa(Y,Y)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}V=a+72|0;d=aa(aa(Y,k[V>>2]|0)|0,Y)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}U=a+4|0;f=k[U>>2]|0;e=aa(aa(Y,k[f+12>>2]|0)|0,Y)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Z|0)<(W|0)){M=a+84|0;O=a+68|0;P=a+28|0;Q=a+56|0;R=a+92|0;S=a+96|0;T=a+8|0;L=a+80|0;a=-1;K=Z;e=f;do{if((k[e+12>>2]|0)>0){J=(K|0)==(Z|0);I=0;do{f=k[M>>2]|0;G=K-f|0;H=I-f|0;if(!I){e=k[X>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+K|0;s=aa(Y,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[V>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(Y,a)|0,Y)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[V>>2]|0}while((a|0)<(e|0))}o=k[M>>2]|0;n=r-o|0;o=q-o|0;f=k[L>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=a+K|0;h=n+a|0;i=k[P>>2]|0;l=k[Q>>2]|0;while(1){C=k[O>>2]|0;B=C+f|0;F=o+f+C|0;E=k[l>>2]|0;A=i+(aa(E,g+C|0)|0)|0;C=i+(aa(E,h+C|0)|0)|0;E=(m[A+(B<<3)>>1]|0)-(m[C+(F<<3)>>1]|0)|0;D=(m[A+(B<<3)+2>>1]|0)-(m[C+(F<<3)+2>>1]|0)|0;e=(m[A+(B<<3)+4>>1]|0)-(m[C+(F<<3)+4>>1]|0)|0;F=(m[A+(B<<3)+6>>1]|0)-(m[C+(F<<3)+6>>1]|0)|0;F=((D|0)>-1?D:0-D|0)+((E|0)>-1?E:0-E|0)+((e|0)>-1?e:0-e|0)+((F|0)>-1?F:0-F|0)|0;k[p>>2]=F+(k[p>>2]|0);e=c+((aa(aa(Y,(k[L>>2]|0)+f|0)|0,Y)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+F;e=k[L>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[V>>2]|0}e=c+((aa(aa(Y,e+-1|0)|0,Y)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[X>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;B=57}else{a=0;q=0;p=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}else{e=k[O>>2]|0;if(J){z=e+Z|0;x=e+I+(k[L>>2]|0)|0;y=z-f|0;e=k[X>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(Y,a)|0,Y)|0)<<2)|0;w=d+((aa(aa(Y,I)|0,Y)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(Y,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{l=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=u+o|0;F=k[L>>2]|0;e=0-F|0;if((F|0)<(e|0))e=0;else{h=k[P>>2]|0;i=k[Q>>2]|0;f=e;e=0;while(1){F=k[i>>2]|0;B=h+(aa(F,f+z|0)|0)|0;F=h+(aa(F,p+f|0)|0)|0;D=(m[B+(x<<3)>>1]|0)-(m[F+(g<<3)>>1]|0)|0;C=(m[B+(x<<3)+2>>1]|0)-(m[F+(g<<3)+2>>1]|0)|0;E=(m[B+(x<<3)+4>>1]|0)-(m[F+(g<<3)+4>>1]|0)|0;F=(m[B+(x<<3)+6>>1]|0)-(m[F+(g<<3)+6>>1]|0)|0;e=((C|0)>-1?C:0-C|0)+((D|0)>-1?D:0-D|0)+((E|0)>-1?E:0-E|0)+((F|0)>-1?F:0-F|0)+e|0;k[l>>2]=e;if((f|0)<(k[L>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[X>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{E=e+K|0;y=e+I|0;i=k[L>>2]|0;h=y+i|0;F=E-f|0;y=y-f+i|0;z=k[P>>2]|0;A=k[Q>>2]|0;l=k[A>>2]|0;g=z+(aa(l,E+~i|0)|0)|0;f=z+(aa(l,E+i|0)|0)|0;e=k[X>>2]|0;if((e|0)>0){B=F+-1|0;C=m[f+(h<<3)>>1]|0;D=m[f+(h<<3)+2>>1]|0;E=m[f+(h<<3)+4>>1]|0;u=m[f+(h<<3)+6>>1]|0;v=m[g+(h<<3)>>1]|0;w=m[g+(h<<3)+2>>1]|0;x=m[g+(h<<3)+4>>1]|0;r=m[g+(h<<3)+6>>1]|0;s=c+((aa(aa(Y,a)|0,Y)|0)<<2)|0;t=d+((aa(aa(Y,I)|0,Y)|0)<<2)|0;f=0;while(1){p=aa(Y,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=z+(aa(l,B+f-i|0)|0)|0;h=z+(aa(l,f+F+i|0)|0)|0;g=0;do{i=o+(g<<2)|0;_=n+(g<<2)|0;k[_>>2]=(k[_>>2]|0)-(k[i>>2]|0);ea=y+g|0;l=p+(g<<2)|0;da=C-(m[h+(ea<<3)>>1]|0)|0;ca=D-(m[h+(ea<<3)+2>>1]|0)|0;ba=E-(m[h+(ea<<3)+4>>1]|0)|0;$=u-(m[h+(ea<<3)+6>>1]|0)|0;ha=v-(m[q+(ea<<3)>>1]|0)|0;ga=w-(m[q+(ea<<3)+2>>1]|0)|0;fa=x-(m[q+(ea<<3)+4>>1]|0)|0;ea=r-(m[q+(ea<<3)+6>>1]|0)|0;$=(k[l>>2]|0)-((ha|0)>-1?ha:0-ha|0)-((ga|0)>-1?ga:0-ga|0)-((fa|0)>-1?fa:0-fa|0)-((ea|0)>-1?ea:0-ea|0)+((da|0)>-1?da:0-da|0)+((ca|0)>-1?ca:0-ca|0)+((ba|0)>-1?ba:0-ba|0)+(($|0)>-1?$:0-$|0)|0;k[i>>2]=$;k[_>>2]=$+(k[_>>2]|0);k[l>>2]=k[i>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;i=k[L>>2]|0;l=k[A>>2]|0}e=k[X>>2]|0}}a=(a+1|0)%(k[V>>2]|0)|0;B=57}if((B|0)==57){B=0;if((e|0)>0){w=k[O>>2]|0;x=k[P>>2]|0;y=k[k[Q>>2]>>2]|0;u=k[R>>2]|0;v=k[S>>2]|0;t=0;f=0;r=0;h=0;g=0;l=0;i=0;o=0;n=0;q=0;p=0;do{z=x+(aa(y,G+t+w|0)|0)|0;A=b+((aa(Y,t)|0)<<2)|0;s=0;do{ga=k[v+(k[A+(s<<2)>>2]>>u<<2)>>2]|0;ca=H+s+w|0;da=j[z+(ca<<3)+2>>1]|0;ea=j[z+(ca<<3)+4>>1]|0;fa=j[z+(ca<<3)+6>>1]|0;ha=((ga|0)<0)<<31>>31;ca=Epb(m[z+(ca<<3)>>1]|0|0,0,ga|0,ha|0)|0;o=kpb(o|0,n|0,ca|0,N|0)|0;n=N;da=Epb(da&65535|0,0,ga|0,ha|0)|0;l=kpb(l|0,i|0,da|0,N|0)|0;i=N;ea=Epb(ea&65535|0,0,ga|0,ha|0)|0;h=kpb(h|0,g|0,ea|0,N|0)|0;g=N;fa=Epb(fa&65535|0,0,ga|0,ha|0)|0;f=kpb(f|0,r|0,fa|0,N|0)|0;r=N;q=kpb(ga|0,ha|0,q|0,p|0)|0;p=N;s=s+1|0}while((s|0)!=(e|0));t=t+1|0}while((t|0)!=(e|0));e=r}else{q=0;p=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}ea=Bpb(q|0,p|0,2,0)|0;da=N;ca=kpb(o|0,n|0,ea|0,da|0)|0;ca=spb(ca|0,N|0,q|0,p|0)|0;ba=N;fa=kpb(l|0,i|0,ea|0,da|0)|0;fa=spb(fa|0,N|0,q|0,p|0)|0;$=N;ha=kpb(h|0,g|0,ea|0,da|0)|0;ha=spb(ha|0,N|0,q|0,p|0)|0;ga=N;da=kpb(f|0,e|0,ea|0,da|0)|0;da=spb(da|0,N|0,q|0,p|0)|0;ea=N;e=k[T>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,K)|0)+(I<<3)|0;da=Apb((ea>>>0<0|(ea|0)==0&da>>>0<65536?da&65535:((ea|0)>0|(ea|0)==0&da>>>0>0)<<31>>31)&65535|0,0,48)|0;ea=N;fa=Apb(($>>>0<0|($|0)==0&fa>>>0<65536?fa&65535:(($|0)>0|($|0)==0&fa>>>0>0)<<31>>31)&65535|0,0,16)|0;fa=(ba>>>0<0|(ba|0)==0&ca>>>0<65536?ca&65535:((ba|0)>0|(ba|0)==0&ca>>>0>0)<<31>>31)&65535|da|fa;ha=ea|N|(ga>>>0<0|(ga|0)==0&ha>>>0<65536?ha&65535:((ga|0)>0|(ga|0)==0&ha>>>0>0)<<31>>31)&65535;ga=e;j[ga>>1]=fa;j[ga+2>>1]=fa>>>16;e=e+4|0;j[e>>1]=ha;j[e+2>>1]=ha>>>16;I=I+1|0;e=k[U>>2]|0}while((I|0)<(k[e+12>>2]|0))}K=K+1|0}while((K|0)!=(W|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function Z0a(a){a=a|0;R0a(a);ggb(a);return}function _0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0;X=k[b>>2]|0;U=k[b+4>>2]|0;V=a+76|0;W=k[V>>2]|0;c=aa(W,W)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}T=a+72|0;d=aa(aa(W,k[T>>2]|0)|0,W)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}S=a+4|0;f=k[S>>2]|0;e=aa(aa(W,k[f+12>>2]|0)|0,W)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((X|0)<(U|0)){K=a+84|0;L=a+68|0;M=a+28|0;O=a+56|0;P=a+92|0;Q=a+96|0;R=a+8|0;J=a+80|0;a=-1;I=X;e=f;do{if((k[e+12>>2]|0)>0){H=(I|0)==(X|0);G=0;do{f=k[K>>2]|0;E=I-f|0;F=G-f|0;if(!G){e=k[V>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+I|0;s=aa(W,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[T>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(W,a)|0,W)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[T>>2]|0}while((a|0)<(e|0))}o=k[K>>2]|0;n=r-o|0;o=q-o|0;f=k[J>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=a+I|0;h=n+a|0;i=k[M>>2]|0;l=k[O>>2]|0;while(1){B=k[L>>2]|0;A=B+f|0;D=o+f+B|0;e=k[l>>2]|0;z=i+(aa(e,g+B|0)|0)|0;B=i+(aa(e,h+B|0)|0)|0;e=(m[z+(A*6|0)>>1]|0)-(m[B+(D*6|0)>>1]|0)|0;C=(m[z+(A*6|0)+2>>1]|0)-(m[B+(D*6|0)+2>>1]|0)|0;D=(m[z+(A*6|0)+4>>1]|0)-(m[B+(D*6|0)+4>>1]|0)|0;D=((C|0)>-1?C:0-C|0)+((e|0)>-1?e:0-e|0)+((D|0)>-1?D:0-D|0)|0;k[p>>2]=D+(k[p>>2]|0);e=c+((aa(aa(W,(k[J>>2]|0)+f|0)|0,W)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+D;e=k[J>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[T>>2]|0}e=c+((aa(aa(W,e+-1|0)|0,W)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[V>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;D=57}else{a=0;s=0;r=0;q=0;p=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}else{e=k[L>>2]|0;if(H){z=e+X|0;x=e+G+(k[J>>2]|0)|0;y=z-f|0;e=k[V>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(W,a)|0,W)|0)<<2)|0;w=d+((aa(aa(W,G)|0,W)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(W,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{l=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=u+o|0;D=k[J>>2]|0;e=0-D|0;if((D|0)<(e|0))e=0;else{h=k[M>>2]|0;i=k[O>>2]|0;f=e;e=0;while(1){D=k[i>>2]|0;A=h+(aa(D,f+z|0)|0)|0;D=h+(aa(D,p+f|0)|0)|0;C=(m[A+(x*6|0)>>1]|0)-(m[D+(g*6|0)>>1]|0)|0;B=(m[A+(x*6|0)+2>>1]|0)-(m[D+(g*6|0)+2>>1]|0)|0;D=(m[A+(x*6|0)+4>>1]|0)-(m[D+(g*6|0)+4>>1]|0)|0;e=((B|0)>-1?B:0-B|0)+((C|0)>-1?C:0-C|0)+((D|0)>-1?D:0-D|0)+e|0;k[l>>2]=e;if((f|0)<(k[J>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[V>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{C=e+I|0;x=e+G|0;i=k[J>>2]|0;h=x+i|0;D=C-f|0;x=x-f+i|0;y=k[M>>2]|0;z=k[O>>2]|0;l=k[z>>2]|0;g=y+(aa(l,C+~i|0)|0)|0;f=y+(aa(l,C+i|0)|0)|0;e=k[V>>2]|0;if((e|0)>0){A=D+-1|0;B=m[f+(h*6|0)>>1]|0;C=m[f+(h*6|0)+2>>1]|0;u=m[f+(h*6|0)+4>>1]|0;v=m[g+(h*6|0)>>1]|0;w=m[g+(h*6|0)+2>>1]|0;r=m[g+(h*6|0)+4>>1]|0;s=c+((aa(aa(W,a)|0,W)|0)<<2)|0;t=d+((aa(aa(W,G)|0,W)|0)<<2)|0;f=0;while(1){p=aa(W,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=y+(aa(l,A+f-i|0)|0)|0;h=y+(aa(l,f+D+i|0)|0)|0;g=0;do{i=o+(g<<2)|0;Y=n+(g<<2)|0;k[Y>>2]=(k[Y>>2]|0)-(k[i>>2]|0);ba=x+g|0;l=p+(g<<2)|0;$=B-(m[h+(ba*6|0)>>1]|0)|0;_=C-(m[h+(ba*6|0)+2>>1]|0)|0;Z=u-(m[h+(ba*6|0)+4>>1]|0)|0;da=v-(m[q+(ba*6|0)>>1]|0)|0;ca=w-(m[q+(ba*6|0)+2>>1]|0)|0;ba=r-(m[q+(ba*6|0)+4>>1]|0)|0;Z=(k[l>>2]|0)-((da|0)>-1?da:0-da|0)-((ca|0)>-1?ca:0-ca|0)-((ba|0)>-1?ba:0-ba|0)+(($|0)>-1?$:0-$|0)+((_|0)>-1?_:0-_|0)+((Z|0)>-1?Z:0-Z|0)|0;k[i>>2]=Z;k[Y>>2]=Z+(k[Y>>2]|0);k[l>>2]=k[i>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;i=k[J>>2]|0;l=k[z>>2]|0}e=k[V>>2]|0}}a=(a+1|0)%(k[T>>2]|0)|0;D=57}if((D|0)==57){D=0;if((e|0)>0){y=k[L>>2]|0;z=k[M>>2]|0;A=k[k[O>>2]>>2]|0;w=k[P>>2]|0;x=k[Q>>2]|0;v=0;h=0;g=0;o=0;n=0;s=0;r=0;f=0;t=0;l=0;i=0;q=0;p=0;do{B=z+(aa(A,E+v+y|0)|0)|0;C=b+((aa(W,v)|0)<<2)|0;u=0;do{ca=k[C+(u<<2)>>2]>>w;Z=k[x+(ca*12|0)>>2]|0;$=k[x+(ca*12|0)+4>>2]|0;ca=k[x+(ca*12|0)+8>>2]|0;ba=F+u+y|0;da=j[B+(ba*6|0)+2>>1]|0;Y=j[B+(ba*6|0)+4>>1]|0;_=((Z|0)<0)<<31>>31;ba=Epb(m[B+(ba*6|0)>>1]|0|0,0,Z|0,_|0)|0;q=kpb(q|0,p|0,ba|0,N|0)|0;p=N;ba=(($|0)<0)<<31>>31;da=Epb(da&65535|0,0,$|0,ba|0)|0;l=kpb(l|0,i|0,da|0,N|0)|0;i=N;da=((ca|0)<0)<<31>>31;Y=Epb(Y&65535|0,0,ca|0,da|0)|0;f=kpb(f|0,t|0,Y|0,N|0)|0;t=N;s=kpb(s|0,r|0,Z|0,_|0)|0;r=N;o=kpb(o|0,n|0,$|0,ba|0)|0;n=N;h=kpb(h|0,g|0,ca|0,da|0)|0;g=N;u=u+1|0}while((u|0)!=(e|0));v=v+1|0}while((v|0)!=(e|0));e=t}else{s=0;r=0;q=0;p=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}_=Bpb(s|0,r|0,2,0)|0;_=kpb(_|0,N|0,q|0,p|0)|0;_=spb(_|0,N|0,s|0,r|0)|0;Z=N;ba=Bpb(o|0,n|0,2,0)|0;ba=kpb(ba|0,N|0,l|0,i|0)|0;ba=spb(ba|0,N|0,o|0,n|0)|0;$=N;da=Bpb(h|0,g|0,2,0)|0;da=kpb(da|0,N|0,f|0,e|0)|0;da=spb(da|0,N|0,h|0,g|0)|0;ca=N;e=k[R>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,I)|0)|0;j[e+(G*6|0)>>1]=Z>>>0<0|(Z|0)==0&_>>>0<65536?_&65535:((Z|0)>0|(Z|0)==0&_>>>0>0)<<31>>31;j[e+(G*6|0)+2>>1]=$>>>0<0|($|0)==0&ba>>>0<65536?ba&65535:(($|0)>0|($|0)==0&ba>>>0>0)<<31>>31;j[e+(G*6|0)+4>>1]=ca>>>0<0|(ca|0)==0&da>>>0<65536?da&65535:((ca|0)>0|(ca|0)==0&da>>>0>0)<<31>>31;G=G+1|0;e=k[S>>2]|0}while((G|0)<(k[e+12>>2]|0))}I=I+1|0}while((I|0)!=(U|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function $0a(a){a=a|0;Q0a(a);ggb(a);return}function a1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0;X=k[b>>2]|0;U=k[b+4>>2]|0;V=a+76|0;W=k[V>>2]|0;c=aa(W,W)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}T=a+72|0;d=aa(aa(W,k[T>>2]|0)|0,W)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}S=a+4|0;f=k[S>>2]|0;e=aa(aa(W,k[f+12>>2]|0)|0,W)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((X|0)<(U|0)){K=a+84|0;L=a+68|0;M=a+28|0;O=a+56|0;P=a+92|0;Q=a+96|0;R=a+8|0;J=a+80|0;a=-1;I=X;e=f;do{if((k[e+12>>2]|0)>0){H=(I|0)==(X|0);G=0;do{f=k[K>>2]|0;E=I-f|0;F=G-f|0;if(!G){e=k[V>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+I|0;s=aa(W,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[T>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(W,a)|0,W)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[T>>2]|0}while((a|0)<(e|0))}o=k[K>>2]|0;n=r-o|0;o=q-o|0;f=k[J>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=a+I|0;h=n+a|0;i=k[M>>2]|0;l=k[O>>2]|0;while(1){B=k[L>>2]|0;A=B+f|0;D=o+f+B|0;e=k[l>>2]|0;z=i+(aa(e,g+B|0)|0)|0;B=i+(aa(e,h+B|0)|0)|0;e=(m[z+(A*6|0)>>1]|0)-(m[B+(D*6|0)>>1]|0)|0;C=(m[z+(A*6|0)+2>>1]|0)-(m[B+(D*6|0)+2>>1]|0)|0;D=(m[z+(A*6|0)+4>>1]|0)-(m[B+(D*6|0)+4>>1]|0)|0;D=((C|0)>-1?C:0-C|0)+((e|0)>-1?e:0-e|0)+((D|0)>-1?D:0-D|0)|0;k[p>>2]=D+(k[p>>2]|0);e=c+((aa(aa(W,(k[J>>2]|0)+f|0)|0,W)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+D;e=k[J>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[T>>2]|0}e=c+((aa(aa(W,e+-1|0)|0,W)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[V>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;z=57}else{a=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}else{e=k[L>>2]|0;if(H){z=e+X|0;x=e+G+(k[J>>2]|0)|0;y=z-f|0;e=k[V>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(W,a)|0,W)|0)<<2)|0;w=d+((aa(aa(W,G)|0,W)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(W,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{l=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=u+o|0;D=k[J>>2]|0;e=0-D|0;if((D|0)<(e|0))e=0;else{h=k[M>>2]|0;i=k[O>>2]|0;f=e;e=0;while(1){D=k[i>>2]|0;A=h+(aa(D,f+z|0)|0)|0;D=h+(aa(D,p+f|0)|0)|0;C=(m[A+(x*6|0)>>1]|0)-(m[D+(g*6|0)>>1]|0)|0;B=(m[A+(x*6|0)+2>>1]|0)-(m[D+(g*6|0)+2>>1]|0)|0;D=(m[A+(x*6|0)+4>>1]|0)-(m[D+(g*6|0)+4>>1]|0)|0;e=((B|0)>-1?B:0-B|0)+((C|0)>-1?C:0-C|0)+((D|0)>-1?D:0-D|0)+e|0;k[l>>2]=e;if((f|0)<(k[J>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[V>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{C=e+I|0;x=e+G|0;i=k[J>>2]|0;h=x+i|0;D=C-f|0;x=x-f+i|0;y=k[M>>2]|0;z=k[O>>2]|0;l=k[z>>2]|0;g=y+(aa(l,C+~i|0)|0)|0;f=y+(aa(l,C+i|0)|0)|0;e=k[V>>2]|0;if((e|0)>0){A=D+-1|0;B=m[f+(h*6|0)>>1]|0;C=m[f+(h*6|0)+2>>1]|0;u=m[f+(h*6|0)+4>>1]|0;v=m[g+(h*6|0)>>1]|0;w=m[g+(h*6|0)+2>>1]|0;r=m[g+(h*6|0)+4>>1]|0;s=c+((aa(aa(W,a)|0,W)|0)<<2)|0;t=d+((aa(aa(W,G)|0,W)|0)<<2)|0;f=0;while(1){p=aa(W,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=y+(aa(l,A+f-i|0)|0)|0;h=y+(aa(l,f+D+i|0)|0)|0;g=0;do{i=o+(g<<2)|0;Y=n+(g<<2)|0;k[Y>>2]=(k[Y>>2]|0)-(k[i>>2]|0);ba=x+g|0;l=p+(g<<2)|0;$=B-(m[h+(ba*6|0)>>1]|0)|0;_=C-(m[h+(ba*6|0)+2>>1]|0)|0;Z=u-(m[h+(ba*6|0)+4>>1]|0)|0;da=v-(m[q+(ba*6|0)>>1]|0)|0;ca=w-(m[q+(ba*6|0)+2>>1]|0)|0;ba=r-(m[q+(ba*6|0)+4>>1]|0)|0;Z=(k[l>>2]|0)-((da|0)>-1?da:0-da|0)-((ca|0)>-1?ca:0-ca|0)-((ba|0)>-1?ba:0-ba|0)+(($|0)>-1?$:0-$|0)+((_|0)>-1?_:0-_|0)+((Z|0)>-1?Z:0-Z|0)|0;k[i>>2]=Z;k[Y>>2]=Z+(k[Y>>2]|0);k[l>>2]=k[i>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;i=k[J>>2]|0;l=k[z>>2]|0}e=k[V>>2]|0}}a=(a+1|0)%(k[T>>2]|0)|0;z=57}if((z|0)==57){z=0;if((e|0)>0){u=k[L>>2]|0;v=k[M>>2]|0;w=k[k[O>>2]>>2]|0;s=k[P>>2]|0;t=k[Q>>2]|0;r=0;f=0;p=0;h=0;g=0;l=0;i=0;o=0;n=0;do{x=v+(aa(w,E+r+u|0)|0)|0;y=b+((aa(W,r)|0)<<2)|0;q=0;do{ca=k[t+(k[y+(q<<2)>>2]>>s<<2)>>2]|0;_=F+q+u|0;$=j[x+(_*6|0)+2>>1]|0;ba=j[x+(_*6|0)+4>>1]|0;da=((ca|0)<0)<<31>>31;_=Epb(m[x+(_*6|0)>>1]|0|0,0,ca|0,da|0)|0;l=kpb(l|0,i|0,_|0,N|0)|0;i=N;$=Epb($&65535|0,0,ca|0,da|0)|0;h=kpb(h|0,g|0,$|0,N|0)|0;g=N;ba=Epb(ba&65535|0,0,ca|0,da|0)|0;f=kpb(f|0,p|0,ba|0,N|0)|0;p=N;o=kpb(ca|0,da|0,o|0,n|0)|0;n=N;q=q+1|0}while((q|0)!=(e|0));r=r+1|0}while((r|0)!=(e|0));e=p}else{o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}ca=Bpb(o|0,n|0,2,0)|0;da=N;_=kpb(l|0,i|0,ca|0,da|0)|0;_=spb(_|0,N|0,o|0,n|0)|0;Z=N;ba=kpb(h|0,g|0,ca|0,da|0)|0;ba=spb(ba|0,N|0,o|0,n|0)|0;$=N;da=kpb(f|0,e|0,ca|0,da|0)|0;da=spb(da|0,N|0,o|0,n|0)|0;ca=N;e=k[R>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,I)|0)|0;j[e+(G*6|0)>>1]=Z>>>0<0|(Z|0)==0&_>>>0<65536?_&65535:((Z|0)>0|(Z|0)==0&_>>>0>0)<<31>>31;j[e+(G*6|0)+2>>1]=$>>>0<0|($|0)==0&ba>>>0<65536?ba&65535:(($|0)>0|($|0)==0&ba>>>0>0)<<31>>31;j[e+(G*6|0)+4>>1]=ca>>>0<0|(ca|0)==0&da>>>0<65536?da&65535:((ca|0)>0|(ca|0)==0&da>>>0>0)<<31>>31;G=G+1|0;e=k[S>>2]|0}while((G|0)<(k[e+12>>2]|0))}I=I+1|0}while((I|0)!=(U|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function b1a(a){a=a|0;P0a(a);ggb(a);return}function c1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;V=k[b>>2]|0;S=k[b+4>>2]|0;T=a+76|0;U=k[T>>2]|0;c=aa(U,U)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}R=a+72|0;d=aa(aa(U,k[R>>2]|0)|0,U)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Q=a+4|0;f=k[Q>>2]|0;e=aa(aa(U,k[f+12>>2]|0)|0,U)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((V|0)<(S|0)){I=a+84|0;J=a+68|0;K=a+28|0;L=a+56|0;M=a+92|0;O=a+96|0;P=a+8|0;H=a+80|0;a=-1;G=V;e=f;do{if((k[e+12>>2]|0)>0){F=(G|0)==(V|0);E=0;do{f=k[I>>2]|0;C=G-f|0;D=E-f|0;if(!E){e=k[T>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+G|0;s=aa(U,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[R>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(U,a)|0,U)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[R>>2]|0}while((a|0)<(e|0))}o=k[I>>2]|0;n=r-o|0;o=q-o|0;f=k[H>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=a+G|0;h=n+a|0;i=k[K>>2]|0;l=k[L>>2]|0;while(1){A=k[J>>2]|0;z=A+f|0;e=o+f+A|0;B=k[l>>2]|0;y=i+(aa(B,g+A|0)|0)|0;A=i+(aa(B,h+A|0)|0)|0;B=(m[y+(z<<2)>>1]|0)-(m[A+(e<<2)>>1]|0)|0;e=(m[y+(z<<2)+2>>1]|0)-(m[A+(e<<2)+2>>1]|0)|0;B=((e|0)>-1?e:0-e|0)+((B|0)>-1?B:0-B|0)|0;k[p>>2]=B+(k[p>>2]|0);e=c+((aa(aa(U,(k[H>>2]|0)+f|0)|0,U)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+B;e=k[H>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[R>>2]|0}e=c+((aa(aa(U,e+-1|0)|0,U)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[T>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;z=57}else{a=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}else{e=k[J>>2]|0;if(F){z=e+V|0;x=e+E+(k[H>>2]|0)|0;y=z-f|0;e=k[T>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(U,a)|0,U)|0)<<2)|0;w=d+((aa(aa(U,E)|0,U)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(U,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{l=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=u+o|0;B=k[H>>2]|0;e=0-B|0;if((B|0)<(e|0))e=0;else{h=k[K>>2]|0;i=k[L>>2]|0;f=e;e=0;while(1){A=k[i>>2]|0;W=h+(aa(A,f+z|0)|0)|0;A=h+(aa(A,p+f|0)|0)|0;B=(m[W+(x<<2)>>1]|0)-(m[A+(g<<2)>>1]|0)|0;A=(m[W+(x<<2)+2>>1]|0)-(m[A+(g<<2)+2>>1]|0)|0;e=((A|0)>-1?A:0-A|0)+((B|0)>-1?B:0-B|0)+e|0;k[l>>2]=e;if((f|0)<(k[H>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[T>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{W=e+G|0;w=e+E|0;i=k[H>>2]|0;h=w+i|0;B=W-f|0;w=w-f+i|0;x=k[K>>2]|0;y=k[L>>2]|0;l=k[y>>2]|0;g=x+(aa(l,W+~i|0)|0)|0;f=x+(aa(l,W+i|0)|0)|0;e=k[T>>2]|0;if((e|0)>0){z=B+-1|0;A=m[f+(h<<2)>>1]|0;u=m[f+(h<<2)+2>>1]|0;v=m[g+(h<<2)>>1]|0;r=m[g+(h<<2)+2>>1]|0;s=c+((aa(aa(U,a)|0,U)|0)<<2)|0;t=d+((aa(aa(U,E)|0,U)|0)<<2)|0;f=0;while(1){p=aa(U,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=x+(aa(l,z+f-i|0)|0)|0;h=x+(aa(l,f+B+i|0)|0)|0;g=0;do{l=o+(g<<2)|0;i=n+(g<<2)|0;k[i>>2]=(k[i>>2]|0)-(k[l>>2]|0);Z=w+g|0;W=p+(g<<2)|0;Y=A-(m[h+(Z<<2)>>1]|0)|0;X=u-(m[h+(Z<<2)+2>>1]|0)|0;_=v-(m[q+(Z<<2)>>1]|0)|0;Z=r-(m[q+(Z<<2)+2>>1]|0)|0;X=(k[W>>2]|0)-((_|0)>-1?_:0-_|0)-((Z|0)>-1?Z:0-Z|0)+((Y|0)>-1?Y:0-Y|0)+((X|0)>-1?X:0-X|0)|0;k[l>>2]=X;k[i>>2]=X+(k[i>>2]|0);k[W>>2]=k[l>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;i=k[H>>2]|0;l=k[y>>2]|0}e=k[T>>2]|0}}a=(a+1|0)%(k[R>>2]|0)|0;z=57}if((z|0)==57){z=0;if((e|0)>0){u=k[J>>2]|0;v=k[K>>2]|0;w=k[k[L>>2]>>2]|0;s=k[M>>2]|0;t=k[O>>2]|0;r=0;h=0;g=0;o=0;n=0;f=0;p=0;l=0;i=0;do{x=v+(aa(w,C+r+u|0)|0)|0;y=b+((aa(U,r)|0)<<2)|0;q=0;do{Z=k[y+(q<<2)>>2]>>s;X=k[t+(Z<<3)>>2]|0;Z=k[t+(Z<<3)+4>>2]|0;_=D+q+u|0;W=j[x+(_<<2)+2>>1]|0;Y=((X|0)<0)<<31>>31;_=Epb(m[x+(_<<2)>>1]|0|0,0,X|0,Y|0)|0;l=kpb(l|0,i|0,_|0,N|0)|0;i=N;_=((Z|0)<0)<<31>>31;W=Epb(W&65535|0,0,Z|0,_|0)|0;f=kpb(f|0,p|0,W|0,N|0)|0;p=N;o=kpb(o|0,n|0,X|0,Y|0)|0;n=N;h=kpb(h|0,g|0,Z|0,_|0)|0;g=N;q=q+1|0}while((q|0)!=(e|0));r=r+1|0}while((r|0)!=(e|0));e=p}else{o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}_=Bpb(o|0,n|0,2,0)|0;_=kpb(_|0,N|0,l|0,i|0)|0;_=spb(_|0,N|0,o|0,n|0)|0;Z=N;Y=Bpb(h|0,g|0,2,0)|0;Y=kpb(Y|0,N|0,f|0,e|0)|0;Y=spb(Y|0,N|0,h|0,g|0)|0;X=N;e=k[P>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,G)|0)+(E<<2)|0;_=(X>>>0<0|(X|0)==0&Y>>>0<65536?Y:((X|0)>0|(X|0)==0&Y>>>0>0)<<31>>31)<<16|(Z>>>0<0|(Z|0)==0&_>>>0<65536?_:((Z|0)>0|(Z|0)==0&_>>>0>0)<<31>>31)&65535;j[e>>1]=_;j[e+2>>1]=_>>>16;E=E+1|0;e=k[Q>>2]|0}while((E|0)<(k[e+12>>2]|0))}G=G+1|0}while((G|0)!=(S|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function d1a(a){a=a|0;O0a(a);ggb(a);return}function e1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;V=k[b>>2]|0;S=k[b+4>>2]|0;T=a+76|0;U=k[T>>2]|0;c=aa(U,U)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}R=a+72|0;d=aa(aa(U,k[R>>2]|0)|0,U)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Q=a+4|0;f=k[Q>>2]|0;e=aa(aa(U,k[f+12>>2]|0)|0,U)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((V|0)<(S|0)){I=a+84|0;J=a+68|0;K=a+28|0;L=a+56|0;M=a+92|0;O=a+96|0;P=a+8|0;H=a+80|0;a=-1;G=V;e=f;do{if((k[e+12>>2]|0)>0){F=(G|0)==(V|0);E=0;do{f=k[I>>2]|0;C=G-f|0;D=E-f|0;if(!E){e=k[T>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+G|0;s=aa(U,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[R>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(U,a)|0,U)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[R>>2]|0}while((a|0)<(e|0))}o=k[I>>2]|0;n=r-o|0;o=q-o|0;f=k[H>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=a+G|0;h=n+a|0;i=k[K>>2]|0;l=k[L>>2]|0;while(1){A=k[J>>2]|0;z=A+f|0;e=o+f+A|0;B=k[l>>2]|0;y=i+(aa(B,g+A|0)|0)|0;A=i+(aa(B,h+A|0)|0)|0;B=(m[y+(z<<2)>>1]|0)-(m[A+(e<<2)>>1]|0)|0;e=(m[y+(z<<2)+2>>1]|0)-(m[A+(e<<2)+2>>1]|0)|0;B=((e|0)>-1?e:0-e|0)+((B|0)>-1?B:0-B|0)|0;k[p>>2]=B+(k[p>>2]|0);e=c+((aa(aa(U,(k[H>>2]|0)+f|0)|0,U)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+B;e=k[H>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[R>>2]|0}e=c+((aa(aa(U,e+-1|0)|0,U)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[T>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;x=57}else{a=0;l=0;i=0;h=0;g=0;f=0;e=0}}else{e=k[J>>2]|0;if(F){z=e+V|0;x=e+E+(k[H>>2]|0)|0;y=z-f|0;e=k[T>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(U,a)|0,U)|0)<<2)|0;w=d+((aa(aa(U,E)|0,U)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(U,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{l=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=u+o|0;B=k[H>>2]|0;e=0-B|0;if((B|0)<(e|0))e=0;else{h=k[K>>2]|0;i=k[L>>2]|0;f=e;e=0;while(1){A=k[i>>2]|0;W=h+(aa(A,f+z|0)|0)|0;A=h+(aa(A,p+f|0)|0)|0;B=(m[W+(x<<2)>>1]|0)-(m[A+(g<<2)>>1]|0)|0;A=(m[W+(x<<2)+2>>1]|0)-(m[A+(g<<2)+2>>1]|0)|0;e=((A|0)>-1?A:0-A|0)+((B|0)>-1?B:0-B|0)+e|0;k[l>>2]=e;if((f|0)<(k[H>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[T>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{W=e+G|0;w=e+E|0;i=k[H>>2]|0;h=w+i|0;B=W-f|0;w=w-f+i|0;x=k[K>>2]|0;y=k[L>>2]|0;l=k[y>>2]|0;g=x+(aa(l,W+~i|0)|0)|0;f=x+(aa(l,W+i|0)|0)|0;e=k[T>>2]|0;if((e|0)>0){z=B+-1|0;A=m[f+(h<<2)>>1]|0;u=m[f+(h<<2)+2>>1]|0;v=m[g+(h<<2)>>1]|0;r=m[g+(h<<2)+2>>1]|0;s=c+((aa(aa(U,a)|0,U)|0)<<2)|0;t=d+((aa(aa(U,E)|0,U)|0)<<2)|0;f=0;while(1){p=aa(U,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=x+(aa(l,z+f-i|0)|0)|0;h=x+(aa(l,f+B+i|0)|0)|0;g=0;do{l=o+(g<<2)|0;i=n+(g<<2)|0;k[i>>2]=(k[i>>2]|0)-(k[l>>2]|0);Z=w+g|0;W=p+(g<<2)|0;Y=A-(m[h+(Z<<2)>>1]|0)|0;X=u-(m[h+(Z<<2)+2>>1]|0)|0;_=v-(m[q+(Z<<2)>>1]|0)|0;Z=r-(m[q+(Z<<2)+2>>1]|0)|0;X=(k[W>>2]|0)-((_|0)>-1?_:0-_|0)-((Z|0)>-1?Z:0-Z|0)+((Y|0)>-1?Y:0-Y|0)+((X|0)>-1?X:0-X|0)|0;k[l>>2]=X;k[i>>2]=X+(k[i>>2]|0);k[W>>2]=k[l>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;i=k[H>>2]|0;l=k[y>>2]|0}e=k[T>>2]|0}}a=(a+1|0)%(k[R>>2]|0)|0;x=57}if((x|0)==57){x=0;if((e|0)>0){s=k[J>>2]|0;t=k[K>>2]|0;u=k[k[L>>2]>>2]|0;q=k[M>>2]|0;r=k[O>>2]|0;p=0;f=0;n=0;h=0;g=0;l=0;i=0;do{v=t+(aa(u,C+p+s|0)|0)|0;w=b+((aa(U,p)|0)<<2)|0;o=0;do{Z=k[r+(k[w+(o<<2)>>2]>>q<<2)>>2]|0;X=D+o+s|0;Y=j[v+(X<<2)+2>>1]|0;_=((Z|0)<0)<<31>>31;X=Epb(m[v+(X<<2)>>1]|0|0,0,Z|0,_|0)|0;h=kpb(h|0,g|0,X|0,N|0)|0;g=N;Y=Epb(Y&65535|0,0,Z|0,_|0)|0;f=kpb(f|0,n|0,Y|0,N|0)|0;n=N;l=kpb(Z|0,_|0,l|0,i|0)|0;i=N;o=o+1|0}while((o|0)!=(e|0));p=p+1|0}while((p|0)!=(e|0));e=n}else{l=0;i=0;h=0;g=0;f=0;e=0}}X=Bpb(l|0,i|0,2,0)|0;Y=N;_=kpb(h|0,g|0,X|0,Y|0)|0;_=spb(_|0,N|0,l|0,i|0)|0;Z=N;Y=kpb(f|0,e|0,X|0,Y|0)|0;Y=spb(Y|0,N|0,l|0,i|0)|0;X=N;e=k[P>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,G)|0)+(E<<2)|0;_=(X>>>0<0|(X|0)==0&Y>>>0<65536?Y:((X|0)>0|(X|0)==0&Y>>>0>0)<<31>>31)<<16|(Z>>>0<0|(Z|0)==0&_>>>0<65536?_:((Z|0)>0|(Z|0)==0&_>>>0>0)<<31>>31)&65535;j[e>>1]=_;j[e+2>>1]=_>>>16;E=E+1|0;e=k[Q>>2]|0}while((E|0)<(k[e+12>>2]|0))}G=G+1|0}while((G|0)!=(S|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function f1a(a){a=a|0;N0a(a);ggb(a);return}function g1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;T=k[b>>2]|0;Q=k[b+4>>2]|0;R=a+76|0;S=k[R>>2]|0;c=aa(S,S)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}P=a+72|0;d=aa(aa(S,k[P>>2]|0)|0,S)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}O=a+4|0;g=k[O>>2]|0;e=aa(aa(S,k[g+12>>2]|0)|0,S)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((T|0)<(Q|0)){G=a+84|0;H=a+68|0;I=a+28|0;J=a+56|0;K=a+92|0;L=a+96|0;M=a+8|0;F=a+80|0;f=-1;E=T;a=S;e=g;do{if((k[e+12>>2]|0)>0){D=(E|0)==(T|0);C=0;do{h=k[G>>2]|0;A=E-h|0;B=C-h|0;if(!C){e=k[R>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+E|0;s=aa(S,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[P>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(S,a)|0,S)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[P>>2]|0}while((a|0)<(e|0))}o=k[G>>2]|0;n=r-o|0;o=q-o|0;f=k[F>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=a+E|0;h=n+a|0;i=k[I>>2]|0;l=k[J>>2]|0;while(1){z=k[H>>2]|0;y=k[l>>2]|0;e=i+(aa(y,g+z|0)|0)+(z+f<<1)|0;z=i+(aa(y,h+z|0)|0)+(o+f+z<<1)|0;z=(m[e>>1]|0)-(m[z>>1]|0)|0;z=(z|0)>-1?z:0-z|0;k[p>>2]=z+(k[p>>2]|0);e=c+((aa(aa(S,(k[F>>2]|0)+f|0)|0,S)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+z;e=k[F>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[P>>2]|0}e=c+((aa(aa(S,e+-1|0)|0,S)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[R>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));f=0;v=56}else{f=0;l=0;i=0;h=0;g=0;a=e}}else{e=k[H>>2]|0;a:do if(D){z=e+T|0;x=e+C+(k[F>>2]|0)|0;y=z-h|0;e=k[R>>2]|0;if((e|0)>0){u=x-h|0;v=c+((aa(aa(S,f)|0,S)|0)<<2)|0;w=d+((aa(aa(S,C)|0,S)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(S,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{l=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=u+o|0;i=k[F>>2]|0;e=0-i|0;if((i|0)<(e|0))e=0;else{h=k[I>>2]|0;i=k[J>>2]|0;a=e;e=0;while(1){U=k[i>>2]|0;V=h+(aa(U,a+z|0)|0)+(x<<1)|0;U=h+(aa(U,p+a|0)|0)+(g<<1)|0;U=(m[V>>1]|0)-(m[U>>1]|0)|0;e=e+((U|0)>-1?U:0-U|0)|0;k[l>>2]=e;if((a|0)<(k[F>>2]|0))a=a+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[R>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{g=e+E|0;v=e+C|0;i=k[F>>2]|0;e=v+i|0;y=g-h|0;v=v-h+i|0;w=k[I>>2]|0;x=k[J>>2]|0;h=k[x>>2]|0;if((a|0)>0){r=w+(aa(h,g+i|0)|0)+(e<<1)|0;s=w+(aa(h,g+~i|0)|0)+(e<<1)|0;q=y+-1|0;r=m[r>>1]|0;s=m[s>>1]|0;t=c+((aa(aa(S,f)|0,S)|0)<<2)|0;u=d+((aa(aa(S,C)|0,S)|0)<<2)|0;e=0;while(1){o=aa(S,e)|0;l=b+(o<<2)|0;n=t+(o<<2)|0;o=u+(o<<2)|0;p=w+(aa(h,q+e-i|0)|0)|0;h=w+(aa(h,e+y+i|0)|0)|0;g=0;do{U=n+(g<<2)|0;z=l+(g<<2)|0;k[z>>2]=(k[z>>2]|0)-(k[U>>2]|0);i=v+g|0;V=o+(g<<2)|0;W=r-(m[h+(i<<1)>>1]|0)|0;i=s-(m[p+(i<<1)>>1]|0)|0;i=((W|0)>-1?W:0-W|0)-((i|0)>-1?i:0-i|0)+(k[V>>2]|0)|0;k[U>>2]=i;k[z>>2]=i+(k[z>>2]|0);k[V>>2]=k[U>>2];g=g+1|0}while((g|0)!=(a|0));e=e+1|0;if((e|0)==(a|0))break a;i=k[F>>2]|0;h=k[x>>2]|0}}}while(0);f=(f+1|0)%(k[P>>2]|0)|0;e=k[R>>2]|0;v=56}if((v|0)==56){v=0;if((e|0)>0){q=k[H>>2]|0;r=k[I>>2]|0;s=k[k[J>>2]>>2]|0;o=k[K>>2]|0;p=k[L>>2]|0;n=0;l=0;i=0;h=0;g=0;do{t=r+(aa(s,A+n+q|0)|0)|0;u=b+((aa(S,n)|0)<<2)|0;a=0;do{V=k[p+(k[u+(a<<2)>>2]>>o<<2)>>2]|0;W=((V|0)<0)<<31>>31;U=Epb(m[t+(B+a+q<<1)>>1]|0|0,0,V|0,W|0)|0;h=kpb(U|0,N|0,h|0,g|0)|0;g=N;l=kpb(V|0,W|0,l|0,i|0)|0;i=N;a=a+1|0}while((a|0)!=(e|0));n=n+1|0}while((n|0)!=(e|0));a=e}else{l=0;i=0;h=0;g=0;a=e}}W=Bpb(l|0,i|0,2,0)|0;W=kpb(W|0,N|0,h|0,g|0)|0;W=spb(W|0,N|0,l|0,i|0)|0;V=N;e=k[M>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,E)|0)+(C<<1)|0;j[e>>1]=V>>>0<0|(V|0)==0&W>>>0<65536?W&65535:((V|0)>0|(V|0)==0&W>>>0>0)<<31>>31;C=C+1|0;e=k[O>>2]|0}while((C|0)<(k[e+12>>2]|0))}E=E+1|0}while((E|0)!=(Q|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function h1a(a){a=a|0;M0a(a);ggb(a);return}function i1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;Y=k[b>>2]|0;V=k[b+4>>2]|0;W=a+76|0;X=k[W>>2]|0;c=aa(X,X)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}U=a+72|0;d=aa(aa(X,k[U>>2]|0)|0,X)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}T=a+4|0;f=k[T>>2]|0;e=aa(aa(X,k[f+12>>2]|0)|0,X)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Y|0)<(V|0)){M=a+84|0;N=a+68|0;O=a+28|0;P=a+56|0;Q=a+92|0;R=a+96|0;S=a+8|0;L=a+80|0;a=-1;K=Y;e=f;do{if((k[e+12>>2]|0)>0){J=(K|0)==(Y|0);I=0;do{f=k[M>>2]|0;G=K-f|0;H=I-f|0;if(!I){e=k[W>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+K|0;s=aa(X,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[U>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(X,a)|0,X)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[U>>2]|0}while((a|0)<(e|0))}o=k[M>>2]|0;n=r-o|0;o=q-o|0;f=k[L>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+K|0;m=n+a|0;g=k[O>>2]|0;h=k[P>>2]|0;while(1){C=k[N>>2]|0;B=C+f|0;F=o+f+C|0;E=k[h>>2]|0;A=g+(aa(E,j+C|0)|0)|0;C=g+(aa(E,m+C|0)|0)|0;E=(l[A+(B<<2)>>0]|0)-(l[C+(F<<2)>>0]|0)|0;D=(l[A+(B<<2)+1>>0]|0)-(l[C+(F<<2)+1>>0]|0)|0;e=(l[A+(B<<2)+2>>0]|0)-(l[C+(F<<2)+2>>0]|0)|0;F=(l[A+(B<<2)+3>>0]|0)-(l[C+(F<<2)+3>>0]|0)|0;F=((D|0)>-1?D:0-D|0)+((E|0)>-1?E:0-E|0)+((e|0)>-1?e:0-e|0)+((F|0)>-1?F:0-F|0)|0;k[p>>2]=F+(k[p>>2]|0);e=c+((aa(aa(X,(k[L>>2]|0)+f|0)|0,X)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+F;e=k[L>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[U>>2]|0}e=c+((aa(aa(X,e+-1|0)|0,X)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[W>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;z=57}else{a=0;o=0;n=0;m=0;j=0;h=0;g=0;f=0;e=0}}else{e=k[N>>2]|0;if(J){z=e+Y|0;x=e+I+(k[L>>2]|0)|0;y=z-f|0;e=k[W>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(X,a)|0,X)|0)<<2)|0;w=d+((aa(aa(X,I)|0,X)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(X,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;F=k[L>>2]|0;e=0-F|0;if((F|0)<(e|0))e=0;else{g=k[O>>2]|0;h=k[P>>2]|0;f=e;e=0;while(1){F=k[h>>2]|0;B=g+(aa(F,f+z|0)|0)|0;F=g+(aa(F,p+f|0)|0)|0;D=(l[B+(x<<2)>>0]|0)-(l[F+(j<<2)>>0]|0)|0;C=(l[B+(x<<2)+1>>0]|0)-(l[F+(j<<2)+1>>0]|0)|0;E=(l[B+(x<<2)+2>>0]|0)-(l[F+(j<<2)+2>>0]|0)|0;F=(l[B+(x<<2)+3>>0]|0)-(l[F+(j<<2)+3>>0]|0)|0;e=((C|0)>-1?C:0-C|0)+((D|0)>-1?D:0-D|0)+((E|0)>-1?E:0-E|0)+((F|0)>-1?F:0-F|0)+e|0;k[m>>2]=e;if((f|0)<(k[L>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[W>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{E=e+K|0;y=e+I|0;j=k[L>>2]|0;h=y+j|0;F=E-f|0;y=y-f+j|0;z=k[O>>2]|0;A=k[P>>2]|0;m=k[A>>2]|0;g=z+(aa(m,E+~j|0)|0)|0;f=z+(aa(m,E+j|0)|0)|0;e=k[W>>2]|0;if((e|0)>0){B=F+-1|0;C=l[f+(h<<2)>>0]|0;D=l[f+(h<<2)+1>>0]|0;E=l[f+(h<<2)+2>>0]|0;u=l[f+(h<<2)+3>>0]|0;v=l[g+(h<<2)>>0]|0;w=l[g+(h<<2)+1>>0]|0;x=l[g+(h<<2)+2>>0]|0;r=l[g+(h<<2)+3>>0]|0;s=c+((aa(aa(X,a)|0,X)|0)<<2)|0;t=d+((aa(aa(X,I)|0,X)|0)<<2)|0;f=0;while(1){p=aa(X,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=z+(aa(m,B+f-j|0)|0)|0;h=z+(aa(m,f+F+j|0)|0)|0;g=0;do{j=o+(g<<2)|0;Z=n+(g<<2)|0;k[Z>>2]=(k[Z>>2]|0)-(k[j>>2]|0);da=y+g|0;m=p+(g<<2)|0;ca=C-(l[h+(da<<2)>>0]|0)|0;ba=D-(l[h+(da<<2)+1>>0]|0)|0;$=E-(l[h+(da<<2)+2>>0]|0)|0;_=u-(l[h+(da<<2)+3>>0]|0)|0;ga=v-(l[q+(da<<2)>>0]|0)|0;fa=w-(l[q+(da<<2)+1>>0]|0)|0;ea=x-(l[q+(da<<2)+2>>0]|0)|0;da=r-(l[q+(da<<2)+3>>0]|0)|0;_=(k[m>>2]|0)-((ga|0)>-1?ga:0-ga|0)-((fa|0)>-1?fa:0-fa|0)-((ea|0)>-1?ea:0-ea|0)-((da|0)>-1?da:0-da|0)+((ca|0)>-1?ca:0-ca|0)+((ba|0)>-1?ba:0-ba|0)+(($|0)>-1?$:0-$|0)+((_|0)>-1?_:0-_|0)|0;k[j>>2]=_;k[Z>>2]=_+(k[Z>>2]|0);k[m>>2]=k[j>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[L>>2]|0;m=k[A>>2]|0}e=k[W>>2]|0}}a=(a+1|0)%(k[U>>2]|0)|0;z=57}if((z|0)==57){z=0;if((e|0)>0){u=k[N>>2]|0;v=k[O>>2]|0;w=k[k[P>>2]>>2]|0;s=k[Q>>2]|0;t=k[R>>2]|0;r=0;n=0;j=0;g=0;p=0;o=0;m=0;h=0;f=0;do{x=v+(aa(w,G+r+u|0)|0)|0;y=b+((aa(X,r)|0)<<2)|0;q=0;do{ga=k[y+(q<<2)>>2]>>s;da=k[t+(ga<<4)>>2]|0;ea=k[t+(ga<<4)+4>>2]|0;fa=k[t+(ga<<4)+8>>2]|0;ga=k[t+(ga<<4)+12>>2]|0;ca=H+q+u|0;n=n+(aa(l[x+(ca<<2)>>0]|0,da)|0)|0;j=j+(aa(l[x+(ca<<2)+1>>0]|0,ea)|0)|0;g=g+(aa(l[x+(ca<<2)+2>>0]|0,fa)|0)|0;p=p+(aa(l[x+(ca<<2)+3>>0]|0,ga)|0)|0;o=o+da|0;m=m+ea|0;h=h+fa|0;f=f+ga|0;q=q+1|0}while((q|0)!=(e|0));r=r+1|0}while((r|0)!=(e|0));e=p}else{o=0;n=0;m=0;j=0;h=0;g=0;f=0;e=0}}da=((((o|0)/2|0)+n|0)>>>0)/(o>>>0)|0;fa=((((m|0)/2|0)+j|0)>>>0)/(m>>>0)|0;ga=((((h|0)/2|0)+g|0)>>>0)/(h>>>0)|0;ea=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[S>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,K)|0)+(I<<2)|0;ga=(da>>>0<256?da:(da|0)>0?255:0)&255|(ea>>>0<256?ea:(ea|0)>0?255:0)<<24|(fa>>>0<256?fa:(fa|0)>0?255:0)<<8&65280|(ga>>>0<256?ga:(ga|0)>0?255:0)<<16&16711680;i[e>>0]=ga;i[e+1>>0]=ga>>8;i[e+2>>0]=ga>>16;i[e+3>>0]=ga>>24;I=I+1|0;e=k[T>>2]|0}while((I|0)<(k[e+12>>2]|0))}K=K+1|0}while((K|0)!=(V|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function j1a(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0.0,f=0.0,g=0.0,h=0;f=-(b*b);e=+(d|0);g=e*.001;b=+o[c>>2];b=+Z(+(f/(b*b*4.0)));p[u>>3]=b;d=k[u+4>>2]&2147483647;b=e*(d>>>0>2146435072|(d|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:b);p[u>>3]=b;d=k[u+4>>2]|0;h=d&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(b==0.0)b=d?-0.0:0.0}d=~~b;k[a>>2]=+(d|0)<g?0:d;b=+o[c+4>>2];b=+Z(+(f/(b*b*4.0)));p[u>>3]=b;d=k[u+4>>2]&2147483647;b=e*(d>>>0>2146435072|(d|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:b);p[u>>3]=b;d=k[u+4>>2]|0;h=d&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(b==0.0)b=d?-0.0:0.0}d=~~b;k[a+4>>2]=+(d|0)<g?0:d;b=+o[c+8>>2];b=+Z(+(f/(b*b*4.0)));p[u>>3]=b;d=k[u+4>>2]&2147483647;b=e*(d>>>0>2146435072|(d|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:b);p[u>>3]=b;d=k[u+4>>2]|0;h=d&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(b==0.0)b=d?-0.0:0.0}d=~~b;k[a+8>>2]=+(d|0)<g?0:d;b=+o[c+12>>2];b=+Z(+(f/(b*b*4.0)));p[u>>3]=b;d=k[u+4>>2]&2147483647;b=e*(d>>>0>2146435072|(d|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:b);p[u>>3]=b;d=k[u+4>>2]|0;h=d&2146435072;if(h>>>0>1126170624|(h|0)==1126170624&0>0){f=b;c=~~f;f=+(c|0);h=f<g;c=h?0:c;h=a+12|0;k[h>>2]=c;return}d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(!(b==0.0)){f=b;c=~~f;f=+(c|0);h=f<g;c=h?0:c;h=a+12|0;k[h>>2]=c;return}f=d?-0.0:0.0;c=~~f;f=+(c|0);h=f<g;c=h?0:c;h=a+12|0;k[h>>2]=c;return}function k1a(a){a=a|0;L0a(a);ggb(a);return}function l1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;Y=k[b>>2]|0;V=k[b+4>>2]|0;W=a+76|0;X=k[W>>2]|0;c=aa(X,X)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}U=a+72|0;d=aa(aa(X,k[U>>2]|0)|0,X)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}T=a+4|0;f=k[T>>2]|0;e=aa(aa(X,k[f+12>>2]|0)|0,X)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Y|0)<(V|0)){M=a+84|0;N=a+68|0;O=a+28|0;P=a+56|0;Q=a+92|0;R=a+96|0;S=a+8|0;L=a+80|0;a=-1;K=Y;e=f;do{if((k[e+12>>2]|0)>0){J=(K|0)==(Y|0);I=0;do{f=k[M>>2]|0;G=K-f|0;H=I-f|0;if(!I){e=k[W>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+K|0;s=aa(X,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[U>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(X,a)|0,X)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[U>>2]|0}while((a|0)<(e|0))}o=k[M>>2]|0;n=r-o|0;o=q-o|0;f=k[L>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+K|0;m=n+a|0;g=k[O>>2]|0;h=k[P>>2]|0;while(1){C=k[N>>2]|0;B=C+f|0;F=o+f+C|0;E=k[h>>2]|0;A=g+(aa(E,j+C|0)|0)|0;C=g+(aa(E,m+C|0)|0)|0;E=(l[A+(B<<2)>>0]|0)-(l[C+(F<<2)>>0]|0)|0;D=(l[A+(B<<2)+1>>0]|0)-(l[C+(F<<2)+1>>0]|0)|0;e=(l[A+(B<<2)+2>>0]|0)-(l[C+(F<<2)+2>>0]|0)|0;F=(l[A+(B<<2)+3>>0]|0)-(l[C+(F<<2)+3>>0]|0)|0;F=((D|0)>-1?D:0-D|0)+((E|0)>-1?E:0-E|0)+((e|0)>-1?e:0-e|0)+((F|0)>-1?F:0-F|0)|0;k[p>>2]=F+(k[p>>2]|0);e=c+((aa(aa(X,(k[L>>2]|0)+f|0)|0,X)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+F;e=k[L>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[U>>2]|0}e=c+((aa(aa(X,e+-1|0)|0,X)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[W>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;w=57}else{a=0;j=0;h=0;g=0;f=0;e=0}}else{e=k[N>>2]|0;if(J){z=e+Y|0;x=e+I+(k[L>>2]|0)|0;y=z-f|0;e=k[W>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(X,a)|0,X)|0)<<2)|0;w=d+((aa(aa(X,I)|0,X)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(X,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;F=k[L>>2]|0;e=0-F|0;if((F|0)<(e|0))e=0;else{g=k[O>>2]|0;h=k[P>>2]|0;f=e;e=0;while(1){F=k[h>>2]|0;B=g+(aa(F,f+z|0)|0)|0;F=g+(aa(F,p+f|0)|0)|0;D=(l[B+(x<<2)>>0]|0)-(l[F+(j<<2)>>0]|0)|0;C=(l[B+(x<<2)+1>>0]|0)-(l[F+(j<<2)+1>>0]|0)|0;E=(l[B+(x<<2)+2>>0]|0)-(l[F+(j<<2)+2>>0]|0)|0;F=(l[B+(x<<2)+3>>0]|0)-(l[F+(j<<2)+3>>0]|0)|0;e=((C|0)>-1?C:0-C|0)+((D|0)>-1?D:0-D|0)+((E|0)>-1?E:0-E|0)+((F|0)>-1?F:0-F|0)+e|0;k[m>>2]=e;if((f|0)<(k[L>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[W>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{E=e+K|0;y=e+I|0;j=k[L>>2]|0;h=y+j|0;F=E-f|0;y=y-f+j|0;z=k[O>>2]|0;A=k[P>>2]|0;m=k[A>>2]|0;g=z+(aa(m,E+~j|0)|0)|0;f=z+(aa(m,E+j|0)|0)|0;e=k[W>>2]|0;if((e|0)>0){B=F+-1|0;C=l[f+(h<<2)>>0]|0;D=l[f+(h<<2)+1>>0]|0;E=l[f+(h<<2)+2>>0]|0;u=l[f+(h<<2)+3>>0]|0;v=l[g+(h<<2)>>0]|0;w=l[g+(h<<2)+1>>0]|0;x=l[g+(h<<2)+2>>0]|0;r=l[g+(h<<2)+3>>0]|0;s=c+((aa(aa(X,a)|0,X)|0)<<2)|0;t=d+((aa(aa(X,I)|0,X)|0)<<2)|0;f=0;while(1){p=aa(X,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=z+(aa(m,B+f-j|0)|0)|0;h=z+(aa(m,f+F+j|0)|0)|0;g=0;do{j=o+(g<<2)|0;Z=n+(g<<2)|0;k[Z>>2]=(k[Z>>2]|0)-(k[j>>2]|0);da=y+g|0;m=p+(g<<2)|0;ca=C-(l[h+(da<<2)>>0]|0)|0;ba=D-(l[h+(da<<2)+1>>0]|0)|0;$=E-(l[h+(da<<2)+2>>0]|0)|0;_=u-(l[h+(da<<2)+3>>0]|0)|0;ga=v-(l[q+(da<<2)>>0]|0)|0;fa=w-(l[q+(da<<2)+1>>0]|0)|0;ea=x-(l[q+(da<<2)+2>>0]|0)|0;da=r-(l[q+(da<<2)+3>>0]|0)|0;_=(k[m>>2]|0)-((ga|0)>-1?ga:0-ga|0)-((fa|0)>-1?fa:0-fa|0)-((ea|0)>-1?ea:0-ea|0)-((da|0)>-1?da:0-da|0)+((ca|0)>-1?ca:0-ca|0)+((ba|0)>-1?ba:0-ba|0)+(($|0)>-1?$:0-$|0)+((_|0)>-1?_:0-_|0)|0;k[j>>2]=_;k[Z>>2]=_+(k[Z>>2]|0);k[m>>2]=k[j>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[L>>2]|0;m=k[A>>2]|0}e=k[W>>2]|0}}a=(a+1|0)%(k[U>>2]|0)|0;w=57}if((w|0)==57){w=0;if((e|0)>0){r=k[N>>2]|0;s=k[O>>2]|0;t=k[k[P>>2]>>2]|0;p=k[Q>>2]|0;q=k[R>>2]|0;o=0;h=0;g=0;f=0;m=0;j=0;do{u=s+(aa(t,G+o+r|0)|0)|0;v=b+((aa(X,o)|0)<<2)|0;n=0;do{ga=k[q+(k[v+(n<<2)>>2]>>p<<2)>>2]|0;fa=H+n+r|0;h=h+(aa(l[u+(fa<<2)>>0]|0,ga)|0)|0;g=g+(aa(l[u+(fa<<2)+1>>0]|0,ga)|0)|0;f=f+(aa(l[u+(fa<<2)+2>>0]|0,ga)|0)|0;m=m+(aa(l[u+(fa<<2)+3>>0]|0,ga)|0)|0;j=ga+j|0;n=n+1|0}while((n|0)!=(e|0));o=o+1|0}while((o|0)!=(e|0));e=m}else{j=0;h=0;g=0;f=0;e=0}}ea=(j|0)/2|0;da=((h+ea|0)>>>0)/(j>>>0)|0;fa=((g+ea|0)>>>0)/(j>>>0)|0;ga=((f+ea|0)>>>0)/(j>>>0)|0;ea=((e+ea|0)>>>0)/(j>>>0)|0;e=k[S>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,K)|0)+(I<<2)|0;ga=(da>>>0<256?da:(da|0)>0?255:0)&255|(ea>>>0<256?ea:(ea|0)>0?255:0)<<24|(fa>>>0<256?fa:(fa|0)>0?255:0)<<8&65280|(ga>>>0<256?ga:(ga|0)>0?255:0)<<16&16711680;i[e>>0]=ga;i[e+1>>0]=ga>>8;i[e+2>>0]=ga>>16;i[e+3>>0]=ga>>24;I=I+1|0;e=k[T>>2]|0}while((I|0)<(k[e+12>>2]|0))}K=K+1|0}while((K|0)!=(V|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function m1a(a){a=a|0;K0a(a);ggb(a);return}function n1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0;W=k[b>>2]|0;T=k[b+4>>2]|0;U=a+76|0;V=k[U>>2]|0;c=aa(V,V)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}S=a+72|0;d=aa(aa(V,k[S>>2]|0)|0,V)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}R=a+4|0;f=k[R>>2]|0;e=aa(aa(V,k[f+12>>2]|0)|0,V)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((W|0)<(T|0)){K=a+84|0;L=a+68|0;M=a+28|0;N=a+56|0;O=a+92|0;P=a+96|0;Q=a+8|0;J=a+80|0;a=-1;I=W;e=f;do{if((k[e+12>>2]|0)>0){H=(I|0)==(W|0);G=0;do{f=k[K>>2]|0;E=I-f|0;F=G-f|0;if(!G){e=k[U>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+I|0;s=aa(V,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[S>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(V,a)|0,V)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[S>>2]|0}while((a|0)<(e|0))}o=k[K>>2]|0;n=r-o|0;o=q-o|0;f=k[J>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+I|0;m=n+a|0;g=k[M>>2]|0;h=k[N>>2]|0;while(1){B=k[L>>2]|0;A=B+f|0;D=o+f+B|0;e=k[h>>2]|0;z=g+(aa(e,j+B|0)|0)|0;B=g+(aa(e,m+B|0)|0)|0;e=(l[z+(A*3|0)>>0]|0)-(l[B+(D*3|0)>>0]|0)|0;C=(l[z+(A*3|0)+1>>0]|0)-(l[B+(D*3|0)+1>>0]|0)|0;D=(l[z+(A*3|0)+2>>0]|0)-(l[B+(D*3|0)+2>>0]|0)|0;D=((C|0)>-1?C:0-C|0)+((e|0)>-1?e:0-e|0)+((D|0)>-1?D:0-D|0)|0;k[p>>2]=D+(k[p>>2]|0);e=c+((aa(aa(V,(k[J>>2]|0)+f|0)|0,V)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+D;e=k[J>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[S>>2]|0}e=c+((aa(aa(V,e+-1|0)|0,V)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[U>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;x=57}else{a=0;m=0;j=0;h=0;g=0;f=0;e=0}}else{e=k[L>>2]|0;if(H){z=e+W|0;x=e+G+(k[J>>2]|0)|0;y=z-f|0;e=k[U>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(V,a)|0,V)|0)<<2)|0;w=d+((aa(aa(V,G)|0,V)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(V,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;D=k[J>>2]|0;e=0-D|0;if((D|0)<(e|0))e=0;else{g=k[M>>2]|0;h=k[N>>2]|0;f=e;e=0;while(1){D=k[h>>2]|0;A=g+(aa(D,f+z|0)|0)|0;D=g+(aa(D,p+f|0)|0)|0;C=(l[A+(x*3|0)>>0]|0)-(l[D+(j*3|0)>>0]|0)|0;B=(l[A+(x*3|0)+1>>0]|0)-(l[D+(j*3|0)+1>>0]|0)|0;D=(l[A+(x*3|0)+2>>0]|0)-(l[D+(j*3|0)+2>>0]|0)|0;e=((B|0)>-1?B:0-B|0)+((C|0)>-1?C:0-C|0)+((D|0)>-1?D:0-D|0)+e|0;k[m>>2]=e;if((f|0)<(k[J>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[U>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{C=e+I|0;x=e+G|0;j=k[J>>2]|0;h=x+j|0;D=C-f|0;x=x-f+j|0;y=k[M>>2]|0;z=k[N>>2]|0;m=k[z>>2]|0;g=y+(aa(m,C+~j|0)|0)|0;f=y+(aa(m,C+j|0)|0)|0;e=k[U>>2]|0;if((e|0)>0){A=D+-1|0;B=l[f+(h*3|0)>>0]|0;C=l[f+(h*3|0)+1>>0]|0;u=l[f+(h*3|0)+2>>0]|0;v=l[g+(h*3|0)>>0]|0;w=l[g+(h*3|0)+1>>0]|0;r=l[g+(h*3|0)+2>>0]|0;s=c+((aa(aa(V,a)|0,V)|0)<<2)|0;t=d+((aa(aa(V,G)|0,V)|0)<<2)|0;f=0;while(1){p=aa(V,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=y+(aa(m,A+f-j|0)|0)|0;h=y+(aa(m,f+D+j|0)|0)|0;g=0;do{j=o+(g<<2)|0;X=n+(g<<2)|0;k[X>>2]=(k[X>>2]|0)-(k[j>>2]|0);$=x+g|0;m=p+(g<<2)|0;_=B-(l[h+($*3|0)>>0]|0)|0;Z=C-(l[h+($*3|0)+1>>0]|0)|0;Y=u-(l[h+($*3|0)+2>>0]|0)|0;ca=v-(l[q+($*3|0)>>0]|0)|0;ba=w-(l[q+($*3|0)+1>>0]|0)|0;$=r-(l[q+($*3|0)+2>>0]|0)|0;Y=(k[m>>2]|0)-((ca|0)>-1?ca:0-ca|0)-((ba|0)>-1?ba:0-ba|0)-(($|0)>-1?$:0-$|0)+((_|0)>-1?_:0-_|0)+((Z|0)>-1?Z:0-Z|0)+((Y|0)>-1?Y:0-Y|0)|0;k[j>>2]=Y;k[X>>2]=Y+(k[X>>2]|0);k[m>>2]=k[j>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[J>>2]|0;m=k[z>>2]|0}e=k[U>>2]|0}}a=(a+1|0)%(k[S>>2]|0)|0;x=57}if((x|0)==57){x=0;if((e|0)>0){s=k[L>>2]|0;t=k[M>>2]|0;u=k[k[N>>2]>>2]|0;q=k[O>>2]|0;r=k[P>>2]|0;p=0;j=0;g=0;n=0;m=0;h=0;f=0;do{v=t+(aa(u,E+p+s|0)|0)|0;w=b+((aa(V,p)|0)<<2)|0;o=0;do{ca=k[w+(o<<2)>>2]>>q;$=k[r+(ca*12|0)>>2]|0;ba=k[r+(ca*12|0)+4>>2]|0;ca=k[r+(ca*12|0)+8>>2]|0;_=F+o+s|0;j=j+(aa(l[v+(_*3|0)>>0]|0,$)|0)|0;g=g+(aa(l[v+(_*3|0)+1>>0]|0,ba)|0)|0;n=n+(aa(l[v+(_*3|0)+2>>0]|0,ca)|0)|0;m=m+$|0;h=h+ba|0;f=f+ca|0;o=o+1|0}while((o|0)!=(e|0));p=p+1|0}while((p|0)!=(e|0));e=n}else{m=0;j=0;h=0;g=0;f=0;e=0}}$=((((m|0)/2|0)+j|0)>>>0)/(m>>>0)|0;ba=((((h|0)/2|0)+g|0)>>>0)/(h>>>0)|0;ca=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[Q>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,I)|0)|0;i[e+(G*3|0)>>0]=$>>>0<256?$:($|0)>0?255:0;i[e+(G*3|0)+1>>0]=ba>>>0<256?ba:(ba|0)>0?255:0;i[e+(G*3|0)+2>>0]=ca>>>0<256?ca:(ca|0)>0?255:0;G=G+1|0;e=k[R>>2]|0}while((G|0)<(k[e+12>>2]|0))}I=I+1|0}while((I|0)!=(T|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function o1a(a){a=a|0;J0a(a);ggb(a);return}function p1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0;W=k[b>>2]|0;T=k[b+4>>2]|0;U=a+76|0;V=k[U>>2]|0;c=aa(V,V)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}S=a+72|0;d=aa(aa(V,k[S>>2]|0)|0,V)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}R=a+4|0;f=k[R>>2]|0;e=aa(aa(V,k[f+12>>2]|0)|0,V)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((W|0)<(T|0)){K=a+84|0;L=a+68|0;M=a+28|0;N=a+56|0;O=a+92|0;P=a+96|0;Q=a+8|0;J=a+80|0;a=-1;I=W;e=f;do{if((k[e+12>>2]|0)>0){H=(I|0)==(W|0);G=0;do{f=k[K>>2]|0;E=I-f|0;F=G-f|0;if(!G){e=k[U>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+I|0;s=aa(V,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[S>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(V,a)|0,V)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[S>>2]|0}while((a|0)<(e|0))}o=k[K>>2]|0;n=r-o|0;o=q-o|0;f=k[J>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+I|0;m=n+a|0;g=k[M>>2]|0;h=k[N>>2]|0;while(1){B=k[L>>2]|0;A=B+f|0;D=o+f+B|0;e=k[h>>2]|0;z=g+(aa(e,j+B|0)|0)|0;B=g+(aa(e,m+B|0)|0)|0;e=(l[z+(A*3|0)>>0]|0)-(l[B+(D*3|0)>>0]|0)|0;C=(l[z+(A*3|0)+1>>0]|0)-(l[B+(D*3|0)+1>>0]|0)|0;D=(l[z+(A*3|0)+2>>0]|0)-(l[B+(D*3|0)+2>>0]|0)|0;D=((C|0)>-1?C:0-C|0)+((e|0)>-1?e:0-e|0)+((D|0)>-1?D:0-D|0)|0;k[p>>2]=D+(k[p>>2]|0);e=c+((aa(aa(V,(k[J>>2]|0)+f|0)|0,V)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+D;e=k[J>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[S>>2]|0}e=c+((aa(aa(V,e+-1|0)|0,V)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[U>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;v=57}else{a=0;h=0;g=0;f=0;e=0}}else{e=k[L>>2]|0;if(H){z=e+W|0;x=e+G+(k[J>>2]|0)|0;y=z-f|0;e=k[U>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(V,a)|0,V)|0)<<2)|0;w=d+((aa(aa(V,G)|0,V)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(V,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;D=k[J>>2]|0;e=0-D|0;if((D|0)<(e|0))e=0;else{g=k[M>>2]|0;h=k[N>>2]|0;f=e;e=0;while(1){D=k[h>>2]|0;A=g+(aa(D,f+z|0)|0)|0;D=g+(aa(D,p+f|0)|0)|0;C=(l[A+(x*3|0)>>0]|0)-(l[D+(j*3|0)>>0]|0)|0;B=(l[A+(x*3|0)+1>>0]|0)-(l[D+(j*3|0)+1>>0]|0)|0;D=(l[A+(x*3|0)+2>>0]|0)-(l[D+(j*3|0)+2>>0]|0)|0;e=((B|0)>-1?B:0-B|0)+((C|0)>-1?C:0-C|0)+((D|0)>-1?D:0-D|0)+e|0;k[m>>2]=e;if((f|0)<(k[J>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[U>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{C=e+I|0;x=e+G|0;j=k[J>>2]|0;h=x+j|0;D=C-f|0;x=x-f+j|0;y=k[M>>2]|0;z=k[N>>2]|0;m=k[z>>2]|0;g=y+(aa(m,C+~j|0)|0)|0;f=y+(aa(m,C+j|0)|0)|0;e=k[U>>2]|0;if((e|0)>0){A=D+-1|0;B=l[f+(h*3|0)>>0]|0;C=l[f+(h*3|0)+1>>0]|0;u=l[f+(h*3|0)+2>>0]|0;v=l[g+(h*3|0)>>0]|0;w=l[g+(h*3|0)+1>>0]|0;r=l[g+(h*3|0)+2>>0]|0;s=c+((aa(aa(V,a)|0,V)|0)<<2)|0;t=d+((aa(aa(V,G)|0,V)|0)<<2)|0;f=0;while(1){p=aa(V,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=y+(aa(m,A+f-j|0)|0)|0;h=y+(aa(m,f+D+j|0)|0)|0;g=0;do{j=o+(g<<2)|0;X=n+(g<<2)|0;k[X>>2]=(k[X>>2]|0)-(k[j>>2]|0);$=x+g|0;m=p+(g<<2)|0;_=B-(l[h+($*3|0)>>0]|0)|0;Z=C-(l[h+($*3|0)+1>>0]|0)|0;Y=u-(l[h+($*3|0)+2>>0]|0)|0;ca=v-(l[q+($*3|0)>>0]|0)|0;ba=w-(l[q+($*3|0)+1>>0]|0)|0;$=r-(l[q+($*3|0)+2>>0]|0)|0;Y=(k[m>>2]|0)-((ca|0)>-1?ca:0-ca|0)-((ba|0)>-1?ba:0-ba|0)-(($|0)>-1?$:0-$|0)+((_|0)>-1?_:0-_|0)+((Z|0)>-1?Z:0-Z|0)+((Y|0)>-1?Y:0-Y|0)|0;k[j>>2]=Y;k[X>>2]=Y+(k[X>>2]|0);k[m>>2]=k[j>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[J>>2]|0;m=k[z>>2]|0}e=k[U>>2]|0}}a=(a+1|0)%(k[S>>2]|0)|0;v=57}if((v|0)==57){v=0;if((e|0)>0){q=k[L>>2]|0;r=k[M>>2]|0;s=k[k[N>>2]>>2]|0;o=k[O>>2]|0;p=k[P>>2]|0;n=0;g=0;f=0;j=0;h=0;do{t=r+(aa(s,E+n+q|0)|0)|0;u=b+((aa(V,n)|0)<<2)|0;m=0;do{ca=k[p+(k[u+(m<<2)>>2]>>o<<2)>>2]|0;ba=F+m+q|0;g=g+(aa(l[t+(ba*3|0)>>0]|0,ca)|0)|0;f=f+(aa(l[t+(ba*3|0)+1>>0]|0,ca)|0)|0;j=j+(aa(l[t+(ba*3|0)+2>>0]|0,ca)|0)|0;h=ca+h|0;m=m+1|0}while((m|0)!=(e|0));n=n+1|0}while((n|0)!=(e|0));e=j}else{h=0;g=0;f=0;e=0}}ca=(h|0)/2|0;$=((g+ca|0)>>>0)/(h>>>0)|0;ba=((f+ca|0)>>>0)/(h>>>0)|0;ca=((e+ca|0)>>>0)/(h>>>0)|0;e=k[Q>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,I)|0)|0;i[e+(G*3|0)>>0]=$>>>0<256?$:($|0)>0?255:0;i[e+(G*3|0)+1>>0]=ba>>>0<256?ba:(ba|0)>0?255:0;i[e+(G*3|0)+2>>0]=ca>>>0<256?ca:(ca|0)>0?255:0;G=G+1|0;e=k[R>>2]|0}while((G|0)<(k[e+12>>2]|0))}I=I+1|0}while((I|0)!=(T|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function q1a(a){a=a|0;I0a(a);ggb(a);return}function r1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;U=k[b>>2]|0;R=k[b+4>>2]|0;S=a+76|0;T=k[S>>2]|0;c=aa(T,T)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Q=a+72|0;d=aa(aa(T,k[Q>>2]|0)|0,T)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}P=a+4|0;f=k[P>>2]|0;e=aa(aa(T,k[f+12>>2]|0)|0,T)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((U|0)<(R|0)){I=a+84|0;J=a+68|0;K=a+28|0;L=a+56|0;M=a+92|0;N=a+96|0;O=a+8|0;H=a+80|0;a=-1;G=U;e=f;do{if((k[e+12>>2]|0)>0){F=(G|0)==(U|0);E=0;do{f=k[I>>2]|0;C=G-f|0;D=E-f|0;if(!E){e=k[S>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+G|0;s=aa(T,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[Q>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(T,a)|0,T)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Q>>2]|0}while((a|0)<(e|0))}o=k[I>>2]|0;n=r-o|0;o=q-o|0;f=k[H>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+G|0;m=n+a|0;g=k[K>>2]|0;h=k[L>>2]|0;while(1){A=k[J>>2]|0;z=A+f|0;e=o+f+A|0;B=k[h>>2]|0;y=g+(aa(B,j+A|0)|0)|0;A=g+(aa(B,m+A|0)|0)|0;B=(l[y+(z<<1)>>0]|0)-(l[A+(e<<1)>>0]|0)|0;e=(l[y+(z<<1)+1>>0]|0)-(l[A+(e<<1)+1>>0]|0)|0;B=((e|0)>-1?e:0-e|0)+((B|0)>-1?B:0-B|0)|0;k[p>>2]=B+(k[p>>2]|0);e=c+((aa(aa(T,(k[H>>2]|0)+f|0)|0,T)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+B;e=k[H>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[Q>>2]|0}e=c+((aa(aa(T,e+-1|0)|0,T)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[S>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;v=57}else{a=0;h=0;g=0;f=0;e=0}}else{e=k[J>>2]|0;if(F){z=e+U|0;x=e+E+(k[H>>2]|0)|0;y=z-f|0;e=k[S>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(T,a)|0,T)|0)<<2)|0;w=d+((aa(aa(T,E)|0,T)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(T,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;B=k[H>>2]|0;e=0-B|0;if((B|0)<(e|0))e=0;else{g=k[K>>2]|0;h=k[L>>2]|0;f=e;e=0;while(1){A=k[h>>2]|0;V=g+(aa(A,f+z|0)|0)|0;A=g+(aa(A,p+f|0)|0)|0;B=(l[V+(x<<1)>>0]|0)-(l[A+(j<<1)>>0]|0)|0;A=(l[V+(x<<1)+1>>0]|0)-(l[A+(j<<1)+1>>0]|0)|0;e=((A|0)>-1?A:0-A|0)+((B|0)>-1?B:0-B|0)+e|0;k[m>>2]=e;if((f|0)<(k[H>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[S>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{V=e+G|0;w=e+E|0;j=k[H>>2]|0;h=w+j|0;B=V-f|0;w=w-f+j|0;x=k[K>>2]|0;y=k[L>>2]|0;m=k[y>>2]|0;g=x+(aa(m,V+~j|0)|0)|0;f=x+(aa(m,V+j|0)|0)|0;e=k[S>>2]|0;if((e|0)>0){z=B+-1|0;A=l[f+(h<<1)>>0]|0;u=l[f+(h<<1)+1>>0]|0;v=l[g+(h<<1)>>0]|0;r=l[g+(h<<1)+1>>0]|0;s=c+((aa(aa(T,a)|0,T)|0)<<2)|0;t=d+((aa(aa(T,E)|0,T)|0)<<2)|0;f=0;while(1){p=aa(T,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=x+(aa(m,z+f-j|0)|0)|0;h=x+(aa(m,f+B+j|0)|0)|0;g=0;do{m=o+(g<<2)|0;j=n+(g<<2)|0;k[j>>2]=(k[j>>2]|0)-(k[m>>2]|0);Y=w+g|0;V=p+(g<<2)|0;X=A-(l[h+(Y<<1)>>0]|0)|0;W=u-(l[h+(Y<<1)+1>>0]|0)|0;Z=v-(l[q+(Y<<1)>>0]|0)|0;Y=r-(l[q+(Y<<1)+1>>0]|0)|0;W=(k[V>>2]|0)-((Z|0)>-1?Z:0-Z|0)-((Y|0)>-1?Y:0-Y|0)+((X|0)>-1?X:0-X|0)+((W|0)>-1?W:0-W|0)|0;k[m>>2]=W;k[j>>2]=W+(k[j>>2]|0);k[V>>2]=k[m>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[H>>2]|0;m=k[y>>2]|0}e=k[S>>2]|0}}a=(a+1|0)%(k[Q>>2]|0)|0;v=57}if((v|0)==57){v=0;if((e|0)>0){q=k[J>>2]|0;r=k[K>>2]|0;s=k[k[L>>2]>>2]|0;o=k[M>>2]|0;p=k[N>>2]|0;n=0;g=0;j=0;h=0;f=0;do{t=r+(aa(s,C+n+q|0)|0)|0;u=b+((aa(T,n)|0)<<2)|0;m=0;do{Z=k[u+(m<<2)>>2]>>o;Y=k[p+(Z<<3)>>2]|0;Z=k[p+(Z<<3)+4>>2]|0;X=D+m+q|0;g=g+(aa(l[t+(X<<1)>>0]|0,Y)|0)|0;j=j+(aa(l[t+(X<<1)+1>>0]|0,Z)|0)|0;h=h+Y|0;f=f+Z|0;m=m+1|0}while((m|0)!=(e|0));n=n+1|0}while((n|0)!=(e|0));e=j}else{h=0;g=0;f=0;e=0}}Z=((((h|0)/2|0)+g|0)>>>0)/(h>>>0)|0;Y=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[O>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,G)|0)+(E<<1)|0;Z=((Y>>>0<256?Y:(Y|0)>0?255:0)&65535)<<8&65535|(Z>>>0<256?Z:(Z|0)>0?255:0)&255;i[e>>0]=Z;i[e+1>>0]=Z>>8;E=E+1|0;e=k[P>>2]|0}while((E|0)<(k[e+12>>2]|0))}G=G+1|0}while((G|0)!=(R|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function s1a(a){a=a|0;H0a(a);ggb(a);return}function t1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;U=k[b>>2]|0;R=k[b+4>>2]|0;S=a+76|0;T=k[S>>2]|0;c=aa(T,T)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Q=a+72|0;d=aa(aa(T,k[Q>>2]|0)|0,T)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}P=a+4|0;f=k[P>>2]|0;e=aa(aa(T,k[f+12>>2]|0)|0,T)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((U|0)<(R|0)){I=a+84|0;J=a+68|0;K=a+28|0;L=a+56|0;M=a+92|0;N=a+96|0;O=a+8|0;H=a+80|0;a=-1;G=U;e=f;do{if((k[e+12>>2]|0)>0){F=(G|0)==(U|0);E=0;do{f=k[I>>2]|0;C=G-f|0;D=E-f|0;if(!E){e=k[S>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+G|0;s=aa(T,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[Q>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(T,a)|0,T)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Q>>2]|0}while((a|0)<(e|0))}o=k[I>>2]|0;n=r-o|0;o=q-o|0;f=k[H>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+G|0;m=n+a|0;g=k[K>>2]|0;h=k[L>>2]|0;while(1){A=k[J>>2]|0;z=A+f|0;e=o+f+A|0;B=k[h>>2]|0;y=g+(aa(B,j+A|0)|0)|0;A=g+(aa(B,m+A|0)|0)|0;B=(l[y+(z<<1)>>0]|0)-(l[A+(e<<1)>>0]|0)|0;e=(l[y+(z<<1)+1>>0]|0)-(l[A+(e<<1)+1>>0]|0)|0;B=((e|0)>-1?e:0-e|0)+((B|0)>-1?B:0-B|0)|0;k[p>>2]=B+(k[p>>2]|0);e=c+((aa(aa(T,(k[H>>2]|0)+f|0)|0,T)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+B;e=k[H>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[Q>>2]|0}e=c+((aa(aa(T,e+-1|0)|0,T)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[S>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;u=57}else{a=0;g=0;f=0;e=0}}else{e=k[J>>2]|0;if(F){z=e+U|0;x=e+E+(k[H>>2]|0)|0;y=z-f|0;e=k[S>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(T,a)|0,T)|0)<<2)|0;w=d+((aa(aa(T,E)|0,T)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(T,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;B=k[H>>2]|0;e=0-B|0;if((B|0)<(e|0))e=0;else{g=k[K>>2]|0;h=k[L>>2]|0;f=e;e=0;while(1){A=k[h>>2]|0;V=g+(aa(A,f+z|0)|0)|0;A=g+(aa(A,p+f|0)|0)|0;B=(l[V+(x<<1)>>0]|0)-(l[A+(j<<1)>>0]|0)|0;A=(l[V+(x<<1)+1>>0]|0)-(l[A+(j<<1)+1>>0]|0)|0;e=((A|0)>-1?A:0-A|0)+((B|0)>-1?B:0-B|0)+e|0;k[m>>2]=e;if((f|0)<(k[H>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[S>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{V=e+G|0;w=e+E|0;j=k[H>>2]|0;h=w+j|0;B=V-f|0;w=w-f+j|0;x=k[K>>2]|0;y=k[L>>2]|0;m=k[y>>2]|0;g=x+(aa(m,V+~j|0)|0)|0;f=x+(aa(m,V+j|0)|0)|0;e=k[S>>2]|0;if((e|0)>0){z=B+-1|0;A=l[f+(h<<1)>>0]|0;u=l[f+(h<<1)+1>>0]|0;v=l[g+(h<<1)>>0]|0;r=l[g+(h<<1)+1>>0]|0;s=c+((aa(aa(T,a)|0,T)|0)<<2)|0;t=d+((aa(aa(T,E)|0,T)|0)<<2)|0;f=0;while(1){p=aa(T,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=x+(aa(m,z+f-j|0)|0)|0;h=x+(aa(m,f+B+j|0)|0)|0;g=0;do{m=o+(g<<2)|0;j=n+(g<<2)|0;k[j>>2]=(k[j>>2]|0)-(k[m>>2]|0);Y=w+g|0;V=p+(g<<2)|0;X=A-(l[h+(Y<<1)>>0]|0)|0;W=u-(l[h+(Y<<1)+1>>0]|0)|0;Z=v-(l[q+(Y<<1)>>0]|0)|0;Y=r-(l[q+(Y<<1)+1>>0]|0)|0;W=(k[V>>2]|0)-((Z|0)>-1?Z:0-Z|0)-((Y|0)>-1?Y:0-Y|0)+((X|0)>-1?X:0-X|0)+((W|0)>-1?W:0-W|0)|0;k[m>>2]=W;k[j>>2]=W+(k[j>>2]|0);k[V>>2]=k[m>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[H>>2]|0;m=k[y>>2]|0}e=k[S>>2]|0}}a=(a+1|0)%(k[Q>>2]|0)|0;u=57}if((u|0)==57){u=0;if((e|0)>0){p=k[J>>2]|0;q=k[K>>2]|0;r=k[k[L>>2]>>2]|0;n=k[M>>2]|0;o=k[N>>2]|0;m=0;f=0;h=0;g=0;do{s=q+(aa(r,C+m+p|0)|0)|0;t=b+((aa(T,m)|0)<<2)|0;j=0;do{Z=k[o+(k[t+(j<<2)>>2]>>n<<2)>>2]|0;Y=D+j+p|0;f=f+(aa(l[s+(Y<<1)>>0]|0,Z)|0)|0;h=h+(aa(l[s+(Y<<1)+1>>0]|0,Z)|0)|0;g=Z+g|0;j=j+1|0}while((j|0)!=(e|0));m=m+1|0}while((m|0)!=(e|0));e=h}else{g=0;f=0;e=0}}Y=(g|0)/2|0;Z=((f+Y|0)>>>0)/(g>>>0)|0;Y=((e+Y|0)>>>0)/(g>>>0)|0;e=k[O>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,G)|0)+(E<<1)|0;Z=((Y>>>0<256?Y:(Y|0)>0?255:0)&65535)<<8&65535|(Z>>>0<256?Z:(Z|0)>0?255:0)&255;i[e>>0]=Z;i[e+1>>0]=Z>>8;E=E+1|0;e=k[P>>2]|0}while((E|0)<(k[e+12>>2]|0))}G=G+1|0}while((G|0)!=(R|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function u1a(a){a=a|0;G0a(a);ggb(a);return}function v1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;S=k[b>>2]|0;P=k[b+4>>2]|0;Q=a+76|0;R=k[Q>>2]|0;c=aa(R,R)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}O=a+72|0;d=aa(aa(R,k[O>>2]|0)|0,R)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}N=a+4|0;f=k[N>>2]|0;e=aa(aa(R,k[f+12>>2]|0)|0,R)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((S|0)<(P|0)){G=a+84|0;H=a+68|0;I=a+28|0;J=a+56|0;K=a+92|0;L=a+96|0;M=a+8|0;F=a+80|0;a=-1;E=S;e=f;do{if((k[e+12>>2]|0)>0){D=(E|0)==(S|0);C=0;do{h=k[G>>2]|0;A=E-h|0;B=C-h|0;if(!C){e=k[Q>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+E|0;s=aa(R,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[O>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(R,a)|0,R)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[O>>2]|0}while((a|0)<(e|0))}o=k[G>>2]|0;n=r-o|0;o=q-o|0;f=k[F>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+E|0;m=n+a|0;g=k[I>>2]|0;h=k[J>>2]|0;while(1){z=k[H>>2]|0;y=k[h>>2]|0;e=g+(aa(y,j+z|0)|0)+(z+f)|0;z=g+(aa(y,m+z|0)|0)+(o+f+z)|0;z=(l[e>>0]|0)-(l[z>>0]|0)|0;z=(z|0)>-1?z:0-z|0;k[p>>2]=z+(k[p>>2]|0);e=c+((aa(aa(R,(k[F>>2]|0)+f|0)|0,R)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+z;e=k[F>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[O>>2]|0}e=c+((aa(aa(R,e+-1|0)|0,R)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[Q>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;j=e;t=57}else{a=0;f=0;e=0}}else{e=k[H>>2]|0;if(D){z=e+S|0;x=e+C+(k[F>>2]|0)|0;y=z-h|0;e=k[Q>>2]|0;if((e|0)>0){u=x-h|0;v=c+((aa(aa(R,a)|0,R)|0)<<2)|0;w=d+((aa(aa(R,C)|0,R)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(R,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;h=k[F>>2]|0;e=0-h|0;if((h|0)<(e|0))e=0;else{g=k[I>>2]|0;h=k[J>>2]|0;f=e;e=0;while(1){T=k[h>>2]|0;U=g+(aa(T,f+z|0)|0)+x|0;T=g+(aa(T,p+f|0)|0)+j|0;T=(l[U>>0]|0)-(l[T>>0]|0)|0;e=e+((T|0)>-1?T:0-T|0)|0;k[m>>2]=e;if((f|0)<(k[F>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[Q>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{g=e+E|0;v=e+C|0;j=k[F>>2]|0;f=v+j|0;y=g-h|0;v=v-h+j|0;w=k[I>>2]|0;x=k[J>>2]|0;h=k[x>>2]|0;e=k[Q>>2]|0;if((e|0)>0){r=w+(aa(h,g+j|0)|0)+f|0;s=w+(aa(h,g+~j|0)|0)+f|0;q=y+-1|0;r=l[r>>0]|0;s=l[s>>0]|0;t=c+((aa(aa(R,a)|0,R)|0)<<2)|0;u=d+((aa(aa(R,C)|0,R)|0)<<2)|0;f=0;while(1){o=aa(R,f)|0;m=b+(o<<2)|0;n=t+(o<<2)|0;o=u+(o<<2)|0;p=w+(aa(h,q+f-j|0)|0)|0;h=w+(aa(h,f+y+j|0)|0)|0;g=0;do{T=n+(g<<2)|0;z=m+(g<<2)|0;k[z>>2]=(k[z>>2]|0)-(k[T>>2]|0);j=v+g|0;U=o+(g<<2)|0;V=r-(l[h+j>>0]|0)|0;j=s-(l[p+j>>0]|0)|0;j=((V|0)>-1?V:0-V|0)-((j|0)>-1?j:0-j|0)+(k[U>>2]|0)|0;k[T>>2]=j;k[z>>2]=j+(k[z>>2]|0);k[U>>2]=k[T>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[F>>2]|0;h=k[x>>2]|0}e=k[Q>>2]|0}}a=(a+1|0)%(k[O>>2]|0)|0;j=e;t=57}if((t|0)==57){t=0;if((j|0)>0){o=k[H>>2]|0;p=k[I>>2]|0;q=k[k[J>>2]>>2]|0;m=k[K>>2]|0;n=k[L>>2]|0;h=0;f=0;e=0;do{r=p+(aa(q,A+h+o|0)|0)|0;s=b+((aa(R,h)|0)<<2)|0;g=0;do{V=k[n+(k[s+(g<<2)>>2]>>m<<2)>>2]|0;e=(aa(l[r+(B+g+o)>>0]|0,V)|0)+e|0;f=V+f|0;g=g+1|0}while((g|0)!=(j|0));h=h+1|0}while((h|0)!=(j|0))}else{f=0;e=0}}V=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[M>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,E)|0)+C|0;i[e>>0]=V>>>0<256?V:(V|0)>0?255:0;C=C+1|0;e=k[N>>2]|0}while((C|0)<(k[e+12>>2]|0))}E=E+1|0}while((E|0)!=(P|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function w1a(a){a=a|0;F0a(a);ggb(a);return}function x1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;Y=k[b>>2]|0;V=k[b+4>>2]|0;W=a+76|0;X=k[W>>2]|0;c=aa(X,X)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}U=a+72|0;d=aa(aa(X,k[U>>2]|0)|0,X)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}T=a+4|0;f=k[T>>2]|0;e=aa(aa(X,k[f+12>>2]|0)|0,X)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Y|0)<(V|0)){M=a+84|0;N=a+68|0;O=a+28|0;P=a+56|0;Q=a+92|0;R=a+96|0;S=a+8|0;L=a+80|0;a=-1;K=Y;e=f;do{if((k[e+12>>2]|0)>0){J=(K|0)==(Y|0);I=0;do{f=k[M>>2]|0;G=K-f|0;H=I-f|0;if(!I){e=k[W>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+K|0;s=aa(X,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[U>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(X,a)|0,X)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[U>>2]|0}while((a|0)<(e|0))}o=k[M>>2]|0;n=r-o|0;o=q-o|0;f=k[L>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+K|0;m=n+a|0;g=k[O>>2]|0;h=k[P>>2]|0;while(1){C=k[N>>2]|0;B=C+f|0;F=o+f+C|0;E=k[h>>2]|0;A=g+(aa(E,j+C|0)|0)|0;C=g+(aa(E,m+C|0)|0)|0;E=(l[A+(B<<2)>>0]|0)-(l[C+(F<<2)>>0]|0)|0;D=(l[A+(B<<2)+1>>0]|0)-(l[C+(F<<2)+1>>0]|0)|0;e=(l[A+(B<<2)+2>>0]|0)-(l[C+(F<<2)+2>>0]|0)|0;F=(l[A+(B<<2)+3>>0]|0)-(l[C+(F<<2)+3>>0]|0)|0;F=(aa(D,D)|0)+(aa(E,E)|0)+(aa(e,e)|0)+(aa(F,F)|0)|0;k[p>>2]=F+(k[p>>2]|0);e=c+((aa(aa(X,(k[L>>2]|0)+f|0)|0,X)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+F;e=k[L>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[U>>2]|0}e=c+((aa(aa(X,e+-1|0)|0,X)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[W>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;z=57}else{a=0;o=0;n=0;m=0;j=0;h=0;g=0;f=0;e=0}}else{e=k[N>>2]|0;if(J){z=e+Y|0;x=e+I+(k[L>>2]|0)|0;y=z-f|0;e=k[W>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(X,a)|0,X)|0)<<2)|0;w=d+((aa(aa(X,I)|0,X)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(X,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;F=k[L>>2]|0;e=0-F|0;if((F|0)<(e|0))e=0;else{g=k[O>>2]|0;h=k[P>>2]|0;f=e;e=0;while(1){F=k[h>>2]|0;B=g+(aa(F,f+z|0)|0)|0;F=g+(aa(F,p+f|0)|0)|0;D=(l[B+(x<<2)>>0]|0)-(l[F+(j<<2)>>0]|0)|0;C=(l[B+(x<<2)+1>>0]|0)-(l[F+(j<<2)+1>>0]|0)|0;E=(l[B+(x<<2)+2>>0]|0)-(l[F+(j<<2)+2>>0]|0)|0;F=(l[B+(x<<2)+3>>0]|0)-(l[F+(j<<2)+3>>0]|0)|0;e=(aa(C,C)|0)+(aa(D,D)|0)+(aa(E,E)|0)+(aa(F,F)|0)+e|0;k[m>>2]=e;if((f|0)<(k[L>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[W>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{E=e+K|0;y=e+I|0;j=k[L>>2]|0;h=y+j|0;F=E-f|0;y=y-f+j|0;z=k[O>>2]|0;A=k[P>>2]|0;m=k[A>>2]|0;g=z+(aa(m,E+~j|0)|0)|0;f=z+(aa(m,E+j|0)|0)|0;e=k[W>>2]|0;if((e|0)>0){B=F+-1|0;C=l[f+(h<<2)>>0]|0;D=l[f+(h<<2)+1>>0]|0;E=l[f+(h<<2)+2>>0]|0;u=l[f+(h<<2)+3>>0]|0;v=l[g+(h<<2)>>0]|0;w=l[g+(h<<2)+1>>0]|0;x=l[g+(h<<2)+2>>0]|0;r=l[g+(h<<2)+3>>0]|0;s=c+((aa(aa(X,a)|0,X)|0)<<2)|0;t=d+((aa(aa(X,I)|0,X)|0)<<2)|0;f=0;while(1){p=aa(X,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=z+(aa(m,B+f-j|0)|0)|0;h=z+(aa(m,f+F+j|0)|0)|0;g=0;do{j=o+(g<<2)|0;Z=n+(g<<2)|0;k[Z>>2]=(k[Z>>2]|0)-(k[j>>2]|0);_=y+g|0;m=p+(g<<2)|0;ga=C-(l[h+(_<<2)>>0]|0)|0;fa=D-(l[h+(_<<2)+1>>0]|0)|0;ea=E-(l[h+(_<<2)+2>>0]|0)|0;da=u-(l[h+(_<<2)+3>>0]|0)|0;ba=v-(l[q+(_<<2)>>0]|0)|0;ca=w-(l[q+(_<<2)+1>>0]|0)|0;$=x-(l[q+(_<<2)+2>>0]|0)|0;_=r-(l[q+(_<<2)+3>>0]|0)|0;_=(aa(ga,ga)|0)+(k[m>>2]|0)+(aa(fa,fa)|0)+(aa(ea,ea)|0)+(aa(da,da)|0)-((aa(ca,ca)|0)+(aa(ba,ba)|0)+(aa($,$)|0)+(aa(_,_)|0))|0;k[j>>2]=_;k[Z>>2]=_+(k[Z>>2]|0);k[m>>2]=k[j>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[L>>2]|0;m=k[A>>2]|0}e=k[W>>2]|0}}a=(a+1|0)%(k[U>>2]|0)|0;z=57}if((z|0)==57){z=0;if((e|0)>0){u=k[N>>2]|0;v=k[O>>2]|0;w=k[k[P>>2]>>2]|0;s=k[Q>>2]|0;t=k[R>>2]|0;r=0;n=0;j=0;g=0;p=0;o=0;m=0;h=0;f=0;do{x=v+(aa(w,G+r+u|0)|0)|0;y=b+((aa(X,r)|0)<<2)|0;q=0;do{ga=k[y+(q<<2)>>2]>>s;da=k[t+(ga<<4)>>2]|0;ea=k[t+(ga<<4)+4>>2]|0;fa=k[t+(ga<<4)+8>>2]|0;ga=k[t+(ga<<4)+12>>2]|0;ca=H+q+u|0;n=n+(aa(l[x+(ca<<2)>>0]|0,da)|0)|0;j=j+(aa(l[x+(ca<<2)+1>>0]|0,ea)|0)|0;g=g+(aa(l[x+(ca<<2)+2>>0]|0,fa)|0)|0;p=p+(aa(l[x+(ca<<2)+3>>0]|0,ga)|0)|0;o=o+da|0;m=m+ea|0;h=h+fa|0;f=f+ga|0;q=q+1|0}while((q|0)!=(e|0));r=r+1|0}while((r|0)!=(e|0));e=p}else{o=0;n=0;m=0;j=0;h=0;g=0;f=0;e=0}}da=((((o|0)/2|0)+n|0)>>>0)/(o>>>0)|0;fa=((((m|0)/2|0)+j|0)>>>0)/(m>>>0)|0;ga=((((h|0)/2|0)+g|0)>>>0)/(h>>>0)|0;ea=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[S>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,K)|0)+(I<<2)|0;ga=(da>>>0<256?da:(da|0)>0?255:0)&255|(ea>>>0<256?ea:(ea|0)>0?255:0)<<24|(fa>>>0<256?fa:(fa|0)>0?255:0)<<8&65280|(ga>>>0<256?ga:(ga|0)>0?255:0)<<16&16711680;i[e>>0]=ga;i[e+1>>0]=ga>>8;i[e+2>>0]=ga>>16;i[e+3>>0]=ga>>24;I=I+1|0;e=k[T>>2]|0}while((I|0)<(k[e+12>>2]|0))}K=K+1|0}while((K|0)!=(V|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function y1a(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0.0,f=0.0,g=0.0,h=0;f=-b;e=+(d|0);g=e*.001;b=+o[c>>2];b=+Z(+(f/(b*b*4.0)));p[u>>3]=b;d=k[u+4>>2]&2147483647;b=e*(d>>>0>2146435072|(d|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:b);p[u>>3]=b;d=k[u+4>>2]|0;h=d&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(b==0.0)b=d?-0.0:0.0}d=~~b;k[a>>2]=+(d|0)<g?0:d;b=+o[c+4>>2];b=+Z(+(f/(b*b*4.0)));p[u>>3]=b;d=k[u+4>>2]&2147483647;b=e*(d>>>0>2146435072|(d|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:b);p[u>>3]=b;d=k[u+4>>2]|0;h=d&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(b==0.0)b=d?-0.0:0.0}d=~~b;k[a+4>>2]=+(d|0)<g?0:d;b=+o[c+8>>2];b=+Z(+(f/(b*b*4.0)));p[u>>3]=b;d=k[u+4>>2]&2147483647;b=e*(d>>>0>2146435072|(d|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:b);p[u>>3]=b;d=k[u+4>>2]|0;h=d&2146435072;if(!(h>>>0>1126170624|(h|0)==1126170624&0>0)){d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(b==0.0)b=d?-0.0:0.0}d=~~b;k[a+8>>2]=+(d|0)<g?0:d;b=+o[c+12>>2];b=+Z(+(f/(b*b*4.0)));p[u>>3]=b;d=k[u+4>>2]&2147483647;b=e*(d>>>0>2146435072|(d|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:b);p[u>>3]=b;d=k[u+4>>2]|0;h=d&2146435072;if(h>>>0>1126170624|(h|0)==1126170624&0>0){f=b;c=~~f;f=+(c|0);h=f<g;c=h?0:c;h=a+12|0;k[h>>2]=c;return}d=(d|0)<0;b=d?b+-4503599627370496.0+4503599627370496.0:b+4503599627370496.0+-4503599627370496.0;if(!(b==0.0)){f=b;c=~~f;f=+(c|0);h=f<g;c=h?0:c;h=a+12|0;k[h>>2]=c;return}f=d?-0.0:0.0;c=~~f;f=+(c|0);h=f<g;c=h?0:c;h=a+12|0;k[h>>2]=c;return}function z1a(a){a=a|0;E0a(a);ggb(a);return}function A1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;Y=k[b>>2]|0;V=k[b+4>>2]|0;W=a+76|0;X=k[W>>2]|0;c=aa(X,X)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}U=a+72|0;d=aa(aa(X,k[U>>2]|0)|0,X)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}T=a+4|0;f=k[T>>2]|0;e=aa(aa(X,k[f+12>>2]|0)|0,X)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Y|0)<(V|0)){M=a+84|0;N=a+68|0;O=a+28|0;P=a+56|0;Q=a+92|0;R=a+96|0;S=a+8|0;L=a+80|0;a=-1;K=Y;e=f;do{if((k[e+12>>2]|0)>0){J=(K|0)==(Y|0);I=0;do{f=k[M>>2]|0;G=K-f|0;H=I-f|0;if(!I){e=k[W>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+K|0;s=aa(X,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[U>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(X,a)|0,X)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[U>>2]|0}while((a|0)<(e|0))}o=k[M>>2]|0;n=r-o|0;o=q-o|0;f=k[L>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+K|0;m=n+a|0;g=k[O>>2]|0;h=k[P>>2]|0;while(1){C=k[N>>2]|0;B=C+f|0;F=o+f+C|0;E=k[h>>2]|0;A=g+(aa(E,j+C|0)|0)|0;C=g+(aa(E,m+C|0)|0)|0;E=(l[A+(B<<2)>>0]|0)-(l[C+(F<<2)>>0]|0)|0;D=(l[A+(B<<2)+1>>0]|0)-(l[C+(F<<2)+1>>0]|0)|0;e=(l[A+(B<<2)+2>>0]|0)-(l[C+(F<<2)+2>>0]|0)|0;F=(l[A+(B<<2)+3>>0]|0)-(l[C+(F<<2)+3>>0]|0)|0;F=(aa(D,D)|0)+(aa(E,E)|0)+(aa(e,e)|0)+(aa(F,F)|0)|0;k[p>>2]=F+(k[p>>2]|0);e=c+((aa(aa(X,(k[L>>2]|0)+f|0)|0,X)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+F;e=k[L>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[U>>2]|0}e=c+((aa(aa(X,e+-1|0)|0,X)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[W>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;w=57}else{a=0;j=0;h=0;g=0;f=0;e=0}}else{e=k[N>>2]|0;if(J){z=e+Y|0;x=e+I+(k[L>>2]|0)|0;y=z-f|0;e=k[W>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(X,a)|0,X)|0)<<2)|0;w=d+((aa(aa(X,I)|0,X)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(X,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;F=k[L>>2]|0;e=0-F|0;if((F|0)<(e|0))e=0;else{g=k[O>>2]|0;h=k[P>>2]|0;f=e;e=0;while(1){F=k[h>>2]|0;B=g+(aa(F,f+z|0)|0)|0;F=g+(aa(F,p+f|0)|0)|0;D=(l[B+(x<<2)>>0]|0)-(l[F+(j<<2)>>0]|0)|0;C=(l[B+(x<<2)+1>>0]|0)-(l[F+(j<<2)+1>>0]|0)|0;E=(l[B+(x<<2)+2>>0]|0)-(l[F+(j<<2)+2>>0]|0)|0;F=(l[B+(x<<2)+3>>0]|0)-(l[F+(j<<2)+3>>0]|0)|0;e=(aa(C,C)|0)+(aa(D,D)|0)+(aa(E,E)|0)+(aa(F,F)|0)+e|0;k[m>>2]=e;if((f|0)<(k[L>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[W>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{E=e+K|0;y=e+I|0;j=k[L>>2]|0;h=y+j|0;F=E-f|0;y=y-f+j|0;z=k[O>>2]|0;A=k[P>>2]|0;m=k[A>>2]|0;g=z+(aa(m,E+~j|0)|0)|0;f=z+(aa(m,E+j|0)|0)|0;e=k[W>>2]|0;if((e|0)>0){B=F+-1|0;C=l[f+(h<<2)>>0]|0;D=l[f+(h<<2)+1>>0]|0;E=l[f+(h<<2)+2>>0]|0;u=l[f+(h<<2)+3>>0]|0;v=l[g+(h<<2)>>0]|0;w=l[g+(h<<2)+1>>0]|0;x=l[g+(h<<2)+2>>0]|0;r=l[g+(h<<2)+3>>0]|0;s=c+((aa(aa(X,a)|0,X)|0)<<2)|0;t=d+((aa(aa(X,I)|0,X)|0)<<2)|0;f=0;while(1){p=aa(X,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=z+(aa(m,B+f-j|0)|0)|0;h=z+(aa(m,f+F+j|0)|0)|0;g=0;do{j=o+(g<<2)|0;Z=n+(g<<2)|0;k[Z>>2]=(k[Z>>2]|0)-(k[j>>2]|0);_=y+g|0;m=p+(g<<2)|0;ga=C-(l[h+(_<<2)>>0]|0)|0;fa=D-(l[h+(_<<2)+1>>0]|0)|0;ea=E-(l[h+(_<<2)+2>>0]|0)|0;da=u-(l[h+(_<<2)+3>>0]|0)|0;ba=v-(l[q+(_<<2)>>0]|0)|0;ca=w-(l[q+(_<<2)+1>>0]|0)|0;$=x-(l[q+(_<<2)+2>>0]|0)|0;_=r-(l[q+(_<<2)+3>>0]|0)|0;_=(aa(ga,ga)|0)+(k[m>>2]|0)+(aa(fa,fa)|0)+(aa(ea,ea)|0)+(aa(da,da)|0)-((aa(ca,ca)|0)+(aa(ba,ba)|0)+(aa($,$)|0)+(aa(_,_)|0))|0;k[j>>2]=_;k[Z>>2]=_+(k[Z>>2]|0);k[m>>2]=k[j>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[L>>2]|0;m=k[A>>2]|0}e=k[W>>2]|0}}a=(a+1|0)%(k[U>>2]|0)|0;w=57}if((w|0)==57){w=0;if((e|0)>0){r=k[N>>2]|0;s=k[O>>2]|0;t=k[k[P>>2]>>2]|0;p=k[Q>>2]|0;q=k[R>>2]|0;o=0;h=0;g=0;f=0;m=0;j=0;do{u=s+(aa(t,G+o+r|0)|0)|0;v=b+((aa(X,o)|0)<<2)|0;n=0;do{ga=k[q+(k[v+(n<<2)>>2]>>p<<2)>>2]|0;fa=H+n+r|0;h=h+(aa(l[u+(fa<<2)>>0]|0,ga)|0)|0;g=g+(aa(l[u+(fa<<2)+1>>0]|0,ga)|0)|0;f=f+(aa(l[u+(fa<<2)+2>>0]|0,ga)|0)|0;m=m+(aa(l[u+(fa<<2)+3>>0]|0,ga)|0)|0;j=ga+j|0;n=n+1|0}while((n|0)!=(e|0));o=o+1|0}while((o|0)!=(e|0));e=m}else{j=0;h=0;g=0;f=0;e=0}}ea=(j|0)/2|0;da=((h+ea|0)>>>0)/(j>>>0)|0;fa=((g+ea|0)>>>0)/(j>>>0)|0;ga=((f+ea|0)>>>0)/(j>>>0)|0;ea=((e+ea|0)>>>0)/(j>>>0)|0;e=k[S>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,K)|0)+(I<<2)|0;ga=(da>>>0<256?da:(da|0)>0?255:0)&255|(ea>>>0<256?ea:(ea|0)>0?255:0)<<24|(fa>>>0<256?fa:(fa|0)>0?255:0)<<8&65280|(ga>>>0<256?ga:(ga|0)>0?255:0)<<16&16711680;i[e>>0]=ga;i[e+1>>0]=ga>>8;i[e+2>>0]=ga>>16;i[e+3>>0]=ga>>24;I=I+1|0;e=k[T>>2]|0}while((I|0)<(k[e+12>>2]|0))}K=K+1|0}while((K|0)!=(V|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function B1a(a){a=a|0;D0a(a);ggb(a);return}function C1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0;W=k[b>>2]|0;T=k[b+4>>2]|0;U=a+76|0;V=k[U>>2]|0;c=aa(V,V)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}S=a+72|0;d=aa(aa(V,k[S>>2]|0)|0,V)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}R=a+4|0;f=k[R>>2]|0;e=aa(aa(V,k[f+12>>2]|0)|0,V)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((W|0)<(T|0)){K=a+84|0;L=a+68|0;M=a+28|0;N=a+56|0;O=a+92|0;P=a+96|0;Q=a+8|0;J=a+80|0;a=-1;I=W;e=f;do{if((k[e+12>>2]|0)>0){H=(I|0)==(W|0);G=0;do{f=k[K>>2]|0;E=I-f|0;F=G-f|0;if(!G){e=k[U>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+I|0;s=aa(V,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[S>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(V,a)|0,V)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[S>>2]|0}while((a|0)<(e|0))}o=k[K>>2]|0;n=r-o|0;o=q-o|0;f=k[J>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+I|0;m=n+a|0;g=k[M>>2]|0;h=k[N>>2]|0;while(1){B=k[L>>2]|0;A=B+f|0;D=o+f+B|0;e=k[h>>2]|0;z=g+(aa(e,j+B|0)|0)|0;B=g+(aa(e,m+B|0)|0)|0;e=(l[z+(A*3|0)>>0]|0)-(l[B+(D*3|0)>>0]|0)|0;C=(l[z+(A*3|0)+1>>0]|0)-(l[B+(D*3|0)+1>>0]|0)|0;D=(l[z+(A*3|0)+2>>0]|0)-(l[B+(D*3|0)+2>>0]|0)|0;D=(aa(C,C)|0)+(aa(e,e)|0)+(aa(D,D)|0)|0;k[p>>2]=D+(k[p>>2]|0);e=c+((aa(aa(V,(k[J>>2]|0)+f|0)|0,V)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+D;e=k[J>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[S>>2]|0}e=c+((aa(aa(V,e+-1|0)|0,V)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[U>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;x=57}else{a=0;m=0;j=0;h=0;g=0;f=0;e=0}}else{e=k[L>>2]|0;if(H){z=e+W|0;x=e+G+(k[J>>2]|0)|0;y=z-f|0;e=k[U>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(V,a)|0,V)|0)<<2)|0;w=d+((aa(aa(V,G)|0,V)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(V,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;D=k[J>>2]|0;e=0-D|0;if((D|0)<(e|0))e=0;else{g=k[M>>2]|0;h=k[N>>2]|0;f=e;e=0;while(1){D=k[h>>2]|0;A=g+(aa(D,f+z|0)|0)|0;D=g+(aa(D,p+f|0)|0)|0;C=(l[A+(x*3|0)>>0]|0)-(l[D+(j*3|0)>>0]|0)|0;B=(l[A+(x*3|0)+1>>0]|0)-(l[D+(j*3|0)+1>>0]|0)|0;D=(l[A+(x*3|0)+2>>0]|0)-(l[D+(j*3|0)+2>>0]|0)|0;e=(aa(B,B)|0)+(aa(C,C)|0)+(aa(D,D)|0)+e|0;k[m>>2]=e;if((f|0)<(k[J>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[U>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{C=e+I|0;x=e+G|0;j=k[J>>2]|0;h=x+j|0;D=C-f|0;x=x-f+j|0;y=k[M>>2]|0;z=k[N>>2]|0;m=k[z>>2]|0;g=y+(aa(m,C+~j|0)|0)|0;f=y+(aa(m,C+j|0)|0)|0;e=k[U>>2]|0;if((e|0)>0){A=D+-1|0;B=l[f+(h*3|0)>>0]|0;C=l[f+(h*3|0)+1>>0]|0;u=l[f+(h*3|0)+2>>0]|0;v=l[g+(h*3|0)>>0]|0;w=l[g+(h*3|0)+1>>0]|0;r=l[g+(h*3|0)+2>>0]|0;s=c+((aa(aa(V,a)|0,V)|0)<<2)|0;t=d+((aa(aa(V,G)|0,V)|0)<<2)|0;f=0;while(1){p=aa(V,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=y+(aa(m,A+f-j|0)|0)|0;h=y+(aa(m,f+D+j|0)|0)|0;g=0;do{j=o+(g<<2)|0;X=n+(g<<2)|0;k[X>>2]=(k[X>>2]|0)-(k[j>>2]|0);Y=x+g|0;m=p+(g<<2)|0;ca=B-(l[h+(Y*3|0)>>0]|0)|0;ba=C-(l[h+(Y*3|0)+1>>0]|0)|0;$=u-(l[h+(Y*3|0)+2>>0]|0)|0;Z=v-(l[q+(Y*3|0)>>0]|0)|0;_=w-(l[q+(Y*3|0)+1>>0]|0)|0;Y=r-(l[q+(Y*3|0)+2>>0]|0)|0;Y=(aa(ca,ca)|0)+(k[m>>2]|0)+(aa(ba,ba)|0)+(aa($,$)|0)-((aa(_,_)|0)+(aa(Z,Z)|0)+(aa(Y,Y)|0))|0;k[j>>2]=Y;k[X>>2]=Y+(k[X>>2]|0);k[m>>2]=k[j>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[J>>2]|0;m=k[z>>2]|0}e=k[U>>2]|0}}a=(a+1|0)%(k[S>>2]|0)|0;x=57}if((x|0)==57){x=0;if((e|0)>0){s=k[L>>2]|0;t=k[M>>2]|0;u=k[k[N>>2]>>2]|0;q=k[O>>2]|0;r=k[P>>2]|0;p=0;j=0;g=0;n=0;m=0;h=0;f=0;do{v=t+(aa(u,E+p+s|0)|0)|0;w=b+((aa(V,p)|0)<<2)|0;o=0;do{ca=k[w+(o<<2)>>2]>>q;$=k[r+(ca*12|0)>>2]|0;ba=k[r+(ca*12|0)+4>>2]|0;ca=k[r+(ca*12|0)+8>>2]|0;_=F+o+s|0;j=j+(aa(l[v+(_*3|0)>>0]|0,$)|0)|0;g=g+(aa(l[v+(_*3|0)+1>>0]|0,ba)|0)|0;n=n+(aa(l[v+(_*3|0)+2>>0]|0,ca)|0)|0;m=m+$|0;h=h+ba|0;f=f+ca|0;o=o+1|0}while((o|0)!=(e|0));p=p+1|0}while((p|0)!=(e|0));e=n}else{m=0;j=0;h=0;g=0;f=0;e=0}}$=((((m|0)/2|0)+j|0)>>>0)/(m>>>0)|0;ba=((((h|0)/2|0)+g|0)>>>0)/(h>>>0)|0;ca=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[Q>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,I)|0)|0;i[e+(G*3|0)>>0]=$>>>0<256?$:($|0)>0?255:0;i[e+(G*3|0)+1>>0]=ba>>>0<256?ba:(ba|0)>0?255:0;i[e+(G*3|0)+2>>0]=ca>>>0<256?ca:(ca|0)>0?255:0;G=G+1|0;e=k[R>>2]|0}while((G|0)<(k[e+12>>2]|0))}I=I+1|0}while((I|0)!=(T|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function D1a(a){a=a|0;C0a(a);ggb(a);return}function E1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0;W=k[b>>2]|0;T=k[b+4>>2]|0;U=a+76|0;V=k[U>>2]|0;c=aa(V,V)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}S=a+72|0;d=aa(aa(V,k[S>>2]|0)|0,V)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}R=a+4|0;f=k[R>>2]|0;e=aa(aa(V,k[f+12>>2]|0)|0,V)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((W|0)<(T|0)){K=a+84|0;L=a+68|0;M=a+28|0;N=a+56|0;O=a+92|0;P=a+96|0;Q=a+8|0;J=a+80|0;a=-1;I=W;e=f;do{if((k[e+12>>2]|0)>0){H=(I|0)==(W|0);G=0;do{f=k[K>>2]|0;E=I-f|0;F=G-f|0;if(!G){e=k[U>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+I|0;s=aa(V,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[S>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(V,a)|0,V)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[S>>2]|0}while((a|0)<(e|0))}o=k[K>>2]|0;n=r-o|0;o=q-o|0;f=k[J>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+I|0;m=n+a|0;g=k[M>>2]|0;h=k[N>>2]|0;while(1){B=k[L>>2]|0;A=B+f|0;D=o+f+B|0;e=k[h>>2]|0;z=g+(aa(e,j+B|0)|0)|0;B=g+(aa(e,m+B|0)|0)|0;e=(l[z+(A*3|0)>>0]|0)-(l[B+(D*3|0)>>0]|0)|0;C=(l[z+(A*3|0)+1>>0]|0)-(l[B+(D*3|0)+1>>0]|0)|0;D=(l[z+(A*3|0)+2>>0]|0)-(l[B+(D*3|0)+2>>0]|0)|0;D=(aa(C,C)|0)+(aa(e,e)|0)+(aa(D,D)|0)|0;k[p>>2]=D+(k[p>>2]|0);e=c+((aa(aa(V,(k[J>>2]|0)+f|0)|0,V)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+D;e=k[J>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[S>>2]|0}e=c+((aa(aa(V,e+-1|0)|0,V)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[U>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;v=57}else{a=0;h=0;g=0;f=0;e=0}}else{e=k[L>>2]|0;if(H){z=e+W|0;x=e+G+(k[J>>2]|0)|0;y=z-f|0;e=k[U>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(V,a)|0,V)|0)<<2)|0;w=d+((aa(aa(V,G)|0,V)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(V,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;D=k[J>>2]|0;e=0-D|0;if((D|0)<(e|0))e=0;else{g=k[M>>2]|0;h=k[N>>2]|0;f=e;e=0;while(1){D=k[h>>2]|0;A=g+(aa(D,f+z|0)|0)|0;D=g+(aa(D,p+f|0)|0)|0;C=(l[A+(x*3|0)>>0]|0)-(l[D+(j*3|0)>>0]|0)|0;B=(l[A+(x*3|0)+1>>0]|0)-(l[D+(j*3|0)+1>>0]|0)|0;D=(l[A+(x*3|0)+2>>0]|0)-(l[D+(j*3|0)+2>>0]|0)|0;e=(aa(B,B)|0)+(aa(C,C)|0)+(aa(D,D)|0)+e|0;k[m>>2]=e;if((f|0)<(k[J>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[U>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{C=e+I|0;x=e+G|0;j=k[J>>2]|0;h=x+j|0;D=C-f|0;x=x-f+j|0;y=k[M>>2]|0;z=k[N>>2]|0;m=k[z>>2]|0;g=y+(aa(m,C+~j|0)|0)|0;f=y+(aa(m,C+j|0)|0)|0;e=k[U>>2]|0;if((e|0)>0){A=D+-1|0;B=l[f+(h*3|0)>>0]|0;C=l[f+(h*3|0)+1>>0]|0;u=l[f+(h*3|0)+2>>0]|0;v=l[g+(h*3|0)>>0]|0;w=l[g+(h*3|0)+1>>0]|0;r=l[g+(h*3|0)+2>>0]|0;s=c+((aa(aa(V,a)|0,V)|0)<<2)|0;t=d+((aa(aa(V,G)|0,V)|0)<<2)|0;f=0;while(1){p=aa(V,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=y+(aa(m,A+f-j|0)|0)|0;h=y+(aa(m,f+D+j|0)|0)|0;g=0;do{j=o+(g<<2)|0;X=n+(g<<2)|0;k[X>>2]=(k[X>>2]|0)-(k[j>>2]|0);Y=x+g|0;m=p+(g<<2)|0;ca=B-(l[h+(Y*3|0)>>0]|0)|0;ba=C-(l[h+(Y*3|0)+1>>0]|0)|0;$=u-(l[h+(Y*3|0)+2>>0]|0)|0;Z=v-(l[q+(Y*3|0)>>0]|0)|0;_=w-(l[q+(Y*3|0)+1>>0]|0)|0;Y=r-(l[q+(Y*3|0)+2>>0]|0)|0;Y=(aa(ca,ca)|0)+(k[m>>2]|0)+(aa(ba,ba)|0)+(aa($,$)|0)-((aa(_,_)|0)+(aa(Z,Z)|0)+(aa(Y,Y)|0))|0;k[j>>2]=Y;k[X>>2]=Y+(k[X>>2]|0);k[m>>2]=k[j>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[J>>2]|0;m=k[z>>2]|0}e=k[U>>2]|0}}a=(a+1|0)%(k[S>>2]|0)|0;v=57}if((v|0)==57){v=0;if((e|0)>0){q=k[L>>2]|0;r=k[M>>2]|0;s=k[k[N>>2]>>2]|0;o=k[O>>2]|0;p=k[P>>2]|0;n=0;g=0;f=0;j=0;h=0;do{t=r+(aa(s,E+n+q|0)|0)|0;u=b+((aa(V,n)|0)<<2)|0;m=0;do{ca=k[p+(k[u+(m<<2)>>2]>>o<<2)>>2]|0;ba=F+m+q|0;g=g+(aa(l[t+(ba*3|0)>>0]|0,ca)|0)|0;f=f+(aa(l[t+(ba*3|0)+1>>0]|0,ca)|0)|0;j=j+(aa(l[t+(ba*3|0)+2>>0]|0,ca)|0)|0;h=ca+h|0;m=m+1|0}while((m|0)!=(e|0));n=n+1|0}while((n|0)!=(e|0));e=j}else{h=0;g=0;f=0;e=0}}ca=(h|0)/2|0;$=((g+ca|0)>>>0)/(h>>>0)|0;ba=((f+ca|0)>>>0)/(h>>>0)|0;ca=((e+ca|0)>>>0)/(h>>>0)|0;e=k[Q>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,I)|0)|0;i[e+(G*3|0)>>0]=$>>>0<256?$:($|0)>0?255:0;i[e+(G*3|0)+1>>0]=ba>>>0<256?ba:(ba|0)>0?255:0;i[e+(G*3|0)+2>>0]=ca>>>0<256?ca:(ca|0)>0?255:0;G=G+1|0;e=k[R>>2]|0}while((G|0)<(k[e+12>>2]|0))}I=I+1|0}while((I|0)!=(T|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function F1a(a){a=a|0;B0a(a);ggb(a);return}function G1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;U=k[b>>2]|0;R=k[b+4>>2]|0;S=a+76|0;T=k[S>>2]|0;c=aa(T,T)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Q=a+72|0;d=aa(aa(T,k[Q>>2]|0)|0,T)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}P=a+4|0;f=k[P>>2]|0;e=aa(aa(T,k[f+12>>2]|0)|0,T)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((U|0)<(R|0)){I=a+84|0;J=a+68|0;K=a+28|0;L=a+56|0;M=a+92|0;N=a+96|0;O=a+8|0;H=a+80|0;a=-1;G=U;e=f;do{if((k[e+12>>2]|0)>0){F=(G|0)==(U|0);E=0;do{f=k[I>>2]|0;C=G-f|0;D=E-f|0;if(!E){e=k[S>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+G|0;s=aa(T,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[Q>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(T,a)|0,T)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Q>>2]|0}while((a|0)<(e|0))}o=k[I>>2]|0;n=r-o|0;o=q-o|0;f=k[H>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+G|0;m=n+a|0;g=k[K>>2]|0;h=k[L>>2]|0;while(1){A=k[J>>2]|0;z=A+f|0;e=o+f+A|0;B=k[h>>2]|0;y=g+(aa(B,j+A|0)|0)|0;A=g+(aa(B,m+A|0)|0)|0;B=(l[y+(z<<1)>>0]|0)-(l[A+(e<<1)>>0]|0)|0;e=(l[y+(z<<1)+1>>0]|0)-(l[A+(e<<1)+1>>0]|0)|0;B=(aa(e,e)|0)+(aa(B,B)|0)|0;k[p>>2]=B+(k[p>>2]|0);e=c+((aa(aa(T,(k[H>>2]|0)+f|0)|0,T)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+B;e=k[H>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[Q>>2]|0}e=c+((aa(aa(T,e+-1|0)|0,T)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[S>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;v=57}else{a=0;h=0;g=0;f=0;e=0}}else{e=k[J>>2]|0;if(F){z=e+U|0;x=e+E+(k[H>>2]|0)|0;y=z-f|0;e=k[S>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(T,a)|0,T)|0)<<2)|0;w=d+((aa(aa(T,E)|0,T)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(T,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;B=k[H>>2]|0;e=0-B|0;if((B|0)<(e|0))e=0;else{g=k[K>>2]|0;h=k[L>>2]|0;f=e;e=0;while(1){A=k[h>>2]|0;V=g+(aa(A,f+z|0)|0)|0;A=g+(aa(A,p+f|0)|0)|0;B=(l[V+(x<<1)>>0]|0)-(l[A+(j<<1)>>0]|0)|0;A=(l[V+(x<<1)+1>>0]|0)-(l[A+(j<<1)+1>>0]|0)|0;e=(aa(A,A)|0)+(aa(B,B)|0)+e|0;k[m>>2]=e;if((f|0)<(k[H>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[S>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{V=e+G|0;w=e+E|0;j=k[H>>2]|0;h=w+j|0;B=V-f|0;w=w-f+j|0;x=k[K>>2]|0;y=k[L>>2]|0;m=k[y>>2]|0;g=x+(aa(m,V+~j|0)|0)|0;f=x+(aa(m,V+j|0)|0)|0;e=k[S>>2]|0;if((e|0)>0){z=B+-1|0;A=l[f+(h<<1)>>0]|0;u=l[f+(h<<1)+1>>0]|0;v=l[g+(h<<1)>>0]|0;r=l[g+(h<<1)+1>>0]|0;s=c+((aa(aa(T,a)|0,T)|0)<<2)|0;t=d+((aa(aa(T,E)|0,T)|0)<<2)|0;f=0;while(1){p=aa(T,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=x+(aa(m,z+f-j|0)|0)|0;h=x+(aa(m,f+B+j|0)|0)|0;g=0;do{m=o+(g<<2)|0;j=n+(g<<2)|0;k[j>>2]=(k[j>>2]|0)-(k[m>>2]|0);X=w+g|0;V=p+(g<<2)|0;Z=A-(l[h+(X<<1)>>0]|0)|0;Y=u-(l[h+(X<<1)+1>>0]|0)|0;W=v-(l[q+(X<<1)>>0]|0)|0;X=r-(l[q+(X<<1)+1>>0]|0)|0;W=(aa(Z,Z)|0)+(k[V>>2]|0)+(aa(Y,Y)|0)-((aa(X,X)|0)+(aa(W,W)|0))|0;k[m>>2]=W;k[j>>2]=W+(k[j>>2]|0);k[V>>2]=k[m>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[H>>2]|0;m=k[y>>2]|0}e=k[S>>2]|0}}a=(a+1|0)%(k[Q>>2]|0)|0;v=57}if((v|0)==57){v=0;if((e|0)>0){q=k[J>>2]|0;r=k[K>>2]|0;s=k[k[L>>2]>>2]|0;o=k[M>>2]|0;p=k[N>>2]|0;n=0;g=0;j=0;h=0;f=0;do{t=r+(aa(s,C+n+q|0)|0)|0;u=b+((aa(T,n)|0)<<2)|0;m=0;do{Z=k[u+(m<<2)>>2]>>o;Y=k[p+(Z<<3)>>2]|0;Z=k[p+(Z<<3)+4>>2]|0;X=D+m+q|0;g=g+(aa(l[t+(X<<1)>>0]|0,Y)|0)|0;j=j+(aa(l[t+(X<<1)+1>>0]|0,Z)|0)|0;h=h+Y|0;f=f+Z|0;m=m+1|0}while((m|0)!=(e|0));n=n+1|0}while((n|0)!=(e|0));e=j}else{h=0;g=0;f=0;e=0}}Z=((((h|0)/2|0)+g|0)>>>0)/(h>>>0)|0;Y=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[O>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,G)|0)+(E<<1)|0;Z=((Y>>>0<256?Y:(Y|0)>0?255:0)&65535)<<8&65535|(Z>>>0<256?Z:(Z|0)>0?255:0)&255;i[e>>0]=Z;i[e+1>>0]=Z>>8;E=E+1|0;e=k[P>>2]|0}while((E|0)<(k[e+12>>2]|0))}G=G+1|0}while((G|0)!=(R|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function H1a(a){a=a|0;A0a(a);ggb(a);return}function I1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;U=k[b>>2]|0;R=k[b+4>>2]|0;S=a+76|0;T=k[S>>2]|0;c=aa(T,T)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Q=a+72|0;d=aa(aa(T,k[Q>>2]|0)|0,T)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}P=a+4|0;f=k[P>>2]|0;e=aa(aa(T,k[f+12>>2]|0)|0,T)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((U|0)<(R|0)){I=a+84|0;J=a+68|0;K=a+28|0;L=a+56|0;M=a+92|0;N=a+96|0;O=a+8|0;H=a+80|0;a=-1;G=U;e=f;do{if((k[e+12>>2]|0)>0){F=(G|0)==(U|0);E=0;do{f=k[I>>2]|0;C=G-f|0;D=E-f|0;if(!E){e=k[S>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+G|0;s=aa(T,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[Q>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(T,a)|0,T)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Q>>2]|0}while((a|0)<(e|0))}o=k[I>>2]|0;n=r-o|0;o=q-o|0;f=k[H>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+G|0;m=n+a|0;g=k[K>>2]|0;h=k[L>>2]|0;while(1){A=k[J>>2]|0;z=A+f|0;e=o+f+A|0;B=k[h>>2]|0;y=g+(aa(B,j+A|0)|0)|0;A=g+(aa(B,m+A|0)|0)|0;B=(l[y+(z<<1)>>0]|0)-(l[A+(e<<1)>>0]|0)|0;e=(l[y+(z<<1)+1>>0]|0)-(l[A+(e<<1)+1>>0]|0)|0;B=(aa(e,e)|0)+(aa(B,B)|0)|0;k[p>>2]=B+(k[p>>2]|0);e=c+((aa(aa(T,(k[H>>2]|0)+f|0)|0,T)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+B;e=k[H>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[Q>>2]|0}e=c+((aa(aa(T,e+-1|0)|0,T)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[S>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;u=57}else{a=0;g=0;f=0;e=0}}else{e=k[J>>2]|0;if(F){z=e+U|0;x=e+E+(k[H>>2]|0)|0;y=z-f|0;e=k[S>>2]|0;if((e|0)>0){u=x-f|0;v=c+((aa(aa(T,a)|0,T)|0)<<2)|0;w=d+((aa(aa(T,E)|0,T)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(T,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;B=k[H>>2]|0;e=0-B|0;if((B|0)<(e|0))e=0;else{g=k[K>>2]|0;h=k[L>>2]|0;f=e;e=0;while(1){A=k[h>>2]|0;V=g+(aa(A,f+z|0)|0)|0;A=g+(aa(A,p+f|0)|0)|0;B=(l[V+(x<<1)>>0]|0)-(l[A+(j<<1)>>0]|0)|0;A=(l[V+(x<<1)+1>>0]|0)-(l[A+(j<<1)+1>>0]|0)|0;e=(aa(A,A)|0)+(aa(B,B)|0)+e|0;k[m>>2]=e;if((f|0)<(k[H>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[S>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{V=e+G|0;w=e+E|0;j=k[H>>2]|0;h=w+j|0;B=V-f|0;w=w-f+j|0;x=k[K>>2]|0;y=k[L>>2]|0;m=k[y>>2]|0;g=x+(aa(m,V+~j|0)|0)|0;f=x+(aa(m,V+j|0)|0)|0;e=k[S>>2]|0;if((e|0)>0){z=B+-1|0;A=l[f+(h<<1)>>0]|0;u=l[f+(h<<1)+1>>0]|0;v=l[g+(h<<1)>>0]|0;r=l[g+(h<<1)+1>>0]|0;s=c+((aa(aa(T,a)|0,T)|0)<<2)|0;t=d+((aa(aa(T,E)|0,T)|0)<<2)|0;f=0;while(1){p=aa(T,f)|0;n=b+(p<<2)|0;o=s+(p<<2)|0;p=t+(p<<2)|0;q=x+(aa(m,z+f-j|0)|0)|0;h=x+(aa(m,f+B+j|0)|0)|0;g=0;do{m=o+(g<<2)|0;j=n+(g<<2)|0;k[j>>2]=(k[j>>2]|0)-(k[m>>2]|0);X=w+g|0;V=p+(g<<2)|0;Z=A-(l[h+(X<<1)>>0]|0)|0;Y=u-(l[h+(X<<1)+1>>0]|0)|0;W=v-(l[q+(X<<1)>>0]|0)|0;X=r-(l[q+(X<<1)+1>>0]|0)|0;W=(aa(Z,Z)|0)+(k[V>>2]|0)+(aa(Y,Y)|0)-((aa(X,X)|0)+(aa(W,W)|0))|0;k[m>>2]=W;k[j>>2]=W+(k[j>>2]|0);k[V>>2]=k[m>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[H>>2]|0;m=k[y>>2]|0}e=k[S>>2]|0}}a=(a+1|0)%(k[Q>>2]|0)|0;u=57}if((u|0)==57){u=0;if((e|0)>0){p=k[J>>2]|0;q=k[K>>2]|0;r=k[k[L>>2]>>2]|0;n=k[M>>2]|0;o=k[N>>2]|0;m=0;f=0;h=0;g=0;do{s=q+(aa(r,C+m+p|0)|0)|0;t=b+((aa(T,m)|0)<<2)|0;j=0;do{Z=k[o+(k[t+(j<<2)>>2]>>n<<2)>>2]|0;Y=D+j+p|0;f=f+(aa(l[s+(Y<<1)>>0]|0,Z)|0)|0;h=h+(aa(l[s+(Y<<1)+1>>0]|0,Z)|0)|0;g=Z+g|0;j=j+1|0}while((j|0)!=(e|0));m=m+1|0}while((m|0)!=(e|0));e=h}else{g=0;f=0;e=0}}Y=(g|0)/2|0;Z=((f+Y|0)>>>0)/(g>>>0)|0;Y=((e+Y|0)>>>0)/(g>>>0)|0;e=k[O>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,G)|0)+(E<<1)|0;Z=((Y>>>0<256?Y:(Y|0)>0?255:0)&65535)<<8&65535|(Z>>>0<256?Z:(Z|0)>0?255:0)&255;i[e>>0]=Z;i[e+1>>0]=Z>>8;E=E+1|0;e=k[P>>2]|0}while((E|0)<(k[e+12>>2]|0))}G=G+1|0}while((G|0)!=(R|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function J1a(a){a=a|0;z0a(a);ggb(a);return}function K1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;S=k[b>>2]|0;P=k[b+4>>2]|0;Q=a+76|0;R=k[Q>>2]|0;c=aa(R,R)|0;c=c>>>0>1073741823?-1:c<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}O=a+72|0;d=aa(aa(R,k[O>>2]|0)|0,R)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}N=a+4|0;f=k[N>>2]|0;e=aa(aa(R,k[f+12>>2]|0)|0,R)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((S|0)<(P|0)){G=a+84|0;H=a+68|0;I=a+28|0;J=a+56|0;K=a+92|0;L=a+96|0;M=a+8|0;F=a+80|0;a=-1;E=S;e=f;do{if((k[e+12>>2]|0)>0){D=(E|0)==(S|0);C=0;do{h=k[G>>2]|0;A=E-h|0;B=C-h|0;if(!C){e=k[Q>>2]|0;if((e|0)>0){v=0;do{if((e|0)>0){r=v+E|0;s=aa(R,v)|0;t=b+(s<<2)|0;u=d+(s<<2)|0;q=0;do{p=t+(q<<2)|0;k[p>>2]=0;e=k[O>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(R,a)|0,R)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[O>>2]|0}while((a|0)<(e|0))}o=k[G>>2]|0;n=r-o|0;o=q-o|0;f=k[F>>2]|0;a=0-f|0;if((f|0)>=(a|0)){e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){j=a+E|0;m=n+a|0;g=k[I>>2]|0;h=k[J>>2]|0;while(1){z=k[H>>2]|0;y=k[h>>2]|0;e=g+(aa(y,j+z|0)|0)+(z+f)|0;z=g+(aa(y,m+z|0)|0)+(o+f+z)|0;z=(l[e>>0]|0)-(l[z>>0]|0)|0;z=aa(z,z)|0;k[p>>2]=(k[p>>2]|0)+z;e=c+((aa(aa(R,(k[F>>2]|0)+f|0)|0,R)|0)<<2)+(s<<2)+(q<<2)|0;k[e>>2]=(k[e>>2]|0)+z;e=k[F>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0))a=a+1|0;else break}e=k[O>>2]|0}e=c+((aa(aa(R,e+-1|0)|0,R)|0)<<2)+(s<<2)+(q<<2)|0;k[u+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[Q>>2]|0}while((q|0)<(e|0))}v=v+1|0}while((v|0)<(e|0));a=0;j=e;t=57}else{a=0;f=0;e=0}}else{e=k[H>>2]|0;if(D){z=e+S|0;x=e+C+(k[F>>2]|0)|0;y=z-h|0;e=k[Q>>2]|0;if((e|0)>0){u=x-h|0;v=c+((aa(aa(R,a)|0,R)|0)<<2)|0;w=d+((aa(aa(R,C)|0,R)|0)<<2)|0;t=0;do{if((e|0)>0){p=y+t|0;s=aa(R,t)|0;q=v+(s<<2)|0;r=b+(s<<2)|0;s=w+(s<<2)|0;o=0;do{m=q+(o<<2)|0;n=r+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[m>>2]|0);k[m>>2]=0;j=u+o|0;h=k[F>>2]|0;e=0-h|0;if((h|0)<(e|0))e=0;else{g=k[I>>2]|0;h=k[J>>2]|0;f=e;e=0;while(1){T=k[h>>2]|0;U=g+(aa(T,f+z|0)|0)+x|0;T=g+(aa(T,p+f|0)|0)+j|0;T=(l[U>>0]|0)-(l[T>>0]|0)|0;e=e+(aa(T,T)|0)|0;k[m>>2]=e;if((f|0)<(k[F>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[s+(o<<2)>>2]=k[m>>2];o=o+1|0;e=k[Q>>2]|0}while((o|0)<(e|0))}t=t+1|0}while((t|0)<(e|0))}}else{g=e+E|0;v=e+C|0;j=k[F>>2]|0;f=v+j|0;y=g-h|0;v=v-h+j|0;w=k[I>>2]|0;x=k[J>>2]|0;h=k[x>>2]|0;e=k[Q>>2]|0;if((e|0)>0){r=w+(aa(h,g+j|0)|0)+f|0;s=w+(aa(h,g+~j|0)|0)+f|0;q=y+-1|0;r=l[r>>0]|0;s=l[s>>0]|0;t=c+((aa(aa(R,a)|0,R)|0)<<2)|0;u=d+((aa(aa(R,C)|0,R)|0)<<2)|0;f=0;while(1){o=aa(R,f)|0;m=b+(o<<2)|0;n=t+(o<<2)|0;o=u+(o<<2)|0;p=w+(aa(h,q+f-j|0)|0)|0;h=w+(aa(h,f+y+j|0)|0)|0;g=0;do{T=n+(g<<2)|0;z=m+(g<<2)|0;k[z>>2]=(k[z>>2]|0)-(k[T>>2]|0);j=v+g|0;U=o+(g<<2)|0;V=r-(l[h+j>>0]|0)|0;j=s-(l[p+j>>0]|0)|0;j=(aa(V-j|0,V+j|0)|0)+(k[U>>2]|0)|0;k[T>>2]=j;k[z>>2]=j+(k[z>>2]|0);k[U>>2]=k[T>>2];g=g+1|0}while((g|0)!=(e|0));f=f+1|0;if((f|0)==(e|0))break;j=k[F>>2]|0;h=k[x>>2]|0}e=k[Q>>2]|0}}a=(a+1|0)%(k[O>>2]|0)|0;j=e;t=57}if((t|0)==57){t=0;if((j|0)>0){o=k[H>>2]|0;p=k[I>>2]|0;q=k[k[J>>2]>>2]|0;m=k[K>>2]|0;n=k[L>>2]|0;h=0;f=0;e=0;do{r=p+(aa(q,A+h+o|0)|0)|0;s=b+((aa(R,h)|0)<<2)|0;g=0;do{V=k[n+(k[s+(g<<2)>>2]>>m<<2)>>2]|0;e=(aa(l[r+(B+g+o)>>0]|0,V)|0)+e|0;f=V+f|0;g=g+1|0}while((g|0)!=(j|0));h=h+1|0}while((h|0)!=(j|0))}else{f=0;e=0}}V=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[M>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,E)|0)+C|0;i[e>>0]=V>>>0<256?V:(V|0)>0?255:0;C=C+1|0;e=k[N>>2]|0}while((C|0)<(k[e+12>>2]|0))}E=E+1|0}while((E|0)!=(P|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b)return;ggb(b);return}function L1a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0.0,n=0,q=0.0,s=0.0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;ma=r;r=r+496|0;ja=ma+472|0;ia=ma+32|0;ea=ma;ga=ma+456|0;ha=ma+324|0;ka=ma+312|0;l=ma+464|0;la=ma+256|0;k[ka>>2]=0;C=ka+4|0;k[C>>2]=0;k[ka+8>>2]=0;B2(a,ka);M1a(ka,c,d,f,g);y=e+4|0;H=(k[y>>2]|0)-(k[e>>2]|0)>>2;a=k[ka>>2]|0;z=k[a>>2]|0;A=z&7;if((H|0)!=1?(H|0)!=((z>>>3&511)+1|0):0){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=19;i[j+23>>0]=0;n=394198;x=w+19|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396176,394239,329);k[a>>2]=0;k[ja>>2]=0;H=k[j>>2]|0;k[j>>2]=H+-1;if((H|0)==1)ggb(k[j+-4>>2]|0);j=k[ka>>2]|0;a=j;j=k[j>>2]|0}else j=z;G=k[a+40>>2]|0;H=k[G>>2]|0;k[l>>2]=k[G+4>>2];k[l+4>>2]=H;x2(b,l,j&4095,0);do if((k[b>>2]&2031616|0)==65536){n=k[b+4>>2]|0;k[la>>2]=k[n>>2];x=la+4|0;a=n+4|0;k[x>>2]=k[a>>2];H=la+8|0;k[H>>2]=k[n+8>>2];k[la+12>>2]=k[n+12>>2];k[la+16>>2]=k[n+16>>2];k[la+20>>2]=k[n+20>>2];k[la+24>>2]=k[n+24>>2];k[la+28>>2]=k[n+28>>2];k[la+32>>2]=k[n+32>>2];j=k[n+36>>2]|0;k[la+36>>2]=j;b=la+40|0;k[b>>2]=H;H=la+48|0;w=la+44|0;k[w>>2]=H;k[la+52>>2]=0;k[H>>2]=0;if(j|0){H=j+12|0;k[H>>2]=(k[H>>2]|0)+1}if((k[a>>2]|0)<3){G=k[n+44>>2]|0;H=k[w>>2]|0;k[H>>2]=k[G>>2];k[H+4>>2]=k[G+4>>2];break}k[x>>2]=0;x1(la,k[a>>2]|0,0,0,0);if((k[x>>2]|0)>0){t=k[n+40>>2]|0;l=k[b>>2]|0;b=k[n+44>>2]|0;j=k[w>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[t+(a<<2)>>2];k[j+(a<<2)>>2]=k[b+(a<<2)>>2];a=a+1|0}while((a|0)<(k[x>>2]|0))}}else Q1(la,b,-1);while(0);a:do switch(h|0){case 4:{if(A|0){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(60)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=54;i[j+58>>0]=0;n=394396;x=w+54|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-5,ja,396176,394239,346);k[a>>2]=0;k[ja>>2]=0;ja=k[j>>2]|0;k[j>>2]=ja+-1;if((ja|0)==1)ggb(k[j+-4>>2]|0);break a}M=k[e>>2]|0;j=(k[y>>2]|0)-M>>2;b=k[ka>>2]|0;a=b;switch(k[b>>2]&4095){case 0:{H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=151e3;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if(!(k[a>>2]&4088))l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;b:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break b;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;v=+(j|0)/+(a|0);l=~~(65025.0/v+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>2;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(Q=j+(l<<2)|0,(b|0)!=(Q|0)):0)k[E>>2]=b+(~((b+-4-Q|0)>>>2)<<2)}else U1(F,l-a|0);if((l|0)>0){s=+o[M>>2];s=s*s;b=k[F>>2]|0;j=0;do{m=+Z(+(-(v*+(j|0))/s));p[u>>3]=m;a=k[u+4>>2]&2147483647;q=+(k[n>>2]|0);m=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[b+(j<<2)>>2]=+(c|0)<q*.001?0:c;j=j+1|0}while((j|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=59}else fa=59;if((fa|0)==59){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);N1a(ha);break a}case 8:{if((j|0)==1){H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150980;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==8)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;c:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break c;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;v=+(j|0)/+(a|0);l=~~(130050.0/v+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>2;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?($=j+(l<<2)|0,(b|0)!=($|0)):0)k[E>>2]=b+(~((b+-4-$|0)>>>2)<<2)}else U1(F,l-a|0);if((l|0)>0){s=+o[M>>2];s=s*s*2.0;b=k[F>>2]|0;j=0;do{m=+Z(+(-(v*+(j|0))/s));p[u>>3]=m;a=k[u+4>>2]&2147483647;q=+(k[n>>2]|0);m=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[b+(j<<2)>>2]=+(c|0)<q*.001?0:c;j=j+1|0}while((j|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=103}else fa=103;if((fa|0)==103){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);O1a(ha);break a}H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150960;H=ha+12|0;k[H>>2]=la;F=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[F>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[F>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;ca=a+48|0;k[a+44>>2]=ca;k[a+52>>2]=0;k[ca>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;G=ha+76|0;k[ha+72>>2]=G;k[ha+80>>2]=0;k[G>>2]=0;G=ha+120|0;k[G>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;ca=k[j>>2]|0;k[j>>2]=ca+-1;if((ca|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==8)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;ca=k[j>>2]|0;k[j>>2]=ca+-1;if((ca|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;d:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[F>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break d;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[F>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;x=ha+112|0;k[x>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;B=+(j|0)/+(a|0);w=~~(130050.0/B+1.0);b=k[E>>2]|0;j=k[G>>2]|0;a=b-j>>3;if(w>>>0<=a>>>0){if(w>>>0<a>>>0?(da=j+(w<<3)|0,(b|0)!=(da|0)):0)k[E>>2]=b+(~((b+-8-da|0)>>>3)<<3)}else V1(G,w-a|0);if((w|0)>0){n=M+4|0;l=0;do{t=(k[G>>2]|0)+(l<<3)|0;q=-(B*+(l|0));s=+(k[x>>2]|0);v=s*.001;m=+o[M>>2];m=+Z(+(q/(m*m*2.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}j=~~m;b=+(j|0)<v;m=+o[n>>2];m=+Z(+(q/(m*m*2.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}g=~~m;f=+(g|0)<v;d=b?0:j;ea=b?0:0;c=t;k[c>>2]=d;k[c+4>>2]=(f?0:g)|ea;l=l+1|0}while((l|0)!=(w|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=149}else fa=149;if((fa|0)==149){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);P1a(ha);break a}case 16:{if((j|0)==1){H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150940;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==16)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;e:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break e;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;v=+(j|0)/+(a|0);l=~~(195075.0/v+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>2;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(I=j+(l<<2)|0,(b|0)!=(I|0)):0)k[E>>2]=b+(~((b+-4-I|0)>>>2)<<2)}else U1(F,l-a|0);if((l|0)>0){s=+o[M>>2];s=s*s*3.0;b=k[F>>2]|0;j=0;do{m=+Z(+(-(v*+(j|0))/s));p[u>>3]=m;a=k[u+4>>2]&2147483647;q=+(k[n>>2]|0);m=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[b+(j<<2)>>2]=+(c|0)<q*.001?0:c;j=j+1|0}while((j|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=193}else fa=193;if((fa|0)==193){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);Q1a(ha);break a}H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150920;H=ha+12|0;k[H>>2]=la;F=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[F>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[F>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;G=ha+76|0;k[ha+72>>2]=G;k[ha+80>>2]=0;k[G>>2]=0;G=ha+120|0;k[G>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==16)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;f:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[F>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break f;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[F>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;y=ha+112|0;k[y>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;B=+(j|0)/+(a|0);x=~~(195075.0/B+1.0);b=k[E>>2]|0;j=k[G>>2]|0;a=(b-j|0)/12|0;if(x>>>0<=a>>>0){if(x>>>0<a>>>0?(J=j+(x*12|0)|0,(b|0)!=(J|0)):0)k[E>>2]=b+(~(((b+-12-J|0)>>>0)/12|0)*12|0)}else W1(G,x-a|0);if((x|0)>0){n=M+4|0;t=M+8|0;l=0;do{w=k[G>>2]|0;q=-(B*+(l|0));s=+(k[y>>2]|0);v=s*.001;m=+o[M>>2];m=+Z(+(q/(m*m*3.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}b=~~m;b=+(b|0)<v?0:b;m=+o[n>>2];m=+Z(+(q/(m*m*3.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}j=~~m;j=+(j|0)<v?0:j;m=+o[t>>2];m=+Z(+(q/(m*m*3.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[w+(l*12|0)>>2]=b;k[w+(l*12|0)+4>>2]=j;k[w+(l*12|0)+8>>2]=+(c|0)<v?0:c;l=l+1|0}while((l|0)!=(x|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=242}else fa=242;if((fa|0)==242){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);R1a(ha);break a}case 24:{if((j|0)!=1){H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150880;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==24)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;g:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break g;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;m=+(j|0)/+(a|0);l=~~(260100.0/m+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>4;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(L=j+(l<<4)|0,(b|0)!=(L|0)):0)k[E>>2]=b+(~((b+-16-L|0)>>>4)<<4)}else X1(F,l-a|0);if((l|0)>0){a=0;do{c=(k[F>>2]|0)+(a<<4)|0;y1a(ja,m*+(a|0),M,k[n>>2]|0);k[c>>2]=k[ja>>2];k[c+4>>2]=k[ja+4>>2];k[c+8>>2]=k[ja+8>>2];k[c+12>>2]=k[ja+12>>2];a=a+1|0}while((a|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=326}else fa=326;if((fa|0)==326){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);T1a(ha);break a}H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150900;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==24)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;h:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break h;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;v=+(j|0)/+(a|0);l=~~(260100.0/v+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>2;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(K=j+(l<<2)|0,(b|0)!=(K|0)):0)k[E>>2]=b+(~((b+-4-K|0)>>>2)<<2)}else U1(F,l-a|0);if((l|0)>0){s=+o[M>>2];s=s*s*4.0;b=k[F>>2]|0;j=0;do{m=+Z(+(-(v*+(j|0))/s));p[u>>3]=m;a=k[u+4>>2]&2147483647;q=+(k[n>>2]|0);m=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[b+(j<<2)>>2]=+(c|0)<q*.001?0:c;j=j+1|0}while((j|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=286}else fa=286;if((fa|0)==286){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);S1a(ha);break a}default:{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(88)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=80;i[j+84>>0]=0;n=396202;x=w+80|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-5,ja,396283,394239,303);k[a>>2]=0;k[ja>>2]=0;ja=k[j>>2]|0;k[j>>2]=ja+-1;if((ja|0)==1)ggb(k[j+-4>>2]|0);break a}}}case 2:switch(z&7){case 0:{I=k[e>>2]|0;j=(k[y>>2]|0)-I>>2;b=k[ka>>2]|0;a=b;switch(k[b>>2]&4095){case 0:{H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150860;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if(!(k[a>>2]&4088))l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;i:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break i;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;v=+(j|0)/+(a|0);l=~~(255.0/v+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>2;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(M=j+(l<<2)|0,(b|0)!=(M|0)):0)k[E>>2]=b+(~((b+-4-M|0)>>>2)<<2)}else U1(F,l-a|0);if((l|0)>0){s=+o[I>>2];s=s*s;b=k[F>>2]|0;j=0;do{m=v*+(j|0);m=+Z(+(-(m*m)/s));p[u>>3]=m;a=k[u+4>>2]&2147483647;q=+(k[n>>2]|0);m=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[b+(j<<2)>>2]=+(c|0)<q*.001?0:c;j=j+1|0}while((j|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=377}else fa=377;if((fa|0)==377){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);U1a(ha);break a}case 8:{if((j|0)==1){H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150840;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==8)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;j:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break j;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;v=+(j|0)/+(a|0);l=~~(510.0/v+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>2;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(O=j+(l<<2)|0,(b|0)!=(O|0)):0)k[E>>2]=b+(~((b+-4-O|0)>>>2)<<2)}else U1(F,l-a|0);if((l|0)>0){s=+o[I>>2];s=s*s*2.0;b=k[F>>2]|0;j=0;do{m=v*+(j|0);m=+Z(+(-(m*m)/s));p[u>>3]=m;a=k[u+4>>2]&2147483647;q=+(k[n>>2]|0);m=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[b+(j<<2)>>2]=+(c|0)<q*.001?0:c;j=j+1|0}while((j|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=421}else fa=421;if((fa|0)==421){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);V1a(ha);break a}H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150820;H=ha+12|0;k[H>>2]=la;F=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[F>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[F>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;G=ha+76|0;k[ha+72>>2]=G;k[ha+80>>2]=0;k[G>>2]=0;G=ha+120|0;k[G>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==8)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;k:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[F>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break k;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[F>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;x=ha+112|0;k[x>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;B=+(j|0)/+(a|0);w=~~(510.0/B+1.0);b=k[E>>2]|0;j=k[G>>2]|0;a=b-j>>3;if(w>>>0<=a>>>0){if(w>>>0<a>>>0?(P=j+(w<<3)|0,(b|0)!=(P|0)):0)k[E>>2]=b+(~((b+-8-P|0)>>>3)<<3)}else V1(G,w-a|0);if((w|0)>0){n=I+4|0;l=0;do{q=B*+(l|0);t=(k[G>>2]|0)+(l<<3)|0;q=-(q*q);s=+(k[x>>2]|0);v=s*.001;m=+o[I>>2];m=+Z(+(q/(m*m*2.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}j=~~m;b=+(j|0)<v;m=+o[n>>2];m=+Z(+(q/(m*m*2.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}g=~~m;f=+(g|0)<v;d=b?0:j;ea=b?0:0;c=t;k[c>>2]=d;k[c+4>>2]=(f?0:g)|ea;l=l+1|0}while((l|0)!=(w|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=467}else fa=467;if((fa|0)==467){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);W1a(ha);break a}case 16:{if((j|0)==1){H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150800;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==16)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;l:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break l;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;v=+(j|0)/+(a|0);l=~~(765.0/v+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>2;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(R=j+(l<<2)|0,(b|0)!=(R|0)):0)k[E>>2]=b+(~((b+-4-R|0)>>>2)<<2)}else U1(F,l-a|0);if((l|0)>0){s=+o[I>>2];s=s*s*3.0;b=k[F>>2]|0;j=0;do{m=v*+(j|0);m=+Z(+(-(m*m)/s));p[u>>3]=m;a=k[u+4>>2]&2147483647;q=+(k[n>>2]|0);m=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[b+(j<<2)>>2]=+(c|0)<q*.001?0:c;j=j+1|0}while((j|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=511}else fa=511;if((fa|0)==511){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);X1a(ha);break a}H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150780;H=ha+12|0;k[H>>2]=la;F=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[F>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[F>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;G=ha+76|0;k[ha+72>>2]=G;k[ha+80>>2]=0;k[G>>2]=0;G=ha+120|0;k[G>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==16)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;m:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[F>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break m;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[F>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;y=ha+112|0;k[y>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;B=+(j|0)/+(a|0);x=~~(765.0/B+1.0);b=k[E>>2]|0;j=k[G>>2]|0;a=(b-j|0)/12|0;if(x>>>0<=a>>>0){if(x>>>0<a>>>0?(S=j+(x*12|0)|0,(b|0)!=(S|0)):0)k[E>>2]=b+(~(((b+-12-S|0)>>>0)/12|0)*12|0)}else W1(G,x-a|0);if((x|0)>0){n=I+4|0;t=I+8|0;l=0;do{q=B*+(l|0);w=k[G>>2]|0;q=-(q*q);s=+(k[y>>2]|0);v=s*.001;m=+o[I>>2];m=+Z(+(q/(m*m*3.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}b=~~m;b=+(b|0)<v?0:b;m=+o[n>>2];m=+Z(+(q/(m*m*3.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}j=~~m;j=+(j|0)<v?0:j;m=+o[t>>2];m=+Z(+(q/(m*m*3.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[w+(l*12|0)>>2]=b;k[w+(l*12|0)+4>>2]=j;k[w+(l*12|0)+8>>2]=+(c|0)<v?0:c;l=l+1|0}while((l|0)!=(x|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=560}else fa=560;if((fa|0)==560){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);Y1a(ha);break a}case 24:{if((j|0)!=1){H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150740;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==24)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;n:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break n;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;m=+(j|0)/+(a|0);l=~~(1020.0/m+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>4;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(U=j+(l<<4)|0,(b|0)!=(U|0)):0)k[E>>2]=b+(~((b+-16-U|0)>>>4)<<4)}else X1(F,l-a|0);if((l|0)>0){a=0;do{c=(k[F>>2]|0)+(a<<4)|0;j1a(ja,m*+(a|0),I,k[n>>2]|0);k[c>>2]=k[ja>>2];k[c+4>>2]=k[ja+4>>2];k[c+8>>2]=k[ja+8>>2];k[c+12>>2]=k[ja+12>>2];a=a+1|0}while((a|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=644}else fa=644;if((fa|0)==644){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);_1a(ha);break a}H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150760;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==24)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;o:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break o;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;a=k[e>>2]|0;a=2147483647/(aa(aa((k[h>>2]|0)*255|0,a)|0,a)|0)|0;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;v=+(j|0)/+(a|0);l=~~(1020.0/v+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>2;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(T=j+(l<<2)|0,(b|0)!=(T|0)):0)k[E>>2]=b+(~((b+-4-T|0)>>>2)<<2)}else U1(F,l-a|0);if((l|0)>0){s=+o[I>>2];s=s*s*4.0;b=k[F>>2]|0;j=0;do{m=v*+(j|0);m=+Z(+(-(m*m)/s));p[u>>3]=m;a=k[u+4>>2]&2147483647;q=+(k[n>>2]|0);m=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[b+(j<<2)>>2]=+(c|0)<q*.001?0:c;j=j+1|0}while((j|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=604}else fa=604;if((fa|0)==604){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);Z1a(ha);break a}default:{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(88)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=80;i[j+84>>0]=0;n=396202;x=w+80|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-5,ja,396283,394239,303);k[a>>2]=0;k[ja>>2]=0;ja=k[j>>2]|0;k[j>>2]=ja+-1;if((ja|0)==1)ggb(k[j+-4>>2]|0);break a}}}case 2:{I=k[e>>2]|0;j=(k[y>>2]|0)-I>>2;b=k[ka>>2]|0;a=b;switch(k[b>>2]&4095){case 0:{H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150720;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if(!(k[a>>2]&4088))l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;p:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break p;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;b=k[h>>2]|0;n=k[e>>2]|0;a=((n|0)<0)<<31>>31;b=Epb(b|0,((b|0)<0)<<31>>31|0,255,0)|0;b=Epb(b|0,N|0,n|0,a|0)|0;a=Epb(b|0,N|0,n|0,a|0)|0;a=Bpb(-1,2147483647,a|0,N|0)|0;n=N;b=(n|0)>0|(n|0)==0&a>>>0>2147483647;a=b?2147483647:a;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;v=+(j|0)/+(a|0);l=~~(255.0/v+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>2;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(V=j+(l<<2)|0,(b|0)!=(V|0)):0)k[E>>2]=b+(~((b+-4-V|0)>>>2)<<2)}else U1(F,l-a|0);if((l|0)>0){s=+o[I>>2];s=s*s;b=k[F>>2]|0;j=0;do{m=v*+(j|0);m=+Z(+(-(m*m)/s));p[u>>3]=m;a=k[u+4>>2]&2147483647;q=+(k[n>>2]|0);m=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[b+(j<<2)>>2]=+(c|0)<q*.001?0:c;j=j+1|0}while((j|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=691}else fa=691;if((fa|0)==691){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);$1a(ha);break a}case 8:{if((j|0)==1){H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150700;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==8)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;q:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break q;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;b=k[h>>2]|0;n=k[e>>2]|0;a=((n|0)<0)<<31>>31;b=Epb(b|0,((b|0)<0)<<31>>31|0,65535,0)|0;b=Epb(b|0,N|0,n|0,a|0)|0;a=Epb(b|0,N|0,n|0,a|0)|0;a=Bpb(-1,2147483647,a|0,N|0)|0;n=N;b=(n|0)>0|(n|0)==0&a>>>0>2147483647;a=b?2147483647:a;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;v=+(j|0)/+(a|0);l=~~(131070.0/v+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>2;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(W=j+(l<<2)|0,(b|0)!=(W|0)):0)k[E>>2]=b+(~((b+-4-W|0)>>>2)<<2)}else U1(F,l-a|0);if((l|0)>0){s=+o[I>>2];s=s*s*2.0;b=k[F>>2]|0;j=0;do{m=v*+(j|0);m=+Z(+(-(m*m)/s));p[u>>3]=m;a=k[u+4>>2]&2147483647;q=+(k[n>>2]|0);m=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[b+(j<<2)>>2]=+(c|0)<q*.001?0:c;j=j+1|0}while((j|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=735}else fa=735;if((fa|0)==735){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);a2a(ha);break a}H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150680;H=ha+12|0;k[H>>2]=la;F=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[F>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[F>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;G=ha+76|0;k[ha+72>>2]=G;k[ha+80>>2]=0;k[G>>2]=0;G=ha+120|0;k[G>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==8)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;r:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[F>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break r;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[F>>2]|0)+(a*56|0)|0)|0;b=k[h>>2]|0;x=k[e>>2]|0;a=((x|0)<0)<<31>>31;b=Epb(b|0,((b|0)<0)<<31>>31|0,65535,0)|0;b=Epb(b|0,N|0,x|0,a|0)|0;a=Epb(b|0,N|0,x|0,a|0)|0;a=Bpb(-1,2147483647,a|0,N|0)|0;x=N;b=(x|0)>0|(x|0)==0&a>>>0>2147483647;a=b?2147483647:a;x=ha+112|0;k[x>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;B=+(j|0)/+(a|0);w=~~(131070.0/B+1.0);b=k[E>>2]|0;j=k[G>>2]|0;a=b-j>>3;if(w>>>0<=a>>>0){if(w>>>0<a>>>0?(X=j+(w<<3)|0,(b|0)!=(X|0)):0)k[E>>2]=b+(~((b+-8-X|0)>>>3)<<3)}else V1(G,w-a|0);if((w|0)>0){n=I+4|0;l=0;do{q=B*+(l|0);t=(k[G>>2]|0)+(l<<3)|0;q=-(q*q);s=+(k[x>>2]|0);v=s*.001;m=+o[I>>2];m=+Z(+(q/(m*m*2.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}j=~~m;b=+(j|0)<v;m=+o[n>>2];m=+Z(+(q/(m*m*2.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}g=~~m;f=+(g|0)<v;d=b?0:j;ea=b?0:0;c=t;k[c>>2]=d;k[c+4>>2]=(f?0:g)|ea;l=l+1|0}while((l|0)!=(w|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=781}else fa=781;if((fa|0)==781){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);b2a(ha);break a}case 16:{if((j|0)==1){H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150660;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==16)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;s:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break s;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;b=k[h>>2]|0;n=k[e>>2]|0;a=((n|0)<0)<<31>>31;b=Epb(b|0,((b|0)<0)<<31>>31|0,65535,0)|0;b=Epb(b|0,N|0,n|0,a|0)|0;a=Epb(b|0,N|0,n|0,a|0)|0;a=Bpb(-1,2147483647,a|0,N|0)|0;n=N;b=(n|0)>0|(n|0)==0&a>>>0>2147483647;a=b?2147483647:a;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;v=+(j|0)/+(a|0);l=~~(196605.0/v+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>2;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(Y=j+(l<<2)|0,(b|0)!=(Y|0)):0)k[E>>2]=b+(~((b+-4-Y|0)>>>2)<<2)}else U1(F,l-a|0);if((l|0)>0){s=+o[I>>2];s=s*s*3.0;b=k[F>>2]|0;j=0;do{m=v*+(j|0);m=+Z(+(-(m*m)/s));p[u>>3]=m;a=k[u+4>>2]&2147483647;q=+(k[n>>2]|0);m=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[b+(j<<2)>>2]=+(c|0)<q*.001?0:c;j=j+1|0}while((j|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=825}else fa=825;if((fa|0)==825){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);c2a(ha);break a}H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150640;H=ha+12|0;k[H>>2]=la;F=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[F>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[F>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;G=ha+76|0;k[ha+72>>2]=G;k[ha+80>>2]=0;k[G>>2]=0;G=ha+120|0;k[G>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==16)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;t:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[F>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break t;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[F>>2]|0)+(a*56|0)|0)|0;b=k[h>>2]|0;y=k[e>>2]|0;a=((y|0)<0)<<31>>31;b=Epb(b|0,((b|0)<0)<<31>>31|0,65535,0)|0;b=Epb(b|0,N|0,y|0,a|0)|0;a=Epb(b|0,N|0,y|0,a|0)|0;a=Bpb(-1,2147483647,a|0,N|0)|0;y=N;b=(y|0)>0|(y|0)==0&a>>>0>2147483647;a=b?2147483647:a;y=ha+112|0;k[y>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;B=+(j|0)/+(a|0);x=~~(196605.0/B+1.0);b=k[E>>2]|0;j=k[G>>2]|0;a=(b-j|0)/12|0;if(x>>>0<=a>>>0){if(x>>>0<a>>>0?(_=j+(x*12|0)|0,(b|0)!=(_|0)):0)k[E>>2]=b+(~(((b+-12-_|0)>>>0)/12|0)*12|0)}else W1(G,x-a|0);if((x|0)>0){n=I+4|0;t=I+8|0;l=0;do{q=B*+(l|0);w=k[G>>2]|0;q=-(q*q);s=+(k[y>>2]|0);v=s*.001;m=+o[I>>2];m=+Z(+(q/(m*m*3.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}b=~~m;b=+(b|0)<v?0:b;m=+o[n>>2];m=+Z(+(q/(m*m*3.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}j=~~m;j=+(j|0)<v?0:j;m=+o[t>>2];m=+Z(+(q/(m*m*3.0)));p[u>>3]=m;a=k[u+4>>2]&2147483647;m=s*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[w+(l*12|0)>>2]=b;k[w+(l*12|0)+4>>2]=j;k[w+(l*12|0)+8>>2]=+(c|0)<v?0:c;l=l+1|0}while((l|0)!=(x|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=874}else fa=874;if((fa|0)==874){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);d2a(ha);break a}case 24:{if((j|0)!=1){H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150600;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==24)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;u:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break u;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;b=k[h>>2]|0;n=k[e>>2]|0;a=((n|0)<0)<<31>>31;b=Epb(b|0,((b|0)<0)<<31>>31|0,65535,0)|0;b=Epb(b|0,N|0,n|0,a|0)|0;a=Epb(b|0,N|0,n|0,a|0)|0;a=Bpb(-1,2147483647,a|0,N|0)|0;n=N;b=(n|0)>0|(n|0)==0&a>>>0>2147483647;a=b?2147483647:a;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;m=+(j|0)/+(a|0);l=~~(262140.0/m+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>4;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(ca=j+(l<<4)|0,(b|0)!=(ca|0)):0)k[E>>2]=b+(~((b+-16-ca|0)>>>4)<<4)}else X1(F,l-a|0);if((l|0)>0){a=0;do{c=(k[F>>2]|0)+(a<<4)|0;W0a(ja,m*+(a|0),I,k[n>>2]|0);k[c>>2]=k[ja>>2];k[c+4>>2]=k[ja+4>>2];k[c+8>>2]=k[ja+8>>2];k[c+12>>2]=k[ja+12>>2];a=a+1|0}while((a|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=958}else fa=958;if((fa|0)==958){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);f2a(ha);break a}H=k[b+8>>2]|0;k[ga>>2]=0;k[ga+4>>2]=H;k[ha>>2]=150620;H=ha+12|0;k[H>>2]=la;G=ha+16|0;j=k[C>>2]|0;b=j-a|0;l=(b|0)/56|0;k[G>>2]=0;n=ha+20|0;k[n>>2]=0;k[ha+24>>2]=0;if(b){if(l>>>0>76695844)ad(426534,426557,304,426811);while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}k[n>>2]=a;k[G>>2]=a;k[ha+24>>2]=a+(l*56|0);do{k[a>>2]=1124007936;j=a+8|0;b=a+40|0;w=a+4|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[b>>2]=j;da=a+48|0;k[a+44>>2]=da;k[a+52>>2]=0;k[da>>2]=0;a=(k[n>>2]|0)+56|0;k[n>>2]=a;l=l+-1|0}while((l|0)!=0);j=k[C>>2]|0;a=k[ka>>2]|0}D=ha+28|0;k[D>>2]=1124007936;b=ha+36|0;l=ha+68|0;w=ha+32|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[l>>2]=b;F=ha+76|0;k[ha+72>>2]=F;k[ha+80>>2]=0;k[F>>2]=0;F=ha+120|0;k[F>>2]=0;E=ha+124|0;k[E>>2]=0;k[ha+128>>2]=0;if((j|0)==(a|0)){k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(24)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=18;i[j+22>>0]=0;n=396385;x=w+18|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,108);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);a=k[ka>>2]|0}if((k[a>>2]&4088|0)==24)l=a;else{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(52)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=47;i[j+51>>0]=0;n=396533;x=w+47|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-215,ja,396404,396437,109);k[a>>2]=0;k[ja>>2]=0;da=k[j>>2]|0;k[j>>2]=da+-1;if((da|0)==1)ggb(k[j+-4>>2]|0);l=k[ka>>2]|0}k[ha+4>>2]=k[l+8>>2];k[ha+8>>2]=k[l+12>>2];t=(f|0)/2|0;k[ha+100>>2]=t;b=(g|0)/2|0;k[ha+104>>2]=b;a=(d|0)/2|0;n=ha+108|0;k[n>>2]=a;C=ha+88|0;k[C>>2]=t<<1|1;e=ha+92|0;k[e>>2]=b<<1|1;g=a<<1|1;h=ha+96|0;k[h>>2]=g;b=t+b|0;t=ha+84|0;k[t>>2]=b;v:do if((g|0)>0){w=ja+8|0;x=ja+12|0;y=ja+4|0;z=ia+4|0;A=z+4|0;j=0;while(1){k[w>>2]=0;k[x>>2]=0;k[ja>>2]=16842752;k[y>>2]=l+((j+c-a|0)*56|0);a=(k[G>>2]|0)+(j*56|0)|0;g=A;k[g>>2]=0;k[g+4>>2]=0;k[ia>>2]=33619968;k[z>>2]=a;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(ja,ia,b,b,b,b,4,ea);j=j+1|0;a=k[n>>2]|0;if((j|0)>=(k[h>>2]|0))break v;l=k[ka>>2]|0;b=k[t>>2]|0}}while(0);KG(D,(k[G>>2]|0)+(a*56|0)|0)|0;b=k[h>>2]|0;n=k[e>>2]|0;a=((n|0)<0)<<31>>31;b=Epb(b|0,((b|0)<0)<<31>>31|0,65535,0)|0;b=Epb(b|0,N|0,n|0,a|0)|0;a=Epb(b|0,N|0,n|0,a|0)|0;a=Bpb(-1,2147483647,a|0,N|0)|0;n=N;b=(n|0)>0|(n|0)==0&a>>>0>2147483647;a=b?2147483647:a;n=ha+112|0;k[n>>2]=a;a=k[C>>2]|0;a=aa(a,a)|0;b=0;while(1){j=1<<b;if((j|0)<(a|0))b=b+1|0;else break}k[ha+116>>2]=b;v=+(j|0)/+(a|0);l=~~(262140.0/v+1.0);b=k[E>>2]|0;j=k[F>>2]|0;a=b-j>>2;if(l>>>0<=a>>>0){if(l>>>0<a>>>0?(ba=j+(l<<2)|0,(b|0)!=(ba|0)):0)k[E>>2]=b+(~((b+-4-ba|0)>>>2)<<2)}else U1(F,l-a|0);if((l|0)>0){s=+o[I>>2];s=s*s*4.0;b=k[F>>2]|0;j=0;do{m=v*+(j|0);m=+Z(+(-(m*m)/s));p[u>>3]=m;a=k[u+4>>2]&2147483647;q=+(k[n>>2]|0);m=q*(a>>>0>2146435072|(a|0)==2146435072&(k[u>>2]|0)>>>0>0?1.0:m);p[u>>3]=m;a=k[u+4>>2]|0;c=a&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){a=(a|0)<0;m=a?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=a?-0.0:0.0}c=~~m;k[b+(j<<2)>>2]=+(c|0)<q*.001?0:c;j=j+1|0}while((j|0)!=(l|0))}t=k[H>>2]|0;if(k[t+16>>2]|0){b=k[t+4>>2]|0;if((b|0)<3)a=aa(k[t+12>>2]|0,k[t+8>>2]|0)|0;else{l=k[t+40>>2]|0;j=0;a=1;do{a=aa(k[l+(j<<2)>>2]|0,a)|0;j=j+1|0}while((j|0)!=(b|0))}if(!a)fa=918}else fa=918;if((fa|0)==918){n=k[ka>>2]|0;l=k[n+40>>2]|0;b=k[l+4>>2]|0;l=k[l>>2]|0;n=k[n>>2]&4095;k[ia>>2]=0;k[ia+4>>2]=0;k[ia+8>>2]=1124007936;a=ia+16|0;j=ia+48|0;w=ia+12|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+56|0;k[ia+52>>2]=a;k[ia+60>>2]=0;k[a>>2]=0;k[ia+64>>2]=1124007936;a=ia+72|0;j=ia+104|0;w=ia+68|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;a=ia+112|0;k[ia+108>>2]=a;k[ia+116>>2]=0;k[a>>2]=0;k[ia+120>>2]=1124007936;a=ia+128|0;j=ia+160|0;w=ia+124|0;x=w+36|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[j>>2]=a;w=ia+168|0;k[ia+164>>2]=w;x=w+56|0;do{k[w>>2]=0;w=w+4|0}while((w|0)<(x|0));k[ja>>2]=b;k[ja+4>>2]=l;j1(ia,48,ja,n);ja=k[ia>>2]|0;dh[k[(k[ja>>2]|0)+12>>2]&255](ja,ia,t,-1);XN(ia)}jh[k[(k[ha>>2]|0)+8>>2]&1023](ha,ga);e2a(ha);break a}default:{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(88)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=80;i[j+84>>0]=0;n=396202;x=w+80|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-5,ja,396283,394239,303);k[a>>2]=0;k[ja>>2]=0;ja=k[j>>2]|0;k[j>>2]=ja+-1;if((ja|0)==1)ggb(k[j+-4>>2]|0);break a}}}default:{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(72)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=66;i[j+70>>0]=0;n=394451;x=w+66|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-5,ja,396176,394239,367);k[a>>2]=0;k[ja>>2]=0;ja=k[j>>2]|0;k[j>>2]=ja+-1;if((ja|0)==1)ggb(k[j+-4>>2]|0);break a}}default:{k[ja>>2]=0;a=ja+4|0;k[a>>2]=0;j=ZT(68)|0;k[j>>2]=1;w=j+4|0;k[ja>>2]=w;k[a>>2]=61;i[j+65>>0]=0;n=394518;x=w+61|0;do{i[w>>0]=i[n>>0]|0;w=w+1|0;n=n+1|0}while((w|0)<(x|0));Y8(-5,ja,396176,394239,372);k[a>>2]=0;k[ja>>2]=0;ja=k[j>>2]|0;k[j>>2]=ja+-1;if((ja|0)==1)ggb(k[j+-4>>2]|0)}}while(0);b=la+36|0;a=k[b>>2]|0;if(a|0?(ia=a+12|0,ja=k[ia>>2]|0,k[ia>>2]=ja+-1,(ja|0)==1):0){j=k[b>>2]|0;if(j|0){a=k[j+4>>2]|0;if(!a){a=k[la+32>>2]|0;if(!a){a=B1()|0;j=k[b>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,j)}k[b>>2]=0}k[b>>2]=0;ja=la+16|0;j=la+4|0;k[ja>>2]=0;k[ja+4>>2]=0;k[ja+8>>2]=0;k[ja+12>>2]=0;if((k[j>>2]|0)>0){b=k[la+40>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[j>>2]|0))}a=k[la+44>>2]|0;if((a|0)==(la+48|0)|(a|0)==0){zF(ka);r=ma;return}ggb(k[a+-4>>2]|0);zF(ka);r=ma;return}function M1a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;n=r;r=r+16|0;l=n;h=(k[a+4>>2]|0)-(k[a>>2]|0)|0;j=(h|0)/56|0;if(!h){f=l+4|0;g=ZT(48)|0;k[g>>2]=1;m=g+4|0;k[l>>2]=m;k[f>>2]=40;i[g+44>>0]=0;o=397939;p=m+40|0;do{i[m>>0]=i[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));Y8(-5,l,397980,394239,216);k[f>>2]=0;k[l>>2]=0;p=k[g>>2]|0;k[g>>2]=p+-1;if((p|0)==1)ggb(k[g+-4>>2]|0)}if(!(c&1&d&e)){f=l+4|0;g=ZT(40)|0;k[g>>2]=1;m=g+4|0;k[l>>2]=m;k[f>>2]=32;i[g+36>>0]=0;o=398024;p=m+32|0;do{i[m>>0]=i[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));Y8(-5,l,397980,394239,222);k[f>>2]=0;k[l>>2]=0;p=k[g>>2]|0;k[g>>2]=p+-1;if((p|0)==1)ggb(k[g+-4>>2]|0)}p=(c|0)/2|0;if(!((p|0)<=(b|0)&(p+b|0)<(j|0))){f=l+4|0;g=ZT(92)|0;k[g>>2]=1;m=g+4|0;k[l>>2]=m;k[f>>2]=85;i[g+89>>0]=0;o=398057;p=m+85|0;do{i[m>>0]=i[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));Y8(-5,l,397980,394239,231);k[f>>2]=0;k[l>>2]=0;p=k[g>>2]|0;k[g>>2]=p+-1;if((p|0)==1)ggb(k[g+-4>>2]|0)}if((h|0)<=56){r=n;return}g=l+4|0;f=1;do{p=k[a>>2]|0;m=k[p+40>>2]|0;o=k[p+(f*56|0)+40>>2]|0;if(!(!((k[m>>2]|0)!=(k[o>>2]|0)?1:(k[m+4>>2]|0)!=(k[o+4>>2]|0))?!((k[p+(f*56|0)>>2]^k[p>>2])&4095|0):0)){d=ZT(56)|0;k[d>>2]=1;m=d+4|0;k[l>>2]=m;k[g>>2]=48;i[d+52>>0]=0;o=398143;p=m+48|0;do{i[m>>0]=i[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));Y8(-5,l,397980,394239,237);k[g>>2]=0;k[l>>2]=0;p=k[d>>2]|0;k[d>>2]=p+-1;if((p|0)==1)ggb(k[d+-4>>2]|0)}f=f+1|0}while((f|0)<(j|0));r=n;return}function N1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=151e3;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function O1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150980;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function P1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150960;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function Q1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150940;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function R1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150920;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~(((e+-12-c|0)>>>0)/12|0)*12|0);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function S1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150900;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function T1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150880;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function U1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150860;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function V1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150840;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function W1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150820;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function X1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150800;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function Y1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150780;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~(((e+-12-c|0)>>>0)/12|0)*12|0);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function Z1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150760;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function _1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150740;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function $1a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150720;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function a2a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150700;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function b2a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150680;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function c2a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150660;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function d2a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150640;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~(((e+-12-c|0)>>>0)/12|0)*12|0);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function e2a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150620;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function f2a(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=150600;b=k[a+120>>2]|0;c=b;if(b|0){d=a+124|0;e=k[d>>2]|0;if((e|0)!=(b|0))k[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);ggb(b)}d=a+64|0;b=k[d>>2]|0;if(b|0?(c=b+12|0,e=k[c>>2]|0,k[c>>2]=e+-1,(e|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+60>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;e=a+44|0;c=a+32|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+68>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+72>>2]|0;if((b|0)==(a+76|0)|(b|0)==0){a=a+16|0;zF(a);return}ggb(k[b+-4>>2]|0);a=a+16|0;zF(a);return}function g2a(a){a=a|0;f2a(a);ggb(a);return}function h2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;Za=r;r=r+64|0;Xa=Za;Ya=k[b>>2]|0;Sa=k[b+4>>2]|0;Ta=a+96|0;Ua=k[Ta>>2]|0;Va=a+92|0;Wa=k[Va>>2]|0;Ra=aa(aa(Wa,Ua)|0,Wa)|0;c=Ra>>>0>1073741823?-1:Ra<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Qa=a+88|0;d=aa(aa(aa(Ua,k[Qa>>2]|0)|0,Wa)|0,Wa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Pa=a+8|0;f=k[Pa>>2]|0;e=aa(aa(aa(Ua,f)|0,Wa)|0,Wa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Ya|0)<(Sa|0)){Ha=a+104|0;Ia=a+12|0;Ja=a+16|0;Ka=a+84|0;La=a+116|0;Ma=a+120|0;Na=a+100|0;Oa=a+44|0;U=a+72|0;V=Xa+4|0;W=Xa+8|0;X=Xa+12|0;Y=Xa+16|0;Z=Xa+20|0;_=Xa+24|0;$=Xa+28|0;ba=Xa+32|0;ca=Xa+36|0;da=Xa+40|0;ea=Xa+48|0;fa=Xa+44|0;ga=Xa+52|0;ha=Xa+4|0;ia=Xa+8|0;ja=Xa+12|0;ka=Xa+16|0;la=Xa+20|0;ma=Xa+24|0;na=Xa+28|0;oa=Xa+32|0;pa=Xa+36|0;qa=Xa+40|0;ra=Xa+48|0;sa=Xa+44|0;ta=Xa+52|0;ua=Xa+4|0;va=Xa+8|0;wa=Xa+12|0;xa=Xa+16|0;ya=Xa+20|0;za=Xa+24|0;Aa=Xa+28|0;Ba=Xa+32|0;Ca=Xa+36|0;Da=Xa+40|0;Ea=Xa+48|0;Fa=Xa+44|0;Ga=Xa+52|0;a=-1;T=Ya;e=f;do{if((e|0)>0){S=(T|0)==(Ya|0);R=0;do{f=k[Ha>>2]|0;P=T-f|0;Q=R-f|0;if(!R)if((k[Ta>>2]|0)>0){E=0;do{f=k[Ja>>2]|0;k[Xa>>2]=k[f+(E*56|0)>>2];e=f+(E*56|0)+4|0;k[ha>>2]=k[e>>2];k[ia>>2]=k[f+(E*56|0)+8>>2];k[ja>>2]=k[f+(E*56|0)+12>>2];k[ka>>2]=k[f+(E*56|0)+16>>2];k[la>>2]=k[f+(E*56|0)+20>>2];k[ma>>2]=k[f+(E*56|0)+24>>2];k[na>>2]=k[f+(E*56|0)+28>>2];k[oa>>2]=k[f+(E*56|0)+32>>2];a=k[f+(E*56|0)+36>>2]|0;k[pa>>2]=a;k[qa>>2]=ia;k[sa>>2]=ra;k[ta>>2]=0;k[ra>>2]=0;if(a|0){O=a+12|0;k[O>>2]=(k[O>>2]|0)+1}if((k[e>>2]|0)>=3){k[ha>>2]=0;x1(Xa,k[e>>2]|0,0,0,0);if((k[ha>>2]|0)>0){g=k[f+(E*56|0)+40>>2]|0;h=k[qa>>2]|0;a=k[f+(E*56|0)+44>>2]|0;f=k[sa>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ha>>2]|0))}}else{M=k[f+(E*56|0)+44>>2]|0;O=k[sa>>2]|0;k[O>>2]=k[M>>2];k[O+4>>2]=k[M+4>>2]}e=k[Va>>2]|0;if((e|0)>0){y=k[ka>>2]|0;z=k[sa>>2]|0;A=aa(aa(Wa,E)|0,Wa)|0;B=b+(A<<2)|0;C=d+(A<<2)|0;D=c+(A<<2)|0;x=0;do{if((e|0)>0){s=x+T|0;t=aa(Wa,x)|0;u=B+(t<<2)|0;v=C+(t<<2)|0;w=D+(t<<2)|0;q=0;do{p=u+(q<<2)|0;k[p>>2]=0;e=k[Qa>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Ua,a)|0,Wa)|0,Wa)|0)<<2)+(A<<2)+(t<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Qa>>2]|0}while((a|0)<(e|0))}o=k[Ha>>2]|0;n=s-o|0;o=q-o|0;f=k[Na>>2]|0;a=0-f|0;if((f|0)>=(a|0)){l=w+(q<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=k[Oa>>2]|0;h=k[U>>2]|0;i=o+a|0;while(1){K=k[Ka>>2]|0;J=K+a|0;I=g+(aa(k[h>>2]|0,f+T+K|0)|0)|0;e=i+K|0;K=y+(aa(k[z>>2]|0,n+f+K|0)|0)|0;M=(m[I+(J<<3)>>1]|0)-(m[K+(e<<3)>>1]|0)|0;L=(m[I+(J<<3)+2>>1]|0)-(m[K+(e<<3)+2>>1]|0)|0;O=(m[I+(J<<3)+4>>1]|0)-(m[K+(e<<3)+4>>1]|0)|0;e=(m[I+(J<<3)+6>>1]|0)-(m[K+(e<<3)+6>>1]|0)|0;e=((L|0)>-1?L:0-L|0)+((M|0)>-1?M:0-M|0)+((O|0)>-1?O:0-O|0)+((e|0)>-1?e:0-e|0)|0;k[p>>2]=e+(k[p>>2]|0);k[l>>2]=e+(k[l>>2]|0);e=k[Na>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;l=l+(Ra<<2)|0}else break}e=k[Qa>>2]|0}e=c+((aa(aa(aa(Ua,e+-1|0)|0,Wa)|0,Wa)|0)<<2)+(A<<2)+(t<<2)+(q<<2)|0;k[v+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[Va>>2]|0}while((q|0)<(e|0))}x=x+1|0}while((x|0)<(e|0))}e=k[pa>>2]|0;if(e|0?(M=e+12|0,O=k[M>>2]|0,k[M>>2]=O+-1,(O|0)==1):0){a=k[pa>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[oa>>2]|0;if(e|0)break;e=B1()|0;a=k[pa>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[pa>>2]=0}k[pa>>2]=0;k[ka>>2]=0;k[ka+4>>2]=0;k[ka+8>>2]=0;k[ka+12>>2]=0;if((k[ha>>2]|0)>0){a=k[qa>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ha>>2]|0))}e=k[sa>>2]|0;if(!((e|0)==(ra|0)|(e|0)==0))ggb(k[e+-4>>2]|0);E=E+1|0;e=k[Ta>>2]|0}while((E|0)<(e|0));a=0;O=125}else{a=0;x=0;w=0;v=0;u=0;t=0;s=0;q=0;p=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}else{e=k[Ka>>2]|0;if(S){G=e+Ya|0;E=e+R+(k[Na>>2]|0)|0;F=G-f|0;e=k[Ta>>2]|0;if((e|0)>0){B=E-f|0;C=c+((aa(aa(aa(Ua,a)|0,Wa)|0,Wa)|0)<<2)|0;D=d+((aa(aa(aa(Ua,R)|0,Wa)|0,Wa)|0)<<2)|0;A=0;do{g=k[Ja>>2]|0;k[Xa>>2]=k[g+(A*56|0)>>2];e=g+(A*56|0)+4|0;k[ua>>2]=k[e>>2];k[va>>2]=k[g+(A*56|0)+8>>2];k[wa>>2]=k[g+(A*56|0)+12>>2];k[xa>>2]=k[g+(A*56|0)+16>>2];k[ya>>2]=k[g+(A*56|0)+20>>2];k[za>>2]=k[g+(A*56|0)+24>>2];k[Aa>>2]=k[g+(A*56|0)+28>>2];k[Ba>>2]=k[g+(A*56|0)+32>>2];f=k[g+(A*56|0)+36>>2]|0;k[Ca>>2]=f;k[Da>>2]=va;k[Fa>>2]=Ea;k[Ga>>2]=0;k[Ea>>2]=0;if(f|0){O=f+12|0;k[O>>2]=(k[O>>2]|0)+1}if((k[e>>2]|0)>=3){k[ua>>2]=0;x1(Xa,k[e>>2]|0,0,0,0);if((k[ua>>2]|0)>0){h=k[g+(A*56|0)+40>>2]|0;i=k[Da>>2]|0;f=k[g+(A*56|0)+44>>2]|0;g=k[Fa>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ua>>2]|0))}}else{M=k[g+(A*56|0)+44>>2]|0;O=k[Fa>>2]|0;k[O>>2]=k[M>>2];k[O+4>>2]=k[M+4>>2]}e=k[Va>>2]|0;if((e|0)>0){v=k[xa>>2]|0;w=k[Fa>>2]|0;z=aa(aa(Wa,A)|0,Wa)|0;x=C+(z<<2)|0;y=b+(z<<2)|0;z=D+(z<<2)|0;u=0;do{if((e|0)>0){p=F+u|0;t=aa(Wa,u)|0;q=x+(t<<2)|0;s=y+(t<<2)|0;t=z+(t<<2)|0;o=0;do{l=q+(o<<2)|0;n=s+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=B+o|0;O=k[Na>>2]|0;e=0-O|0;if((O|0)<(e|0))e=0;else{h=k[Oa>>2]|0;i=k[U>>2]|0;f=e;e=0;while(1){J=h+(aa(k[i>>2]|0,f+G|0)|0)|0;O=v+(aa(k[w>>2]|0,p+f|0)|0)|0;K=(m[J+(E<<3)>>1]|0)-(m[O+(g<<3)>>1]|0)|0;L=(m[J+(E<<3)+2>>1]|0)-(m[O+(g<<3)+2>>1]|0)|0;M=(m[J+(E<<3)+4>>1]|0)-(m[O+(g<<3)+4>>1]|0)|0;O=(m[J+(E<<3)+6>>1]|0)-(m[O+(g<<3)+6>>1]|0)|0;e=e+((K|0)>-1?K:0-K|0)+((L|0)>-1?L:0-L|0)+((M|0)>-1?M:0-M|0)+((O|0)>-1?O:0-O|0)|0;k[l>>2]=e;if((f|0)<(k[Na>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[t+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[Va>>2]|0}while((o|0)<(e|0))}u=u+1|0}while((u|0)<(e|0))}e=k[Ca>>2]|0;if(e|0?(M=e+12|0,O=k[M>>2]|0,k[M>>2]=O+-1,(O|0)==1):0){f=k[Ca>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[Ba>>2]|0;if(e|0)break;e=B1()|0;f=k[Ca>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[Ca>>2]=0}k[Ca>>2]=0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[ua>>2]|0)>0){f=k[Da>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ua>>2]|0))}e=k[Fa>>2]|0;if(!((e|0)==(Ea|0)|(e|0)==0))ggb(k[e+-4>>2]|0);A=A+1|0;e=k[Ta>>2]|0}while((A|0)<(e|0))}}else{O=e+T|0;H=e+R|0;I=k[Na>>2]|0;h=H+I|0;J=O-f|0;H=H-f+I|0;e=k[Oa>>2]|0;f=k[k[U>>2]>>2]|0;g=e+(aa(f,O+~I|0)|0)|0;f=e+(aa(f,O+I|0)|0)|0;I=k[Va>>2]|0;e=k[Ta>>2]|0;if((e|0)>0){C=(I|0)>0;D=J+-1|0;E=m[f+(h<<3)>>1]|0;F=m[f+(h<<3)+2>>1]|0;G=m[f+(h<<3)+4>>1]|0;y=m[f+(h<<3)+6>>1]|0;z=m[g+(h<<3)>>1]|0;A=m[g+(h<<3)+2>>1]|0;B=m[g+(h<<3)+4>>1]|0;v=m[g+(h<<3)+6>>1]|0;w=c+((aa(aa(aa(Ua,a)|0,Wa)|0,Wa)|0)<<2)|0;x=d+((aa(aa(aa(Ua,R)|0,Wa)|0,Wa)|0)<<2)|0;u=0;do{g=k[Ja>>2]|0;k[Xa>>2]=k[g+(u*56|0)>>2];e=g+(u*56|0)+4|0;k[V>>2]=k[e>>2];k[W>>2]=k[g+(u*56|0)+8>>2];k[X>>2]=k[g+(u*56|0)+12>>2];k[Y>>2]=k[g+(u*56|0)+16>>2];k[Z>>2]=k[g+(u*56|0)+20>>2];k[_>>2]=k[g+(u*56|0)+24>>2];k[$>>2]=k[g+(u*56|0)+28>>2];k[ba>>2]=k[g+(u*56|0)+32>>2];f=k[g+(u*56|0)+36>>2]|0;k[ca>>2]=f;k[da>>2]=W;k[fa>>2]=ea;k[ga>>2]=0;k[ea>>2]=0;if(f|0){O=f+12|0;k[O>>2]=(k[O>>2]|0)+1}if((k[e>>2]|0)>=3){k[V>>2]=0;x1(Xa,k[e>>2]|0,0,0,0);if((k[V>>2]|0)>0){h=k[g+(u*56|0)+40>>2]|0;i=k[da>>2]|0;f=k[g+(u*56|0)+44>>2]|0;g=k[fa>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[V>>2]|0))}}else{M=k[g+(u*56|0)+44>>2]|0;O=k[fa>>2]|0;k[O>>2]=k[M>>2];k[O+4>>2]=k[M+4>>2]}i=aa(aa(Wa,u)|0,Wa)|0;g=b+(i<<2)|0;h=w+(i<<2)|0;i=x+(i<<2)|0;if(C){l=k[Y>>2]|0;n=k[fa>>2]|0;f=0;do{q=aa(f,Wa)|0;o=g+(q<<2)|0;p=h+(q<<2)|0;q=i+(q<<2)|0;t=k[Na>>2]|0;e=k[n>>2]|0;s=l+(aa(e,D+f-t|0)|0)|0;t=l+(aa(e,f+J+t|0)|0)|0;e=0;do{M=p+(e<<2)|0;L=o+(e<<2)|0;k[L>>2]=(k[L>>2]|0)-(k[M>>2]|0);O=q+(e<<2)|0;bb=H+e|0;ab=E-(m[t+(bb<<3)>>1]|0)|0;$a=F-(m[t+(bb<<3)+2>>1]|0)|0;_a=G-(m[t+(bb<<3)+4>>1]|0)|0;K=y-(m[t+(bb<<3)+6>>1]|0)|0;eb=z-(m[s+(bb<<3)>>1]|0)|0;db=A-(m[s+(bb<<3)+2>>1]|0)|0;cb=B-(m[s+(bb<<3)+4>>1]|0)|0;bb=v-(m[s+(bb<<3)+6>>1]|0)|0;K=(k[O>>2]|0)-((eb|0)>-1?eb:0-eb|0)-((db|0)>-1?db:0-db|0)-((cb|0)>-1?cb:0-cb|0)-((bb|0)>-1?bb:0-bb|0)+((ab|0)>-1?ab:0-ab|0)+(($a|0)>-1?$a:0-$a|0)+((_a|0)>-1?_a:0-_a|0)+((K|0)>-1?K:0-K|0)|0;k[M>>2]=K;k[L>>2]=K+(k[L>>2]|0);k[O>>2]=k[M>>2];e=e+1|0}while((e|0)!=(I|0));f=f+1|0}while((f|0)!=(I|0))}e=k[ca>>2]|0;if(e|0?(db=e+12|0,eb=k[db>>2]|0,k[db>>2]=eb+-1,(eb|0)==1):0){f=k[ca>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[ba>>2]|0;if(e|0)break;e=B1()|0;f=k[ca>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ca>>2]=0}k[ca>>2]=0;k[Y>>2]=0;k[Y+4>>2]=0;k[Y+8>>2]=0;k[Y+12>>2]=0;if((k[V>>2]|0)>0){f=k[da>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[V>>2]|0))}e=k[fa>>2]|0;if(!((e|0)==(ea|0)|(e|0)==0))ggb(k[e+-4>>2]|0);u=u+1|0;e=k[Ta>>2]|0}while((u|0)<(e|0))}}a=(a+1|0)%(k[Qa>>2]|0)|0;O=125}if((O|0)==125){O=0;if((e|0)>0){K=k[Ja>>2]|0;L=k[Va>>2]|0;M=(L|0)>0;J=0;h=0;g=0;o=0;n=0;t=0;s=0;x=0;w=0;f=0;y=0;l=0;i=0;q=0;p=0;v=0;u=0;do{if(M){F=k[Ka>>2]|0;G=k[K+(J*56|0)+16>>2]|0;H=k[k[K+(J*56|0)+44>>2]>>2]|0;I=b+((aa(aa(Wa,J)|0,Wa)|0)<<2)|0;D=k[La>>2]|0;E=k[Ma>>2]|0;C=0;do{A=G+(aa(H,P+C+F|0)|0)|0;B=I+((aa(Wa,C)|0)<<2)|0;z=0;do{db=k[B+(z<<2)>>2]>>D;fb=k[E+(db<<4)>>2]|0;$a=k[E+(db<<4)+4>>2]|0;bb=k[E+(db<<4)+8>>2]|0;db=k[E+(db<<4)+12>>2]|0;ab=Q+z+F|0;cb=j[A+(ab<<3)+2>>1]|0;eb=j[A+(ab<<3)+4>>1]|0;gb=j[A+(ab<<3)+6>>1]|0;_a=((fb|0)<0)<<31>>31;ab=Epb(m[A+(ab<<3)>>1]|0|0,0,fb|0,_a|0)|0;v=kpb(v|0,u|0,ab|0,N|0)|0;u=N;ab=(($a|0)<0)<<31>>31;cb=Epb(cb&65535|0,0,$a|0,ab|0)|0;q=kpb(q|0,p|0,cb|0,N|0)|0;p=N;cb=((bb|0)<0)<<31>>31;eb=Epb(eb&65535|0,0,bb|0,cb|0)|0;l=kpb(l|0,i|0,eb|0,N|0)|0;i=N;eb=((db|0)<0)<<31>>31;gb=Epb(gb&65535|0,0,db|0,eb|0)|0;f=kpb(f|0,y|0,gb|0,N|0)|0;y=N;x=kpb(x|0,w|0,fb|0,_a|0)|0;w=N;t=kpb(t|0,s|0,$a|0,ab|0)|0;s=N;o=kpb(o|0,n|0,bb|0,cb|0)|0;n=N;h=kpb(h|0,g|0,db|0,eb|0)|0;g=N;z=z+1|0}while((z|0)!=(L|0));C=C+1|0}while((C|0)!=(L|0))}J=J+1|0}while((J|0)!=(e|0));e=y}else{x=0;w=0;v=0;u=0;t=0;s=0;q=0;p=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}bb=Bpb(x|0,w|0,2,0)|0;bb=kpb(bb|0,N|0,v|0,u|0)|0;bb=spb(bb|0,N|0,x|0,w|0)|0;ab=N;eb=Bpb(t|0,s|0,2,0)|0;eb=kpb(eb|0,N|0,q|0,p|0)|0;eb=spb(eb|0,N|0,t|0,s|0)|0;$a=N;gb=Bpb(o|0,n|0,2,0)|0;gb=kpb(gb|0,N|0,l|0,i|0)|0;gb=spb(gb|0,N|0,o|0,n|0)|0;fb=N;cb=Bpb(h|0,g|0,2,0)|0;cb=kpb(cb|0,N|0,f|0,e|0)|0;cb=spb(cb|0,N|0,h|0,g|0)|0;db=N;e=k[Ia>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,T)|0)+(R<<3)|0;cb=Apb((db>>>0<0|(db|0)==0&cb>>>0<65536?cb&65535:((db|0)>0|(db|0)==0&cb>>>0>0)<<31>>31)&65535|0,0,48)|0;db=N;eb=Apb(($a>>>0<0|($a|0)==0&eb>>>0<65536?eb&65535:(($a|0)>0|($a|0)==0&eb>>>0>0)<<31>>31)&65535|0,0,16)|0;eb=(ab>>>0<0|(ab|0)==0&bb>>>0<65536?bb&65535:((ab|0)>0|(ab|0)==0&bb>>>0>0)<<31>>31)&65535|cb|eb;gb=db|N|(fb>>>0<0|(fb|0)==0&gb>>>0<65536?gb&65535:((fb|0)>0|(fb|0)==0&gb>>>0>0)<<31>>31)&65535;fb=e;j[fb>>1]=eb;j[fb+2>>1]=eb>>>16;e=e+4|0;j[e>>1]=gb;j[e+2>>1]=gb>>>16;R=R+1|0;e=k[Pa>>2]|0}while((R|0)<(e|0))}T=T+1|0}while((T|0)<(Sa|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Za;return}ggb(b);r=Za;return}function i2a(a){a=a|0;e2a(a);ggb(a);return}function j2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0;Va=r;r=r+64|0;Ta=Va;Ua=k[b>>2]|0;Oa=k[b+4>>2]|0;Pa=a+96|0;Qa=k[Pa>>2]|0;Ra=a+92|0;Sa=k[Ra>>2]|0;Na=aa(aa(Sa,Qa)|0,Sa)|0;c=Na>>>0>1073741823?-1:Na<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ma=a+88|0;d=aa(aa(aa(Qa,k[Ma>>2]|0)|0,Sa)|0,Sa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}La=a+8|0;f=k[La>>2]|0;e=aa(aa(aa(Qa,f)|0,Sa)|0,Sa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Ua|0)<(Oa|0)){Da=a+104|0;Ea=a+12|0;Fa=a+16|0;Ga=a+84|0;Ha=a+116|0;Ia=a+120|0;Ja=a+100|0;Ka=a+44|0;Q=a+72|0;R=Ta+4|0;S=Ta+8|0;T=Ta+12|0;U=Ta+16|0;V=Ta+20|0;W=Ta+24|0;X=Ta+28|0;Y=Ta+32|0;Z=Ta+36|0;_=Ta+40|0;$=Ta+48|0;ba=Ta+44|0;ca=Ta+52|0;da=Ta+4|0;ea=Ta+8|0;fa=Ta+12|0;ga=Ta+16|0;ha=Ta+20|0;ia=Ta+24|0;ja=Ta+28|0;ka=Ta+32|0;la=Ta+36|0;ma=Ta+40|0;na=Ta+48|0;oa=Ta+44|0;pa=Ta+52|0;qa=Ta+4|0;ra=Ta+8|0;sa=Ta+12|0;ta=Ta+16|0;ua=Ta+20|0;va=Ta+24|0;wa=Ta+28|0;xa=Ta+32|0;ya=Ta+36|0;za=Ta+40|0;Aa=Ta+48|0;Ba=Ta+44|0;Ca=Ta+52|0;a=-1;P=Ua;e=f;do{if((e|0)>0){O=(P|0)==(Ua|0);M=0;do{f=k[Da>>2]|0;K=P-f|0;L=M-f|0;if(!M)if((k[Pa>>2]|0)>0){E=0;do{f=k[Fa>>2]|0;k[Ta>>2]=k[f+(E*56|0)>>2];e=f+(E*56|0)+4|0;k[da>>2]=k[e>>2];k[ea>>2]=k[f+(E*56|0)+8>>2];k[fa>>2]=k[f+(E*56|0)+12>>2];k[ga>>2]=k[f+(E*56|0)+16>>2];k[ha>>2]=k[f+(E*56|0)+20>>2];k[ia>>2]=k[f+(E*56|0)+24>>2];k[ja>>2]=k[f+(E*56|0)+28>>2];k[ka>>2]=k[f+(E*56|0)+32>>2];a=k[f+(E*56|0)+36>>2]|0;k[la>>2]=a;k[ma>>2]=ea;k[oa>>2]=na;k[pa>>2]=0;k[na>>2]=0;if(a|0){J=a+12|0;k[J>>2]=(k[J>>2]|0)+1}if((k[e>>2]|0)>=3){k[da>>2]=0;x1(Ta,k[e>>2]|0,0,0,0);if((k[da>>2]|0)>0){g=k[f+(E*56|0)+40>>2]|0;h=k[ma>>2]|0;a=k[f+(E*56|0)+44>>2]|0;f=k[oa>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[da>>2]|0))}}else{I=k[f+(E*56|0)+44>>2]|0;J=k[oa>>2]|0;k[J>>2]=k[I>>2];k[J+4>>2]=k[I+4>>2]}e=k[Ra>>2]|0;if((e|0)>0){y=k[ga>>2]|0;z=k[oa>>2]|0;A=aa(aa(Sa,E)|0,Sa)|0;B=b+(A<<2)|0;C=d+(A<<2)|0;D=c+(A<<2)|0;x=0;do{if((e|0)>0){s=x+P|0;t=aa(Sa,x)|0;u=B+(t<<2)|0;v=C+(t<<2)|0;w=D+(t<<2)|0;q=0;do{p=u+(q<<2)|0;k[p>>2]=0;e=k[Ma>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Qa,a)|0,Sa)|0,Sa)|0)<<2)+(A<<2)+(t<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ma>>2]|0}while((a|0)<(e|0))}o=k[Da>>2]|0;n=s-o|0;o=q-o|0;f=k[Ja>>2]|0;a=0-f|0;if((f|0)>=(a|0)){l=w+(q<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=k[Ka>>2]|0;h=k[Q>>2]|0;i=o+a|0;while(1){G=k[Ga>>2]|0;F=G+a|0;Wa=g+(aa(k[h>>2]|0,f+P+G|0)|0)|0;e=i+G|0;G=y+(aa(k[z>>2]|0,n+f+G|0)|0)|0;I=(m[Wa+(F<<3)>>1]|0)-(m[G+(e<<3)>>1]|0)|0;H=(m[Wa+(F<<3)+2>>1]|0)-(m[G+(e<<3)+2>>1]|0)|0;J=(m[Wa+(F<<3)+4>>1]|0)-(m[G+(e<<3)+4>>1]|0)|0;e=(m[Wa+(F<<3)+6>>1]|0)-(m[G+(e<<3)+6>>1]|0)|0;e=((H|0)>-1?H:0-H|0)+((I|0)>-1?I:0-I|0)+((J|0)>-1?J:0-J|0)+((e|0)>-1?e:0-e|0)|0;k[p>>2]=e+(k[p>>2]|0);k[l>>2]=e+(k[l>>2]|0);e=k[Ja>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;l=l+(Na<<2)|0}else break}e=k[Ma>>2]|0}e=c+((aa(aa(aa(Qa,e+-1|0)|0,Sa)|0,Sa)|0)<<2)+(A<<2)+(t<<2)+(q<<2)|0;k[v+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[Ra>>2]|0}while((q|0)<(e|0))}x=x+1|0}while((x|0)<(e|0))}e=k[la>>2]|0;if(e|0?(J=e+12|0,Wa=k[J>>2]|0,k[J>>2]=Wa+-1,(Wa|0)==1):0){a=k[la>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ka>>2]|0;if(e|0)break;e=B1()|0;a=k[la>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[la>>2]=0}k[la>>2]=0;k[ga>>2]=0;k[ga+4>>2]=0;k[ga+8>>2]=0;k[ga+12>>2]=0;if((k[da>>2]|0)>0){a=k[ma>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[da>>2]|0))}e=k[oa>>2]|0;if(!((e|0)==(na|0)|(e|0)==0))ggb(k[e+-4>>2]|0);E=E+1|0;e=k[Pa>>2]|0}while((E|0)<(e|0));a=0;H=125}else{a=0;q=0;p=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}else{e=k[Ga>>2]|0;if(O){G=e+Ua|0;E=e+M+(k[Ja>>2]|0)|0;F=G-f|0;e=k[Pa>>2]|0;if((e|0)>0){B=E-f|0;C=c+((aa(aa(aa(Qa,a)|0,Sa)|0,Sa)|0)<<2)|0;D=d+((aa(aa(aa(Qa,M)|0,Sa)|0,Sa)|0)<<2)|0;A=0;do{g=k[Fa>>2]|0;k[Ta>>2]=k[g+(A*56|0)>>2];e=g+(A*56|0)+4|0;k[qa>>2]=k[e>>2];k[ra>>2]=k[g+(A*56|0)+8>>2];k[sa>>2]=k[g+(A*56|0)+12>>2];k[ta>>2]=k[g+(A*56|0)+16>>2];k[ua>>2]=k[g+(A*56|0)+20>>2];k[va>>2]=k[g+(A*56|0)+24>>2];k[wa>>2]=k[g+(A*56|0)+28>>2];k[xa>>2]=k[g+(A*56|0)+32>>2];f=k[g+(A*56|0)+36>>2]|0;k[ya>>2]=f;k[za>>2]=ra;k[Ba>>2]=Aa;k[Ca>>2]=0;k[Aa>>2]=0;if(f|0){Wa=f+12|0;k[Wa>>2]=(k[Wa>>2]|0)+1}if((k[e>>2]|0)>=3){k[qa>>2]=0;x1(Ta,k[e>>2]|0,0,0,0);if((k[qa>>2]|0)>0){h=k[g+(A*56|0)+40>>2]|0;i=k[za>>2]|0;f=k[g+(A*56|0)+44>>2]|0;g=k[Ba>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[qa>>2]|0))}}else{J=k[g+(A*56|0)+44>>2]|0;Wa=k[Ba>>2]|0;k[Wa>>2]=k[J>>2];k[Wa+4>>2]=k[J+4>>2]}e=k[Ra>>2]|0;if((e|0)>0){v=k[ta>>2]|0;w=k[Ba>>2]|0;z=aa(aa(Sa,A)|0,Sa)|0;x=C+(z<<2)|0;y=b+(z<<2)|0;z=D+(z<<2)|0;u=0;do{if((e|0)>0){p=F+u|0;t=aa(Sa,u)|0;q=x+(t<<2)|0;s=y+(t<<2)|0;t=z+(t<<2)|0;o=0;do{l=q+(o<<2)|0;n=s+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=B+o|0;Wa=k[Ja>>2]|0;e=0-Wa|0;if((Wa|0)<(e|0))e=0;else{h=k[Ka>>2]|0;i=k[Q>>2]|0;f=e;e=0;while(1){Xa=h+(aa(k[i>>2]|0,f+G|0)|0)|0;Wa=v+(aa(k[w>>2]|0,p+f|0)|0)|0;H=(m[Xa+(E<<3)>>1]|0)-(m[Wa+(g<<3)>>1]|0)|0;I=(m[Xa+(E<<3)+2>>1]|0)-(m[Wa+(g<<3)+2>>1]|0)|0;J=(m[Xa+(E<<3)+4>>1]|0)-(m[Wa+(g<<3)+4>>1]|0)|0;Wa=(m[Xa+(E<<3)+6>>1]|0)-(m[Wa+(g<<3)+6>>1]|0)|0;e=e+((H|0)>-1?H:0-H|0)+((I|0)>-1?I:0-I|0)+((J|0)>-1?J:0-J|0)+((Wa|0)>-1?Wa:0-Wa|0)|0;k[l>>2]=e;if((f|0)<(k[Ja>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[t+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[Ra>>2]|0}while((o|0)<(e|0))}u=u+1|0}while((u|0)<(e|0))}e=k[ya>>2]|0;if(e|0?(Wa=e+12|0,Xa=k[Wa>>2]|0,k[Wa>>2]=Xa+-1,(Xa|0)==1):0){f=k[ya>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[xa>>2]|0;if(e|0)break;e=B1()|0;f=k[ya>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ya>>2]=0}k[ya>>2]=0;k[ta>>2]=0;k[ta+4>>2]=0;k[ta+8>>2]=0;k[ta+12>>2]=0;if((k[qa>>2]|0)>0){f=k[za>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[qa>>2]|0))}e=k[Ba>>2]|0;if(!((e|0)==(Aa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);A=A+1|0;e=k[Pa>>2]|0}while((A|0)<(e|0))}}else{Xa=e+P|0;H=e+M|0;I=k[Ja>>2]|0;h=H+I|0;J=Xa-f|0;H=H-f+I|0;e=k[Ka>>2]|0;f=k[k[Q>>2]>>2]|0;g=e+(aa(f,Xa+~I|0)|0)|0;f=e+(aa(f,Xa+I|0)|0)|0;I=k[Ra>>2]|0;e=k[Pa>>2]|0;if((e|0)>0){C=(I|0)>0;D=J+-1|0;E=m[f+(h<<3)>>1]|0;F=m[f+(h<<3)+2>>1]|0;G=m[f+(h<<3)+4>>1]|0;y=m[f+(h<<3)+6>>1]|0;z=m[g+(h<<3)>>1]|0;A=m[g+(h<<3)+2>>1]|0;B=m[g+(h<<3)+4>>1]|0;v=m[g+(h<<3)+6>>1]|0;w=c+((aa(aa(aa(Qa,a)|0,Sa)|0,Sa)|0)<<2)|0;x=d+((aa(aa(aa(Qa,M)|0,Sa)|0,Sa)|0)<<2)|0;u=0;do{g=k[Fa>>2]|0;k[Ta>>2]=k[g+(u*56|0)>>2];e=g+(u*56|0)+4|0;k[R>>2]=k[e>>2];k[S>>2]=k[g+(u*56|0)+8>>2];k[T>>2]=k[g+(u*56|0)+12>>2];k[U>>2]=k[g+(u*56|0)+16>>2];k[V>>2]=k[g+(u*56|0)+20>>2];k[W>>2]=k[g+(u*56|0)+24>>2];k[X>>2]=k[g+(u*56|0)+28>>2];k[Y>>2]=k[g+(u*56|0)+32>>2];f=k[g+(u*56|0)+36>>2]|0;k[Z>>2]=f;k[_>>2]=S;k[ba>>2]=$;k[ca>>2]=0;k[$>>2]=0;if(f|0){Xa=f+12|0;k[Xa>>2]=(k[Xa>>2]|0)+1}if((k[e>>2]|0)>=3){k[R>>2]=0;x1(Ta,k[e>>2]|0,0,0,0);if((k[R>>2]|0)>0){h=k[g+(u*56|0)+40>>2]|0;i=k[_>>2]|0;f=k[g+(u*56|0)+44>>2]|0;g=k[ba>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[R>>2]|0))}}else{Wa=k[g+(u*56|0)+44>>2]|0;Xa=k[ba>>2]|0;k[Xa>>2]=k[Wa>>2];k[Xa+4>>2]=k[Wa+4>>2]}i=aa(aa(Sa,u)|0,Sa)|0;g=b+(i<<2)|0;h=w+(i<<2)|0;i=x+(i<<2)|0;if(C){l=k[U>>2]|0;n=k[ba>>2]|0;f=0;do{q=aa(f,Sa)|0;o=g+(q<<2)|0;p=h+(q<<2)|0;q=i+(q<<2)|0;t=k[Ja>>2]|0;e=k[n>>2]|0;s=l+(aa(e,D+f-t|0)|0)|0;t=l+(aa(e,f+J+t|0)|0)|0;e=0;do{Wa=p+(e<<2)|0;Ya=o+(e<<2)|0;k[Ya>>2]=(k[Ya>>2]|0)-(k[Wa>>2]|0);Xa=q+(e<<2)|0;bb=H+e|0;ab=E-(m[t+(bb<<3)>>1]|0)|0;$a=F-(m[t+(bb<<3)+2>>1]|0)|0;_a=G-(m[t+(bb<<3)+4>>1]|0)|0;Za=y-(m[t+(bb<<3)+6>>1]|0)|0;eb=z-(m[s+(bb<<3)>>1]|0)|0;db=A-(m[s+(bb<<3)+2>>1]|0)|0;cb=B-(m[s+(bb<<3)+4>>1]|0)|0;bb=v-(m[s+(bb<<3)+6>>1]|0)|0;Za=(k[Xa>>2]|0)-((eb|0)>-1?eb:0-eb|0)-((db|0)>-1?db:0-db|0)-((cb|0)>-1?cb:0-cb|0)-((bb|0)>-1?bb:0-bb|0)+((ab|0)>-1?ab:0-ab|0)+(($a|0)>-1?$a:0-$a|0)+((_a|0)>-1?_a:0-_a|0)+((Za|0)>-1?Za:0-Za|0)|0;k[Wa>>2]=Za;k[Ya>>2]=Za+(k[Ya>>2]|0);k[Xa>>2]=k[Wa>>2];e=e+1|0}while((e|0)!=(I|0));f=f+1|0}while((f|0)!=(I|0))}e=k[Z>>2]|0;if(e|0?(db=e+12|0,eb=k[db>>2]|0,k[db>>2]=eb+-1,(eb|0)==1):0){f=k[Z>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[Y>>2]|0;if(e|0)break;e=B1()|0;f=k[Z>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[Z>>2]=0}k[Z>>2]=0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[R>>2]|0)>0){f=k[_>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[R>>2]|0))}e=k[ba>>2]|0;if(!((e|0)==($|0)|(e|0)==0))ggb(k[e+-4>>2]|0);u=u+1|0;e=k[Pa>>2]|0}while((u|0)<(e|0))}}a=(a+1|0)%(k[Ma>>2]|0)|0;H=125}if((H|0)==125){H=0;if((e|0)>0){E=k[Fa>>2]|0;F=k[Ra>>2]|0;G=(F|0)>0;D=0;f=0;s=0;h=0;g=0;l=0;i=0;o=0;n=0;q=0;p=0;do{if(G){z=k[Ga>>2]|0;A=k[E+(D*56|0)+16>>2]|0;B=k[k[E+(D*56|0)+44>>2]>>2]|0;C=b+((aa(aa(Sa,D)|0,Sa)|0)<<2)|0;x=k[Ha>>2]|0;y=k[Ia>>2]|0;w=0;do{u=A+(aa(B,K+w+z|0)|0)|0;v=C+((aa(Sa,w)|0)<<2)|0;t=0;do{db=k[y+(k[v+(t<<2)>>2]>>x<<2)>>2]|0;$a=L+t+z|0;ab=j[u+($a<<3)+2>>1]|0;bb=j[u+($a<<3)+4>>1]|0;cb=j[u+($a<<3)+6>>1]|0;eb=((db|0)<0)<<31>>31;$a=Epb(m[u+($a<<3)>>1]|0|0,0,db|0,eb|0)|0;o=kpb(o|0,n|0,$a|0,N|0)|0;n=N;ab=Epb(ab&65535|0,0,db|0,eb|0)|0;l=kpb(l|0,i|0,ab|0,N|0)|0;i=N;bb=Epb(bb&65535|0,0,db|0,eb|0)|0;h=kpb(h|0,g|0,bb|0,N|0)|0;g=N;cb=Epb(cb&65535|0,0,db|0,eb|0)|0;f=kpb(f|0,s|0,cb|0,N|0)|0;s=N;q=kpb(db|0,eb|0,q|0,p|0)|0;p=N;t=t+1|0}while((t|0)!=(F|0));w=w+1|0}while((w|0)!=(F|0))}D=D+1|0}while((D|0)!=(e|0));e=s}else{q=0;p=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}bb=Bpb(q|0,p|0,2,0)|0;ab=N;$a=kpb(o|0,n|0,bb|0,ab|0)|0;$a=spb($a|0,N|0,q|0,p|0)|0;_a=N;cb=kpb(l|0,i|0,bb|0,ab|0)|0;cb=spb(cb|0,N|0,q|0,p|0)|0;Za=N;eb=kpb(h|0,g|0,bb|0,ab|0)|0;eb=spb(eb|0,N|0,q|0,p|0)|0;db=N;ab=kpb(f|0,e|0,bb|0,ab|0)|0;ab=spb(ab|0,N|0,q|0,p|0)|0;bb=N;e=k[Ea>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,P)|0)+(M<<3)|0;ab=Apb((bb>>>0<0|(bb|0)==0&ab>>>0<65536?ab&65535:((bb|0)>0|(bb|0)==0&ab>>>0>0)<<31>>31)&65535|0,0,48)|0;bb=N;cb=Apb((Za>>>0<0|(Za|0)==0&cb>>>0<65536?cb&65535:((Za|0)>0|(Za|0)==0&cb>>>0>0)<<31>>31)&65535|0,0,16)|0;cb=(_a>>>0<0|(_a|0)==0&$a>>>0<65536?$a&65535:((_a|0)>0|(_a|0)==0&$a>>>0>0)<<31>>31)&65535|ab|cb;eb=bb|N|(db>>>0<0|(db|0)==0&eb>>>0<65536?eb&65535:((db|0)>0|(db|0)==0&eb>>>0>0)<<31>>31)&65535;db=e;j[db>>1]=cb;j[db+2>>1]=cb>>>16;e=e+4|0;j[e>>1]=eb;j[e+2>>1]=eb>>>16;M=M+1|0;e=k[La>>2]|0}while((M|0)<(e|0))}P=P+1|0}while((P|0)<(Oa|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Va;return}ggb(b);r=Va;return}function k2a(a){a=a|0;d2a(a);ggb(a);return}function l2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0;Va=r;r=r+64|0;Ta=Va;Ua=k[b>>2]|0;Oa=k[b+4>>2]|0;Pa=a+96|0;Qa=k[Pa>>2]|0;Ra=a+92|0;Sa=k[Ra>>2]|0;Na=aa(aa(Sa,Qa)|0,Sa)|0;c=Na>>>0>1073741823?-1:Na<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ma=a+88|0;d=aa(aa(aa(Qa,k[Ma>>2]|0)|0,Sa)|0,Sa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}La=a+8|0;f=k[La>>2]|0;e=aa(aa(aa(Qa,f)|0,Sa)|0,Sa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Ua|0)<(Oa|0)){Da=a+104|0;Ea=a+12|0;Fa=a+16|0;Ga=a+84|0;Ha=a+116|0;Ia=a+120|0;Ja=a+100|0;Ka=a+44|0;Q=a+72|0;R=Ta+4|0;S=Ta+8|0;T=Ta+12|0;U=Ta+16|0;V=Ta+20|0;W=Ta+24|0;X=Ta+28|0;Y=Ta+32|0;Z=Ta+36|0;_=Ta+40|0;$=Ta+48|0;ba=Ta+44|0;ca=Ta+52|0;da=Ta+4|0;ea=Ta+8|0;fa=Ta+12|0;ga=Ta+16|0;ha=Ta+20|0;ia=Ta+24|0;ja=Ta+28|0;ka=Ta+32|0;la=Ta+36|0;ma=Ta+40|0;na=Ta+48|0;oa=Ta+44|0;pa=Ta+52|0;qa=Ta+4|0;ra=Ta+8|0;sa=Ta+12|0;ta=Ta+16|0;ua=Ta+20|0;va=Ta+24|0;wa=Ta+28|0;xa=Ta+32|0;ya=Ta+36|0;za=Ta+40|0;Aa=Ta+48|0;Ba=Ta+44|0;Ca=Ta+52|0;a=-1;P=Ua;e=f;do{if((e|0)>0){O=(P|0)==(Ua|0);M=0;do{f=k[Da>>2]|0;K=P-f|0;L=M-f|0;if(!M)if((k[Pa>>2]|0)>0){E=0;do{f=k[Fa>>2]|0;k[Ta>>2]=k[f+(E*56|0)>>2];e=f+(E*56|0)+4|0;k[da>>2]=k[e>>2];k[ea>>2]=k[f+(E*56|0)+8>>2];k[fa>>2]=k[f+(E*56|0)+12>>2];k[ga>>2]=k[f+(E*56|0)+16>>2];k[ha>>2]=k[f+(E*56|0)+20>>2];k[ia>>2]=k[f+(E*56|0)+24>>2];k[ja>>2]=k[f+(E*56|0)+28>>2];k[ka>>2]=k[f+(E*56|0)+32>>2];a=k[f+(E*56|0)+36>>2]|0;k[la>>2]=a;k[ma>>2]=ea;k[oa>>2]=na;k[pa>>2]=0;k[na>>2]=0;if(a|0){J=a+12|0;k[J>>2]=(k[J>>2]|0)+1}if((k[e>>2]|0)>=3){k[da>>2]=0;x1(Ta,k[e>>2]|0,0,0,0);if((k[da>>2]|0)>0){g=k[f+(E*56|0)+40>>2]|0;h=k[ma>>2]|0;a=k[f+(E*56|0)+44>>2]|0;f=k[oa>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[da>>2]|0))}}else{I=k[f+(E*56|0)+44>>2]|0;J=k[oa>>2]|0;k[J>>2]=k[I>>2];k[J+4>>2]=k[I+4>>2]}e=k[Ra>>2]|0;if((e|0)>0){y=k[ga>>2]|0;z=k[oa>>2]|0;A=aa(aa(Sa,E)|0,Sa)|0;B=b+(A<<2)|0;C=d+(A<<2)|0;D=c+(A<<2)|0;x=0;do{if((e|0)>0){s=x+P|0;t=aa(Sa,x)|0;u=B+(t<<2)|0;v=C+(t<<2)|0;w=D+(t<<2)|0;q=0;do{p=u+(q<<2)|0;k[p>>2]=0;e=k[Ma>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Qa,a)|0,Sa)|0,Sa)|0)<<2)+(A<<2)+(t<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ma>>2]|0}while((a|0)<(e|0))}o=k[Da>>2]|0;n=s-o|0;o=q-o|0;f=k[Ja>>2]|0;a=0-f|0;if((f|0)>=(a|0)){l=w+(q<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=k[Ka>>2]|0;h=k[Q>>2]|0;i=o+a|0;while(1){H=k[Ga>>2]|0;G=H+a|0;F=g+(aa(k[h>>2]|0,f+P+H|0)|0)|0;e=i+H|0;H=y+(aa(k[z>>2]|0,n+f+H|0)|0)|0;J=(m[F+(G*6|0)>>1]|0)-(m[H+(e*6|0)>>1]|0)|0;I=(m[F+(G*6|0)+2>>1]|0)-(m[H+(e*6|0)+2>>1]|0)|0;e=(m[F+(G*6|0)+4>>1]|0)-(m[H+(e*6|0)+4>>1]|0)|0;e=((I|0)>-1?I:0-I|0)+((J|0)>-1?J:0-J|0)+((e|0)>-1?e:0-e|0)|0;k[p>>2]=e+(k[p>>2]|0);k[l>>2]=e+(k[l>>2]|0);e=k[Ja>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;l=l+(Na<<2)|0}else break}e=k[Ma>>2]|0}e=c+((aa(aa(aa(Qa,e+-1|0)|0,Sa)|0,Sa)|0)<<2)+(A<<2)+(t<<2)+(q<<2)|0;k[v+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[Ra>>2]|0}while((q|0)<(e|0))}x=x+1|0}while((x|0)<(e|0))}e=k[la>>2]|0;if(e|0?(I=e+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){a=k[la>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ka>>2]|0;if(e|0)break;e=B1()|0;a=k[la>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[la>>2]=0}k[la>>2]=0;k[ga>>2]=0;k[ga+4>>2]=0;k[ga+8>>2]=0;k[ga+12>>2]=0;if((k[da>>2]|0)>0){a=k[ma>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[da>>2]|0))}e=k[oa>>2]|0;if(!((e|0)==(na|0)|(e|0)==0))ggb(k[e+-4>>2]|0);E=E+1|0;e=k[Pa>>2]|0}while((E|0)<(e|0));a=0;J=125}else{a=0;t=0;s=0;q=0;p=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}else{e=k[Ga>>2]|0;if(O){G=e+Ua|0;E=e+M+(k[Ja>>2]|0)|0;F=G-f|0;e=k[Pa>>2]|0;if((e|0)>0){B=E-f|0;C=c+((aa(aa(aa(Qa,a)|0,Sa)|0,Sa)|0)<<2)|0;D=d+((aa(aa(aa(Qa,M)|0,Sa)|0,Sa)|0)<<2)|0;A=0;do{g=k[Fa>>2]|0;k[Ta>>2]=k[g+(A*56|0)>>2];e=g+(A*56|0)+4|0;k[qa>>2]=k[e>>2];k[ra>>2]=k[g+(A*56|0)+8>>2];k[sa>>2]=k[g+(A*56|0)+12>>2];k[ta>>2]=k[g+(A*56|0)+16>>2];k[ua>>2]=k[g+(A*56|0)+20>>2];k[va>>2]=k[g+(A*56|0)+24>>2];k[wa>>2]=k[g+(A*56|0)+28>>2];k[xa>>2]=k[g+(A*56|0)+32>>2];f=k[g+(A*56|0)+36>>2]|0;k[ya>>2]=f;k[za>>2]=ra;k[Ba>>2]=Aa;k[Ca>>2]=0;k[Aa>>2]=0;if(f|0){J=f+12|0;k[J>>2]=(k[J>>2]|0)+1}if((k[e>>2]|0)>=3){k[qa>>2]=0;x1(Ta,k[e>>2]|0,0,0,0);if((k[qa>>2]|0)>0){h=k[g+(A*56|0)+40>>2]|0;i=k[za>>2]|0;f=k[g+(A*56|0)+44>>2]|0;g=k[Ba>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[qa>>2]|0))}}else{I=k[g+(A*56|0)+44>>2]|0;J=k[Ba>>2]|0;k[J>>2]=k[I>>2];k[J+4>>2]=k[I+4>>2]}e=k[Ra>>2]|0;if((e|0)>0){v=k[ta>>2]|0;w=k[Ba>>2]|0;z=aa(aa(Sa,A)|0,Sa)|0;x=C+(z<<2)|0;y=b+(z<<2)|0;z=D+(z<<2)|0;u=0;do{if((e|0)>0){p=F+u|0;t=aa(Sa,u)|0;q=x+(t<<2)|0;s=y+(t<<2)|0;t=z+(t<<2)|0;o=0;do{l=q+(o<<2)|0;n=s+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=B+o|0;J=k[Ja>>2]|0;e=0-J|0;if((J|0)<(e|0))e=0;else{h=k[Ka>>2]|0;i=k[Q>>2]|0;f=e;e=0;while(1){Wa=h+(aa(k[i>>2]|0,f+G|0)|0)|0;J=v+(aa(k[w>>2]|0,p+f|0)|0)|0;H=(m[Wa+(E*6|0)>>1]|0)-(m[J+(g*6|0)>>1]|0)|0;I=(m[Wa+(E*6|0)+2>>1]|0)-(m[J+(g*6|0)+2>>1]|0)|0;J=(m[Wa+(E*6|0)+4>>1]|0)-(m[J+(g*6|0)+4>>1]|0)|0;e=((H|0)>-1?H:0-H|0)+e+((I|0)>-1?I:0-I|0)+((J|0)>-1?J:0-J|0)|0;k[l>>2]=e;if((f|0)<(k[Ja>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[t+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[Ra>>2]|0}while((o|0)<(e|0))}u=u+1|0}while((u|0)<(e|0))}e=k[ya>>2]|0;if(e|0?(J=e+12|0,Wa=k[J>>2]|0,k[J>>2]=Wa+-1,(Wa|0)==1):0){f=k[ya>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[xa>>2]|0;if(e|0)break;e=B1()|0;f=k[ya>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ya>>2]=0}k[ya>>2]=0;k[ta>>2]=0;k[ta+4>>2]=0;k[ta+8>>2]=0;k[ta+12>>2]=0;if((k[qa>>2]|0)>0){f=k[za>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[qa>>2]|0))}e=k[Ba>>2]|0;if(!((e|0)==(Aa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);A=A+1|0;e=k[Pa>>2]|0}while((A|0)<(e|0))}}else{Wa=e+P|0;F=e+M|0;G=k[Ja>>2]|0;h=F+G|0;H=Wa-f|0;F=F-f+G|0;e=k[Ka>>2]|0;f=k[k[Q>>2]>>2]|0;g=e+(aa(f,Wa+~G|0)|0)|0;f=e+(aa(f,Wa+G|0)|0)|0;G=k[Ra>>2]|0;e=k[Pa>>2]|0;if((e|0)>0){B=(G|0)>0;C=H+-1|0;D=m[f+(h*6|0)>>1]|0;E=m[f+(h*6|0)+2>>1]|0;y=m[f+(h*6|0)+4>>1]|0;z=m[g+(h*6|0)>>1]|0;A=m[g+(h*6|0)+2>>1]|0;v=m[g+(h*6|0)+4>>1]|0;w=c+((aa(aa(aa(Qa,a)|0,Sa)|0,Sa)|0)<<2)|0;x=d+((aa(aa(aa(Qa,M)|0,Sa)|0,Sa)|0)<<2)|0;u=0;do{g=k[Fa>>2]|0;k[Ta>>2]=k[g+(u*56|0)>>2];e=g+(u*56|0)+4|0;k[R>>2]=k[e>>2];k[S>>2]=k[g+(u*56|0)+8>>2];k[T>>2]=k[g+(u*56|0)+12>>2];k[U>>2]=k[g+(u*56|0)+16>>2];k[V>>2]=k[g+(u*56|0)+20>>2];k[W>>2]=k[g+(u*56|0)+24>>2];k[X>>2]=k[g+(u*56|0)+28>>2];k[Y>>2]=k[g+(u*56|0)+32>>2];f=k[g+(u*56|0)+36>>2]|0;k[Z>>2]=f;k[_>>2]=S;k[ba>>2]=$;k[ca>>2]=0;k[$>>2]=0;if(f|0){Wa=f+12|0;k[Wa>>2]=(k[Wa>>2]|0)+1}if((k[e>>2]|0)>=3){k[R>>2]=0;x1(Ta,k[e>>2]|0,0,0,0);if((k[R>>2]|0)>0){h=k[g+(u*56|0)+40>>2]|0;i=k[_>>2]|0;f=k[g+(u*56|0)+44>>2]|0;g=k[ba>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[R>>2]|0))}}else{J=k[g+(u*56|0)+44>>2]|0;Wa=k[ba>>2]|0;k[Wa>>2]=k[J>>2];k[Wa+4>>2]=k[J+4>>2]}i=aa(aa(Sa,u)|0,Sa)|0;g=b+(i<<2)|0;h=w+(i<<2)|0;i=x+(i<<2)|0;if(B){l=k[U>>2]|0;n=k[ba>>2]|0;f=0;do{q=aa(f,Sa)|0;o=g+(q<<2)|0;p=h+(q<<2)|0;q=i+(q<<2)|0;t=k[Ja>>2]|0;e=k[n>>2]|0;s=l+(aa(e,C+f-t|0)|0)|0;t=l+(aa(e,f+H+t|0)|0)|0;e=0;do{J=p+(e<<2)|0;I=o+(e<<2)|0;k[I>>2]=(k[I>>2]|0)-(k[J>>2]|0);Wa=q+(e<<2)|0;_a=F+e|0;Za=D-(m[t+(_a*6|0)>>1]|0)|0;Ya=E-(m[t+(_a*6|0)+2>>1]|0)|0;Xa=y-(m[t+(_a*6|0)+4>>1]|0)|0;ab=z-(m[s+(_a*6|0)>>1]|0)|0;$a=A-(m[s+(_a*6|0)+2>>1]|0)|0;_a=v-(m[s+(_a*6|0)+4>>1]|0)|0;Xa=(k[Wa>>2]|0)-((ab|0)>-1?ab:0-ab|0)-(($a|0)>-1?$a:0-$a|0)-((_a|0)>-1?_a:0-_a|0)+((Za|0)>-1?Za:0-Za|0)+((Ya|0)>-1?Ya:0-Ya|0)+((Xa|0)>-1?Xa:0-Xa|0)|0;k[J>>2]=Xa;k[I>>2]=Xa+(k[I>>2]|0);k[Wa>>2]=k[J>>2];e=e+1|0}while((e|0)!=(G|0));f=f+1|0}while((f|0)!=(G|0))}e=k[Z>>2]|0;if(e|0?($a=e+12|0,ab=k[$a>>2]|0,k[$a>>2]=ab+-1,(ab|0)==1):0){f=k[Z>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[Y>>2]|0;if(e|0)break;e=B1()|0;f=k[Z>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[Z>>2]=0}k[Z>>2]=0;k[U>>2]=0;k[U+4>>2]=0;k[U+8>>2]=0;k[U+12>>2]=0;if((k[R>>2]|0)>0){f=k[_>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[R>>2]|0))}e=k[ba>>2]|0;if(!((e|0)==($|0)|(e|0)==0))ggb(k[e+-4>>2]|0);u=u+1|0;e=k[Pa>>2]|0}while((u|0)<(e|0))}}a=(a+1|0)%(k[Ma>>2]|0)|0;J=125}if((J|0)==125){J=0;if((e|0)>0){G=k[Fa>>2]|0;H=k[Ra>>2]|0;I=(H|0)>0;F=0;h=0;g=0;o=0;n=0;t=0;s=0;f=0;u=0;l=0;i=0;q=0;p=0;do{if(I){B=k[Ga>>2]|0;C=k[G+(F*56|0)+16>>2]|0;D=k[k[G+(F*56|0)+44>>2]>>2]|0;E=b+((aa(aa(Sa,F)|0,Sa)|0)<<2)|0;z=k[Ha>>2]|0;A=k[Ia>>2]|0;y=0;do{w=C+(aa(D,K+y+B|0)|0)|0;x=E+((aa(Sa,y)|0)<<2)|0;v=0;do{$a=k[x+(v<<2)>>2]>>z;Xa=k[A+($a*12|0)>>2]|0;Za=k[A+($a*12|0)+4>>2]|0;$a=k[A+($a*12|0)+8>>2]|0;_a=L+v+B|0;ab=j[w+(_a*6|0)+2>>1]|0;Wa=j[w+(_a*6|0)+4>>1]|0;Ya=((Xa|0)<0)<<31>>31;_a=Epb(m[w+(_a*6|0)>>1]|0|0,0,Xa|0,Ya|0)|0;q=kpb(q|0,p|0,_a|0,N|0)|0;p=N;_a=((Za|0)<0)<<31>>31;ab=Epb(ab&65535|0,0,Za|0,_a|0)|0;l=kpb(l|0,i|0,ab|0,N|0)|0;i=N;ab=(($a|0)<0)<<31>>31;Wa=Epb(Wa&65535|0,0,$a|0,ab|0)|0;f=kpb(f|0,u|0,Wa|0,N|0)|0;u=N;t=kpb(t|0,s|0,Xa|0,Ya|0)|0;s=N;o=kpb(o|0,n|0,Za|0,_a|0)|0;n=N;h=kpb(h|0,g|0,$a|0,ab|0)|0;g=N;v=v+1|0}while((v|0)!=(H|0));y=y+1|0}while((y|0)!=(H|0))}F=F+1|0}while((F|0)!=(e|0));e=u}else{t=0;s=0;q=0;p=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}Ya=Bpb(t|0,s|0,2,0)|0;Ya=kpb(Ya|0,N|0,q|0,p|0)|0;Ya=spb(Ya|0,N|0,t|0,s|0)|0;Xa=N;_a=Bpb(o|0,n|0,2,0)|0;_a=kpb(_a|0,N|0,l|0,i|0)|0;_a=spb(_a|0,N|0,o|0,n|0)|0;Za=N;ab=Bpb(h|0,g|0,2,0)|0;ab=kpb(ab|0,N|0,f|0,e|0)|0;ab=spb(ab|0,N|0,h|0,g|0)|0;$a=N;e=k[Ea>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,P)|0)|0;j[e+(M*6|0)>>1]=Xa>>>0<0|(Xa|0)==0&Ya>>>0<65536?Ya&65535:((Xa|0)>0|(Xa|0)==0&Ya>>>0>0)<<31>>31;j[e+(M*6|0)+2>>1]=Za>>>0<0|(Za|0)==0&_a>>>0<65536?_a&65535:((Za|0)>0|(Za|0)==0&_a>>>0>0)<<31>>31;j[e+(M*6|0)+4>>1]=$a>>>0<0|($a|0)==0&ab>>>0<65536?ab&65535:(($a|0)>0|($a|0)==0&ab>>>0>0)<<31>>31;M=M+1|0;e=k[La>>2]|0}while((M|0)<(e|0))}P=P+1|0}while((P|0)<(Oa|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Va;return}ggb(b);r=Va;return}function m2a(a){a=a|0;c2a(a);ggb(a);return}function n2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0;Ta=r;r=r+64|0;Ra=Ta;Sa=k[b>>2]|0;Ma=k[b+4>>2]|0;Na=a+96|0;Oa=k[Na>>2]|0;Pa=a+92|0;Qa=k[Pa>>2]|0;La=aa(aa(Qa,Oa)|0,Qa)|0;c=La>>>0>1073741823?-1:La<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ka=a+88|0;d=aa(aa(aa(Oa,k[Ka>>2]|0)|0,Qa)|0,Qa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ja=a+8|0;f=k[Ja>>2]|0;e=aa(aa(aa(Oa,f)|0,Qa)|0,Qa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Sa|0)<(Ma|0)){Ba=a+104|0;Ca=a+12|0;Da=a+16|0;Ea=a+84|0;Fa=a+116|0;Ga=a+120|0;Ha=a+100|0;Ia=a+44|0;O=a+72|0;P=Ra+4|0;Q=Ra+8|0;R=Ra+12|0;S=Ra+16|0;T=Ra+20|0;U=Ra+24|0;V=Ra+28|0;W=Ra+32|0;X=Ra+36|0;Y=Ra+40|0;Z=Ra+48|0;_=Ra+44|0;$=Ra+52|0;ba=Ra+4|0;ca=Ra+8|0;da=Ra+12|0;ea=Ra+16|0;fa=Ra+20|0;ga=Ra+24|0;ha=Ra+28|0;ia=Ra+32|0;ja=Ra+36|0;ka=Ra+40|0;la=Ra+48|0;ma=Ra+44|0;na=Ra+52|0;oa=Ra+4|0;pa=Ra+8|0;qa=Ra+12|0;ra=Ra+16|0;sa=Ra+20|0;ta=Ra+24|0;ua=Ra+28|0;va=Ra+32|0;wa=Ra+36|0;xa=Ra+40|0;ya=Ra+48|0;za=Ra+44|0;Aa=Ra+52|0;a=-1;M=Sa;e=f;do{if((e|0)>0){L=(M|0)==(Sa|0);K=0;do{f=k[Ba>>2]|0;I=M-f|0;J=K-f|0;if(!K)if((k[Na>>2]|0)>0){E=0;do{f=k[Da>>2]|0;k[Ra>>2]=k[f+(E*56|0)>>2];e=f+(E*56|0)+4|0;k[ba>>2]=k[e>>2];k[ca>>2]=k[f+(E*56|0)+8>>2];k[da>>2]=k[f+(E*56|0)+12>>2];k[ea>>2]=k[f+(E*56|0)+16>>2];k[fa>>2]=k[f+(E*56|0)+20>>2];k[ga>>2]=k[f+(E*56|0)+24>>2];k[ha>>2]=k[f+(E*56|0)+28>>2];k[ia>>2]=k[f+(E*56|0)+32>>2];a=k[f+(E*56|0)+36>>2]|0;k[ja>>2]=a;k[ka>>2]=ca;k[ma>>2]=la;k[na>>2]=0;k[la>>2]=0;if(a|0){H=a+12|0;k[H>>2]=(k[H>>2]|0)+1}if((k[e>>2]|0)>=3){k[ba>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[ba>>2]|0)>0){g=k[f+(E*56|0)+40>>2]|0;h=k[ka>>2]|0;a=k[f+(E*56|0)+44>>2]|0;f=k[ma>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ba>>2]|0))}}else{G=k[f+(E*56|0)+44>>2]|0;H=k[ma>>2]|0;k[H>>2]=k[G>>2];k[H+4>>2]=k[G+4>>2]}e=k[Pa>>2]|0;if((e|0)>0){y=k[ea>>2]|0;z=k[ma>>2]|0;A=aa(aa(Qa,E)|0,Qa)|0;B=b+(A<<2)|0;C=d+(A<<2)|0;D=c+(A<<2)|0;x=0;do{if((e|0)>0){s=x+M|0;t=aa(Qa,x)|0;u=B+(t<<2)|0;v=C+(t<<2)|0;w=D+(t<<2)|0;q=0;do{p=u+(q<<2)|0;k[p>>2]=0;e=k[Ka>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)+(A<<2)+(t<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ka>>2]|0}while((a|0)<(e|0))}o=k[Ba>>2]|0;n=s-o|0;o=q-o|0;f=k[Ha>>2]|0;a=0-f|0;if((f|0)>=(a|0)){l=w+(q<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=k[Ia>>2]|0;h=k[O>>2]|0;i=o+a|0;while(1){F=k[Ea>>2]|0;Ua=F+a|0;Va=g+(aa(k[h>>2]|0,f+M+F|0)|0)|0;e=i+F|0;F=y+(aa(k[z>>2]|0,n+f+F|0)|0)|0;H=(m[Va+(Ua*6|0)>>1]|0)-(m[F+(e*6|0)>>1]|0)|0;G=(m[Va+(Ua*6|0)+2>>1]|0)-(m[F+(e*6|0)+2>>1]|0)|0;e=(m[Va+(Ua*6|0)+4>>1]|0)-(m[F+(e*6|0)+4>>1]|0)|0;e=((G|0)>-1?G:0-G|0)+((H|0)>-1?H:0-H|0)+((e|0)>-1?e:0-e|0)|0;k[p>>2]=e+(k[p>>2]|0);k[l>>2]=e+(k[l>>2]|0);e=k[Ha>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;l=l+(La<<2)|0}else break}e=k[Ka>>2]|0}e=c+((aa(aa(aa(Oa,e+-1|0)|0,Qa)|0,Qa)|0)<<2)+(A<<2)+(t<<2)+(q<<2)|0;k[v+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[Pa>>2]|0}while((q|0)<(e|0))}x=x+1|0}while((x|0)<(e|0))}e=k[ja>>2]|0;if(e|0?(Ua=e+12|0,Va=k[Ua>>2]|0,k[Ua>>2]=Va+-1,(Va|0)==1):0){a=k[ja>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ia>>2]|0;if(e|0)break;e=B1()|0;a=k[ja>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ja>>2]=0}k[ja>>2]=0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[ba>>2]|0)>0){a=k[ka>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ba>>2]|0))}e=k[ma>>2]|0;if(!((e|0)==(la|0)|(e|0)==0))ggb(k[e+-4>>2]|0);E=E+1|0;e=k[Na>>2]|0}while((E|0)<(e|0));a=0;F=125}else{a=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}else{e=k[Ea>>2]|0;if(L){G=e+Sa|0;E=e+K+(k[Ha>>2]|0)|0;F=G-f|0;e=k[Na>>2]|0;if((e|0)>0){B=E-f|0;C=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)|0;D=d+((aa(aa(aa(Oa,K)|0,Qa)|0,Qa)|0)<<2)|0;A=0;do{g=k[Da>>2]|0;k[Ra>>2]=k[g+(A*56|0)>>2];e=g+(A*56|0)+4|0;k[oa>>2]=k[e>>2];k[pa>>2]=k[g+(A*56|0)+8>>2];k[qa>>2]=k[g+(A*56|0)+12>>2];k[ra>>2]=k[g+(A*56|0)+16>>2];k[sa>>2]=k[g+(A*56|0)+20>>2];k[ta>>2]=k[g+(A*56|0)+24>>2];k[ua>>2]=k[g+(A*56|0)+28>>2];k[va>>2]=k[g+(A*56|0)+32>>2];f=k[g+(A*56|0)+36>>2]|0;k[wa>>2]=f;k[xa>>2]=pa;k[za>>2]=ya;k[Aa>>2]=0;k[ya>>2]=0;if(f|0){Va=f+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[e>>2]|0)>=3){k[oa>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[oa>>2]|0)>0){h=k[g+(A*56|0)+40>>2]|0;i=k[xa>>2]|0;f=k[g+(A*56|0)+44>>2]|0;g=k[za>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[oa>>2]|0))}}else{Ua=k[g+(A*56|0)+44>>2]|0;Va=k[za>>2]|0;k[Va>>2]=k[Ua>>2];k[Va+4>>2]=k[Ua+4>>2]}e=k[Pa>>2]|0;if((e|0)>0){v=k[ra>>2]|0;w=k[za>>2]|0;z=aa(aa(Qa,A)|0,Qa)|0;x=C+(z<<2)|0;y=b+(z<<2)|0;z=D+(z<<2)|0;u=0;do{if((e|0)>0){p=F+u|0;t=aa(Qa,u)|0;q=x+(t<<2)|0;s=y+(t<<2)|0;t=z+(t<<2)|0;o=0;do{l=q+(o<<2)|0;n=s+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=B+o|0;Va=k[Ha>>2]|0;e=0-Va|0;if((Va|0)<(e|0))e=0;else{h=k[Ia>>2]|0;i=k[O>>2]|0;f=e;e=0;while(1){Wa=h+(aa(k[i>>2]|0,f+G|0)|0)|0;Va=v+(aa(k[w>>2]|0,p+f|0)|0)|0;H=(m[Wa+(E*6|0)>>1]|0)-(m[Va+(g*6|0)>>1]|0)|0;Ua=(m[Wa+(E*6|0)+2>>1]|0)-(m[Va+(g*6|0)+2>>1]|0)|0;Va=(m[Wa+(E*6|0)+4>>1]|0)-(m[Va+(g*6|0)+4>>1]|0)|0;e=((H|0)>-1?H:0-H|0)+e+((Ua|0)>-1?Ua:0-Ua|0)+((Va|0)>-1?Va:0-Va|0)|0;k[l>>2]=e;if((f|0)<(k[Ha>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[t+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[Pa>>2]|0}while((o|0)<(e|0))}u=u+1|0}while((u|0)<(e|0))}e=k[wa>>2]|0;if(e|0?(Va=e+12|0,Wa=k[Va>>2]|0,k[Va>>2]=Wa+-1,(Wa|0)==1):0){f=k[wa>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[va>>2]|0;if(e|0)break;e=B1()|0;f=k[wa>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[wa>>2]=0}k[wa>>2]=0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[oa>>2]|0)>0){f=k[xa>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[oa>>2]|0))}e=k[za>>2]|0;if(!((e|0)==(ya|0)|(e|0)==0))ggb(k[e+-4>>2]|0);A=A+1|0;e=k[Na>>2]|0}while((A|0)<(e|0))}}else{Wa=e+M|0;F=e+K|0;G=k[Ha>>2]|0;h=F+G|0;H=Wa-f|0;F=F-f+G|0;e=k[Ia>>2]|0;f=k[k[O>>2]>>2]|0;g=e+(aa(f,Wa+~G|0)|0)|0;f=e+(aa(f,Wa+G|0)|0)|0;G=k[Pa>>2]|0;e=k[Na>>2]|0;if((e|0)>0){B=(G|0)>0;C=H+-1|0;D=m[f+(h*6|0)>>1]|0;E=m[f+(h*6|0)+2>>1]|0;y=m[f+(h*6|0)+4>>1]|0;z=m[g+(h*6|0)>>1]|0;A=m[g+(h*6|0)+2>>1]|0;v=m[g+(h*6|0)+4>>1]|0;w=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)|0;x=d+((aa(aa(aa(Oa,K)|0,Qa)|0,Qa)|0)<<2)|0;u=0;do{g=k[Da>>2]|0;k[Ra>>2]=k[g+(u*56|0)>>2];e=g+(u*56|0)+4|0;k[P>>2]=k[e>>2];k[Q>>2]=k[g+(u*56|0)+8>>2];k[R>>2]=k[g+(u*56|0)+12>>2];k[S>>2]=k[g+(u*56|0)+16>>2];k[T>>2]=k[g+(u*56|0)+20>>2];k[U>>2]=k[g+(u*56|0)+24>>2];k[V>>2]=k[g+(u*56|0)+28>>2];k[W>>2]=k[g+(u*56|0)+32>>2];f=k[g+(u*56|0)+36>>2]|0;k[X>>2]=f;k[Y>>2]=Q;k[_>>2]=Z;k[$>>2]=0;k[Z>>2]=0;if(f|0){Wa=f+12|0;k[Wa>>2]=(k[Wa>>2]|0)+1}if((k[e>>2]|0)>=3){k[P>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[P>>2]|0)>0){h=k[g+(u*56|0)+40>>2]|0;i=k[Y>>2]|0;f=k[g+(u*56|0)+44>>2]|0;g=k[_>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[P>>2]|0))}}else{Va=k[g+(u*56|0)+44>>2]|0;Wa=k[_>>2]|0;k[Wa>>2]=k[Va>>2];k[Wa+4>>2]=k[Va+4>>2]}i=aa(aa(Qa,u)|0,Qa)|0;g=b+(i<<2)|0;h=w+(i<<2)|0;i=x+(i<<2)|0;if(B){l=k[S>>2]|0;n=k[_>>2]|0;f=0;do{q=aa(f,Qa)|0;o=g+(q<<2)|0;p=h+(q<<2)|0;q=i+(q<<2)|0;t=k[Ha>>2]|0;e=k[n>>2]|0;s=l+(aa(e,C+f-t|0)|0)|0;t=l+(aa(e,f+H+t|0)|0)|0;e=0;do{Va=p+(e<<2)|0;Ua=o+(e<<2)|0;k[Ua>>2]=(k[Ua>>2]|0)-(k[Va>>2]|0);Wa=q+(e<<2)|0;_a=F+e|0;Za=D-(m[t+(_a*6|0)>>1]|0)|0;Ya=E-(m[t+(_a*6|0)+2>>1]|0)|0;Xa=y-(m[t+(_a*6|0)+4>>1]|0)|0;ab=z-(m[s+(_a*6|0)>>1]|0)|0;$a=A-(m[s+(_a*6|0)+2>>1]|0)|0;_a=v-(m[s+(_a*6|0)+4>>1]|0)|0;Xa=(k[Wa>>2]|0)-((ab|0)>-1?ab:0-ab|0)-(($a|0)>-1?$a:0-$a|0)-((_a|0)>-1?_a:0-_a|0)+((Za|0)>-1?Za:0-Za|0)+((Ya|0)>-1?Ya:0-Ya|0)+((Xa|0)>-1?Xa:0-Xa|0)|0;k[Va>>2]=Xa;k[Ua>>2]=Xa+(k[Ua>>2]|0);k[Wa>>2]=k[Va>>2];e=e+1|0}while((e|0)!=(G|0));f=f+1|0}while((f|0)!=(G|0))}e=k[X>>2]|0;if(e|0?($a=e+12|0,ab=k[$a>>2]|0,k[$a>>2]=ab+-1,(ab|0)==1):0){f=k[X>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[W>>2]|0;if(e|0)break;e=B1()|0;f=k[X>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[X>>2]=0}k[X>>2]=0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[P>>2]|0)>0){f=k[Y>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[P>>2]|0))}e=k[_>>2]|0;if(!((e|0)==(Z|0)|(e|0)==0))ggb(k[e+-4>>2]|0);u=u+1|0;e=k[Na>>2]|0}while((u|0)<(e|0))}}a=(a+1|0)%(k[Ka>>2]|0)|0;F=125}if((F|0)==125){F=0;if((e|0)>0){C=k[Da>>2]|0;D=k[Pa>>2]|0;E=(D|0)>0;B=0;f=0;p=0;h=0;g=0;l=0;i=0;o=0;n=0;do{if(E){x=k[Ea>>2]|0;y=k[C+(B*56|0)+16>>2]|0;z=k[k[C+(B*56|0)+44>>2]>>2]|0;A=b+((aa(aa(Qa,B)|0,Qa)|0)<<2)|0;v=k[Fa>>2]|0;w=k[Ga>>2]|0;u=0;do{s=y+(aa(z,I+u+x|0)|0)|0;t=A+((aa(Qa,u)|0)<<2)|0;q=0;do{$a=k[w+(k[t+(q<<2)>>2]>>v<<2)>>2]|0;Ya=J+q+x|0;Za=j[s+(Ya*6|0)+2>>1]|0;_a=j[s+(Ya*6|0)+4>>1]|0;ab=(($a|0)<0)<<31>>31;Ya=Epb(m[s+(Ya*6|0)>>1]|0|0,0,$a|0,ab|0)|0;l=kpb(l|0,i|0,Ya|0,N|0)|0;i=N;Za=Epb(Za&65535|0,0,$a|0,ab|0)|0;h=kpb(h|0,g|0,Za|0,N|0)|0;g=N;_a=Epb(_a&65535|0,0,$a|0,ab|0)|0;f=kpb(f|0,p|0,_a|0,N|0)|0;p=N;o=kpb($a|0,ab|0,o|0,n|0)|0;n=N;q=q+1|0}while((q|0)!=(D|0));u=u+1|0}while((u|0)!=(D|0))}B=B+1|0}while((B|0)!=(e|0));e=p}else{o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}$a=Bpb(o|0,n|0,2,0)|0;ab=N;Ya=kpb(l|0,i|0,$a|0,ab|0)|0;Ya=spb(Ya|0,N|0,o|0,n|0)|0;Xa=N;_a=kpb(h|0,g|0,$a|0,ab|0)|0;_a=spb(_a|0,N|0,o|0,n|0)|0;Za=N;ab=kpb(f|0,e|0,$a|0,ab|0)|0;ab=spb(ab|0,N|0,o|0,n|0)|0;$a=N;e=k[Ca>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,M)|0)|0;j[e+(K*6|0)>>1]=Xa>>>0<0|(Xa|0)==0&Ya>>>0<65536?Ya&65535:((Xa|0)>0|(Xa|0)==0&Ya>>>0>0)<<31>>31;j[e+(K*6|0)+2>>1]=Za>>>0<0|(Za|0)==0&_a>>>0<65536?_a&65535:((Za|0)>0|(Za|0)==0&_a>>>0>0)<<31>>31;j[e+(K*6|0)+4>>1]=$a>>>0<0|($a|0)==0&ab>>>0<65536?ab&65535:(($a|0)>0|($a|0)==0&ab>>>0>0)<<31>>31;K=K+1|0;e=k[Ja>>2]|0}while((K|0)<(e|0))}M=M+1|0}while((M|0)<(Ma|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Ta;return}ggb(b);r=Ta;return}function o2a(a){a=a|0;b2a(a);ggb(a);return}function p2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0;Sa=r;r=r+64|0;Qa=Sa;Ra=k[b>>2]|0;La=k[b+4>>2]|0;Ma=a+96|0;Na=k[Ma>>2]|0;Oa=a+92|0;Pa=k[Oa>>2]|0;Ka=aa(aa(Pa,Na)|0,Pa)|0;c=Ka>>>0>1073741823?-1:Ka<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ja=a+88|0;d=aa(aa(aa(Na,k[Ja>>2]|0)|0,Pa)|0,Pa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ia=a+8|0;f=k[Ia>>2]|0;e=aa(aa(aa(Na,f)|0,Pa)|0,Pa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Ra|0)<(La|0)){Aa=a+104|0;Ba=a+12|0;Ca=a+16|0;Da=a+84|0;Ea=a+116|0;Fa=a+120|0;Ga=a+100|0;Ha=a+44|0;M=a+72|0;O=Qa+4|0;P=Qa+8|0;Q=Qa+12|0;R=Qa+16|0;S=Qa+20|0;T=Qa+24|0;U=Qa+28|0;V=Qa+32|0;W=Qa+36|0;X=Qa+40|0;Y=Qa+48|0;Z=Qa+44|0;_=Qa+52|0;$=Qa+4|0;ba=Qa+8|0;ca=Qa+12|0;da=Qa+16|0;ea=Qa+20|0;fa=Qa+24|0;ga=Qa+28|0;ha=Qa+32|0;ia=Qa+36|0;ja=Qa+40|0;ka=Qa+48|0;la=Qa+44|0;ma=Qa+52|0;na=Qa+4|0;oa=Qa+8|0;pa=Qa+12|0;qa=Qa+16|0;ra=Qa+20|0;sa=Qa+24|0;ta=Qa+28|0;ua=Qa+32|0;va=Qa+36|0;wa=Qa+40|0;xa=Qa+48|0;ya=Qa+44|0;za=Qa+52|0;a=-1;L=Ra;e=f;do{if((e|0)>0){K=(L|0)==(Ra|0);J=0;do{f=k[Aa>>2]|0;H=L-f|0;I=J-f|0;if(!J)if((k[Ma>>2]|0)>0){E=0;do{f=k[Ca>>2]|0;k[Qa>>2]=k[f+(E*56|0)>>2];e=f+(E*56|0)+4|0;k[$>>2]=k[e>>2];k[ba>>2]=k[f+(E*56|0)+8>>2];k[ca>>2]=k[f+(E*56|0)+12>>2];k[da>>2]=k[f+(E*56|0)+16>>2];k[ea>>2]=k[f+(E*56|0)+20>>2];k[fa>>2]=k[f+(E*56|0)+24>>2];k[ga>>2]=k[f+(E*56|0)+28>>2];k[ha>>2]=k[f+(E*56|0)+32>>2];a=k[f+(E*56|0)+36>>2]|0;k[ia>>2]=a;k[ja>>2]=ba;k[la>>2]=ka;k[ma>>2]=0;k[ka>>2]=0;if(a|0){G=a+12|0;k[G>>2]=(k[G>>2]|0)+1}if((k[e>>2]|0)>=3){k[$>>2]=0;x1(Qa,k[e>>2]|0,0,0,0);if((k[$>>2]|0)>0){g=k[f+(E*56|0)+40>>2]|0;h=k[ja>>2]|0;a=k[f+(E*56|0)+44>>2]|0;f=k[la>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[$>>2]|0))}}else{F=k[f+(E*56|0)+44>>2]|0;G=k[la>>2]|0;k[G>>2]=k[F>>2];k[G+4>>2]=k[F+4>>2]}e=k[Oa>>2]|0;if((e|0)>0){y=k[da>>2]|0;z=k[la>>2]|0;A=aa(aa(Pa,E)|0,Pa)|0;B=b+(A<<2)|0;C=d+(A<<2)|0;D=c+(A<<2)|0;x=0;do{if((e|0)>0){s=x+L|0;t=aa(Pa,x)|0;u=B+(t<<2)|0;v=C+(t<<2)|0;w=D+(t<<2)|0;q=0;do{p=u+(q<<2)|0;k[p>>2]=0;e=k[Ja>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Na,a)|0,Pa)|0,Pa)|0)<<2)+(A<<2)+(t<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ja>>2]|0}while((a|0)<(e|0))}o=k[Aa>>2]|0;n=s-o|0;o=q-o|0;f=k[Ga>>2]|0;a=0-f|0;if((f|0)>=(a|0)){l=w+(q<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=k[Ha>>2]|0;h=k[M>>2]|0;i=o+a|0;while(1){F=k[Da>>2]|0;Ta=F+a|0;Ua=g+(aa(k[h>>2]|0,f+L+F|0)|0)|0;G=i+F|0;F=y+(aa(k[z>>2]|0,n+f+F|0)|0)|0;e=(m[Ua+(Ta<<2)>>1]|0)-(m[F+(G<<2)>>1]|0)|0;G=(m[Ua+(Ta<<2)+2>>1]|0)-(m[F+(G<<2)+2>>1]|0)|0;e=((G|0)>-1?G:0-G|0)+((e|0)>-1?e:0-e|0)|0;k[p>>2]=e+(k[p>>2]|0);k[l>>2]=e+(k[l>>2]|0);e=k[Ga>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;l=l+(Ka<<2)|0}else break}e=k[Ja>>2]|0}e=c+((aa(aa(aa(Na,e+-1|0)|0,Pa)|0,Pa)|0)<<2)+(A<<2)+(t<<2)+(q<<2)|0;k[v+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[Oa>>2]|0}while((q|0)<(e|0))}x=x+1|0}while((x|0)<(e|0))}e=k[ia>>2]|0;if(e|0?(Ta=e+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){a=k[ia>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ha>>2]|0;if(e|0)break;e=B1()|0;a=k[ia>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ia>>2]=0}k[ia>>2]=0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[$>>2]|0)>0){a=k[ja>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[$>>2]|0))}e=k[la>>2]|0;if(!((e|0)==(ka|0)|(e|0)==0))ggb(k[e+-4>>2]|0);E=E+1|0;e=k[Ma>>2]|0}while((E|0)<(e|0));a=0;F=125}else{a=0;o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}else{e=k[Da>>2]|0;if(K){G=e+Ra|0;E=e+J+(k[Ga>>2]|0)|0;F=G-f|0;e=k[Ma>>2]|0;if((e|0)>0){B=E-f|0;C=c+((aa(aa(aa(Na,a)|0,Pa)|0,Pa)|0)<<2)|0;D=d+((aa(aa(aa(Na,J)|0,Pa)|0,Pa)|0)<<2)|0;A=0;do{g=k[Ca>>2]|0;k[Qa>>2]=k[g+(A*56|0)>>2];e=g+(A*56|0)+4|0;k[na>>2]=k[e>>2];k[oa>>2]=k[g+(A*56|0)+8>>2];k[pa>>2]=k[g+(A*56|0)+12>>2];k[qa>>2]=k[g+(A*56|0)+16>>2];k[ra>>2]=k[g+(A*56|0)+20>>2];k[sa>>2]=k[g+(A*56|0)+24>>2];k[ta>>2]=k[g+(A*56|0)+28>>2];k[ua>>2]=k[g+(A*56|0)+32>>2];f=k[g+(A*56|0)+36>>2]|0;k[va>>2]=f;k[wa>>2]=oa;k[ya>>2]=xa;k[za>>2]=0;k[xa>>2]=0;if(f|0){Ua=f+12|0;k[Ua>>2]=(k[Ua>>2]|0)+1}if((k[e>>2]|0)>=3){k[na>>2]=0;x1(Qa,k[e>>2]|0,0,0,0);if((k[na>>2]|0)>0){h=k[g+(A*56|0)+40>>2]|0;i=k[wa>>2]|0;f=k[g+(A*56|0)+44>>2]|0;g=k[ya>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[na>>2]|0))}}else{Ta=k[g+(A*56|0)+44>>2]|0;Ua=k[ya>>2]|0;k[Ua>>2]=k[Ta>>2];k[Ua+4>>2]=k[Ta+4>>2]}e=k[Oa>>2]|0;if((e|0)>0){v=k[qa>>2]|0;w=k[ya>>2]|0;z=aa(aa(Pa,A)|0,Pa)|0;x=C+(z<<2)|0;y=b+(z<<2)|0;z=D+(z<<2)|0;u=0;do{if((e|0)>0){p=F+u|0;t=aa(Pa,u)|0;q=x+(t<<2)|0;s=y+(t<<2)|0;t=z+(t<<2)|0;o=0;do{l=q+(o<<2)|0;n=s+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=B+o|0;Ua=k[Ga>>2]|0;e=0-Ua|0;if((Ua|0)<(e|0))e=0;else{h=k[Ha>>2]|0;i=k[M>>2]|0;f=e;e=0;while(1){Va=h+(aa(k[i>>2]|0,f+G|0)|0)|0;Ua=v+(aa(k[w>>2]|0,p+f|0)|0)|0;Ta=(m[Va+(E<<2)>>1]|0)-(m[Ua+(g<<2)>>1]|0)|0;Ua=(m[Va+(E<<2)+2>>1]|0)-(m[Ua+(g<<2)+2>>1]|0)|0;e=((Ta|0)>-1?Ta:0-Ta|0)+e+((Ua|0)>-1?Ua:0-Ua|0)|0;k[l>>2]=e;if((f|0)<(k[Ga>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[t+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[Oa>>2]|0}while((o|0)<(e|0))}u=u+1|0}while((u|0)<(e|0))}e=k[va>>2]|0;if(e|0?(Ua=e+12|0,Va=k[Ua>>2]|0,k[Ua>>2]=Va+-1,(Va|0)==1):0){f=k[va>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[ua>>2]|0;if(e|0)break;e=B1()|0;f=k[va>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[va>>2]=0}k[va>>2]=0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[qa+12>>2]=0;if((k[na>>2]|0)>0){f=k[wa>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[na>>2]|0))}e=k[ya>>2]|0;if(!((e|0)==(xa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);A=A+1|0;e=k[Ma>>2]|0}while((A|0)<(e|0))}}else{Va=e+L|0;D=e+J|0;E=k[Ga>>2]|0;h=D+E|0;F=Va-f|0;D=D-f+E|0;e=k[Ha>>2]|0;f=k[k[M>>2]>>2]|0;g=e+(aa(f,Va+~E|0)|0)|0;f=e+(aa(f,Va+E|0)|0)|0;E=k[Oa>>2]|0;e=k[Ma>>2]|0;if((e|0)>0){A=(E|0)>0;B=F+-1|0;C=m[f+(h<<2)>>1]|0;y=m[f+(h<<2)+2>>1]|0;z=m[g+(h<<2)>>1]|0;v=m[g+(h<<2)+2>>1]|0;w=c+((aa(aa(aa(Na,a)|0,Pa)|0,Pa)|0)<<2)|0;x=d+((aa(aa(aa(Na,J)|0,Pa)|0,Pa)|0)<<2)|0;u=0;do{g=k[Ca>>2]|0;k[Qa>>2]=k[g+(u*56|0)>>2];e=g+(u*56|0)+4|0;k[O>>2]=k[e>>2];k[P>>2]=k[g+(u*56|0)+8>>2];k[Q>>2]=k[g+(u*56|0)+12>>2];k[R>>2]=k[g+(u*56|0)+16>>2];k[S>>2]=k[g+(u*56|0)+20>>2];k[T>>2]=k[g+(u*56|0)+24>>2];k[U>>2]=k[g+(u*56|0)+28>>2];k[V>>2]=k[g+(u*56|0)+32>>2];f=k[g+(u*56|0)+36>>2]|0;k[W>>2]=f;k[X>>2]=P;k[Z>>2]=Y;k[_>>2]=0;k[Y>>2]=0;if(f|0){Va=f+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[e>>2]|0)>=3){k[O>>2]=0;x1(Qa,k[e>>2]|0,0,0,0);if((k[O>>2]|0)>0){h=k[g+(u*56|0)+40>>2]|0;i=k[X>>2]|0;f=k[g+(u*56|0)+44>>2]|0;g=k[Z>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[O>>2]|0))}}else{Ua=k[g+(u*56|0)+44>>2]|0;Va=k[Z>>2]|0;k[Va>>2]=k[Ua>>2];k[Va+4>>2]=k[Ua+4>>2]}i=aa(aa(Pa,u)|0,Pa)|0;g=b+(i<<2)|0;h=w+(i<<2)|0;i=x+(i<<2)|0;if(A){l=k[R>>2]|0;n=k[Z>>2]|0;f=0;do{q=aa(f,Pa)|0;o=g+(q<<2)|0;p=h+(q<<2)|0;q=i+(q<<2)|0;t=k[Ga>>2]|0;e=k[n>>2]|0;s=l+(aa(e,B+f-t|0)|0)|0;t=l+(aa(e,f+F+t|0)|0)|0;e=0;do{Ua=p+(e<<2)|0;Ta=o+(e<<2)|0;k[Ta>>2]=(k[Ta>>2]|0)-(k[Ua>>2]|0);Va=q+(e<<2)|0;Xa=D+e|0;Wa=C-(m[t+(Xa<<2)>>1]|0)|0;G=y-(m[t+(Xa<<2)+2>>1]|0)|0;Ya=z-(m[s+(Xa<<2)>>1]|0)|0;Xa=v-(m[s+(Xa<<2)+2>>1]|0)|0;G=(k[Va>>2]|0)-((Ya|0)>-1?Ya:0-Ya|0)-((Xa|0)>-1?Xa:0-Xa|0)+((Wa|0)>-1?Wa:0-Wa|0)+((G|0)>-1?G:0-G|0)|0;k[Ua>>2]=G;k[Ta>>2]=G+(k[Ta>>2]|0);k[Va>>2]=k[Ua>>2];e=e+1|0}while((e|0)!=(E|0));f=f+1|0}while((f|0)!=(E|0))}e=k[W>>2]|0;if(e|0?(Xa=e+12|0,Ya=k[Xa>>2]|0,k[Xa>>2]=Ya+-1,(Ya|0)==1):0){f=k[W>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[V>>2]|0;if(e|0)break;e=B1()|0;f=k[W>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[W>>2]=0}k[W>>2]=0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[O>>2]|0)>0){f=k[X>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[O>>2]|0))}e=k[Z>>2]|0;if(!((e|0)==(Y|0)|(e|0)==0))ggb(k[e+-4>>2]|0);u=u+1|0;e=k[Ma>>2]|0}while((u|0)<(e|0))}}a=(a+1|0)%(k[Ja>>2]|0)|0;F=125}if((F|0)==125){F=0;if((e|0)>0){C=k[Ca>>2]|0;D=k[Oa>>2]|0;E=(D|0)>0;B=0;h=0;g=0;o=0;n=0;f=0;p=0;l=0;i=0;do{if(E){x=k[Da>>2]|0;y=k[C+(B*56|0)+16>>2]|0;z=k[k[C+(B*56|0)+44>>2]>>2]|0;A=b+((aa(aa(Pa,B)|0,Pa)|0)<<2)|0;v=k[Ea>>2]|0;w=k[Fa>>2]|0;u=0;do{s=y+(aa(z,H+u+x|0)|0)|0;t=A+((aa(Pa,u)|0)<<2)|0;q=0;do{Xa=k[t+(q<<2)>>2]>>v;Va=k[w+(Xa<<3)>>2]|0;Xa=k[w+(Xa<<3)+4>>2]|0;Ya=I+q+x|0;Ua=j[s+(Ya<<2)+2>>1]|0;Wa=((Va|0)<0)<<31>>31;Ya=Epb(m[s+(Ya<<2)>>1]|0|0,0,Va|0,Wa|0)|0;l=kpb(l|0,i|0,Ya|0,N|0)|0;i=N;Ya=((Xa|0)<0)<<31>>31;Ua=Epb(Ua&65535|0,0,Xa|0,Ya|0)|0;f=kpb(f|0,p|0,Ua|0,N|0)|0;p=N;o=kpb(o|0,n|0,Va|0,Wa|0)|0;n=N;h=kpb(h|0,g|0,Xa|0,Ya|0)|0;g=N;q=q+1|0}while((q|0)!=(D|0));u=u+1|0}while((u|0)!=(D|0))}B=B+1|0}while((B|0)!=(e|0));e=p}else{o=0;n=0;l=0;i=0;h=0;g=0;f=0;e=0}}Ya=Bpb(o|0,n|0,2,0)|0;Ya=kpb(Ya|0,N|0,l|0,i|0)|0;Ya=spb(Ya|0,N|0,o|0,n|0)|0;Xa=N;Wa=Bpb(h|0,g|0,2,0)|0;Wa=kpb(Wa|0,N|0,f|0,e|0)|0;Wa=spb(Wa|0,N|0,h|0,g|0)|0;Va=N;e=k[Ba>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,L)|0)+(J<<2)|0;Ya=(Va>>>0<0|(Va|0)==0&Wa>>>0<65536?Wa:((Va|0)>0|(Va|0)==0&Wa>>>0>0)<<31>>31)<<16|(Xa>>>0<0|(Xa|0)==0&Ya>>>0<65536?Ya:((Xa|0)>0|(Xa|0)==0&Ya>>>0>0)<<31>>31)&65535;j[e>>1]=Ya;j[e+2>>1]=Ya>>>16;J=J+1|0;e=k[Ia>>2]|0}while((J|0)<(e|0))}L=L+1|0}while((L|0)<(La|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Sa;return}ggb(b);r=Sa;return}function q2a(a){a=a|0;a2a(a);ggb(a);return}function r2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0;Sa=r;r=r+64|0;Qa=Sa;Ra=k[b>>2]|0;La=k[b+4>>2]|0;Ma=a+96|0;Na=k[Ma>>2]|0;Oa=a+92|0;Pa=k[Oa>>2]|0;Ka=aa(aa(Pa,Na)|0,Pa)|0;c=Ka>>>0>1073741823?-1:Ka<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ja=a+88|0;d=aa(aa(aa(Na,k[Ja>>2]|0)|0,Pa)|0,Pa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ia=a+8|0;f=k[Ia>>2]|0;e=aa(aa(aa(Na,f)|0,Pa)|0,Pa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Ra|0)<(La|0)){Aa=a+104|0;Ba=a+12|0;Ca=a+16|0;Da=a+84|0;Ea=a+116|0;Fa=a+120|0;Ga=a+100|0;Ha=a+44|0;M=a+72|0;O=Qa+4|0;P=Qa+8|0;Q=Qa+12|0;R=Qa+16|0;S=Qa+20|0;T=Qa+24|0;U=Qa+28|0;V=Qa+32|0;W=Qa+36|0;X=Qa+40|0;Y=Qa+48|0;Z=Qa+44|0;_=Qa+52|0;$=Qa+4|0;ba=Qa+8|0;ca=Qa+12|0;da=Qa+16|0;ea=Qa+20|0;fa=Qa+24|0;ga=Qa+28|0;ha=Qa+32|0;ia=Qa+36|0;ja=Qa+40|0;ka=Qa+48|0;la=Qa+44|0;ma=Qa+52|0;na=Qa+4|0;oa=Qa+8|0;pa=Qa+12|0;qa=Qa+16|0;ra=Qa+20|0;sa=Qa+24|0;ta=Qa+28|0;ua=Qa+32|0;va=Qa+36|0;wa=Qa+40|0;xa=Qa+48|0;ya=Qa+44|0;za=Qa+52|0;a=-1;L=Ra;e=f;do{if((e|0)>0){K=(L|0)==(Ra|0);J=0;do{f=k[Aa>>2]|0;H=L-f|0;I=J-f|0;if(!J)if((k[Ma>>2]|0)>0){E=0;do{f=k[Ca>>2]|0;k[Qa>>2]=k[f+(E*56|0)>>2];e=f+(E*56|0)+4|0;k[$>>2]=k[e>>2];k[ba>>2]=k[f+(E*56|0)+8>>2];k[ca>>2]=k[f+(E*56|0)+12>>2];k[da>>2]=k[f+(E*56|0)+16>>2];k[ea>>2]=k[f+(E*56|0)+20>>2];k[fa>>2]=k[f+(E*56|0)+24>>2];k[ga>>2]=k[f+(E*56|0)+28>>2];k[ha>>2]=k[f+(E*56|0)+32>>2];a=k[f+(E*56|0)+36>>2]|0;k[ia>>2]=a;k[ja>>2]=ba;k[la>>2]=ka;k[ma>>2]=0;k[ka>>2]=0;if(a|0){G=a+12|0;k[G>>2]=(k[G>>2]|0)+1}if((k[e>>2]|0)>=3){k[$>>2]=0;x1(Qa,k[e>>2]|0,0,0,0);if((k[$>>2]|0)>0){g=k[f+(E*56|0)+40>>2]|0;h=k[ja>>2]|0;a=k[f+(E*56|0)+44>>2]|0;f=k[la>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[$>>2]|0))}}else{F=k[f+(E*56|0)+44>>2]|0;G=k[la>>2]|0;k[G>>2]=k[F>>2];k[G+4>>2]=k[F+4>>2]}e=k[Oa>>2]|0;if((e|0)>0){y=k[da>>2]|0;z=k[la>>2]|0;A=aa(aa(Pa,E)|0,Pa)|0;B=b+(A<<2)|0;C=d+(A<<2)|0;D=c+(A<<2)|0;x=0;do{if((e|0)>0){s=x+L|0;t=aa(Pa,x)|0;u=B+(t<<2)|0;v=C+(t<<2)|0;w=D+(t<<2)|0;q=0;do{p=u+(q<<2)|0;k[p>>2]=0;e=k[Ja>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Na,a)|0,Pa)|0,Pa)|0)<<2)+(A<<2)+(t<<2)+(q<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ja>>2]|0}while((a|0)<(e|0))}o=k[Aa>>2]|0;n=s-o|0;o=q-o|0;f=k[Ga>>2]|0;a=0-f|0;if((f|0)>=(a|0)){l=w+(q<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){g=k[Ha>>2]|0;h=k[M>>2]|0;i=o+a|0;while(1){F=k[Da>>2]|0;Ta=F+a|0;Ua=g+(aa(k[h>>2]|0,f+L+F|0)|0)|0;G=i+F|0;F=y+(aa(k[z>>2]|0,n+f+F|0)|0)|0;e=(m[Ua+(Ta<<2)>>1]|0)-(m[F+(G<<2)>>1]|0)|0;G=(m[Ua+(Ta<<2)+2>>1]|0)-(m[F+(G<<2)+2>>1]|0)|0;e=((G|0)>-1?G:0-G|0)+((e|0)>-1?e:0-e|0)|0;k[p>>2]=e+(k[p>>2]|0);k[l>>2]=e+(k[l>>2]|0);e=k[Ga>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;l=l+(Ka<<2)|0}else break}e=k[Ja>>2]|0}e=c+((aa(aa(aa(Na,e+-1|0)|0,Pa)|0,Pa)|0)<<2)+(A<<2)+(t<<2)+(q<<2)|0;k[v+(q<<2)>>2]=k[e>>2];q=q+1|0;e=k[Oa>>2]|0}while((q|0)<(e|0))}x=x+1|0}while((x|0)<(e|0))}e=k[ia>>2]|0;if(e|0?(Ta=e+12|0,Ua=k[Ta>>2]|0,k[Ta>>2]=Ua+-1,(Ua|0)==1):0){a=k[ia>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ha>>2]|0;if(e|0)break;e=B1()|0;a=k[ia>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ia>>2]=0}k[ia>>2]=0;k[da>>2]=0;k[da+4>>2]=0;k[da+8>>2]=0;k[da+12>>2]=0;if((k[$>>2]|0)>0){a=k[ja>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[$>>2]|0))}e=k[la>>2]|0;if(!((e|0)==(ka|0)|(e|0)==0))ggb(k[e+-4>>2]|0);E=E+1|0;e=k[Ma>>2]|0}while((E|0)<(e|0));a=0;D=125}else{a=0;l=0;i=0;h=0;g=0;f=0;e=0}else{e=k[Da>>2]|0;if(K){G=e+Ra|0;E=e+J+(k[Ga>>2]|0)|0;F=G-f|0;e=k[Ma>>2]|0;if((e|0)>0){B=E-f|0;C=c+((aa(aa(aa(Na,a)|0,Pa)|0,Pa)|0)<<2)|0;D=d+((aa(aa(aa(Na,J)|0,Pa)|0,Pa)|0)<<2)|0;A=0;do{g=k[Ca>>2]|0;k[Qa>>2]=k[g+(A*56|0)>>2];e=g+(A*56|0)+4|0;k[na>>2]=k[e>>2];k[oa>>2]=k[g+(A*56|0)+8>>2];k[pa>>2]=k[g+(A*56|0)+12>>2];k[qa>>2]=k[g+(A*56|0)+16>>2];k[ra>>2]=k[g+(A*56|0)+20>>2];k[sa>>2]=k[g+(A*56|0)+24>>2];k[ta>>2]=k[g+(A*56|0)+28>>2];k[ua>>2]=k[g+(A*56|0)+32>>2];f=k[g+(A*56|0)+36>>2]|0;k[va>>2]=f;k[wa>>2]=oa;k[ya>>2]=xa;k[za>>2]=0;k[xa>>2]=0;if(f|0){Ua=f+12|0;k[Ua>>2]=(k[Ua>>2]|0)+1}if((k[e>>2]|0)>=3){k[na>>2]=0;x1(Qa,k[e>>2]|0,0,0,0);if((k[na>>2]|0)>0){h=k[g+(A*56|0)+40>>2]|0;i=k[wa>>2]|0;f=k[g+(A*56|0)+44>>2]|0;g=k[ya>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[na>>2]|0))}}else{Ta=k[g+(A*56|0)+44>>2]|0;Ua=k[ya>>2]|0;k[Ua>>2]=k[Ta>>2];k[Ua+4>>2]=k[Ta+4>>2]}e=k[Oa>>2]|0;if((e|0)>0){v=k[qa>>2]|0;w=k[ya>>2]|0;z=aa(aa(Pa,A)|0,Pa)|0;x=C+(z<<2)|0;y=b+(z<<2)|0;z=D+(z<<2)|0;u=0;do{if((e|0)>0){p=F+u|0;t=aa(Pa,u)|0;q=x+(t<<2)|0;s=y+(t<<2)|0;t=z+(t<<2)|0;o=0;do{l=q+(o<<2)|0;n=s+(o<<2)|0;k[n>>2]=(k[n>>2]|0)-(k[l>>2]|0);k[l>>2]=0;g=B+o|0;Ua=k[Ga>>2]|0;e=0-Ua|0;if((Ua|0)<(e|0))e=0;else{h=k[Ha>>2]|0;i=k[M>>2]|0;f=e;e=0;while(1){Va=h+(aa(k[i>>2]|0,f+G|0)|0)|0;Ua=v+(aa(k[w>>2]|0,p+f|0)|0)|0;Ta=(m[Va+(E<<2)>>1]|0)-(m[Ua+(g<<2)>>1]|0)|0;Ua=(m[Va+(E<<2)+2>>1]|0)-(m[Ua+(g<<2)+2>>1]|0)|0;e=((Ta|0)>-1?Ta:0-Ta|0)+e+((Ua|0)>-1?Ua:0-Ua|0)|0;k[l>>2]=e;if((f|0)<(k[Ga>>2]|0))f=f+1|0;else break}}k[n>>2]=(k[n>>2]|0)+e;k[t+(o<<2)>>2]=k[l>>2];o=o+1|0;e=k[Oa>>2]|0}while((o|0)<(e|0))}u=u+1|0}while((u|0)<(e|0))}e=k[va>>2]|0;if(e|0?(Ua=e+12|0,Va=k[Ua>>2]|0,k[Ua>>2]=Va+-1,(Va|0)==1):0){f=k[va>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[ua>>2]|0;if(e|0)break;e=B1()|0;f=k[va>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[va>>2]=0}k[va>>2]=0;k[qa>>2]=0;k[qa+4>>2]=0;k[qa+8>>2]=0;k[qa+12>>2]=0;if((k[na>>2]|0)>0){f=k[wa>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[na>>2]|0))}e=k[ya>>2]|0;if(!((e|0)==(xa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);A=A+1|0;e=k[Ma>>2]|0}while((A|0)<(e|0))}}else{Va=e+L|0;D=e+J|0;E=k[Ga>>2]|0;h=D+E|0;F=Va-f|0;D=D-f+E|0;e=k[Ha>>2]|0;f=k[k[M>>2]>>2]|0;g=e+(aa(f,Va+~E|0)|0)|0;f=e+(aa(f,Va+E|0)|0)|0;E=k[Oa>>2]|0;e=k[Ma>>2]|0;if((e|0)>0){A=(E|0)>0;B=F+-1|0;C=m[f+(h<<2)>>1]|0;y=m[f+(h<<2)+2>>1]|0;z=m[g+(h<<2)>>1]|0;v=m[g+(h<<2)+2>>1]|0;w=c+((aa(aa(aa(Na,a)|0,Pa)|0,Pa)|0)<<2)|0;x=d+((aa(aa(aa(Na,J)|0,Pa)|0,Pa)|0)<<2)|0;u=0;do{g=k[Ca>>2]|0;k[Qa>>2]=k[g+(u*56|0)>>2];e=g+(u*56|0)+4|0;k[O>>2]=k[e>>2];k[P>>2]=k[g+(u*56|0)+8>>2];k[Q>>2]=k[g+(u*56|0)+12>>2];k[R>>2]=k[g+(u*56|0)+16>>2];k[S>>2]=k[g+(u*56|0)+20>>2];k[T>>2]=k[g+(u*56|0)+24>>2];k[U>>2]=k[g+(u*56|0)+28>>2];k[V>>2]=k[g+(u*56|0)+32>>2];f=k[g+(u*56|0)+36>>2]|0;k[W>>2]=f;k[X>>2]=P;k[Z>>2]=Y;k[_>>2]=0;k[Y>>2]=0;if(f|0){Va=f+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[e>>2]|0)>=3){k[O>>2]=0;x1(Qa,k[e>>2]|0,0,0,0);if((k[O>>2]|0)>0){h=k[g+(u*56|0)+40>>2]|0;i=k[X>>2]|0;f=k[g+(u*56|0)+44>>2]|0;g=k[Z>>2]|0;e=0;do{k[i+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[O>>2]|0))}}else{Ua=k[g+(u*56|0)+44>>2]|0;Va=k[Z>>2]|0;k[Va>>2]=k[Ua>>2];k[Va+4>>2]=k[Ua+4>>2]}i=aa(aa(Pa,u)|0,Pa)|0;g=b+(i<<2)|0;h=w+(i<<2)|0;i=x+(i<<2)|0;if(A){l=k[R>>2]|0;n=k[Z>>2]|0;f=0;do{q=aa(f,Pa)|0;o=g+(q<<2)|0;p=h+(q<<2)|0;q=i+(q<<2)|0;t=k[Ga>>2]|0;e=k[n>>2]|0;s=l+(aa(e,B+f-t|0)|0)|0;t=l+(aa(e,f+F+t|0)|0)|0;e=0;do{Ua=p+(e<<2)|0;Ta=o+(e<<2)|0;k[Ta>>2]=(k[Ta>>2]|0)-(k[Ua>>2]|0);Va=q+(e<<2)|0;Xa=D+e|0;Wa=C-(m[t+(Xa<<2)>>1]|0)|0;G=y-(m[t+(Xa<<2)+2>>1]|0)|0;Ya=z-(m[s+(Xa<<2)>>1]|0)|0;Xa=v-(m[s+(Xa<<2)+2>>1]|0)|0;G=(k[Va>>2]|0)-((Ya|0)>-1?Ya:0-Ya|0)-((Xa|0)>-1?Xa:0-Xa|0)+((Wa|0)>-1?Wa:0-Wa|0)+((G|0)>-1?G:0-G|0)|0;k[Ua>>2]=G;k[Ta>>2]=G+(k[Ta>>2]|0);k[Va>>2]=k[Ua>>2];e=e+1|0}while((e|0)!=(E|0));f=f+1|0}while((f|0)!=(E|0))}e=k[W>>2]|0;if(e|0?(Xa=e+12|0,Ya=k[Xa>>2]|0,k[Xa>>2]=Ya+-1,(Ya|0)==1):0){f=k[W>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[V>>2]|0;if(e|0)break;e=B1()|0;f=k[W>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[W>>2]=0}k[W>>2]=0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;if((k[O>>2]|0)>0){f=k[X>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[O>>2]|0))}e=k[Z>>2]|0;if(!((e|0)==(Y|0)|(e|0)==0))ggb(k[e+-4>>2]|0);u=u+1|0;e=k[Ma>>2]|0}while((u|0)<(e|0))}}a=(a+1|0)%(k[Ja>>2]|0)|0;D=125}if((D|0)==125){D=0;if((e|0)>0){A=k[Ca>>2]|0;B=k[Oa>>2]|0;C=(B|0)>0;z=0;f=0;n=0;h=0;g=0;l=0;i=0;do{if(C){v=k[Da>>2]|0;w=k[A+(z*56|0)+16>>2]|0;x=k[k[A+(z*56|0)+44>>2]>>2]|0;y=b+((aa(aa(Pa,z)|0,Pa)|0)<<2)|0;t=k[Ea>>2]|0;u=k[Fa>>2]|0;s=0;do{p=w+(aa(x,H+s+v|0)|0)|0;q=y+((aa(Pa,s)|0)<<2)|0;o=0;do{Xa=k[u+(k[q+(o<<2)>>2]>>t<<2)>>2]|0;Va=I+o+v|0;Wa=j[p+(Va<<2)+2>>1]|0;Ya=((Xa|0)<0)<<31>>31;Va=Epb(m[p+(Va<<2)>>1]|0|0,0,Xa|0,Ya|0)|0;h=kpb(h|0,g|0,Va|0,N|0)|0;g=N;Wa=Epb(Wa&65535|0,0,Xa|0,Ya|0)|0;f=kpb(f|0,n|0,Wa|0,N|0)|0;n=N;l=kpb(Xa|0,Ya|0,l|0,i|0)|0;i=N;o=o+1|0}while((o|0)!=(B|0));s=s+1|0}while((s|0)!=(B|0))}z=z+1|0}while((z|0)!=(e|0));e=n}else{l=0;i=0;h=0;g=0;f=0;e=0}}Va=Bpb(l|0,i|0,2,0)|0;Wa=N;Ya=kpb(h|0,g|0,Va|0,Wa|0)|0;Ya=spb(Ya|0,N|0,l|0,i|0)|0;Xa=N;Wa=kpb(f|0,e|0,Va|0,Wa|0)|0;Wa=spb(Wa|0,N|0,l|0,i|0)|0;Va=N;e=k[Ba>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,L)|0)+(J<<2)|0;Ya=(Va>>>0<0|(Va|0)==0&Wa>>>0<65536?Wa:((Va|0)>0|(Va|0)==0&Wa>>>0>0)<<31>>31)<<16|(Xa>>>0<0|(Xa|0)==0&Ya>>>0<65536?Ya:((Xa|0)>0|(Xa|0)==0&Ya>>>0>0)<<31>>31)&65535;j[e>>1]=Ya;j[e+2>>1]=Ya>>>16;J=J+1|0;e=k[Ia>>2]|0}while((J|0)<(e|0))}L=L+1|0}while((L|0)<(La|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Sa;return}ggb(b);r=Sa;return}function s2a(a){a=a|0;$1a(a);ggb(a);return}function t2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0;Ta=r;r=r+64|0;Pa=Ta;Qa=k[b>>2]|0;Ka=k[b+4>>2]|0;La=a+96|0;Ma=k[La>>2]|0;Na=a+92|0;Oa=k[Na>>2]|0;Ja=aa(aa(Oa,Ma)|0,Oa)|0;c=Ja>>>0>1073741823?-1:Ja<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ia=a+88|0;d=aa(aa(aa(Ma,k[Ia>>2]|0)|0,Oa)|0,Oa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ha=a+8|0;f=k[Ha>>2]|0;e=aa(aa(aa(Ma,f)|0,Oa)|0,Oa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Qa|0)<(Ka|0)){za=a+104|0;Aa=a+16|0;Ba=a+84|0;Ca=a+116|0;Da=a+120|0;Ea=a+12|0;Fa=a+100|0;Ga=a+44|0;L=a+72|0;M=Pa+4|0;O=Pa+8|0;P=Pa+12|0;Q=Pa+16|0;R=Pa+20|0;S=Pa+24|0;T=Pa+28|0;U=Pa+32|0;V=Pa+36|0;W=Pa+40|0;X=Pa+48|0;Y=Pa+44|0;Z=Pa+52|0;_=Pa+4|0;$=Pa+8|0;ba=Pa+12|0;ca=Pa+16|0;da=Pa+20|0;ea=Pa+24|0;fa=Pa+28|0;ga=Pa+32|0;ha=Pa+36|0;ia=Pa+40|0;ja=Pa+48|0;ka=Pa+44|0;la=Pa+52|0;ma=Pa+4|0;na=Pa+8|0;oa=Pa+12|0;pa=Pa+16|0;qa=Pa+20|0;ra=Pa+24|0;sa=Pa+28|0;ta=Pa+32|0;ua=Pa+36|0;va=Pa+40|0;wa=Pa+48|0;xa=Pa+44|0;ya=Pa+52|0;a=-1;K=Qa;e=f;do{if((e|0)>0){J=(K|0)==(Qa|0);I=0;do{f=k[za>>2]|0;G=K-f|0;H=I-f|0;if(!I)if((k[La>>2]|0)>0){D=0;do{f=k[Aa>>2]|0;k[Pa>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[_>>2]=k[e>>2];k[$>>2]=k[f+(D*56|0)+8>>2];k[ba>>2]=k[f+(D*56|0)+12>>2];k[ca>>2]=k[f+(D*56|0)+16>>2];k[da>>2]=k[f+(D*56|0)+20>>2];k[ea>>2]=k[f+(D*56|0)+24>>2];k[fa>>2]=k[f+(D*56|0)+28>>2];k[ga>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ha>>2]=a;k[ia>>2]=$;k[ka>>2]=ja;k[la>>2]=0;k[ja>>2]=0;if(a|0){F=a+12|0;k[F>>2]=(k[F>>2]|0)+1}if((k[e>>2]|0)>=3){k[_>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[_>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ia>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ka>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[_>>2]|0))}}else{E=k[f+(D*56|0)+44>>2]|0;F=k[ka>>2]|0;k[F>>2]=k[E>>2];k[F+4>>2]=k[E+4>>2]}e=k[Na>>2]|0;if((e|0)>0){z=aa(aa(Oa,D)|0,Oa)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+K|0;u=aa(Oa,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ia>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ia>>2]|0}while((a|0)<(e|0))}p=k[za>>2]|0;o=t-p|0;p=s-p|0;f=k[Fa>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Ga>>2]|0;h=k[L>>2]|0;j=k[ca>>2]|0;while(1){e=k[Ba>>2]|0;F=g+(aa(k[h>>2]|0,f+K+e|0)|0)+(e+a)|0;e=j+(aa(k[k[ka>>2]>>2]|0,o+f+e|0)|0)+(m+e)|0;e=(l[F>>0]|0)-(l[e>>0]|0)|0;e=(e|0)>-1?e:0-e|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Fa>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(Ja<<2)|0}else break}e=k[Ia>>2]|0}e=c+((aa(aa(aa(Ma,e+-1|0)|0,Oa)|0,Oa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Na>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ha>>2]|0;if(e|0?(E=e+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){a=k[ha>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ga>>2]|0;if(e|0)break;e=B1()|0;a=k[ha>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ha>>2]=0}k[ha>>2]=0;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;if((k[_>>2]|0)>0){a=k[ia>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[_>>2]|0))}e=k[ka>>2]|0;if(!((e|0)==(ja|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[La>>2]|0}while((D|0)<(e|0));a=0;y=125}else{a=0;h=0;g=0;f=0;e=0}else{e=k[Ba>>2]|0;if(J){F=e+Qa|0;D=e+I+(k[Fa>>2]|0)|0;E=F-f|0;e=k[La>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)|0;C=d+((aa(aa(aa(Ma,I)|0,Oa)|0,Oa)|0)<<2)|0;z=0;do{g=k[Aa>>2]|0;k[Pa>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[ma>>2]=k[e>>2];k[na>>2]=k[g+(z*56|0)+8>>2];k[oa>>2]=k[g+(z*56|0)+12>>2];k[pa>>2]=k[g+(z*56|0)+16>>2];k[qa>>2]=k[g+(z*56|0)+20>>2];k[ra>>2]=k[g+(z*56|0)+24>>2];k[sa>>2]=k[g+(z*56|0)+28>>2];k[ta>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[ua>>2]=f;k[va>>2]=na;k[xa>>2]=wa;k[ya>>2]=0;k[wa>>2]=0;if(f|0){y=f+12|0;k[y>>2]=(k[y>>2]|0)+1}if((k[e>>2]|0)>=3){k[ma>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[ma>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[va>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[xa>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ma>>2]|0))}}else{x=k[g+(z*56|0)+44>>2]|0;y=k[xa>>2]|0;k[y>>2]=k[x>>2];k[y+4>>2]=k[x+4>>2]}e=k[Na>>2]|0;if((e|0)>0){y=aa(aa(Oa,z)|0,Oa)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Oa,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;j=k[Fa>>2]|0;e=0-j|0;if((j|0)<(e|0))e=0;else{g=k[Ga>>2]|0;h=k[L>>2]|0;j=k[pa>>2]|0;f=e;e=0;while(1){Va=g+(aa(k[h>>2]|0,f+F|0)|0)+D|0;Ua=j+(aa(k[k[xa>>2]>>2]|0,q+f|0)|0)+m|0;Ua=(l[Va>>0]|0)-(l[Ua>>0]|0)|0;e=((Ua|0)>-1?Ua:0-Ua|0)+e|0;k[n>>2]=e;if((f|0)<(k[Fa>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Na>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[ua>>2]|0;if(e|0?(Ua=e+12|0,Va=k[Ua>>2]|0,k[Ua>>2]=Va+-1,(Va|0)==1):0){f=k[ua>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[ta>>2]|0;if(e|0)break;e=B1()|0;f=k[ua>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[ua>>2]=0}k[ua>>2]=0;k[pa>>2]=0;k[pa+4>>2]=0;k[pa+8>>2]=0;k[pa+12>>2]=0;if((k[ma>>2]|0)>0){f=k[va>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ma>>2]|0))}e=k[xa>>2]|0;if(!((e|0)==(wa|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[La>>2]|0}while((z|0)<(e|0))}}else{m=e+K|0;A=e+I|0;h=k[Fa>>2]|0;j=A+h|0;C=m-f|0;A=A-f+h|0;f=k[Ga>>2]|0;g=k[k[L>>2]>>2]|0;B=k[Na>>2]|0;e=k[La>>2]|0;if((e|0)>0){w=f+(aa(g,m+h|0)|0)+j|0;x=f+(aa(g,m+~h|0)|0)+j|0;u=(B|0)>0;v=C+-1|0;w=l[w>>0]|0;x=l[x>>0]|0;y=c+((aa(aa(aa(Ma,a)|0,Oa)|0,Oa)|0)<<2)|0;z=d+((aa(aa(aa(Ma,I)|0,Oa)|0,Oa)|0)<<2)|0;t=0;do{g=k[Aa>>2]|0;k[Pa>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[M>>2]=k[e>>2];k[O>>2]=k[g+(t*56|0)+8>>2];k[P>>2]=k[g+(t*56|0)+12>>2];k[Q>>2]=k[g+(t*56|0)+16>>2];k[R>>2]=k[g+(t*56|0)+20>>2];k[S>>2]=k[g+(t*56|0)+24>>2];k[T>>2]=k[g+(t*56|0)+28>>2];k[U>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[V>>2]=f;k[W>>2]=O;k[Y>>2]=X;k[Z>>2]=0;k[X>>2]=0;if(f|0){Va=f+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[e>>2]|0)>=3){k[M>>2]=0;x1(Pa,k[e>>2]|0,0,0,0);if((k[M>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[W>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[Y>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[M>>2]|0))}}else{Ua=k[g+(t*56|0)+44>>2]|0;Va=k[Y>>2]|0;k[Va>>2]=k[Ua>>2];k[Va+4>>2]=k[Ua+4>>2]}m=aa(aa(Oa,t)|0,Oa)|0;h=b+(m<<2)|0;j=y+(m<<2)|0;m=z+(m<<2)|0;if(u){g=k[Q>>2]|0;f=0;do{p=aa(f,Oa)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Fa>>2]|0;e=k[k[Y>>2]>>2]|0;q=g+(aa(e,v+f-s|0)|0)|0;s=g+(aa(e,f+C+s|0)|0)|0;e=0;do{Ua=o+(e<<2)|0;F=n+(e<<2)|0;k[F>>2]=(k[F>>2]|0)-(k[Ua>>2]|0);Va=p+(e<<2)|0;E=A+e|0;D=w-(l[s+E>>0]|0)|0;E=x-(l[q+E>>0]|0)|0;E=((D|0)>-1?D:0-D|0)-((E|0)>-1?E:0-E|0)+(k[Va>>2]|0)|0;k[Ua>>2]=E;k[F>>2]=E+(k[F>>2]|0);k[Va>>2]=k[Ua>>2];e=e+1|0}while((e|0)!=(B|0));f=f+1|0}while((f|0)!=(B|0))}e=k[V>>2]|0;if(e|0?(Ua=e+12|0,Va=k[Ua>>2]|0,k[Ua>>2]=Va+-1,(Va|0)==1):0){f=k[V>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[U>>2]|0;if(e|0)break;e=B1()|0;f=k[V>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[V>>2]=0}k[V>>2]=0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[M>>2]|0)>0){f=k[W>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[M>>2]|0))}e=k[Y>>2]|0;if(!((e|0)==(X|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[La>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ia>>2]|0)|0;y=125}if((y|0)==125){y=0;if((e|0)>0?(Ra=k[Aa>>2]|0,Sa=k[Na>>2]|0,(Sa|0)>0):0){s=k[Ba>>2]|0;t=k[Ca>>2]|0;u=k[Da>>2]|0;q=0;h=0;g=0;f=0;j=0;do{v=k[Ra+(q*56|0)+16>>2]|0;w=k[k[Ra+(q*56|0)+44>>2]>>2]|0;x=b+((aa(aa(Oa,q)|0,Oa)|0)<<2)|0;p=0;do{n=v+(aa(w,G+p+s|0)|0)|0;o=x+((aa(Oa,p)|0)<<2)|0;m=0;do{Ua=k[u+(k[o+(m<<2)>>2]>>t<<2)>>2]|0;Va=((Ua|0)<0)<<31>>31;F=Epb(l[n+(H+m+s)>>0]|0|0,0,Ua|0,Va|0)|0;f=kpb(F|0,N|0,f|0,j|0)|0;j=N;h=kpb(Ua|0,Va|0,h|0,g|0)|0;g=N;m=m+1|0}while((m|0)!=(Sa|0));p=p+1|0}while((p|0)!=(Sa|0));q=q+1|0}while((q|0)!=(e|0));e=j}else{h=0;g=0;f=0;e=0}}Va=Bpb(h|0,g|0,2,0)|0;Va=kpb(Va|0,N|0,f|0,e|0)|0;Va=spb(Va|0,N|0,h|0,g|0)|0;Ua=N;e=k[Ea>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,K)|0)+I|0;i[e>>0]=Ua>>>0<0|(Ua|0)==0&Va>>>0<256?Va&255:((Ua|0)>0|(Ua|0)==0&Va>>>0>0)<<31>>31;I=I+1|0;e=k[Ha>>2]|0}while((I|0)<(e|0))}K=K+1|0}while((K|0)<(Ka|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Ta;return}ggb(b);r=Ta;return}function u2a(a){a=a|0;_1a(a);ggb(a);return}function v2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0;Ta=r;r=r+64|0;Ra=Ta;Sa=k[b>>2]|0;Ma=k[b+4>>2]|0;Na=a+96|0;Oa=k[Na>>2]|0;Pa=a+92|0;Qa=k[Pa>>2]|0;La=aa(aa(Qa,Oa)|0,Qa)|0;c=La>>>0>1073741823?-1:La<<2;c=(c|0)==0?1:c;while(1){b=fgb(c)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}Ka=a+88|0;d=aa(aa(aa(Oa,k[Ka>>2]|0)|0,Qa)|0,Qa)|0;d=d>>>0>1073741823?-1:d<<2;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}Ja=a+8|0;f=k[Ja>>2]|0;e=aa(aa(aa(Oa,f)|0,Qa)|0,Qa)|0;e=e>>>0>1073741823?-1:e<<2;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}if((Sa|0)<(Ma|0)){Ba=a+104|0;Ca=a+12|0;Da=a+16|0;Ea=a+84|0;Fa=a+116|0;Ga=a+120|0;Ha=a+100|0;Ia=a+44|0;O=a+72|0;P=Ra+4|0;Q=Ra+8|0;R=Ra+12|0;S=Ra+16|0;T=Ra+20|0;U=Ra+24|0;V=Ra+28|0;W=Ra+32|0;X=Ra+36|0;Y=Ra+40|0;Z=Ra+48|0;_=Ra+44|0;$=Ra+52|0;ba=Ra+4|0;ca=Ra+8|0;da=Ra+12|0;ea=Ra+16|0;fa=Ra+20|0;ga=Ra+24|0;ha=Ra+28|0;ia=Ra+32|0;ja=Ra+36|0;ka=Ra+40|0;la=Ra+48|0;ma=Ra+44|0;na=Ra+52|0;oa=Ra+4|0;pa=Ra+8|0;qa=Ra+12|0;ra=Ra+16|0;sa=Ra+20|0;ta=Ra+24|0;ua=Ra+28|0;va=Ra+32|0;wa=Ra+36|0;xa=Ra+40|0;ya=Ra+48|0;za=Ra+44|0;Aa=Ra+52|0;a=-1;N=Sa;e=f;do{if((e|0)>0){M=(N|0)==(Sa|0);L=0;do{f=k[Ba>>2]|0;J=N-f|0;K=L-f|0;if(!L)if((k[Na>>2]|0)>0){D=0;do{f=k[Da>>2]|0;k[Ra>>2]=k[f+(D*56|0)>>2];e=f+(D*56|0)+4|0;k[ba>>2]=k[e>>2];k[ca>>2]=k[f+(D*56|0)+8>>2];k[da>>2]=k[f+(D*56|0)+12>>2];k[ea>>2]=k[f+(D*56|0)+16>>2];k[fa>>2]=k[f+(D*56|0)+20>>2];k[ga>>2]=k[f+(D*56|0)+24>>2];k[ha>>2]=k[f+(D*56|0)+28>>2];k[ia>>2]=k[f+(D*56|0)+32>>2];a=k[f+(D*56|0)+36>>2]|0;k[ja>>2]=a;k[ka>>2]=ca;k[ma>>2]=la;k[na>>2]=0;k[la>>2]=0;if(a|0){I=a+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[e>>2]|0)>=3){k[ba>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[ba>>2]|0)>0){g=k[f+(D*56|0)+40>>2]|0;h=k[ka>>2]|0;a=k[f+(D*56|0)+44>>2]|0;f=k[ma>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[g+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[ba>>2]|0))}}else{H=k[f+(D*56|0)+44>>2]|0;I=k[ma>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2]}e=k[Pa>>2]|0;if((e|0)>0){z=aa(aa(Qa,D)|0,Qa)|0;A=b+(z<<2)|0;B=d+(z<<2)|0;C=c+(z<<2)|0;y=0;do{if((e|0)>0){t=y+N|0;u=aa(Qa,y)|0;v=A+(u<<2)|0;w=B+(u<<2)|0;x=C+(u<<2)|0;s=0;do{q=v+(s<<2)|0;k[q>>2]=0;e=k[Ka>>2]|0;if((e|0)>0){a=0;do{e=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[e>>2]=0;a=a+1|0;e=k[Ka>>2]|0}while((a|0)<(e|0))}p=k[Ba>>2]|0;o=t-p|0;p=s-p|0;f=k[Ha>>2]|0;a=0-f|0;if((f|0)>=(a|0)){n=x+(s<<2)|0;e=f;while(1){f=0-e|0;if((e|0)>=(f|0)){m=p+a|0;g=k[Ia>>2]|0;h=k[O>>2]|0;j=k[ea>>2]|0;while(1){F=k[Ea>>2]|0;E=F+a|0;Ua=g+(aa(k[h>>2]|0,f+N+F|0)|0)|0;e=m+F|0;F=j+(aa(k[k[ma>>2]>>2]|0,o+f+F|0)|0)|0;H=(l[Ua+(E<<2)>>0]|0)-(l[F+(e<<2)>>0]|0)|0;G=(l[Ua+(E<<2)+1>>0]|0)-(l[F+(e<<2)+1>>0]|0)|0;I=(l[Ua+(E<<2)+2>>0]|0)-(l[F+(e<<2)+2>>0]|0)|0;e=(l[Ua+(E<<2)+3>>0]|0)-(l[F+(e<<2)+3>>0]|0)|0;e=((G|0)>-1?G:0-G|0)+((H|0)>-1?H:0-H|0)+((I|0)>-1?I:0-I|0)+((e|0)>-1?e:0-e|0)|0;k[q>>2]=e+(k[q>>2]|0);k[n>>2]=e+(k[n>>2]|0);e=k[Ha>>2]|0;if((f|0)<(e|0))f=f+1|0;else break}}if((a|0)<(e|0)){a=a+1|0;n=n+(La<<2)|0}else break}e=k[Ka>>2]|0}e=c+((aa(aa(aa(Oa,e+-1|0)|0,Qa)|0,Qa)|0)<<2)+(z<<2)+(u<<2)+(s<<2)|0;k[w+(s<<2)>>2]=k[e>>2];s=s+1|0;e=k[Pa>>2]|0}while((s|0)<(e|0))}y=y+1|0}while((y|0)<(e|0))}e=k[ja>>2]|0;if(e|0?(I=e+12|0,Ua=k[I>>2]|0,k[I>>2]=Ua+-1,(Ua|0)==1):0){a=k[ja>>2]|0;if(a|0){e=k[a+4>>2]|0;do if(!e){e=k[ia>>2]|0;if(e|0)break;e=B1()|0;a=k[ja>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,a)}k[ja>>2]=0}k[ja>>2]=0;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;if((k[ba>>2]|0)>0){a=k[ka>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[ba>>2]|0))}e=k[ma>>2]|0;if(!((e|0)==(la|0)|(e|0)==0))ggb(k[e+-4>>2]|0);D=D+1|0;e=k[Na>>2]|0}while((D|0)<(e|0));a=0;F=125}else{a=0;o=0;n=0;m=0;j=0;h=0;g=0;f=0;e=0}else{e=k[Ea>>2]|0;if(M){F=e+Sa|0;D=e+L+(k[Ha>>2]|0)|0;E=F-f|0;e=k[Na>>2]|0;if((e|0)>0){A=D-f|0;B=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)|0;C=d+((aa(aa(aa(Oa,L)|0,Qa)|0,Qa)|0)<<2)|0;z=0;do{g=k[Da>>2]|0;k[Ra>>2]=k[g+(z*56|0)>>2];e=g+(z*56|0)+4|0;k[oa>>2]=k[e>>2];k[pa>>2]=k[g+(z*56|0)+8>>2];k[qa>>2]=k[g+(z*56|0)+12>>2];k[ra>>2]=k[g+(z*56|0)+16>>2];k[sa>>2]=k[g+(z*56|0)+20>>2];k[ta>>2]=k[g+(z*56|0)+24>>2];k[ua>>2]=k[g+(z*56|0)+28>>2];k[va>>2]=k[g+(z*56|0)+32>>2];f=k[g+(z*56|0)+36>>2]|0;k[wa>>2]=f;k[xa>>2]=pa;k[za>>2]=ya;k[Aa>>2]=0;k[ya>>2]=0;if(f|0){Ua=f+12|0;k[Ua>>2]=(k[Ua>>2]|0)+1}if((k[e>>2]|0)>=3){k[oa>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[oa>>2]|0)>0){h=k[g+(z*56|0)+40>>2]|0;j=k[xa>>2]|0;f=k[g+(z*56|0)+44>>2]|0;g=k[za>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[oa>>2]|0))}}else{I=k[g+(z*56|0)+44>>2]|0;Ua=k[za>>2]|0;k[Ua>>2]=k[I>>2];k[Ua+4>>2]=k[I+4>>2]}e=k[Pa>>2]|0;if((e|0)>0){y=aa(aa(Qa,z)|0,Qa)|0;w=B+(y<<2)|0;x=b+(y<<2)|0;y=C+(y<<2)|0;v=0;do{if((e|0)>0){q=E+v|0;u=aa(Qa,v)|0;s=w+(u<<2)|0;t=x+(u<<2)|0;u=y+(u<<2)|0;p=0;do{n=s+(p<<2)|0;o=t+(p<<2)|0;k[o>>2]=(k[o>>2]|0)-(k[n>>2]|0);k[n>>2]=0;m=A+p|0;Ua=k[Ha>>2]|0;e=0-Ua|0;if((Ua|0)<(e|0))e=0;else{g=k[Ia>>2]|0;h=k[O>>2]|0;j=k[ra>>2]|0;f=e;e=0;while(1){Va=g+(aa(k[h>>2]|0,f+F|0)|0)|0;Ua=j+(aa(k[k[za>>2]>>2]|0,q+f|0)|0)|0;G=(l[Va+(D<<2)>>0]|0)-(l[Ua+(m<<2)>>0]|0)|0;H=(l[Va+(D<<2)+1>>0]|0)-(l[Ua+(m<<2)+1>>0]|0)|0;I=(l[Va+(D<<2)+2>>0]|0)-(l[Ua+(m<<2)+2>>0]|0)|0;Ua=(l[Va+(D<<2)+3>>0]|0)-(l[Ua+(m<<2)+3>>0]|0)|0;e=e+((G|0)>-1?G:0-G|0)+((H|0)>-1?H:0-H|0)+((I|0)>-1?I:0-I|0)+((Ua|0)>-1?Ua:0-Ua|0)|0;k[n>>2]=e;if((f|0)<(k[Ha>>2]|0))f=f+1|0;else break}}k[o>>2]=(k[o>>2]|0)+e;k[u+(p<<2)>>2]=k[n>>2];p=p+1|0;e=k[Pa>>2]|0}while((p|0)<(e|0))}v=v+1|0}while((v|0)<(e|0))}e=k[wa>>2]|0;if(e|0?(Ua=e+12|0,Va=k[Ua>>2]|0,k[Ua>>2]=Va+-1,(Va|0)==1):0){f=k[wa>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[va>>2]|0;if(e|0)break;e=B1()|0;f=k[wa>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[wa>>2]=0}k[wa>>2]=0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[oa>>2]|0)>0){f=k[xa>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[oa>>2]|0))}e=k[za>>2]|0;if(!((e|0)==(ya|0)|(e|0)==0))ggb(k[e+-4>>2]|0);z=z+1|0;e=k[Na>>2]|0}while((z|0)<(e|0))}}else{Va=e+N|0;G=e+L|0;H=k[Ha>>2]|0;h=G+H|0;I=Va-f|0;G=G-f+H|0;e=k[Ia>>2]|0;f=k[k[O>>2]>>2]|0;g=e+(aa(f,Va+~H|0)|0)|0;f=e+(aa(f,Va+H|0)|0)|0;H=k[Pa>>2]|0;e=k[Na>>2]|0;if((e|0)>0){B=(H|0)>0;C=I+-1|0;D=l[f+(h<<2)>>0]|0;E=l[f+(h<<2)+1>>0]|0;F=l[f+(h<<2)+2>>0]|0;x=l[f+(h<<2)+3>>0]|0;y=l[g+(h<<2)>>0]|0;z=l[g+(h<<2)+1>>0]|0;A=l[g+(h<<2)+2>>0]|0;u=l[g+(h<<2)+3>>0]|0;v=c+((aa(aa(aa(Oa,a)|0,Qa)|0,Qa)|0)<<2)|0;w=d+((aa(aa(aa(Oa,L)|0,Qa)|0,Qa)|0)<<2)|0;t=0;do{g=k[Da>>2]|0;k[Ra>>2]=k[g+(t*56|0)>>2];e=g+(t*56|0)+4|0;k[P>>2]=k[e>>2];k[Q>>2]=k[g+(t*56|0)+8>>2];k[R>>2]=k[g+(t*56|0)+12>>2];k[S>>2]=k[g+(t*56|0)+16>>2];k[T>>2]=k[g+(t*56|0)+20>>2];k[U>>2]=k[g+(t*56|0)+24>>2];k[V>>2]=k[g+(t*56|0)+28>>2];k[W>>2]=k[g+(t*56|0)+32>>2];f=k[g+(t*56|0)+36>>2]|0;k[X>>2]=f;k[Y>>2]=Q;k[_>>2]=Z;k[$>>2]=0;k[Z>>2]=0;if(f|0){Va=f+12|0;k[Va>>2]=(k[Va>>2]|0)+1}if((k[e>>2]|0)>=3){k[P>>2]=0;x1(Ra,k[e>>2]|0,0,0,0);if((k[P>>2]|0)>0){h=k[g+(t*56|0)+40>>2]|0;j=k[Y>>2]|0;f=k[g+(t*56|0)+44>>2]|0;g=k[_>>2]|0;e=0;do{k[j+(e<<2)>>2]=k[h+(e<<2)>>2];k[g+(e<<2)>>2]=k[f+(e<<2)>>2];e=e+1|0}while((e|0)<(k[P>>2]|0))}}else{Ua=k[g+(t*56|0)+44>>2]|0;Va=k[_>>2]|0;k[Va>>2]=k[Ua>>2];k[Va+4>>2]=k[Ua+4>>2]}m=aa(aa(Qa,t)|0,Qa)|0;h=b+(m<<2)|0;j=v+(m<<2)|0;m=w+(m<<2)|0;if(B){g=k[S>>2]|0;f=0;do{p=aa(f,Qa)|0;n=h+(p<<2)|0;o=j+(p<<2)|0;p=m+(p<<2)|0;s=k[Ha>>2]|0;e=k[k[_>>2]>>2]|0;q=g+(aa(e,C+f-s|0)|0)|0;s=g+(aa(e,f+I+s|0)|0)|0;e=0;do{Ua=o+(e<<2)|0;Wa=n+(e<<2)|0;k[Wa>>2]=(k[Wa>>2]|0)-(k[Ua>>2]|0);Va=p+(e<<2)|0;$a=G+e|0;_a=D-(l[s+($a<<2)>>0]|0)|0;Za=E-(l[s+($a<<2)+1>>0]|0)|0;Ya=F-(l[s+($a<<2)+2>>0]|0)|0;Xa=x-(l[s+($a<<2)+3>>0]|0)|0;cb=y-(l[q+($a<<2)>>0]|0)|0;bb=z-(l[q+($a<<2)+1>>0]|0)|0;ab=A-(l[q+($a<<2)+2>>0]|0)|0;$a=u-(l[q+($a<<2)+3>>0]|0)|0;Xa=(k[Va>>2]|0)-((cb|0)>-1?cb:0-cb|0)-((bb|0)>-1?bb:0-bb|0)-((ab|0)>-1?ab:0-ab|0)-(($a|0)>-1?$a:0-$a|0)+((_a|0)>-1?_a:0-_a|0)+((Za|0)>-1?Za:0-Za|0)+((Ya|0)>-1?Ya:0-Ya|0)+((Xa|0)>-1?Xa:0-Xa|0)|0;k[Ua>>2]=Xa;k[Wa>>2]=Xa+(k[Wa>>2]|0);k[Va>>2]=k[Ua>>2];e=e+1|0}while((e|0)!=(H|0));f=f+1|0}while((f|0)!=(H|0))}e=k[X>>2]|0;if(e|0?(bb=e+12|0,cb=k[bb>>2]|0,k[bb>>2]=cb+-1,(cb|0)==1):0){f=k[X>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[W>>2]|0;if(e|0)break;e=B1()|0;f=k[X>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[X>>2]=0}k[X>>2]=0;k[S>>2]=0;k[S+4>>2]=0;k[S+8>>2]=0;k[S+12>>2]=0;if((k[P>>2]|0)>0){f=k[Y>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[P>>2]|0))}e=k[_>>2]|0;if(!((e|0)==(Z|0)|(e|0)==0))ggb(k[e+-4>>2]|0);t=t+1|0;e=k[Na>>2]|0}while((t|0)<(e|0))}}a=(a+1|0)%(k[Ka>>2]|0)|0;F=125}if((F|0)==125){F=0;if((e|0)>0){C=k[Da>>2]|0;D=k[Pa>>2]|0;E=(D|0)>0;B=0;n=0;j=0;g=0;p=0;o=0;m=0;h=0;f=0;do{if(E){x=k[Ea>>2]|0;y=k[C+(B*56|0)+16>>2]|0;z=k[k[C+(B*56|0)+44>>2]>>2]|0;A=b+((aa(aa(Qa,B)|0,Qa)|0)<<2)|0;v=k[Fa>>2]|0;w=k[Ga>>2]|0;u=0;do{s=y+(aa(z,J+u+x|0)|0)|0;t=A+((aa(Qa,u)|0)<<2)|0;q=0;do{cb=k[t+(q<<2)>>2]>>v;$a=k[w+(cb<<4)>>2]|0;ab=k[w+(cb<<4)+4>>2]|0;bb=k[w+(cb<<4)+8>>2]|0;cb=k[w+(cb<<4)+12>>2]|0;_a=K+q+x|0;n=n+(aa(l[s+(_a<<2)>>0]|0,$a)|0)|0;j=j+(aa(l[s+(_a<<2)+1>>0]|0,ab)|0)|0;g=g+(aa(l[s+(_a<<2)+2>>0]|0,bb)|0)|0;p=p+(aa(l[s+(_a<<2)+3>>0]|0,cb)|0)|0;o=o+$a|0;m=m+ab|0;h=h+bb|0;f=f+cb|0;q=q+1|0}while((q|0)!=(D|0));u=u+1|0}while((u|0)!=(D|0))}B=B+1|0}while((B|0)!=(e|0));e=p}else{o=0;n=0;m=0;j=0;h=0;g=0;f=0;e=0}}$a=((((o|0)/2|0)+n|0)>>>0)/(o>>>0)|0;bb=((((m|0)/2|0)+j|0)>>>0)/(m>>>0)|0;cb=((((h|0)/2|0)+g|0)>>>0)/(h>>>0)|0;ab=((((f|0)/2|0)+e|0)>>>0)/(f>>>0)|0;e=k[Ca>>2]|0;e=(k[e+16>>2]|0)+(aa(k[k[e+44>>2]>>2]|0,N)|0)+(L<<2)|0;cb=($a>>>0<256?$a:($a|0)>0?255:0)&255|(ab>>>0<256?ab:(ab|0)>0?255:0)<<24|(bb>>>0<256?bb:(bb|0)>0?255:0)<<8&65280|(cb>>>0<256?cb:(cb|0)>0?255:0)<<16&16711680;i[e>>0]=cb;i[e+1>>0]=cb>>8;i[e+2>>0]=cb>>16;i[e+3>>0]=cb>>24;L=L+1|0;e=k[Ja>>2]|0}while((L|0)<(e|0))}N=N+1|0}while((N|0)<(Ma|0))}if(d|0)ggb(d);if(c|0)ggb(c);if(!b){r=Ta;return}ggb(b);r=Ta;return}function w2a(a){a=a|0;Z1a(a);ggb(a);return}
function ssa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;i=aa(k[a+4>>2]|0,e)|0;h=aa(d+-1|0,e)|0;if((e|0)<=0)return;a=(h|0)>0;if((i|0)<=0){if(a){f=0;a=b}else{zpb(c|0,0,e<<2|0)|0;return}while(1){k[c>>2]=0;d=0;b=0;do{b=(k[a+(d+i<<2)>>2]|0)-(k[a+(d<<2)>>2]|0)+b|0;d=d+e|0;k[c+(d<<2)>>2]=b}while((d|0)<(h|0));f=f+1|0;if((f|0)==(e|0))break;else{c=c+4|0;a=a+4|0}}return}if(a){g=0;f=b}else{f=0;d=b;while(1){a=0;b=0;do{b=(k[d+(a<<2)>>2]|0)+b|0;a=a+e|0}while((a|0)<(i|0));k[c>>2]=b;f=f+1|0;if((f|0)==(e|0))break;else{c=c+4|0;d=d+4|0}}return}while(1){a=0;d=0;do{d=(k[f+(a<<2)>>2]|0)+d|0;a=a+e|0}while((a|0)<(i|0));k[c>>2]=d;b=0;a=d;do{a=(k[f+(b+i<<2)>>2]|0)-(k[f+(b<<2)>>2]|0)+a|0;b=b+e|0;k[c+(b<<2)>>2]=a}while((b|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+4|0;f=f+4|0}}return}function tsa(a){a=a|0;ggb(a);return}function usa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function vsa(a){a=a|0;ggb(a);return}function wsa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;i=aa(k[a+4>>2]|0,e)|0;h=aa(d+-1|0,e)|0;if((e|0)<=0)return;a=(h|0)>0;if((i|0)<=0){if(a){f=0;a=b}else{zpb(c|0,0,e<<2|0)|0;return}while(1){k[c>>2]=0;d=0;b=0;do{b=(j[a+(d+i<<1)>>1]|0)-(j[a+(d<<1)>>1]|0)+b|0;d=d+e|0;k[c+(d<<2)>>2]=b}while((d|0)<(h|0));f=f+1|0;if((f|0)==(e|0))break;else{c=c+4|0;a=a+2|0}}return}if(a){g=0;f=b}else{f=0;d=b;while(1){a=0;b=0;do{b=(j[d+(a<<1)>>1]|0)+b|0;a=a+e|0}while((a|0)<(i|0));k[c>>2]=b;f=f+1|0;if((f|0)==(e|0))break;else{c=c+4|0;d=d+2|0}}return}while(1){a=0;d=0;do{d=(j[f+(a<<1)>>1]|0)+d|0;a=a+e|0}while((a|0)<(i|0));k[c>>2]=d;b=0;a=d;do{a=(j[f+(b+i<<1)>>1]|0)-(j[f+(b<<1)>>1]|0)+a|0;b=b+e|0;k[c+(b<<2)>>2]=a}while((b|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+4|0;f=f+2|0}}return}function xsa(a){a=a|0;ggb(a);return}function ysa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function zsa(a){a=a|0;ggb(a);return}function Asa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0;i=aa(k[a+4>>2]|0,e)|0;h=aa(d+-1|0,e)|0;if((e|0)<=0)return;a=(h|0)>0;if((i|0)<=0){if(a){g=0;a=b}else{zpb(c|0,0,e<<3|0)|0;return}while(1){p[c>>3]=0.0;d=0;f=0.0;do{f=f+ +((m[a+(d+i<<1)>>1]|0)-(m[a+(d<<1)>>1]|0)|0);d=d+e|0;p[c+(d<<3)>>3]=f}while((d|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;a=a+2|0}}return}if(a){g=0;d=b}else{g=0;d=b;while(1){a=0;f=0.0;do{f=f+ +(m[d+(a<<1)>>1]|0);a=a+e|0}while((a|0)<(i|0));p[c>>3]=f;g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+2|0}}return}while(1){a=0;f=0.0;do{f=f+ +(m[d+(a<<1)>>1]|0);a=a+e|0}while((a|0)<(i|0));p[c>>3]=f;a=0;do{f=f+ +((m[d+(a+i<<1)>>1]|0)-(m[d+(a<<1)>>1]|0)|0);a=a+e|0;p[c+(a<<3)>>3]=f}while((a|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+2|0}}return}function Bsa(a){a=a|0;ggb(a);return}function Csa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Dsa(a){a=a|0;ggb(a);return}function Esa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;i=aa(k[a+4>>2]|0,e)|0;h=aa(d+-1|0,e)|0;if((e|0)<=0)return;a=(h|0)>0;if((i|0)<=0){if(a){f=0;a=b}else{zpb(c|0,0,e<<2|0)|0;return}while(1){k[c>>2]=0;d=0;b=0;do{b=(m[a+(d+i<<1)>>1]|0)-(m[a+(d<<1)>>1]|0)+b|0;d=d+e|0;k[c+(d<<2)>>2]=b}while((d|0)<(h|0));f=f+1|0;if((f|0)==(e|0))break;else{c=c+4|0;a=a+2|0}}return}if(a){g=0;f=b}else{f=0;d=b;while(1){a=0;b=0;do{b=(m[d+(a<<1)>>1]|0)+b|0;a=a+e|0}while((a|0)<(i|0));k[c>>2]=b;f=f+1|0;if((f|0)==(e|0))break;else{c=c+4|0;d=d+2|0}}return}while(1){a=0;d=0;do{d=(m[f+(a<<1)>>1]|0)+d|0;a=a+e|0}while((a|0)<(i|0));k[c>>2]=d;b=0;a=d;do{a=(m[f+(b+i<<1)>>1]|0)-(m[f+(b<<1)>>1]|0)+a|0;b=b+e|0;k[c+(b<<2)>>2]=a}while((b|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+4|0;f=f+2|0}}return}function Fsa(a){a=a|0;ggb(a);return}function Gsa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Hsa(a){a=a|0;ggb(a);return}function Isa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0;i=aa(k[a+4>>2]|0,e)|0;h=aa(d+-1|0,e)|0;if((e|0)<=0)return;a=(h|0)>0;if((i|0)<=0){if(a){g=0;a=b}else{zpb(c|0,0,e<<3|0)|0;return}while(1){p[c>>3]=0.0;d=0;f=0.0;do{f=f+ +((l[a+(d+i)>>0]|0)-(l[a+d>>0]|0)|0);d=d+e|0;p[c+(d<<3)>>3]=f}while((d|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;a=a+1|0}}return}if(a){g=0;d=b}else{g=0;d=b;while(1){a=0;f=0.0;do{f=f+ +(l[d+a>>0]|0);a=a+e|0}while((a|0)<(i|0));p[c>>3]=f;g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+1|0}}return}while(1){a=0;f=0.0;do{f=f+ +(l[d+a>>0]|0);a=a+e|0}while((a|0)<(i|0));p[c>>3]=f;a=0;do{f=f+ +((l[d+(a+i)>>0]|0)-(l[d+a>>0]|0)|0);a=a+e|0;p[c+(a<<3)>>3]=f}while((a|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+1|0}}return}function Jsa(a){a=a|0;ggb(a);return}function Ksa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Lsa(a){a=a|0;ggb(a);return}function Msa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;i=aa(k[a+4>>2]|0,e)|0;h=aa(d+-1|0,e)|0;if((e|0)<=0)return;a=(h|0)>0;if((i|0)<=0){if(a){f=0;a=b}else{zpb(c|0,0,e<<2|0)|0;return}while(1){k[c>>2]=0;d=0;b=0;do{b=(l[a+(d+i)>>0]|0)-(l[a+d>>0]|0)+b|0;d=d+e|0;k[c+(d<<2)>>2]=b}while((d|0)<(h|0));f=f+1|0;if((f|0)==(e|0))break;else{c=c+4|0;a=a+1|0}}return}if(a){g=0;f=b}else{f=0;d=b;while(1){a=0;b=0;do{b=(l[d+a>>0]|0)+b|0;a=a+e|0}while((a|0)<(i|0));k[c>>2]=b;f=f+1|0;if((f|0)==(e|0))break;else{c=c+4|0;d=d+1|0}}return}while(1){a=0;d=0;do{d=(l[f+a>>0]|0)+d|0;a=a+e|0}while((a|0)<(i|0));k[c>>2]=d;b=0;a=d;do{a=(l[f+(b+i)>>0]|0)-(l[f+b>>0]|0)+a|0;b=b+e|0;k[c+(b<<2)>>2]=a}while((b|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+4|0;f=f+1|0}}return}function Nsa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0;t=r;r=r+16|0;q=t;s=t+8|0;n=b&7;o=c&7;if((c^b)&4088|0){g=s+4|0;h=ZT(48)|0;k[h>>2]=1;j=h+4|0;k[s>>2]=j;k[g>>2]=40;i[h+44>>0]=0;l=349760;m=j+40|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,s,349801,348846,1251);k[g>>2]=0;k[s>>2]=0;m=k[h>>2]|0;k[h>>2]=m+-1;if((m|0)==1)ggb(k[h+-4>>2]|0)}j=(e|0)<0?(d|0)/2|0:e;g=(o|0)==0;e=(n|0)==4;if(e&g){while(1){g=fgb(40)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}k[h>>2]=88496;k[h+28>>2]=0;k[h+32>>2]=0;k[h+36>>2]=0;k[h+4>>2]=d;k[h+8>>2]=j;p[h+16>>3]=f;k[h+24>>2]=0;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}d=g+4|0;k[d>>2]=1;k[g>>2]=88520;k[g+8>>2]=h;k[a>>2]=g;k[a+4>>2]=h;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1){r=t;return}Uh[k[(k[g>>2]|0)+8>>2]&2047](g);r=t;return}h=(n|0)==6;if(h&g){while(1){g=fgb(40)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}k[h>>2]=88540;k[h+28>>2]=0;k[h+32>>2]=0;k[h+36>>2]=0;k[h+4>>2]=d;k[h+8>>2]=j;p[h+16>>3]=f;k[h+24>>2]=0;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}d=g+4|0;k[d>>2]=1;k[g>>2]=88564;k[g+8>>2]=h;k[a>>2]=g;k[a+4>>2]=h;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1){r=t;return}Uh[k[(k[g>>2]|0)+8>>2]&2047](g);r=t;return}g=(o|0)==2;if(e&g){while(1){g=fgb(40)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}k[h>>2]=88584;k[h+28>>2]=0;k[h+32>>2]=0;k[h+36>>2]=0;k[h+4>>2]=d;k[h+8>>2]=j;p[h+16>>3]=f;k[h+24>>2]=0;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}d=g+4|0;k[d>>2]=1;k[g>>2]=88608;k[g+8>>2]=h;k[a>>2]=g;k[a+4>>2]=h;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1){r=t;return}Uh[k[(k[g>>2]|0)+8>>2]&2047](g);r=t;return}if(h&g){while(1){g=fgb(40)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}k[h>>2]=88628;k[h+28>>2]=0;k[h+32>>2]=0;k[h+36>>2]=0;k[h+4>>2]=d;k[h+8>>2]=j;p[h+16>>3]=f;k[h+24>>2]=0;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}d=g+4|0;k[d>>2]=1;k[g>>2]=88652;k[g+8>>2]=h;k[a>>2]=g;k[a+4>>2]=h;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1){r=t;return}Uh[k[(k[g>>2]|0)+8>>2]&2047](g);r=t;return}g=(o|0)==3;if(e&g){while(1){g=fgb(40)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}k[h>>2]=88672;k[h+28>>2]=0;k[h+32>>2]=0;k[h+36>>2]=0;k[h+4>>2]=d;k[h+8>>2]=j;p[h+16>>3]=f;k[h+24>>2]=0;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}d=g+4|0;k[d>>2]=1;k[g>>2]=88696;k[g+8>>2]=h;k[a>>2]=g;k[a+4>>2]=h;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1){r=t;return}Uh[k[(k[g>>2]|0)+8>>2]&2047](g);r=t;return}if(h&g){while(1){g=fgb(40)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}k[h>>2]=88716;k[h+28>>2]=0;k[h+32>>2]=0;k[h+36>>2]=0;k[h+4>>2]=d;k[h+8>>2]=j;p[h+16>>3]=f;k[h+24>>2]=0;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}d=g+4|0;k[d>>2]=1;k[g>>2]=88740;k[g+8>>2]=h;k[a>>2]=g;k[a+4>>2]=h;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1){r=t;return}Uh[k[(k[g>>2]|0)+8>>2]&2047](g);r=t;return}if(e&(o|0)==4){while(1){g=fgb(40)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}k[h>>2]=88760;k[h+28>>2]=0;k[h+32>>2]=0;k[h+36>>2]=0;k[h+4>>2]=d;k[h+8>>2]=j;p[h+16>>3]=f;k[h+24>>2]=0;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}d=g+4|0;k[d>>2]=1;k[g>>2]=88784;k[g+8>>2]=h;k[a>>2]=g;k[a+4>>2]=h;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1){r=t;return}Uh[k[(k[g>>2]|0)+8>>2]&2047](g);r=t;return}g=(o|0)==5;if(e&g){while(1){g=fgb(40)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}k[h>>2]=88804;k[h+28>>2]=0;k[h+32>>2]=0;k[h+36>>2]=0;k[h+4>>2]=d;k[h+8>>2]=j;p[h+16>>3]=f;k[h+24>>2]=0;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}d=g+4|0;k[d>>2]=1;k[g>>2]=88828;k[g+8>>2]=h;k[a>>2]=g;k[a+4>>2]=h;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1){r=t;return}Uh[k[(k[g>>2]|0)+8>>2]&2047](g);r=t;return}if(h&g){while(1){g=fgb(40)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}k[h>>2]=88848;k[h+28>>2]=0;k[h+32>>2]=0;k[h+36>>2]=0;k[h+4>>2]=d;k[h+8>>2]=j;p[h+16>>3]=f;k[h+24>>2]=0;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}d=g+4|0;k[d>>2]=1;k[g>>2]=88872;k[g+8>>2]=h;k[a>>2]=g;k[a+4>>2]=h;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1){r=t;return}Uh[k[(k[g>>2]|0)+8>>2]&2047](g);r=t;return}g=(o|0)==6;if(e&g){while(1){g=fgb(40)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}k[h>>2]=88892;k[h+28>>2]=0;k[h+32>>2]=0;k[h+36>>2]=0;k[h+4>>2]=d;k[h+8>>2]=j;p[h+16>>3]=f;k[h+24>>2]=0;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}d=g+4|0;k[d>>2]=1;k[g>>2]=88916;k[g+8>>2]=h;k[a>>2]=g;k[a+4>>2]=h;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1){r=t;return}Uh[k[(k[g>>2]|0)+8>>2]&2047](g);r=t;return}if(!(h&g)){k[q>>2]=b;k[q+4>>2]=c;$8(s,349820,q);Y8(-213,s,349801,348846,1281);g=k[s>>2]|0;k[s+4>>2]=0;k[s>>2]=0;if(g|0?(s=g+-4|0,d=k[s>>2]|0,k[s>>2]=d+-1,(d|0)==1):0)ggb(k[g+-8>>2]|0);k[a>>2]=0;k[a+4>>2]=0;r=t;return}while(1){g=fgb(40)|0;if(g|0){h=g;break}g=k[207666]|0;k[207666]=g+0;if(!g){h=0;break}Qh[g&7]()}k[h>>2]=88936;k[h+28>>2]=0;k[h+32>>2]=0;k[h+36>>2]=0;k[h+4>>2]=d;k[h+8>>2]=j;p[h+16>>3]=f;k[h+24>>2]=0;while(1){g=fgb(16)|0;if(g|0)break;g=k[207666]|0;k[207666]=g+0;if(!g){g=0;break}Qh[g&7]()}d=g+4|0;k[d>>2]=1;k[g>>2]=88960;k[g+8>>2]=h;k[a>>2]=g;k[a+4>>2]=h;k[d>>2]=(k[d>>2]|0)+1;a=k[d>>2]|0;k[d>>2]=a+-1;if((a|0)!=1){r=t;return}Uh[k[(k[g>>2]|0)+8>>2]&2047](g);r=t;return}function Osa(a){a=a|0;ggb(a);return}function Psa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Qsa(a){a=a|0;var b=0,c=0;k[a>>2]=88936;c=k[a+28>>2]|0;if(!c)return;a=a+32|0;b=k[a>>2]|0;if((b|0)!=(c|0))k[a>>2]=b+(~((b+-8-c|0)>>>3)<<3);ggb(c);return}function Rsa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=88936;b=k[a+28>>2]|0;if(!b){ggb(a);return}c=a+32|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Ssa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0;x=r;r=r+16|0;o=x;v=+p[a+16>>3];w=v!=1.0;j=a+28|0;l=a+32|0;h=k[l>>2]|0;g=k[j>>2]|0;m=h-g>>3;if((m|0)==(f|0)){h=a+24|0;j=k[h>>2]|0;if(!j){u=h;q=9}else{a=a+4|0;h=k[a>>2]|0;if((j|0)!=(h+-1|0)){h=o+4|0;j=ZT(24)|0;k[j>>2]=1;l=j+4|0;k[o>>2]=l;k[h>>2]=19;i[j+23>>0]=0;m=349966;n=l+19|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,o,369779,348846,153);k[h>>2]=0;k[o>>2]=0;u=k[j>>2]|0;k[j>>2]=u+-1;if((u|0)==1)ggb(k[j+-4>>2]|0);h=k[a>>2]|0}j=b+(h+-1<<2)|0}}else{if(m>>>0>=f>>>0){if(m>>>0>f>>>0?(n=g+(f<<3)|0,(h|0)!=(n|0)):0)k[l>>2]=h+(~((h+-8-n|0)>>>3)<<3)}else{Bla(j,f-m|0);g=k[j>>2]|0}u=a+24|0;k[u>>2]=0;q=9}if((q|0)==9){zpb(g|0,0,f<<3|0)|0;t=k[u>>2]|0;h=k[a+4>>2]|0;s=h+-1|0;if((t|0)<(s|0)){m=f+-2|0;if((f|0)<2){l=(f|0)==1;j=b;m=t;while(1){if(l)p[g>>3]=+p[k[j>>2]>>3]+ +p[g>>3];m=m+1|0;if((m|0)==(s|0))break;else j=j+4|0}}else{n=f&-2;a=(n|0)<(f|0);l=b;q=t;while(1){o=k[l>>2]|0;j=0;do{A=g+(j<<3)|0;B=j|1;y=g+(B<<3)|0;z=+p[y>>3]+ +p[o+(B<<3)>>3];p[A>>3]=+p[A>>3]+ +p[o+(j<<3)>>3];p[y>>3]=z;j=j+2|0}while((j|0)<=(m|0));if(a){j=n;do{B=g+(j<<3)|0;p[B>>3]=+p[o+(j<<3)>>3]+ +p[B>>3];j=j+1|0}while((j|0)!=(f|0))}q=q+1|0;if((q|0)==(s|0))break;else l=l+4|0}}k[u>>2]=s;j=b+(h+-1-t<<2)|0}else j=b}if(!e){r=x;return}o=1-h|0;q=f+-2|0;s=(f|0)<2;t=f&-2;a=c;l=e;while(1){l=l+-1|0;m=k[j>>2]|0;n=k[j+(o<<2)>>2]|0;if(w){if(s)h=0;else{h=0;do{A=g+(h<<3)|0;C=+p[A>>3]+ +p[m+(h<<3)>>3];y=h|1;B=g+(y<<3)|0;z=+p[B>>3]+ +p[m+(y<<3)>>3];p[a+(h<<3)>>3]=v*C;p[a+(y<<3)>>3]=v*z;z=z-+p[n+(y<<3)>>3];p[A>>3]=C-+p[n+(h<<3)>>3];p[B>>3]=z;h=h+2|0}while((h|0)<=(q|0));h=t}if((h|0)<(f|0))do{B=g+(h<<3)|0;C=+p[B>>3]+ +p[m+(h<<3)>>3];p[a+(h<<3)>>3]=v*C;p[B>>3]=C-+p[n+(h<<3)>>3];h=h+1|0}while((h|0)!=(f|0))}else{if(s)h=0;else{h=0;do{A=g+(h<<3)|0;z=+p[A>>3]+ +p[m+(h<<3)>>3];y=h|1;B=g+(y<<3)|0;C=+p[B>>3]+ +p[m+(y<<3)>>3];p[a+(h<<3)>>3]=z;p[a+(y<<3)>>3]=C;C=C-+p[n+(y<<3)>>3];p[A>>3]=z-+p[n+(h<<3)>>3];p[B>>3]=C;h=h+2|0}while((h|0)<=(q|0));h=t}if((h|0)<(f|0))do{B=g+(h<<3)|0;C=+p[B>>3]+ +p[m+(h<<3)>>3];p[a+(h<<3)>>3]=C;p[B>>3]=C-+p[n+(h<<3)>>3];h=h+1|0}while((h|0)!=(f|0))}if(!l)break;else{a=a+d|0;j=j+4|0}}r=x;return}function Tsa(a){a=a|0;k[a+24>>2]=0;return}function Usa(a){a=a|0;ggb(a);return}function Vsa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Wsa(a){a=a|0;var b=0,c=0;k[a>>2]=88892;c=k[a+28>>2]|0;if(!c)return;a=a+32|0;b=k[a>>2]|0;if((b|0)!=(c|0))k[a>>2]=b+(~((b+-4-c|0)>>>2)<<2);ggb(c);return}function Xsa(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=88892;b=k[a+28>>2]|0;if(!b){ggb(a);return}c=a+32|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);ggb(b);ggb(a);return}function Ysa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0;v=r;r=r+16|0;q=v;t=+p[a+16>>3];u=t!=1.0;j=a+28|0;l=a+32|0;h=k[l>>2]|0;g=k[j>>2]|0;m=h-g>>2;if((m|0)==(f|0)){h=a+24|0;j=k[h>>2]|0;if(!j)s=9;else{o=a+4|0;h=k[o>>2]|0;if((j|0)!=(h+-1|0)){h=q+4|0;j=ZT(24)|0;k[j>>2]=1;l=j+4|0;k[q>>2]=l;k[h>>2]=19;i[j+23>>0]=0;m=349966;n=l+19|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,q,369779,348846,153);k[h>>2]=0;k[q>>2]=0;q=k[j>>2]|0;k[j>>2]=q+-1;if((q|0)==1)ggb(k[j+-4>>2]|0);h=k[o>>2]|0}b=b+(h+-1<<2)|0}}else{if(m>>>0>=f>>>0){if(m>>>0>f>>>0?(n=g+(f<<2)|0,(h|0)!=(n|0)):0)k[l>>2]=h+(~((h+-4-n|0)>>>2)<<2)}else{U1(j,f-m|0);g=k[j>>2]|0}h=a+24|0;k[h>>2]=0;s=9}a:do if((s|0)==9){zpb(g|0,0,f<<2|0)|0;j=k[h>>2]|0;q=a+4|0;l=k[q>>2]|0;if((j|0)<(l+-1|0)){o=f+-2|0;if((f|0)<2){m=(f|0)==1;while(1){if(m){k[g>>2]=(k[g>>2]|0)+(k[k[b>>2]>>2]|0);j=k[h>>2]|0;l=k[q>>2]|0}j=j+1|0;k[h>>2]=j;b=b+4|0;if((j|0)>=(l+-1|0)){h=l;break a}}}m=f&-2;n=(m|0)<(f|0);do{l=k[b>>2]|0;j=0;do{x=g+(j<<2)|0;w=j|1;s=g+(w<<2)|0;w=(k[l+(w<<2)>>2]|0)+(k[s>>2]|0)|0;k[x>>2]=(k[l+(j<<2)>>2]|0)+(k[x>>2]|0);k[s>>2]=w;j=j+2|0}while((j|0)<=(o|0));if(n){j=m;do{x=g+(j<<2)|0;k[x>>2]=(k[x>>2]|0)+(k[l+(j<<2)>>2]|0);j=j+1|0}while((j|0)!=(f|0))}x=(k[h>>2]|0)+1|0;k[h>>2]=x;b=b+4|0;j=k[q>>2]|0}while((x|0)<(j+-1|0));h=j}else h=l}while(0);if(!e){r=v;return}n=a+4|0;o=f+-2|0;q=(f|0)<2;s=f&-2;m=c;while(1){e=e+-1|0;l=k[b>>2]|0;j=k[b+(1-h<<2)>>2]|0;if(u){if(q)h=0;else{h=0;do{c=g+(h<<2)|0;a=(k[l+(h<<2)>>2]|0)+(k[c>>2]|0)|0;w=h|1;x=g+(w<<2)|0;y=(k[l+(w<<2)>>2]|0)+(k[x>>2]|0)|0;p[m+(h<<3)>>3]=t*+(a|0);p[m+(w<<3)>>3]=t*+(y|0);w=y-(k[j+(w<<2)>>2]|0)|0;k[c>>2]=a-(k[j+(h<<2)>>2]|0);k[x>>2]=w;h=h+2|0}while((h|0)<=(o|0));h=s}if((h|0)<(f|0))do{y=g+(h<<2)|0;x=(k[l+(h<<2)>>2]|0)+(k[y>>2]|0)|0;p[m+(h<<3)>>3]=t*+(x|0);k[y>>2]=x-(k[j+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(f|0))}else{if(q)h=0;else{h=0;do{w=g+(h<<2)|0;c=(k[l+(h<<2)>>2]|0)+(k[w>>2]|0)|0;x=h|1;y=g+(x<<2)|0;a=(k[l+(x<<2)>>2]|0)+(k[y>>2]|0)|0;p[m+(h<<3)>>3]=+(c|0);p[m+(x<<3)>>3]=+(a|0);x=a-(k[j+(x<<2)>>2]|0)|0;k[w>>2]=c-(k[j+(h<<2)>>2]|0);k[y>>2]=x;h=h+2|0}while((h|0)<=(o|0));h=s}if((h|0)<(f|0))do{y=g+(h<<2)|0;x=(k[l+(h<<2)>>2]|0)+(k[y>>2]|0)|0;p[m+(h<<3)>>3]=+(x|0);k[y>>2]=x-(k[j+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(f|0))}if(!e)break;m=m+d|0;b=b+4|0;h=k[n>>2]|0}r=v;return}function Zsa(a){a=a|0;k[a+24>>2]=0;return}function _sa(a){a=a|0;ggb(a);return}function $sa(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function ata(a){a=a|0;var b=0,c=0;k[a>>2]=88848;c=k[a+28>>2]|0;if(!c)return;a=a+32|0;b=k[a>>2]|0;if((b|0)!=(c|0))k[a>>2]=b+(~((b+-8-c|0)>>>3)<<3);ggb(c);return}function bta(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=88848;b=k[a+28>>2]|0;if(!b){ggb(a);return}c=a+32|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function cta(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0.0;y=r;r=r+16|0;q=y;w=+p[a+16>>3];x=w!=1.0;j=a+28|0;l=a+32|0;h=k[l>>2]|0;g=k[j>>2]|0;m=h-g>>3;if((m|0)==(f|0)){h=a+24|0;j=k[h>>2]|0;if(!j){v=h;s=9}else{a=a+4|0;h=k[a>>2]|0;if((j|0)!=(h+-1|0)){h=q+4|0;j=ZT(24)|0;k[j>>2]=1;l=j+4|0;k[q>>2]=l;k[h>>2]=19;i[j+23>>0]=0;m=349966;n=l+19|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,q,369779,348846,153);k[h>>2]=0;k[q>>2]=0;v=k[j>>2]|0;k[j>>2]=v+-1;if((v|0)==1)ggb(k[j+-4>>2]|0);h=k[a>>2]|0}j=b+(h+-1<<2)|0}}else{if(m>>>0>=f>>>0){if(m>>>0>f>>>0?(n=g+(f<<3)|0,(h|0)!=(n|0)):0)k[l>>2]=h+(~((h+-8-n|0)>>>3)<<3)}else{Bla(j,f-m|0);g=k[j>>2]|0}v=a+24|0;k[v>>2]=0;s=9}if((s|0)==9){zpb(g|0,0,f<<3|0)|0;u=k[v>>2]|0;h=k[a+4>>2]|0;t=h+-1|0;if((u|0)<(t|0)){m=f+-2|0;if((f|0)<2){l=(f|0)==1;j=b;m=u;while(1){if(l)p[g>>3]=+p[k[j>>2]>>3]+ +p[g>>3];m=m+1|0;if((m|0)==(t|0))break;else j=j+4|0}}else{n=f&-2;a=(n|0)<(f|0);l=b;s=u;while(1){q=k[l>>2]|0;j=0;do{B=g+(j<<3)|0;C=j|1;z=g+(C<<3)|0;A=+p[z>>3]+ +p[q+(C<<3)>>3];p[B>>3]=+p[B>>3]+ +p[q+(j<<3)>>3];p[z>>3]=A;j=j+2|0}while((j|0)<=(m|0));if(a){j=n;do{C=g+(j<<3)|0;p[C>>3]=+p[q+(j<<3)>>3]+ +p[C>>3];j=j+1|0}while((j|0)!=(f|0))}s=s+1|0;if((s|0)==(t|0))break;else l=l+4|0}}k[v>>2]=t;j=b+(h+-1-u<<2)|0}else j=b}if(!e){r=y;return}q=1-h|0;s=f+-2|0;t=(f|0)<2;u=f&-2;a=c;l=e;while(1){l=l+-1|0;m=k[j>>2]|0;n=k[j+(q<<2)>>2]|0;if(x){if(t)h=0;else{h=0;do{B=g+(h<<3)|0;D=+p[B>>3]+ +p[m+(h<<3)>>3];z=h|1;C=g+(z<<3)|0;A=+p[C>>3]+ +p[m+(z<<3)>>3];o[a+(h<<2)>>2]=w*D;o[a+(z<<2)>>2]=w*A;A=A-+p[n+(z<<3)>>3];p[B>>3]=D-+p[n+(h<<3)>>3];p[C>>3]=A;h=h+2|0}while((h|0)<=(s|0));h=u}if((h|0)<(f|0))do{C=g+(h<<3)|0;D=+p[C>>3]+ +p[m+(h<<3)>>3];o[a+(h<<2)>>2]=w*D;p[C>>3]=D-+p[n+(h<<3)>>3];h=h+1|0}while((h|0)!=(f|0))}else{if(t)h=0;else{h=0;do{B=g+(h<<3)|0;A=+p[B>>3]+ +p[m+(h<<3)>>3];z=h|1;C=g+(z<<3)|0;D=+p[C>>3]+ +p[m+(z<<3)>>3];o[a+(h<<2)>>2]=A;o[a+(z<<2)>>2]=D;D=D-+p[n+(z<<3)>>3];p[B>>3]=A-+p[n+(h<<3)>>3];p[C>>3]=D;h=h+2|0}while((h|0)<=(s|0));h=u}if((h|0)<(f|0))do{C=g+(h<<3)|0;D=+p[C>>3]+ +p[m+(h<<3)>>3];o[a+(h<<2)>>2]=D;p[C>>3]=D-+p[n+(h<<3)>>3];h=h+1|0}while((h|0)!=(f|0))}if(!l)break;else{a=a+d|0;j=j+4|0}}r=y;return}function dta(a){a=a|0;k[a+24>>2]=0;return}function eta(a){a=a|0;ggb(a);return}function fta(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function gta(a){a=a|0;var b=0,c=0;k[a>>2]=88804;c=k[a+28>>2]|0;if(!c)return;a=a+32|0;b=k[a>>2]|0;if((b|0)!=(c|0))k[a>>2]=b+(~((b+-4-c|0)>>>2)<<2);ggb(c);return}function hta(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=88804;b=k[a+28>>2]|0;if(!b){ggb(a);return}c=a+32|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);ggb(b);ggb(a);return}function ita(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,v=0.0,w=0;w=r;r=r+16|0;q=w;v=+p[a+16>>3];u=v!=1.0;h=a+28|0;j=a+32|0;g=k[j>>2]|0;s=k[h>>2]|0;l=g-s>>2;if((l|0)==(f|0)){g=a+24|0;h=k[g>>2]|0;if(!h){m=g;n=s;t=9}else{n=a+4|0;g=k[n>>2]|0;if((h|0)!=(g+-1|0)){g=q+4|0;h=ZT(24)|0;k[h>>2]=1;j=h+4|0;k[q>>2]=j;k[g>>2]=19;i[h+23>>0]=0;l=349966;m=j+19|0;do{i[j>>0]=i[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(m|0));Y8(-215,q,369779,348846,930);k[g>>2]=0;k[q>>2]=0;q=k[h>>2]|0;k[h>>2]=q+-1;if((q|0)==1)ggb(k[h+-4>>2]|0);g=k[n>>2]|0}b=b+(g+-1<<2)|0;n=s}}else{if(l>>>0>=f>>>0)if(l>>>0>f>>>0?(m=s+(f<<2)|0,(g|0)!=(m|0)):0){k[j>>2]=g+(~((g+-4-m|0)>>>2)<<2);g=s}else g=s;else{U1(h,f-l|0);g=k[h>>2]|0}m=a+24|0;k[m>>2]=0;n=g;t=9}do if((t|0)==9){zpb(n|0,0,f<<2|0)|0;h=k[m>>2]|0;l=a+4|0;g=k[l>>2]|0;j=g+-1|0;if((h|0)<(j|0)){if((f|0)<=0){k[m>>2]=j;b=b+(g+-1-h<<2)|0;break}do{h=k[b>>2]|0;g=0;do{t=n+(g<<2)|0;k[t>>2]=(k[t>>2]|0)+(k[h+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(f|0));t=(k[m>>2]|0)+1|0;k[m>>2]=t;b=b+4|0;g=k[l>>2]|0}while((t|0)<(g+-1|0))}}while(0);j=e+-1|0;if(!e){r=w;return}q=a+4|0;m=(f|0)>0;if(u){while(1){l=k[b>>2]|0;h=k[b+(1-g<<2)>>2]|0;if(m){g=0;do{u=n+(g<<2)|0;e=(k[l+(g<<2)>>2]|0)+(k[u>>2]|0)|0;o[c+(g<<2)>>2]=v*+(e|0);k[u>>2]=e-(k[h+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(f|0))}if(!j)break;c=c+d|0;b=b+4|0;g=k[q>>2]|0;j=j+-1|0}r=w;return}if(m)l=b;else{r=w;return}while(1){h=k[l>>2]|0;b=k[l+(1-g<<2)>>2]|0;g=0;do{u=n+(g<<2)|0;e=(k[h+(g<<2)>>2]|0)+(k[u>>2]|0)|0;o[c+(g<<2)>>2]=+(e|0);k[u>>2]=e-(k[b+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(f|0));if(!j)break;c=c+d|0;l=l+4|0;j=j+-1|0;g=k[q>>2]|0}r=w;return}function jta(a){a=a|0;k[a+24>>2]=0;return}function kta(a){a=a|0;ggb(a);return}function lta(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function mta(a){a=a|0;var b=0,c=0;k[a>>2]=88760;c=k[a+28>>2]|0;if(!c)return;a=a+32|0;b=k[a>>2]|0;if((b|0)!=(c|0))k[a>>2]=b+(~((b+-4-c|0)>>>2)<<2);ggb(c);return}function nta(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=88760;b=k[a+28>>2]|0;if(!b){ggb(a);return}c=a+32|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);ggb(b);ggb(a);return}function ota(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0.0,n=0,o=0,q=0,s=0,t=0,v=0,w=0,x=0.0,y=0;y=r;r=r+16|0;s=y;x=+p[a+16>>3];w=x!=1.0;j=a+28|0;l=a+32|0;h=k[l>>2]|0;g=k[j>>2]|0;n=h-g>>2;if((n|0)==(f|0)){h=a+24|0;j=k[h>>2]|0;if(!j){o=h;t=9}else{q=a+4|0;h=k[q>>2]|0;if((j|0)!=(h+-1|0)){h=s+4|0;j=ZT(24)|0;k[j>>2]=1;l=j+4|0;k[s>>2]=l;k[h>>2]=19;i[j+23>>0]=0;n=349966;o=l+19|0;do{i[l>>0]=i[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));Y8(-215,s,369779,348846,776);k[h>>2]=0;k[s>>2]=0;v=k[j>>2]|0;k[j>>2]=v+-1;if((v|0)==1)ggb(k[j+-4>>2]|0);h=k[q>>2]|0}b=b+(h+-1<<2)|0;v=g}}else{if(n>>>0>=f>>>0){if(n>>>0>f>>>0?(o=g+(f<<2)|0,(h|0)!=(o|0)):0)k[l>>2]=h+(~((h+-4-o|0)>>>2)<<2)}else{U1(j,f-n|0);g=k[j>>2]|0}o=a+24|0;k[o>>2]=0;t=9}do if((t|0)==9){zpb(g|0,0,f<<2|0)|0;j=k[o>>2]|0;n=a+4|0;h=k[n>>2]|0;l=h+-1|0;if((j|0)<(l|0)){if((f|0)<=0){k[o>>2]=l;b=b+(h+-1-j<<2)|0;v=g;break}do{j=k[b>>2]|0;h=0;do{v=g+(h<<2)|0;k[v>>2]=(k[v>>2]|0)+(k[j+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(f|0));v=(k[o>>2]|0)+1|0;k[o>>2]=v;b=b+4|0;h=k[n>>2]|0}while((v|0)<(h+-1|0));v=g}else v=g}while(0);j=e+-1|0;if(!e){r=y;return}t=a+4|0;s=(f|0)>0;if(w)g=h;else{if(s){l=b;g=h}else{r=y;return}while(1){h=k[l>>2]|0;b=k[l+(1-g<<2)>>2]|0;g=0;do{w=v+(g<<2)|0;e=(k[h+(g<<2)>>2]|0)+(k[w>>2]|0)|0;k[c+(g<<2)>>2]=e;k[w>>2]=e-(k[b+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(f|0));if(!j)break;c=c+d|0;l=l+4|0;g=k[t>>2]|0;j=j+-1|0}r=y;return}while(1){q=k[b>>2]|0;l=k[b+(1-g<<2)>>2]|0;if(s){h=0;do{n=v+(h<<2)|0;o=(k[q+(h<<2)>>2]|0)+(k[n>>2]|0)|0;m=x*+(o|0);p[u>>3]=m;g=k[u+4>>2]|0;w=g&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){g=(g|0)<0;m=g?m+-4503599627370496.0+4503599627370496.0:m+4503599627370496.0+-4503599627370496.0;if(m==0.0)m=g?-0.0:0.0}k[c+(h<<2)>>2]=~~m;k[n>>2]=o-(k[l+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(f|0))}if(!j)break;c=c+d|0;b=b+4|0;j=j+-1|0;g=k[t>>2]|0}r=y;return}function pta(a){a=a|0;k[a+24>>2]=0;return}function qta(a){a=a|0;ggb(a);return}function rta(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function sta(a){a=a|0;var b=0,c=0;k[a>>2]=88716;c=k[a+28>>2]|0;if(!c)return;a=a+32|0;b=k[a>>2]|0;if((b|0)!=(c|0))k[a>>2]=b+(~((b+-8-c|0)>>>3)<<3);ggb(c);return}function tta(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=88716;b=k[a+28>>2]|0;if(!b){ggb(a);return}c=a+32|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function uta(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0,m=0,n=0,o=0,q=0.0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0;C=r;r=r+16|0;s=C;A=+p[a+16>>3];B=A!=1.0;l=a+28|0;m=a+32|0;h=k[m>>2]|0;g=k[l>>2]|0;n=h-g>>3;if((n|0)==(f|0)){h=a+24|0;l=k[h>>2]|0;if(!l){y=h;t=9}else{a=a+4|0;h=k[a>>2]|0;if((l|0)!=(h+-1|0)){h=s+4|0;l=ZT(24)|0;k[l>>2]=1;m=l+4|0;k[s>>2]=m;k[h>>2]=19;i[l+23>>0]=0;n=349966;o=m+19|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,s,369779,348846,153);k[h>>2]=0;k[s>>2]=0;y=k[l>>2]|0;k[l>>2]=y+-1;if((y|0)==1)ggb(k[l+-4>>2]|0);h=k[a>>2]|0}l=b+(h+-1<<2)|0}}else{if(n>>>0>=f>>>0){if(n>>>0>f>>>0?(o=g+(f<<3)|0,(h|0)!=(o|0)):0)k[m>>2]=h+(~((h+-8-o|0)>>>3)<<3)}else{Bla(l,f-n|0);g=k[l>>2]|0}y=a+24|0;k[y>>2]=0;t=9}if((t|0)==9){zpb(g|0,0,f<<3|0)|0;x=k[y>>2]|0;h=k[a+4>>2]|0;w=h+-1|0;if((x|0)<(w|0)){n=f+-2|0;if((f|0)<2){m=(f|0)==1;l=b;n=x;while(1){if(m)p[g>>3]=+p[k[l>>2]>>3]+ +p[g>>3];n=n+1|0;if((n|0)==(w|0))break;else l=l+4|0}}else{o=f&-2;a=(o|0)<(f|0);m=b;t=x;while(1){s=k[m>>2]|0;l=0;do{E=g+(l<<3)|0;F=l|1;D=g+(F<<3)|0;z=+p[D>>3]+ +p[s+(F<<3)>>3];p[E>>3]=+p[E>>3]+ +p[s+(l<<3)>>3];p[D>>3]=z;l=l+2|0}while((l|0)<=(n|0));if(a){l=o;do{F=g+(l<<3)|0;p[F>>3]=+p[s+(l<<3)>>3]+ +p[F>>3];l=l+1|0}while((l|0)!=(f|0))}t=t+1|0;if((t|0)==(w|0))break;else m=m+4|0}}k[y>>2]=w;l=b+(h+-1-x<<2)|0}else l=b}if(!e){r=C;return}w=1-h|0;x=f+-2|0;y=(f|0)<2;b=f&-2;t=l;while(1){e=e+-1|0;a=k[t>>2]|0;s=k[t+(w<<2)>>2]|0;if(B){if(y)h=0;else{l=0;do{o=g+(l<<3)|0;v=+p[o>>3]+ +p[a+(l<<3)>>3];m=l|1;n=g+(m<<3)|0;z=+p[n>>3]+ +p[a+(m<<3)>>3];q=A*v;p[u>>3]=q;h=k[u+4>>2]|0;F=h&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){h=(h|0)<0;q=h?q+-4503599627370496.0+4503599627370496.0:q+4503599627370496.0+-4503599627370496.0;if(q==0.0)q=h?-0.0:0.0}h=~~q;j[c+(l<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;q=A*z;p[u>>3]=q;h=k[u+4>>2]|0;F=h&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){h=(h|0)<0;q=h?q+-4503599627370496.0+4503599627370496.0:q+4503599627370496.0+-4503599627370496.0;if(q==0.0)q=h?-0.0:0.0}F=~~q;j[c+(m<<1)>>1]=(F+32768|0)>>>0<65536?F:(F|0)>0?32767:32768;z=z-+p[s+(m<<3)>>3];p[o>>3]=v-+p[s+(l<<3)>>3];p[n>>3]=z;l=l+2|0}while((l|0)<=(x|0));h=b}if((h|0)<(f|0))do{m=g+(h<<3)|0;v=+p[m>>3]+ +p[a+(h<<3)>>3];q=A*v;p[u>>3]=q;l=k[u+4>>2]|0;F=l&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){l=(l|0)<0;q=l?q+-4503599627370496.0+4503599627370496.0:q+4503599627370496.0+-4503599627370496.0;if(q==0.0)q=l?-0.0:0.0}F=~~q;j[c+(h<<1)>>1]=(F+32768|0)>>>0<65536?F:(F|0)>0?32767:32768;p[m>>3]=v-+p[s+(h<<3)>>3];h=h+1|0}while((h|0)!=(f|0))}else{if(y)h=0;else{l=0;do{m=g+(l<<3)|0;v=+p[m>>3]+ +p[a+(l<<3)>>3];n=l|1;o=g+(n<<3)|0;z=+p[o>>3]+ +p[a+(n<<3)>>3];p[u>>3]=v;h=k[u+4>>2]|0;F=h&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){h=(h|0)<0;q=h?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(q==0.0)q=h?-0.0:0.0}else q=v;h=~~q;j[c+(l<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;p[u>>3]=z;h=k[u+4>>2]|0;F=h&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){h=(h|0)<0;q=h?z+-4503599627370496.0+4503599627370496.0:z+4503599627370496.0+-4503599627370496.0;if(q==0.0)q=h?-0.0:0.0}else q=z;F=~~q;j[c+(n<<1)>>1]=(F+32768|0)>>>0<65536?F:(F|0)>0?32767:32768;z=z-+p[s+(n<<3)>>3];p[m>>3]=v-+p[s+(l<<3)>>3];p[o>>3]=z;l=l+2|0}while((l|0)<=(x|0));h=b}if((h|0)<(f|0))do{m=g+(h<<3)|0;v=+p[m>>3]+ +p[a+(h<<3)>>3];p[u>>3]=v;l=k[u+4>>2]|0;F=l&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){l=(l|0)<0;q=l?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(q==0.0)q=l?-0.0:0.0}else q=v;F=~~q;j[c+(h<<1)>>1]=(F+32768|0)>>>0<65536?F:(F|0)>0?32767:32768;p[m>>3]=v-+p[s+(h<<3)>>3];h=h+1|0}while((h|0)!=(f|0))}if(!e)break;else{c=c+d|0;t=t+4|0}}r=C;return}function vta(a){a=a|0;k[a+24>>2]=0;return}function wta(a){a=a|0;ggb(a);return}function xta(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function yta(a){a=a|0;var b=0,c=0;k[a>>2]=88672;c=k[a+28>>2]|0;if(!c)return;a=a+32|0;b=k[a>>2]|0;if((b|0)!=(c|0))k[a>>2]=b+(~((b+-4-c|0)>>>2)<<2);ggb(c);return}function zta(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=88672;b=k[a+28>>2]|0;if(!b){ggb(a);return}c=a+32|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);ggb(b);ggb(a);return}function Ata(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0,m=0,n=0,o=0.0,q=0,s=0,t=0,v=0,w=0,x=0.0,y=0;y=r;r=r+16|0;t=y;x=+p[a+16>>3];w=x!=1.0;l=a+28|0;m=a+32|0;h=k[m>>2]|0;g=k[l>>2]|0;n=h-g>>2;if((n|0)==(f|0)){h=a+24|0;l=k[h>>2]|0;if(!l){q=h;v=9}else{s=a+4|0;h=k[s>>2]|0;if((l|0)!=(h+-1|0)){h=t+4|0;l=ZT(24)|0;k[l>>2]=1;m=l+4|0;k[t>>2]=m;k[h>>2]=19;i[l+23>>0]=0;n=349966;q=m+19|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(q|0));Y8(-215,t,369779,348846,442);k[h>>2]=0;k[t>>2]=0;t=k[l>>2]|0;k[l>>2]=t+-1;if((t|0)==1)ggb(k[l+-4>>2]|0);h=k[s>>2]|0}b=b+(h+-1<<2)|0}}else{if(n>>>0>=f>>>0){if(n>>>0>f>>>0?(q=g+(f<<2)|0,(h|0)!=(q|0)):0)k[m>>2]=h+(~((h+-4-q|0)>>>2)<<2)}else{U1(l,f-n|0);g=k[l>>2]|0}q=a+24|0;k[q>>2]=0;v=9}do if((v|0)==9){zpb(g|0,0,f<<2|0)|0;l=k[q>>2]|0;n=a+4|0;h=k[n>>2]|0;m=h+-1|0;if((l|0)<(m|0)){if((f|0)<=0){k[q>>2]=m;b=b+(h+-1-l<<2)|0;break}do{l=k[b>>2]|0;h=0;do{v=g+(h<<2)|0;k[v>>2]=(k[v>>2]|0)+(k[l+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(f|0));v=(k[q>>2]|0)+1|0;k[q>>2]=v;b=b+4|0;h=k[n>>2]|0}while((v|0)<(h+-1|0))}}while(0);m=e+-1|0;if(!e){r=y;return}v=a+4|0;a=(f|0)>0;if(!w){n=b;while(1){l=k[n>>2]|0;b=k[n+(1-h<<2)>>2]|0;if(a){h=0;do{w=g+(h<<2)|0;e=(k[l+(h<<2)>>2]|0)+(k[w>>2]|0)|0;j[c+(h<<1)>>1]=(e+32768|0)>>>0<65536?e:(e|0)>0?32767:32768;k[w>>2]=e-(k[b+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(f|0))}if(!m)break;c=c+d|0;n=n+4|0;h=k[v>>2]|0;m=m+-1|0}r=y;return}while(1){t=k[b>>2]|0;n=k[b+(1-h<<2)>>2]|0;if(a){l=0;do{q=g+(l<<2)|0;s=(k[t+(l<<2)>>2]|0)+(k[q>>2]|0)|0;o=x*+(s|0);p[u>>3]=o;h=k[u+4>>2]|0;w=h&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){h=(h|0)<0;o=h?o+-4503599627370496.0+4503599627370496.0:o+4503599627370496.0+-4503599627370496.0;if(o==0.0)o=h?-0.0:0.0}w=~~o;j[c+(l<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;k[q>>2]=s-(k[n+(l<<2)>>2]|0);l=l+1|0}while((l|0)!=(f|0))}if(!m)break;c=c+d|0;b=b+4|0;m=m+-1|0;h=k[v>>2]|0}r=y;return}function Bta(a){a=a|0;k[a+24>>2]=0;return}function Cta(a){a=a|0;ggb(a);return}function Dta(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Eta(a){a=a|0;var b=0,c=0;k[a>>2]=88628;c=k[a+28>>2]|0;if(!c)return;a=a+32|0;b=k[a>>2]|0;if((b|0)!=(c|0))k[a>>2]=b+(~((b+-8-c|0)>>>3)<<3);ggb(c);return}function Fta(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=88628;b=k[a+28>>2]|0;if(!b){ggb(a);return}c=a+32|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Gta(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0,m=0,n=0,o=0,q=0.0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0;C=r;r=r+16|0;s=C;A=+p[a+16>>3];B=A!=1.0;l=a+28|0;m=a+32|0;h=k[m>>2]|0;g=k[l>>2]|0;n=h-g>>3;if((n|0)==(f|0)){h=a+24|0;l=k[h>>2]|0;if(!l){y=h;t=9}else{a=a+4|0;h=k[a>>2]|0;if((l|0)!=(h+-1|0)){h=s+4|0;l=ZT(24)|0;k[l>>2]=1;m=l+4|0;k[s>>2]=m;k[h>>2]=19;i[l+23>>0]=0;n=349966;o=m+19|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Y8(-215,s,369779,348846,153);k[h>>2]=0;k[s>>2]=0;y=k[l>>2]|0;k[l>>2]=y+-1;if((y|0)==1)ggb(k[l+-4>>2]|0);h=k[a>>2]|0}l=b+(h+-1<<2)|0}}else{if(n>>>0>=f>>>0){if(n>>>0>f>>>0?(o=g+(f<<3)|0,(h|0)!=(o|0)):0)k[m>>2]=h+(~((h+-8-o|0)>>>3)<<3)}else{Bla(l,f-n|0);g=k[l>>2]|0}y=a+24|0;k[y>>2]=0;t=9}if((t|0)==9){zpb(g|0,0,f<<3|0)|0;x=k[y>>2]|0;h=k[a+4>>2]|0;w=h+-1|0;if((x|0)<(w|0)){n=f+-2|0;if((f|0)<2){m=(f|0)==1;l=b;n=x;while(1){if(m)p[g>>3]=+p[k[l>>2]>>3]+ +p[g>>3];n=n+1|0;if((n|0)==(w|0))break;else l=l+4|0}}else{o=f&-2;a=(o|0)<(f|0);m=b;t=x;while(1){s=k[m>>2]|0;l=0;do{E=g+(l<<3)|0;F=l|1;D=g+(F<<3)|0;z=+p[D>>3]+ +p[s+(F<<3)>>3];p[E>>3]=+p[E>>3]+ +p[s+(l<<3)>>3];p[D>>3]=z;l=l+2|0}while((l|0)<=(n|0));if(a){l=o;do{F=g+(l<<3)|0;p[F>>3]=+p[s+(l<<3)>>3]+ +p[F>>3];l=l+1|0}while((l|0)!=(f|0))}t=t+1|0;if((t|0)==(w|0))break;else m=m+4|0}}k[y>>2]=w;l=b+(h+-1-x<<2)|0}else l=b}if(!e){r=C;return}w=1-h|0;x=f+-2|0;y=(f|0)<2;b=f&-2;t=l;while(1){e=e+-1|0;a=k[t>>2]|0;s=k[t+(w<<2)>>2]|0;if(B){if(y)h=0;else{l=0;do{o=g+(l<<3)|0;v=+p[o>>3]+ +p[a+(l<<3)>>3];m=l|1;n=g+(m<<3)|0;z=+p[n>>3]+ +p[a+(m<<3)>>3];q=A*v;p[u>>3]=q;h=k[u+4>>2]|0;F=h&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){h=(h|0)<0;q=h?q+-4503599627370496.0+4503599627370496.0:q+4503599627370496.0+-4503599627370496.0;if(q==0.0)q=h?-0.0:0.0}h=~~q;j[c+(l<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;q=A*z;p[u>>3]=q;h=k[u+4>>2]|0;F=h&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){h=(h|0)<0;q=h?q+-4503599627370496.0+4503599627370496.0:q+4503599627370496.0+-4503599627370496.0;if(q==0.0)q=h?-0.0:0.0}F=~~q;j[c+(m<<1)>>1]=F>>>0<65536?F:(F|0)>0?65535:0;z=z-+p[s+(m<<3)>>3];p[o>>3]=v-+p[s+(l<<3)>>3];p[n>>3]=z;l=l+2|0}while((l|0)<=(x|0));h=b}if((h|0)<(f|0))do{m=g+(h<<3)|0;v=+p[m>>3]+ +p[a+(h<<3)>>3];q=A*v;p[u>>3]=q;l=k[u+4>>2]|0;F=l&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){l=(l|0)<0;q=l?q+-4503599627370496.0+4503599627370496.0:q+4503599627370496.0+-4503599627370496.0;if(q==0.0)q=l?-0.0:0.0}F=~~q;j[c+(h<<1)>>1]=F>>>0<65536?F:(F|0)>0?65535:0;p[m>>3]=v-+p[s+(h<<3)>>3];h=h+1|0}while((h|0)!=(f|0))}else{if(y)h=0;else{l=0;do{m=g+(l<<3)|0;v=+p[m>>3]+ +p[a+(l<<3)>>3];n=l|1;o=g+(n<<3)|0;z=+p[o>>3]+ +p[a+(n<<3)>>3];p[u>>3]=v;h=k[u+4>>2]|0;F=h&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){h=(h|0)<0;q=h?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(q==0.0)q=h?-0.0:0.0}else q=v;h=~~q;j[c+(l<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;p[u>>3]=z;h=k[u+4>>2]|0;F=h&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){h=(h|0)<0;q=h?z+-4503599627370496.0+4503599627370496.0:z+4503599627370496.0+-4503599627370496.0;if(q==0.0)q=h?-0.0:0.0}else q=z;F=~~q;j[c+(n<<1)>>1]=F>>>0<65536?F:(F|0)>0?65535:0;z=z-+p[s+(n<<3)>>3];p[m>>3]=v-+p[s+(l<<3)>>3];p[o>>3]=z;l=l+2|0}while((l|0)<=(x|0));h=b}if((h|0)<(f|0))do{m=g+(h<<3)|0;v=+p[m>>3]+ +p[a+(h<<3)>>3];p[u>>3]=v;l=k[u+4>>2]|0;F=l&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){l=(l|0)<0;q=l?v+-4503599627370496.0+4503599627370496.0:v+4503599627370496.0+-4503599627370496.0;if(q==0.0)q=l?-0.0:0.0}else q=v;F=~~q;j[c+(h<<1)>>1]=F>>>0<65536?F:(F|0)>0?65535:0;p[m>>3]=v-+p[s+(h<<3)>>3];h=h+1|0}while((h|0)!=(f|0))}if(!e)break;else{c=c+d|0;t=t+4|0}}r=C;return}function Hta(a){a=a|0;k[a+24>>2]=0;return}function Ita(a){a=a|0;ggb(a);return}function Jta(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Kta(a){a=a|0;var b=0,c=0;k[a>>2]=88584;c=k[a+28>>2]|0;if(!c)return;a=a+32|0;b=k[a>>2]|0;if((b|0)!=(c|0))k[a>>2]=b+(~((b+-4-c|0)>>>2)<<2);ggb(c);return}function Lta(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=88584;b=k[a+28>>2]|0;if(!b){ggb(a);return}c=a+32|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);ggb(b);ggb(a);return}function Mta(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0,m=0,n=0,o=0.0,q=0,s=0,t=0,v=0,w=0,x=0.0,y=0;y=r;r=r+16|0;t=y;x=+p[a+16>>3];w=x!=1.0;l=a+28|0;m=a+32|0;h=k[m>>2]|0;g=k[l>>2]|0;n=h-g>>2;if((n|0)==(f|0)){h=a+24|0;l=k[h>>2]|0;if(!l){q=h;v=9}else{s=a+4|0;h=k[s>>2]|0;if((l|0)!=(h+-1|0)){h=t+4|0;l=ZT(24)|0;k[l>>2]=1;m=l+4|0;k[t>>2]=m;k[h>>2]=19;i[l+23>>0]=0;n=349966;q=m+19|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(q|0));Y8(-215,t,369779,348846,610);k[h>>2]=0;k[t>>2]=0;t=k[l>>2]|0;k[l>>2]=t+-1;if((t|0)==1)ggb(k[l+-4>>2]|0);h=k[s>>2]|0}b=b+(h+-1<<2)|0}}else{if(n>>>0>=f>>>0){if(n>>>0>f>>>0?(q=g+(f<<2)|0,(h|0)!=(q|0)):0)k[m>>2]=h+(~((h+-4-q|0)>>>2)<<2)}else{U1(l,f-n|0);g=k[l>>2]|0}q=a+24|0;k[q>>2]=0;v=9}do if((v|0)==9){zpb(g|0,0,f<<2|0)|0;l=k[q>>2]|0;n=a+4|0;h=k[n>>2]|0;m=h+-1|0;if((l|0)<(m|0)){if((f|0)<=0){k[q>>2]=m;b=b+(h+-1-l<<2)|0;break}do{l=k[b>>2]|0;h=0;do{v=g+(h<<2)|0;k[v>>2]=(k[v>>2]|0)+(k[l+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(f|0));v=(k[q>>2]|0)+1|0;k[q>>2]=v;b=b+4|0;h=k[n>>2]|0}while((v|0)<(h+-1|0))}}while(0);m=e+-1|0;if(!e){r=y;return}v=a+4|0;a=(f|0)>0;if(!w){n=b;while(1){l=k[n>>2]|0;b=k[n+(1-h<<2)>>2]|0;if(a){h=0;do{w=g+(h<<2)|0;e=(k[l+(h<<2)>>2]|0)+(k[w>>2]|0)|0;j[c+(h<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;k[w>>2]=e-(k[b+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(f|0))}if(!m)break;c=c+d|0;n=n+4|0;h=k[v>>2]|0;m=m+-1|0}r=y;return}while(1){t=k[b>>2]|0;n=k[b+(1-h<<2)>>2]|0;if(a){l=0;do{q=g+(l<<2)|0;s=(k[t+(l<<2)>>2]|0)+(k[q>>2]|0)|0;o=x*+(s|0);p[u>>3]=o;h=k[u+4>>2]|0;w=h&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){h=(h|0)<0;o=h?o+-4503599627370496.0+4503599627370496.0:o+4503599627370496.0+-4503599627370496.0;if(o==0.0)o=h?-0.0:0.0}w=~~o;j[c+(l<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;k[q>>2]=s-(k[n+(l<<2)>>2]|0);l=l+1|0}while((l|0)!=(f|0))}if(!m)break;c=c+d|0;b=b+4|0;m=m+-1|0;h=k[v>>2]|0}r=y;return}function Nta(a){a=a|0;k[a+24>>2]=0;return}function Ota(a){a=a|0;ggb(a);return}function Pta(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Qta(a){a=a|0;var b=0,c=0;k[a>>2]=88540;c=k[a+28>>2]|0;if(!c)return;a=a+32|0;b=k[a>>2]|0;if((b|0)!=(c|0))k[a>>2]=b+(~((b+-8-c|0)>>>3)<<3);ggb(c);return}function Rta(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=88540;b=k[a+28>>2]|0;if(!b){ggb(a);return}c=a+32|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);ggb(b);ggb(a);return}function Sta(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0.0,q=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0;C=r;r=r+16|0;t=C;A=+p[a+16>>3];B=A!=1.0;j=a+28|0;l=a+32|0;h=k[l>>2]|0;g=k[j>>2]|0;m=h-g>>3;if((m|0)==(f|0)){h=a+24|0;j=k[h>>2]|0;if(!j)v=9;else{q=a+4|0;h=k[q>>2]|0;if((j|0)!=(h+-1|0)){h=t+4|0;j=ZT(24)|0;k[j>>2]=1;l=j+4|0;k[t>>2]=l;k[h>>2]=19;i[j+23>>0]=0;m=349966;n=l+19|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Y8(-215,t,369779,348846,153);k[h>>2]=0;k[t>>2]=0;y=k[j>>2]|0;k[j>>2]=y+-1;if((y|0)==1)ggb(k[j+-4>>2]|0);h=k[q>>2]|0}j=b+(h+-1<<2)|0}}else{if(m>>>0>=f>>>0){if(m>>>0>f>>>0?(n=g+(f<<3)|0,(h|0)!=(n|0)):0)k[l>>2]=h+(~((h+-8-n|0)>>>3)<<3)}else{Bla(j,f-m|0);g=k[j>>2]|0}h=a+24|0;k[h>>2]=0;v=9}if((v|0)==9){zpb(g|0,0,f<<3|0)|0;w=k[h>>2]|0;y=k[a+4>>2]|0;x=y+-1|0;if((w|0)<(x|0)){m=f+-2|0;if((f|0)<2){l=(f|0)==1;j=b;m=w;while(1){if(l)p[g>>3]=+p[k[j>>2]>>3]+ +p[g>>3];m=m+1|0;if((m|0)==(x|0))break;else j=j+4|0}}else{n=f&-2;q=(n|0)<(f|0);l=b;v=w;while(1){t=k[l>>2]|0;j=0;do{E=g+(j<<3)|0;F=j|1;D=g+(F<<3)|0;z=+p[D>>3]+ +p[t+(F<<3)>>3];p[E>>3]=+p[E>>3]+ +p[t+(j<<3)>>3];p[D>>3]=z;j=j+2|0}while((j|0)<=(m|0));if(q){j=n;do{F=g+(j<<3)|0;p[F>>3]=+p[t+(j<<3)>>3]+ +p[F>>3];j=j+1|0}while((j|0)!=(f|0))}v=v+1|0;if((v|0)==(x|0))break;else l=l+4|0}}k[h>>2]=x;j=b+(y+-1-w<<2)|0;h=y}else{j=b;h=y}}if(!e){r=C;return}w=a+4|0;x=f+-2|0;y=(f|0)<2;b=f&-2;v=j;while(1){e=e+-1|0;t=k[v>>2]|0;q=k[v+(1-h<<2)>>2]|0;if(B){if(y)h=0;else{j=0;do{l=g+(j<<3)|0;s=+p[l>>3]+ +p[t+(j<<3)>>3];m=j|1;n=g+(m<<3)|0;z=+p[n>>3]+ +p[t+(m<<3)>>3];o=A*s;p[u>>3]=o;h=k[u+4>>2]|0;F=h&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){h=(h|0)<0;o=h?o+-4503599627370496.0+4503599627370496.0:o+4503599627370496.0+-4503599627370496.0;if(o==0.0)o=h?-0.0:0.0}h=~~o;i[c+j>>0]=h>>>0<256?h:(h|0)>0?255:0;o=A*z;p[u>>3]=o;h=k[u+4>>2]|0;F=h&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){h=(h|0)<0;o=h?o+-4503599627370496.0+4503599627370496.0:o+4503599627370496.0+-4503599627370496.0;if(o==0.0)o=h?-0.0:0.0}F=~~o;i[c+m>>0]=F>>>0<256?F:(F|0)>0?255:0;z=z-+p[q+(m<<3)>>3];p[l>>3]=s-+p[q+(j<<3)>>3];p[n>>3]=z;j=j+2|0}while((j|0)<=(x|0));h=b}if((h|0)<(f|0))do{l=g+(h<<3)|0;s=+p[l>>3]+ +p[t+(h<<3)>>3];o=A*s;p[u>>3]=o;j=k[u+4>>2]|0;F=j&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){j=(j|0)<0;o=j?o+-4503599627370496.0+4503599627370496.0:o+4503599627370496.0+-4503599627370496.0;if(o==0.0)o=j?-0.0:0.0}F=~~o;i[c+h>>0]=F>>>0<256?F:(F|0)>0?255:0;p[l>>3]=s-+p[q+(h<<3)>>3];h=h+1|0}while((h|0)!=(f|0))}else{if(y)h=0;else{j=0;do{l=g+(j<<3)|0;s=+p[l>>3]+ +p[t+(j<<3)>>3];m=j|1;n=g+(m<<3)|0;z=+p[n>>3]+ +p[t+(m<<3)>>3];p[u>>3]=s;h=k[u+4>>2]|0;F=h&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){h=(h|0)<0;o=h?s+-4503599627370496.0+4503599627370496.0:s+4503599627370496.0+-4503599627370496.0;if(o==0.0)o=h?-0.0:0.0}else o=s;h=~~o;i[c+j>>0]=h>>>0<256?h:(h|0)>0?255:0;p[u>>3]=z;h=k[u+4>>2]|0;F=h&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){h=(h|0)<0;o=h?z+-4503599627370496.0+4503599627370496.0:z+4503599627370496.0+-4503599627370496.0;if(o==0.0)o=h?-0.0:0.0}else o=z;F=~~o;i[c+m>>0]=F>>>0<256?F:(F|0)>0?255:0;z=z-+p[q+(m<<3)>>3];p[l>>3]=s-+p[q+(j<<3)>>3];p[n>>3]=z;j=j+2|0}while((j|0)<=(x|0));h=b}if((h|0)<(f|0))do{l=g+(h<<3)|0;s=+p[l>>3]+ +p[t+(h<<3)>>3];p[u>>3]=s;j=k[u+4>>2]|0;F=j&2146435072;if(!(F>>>0>1126170624|(F|0)==1126170624&0>0)){j=(j|0)<0;o=j?s+-4503599627370496.0+4503599627370496.0:s+4503599627370496.0+-4503599627370496.0;if(o==0.0)o=j?-0.0:0.0}else o=s;F=~~o;i[c+h>>0]=F>>>0<256?F:(F|0)>0?255:0;p[l>>3]=s-+p[q+(h<<3)>>3];h=h+1|0}while((h|0)!=(f|0))}if(!e)break;c=c+d|0;v=v+4|0;h=k[w>>2]|0}r=C;return}function Tta(a){a=a|0;k[a+24>>2]=0;return}function Uta(a){a=a|0;ggb(a);return}function Vta(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Wta(a){a=a|0;var b=0,c=0;k[a>>2]=88496;c=k[a+28>>2]|0;if(!c)return;a=a+32|0;b=k[a>>2]|0;if((b|0)!=(c|0))k[a>>2]=b+(~((b+-4-c|0)>>>2)<<2);ggb(c);return}function Xta(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=88496;b=k[a+28>>2]|0;if(!b){ggb(a);return}c=a+32|0;d=k[c>>2]|0;if((d|0)!=(b|0))k[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);ggb(b);ggb(a);return}function Yta(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0.0,o=0,q=0,s=0,t=0,v=0,w=0.0,x=0;x=r;r=r+16|0;s=x;w=+p[a+16>>3];v=w!=1.0;j=a+28|0;l=a+32|0;h=k[l>>2]|0;g=k[j>>2]|0;m=h-g>>2;if((m|0)==(f|0)){h=a+24|0;j=k[h>>2]|0;if(!j){o=h;t=9}else{q=a+4|0;h=k[q>>2]|0;if((j|0)!=(h+-1|0)){h=s+4|0;j=ZT(24)|0;k[j>>2]=1;l=j+4|0;k[s>>2]=l;k[h>>2]=19;i[j+23>>0]=0;m=349966;o=l+19|0;do{i[l>>0]=i[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));Y8(-215,s,369779,348846,268);k[h>>2]=0;k[s>>2]=0;s=k[j>>2]|0;k[j>>2]=s+-1;if((s|0)==1)ggb(k[j+-4>>2]|0);h=k[q>>2]|0}b=b+(h+-1<<2)|0}}else{if(m>>>0>=f>>>0){if(m>>>0>f>>>0?(o=g+(f<<2)|0,(h|0)!=(o|0)):0)k[l>>2]=h+(~((h+-4-o|0)>>>2)<<2)}else{U1(j,f-m|0);g=k[j>>2]|0}o=a+24|0;k[o>>2]=0;t=9}do if((t|0)==9){zpb(g|0,0,f<<2|0)|0;j=k[o>>2]|0;m=a+4|0;h=k[m>>2]|0;l=h+-1|0;if((j|0)<(l|0)){if((f|0)<=0){k[o>>2]=l;b=b+(h+-1-j<<2)|0;break}do{j=k[b>>2]|0;h=0;do{t=g+(h<<2)|0;k[t>>2]=(k[t>>2]|0)+(k[j+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(f|0));t=(k[o>>2]|0)+1|0;k[o>>2]=t;b=b+4|0;h=k[m>>2]|0}while((t|0)<(h+-1|0))}}while(0);l=e+-1|0;if(!e){r=x;return}t=a+4|0;a=(f|0)>0;if(!v){m=b;while(1){j=k[m>>2]|0;b=k[m+(1-h<<2)>>2]|0;if(a){h=0;do{v=g+(h<<2)|0;e=(k[j+(h<<2)>>2]|0)+(k[v>>2]|0)|0;i[c+h>>0]=e>>>0<256?e:(e|0)>0?255:0;k[v>>2]=e-(k[b+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(f|0))}if(!l)break;c=c+d|0;m=m+4|0;h=k[t>>2]|0;l=l+-1|0}r=x;return}while(1){s=k[b>>2]|0;m=k[b+(1-h<<2)>>2]|0;if(a){j=0;do{o=g+(j<<2)|0;q=(k[s+(j<<2)>>2]|0)+(k[o>>2]|0)|0;n=w*+(q|0);p[u>>3]=n;h=k[u+4>>2]|0;v=h&2146435072;if(!(v>>>0>1126170624|(v|0)==1126170624&0>0)){h=(h|0)<0;n=h?n+-4503599627370496.0+4503599627370496.0:n+4503599627370496.0+-4503599627370496.0;if(n==0.0)n=h?-0.0:0.0}v=~~n;i[c+j>>0]=v>>>0<256?v:(v|0)>0?255:0;k[o>>2]=q-(k[m+(j<<2)>>2]|0);j=j+1|0}while((j|0)!=(f|0))}if(!l)break;c=c+d|0;b=b+4|0;l=l+-1|0;h=k[t>>2]|0}r=x;return}function Zta(a){a=a|0;k[a+24>>2]=0;return}function _ta(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=r;r=r+192|0;t=C+32|0;y=C;w=C+184|0;v=C+176|0;u=C+168|0;B=C+104|0;s=C+160|0;A=C+48|0;x=C+40|0;do if((k[a>>2]&2031616|0)==65536){i=k[a+4>>2]|0;k[B>>2]=k[i>>2];o=B+4|0;a=i+4|0;k[o>>2]=k[a>>2];z=B+8|0;k[z>>2]=k[i+8>>2];k[B+12>>2]=k[i+12>>2];k[B+16>>2]=k[i+16>>2];k[B+20>>2]=k[i+20>>2];k[B+24>>2]=k[i+24>>2];k[B+28>>2]=k[i+28>>2];k[B+32>>2]=k[i+32>>2];h=k[i+36>>2]|0;k[B+36>>2]=h;p=B+40|0;k[p>>2]=z;z=B+48|0;l=B+44|0;k[l>>2]=z;k[B+52>>2]=0;k[z>>2]=0;if(h|0){z=h+12|0;k[z>>2]=(k[z>>2]|0)+1}if((k[a>>2]|0)<3){q=k[i+44>>2]|0;z=k[l>>2]|0;k[z>>2]=k[q>>2];k[z+4>>2]=k[q+4>>2];z=p;q=B;break}k[o>>2]=0;x1(B,k[a>>2]|0,0,0,0);if((k[o>>2]|0)>0){m=k[i+40>>2]|0;n=k[p>>2]|0;i=k[i+44>>2]|0;h=k[l>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[m+(a<<2)>>2];k[h+(a<<2)>>2]=k[i+(a<<2)>>2];a=a+1|0}while((a|0)<(k[o>>2]|0));z=p;q=B}else{z=p;q=B}}else{Q1(B,a,-1);z=B+40|0;q=B}while(0);p=k[q>>2]|0;n=k[z>>2]|0;o=k[n>>2]|0;k[s>>2]=k[n+4>>2];k[s+4>>2]=o;x2(b,s,((c|0)<0?p:c)&7|p&4088,0);do if((k[b>>2]&2031616|0)==65536){m=k[b+4>>2]|0;k[A>>2]=k[m>>2];p=A+4|0;a=m+4|0;k[p>>2]=k[a>>2];c=A+8|0;k[c>>2]=k[m+8>>2];k[A+12>>2]=k[m+12>>2];k[A+16>>2]=k[m+16>>2];k[A+20>>2]=k[m+20>>2];k[A+24>>2]=k[m+24>>2];k[A+28>>2]=k[m+28>>2];k[A+32>>2]=k[m+32>>2];h=k[m+36>>2]|0;k[A+36>>2]=h;i=A+40|0;k[i>>2]=c;c=A+48|0;n=A+44|0;k[n>>2]=c;k[A+52>>2]=0;k[c>>2]=0;if(h|0){c=h+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[a>>2]|0)<3){s=k[m+44>>2]|0;c=k[n>>2]|0;k[c>>2]=k[s>>2];k[c+4>>2]=k[s+4>>2];break}k[p>>2]=0;x1(A,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){o=k[m+40>>2]|0;l=k[i>>2]|0;i=k[m+44>>2]|0;h=k[n>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[o+(a<<2)>>2];k[h+(a<<2)>>2]=k[i+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(A,b,-1);while(0);if(!((g&16|0)==0|f^1)){if((k[B+8>>2]|0)==1)k[d+4>>2]=1;if((k[B+12>>2]|0)==1)k[d>>2]=1}a=k[q>>2]|0;s=a&4095;c=k[A>>2]&4095;p=k[d>>2]|0;q=k[d+4>>2]|0;h=k[e>>2]|0;o=k[e+4>>2]|0;m=a&7;a=a&4088;do if(m>>>0<5){if(f?(e=aa(q,p)|0,(e|0)>(((m|0)==0?8388608:(m|0)==2?32768:65536)|0)):0){i=6;break}i=4}else i=6;while(0);b=i|a;n=(h|0)<0?(p|0)/2|0:h;a=(m|0)==0;l=(i|0)==4;do if(a&l){while(1){a=fgb(12)|0;if(a|0){h=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){h=0;break}Qh[a&7]()}k[h>>2]=88136;k[h+4>>2]=p;k[h+8>>2]=n;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}e=a+4|0;k[e>>2]=1;k[a>>2]=88156;k[a+8>>2]=h;k[w>>2]=a;k[w+4>>2]=h;k[e>>2]=(k[e>>2]|0)+1;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)Uh[k[(k[a>>2]|0)+8>>2]&2047](a)}else{h=(i|0)==6;if(a&h){while(1){a=fgb(12)|0;if(a|0){h=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){h=0;break}Qh[a&7]()}k[h>>2]=88176;k[h+4>>2]=p;k[h+8>>2]=n;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}e=a+4|0;k[e>>2]=1;k[a>>2]=88196;k[a+8>>2]=h;k[w>>2]=a;k[w+4>>2]=h;k[e>>2]=(k[e>>2]|0)+1;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);break}a=(m|0)==2;if(a&l){while(1){a=fgb(12)|0;if(a|0){h=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){h=0;break}Qh[a&7]()}k[h>>2]=88216;k[h+4>>2]=p;k[h+8>>2]=n;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}e=a+4|0;k[e>>2]=1;k[a>>2]=88236;k[a+8>>2]=h;k[w>>2]=a;k[w+4>>2]=h;k[e>>2]=(k[e>>2]|0)+1;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);break}if(a&h){while(1){a=fgb(12)|0;if(a|0){h=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){h=0;break}Qh[a&7]()}k[h>>2]=88256;k[h+4>>2]=p;k[h+8>>2]=n;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}e=a+4|0;k[e>>2]=1;k[a>>2]=88276;k[a+8>>2]=h;k[w>>2]=a;k[w+4>>2]=h;k[e>>2]=(k[e>>2]|0)+1;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);break}a=(m|0)==3;if(a&l){while(1){a=fgb(12)|0;if(a|0){h=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){h=0;break}Qh[a&7]()}k[h>>2]=88296;k[h+4>>2]=p;k[h+8>>2]=n;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}e=a+4|0;k[e>>2]=1;k[a>>2]=88316;k[a+8>>2]=h;k[w>>2]=a;k[w+4>>2]=h;k[e>>2]=(k[e>>2]|0)+1;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);break}if((m|0)==4&l){while(1){a=fgb(12)|0;if(a|0){h=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){h=0;break}Qh[a&7]()}k[h>>2]=88336;k[h+4>>2]=p;k[h+8>>2]=n;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}e=a+4|0;k[e>>2]=1;k[a>>2]=88356;k[a+8>>2]=h;k[w>>2]=a;k[w+4>>2]=h;k[e>>2]=(k[e>>2]|0)+1;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);break}if(a&h){while(1){a=fgb(12)|0;if(a|0){h=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){h=0;break}Qh[a&7]()}k[h>>2]=88376;k[h+4>>2]=p;k[h+8>>2]=n;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}e=a+4|0;k[e>>2]=1;k[a>>2]=88396;k[a+8>>2]=h;k[w>>2]=a;k[w+4>>2]=h;k[e>>2]=(k[e>>2]|0)+1;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);break}if((m|0)==5&h){while(1){a=fgb(12)|0;if(a|0){h=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){h=0;break}Qh[a&7]()}k[h>>2]=88416;k[h+4>>2]=p;k[h+8>>2]=n;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}e=a+4|0;k[e>>2]=1;k[a>>2]=88436;k[a+8>>2]=h;k[w>>2]=a;k[w+4>>2]=h;k[e>>2]=(k[e>>2]|0)+1;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a);break}if(!((m|0)==6&h)){k[t>>2]=s;k[t+4>>2]=b;$8(y,348914,t);Y8(-213,y,348830,348846,1241);a=k[y>>2]|0;k[y+4>>2]=0;k[y>>2]=0;if(a|0?(e=a+-4|0,t=k[e>>2]|0,k[e>>2]=t+-1,(t|0)==1):0)ggb(k[a+-8>>2]|0);k[w>>2]=0;k[w+4>>2]=0;break}while(1){a=fgb(12)|0;if(a|0){h=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){h=0;break}Qh[a&7]()}k[h>>2]=88456;k[h+4>>2]=p;k[h+8>>2]=n;while(1){a=fgb(16)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}e=a+4|0;k[e>>2]=1;k[a>>2]=88476;k[a+8>>2]=h;k[w>>2]=a;k[w+4>>2]=h;k[e>>2]=(k[e>>2]|0)+1;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)Uh[k[(k[a>>2]|0)+8>>2]&2047](a)}while(0);if(f)j=1.0/+(aa(p,q)|0);else j=1.0;Nsa(v,b,c,q,o,j);k[u>>2]=0;k[u+4>>2]=0;while(1){a=fgb(200)|0;if(a|0){i=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){i=0;break}Qh[a&7]()}k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;k[y+16>>2]=0;k[y+20>>2]=0;k[y+24>>2]=0;k[y+28>>2]=0;qga(i,u,w,v,s,c,b,g,-1,y);while(1){a=fgb(16)|0;if(a|0){h=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){h=0;break}Qh[a&7]()}k[h+4>>2]=1;k[h>>2]=72040;k[h+8>>2]=i;a=k[u>>2]|0;if(a|0?(g=a+4|0,u=k[g>>2]|0,k[g>>2]=u+-1,(u|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);a=k[v>>2]|0;if(a|0?(u=a+4|0,v=k[u>>2]|0,k[u>>2]=v+-1,(v|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);a=k[w>>2]|0;if(a|0?(v=a+4|0,w=k[v>>2]|0,k[v>>2]=w+-1,(w|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);w=k[(k[i>>2]|0)+20>>2]|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=-1;k[y+12>>2]=-1;k[x>>2]=0;k[x+4>>2]=0;Lg[w&255](i,B,A,y,x,0);if(h|0?(x=h+4|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0)Uh[k[(k[h>>2]|0)+8>>2]&2047](h);i=A+36|0;a=k[i>>2]|0;if(a|0?(x=a+12|0,y=k[x>>2]|0,k[x>>2]=y+-1,(y|0)==1):0){h=k[i>>2]|0;if(h|0){a=k[h+4>>2]|0;if(!a){a=k[A+32>>2]|0;if(!a){a=B1()|0;h=k[i>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[i>>2]=0}k[i>>2]=0;y=A+16|0;h=A+4|0;k[y>>2]=0;k[y+4>>2]=0;k[y+8>>2]=0;k[y+12>>2]=0;if((k[h>>2]|0)>0){i=k[A+40>>2]|0;a=0;do{k[i+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[A+44>>2]|0;if(!((a|0)==(A+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);i=B+36|0;a=k[i>>2]|0;if(a|0?(y=a+12|0,A=k[y>>2]|0,k[y>>2]=A+-1,(A|0)==1):0){h=k[i>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[B+32>>2]|0;if(a|0)break;a=B1()|0;h=k[i>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[i>>2]=0}k[i>>2]=0;A=B+16|0;i=B+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[i>>2]|0)>0){h=k[z>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[i>>2]|0))}a=k[B+44>>2]|0;if((a|0)==(B+48|0)|(a|0)==0){r=C;return}ggb(k[a+-4>>2]|0);r=C;return}function $ta(a){a=a|0;ggb(a);return}function aua(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function bua(a){a=a|0;ggb(a);return}function cua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0,j=0.0,l=0.0;i=aa(k[a+4>>2]|0,e)|0;h=aa(d+-1|0,e)|0;if((e|0)<=0)return;a=(h|0)>0;if((i|0)<=0){if(a){g=0;a=b}else{zpb(c|0,0,e<<3|0)|0;return}while(1){p[c>>3]=0.0;d=0;f=0.0;do{j=+p[a+(d<<3)>>3];l=+p[a+(d+i<<3)>>3];f=f+(l*l-j*j);d=d+e|0;p[c+(d<<3)>>3]=f}while((d|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;a=a+8|0}}return}if(a){g=0;d=b}else{g=0;d=b;while(1){f=0.0;a=0;do{l=+p[d+(a<<3)>>3];f=f+l*l;a=a+e|0}while((a|0)<(i|0));p[c>>3]=f;g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+8|0}}return}while(1){f=0.0;a=0;do{l=+p[d+(a<<3)>>3];f=f+l*l;a=a+e|0}while((a|0)<(i|0));p[c>>3]=f;a=0;do{l=+p[d+(a<<3)>>3];j=+p[d+(a+i<<3)>>3];f=f+(j*j-l*l);a=a+e|0;p[c+(a<<3)>>3]=f}while((a|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+8|0}}return}function dua(a){a=a|0;ggb(a);return}function eua(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function fua(a){a=a|0;ggb(a);return}function gua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0,j=0,l=0.0,m=0.0;j=aa(k[a+4>>2]|0,e)|0;i=aa(d+-1|0,e)|0;if((e|0)<=0)return;h=(i|0)>0;if((j|0)>0){g=0;d=b;while(1){f=0.0;a=0;do{l=+o[d+(a<<2)>>2];f=f+l*l;a=a+e|0}while((a|0)<(j|0));p[c>>3]=f;if(h){a=0;do{l=+o[d+(a<<2)>>2];m=+o[d+(a+j<<2)>>2];f=f+(m*m-l*l);a=a+e|0;p[c+(a<<3)>>3]=f}while((a|0)<(i|0))}g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+4|0}}return}if(h){g=0;a=b}else{zpb(c|0,0,e<<3|0)|0;return}while(1){p[c>>3]=0.0;d=0;f=0.0;do{m=+o[a+(d<<2)>>2];l=+o[a+(d+j<<2)>>2];f=f+(l*l-m*m);d=d+e|0;p[c+(d<<3)>>3]=f}while((d|0)<(i|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;a=a+4|0}}return}function hua(a){a=a|0;ggb(a);return}function iua(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function jua(a){a=a|0;ggb(a);return}function kua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0,l=0,m=0.0,n=0.0;l=aa(k[a+4>>2]|0,e)|0;i=aa(d+-1|0,e)|0;if((e|0)<=0)return;h=(i|0)>0;if((l|0)>0){g=0;d=b;while(1){f=0.0;a=0;do{m=+(j[d+(a<<1)>>1]|0);f=f+m*m;a=a+e|0}while((a|0)<(l|0));p[c>>3]=f;if(h){a=0;do{m=+(j[d+(a<<1)>>1]|0);n=+(j[d+(a+l<<1)>>1]|0);f=f+(n*n-m*m);a=a+e|0;p[c+(a<<3)>>3]=f}while((a|0)<(i|0))}g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+2|0}}return}if(h){g=0;a=b}else{zpb(c|0,0,e<<3|0)|0;return}while(1){p[c>>3]=0.0;d=0;f=0.0;do{n=+(j[a+(d<<1)>>1]|0);m=+(j[a+(d+l<<1)>>1]|0);f=f+(m*m-n*n);d=d+e|0;p[c+(d<<3)>>3]=f}while((d|0)<(i|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;a=a+2|0}}return}function lua(a){a=a|0;ggb(a);return}function mua(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function nua(a){a=a|0;ggb(a);return}function oua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0,j=0,l=0.0,n=0.0;j=aa(k[a+4>>2]|0,e)|0;i=aa(d+-1|0,e)|0;if((e|0)<=0)return;h=(i|0)>0;if((j|0)>0){g=0;d=b;while(1){f=0.0;a=0;do{l=+(m[d+(a<<1)>>1]|0);f=f+l*l;a=a+e|0}while((a|0)<(j|0));p[c>>3]=f;if(h){a=0;do{l=+(m[d+(a<<1)>>1]|0);n=+(m[d+(a+j<<1)>>1]|0);f=f+(n*n-l*l);a=a+e|0;p[c+(a<<3)>>3]=f}while((a|0)<(i|0))}g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;d=d+2|0}}return}if(h){g=0;a=b}else{zpb(c|0,0,e<<3|0)|0;return}while(1){p[c>>3]=0.0;d=0;f=0.0;do{n=+(m[a+(d<<1)>>1]|0);l=+(m[a+(d+j<<1)>>1]|0);f=f+(l*l-n*n);d=d+e|0;p[c+(d<<3)>>3]=f}while((d|0)<(i|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+8|0;a=a+2|0}}return}function pua(a){a=a|0;ggb(a);return}function qua(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function rua(a){a=a|0;ggb(a);return}function sua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;i=aa(k[a+4>>2]|0,e)|0;h=aa(d+-1|0,e)|0;if((e|0)<=0)return;a=(h|0)>0;if((i|0)<=0){if(a)f=0;else{zpb(c|0,0,e<<2|0)|0;return}while(1){k[c>>2]=0;a=0;d=0;do{g=l[b+a>>0]|0;j=l[b+(a+i)>>0]|0;d=(aa(j,j)|0)-(aa(g,g)|0)+d|0;a=a+e|0;k[c+(a<<2)>>2]=d}while((a|0)<(h|0));f=f+1|0;if((f|0)==(e|0))break;else{c=c+4|0;b=b+1|0}}return}if(a)g=0;else{f=0;while(1){a=0;d=0;do{j=l[b+d>>0]|0;a=(aa(j,j)|0)+a|0;d=d+e|0}while((d|0)<(i|0));k[c>>2]=a;f=f+1|0;if((f|0)==(e|0))break;else{c=c+4|0;b=b+1|0}}return}while(1){d=0;a=0;do{j=l[b+a>>0]|0;d=(aa(j,j)|0)+d|0;a=a+e|0}while((a|0)<(i|0));k[c>>2]=d;f=0;a=d;do{j=l[b+f>>0]|0;d=l[b+(f+i)>>0]|0;a=(aa(d,d)|0)-(aa(j,j)|0)+a|0;f=f+e|0;k[c+(f<<2)>>2]=a}while((f|0)<(h|0));g=g+1|0;if((g|0)==(e|0))break;else{c=c+4|0;b=b+1|0}}return}function tua(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0.0,g=0,h=0.0,j=0.0,l=0,m=0,n=0,q=0,s=0,t=0,u=0;u=r;r=r+16|0;m=u;s=c<=0.0&((b|0)<8&((b|0)%2|0|0)==1)?89172+((b>>1)*28|0)|0:0;t=(d|0)==5;if((d+-5|0)>>>0>=2){e=m+4|0;g=ZT(40)|0;k[g>>2]=1;n=g+4|0;k[m>>2]=n;k[e>>2]=34;i[g+38>>0]=0;l=351405;q=n+34|0;do{i[n>>0]=i[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(q|0));Y8(-215,m,351440,348846,1586);k[e>>2]=0;k[m>>2]=0;q=k[g>>2]|0;k[g>>2]=q+-1;if((q|0)==1)ggb(k[g+-4>>2]|0)}k[a>>2]=1124007936;e=a+8|0;g=a+40|0;n=a+4|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[g>>2]=e;g=a+48|0;k[a+44>>2]=g;k[a+52>>2]=0;k[g>>2]=0;k[m>>2]=b;k[m+4>>2]=1;G1(a,2,m,d&4095);g=k[a+16>>2]|0;if(!(c>0.0))c=(+(b+-1|0)*.5+-1.0)*.3+.8;h=-.5/(c*c);if((b|0)<=0){r=u;return}j=+(b+-1|0)*.5;if(s)if(t){e=0;c=0.0;do{j=+o[s+(e<<2)>>2];o[g+(e<<2)>>2]=j;c=c+j;e=e+1|0}while((e|0)!=(b|0))}else{e=0;c=0.0;do{j=+o[s+(e<<2)>>2];p[g+(e<<3)>>3]=j;c=c+j;e=e+1|0}while((e|0)!=(b|0))}else{e=0;c=0.0;do{f=+(e|0)-j;f=+Z(+(f*(h*f)));if(t)o[g+(e<<2)>>2]=f;else p[g+(e<<3)>>3]=f;c=c+f;e=e+1|0}while((e|0)!=(b|0))}c=1.0/c;if(t){e=0;do{t=g+(e<<2)|0;o[t>>2]=c*+o[t>>2];e=e+1|0}while((e|0)!=(b|0));r=u;return}else{e=0;do{t=g+(e<<3)|0;p[t>>3]=c*+p[t>>3];e=e+1|0}while((e|0)!=(b|0));r=u;return}}function uua(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0.0,o=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=r;r=r+208|0;w=H+152|0;h=H+136|0;F=H+144|0;G=H+80|0;B=H+24|0;t=H;v=H+16|0;j=S1(a,-1)|0;R1(h,a,-1);k[F>>2]=k[h>>2];g=h+4|0;k[F+4>>2]=k[g>>2];x2(b,F,j,0);if(f&16|0){if((k[g>>2]|0)==1)k[c+4>>2]=1;if((k[h>>2]|0)==1)k[c>>2]=1}h=k[c>>2]|0;c=k[c+4>>2]|0;if((h|0)==1&(c|0)==1){I2(a,b);r=H;return}k[G>>2]=1124007936;E=G+4|0;g=G+8|0;C=G+40|0;l=E;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[C>>2]=g;F=G+48|0;D=G+44|0;k[D>>2]=F;k[G+52>>2]=0;k[F>>2]=0;k[B>>2]=1124007936;z=B+4|0;g=B+8|0;x=B+40|0;l=z;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k[x>>2]=g;A=B+48|0;y=B+44|0;k[y>>2]=A;k[B+52>>2]=0;k[A>>2]=0;s=j&7;n=!(e<=0.0)?e:d;if(d>0.0&(h|0)<1){e=((s|0)==0?3.0:4.0)*d*2.0+1.0;p[u>>3]=e;g=k[u+4>>2]|0;q=g&2146435072;if(!(q>>>0>1126170624|(q|0)==1126170624&0>0)){g=(g|0)<0;e=g?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=g?-0.0:0.0}q=~~e|1}else q=h;if(n>0.0&(c|0)<1){e=((s|0)==0?3.0:4.0)*n*2.0+1.0;p[u>>3]=e;g=k[u+4>>2]|0;o=g&2146435072;if(!(o>>>0>1126170624|(o|0)==1126170624&0>0)){g=(g|0)<0;e=g?e+-4503599627370496.0+4503599627370496.0:e+4503599627370496.0+-4503599627370496.0;if(e==0.0)e=g?-0.0:0.0}o=~~e|1}else o=c;if(!((q|0)>0&((q|0)%2|0|0)==1?(o|0)>0&((o|0)%2|0|0)==1:0)){k[w>>2]=0;g=w+4|0;k[g>>2]=0;h=ZT(92)|0;k[h>>2]=1;l=h+4|0;k[w>>2]=l;k[g>>2]=84;i[h+88>>0]=0;c=351458;m=l+84|0;do{i[l>>0]=i[c>>0]|0;l=l+1|0;c=c+1|0}while((l|0)<(m|0));Y8(-215,w,351543,348846,1640);k[g>>2]=0;k[w>>2]=0;m=k[h>>2]|0;k[h>>2]=m+-1;if((m|0)==1)ggb(k[h+-4>>2]|0)}d=d<0.0?0.0:d;e=n<0.0?0.0:n;j=s>>>0<5?5:s;tua(w,q,d,j);KG(G,w)|0;c=w+36|0;g=k[c>>2]|0;if(g|0?(l=g+12|0,m=k[l>>2]|0,k[l>>2]=m+-1,(m|0)==1):0){h=k[c>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[w+32>>2]|0;if(!g){g=B1()|0;h=k[c>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[c>>2]=0}k[c>>2]=0;m=w+16|0;h=w+4|0;k[m>>2]=0;k[m+4>>2]=0;k[m+8>>2]=0;k[m+12>>2]=0;if((k[h>>2]|0)>0){c=k[w+40>>2]|0;g=0;do{k[c+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[w+44>>2]|0;if(!((g|0)==(w+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0);if((o|0)==(q|0)?+P(+(d-e))<2.220446049250313e-16:0)KG(B,G)|0;else{tua(w,o,e,j);KG(B,w)|0;c=w+36|0;g=k[c>>2]|0;if(g|0?(o=g+12|0,q=k[o>>2]|0,k[o>>2]=q+-1,(q|0)==1):0){h=k[c>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[w+32>>2]|0;if(!g){g=B1()|0;h=k[c>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[c>>2]=0}k[c>>2]=0;q=w+16|0;h=w+4|0;k[q>>2]=0;k[q+4>>2]=0;k[q+8>>2]=0;k[q+12>>2]=0;if((k[h>>2]|0)>0){c=k[w+40>>2]|0;g=0;do{k[c+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[h>>2]|0))}g=k[w+44>>2]|0;if(!((g|0)==(w+48|0)|(g|0)==0))ggb(k[g+-4>>2]|0)}k[w+8>>2]=0;k[w+12>>2]=0;k[w>>2]=16842752;k[w+4>>2]=G;k[t+8>>2]=0;k[t+12>>2]=0;k[t>>2]=16842752;k[t+4>>2]=B;k[v>>2]=-1;k[v+4>>2]=-1;gla(a,b,s,w,t,v,0.0,f);c=B+36|0;g=k[c>>2]|0;if(g|0?(f=g+12|0,w=k[f>>2]|0,k[f>>2]=w+-1,(w|0)==1):0){h=k[c>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[B+32>>2]|0;if(!g){g=B1()|0;h=k[c>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[c>>2]=0}k[c>>2]=0;B=B+16|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[z>>2]|0)>0){h=k[x>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[z>>2]|0))}g=k[y>>2]|0;if(!((g|0)==(A|0)|(g|0)==0))ggb(k[g+-4>>2]|0);c=G+36|0;g=k[c>>2]|0;if(g|0?(A=g+12|0,B=k[A>>2]|0,k[A>>2]=B+-1,(B|0)==1):0){h=k[c>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[G+32>>2]|0;if(!g){g=B1()|0;h=k[c>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[c>>2]=0}k[c>>2]=0;G=G+16|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[E>>2]|0)>0){h=k[C>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[E>>2]|0))}g=k[D>>2]|0;if(!((g|0)==(F|0)|(g|0)==0))ggb(k[g+-4>>2]|0);r=H;return}function vua(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,n=0,p=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0;Ma=r;r=r+6576|0;Da=Ma+4096|0;Ca=Ma;ea=Ma+6272|0;da=Ma+6564|0;ca=Ma+6560|0;ba=Ma+6556|0;$=Ma+6552|0;Z=Ma+6548|0;Y=Ma+6544|0;X=Ma+6540|0;W=Ma+6536|0;C=Ma+6532|0;D=Ma+6528|0;E=Ma+6524|0;F=Ma+6520|0;G=Ma+6516|0;H=Ma+6512|0;I=Ma+6508|0;J=Ma+6504|0;K=Ma+6500|0;L=Ma+6496|0;M=Ma+6492|0;N=Ma+6488|0;O=Ma+6484|0;P=Ma+6480|0;Q=Ma+6476|0;R=Ma+6472|0;La=Ma+6416|0;q=Ma+6568|0;Ka=Ma+6360|0;Ia=Ma+6304|0;if(!(((c|0)%2|0|0)==1?(a2(a)|0)<3:0)){d=Da+4|0;e=ZT(48)|0;k[e>>2]=1;g=e+4|0;k[Da>>2]=g;k[d>>2]=40;i[e+44>>0]=0;f=351565;h=g+40|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,Da,351606,348846,2762);k[d>>2]=0;k[Da>>2]=0;Ja=k[e>>2]|0;k[e>>2]=Ja+-1;if((Ja|0)==1)ggb(k[e+-4>>2]|0)}if((c|0)<2){I2(a,b);r=Ma;return}do if((k[a>>2]&2031616|0)==65536){e=k[a+4>>2]|0;k[La>>2]=k[e>>2];n=La+4|0;a=e+4|0;k[n>>2]=k[a>>2];Ja=La+8|0;k[Ja>>2]=k[e+8>>2];k[La+12>>2]=k[e+12>>2];k[La+16>>2]=k[e+16>>2];k[La+20>>2]=k[e+20>>2];k[La+24>>2]=k[e+24>>2];k[La+28>>2]=k[e+28>>2];k[La+32>>2]=k[e+32>>2];d=k[e+36>>2]|0;k[La+36>>2]=d;p=La+40|0;k[p>>2]=Ja;Ja=La+48|0;f=La+44|0;k[f>>2]=Ja;k[La+52>>2]=0;k[Ja>>2]=0;if(d|0){Ja=d+12|0;k[Ja>>2]=(k[Ja>>2]|0)+1}if((k[a>>2]|0)<3){Ja=k[e+44>>2]|0;s=k[f>>2]|0;k[s>>2]=k[Ja>>2];k[s+4>>2]=k[Ja+4>>2];s=La;Ja=p;break}k[n>>2]=0;x1(La,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){g=k[e+40>>2]|0;h=k[p>>2]|0;e=k[e+44>>2]|0;d=k[f>>2]|0;a=0;do{k[h+(a<<2)>>2]=k[g+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0));s=La;Ja=p}else{s=La;Ja=p}}else{Q1(La,a,-1);s=La;Ja=La+40|0}while(0);Ga=k[Ja>>2]|0;Ha=k[Ga>>2]|0;k[q>>2]=k[Ga+4>>2];k[q+4>>2]=Ha;x2(b,q,k[s>>2]&4095,0);do if((k[b>>2]&2031616|0)==65536){f=k[b+4>>2]|0;k[Ka>>2]=k[f>>2];p=Ka+4|0;a=f+4|0;k[p>>2]=k[a>>2];Ha=Ka+8|0;k[Ha>>2]=k[f+8>>2];k[Ka+12>>2]=k[f+12>>2];k[Ka+16>>2]=k[f+16>>2];k[Ka+20>>2]=k[f+20>>2];k[Ka+24>>2]=k[f+24>>2];k[Ka+28>>2]=k[f+28>>2];k[Ka+32>>2]=k[f+32>>2];d=k[f+36>>2]|0;k[Ka+36>>2]=d;e=Ka+40|0;k[e>>2]=Ha;Ha=Ka+48|0;h=Ka+44|0;k[h>>2]=Ha;k[Ka+52>>2]=0;k[Ha>>2]=0;if(d|0){Ha=d+12|0;k[Ha>>2]=(k[Ha>>2]|0)+1}if((k[a>>2]|0)<3){Ga=k[f+44>>2]|0;Ha=k[h>>2]|0;k[Ha>>2]=k[Ga>>2];k[Ha+4>>2]=k[Ga+4>>2];break}k[p>>2]=0;x1(Ka,k[a>>2]|0,0,0,0);if((k[p>>2]|0)>0){n=k[f+40>>2]|0;g=k[e>>2]|0;e=k[f+44>>2]|0;d=k[h>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[n+(a<<2)>>2];k[d+(a<<2)>>2]=k[e+(a<<2)>>2];a=a+1|0}while((a|0)<(k[p>>2]|0))}}else Q1(Ka,b,-1);while(0);if((c|0)!=3)if((c|0)==5)d=(k[s>>2]&7|0)!=0;else d=0;else d=1;k[Ia>>2]=1124007936;Ga=Ia+4|0;a=Ia+8|0;Ea=Ia+40|0;g=Ga;h=g+36|0;do{k[g>>2]=0;g=g+4|0}while((g|0)<(h|0));k[Ea>>2]=a;Ha=Ia+48|0;Fa=Ia+44|0;k[Fa>>2]=Ha;k[Ia+52>>2]=0;k[Ha>>2]=0;a:do if(!d){k[Da+8>>2]=0;k[Da+12>>2]=0;k[Da>>2]=16842752;k[Da+4>>2]=La;W=Ca+4|0;Aa=W+4|0;k[Aa>>2]=0;k[Aa+4>>2]=0;k[Ca>>2]=33619968;k[W>>2]=Ia;W=c>>>1;k[ea>>2]=0;k[ea+4>>2]=0;k[ea+8>>2]=0;k[ea+12>>2]=0;k[ea+16>>2]=0;k[ea+20>>2]=0;k[ea+24>>2]=0;k[ea+28>>2]=0;vY(Da,Ca,0,0,W,W,1,ea);if(!(k[Ia>>2]&7))switch((k[s>>2]|0)>>>3&511){case 0:case 2:case 3:break;default:Ba=167}else Ba=167;if((Ba|0)==167){k[Da>>2]=0;a=Da+4|0;k[a>>2]=0;d=ZT(60)|0;k[d>>2]=1;g=d+4|0;k[Da>>2]=g;k[a>>2]=55;i[d+59>>0]=0;f=351617;h=g+55|0;do{i[g>>0]=i[f>>0]|0;g=g+1|0;f=f+1|0}while((g|0)<(h|0));Y8(-215,Da,351606,348846,2816);k[a>>2]=0;k[Da>>2]=0;Aa=k[d>>2]|0;k[d>>2]=Aa+-1;if((Aa|0)==1)ggb(k[d+-4>>2]|0)}e=k[La+4>>2]|0;if((e|0)<3)a=aa(k[La+12>>2]|0,k[La+8>>2]|0)|0;else{f=k[Ja>>2]|0;d=0;a=1;do{a=aa(k[f+(d<<2)>>2]|0,a)|0;d=d+1|0}while((d|0)!=(e|0))}Na=+(a>>>0)*9.5367431640625e-07;if(((Na<1.0?39:Na<4.0?21:9)|0)>=(c|0)){G=(aa(c,c)|0)>>>1;I=k[Ka+40>>2]|0;H=k[I+4>>2]|0;I=k[I>>2]|0;d=k[Ia+16>>2]|0;J=k[Ha>>2]|0;K=k[Ka+48>>2]|0;a=(k[Ia>>2]|0)>>>3;L=(a&511)+1|0;M=d+(aa(J,I)|0)|0;if((H|0)>0){N=I+-1|0;O=aa(J,N)|0;P=aa(K,N)|0;Q=0-J|0;R=0-K|0;S=L<<6;T=L<<10;U=(c|0)<-1;V=(I|0)>0;F=a&65535;y=c<<2;z=(c|0)>0;A=c*3|0;B=aa(L,c)|0;C=(B|0)>0;D=W+1|0;E=(J|0)!=0;t=k[Ka+16>>2]|0;v=0;while(1){n=(v&1|0)==0;w=n?K:R;x=n?J:Q;p=n?d:d+O|0;n=n?t:t+P|0;zpb(Da|0,0,S|0)|0;zpb(Ca|0,0,T|0)|0;b:do if(U)a=p;else{h=(x|0)>0;if(C){g=0;a=p}else{e=0;a=p;while(1){if(h){if((e|0)<(N|0))Ba=196}else if(E&(I-e|0)>1)Ba=196;if((Ba|0)==196){Ba=0;a=a+x|0}e=e+1|0;if((e|0)==(D|0))break b}}do{if((g|0)>0){f=0;do{e=0;do{Aa=l[a+(e+f)>>0]|0;za=Ca+(f<<10)+(Aa<<2)|0;k[za>>2]=(k[za>>2]|0)+1;Aa=Da+(f<<6)+(Aa>>>4<<2)|0;k[Aa>>2]=(k[Aa>>2]|0)+1;e=e+L|0}while((e|0)<(B|0));f=f+1|0}while((f|0)!=(L|0))}else{e=0;do{f=0;do{Aa=l[a+(f+e)>>0]|0;za=Ca+(e<<10)+(Aa<<2)|0;k[za>>2]=(k[za>>2]|0)+D;Aa=Da+(e<<6)+(Aa>>>4<<2)|0;k[Aa>>2]=(k[Aa>>2]|0)+D;f=f+L|0}while((f|0)<(B|0));e=e+1|0}while((e|0)!=(L|0))}if(h){if((g|0)<(N|0))Ba=186}else if(E&(I-g|0)>1)Ba=186;if((Ba|0)==186){Ba=0;a=a+x|0}g=g+1|0}while((g|0)!=(D|0))}while(0);c:do if(V){q=(x|0)>-1;s=(x|0)<1;b=0;while(1){h=0;do{e=0;g=0;while(1){f=(k[Da+(h<<6)+(g<<2)>>2]|0)+e|0;if((f|0)>(G|0))break;else{e=f;g=g+1|0}}f=e;e=g<<4;while(1){f=(k[Ca+(h<<10)+(e<<2)>>2]|0)+f|0;if((f|0)>(G|0))break;else e=e+1|0}i[n+h>>0]=e;h=h+1|0}while((h|0)!=(L|0));f=b+1|0;if((f|0)==(I|0))break c;d:do switch(F&511){case 0:{if(z)e=0;else break d;do{za=l[p+e>>0]|0;Aa=l[a+e>>0]|0;ya=Ca+(za<<2)|0;k[ya>>2]=(k[ya>>2]|0)+-1;za=Da+(za>>>4<<2)|0;k[za>>2]=(k[za>>2]|0)+-1;za=Ca+(Aa<<2)|0;k[za>>2]=(k[za>>2]|0)+1;Aa=Da+(Aa>>>4<<2)|0;k[Aa>>2]=(k[Aa>>2]|0)+1;e=e+1|0}while((e|0)!=(c|0));break}case 2:{if(z)e=0;else break d;do{za=l[p+e>>0]|0;Aa=Ca+(za<<2)|0;k[Aa>>2]=(k[Aa>>2]|0)+-1;za=Da+(za>>>4<<2)|0;k[za>>2]=(k[za>>2]|0)+-1;za=e+1|0;Aa=l[p+za>>0]|0;ya=Ca+1024+(Aa<<2)|0;k[ya>>2]=(k[ya>>2]|0)+-1;Aa=Da+64+(Aa>>>4<<2)|0;k[Aa>>2]=(k[Aa>>2]|0)+-1;Aa=e+2|0;ya=l[p+Aa>>0]|0;xa=Ca+2048+(ya<<2)|0;k[xa>>2]=(k[xa>>2]|0)+-1;ya=Da+128+(ya>>>4<<2)|0;k[ya>>2]=(k[ya>>2]|0)+-1;ya=l[a+e>>0]|0;xa=Ca+(ya<<2)|0;k[xa>>2]=(k[xa>>2]|0)+1;ya=Da+(ya>>>4<<2)|0;k[ya>>2]=(k[ya>>2]|0)+1;za=l[a+za>>0]|0;ya=Ca+1024+(za<<2)|0;k[ya>>2]=(k[ya>>2]|0)+1;za=Da+64+(za>>>4<<2)|0;k[za>>2]=(k[za>>2]|0)+1;Aa=l[a+Aa>>0]|0;za=Ca+2048+(Aa<<2)|0;k[za>>2]=(k[za>>2]|0)+1;Aa=Da+128+(Aa>>>4<<2)|0;k[Aa>>2]=(k[Aa>>2]|0)+1;e=e+3|0}while((e|0)<(A|0));break}default:{if(z)e=0;else break d;do{ya=l[p+e>>0]|0;za=Ca+(ya<<2)|0;k[za>>2]=(k[za>>2]|0)+-1;ya=Da+(ya>>>4<<2)|0;k[ya>>2]=(k[ya>>2]|0)+-1;ya=e|1;za=l[p+ya>>0]|0;Aa=Ca+1024+(za<<2)|0;k[Aa>>2]=(k[Aa>>2]|0)+-1;za=Da+64+(za>>>4<<2)|0;k[za>>2]=(k[za>>2]|0)+-1;za=e|2;Aa=l[p+za>>0]|0;xa=Ca+2048+(Aa<<2)|0;k[xa>>2]=(k[xa>>2]|0)+-1;Aa=Da+128+(Aa>>>4<<2)|0;k[Aa>>2]=(k[Aa>>2]|0)+-1;Aa=e|3;xa=l[p+Aa>>0]|0;wa=Ca+3072+(xa<<2)|0;k[wa>>2]=(k[wa>>2]|0)+-1;xa=Da+192+(xa>>>4<<2)|0;k[xa>>2]=(k[xa>>2]|0)+-1;xa=l[a+e>>0]|0;wa=Ca+(xa<<2)|0;k[wa>>2]=(k[wa>>2]|0)+1;xa=Da+(xa>>>4<<2)|0;k[xa>>2]=(k[xa>>2]|0)+1;ya=l[a+ya>>0]|0;xa=Ca+1024+(ya<<2)|0;k[xa>>2]=(k[xa>>2]|0)+1;ya=Da+64+(ya>>>4<<2)|0;k[ya>>2]=(k[ya>>2]|0)+1;za=l[a+za>>0]|0;ya=Ca+2048+(za<<2)|0;k[ya>>2]=(k[ya>>2]|0)+1;za=Da+128+(za>>>4<<2)|0;k[za>>2]=(k[za>>2]|0)+1;Aa=l[a+Aa>>0]|0;za=Ca+3072+(Aa<<2)|0;k[za>>2]=(k[za>>2]|0)+1;Aa=Da+192+(Aa>>>4<<2)|0;k[Aa>>2]=(k[Aa>>2]|0)+1;e=e+4|0}while((e|0)<(y|0))}}while(0);e=a+x|0;if((f|0)<(I|0)){n=n+w|0;p=(b|0)<(W|0)?p:p+x|0;b=f;a=(s|e>>>0>=M>>>0)&(q|e>>>0<d>>>0)?a:e}else break c}}while(0);v=v+1|0;if((v|0)==(H|0))break;else{d=d+L|0;t=t+L|0}}}break}za=((k[Ka>>2]|0)>>>3&511)+1|0;Aa=k[Ka+8>>2]|0;g=c+-1|0;ua=(g|0)/2|0;va=k[Ha>>2]|0;wa=k[Ka+48>>2]|0;xa=Ka+12|0;ya=512/(za>>>0)|0;ta=k[xa>>2]|0;ta=(ya|0)<(ta|0)?ya:ta;ya=ua<<1;f=ta+ya|0;a=aa(za<<4,f)|0;d=a+16|0;if(!d)sa=0;else{if((a|0)<-16)ad(426534,426557,304,426811);e=d<<1;d=(e|0)==0?1:e;while(1){a=fgb(d)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}zpb(a|0,0,e|0)|0;sa=a}a=aa(za<<8,f)|0|16;if((a|0)<0)ad(426534,426557,304,426811);d=a<<1;while(1){a=fgb(d)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}zpb(a|0,0,d|0)|0;d=sa+15&-16;oa=d;e=a+15&-16;pa=e;f=k[xa>>2]|0;if((f|0)>0){qa=Ia+16|0;ra=Ka+16|0;na=za<<1;fa=za<<9;ga=ua+2|0;ha=(g|0)>3;ia=Aa+-1|0;ja=(Aa|0)>0;ka=za*544|0;la=za<<5;ma=ya|1;da=(g|0)>1;ea=(aa(ya,ua)|0)+ya|0;ca=0;do{_=f-ca|0;_=((ta|0)<(_|0)?ta:_)+ya|0;$=(k[qa>>2]|0)+(aa(ca,za)|0)|0;p=k[ra>>2]|0;b=aa(ca-ua|0,za)|0;ba=_<<4;zpb(d|0,0,aa(na,ba)|0)|0;zpb(e|0,0,aa(fa,_)|0)|0;c=(_|0)>0;if(c){n=0;do{q=aa(n,_)|0;s=n<<4;f=0;do{Z=$+((aa(f,za)|0)+n)|0;Y=oa+(((l[Z>>0]|0)>>>4|f+q<<4)<<1)|0;j[Y>>1]=(m[Y>>1]|0)+ga;Z=l[Z>>0]|0;Z=pa+(((aa(Z>>>4|s,_)|0)+f<<4|Z&15)<<1)|0;j[Z>>1]=(m[Z>>1]|0)+ga;f=f+1|0}while((f|0)<(_|0));if(ha){h=1;do{g=$+(aa((ia|0)<(h|0)?ia:h,va)|0)|0;f=0;do{Z=g+((aa(f,za)|0)+n)|0;Y=oa+(((l[Z>>0]|0)>>>4|f+q<<4)<<1)|0;j[Y>>1]=(j[Y>>1]|0)+1<<16>>16;Z=l[Z>>0]|0;Z=pa+(((aa(Z>>>4|s,_)|0)+f<<4|Z&15)<<1)|0;j[Z>>1]=(j[Z>>1]|0)+1<<16>>16;f=f+1|0}while((f|0)<(_|0));h=h+1|0}while((h|0)<(ua|0))}n=n+1|0}while((n|0)!=(za|0))}S=p+b|0;if(ja){T=_-ua|0;U=(ua|0)<(T|0);V=_+-1|0;Z=0;do{W=Z-ua+-1|0;W=$+(aa((W|0)>0?W:0,va)|0)|0;X=Z+ua|0;X=$+(aa((X|0)<(ia|0)?X:ia,va)|0)|0;zpb(Da|0,0,ka|0)|0;zpb(Ca|0,0,la|0)|0;Y=aa(Z,wa)|0;R=0;do{if(c){g=aa(R,_)|0;h=R<<4;f=0;do{P=f+g<<4;Q=(aa(f,za)|0)+R|0;O=W+Q|0;N=oa+(((l[O>>0]|0)>>>4|P)<<1)|0;j[N>>1]=(j[N>>1]|0)+-1<<16>>16;O=l[O>>0]|0;O=pa+(((aa(O>>>4|h,_)|0)+f<<4|O&15)<<1)|0;j[O>>1]=(j[O>>1]|0)+-1<<16>>16;Q=X+Q|0;P=oa+(((l[Q>>0]|0)>>>4|P)<<1)|0;j[P>>1]=(j[P>>1]|0)+1<<16>>16;Q=l[Q>>0]|0;Q=pa+(((aa(Q>>>4|h,_)|0)+f<<4|Q&15)<<1)|0;j[Q>>1]=(j[Q>>1]|0)+1<<16>>16;f=f+1|0}while((f|0)<(_|0))}else h=R<<4;f=0;do{n=pa+((aa(f+h|0,ba)|0)<<1)|0;g=0;do{Q=Da+(R*544|0)+32+(f<<5)+(g<<1)|0;P=(aa(m[n+(g<<1)>>1]|0,ma)|0)+(m[Q>>1]|0)&65535;j[Q>>1]=P;g=g+1|0}while((g|0)!=16);f=f+1|0}while((f|0)!=16);if(da){n=aa(R,_)|0;g=0;do{p=oa+(g+n<<4<<1)|0;f=0;do{Q=Da+(R*544|0)+(f<<1)|0;j[Q>>1]=(m[p+(f<<1)>>1]|0)+(m[Q>>1]|0);f=f+1|0}while((f|0)!=16);g=g+1|0}while((g|0)<(ya|0))}if(U){z=aa(R,_)|0;A=R+Y|0;B=Da+(R*544|0)|0;C=Da+(R*544|0)+2|0;D=Da+(R*544|0)+4|0;E=Da+(R*544|0)+6|0;F=Da+(R*544|0)+8|0;G=Da+(R*544|0)+10|0;H=Da+(R*544|0)+12|0;I=Da+(R*544|0)+14|0;J=Da+(R*544|0)+16|0;K=Da+(R*544|0)+18|0;L=Da+(R*544|0)+20|0;M=Da+(R*544|0)+22|0;N=Da+(R*544|0)+24|0;O=Da+(R*544|0)+26|0;P=Da+(R*544|0)+28|0;Q=Da+(R*544|0)+30|0;y=ua;do{w=y+ua|0;g=oa+(((V|0)<(w|0)?V:w)+z<<4<<1)|0;f=0;do{x=Da+(R*544|0)+(f<<1)|0;j[x>>1]=(m[g+(f<<1)>>1]|0)+(m[x>>1]|0);f=f+1|0}while((f|0)!=16);f=m[B>>1]|0;do if((f|0)>(ea|0)){f=0;x=0}else{g=(m[C>>1]|0)+f|0;if((g|0)>(ea|0)){x=1;break}f=(m[D>>1]|0)+g|0;if((f|0)>(ea|0)){f=g;x=2;break}g=(m[E>>1]|0)+f|0;if((g|0)>(ea|0)){x=3;break}f=(m[F>>1]|0)+g|0;if((f|0)>(ea|0)){f=g;x=4;break}g=(m[G>>1]|0)+f|0;if((g|0)>(ea|0)){x=5;break}f=(m[H>>1]|0)+g|0;if((f|0)>(ea|0)){f=g;x=6;break}g=(m[I>>1]|0)+f|0;if((g|0)>(ea|0)){x=7;break}f=(m[J>>1]|0)+g|0;if((f|0)>(ea|0)){f=g;x=8;break}g=(m[K>>1]|0)+f|0;if((g|0)>(ea|0)){x=9;break}f=(m[L>>1]|0)+g|0;if((f|0)>(ea|0)){f=g;x=10;break}g=(m[M>>1]|0)+f|0;if((g|0)>(ea|0)){x=11;break}f=(m[N>>1]|0)+g|0;if((f|0)>(ea|0)){f=g;x=12;break}g=(m[O>>1]|0)+f|0;if((g|0)>(ea|0)){x=13;break}f=(m[P>>1]|0)+g|0;if((f|0)>(ea|0)){f=g;x=14;break}v=(m[Q>>1]|0)+f|0;x=(v|0)>(ea|0);f=x?f:v;x=x?15:16}while(0);t=Ca+(R<<5)+(x<<1)|0;n=j[t>>1]|0;g=n&65535;v=y-ua|0;do if((g|0)>(v|0)){if((g|0)>(w|0))break;b=aa(x+h|0,_)|0;do{p=g-ya|0;p=pa+(((p|0)<1?0:p+-1|0)+b<<4<<1)|0;g=0;do{s=Da+(R*544|0)+32+(x<<5)+(g<<1)|0;j[s>>1]=(m[s>>1]|0)-(m[p+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=16);p=n&65535;p=pa+(((p|0)<(_|0)?p:V)+b<<4<<1)|0;g=0;do{s=Da+(R*544|0)+32+(x<<5)+(g<<1)|0;j[s>>1]=(m[p+(g<<1)>>1]|0)+(m[s>>1]|0);g=g+1|0}while((g|0)!=16);n=n+1<<16>>16;j[t>>1]=n;g=n&65535}while((g|0)<=(w|0))}else{n=Da+(R*544|0)+32+(x<<5)|0;k[n>>2]=0;k[n+4>>2]=0;k[n+8>>2]=0;k[n+12>>2]=0;k[n+16>>2]=0;k[n+20>>2]=0;k[n+24>>2]=0;k[n+28>>2]=0;n=v&65535;j[t>>1]=n;g=v&65535;s=w+1|0;b=(w|0)<(_|0)?s:_;if((g|0)<(b|0)){q=aa(x+h|0,_)|0;do{p=pa+(g+q<<4<<1)|0;g=0;do{Oa=Da+(R*544|0)+32+(x<<5)+(g<<1)|0;j[Oa>>1]=(m[p+(g<<1)>>1]|0)+(m[Oa>>1]|0);g=g+1|0}while((g|0)!=16);n=n+1<<16>>16;j[t>>1]=n;g=n&65535}while((g|0)<(b|0))}if((g|0)>(w|0))break;n=s-_|0;p=pa+((aa(x+h|0,_)|0)+V<<4<<1)|0;g=0;do{Oa=Da+(R*544|0)+32+(x<<5)+(g<<1)|0;w=(aa(m[p+(g<<1)>>1]|0,n)|0)+(m[Oa>>1]|0)&65535;j[Oa>>1]=w;g=g+1|0}while((g|0)!=16);j[t>>1]=s}while(0);n=oa+(((v|0)<0?0:v)+z<<4<<1)|0;g=0;do{Oa=Da+(R*544|0)+(g<<1)|0;j[Oa>>1]=(m[Oa>>1]|0)-(m[n+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=16);f=(m[Da+(R*544|0)+32+(x<<5)>>1]|0)+f|0;do if((f|0)<=(ea|0)){f=(m[Da+(R*544|0)+32+(x<<5)+2>>1]|0)+f|0;if((f|0)>(ea|0)){f=1;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+4>>1]|0)+f|0;if((f|0)>(ea|0)){f=2;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+6>>1]|0)+f|0;if((f|0)>(ea|0)){f=3;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+8>>1]|0)+f|0;if((f|0)>(ea|0)){f=4;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+10>>1]|0)+f|0;if((f|0)>(ea|0)){f=5;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+12>>1]|0)+f|0;if((f|0)>(ea|0)){f=6;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+14>>1]|0)+f|0;if((f|0)>(ea|0)){f=7;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+16>>1]|0)+f|0;if((f|0)>(ea|0)){f=8;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+18>>1]|0)+f|0;if((f|0)>(ea|0)){f=9;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+20>>1]|0)+f|0;if((f|0)>(ea|0)){f=10;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+22>>1]|0)+f|0;if((f|0)>(ea|0)){f=11;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+24>>1]|0)+f|0;if((f|0)>(ea|0)){f=12;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+26>>1]|0)+f|0;if((f|0)>(ea|0)){f=13;Ba=283;break}f=(m[Da+(R*544|0)+32+(x<<5)+28>>1]|0)+f|0;if((f|0)>(ea|0)){f=14;Ba=283;break}if(((m[Da+(R*544|0)+32+(x<<5)+30>>1]|0)+f|0)>(ea|0)){f=15;Ba=283}}else{f=0;Ba=283}while(0);if((Ba|0)==283){Ba=0;Oa=S+(A+(aa(y,za)|0))|0;i[Oa>>0]=f|x<<4}y=y+1|0}while((y|0)<(T|0))}R=R+1|0}while((R|0)!=(za|0));Z=Z+1|0}while((Z|0)!=(Aa|0))}ca=ca+ta|0;f=k[xa>>2]|0}while((f|0)>(ca|0))}if(a|0)ggb(a);if(sa|0)ggb(sa)}else{a=Ka+16|0;if((k[a>>2]|0)==(k[La+16>>2]|0)){Oa=Da+4|0;Ba=Oa+4|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Da>>2]=33619968;k[Oa>>2]=Ia;mY(La,Da)}else KG(Ia,La)|0;e=k[Ia>>2]|0;switch(e&7){case 0:{d=k[Ia+16>>2]|0;h=k[a>>2]|0;E=k[Ha>>2]|0;F=k[Ka+48>>2]|0;D=k[Ka+40>>2]|0;a=k[D+4>>2]|0;D=k[D>>2]|0;f=e>>>3;C=f&511;G=C+1|0;i[Da>>0]=i[430452]|i[430355];e:do switch(c|0){case 3:{e=(D|0)==1;if((a|0)==1|e){a=D+a|0;t=a+-1|0;v=e?G:E;s=e?0:E-G|0;b=e?G:F;if((a|0)<=1)break e;q=0-v|0;p=a+-2|0;n=0;while(1){f=(n|0)>0?q:0;g=(n|0)<(p|0)?v:0;a=0;e=d;while(1){Oa=l[e>>0]|0;Ca=l[e+f>>0]|256;Da=l[352559+(Ca-Oa)>>0]|0;Oa=Da+Oa|0;Oa=Oa-(l[352559+(256-(l[e+g>>0]|0)+Oa)>>0]|0)|0;i[h+a>>0]=(l[352559+(Ca-Da-Oa)>>0]|0)+Oa;a=a+1|0;if((a|0)==(G|0))break;else e=e+1|0}n=n+1|0;if((n|0)>=(t|0))break e;else{h=h+b|0;d=d+G+s|0}}}v=aa(a,G)|0;if((D|0)>0){w=D+-1|0;q=(f|-512)^511;s=q+-1+v|0;t=v-G|0;g=0;while(1){n=g+-1|0;n=d+(aa((n|0)<0?0:n,E)|0)|0;p=d+(aa(g,E)|0)|0;g=g+1|0;b=d+(aa((w|0)<(g|0)?w:g,E)|0)|0;f=i[Da>>0]&1?G:v;a=0;f:while(1){if((a|0)<(f|0)){do{ya=a-((a|0)>(C|0)?G:0)|0;Ca=((a|0)<(t|0)?G:0)+a|0;ua=l[n+a>>0]|0;Ba=l[n+Ca>>0]|0;xa=l[p+ya>>0]|0;wa=l[p+a>>0]|0;va=l[p+Ca>>0]|0;sa=l[b+ya>>0]|0;ta=l[b+a>>0]|0;Ca=l[b+Ca>>0]|0;ra=l[352559+((ua|256)-Ba)>>0]|0;Ba=ra+Ba|0;ra=ua-ra|0;ua=l[352559+((wa|256)-va)>>0]|0;va=ua+va|0;ua=wa-ua|0;wa=l[352559+((ta|256)-Ca)>>0]|0;ta=ta-wa|0;ya=l[n+ya>>0]|256;za=l[352559+(ya-ra)>>0]|0;ra=za+ra|0;Aa=l[352559+((xa|256)-ua)>>0]|0;ua=Aa+ua|0;Aa=xa-Aa|0;xa=l[352559+((sa|256)-ta)>>0]|0;ta=xa+ta|0;xa=sa-xa|0;sa=l[352559+(256-Ba+ra)>>0]|0;Ba=sa+Ba|0;Oa=l[352559+(256-va+ua)>>0]|0;va=Oa+va|0;Oa=ua-Oa|0;wa=256-Ca-wa|0;Ca=l[352559+(ta+wa)>>0]|0;ta=Ca-ta|0;ua=l[352559+(Oa+256+ta)>>0]|0;Oa=Oa-ua|0;Oa=(l[352559+(ra+256-sa-Oa)>>0]|0)+Oa|0;Oa=Oa-(l[352559+(ta+256-ua+Oa)>>0]|0)|0;Ba=(l[352559+(Ba+256-va+(l[352559+(va+wa-Ca)>>0]|0))>>0]|0)-Ba+256|0;Ca=l[352559+(Ba+Oa)>>0]|0;Oa=Oa-Ca|0;Oa=(l[352559+(xa+256+(l[352559+(Aa+256-xa+(l[352559+(ya-za-Aa)>>0]|0))>>0]|0)-Oa)>>0]|0)+Oa|0;i[h+a>>0]=Oa-(l[352559+(Ba-Ca+Oa)>>0]|0);a=a+1|0}while((a|0)!=(f|0));a=f}if((f|0)==(v|0))break;if((a|0)>(s|0)){f=v;continue}while(1){za=n+a|0;va=l[za>>0]|0;Ca=l[za+G>>0]|0;wa=p+a|0;ya=l[wa+q>>0]|0;xa=l[wa>>0]|0;wa=l[wa+G>>0]|0;Oa=b+a|0;ta=l[Oa+q>>0]|0;ua=l[Oa>>0]|0;Oa=l[Oa+G>>0]|0;sa=l[352559+((va|256)-Ca)>>0]|0;Ca=sa+Ca|0;sa=va-sa|0;va=l[352559+((xa|256)-wa)>>0]|0;wa=va+wa|0;va=xa-va|0;xa=l[352559+((ua|256)-Oa)>>0]|0;ua=ua-xa|0;za=l[za+q>>0]|256;Aa=l[352559+(za-sa)>>0]|0;sa=Aa+sa|0;Ba=l[352559+((ya|256)-va)>>0]|0;va=Ba+va|0;Ba=ya-Ba|0;ya=l[352559+((ta|256)-ua)>>0]|0;ua=ya+ua|0;ya=ta-ya|0;ta=l[352559+(256-Ca+sa)>>0]|0;Ca=ta+Ca|0;e=l[352559+(256-wa+va)>>0]|0;wa=e+wa|0;e=va-e|0;xa=256-Oa-xa|0;Oa=l[352559+(ua+xa)>>0]|0;ua=Oa-ua|0;va=l[352559+(e+256+ua)>>0]|0;e=e-va|0;e=(l[352559+(sa+256-ta-e)>>0]|0)+e|0;e=e-(l[352559+(ua+256-va+e)>>0]|0)|0;Ca=(l[352559+(Ca+256-wa+(l[352559+(wa+xa-Oa)>>0]|0))>>0]|0)-Ca+256|0;Oa=l[352559+(Ca+e)>>0]|0;e=e-Oa|0;e=(l[352559+(ya+256+(l[352559+(Ba+256-ya+(l[352559+(za-Aa-Ba)>>0]|0))>>0]|0)-e)>>0]|0)+e|0;i[h+a>>0]=e-(l[352559+(Ca-Oa+e)>>0]|0);e=a+1|0;if((a|0)<(s|0))a=e;else{f=v;a=e;continue f}}}if((g|0)==(D|0))break;else h=h+F|0}}break}case 5:{e=(D|0)==1;if((a|0)==1|e){a=D+a|0;z=a+-1|0;A=e?G:E;y=e?0:E-G|0;t=e?G:F;if((a|0)<=1)break e;v=0-A|0;w=v<<1;x=a+-2|0;q=a+-3|0;s=A<<1;b=0;while(1){f=(b|0)>0?v:0;g=(b|0)>1?w:f;n=(b|0)<(x|0)?A:0;p=(b|0)<(q|0)?s:n;a=d;e=0;while(1){Aa=l[a+f>>0]|0;xa=l[a>>0]|0;Ca=l[a+n>>0]|0;Da=l[a+p>>0]|0;ya=l[a+g>>0]|256;Ba=l[352559+(ya-Aa)>>0]|0;za=l[352559+((Ca|256)-Da)>>0]|0;Ca=Ca-za|0;Oa=l[352559+((xa|256)-Ca)>>0]|0;Ca=Oa+Ca|0;Oa=xa-Oa|0;za=256-Da-za|0;Da=l[352559+(Ca+za)>>0]|0;Oa=(l[352559+(ya-Ba-Oa)>>0]|0)+Oa|0;Oa=Oa-(l[352559+(za-Da+Oa)>>0]|0)|0;Ba=(Aa|256)+Ba|0;i[h+e>>0]=(l[352559+(Ba-(l[352559+(Ba-Ca+Da)>>0]|0)-Oa)>>0]|0)+Oa;e=e+1|0;if((e|0)==(G|0))break;else a=a+1|0}b=b+1|0;if((b|0)>=(z|0))break e;else{h=h+t|0;d=d+G+y|0}}}x=aa(a,G)|0;if((D|0)>0){y=D+-1|0;z=G<<1;A=0-z|0;B=x+~z|0;t=(f|-512)^511;v=x-G|0;w=x-z|0;g=0;while(1){n=g+-2|0;n=d+(aa((n|0)<0?0:n,E)|0)|0;p=g+-1|0;p=d+(aa((p|0)<0?0:p,E)|0)|0;b=d+(aa(g,E)|0)|0;s=g;g=g+1|0;q=d+(aa((y|0)<(g|0)?y:g,E)|0)|0;s=s+2|0;s=d+(aa((y|0)<(s|0)?y:s,E)|0)|0;f=i[Da>>0]&1?z:x;a=0;g:while(1){if((a|0)<(f|0)){do{ba=a-((a|0)>(C|0)?G:0)|0;ea=(a|0)<(z|0)?ba:a-z|0;qa=((a|0)<(v|0)?G:0)+a|0;c=(a|0)<(w|0)?a+z|0:qa;ua=l[n+ea>>0]|0;Y=l[n+ba>>0]|0;da=l[n+a>>0]|0;$=l[n+qa>>0]|0;ja=l[n+c>>0]|0;ya=l[p+ea>>0]|0;ka=l[p+ba>>0]|0;la=l[p+a>>0]|0;Z=l[p+qa>>0]|0;ca=l[p+c>>0]|0;fa=l[b+ea>>0]|0;pa=l[b+ba>>0]|0;wa=l[b+a>>0]|0;ta=l[b+qa>>0]|0;_=l[b+c>>0]|0;Oa=l[q+ea>>0]|0;ga=l[q+ba>>0]|0;Aa=l[q+a>>0]|0;ia=l[q+qa>>0]|0;na=l[q+c>>0]|0;ea=l[s+ea>>0]|0;ba=l[s+ba>>0]|0;Ba=l[s+a>>0]|0;qa=l[s+qa>>0]|0;c=l[s+c>>0]|0;X=l[352559+((Y|256)-da)>>0]|0;da=X+da|0;X=Y-X|0;Y=l[352559+((ua|256)-X)>>0]|0;X=Y+X|0;Y=ua-Y|0;ua=l[352559+(256-da+X)>>0]|0;da=ua+da|0;ua=X-ua|0;X=l[352559+((ja|256)-ya)>>0]|0;ya=X+ya|0;X=ja-X|0;ja=l[352559+(($|256)-X)>>0]|0;X=ja+X|0;ja=$-ja|0;$=l[352559+(256-ya+X)>>0]|0;ya=$+ya|0;$=X-$|0;X=l[352559+(Y+256-ja)>>0]|0;ja=X+ja|0;ra=l[352559+(da+256-ya)>>0]|0;ya=ra+ya|0;ra=da-ra|0;da=l[352559+(256-ja+ra)>>0]|0;ja=da+ja|0;da=ra-da|0;ra=l[352559+(ua+256-$)>>0]|0;$=ra+$|0;ra=ua-ra|0;ua=l[352559+(256-da+ra)>>0]|0;da=ua+da|0;ua=ra-ua|0;ra=l[352559+(ja+256-$)>>0]|0;$=ra+$|0;ra=ja-ra|0;ja=l[352559+((la|256)-Z)>>0]|0;Z=ja+Z|0;ja=la-ja|0;la=l[352559+((ka|256)-ja)>>0]|0;ja=la+ja|0;la=ka-la|0;ka=l[352559+(256-Z+ja)>>0]|0;Z=ka+Z|0;ka=ja-ka|0;ja=l[352559+((fa|256)-pa)>>0]|0;pa=ja+pa|0;ja=fa-ja|0;fa=l[352559+((ca|256)-ja)>>0]|0;ja=fa+ja|0;fa=ca-fa|0;ca=l[352559+(256-pa+ja)>>0]|0;pa=ca+pa|0;ca=ja-ca|0;ja=l[352559+(la+256-fa)>>0]|0;fa=ja+fa|0;ja=la-ja|0;la=l[352559+(Z+256-pa)>>0]|0;pa=la+pa|0;la=Z-la|0;Z=l[352559+(256-fa+la)>>0]|0;fa=Z+fa|0;Z=la-Z|0;la=l[352559+(ka+256-ca)>>0]|0;ca=la+ca|0;la=ka-la|0;ka=l[352559+(256-Z+la)>>0]|0;Z=ka+Z|0;ka=la-ka|0;la=l[352559+(fa+256-ca)>>0]|0;ca=la+ca|0;la=fa-la|0;X=Y-X+256|0;Y=l[352559+(X-ja)>>0]|0;ja=Y+ja|0;fa=l[352559+($+256-ca)>>0]|0;ca=fa+ca|0;fa=$-fa|0;$=l[352559+(256-ja+fa)>>0]|0;ja=$+ja|0;$=fa-$|0;fa=l[352559+(da+256-Z)>>0]|0;Z=fa+Z|0;fa=da-fa|0;da=l[352559+(256-$+fa)>>0]|0;$=da+$|0;da=fa-da|0;fa=l[352559+(ja+256-Z)>>0]|0;Z=fa+Z|0;fa=ja-fa|0;ja=l[352559+(ua+256-ka)>>0]|0;ka=ja+ka|0;ja=ua-ja|0;ua=l[352559+(ya+256-pa)>>0]|0;pa=ua+pa|0;ua=ya-ua|0;ya=l[352559+(256-ka+ua)>>0]|0;ka=ya+ka|0;ya=ua-ya|0;ua=l[352559+(ra+256-la)>>0]|0;la=ua+la|0;ua=ra-ua|0;ra=l[352559+(256-ya+ua)>>0]|0;ya=ra+ya|0;ra=ua-ra|0;ua=l[352559+(ka+256-la)>>0]|0;la=ua+la|0;ua=ka-ua|0;ka=l[352559+(256-da+ja)>>0]|0;sa=l[352559+(256-$+ra)>>0]|0;za=l[352559+(256-fa+ya)>>0]|0;va=l[352559+(256-Z+ua)>>0]|0;ma=l[352559+(256-ca+la)>>0]|0;ca=ma+ca|0;Ca=l[352559+((ta|256)-_)>>0]|0;_=Ca+_|0;Ca=ta-Ca|0;ta=l[352559+((wa|256)-Ca)>>0]|0;Ca=ta+Ca|0;ta=wa-ta|0;wa=l[352559+(256-_+Ca)>>0]|0;_=wa+_|0;wa=Ca-wa|0;Ca=l[352559+((ga|256)-Aa)>>0]|0;Aa=Ca+Aa|0;Ca=ga-Ca|0;ga=l[352559+((Oa|256)-Ca)>>0]|0;Ca=ga+Ca|0;ga=Oa-ga|0;Oa=l[352559+(256-Aa+Ca)>>0]|0;Aa=Oa+Aa|0;Oa=Ca-Oa|0;Ca=l[352559+(ta+256-ga)>>0]|0;ga=Ca+ga|0;Ca=ta-Ca|0;ta=l[352559+(_+256-Aa)>>0]|0;Aa=ta+Aa|0;ta=_-ta|0;_=l[352559+(256-ga+ta)>>0]|0;ga=_+ga|0;_=ta-_|0;ta=l[352559+(wa+256-Oa)>>0]|0;Oa=ta+Oa|0;ta=wa-ta|0;wa=l[352559+(256-_+ta)>>0]|0;_=wa+_|0;wa=ta-wa|0;ta=l[352559+(ga+256-Oa)>>0]|0;Oa=ta+Oa|0;ta=ga-ta|0;ga=l[352559+((na|256)-ea)>>0]|0;ea=ga+ea|0;ga=na-ga|0;na=l[352559+((ia|256)-ga)>>0]|0;ga=na+ga|0;na=ia-na|0;ia=l[352559+(256-ea+ga)>>0]|0;ea=ia+ea|0;ia=ga-ia|0;ga=l[352559+((ba|256)-Ba)>>0]|0;Ba=ga+Ba|0;ga=ba-ga|0;ba=l[352559+((qa|256)-c)>>0]|0;c=ba+c|0;ba=qa-ba|0;qa=l[352559+(ga+256-ba)>>0]|0;ba=qa+ba|0;qa=ga-qa|0;ga=l[352559+(Ba+256-c)>>0]|0;c=ga+c|0;ga=Ba-ga|0;Ba=l[352559+(256-ba+ga)>>0]|0;ba=Ba+ba|0;Ba=ga-Ba|0;ga=l[352559+(na+256-qa)>>0]|0;qa=ga+qa|0;ga=na-ga|0;na=l[352559+(ea+256-ba)>>0]|0;ba=na+ba|0;na=ea-na|0;ea=l[352559+(256-qa+na)>>0]|0;qa=ea+qa|0;ea=na-ea|0;na=l[352559+(ia+256-Ba)>>0]|0;Ba=na+Ba|0;na=ia-na|0;ia=l[352559+(256-c+Ba)>>0]|0;c=ia+c|0;ia=Ba-ia|0;Ba=l[352559+(256-ea+na)>>0]|0;ea=Ba+ea|0;Ba=na-Ba|0;na=l[352559+(qa+256-ia)>>0]|0;ia=na+ia|0;na=qa-na|0;qa=l[352559+(ba+256-c)>>0]|0;c=qa+c|0;qa=ba-qa|0;ba=l[352559+(Ca+256-ga)>>0]|0;ga=ba+ga|0;ba=Ca-ba|0;Ca=l[352559+(Oa+256-ia)>>0]|0;ia=Ca+ia|0;Ca=Oa-Ca|0;Oa=l[352559+(256-ga+Ca)>>0]|0;ga=Oa+ga|0;Oa=Ca-Oa|0;Ca=l[352559+(_+256-ea)>>0]|0;ea=Ca+ea|0;Ca=_-Ca|0;_=l[352559+(256-c+ea)>>0]|0;c=_+c|0;_=ea-_|0;ea=l[352559+(256-Oa+Ca)>>0]|0;Oa=ea+Oa|0;ea=Ca-ea|0;Ca=l[352559+(ga+256-_)>>0]|0;_=Ca+_|0;ga=Ca-ga|0;Ca=l[352559+(ia+256-c)>>0]|0;ia=Ca-ia|0;ha=l[352559+(wa+256-Ba)>>0]|0;Ba=ha+Ba|0;ha=wa-ha|0;wa=l[352559+(Aa+256-qa)>>0]|0;qa=wa+qa|0;wa=Aa-wa|0;Aa=l[352559+(256-Ba+wa)>>0]|0;Ba=Aa+Ba|0;Aa=wa-Aa|0;wa=l[352559+(ta+256-na)>>0]|0;na=wa+na|0;wa=ta-wa|0;ta=l[352559+(256-Aa+wa)>>0]|0;Aa=ta+Aa|0;ta=wa-ta|0;wa=l[352559+(Ba+256-na)>>0]|0;na=wa+na|0;wa=Ba-wa|0;Ba=l[352559+(256-ea+ha)>>0]|0;ea=Ba+ea|0;Ba=ha-Ba|0;ha=l[352559+(256-Oa+ta)>>0]|0;Oa=ha+Oa|0;ta=ha-ta|0;ha=l[352559+(ga+256+Aa)>>0]|0;Aa=ha-Aa|0;xa=l[352559+(256-_+wa)>>0]|0;oa=l[352559+(ia+256+na)>>0]|0;c=256-(Ca+c)|0;Ca=l[352559+(c+qa)>>0]|0;ba=(l[352559+(X-Y-ba)>>0]|0)+ba|0;Z=va+Z+256|0;ba=(l[352559+(Z-(l[352559+(Z-_-xa)>>0]|0)-ba)>>0]|0)+ba|0;Oa=(l[352559+($+256+sa-Oa)>>0]|0)+Oa|0;Oa=ba-(l[352559+(ba+256-Oa+(l[352559+(c-Ca+Oa)>>0]|0))>>0]|0)|0;ia=ca-(l[352559+(ca+256+ia-oa)>>0]|0)|0;ia=ia-(l[352559+(256-ea-(l[352559+(da+256+ka-ea)>>0]|0)+ia)>>0]|0)|0;fa=za+fa+256|0;Oa=(l[352559+(256-Oa+ia+(l[352559+(fa-(l[352559+(fa+ga-ha)>>0]|0)-ia)>>0]|0))>>0]|0)+Oa|0;Ba=(l[352559+(ja+256-ka-Ba)>>0]|0)+Ba|0;ma=la-ma+256|0;Ba=(l[352559+(ma-(l[352559+(ma-na+oa)>>0]|0)-Ba)>>0]|0)+Ba|0;Ca=pa-(l[352559+(pa+256-qa+Ca)>>0]|0)|0;Ca=Ca-(l[352559+(ta+256-(l[352559+(ra+256-sa+ta)>>0]|0)+Ca)>>0]|0)|0;va=ua-va+256|0;Ca=(l[352559+(va-(l[352559+(va-wa+xa)>>0]|0)-Ca)>>0]|0)+Ca|0;i[h+a>>0]=(l[352559+(256-Oa-(l[352559+(256-Ba+(l[352559+(Aa+256-(l[352559+(ya+256-za+Aa)>>0]|0)+Ba)>>0]|0)+Ca)>>0]|0)+Ca)>>0]|0)+Oa;a=a+1|0}while((a|0)!=(f|0));a=f}if((f|0)==(x|0))break;if((a|0)>(B|0)){f=x;continue}while(1){ka=n+a|0;va=l[ka+A>>0]|0;Z=l[ka+t>>0]|0;ea=l[ka>>0]|0;ba=l[ka+G>>0]|0;ka=l[ka+z>>0]|0;da=p+a|0;za=l[da+A>>0]|0;la=l[da+t>>0]|0;ma=l[da>>0]|0;_=l[da+G>>0]|0;da=l[da+z>>0]|0;$=b+a|0;ga=l[$+A>>0]|0;qa=l[$+t>>0]|0;xa=l[$>>0]|0;ua=l[$+G>>0]|0;$=l[$+z>>0]|0;oa=q+a|0;e=l[oa+A>>0]|0;ha=l[oa+t>>0]|0;Ba=l[oa>>0]|0;ja=l[oa+G>>0]|0;oa=l[oa+z>>0]|0;ca=s+a|0;fa=l[ca+A>>0]|0;c=l[ca+t>>0]|0;Ca=l[ca>>0]|0;ra=l[ca+G>>0]|0;ca=l[ca+z>>0]|0;Y=l[352559+((Z|256)-ea)>>0]|0;ea=Y+ea|0;Y=Z-Y|0;Z=l[352559+((va|256)-Y)>>0]|0;Y=Z+Y|0;Z=va-Z|0;va=l[352559+(256-ea+Y)>>0]|0;ea=va+ea|0;va=Y-va|0;Y=l[352559+((ka|256)-za)>>0]|0;za=Y+za|0;Y=ka-Y|0;ka=l[352559+((ba|256)-Y)>>0]|0;Y=ka+Y|0;ka=ba-ka|0;ba=l[352559+(256-za+Y)>>0]|0;za=ba+za|0;ba=Y-ba|0;Y=l[352559+(Z+256-ka)>>0]|0;ka=Y+ka|0;sa=l[352559+(ea+256-za)>>0]|0;za=sa+za|0;sa=ea-sa|0;ea=l[352559+(256-ka+sa)>>0]|0;ka=ea+ka|0;ea=sa-ea|0;sa=l[352559+(va+256-ba)>>0]|0;ba=sa+ba|0;sa=va-sa|0;va=l[352559+(256-ea+sa)>>0]|0;ea=va+ea|0;va=sa-va|0;sa=l[352559+(ka+256-ba)>>0]|0;ba=sa+ba|0;sa=ka-sa|0;ka=l[352559+((ma|256)-_)>>0]|0;_=ka+_|0;ka=ma-ka|0;ma=l[352559+((la|256)-ka)>>0]|0;ka=ma+ka|0;ma=la-ma|0;la=l[352559+(256-_+ka)>>0]|0;_=la+_|0;la=ka-la|0;ka=l[352559+((ga|256)-qa)>>0]|0;qa=ka+qa|0;ka=ga-ka|0;ga=l[352559+((da|256)-ka)>>0]|0;ka=ga+ka|0;ga=da-ga|0;da=l[352559+(256-qa+ka)>>0]|0;qa=da+qa|0;da=ka-da|0;ka=l[352559+(ma+256-ga)>>0]|0;ga=ka+ga|0;ka=ma-ka|0;ma=l[352559+(_+256-qa)>>0]|0;qa=ma+qa|0;ma=_-ma|0;_=l[352559+(256-ga+ma)>>0]|0;ga=_+ga|0;_=ma-_|0;ma=l[352559+(la+256-da)>>0]|0;da=ma+da|0;ma=la-ma|0;la=l[352559+(256-_+ma)>>0]|0;_=la+_|0;la=ma-la|0;ma=l[352559+(ga+256-da)>>0]|0;da=ma+da|0;ma=ga-ma|0;Y=Z-Y+256|0;Z=l[352559+(Y-ka)>>0]|0;ka=Z+ka|0;ga=l[352559+(ba+256-da)>>0]|0;da=ga+da|0;ga=ba-ga|0;ba=l[352559+(256-ka+ga)>>0]|0;ka=ba+ka|0;ba=ga-ba|0;ga=l[352559+(ea+256-_)>>0]|0;_=ga+_|0;ga=ea-ga|0;ea=l[352559+(256-ba+ga)>>0]|0;ba=ea+ba|0;ea=ga-ea|0;ga=l[352559+(ka+256-_)>>0]|0;_=ga+_|0;ga=ka-ga|0;ka=l[352559+(va+256-la)>>0]|0;la=ka+la|0;ka=va-ka|0;va=l[352559+(za+256-qa)>>0]|0;qa=va+qa|0;va=za-va|0;za=l[352559+(256-la+va)>>0]|0;la=za+la|0;za=va-za|0;va=l[352559+(sa+256-ma)>>0]|0;ma=va+ma|0;va=sa-va|0;sa=l[352559+(256-za+va)>>0]|0;za=sa+za|0;sa=va-sa|0;va=l[352559+(la+256-ma)>>0]|0;ma=va+ma|0;va=la-va|0;la=l[352559+(256-ea+ka)>>0]|0;ta=l[352559+(256-ba+sa)>>0]|0;Aa=l[352559+(256-ga+za)>>0]|0;wa=l[352559+(256-_+va)>>0]|0;na=l[352559+(256-da+ma)>>0]|0;da=na+da|0;Oa=l[352559+((ua|256)-$)>>0]|0;$=Oa+$|0;Oa=ua-Oa|0;ua=l[352559+((xa|256)-Oa)>>0]|0;Oa=ua+Oa|0;ua=xa-ua|0;xa=l[352559+(256-$+Oa)>>0]|0;$=xa+$|0;xa=Oa-xa|0;Oa=l[352559+((ha|256)-Ba)>>0]|0;Ba=Oa+Ba|0;Oa=ha-Oa|0;ha=l[352559+((e|256)-Oa)>>0]|0;Oa=ha+Oa|0;ha=e-ha|0;e=l[352559+(256-Ba+Oa)>>0]|0;Ba=e+Ba|0;e=Oa-e|0;Oa=l[352559+(ua+256-ha)>>0]|0;ha=Oa+ha|0;Oa=ua-Oa|0;ua=l[352559+($+256-Ba)>>0]|0;Ba=ua+Ba|0;ua=$-ua|0;$=l[352559+(256-ha+ua)>>0]|0;ha=$+ha|0;$=ua-$|0;ua=l[352559+(xa+256-e)>>0]|0;e=ua+e|0;ua=xa-ua|0;xa=l[352559+(256-$+ua)>>0]|0;$=xa+$|0;xa=ua-xa|0;ua=l[352559+(ha+256-e)>>0]|0;e=ua+e|0;ua=ha-ua|0;ha=l[352559+((oa|256)-fa)>>0]|0;fa=ha+fa|0;ha=oa-ha|0;oa=l[352559+((ja|256)-ha)>>0]|0;ha=oa+ha|0;oa=ja-oa|0;ja=l[352559+(256-fa+ha)>>0]|0;fa=ja+fa|0;ja=ha-ja|0;ha=l[352559+((c|256)-Ca)>>0]|0;Ca=ha+Ca|0;ha=c-ha|0;c=l[352559+((ra|256)-ca)>>0]|0;ca=c+ca|0;c=ra-c|0;ra=l[352559+(ha+256-c)>>0]|0;c=ra+c|0;ra=ha-ra|0;ha=l[352559+(Ca+256-ca)>>0]|0;ca=ha+ca|0;ha=Ca-ha|0;Ca=l[352559+(256-c+ha)>>0]|0;c=Ca+c|0;Ca=ha-Ca|0;ha=l[352559+(oa+256-ra)>>0]|0;ra=ha+ra|0;ha=oa-ha|0;oa=l[352559+(fa+256-c)>>0]|0;c=oa+c|0;oa=fa-oa|0;fa=l[352559+(256-ra+oa)>>0]|0;ra=fa+ra|0;fa=oa-fa|0;oa=l[352559+(ja+256-Ca)>>0]|0;Ca=oa+Ca|0;oa=ja-oa|0;ja=l[352559+(256-ca+Ca)>>0]|0;ca=ja+ca|0;ja=Ca-ja|0;Ca=l[352559+(256-fa+oa)>>0]|0;fa=Ca+fa|0;Ca=oa-Ca|0;oa=l[352559+(ra+256-ja)>>0]|0;ja=oa+ja|0;oa=ra-oa|0;ra=l[352559+(c+256-ca)>>0]|0;ca=ra+ca|0;ra=c-ra|0;c=l[352559+(Oa+256-ha)>>0]|0;ha=c+ha|0;c=Oa-c|0;Oa=l[352559+(e+256-ja)>>0]|0;ja=Oa+ja|0;Oa=e-Oa|0;e=l[352559+(256-ha+Oa)>>0]|0;ha=e+ha|0;e=Oa-e|0;Oa=l[352559+($+256-fa)>>0]|0;fa=Oa+fa|0;Oa=$-Oa|0;$=l[352559+(256-ca+fa)>>0]|0;ca=$+ca|0;$=fa-$|0;fa=l[352559+(256-e+Oa)>>0]|0;e=fa+e|0;fa=Oa-fa|0;Oa=l[352559+(ha+256-$)>>0]|0;$=Oa+$|0;ha=Oa-ha|0;Oa=l[352559+(ja+256-ca)>>0]|0;ja=Oa-ja|0;ia=l[352559+(xa+256-Ca)>>0]|0;Ca=ia+Ca|0;ia=xa-ia|0;xa=l[352559+(Ba+256-ra)>>0]|0;ra=xa+ra|0;xa=Ba-xa|0;Ba=l[352559+(256-Ca+xa)>>0]|0;Ca=Ba+Ca|0;Ba=xa-Ba|0;xa=l[352559+(ua+256-oa)>>0]|0;oa=xa+oa|0;xa=ua-xa|0;ua=l[352559+(256-Ba+xa)>>0]|0;Ba=ua+Ba|0;ua=xa-ua|0;xa=l[352559+(Ca+256-oa)>>0]|0;oa=xa+oa|0;xa=Ca-xa|0;Ca=l[352559+(256-fa+ia)>>0]|0;fa=Ca+fa|0;Ca=ia-Ca|0;ia=l[352559+(256-e+ua)>>0]|0;e=ia+e|0;ua=ia-ua|0;ia=l[352559+(ha+256+Ba)>>0]|0;Ba=ia-Ba|0;ya=l[352559+(256-$+xa)>>0]|0;pa=l[352559+(ja+256+oa)>>0]|0;ca=256-(Oa+ca)|0;Oa=l[352559+(ca+ra)>>0]|0;c=(l[352559+(Y-Z-c)>>0]|0)+c|0;_=wa+_+256|0;c=(l[352559+(_-(l[352559+(_-$-ya)>>0]|0)-c)>>0]|0)+c|0;e=(l[352559+(ba+256+ta-e)>>0]|0)+e|0;e=c-(l[352559+(c+256-e+(l[352559+(ca-Oa+e)>>0]|0))>>0]|0)|0;ja=da-(l[352559+(da+256+ja-pa)>>0]|0)|0;ja=ja-(l[352559+(256-fa-(l[352559+(ea+256+la-fa)>>0]|0)+ja)>>0]|0)|0;ga=Aa+ga+256|0;e=(l[352559+(256-e+ja+(l[352559+(ga-(l[352559+(ga+ha-ia)>>0]|0)-ja)>>0]|0))>>0]|0)+e|0;Ca=(l[352559+(ka+256-la-Ca)>>0]|0)+Ca|0;na=ma-na+256|0;Ca=(l[352559+(na-(l[352559+(na-oa+pa)>>0]|0)-Ca)>>0]|0)+Ca|0;Oa=qa-(l[352559+(qa+256-ra+Oa)>>0]|0)|0;Oa=Oa-(l[352559+(ua+256-(l[352559+(sa+256-ta+ua)>>0]|0)+Oa)>>0]|0)|0;wa=va-wa+256|0;Oa=(l[352559+(wa-(l[352559+(wa-xa+ya)>>0]|0)-Oa)>>0]|0)+Oa|0;i[h+a>>0]=(l[352559+(256-e-(l[352559+(256-Ca+(l[352559+(Ba+256-(l[352559+(za+256-Aa+Ba)>>0]|0)+Ca)>>0]|0)+Oa)>>0]|0)+Oa)>>0]|0)+e;e=a+1|0;if((a|0)<(B|0))a=e;else{f=x;a=e;continue g}}}if((g|0)==(D|0))break;else h=h+F|0}}break}default:{}}while(0);break a}case 2:{d=k[Ia+16>>2]|0;h=k[a>>2]|0;E=(k[Ha>>2]|0)>>>1;F=(k[Ka+48>>2]|0)>>>1;D=k[Ka+40>>2]|0;a=k[D+4>>2]|0;D=k[D>>2]|0;f=e>>>3;C=f&511;G=C+1|0;i[Da>>0]=i[430452]|i[430355];h:do switch(c|0){case 3:{e=(D|0)==1;if((a|0)==1|e){a=D+a|0;t=a+-1|0;v=e?G:E;s=e?0:E-G|0;b=e?G:F;if((a|0)<=1)break h;q=0-v|0;p=a+-2|0;n=0;while(1){f=(n|0)>0?q:0;g=(n|0)<(p|0)?v:0;a=0;e=d;while(1){Ba=j[e+(f<<1)>>1]|0;Oa=j[e>>1]|0;Ca=m[e+(g<<1)>>1]|0;Aa=(Oa&65535)<(Ba&65535);Da=(Aa?Oa:Ba)&65535;Oa=(Aa?Ba:Oa)&65535;Oa=Ca>>>0<Oa>>>0?Ca:Oa;j[h+(a<<1)>>1]=(Oa|0)<(Da|0)?Da:Oa;a=a+1|0;if((a|0)==(G|0))break;else e=e+2|0}n=n+1|0;if((n|0)>=(t|0))break h;else{h=h+(b<<1)|0;d=d+(G<<1)+(s<<1)|0}}}v=aa(a,G)|0;if((D|0)>0){w=D+-1|0;q=(f|-512)^511;s=q+-1+v|0;t=v-G|0;g=0;while(1){n=g+-1|0;n=d+((aa((n|0)<0?0:n,E)|0)<<1)|0;p=d+((aa(g,E)|0)<<1)|0;g=g+1|0;b=d+((aa((w|0)<(g|0)?w:g,E)|0)<<1)|0;f=i[Da>>0]&1?G:v;a=0;i:while(1){if((a|0)<(f|0)){do{wa=a-((a|0)>(C|0)?G:0)|0;va=((a|0)<(t|0)?G:0)+a|0;Ba=j[n+(wa<<1)>>1]|0;ua=j[n+(a<<1)>>1]|0;Ca=j[n+(va<<1)>>1]|0;ya=j[p+(wa<<1)>>1]|0;Aa=j[p+(a<<1)>>1]|0;Oa=j[p+(va<<1)>>1]|0;wa=j[b+(wa<<1)>>1]|0;xa=j[b+(a<<1)>>1]|0;va=j[b+(va<<1)>>1]|0;ta=(Ca&65535)<(ua&65535);za=ta?Ca:ua;Ca=ta?ua:Ca;ua=(Oa&65535)<(Aa&65535);ta=ua?Oa:Aa;Oa=ua?Aa:Oa;Aa=(va&65535)<(xa&65535);ua=Aa?va:xa;va=Aa?xa:va;xa=(za&65535)<(Ba&65535);Aa=(xa?za:Ba)&65535;za=xa?Ba:za;Ba=(ta&65535)<(ya&65535);xa=(Ba?ta:ya)&65535;ta=Ba?ya:ta;ya=(ua&65535)<(wa&65535);Ba=(ya?ua:wa)&65535;ua=ya?wa:ua;wa=(Ca&65535)<(za&65535);ya=(wa?Ca:za)&65535;Ca=(wa?za:Ca)&65535;za=(Oa&65535)<(ta&65535);wa=za?Oa:ta;Oa=(za?ta:Oa)&65535;ta=(va&65535)<(ua&65535);za=ta?va:ua;va=(ta?ua:va)&65535;xa=xa>>>0<Aa>>>0?Aa:xa;Oa=va>>>0<Oa>>>0?va:Oa;va=(za&65535)<(wa&65535);Aa=(va?za:wa)&65535;za=(va?wa:za)&65535;Ba=(Ba|0)<(xa|0)?xa:Ba;Aa=Aa>>>0<ya>>>0?ya:Aa;Ca=(Oa|0)<(Ca|0)?Oa:Ca;Aa=(za|0)<(Aa|0)?za:Aa;za=(Ca|0)<(Aa|0);Oa=za?Ca:Aa;Ca=za?Aa:Ca;Oa=(Oa|0)<(Ba|0)?Ba:Oa;j[h+(a<<1)>>1]=(Ca|0)<(Oa|0)?Ca:Oa;a=a+1|0}while((a|0)!=(f|0));a=f}if((f|0)==(v|0))break;if((a|0)>(s|0)){f=v;continue}while(1){Oa=n+(a<<1)|0;Ca=j[Oa+(q<<1)>>1]|0;va=j[Oa>>1]|0;Oa=j[Oa+(G<<1)>>1]|0;e=p+(a<<1)|0;za=j[e+(q<<1)>>1]|0;Ba=j[e>>1]|0;e=j[e+(G<<1)>>1]|0;wa=b+(a<<1)|0;xa=j[wa+(q<<1)>>1]|0;ya=j[wa>>1]|0;wa=j[wa+(G<<1)>>1]|0;ua=(Oa&65535)<(va&65535);Aa=ua?Oa:va;Oa=ua?va:Oa;va=(e&65535)<(Ba&65535);ua=va?e:Ba;e=va?Ba:e;Ba=(wa&65535)<(ya&65535);va=Ba?wa:ya;wa=Ba?ya:wa;ya=(Aa&65535)<(Ca&65535);Ba=(ya?Aa:Ca)&65535;Aa=ya?Ca:Aa;Ca=(ua&65535)<(za&65535);ya=(Ca?ua:za)&65535;ua=Ca?za:ua;za=(va&65535)<(xa&65535);Ca=(za?va:xa)&65535;va=za?xa:va;xa=(Oa&65535)<(Aa&65535);za=(xa?Oa:Aa)&65535;Oa=(xa?Aa:Oa)&65535;Aa=(e&65535)<(ua&65535);xa=Aa?e:ua;e=(Aa?ua:e)&65535;ua=(wa&65535)<(va&65535);Aa=ua?wa:va;wa=(ua?va:wa)&65535;ya=ya>>>0<Ba>>>0?Ba:ya;e=wa>>>0<e>>>0?wa:e;wa=(Aa&65535)<(xa&65535);Ba=(wa?Aa:xa)&65535;Aa=(wa?xa:Aa)&65535;Ca=(Ca|0)<(ya|0)?ya:Ca;Ba=Ba>>>0<za>>>0?za:Ba;Oa=(e|0)<(Oa|0)?e:Oa;Ba=(Aa|0)<(Ba|0)?Aa:Ba;Aa=(Oa|0)<(Ba|0);e=Aa?Oa:Ba;Oa=Aa?Ba:Oa;e=(e|0)<(Ca|0)?Ca:e;j[h+(a<<1)>>1]=(Oa|0)<(e|0)?Oa:e;e=a+1|0;if((a|0)<(s|0))a=e;else{f=v;a=e;continue i}}}if((g|0)==(D|0))break;else h=h+(F<<1)|0}}break}case 5:{e=(D|0)==1;if((a|0)==1|e){a=D+a|0;z=a+-1|0;A=e?G:E;y=e?0:E-G|0;t=e?G:F;if((a|0)<=1)break h;v=0-A|0;w=v<<1;x=a+-2|0;q=a+-3|0;s=A<<1;b=0;while(1){f=(b|0)>0?v:0;g=(b|0)>1?w:f;n=(b|0)<(x|0)?A:0;p=(b|0)<(q|0)?s:n;a=d;e=0;while(1){Oa=j[a+(g<<1)>>1]|0;Da=j[a+(f<<1)>>1]|0;ya=j[a>>1]|0;Ca=j[a+(n<<1)>>1]|0;Ba=j[a+(p<<1)>>1]|0;za=(Da&65535)<(Oa&65535);Aa=(za?Da:Oa)&65535;Da=(za?Oa:Da)&65535;Oa=(Ba&65535)<(Ca&65535);za=Oa?Ba:Ca;Ba=Oa?Ca:Ba;Ca=(za&65535)<(ya&65535);Oa=(Ca?za:ya)&65535;za=Ca?ya:za;ya=(Ba&65535)<(za&65535);Ca=(ya?Ba:za)&65535;Ba=(ya?za:Ba)&65535;Oa=Oa>>>0<Aa>>>0?Aa:Oa;Oa=(Ba|0)<(Oa|0)?Ba:Oa;Da=Ca>>>0<Da>>>0?Ca:Da;j[h+(e<<1)>>1]=(Oa|0)<(Da|0)?Da:Oa;e=e+1|0;if((e|0)==(G|0))break;else a=a+2|0}b=b+1|0;if((b|0)>=(z|0))break h;else{h=h+(t<<1)|0;d=d+(G<<1)+(y<<1)|0}}}x=aa(a,G)|0;if((D|0)>0){y=D+-1|0;z=G<<1;A=0-z|0;B=x+~z|0;t=(f|-512)^511;v=x-G|0;w=x-z|0;g=0;while(1){n=g+-2|0;n=d+((aa((n|0)<0?0:n,E)|0)<<1)|0;p=g+-1|0;p=d+((aa((p|0)<0?0:p,E)|0)<<1)|0;b=d+((aa(g,E)|0)<<1)|0;s=g;g=g+1|0;q=d+((aa((y|0)<(g|0)?y:g,E)|0)<<1)|0;s=s+2|0;s=d+((aa((y|0)<(s|0)?y:s,E)|0)<<1)|0;f=i[Da>>0]&1?z:x;a=0;j:while(1){if((a|0)<(f|0)){do{Oa=a-((a|0)>(C|0)?G:0)|0;ea=(a|0)<(z|0)?Oa:a-z|0;za=((a|0)<(v|0)?G:0)+a|0;ja=(a|0)<(w|0)?a+z|0:za;ta=j[n+(ea<<1)>>1]|0;la=j[n+(Oa<<1)>>1]|0;oa=j[n+(a<<1)>>1]|0;ia=j[n+(za<<1)>>1]|0;ua=j[n+(ja<<1)>>1]|0;ra=j[p+(ea<<1)>>1]|0;wa=j[p+(Oa<<1)>>1]|0;na=j[p+(a<<1)>>1]|0;fa=j[p+(za<<1)>>1]|0;Aa=j[p+(ja<<1)>>1]|0;qa=j[b+(ea<<1)>>1]|0;Ca=j[b+(Oa<<1)>>1]|0;sa=j[b+(a<<1)>>1]|0;xa=j[b+(za<<1)>>1]|0;ga=j[b+(ja<<1)>>1]|0;ka=j[q+(ea<<1)>>1]|0;ma=j[q+(Oa<<1)>>1]|0;Ba=j[q+(a<<1)>>1]|0;da=j[q+(za<<1)>>1]|0;ya=j[q+(ja<<1)>>1]|0;ea=j[s+(ea<<1)>>1]|0;Oa=j[s+(Oa<<1)>>1]|0;va=j[s+(a<<1)>>1]|0;za=j[s+(za<<1)>>1]|0;ja=j[s+(ja<<1)>>1]|0;ha=(oa&65535)<(la&65535)?oa:la;la=(oa&65535)>(la&65535)?oa:la;oa=(ha&65535)<(ta&65535);pa=oa?ha:ta;ha=oa?ta:ha;ta=(la&65535)<(ha&65535);oa=ta?la:ha;la=ta?ha:la;ha=(ra&65535)<(ua&65535);ta=ha?ra:ua;ra=ha?ua:ra;ua=(ta&65535)<(ia&65535);ha=ua?ta:ia;ta=ua?ia:ta;ia=(ra&65535)<(ta&65535);ua=ia?ra:ta;ra=ia?ta:ra;ta=(ha&65535)<(pa&65535);ia=ta?ha:pa;ha=ta?pa:ha;pa=(ra&65535)<(la&65535);ta=pa?ra:la;ra=pa?la:ra;la=(ha&65535)<(ta&65535);pa=la?ha:ta;ha=la?ta:ha;ta=(ua&65535)<(oa&65535);la=ta?ua:oa;ua=ta?oa:ua;oa=(pa&65535)<(la&65535);ta=oa?pa:la;pa=oa?la:pa;la=(ua&65535)<(ha&65535);oa=la?ua:ha;ua=la?ha:ua;ha=(fa&65535)<(na&65535);la=ha?fa:na;fa=ha?na:fa;na=(la&65535)<(wa&65535);ha=na?la:wa;la=na?wa:la;wa=(fa&65535)<(la&65535);na=wa?fa:la;fa=wa?la:fa;la=(Ca&65535)<(qa&65535);wa=la?Ca:qa;Ca=la?qa:Ca;qa=(wa&65535)<(Aa&65535);la=qa?wa:Aa;wa=qa?Aa:wa;Aa=(Ca&65535)<(wa&65535);qa=Aa?Ca:wa;Ca=Aa?wa:Ca;wa=(la&65535)<(ha&65535);Aa=wa?la:ha;la=wa?ha:la;ha=(Ca&65535)<(fa&65535);wa=ha?Ca:fa;Ca=ha?fa:Ca;fa=(la&65535)<(wa&65535);ha=fa?la:wa;la=fa?wa:la;wa=(qa&65535)<(na&65535);fa=wa?qa:na;qa=wa?na:qa;na=(ha&65535)<(fa&65535);wa=na?ha:fa;ha=na?fa:ha;fa=(qa&65535)<(la&65535);na=fa?qa:la;qa=fa?la:qa;la=(Aa&65535)<(ia&65535);fa=(la?Aa:ia)&65535;Aa=la?ia:Aa;ia=(qa&65535)<(ua&65535);la=ia?qa:ua;qa=ia?ua:qa;ua=(Aa&65535)<(la&65535);ia=ua?Aa:la;Aa=ua?la:Aa;la=(ha&65535)<(pa&65535);ua=la?ha:pa;ha=la?pa:ha;pa=(ia&65535)<(ua&65535);la=pa?ia:ua;ia=pa?ua:ia;ua=(ha&65535)<(Aa&65535);pa=ua?ha:Aa;ha=ua?Aa:ha;Aa=(wa&65535)<(ta&65535);ua=Aa?wa:ta;wa=Aa?ta:wa;ta=(Ca&65535)<(ra&65535);Aa=ta?Ca:ra;Ca=(ta?ra:Ca)&65535;ra=(wa&65535)<(Aa&65535);ta=ra?wa:Aa;wa=ra?Aa:wa;Aa=(na&65535)<(oa&65535);ra=Aa?na:oa;na=Aa?oa:na;oa=(ta&65535)<(ra&65535);Aa=oa?ta:ra;ta=oa?ra:ta;ra=(na&65535)<(wa&65535);oa=ra?na:wa;na=ra?wa:na;wa=(la&65535)<(ua&65535);ra=(wa?la:ua)&65535;la=(wa?ua:la)&65535;ua=(ia&65535)<(Aa&65535);wa=(ua?ia:Aa)&65535;ia=(ua?Aa:ia)&65535;Aa=(pa&65535)<(ta&65535);ua=(Aa?pa:ta)&65535;pa=(Aa?ta:pa)&65535;ta=(ha&65535)<(oa&65535);Aa=(ta?ha:oa)&65535;ha=(ta?oa:ha)&65535;oa=(qa&65535)<(na&65535);ta=(oa?qa:na)&65535;qa=(oa?na:qa)&65535;na=(ga&65535)<(xa&65535);oa=na?ga:xa;ga=na?xa:ga;xa=(oa&65535)<(sa&65535);na=xa?oa:sa;oa=xa?sa:oa;sa=(ga&65535)<(oa&65535);xa=sa?ga:oa;ga=sa?oa:ga;oa=(Ba&65535)<(ma&65535);sa=oa?Ba:ma;Ba=oa?ma:Ba;ma=(sa&65535)<(ka&65535);oa=ma?sa:ka;sa=ma?ka:sa;ka=(Ba&65535)<(sa&65535);ma=ka?Ba:sa;Ba=ka?sa:Ba;sa=(oa&65535)<(na&65535);ka=sa?oa:na;oa=sa?na:oa;na=(Ba&65535)<(ga&65535);sa=na?Ba:ga;Ba=na?ga:Ba;ga=(oa&65535)<(sa&65535);na=ga?oa:sa;oa=ga?sa:oa;sa=(ma&65535)<(xa&65535);ga=sa?ma:xa;ma=sa?xa:ma;xa=(na&65535)<(ga&65535);sa=xa?na:ga;na=xa?ga:na;ga=(ma&65535)<(oa&65535);xa=ga?ma:oa;ma=ga?oa:ma;oa=(ea&65535)<(ya&65535);ga=oa?ea:ya;ea=oa?ya:ea;ya=(ga&65535)<(da&65535);oa=ya?ga:da;ga=ya?da:ga;da=(ea&65535)<(ga&65535);ya=da?ea:ga;ea=da?ga:ea;ga=(va&65535)<(Oa&65535);da=ga?va:Oa;va=ga?Oa:va;Oa=(ja&65535)<(za&65535);ga=Oa?ja:za;ja=Oa?za:ja;za=(ga&65535)<(da&65535);Oa=za?ga:da;ga=za?da:ga;da=(ja&65535)<(va&65535);za=da?ja:va;ja=da?va:ja;va=(ga&65535)<(za&65535);da=va?ga:za;ga=va?za:ga;za=(Oa&65535)<(oa&65535);va=za?Oa:oa;Oa=za?oa:Oa;oa=(ga&65535)<(ea&65535);za=oa?ga:ea;ga=oa?ea:ga;ea=(Oa&65535)<(za&65535);oa=ea?Oa:za;Oa=ea?za:Oa;za=(da&65535)<(ya&65535);ea=za?da:ya;da=za?ya:da;ya=(ja&65535)<(da&65535);za=ya?ja:da;ja=ya?da:ja;da=(oa&65535)<(ea&65535);ya=da?oa:ea;oa=da?ea:oa;ea=(za&65535)<(Oa&65535);da=ea?za:Oa;za=ea?Oa:za;Oa=(ja&65535)<(ga&65535);ea=Oa?ja:ga;ja=Oa?ga:ja;ga=(va&65535)<(ka&65535);Oa=(ga?va:ka)&65535;va=ga?ka:va;ka=(za&65535)<(ma&65535);ga=ka?za:ma;za=ka?ma:za;ma=(va&65535)<(ga&65535);ka=ma?va:ga;va=ma?ga:va;ga=(oa&65535)<(na&65535);ma=ga?oa:na;oa=ga?na:oa;na=(ja&65535)<(oa&65535);ga=na?ja:oa;ja=na?oa:ja;oa=(ka&65535)<(ma&65535);na=oa?ka:ma;ka=oa?ma:ka;ma=(ga&65535)<(va&65535);oa=ma?ga:va;ga=ma?va:ga;va=(ja&65535)<(za&65535);ma=va?ja:za;ja=va?za:ja;za=(ya&65535)<(sa&65535);va=za?ya:sa;ya=za?sa:ya;sa=(ea&65535)<(Ba&65535);za=sa?ea:Ba;ea=sa?Ba:ea;Ba=(ya&65535)<(za&65535);sa=Ba?ya:za;ya=Ba?za:ya;za=(da&65535)<(xa&65535);Ba=za?da:xa;da=za?xa:da;xa=(sa&65535)<(Ba&65535);za=xa?sa:Ba;sa=xa?Ba:sa;Ba=(da&65535)<(ya&65535);xa=Ba?da:ya;da=Ba?ya:da;ya=(na&65535)<(va&65535);Ba=(ya?na:va)&65535;na=(ya?va:na)&65535;va=(ka&65535)<(za&65535);ya=(va?ka:za)&65535;ka=(va?za:ka)&65535;za=(oa&65535)<(sa&65535);va=(za?oa:sa)&65535;oa=(za?sa:oa)&65535;sa=(ga&65535)<(xa&65535);za=(sa?ga:xa)&65535;ga=(sa?xa:ga)&65535;xa=(ma&65535)<(da&65535);sa=(xa?ma:da)&65535;ma=(xa?da:ma)&65535;da=(ja&65535)<(ea&65535);xa=(da?ja:ea)&65535;ja=(da?ea:ja)&65535;Oa=Oa>>>0<fa>>>0?fa:Oa;ha=ga>>>0<ha>>>0?ga:ha;Oa=(Oa|0)<(ha|0)?ha:Oa;ka=ka>>>0<ia>>>0?ia:ka;ka=(ja|0)<(ka|0)?ja:ka;Oa=(ka|0)<(Oa|0)?ka:Oa;na=na>>>0<la>>>0?la:na;qa=ma>>>0<qa>>>0?ma:qa;qa=(na|0)<(qa|0)?na:qa;pa=oa>>>0<pa>>>0?oa:pa;qa=(qa|0)<(pa|0)?pa:qa;Oa=(Oa|0)<(qa|0)?qa:Oa;Ba=Ba>>>0<ra>>>0?ra:Ba;ta=sa>>>0<ta>>>0?sa:ta;Ba=(Ba|0)<(ta|0)?ta:Ba;va=va>>>0<ua>>>0?ua:va;Ba=(va|0)<(Ba|0)?va:Ba;ya=ya>>>0<wa>>>0?wa:ya;Ca=xa>>>0<Ca>>>0?xa:Ca;Ca=(ya|0)<(Ca|0)?ya:Ca;Aa=za>>>0<Aa>>>0?za:Aa;Ca=(Ca|0)<(Aa|0)?Aa:Ca;Ca=(Ba|0)<(Ca|0)?Ba:Ca;j[h+(a<<1)>>1]=(Oa|0)<(Ca|0)?Ca:Oa;a=a+1|0}while((a|0)!=(f|0));a=f}if((f|0)==(x|0))break;if((a|0)>(B|0)){f=x;continue}while(1){va=n+(a<<1)|0;ua=j[va+(A<<1)>>1]|0;ma=j[va+(t<<1)>>1]|0;pa=j[va>>1]|0;ja=j[va+(G<<1)>>1]|0;va=j[va+(z<<1)>>1]|0;Ba=p+(a<<1)|0;sa=j[Ba+(A<<1)>>1]|0;xa=j[Ba+(t<<1)>>1]|0;oa=j[Ba>>1]|0;ga=j[Ba+(G<<1)>>1]|0;Ba=j[Ba+(z<<1)>>1]|0;ha=b+(a<<1)|0;ra=j[ha+(A<<1)>>1]|0;Oa=j[ha+(t<<1)>>1]|0;ta=j[ha>>1]|0;ya=j[ha+(G<<1)>>1]|0;ha=j[ha+(z<<1)>>1]|0;za=q+(a<<1)|0;la=j[za+(A<<1)>>1]|0;na=j[za+(t<<1)>>1]|0;Ca=j[za>>1]|0;ea=j[za+(G<<1)>>1]|0;za=j[za+(z<<1)>>1]|0;ka=s+(a<<1)|0;fa=j[ka+(A<<1)>>1]|0;e=j[ka+(t<<1)>>1]|0;wa=j[ka>>1]|0;Aa=j[ka+(G<<1)>>1]|0;ka=j[ka+(z<<1)>>1]|0;ia=(pa&65535)<(ma&65535)?pa:ma;ma=(pa&65535)>(ma&65535)?pa:ma;pa=(ia&65535)<(ua&65535);qa=pa?ia:ua;ia=pa?ua:ia;ua=(ma&65535)<(ia&65535);pa=ua?ma:ia;ma=ua?ia:ma;ia=(sa&65535)<(va&65535);ua=ia?sa:va;sa=ia?va:sa;va=(ua&65535)<(ja&65535);ia=va?ua:ja;ua=va?ja:ua;ja=(sa&65535)<(ua&65535);va=ja?sa:ua;sa=ja?ua:sa;ua=(ia&65535)<(qa&65535);ja=ua?ia:qa;ia=ua?qa:ia;qa=(sa&65535)<(ma&65535);ua=qa?sa:ma;sa=qa?ma:sa;ma=(ia&65535)<(ua&65535);qa=ma?ia:ua;ia=ma?ua:ia;ua=(va&65535)<(pa&65535);ma=ua?va:pa;va=ua?pa:va;pa=(qa&65535)<(ma&65535);ua=pa?qa:ma;qa=pa?ma:qa;ma=(va&65535)<(ia&65535);pa=ma?va:ia;va=ma?ia:va;ia=(ga&65535)<(oa&65535);ma=ia?ga:oa;ga=ia?oa:ga;oa=(ma&65535)<(xa&65535);ia=oa?ma:xa;ma=oa?xa:ma;xa=(ga&65535)<(ma&65535);oa=xa?ga:ma;ga=xa?ma:ga;ma=(Oa&65535)<(ra&65535);xa=ma?Oa:ra;Oa=ma?ra:Oa;ra=(xa&65535)<(Ba&65535);ma=ra?xa:Ba;xa=ra?Ba:xa;Ba=(Oa&65535)<(xa&65535);ra=Ba?Oa:xa;Oa=Ba?xa:Oa;xa=(ma&65535)<(ia&65535);Ba=xa?ma:ia;ma=xa?ia:ma;ia=(Oa&65535)<(ga&65535);xa=ia?Oa:ga;Oa=ia?ga:Oa;ga=(ma&65535)<(xa&65535);ia=ga?ma:xa;ma=ga?xa:ma;xa=(ra&65535)<(oa&65535);ga=xa?ra:oa;ra=xa?oa:ra;oa=(ia&65535)<(ga&65535);xa=oa?ia:ga;ia=oa?ga:ia;ga=(ra&65535)<(ma&65535);oa=ga?ra:ma;ra=ga?ma:ra;ma=(Ba&65535)<(ja&65535);ga=(ma?Ba:ja)&65535;Ba=ma?ja:Ba;ja=(ra&65535)<(va&65535);ma=ja?ra:va;ra=ja?va:ra;va=(Ba&65535)<(ma&65535);ja=va?Ba:ma;Ba=va?ma:Ba;ma=(ia&65535)<(qa&65535);va=ma?ia:qa;ia=ma?qa:ia;qa=(ja&65535)<(va&65535);ma=qa?ja:va;ja=qa?va:ja;va=(ia&65535)<(Ba&65535);qa=va?ia:Ba;ia=va?Ba:ia;Ba=(xa&65535)<(ua&65535);va=Ba?xa:ua;xa=Ba?ua:xa;ua=(Oa&65535)<(sa&65535);Ba=ua?Oa:sa;Oa=(ua?sa:Oa)&65535;sa=(xa&65535)<(Ba&65535);ua=sa?xa:Ba;xa=sa?Ba:xa;Ba=(oa&65535)<(pa&65535);sa=Ba?oa:pa;oa=Ba?pa:oa;pa=(ua&65535)<(sa&65535);Ba=pa?ua:sa;ua=pa?sa:ua;sa=(oa&65535)<(xa&65535);pa=sa?oa:xa;oa=sa?xa:oa;xa=(ma&65535)<(va&65535);sa=(xa?ma:va)&65535;ma=(xa?va:ma)&65535;va=(ja&65535)<(Ba&65535);xa=(va?ja:Ba)&65535;ja=(va?Ba:ja)&65535;Ba=(qa&65535)<(ua&65535);va=(Ba?qa:ua)&65535;qa=(Ba?ua:qa)&65535;ua=(ia&65535)<(pa&65535);Ba=(ua?ia:pa)&65535;ia=(ua?pa:ia)&65535;pa=(ra&65535)<(oa&65535);ua=(pa?ra:oa)&65535;ra=(pa?oa:ra)&65535;oa=(ha&65535)<(ya&65535);pa=oa?ha:ya;ha=oa?ya:ha;ya=(pa&65535)<(ta&65535);oa=ya?pa:ta;pa=ya?ta:pa;ta=(ha&65535)<(pa&65535);ya=ta?ha:pa;ha=ta?pa:ha;pa=(Ca&65535)<(na&65535);ta=pa?Ca:na;Ca=pa?na:Ca;na=(ta&65535)<(la&65535);pa=na?ta:la;ta=na?la:ta;la=(Ca&65535)<(ta&65535);na=la?Ca:ta;Ca=la?ta:Ca;ta=(pa&65535)<(oa&65535);la=ta?pa:oa;pa=ta?oa:pa;oa=(Ca&65535)<(ha&65535);ta=oa?Ca:ha;Ca=oa?ha:Ca;ha=(pa&65535)<(ta&65535);oa=ha?pa:ta;pa=ha?ta:pa;ta=(na&65535)<(ya&65535);ha=ta?na:ya;na=ta?ya:na;ya=(oa&65535)<(ha&65535);ta=ya?oa:ha;oa=ya?ha:oa;ha=(na&65535)<(pa&65535);ya=ha?na:pa;na=ha?pa:na;pa=(fa&65535)<(za&65535);ha=pa?fa:za;fa=pa?za:fa;za=(ha&65535)<(ea&65535);pa=za?ha:ea;ha=za?ea:ha;ea=(fa&65535)<(ha&65535);za=ea?fa:ha;fa=ea?ha:fa;ha=(wa&65535)<(e&65535);ea=ha?wa:e;wa=ha?e:wa;e=(ka&65535)<(Aa&65535);ha=e?ka:Aa;ka=e?Aa:ka;Aa=(ha&65535)<(ea&65535);e=Aa?ha:ea;ha=Aa?ea:ha;ea=(ka&65535)<(wa&65535);Aa=ea?ka:wa;ka=ea?wa:ka;wa=(ha&65535)<(Aa&65535);ea=wa?ha:Aa;ha=wa?Aa:ha;Aa=(e&65535)<(pa&65535);wa=Aa?e:pa;e=Aa?pa:e;pa=(ha&65535)<(fa&65535);Aa=pa?ha:fa;ha=pa?fa:ha;fa=(e&65535)<(Aa&65535);pa=fa?e:Aa;e=fa?Aa:e;Aa=(ea&65535)<(za&65535);fa=Aa?ea:za;ea=Aa?za:ea;za=(ka&65535)<(ea&65535);Aa=za?ka:ea;ka=za?ea:ka;ea=(pa&65535)<(fa&65535);za=ea?pa:fa;pa=ea?fa:pa;fa=(Aa&65535)<(e&65535);ea=fa?Aa:e;Aa=fa?e:Aa;e=(ka&65535)<(ha&65535);fa=e?ka:ha;ka=e?ha:ka;ha=(wa&65535)<(la&65535);e=(ha?wa:la)&65535;wa=ha?la:wa;la=(Aa&65535)<(na&65535);ha=la?Aa:na;Aa=la?na:Aa;na=(wa&65535)<(ha&65535);la=na?wa:ha;wa=na?ha:wa;ha=(pa&65535)<(oa&65535);na=ha?pa:oa;pa=ha?oa:pa;oa=(ka&65535)<(pa&65535);ha=oa?ka:pa;ka=oa?pa:ka;pa=(la&65535)<(na&65535);oa=pa?la:na;la=pa?na:la;na=(ha&65535)<(wa&65535);pa=na?ha:wa;ha=na?wa:ha;wa=(ka&65535)<(Aa&65535);na=wa?ka:Aa;ka=wa?Aa:ka;Aa=(za&65535)<(ta&65535);wa=Aa?za:ta;za=Aa?ta:za;ta=(fa&65535)<(Ca&65535);Aa=ta?fa:Ca;fa=ta?Ca:fa;Ca=(za&65535)<(Aa&65535);ta=Ca?za:Aa;za=Ca?Aa:za;Aa=(ea&65535)<(ya&65535);Ca=Aa?ea:ya;ea=Aa?ya:ea;ya=(ta&65535)<(Ca&65535);Aa=ya?ta:Ca;ta=ya?Ca:ta;Ca=(ea&65535)<(za&65535);ya=Ca?ea:za;ea=Ca?za:ea;za=(oa&65535)<(wa&65535);Ca=(za?oa:wa)&65535;oa=(za?wa:oa)&65535;wa=(la&65535)<(Aa&65535);za=(wa?la:Aa)&65535;la=(wa?Aa:la)&65535;Aa=(pa&65535)<(ta&65535);wa=(Aa?pa:ta)&65535;pa=(Aa?ta:pa)&65535;ta=(ha&65535)<(ya&65535);Aa=(ta?ha:ya)&65535;ha=(ta?ya:ha)&65535;ya=(na&65535)<(ea&65535);ta=(ya?na:ea)&65535;na=(ya?ea:na)&65535;ea=(ka&65535)<(fa&65535);ya=(ea?ka:fa)&65535;ka=(ea?fa:ka)&65535;e=e>>>0<ga>>>0?ga:e;ia=ha>>>0<ia>>>0?ha:ia;e=(e|0)<(ia|0)?ia:e;la=la>>>0<ja>>>0?ja:la;la=(ka|0)<(la|0)?ka:la;e=(la|0)<(e|0)?la:e;oa=oa>>>0<ma>>>0?ma:oa;ra=na>>>0<ra>>>0?na:ra;ra=(oa|0)<(ra|0)?oa:ra;qa=pa>>>0<qa>>>0?pa:qa;ra=(ra|0)<(qa|0)?qa:ra;e=(e|0)<(ra|0)?ra:e;Ca=Ca>>>0<sa>>>0?sa:Ca;ua=ta>>>0<ua>>>0?ta:ua;Ca=(Ca|0)<(ua|0)?ua:Ca;wa=wa>>>0<va>>>0?va:wa;Ca=(wa|0)<(Ca|0)?wa:Ca;za=za>>>0<xa>>>0?xa:za;Oa=ya>>>0<Oa>>>0?ya:Oa;Oa=(za|0)<(Oa|0)?za:Oa;Ba=Aa>>>0<Ba>>>0?Aa:Ba;Oa=(Oa|0)<(Ba|0)?Ba:Oa;Oa=(Ca|0)<(Oa|0)?Ca:Oa;j[h+(a<<1)>>1]=(e|0)<(Oa|0)?Oa:e;e=a+1|0;if((a|0)<(B|0))a=e;else{f=x;a=e;continue j}}}if((g|0)==(D|0))break;else h=h+(F<<1)|0}}break}default:{}}while(0);break a}case 3:{d=k[Ia+16>>2]|0;h=k[a>>2]|0;E=(k[Ha>>2]|0)>>>1;F=(k[Ka+48>>2]|0)>>>1;D=k[Ka+40>>2]|0;a=k[D+4>>2]|0;D=k[D>>2]|0;f=e>>>3;C=f&511;G=C+1|0;i[Da>>0]=i[430452]|i[430355];k:do switch(c|0){case 3:{e=(D|0)==1;if((a|0)==1|e){a=D+a|0;t=a+-1|0;v=e?G:E;s=e?0:E-G|0;b=e?G:F;if((a|0)<=1)break k;q=0-v|0;p=a+-2|0;n=0;while(1){f=(n|0)>0?q:0;g=(n|0)<(p|0)?v:0;a=0;e=d;while(1){Ba=j[e+(f<<1)>>1]|0;Oa=j[e>>1]|0;Ca=j[e+(g<<1)>>1]|0;Aa=Oa<<16>>16<Ba<<16>>16;Da=(Aa?Oa:Ba)<<16>>16;Oa=(Aa?Ba:Oa)<<16>>16;Oa=(Ca|0)<(Oa|0)?Ca:Oa;j[h+(a<<1)>>1]=(Oa|0)<(Da|0)?Da:Oa;a=a+1|0;if((a|0)==(G|0))break;else e=e+2|0}n=n+1|0;if((n|0)>=(t|0))break k;else{h=h+(b<<1)|0;d=d+(G<<1)+(s<<1)|0}}}v=aa(a,G)|0;if((D|0)>0){w=D+-1|0;q=(f|-512)^511;s=q+-1+v|0;t=v-G|0;g=0;while(1){n=g+-1|0;n=d+((aa((n|0)<0?0:n,E)|0)<<1)|0;p=d+((aa(g,E)|0)<<1)|0;g=g+1|0;b=d+((aa((w|0)<(g|0)?w:g,E)|0)<<1)|0;f=i[Da>>0]&1?G:v;a=0;l:while(1){if((a|0)<(f|0)){do{wa=a-((a|0)>(C|0)?G:0)|0;va=((a|0)<(t|0)?G:0)+a|0;Ba=j[n+(wa<<1)>>1]|0;ua=j[n+(a<<1)>>1]|0;Ca=j[n+(va<<1)>>1]|0;ya=j[p+(wa<<1)>>1]|0;Aa=j[p+(a<<1)>>1]|0;Oa=j[p+(va<<1)>>1]|0;wa=j[b+(wa<<1)>>1]|0;xa=j[b+(a<<1)>>1]|0;va=j[b+(va<<1)>>1]|0;ta=Ca<<16>>16<ua<<16>>16;za=ta?Ca:ua;Ca=ta?ua:Ca;ua=Oa<<16>>16<Aa<<16>>16;ta=ua?Oa:Aa;Oa=ua?Aa:Oa;Aa=va<<16>>16<xa<<16>>16;ua=Aa?va:xa;va=Aa?xa:va;xa=za<<16>>16<Ba<<16>>16;Aa=(xa?za:Ba)<<16>>16;za=xa?Ba:za;Ba=ta<<16>>16<ya<<16>>16;xa=(Ba?ta:ya)<<16>>16;ta=Ba?ya:ta;ya=ua<<16>>16<wa<<16>>16;Ba=(ya?ua:wa)<<16>>16;ua=ya?wa:ua;wa=Ca<<16>>16<za<<16>>16;ya=(wa?Ca:za)<<16>>16;Ca=(wa?za:Ca)<<16>>16;za=Oa<<16>>16<ta<<16>>16;wa=za?Oa:ta;Oa=(za?ta:Oa)<<16>>16;ta=va<<16>>16<ua<<16>>16;za=ta?va:ua;va=(ta?ua:va)<<16>>16;xa=(xa|0)<(Aa|0)?Aa:xa;Oa=(va|0)<(Oa|0)?va:Oa;va=za<<16>>16<wa<<16>>16;Aa=(va?za:wa)<<16>>16;za=(va?wa:za)<<16>>16;Ba=(Ba|0)<(xa|0)?xa:Ba;Aa=(Aa|0)<(ya|0)?ya:Aa;Ca=(Oa|0)<(Ca|0)?Oa:Ca;Aa=(za|0)<(Aa|0)?za:Aa;za=(Ca|0)<(Aa|0);Oa=za?Ca:Aa;Ca=za?Aa:Ca;Oa=(Oa|0)<(Ba|0)?Ba:Oa;j[h+(a<<1)>>1]=(Ca|0)<(Oa|0)?Ca:Oa;a=a+1|0}while((a|0)!=(f|0));a=f}if((f|0)==(v|0))break;if((a|0)>(s|0)){f=v;continue}while(1){Oa=n+(a<<1)|0;Ca=j[Oa+(q<<1)>>1]|0;va=j[Oa>>1]|0;Oa=j[Oa+(G<<1)>>1]|0;e=p+(a<<1)|0;za=j[e+(q<<1)>>1]|0;Ba=j[e>>1]|0;e=j[e+(G<<1)>>1]|0;wa=b+(a<<1)|0;xa=j[wa+(q<<1)>>1]|0;ya=j[wa>>1]|0;wa=j[wa+(G<<1)>>1]|0;ua=Oa<<16>>16<va<<16>>16;Aa=ua?Oa:va;Oa=ua?va:Oa;va=e<<16>>16<Ba<<16>>16;ua=va?e:Ba;e=va?Ba:e;Ba=wa<<16>>16<ya<<16>>16;va=Ba?wa:ya;wa=Ba?ya:wa;ya=Aa<<16>>16<Ca<<16>>16;Ba=(ya?Aa:Ca)<<16>>16;Aa=ya?Ca:Aa;Ca=ua<<16>>16<za<<16>>16;ya=(Ca?ua:za)<<16>>16;ua=Ca?za:ua;za=va<<16>>16<xa<<16>>16;Ca=(za?va:xa)<<16>>16;va=za?xa:va;xa=Oa<<16>>16<Aa<<16>>16;za=(xa?Oa:Aa)<<16>>16;Oa=(xa?Aa:Oa)<<16>>16;Aa=e<<16>>16<ua<<16>>16;xa=Aa?e:ua;e=(Aa?ua:e)<<16>>16;ua=wa<<16>>16<va<<16>>16;Aa=ua?wa:va;wa=(ua?va:wa)<<16>>16;ya=(ya|0)<(Ba|0)?Ba:ya;e=(wa|0)<(e|0)?wa:e;wa=Aa<<16>>16<xa<<16>>16;Ba=(wa?Aa:xa)<<16>>16;Aa=(wa?xa:Aa)<<16>>16;Ca=(Ca|0)<(ya|0)?ya:Ca;Ba=(Ba|0)<(za|0)?za:Ba;Oa=(e|0)<(Oa|0)?e:Oa;Ba=(Aa|0)<(Ba|0)?Aa:Ba;Aa=(Oa|0)<(Ba|0);e=Aa?Oa:Ba;Oa=Aa?Ba:Oa;e=(e|0)<(Ca|0)?Ca:e;j[h+(a<<1)>>1]=(Oa|0)<(e|0)?Oa:e;e=a+1|0;if((a|0)<(s|0))a=e;else{f=v;a=e;continue l}}}if((g|0)==(D|0))break;else h=h+(F<<1)|0}}break}case 5:{e=(D|0)==1;if((a|0)==1|e){a=D+a|0;z=a+-1|0;A=e?G:E;y=e?0:E-G|0;t=e?G:F;if((a|0)<=1)break k;v=0-A|0;w=v<<1;x=a+-2|0;q=a+-3|0;s=A<<1;b=0;while(1){f=(b|0)>0?v:0;g=(b|0)>1?w:f;n=(b|0)<(x|0)?A:0;p=(b|0)<(q|0)?s:n;a=d;e=0;while(1){Oa=j[a+(g<<1)>>1]|0;Da=j[a+(f<<1)>>1]|0;ya=j[a>>1]|0;Ca=j[a+(n<<1)>>1]|0;Ba=j[a+(p<<1)>>1]|0;za=Da<<16>>16<Oa<<16>>16;Aa=(za?Da:Oa)<<16>>16;Da=(za?Oa:Da)<<16>>16;Oa=Ba<<16>>16<Ca<<16>>16;za=Oa?Ba:Ca;Ba=Oa?Ca:Ba;Ca=za<<16>>16<ya<<16>>16;Oa=(Ca?za:ya)<<16>>16;za=Ca?ya:za;ya=Ba<<16>>16<za<<16>>16;Ca=(ya?Ba:za)<<16>>16;Ba=(ya?za:Ba)<<16>>16;Oa=(Oa|0)<(Aa|0)?Aa:Oa;Oa=(Ba|0)<(Oa|0)?Ba:Oa;Da=(Ca|0)<(Da|0)?Ca:Da;j[h+(e<<1)>>1]=(Oa|0)<(Da|0)?Da:Oa;e=e+1|0;if((e|0)==(G|0))break;else a=a+2|0}b=b+1|0;if((b|0)>=(z|0))break k;else{h=h+(t<<1)|0;d=d+(G<<1)+(y<<1)|0}}}x=aa(a,G)|0;if((D|0)>0){y=D+-1|0;z=G<<1;A=0-z|0;B=x+~z|0;t=(f|-512)^511;v=x-G|0;w=x-z|0;g=0;while(1){n=g+-2|0;n=d+((aa((n|0)<0?0:n,E)|0)<<1)|0;p=g+-1|0;p=d+((aa((p|0)<0?0:p,E)|0)<<1)|0;b=d+((aa(g,E)|0)<<1)|0;s=g;g=g+1|0;q=d+((aa((y|0)<(g|0)?y:g,E)|0)<<1)|0;s=s+2|0;s=d+((aa((y|0)<(s|0)?y:s,E)|0)<<1)|0;f=i[Da>>0]&1?z:x;a=0;m:while(1){if((a|0)<(f|0)){do{Oa=a-((a|0)>(C|0)?G:0)|0;ea=(a|0)<(z|0)?Oa:a-z|0;za=((a|0)<(v|0)?G:0)+a|0;ja=(a|0)<(w|0)?a+z|0:za;ta=j[n+(ea<<1)>>1]|0;la=j[n+(Oa<<1)>>1]|0;oa=j[n+(a<<1)>>1]|0;ia=j[n+(za<<1)>>1]|0;ua=j[n+(ja<<1)>>1]|0;ra=j[p+(ea<<1)>>1]|0;wa=j[p+(Oa<<1)>>1]|0;na=j[p+(a<<1)>>1]|0;fa=j[p+(za<<1)>>1]|0;Aa=j[p+(ja<<1)>>1]|0;qa=j[b+(ea<<1)>>1]|0;Ca=j[b+(Oa<<1)>>1]|0;sa=j[b+(a<<1)>>1]|0;xa=j[b+(za<<1)>>1]|0;ga=j[b+(ja<<1)>>1]|0;ka=j[q+(ea<<1)>>1]|0;ma=j[q+(Oa<<1)>>1]|0;Ba=j[q+(a<<1)>>1]|0;da=j[q+(za<<1)>>1]|0;ya=j[q+(ja<<1)>>1]|0;ea=j[s+(ea<<1)>>1]|0;Oa=j[s+(Oa<<1)>>1]|0;va=j[s+(a<<1)>>1]|0;za=j[s+(za<<1)>>1]|0;ja=j[s+(ja<<1)>>1]|0;ha=oa<<16>>16<la<<16>>16?oa:la;la=oa<<16>>16>la<<16>>16?oa:la;oa=ha<<16>>16<ta<<16>>16;pa=oa?ha:ta;ha=oa?ta:ha;ta=la<<16>>16<ha<<16>>16;oa=ta?la:ha;la=ta?ha:la;ha=ra<<16>>16<ua<<16>>16;ta=ha?ra:ua;ra=ha?ua:ra;ua=ta<<16>>16<ia<<16>>16;ha=ua?ta:ia;ta=ua?ia:ta;ia=ra<<16>>16<ta<<16>>16;ua=ia?ra:ta;ra=ia?ta:ra;ta=ha<<16>>16<pa<<16>>16;ia=ta?ha:pa;ha=ta?pa:ha;pa=ra<<16>>16<la<<16>>16;ta=pa?ra:la;ra=pa?la:ra;la=ha<<16>>16<ta<<16>>16;pa=la?ha:ta;ha=la?ta:ha;ta=ua<<16>>16<oa<<16>>16;la=ta?ua:oa;ua=ta?oa:ua;oa=pa<<16>>16<la<<16>>16;ta=oa?pa:la;pa=oa?la:pa;la=ua<<16>>16<ha<<16>>16;oa=la?ua:ha;ua=la?ha:ua;ha=fa<<16>>16<na<<16>>16;la=ha?fa:na;fa=ha?na:fa;na=la<<16>>16<wa<<16>>16;ha=na?la:wa;la=na?wa:la;wa=fa<<16>>16<la<<16>>16;na=wa?fa:la;fa=wa?la:fa;la=Ca<<16>>16<qa<<16>>16;wa=la?Ca:qa;Ca=la?qa:Ca;qa=wa<<16>>16<Aa<<16>>16;la=qa?wa:Aa;wa=qa?Aa:wa;Aa=Ca<<16>>16<wa<<16>>16;qa=Aa?Ca:wa;Ca=Aa?wa:Ca;wa=la<<16>>16<ha<<16>>16;Aa=wa?la:ha;la=wa?ha:la;ha=Ca<<16>>16<fa<<16>>16;wa=ha?Ca:fa;Ca=ha?fa:Ca;fa=la<<16>>16<wa<<16>>16;ha=fa?la:wa;la=fa?wa:la;wa=qa<<16>>16<na<<16>>16;fa=wa?qa:na;qa=wa?na:qa;na=ha<<16>>16<fa<<16>>16;wa=na?ha:fa;ha=na?fa:ha;fa=qa<<16>>16<la<<16>>16;na=fa?qa:la;qa=fa?la:qa;la=Aa<<16>>16<ia<<16>>16;fa=(la?Aa:ia)<<16>>16;Aa=la?ia:Aa;ia=qa<<16>>16<ua<<16>>16;la=ia?qa:ua;qa=ia?ua:qa;ua=Aa<<16>>16<la<<16>>16;ia=ua?Aa:la;Aa=ua?la:Aa;la=ha<<16>>16<pa<<16>>16;ua=la?ha:pa;ha=la?pa:ha;pa=ia<<16>>16<ua<<16>>16;la=pa?ia:ua;ia=pa?ua:ia;ua=ha<<16>>16<Aa<<16>>16;pa=ua?ha:Aa;ha=ua?Aa:ha;Aa=wa<<16>>16<ta<<16>>16;ua=Aa?wa:ta;wa=Aa?ta:wa;ta=Ca<<16>>16<ra<<16>>16;Aa=ta?Ca:ra;Ca=(ta?ra:Ca)<<16>>16;ra=wa<<16>>16<Aa<<16>>16;ta=ra?wa:Aa;wa=ra?Aa:wa;Aa=na<<16>>16<oa<<16>>16;ra=Aa?na:oa;na=Aa?oa:na;oa=ta<<16>>16<ra<<16>>16;Aa=oa?ta:ra;ta=oa?ra:ta;ra=na<<16>>16<wa<<16>>16;oa=ra?na:wa;na=ra?wa:na;wa=la<<16>>16<ua<<16>>16;ra=(wa?la:ua)<<16>>16;la=(wa?ua:la)<<16>>16;ua=ia<<16>>16<Aa<<16>>16;wa=(ua?ia:Aa)<<16>>16;ia=(ua?Aa:ia)<<16>>16;Aa=pa<<16>>16<ta<<16>>16;ua=(Aa?pa:ta)<<16>>16;pa=(Aa?ta:pa)<<16>>16;ta=ha<<16>>16<oa<<16>>16;Aa=(ta?ha:oa)<<16>>16;ha=(ta?oa:ha)<<16>>16;oa=qa<<16>>16<na<<16>>16;ta=(oa?qa:na)<<16>>16;qa=(oa?na:qa)<<16>>16;na=ga<<16>>16<xa<<16>>16;oa=na?ga:xa;ga=na?xa:ga;xa=oa<<16>>16<sa<<16>>16;na=xa?oa:sa;oa=xa?sa:oa;sa=ga<<16>>16<oa<<16>>16;xa=sa?ga:oa;ga=sa?oa:ga;oa=Ba<<16>>16<ma<<16>>16;sa=oa?Ba:ma;Ba=oa?ma:Ba;ma=sa<<16>>16<ka<<16>>16;oa=ma?sa:ka;sa=ma?ka:sa;ka=Ba<<16>>16<sa<<16>>16;ma=ka?Ba:sa;Ba=ka?sa:Ba;sa=oa<<16>>16<na<<16>>16;ka=sa?oa:na;oa=sa?na:oa;na=Ba<<16>>16<ga<<16>>16;sa=na?Ba:ga;Ba=na?ga:Ba;ga=oa<<16>>16<sa<<16>>16;na=ga?oa:sa;oa=ga?sa:oa;sa=ma<<16>>16<xa<<16>>16;ga=sa?ma:xa;ma=sa?xa:ma;xa=na<<16>>16<ga<<16>>16;sa=xa?na:ga;na=xa?ga:na;ga=ma<<16>>16<oa<<16>>16;xa=ga?ma:oa;ma=ga?oa:ma;oa=ea<<16>>16<ya<<16>>16;ga=oa?ea:ya;ea=oa?ya:ea;ya=ga<<16>>16<da<<16>>16;oa=ya?ga:da;ga=ya?da:ga;da=ea<<16>>16<ga<<16>>16;ya=da?ea:ga;ea=da?ga:ea;ga=va<<16>>16<Oa<<16>>16;da=ga?va:Oa;va=ga?Oa:va;Oa=ja<<16>>16<za<<16>>16;ga=Oa?ja:za;ja=Oa?za:ja;za=ga<<16>>16<da<<16>>16;Oa=za?ga:da;ga=za?da:ga;da=ja<<16>>16<va<<16>>16;za=da?ja:va;ja=da?va:ja;va=ga<<16>>16<za<<16>>16;da=va?ga:za;ga=va?za:ga;za=Oa<<16>>16<oa<<16>>16;va=za?Oa:oa;Oa=za?oa:Oa;oa=ga<<16>>16<ea<<16>>16;za=oa?ga:ea;ga=oa?ea:ga;ea=Oa<<16>>16<za<<16>>16;oa=ea?Oa:za;Oa=ea?za:Oa;za=da<<16>>16<ya<<16>>16;ea=za?da:ya;da=za?ya:da;ya=ja<<16>>16<da<<16>>16;za=ya?ja:da;ja=ya?da:ja;da=oa<<16>>16<ea<<16>>16;ya=da?oa:ea;oa=da?ea:oa;ea=za<<16>>16<Oa<<16>>16;da=ea?za:Oa;za=ea?Oa:za;Oa=ja<<16>>16<ga<<16>>16;ea=Oa?ja:ga;ja=Oa?ga:ja;ga=va<<16>>16<ka<<16>>16;Oa=(ga?va:ka)<<16>>16;va=ga?ka:va;ka=za<<16>>16<ma<<16>>16;ga=ka?za:ma;za=ka?ma:za;ma=va<<16>>16<ga<<16>>16;ka=ma?va:ga;va=ma?ga:va;ga=oa<<16>>16<na<<16>>16;ma=ga?oa:na;oa=ga?na:oa;na=ja<<16>>16<oa<<16>>16;ga=na?ja:oa;ja=na?oa:ja;oa=ka<<16>>16<ma<<16>>16;na=oa?ka:ma;ka=oa?ma:ka;ma=ga<<16>>16<va<<16>>16;oa=ma?ga:va;ga=ma?va:ga;va=ja<<16>>16<za<<16>>16;ma=va?ja:za;ja=va?za:ja;za=ya<<16>>16<sa<<16>>16;va=za?ya:sa;ya=za?sa:ya;sa=ea<<16>>16<Ba<<16>>16;za=sa?ea:Ba;ea=sa?Ba:ea;Ba=ya<<16>>16<za<<16>>16;sa=Ba?ya:za;ya=Ba?za:ya;za=da<<16>>16<xa<<16>>16;Ba=za?da:xa;da=za?xa:da;xa=sa<<16>>16<Ba<<16>>16;za=xa?sa:Ba;sa=xa?Ba:sa;Ba=da<<16>>16<ya<<16>>16;xa=Ba?da:ya;da=Ba?ya:da;ya=na<<16>>16<va<<16>>16;Ba=(ya?na:va)<<16>>16;na=(ya?va:na)<<16>>16;va=ka<<16>>16<za<<16>>16;ya=(va?ka:za)<<16>>16;ka=(va?za:ka)<<16>>16;za=oa<<16>>16<sa<<16>>16;va=(za?oa:sa)<<16>>16;oa=(za?sa:oa)<<16>>16;sa=ga<<16>>16<xa<<16>>16;za=(sa?ga:xa)<<16>>16;ga=(sa?xa:ga)<<16>>16;xa=ma<<16>>16<da<<16>>16;sa=(xa?ma:da)<<16>>16;ma=(xa?da:ma)<<16>>16;da=ja<<16>>16<ea<<16>>16;xa=(da?ja:ea)<<16>>16;ja=(da?ea:ja)<<16>>16;Oa=(Oa|0)<(fa|0)?fa:Oa;ha=(ga|0)<(ha|0)?ga:ha;Oa=(Oa|0)<(ha|0)?ha:Oa;ka=(ka|0)<(ia|0)?ia:ka;ka=(ja|0)<(ka|0)?ja:ka;Oa=(ka|0)<(Oa|0)?ka:Oa;na=(na|0)<(la|0)?la:na;qa=(ma|0)<(qa|0)?ma:qa;qa=(na|0)<(qa|0)?na:qa;pa=(oa|0)<(pa|0)?oa:pa;qa=(qa|0)<(pa|0)?pa:qa;Oa=(Oa|0)<(qa|0)?qa:Oa;Ba=(Ba|0)<(ra|0)?ra:Ba;ta=(sa|0)<(ta|0)?sa:ta;Ba=(Ba|0)<(ta|0)?ta:Ba;va=(va|0)<(ua|0)?ua:va;Ba=(va|0)<(Ba|0)?va:Ba;ya=(ya|0)<(wa|0)?wa:ya;Ca=(xa|0)<(Ca|0)?xa:Ca;Ca=(ya|0)<(Ca|0)?ya:Ca;Aa=(za|0)<(Aa|0)?za:Aa;Ca=(Ca|0)<(Aa|0)?Aa:Ca;Ca=(Ba|0)<(Ca|0)?Ba:Ca;j[h+(a<<1)>>1]=(Oa|0)<(Ca|0)?Ca:Oa;a=a+1|0}while((a|0)!=(f|0));a=f}if((f|0)==(x|0))break;if((a|0)>(B|0)){f=x;continue}while(1){va=n+(a<<1)|0;ua=j[va+(A<<1)>>1]|0;ma=j[va+(t<<1)>>1]|0;pa=j[va>>1]|0;ja=j[va+(G<<1)>>1]|0;va=j[va+(z<<1)>>1]|0;Ba=p+(a<<1)|0;sa=j[Ba+(A<<1)>>1]|0;xa=j[Ba+(t<<1)>>1]|0;oa=j[Ba>>1]|0;ga=j[Ba+(G<<1)>>1]|0;Ba=j[Ba+(z<<1)>>1]|0;ha=b+(a<<1)|0;ra=j[ha+(A<<1)>>1]|0;Oa=j[ha+(t<<1)>>1]|0;ta=j[ha>>1]|0;ya=j[ha+(G<<1)>>1]|0;ha=j[ha+(z<<1)>>1]|0;za=q+(a<<1)|0;la=j[za+(A<<1)>>1]|0;na=j[za+(t<<1)>>1]|0;Ca=j[za>>1]|0;ea=j[za+(G<<1)>>1]|0;za=j[za+(z<<1)>>1]|0;ka=s+(a<<1)|0;fa=j[ka+(A<<1)>>1]|0;e=j[ka+(t<<1)>>1]|0;wa=j[ka>>1]|0;Aa=j[ka+(G<<1)>>1]|0;ka=j[ka+(z<<1)>>1]|0;ia=pa<<16>>16<ma<<16>>16?pa:ma;ma=pa<<16>>16>ma<<16>>16?pa:ma;pa=ia<<16>>16<ua<<16>>16;qa=pa?ia:ua;ia=pa?ua:ia;ua=ma<<16>>16<ia<<16>>16;pa=ua?ma:ia;ma=ua?ia:ma;ia=sa<<16>>16<va<<16>>16;ua=ia?sa:va;sa=ia?va:sa;va=ua<<16>>16<ja<<16>>16;ia=va?ua:ja;ua=va?ja:ua;ja=sa<<16>>16<ua<<16>>16;va=ja?sa:ua;sa=ja?ua:sa;ua=ia<<16>>16<qa<<16>>16;ja=ua?ia:qa;ia=ua?qa:ia;qa=sa<<16>>16<ma<<16>>16;ua=qa?sa:ma;sa=qa?ma:sa;ma=ia<<16>>16<ua<<16>>16;qa=ma?ia:ua;ia=ma?ua:ia;ua=va<<16>>16<pa<<16>>16;ma=ua?va:pa;va=ua?pa:va;pa=qa<<16>>16<ma<<16>>16;ua=pa?qa:ma;qa=pa?ma:qa;ma=va<<16>>16<ia<<16>>16;pa=ma?va:ia;va=ma?ia:va;ia=ga<<16>>16<oa<<16>>16;ma=ia?ga:oa;ga=ia?oa:ga;oa=ma<<16>>16<xa<<16>>16;ia=oa?ma:xa;ma=oa?xa:ma;xa=ga<<16>>16<ma<<16>>16;oa=xa?ga:ma;ga=xa?ma:ga;ma=Oa<<16>>16<ra<<16>>16;xa=ma?Oa:ra;Oa=ma?ra:Oa;ra=xa<<16>>16<Ba<<16>>16;ma=ra?xa:Ba;xa=ra?Ba:xa;Ba=Oa<<16>>16<xa<<16>>16;ra=Ba?Oa:xa;Oa=Ba?xa:Oa;xa=ma<<16>>16<ia<<16>>16;Ba=xa?ma:ia;ma=xa?ia:ma;ia=Oa<<16>>16<ga<<16>>16;xa=ia?Oa:ga;Oa=ia?ga:Oa;ga=ma<<16>>16<xa<<16>>16;ia=ga?ma:xa;ma=ga?xa:ma;xa=ra<<16>>16<oa<<16>>16;ga=xa?ra:oa;ra=xa?oa:ra;oa=ia<<16>>16<ga<<16>>16;xa=oa?ia:ga;ia=oa?ga:ia;ga=ra<<16>>16<ma<<16>>16;oa=ga?ra:ma;ra=ga?ma:ra;ma=Ba<<16>>16<ja<<16>>16;ga=(ma?Ba:ja)<<16>>16;Ba=ma?ja:Ba;ja=ra<<16>>16<va<<16>>16;ma=ja?ra:va;ra=ja?va:ra;va=Ba<<16>>16<ma<<16>>16;ja=va?Ba:ma;Ba=va?ma:Ba;ma=ia<<16>>16<qa<<16>>16;va=ma?ia:qa;ia=ma?qa:ia;qa=ja<<16>>16<va<<16>>16;ma=qa?ja:va;ja=qa?va:ja;va=ia<<16>>16<Ba<<16>>16;qa=va?ia:Ba;ia=va?Ba:ia;Ba=xa<<16>>16<ua<<16>>16;va=Ba?xa:ua;xa=Ba?ua:xa;ua=Oa<<16>>16<sa<<16>>16;Ba=ua?Oa:sa;Oa=(ua?sa:Oa)<<16>>16;sa=xa<<16>>16<Ba<<16>>16;ua=sa?xa:Ba;xa=sa?Ba:xa;Ba=oa<<16>>16<pa<<16>>16;sa=Ba?oa:pa;oa=Ba?pa:oa;pa=ua<<16>>16<sa<<16>>16;Ba=pa?ua:sa;ua=pa?sa:ua;sa=oa<<16>>16<xa<<16>>16;pa=sa?oa:xa;oa=sa?xa:oa;xa=ma<<16>>16<va<<16>>16;sa=(xa?ma:va)<<16>>16;ma=(xa?va:ma)<<16>>16;va=ja<<16>>16<Ba<<16>>16;xa=(va?ja:Ba)<<16>>16;ja=(va?Ba:ja)<<16>>16;Ba=qa<<16>>16<ua<<16>>16;va=(Ba?qa:ua)<<16>>16;qa=(Ba?ua:qa)<<16>>16;ua=ia<<16>>16<pa<<16>>16;Ba=(ua?ia:pa)<<16>>16;ia=(ua?pa:ia)<<16>>16;pa=ra<<16>>16<oa<<16>>16;ua=(pa?ra:oa)<<16>>16;ra=(pa?oa:ra)<<16>>16;oa=ha<<16>>16<ya<<16>>16;pa=oa?ha:ya;ha=oa?ya:ha;ya=pa<<16>>16<ta<<16>>16;oa=ya?pa:ta;pa=ya?ta:pa;ta=ha<<16>>16<pa<<16>>16;ya=ta?ha:pa;ha=ta?pa:ha;pa=Ca<<16>>16<na<<16>>16;ta=pa?Ca:na;Ca=pa?na:Ca;na=ta<<16>>16<la<<16>>16;pa=na?ta:la;ta=na?la:ta;la=Ca<<16>>16<ta<<16>>16;na=la?Ca:ta;Ca=la?ta:Ca;ta=pa<<16>>16<oa<<16>>16;la=ta?pa:oa;pa=ta?oa:pa;oa=Ca<<16>>16<ha<<16>>16;ta=oa?Ca:ha;Ca=oa?ha:Ca;ha=pa<<16>>16<ta<<16>>16;oa=ha?pa:ta;pa=ha?ta:pa;ta=na<<16>>16<ya<<16>>16;ha=ta?na:ya;na=ta?ya:na;ya=oa<<16>>16<ha<<16>>16;ta=ya?oa:ha;oa=ya?ha:oa;ha=na<<16>>16<pa<<16>>16;ya=ha?na:pa;na=ha?pa:na;pa=fa<<16>>16<za<<16>>16;ha=pa?fa:za;fa=pa?za:fa;za=ha<<16>>16<ea<<16>>16;pa=za?ha:ea;ha=za?ea:ha;ea=fa<<16>>16<ha<<16>>16;za=ea?fa:ha;fa=ea?ha:fa;ha=wa<<16>>16<e<<16>>16;ea=ha?wa:e;wa=ha?e:wa;e=ka<<16>>16<Aa<<16>>16;ha=e?ka:Aa;ka=e?Aa:ka;Aa=ha<<16>>16<ea<<16>>16;e=Aa?ha:ea;ha=Aa?ea:ha;ea=ka<<16>>16<wa<<16>>16;Aa=ea?ka:wa;ka=ea?wa:ka;wa=ha<<16>>16<Aa<<16>>16;ea=wa?ha:Aa;ha=wa?Aa:ha;Aa=e<<16>>16<pa<<16>>16;wa=Aa?e:pa;e=Aa?pa:e;pa=ha<<16>>16<fa<<16>>16;Aa=pa?ha:fa;ha=pa?fa:ha;fa=e<<16>>16<Aa<<16>>16;pa=fa?e:Aa;e=fa?Aa:e;Aa=ea<<16>>16<za<<16>>16;fa=Aa?ea:za;ea=Aa?za:ea;za=ka<<16>>16<ea<<16>>16;Aa=za?ka:ea;ka=za?ea:ka;ea=pa<<16>>16<fa<<16>>16;za=ea?pa:fa;pa=ea?fa:pa;fa=Aa<<16>>16<e<<16>>16;ea=fa?Aa:e;Aa=fa?e:Aa;e=ka<<16>>16<ha<<16>>16;fa=e?ka:ha;ka=e?ha:ka;ha=wa<<16>>16<la<<16>>16;e=(ha?wa:la)<<16>>16;wa=ha?la:wa;la=Aa<<16>>16<na<<16>>16;ha=la?Aa:na;Aa=la?na:Aa;na=wa<<16>>16<ha<<16>>16;la=na?wa:ha;wa=na?ha:wa;ha=pa<<16>>16<oa<<16>>16;na=ha?pa:oa;pa=ha?oa:pa;oa=ka<<16>>16<pa<<16>>16;ha=oa?ka:pa;ka=oa?pa:ka;pa=la<<16>>16<na<<16>>16;oa=pa?la:na;la=pa?na:la;na=ha<<16>>16<wa<<16>>16;pa=na?ha:wa;ha=na?wa:ha;wa=ka<<16>>16<Aa<<16>>16;na=wa?ka:Aa;ka=wa?Aa:ka;Aa=za<<16>>16<ta<<16>>16;wa=Aa?za:ta;za=Aa?ta:za;ta=fa<<16>>16<Ca<<16>>16;Aa=ta?fa:Ca;fa=ta?Ca:fa;Ca=za<<16>>16<Aa<<16>>16;ta=Ca?za:Aa;za=Ca?Aa:za;Aa=ea<<16>>16<ya<<16>>16;Ca=Aa?ea:ya;ea=Aa?ya:ea;ya=ta<<16>>16<Ca<<16>>16;Aa=ya?ta:Ca;ta=ya?Ca:ta;Ca=ea<<16>>16<za<<16>>16;ya=Ca?ea:za;ea=Ca?za:ea;za=oa<<16>>16<wa<<16>>16;Ca=(za?oa:wa)<<16>>16;oa=(za?wa:oa)<<16>>16;wa=la<<16>>16<Aa<<16>>16;za=(wa?la:Aa)<<16>>16;la=(wa?Aa:la)<<16>>16;Aa=pa<<16>>16<ta<<16>>16;wa=(Aa?pa:ta)<<16>>16;pa=(Aa?ta:pa)<<16>>16;ta=ha<<16>>16<ya<<16>>16;Aa=(ta?ha:ya)<<16>>16;ha=(ta?ya:ha)<<16>>16;ya=na<<16>>16<ea<<16>>16;ta=(ya?na:ea)<<16>>16;na=(ya?ea:na)<<16>>16;ea=ka<<16>>16<fa<<16>>16;ya=(ea?ka:fa)<<16>>16;ka=(ea?fa:ka)<<16>>16;e=(e|0)<(ga|0)?ga:e;ia=(ha|0)<(ia|0)?ha:ia;e=(e|0)<(ia|0)?ia:e;la=(la|0)<(ja|0)?ja:la;la=(ka|0)<(la|0)?ka:la;e=(la|0)<(e|0)?la:e;oa=(oa|0)<(ma|0)?ma:oa;ra=(na|0)<(ra|0)?na:ra;ra=(oa|0)<(ra|0)?oa:ra;qa=(pa|0)<(qa|0)?pa:qa;ra=(ra|0)<(qa|0)?qa:ra;e=(e|0)<(ra|0)?ra:e;Ca=(Ca|0)<(sa|0)?sa:Ca;ua=(ta|0)<(ua|0)?ta:ua;Ca=(Ca|0)<(ua|0)?ua:Ca;wa=(wa|0)<(va|0)?va:wa;Ca=(wa|0)<(Ca|0)?wa:Ca;za=(za|0)<(xa|0)?xa:za;Oa=(ya|0)<(Oa|0)?ya:Oa;Oa=(za|0)<(Oa|0)?za:Oa;Ba=(Aa|0)<(Ba|0)?Aa:Ba;Oa=(Oa|0)<(Ba|0)?Ba:Oa;Oa=(Ca|0)<(Oa|0)?Ca:Oa;j[h+(a<<1)>>1]=(e|0)<(Oa|0)?Oa:e;e=a+1|0;if((a|0)<(B|0))a=e;else{f=x;a=e;continue m}}}if((g|0)==(D|0))break;else h=h+(F<<1)|0}}break}default:{}}while(0);break a}case 5:{p=k[Ia+16>>2]|0;f=k[a>>2]|0;U=(k[Ha>>2]|0)>>>2;V=(k[Ka+48>>2]|0)>>>2;T=k[Ka+40>>2]|0;a=k[T+4>>2]|0;T=k[T>>2]|0;e=e>>>3;S=e&511;_=S+1|0;i[Ca>>0]=i[430452]|i[430355];n:do switch(c|0){case 3:{d=(T|0)==1;if((a|0)==1|d){a=T+a|0;v=a+-1|0;w=d?_:U;t=d?0:U-_|0;q=d?_:V;if((a|0)<=1)break n;s=0-w|0;b=a+-2|0;a=f;d=0;while(1){g=(d|0)>0?s:0;h=(d|0)<(b|0)?w:0;e=0;f=p;while(1){Oa=k[f+(g<<2)>>2]|0;k[ea>>2]=Oa;n=k[f>>2]|0;k[da>>2]=n;Ca=k[f+(h<<2)>>2]|0;k[ca>>2]=Ca;k[Da>>2]=Oa;Na=(k[u>>2]=n,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);n=k[(Oa?da:ea)>>2]|0;Oa=k[(Oa?Da:da)>>2]|0;k[da>>2]=Oa;Na=(k[u>>2]=Ca,+o[u>>2]);Oa=k[(Na<(k[u>>2]=Oa,+o[u>>2])?ca:da)>>2]|0;k[da>>2]=Oa;k[Da>>2]=n;Na=(k[u>>2]=Oa,+o[u>>2]);k[a+(e<<2)>>2]=k[(Na<(k[u>>2]=n,+o[u>>2])?Da:da)>>2];e=e+1|0;if((e|0)==(_|0))break;else f=f+4|0}d=d+1|0;if((d|0)>=(v|0))break n;else{p=p+(_<<2)+(t<<2)|0;a=a+(q<<2)|0}}}D=aa(a,_)|0;if((T|0)>0){E=T+-1|0;A=(e|-512)^511;B=A+-1+D|0;C=D-_|0;v=f;w=0;while(1){x=w+-1|0;x=p+((aa((x|0)<0?0:x,U)|0)<<2)|0;y=p+((aa(w,U)|0)<<2)|0;w=w+1|0;z=p+((aa((E|0)<(w|0)?E:w,U)|0)<<2)|0;t=i[Ca>>0]&1?_:D;a=0;o:while(1){if((a|0)<(t|0)){do{e=a-((a|0)>(S|0)?_:0)|0;h=((a|0)<(C|0)?_:0)+a|0;s=k[x+(e<<2)>>2]|0;k[ea>>2]=s;q=k[x+(a<<2)>>2]|0;k[da>>2]=q;Oa=k[x+(h<<2)>>2]|0;k[ca>>2]=Oa;d=k[y+(e<<2)>>2]|0;k[ba>>2]=d;f=k[y+(a<<2)>>2]|0;k[$>>2]=f;Ba=k[y+(h<<2)>>2]|0;k[Z>>2]=Ba;e=k[z+(e<<2)>>2]|0;k[Y>>2]=e;g=k[z+(a<<2)>>2]|0;k[X>>2]=g;h=k[z+(h<<2)>>2]|0;k[W>>2]=h;k[Da>>2]=q;Na=(k[u>>2]=Oa,+o[u>>2]);q=Na<(k[u>>2]=q,+o[u>>2]);Oa=k[(q?ca:da)>>2]|0;k[da>>2]=Oa;q=k[(q?Da:ca)>>2]|0;k[ca>>2]=q;k[Da>>2]=f;Na=(k[u>>2]=Ba,+o[u>>2]);f=Na<(k[u>>2]=f,+o[u>>2]);Ba=k[(f?Z:$)>>2]|0;k[$>>2]=Ba;f=k[(f?Da:Z)>>2]|0;k[Z>>2]=f;k[Da>>2]=g;Na=(k[u>>2]=h,+o[u>>2]);g=Na<(k[u>>2]=g,+o[u>>2]);h=k[(g?W:X)>>2]|0;k[X>>2]=h;g=k[(g?Da:W)>>2]|0;k[W>>2]=g;k[Da>>2]=s;Na=(k[u>>2]=Oa,+o[u>>2]);s=Na<(k[u>>2]=s,+o[u>>2]);Oa=k[(s?da:ea)>>2]|0;k[ea>>2]=Oa;s=k[(s?Da:da)>>2]|0;k[da>>2]=s;k[Da>>2]=d;Na=(k[u>>2]=Ba,+o[u>>2]);d=Na<(k[u>>2]=d,+o[u>>2]);Ba=k[(d?$:ba)>>2]|0;k[ba>>2]=Ba;d=k[(d?Da:$)>>2]|0;k[$>>2]=d;k[Da>>2]=e;Na=(k[u>>2]=h,+o[u>>2]);e=Na<(k[u>>2]=e,+o[u>>2]);h=k[(e?X:Y)>>2]|0;k[Y>>2]=h;e=k[(e?Da:X)>>2]|0;k[X>>2]=e;k[Da>>2]=s;Na=(k[u>>2]=q,+o[u>>2]);s=Na<(k[u>>2]=s,+o[u>>2]);q=k[(s?ca:da)>>2]|0;k[da>>2]=q;s=k[(s?Da:ca)>>2]|0;k[ca>>2]=s;k[Da>>2]=d;Na=(k[u>>2]=f,+o[u>>2]);d=Na<(k[u>>2]=d,+o[u>>2]);f=k[(d?Z:$)>>2]|0;k[$>>2]=f;d=k[(d?Da:Z)>>2]|0;k[Z>>2]=d;k[Da>>2]=e;Na=(k[u>>2]=g,+o[u>>2]);e=Na<(k[u>>2]=e,+o[u>>2]);g=k[(e?W:X)>>2]|0;k[X>>2]=g;e=k[(e?Da:W)>>2]|0;k[W>>2]=e;k[Da>>2]=Oa;Na=(k[u>>2]=Ba,+o[u>>2]);n=k[(Na<(k[u>>2]=Oa,+o[u>>2])?Da:ba)>>2]|0;Na=(k[u>>2]=e,+o[u>>2]);b=k[(Na<(k[u>>2]=d,+o[u>>2])?W:Z)>>2]|0;k[Z>>2]=b;k[Da>>2]=f;Na=(k[u>>2]=g,+o[u>>2]);g=Na<(k[u>>2]=f,+o[u>>2]);d=k[(g?X:$)>>2]|0;k[$>>2]=d;g=k[(g?Da:X)>>2]|0;k[X>>2]=g;k[Da>>2]=n;Na=(k[u>>2]=n,+o[u>>2]);f=k[((k[u>>2]=h,+o[u>>2])<Na?Da:Y)>>2]|0;k[Da>>2]=q;Na=(k[u>>2]=d,+o[u>>2]);e=k[(Na<(k[u>>2]=q,+o[u>>2])?Da:$)>>2]|0;k[$>>2]=e;Na=(k[u>>2]=s,+o[u>>2]);d=k[((k[u>>2]=b,+o[u>>2])<Na?Z:ca)>>2]|0;k[ca>>2]=d;Na=(k[u>>2]=g,+o[u>>2]);Oa=k[(Na<(k[u>>2]=e,+o[u>>2])?X:$)>>2]|0;k[$>>2]=Oa;k[Da>>2]=Oa;Na=(k[u>>2]=d,+o[u>>2]);d=Na<(k[u>>2]=Oa,+o[u>>2]);Oa=k[(d?ca:$)>>2]|0;k[$>>2]=Oa;d=k[(d?Da:ca)>>2]|0;k[ca>>2]=d;k[Da>>2]=f;Na=(k[u>>2]=Oa,+o[u>>2]);Oa=k[(Na<(k[u>>2]=f,+o[u>>2])?Da:$)>>2]|0;k[$>>2]=Oa;Na=(k[u>>2]=d,+o[u>>2]);k[v+(a<<2)>>2]=k[(Na<(k[u>>2]=Oa,+o[u>>2])?ca:$)>>2];a=a+1|0}while((a|0)!=(t|0));a=t}if((t|0)==(D|0))break;if((a|0)>(B|0)){t=D;continue}while(1){Oa=x+(a<<2)|0;s=k[Oa+(A<<2)>>2]|0;k[ea>>2]=s;q=k[Oa>>2]|0;k[da>>2]=q;Oa=k[Oa+(_<<2)>>2]|0;k[ca>>2]=Oa;Ba=y+(a<<2)|0;d=k[Ba+(A<<2)>>2]|0;k[ba>>2]=d;f=k[Ba>>2]|0;k[$>>2]=f;Ba=k[Ba+(_<<2)>>2]|0;k[Z>>2]=Ba;h=z+(a<<2)|0;e=k[h+(A<<2)>>2]|0;k[Y>>2]=e;g=k[h>>2]|0;k[X>>2]=g;h=k[h+(_<<2)>>2]|0;k[W>>2]=h;k[Da>>2]=q;Na=(k[u>>2]=Oa,+o[u>>2]);q=Na<(k[u>>2]=q,+o[u>>2]);Oa=k[(q?ca:da)>>2]|0;k[da>>2]=Oa;q=k[(q?Da:ca)>>2]|0;k[ca>>2]=q;k[Da>>2]=f;Na=(k[u>>2]=Ba,+o[u>>2]);f=Na<(k[u>>2]=f,+o[u>>2]);Ba=k[(f?Z:$)>>2]|0;k[$>>2]=Ba;f=k[(f?Da:Z)>>2]|0;k[Z>>2]=f;k[Da>>2]=g;Na=(k[u>>2]=h,+o[u>>2]);g=Na<(k[u>>2]=g,+o[u>>2]);h=k[(g?W:X)>>2]|0;k[X>>2]=h;g=k[(g?Da:W)>>2]|0;k[W>>2]=g;k[Da>>2]=s;Na=(k[u>>2]=Oa,+o[u>>2]);s=Na<(k[u>>2]=s,+o[u>>2]);Oa=k[(s?da:ea)>>2]|0;k[ea>>2]=Oa;s=k[(s?Da:da)>>2]|0;k[da>>2]=s;k[Da>>2]=d;Na=(k[u>>2]=Ba,+o[u>>2]);d=Na<(k[u>>2]=d,+o[u>>2]);Ba=k[(d?$:ba)>>2]|0;k[ba>>2]=Ba;d=k[(d?Da:$)>>2]|0;k[$>>2]=d;k[Da>>2]=e;Na=(k[u>>2]=h,+o[u>>2]);e=Na<(k[u>>2]=e,+o[u>>2]);h=k[(e?X:Y)>>2]|0;k[Y>>2]=h;e=k[(e?Da:X)>>2]|0;k[X>>2]=e;k[Da>>2]=s;Na=(k[u>>2]=q,+o[u>>2]);s=Na<(k[u>>2]=s,+o[u>>2]);q=k[(s?ca:da)>>2]|0;k[da>>2]=q;s=k[(s?Da:ca)>>2]|0;k[ca>>2]=s;k[Da>>2]=d;Na=(k[u>>2]=f,+o[u>>2]);d=Na<(k[u>>2]=d,+o[u>>2]);f=k[(d?Z:$)>>2]|0;k[$>>2]=f;d=k[(d?Da:Z)>>2]|0;k[Z>>2]=d;k[Da>>2]=e;Na=(k[u>>2]=g,+o[u>>2]);e=Na<(k[u>>2]=e,+o[u>>2]);g=k[(e?W:X)>>2]|0;k[X>>2]=g;e=k[(e?Da:W)>>2]|0;k[W>>2]=e;k[Da>>2]=Oa;Na=(k[u>>2]=Ba,+o[u>>2]);n=k[(Na<(k[u>>2]=Oa,+o[u>>2])?Da:ba)>>2]|0;Na=(k[u>>2]=e,+o[u>>2]);b=k[(Na<(k[u>>2]=d,+o[u>>2])?W:Z)>>2]|0;k[Z>>2]=b;k[Da>>2]=f;Na=(k[u>>2]=g,+o[u>>2]);g=Na<(k[u>>2]=f,+o[u>>2]);d=k[(g?X:$)>>2]|0;k[$>>2]=d;g=k[(g?Da:X)>>2]|0;k[X>>2]=g;k[Da>>2]=n;Na=(k[u>>2]=n,+o[u>>2]);f=k[((k[u>>2]=h,+o[u>>2])<Na?Da:Y)>>2]|0;k[Da>>2]=q;Na=(k[u>>2]=d,+o[u>>2]);e=k[(Na<(k[u>>2]=q,+o[u>>2])?Da:$)>>2]|0;k[$>>2]=e;Na=(k[u>>2]=s,+o[u>>2]);d=k[((k[u>>2]=b,+o[u>>2])<Na?Z:ca)>>2]|0;k[ca>>2]=d;Na=(k[u>>2]=g,+o[u>>2]);Oa=k[(Na<(k[u>>2]=e,+o[u>>2])?X:$)>>2]|0;k[$>>2]=Oa;k[Da>>2]=Oa;Na=(k[u>>2]=d,+o[u>>2]);d=Na<(k[u>>2]=Oa,+o[u>>2]);Oa=k[(d?ca:$)>>2]|0;k[$>>2]=Oa;d=k[(d?Da:ca)>>2]|0;k[ca>>2]=d;k[Da>>2]=f;Na=(k[u>>2]=Oa,+o[u>>2]);Oa=k[(Na<(k[u>>2]=f,+o[u>>2])?Da:$)>>2]|0;k[$>>2]=Oa;Na=(k[u>>2]=d,+o[u>>2]);k[v+(a<<2)>>2]=k[(Na<(k[u>>2]=Oa,+o[u>>2])?ca:$)>>2];d=a+1|0;if((a|0)<(B|0))a=d;else{t=D;a=d;continue o}}}if((w|0)==(T|0))break;else v=v+(V<<2)|0}}break}case 5:{d=(T|0)==1;if((a|0)==1|d){a=T+a|0;C=a+-1|0;D=d?_:U;B=d?0:U-_|0;x=d?_:V;if((a|0)<=1)break n;y=0-D|0;z=y<<1;A=a+-2|0;v=a+-3|0;w=D<<1;d=f;e=0;while(1){h=(e|0)>0?y:0;n=(e|0)>1?z:h;b=(e|0)<(A|0)?D:0;q=(e|0)<(v|0)?w:b;f=p;g=0;while(1){s=k[f+(n<<2)>>2]|0;k[ea>>2]=s;Oa=k[f+(h<<2)>>2]|0;k[da>>2]=Oa;a=k[f>>2]|0;k[ca>>2]=a;t=k[f+(b<<2)>>2]|0;k[ba>>2]=t;Ca=k[f+(q<<2)>>2]|0;k[$>>2]=Ca;k[Da>>2]=s;Na=(k[u>>2]=Oa,+o[u>>2]);s=Na<(k[u>>2]=s,+o[u>>2]);Oa=k[(s?da:ea)>>2]|0;s=k[(s?Da:da)>>2]|0;k[da>>2]=s;k[Da>>2]=t;Na=(k[u>>2]=Ca,+o[u>>2]);t=Na<(k[u>>2]=t,+o[u>>2]);Ca=k[(t?$:ba)>>2]|0;k[ba>>2]=Ca;t=k[(t?Da:$)>>2]|0;k[$>>2]=t;k[Da>>2]=a;Na=(k[u>>2]=Ca,+o[u>>2]);a=Na<(k[u>>2]=a,+o[u>>2]);Ca=k[(a?ba:ca)>>2]|0;k[ca>>2]=Ca;a=k[(a?Da:ba)>>2]|0;k[ba>>2]=a;k[Da>>2]=a;Na=(k[u>>2]=t,+o[u>>2]);a=Na<(k[u>>2]=a,+o[u>>2]);t=k[(a?$:ba)>>2]|0;k[ba>>2]=t;a=k[(a?Da:$)>>2]|0;k[$>>2]=a;k[Da>>2]=Oa;Na=(k[u>>2]=Ca,+o[u>>2]);Oa=k[(Na<(k[u>>2]=Oa,+o[u>>2])?Da:ca)>>2]|0;k[ca>>2]=Oa;Na=(k[u>>2]=a,+o[u>>2]);a=k[(Na<(k[u>>2]=Oa,+o[u>>2])?$:ca)>>2]|0;k[ca>>2]=a;Na=(k[u>>2]=t,+o[u>>2]);Oa=k[(Na<(k[u>>2]=s,+o[u>>2])?ba:da)>>2]|0;k[Da>>2]=Oa;Na=(k[u>>2]=a,+o[u>>2]);k[d+(g<<2)>>2]=k[(Na<(k[u>>2]=Oa,+o[u>>2])?Da:ca)>>2];g=g+1|0;if((g|0)==(_|0))break;else f=f+4|0}e=e+1|0;if((e|0)>=(C|0))break n;else{p=p+(_<<2)+(B<<2)|0;d=d+(x<<2)|0}}}x=aa(a,_)|0;if((T|0)>0){y=T+-1|0;z=_<<1;A=0-z|0;B=x+~z|0;t=(e|-512)^511;v=x-_|0;w=x-z|0;g=0;while(1){h=g+-2|0;h=p+((aa((h|0)<0?0:h,U)|0)<<2)|0;n=g+-1|0;n=p+((aa((n|0)<0?0:n,U)|0)<<2)|0;b=p+((aa(g,U)|0)<<2)|0;s=g;g=g+1|0;q=p+((aa((y|0)<(g|0)?y:g,U)|0)<<2)|0;s=s+2|0;s=p+((aa((y|0)<(s|0)?y:s,U)|0)<<2)|0;e=i[Ca>>0]&1?z:x;a=0;p:while(1){if((a|0)<(e|0)){do{Oa=a-((a|0)>(S|0)?_:0)|0;ya=(a|0)<(z|0)?Oa:a-z|0;za=((a|0)<(v|0)?_:0)+a|0;xa=(a|0)<(w|0)?a+z|0:za;k[ea>>2]=k[h+(ya<<2)>>2];Aa=k[h+(Oa<<2)>>2]|0;k[da>>2]=Aa;Ba=k[h+(a<<2)>>2]|0;k[ca>>2]=Ba;k[ba>>2]=k[h+(za<<2)>>2];k[$>>2]=k[h+(xa<<2)>>2];k[Z>>2]=k[n+(ya<<2)>>2];k[Y>>2]=k[n+(Oa<<2)>>2];k[X>>2]=k[n+(a<<2)>>2];k[W>>2]=k[n+(za<<2)>>2];k[C>>2]=k[n+(xa<<2)>>2];k[D>>2]=k[b+(ya<<2)>>2];k[E>>2]=k[b+(Oa<<2)>>2];k[F>>2]=k[b+(a<<2)>>2];k[G>>2]=k[b+(za<<2)>>2];k[H>>2]=k[b+(xa<<2)>>2];k[I>>2]=k[q+(ya<<2)>>2];k[J>>2]=k[q+(Oa<<2)>>2];k[K>>2]=k[q+(a<<2)>>2];k[L>>2]=k[q+(za<<2)>>2];k[M>>2]=k[q+(xa<<2)>>2];k[N>>2]=k[s+(ya<<2)>>2];k[O>>2]=k[s+(Oa<<2)>>2];k[P>>2]=k[s+(a<<2)>>2];k[Q>>2]=k[s+(za<<2)>>2];k[R>>2]=k[s+(xa<<2)>>2];k[Da>>2]=Aa;Na=(k[u>>2]=Ba,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);Ba=k[(Aa?ca:da)>>2]|0;k[da>>2]=Ba;Aa=k[(Aa?Da:ca)>>2]|0;k[ca>>2]=Aa;xa=k[ea>>2]|0;k[Da>>2]=xa;Na=(k[u>>2]=Ba,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);Ba=k[(xa?da:ea)>>2]|0;k[ea>>2]=Ba;xa=k[(xa?Da:da)>>2]|0;k[da>>2]=xa;k[Da>>2]=xa;Na=(k[u>>2]=Aa,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);Aa=k[(xa?ca:da)>>2]|0;k[da>>2]=Aa;xa=k[(xa?Da:ca)>>2]|0;k[ca>>2]=xa;za=k[$>>2]|0;k[Da>>2]=za;za=+o[Z>>2]<(k[u>>2]=za,+o[u>>2]);Oa=k[(za?Z:$)>>2]|0;k[$>>2]=Oa;za=k[(za?Da:Z)>>2]|0;k[Z>>2]=za;ya=k[ba>>2]|0;k[Da>>2]=ya;Na=(k[u>>2]=Oa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Oa=k[(ya?$:ba)>>2]|0;k[ba>>2]=Oa;ya=k[(ya?Da:$)>>2]|0;k[$>>2]=ya;k[Da>>2]=ya;Na=(k[u>>2]=za,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);za=k[(ya?Z:$)>>2]|0;k[$>>2]=za;ya=k[(ya?Da:Z)>>2]|0;k[Z>>2]=ya;k[Da>>2]=Ba;Na=(k[u>>2]=Oa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[ea>>2]=k[(Ba?ba:ea)>>2];Ba=k[(Ba?Da:ba)>>2]|0;k[ba>>2]=Ba;k[Da>>2]=xa;Na=(k[u>>2]=ya,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);ya=k[(xa?Z:ca)>>2]|0;k[ca>>2]=ya;k[Z>>2]=k[(xa?Da:Z)>>2];k[Da>>2]=ya;Na=(k[u>>2]=Ba,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Ba=k[(ya?ba:ca)>>2]|0;k[ca>>2]=Ba;ya=k[(ya?Da:ba)>>2]|0;k[ba>>2]=ya;k[Da>>2]=Aa;Na=(k[u>>2]=za,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);za=k[(Aa?$:da)>>2]|0;k[da>>2]=za;Aa=k[(Aa?Da:$)>>2]|0;k[$>>2]=Aa;k[Da>>2]=za;Na=(k[u>>2]=Ba,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);k[da>>2]=k[(za?ca:da)>>2];k[ca>>2]=k[(za?Da:ca)>>2];k[Da>>2]=ya;Na=(k[u>>2]=Aa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);k[ba>>2]=k[(ya?$:ba)>>2];k[$>>2]=k[(ya?Da:$)>>2];ya=k[X>>2]|0;k[Da>>2]=ya;ya=+o[W>>2]<(k[u>>2]=ya,+o[u>>2]);Aa=k[(ya?W:X)>>2]|0;k[X>>2]=Aa;ya=k[(ya?Da:W)>>2]|0;k[W>>2]=ya;za=k[Y>>2]|0;k[Da>>2]=za;Na=(k[u>>2]=Aa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Aa=k[(za?X:Y)>>2]|0;k[Y>>2]=Aa;za=k[(za?Da:X)>>2]|0;k[X>>2]=za;k[Da>>2]=za;Na=(k[u>>2]=ya,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);ya=k[(za?W:X)>>2]|0;k[X>>2]=ya;za=k[(za?Da:W)>>2]|0;k[W>>2]=za;Ba=k[D>>2]|0;k[Da>>2]=Ba;Ba=+o[E>>2]<(k[u>>2]=Ba,+o[u>>2]);xa=k[(Ba?E:D)>>2]|0;k[D>>2]=xa;Ba=k[(Ba?Da:E)>>2]|0;k[E>>2]=Ba;Oa=k[C>>2]|0;k[Da>>2]=Oa;Na=(k[u>>2]=xa,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);xa=k[(Oa?D:C)>>2]|0;k[C>>2]=xa;Oa=k[(Oa?Da:D)>>2]|0;k[D>>2]=Oa;k[Da>>2]=Oa;Na=(k[u>>2]=Ba,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);Ba=k[(Oa?E:D)>>2]|0;k[D>>2]=Ba;Oa=k[(Oa?Da:E)>>2]|0;k[E>>2]=Oa;k[Da>>2]=Aa;Na=(k[u>>2]=xa,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);xa=k[(Aa?C:Y)>>2]|0;k[Y>>2]=xa;Aa=k[(Aa?Da:C)>>2]|0;k[C>>2]=Aa;k[Da>>2]=za;Na=(k[u>>2]=Oa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Oa=k[(za?E:W)>>2]|0;k[W>>2]=Oa;k[E>>2]=k[(za?Da:E)>>2];k[Da>>2]=Oa;Na=(k[u>>2]=Aa,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);Aa=k[(Oa?C:W)>>2]|0;k[W>>2]=Aa;Oa=k[(Oa?Da:C)>>2]|0;k[C>>2]=Oa;k[Da>>2]=ya;Na=(k[u>>2]=Ba,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Ba=k[(ya?D:X)>>2]|0;k[X>>2]=Ba;ya=k[(ya?Da:D)>>2]|0;k[D>>2]=ya;k[Da>>2]=Ba;Na=(k[u>>2]=Aa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[X>>2]=k[(Ba?W:X)>>2];Ba=k[(Ba?Da:W)>>2]|0;k[W>>2]=Ba;k[Da>>2]=Oa;Na=(k[u>>2]=ya,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);k[C>>2]=k[(Oa?D:C)>>2];Oa=k[(Oa?Da:D)>>2]|0;k[D>>2]=Oa;ya=k[ea>>2]|0;k[Da>>2]=ya;Na=(k[u>>2]=xa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);k[ea>>2]=k[(ya?Y:ea)>>2];ya=k[(ya?Da:Y)>>2]|0;k[Y>>2]=ya;xa=k[$>>2]|0;k[Da>>2]=xa;Na=(k[u>>2]=Oa,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);Oa=k[(xa?D:$)>>2]|0;k[$>>2]=Oa;k[D>>2]=k[(xa?Da:D)>>2];k[Da>>2]=Oa;Na=(k[u>>2]=ya,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);ya=k[(Oa?Y:$)>>2]|0;k[$>>2]=ya;Oa=k[(Oa?Da:Y)>>2]|0;k[Y>>2]=Oa;xa=k[ca>>2]|0;k[Da>>2]=xa;Na=(k[u>>2]=Ba,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);Ba=k[(xa?W:ca)>>2]|0;k[ca>>2]=Ba;xa=k[(xa?Da:W)>>2]|0;k[W>>2]=xa;k[Da>>2]=Ba;Na=(k[u>>2]=ya,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[ca>>2]=k[(Ba?$:ca)>>2];k[$>>2]=k[(Ba?Da:$)>>2];k[Da>>2]=Oa;Na=(k[u>>2]=xa,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);k[Y>>2]=k[(Oa?W:Y)>>2];k[W>>2]=k[(Oa?Da:W)>>2];Oa=k[da>>2]|0;k[Da>>2]=Oa;Oa=+o[X>>2]<(k[u>>2]=Oa,+o[u>>2]);xa=k[(Oa?X:da)>>2]|0;k[da>>2]=xa;Oa=k[(Oa?Da:X)>>2]|0;k[X>>2]=Oa;Ba=k[Z>>2]|0;k[Da>>2]=Ba;Ba=+o[E>>2]<(k[u>>2]=Ba,+o[u>>2]);ya=k[(Ba?E:Z)>>2]|0;k[Z>>2]=ya;k[E>>2]=k[(Ba?Da:E)>>2];k[Da>>2]=ya;Na=(k[u>>2]=Oa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Oa=k[(ya?X:Z)>>2]|0;k[Z>>2]=Oa;ya=k[(ya?Da:X)>>2]|0;k[X>>2]=ya;Ba=k[ba>>2]|0;k[Da>>2]=Ba;Ba=+o[C>>2]<(k[u>>2]=Ba,+o[u>>2]);Aa=k[(Ba?C:ba)>>2]|0;k[ba>>2]=Aa;Ba=k[(Ba?Da:C)>>2]|0;k[C>>2]=Ba;k[Da>>2]=Aa;Na=(k[u>>2]=Oa,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);Oa=k[(Aa?Z:ba)>>2]|0;k[ba>>2]=Oa;Aa=k[(Aa?Da:Z)>>2]|0;k[Z>>2]=Aa;k[Da>>2]=ya;Na=(k[u>>2]=Ba,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Ba=k[(ya?C:X)>>2]|0;k[X>>2]=Ba;ya=k[(ya?Da:C)>>2]|0;k[C>>2]=ya;k[Da>>2]=xa;xa=+o[ca>>2]<(k[u>>2]=xa,+o[u>>2]);k[da>>2]=k[(xa?ca:da)>>2];k[ca>>2]=k[(xa?Da:ca)>>2];k[Da>>2]=Oa;Oa=+o[$>>2]<(k[u>>2]=Oa,+o[u>>2]);k[ba>>2]=k[(Oa?$:ba)>>2];k[$>>2]=k[(Oa?Da:$)>>2];k[Da>>2]=Aa;Aa=+o[Y>>2]<(k[u>>2]=Aa,+o[u>>2]);k[Z>>2]=k[(Aa?Y:Z)>>2];k[Y>>2]=k[(Aa?Da:Y)>>2];k[Da>>2]=Ba;Ba=+o[W>>2]<(k[u>>2]=Ba,+o[u>>2]);k[X>>2]=k[(Ba?W:X)>>2];k[W>>2]=k[(Ba?Da:W)>>2];k[Da>>2]=ya;ya=+o[D>>2]<(k[u>>2]=ya,+o[u>>2]);k[C>>2]=k[(ya?D:C)>>2];k[D>>2]=k[(ya?Da:D)>>2];ya=k[G>>2]|0;k[Da>>2]=ya;ya=+o[H>>2]<(k[u>>2]=ya,+o[u>>2]);Ba=k[(ya?H:G)>>2]|0;k[G>>2]=Ba;ya=k[(ya?Da:H)>>2]|0;k[H>>2]=ya;Aa=k[F>>2]|0;k[Da>>2]=Aa;Na=(k[u>>2]=Ba,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);Ba=k[(Aa?G:F)>>2]|0;k[F>>2]=Ba;Aa=k[(Aa?Da:G)>>2]|0;k[G>>2]=Aa;k[Da>>2]=Aa;Na=(k[u>>2]=ya,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);ya=k[(Aa?H:G)>>2]|0;k[G>>2]=ya;Aa=k[(Aa?Da:H)>>2]|0;k[H>>2]=Aa;Oa=k[J>>2]|0;k[Da>>2]=Oa;Oa=+o[K>>2]<(k[u>>2]=Oa,+o[u>>2]);xa=k[(Oa?K:J)>>2]|0;k[J>>2]=xa;Oa=k[(Oa?Da:K)>>2]|0;k[K>>2]=Oa;za=k[I>>2]|0;k[Da>>2]=za;Na=(k[u>>2]=xa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);xa=k[(za?J:I)>>2]|0;k[I>>2]=xa;za=k[(za?Da:J)>>2]|0;k[J>>2]=za;k[Da>>2]=za;Na=(k[u>>2]=Oa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Oa=k[(za?K:J)>>2]|0;k[J>>2]=Oa;za=k[(za?Da:K)>>2]|0;k[K>>2]=za;k[Da>>2]=Ba;Na=(k[u>>2]=xa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[F>>2]=k[(Ba?I:F)>>2];Ba=k[(Ba?Da:I)>>2]|0;k[I>>2]=Ba;k[Da>>2]=Aa;Na=(k[u>>2]=za,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);za=k[(Aa?K:H)>>2]|0;k[H>>2]=za;k[K>>2]=k[(Aa?Da:K)>>2];k[Da>>2]=za;Na=(k[u>>2]=Ba,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Ba=k[(za?I:H)>>2]|0;k[H>>2]=Ba;za=k[(za?Da:I)>>2]|0;k[I>>2]=za;k[Da>>2]=ya;Na=(k[u>>2]=Oa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Oa=k[(ya?J:G)>>2]|0;k[G>>2]=Oa;ya=k[(ya?Da:J)>>2]|0;k[J>>2]=ya;k[Da>>2]=Oa;Na=(k[u>>2]=Ba,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);k[G>>2]=k[(Oa?H:G)>>2];k[H>>2]=k[(Oa?Da:H)>>2];k[Da>>2]=za;Na=(k[u>>2]=ya,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);k[I>>2]=k[(za?J:I)>>2];k[J>>2]=k[(za?Da:J)>>2];za=k[M>>2]|0;k[Da>>2]=za;za=+o[N>>2]<(k[u>>2]=za,+o[u>>2]);ya=k[(za?N:M)>>2]|0;k[M>>2]=ya;za=k[(za?Da:N)>>2]|0;k[N>>2]=za;Oa=k[L>>2]|0;k[Da>>2]=Oa;Na=(k[u>>2]=ya,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);ya=k[(Oa?M:L)>>2]|0;k[L>>2]=ya;Oa=k[(Oa?Da:M)>>2]|0;k[M>>2]=Oa;k[Da>>2]=Oa;Na=(k[u>>2]=za,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);k[M>>2]=k[(Oa?N:M)>>2];Oa=k[(Oa?Da:N)>>2]|0;k[N>>2]=Oa;za=k[O>>2]|0;k[Da>>2]=za;za=+o[P>>2]<(k[u>>2]=za,+o[u>>2]);Ba=k[(za?P:O)>>2]|0;k[O>>2]=Ba;za=k[(za?Da:P)>>2]|0;k[P>>2]=za;Aa=k[Q>>2]|0;k[Da>>2]=Aa;Aa=+o[R>>2]<(k[u>>2]=Aa,+o[u>>2]);xa=k[(Aa?R:Q)>>2]|0;k[Q>>2]=xa;Aa=k[(Aa?Da:R)>>2]|0;k[R>>2]=Aa;k[Da>>2]=Ba;Na=(k[u>>2]=xa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);xa=k[(Ba?Q:O)>>2]|0;k[O>>2]=xa;Ba=k[(Ba?Da:Q)>>2]|0;k[Q>>2]=Ba;k[Da>>2]=za;Na=(k[u>>2]=Aa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Aa=k[(za?R:P)>>2]|0;k[P>>2]=Aa;za=k[(za?Da:R)>>2]|0;k[R>>2]=za;k[Da>>2]=Aa;Na=(k[u>>2]=Ba,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);Ba=k[(Aa?Q:P)>>2]|0;k[P>>2]=Ba;Aa=k[(Aa?Da:Q)>>2]|0;k[Q>>2]=Aa;k[Da>>2]=ya;Na=(k[u>>2]=xa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);k[L>>2]=k[(ya?O:L)>>2];ya=k[(ya?Da:O)>>2]|0;k[O>>2]=ya;k[Da>>2]=Oa;Na=(k[u>>2]=Aa,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);Aa=k[(Oa?Q:N)>>2]|0;k[N>>2]=Aa;Oa=k[(Oa?Da:Q)>>2]|0;k[Q>>2]=Oa;k[Da>>2]=Aa;Na=(k[u>>2]=ya,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);ya=k[(Aa?O:N)>>2]|0;k[N>>2]=ya;Aa=k[(Aa?Da:O)>>2]|0;k[O>>2]=Aa;xa=k[M>>2]|0;k[Da>>2]=xa;Na=(k[u>>2]=Ba,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);Ba=k[(xa?P:M)>>2]|0;k[M>>2]=Ba;xa=k[(xa?Da:P)>>2]|0;k[P>>2]=xa;k[Da>>2]=xa;Na=(k[u>>2]=za,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);za=k[(xa?R:P)>>2]|0;k[P>>2]=za;xa=k[(xa?Da:R)>>2]|0;k[R>>2]=xa;k[Da>>2]=Ba;Na=(k[u>>2]=ya,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[M>>2]=k[(Ba?N:M)>>2];Ba=k[(Ba?Da:N)>>2]|0;k[N>>2]=Ba;k[Da>>2]=Aa;Na=(k[u>>2]=za,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);k[O>>2]=k[(Aa?P:O)>>2];Aa=k[(Aa?Da:P)>>2]|0;k[P>>2]=Aa;k[Da>>2]=Oa;Na=(k[u>>2]=xa,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);k[Q>>2]=k[(Oa?R:Q)>>2];Oa=k[(Oa?Da:R)>>2]|0;k[R>>2]=Oa;xa=k[F>>2]|0;k[Da>>2]=xa;xa=+o[L>>2]<(k[u>>2]=xa,+o[u>>2]);k[F>>2]=k[(xa?L:F)>>2];xa=k[(xa?Da:L)>>2]|0;k[L>>2]=xa;za=k[J>>2]|0;k[Da>>2]=za;Na=(k[u>>2]=Aa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Aa=k[(za?P:J)>>2]|0;k[J>>2]=Aa;za=k[(za?Da:P)>>2]|0;k[P>>2]=za;k[Da>>2]=Aa;Na=(k[u>>2]=xa,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);xa=k[(Aa?L:J)>>2]|0;k[J>>2]=xa;Aa=k[(Aa?Da:L)>>2]|0;k[L>>2]=Aa;ya=k[H>>2]|0;k[Da>>2]=ya;Na=(k[u>>2]=Ba,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Ba=k[(ya?N:H)>>2]|0;k[H>>2]=Ba;ya=k[(ya?Da:N)>>2]|0;k[N>>2]=ya;k[Da>>2]=ya;Na=(k[u>>2]=Oa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Oa=k[(ya?R:N)>>2]|0;k[N>>2]=Oa;ya=k[(ya?Da:R)>>2]|0;k[R>>2]=ya;k[Da>>2]=Ba;Na=(k[u>>2]=xa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[H>>2]=k[(Ba?J:H)>>2];k[J>>2]=k[(Ba?Da:J)>>2];k[Da>>2]=Aa;Na=(k[u>>2]=Oa,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);k[L>>2]=k[(Aa?N:L)>>2];k[N>>2]=k[(Aa?Da:N)>>2];k[Da>>2]=za;Na=(k[u>>2]=ya,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);k[P>>2]=k[(za?R:P)>>2];k[R>>2]=k[(za?Da:R)>>2];za=k[G>>2]|0;k[Da>>2]=za;za=+o[M>>2]<(k[u>>2]=za,+o[u>>2]);ya=k[(za?M:G)>>2]|0;k[G>>2]=ya;za=k[(za?Da:M)>>2]|0;k[M>>2]=za;Aa=k[K>>2]|0;k[Da>>2]=Aa;Aa=+o[Q>>2]<(k[u>>2]=Aa,+o[u>>2]);Oa=k[(Aa?Q:K)>>2]|0;k[K>>2]=Oa;k[Q>>2]=k[(Aa?Da:Q)>>2];k[Da>>2]=Oa;Na=(k[u>>2]=za,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);za=k[(Oa?M:K)>>2]|0;k[K>>2]=za;Oa=k[(Oa?Da:M)>>2]|0;k[M>>2]=Oa;Aa=k[I>>2]|0;k[Da>>2]=Aa;Aa=+o[O>>2]<(k[u>>2]=Aa,+o[u>>2]);Ba=k[(Aa?O:I)>>2]|0;k[I>>2]=Ba;Aa=k[(Aa?Da:O)>>2]|0;k[O>>2]=Aa;k[Da>>2]=Ba;Na=(k[u>>2]=za,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);za=k[(Ba?K:I)>>2]|0;k[I>>2]=za;Ba=k[(Ba?Da:K)>>2]|0;k[K>>2]=Ba;k[Da>>2]=Oa;Na=(k[u>>2]=Aa,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);Aa=k[(Oa?O:M)>>2]|0;k[M>>2]=Aa;Oa=k[(Oa?Da:O)>>2]|0;k[O>>2]=Oa;k[Da>>2]=ya;ya=+o[H>>2]<(k[u>>2]=ya,+o[u>>2]);k[G>>2]=k[(ya?H:G)>>2];k[H>>2]=k[(ya?Da:H)>>2];k[Da>>2]=za;za=+o[J>>2]<(k[u>>2]=za,+o[u>>2]);k[I>>2]=k[(za?J:I)>>2];k[J>>2]=k[(za?Da:J)>>2];k[Da>>2]=Ba;Ba=+o[L>>2]<(k[u>>2]=Ba,+o[u>>2]);k[K>>2]=k[(Ba?L:K)>>2];k[L>>2]=k[(Ba?Da:L)>>2];k[Da>>2]=Aa;Aa=+o[N>>2]<(k[u>>2]=Aa,+o[u>>2]);k[M>>2]=k[(Aa?N:M)>>2];Aa=k[(Aa?Da:N)>>2]|0;k[N>>2]=Aa;k[Da>>2]=Oa;Oa=+o[P>>2]<(k[u>>2]=Oa,+o[u>>2]);k[O>>2]=k[(Oa?P:O)>>2];k[P>>2]=k[(Oa?Da:P)>>2];Oa=k[Q>>2]|0;k[Da>>2]=Oa;Oa=+o[R>>2]<(k[u>>2]=Oa,+o[u>>2]);k[Q>>2]=k[(Oa?R:Q)>>2];Oa=k[(Oa?Da:R)>>2]|0;k[R>>2]=Oa;Ba=k[ea>>2]|0;k[Da>>2]=Ba;Ba=+o[F>>2]<(k[u>>2]=Ba,+o[u>>2]);k[ea>>2]=k[(Ba?F:ea)>>2];Ba=k[(Ba?Da:F)>>2]|0;k[F>>2]=Ba;za=k[W>>2]|0;k[Da>>2]=za;Na=(k[u>>2]=Aa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Aa=k[(za?N:W)>>2]|0;k[W>>2]=Aa;k[N>>2]=k[(za?Da:N)>>2];k[Da>>2]=Aa;Na=(k[u>>2]=Ba,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);k[W>>2]=k[(Aa?F:W)>>2];Aa=k[(Aa?Da:F)>>2]|0;k[F>>2]=Aa;Ba=k[$>>2]|0;k[Da>>2]=Ba;Ba=+o[J>>2]<(k[u>>2]=Ba,+o[u>>2]);k[$>>2]=k[(Ba?J:$)>>2];Ba=k[(Ba?Da:J)>>2]|0;k[J>>2]=Ba;k[Da>>2]=Ba;Na=(k[u>>2]=Oa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);Oa=k[(Ba?R:J)>>2]|0;k[J>>2]=Oa;k[R>>2]=k[(Ba?Da:R)>>2];k[Da>>2]=Aa;Na=(k[u>>2]=Oa,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);Oa=k[(Aa?J:F)>>2]|0;k[F>>2]=Oa;k[J>>2]=k[(Aa?Da:J)>>2];Aa=k[ca>>2]|0;k[Da>>2]=Aa;Aa=+o[H>>2]<(k[u>>2]=Aa,+o[u>>2]);k[ca>>2]=k[(Aa?H:ca)>>2];Aa=k[(Aa?Da:H)>>2]|0;k[H>>2]=Aa;Ba=k[D>>2]|0;k[Da>>2]=Ba;Ba=+o[P>>2]<(k[u>>2]=Ba,+o[u>>2]);za=k[(Ba?P:D)>>2]|0;k[D>>2]=za;k[P>>2]=k[(Ba?Da:P)>>2];k[Da>>2]=za;Na=(k[u>>2]=Aa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Aa=k[(za?H:D)>>2]|0;k[D>>2]=Aa;k[H>>2]=k[(za?Da:H)>>2];za=k[Y>>2]|0;k[Da>>2]=za;za=+o[L>>2]<(k[u>>2]=za,+o[u>>2]);Ba=k[(za?L:Y)>>2]|0;k[Y>>2]=Ba;k[L>>2]=k[(za?Da:L)>>2];k[Da>>2]=Ba;Na=(k[u>>2]=Aa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[Y>>2]=k[(Ba?D:Y)>>2];Ba=k[(Ba?Da:D)>>2]|0;k[D>>2]=Ba;k[Da>>2]=Ba;Na=(k[u>>2]=Oa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[D>>2]=k[(Ba?F:D)>>2];k[F>>2]=k[(Ba?Da:F)>>2];Ba=k[da>>2]|0;k[Da>>2]=Ba;Ba=+o[G>>2]<(k[u>>2]=Ba,+o[u>>2]);k[da>>2]=k[(Ba?G:da)>>2];Ba=k[(Ba?Da:G)>>2]|0;k[G>>2]=Ba;Oa=k[(+o[O>>2]<+o[C>>2]?O:C)>>2]|0;k[Da>>2]=Oa;Na=(k[u>>2]=Ba,+o[u>>2]);d=k[(Na<(k[u>>2]=Oa,+o[u>>2])?Da:G)>>2]|0;k[G>>2]=d;Oa=k[Z>>2]|0;k[Da>>2]=Oa;Oa=k[(+o[K>>2]<(k[u>>2]=Oa,+o[u>>2])?Da:K)>>2]|0;k[K>>2]=Oa;Na=(k[u>>2]=Oa,+o[u>>2]);d=k[(Na<(k[u>>2]=d,+o[u>>2])?K:G)>>2]|0;k[G>>2]=d;Oa=k[ba>>2]|0;k[Da>>2]=Oa;Ba=k[(+o[I>>2]<(k[u>>2]=Oa,+o[u>>2])?Da:I)>>2]|0;k[I>>2]=Ba;Oa=k[(+o[Q>>2]<+o[E>>2]?Q:E)>>2]|0;k[E>>2]=Oa;Na=(k[u>>2]=Ba,+o[u>>2]);Ba=k[(Na<(k[u>>2]=Oa,+o[u>>2])?I:E)>>2]|0;k[E>>2]=Ba;Oa=k[(+o[M>>2]<+o[X>>2]?M:X)>>2]|0;k[Da>>2]=Oa;Na=(k[u>>2]=Ba,+o[u>>2]);Oa=k[(Na<(k[u>>2]=Oa,+o[u>>2])?Da:E)>>2]|0;k[E>>2]=Oa;Na=(k[u>>2]=d,+o[u>>2]);Oa=k[(Na<(k[u>>2]=Oa,+o[u>>2])?G:E)>>2]|0;k[Da>>2]=Oa;k[f+(a<<2)>>2]=k[(+o[F>>2]<(k[u>>2]=Oa,+o[u>>2])?Da:F)>>2];a=a+1|0}while((a|0)!=(e|0));a=e}if((e|0)==(x|0))break;if((a|0)>(B|0)){e=x;continue}while(1){xa=h+(a<<2)|0;k[ea>>2]=k[xa+(A<<2)>>2];Aa=k[xa+(t<<2)>>2]|0;k[da>>2]=Aa;Ba=k[xa>>2]|0;k[ca>>2]=Ba;k[ba>>2]=k[xa+(_<<2)>>2];k[$>>2]=k[xa+(z<<2)>>2];xa=n+(a<<2)|0;k[Z>>2]=k[xa+(A<<2)>>2];k[Y>>2]=k[xa+(t<<2)>>2];k[X>>2]=k[xa>>2];k[W>>2]=k[xa+(_<<2)>>2];k[C>>2]=k[xa+(z<<2)>>2];xa=b+(a<<2)|0;k[D>>2]=k[xa+(A<<2)>>2];k[E>>2]=k[xa+(t<<2)>>2];k[F>>2]=k[xa>>2];k[G>>2]=k[xa+(_<<2)>>2];k[H>>2]=k[xa+(z<<2)>>2];xa=q+(a<<2)|0;k[I>>2]=k[xa+(A<<2)>>2];k[J>>2]=k[xa+(t<<2)>>2];k[K>>2]=k[xa>>2];k[L>>2]=k[xa+(_<<2)>>2];k[M>>2]=k[xa+(z<<2)>>2];xa=s+(a<<2)|0;k[N>>2]=k[xa+(A<<2)>>2];k[O>>2]=k[xa+(t<<2)>>2];k[P>>2]=k[xa>>2];k[Q>>2]=k[xa+(_<<2)>>2];k[R>>2]=k[xa+(z<<2)>>2];k[Da>>2]=Aa;Na=(k[u>>2]=Ba,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);Ba=k[(Aa?ca:da)>>2]|0;k[da>>2]=Ba;Aa=k[(Aa?Da:ca)>>2]|0;k[ca>>2]=Aa;xa=k[ea>>2]|0;k[Da>>2]=xa;Na=(k[u>>2]=Ba,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);Ba=k[(xa?da:ea)>>2]|0;k[ea>>2]=Ba;xa=k[(xa?Da:da)>>2]|0;k[da>>2]=xa;k[Da>>2]=xa;Na=(k[u>>2]=Aa,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);Aa=k[(xa?ca:da)>>2]|0;k[da>>2]=Aa;xa=k[(xa?Da:ca)>>2]|0;k[ca>>2]=xa;za=k[$>>2]|0;k[Da>>2]=za;za=+o[Z>>2]<(k[u>>2]=za,+o[u>>2]);Oa=k[(za?Z:$)>>2]|0;k[$>>2]=Oa;za=k[(za?Da:Z)>>2]|0;k[Z>>2]=za;ya=k[ba>>2]|0;k[Da>>2]=ya;Na=(k[u>>2]=Oa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Oa=k[(ya?$:ba)>>2]|0;k[ba>>2]=Oa;ya=k[(ya?Da:$)>>2]|0;k[$>>2]=ya;k[Da>>2]=ya;Na=(k[u>>2]=za,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);za=k[(ya?Z:$)>>2]|0;k[$>>2]=za;ya=k[(ya?Da:Z)>>2]|0;k[Z>>2]=ya;k[Da>>2]=Ba;Na=(k[u>>2]=Oa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[ea>>2]=k[(Ba?ba:ea)>>2];Ba=k[(Ba?Da:ba)>>2]|0;k[ba>>2]=Ba;k[Da>>2]=xa;Na=(k[u>>2]=ya,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);ya=k[(xa?Z:ca)>>2]|0;k[ca>>2]=ya;k[Z>>2]=k[(xa?Da:Z)>>2];k[Da>>2]=ya;Na=(k[u>>2]=Ba,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Ba=k[(ya?ba:ca)>>2]|0;k[ca>>2]=Ba;ya=k[(ya?Da:ba)>>2]|0;k[ba>>2]=ya;k[Da>>2]=Aa;Na=(k[u>>2]=za,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);za=k[(Aa?$:da)>>2]|0;k[da>>2]=za;Aa=k[(Aa?Da:$)>>2]|0;k[$>>2]=Aa;k[Da>>2]=za;Na=(k[u>>2]=Ba,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);k[da>>2]=k[(za?ca:da)>>2];k[ca>>2]=k[(za?Da:ca)>>2];k[Da>>2]=ya;Na=(k[u>>2]=Aa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);k[ba>>2]=k[(ya?$:ba)>>2];k[$>>2]=k[(ya?Da:$)>>2];ya=k[X>>2]|0;k[Da>>2]=ya;ya=+o[W>>2]<(k[u>>2]=ya,+o[u>>2]);Aa=k[(ya?W:X)>>2]|0;k[X>>2]=Aa;ya=k[(ya?Da:W)>>2]|0;k[W>>2]=ya;za=k[Y>>2]|0;k[Da>>2]=za;Na=(k[u>>2]=Aa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Aa=k[(za?X:Y)>>2]|0;k[Y>>2]=Aa;za=k[(za?Da:X)>>2]|0;k[X>>2]=za;k[Da>>2]=za;Na=(k[u>>2]=ya,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);ya=k[(za?W:X)>>2]|0;k[X>>2]=ya;za=k[(za?Da:W)>>2]|0;k[W>>2]=za;Ba=k[D>>2]|0;k[Da>>2]=Ba;Ba=+o[E>>2]<(k[u>>2]=Ba,+o[u>>2]);xa=k[(Ba?E:D)>>2]|0;k[D>>2]=xa;Ba=k[(Ba?Da:E)>>2]|0;k[E>>2]=Ba;Oa=k[C>>2]|0;k[Da>>2]=Oa;Na=(k[u>>2]=xa,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);xa=k[(Oa?D:C)>>2]|0;k[C>>2]=xa;Oa=k[(Oa?Da:D)>>2]|0;k[D>>2]=Oa;k[Da>>2]=Oa;Na=(k[u>>2]=Ba,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);Ba=k[(Oa?E:D)>>2]|0;k[D>>2]=Ba;Oa=k[(Oa?Da:E)>>2]|0;k[E>>2]=Oa;k[Da>>2]=Aa;Na=(k[u>>2]=xa,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);xa=k[(Aa?C:Y)>>2]|0;k[Y>>2]=xa;Aa=k[(Aa?Da:C)>>2]|0;k[C>>2]=Aa;k[Da>>2]=za;Na=(k[u>>2]=Oa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Oa=k[(za?E:W)>>2]|0;k[W>>2]=Oa;k[E>>2]=k[(za?Da:E)>>2];k[Da>>2]=Oa;Na=(k[u>>2]=Aa,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);Aa=k[(Oa?C:W)>>2]|0;k[W>>2]=Aa;Oa=k[(Oa?Da:C)>>2]|0;k[C>>2]=Oa;k[Da>>2]=ya;Na=(k[u>>2]=Ba,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Ba=k[(ya?D:X)>>2]|0;k[X>>2]=Ba;ya=k[(ya?Da:D)>>2]|0;k[D>>2]=ya;k[Da>>2]=Ba;Na=(k[u>>2]=Aa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[X>>2]=k[(Ba?W:X)>>2];Ba=k[(Ba?Da:W)>>2]|0;k[W>>2]=Ba;k[Da>>2]=Oa;Na=(k[u>>2]=ya,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);k[C>>2]=k[(Oa?D:C)>>2];Oa=k[(Oa?Da:D)>>2]|0;k[D>>2]=Oa;ya=k[ea>>2]|0;k[Da>>2]=ya;Na=(k[u>>2]=xa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);k[ea>>2]=k[(ya?Y:ea)>>2];ya=k[(ya?Da:Y)>>2]|0;k[Y>>2]=ya;xa=k[$>>2]|0;k[Da>>2]=xa;Na=(k[u>>2]=Oa,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);Oa=k[(xa?D:$)>>2]|0;k[$>>2]=Oa;k[D>>2]=k[(xa?Da:D)>>2];k[Da>>2]=Oa;Na=(k[u>>2]=ya,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);ya=k[(Oa?Y:$)>>2]|0;k[$>>2]=ya;Oa=k[(Oa?Da:Y)>>2]|0;k[Y>>2]=Oa;xa=k[ca>>2]|0;k[Da>>2]=xa;Na=(k[u>>2]=Ba,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);Ba=k[(xa?W:ca)>>2]|0;k[ca>>2]=Ba;xa=k[(xa?Da:W)>>2]|0;k[W>>2]=xa;k[Da>>2]=Ba;Na=(k[u>>2]=ya,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[ca>>2]=k[(Ba?$:ca)>>2];k[$>>2]=k[(Ba?Da:$)>>2];k[Da>>2]=Oa;Na=(k[u>>2]=xa,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);k[Y>>2]=k[(Oa?W:Y)>>2];k[W>>2]=k[(Oa?Da:W)>>2];Oa=k[da>>2]|0;k[Da>>2]=Oa;Oa=+o[X>>2]<(k[u>>2]=Oa,+o[u>>2]);xa=k[(Oa?X:da)>>2]|0;k[da>>2]=xa;Oa=k[(Oa?Da:X)>>2]|0;k[X>>2]=Oa;Ba=k[Z>>2]|0;k[Da>>2]=Ba;Ba=+o[E>>2]<(k[u>>2]=Ba,+o[u>>2]);ya=k[(Ba?E:Z)>>2]|0;k[Z>>2]=ya;k[E>>2]=k[(Ba?Da:E)>>2];k[Da>>2]=ya;Na=(k[u>>2]=Oa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Oa=k[(ya?X:Z)>>2]|0;k[Z>>2]=Oa;ya=k[(ya?Da:X)>>2]|0;k[X>>2]=ya;Ba=k[ba>>2]|0;k[Da>>2]=Ba;Ba=+o[C>>2]<(k[u>>2]=Ba,+o[u>>2]);Aa=k[(Ba?C:ba)>>2]|0;k[ba>>2]=Aa;Ba=k[(Ba?Da:C)>>2]|0;k[C>>2]=Ba;k[Da>>2]=Aa;Na=(k[u>>2]=Oa,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);Oa=k[(Aa?Z:ba)>>2]|0;k[ba>>2]=Oa;Aa=k[(Aa?Da:Z)>>2]|0;k[Z>>2]=Aa;k[Da>>2]=ya;Na=(k[u>>2]=Ba,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Ba=k[(ya?C:X)>>2]|0;k[X>>2]=Ba;ya=k[(ya?Da:C)>>2]|0;k[C>>2]=ya;k[Da>>2]=xa;xa=+o[ca>>2]<(k[u>>2]=xa,+o[u>>2]);k[da>>2]=k[(xa?ca:da)>>2];k[ca>>2]=k[(xa?Da:ca)>>2];k[Da>>2]=Oa;Oa=+o[$>>2]<(k[u>>2]=Oa,+o[u>>2]);k[ba>>2]=k[(Oa?$:ba)>>2];k[$>>2]=k[(Oa?Da:$)>>2];k[Da>>2]=Aa;Aa=+o[Y>>2]<(k[u>>2]=Aa,+o[u>>2]);k[Z>>2]=k[(Aa?Y:Z)>>2];k[Y>>2]=k[(Aa?Da:Y)>>2];k[Da>>2]=Ba;Ba=+o[W>>2]<(k[u>>2]=Ba,+o[u>>2]);k[X>>2]=k[(Ba?W:X)>>2];k[W>>2]=k[(Ba?Da:W)>>2];k[Da>>2]=ya;ya=+o[D>>2]<(k[u>>2]=ya,+o[u>>2]);k[C>>2]=k[(ya?D:C)>>2];k[D>>2]=k[(ya?Da:D)>>2];ya=k[G>>2]|0;k[Da>>2]=ya;ya=+o[H>>2]<(k[u>>2]=ya,+o[u>>2]);Ba=k[(ya?H:G)>>2]|0;k[G>>2]=Ba;ya=k[(ya?Da:H)>>2]|0;k[H>>2]=ya;Aa=k[F>>2]|0;k[Da>>2]=Aa;Na=(k[u>>2]=Ba,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);Ba=k[(Aa?G:F)>>2]|0;k[F>>2]=Ba;Aa=k[(Aa?Da:G)>>2]|0;k[G>>2]=Aa;k[Da>>2]=Aa;Na=(k[u>>2]=ya,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);ya=k[(Aa?H:G)>>2]|0;k[G>>2]=ya;Aa=k[(Aa?Da:H)>>2]|0;k[H>>2]=Aa;Oa=k[J>>2]|0;k[Da>>2]=Oa;Oa=+o[K>>2]<(k[u>>2]=Oa,+o[u>>2]);xa=k[(Oa?K:J)>>2]|0;k[J>>2]=xa;Oa=k[(Oa?Da:K)>>2]|0;k[K>>2]=Oa;za=k[I>>2]|0;k[Da>>2]=za;Na=(k[u>>2]=xa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);xa=k[(za?J:I)>>2]|0;k[I>>2]=xa;za=k[(za?Da:J)>>2]|0;k[J>>2]=za;k[Da>>2]=za;Na=(k[u>>2]=Oa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Oa=k[(za?K:J)>>2]|0;k[J>>2]=Oa;za=k[(za?Da:K)>>2]|0;k[K>>2]=za;k[Da>>2]=Ba;Na=(k[u>>2]=xa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[F>>2]=k[(Ba?I:F)>>2];Ba=k[(Ba?Da:I)>>2]|0;k[I>>2]=Ba;k[Da>>2]=Aa;Na=(k[u>>2]=za,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);za=k[(Aa?K:H)>>2]|0;k[H>>2]=za;k[K>>2]=k[(Aa?Da:K)>>2];k[Da>>2]=za;Na=(k[u>>2]=Ba,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Ba=k[(za?I:H)>>2]|0;k[H>>2]=Ba;za=k[(za?Da:I)>>2]|0;k[I>>2]=za;k[Da>>2]=ya;Na=(k[u>>2]=Oa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Oa=k[(ya?J:G)>>2]|0;k[G>>2]=Oa;ya=k[(ya?Da:J)>>2]|0;k[J>>2]=ya;k[Da>>2]=Oa;Na=(k[u>>2]=Ba,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);k[G>>2]=k[(Oa?H:G)>>2];k[H>>2]=k[(Oa?Da:H)>>2];k[Da>>2]=za;Na=(k[u>>2]=ya,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);k[I>>2]=k[(za?J:I)>>2];k[J>>2]=k[(za?Da:J)>>2];za=k[M>>2]|0;k[Da>>2]=za;za=+o[N>>2]<(k[u>>2]=za,+o[u>>2]);ya=k[(za?N:M)>>2]|0;k[M>>2]=ya;za=k[(za?Da:N)>>2]|0;k[N>>2]=za;Oa=k[L>>2]|0;k[Da>>2]=Oa;Na=(k[u>>2]=ya,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);ya=k[(Oa?M:L)>>2]|0;k[L>>2]=ya;Oa=k[(Oa?Da:M)>>2]|0;k[M>>2]=Oa;k[Da>>2]=Oa;Na=(k[u>>2]=za,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);k[M>>2]=k[(Oa?N:M)>>2];Oa=k[(Oa?Da:N)>>2]|0;k[N>>2]=Oa;za=k[O>>2]|0;k[Da>>2]=za;za=+o[P>>2]<(k[u>>2]=za,+o[u>>2]);Ba=k[(za?P:O)>>2]|0;k[O>>2]=Ba;za=k[(za?Da:P)>>2]|0;k[P>>2]=za;Aa=k[Q>>2]|0;k[Da>>2]=Aa;Aa=+o[R>>2]<(k[u>>2]=Aa,+o[u>>2]);xa=k[(Aa?R:Q)>>2]|0;k[Q>>2]=xa;Aa=k[(Aa?Da:R)>>2]|0;k[R>>2]=Aa;k[Da>>2]=Ba;Na=(k[u>>2]=xa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);xa=k[(Ba?Q:O)>>2]|0;k[O>>2]=xa;Ba=k[(Ba?Da:Q)>>2]|0;k[Q>>2]=Ba;k[Da>>2]=za;Na=(k[u>>2]=Aa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Aa=k[(za?R:P)>>2]|0;k[P>>2]=Aa;za=k[(za?Da:R)>>2]|0;k[R>>2]=za;k[Da>>2]=Aa;Na=(k[u>>2]=Ba,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);Ba=k[(Aa?Q:P)>>2]|0;k[P>>2]=Ba;Aa=k[(Aa?Da:Q)>>2]|0;k[Q>>2]=Aa;k[Da>>2]=ya;Na=(k[u>>2]=xa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);k[L>>2]=k[(ya?O:L)>>2];ya=k[(ya?Da:O)>>2]|0;k[O>>2]=ya;k[Da>>2]=Oa;Na=(k[u>>2]=Aa,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);Aa=k[(Oa?Q:N)>>2]|0;k[N>>2]=Aa;Oa=k[(Oa?Da:Q)>>2]|0;k[Q>>2]=Oa;k[Da>>2]=Aa;Na=(k[u>>2]=ya,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);ya=k[(Aa?O:N)>>2]|0;k[N>>2]=ya;Aa=k[(Aa?Da:O)>>2]|0;k[O>>2]=Aa;xa=k[M>>2]|0;k[Da>>2]=xa;Na=(k[u>>2]=Ba,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);Ba=k[(xa?P:M)>>2]|0;k[M>>2]=Ba;xa=k[(xa?Da:P)>>2]|0;k[P>>2]=xa;k[Da>>2]=xa;Na=(k[u>>2]=za,+o[u>>2]);xa=Na<(k[u>>2]=xa,+o[u>>2]);za=k[(xa?R:P)>>2]|0;k[P>>2]=za;xa=k[(xa?Da:R)>>2]|0;k[R>>2]=xa;k[Da>>2]=Ba;Na=(k[u>>2]=ya,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[M>>2]=k[(Ba?N:M)>>2];Ba=k[(Ba?Da:N)>>2]|0;k[N>>2]=Ba;k[Da>>2]=Aa;Na=(k[u>>2]=za,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);k[O>>2]=k[(Aa?P:O)>>2];Aa=k[(Aa?Da:P)>>2]|0;k[P>>2]=Aa;k[Da>>2]=Oa;Na=(k[u>>2]=xa,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);k[Q>>2]=k[(Oa?R:Q)>>2];Oa=k[(Oa?Da:R)>>2]|0;k[R>>2]=Oa;xa=k[F>>2]|0;k[Da>>2]=xa;xa=+o[L>>2]<(k[u>>2]=xa,+o[u>>2]);k[F>>2]=k[(xa?L:F)>>2];xa=k[(xa?Da:L)>>2]|0;k[L>>2]=xa;za=k[J>>2]|0;k[Da>>2]=za;Na=(k[u>>2]=Aa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Aa=k[(za?P:J)>>2]|0;k[J>>2]=Aa;za=k[(za?Da:P)>>2]|0;k[P>>2]=za;k[Da>>2]=Aa;Na=(k[u>>2]=xa,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);xa=k[(Aa?L:J)>>2]|0;k[J>>2]=xa;Aa=k[(Aa?Da:L)>>2]|0;k[L>>2]=Aa;ya=k[H>>2]|0;k[Da>>2]=ya;Na=(k[u>>2]=Ba,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Ba=k[(ya?N:H)>>2]|0;k[H>>2]=Ba;ya=k[(ya?Da:N)>>2]|0;k[N>>2]=ya;k[Da>>2]=ya;Na=(k[u>>2]=Oa,+o[u>>2]);ya=Na<(k[u>>2]=ya,+o[u>>2]);Oa=k[(ya?R:N)>>2]|0;k[N>>2]=Oa;ya=k[(ya?Da:R)>>2]|0;k[R>>2]=ya;k[Da>>2]=Ba;Na=(k[u>>2]=xa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[H>>2]=k[(Ba?J:H)>>2];k[J>>2]=k[(Ba?Da:J)>>2];k[Da>>2]=Aa;Na=(k[u>>2]=Oa,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);k[L>>2]=k[(Aa?N:L)>>2];k[N>>2]=k[(Aa?Da:N)>>2];k[Da>>2]=za;Na=(k[u>>2]=ya,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);k[P>>2]=k[(za?R:P)>>2];k[R>>2]=k[(za?Da:R)>>2];za=k[G>>2]|0;k[Da>>2]=za;za=+o[M>>2]<(k[u>>2]=za,+o[u>>2]);ya=k[(za?M:G)>>2]|0;k[G>>2]=ya;za=k[(za?Da:M)>>2]|0;k[M>>2]=za;Aa=k[K>>2]|0;k[Da>>2]=Aa;Aa=+o[Q>>2]<(k[u>>2]=Aa,+o[u>>2]);Oa=k[(Aa?Q:K)>>2]|0;k[K>>2]=Oa;k[Q>>2]=k[(Aa?Da:Q)>>2];k[Da>>2]=Oa;Na=(k[u>>2]=za,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);za=k[(Oa?M:K)>>2]|0;k[K>>2]=za;Oa=k[(Oa?Da:M)>>2]|0;k[M>>2]=Oa;Aa=k[I>>2]|0;k[Da>>2]=Aa;Aa=+o[O>>2]<(k[u>>2]=Aa,+o[u>>2]);Ba=k[(Aa?O:I)>>2]|0;k[I>>2]=Ba;Aa=k[(Aa?Da:O)>>2]|0;k[O>>2]=Aa;k[Da>>2]=Ba;Na=(k[u>>2]=za,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);za=k[(Ba?K:I)>>2]|0;k[I>>2]=za;Ba=k[(Ba?Da:K)>>2]|0;k[K>>2]=Ba;k[Da>>2]=Oa;Na=(k[u>>2]=Aa,+o[u>>2]);Oa=Na<(k[u>>2]=Oa,+o[u>>2]);Aa=k[(Oa?O:M)>>2]|0;k[M>>2]=Aa;Oa=k[(Oa?Da:O)>>2]|0;k[O>>2]=Oa;k[Da>>2]=ya;ya=+o[H>>2]<(k[u>>2]=ya,+o[u>>2]);k[G>>2]=k[(ya?H:G)>>2];k[H>>2]=k[(ya?Da:H)>>2];k[Da>>2]=za;za=+o[J>>2]<(k[u>>2]=za,+o[u>>2]);k[I>>2]=k[(za?J:I)>>2];k[J>>2]=k[(za?Da:J)>>2];k[Da>>2]=Ba;Ba=+o[L>>2]<(k[u>>2]=Ba,+o[u>>2]);k[K>>2]=k[(Ba?L:K)>>2];k[L>>2]=k[(Ba?Da:L)>>2];k[Da>>2]=Aa;Aa=+o[N>>2]<(k[u>>2]=Aa,+o[u>>2]);k[M>>2]=k[(Aa?N:M)>>2];Aa=k[(Aa?Da:N)>>2]|0;k[N>>2]=Aa;k[Da>>2]=Oa;Oa=+o[P>>2]<(k[u>>2]=Oa,+o[u>>2]);k[O>>2]=k[(Oa?P:O)>>2];k[P>>2]=k[(Oa?Da:P)>>2];Oa=k[Q>>2]|0;k[Da>>2]=Oa;Oa=+o[R>>2]<(k[u>>2]=Oa,+o[u>>2]);k[Q>>2]=k[(Oa?R:Q)>>2];Oa=k[(Oa?Da:R)>>2]|0;k[R>>2]=Oa;Ba=k[ea>>2]|0;k[Da>>2]=Ba;Ba=+o[F>>2]<(k[u>>2]=Ba,+o[u>>2]);k[ea>>2]=k[(Ba?F:ea)>>2];Ba=k[(Ba?Da:F)>>2]|0;k[F>>2]=Ba;za=k[W>>2]|0;k[Da>>2]=za;Na=(k[u>>2]=Aa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Aa=k[(za?N:W)>>2]|0;k[W>>2]=Aa;k[N>>2]=k[(za?Da:N)>>2];k[Da>>2]=Aa;Na=(k[u>>2]=Ba,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);k[W>>2]=k[(Aa?F:W)>>2];Aa=k[(Aa?Da:F)>>2]|0;k[F>>2]=Aa;Ba=k[$>>2]|0;k[Da>>2]=Ba;Ba=+o[J>>2]<(k[u>>2]=Ba,+o[u>>2]);k[$>>2]=k[(Ba?J:$)>>2];Ba=k[(Ba?Da:J)>>2]|0;k[J>>2]=Ba;k[Da>>2]=Ba;Na=(k[u>>2]=Oa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);Oa=k[(Ba?R:J)>>2]|0;k[J>>2]=Oa;k[R>>2]=k[(Ba?Da:R)>>2];k[Da>>2]=Aa;Na=(k[u>>2]=Oa,+o[u>>2]);Aa=Na<(k[u>>2]=Aa,+o[u>>2]);Oa=k[(Aa?J:F)>>2]|0;k[F>>2]=Oa;k[J>>2]=k[(Aa?Da:J)>>2];Aa=k[ca>>2]|0;k[Da>>2]=Aa;Aa=+o[H>>2]<(k[u>>2]=Aa,+o[u>>2]);k[ca>>2]=k[(Aa?H:ca)>>2];Aa=k[(Aa?Da:H)>>2]|0;k[H>>2]=Aa;Ba=k[D>>2]|0;k[Da>>2]=Ba;Ba=+o[P>>2]<(k[u>>2]=Ba,+o[u>>2]);za=k[(Ba?P:D)>>2]|0;k[D>>2]=za;k[P>>2]=k[(Ba?Da:P)>>2];k[Da>>2]=za;Na=(k[u>>2]=Aa,+o[u>>2]);za=Na<(k[u>>2]=za,+o[u>>2]);Aa=k[(za?H:D)>>2]|0;k[D>>2]=Aa;k[H>>2]=k[(za?Da:H)>>2];za=k[Y>>2]|0;k[Da>>2]=za;za=+o[L>>2]<(k[u>>2]=za,+o[u>>2]);Ba=k[(za?L:Y)>>2]|0;k[Y>>2]=Ba;k[L>>2]=k[(za?Da:L)>>2];k[Da>>2]=Ba;Na=(k[u>>2]=Aa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[Y>>2]=k[(Ba?D:Y)>>2];Ba=k[(Ba?Da:D)>>2]|0;k[D>>2]=Ba;k[Da>>2]=Ba;Na=(k[u>>2]=Oa,+o[u>>2]);Ba=Na<(k[u>>2]=Ba,+o[u>>2]);k[D>>2]=k[(Ba?F:D)>>2];k[F>>2]=k[(Ba?Da:F)>>2];Ba=k[da>>2]|0;k[Da>>2]=Ba;Ba=+o[G>>2]<(k[u>>2]=Ba,+o[u>>2]);k[da>>2]=k[(Ba?G:da)>>2];Ba=k[(Ba?Da:G)>>2]|0;k[G>>2]=Ba;Oa=k[(+o[O>>2]<+o[C>>2]?O:C)>>2]|0;k[Da>>2]=Oa;Na=(k[u>>2]=Ba,+o[u>>2]);d=k[(Na<(k[u>>2]=Oa,+o[u>>2])?Da:G)>>2]|0;k[G>>2]=d;Oa=k[Z>>2]|0;k[Da>>2]=Oa;Oa=k[(+o[K>>2]<(k[u>>2]=Oa,+o[u>>2])?Da:K)>>2]|0;k[K>>2]=Oa;Na=(k[u>>2]=Oa,+o[u>>2]);d=k[(Na<(k[u>>2]=d,+o[u>>2])?K:G)>>2]|0;k[G>>2]=d;Oa=k[ba>>2]|0;k[Da>>2]=Oa;Ba=k[(+o[I>>2]<(k[u>>2]=Oa,+o[u>>2])?Da:I)>>2]|0;k[I>>2]=Ba;Oa=k[(+o[Q>>2]<+o[E>>2]?Q:E)>>2]|0;k[E>>2]=Oa;Na=(k[u>>2]=Ba,+o[u>>2]);Ba=k[(Na<(k[u>>2]=Oa,+o[u>>2])?I:E)>>2]|0;k[E>>2]=Ba;Oa=k[(+o[M>>2]<+o[X>>2]?M:X)>>2]|0;k[Da>>2]=Oa;Na=(k[u>>2]=Ba,+o[u>>2]);Oa=k[(Na<(k[u>>2]=Oa,+o[u>>2])?Da:E)>>2]|0;k[E>>2]=Oa;Na=(k[u>>2]=d,+o[u>>2]);Oa=k[(Na<(k[u>>2]=Oa,+o[u>>2])?G:E)>>2]|0;k[Da>>2]=Oa;k[f+(a<<2)>>2]=k[(+o[F>>2]<(k[u>>2]=Oa,+o[u>>2])?Da:F)>>2];d=a+1|0;if((a|0)<(B|0))a=d;else{e=x;a=d;continue p}}}if((g|0)==(T|0))break;else f=f+(V<<2)|0}}break}default:{}}while(0);break a}default:{k[Da>>2]=0;Oa=Da+4|0;k[Oa>>2]=0;a=ZT(8)|0;k[a>>2]=1;Ca=a+4|0;k[Da>>2]=Ca;k[Oa>>2]=0;i[Ca>>0]=0;Y8(-210,Da,351606,348846,2807);k[Oa>>2]=0;k[Da>>2]=0;Oa=k[a>>2]|0;k[a>>2]=Oa+-1;if((Oa|0)==1)ggb(k[a+-4>>2]|0);break a}}}while(0);e=Ia+36|0;a=k[e>>2]|0;if(a|0?(Da=a+12|0,Oa=k[Da>>2]|0,k[Da>>2]=Oa+-1,(Oa|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[Ia+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;Oa=Ia+16|0;k[Oa>>2]=0;k[Oa+4>>2]=0;k[Oa+8>>2]=0;k[Oa+12>>2]=0;if((k[Ga>>2]|0)>0){d=k[Ea>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Ga>>2]|0))}a=k[Fa>>2]|0;if(!((a|0)==(Ha|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=Ka+36|0;a=k[e>>2]|0;if(a|0?(Ia=a+12|0,Oa=k[Ia>>2]|0,k[Ia>>2]=Oa+-1,(Oa|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[Ka+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;Oa=Ka+16|0;d=Ka+4|0;k[Oa>>2]=0;k[Oa+4>>2]=0;k[Oa+8>>2]=0;k[Oa+12>>2]=0;if((k[d>>2]|0)>0){e=k[Ka+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[d>>2]|0))}a=k[Ka+44>>2]|0;if(!((a|0)==(Ka+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=La+36|0;a=k[e>>2]|0;if(a|0?(Ka=a+12|0,Oa=k[Ka>>2]|0,k[Ka>>2]=Oa+-1,(Oa|0)==1):0){d=k[e>>2]|0;if(d|0){a=k[d+4>>2]|0;if(!a){a=k[La+32>>2]|0;if(!a){a=B1()|0;d=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,d)}k[e>>2]=0}k[e>>2]=0;Oa=La+16|0;e=La+4|0;k[Oa>>2]=0;k[Oa+4>>2]=0;k[Oa+8>>2]=0;k[Oa+12>>2]=0;if((k[e>>2]|0)>0){d=k[Ja>>2]|0;a=0;do{k[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[e>>2]|0))}a=k[La+44>>2]|0;if(!((a|0)==(La+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);r=Ma;return}function wua(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,l=0,m=0.0,n=0,q=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=r;r=r+368|0;E=I+120|0;D=I+88|0;F=I+312|0;C=I+32|0;B=I+288|0;x=I;A=I+304|0;H=I+232|0;G=I+176|0;R1(A,a,-1);x2(b,A,S1(a,-1)|0,0);do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[H>>2]=k[j>>2];s=H+4|0;a=j+4|0;k[s>>2]=k[a>>2];A=H+8|0;k[A>>2]=k[j+8>>2];k[H+12>>2]=k[j+12>>2];k[H+16>>2]=k[j+16>>2];k[H+20>>2]=k[j+20>>2];k[H+24>>2]=k[j+24>>2];k[H+28>>2]=k[j+28>>2];k[H+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[H+36>>2]=g;h=H+40|0;k[h>>2]=A;A=H+48|0;n=H+44|0;k[n>>2]=A;k[H+52>>2]=0;k[A>>2]=0;if(g|0){A=g+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[a>>2]|0)<3){y=k[j+44>>2]|0;A=k[n>>2]|0;k[A>>2]=k[y>>2];k[A+4>>2]=k[y+4>>2];break}k[s>>2]=0;x1(H,k[a>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[n>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[q+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else Q1(H,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){l=k[b+4>>2]|0;k[G>>2]=k[l>>2];s=G+4|0;g=l+4|0;k[s>>2]=k[g>>2];A=G+8|0;k[A>>2]=k[l+8>>2];k[G+12>>2]=k[l+12>>2];k[G+16>>2]=k[l+16>>2];k[G+20>>2]=k[l+20>>2];k[G+24>>2]=k[l+24>>2];k[G+28>>2]=k[l+28>>2];k[G+32>>2]=k[l+32>>2];a=k[l+36>>2]|0;k[G+36>>2]=a;h=G+40|0;k[h>>2]=A;A=G+48|0;n=G+44|0;k[n>>2]=A;k[G+52>>2]=0;k[A>>2]=0;if(a|0){A=a+12|0;k[A>>2]=(k[A>>2]|0)+1}if((k[g>>2]|0)<3){y=k[l+44>>2]|0;A=k[n>>2]|0;k[A>>2]=k[y>>2];k[A+4>>2]=k[y+4>>2];break}k[s>>2]=0;x1(G,k[g>>2]|0,0,0,0);if((k[s>>2]|0)>0){q=k[l+40>>2]|0;j=k[h>>2]|0;h=k[l+44>>2]|0;g=k[n>>2]|0;a=0;do{k[j+(a<<2)>>2]=k[q+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[s>>2]|0))}}else Q1(G,b,-1);while(0);a=k[H>>2]|0;switch(a&7){case 0:{x=(a>>>3&511)+1|0;y=k[k[H+40>>2]>>2]|0;switch(a&4095){case 16:case 0:{if((k[H+16>>2]|0)==(k[G+16>>2]|0))v=22;break}default:v=22}if((v|0)==22){k[E>>2]=0;a=E+4|0;k[a>>2]=0;g=ZT(80)|0;k[g>>2]=1;l=g+4|0;k[E>>2]=l;k[a>>2]=72;i[g+76>>0]=0;h=351673;n=l+72|0;do{i[l>>0]=i[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(n|0));Y8(-215,E,351746,348846,3145);k[a>>2]=0;k[E>>2]=0;B=k[g>>2]|0;k[g>>2]=B+-1;if((B|0)==1)ggb(k[g+-4>>2]|0)}m=!(d<=0.0)?d:1.0;d=!(e<=0.0)?e:1.0;m=-.5/(m*m);t=-.5/(d*d);if((c|0)<1){d=d*1.5;p[u>>3]=d;a=k[u+4>>2]|0;B=a&2146435072;if(!(B>>>0>1126170624|(B|0)==1126170624&0>0)){a=(a|0)<0;d=a?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=a?-0.0:0.0}a=~~d}else a=c>>>1;s=(a|0)<1?1:a;h=s<<1|1;k[E>>2]=1124007936;w=E+4|0;a=E+8|0;v=E+40|0;l=w;n=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(n|0));k[v>>2]=a;c=E+48|0;b=E+44|0;k[b>>2]=c;k[E+52>>2]=0;k[c>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D>>2]=16842752;k[D+4>>2]=H;j=F+4|0;g=j+4|0;k[g>>2]=0;k[g+4>>2]=0;k[F>>2]=33619968;k[j>>2]=E;k[C>>2]=0;k[C+4>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;k[C+16>>2]=0;k[C+20>>2]=0;k[C+24>>2]=0;k[C+28>>2]=0;vY(D,F,s,s,s,s,f,C);j=x<<8;g=x<<10;while(1){a=fgb(g)|0;if(a|0){q=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){q=0;break}Qh[a&7]()}zpb(q|0,0,g|0)|0;a=aa(h,h)|0;if(a>>>0>1073741823)ad(426534,426557,304,426811);h=a<<2;g=(h|0)==0?1:h;while(1){a=fgb(g)|0;if(a|0){n=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){n=0;break}Qh[a&7]()}zpb(n|0,0,h|0)|0;while(1){a=fgb(g)|0;if(a|0){l=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){l=0;break}Qh[a&7]()}zpb(l|0,0,h|0)|0;a=0;do{z=+Z(+(m*+(aa(a,a)|0)));o[q+(a<<2)>>2]=z;a=a+1|0}while((a|0)!=(j|0));j=0-s|0;if((s|0)<(j|0))a=0;else{m=+(s|0);a=0;h=j;while(1){e=+(h|0);e=e*e;g=j;while(1){d=+(g|0);d=+Q(+(e+d*d));if(!(d>m)){z=+Z(+(t*(d*d)));o[n+(a<<2)>>2]=z;C=(aa(k[c>>2]|0,h)|0)+(aa(g,x)|0)|0;k[l+(a<<2)>>2]=C;a=a+1|0}if((g|0)<(s|0))g=g+1|0;else break}if((h|0)<(s|0))h=h+1|0;else break}}k[D>>2]=89292;k[D+4>>2]=E;k[D+8>>2]=G;k[D+12>>2]=s;k[D+16>>2]=a;k[D+20>>2]=l;k[D+24>>2]=n;k[D+28>>2]=q;k[F>>2]=0;k[F+4>>2]=y;Aua(D,F);if(l|0)ggb(l);if(n|0)ggb(n);if(q|0)ggb(q);h=E+36|0;a=k[h>>2]|0;if(a|0?(D=a+12|0,F=k[D>>2]|0,k[D>>2]=F+-1,(F|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[E+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;F=E+16|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[w>>2]|0)>0){g=k[v>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[w>>2]|0))}a=k[b>>2]|0;if(!((a|0)==(c|0)|(a|0)==0))ggb(k[a+-4>>2]|0);break}case 5:{y=(a>>>3&511)+1|0;p[E>>3]=-1.0;p[D>>3]=1.0;A=k[k[H+40>>2]>>2]|0;switch(a&4095){case 21:case 5:{if((k[H+16>>2]|0)==(k[G+16>>2]|0))v=76;break}default:v=76}if((v|0)==76){k[F>>2]=0;a=F+4|0;k[a>>2]=0;g=ZT(80)|0;k[g>>2]=1;l=g+4|0;k[F>>2]=l;k[a>>2]=74;i[g+78>>0]=0;h=351765;n=l+74|0;do{i[l>>0]=i[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(n|0));Y8(-215,F,351840,348846,3411);k[a>>2]=0;k[F>>2]=0;w=k[g>>2]|0;k[g>>2]=w+-1;if((w|0)==1)ggb(k[g+-4>>2]|0)}m=!(d<=0.0)?d:1.0;d=!(e<=0.0)?e:1.0;e=-.5/(m*m);z=-.5/(d*d);if((c|0)<1){d=d*1.5;p[u>>3]=d;a=k[u+4>>2]|0;w=a&2146435072;if(!(w>>>0>1126170624|(w|0)==1126170624&0>0)){a=(a|0)<0;d=a?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(d==0.0)d=a?-0.0:0.0}a=~~d}else a=c>>>1;w=(a|0)<1?1:a;j=w<<1|1;_1(C,H,1,0);k[F+8>>2]=0;k[F+12>>2]=0;k[F>>2]=16842752;k[F+4>>2]=C;L7(F,E,D,0,0,49332);h=C+36|0;a=k[h>>2]|0;if(a|0?(v=a+12|0,c=k[v>>2]|0,k[v>>2]=c+-1,(c|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[C+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;c=C+16|0;g=C+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[g>>2]|0)>0){h=k[C+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[C+44>>2]|0;if(!((a|0)==(C+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);if(!(+P(+(+p[E>>3]-+p[D>>3]))<1.1920928955078125e-07)){k[F>>2]=1124007936;c=F+4|0;a=F+8|0;b=F+40|0;l=c;n=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(n|0));k[b>>2]=a;v=F+48|0;s=F+44|0;k[s>>2]=v;k[F+52>>2]=0;k[v>>2]=0;k[C+8>>2]=0;k[C+12>>2]=0;k[C>>2]=16842752;k[C+4>>2]=H;a=B+4|0;q=a+4|0;k[q>>2]=0;k[q+4>>2]=0;k[B>>2]=33619968;k[a>>2]=F;k[x>>2]=0;k[x+4>>2]=0;k[x+8>>2]=0;k[x+12>>2]=0;k[x+16>>2]=0;k[x+20>>2]=0;k[x+24>>2]=0;k[x+28>>2]=0;vY(C,B,w,w,w,w,f,x);a=C+4|0;f=a+4|0;k[f>>2]=0;k[f+4>>2]=0;k[C>>2]=50397184;k[a>>2]=F;k_(C,m*-5.0);a=aa(j,j)|0;if(a>>>0>1073741823)ad(426534,426557,304,426811);h=a<<2;g=(h|0)==0?1:h;while(1){a=fgb(g)|0;if(a|0){q=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){q=0;break}Qh[a&7]()}zpb(q|0,0,h|0)|0;while(1){a=fgb(g)|0;if(a|0){n=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){n=0;break}Qh[a&7]()}zpb(n|0,0,h|0)|0;m=+p[D>>3];d=+p[E>>3];g=y<<12;j=g|2;h=j<<2;while(1){a=fgb(h)|0;if(a|0){l=a;break}a=k[207666]|0;k[207666]=a+0;if(!a){l=0;break}Qh[a&7]()}zpb(l|0,0,h|0)|0;t=+(g|0)/(+(y|0)*(m-d));a=0;d=1.0;do{if(d>0.0){m=+(a|0)/t;m=+Z(+(e*(m*m)));d=m}else m=0.0;o[l+(a<<2)>>2]=m;a=a+1|0}while((a|0)!=(j|0));j=0-w|0;if((w|0)<(j|0))a=0;else{m=+(w|0);a=0;h=j;while(1){e=+(h|0);e=e*e;g=j;while(1){d=+(g|0);d=+Q(+(e+d*d));if(!(d>m)){d=+Z(+(z*(d*d)));o[q+(a<<2)>>2]=d;E=(aa((k[v>>2]|0)>>>2,h)|0)+(aa(g,y)|0)|0;k[n+(a<<2)>>2]=E;a=a+1|0}if((g|0)<(w|0))g=g+1|0;else break}if((h|0)<(w|0))h=h+1|0;else break}}k[C>>2]=89312;k[C+4>>2]=y;k[C+8>>2]=w;k[C+12>>2]=a;k[C+16>>2]=n;k[C+20>>2]=F;k[C+24>>2]=G;o[C+28>>2]=t;k[C+32>>2]=q;k[C+36>>2]=l;k[B>>2]=0;k[B+4>>2]=A;yua(C,B);if(l|0)ggb(l);if(n|0)ggb(n);if(q|0)ggb(q);h=F+36|0;a=k[h>>2]|0;if(a|0?(D=a+12|0,E=k[D>>2]|0,k[D>>2]=E+-1,(E|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[F+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;F=F+16|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[c>>2]|0)>0){g=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[c>>2]|0))}a=k[s>>2]|0;if(!((a|0)==(v|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else{E=F+4|0;D=E+4|0;k[D>>2]=0;k[D+4>>2]=0;k[F>>2]=33619968;k[E>>2]=G;mY(H,F)}break}default:{k[E>>2]=0;a=E+4|0;k[a>>2]=0;g=ZT(68)|0;k[g>>2]=1;l=g+4|0;k[E>>2]=l;k[a>>2]=61;i[g+65>>0]=0;h=351860;n=l+61|0;do{i[l>>0]=i[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(n|0));Y8(-210,E,351922,348846,3505);k[a>>2]=0;k[E>>2]=0;F=k[g>>2]|0;k[g>>2]=F+-1;if((F|0)==1)ggb(k[g+-4>>2]|0)}}h=G+36|0;a=k[h>>2]|0;if(a|0?(E=a+12|0,F=k[E>>2]|0,k[E>>2]=F+-1,(F|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[G+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;F=G+16|0;g=G+4|0;k[F>>2]=0;k[F+4>>2]=0;k[F+8>>2]=0;k[F+12>>2]=0;if((k[g>>2]|0)>0){h=k[G+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[G+44>>2]|0;if(!((a|0)==(G+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=H+36|0;a=k[h>>2]|0;if(a|0?(F=a+12|0,G=k[F>>2]|0,k[F>>2]=G+-1,(G|0)==1):0){g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;if(!a){a=k[H+32>>2]|0;if(!a){a=B1()|0;g=k[h>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}k[h>>2]=0;G=H+16|0;g=H+4|0;k[G>>2]=0;k[G+4>>2]=0;k[G+8>>2]=0;k[G+12>>2]=0;if((k[g>>2]|0)>0){h=k[H+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[H+44>>2]|0;if((a|0)==(H+48|0)|(a|0)==0){r=I;return}ggb(k[a+-4>>2]|0);r=I;return}function xua(a){a=a|0;ggb(a);return}function yua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0.0,g=0,h=0,j=0,l=0.0,m=0.0,n=0.0,p=0.0,q=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0,W=0.0;Q=r;r=r+16|0;M=Q;N=a+24|0;d=k[N>>2]|0;O=k[(k[d+40>>2]|0)+4>>2]|0;c=k[b>>2]|0;z=b+4|0;if((c|0)>=(k[z>>2]|0)){r=Q;return}A=a+20|0;B=a+8|0;D=a+4|0;E=M+4|0;F=O*3|0;G=(O|0)>0;H=a+12|0;I=a+16|0;J=a+28|0;K=a+32|0;y=a+36|0;b=c;a=d;while(1){x=k[A>>2]|0;w=k[B>>2]|0;x=(k[x+16>>2]|0)+(aa(k[k[x+44>>2]>>2]|0,w+b|0)|0)|0;v=k[D>>2]|0;w=x+((aa(v,w)|0)<<2)|0;x=(k[a+16>>2]|0)+(aa(k[k[a+44>>2]>>2]|0,b)|0)|0;a:do switch(v|0){case 1:{if(G){d=k[H>>2]|0;if((d|0)<=0){a=0;while(1){o[x+(a<<2)>>2]=C;a=a+1|0;if((a|0)==(O|0))break a}}g=k[I>>2]|0;h=k[K>>2]|0;j=k[y>>2]|0;a=0;do{l=+o[w+(a<<2)>>2];m=+o[J>>2];c=0;e=0.0;f=0.0;do{q=+o[w+((k[g+(c<<2)>>2]|0)+a<<2)>>2];s=+P(+(q-l))*m;v=~~s;v=v-(+(v|0)>s&1)|0;p=+o[j+(v<<2)>>2];s=+o[h+(c<<2)>>2]*(p+(+o[j+(v+1<<2)>>2]-p)*(s-+(v|0)));e=e+q*s;f=f+s;c=c+1|0}while((c|0)!=(d|0));o[x+(a<<2)>>2]=e/f;a=a+1|0}while((a|0)!=(O|0))}break}case 3:{L=14;break}default:{a=ZT(12)|0;k[a>>2]=1;L=a+4|0;k[M>>2]=L;k[E>>2]=7;i[a+11>>0]=0;i[L>>0]=i[351938]|0;i[L+1>>0]=i[351939]|0;i[L+2>>0]=i[351940]|0;i[L+3>>0]=i[351941]|0;i[L+4>>0]=i[351942]|0;i[L+5>>0]=i[351943]|0;i[L+6>>0]=i[351944]|0;Y8(-215,M,369779,348846,3303);k[E>>2]=0;k[M>>2]=0;L=k[a>>2]|0;k[a>>2]=L+-1;if((L|0)==1)ggb(k[a+-4>>2]|0);L=14}}while(0);b:do if((L|0)==14?(L=0,G):0){j=k[H>>2]|0;if((j|0)<=0){a=0;while(1){o[x+(a<<2)>>2]=C;o[x+(a+1<<2)>>2]=C;o[x+(a+2<<2)>>2]=C;a=a+3|0;if((a|0)>=(F|0))break b}}t=k[I>>2]|0;u=k[K>>2]|0;v=k[y>>2]|0;c=0;do{d=w+(c<<2)|0;n=+o[d>>2];g=c+1|0;p=+o[w+(g<<2)>>2];h=c+2|0;q=+o[w+(h<<2)>>2];s=+o[J>>2];e=0.0;f=0.0;l=0.0;m=0.0;a=0;do{V=d+(k[t+(a<<2)>>2]<<2)|0;U=+o[V>>2];T=+o[V+4>>2];S=+o[V+8>>2];R=(+P(+(U-n))+ +P(+(T-p))+ +P(+(S-q)))*s;V=~~R;V=V-(+(V|0)>R&1)|0;W=+o[v+(V<<2)>>2];R=+o[u+(a<<2)>>2]*(W+(+o[v+(V+1<<2)>>2]-W)*(R-+(V|0)));e=e+U*R;f=f+T*R;m=m+S*R;l=l+R;a=a+1|0}while((a|0)!=(j|0));W=1.0/l;o[x+(c<<2)>>2]=W*e;o[x+(g<<2)>>2]=f*W;o[x+(h<<2)>>2]=m*W;c=c+3|0}while((c|0)<(F|0))}while(0);b=b+1|0;if((b|0)>=(k[z>>2]|0))break;a=k[N>>2]|0}r=Q;return}function zua(a){a=a|0;ggb(a);return}function Aua(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0,f=0,g=0.0,h=0,j=0,m=0.0,n=0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0;J=a+8|0;f=k[J>>2]|0;c=(k[f>>2]|0)>>>3&511;K=c+1|0;I=k[(k[f+40>>2]|0)+4>>2]|0;e=k[b>>2]|0;F=b+4|0;if((e|0)>=(k[F>>2]|0))return;G=a+4|0;H=a+12|0;A=(c|0)==0;B=(I|0)>0;C=a+16|0;D=a+20|0;E=a+24|0;y=a+28|0;z=I*3|0;b=e;c=f;while(1){w=k[G>>2]|0;x=k[H>>2]|0;x=(k[w+16>>2]|0)+(aa(k[k[w+44>>2]>>2]|0,x+b|0)|0)+(aa(x,K)|0)|0;w=(k[c+16>>2]|0)+(aa(k[k[c+44>>2]>>2]|0,b)|0)|0;if(A){if(B){n=0;do{a=l[x+n>>0]|0;e=k[C>>2]|0;if((e|0)>0){f=k[D>>2]|0;h=k[E>>2]|0;j=k[y>>2]|0;c=0;g=0.0;d=0.0;do{v=i[x+((k[f+(c<<2)>>2]|0)+n)>>0]|0;t=(v&255)-a|0;p=+o[h+(c<<2)>>2]*+o[j+(((t|0)>-1?t:0-t|0)<<2)>>2];g=g+ +(v&255)*p;d=d+p;c=c+1|0}while((c|0)!=(e|0))}else{g=0.0;d=0.0}d=g/d;c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}i[w+n>>0]=~~d;n=n+1|0}while((n|0)!=(I|0))}}else if(B){s=0;do{f=x+s|0;h=l[f>>0]|0;t=s+1|0;j=l[x+t>>0]|0;v=s+2|0;n=l[x+v>>0]|0;q=k[C>>2]|0;if((q|0)>0){r=k[D>>2]|0;a=k[E>>2]|0;e=k[y>>2]|0;g=0.0;p=0.0;m=0.0;d=0.0;c=0;do{M=f+(k[r+(c<<2)>>2]|0)|0;O=i[M>>0]|0;N=i[M+1>>0]|0;M=i[M+2>>0]|0;Q=(O&255)-h|0;R=(N&255)-j|0;P=(M&255)-n|0;L=+o[a+(c<<2)>>2]*+o[e+(((R|0)>-1?R:0-R|0)+((Q|0)>-1?Q:0-Q|0)+((P|0)>-1?P:0-P|0)<<2)>>2];d=d+ +(O&255)*L;m=m+ +(N&255)*L;p=p+ +(M&255)*L;g=g+L;c=c+1|0}while((c|0)!=(q|0))}else{g=0.0;p=0.0;m=0.0;d=0.0}g=1.0/g;d=d*g;c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}e=~~d;d=m*g;c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}a=~~d;d=p*g;c=(o[u>>2]=d,k[u>>2]|0);if((c&2130706432)>>>0<=1249902592){c=(c|0)<0;d=c?d+-8388608.0+8388608.0:d+8388608.0+-8388608.0;if(d==0.0)d=c?-0.0:0.0}i[w+s>>0]=e;i[w+t>>0]=a;i[w+v>>0]=~~d;s=s+3|0}while((s|0)<(z|0))}b=b+1|0;if((b|0)>=(k[F>>2]|0))break;c=k[J>>2]|0}return}function Bua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0.0,l=0.0,m=0.0,n=0.0,p=0.0,q=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+32|0;z=A;e=k[b+8>>2]|0;f=k[b+12>>2]|0;m=+(((e|0)<(f|0)?f:e)|0)*3.0;s=+(k[b>>2]|0);l=+(k[b+4>>2]|0);b=k[a>>2]|0;g=a+4|0;c=k[g>>2]|0;if((c|0)!=(b|0)){b=c+(~((c+-16-b|0)>>>4)<<4)|0;k[g>>2]=b}x=a+12|0;c=k[x>>2]|0;w=a+16|0;d=k[w>>2]|0;if((d|0)!=(c|0))k[w>>2]=d+(~((d+-32-c|0)>>>5)<<5);y=a+36|0;k[y>>2]=0;i[a+32>>0]=0;o[a+40>>2]=s;o[a+44>>2]=l;o[a+48>>2]=s+ +(e|0);o[a+52>>2]=l+ +(f|0);j=l+m;n=s-m;p=l-m;o[z+8>>2]=0.0;o[z+12>>2]=0.0;k[z>>2]=0;k[z+4>>2]=-1;d=a+8|0;if((b|0)==(k[d>>2]|0))Cua(a,z);else{t=z;u=k[t+4>>2]|0;v=b;k[v>>2]=k[t>>2];k[v+4>>2]=u;k[b+8>>2]=0;k[b+12>>2]=0;k[g>>2]=(k[g>>2]|0)+16};k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;k[z+16>>2]=0;k[z+20>>2]=0;k[z+24>>2]=0;k[z+28>>2]=0;b=k[w>>2]|0;f=a+20|0;if((b|0)==(k[f>>2]|0))Dua(x,z);else{k[b>>2]=k[z>>2];k[b+4>>2]=k[z+4>>2];k[b+8>>2]=k[z+8>>2];k[b+12>>2]=k[z+12>>2];k[b+16>>2]=k[z+16>>2];k[b+20>>2]=k[z+20>>2];k[b+24>>2]=k[z+24>>2];k[b+28>>2]=k[z+28>>2];k[w>>2]=(k[w>>2]|0)+32}v=a+24|0;k[v>>2]=0;e=a+28|0;k[e>>2]=0;o[z+8>>2]=0.0;o[z+12>>2]=0.0;k[z>>2]=0;k[z+4>>2]=-1;b=k[g>>2]|0;if((b|0)==(k[d>>2]|0)){Cua(a,z);b=k[g>>2]|0}else{q=z;t=k[q+4>>2]|0;u=b;k[u>>2]=k[q>>2];k[u+4>>2]=t;k[b+8>>2]=0;k[b+12>>2]=0;b=(k[g>>2]|0)+16|0;k[g>>2]=b}t=k[a>>2]|0;u=(b-t>>4)+-1|0;b=t;k[e>>2]=k[b+(u<<4)>>2];t=b+(u<<4)|0;k[t>>2]=0;k[t+4>>2]=0;o[b+(u<<4)+8>>2]=s+m;o[b+(u<<4)+12>>2]=l;b=k[e>>2]|0;if(!b){o[z+8>>2]=0.0;o[z+12>>2]=0.0;k[z>>2]=0;k[z+4>>2]=-1;b=k[g>>2]|0;if((b|0)==(k[d>>2]|0)){Cua(a,z);b=k[g>>2]|0}else{h=z;q=k[h+4>>2]|0;t=b;k[t>>2]=k[h>>2];k[t+4>>2]=q;k[b+8>>2]=0;k[b+12>>2]=0;b=(k[g>>2]|0)+16|0;k[g>>2]=b}c=k[a>>2]|0;t=(b-c>>4)+-1|0;k[e>>2]=t}else{c=k[a>>2]|0;t=b}k[e>>2]=k[c+(t<<4)>>2];q=c+(t<<4)|0;k[q>>2]=0;k[q+4>>2]=0;o[c+(t<<4)+8>>2]=s;o[c+(t<<4)+12>>2]=j;c=k[e>>2]|0;if(!c){o[z+8>>2]=0.0;o[z+12>>2]=0.0;k[z>>2]=0;k[z+4>>2]=-1;b=k[g>>2]|0;if((b|0)==(k[d>>2]|0)){Cua(a,z);b=k[g>>2]|0}else{d=z;h=k[d+4>>2]|0;q=b;k[q>>2]=k[d>>2];k[q+4>>2]=h;k[b+8>>2]=0;k[b+12>>2]=0;b=(k[g>>2]|0)+16|0;k[g>>2]=b}h=k[a>>2]|0;q=(b-h>>4)+-1|0;k[e>>2]=q;b=h}else{b=k[a>>2]|0;q=c}k[e>>2]=k[b+(q<<4)>>2];h=b+(q<<4)|0;k[h>>2]=0;k[h+4>>2]=0;o[b+(q<<4)+8>>2]=n;o[b+(q<<4)+12>>2]=p;b=k[v>>2]|0;if((b|0)<1){k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;k[z+16>>2]=0;k[z+20>>2]=0;k[z+24>>2]=0;k[z+28>>2]=0;b=k[w>>2]|0;if((b|0)==(k[f>>2]|0)){Dua(x,z);b=k[w>>2]|0}else{k[b>>2]=k[z>>2];k[b+4>>2]=k[z+4>>2];k[b+8>>2]=k[z+8>>2];k[b+12>>2]=k[z+12>>2];k[b+16>>2]=k[z+16>>2];k[b+20>>2]=k[z+20>>2];k[b+24>>2]=k[z+24>>2];k[b+28>>2]=k[z+28>>2];b=(k[w>>2]|0)+32|0;k[w>>2]=b}c=k[x>>2]|0;b=(b-c>>5)+-1|0;k[v>>2]=b}else c=k[a+12>>2]|0;h=b<<2;g=c+(b<<5)+4|0;k[v>>2]=k[g>>2];k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;k[c+(b<<5)>>2]=h;k[g>>2]=h|3;k[c+(b<<5)+8>>2]=h|2;k[c+(b<<5)+12>>2]=h|1;c=c+(b<<5)+16|0;k[c>>2]=k[z>>2];k[c+4>>2]=k[z+4>>2];k[c+8>>2]=k[z+8>>2];k[c+12>>2]=k[z+12>>2];c=k[v>>2]|0;if((c|0)<1){k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;k[z+16>>2]=0;k[z+20>>2]=0;k[z+24>>2]=0;k[z+28>>2]=0;c=k[w>>2]|0;if((c|0)==(k[f>>2]|0)){Dua(x,z);c=k[w>>2]|0}else{k[c>>2]=k[z>>2];k[c+4>>2]=k[z+4>>2];k[c+8>>2]=k[z+8>>2];k[c+12>>2]=k[z+12>>2];k[c+16>>2]=k[z+16>>2];k[c+20>>2]=k[z+20>>2];k[c+24>>2]=k[z+24>>2];k[c+28>>2]=k[z+28>>2];c=(k[w>>2]|0)+32|0;k[w>>2]=c}d=k[x>>2]|0;c=(c-d>>5)+-1|0;k[v>>2]=c}else d=k[a+12>>2]|0;g=c<<2;e=d+(c<<5)+4|0;k[v>>2]=k[e>>2];k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;k[d+(c<<5)>>2]=g;k[e>>2]=g|3;k[d+(c<<5)+8>>2]=g|2;k[d+(c<<5)+12>>2]=g|1;d=d+(c<<5)+16|0;k[d>>2]=k[z>>2];k[d+4>>2]=k[z+4>>2];k[d+8>>2]=k[z+8>>2];k[d+12>>2]=k[z+12>>2];d=k[v>>2]|0;if((d|0)<1){k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;k[z+16>>2]=0;k[z+20>>2]=0;k[z+24>>2]=0;k[z+28>>2]=0;d=k[w>>2]|0;if((d|0)==(k[f>>2]|0)){Dua(x,z);d=k[w>>2]|0}else{k[d>>2]=k[z>>2];k[d+4>>2]=k[z+4>>2];k[d+8>>2]=k[z+8>>2];k[d+12>>2]=k[z+12>>2];k[d+16>>2]=k[z+16>>2];k[d+20>>2]=k[z+20>>2];k[d+24>>2]=k[z+24>>2];k[d+28>>2]=k[z+28>>2];d=(k[w>>2]|0)+32|0;k[w>>2]=d}e=k[x>>2]|0;d=(d-e>>5)+-1|0;k[v>>2]=d;f=a+12|0}else{e=a+12|0;f=e;e=k[e>>2]|0}x=d<<2;w=e+(d<<5)+4|0;k[v>>2]=k[w>>2];v=x|2;k[z>>2]=0;k[z+4>>2]=0;k[z+8>>2]=0;k[z+12>>2]=0;k[e+(d<<5)>>2]=x;k[w>>2]=x|3;k[e+(d<<5)+8>>2]=v;k[e+(d<<5)+12>>2]=x|1;w=e+(d<<5)+16|0;k[w>>2]=k[z>>2];k[w+4>>2]=k[z+4>>2];k[w+8>>2]=k[z+8>>2];k[w+12>>2]=k[z+12>>2];z=k[f>>2]|0;k[z+(b<<5)+16>>2]=u;k[z+(b<<5)+24>>2]=t;w=k[a>>2]|0;k[z+(c<<5)+16>>2]=t;k[z+(c<<5)+24>>2]=q;k[w+(t<<4)>>2]=g;k[z+(d<<5)+16>>2]=q;k[z+(d<<5)+24>>2]=u;k[w+(q<<4)>>2]=x;k[w+(u<<4)>>2]=v;w=z+(b<<5)|0;a=z+(d<<5)+8|0;t=k[w>>2]|0;v=k[a>>2]|0;u=z+(t>>2<<5)+((t+1&3)<<2)|0;x=z+(v>>2<<5)+((v+1&3)<<2)|0;k[w>>2]=v;k[a>>2]=t;a=k[u>>2]|0;k[u>>2]=k[x>>2];k[x>>2]=a;x=z+(c<<5)|0;a=z+(b<<5)+8|0;u=k[x>>2]|0;t=k[a>>2]|0;w=z+(u>>2<<5)+((u+1&3)<<2)|0;v=z+(t>>2<<5)+((t+1&3)<<2)|0;k[x>>2]=t;k[a>>2]=u;a=k[w>>2]|0;k[w>>2]=k[v>>2];k[v>>2]=a;v=z+(d<<5)|0;a=z+(c<<5)+8|0;w=k[v>>2]|0;u=k[a>>2]|0;x=z+(w>>2<<5)+((w+1&3)<<2)|0;z=z+(u>>2<<5)+((u+1&3)<<2)|0;k[v>>2]=u;k[a>>2]=w;a=k[x>>2]|0;k[x>>2]=k[z>>2];k[z>>2]=a;k[y>>2]=h;r=A;return}function Cua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;n=a+4|0;c=k[n>>2]|0;d=k[a>>2]|0;i=c-d>>4;e=i+1|0;if(e>>>0>268435455)ad(426534,426557,304,426811);l=d;j=c;m=a+8|0;h=(k[m>>2]|0)-d|0;f=h>>3;f=h>>4>>>0<134217727?(f>>>0<e>>>0?e:f):268435455;if(!f)e=0;else{if(f>>>0>268435455){n=te(4)|0;k[n>>2]=172664;Cf(n|0,28816,1287)}e=f<<4;e=(e|0)==0?1:e;while(1){d=fgb(e)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}e=d}g=e+(i<<4)|0;d=g;h=e+(f<<4)|0;p=b;o=k[p+4>>2]|0;f=g;k[f>>2]=k[p>>2];k[f+4>>2]=o;k[e+(i<<4)+8>>2]=k[b+8>>2];k[e+(i<<4)+12>>2]=k[b+12>>2];f=g+16|0;if((j|0)!=(l|0)){e=j;c=g;do{p=e;e=e+-16|0;i=e;j=k[i+4>>2]|0;o=c+-16|0;k[o>>2]=k[i>>2];k[o+4>>2]=j;k[c+-8>>2]=k[p+-8>>2];k[c+-4>>2]=k[p+-4>>2];c=d+-16|0;d=c}while((e|0)!=(l|0));c=k[a>>2]|0}k[a>>2]=d;k[n>>2]=f;k[m>>2]=h;if(!c)return;ggb(c);return}function Dua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,l=0;h=a+4|0;i=k[a>>2]|0;j=(k[h>>2]|0)-i|0;g=j>>5;c=g+1|0;if(c>>>0>134217727)ad(426534,426557,304,426811);l=a+8|0;e=(k[l>>2]|0)-i|0;f=e>>4;f=e>>5>>>0<67108863?(f>>>0<c>>>0?c:f):134217727;if(!f)c=0;else{if(f>>>0>134217727){l=te(4)|0;k[l>>2]=172664;Cf(l|0,28816,1287)}d=f<<5;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}e=c+(g<<5)|0;k[e>>2]=k[b>>2];k[e+4>>2]=k[b+4>>2];k[e+8>>2]=k[b+8>>2];k[e+12>>2]=k[b+12>>2];k[e+16>>2]=k[b+16>>2];k[e+20>>2]=k[b+20>>2];k[e+24>>2]=k[b+24>>2];k[e+28>>2]=k[b+28>>2];d=e+(0-g<<5)|0;if((j|0)>0)upb(d|0,i|0,j|0)|0;k[a>>2]=d;k[h>>2]=e+32;k[l>>2]=c+(f<<5);if(!i)return;ggb(i);return}function Eua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,h=0,j=0.0,l=0.0,m=0,n=0,p=0,q=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0;G=r;r=r+16|0;w=G;y=(k[a+16>>2]|0)-(k[a+12>>2]|0)|0;F=y>>3;if(y>>5>>>0<4){e=w+4|0;h=ZT(28)|0;k[h>>2]=1;m=h+4|0;k[w>>2]=m;k[e>>2]=20;i[h+24>>0]=0;n=352182;p=m+20|0;do{i[m>>0]=i[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(p|0));Y8(-2,w,352203,352210,283);k[e>>2]=0;k[w>>2]=0;A=k[h>>2]|0;k[h>>2]=A+-1;if((A|0)==1)ggb(k[h+-4>>2]|0)}f=+o[b>>2];if(!(((!(f<+o[a+40>>2])?(g=+o[b+4>>2],!(g<+o[a+44>>2])):0)?!(f>=+o[a+48>>2]):0)?!(g>=+o[a+52>>2]):0))t=9;if((t|0)==9?(A=w+4|0,s=ZT(8)|0,k[s>>2]=1,z=s+4|0,k[w>>2]=z,k[A>>2]=0,i[z>>0]=0,Y8(-211,w,352203,352210,286),k[A>>2]=0,k[w>>2]=0,A=k[s>>2]|0,k[s>>2]=A+-1,(A|0)==1):0)ggb(k[s+-4>>2]|0);A=a+36|0;e=k[A>>2]|0;if((e|0)<=0?(z=w+4|0,x=ZT(16)|0,k[x>>2]=1,t=x+4|0,k[w>>2]=t,k[z>>2]=8,i[x+12>>0]=0,t,s=t,i[s>>0]=101,i[s+1>>0]=100,i[s+2>>0]=103,i[s+3>>0]=101,t=t+4|0,i[t>>0]=32,i[t+1>>0]=62,i[t+2>>0]=32,i[t+3>>0]=48,Y8(-215,w,352203,352210,289),k[z>>2]=0,k[w>>2]=0,z=k[x>>2]|0,k[x>>2]=z+-1,(z|0)==1):0)ggb(k[x+-4>>2]|0);C=+o[b>>2];B=+o[b+4>>2];h=e>>2;z=k[a+12>>2]|0;m=k[z+(h<<5)+16+((e&3)<<2)>>2]|0;a=k[a>>2]|0;h=k[z+(h<<5)+16+((e+2&3)<<2)>>2]|0;D=C;E=B;v=(+o[a+(m<<4)+12>>2]-E)*(+o[a+(h<<4)+8>>2]-D)-(+o[a+(m<<4)+8>>2]-D)*(+o[a+(h<<4)+12>>2]-E);h=(v>0.0&1)-(v<0.0&1)|0;m=(h|0)>0;e=m?e^2:e;a:do if((y|0)>0){b=0;h=m?0-h|0:h;b:while(1){m=e&3;x=e>>2;t=k[z+(x<<5)+(m<<2)>>2]|0;p=k[z+(x<<5)+((e+3&3)<<2)>>2]|0;s=p+3&3;w=s|p&-4;y=t>>2;n=k[z+(y<<5)+16+((t&3)<<2)>>2]|0;y=k[z+(y<<5)+16+((t+2&3)<<2)>>2]|0;f=+o[a+(y<<4)+8>>2];g=+o[a+(y<<4)+12>>2];v=(+o[a+(n<<4)+12>>2]-E)*(f-D)-(+o[a+(n<<4)+8>>2]-D)*(g-E);n=(v>0.0&1)-(v<0.0&1)|0;y=p>>2;s=k[z+(y<<5)+16+(s<<2)>>2]|0;p=k[z+(y<<5)+16+((p+1&3)<<2)>>2]|0;v=(+o[a+(s<<4)+12>>2]-E)*(+o[a+(p<<4)+8>>2]-D)-(+o[a+(s<<4)+8>>2]-D)*(+o[a+(p<<4)+12>>2]-E);p=(v>0.0&1)-(v<0.0&1)|0;s=(n|0)>0;do if((p|0)>0)if(s|(n|h|0)==0)break b;else{h=n;e=t}else{if(s)if(!(p|h))break b;else{h=p;e=w;break}if(!h){h=k[z+(x<<5)+16+(m<<2)>>2]|0;y=k[z+(x<<5)+16+((e+2&3)<<2)>>2]|0;y=!((+o[a+(h<<4)+12>>2]-g)*(+o[a+(y<<4)+8>>2]-f)-(+o[a+(h<<4)+8>>2]-f)*(+o[a+(y<<4)+12>>2]-g)<0.0);h=y?0:n;e=y?e^2:t}else{h=n;e=t}}while(0);b=b+1|0;if((b|0)>=(F|0))break a}k[A>>2]=e;m=k[z+(x<<5)+16+(m<<2)>>2]|0;u=+o[a+(m<<4)+8>>2];v=+o[a+(m<<4)+12>>2];h=k[z+(x<<5)+16+((e+2&3)<<2)>>2]|0;q=+o[a+(h<<4)+8>>2];j=+o[a+(h<<4)+12>>2];l=+P(+(C-u))+ +P(+(B-v));f=+P(+(C-q))+ +P(+(B-j));g=+P(+(u-q))+ +P(+(v-j));if(l<1.1920928955078125e-07){A=m;F=1;z=0;y=(F|0)==-2;z=y?0:z;A=y?0:A;k[c>>2]=z;k[d>>2]=A;r=G;return F|0}if(f<1.1920928955078125e-07){A=h;F=1;z=0;y=(F|0)==-2;z=y?0:z;A=y?0:A;k[c>>2]=z;k[d>>2]=A;r=G;return F|0}if(!(l<g|f<g)){A=0;F=0;z=e;y=(F|0)==-2;z=y?0:z;A=y?0:A;k[c>>2]=z;k[d>>2]=A;r=G;return F|0}if(!(+P(+((u-D)*(j-E)-(q-D)*(v-E)))<1.1920928955078125e-07)){A=0;F=0;z=e;y=(F|0)==-2;z=y?0:z;A=y?0:A;k[c>>2]=z;k[d>>2]=A;r=G;return F|0}A=0;F=2;z=e;y=(F|0)==-2;z=y?0:z;A=y?0:A;k[c>>2]=z;k[d>>2]=A;r=G;return F|0}while(0);k[A>>2]=e;A=0;F=-2;z=e;y=(F|0)==-2;z=y?0:z;A=y?0:A;k[c>>2]=z;k[d>>2]=A;r=G;return F|0}function Fua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0.0,n=0.0,p=0.0,q=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;G=r;r=r+64|0;g=G+32|0;D=G;A=G+40|0;F=G+36|0;e=G+48|0;k[A>>2]=0;k[F>>2]=0;k[e>>2]=k[b>>2];h=b+4|0;k[e+4>>2]=k[h>>2];e=Eua(a,e,F,A)|0;switch(e|0){case -2:{E=D+4|0;c=ZT(8)|0;k[c>>2]=1;C=c+4|0;k[D>>2]=C;k[E>>2]=0;i[C>>0]=0;Y8(-201,D,352285,352210,416);k[E>>2]=0;k[D>>2]=0;E=k[c>>2]|0;k[c>>2]=E+-1;if((E|0)==1)ggb(k[c+-4>>2]|0);d=10;break}case -1:{E=D+4|0;c=ZT(8)|0;k[c>>2]=1;C=c+4|0;k[D>>2]=C;k[E>>2]=0;i[C>>0]=0;Y8(-211,D,352285,352210,419);k[E>>2]=0;k[D>>2]=0;E=k[c>>2]|0;k[c>>2]=E+-1;if((E|0)==1)ggb(k[c+-4>>2]|0);d=10;break}case 1:{F=k[A>>2]|0;r=G;return F|0}case 2:{c=k[F>>2]|0;C=c>>2;B=k[a+12>>2]|0;j=B+(C<<5)+((c+1&3)<<2)|0;E=k[j>>2]|0;E=E+1&3|E&-4;k[F>>2]=E;k[a+36>>2]=E;j=k[j>>2]|0;E=B+(C<<5)+((c&3)<<2)|0;j=B+(j>>2<<5)+((j+1&3)<<2)|0;l=k[E>>2]|0;I=k[j>>2]|0;H=B+(l>>2<<5)+((l+1&3)<<2)|0;z=B+(I>>2<<5)+((I+1&3)<<2)|0;k[E>>2]=I;k[j>>2]=l;j=k[H>>2]|0;k[H>>2]=k[z>>2];k[z>>2]=j;c=c^2;z=k[B+(C<<5)+((c+1&3)<<2)>>2]|0;c=B+(C<<5)+((c&3)<<2)|0;z=B+(z>>2<<5)+((z+1&3)<<2)|0;j=k[c>>2]|0;H=k[z>>2]|0;l=B+(j>>2<<5)+((j+1&3)<<2)|0;E=B+(H>>2<<5)+((H+1&3)<<2)|0;k[c>>2]=H;k[z>>2]=j;z=k[l>>2]|0;k[l>>2]=k[E>>2];k[E>>2]=z;k[B+(C<<5)>>2]=0;E=a+24|0;k[B+(C<<5)+4>>2]=k[E>>2];k[E>>2]=C;break}case 0:break;default:d=10}if(((d|0)==10?(k[g>>2]=e,$8(D,352292,g),Y8(-2,D,352285,352210,433),f=k[D>>2]|0,k[D+4>>2]=0,k[D>>2]=0,f|0):0)?(H=f+-4|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0)ggb(k[f+-8>>2]|0);i[a+32>>0]=0;f=k[b>>2]|0;b=k[h>>2]|0;e=a+28|0;c=k[e>>2]|0;if(!c){o[D+8>>2]=0.0;o[D+12>>2]=0.0;k[D>>2]=0;k[D+4>>2]=-1;c=a+4|0;d=k[c>>2]|0;if((d|0)==(k[a+8>>2]|0)){Cua(a,D);c=k[c>>2]|0}else{E=D;H=k[E+4>>2]|0;I=d;k[I>>2]=k[E>>2];k[I+4>>2]=H;k[d+8>>2]=0;k[d+12>>2]=0;I=(k[c>>2]|0)+16|0;k[c>>2]=I;c=I}d=k[a>>2]|0;c=(c-d>>4)+-1|0;k[e>>2]=c}else d=k[a>>2]|0;k[e>>2]=k[d+(c<<4)>>2];z=d+(c<<4)|0;k[z>>2]=0;k[z+4>>2]=0;k[d+(c<<4)+8>>2]=f;k[d+(c<<4)+12>>2]=b;k[A>>2]=c;z=a+24|0;c=k[z>>2]|0;if((c|0)<1){e=a+12|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;d=a+16|0;c=k[d>>2]|0;b=a+20|0;if((c|0)==(k[b>>2]|0)){Dua(e,D);c=k[d>>2]|0}else{k[c>>2]=k[D>>2];k[c+4>>2]=k[D+4>>2];k[c+8>>2]=k[D+8>>2];k[c+12>>2]=k[D+12>>2];k[c+16>>2]=k[D+16>>2];k[c+20>>2]=k[D+20>>2];k[c+24>>2]=k[D+24>>2];k[c+28>>2]=k[D+28>>2];c=(k[d>>2]|0)+32|0;k[d>>2]=c}I=k[e>>2]|0;c=(c-I>>5)+-1|0;k[z>>2]=c;E=a+12|0;l=e;j=d;h=b;g=e;d=c;c=I}else{I=a+12|0;g=a+12|0;E=I;l=g;j=a+16|0;h=a+20|0;d=c;c=k[I>>2]|0}f=d<<2;I=c+(d<<5)+4|0;k[z>>2]=k[I>>2];B=f|2;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[c+(d<<5)>>2]=f;k[I>>2]=f|3;k[c+(d<<5)+8>>2]=B;k[c+(d<<5)+12>>2]=f|1;I=c+(d<<5)+16|0;k[I>>2]=k[D>>2];k[I+4>>2]=k[D+4>>2];k[I+8>>2]=k[D+8>>2];k[I+12>>2]=k[D+12>>2];I=k[F>>2]|0;H=I&3;b=I>>2;J=k[E>>2]|0;C=k[J+(b<<5)+16+(H<<2)>>2]|0;c=k[A>>2]|0;k[J+(d<<5)+16>>2]=C;k[J+(d<<5)+24>>2]=c;e=k[a>>2]|0;k[e+(C<<4)>>2]=f;k[e+(c<<4)>>2]=B;e=J+(d<<5)|0;H=J+(b<<5)+(H<<2)|0;A=k[e>>2]|0;b=k[H>>2]|0;B=J+(A>>2<<5)+((A+1&3)<<2)|0;d=J+(b>>2<<5)+((b+1&3)<<2)|0;k[e>>2]=b;k[H>>2]=A;H=k[B>>2]|0;k[B>>2]=k[d>>2];k[d>>2]=H;d=I;do{b=k[z>>2]|0;if((b|0)<1){k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[D+16>>2]=0;k[D+20>>2]=0;k[D+24>>2]=0;k[D+28>>2]=0;b=k[j>>2]|0;if((b|0)==(k[h>>2]|0)){Dua(l,D);b=k[j>>2]|0}else{k[b>>2]=k[D>>2];k[b+4>>2]=k[D+4>>2];k[b+8>>2]=k[D+8>>2];k[b+12>>2]=k[D+12>>2];k[b+16>>2]=k[D+16>>2];k[b+20>>2]=k[D+20>>2];k[b+24>>2]=k[D+24>>2];k[b+28>>2]=k[D+28>>2];b=(k[j>>2]|0)+32|0;k[j>>2]=b}J=k[g>>2]|0;e=(b-J>>5)+-1|0;k[z>>2]=e;b=J}else{e=b;b=k[E>>2]|0}A=f;f=e<<2;I=b+(e<<5)+4|0;k[z>>2]=k[I>>2];J=f|2;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;k[b+(e<<5)>>2]=f;k[I>>2]=f|3;k[b+(e<<5)+8>>2]=J;k[b+(e<<5)+12>>2]=f|1;I=b+(e<<5)+16|0;k[I>>2]=k[D>>2];k[I+4>>2]=k[D+4>>2];k[I+8>>2]=k[D+8>>2];k[I+12>>2]=k[D+12>>2];I=d>>2;B=k[E>>2]|0;b=k[B+(I<<5)+((d+3&3)<<2)>>2]|0;K=B+(e<<5)|0;b=B+(b>>2<<5)+((b+1&3)<<2)|0;N=k[K>>2]|0;H=k[b>>2]|0;L=B+(N>>2<<5)+((N+1&3)<<2)|0;M=B+(H>>2<<5)+((H+1&3)<<2)|0;k[K>>2]=H;k[b>>2]=N;b=k[L>>2]|0;k[L>>2]=k[M>>2];k[M>>2]=b;M=B+(e<<5)+8|0;b=A>>2;A=B+(b<<5)+8|0;L=k[M>>2]|0;N=k[A>>2]|0;K=B+(L>>2<<5)+((L+1&3)<<2)|0;H=B+(N>>2<<5)+((N+1&3)<<2)|0;k[M>>2]=N;k[A>>2]=L;A=k[K>>2]|0;k[K>>2]=k[H>>2];k[H>>2]=A;I=k[B+(I<<5)+16+((d+2&3)<<2)>>2]|0;b=k[B+(b<<5)+24>>2]|0;k[B+(e<<5)+16>>2]=I;k[B+(e<<5)+24>>2]=b;B=k[a>>2]|0;k[B+(I<<4)>>2]=f;k[B+(b<<4)>>2]=J;b=k[E>>2]|0;J=k[b+(e<<5)+4>>2]|0;d=J+1&3|J&-4;k[F>>2]=d}while((k[b+(J>>2<<5)+16+((J+3&3)<<2)>>2]|0)!=(C|0));k[F>>2]=d;N=(k[j>>2]|0)-b|0;z=N>>3;if((N|0)<=0){N=c;r=G;return N|0}A=B+(c<<4)+8|0;a=B+(c<<4)+12|0;l=0;while(1){e=d+1&3;f=d>>2;M=k[b+(f<<5)+(e<<2)>>2]|0;M=k[b+(M>>2<<5)+16+((M+3&3)<<2)>>2]|0;g=d&3;h=k[b+(f<<5)+16+(g<<2)>>2]|0;j=d+2&3;N=k[b+(f<<5)+16+(j<<2)>>2]|0;m=+o[B+(N<<4)+8>>2];n=+o[B+(M<<4)+8>>2];p=m-n;q=+o[B+(h<<4)+12>>2];s=+o[B+(M<<4)+12>>2];t=q-s;u=+o[B+(N<<4)+12>>2];v=u-s;w=+o[B+(h<<4)+8>>2];x=w-n;y=t*p-x*v;if(y>0.0?(R=+o[A>>2],Q=+o[a>>2],O=R-n,P=Q-s,y=y*(R*R+Q*Q)+((n*n+s*s)*((q-u)*(R-m)-(w-m)*(Q-u))-(m*m+u*u)*(t*O-x*P))-(w*w+q*q)*(p*P-v*O),y<-1.4901161193847656e-08&!(y>1.4901161193847656e-08)):0){J=d^2;b=k[E>>2]|0;N=k[b+(f<<5)+(e<<2)>>2]|0;M=k[b+(f<<5)+((J+1&3)<<2)>>2]|0;H=b+(f<<5)+(g<<2)|0;I=N>>2;K=b+(I<<5)+((N+1&3)<<2)|0;T=k[H>>2]|0;U=k[K>>2]|0;D=b+(T>>2<<5)+((T+1&3)<<2)|0;L=b+(U>>2<<5)+((U+1&3)<<2)|0;k[H>>2]=U;k[K>>2]=T;K=k[D>>2]|0;k[D>>2]=k[L>>2];k[L>>2]=K;L=b+(f<<5)+((J&3)<<2)|0;K=M>>2;D=b+(K<<5)+((M+1&3)<<2)|0;T=k[L>>2]|0;U=k[D>>2]|0;S=b+(T>>2<<5)+((T+1&3)<<2)|0;h=b+(U>>2<<5)+((U+1&3)<<2)|0;k[L>>2]=U;k[D>>2]=T;D=k[S>>2]|0;k[S>>2]=k[h>>2];k[h>>2]=D;h=k[b+(I<<5)+16+((N+3&3)<<2)>>2]|0;D=k[b+(K<<5)+16+((M+3&3)<<2)>>2]|0;k[b+(f<<5)+16+(g<<2)>>2]=h;k[b+(f<<5)+16+(j<<2)>>2]=D;k[B+(h<<4)>>2]=d;k[B+(D<<4)>>2]=J;N=k[b+(I<<5)+((N&3)<<2)>>2]|0;N=b+(N>>2<<5)+((N+1&3)<<2)|0;I=k[H>>2]|0;D=k[N>>2]|0;J=b+(I>>2<<5)+((I+1&3)<<2)|0;d=b+(D>>2<<5)+((D+1&3)<<2)|0;k[H>>2]=D;k[N>>2]=I;N=k[J>>2]|0;k[J>>2]=k[d>>2];k[d>>2]=N;d=k[b+(K<<5)+((M&3)<<2)>>2]|0;d=b+(d>>2<<5)+((d+1&3)<<2)|0;M=k[L>>2]|0;K=k[d>>2]|0;N=b+(M>>2<<5)+((M+1&3)<<2)|0;b=b+(K>>2<<5)+((K+1&3)<<2)|0;k[L>>2]=K;k[d>>2]=M;d=k[N>>2]|0;k[N>>2]=k[b>>2];k[b>>2]=d;b=k[E>>2]|0;d=k[b+(f<<5)+(e<<2)>>2]|0;d=d+1&3|d&-4}else{if((h|0)==(C|0)){d=42;break}d=k[b+(f<<5)+(g<<2)>>2]|0;d=k[b+(d>>2<<5)+((d&3)<<2)>>2]|0;d=d+2&3|d&-4}k[F>>2]=d;l=l+1|0;if((l|0)>=(z|0)){d=42;break}}if((d|0)==42){r=G;return c|0}return 0}function Gua(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0.0,l=0.0,m=0.0,n=0.0,p=0.0,q=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;J=r;r=r+16|0;F=J;H=a+32|0;if(i[H>>0]|0){r=J;return}I=a+12|0;h=k[I>>2]|0;g=(k[a+16>>2]|0)-h|0;G=g>>5;if(G|0){b=0;do{k[h+(b<<5)+28>>2]=0;k[h+(b<<5)+20>>2]=0;b=b+1|0}while((b|0)!=(G|0))}E=a+4|0;d=k[a>>2]|0;c=(k[E>>2]|0)-d>>4;if(c|0){e=a+28|0;b=0;do{f=d+(b<<4)+4|0;if((k[f>>2]|0)>0){k[d+(b<<4)>>2]=k[e>>2];k[f>>2]=-1;k[e>>2]=b}b=b+1|0}while((b|0)!=(c|0))}i[H>>0]=0;if((g|0)>128){w=a+28|0;x=F+8|0;y=F+12|0;z=F+4|0;A=a+8|0;B=F+8|0;C=F+12|0;D=F+4|0;v=4;d=h;u=h;b=h;while(1){if((k[u+(v<<5)>>2]|0)>=1){e=u+(v<<5)+28|0;if(!(k[e>>2]|0)){N=k[b+(v<<5)+12>>2]|0;f=N+1|0;g=N>>2;h=k[b+(g<<5)+((N&3)<<2)>>2]|0;t=h+1|0;O=k[b+(v<<5)+16>>2]|0;c=k[a>>2]|0;M=+o[c+(O<<4)+8>>2];m=+o[c+(O<<4)+12>>2];O=k[b+(v<<5)+24>>2]|0;s=+o[c+(O<<4)+8>>2];q=+o[c+(O<<4)+12>>2];O=k[b+(g<<5)+16+((f&3)<<2)>>2]|0;L=+o[c+(O<<4)+8>>2];j=+o[c+(O<<4)+12>>2];N=k[b+(g<<5)+16+((N+3&3)<<2)>>2]|0;K=+o[c+(N<<4)+8>>2];n=+o[c+(N<<4)+12>>2];l=s-M;p=q-m;q=(l*(M+s)+p*(m+q))*-.5;m=K-L;s=n-j;n=(m*(L+K)+s*(j+n))*-.5;j=l*s-p*m;if(j!=0.0){j=1.0/j;l=j*(q*m-l*n);j=j*(p*n-q*s)}else{l=3402823466385288598117041.0e14;j=3402823466385288598117041.0e14}if(+P(+j)<170141173319264429905852.0e15?+P(+l)<170141173319264429905852.0e15:0){b=k[w>>2]|0;if(!b){o[x>>2]=0.0;o[y>>2]=0.0;k[F>>2]=0;k[z>>2]=-1;b=k[E>>2]|0;if((b|0)==(k[A>>2]|0)){Cua(a,F);b=k[E>>2]|0}else{d=F;N=k[d+4>>2]|0;O=b;k[O>>2]=k[d>>2];k[O+4>>2]=N;k[b+8>>2]=0;k[b+12>>2]=0;b=(k[E>>2]|0)+16|0;k[E>>2]=b}c=k[a>>2]|0;b=(b-c>>4)+-1|0;k[w>>2]=b}k[w>>2]=k[c+(b<<4)>>2];O=c+(b<<4)|0;k[O>>2]=0;k[O+4>>2]=1;o[c+(b<<4)+8>>2]=j;o[c+(b<<4)+12>>2]=l;O=k[I>>2]|0;k[O+(h>>2<<5)+16+((t&2^3)<<2)>>2]=b;k[O+(g<<5)+16+((f&2^3)<<2)>>2]=b;k[e>>2]=b;h=O;c=O;b=O}else{h=d;c=b}}else{h=d;c=b;b=u}t=u+(v<<5)+20|0;if(!(k[t>>2]|0)){O=k[h+(v<<5)+4>>2]|0;d=O+3|0;e=O>>2;f=k[h+(e<<5)+((O&3)<<2)>>2]|0;g=f+3|0;N=k[h+(v<<5)+16>>2]|0;c=k[a>>2]|0;K=+o[c+(N<<4)+8>>2];l=+o[c+(N<<4)+12>>2];N=k[h+(v<<5)+24>>2]|0;q=+o[c+(N<<4)+8>>2];p=+o[c+(N<<4)+12>>2];N=k[h+(e<<5)+16+((d&3)<<2)>>2]|0;L=+o[c+(N<<4)+8>>2];m=+o[c+(N<<4)+12>>2];O=k[h+(e<<5)+16+((O+1&3)<<2)>>2]|0;M=+o[c+(O<<4)+8>>2];s=+o[c+(O<<4)+12>>2];j=q-K;n=p-l;p=(j*(K+q)+n*(l+p))*-.5;l=M-L;q=s-m;s=(l*(L+M)+q*(m+s))*-.5;m=j*q-n*l;if(m!=0.0){M=1.0/m;l=M*(p*l-j*s);j=M*(n*s-p*q)}else{l=3402823466385288598117041.0e14;j=3402823466385288598117041.0e14}if(+P(+j)<170141173319264429905852.0e15?+P(+l)<170141173319264429905852.0e15:0){b=k[w>>2]|0;if(!b){o[B>>2]=0.0;o[C>>2]=0.0;k[F>>2]=0;k[D>>2]=-1;b=k[E>>2]|0;if((b|0)==(k[A>>2]|0)){Cua(a,F);b=k[E>>2]|0}else{u=F;N=k[u+4>>2]|0;O=b;k[O>>2]=k[u>>2];k[O+4>>2]=N;k[b+8>>2]=0;k[b+12>>2]=0;b=(k[E>>2]|0)+16|0;k[E>>2]=b}c=k[a>>2]|0;b=(b-c>>4)+-1|0;k[w>>2]=b}k[w>>2]=k[c+(b<<4)>>2];O=c+(b<<4)|0;k[O>>2]=0;k[O+4>>2]=1;o[c+(b<<4)+8>>2]=j;o[c+(b<<4)+12>>2]=l;O=k[I>>2]|0;k[O+(f>>2<<5)+16+((g&2|1)<<2)>>2]=b;k[O+(e<<5)+16+((d&2|1)<<2)>>2]=b;k[t>>2]=b;d=O;c=O;b=O}else{d=h;c=h;b=h}}else d=h}else{c=b;b=u}v=v+1|0;if((v|0)>=(G|0))break;else{u=b;b=c}}}i[H>>0]=1;r=J;return}function Hua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;k[a>>2]=0;h=a+4|0;k[h>>2]=0;k[a+8>>2]=0;g=b+4|0;c=(k[g>>2]|0)-(k[b>>2]|0)|0;e=c>>3;if(!e)return;if(e>>>0>536870911)ad(426534,426557,304,426811);d=(c|0)==0?1:c;while(1){c=fgb(d)|0;if(c|0){f=c;break}c=k[207666]|0;k[207666]=c+0;if(!c){f=0;break}Qh[c&7]()}k[h>>2]=f;k[a>>2]=f;k[a+8>>2]=f+(e<<3);e=k[b>>2]|0;d=k[g>>2]|0;if((e|0)==(d|0))return;a=d+-8|0;c=e;b=f;while(1){k[b>>2]=k[c>>2];k[b+4>>2]=k[c+4>>2];c=c+8|0;if((c|0)==(d|0))break;else b=b+8|0}k[h>>2]=f+(((a-e|0)>>>3)+1<<3);return}function Iua(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;N=r;r=r+320|0;q=N+312|0;G=N+248|0;M=N+256|0;L=N+192|0;K=N+136|0;J=N+80|0;o=N+16|0;C=N+24|0;t=N+8|0;H=N;n=S1(a,-1)|0;B=n&7;n=n>>>3&511;I=n+1|0;A=(B|0)==0;z=((e|0)<1?(A?4:6):e)&7;y=(f|0)<1?6:f&7;R1(q,a,-1);p=(k[q>>2]|0)+1|0;q=(k[q+4>>2]|0)+1|0;k[G>>2]=p;k[G+4>>2]=q;n=n<<3;s=z|n;x2(b,G,s,0);do if((k[a>>2]&2031616|0)==65536){g=k[a+4>>2]|0;k[M>>2]=k[g>>2];m=M+4|0;e=g+4|0;k[m>>2]=k[e>>2];G=M+8|0;k[G>>2]=k[g+8>>2];k[M+12>>2]=k[g+12>>2];k[M+16>>2]=k[g+16>>2];k[M+20>>2]=k[g+20>>2];k[M+24>>2]=k[g+24>>2];k[M+28>>2]=k[g+28>>2];k[M+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[M+36>>2]=f;a=M+40|0;k[a>>2]=G;G=M+48|0;j=M+44|0;k[j>>2]=G;k[M+52>>2]=0;k[G>>2]=0;if(f|0){G=f+12|0;k[G>>2]=(k[G>>2]|0)+1}if((k[e>>2]|0)<3){F=k[g+44>>2]|0;G=k[j>>2]|0;k[G>>2]=k[F>>2];k[G+4>>2]=k[F+4>>2];break}k[m>>2]=0;x1(M,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[a>>2]|0;a=k[g+44>>2]|0;f=k[j>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else Q1(M,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[L>>2]=k[g>>2];m=L+4|0;e=g+4|0;k[m>>2]=k[e>>2];G=L+8|0;k[G>>2]=k[g+8>>2];k[L+12>>2]=k[g+12>>2];k[L+16>>2]=k[g+16>>2];k[L+20>>2]=k[g+20>>2];k[L+24>>2]=k[g+24>>2];k[L+28>>2]=k[g+28>>2];k[L+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[L+36>>2]=f;a=L+40|0;k[a>>2]=G;G=L+48|0;j=L+44|0;k[j>>2]=G;k[L+52>>2]=0;k[G>>2]=0;if(f|0){G=f+12|0;k[G>>2]=(k[G>>2]|0)+1}if((k[e>>2]|0)<3){F=k[g+44>>2]|0;G=k[j>>2]|0;k[G>>2]=k[F>>2];k[G+4>>2]=k[F+4>>2];break}k[m>>2]=0;x1(L,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[a>>2]|0;a=k[g+44>>2]|0;f=k[j>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else Q1(L,b,-1);while(0);k[K>>2]=1124007936;F=K+4|0;e=K+8|0;D=K+40|0;f=F;a=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(a|0));k[D>>2]=e;G=K+48|0;E=K+44|0;k[E>>2]=G;k[K+52>>2]=0;k[G>>2]=0;k[J>>2]=1124007936;x=J+4|0;e=J+8|0;v=J+40|0;f=x;a=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(a|0));k[v>>2]=e;w=J+48|0;u=J+44|0;k[u>>2]=w;k[J+52>>2]=0;k[w>>2]=0;if(k[c>>2]&2031616|0){k[o>>2]=p;k[o+4>>2]=q;x2(c,o,n|y,0);do if((k[c>>2]&2031616|0)==65536){g=k[c+4>>2]|0;k[C>>2]=k[g>>2];m=C+4|0;e=g+4|0;k[m>>2]=k[e>>2];c=C+8|0;k[c>>2]=k[g+8>>2];k[C+12>>2]=k[g+12>>2];k[C+16>>2]=k[g+16>>2];k[C+20>>2]=k[g+20>>2];k[C+24>>2]=k[g+24>>2];k[C+28>>2]=k[g+28>>2];k[C+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[C+36>>2]=f;a=C+40|0;k[a>>2]=c;c=C+48|0;j=C+44|0;k[j>>2]=c;k[C+52>>2]=0;k[c>>2]=0;if(f|0){c=f+12|0;k[c>>2]=(k[c>>2]|0)+1}if((k[e>>2]|0)<3){o=k[g+44>>2]|0;c=k[j>>2]|0;k[c>>2]=k[o>>2];k[c+4>>2]=k[o+4>>2];break}k[m>>2]=0;x1(C,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[a>>2]|0;a=k[g+44>>2]|0;f=k[j>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else Q1(C,c,-1);while(0);KG(K,C)|0;a=C+36|0;e=k[a>>2]|0;if(e|0?(o=e+12|0,c=k[o>>2]|0,k[o>>2]=c+-1,(c|0)==1):0){f=k[a>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[C+32>>2]|0;if(!e){e=B1()|0;f=k[a>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[a>>2]=0}k[a>>2]=0;c=C+16|0;f=C+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[f>>2]|0)>0){a=k[C+40>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[C+44>>2]|0;if(!((e|0)==(C+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}if(k[d>>2]&2031616|0){k[t>>2]=p;k[t+4>>2]=q;x2(d,t,s,0);do if((k[d>>2]&2031616|0)==65536){g=k[d+4>>2]|0;k[C>>2]=k[g>>2];m=C+4|0;e=g+4|0;k[m>>2]=k[e>>2];d=C+8|0;k[d>>2]=k[g+8>>2];k[C+12>>2]=k[g+12>>2];k[C+16>>2]=k[g+16>>2];k[C+20>>2]=k[g+20>>2];k[C+24>>2]=k[g+24>>2];k[C+28>>2]=k[g+28>>2];k[C+32>>2]=k[g+32>>2];f=k[g+36>>2]|0;k[C+36>>2]=f;a=C+40|0;k[a>>2]=d;d=C+48|0;j=C+44|0;k[j>>2]=d;k[C+52>>2]=0;k[d>>2]=0;if(f|0){d=f+12|0;k[d>>2]=(k[d>>2]|0)+1}if((k[e>>2]|0)<3){t=k[g+44>>2]|0;d=k[j>>2]|0;k[d>>2]=k[t>>2];k[d+4>>2]=k[t+4>>2];break}k[m>>2]=0;x1(C,k[e>>2]|0,0,0,0);if((k[m>>2]|0)>0){l=k[g+40>>2]|0;h=k[a>>2]|0;a=k[g+44>>2]|0;f=k[j>>2]|0;e=0;do{k[h+(e<<2)>>2]=k[l+(e<<2)>>2];k[f+(e<<2)>>2]=k[a+(e<<2)>>2];e=e+1|0}while((e|0)<(k[m>>2]|0))}}else Q1(C,d,-1);while(0);KG(J,C)|0;a=C+36|0;e=k[a>>2]|0;if(e|0?(t=e+12|0,d=k[t>>2]|0,k[t>>2]=d+-1,(d|0)==1):0){f=k[a>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[C+32>>2]|0;if(!e){e=B1()|0;f=k[a>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[a>>2]=0}k[a>>2]=0;d=C+16|0;f=C+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[f>>2]|0)>0){a=k[C+40>>2]|0;e=0;do{k[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[f>>2]|0))}e=k[C+44>>2]|0;if(!((e|0)==(C+48|0)|(e|0)==0))ggb(k[e+-4>>2]|0)}e=A&(z|0)==4;h=(y|0)==6;if(!(h&e)){j=(y|0)==5;if(!(j&e))if(!((y|0)==4&e)){g=(z|0)==5;e=A&g;if(!(h&e))if(!(j&e)){a=(z|0)==6;if(!(h&(A&a)))if(!(h&((B|0)==2&a)))if(!(h&((B|0)==3&a))){f=(B|0)==5;e=f&g;if(!(h&e))if(!(j&e))if(!(h&(f&a)))if(h&((B|0)==6&a))e=17;else{k[C>>2]=0;B=C+4|0;k[B>>2]=0;e=ZT(8)|0;k[e>>2]=1;A=e+4|0;k[C>>2]=A;k[B>>2]=0;i[A>>0]=0;Y8(-210,C,352386,352395,554);k[B>>2]=0;k[C>>2]=0;C=k[e>>2]|0;k[e>>2]=C+-1;if((C|0)==1)ggb(k[e+-4>>2]|0);e=0}else e=16;else e=15;else e=14}else e=13;else e=12;else e=11}else e=10;else e=9}else e=8;else e=7}else e=6;b=M+16|0;t=k[b>>2]|0;o=M+44|0;c=M+48|0;d=k[c>>2]|0;j=L+16|0;y=k[j>>2]|0;l=L+44|0;m=L+48|0;z=k[m>>2]|0;h=K+16|0;A=k[h>>2]|0;B=k[G>>2]|0;g=J+16|0;C=k[g>>2]|0;a=k[w>>2]|0;n=M+40|0;q=k[n>>2]|0;s=k[q>>2]|0;k[H>>2]=k[q+4>>2];k[H+4>>2]=s;Sg[e&31](t,d,y,z,A,B,C,a,H,I);a=J+36|0;e=k[a>>2]|0;if(e|0?(H=e+12|0,I=k[H>>2]|0,k[H>>2]=I+-1,(I|0)==1):0){f=k[a>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[J+32>>2]|0;if(!e){e=B1()|0;f=k[a>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[a>>2]=0}k[a>>2]=0;k[g>>2]=0;k[g+4>>2]=0;k[g+8>>2]=0;k[g+12>>2]=0;if((k[x>>2]|0)>0){f=k[v>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[x>>2]|0))}e=k[u>>2]|0;if(!((e|0)==(w|0)|(e|0)==0))ggb(k[e+-4>>2]|0);a=K+36|0;e=k[a>>2]|0;if(e|0?(I=e+12|0,J=k[I>>2]|0,k[I>>2]=J+-1,(J|0)==1):0){f=k[a>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[K+32>>2]|0;if(!e){e=B1()|0;f=k[a>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[a>>2]=0}k[a>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[F>>2]|0)>0){f=k[D>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[F>>2]|0))}e=k[E>>2]|0;if(!((e|0)==(G|0)|(e|0)==0))ggb(k[e+-4>>2]|0);a=L+36|0;e=k[a>>2]|0;if(e|0?(J=e+12|0,K=k[J>>2]|0,k[J>>2]=K+-1,(K|0)==1):0){f=k[a>>2]|0;if(f|0){e=k[f+4>>2]|0;if(!e){e=k[L+32>>2]|0;if(!e){e=B1()|0;f=k[a>>2]|0}}jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[a>>2]=0}k[a>>2]=0;a=L+4|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;if((k[a>>2]|0)>0){f=k[L+40>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[a>>2]|0))}e=k[l>>2]|0;if(!((e|0)==(m|0)|(e|0)==0))ggb(k[e+-4>>2]|0);a=M+36|0;e=k[a>>2]|0;if(e|0?(K=e+12|0,L=k[K>>2]|0,k[K>>2]=L+-1,(L|0)==1):0){f=k[a>>2]|0;if(f|0){e=k[f+4>>2]|0;do if(!e){e=k[M+32>>2]|0;if(e|0)break;e=B1()|0;f=k[a>>2]|0}while(0);jh[k[(k[e>>2]|0)+24>>2]&1023](e,f)}k[a>>2]=0}k[a>>2]=0;a=M+4|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;if((k[a>>2]|0)>0){f=k[n>>2]|0;e=0;do{k[f+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(k[a>>2]|0))}e=k[o>>2]|0;if((e|0)==(c|0)|(e|0)==0){r=N;return}ggb(k[e+-4>>2]|0);r=N;return}function Jua(a,b,c,d,e,f,g,h,j,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;m=m|0;var n=0,o=0,q=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0;V=r;r=r+1072|0;P=V;T=k[j+4>>2]|0;U=0-m|0;S=d>>>2;N=h>>>2;O=0-N|0;Q=f>>>3;R=aa(k[j>>2]|0,m)|0;f=R+m|0;d=f<<2;zpb(c|0,0,d|0)|0;n=c+(S+m<<2)|0;if(!e)o=0;else{zpb(e|0,0,f<<3|0)|0;o=e+(Q+m<<3)|0}if(!g)v=0;else{zpb(g|0,0,d|0)|0;v=g+(N+m<<2)|0}d=(v|0)==0;if((o|0)==0&d){if((T|0)<=0){r=V;return}o=b-m|0;q=S-m|0;if((m|0)<=0){r=V;return}s=(R|0)>0;g=0;while(1){f=0;j=n;e=a;while(1){k[j+(U<<2)>>2]=0;if(s){d=0;h=0;do{h=(l[e+d>>0]|0)+h|0;k[j+(d<<2)>>2]=h+(k[j+(d-S<<2)>>2]|0);d=d+m|0}while((d|0)<(R|0))}f=f+1|0;if((f|0)==(m|0))break;else{j=j+4|0;e=e+1|0}}g=g+1|0;if((g|0)==(T|0))break;else{n=n+(m<<2)+(q<<2)|0;a=a+m+o|0}}r=V;return}if(d){if((T|0)<=0){r=V;return}s=b-m|0;u=S-m|0;v=Q-m|0;if((m|0)<=0){r=V;return}c=(R|0)>0;q=0;while(1){f=0;j=o;e=n;g=a;while(1){k[e+(U<<2)>>2]=0;p[j+(U<<3)>>3]=0.0;if(c){t=0.0;d=0;h=0;do{P=i[g+h>>0]|0;d=(P&255)+d|0;W=+(P&255);t=t+W*W;W=+p[j+(h-Q<<3)>>3]+t;k[e+(h<<2)>>2]=d+(k[e+(h-S<<2)>>2]|0);p[j+(h<<3)>>3]=W;h=h+m|0}while((h|0)<(R|0))}f=f+1|0;if((f|0)==(m|0))break;else{j=j+8|0;e=e+4|0;g=g+1|0}}q=q+1|0;if((q|0)==(T|0))break;else{o=o+(m<<3)+(v<<3)|0;n=n+(m<<2)+(u<<2)|0;a=a+m+s|0}}r=V;return}L=P+8|0;k[P>>2]=L;M=P+4|0;k[M>>2]=264;if(f>>>0>264){h=f>>>0>1073741823?-1:f<<2;h=(h|0)==0?1:h;while(1){d=fgb(h)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[P>>2]=d}else d=L;k[M>>2]=f;K=(m|0)>0;if(K){u=S+(m<<1)|0;s=(R|0)>0;e=d;g=v;q=0;j=a;while(1){k[g+(U<<2)>>2]=0;k[n+(U<<2)>>2]=0;if(s)if(!o){h=0;f=0;do{J=l[j+f>>0]|0;k[g+(f<<2)>>2]=J;k[e+(f<<2)>>2]=J;h=J+h|0;k[n+(f<<2)>>2]=h;f=f+m|0}while((f|0)<(R|0))}else{t=0.0;h=0;f=0;do{J=i[j+f>>0]|0;I=J&255;k[g+(f<<2)>>2]=I;k[e+(f<<2)>>2]=I;h=I+h|0;W=+(J&255);t=t+W*W;k[n+(f<<2)>>2]=h;p[o+(f<<3)>>3]=t;f=f+m|0}while((f|0)<(R|0))}if((R|0)==(m|0))k[e+(m<<2)>>2]=0;if(!o)o=0;else{p[o+(U<<3)>>3]=0.0;o=o+8|0}q=q+1|0;if((q|0)==(m|0))break;else{e=e+4|0;g=g+4|0;n=n+4|0;j=j+1|0}}h=d+(m<<2)|0;f=v+(m<<2)|0;a=a+m|0;n=c+(u<<2)|0}else{h=d;f=v}if((T|0)>1){B=b-m|0;C=S-m|0;D=N-m|0;E=Q-m|0;F=0-S|0;G=0-Q|0;J=N+m|0;H=R-m|0;I=(H|0)>(m|0);z=h;A=1;while(1){e=a+B|0;g=n+(C<<2)|0;j=f+(D<<2)|0;h=z+(U<<2)|0;o=(o|0)==0?0:o+(E<<3)|0;if(K){y=0;x=e;while(1){w=i[x>>0]|0;s=w&255;t=+(w&255);t=t*t;k[g+(U<<2)>>2]=0;w=(o|0)!=0;if(w)p[o+(U<<3)>>3]=0.0;e=j+(O<<2)|0;k[j+(U<<2)>>2]=k[e>>2];k[g>>2]=(k[g+(F<<2)>>2]|0)+s;if(w)p[o>>3]=t+ +p[o+(G<<3)>>3];k[j>>2]=(k[e>>2]|0)+s+(k[h+(m<<2)>>2]|0);if(I)if(w){q=s;e=s;s=m;while(1){c=k[h+(s<<2)>>2]|0;k[h+(s-m<<2)>>2]=c+q;u=i[x+s>>0]|0;q=u&255;W=+(u&255);e=q+e|0;t=t+W*W;k[g+(s<<2)>>2]=e+(k[g+(s-S<<2)>>2]|0);p[o+(s<<3)>>3]=t+ +p[o+(s-Q<<3)>>3];u=s+m|0;k[j+(s<<2)>>2]=q+c+(k[h+(u<<2)>>2]|0)+(k[j+(s-J<<2)>>2]|0);if((u|0)<(H|0))s=u;else break}}else{q=s;e=s;s=m;while(1){c=k[h+(s<<2)>>2]|0;k[h+(s-m<<2)>>2]=c+q;u=i[x+s>>0]|0;q=u&255;W=+(u&255);e=q+e|0;t=t+W*W;k[g+(s<<2)>>2]=e+(k[g+(s-S<<2)>>2]|0);u=s+m|0;k[j+(s<<2)>>2]=q+c+(k[h+(u<<2)>>2]|0)+(k[j+(s-J<<2)>>2]|0);if((u|0)<(H|0))s=u;else break}}else{q=s;e=s;u=m}if((R|0)>(m|0)){v=h+(u<<2)|0;c=k[v>>2]|0;k[h+(u-m<<2)>>2]=c+q;q=i[x+u>>0]|0;s=q&255;k[g+(u<<2)>>2]=s+e+(k[g+(u-S<<2)>>2]|0);if(w){W=+(q&255);p[o+(u<<3)>>3]=t+W*W+ +p[o+(u-Q<<3)>>3]}k[j+(u<<2)>>2]=s+c+(k[j+(u-J<<2)>>2]|0);k[v>>2]=s}o=w?o+8|0:0;y=y+1|0;if((y|0)==(m|0))break;else{h=h+4|0;j=j+4|0;g=g+4|0;x=x+1|0}}h=z;f=f+(N<<2)|0;a=a+b|0;n=n+(S<<2)|0}else{f=j;a=e;n=g}A=A+1|0;if((A|0)>=(T|0))break;else z=h}}if((d|0)!=(L|0)){ggb(d);k[P>>2]=L;k[M>>2]=264}r=V;return}function Kua(a,b,c,d,e,f,g,h,j,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;m=m|0;var n=0,p=0,q=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0;V=r;r=r+1072|0;P=V;T=k[j+4>>2]|0;U=0-m|0;S=d>>>2;N=h>>>2;O=0-N|0;Q=f>>>2;R=aa(k[j>>2]|0,m)|0;f=R+m|0;d=f<<2;zpb(c|0,0,d|0)|0;n=c+(S+m<<2)|0;if(!e)p=0;else{zpb(e|0,0,d|0)|0;p=e+(Q+m<<2)|0}if(!g)v=0;else{zpb(g|0,0,d|0)|0;v=g+(N+m<<2)|0}d=(v|0)==0;if((p|0)==0&d){if((T|0)<=0){r=V;return}p=b-m|0;q=S-m|0;if((m|0)<=0){r=V;return}s=(R|0)>0;g=0;while(1){f=0;j=n;e=a;while(1){k[j+(U<<2)>>2]=0;if(s){d=0;h=0;do{h=(l[e+d>>0]|0)+h|0;k[j+(d<<2)>>2]=h+(k[j+(d-S<<2)>>2]|0);d=d+m|0}while((d|0)<(R|0))}f=f+1|0;if((f|0)==(m|0))break;else{j=j+4|0;e=e+1|0}}g=g+1|0;if((g|0)==(T|0))break;else{n=n+(m<<2)+(q<<2)|0;a=a+m+p|0}}r=V;return}if(d){if((T|0)<=0){r=V;return}s=b-m|0;u=S-m|0;v=Q-m|0;if((m|0)<=0){r=V;return}c=(R|0)>0;q=0;while(1){f=0;j=p;e=n;g=a;while(1){k[e+(U<<2)>>2]=0;o[j+(U<<2)>>2]=0.0;if(c){t=0.0;d=0;h=0;do{P=i[g+h>>0]|0;d=(P&255)+d|0;W=+(P&255);t=t+W*W;W=+o[j+(h-Q<<2)>>2]+t;k[e+(h<<2)>>2]=d+(k[e+(h-S<<2)>>2]|0);o[j+(h<<2)>>2]=W;h=h+m|0}while((h|0)<(R|0))}f=f+1|0;if((f|0)==(m|0))break;else{j=j+4|0;e=e+4|0;g=g+1|0}}q=q+1|0;if((q|0)==(T|0))break;else{p=p+(m<<2)+(v<<2)|0;n=n+(m<<2)+(u<<2)|0;a=a+m+s|0}}r=V;return}L=P+8|0;k[P>>2]=L;M=P+4|0;k[M>>2]=264;if(f>>>0>264){h=f>>>0>1073741823?-1:f<<2;h=(h|0)==0?1:h;while(1){d=fgb(h)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[P>>2]=d}else d=L;k[M>>2]=f;K=(m|0)>0;if(K){u=S+(m<<1)|0;s=(R|0)>0;e=d;g=v;q=0;j=a;while(1){k[g+(U<<2)>>2]=0;k[n+(U<<2)>>2]=0;if(s)if(!p){h=0;f=0;do{J=l[j+f>>0]|0;k[g+(f<<2)>>2]=J;k[e+(f<<2)>>2]=J;h=J+h|0;k[n+(f<<2)>>2]=h;f=f+m|0}while((f|0)<(R|0))}else{t=0.0;h=0;f=0;do{J=i[j+f>>0]|0;I=J&255;k[g+(f<<2)>>2]=I;k[e+(f<<2)>>2]=I;h=I+h|0;W=+(J&255);t=t+W*W;k[n+(f<<2)>>2]=h;o[p+(f<<2)>>2]=t;f=f+m|0}while((f|0)<(R|0))}if((R|0)==(m|0))k[e+(m<<2)>>2]=0;if(!p)p=0;else{o[p+(U<<2)>>2]=0.0;p=p+4|0}q=q+1|0;if((q|0)==(m|0))break;else{e=e+4|0;g=g+4|0;n=n+4|0;j=j+1|0}}h=d+(m<<2)|0;f=v+(m<<2)|0;a=a+m|0;n=c+(u<<2)|0}else{h=d;f=v}if((T|0)>1){B=b-m|0;C=S-m|0;D=N-m|0;E=Q-m|0;F=0-S|0;G=0-Q|0;J=N+m|0;H=R-m|0;I=(H|0)>(m|0);z=h;A=1;while(1){e=a+B|0;g=n+(C<<2)|0;j=f+(D<<2)|0;h=z+(U<<2)|0;p=(p|0)==0?0:p+(E<<2)|0;if(K){y=0;x=e;while(1){w=i[x>>0]|0;s=w&255;t=+(w&255);t=t*t;k[g+(U<<2)>>2]=0;w=(p|0)!=0;if(w)o[p+(U<<2)>>2]=0.0;e=j+(O<<2)|0;k[j+(U<<2)>>2]=k[e>>2];k[g>>2]=(k[g+(F<<2)>>2]|0)+s;if(w)o[p>>2]=t+ +o[p+(G<<2)>>2];k[j>>2]=(k[e>>2]|0)+s+(k[h+(m<<2)>>2]|0);if(I)if(w){q=s;e=s;s=m;while(1){c=k[h+(s<<2)>>2]|0;k[h+(s-m<<2)>>2]=c+q;u=i[x+s>>0]|0;q=u&255;W=+(u&255);e=q+e|0;t=t+W*W;k[g+(s<<2)>>2]=e+(k[g+(s-S<<2)>>2]|0);o[p+(s<<2)>>2]=t+ +o[p+(s-Q<<2)>>2];u=s+m|0;k[j+(s<<2)>>2]=q+c+(k[h+(u<<2)>>2]|0)+(k[j+(s-J<<2)>>2]|0);if((u|0)<(H|0))s=u;else break}}else{q=s;e=s;s=m;while(1){c=k[h+(s<<2)>>2]|0;k[h+(s-m<<2)>>2]=c+q;u=i[x+s>>0]|0;q=u&255;W=+(u&255);e=q+e|0;t=t+W*W;k[g+(s<<2)>>2]=e+(k[g+(s-S<<2)>>2]|0);u=s+m|0;k[j+(s<<2)>>2]=q+c+(k[h+(u<<2)>>2]|0)+(k[j+(s-J<<2)>>2]|0);if((u|0)<(H|0))s=u;else break}}else{q=s;e=s;u=m}if((R|0)>(m|0)){v=h+(u<<2)|0;c=k[v>>2]|0;k[h+(u-m<<2)>>2]=c+q;q=i[x+u>>0]|0;s=q&255;k[g+(u<<2)>>2]=s+e+(k[g+(u-S<<2)>>2]|0);if(w){W=+(q&255);o[p+(u<<2)>>2]=t+W*W+ +o[p+(u-Q<<2)>>2]}k[j+(u<<2)>>2]=s+c+(k[j+(u-J<<2)>>2]|0);k[v>>2]=s}p=w?p+4|0:0;y=y+1|0;if((y|0)==(m|0))break;else{h=h+4|0;j=j+4|0;g=g+4|0;x=x+1|0}}h=z;f=f+(N<<2)|0;a=a+b|0;n=n+(S<<2)|0}else{f=j;a=e;n=g}A=A+1|0;if((A|0)>=(T|0))break;else z=h}}if((d|0)!=(L|0)){ggb(d);k[P>>2]=L;k[M>>2]=264}r=V;return}function Lua(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;S=r;r=r+1072|0;M=S;Q=k[i+4>>2]|0;R=0-j|0;P=d>>>2;K=h>>>2;L=0-K|0;N=f>>>2;O=aa(k[i>>2]|0,j)|0;f=O+j|0;d=f<<2;zpb(c|0,0,d|0)|0;m=c+(P+j<<2)|0;if(!e)o=0;else{zpb(e|0,0,d|0)|0;o=e+(N+j<<2)|0}if(!g)t=0;else{zpb(g|0,0,d|0)|0;t=g+(K+j<<2)|0}d=(t|0)==0;if((o|0)==0&d){if((Q|0)<=0){r=S;return}n=b-j|0;o=P-j|0;if((j|0)<=0){r=S;return}p=(O|0)>0;g=0;while(1){f=0;i=m;e=a;while(1){k[i+(R<<2)>>2]=0;if(p){d=0;h=0;do{h=(l[e+d>>0]|0)+h|0;k[i+(d<<2)>>2]=h+(k[i+(d-P<<2)>>2]|0);d=d+j|0}while((d|0)<(O|0))}f=f+1|0;if((f|0)==(j|0))break;else{i=i+4|0;e=e+1|0}}g=g+1|0;if((g|0)==(Q|0))break;else{m=m+(j<<2)+(o<<2)|0;a=a+j+n|0}}r=S;return}if(d){if((Q|0)<=0){r=S;return}q=b-j|0;s=P-j|0;t=N-j|0;if((j|0)<=0){r=S;return}c=(O|0)>0;p=0;while(1){i=0;e=o;g=m;n=a;while(1){k[g+(R<<2)>>2]=0;k[e+(R<<2)>>2]=0;if(c){d=0;h=0;f=0;do{M=l[n+f>>0]|0;h=M+h|0;d=(aa(M,M)|0)+d|0;M=d+(k[e+(f-N<<2)>>2]|0)|0;k[g+(f<<2)>>2]=h+(k[g+(f-P<<2)>>2]|0);k[e+(f<<2)>>2]=M;f=f+j|0}while((f|0)<(O|0))}i=i+1|0;if((i|0)==(j|0))break;else{e=e+4|0;g=g+4|0;n=n+1|0}}p=p+1|0;if((p|0)==(Q|0))break;else{o=o+(j<<2)+(t<<2)|0;m=m+(j<<2)+(s<<2)|0;a=a+j+q|0}}r=S;return}I=M+8|0;k[M>>2]=I;J=M+4|0;k[J>>2]=264;if(f>>>0>264){h=f>>>0>1073741823?-1:f<<2;h=(h|0)==0?1:h;while(1){d=fgb(h)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[M>>2]=d}else d=I;k[J>>2]=f;H=(j|0)>0;if(H){s=P+(j<<1)|0;q=(O|0)>0;g=d;n=t;p=0;e=a;while(1){k[n+(R<<2)>>2]=0;k[m+(R<<2)>>2]=0;if(q)if(!o){h=0;f=0;do{G=l[e+f>>0]|0;k[n+(f<<2)>>2]=G;k[g+(f<<2)>>2]=G;h=G+h|0;k[m+(f<<2)>>2]=h;f=f+j|0}while((f|0)<(O|0))}else{h=0;f=0;i=0;do{G=l[e+i>>0]|0;k[n+(i<<2)>>2]=G;k[g+(i<<2)>>2]=G;f=G+f|0;h=(aa(G,G)|0)+h|0;k[m+(i<<2)>>2]=f;k[o+(i<<2)>>2]=h;i=i+j|0}while((i|0)<(O|0))}if((O|0)==(j|0))k[g+(j<<2)>>2]=0;if(!o)o=0;else{k[o+(R<<2)>>2]=0;o=o+4|0}p=p+1|0;if((p|0)==(j|0))break;else{g=g+4|0;n=n+4|0;m=m+4|0;e=e+1|0}}h=d+(j<<2)|0;f=t+(j<<2)|0;a=a+j|0;m=c+(s<<2)|0}else{h=d;f=t}if((Q|0)>1){y=b-j|0;z=P-j|0;A=K-j|0;B=N-j|0;C=0-P|0;D=0-N|0;G=K+j|0;E=O-j|0;F=(E|0)>(j|0);w=h;x=1;while(1){e=a+y|0;g=m+(z<<2)|0;i=f+(A<<2)|0;h=w+(R<<2)|0;o=(o|0)==0?0:o+(B<<2)|0;if(H){v=0;u=e;while(1){q=l[u>>0]|0;n=aa(q,q)|0;k[g+(R<<2)>>2]=0;c=(o|0)!=0;if(c)k[o+(R<<2)>>2]=0;e=i+(L<<2)|0;k[i+(R<<2)>>2]=k[e>>2];k[g>>2]=(k[g+(C<<2)>>2]|0)+q;if(c)k[o>>2]=(k[o+(D<<2)>>2]|0)+n;k[i>>2]=(k[e>>2]|0)+q+(k[h+(j<<2)>>2]|0);if(F)if(c){p=q;e=q;s=j;while(1){t=k[h+(s<<2)>>2]|0;k[h+(s-j<<2)>>2]=t+p;p=l[u+s>>0]|0;e=p+e|0;n=(aa(p,p)|0)+n|0;k[g+(s<<2)>>2]=e+(k[g+(s-P<<2)>>2]|0);k[o+(s<<2)>>2]=(k[o+(s-N<<2)>>2]|0)+n;q=s+j|0;k[i+(s<<2)>>2]=p+t+(k[h+(q<<2)>>2]|0)+(k[i+(s-G<<2)>>2]|0);if((q|0)<(E|0))s=q;else break}}else{p=q;e=q;s=j;while(1){t=k[h+(s<<2)>>2]|0;k[h+(s-j<<2)>>2]=t+p;p=l[u+s>>0]|0;e=p+e|0;n=(aa(p,p)|0)+n|0;k[g+(s<<2)>>2]=e+(k[g+(s-P<<2)>>2]|0);q=s+j|0;k[i+(s<<2)>>2]=p+t+(k[h+(q<<2)>>2]|0)+(k[i+(s-G<<2)>>2]|0);if((q|0)<(E|0))s=q;else break}}else{p=q;e=q;q=j}if((O|0)>(j|0)){s=h+(q<<2)|0;t=k[s>>2]|0;k[h+(q-j<<2)>>2]=t+p;p=l[u+q>>0]|0;k[g+(q<<2)>>2]=p+e+(k[g+(q-P<<2)>>2]|0);if(c){n=(aa(p,p)|0)+n|0;k[o+(q<<2)>>2]=n+(k[o+(q-N<<2)>>2]|0)}k[i+(q<<2)>>2]=p+t+(k[i+(q-G<<2)>>2]|0);k[s>>2]=p}o=c?o+4|0:0;v=v+1|0;if((v|0)==(j|0))break;else{h=h+4|0;i=i+4|0;g=g+4|0;u=u+1|0}}h=w;f=f+(K<<2)|0;a=a+b|0;m=m+(P<<2)|0}else{f=i;a=e;m=g}x=x+1|0;if((x|0)>=(Q|0))break;else w=h}}if((d|0)!=(I|0)){ggb(d);k[M>>2]=I;k[J>>2]=264}r=S;return}function Mua(a,b,c,d,e,f,g,h,j,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;m=m|0;var n=0.0,q=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0;W=r;r=r+1072|0;R=W;U=k[j+4>>2]|0;V=0-m|0;T=d>>>2;P=h>>>2;Q=0-P|0;S=f>>>3;B=aa(k[j>>2]|0,m)|0;f=B+m|0;d=f<<2;zpb(c|0,0,d|0)|0;q=c+(T+m<<2)|0;if(!e)y=0;else{zpb(e|0,0,f<<3|0)|0;y=e+(S+m<<3)|0}if(!g)x=0;else{zpb(g|0,0,d|0)|0;x=g+(P+m<<2)|0}d=(x|0)==0;if((y|0)==0&d){if((U|0)<=0){r=W;return}g=b-m|0;s=T-m|0;if((m|0)<=0){r=W;return}t=(B|0)>0;e=0;while(1){h=0;f=q;j=a;while(1){o[f+(V<<2)>>2]=0.0;if(t){d=0;n=0.0;do{n=n+ +(l[j+d>>0]|0);o[f+(d<<2)>>2]=+o[f+(d-T<<2)>>2]+n;d=d+m|0}while((d|0)<(B|0))}h=h+1|0;if((h|0)==(m|0))break;else{f=f+4|0;j=j+1|0}}e=e+1|0;if((e|0)==(U|0))break;else{q=q+(m<<2)+(s<<2)|0;a=a+m+g|0}}r=W;return}if(d){if((U|0)<=0){r=W;return}t=b-m|0;v=T-m|0;w=S-m|0;if((m|0)<=0){r=W;return}x=(B|0)>0;g=y;s=0;while(1){h=0;f=g;j=q;e=a;while(1){o[j+(V<<2)>>2]=0.0;p[f+(V<<3)>>3]=0.0;if(x){n=0.0;u=0.0;d=0;do{R=i[e+d>>0]|0;u=u+ +(R&255);A=+(R&255);n=n+A*A;A=+p[f+(d-S<<3)>>3]+n;o[j+(d<<2)>>2]=+o[j+(d-T<<2)>>2]+u;p[f+(d<<3)>>3]=A;d=d+m|0}while((d|0)<(B|0))}h=h+1|0;if((h|0)==(m|0))break;else{f=f+8|0;j=j+4|0;e=e+1|0}}s=s+1|0;if((s|0)==(U|0))break;else{g=g+(m<<3)+(w<<3)|0;q=q+(m<<2)+(v<<2)|0;a=a+m+t|0}}r=W;return}N=R+8|0;k[R>>2]=N;O=R+4|0;k[O>>2]=264;if(f>>>0>264){h=f>>>0>1073741823?-1:f<<2;h=(h|0)==0?1:h;while(1){d=fgb(h)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[R>>2]=d}else d=N;k[O>>2]=f;M=(m|0)>0;if(M){w=T+(m<<1)|0;t=(B|0)>0;v=(B|0)==(m|0);e=d;g=x;s=0;f=y;j=a;while(1){o[g+(V<<2)>>2]=0.0;o[q+(V<<2)>>2]=0.0;if(t)if(!f){n=0.0;h=0;do{A=+(l[j+h>>0]|0);o[g+(h<<2)>>2]=A;o[e+(h<<2)>>2]=A;n=n+A;o[q+(h<<2)>>2]=n;h=h+m|0}while((h|0)<(B|0))}else{n=0.0;u=0.0;h=0;do{L=i[j+h>>0]|0;A=+(L&255);o[g+(h<<2)>>2]=A;o[e+(h<<2)>>2]=A;u=u+A;A=+(L&255);n=n+A*A;o[q+(h<<2)>>2]=u;p[f+(h<<3)>>3]=n;h=h+m|0}while((h|0)<(B|0))}if(v)o[e+(m<<2)>>2]=0.0;if(!f)h=0;else{p[f+(V<<3)>>3]=0.0;h=f+8|0}s=s+1|0;if((s|0)==(m|0))break;else{e=e+4|0;g=g+4|0;f=h;q=q+4|0;j=j+1|0}}f=d+(m<<2)|0;j=x+(m<<2)|0;a=a+m|0;q=c+(w<<2)|0}else{f=d;j=x;h=y}if((U|0)>1){D=b-m|0;E=T-m|0;F=P-m|0;G=S-m|0;H=0-T|0;I=0-S|0;L=P+m|0;J=B-m|0;K=(J|0)>(m|0);C=(B|0)>(m|0);c=f;B=1;while(1){g=a+D|0;s=q+(E<<2)|0;e=j+(F<<2)|0;f=c+(V<<2)|0;h=(h|0)==0?0:h+(G<<3)|0;if(M){y=0;x=g;while(1){w=i[x>>0]|0;A=+(w&255);n=+(w&255);n=n*n;o[s+(V<<2)>>2]=0.0;w=(h|0)!=0;if(w)p[h+(V<<3)>>3]=0.0;g=e+(Q<<2)|0;k[e+(V<<2)>>2]=k[g>>2];o[s>>2]=A+ +o[s+(H<<2)>>2];if(w)p[h>>3]=n+ +p[h+(I<<3)>>3];o[e>>2]=A+ +o[g>>2]+ +o[f+(m<<2)>>2];if(K)if(w){u=A;z=n;n=A;g=m;while(1){A=+o[f+(g<<2)>>2];o[f+(g-m<<2)>>2]=u+A;t=i[x+g>>0]|0;u=+(t&255);X=+(t&255);n=n+u;z=z+X*X;o[s+(g<<2)>>2]=+o[s+(g-T<<2)>>2]+n;p[h+(g<<3)>>3]=z+ +p[h+(g-S<<3)>>3];t=g+m|0;o[e+(g<<2)>>2]=A+(u+ +o[f+(t<<2)>>2]+ +o[e+(g-L<<2)>>2]);if((t|0)<(J|0))g=t;else break}}else{u=A;z=n;n=A;g=m;while(1){X=+o[f+(g<<2)>>2];o[f+(g-m<<2)>>2]=u+X;t=i[x+g>>0]|0;u=+(t&255);A=+(t&255);n=n+u;z=z+A*A;o[s+(g<<2)>>2]=+o[s+(g-T<<2)>>2]+n;t=g+m|0;o[e+(g<<2)>>2]=X+(u+ +o[f+(t<<2)>>2]+ +o[e+(g-L<<2)>>2]);if((t|0)<(J|0))g=t;else break}}else{u=A;z=n;n=A;t=m}if(C){v=f+(t<<2)|0;A=+o[v>>2];o[f+(t-m<<2)>>2]=u+A;g=i[x+t>>0]|0;u=+(g&255);o[s+(t<<2)>>2]=+o[s+(t-T<<2)>>2]+(n+u);if(w){X=+(g&255);p[h+(t<<3)>>3]=z+X*X+ +p[h+(t-S<<3)>>3]}o[e+(t<<2)>>2]=A+u+ +o[e+(t-L<<2)>>2];o[v>>2]=u}h=w?h+8|0:0;y=y+1|0;if((y|0)==(m|0))break;else{f=f+4|0;e=e+4|0;s=s+4|0;x=x+1|0}}f=c;j=j+(P<<2)|0;a=a+b|0;q=q+(T<<2)|0}else{j=e;a=g;q=s}B=B+1|0;if((B|0)==(U|0))break;else c=f}}if((d|0)!=(N|0)){ggb(d);k[R>>2]=N;k[O>>2]=264}r=W;return}function Nua(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var m=0.0,n=0,p=0,q=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;T=r;r=r+1072|0;O=T;R=k[i+4>>2]|0;S=0-j|0;Q=d>>>2;M=h>>>2;N=0-M|0;P=f>>>2;z=aa(k[i>>2]|0,j)|0;f=z+j|0;d=f<<2;zpb(c|0,0,d|0)|0;n=c+(Q+j<<2)|0;if(!e)w=0;else{zpb(e|0,0,d|0)|0;w=e+(P+j<<2)|0}if(!g)v=0;else{zpb(g|0,0,d|0)|0;v=g+(M+j<<2)|0}d=(v|0)==0;if((w|0)==0&d){if((R|0)<=0){r=T;return}g=b-j|0;p=Q-j|0;if((j|0)<=0){r=T;return}q=(z|0)>0;e=0;while(1){h=0;f=n;i=a;while(1){o[f+(S<<2)>>2]=0.0;if(q){d=0;m=0.0;do{m=m+ +(l[i+d>>0]|0);o[f+(d<<2)>>2]=+o[f+(d-Q<<2)>>2]+m;d=d+j|0}while((d|0)<(z|0))}h=h+1|0;if((h|0)==(j|0))break;else{f=f+4|0;i=i+1|0}}e=e+1|0;if((e|0)==(R|0))break;else{n=n+(j<<2)+(p<<2)|0;a=a+j+g|0}}r=T;return}if(d){if((R|0)<=0){r=T;return}q=b-j|0;t=Q-j|0;u=P-j|0;if((j|0)<=0){r=T;return}v=(z|0)>0;g=w;p=0;while(1){h=0;f=g;i=n;e=a;while(1){o[i+(S<<2)>>2]=0.0;o[f+(S<<2)>>2]=0.0;if(v){m=0.0;s=0.0;d=0;do{y=+(l[e+d>>0]|0);s=s+y;m=m+y*y;y=+o[f+(d-P<<2)>>2]+m;o[i+(d<<2)>>2]=+o[i+(d-Q<<2)>>2]+s;o[f+(d<<2)>>2]=y;d=d+j|0}while((d|0)<(z|0))}h=h+1|0;if((h|0)==(j|0))break;else{f=f+4|0;i=i+4|0;e=e+1|0}}p=p+1|0;if((p|0)==(R|0))break;else{g=g+(j<<2)+(u<<2)|0;n=n+(j<<2)+(t<<2)|0;a=a+j+q|0}}r=T;return}K=O+8|0;k[O>>2]=K;L=O+4|0;k[L>>2]=264;if(f>>>0>264){h=f>>>0>1073741823?-1:f<<2;h=(h|0)==0?1:h;while(1){d=fgb(h)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[O>>2]=d}else d=K;k[L>>2]=f;J=(j|0)>0;if(J){u=Q+(j<<1)|0;q=(z|0)>0;t=(z|0)==(j|0);e=d;g=v;p=0;f=w;i=a;while(1){o[g+(S<<2)>>2]=0.0;o[n+(S<<2)>>2]=0.0;if(q)if(!f){m=0.0;h=0;do{y=+(l[i+h>>0]|0);o[g+(h<<2)>>2]=y;o[e+(h<<2)>>2]=y;m=m+y;o[n+(h<<2)>>2]=m;h=h+j|0}while((h|0)<(z|0))}else{m=0.0;s=0.0;h=0;do{y=+(l[i+h>>0]|0);o[g+(h<<2)>>2]=y;o[e+(h<<2)>>2]=y;s=s+y;m=m+y*y;o[n+(h<<2)>>2]=s;o[f+(h<<2)>>2]=m;h=h+j|0}while((h|0)<(z|0))}if(t)o[e+(j<<2)>>2]=0.0;if(!f)h=0;else{o[f+(S<<2)>>2]=0.0;h=f+4|0}p=p+1|0;if((p|0)==(j|0))break;else{e=e+4|0;g=g+4|0;f=h;n=n+4|0;i=i+1|0}}f=d+(j<<2)|0;i=v+(j<<2)|0;a=a+j|0;n=c+(u<<2)|0}else{f=d;i=v;h=w}if((R|0)>1){A=b-j|0;B=Q-j|0;C=M-j|0;D=P-j|0;E=0-Q|0;F=0-P|0;I=M+j|0;G=z-j|0;H=(G|0)>(j|0);z=(z|0)>(j|0);w=f;c=1;while(1){g=a+A|0;p=n+(B<<2)|0;e=i+(C<<2)|0;f=w+(S<<2)|0;h=(h|0)==0?0:h+(D<<2)|0;if(J){v=0;u=g;while(1){y=+(l[u>>0]|0);m=y*y;o[p+(S<<2)>>2]=0.0;t=(h|0)!=0;if(t)o[h+(S<<2)>>2]=0.0;g=e+(N<<2)|0;k[e+(S<<2)>>2]=k[g>>2];o[p>>2]=y+ +o[p+(E<<2)>>2];if(t)o[h>>2]=m+ +o[h+(F<<2)>>2];o[e>>2]=y+ +o[g>>2]+ +o[f+(j<<2)>>2];if(H)if(t){s=y;x=m;m=y;q=j;while(1){y=+o[f+(q<<2)>>2];o[f+(q-j<<2)>>2]=s+y;s=+(l[u+q>>0]|0);m=m+s;x=x+s*s;o[p+(q<<2)>>2]=+o[p+(q-Q<<2)>>2]+m;o[h+(q<<2)>>2]=x+ +o[h+(q-P<<2)>>2];g=q+j|0;o[e+(q<<2)>>2]=y+(s+ +o[f+(g<<2)>>2]+ +o[e+(q-I<<2)>>2]);if((g|0)<(G|0))q=g;else break}}else{s=y;x=m;m=y;q=j;while(1){y=+o[f+(q<<2)>>2];o[f+(q-j<<2)>>2]=s+y;s=+(l[u+q>>0]|0);m=m+s;x=x+s*s;o[p+(q<<2)>>2]=+o[p+(q-Q<<2)>>2]+m;g=q+j|0;o[e+(q<<2)>>2]=y+(s+ +o[f+(g<<2)>>2]+ +o[e+(q-I<<2)>>2]);if((g|0)<(G|0))q=g;else break}}else{s=y;x=m;m=y;g=j}if(z){q=f+(g<<2)|0;y=+o[q>>2];o[f+(g-j<<2)>>2]=s+y;s=+(l[u+g>>0]|0);o[p+(g<<2)>>2]=+o[p+(g-Q<<2)>>2]+(m+s);if(t)o[h+(g<<2)>>2]=x+s*s+ +o[h+(g-P<<2)>>2];o[e+(g<<2)>>2]=y+s+ +o[e+(g-I<<2)>>2];o[q>>2]=s}h=t?h+4|0:0;v=v+1|0;if((v|0)==(j|0))break;else{f=f+4|0;e=e+4|0;p=p+4|0;u=u+1|0}}f=w;i=i+(M<<2)|0;a=a+b|0;n=n+(Q<<2)|0}else{i=e;a=g;n=p}c=c+1|0;if((c|0)==(R|0))break;else w=f}}if((d|0)!=(K|0)){ggb(d);k[O>>2]=K;k[L>>2]=264}r=T;return}function Oua(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var m=0.0,n=0,o=0,q=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;T=r;r=r+1104|0;O=T;R=k[i+4>>2]|0;S=0-j|0;Q=d>>>3;M=h>>>3;N=0-M|0;P=f>>>3;z=aa(k[i>>2]|0,j)|0;f=z+j|0;d=f<<3;zpb(c|0,0,d|0)|0;n=c+(Q+j<<3)|0;if(!e)w=0;else{zpb(e|0,0,d|0)|0;w=e+(P+j<<3)|0}if(!g)v=0;else{zpb(g|0,0,d|0)|0;v=g+(M+j<<3)|0}d=(v|0)==0;if((w|0)==0&d){if((R|0)<=0){r=T;return}g=b-j|0;o=Q-j|0;if((j|0)<=0){r=T;return}q=(z|0)>0;e=0;while(1){h=0;f=n;i=a;while(1){p[f+(S<<3)>>3]=0.0;if(q){d=0;m=0.0;do{m=m+ +(l[i+d>>0]|0);p[f+(d<<3)>>3]=+p[f+(d-Q<<3)>>3]+m;d=d+j|0}while((d|0)<(z|0))}h=h+1|0;if((h|0)==(j|0))break;else{f=f+8|0;i=i+1|0}}e=e+1|0;if((e|0)==(R|0))break;else{n=n+(j<<3)+(o<<3)|0;a=a+j+g|0}}r=T;return}if(d){if((R|0)<=0){r=T;return}q=b-j|0;t=Q-j|0;u=P-j|0;if((j|0)<=0){r=T;return}v=(z|0)>0;g=w;o=0;while(1){h=0;f=g;i=n;e=a;while(1){p[i+(S<<3)>>3]=0.0;p[f+(S<<3)>>3]=0.0;if(v){m=0.0;s=0.0;d=0;do{y=+(l[e+d>>0]|0);s=s+y;m=m+y*y;y=+p[f+(d-P<<3)>>3]+m;p[i+(d<<3)>>3]=+p[i+(d-Q<<3)>>3]+s;p[f+(d<<3)>>3]=y;d=d+j|0}while((d|0)<(z|0))}h=h+1|0;if((h|0)==(j|0))break;else{f=f+8|0;i=i+8|0;e=e+1|0}}o=o+1|0;if((o|0)==(R|0))break;else{g=g+(j<<3)+(u<<3)|0;n=n+(j<<3)+(t<<3)|0;a=a+j+q|0}}r=T;return}K=O+8|0;k[O>>2]=K;L=O+4|0;k[L>>2]=136;if(f>>>0>136){h=f>>>0>536870911?-1:f<<3;h=(h|0)==0?1:h;while(1){d=fgb(h)|0;if(d|0)break;d=k[207666]|0;k[207666]=d+0;if(!d){d=0;break}Qh[d&7]()}k[O>>2]=d}else d=K;k[L>>2]=f;J=(j|0)>0;if(J){u=Q+(j<<1)|0;q=(z|0)>0;t=(z|0)==(j|0);e=d;g=v;o=0;f=w;i=a;while(1){p[g+(S<<3)>>3]=0.0;p[n+(S<<3)>>3]=0.0;if(q)if(!f){m=0.0;h=0;do{y=+(l[i+h>>0]|0);p[g+(h<<3)>>3]=y;p[e+(h<<3)>>3]=y;m=m+y;p[n+(h<<3)>>3]=m;h=h+j|0}while((h|0)<(z|0))}else{m=0.0;s=0.0;h=0;do{y=+(l[i+h>>0]|0);p[g+(h<<3)>>3]=y;p[e+(h<<3)>>3]=y;s=s+y;m=m+y*y;p[n+(h<<3)>>3]=s;p[f+(h<<3)>>3]=m;h=h+j|0}while((h|0)<(z|0))}if(t)p[e+(j<<3)>>3]=0.0;if(!f)h=0;else{p[f+(S<<3)>>3]=0.0;h=f+8|0}o=o+1|0;if((o|0)==(j|0))break;else{e=e+8|0;g=g+8|0;f=h;n=n+8|0;i=i+1|0}}f=d+(j<<3)|0;i=v+(j<<3)|0;a=a+j|0;n=c+(u<<3)|0}else{f=d;i=v;h=w}if((R|0)>1){A=b-j|0;B=Q-j|0;C=M-j|0;D=P-j|0;E=0-Q|0;F=0-P|0;I=M+j|0;G=z-j|0;H=(G|0)>(j|0);z=(z|0)>(j|0);w=f;c=1;while(1){g=a+A|0;o=n+(B<<3)|0;e=i+(C<<3)|0;f=w+(S<<3)|0;h=(h|0)==0?0:h+(D<<3)|0;if(J){v=0;u=g;while(1){y=+(l[u>>0]|0);m=y*y;p[o+(S<<3)>>3]=0.0;t=(h|0)!=0;if(t)p[h+(S<<3)>>3]=0.0;g=e+(N<<3)|0;p[e+(S<<3)>>3]=+p[g>>3];p[o>>3]=y+ +p[o+(E<<3)>>3];if(t)p[h>>3]=m+ +p[h+(F<<3)>>3];p[e>>3]=y+ +p[g>>3]+ +p[f+(j<<3)>>3];if(H)if(t){s=y;x=m;m=y;q=j;while(1){y=+p[f+(q<<3)>>3];p[f+(q-j<<3)>>3]=s+y;s=+(l[u+q>>0]|0);m=m+s;x=x+s*s;p[o+(q<<3)>>3]=+p[o+(q-Q<<3)>>3]+m;p[h+(q<<3)>>3]=x+ +p[h+(q-P<<3)>>3];g=q+j|0;p[e+(q<<3)>>3]=y+(s+ +p[f+(g<<3)>>3]+ +p[e+(q-I<<3)>>3]);if((g|0)<(G|0))q=g;else break}}else{s=y;x=m;m=y;q=j;while(1){y=+p[f+(q<<3)>>3];p[f+(q-j<<3)>>3]=s+y;s=+(l[u+q>>0]|0);m=m+s;x=x+s*s;p[o+(q<<3)>>3]=+p[o+(q-Q<<3)>>3]+m;g=q+j|0;p[e+(q<<3)>>3]=y+(s+ +p[f+(g<<3)>>3]+ +p[e+(q-I<<3)>>3]);if((g|0)<(G|0))q=g;else break}}else{s=y;x=m;m=y;g=j}if(z){q=f+(g<<3)|0;y=+p[q>>3];p[f+(g-j<<3)>>3]=s+y;s=+(l[u+g>>0]|0);p[o+(g<<3)>>3]=+p[o+(g-Q<<3)>>3]+(m+s);if(t)p[h+(g<<3)>>3]=x+s*s+ +p[h+(g-P<<3)>>3];p[e+(g<<3)>>3]=y+s+ +p[e+(g-I<<3)>>3];p[q>>3]=s}h=t?h+8|0:0;v=v+1|0;if((v|0)==(j|0))break;else{f=f+8|0;e=e+8|0;o=o+8|0;u=u+1|0}}f=w;i=i+(M<<3)|0;a=a+b|0;n=n+(Q<<3)|0}else{i=e;a=g;n=o}c=c+1|0;if((c|0)==(R|0))break;else w=f}}if((d|0)!=(K|0)){ggb(d);k[O>>2]=K;k[L>>2]=136}r=T;return}function Pua(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var l=0.0,n=0,o=0,q=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;T=r;r=r+1104|0;O=T;R=k[i+4>>2]|0;S=0-j|0;N=b>>>1;Q=d>>>3;L=h>>>3;M=0-L|0;P=f>>>3;y=aa(k[i>>2]|0,j)|0;f=y+j|0;b=f<<3;zpb(c|0,0,b|0)|0;n=c+(Q+j<<3)|0;if(!e)e=0;else{zpb(e|0,0,b|0)|0;e=e+(P+j<<3)|0}if(!g)h=0;else{zpb(g|0,0,b|0)|0;h=g+(L+j<<3)|0}b=(h|0)==0;if((e|0)==0&b){if((R|0)<=0){r=T;return}g=N-j|0;o=Q-j|0;if((j|0)<=0){r=T;return}q=j+-1|0;s=j<<3;t=(y|0)>0;e=0;h=a;while(1){if(t){d=0;f=n;i=h;while(1){p[f+(S<<3)>>3]=0.0;b=0;l=0.0;do{l=l+ +(m[i+(b<<1)>>1]|0);p[f+(b<<3)>>3]=+p[f+(b-Q<<3)>>3]+l;b=b+j|0}while((b|0)<(y|0));d=d+1|0;if((d|0)==(j|0))break;else{f=f+8|0;i=i+2|0}}}else zpb(n+(S<<3)|0,0,s|0)|0;e=e+1|0;if((e|0)==(R|0))break;else{n=n+(q<<3)+8+(o<<3)|0;h=h+(q<<1)+2+(g<<1)|0}}r=T;return}if(b){if((R|0)<=0){r=T;return}q=N-j|0;s=Q-j|0;t=P-j|0;if((j|0)<=0){r=T;return}c=j+-1|0;v=(y|0)>0;g=e;o=0;e=a;while(1){if(v){d=0;h=g;f=n;i=e;while(1){p[f+(S<<3)>>3]=0.0;p[h+(S<<3)>>3]=0.0;l=0.0;u=0.0;b=0;do{x=+(m[i+(b<<1)>>1]|0);u=u+x;l=l+x*x;x=+p[h+(b-P<<3)>>3]+l;p[f+(b<<3)>>3]=+p[f+(b-Q<<3)>>3]+u;p[h+(b<<3)>>3]=x;b=b+j|0}while((b|0)<(y|0));d=d+1|0;if((d|0)==(j|0))break;else{h=h+8|0;f=f+8|0;i=i+2|0}}}else{b=0;d=g;h=n;while(1){p[h+(S<<3)>>3]=0.0;p[d+(S<<3)>>3]=0.0;b=b+1|0;if((b|0)==(j|0))break;else{d=d+8|0;h=h+8|0}}}o=o+1|0;if((o|0)==(R|0))break;else{g=g+(c<<3)+8+(t<<3)|0;n=n+(c<<3)+8+(s<<3)|0;e=e+(c<<1)+2+(q<<1)|0}}r=T;return}J=O+8|0;k[O>>2]=J;K=O+4|0;k[K>>2]=136;if(f>>>0>136){d=f>>>0>536870911?-1:f<<3;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[O>>2]=b}else b=J;k[K>>2]=f;I=(j|0)>0;do if(I){t=Q+(j<<1)|0;s=h+(j<<3)|0;q=(y|0)==(j|0);if((y|0)>0){o=b;g=0;d=e;e=a}else{i=b;f=0;d=e;while(1){p[h+(S<<3)>>3]=0.0;p[n+(S<<3)>>3]=0.0;if(q)p[i+(j<<3)>>3]=0.0;if(!d)d=0;else{p[d+(S<<3)>>3]=0.0;d=d+8|0}f=f+1|0;if((f|0)==(j|0))break;else{i=i+8|0;h=h+8|0;n=n+8|0}}f=b+(j<<3)|0;h=s;i=a+(j<<1)|0;n=c+(t<<3)|0;break}while(1){p[h+(S<<3)>>3]=0.0;p[n+(S<<3)>>3]=0.0;i=(d|0)==0;if(i){l=0.0;f=0;do{x=+(m[e+(f<<1)>>1]|0);p[h+(f<<3)>>3]=x;p[o+(f<<3)>>3]=x;l=l+x;p[n+(f<<3)>>3]=l;f=f+j|0}while((f|0)<(y|0))}else{l=0.0;u=0.0;f=0;do{x=+(m[e+(f<<1)>>1]|0);p[h+(f<<3)>>3]=x;p[o+(f<<3)>>3]=x;u=u+x;l=l+x*x;p[n+(f<<3)>>3]=u;p[d+(f<<3)>>3]=l;f=f+j|0}while((f|0)<(y|0))}if(q)p[o+(j<<3)>>3]=0.0;if(i)d=0;else{p[d+(S<<3)>>3]=0.0;d=d+8|0}g=g+1|0;if((g|0)==(j|0))break;else{o=o+8|0;h=h+8|0;n=n+8|0;e=e+2|0}}f=b+(j<<3)|0;h=s;i=a+(j<<1)|0;n=c+(t<<3)|0}else{f=b;d=e;i=a}while(0);if((R|0)>1){z=N-j|0;A=Q-j|0;B=L-j|0;C=P-j|0;D=0-Q|0;E=0-P|0;H=L+j|0;F=y-j|0;G=(F|0)>(j|0);y=(y|0)>(j|0);v=f;a=1;while(1){g=i+(z<<1)|0;o=n+(A<<3)|0;e=h+(B<<3)|0;f=v+(S<<3)|0;d=(d|0)==0?0:d+(C<<3)|0;if(I){c=0;t=g;while(1){x=+(m[t>>1]|0);l=x*x;p[o+(S<<3)>>3]=0.0;s=(d|0)!=0;if(s)p[d+(S<<3)>>3]=0.0;g=e+(M<<3)|0;p[e+(S<<3)>>3]=+p[g>>3];p[o>>3]=x+ +p[o+(D<<3)>>3];if(s)p[d>>3]=l+ +p[d+(E<<3)>>3];p[e>>3]=x+ +p[g>>3]+ +p[f+(j<<3)>>3];if(G)if(s){u=x;w=l;l=x;q=j;while(1){x=+p[f+(q<<3)>>3];p[f+(q-j<<3)>>3]=u+x;u=+(m[t+(q<<1)>>1]|0);l=l+u;w=w+u*u;p[o+(q<<3)>>3]=+p[o+(q-Q<<3)>>3]+l;p[d+(q<<3)>>3]=w+ +p[d+(q-P<<3)>>3];g=q+j|0;p[e+(q<<3)>>3]=x+(u+ +p[f+(g<<3)>>3]+ +p[e+(q-H<<3)>>3]);if((g|0)<(F|0))q=g;else break}}else{u=x;w=l;l=x;q=j;while(1){x=+p[f+(q<<3)>>3];p[f+(q-j<<3)>>3]=u+x;u=+(m[t+(q<<1)>>1]|0);l=l+u;w=w+u*u;p[o+(q<<3)>>3]=+p[o+(q-Q<<3)>>3]+l;g=q+j|0;p[e+(q<<3)>>3]=x+(u+ +p[f+(g<<3)>>3]+ +p[e+(q-H<<3)>>3]);if((g|0)<(F|0))q=g;else break}}else{u=x;w=l;l=x;g=j}if(y){q=f+(g<<3)|0;x=+p[q>>3];p[f+(g-j<<3)>>3]=u+x;u=+(m[t+(g<<1)>>1]|0);p[o+(g<<3)>>3]=+p[o+(g-Q<<3)>>3]+(l+u);if(s)p[d+(g<<3)>>3]=w+u*u+ +p[d+(g-P<<3)>>3];p[e+(g<<3)>>3]=x+u+ +p[e+(g-H<<3)>>3];p[q>>3]=u}d=s?d+8|0:0;c=c+1|0;if((c|0)==(j|0))break;else{f=f+8|0;e=e+8|0;o=o+8|0;t=t+2|0}}f=v;h=h+(L<<3)|0;i=i+(N<<1)|0;n=n+(Q<<3)|0}else{h=e;i=g;n=o}a=a+1|0;if((a|0)==(R|0))break;else v=f}}if((b|0)!=(J|0)){ggb(b);k[O>>2]=J;k[K>>2]=136}r=T;return}function Qua(a,b,c,d,e,f,g,h,i,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;l=l|0;var m=0.0,n=0,o=0,q=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;T=r;r=r+1104|0;O=T;R=k[i+4>>2]|0;S=0-l|0;N=b>>>1;Q=d>>>3;L=h>>>3;M=0-L|0;P=f>>>3;y=aa(k[i>>2]|0,l)|0;f=y+l|0;b=f<<3;zpb(c|0,0,b|0)|0;n=c+(Q+l<<3)|0;if(!e)e=0;else{zpb(e|0,0,b|0)|0;e=e+(P+l<<3)|0}if(!g)h=0;else{zpb(g|0,0,b|0)|0;h=g+(L+l<<3)|0}b=(h|0)==0;if((e|0)==0&b){if((R|0)<=0){r=T;return}g=N-l|0;o=Q-l|0;if((l|0)<=0){r=T;return}q=l+-1|0;s=l<<3;t=(y|0)>0;e=0;h=a;while(1){if(t){d=0;f=n;i=h;while(1){p[f+(S<<3)>>3]=0.0;b=0;m=0.0;do{m=m+ +(j[i+(b<<1)>>1]|0);p[f+(b<<3)>>3]=+p[f+(b-Q<<3)>>3]+m;b=b+l|0}while((b|0)<(y|0));d=d+1|0;if((d|0)==(l|0))break;else{f=f+8|0;i=i+2|0}}}else zpb(n+(S<<3)|0,0,s|0)|0;e=e+1|0;if((e|0)==(R|0))break;else{n=n+(q<<3)+8+(o<<3)|0;h=h+(q<<1)+2+(g<<1)|0}}r=T;return}if(b){if((R|0)<=0){r=T;return}q=N-l|0;s=Q-l|0;t=P-l|0;if((l|0)<=0){r=T;return}c=l+-1|0;v=(y|0)>0;g=e;o=0;e=a;while(1){if(v){d=0;h=g;f=n;i=e;while(1){p[f+(S<<3)>>3]=0.0;p[h+(S<<3)>>3]=0.0;m=0.0;u=0.0;b=0;do{x=+(j[i+(b<<1)>>1]|0);u=u+x;m=m+x*x;x=+p[h+(b-P<<3)>>3]+m;p[f+(b<<3)>>3]=+p[f+(b-Q<<3)>>3]+u;p[h+(b<<3)>>3]=x;b=b+l|0}while((b|0)<(y|0));d=d+1|0;if((d|0)==(l|0))break;else{h=h+8|0;f=f+8|0;i=i+2|0}}}else{b=0;d=g;h=n;while(1){p[h+(S<<3)>>3]=0.0;p[d+(S<<3)>>3]=0.0;b=b+1|0;if((b|0)==(l|0))break;else{d=d+8|0;h=h+8|0}}}o=o+1|0;if((o|0)==(R|0))break;else{g=g+(c<<3)+8+(t<<3)|0;n=n+(c<<3)+8+(s<<3)|0;e=e+(c<<1)+2+(q<<1)|0}}r=T;return}J=O+8|0;k[O>>2]=J;K=O+4|0;k[K>>2]=136;if(f>>>0>136){d=f>>>0>536870911?-1:f<<3;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[O>>2]=b}else b=J;k[K>>2]=f;I=(l|0)>0;do if(I){t=Q+(l<<1)|0;s=h+(l<<3)|0;q=(y|0)==(l|0);if((y|0)>0){o=b;g=0;d=e;e=a}else{i=b;f=0;d=e;while(1){p[h+(S<<3)>>3]=0.0;p[n+(S<<3)>>3]=0.0;if(q)p[i+(l<<3)>>3]=0.0;if(!d)d=0;else{p[d+(S<<3)>>3]=0.0;d=d+8|0}f=f+1|0;if((f|0)==(l|0))break;else{i=i+8|0;h=h+8|0;n=n+8|0}}f=b+(l<<3)|0;h=s;i=a+(l<<1)|0;n=c+(t<<3)|0;break}while(1){p[h+(S<<3)>>3]=0.0;p[n+(S<<3)>>3]=0.0;i=(d|0)==0;if(i){m=0.0;f=0;do{x=+(j[e+(f<<1)>>1]|0);p[h+(f<<3)>>3]=x;p[o+(f<<3)>>3]=x;m=m+x;p[n+(f<<3)>>3]=m;f=f+l|0}while((f|0)<(y|0))}else{m=0.0;u=0.0;f=0;do{x=+(j[e+(f<<1)>>1]|0);p[h+(f<<3)>>3]=x;p[o+(f<<3)>>3]=x;u=u+x;m=m+x*x;p[n+(f<<3)>>3]=u;p[d+(f<<3)>>3]=m;f=f+l|0}while((f|0)<(y|0))}if(q)p[o+(l<<3)>>3]=0.0;if(i)d=0;else{p[d+(S<<3)>>3]=0.0;d=d+8|0}g=g+1|0;if((g|0)==(l|0))break;else{o=o+8|0;h=h+8|0;n=n+8|0;e=e+2|0}}f=b+(l<<3)|0;h=s;i=a+(l<<1)|0;n=c+(t<<3)|0}else{f=b;d=e;i=a}while(0);if((R|0)>1){z=N-l|0;A=Q-l|0;B=L-l|0;C=P-l|0;D=0-Q|0;E=0-P|0;H=L+l|0;F=y-l|0;G=(F|0)>(l|0);y=(y|0)>(l|0);v=f;a=1;while(1){g=i+(z<<1)|0;o=n+(A<<3)|0;e=h+(B<<3)|0;f=v+(S<<3)|0;d=(d|0)==0?0:d+(C<<3)|0;if(I){c=0;t=g;while(1){x=+(j[t>>1]|0);m=x*x;p[o+(S<<3)>>3]=0.0;s=(d|0)!=0;if(s)p[d+(S<<3)>>3]=0.0;g=e+(M<<3)|0;p[e+(S<<3)>>3]=+p[g>>3];p[o>>3]=x+ +p[o+(D<<3)>>3];if(s)p[d>>3]=m+ +p[d+(E<<3)>>3];p[e>>3]=x+ +p[g>>3]+ +p[f+(l<<3)>>3];if(G)if(s){u=x;w=m;m=x;q=l;while(1){x=+p[f+(q<<3)>>3];p[f+(q-l<<3)>>3]=u+x;u=+(j[t+(q<<1)>>1]|0);m=m+u;w=w+u*u;p[o+(q<<3)>>3]=+p[o+(q-Q<<3)>>3]+m;p[d+(q<<3)>>3]=w+ +p[d+(q-P<<3)>>3];g=q+l|0;p[e+(q<<3)>>3]=x+(u+ +p[f+(g<<3)>>3]+ +p[e+(q-H<<3)>>3]);if((g|0)<(F|0))q=g;else break}}else{u=x;w=m;m=x;q=l;while(1){x=+p[f+(q<<3)>>3];p[f+(q-l<<3)>>3]=u+x;u=+(j[t+(q<<1)>>1]|0);m=m+u;w=w+u*u;p[o+(q<<3)>>3]=+p[o+(q-Q<<3)>>3]+m;g=q+l|0;p[e+(q<<3)>>3]=x+(u+ +p[f+(g<<3)>>3]+ +p[e+(q-H<<3)>>3]);if((g|0)<(F|0))q=g;else break}}else{u=x;w=m;m=x;g=l}if(y){q=f+(g<<3)|0;x=+p[q>>3];p[f+(g-l<<3)>>3]=u+x;u=+(j[t+(g<<1)>>1]|0);p[o+(g<<3)>>3]=+p[o+(g-Q<<3)>>3]+(m+u);if(s)p[d+(g<<3)>>3]=w+u*u+ +p[d+(g-P<<3)>>3];p[e+(g<<3)>>3]=x+u+ +p[e+(g-H<<3)>>3];p[q>>3]=u}d=s?d+8|0:0;c=c+1|0;if((c|0)==(l|0))break;else{f=f+8|0;e=e+8|0;o=o+8|0;t=t+2|0}}f=v;h=h+(L<<3)|0;i=i+(N<<1)|0;n=n+(Q<<3)|0}else{h=e;i=g;n=o}a=a+1|0;if((a|0)==(R|0))break;else v=f}}if((b|0)!=(J|0)){ggb(b);k[O>>2]=J;k[K>>2]=136}r=T;return}function Rua(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var l=0.0,m=0,n=0,q=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;U=r;r=r+1072|0;P=U;S=k[i+4>>2]|0;T=0-j|0;O=b>>>2;R=d>>>2;M=h>>>2;N=0-M|0;Q=f>>>3;z=aa(k[i>>2]|0,j)|0;f=z+j|0;b=f<<2;zpb(c|0,0,b|0)|0;m=c+(R+j<<2)|0;if(!e)e=0;else{zpb(e|0,0,f<<3|0)|0;e=e+(Q+j<<3)|0}if(!g)h=0;else{zpb(g|0,0,b|0)|0;h=g+(M+j<<2)|0}b=(h|0)==0;if((e|0)==0&b){if((S|0)<=0){r=U;return}g=O-j|0;n=R-j|0;if((j|0)<=0){r=U;return}q=j+-1|0;s=j<<2;t=(z|0)>0;e=0;h=a;while(1){if(t){d=0;f=m;i=h;while(1){o[f+(T<<2)>>2]=0.0;b=0;l=0.0;do{l=l+ +o[i+(b<<2)>>2];o[f+(b<<2)>>2]=+o[f+(b-R<<2)>>2]+l;b=b+j|0}while((b|0)<(z|0));d=d+1|0;if((d|0)==(j|0))break;else{f=f+4|0;i=i+4|0}}}else zpb(m+(T<<2)|0,0,s|0)|0;e=e+1|0;if((e|0)==(S|0))break;else{m=m+(q<<2)+4+(n<<2)|0;h=h+(q<<2)+4+(g<<2)|0}}r=U;return}if(b){if((S|0)<=0){r=U;return}q=O-j|0;s=R-j|0;t=Q-j|0;if((j|0)<=0){r=U;return}c=j+-1|0;v=(z|0)>0;g=e;n=0;e=a;while(1){if(v){d=0;h=g;f=m;i=e;while(1){o[f+(T<<2)>>2]=0.0;p[h+(T<<3)>>3]=0.0;l=0.0;u=0.0;b=0;do{y=+o[i+(b<<2)>>2];u=u+y;l=l+y*y;y=+p[h+(b-Q<<3)>>3]+l;o[f+(b<<2)>>2]=+o[f+(b-R<<2)>>2]+u;p[h+(b<<3)>>3]=y;b=b+j|0}while((b|0)<(z|0));d=d+1|0;if((d|0)==(j|0))break;else{h=h+8|0;f=f+4|0;i=i+4|0}}}else{b=0;d=g;h=m;while(1){o[h+(T<<2)>>2]=0.0;p[d+(T<<3)>>3]=0.0;b=b+1|0;if((b|0)==(j|0))break;else{d=d+8|0;h=h+4|0}}}n=n+1|0;if((n|0)==(S|0))break;else{g=g+(c<<3)+8+(t<<3)|0;m=m+(c<<2)+4+(s<<2)|0;e=e+(c<<2)+4+(q<<2)|0}}r=U;return}K=P+8|0;k[P>>2]=K;L=P+4|0;k[L>>2]=264;if(f>>>0>264){d=f>>>0>1073741823?-1:f<<2;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[P>>2]=b}else b=K;k[L>>2]=f;J=(j|0)>0;do if(J){t=R+(j<<1)|0;s=h+(j<<2)|0;q=(z|0)==(j|0);if((z|0)>0){n=b;g=0;d=e;e=a}else{i=b;f=0;d=e;while(1){o[h+(T<<2)>>2]=0.0;o[m+(T<<2)>>2]=0.0;if(q)o[i+(j<<2)>>2]=0.0;if(!d)d=0;else{p[d+(T<<3)>>3]=0.0;d=d+8|0}f=f+1|0;if((f|0)==(j|0))break;else{i=i+4|0;h=h+4|0;m=m+4|0}}f=b+(j<<2)|0;h=s;i=a+(j<<2)|0;m=c+(t<<2)|0;break}while(1){o[h+(T<<2)>>2]=0.0;o[m+(T<<2)>>2]=0.0;i=(d|0)==0;if(i){l=0.0;f=0;do{y=+o[e+(f<<2)>>2];o[h+(f<<2)>>2]=y;o[n+(f<<2)>>2]=y;l=l+y;o[m+(f<<2)>>2]=l;f=f+j|0}while((f|0)<(z|0))}else{l=0.0;u=0.0;f=0;do{y=+o[e+(f<<2)>>2];o[h+(f<<2)>>2]=y;o[n+(f<<2)>>2]=y;u=u+y;l=l+y*y;o[m+(f<<2)>>2]=u;p[d+(f<<3)>>3]=l;f=f+j|0}while((f|0)<(z|0))}if(q)o[n+(j<<2)>>2]=0.0;if(i)d=0;else{p[d+(T<<3)>>3]=0.0;d=d+8|0}g=g+1|0;if((g|0)==(j|0))break;else{n=n+4|0;h=h+4|0;m=m+4|0;e=e+4|0}}f=b+(j<<2)|0;h=s;i=a+(j<<2)|0;m=c+(t<<2)|0}else{f=b;d=e;i=a}while(0);if((S|0)>1){A=O-j|0;B=R-j|0;C=M-j|0;D=Q-j|0;E=0-R|0;F=0-Q|0;I=M+j|0;G=z-j|0;H=(G|0)>(j|0);z=(z|0)>(j|0);v=f;a=1;while(1){g=i+(A<<2)|0;n=m+(B<<2)|0;e=h+(C<<2)|0;f=v+(T<<2)|0;d=(d|0)==0?0:d+(D<<3)|0;if(J){c=0;t=g;while(1){x=+o[t>>2];l=x;l=l*l;o[n+(T<<2)>>2]=0.0;s=(d|0)!=0;if(s)p[d+(T<<3)>>3]=0.0;g=e+(N<<2)|0;k[e+(T<<2)>>2]=k[g>>2];o[n>>2]=x+ +o[n+(E<<2)>>2];if(s)p[d>>3]=l+ +p[d+(F<<3)>>3];o[e>>2]=x+ +o[g>>2]+ +o[f+(j<<2)>>2];if(H)if(s){u=x;w=l;l=x;q=j;while(1){y=+o[f+(q<<2)>>2];o[f+(q-j<<2)>>2]=u+y;u=+o[t+(q<<2)>>2];x=u;l=l+u;w=w+x*x;o[n+(q<<2)>>2]=+o[n+(q-R<<2)>>2]+l;p[d+(q<<3)>>3]=w+ +p[d+(q-Q<<3)>>3];g=q+j|0;o[e+(q<<2)>>2]=y+(u+ +o[f+(g<<2)>>2]+ +o[e+(q-I<<2)>>2]);if((g|0)<(G|0))q=g;else break}}else{u=x;w=l;l=x;q=j;while(1){y=+o[f+(q<<2)>>2];o[f+(q-j<<2)>>2]=u+y;u=+o[t+(q<<2)>>2];x=u;l=l+u;w=w+x*x;o[n+(q<<2)>>2]=+o[n+(q-R<<2)>>2]+l;g=q+j|0;o[e+(q<<2)>>2]=y+(u+ +o[f+(g<<2)>>2]+ +o[e+(q-I<<2)>>2]);if((g|0)<(G|0))q=g;else break}}else{u=x;w=l;l=x;g=j}if(z){q=f+(g<<2)|0;y=+o[q>>2];o[f+(g-j<<2)>>2]=u+y;u=+o[t+(g<<2)>>2];x=u;o[n+(g<<2)>>2]=+o[n+(g-R<<2)>>2]+(l+u);if(s)p[d+(g<<3)>>3]=w+x*x+ +p[d+(g-Q<<3)>>3];o[e+(g<<2)>>2]=y+u+ +o[e+(g-I<<2)>>2];o[q>>2]=u}d=s?d+8|0:0;c=c+1|0;if((c|0)==(j|0))break;else{f=f+4|0;e=e+4|0;n=n+4|0;t=t+4|0}}f=v;h=h+(M<<2)|0;i=i+(O<<2)|0;m=m+(R<<2)|0}else{h=e;i=g;m=n}a=a+1|0;if((a|0)==(S|0))break;else v=f}}if((b|0)!=(K|0)){ggb(b);k[P>>2]=K;k[L>>2]=264}r=U;return}function Sua(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var l=0.0,m=0,n=0,p=0,q=0,s=0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;S=r;r=r+1072|0;N=S;Q=k[i+4>>2]|0;R=0-j|0;M=b>>>2;P=d>>>2;K=h>>>2;L=0-K|0;O=f>>>2;x=aa(k[i>>2]|0,j)|0;f=x+j|0;b=f<<2;zpb(c|0,0,b|0)|0;m=c+(P+j<<2)|0;if(!e)e=0;else{zpb(e|0,0,b|0)|0;e=e+(O+j<<2)|0}if(!g)h=0;else{zpb(g|0,0,b|0)|0;h=g+(K+j<<2)|0}b=(h|0)==0;if((e|0)==0&b){if((Q|0)<=0){r=S;return}g=M-j|0;n=P-j|0;if((j|0)<=0){r=S;return}p=j+-1|0;q=j<<2;s=(x|0)>0;e=0;h=a;while(1){if(s){d=0;f=m;i=h;while(1){o[f+(R<<2)>>2]=0.0;b=0;l=0.0;do{l=l+ +o[i+(b<<2)>>2];o[f+(b<<2)>>2]=+o[f+(b-P<<2)>>2]+l;b=b+j|0}while((b|0)<(x|0));d=d+1|0;if((d|0)==(j|0))break;else{f=f+4|0;i=i+4|0}}}else zpb(m+(R<<2)|0,0,q|0)|0;e=e+1|0;if((e|0)==(Q|0))break;else{m=m+(p<<2)+4+(n<<2)|0;h=h+(p<<2)+4+(g<<2)|0}}r=S;return}if(b){if((Q|0)<=0){r=S;return}p=M-j|0;q=P-j|0;s=O-j|0;if((j|0)<=0){r=S;return}c=j+-1|0;u=(x|0)>0;g=e;n=0;e=a;while(1){if(u){d=0;h=g;f=m;i=e;while(1){o[f+(R<<2)>>2]=0.0;o[h+(R<<2)>>2]=0.0;l=0.0;t=0.0;b=0;do{w=+o[i+(b<<2)>>2];t=t+w;l=l+w*w;w=+o[h+(b-O<<2)>>2]+l;o[f+(b<<2)>>2]=+o[f+(b-P<<2)>>2]+t;o[h+(b<<2)>>2]=w;b=b+j|0}while((b|0)<(x|0));d=d+1|0;if((d|0)==(j|0))break;else{h=h+4|0;f=f+4|0;i=i+4|0}}}else{b=0;d=g;h=m;while(1){o[h+(R<<2)>>2]=0.0;o[d+(R<<2)>>2]=0.0;b=b+1|0;if((b|0)==(j|0))break;else{d=d+4|0;h=h+4|0}}}n=n+1|0;if((n|0)==(Q|0))break;else{g=g+(c<<2)+4+(s<<2)|0;m=m+(c<<2)+4+(q<<2)|0;e=e+(c<<2)+4+(p<<2)|0}}r=S;return}I=N+8|0;k[N>>2]=I;J=N+4|0;k[J>>2]=264;if(f>>>0>264){d=f>>>0>1073741823?-1:f<<2;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[N>>2]=b}else b=I;k[J>>2]=f;H=(j|0)>0;do if(H){s=P+(j<<1)|0;q=h+(j<<2)|0;p=(x|0)==(j|0);if((x|0)>0){n=b;g=0;d=e;e=a}else{i=b;f=0;d=e;while(1){o[h+(R<<2)>>2]=0.0;o[m+(R<<2)>>2]=0.0;if(p)o[i+(j<<2)>>2]=0.0;if(!d)d=0;else{o[d+(R<<2)>>2]=0.0;d=d+4|0}f=f+1|0;if((f|0)==(j|0))break;else{i=i+4|0;h=h+4|0;m=m+4|0}}f=b+(j<<2)|0;h=q;i=a+(j<<2)|0;m=c+(s<<2)|0;break}while(1){o[h+(R<<2)>>2]=0.0;o[m+(R<<2)>>2]=0.0;i=(d|0)==0;if(i){l=0.0;f=0;do{w=+o[e+(f<<2)>>2];o[h+(f<<2)>>2]=w;o[n+(f<<2)>>2]=w;l=l+w;o[m+(f<<2)>>2]=l;f=f+j|0}while((f|0)<(x|0))}else{l=0.0;t=0.0;f=0;do{w=+o[e+(f<<2)>>2];o[h+(f<<2)>>2]=w;o[n+(f<<2)>>2]=w;t=t+w;l=l+w*w;o[m+(f<<2)>>2]=t;o[d+(f<<2)>>2]=l;f=f+j|0}while((f|0)<(x|0))}if(p)o[n+(j<<2)>>2]=0.0;if(i)d=0;else{o[d+(R<<2)>>2]=0.0;d=d+4|0}g=g+1|0;if((g|0)==(j|0))break;else{n=n+4|0;h=h+4|0;m=m+4|0;e=e+4|0}}f=b+(j<<2)|0;h=q;i=a+(j<<2)|0;m=c+(s<<2)|0}else{f=b;d=e;i=a}while(0);if((Q|0)>1){y=M-j|0;z=P-j|0;A=K-j|0;B=O-j|0;C=0-P|0;D=0-O|0;G=K+j|0;E=x-j|0;F=(E|0)>(j|0);x=(x|0)>(j|0);u=f;a=1;while(1){g=i+(y<<2)|0;n=m+(z<<2)|0;e=h+(A<<2)|0;f=u+(R<<2)|0;d=(d|0)==0?0:d+(B<<2)|0;if(H){c=0;s=g;while(1){w=+o[s>>2];l=w*w;o[n+(R<<2)>>2]=0.0;q=(d|0)!=0;if(q)o[d+(R<<2)>>2]=0.0;g=e+(L<<2)|0;k[e+(R<<2)>>2]=k[g>>2];o[n>>2]=w+ +o[n+(C<<2)>>2];if(q)o[d>>2]=l+ +o[d+(D<<2)>>2];o[e>>2]=w+ +o[g>>2]+ +o[f+(j<<2)>>2];if(F)if(q){t=w;v=l;l=w;p=j;while(1){w=+o[f+(p<<2)>>2];o[f+(p-j<<2)>>2]=t+w;t=+o[s+(p<<2)>>2];l=l+t;v=v+t*t;o[n+(p<<2)>>2]=+o[n+(p-P<<2)>>2]+l;o[d+(p<<2)>>2]=v+ +o[d+(p-O<<2)>>2];g=p+j|0;o[e+(p<<2)>>2]=w+(t+ +o[f+(g<<2)>>2]+ +o[e+(p-G<<2)>>2]);if((g|0)<(E|0))p=g;else break}}else{t=w;v=l;l=w;p=j;while(1){w=+o[f+(p<<2)>>2];o[f+(p-j<<2)>>2]=t+w;t=+o[s+(p<<2)>>2];l=l+t;v=v+t*t;o[n+(p<<2)>>2]=+o[n+(p-P<<2)>>2]+l;g=p+j|0;o[e+(p<<2)>>2]=w+(t+ +o[f+(g<<2)>>2]+ +o[e+(p-G<<2)>>2]);if((g|0)<(E|0))p=g;else break}}else{t=w;v=l;l=w;g=j}if(x){p=f+(g<<2)|0;w=+o[p>>2];o[f+(g-j<<2)>>2]=t+w;t=+o[s+(g<<2)>>2];o[n+(g<<2)>>2]=+o[n+(g-P<<2)>>2]+(l+t);if(q)o[d+(g<<2)>>2]=v+t*t+ +o[d+(g-O<<2)>>2];o[e+(g<<2)>>2]=w+t+ +o[e+(g-G<<2)>>2];o[p>>2]=t}d=q?d+4|0:0;c=c+1|0;if((c|0)==(j|0))break;else{f=f+4|0;e=e+4|0;n=n+4|0;s=s+4|0}}f=u;h=h+(K<<2)|0;i=i+(M<<2)|0;m=m+(P<<2)|0}else{h=e;i=g;m=n}a=a+1|0;if((a|0)==(Q|0))break;else u=f}}if((b|0)!=(I|0)){ggb(b);k[N>>2]=I;k[J>>2]=264}r=S;return}function Tua(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var l=0.0,m=0,n=0,q=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;T=r;r=r+1104|0;O=T;R=k[i+4>>2]|0;S=0-j|0;N=b>>>2;Q=d>>>3;L=h>>>3;M=0-L|0;P=f>>>3;y=aa(k[i>>2]|0,j)|0;f=y+j|0;b=f<<3;zpb(c|0,0,b|0)|0;m=c+(Q+j<<3)|0;if(!e)e=0;else{zpb(e|0,0,b|0)|0;e=e+(P+j<<3)|0}if(!g)h=0;else{zpb(g|0,0,b|0)|0;h=g+(L+j<<3)|0}b=(h|0)==0;if((e|0)==0&b){if((R|0)<=0){r=T;return}g=N-j|0;n=Q-j|0;if((j|0)<=0){r=T;return}q=j+-1|0;s=j<<3;t=(y|0)>0;e=0;h=a;while(1){if(t){d=0;f=m;i=h;while(1){p[f+(S<<3)>>3]=0.0;b=0;l=0.0;do{l=l+ +o[i+(b<<2)>>2];p[f+(b<<3)>>3]=+p[f+(b-Q<<3)>>3]+l;b=b+j|0}while((b|0)<(y|0));d=d+1|0;if((d|0)==(j|0))break;else{f=f+8|0;i=i+4|0}}}else zpb(m+(S<<3)|0,0,s|0)|0;e=e+1|0;if((e|0)==(R|0))break;else{m=m+(q<<3)+8+(n<<3)|0;h=h+(q<<2)+4+(g<<2)|0}}r=T;return}if(b){if((R|0)<=0){r=T;return}q=N-j|0;s=Q-j|0;t=P-j|0;if((j|0)<=0){r=T;return}c=j+-1|0;v=(y|0)>0;g=e;n=0;e=a;while(1){if(v){d=0;h=g;f=m;i=e;while(1){p[f+(S<<3)>>3]=0.0;p[h+(S<<3)>>3]=0.0;l=0.0;u=0.0;b=0;do{x=+o[i+(b<<2)>>2];u=u+x;l=l+x*x;x=+p[h+(b-P<<3)>>3]+l;p[f+(b<<3)>>3]=+p[f+(b-Q<<3)>>3]+u;p[h+(b<<3)>>3]=x;b=b+j|0}while((b|0)<(y|0));d=d+1|0;if((d|0)==(j|0))break;else{h=h+8|0;f=f+8|0;i=i+4|0}}}else{b=0;d=g;h=m;while(1){p[h+(S<<3)>>3]=0.0;p[d+(S<<3)>>3]=0.0;b=b+1|0;if((b|0)==(j|0))break;else{d=d+8|0;h=h+8|0}}}n=n+1|0;if((n|0)==(R|0))break;else{g=g+(c<<3)+8+(t<<3)|0;m=m+(c<<3)+8+(s<<3)|0;e=e+(c<<2)+4+(q<<2)|0}}r=T;return}J=O+8|0;k[O>>2]=J;K=O+4|0;k[K>>2]=136;if(f>>>0>136){d=f>>>0>536870911?-1:f<<3;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[O>>2]=b}else b=J;k[K>>2]=f;I=(j|0)>0;do if(I){t=Q+(j<<1)|0;s=h+(j<<3)|0;q=(y|0)==(j|0);if((y|0)>0){n=b;g=0;d=e;e=a}else{i=b;f=0;d=e;while(1){p[h+(S<<3)>>3]=0.0;p[m+(S<<3)>>3]=0.0;if(q)p[i+(j<<3)>>3]=0.0;if(!d)d=0;else{p[d+(S<<3)>>3]=0.0;d=d+8|0}f=f+1|0;if((f|0)==(j|0))break;else{i=i+8|0;h=h+8|0;m=m+8|0}}f=b+(j<<3)|0;h=s;i=a+(j<<2)|0;m=c+(t<<3)|0;break}while(1){p[h+(S<<3)>>3]=0.0;p[m+(S<<3)>>3]=0.0;i=(d|0)==0;if(i){l=0.0;f=0;do{x=+o[e+(f<<2)>>2];p[h+(f<<3)>>3]=x;p[n+(f<<3)>>3]=x;l=l+x;p[m+(f<<3)>>3]=l;f=f+j|0}while((f|0)<(y|0))}else{l=0.0;u=0.0;f=0;do{x=+o[e+(f<<2)>>2];p[h+(f<<3)>>3]=x;p[n+(f<<3)>>3]=x;u=u+x;l=l+x*x;p[m+(f<<3)>>3]=u;p[d+(f<<3)>>3]=l;f=f+j|0}while((f|0)<(y|0))}if(q)p[n+(j<<3)>>3]=0.0;if(i)d=0;else{p[d+(S<<3)>>3]=0.0;d=d+8|0}g=g+1|0;if((g|0)==(j|0))break;else{n=n+8|0;h=h+8|0;m=m+8|0;e=e+4|0}}f=b+(j<<3)|0;h=s;i=a+(j<<2)|0;m=c+(t<<3)|0}else{f=b;d=e;i=a}while(0);if((R|0)>1){z=N-j|0;A=Q-j|0;B=L-j|0;C=P-j|0;D=0-Q|0;E=0-P|0;H=L+j|0;F=y-j|0;G=(F|0)>(j|0);y=(y|0)>(j|0);v=f;a=1;while(1){g=i+(z<<2)|0;n=m+(A<<3)|0;e=h+(B<<3)|0;f=v+(S<<3)|0;d=(d|0)==0?0:d+(C<<3)|0;if(I){c=0;t=g;while(1){x=+o[t>>2];l=x*x;p[n+(S<<3)>>3]=0.0;s=(d|0)!=0;if(s)p[d+(S<<3)>>3]=0.0;g=e+(M<<3)|0;p[e+(S<<3)>>3]=+p[g>>3];p[n>>3]=x+ +p[n+(D<<3)>>3];if(s)p[d>>3]=l+ +p[d+(E<<3)>>3];p[e>>3]=x+ +p[g>>3]+ +p[f+(j<<3)>>3];if(G)if(s){u=x;w=l;l=x;q=j;while(1){x=+p[f+(q<<3)>>3];p[f+(q-j<<3)>>3]=u+x;u=+o[t+(q<<2)>>2];l=l+u;w=w+u*u;p[n+(q<<3)>>3]=+p[n+(q-Q<<3)>>3]+l;p[d+(q<<3)>>3]=w+ +p[d+(q-P<<3)>>3];g=q+j|0;p[e+(q<<3)>>3]=x+(u+ +p[f+(g<<3)>>3]+ +p[e+(q-H<<3)>>3]);if((g|0)<(F|0))q=g;else break}}else{u=x;w=l;l=x;q=j;while(1){x=+p[f+(q<<3)>>3];p[f+(q-j<<3)>>3]=u+x;u=+o[t+(q<<2)>>2];l=l+u;w=w+u*u;p[n+(q<<3)>>3]=+p[n+(q-Q<<3)>>3]+l;g=q+j|0;p[e+(q<<3)>>3]=x+(u+ +p[f+(g<<3)>>3]+ +p[e+(q-H<<3)>>3]);if((g|0)<(F|0))q=g;else break}}else{u=x;w=l;l=x;g=j}if(y){q=f+(g<<3)|0;x=+p[q>>3];p[f+(g-j<<3)>>3]=u+x;u=+o[t+(g<<2)>>2];p[n+(g<<3)>>3]=+p[n+(g-Q<<3)>>3]+(l+u);if(s)p[d+(g<<3)>>3]=w+u*u+ +p[d+(g-P<<3)>>3];p[e+(g<<3)>>3]=x+u+ +p[e+(g-H<<3)>>3];p[q>>3]=u}d=s?d+8|0:0;c=c+1|0;if((c|0)==(j|0))break;else{f=f+8|0;e=e+8|0;n=n+8|0;t=t+4|0}}f=v;h=h+(L<<3)|0;i=i+(N<<2)|0;m=m+(Q<<3)|0}else{h=e;i=g;m=n}a=a+1|0;if((a|0)==(R|0))break;else v=f}}if((b|0)!=(J|0)){ggb(b);k[O>>2]=J;k[K>>2]=136}r=T;return}function Uua(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var l=0.0,m=0,n=0,o=0,q=0,s=0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;S=r;r=r+1104|0;N=S;Q=k[i+4>>2]|0;R=0-j|0;M=b>>>3;P=d>>>3;K=h>>>3;L=0-K|0;O=f>>>3;x=aa(k[i>>2]|0,j)|0;f=x+j|0;b=f<<3;zpb(c|0,0,b|0)|0;m=c+(P+j<<3)|0;if(!e)e=0;else{zpb(e|0,0,b|0)|0;e=e+(O+j<<3)|0}if(!g)h=0;else{zpb(g|0,0,b|0)|0;h=g+(K+j<<3)|0}b=(h|0)==0;if((e|0)==0&b){if((Q|0)<=0){r=S;return}g=M-j|0;n=P-j|0;if((j|0)<=0){r=S;return}o=j+-1|0;q=j<<3;s=(x|0)>0;e=0;h=a;while(1){if(s){d=0;f=m;i=h;while(1){p[f+(R<<3)>>3]=0.0;b=0;l=0.0;do{l=l+ +p[i+(b<<3)>>3];p[f+(b<<3)>>3]=+p[f+(b-P<<3)>>3]+l;b=b+j|0}while((b|0)<(x|0));d=d+1|0;if((d|0)==(j|0))break;else{f=f+8|0;i=i+8|0}}}else zpb(m+(R<<3)|0,0,q|0)|0;e=e+1|0;if((e|0)==(Q|0))break;else{m=m+(o<<3)+8+(n<<3)|0;h=h+(o<<3)+8+(g<<3)|0}}r=S;return}if(b){if((Q|0)<=0){r=S;return}o=M-j|0;q=P-j|0;s=O-j|0;if((j|0)<=0){r=S;return}c=j+-1|0;u=(x|0)>0;g=e;n=0;e=a;while(1){if(u){d=0;h=g;f=m;i=e;while(1){p[f+(R<<3)>>3]=0.0;p[h+(R<<3)>>3]=0.0;l=0.0;t=0.0;b=0;do{w=+p[i+(b<<3)>>3];t=t+w;l=l+w*w;w=+p[h+(b-O<<3)>>3]+l;p[f+(b<<3)>>3]=+p[f+(b-P<<3)>>3]+t;p[h+(b<<3)>>3]=w;b=b+j|0}while((b|0)<(x|0));d=d+1|0;if((d|0)==(j|0))break;else{h=h+8|0;f=f+8|0;i=i+8|0}}}else{b=0;d=g;h=m;while(1){p[h+(R<<3)>>3]=0.0;p[d+(R<<3)>>3]=0.0;b=b+1|0;if((b|0)==(j|0))break;else{d=d+8|0;h=h+8|0}}}n=n+1|0;if((n|0)==(Q|0))break;else{g=g+(c<<3)+8+(s<<3)|0;m=m+(c<<3)+8+(q<<3)|0;e=e+(c<<3)+8+(o<<3)|0}}r=S;return}I=N+8|0;k[N>>2]=I;J=N+4|0;k[J>>2]=136;if(f>>>0>136){d=f>>>0>536870911?-1:f<<3;d=(d|0)==0?1:d;while(1){b=fgb(d)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}k[N>>2]=b}else b=I;k[J>>2]=f;H=(j|0)>0;do if(H){s=P+(j<<1)|0;q=h+(j<<3)|0;o=(x|0)==(j|0);if((x|0)>0){n=b;g=0;d=e;e=a}else{i=b;f=0;d=e;while(1){p[h+(R<<3)>>3]=0.0;p[m+(R<<3)>>3]=0.0;if(o)p[i+(j<<3)>>3]=0.0;if(!d)d=0;else{p[d+(R<<3)>>3]=0.0;d=d+8|0}f=f+1|0;if((f|0)==(j|0))break;else{i=i+8|0;h=h+8|0;m=m+8|0}}f=b+(j<<3)|0;h=q;i=a+(j<<3)|0;m=c+(s<<3)|0;break}while(1){p[h+(R<<3)>>3]=0.0;p[m+(R<<3)>>3]=0.0;i=(d|0)==0;if(i){l=0.0;f=0;do{w=+p[e+(f<<3)>>3];p[h+(f<<3)>>3]=w;p[n+(f<<3)>>3]=w;l=l+w;p[m+(f<<3)>>3]=l;f=f+j|0}while((f|0)<(x|0))}else{l=0.0;t=0.0;f=0;do{w=+p[e+(f<<3)>>3];p[h+(f<<3)>>3]=w;p[n+(f<<3)>>3]=w;t=t+w;l=l+w*w;p[m+(f<<3)>>3]=t;p[d+(f<<3)>>3]=l;f=f+j|0}while((f|0)<(x|0))}if(o)p[n+(j<<3)>>3]=0.0;if(i)d=0;else{p[d+(R<<3)>>3]=0.0;d=d+8|0}g=g+1|0;if((g|0)==(j|0))break;else{n=n+8|0;h=h+8|0;m=m+8|0;e=e+8|0}}f=b+(j<<3)|0;h=q;i=a+(j<<3)|0;m=c+(s<<3)|0}else{f=b;d=e;i=a}while(0);if((Q|0)>1){y=M-j|0;z=P-j|0;A=K-j|0;B=O-j|0;C=0-P|0;D=0-O|0;G=K+j|0;E=x-j|0;F=(E|0)>(j|0);x=(x|0)>(j|0);u=f;a=1;while(1){g=i+(y<<3)|0;n=m+(z<<3)|0;e=h+(A<<3)|0;f=u+(R<<3)|0;d=(d|0)==0?0:d+(B<<3)|0;if(H){c=0;s=g;while(1){w=+p[s>>3];l=w*w;p[n+(R<<3)>>3]=0.0;q=(d|0)!=0;if(q)p[d+(R<<3)>>3]=0.0;g=e+(L<<3)|0;p[e+(R<<3)>>3]=+p[g>>3];p[n>>3]=w+ +p[n+(C<<3)>>3];if(q)p[d>>3]=l+ +p[d+(D<<3)>>3];p[e>>3]=w+ +p[g>>3]+ +p[f+(j<<3)>>3];if(F)if(q){t=w;v=l;l=w;o=j;while(1){w=+p[f+(o<<3)>>3];p[f+(o-j<<3)>>3]=t+w;t=+p[s+(o<<3)>>3];l=l+t;v=v+t*t;p[n+(o<<3)>>3]=+p[n+(o-P<<3)>>3]+l;p[d+(o<<3)>>3]=v+ +p[d+(o-O<<3)>>3];g=o+j|0;p[e+(o<<3)>>3]=w+(t+ +p[f+(g<<3)>>3]+ +p[e+(o-G<<3)>>3]);if((g|0)<(E|0))o=g;else break}}else{t=w;v=l;l=w;o=j;while(1){w=+p[f+(o<<3)>>3];p[f+(o-j<<3)>>3]=t+w;t=+p[s+(o<<3)>>3];l=l+t;v=v+t*t;p[n+(o<<3)>>3]=+p[n+(o-P<<3)>>3]+l;g=o+j|0;p[e+(o<<3)>>3]=w+(t+ +p[f+(g<<3)>>3]+ +p[e+(o-G<<3)>>3]);if((g|0)<(E|0))o=g;else break}}else{t=w;v=l;l=w;g=j}if(x){o=f+(g<<3)|0;w=+p[o>>3];p[f+(g-j<<3)>>3]=t+w;t=+p[s+(g<<3)>>3];p[n+(g<<3)>>3]=+p[n+(g-P<<3)>>3]+(l+t);if(q)p[d+(g<<3)>>3]=v+t*t+ +p[d+(g-O<<3)>>3];p[e+(g<<3)>>3]=w+t+ +p[e+(g-G<<3)>>3];p[o>>3]=t}d=q?d+8|0:0;c=c+1|0;if((c|0)==(j|0))break;else{f=f+8|0;e=e+8|0;n=n+8|0;s=s+8|0}}f=u;h=h+(K<<3)|0;i=i+(M<<3)|0;m=m+(P<<3)|0}else{h=e;i=g;m=n}a=a+1|0;if((a|0)==(Q|0))break;else u=f}}if((b|0)!=(I|0)){ggb(b);k[N>>2]=I;k[J>>2]=136}r=S;return}function Vua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;V=r;r=r+496|0;U=V+440|0;T=V+384|0;e=V+328|0;H=V+272|0;D=V+216|0;B=V+160|0;w=V+104|0;q=V+48|0;n=V+32|0;o=V+16|0;p=V;M1(U,a,0,1,0,0);M1(T,b,0,1,0,0);k[e>>2]=k[T>>2];M=e+4|0;S=T+4|0;a=k[S>>2]|0;k[M>>2]=a;O=e+8|0;k[O>>2]=k[T+8>>2];k[e+12>>2]=k[T+12>>2];J=e+16|0;Q=T+16|0;k[J>>2]=k[Q>>2];k[e+20>>2]=k[T+20>>2];k[e+24>>2]=k[T+24>>2];k[e+28>>2]=k[T+28>>2];I=e+32|0;P=T+32|0;k[I>>2]=k[P>>2];K=e+36|0;R=T+36|0;b=k[R>>2]|0;k[K>>2]=b;L=e+40|0;k[L>>2]=O;O=e+48|0;N=e+44|0;k[N>>2]=O;k[e+52>>2]=0;k[O>>2]=0;if(b){a=b+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[S>>2]|0}if((a|0)>=3){k[M>>2]=0;x1(e,a,0,0,0);if((k[M>>2]|0)>0){b=k[T+40>>2]|0;e=k[L>>2]|0;f=k[T+44>>2]|0;g=k[N>>2]|0;a=0;do{k[e+(a<<2)>>2]=k[b+(a<<2)>>2];k[g+(a<<2)>>2]=k[f+(a<<2)>>2];a=a+1|0}while((a|0)<(k[M>>2]|0))}}else{F=k[T+44>>2]|0;G=k[N>>2]|0;k[G>>2]=k[F>>2];k[G+4>>2]=k[F+4>>2]}k[H>>2]=1124007936;F=H+4|0;a=H+8|0;C=H+40|0;f=F;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[C>>2]=a;G=H+48|0;E=H+44|0;k[E>>2]=G;k[H+52>>2]=0;k[G>>2]=0;k[D>>2]=1124007936;z=D+4|0;a=D+8|0;x=D+40|0;f=z;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[x>>2]=a;A=D+48|0;y=D+44|0;k[y>>2]=A;k[D+52>>2]=0;k[A>>2]=0;k[B>>2]=1124007936;u=B+4|0;a=B+8|0;s=B+40|0;f=u;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[s>>2]=a;v=B+48|0;t=B+44|0;k[t>>2]=v;k[B+52>>2]=0;k[v>>2]=0;k[w>>2]=1124007936;l=w+4|0;a=w+8|0;h=w+40|0;f=l;g=f+36|0;do{k[f>>2]=0;f=f+4|0}while((f|0)<(g|0));k[h>>2]=a;m=w+48|0;j=w+44|0;k[j>>2]=m;k[w+52>>2]=0;k[m>>2]=0;if(!c)f=0;else{M1(q,c,0,1,0,0);KG(H,KG(D,q)|0)|0;e=q+36|0;a=k[e>>2]|0;if(a|0?(g=a+12|0,c=k[g>>2]|0,k[g>>2]=c+-1,(c|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;c=q+16|0;b=q+4|0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[b>>2]|0)>0){e=k[q+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[q+44>>2]|0;if(!((a|0)==(q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);f=D}if(!d)b=0;else{M1(q,d,0,1,0,0);KG(B,KG(w,q)|0)|0;e=q+36|0;a=k[e>>2]|0;if(a|0?(c=a+12|0,d=k[c>>2]|0,k[c>>2]=d+-1,(d|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[q+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;d=q+16|0;b=q+4|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[b>>2]|0)>0){e=k[q+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[q+44>>2]|0;if(!((a|0)==(q+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);b=w}k[q+8>>2]=0;k[q+12>>2]=0;k[q>>2]=16842752;k[q+4>>2]=U;a=n+4|0;d=a+4|0;k[d>>2]=0;k[d+4>>2]=0;k[n>>2]=33619968;k[a>>2]=T;a=o+4|0;d=a+4|0;k[d>>2]=0;k[d+4>>2]=0;if(!f){k[o>>2]=33554432;k[a>>2]=0}else{k[o>>2]=33619968;k[a>>2]=f}a=p+4|0;d=a+4|0;k[d>>2]=0;k[d+4>>2]=0;if(!b){k[p>>2]=33554432;k[a>>2]=0}else{k[p>>2]=33619968;k[a>>2]=b}Iua(q,n,o,p,k[T>>2]&7,-1);if(!(((k[Q>>2]|0)==(k[J>>2]|0)?(k[D+16>>2]|0)==(k[H+16>>2]|0):0)?(k[w+16>>2]|0)==(k[B+16>>2]|0):0)){k[q>>2]=0;a=q+4|0;k[a>>2]=0;b=ZT(88)|0;k[b>>2]=1;f=b+4|0;k[q>>2]=f;k[a>>2]=81;i[b+85>>0]=0;e=352466;g=f+81|0;do{i[f>>0]=i[e>>0]|0;f=f+1|0;e=e+1|0}while((f|0)<(g|0));Y8(-215,q,352548,352395,593);k[a>>2]=0;k[q>>2]=0;q=k[b>>2]|0;k[b>>2]=q+-1;if((q|0)==1)ggb(k[b+-4>>2]|0)}e=w+36|0;a=k[e>>2]|0;if(a|0?(p=a+12|0,q=k[p>>2]|0,k[p>>2]=q+-1,(q|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[w+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;w=w+16|0;k[w>>2]=0;k[w+4>>2]=0;k[w+8>>2]=0;k[w+12>>2]=0;if((k[l>>2]|0)>0){b=k[h>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[j>>2]|0;if(!((a|0)==(m|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=B+36|0;a=k[e>>2]|0;if(a|0?(q=a+12|0,w=k[q>>2]|0,k[q>>2]=w+-1,(w|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;if(!a){a=k[B+32>>2]|0;if(!a){a=B1()|0;b=k[e>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;B=B+16|0;k[B>>2]=0;k[B+4>>2]=0;k[B+8>>2]=0;k[B+12>>2]=0;if((k[u>>2]|0)>0){b=k[s>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[u>>2]|0))}a=k[t>>2]|0;if(!((a|0)==(v|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=D+36|0;a=k[e>>2]|0;if(a|0?(w=a+12|0,B=k[w>>2]|0,k[w>>2]=B+-1,(B|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[D+32>>2]|0;if(a|0)break;a=B1()|0;b=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;D=D+16|0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[z>>2]|0)>0){b=k[x>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[z>>2]|0))}a=k[y>>2]|0;if(!((a|0)==(A|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=H+36|0;a=k[e>>2]|0;if(a|0?(B=a+12|0,D=k[B>>2]|0,k[B>>2]=D+-1,(D|0)==1):0){b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[H+32>>2]|0;if(a|0)break;a=B1()|0;b=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}k[e>>2]=0;H=H+16|0;k[H>>2]=0;k[H+4>>2]=0;k[H+8>>2]=0;k[H+12>>2]=0;if((k[F>>2]|0)>0){b=k[C>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[F>>2]|0))}a=k[E>>2]|0;if(!((a|0)==(G|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[K>>2]|0;do if(a|0){G=a+12|0;H=k[G>>2]|0;k[G>>2]=H+-1;if((H|0)!=1)break;b=k[K>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[I>>2]|0;if(a|0)break;a=B1()|0;b=k[K>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[K>>2]=0}while(0);k[K>>2]=0;k[J>>2]=0;k[J+4>>2]=0;k[J+8>>2]=0;k[J+12>>2]=0;if((k[M>>2]|0)>0){b=k[L>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[M>>2]|0))}a=k[N>>2]|0;if(!((a|0)==(O|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[R>>2]|0;do if(a|0){N=a+12|0;O=k[N>>2]|0;k[N>>2]=O+-1;if((O|0)!=1)break;b=k[R>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[P>>2]|0;if(a|0)break;a=B1()|0;b=k[R>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[R>>2]=0}while(0);k[R>>2]=0;k[Q>>2]=0;k[Q+4>>2]=0;k[Q+8>>2]=0;k[Q+12>>2]=0;if((k[S>>2]|0)>0){b=k[T+40>>2]|0;a=0;do{k[b+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[S>>2]|0))}a=k[T+44>>2]|0;if(!((a|0)==(T+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);e=U+36|0;a=k[e>>2]|0;do if(a|0){S=a+12|0;T=k[S>>2]|0;k[S>>2]=T+-1;if((T|0)!=1)break;b=k[e>>2]|0;if(b|0){a=k[b+4>>2]|0;do if(!a){a=k[U+32>>2]|0;if(a|0)break;a=B1()|0;b=k[e>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,b)}k[e>>2]=0}while(0);k[e>>2]=0;T=U+16|0;b=U+4|0;k[T>>2]=0;k[T+4>>2]=0;k[T+8>>2]=0;k[T+12>>2]=0;if((k[b>>2]|0)>0){e=k[U+40>>2]|0;a=0;do{k[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[b>>2]|0))}a=k[U+44>>2]|0;if((a|0)==(U+48|0)|(a|0)==0){r=V;return}ggb(k[a+-4>>2]|0);r=V;return}function Wua(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;var j=0,l=0,m=0,n=0,o=0,q=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0;Td=r;r=r+800|0;Hd=Td+88|0;Rd=Td+776|0;Qa=Td+720|0;Jd=Td+664|0;Id=Td+608|0;Wa=Td+552|0;vd=Td+496|0;wd=Td+440|0;xd=Td+32|0;yd=Td+384|0;zd=Td+328|0;Ad=Td+272|0;Bd=Td+216|0;Cd=Td+160|0;Dd=Td;Ed=Td+144|0;k[Rd>>2]=0;Sd=Rd+4|0;k[Sd>>2]=0;k[Rd+8>>2]=0;k[Qa>>2]=k[b>>2];Od=Qa+4|0;l=b+4|0;j=k[l>>2]|0;k[Od>>2]=j;Fd=Qa+8|0;k[Fd>>2]=k[b+8>>2];Gd=Qa+12|0;k[Gd>>2]=k[b+12>>2];Ld=Qa+16|0;k[Ld>>2]=k[b+16>>2];Ra=Qa+20|0;k[Ra>>2]=k[b+20>>2];Sa=Qa+24|0;k[Sa>>2]=k[b+24>>2];Ta=Qa+28|0;k[Ta>>2]=k[b+28>>2];Kd=Qa+32|0;k[Kd>>2]=k[b+32>>2];Md=Qa+36|0;m=k[b+36>>2]|0;k[Md>>2]=m;Nd=Qa+40|0;k[Nd>>2]=Fd;Qd=Qa+48|0;Pd=Qa+44|0;k[Pd>>2]=Qd;k[Qa+52>>2]=0;k[Qd>>2]=0;if(m){j=m+12|0;k[j>>2]=(k[j>>2]|0)+1;j=k[l>>2]|0}if((j|0)>=3){k[Od>>2]=0;x1(Qa,j,0,0,0);j=k[Od>>2]|0;if((j|0)>0){m=k[b+40>>2]|0;n=k[Nd>>2]|0;o=k[b+44>>2]|0;q=k[Pd>>2]|0;l=0;do{k[n+(l<<2)>>2]=k[m+(l<<2)>>2];k[q+(l<<2)>>2]=k[o+(l<<2)>>2];l=l+1|0;j=k[Od>>2]|0}while((l|0)<(j|0))}}else{ud=k[b+44>>2]|0;j=k[Pd>>2]|0;k[j>>2]=k[ud>>2];k[j+4>>2]=k[ud+4>>2];j=k[Od>>2]|0}w=k[a>>2]|0;Xa=w&7;w=w>>>3;td=w&511;Pa=k[Qa>>2]|0;m=Pa&7;Pa=Pa>>>3&511;t=Pa+1|0;ud=e&7;x=e>>>3;o=x&511;Va=a+4|0;if(!((k[Va>>2]|0)<3&(j|0)<3?(k[c+4>>2]|0)<3:0)){k[Hd>>2]=0;j=Hd+4|0;k[j>>2]=0;l=ZT(56)|0;k[l>>2]=1;Pc=l+4|0;k[Hd>>2]=Pc;k[j>>2]=50;i[l+54>>0]=0;q=353328;Qc=Pc+50|0;do{i[Pc>>0]=i[q>>0]|0;Pc=Pc+1|0;q=q+1|0}while((Pc|0)<(Qc|0));Y8(-215,Hd,353379,353389,648);k[j>>2]=0;k[Hd>>2]=0;sd=k[l>>2]|0;k[l>>2]=sd+-1;if((sd|0)==1)ggb(k[l+-4>>2]|0)}if((Xa|0)!=(m|0)){j=Xa>>>0>5?Xa:5;if((m|0)==(j|0))z=m;else{z=Hd+4|0;sd=z+4|0;k[sd>>2]=0;k[sd+4>>2]=0;k[Hd>>2]=33619968;k[z>>2]=Qa;SW(b,Hd,j,1.0,0.0);z=k[Qa>>2]&7}}else z=Xa;if(!((Xa|0)==(z|0)|(z|0)==5)){k[Hd>>2]=0;j=Hd+4|0;k[j>>2]=0;l=ZT(40)|0;k[l>>2]=1;Pc=l+4|0;k[Hd>>2]=Pc;k[j>>2]=35;i[l+39>>0]=0;q=353461;Qc=Pc+35|0;do{i[Pc>>0]=i[q>>0]|0;Pc=Pc+1|0;q=q+1|0}while((Pc|0)<(Qc|0));Y8(-215,Hd,353379,353389,656);k[j>>2]=0;k[Hd>>2]=0;sd=k[l>>2]|0;k[l>>2]=sd+-1;if((sd|0)==1)ggb(k[l+-4>>2]|0)}n=d+4|0;Ua=a+8|0;if(!((k[n>>2]|0)<((k[Fd>>2]|0)+(k[Ua>>2]|0)|0)?(k[d>>2]|0)<((k[Gd>>2]|0)+(k[a+12>>2]|0)|0):0)){k[Hd>>2]=0;j=Hd+4|0;k[j>>2]=0;l=ZT(96)|0;k[l>>2]=1;Pc=l+4|0;k[Hd>>2]=Pc;k[j>>2]=91;i[l+95>>0]=0;q=353497;Qc=Pc+91|0;do{i[Pc>>0]=i[q>>0]|0;Pc=Pc+1|0;q=q+1|0}while((Pc|0)<(Qc|0));Y8(-215,Hd,353379,353389,658);k[j>>2]=0;k[Hd>>2]=0;sd=k[l>>2]|0;k[l>>2]=sd+-1;if((sd|0)==1)ggb(k[l+-4>>2]|0)}sd=(o|0)==0;if(!(sd|g==0.0)){k[Hd>>2]=0;j=Hd+4|0;k[j>>2]=0;l=ZT(28)|0;k[l>>2]=1;Pc=l+4|0;k[Hd>>2]=Pc;k[j>>2]=22;i[l+26>>0]=0;q=353589;Qc=Pc+22|0;do{i[Pc>>0]=i[q>>0]|0;Pc=Pc+1|0;q=q+1|0}while((Pc|0)<(Qc|0));Y8(-215,Hd,353379,353389,660);k[j>>2]=0;k[Hd>>2]=0;rd=k[l>>2]|0;k[l>>2]=rd+-1;if((rd|0)==1)ggb(k[l+-4>>2]|0)}m=k[d>>2]|0;l=k[n>>2]|0;j=e&4095;if(!(((((k[c+4>>2]|0)<3?(k[c+8>>2]|0)==(l|0):0)?(k[c+12>>2]|0)==(m|0):0)?(k[c>>2]&4095|0)==(j|0):0)?(k[c+16>>2]|0)!=0:0)){k[Hd>>2]=l;k[Hd+4>>2]=m;G1(c,2,Hd,j)}if(Xa>>>0>1)e=6;else{e=z>>>0>5?z:5;e=(e|0)<(ud|0)?ud:e}o=k[Gd>>2]|0;s=+(o|0)*4.5;p[u>>3]=s;j=k[u+4>>2]|0;rd=j&2146435072;if(!(rd>>>0>1126170624|(rd|0)==1126170624&0>0)){j=(j|0)<0;s=j?s+-4503599627370496.0+4503599627370496.0:s+4503599627370496.0+-4503599627370496.0;if(s==0.0)s=j?-0.0:0.0}m=~~s;pd=256-o+1|0;m=(m|0)<(pd|0)?pd:m;pd=c+12|0;b=k[pd>>2]|0;m=(b|0)<(m|0)?b:m;d=k[Fd>>2]|0;s=+(d|0)*4.5;p[u>>3]=s;j=k[u+4>>2]|0;rd=j&2146435072;if(!(rd>>>0>1126170624|(rd|0)==1126170624&0>0)){j=(j|0)<0;s=j?s+-4503599627370496.0+4503599627370496.0:s+4503599627370496.0+-4503599627370496.0;if(s==0.0)s=j?-0.0:0.0}q=~~s;md=256-d+1|0;q=(q|0)<(md|0)?md:q;md=c+8|0;l=k[md>>2]|0;n=o+-1+m|0;if(n>>>0>2125763999)j=-1;else{j=1650;m=0;do{rd=j+m>>1;qd=(k[41108+(rd<<2)>>2]|0)<(n|0);m=qd?rd+1|0:m;j=qd?j:rd}while((m|0)<(j|0));j=k[41108+(j<<2)>>2]|0}ld=(j|0)<2?2:j;n=((l|0)<(q|0)?l:q)+-1+d|0;if(n>>>0<=2125763999){j=1650;m=0;do{rd=j+m>>1;qd=(k[41108+(rd<<2)>>2]|0)<(n|0);m=qd?rd+1|0:m;j=qd?j:rd}while((m|0)<(j|0));j=k[41108+(j<<2)>>2]|0;if((ld|0)<1|(j|0)<1)v=49;else{m=b;n=d}}else{j=-1;v=49}if((v|0)==49){k[Hd>>2]=0;l=Hd+4|0;k[l>>2]=0;m=ZT(36)|0;k[m>>2]=1;Pc=m+4|0;k[Hd>>2]=Pc;k[l>>2]=28;i[m+32>>0]=0;q=353612;Qc=Pc+28|0;do{i[Pc>>0]=i[q>>0]|0;Pc=Pc+1|0;q=q+1|0}while((Pc|0)<(Qc|0));Y8(-211,Hd,353379,353389,677);k[l>>2]=0;k[Hd>>2]=0;rd=k[m>>2]|0;k[m>>2]=rd+-1;if((rd|0)==1)ggb(k[m+-4>>2]|0);o=k[Gd>>2]|0;m=k[pd>>2]|0;n=k[Fd>>2]|0;l=k[md>>2]|0}gd=ld-o|0;gd=(gd|0)<(m|0)?gd+1|0:m;fd=j-n|0;fd=(fd|0)<(l|0)?fd+1|0:l;m=aa(j,t)|0;k[Jd>>2]=1124007936;qd=Jd+4|0;l=Jd+8|0;nd=Jd+40|0;Pc=qd;Qc=Pc+36|0;do{k[Pc>>2]=0;Pc=Pc+4|0}while((Pc|0)<(Qc|0));k[nd>>2]=l;rd=Jd+48|0;od=Jd+44|0;k[od>>2]=rd;k[Jd+52>>2]=0;k[rd>>2]=0;n=e&4095;k[Hd>>2]=m;m=Hd+4|0;k[m>>2]=ld;G1(Jd,2,Hd,n);k[Id>>2]=1124007936;jd=Id+4|0;l=Id+8|0;hd=Id+40|0;Pc=jd;Qc=Pc+36|0;do{k[Pc>>2]=0;Pc=Pc+4|0}while((Pc|0)<(Qc|0));k[hd>>2]=l;kd=Id+48|0;id=Id+44|0;k[id>>2]=kd;k[Id+52>>2]=0;k[kd>>2]=0;k[Hd>>2]=j;k[m>>2]=ld;G1(Id,2,Hd,n);cd=(Pa|0)!=0;if((z|0)==(e|0)|cd^1)l=0;else l=aa(k[Gd>>2]<<(47696>>>(z<<1)&3),k[Fd>>2]|0)|0;dd=(td|0)!=0;ed=(Xa|0)==(e|0);if(!(ed|dd^1)){bd=(aa(fd+-1+(k[Fd>>2]|0)|0,gd+-1+(k[Gd>>2]|0)|0)|0)<<(47696>>>(Xa<<1)&3);l=(l|0)<(bd|0)?bd:l}bd=(ud|0)==(e|0);if(!(((w|x)&511|0)==0|bd)){ad=(aa(fd,gd)|0)<<(47696>>>(ud<<1)&3);l=(l|0)<(ad|0)?ad:l}o=k[Sd>>2]|0;n=k[Rd>>2]|0;m=o-n|0;if(l>>>0<=m>>>0){if(l>>>0<m>>>0?(y=n+l|0,(o|0)!=(y|0)):0)k[Sd>>2]=y}else T1(Rd,l-m|0);A=Wa+4|0;B=Wa+8|0;C=Wa+12|0;D=Wa+16|0;E=Wa+20|0;F=Wa+24|0;G=Wa+28|0;H=Wa+32|0;I=Wa+36|0;J=Wa+40|0;K=Wa+48|0;L=Wa+44|0;M=Wa+52|0;N=Hd+4|0;O=Hd+8|0;P=Hd+12|0;Q=Hd+4|0;R=Hd+8|0;S=Hd+12|0;T=xd+4|0;U=wd+4|0;V=xd+8|0;W=wd+8|0;X=xd+12|0;Y=wd+12|0;Z=xd+16|0;_=wd+16|0;$=xd+20|0;ba=wd+20|0;ca=xd+24|0;da=wd+24|0;ea=xd+28|0;fa=wd+28|0;ga=xd+32|0;ha=wd+32|0;ia=xd+36|0;ja=wd+36|0;ka=xd+40|0;la=xd+48|0;ma=xd+44|0;na=xd+52|0;oa=wd+44|0;pa=Hd+4|0;qa=Hd+4|0;ra=vd+12|0;sa=xd+4|0;ta=yd+4|0;ua=Hd+36|0;va=Hd+16|0;wa=Hd+4|0;xa=Hd+40|0;ya=Hd+44|0;za=Hd+48|0;Aa=Hd+8|0;Ba=Hd+12|0;Ca=Hd+4|0;Da=xd+4|0;Ea=Da+4|0;Fa=wd+40|0;Ga=wd+48|0;Ha=vd+36|0;Ia=vd+16|0;Ja=vd+4|0;Ka=vd+40|0;La=vd+44|0;Ma=vd+48|0;Na=Hd+4|0;Oa=Na+4|0;x=(z|0)==(e|0);y=z|1124007936;e=47696>>>(z<<1)&3;t=1<<e;v=Hd+32|0;w=vd+32|0;d=0;while(1){b=aa(d,j)|0;k[Wa>>2]=k[Qa>>2];l=k[Od>>2]|0;k[A>>2]=l;k[B>>2]=k[Fd>>2];k[C>>2]=k[Gd>>2];k[D>>2]=k[Ld>>2];k[E>>2]=k[Ra>>2];k[F>>2]=k[Sa>>2];k[G>>2]=k[Ta>>2];k[H>>2]=k[Kd>>2];m=k[Md>>2]|0;k[I>>2]=m;k[J>>2]=B;k[L>>2]=K;k[M>>2]=0;k[K>>2]=0;if(m){l=m+12|0;k[l>>2]=(k[l>>2]|0)+1;l=k[Od>>2]|0}do if((l|0)<3){$c=k[Pd>>2]|0;ad=k[L>>2]|0;k[ad>>2]=k[$c>>2];k[ad+4>>2]=k[$c+4>>2]}else{k[A>>2]=0;x1(Wa,l,0,0,0);if((k[A>>2]|0)<=0)break;m=k[Nd>>2]|0;n=k[J>>2]|0;o=k[Pd>>2]|0;q=k[L>>2]|0;l=0;do{k[n+(l<<2)>>2]=k[m+(l<<2)>>2];k[q+(l<<2)>>2]=k[o+(l<<2)>>2];l=l+1|0}while((l|0)<(k[A>>2]|0))}while(0);k[Hd>>2]=0;k[N>>2]=b;k[O>>2]=ld;k[P>>2]=j;I1(vd,Jd,Hd);$c=k[Gd>>2]|0;ad=k[Fd>>2]|0;k[Hd>>2]=0;k[Q>>2]=b;k[R>>2]=$c;k[S>>2]=ad;I1(wd,Jd,Hd);if(cd){do if(x){k[xd>>2]=k[wd>>2];l=k[U>>2]|0;k[T>>2]=l;k[V>>2]=k[W>>2];k[X>>2]=k[Y>>2];k[Z>>2]=k[_>>2];k[$>>2]=k[ba>>2];k[ca>>2]=k[da>>2];k[ea>>2]=k[fa>>2];k[ga>>2]=k[ha>>2];m=k[ja>>2]|0;k[ia>>2]=m;k[ka>>2]=V;k[ma>>2]=la;k[na>>2]=0;k[la>>2]=0;if(m){l=m+12|0;k[l>>2]=(k[l>>2]|0)+1;l=k[U>>2]|0}if((l|0)<3){$c=k[oa>>2]|0;ad=k[ma>>2]|0;k[ad>>2]=k[$c>>2];k[ad+4>>2]=k[$c+4>>2];break}k[T>>2]=0;x1(xd,l,0,0,0);if((k[T>>2]|0)<=0)break;m=k[Fa>>2]|0;n=k[ka>>2]|0;o=k[oa>>2]|0;q=k[ma>>2]|0;l=0;do{k[n+(l<<2)>>2]=k[m+(l<<2)>>2];k[q+(l<<2)>>2]=k[o+(l<<2)>>2];l=l+1|0}while((l|0)<(k[T>>2]|0))}else{ad=k[Nd>>2]|0;l=k[ad+4>>2]|0;ad=k[ad>>2]|0;m=k[Rd>>2]|0;k[xd>>2]=y;k[T>>2]=2;k[V>>2]=ad;k[X>>2]=l;k[Z>>2]=m;k[$>>2]=m;k[ca>>2]=0;k[ca+4>>2]=0;k[ca+8>>2]=0;k[ca+12>>2]=0;k[ka>>2]=V;k[ma>>2]=la;k[na>>2]=0;k[la>>2]=0;if((aa(ad,l)|0)!=0&(m|0)==0){k[Hd>>2]=0;k[qa>>2]=0;l=ZT(36)|0;k[l>>2]=1;Pc=l+4|0;k[Hd>>2]=Pc;k[qa>>2]=28;i[l+32>>0]=0;q=390609;Qc=Pc+28|0;do{i[Pc>>0]=i[q>>0]|0;Pc=Pc+1|0;q=q+1|0}while((Pc|0)<(Qc|0));Y8(-215,Hd,390638,390642,443);k[qa>>2]=0;k[Hd>>2]=0;ad=k[l>>2]|0;k[l>>2]=ad+-1;if((ad|0)==1)ggb(k[l+-4>>2]|0);l=k[X>>2]|0;n=k[xd>>2]|0;o=k[ma>>2]|0;m=k[$>>2]|0}else{n=y;o=la}ad=l<<e;k[xd>>2]=n|16384;k[o>>2]=ad;k[o+4>>2]=t;$c=m+(aa(k[V>>2]|0,ad)|0)|0;k[ea>>2]=$c;k[ca>>2]=$c+(0-ad)+ad}while(0);KG(Wa,xd)|0;l=k[ia>>2]|0;do if(l|0){$c=l+12|0;ad=k[$c>>2]|0;k[$c>>2]=ad+-1;if((ad|0)!=1)break;m=k[ia>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[ga>>2]|0;if(l|0)break;l=B1()|0;m=k[ia>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[ia>>2]=0}while(0);k[ia>>2]=0;k[Z>>2]=0;k[Z+4>>2]=0;k[Z+8>>2]=0;k[Z+12>>2]=0;if((k[T>>2]|0)>0){m=k[ka>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[T>>2]|0))}l=k[ma>>2]|0;if(!((l|0)==(la|0)|(l|0)==0))ggb(k[l+-4>>2]|0);k[Hd>>2]=d;k[pa>>2]=0;HV(Qa,1,Wa,1,Hd,1)}if((k[_>>2]|0)!=(k[D>>2]|0)){ad=Oa;k[ad>>2]=0;k[ad+4>>2]=0;k[Hd>>2]=33619968;k[Na>>2]=wd;SW(Wa,Hd,k[wd>>2]&7,1.0,0.0)}l=k[ra>>2]|0;m=k[Gd>>2]|0;if((l|0)>(m|0)){ad=k[Fd>>2]|0;k[xd>>2]=0;k[sa>>2]=ad;k[yd>>2]=m;k[ta>>2]=l;H1(Hd,vd,xd,yd);k[xd>>2]=0;k[xd+4>>2]=0;k[xd+8>>2]=0;k[xd+12>>2]=0;k[xd+16>>2]=0;k[xd+20>>2]=0;k[xd+24>>2]=0;k[xd+28>>2]=0;oY(Hd,xd);l=k[ua>>2]|0;do if(l|0){$c=l+12|0;ad=k[$c>>2]|0;k[$c>>2]=ad+-1;if((ad|0)!=1)break;m=k[ua>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[v>>2]|0;if(l|0)break;l=B1()|0;m=k[ua>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[ua>>2]=0}while(0);k[ua>>2]=0;k[va>>2]=0;k[va+4>>2]=0;k[va+8>>2]=0;k[va+12>>2]=0;if((k[wa>>2]|0)>0){m=k[xa>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[wa>>2]|0))}l=k[ya>>2]|0;if(!((l|0)==(za|0)|(l|0)==0))ggb(k[l+-4>>2]|0)}k[Aa>>2]=0;k[Ba>>2]=0;k[Hd>>2]=16842752;k[Ca>>2]=vd;l=Ea;k[l>>2]=0;k[l+4>>2]=0;k[xd>>2]=33619968;k[Da>>2]=vd;bZ(Hd,xd,0,k[Fd>>2]|0);l=k[ja>>2]|0;do if(l|0){$c=l+12|0;ad=k[$c>>2]|0;k[$c>>2]=ad+-1;if((ad|0)!=1)break;m=k[ja>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[ha>>2]|0;if(l|0)break;l=B1()|0;m=k[ja>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[ja>>2]=0}while(0);k[ja>>2]=0;k[_>>2]=0;k[_+4>>2]=0;k[_+8>>2]=0;k[_+12>>2]=0;if((k[U>>2]|0)>0){m=k[Fa>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[U>>2]|0))}l=k[oa>>2]|0;if(!((l|0)==(Ga|0)|(l|0)==0))ggb(k[l+-4>>2]|0);l=k[Ha>>2]|0;do if(l|0){$c=l+12|0;ad=k[$c>>2]|0;k[$c>>2]=ad+-1;if((ad|0)!=1)break;m=k[Ha>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[w>>2]|0;if(l|0)break;l=B1()|0;m=k[Ha>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[Ha>>2]=0}while(0);k[Ha>>2]=0;k[Ia>>2]=0;k[Ia+4>>2]=0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;if((k[Ja>>2]|0)>0){m=k[Ka>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[Ja>>2]|0))}l=k[La>>2]|0;if(!((l|0)==(Ma|0)|(l|0)==0))ggb(k[l+-4>>2]|0);l=k[I>>2]|0;do if(l|0){$c=l+12|0;ad=k[$c>>2]|0;k[$c>>2]=ad+-1;if((ad|0)!=1)break;m=k[I>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[H>>2]|0;if(l|0)break;l=B1()|0;m=k[I>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[I>>2]=0}while(0);k[I>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[A>>2]|0)>0){m=k[J>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[A>>2]|0))}l=k[L>>2]|0;if(!((l|0)==(K|0)|(l|0)==0))ggb(k[l+-4>>2]|0);if((d|0)<(Pa|0))d=d+1|0;else break}Rc=(gd+-1+(k[pd>>2]|0)|0)/(gd|0)|0;Sc=aa((fd+-1+(k[md>>2]|0)|0)/(fd|0)|0,Rc)|0;n=a+40|0;b=k[n>>2]|0;Tc=k[b>>2]|0;k[Wa>>2]=k[b+4>>2];b=Wa+4|0;k[b>>2]=Tc;k[vd>>2]=0;Tc=vd+4|0;k[Tc>>2]=0;k[wd>>2]=k[a>>2];_c=wd+4|0;l=k[Va>>2]|0;k[_c>>2]=l;Uc=wd+8|0;k[Uc>>2]=k[Ua>>2];Vc=wd+12|0;d=a+12|0;k[Vc>>2]=k[d>>2];Xc=wd+16|0;k[Xc>>2]=k[a+16>>2];k[wd+20>>2]=k[a+20>>2];k[wd+24>>2]=k[a+24>>2];k[wd+28>>2]=k[a+28>>2];Wc=wd+32|0;k[Wc>>2]=k[a+32>>2];Yc=wd+36|0;m=k[a+36>>2]|0;k[Yc>>2]=m;Zc=wd+40|0;k[Zc>>2]=Uc;ad=wd+48|0;$c=wd+44|0;k[$c>>2]=ad;k[wd+52>>2]=0;k[ad>>2]=0;if(m){l=m+12|0;k[l>>2]=(k[l>>2]|0)+1;l=k[Va>>2]|0}do if((l|0)<3){Pc=k[a+44>>2]|0;Qc=k[$c>>2]|0;k[Qc>>2]=k[Pc>>2];k[Qc+4>>2]=k[Pc+4>>2]}else{k[_c>>2]=0;x1(wd,l,0,0,0);if((k[_c>>2]|0)<=0)break;m=k[n>>2]|0;n=k[Zc>>2]|0;o=k[a+44>>2]|0;q=k[$c>>2]|0;l=0;do{k[n+(l<<2)>>2]=k[m+(l<<2)>>2];k[q+(l<<2)>>2]=k[o+(l<<2)>>2];l=l+1|0}while((l|0)<(k[_c>>2]|0))}while(0);if(!(h&16)){N1(a,Wa,vd);Pc=k[Tc>>2]|0;Qc=k[vd>>2]|0;O1(wd,Pc,(k[b>>2]|0)-Pc-(k[Ua>>2]|0)|0,Qc,(k[Wa>>2]|0)-Qc-(k[d>>2]|0)|0)}Hb=h|16;if((Sc|0)>0){Ib=f+4|0;Jb=Hd+4|0;Kb=yd+4|0;Lb=Hd+4|0;Mb=Hd+8|0;Nb=Hd+12|0;Ob=Hd+4|0;Pb=Hd+8|0;Qb=Hd+12|0;Rb=Hd+4|0;Sb=Hd+8|0;Tb=Hd+12|0;Ub=Bd+4|0;Vb=xd+4|0;Wb=Bd+8|0;Xb=xd+8|0;Yb=Bd+12|0;Zb=xd+12|0;_b=Bd+16|0;$b=xd+16|0;ac=Bd+20|0;bc=xd+20|0;cc=Bd+24|0;dc=xd+24|0;ec=Bd+28|0;fc=xd+28|0;gc=Bd+32|0;hc=xd+32|0;ic=Bd+36|0;jc=xd+36|0;kc=Bd+40|0;lc=Bd+48|0;mc=Bd+44|0;nc=Bd+52|0;oc=xd+44|0;pc=Cd+4|0;qc=zd+4|0;rc=Cd+8|0;sc=zd+8|0;tc=Cd+12|0;uc=zd+12|0;vc=Cd+16|0;wc=zd+16|0;xc=Cd+20|0;yc=zd+20|0;zc=Cd+24|0;Ac=zd+24|0;Bc=Cd+28|0;Cc=zd+28|0;Dc=Cd+32|0;Ec=zd+32|0;Fc=Cd+36|0;Gc=zd+36|0;Hc=Cd+40|0;Ic=Cd+48|0;Jc=Cd+44|0;Kc=Cd+52|0;Lc=zd+44|0;Mc=Hd+4|0;Nc=Xa|1124007936;Oc=Hd+4|0;F=47696>>>(Xa<<1)&3;G=1<<F;H=Hd+8|0;I=Hd+12|0;J=Hd+4|0;K=Cd+4|0;L=K+4|0;M=yd+8|0;N=yd+12|0;O=Hd+8|0;P=Hd+12|0;Q=Hd+4|0;R=Cd+4|0;S=R+4|0;T=Cd+4|0;U=Cd+8|0;V=Cd+12|0;W=Cd+8|0;X=Cd+12|0;Y=Cd+4|0;Z=Dd+8|0;_=Dd+12|0;$=Dd+4|0;ba=Ed+4|0;ca=ba+4|0;da=Cd+8|0;ea=Cd+12|0;fa=Cd+4|0;ga=Dd+4|0;ha=ga+4|0;ia=Dd+4|0;ja=Dd+8|0;ka=Dd+12|0;la=Cd+36|0;ma=Cd+16|0;na=Cd+4|0;oa=Cd+40|0;pa=Cd+44|0;qa=Cd+48|0;ra=Cd+4|0;sa=ra+4|0;ta=Cd+8|0;ua=Cd+12|0;va=Cd+4|0;wa=Dd+8|0;xa=Dd+12|0;ya=Dd+4|0;za=Ed+4|0;Aa=za+4|0;Ba=Cd+4|0;Ca=Cd+8|0;Da=Cd+12|0;Ea=Cd+16|0;Fa=Cd+20|0;Ga=Cd+24|0;Ha=Cd+28|0;Ia=Cd+40|0;Ja=Cd+48|0;Ka=Cd+44|0;La=Dd+4|0;Ma=La+4|0;Na=Cd+36|0;Oa=Hd+36|0;Pa=Hd+16|0;Qa=Hd+4|0;Ra=Hd+40|0;Sa=Hd+44|0;Ta=Hd+48|0;Ua=Cd+4|0;Va=Cd+4|0;a=Cd+8|0;Wa=Cd+12|0;h=Cd+16|0;Xa=Cd+20|0;Ya=Cd+24|0;Za=Cd+28|0;_a=Cd+40|0;$a=Cd+48|0;ab=Cd+44|0;bb=Dd+4|0;cb=bb+4|0;db=Cd+36|0;eb=Hd+4|0;fb=eb+4|0;gb=Ad+36|0;hb=Ad+16|0;ib=Ad+4|0;jb=Ad+40|0;kb=Ad+44|0;lb=Ad+48|0;mb=zd+40|0;nb=zd+48|0;ob=yd+36|0;pb=yd+16|0;qb=yd+4|0;rb=yd+40|0;sb=yd+44|0;tb=yd+48|0;ub=xd+40|0;vb=xd+48|0;wb=Cd+52|0;xb=Cd+52|0;yb=47696>>>(ud<<1)&3;zb=1<<yb;Ab=ud|1124024320;Bb=Cd+32|0;Cb=Hd+32|0;Db=Cd+32|0;Eb=Cd+32|0;Fb=yd+32|0;Gb=Ad+32|0;E=0;do{t=aa((E|0)%(Rc|0)|0,gd)|0;D=aa((E|0)/(Rc|0)|0,fd)|0;e=(k[pd>>2]|0)-t|0;e=(e|0)<(gd|0)?e:gd;d=(k[md>>2]|0)-D|0;d=(d|0)<(fd|0)?d:fd;C=(k[Gd>>2]|0)+-1+e|0;x=(k[Fd>>2]|0)+-1+d|0;y=t-(k[f>>2]|0)+(k[vd>>2]|0)|0;z=D-(k[Ib>>2]|0)+(k[Tc>>2]|0)|0;A=(y|0)>0?y:0;B=(z|0)>0?z:0;b=y+C|0;w=k[Vc>>2]|0;w=(b|0)<(w|0)?b:w;b=z+x|0;v=k[Uc>>2]|0;v=(b|0)<(v|0)?b:v;k[Hd>>2]=B;k[Jb>>2]=v;k[yd>>2]=A;k[Kb>>2]=w;H1(xd,wd,Hd,yd);k[Hd>>2]=0;k[Lb>>2]=0;k[Mb>>2]=C;k[Nb>>2]=x;I1(yd,Id,Hd);y=A-y|0;z=B-z|0;A=w-A|0;B=v-B|0;k[Hd>>2]=y;k[Ob>>2]=z;k[Pb>>2]=A;k[Qb>>2]=B;I1(zd,Id,Hd);k[Hd>>2]=t;k[Rb>>2]=D;k[Sb>>2]=e;k[Tb>>2]=d;I1(Ad,c,Hd);D=(aa(B,A)|0)!=0;C=(A|0)<(C|0)|(B|0)<(x|0);t=e<<yb;v=aa(d,t)|0;w=0-t|0;b=0;while(1){k[Bd>>2]=k[xd>>2];l=k[Vb>>2]|0;k[Ub>>2]=l;k[Wb>>2]=k[Xb>>2];k[Yb>>2]=k[Zb>>2];k[_b>>2]=k[$b>>2];k[ac>>2]=k[bc>>2];k[cc>>2]=k[dc>>2];k[ec>>2]=k[fc>>2];k[gc>>2]=k[hc>>2];m=k[jc>>2]|0;k[ic>>2]=m;k[kc>>2]=Wb;k[mc>>2]=lc;k[nc>>2]=0;k[lc>>2]=0;if(m){l=m+12|0;k[l>>2]=(k[l>>2]|0)+1;l=k[Vb>>2]|0}do if((l|0)<3){Pc=k[oc>>2]|0;Qc=k[mc>>2]|0;k[Qc>>2]=k[Pc>>2];k[Qc+4>>2]=k[Pc+4>>2]}else{k[Ub>>2]=0;x1(Bd,l,0,0,0);if((k[Ub>>2]|0)<=0)break;m=k[ub>>2]|0;n=k[kc>>2]|0;o=k[oc>>2]|0;q=k[mc>>2]|0;l=0;do{k[n+(l<<2)>>2]=k[m+(l<<2)>>2];k[q+(l<<2)>>2]=k[o+(l<<2)>>2];l=l+1|0}while((l|0)<(k[Ub>>2]|0))}while(0);k[Hd>>2]=0;k[Hd+4>>2]=0;k[Hd+8>>2]=0;k[Hd+12>>2]=0;k[Hd+16>>2]=0;k[Hd+20>>2]=0;k[Hd+24>>2]=0;k[Hd+28>>2]=0;oY(Id,Hd);if(dd){do if(ed){k[Cd>>2]=k[zd>>2];l=k[qc>>2]|0;k[pc>>2]=l;k[rc>>2]=k[sc>>2];k[tc>>2]=k[uc>>2];k[vc>>2]=k[wc>>2];k[xc>>2]=k[yc>>2];k[zc>>2]=k[Ac>>2];k[Bc>>2]=k[Cc>>2];k[Dc>>2]=k[Ec>>2];m=k[Gc>>2]|0;k[Fc>>2]=m;k[Hc>>2]=rc;k[Jc>>2]=Ic;k[Kc>>2]=0;k[Ic>>2]=0;if(m){l=m+12|0;k[l>>2]=(k[l>>2]|0)+1;l=k[qc>>2]|0}if((l|0)<3){Pc=k[Lc>>2]|0;Qc=k[Jc>>2]|0;k[Qc>>2]=k[Pc>>2];k[Qc+4>>2]=k[Pc+4>>2];break}k[pc>>2]=0;x1(Cd,l,0,0,0);if((k[pc>>2]|0)<=0)break;m=k[mb>>2]|0;n=k[Hc>>2]|0;o=k[Lc>>2]|0;q=k[Jc>>2]|0;l=0;do{k[n+(l<<2)>>2]=k[m+(l<<2)>>2];k[q+(l<<2)>>2]=k[o+(l<<2)>>2];l=l+1|0}while((l|0)<(k[pc>>2]|0))}else{l=k[Rd>>2]|0;k[Cd>>2]=Nc;k[pc>>2]=2;k[rc>>2]=B;k[tc>>2]=A;k[vc>>2]=l;k[xc>>2]=l;k[zc>>2]=0;k[zc+4>>2]=0;k[zc+8>>2]=0;k[zc+12>>2]=0;k[Hc>>2]=rc;k[Jc>>2]=Ic;k[Kc>>2]=0;k[Ic>>2]=0;if(D&(l|0)==0){k[Hd>>2]=0;k[Oc>>2]=0;l=ZT(36)|0;k[l>>2]=1;Pc=l+4|0;k[Hd>>2]=Pc;k[Oc>>2]=28;i[l+32>>0]=0;q=390609;Qc=Pc+28|0;do{i[Pc>>0]=i[q>>0]|0;Pc=Pc+1|0;q=q+1|0}while((Pc|0)<(Qc|0));Y8(-215,Hd,390638,390642,410);k[Oc>>2]=0;k[Hd>>2]=0;Qc=k[l>>2]|0;k[l>>2]=Qc+-1;if((Qc|0)==1)ggb(k[l+-4>>2]|0);m=k[tc>>2]|0;n=k[Cd>>2]|0;o=k[Jc>>2]|0;l=k[xc>>2]|0}else{m=A;n=Nc;o=Ic}Qc=m<<F;k[Cd>>2]=n|16384;k[o>>2]=Qc;k[o+4>>2]=G;Pc=l+(aa(k[rc>>2]|0,Qc)|0)|0;k[Bc>>2]=Pc;k[zc>>2]=Pc+(0-Qc)+Qc}while(0);KG(Bd,Cd)|0;l=k[Fc>>2]|0;do if(l|0){Pc=l+12|0;Qc=k[Pc>>2]|0;k[Pc>>2]=Qc+-1;if((Qc|0)!=1)break;m=k[Fc>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[Dc>>2]|0;if(l|0)break;l=B1()|0;m=k[Fc>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[Fc>>2]=0}while(0);k[Fc>>2]=0;k[vc>>2]=0;k[vc+4>>2]=0;k[vc+8>>2]=0;k[vc+12>>2]=0;if((k[pc>>2]|0)>0){m=k[Hc>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[pc>>2]|0))}l=k[Jc>>2]|0;if(!((l|0)==(Ic|0)|(l|0)==0))ggb(k[l+-4>>2]|0);k[Hd>>2]=b;k[Mc>>2]=0;HV(xd,1,Bd,1,Hd,1)}if((k[wc>>2]|0)!=(k[_b>>2]|0)){Qc=fb;k[Qc>>2]=0;k[Qc+4>>2]=0;k[Hd>>2]=33619968;k[eb>>2]=zd;SW(Bd,Hd,k[zd>>2]&7,1.0,0.0)}if(C){k[H>>2]=0;k[I>>2]=0;k[Hd>>2]=16842752;k[J>>2]=zd;o=L;k[o>>2]=0;k[o+4>>2]=0;k[Cd>>2]=33619968;k[K>>2]=yd;o=k[M>>2]|0;q=k[sc>>2]|0;Pc=k[N>>2]|0;Qc=k[uc>>2]|0;k[Dd>>2]=0;k[Dd+4>>2]=0;k[Dd+8>>2]=0;k[Dd+12>>2]=0;k[Dd+16>>2]=0;k[Dd+20>>2]=0;k[Dd+24>>2]=0;k[Dd+28>>2]=0;vY(Hd,Cd,z,o-z-q|0,y,Pc-y-Qc|0,Hb,Dd)}k[O>>2]=0;k[P>>2]=0;k[Hd>>2]=16842752;k[Q>>2]=Id;l=S;k[l>>2]=0;k[l+4>>2]=0;k[Cd>>2]=33619968;k[R>>2]=Id;bZ(Hd,Cd,0,x);l=aa(b,j)|0;k[Cd>>2]=0;k[T>>2]=cd?l:0;k[U>>2]=ld;k[V>>2]=j;I1(Hd,Jd,Cd);k[W>>2]=0;k[X>>2]=0;k[Cd>>2]=16842752;k[Y>>2]=Id;k[Z>>2]=0;k[_>>2]=0;k[Dd>>2]=16842752;k[$>>2]=Hd;l=ca;k[l>>2]=0;k[l+4>>2]=0;k[Ed>>2]=33619968;k[ba>>2]=Id;rZ(Cd,Dd,Ed,0,1);k[da>>2]=0;k[ea>>2]=0;k[Cd>>2]=16842752;k[fa>>2]=Id;l=ha;k[l>>2]=0;k[l+4>>2]=0;k[Dd>>2]=33619968;k[ga>>2]=Id;bZ(Cd,Dd,3,d);k[Dd>>2]=0;k[ia>>2]=0;k[ja>>2]=e;k[ka>>2]=d;I1(Cd,Id,Dd);KG(Bd,Cd)|0;l=k[la>>2]|0;do if(l|0){Pc=l+12|0;Qc=k[Pc>>2]|0;k[Pc>>2]=Qc+-1;if((Qc|0)!=1)break;m=k[la>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[Eb>>2]|0;if(l|0)break;l=B1()|0;m=k[la>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[la>>2]=0}while(0);k[la>>2]=0;k[ma>>2]=0;k[ma+4>>2]=0;k[ma+8>>2]=0;k[ma+12>>2]=0;if((k[na>>2]|0)>0){m=k[oa>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[na>>2]|0))}l=k[pa>>2]|0;if(!((l|0)==(qa|0)|(l|0)==0))ggb(k[l+-4>>2]|0);do if(sd){if(!b){Qc=sa;k[Qc>>2]=0;k[Qc+4>>2]=0;k[Cd>>2]=33619968;k[ra>>2]=Ad;SW(Bd,Cd,ud,1.0,g);break}if(!bd){l=k[Rd>>2]|0;k[Ba>>2]=2;k[Ca>>2]=d;k[Da>>2]=e;k[Ea>>2]=l;k[Fa>>2]=l;Qc=Ga+8|0;k[Qc>>2]=0;k[Qc+4>>2]=0;k[Ia>>2]=Ca;k[Ka>>2]=Ja;k[Cd>>2]=Ab;k[Ja>>2]=t;k[wb>>2]=zb;l=l+v|0;k[Ha>>2]=l;k[Ga>>2]=l+w+t;l=Ma;k[l>>2]=0;k[l+4>>2]=0;k[Dd>>2]=33619968;k[La>>2]=Cd;SW(Bd,Dd,ud,1.0,0.0);KG(Bd,Cd)|0;l=k[Na>>2]|0;do if(l|0){Pc=l+12|0;Qc=k[Pc>>2]|0;k[Pc>>2]=Qc+-1;if((Qc|0)!=1)break;m=k[Na>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[Bb>>2]|0;if(l|0)break;l=B1()|0;m=k[Na>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[Na>>2]=0}while(0);k[Na>>2]=0;k[Ea>>2]=0;k[Ea+4>>2]=0;k[Ea+8>>2]=0;k[Ea+12>>2]=0;if((k[Ba>>2]|0)>0){m=k[Ia>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[Ba>>2]|0))}l=k[Ka>>2]|0;if(!((l|0)==(Ja|0)|(l|0)==0))ggb(k[l+-4>>2]|0)}k[ta>>2]=0;k[ua>>2]=0;k[Cd>>2]=16842752;k[va>>2]=Bd;k[wa>>2]=0;k[xa>>2]=0;k[Dd>>2]=16842752;k[ya>>2]=Ad;Qc=Aa;k[Qc>>2]=0;k[Qc+4>>2]=0;k[Ed>>2]=33619968;k[za>>2]=Ad;sU(Cd,Dd,Ed,49332,-1,39936,0,0)}else{if(!bd){l=k[Rd>>2]|0;k[Va>>2]=2;k[a>>2]=d;k[Wa>>2]=e;k[h>>2]=l;k[Xa>>2]=l;Qc=Ya+8|0;k[Qc>>2]=0;k[Qc+4>>2]=0;k[_a>>2]=a;k[ab>>2]=$a;k[Cd>>2]=Ab;k[$a>>2]=t;k[xb>>2]=zb;l=l+v|0;k[Za>>2]=l;k[Ya>>2]=l+w+t;l=cb;k[l>>2]=0;k[l+4>>2]=0;k[Dd>>2]=33619968;k[bb>>2]=Cd;SW(Bd,Dd,ud,1.0,g);KG(Bd,Cd)|0;l=k[db>>2]|0;do if(l|0){Pc=l+12|0;Qc=k[Pc>>2]|0;k[Pc>>2]=Qc+-1;if((Qc|0)!=1)break;m=k[db>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[Db>>2]|0;if(l|0)break;l=B1()|0;m=k[db>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[db>>2]=0}while(0);k[db>>2]=0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;if((k[Va>>2]|0)>0){m=k[_a>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[Va>>2]|0))}l=k[ab>>2]|0;if(!((l|0)==($a|0)|(l|0)==0))ggb(k[l+-4>>2]|0)}k[Cd>>2]=0;k[Ua>>2]=b;HV(Bd,1,Ad,1,Cd,1)}while(0);l=k[Oa>>2]|0;do if(l|0){Pc=l+12|0;Qc=k[Pc>>2]|0;k[Pc>>2]=Qc+-1;if((Qc|0)!=1)break;m=k[Oa>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[Cb>>2]|0;if(l|0)break;l=B1()|0;m=k[Oa>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[Oa>>2]=0}while(0);k[Oa>>2]=0;k[Pa>>2]=0;k[Pa+4>>2]=0;k[Pa+8>>2]=0;k[Pa+12>>2]=0;if((k[Qa>>2]|0)>0){m=k[Ra>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[Qa>>2]|0))}l=k[Sa>>2]|0;if(!((l|0)==(Ta|0)|(l|0)==0))ggb(k[l+-4>>2]|0);l=k[ic>>2]|0;do if(l|0){Pc=l+12|0;Qc=k[Pc>>2]|0;k[Pc>>2]=Qc+-1;if((Qc|0)!=1)break;m=k[ic>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[gc>>2]|0;if(l|0)break;l=B1()|0;m=k[ic>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[ic>>2]=0}while(0);k[ic>>2]=0;k[_b>>2]=0;k[_b+4>>2]=0;k[_b+8>>2]=0;k[_b+12>>2]=0;if((k[Ub>>2]|0)>0){m=k[kc>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[Ub>>2]|0))}l=k[mc>>2]|0;if(!((l|0)==(lc|0)|(l|0)==0))ggb(k[l+-4>>2]|0);if((b|0)<(td|0))b=b+1|0;else break}l=k[gb>>2]|0;do if(l|0){Pc=l+12|0;Qc=k[Pc>>2]|0;k[Pc>>2]=Qc+-1;if((Qc|0)!=1)break;m=k[gb>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[Gb>>2]|0;if(l|0)break;l=B1()|0;m=k[gb>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[gb>>2]=0}while(0);k[gb>>2]=0;k[hb>>2]=0;k[hb+4>>2]=0;k[hb+8>>2]=0;k[hb+12>>2]=0;if((k[ib>>2]|0)>0){m=k[jb>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[ib>>2]|0))}l=k[kb>>2]|0;if(!((l|0)==(lb|0)|(l|0)==0))ggb(k[l+-4>>2]|0);l=k[Gc>>2]|0;do if(l|0){Pc=l+12|0;Qc=k[Pc>>2]|0;k[Pc>>2]=Qc+-1;if((Qc|0)!=1)break;m=k[Gc>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[Ec>>2]|0;if(l|0)break;l=B1()|0;m=k[Gc>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[Gc>>2]=0}while(0);k[Gc>>2]=0;k[wc>>2]=0;k[wc+4>>2]=0;k[wc+8>>2]=0;k[wc+12>>2]=0;if((k[qc>>2]|0)>0){m=k[mb>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[qc>>2]|0))}l=k[Lc>>2]|0;if(!((l|0)==(nb|0)|(l|0)==0))ggb(k[l+-4>>2]|0);l=k[ob>>2]|0;do if(l|0){Pc=l+12|0;Qc=k[Pc>>2]|0;k[Pc>>2]=Qc+-1;if((Qc|0)!=1)break;m=k[ob>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[Fb>>2]|0;if(l|0)break;l=B1()|0;m=k[ob>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[ob>>2]=0}while(0);k[ob>>2]=0;k[pb>>2]=0;k[pb+4>>2]=0;k[pb+8>>2]=0;k[pb+12>>2]=0;if((k[qb>>2]|0)>0){m=k[rb>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[qb>>2]|0))}l=k[sb>>2]|0;if(!((l|0)==(tb|0)|(l|0)==0))ggb(k[l+-4>>2]|0);l=k[jc>>2]|0;do if(l|0){Pc=l+12|0;Qc=k[Pc>>2]|0;k[Pc>>2]=Qc+-1;if((Qc|0)!=1)break;m=k[jc>>2]|0;if(m|0){l=k[m+4>>2]|0;do if(!l){l=k[hc>>2]|0;if(l|0)break;l=B1()|0;m=k[jc>>2]|0}while(0);jh[k[(k[l>>2]|0)+24>>2]&1023](l,m)}k[jc>>2]=0}while(0);k[jc>>2]=0;k[$b>>2]=0;k[$b+4>>2]=0;k[$b+8>>2]=0;k[$b+12>>2]=0;if((k[Vb>>2]|0)>0){m=k[ub>>2]|0;l=0;do{k[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(k[Vb>>2]|0))}l=k[oc>>2]|0;if(!((l|0)==(vb|0)|(l|0)==0))ggb(k[l+-4>>2]|0);E=E+1|0}while((E|0)<(Sc|0))}j=k[Yc>>2]|0;do if(j|0){f=j+12|0;Hd=k[f>>2]|0;k[f>>2]=Hd+-1;if((Hd|0)!=1)break;l=k[Yc>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[Wc>>2]|0;if(j|0)break;j=B1()|0;l=k[Yc>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[Yc>>2]=0}while(0);k[Yc>>2]=0;k[Xc>>2]=0;k[Xc+4>>2]=0;k[Xc+8>>2]=0;k[Xc+12>>2]=0;if((k[_c>>2]|0)>0){l=k[Zc>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[_c>>2]|0))}j=k[$c>>2]|0;if(!((j|0)==(ad|0)|(j|0)==0))ggb(k[j+-4>>2]|0);m=Id+36|0;j=k[m>>2]|0;do if(j|0){f=j+12|0;Hd=k[f>>2]|0;k[f>>2]=Hd+-1;if((Hd|0)!=1)break;l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[Id+32>>2]|0;if(j|0)break;j=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}while(0);k[m>>2]=0;Id=Id+16|0;k[Id>>2]=0;k[Id+4>>2]=0;k[Id+8>>2]=0;k[Id+12>>2]=0;if((k[jd>>2]|0)>0){l=k[hd>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[jd>>2]|0))}j=k[id>>2]|0;if(!((j|0)==(kd|0)|(j|0)==0))ggb(k[j+-4>>2]|0);m=Jd+36|0;j=k[m>>2]|0;do if(j|0){Hd=j+12|0;Id=k[Hd>>2]|0;k[Hd>>2]=Id+-1;if((Id|0)!=1)break;l=k[m>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[Jd+32>>2]|0;if(j|0)break;j=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[m>>2]=0}while(0);k[m>>2]=0;Jd=Jd+16|0;k[Jd>>2]=0;k[Jd+4>>2]=0;k[Jd+8>>2]=0;k[Jd+12>>2]=0;if((k[qd>>2]|0)>0){l=k[nd>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[qd>>2]|0))}j=k[od>>2]|0;if(!((j|0)==(rd|0)|(j|0)==0))ggb(k[j+-4>>2]|0);j=k[Md>>2]|0;do if(j|0){Id=j+12|0;Jd=k[Id>>2]|0;k[Id>>2]=Jd+-1;if((Jd|0)!=1)break;l=k[Md>>2]|0;if(l|0){j=k[l+4>>2]|0;do if(!j){j=k[Kd>>2]|0;if(j|0)break;j=B1()|0;l=k[Md>>2]|0}while(0);jh[k[(k[j>>2]|0)+24>>2]&1023](j,l)}k[Md>>2]=0}while(0);k[Md>>2]=0;k[Ld>>2]=0;k[Ld+4>>2]=0;k[Ld+8>>2]=0;k[Ld+12>>2]=0;if((k[Od>>2]|0)>0){l=k[Nd>>2]|0;j=0;do{k[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(k[Od>>2]|0))}j=k[Pd>>2]|0;if(!((j|0)==(Qd|0)|(j|0)==0))ggb(k[j+-4>>2]|0);j=k[Rd>>2]|0;if(!j){r=Td;return}if((k[Sd>>2]|0)!=(j|0))k[Sd>>2]=j;ggb(j);r=Td;return}function Xua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,l=0.0,m=0,n=0,q=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;Da=r;r=r+2192|0;xa=Da+1360|0;wa=Da+2128|0;ta=Da+1328|0;Ba=Da+1272|0;Aa=Da+1216|0;za=Da+2072|0;ya=Da+2016|0;va=Da+1912|0;Ca=Da+1840|0;ua=Da+992|0;sa=Da+1760|0;D=Da+768|0;ea=Da+1704|0;N=Da+544|0;O=Da+512|0;R=Da+480|0;da=Da+256|0;S=Da+32|0;ba=Da+1648|0;X=Da+1640|0;Y=Da+1632|0;Z=Da+1624|0;_=Da+1616|0;$=Da;T=Da+1608|0;U=Da+1600|0;V=Da+1592|0;W=Da+1584|0;m=Da+2008|0;n=Da+2e3|0;q=Da+1992|0;s=Da+1984|0;t=Da+1976|0;w=Da+1968|0;x=Da+1904|0;y=Da+1896|0;C=Da+1832|0;E=Da+1824|0;F=Da+1816|0;if(G2(e)|0){f=S1(a,-1)|0;N=(f>>>3&511)+1|0;if(d>>>0>=6){g=xa+4|0;h=ZT(60)|0;k[h>>2]=1;L=h+4|0;k[xa>>2]=L;k[g>>2]=55;i[h+59>>0]=0;z=353641;M=L+55|0;do{i[L>>0]=i[z>>0]|0;L=L+1|0;z=z+1|0}while((L|0)<(M|0));Y8(-215,xa,353796,353389,1061);k[g>>2]=0;k[xa>>2]=0;sa=k[h>>2]|0;k[h>>2]=sa+-1;if((sa|0)==1)ggb(k[h+-4>>2]|0)}switch(f&7){case 0:case 5:{if(!((f|0)==(S1(b,-1)|0)?(a2(a)|0)<3:0))ca=200;break}default:ca=200}if((ca|0)==200){f=xa+4|0;g=ZT(88)|0;k[g>>2]=1;L=g+4|0;k[xa>>2]=L;k[f>>2]=80;i[g+84>>0]=0;z=353715;M=L+80|0;do{i[L>>0]=i[z>>0]|0;L=L+1|0;z=z+1|0}while((L|0)<(M|0));Y8(-215,xa,353796,353389,1062);k[f>>2]=0;k[xa>>2]=0;sa=k[g>>2]|0;k[g>>2]=sa+-1;if((sa|0)==1)ggb(k[g+-4>>2]|0)}R1(m,a,-1);sa=k[m+4>>2]|0;R1(n,b,-1);if((sa|0)>=(k[n+4>>2]|0)?(R1(q,a,-1),sa=k[q>>2]|0,R1(s,b,-1),(sa|0)>=(k[s>>2]|0)):0)w=0;else ca=205;do if((ca|0)==205){R1(t,a,-1);sa=k[t+4>>2]|0;R1(w,b,-1);if((sa|0)<=(k[w+4>>2]|0)?(R1(x,a,-1),sa=k[x>>2]|0,R1(y,b,-1),(sa|0)<=(k[y>>2]|0)):0){w=1;break}f=xa+4|0;g=ZT(92)|0;k[g>>2]=1;L=g+4|0;k[xa>>2]=L;k[f>>2]=86;i[g+90>>0]=0;z=353810;M=L+86|0;do{i[L>>0]=i[z>>0]|0;L=L+1|0;z=z+1|0}while((L|0)<(M|0));Y8(-215,xa,353796,353389,1067);k[f>>2]=0;k[xa>>2]=0;sa=k[g>>2]|0;k[g>>2]=sa+-1;if((sa|0)==1)ggb(k[g+-4>>2]|0);w=1}while(0);do if((k[a>>2]&2031616|0)==65536){n=k[a+4>>2]|0;k[va>>2]=k[n>>2];t=va+4|0;g=n+4|0;k[t>>2]=k[g>>2];sa=va+8|0;k[sa>>2]=k[n+8>>2];k[va+12>>2]=k[n+12>>2];k[va+16>>2]=k[n+16>>2];k[va+20>>2]=k[n+20>>2];k[va+24>>2]=k[n+24>>2];k[va+28>>2]=k[n+28>>2];k[va+32>>2]=k[n+32>>2];f=k[n+36>>2]|0;k[va+36>>2]=f;h=va+40|0;k[h>>2]=sa;sa=va+48|0;q=va+44|0;k[q>>2]=sa;k[va+52>>2]=0;k[sa>>2]=0;if(f|0){sa=f+12|0;k[sa>>2]=(k[sa>>2]|0)+1}if((k[g>>2]|0)<3){ea=k[n+44>>2]|0;sa=k[q>>2]|0;k[sa>>2]=k[ea>>2];k[sa+4>>2]=k[ea+4>>2];break}k[t>>2]=0;x1(va,k[g>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[n+40>>2]|0;m=k[h>>2]|0;h=k[n+44>>2]|0;g=k[q>>2]|0;f=0;do{k[m+(f<<2)>>2]=k[s+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[t>>2]|0))}}else Q1(va,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){m=k[b+4>>2]|0;k[Ca>>2]=k[m>>2];t=Ca+4|0;f=m+4|0;k[t>>2]=k[f>>2];sa=Ca+8|0;k[sa>>2]=k[m+8>>2];k[Ca+12>>2]=k[m+12>>2];k[Ca+16>>2]=k[m+16>>2];k[Ca+20>>2]=k[m+20>>2];k[Ca+24>>2]=k[m+24>>2];k[Ca+28>>2]=k[m+28>>2];k[Ca+32>>2]=k[m+32>>2];g=k[m+36>>2]|0;k[Ca+36>>2]=g;h=Ca+40|0;k[h>>2]=sa;sa=Ca+48|0;q=Ca+44|0;k[q>>2]=sa;k[Ca+52>>2]=0;k[sa>>2]=0;if(g|0){sa=g+12|0;k[sa>>2]=(k[sa>>2]|0)+1}if((k[f>>2]|0)<3){ea=k[m+44>>2]|0;sa=k[q>>2]|0;k[sa>>2]=k[ea>>2];k[sa+4>>2]=k[ea+4>>2];break}k[t>>2]=0;x1(Ca,k[f>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[m+40>>2]|0;n=k[h>>2]|0;h=k[m+44>>2]|0;g=k[q>>2]|0;f=0;do{k[n+(f<<2)>>2]=k[s+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[t>>2]|0))}}else Q1(Ca,b,-1);while(0);if(w){k[xa>>2]=k[va>>2];y=xa+4|0;h=va+4|0;g=k[h>>2]|0;k[y>>2]=g;e=xa+8|0;a=va+8|0;k[e>>2]=k[a>>2];f=va+12|0;k[xa+12>>2]=k[f>>2];t=xa+16|0;k[t>>2]=k[va+16>>2];k[xa+20>>2]=k[va+20>>2];k[xa+24>>2]=k[va+24>>2];k[xa+28>>2]=k[va+28>>2];s=xa+32|0;k[s>>2]=k[va+32>>2];w=xa+36|0;m=k[va+36>>2]|0;k[w>>2]=m;x=xa+40|0;k[x>>2]=e;e=xa+48|0;z=xa+44|0;k[z>>2]=e;k[xa+52>>2]=0;k[e>>2]=0;if(m){g=m+12|0;k[g>>2]=(k[g>>2]|0)+1;g=k[h>>2]|0}if((g|0)>=3){k[y>>2]=0;x1(xa,g,0,0,0);if((k[y>>2]|0)>0){h=k[va+40>>2]|0;m=k[x>>2]|0;n=k[va+44>>2]|0;q=k[z>>2]|0;g=0;do{k[m+(g<<2)>>2]=k[h+(g<<2)>>2];k[q+(g<<2)>>2]=k[n+(g<<2)>>2];g=g+1|0}while((g|0)<(k[y>>2]|0))}}else{ea=k[va+44>>2]|0;sa=k[z>>2]|0;k[sa>>2]=k[ea>>2];k[sa+4>>2]=k[ea+4>>2]}KG(va,Ca)|0;KG(Ca,xa)|0;g=k[w>>2]|0;if(g|0?(ea=g+12|0,sa=k[ea>>2]|0,k[ea>>2]=sa+-1,(sa|0)==1):0){h=k[w>>2]|0;if(h|0){g=k[h+4>>2]|0;if(!g){g=k[s>>2]|0;if(!g){g=B1()|0;h=k[w>>2]|0}}jh[k[(k[g>>2]|0)+24>>2]&1023](g,h)}k[w>>2]=0}k[w>>2]=0;k[t>>2]=0;k[t+4>>2]=0;k[t+8>>2]=0;k[t+12>>2]=0;if((k[y>>2]|0)>0){h=k[x>>2]|0;g=0;do{k[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(k[y>>2]|0))}g=k[z>>2]|0;if(!((g|0)==(e|0)|(g|0)==0))ggb(k[g+-4>>2]|0);g=a}else{g=va+8|0;f=va+12|0}w=Ca+12|0;x=Ca+8|0;sa=(k[g>>2]|0)+1-(k[x>>2]|0)|0;k[C>>2]=(k[f>>2]|0)+1-(k[w>>2]|0);k[C+4>>2]=sa;x2(c,C,5,0);do if((k[c>>2]&2031616|0)==65536){h=k[c+4>>2]|0;k[ua>>2]=k[h>>2];s=ua+4|0;f=h+4|0;k[s>>2]=k[f>>2];sa=ua+8|0;k[sa>>2]=k[h+8>>2];k[ua+12>>2]=k[h+12>>2];k[ua+16>>2]=k[h+16>>2];k[ua+20>>2]=k[h+20>>2];k[ua+24>>2]=k[h+24>>2];k[ua+28>>2]=k[h+28>>2];k[ua+32>>2]=k[h+32>>2];g=k[h+36>>2]|0;k[ua+36>>2]=g;t=ua+40|0;k[t>>2]=sa;sa=ua+48|0;m=ua+44|0;k[m>>2]=sa;k[ua+52>>2]=0;k[sa>>2]=0;if(g|0){sa=g+12|0;k[sa>>2]=(k[sa>>2]|0)+1}if((k[f>>2]|0)<3){sa=k[h+44>>2]|0;f=k[m>>2]|0;k[f>>2]=k[sa>>2];k[f+4>>2]=k[sa+4>>2];f=ua;break}k[s>>2]=0;x1(ua,k[f>>2]|0,0,0,0);if((k[s>>2]|0)>0){n=k[h+40>>2]|0;q=k[t>>2]|0;h=k[h+44>>2]|0;g=k[m>>2]|0;f=0;do{k[q+(f<<2)>>2]=k[n+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[s>>2]|0));f=ua}else f=ua}else{Q1(ua,c,-1);t=ua+40|0;f=ua}while(0);ea=k[t>>2]|0;sa=k[ea>>2]|0;k[E>>2]=k[ea+4>>2];k[E+4>>2]=sa;sa=k[f>>2]&4095;k[F>>2]=0;k[F+4>>2]=0;Wua(va,Ca,ua,E,sa,F,0.0,0);switch(d|0){case 2:break;case 3:{h=0;ca=262;break}default:{h=(d|1|0)==5?1:2;ca=262}}if((ca|0)==262){g=(d|0)==5;B=1.0/(+(k[x>>2]|0)*+(k[w>>2]|0));k[xa>>2]=1124007936;c=xa+4|0;f=xa+8|0;E=xa+40|0;L=c;M=L+36|0;do{k[L>>2]=0;L=L+4|0}while((L|0)<(M|0));k[E>>2]=f;G=xa+48|0;F=xa+44|0;k[F>>2]=G;k[xa+52>>2]=0;k[G>>2]=0;k[wa>>2]=1124007936;D=wa+4|0;f=wa+8|0;b=wa+40|0;L=D;M=L+36|0;do{k[L>>2]=0;L=L+4|0}while((L|0)<(M|0));k[b>>2]=f;C=wa+48|0;e=wa+44|0;k[e>>2]=C;k[wa+52>>2]=0;k[C>>2]=0;k[ta>>2]=0;k[ta+4>>2]=0;k[ta+8>>2]=0;k[ta+12>>2]=0;k[ta+16>>2]=0;k[ta+20>>2]=0;k[ta+24>>2]=0;k[ta+28>>2]=0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;k[Ba+16>>2]=0;k[Ba+20>>2]=0;k[Ba+24>>2]=0;k[Ba+28>>2]=0;do if((d|0)==4){k[Aa+8>>2]=0;k[Aa+12>>2]=0;k[Aa>>2]=16842752;k[Aa+4>>2]=va;ha=za+4|0;ia=ha+4|0;k[ia>>2]=0;k[ia+4>>2]=0;k[za>>2]=33619968;k[ha>>2]=xa;Iua(Aa,za,49332,49332,6,-1);k[za+8>>2]=0;k[za+12>>2]=0;k[za>>2]=16842752;k[za+4>>2]=Ca;u7(Aa,za,49332);k[ta>>2]=k[Aa>>2];k[ta+4>>2]=k[Aa+4>>2];k[ta+8>>2]=k[Aa+8>>2];k[ta+12>>2]=k[Aa+12>>2];k[ta+16>>2]=k[Aa+16>>2];k[ta+20>>2]=k[Aa+20>>2];k[ta+24>>2]=k[Aa+24>>2];k[ta+28>>2]=k[Aa+28>>2];ha=0;ia=0;ja=0;ka=0;fa=0.0;ga=0.0;H=k[w>>2]|0;I=k[x>>2]|0;J=k[wa+16>>2]|0;K=k[C>>2]|0;ca=269}else{k[Aa+8>>2]=0;k[Aa+12>>2]=0;k[Aa>>2]=16842752;k[Aa+4>>2]=va;sa=za+4|0;ea=sa+4|0;k[ea>>2]=0;k[ea+4>>2]=0;k[za>>2]=33619968;k[sa>>2]=xa;sa=ya+4|0;ea=sa+4|0;k[ea>>2]=0;k[ea+4>>2]=0;k[ya>>2]=33619968;k[sa>>2]=wa;Iua(Aa,za,ya,49332,6,-1);k[Aa+8>>2]=0;k[Aa+12>>2]=0;k[Aa>>2]=16842752;k[Aa+4>>2]=Ca;k[za>>2]=-1040056314;k[za+4>>2]=ta;k[za+8>>2]=1;k[za+12>>2]=4;k[ya>>2]=-1040056314;k[ya+4>>2]=Ba;k[ya+8>>2]=1;k[ya+12>>2]=4;v7(Aa,za,ya,49332);u=+p[Ba>>3];v=+p[Ba+8>>3];A=+p[Ba+16>>3];j=+p[Ba+24>>3];j=u*u+v*v+A*A+j*j;if(g&j<2.220446049250313e-16){p[Aa>>3]=1.0;p[Aa+8>>3]=1.0;p[Aa+16>>3]=1.0;p[Aa+24>>3]=1.0;oY(ua,Aa);break}A=+p[ta>>3];fa=+p[ta+8>>3];ga=+p[ta+16>>3];l=+p[ta+24>>3];l=j+A*A+fa*fa+ga*ga+l*l;if((h|0)!=1){k[ta>>2]=0;k[ta+4>>2]=0;k[ta+8>>2]=0;k[ta+12>>2]=0;k[ta+16>>2]=0;k[ta+20>>2]=0;k[ta+24>>2]=0;k[ta+28>>2]=0;j=l}ga=+Q(+j)/+Q(+B);J=k[wa+16>>2]|0;H=k[w>>2]|0;ka=aa(H,N)|0;I=k[x>>2]|0;K=k[C>>2]|0;ca=J+(aa(K,I)|0)|0;ha=J;ia=J+(ka<<3)|0;ja=ca;ka=ca+(ka<<3)|0;fa=l/B;ca=269}while(0);if((ca|0)==269?(ma=k[xa+16>>2]|0,pa=aa(H,N)|0,na=ma+(pa<<3)|0,la=k[G>>2]|0,oa=ma+(aa(la,I)|0)|0,pa=oa+(pa<<3)|0,la=(ma|0)==0?0:la>>>3,qa=(J|0)==0?0:K>>>3,ra=k[ua+8>>2]|0,(ra|0)>0):0){x=k[ua+16>>2]|0;y=k[k[ua+44>>2]>>2]|0;z=k[ua+12>>2]|0;a=(z|0)>0;A=+((d|0)==1&1);w=h&255;q=0;do{s=x+(aa(q,y)|0)|0;f=aa(q,qa)|0;a:do if(a)switch(w&3){case 1:{h=aa(q,la)|0;m=0;while(1){n=s+(m<<2)|0;l=0.0;j=+o[n>>2];g=0;do{Ba=g+h|0;v=+p[ma+(Ba<<3)>>3]-+p[na+(Ba<<3)>>3]-+p[oa+(Ba<<3)>>3]+ +p[pa+(Ba<<3)>>3];l=l+v*v;j=j-v*+p[ta+(g<<3)>>3];g=g+1|0}while((g|0)!=(N|0));u=B*l;switch(d|0){case 1:case 3:case 5:{l=0.0;g=0;do{Ba=g+f|0;l=l+(+p[ha+(Ba<<3)>>3]-+p[ia+(Ba<<3)>>3]-+p[ja+(Ba<<3)>>3]+ +p[ka+(Ba<<3)>>3]);g=g+1|0}while((g|0)!=(N|0));break}default:l=0.0}b:do switch(d|0){case 1:case 3:case 5:{l=l-u;l=ga*+Q(+(l<0.0?0.0:l));u=+P(+j);if(u<l){j=j/l;break b}if(u<l*1.125)j=j>0.0?1.0:-1.0;else j=A;break}default:{}}while(0);o[n>>2]=j;m=m+1|0;if((m|0)==(z|0))break a;else{f=f+N|0;h=h+N|0}}}case 2:{h=0;while(1){m=s+(h<<2)|0;j=+o[m>>2];l=0.0;g=0;do{Ba=g+f|0;l=l+(+p[ha+(Ba<<3)>>3]-+p[ia+(Ba<<3)>>3]-+p[ja+(Ba<<3)>>3]+ +p[ka+(Ba<<3)>>3]);g=g+1|0}while((g|0)!=(N|0));j=fa+(l-j*2.0);j=j<0.0?0.0:j;c:do switch(d|0){case 1:case 3:case 5:{l=ga*+Q(+(l<0.0?0.0:l));u=+P(+j);if(u<l){j=j/l;break c}if(u<l*1.125)j=j>0.0?1.0:-1.0;else j=A;break}default:{}}while(0);o[m>>2]=j;h=h+1|0;if((h|0)==(z|0))break a;else f=f+N|0}}default:{h=0;while(1){m=s+(h<<2)|0;v=+o[m>>2];j=v;switch(d|0){case 1:case 3:case 5:{l=0.0;g=0;do{Ba=g+f|0;l=l+(+p[ha+(Ba<<3)>>3]-+p[ia+(Ba<<3)>>3]-+p[ja+(Ba<<3)>>3]+ +p[ka+(Ba<<3)>>3]);g=g+1|0}while((g|0)!=(N|0));break}default:l=0.0}d:do switch(d|0){case 1:case 3:case 5:{l=ga*+Q(+(l<0.0?0.0:l));u=+P(+v);if(u<l){j=j/l;break d}if(u<l*1.125)j=v>0.0?1.0:-1.0;else j=A;break}default:{}}while(0);o[m>>2]=j;h=h+1|0;if((h|0)==(z|0))break a;else f=f+N|0}}}while(0);q=q+1|0}while((q|0)!=(ra|0))}h=wa+36|0;f=k[h>>2]|0;if(f|0?(Aa=f+12|0,Ba=k[Aa>>2]|0,k[Aa>>2]=Ba+-1,(Ba|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[wa+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Ba=wa+16|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;if((k[D>>2]|0)>0){g=k[b>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[D>>2]|0))}f=k[e>>2]|0;if(!((f|0)==(C|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=xa+36|0;f=k[h>>2]|0;if(f|0?(Aa=f+12|0,Ba=k[Aa>>2]|0,k[Aa>>2]=Ba+-1,(Ba|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[xa+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Ba=xa+16|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;if((k[c>>2]|0)>0){g=k[E>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[c>>2]|0))}f=k[F>>2]|0;if(!((f|0)==(G|0)|(f|0)==0))ggb(k[f+-4>>2]|0)}h=ua+36|0;f=k[h>>2]|0;if(f|0?(Aa=f+12|0,Ba=k[Aa>>2]|0,k[Aa>>2]=Ba+-1,(Ba|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[ua+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Ba=ua+16|0;h=ua+4|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;if((k[h>>2]|0)>0){g=k[t>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[h>>2]|0))}f=k[ua+44>>2]|0;if(!((f|0)==(ua+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=Ca+36|0;f=k[h>>2]|0;if(f|0?(Aa=f+12|0,Ba=k[Aa>>2]|0,k[Aa>>2]=Ba+-1,(Ba|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[Ca+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Ba=Ca+16|0;g=Ca+4|0;k[Ba>>2]=0;k[Ba+4>>2]=0;k[Ba+8>>2]=0;k[Ba+12>>2]=0;if((k[g>>2]|0)>0){h=k[Ca+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[Ca+44>>2]|0;if(!((f|0)==(Ca+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=va+36|0;f=k[h>>2]|0;if(f|0?(Ba=f+12|0,Ca=k[Ba>>2]|0,k[Ba>>2]=Ca+-1,(Ca|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[va+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Ca=va+16|0;g=va+4|0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[g>>2]|0)>0){h=k[va+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[va+44>>2]|0;if(!((f|0)==(va+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);r=Da;return}m=S1(a,-1)|0;f=m&7;x=m&4088;if(d>>>0>=6){g=xa+4|0;h=ZT(60)|0;k[h>>2]=1;L=h+4|0;k[xa>>2]=L;k[g>>2]=55;i[h+59>>0]=0;z=353641;M=L+55|0;do{i[L>>0]=i[z>>0]|0;L=L+1|0;z=z+1|0}while((L|0)<(M|0));Y8(-215,xa,353697,353389,821);k[g>>2]=0;k[xa>>2]=0;ra=k[h>>2]|0;k[h>>2]=ra+-1;if((ra|0)==1)ggb(k[h+-4>>2]|0)}w=(f|0)==0;switch(m&7){case 0:case 5:{if(!((m|0)==(S1(b,-1)|0)?(a2(a)|0)<3:0))ca=9;break}default:ca=9}if((ca|0)==9){f=xa+4|0;g=ZT(88)|0;k[g>>2]=1;L=g+4|0;k[xa>>2]=L;k[f>>2]=80;i[g+84>>0]=0;z=353715;M=L+80|0;do{i[L>>0]=i[z>>0]|0;L=L+1|0;z=z+1|0}while((L|0)<(M|0));Y8(-215,xa,353697,353389,822);k[f>>2]=0;k[xa>>2]=0;ra=k[g>>2]|0;k[g>>2]=ra+-1;if((ra|0)==1)ggb(k[g+-4>>2]|0)}do if((k[a>>2]&2031616|0)==65536){n=k[a+4>>2]|0;k[Ba>>2]=k[n>>2];t=Ba+4|0;g=n+4|0;k[t>>2]=k[g>>2];ra=Ba+8|0;k[ra>>2]=k[n+8>>2];k[Ba+12>>2]=k[n+12>>2];k[Ba+16>>2]=k[n+16>>2];k[Ba+20>>2]=k[n+20>>2];k[Ba+24>>2]=k[n+24>>2];k[Ba+28>>2]=k[n+28>>2];k[Ba+32>>2]=k[n+32>>2];f=k[n+36>>2]|0;k[Ba+36>>2]=f;h=Ba+40|0;k[h>>2]=ra;ra=Ba+48|0;q=Ba+44|0;k[q>>2]=ra;k[Ba+52>>2]=0;k[ra>>2]=0;if(f|0){ra=f+12|0;k[ra>>2]=(k[ra>>2]|0)+1}if((k[g>>2]|0)<3){qa=k[n+44>>2]|0;ra=k[q>>2]|0;k[ra>>2]=k[qa>>2];k[ra+4>>2]=k[qa+4>>2];break}k[t>>2]=0;x1(Ba,k[g>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[n+40>>2]|0;m=k[h>>2]|0;h=k[n+44>>2]|0;g=k[q>>2]|0;f=0;do{k[m+(f<<2)>>2]=k[s+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[t>>2]|0))}}else Q1(Ba,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){m=k[b+4>>2]|0;k[Aa>>2]=k[m>>2];t=Aa+4|0;f=m+4|0;k[t>>2]=k[f>>2];ra=Aa+8|0;k[ra>>2]=k[m+8>>2];k[Aa+12>>2]=k[m+12>>2];k[Aa+16>>2]=k[m+16>>2];k[Aa+20>>2]=k[m+20>>2];k[Aa+24>>2]=k[m+24>>2];k[Aa+28>>2]=k[m+28>>2];k[Aa+32>>2]=k[m+32>>2];g=k[m+36>>2]|0;k[Aa+36>>2]=g;h=Aa+40|0;k[h>>2]=ra;ra=Aa+48|0;q=Aa+44|0;k[q>>2]=ra;k[Aa+52>>2]=0;k[ra>>2]=0;if(g|0){ra=g+12|0;k[ra>>2]=(k[ra>>2]|0)+1}if((k[f>>2]|0)<3){qa=k[m+44>>2]|0;ra=k[q>>2]|0;k[ra>>2]=k[qa>>2];k[ra+4>>2]=k[qa+4>>2];break}k[t>>2]=0;x1(Aa,k[f>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[m+40>>2]|0;n=k[h>>2]|0;h=k[m+44>>2]|0;g=k[q>>2]|0;f=0;do{k[n+(f<<2)>>2]=k[s+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[t>>2]|0))}}else Q1(Aa,b,-1);while(0);do if((k[e>>2]&2031616|0)==65536){m=k[e+4>>2]|0;k[za>>2]=k[m>>2];t=za+4|0;f=m+4|0;k[t>>2]=k[f>>2];ra=za+8|0;k[ra>>2]=k[m+8>>2];k[za+12>>2]=k[m+12>>2];k[za+16>>2]=k[m+16>>2];k[za+20>>2]=k[m+20>>2];k[za+24>>2]=k[m+24>>2];k[za+28>>2]=k[m+28>>2];k[za+32>>2]=k[m+32>>2];g=k[m+36>>2]|0;k[za+36>>2]=g;h=za+40|0;k[h>>2]=ra;ra=za+48|0;q=za+44|0;k[q>>2]=ra;k[za+52>>2]=0;k[ra>>2]=0;if(g|0){ra=g+12|0;k[ra>>2]=(k[ra>>2]|0)+1}if((k[f>>2]|0)<3){qa=k[m+44>>2]|0;ra=k[q>>2]|0;k[ra>>2]=k[qa>>2];k[ra+4>>2]=k[qa+4>>2];break}k[t>>2]=0;x1(za,k[f>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[m+40>>2]|0;n=k[h>>2]|0;h=k[m+44>>2]|0;g=k[q>>2]|0;f=0;do{k[n+(f<<2)>>2]=k[s+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[t>>2]|0))}}else Q1(za,e,-1);while(0);f=k[Aa>>2]|0;g=k[Ba>>2]&4088;if(w){ra=xa+4|0;qa=ra+4|0;k[qa>>2]=0;k[qa+4>>2]=0;k[xa>>2]=33619968;k[ra>>2]=Ba;SW(Ba,xa,x|5,.00392156862745098,0.0)}if(!(f&7)){ra=xa+4|0;qa=ra+4|0;k[qa>>2]=0;k[qa+4>>2]=0;k[xa>>2]=33619968;k[ra>>2]=Aa;SW(Aa,xa,f&4088|5,.00392156862745098,0.0)}if(w){k[xa+8>>2]=0;k[xa+12>>2]=0;k[xa>>2]=16842752;k[xa+4>>2]=za;k[ta>>2]=0;k[ta+4>>2]=0;k[ta+8>>2]=0;k[ta+12>>2]=0;k[ta+16>>2]=0;k[ta+20>>2]=0;k[ta+24>>2]=0;k[ta+28>>2]=0;k[wa>>2]=-1056833530;k[wa+4>>2]=ta;k[wa+8>>2]=1;k[wa+12>>2]=4;ra=ya+4|0;qa=ra+4|0;k[qa>>2]=0;k[qa+4>>2]=0;k[ya>>2]=33619968;k[ra>>2]=za;oV(xa,wa,ya,5);ra=xa+4|0;qa=ra+4|0;k[qa>>2]=0;k[qa+4>>2]=0;k[xa>>2]=33619968;k[ra>>2]=za;SW(za,xa,g|5,.00392156862745098,0.0)}w=Aa+12|0;z=(k[Ba+12>>2]|0)-(k[w>>2]|0)+1|0;x=Aa+8|0;a=(k[Ba+8>>2]|0)-(k[x>>2]|0)+1|0;k[va>>2]=z;k[va+4>>2]=a;x2(c,va,5,0);do if((k[c>>2]&2031616|0)==65536){m=k[c+4>>2]|0;k[ya>>2]=k[m>>2];t=ya+4|0;f=m+4|0;k[t>>2]=k[f>>2];va=ya+8|0;k[va>>2]=k[m+8>>2];k[ya+12>>2]=k[m+12>>2];k[ya+16>>2]=k[m+16>>2];k[ya+20>>2]=k[m+20>>2];k[ya+24>>2]=k[m+24>>2];k[ya+28>>2]=k[m+28>>2];k[ya+32>>2]=k[m+32>>2];g=k[m+36>>2]|0;k[ya+36>>2]=g;h=ya+40|0;k[h>>2]=va;va=ya+48|0;q=ya+44|0;k[q>>2]=va;k[ya+52>>2]=0;k[va>>2]=0;if(g|0){va=g+12|0;k[va>>2]=(k[va>>2]|0)+1}if((k[f>>2]|0)<3){ra=k[m+44>>2]|0;va=k[q>>2]|0;k[va>>2]=k[ra>>2];k[va+4>>2]=k[ra+4>>2];break}k[t>>2]=0;x1(ya,k[f>>2]|0,0,0,0);if((k[t>>2]|0)>0){s=k[m+40>>2]|0;n=k[h>>2]|0;h=k[m+44>>2]|0;g=k[q>>2]|0;f=0;do{k[n+(f<<2)>>2]=k[s+(f<<2)>>2];k[g+(f<<2)>>2]=k[h+(f<<2)>>2];f=f+1|0}while((f|0)<(k[t>>2]|0))}}else Q1(ya,c,-1);while(0);k[xa+8>>2]=0;k[xa+12>>2]=0;k[xa>>2]=16842752;k[xa+4>>2]=Ba;i1(ua,Ba,xa,1.0);k[Ca>>2]=1124007936;J=Ca+4|0;f=Ca+8|0;H=Ca+40|0;L=J;M=L+36|0;do{k[L>>2]=0;L=L+4|0}while((L|0)<(M|0));k[H>>2]=f;K=Ca+48|0;I=Ca+44|0;k[I>>2]=K;k[Ca+52>>2]=0;k[K>>2]=0;c=k[ua>>2]|0;dh[k[(k[c>>2]|0)+12>>2]&255](c,ua,Ca,-1);XN(ua);k[xa+8>>2]=0;k[xa+12>>2]=0;k[xa>>2]=16842752;k[xa+4>>2]=za;i1(D,za,xa,1.0);k[sa>>2]=1124007936;c=sa+4|0;f=sa+8|0;E=sa+40|0;L=c;M=L+36|0;do{k[L>>2]=0;L=L+4|0}while((L|0)<(M|0));k[E>>2]=f;G=sa+48|0;F=sa+44|0;k[F>>2]=G;k[sa+52>>2]=0;k[G>>2]=0;C=k[D>>2]|0;dh[k[(k[C>>2]|0)+12>>2]&255](C,D,sa,-1);XN(D);k[xa+8>>2]=0;k[xa+12>>2]=0;k[xa>>2]=16842752;k[xa+4>>2]=za;i1(N,Aa,xa,1.0);k[ea>>2]=1124007936;C=ea+4|0;f=ea+8|0;e=ea+40|0;L=C;M=L+36|0;do{k[L>>2]=0;L=L+4|0}while((L|0)<(M|0));k[e>>2]=f;D=ea+48|0;b=ea+44|0;k[b>>2]=D;k[ea+52>>2]=0;k[D>>2]=0;va=k[N>>2]|0;dh[k[(k[va>>2]|0)+12>>2]&255](va,N,ea,-1);XN(N);k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;k[O+16>>2]=0;k[O+20>>2]=0;k[O+24>>2]=0;k[O+28>>2]=0;k[R>>2]=0;k[R+4>>2]=0;k[R+8>>2]=0;k[R+12>>2]=0;k[R+16>>2]=0;k[R+20>>2]=0;k[R+24>>2]=0;k[R+28>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;k[xa>>2]=16842752;k[xa+4>>2]=ea;k[wa>>2]=-1040056314;k[wa+4>>2]=O;k[wa+8>>2]=1;k[wa+12>>2]=4;k[ta>>2]=-1040056314;k[ta+4>>2]=R;k[ta+8>>2]=1;k[ta+12>>2]=4;v7(xa,wa,ta,49332);l=+p[R>>3];u=+p[R+8>>3];v=+p[R+16>>3];A=+p[R+24>>3];B=+p[O>>3];fa=+p[O+8>>3];ga=+p[O+16>>3];j=+p[O+24>>3];j=(l*l+u*u+v*v+A*A+(B*B+fa*fa+ga*ga+j*j))*(+(k[x>>2]|0)*+(k[w>>2]|0));e:do switch(d|0){case 0:{k[xa+8>>2]=0;k[xa+12>>2]=0;k[xa>>2]=16842752;k[xa+4>>2]=sa;i1(S,Aa,xa,1.0);k[da>>2]=1124007936;x=da+4|0;f=da+8|0;t=da+40|0;L=x;M=L+36|0;do{k[L>>2]=0;L=L+4|0}while((L|0)<(M|0));k[t>>2]=f;y=da+48|0;w=da+44|0;k[w>>2]=y;k[da+52>>2]=0;k[y>>2]=0;s=k[S>>2]|0;dh[k[(k[s>>2]|0)+12>>2]&255](s,S,da,-1);XN(S);k[ba>>2]=1124007936;s=ba+4|0;f=ba+8|0;n=ba+40|0;L=s;M=L+36|0;do{k[L>>2]=0;L=L+4|0}while((L|0)<(M|0));k[n>>2]=f;q=ba+48|0;m=ba+44|0;k[m>>2]=q;k[ba+52>>2]=0;k[q>>2]=0;k[xa>>2]=a;k[xa+4>>2]=z;G1(ba,2,xa,5);h=k[n>>2]|0;f=k[h>>2]|0;k[X>>2]=k[h+4>>2];k[X+4>>2]=f;f=k[ba>>2]&4095;k[Y>>2]=0;k[Y+4>>2]=0;Wua(Ba,da,ba,X,f,Y,0.0,0);f=k[ya+40>>2]|0;h=k[f>>2]|0;k[Z>>2]=k[f+4>>2];k[Z+4>>2]=h;h=k[ya>>2]&4095;k[_>>2]=0;k[_+4>>2]=0;Wua(Ca,za,ya,Z,h,_,0.0,0);b1(xa,ba,2.0);h=k[xa>>2]|0;Ph[k[(k[h>>2]|0)+28>>2]&511](h,xa,ya);XN(xa);p[$>>3]=j;h=$+8|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[h+16>>2]=0;k[h+20>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;k[xa>>2]=16842752;k[xa+4>>2]=ya;k[wa>>2]=-1056833530;k[wa+4>>2]=$;k[wa+8>>2]=1;k[wa+12>>2]=4;h=ta+4|0;f=h+4|0;k[f>>2]=0;k[f+4>>2]=0;k[ta>>2]=33619968;k[h>>2]=ya;sU(xa,wa,ta,49332,-1,39936,0,0);h=ba+36|0;f=k[h>>2]|0;if(f|0?(wa=f+12|0,xa=k[wa>>2]|0,k[wa>>2]=xa+-1,(xa|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[ba+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;xa=ba+16|0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[s>>2]|0)>0){g=k[n>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[s>>2]|0))}f=k[m>>2]|0;if(!((f|0)==(q|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=da+36|0;f=k[h>>2]|0;if(f|0?(wa=f+12|0,xa=k[wa>>2]|0,k[wa>>2]=xa+-1,(xa|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[da+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;xa=da+16|0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[x>>2]|0)>0){g=k[t>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[x>>2]|0))}f=k[w>>2]|0;if(!((f|0)==(y|0)|(f|0)==0))ggb(k[f+-4>>2]|0);break}case 3:{if(j<2.220446049250313e-16){p[xa>>3]=1.0;p[xa+8>>3]=1.0;p[xa+16>>3]=1.0;p[xa+24>>3]=1.0;oY(ya,xa);break e}k[wa>>2]=1124007936;s=wa+4|0;f=wa+8|0;n=wa+40|0;L=s;M=L+36|0;do{k[L>>2]=0;L=L+4|0}while((L|0)<(M|0));k[n>>2]=f;q=wa+48|0;m=wa+44|0;k[m>>2]=q;k[wa+52>>2]=0;k[q>>2]=0;k[xa>>2]=a;k[xa+4>>2]=z;G1(wa,2,xa,5);h=k[n>>2]|0;f=k[h>>2]|0;k[T>>2]=k[h+4>>2];k[T+4>>2]=f;f=k[wa>>2]&4095;k[U>>2]=0;k[U+4>>2]=0;Wua(Ca,sa,wa,T,f,U,0.0,0);f=k[ya+40>>2]|0;h=k[f>>2]|0;k[V>>2]=k[f+4>>2];k[V+4>>2]=h;h=k[ya>>2]&4095;k[W>>2]=0;k[W+4>>2]=0;Wua(Ba,ea,ya,V,h,W,0.0,0);k[xa+8>>2]=0;k[xa+12>>2]=0;k[xa>>2]=16842752;k[xa+4>>2]=wa;h=ta+4|0;f=h+4|0;k[f>>2]=0;k[f+4>>2]=0;k[ta>>2]=33619968;k[h>>2]=wa;ZZ(xa,.5,ta);g1(da,wa);k[ta+8>>2]=0;k[ta+12>>2]=0;k[ta>>2]=-1056571392;k[ta+4>>2]=da;i1(xa,ya,ta,1.0);h=k[xa>>2]|0;dh[k[(k[h>>2]|0)+12>>2]&255](h,xa,ya,-1);XN(xa);XN(da);ga=+Q(+j);h=xa+4|0;f=h+4|0;k[f>>2]=0;k[f+4>>2]=0;k[xa>>2]=33619968;k[h>>2]=ya;SW(ya,xa,-1,1.0/ga,0.0);h=wa+36|0;f=k[h>>2]|0;if(f|0?(va=f+12|0,xa=k[va>>2]|0,k[va>>2]=xa+-1,(xa|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[wa+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;xa=wa+16|0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[s>>2]|0)>0){g=k[n>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[s>>2]|0))}f=k[m>>2]|0;if(!((f|0)==(q|0)|(f|0)==0))ggb(k[f+-4>>2]|0);break}default:{k[xa>>2]=0;wa=xa+4|0;k[wa>>2]=0;f=ZT(8)|0;k[f>>2]=1;va=f+4|0;k[xa>>2]=va;k[wa>>2]=0;i[va>>0]=0;Y8(-213,xa,353697,353389,894);k[wa>>2]=0;k[xa>>2]=0;xa=k[f>>2]|0;k[f>>2]=xa+-1;if((xa|0)==1)ggb(k[f+-4>>2]|0)}}while(0);h=ea+36|0;f=k[h>>2]|0;if(f|0?(wa=f+12|0,xa=k[wa>>2]|0,k[wa>>2]=xa+-1,(xa|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[ea+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;xa=ea+16|0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[C>>2]|0)>0){g=k[e>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[C>>2]|0))}f=k[b>>2]|0;if(!((f|0)==(D|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=sa+36|0;f=k[h>>2]|0;if(f|0?(wa=f+12|0,xa=k[wa>>2]|0,k[wa>>2]=xa+-1,(xa|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;if(!f){f=k[sa+32>>2]|0;if(!f){f=B1()|0;g=k[h>>2]|0}}jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;xa=sa+16|0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[c>>2]|0)>0){g=k[E>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[c>>2]|0))}f=k[F>>2]|0;if(!((f|0)==(G|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=Ca+36|0;f=k[h>>2]|0;if(f|0?(wa=f+12|0,xa=k[wa>>2]|0,k[wa>>2]=xa+-1,(xa|0)==1):0){g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[Ca+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}k[h>>2]=0;Ca=Ca+16|0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[J>>2]|0)>0){g=k[H>>2]|0;f=0;do{k[g+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[J>>2]|0))}f=k[I>>2]|0;if(!((f|0)==(K|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=ya+36|0;f=k[h>>2]|0;do if(f|0){xa=f+12|0;Ca=k[xa>>2]|0;k[xa>>2]=Ca+-1;if((Ca|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[ya+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;Ca=ya+16|0;g=ya+4|0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[g>>2]|0)>0){h=k[ya+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[ya+44>>2]|0;if(!((f|0)==(ya+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=za+36|0;f=k[h>>2]|0;do if(f|0){ya=f+12|0;Ca=k[ya>>2]|0;k[ya>>2]=Ca+-1;if((Ca|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[za+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;Ca=za+16|0;g=za+4|0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[g>>2]|0)>0){h=k[za+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[za+44>>2]|0;if(!((f|0)==(za+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=Aa+36|0;f=k[h>>2]|0;do if(f|0){za=f+12|0;Ca=k[za>>2]|0;k[za>>2]=Ca+-1;if((Ca|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[Aa+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;Ca=Aa+16|0;g=Aa+4|0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[g>>2]|0)>0){h=k[Aa+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[Aa+44>>2]|0;if(!((f|0)==(Aa+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);h=Ba+36|0;f=k[h>>2]|0;do if(f|0){Aa=f+12|0;Ca=k[Aa>>2]|0;k[Aa>>2]=Ca+-1;if((Ca|0)!=1)break;g=k[h>>2]|0;if(g|0){f=k[g+4>>2]|0;do if(!f){f=k[Ba+32>>2]|0;if(f|0)break;f=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[f>>2]|0)+24>>2]&1023](f,g)}k[h>>2]=0}while(0);k[h>>2]=0;Ca=Ba+16|0;g=Ba+4|0;k[Ca>>2]=0;k[Ca+4>>2]=0;k[Ca+8>>2]=0;k[Ca+12>>2]=0;if((k[g>>2]|0)>0){h=k[Ba+40>>2]|0;f=0;do{k[h+(f<<2)>>2]=0;f=f+1|0}while((f|0)<(k[g>>2]|0))}f=k[Ba+44>>2]|0;if(!((f|0)==(Ba+48|0)|(f|0)==0))ggb(k[f+-4>>2]|0);r=Da;return}function Yua(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var f=0,g=0,h=0.0,j=0,m=0,n=0.0,o=0.0,q=0,s=0,t=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0;R=r;r=r+1360|0;P=R+336|0;Q=R+280|0;B=R+272|0;N=R+144|0;O=R;L=R+216|0;M=R+160|0;do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[Q>>2]=k[j>>2];v=Q+4|0;a=j+4|0;k[v>>2]=k[a>>2];K=Q+8|0;k[K>>2]=k[j+8>>2];k[Q+12>>2]=k[j+12>>2];k[Q+16>>2]=k[j+16>>2];k[Q+20>>2]=k[j+20>>2];k[Q+24>>2]=k[j+24>>2];k[Q+28>>2]=k[j+28>>2];k[Q+32>>2]=k[j+32>>2];f=k[j+36>>2]|0;k[Q+36>>2]=f;g=Q+40|0;k[g>>2]=K;K=Q+48|0;q=Q+44|0;k[q>>2]=K;k[Q+52>>2]=0;k[K>>2]=0;if(f|0){K=f+12|0;k[K>>2]=(k[K>>2]|0)+1}if((k[a>>2]|0)<3){J=k[j+44>>2]|0;K=k[q>>2]|0;k[K>>2]=k[J>>2];k[K+4>>2]=k[J+4>>2];break}k[v>>2]=0;x1(Q,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){s=k[j+40>>2]|0;m=k[g>>2]|0;g=k[j+44>>2]|0;f=k[q>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[s+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(Q,a,-1);while(0);K=e&7;switch(e&-8|0){case 24:{k[P>>2]=0;a=P+4|0;k[a>>2]=0;f=ZT(64)|0;k[f>>2]=1;m=f+4|0;k[P>>2]=m;k[a>>2]=57;i[f+61>>0]=0;g=353897;s=m+57|0;do{i[m>>0]=i[g>>0]|0;m=m+1|0;g=g+1|0}while((m|0)<(s|0));Y8(-215,P,393853,353955,1201);k[a>>2]=0;k[P>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0);break}case 8:{a=k[Q>>2]|0;if(a&4095){k[P>>2]=0;a=P+4|0;k[a>>2]=0;f=ZT(28)|0;k[f>>2]=1;m=f+4|0;k[P>>2]=m;k[a>>2]=21;i[f+25>>0]=0;g=354023;s=m+21|0;do{i[m>>0]=i[g>>0]|0;m=m+1|0;g=g+1|0}while((m|0)<(s|0));Y8(-215,P,393853,353955,1204);k[a>>2]=0;k[P>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0);a=k[Q>>2]|0}s=k[Q+40>>2]|0;m=k[s+4>>2]|0;s=k[s>>2]|0;v=(a&16384|0)!=0;A=aa(s,m)|0;m=v?A:m;s=v?1:s;v=v?A:k[Q+48>>2]|0;zpb(P|0,0,1024)|0;a:do if((s|0)>0){z=k[Q+16>>2]|0;q=m+-4|0;if((m|0)<4){if((m|0)>0)a=0;else{h=0.0;a=0;break}while(1){g=z+(aa(a,v)|0)|0;f=0;do{J=P+((l[g+f>>0]|0)<<2)|0;k[J>>2]=(k[J>>2]|0)+1;f=f+1|0}while((f|0)!=(m|0));a=a+1|0;if((a|0)==(s|0)){h=0.0;a=0;break a}}}g=m&-4;if((g|0)<(m|0))f=0;else{a=0;while(1){g=z+(aa(a,v)|0)|0;f=0;do{J=l[g+(f|1)>>0]|0;I=P+((l[g+f>>0]|0)<<2)|0;k[I>>2]=(k[I>>2]|0)+1;J=P+(J<<2)|0;k[J>>2]=(k[J>>2]|0)+1;J=l[g+(f|3)>>0]|0;I=P+((l[g+(f|2)>>0]|0)<<2)|0;k[I>>2]=(k[I>>2]|0)+1;J=P+(J<<2)|0;k[J>>2]=(k[J>>2]|0)+1;f=f+4|0}while((f|0)<=(q|0));a=a+1|0;if((a|0)==(s|0)){h=0.0;a=0;break a}}}do{j=z+(aa(f,v)|0)|0;a=0;do{J=l[j+(a|1)>>0]|0;I=P+((l[j+a>>0]|0)<<2)|0;k[I>>2]=(k[I>>2]|0)+1;J=P+(J<<2)|0;k[J>>2]=(k[J>>2]|0)+1;J=l[j+(a|3)>>0]|0;I=P+((l[j+(a|2)>>0]|0)<<2)|0;k[I>>2]=(k[I>>2]|0)+1;J=P+(J<<2)|0;k[J>>2]=(k[J>>2]|0)+1;a=a+4|0}while((a|0)<=(q|0));a=g;do{J=P+((l[j+a>>0]|0)<<2)|0;k[J>>2]=(k[J>>2]|0)+1;a=a+1|0}while((a|0)!=(m|0));f=f+1|0}while((f|0)!=(s|0));h=0.0;a=0}else{h=0.0;a=0}while(0);do{h=h+ +(a|0)*+(k[P+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=256);y=1.0/+(A|0);x=y*h;w=0.0;c=0.0;n=0.0;h=0.0;a=0;do{t=y*+(k[P+(a<<2)>>2]|0);h=h*w;w=w+t;o=1.0-w;if(!((o<w?o:w)<1.1920928955078125e-07)?!((w<o?o:w)>.9999998807907104):0){S=+(a|0);h=(h+S*t)/w;t=h-(x-w*h)/o;t=t*(w*o*t);J=t>n;c=J?S:c;n=J?t:n}a=a+1|0}while((a|0)!=256);break}case 16:{a=k[Q>>2]|0;if(a&4095){k[P>>2]=0;a=P+4|0;k[a>>2]=0;f=ZT(28)|0;k[f>>2]=1;m=f+4|0;k[P>>2]=m;k[a>>2]=21;i[f+25>>0]=0;g=354023;s=m+21|0;do{i[m>>0]=i[g>>0]|0;m=m+1|0;g=g+1|0}while((m|0)<(s|0));Y8(-215,P,393853,353955,1209);k[a>>2]=0;k[P>>2]=0;J=k[f>>2]|0;k[f>>2]=J+-1;if((J|0)==1)ggb(k[f+-4>>2]|0);a=k[Q>>2]|0}s=k[Q+40>>2]|0;m=k[s+4>>2]|0;s=k[s>>2]|0;J=(a&16384|0)!=0;v=aa(s,m)|0;s=J?1:s;m=J?v:m;v=J?v:k[Q+48>>2]|0;zpb(P|0,0,1024)|0;b:do if((s|0)>0){z=k[Q+16>>2]|0;q=m+-4|0;if((m|0)<4){if((m|0)>0)a=0;else{a=0;break}while(1){g=z+(aa(a,v)|0)|0;f=0;do{J=P+((l[g+f>>0]|0)<<2)|0;k[J>>2]=(k[J>>2]|0)+1;f=f+1|0}while((f|0)!=(m|0));a=a+1|0;if((a|0)==(s|0)){a=0;break b}}}g=m&-4;if((g|0)<(m|0))f=0;else{a=0;while(1){g=z+(aa(a,v)|0)|0;f=0;do{J=l[g+(f|1)>>0]|0;I=P+((l[g+f>>0]|0)<<2)|0;k[I>>2]=(k[I>>2]|0)+1;J=P+(J<<2)|0;k[J>>2]=(k[J>>2]|0)+1;J=l[g+(f|3)>>0]|0;I=P+((l[g+(f|2)>>0]|0)<<2)|0;k[I>>2]=(k[I>>2]|0)+1;J=P+(J<<2)|0;k[J>>2]=(k[J>>2]|0)+1;f=f+4|0}while((f|0)<=(q|0));a=a+1|0;if((a|0)==(s|0)){a=0;break b}}}do{j=z+(aa(f,v)|0)|0;a=0;do{J=l[j+(a|1)>>0]|0;I=P+((l[j+a>>0]|0)<<2)|0;k[I>>2]=(k[I>>2]|0)+1;J=P+(J<<2)|0;k[J>>2]=(k[J>>2]|0)+1;J=l[j+(a|3)>>0]|0;I=P+((l[j+(a|2)>>0]|0)<<2)|0;k[I>>2]=(k[I>>2]|0)+1;J=P+(J<<2)|0;k[J>>2]=(k[J>>2]|0)+1;a=a+4|0}while((a|0)<=(q|0));a=g;do{J=P+((l[j+a>>0]|0)<<2)|0;k[J>>2]=(k[J>>2]|0)+1;a=a+1|0}while((a|0)!=(m|0));f=f+1|0}while((f|0)!=(s|0));a=0}else a=0;while(0);while(1){if((k[P+(a<<2)>>2]|0)>0)break;a=a+1|0;if((a|0)>=256){a=0;break}}j=(((a|0)>0)<<31>>31)+a|0;a=255;while(1){if((k[P+(a<<2)>>2]|0)>0)break;if((a|0)>1)a=a+-1|0;else{a=0;break}}q=0;m=0;f=0;do{J=k[P+(f<<2)>>2]|0;I=(J|0)>(q|0);m=I?f:m;q=I?J:q;f=f+1|0}while((f|0)!=256);g=((a|0)<255&1)+a|0;if((m-j|0)<(g-m|0)){a=255;f=0;do{H=P+(f<<2)|0;I=k[H>>2]|0;J=P+(a<<2)|0;k[H>>2]=k[J>>2];k[J>>2]=I;f=f+1|0;a=a+-1|0}while((f|0)<(a|0));f=1;j=255-g|0;m=255-m|0}else f=0;h=+(j|0);o=+(q|0);t=+(j-m|0);if((j|0)<(m|0)){n=0.0;while(1){j=j+1|0;S=+(j|0);c=o*S+t*+(k[P+(j<<2)>>2]|0);a=c>n;h=a?S:h;if((j|0)==(m|0))break;else n=a?c:n}}c=h+-1.0;c=f?255.0-c:c;break}default:{}}J=Q+40|0;H=k[J>>2]|0;I=k[H>>2]|0;k[B>>2]=k[H+4>>2];k[B+4>>2]=I;x2(b,B,k[Q>>2]&4095,0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[P>>2]=k[j>>2];v=P+4|0;a=j+4|0;k[v>>2]=k[a>>2];I=P+8|0;k[I>>2]=k[j+8>>2];k[P+12>>2]=k[j+12>>2];k[P+16>>2]=k[j+16>>2];k[P+20>>2]=k[j+20>>2];k[P+24>>2]=k[j+24>>2];k[P+28>>2]=k[j+28>>2];k[P+32>>2]=k[j+32>>2];f=k[j+36>>2]|0;k[P+36>>2]=f;g=P+40|0;k[g>>2]=I;I=P+48|0;q=P+44|0;k[q>>2]=I;k[P+52>>2]=0;k[I>>2]=0;if(f|0){I=f+12|0;k[I>>2]=(k[I>>2]|0)+1}if((k[a>>2]|0)<3){H=k[j+44>>2]|0;I=k[q>>2]|0;k[I>>2]=k[H>>2];k[I+4>>2]=k[H+4>>2];break}k[v>>2]=0;x1(P,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){s=k[j+40>>2]|0;m=k[g>>2]|0;g=k[j+44>>2]|0;f=k[q>>2]|0;a=0;do{k[m+(a<<2)>>2]=k[s+(a<<2)>>2];k[f+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(P,b,-1);while(0);a=k[Q>>2]|0;c:do switch(a&7){case 0:{q=~~c;q=q-(+(q|0)>c&1)|0;c=+(q|0);p[u>>3]=d;f=k[u+4>>2]|0;I=f&2146435072;if(!(I>>>0>1126170624|(I|0)==1126170624&0>0)){f=(f|0)<0;h=f?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=f?-0.0:0.0}else h=d;m=(K|0)==2;f=m?q:~~h;f=f>>>0<256?f:(f|0)>0?255:0;g=f&255;j=(q|0)>254;if(q>>>0<=254){h=+(f&255);C=107;break c}if((K|1|0)!=1?!((m|(K|0)==4)&(q|0)<0|(K|0)==3&j):0){O=N+4|0;M=O+4|0;k[M>>2]=0;k[M+4>>2]=0;k[N>>2]=33619968;k[O>>2]=P;mY(Q,N);break c}switch(e&7){case 0:{a=j?0:g;break}case 1:{a=j?g:0;break}default:a=0}p[O>>3]=+(a|0);k[N>>2]=-1056833530;k[N+4>>2]=O;k[N+8>>2]=1;k[N+12>>2]=1;pY(P,N,49332);break}case 3:{q=~~c;q=q-(+(q|0)>c&1)|0;c=+(q|0);p[u>>3]=d;f=k[u+4>>2]|0;I=f&2146435072;if(!(I>>>0>1126170624|(I|0)==1126170624&0>0)){f=(f|0)<0;h=f?d+-4503599627370496.0+4503599627370496.0:d+4503599627370496.0+-4503599627370496.0;if(h==0.0)h=f?-0.0:0.0}else h=d;m=(K|0)==2;f=m?q:~~h;f=(f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768;g=f<<16>>16;j=(q|0)>32766;if((q+32768|0)>>>0<=65534){h=+((f&65535)<<16>>16);C=107;break c}if((K|1|0)!=1?!((m|(K|0)==4)&(q|0)<-32768|(K|0)==3&j):0){O=N+4|0;M=O+4|0;k[M>>2]=0;k[M+4>>2]=0;k[N>>2]=33619968;k[O>>2]=P;mY(Q,N);break c}switch(e&7){case 0:{a=j?0:g;break}case 1:{a=j?g:0;break}default:a=0}p[O>>3]=+(a|0);k[N>>2]=-1056833530;k[N+4>>2]=O;k[N+8>>2]=1;k[N+12>>2]=1;pY(P,N,49332);break}case 5:{h=d;C=107;break}default:{k[N>>2]=0;I=N+4|0;k[I>>2]=0;a=ZT(8)|0;k[a>>2]=1;H=a+4|0;k[N>>2]=H;k[I>>2]=0;i[H>>0]=0;Y8(-210,N,393853,353955,1273);k[I>>2]=0;k[N>>2]=0;I=k[a>>2]|0;k[a>>2]=I+-1;if((I|0)==1)ggb(k[a+-4>>2]|0);h=d;a=k[Q>>2]|0;C=107}}while(0);if((C|0)==107){q=P+8|0;G=k[q>>2]|0;k[N>>2]=0;k[N+4>>2]=G;k[L>>2]=a;G=L+4|0;f=Q+4|0;a=k[f>>2]|0;k[G>>2]=a;I=L+8|0;k[I>>2]=k[Q+8>>2];k[L+12>>2]=k[Q+12>>2];D=L+16|0;k[D>>2]=k[Q+16>>2];k[L+20>>2]=k[Q+20>>2];k[L+24>>2]=k[Q+24>>2];k[L+28>>2]=k[Q+28>>2];C=L+32|0;k[C>>2]=k[Q+32>>2];E=L+36|0;g=k[Q+36>>2]|0;k[E>>2]=g;F=L+40|0;k[F>>2]=I;I=L+48|0;H=L+44|0;k[H>>2]=I;k[L+52>>2]=0;k[I>>2]=0;if(g){a=g+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[f>>2]|0}if((a|0)>=3){k[G>>2]=0;x1(L,a,0,0,0);if((k[G>>2]|0)>0){f=k[J>>2]|0;g=k[F>>2]|0;j=k[Q+44>>2]|0;m=k[H>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[f+(a<<2)>>2];k[m+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[G>>2]|0))}}else{B=k[Q+44>>2]|0;e=k[H>>2]|0;k[e>>2]=k[B>>2];k[e+4>>2]=k[B+4>>2]}k[M>>2]=k[P>>2];B=M+4|0;g=P+4|0;a=k[g>>2]|0;k[B>>2]=a;e=M+8|0;k[e>>2]=k[q>>2];k[M+12>>2]=k[P+12>>2];v=M+16|0;k[v>>2]=k[P+16>>2];k[M+20>>2]=k[P+20>>2];k[M+24>>2]=k[P+24>>2];k[M+28>>2]=k[P+28>>2];q=M+32|0;k[q>>2]=k[P+32>>2];z=M+36|0;f=k[P+36>>2]|0;k[z>>2]=f;A=M+40|0;k[A>>2]=e;e=M+48|0;b=M+44|0;k[b>>2]=e;k[M+52>>2]=0;k[e>>2]=0;if(f){a=f+12|0;k[a>>2]=(k[a>>2]|0)+1;a=k[g>>2]|0}if((a|0)>=3){k[B>>2]=0;x1(M,a,0,0,0);if((k[B>>2]|0)>0){f=k[P+40>>2]|0;g=k[A>>2]|0;j=k[P+44>>2]|0;m=k[b>>2]|0;a=0;do{k[g+(a<<2)>>2]=k[f+(a<<2)>>2];k[m+(a<<2)>>2]=k[j+(a<<2)>>2];a=a+1|0}while((a|0)<(k[B>>2]|0))}}else{m=k[P+44>>2]|0;s=k[b>>2]|0;k[s>>2]=k[m>>2];k[s+4>>2]=k[m+4>>2]}k[O>>2]=89332;j=O+4|0;k[j>>2]=1124007936;a=O+12|0;f=O+44|0;m=O+8|0;s=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(s|0));k[f>>2]=a;a=O+52|0;k[O+48>>2]=a;k[O+56>>2]=0;k[a>>2]=0;a=O+60|0;k[a>>2]=1124007936;f=O+68|0;g=O+100|0;m=O+64|0;s=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(s|0));k[g>>2]=f;s=O+108|0;k[O+104>>2]=s;k[O+112>>2]=0;k[s>>2]=0;KG(j,L)|0;KG(a,M)|0;p[O+120>>3]=c;p[O+128>>3]=h;k[O+136>>2]=K;jh[k[(k[O>>2]|0)+8>>2]&1023](O,N);Zua(O);a=k[z>>2]|0;if(a|0?(N=a+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){f=k[z>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[q>>2]|0;if(!a){a=B1()|0;f=k[z>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[z>>2]=0}k[z>>2]=0;k[v>>2]=0;k[v+4>>2]=0;k[v+8>>2]=0;k[v+12>>2]=0;if((k[B>>2]|0)>0){f=k[A>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[B>>2]|0))}a=k[b>>2]|0;if(!((a|0)==(e|0)|(a|0)==0))ggb(k[a+-4>>2]|0);a=k[E>>2]|0;if(a|0?(N=a+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){f=k[E>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[C>>2]|0;if(!a){a=B1()|0;f=k[E>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[E>>2]=0}k[E>>2]=0;k[D>>2]=0;k[D+4>>2]=0;k[D+8>>2]=0;k[D+12>>2]=0;if((k[G>>2]|0)>0){f=k[F>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[G>>2]|0))}a=k[H>>2]|0;if(!((a|0)==(I|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}g=P+36|0;a=k[g>>2]|0;if(a|0?(N=a+12|0,O=k[N>>2]|0,k[N>>2]=O+-1,(O|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[P+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;O=P+16|0;f=P+4|0;k[O>>2]=0;k[O+4>>2]=0;k[O+8>>2]=0;k[O+12>>2]=0;if((k[f>>2]|0)>0){g=k[P+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[f>>2]|0))}a=k[P+44>>2]|0;if(!((a|0)==(P+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);g=Q+36|0;a=k[g>>2]|0;if(a|0?(O=a+12|0,P=k[O>>2]|0,k[O>>2]=P+-1,(P|0)==1):0){f=k[g>>2]|0;if(f|0){a=k[f+4>>2]|0;if(!a){a=k[Q+32>>2]|0;if(!a){a=B1()|0;f=k[g>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,f)}k[g>>2]=0}k[g>>2]=0;P=Q+16|0;g=Q+4|0;k[P>>2]=0;k[P+4>>2]=0;k[P+8>>2]=0;k[P+12>>2]=0;if((k[g>>2]|0)>0){f=k[J>>2]|0;a=0;do{k[f+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[Q+44>>2]|0;if((a|0)==(Q+48|0)|(a|0)==0){r=R;return +c}ggb(k[a+-4>>2]|0);r=R;return +c}function Zua(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=89332;d=a+96|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+92>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+76|0;c=a+64|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+100>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+104>>2]|0;if(!((b|0)==(a+108|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=a+40|0;b=k[d>>2]|0;if(b|0?(b=b+12|0,c=k[b>>2]|0,k[b>>2]=c+-1,(c|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[a+36>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;d=a+20|0;c=a+8|0;k[d>>2]=0;k[d+4>>2]=0;k[d+8>>2]=0;k[d+12>>2]=0;if((k[c>>2]|0)>0){d=k[a+44>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[a+48>>2]|0;if((b|0)==(a+52|0)|(b|0)==0)return;ggb(k[b+-4>>2]|0);return}function _ua(a){a=a|0;Zua(a);ggb(a);return}function $ua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0.0,m=0,n=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;z=r;r=r+384|0;w=z+120|0;q=z+112|0;y=z+56|0;x=z;v=k[b>>2]|0;n=k[b+4>>2]|0;k[w>>2]=v;k[w+4>>2]=n;k[q>>2]=-2147483648;k[q+4>>2]=2147483647;H1(y,a+4|0,w,q);k[w>>2]=v;k[w+4>>2]=n;k[q>>2]=-2147483648;k[q+4>>2]=2147483647;H1(x,a+60|0,w,q);n=k[y>>2]|0;a:do switch(n&7){case 0:{f=~~+p[a+120>>3]&255;g=~~+p[a+128>>3]&255;d=k[y+40>>2]|0;e=k[d>>2]|0;d=aa((n>>>3&511)+1|0,k[d+4>>2]|0)|0;b=k[y+48>>2]|0;c=k[x+48>>2]|0;if(!(n&16384)){v=b;u=c;s=d;t=e}else{t=(k[x>>2]&16384|0)!=0;s=aa(d,e)|0;v=t?s:b;u=t?s:c;s=t?s:d;t=t?1:e}switch(k[a+136>>2]|0){case 0:{b=f&255;c=b+1|0;zpb(w|0,0,c|0)|0;if(c>>>0<256)zpb(w+c|0,g|0,b^255|0)|0;break}case 1:{b=f&255;c=b+1|0;zpb(w|0,g|0,c|0)|0;if(c>>>0<256)zpb(w+c|0,0,b^255|0)|0;break}case 2:{c=f&255;d=c+1|0;b=0;do{i[w+b>>0]=b;b=b+1|0}while((b|0)!=(d|0));if(d>>>0<256)zpb(w+d|0,f|0,c^255|0)|0;break}case 3:{b=(f&255)+1|0;zpb(w|0,0,b|0)|0;if(b>>>0<256)do{i[w+b>>0]=b;b=b+1|0}while((b|0)!=256);break}case 4:{c=f&255;d=c+1|0;b=0;do{i[w+b>>0]=b;b=b+1|0}while((b|0)!=(d|0));if(d>>>0<256)zpb(w+d|0,0,c^255|0)|0;break}default:{k[q>>2]=0;b=q+4|0;k[b>>2]=0;c=ZT(28)|0;k[c>>2]=1;d=c+4|0;k[q>>2]=d;k[b>>2]=22;i[c+26>>0]=0;e=354045;f=d+22|0;do{i[d>>0]=i[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));Y8(-5,q,354068,353955,161);k[b>>2]=0;k[q>>2]=0;q=k[c>>2]|0;k[c>>2]=q+-1;if((q|0)==1)ggb(k[c+-4>>2]|0)}}b:do if((t|0)>0&(s|0)>0){m=y+16|0;n=x+16|0;g=s+-4|0;if((s|0)<4){b=0;while(1){d=(k[m>>2]|0)+(aa(b,v)|0)|0;e=(k[n>>2]|0)+(aa(b,u)|0)|0;c=0;do{i[e+c>>0]=i[w+(l[d+c>>0]|0)>>0]|0;c=c+1|0}while((c|0)!=(s|0));b=b+1|0;if((b|0)==(t|0))break b}}d=s&-4;if((d|0)<(s|0))c=0;else{c=0;while(1){d=(k[m>>2]|0)+(aa(c,v)|0)|0;e=(k[n>>2]|0)+(aa(c,u)|0)|0;b=0;do{a=b|1;s=i[w+(l[d+a>>0]|0)>>0]|0;i[e+b>>0]=i[w+(l[d+b>>0]|0)>>0]|0;i[e+a>>0]=s;a=b|2;s=b|3;q=i[w+(l[d+s>>0]|0)>>0]|0;i[e+a>>0]=i[w+(l[d+a>>0]|0)>>0]|0;i[e+s>>0]=q;b=b+4|0}while((b|0)<=(g|0));c=c+1|0;if((c|0)==(t|0))break b}}do{e=(k[m>>2]|0)+(aa(c,v)|0)|0;f=(k[n>>2]|0)+(aa(c,u)|0)|0;b=0;do{A=b|1;q=i[w+(l[e+A>>0]|0)>>0]|0;i[f+b>>0]=i[w+(l[e+b>>0]|0)>>0]|0;i[f+A>>0]=q;A=b|2;q=b|3;a=i[w+(l[e+q>>0]|0)>>0]|0;i[f+A>>0]=i[w+(l[e+A>>0]|0)>>0]|0;i[f+q>>0]=a;b=b+4|0}while((b|0)<=(g|0));b=d;do{i[f+b>>0]=i[w+(l[e+b>>0]|0)>>0]|0;b=b+1|0}while((b|0)!=(s|0));c=c+1|0}while((c|0)!=(t|0))}while(0);break}case 3:{s=~~+p[a+120>>3];m=~~+p[a+128>>3];f=k[y+40>>2]|0;g=k[f>>2]|0;f=aa(k[f+4>>2]|0,(n>>>3&511)+1|0)|0;e=k[y+16>>2]|0;b=k[x+16>>2]|0;d=(k[y+48>>2]|0)>>>1;c=(k[x+48>>2]|0)>>>1;if(!(n&16384)){q=c;n=d}else{A=(k[x>>2]&16384|0)!=0;v=aa(f,g)|0;q=A?v:c;n=A?v:d;f=A?v:f;g=A?1:g}switch(k[a+136>>2]|0){case 0:{if((g|0)>0&(f|0)>0)c=0;else break a;while(1){d=0;do{j[b+(d<<1)>>1]=(j[e+(d<<1)>>1]|0)>s<<16>>16?m:0;d=d+1|0}while((d|0)!=(f|0));c=c+1|0;if((c|0)==(g|0))break;else{e=e+(n<<1)|0;b=b+(q<<1)|0}}break}case 1:{if((g|0)>0&(f|0)>0)c=0;else break a;while(1){d=0;do{j[b+(d<<1)>>1]=(j[e+(d<<1)>>1]|0)<=s<<16>>16?m:0;d=d+1|0}while((d|0)!=(f|0));c=c+1|0;if((c|0)==(g|0))break;else{e=e+(n<<1)|0;b=b+(q<<1)|0}}break}case 2:{if((g|0)>0&(f|0)>0)c=0;else break a;while(1){d=0;do{A=j[e+(d<<1)>>1]|0;j[b+(d<<1)>>1]=A<<16>>16>s<<16>>16?s:A;d=d+1|0}while((d|0)!=(f|0));c=c+1|0;if((c|0)==(g|0))break;else{e=e+(n<<1)|0;b=b+(q<<1)|0}}break}case 3:{if((g|0)>0&(f|0)>0)d=0;else break a;while(1){c=0;do{A=j[e+(c<<1)>>1]|0;j[b+(c<<1)>>1]=A<<16>>16>s<<16>>16?A:0;c=c+1|0}while((c|0)!=(f|0));d=d+1|0;if((d|0)==(g|0))break;else{e=e+(n<<1)|0;b=b+(q<<1)|0}}break}case 4:{if((g|0)>0&(f|0)>0)d=0;else break a;while(1){c=0;do{A=j[e+(c<<1)>>1]|0;j[b+(c<<1)>>1]=A<<16>>16<=s<<16>>16?A:0;c=c+1|0}while((c|0)!=(f|0));d=d+1|0;if((d|0)==(g|0))break;else{e=e+(n<<1)|0;b=b+(q<<1)|0}}break}default:{k[w>>2]=0;A=w+4|0;k[A>>2]=0;b=ZT(8)|0;k[b>>2]=1;v=b+4|0;k[w>>2]=v;k[A>>2]=0;i[v>>0]=0;Y8(-5,w,354078,353955,652);k[A>>2]=0;k[w>>2]=0;A=k[b>>2]|0;k[b>>2]=A+-1;if((A|0)==1)ggb(k[b+-4>>2]|0);break a}}break}case 5:{h=+p[a+128>>3];f=k[a+136>>2]|0;o[w>>2]=+p[a+120>>3];c=k[y+40>>2]|0;d=k[c>>2]|0;c=aa((n>>>3&511)+1|0,k[c+4>>2]|0)|0;e=k[y+16>>2]|0;b=k[x+16>>2]|0;a=(k[y+48>>2]|0)>>>2;s=(k[x+48>>2]|0)>>>2;if(!(n&16384)){m=c;g=d}else{g=(k[x>>2]&16384|0)!=0;m=aa(g?d:1,c)|0;g=g?1:d}switch(f|0){case 0:{if((g|0)>0&(m|0)>0){c=0;while(1){d=0;do{o[b+(d<<2)>>2]=+o[e+(d<<2)>>2]>+o[w>>2]?h:0.0;d=d+1|0}while((d|0)!=(m|0));c=c+1|0;if((c|0)==(g|0))break;else{e=e+(a<<2)|0;b=b+(s<<2)|0}}}break}case 1:{if((g|0)>0&(m|0)>0){c=0;while(1){d=0;do{o[b+(d<<2)>>2]=+o[e+(d<<2)>>2]<=+o[w>>2]?h:0.0;d=d+1|0}while((d|0)!=(m|0));c=c+1|0;if((c|0)==(g|0))break;else{e=e+(a<<2)|0;b=b+(s<<2)|0}}}break}case 2:{if((g|0)>0&(m|0)>0){c=0;while(1){d=0;do{A=e+(d<<2)|0;k[b+(d<<2)>>2]=k[(+o[w>>2]<+o[A>>2]?w:A)>>2];d=d+1|0}while((d|0)!=(m|0));c=c+1|0;if((c|0)==(g|0))break;else{e=e+(a<<2)|0;b=b+(s<<2)|0}}}break}case 3:{if((g|0)>0&(m|0)>0){d=0;while(1){c=0;do{h=+o[e+(c<<2)>>2];o[b+(c<<2)>>2]=h>+o[w>>2]?h:0.0;c=c+1|0}while((c|0)!=(m|0));d=d+1|0;if((d|0)==(g|0))break;else{e=e+(a<<2)|0;b=b+(s<<2)|0}}}break}case 4:{if((g|0)>0&(m|0)>0){d=0;while(1){c=0;do{h=+o[e+(c<<2)>>2];o[b+(c<<2)>>2]=h<=+o[w>>2]?h:0.0;c=c+1|0}while((c|0)!=(m|0));d=d+1|0;if((d|0)==(g|0))break;else{e=e+(a<<2)|0;b=b+(s<<2)|0}}}break}default:{k[q>>2]=0;A=q+4|0;k[A>>2]=0;b=ZT(8)|0;k[b>>2]=1;w=b+4|0;k[q>>2]=w;k[A>>2]=0;i[w>>0]=0;Y8(-5,q,354089,353955,903);k[A>>2]=0;k[q>>2]=0;A=k[b>>2]|0;k[b>>2]=A+-1;if((A|0)==1)ggb(k[b+-4>>2]|0)}}break}default:{}}while(0);d=x+36|0;b=k[d>>2]|0;if(b|0?(w=b+12|0,A=k[w>>2]|0,k[w>>2]=A+-1,(A|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[x+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;A=x+16|0;c=x+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[c>>2]|0)>0){d=k[x+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[x+44>>2]|0;if(!((b|0)==(x+48|0)|(b|0)==0))ggb(k[b+-4>>2]|0);d=y+36|0;b=k[d>>2]|0;if(b|0?(x=b+12|0,A=k[x>>2]|0,k[x>>2]=A+-1,(A|0)==1):0){c=k[d>>2]|0;if(c|0){b=k[c+4>>2]|0;if(!b){b=k[y+32>>2]|0;if(!b){b=B1()|0;c=k[d>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,c)}k[d>>2]=0}k[d>>2]=0;A=y+16|0;c=y+4|0;k[A>>2]=0;k[A+4>>2]=0;k[A+8>>2]=0;k[A+12>>2]=0;if((k[c>>2]|0)>0){d=k[y+40>>2]|0;b=0;do{k[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[c>>2]|0))}b=k[y+44>>2]|0;if((b|0)==(y+48|0)|(b|0)==0){r=z;return}ggb(k[b+-4>>2]|0);r=z;return}function ava(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0;w=r;r=r+128|0;v=w+72|0;o=w+16|0;n=w;do if((k[b>>2]&2031616|0)==65536){g=k[b+4>>2]|0;k[v>>2]=k[g>>2];l=v+4|0;b=g+4|0;k[l>>2]=k[b>>2];u=v+8|0;k[u>>2]=k[g+8>>2];k[v+12>>2]=k[g+12>>2];k[v+16>>2]=k[g+16>>2];k[v+20>>2]=k[g+20>>2];k[v+24>>2]=k[g+24>>2];k[v+28>>2]=k[g+28>>2];k[v+32>>2]=k[g+32>>2];e=k[g+36>>2]|0;k[v+36>>2]=e;f=v+40|0;k[f>>2]=u;u=v+48|0;i=v+44|0;k[i>>2]=u;k[v+52>>2]=0;k[u>>2]=0;if(e|0){u=e+12|0;k[u>>2]=(k[u>>2]|0)+1}if((k[b>>2]|0)<3){t=k[g+44>>2]|0;u=k[i>>2]|0;k[u>>2]=k[t>>2];k[u+4>>2]=k[t+4>>2];break}k[l>>2]=0;x1(v,k[b>>2]|0,0,0,0);if((k[l>>2]|0)>0){j=k[g+40>>2]|0;h=k[f>>2]|0;f=k[g+44>>2]|0;e=k[i>>2]|0;b=0;do{k[h+(b<<2)>>2]=k[j+(b<<2)>>2];k[e+(b<<2)>>2]=k[f+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else Q1(v,b,-1);while(0);do if(!d?(m=k[v>>2]|0,(m&4095|0)==6):0){k[a>>2]=m;l=a+4|0;f=v+4|0;b=k[f>>2]|0;k[l>>2]=b;u=a+8|0;k[u>>2]=k[v+8>>2];k[a+12>>2]=k[v+12>>2];k[a+16>>2]=k[v+16>>2];k[a+20>>2]=k[v+20>>2];k[a+24>>2]=k[v+24>>2];k[a+28>>2]=k[v+28>>2];k[a+32>>2]=k[v+32>>2];g=v+36|0;e=k[g>>2]|0;k[a+36>>2]=e;h=a+40|0;k[h>>2]=u;u=a+48|0;j=a+44|0;k[j>>2]=u;k[a+52>>2]=0;k[u>>2]=0;if(e){b=e+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[f>>2]|0}if((b|0)<3){u=k[v+44>>2]|0;a=k[j>>2]|0;k[a>>2]=k[u>>2];k[a+4>>2]=k[u+4>>2];break}k[l>>2]=0;x1(a,b,0,0,0);if((k[l>>2]|0)>0){i=k[v+40>>2]|0;f=k[h>>2]|0;h=k[v+44>>2]|0;e=k[j>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[i+(b<<2)>>2];k[e+(b<<2)>>2]=k[h+(b<<2)>>2];b=b+1|0}while((b|0)<(k[l>>2]|0))}}else q=19;while(0);if((q|0)==19){k[o>>2]=1124007936;u=o+4|0;f=o+8|0;q=o+40|0;b=u;e=b+36|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(e|0));k[q>>2]=f;t=o+48|0;s=o+44|0;k[s>>2]=t;k[o+52>>2]=0;k[t>>2]=0;m=n+4|0;l=m+4|0;k[l>>2]=0;k[l+4>>2]=0;k[n>>2]=33619968;k[m>>2]=o;SW(v,n,6,1.0,0.0);if(d){n=o+16|0;b=k[n>>2]|0;p[b+16>>3]=+((k[c>>2]|0)+-1|0)*.5;p[b+40>>3]=+((k[c+4>>2]|0)+-1|0)*.5;c=n}else{b=o+16|0;c=b;b=k[b>>2]|0}k[a>>2]=k[o>>2];j=a+4|0;g=k[u>>2]|0;k[j>>2]=g;i=a+8|0;k[i>>2]=k[f>>2];k[a+12>>2]=k[o+12>>2];k[a+16>>2]=b;k[a+20>>2]=k[o+20>>2];k[a+24>>2]=k[o+24>>2];k[a+28>>2]=k[o+28>>2];l=o+32|0;k[a+32>>2]=k[l>>2];m=o+36|0;b=k[m>>2]|0;k[a+36>>2]=b;e=a+40|0;k[e>>2]=i;o=a+48|0;i=a+44|0;k[i>>2]=o;k[a+52>>2]=0;k[o>>2]=0;if(!b)b=g;else{b=b+12|0;k[b>>2]=(k[b>>2]|0)+1;b=k[u>>2]|0}if((b|0)>=3){k[j>>2]=0;x1(a,b,0,0,0);if((k[j>>2]|0)>0){h=k[q>>2]|0;f=k[e>>2]|0;g=k[s>>2]|0;e=k[i>>2]|0;b=0;do{k[f+(b<<2)>>2]=k[h+(b<<2)>>2];k[e+(b<<2)>>2]=k[g+(b<<2)>>2];b=b+1|0}while((b|0)<(k[j>>2]|0))}}else{o=k[s>>2]|0;a=k[i>>2]|0;k[a>>2]=k[o>>2];k[a+4>>2]=k[o+4>>2]}b=k[m>>2]|0;if(b|0?(o=b+12|0,a=k[o>>2]|0,k[o>>2]=a+-1,(a|0)==1):0){e=k[m>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[l>>2]|0;if(!b){b=B1()|0;e=k[m>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[m>>2]=0}k[m>>2]=0;k[c>>2]=0;k[c+4>>2]=0;k[c+8>>2]=0;k[c+12>>2]=0;if((k[u>>2]|0)>0){e=k[q>>2]|0;b=0;do{k[e+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[u>>2]|0))}b=k[s>>2]|0;if(!((b|0)==(t|0)|(b|0)==0))ggb(k[b+-4>>2]|0);g=v+36|0}b=k[g>>2]|0;if(b|0?(u=b+12|0,a=k[u>>2]|0,k[u>>2]=a+-1,(a|0)==1):0){f=v+36|0;e=k[f>>2]|0;if(e|0){b=k[e+4>>2]|0;if(!b){b=k[v+32>>2]|0;if(!b){b=B1()|0;e=k[f>>2]|0}}jh[k[(k[b>>2]|0)+24>>2]&1023](b,e)}k[f>>2]=0}k[g>>2]=0;a=v+16|0;e=v+4|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;k[a+12>>2]=0;if((k[e>>2]|0)>0){f=k[v+40>>2]|0;b=0;do{k[f+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(k[e>>2]|0))}b=k[v+44>>2]|0;if((b|0)==(v+48|0)|(b|0)==0){r=w;return}ggb(k[b+-4>>2]|0);r=w;return}function bva(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0;Xa=r;r=r+1552|0;ya=Xa+672|0;P=Xa+1536|0;Wa=Xa+1480|0;Va=Xa+1424|0;Ua=Xa+1360|0;Ta=Xa+1304|0;E=Xa+1416|0;Sa=Xa+1240|0;Ra=Xa+1184|0;F=Xa+1296|0;Qa=Xa+1128|0;M=Xa+448|0;Pa=Xa+1072|0;Oa=Xa+1008|0;N=Xa+1064|0;Na=Xa+952|0;ma=Xa+224|0;ra=Xa;sa=Xa+896|0;do if((k[a>>2]&2031616|0)==65536){n=k[a+4>>2]|0;k[Wa>>2]=k[n>>2];v=Wa+4|0;a=n+4|0;k[v>>2]=k[a>>2];Ma=Wa+8|0;k[Ma>>2]=k[n+8>>2];k[Wa+12>>2]=k[n+12>>2];k[Wa+16>>2]=k[n+16>>2];k[Wa+20>>2]=k[n+20>>2];k[Wa+24>>2]=k[n+24>>2];k[Wa+28>>2]=k[n+28>>2];k[Wa+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[Wa+36>>2]=l;m=Wa+40|0;k[m>>2]=Ma;Ma=Wa+48|0;s=Wa+44|0;k[s>>2]=Ma;k[Wa+52>>2]=0;k[Ma>>2]=0;if(l|0){Ma=l+12|0;k[Ma>>2]=(k[Ma>>2]|0)+1}if((k[a>>2]|0)<3){La=k[n+44>>2]|0;Ma=k[s>>2]|0;k[Ma>>2]=k[La>>2];k[Ma+4>>2]=k[La+4>>2];break}k[v>>2]=0;x1(Wa,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){t=k[n+40>>2]|0;q=k[m>>2]|0;m=k[n+44>>2]|0;l=k[s>>2]|0;a=0;do{k[q+(a<<2)>>2]=k[t+(a<<2)>>2];k[l+(a<<2)>>2]=k[m+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(Wa,a,-1);while(0);do if((k[b>>2]&2031616|0)==65536){q=k[b+4>>2]|0;k[Va>>2]=k[q>>2];v=Va+4|0;a=q+4|0;k[v>>2]=k[a>>2];Ma=Va+8|0;k[Ma>>2]=k[q+8>>2];k[Va+12>>2]=k[q+12>>2];k[Va+16>>2]=k[q+16>>2];k[Va+20>>2]=k[q+20>>2];k[Va+24>>2]=k[q+24>>2];k[Va+28>>2]=k[q+28>>2];k[Va+32>>2]=k[q+32>>2];l=k[q+36>>2]|0;k[Va+36>>2]=l;m=Va+40|0;k[m>>2]=Ma;Ma=Va+48|0;s=Va+44|0;k[s>>2]=Ma;k[Va+52>>2]=0;k[Ma>>2]=0;if(l|0){Ma=l+12|0;k[Ma>>2]=(k[Ma>>2]|0)+1}if((k[a>>2]|0)<3){La=k[q+44>>2]|0;Ma=k[s>>2]|0;k[Ma>>2]=k[La>>2];k[Ma+4>>2]=k[La+4>>2];break}k[v>>2]=0;x1(Va,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){t=k[q+40>>2]|0;n=k[m>>2]|0;m=k[q+44>>2]|0;l=k[s>>2]|0;a=0;do{k[n+(a<<2)>>2]=k[t+(a<<2)>>2];k[l+(a<<2)>>2]=k[m+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(Va,b,-1);while(0);do if((k[c>>2]&2031616|0)==65536){n=k[c+4>>2]|0;k[Ua>>2]=k[n>>2];v=Ua+4|0;a=n+4|0;k[v>>2]=k[a>>2];Ma=Ua+8|0;k[Ma>>2]=k[n+8>>2];k[Ua+12>>2]=k[n+12>>2];k[Ua+16>>2]=k[n+16>>2];k[Ua+20>>2]=k[n+20>>2];k[Ua+24>>2]=k[n+24>>2];k[Ua+28>>2]=k[n+28>>2];k[Ua+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[Ua+36>>2]=l;m=Ua+40|0;k[m>>2]=Ma;Ma=Ua+48|0;s=Ua+44|0;k[s>>2]=Ma;k[Ua+52>>2]=0;k[Ma>>2]=0;if(l|0){Ma=l+12|0;k[Ma>>2]=(k[Ma>>2]|0)+1}if((k[a>>2]|0)<3){La=k[n+44>>2]|0;Ma=k[s>>2]|0;k[Ma>>2]=k[La>>2];k[Ma+4>>2]=k[La+4>>2];break}k[v>>2]=0;x1(Ua,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){t=k[n+40>>2]|0;q=k[m>>2]|0;m=k[n+44>>2]|0;l=k[s>>2]|0;a=0;do{k[q+(a<<2)>>2]=k[t+(a<<2)>>2];k[l+(a<<2)>>2]=k[m+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(Ua,c,-1);while(0);do if((k[d>>2]&2031616|0)==65536){n=k[d+4>>2]|0;k[Ta>>2]=k[n>>2];v=Ta+4|0;a=n+4|0;k[v>>2]=k[a>>2];Ma=Ta+8|0;k[Ma>>2]=k[n+8>>2];k[Ta+12>>2]=k[n+12>>2];k[Ta+16>>2]=k[n+16>>2];k[Ta+20>>2]=k[n+20>>2];k[Ta+24>>2]=k[n+24>>2];k[Ta+28>>2]=k[n+28>>2];k[Ta+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[Ta+36>>2]=l;m=Ta+40|0;k[m>>2]=Ma;Ma=Ta+48|0;s=Ta+44|0;k[s>>2]=Ma;k[Ta+52>>2]=0;k[Ma>>2]=0;if(l|0){Ma=l+12|0;k[Ma>>2]=(k[Ma>>2]|0)+1}if((k[a>>2]|0)<3){La=k[n+44>>2]|0;Ma=k[s>>2]|0;k[Ma>>2]=k[La>>2];k[Ma+4>>2]=k[La+4>>2];break}k[v>>2]=0;x1(Ta,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){t=k[n+40>>2]|0;q=k[m>>2]|0;m=k[n+44>>2]|0;l=k[s>>2]|0;a=0;do{k[q+(a<<2)>>2]=k[t+(a<<2)>>2];k[l+(a<<2)>>2]=k[m+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(Ta,d,-1);while(0);b=(f|0)<1?11:f;Ea=(b|0)==11;Fa=(b|0)==5;switch(b|0){case 5:case 11:case 13:break;default:{k[ya>>2]=0;a=ya+4|0;k[a>>2]=0;l=ZT(68)|0;k[l>>2]=1;n=l+4|0;k[ya>>2]=n;k[a>>2]=62;i[l+66>>0]=0;m=354383;q=n+62|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,ya,354446,354470,72);k[a>>2]=0;k[ya>>2]=0;Ma=k[l>>2]|0;k[l>>2]=Ma+-1;if((Ma|0)==1)ggb(k[l+-4>>2]|0)}}k[E>>2]=k[e>>2];c=e+4|0;k[E+4>>2]=k[c>>2];x2(g,E,b,0);do if((k[g>>2]&2031616|0)==65536){n=k[g+4>>2]|0;k[Sa>>2]=k[n>>2];v=Sa+4|0;a=n+4|0;k[v>>2]=k[a>>2];Ma=Sa+8|0;k[Ma>>2]=k[n+8>>2];k[Sa+12>>2]=k[n+12>>2];k[Sa+16>>2]=k[n+16>>2];k[Sa+20>>2]=k[n+20>>2];k[Sa+24>>2]=k[n+24>>2];k[Sa+28>>2]=k[n+28>>2];k[Sa+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[Sa+36>>2]=l;m=Sa+40|0;k[m>>2]=Ma;Ma=Sa+48|0;s=Sa+44|0;k[s>>2]=Ma;k[Sa+52>>2]=0;k[Ma>>2]=0;if(l|0){Ma=l+12|0;k[Ma>>2]=(k[Ma>>2]|0)+1}if((k[a>>2]|0)<3){La=k[n+44>>2]|0;Ma=k[s>>2]|0;k[Ma>>2]=k[La>>2];k[Ma+4>>2]=k[La+4>>2];break}k[v>>2]=0;x1(Sa,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){t=k[n+40>>2]|0;q=k[m>>2]|0;m=k[n+44>>2]|0;l=k[s>>2]|0;a=0;do{k[q+(a<<2)>>2]=k[t+(a<<2)>>2];k[l+(a<<2)>>2]=k[m+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(Sa,g,-1);while(0);k[Ra>>2]=1124007936;Ka=Ra+4|0;wa=Ra+8|0;Ja=Ra+40|0;n=Ka;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[Ja>>2]=wa;Ma=Ra+48|0;La=Ra+44|0;k[La>>2]=Ma;k[Ra+52>>2]=0;k[Ma>>2]=0;if((b|0)!=13){k[F>>2]=k[e>>2];k[F+4>>2]=k[c>>2];x2(h,F,Ea?2:5,0);do if((k[h>>2]&2031616|0)==65536){n=k[h+4>>2]|0;k[ya>>2]=k[n>>2];v=ya+4|0;a=n+4|0;k[v>>2]=k[a>>2];Ia=ya+8|0;k[Ia>>2]=k[n+8>>2];k[ya+12>>2]=k[n+12>>2];k[ya+16>>2]=k[n+16>>2];k[ya+20>>2]=k[n+20>>2];k[ya+24>>2]=k[n+24>>2];k[ya+28>>2]=k[n+28>>2];k[ya+32>>2]=k[n+32>>2];l=k[n+36>>2]|0;k[ya+36>>2]=l;m=ya+40|0;k[m>>2]=Ia;Ia=ya+48|0;s=ya+44|0;k[s>>2]=Ia;k[ya+52>>2]=0;k[Ia>>2]=0;if(l|0){Ia=l+12|0;k[Ia>>2]=(k[Ia>>2]|0)+1}if((k[a>>2]|0)<3){Ha=k[n+44>>2]|0;Ia=k[s>>2]|0;k[Ia>>2]=k[Ha>>2];k[Ia+4>>2]=k[Ha+4>>2];break}k[v>>2]=0;x1(ya,k[a>>2]|0,0,0,0);if((k[v>>2]|0)>0){t=k[n+40>>2]|0;q=k[m>>2]|0;m=k[n+44>>2]|0;l=k[s>>2]|0;a=0;do{k[q+(a<<2)>>2]=k[t+(a<<2)>>2];k[l+(a<<2)>>2]=k[m+(a<<2)>>2];a=a+1|0}while((a|0)<(k[v>>2]|0))}}else Q1(ya,h,-1);while(0);KG(Ra,ya)|0;m=ya+36|0;a=k[m>>2]|0;if(a|0?(Ha=a+12|0,Ia=k[Ha>>2]|0,k[Ha>>2]=Ia+-1,(Ia|0)==1):0){l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;if(!a){a=k[ya+32>>2]|0;if(!a){a=B1()|0;l=k[m>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}k[m>>2]=0;Ia=ya+16|0;l=ya+4|0;k[Ia>>2]=0;k[Ia+4>>2]=0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;if((k[l>>2]|0)>0){m=k[ya+40>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[ya+44>>2]|0;if(!((a|0)==(ya+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else b2(h);k[M>>2]=0;k[M+4>>2]=0;k[M+8>>2]=1124007936;a=M+16|0;l=M+48|0;n=M+12|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[l>>2]=a;a=M+56|0;k[M+52>>2]=a;k[M+60>>2]=0;k[a>>2]=0;k[M+64>>2]=1124007936;a=M+72|0;l=M+104|0;n=M+68|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[l>>2]=a;a=M+112|0;k[M+108>>2]=a;k[M+116>>2]=0;k[a>>2]=0;k[M+120>>2]=1124007936;a=M+128|0;l=M+160|0;n=M+124|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[l>>2]=a;n=M+168|0;k[M+164>>2]=n;q=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[ya>>2]=3;k[ya+4>>2]=3;j1(M,73,ya,6);cva(Qa,M);XN(M);Eoa(Pa,Wa);Ba=Oa+4|0;a=Oa+8|0;za=Oa+40|0;n=Ba;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[za>>2]=a;Ca=Oa+48|0;Aa=Oa+44|0;k[Aa>>2]=Ca;k[Oa+52>>2]=0;k[Ca>>2]=0;k[Oa>>2]=1124007942;Ia=Ta+16|0;if(k[Ia>>2]|0){m=k[Ta+4>>2]|0;if((m|0)<3)a=aa(k[Ta+12>>2]|0,k[Ta+8>>2]|0)|0;else{n=k[Ta+40>>2]|0;l=0;a=1;do{a=aa(k[n+(l<<2)>>2]|0,a)|0;l=l+1|0}while((l|0)!=(m|0))}if(a){Eoa(ya,Ta);KG(Oa,ya)|0;m=ya+36|0;a=k[m>>2]|0;if(a|0?(Ga=a+12|0,Ha=k[Ga>>2]|0,k[Ga>>2]=Ha+-1,(Ha|0)==1):0){l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;if(!a){a=k[ya+32>>2]|0;if(!a){a=B1()|0;l=k[m>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}k[m>>2]=0;Ha=ya+16|0;l=ya+4|0;k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ha+8>>2]=0;k[Ha+12>>2]=0;if((k[l>>2]|0)>0){m=k[ya+40>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[ya+44>>2]|0;if(!((a|0)==(ya+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else O=95}else O=95;if((O|0)==95){k[P+8>>2]=0;k[P+12>>2]=0;k[P>>2]=-2130640890;k[P+4>>2]=Pa;k[N>>2]=k[e>>2];k[N+4>>2]=k[c>>2];ava(ya,P,N,1);Goa(Oa,ya)|0;m=ya+36|0;a=k[m>>2]|0;if(a|0?(Ga=a+12|0,Ha=k[Ga>>2]|0,k[Ga>>2]=Ha+-1,(Ha|0)==1):0){l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;if(!a){a=k[ya+32>>2]|0;if(!a){a=B1()|0;l=k[m>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}k[m>>2]=0;Ha=ya+16|0;l=ya+4|0;k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ha+8>>2]=0;k[Ha+12>>2]=0;if((k[l>>2]|0)>0){m=k[ya+40>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[ya+44>>2]|0;if(!((a|0)==(ya+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}Ha=Ua+16|0;if(k[Ha>>2]|0){m=k[Ua+4>>2]|0;if((m|0)<3)a=aa(k[Ua+12>>2]|0,k[Ua+8>>2]|0)|0;else{n=k[Ua+40>>2]|0;l=0;a=1;do{a=aa(k[n+(l<<2)>>2]|0,a)|0;l=l+1|0}while((l|0)!=(m|0))}if(a|0){Eoa(ya,Ua);KG(Qa,ya)|0;m=ya+36|0;a=k[m>>2]|0;if(a|0?(Da=a+12|0,Ga=k[Da>>2]|0,k[Da>>2]=Ga+-1,(Ga|0)==1):0){l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;if(!a){a=k[ya+32>>2]|0;if(!a){a=B1()|0;l=k[m>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}k[m>>2]=0;Ga=ya+16|0;l=ya+4|0;k[Ga>>2]=0;k[Ga+4>>2]=0;k[Ga+8>>2]=0;k[Ga+12>>2]=0;if((k[l>>2]|0)>0){m=k[ya+40>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[ya+44>>2]|0;if(!((a|0)==(ya+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}}Da=Va+16|0;q=(k[Da>>2]|0)==0;Ga=Va+4|0;n=k[Ga>>2]|0;if(!q){if((n|0)<3)a=aa(k[Va+12>>2]|0,k[Va+8>>2]|0)|0;else{m=k[Va+40>>2]|0;l=0;a=1;do{a=aa(k[m+(l<<2)>>2]|0,a)|0;l=l+1|0}while((l|0)!=(n|0))}if(a){Eoa(ya,Va);KG(Va,ya)|0;m=ya+36|0;a=k[m>>2]|0;if(a|0?(ua=a+12|0,xa=k[ua>>2]|0,k[ua>>2]=xa+-1,(xa|0)==1):0){l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;if(!a){a=k[ya+32>>2]|0;if(!a){a=B1()|0;l=k[m>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}k[m>>2]=0;xa=ya+16|0;l=ya+4|0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[l>>2]|0)>0){m=k[ya+40>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[ya+44>>2]|0;if(!((a|0)==(ya+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else O=149}else O=149;if((O|0)==149){if(!((((n|0)<3?(k[Va+8>>2]|0)==14:0)?(k[Va+12>>2]|0)==1:0)?!((k[Va>>2]&4095|0)!=6|q):0))O=153;if((O|0)==153){k[ya>>2]=14;k[ya+4>>2]=1;G1(Va,2,ya,6)};k[ya>>2]=0;k[ya+4>>2]=0;k[ya+8>>2]=0;k[ya+12>>2]=0;k[ya+16>>2]=0;k[ya+20>>2]=0;k[ya+24>>2]=0;k[ya+28>>2]=0;oY(Va,ya)}ua=Pa+40|0;xa=k[ua>>2]|0;if(!(((k[xa>>2]|0)==3?(k[xa+4>>2]|0)==3:0)?(xa=k[Qa+40>>2]|0,(k[xa>>2]|0)==3?(k[xa+4>>2]|0)==3:0):0)){k[ya>>2]=0;a=ya+4|0;k[a>>2]=0;l=ZT(52)|0;k[l>>2]=1;n=l+4|0;k[ya>>2]=n;k[a>>2]=45;i[l+49>>0]=0;m=354541;q=n+45|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,ya,354446,354470,102);k[a>>2]=0;k[ya>>2]=0;xa=k[l>>2]|0;k[l>>2]=xa+-1;if((xa|0)==1)ggb(k[l+-4>>2]|0)}xa=k[za>>2]|0;if(!((k[xa>>2]|0)==3?((k[xa+4>>2]|0)+-3|0)>>>0<2:0)){k[ya>>2]=0;a=ya+4|0;k[a>>2]=0;l=ZT(56)|0;k[l>>2]=1;n=l+4|0;k[ya>>2]=n;k[a>>2]=49;i[l+53>>0]=0;m=354587;q=n+49|0;do{i[n>>0]=i[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(q|0));Y8(-215,ya,354446,354470,103);k[a>>2]=0;k[ya>>2]=0;xa=k[l>>2]|0;k[l>>2]=xa+-1;if((xa|0)==1)ggb(k[l+-4>>2]|0)}k[ya>>2]=-2147483648;k[ya+4>>2]=2147483647;k[P>>2]=0;k[P+4>>2]=3;H1(sa,Oa,ya,P);a1(ra,sa,Qa);k[ma>>2]=0;k[ma+4>>2]=0;k[ma+8>>2]=1124007936;a=ma+16|0;l=ma+48|0;n=ma+12|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[l>>2]=a;a=ma+56|0;k[ma+52>>2]=a;k[ma+60>>2]=0;k[a>>2]=0;k[ma+64>>2]=1124007936;a=ma+72|0;l=ma+104|0;n=ma+68|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[l>>2]=a;a=ma+112|0;k[ma+108>>2]=a;k[ma+116>>2]=0;k[a>>2]=0;k[ma+120>>2]=1124007936;a=ma+128|0;l=ma+160|0;n=ma+124|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[l>>2]=a;n=ma+168|0;k[ma+164>>2]=n;q=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));m=k[ra>>2]|0;dh[k[(k[m>>2]|0)+96>>2]&255](m,ra,0,ma);cva(Na,ma);XN(ma);XN(ra);m=sa+36|0;a=k[m>>2]|0;if(a|0?(ta=a+12|0,xa=k[ta>>2]|0,k[ta>>2]=xa+-1,(xa|0)==1):0){l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;if(!a){a=k[sa+32>>2]|0;if(!a){a=B1()|0;l=k[m>>2]|0}}jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}k[m>>2]=0;xa=sa+16|0;l=sa+4|0;k[xa>>2]=0;k[xa+4>>2]=0;k[xa+8>>2]=0;k[xa+12>>2]=0;if((k[l>>2]|0)>0){m=k[sa+40>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[sa+44>>2]|0;if(!((a|0)==(sa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);ra=Na+16|0;ma=k[ra>>2]|0;sa=Pa+16|0;l=k[sa>>2]|0;ta=Pa+44|0;na=+p[l+16>>3];xa=l+(k[k[ta>>2]>>2]|0)|0;oa=+p[xa+16>>3];pa=+p[l>>3];qa=+p[xa+8>>3];xa=Va+40|0;l=k[xa>>2]|0;a=k[l+4>>2]|0;l=k[l>>2]|0;m=(a|0)==1;if((!(m&(l|0)==4)?(P=(l|0)==1,!((a|0)==14&P|(m&(l|0)==14|((a|0)==12&P|(m&(l|0)==12|((a|0)==8&P|(m&(l|0)==8|((a|0)==5&P|((a|0)==4&P|m&(l|0)==5))))))))):0)?(k[ya>>2]=0,P=ya+4|0,k[P>>2]=0,va=ZT(356)|0,k[va>>2]=1,O=va+4|0,k[ya>>2]=O,k[P>>2]=350,i[va+354>>0]=0,upb(O|0,354637,350)|0,Y8(-215,ya,354446,354470,114),k[P>>2]=0,k[ya>>2]=0,P=k[va>>2]|0,k[va>>2]=P+-1,(P|0)==1):0)ggb(k[va+-4>>2]|0);m=Va+8|0;a=k[m>>2]|0;if((a|0)!=1){if(!(k[Va>>2]&16384)){k[ya>>2]=0;k[ya+4>>2]=0;k[ya+8>>2]=1124007936;a=ya+16|0;l=ya+48|0;n=ya+12|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[l>>2]=a;a=ya+56|0;k[ya+52>>2]=a;k[ya+60>>2]=0;k[a>>2]=0;k[ya+64>>2]=1124007936;a=ya+72|0;l=ya+104|0;n=ya+68|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[l>>2]=a;a=ya+112|0;k[ya+108>>2]=a;k[ya+116>>2]=0;k[a>>2]=0;k[ya+120>>2]=1124007936;a=ya+128|0;l=ya+160|0;n=ya+124|0;q=n+36|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));k[l>>2]=a;n=ya+168|0;k[ya+164>>2]=n;q=n+56|0;do{k[n>>2]=0;n=n+4|0}while((n|0)<(q|0));y0(ya,Va,1.0);a=k[ya>>2]|0;dh[k[(k[a>>2]|0)+12>>2]&255](a,ya,Va,-1);XN(ya);a=k[m>>2]|0}}else a=1;l=k[Da>>2]|0;va=Va+44|0;ia=+p[l>>3];ja=+p[l+8>>3];ka=+p[l+16>>3];la=+p[l+24>>3];a=(k[Va+12>>2]|0)+-1+a|0;do if((a|0)>4){w=+p[l+32>>3];if((a|0)>7){z=+p[l+40>>3];y=+p[l+48>>3];x=+p[l+56>>3];if((a|0)>11){A=+p[l+64>>3];B=+p[l+72>>3];C=+p[l+80>>3];D=+p[l+88>>3];if((a|0)<=13){ha=x;ga=y;y=0.0;x=0.0;break}ha=x;ga=y;y=+p[l+96>>3];x=+p[l+104>>3]}else{ha=x;ga=y;A=0.0;B=0.0;C=0.0;D=0.0;y=0.0;x=0.0}}else{ha=0.0;ga=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;y=0.0;x=0.0}}else{w=0.0;ha=0.0;ga=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;y=0.0;x=0.0}while(0);ea=+S(+y);U=+T(+y);Q=+S(+x);R=+T(+x);W=R*0.0;ba=Q+0.0-W;fa=Q*0.0;da=fa+0.0;V=ea*0.0;ca=U*R+(V+da);Y=U*0.0;da=Y+da-ea*R;_=ea+0.0-Y;$=V+(U+0.0);R=fa+(R+0.0);W=W+0.0;U=V+W-U*Q;W=ea*Q+(Y+W);Y=-da;Q=-$;ea=R*Y+(ba*W+0.0);V=_*0.0;fa=U*Y+(V+(ca*W+0.0));X=$*0.0;Y=W*Y+(X+(da*W+0.0));ba=ba*0.0+0.0;Z=R*Q+(ba+W*0.0);ca=ca*0.0+0.0;_=U*Q+(ca+_*W);da=da*0.0+0.0;$=W*Q+(da+$*W);ba=R+ba;ca=U+(V+ca);da=W+(X+da);h=k[c>>2]|0;if((h|0)>0){M=k[Sa+16>>2]|0;N=k[k[Sa+44>>2]>>2]|0;O=k[Ra+16>>2]|0;P=(O|0)==0;Q=+p[ma+8>>3];R=+p[ma+16>>3];U=+p[ma+32>>3];V=+p[ma+40>>3];W=+p[ma+56>>3];X=+p[ma+64>>3];c=k[e>>2]|0;d=(c|0)>0;f=ma+24|0;E=ma+48|0;g=k[Ka>>2]|0;F=(g|0)<3;s=aa(k[Ra+12>>2]|0,k[wa>>2]|0)|0;t=k[La>>2]|0;v=k[Ja>>2]|0;q=0;do{b=M+(aa(N,q)|0)|0;do if(P)n=0;else{if(F)a=s;else{l=0;a=1;do{a=aa(k[v+(l<<2)>>2]|0,a)|0;l=l+1|0}while((l|0)!=(g|0))}if(!a){n=0;break}n=O+(aa(k[t>>2]|0,q)|0)|0}while(0);x=+(q|0);if(d){J=+p[ma>>3];K=+p[f>>3];L=+p[E>>3];m=0;H=x*W+X;I=x*U+V;G=x*Q+R;while(1){y=1.0/H;Ya=G*y;y=I*y;ab=Ya*Ya;x=y*y;_a=ab+x;$a=y*(Ya*2.0);Za=(_a*(ia+_a*(ja+w*_a))+1.0)/(_a*(z+_a*(ga+ha*_a))+1.0);Ya=_a*(B*_a)+(A*_a+(la*(_a+ab*2.0)+(ka*$a+Ya*Za)));Za=_a*(D*_a)+(C*_a+(la*$a+(ka*(_a+x*2.0)+y*Za)));y=da+(ca*Za+(ba*Ya+0.0));y=y!=0.0?1.0/y:1.0;x=na+(Y+(fa*Za+(ea*Ya+0.0)))*(pa*y);y=oa+($+(_*Za+(Z*Ya+0.0)))*(qa*y);do if(!Ea)if(Fa){o[b+(m<<2)>>2]=x;o[n+(m<<2)>>2]=y;break}else{e=m<<1;o[b+(e<<2)>>2]=x;o[b+((e|1)<<2)>>2]=y;break}else{x=x*32.0;p[u>>3]=x;a=k[u+4>>2]|0;e=a&2146435072;do if(!(e>>>0>1126170624|(e|0)==1126170624&0>0)){a=(a|0)<0;x=a?x+-4503599627370496.0+4503599627370496.0:x+4503599627370496.0+-4503599627370496.0;if(!(x==0.0))break;x=a?-0.0:0.0}while(0);l=~~x;x=y*32.0;p[u>>3]=x;a=k[u+4>>2]|0;e=a&2146435072;do if(!(e>>>0>1126170624|(e|0)==1126170624&0>0)){a=(a|0)<0;x=a?x+-4503599627370496.0+4503599627370496.0:x+4503599627370496.0+-4503599627370496.0;if(!(x==0.0))break;x=a?-0.0:0.0}while(0);e=~~x;j[b+(m<<2)>>1]=l>>>5;j[b+((m<<1|1)<<1)>>1]=e>>>5;j[n+(m<<1)>>1]=e<<5&992|l&31}while(0);m=m+1|0;if((m|0)==(c|0))break;else{H=H+L;I=I+K;G=G+J}}}q=q+1|0}while((q|0)!=(h|0))}m=Na+36|0;a=k[m>>2]|0;do if(a|0){Fa=a+12|0;e=k[Fa>>2]|0;k[Fa>>2]=e+-1;if((e|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Na+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;m=Na+4|0;k[ra>>2]=0;k[ra+4>>2]=0;k[ra+8>>2]=0;k[ra+12>>2]=0;if((k[m>>2]|0)>0){l=k[Na+40>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[Na+44>>2]|0;if(!((a|0)==(Na+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Oa+36|0;a=k[m>>2]|0;do if(a|0){e=a+12|0;Na=k[e>>2]|0;k[e>>2]=Na+-1;if((Na|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Oa+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;Oa=Oa+16|0;k[Oa>>2]=0;k[Oa+4>>2]=0;k[Oa+8>>2]=0;k[Oa+12>>2]=0;if((k[Ba>>2]|0)>0){l=k[za>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Ba>>2]|0))}a=k[Aa>>2]|0;if(!((a|0)==(Ca|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Pa+36|0;a=k[m>>2]|0;do if(a|0){Na=a+12|0;Oa=k[Na>>2]|0;k[Na>>2]=Oa+-1;if((Oa|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Pa+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;m=Pa+4|0;k[sa>>2]=0;k[sa+4>>2]=0;k[sa+8>>2]=0;k[sa+12>>2]=0;if((k[m>>2]|0)>0){l=k[ua>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[ta>>2]|0;if(!((a|0)==(Pa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Qa+36|0;a=k[m>>2]|0;do if(a|0){Oa=a+12|0;Pa=k[Oa>>2]|0;k[Oa>>2]=Pa+-1;if((Pa|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Qa+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;Pa=Qa+16|0;l=Qa+4|0;k[Pa>>2]=0;k[Pa+4>>2]=0;k[Pa+8>>2]=0;k[Pa+12>>2]=0;if((k[l>>2]|0)>0){m=k[Qa+40>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[Qa+44>>2]|0;if(!((a|0)==(Qa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Ra+36|0;a=k[m>>2]|0;do if(a|0){Pa=a+12|0;Qa=k[Pa>>2]|0;k[Pa>>2]=Qa+-1;if((Qa|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Ra+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;Ra=Ra+16|0;k[Ra>>2]=0;k[Ra+4>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;if((k[Ka>>2]|0)>0){l=k[Ja>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Ka>>2]|0))}a=k[La>>2]|0;if(!((a|0)==(Ma|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Sa+36|0;a=k[m>>2]|0;do if(a|0){Qa=a+12|0;Ra=k[Qa>>2]|0;k[Qa>>2]=Ra+-1;if((Ra|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Sa+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;Ra=Sa+16|0;l=Sa+4|0;k[Ra>>2]=0;k[Ra+4>>2]=0;k[Ra+8>>2]=0;k[Ra+12>>2]=0;if((k[l>>2]|0)>0){m=k[Sa+40>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[Sa+44>>2]|0;if(!((a|0)==(Sa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Ta+36|0;a=k[m>>2]|0;do if(a|0){Ra=a+12|0;Sa=k[Ra>>2]|0;k[Ra>>2]=Sa+-1;if((Sa|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Ta+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;m=Ta+4|0;k[Ia>>2]=0;k[Ia+4>>2]=0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;if((k[m>>2]|0)>0){l=k[Ta+40>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[Ta+44>>2]|0;if(!((a|0)==(Ta+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Ua+36|0;a=k[m>>2]|0;do if(a|0){Sa=a+12|0;Ta=k[Sa>>2]|0;k[Sa>>2]=Ta+-1;if((Ta|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Ua+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;m=Ua+4|0;k[Ha>>2]=0;k[Ha+4>>2]=0;k[Ha+8>>2]=0;k[Ha+12>>2]=0;if((k[m>>2]|0)>0){l=k[Ua+40>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[m>>2]|0))}a=k[Ua+44>>2]|0;if(!((a|0)==(Ua+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Va+36|0;a=k[m>>2]|0;do if(a|0){Ta=a+12|0;Ua=k[Ta>>2]|0;k[Ta>>2]=Ua+-1;if((Ua|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Va+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;k[Da>>2]=0;k[Da+4>>2]=0;k[Da+8>>2]=0;k[Da+12>>2]=0;if((k[Ga>>2]|0)>0){l=k[xa>>2]|0;a=0;do{k[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Ga>>2]|0))}a=k[va>>2]|0;if(!((a|0)==(Va+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);m=Wa+36|0;a=k[m>>2]|0;do if(a|0){Ua=a+12|0;Va=k[Ua>>2]|0;k[Ua>>2]=Va+-1;if((Va|0)!=1)break;l=k[m>>2]|0;if(l|0){a=k[l+4>>2]|0;do if(!a){a=k[Wa+32>>2]|0;if(a|0)break;a=B1()|0;l=k[m>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,l)}k[m>>2]=0}while(0);k[m>>2]=0;Va=Wa+16|0;l=Wa+4|0;k[Va>>2]=0;k[Va+4>>2]=0;k[Va+8>>2]=0;k[Va+12>>2]=0;if((k[l>>2]|0)>0){m=k[Wa+40>>2]|0;a=0;do{k[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[l>>2]|0))}a=k[Wa+44>>2]|0;if((a|0)==(Wa+48|0)|(a|0)==0){r=Xa;return}ggb(k[a+-4>>2]|0);r=Xa;return}function cva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a+8|0;d=a+40|0;e=a+4|0;f=e+36|0;do{k[e>>2]=0;e=e+4|0}while((e|0)<(f|0));k[d>>2]=c;f=a+48|0;k[a+44>>2]=f;k[a+52>>2]=0;k[f>>2]=0;k[a>>2]=1124007942;f=k[b>>2]|0;dh[k[(k[f>>2]|0)+12>>2]&255](f,b,a,6);return}function dva(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,q=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0.0,$=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0.0,hb=0.0,ib=0.0;fb=r;r=r+1216|0;Pa=fb+1152|0;Na=fb+1096|0;Ka=fb+328|0;Ja=fb+1040|0;Ca=fb+1024|0;Da=fb+1008|0;Ea=fb+992|0;Fa=fb+976|0;Ra=fb+256|0;Za=fb+184|0;_a=fb+72|0;Q=fb+944|0;W=fb+916|0;Ga=fb+888|0;ga=fb;za=fb+860|0;Aa=fb+832|0;eb=fb+776|0;db=fb+720|0;cb=fb+664|0;bb=fb+608|0;ab=fb+552|0;$a=fb+496|0;R=fb+468|0;L=fb+440|0;M=fb+412|0;N=fb+384|0;do if((k[a>>2]&2031616|0)==65536){j=k[a+4>>2]|0;k[eb>>2]=k[j>>2];q=eb+4|0;a=j+4|0;k[q>>2]=k[a>>2];Ya=eb+8|0;k[Ya>>2]=k[j+8>>2];k[eb+12>>2]=k[j+12>>2];k[eb+16>>2]=k[j+16>>2];k[eb+20>>2]=k[j+20>>2];k[eb+24>>2]=k[j+24>>2];k[eb+28>>2]=k[j+28>>2];k[eb+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[eb+36>>2]=g;h=eb+40|0;k[h>>2]=Ya;Ya=eb+48|0;m=eb+44|0;k[m>>2]=Ya;k[eb+52>>2]=0;k[Ya>>2]=0;if(g|0){Ya=g+12|0;k[Ya>>2]=(k[Ya>>2]|0)+1}if((k[a>>2]|0)<3){Xa=k[j+44>>2]|0;Ya=k[m>>2]|0;k[Ya>>2]=k[Xa>>2];k[Ya+4>>2]=k[Xa+4>>2];break}k[q>>2]=0;x1(eb,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(eb,a,-1);while(0);do if((k[c>>2]&2031616|0)==65536){j=k[c+4>>2]|0;k[db>>2]=k[j>>2];q=db+4|0;a=j+4|0;k[q>>2]=k[a>>2];Ya=db+8|0;k[Ya>>2]=k[j+8>>2];k[db+12>>2]=k[j+12>>2];k[db+16>>2]=k[j+16>>2];k[db+20>>2]=k[j+20>>2];k[db+24>>2]=k[j+24>>2];k[db+28>>2]=k[j+28>>2];k[db+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[db+36>>2]=g;h=db+40|0;k[h>>2]=Ya;Ya=db+48|0;m=db+44|0;k[m>>2]=Ya;k[db+52>>2]=0;k[Ya>>2]=0;if(g|0){Ya=g+12|0;k[Ya>>2]=(k[Ya>>2]|0)+1}if((k[a>>2]|0)<3){Xa=k[j+44>>2]|0;Ya=k[m>>2]|0;k[Ya>>2]=k[Xa>>2];k[Ya+4>>2]=k[Xa+4>>2];break}k[q>>2]=0;x1(db,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(db,c,-1);while(0);do if((k[d>>2]&2031616|0)==65536){j=k[d+4>>2]|0;k[cb>>2]=k[j>>2];q=cb+4|0;a=j+4|0;k[q>>2]=k[a>>2];Ya=cb+8|0;k[Ya>>2]=k[j+8>>2];k[cb+12>>2]=k[j+12>>2];k[cb+16>>2]=k[j+16>>2];k[cb+20>>2]=k[j+20>>2];k[cb+24>>2]=k[j+24>>2];k[cb+28>>2]=k[j+28>>2];k[cb+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[cb+36>>2]=g;h=cb+40|0;k[h>>2]=Ya;Ya=cb+48|0;m=cb+44|0;k[m>>2]=Ya;k[cb+52>>2]=0;k[Ya>>2]=0;if(g|0){Ya=g+12|0;k[Ya>>2]=(k[Ya>>2]|0)+1}if((k[a>>2]|0)<3){Xa=k[j+44>>2]|0;Ya=k[m>>2]|0;k[Ya>>2]=k[Xa>>2];k[Ya+4>>2]=k[Xa+4>>2];break}k[q>>2]=0;x1(cb,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(cb,d,-1);while(0);do if((k[e>>2]&2031616|0)==65536){j=k[e+4>>2]|0;k[bb>>2]=k[j>>2];q=bb+4|0;a=j+4|0;k[q>>2]=k[a>>2];Ya=bb+8|0;k[Ya>>2]=k[j+8>>2];k[bb+12>>2]=k[j+12>>2];k[bb+16>>2]=k[j+16>>2];k[bb+20>>2]=k[j+20>>2];k[bb+24>>2]=k[j+24>>2];k[bb+28>>2]=k[j+28>>2];k[bb+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[bb+36>>2]=g;h=bb+40|0;k[h>>2]=Ya;Ya=bb+48|0;m=bb+44|0;k[m>>2]=Ya;k[bb+52>>2]=0;k[Ya>>2]=0;if(g|0){Ya=g+12|0;k[Ya>>2]=(k[Ya>>2]|0)+1}if((k[a>>2]|0)<3){Xa=k[j+44>>2]|0;Ya=k[m>>2]|0;k[Ya>>2]=k[Xa>>2];k[Ya+4>>2]=k[Xa+4>>2];break}k[q>>2]=0;x1(bb,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(bb,e,-1);while(0);do if((k[f>>2]&2031616|0)==65536){j=k[f+4>>2]|0;k[ab>>2]=k[j>>2];q=ab+4|0;a=j+4|0;k[q>>2]=k[a>>2];Ya=ab+8|0;k[Ya>>2]=k[j+8>>2];k[ab+12>>2]=k[j+12>>2];k[ab+16>>2]=k[j+16>>2];k[ab+20>>2]=k[j+20>>2];k[ab+24>>2]=k[j+24>>2];k[ab+28>>2]=k[j+28>>2];k[ab+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[ab+36>>2]=g;h=ab+40|0;k[h>>2]=Ya;Ya=ab+48|0;m=ab+44|0;k[m>>2]=Ya;k[ab+52>>2]=0;k[Ya>>2]=0;if(g|0){Ya=g+12|0;k[Ya>>2]=(k[Ya>>2]|0)+1}if((k[a>>2]|0)<3){Xa=k[j+44>>2]|0;Ya=k[m>>2]|0;k[Ya>>2]=k[Xa>>2];k[Ya+4>>2]=k[Xa+4>>2];break}k[q>>2]=0;x1(ab,k[a>>2]|0,0,0,0);if((k[q>>2]|0)>0){n=k[j+40>>2]|0;l=k[h>>2]|0;h=k[j+44>>2]|0;g=k[m>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[n+(a<<2)>>2];k[g+(a<<2)>>2]=k[h+(a<<2)>>2];a=a+1|0}while((a|0)<(k[q>>2]|0))}}else Q1(ab,f,-1);while(0);a=k[eb>>2]|0;if((a&16384|0)!=0?((a&7)+-5|0)>>>0<2:0){if(!((a&4088|0)==8?(k[eb+8>>2]|0)==1:0)?(aa((a>>>3&511)+1|0,k[eb+12>>2]|0)|0)!=2:0)Ia=50}else Ia=50;if((Ia|0)==50){k[Pa>>2]=0;Ya=Pa+4|0;k[Ya>>2]=0;a=ZT(152)|0;k[a>>2]=1;Xa=a+4|0;k[Pa>>2]=Xa;k[Ya>>2]=146;i[a+150>>0]=0;upb(Xa|0,355885,146)|0;Y8(-215,Pa,356032,354470,423);k[Ya>>2]=0;k[Pa>>2]=0;Ya=k[a>>2]|0;k[a>>2]=Ya+-1;if((Ya|0)==1)ggb(k[a+-4>>2]|0);a=k[eb>>2]|0}Ya=eb+40|0;Wa=k[Ya>>2]|0;Xa=k[Wa+4>>2]|0;k[Pa>>2]=k[Wa>>2];k[Pa+4>>2]=Xa;P1(b,2,Pa,a&4095,-1,1,0);do if((k[b>>2]&2031616|0)==65536){j=k[b+4>>2]|0;k[$a>>2]=k[j>>2];n=$a+4|0;a=j+4|0;k[n>>2]=k[a>>2];e=$a+8|0;k[e>>2]=k[j+8>>2];q=$a+12|0;k[q>>2]=k[j+12>>2];c=$a+16|0;k[c>>2]=k[j+16>>2];k[$a+20>>2]=k[j+20>>2];k[$a+24>>2]=k[j+24>>2];k[$a+28>>2]=k[j+28>>2];k[$a+32>>2]=k[j+32>>2];g=k[j+36>>2]|0;k[$a+36>>2]=g;h=$a+40|0;k[h>>2]=e;Xa=$a+48|0;d=$a+44|0;k[d>>2]=Xa;k[$a+52>>2]=0;k[Xa>>2]=0;if(g|0){Xa=g+12|0;k[Xa>>2]=(k[Xa>>2]|0)+1}if((k[a>>2]|0)<3){Ma=k[j+44>>2]|0;g=k[d>>2]|0;k[g>>2]=k[Ma>>2];k[g+4>>2]=k[Ma+4>>2];g=$a;Ma=c;h=c;a=e;break}k[n>>2]=0;x1($a,k[a>>2]|0,0,0,0);if((k[n>>2]|0)>0){m=k[j+40>>2]|0;l=k[h>>2]|0;g=k[j+44>>2]|0;h=k[d>>2]|0;a=0;do{k[l+(a<<2)>>2]=k[m+(a<<2)>>2];k[h+(a<<2)>>2]=k[g+(a<<2)>>2];a=a+1|0}while((a|0)<(k[n>>2]|0));g=$a;Ma=c;h=c;a=e}else{g=$a;Ma=c;h=c;a=e}}else{Q1($a,b,-1);h=$a+16|0;n=$a+4|0;q=$a+12|0;g=$a;Ma=h;d=$a+44|0;a=$a+8|0}while(0);ta=k[eb+8>>2]|0;Wa=eb+4|0;ua=(k[Wa>>2]|0)==1?1:k[eb+12>>2]|0;va=k[eb>>2]|0;Va=eb+16|0;Z=k[Va>>2]|0;Xa=eb+44|0;da=k[k[Xa>>2]>>2]|0;ia=k[a>>2]|0;K=(k[n>>2]|0)==1?1:k[q>>2]|0;xa=k[g>>2]|0;X=k[h>>2]|0;ca=k[k[d>>2]>>2]|0;b=k[db+8>>2]|0;Ta=db+4|0;Ua=(k[Ta>>2]|0)==1?1:k[db+12>>2]|0;a=k[db>>2]|0;Qa=a&4095;Sa=db+16|0;f=k[Sa>>2]|0;e=aa((a>>>3&511)+1<<(47696>>>(Qa<<1&14)&3),Ua)|0;k[R>>2]=Qa|1111638016;Qa=R+4|0;k[Qa>>2]=e;k[R+8>>2]=0;k[R+12>>2]=0;e=R+16|0;k[e>>2]=f;f=R+20|0;k[f>>2]=b;b=R+24|0;k[b>>2]=Ua;Ua=db+44|0;k[Qa>>2]=k[k[Ua>>2]>>2];a=a&20479|1111621632;k[R>>2]=a;Qa=bb+16|0;Oa=k[Qa>>2]|0;l=Oa;if(Oa){m=k[bb+4>>2]|0;if((m|0)<3)g=aa(k[bb+12>>2]|0,k[bb+8>>2]|0)|0;else{j=k[bb+40>>2]|0;h=0;g=1;do{g=aa(k[j+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(m|0))}if(g){La=k[bb+8>>2]|0;Oa=(m|0)==1?1:k[bb+12>>2]|0;ja=k[k[bb+44>>2]>>2]|0;k[L>>2]=k[bb>>2]&20479|1111621632;k[L+4>>2]=ja;k[L+8>>2]=0;k[L+12>>2]=0;k[L+16>>2]=l;k[L+20>>2]=La;k[L+24>>2]=Oa}else L=0}else L=0;La=ab+16|0;Oa=k[La>>2]|0;l=Oa;if(Oa){m=k[ab+4>>2]|0;if((m|0)<3)g=aa(k[ab+12>>2]|0,k[ab+8>>2]|0)|0;else{j=k[ab+40>>2]|0;h=0;g=1;do{g=aa(k[j+(h<<2)>>2]|0,g)|0;h=h+1|0}while((h|0)!=(m|0))}if(g){Oa=k[ab+8>>2]|0;g=(m|0)==1?1:k[ab+12>>2]|0;ja=k[k[ab+44>>2]>>2]|0;k[M>>2]=k[ab>>2]&20479|1111621632;k[M+4>>2]=ja;k[M+8>>2]=0;k[M+12>>2]=0;k[M+16>>2]=l;k[M+20>>2]=Oa;k[M+24>>2]=g;g=M}else g=0}else g=0;Oa=cb+16|0;ja=k[Oa>>2]|0;m=ja;if(ja){q=k[cb+4>>2]|0;if((q|0)<3)h=aa(k[cb+12>>2]|0,k[cb+8>>2]|0)|0;else{l=k[cb+40>>2]|0;j=0;h=1;do{h=aa(k[l+(j<<2)>>2]|0,h)|0;j=j+1|0}while((j|0)!=(q|0))}if(h){ja=k[cb+8>>2]|0;l=(q|0)==1?1:k[cb+12>>2]|0;M=k[k[cb+44>>2]>>2]|0;k[N>>2]=k[cb>>2]&20479|1111621632;k[N+4>>2]=M;k[N+8>>2]=0;k[N+12>>2]=0;k[N+16>>2]=m;k[N+20>>2]=ja;k[N+24>>2]=l;l=N}else l=0}else l=0;m=_a;c=m+112|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(c|0));k[Q>>2]=1111638022;k[Q+24>>2]=3;k[Q+20>>2]=3;k[Q+4>>2]=24;k[Q+16>>2]=Ra;k[Q+8>>2]=0;k[Q+12>>2]=0;k[Ga>>2]=1111638022;k[Ga+24>>2]=3;k[Ga+20>>2]=3;k[Ga+4>>2]=24;k[Ga+16>>2]=Za;k[Ga+8>>2]=0;k[Ga+12>>2]=0;if(!(((((!((X|0)==0|(K|0)>0&(((ta|0)<1|(ua|0)<1|(Z|0)==0)^1)&(ia|0)>0^1)?(ua|0)==1|(ta|0)==1:0)?(K|0)==1|(ia|0)==1:0)?(ta+ua|0)==(K+ia|0):0)?((va&4095)+-13|0)>>>0<2:0)?((xa&4095)+-13|0)>>>0<2:0)){k[Pa>>2]=0;ja=Pa+4|0;k[ja>>2]=0;a=ZT(344)|0;k[a>>2]=1;N=a+4|0;k[Pa>>2]=N;k[ja>>2]=336;i[a+340>>0]=0;upb(N|0,355019,336)|0;Y8(-215,Pa,355356,354470,298);k[ja>>2]=0;k[Pa>>2]=0;ja=k[a>>2]|0;k[a>>2]=ja+-1;if((ja|0)==1)ggb(k[a+-4>>2]|0);a=k[R>>2]|0}if(!((((a&-65536|0)==1111621632?(O=k[b>>2]|0,(O|0)>0):0)?(P=k[f>>2]|0,(P|0)>0):0)?(O|0)==3&((P|0)==3&(k[e>>2]|0)!=0):0)){k[Pa>>2]=0;a=Pa+4|0;k[a>>2]=0;h=ZT(88)|0;k[h>>2]=1;m=h+4|0;k[Pa>>2]=m;k[a>>2]=80;i[h+84>>0]=0;j=355374;c=m+80|0;do{i[m>>0]=i[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(c|0));Y8(-215,Pa,355356,354470,301);k[a>>2]=0;k[Pa>>2]=0;ja=k[h>>2]|0;k[h>>2]=ja+-1;if((ja|0)==1)ggb(k[h+-4>>2]|0)}aY(R,Q);if(l){a=k[l>>2]|0;if(((((a&-65536|0)==1111621632?(U=k[l+24>>2]|0,(U|0)>0):0)?(V=k[l+20>>2]|0,(V|0)>0):0)?(k[l+16>>2]|0)!=0:0)?(U|0)==1|(V|0)==1:0)switch(aa(V,U)|0){case 14:case 12:case 8:case 5:case 4:{j=U;h=V;break}default:Ia=106}else Ia=106;if((Ia|0)==106){k[Pa>>2]=0;ja=Pa+4|0;k[ja>>2]=0;a=ZT(308)|0;k[a>>2]=1;V=a+4|0;k[Pa>>2]=V;k[ja>>2]=300;i[a+304>>0]=0;upb(V|0,355455,300)|0;Y8(-215,Pa,355356,354470,313);k[ja>>2]=0;k[Pa>>2]=0;ja=k[a>>2]|0;k[a>>2]=ja+-1;if((ja|0)==1)ggb(k[a+-4>>2]|0);a=k[l>>2]|0;j=k[l+24>>2]|0;h=k[l+20>>2]|0}V=a&4088;ja=aa(V+8|0,j)|0;k[W>>2]=V|1111638022;k[W+4>>2]=ja;k[W+8>>2]=0;k[W+12>>2]=0;k[W+16>>2]=_a;k[W+20>>2]=h;k[W+24>>2]=j;aY(l,W);t=+p[_a+96>>3];s=+p[_a+104>>3];if(t!=0.0|s!=0.0){$=+S(+t);H=+T(+t);sa=+S(+s);_=+T(+s);I=_*0.0;ba=sa+0.0-I;ma=sa*0.0;qa=ma+0.0;Y=$*0.0;na=H*_+(Y+qa);ra=H*0.0;qa=ra+qa-$*_;oa=$+0.0-ra;J=Y+(H+0.0);_=ma+(_+0.0);I=I+0.0;H=Y+I-H*sa;I=$*sa+(ra+I);ra=1.0/I;sa=qa*ra;$=J*ra;Y=_*0.0;ma=H*0.0;pa=I*0.0;ja=5;ka=Y+(ba*ra+0.0);la=ma+(oa*0.0+(na*ra+0.0));ma=ma+(na*0.0+0.0+oa*ra);na=H+(oa*$+(na*sa+0.0));oa=pa+(J*0.0+(sa+0.0));pa=pa+(qa*0.0+0.0+$);qa=I+(J*$+(qa*sa+0.0));ra=Y+(ba*0.0+0.0+ra*0.0);sa=_+($*0.0+(ba*sa+0.0))}else{ja=5;ka=1.0;la=0.0;ma=1.0;na=0.0;oa=0.0;pa=0.0;qa=1.0;ra=0.0;sa=0.0}}else{ja=1;ka=1.0;la=0.0;ma=1.0;na=0.0;oa=0.0;pa=0.0;qa=1.0;ra=0.0;sa=0.0}if(!L){M1(Pa,Ga,0,0,0,0);j=Na+4|0;a=j+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Na>>2]=50397184;k[j>>2]=Pa;p[Ka>>3]=1.0;j=Ka+8|0;k[j>>2]=0;k[j+4>>2]=0;k[j+8>>2]=0;k[j+12>>2]=0;k[j+16>>2]=0;k[j+20>>2]=0;R2(Na,Ka);j=Pa+36|0;a=k[j>>2]|0;if(a|0?(ea=a+12|0,fa=k[ea>>2]|0,k[ea>>2]=fa+-1,(fa|0)==1):0){h=k[j>>2]|0;if(h|0){a=k[h+4>>2]|0;do if(!a){a=k[Pa+32>>2]|0;if(a|0)break;a=B1()|0;h=k[j>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,h)}k[j>>2]=0}k[j>>2]=0;fa=Pa+16|0;h=Pa+4|0;k[fa>>2]=0;k[fa+4>>2]=0;k[fa+8>>2]=0;k[fa+12>>2]=0;if((k[h>>2]|0)>0){j=k[Pa+40>>2]|0;a=0;do{k[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[Pa+44>>2]|0;if(!((a|0)==(Pa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}else{if(!((((k[L>>2]&-65536|0)==1111621632?(ea=k[L+24>>2]|0,(ea|0)>0):0)?(fa=k[L+20>>2]|0,(fa|0)>0):0)?(ea|0)==3&((fa|0)==3&(k[L+16>>2]|0)!=0):0)){k[Pa>>2]=0;a=Pa+4|0;k[a>>2]=0;h=ZT(60)|0;k[h>>2]=1;m=h+4|0;k[Pa>>2]=m;k[a>>2]=53;i[h+57>>0]=0;j=355756;c=m+53|0;do{i[m>>0]=i[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(c|0));Y8(-215,Pa,355356,354470,326);k[a>>2]=0;k[Pa>>2]=0;fa=k[h>>2]|0;k[h>>2]=fa+-1;if((fa|0)==1)ggb(k[h+-4>>2]|0)}aY(L,Ga)}if(g|0){k[Aa>>2]=1111638022;k[Aa+24>>2]=3;k[Aa+20>>2]=3;k[Aa+4>>2]=24;k[Aa+16>>2]=ga;k[Aa+8>>2]=0;k[Aa+12>>2]=0;a=k[g>>2]|0;if(!((((a&-65536|0)==1111621632?(ha=k[g+24>>2]|0,(ha|0)>0):0)?(wa=k[g+20>>2]|0,(wa|0)>0):0)?(ha+-3|0)>>>0<2&((wa|0)==3&(k[g+16>>2]|0)!=0):0)){k[Pa>>2]=0;a=Pa+4|0;k[a>>2]=0;h=ZT(80)|0;k[h>>2]=1;m=h+4|0;k[Pa>>2]=m;k[a>>2]=74;i[h+78>>0]=0;j=355810;c=m+74|0;do{i[m>>0]=i[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(c|0));Y8(-215,Pa,355356,354470,336);k[a>>2]=0;k[Pa>>2]=0;wa=k[h>>2]|0;k[h>>2]=wa+-1;if((wa|0)==1)ggb(k[h+-4>>2]|0);a=k[g>>2]|0}do if((a&-65536|0)==1111621632?(ya=k[g+24>>2]|0,(ya|0)>0):0){if((k[g+20>>2]|0)<=0){Ia=146;break}if(k[g+16>>2]|0)a=ya;else Ia=146}else Ia=146;while(0);if((Ia|0)==146){a=G9(g,Pa,0,0)|0;g=a;a=k[a+24>>2]|0}if(a>>>0<3?(k[Na>>2]=0,ya=Na+4|0,k[ya>>2]=0,Ba=ZT(8)|0,k[Ba>>2]=1,wa=Ba+4|0,k[Na>>2]=wa,k[ya>>2]=0,i[wa>>0]=0,Y8(-211,Na,235092,233613,1367),k[ya>>2]=0,k[Na>>2]=0,ya=k[Ba>>2]|0,k[Ba>>2]=ya+-1,(ya|0)==1):0)ggb(k[Ba+-4>>2]|0);l=k[g+20>>2]|0;k[za+20>>2]=l;k[za+24>>2]=3;k[za+4>>2]=k[g+4>>2];q=k[g>>2]|0;k[za+16>>2]=k[g+16>>2];k[za>>2]=((l|0)>1&(a|0)>3?-16385:-1)&q;k[za+8>>2]=0;k[za+12>>2]=0;aY(za,Aa);M1(Pa,Aa,0,1,0,0);M1(Na,Ga,0,1,0,0);k[Ka>>2]=1124007936;q=Ka+4|0;a=Ka+8|0;l=Ka+40|0;m=q;c=m+36|0;do{k[m>>2]=0;m=m+4|0}while((m|0)<(c|0));k[l>>2]=a;m=Ka+48|0;j=Ka+44|0;k[j>>2]=m;k[Ka+52>>2]=0;k[m>>2]=0;M1(Ja,Ga,0,1,0,0);do if((k[Ja+8>>2]|0)==(k[Pa+8>>2]|0)){if((k[Ja+12>>2]|0)!=(k[Na+12>>2]|0)){Ia=154;break}if((k[Pa>>2]^k[Ja>>2])&4095|0)Ia=154}else Ia=154;while(0);if((Ia|0)==154?(k[Ca>>2]=0,Ia=Ca+4|0,k[Ia>>2]=0,Ha=ZT(152)|0,k[Ha>>2]=1,Ga=Ha+4|0,k[Ca>>2]=Ga,k[Ia>>2]=144,i[Ha+148>>0]=0,upb(Ga|0,216395,144)|0,Y8(-215,Ca,216540,215417,3282),k[Ia>>2]=0,k[Ca>>2]=0,Ia=k[Ha>>2]|0,k[Ha>>2]=Ia+-1,(Ia|0)==1):0)ggb(k[Ha+-4>>2]|0);k[Ca+8>>2]=0;k[Ca+12>>2]=0;k[Ca>>2]=16842752;k[Ca+4>>2]=Pa;k[Da+8>>2]=0;k[Da+12>>2]=0;k[Da>>2]=16842752;k[Da+4>>2]=Na;k[Ea+8>>2]=0;k[Ea+12>>2]=0;k[Ea>>2]=16842752;k[Ea+4>>2]=Ka;h=Fa+4|0;a=h+4|0;k[a>>2]=0;k[a+4>>2]=0;k[Fa>>2]=33619968;k[h>>2]=Ja;s_(Ca,Da,1.0,Ea,1.0,Fa,0);h=Ja+36|0;a=k[h>>2]|0;do if(a|0){Ha=a+12|0;Ia=k[Ha>>2]|0;k[Ha>>2]=Ia+-1;if((Ia|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[Ja+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;Ia=Ja+16|0;g=Ja+4|0;k[Ia>>2]=0;k[Ia+4>>2]=0;k[Ia+8>>2]=0;k[Ia+12>>2]=0;if((k[g>>2]|0)>0){h=k[Ja+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[Ja+44>>2]|0;if(!((a|0)==(Ja+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=Ka+36|0;a=k[h>>2]|0;do if(a|0){Ia=a+12|0;Ja=k[Ia>>2]|0;k[Ia>>2]=Ja+-1;if((Ja|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[Ka+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;Ka=Ka+16|0;k[Ka>>2]=0;k[Ka+4>>2]=0;k[Ka+8>>2]=0;k[Ka+12>>2]=0;if((k[q>>2]|0)>0){g=k[l>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[q>>2]|0))}a=k[j>>2]|0;if(!((a|0)==(m|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=Na+36|0;a=k[h>>2]|0;do if(a|0){Ja=a+12|0;Ka=k[Ja>>2]|0;k[Ja>>2]=Ka+-1;if((Ka|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[Na+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;Ka=Na+16|0;g=Na+4|0;k[Ka>>2]=0;k[Ka+4>>2]=0;k[Ka+8>>2]=0;k[Ka+12>>2]=0;if((k[g>>2]|0)>0){h=k[Na+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[Na+44>>2]|0;if(!((a|0)==(Na+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=Pa+36|0;a=k[h>>2]|0;do if(a|0){Ka=a+12|0;Na=k[Ka>>2]|0;k[Ka>>2]=Na+-1;if((Na|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[Pa+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;Na=Pa+16|0;g=Pa+4|0;k[Na>>2]=0;k[Na+4>>2]=0;k[Na+8>>2]=0;k[Na+12>>2]=0;if((k[g>>2]|0)>0){h=k[Pa+40>>2]|0;a=0;do{k[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[g>>2]|0))}a=k[Pa+44>>2]|0;if(!((a|0)==(Pa+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0)}ha=Z;fa=Z;ga=X;ea=X;if((ta|0)==1)da=1;else da=(da|0)/((va>>>3&511)+1<<(47696>>>(va<<1&14)&3)|0)|0;if((ia|0)==1)ca=1;else ca=(ca|0)/((xa>>>3&511)+1<<(47696>>>(xa<<1&14)&3)|0)|0;Z=ta+-1+ua|0;_=1.0/+p[Ra>>3];$=1.0/+p[Ra+32>>3];ba=+p[Ra+16>>3];Y=+p[Ra+40>>3];if((Z|0)>0){j=(va&4095|0)==13;l=_a+56|0;m=_a+48|0;q=_a+40|0;c=_a+32|0;e=_a+8|0;f=_a+16|0;b=_a+24|0;K=_a+64|0;L=_a+72|0;M=_a+80|0;N=_a+88|0;O=Za+8|0;P=Za+16|0;Q=Za+24|0;R=Za+32|0;U=Za+40|0;V=Za+48|0;W=Za+56|0;X=Za+64|0;h=(xa&4095|0)==13;g=0;do{a=aa(g,da)|0;if(j){t=+o[ha+(a<<3)>>2];s=+o[ha+(a<<3)+4>>2]}else{t=+p[fa+(a<<4)>>3];s=+p[fa+(a<<4)+8>>3]}u=_*(t-ba);v=$*(s-Y);t=qa+(pa*v+(oa*u+0.0));t=t!=0.0?1.0/t:1.0;s=(sa+(ra*v+(ka*u+0.0)))*t;t=(na+(ma*v+(la*u+0.0)))*t;u=+p[l>>3];v=+p[m>>3];w=+p[q>>3];x=+p[c>>3];y=+p[e>>3];z=+p[_a>>3];A=+p[f>>3];B=A*2.0;C=+p[b>>3];D=+p[K>>3];E=+p[L>>3];F=C*2.0;G=+p[M>>3];H=+p[N>>3];a=0;I=t;J=s;do{gb=I*I+J*J;ib=(gb*(w+gb*(gb*u+v))+1.0)/(gb*(z+gb*(gb*x+y))+1.0);hb=J;J=ib*(s-(gb*D+((gb+J*(J*2.0))*C+I*(J*B))+gb*(gb*E)));I=ib*(t-((I*(I*2.0)+gb)*A+I*(hb*F)+gb*G+gb*(gb*H)));a=a+1|0}while((a|0)<(ja|0));s=1.0/(+p[X>>3]+(J*+p[V>>3]+I*+p[W>>3]));t=(+p[P>>3]+(J*+p[Za>>3]+I*+p[O>>3]))*s;s=(+p[U>>3]+(J*+p[Q>>3]+I*+p[R>>3]))*s;if(h){Ra=aa(g,ca)|0;o[ga+(Ra<<3)>>2]=t;o[ga+(Ra<<3)+4>>2]=s}else{Ra=aa(g,ca)|0;p[ea+(Ra<<4)>>3]=t;p[ea+(Ra<<4)+8>>3]=s}g=g+1|0}while((g|0)!=(Z|0))}h=$a+36|0;a=k[h>>2]|0;do if(a|0){Za=a+12|0;_a=k[Za>>2]|0;k[Za>>2]=_a+-1;if((_a|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[$a+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;k[Ma>>2]=0;k[Ma+4>>2]=0;k[Ma+8>>2]=0;k[Ma+12>>2]=0;if((k[n>>2]|0)>0){g=k[$a+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[n>>2]|0))}a=k[d>>2]|0;if(!((a|0)==($a+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=ab+36|0;a=k[h>>2]|0;do if(a|0){_a=a+12|0;$a=k[_a>>2]|0;k[_a>>2]=$a+-1;if(($a|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[ab+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;h=ab+4|0;k[La>>2]=0;k[La+4>>2]=0;k[La+8>>2]=0;k[La+12>>2]=0;if((k[h>>2]|0)>0){g=k[ab+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[ab+44>>2]|0;if(!((a|0)==(ab+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=bb+36|0;a=k[h>>2]|0;do if(a|0){$a=a+12|0;ab=k[$a>>2]|0;k[$a>>2]=ab+-1;if((ab|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[bb+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;h=bb+4|0;k[Qa>>2]=0;k[Qa+4>>2]=0;k[Qa+8>>2]=0;k[Qa+12>>2]=0;if((k[h>>2]|0)>0){g=k[bb+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[bb+44>>2]|0;if(!((a|0)==(bb+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=cb+36|0;a=k[h>>2]|0;do if(a|0){ab=a+12|0;bb=k[ab>>2]|0;k[ab>>2]=bb+-1;if((bb|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[cb+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;h=cb+4|0;k[Oa>>2]=0;k[Oa+4>>2]=0;k[Oa+8>>2]=0;k[Oa+12>>2]=0;if((k[h>>2]|0)>0){g=k[cb+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[h>>2]|0))}a=k[cb+44>>2]|0;if(!((a|0)==(cb+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=db+36|0;a=k[h>>2]|0;do if(a|0){bb=a+12|0;cb=k[bb>>2]|0;k[bb>>2]=cb+-1;if((cb|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[db+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;k[Sa>>2]=0;k[Sa+4>>2]=0;k[Sa+8>>2]=0;k[Sa+12>>2]=0;if((k[Ta>>2]|0)>0){g=k[db+40>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Ta>>2]|0))}a=k[Ua>>2]|0;if(!((a|0)==(db+48|0)|(a|0)==0))ggb(k[a+-4>>2]|0);h=eb+36|0;a=k[h>>2]|0;do if(a|0){cb=a+12|0;db=k[cb>>2]|0;k[cb>>2]=db+-1;if((db|0)!=1)break;g=k[h>>2]|0;if(g|0){a=k[g+4>>2]|0;do if(!a){a=k[eb+32>>2]|0;if(a|0)break;a=B1()|0;g=k[h>>2]|0}while(0);jh[k[(k[a>>2]|0)+24>>2]&1023](a,g)}k[h>>2]=0}while(0);k[h>>2]=0;k[Va>>2]=0;k[Va+4>>2]=0;k[Va+8>>2]=0;k[Va+12>>2]=0;if((k[Wa>>2]|0)>0){g=k[Ya>>2]|0;a=0;do{k[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(k[Wa>>2]|0))}a=k[Xa>>2]|0;if((a|0)==(eb+48|0)|(a|0)==0){r=fb;return}ggb(k[a+-4>>2]|0);r=fb;return}function eva(a,b,c,d,e,f){a=a|0;b=+b;c=+c;d=+d;e=e|0;f=f|0;var g=0,h=0,j=0,l=0.0,m=0.0,n=0.0,q=0.0,s=0.0,t=0,u=0,v=0.0;u=r;r=r+16|0;t=u;m=b*b+c*c+1.0;l=1.0/m;m=(d*2.0+1.0)*m;q=+Q(+(d*d+m));s=q-d;n=l*s;s=l*(l*(m/q-s*2.0));q=b*s;s=c*s;switch(f|0){case 0:{if(e|0){p[e>>3]=n+b*q;p[e+8>>3]=c*q;p[e+16>>3]=b*s;p[e+24>>3]=n+c*s}o[a>>2]=b*n;o[a+4>>2]=c*n;r=u;return}case 1:{m=1.0/(d+1.0);l=m*(b*n);l=l>1.0?1.0:l;l=l<-1.0?-1.0:l;d=m*(c*n);d=d>1.0?1.0:d;d=d<-1.0?-1.0:d;if(e|0){v=m/+Q(+(1.0-l*l));m=m/+Q(+(1.0-d*d));p[e>>3]=(n+b*q)*v;p[e+8>>3]=b*(s*v);p[e+16>>3]=c*(q*m);p[e+24>>3]=(n+c*s)*m}s=+W(+l);v=+W(+d);o[a>>2]=s;o[a+4>>2]=v;r=u;return}default:{f=t+4|0;e=ZT(28)|0;k[e>>2]=1;g=e+4|0;k[t>>2]=g;k[f>>2]=23;i[e+27>>0]=0;h=356257;j=g+23|0;do{i[g>>0]=i[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Y8(-5,t,356281,354470,474);k[f>>2]=0;k[t>>2]=0;t=k[e>>2]|0;k[e>>2]=t+-1;if((t|0)==1)ggb(k[e+-4>>2]|0);o[a>>2]=0.0;o[a+4>>2]=0.0;r=u;return}}}function fva(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0,h=0;g=r;r=r+16|0;f=g;k[206763]=0;k[206764]=0;k[206765]=0;k[206766]=0;k[206767]=0;k[206768]=0;while(1){a=fgb(1172)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}Sva(a);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89352;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206764]|0;if((a|0)==(k[206765]|0))hva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206764]|0}k[206764]=a+8}a=k[f>>2]|0;if(a|0?(h=a+4|0,c=k[h>>2]|0,k[h>>2]=c+-1,(c|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);while(1){a=fgb(36)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}Yva(a);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89372;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206767]|0;if((a|0)==(k[206768]|0))iva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206767]|0}k[206767]=a+8}a=k[f>>2]|0;if(a|0?(c=a+4|0,h=k[c>>2]|0,k[c>>2]=h+-1,(h|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);while(1){a=fgb(108)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}ewa(a);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89392;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206764]|0;if((a|0)==(k[206765]|0))hva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206764]|0}k[206764]=a+8}a=k[f>>2]|0;if(a|0?(c=a+4|0,h=k[c>>2]|0,k[c>>2]=h+-1,(h|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);while(1){a=fgb(36)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}kwa(a);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89412;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206767]|0;if((a|0)==(k[206768]|0))iva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206767]|0}k[206767]=a+8}a=k[f>>2]|0;if(a|0?(c=a+4|0,h=k[c>>2]|0,k[c>>2]=h+-1,(h|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);while(1){a=fgb(108)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}b=a+20|0;k[b>>2]=0;k[b+4>>2]=0;k[a+36>>2]=1124007936;b=a+44|0;c=a+76|0;d=a+40|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;h=a+84|0;k[a+80>>2]=h;k[a+88>>2]=0;k[h>>2]=0;k[a+8>>2]=0;k[a+4>>2]=0;k[a+12>>2]=-1;h=a+92|0;i[h>>0]=0;k[a+16>>2]=1;k[a>>2]=89812;e=a+28|0;c=a+32|0;k[c>>2]=0;k[e>>2]=0;d=ZT(8)|0;k[d>>2]=1;k[e>>2]=d+4;k[c>>2]=3;i[d+7>>0]=0;e=k[e>>2]|0;i[e>>0]=i[358293]|0;i[e+1>>0]=i[358294]|0;i[e+2>>0]=i[358295]|0;k[a+100>>2]=0;k[a+96>>2]=0;i[h>>0]=1;k[a+104>>2]=1;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89432;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206764]|0;if((a|0)==(k[206765]|0))hva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206764]|0}k[206764]=a+8}a=k[f>>2]|0;if(a|0?(c=a+4|0,h=k[c>>2]|0,k[c>>2]=h+-1,(h|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);while(1){a=fgb(36)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}zwa(a);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89452;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206767]|0;if((a|0)==(k[206768]|0))iva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206767]|0}k[206767]=a+8}a=k[f>>2]|0;if(a|0?(c=a+4|0,h=k[c>>2]|0,k[c>>2]=h+-1,(h|0)==1):0)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);while(1){a=fgb(1176)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}ixa(a);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89472;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206764]|0;if((a|0)==(k[206765]|0))hva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206764]|0}k[206764]=a+8}a=k[f>>2]|0;do if(a|0){c=a+4|0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a)}while(0);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);while(1){a=fgb(36)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}nxa(a);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89492;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206767]|0;if((a|0)==(k[206768]|0))iva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206767]|0}k[206767]=a+8}a=k[f>>2]|0;do if(a|0){c=a+4|0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a)}while(0);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);while(1){a=fgb(1172)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}b=a+20|0;k[b>>2]=0;k[b+4>>2]=0;k[b+8>>2]=0;k[b+12>>2]=0;k[a+36>>2]=1124007936;b=a+44|0;c=a+76|0;d=a+40|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;h=a+84|0;k[a+80>>2]=h;k[a+88>>2]=0;k[h>>2]=0;k[a+8>>2]=0;k[a+4>>2]=0;k[a+12>>2]=-1;k[a+16>>2]=1;k[a>>2]=90012;h=a+104|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;k[h+12>>2]=0;k[a+120>>2]=32768;i[a+128>>0]=0;i[a+100>>0]=0;k[a+96>>2]=90336;k[a+1160>>2]=-1;i[a+92>>0]=1;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89512;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206764]|0;if((a|0)==(k[206765]|0))hva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206764]|0}k[206764]=a+8}a=k[f>>2]|0;do if(a|0){c=a+4|0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a)}while(0);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);while(1){a=fgb(36)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}cxa(a);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89532;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206767]|0;if((a|0)==(k[206768]|0))iva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206767]|0}k[206767]=a+8}a=k[f>>2]|0;do if(a|0){c=a+4|0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a)}while(0);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);while(1){a=fgb(36)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}txa(a);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89552;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206767]|0;if((a|0)==(k[206768]|0))iva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206767]|0}k[206767]=a+8}a=k[f>>2]|0;do if(a|0){c=a+4|0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a)}while(0);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);while(1){a=fgb(124)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}b=a+20|0;k[b>>2]=0;k[b+4>>2]=0;k[a+36>>2]=1124007936;b=a+44|0;c=a+76|0;d=a+40|0;e=d+36|0;do{k[d>>2]=0;d=d+4|0}while((d|0)<(e|0));k[c>>2]=b;h=a+84|0;k[a+80>>2]=h;k[a+88>>2]=0;k[h>>2]=0;k[a+8>>2]=0;k[a+4>>2]=0;k[a+12>>2]=-1;h=a+92|0;i[h>>0]=0;k[a+16>>2]=1;k[a>>2]=89912;e=a+28|0;c=a+32|0;k[c>>2]=0;k[e>>2]=0;d=ZT(16)|0;k[d>>2]=1;k[e>>2]=d+4;k[c>>2]=8;i[d+12>>0]=0;e=k[e>>2]|0;d=e;i[d>>0]=137;i[d+1>>0]=80;i[d+2>>0]=78;i[d+3>>0]=71;e=e+4|0;i[e>>0]=13;i[e+1>>0]=10;i[e+2>>0]=26;i[e+3>>0]=10;e=a+100|0;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;k[e+12>>2]=0;k[e+16>>2]=0;i[h>>0]=1;k[a+120>>2]=0;while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89572;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206764]|0;if((a|0)==(k[206765]|0))hva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206764]|0}k[206764]=a+8}a=k[f>>2]|0;do if(a|0){c=a+4|0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a)}while(0);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)==1)Uh[k[(k[b>>2]|0)+8>>2]&2047](b);while(1){a=fgb(36)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}Owa(a);while(1){b=fgb(16)|0;if(b|0)break;b=k[207666]|0;k[207666]=b+0;if(!b){b=0;break}Qh[b&7]()}d=b+4|0;k[d>>2]=1;k[b>>2]=89592;k[b+8>>2]=a;k[f>>2]=b;e=f+4|0;k[e>>2]=a;k[d>>2]=(k[d>>2]|0)+1;a=k[206767]|0;if((a|0)==(k[206768]|0))iva(f);else{c=k[f>>2]|0;k[a>>2]=c;k[a+4>>2]=k[e>>2];if(c){a=c+4|0;k[a>>2]=(k[a>>2]|0)+1;a=k[206767]|0}k[206767]=a+8}a=k[f>>2]|0;do if(a|0){c=a+4|0;h=k[c>>2]|0;k[c>>2]=h+-1;if((h|0)!=1)break;Uh[k[(k[a>>2]|0)+8>>2]&2047](a)}while(0);k[f>>2]=0;k[e>>2]=0;h=k[d>>2]|0;k[d>>2]=h+-1;if((h|0)!=1){ud(1458,827052,x|0)|0;r=g;return}Uh[k[(k[b>>2]|0)+8>>2]&2047](b);ud(1458,827052,x|0)|0;r=g;return}function gva(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;f=a+12|0;b=k[f>>2]|0;if(b|0){g=a+16|0;c=k[g>>2]|0;if((c|0)!=(b|0)){do{d=c+-8|0;k[g>>2]=d;e=k[d>>2]|0;if(e|0?(i=e+4|0,h=k[i>>2]|0,k[i>>2]=h+-1,(h|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);k[d>>2]=0;k[c+-4>>2]=0;c=k[g>>2]|0}while((c|0)!=(b|0));b=k[f>>2]|0}ggb(b)}b=k[a>>2]|0;if(!b)return;f=a+4|0;c=k[f>>2]|0;if((c|0)!=(b|0)){do{d=c+-8|0;k[f>>2]=d;e=k[d>>2]|0;if(e|0?(h=e+4|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0)Uh[k[(k[e>>2]|0)+8>>2]&2047](e);k[d>>2]=0;k[c+-4>>2]=0;c=k[f>>2]|0}while((c|0)!=(b|0));b=k[a>>2]|0}ggb(b);return}function hva(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;b=k[206764]|0;c=k[206763]|0;h=b-c>>3;d=h+1|0;if(d>>>0>536870911)ad(426534,426557,304,426811);f=c;i=(k[206765]|0)-c|0;e=i>>2;e=i>>3>>>0<268435455?(e>>>0<d>>>0?d:e):536870911;if(!e)c=0;else{if(e>>>0>536870911){i=te(4)|0;k[i>>2]=172664;Cf(i|0,28816,1287)}d=e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}d=c+(h<<3)|0;g=d;i=c+(e<<3)|0;e=k[a>>2]|0;k[d>>2]=e;k[c+(h<<3)+4>>2]=k[a+4>>2];if(e){b=e+4|0;k[b>>2]=(k[b>>2]|0)+1;b=k[206764]|0;f=k[206763]|0}a=d+8|0;if((b|0)==(f|0)){c=g;f=b}else{c=g;do{h=b;b=b+-8|0;e=k[b>>2]|0;k[d+-8>>2]=e;k[d+-4>>2]=k[h+-4>>2];if(e|0){h=e+4|0;k[h>>2]=(k[h>>2]|0)+1}d=c+-8|0;c=d}while((b|0)!=(f|0));f=k[206763]|0;b=k[206764]|0}k[206763]=c;k[206764]=a;k[206765]=i;e=f;if((b|0)!=(e|0))do{c=b;b=b+-8|0;d=k[b>>2]|0;if(d|0?(h=d+4|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);k[b>>2]=0;k[c+-4>>2]=0}while((b|0)!=(e|0));if(!f)return;ggb(f);return}function iva(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;b=k[206767]|0;c=k[206766]|0;h=b-c>>3;d=h+1|0;if(d>>>0>536870911)ad(426534,426557,304,426811);f=c;i=(k[206768]|0)-c|0;e=i>>2;e=i>>3>>>0<268435455?(e>>>0<d>>>0?d:e):536870911;if(!e)c=0;else{if(e>>>0>536870911){i=te(4)|0;k[i>>2]=172664;Cf(i|0,28816,1287)}d=e<<3;d=(d|0)==0?1:d;while(1){c=fgb(d)|0;if(c|0)break;c=k[207666]|0;k[207666]=c+0;if(!c){c=0;break}Qh[c&7]()}}d=c+(h<<3)|0;g=d;i=c+(e<<3)|0;e=k[a>>2]|0;k[d>>2]=e;k[c+(h<<3)+4>>2]=k[a+4>>2];if(e){b=e+4|0;k[b>>2]=(k[b>>2]|0)+1;b=k[206767]|0;f=k[206766]|0}a=d+8|0;if((b|0)==(f|0)){c=g;f=b}else{c=g;do{h=b;b=b+-8|0;e=k[b>>2]|0;k[d+-8>>2]=e;k[d+-4>>2]=k[h+-4>>2];if(e|0){h=e+4|0;k[h>>2]=(k[h>>2]|0)+1}d=c+-8|0;c=d}while((b|0)!=(f|0));f=k[206766]|0;b=k[206767]|0}k[206766]=c;k[206767]=a;k[206768]=i;e=f;if((b|0)!=(e|0))do{c=b;b=b+-8|0;d=k[b>>2]|0;if(d|0?(h=d+4|0,i=k[h>>2]|0,k[h>>2]=i+-1,(i|0)==1):0)Uh[k[(k[d>>2]|0)+8>>2]&2047](d);k[b>>2]=0;k[c+-4>>2]=0}while((b|0)!=(e|0));if(!f)return;ggb(f);return}function jva(a){a=a|0;ggb(a);return}function kva(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function lva(a){a=a|0;ggb(a);return}function mva(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function nva(a){a=a|0;ggb(a);return}function ova(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function pva(a){a=a|0;ggb(a);return}function qva(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function rva(a){a=a|0;ggb(a);return}function sva(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function tva(a){a=a|0;ggb(a);return}function uva(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function vva(a){a=a|0;ggb(a);return}function wva(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function xva(a){a=a|0;ggb(a);return}function yva(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function zva(a){a=a|0;ggb(a);return}function Ava(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Bva(a){a=a|0;ggb(a);return}function Cva(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Dva(a){a=a|0;ggb(a);return}function Eva(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Fva(a){a=a|0;ggb(a);return}function Gva(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Hva(a){a=a|0;ggb(a);return}function Iva(a){a=a|0;var b=0;b=k[a+8>>2]|0;if(b|0)Uh[k[(k[b>>2]|0)+4>>2]&2047](b);Uh[k[(k[a>>2]|0)+4>>2]&2047](a);return}function Jva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;j=r;r=r+16|0;h=j;d=k[206763]|0;if((k[206764]|0)==(d|0))c=0;else{e=0;c=0;do{f=k[d+(e<<3)+4>>2]|0;f=Xh[k[(k[f>>2]|0)+36>>2]&1023](f)|0;c=c>>>0<f>>>0?f:c;e=e+1|0;d=k[206763]|0}while(e>>>0<(k[206764]|0)-d>>3>>>0)}d=k[b>>2]|0;d=Ufb((d|0)==0?1016759:d,373005)|0;if(!d){k[a>>2]=0;k[a+4>>2]=0;r=j;return}f=h+4|0;b=ZT(c+8&-4)|0;k[b>>2]=1;b=b+4|0;k[h>>2]=b;k[f>>2]=c;i[b+c>>0]=0;zpb(k[h>>2]|0,32,c|0)|0;b=k[h>>2]|0;e=_fb((b|0)==0?1016759:b,1,c,d)|0;Qfb(d)|0;c=k[f>>2]|0;e=c>>>0>e>>>0?e:c;do if(e)if((e|0)==(c|0)){d=b+-4|0;k[d>>2]=(k[d>>2]|0)+1;d=k[h>>2]|0;c=d;e=k[f>>2]|0;break}else{c=ZT(e+8&-4)|0;k[c>>2]=1;c=c+4|0;i[c+e>>0]=0;d=k[h>>2]|0;upb(c|0,d|0,e|0)|0;break}else{c=0;e=0;d=b}while(0);k[f>>2]=0;k[h>>2]=0;if(d|0?(l=d+-4|0,b=k[l>>2]|0,k[l>>2]=b+-1,(b|0)==1):0)ggb(k[d+-8>>2]|0);if(c){b=c+-4|0;k[b>>2]=(k[b>>2]|0)+1;k[h>>2]=c;k[f>>2]=e;b=c+-4|0;l=k[b>>2]|0;k[b>>2]=l+-1;if((l|0)==1)ggb(k[c+-8>>2]|0)}else{k[h>>2]=0;k[f>>2]=e}c=k[206763]|0;a:do if((k[206764]|0)==(c|0))g=21;else{d=0;while(1){l=k[c+(d<<3)+4>>2]|0;if(Hh[k[(k[l>>2]|0)+40>>2]&511](l,h)|0)break;d=d+1|0;c=k[206763]|0;if(d>>>0>=(k[206764]|0)-c>>3>>>0){g=21;break a}}l=k[(k[206763]|0)+(d<<3)+4>>2]|0;jh[k[(k[l>>2]|0)+44>>2]&1023](a,l)}while(0);if((g|0)==21){k[a>>2]=0;k[a+4>>2]=0}c=k[h>>2]|0;k[f>>2]=0;k[h>>2]=0;if(c|0?(h=c+-4|0,l=k[h>>2]|0,k[h>>2]=l+-1,(l|0)==1):0)ggb(k[c+-8>>2]|0);r=j;return}function Kva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0;q=r;r=r+16|0;p=q;if(c>>>0<2){k[a>>2]=0;k[a+4>>2]=0;r=q;return}e=(b|0)==0?1016759:b;d=e;a:do if(!(d&3)){b=e;o=6}else{c=e;b=d;while(1){if(!(i[c>>0]|0))break a;c=c+1|0;b=c;if(!(b&3)){b=c;o=6;break}}}while(0);if((o|0)==6){while(1){c=k[b>>2]|0;if(!((c&-2139062144^-2139062144)&c+-16843009))b=b+4|0;else break}if((c&255)<<24>>24)do b=b+1|0;while((i[b>>0]|0)!=0)}b=b-d+1|0;while(1){if(!b)break;b=b+-1|0;f=e+b|0;if((i[f>>0]|0)==46){o=14;break}}if((o|0)==14?f|0:0){n=f+1|0;b=0;do{m=i[n+b>>0]|0;if(!((m+-48|0)>>>0<10|((m|32)+-97|0)>>>0<26))break;b=b+1|0}while((b|0)<128);d=k[206766]|0;b:do if((k[206767]|0)!=(d|0)){j=(b|0)>0;l=(b|0)==0;m=p+4|0;c=0;c:while(1){h=k[d+(c<<3)+4>>2]|0;jh[k[(k[h>>2]|0)+24>>2]&1023](p,h);h=k[p>>2]|0;d=(h|0)==0?1016759:h;d:do if(!(d&3))o=24;else while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 40:break d;default:{}}d=d+1|0;if(!(d&3)){o=24;break d}}while(0);e:do if((o|0)==24){o=0;e=k[d>>2]|0;f:do if(!((e&-2139062144^-2139062144)&e+-16843009))do{if((e&-2139062144^-2139062144)&(e^673720360)+-16843009|0)break f;d=d+4|0;e=k[d>>2]|0}while(!((e&-2139062144^-2139062144)&e+-16843009|0));while(0);while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 40:break e;default:d=d+1|0}}}while(0);if((d|0)==0|e<<24>>24!=40){k[m>>2]=0;k[p>>2]=0;if(h|0?(f=h+-4|0,g=k[f>>2]|0,k[f>>2]=g+-1,(g|0)==1):0)ggb(k[h+-8>>2]|0)}else{d=d+1|0;g:do if(!(d&3))o=33;else while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 46:break g;default:{}}d=d+1|0;if(!(d&3)){o=33;break g}}while(0);h:do if((o|0)==33){o=0;e=k[d>>2]|0;i:do if(!((e&-2139062144^-2139062144)&e+-16843009))do{if((e&-2139062144^-2139062144)&(e^774778414)+-16843009|0)break i;d=d+4|0;e=k[d>>2]|0}while(!((e&-2139062144^-2139062144)&e+-16843009|0));while(0);while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 46:break h;default:d=d+1|0}}}while(0);d=e<<24>>24==46?d:0;e=(d|0)==0;if(j){if(!e)do{g=d+1|0;d=0;do{e=i[g+d>>0]|0;f=e|32;if(!((e+-48|0)>>>0<10|(f+-97|0)>>>0<26))break;s=i[n+d>>0]|0;if((((s+-65|0)>>>0<26?s|32:s)|0)!=(((e+-65|0)>>>0<26?f:e)|0))break;d=d+1|0}while((d|0)<(b|0));if((d|0)==(b|0)?(s=i[g+b>>0]|0,!((s+-48|0)>>>0<10|((s|32)+-97|0)>>>0<26)):0)break c;d=g+d+1|0;j:do if(!(d&3))o=50;else while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 46:break j;default:{}}d=d+1|0;if(!(d&3)){o=50;break j}}while(0);k:do if((o|0)==50){o=0;e=k[d>>2]|0;l:do if(!((e&-2139062144^-2139062144)&e+-16843009))do{if((e&-2139062144^-2139062144)&(e^774778414)+-16843009|0)break l;d=d+4|0;e=k[d>>2]|0}while(!((e&-2139062144^-2139062144)&e+-16843009|0));while(0);while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 46:break k;default:d=d+1|0}}}while(0);d=e<<24>>24==46?d:0}while((d|0)!=0)}else if(!e)do{if(l?(s=i[d+1>>0]|0,!((s+-48|0)>>>0<10|((s|32)+-97|0)>>>0<26)):0)break c;d=d+2|0;m:do if(!(d&3))o=60;else while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 46:break m;default:{}}d=d+1|0;if(!(d&3)){o=60;break m}}while(0);n:do if((o|0)==60){o=0;e=k[d>>2]|0;o:do if(!((e&-2139062144^-2139062144)&e+-16843009))do{if((e&-2139062144^-2139062144)&(e^774778414)+-16843009|0)break o;d=d+4|0;e=k[d>>2]|0}while(!((e&-2139062144^-2139062144)&e+-16843009|0));while(0);while(1){e=i[d>>0]|0;switch(e<<24>>24){case 0:case 46:break n;default:d=d+1|0}}}while(0);d=e<<24>>24==46?d:0}while((d|0)!=0);k[m>>2]=0;k[p>>2]=0;if(h|0?(g=h+-4|0,s=k[g>>2]|0,k[g>>2]=s+-1,(s|0)==1):0)ggb(k[h+-8>>2]|0)}c=c+1|0;d=k[206766]|0;if(c>>>0>=(k[206767]|0)-d>>3>>>0)break b}b=k[(k[206766]|0)+(c<<3)+4>>2]|0;jh[k[(k[b>>2]|0)+28>>2]&1023](a,b);b=k[p>>2]|0;k[m>>2]=0;k[p>>2]=0;if(b|0?(p=b+-4|0,s=k[p>>2]|0,k[p>>2]=s+-1,(s|0)==1):0)ggb(k[b+-8>>2]|0);r=q;return}while(0);k[a>>2]=0;k[a+4>>2]=0;r=q;return}k[a>>2]=0;k[a+4>>2]=0;r=q;return}function Lva(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=89612;b=a+96|0;k[b>>2]=90256;c=a+116|0;d=k[c>>2]|0;if(d|0){Qfb(d)|0;k[c>>2]=0}i[a+128>>0]=0;if(!(i[a+100>>0]|0)){k[a+112>>2]=0;k[a+108>>2]=0;k[a+104>>2]=0}Uh[k[(k[b>>2]|0)+24>>2]&2047](b);Tva(a);return}function Mva(a){a=a|0;var b=0,c=0,d=0;k[a>>2]=89612;b=a+96|0;k[b>>2]=90256;c=a+116|0;d=k[c>>2]|0;if(d|0){Qfb(d)|0;k[c>>2]=0}i[a+128>>0]=0;if(!(i[a+100>>0]|0)){k[a+112>>2]=0;k[a+108>>2]=0;k[a+104>>2]=0}Uh[k[(k[b>>2]|0)+24>>2]&2047](b);Tva(a);ggb(a);return}function Nva(a){a=a|0;return k[a+12>>2]|0}function Ova(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,m=0,n=0,o=0,p=0;p=r;r=r+768|0;j=p;f=a+36|0;if(k[a+52>>2]|0){e=k[a+40>>2]|0;if((e|0)<3)b=aa(k[a+48>>2]|0,k[a+44>>2]|0)|0;else{d=k[a+76>>2]|0;c=0;b=1;do{b=aa(k[d+(c<<2)>>2]|0,b)|0;c=c+1|0}while((c|0)!=(e|0))}d=a+96|0;if(b)if(Hh[k[(k[d>>2]|0)+12>>2]&511](d,f)|0){o=d;n=d}else{a=0;r=p;return a|0}else{c=d;b=d;m=9}}else{b=a+96|0;c=b;m=9}if((m|0)==9)if(Hh[k[(k[c>>2]|0)+8>>2]&511](b,a+20|0)|0){o=b;n=c}else{a=0;r=p;return a|0}b=o+16|0;k[b>>2]=(k[b>>2]|0)+10;c=Oxa(n)|0;k[a+1164>>2]=c;c=Oxa(n)|0;a:do if((c|0)>35){e=Oxa(n)|0;g=a+4|0;k[g>>2]=e;e=Oxa(n)|0;h=a+8|0;k[h>>2]=e;e=(Oxa(n)|0)>>16;j=a+1160|0;k[j>>2]=e;e=Oxa(n)|0;d=a+1168|0;k[d>>2]=e;k[b>>2]=(k[b>>2]|0)+12;e=Oxa(n)|0;k[b>>2]=(k[b>>2]|0)+(c+-36);if((k[g>>2]|0)>0?(k[h>>2]|0)!=0:0){f=k[j>>2]|0;b:do switch(f|0){case 32:case 24:case 8:case 4:case 1:{b=k[d>>2]|0;c:do if(!b){if((f|0)>=9){b=0;m=32;break b}}else switch(f|0){case 32:case 16:{m=17;break b}case 4:if((b|0)==2)break c;else{c=0;b=0;break a}case 8:if((b|0)==1)break c;else{c=0;b=0;break a}default:{c=0;b=0;break a}}while(0);c=a+132|0;zpb(c|0,0,1024)|0;b=(e|0)==0?1<<f:e;if((b|0)>0){g=n+12|0;h=n+16|0;e=k[h>>2]|0;f=b<<2;d=e;b=e;while(1){b=(k[g>>2]|0)-b|0;b=(b|0)>(f|0)?f:b;if((b|0)<=0)do{Uh[k[(k[n>>2]|0)+20>>2]&2047](n);d=k[h>>2]|0;b=(k[g>>2]|0)-d|0;b=(b|0)>(f|0)?f:b}while((b|0)<=0);upb(c|0,d|0,b|0)|0;e=(k[h>>2]|0)+b|0;k[h>>2]=e;d=f-b|0;if((d|0)>0){c=c+b|0;f=d;d=e;b=e}else break}b=k[j>>2]|0;if((b|0)==31){c=1;b=0;break a}else{d=0;b=1<<b}}else{d=0;b=1<<f}while(1){c=i[a+132+(d<<2)>>0]|0;if(c<<24>>24!=(i[a+132+(d<<2)+1>>0]|0)){b=1;break b}if(c<<24>>24!=(i[a+132+(d<<2)+2>>0]|0)){b=1;break b}d=d+1|0;if((d|0)>=(b|0)){c=1;b=0;break a}}}case 16:{b=k[d>>2]|0;m=17;break}default:{c=0;b=0;break a}}while(0);if((m|0)==17)switch(b|0){case 3:case 0:{m=32;break}default:{c=0;b=0;break a}}d:do if((m|0)==32)if((f|0)==16){switch(b|0){case 3:break;case 0:{k[j>>2]=15;b=1;break d}default:{b=1;break d}}b=Oxa(n)|0;c=Oxa(n)|0;d=(Oxa(n)|0)==31;if((b|0)==31744&((c|0)==992&d)){k[j>>2]=15;b=1;break}else{b=(b|0)==63488&((c|0)==2016&d);break}}else b=1;while(0);c=b;b=(k[j>>2]|0)==32?24:16}else{c=0;b=0}}else if((c|0)==12){g=n+16|0;b=k[g>>2]|0;c=b+1|0;h=n+12|0;d=k[h>>2]|0;if(c>>>0<d>>>0){c=l[c>>0]<<8|l[b>>0];e=b+2|0;k[g>>2]=e;b=c;c=d}else{if(b>>>0<d>>>0)c=d;else{Uh[k[(k[n>>2]|0)+20>>2]&2047](n);b=k[g>>2]|0;c=k[h>>2]|0}d=l[b>>0]|0;b=b+1|0;k[g>>2]=b;if(b>>>0>=c>>>0){Uh[k[(k[n>>2]|0)+20>>2]&2047](n);b=k[g>>2]|0;c=k[h>>2]|0}m=l[b>>0]|0;e=b+1|0;k[g>>2]=e;b=m<<8|d}f=a+4|0;k[f>>2]=b;b=e+1|0;if(b>>>0<c>>>0){b=l[b>>0]<<8|l[e>>0];k[g>>2]=e+2}else{if(e>>>0<c>>>0)b=e;else{Uh[k[(k[n>>2]|0)+20>>2]&2047](n);b=k[g>>2]|0;c=k[h>>2]|0}d=l[b>>0]|0;b=b+1|0;k[g>>2]=b;if(b>>>0>=c>>>0){Uh[k[(k[n>>2]|0)+20>>2]&2047](n);b=k[g>>2]|0}m=l[b>>0]|0;k[g>>2]=b+1;b=m<<8|d}m=a+8|0;k[m>>2]=b;b=(Oxa(n)|0)>>16;k[a+1160>>2]=b;k[a+1168>>2]=0;if((k[f>>2]|0)>0?(k[m>>2]|0)!=0:0){switch(b|0){case 32:case 24:case 8:case 4:case 1:break;default:{c=0;b=0;break a}}if((b|0)<9){f=1<<b;b=3<<b;if((b|0)>0){d=k[g>>2]|0;e=j;c=d;while(1){c=(k[h>>2]|0)-c|0;c=(c|0)>(b|0)?b:c;if((c|0)<=0)do{Uh[k[(k[n>>2]|0)+20>>2]&2047](n);d=k[g>>2]|0;c=(k[h>>2]|0)-d|0;c=(c|0)>(b|0)?b:c}while((c|0)<=0);upb(e|0,d|0,c|0)|0;d=(k[g>>2]|0)+c|0;k[g>>2]=d;b=b-c|0;if((b|0)>0){e=e+c|0;c=d}else{b=0;break}}}else b=0;do{m=b*3|0;i[a+132+(b<<2)>>0]=i[j+m>>0]|0;i[a+132+(b<<2)+1>>0]=i[j+(m+1)>>0]|0;i[a+132+(b<<2)+2>>0]=i[j+(m+2)>>0]|0;b=b+1|0}while((b|0)<(f|0));c=1;b=0}else{c=1;b=0}}else{c=0;b=0}}else{c=0;b=0}while(0);k[a+12>>2]=b;b=a+8|0;m=k[b>>2]|0;k[a+1156>>2]=(m|0)>0&1;k[b>>2]=(m|0)>-1?m:0-m|0;if(c){a=1;r=p;return a|0}k[a+1164>>2]=-1;k[b>>2]=-1;k[a+4>>2]=-1;Uh[k[(k[n>>2]|0)+16>>2]&2047](o);a=0;r=p;return a|0}
function vmb(a,b,c,d,e,f,g,h,j,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;var m=0,n=0;n=r;r=r+16|0;m=n;if(a){a=Sib(c,830484)|0;if(b){jh[k[(k[a>>2]|0)+44>>2]&1023](m,a);c=k[m>>2]|0;i[d>>0]=c;i[d+1>>0]=c>>8;i[d+2>>0]=c>>16;i[d+3>>0]=c>>24;jh[k[(k[a>>2]|0)+32>>2]&1023](m,a);c=j+8+3|0;if((i[c>>0]|0)<0){k[k[j>>2]>>2]=0;k[j+4>>2]=0}else{k[j>>2]=0;i[c>>0]=0}uob(j);k[j>>2]=k[m>>2];k[j+4>>2]=k[m+4>>2];k[j+8>>2]=k[m+8>>2];c=0;while(1){if((c|0)==3)break;k[m+(c<<2)>>2]=0;c=c+1|0}tob(m)}else{jh[k[(k[a>>2]|0)+40>>2]&1023](m,a);c=k[m>>2]|0;i[d>>0]=c;i[d+1>>0]=c>>8;i[d+2>>0]=c>>16;i[d+3>>0]=c>>24;jh[k[(k[a>>2]|0)+28>>2]&1023](m,a);c=j+8+3|0;if((i[c>>0]|0)<0){k[k[j>>2]>>2]=0;k[j+4>>2]=0}else{k[j>>2]=0;i[c>>0]=0}uob(j);k[j>>2]=k[m>>2];k[j+4>>2]=k[m+4>>2];k[j+8>>2]=k[m+8>>2];c=0;while(1){if((c|0)==3)break;k[m+(c<<2)>>2]=0;c=c+1|0}tob(m)}c=Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0;k[e>>2]=c;c=Xh[k[(k[a>>2]|0)+16>>2]&1023](a)|0;k[f>>2]=c;jh[k[(k[a>>2]|0)+20>>2]&1023](m,a);c=g+11|0;if((i[c>>0]|0)<0){i[k[g>>2]>>0]=0;k[g+4>>2]=0;c=g}else{i[g>>0]=0;i[c>>0]=0;c=g}mob(g);k[c>>2]=k[m>>2];k[c+4>>2]=k[m+4>>2];k[c+8>>2]=k[m+8>>2];c=0;while(1){if((c|0)==3)break;k[m+(c<<2)>>2]=0;c=c+1|0}kob(m);jh[k[(k[a>>2]|0)+24>>2]&1023](m,a);c=h+8+3|0;if((i[c>>0]|0)<0){k[k[h>>2]>>2]=0;k[h+4>>2]=0}else{k[h>>2]=0;i[c>>0]=0}uob(h);k[h>>2]=k[m>>2];k[h+4>>2]=k[m+4>>2];k[h+8>>2]=k[m+8>>2];c=0;while(1){if((c|0)==3)break;k[m+(c<<2)>>2]=0;c=c+1|0}tob(m);c=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0}else{a=Sib(c,830476)|0;if(b){jh[k[(k[a>>2]|0)+44>>2]&1023](m,a);c=k[m>>2]|0;i[d>>0]=c;i[d+1>>0]=c>>8;i[d+2>>0]=c>>16;i[d+3>>0]=c>>24;jh[k[(k[a>>2]|0)+32>>2]&1023](m,a);c=j+8+3|0;if((i[c>>0]|0)<0){k[k[j>>2]>>2]=0;k[j+4>>2]=0}else{k[j>>2]=0;i[c>>0]=0}uob(j);k[j>>2]=k[m>>2];k[j+4>>2]=k[m+4>>2];k[j+8>>2]=k[m+8>>2];c=0;while(1){if((c|0)==3)break;k[m+(c<<2)>>2]=0;c=c+1|0}tob(m)}else{jh[k[(k[a>>2]|0)+40>>2]&1023](m,a);c=k[m>>2]|0;i[d>>0]=c;i[d+1>>0]=c>>8;i[d+2>>0]=c>>16;i[d+3>>0]=c>>24;jh[k[(k[a>>2]|0)+28>>2]&1023](m,a);c=j+8+3|0;if((i[c>>0]|0)<0){k[k[j>>2]>>2]=0;k[j+4>>2]=0}else{k[j>>2]=0;i[c>>0]=0}uob(j);k[j>>2]=k[m>>2];k[j+4>>2]=k[m+4>>2];k[j+8>>2]=k[m+8>>2];c=0;while(1){if((c|0)==3)break;k[m+(c<<2)>>2]=0;c=c+1|0}tob(m)}c=Xh[k[(k[a>>2]|0)+12>>2]&1023](a)|0;k[e>>2]=c;c=Xh[k[(k[a>>2]|0)+16>>2]&1023](a)|0;k[f>>2]=c;jh[k[(k[a>>2]|0)+20>>2]&1023](m,a);c=g+11|0;if((i[c>>0]|0)<0){i[k[g>>2]>>0]=0;k[g+4>>2]=0;c=g}else{i[g>>0]=0;i[c>>0]=0;c=g}mob(g);k[c>>2]=k[m>>2];k[c+4>>2]=k[m+4>>2];k[c+8>>2]=k[m+8>>2];c=0;while(1){if((c|0)==3)break;k[m+(c<<2)>>2]=0;c=c+1|0}kob(m);jh[k[(k[a>>2]|0)+24>>2]&1023](m,a);c=h+8+3|0;if((i[c>>0]|0)<0){k[k[h>>2]>>2]=0;k[h+4>>2]=0}else{k[h>>2]=0;i[c>>0]=0}uob(h);k[h>>2]=k[m>>2];k[h+4>>2]=k[m+4>>2];k[h+8>>2]=k[m+8>>2];c=0;while(1){if((c|0)==3)break;k[m+(c<<2)>>2]=0;c=c+1|0}tob(m);c=Xh[k[(k[a>>2]|0)+36>>2]&1023](a)|0}k[l>>2]=c;r=n;return}function wmb(a,b,c,d,e,f,g,h,j,l,m,n,o,p,q){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k[c>>2]=a;B=p+8+3|0;I=p+4|0;C=o+8+3|0;D=o+4|0;E=(d&512|0)==0;F=(q|0)>0;G=n+11|0;H=n+4|0;A=0;while(1){if((A|0)==4)break;a:do switch(i[j+A>>0]|0){case 0:{k[b>>2]=k[c>>2];break}case 1:{k[b>>2]=k[c>>2];y=Hh[k[(k[g>>2]|0)+44>>2]&511](g,32)|0;z=k[c>>2]|0;k[c>>2]=z+4;k[z>>2]=y;break}case 3:{z=i[B>>0]|0;r=z<<24>>24<0;if((r?k[I>>2]|0:z&255)|0){y=k[(r?k[p>>2]|0:p)>>2]|0;z=k[c>>2]|0;k[c>>2]=z+4;k[z>>2]=y}break}case 2:{v=i[C>>0]|0;r=v<<24>>24<0;v=r?k[D>>2]|0:v&255;if(!(E|(v|0)==0)){u=r?k[o>>2]|0:o;s=u+(v<<2)|0;t=k[c>>2]|0;r=t;while(1){if((u|0)==(s|0))break;k[r>>2]=k[u>>2];r=r+4|0;u=u+4|0}k[c>>2]=t+(v<<2)}break}case 4:{s=k[c>>2]|0;e=h?e+4|0:e;r=e;while(1){if(r>>>0>=f>>>0)break;if(!(ci[k[(k[g>>2]|0)+12>>2]&255](g,2048,k[r>>2]|0)|0))break;r=r+4|0}if(F){u=q;while(1){t=(u|0)>0;if(!(r>>>0>e>>>0&t))break;z=r+-4|0;x=k[z>>2]|0;y=k[c>>2]|0;k[c>>2]=y+4;k[y>>2]=x;u=u+-1|0;r=z}if(t)w=Hh[k[(k[g>>2]|0)+44>>2]&511](g,48)|0;else w=0;v=k[c>>2]|0;while(1){t=v+4|0;if((u|0)<=0)break;k[v>>2]=w;u=u+-1|0;v=t}k[c>>2]=t;k[v>>2]=l}if((r|0)==(e|0)){y=Hh[k[(k[g>>2]|0)+44>>2]&511](g,48)|0;z=k[c>>2]|0;r=z+4|0;k[c>>2]=r;k[z>>2]=y}else{z=i[G>>0]|0;y=z<<24>>24<0;z=y?k[H>>2]|0:z&255;if(!z){v=-1;t=0;w=0}else{v=i[(y?k[n>>2]|0:n)>>0]|0;t=0;w=0}while(1){if((r|0)==(e|0))break;u=k[c>>2]|0;if((w|0)==(v|0)){x=u+4|0;k[c>>2]=x;k[u>>2]=m;t=t+1|0;if(t>>>0<z>>>0){v=i[(y?k[n>>2]|0:n)+t>>0]|0;v=v<<24>>24==127?-1:v<<24>>24;w=0;u=x}else{v=w;w=0;u=x}}x=r+-4|0;J=k[x>>2]|0;k[c>>2]=u+4;k[u>>2]=J;w=w+1|0;r=x}r=k[c>>2]|0}if((s|0)!=(r|0))while(1){r=r+-4|0;if(s>>>0>=r>>>0)break a;J=k[s>>2]|0;k[s>>2]=k[r>>2];k[r>>2]=J;s=s+4|0}break}default:{}}while(0);A=A+1|0}r=i[B>>0]|0;e=r<<24>>24<0;r=e?k[I>>2]|0:r&255;if(r>>>0>1){s=e?k[p>>2]|0:p;v=s+4|0;r=s+(r<<2)|0;s=k[c>>2]|0;t=r;e=s;u=v;while(1){if((u|0)==(r|0))break;k[e>>2]=k[u>>2];e=e+4|0;u=u+4|0}k[c>>2]=s+((t-v|0)>>>2<<2)}switch((d&176)<<24>>24){case 32:{k[b>>2]=k[c>>2];break}case 16:break;default:k[b>>2]=a}return}function xmb(a){a=a|0;return}function ymb(a){a=a|0;ggb(a);return}function zmb(a,b,c){a=a|0;b=b|0;c=c|0;return -1}function Amb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=r;r=r+16|0;e=g;k[e>>2]=0;k[e+4>>2]=0;k[e+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[e+(b<<2)>>2]=0;b=b+1|0}c=i[f+11>>0]|0;d=c<<24>>24<0;b=d?k[f>>2]|0:f;c=b+(d?k[f+4>>2]|0:c&255)|0;while(1){if(b>>>0>=c>>>0)break;qob(e,i[b>>0]|0);b=b+1|0}c=i[e+11>>0]|0;d=k[e>>2]|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}b=c<<24>>24<0?d:e;c=b+(hfb(b)|0)|0;while(1){if(b>>>0>=c>>>0)break;qob(a,i[b>>0]|0);b=b+1|0}kob(e);r=g;return}function Bmb(a,b){a=a|0;b=b|0;return}function Cmb(a){a=a|0;return}function Dmb(a){a=a|0;ggb(a);return}function Emb(a,b,c){a=a|0;b=b|0;c=c|0;return -1}function Fmb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0;p=r;r=r+176|0;l=p+168|0;m=p+40|0;n=p+36|0;o=p+32|0;h=p;g=p+24|0;j=p+16|0;k[h>>2]=0;k[h+4>>2]=0;k[h+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[h+(b<<2)>>2]=0;b=b+1|0}k[g+4>>2]=0;k[g>>2]=172008;e=i[f+8+3>>0]|0;b=e<<24>>24<0;c=b?k[f>>2]|0:f;e=c+((b?k[f+4>>2]|0:e&255)<<2)|0;f=m+32|0;b=0;while(1){if(!((b|0)!=2&c>>>0<e>>>0))break;k[o>>2]=c;d=si[k[(k[g>>2]|0)+12>>2]&15](g,l,c,e,o,m,f,n)|0;b=m;while(1){if(b>>>0>=(k[n>>2]|0)>>>0)break;qob(h,i[b>>0]|0);b=b+1|0}c=k[o>>2]|0;b=d}c=i[h+11>>0]|0;d=k[h>>2]|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;k[a+(b<<2)>>2]=0;b=b+1|0}c=c<<24>>24<0?d:h;k[j+4>>2]=0;k[j>>2]=172056;e=c+(hfb(c)|0)|0;f=e;g=m+128|0;b=0;while(1){if(!((b|0)!=2&c>>>0<e>>>0))break;k[o>>2]=c;d=si[k[(k[j>>2]|0)+16>>2]&15](j,l,c,(f-c|0)>32?c+32|0:e,o,m,g,n)|0;b=m;while(1){if(b>>>0>=(k[n>>2]|0)>>>0)break;xob(a,k[b>>2]|0);b=b+4|0}c=k[o>>2]|0;b=d}kob(h);r=p;return}function Gmb(a,b){a=a|0;b=b|0;return}function Hmb(a){a=a|0;return}function Imb(a){a=a|0;ggb(a);return}function Jmb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0;a:while(1){j=f;l=c;if(c>>>0>=d>>>0){f=0;break}b=k[c>>2]|0;if(b>>>0>1114111|(b&-2048|0)==55296){f=2;break}do if(b>>>0>=128){if(b>>>0<2048){if((g-f|0)<2){f=1;break a}i[f>>0]=b>>>6|192;i[f+1>>0]=b&63|128;f=f+2|0;break}a=g-j|0;if(b>>>0<65536){if((a|0)<3){f=1;break a}i[f>>0]=b>>>12|224;i[f+1>>0]=b>>>6&63|128;i[f+2>>0]=b&63|128;f=f+3|0;break}else{if((a|0)<4){f=1;break a}i[f>>0]=b>>>18|240;i[f+1>>0]=b>>>12&63|128;i[f+2>>0]=b>>>6&63|128;i[f+3>>0]=b&63|128;f=f+4|0;break}}else{if((g-f|0)<1){f=1;break a}i[f>>0]=b;f=f+1|0}while(0);c=c+4|0}k[e>>2]=l;k[h>>2]=j;return f|0}function Kmb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,m=0,n=0,o=0,p=0,q=0,r=0;r=d;a:while(1){q=c;p=f;if(c>>>0>=d>>>0){c=0;break}if(f>>>0>=g>>>0){c=1;break}m=i[c>>0]|0;o=m&255;do if(m<<24>>24>-1){k[f>>2]=o;c=c+1|0}else{if((m&255)<194){c=2;break a}if((m&255)<224){if((r-c|0)<2){c=1;break a}a=l[c+1>>0]|0;if((a&192|0)!=128){c=2;break a}k[f>>2]=a&63|o<<6&1984;c=c+2|0;break}if((m&255)<240){if((r-c|0)<3){c=1;break a}b=i[c+1>>0]|0;a=i[c+2>>0]|0;switch(m<<24>>24){case -32:{if((b&-32)<<24>>24!=-96){c=2;break a}break}case -19:{if((b&-32)<<24>>24!=-128){c=2;break a}break}default:if((b&-64)<<24>>24!=-128){c=2;break a}}a=a&255;if((a&192|0)!=128){c=2;break a}k[f>>2]=(b&255)<<6&4032|o<<12&61440|a&63;c=c+3|0;break}if((m&255)>=245){c=2;break a}if((r-q|0)<4){c=1;break a}n=i[c+1>>0]|0;a=i[c+2>>0]|0;j=i[c+3>>0]|0;switch(m<<24>>24){case -16:{if((n+112&255)>=48){c=2;break a}break}case -12:{if((n&-16)<<24>>24!=-128){c=2;break a}break}default:if((n&-64)<<24>>24!=-128){c=2;break a}}b=a&255;if((b&192|0)!=128){c=2;break a}a=j&255;if((a&192|0)!=128){c=2;break a}a=(n&255)<<12&258048|o<<18&1835008|b<<6&4032|a&63;if(a>>>0>1114111){c=2;break a}k[f>>2]=a;c=c+4|0}while(0);f=f+4|0}k[e>>2]=q;k[h>>2]=p;return c|0}function Lmb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;k[e>>2]=c;return 3}function Mmb(a){a=a|0;return 0}function Nmb(a){a=a|0;return 0}function Omb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;m=d;l=0;a=c;a:while(1){if(!(l>>>0<e>>>0&a>>>0<d>>>0)){b=33;break}k=i[a>>0]|0;h=k&255;do if(k<<24>>24<=-1){if((k&255)<194){b=33;break a}if((k&255)<224){if((m-a|0)<2){b=33;break a}if((i[a+1>>0]&-64)<<24>>24!=-128){b=33;break a}a=a+2|0;break}if((k&255)<240){g=a;if((m-g|0)<3){b=33;break a}b=i[a+1>>0]|0;f=i[a+2>>0]|0;switch(k<<24>>24){case -32:{if((b&-32)<<24>>24!=-96){b=14;break a}break}case -19:{if((b&-32)<<24>>24!=-128){b=16;break a}break}default:if((b&-64)<<24>>24!=-128){b=18;break a}}if((f&-64)<<24>>24!=-128){b=33;break a}a=a+3|0;break}if((k&255)>=245){b=33;break a}j=a;if((m-j|0)<4){b=33;break a}b=i[a+1>>0]|0;f=i[a+2>>0]|0;g=i[a+3>>0]|0;switch(k<<24>>24){case -16:{if((b+112&255)>=48){b=25;break a}break}case -12:{if((b&-16)<<24>>24!=-128){b=27;break a}break}default:if((b&-64)<<24>>24!=-128){b=29;break a}}if(!((f&-64)<<24>>24==-128&(g&-64)<<24>>24==-128)){b=33;break a}if(((b&255)<<12&196608|h<<18&1835008)>>>0>1114111){b=33;break a}else a=a+4|0}else a=a+1|0;while(0);l=l+1|0}if((b|0)==14)a=g-c|0;else if((b|0)==16)a=g-c|0;else if((b|0)==18)a=g-c|0;else if((b|0)==25)a=j-c|0;else if((b|0)==27)a=j-c|0;else if((b|0)==29)a=j-c|0;else if((b|0)==33)a=a-c|0;return a|0}function Pmb(a){a=a|0;return 4}function Qmb(a){a=a|0;ggb(a);return}function Rmb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;k[e>>2]=c;k[h>>2]=f;return 3}function Smb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;k[e>>2]=c;k[h>>2]=f;return 3}function Tmb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;k[e>>2]=c;return 3}function Umb(a){a=a|0;return 1}function Vmb(a){a=a|0;return 1}function Wmb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;d=d-c|0;return (d>>>0<e>>>0?d:e)|0}function Xmb(a){a=a|0;return 1}function Ymb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=r;r=r+272|0;x=A+256|0;y=A;b=c;while(1){if((b|0)==(d|0)){b=d;break}if(!(k[b>>2]|0))break;b=b+4|0}k[h>>2]=f;k[e>>2]=c;w=g;z=a+8|0;a:while(1){if((f|0)==(g|0)|(c|0)==(d|0)){q=71;break}m=b-c>>2;u=xfb(k[z>>2]|0)|0;a=k[e>>2]|0;v=(f|0)!=0;n=v?w-f|0:256;j=v?f:y;o=a;b:do if((n|0)!=0&(a|0)!=0){t=0;c:while(1){l=m>>>0>=n>>>0;if(!(l|m>>>0>32)){l=t;p=m;m=o;break b}l=l?n:m;p=m-l|0;d:do if(j){e:do if(l>>>0>3){m=j;o=l;s=a;q=a;while(1){a=k[q>>2]|0;if((a+-1|0)>>>0>126){if(!a)break;a=jfb(m,a)|0;if((a|0)==-1){a=s;q=35;break c}m=m+a|0;o=o-a|0;a=q}else{i[m>>0]=a;m=m+1|0;o=o+-1|0;a=s}q=a+4|0;a=q;if(o>>>0<=3)break e;else s=a}i[m>>0]=0;l=l-o|0;a=0;q=36;break d}else{m=j;o=l}while(0);if(o){s=a;q=a;while(1){a=k[q>>2]|0;if((a+-1|0)>>>0>126){if(!a){q=28;break}a=jfb(x,a)|0;if((a|0)==-1){a=s;q=35;break c}if(o>>>0<a>>>0){q=31;break}jfb(m,k[q>>2]|0)|0;m=m+a|0;o=o-a|0;a=q}else{i[m>>0]=a;m=m+1|0;o=o+-1|0;a=s}q=a+4|0;a=q;if(!o){q=36;break d}else s=a}if((q|0)==28){i[m>>0]=0;l=l-o|0;a=0;q=36;break}else if((q|0)==31){l=l-o|0;a=s;q=36;break}}else q=36}else{l=a;m=k[l>>2]|0;if(!m){l=0;break}else{o=l;l=0}while(1){if(m>>>0>127){m=jfb(x,m)|0;if((m|0)==-1){j=0;q=35;break c}}else m=1;l=m+l|0;o=o+4|0;m=k[o>>2]|0;if(!m){q=36;break}}}while(0);if((q|0)==36){q=0;if((l|0)==-1){m=a;break}}o=(j|0)==(y|0);n=n-(o?0:l)|0;j=o?j:j+l|0;l=l+t|0;o=a;if((n|0)!=0&(a|0)!=0){t=l;m=p}else{m=o;break b}}if((q|0)==35){q=0;m=a}l=-1;n=0;a=m}else{l=0;p=m;m=o}while(0);f:do if((m|0)!=0?(n|0)!=0&(p|0)!=0:0){o=n;while(1){n=jfb(j,k[m>>2]|0)|0;if((n+1|0)>>>0<2)break;m=a+4|0;a=m;p=p+-1|0;o=o-n|0;l=l+1|0;if(!((o|0)!=0&(p|0)!=0)){j=l;break f}else j=j+n|0}t=(n|0)==0;j=t?l:-1;a=t?0:a}else j=l;while(0);if(v)k[e>>2]=a;if(u|0){v=(Fpb()|0)+184|0;k[v>>2]=u}switch(j|0){case -1:{q=49;break a}case 0:{c=1;break a}default:{}}f=(k[h>>2]|0)+j|0;k[h>>2]=f;if((f|0)==(g|0)){q=70;break}if((b|0)==(d|0)){c=k[e>>2]|0;b=d;continue}c=xfb(k[z>>2]|0)|0;i[x>>0]=0;if(c|0){v=(Fpb()|0)+184|0;k[v>>2]=c}if((w|0)==(k[h>>2]|0)){q=69;break}else{c=x;f=1}while(1){if(!f)break;u=i[c>>0]|0;v=k[h>>2]|0;k[h>>2]=v+1;i[v>>0]=u;c=c+1|0;f=f+-1|0}c=(k[e>>2]|0)+4|0;k[e>>2]=c;b=c;while(1){if((b|0)==(d|0)){b=d;break}if(!(k[b>>2]|0))break;b=b+4|0}f=k[h>>2]|0}if((q|0)==49){k[h>>2]=f;while(1){if((c|0)==(k[e>>2]|0))break;d=k[c>>2]|0;b=xfb(k[z>>2]|0)|0;f=jfb(f,d)|0;if(b|0){d=(Fpb()|0)+184|0;k[d>>2]=b}if((f|0)==-1)break;f=(k[h>>2]|0)+f|0;k[h>>2]=f;c=c+4|0}k[e>>2]=c;c=2}else if((q|0)==69)c=1;else if((q|0)==70){c=k[e>>2]|0;q=71}if((q|0)==71)c=(c|0)!=(d|0)&1;r=A;return c|0}function Zmb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=r;r=r+1040|0;x=B+16|0;y=B+8|0;A=B;j=c;while(1){if((j|0)==(d|0)){j=d;break}if(!(i[j>>0]|0))break;j=j+1|0}k[h>>2]=f;k[e>>2]=c;w=g;z=a+8|0;while(1){if((f|0)==(g|0)|(c|0)==(d|0)){j=47;break}t=b;n=k[t+4>>2]|0;v=A;k[v>>2]=k[t>>2];k[v+4>>2]=n;v=j;n=v-c|0;t=xfb(k[z>>2]|0)|0;a=k[e>>2]|0;k[y>>2]=a;u=(f|0)!=0;p=u?w-f>>2:256;m=u?f:x;o=a;a:do if((p|0)!=0&(a|0)!=0){l=0;s=p;q=o;while(1){o=n>>>2;p=o>>>0>=s>>>0;if(!(n>>>0>131|p)){p=s;o=q;break a}a=p?s:o;n=n-a|0;a=zfb(m,y,a,b)|0;if((a|0)==-1)break;o=(m|0)==(x|0);p=s-(o?0:a)|0;m=o?m:m+(a<<2)|0;l=a+l|0;o=k[y>>2]|0;a=o;if((p|0)!=0&(o|0)!=0){s=p;q=o}else break a}o=k[y>>2]|0;l=-1;p=0;a=o}else l=0;while(0);b:do if((o|0)!=0?(p|0)!=0&(n|0)!=0:0){q=m;while(1){m=ifb(q,o,n,b)|0;if((m+2|0)>>>0<3)break;o=o+m|0;k[y>>2]=o;n=n-m|0;p=p+-1|0;l=l+1|0;a=o;if(!((p|0)!=0&(n|0)!=0))break b;else q=q+4|0}switch(m|0){case -1:{l=-1;break b}case 0:{k[y>>2]=0;a=0;break b}default:{k[b>>2]=0;break b}}}while(0);if(u)k[e>>2]=a;if(t|0){u=(Fpb()|0)+184|0;k[u>>2]=t}if((l|0)==-1){j=24;break}f=(k[h>>2]|0)+(l<<2)|0;k[h>>2]=f;if((f|0)==(g|0)){j=44;break}c=k[e>>2]|0;if((j|0)==(d|0))j=d;else{j=xfb(k[z>>2]|0)|0;c=ifb(f,c,1,b)|0;if(j|0){v=(Fpb()|0)+184|0;k[v>>2]=j}if(c|0){c=2;j=43;break}k[h>>2]=(k[h>>2]|0)+4;c=(k[e>>2]|0)+1|0;k[e>>2]=c;j=c;while(1){if((j|0)==(d|0)){j=d;break}if(!(i[j>>0]|0))break;j=j+1|0}f=k[h>>2]|0}}do if((j|0)==24){c:while(1){k[h>>2]=f;if((c|0)==(k[e>>2]|0)){j=33;break}j=xfb(k[z>>2]|0)|0;f=ifb(f,c,v-c|0,A)|0;if(j|0){y=(Fpb()|0)+184|0;k[y>>2]=j}switch(f|0){case -1:{j=29;break c}case -2:{j=30;break c}case 0:{c=c+1|0;break}default:c=c+f|0}f=(k[h>>2]|0)+4|0;j=24}if((j|0)==29){k[e>>2]=c;c=2;j=43;break}else if((j|0)==30){k[e>>2]=c;c=1;j=43;break}else if((j|0)==33){k[e>>2]=c;c=(c|0)!=(d|0)&1;j=43;break}}else if((j|0)==44){c=k[e>>2]|0;j=47}while(0);if((j|0)!=43)if((j|0)==47)c=(c|0)!=(d|0)&1;r=B;return c|0}function _mb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;k[e>>2]=c;a=xfb(k[a+8>>2]|0)|0;if(a|0){e=(Fpb()|0)+184|0;k[e>>2]=a}return 0}function $mb(a){a=a|0;var b=0,c=0;a=a+8|0;b=xfb(k[a>>2]|0)|0;if(b|0){c=(Fpb()|0)+184|0;k[c>>2]=b}a=k[a>>2]|0;if(!a)return 1;else{c=(Fpb()|0)+184|0;b=k[c>>2]|0;k[c>>2]=(b|0)==0?a:b;return 0}return 0}function anb(a){a=a|0;return 0}function bnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0;j=d;i=a+8|0;g=0;h=0;a:while(1){if((c|0)==(d|0)|g>>>0>=e>>>0)break;f=xfb(k[i>>2]|0)|0;a=ifb(0,c,j-c|0,b)|0;if(f|0){l=(Fpb()|0)+184|0;k[l>>2]=f}switch(a|0){case -2:case -1:break a;case 0:{c=c+1|0;a=1;break}default:c=c+a|0}g=g+1|0;h=a+h|0}return h|0}function cnb(a){a=a|0;var b=0,c=0;a=k[a+8>>2]|0;if(!a)return 1;else{b=(Fpb()|0)+184|0;c=k[b>>2]|0;k[b>>2]=(c|0)==0?a:c;return 4}return 0}function dnb(a){a=a|0;var b=0;k[a>>2]=172104;a=a+8|0;b=k[a>>2]|0;if((b|0)!=(Uib()|0))ggb(k[a>>2]|0);return}function enb(a){a=a|0;dnb(a);ggb(a);return}function fnb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var l=0,n=0,o=0,p=0;p=d;b=f;a=c;a:while(1){n=b;o=a;if(a>>>0>=d>>>0){a=0;break}f=j[a>>1]|0;l=f&65535;do if((f&65535)<128){if((g-b|0)<1){a=1;break a}i[b>>0]=f;b=b+1|0;a=o}else{if((f&65535)<2048){if((g-b|0)<2){a=1;break a}i[b>>0]=l>>>6|192;i[b+1>>0]=l&63|128;b=b+2|0;a=o;break}if((f&65535)<55296){if((g-b|0)<3){a=1;break a}i[b>>0]=l>>>12|224;i[b+1>>0]=l>>>6&63|128;i[b+2>>0]=l&63|128;b=b+3|0;a=o;break}if((f&65535)>=56320){if((f&65535)<57344){a=2;break a}if((g-n|0)<3){a=1;break a}i[b>>0]=l>>>12|224;i[b+1>>0]=l>>>6&63|128;i[b+2>>0]=l&63|128;b=b+3|0;a=o;break}if((p-a|0)<4){a=1;break a}a=a+2|0;f=m[a>>1]|0;if((f&64512|0)!=56320){a=2;break a}if((g-n|0)<4){a=1;break a}c=l&960;if(((c<<10)+65536|0)>>>0>1114111){a=2;break a}o=(c>>>6)+1|0;i[b>>0]=o>>>2|240;i[b+1>>0]=l>>>2&15|o<<4&48|128;i[b+2>>0]=l<<4&48|f>>>6&15|128;i[b+3>>0]=f&63|128;b=b+4|0}while(0);a=a+2|0}k[e>>2]=o;k[h>>2]=n;return a|0}function gnb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=d;t=g;b=c;a:while(1){r=b;q=f;if(b>>>0>=d>>>0){a=0;break}if(f>>>0>=g>>>0){a=1;break}m=i[b>>0]|0;p=m&255;do if(m<<24>>24>-1){j[f>>1]=m&255;a=q;b=b+1|0}else{if((m&255)<194){a=2;break a}if((m&255)<224){if((s-b|0)<2){a=1;break a}a=l[b+1>>0]|0;if((a&192|0)!=128){a=2;break a}j[f>>1]=a&63|p<<6&1984;a=q;b=b+2|0;break}if((m&255)<240){if((s-b|0)<3){a=1;break a}c=i[b+1>>0]|0;a=i[b+2>>0]|0;switch(m<<24>>24){case -32:{if((c&-32)<<24>>24!=-96){a=2;break a}break}case -19:{if((c&-32)<<24>>24!=-128){a=2;break a}break}default:if((c&-64)<<24>>24!=-128){a=2;break a}}a=a&255;if((a&192|0)!=128){a=2;break a}j[f>>1]=(c&255)<<6&4032|p<<12|a&63;a=q;b=b+3|0;break}if((m&255)>=245){a=2;break a}if((s-r|0)<4){a=1;break a}o=i[b+1>>0]|0;a=i[b+2>>0]|0;c=i[b+3>>0]|0;switch(m<<24>>24){case -16:{if((o+112&255)>=48){a=2;break a}break}case -12:{if((o&-16)<<24>>24!=-128){a=2;break a}break}default:if((o&-64)<<24>>24!=-128){a=2;break a}}n=a&255;if((n&192|0)!=128){a=2;break a}m=c&255;if((m&192|0)!=128){a=2;break a}if((t-f|0)<4){a=1;break a}c=p&7;a=o&255;if((a<<12&196608|c<<18)>>>0>1114111){a=2;break a}j[f>>1]=a<<2&60|n>>>4&3|((a>>>4&3|c<<2)<<6)+16320|55296;a=f+2|0;j[a>>1]=m&63|n<<6&960|56320;b=b+4|0}while(0);f=a+2|0}k[e>>2]=r;k[h>>2]=q;return a|0}function hnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;k[e>>2]=c;return 3}function inb(a){a=a|0;return 0}function jnb(a){a=a|0;return 0}function knb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;m=d;a=0;l=c;a:while(1){if(!(a>>>0<e>>>0&l>>>0<d>>>0)){b=33;break}k=i[l>>0]|0;h=k&255;do if(k<<24>>24<=-1){if((k&255)<194){b=33;break a}if((k&255)<224){if((m-l|0)<2){b=33;break a}if((i[l+1>>0]&-64)<<24>>24!=-128){b=33;break a}b=l+2|0;break}if((k&255)<240){g=l;if((m-g|0)<3){b=33;break a}b=i[l+1>>0]|0;f=i[l+2>>0]|0;switch(k<<24>>24){case -32:{if((b&-32)<<24>>24!=-96){b=14;break a}break}case -19:{if((b&-32)<<24>>24!=-128){b=16;break a}break}default:if((b&-64)<<24>>24!=-128){b=18;break a}}if((f&-64)<<24>>24!=-128){b=33;break a}b=l+3|0;break}if((k&255)>=245){b=33;break a}j=l;if((e-a|0)>>>0<2|(m-j|0)<4){b=33;break a}b=i[l+1>>0]|0;f=i[l+2>>0]|0;g=i[l+3>>0]|0;switch(k<<24>>24){case -16:{if((b+112&255)>=48){b=25;break a}break}case -12:{if((b&-16)<<24>>24!=-128){b=27;break a}break}default:if((b&-64)<<24>>24!=-128){b=29;break a}}if(!((f&-64)<<24>>24==-128&(g&-64)<<24>>24==-128)){b=33;break a}if(((b&255)<<12&196608|h<<18&1835008)>>>0>1114111){b=33;break a}else{a=a+1|0;b=l+4|0}}else b=l+1|0;while(0);a=a+1|0;l=b}if((b|0)==14)a=g-c|0;else if((b|0)==16)a=g-c|0;else if((b|0)==18)a=g-c|0;else if((b|0)==25)a=j-c|0;else if((b|0)==27)a=j-c|0;else if((b|0)==29)a=j-c|0;else if((b|0)==33)a=l-c|0;return a|0}function lnb(a){a=a|0;return 4}function mnb(a){a=a|0;var b=0,c=0,d=0,e=0;k[a>>2]=172152;d=a+8|0;e=a+12|0;c=0;while(1){b=k[d>>2]|0;if(c>>>0>=(k[e>>2]|0)-b>>2>>>0)break;b=k[b+(c<<2)>>2]|0;if(b|0)fob(b);c=c+1|0}kob(a+144|0);c=k[d>>2]|0;do if(c|0){b=k[e>>2]|0;while(1){if((b|0)==(c|0))break;d=b+-4|0;k[e>>2]=d;b=d}if((a+24|0)==(c|0)){i[a+136>>0]=0;break}else{ggb(c);break}}while(0);return}function nnb(a){a=a|0;mnb(a);ggb(a);return}function onb(a){a=a|0;var b=0;k[a>>2]=172172;b=k[a+8>>2]|0;if(b|0?i[a+12>>0]|0:0)ggb(b);return}function pnb(a){a=a|0;onb(a);ggb(a);return}function qnb(a,b){a=a|0;b=b|0;if(b<<24>>24>-1)b=k[166648+((b&255)<<2)>>2]&255;return b|0}function rnb(a,b,c){a=a|0;b=b|0;c=c|0;while(1){if((b|0)==(c|0))break;a=i[b>>0]|0;if(a<<24>>24>-1)a=k[166648+(a<<24>>24<<2)>>2]&255;i[b>>0]=a;b=b+1|0}return c|0}function snb(a,b){a=a|0;b=b|0;if(b<<24>>24>-1)b=k[168184+(b<<24>>24<<2)>>2]&255;return b|0}function tnb(a,b,c){a=a|0;b=b|0;c=c|0;while(1){if((b|0)==(c|0))break;a=i[b>>0]|0;if(a<<24>>24>-1)a=k[168184+(a<<24>>24<<2)>>2]&255;i[b>>0]=a;b=b+1|0}return c|0}function unb(a,b){a=a|0;b=b|0;return b|0}function vnb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)==(c|0))break;i[d>>0]=i[b>>0]|0;d=d+1|0;b=b+1|0}return c|0}function wnb(a,b,c){a=a|0;b=b|0;c=c|0;return (b<<24>>24>-1?b:c)|0}function xnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((b|0)==(c|0))break;a=i[b>>0]|0;i[e>>0]=a<<24>>24>-1?a:d;e=e+1|0;b=b+1|0}return c|0}function ynb(a){a=a|0;k[a>>2]=172224;kob(a+12|0);return}function znb(a){a=a|0;k[a>>2]=172224;kob(a+12|0);ggb(a);return}function Anb(a){a=a|0;return i[a+8>>0]|0}function Bnb(a){a=a|0;return i[a+9>>0]|0}function Cnb(a,b){a=a|0;b=b|0;iob(a,b+12|0);return}function Dnb(a,b){a=a|0;b=b|0;b=a+4|0;k[b>>2]=0;k[b+4>>2]=0;i[a+11>>0]=4;k[a>>2]=1702195828;i[a+4>>0]=0;return}function Enb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;i[a+11>>0]=5;i[a>>0]=i[426481]|0;i[a+1>>0]=i[426482]|0;i[a+2>>0]=i[426483]|0;i[a+3>>0]=i[426484]|0;i[a+4>>0]=i[426485]|0;i[a+5>>0]=0;return}function Fnb(a){a=a|0;k[a>>2]=172264;kob(a+16|0);return}function Gnb(a){a=a|0;k[a>>2]=172264;kob(a+16|0);ggb(a);return}function Hnb(a){a=a|0;return k[a+8>>2]|0}function Inb(a){a=a|0;return k[a+12>>2]|0}function Jnb(a,b){a=a|0;b=b|0;iob(a,b+16|0);return}function Knb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;rob(a,172320,4);return}function Lnb(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;rob(a,172296,5);return}function Mnb(a){a=a|0;ggb(a);return}function Nnb(a){a=a|0;ggb(a);return}function Onb(a,b,c){a=a|0;b=b|0;c=c|0;if(c>>>0<128)a=(j[176922+(c<<1)>>1]&b)<<16>>16!=0;else a=0;return a|0}function Pnb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)==(c|0))break;a=k[b>>2]|0;if(a>>>0<128)a=m[176922+(a<<1)>>1]|0;else a=0;j[d>>1]=a;d=d+2|0;b=b+4|0}return c|0}function Qnb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((c|0)==(d|0)){c=d;break}a=k[c>>2]|0;if(a>>>0<128?(j[176922+(a<<1)>>1]&b)<<16>>16:0)break;c=c+4|0}return c|0}function Rnb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((c|0)==(d|0)){c=d;break}a=k[c>>2]|0;if(a>>>0>=128)break;if(!((j[176922+(a<<1)>>1]&b)<<16>>16))break;c=c+4|0}return c|0}function Snb(a,b){a=a|0;b=b|0;if(b>>>0<128)b=k[166648+(b<<2)>>2]|0;return b|0}function Tnb(a,b,c){a=a|0;b=b|0;c=c|0;while(1){if((b|0)==(c|0))break;a=k[b>>2]|0;if(a>>>0<128)a=k[166648+(a<<2)>>2]|0;k[b>>2]=a;b=b+4|0}return c|0}function Unb(a,b){a=a|0;b=b|0;if(b>>>0<128)b=k[168184+(b<<2)>>2]|0;return b|0}function Vnb(a,b,c){a=a|0;b=b|0;c=c|0;while(1){if((b|0)==(c|0))break;a=k[b>>2]|0;if(a>>>0<128)a=k[168184+(a<<2)>>2]|0;k[b>>2]=a;b=b+4|0}return c|0}function Wnb(a,b){a=a|0;b=b|0;return b<<24>>24|0}function Xnb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)==(c|0))break;k[d>>2]=i[b>>0];d=d+4|0;b=b+1|0}return c|0}function Ynb(a,b,c){a=a|0;b=b|0;c=c|0;return (b>>>0<128?b&255:c)|0}function Znb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=c-b|0;a=e;e=b;while(1){if((e|0)==(c|0))break;g=k[e>>2]|0;i[a>>0]=g>>>0<128?g&255:d;a=a+1|0;e=e+4|0}return b+(f>>>2<<2)|0}function _nb(a){a=a|0;ggb(a);return}function $nb(a){a=a|0;ggb(a);return}function aob(a){a=a|0;ggb(a);return}function bob(){ad(426534,426557,304,426811)}function cob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;g=a+4|0;k[g>>2]=(k[g>>2]|0)+1;g=k[107137]|0;h=k[107136]|0;j=g-h>>2;c=h;if(j>>>0<=b>>>0){f=b+1|0;e=g;a:do if(f>>>0>j>>>0){c=f-j|0;d=k[107138]|0;if(d-g>>2>>>0>=c>>>0){dob(c);break}if(f>>>0>1073741823)bob();h=d-h|0;d=h>>1;d=h>>2>>>0<536870911?(d>>>0<f>>>0?f:d):1073741823;do if(d)if(d>>>0<29&(i[428672]|0)==0){i[428672]=1;e=428560;break}else{e=gob(d<<2)|0;break}else e=0;while(0);f=e+(j<<2)|0;h=e+(d<<2)|0;g=f;d=f;do{k[d>>2]=0;d=g+4|0;g=d;c=c+-1|0}while((c|0)!=0);d=k[107136]|0;c=d;e=(k[107137]|0)-c|0;f=f+(0-(e>>2)<<2)|0;if((e|0)>0){upb(f|0,d|0,e|0)|0;c=k[107136]|0}k[107136]=f;k[107137]=g;k[107138]=h;if(c|0)if((c|0)==428560){i[428672]=0;break}else{ggb(c);break}}else if(f>>>0<j>>>0){d=c+(f<<2)|0;c=e;while(1){if((c|0)==(d|0))break a;j=c+-4|0;k[107137]=j;c=j}}while(0);c=k[107136]|0}d=k[c+(b<<2)>>2]|0;if(d){fob(d);c=k[107136]|0}k[c+(b<<2)>>2]=a;return}function dob(a){a=a|0;var b=0;b=k[107137]|0;do{k[b>>2]=0;b=(k[107137]|0)+4|0;k[107137]=b;a=a+-1|0}while((a|0)!=0);return}function eob(a){a=a|0;var b=0,c=0,d=0;if(!(i[428696]|0)){i[428696]=1;if(!(i[428528]|0)){i[428528]=1;k[107135]=0;k[107134]=172152;i[428672]=1;k[107137]=428560;k[107136]=428560;k[107138]=428672;dob(28);k[107170]=0;k[107171]=0;k[107172]=0;i[428691]=1;i[428680]=67;i[428681]=0;b=k[107136]|0;c=k[107137]|0;while(1){if((c|0)==(b|0))break;d=c+-4|0;k[107137]=d;c=d}k[107055]=0;k[107054]=169816;cob(428216,Wib(828756)|0);k[107057]=0;k[107056]=169848;cob(428224,Wib(828764)|0);k[107059]=0;k[107058]=172172;i[428244]=0;k[107060]=176922;cob(428232,Wib(828772)|0);k[107063]=0;k[107062]=172368;cob(428248,Wib(828804)|0);k[107065]=0;k[107064]=172436;cob(428256,Wib(830540)|0);k[107067]=0;k[107066]=172104;b=Uib()|0;k[107068]=b;cob(428264,Wib(830548)|0);k[107071]=0;k[107070]=172484;cob(428280,Wib(830556)|0);k[107073]=0;k[107072]=172532;cob(428288,Wib(830564)|0);k[107075]=0;k[107074]=172224;i[428304]=46;i[428305]=44;k[107077]=0;k[107078]=0;k[107079]=0;b=0;while(1){if((b|0)==3)break;k[428308+(b<<2)>>2]=0;b=b+1|0}cob(428296,Wib(828788)|0);k[107081]=0;k[107080]=172264;k[107082]=46;k[107083]=44;k[107084]=0;k[107085]=0;k[107086]=0;b=0;while(1){if((b|0)==3)break;k[428336+(b<<2)>>2]=0;b=b+1|0}cob(428320,Wib(828812)|0);k[107089]=0;k[107088]=169880;cob(428352,Wib(828796)|0);k[107091]=0;k[107090]=169944;cob(428360,Wib(828820)|0);k[107093]=0;k[107092]=170008;cob(428368,Wib(828828)|0);k[107095]=0;k[107094]=170060;cob(428376,Wib(828836)|0);k[107097]=0;k[107096]=171608;cob(428384,Wib(830460)|0);k[107099]=0;k[107098]=171664;cob(428392,Wib(830468)|0);k[107101]=0;k[107100]=171720;cob(428400,Wib(830476)|0);k[107103]=0;k[107102]=171776;cob(428408,Wib(830484)|0);k[107105]=0;k[107104]=171832;cob(428416,Wib(830492)|0);k[107107]=0;k[107106]=171860;cob(428424,Wib(830500)|0);k[107109]=0;k[107108]=171888;cob(428432,Wib(830508)|0);k[107111]=0;k[107110]=171916;cob(428440,Wib(830516)|0);k[107113]=0;k[107112]=170112;k[107114]=170160;cob(428448,Wib(829624)|0);k[107117]=0;k[107116]=170196;k[107118]=170244;cob(428464,Wib(830436)|0);k[107121]=0;k[107120]=172348;d=Uib()|0;k[107122]=d;k[107120]=171560;cob(428480,Wib(830444)|0);k[107125]=0;k[107124]=172348;d=Uib()|0;k[107126]=d;k[107124]=171584;cob(428496,Wib(830452)|0);k[107129]=0;k[107128]=171944;cob(428512,Wib(830524)|0);k[107131]=0;k[107130]=171976;cob(428520,Wib(830532)|0);k[207643]=428536}d=k[207643]|0;k[207644]=d;d=d+4|0;k[d>>2]=(k[d>>2]|0)+1}d=k[207644]|0;k[a>>2]=d;d=d+4|0;k[d>>2]=(k[d>>2]|0)+1;return}function fob(a){a=a|0;var b=0,c=0;c=a+4|0;b=k[c>>2]|0;k[c>>2]=b+-1;if(!b)Uh[k[(k[a>>2]|0)+8>>2]&2047](a);return}function gob(a){a=a|0;var b=0;b=(a|0)==0?1:a;while(1){a=fgb(b)|0;if(a|0)break;a=k[207666]|0;k[207666]=a+0;if(!a){a=0;break}Qh[a&7]()}return a|0}function hob(){ad(426704,426733,1183,426811)}function iob(a,b){a=a|0;b=b|0;k[a>>2]=0;k[a+4>>2]=0;k[a+8>>2]=0;if((i[b+11>>0]|0)<0)job(a,k[b>>2]|0,k[b+4>>2]|0);else{k[a>>2]=k[b>>2];k[a+4>>2]=k[b+4>>2];k[a+8>>2]=k[b+8>>2]}return}function job(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;if(c>>>0>4294967279)hob();if(c>>>0<11){i[a+11>>0]=c;if(c)d=6}else{e=c+16&-16;d=gob(e)|0;k[a>>2]=d;k[a+8>>2]=e|-2147483648;k[a+4>>2]=c;a=d;d=6}if((d|0)==6)upb(a|0,b|0,c|0)|0;i[a+c>>0]=0;return}function kob(a){a=a|0;if((i[a+11>>0]|0)<0)ggb(k[a>>2]|0);return}function lob(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=a+11|0;d=(i[e>>0]|0)<0;if(d)g=(k[a+8>>2]&2147483647)+-1|0;else g=10;do if(g>>>0>=c>>>0){if(d)d=k[a>>2]|0;else d=a;if(c|0)wpb(d|0,b|0,c|0)|0;i[d+c>>0]=0;if((i[e>>0]|0)<0){k[a+4>>2]=c;break}else{i[e>>0]=c;break}}else{if((-18-g|0)>>>0<(c-g|0)>>>0)hob();if(d)f=k[a>>2]|0;else f=a;if(g>>>0<2147483623){d=g<<1;d=d>>>0>c>>>0?d:c;d=d>>>0<11?11:d+16&-16}else d=-17;e=gob(d)|0;if(c|0)upb(e|0,b|0,c|0)|0;if((g|0)!=10)ggb(f);k[a>>2]=e;k[a+8>>2]=d|-2147483648;k[a+4>>2]=c;i[e+c>>0]=0}while(0);return}function mob(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0,m=0;l=a+11|0;h=i[l>>0]|0;d=h<<24>>24<0;if(d){m=k[a+4>>2]|0;c=(k[a+8>>2]&2147483647)+-1|0}else{m=h&255;c=10}b=m>>>0<11;j=b?10:(m+16&-16)+-1|0;do if((j|0)!=(c|0)){do if(b){c=k[a>>2]|0;if(d){b=0;d=a;g=10}else{b=0;f=1;d=a;g=11}}else{e=gob(j+1|0)|0;if(d){b=1;c=k[a>>2]|0;d=e;g=10;break}else{b=1;f=0;c=a;d=e;g=11;break}}while(0);if((g|0)==10){e=b;f=1;b=k[a+4>>2]|0}else if((g|0)==11){e=b;b=h&255}b=b+1|0;if(b|0)upb(d|0,c|0,b|0)|0;if(f)ggb(c);if(e){k[a+8>>2]=j+1|-2147483648;k[a+4>>2]=m;k[a>>2]=d;break}else{i[l>>0]=m;break}}while(0);return}function nob(a,b){a=a|0;b=b|0;lob(a,b,hfb(b)|0);return}function oob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;g=a+11|0;c=i[g>>0]|0;e=c<<24>>24<0;if(e)d=k[a+4>>2]|0;else d=c&255;do if(d>>>0<b>>>0){f=b-d|0;if(f|0){if(e){d=k[a+4>>2]|0;b=(k[a+8>>2]&2147483647)+-1|0}else{d=c&255;b=10}if((b-d|0)>>>0<f>>>0){pob(a,b,f-b+d|0,d,d);c=i[g>>0]|0}if(c<<24>>24<0)b=k[a>>2]|0;else b=a;zpb(b+d|0,0,f|0)|0;c=d+f|0;if((i[g>>0]|0)<0)k[a+4>>2]=c;else i[g>>0]=c;i[b+c>>0]=0}}else if(e){i[(k[a>>2]|0)+b>>0]=0;k[a+4>>2]=b;break}else{i[a+b>>0]=0;i[g>>0]=b;break}while(0);return}function pob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;if((-17-b|0)>>>0<c>>>0)hob();if((i[a+11>>0]|0)<0)h=k[a>>2]|0;else h=a;if(b>>>0<2147483623){f=c+b|0;g=b<<1;f=f>>>0<g>>>0?g:f;f=f>>>0<11?11:f+16&-16}else f=-17;g=gob(f)|0;if(e|0)upb(g|0,h|0,e|0)|0;c=d-e|0;if(c|0)upb(g+e|0,h+e|0,c|0)|0;if((b|0)!=10)ggb(h);k[a>>2]=g;k[a+8>>2]=f|-2147483648;return}function qob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=a+11|0;c=i[f>>0]|0;d=c<<24>>24<0;if(d){e=k[a+4>>2]|0;c=(k[a+8>>2]&2147483647)+-1|0}else{e=c&255;c=10}if((e|0)==(c|0)){pob(a,c,1,c,c);if((i[f>>0]|0)>-1)c=7;else c=8}else if(d)c=8;else c=7;if((c|0)==7)i[f>>0]=e+1;else if((c|0)==8){f=k[a>>2]|0;k[a+4>>2]=e+1;a=f}f=a+e|0;i[f>>0]=b;i[f+1>>0]=0;return}function rob(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;if(c>>>0>1073741807)hob();do if(c>>>0>=2){e=c+4&-4;if(e>>>0>1073741823)ad(426832,426869,1734,426947);else{d=gob(e<<2)|0;k[a>>2]=d;k[a+8>>2]=e|-2147483648;k[a+4>>2]=c;break}}else{i[a+8+3>>0]=c;d=a}while(0);vhb(d,b,c);k[d+(c<<2)>>2]=0;return}function sob(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;if(b>>>0>1073741807)hob();do if(b>>>0<2){i[a+8+3>>0]=b;if(!b)e=a;else{e=a;f=8}}else{d=b+4&-4;if(d>>>0>1073741823)ad(426832,426869,1734,426947);else{e=gob(d<<2)|0;k[a>>2]=e;k[a+8>>2]=d|-2147483648;k[a+4>>2]=b;f=8;break}}while(0);if((f|0)==8){a=b;d=e;while(1){a=a+-1|0;k[d>>2]=c;if(!a)break;else d=d+4|0}}k[e+(b<<2)>>2]=0;return}function tob(a){a=a|0;if((i[a+8+3>>0]|0)<0)ggb(k[a>>2]|0);return}function uob(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,l=0;j=a+8|0;g=j+3|0;e=i[g>>0]|0;f=e<<24>>24<0;if(f){l=k[a+4>>2]|0;c=(k[j>>2]&2147483647)+-1|0}else{l=e&255;c=1}b=l>>>0<2;h=b?1:(l+4&-4)+-1|0;do if((h|0)!=(c|0)){do if(b){b=k[a>>2]|0;if(f){e=0;c=b;d=a;f=13}else{vhb(a,b,(e&255)+1|0);ggb(b);f=16}}else{c=h+1|0;if(c>>>0>1073741823)ad(426832,426869,1734,426947);d=gob(c<<2)|0;if(f){e=1;c=k[a>>2]|0;f=13;break}else{vhb(d,a,(e&255)+1|0);b=a+4|0;f=15;break}}while(0);if((f|0)==13){b=a+4|0;vhb(d,c,(k[b>>2]|0)+1|0);ggb(c);if(e){c=h+1|0;f=15}else f=16}if((f|0)==15){k[j>>2]=c|-2147483648;k[b>>2]=l;k[a>>2]=d;break}else if((f|0)==16){i[g>>0]=l;break}}while(0);return}function vob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0;c=b;while(1)if(!(k[c>>2]|0))break;else c=c+4|0;d=b;j=c-d>>2;f=a+8|0;h=f+3|0;c=(i[h>>0]|0)<0;if(c)e=(k[f>>2]&2147483647)+-1|0;else e=1;do if(j>>>0<=e>>>0){if(c)f=k[a>>2]|0;else f=a;if(j|0)if(f-d>>2>>>0<j>>>0){c=j;do{c=c+-1|0;k[f+(c<<2)>>2]=k[b+(c<<2)>>2]}while((c|0)!=0)}else{c=b;d=f;e=j;while(1){e=e+-1|0;k[d>>2]=k[c>>2];if(!e)break;else{c=c+4|0;d=d+4|0}}}k[f+(j<<2)>>2]=0;if((i[h>>0]|0)<0){k[a+4>>2]=j;break}else{i[h>>0]=j;break}}else{if((1073741806-e|0)>>>0<(j-e|0)>>>0)hob();if(c)d=k[a>>2]|0;else d=a;if(e>>>0<536870887){c=e<<1;c=j>>>0<c>>>0?c:j;c=c>>>0<2?2:c+4&-4;if(c>>>0>1073741823)ad(426832,426869,1734,426947);else g=c}else g=1073741807;c=gob(g<<2)|0;if(j|0)vhb(c,b,j);if((e|0)!=1)ggb(d);k[a>>2]=c;k[f>>2]=g|-2147483648;k[a+4>>2]=j;k[c+(j<<2)>>2]=0}while(0);return}function wob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;if((1073741807-b|0)>>>0<c>>>0)hob();j=a+8|0;if((i[j+3>>0]|0)<0)h=k[a>>2]|0;else h=a;if(b>>>0<536870887){c=c+b|0;f=b<<1;c=c>>>0<f>>>0?f:c;c=c>>>0<2?2:c+4&-4;if(c>>>0>1073741823)ad(426832,426869,1734,426947);else g=c}else g=1073741807;f=gob(g<<2)|0;if(e|0)vhb(f,h,e);c=d-e|0;if(c|0)vhb(f+(e<<2)|0,h+(e<<2)|0,c);if((b|0)!=1)ggb(h);k[a>>2]=f;k[j>>2]=g|-2147483648;return}function xob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=a+8|0;g=d+3|0;c=i[g>>0]|0;e=c<<24>>24<0;if(e){f=k[a+4>>2]|0;c=(k[d>>2]&2147483647)+-1|0}else{f=c&255;c=1}if((f|0)==(c|0)){wob(a,c,1,c,c);if((i[g>>0]|0)>-1)c=7;else c=8}else if(e)c=8;else c=7;if((c|0)==7)i[g>>0]=f+1;else if((c|0)==8){g=k[a>>2]|0;k[a+4>>2]=f+1;a=g}g=a+(f<<2)|0;k[g>>2]=b;k[g+4>>2]=0;return}function yob(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0,h=0;a=r;r=r+48|0;g=a+40|0;c=a+32|0;h=a+24|0;f=a+8|0;e=a+44|0;if(Ud(830656,4)|0)zob(427231,a);a=Ue(k[207665]|0)|0;if(a|0?(d=k[a>>2]|0,d|0):0){b=d+48|0;a=k[b>>2]|0;b=k[b+4>>2]|0;if(!((a&-256|0)==1126902528&(b|0)==1129074247)){k[c>>2]=427092;zob(427042,c)}if((a|0)==1126902529&(b|0)==1129074247)a=k[d+44>>2]|0;else a=d+80|0;k[e>>2]=a;d=k[d>>2]|0;a=k[d+4>>2]|0;if(Eob(28752,d,e)|0){h=k[e>>2]|0;h=Xh[k[(k[h>>2]|0)+8>>2]&1023](h)|0;k[f>>2]=427092;k[f+4>>2]=a;k[f+8>>2]=h;zob(426956,f)}else{k[h>>2]=427092;k[h+4>>2]=a;zob(427001,h)}}zob(427080,g)}function zob(a,b){a=a|0;b=b|0;var c=0;c=r;r=r+16|0;k[c>>2]=b;mfb(165912,a,c)|0;agb(10,165912);Ne()}function Aob(a){a=a|0;return}function Bob(a){a=a|0;ggb(a);return}function Cob(a){a=a|0;return}function Dob(a){a=a|0;return}function Eob(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;g=r;r=r+64|0;e=g;if((a|0)!=(b|0))if((b|0)!=0?(f=Kob(b,28776,28760,0)|0,(f|0)!=0):0){b=e+4|0;d=b+52|0;do{k[b>>2]=0;b=b+4|0}while((b|0)<(d|0));k[e>>2]=f;k[e+8>>2]=a;k[e+12>>2]=-1;k[e+48>>2]=1;dh[k[(k[f>>2]|0)+28>>2]&255](f,e,k[c>>2]|0,1);if((k[e+24>>2]|0)==1){k[c>>2]=k[e+16>>2];b=1}else b=0}else b=0;else b=1;r=g;return b|0}function Fob(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if((a|0)==(k[b+8>>2]|0))Job(b,c,d,e);return}function Gob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;do if((a|0)==(k[b+8>>2]|0)){if((k[b+4>>2]|0)==(c|0)?(f=b+28|0,(k[f>>2]|0)!=1):0)k[f>>2]=d}else if((a|0)==(k[b>>2]|0)){if((k[b+16>>2]|0)!=(c|0)?(g=b+20|0,(k[g>>2]|0)!=(c|0)):0){k[b+32>>2]=d;k[g>>2]=c;e=b+40|0;k[e>>2]=(k[e>>2]|0)+1;if((k[b+36>>2]|0)==1?(k[b+24>>2]|0)==2:0)i[b+54>>0]=1;k[b+44>>2]=4;break}if((d|0)==1)k[b+32>>2]=1}while(0);return}function Hob(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if((a|0)==(k[b+8>>2]|0))Iob(b,c,d);return}function Iob(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=a+16|0;e=k[d>>2]|0;do if(e){if((e|0)!=(b|0)){c=a+36|0;k[c>>2]=(k[c>>2]|0)+1;k[a+24>>2]=2;i[a+54>>0]=1;break}a=a+24|0;if((k[a>>2]|0)==2)k[a>>2]=c}else{k[d>>2]=b;k[a+24>>2]=c;k[a+36>>2]=1}while(0);return}function Job(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;i[a+53>>0]=1;do if((k[a+4>>2]|0)==(c|0)){i[a+52>>0]=1;e=a+16|0;c=k[e>>2]|0;if(!c){k[e>>2]=b;k[a+24>>2]=d;k[a+36>>2]=1;if(!((d|0)==1?(k[a+48>>2]|0)==1:0))break;i[a+54>>0]=1;break}if((c|0)!=(b|0)){d=a+36|0;k[d>>2]=(k[d>>2]|0)+1;i[a+54>>0]=1;break}e=a+24|0;c=k[e>>2]|0;if((c|0)==2){k[e>>2]=d;c=d}if((c|0)==1?(k[a+48>>2]|0)==1:0)i[a+54>>0]=1}while(0);return}function Kob(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0;q=r;r=r+64|0;o=q;n=k[a>>2]|0;p=a+(k[n+-8>>2]|0)|0;n=k[n+-4>>2]|0;k[o>>2]=c;k[o+4>>2]=a;k[o+8>>2]=b;k[o+12>>2]=d;a=o+16|0;b=o+20|0;d=o+24|0;e=o+28|0;f=o+32|0;g=o+40|0;h=(n|0)==(c|0);l=a;m=l+36|0;do{k[l>>2]=0;l=l+4|0}while((l|0)<(m|0));j[a+36>>1]=0;i[a+38>>0]=0;a:do if(h){k[o+48>>2]=1;Lg[k[(k[c>>2]|0)+20>>2]&255](c,o,p,p,1,0);a=(k[d>>2]|0)==1?p:0}else{eh[k[(k[n>>2]|0)+24>>2]&255](n,o,p,1,0);switch(k[o+36>>2]|0){case 0:{a=(k[g>>2]|0)==1&(k[e>>2]|0)==1&(k[f>>2]|0)==1?k[b>>2]|0:0;break a}case 1:break;default:{a=0;break a}}if((k[d>>2]|0)!=1?!((k[g>>2]|0)==0&(k[e>>2]|0)==1&(k[f>>2]|0)==1):0){a=0;break}a=k[a>>2]|0}while(0);r=q;return a|0}function Lob(a){a=a|0;ggb(a);return}function Mob(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if((a|0)==(k[b+8>>2]|0))Job(b,c,d,e);else{a=k[a+8>>2]|0;Lg[k[(k[a>>2]|0)+20>>2]&255](a,b,c,d,e,f)}return}function Nob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;do if((a|0)==(k[b+8>>2]|0)){if((k[b+4>>2]|0)==(c|0)?(f=b+28|0,(k[f>>2]|0)!=1):0)k[f>>2]=d}else{if((a|0)!=(k[b>>2]|0)){h=k[a+8>>2]|0;eh[k[(k[h>>2]|0)+24>>2]&255](h,b,c,d,e);break}if((k[b+16>>2]|0)!=(c|0)?(h=b+20|0,(k[h>>2]|0)!=(c|0)):0){k[b+32>>2]=d;g=b+44|0;if((k[g>>2]|0)==4)break;f=b+52|0;i[f>>0]=0;d=b+53|0;i[d>>0]=0;a=k[a+8>>2]|0;Lg[k[(k[a>>2]|0)+20>>2]&255](a,b,c,c,1,e);if(i[d>>0]|0)if(!(i[f>>0]|0)){f=1;d=13}else d=17;else{f=0;d=13}do if((d|0)==13){k[h>>2]=c;c=b+40|0;k[c>>2]=(k[c>>2]|0)+1;if((k[b+36>>2]|0)==1?(k[b+24>>2]|0)==2:0){i[b+54>>0]=1;if(f){d=17;break}else{f=4;break}}if(f)d=17;else f=4}while(0);if((d|0)==17)f=3;k[g>>2]=f;break}if((d|0)==1)k[b+32>>2]=1}while(0);return}function Oob(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if((a|0)==(k[b+8>>2]|0))Iob(b,c,d);else{a=k[a+8>>2]|0;dh[k[(k[a>>2]|0)+28>>2]&255](a,b,c,d)}return}function Pob(){var a=0;a=r;r=r+16|0;if(!(He(830660,1536)|0)){r=a;return}else zob(427280,a)}function Qob(a){a=a|0;var b=0;b=r;r=r+16|0;ggb(a);if(!(zf(k[207665]|0,0)|0)){r=b;return}else zob(427330,b)}function Rob(a){a=a|0;var b=0;b=r;r=r+16|0;Qh[a&7]();zob(427383,b)}function Sob(a){a=a|0;return}function Tob(a){a=a|0;ggb(a);return}function Uob(a){a=a|0;return 427423}function Vob(a){a=a|0;ggb(a);return}function Wob(a,b,c){a=a|0;b=b|0;c=c|0;return (a|0)==(b|0)|0}function Xob(a){a=a|0;ggb(a);return}function Yob(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=r;r=r+64|0;h=i;k[c>>2]=k[k[c>>2]>>2];if(!((a|0)==(b|0)|(b|0)==28888))if(((b|0)!=0?(d=Kob(b,28776,28848,0)|0,(d|0)!=0):0)?(k[d+8>>2]&~k[a+8>>2]|0)==0:0){b=k[a+12>>2]|0;a=d+12|0;if(!((b|0)==28880?1:(b|0)==(k[a>>2]|0)))if((((b|0)!=0?(f=Kob(b,28776,28760,0)|0,(f|0)!=0):0)?(e=k[a>>2]|0,(e|0)!=0):0)?(g=Kob(e,28776,28760,0)|0,(g|0)!=0):0){a=h+4|0;b=a+52|0;do{k[a>>2]=0;a=a+4|0}while((a|0)<(b|0));k[h>>2]=g;k[h+8>>2]=f;k[h+12>>2]=-1;k[h+48>>2]=1;dh[k[(k[g>>2]|0)+28>>2]&255](g,h,k[c>>2]|0,1);if((k[h+24>>2]|0)==1){k[c>>2]=k[h+16>>2];a=1}else a=0}else a=0;else a=1}else a=0;else a=1;r=i;return a|0}function Zob(a){a=a|0;ggb(a);return}function _ob(a,b,c){a=a|0;b=b|0;c=c|0;return (a|0)==(b|0)|0}function $ob(a){a=a|0;ggb(a);return}function apb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((a|0)==(k[b+8>>2]|0))Job(b,c,d,e);else{r=b+52|0;m=j[r>>1]|0;h=m&255;l=b+53|0;m=(m&65535)>>>8&255;q=k[a+12>>2]|0;n=a+16+(q<<3)|0;i[r>>0]=0;i[l>>0]=0;epb(a+16|0,b,c,d,e,f);a:do if((q|0)>1){o=b+24|0;p=a+8|0;q=b+54|0;a=a+24|0;do{if(i[q>>0]|0)break a;g=j[r>>1]|0;if(!((g&255)<<24>>24)){if((g&65535)>=256?(k[p>>2]&1|0)==0:0)break a}else{if((k[o>>2]|0)==1)break a;if(!(k[p>>2]&2))break a}i[r>>0]=0;i[l>>0]=0;epb(a,b,c,d,e,f);a=a+8|0}while(a>>>0<n>>>0)}while(0);i[r>>0]=h;i[l>>0]=m}return}function bpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;a:do if((a|0)==(k[b+8>>2]|0)){if((k[b+4>>2]|0)==(c|0)?(f=b+28|0,(k[f>>2]|0)!=1):0)k[f>>2]=d}else{if((a|0)!=(k[b>>2]|0)){q=k[a+12>>2]|0;h=a+16+(q<<3)|0;fpb(a+16|0,b,c,d,e);f=a+24|0;if((q|0)<=1)break;a=k[a+8>>2]|0;if((a&2|0)==0?(j=b+36|0,(k[j>>2]|0)!=1):0){if(!(a&1)){a=b+54|0;while(1){if(i[a>>0]|0)break a;if((k[j>>2]|0)==1)break a;fpb(f,b,c,d,e);f=f+8|0;if(f>>>0>=h>>>0)break a}}a=b+24|0;g=b+54|0;while(1){if(i[g>>0]|0)break a;if((k[j>>2]|0)==1?(k[a>>2]|0)==1:0)break a;fpb(f,b,c,d,e);f=f+8|0;if(f>>>0>=h>>>0)break a}}a=b+54|0;while(1){if(i[a>>0]|0)break a;fpb(f,b,c,d,e);f=f+8|0;if(f>>>0>=h>>>0)break a}}if((k[b+16>>2]|0)!=(c|0)?(q=b+20|0,(k[q>>2]|0)!=(c|0)):0){k[b+32>>2]=d;p=b+44|0;if((k[p>>2]|0)==4)break;j=a+16+(k[a+12>>2]<<3)|0;d=b+52|0;l=b+53|0;n=b+54|0;m=a+8|0;o=b+24|0;f=0;g=a+16|0;h=0;b:while(1){if(g>>>0>=j>>>0){a=20;break}i[d>>0]=0;i[l>>0]=0;epb(g,b,c,c,1,e);if(i[n>>0]|0){a=20;break}do if(i[l>>0]|0){if(!(i[d>>0]|0))if(!(k[m>>2]&1)){f=1;a=20;break b}else{f=1;a=h;break}if((k[o>>2]|0)==1){a=25;break b}if(!(k[m>>2]&2)){a=25;break b}else{f=1;a=1}}else a=h;while(0);g=g+8|0;h=a}do if((a|0)==20){if((!h?(k[q>>2]=c,c=b+40|0,k[c>>2]=(k[c>>2]|0)+1,(k[b+36>>2]|0)==1):0)?(k[o>>2]|0)==2:0){i[n>>0]=1;if(f){a=25;break}else{f=4;break}}if(f)a=25;else f=4}while(0);if((a|0)==25)f=3;k[p>>2]=f;break}if((d|0)==1)k[b+32>>2]=1}while(0);return}function cpb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a:do if((a|0)!=(k[b+8>>2]|0)){f=k[a+12>>2]|0;e=a+16+(f<<3)|0;dpb(a+16|0,b,c,d);if((f|0)>1){f=b+54|0;a=a+24|0;do{dpb(a,b,c,d);if(i[f>>0]|0)break a;a=a+8|0}while(a>>>0<e>>>0)}}else Iob(b,c,d);while(0);return}function dpb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;f=k[a+4>>2]|0;e=f>>8;if(f&1)e=k[(k[c>>2]|0)+e>>2]|0;a=k[a>>2]|0;dh[k[(k[a>>2]|0)+28>>2]&255](a,b,c+e|0,f&2|0?d:2);return}function epb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;h=k[a+4>>2]|0;g=h>>8;if(h&1)g=k[(k[d>>2]|0)+g>>2]|0;a=k[a>>2]|0;Lg[k[(k[a>>2]|0)+20>>2]&255](a,b,c,d+g|0,h&2|0?e:2,f);return}function fpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;g=k[a+4>>2]|0;f=g>>8;if(g&1)f=k[(k[c>>2]|0)+f>>2]|0;a=k[a>>2]|0;eh[k[(k[a>>2]|0)+24>>2]&255](a,b,c+f|0,g&2|0?d:2,e);return}function gpb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=r;r=r+16|0;d=e;k[d>>2]=k[c>>2];a=ci[k[(k[a>>2]|0)+16>>2]&255](a,b,d)|0;if(a)k[c>>2]=k[d>>2];r=e;return a&1|0}function hpb(a){a=a|0;if(!a)a=0;else a=(Kob(a,28776,28848,0)|0)!=0;return a&1|0}function ipb(){}function jpb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=b-d-(c>>>0>a>>>0|0)>>>0;return (N=d,a-c>>>0|0)|0}function kpb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c=a+c>>>0;return (N=b+d+(c>>>0<a>>>0|0)>>>0,c|0)|0}function lpb(a){a=a|0;return 0}function mpb(a){a=a|0;return 0}function npb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;A=A+1|0;k[a>>2]=A;while((e|0)<(d|0)){if(!(k[c+(e<<3)>>2]|0)){k[c+(e<<3)>>2]=A;k[c+((e<<3)+4)>>2]=b;k[c+((e<<3)+8)>>2]=0;N=d;return c|0}e=e+1|0}d=d*2|0;c=hgb(c|0,8*(d+1|0)|0)|0;c=npb(a|0,b|0,c|0,d|0)|0;N=d;return c|0}function opb(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){N=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}N=(b|0)<0?-1:0;return b>>c-32|0}function ppb(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){N=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}N=0;return b>>>c-32|0}function qpb(a){a=a|0;var b=0;b=i[w+(a&255)>>0]|0;if((b|0)<8)return b|0;b=i[w+(a>>8&255)>>0]|0;if((b|0)<8)return b+8|0;b=i[w+(a>>16&255)>>0]|0;if((b|0)<8)return b+16|0;return (i[w+(a>>>24)>>0]|0)+24|0}function rpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;l=a;i=b;j=i;g=c;n=d;h=n;if(!j){f=(e|0)!=0;if(!h){if(f){k[e>>2]=(l>>>0)%(g>>>0);k[e+4>>2]=0}n=0;e=(l>>>0)/(g>>>0)>>>0;return (N=n,e)|0}else{if(!f){n=0;e=0;return (N=n,e)|0}k[e>>2]=a|0;k[e+4>>2]=b&0;n=0;e=0;return (N=n,e)|0}}f=(h|0)==0;do if(g){if(!f){f=(da(h|0)|0)-(da(j|0)|0)|0;if(f>>>0<=31){m=f+1|0;h=31-f|0;b=f-31>>31;g=m;a=l>>>(m>>>0)&b|j<<h;b=j>>>(m>>>0)&b;f=0;h=l<<h;break}if(!e){n=0;e=0;return (N=n,e)|0}k[e>>2]=a|0;k[e+4>>2]=i|b&0;n=0;e=0;return (N=n,e)|0}f=g-1|0;if(f&g|0){h=(da(g|0)|0)+33-(da(j|0)|0)|0;p=64-h|0;m=32-h|0;i=m>>31;o=h-32|0;b=o>>31;g=h;a=m-1>>31&j>>>(o>>>0)|(j<<m|l>>>(h>>>0))&b;b=b&j>>>(h>>>0);f=l<<p&i;h=(j<<p|l>>>(o>>>0))&i|l<<m&h-33>>31;break}if(e|0){k[e>>2]=f&l;k[e+4>>2]=0}if((g|0)==1){o=i|b&0;p=a|0|0;return (N=o,p)|0}else{p=qpb(g|0)|0;o=j>>>(p>>>0)|0;p=j<<32-p|l>>>(p>>>0)|0;return (N=o,p)|0}}else{if(f){if(e|0){k[e>>2]=(j>>>0)%(g>>>0);k[e+4>>2]=0}o=0;p=(j>>>0)/(g>>>0)>>>0;return (N=o,p)|0}if(!l){if(e|0){k[e>>2]=0;k[e+4>>2]=(j>>>0)%(h>>>0)}o=0;p=(j>>>0)/(h>>>0)>>>0;return (N=o,p)|0}f=h-1|0;if(!(f&h)){if(e|0){k[e>>2]=a|0;k[e+4>>2]=f&j|b&0}o=0;p=j>>>((qpb(h|0)|0)>>>0);return (N=o,p)|0}f=(da(h|0)|0)-(da(j|0)|0)|0;if(f>>>0<=30){b=f+1|0;h=31-f|0;g=b;a=j<<h|l>>>(b>>>0);b=j>>>(b>>>0);f=0;h=l<<h;break}if(!e){o=0;p=0;return (N=o,p)|0}k[e>>2]=a|0;k[e+4>>2]=i|b&0;o=0;p=0;return (N=o,p)|0}while(0);if(!g){j=h;i=0;h=0}else{m=c|0|0;l=n|d&0;j=kpb(m|0,l|0,-1,-1)|0;c=N;i=h;h=0;do{d=i;i=f>>>31|i<<1;f=h|f<<1;d=a<<1|d>>>31|0;n=a>>>31|b<<1|0;jpb(j|0,c|0,d|0,n|0)|0;p=N;o=p>>31|((p|0)<0?-1:0)<<1;h=o&1;a=jpb(d|0,n|0,o&m|0,(((p|0)<0?-1:0)>>31|((p|0)<0?-1:0)<<1)&l|0)|0;b=N;g=g-1|0}while((g|0)!=0);j=i;i=0}g=0;if(e|0){k[e>>2]=a;k[e+4>>2]=b}o=(f|0)>>>31|(j|g)<<1|(g<<1|f>>>31)&0|i;p=(f<<1|0>>>31)&-2|h;return (N=o,p)|0}function spb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return rpb(a,b,c,d,0)|0}function tpb(a){a=a|0;return 0}function upb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if((c|0)>=4096)return id(a|0,b|0,c|0)|0;d=a|0;if((a&3)==(b&3)){while(a&3){if(!c)return d|0;i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0;c=c-1|0}while((c|0)>=4){k[a>>2]=k[b>>2];a=a+4|0;b=b+4|0;c=c-4|0}}while((c|0)>0){i[a>>0]=i[b>>0]|0;a=a+1|0;b=b+1|0;c=c-1|0}return d|0}function vpb(a){a=a|0;var b=0,c=0;c=a+15&-16|0;b=k[t>>2]|0;a=b+c|0;if((c|0)>0&(a|0)<(b|0)|(a|0)<0){ia()|0;Kd(12);return -1}k[t>>2]=a;if((a|0)>(ha()|0)?(ga()|0)==0:0){Kd(12);k[t>>2]=b;return -1}return b|0}function wpb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if((b|0)<(a|0)&(a|0)<(b+c|0)){d=a;b=b+c|0;a=a+c|0;while((c|0)>0){a=a-1|0;b=b-1|0;c=c-1|0;i[a>>0]=i[b>>0]|0}a=d}else upb(a,b,c)|0;return a|0}function xpb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;f=r;r=r+16|0;e=f|0;rpb(a,b,c,d,e)|0;r=f;return (N=k[e+4>>2]|0,k[e>>2]|0)|0}function ypb(a){a=a|0;return (a&255)<<24|(a>>8&255)<<16|(a>>16&255)<<8|a>>>24|0}function zpb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=a+c|0;if((c|0)>=20){b=b&255;f=a&3;g=b|b<<8|b<<16|b<<24;e=d&~3;if(f){f=a+4-f|0;while((a|0)<(f|0)){i[a>>0]=b;a=a+1|0}}while((a|0)<(e|0)){k[a>>2]=g;a=a+4|0}}while((a|0)<(d|0)){i[a>>0]=b;a=a+1|0}return a-c|0}function Apb(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){N=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}N=a<<c-32;return 0}function Bpb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=b>>31|((b|0)<0?-1:0)<<1;i=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;f=d>>31|((d|0)<0?-1:0)<<1;e=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;h=jpb(j^a|0,i^b|0,j|0,i|0)|0;g=N;a=f^j;b=e^i;return jpb((rpb(h,g,jpb(f^c|0,e^d|0,f|0,e|0)|0,N,0)|0)^a|0,N^b|0,a|0,b|0)|0}function Cpb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;while((e|0)<(c|0)){d=k[b+(e<<3)>>2]|0;if(!d)break;if((d|0)==(a|0))return k[b+((e<<3)+4)>>2]|0;e=e+1|0}return 0}function Dpb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=a&65535;e=b&65535;c=aa(e,f)|0;d=a>>>16;a=(c>>>16)+(aa(e,d)|0)|0;e=b>>>16;b=aa(e,f)|0;return (N=(a>>>16)+(aa(e,d)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|c&65535|0)|0}function Epb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;f=c;c=Dpb(e,f)|0;a=N;return (N=(aa(b,f)|0)+(aa(d,e)|0)+a|a&0,c|0|0)|0}function Fpb(){return 0}function Gpb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;return Mf[a&3](b|0,c|0,d|0,e|0,f|0,+g)|0}function Hpb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;Nf[a&3](b|0,c|0,d|0,e|0,+f,+g,+h)}function Ipb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;Of[a&3](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)}function Jpb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;Pf[a&3](b|0,c|0,d|0,e|0,f|0,+g,+h,i|0)}function Kpb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;Qf[a&3](b|0,c|0,d|0,+e,f|0,g|0,h|0)}function Lpb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;return Rf[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0)|0}function Mpb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Sf[a&127](b|0,c|0,d|0,e|0,f|0,g|0)|0}function Npb(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;Tf[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0,k|0,l|0)}function Opb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;Uf[a&7](b|0,c|0,d|0,e|0,+f,+g,h|0)}function Ppb(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;Vf[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0)}function Qpb(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return Wf[a&1](b|0,+c,+d)|0}function Rpb(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;Xf[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,+l)}function Spb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;Yf[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0,j|0)}function Tpb(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;return Zf[a&1](b|0,+c,d|0)|0}function Upb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;_f[a&1](b|0,c|0,+d,+e,f|0,+g,+h)}function Vpb(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;$f[a&15](b|0,+c,d|0)}function Wpb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;ag[a&3](b|0,c|0,+d,+e,f|0,g|0)}function Xpb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;j=+j;k=k|0;bg[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i,+j,k|0)}function Ypb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;cg[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0)}function Zpb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;dg[a&1](b|0,c|0,+d,+e,f|0,+g,+h,+i,+j)}function _pb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=+k;eg[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,+k)}function $pb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;fg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,j|0)}function aqb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;gg[a&7](b|0,c|0,d|0,+e,f|0,g|0)}function bqb(a,b){a=a|0;b=b|0;return +hg[a&127](b|0)}function cqb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;return ig[a&1](b|0,c|0,d|0,+e,+f,g|0)|0}function dqb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;k=k|0;jg[a&3](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i,+j,k|0)}function eqb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;return kg[a&1](b|0,+c,+d,+e,+f,+g)|0}function fqb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return +lg[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function gqb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;j=+j;k=k|0;return mg[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i,+j,k|0)|0}function hqb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=+h;i=i|0;ng[a&1](b|0,c|0,+d,+e,+f,+g,+h,i|0)}function iqb(a,b,c){a=a|0;b=b|0;c=c|0;return +og[a&63](b|0,c|0)}function jqb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;pg[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,+j)}function kqb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=+h;i=i|0;return qg[a&1](b|0,c|0,+d,+e,+f,+g,+h,i|0)|0}function lqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;return +rg[a&1](b|0,c|0,+d,e|0)}function mqb(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;sg[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,+l,+m,n|0)}function nqb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return tg[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function oqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return ug[a&7](b|0,c|0,d|0,+e)|0}function pqb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return vg[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function qqb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;wg[a&1](b|0,c|0,+d,+e,f|0,g|0,h|0)}function rqb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=+h;xg[a&1](b|0,c|0,+d,+e,f|0,g|0,+h)}function sqb(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;k=+k;l=l|0;m=m|0;n=n|0;return yg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,j|0,+k,l|0,m|0,n|0)|0}function tqb(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;return zg[a&3](b|0,+c,+d,+e,+f)|0}function uqb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;Ag[a&1](b|0,c|0,+d,e|0,f|0,g|0,+h)}function vqb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;Bg[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0,k|0)}function wqb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;return +Cg[a&1](b|0,c|0,d|0,+e,+f,g|0)}function xqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Dg[a&127](b|0,c|0,d|0,e|0)|0}function yqb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=+g;h=h|0;i=i|0;Eg[a&1](b|0,c|0,d|0,+e,f|0,+g,h|0,i|0)}function zqb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return +Fg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function Aqb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=+i;Gg[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0,+i)}function Bqb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;Hg[a&1](b|0,c|0,d|0,+e,+f,+g,+h,i|0,j|0)}function Cqb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return Ig[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function Dqb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;Jg[a&15](b|0,c|0,d|0,e|0,f|0,+g)}function Eqb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;j=j|0;k=k|0;Kg[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i,j|0,k|0)}function Fqb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Lg[a&255](b|0,c|0,d|0,e|0,f|0,g|0)}function Gqb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;Mg[a&3](b|0,c|0,d|0,+e,f|0,g|0,h|0,i|0)}function Hqb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;Ng[a&7](b|0,c|0,d|0,+e,+f)}function Iqb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;Og[a&15](b|0,c|0,d|0,+e,f|0)}function Jqb(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;Pg[a&1](b|0,+c,+d,+e,+f)}function Kqb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;return Qg[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0)|0}function Lqb(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=+e;return Rg[a&7](b|0,+c,+d,+e)|0}function Mqb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;Sg[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function Nqb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;return +Tg[a&1](b|0,c|0,+d,+e,f|0)}function Oqb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +Ug[a&31](b|0,c|0,d|0)}function Pqb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;Vg[a&3](b|0,c|0,d|0,+e,+f,+g)}function Qqb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=+j;k=+k;Wg[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i,+j,+k)}function Rqb(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;Xg[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,+m)}function Sqb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;Yg[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i)}function Tqb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;Zg[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0,i|0,+j,k|0)}function Uqb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;_g[a&7](b|0,c|0,d|0,+e,+f,g|0)}function Vqb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return $g[a&127](b|0,c|0,d|0,e|0,f|0)|0}function Wqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;ah[a&31](b|0,c|0,d|0,+e)}function Xqb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;bh[a&3](b|0,c|0,+d,e|0,f|0)}function Yqb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return ch[a&7](b|0,c|0,d|0,e|0,+f)|0}function Zqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dh[a&255](b|0,c|0,d|0,e|0)}function _qb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eh[a&255](b|0,c|0,d|0,e|0,f|0)}function $qb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;fh[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function arb(a,b,c){a=a|0;b=b|0;c=+c;gh[a&255](b|0,+c)}function brb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;return hh[a&7](b|0,c|0,+d,e|0)|0}function crb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;return ih[a&1](b|0,c|0,+d,+e)|0}function drb(a,b,c){a=a|0;b=b|0;c=c|0;jh[a&1023](b|0,c|0)}function erb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;kh[a&7](b|0,c|0,d|0,e|0,+f)}function frb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return lh[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function grb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;mh[a&15](b|0,c|0,+d,+e)}function hrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;nh[a&15](b|0,c|0,+d,e|0)}function irb(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=+e;oh[a&3](b|0,+c,+d,+e)}function jrb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;j=j|0;ph[a&1](b|0,c|0,d|0,+e,f|0,g|0,+h,+i,j|0)}function krb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;return qh[a&1](b|0,c|0,d|0,+e,f|0,g|0)|0}function lrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return +rh[a&1](b|0,c|0,d|0,+e)}function mrb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;sh[a&255](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function nrb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;th[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0,j|0,k|0)}function orb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;uh[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i)}function prb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;vh[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,+i,j|0)}function qrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +wh[a&31](b|0,c|0,d|0,e|0)}function rrb(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;l=l|0;xh[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j,+k,l|0)}function srb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;yh[a&1](b|0,+c,+d,+e,+f,+g)}function trb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=+h;i=+i;j=j|0;zh[a&1](b|0,c|0,+d,+e,+f,+g,+h,+i,j|0)}function urb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;j=j|0;Ah[a&1](b|0,c|0,d|0,e|0,f|0,+g,+h,i|0,j|0)}function vrb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;Bh[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0)}function wrb(a,b,c){a=a|0;b=b|0;c=+c;return Ch[a&7](b|0,+c)|0}function xrb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;Dh[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,+j)}function yrb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Eh[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function zrb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Fh[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function Arb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;Gh[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function Brb(a,b,c){a=a|0;b=b|0;c=c|0;return Hh[a&511](b|0,c|0)|0}function Crb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Ih[a&7](b|0,c|0,d|0,+e,+f,g|0,h|0)}function Drb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;Jh[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0)}function Erb(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;Kh[a&1](+b,c|0,d|0,e|0)}function Frb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;return +Lh[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,+j)}function Grb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=+h;i=+i;j=j|0;return Mh[a&1](b|0,c|0,+d,+e,+f,+g,+h,+i,j|0)|0}function Hrb(a){a=a|0;return Nh[a&127]()|0}function Irb(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;Oh[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0,k|0,l|0)}function Jrb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ph[a&511](b|0,c|0,d|0)}function Krb(a){a=a|0;Qh[a&7]()}function Lrb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;Rh[a&63](b|0,c|0,+d)}function Mrb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;h=h|0;i=i|0;return Sh[a&1](b|0,+c,+d,+e,+f,+g,h|0,i|0)|0}function Nrb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=+h;return Th[a&1](b|0,c|0,+d,+e,f|0,g|0,+h)|0}function Orb(a,b){a=a|0;b=b|0;Uh[a&2047](b|0)}function Prb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return Vh[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function Qrb(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=l|0;Wh[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0,j|0,+k,l|0)}function Rrb(a,b){a=a|0;b=b|0;return Xh[a&1023](b|0)|0}function Srb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;Yh[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,+j,k|0)}function Trb(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;Zh[a&7](b|0,+c,d|0,e|0)}function Urb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;return _h[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0)|0}function Vrb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;$h[a&7](b|0,c|0,d|0,e|0,+f,g|0)}function Wrb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;ai[a&3](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0)}function Xrb(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;bi[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0,l|0,m|0)}function Yrb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ci[a&255](b|0,c|0,d|0)|0}function Zrb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;di[a&1](b|0,c|0,+d,e|0,+f,g|0,h|0)}function _rb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;ei[a&3](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0)}function $rb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;return fi[a&3](b|0,c|0,+d)|0}function asb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;gi[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0)}function bsb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return +hi[a&15](b|0,c|0,d|0,e|0,f|0)}function csb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return +ii[a&1](b|0,c|0,d|0,e|0,+f)}function dsb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;ji[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function esb(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;return ki[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0)|0}function fsb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return li[a&7](b|0,c|0,d|0,e|0,+f,g|0)|0}function gsb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;return mi[a&1](b|0,c|0,+d,e|0,+f)|0}function hsb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;return +ni[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,+k)}function isb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;return oi[a&3](b|0,c|0,d|0,e|0,+f,g|0,h|0)|0}function jsb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return +pi[a&7](b|0,c|0,d|0,e|0,f|0,g|0)}function ksb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;qi[a&1](b|0,+c,d|0,+e,+f,g|0,h|0)}function lsb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;ri[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0)}function msb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return si[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function nsb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=+g;h=h|0;i=i|0;ti[a&1](b|0,c|0,+d,e|0,+f,+g,h|0,i|0)}function osb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;ui[a&3](b|0,c|0,d|0,e|0,+f,+g)}function psb(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;vi[a&1](b|0,+c,d|0,e|0,f|0)}function qsb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ea(0);return 0}function rsb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;ea(1)}function ssb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ea(2)}function tsb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;ea(3)}function usb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;ea(4)}function vsb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;ea(5);return 0}function wsb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ea(6);return 0}function xsb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;ea(7)}function ysb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;ea(8)}function zsb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;ea(9)}function Asb(a,b,c){a=a|0;b=+b;c=+c;ea(10);return 0}function Bsb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;ea(11)}function Csb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;ea(12)}function Dsb(a,b,c){a=a|0;b=+b;c=c|0;ea(13);return 0}function Esb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;ea(14)}function Fsb(a,b,c){a=a|0;b=+b;c=c|0;ea(15)}function Gsb(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;ea(16)}function Hsb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=j|0;ea(17)}function Isb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;ea(18)}function Jsb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h=+h;i=+i;ea(19)}function Ksb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;ea(20)}function Lsb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;ea(21)}function Msb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ea(22)}function Nsb(a){a=a|0;ea(23);return 0.0}function Osb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;ea(24);return 0}function Psb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;j=j|0;ea(25)}function Qsb(a,b,c,d,e,f){a=a|0;b=+b;c=+c;d=+d;e=+e;f=+f;ea(26);return 0}function Rsb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ea(27);return 0.0}function Ssb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=j|0;ea(28);return 0}function Tsb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;h=h|0;ea(29)}function Usb(a,b){a=a|0;b=b|0;ea(30);return 0.0}function Vsb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;ea(31)}function Wsb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;h=h|0;ea(32);return 0}function Xsb(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ea(33);return 0.0}function Ysb(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;m=m|0;ea(34)}function Zsb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ea(35);return 0}function _sb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;ea(36);return 0}function $sb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ea(37);return 0}function atb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;ea(38)}function btb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=+g;ea(39)}function ctb(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=+j;k=k|0;l=l|0;m=m|0;ea(40);return 0}function dtb(a,b,c,d,e){a=a|0;b=+b;c=+c;d=+d;e=+e;ea(41);return 0}function etb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=+g;ea(42)}function ftb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;ea(43)}function gtb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;ea(44);return 0.0}function htb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ea(45);return 0}function itb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;ea(46)}function jtb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ea(47);return 0.0}function ktb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;ea(48)}function ltb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;i=i|0;ea(49)}function mtb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ea(50);return 0}function ntb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ea(51)}function otb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;ea(52)}function ptb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ea(53)}function qtb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;ea(54)}function rtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;ea(55)}function stb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ea(56)}function ttb(a,b,c,d,e){a=a|0;b=+b;c=+c;d=+d;e=+e;ea(57)}function utb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;ea(58);return 0}function vtb(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;ea(59);return 0}function wtb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ea(60)}function xtb(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;ea(61);return 0.0}function ytb(a,b,c){a=a|0;b=b|0;c=c|0;ea(62);return 0.0}function ztb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;ea(63)}function Atb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;ea(64)}function Btb(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;ea(65)}function Ctb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;ea(66)}function Dtb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;ea(67)}function Etb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;ea(68)}function Ftb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ea(69);return 0}function Gtb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;ea(70)}function Htb(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ea(71)}function Itb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;ea(72);return 0}function Jtb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ea(73)}function Ktb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ea(74)}function Ltb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ea(75)}function Mtb(a,b){a=a|0;b=+b;ea(76)}function Ntb(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ea(77);return 0}function Otb(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;ea(78);return 0}function Ptb(a,b){a=a|0;b=b|0;ea(79)}function Qtb(a,b){a=a|0;b=b|0;Hf(a|0,b|0)}function Rtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;ea(80)}function Stb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ea(81);return 0}function Ttb(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;ea(82)}function Utb(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ea(83)}function Vtb(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;ea(84)}function Wtb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=+g;h=+h;i=i|0;ea(85)}function Xtb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ea(86);return 0}function Ytb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;ea(87);return 0.0}function Ztb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ea(88)}function _tb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;ea(89)}function $tb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;ea(90)}function aub(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;ea(91)}function bub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ea(92);return 0.0}function cub(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;k=k|0;ea(93)}function dub(a,b,c,d,e,f){a=a|0;b=+b;c=+c;d=+d;e=+e;f=+f;ea(94)}function eub(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;h=+h;i=i|0;ea(95)}function fub(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;ea(96)}function gub(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;ea(97)}function hub(a,b){a=a|0;b=+b;ea(98);return 0}function iub(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;ea(99)}function jub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ea(100)}function kub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ea(101)}function lub(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ea(102)}function mub(a,b){a=a|0;b=b|0;ea(103);return 0}function nub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;ea(104)}function oub(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;ea(105)}function pub(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;ea(106)}function qub(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;ea(107);return 0.0}function rub(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;h=+h;i=i|0;ea(108);return 0}function sub(){ea(109);return 0}function tub(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;ea(110)}function uub(a,b,c){a=a|0;b=b|0;c=c|0;ea(111)}function vub(){ea(112)}function wub(){Te()}function xub(a,b,c){a=a|0;b=b|0;c=+c;ea(113)}function yub(a,b,c,d,e,f,g,h){a=a|0;b=+b;c=+c;d=+d;e=+e;f=+f;g=g|0;h=h|0;ea(114);return 0}function zub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=+g;ea(115);return 0}function Aub(a){a=a|0;ea(116)}function Bub(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ea(117);return 0}function Cub(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;ea(118)}function Dub(a){a=a|0;ea(119);return 0}function Eub(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;ea(120)}function Fub(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;ea(121)}function Gub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;ea(122);return 0}function Hub(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ea(123)}function Iub(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;ea(124)}function Jub(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;ea(125)}function Kub(a,b,c){a=a|0;b=b|0;c=c|0;ea(126);return 0}function Lub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=f|0;g=g|0;ea(127)}function Mub(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;ea(128)}function Nub(a,b,c){a=a|0;b=b|0;c=+c;ea(129);return 0}function Oub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;ea(130)}function Pub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ea(131);return 0.0}function Qub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;ea(132);return 0.0}function Rub(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;ea(133)}function Sub(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;ea(134);return 0}function Tub(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ea(135);return 0}function Uub(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=+e;ea(136);return 0}function Vub(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;ea(137);return 0.0}function Wub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;ea(138);return 0}function Xub(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ea(139);return 0.0}function Yub(a,b,c,d,e,f,g){a=a|0;b=+b;c=c|0;d=+d;e=+e;f=f|0;g=g|0;ea(140)}function Zub(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;ea(141)}function _ub(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ea(142);return 0}function $ub(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;ea(143)}function avb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;ea(144)}function bvb(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;ea(145)}

// EMSCRIPTEN_END_FUNCS
var Mf=[qsb,nmb,tmb,qsb];var Nf=[rsb,VJ,$I,hI];var Of=[ssb,TSa,io,ow];var Pf=[tsb,DK,dj,tsb];var Qf=[usb,USa,Tv,usb];var Rf=[vsb,Av];var Sf=[wsb,w7,x7,y7,z7,A7,B7,C7,j8,k8,l8,m8,n8,o8,p8,q8,r8,s8,t8,u8,v8,w8,x8,y8,z8,A8,B8,C8,D8,oga,gCa,Hib,Iib,Jib,Kib,Lib,Mib,Nib,Oib,Pib,Qib,Rib,njb,ojb,pjb,qjb,rjb,sjb,tjb,ujb,vjb,wjb,xjb,Hjb,Jjb,Yjb,_jb,ikb,jkb,kkb,lkb,mkb,Gkb,Hkb,Ikb,Jkb,Kkb,omb,umb,Qj,_p,eF,oF,q9a,r9a,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb,wsb];var Tf=[xsb,qJ];var Uf=[ysb,JK,Wi,iK,PH,ysb,ysb,ysb];var Vf=[zsb,jK,uJ,tJ];var Wf=[Asb,yN];var Xf=[Bsb,Hj];var Yf=[Csb,GRa,hm,tD,ED,Csb,Csb,Csb];var Zf=[Dsb,_B];var _f=[Esb,Ti];var $f=[Fsb,FBa,GIa,KIa,QJa,kLa,fm,JA,ZB,Fsb,Fsb,Fsb,Fsb,Fsb,Fsb,Fsb];var ag=[Gsb,Pi,Fk,jm];var bg=[Hsb,hB];var cg=[Isb,KJ,Lk,mI];var dg=[Jsb,Si];var eg=[Ksb,PI];var fg=[Lsb,VH];var gg=[Msb,vXa,OXa,lJ,bl,Msb,Msb,Msb];var hg=[Nsb,Daa,Pya,Rya,Tya,Vya,Xya,Zya,$ya,wAa,IAa,Lza,yDa,dFa,RFa,TFa,VFa,XFa,ZFa,$Fa,HIa,BIa,RJa,lLa,_Ta,MVa,OVa,UVa,iWa,PYa,xZa,JZa,WZa,f_a,o_a,H_a,J_a,N_a,P_a,R_a,Z_a,o$a,a0a,r0a,u3a,w3a,y3a,e4a,o4a,q4a,s4a,B4a,D4a,F4a,H4a,J4a,S4a,U4a,W4a,Y4a,f5a,h5a,j5a,B5a,J5a,Z5a,$5a,b6a,d6a,f6a,h6a,j6a,p6a,P6a,R6a,T6a,V6a,$6a,h7a,hk,rTa,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb,Nsb];var ig=[Osb,xu];var jg=[Psb,VSa,Co,Psb];var kg=[Qsb,sA];var lg=[Rsb,bJ,Al,vt];var mg=[Ssb,iB];var ng=[Tsb,Wk];var og=[Usb,LQa,YQa,aj,pj,Rj,CJ,Ql,cn,tn,Sn,uo,Io,Xo,Hp,Hq,Hr,js,Cs,et,Zu,ev,Xv,nw,Kx,ty,oz,iA,qA,BB,dC,oC,yC,KC,KD,WD,lE,ME,VK,UL,KN,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb,Usb];var pg=[Vsb,cl];var qg=[Wsb,WI];var rg=[Xsb,gHa];var sg=[Ysb,w_,t_,u_,v_,Ysb,Ysb,Ysb];var tg=[Zsb,cK,ZE,Zsb];var ug=[_sb,lp,vu,dA,sQ,SK,XL,_sb];var vg=[$sb,blb,glb,$lb,amb,hmb,imb,QJ,Bq,fF,$sb,$sb,$sb,$sb,$sb,$sb];var wg=[atb,Zl];var xg=[btb,tz];var yg=[ctb,no];var zg=[dtb,MD,CN,dtb];var Ag=[etb,kj];var Bg=[ftb,cI,uD,ftb];var Cg=[gtb,OH];var Dg=[htb,PZ,QZ,RZ,SZ,TZ,E1,V4,mga,tCa,vnb,Pnb,Qnb,Rnb,Xnb,LK,gK,WJ,Pj,rJ,mJ,YI,RI,kl,HI,GI,tI,YH,xm,ho,up,Wq,dr,us,Vs,Ws,Ft,Wt,Yt,mu,ru,Iu,Mw,Qw,eA,VA,qD,hF,XR,JR,vR,hR,VQ,HQ,cQ,OP,AP,mP,_O,MO,yO,kO,cL,dL,rL,zL,nM,tM,uM,zM,AM,FM,GM,IM,SM,_M,lN,BN,o9a,p9a,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb,htb];var Eg=[itb,_I];var Fg=[jtb,zI];var Gg=[ktb,qK];var Hg=[ltb,Ri];var Ig=[mtb,IE];var Jg=[ntb,naa,oaa,paa,qaa,raa,saa,taa,Dj,ntb,ntb,ntb,ntb,ntb,ntb,ntb];var Kg=[otb,IK];var Lg=[ptb,IV,JV,KV,LV,TX,UX,VX,WX,XX,YX,ZX,N_,O_,P_,Q_,R_,S_,T_,G_,H_,I_,J_,K_,L_,M_,H4,gaa,haa,iaa,jaa,kaa,laa,maa,pga,Uha,Sha,$ha,Zha,gia,eia,nia,lia,uia,sia,Bia,zia,Iia,Gia,Pia,Nia,Wia,Uia,bja,$ia,ija,gja,kja,rja,pja,tja,xja,nna,ona,pna,qna,rna,zoa,Eqa,Aqa,wqa,sqa,oqa,kqa,gqa,cqa,_pa,Wpa,Yta,Sta,Mta,Gta,Ata,uta,ota,ita,cta,Ysa,Ssa,CFa,PHa,BLa,kIa,eJa,WKa,kOa,TLa,iMa,KNa,GPa,BOa,fPa,SSa,XSa,AVa,PTa,KUa,$Va,uXa,NXa,IYa,kZa,m$a,Zgb,lhb,Amb,Fmb,Fob,Mob,apb,xK,wK,pK,hK,aK,YJ,Sj,LJ,JJ,lk,wJ,pJ,Ek,fJ,Kk,Mk,TI,vl,vI,nI,um,NH,Pm,en,ro,vo,$p,Sq,wr,Gw,_w,mx,qx,ay,ky,Mz,Rz,V_,U_,neb,XIa,YIa,ZIa,_Ia,QKa,RKa,SKa,bMa,cMa,dMa,eMa,ENa,FNa,GNa,_Oa,$Oa,aPa,bPa,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb,ptb];var Mg=[qtb,FRa,DD,qtb];var Ng=[rtb,OJ,DJ,tk,il,zy,lL,rtb];var Og=[stb,rK,mK,EJ,mk,rl,Cl,El,Wl,stb,stb,stb,stb,stb,stb,stb];var Pg=[ttb,LD];var Qg=[utb,Sw];var Rg=[vtb,kn,Es,YD,AN,vtb,vtb,vtb];var Sg=[wtb,p1,rj,xJ,rk,sk,Jua,Kua,Lua,Mua,Nua,Oua,Pua,Qua,Rua,Sua,Tua,Uua,wtb,wtb,wtb,wtb,wtb,wtb,wtb,wtb,wtb,wtb,wtb,wtb,wtb,wtb];var Tg=[xtb,Km];var Ug=[ytb,s$,t$,u$,v$,w$,x$,y$,jZa,tZa,B_a,l$a,Xi,yK,lK,Nj,xl,rI,Xl,cm,zm,Dq,oy,jz,VL,LM,PM,ytb,ytb,ytb,ytb,ytb];var Vg=[ztb,Lj,Qk,$l];var Wg=[Atb,HK];var Xg=[Btb,fZ,gZ,hZ,iZ,jZ,kZ,ZJ];var Yg=[Ctb,GK];var Zg=[Dtb,Gj];var _g=[Etb,Qi,sj,rm,Jm,wu,Etb,Etb];var $g=[Ftb,h7,i7,j7,k7,l7,m7,n7,O7,P7,Q7,R7,S7,T7,U7,V7,W7,X7,Y7,Z7,_7,$7,a8,b8,c8,d8,e8,f8,g8,nga,Boa,eHa,eCa,xib,Cib,Fjb,Gjb,Ijb,Mjb,Wjb,Xjb,Zjb,bkb,Lmb,Omb,_mb,bnb,xnb,Znb,Tmb,Wmb,hnb,knb,RJ,JI,TH,Zp,vs,Xs,Ju,YA,nF,eL,vM,BM,HM,$M,mN,EGa,DGa,rGa,t9a,u9a,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb,Ftb];var ah=[Gtb,v5a,T5a,_i,el,kp,lq,uu,Pu,soa,roa,qoa,mQ,WL,a$,$_,c$,b$,e$,d$,g$,f$,i$,h$,k$,j$,m$,l$,o$,n$,q$,p$];var bh=[Htb,Dk,XH,Htb];var ch=[Itb,Kjb,Ljb,$jb,akb,fA,Itb,Itb];var dh=[Jtb,c7,d7,e7,f7,x4,y4,z4,A4,c_,d_,e_,f_,g_,h_,i_,a0,C$,K$,L$,M$,N$,b0,V$,e0,U$,h0,k0,l0,m0,r0,s0,t0,D0,J0,O0,R0,I4,mHa,fBa,xBa,yBa,dCa,OHa,KLa,tIa,CIa,DIa,mJa,DJa,gKa,wKa,PKa,cLa,xLa,tOa,aMa,qMa,FMa,WMa,kNa,DNa,SNa,gOa,PPa,KOa,QOa,ROa,nPa,CPa,BTa,xVa,yVa,zVa,wVa,zUa,AUa,kVa,IVa,mYa,nYa,iZa,FZa,SZa,b_a,k_a,k$a,K$a,L$a,M$a,$$a,o0a,l3a,H3a,N6a,_gb,mhb,yib,Dib,Hob,Oob,cpb,Oi,EK,Yi,Zi,$i,tK,hj,nK,tj,vj,wj,Mj,Uj,HJ,bk,FJ,ek,ik,Ak,Uk,al,hl,ol,Ll,qI,bm,gm,im,km,$H,qm,gn,yo,tp,Up,cq,vq,Pq,Uq,Vq,$q,cr,xr,Ir,$s,Et,lu,nu,yv,Ev,ew,Bw,Dw,Uw,rx,Tx,my,Sz,HA,LA,QA,UA,mB,fC,gF,RR,DR,pR,bR,PQ,BQ,YP,IP,uP,gP,UO,GO,sO,eO,qL,uL,xL,yL,DL,IL,OL,QL,f5,j5,m5,q5,M5,U5,X5,_5,b6,f6,wla,Cdb,Vdb,oeb,qeb,reb,meb,leb,Kcb,tSa,pTa,o8a,p8a,q8a,r8a,s8a,t8a,P7a,V8a,X8a,c9a,d9a,e9a,f9a,g9a,B9a,C9a,E9a,D9a,F9a,J9a,M9a,L9a,mbb,nbb,obb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb,Jtb];var eh=[Ktb,B$,d2,e2,f2,g2,h2,i2,j2,k2,l2,m2,S6,T6,U6,V6,W6,X6,Y6,Z6,_6,$6,a7,b7,U9,V9,W9,X9,Y9,Z9,_9,$9,aaa,baa,caa,daa,eaa,faa,xga,Cga,Hga,Mga,Rga,Wga,$ga,eha,jha,oha,vha,tha,Cha,Aha,$na,aoa,boa,coa,doa,eoa,foa,Spa,Opa,Kpa,Gpa,Cpa,ypa,upa,qpa,mpa,ipa,Msa,Isa,Esa,Asa,wsa,ssa,osa,ksa,gsa,sua,oua,kua,gua,cua,iBa,I$a,k3a,s3a,G3a,Gob,Nob,bpb,BK,AK,bj,cj,sK,lj,xj,Ej,Ij,UJ,NJ,Xj,Zj,_j,GJ,kk,pk,wk,Jk,_k,ul,Hl,sI,Ul,gI,dm,bI,om,ZH,Cm,Hm,Om,dn,Vp,wq,Qq,Rq,ar,vr,yr,Jr,ou,fw,Cw,Ew,Vw,lx,px,sx,Ux,$x,ny,Qz,Tz,MA,RA,XA,nB,vL,Y_,X_,ieb,dab,fab,gab,hab,iab,jab,kab,n8a,Sab,Tab,Uab,Vab,Wab,Xab,Yab,Zab,_ab,ecb,dcb,ccb,bcb,acb,$bb,_bb,fcb,gcb,hcb,icb,jcb,kcb,lcb,mcb,ncb,ocb,pcb,qcb,rcb,scb,tcb,ucb,vcb,wcb,xcb,ycb,zcb,Acb,Bcb,Ccb,Zbb,Ybb,Xbb,Ecb,Fcb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb,Ktb];var fh=[Ltb,HE];var gh=[Mtb,Caa,Qya,Sya,Uya,Wya,Yya,_ya,aza,xAa,JAa,Mza,zDa,eFa,SFa,UFa,WFa,YFa,_Fa,aGa,ZTa,LVa,NVa,TVa,hWa,OYa,wZa,IZa,VZa,e_a,n_a,G_a,I_a,M_a,O_a,Q_a,Y_a,n$a,b0a,s0a,v3a,x3a,z3a,f4a,p4a,r4a,t4a,C4a,E4a,G4a,I4a,K4a,T4a,V4a,X4a,Z4a,g5a,i5a,k5a,C5a,K5a,_5a,a6a,c6a,e6a,g6a,i6a,k6a,q6a,Q6a,S6a,U6a,W6a,a7a,i7a,_l,an,hn,ln,wn,yn,Cn,Fn,Hn,In,Jn,Ln,Un,ap,Lp,Mr,es,Fs,Hs,at,ct,Vu,Xu,mv,ov,rv,sv,vv,Bv,Yv,rw,Gx,uy,wy,xy,Ay,Cy,Dy,Ey,vz,yz,zz,mA,oA,pA,tA,CB,JB,aC,LC,NC,RC,TC,XC,YC,HD,JD,ND,UD,ZD,gE,PE,DN,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb,Mtb];var hh=[Ntb,VI,vn,Ex,yB,Ntb,Ntb,Ntb];var ih=[Otb,SI];var jh=[Ptb,$R,mS,xS,IS,TS,cT,nT,yT,JT,PX,BZ,zZ,t1,F1,m1,Xgb,Y4,R8,i9,UT,VT,XT,YT,Eaa,Faa,_aa,Vaa,Qaa,Laa,Uda,Sda,Qda,Oda,Mda,Kda,Ida,Gda,Eda,Cda,Ada,yda,wda,uda,sda,qda,oda,mda,kda,ida,gda,eda,cda,ada,_ca,Yca,Wca,Uca,Rca,Pca,Mca,Kca,Hca,Fca,Dca,Bca,yca,vca,sca,qca,nca,cba,dba,eba,fba,gba,hba,iba,jba,kba,lba,mba,nba,oba,pba,qba,rba,sba,tba,uba,vba,wba,xba,yba,zba,Aba,Bba,Cba,Dba,Eba,Fba,Jba,Hba,Zda,_da,$da,aea,bea,cea,dea,eea,fea,gea,hea,iea,jea,ffa,hfa,jfa,mfa,ofa,qfa,Bfa,zfa,Cla,Dla,$la,cma,fma,ima,lma,tma,wma,zma,Cma,Fma,Nma,Qma,Tma,Wma,Zma,ena,gna,ina,kna,mna,una,xna,Ana,Dna,Gna,Ina,Lna,koa,ooa,Gra,Aua,yua,$ua,Rva,rya,Xva,dwa,jwa,qwa,ywa,Hwa,Nwa,Xwa,bxa,hxa,mxa,sxa,lya,sya,Aya,Bya,Cya,Lya,Mya,Nya,Oya,eza,aAa,bAa,cAa,jAa,lAa,nAa,pAa,rAa,tAa,vAa,yAa,zAa,FAa,HAa,qza,rza,sza,yza,Aza,Cza,Eza,Gza,Iza,Kza,Nza,Oza,SGa,Xza,kHa,Yza,gBa,hBa,jBa,kBa,lBa,mBa,nBa,oBa,pBa,qBa,rBa,sBa,tBa,vBa,wBa,zBa,BBa,CBa,DBa,OBa,PBa,QBa,XBa,ZBa,_Ba,$Ba,aCa,bCa,cCa,WCa,XCa,YCa,dDa,fDa,hDa,jDa,PCa,ECa,HCa,KCa,TCa,qDa,rDa,sDa,BDa,DDa,FDa,HDa,IDa,JDa,KDa,bEa,cEa,dEa,lEa,JEa,KEa,LEa,SEa,UEa,WEa,YEa,_Ea,aFa,cFa,fFa,gFa,mFa,oFa,pFa,qFa,rFa,uEa,vEa,BEa,CEa,HFa,IFa,JFa,QFa,bGa,cGa,dGa,eGa,gGa,hGa,jGa,FGa,OGa,PGa,jHa,oHa,RHa,DLa,ELa,JLa,mIa,nIa,sIa,fJa,gJa,lJa,wJa,xJa,CJa,$Ja,aKa,fKa,pKa,qKa,vKa,EKa,IKa,JKa,OKa,XKa,YKa,bLa,qLa,rLa,wLa,mOa,nOa,sOa,VLa,WLa,$La,jMa,kMa,pMa,yMa,zMa,EMa,PMa,QMa,VMa,dNa,eNa,jNa,sNa,wNa,xNa,CNa,LNa,MNa,RNa,$Na,aOa,fOa,IPa,JPa,OPa,DOa,EOa,JOa,gPa,hPa,mPa,vPa,wPa,BPa,UPa,cQa,mQa,FQa,JQa,VQa,nRa,CRa,JRa,MRa,NRa,VRa,DSa,FSa,JSa,MSa,RSa,aTa,gTa,CTa,ETa,GTa,NTa,OTa,TTa,VTa,XTa,$Ta,bUa,dUa,mUa,xUa,yUa,lVa,nVa,pVa,JVa,PVa,RVa,ZVa,_Va,dWa,fWa,jWa,lWa,nWa,xWa,MWa,KWa,IWa,EWa,BWa,GWa,OWa,QWa,SWa,$Wa,kXa,lXa,nXa,HXa,IXa,JXa,oYa,qYa,sYa,uYa,MYa,QYa,SYa,UYa,WYa,YYa,_Ya,aZa,gZa,hZa,lZa,rZa,sZa,uZa,DZa,EZa,GZa,KZa,QZa,RZa,TZa,XZa,$Za,a_a,c_a,i_a,j_a,l_a,z_a,A_a,C_a,E_a,K_a,U_a,W_a,X_a,__a,$_a,i$a,j$a,G$a,H$a,O$a,Q$a,S$a,Z$a,_$a,d0a,f0a,m0a,n0a,q0a,t0a,V0a,Y0a,_0a,a1a,c1a,e1a,g1a,i1a,l1a,n1a,p1a,r1a,t1a,v1a,x1a,A1a,C1a,E1a,G1a,I1a,K1a,h2a,j2a,l2a,n2a,p2a,r2a,t2a,v2a,x2a,z2a,B2a,D2a,F2a,H2a,J2a,L2a,N2a,P2a,R2a,T2a,V2a,q3a,r3a,b4a,c4a,l4a,m4a,y4a,z4a,P4a,Q4a,c5a,d5a,t5a,u5a,w5a,y5a,A5a,E5a,G5a,I5a,R5a,S5a,U5a,W5a,Y5a,m6a,o6a,s6a,B6a,Y6a,_6a,c7a,e7a,g7a,k7a,J7a,H7a,F7a,D7a,v7a,y7a,B7a,jhb,$hb,eib,iib,oib,llb,mlb,nlb,olb,qlb,rlb,wlb,xlb,ylb,zlb,Blb,Clb,Hlb,Ilb,Jlb,Klb,Mlb,Nlb,Slb,Tlb,Ulb,Vlb,Xlb,Ylb,Bmb,Gmb,Cnb,Dnb,Enb,Jnb,Knb,Lnb,Ui,zj,Bj,Oj,yk,Bk,Nk,Pk,fl,yl,Dl,Nl,Pl,wm,Dm,Fm,Im,Lm,Nm,Qm,Tm,IH,An,Dn,Gn,Kn,Wn,zo,Ro,Yo,_o,$o,cp,mp,vp,xp,zp,Ip,Np,Wp,nq,Nq,Xq,_q,kr,nr,Kr,Wr,Yr,_r,$r,as,cs,ds,gs,qs,lt,ot,qt,rt,Gt,It,Kt,Tt,Zt,eu,ju,Qu,fv,jv,pv,tv,Cv,Fv,Mv,Ov,Rv,Vv,Wv,iw,kw,mw,qw,tw,uw,Xw,Yw,Ax,Ix,Rx,dy,fy,gy,Gy,Iy,Xy,_y,bz,pz,rz,xz,Hz,Jz,Oz,WA,eB,jB,kB,oB,zB,EB,GB,HB,IB,XB,$B,CC,OC,VC,aD,bD,KGa,jSa,eE,tE,xE,zE,EE,GE,JE,KE,LE,NE,OE,RE,$E,cF,jF,lF,KR,wR,iR,WQ,IQ,uQ,fQ,RP,BP,nP,$O,NO,zO,lO,ZN,mY,ML,_L,oM,z3,y3,x3,w3,v3,u3,t3,s3,r3,A3,q3,p3,o3,n3,B3,m3,l3,k3,j3,C3,i3,h3,g3,f3,e3,d3,c3,b3,a3,D3,$2,_2,Z2,Y2,E3,X2,W2,V2,U2,F3,dpa,epa,apa,bpa,cpa,h9a,j9a,uwa,A8a,$1,d8a,Vcb,Ucb,Qtb,Ycb,bdb,Wcb,aeb,beb,heb,seb,feb,Rdb,Sdb,veb,Q9a,oab,O7a,W7a,j8a,x9a,G9a,Y8a,v9a,_9a,lbb,Gcb,Icb,Xeb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb,Ptb];var kh=[Rtb,O$,Q$,$Ga,cHa,zK,NI,mq];var lh=[Stb,pw];var mh=[Ttb,Iya,Kya,Tj,gk,$k,Gm,yy,Fy,Ttb,Ttb,Ttb,Ttb,Ttb,Ttb,Ttb];var nh=[Utb,P$,n0,u0,E0,K0,S0,jj,oj,fk,Xk,dI,un,Dx,KA,xB];var oh=[Vtb,jn,Ds,XD];var ph=[Wtb,WSa];var qh=[Xtb,QI];var rh=[Ytb,Gl];var sh=[Ztb,SV,TV,UV,VV,WV,XV,YV,ZV,_V,$V,aW,bW,cW,dW,eW,fW,gW,hW,iW,jW,kW,lW,mW,nW,oW,pW,qW,rW,sW,tW,uW,vW,wW,xW,yW,zW,AW,BW,CW,DW,EW,FW,GW,HW,IW,JW,LW,MW,NW,OW,PW,QW,RW,TW,UW,VW,WW,XW,YW,ZW,_W,$W,aX,bX,cX,dX,eX,fX,gX,hX,iX,jX,kX,lX,mX,nX,oX,pX,qX,rX,sX,tX,uX,vX,wX,xX,yX,zX,AX,BX,CX,DX,EX,FX,GX,HX,IX,JX,KX,LX,MX,NX,bY,cY,dY,eY,fY,gY,hY,iY,jY,kY,n1,o1,E7,F7,G7,H7,I7,J7,K7,eK,$J,XJ,Wj,BJ,vJ,oJ,Ik,XI,OI,pl,yI,Tl,eI,_H,LH,Lz,OA,lY,Qcb,Wdb,peb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb,Ztb];var th=[_tb,vk];var uh=[$tb,qj];var vh=[aub,vK,ej,aub];var wh=[bub,uCa,Hya,hAa,RGa,Wza,VBa,bDa,xDa,iEa,QEa,iHa,OFa,kGa,CK,TJ,wl,BI,lI,Yl,fI,Uo,Eq,Ps,Rs,py,kz,_C,NM,RM,bub,bub];var xh=[cub,Do];var yh=[dub,rA];var zh=[eub,dq];var Ah=[fub,iJ];var Bh=[gub,YSa,hJ,gub];var Ch=[hub,dt,Yu,wN,EN,hub,hub,hub];var Dh=[iub,kK];var Eh=[jub,L6,M6,N6,O6,P6,Q6,R6,_ja,dka,ika,nka,ska,xka,Cka,Hka,Mka,Rka,Wka,$ka,ela,_ma,$ma,ana,bna,cna,Wna,Xna,Yna,Zna,_na,Rna,Sna,Tna,Una,Vna,Mna,Nna,Ona,Pna,Qna,Jqa,Oqa,Tqa,Yqa,bra,gra,lra,qra,vra,Ara,aHa,ISa,Aj,Fj,Jj,PJ,jk,AJ,qk,xk,zk,kJ,eJ,cJ,Vk,dl,DI,Bl,em,nm,pm,WH,Em,MH,Rm,Sm,so,wo,aq,Hw,$w,ly,Kz,Nz,M8,L8,K8,J8,I8,H8,O8,G8,N8,P8,k8a,l8a,U8a,W8a,b9a,Z8a,_8a,$8a,mab,nab,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub,jub];var Fh=[kub,bK];var Gh=[lub,eU,fU,gU,hU,iU,jU,kU,lU,mU,nU,oU,pU,qU,rU,tU,uU,vU,wU,xU,yU,zU,AU,BU,CU,DU,EU,FU,GU,HU,IU,JU,KU,LU,MU,NU,OU,PU,QU,RU,SU,TU,UU,VU,WU,XU,YU,ZU,_U,$U,aV,bV,cV,dV,eV,fV,gV,hV,iV,jV,kV,lV,mV,nV,pV,qV,rV,sV,tV,uV,vV,wV,xV,yV,zV,AV,BV,CV,Gma,Hma,Ima,Jma,Kma,mma,nma,oma,pma,qma,Ula,Vla,Wla,Xla,Yla,MJ,ok,gJ,FI,oI,$T,dU,bU,cU,A_,x_,y_,z_,Ndb,lub,lub,lub,lub,lub,lub,lub,lub,lub,lub,lub,lub,lub,lub,lub,lub,lub,lub,lub,lub,lub];var Hh=[mub,dS,eS,qS,rS,BS,CS,MS,NS,XS,YS,gT,hT,rT,sT,CT,DT,NT,OT,$$,X$,d0,g0,j0,q0,C0,I0,N0,Q0,q1,K4,L4,p7,q7,r7,s7,t7,gya,hya,iya,Pva,kya,oya,pya,qya,awa,cwa,hwa,pwa,Gwa,Lwa,Uwa,Wwa,$wa,gxa,qxa,wxa,xxa,Exa,Fxa,WGa,ZGa,fHa,pHa,qHa,rHa,ABa,YPa,ZPa,gQa,hQa,qQa,rQa,MQa,qRa,ERa,NSa,Beb,Ceb,Deb,ehb,ghb,shb,uhb,cib,hib,mib,sib,qnb,snb,unb,Snb,Unb,Wnb,fK,IJ,aJ,UI,AI,ym,QH,sn,zn,Tn,_n,po,to,Bo,Eo,Go,Ko,Mo,Qo,To,dp,op,rp,sp,Kp,Fq,Jq,Zq,br,lr,mr,Gr,Ur,Vr,bs,rs,ys,Os,Ts,nt,st,Ct,Dt,Rt,cu,gu,pu,Eu,Ku,Lu,Su,hv,iv,lv,wv,Qv,Sv,lw,Fw,Iw,Tw,Ww,Cx,Fx,Vx,Xx,Yx,ey,sy,Ky,Ly,Uy,Vy,Zy,az,nz,Az,Iz,Uz,Vz,gA,AA,IA,NA,SA,dB,gB,vB,wB,cC,qC,sC,uC,DC,QC,UC,ZC,mD,oD,rD,vD,zD,CD,kE,sE,uE,AE,DE,_E,bF,iF,TR,UR,FR,GR,rR,sR,dR,eR,RQ,SQ,DQ,EQ,oQ,pQ,_P,$P,KP,LP,wP,xP,iP,jP,WO,XO,IO,JO,uO,vO,gO,hO,TK,$K,gL,iL,kL,HL,KL,NL,$L,aM,dM,kM,pM,qM,wM,CM,KM,OM,jN,oN,pN,xN,GN,HN,SN,ON,L5,P5,T5,W5,Z5,a6,e6,vla,Moa,G8a,Ufb,fdb,sSa,oTa,S9a,T9a,U9a,V9a,W9a,$9a,aab,bab,rab,sab,tab,uab,vab,wab,Cab,Dab,Eab,Fab,Gab,Nab,Pab,Qab,bbb,cbb,dbb,ebb,hbb,gbb,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub,mub];var Ih=[nub,KK,jJ,aI,xq,nub,nub,nub];var Jh=[oub,dJ,vm,oub];var Kh=[pub,nk];var Lh=[qub,ql];var Mh=[rub,eq];var Nh=[sub,Vm,Wm,Xm,Zm,nn,Nn,ao,ko,fp,Bp,Pp,gq,zq,fr,qr,Br,Pr,ls,Js,gt,xt,Mt,$t,zu,Gu,$u,Hv,$v,ww,Nw,gx,vx,Mx,Py,ez,Cz,Xz,aA,vA,_A,qB,LB,SB,hC,mC,FC,eD,wD,PD,$D,nE,TE,qF,OR,AR,mR,_Q,MQ,yQ,jQ,VP,FP,rP,dP,RO,DO,pO,bO,PK,ZK,YM,UN,QN,MN,hN,tN,Jcb,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub,sub];var Oh=[tub,HRa,AD,tub];var Ph=[uub,aS,bS,cS,hS,nS,oS,pS,uS,yS,zS,AS,FS,JS,KS,LS,QS,US,VS,WS,$S,dT,eT,fT,kT,oT,pT,qT,vT,zT,AT,BT,GT,KT,LT,MT,RT,D$,E$,F$,G$,H$,I$,J$,S$,T$,W$,o0,w0,x0,L0,l1,n2,o2,p2,q2,r2,s2,t2,u2,v2,w2,H3,I3,J3,K3,L3,M3,N3,P3,Q3,R3,S3,T3,U3,V3,Baa,Aoa,bza,Tza,Vza,lHa,nHa,EBa,yEa,_Ga,TGa,UOa,YOa,VPa,WPa,XPa,aQa,dQa,eQa,fQa,kQa,nQa,oQa,pQa,uQa,NQa,ZQa,rRa,OSa,QSa,nUa,tXa,MXa,S_a,T_a,J$a,t3a,d4a,n4a,A4a,R4a,e5a,FK,Vi,fj,gj,ij,nj,uj,dK,SJ,Vj,ak,ck,dk,nJ,Ck,Rk,Tk,Zk,MI,gl,jl,ll,sl,tl,Fl,Il,Jl,Ml,Ol,Rl,Sl,am,lm,mm,UH,Am,Bm,RH,Mm,fn,Bn,En,Xn,xo,Ao,Fo,Ho,Lo,No,So,Zo,np,wp,yp,Jp,bq,oq,Gq,Kq,Oq,Tq,Yq,or,Lr,Xr,Zr,hs,ss,_s,mt,pt,Ht,Jt,Ut,_t,fu,ku,Mu,Ru,gv,kv,qv,uv,xv,Dv,Nv,Pv,jw,Zw,Bx,Jx,Sx,hy,Hy,Jy,My,Yy,$y,cz,qz,sz,Pz,hA,GA,fB,lB,AB,FB,YB,eC,rC,tC,vC,PC,WC,cD,fE,vE,yE,FE,aF,dF,kF,uoa,toa,QR,LR,CR,xR,oR,jR,aR,XQ,OQ,JQ,AQ,vQ,gQ,XP,SP,HP,CP,tP,oP,fP,aP,TO,OO,FO,AO,rO,mO,dO,_N,UK,oL,sL,wL,AL,CL,nY,JL,PL,RL,TL,YL,bM,UM,qN,TN,PN,$Z,_Z,b_,a_,h5,k5,o5,r5,Ora,Kra,Lra,Mra,Nra,Ura,Qra,Rra,Sra,Tra,cya,qY,e8a,$cb,adb,Iwa,Xcb,gdb,hdb,rdb,kdb,idb,sdb,udb,vdb,wdb,tdb,jdb,ldb,mdb,pdb,ydb,xdb,qdb,zdb,Bdb,Kdb,Fdb,Gdb,Hdb,Jdb,Idb,Edb,Tdb,Pwa,ceb,geb,Xdb,jeb,keb,Qdb,AGa,tGa,V7a,ybb,xbb,wbb,vbb,ubb,tbb,sbb,zbb,Abb,Bbb,Cbb,Dbb,Ebb,Fbb,Gbb,Hbb,Ibb,Jbb,Kbb,Lbb,Mbb,Nbb,Obb,Pbb,Qbb,Rbb,Sbb,Tbb,Ubb,Vbb,Wbb,rbb,qbb,pbb,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub,uub];var Qh=[vub,wub,yob,Um,Pob,hob,vub,vub];var Rh=[xub,iI,bn,xn,Vn,Yn,Jo,bp,Mp,rq,Iq,Nr,fs,Gs,bt,Wu,nv,Zv,sw,Hx,vy,wz,jA,nA,DB,bC,pC,zC,MC,jD,ID,VD,hE,iE,QE,lQ,WK,LN,i5,p5,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub,xub];var Sh=[yub,Cq];var Th=[zub,uz];var Uh=[Aub,ZR,iS,lS,vS,wS,GS,HS,RS,SS,aT,bT,lT,mT,wT,xT,HT,IT,ST,S4,_X,QX,RX,SX,AZ,yZ,A$,_$,c0,f0,i0,p0,B0,H0,M0,P0,u1,v1,w1,k1,C1,Ehb,Fhb,Ghb,Hhb,E4,M4,N4,O4,F4,G4,T4,U4,X4,b5,c5,Q8,T8,U8,W8,X8,f9,g9,zaa,Aaa,TT,Gaa,xaa,yaa,Yaa,Zaa,Waa,Xaa,Taa,Uaa,Raa,Saa,Oaa,Paa,Maa,Naa,Jaa,Kaa,Haa,Iaa,Tda,Rda,Pda,Nda,Lda,Jda,Hda,Fda,Dda,Bda,zda,xda,vda,tda,rda,pda,nda,lda,jda,hda,fda,dda,bda,$ca,Zca,Xca,Vca,Tca,Qca,Oca,Lca,Jca,Gca,Eca,Cca,Aca,xca,uca,rca,pca,mca,lca,kca,jca,ica,hca,gca,fca,eca,dca,cca,bca,aca,$ba,_ba,Zba,Yba,Xba,Wba,Vba,Uba,Tba,Sba,Rba,Qba,Pba,Oba,Nba,Mba,Lba,Kba,Iba,Gba,lea,zea,yea,xea,wea,vea,uea,tea,sea,rea,qea,pea,oea,nea,mea,Hea,Iea,dfa,efa,cfa,gfa,bfa,ifa,kfa,lfa,$ea,nfa,_ea,pfa,Afa,yfa,kga,lga,wha,xha,pha,qha,kha,lha,fha,gha,aha,bha,Xga,Yga,Sga,Tga,Nga,Oga,Iga,Jga,Dga,Ega,yga,zga,tga,uga,vga,wga,Aga,Bga,Fga,Gga,Kga,Lga,Pga,Qga,Uga,Vga,Zga,_ga,cha,dha,hha,iha,mha,nha,rha,uha,sha,yha,Bha,zha,Oja,Pja,Mja,Nja,Kja,Lja,Ija,Jja,Gja,Hja,Eja,Fja,Cja,Dja,Aja,Bja,yja,zja,uja,vja,lja,mja,cja,dja,Xia,Yia,Qia,Ria,Jia,Kia,Cia,Dia,via,wia,oia,pia,hia,iia,aia,bia,Vha,Wha,Oha,Pha,Qha,Tha,iga,Rha,Xha,_ha,Yha,cia,fia,dia,jia,mia,kia,qia,tia,ria,xia,Aia,yia,Eia,Hia,Fia,Lia,Oia,Mia,Sia,Via,Tia,Zia,aja,_ia,eja,hja,fja,jja,nja,qja,oja,sja,wja,Rja,Sja,ala,bla,Xka,Yka,Ska,Tka,Nka,Oka,Ika,Jka,Dka,Eka,yka,zka,tka,uka,oka,pka,jka,kka,eka,fka,$ja,aka,Wja,Xja,Yja,Zja,jga,bka,cka,gka,hka,lka,mka,qka,rka,vka,wka,Aka,Bka,Fka,Gka,Kka,Lka,Pka,Qka,Uka,Vka,Zka,_ka,cla,dla,Fla,Ela,Nla,Ola,Zla,_la,ama,bma,dma,ema,gma,hma,jma,kma,rma,sma,uma,vma,xma,yma,Ama,Bma,Dma,Ema,Lma,Mma,Oma,Pma,Rma,Sma,Uma,Vma,Xma,Yma,dna,fna,hna,jna,lna,sna,tna,vna,wna,yna,zna,Bna,Cna,Ena,Fna,Sla,Hna,Kna,ioa,joa,moa,noa,xoa,yoa,Toa,Uoa,gga,Rpa,Ppa,Qpa,Npa,Lpa,Mpa,Jpa,Hpa,Ipa,Fpa,Dpa,Epa,Bpa,zpa,Apa,xpa,vpa,wpa,tpa,rpa,spa,ppa,npa,opa,lpa,jpa,kpa,hpa,fpa,gpa,hga,Dqa,Bqa,Cqa,zqa,xqa,yqa,vqa,tqa,uqa,rqa,pqa,qqa,nqa,lqa,mqa,jqa,hqa,iqa,fqa,dqa,eqa,bqa,$pa,aqa,Zpa,Xpa,Ypa,Vpa,Tpa,Upa,wra,xra,rra,sra,mra,nra,hra,ira,cra,dra,Zqa,_qa,Uqa,Vqa,Pqa,Qqa,Kqa,Lqa,Fqa,Gqa,Hqa,Iqa,Mqa,Nqa,Rqa,Sqa,Wqa,Xqa,$qa,ara,era,fra,jra,kra,ora,pra,tra,ura,yra,zra,Era,Fra,Lsa,Jsa,Ksa,Hsa,Fsa,Gsa,Dsa,Bsa,Csa,zsa,xsa,ysa,vsa,tsa,usa,rsa,psa,qsa,nsa,lsa,msa,jsa,hsa,isa,fsa,dsa,esa,Wta,Xta,Zta,Uta,Vta,Qta,Rta,Tta,Ota,Pta,Kta,Lta,Nta,Ita,Jta,Eta,Fta,Hta,Cta,Dta,yta,zta,Bta,wta,xta,sta,tta,vta,qta,rta,mta,nta,pta,kta,lta,gta,hta,jta,eta,fta,ata,bta,dta,_sa,$sa,Wsa,Xsa,Zsa,Usa,Vsa,Qsa,Rsa,Tsa,Osa,Psa,rua,pua,qua,nua,lua,mua,jua,hua,iua,fua,dua,eua,bua,$ta,aua,zua,xua,Zua,_ua,Hva,Iva,Fva,Gva,Dva,Eva,Bva,Cva,zva,Ava,xva,yva,vva,wva,tva,uva,rva,sva,pva,qva,nva,ova,lva,mva,jva,kva,Lva,Mva,Uva,Vva,tya,Zva,_va,fwa,gwa,mwa,nwa,vwa,wwa,Dwa,Ewa,Jwa,Kwa,Rwa,Swa,Zwa,_wa,dxa,exa,jxa,kxa,oxa,pxa,uxa,vxa,yxa,zxa,Axa,Bxa,Cxa,Dxa,Gxa,Hxa,Ixa,Jxa,Kxa,Lxa,Mxa,Nxa,Tva,fya,mya,nya,vya,wya,xya,yya,zya,cza,dza,_za,$za,nza,oza,pza,Uza,VGa,lza,mza,XAa,YAa,ZAa,_Aa,GBa,LBa,MBa,NBa,JBa,KBa,UCa,VCa,yCa,zCa,ACa,OCa,MCa,NCa,FCa,GCa,BCa,CCa,DCa,SCa,nDa,oDa,pDa,VDa,WDa,_Da,$Da,aEa,YDa,ZDa,kEa,HEa,IEa,pEa,qEa,rEa,sEa,tEa,zEa,tFa,uFa,EFa,FFa,GFa,xFa,yFa,zFa,AFa,GGa,LGa,MGa,NGa,UGa,GHa,HHa,JHa,KHa,MHa,NHa,THa,yLa,zLa,ALa,hIa,iIa,jIa,yIa,EIa,IIa,zIa,JIa,LIa,bJa,cJa,dJa,tJa,uJa,vJa,GJa,NJa,OJa,YJa,ZJa,_Ja,nKa,oKa,lKa,DKa,FKa,GKa,HKa,TKa,UKa,VKa,iLa,nLa,oLa,pLa,hOa,iOa,jOa,QLa,RLa,SLa,fMa,gMa,hMa,vMa,wMa,xMa,MMa,NMa,OMa,bNa,cNa,$Ma,rNa,tNa,uNa,vNa,HNa,INa,JNa,YNa,ZNa,_Na,DPa,EPa,FPa,yOa,zOa,AOa,MOa,SOa,WOa,NOa,XOa,ZOa,cPa,dPa,ePa,sPa,tPa,uPa,_R,bQa,lQa,vQa,CQa,DQa,KQa,OQa,QQa,RQa,SQa,TQa,_Qa,eRa,fRa,iRa,jRa,gRa,hRa,kRa,lRa,sRa,uRa,vRa,yRa,zRa,wRa,xRa,ARa,BRa,TRa,URa,ZRa,_Ra,dSa,eSa,CSa,BSa,ESa,GSa,HSa,KSa,LSa,_Sa,$Sa,eTa,fTa,zTa,ATa,xTa,yTa,LTa,MTa,JTa,KTa,iUa,jUa,kUa,lUa,oUa,pUa,vUa,wUa,GUa,HUa,IUa,JUa,aVa,bVa,iVa,jVa,gVa,hVa,GVa,HVa,EVa,FVa,XVa,YVa,VVa,WVa,wWa,LWa,JWa,HWa,DWa,zWa,AWa,yWa,FWa,NWa,PWa,RWa,_Wa,eXa,fXa,gXa,hXa,iXa,jXa,oXa,rXa,CXa,DXa,EXa,FXa,GXa,LXa,RXa,SXa,TXa,UXa,XXa,YXa,VXa,WXa,iYa,jYa,kYa,lYa,EYa,FYa,GYa,HYa,cZa,dZa,eZa,fZa,nZa,oZa,pZa,qZa,zZa,AZa,BZa,CZa,OZa,PZa,ZZa,_Za,g_a,h_a,p_a,q_a,r_a,s_a,t_a,u_a,v_a,w_a,x_a,y_a,e$a,f$a,g$a,h$a,q$a,r$a,E$a,F$a,C$a,D$a,V$a,W$a,X$a,Y$a,i0a,j0a,k0a,l0a,T0a,U0a,S0a,X0a,R0a,Z0a,Q0a,$0a,P0a,b1a,O0a,d1a,N0a,f1a,M0a,h1a,L0a,k1a,K0a,m1a,J0a,o1a,I0a,q1a,H0a,s1a,G0a,u1a,F0a,w1a,E0a,z1a,D0a,B1a,C0a,D1a,B0a,F1a,A0a,H1a,z0a,J1a,f2a,g2a,e2a,i2a,d2a,k2a,c2a,m2a,b2a,o2a,a2a,q2a,$1a,s2a,_1a,u2a,Z1a,w2a,Y1a,y2a,X1a,A2a,W1a,C2a,V1a,E2a,U1a,G2a,T1a,I2a,S1a,K2a,R1a,M2a,Q1a,O2a,P1a,Q2a,O1a,S2a,N1a,U2a,d3a,e3a,b3a,c3a,g3a,h3a,i3a,j3a,o3a,p3a,m3a,n3a,C3a,D3a,E3a,F3a,$3a,a4a,Z3a,_3a,j4a,k4a,h4a,i4a,w4a,x4a,u4a,v4a,N4a,O4a,L4a,M4a,a5a,b5a,_4a,$4a,r5a,s5a,N5a,O5a,P5a,Q5a,r6a,v6a,w6a,A6a,L6a,M6a,O6a,J6a,K6a,n7a,I7a,o7a,G7a,p7a,E7a,q7a,C7a,t7a,u7a,w7a,x7a,z7a,A7a,Tgb,Ugb,Vgb,Wgb,hhb,ihb,whb,xhb,yhb,zhb,Ahb,Bhb,Chb,Dhb,Ihb,Jhb,Khb,Lhb,_hb,dib,jib,pib,uib,vib,wib,Aib,Bib,Fib,Gib,ljb,mjb,Djb,Ejb,Ujb,Vjb,fkb,gkb,Dkb,Ekb,$kb,alb,elb,flb,hlb,ilb,slb,tlb,Dlb,Elb,Olb,Plb,Zlb,_lb,fmb,gmb,lmb,mmb,rmb,smb,xmb,ymb,Cmb,Dmb,Hmb,Qmb,Imb,dnb,enb,mnb,nnb,onb,pnb,ynb,znb,Fnb,Gnb,Mnb,Nnb,_nb,$nb,aob,Aob,Bob,Cob,Dob,Lob,Sob,Tob,Vob,Xob,Zob,$ob,KH,Ym,$m,pn,rn,Pn,Rn,co,fo,tTa,uTa,Po,UDa,hp,jp,qp,Dp,Fp,kza,Rp,Tp,Yp,iq,kq,qq,uq,Mq,hr,jr,sr,ur,f3a,Dr,Fr,Rr,Tr,IHa,ns,ps,xs,Bs,Ls,Ns,Zs,it,kt,wCa,zt,Bt,Ot,Qt,tu,Bu,Du,Ou,Uu,bv,dv,Jv,Lv,bw,dw,hw,yw,Aw,Kw,bx,XDa,ix,kx,ox,B3a,xx,zx,Ox,Qx,_x,cy,jy,ry,uya,Ry,Ty,oEa,gz,iz,mz,Ez,Gz,Zz,$z,lA,xA,zA,DA,FA,aB,cB,sB,uB,NB,PB,I6a,UB,WB,jC,lC,xC,BC,HC,JC,sFa,gD,iD,lD,GD,RD,TD,bE,dE,pE,rE,CE,VE,XE,IBa,sF,NR,zR,lR,ZQ,LQ,xQ,iQ,UP,EP,qP,cP,QO,CO,oO,aO,OK,YK,XM,bN,VN,RN,NN,gN,sN,g5,l5,n5,s5,J5,O5,R5,I9,O9,B9,d6,r9,T9,ula,gva,ggb,i9a,k9a,rwa,l9a,I8a,D8a,E8a,F8a,swa,y8a,B8a,O8a,Uxa,v8a,x8a,Awa,Cwa,f8a,h8a,N7a,Mdb,Ldb,Udb,Qwa,teb,ueb,$db,_cb,HF,SJa,rSa,nTa,_7a,$7a,a8a,cab,eab,m8a,lab,R9a,Q7a,R7a,S7a,T7a,U7a,R8a,S8a,y9a,z9a,H9a,T8a,Rab,a9a,$ab,Bab,abb,s9a,w9a,K9a,N9a,qab,pab,Kab,Lab,dfb,gfb,Xhb,xkb,wkb,vkb,kob,Vkb,Ukb,Tkb,tob,bmb,Qob,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub,Aub];var Vh=[Bub,iGa];var Wh=[Cub,_J];var Xh=[Dub,fS,gS,sS,tS,DS,ES,OS,PS,ZS,_S,iT,jT,tT,uT,ET,FT,PT,QT,r1,s1,$gb,ahb,J4,dhb,W4,V8,h9,WT,Nva,Ova,Qva,jya,$va,bwa,owa,Fwa,Twa,Vwa,fxa,sCa,Dya,Eya,Fya,Jya,dAa,eAa,fAa,iAa,kAa,mAa,oAa,qAa,sAa,uAa,AAa,BAa,CAa,DAa,EAa,GAa,tza,uza,vza,xza,zza,Bza,Dza,Fza,Hza,Jza,Pza,Qza,Rza,Sza,YGa,$Aa,aBa,bBa,cBa,dBa,eBa,uBa,RBa,SBa,TBa,WBa,YBa,ZCa,_Ca,$Ca,cDa,eDa,gDa,iDa,QCa,ICa,tDa,uDa,vDa,ADa,CDa,EDa,GDa,eEa,fEa,gEa,MEa,NEa,OEa,REa,TEa,VEa,XEa,ZEa,$Ea,bFa,hFa,iFa,jFa,kFa,lFa,nFa,wEa,AEa,KFa,LFa,MFa,PFa,fGa,BFa,FLa,GLa,HLa,ILa,oIa,pIa,qIa,rIa,FIa,AIa,hJa,iJa,jJa,kJa,yJa,zJa,AJa,BJa,PJa,bKa,cKa,dKa,eKa,rKa,sKa,tKa,uKa,KKa,LKa,MKa,NKa,ZKa,_Ka,$Ka,aLa,jLa,sLa,tLa,uLa,vLa,oOa,pOa,qOa,rOa,XLa,YLa,ZLa,_La,lMa,mMa,nMa,oMa,AMa,BMa,CMa,DMa,RMa,SMa,TMa,UMa,fNa,gNa,hNa,iNa,yNa,zNa,ANa,BNa,NNa,ONa,PNa,QNa,bOa,cOa,dOa,eOa,KPa,LPa,MPa,NPa,FOa,GOa,HOa,IOa,TOa,VOa,OOa,POa,iPa,jPa,kPa,lPa,xPa,yPa,zPa,APa,_Pa,$Pa,iQa,jQa,sQa,tQa,GQa,WQa,oRa,DRa,IRa,KRa,LRa,vVa,BVa,CVa,DVa,DTa,FTa,HTa,QTa,RTa,STa,UTa,WTa,YTa,aUa,cUa,eUa,LUa,MUa,NUa,mVa,oVa,qVa,KVa,QVa,SVa,aWa,bWa,cWa,eWa,gWa,kWa,mWa,oWa,mXa,sXa,KXa,pYa,rYa,tYa,vYa,JYa,KYa,LYa,NYa,RYa,TYa,VYa,XYa,ZYa,$Ya,bZa,mZa,vZa,HZa,LZa,UZa,YZa,d_a,m_a,D_a,F_a,L_a,V_a,N$a,P$a,R$a,c0a,e0a,p0a,x5a,z5a,D5a,F5a,H5a,V5a,X5a,l6a,n6a,X6a,Z6a,b7a,d7a,f7a,j7a,_eb,chb,nhb,ohb,qhb,rhb,aib,fib,kib,lib,qib,rib,hkb,okb,pkb,qkb,rkb,skb,tkb,ukb,Fkb,Mkb,Nkb,Okb,Pkb,Qkb,Rkb,Skb,jlb,klb,plb,ulb,vlb,Alb,Flb,Glb,Llb,Qlb,Rlb,Wlb,Mmb,Nmb,Pmb,$mb,anb,cnb,Anb,Bnb,Hnb,Inb,Umb,Vmb,Xmb,inb,jnb,lnb,Uob,$j,Yk,zl,JH,_m,HH,GH,mn,on,qn,FH,EH,Mn,On,Qn,DH,CH,$n,bo,eo,lo,oo,qo,sTa,cTa,Oo,yH,xH,Wo,ep,gp,ip,wH,vH,pp,uH,tH,Ap,Cp,Ep,sH,rH,Gp,Op,Qp,Sp,qH,pH,Xp,oH,nH,fq,hq,jq,mH,lH,pq,kH,jH,tq,Aq,Lq,iH,hH,er,gr,ir,gH,fH,pr,rr,tr,eH,dH,zr,Ar,Cr,Er,cH,bH,Or,Qr,Sr,aH,$G,is,ks,ms,os,_G,ZG,ws,YG,XG,As,WG,VG,Is,Ks,Ms,UG,TG,Ys,SG,RG,ft,ht,jt,QG,PG,tt,wt,yt,At,OG,NG,Lt,Nt,Pt,au,bu,su,MG,LG,yu,Au,Cu,Hu,Nu,JG,IG,Tu,HG,GG,_u,av,cv,FG,EG,Gv,Iv,Kv,DG,CG,_v,aw,cw,BG,AG,gw,zG,yG,vw,xw,zw,xG,wG,Jw,Ow,BQa,AQa,ax,vG,uG,ex,fx,hx,jx,tG,sG,nx,rG,qG,tx,ux,wx,yx,pG,oG,Lx,Nx,Px,sUa,tUa,uUa,Zx,nG,mG,by,iy,lG,kG,qy,jG,iG,By,Oy,Qy,Sy,hG,gG,Wy,dz,fz,hz,fG,eG,lz,dG,cG,Bz,Dz,Fz,bG,aG,eYa,Wz,Yz,_z,bA,kA,$F,_F,uA,wA,yA,ZF,YF,CA,XF,WF,EA,ZA,$A,bB,VF,UF,pB,rB,tB,TF,SF,KB,MB,OB,RF,QF,QB,RB,TB,VB,PF,OF,gC,iC,kC,nC,wC,AC,NF,MF,EC,GC,IC,LF,KF,SC,dD,fD,hD,JF,IF,kD,kSa,iSa,xD,yD,fSa,FD,GF,FF,OD,QD,SD,EF,DF,_D,aE,cE,CF,BF,mE,oE,qE,qUa,rUa,BE,xF,wF,SE,UE,WE,vF,uF,mF,pF,rF,MR,PR,SR,yR,BR,ER,kR,nR,qR,YQ,$Q,cR,KQ,NQ,QQ,wQ,zQ,CQ,hQ,kQ,nQ,TP,WP,ZP,DP,GP,JP,pP,sP,vP,bP,eP,hP,PO,SO,VO,BO,EO,HO,nO,qO,tO,$N,cO,fO,NK,QK,XK,_K,fL,hL,jL,nL,EL,FL,GL,SL,cM,eM,fM,gM,hM,iM,jM,WM,ZM,aN,fN,iN,nN,rN,uN,vN,FN,I5,K5,Q5,S5,V5,J9,Y5,P9,$5,C9,c6,F9,tla,xla,Qfb,fgb,J8a,K8a,L8a,M8a,C8a,twa,z8a,Vxa,u8a,w8a,Bwa,ZT,edb,Geb,qSa,uSa,mTa,qTa,Mab,Oab,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub,Dub];var Yh=[Eub,uK,E_,B_,C_,D_,Eub,Eub];var Zh=[Fub,R$,v0,F0,tm,Fub,Fub,Fub];var _h=[Gub,Uv];var $h=[Hub,bHa,dHa,ZSa,Yj,zJ,xI,Vl];var ai=[Iub,jI,zv,Iub];var bi=[Jub,BD];var ci=[Kub,Ygb,bhb,fhb,Wva,iwa,xwa,Mwa,axa,lxa,rxa,Gya,gAa,wza,XGa,UBa,aDa,wDa,hEa,PEa,xEa,NFa,QGa,SHa,EQa,HQa,IQa,UQa,XQa,mRa,pRa,PSa,$eb,afb,efb,ffb,wfb,khb,phb,thb,bib,gib,zib,Eib,zmb,Emb,rnb,tnb,wnb,Onb,Tnb,Vnb,Ynb,Eob,Wob,Yob,_ob,yj,Kj,uk,ZI,KI,II,ml,nl,uI,Kl,pI,sm,SH,go,ts,zs,Us,St,Vt,Xt,du,hu,iu,qu,Fu,Lw,Pw,Wx,Ny,cA,BA,TA,nD,pD,sD,wE,VR,WR,HR,IR,tR,uR,fR,gR,TQ,UQ,FQ,GQ,qQ,rQ,aQ,bQ,MP,NP,yP,zP,kP,lP,YO,ZO,KO,LO,wO,xO,iO,jO,RK,aL,bL,pL,tL,BL,LL,ZL,lM,mM,rM,sM,xM,yM,DM,EM,MM,QM,VM,kN,zN,IN,M7a,zGa,sGa,m9a,n9a,Hcb,Web,Yfb,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub,Kub];var di=[Lub,Sk];var ei=[Mub,Gk,yq,Mub];var fi=[Nub,Zn,sq,jE];var gi=[Oub,Hk];var hi=[Pub,jEa,CI,kI,Vo,Qs,Ss,cx,$C,JM,TM,Pub,Pub,Pub,Pub,Pub];var ii=[Qub,wI];var ji=[Rub,tZ,uZ,vZ,wZ,Rub,Rub,Rub];var ki=[Sub,mo];var li=[Tub,CLa,lIa,lOa,ULa,HPa,COa,Tub];var mi=[Uub,hHa];var ni=[Vub,EI];var oi=[Wub,QHa,Rw,Wub];var pi=[Xub,kDa,RCa,JCa,Ok,ut,dx,Xub];var qi=[Yub,mj];var ri=[Zub,jo];var si=[_ub,D1,fCa,nkb,Lkb,Jmb,Kmb,Ymb,Zmb,Rmb,Smb,fnb,gnb,Cj,PA,YE];var ti=[$ub,oK];var ui=[avb,sJ,LI,mL];var vi=[bvb,yJ];return{_memset:zpb,___udivdi3:spb,_bitshift64Lshr:ppb,_bitshift64Shl:Apb,_fflush:Rfb,___cxa_is_pointer_type:hpb,_bitshift64Ashr:opb,_llvm_cttz_i32:qpb,_sbrk:vpb,_memcpy:upb,_llvm_bswap_i32:ypb,___muldi3:Epb,___uremdi3:xpb,___divdi3:Bpb,_i64Subtract:jpb,___udivmoddi4:rpb,_realloc:hgb,_i64Add:kpb,_pthread_self:Fpb,_pthread_mutex_unlock:lpb,_saveSetjmp:npb,___getTypeName:Zeb,_pthread_cond_broadcast:tpb,___errno_location:cfb,___muldsi3:Dpb,_testSetjmp:Cpb,___cxa_can_catch:gpb,_free:ggb,_memmove:wpb,_malloc:fgb,_pthread_mutex_lock:mpb,__GLOBAL__I_000101:Vhb,__GLOBAL__sub_I_umatrix_cpp:q9,__GLOBAL__sub_I_iostream_cpp:Whb,__GLOBAL__sub_I_bind_cpp:Yeb,__GLOBAL__sub_I_hog_cpp:lTa,__GLOBAL__sub_I_haar_cpp:pSa,___cxx_global_var_init_38:TPa,___cxx_global_var_init_37:SPa,___cxx_global_var_init_36:RPa,__GLOBAL__sub_I_knearest_cpp:vCa,__GLOBAL__sub_I_loadsave_cpp:fva,__GLOBAL__sub_I_imgwarp_cpp:Pla,__GLOBAL__sub_I_histogram_cpp:sla,___cxx_global_var_init_1423:Di,__GLOBAL__sub_I_system_cpp:a9,__GLOBAL__sub_I_persistence_cpp:H5,__GLOBAL__sub_I_bindings_cpp:Mi,___cxx_global_var_init_1431:Li,___cxx_global_var_init_1430:Ki,___cxx_global_var_init_1429:Ji,___cxx_global_var_init_1428:Ii,___cxx_global_var_init_1427:Hi,___cxx_global_var_init_1426:Gi,___cxx_global_var_init_1425:Fi,___cxx_global_var_init_1424:Ei,runPostSets:ipb,_emscripten_replace_memory:Lf,stackAlloc:wi,stackSave:xi,stackRestore:yi,establishStackSpace:zi,setThrew:Ai,setTempRet0:Bi,getTempRet0:Ci,dynCall_iiiiiid:Gpb,dynCall_viiiiddd:Hpb,dynCall_viiiidiii:Ipb,dynCall_viiiiiddi:Jpb,dynCall_viiidiii:Kpb,dynCall_iiiiddiii:Lpb,dynCall_iiiiiii:Mpb,dynCall_viiiidddiiii:Npb,dynCall_viiiiddi:Opb,dynCall_viiiiiiiiiii:Ppb,dynCall_iidd:Qpb,dynCall_viiiiiiiiiid:Rpb,dynCall_viiiidiiii:Spb,dynCall_iidi:Tpb,dynCall_viiddidd:Upb,dynCall_vidi:Vpb,dynCall_viiddii:Wpb,dynCall_viiiiddiddi:Xpb,dynCall_viiiiidi:Ypb,dynCall_viiddidddd:Zpb,dynCall_viiiiddiiid:_pb,dynCall_viiiiiiidi:$pb,dynCall_viiidii:aqb,dynCall_di:bqb,dynCall_iiiiddi:cqb,dynCall_viiiidiiddi:dqb,dynCall_iiddddd:eqb,dynCall_diiiiiii:fqb,dynCall_iiiiiddiddi:gqb,dynCall_viidddddi:hqb,dynCall_dii:iqb,dynCall_viiiddiiid:jqb,dynCall_iiidddddi:kqb,dynCall_diidi:lqb,dynCall_viiiiiiiiiiddi:mqb,dynCall_iiiiiiiiii:nqb,dynCall_iiiid:oqb,dynCall_iiiiiiii:pqb,dynCall_viiddiii:qqb,dynCall_viiddiid:rqb,dynCall_iiiiiiiididiii:sqb,dynCall_iidddd:tqb,dynCall_viidiiid:uqb,dynCall_viiiiidiiii:vqb,dynCall_diiiddi:wqb,dynCall_iiiii:xqb,dynCall_viiididii:yqb,dynCall_diiiiiiii:zqb,dynCall_viiidiiid:Aqb,dynCall_viiiddddii:Bqb,dynCall_iiidiiiiiii:Cqb,dynCall_viiiiid:Dqb,dynCall_viiiiddddii:Eqb,dynCall_viiiiii:Fqb,dynCall_viiidiiii:Gqb,dynCall_viiidd:Hqb,dynCall_viiidi:Iqb,dynCall_vidddd:Jqb,dynCall_iiiiiidii:Kqb,dynCall_iiddd:Lqb,dynCall_viiiiiiiiii:Mqb,dynCall_diiddi:Nqb,dynCall_diii:Oqb,dynCall_viiiddd:Pqb,dynCall_viiiddidddd:Qqb,dynCall_viiiiiiiiiiid:Rqb,dynCall_viiiddidd:Sqb,dynCall_viiidiiiidi:Tqb,dynCall_viiiddi:Uqb,dynCall_iiiiii:Vqb,dynCall_viiid:Wqb,dynCall_viidii:Xqb,dynCall_iiiiid:Yqb,dynCall_viiii:Zqb,dynCall_viiiii:_qb,dynCall_viidiiiiiii:$qb,dynCall_vid:arb,dynCall_iiidi:brb,dynCall_iiidd:crb,dynCall_vii:drb,dynCall_viiiid:erb,dynCall_iiiiidiii:frb,dynCall_viidd:grb,dynCall_viidi:hrb,dynCall_viddd:irb,dynCall_viiidiiddi:jrb,dynCall_iiiidii:krb,dynCall_diiid:lrb,dynCall_viiiiiiii:mrb,dynCall_viiidddiiii:nrb,dynCall_viiiiiiid:orb,dynCall_viiiiiiddi:prb,dynCall_diiii:qrb,dynCall_viiiiidiiddi:rrb,dynCall_viddddd:srb,dynCall_viiddddddi:trb,dynCall_viiiiiddii:urb,dynCall_viiiiidii:vrb,dynCall_iid:wrb,dynCall_viiiiiiiid:xrb,dynCall_viiiiiii:yrb,dynCall_viiiiiid:zrb,dynCall_viiiiiiiii:Arb,dynCall_iii:Brb,dynCall_viiiddii:Crb,dynCall_viiiiiidi:Drb,dynCall_vdiii:Erb,dynCall_diiiiiiiid:Frb,dynCall_iiiddddddi:Grb,dynCall_i:Hrb,dynCall_viiiiidiiiii:Irb,dynCall_viii:Jrb,dynCall_v:Krb,dynCall_viid:Lrb,dynCall_iidddddii:Mrb,dynCall_iiiddiid:Nrb,dynCall_vi:Orb,dynCall_iiiiiiiiiii:Prb,dynCall_viiiidiiiidi:Qrb,dynCall_ii:Rrb,dynCall_viiiiiiiddi:Srb,dynCall_vidii:Trb,dynCall_iiiidiii:Urb,dynCall_viiiidi:Vrb,dynCall_viiiddiii:Wrb,dynCall_viiiiiidiiiii:Xrb,dynCall_iiii:Yrb,dynCall_viididii:Zrb,dynCall_viiiiddii:_rb,dynCall_iiid:$rb,dynCall_viiiidii:asb,dynCall_diiiii:bsb,dynCall_diiiid:csb,dynCall_viiiiiiiiiiiiii:dsb,dynCall_iiiiiiiiiiiii:esb,dynCall_iiiiidi:fsb,dynCall_iiidid:gsb,dynCall_diiiiiiiiid:hsb,dynCall_iiiiidii:isb,dynCall_diiiiii:jsb,dynCall_vididdii:ksb,dynCall_viiiiidiii:lsb,dynCall_iiiiiiiii:msb,dynCall_viididdii:nsb,dynCall_viiiidd:osb,dynCall_vidiii:psb}})


// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg,Module.asmLibraryArg,buffer);var __GLOBAL__sub_I_system_cpp=Module["__GLOBAL__sub_I_system_cpp"]=asm["__GLOBAL__sub_I_system_cpp"];var ___cxx_global_var_init_37=Module["___cxx_global_var_init_37"]=asm["___cxx_global_var_init_37"];var __GLOBAL__sub_I_umatrix_cpp=Module["__GLOBAL__sub_I_umatrix_cpp"]=asm["__GLOBAL__sub_I_umatrix_cpp"];var _memset=Module["_memset"]=asm["_memset"];var _bitshift64Lshr=Module["_bitshift64Lshr"]=asm["_bitshift64Lshr"];var __GLOBAL__sub_I_persistence_cpp=Module["__GLOBAL__sub_I_persistence_cpp"]=asm["__GLOBAL__sub_I_persistence_cpp"];var _bitshift64Shl=Module["_bitshift64Shl"]=asm["_bitshift64Shl"];var ___cxx_global_var_init_1423=Module["___cxx_global_var_init_1423"]=asm["___cxx_global_var_init_1423"];var _pthread_cond_broadcast=Module["_pthread_cond_broadcast"]=asm["_pthread_cond_broadcast"];var _fflush=Module["_fflush"]=asm["_fflush"];var ___cxa_is_pointer_type=Module["___cxa_is_pointer_type"]=asm["___cxa_is_pointer_type"];var __GLOBAL__sub_I_haar_cpp=Module["__GLOBAL__sub_I_haar_cpp"]=asm["__GLOBAL__sub_I_haar_cpp"];var _bitshift64Ashr=Module["_bitshift64Ashr"]=asm["_bitshift64Ashr"];var _llvm_cttz_i32=Module["_llvm_cttz_i32"]=asm["_llvm_cttz_i32"];var _sbrk=Module["_sbrk"]=asm["_sbrk"];var __GLOBAL__sub_I_imgwarp_cpp=Module["__GLOBAL__sub_I_imgwarp_cpp"]=asm["__GLOBAL__sub_I_imgwarp_cpp"];var _memcpy=Module["_memcpy"]=asm["_memcpy"];var ___errno_location=Module["___errno_location"]=asm["___errno_location"];var ___muldi3=Module["___muldi3"]=asm["___muldi3"];var _emscripten_replace_memory=Module["_emscripten_replace_memory"]=asm["_emscripten_replace_memory"];var ___uremdi3=Module["___uremdi3"]=asm["___uremdi3"];var ___cxx_global_var_init_1430=Module["___cxx_global_var_init_1430"]=asm["___cxx_global_var_init_1430"];var ___divdi3=Module["___divdi3"]=asm["___divdi3"];var _i64Subtract=Module["_i64Subtract"]=asm["_i64Subtract"];var __GLOBAL__sub_I_bind_cpp=Module["__GLOBAL__sub_I_bind_cpp"]=asm["__GLOBAL__sub_I_bind_cpp"];var ___cxx_global_var_init_38=Module["___cxx_global_var_init_38"]=asm["___cxx_global_var_init_38"];var ___udivmoddi4=Module["___udivmoddi4"]=asm["___udivmoddi4"];var _realloc=Module["_realloc"]=asm["_realloc"];var _i64Add=Module["_i64Add"]=asm["_i64Add"];var ___cxx_global_var_init_36=Module["___cxx_global_var_init_36"]=asm["___cxx_global_var_init_36"];var _pthread_self=Module["_pthread_self"]=asm["_pthread_self"];var _pthread_mutex_unlock=Module["_pthread_mutex_unlock"]=asm["_pthread_mutex_unlock"];var __GLOBAL__I_000101=Module["__GLOBAL__I_000101"]=asm["__GLOBAL__I_000101"];var ___getTypeName=Module["___getTypeName"]=asm["___getTypeName"];var __GLOBAL__sub_I_iostream_cpp=Module["__GLOBAL__sub_I_iostream_cpp"]=asm["__GLOBAL__sub_I_iostream_cpp"];var ___cxx_global_var_init_1431=Module["___cxx_global_var_init_1431"]=asm["___cxx_global_var_init_1431"];var __GLOBAL__sub_I_knearest_cpp=Module["__GLOBAL__sub_I_knearest_cpp"]=asm["__GLOBAL__sub_I_knearest_cpp"];var ___udivdi3=Module["___udivdi3"]=asm["___udivdi3"];var _llvm_bswap_i32=Module["_llvm_bswap_i32"]=asm["_llvm_bswap_i32"];var runPostSets=Module["runPostSets"]=asm["runPostSets"];var ___muldsi3=Module["___muldsi3"]=asm["___muldsi3"];var _testSetjmp=Module["_testSetjmp"]=asm["_testSetjmp"];var _saveSetjmp=Module["_saveSetjmp"]=asm["_saveSetjmp"];var _free=Module["_free"]=asm["_free"];var ___cxa_can_catch=Module["___cxa_can_catch"]=asm["___cxa_can_catch"];var __GLOBAL__sub_I_hog_cpp=Module["__GLOBAL__sub_I_hog_cpp"]=asm["__GLOBAL__sub_I_hog_cpp"];var _memmove=Module["_memmove"]=asm["_memmove"];var __GLOBAL__sub_I_bindings_cpp=Module["__GLOBAL__sub_I_bindings_cpp"]=asm["__GLOBAL__sub_I_bindings_cpp"];var _malloc=Module["_malloc"]=asm["_malloc"];var __GLOBAL__sub_I_histogram_cpp=Module["__GLOBAL__sub_I_histogram_cpp"]=asm["__GLOBAL__sub_I_histogram_cpp"];var _pthread_mutex_lock=Module["_pthread_mutex_lock"]=asm["_pthread_mutex_lock"];var ___cxx_global_var_init_1426=Module["___cxx_global_var_init_1426"]=asm["___cxx_global_var_init_1426"];var ___cxx_global_var_init_1427=Module["___cxx_global_var_init_1427"]=asm["___cxx_global_var_init_1427"];var ___cxx_global_var_init_1424=Module["___cxx_global_var_init_1424"]=asm["___cxx_global_var_init_1424"];var ___cxx_global_var_init_1425=Module["___cxx_global_var_init_1425"]=asm["___cxx_global_var_init_1425"];var ___cxx_global_var_init_1428=Module["___cxx_global_var_init_1428"]=asm["___cxx_global_var_init_1428"];var ___cxx_global_var_init_1429=Module["___cxx_global_var_init_1429"]=asm["___cxx_global_var_init_1429"];var __GLOBAL__sub_I_loadsave_cpp=Module["__GLOBAL__sub_I_loadsave_cpp"]=asm["__GLOBAL__sub_I_loadsave_cpp"];var dynCall_iiiiiid=Module["dynCall_iiiiiid"]=asm["dynCall_iiiiiid"];var dynCall_viiiiddd=Module["dynCall_viiiiddd"]=asm["dynCall_viiiiddd"];var dynCall_viiiidiii=Module["dynCall_viiiidiii"]=asm["dynCall_viiiidiii"];var dynCall_viiiiiddi=Module["dynCall_viiiiiddi"]=asm["dynCall_viiiiiddi"];var dynCall_viiidiii=Module["dynCall_viiidiii"]=asm["dynCall_viiidiii"];var dynCall_iiiiddiii=Module["dynCall_iiiiddiii"]=asm["dynCall_iiiiddiii"];var dynCall_iiiiiii=Module["dynCall_iiiiiii"]=asm["dynCall_iiiiiii"];var dynCall_viiiidddiiii=Module["dynCall_viiiidddiiii"]=asm["dynCall_viiiidddiiii"];var dynCall_viiiiddi=Module["dynCall_viiiiddi"]=asm["dynCall_viiiiddi"];var dynCall_viiiiiiiiiii=Module["dynCall_viiiiiiiiiii"]=asm["dynCall_viiiiiiiiiii"];var dynCall_iidd=Module["dynCall_iidd"]=asm["dynCall_iidd"];var dynCall_viiiiiiiiiid=Module["dynCall_viiiiiiiiiid"]=asm["dynCall_viiiiiiiiiid"];var dynCall_viiiidiiii=Module["dynCall_viiiidiiii"]=asm["dynCall_viiiidiiii"];var dynCall_iidi=Module["dynCall_iidi"]=asm["dynCall_iidi"];var dynCall_viiddidd=Module["dynCall_viiddidd"]=asm["dynCall_viiddidd"];var dynCall_vidi=Module["dynCall_vidi"]=asm["dynCall_vidi"];var dynCall_viiddii=Module["dynCall_viiddii"]=asm["dynCall_viiddii"];var dynCall_viiiiddiddi=Module["dynCall_viiiiddiddi"]=asm["dynCall_viiiiddiddi"];var dynCall_viiiiidi=Module["dynCall_viiiiidi"]=asm["dynCall_viiiiidi"];var dynCall_viiddidddd=Module["dynCall_viiddidddd"]=asm["dynCall_viiddidddd"];var dynCall_viiiiddiiid=Module["dynCall_viiiiddiiid"]=asm["dynCall_viiiiddiiid"];var dynCall_viiiiiiidi=Module["dynCall_viiiiiiidi"]=asm["dynCall_viiiiiiidi"];var dynCall_viiidii=Module["dynCall_viiidii"]=asm["dynCall_viiidii"];var dynCall_di=Module["dynCall_di"]=asm["dynCall_di"];var dynCall_iiiiddi=Module["dynCall_iiiiddi"]=asm["dynCall_iiiiddi"];var dynCall_viiiidiiddi=Module["dynCall_viiiidiiddi"]=asm["dynCall_viiiidiiddi"];var dynCall_iiddddd=Module["dynCall_iiddddd"]=asm["dynCall_iiddddd"];var dynCall_diiiiiii=Module["dynCall_diiiiiii"]=asm["dynCall_diiiiiii"];var dynCall_iiiiiddiddi=Module["dynCall_iiiiiddiddi"]=asm["dynCall_iiiiiddiddi"];var dynCall_viidddddi=Module["dynCall_viidddddi"]=asm["dynCall_viidddddi"];var dynCall_dii=Module["dynCall_dii"]=asm["dynCall_dii"];var dynCall_viiiddiiid=Module["dynCall_viiiddiiid"]=asm["dynCall_viiiddiiid"];var dynCall_iiidddddi=Module["dynCall_iiidddddi"]=asm["dynCall_iiidddddi"];var dynCall_diidi=Module["dynCall_diidi"]=asm["dynCall_diidi"];var dynCall_viiiiiiiiiiddi=Module["dynCall_viiiiiiiiiiddi"]=asm["dynCall_viiiiiiiiiiddi"];var dynCall_iiiiiiiiii=Module["dynCall_iiiiiiiiii"]=asm["dynCall_iiiiiiiiii"];var dynCall_iiiid=Module["dynCall_iiiid"]=asm["dynCall_iiiid"];var dynCall_iiiiiiii=Module["dynCall_iiiiiiii"]=asm["dynCall_iiiiiiii"];var dynCall_viiddiii=Module["dynCall_viiddiii"]=asm["dynCall_viiddiii"];var dynCall_viiddiid=Module["dynCall_viiddiid"]=asm["dynCall_viiddiid"];var dynCall_iiiiiiiididiii=Module["dynCall_iiiiiiiididiii"]=asm["dynCall_iiiiiiiididiii"];var dynCall_iidddd=Module["dynCall_iidddd"]=asm["dynCall_iidddd"];var dynCall_viidiiid=Module["dynCall_viidiiid"]=asm["dynCall_viidiiid"];var dynCall_viiiiidiiii=Module["dynCall_viiiiidiiii"]=asm["dynCall_viiiiidiiii"];var dynCall_diiiddi=Module["dynCall_diiiddi"]=asm["dynCall_diiiddi"];var dynCall_iiiii=Module["dynCall_iiiii"]=asm["dynCall_iiiii"];var dynCall_viiididii=Module["dynCall_viiididii"]=asm["dynCall_viiididii"];var dynCall_diiiiiiii=Module["dynCall_diiiiiiii"]=asm["dynCall_diiiiiiii"];var dynCall_viiidiiid=Module["dynCall_viiidiiid"]=asm["dynCall_viiidiiid"];var dynCall_viiiddddii=Module["dynCall_viiiddddii"]=asm["dynCall_viiiddddii"];var dynCall_iiidiiiiiii=Module["dynCall_iiidiiiiiii"]=asm["dynCall_iiidiiiiiii"];var dynCall_viiiiid=Module["dynCall_viiiiid"]=asm["dynCall_viiiiid"];var dynCall_viiiiddddii=Module["dynCall_viiiiddddii"]=asm["dynCall_viiiiddddii"];var dynCall_viiiiii=Module["dynCall_viiiiii"]=asm["dynCall_viiiiii"];var dynCall_viiidiiii=Module["dynCall_viiidiiii"]=asm["dynCall_viiidiiii"];var dynCall_viiidd=Module["dynCall_viiidd"]=asm["dynCall_viiidd"];var dynCall_viiidi=Module["dynCall_viiidi"]=asm["dynCall_viiidi"];var dynCall_vidddd=Module["dynCall_vidddd"]=asm["dynCall_vidddd"];var dynCall_iiiiiidii=Module["dynCall_iiiiiidii"]=asm["dynCall_iiiiiidii"];var dynCall_iiddd=Module["dynCall_iiddd"]=asm["dynCall_iiddd"];var dynCall_viiiiiiiiii=Module["dynCall_viiiiiiiiii"]=asm["dynCall_viiiiiiiiii"];var dynCall_diiddi=Module["dynCall_diiddi"]=asm["dynCall_diiddi"];var dynCall_diii=Module["dynCall_diii"]=asm["dynCall_diii"];var dynCall_viiiddd=Module["dynCall_viiiddd"]=asm["dynCall_viiiddd"];var dynCall_viiiddidddd=Module["dynCall_viiiddidddd"]=asm["dynCall_viiiddidddd"];var dynCall_viiiiiiiiiiid=Module["dynCall_viiiiiiiiiiid"]=asm["dynCall_viiiiiiiiiiid"];var dynCall_viiiddidd=Module["dynCall_viiiddidd"]=asm["dynCall_viiiddidd"];var dynCall_viiidiiiidi=Module["dynCall_viiidiiiidi"]=asm["dynCall_viiidiiiidi"];var dynCall_viiiddi=Module["dynCall_viiiddi"]=asm["dynCall_viiiddi"];var dynCall_iiiiii=Module["dynCall_iiiiii"]=asm["dynCall_iiiiii"];var dynCall_viiid=Module["dynCall_viiid"]=asm["dynCall_viiid"];var dynCall_viidii=Module["dynCall_viidii"]=asm["dynCall_viidii"];var dynCall_iiiiid=Module["dynCall_iiiiid"]=asm["dynCall_iiiiid"];var dynCall_viiii=Module["dynCall_viiii"]=asm["dynCall_viiii"];var dynCall_viiiii=Module["dynCall_viiiii"]=asm["dynCall_viiiii"];var dynCall_viidiiiiiii=Module["dynCall_viidiiiiiii"]=asm["dynCall_viidiiiiiii"];var dynCall_vid=Module["dynCall_vid"]=asm["dynCall_vid"];var dynCall_iiidi=Module["dynCall_iiidi"]=asm["dynCall_iiidi"];var dynCall_iiidd=Module["dynCall_iiidd"]=asm["dynCall_iiidd"];var dynCall_vii=Module["dynCall_vii"]=asm["dynCall_vii"];var dynCall_viiiid=Module["dynCall_viiiid"]=asm["dynCall_viiiid"];var dynCall_iiiiidiii=Module["dynCall_iiiiidiii"]=asm["dynCall_iiiiidiii"];var dynCall_viidd=Module["dynCall_viidd"]=asm["dynCall_viidd"];var dynCall_viidi=Module["dynCall_viidi"]=asm["dynCall_viidi"];var dynCall_viddd=Module["dynCall_viddd"]=asm["dynCall_viddd"];var dynCall_viiidiiddi=Module["dynCall_viiidiiddi"]=asm["dynCall_viiidiiddi"];var dynCall_iiiidii=Module["dynCall_iiiidii"]=asm["dynCall_iiiidii"];var dynCall_diiid=Module["dynCall_diiid"]=asm["dynCall_diiid"];var dynCall_viiiiiiii=Module["dynCall_viiiiiiii"]=asm["dynCall_viiiiiiii"];var dynCall_viiidddiiii=Module["dynCall_viiidddiiii"]=asm["dynCall_viiidddiiii"];var dynCall_viiiiiiid=Module["dynCall_viiiiiiid"]=asm["dynCall_viiiiiiid"];var dynCall_viiiiiiddi=Module["dynCall_viiiiiiddi"]=asm["dynCall_viiiiiiddi"];var dynCall_diiii=Module["dynCall_diiii"]=asm["dynCall_diiii"];var dynCall_viiiiidiiddi=Module["dynCall_viiiiidiiddi"]=asm["dynCall_viiiiidiiddi"];var dynCall_viddddd=Module["dynCall_viddddd"]=asm["dynCall_viddddd"];var dynCall_viiddddddi=Module["dynCall_viiddddddi"]=asm["dynCall_viiddddddi"];var dynCall_viiiiiddii=Module["dynCall_viiiiiddii"]=asm["dynCall_viiiiiddii"];var dynCall_viiiiidii=Module["dynCall_viiiiidii"]=asm["dynCall_viiiiidii"];var dynCall_iid=Module["dynCall_iid"]=asm["dynCall_iid"];var dynCall_viiiiiiiid=Module["dynCall_viiiiiiiid"]=asm["dynCall_viiiiiiiid"];var dynCall_viiiiiii=Module["dynCall_viiiiiii"]=asm["dynCall_viiiiiii"];var dynCall_viiiiiid=Module["dynCall_viiiiiid"]=asm["dynCall_viiiiiid"];var dynCall_viiiiiiiii=Module["dynCall_viiiiiiiii"]=asm["dynCall_viiiiiiiii"];var dynCall_iii=Module["dynCall_iii"]=asm["dynCall_iii"];var dynCall_viiiddii=Module["dynCall_viiiddii"]=asm["dynCall_viiiddii"];var dynCall_viiiiiidi=Module["dynCall_viiiiiidi"]=asm["dynCall_viiiiiidi"];var dynCall_vdiii=Module["dynCall_vdiii"]=asm["dynCall_vdiii"];var dynCall_diiiiiiiid=Module["dynCall_diiiiiiiid"]=asm["dynCall_diiiiiiiid"];var dynCall_iiiddddddi=Module["dynCall_iiiddddddi"]=asm["dynCall_iiiddddddi"];var dynCall_i=Module["dynCall_i"]=asm["dynCall_i"];var dynCall_viiiiidiiiii=Module["dynCall_viiiiidiiiii"]=asm["dynCall_viiiiidiiiii"];var dynCall_viii=Module["dynCall_viii"]=asm["dynCall_viii"];var dynCall_v=Module["dynCall_v"]=asm["dynCall_v"];var dynCall_viid=Module["dynCall_viid"]=asm["dynCall_viid"];var dynCall_iidddddii=Module["dynCall_iidddddii"]=asm["dynCall_iidddddii"];var dynCall_iiiddiid=Module["dynCall_iiiddiid"]=asm["dynCall_iiiddiid"];var dynCall_vi=Module["dynCall_vi"]=asm["dynCall_vi"];var dynCall_iiiiiiiiiii=Module["dynCall_iiiiiiiiiii"]=asm["dynCall_iiiiiiiiiii"];var dynCall_viiiidiiiidi=Module["dynCall_viiiidiiiidi"]=asm["dynCall_viiiidiiiidi"];var dynCall_ii=Module["dynCall_ii"]=asm["dynCall_ii"];var dynCall_viiiiiiiddi=Module["dynCall_viiiiiiiddi"]=asm["dynCall_viiiiiiiddi"];var dynCall_vidii=Module["dynCall_vidii"]=asm["dynCall_vidii"];var dynCall_iiiidiii=Module["dynCall_iiiidiii"]=asm["dynCall_iiiidiii"];var dynCall_viiiidi=Module["dynCall_viiiidi"]=asm["dynCall_viiiidi"];var dynCall_viiiddiii=Module["dynCall_viiiddiii"]=asm["dynCall_viiiddiii"];var dynCall_viiiiiidiiiii=Module["dynCall_viiiiiidiiiii"]=asm["dynCall_viiiiiidiiiii"];var dynCall_iiii=Module["dynCall_iiii"]=asm["dynCall_iiii"];var dynCall_viididii=Module["dynCall_viididii"]=asm["dynCall_viididii"];var dynCall_viiiiddii=Module["dynCall_viiiiddii"]=asm["dynCall_viiiiddii"];var dynCall_iiid=Module["dynCall_iiid"]=asm["dynCall_iiid"];var dynCall_viiiidii=Module["dynCall_viiiidii"]=asm["dynCall_viiiidii"];var dynCall_diiiii=Module["dynCall_diiiii"]=asm["dynCall_diiiii"];var dynCall_diiiid=Module["dynCall_diiiid"]=asm["dynCall_diiiid"];var dynCall_viiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiii"]=asm["dynCall_viiiiiiiiiiiiii"];var dynCall_iiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiii"]=asm["dynCall_iiiiiiiiiiiii"];var dynCall_iiiiidi=Module["dynCall_iiiiidi"]=asm["dynCall_iiiiidi"];var dynCall_iiidid=Module["dynCall_iiidid"]=asm["dynCall_iiidid"];var dynCall_diiiiiiiiid=Module["dynCall_diiiiiiiiid"]=asm["dynCall_diiiiiiiiid"];var dynCall_iiiiidii=Module["dynCall_iiiiidii"]=asm["dynCall_iiiiidii"];var dynCall_diiiiii=Module["dynCall_diiiiii"]=asm["dynCall_diiiiii"];var dynCall_vididdii=Module["dynCall_vididdii"]=asm["dynCall_vididdii"];var dynCall_viiiiidiii=Module["dynCall_viiiiidiii"]=asm["dynCall_viiiiidiii"];var dynCall_iiiiiiiii=Module["dynCall_iiiiiiiii"]=asm["dynCall_iiiiiiiii"];var dynCall_viididdii=Module["dynCall_viididdii"]=asm["dynCall_viididdii"];var dynCall_viiiidd=Module["dynCall_viiiidd"]=asm["dynCall_viiiidd"];var dynCall_vidiii=Module["dynCall_vidiii"]=asm["dynCall_vidiii"];Runtime.stackAlloc=asm["stackAlloc"];Runtime.stackSave=asm["stackSave"];Runtime.stackRestore=asm["stackRestore"];Runtime.establishStackSpace=asm["establishStackSpace"];Runtime.setTempRet0=asm["setTempRet0"];Runtime.getTempRet0=asm["getTempRet0"];function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}ExitStatus.prototype=new Error;ExitStatus.prototype.constructor=ExitStatus;var initialStackTop;var preloadStartTime=null;var calledMain=false;dependenciesFulfilled=function runCaller(){if(!Module["calledRun"])run();if(!Module["calledRun"])dependenciesFulfilled=runCaller};Module["callMain"]=Module.callMain=function callMain(args){args=args||[];ensureInitRuntime();var argc=args.length+1;function pad(){for(var i=0;i<4-1;i++){argv.push(0)}}var argv=[allocate(intArrayFromString(Module["thisProgram"]),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i=i+1){argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL));pad()}argv.push(0);argv=allocate(argv,"i32",ALLOC_NORMAL);try{var ret=Module["_main"](argc,argv,0);exit(ret,true)}catch(e){if(e instanceof ExitStatus){return}else if(e=="SimulateInfiniteLoop"){Module["noExitRuntime"]=true;return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}finally{calledMain=true}};function run(args){args=args||Module["arguments"];if(preloadStartTime===null)preloadStartTime=Date.now();if(runDependencies>0){return}preRun();if(runDependencies>0)return;if(Module["calledRun"])return;function doRun(){if(Module["calledRun"])return;Module["calledRun"]=true;if(ABORT)return;ensureInitRuntime();preMain();if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();if(Module["_main"]&&shouldRunNow)Module["callMain"](args);postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout((function(){setTimeout((function(){Module["setStatus"]("")}),1);doRun()}),1)}else{doRun()}}Module["run"]=Module.run=run;function exit(status,implicit){if(implicit&&Module["noExitRuntime"]){return}if(Module["noExitRuntime"]){}else{ABORT=true;EXITSTATUS=status;STACKTOP=initialStackTop;exitRuntime();if(Module["onExit"])Module["onExit"](status)}if(ENVIRONMENT_IS_NODE){process["exit"](status)}else if(ENVIRONMENT_IS_SHELL&&typeof quit==="function"){quit(status)}throw new ExitStatus(status)}Module["exit"]=Module.exit=exit;var abortDecorators=[];function abort(what){if(what!==undefined){Module.print(what);Module.printErr(what);what=JSON.stringify(what)}else{what=""}ABORT=true;EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";var output="abort("+what+") at "+stackTrace()+extra;if(abortDecorators){abortDecorators.forEach((function(decorator){output=decorator(output,what)}))}throw output}Module["abort"]=Module.abort=abort;if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}var shouldRunNow=true;if(Module["noInitialRun"]){shouldRunNow=false}run()





  return cv;
};

    return cv(Module || {});
}));
